# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class adm_empresa_centrocusto(osv.Model):
    _name = 'adm.empresa.centrocusto'
    _inherit = 'adm.empresa.centrocusto'

    def ler(self, cr, uid, args, context=None):
        context = context and context.copy() or {}
        if not args:
            return []
        try:
            ids = self.search(cr, uid, args, context=context)
            vals = self.read(cr, uid, ids, [], context=context)
            return vals
        except:
            return []


    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not len(ids):
            return []
        res = []
        for brw in  self.browse(cr, uid, ids, context=context):
            _codigo = brw.codigo
            _name = brw.name
            brw_parent_id = brw.parent_id
            while brw_parent_id:
                _name = brw_parent_id.name + '/' + _name
                brw_parent_id = brw_parent_id.parent_id
            res.append((brw.id, '%s-%s' % (_codigo, _name)))
        return res

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if 'sigla' in vals:
            if vals['sigla']:
                vals['sigla'] = vals['sigla'].upper()
        if not 'parent_id' in vals:
            parent_id = False
        else:
            parent_id = vals['parent_id']
        if vals.get('active'):
            vals['controle'] = self.pool.get('adm.utils').get_controle(cr, uid, self._name, parent_id,
                                                                       vals['company_id'], context)
        result = super(adm_empresa_centrocusto, self).create(cr, uid, vals, context)
        return result

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if 'active' in vals:
            if vals.get("active") == False:
                vals['controle'] = 0
        if vals.get('sigla'):
            vals['sigla'] = vals['sigla'].upper()
        result = super(adm_empresa_centrocusto, self).write(cr, uid, ids, vals, context=context)
        return result

    def unlink(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        record = self.search(cr, uid, [('parent_id', 'child_of', ids)], context=context)
        if record and record != ids:
            raise osv.except_osv(_('Atencao'), _('Centro de Custo contem conta filho!'))
        else:
            result = super(adm_empresa_centrocusto, self).unlink(cr, uid, ids, context=context)
            return result

    def name_search(self, cr, uid, name='', args=[], operator='ilike', context=None, limit=100):
        if not args:
            args = []
        context = context and context.copy() or {}
        ids = self.search(cr, uid, [('codigo', '=', name)] + args, limit=limit, context=context)
        if not ids:
            if not isinstance(name, int):
                ids = self.search(cr, uid, [('sigla', operator, name)] + args, limit=limit, context=context)
        if not ids:
            ids = self.search(cr, uid, [('name', operator, name)] + args, limit=limit, context=context)
        return self.name_get(cr, uid, ids)

