# -*- encoding: utf-8 -*-
# #############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
import re


class adm_cnae(osv.Model):
    _name = 'adm.cnae'
    _inherit = 'adm.cnae'

    def read(self, cr, uid, ids, fields=None, context=None, load='_classic_read'):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
        registros = super(adm_cnae, self).read(cr, uid, ids, fields=fields, context=context,
                                               load=load)
        res = []
        for registro in registros:
            if registro and registro.get('admcna_codigo') and registro['admcna_codigo']:
                if registro.get('admcna_codigo') and registro['admcna_codigo']:
                    _codigo = registro['admcna_codigo']
                else:
                    _codigo = ''
                if len(_codigo) > 1:
                    val = re.sub('[^0-9]', '', _codigo)
                    if len(val) < 5:
                        registro['admcna_codigo'] = val
                    else:
                        if len(val) < 6:
                            registro['admcna_codigo'] = "%s-%s" % (val[0:4], val[4:])
                        else:
                            registro['admcna_codigo'] = "%s-%s/%s" % (val[0:4], val[4:5], val[5:])
            res.append(registro)
        return res

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('admcna_codigo') and vals['admcna_codigo']:
            vals['admcna_codigo'] = re.sub('[^0-9]', '', vals['admcna_codigo'])
        result = super(adm_cnae, self).create(cr, uid, vals, context)
        return result

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('admcna_codigo') and vals['admcna_codigo']:
            vals['admcna_codigo'] = re.sub('[^0-9]', '', vals['admcna_codigo'])
        result = super(adm_cnae, self).write(cr, uid, ids, vals, context=context)
        return result

    def name_search(self, cr, uid, name='', args=None, operator='ilike', context=None, limit=100):
        res = []
        args = []
        context = context and context.copy() or {}
        if args is None:
            args = []
        if name:
            args.append(('name', 'ilike', name), )
            ids = self.search(cr, uid, args, limit=limit, context=context)
            if not ids:
                args = []
                name = list(name)
                codigo = ''
                for x in name:
                    if x != '-' and x != '/':
                        codigo += x
                args.append(('admcna_codigo', '=', codigo), )
                ids = self.search(cr, uid, args, limit=limit, context=context)
        else:
            ids = self.search(cr, uid, args, limit=limit, context=context)
        if ids:
            res = self.name_get(cr, uid, ids, context)
        return res

    def name_get(self, cr, uid, ids, context=None):
        res = []
        context = context and context.copy() or {}
        if not len(ids):
            return []
        dados = self.read(cr, uid, ids, ['admcna_codigo', 'name'], context=context)
        for x in dados:
            res.append((x['id'], str(x['admcna_codigo']) + ' - ' + x['name']))
        return res

