# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class adm_condicao(osv.Model):
    _name = 'adm.condicao'
    _inherit = 'adm.condicao'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('tipo', False) == 'V':
            vals['qtde_parcelas'] = 1
        if vals.get('qtde_parcelas', False) <= 0:
            raise osv.except_osv(_('Atencao'),
                                 _('A quantidade da parcela deve ser maior que zero.'))
        if vals.get('qtde_parcelas', False) == 1:
            vals['dias_incremento'] = 0
        if vals.get('qtde_parcelas', False) > 1:
            if vals.get('dias_incremento', False) <= 0:
                raise osv.except_osv(_('Atencao'),
                                     _('O campo Dias de Incremento, deve ser maior que zero.'))
        # Bloco inserido na versao 3G1, para evitar erro na insercao de dados do arquivo local.xml
        # em bases que já tem local cadastrado.
        # TODO: Pode ser removido apos a versao  4A1
        if context.get('install_mode') and context['install_mode']:
            args = [('tipo', '=', vals['tipo']),
                    ('qtde_parcelas', '=', vals['qtde_parcelas']),
                    ('tipo_prazo', '=', vals['tipo_prazo'])
            ]
            _id = self.search(cr, uid, args, context=context)
            if _id:
                return _id[0]
            # Fim do Bloco #
        res = super(adm_condicao, self).create(cr, uid, vals, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
            # Obs: usei o in vals porque usando o get nao funcionou perfeitamente na validacao,somente em alguns casos,mesmo com a chave no dicionario ele nao encontrou
        if 'qtde_parcelas' in vals:
            qt_parcelas = vals.get('qtde_parcelas', False)
        else:
            qt_parcelas = self.read(cr, uid, ids[0], ['qtde_parcelas'], context=context)['qtde_parcelas']
        if 'dias_incremento' in vals:
            dias_inc = vals.get('dias_incremento', False)
        else:
            dias_inc = self.read(cr, uid, ids[0], ['dias_incremento'], context=context)['dias_incremento']
        if qt_parcelas <= 0:
            raise osv.except_osv(_('Atencao'),
                                 _('A quantidade da parcela deve ser maior que zero.'))
        if qt_parcelas == 1:
            vals['dias_incremento'] = 0
        if qt_parcelas > 1:
            if dias_inc <= 0:
                raise osv.except_osv(_('Atencao'),
                                     _('O campo Dias de Incremento, deve ser maior que zero.'))
        res = super(adm_condicao, self).write(cr, uid, ids, vals, context=context)
        return res

    def onchange_tipo_prazo(self, cr, uid, ids, tipo_prazo, admcnd_dia_fechamento, context=None):
        context = context and context.copy() or {}
        if tipo_prazo == 'DD':
            admcnd_dia_fechamento = 0
        return {'value': {'admcnd_dia_fechamento': admcnd_dia_fechamento}}

    def onchange_admcnd_tipo(self, cr, uid, ids, tipo, context=None):
        context = context and context.copy() or {}
        res = {'value':{}}
        if not tipo:
            return {}

        if tipo in ('V','S'):
            res['value'] = {'dias_primeira_parcela': 0,
                            'admcnd_dia_fechamento': 0,
                            'dias_incremento': 0}

        return res