#-*- encoding: utf-8 -*-

from openerp.osv import osv


class adm_condicao_forma(osv.Model):
    _name = "adm.condicao.forma"
    _inherit = "adm.condicao.forma"

    def default_get(self, cr, uid, fields_list, context=None):
        context = context and context.copy() or {}
        res = super(adm_condicao_forma, self).default_get(cr, uid, fields_list, context)
        print res
        return res

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = []
        for r in self.browse(cr, uid, ids):
            res.append((r.id, r.name))
        return res

    def get_inative_ids(self, cr, uid, values, context=None):
        """
        Retorna os ids de adm_condicao_forma para serem inativados
        """
        context = context and context.copy() or {}
        adm_condicao_forma_ids = []
        field = False
        dado_id = False
        for i in values:
            field = i
            dado_id = values.get(field)
        if all([field, dado_id]):
            args_cond_forma = [(field, '=', dado_id), ('active', '=', True)]
            adm_condicao_forma_ids = self.search(cr, uid, args=args_cond_forma, context=context)
        return adm_condicao_forma_ids

    def get_active_ids(self, cr, uid, values, context=None):
        """
        Retorna os ids de adm_condicao_forma para serem ativados
        """
        context = context and context.copy() or {}
        adm_condicao_forma_ids = []
        field = False
        dado_id = False
        for i in values:
            field = i
            dado_id = values.get(field)
        if all([field, dado_id]):
            args_cond_forma = [(field, '=', dado_id), ('active', '=', False)]
            adm_condicao_forma_ids = self.search(cr, uid, args=args_cond_forma, context=context)
            brw_adm_condicao_forma = self.browse(cr, uid, adm_condicao_forma_ids, context=context)
            for x in brw_adm_condicao_forma:
                adm_condicao_active = x.adm_condicao_id.active
                forma_pagamento_active = x.forma_pagamento_id.active
                if all([adm_condicao_active, forma_pagamento_active]):
                    adm_condicao_forma_ids.append(x.id)
        return adm_condicao_forma_ids

    def onchange_adm_cond_forma_active(self, cr, uid, ids, forma_pagamento_id, adm_condicao_id, context=None):
        context = context and context.copy() or {}
        obj_adm_condicao = self.pool.get('adm.condicao')
        obj_adm_forma_pgto = self.pool.get('adm.forma.pgto')
        adm_condicao_active = False
        adm_forma_pgto_active = False
        if not isinstance(adm_condicao_id, list) and adm_condicao_id:
            adm_condicao_id = [adm_condicao_id]
        if not isinstance(forma_pagamento_id, list) and forma_pagamento_id:
            forma_pagamento_id = [forma_pagamento_id]
        value = {}
        if adm_condicao_id and forma_pagamento_id:
            read_adm_condicao = obj_adm_condicao.read(cr, uid, adm_condicao_id, context=context)
            for i in read_adm_condicao:
                adm_condicao_active = i['active']
            read_forma_pgto = obj_adm_forma_pgto.read(cr, uid, forma_pagamento_id, context=context)
            for x in read_forma_pgto:
                adm_forma_pgto_active = x['active']
        if all([adm_condicao_active, adm_forma_pgto_active]):
            value['active'] = True
        else:
            value['active'] = False
        return {'value': value}