# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp import SUPERUSER_ID
READ_LOAD = '_classic_write'


class adm_empresa_objeto(osv.Model):
    _name = 'adm.empresa.objeto'
    _inherit = 'adm.empresa.objeto'

    # Método será descontinuado, use o getEmpresa do SigUtils.sigerp
    # Se fizer alterações neste médido faça tambem no SigUtils
    def getEmpresa(self, cr, uid, tabela=None, args=None, context=None, user_company_id=False):
        """
        Funcao getEmpresa,
        - retorna a empresa padrao do usuario ou a empresa a ser utilizada para uma determinada tabela, conforme adm.empresa.objeto
        - se nao informar args, usara a empresa default do usuario
        - Args pode ser o numero da empresa ou um conjunto de argumentos do tipo [('n','=', 'n)]
        - Se args for numero de empresa ou se nao informar tabela, o retorno sera um id de empresa
        - Se arqs for do tipo argumento, o retorno sera tambem do tipo argumento
        """
        context = context and context.copy() or {}
        company_id = user_company_id
        if not company_id:
            if context.get('sig_force_company') and context.get('sig_force_company') != True:
                company_id = context.get('sig_force_company')
            else:
                company_id = self.pool.get('res.users').browse(cr, SUPERUSER_ID, uid).company_id.id

        if not tabela:  # se nao tem tabela, nao interessa args. Retornar a empresa default
            return company_id

        if args: # Tendo args:1) se inteiro, usar a empresa, 2)tendo company_id em args, usar a empresa que veio no args. formato args ex:  '2' ou '[('company_id', '=', 2)]'
            try:
                company_id = int(args)
            except:
                for arg in args:
                    if arg[0] == 'company_id':
                        company_id = arg[2]
                        break

        result = company_id
        res = self.pool.get('ir.model').search(cr, uid, [('model', '=', tabela)], context=context)
        if not res:  # Tabela nao localizada
            return result

        tabelaId = res[0]
        if isinstance(company_id, (int, long)):
            company_id = [company_id]

        ids = self.search(cr, uid, [('empresa_escolhida_id', 'in', company_id), ('ir_model_id', '=', tabelaId)],
                          context=context)
        if ids:
            res = self.read(cr, uid, ids[0], ['empresa_a_usar_id'], context=context, load=READ_LOAD)
            if res:
                result = res['empresa_a_usar_id']
        if not args:  # retornar apenas o numero da empresa
            return result
        try:
            integer = int(args)
            args1 = result
        except:
            if not args: #Retornar lista com argumentos(args)
                args1 = [('company_id', '=', result)]
            else:
                args1 = [('company_id', '=', result)]
                for arg in args:
                    if arg[0] != 'company_id':
                        args1.append(arg)
        return args1

    def admemp_get_empresa_escolhida_ids(self, cr, uid, tabela, company_a_usar_id, context=None):
        """
        O metodo encontra todas as empresas escolhidas, a partir da empresa a
        usar (company_a_usar_id).
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param tabela: descricao do objeto que possui a empresa (company_id).
        :type tabela: str
        :param company_id_a_usar: id da tabela res_company, identificador da empresa na qual a
        tabela esta sendo usada.
        :type company_a_usar_id: int
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: lista de registros da tabela res_company
         :rtype: list
        """
        context = context and context.copy() or {}
        res = list()
        company_id_escolhida = self.getEmpresa(cr, uid, tabela, context=context,
                                               user_company_id=company_a_usar_id)
        if company_a_usar_id == company_id_escolhida:
            res.append(company_a_usar_id)
        company_id_escolhida_ids = self.search(
            cr, uid, [('empresa_a_usar_id', '=', company_a_usar_id)], context=context)
        if not company_id_escolhida_ids:
            return res

        map(lambda i: res.append(i.get('empresa_escolhida_id')),
            self.read(cr, uid, company_id_escolhida_ids, ['empresa_escolhida_id'], context,
                      load='_classic_write'))

        return list(set(res))


