# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_moeda(osv.Model):
    _name = 'adm.moeda'
    _inherit = 'adm.moeda'

    def name_search(self, cr, user, name='', args=None, operator='ilike', context=None, limit=100):
        if not args:
            args = []
        context = context and context.copy() or {}
        ids = self.search(cr, user, [('sigla', '=', name.upper())] + args, limit=limit,
                          context=context)
        if not ids:
            ids = self.search(cr, user, [('name', operator, name)] + args,
                              limit=limit, context=context)
        return self.name_get(cr, user, ids, context)

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('sigla'):
            vals['sigla'] = vals['sigla'].upper()
        result = super(adm_moeda, self).create(cr, uid, vals, context)
        return result

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('sigla'):
            vals['sigla'] = vals['sigla'].upper()
        result = super(adm_moeda, self).write(cr, uid, ids, vals, context)
        return result

