# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class adm_moeda_valor(osv.Model):
    _name = 'adm.moeda.valor'
    _inherit = 'adm.moeda.valor'

    # Metodo para retornar o valor de uma moeda
    #O retorno e um dicionario com status, mensagem, valor
    def achar_valor_moeda(self, cr, uid, sigla, ano, mes, dia='01', operador="=", vlDefault='0.00', context=None):
        """
        Se vlDefault for 0.00 e nao achar a moeda na data desejada, o retorno sera false;
        Se vlDefault for diferente de 0.00 mesmo nao achando a moeda na data desejada, o retorno sera True com o valor default
        """
        context = context and context.copy() or {}
        res = {'valor': vlDefault}
        if vlDefault == '0.00':
            status = False
        else:
            status = True
        try:
            if int(ano) < 1900 and int(ano) > 2300:
                res['status'] = status
                res['mensagem'] = _('Ano invalido!')
                return res
        except:
            res['status'] = status
            res['mensagem'] = _('Ano invalido!')
            return res
        try:
            if int(mes) < 1 and int(mes) > 12:
                res['status'] = status
                res['mensagem'] = _('Mes invalido!')
                return res
        except:
            res['status'] = status
            res['mensagem'] = _('Mes invalido!')
            return res
        try:
            if int(dia) < 1 and int(dia) > 31:
                res['status'] = status
                res['mensagem'] = _('Dia invalido!')
                return res
        except:
            res['status'] = status
            res['mensagem'] = _('Dia invalido!')
            return res
        oMoeda = self.pool.get('adm.moeda')
        _idMoeda = oMoeda.search(cr, uid, [('sigla', '=', sigla)], context=context)
        if not _idMoeda:
            res['status'] = status
            res['mensagem'] = _('Indexador:') + sigla + _(' Nao cadastrado como moeda!')
            return res
        if isinstance(_idMoeda, list):
            _idMoeda = _idMoeda[0]
        _data = str(ano) + str(mes) + str(dia)
        _idMoedaValor = self.search(cr, uid, [('moeda_id', '=', _idMoeda), ('data_movimento', operador, _data)],
                                    order='data_movimento desc', context=context)
        if not _idMoedaValor:
            res['status'] = status
            res['mensagem'] = _('Indexador: ') + sigla + _(' Nao cadastrado(a) nesta data!')
            return res
        _valor = self.read(cr, uid, [_idMoedaValor[0]], ['valor'], context=context)[0][
            'valor'] # pegar o indice da primeira moeda, que e a mais recente
        res['status'] = True
        res['valor'] = _valor
        res['mensagem'] = ''
        return res


