# -*- encoding: utf-8 -*-

from openerp.osv import osv
from dateutil.parser import parse
from dateutil.relativedelta import relativedelta
from datetime import date, datetime


class adm_paginas(osv.Model):
    _name = 'adm.paginas'
    _inherit = 'adm.paginas'

    def _admpag_set_first_day(self, data):
        # FORMATO DO PARAMETRO (data) DEVE SER YYYY-MM-DD
        if isinstance(data, basestring):
            data = parse(data, yearfirst=True)
        if isinstance(data, (date, datetime)):
            data = data + relativedelta(day=1)# ALTERA A DATA PARA O PRIMEIRO DIA.
            return data.strftime('%Y-%m-%d')
        return ''

    def _admpag_search_registro(self, cr, uid, data, tipo, context=None):
        context = context and context.copy() or {}
        data = self._admpag_set_first_day(data)
        args = [('data', '=', data), ('tipo', '=', tipo)]
        adm_pag_ids = self.search(cr, uid, args, context=context)
        return {'adm_pagina_ids': adm_pag_ids}

    def admpag_set_pagina(self, cr, uid, data_inicial, pag_final, tipo, context=None):
        context = context and context.copy() or {}
        pagina_mes_anterior = self.admpag_get_pagina(cr, uid, data_inicial, tipo, context=None)
        adm_paginas_dados = self._admpag_search_registro(cr, uid, data_inicial, tipo, context)
        if adm_paginas_dados.get('adm_pagina_ids'):
            try:
                adm_paginas_id = adm_paginas_dados['adm_pagina_ids'][0]
            except:
                return False
            return self.write(cr, uid, adm_paginas_id, {'inicial': pagina_mes_anterior, 'final': pag_final}, context)
        else:
            data_inicial = self._admpag_set_first_day(data_inicial)
            if data_inicial:
                return self.create(cr, uid, {'company_id': self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'adm.paginas', context=context),
                                             'data': data_inicial,
                                             'tipo': tipo,
                                             'inicial': pagina_mes_anterior,
                                             'final': pag_final})
        return False

    def admpag_get_pagina(self, cr, uid, data, tipo, context=None):
        context = context and context.copy() or {}
        data = self._admpag_set_first_day(data)
        if data:
            mes_anterior = parse(data) - relativedelta(months=1) # BUSCA A PAGINA DO ULTIMO MES
            pagina_mes_anterior_ids = self._admpag_search_registro(cr, uid, mes_anterior, tipo,
                                                                      context) # PESQUISA REGISTRO DE PAG. NO ULTIMO MES
            adm_paginas_ids = pagina_mes_anterior_ids.get('adm_pagina_ids')
            if adm_paginas_ids:
                adm_paginas_dados = self.read(cr, uid, adm_paginas_ids[0], ['final'], context=context)
                if isinstance(adm_paginas_dados, list):
                    adm_paginas_dados = adm_paginas_dados[0]
                if isinstance(adm_paginas_dados, dict):
                    return (adm_paginas_dados.get('final') or 0) + 1
        return 1

