# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class adm_parametro(osv.Model):
    _name = 'adm.parametro'
    _inherit = 'adm.parametro'

    def ler(self, cr, uid, args, context=None):
        context = context and context.copy() or {}
        if not args:
            return []
        try:
            ids = self.search(cr, uid, args, context=context)
            vals = self.read(cr, uid, ids, [], context=context)
            return vals
        except:
            return []


    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        def _admpar_create_contabil(vals):
            if vals.get('admpar_ctb_mascara_conta') and vals['admpar_ctb_mascara_conta']:
                for letra in vals['admpar_ctb_mascara_conta']:
                    if not letra in ('#', '.'):
                        raise osv.except_osv(_('Mensagem:'),
                                             _('Mascara invalida!\n Somente sao aceitos os caracteres "#" e "."!'))
            return True
        if not self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'contabil', context):
            _admpar_create_contabil(vals)
        result = super(adm_parametro, self).create(cr, uid, vals, context)
        return result

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        def _admpar_write_contabil(vals):
            if vals.get('admpar_ctb_mascara_conta') and vals['admpar_ctb_mascara_conta']:
                for letra in vals['admpar_ctb_mascara_conta']:
                    if not letra in ('#', '.'):
                        raise osv.except_osv(_('Mensagem:'),
                                             _('Mascara invalida!\n Somente sao aceitos os caracteres "#" e "."!'))
            return True
        if not self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'contabil', context):
            _admpar_write_contabil(vals)
        result = super(adm_parametro, self).write(cr, uid, ids, vals, context)
        return result

    def copy(self, cr, uid, id, default=None, context=None):
        context = context and context.copy() or {}
        if not isinstance(default, dict):
            default = {}
        default['company_id'] = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, context=context)
        return super(adm_parametro, self).copy(cr, uid, id, default, context)