# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class adm_transportador(osv.Model):
    _name = 'adm.transportador'
    _inherit = 'adm.transportador'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        pessoa = vals.get('pessoa_id')
        var = self.valida_pessoa(cr, uid, pessoa, context=context)
        if not var.get('validade'):
            raise osv.except_osv(_('Mensagem:'),
                                 _("Dados de preenchimento obrigatorio: " + (", ".join(var.get('mensagem')))))
        res = super(adm_transportador, self).create(cr, uid, vals, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('pessoa_id'):
            var = self.valida_pessoa(cr, uid, vals.get('pessoa_id'), context=context)
            if not var.get('validade'):
                raise osv.except_osv(
                    _('Mensagem:'),
                    _("Dados de preenchimento obrigatorio: " + (", ".join(var.get('mensagem')))))
        res = super(adm_transportador, self).write(cr, uid, ids, vals, context)
        return res

    def valida_pessoa(self, cr, uid, pessoa_id, context=None):
        context = context and context.copy() or {}
        res = {'validade': True, 'mensagem': []}
        pessoa_dados = self.pool.get('adm.pessoa').read(cr, uid, pessoa_id, ['pessoa_tipo', 'admpes_jur_tipo_atividade'], context=context)
        if pessoa_dados.get('pessoa_tipo') == 'J':
            if not pessoa_dados.get('admpes_jur_tipo_atividade'):
                res['validade'] = False
                res['mensagem'].append('Tipo Atividade')
        return res


