# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class ir_model(osv.Model):
    _name = "ir.model"
    _inherit = "ir.model"

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = []
        if not len(ids):
            return []
        dados = self.read(cr, uid, ids, ['name'], context=context)
        for x in dados:
            res.append((x['id'], x['name']))
        return res

    def name_search(self, cr, uid, name='', args=[], operator='ilike', context=None, limit=100):
        context = context and context.copy() or {}
        ids = []
        if not ids:
            ids = self.search(cr, uid, [( 'name', operator, name )] + args, limit=limit, context=context)
        if context.get('pesquisa_roteavel'):
            ids = self.search(cr, uid, [], limit=None, context=context)
        return self.name_get(cr, uid, ids)

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        if not args:
            args = []
        context = context and context.copy() or {}
        res = super(ir_model, self).search(cr, uid, args, offset, limit, order, context, count)
        if context.get('pesquisa_roteavel'):
            resultado = []
            model_dados = self.browse(cr, uid, res)
            for i in model_dados:
                model = self.pool.get(i.model)
                if model:
                    try:
                        roteavel = model._roteavel
                        if roteavel:
                            resultado.append(i.id)
                    except:
                        pass
            return resultado
        return res
