# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv

class res_company(osv.Model):
    _name = "res.company"
    _inherit = "res.company"

    def name_get(self, cr, uid, ids, context=None):
        res = []
        context = context and context.copy() or {}
        if not len(ids):
            return []
        for brw_company in self.browse(cr, uid, ids):
             res.append((brw_company.id, '%03d - %s' % (brw_company.id, brw_company.name)))
        return res

    def name_search(self, cr, uid, name='', args=[], operator='ilike', context=None, limit=100):
        context = context and context.copy() or {}
        ids = []
        try:
            name = int(name)
        except:
            pass
        if isinstance(name, int):
            ids = self.search(cr, uid, [('id', '=', name)] + args, limit=limit, context=context)
        if not ids:
            ids = self.search(cr, uid, [('name', operator, name)] + args, limit=limit, context=context)
        return self.name_get(cr, uid, ids)

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        obj_adm_utils = self.pool.get('adm.utils')
        res = obj_adm_utils.admutl_valida_superuser(cr, uid, context)
        uid = res.get('uid')
        context.update({'uid': uid})
        res = super(res_company, self).search(cr, uid, args, offset, limit, order, context, count)
        return res

    def onchange_rescon_pessoa_id(self, cr, uid, ids, rescon_pessoa_id, name, context=None):
        context = context and context.copy() or {}
        if name:
            return {'value': {}}
        else:
            if rescon_pessoa_id:
                obj_pessoa = self.pool.get('adm.pessoa')
                fantasia_apelido = obj_pessoa.read(cr, uid, rescon_pessoa_id, ['fantasia_apelido'], context=context)[0][
                    'fantasia_apelido']
                if not fantasia_apelido:
                    fantasia_apelido = obj_pessoa.read(cr, uid, rescon_pessoa_id, ['name'], context=context)[0]['name']
            else:
                fantasia_apelido = False
            return {'value': {'name': fantasia_apelido}}

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        obj_adm_utils = self.pool.get('adm.utils')
        res = obj_adm_utils.admutl_valida_superuser(cr, uid, context)
        uid = res.get('uid')
        context.update({'uid': uid})
        if not vals.get('name', False) or vals.get('rescon_pessoa_id', False):
            self.cache_restart(cr)
            return super(res_company, self).create(cr, uid, vals, context=context)
        obj_partner = self.pool.get('adm.pessoa')
        rescon_pessoa_id = obj_partner.create(cr, uid, {'name': vals['name'], 'pessoa_tipo': 'J'}, context=context)
        vals.update({'rescon_pessoa_id': rescon_pessoa_id})
        self.cache_restart(cr)
        company_id = super(res_company, self).create(cr, uid, vals, context=context)
        obj_partner.write(cr, uid, rescon_pessoa_id, {'company_id': company_id}, context=context)
        return company_id

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        obj_adm_utils = self.pool.get('adm.utils')
        res = obj_adm_utils.admutl_valida_superuser(cr, uid, context)
        uid = res.get('uid')
        context.update({'uid': uid})
        if 'rescon_pessoa_id' in vals:
            if not vals.get('name', False):
                obj_pessoa = self.pool.get('adm.pessoa')
                vals_pessoa = obj_pessoa.read(cr, uid, vals['rescon_pessoa_id'],
                                              ['fantasia_apelido', 'name'], context=context)
                if not 'fantasia_apelido' in vals:
                    vals['name'] = vals_pessoa['name']
        result = super(res_company, self).write(cr, uid, ids, vals, context=context)
        return result

    def read(self, cr, uid, ids, fields=[], context=None, load='_classic_read'):
        context = context and context.copy() or {}
        obj_adm_utils = self.pool.get('adm.utils')
        res = obj_adm_utils.admutl_valida_superuser(cr, uid, context)
        uid = res.get('uid')
        context.update({'uid': uid})
        res = super(res_company, self).read(cr, uid, ids, fields, context=context, load=load)

        return res


    def unlink(self, cr, uid, ids, context=None):

        context = context and context.copy() or {}
        obj_adm_utils = self.pool.get('adm.utils')
        res = obj_adm_utils.admutl_valida_superuser(cr, uid, context)
        uid = res.get('uid')
        context.update({'uid': uid})
        res = super(res_company, self).unlink(cr, uid, ids, context)

        return res
