# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools import image_resize_image

class res_company(osv.Model):
    _name = "res.company"
    _inherit = "res.company"

    def _get_logo_web(self, cr, uid, ids, _field_name, _args, context=None):
        context = context and context.copy() or {}
        result = dict.fromkeys(ids, False)
        for record in self.browse(cr, uid, ids, context=context):
            size = (180, None)
            result[record.id] = image_resize_image(record.logo_br, size)
        return result

    def _get_logo_br(self, cr, uid, ids, _field_name, _args, context=None):
        context = context and context.copy() or {}
        result = dict.fromkeys(ids, False)
        for record in self.browse(cr, uid, ids, context=context):
            result[record.id] = record.logo_br
        return result

    def _get_logo(self, cr, uid, ids):

        return False

    _columns = {
        'rescon_pessoa_id': fields.many2one('adm.pessoa', 'Partner', ondelete="restrict", select=True),
        'centrocusto_id': fields.many2one("adm.empresa.centrocusto", 'Centro de custo', ondelete="restrict",
                                          select=True),  # Centro de custo do rateio
        'servidor_smtp_id': fields.many2one('ir.mail_server','Servidor smtp', ondelete='set null', select=True, oldname='servidor_smtp'),  # nome do servidor de smtp
        'id': fields.integer('Numero', readonly=True),
        'name': fields.char('Nome', size=64, required=True),
        'website': fields.char('Site', size=64),
        'logo_br':fields.binary('LogoBR'),
        'logo': fields.function(_get_logo_br, string="Logo", type="binary",store=True),
        'logo_web': fields.function(_get_logo_web, string="Logo Web", type="binary", store=True),
        'rescon_codigo_atividade': fields.char('Codigo de atividade', size=10,
                                               help='Codigo de atividade para nota de servios'),
        'rescon_fiscal': fields.boolean('Fiscal', help='Se marcado, informa que a empresa tem '
                                                       'finalidade apenas fiscal.')

    }

    _defaults = {
        'logo_br':_get_logo,
        'rescon_fiscal': False,
    }
