# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_banco_agencia(osv.Model):
    """
    Tabela com as agencias do banco.
    prefixo admbag_
    """
    _name = 'adm.banco.agencia'
    _columns = {
        'admbag_banco_id': fields.many2one("adm.banco", 'Banco', ondelete="cascade", required=True,
                                           select=True, oldname="banco_id"),
        'name': fields.char('Nome', size=45, required=True),
        'admbag_codigo_agencia': fields.integer('Codigo da agencia', oldname="codigo_agencia"),
        'admbag_dv_agencia': fields.char('Digito da agencia', size=1),
        'admbag_pais_id': fields.many2one("adm.pais", 'Pais', ondelete="restrict", select=True,
                                          oldname="pais_id"),
        'admbag_uf_id': fields.many2one("adm.uf", 'Estado', ondelete="restrict", select=True,
                                        domain="[('pais_id', '=', admbag_pais_id)]",
                                        oldname="uf_id"),
        'admbag_cidade_id': fields.many2one("adm.cidade", 'Cidade', ondelete="restrict",
                                            select=True, domain="[('uf_id', '=', admbag_uf_id)]",
                                            oldname="cidade_id"),
    }


