# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_banco(osv.Model):
    """
    Tabela de bancos
    """

    #prefixo = admbco_

    from funcoes import _admbco_name_get

    _name = 'adm.banco'
    _columns = {
        'admbco_pessoa_id': fields.many2one("adm.pessoa", 'Banco', ondelete="restrict",
                                     required=True, select=True,
                                     domain="[('admpes_jur_tipo_empresa', '=', 'B'),('pessoa_tipo', '=', 'J')]",
                                     oldname="pessoa_id"),
        'admbco_codigo_bc': fields.integer('Codigo no Banco Central', required=True, select=True, oldname='codigo_bc'),
        # Codigo do banco para o banco central
        'admbco_banco_agencia_ids': fields.one2many('adm.banco.agencia', 'admbag_banco_id', 'Agencia'),
        'name': fields.function(_admbco_name_get, method=True, string='Banco', type='char', size=56, store=False),
    }
    _sql_constraints = [
        ('codigo_bc_uniq', 'unique (admbco_codigo_bc)', 'O codigo banco precisa ser unico!'),
    ]


