# -*- encoding: utf-8 -*-
# #############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
# www.siginformatica.com.br luiz@siginformatica.com.br
#############################################################################

from datetime import date
from openerp.osv import fields
from openerp.osv import osv

YEAR = date.today().year


class adm_calendario_feriados(osv.Model):
    """
    Tabela contendo os feriados municipais, estaduais e federais
    """

    #prefixo = admcfe_

    from funcoes import _admcfe_get_data

    _name = 'adm.calendario.feriados'
    _columns = {
        'admcfe_tipo': fields.selection(
            [('I', 'Internacional'), ('F', 'Federal'), ('E', 'Estadual'), ('M', 'Municipal')],
            'Tipo', required=True, size=1, oldname='tipo'),
        'admcfe_dia': fields.integer('Dia', required=True, oldname='dia'),  # Dia do Feriado
        'admcfe_mes': fields.integer('Mes', required=True, select=True, oldname='mes'),
        # Mes do Feriado
        'name': fields.char('Descricao', size=30),  # Descricao do Feriado
        'admcfe_pais_id': fields.many2one("adm.pais", 'Pais', ondelete="cascade", select=True,
                                          oldname='pais_id'),
        'admcfe_uf_id': fields.many2one("adm.uf", 'Estado', ondelete="cascade", select=True,
                                        domain="[('pais_id', '=', pais_id)]", oldname='uf_id'),
        'admcfe_cidade_id': fields.many2one("adm.cidade", 'Cidade', ondelete="cascade", select=True,
                                            oldname='cidade_id', domain="[('uf_id', '=', uf_id)]"),
        'admcfe_data': fields.function(_admcfe_get_data, method=True, string='Data', type='date',
                                       store=False)
    }


