# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_empresa_centrocusto(osv.Model):
    """
    Tabela de Centros de Custos (departamentos, setores, etc.) da empresa.
    """

    #prefixo = admecc_

    from funcoes import _admecc_get_codigo

    _name = 'adm.empresa.centrocusto'
    _parent_store = True
    _roteavel = True
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True), # Codigo de identificacao da empresa
        'parent_id': fields.many2one("adm.empresa.centrocusto", 'Conta Pai', ondelete="cascade", select=True,
                                     domain="[('company_id', '=', company_id)]"), # Centro de custo pai
        'child_id': fields.one2many("adm.empresa.centrocusto", 'parent_id', 'Empresa filha'), # Empresa filha
        'name': fields.char('Descricao', size=40, required=True), # Descricao, nome do departamento
        'sigla': fields.char('Sigla', size=10, select=True), # Sigla do departamento
        'codigo': fields.function(_admecc_get_codigo, method=True, string='Codigo', type='char', size=20, store=True),
        'parent_left': fields.integer('Centro de custo Descendente', select=1),
        'parent_right': fields.integer('Centro de custo ascendente', select=1),
        'controle': fields.integer('Codigo de Controle'), # Controla a criacao dos codigos das contas ex: 2.2.4
        'active': fields.boolean('Ativo'),
    }
    _sql_constraints = [
        ('sigla_uniq', 'unique (company_id, sigla)', 'A sigla precisa ser unica!'),
    ]
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        'active': True,
    }


