# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class adm_condicao(osv.Model):
    """
    Tabela que contem as condicoes de pagamentos.
    """
    _name = 'adm.condicao'
    _columns = {
        'name': fields.char('Nome', size=45, required=True), # Descricao da condicao de pagamento.
        'tipo': fields.selection(
            [('V', 'A vista'), ('P', 'Contra apresentacao'), ('C', 'A prazo'), ('S', 'Sem condicoes')], 'Tipo',
            required=True, size=1), # Tipo da condicao: V=a vista, C=contra apresentacao, P=Prazo
        'qtde_parcelas': fields.integer('Quantidade de parcelas', required=True), # Quantidade de parcelas.
        'dias_incremento': fields.integer('Dias de incremento', required=True), # Quantidade de dias de intervalo entre as parcelas.
        'dias_primeira_parcela': fields.integer('Dias da primeira parcela', required=True),
        'forma_pgto_ids': fields.one2many('adm.condicao.forma', 'adm_condicao_id', "Condicoes de Pagamento"),
        'tipo_prazo': fields.selection([
                                           ('DD', 'Dias Direto'),
                                           ('DFS', 'Dias Fora Semana'),
                                           ('DFQ', 'Dias Fora a Quinzena'),
                                           ('DFM', 'Dias Fora o mes')
                                       ], 'Tipo prazo', required=True, size=3),
        'active': fields.boolean('Ativo'),
        'admcnd_dia_fechamento': fields.integer('Dia de Fechamento',
                                                help="Dia a ser usado para fechamento do periodo(semana, quinzena, mes)"),
    }
    _defaults = {
        'dias_incremento': lambda *a: 0,
        'tipo': lambda *a: 'V',
        'qtde_parcelas': 1,
        'dias_primeira_parcela': 0,
        'tipo_prazo': lambda *a: 'DD',
        'active': True,
    }



