# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from funcoes import _admcf_name, _admcof_get_active, admcof_get_cond_forma_id_condicao,\
                    admcof_get_cond_forma_id_forma, admcof_get_forma_condicao_id

class adm_condicao_forma(osv.Model):
    """
    Tabela que contem as condicoes de pagamento utilizadas pela empresa
    Prefixo: admcof_
    """

    _name = 'adm.condicao.forma'
    _rec_name = 'name'
    _columns = {
        'name': fields.function(_admcf_name, string='Nome', type='char', store=True),
        'active':  fields.function(_admcof_get_active, string="Activo", type="boolean", method=True,
                         store={'adm.condicao': (admcof_get_cond_forma_id_condicao, ['active'], 10),
                                'adm.forma.pgto': (admcof_get_cond_forma_id_forma, ['active'], 10),
                                'adm.condicao.forma': (admcof_get_forma_condicao_id, [], 10)},
                                  ),
        'taxa': fields.float("Taxa", digits=(2, 3), help="Taxa de administracao, no caso de cartoes de credito/debito"),
        'desconto': fields.float("Desconto", digits=(2, 3)),
        'forma_pagamento_id': fields.many2one('adm.forma.pgto', 'Forma de Pagamento', ondelete="cascade", select=True,
                                              required=True),
        'adm_condicao_id': fields.many2one('adm.condicao', "Condicao de Pagamento", required=True, ondelete='cascade',
                                           select=True),
        'acrescimo': fields.float("Acrescimo", digits=(2, 3)),
        'admcof_aceita_desconto': fields.boolean('Permite desconto'),
    }

    _defaults = {
        'admcof_aceita_desconto': lambda *a: True,
        'active': True,
    }



