# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_empresa_objeto(osv.Model):
    """
    Tabela que identifica qual objetos e empresas
    Identifica por exemplo que o objeto cliente para a empresa 1, sera utilizado utilizado o da empresa 2
    """
    _name = 'adm.empresa.objeto'
    _columns = {
        'empresa_escolhida_id': fields.many2one("res.company", 'Empresa escolhida', ondelete="cascade", required=True,
                                                select=True), # id da empresa escolhida
        'empresa_a_usar_id': fields.many2one("res.company", 'Empresa a usar', ondelete="cascade", required=True,
                                             select=True), # id da empresa a ser utilizada\n
        'ir_model_id': fields.many2one("ir.model", 'Objeto', ondelete="cascade", required=True, select=True,
                                       help="Nome da Tabela a ser redirecionada"), # id do objeto
    }
    _sql_constraints = [
        ('codigo_uniq', 'unique (empresa_escolhida_id, ir_model_id)',
         'Nao posso fazer mais de um relacionamento para uma tabela em uma empresa!!'.decode('utf-8')),
    ]

