# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_forma_pgto(osv.Model):
    """
    Tabela de tipos de moedas usado nas transacoes financeiras.
    """
    _name = 'adm.forma.pgto'  # admfpg
    _columns = {
        'name': fields.char('Descricao', size=30, required=True), # Descricao do tipo de moeda
        'bloqueio': fields.boolean('Bloqueio'), # True=Bloqueio, nao pode ser excluido. \nFalse=Nao bloqueia, pode ser excluido
        'sigla': fields.char('Sigla', size=3, select=True), # Sigla para identificacao do tipo de moeda
        'active': fields.boolean('Ativo'),
        'condicao_forma_ids': fields.one2many('adm.condicao.forma', 'forma_pagamento_id',
                                              "Condicoes/Formas de Pagamento"),
        'cartao_credito_debito': fields.boolean('Cartao de Credito/Debito'),
        'tipo_cartao': fields.selection([('D', 'Debito'), ('C', 'Credito')], 'Tipo do Cartao'),
        'admfpg_cartao_pessoa_id': fields.many2one("adm.pessoa", 'Operadora de Cartao', select=True,
                                                   domain=[('admpes_jur_tipo_empresa', '=', 'A')]),
    }

    _defaults = {
        'bloqueio': lambda *a: False,
        'active': lambda *a: True,
        'cartao_credito_debito': lambda *a: False,
    }

