# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from datetime import date

# Funcoes da classe adm_banco
def _admbco_name_get(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    if not len(ids):
        return []
    reads = self.read(cr, uid, ids, ['admbco_codigo_bc', 'admbco_pessoa_id'], context=context)
    res = {}
    for record in reads:
        name = '%03d - %s' % (record['admbco_codigo_bc'], record['admbco_pessoa_id'][-1])
        res[record['id']] = name
    return res

# Funcoes da classe adm_calendario_feriado
YEAR = date.today().year


def _admcfe_get_data(self, cr, uid, ids, name, arg, context=None):
    res = {}
    obj = self.browse(cr, uid, ids)
    for x in obj:
        res[x.id] = str(date(YEAR, x.admcfe_mes, x.admcfe_dia))
    return res

# Funcoes da classe adm_empresa_centrocusto
def _admecc_get_codigo(self, cr, uid, ids, name_field, args, context=None):
    context = context and context.copy() or {}
    return self.pool.get('adm.utils').get_nome_conta(cr, uid, ids, self._name, True, context)

# Selection da classe adm_transacao_capa
admtrc_operacao = [
    ('orca', 'Orcamento'),
    ('pedi', 'Pedido'),
    ('nota', 'NF'),
    ('fatu', 'fatura'),
    ('titu', 'titulo'),
    ('epro', 'Entrada de producao'),
    ('teso', 'Tesouraria'),
    ('almx', 'Almoxarifado'),
    ('rsup', 'Ressuprimento'),
    ('solc', 'Solicitacao de Compras'),
    ('rqcp', 'Requisicao de Compras'),
    ('cota', 'Cotacoes'),
    ('cupo', 'Cupons fiscais'),
]

# Funcoes da classe adm_transportador
def _admtra_nome_transportador(self, cursor, user, ids, name, arg, context=None):
    """
    Retorna o nome do transportador
    """
    context = context and context.copy() or {}
    res = {}
    for transportadora in self.browse(cursor, user, ids):
        if transportadora.pessoa_id:
            res[transportadora.id] = transportadora.pessoa_id.name
        else:
            res[transportadora.id] = False
    return res


def _admcf_name(self, cr, uid, ids, name, arg, context=None):
    """
    Retorna o nome da forma de pagamento + nome da condicao
    """
    context = context and context.copy() or {}
    if not len(ids):
        return []
    brw_cond_forma = self.browse(cr, uid, ids)
    res = {}
    for i in brw_cond_forma:
        name = "%s - %s" % (i.forma_pagamento_id.name, i.adm_condicao_id.name)
        res[i.id] = name
    return res

def _admcof_get_active(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for forma_condicao in self.browse(cr, uid, ids, context=context):
        # caso o active da forma ou da condicao de pagamenro sejam False, forma_condicao deve ser
        # false, sera True apenas se as duas forem True
        active = forma_condicao.adm_condicao_id.active and forma_condicao.forma_pagamento_id.active
        res[forma_condicao.id] = active

    return res

def admcof_get_cond_forma_id_condicao(self, cr, uid, ids, context=None):
    '''
    Retorna os ids de adm.condicao.forma que possuem os ids das condicoes de pagamento passadas
    '''
    context = context and context.copy() or {}
    res = self.pool.get('adm.condicao.forma').search(cr, uid, [('adm_condicao_id','in', ids)],
                                               context=context)
    return res

def admcof_get_cond_forma_id_forma(self, cr, uid, ids, context=None):
    '''
    Retorna os ids de adm.condicao.forma que possuem os ids das formas de pagamento passadas
    '''
    context = context and context.copy() or {}
    res = self.pool.get('adm.condicao.forma').search(cr, uid, [('forma_pagamento_id','in', ids)],
                                                     context=context)
    return res

def admcof_get_forma_condicao_id(self, cr, uid, ids, context=None):
    context = context and context.copy() or {}
    return ids
