# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_moeda(osv.Model):
    """
    Tabela de moedas
    """
    _name = 'adm.moeda'
    _columns = {
        'name': fields.char('Nome', size=30, required=True), # Nome da moeda
        'sigla': fields.char('Sigla', size=6, required=True, select=True), # Sigla da moeda
        'moeda_valor_ids': fields.one2many('adm.moeda.valor', 'moeda_id', 'Valores'),
        'active': fields.boolean('Ativo'),
    }
    _defaults = {
        'active': True
    }
    _sql_constraints = [
        ('sigla_uniq', 'unique (sigla)', 'A sigla precisa ser unica!'),
    ]

