# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_paginas(osv.Model):
    """
    Tabela de controle de paginacao de relatorios
    """
    _name = 'adm.paginas'
    _order = 'company_id, tipo, data'
    _columns = {
        'data': fields.date('Data', required=True), #Data do controle.Para livros que sao mensais, use 01 no dia da data.
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True), # Codigo de identificacao da empresa
        'tipo': fields.char('Tipo', size=20, required=True),
        'inicial': fields.integer('Pagina Inicial'),
        'final': fields.integer('Pagina Final'),
        'create_date': fields.datetime('Data criacao'),
        'write_date': fields.datetime('Data edicao'),
    }
    _sql_constraints = [('adm_pagina_uniq', 'unique(company_id, data, tipo)',
                         'A data informada ja encontra-se cadastrada para este tipo de registro!'), ]
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }

