# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_parametro(osv.Model):
    """
    Tabela Geral de parametro
    """
    _name = 'adm.parametro'
    _rec_name = 'company_id'
    _description = 'Parametros da Administracao'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True), # id da empresa
        'responsavel_id': fields.many2one('adm.pessoa', 'Responsavel', ondelete="restrict", select=True),
        'admpar_cpf_cnpj_obrigatorio': fields.boolean('CPF/CNPJ obrigatorio'),
        'contador_id': fields.many2one("adm.pessoa", 'Contador', ondelete="restrict", required=True, select=True),
        'socio_id': fields.many2one("adm.pessoa", 'Socio responsavel', ondelete="restrict", required=True, select=True),
        'busca_cep': fields.selection([('C', 'Correios'), ('B', 'Base cep'), ('A', 'Ambos')], 'Modo de busca', size=1,
                                      help='Maneira pela qual o sistema busca os ceps digitados, a opcao ambos, tenta primeiro pelo Correio e somente se nao conseguir verifica na base'),
        'admpar_siggestao_servidor': fields.char('Servidor SigGestao', size=64,
                                                 help='IP ou dominio do servidor SigGestao'),
        'admpar_siggestao_diretorio': fields.char('Diretorio do SigGestao', size=64,
                                                  help='Diretorio onde está instalado o SigGestao'),
        'admpar_siggestao_dav_exportar': fields.char('Comando exportar DAV', size=64,
                                                     help='Comando a ser executado no sigGestao para exportacao do DAV'),
        'admpar_nao_usar_soundex': fields.boolean('Nao usar fonemas na pesquisa de nomes'),
        'admpar_capitaliza_nomes': fields.boolean('Capitalizar nomes', help='Capitaliza nomes de pessoas, ruas, cidades e bairros'),
    }
    _defaults = {
        'admpar_cpf_cnpj_obrigatorio': lambda *a: False,
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        'busca_cep': lambda *a: 'A',
        'admpar_nao_usar_soundex': lambda *a: False,

    }


