# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_transportador(osv.Model):
    """
    Tabela de Transportadores
    """

    #prefixo = admtra_

    from funcoes import _admtra_nome_transportador

    _name = 'adm.transportador'
    _columns = {
        'pessoa_id': fields.many2one("adm.pessoa", 'Transportador', ondelete="cascade",
                                     required=True, select=True,
                                     domain="[('admpes_jur_tipo_atividade', '=', 'T')]"),
        'name': fields.function(_admtra_nome_transportador, method=True, string='Transportadora',
                                type='text', store=False),  # nome do transportador
        'admtra_annt':fields.char('ANTT', size=20),
    }
    _sql_constraints = [
        ('pessoa_id_uniq', 'unique (pessoa_id)', 'Transportadora ja cadastrada'),
    ]

