# -*- encoding: utf-8 -*-
# #############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
import time
from SigUtils import datas
import logging
from openerp.tools.translate import _
from datetime import timedelta, datetime  # Não remover este import, poderá ser utilizado no dominio

_logger = logging.getLogger(__name__)


class adm_monitor_alertas(osv.Model):
    _name = 'adm.monitor.alertas'
    _inherit = 'adm.monitor.alertas'

    def copy(self, cr, uid, id, default={}, context=None):
        context = context and context.copy() or {}
        if isinstance(default, dict):
            default.update({'admmal_ultima_verificacao': False})
        return super(adm_monitor_alertas, self).copy(cr, uid, id, default, context)

    def admmal_verificar_alertas(self, cr, uid, context=None):
        """
        Verificar cada regra cadastrada no monitor para cada empresa para gerar os alertas
        """
        context = context and context.copy() or {}
        def _admmal_verifica_ocorrencia(empresa, dominio, descricao=''):
            args = [('company_id', '=', empresa), ('admmoc_dominio', '=', str(dominio))]
            if descricao:
                args.append(('name', '=', descricao))
            ids = _obj_ocorrencias.search(cr, uid, args, context=context)
            if ids:
                return True
            else:
                return False


        def _admmal_aplicar_regra(cr, uid, id):
            """
            Verificar se a regra esta dentro do prazo para ser aplicada
            """
            res = True
            _dados_alerta = self.read(cr, uid, id, ['admmal_ultima_verificacao', 'admmal_periodo',
                                                    'admmal_prazo'], context=context)
            if isinstance(_dados_alerta, list):
                _dados_alerta = _dados_alerta[0]
            _ultimoPrazo = _dados_alerta['admmal_ultima_verificacao'] or False
            if not _ultimoPrazo:
                return res
            _periodo = _dados_alerta['admmal_periodo']
            _prazo = _dados_alerta['admmal_prazo']
            _agora = time.strftime('%Y-%m-%d %H:%M:%S')
            if _periodo in ('D', 'M'):
                _ultimoPrazo = _ultimoPrazo[:11] + '00:00:00'
                _agora = _agora[:11] + '00:00:00'
            _diff = datas.getDiffDatetime(_ultimoPrazo, _agora, 'T')
            if _diff:
                if _periodo == 'D':  # Dias
                    if _diff[2] < _prazo:
                        res = False
                elif _periodo == 'M':
                    if _diff[1] < _prazo:
                        res = False
                elif _periodo == 'h':
                    if _diff[3] < _prazo:
                        res = False
                elif _periodo == 'm':
                    if _diff[4] < _prazo:
                        res = False
                elif _periodo == 'S':
                    res = False
            return res

        def _admmal_executar_metodo(self, cr, uid, xm_brw_regra, xm_empresa, xm_alerta, xm_args,
                                    xm_context):
            """
            Método para executar métodos do openerp dentro do sistema de monitoramento de alertas
            Obs:
               1- NÃO REMOVER O "self" DA ASSINATURA DO MÉTODO ELE É NECESSÁRIO NO EVAL DO COMANDO
               2- Na definição da regra, se desejar usar contexto, use apenas a palavra context para
                  que possa ser substituida pelo contexto correto
            @param cr:
            @param uid:
            @param xm_brw_regra: Método a ser executado
            @param xm_empresa: Empresa em que o método se
            @param xm_alerta:
            @param xm_args:
            @param context:
            @return: {bool} True
            """
            xm_context = xm_context and xm_context.copy() or {}
            #
            if 'context' in xm_args:
                xm_args = xm_args.replace('context', 'context=' + str(context))
            if 'company_id' in xm_args and 'estpgr_get_saldo_menor_minimo' in xm_args:
                xm_args = xm_args.replace('company_id', 'company_id=' + str(xm_empresa))
            try:
                _cmd = "self.pool.get('%s').%s" % (xm_brw_regra.admmrg_classe, xm_args)
                res = eval(_cmd)
            except Exception as e:
                _logger.error(_("%s. Erro na execucao do metodo: %s"), e, xm_args)
                return True
            if isinstance(res, (list, tuple)):
                pass
            else:
                res = [res]
            if 'estpgr_get_saldo_menor_minimo' in xm_args:
                xm_args = "[('id', 'in', %s)]" % res
                res = ['Quantidade: %s' % len(res)]
            for linha in res:
                user_ids = []
                if isinstance(linha, list):
                    user_ids = linha[1]
                    linha = linha[0]
                vals = {
                    'admmoc_alerta_id': xm_alerta,
                    'name': linha,
                    'company_id': xm_empresa,
                    'admmoc_classe': xm_brw_regra.admmrg_classe,
                    'admmoc_dominio': xm_args,
                }
                if not _admmal_verifica_ocorrencia(xm_empresa, xm_args, linha):
                    ocorrencia_id = _obj_ocorrencias.create(cr, uid, vals, context=xm_context)
                    for user_id in user_ids:
                        vals_ocorrencia_usuario = {
                            'admmou_user_id': user_id,
                            'admmou_ocorrencia_id': ocorrencia_id,
                        }
                        _obj_adm_monitor_ocorrencia_usuario.create(cr, uid, vals_ocorrencia_usuario,
                                                                   context=xm_context)
            return True


        def _admmal_executar_search(xs_cr, xs_uid, xs_brw_regra, xs_empresa, xs_alerta, xs_args,
                                    xs_context):
            xs_context = xs_context and xs_context.copy() or {}
            try:
                xs_args = eval(xs_args)
            except Exception as e:
                _logger.error(_("%s. Erro na avaliacao do dominio: %s"), e, xs_args)
                return True
            if 'company_id' in self.pool.get(xs_brw_regra.admmrg_classe)._columns:
                xs_args.append(('company_id', '=', xs_empresa))

            if xs_brw_regra.admmrg_contexto:
                xs_context.update(xs_brw_regra.admmrg_contexto)
            _ids = self.pool.get(xs_brw_regra.admmrg_classe).search(xs_cr, xs_uid, xs_args,
                                                                    context=xs_context)
            if _ids:
                vals = {
                    'admmoc_alerta_id': xs_alerta,
                    'name': 'Quantidade: ' + str(len(_ids)),
                    'company_id': xs_empresa,
                    'admmoc_classe': xs_brw_regra.admmrg_classe,
                    'admmoc_dominio': xs_args,
                }
                if not _admmal_verifica_ocorrencia(xs_empresa, xs_args):
                    _obj_ocorrencias.create(xs_cr, xs_uid, vals, context=xs_context)
            return True

        context = context and context.copy() or {}
        _obj_ocorrencias = self.pool.get('adm.monitor.ocorrencias')
        _obj_regras = self.pool.get('adm.monitor.alertas.regras')
        _obj_adm_monitor_ocorrencia_usuario = self.pool.get('adm.monitor.ocorrencia.usuario')
        _obj_adm_monitor_alertas_grupos = self.pool.get('adm.monitor.alertas.grupos')
        if not 'sig_force_company' in context:
            context['sig_force_company'] = True
        _empresa_ids = self.pool.get('res.company').search(cr, uid, [], context=context)
        for _alerta_id in self.search(cr, uid, [], context=context):
            if not _admmal_aplicar_regra(cr, uid, _alerta_id):
                continue
            for _empresa_id in _empresa_ids:
                _args = [('admmoc_alerta_id', '=', _alerta_id), ('company_id', '=', _empresa_id)]
                _ocorrencia_ids = _obj_ocorrencias.search(cr, uid, _args, context=context)
                if _ocorrencia_ids:
                    res = _obj_ocorrencias.unlink(cr, uid, _ocorrencia_ids)
                else:
                    _regra_ids = _obj_regras.search(cr, uid, [('admmrg_alerta_id', '=', _alerta_id)], context=context)
                    for _brw_regra in _obj_regras.browse(cr, uid, _regra_ids):
                        _args = _brw_regra.name
                        if len(_args) > 7 and _args[:7] == 'metodo:':
                            res = _admmal_executar_metodo(self, cr, uid, _brw_regra, _empresa_id,
                                                          _alerta_id,
                                                          _args[7:], context)
                        else:
                            res = _admmal_executar_search(cr, uid, _brw_regra, _empresa_id, _alerta_id,
                                                          _args, context)
                        if not 'company_id' in self.pool.get(_brw_regra.admmrg_classe)._columns:
                            break
            vals = {
                'admmal_ultima_verificacao': time.strftime('%Y-%m-%d %H:%M:%S'),
            }
            self.write(cr, uid, _alerta_id, vals, context=context)
        return True
