# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class adm_monitor_ocorrencias(osv.Model):
    """
     Esta classe contem as ocorrencias identificadas.
     São os alertas verificados e que tiverem suas regras satisfeitas.
     Sempre que um alerta for verificado novamente as ocorrencias do alerta anterior devem ser apagadas.
     As ocorrencias devem ser geradas por empresa.
     O admmoc_domain, é o dominio ou argumento a ser aplicado no search da classe identificada nas regras
    """
    _name = 'adm.monitor.ocorrencias'
    _inherit = 'adm.monitor.ocorrencias'

    def button_desativar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
        obj_adm_monitor_ocorrencia_usuario = self.pool.get('adm.monitor.ocorrencia.usuario')
        ocorrencia_usuario_ids = obj_adm_monitor_ocorrencia_usuario.search(
            cr, uid, [('admmou_ocorrencia_id', 'in', ids), ('admmou_user_id', '=', uid)], context=context)
        obj_adm_monitor_ocorrencia_usuario.unlink(cr, uid, ocorrencia_usuario_ids, context)
        return True

    def button_consultar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        def _get_view_id(_view_name):
            res_id = False
            _obj_ir_model_data = self.pool.get('ir.model.data')
            ids = _obj_ir_model_data.search(cr, uid,[('name', '=', _view_name)], context=context)
            if ids:
                res_id = _obj_ir_model_data.read(cr, uid, ids[0], ['res_id'], context=context)['res_id']
            return res_id

        if not ids:
            return False
        id = ids[0]
        _brw_ocorrencias = self.browse(cr, uid, id)
        try:
            _brw_ocorrencias.admmoc_alerta_id.name
        except Exception as e:
            raise osv.except_osv(_('Atencao'), _('Alerta removido pelo agendador de tarefas. '
                                                 'Tecle F5.'))
        res = {
            'name': _brw_ocorrencias.admmoc_alerta_id.name,
            'view_type': 'form',
            'view_mode': 'tree',
            'res_model': _brw_ocorrencias.admmoc_classe,
            'view_id': False,
            'context': context,
            'target': 'new',
            'type': 'ir.actions.act_window',
            'domain': _brw_ocorrencias.admmoc_dominio,
        }
        if ('Chamados' in _brw_ocorrencias.admmoc_alerta_id.name and
            _brw_ocorrencias.admmoc_classe == 'crm_br.case'):
                res['view_id'] = _get_view_id('crm_br_case_tree_view')
        return res

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        def _verificar_ocorrencia(res, uid):
            if not res:
                return res
            _ocorrencia_usuario_ids = obj_adm_monitor_ocorrencia_usuario.search(
                cr, uid, [('admmou_ocorrencia_id', 'in', res),
                          ('admmou_user_id', '=', uid)], context=context)
            if _ocorrencia_usuario_ids:
                dados_ocorrencia_usuario = obj_adm_monitor_ocorrencia_usuario.read(
                    cr, uid, _ocorrencia_usuario_ids, ['admmou_ocorrencia_id'], context=context)
                res = list(set(map(lambda i: i.get('admmou_ocorrencia_id')[0], dados_ocorrencia_usuario)))
            else:
                res = []
            return res

        context = context and context.copy() or {}
        obj_adm_monitor_ocorrencia_usuario = self.pool.get('adm.monitor.ocorrencia.usuario')
        res = super(adm_monitor_ocorrencias, self).search(cr, uid, args, offset, limit, order, context, count)
        if context.get('alerta_painel'):
            if not isinstance(res, list):
                return []
            res = _verificar_ocorrencia(res, uid)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if not 'sig_force_company' in context:
            context['sig_force_company'] = True
        result = super(adm_monitor_ocorrencias, self).write(cr, uid, ids, vals, context)
        return result

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        def _admmoc_incluir_ocorrencia_usuario(cr, uid, alerta_id):
            """
            O metodo identifica os usuarios e as ocorrencias para um determinado alerta, para assim
            incluir esses dados na tabela 'adm_monitor_ocorrencia_usuario'
            @param cr: cursor do banco de dados
            @param uid: id do usuario
            @param alerta_id: id da tabela 'adm_monitor_alertas'
            @return: False, caso a inclusao nao seja realizada. True, caso a inclusao seja realizada
            """
            res = False
            if not alerta_id:
                return res
            _obj_adm_monitor_alertas_grupos = self.pool.get('adm.monitor.alertas.grupos')
            _obj_adm_monitor_ocorrencia_usuario = self.pool.get('adm.monitor.ocorrencia.usuario')
            _obj_ocorrencias = self.pool.get('adm.monitor.ocorrencias')
            # Identifica os usuarios do alerta
            alerta_grupo_ids = _obj_adm_monitor_alertas_grupos.search(
                cr, uid, [('admmgr_alerta_id', '=', alerta_id)], context=context)
            if not alerta_grupo_ids:
                return res
            brw_monitor_altera_grupo = _obj_adm_monitor_alertas_grupos.browse(cr, uid,
                                                                              alerta_grupo_ids)
            user_ids = []
            for x in brw_monitor_altera_grupo:
                grupo_id = x.admmgr_grupo_id.id
                user_id = x.admmgr_user_id.id
                if grupo_id:
                    sql = """SELECT uid FROM res_groups_users_rel WHERE gid = %s""" % grupo_id
                    cr.execute(sql)
                    user_ids.extend(list(set(map(lambda i: i.get('uid'), cr.dictfetchall()))))
                if user_id and not user_id in user_ids:
                    user_ids.append(user_id)

            # Identifica as ocorrencias do alerta
            ids_ocorrencia = _obj_ocorrencias.search(cr, uid,
                                                     [('admmoc_alerta_id', '=', alerta_id)], context=context)
            if not ids_ocorrencia:
                return res

            # Relaciona cada ocorrencia aos devidos usuarios, ou seja, os usuarios que verao cada
            # ocorrencia
            for ocorrencia_id in ids_ocorrencia:
                for id_user in user_ids:
                    vals_ocorrencia_usuario = {
                        'admmou_user_id': id_user,
                        'admmou_ocorrencia_id': ocorrencia_id,
                    }
                    _obj_adm_monitor_ocorrencia_usuario.create(cr, uid, vals_ocorrencia_usuario, context)
                    res = True
            return res

        if not 'sig_force_company' in context:
            context['sig_force_company'] = True
        try: # Não permitir Criar alerta repetido
            result = super(adm_monitor_ocorrencias, self).create(cr, uid, vals, context)
            if vals.get('admmoc_alerta_id', False):
                _admmoc_incluir_ocorrencia_usuario(cr, uid, vals.get('admmoc_alerta_id'))
        except:
            result = True
        return result

