# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_monitor_ocorrencias(osv.Model):
    """
     Esta classe contem as ocorrencias identificadas.
     São os alertas verificados e que tiverem suas regras satisfeitas.
     Sempre que um alerta for verificado novamente as ocorrencias do alerta anterior devem ser apagadas.
     As ocorrencias devem ser geradas por empresa.
     O admmoc_domain, é o dominio ou argumento a ser aplicado no search da classe identificada nas regras
    """
    _name = 'adm.monitor.ocorrencias'
    _gerar_logs_logs = 'N'
    _columns = {
        'admmoc_alerta_id': fields.many2one('adm.monitor.alertas', 'Alerta', required=True, ondelete='cascade',
                                            select=True),
        'name': fields.char('Descricao', size=64, required=True),
        'company_id': fields.many2one('res.company',  'Empresa', ondelete='cascade', required=True, select=True),
        'admmoc_classe': fields.char('Nome da classe', size=64, readonly=True),
        'admmoc_dominio': fields.text('Dominio', readonly=True),
    }
    _order = 'name'

