# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv


class adm_pessoa_categoria_nome(osv.Model):
    _name = 'adm.pessoa.categoria.nome'
    _inherit = 'adm.pessoa.categoria.nome'

    def _verifica_recursao(self, cr, uid, ids):
        """
        Metodo para Impedir o cadastramento de categorias recursivas
        """
        level = 100
        while len(ids):
            cr.execute("select distinct parent_id from adm_pessoa_categoria_nome where id in (" + ','.join(
                map(str, ids)) + ')')
            ids = filter(None, map(lambda x: x[0], cr.fetchall()))
            if not level:
                return False
            level -= 1
        return True

    _constraints = [
        (_verifica_recursao, 'Erro! Voce nao pode criar uma categoria recursiva.', ['parent_id'])
    ]

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if context.get('associacao'):
            ids = self.pool.get('adm.pessoa.categoria.nome').search(cr, uid, [('name', '=', 'Socios')], context=context)
            if ids:
                vals['parent_id'] = ids[0]
        result = super(adm_pessoa_categoria_nome, self).create(cr, uid, vals, context)
        return result

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not len(ids):
            return []
        reads = self.read(cr, uid, ids, ['name', 'parent_id'], context=context)
        res = []
        for record in reads:
            name = record['name']
            if record['parent_id']:
                name = record['parent_id'][1] + ' / ' + name
            res.append((record['id'], name))
        return res

