# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
from SigUtils import uf, inscricao_estadual


class adm_pessoa_documento_dados(osv.Model):
    _inherit = 'adm.pessoa.documento.dados'

    def admpdo_validar(self, cr, uid, tipo_doc_id=None, emitente=None, numero=None, context=None):
        res = {'status': True, 'mensagem': ''}
        if numero or emitente:
            if not tipo_doc_id:
                return {'status': False, 'mensagem': _('Tipo de documento nao definido!')}
        brw_tipo_doc = self.pool.get('adm.pessoa.documento.tipo').browse(cr, uid, tipo_doc_id, context=context)
        if brw_tipo_doc.sigla == 'IEST':
            if not emitente:
                return {'status': False, 'mensagem': _('Para tipo de documento IEST, tem que informar um emitente!')}
            _uf = uf.Uf(emitente)
            if not _uf.validaEstado():
                return {'status': False, 'mensagem': _('Emitente nao e uma UF(estado) valida!')}
            _ie = inscricao_estadual.validar(emitente, numero)
            if not _ie:
                return {'status': False, 'mensagem': _('Numero de inscricao invalido para este emitente!')}
            res['mensagem'] = _ie
        return res

    def write(self, cr, uid, ids, vals, context=None):
        if vals.get('emitente'):
            _emitente = vals.get('emitente').upper()
        else:
            _emitente = None
        _numero = vals.get('numero')
        if _emitente or _numero:
            if isinstance(ids, (list, tuple)):
                _doc_id = ids[0]
            else:
                _doc_id = ids
            brw_doc = self.browse(cr, uid, _doc_id, context=context)
            _tipo_id = False
            if vals.get('tipo_id'):
                _tipo_id = vals.get('tipo_id')
            else:
                _tipo_id = brw_doc.tipo_id.id
            if not _emitente:
                _emitente = brw_doc.emitente.upper()
            if not _numero:
                _numero = brw_doc.numero
            res = self.admpdo_validar(cr, uid, tipo_doc_id=_tipo_id, emitente=_emitente, numero=_numero,
                                      context=context)
            if not res.get('status'):
                raise osv.except_osv(_('Atencao'), res.get('mensagem'))
            if res.get('mensagem'):
                vals['numero'] = res.get('mensagem')
                vals['emitente'] = _emitente
        res = super(adm_pessoa_documento_dados, self).write(cr, uid, ids, vals, context=context)
        return res

    def create(self, cr, uid, vals, context=None):
        if vals.get('emitente'):
            _emitente = vals.get('emitente').upper()
        else:
            _emitente = None
        _numero = vals.get('numero')
        _tipo_id = vals.get('tipo_id')
        res = self.admpdo_validar(cr, uid, tipo_doc_id=_tipo_id, emitente=_emitente, numero=_numero, context=context)
        if not res.get('status'):
            raise osv.except_osv(_('Atencao'), res.get('mensagem'))
        if res.get('mensagem'):
            vals['numero'] = res.get('mensagem')
            vals['emitente'] = _emitente
        res = super(adm_pessoa_documento_dados, self).create(cr, uid, vals, context=context)
        return res
