# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class adm_email_tipo(osv.Model):
    _name = 'adm.email.tipo'
    _inherit = 'adm.email.tipo'

    def write(self, cr, uid, ids, vals, context=None):
        """
        Metodo para atualizacao de registro.
        Nao atualiza registro cujo atributo bloqueio e False
        """
        context = context and context.copy() or {}
        tipo_email = self.pool.get('adm.email.tipo')
        ler_bloqueio = tipo_email.read(cr, uid, ids, ['bloqueio'], context=context)
        if ler_bloqueio[0]['bloqueio']:
            raise osv.except_osv(_('Mensagem:'),
                                 _('Este tipo de e-mail nao pode ser alterado !'))
        result = super(adm_email_tipo, self).write(cr, uid, ids, vals, context=context)
        return result

    def unlink(self, cr, uid, ids, context=None):
        """
        Metodo que proporciona a exclusao do registro.
        Nao exclue registro cujo atributo bloqueio e False
        """
        context = context and context.copy() or {}
        for tipo_email in self.browse(cr, uid, ids):
            if tipo_email.bloqueio:
                raise osv.except_osv(_('Mensagem:'),
                                     _('Este tipo de e-mail nao pode ser excluido !'))
        return super(adm_email_tipo, self).unlink(cr, uid, ids)


