# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
READ_LOAD = '_classic_write'
import logging

class adm_cidade(osv.Model):

    _inherit = 'adm.cidade'
    _name = 'adm.cidade'
    _logger = logging.getLogger(_name)

    def admcid_get_cidade_pelo_codigo_ibge(self, cr, uid, cod_ibge, context=None):
        context = context and context.copy() or {}
        if cod_ibge:
            cidade_ids = self.search(cr, uid, [('codigo_ibge', '=', cod_ibge)], context=context)
            if cidade_ids:
                return cidade_ids[0]
        return False

    def name_search(self, cr, uid, name='', args=[], operator='ilike', context=None, limit=100):
        context = context and context.copy() or {}
        args.append(['name','ilike',name])
        ids = self.search(cr, uid, args)
        return self.name_get(cr, uid, ids, context)

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        if context.get('not_simple_unaccent'):
            return super(adm_cidade, self).search(
                cr, uid, args, offset, limit, order, context, count)
        sql_create = ''''''
        sql = ''''''
        uf_id_sql = ''''''
        uf_id = False
        for i in args:
            if i[0] == 'uf_id' and i[2]:
                uf_id = i[2]
                uf_id_sql = '''   AND uf_id = %s
                            ''' % uf_id
            if i[0] == 'name' and i[2]:
                sql_create = '''
                            CREATE OR REPLACE FUNCTION simple_unaccent(text)
                            RETURNS text AS
                            $BODY$
                            select
                            translate($1,'áàâãäéèêëíìïóòôõöúùûüÁÀÂÃÄÉÈÊËÍÌÏÓÒÔÕÖÚÙÛÜçÇ',
                            'aaaaaeeeeiiiooooouuuuAAAAAEEEEIIIOOOOOUUUUcC')
                            $BODY$
                            LANGUAGE 'sql' IMMUTABLE STRICT;
                       '''
                nome = self.pool.get('adm.utils').admutl_remover_acentuacao(cr, uid, i[2])
                sql = '''
                        SELECT id
                        FROM(
                            SELECT id, simple_unaccent(name) AS name, uf_id
                            FROM adm_cidade) AS tmp
                        WHERE name ilike '%s'
                      ''' % ('%'+nome.replace("'", "''")+'%')
        dados = []
        if sql:
            if uf_id:
                sql += uf_id_sql
            cr.execute(sql_create)
            cr.execute(sql)
            dados = cr.dictfetchall()
        ids = []
        for dado in dados:
            ids.append(dado.get('id'))
        if ids:
            return ids
        res = super(adm_cidade, self).search(cr, uid, args, offset, limit, order, context, count)
        return res

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        brw_res_users = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        if brw_res_users and brw_res_users.login and brw_res_users.login == 'remoto':
            # self._logger.info('===> Usuario remoto criando Cidade:' + str(vals))
            return True # Usuario remoto não atualiza mais
        install_mode = context.get('install_mode')
        uf_id = vals.get('uf_id')
        cidade_nome = vals.get('name')
        codigo_ibge = vals.get('codigo_ibge') or ''
        # ID da Cidade
        cid_codibge_ja_cadastrado = self.admcid_get_cidade_pelo_codigo_ibge(cr, uid, cod_ibge=codigo_ibge)
        args = [('uf_id', '=', uf_id), ('name', 'ilike', cidade_nome)]
        nova_cidade_ids = self.search(cr, uid, args, context=context)
        vals['name'] = self.pool.get('adm.utils').admutl_capitalizar_adm_nome(cr, uid, vals.get('name'),
                                                                              context=context)
        # DADOS DO VALS NAO ESTAO CADASTRADOS NA BASE
        if not nova_cidade_ids:
            if cid_codibge_ja_cadastrado:
                if install_mode:
                    return cid_codibge_ja_cadastrado
                else:
                    raise osv.except_osv(
                        _('Atencao'),
                        _('Codigo do IBGE: %s ja cadastrado. ID - %d') % (codigo_ibge, cid_codibge_ja_cadastrado)
                    )
            else:
                return super(adm_cidade, self).create(cr, uid, vals, context)
        # DADOS DO VALS JA ENCONTRAM-SE CADASTRADOS NA BASE
        else:
            cidade_id = nova_cidade_ids[0]
            if cid_codibge_ja_cadastrado:
                if install_mode:
                    return cid_codibge_ja_cadastrado
                else:
                    if cidade_id != cid_codibge_ja_cadastrado:
                        raise osv.except_osv(
                            _('Atencao'),
                            _('Codigo do IBGE: %s ja cadastrado. ID - %d') % (codigo_ibge, cid_codibge_ja_cadastrado)
                        )
                    else:
                        return cidade_id
            else:
                if codigo_ibge and install_mode:
                    self.write(cr, uid, [cidade_id], {'codigo_ibge': codigo_ibge}, context=context)
                return cidade_id

    def write(self, cr, uid, ids, values, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
        install_mode = context.get('install_mode')
        vls_uf_id = values.get('uf_id') or False
        vls_nome = values.get('name') or ''
        vls_codigo_ibge = values.get('codigo_ibge') or ''
        # ID da Cidade
        cid_codibge_ja_cadastrado = self.admcid_get_cidade_pelo_codigo_ibge(cr, uid, cod_ibge=vls_codigo_ibge)
        cidade_dados = self.read(cr, uid, ids, fields=['uf_id', 'name'], context=context, load=READ_LOAD)
        for i in cidade_dados:
            cidade_id = i['id']
            cidade_uf_id = vls_uf_id or i.get('uf_id') or 0
            cidade_nome = vls_nome or i.get('name') or ''
            args = [
                ('uf_id', '=', cidade_uf_id), ('name', 'ilike', cidade_nome)
            ]
            cidade_cadastrada_ids = self.search(cr, uid, args, context=context)
            if install_mode:
                # NAO EXISTE NENHUMA CIDADE CADASTRADA COM O PAIS, UF E NOME.
                if not cidade_cadastrada_ids:
                    # NENHUMA CIDADE CADASTRADA COM O CODIGO IBGE INFORMADO.
                    if not cid_codibge_ja_cadastrado:
                        # A CIDADE É ATUALIZADA COM OS VALORES.
                        super(adm_cidade, self).write(cr, uid, [cidade_id], values, context)
                    else:
                        # JA EXISTE UMA CIDADE COM O CODIGO IBGE CADASTRADO. NO MODULO DE INSTALACAO, NADA SERA FEITO.
                        pass
                else:
                    # EXISTE UMA CIDADE CADASTRADA COM O PAIS, UF E NOME.
                    # É VERIFICADO SE ESTA CIDADE QUE FOI ENCONTRADA É IGUAL A CIDADE_ID (FOR NOS IDS)
                    if cidade_cadastrada_ids[0] == cidade_id:
                        # SE NAO HOUVER CODIGO IBGE CADASTRADO OU SE O CODIGO PERTENCER A MESMA CIDADE
                        if not cid_codibge_ja_cadastrado or cid_codibge_ja_cadastrado == cidade_id:
                            # A CIDADE É ATUALIZADA COM OS VALORES
                            super(adm_cidade, self).write(cr, uid, [cidade_id], values, context)
                        else:
                            # JA EXISTE UMA CIDADE COM O CODIGO IBGE CADASTRADO. NO MODULO DE INSTALACAO,
                            # NADA SERA FEITO.
                            pass
                    else:
                        pass
            else:
                if cid_codibge_ja_cadastrado:
                    if cid_codibge_ja_cadastrado != cidade_id:
                        raise osv.except_osv(
                            _('Atencao'),
                            _('Codigo do IBGE: %s ja cadastrado. ID - %d') % (vls_codigo_ibge, cid_codibge_ja_cadastrado)
                        )
                if cidade_cadastrada_ids and cidade_cadastrada_ids[0] != cidade_id:
                    raise osv.except_osv(_('Atencao'), _('Cidade ja cadastrada para o Estado!'))
                if 'name' in values:
                    values['name'] = self.pool.get('adm.utils').admutl_capitalizar_adm_nome(cr, uid, values.get('name'),
                                                                                      context=context)
                return super(adm_cidade, self).write(cr, uid, [cidade_id], values, context)
        return True
