# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv


class adm_logradouro(osv.Model):
    _name = 'adm.logradouro'
    _inherit = 'adm.logradouro'

    def name_search(self, cr, user, name='', args=None, operator='ilike', context=None, limit=100):
        """
        Metodo para pesquisar rua.

        """
        if not args:
            args = []
        context = context and context.copy() or {}
        ids = self.search(cr, user, [('titulo', '=', name.upper())] + args, limit=limit, context=context)
        if not ids:
            ids = self.search(cr, user, [('descricao', operator, name)] + args, limit=limit, context=context)
        return self.name_get(cr, user, ids, context)

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        vals['descricao'] = self.pool.get('adm.utils').admutl_capitalizar_adm_nome(cr, uid, vals.get('descricao'),
                                                                              context=context)
        res = super(adm_logradouro, self).create(cr, uid, vals, context=context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if 'descricao' in vals:
            vals['descricao'] = self.pool.get('adm.utils').admutl_capitalizar_adm_nome(cr, uid, vals.get('descricao'),
                                                                                  context=context)
        res = super(adm_logradouro, self).write(cr, uid, ids, vals, context=context)
        return res


    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        # if 'descricao' in vals:
        #     vals['descricao'] = self.pool.get('adm.utils').admutl_capitalizar_adm_nome(cr, uid, vals.get('descricao'),
        #
        #                                                                         context=context)
        _new_args = []
        for arg in args:
            if arg[0] != 'descricao':
                _new_args.append(arg)
            else:
                _logradouro = self.pool.get('adm.utils').admutl_capitalizar_adm_nome(cr, uid, arg[2], context=context)
                _new_args.append((arg[0],arg[1],_logradouro))
        res = super(adm_logradouro, self).search(cr, uid, _new_args, offset=offset, limit=limit, order=order, context=context, count=count)
        return res