# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _
import logging


class adm_pais(osv.Model):
    _name = 'adm.pais'
    _inherit = 'adm.pais'
    _logger = logging.getLogger(_name)

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        brw_res_users = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        if brw_res_users and brw_res_users.login and brw_res_users.login == 'remoto':
            return True

        nome = vals.get('name')
        pais_ids = self.search(cr, uid, [], context=context)
        for pais in self.read(cr, uid, pais_ids, ['name'], context=context):
            if pais.get('name').upper() == nome.upper():
                return pais.get('id')[0]

        if context.get('install_mode') and context['install_mode']:
            _id = self.search(cr, uid, [('sigla', '=', vals['sigla'].upper())], context=context)
            pais_id = self.search(cr, uid, [('name', '=', nome)], context=context)
            if _id or pais_id:
                return _id[0]

        if vals.get('sigla'):
            sigla = vals.get('sigla').upper()
            pais_id = self.search(cr, uid, [('sigla', '=', sigla)], context=context)
            if pais_id:
                raise osv.except_osv(_('Atencao'), _('Pais ja cadastrado com esta sigla'))
            vals['sigla'] = sigla
        vals['name'] = self.pool.get('adm.utils').admutl_capitalizar_adm_nome(cr, uid, vals.get('name'),
                                                                              context=context)
        res = super(adm_pais, self).create(cr, uid, vals, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('name'):
            nome = vals.get('name')
            pais_ids = self.search(cr, uid, [], context=context)
            for pais in self.read(cr, uid, pais_ids, ['name'], context=context):
                if pais.get('id') != ids[0] and pais.get('name').upper() == nome.upper():
                    raise osv.except_osv(_('Atencao'), _('Pais ja cadastrado com este nome'))

        if vals.get('sigla'):
            sigla = vals.get('sigla').upper()
            pais_id = self.search(cr, uid, [('sigla', '=', sigla)], context=context)
            if pais_id:
                raise osv.except_osv(_('Atencao'), _('Pais ja cadastrado com esta sigla'))
            vals['sigla'] = sigla
        if 'name' in vals:
            vals['name'] = self.pool.get('adm.utils').admutl_capitalizar_adm_nome(cr, uid, vals.get('name'),
                                                                              context=context)
        res = super(adm_pais, self).write(cr, uid, ids, vals, context=context)
        return res
