# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class adm_endereco_tipo(osv.Model):
    _name = 'adm.endereco.tipo'
    _inherit = 'adm.endereco.tipo'

    def write(self, cr, uid, ids, vals, context=None):
        """
        Metodo para atualizacao do tipo de endereco
        Nao permite alterar o registro quando o atributo bloqueio e True
        """
        context = context and context.copy() or {}
        endereco_tipo = self.pool.get('adm.endereco.tipo')
        bloqueio = endereco_tipo.read(cr, uid, ids, ['bloqueio'], context=context)
        if bloqueio[0]['bloqueio']:
            raise osv.except_osv(_('Mensagem:'),
                                 _('Este tipo de endereco nao pode ser alterado !'))
        result = super(adm_endereco_tipo, self).write(cr, uid, ids, vals, context=context)
        return result

    def unlink(self, cr, uid, ids, context=None):
        """
        Metodo para exclusao de registros
        Nao permite a exclusao o registro quando o atributo bloqueio e True
        """
        context = context and context.copy() or {}
        for endereco_tipo in self.browse(cr, uid, ids):
            if endereco_tipo.bloqueio:
                raise osv.except_osv(_('Mensagem:'),
                                     _('Este tipo de endereco nao pode ser excluido !'))
        return super(adm_endereco_tipo, self).unlink(cr, uid, ids)
