# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
import logging

class adm_uf(osv.Model):
    _name = 'adm.uf'
    _inherit = 'adm.uf'
    _logger = logging.getLogger(_name)

    def name_search(self, cr, user, name='', args=None, operator='ilike',
                    context=None, limit=100):
        """
        Metodo para search estados.
        Pode-se informar parte d nome do estado ou a sigla do estado
        """
        if not args:
            args = []
        context = context and context.copy() or {}
        ids = self.search(cr, user, [('sigla', '=', name.upper())] + args, limit=limit, context=context)
        if not ids:
            ids = self.search(cr, user, [('name', operator, name)] + args, limit=limit, context=context)
        return self.name_get(cr, user, ids, context)

    def create(self, cr, uid, vals, context=None):
        """
        Metodo para criacao do registro
        Converte a sigla para maiusculas antes da gravacao
        """
        context = context and context.copy() or {}
        brw_res_users = self.pool.get('res.users').browse(cr, uid, uid, context=context)
        # _usuarioRemoto = False
        if brw_res_users and brw_res_users.login and brw_res_users.login == 'remoto':
            # _usuarioRemoto = True
            # self._logger.info('===> Usuario remoto criando UF:' + str(vals))
            return True # Usuario remoto não atualiza mais

        pais_id = vals.get('pais_id')
        nome = vals.get('name')
        uf_ids = self.search(cr, uid, [('pais_id', '=', pais_id)], context=context)
        for uf in self.read(cr, uid, uf_ids, ['name'], context=context):
            if uf.get('name').upper() == nome.upper():
                if context.get('criando_uf'):
                    raise osv.except_osv(_('Atencao'), _('Estado ja cadastrado para este pais'))
                return False

        if vals.get('sigla'):
            sigla = vals.get('sigla').upper()
            uf_id = self.search(cr, uid, [('sigla', '=', sigla)], context=context)
            if uf_id:
                return uf_id[0]
                # raise osv.except_osv(_('Atencao'), _('Estado ja cadastrado com esta sigla'))
            vals['sigla'] = sigla

        vals['name'] = self.pool.get('adm.utils').admutl_capitalizar_adm_nome(cr, uid, vals.get('name'),
                                                                              context=context)
        result = super(adm_uf, self).create(cr, uid, vals, context)
        return result

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('sigla'):
            sigla = vals.get('sigla').upper()
            uf_id = self.search(cr, uid, [('sigla', '=', sigla)], context=context)
            if uf_id:
                raise osv.except_osv(_('Atencao'), _('Estado ja cadastrado com esta sigla'))
            vals['sigla'] = sigla

        uf_dados = self.browse(cr, uid, ids[0])
        if vals.get('name'):
            nome = vals.get('name')
        else:
            nome = uf_dados.name
        if vals.get('pais_id'):
            pais_id = vals.get('pais_id')
        else:
            pais_id = uf_dados.pais_id.id

        uf_ids = self.search(cr, uid, [('pais_id', '=', pais_id)], context=context)
        for uf in self.read(cr, uid, uf_ids, ['name'], context=context):
            if ids[0] != uf.get('id') and uf.get('name').upper() == nome.upper():
                raise osv.except_osv(_('Atencao'), _('Estado ja cadastrado para este pais'))

        if 'name' in vals:
            vals['name'] = self.pool.get('adm.utils').admutl_capitalizar_adm_nome(cr, uid, vals.get('name'),
                                                                              context=context)
        res = super(adm_uf, self).write(cr, uid, ids, vals, context=context)
        return res
