# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################


from openerp.osv import osv
from openerp.tools.translate import _


class adm_relacionamento_tipo(osv.Model):
    _name = 'adm.relacionamento.tipo'
    _inherit = 'adm.relacionamento.tipo'

    def write(self, cr, uid, ids, vals, context=None):
        """
        Nao permite alterar o registro quando o atributo bloqueio e True
        """
        context = context and context.copy() or {}
        bloqueio = self.read(cr, uid, ids, ['bloqueio'], context=context)
        if bloqueio[0]['bloqueio']:
            raise osv.except_osv(_('Mensagem:'), _('Este tipo de relacionamento nao pode ser alterado !'))
        result = super(adm_relacionamento_tipo, self).write(cr, uid, ids, vals, context=context)
        return result

    def unlink(self, cr, uid, ids, context=None):
        """
        Nao permite a exclusao o registro quando o atributo bloqueio e True
        """
        context = context and context.copy() or {}
        for relacionamento_tipo in self.browse(cr, uid, ids):
            if relacionamento_tipo.bloqueio:
                raise osv.except_osv(_('Mensagem:'),
                                     _('Este tipo de relacionamento nao pode ser excluido !'))
        return super(adm_relacionamento_tipo, self).unlink(cr, uid, ids)

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if context.get('install_mode') and context['install_mode']:
            args = [('sigla', '=', vals['sigla'].upper()),
            ]
            _id = self.search(cr, uid, args, context=context)
            if _id:
                return _id[0]
        res = super(adm_relacionamento_tipo, self).create(cr, uid, vals, context)
        return res