# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv

class users(osv.Model):
    _name = "res.users"
    _inherit = "res.users"

    def onchange_pessoa_id(self, cr, uid, ids, pessoa_id, name):
        if pessoa_id:
            o_pessoa = self.pool.get('adm.pessoa')
            name = o_pessoa.browse(cr, uid, pessoa_id).name
            return {
                'value': {
                    'name': name
                }
            }
        return {}

    def _ajusta_partner(self, cr, uid, vals, context):
        context = context and context.copy() or {}
        if not vals.get('pessoa_id'):
            return True

        context['super_read_adm_pessoa'] = True
        partner_id = self.pool.get('adm.pessoa').read(cr, uid, vals.get('pessoa_id'),
                       ['partner_id'], context=context, load='_classic_write').get('partner_id')
        if partner_id:
            vals['partner_id'] = partner_id

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        obj_adm_utils = self.pool.get('adm.utils')
        res = obj_adm_utils.admutl_valida_superuser(cr, uid, context)
        uid = res.get('uid')
        context.update({'uid': uid})
        res = super(users, self).create(cr, uid, vals, context=context)
        return res


    def write(self, cr, uid, ids, values, context=None):

        context = context and context.copy() or {}
        if 'active' in values:
            if values['active'] == False:
                values['login'] = str(ids)
        obj_adm_utils = self.pool.get('adm.utils')
        res = obj_adm_utils.admutl_valida_superuser(cr, uid, context)
        uid = res.get('uid')
        context.update({'uid': uid})
        res = super(users, self).write(cr, uid, ids, values, context=context)
        return res


    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        obj_adm_utils = self.pool.get('adm.utils')
        res = obj_adm_utils.admutl_valida_superuser(cr, uid, context)
        uid = res.get('uid')
        context.update({'uid': uid})
        res = super(users, self).search(cr, uid, args, offset, limit, order, context, count)
        return res


    def read(self, cr, uid, ids, fields=[], context=None, load='_classic_read'):
        context = context and context.copy() or {}

        obj_adm_utils = self.pool.get('adm.utils')
        res = obj_adm_utils.admutl_valida_superuser(cr, uid, context)
        uid = res.get('uid')
        context.update({'uid': uid})
        res = super(users, self).read(cr, uid, ids, fields, context=context, load=load)

        return res

    def unlink(self, cr, uid, ids, context=None):

        context = context and context.copy() or {}
        obj_adm_utils = self.pool.get('adm.utils')
        res = obj_adm_utils.admutl_valida_superuser(cr, uid, context)
        uid = res.get('uid')
        context.update({'uid': uid})
        res = super(users, self).unlink(cr, uid, ids, context)

        return res
