# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class adm_cep(osv.Model):
    _name = 'adm.cep'
    _rec_name = 'cep'
    _columns = {
        'cep': fields.char('CEP', size=8, required=True),
        'pessoa_pais_id': fields.many2one('adm.pais', "Pais", required=True, ondelete="cascade", select=True),
        'pessoa_uf_id': fields.many2one('adm.uf', "UF", required=True, ondelete="cascade", select=True),
        'pessoa_cidade_id': fields.many2one('adm.cidade', "Cidade", required=True, ondelete="cascade", select=True),
        'pessoa_bairro_id': fields.many2one('adm.bairro', "Bairro", ondelete="cascade", select=True),
        'pessoa_logradouro_id': fields.many2one('adm.logradouro', "Logradouro", ondelete="cascade", select=True),
    }
    _sql_constraints = [
        ('adm_cep_uniq', 'unique (cep)', 'O CEP informado ja encontra-se cadastrado!'),
    ]

