# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_pessoa_documento_complemento(osv.Model):
    """
    tabela de dados complementares do documento
    Contem os dados complementares cadastrados na tabela adm_pessoa_documento_complemento_tipo
    """

    # prefixo = admdcc_

    from funcoes import _admdcc_get_dados

    _name = 'adm.pessoa.documento.complemento'
    _columns = {
        'documento_id': fields.many2one("adm.pessoa.documento.dados", 'Documento', ondelete="cascade", required=True,
                                        select=True), # id do documento
        'complemento_tipo_id': fields.many2one("adm.pessoa.documento.complemento.tipo", 'Tipo de complemento',
                                               ondelete="restrict", required=True, select=True),
        'name': fields.char('Descricao', size=20, required=True), # Dado complementar
        'admdcc_tipo_id': fields.function(_admdcc_get_dados, method=True, string="Tipo", multi="dados", type="integer",
                                          store=False),
        'admdcc_numero': fields.function(_admdcc_get_dados, method=True, string="Numero", multi="dados", type="char",
                                         size=30, store=False),
        'admdcc_emitente': fields.function(_admdcc_get_dados, method=True, string="Emitente", multi="dados",
                                           type="char", size=20, store=False),
        'admdcc_data_emissao': fields.function(_admdcc_get_dados, method=True, string="Data Emissao", multi="dados",
                                               type="date", store=False),
        'admdcc_pessoa_id': fields.function(_admdcc_get_dados, method=True, string="Pessoa", multi="dados", type="char",
                                            size=30, store=False),
    }
