# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class adm_pessoa_documento_dados(osv.Model):
    """
    Tabela dos dados do documento
    Contem os dados do documento cadastrado na tabela adm_pessoa_documento_tipo
    e relaciona com a tagela adm_pessoa
    """
    _name = 'adm.pessoa.documento.dados'
    _rec_name = 'pessoa_id'
    _columns = {
        'pessoa_id': fields.many2one("adm.pessoa", 'Pessoa', ondelete="cascade", required=True, select=True),
        'tipo_id': fields.many2one("adm.pessoa.documento.tipo", 'Tipo', ondelete="restrict", required=True,
                                   select=True), # id do tipo de documento
        'numero': fields.char('Numero', size=30, required=True), # Numero do documento
        'emitente': fields.char('Emitente', size=20), # Identificacao do orgao emitente do documento
        'data_emissao': fields.date('Data de emissao'), # Data da emissao do documento
        'documento_complemento_ids': fields.one2many('adm.pessoa.documento.complemento', 'documento_id', 'Complemento'),
    }

