# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_pessoa_documento_tipo(osv.Model):
    """
    Tabela de tipo de documentos das pessoas(Fisicas e Juridicas)
    Contem todos os tipos de documentos possiveis para as pessoas
    """
    _name = 'adm.pessoa.documento.tipo'
    _columns = {
        'name': fields.char('Name', size=30, required=True), # Descricao do tipo de documento
        'pessoa_tipo': fields.selection([('F', 'Fisica'), ('J', 'Juridica')], 'Tipo de pessoa', required=True, size=1),
        'sigla': fields.char('Sigla', size=8, required=True, select=True),
        # Sigla para identificacao do documento\nCNH - Carteira Nacional de Habilitacao\nCRC - Conselho Regional de Contabilidade\n
        'bloqueio': fields.boolean('Bloqueio'),
        # Bloqueio contra exclusao\nTrue=Nao permite excluir\nFalse=Permite excluir
        'documento_dados_ids': fields.one2many('adm.pessoa.documento.dados', 'tipo_id', 'Dados'),
    }
    _defaults = {
        'bloqueio': lambda *a: False,
    }
