# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class adm_pessoa_email(osv.Model):
    # prefixo = admpem_

    from funcoes import _admpem_check_email

    """
    Tabela de emails do cadastro de pessoa
    """
    _name = 'adm.pessoa.email'
    _columns = {
        'email_tipo_id': fields.many2one("adm.email.tipo", 'Tipo de email', ondelete="restrict", required=True,
                                         select=True),
        'pessoa_id': fields.many2one("adm.pessoa", 'Pessoa', ondelete="cascade", required=True, select=True),
        'admpem_setor_ids': fields.many2many("adm.setor", 'adm_m2m_email_setor', 'email_id',
                                             'setor_id', 'Setor'),
        'name': fields.char('Email', size=75, required=True), # Endereco de email da pessoa
        'observacao': fields.text('Observacao'), # Observacoes
    }
    _order = 'pessoa_id, name'
    _constraints = [(_admpem_check_email, 'Email invalido', ['name'])]
    _defaults = {
        'email_tipo_id': lambda *a: 1,
    }



