# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class adm_email_tipo(osv.Model):
    """
    Tabela de Tipos de emails,
    Ex. Email normal, Email celular, etc..
    """
    _name = 'adm.email.tipo'
    _columns = {
        'name': fields.char('Descricao', size=50, required=True), # Descricao do tipo de email
        'bloqueio': fields.boolean('Bloqueio'), # True=Bloqueio, nao pode ser excluido. False=Nao bloqueia, pode ser excluido
        'email_ids': fields.one2many('adm.pessoa.email', 'email_tipo_id', 'Pessoa email'),
    }
    _order = 'name'
    _defaults = {
        'bloqueio': lambda *a: False,
    }
