# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_cidade(osv.Model):
    """
    Tabela de cidades
    """

    from funcoes import _admpci_get_uf, _admpci_get_pais

    _name = 'adm.cidade'
    _columns = {
        'uf_id': fields.many2one(
            "adm.uf", 'Estado', ondelete="restrict", required=True, select=True, domain="[('pais_id', '=', pais_id)]"
        ),
        'name': fields.char('Nome da cidade', size=50, required=True),  # Descricao, nome da cidade
        'codigo_ibge': fields.integer('Codigo ibge'),  # Codigo do municipio no IBGE
        'pais_id': fields.related(
            'uf_id', 'pais_id', type="many2one", relation="adm.pais", string="Pais", store=False, required=True
        ),
        'endereco_ids': fields.one2many('adm.pessoa.endereco', 'cidade_id', 'Enderecos'),
    }
    _order = 'uf_id, name'

    _defaults = {
        'uf_id': _admpci_get_uf,
        'pais_id': _admpci_get_pais,
    }
    _sql_constraints = [
        ('uf_cidade_uniq', 'unique(uf_id, name)', 'Cidade ja cadastrada para o UF!'),
    ]
