# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_logradouro(osv.Model):
    #prefixo = admlgd_

    from funcoes import _admlgd_nome_rua

    _name = 'adm.logradouro'
    _columns = {
        'titulo': fields.char('Titulo', size=16, required=True), # tipo de logradouro. \nRua, Avenida, alameda, etc
        'descricao': fields.char('Descricao', size=50, required=True), # Nome da rua
        'name': fields.function(_admlgd_nome_rua, method=True, string='Endereco', type='text', store=False), #Nome da rua com a titularidade
        'endereco_ids': fields.one2many('adm.pessoa.endereco', 'logradouro_id', 'Enderecos'),
    }

    _sql_constraints = [
        ('logradouro_uniq', 'unique(titulo, descricao)', 'Logradouro ja cadastrado!'),
    ]
