# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_pais(osv.Model):
    """
    Tabela de paises
    """
    _name = 'adm.pais'
    _columns = {
        'name': fields.char('Nome do Pais', size=50, required=True), # Nome do Pais
        'sigla': fields.char('Sigla', size=3), # Sigla do Pais (Abreviatura)
        'codigo_bc': fields.char('Codigo bc', size=5), # Codigo do Pais no Banco Central
        'endereco_uf_ids': fields.one2many('adm.uf', 'pais_id', 'Estados'), # Estados que pertencem a um pais
        'endereco_ids': fields.one2many('adm.pessoa.endereco', 'pais_id', 'Enderecos'),
    }
    _order = 'name'
    _sql_constraints = [('name_pais_unique', 'unique (name)',
                         'Pais ja cadastrado com este nome!')]
