# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_regiao(osv.Model):
    """
    Tabela de regiao geografica das pessoa
    """

    #prefixo = admreg_

    from funcoes import _admreg_verifica_recursao

    _name = 'adm.regiao'
    _columns = {
        'parent_id': fields.many2one("adm.regiao", 'Regiao pai', ondelete="cascade", select=True), # id da regiao pai
        'name': fields.char('Nome', size=30, required=True), # Nome da regiao geografica
        'endereco_regiao_ids': fields.one2many('adm.regiao', 'parent_id', 'Regiao'), # Enderecos pertencentes a regiao
        'endereco_ids': fields.one2many('adm.pessoa.endereco', 'regiao_id', 'Enderecos'),
    }

    _constraints = [
        (_admreg_verifica_recursao, 'Erro! Voce nao pode criar uma regiao recursiva.', ['parent_id'])
    ]
    _order = 'name'
