# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_uf(osv.Model):
    """
    Tabela de estados (UF)
    """

    from funcoes import _admpuf_get_pais

    _name = 'adm.uf'
    _rec_name = 'sigla'
    _columns = {
        'pais_id': fields.many2one("adm.pais", 'Pais', ondelete="restrict", required=True, select=True), # id do Pais
        'sigla': fields.char('Sigla', size=2, required=True, select=True), # Sigla do estado
        'name': fields.char('Estado', size=20, required=True), # Nome do Estado
        'endereco_cidade_ids': fields.one2many('adm.cidade', 'uf_id', 'Cidades'), # Cidades que pertencem a um estado
        'endereco_ids': fields.one2many('adm.pessoa.endereco', 'uf_id', 'Enderecos'),
    }
    _order = 'name'

    _defaults = {
        'pais_id': _admpuf_get_pais,
    }

    _sql_constraints = [('name_uf_unique', 'unique (name)',
                         'Estado ja cadastrado com este nome!')]
