# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################


from openerp.osv import osv, fields


class adm_relacionamento_tipo(osv.Model):
    """
    Tabela de Titularidade/Dependente
    Ex.Dependente pessoa fisica. Mae, Pae, Filho, etc...
    Ex. titularidade pessoa juridica. Gerente, Secretario, Diretor, etc..
    """
    _name = 'adm.relacionamento.tipo'
    _columns = {
        'pessoa_tipo': fields.selection([('F', 'Fisica'), ('J', 'Juridica')],
                                        'Tipo', required=True, size=1), # Tipo de pessoa. \nF=Fisica, \nJ=Juridica
        'name': fields.char('Descricao', size=50, required=True), # Descricao da titularidade.
        'relacionamentos_ids': fields.one2many('adm.pessoa.relacionamento',
                                               'relacionamento_tipo_id', 'Relacionamentos'),
        'bloqueio': fields.boolean('Bloqueio'),
        'sigla': fields.char('Sigla', size=5, required=True, select=True),
        'relacionamento_inverso_id': fields.many2one("adm.relacionamento.tipo", 'Relacionamento Inverso',
                                                     ondelete="restrict", select=True),
    }
    _defaults = {
        'pessoa_tipo': lambda *a: 'J',
        'bloqueio': lambda *a: False,
    }

    _sql_constraints = [
        ('sigla_uniq', 'unique (sigla)', 'A sigla precisa ser unica!'),
    ]

