# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################


from openerp.osv import osv, fields


class adm_pessoa_relacionamento(osv.Model):
    """
    Tabela de Dependentes ou contatos, se pessoa fisica ou juridica.
    Nesta tabela consta os dependentes da pessoa fisica e/ou
    os contatos da pessoa juridica
    """

    #prefixo = admpre_

    from funcoes import _admpre_nome_pessoa

    _name = 'adm.pessoa.relacionamento'
    _columns = {
        'name': fields.function(_admpre_nome_pessoa, method=True, string='Nome', type='text', store=True),
        'pessoa_id': fields.many2one("adm.pessoa", 'Pessoa', ondelete="cascade",
                                     required=True, select=True), # id da pessoa
        'dependente_id': fields.many2one("adm.pessoa", 'Relaciona com', ondelete="cascade",
                                         required=True, select=True), # id do dependente / contato
        'relacionamento_tipo_id': fields.many2one("adm.relacionamento.tipo", 'Tipo de relacionamento',
                                                  ondelete="restrict", required=True, select=True),
        'observacao': fields.text('Observacao'), # Observacoes
        'admprel_setor_ids': fields.many2many("adm.setor", 'adm_m2m_relacionamento_setor', 'relacionamento_id',
                                             'setor_id', 'Setor'),
    }
    _sql_constraints = [
        ('pessoa_dependente_unique', 'unique (pessoa_id, dependente_id)',
            'O contato/dependente nao pode ser repetido!'),
    ]


