# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_pessoa_telefone(osv.Model):
    """
    Tabela de telefones do cadastro de pessoa
    """
    _name = 'adm.pessoa.telefone'
    _rec_name = 'pessoa_id'
    _columns = {
        'pessoa_id': fields.many2one("adm.pessoa", 'Pessoa', ondelete="cascade", required=True,
                                     select=True),  # id da pessoa
        'telefone_tipo_id': fields.many2one("adm.telefone.tipo", 'Tipo de telefone',
                                            ondelete="restrict", required=True,
                                            select=True),  # id do tipo de telefone
        'admptel_setor_ids': fields.many2many("adm.setor", 'adm_m2m_telefone_setor', 'telefone_id',
                                             'setor_id', 'Setor'),
        'ddi': fields.char('DDI', size=4),  # Codigo do DDI
        'ddd': fields.char('DDD', size=4, select=True),  # Codigo do DDD
        'numero': fields.char('Numero', size=25, required=True),  # Numero do telefone da pessoa
        'observacoes': fields.text('Observacoes'),  # Observacoes
        'admptel_operadora_id': fields.many2one('adm.telefone.operadora', 'Operadora', select=True),
    }

    _order = 'pessoa_id, numero'
