# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_telefone_tipo(osv.Model):
    """
    Tabela de Tipos de Telefone.
    Exemplo. Fax, Celular, Telefone, etc...\
    """
    _name = 'adm.telefone.tipo'
    _columns = {
        'name': fields.char('Descricao', size=50, required=True), # Descricao do tipo de telefone
        'bloqueio': fields.boolean('Bloqueio'), # True=Bloqueio, nao pode ser excluido. False=Nao bloqueia, pode ser excluido
        'telefone_ids': fields.one2many('adm.pessoa.telefone', 'telefone_tipo_id', 'Telefones'),
    }
    _order = 'name'
    _defaults = {
        'bloqueio': lambda *a: False,
    }
