# -*- coding: utf-8 -*-

from openerp.tests.common import TransactionCase
from sigaddons.config_teste import set_config


class TestAdmPessoa(TransactionCase):
    """
    Classe responsavel por testes unitarios dos metodos da classe adm_pessoa.
    :author: Tiago Henrique Prates dos Santos <tiago.santos[at]siginformatica.com.br>
    """

    @classmethod
    def setUpClass(cls):
        set_config()

    def setUp(self):
        super(TestAdmPessoa, self).setUp()
        self.adm_pessoa = self.registry('adm.pessoa')
        self.pessoa_id = self.get_pessoa_id()

    def get_pessoa_id(self):
        obj_adm_pessoa_endereco = self.registry('adm.pessoa.endereco')
        pessoa_endereco_id = obj_adm_pessoa_endereco.search(self.cr, self.uid, [], limit=1)[0]
        return obj_adm_pessoa_endereco.browse(self.cr, self.uid, pessoa_endereco_id).pessoa_id.id

    def test_admpes_endereco_fiscal(self):
        res = self.adm_pessoa.admpes_endereco_fiscal(self.cr, self.uid, [self.pessoa_id])
        self.assertEqual(type(res), dict)

    def test_search(self):
        res = self.adm_pessoa.search(self.cr, self.uid, [], limit=1)
        self.assertEqual(len(res), 1)
