# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2010 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################


from openerp.osv import fields, osv
from openerp.tools.translate import _

adm_operacao = {
    'orca': 'Orcamento',
    'pedi': 'Pedido',
    'nota': 'NF',
    'fatu': 'fatura',
    'titu': 'titulo',
    'epro': 'Entrada de producao',
    'teso': 'Tesouraria',
    'almx': 'Almoxarifado',
    'rsup': 'Ressuprimento',
    'solc': 'Solicitacao de Compras',
    'rqcp': 'Requisicao de Compras',
    'cota': 'Cotacoes',
    'cupo': 'Cupons fiscais',
}
adm_classes = {
    'orcamentos.orcamento.capa': 'Orcamento',
    'estoquepedidos.pedido.capa': 'Pedido',
    'fiscal.nf.capa': 'NF',
    'financeiro.fatura': 'fatura',
    'financeiro.titulo': 'titulo',
    'financeiro.tesouraria.movimento': 'Tesouraria',
    'almoxarifado.requisicao.capa': 'Almoxarifado',
    'estoqueressuprimento.requisicao.capa': 'Ressuprimento',
    'compras.solicitacao.capa': 'Solicitacao de Compras',
    'compras.requisicao.capa': 'Requisicao de Compras',
    'compras.cotacoes.capa': 'Cotacoes',
    'ecf.cupons.capa': 'Cupons fiscais',
}


def _links_get(self, cr, uid, context=None):
    context = context and context.copy() or {}
    obj = self.pool.get('res.request.link')
    ids = obj.search(cr, uid, [], context=context)
    res = obj.read(cr, uid, ids, ['object', 'name'], context=context)
    return [(r['object'], r['name']) for r in res]


class transacao_capa_wizard(osv.TransientModel):
    def _get_transacao_id(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not ids or not ids.get('active_id', False):
            return
        id = ids['active_id']
        _obj_adm_transacao_itens = self.pool.get('adm.transacao.itens')
        _obj_adm_transacao_capa = self.pool.get('adm.transacao.capa')
        _ref = ids['active_model'].strip() + ',' + str(id)
        _adm_transacao_itens_id = _obj_adm_transacao_itens.search(cr, uid, [('admtri_objeto_ref', '=', _ref)],
                                                                  context=context)
        if _adm_transacao_itens_id:
            _brw_adm_transacao_itens = _obj_adm_transacao_itens.browse(cr, uid, _adm_transacao_itens_id, context)
            for _reg in _brw_adm_transacao_itens:
                _adm_transacap_capa_id = _reg.admtri_capa_id.id
                return _adm_transacap_capa_id
            return
        else:
            raise osv.except_osv(_('Mensagem:'), _('Nao existe transacao associada!'))

    def _get_id(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        adm_transacao_id = self._get_transacao_id(cr, uid, ids, context)
        _reg = self.pool.get('adm.transacao.capa').read(cr, uid, adm_transacao_id, ['id'], context=context)
        return _reg['id']
        """
        _obj_adm_transacao_itens = self.pool.get('adm.transacao.itens')
        _obj_adm_transacao_capa = self.pool.get('adm.transacao.capa')
        _ref = ids['active_model'].strip()+','+str(id)
        _adm_transacao_itens_id = _obj_adm_transacao_itens.search(cr, uid, [('admtri_objeto_ref', '=', _ref)], context)
        _brw_adm_transacao_itens = _obj_adm_transacao_itens.browse(cr, uid, _adm_transacao_itens_id, context)
        for _reg in _brw_adm_transacao_itens:
            _adm_transacap_capa_id = _reg.admtri_capa_id.id
        _brw_adm_transacao_capa = _obj_adm_transacao_capa.browse(cr, uid, _adm_transacap_capa_id, context)
        vals = {}
        vals['data'] = _brw_adm_transacao_capa.create_date
        vals['operacao'] = _brw_adm_transacao_capa.admtrc_operacao
        vals['id_ativo'] = _brw_adm_transacao_capa.id
        _capa_id = self.create(cr, uid, vals)
        for _item in _brw_adm_transacao_capa.admtrc_transacao_itens_ids:
            vals={}
            vals['id'] = _item.id
            vals['capa_id'] = _capa_id
            vals['objeto_ref'] = _item.admtri_objeto_ref
            self.pool.get('transacao.itens.wizard').create(cr, uid, vals)
        """

    def _get_itens(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not ids:
            return
        adm_transacao_id = self._get_transacao_id(cr, uid, ids, context)
        _obj_adm_transacao_capa = self.pool.get('adm.transacao.capa')
        _brw_adm_transacao_capa = _obj_adm_transacao_capa.browse(cr, uid, adm_transacao_id, context)
        vals = {}
        vals['data'] = _brw_adm_transacao_capa.create_date
        vals['operacao'] = _brw_adm_transacao_capa.admtrc_operacao
        vals['id_ativo'] = _brw_adm_transacao_capa.id
        _capa_id = self.create(cr, uid, vals, context)
        _lista = []
        for _item in _brw_adm_transacao_capa.admtrc_transacao_itens_ids:
            vals = {}
            vals['id'] = _item.id
            vals['capa_id'] = _capa_id
            vals['objeto_ref'] = _item.admtri_objeto_ref
            vals['data'] = _item.create_date
            vals['operacao'] = adm_classes[_item.admtri_objeto_ref.split(',')[0]]
            vals['usuario_id'] = _item.create_uid.id
            _item_id = self.pool.get('transacao.itens.wizard').create(cr, uid, vals, context)
            _lista.append(_item_id)
        return _lista

    def _get_data(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not ids or not ids.get('active_id', False):
            return
        adm_transacao_id = self._get_transacao_id(cr, uid, ids, context)
        _reg = self.pool.get('adm.transacao.capa').read(cr, uid, adm_transacao_id, ['create_date'], context=context)
        return _reg['create_date']

    def _get_usuario(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not ids or not ids.get('active_id', False):
            return
        adm_transacao_id = self._get_transacao_id(cr, uid, ids, context)
        _reg = self.pool.get('adm.transacao.capa').read(cr, uid, adm_transacao_id, ['create_uid'], context=context)
        return _reg['create_uid']

    def _get_operacao(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not ids or not ids.get('active_id', False):
            return
        adm_transacao_id = self._get_transacao_id(cr, uid, ids, context)
        _reg = self.pool.get('adm.transacao.capa').read(cr, uid, adm_transacao_id, ['admtrc_operacao'], context=context)
        return adm_operacao[_reg['admtrc_operacao']]

    _name = "transacao.capa.wizard"
    _description = "Wizard das Transacoes"
    _columns = {

        'id_ativo': fields.integer('Transacao Nro:'), # id da transacao
        'data': fields.datetime('Data da transacao'),
        'usuario_id': fields.many2one('res.users', 'Usuario', select=True),
        'operacao': fields.char('Operacao', size=40),
        'transacao_itens_ids': fields.one2many('transacao.itens.wizard', 'capa_id', 'Documentos'),
    }
    _defaults = {
        'id_ativo': _get_id,
        'data': _get_data,
        'usuario_id': _get_usuario,
        'operacao': _get_operacao,
        'transacao_itens_ids': _get_itens
    }


class transacao_itens_wizard(osv.TransientModel):
    _name = 'transacao.itens.wizard'
    _description = 'Documentos da transacao'
    _rec_name = 'objeto_ref'
    _columns = {
        'capa_id': fields.many2one('transacao.capa.wizard', 'Transacao', select=True),
        'objeto_ref': fields.reference('Objeto/Classe', selection=_links_get, size=64),
        'data': fields.datetime('Data da transacao'),
        'usuario_id': fields.many2one('res.users', 'Usuario', select=True),
        'operacao': fields.char('Operacao', size=40),
    }

