#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
import os
if os.name == 'posix':
    from cups import Connection

try:
    conn = Connection()
    printers = conn.getPrinters()
except:
    printers = {}

if not printers:
    printers = {'Impressora nao localizada': ''}

printer_names = printers.keys()
# SE O INDICE COMECA COM ZERO, NAO ACEITA SER SELECIONADO.
printer_len = map(str, range(1, printer_names.__len__() + 1))

PRINTER_CHOICES = zip(printer_len, printer_names)


class wizard_listagem_impressoras(osv.TransientModel):
    """
    Este wizard exibe todas as impressoras cadastras.
    Pode ser utilizado em qualquer lugar.
    Para utiliza-lo, e necessario passar a chave 'insert_printer_on_field' no contexto,
    informando em qual campo a impressora escolhida na tela será gravado.
    """

    _name = 'wizard.listagem.impressora'
    _rec_name = 'wlist_printer'
    _columns = {
        'wlist_printer': fields.selection(PRINTER_CHOICES, string='Impressoras', required=True)
    }

    def get_printer_label(self, choice):
        label = dict(PRINTER_CHOICES).get(choice) or ''
        return label

    def button_list_printer(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]

        active_model = context.get('active_model')
        active_id = context.get('active_id')
        field_to_insert = context.get('insert_printer_on_field')

        if active_model and active_id and field_to_insert:
            listagem_impressora_dados = self.read(cr, uid, ids, ['wlist_printer'], context=context)
            for i in listagem_impressora_dados:
                impressoa = i.get('wlist_printer')
                impressoa_nome = self.get_printer_label(impressoa)
                self.pool.get(active_model).write(cr, uid, [active_id], {field_to_insert: impressoa_nome}, context=context)
        return True
