# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from datetime import date
from datetime import datetime
from openerp.tools.translate import _

class wizard_periodo(osv.TransientModel):
    def criar_valores(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_adm_moeda_valor = self.pool.get('adm.moeda.valor')
        dados = self.read(cr, uid, ids, ['percentual', 'data', 'moeda_id'], context=context)
        if dados and isinstance(dados, list):
            dados = dados[0]
        percentual = dados.get('percentual')
        data = dados.get('data')
        moeda_id = dados.get('moeda_id')
        if isinstance(moeda_id, (list, tuple)):
            moeda_id = moeda_id[0]
        args = []
        args.append(('data_movimento', '<', data))
        args.append(('moeda_id', '=', moeda_id))
        ids = obj_adm_moeda_valor.search(cr, uid, args, order='data_movimento desc', limit=1, context=context)
        if not ids:
            raise osv.except_osv(_('Mensagem'), _('Nao existem valores para esta moeda anteriores a data informada!'))
        valores = obj_adm_moeda_valor.read(cr, uid, ids, ['data_movimento', 'valor'], context=context)
        if valores and isinstance(valores, list):
            valores = valores[0]
        ultima_data = valores.get('data_movimento')
        valor = valores.get('valor')
        percentual_dia = 1 + percentual / 30 / 100
        data = datetime.strptime(data, "%Y-%m-%d")
        dias_data = date.toordinal(data)
        ultima_data = datetime.strptime(ultima_data, "%Y-%m-%d")
        dias_ultima_data = date.toordinal(ultima_data) + 1
        while dias_ultima_data <= dias_data:
            data_create = date.fromordinal(dias_ultima_data)
            valor *= percentual_dia
            obj_adm_moeda_valor.create(cr, uid, {'moeda_id': moeda_id, 'data_movimento': data_create, 'valor': valor},
                                       context)
            dias_ultima_data += 1
        obj_model_data = self.pool.get('ir.model.data')
        reference = obj_model_data.get_object_reference(cr, uid, 'adm', 'view_compras_valores_criados_form')
        view_id = reference and reference[1] or False
        return {
            'name': 'Criar valores',
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'wizard.periodo',
            'view_id': [view_id],
            'target': 'new',
            'type': 'ir.actions.act_window',
        }

    def cancelar_valores(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_adm_moeda_valor = self.pool.get('adm.moeda.valor')
        dados = self.read(cr, uid, ids, ['data', 'moeda_id'], context=context)
        if dados and isinstance(dados, list):
            dados = dados[0]
        data = dados.get('data')
        moeda_id = dados.get('moeda_id')
        if isinstance(moeda_id, (list, tuple)):
            moeda_id = moeda_id[0]
        args = []
        args.append(('data_movimento', '>=', data))
        args.append(('moeda_id', '=', moeda_id))
        ids = obj_adm_moeda_valor.search(cr, uid, args, context=context)
        res = obj_adm_moeda_valor.unlink(cr, uid, ids)
        if ids and res:
            obj_model_data = self.pool.get('ir.model.data')
            reference = obj_model_data.get_object_reference(cr, uid, 'adm', 'view_compras_valores_cancelados_form')
            view_id = reference and reference[1] or False
            return {
                'name': 'Cancelar valores',
                'view_type': 'form',
                'view_mode': 'form',
                'res_model': 'wizard.periodo',
                'view_id': [view_id],
                'target': 'new',
                'type': 'ir.actions.act_window',
            }
        else:
            raise osv.except_osv(_('Atencao'), _('Nao ha valores para cancelar'))
        return {}

    _name = 'wizard.periodo'
    _columns = {
        'moeda_id': fields.many2one('adm.moeda', 'Moeda', required=True, select=True),
        'data': fields.date("Data", required=True),
        'percentual': fields.float("Percentual Mensal", digits=(8, 2), required=True)
    }

wizard_periodo()
