# -*- encoding: utf-8 -*-
from openerp.tools.translate import _


status_api = {
    '00': '',
    '01': _('Token invalido. Tente novamente!'),
    '02': _('Token vencido. Tente novamente!'),
    '03': _('Usuario ou senha invalido!'),
    '04': _('Acao nao implementada!'),
    '05': _('Token para refresh, invalido para acessar a aplicacao!'),
    '06': _('Token nao foi gerado pelo SigERP!'),
    '07': _('Erro ao acessar o SigERP!'),
    '08': _('Registro nao localizado!'),
    '09': _('Um ou mais dados de entrada sao invalidos!'),
    '10': _('Acao nao disponivel, modulo %s nao instalado!'),
    '11': _('"sg_code" invalido!'),
    '12': _('Nao consegui inserir o registro!'),
    '13': _('Nao foi informado ID do registro para alteracao!'),
    '14': _('Mao consegui alterar o registro!'),
}
classes = {
    'fields_adm_bairro': ('adm.bairro', 'adm'),
    'fields_adm_cidade': ('adm.cidade', 'adm'),
    'fields_adm_endereco': ('adm.pessoa.endereco', 'adm'),
    'fields_adm_endereco_tipo': ('adm.endereco.tipo', 'adm'),
    'fields_adm_email': ('adm.pessoa.email', 'adm'),
    'fields_adm_email_tipo': ('adm.email.tipo', 'adm'),
    'fields_adm_logradouro': ('adm.logradouro', 'adm'),
    'fields_adm_telefone': ('adm.pessoa.telefone', 'adm'),
    'fields_adm_telefone_tipo': ('adm.telefone.tipo', 'adm'),
    'fields_adm_pais': ('adm.pais', 'adm'),
    'fields_adm_uf': ('adm.uf', 'adm'),
    'fields_embalagens': ('estoque.embalagem', 'estoque'),
    'fields_pessoa': ('adm.pessoa', 'adm'),
    'fields_vex_departamento': ('vendas.externas.departamento', 'vendas_externas'),
    'fields_setor': ('adm.setor', 'adm'),
    'fields_pedidos': ('estoquepedidos.pedido.capa','estoquepedidos'),
    'fields_pedidos_itens': ('estoquepedidos.pedido.item','estoquepedidos'),
    'fields_pedidos_parcelas': ('estoquepedidos.pedido.parcela','estoquepedidos'),
    'fields_pedidos_condicoes': ('estoquepedidos.pedido.condicao','estoquepedidos'),
    'fields_embalagens': ('estoque.produto.embalagem','estoque'),
    'fields_produtos': ('estoque.produto','estoque'),
    'fields_produtos_grades': ('estoque.produto.grade', 'estoque'),
    'fields_produtos_embalagens': ('estoque.produto.embalagem', 'estoque'),
    'fields_unidades': ('estoque.embalagem.unidade', 'estoque'),
    'fields_locais': ('estoque.local', 'estoque'),
    'fields_locais_locacoes': ('estoque.local.locacao', 'estoque'),
    'fields_estoque_parametros': ('estoque.parametro', 'estoque'),
    'fields_forma_pgto': ('adm.forma.pgto', 'adm'),
    'fields_codigo_barra': ('automacao.codigo.barra', 'automacao'),
    'fields_api_controle': ('api.controle', 'api_sigerp'),
    'fields_local_cobranca': (),
    'fields_natureza_cobranca': (),
    'fields_documento_tipo': (),
    'fields_empresa': (),

### Classes especiais
    'sigerp_pedidos': ('sigerp.pedidos', 'estoquepedidos'),
}

# Definições:
# nome_externo(0) é a identificação que o desenvolverdor vai informar e receber referente ao atributo da classe/registro
# nome_interno(1) é a identificação que a api vai transformar para acessar a base interna
# descricao do campo(2) Breve descrição para que o integrador saiba que informação está sendo acessada
# tamanho do campo(4) É o tamanho do campo quando ele for sucetível a ter um tamanho ou quando for um campo referencial identifica a tabela referenciada
# Obrigatorio na inclusao(5) pode ser 'N', Não, 'S', Sim, 'P', Proibido(se informado sera desconsiderado
# Agrupamento p/pesquisa(6) Ao inserir registro, se não informado o id, fara pesquisa na ordem definida. '0' não fará pesquisa do id

# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_setor = {
    ('id', 'id', 'Id interno do banco de dados', 'integer', 0, 'N', '0'),
    ('descricao', 'name', 'Descricao do setor', 'string', 20, 'S', '1'),
}
# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_bairro = {
    ('id', 'id', 'Id interno do banco de dados', 'integer', 0, 'N', '0'),
    ('descricao', 'name', 'Nome do bairro', 'string', 30, 'S', '1'),
}
# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_adm_endereco_tipo = {
    ('id', 'id', 'Id interno do banco de dados', 'integer', 0, 'N', '0'),
    ('descricao', 'name', 'Descricao do tipod e endereco', 'string', 50, 'S', '1'),
}
# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_adm_telefone_tipo = {
    ('id', 'id', 'Id interno do banco de dados', 'integer', 0, 'N', '0'),
    ('descricao', 'name', 'Descricao do tipo de telefone', 'string', 50, 'S', '1'),
}

# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_adm_telefone = {
    ('id', 'id', 'Id interno do banco de dados', 'integer', 0, 'N', '0'),
    ('ddd', 'ddd', 'DDD do telefone', 'string', 4, 'S', '2'),
    ('numero', 'numero', 'Numero do telefone', 'string', 25, 'S', '2'),
    ('observacoes', 'observacoes', 'Observacoes', 'string', 254, 'N', '0'),
    ('pessoa', 'pessoa_id', 'Pessoa a quem pertence o numero', 'm2o', 'fields_pessoa', 'S', '1'),
    ('tipo', 'telefone_tipo_id', 'Tipo de numero de telefone', 'm2o', 'fields_adm_telefone_tipo', 'S', '1'),
}
# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_adm_email_tipo = {
    ('id', 'id', 'Id interno do banco de dados', 'integer', 0, 'N', '0'),
    ('descricao', 'name', 'Descricao do tipo de email', 'string', 50, 'S', '1'),
}
# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_adm_logradouro = {
    ('id', 'id', 'Id interno do banco de dados', 'integer', 0, 'N', '0'),
    ('descricao', 'descricao', 'Nome da rua', 'string', 50, 'S', '1'),
    ('tipo', 'titulo', 'Tipo do logradouro(Rua, Avenida, alameda, etc', 'string', 16, 'S', '1'),
}
# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_adm_pais = {
    ('id', 'id', 'Id interno do banco de dados', 'integer', 0, 'N', '0'),
    ('nome', 'name', 'Nome do pais', 'string', 50, 'S', '1'),
    ('sigla', 'sigla', 'Sigla do pais', 'string', 3, 'N', '2'),
    ('codigo_bc', 'codigo_bc', 'Codigo no Banco central', 'string', 5, 'N', '3'),
}

# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_adm_uf = {
    ('id', 'id', 'Id interno do banco de dados', 'integer', 0, 'N', '0'),
    ('nome', 'name', 'Nome do estado da federacao', 'string', 20, 'S', '1'),
    ('sigla', 'sigla', 'Sigla do pais', 'string', 2, 'S', '2'),
    ('pais', 'pais_id', 'Id da tabela de pais', 'm2o', 'fields_adm_pais', '1,2'),
}

# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_adm_cidade = {
    ('id', 'id', 'Id interno do banco de dados', 'integer', 0, 'N', '0'),
    ('codigo_ibge', 'codigo_ibge', 'Codigo da cidade no IBGE', 'integer', 0, 'S', '1'),
    ('nome', 'name', 'Nome da cidade', 'string', 50, 'S', '1', '2'),
    ('uf', 'uf_id', 'Estado a que pertence a cidade', 'm2o', 'fields_adm_uf', 'S', '2'),
    ('pais', 'pais_id', 'Id da tabela de pais', 'm2o', 'fields_adm_pais', '0'),
}

# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_adm_email = (
    ('id', 'id', 'Id interno do e-mail', 'integer', 0, 'N', '0'),
    ('email', 'name', 'Endereco de e-mail', 'string', 75, 'S', '0'),
    ('observacao', 'observacao', 'Alguma observacao sobre o e-mail', 'string', 255, 'N', '0'),
    ('setor', 'admpem_setor_ids.name', 'Setor', 'm2m', 'fields_setor', 'N', '0'),
    ('pessoa', 'pessoa_id', 'Pessoa a quem pertence o email', 'm2o', 'fields_pessoa', 'S', '1'),
    ('tipo', 'email_tipo_id', 'Tipo de email', 'm2o', 'fields_adm_email_tipo', 'S', '0')
)

# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_adm_endereco = (
    ('id', 'id', 'Id interno do endereco', 'integer', 0, 'N', '0'),
    ('ativo', 'active', 'Identifica se esta ativo(1) ou inativo(0)', (0, 1), 1, 'N', '0'),
    ('endereco_tipo', 'endereco_tipo_id', 'Tipo de endereco da pessoa, Normal, Entrega, Cobranca, etc', 'm2o', 'fields_adm_endereco_tipo', 'S', '0'),
    ('pais', 'pais_id', 'Pais', 'm2o', 'fields_adm_pais', 'N', '0'),
    ('cep', 'cep', 'Codigo de enderecamento postal-CEP', 'string', 10, 'N', '0'),
    ('estado', 'uf_id', 'Estado da federacao', 'm2o', 'fields_adm_uf', 'N', '0'),
    ('Cidade', 'cidade_id', 'Cidade', 'm2o', 'fields_adm_cidade', 'N', '0'),
    ('ibge', 'cidade_id.codigo_ibge', 'Codigo da cidade no Ibge', 'integer', 0, 'N', '0'),
    ('bairro', 'bairro_id', 'Bairro', 'm2o', 'fields_adm_bairro', 'N', '0'),
    ('rua', 'logradouro_id', 'Rua', 'm2o', 'fields_adm_logradouro', 'N', '0'),
    ('numero', 'numero', 'Numero do imovel na rua', 'string', 5, 'N', '0'),
    ('complemento', 'complemento', 'Complemento do endereco', 'string', 20, 'N', '0'),
    ('observacao', 'observacao', 'Alguma observacao sobre o endereco', 'string', 255, 'N', '0'),
    ('pessoa', 'pessoa_id', 'Pessoa de quem eh o endereco', 'm2o', 'fields_pessoa', 'S', '0'),
)

# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_pessoa = (
    ('id', 'id', 'Id interno do banco de dados', 'integer', 0, 'N', '0'),
    ('ativo', 'active', 'Identifica se esta ativo(1) ou inativo(0)', (0, 1), 1, 'N', '0'),
    ('data_nascimento', 'admpes_fis_data_nascimento', 'Data de nascimento no formato AAAAMMDD', 'AAAAMMDD', 8, 'N', '0'),
    ('estado_civil', 'admpes_fis_estado_civil',
     'Estado civil, C=Casado, S=Solteiro, V=viuvo, D=Divorciado, E=dEsquitado', ('C', 'S', 'V', 'D', 'E'), 1, 'N', '0'),
    ('produto_rural', 'admpes_fis_produtor_rural', 'Indica a condicao de produtor rural, 1=Produtor, 0=Nao produtor',
     (0, 1), 1, 'N', '0'),
    ('rg', 'admpes_fis_rg', 'Numero da carteira de identidade da pessoa fisica(ate 14 bytes)', 'string', 14, 'N', '9'),
    ('sexo', 'admpes_fis_sexo', 'Sexo da pessoa, M=Masculino F=Feminino', ('M', 'F'), 1, 'N', '0'),
    ('id_externo', 'admpes_id_externo', 'Codigo de identificacao externo', 'string', 14, 'N', '8'),
    ('ie', 'admpes_jur_ie', 'Inscricao estadual da pessoa juridica', 'string', 14, 'N', '7'),
    ('codigo', 'codigo', 'Codigo de identificacao interno', 'integer', 0, 'N', '1'),
    ('cpf_cnpj', 'cpf_cnpj', 'Cpf/Cnpj da pessoa', 'string', 19, 'S', '2'),
    ('emails', 'fields_adm_email', 'lista de e-mails', 'o2m', 'fields_adm_email', 'N', '0'),
    ('email', 'email', 'Email padrao da pessoa', 'string', 50, 'P', '0'),
    ('enderecos', 'endereco_ids', 'Lista de enderecos', 'o2m', 'fields_adm_endereco', 'N', '0'),
    ('fantasia_apelido', 'fantasia_apelido', 'Nome fantasia ou apelido da pessoa', 'string', 30, 'N', '0'),
    ('nome', 'name', 'Nome da pessoa', 'string', 50, 'S', '0' ),
    ('fisica_juridica', 'pessoa_tipo', 'Tipo de pessoa, F=Fisica ou J=Juridica', ('F','J'), 1, 'S', '0'),
    ('telefones', 'telefones_ids', 'Lista de telefones', 'o2m', 'fields_adm_telefone', 'N', '0'),
    ('telefone', 'telefone', 'Numero telefone padrao', 'string', 25, 'P', '0'),
)

# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_vex_departamento = (
    ('id', 'id', 'Id interno do banco de dados', 'integer', 0, 'N', '0'),
    ('codigo', 'vexdep_codigo', 'Codigo de identificacao interno', 'integer', 0, 'S', '1'),
    ('nome', 'name', 'Nome do departamento', 'string', 30, 'S', '0'),
    ('pai', 'vexdep_departamento_pai_id', 'Id do departamento pai', 'm2o', 0, 'N', '0'),
    ('imagem', 'vexdep_imagem', 'Imagem do departamento', 'binary', 0, 'N', '0'),
)

# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_embalagens = (
    ('id', 'id', 'Id interno do banco de dados', 'integer', 0, 'N', '0'),
    ('nome', 'name', 'Nome da embalagem', 'string', 30, 'S', '0'),
    ('sigla', 'sigla', 'Sigla da embalagem', 'string', 7, 'N', '0'),
    ('unidade', 'unidade_id', 'Unidade', 'm2o'  'fields_unidades', 'S', '0'),
)
# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_produtos = (
    ('id', 'id', 'Id interno do banco de dados', 'integer', 0, 'N', '0'),
    ('ativo', 'active', 'Identifica se esta ativo(1) ou inativo(0)', (0, 1), 1, 'N', '0'),
    ('codigo', 'codigo', 'Codigo de identificacao interno', 'string', 20, 'N', '1'),
    ('descricao', 'name', 'Nome do produto', 'string', 60, 'S', '0'),
    ('departamentos', 'estpro_departamento_ids', 'Departamentos', 'dict', 0, 'N', '0'),
    ('imagem', 'estpro_foto', 'Imagem do produto', 'binary', 0, 'N', '0'),
    ('preco_venda', 'preco_venda', 'Preco de venda', 'float', 0, 'N', '0'),
    ('grades', 'produto_grade_ids', 'Grades', 'o2m', 'fields_produtos_grades', 'N', '0'),
    ('embalagens', 'produto_embalagem_ids', 'Embalagens', 'o2m', 'fields_produtos_embalagens', 'N', '0'),
)

# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_produtos_grades = (
    ('id', 'id', 'Id das grades', 'integer', 0, 'N', '0'),
    ('ativo', 'active', 'Identifica se esta ativo(1) ou inativo(0)', (0, 1), 1, 'N', '0'),
    ('grade', 'grade', 'Codigo da grade', 'string', 2, 'N', '1'),
    ('produto', 'produto_id', 'Id do produto', 'm2o', 'fields_produtos', 'S', '1'),
    ('descricao', 'descricao', 'Descricao da grade,(somente da grade)', 'string', 40, 'S', '0'),
    ('nome', 'name', 'Descricao da grade/produto,(completo)', 'string', 63, 'P', '0'),
    ('saldo', 'saldo', 'Saldo do produto/grade', 'float', 0, 'P', '0'),
    ('locacoes', 'local_locacao_ids', 'Locais', 'o2m', 'fields_locais_locacoes', 'N', '0'),
)

# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_locais = (
    ('id', 'id', 'Id dos locais', 'integer', 0, 'N', '0'),
    ('nome', 'name', 'Descricao do local', 'string', 30, 'S', '0'),
    ('ativo', 'active', 'Identifica se esta ativo(1) ou inativo(0)', (0, 1), 1, 'N', '0'),
    ('numero', 'numero', 'Numero do local', 'integer', 0, 'S', '0'),
)
# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_locais_locacoes = (
    ('id', 'id', 'Id das locacoes', 'integer', 0, 'N', '0'),
    ('ativo', 'active', 'Identifica se esta ativo(1) ou inativo(0)', (0, 1), 1, 'N', '0'),
    ('locacao', 'locacao', 'Endereco da locacao', 'string', 15, 'N', '0'),
    ('grade', 'grade_id', 'Grade', 'm2o', 'fields_produtos_grades', 'S', '0'),
    ('altura', 'altura', 'Altura (cm)', 'float', 0, 'N', '0'),
    ('largura', 'largura', 'Largura (cm)', 'float', 0, 'N', '0'),
    ('profundidade', 'profundidade', 'Profundidade (cm)', 'float', 0, 'N', '0'),
    ('produto', 'produto_id', 'Id do produto', 'm2o', 'fields_produtos', 'S', '1'),
    ('local', 'local_id', 'Id do local', 'm2o', 'fields_locais', 'S', '0'),
    ('embalagens', 'estllc_produto_embalagem_id', 'Embalagem', 'm2o', 'fields_produtos_embalagens', 'N', '0'),
)

# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_produtos_embalagens = (
    ('id', 'id', 'Id da embalagem', 'integer', 0, 'N', '0'),
    ('produto', 'produto_id', 'Id do produto', 'm2o', 'fields_produtos', 'S', '1'),
    ('embalagem', 'embalagem_id', 'Id da embalagem', 'm2o', 'fields_embalagens', 'S', '0'),
    ('peso_liquido', 'peso_liquido', 'Peso liquido (Kg)', 'float', 0, 'N', '0'),
    ('peso_bruto', 'peso_bruto', 'Peso bruto (Kg)', 'float', 0, 'N', '0'),
    ('ativo', 'active', 'Identifica se esta ativo(1) ou inativo(0)', (0, 1), 1, 'N', '0'),
    ('altura', 'altura', 'Altura (cm)', 'float', 0, 'N', '0'),
    ('largura', 'largura', 'Largura (cm)', 'float', 0, 'N', '0'),
    ('profundidade', 'profundidade', 'Profundidade (cm)', 'float', 0, 'N', '0'),
)
# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_pedidos = (
    ('id', 'id', 'Id do pedido', 'integer', 0, 'N', '0'),
    ('data_emissao', 'data_emissao', 'Data do pedido', 'AAAAMMDD', 0, 'S', '0'),
    ('data_entrega', 'data_entrega', 'Data de entrega', 'AAAAMMDD', 0, 'N', '0'),
    ('numero_pedido', 'numero_pedido','Numero do pedido', 'string', 20, 'P', '0'),
    ('observacoes', 'observacao', 'Observacoes', 'string', 254, 'N', '0'),
    ('pessoa', 'pessoa_id', 'Id da pessoa', 'm2o', 0, 'S', '0'),
    ('itens', 'pedido_item_ids', 'Itens do pedido', 'o2m', 'fields_pedidos_itens', 'N', '0'),
    ('state', 'state', 'Estado do pedido', 'string', '1', '0'),
    ('valor', 'valor_total', 'Valor total do pedido', 'float', 0, 'P', '0'),
    ('tipo', 'tipo', 'Tipo do pedido Compra ou Venda', ('C', 'V'), 1, 'S', '0'),
    ('parcelas', 'pedido_parcela_ids', 'Parcelas do pedido', 'o2m', 'fields_pedidos_parcelas', 'P', '0'),
    ('condicoes', 'pedido_condicao_ids', 'Condicoes de pagamento do pedido', 'o2m', 'fields_pedidos_condicoes','N', '0'),
)

# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_forma_pgto = (
    ('id', 'id', 'Id da forma', 'integer', 0, 'N', '0'),
    ('imprimir_boleto', 'admfpg_boleto','Indica se imprime boleto. 1-Imprieme, 0-Nao imprime', (0, 1), 1, 'N', '0'),
    ('local_cobranca', 'admfpg_local_cobranca_id', 'Local de cobranca', 'm2o', 'fields_local_cobranca', 'N', '0'),
    ('natureza', 'admfpg_natureza_id', 'Natureza da cobranca', 'm2o', 'fields_natureza_cobranca', 'N', '0'),
    ('documento_tipo', 'admfpg_documento_tipo_id', 'Tipo de documento' , 'm2o', 'fields_documento_tipo', 'S', '0'),
    ('imprimir_promissoria', 'admfpg_promissoria', 'Indica se imprime promissoria. 1-Imprieme, 0-Nao imprime', (0, 1), 1, 'N', '0'),
    # ('01', 'Dinheiro'), ('02', 'Cheque'), ('03', 'Cartao de credito'),
    #      ('04', 'Cartao de debito'), ('05', 'Credito loja'), ('10', 'Vale alimentacao'),
    #      ('11', 'Vale refeicao'), ('12', 'Vale presente'), ('13', 'Vale combustivel'),
    #      ('14', 'Duplicata mercantil'), ('15', 'Boleto bancario'), ('90', 'Sem pagamento'),
    #      ('99', 'Outros')
    ('tipo', 'admfpg_tipo', 'Tipo da forma de pagamento', ('01', '02', '03', '04', '05', '10', '11', '12', '13', '14', '15', '90', '99'), 2, 'N', 0 ),

)

# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_pedidos_parcelas = (
   ('id', 'id', 'Id da parcela', 'integer', 0, 'N', '0'),
   ('valor_parcela', 'vr_parcela', 'Valor da parcela', 'float', '0', 'N', '0'),
   ('condicao', 'pedido_condicao_id', 'Condicao pagamento', 'm2o', 'fields_pedidos_condicoes', 'N', '0'),
   ('vencimento', 'data_vencimento', 'Vencimento', 'AAAAMMDD', 0, 'S', '0'),
   ('capa_pedido', 'pedido_id', 'Id da capa do pedido', 'm2o', 'fields_pedidos', 'P', '0'),
)

# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_pedidos_condicoes = (
   ('id', 'id', 'Id da condicao', 'integer', 0, 'N', '0'),
   ('capa_pedido', 'pedido_id', 'Id da capa do pedido', 'm2o', 'fields_pedidos', 'S', '0'),
   ('condicao_forma', 'condicao_forma_id', 'Id da condicao forma', 'm2o', 'fields_condicao_forma', 'S', '0'),
   ('forma_pgto', 'forma_pagto_id', 'Id da forma de pagamento', 'm2o', 'fields_forma_pgto', 'S', '0'),
   ('parcelas', 'pedido_parcela_ids', 'Parcelas da condicao', 'o2m', 'fields_pedidos_parcelas', 'N', '0'),
)

# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_pedidos_itens = (
    ('id', 'id', 'Id dos iten do pedido', 'integer', 0, 'N', '0'),
    ('capa_pedido', 'pedido_id', 'Id da capa do pedido', 'm2o', 'fields_pedidos', 'S', '0'),
    ('quantidade', 'qtde_pedida', 'Quantidade', 'float', '0', 'S', '0'),
    ('valor_unitario', 'vr_unitario', 'Valor unitário', 'float', '0', 'S', '0'),
    ('desconto', 'vr_desconto', 'Valor do desconto', 'float', '0', 'N', '0'),
    ('observacoes', 'observacao', 'Observacoes', 'string', 254, 'N', '0'),
    ('produto', 'produto_id', 'Id do produto', 'm2o', 'fields_produtos', 'S', '0'),
    ('grade', 'grade_id', 'Id da grade', 'm2o', 'fields_produtos_grades', 'S', '0'),
    ('local', 'local_id', 'Id do local', 'm2o', 'fields_locais', 'S', '0'),
    ('valor_total', 'valor_total', 'Valor total do item', 'float', '0', 'N', '0'),
    ('embalagem', 'produto_embalagem_id', 'Id da empbalagem no produto', 'm2o', 'fields_produtos_embalagens','S', '0'),
)

# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_produtos_embalagens = {
    ('id', 'id', 'Id do produtos embalagens', 'integer', 0, 'N', '0'),
    ('ativo', 'active', 'Identifica se esta ativo(1) ou inativo(0)', (0, 1), 1, 'N', '0'),
    ('produto', 'produto_id', 'Id do produto', 'm2o', 'fields_produtos', 'S', '0'),
    ('embalagem', 'embalagem_id', 'Id da embalagem', 'm2o', 'fields_embalagens', 'S', '0'),
}

# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_embalagens = {
    ('id', 'id', 'Id das embalagens', 'integer', 0, 'N', '0'),
    ('descricao', 'name', 'Descricao da embalagem', 'string', 30, 'S', '1'),
    ('sigla', 'sigla', 'Sigla da embalagem', 'string', 7, 'N', '0'),
    ('unidade', 'unidade_id', 'Id da unidade', 'm2o', 'fields_unidades', 'S', '0'),
    ('qtd_emb', 'quantidade_na_embalagem', 'Quantidade na embalagem', 'float', '0', 'S', '0'),
}

# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_unidades = {
    ('id', 'id', 'Id das unidades', 'integer', 0, 'N', '0'),
    ('unidade', 'unidade', 'Sigla da unidade', 'string', 3, 'S', '1'),
    ('descricao', 'name', 'Descricao da unidade', 'string', 30, 'S', '2'),
    ('fracao', 'fracao', 'Informa se a unidade aceita fracionar', ('0', '1'), 1, 'N', '0'),
}

# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_estoque_parametros = {
    ('id', 'id', 'Id das unidades', 'integer', 0, 'N', '0'),
    ('local_venda','local_venda_padrao_id', 'Local de venda', 'm2o', 'fields_locais', 'N', '0'),
    ('Local_compra', 'estpar_local_compra_padrao_id', 'Local de compra', 'm2o', 'fields_locais', 'N', '0'),
}
# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)

fields_codigo_barra = {
    ('id', 'id', 'Id do codigo de barras', 'integer', 0, 'N', '0'),
    ('ativo', 'active', 'Identifica se esta ativo(1) ou inativo(0)', (0, 1), 1, 'N', '0'),
    ('codigo_barra', 'codigo_barra', 'Codigo de barras', 'string', 14, 'S', '0'),
    ('empresa', 'company_id', 'Empresa', 'm2o', 'fields_empresa', 'N', '0'),
    ('produto', 'produto_id', 'Produto', 'm2o', 'fields_produtos', 'S', '0'),
    ('grade', 'grade_id', 'Grade do produto', 'm2o', 'fields_produtos_grades', 'S', '0'),
    ('embalagem', 'produto_embalagem_id', 'Embalagem do produto', 'm2o', 'fields_embalagens', 'S', '0'),

}

# Classes especiais, são classe conteiners, que agrupam 2 ou mais classes
# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
sigerp_pedidos = (
    ('id', 'id', 'Id do pedido', 'integer', 0, 'N', '0'),
    ('data_emissao', 'data_emissao', 'Data do pedido', 'AAAAMMDD', 0, 'S', '0'),
    ('data_entrega', 'data_entrega', 'Data de entrega', 'AAAAMMDD', 0, 'N', '0'),
    ('numero_pedido', 'numero_pedido','Numero do pedido', 'string', 20, 'P', '0'),
    ('observacoes', 'observacao', 'Observacoes', 'string', 254, 'N', '0'),
    ('pessoa', 'pessoa_id', 'Id da pessoa', 'm2o', 0, 'S', '0'),
    ('itens', 'pedido_item_ids', 'Itens do pedido', 'o2m', 'fields_pedidos_itens', 'N', '0'),
    ('state', 'state', 'Estado do pedido', 'string', '1', '0'),
    ('valor', 'valor_total', 'Valor total do pedido', 'float', 0, 'P', '0'),
    ('tipo', 'tipo', 'Tipo do pedido Compra ou Venda', ('C', 'V'), 1, 'S', '0'),
    ('parcelas', 'pedido_parcela_ids', 'Parcelas do pedido', 'o2m', 'fields_pedidos_parcelas', 'P', '0'),
    ('condicoes', 'pedido_condicao_ids', 'Condicoes de pagamento do pedido', 'o2m', 'fields_pedidos_condicoes','N', '0'),
)
# tuplas com nome_externo(0), nome_interno(1), descricao do campo(2), tipo de dados(3), tamanho do campo(4), Obrigatorio na inclusao(5), Agrupamento p/pesquisa(6)
fields_api_controle = {
    ('apicon_log', 'apicon_log', 'Habilitar log', (0, 1), 1, 'N', '0'),
}
