# -*- encoding: utf-8 -*-

from controller import api_sigerp
import requests
import openerp.addons.web.http as http
import json

sig_template = """
        <html>
            <header>{header}</header>
            <body>
            <form name="teste" action="http://localhost:8069/apsg/api_html" method="post">
                <br>
                    <input type="submit" name="btn_inicio" value='Inicio'>
                    <input type="submit" name="btn_logar" value='Logar'>
                    <input type="submit" name="btn_refresh" value='Refresh token'>
                    <input type="submit" name="btn_cliente" value='cliente'>
                    <input type="submit" name="btn_cliente_campos" value='Campos do cliente'>
                    {buttons}
                <br><br>
                    Base:<input type="text" name="base" value="{base}">
                    Usuario:<input type="text" name="usuario" value="{user}">
                    Senha:<input type="text" name="senha" value="{senha}">
                    Tempo:<input type="text" name="tempo" value="{tempo}">
                <br><br>
                {mens}
                </form>
            </body>
        </html>

"""

class api_teste(api_sigerp):
    # Métodos para teste
    @http.httprequest
    def inic(self, req, s_action=None, **kw):
        template =  self.template_preparar('Login no SigERP', buttons='', corpo='')
        return template

    @http.httprequest
    def api_html(self, req, s_action=None, **kw):
        self.sig_base = req.params.get('base')
        self.sig_user = req.params.get('usuario')
        self.sig_senha = req.params.get('senha')
        self.sig_tempo = req.params.get('tempo')
        if 'btn_logar' in req.params:
            res = self.api_logar(req, s_action=None, **kw)
            res = json.loads(res)
            if res.get('cod') != '00':
                token = refresh_token = ''
                mens = res.get('message')
            else:
                token = res.get('token')
                refresh_token = res.get('refresh_token')
                mens = 'Login com sucesso'
            _user = req.params.get('usuario')
            corpo = [('Mensagem', mens), ('Token', token), ('Refresh Token', refresh_token)]
            template = self.template_preparar('Confirmacao de login', None, corpo)
        elif 'btn_inicio' in req.params:
            template = self.inic(req, s_action=None, **kw)
        elif 'btn_refresh' in req.params:
            req.params['token'] = self.sig_token
            req.params['refresh_token'] = self.sig_refresh_token
            res = self.api_revalidar_token(req, s_action=None, **kw)
            if res.get('cod') == '00':
                token = res.get('token')
                refresh_token = res.get('refresh_token')
                mens = 'Token revalidado'
            else:
                token = refresh_token = ''
                mens = res.get('message')
            corpo = [('Mensagem', mens), ('Token', token), ('Refresh Token', refresh_token)]
            template = self.template_preparar('Revalidando token', buttons='', corpo=corpo)
        elif 'btn_cliente' in req.params:
            corpo = [('CPF/CNPJ', 'input_cpf_cnpj')]
            buttons = [('btn_consultar_cliente', 'Consultar')]
            template = self.template_preparar('Consultar cliente', buttons=buttons, corpo=corpo)
        elif 'btn_consultar_cliente' in req.params:
            params = {}
            params['acao'] = 'cons_cliente'
            params['dados_acao'] = json.dumps({'cpf_cnpj': req.params.get('input_cpf_cnpj')})
            headers = {"Authorization": self.sig_token}
            _server = str(req.httprequest.host_url)+'apsg/api_aplicacao'
            res = requests.get(_server, params=params, headers=headers)
            dados = ret_acao = json.loads(res.content)
            if dados.get('cod') == '00':
                for dados in dados.get('retorno_acao'):
                    corpo = []
                    for key in  dados.keys():
                        if dados.get(key):
                            corpo.append((key, dados.get(key)))
                        else:
                            corpo.append((key, ''))
                    template = self.template_preparar('Lido cliente com sucesso', buttons='', corpo=corpo, retorno_acao=ret_acao)
            else:
                mens = dados.get('message')
                corpo = [('Mensagem', mens)]
                template = self.template_preparar('Erro na leitura do cliente', buttons='', corpo=corpo)
        elif 'btn_cliente_campos' in req.params:
            params = {}
            params['acao'] = 'cons_cliente_campos'
            params['dados_acao'] = '{}'
            headers = {"Authorization": self.sig_token}
            _server = str(req.httprequest.host_url)+'apsg/api_aplicacao'
            res = requests.get(_server, params=params, headers=headers)
            dados = ret_acao = json.loads(res.content)
            if dados.get('cod') == '00':
                corpo = []
                for dados in dados.get('retorno_acao'):
                    for key in  dados.keys():
                        if dados.get(key):
                            corpo.append((key, dados.get(key)))
                        else:
                            corpo.append((key, ''))
                    template = self.template_preparar('Lido campos do cliente com sucesso', buttons='', corpo=corpo, retorno_acao=ret_acao)
            else:
                mens = dados.get('message')
                corpo = [('Mensagem', mens)]
                template = self.template_preparar('Erro na leitura dos campos de cliente', buttons='', corpo=corpo)

        else:
            template = self.template_preparar('Funcao nao implementada', buttons='', corpo='')
        return template


    ## Métodos internos da classe ##########################################
    def template_preparar(self, header, buttons, corpo, retorno_acao=None):
        res = sig_template
        res = res.replace('{user}', self.sig_user).replace('{senha}', self.sig_senha).replace('{base}', self.sig_base)
        res = res.replace('{tempo}', self.sig_tempo)
        res = res.replace('{header}', header)
        if not buttons:
            res = res.replace('{buttons}', '')
        else:
            _but = ''
            for x in buttons:
                _but = _but + '<input type = "submit" name="%s" value="%s">' % (x[0], x[1])
            res = res.replace('{buttons}', _but)

        if not corpo:
            res = res.replace('{mens}', '')
        else:
            mens = '<br><table>'
            for c in corpo:
                x = c[0]
                y = str(c[1])
                if len(y) > 6 and y[:5] == 'input':
                    y = '<input type="text" name="%s">' % y
                mens = mens + '<tr><td>%s</td><td>%s</td></tr>' % (x, y)
            mens = mens + '</table>'
            if retorno_acao:
                mens = mens + '<br>Retorno completo:'+ str(retorno_acao)
            res = res.replace('{mens}', mens)
        # for x in dados_troca:
        #     res = res.replace(x[0], x[1])
        return res

