# -*- encoding: utf-8 -*-

from controller import api_sigerp
import requests
import openerp.addons.web.http as http
import json
import base64
# frase composta de base(20) + tempo(8) + texto da frase
# _frase_fonte = 'T_mlapi*|*3600*|*Palavra Secreta'
# _frase_encode = base64.b64encode(_frase_fonte)
# frase = base64.b64decode(_frase_encode)
_frase_encode = 'VF9tbGFwaSp8KjM2MDAqfCpGcmFzZSBzZWNyZXRh'

sig_template = """
        <html>
            <header>{header}</header>
            <body>
            <form name="teste" action="https://impulso.erp.siginformatica.com.br/apsg/api_html" method="post">
                <br>
                    <input type="submit" name="btn_inicio" value='Inicio'>
                    <input type="submit" name="btn_logar" value='Logar'>
                    <input type="submit" name="btn_refresh" value='Refresh token'>
                    <input type="submit" name="btn_pessoa" value='pessoa'>
                    <input type="submit" name="btn_pessoa_campos" value='Campos do pessoa'>
                    {buttons}
                <br><br>
                    <table>
                        <tr>
                           <td colspan="1">Usuario:</td>
                           <td colspan="1"><input type="text" name="usuario" value="{user}"></td>
                           <td colspan="1">Senha:</td>
                           <td colspan="1"><input type="text" name="senha" value="{senha}"></td>
                        </tr>
                        <tr>
                            <td colspan="1">Code:</td>
                            <td colspan="3"><input type="text" name="sg_code" value="{sg_code}"></td>
                        </tr>
                    </table>
                <br><br>
                {mens}
                </form>
            </body>
        </html>

"""

class api_teste(api_sigerp):
    # Métodos para teste
    @http.httprequest
    def api_testar(self, req, s_action=None, **kw):
        template =  self.template_preparar('Login no SigERP', buttons='', corpo='')
        return template

    @http.httprequest
    def api_html(self, req, s_action=None, **kw):
        self.sig_code = req.params.get('sg_code')
        self.sig_frase = base64.b64decode(self.sig_code)
        self.sig_base, self.sig_tempo, x = self.sig_frase.split('*|*')
        self.sig_user = req.params.get('usuario')
        self.sig_senha = req.params.get('senha')
        if 'btn_logar' in req.params:
            res = self.api_logar(req, s_action=None, **kw)
            res = json.loads(res)
            if res.get('cod') != '00':
                token = refresh_token = ''
                mens = res.get('message')
            else:
                token = res.get('token')
                refresh_token = res.get('refresh_token')
                mens = 'Login com sucesso'
            _user = req.params.get('usuario')
            corpo = [('Mensagem', mens), ('Token', token), ('Refresh Token', refresh_token)]
            template = self.template_preparar('Confirmacao de login', None, corpo)
        elif 'btn_inicio' in req.params:
            template = self.api_testar(req, s_action=None, **kw)
        elif 'btn_refresh' in req.params:
            req.params['token'] = self.sig_refresh_token
            # req.params['refresh_token'] = self.sig_refresh_token
            res = self.api_revalidar_token(req, s_action=None, **kw)
            res = json.loads(res)
            if res.get('cod') == '00':
                token = res.get('token')
                refresh_token = res.get('refresh_token')
                mens = 'Token revalidado'
            else:
                token = refresh_token = ''
                mens = res.get('message')
            corpo = [('Mensagem', mens), ('Token', token), ('Refresh Token', refresh_token)]
            template = self.template_preparar('Revalidando token', buttons='', corpo=corpo)
        elif 'btn_pessoa' in req.params:
            corpo = [('CPF/CNPJ', 'input_cpf_cnpj')]
            buttons = [('btn_consultar_pessoa', 'Consultar')]
            template = self.template_preparar('Consultar pessoa', buttons=buttons, corpo=corpo)
        elif 'btn_consultar_pessoa' in req.params:
            params = {}
            params['tabela'] = 'fields_pessoa'
            params['dados_acao'] = json.dumps({'filters':{'cpf_cnpj': req.params.get('input_cpf_cnpj')}})
            headers = {"Authorization": self.sig_token}
            _server = str(req.httprequest.host_url)+'apsg/api_executar'
            res = requests.get(_server, params=params, headers=headers)
            dados = ret_acao = json.loads(res.content)
            if dados.get('cod') == '00':
                for dados in dados.get('retorno_acao'):
                    corpo = []
                    for key in  dados.keys():
                        if dados.get(key):
                            corpo.append((key, dados.get(key)))
                        else:
                            corpo.append((key, ''))
                    template = self.template_preparar('Lido pessoa com sucesso', buttons='', corpo=corpo, retorno_acao=ret_acao)
            else:
                mens = dados.get('message')
                corpo = [('Mensagem', mens)]
                template = self.template_preparar('Erro na leitura do pessoa', buttons='', corpo=corpo)
        elif 'btn_pessoa_campos' in req.params:
            params = {}
            params['tabela'] = 'fields_pessoa'
            params['dados_acao'] = '{}'
            params['retornar_campos'] = True
            headers = {"Authorization": self.sig_token}
            _server = str(req.httprequest.host_url)+'apsg/api_executar'
            res = requests.get(_server, params=params, headers=headers)
            dados = ret_acao = json.loads(res.content)
            if dados.get('cod') == '00':
                corpo = []
                for dados in dados.get('retorno_acao'):
                    for key in  dados.keys():
                        if dados.get(key):
                            corpo.append((key, dados.get(key)))
                        else:
                            corpo.append((key, ''))
                    template = self.template_preparar('Lido campos do pessoa com sucesso', buttons='', corpo=corpo, retorno_acao=ret_acao)
            else:
                mens = dados.get('message')
                corpo = [('Mensagem', mens)]
                template = self.template_preparar('Erro na leitura dos campos de pessoa', buttons='', corpo=corpo)

        else:
            template = self.template_preparar('Funcao nao implementada', buttons='', corpo='')
        return template


    ## Métodos internos da classe ##########################################
    def template_preparar(self, header, buttons, corpo, retorno_acao=None):
        res = sig_template
        res = res.replace('{user}', self.sig_user).replace('{senha}', self.sig_senha).replace('{sg_code}', _frase_encode)
        res = res.replace('{header}', header)
        if not buttons:
            res = res.replace('{buttons}', '')
        else:
            _but = ''
            for x in buttons:
                _but = _but + '<input type = "submit" name="%s" value="%s">' % (x[0], x[1])
            res = res.replace('{buttons}', _but)

        if not corpo:
            res = res.replace('{mens}', '')
        else:
            mens = '<br><table>'
            for c in corpo:
                x = c[0]
                y = str(c[1])
                if len(y) > 6 and y[:5] == 'input':
                    y = '<input type="text" name="%s">' % y
                mens = mens + '<tr><td>%s</td><td>%s</td></tr>' % (x, y)
            mens = mens + '</table>'
            if retorno_acao:
                mens = mens + '<br>Retorno completo:'+ str(retorno_acao)
            res = res.replace('{mens}', mens)
        # for x in dados_troca:
        #     res = res.replace(x[0], x[1])
        return res

