#-*- encoding: utf-8 -*-

from openerp.osv import osv
from SigUtils import datas
from openerp.tools.translate import _


class associacao_mandato(osv.Model):
    _name = 'associacao.mandato'
    _inherit = 'associacao.mandato'

    def assman_onchange_data(self, cr, uid, ids, data, prazo):
        warning = {}
        value = {}
        if not prazo:
            warning['title'] = _('Atencao')
            warning['message'] = _('Prazo invalido!')
            return {'value': value, 'warning': warning}
        _ano, _mes, _dia = data.split('-')
        _ano = int(_ano) + prazo
        _data = '%s-%s-%s' % (_ano, _mes, _dia)
        _data = datas.calcVencimento(_data, -1)
        value['assman_termino'] = _data[:4]+'-'+_data[4:6]+'-'+_data[6:]
        res = {'value': value, 'warning': warning}
        return res

    def _assman_inserir_orgao(self, cr, uid, vals, ids=False):
        _orgao = vals.get('assman_orgao_id')
        if not _orgao and ids:
            for brw in self.browse(cr, uid, ids):
                _orgao = brw.assman_orgao_id.id
        if _orgao:
            _ocupante_ids = vals.get('assman_ocupante_ids') or False
            if _ocupante_ids:
                _novo_ocupante_ids = []
                for _linha in _ocupante_ids:
                    _acao, _id, _dic = _linha
                    if isinstance(_dic, dict):
                        if not _dic.get('assocu_orgao_id'):
                            _dic['assocu_orgao_id'] = _orgao
                    _novo_ocupante_ids.append((_acao, _id, _dic))
                vals['assman_ocupante_ids'] = _novo_ocupante_ids
        return vals

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        vals = self._assman_inserir_orgao(cr, uid, vals)
        res = super(associacao_mandato, self).create(cr, uid, vals, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        vals = self._assman_inserir_orgao(cr, uid, vals, ids)
        res = super(associacao_mandato, self).write(cr, uid, ids, vals, context)
        return res