#-*- encoding: utf-8 -*-

from openerp.osv import osv
import re
from openerp.tools.translate import _
from SigUtils import inscricao_estadual


class associacao_socios(osv.Model):
    _name = 'associacao.socios'
    _inherit = 'associacao.socios'

    def asssoc_button_salvar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = self.write(cr, uid, ids, {}, context)
        return res

    def asssoc_onchange_cpf_cnpj(self, cr, uid, ids, pessoa_tipo, cpf_cnpj, context=None):
        """
        Metodo invocado na saida do campo cpf/cnpj da tela.
        Valida o cpf/cnpj e caso esteja correto, devolve o cpf/cnpj formatado
        """
        context = context and context.copy() or {}
        warning = {}
        if not cpf_cnpj:
            return {'warning': warning, 'value': {}}
        res = self.pool.get('adm.utils').admutl_cpf_cnpj_testar(pessoa_tipo, cpf_cnpj, True)
        if res:
            cpf_cnpj = res
        else:
            warning = {'title': _('Erro na validacao')}
            if pessoa_tipo == 'F':
                warning['message'] = _('CPF Invalido!  Digite Novamente!')
            else:
                warning['message'] = _('CNPJ Invalido!  Digite Novamente!')
            return {'warning': warning, 'value': {'cpf_cnpj': ''}}
        _cnpj_cpf_sem_formatar = re.sub('[^0-9]', '', cpf_cnpj)
        obj_pessoa = self.pool.get('adm.pessoa')
        pessoa_ids = obj_pessoa.search(cr, uid,
                                       [('cpf_cnpj', '=', _cnpj_cpf_sem_formatar),
                                        ('pessoa_tipo', '=', pessoa_tipo)], context=context)
        if pessoa_ids:
            socio_id = self.search(cr, uid,
                                   [('asssoc_pessoa_id', 'in', pessoa_ids), ('active', '=', True)], context=context)
            if socio_id:
                warning = {'title': _('Atencao')}
                warning['message'] = _('Socio ja cadastrado!')
                return {'warning': warning, 'value': {'cpf_cnpj': ''}}
            dados_pessoa = obj_pessoa.browse(cr, uid, pessoa_ids)
            if isinstance(dados_pessoa, list):
                dados_pessoa = dados_pessoa[0]
            res = self.pool.get('adm.pessoa').admpes_prepara_onchange_pessoa(cr, uid, dados_pessoa)
            res['value']['asssoc_pessoa_id'] = dados_pessoa.id
            return res
        return {'warning': warning, 'value': {'cpf_cnpj': cpf_cnpj}}

    def asssoc_onchange_pessoa(self, cr, uid, ids, pessoa_id, context=None):
        """
        Metodo invocado na saida do campo asssoc_pessoa_id da tela.
        Pesquisa em adm.pessoa, se já existe o cadastro que deseja incluir como socio
        """
        context = context and context.copy() or {}
        warning = {}
        if not pessoa_id:
            return {'warning': warning, 'value': {}}
        obj_adm_pessoa = self.pool.get('adm.pessoa')
        dados_pessoa = obj_adm_pessoa.browse(cr, uid, pessoa_id)
        if isinstance(dados_pessoa, list):
            dados_pessoa = dados_pessoa[0]
        res = self.pool.get('adm.pessoa').admpes_prepara_onchange_pessoa(cr, uid, dados_pessoa)
        res['value']['asssoc_pessoa_id'] = dados_pessoa.id
        _socio_ids = self.search(cr, uid, [('asssoc_pessoa_id', '=', pessoa_id)], context=context)
        if _socio_ids:
            warning = {'title': _('Atencao')}
            warning['message'] = _('Socio ja cadastrado!  Selecione um outro!')
            return {'warning': warning, 'value': {'asssoc_pessoa_id': ''}}
            # Forcar um id qualquer, para que o campo assoc_pessoa_id desapareca da tela
        res['value']['id'] = 1
        return res

    def _asssoc_validar_socio(self, cr, uid, ids=None, context=None):
        context = context and context.copy() or {}
        obj_associacao_parametros = self.pool.get('associacao.parametros')
        associacao_parametros_ids = obj_associacao_parametros.search(cr, uid, [], context=context)
        if not associacao_parametros_ids:
            raise osv.except_osv(_('Atencao'), _('Parametros nao cadastrados!'))
        dados_associacao_parametros = obj_associacao_parametros.read(cr, uid,
                                                                     associacao_parametros_ids[0], context=context)
        _mensalidade_valor_minimo = dados_associacao_parametros['asspar_mensalidade_valor_minimo']
        for id in ids:
            brw_associacao_socios = self.browse(cr, uid, [id], context=context)
            _tipo_mensalidade = self.pool.get('associacao.utils').assutl_get_tipo_mensalidade(cr,
                                                                                              uid,
                                                                                              [id])
            _tipo_mensalidade = _tipo_mensalidade[0][1]
            _valor = brw_associacao_socios[0].asssoc_valor_contribuicao
            _dia = brw_associacao_socios[0].asssoc_dia_vencimento
            if _tipo_mensalidade == 'C':
                if not _valor:
                    raise osv.except_osv(_('Atencao'), _(
                        'A mensalidade e obrigatoria para a categoria utilizada!'))
            if _valor:
                if _tipo_mensalidade == 'S':
                    raise osv.except_osv(_('Atencao'), _(
                        'Nao existe mensalidade para esta categoria ou neste socio nao tem categoria informada!'))
                if not _dia:
                    raise osv.except_osv(_('Atencao'),
                                         _('Vencimento da mensalidade nao foi informado!'))
                if _valor < _mensalidade_valor_minimo:
                    raise osv.except_osv(_('Atencao'),
                                         _('Valor da mensalidade e menor do que o valor minimo!'))
            else:
                _tipo_cobranca = brw_associacao_socios[0].asssoc_cobranca_tipo_id.id or False
                vals = {}
                if _tipo_cobranca:
                    vals={'asssoc_cobranca_tipo_id': False}
                if _dia:
                    vals={'asssoc_dia_vencimento': False}
                if vals:
                    context['sem_validacao'] = True
                    self.write(cr, uid, [id], vals, context=context)
        return True

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        res = super(associacao_socios, self).write(cr, uid, ids, vals, context)
        # a validação está depois da alteração, porque se houver erro, vai dar um raise e fazer um rollback
        if not context.get('sem_validacao'):
            self._asssoc_validar_socio(cr, uid, ids=ids, context=context)
        return res

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        res = super(associacao_socios, self).create(cr, uid, vals, context)
        # a validação está depois da alteração, porque se houver erro, vai dar um raise e fazer um rollback
        if not context.get('sem_validacao'):
            self._asssoc_validar_socio(cr, uid, ids=[res], context=context)
        return res

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = []
        if context is None:
            context = []
        if not len(ids):
            return []
        dados = self.browse(cr, uid, ids, context=context)
        for x in dados:
            res.append((x.id, x.asssoc_pessoa_id.name))
        return res

    def asssoc_onchange_ie(self, cr, uid, ids, admpes_jur_ie):
        res, estado = self.pool.get('adm.pessoa').admpes_validar_ie(cr, uid, ids, admpes_jur_ie)
        if not res:
            return {'warning': {'title': _('Atencao'),
                                'message': _(
                                    'Inscricao Estadual invalida para o seguinte estado: %s') % estado}}
        return res
