# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _

class associacao_utils(osv.Model):
    _name = 'associacao.utils'
    _auto = False

    def assutl_get_categoria(self, cr, uid, context=None):
        """
        Método para identificar a categoria pai que representa as categorias utilizadas no modulo
          associacao.
        @param cr:
        @param uid:
        @param context:
        @return: {list} Lista com um único id
        """
        context = context and context.copy() or {}
        obj = self.pool.get('associacao.parametros')
        ids = obj.search(cr, uid, [], context=context)
        res = obj.read(cr, uid, ids, ['asspar_categoria_id'], context=context)
        for x in res:
            if not x.get('asspar_categoria_id'):
                raise osv.except_osv(_('Atencao'), _('Categoria nao cadastrada no parametro!'))
        return [(r['asspar_categoria_id'][0]) for r in res]

    def assutl_get_tipo_mensalidade(self, cr, uid, socio_ids):
        """
        Método para identificar se o sócio está em alguma categoria que tenha obrigatoriedade
          ou opcionalidade na mensalidade.
        @param cr:
        @param uid:
        @param socio_ids: {list} Lista de ids dos socios a identificar se tem mensalidade ou não
        @return: {list} Lista de lista com ids com a resposta para cada id {char}
           A resposta pode ser:
              'S' é Sem mensalidade,
              'C' Com mensalidade obrigatoria e
              'O' a mensalidade é Opcional.
           Ex.: [[id, resposta], [id, resposta]]
           Obs.: Caso o associado pertença a mais de uma categoria, a ordem que prevalece é: O, C, S
        """
        res = []
        for brw_associacao_socios in self.pool.get('associacao.socios').browse(cr, uid, socio_ids):
            if brw_associacao_socios.asssoc_pessoa_id.categoria_ids:
                _tem_mensalidade = 'S'
                for brw_categoria in brw_associacao_socios.asssoc_pessoa_id.categoria_ids:
                    if brw_categoria.admpcn_tipo_mensalidade == 'C':
                        _tem_mensalidade = 'C'
                        break
                    if brw_categoria.admpcn_tipo_mensalidade == 'O':
                        _tem_mensalidade = 'O'
                        continue
                res.append([brw_associacao_socios.id, _tem_mensalidade])
            else:
                res.append([brw_associacao_socios.id, 'S'])
        return res

