#-*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class associacao_ocupante(osv.Model):
    """
    Tabela de ocupantes dos cargos, pessoas que assumiram mandatos
    """
    _name = 'associacao.ocupante'
    from funcoes import _assocu_get_ocupante
    _columns = {
        'name': fields.function(_assocu_get_ocupante, method=True, type="char", size=64,
                                            string='Categoria', store=True),
        'assocu_orgao_id': fields.many2one('associacao.orgao', 'Orgao', required=True, select=True),
        'assocu_cargo_id': fields.many2one('associacao.cargo', 'Cargo', required=True, select=True),
        'assocu_mandato_id': fields.many2one('associacao.mandato', 'Mandato', required=True, select=True),
        'assocu_socio_id': fields.many2one('associacao.socios', 'Socio', required=True, select=True),
        'assocu_data_afastamento': fields.date('Data de afastamento',
                                               help='Data de afastamento definitivo por renuncia, morte, etc')
    }
    _order = 'assocu_orgao_id,assocu_mandato_id,assocu_cargo_id'


