#-*- encoding: utf-7 -*-

from openerp.osv import osv, fields
import time


class associacao_socios(osv.Model):
    """
    Tabela que contem os socios da instituicao
    """
    _name = 'associacao.socios'
    _rec_name = 'asssoc_pessoa_id'
    _inherits = {
        'adm.pessoa': 'asssoc_pessoa_id',
    }
    from funcoes import _asssoc_get_categoria

    _columns = {
        'asssoc_pessoa_id': fields.many2one("adm.pessoa", 'Socio', required=True, select=True, ondelete="cascade"),
        'asssoc_data_inicio': fields.date('Data da associacao', requited=True),
        'active': fields.boolean('Ativo'),
        'asssoc_data_fim': fields.date('Data da saida'),
        'asssoc_dia_vencimento': fields.integer('Dia do vencimento'),
        'asssoc_valor_contribuicao': fields.float('Valor da contribuicao', digits=(12, 2)),
        'asssoc_fundador': fields.boolean('Socio fundador'),
        'asssoc_apresentado_por_1_id': fields.many2one('associacao.socios', 'Apresentado por', ondelete="restrict",
                                                       select=True),
        'asssoc_apresentado_por_2_id': fields.many2one('associacao.socios', 'Apresentado por', ondelete="restrict",
                                                       select=True),
        'asssoc_categoria': fields.function(_asssoc_get_categoria, method=True, type="char", size=30,
                                            string='Categoria', store=True), # Categoria do socio
        'asssoc_profissao': fields.char('Profissao', size=30),
        'asssoc_cobranca_tipo_id': fields.many2one("associacao.cobranca.tipo", 'Tipo de cobranca', ondelete="restrict",
                                                   select=True),
    }
    _defaults = {
        'asssoc_data_inicio': lambda *a: time.strftime('%Y-%m-%d'),
        'active': lambda *a: True,
    }
    _order = 'asssoc_pessoa_id'



