# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from SigUtils import formatastring
import time
from openerp.tools.translate import _


class associacao_gerar_carne(osv.TransientModel):
    def _assgca_get_ano_mes(self, cr, uid):
        _ano = int(time.strftime('%Y'))
        res = str(_ano)
        return res

    _name = "associacao.gerar.carne"
    _columns = {
        'assgca_ano': fields.char("Ano a gerar", size=4, required=True),
    }
    _defaults = {
        'assgca_ano': lambda s, cr, uid, c: s._assgca_get_ano_mes(cr, uid),
    }

    def button_gerar(self, cr, uid, ids, context=None):
        """
        Funcao para gerar carne para os socios
        """
        context = context and context.copy() or {}
        context['ctx_fisnfc_titulo_create_sem_custificacao'] = True
        context['pessoa_nao_validar'] = True
        obj_associacao_socio = self.pool.get('associacao.socios')
        obj_financeiro_titulo = self.pool.get('financeiro.titulo')
        obj_documento_documento_tipo = self.pool.get('documento.documento.tipo')
        documento_tipo_id = obj_documento_documento_tipo.search(cr, uid, [('sigla', '=', 'CAR')], context=context)
        if documento_tipo_id:
            documento_tipo_id = documento_tipo_id[0]
        else:
            val = {
                'bloqueio': True,
                'liquidavel': True,
                'descricao': 'Carne',
                'sigla': 'CAR',
            }
            documento_tipo_id = obj_documento_documento_tipo.create(cr, uid, val, context)
        _socios_ids = obj_associacao_socio.search(cr, uid, [('asssoc_cobranca_tipo_id.asscot_sigla', '=', 'CAR'),
                                                            ('asssoc_dia_vencimento', '>', '0')], context=context)
        if not _socios_ids:
            raise osv.except_osv(_('Atencao'), _('Nao ha socios para gerar carne!'))
        vals = self.read(cr, uid, ids[0], ['assgca_ano'], context=context)
        if isinstance(vals, list):
            vals = vals[0]
        _ano = vals.get('assgca_ano')
        brw_associacao_socio = obj_associacao_socio.browse(cr, uid, _socios_ids)
        parcela = 1
        for _dados_socio in brw_associacao_socio:
            for i in range(1, 13):
                _mes = formatastring.formataString(i, 2, '0', 'E', 'S', 'S')
                _nro_titulo = _ano + _mes
                _args = [('pessoa_id', '=', _dados_socio.asssoc_pessoa_id.id), ('documento', '=', _nro_titulo)]
                _titulo_ids = obj_financeiro_titulo.search(cr, uid, _args, context=context)
                if _titulo_ids: # Se tiver titulo para socio, nao fazer nada
                    continue
                _emissao = '%s-01-01' % _ano
                _vencimento = _ano + '-' + _mes + '-' + formatastring.formataString(_dados_socio.asssoc_dia_vencimento,
                                                                                    2, '0', 'E', 'S', 'S')
                res = self.pool.get('financeiro').financ_titulo_entrada(cr,
                                                                        uid,
                                                                        _dados_socio.asssoc_pessoa_id.id,
                                                                        _emissao,
                                                                        _vencimento,
                                                                        _nro_titulo,
                                                                        parcela,
                                                                        _dados_socio.asssoc_valor_contribuicao,
                                                                        'A',
                                                                        'R',
                                                                        fult_tit_doc_tipo_id=documento_tipo_id,
                                                                        context=context)
                if res:
                    parcela += 1

        return True




