# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from SigUtils import formatastring, datas
import time
from openerp.tools.translate import _


class associacao_gerar_mensalidades(osv.TransientModel):
    def _assgme_get_ano_mes(self, cr, uid, tipo):
        _ano = int(time.strftime('%Y'))
        _mes = int(time.strftime('%m'))
        _mes += 1
        if _mes > 12:
            _mes = 01
            _ano += 1
        if tipo == 'A':
            res = str(_ano)
        else:
            res = str(_mes)
            if len(res) < 2:
                res = formatastring.formataString(res, 2, '0', 'E')
        return res

    _name = "associacao.gerar.mensalidades"
    _columns = {
        'assgme_ano': fields.char("Ano a gerar", size=4, required=True),
        'assgme_mes': fields.char("Mes a gerar", size=2, required=True),
        'assqme_informacao': fields.text(''),
        'state': fields.selection([('N', 'Nova'), ('P', 'Processado')], string="Estado"),
    }
    _defaults = {
        'assgme_ano': lambda s, cr, uid, c: s._assgme_get_ano_mes(cr, uid, 'A'),
        'assgme_mes': lambda s, cr, uid, c: s._assgme_get_ano_mes(cr, uid, 'M'),
        'state': lambda *a: 'N',
    }

    def button_atualizar(self, cr, uid, ids, context=None):
        """
        Funcao para gerar mensalidade para os socios
        Pesquisa por todos os socios que contribuem financeiramente e gera um titulo no contas a receber
        """
        context = context and context.copy() or {}
        context['pessoa_nao_validar'] = True
        obj_associacao_socio = self.pool.get('associacao.socios')
        obj_financeiro_titulo = self.pool.get('financeiro.titulo')
        args_socios = []
        args_socios.append(('asssoc_valor_contribuicao', '>', '0'))
        args_socios.append(('asssoc_dia_vencimento', '>', '0'))
        args_socios.append(('asssoc_cobranca_tipo_id.asscot_sigla', '!=', 'CAR'))
        _socios_ids = obj_associacao_socio.search(cr, uid, args_socios, context=context)
        if not _socios_ids:
            raise osv.except_osv(_('Atencao'), _('Nao ha socios para gerar mensalidades!'))
        vals = self.read(cr, uid, ids[0], ['assgme_ano', 'assgme_mes'], context=context)
        if isinstance(vals, list):
            vals = vals[0]
        _ano = vals.get('assgme_ano')
        _mes = vals.get('assgme_mes')
        _nro_titulo = _ano + _mes
        brw_associacao_socio = obj_associacao_socio.browse(cr, uid, _socios_ids)
        _qtd_associados = len(brw_associacao_socio)
        _qtd_mensalidades = 0
        for _dados_socio in brw_associacao_socio:
            _args = [('pessoa_id', '=', _dados_socio.asssoc_pessoa_id.id), ('documento', '=', _nro_titulo)]
            _titulo_ids = obj_financeiro_titulo.search(cr, uid, _args, context=context)
            if _titulo_ids: # Se tiver titulo para socio, nao fazer nada
                continue
            _emissao = time.strftime('%Y-%m-%d')
            _vencimento = _ano + '-' + _mes + '-' + formatastring.formataString(_dados_socio.asssoc_dia_vencimento, 2,
                                                                                '0', 'E', 'S', 'S')
            res = self.pool.get('financeiro').financ_titulo_entrada(cr,
                                                                    uid,
                                                                    _dados_socio.asssoc_pessoa_id.id,
                                                                    _emissao,
                                                                    _vencimento,
                                                                    _nro_titulo,
                                                                    1,
                                                                    _dados_socio.asssoc_valor_contribuicao,
                                                                    'A',
                                                                    'R',
                                                                    context=context)
            _qtd_mensalidades += 1
        log = _('Associados Processados: %d \
             \nMensalidades Geradas: %d') % (_qtd_associados, _qtd_mensalidades)
        self.write(cr, uid, ids, {'assqme_informacao': log, 'state': 'P'}, context=context)
        return True

