# -*- coding: utf-8 -*-

from openerp.osv import osv, fields


class wizard_correcao_mensalidade(osv.TransientModel):
    # prefixo: wcomen_

    _name = 'wizard.correcao.mensalidade'
    _columns = {
        'wcomen_valor_mensalidade': fields.float('Novo valor mensalidade', digits=(12, 2)),
        'wcomen_atualizacao': fields.selection([('0', 'Nao executado'), ('1', 'Atualizado'),
                                                ('2', 'Nao atualizado')], 'Atualizacao', size=1),
    }
    _defaults = {
        'wcomen_atualizacao': '0',
    }

    def wcomen_set_valor_mensalidade(self, cr, uid, ids, context=None):
        """
        O metodo atualiza todos os registros da tabela 'associacao_socios' com o novo valor da
        mensalidade definida. Coluna 'asssoc_valor_contribuicao'.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela dessa classe.
        :type ids: list
        :param context: dados de valores contextuais.
        :type context: dict
        :return: Verdadeiro, caso a atualizacao do valor seja realizada. Senao, falso.
        :rtype: bool
        """
        context.update({'active_test': False, 'sem_validacao': True})
        obj_associacao_socios = self.pool.get('associacao.socios')
        res = False
        socio_ids = obj_associacao_socios.search(cr, uid, [], context=context)
        for correcao in self.browse(cr, uid, ids, context):
            if correcao.wcomen_valor_mensalidade <= 0 or not socio_ids:
                self.write(cr, uid, correcao.id, {'wcomen_atualizacao': '2'}, context)
                continue
            res = obj_associacao_socios.write(
                cr, uid, socio_ids,
                {'asssoc_valor_contribuicao': correcao.wcomen_valor_mensalidade}, context)
            if res:
                self.write(cr, uid, correcao.id, {'wcomen_atualizacao': '1'}, context)
        return res
