#-*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from datetime import datetime
from openerp.report import report_sxw
import base64
from openerp.tools.translate import _


class wizard_impressao_carne(osv.TransientModel):
    _name = "wizard.impressao.carne"
    _columns = {
        'company_id': fields.many2one("res.company", "Empresa", required=True, select=True),
        'socio_ids': fields.many2many('associacao.socios', 'associacao_socios_impressao_carne', 'id', 'socio_id',
                                      'Socio'),
        'data_vencimento_inicio': fields.date('Data inicial'),
        'data_vencimento_final': fields.date('Data final'),
        'reimprimir': fields.boolean('Reimprimir'),
        'dados': fields.binary('Clique para baixar o arquivo', readonly=True),
        'carne_gerado': fields.boolean('Carne gerado'),
        'file_name': fields.char('Arquivo', size=20, readonly=False),
        'carne_capa_ids': fields.one2many('wizard.impressao.carne.capa', 'carne_id', 'Capa'),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(cr, uid, uid).company_id.id,
        'reimprimir': False,
        'carne_gerado': False,
        'file_name': lambda * a: 'carnes.pdf'
    }

    def button_localizar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, list):
            ids = ids[0]
        obj_documento_documento_tipo = self.pool.get('documento.documento.tipo')
        obj_financeiro_titulo = self.pool.get('financeiro.titulo')
        obj_associacao_socios = self.pool.get('associacao.socios')
        obj_wizard_impressao_carne_detalhes = self.pool.get('wizard.impressao.carne.detalhes')
        obj_wizard_impressao_carne_capa = self.pool.get('wizard.impressao.carne.capa')
        capa_id = obj_wizard_impressao_carne_capa.search(cr, uid, [], context=context)
        obj_wizard_impressao_carne_capa.unlink(cr, uid, capa_id)
        detalhes_id = obj_wizard_impressao_carne_detalhes.search(cr, uid, [], context=context)
        obj_wizard_impressao_carne_detalhes.unlink(cr, uid, detalhes_id)
        carne_dados = self.browse(cr, uid, ids)
        company_id = carne_dados.company_id.id
        documento_tipo_id = obj_documento_documento_tipo.search(cr, uid, [('sigla', '=', 'CAR')], context=context)
        if not documento_tipo_id:
            val = {
                'bloqueio': True,
                'liquidavel': True,
                'descricao': 'Carne',
                'sigla': 'CAR',
            }
            documento_tipo_id = obj_documento_documento_tipo.create(cr, uid, val, context)
        if isinstance(documento_tipo_id, list):
            documento_tipo_id = documento_tipo_id[0]
        if carne_dados.socio_ids:
            socios_dados = carne_dados.socio_ids
        else:
            socios_ids = obj_associacao_socios.search(cr, uid, [('asssoc_cobranca_tipo_id.asscot_sigla', '=', 'CAR')],
                                                      context=context)
            socios_dados = obj_associacao_socios.browse(cr, uid, socios_ids, context=context)
        for j in socios_dados:
            vals_capa = {
                'carne_id': ids,
                'pessoa_id': j.asssoc_pessoa_id.id,
                'company_id': company_id
            }
            args = []
            args.append(('company_id', '=', company_id))
            args.append(('doc_tipo_id', '=', documento_tipo_id))
            if carne_dados.data_vencimento_inicio:
                args.append(('data_prorrogacao', '>=', carne_dados.data_vencimento_inicio))
            if carne_dados.data_vencimento_final:
                args.append(('data_prorrogacao', '<=', carne_dados.data_vencimento_final))
            if not carne_dados.reimprimir:
                args.append(('fintit_ja_impresso', '=', False))
            args.append(('pessoa_id', '=', j.asssoc_pessoa_id.id))
            titulo_id = obj_financeiro_titulo.search(cr, uid, args, order='documento asc', context=context)
            if titulo_id:
                carne_capa_id = obj_wizard_impressao_carne_capa.create(cr, uid, vals_capa, context)
                titulo_dados = obj_financeiro_titulo.browse(cr, uid, titulo_id)
                for i in titulo_dados:
                    vals = {
                        'carne_capa_id': carne_capa_id,
                        'titulo_id': i.id,
                        'pessoa_id': i.pessoa_id.id,
                        'tipo_titulo': i.tipo_titulo,
                        'documento': i.documento,
                        'local_cobranca_id': i.local_cobranca_id.id,
                        'state': i.state,
                        'data_emissao': i.data_emissao,
                        'data_prorrogacao': i.data_prorrogacao,
                        'valor': i.vr_original,
                        'atraso_dias': i.fintit_atraso_dias,
                        'doc_tipo_id': documento_tipo_id,
                        'company_id': company_id,
                    }
                    obj_wizard_impressao_carne_detalhes.create(cr, uid, vals, context)

        return True

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, list):
            ids = ids[0]
        obj_financeiro_titulo = self.pool.get('financeiro.titulo')
        dados = self.browse(cr, uid, ids)
        if not dados.carne_capa_ids:
            raise osv.except_osv(_('Atencao'), _('Nao ha dados para gerar relatorio'))
        capa_ids = []
        titulo_ids = []
        for i in dados.carne_capa_ids:
            if not i.carne_detalhes_ids:
                raise osv.except_osv(_('Atencao'), (_('Socio ') + i.pessoa_id.name.upper() + _(' nao possui carne')))
            capa_ids.append(i.id)
            for j in i.carne_detalhes_ids:
                titulo_ids.append(j.titulo_id.id)
        if titulo_ids:
            obj_financeiro_titulo.write(cr, uid, titulo_ids, {'fintit_ja_impresso': True})
        hoje = datetime.now()
        documento = 'report.carne.' + str(hoje) + 'tetqwer'
        obj_ir_act_report_xml = self.pool.get('ir.actions.report.xml')
        report_id = obj_ir_act_report_xml.search(cr, uid, [('report_name', '=', 'wizard.impressao.carne.capa')],
                                                 context=context)
        report_xml = obj_ir_act_report_xml.browse(cr, uid, report_id[0])
        report_xml._data.get(report_id[0])['name'] = _('Impressao de Carne')
        report_pdf = report_sxw.report_sxw(documento, 'wizard.impressao.carne.capa',
                                           'associacao_financeiro/report/carne.rml').create_single_pdf(cr, uid, capa_ids,
                                                                                            {'report_type': 'pdf'},
                                                                                            report_xml)
        self.write(cr, uid, ids, {'dados': base64.encodestring(report_pdf[0]), 'carne_gerado': True}, context=context)
        return report_pdf

