# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estsug_compra_capa(osv.Model):
    # prefixo: esgccp_
    _inherit = 'estsug.compra.capa'

    def esgccp_get_selection_codigo_imprimir(self, cr, uid, context=None):
        """
        O metodo disponibiliza as opcoes possiveis para impressao do codigo que representa o produto
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: lista com os valores de cada tipo de impressao.
        :rtype: list
        """
        context = context and context.copy() or {}
        res = super(estsug_compra_capa, self).esgccp_get_selection_codigo_imprimir(cr, uid, context)
        res.append(('B', 'Barras'))
        return res

    _columns = {
        'esgccp_codigo_imprimir': fields.selection(esgccp_get_selection_codigo_imprimir,
                                                   'Codigo para impressao', size=1, required=True),
    }
