# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class estoque_produto(osv.Model):
    _inherit = 'estoque.produto'

    def copy(self, cr, uid, id, default=None, context=None):
        context = context and context.copy() or {}
        if not default:
            default = {}
        default.update({
            'automacao_ids': [],
            'precos_promocao_ids': [],
        })
        res = super(estoque_produto, self).copy(cr, uid, id, default, context)
        return res

    def estpro_button_atualiza_preco_automacao(self, cr, uid, ids, context=None):
        """
        Metodo do botao 'Atualizar na automacao'. Acao para chamada do processo de atualizacao do
        preco de venda na automacao
        :param cr: cursor no banco de dados
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario
        :type uid: int
        :param ids: lista de id da tabela desse objeto
        :type ids: list
        :param context: dados contextuais
        :type context: dict
        :return: Verdadeiro
        :rtype: bool
        """
        context = context and context.copy() or {}
        obj_atualizar_precos = self.pool.get('automacao.atualizar.precos.osv')
        produto_id = isinstance(ids, list) and ids[0] or ids
        preco_venda = self.pool.get('estoque.preco.venda').get_preco_venda(
            cr, uid, [produto_id], context=context).get(produto_id).get('preco_venda')
        if not preco_venda:
            raise osv.except_osv(_('Atencao'), _('Produto nao possui preco de venda.'))
        atualizar_precos_id = obj_atualizar_precos.create(cr, uid, {'produto_id': produto_id},
                                                          context)
        if not obj_atualizar_precos.read(cr, uid, atualizar_precos_id, ['local_ids'], context).get(
                'local_ids'):
            raise osv.except_osv(_('Atencao'), _("'Local para saidas' nao cadastrado nos parametros"
                                                 " do estoque."))
        obj_atualizar_precos.button_atualizar(cr, uid, [atualizar_precos_id], context)
        return True

    def write(self, cr, user, ids, vals, context=None):
        context = context and context.copy() or {}
        campos_alterados = vals.keys()
        obj_precos = self.pool.get('automacao.precos')
        obj_cb = self.pool.get('automacao.codigo.barra')
        # caso algum desses campos sejam alterados no produto, marca o preco como nao exportado,
        # para exporta-lo na exportacao parcial
        for i in ['ncm_id', 'estpro_cest_id', 'tributacao_ids']:
            if i not in campos_alterados:
                continue

            if not isinstance(ids, list):
                ids = [ids]

            cb_ids = obj_cb.search(cr, user, [('produto_id', 'in', ids)], context=context)
            if not cb_ids:
                break

            preco_ids = obj_precos.search(cr, user, [('codigo_barra_id', 'in', cb_ids)],
                                          context=context)
            if not preco_ids:
                break

            obj_precos.write(cr, user, preco_ids, {'autpre_ja_exportou': False}, context)

        return super(estoque_produto, self).write(cr, user, ids, vals, context)