# -*- coding: utf-8 -*-

from openerp.osv import osv, fields


class wizard_listagem_geral(osv.TransientModel):
    """
    Heranca da classe ´wizard_listagem_geral´.
    """

    _inherit = 'wizard.listagem.geral'
    _columns = {
        'codigo_a_listar': fields.selection([('P', 'Codigo do produto'), ('B', 'Codigo de barras'),
                                             ('F', 'Codigo no fabricante')], 'Codigo a listar',
                                            required=True)
    }
    _defaults = {
        'codigo_a_listar': lambda *args: 'P'
    }


class wizard_listagem_geral_item(osv.TransientModel):
    """
    Heranca da classe ´wizard_listagem_geral_item´.
    """

    _inherit = 'wizard.listagem.geral.item'

    def build_query(self, params):
        sql = super(wizard_listagem_geral_item, self).build_query(params)
        if params.get('codigo_a_listar') != 'B':
            return sql
        sql = sql.format(codigo_heranca='acb.codigo_barra       AS codigo_item,',
                         codigo_heranca_group='acb.codigo_barra,')
        sql = sql.replace('LEFT JOIN fiscal_cst                 AS cst ON cst.id = fte.cst_id',
                          'LEFT JOIN fiscal_cst                 AS cst ON cst.id = fte.cst_id\n'
                          'LEFT JOIN automacao_codigo_barra    AS acb '
                          '    ON acb.grade_id = epg.id AND acb.produto_embalagem_id = epe.id')
        return sql

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
