# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from SigUtils import calcDigito


#Funcoes da classe automacao.codigo.barra
def _autcba_get_dun(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    ret = {}
    res = self.read(cr, uid, ids, ['codigo_barra'], context=context)
    for x in res:
        ret[x['id']] = len(str(x['codigo_barra'])) == 14
    return ret


def _autcba_validar_codigo(self, cr, uid, ids, codigo_barra=None, usa_digito=True, context=None):
    context = context and context.copy() or {}
    if not codigo_barra:
        dados = self.read(cr, uid, ids, ['codigo_barra', 'autcba_usa_digito'], context=context)[0]
        usa_digito = dados.get('autcba_usa_digito')
        codigo_barra = dados.get('codigo_barra')

    if not usa_digito:
        return True

    digito = str(calcDigito.ean(codigo_barra[:-1]))
    if str(codigo_barra[-1:]) == digito:
        return True
    else:
        return digito


#Funcoes da classe automacao.precos.promocao
def _autppr_check_data(self, cr, uid, ids, context=None):
    context = context and context.copy() or {}
    ret = 0
    for i in self.read(cr, uid, ids, context=context):
        sql_grade = ''
        grade_id = i.get('grade_id')
        if grade_id:
            if isinstance(grade_id, (list, tuple)):
                grade_id = grade_id[0]
            sql_grade = """
                 ap.grade_id = %s   and
            """ % grade_id
        sql = """
            select count(1)
             from automacao_precos_promocao ap
            where ap.produto_id = %s and
                  ap.company_id = %s and
                  %s
                 (ap.data_inicio-1 , ap.data_termino+1) OVERLAPS ( to_date('%s','YYYY-MM-DD'),
                 to_date('%s','YYYY-MM-DD') )
            """ % (i['produto_id'][0], i['company_id'][0], sql_grade, i['data_inicio'],
                   i['data_termino'])
        cr.execute(sql)
        ret = cr.fetchone()[0] or 0
    #TODO criar Select ṕara retornar se existe promocao
    return ret <= 1


def _autppr_get_local_default(self, cr, uid, context=None):
    context = context and context.copy() or {}
    res = []
    obj_estoque_local = self.pool.get('estoque.local')
    obj_estoque_parametro = self.pool.get('estoque.parametro')
    company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'estoque.local', context=context)
    estoque_parametro_id = obj_estoque_parametro.search(cr, uid, [('company_id', '=', company_id)], context=context)
    if estoque_parametro_id:
        local_venda_padrao = obj_estoque_parametro.browse(
            cr, uid, estoque_parametro_id[0]).local_venda_padrao_id
        if local_venda_padrao:
            local_id = local_venda_padrao.id
        else:
            local_id = obj_estoque_local.search(cr, uid, [('company_id', '=', company_id)], context=context)
        if local_id:
            if isinstance(local_id, list):
                res = [local_id[0]]
            else:
                res = [local_id]
    return res
