# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class automacao_precos(osv.Model):
    """
    Tabela de automacao
    Utilizado pelos programas de venda, principalmente para autoservico

    # prefixo: autpre_

    """
    _name = 'automacao.precos'
    _roteavel = True
    _gerar_logs_logs = 'N'
    _columns = {
        'codigo_barra_id': fields.many2one("automacao.codigo.barra", 'Codigo de Barra', ondelete="cascade",
                                           required=True, select=True),
        'autpre_produto_id': fields.related('codigo_barra_id', 'produto_id', type='many2one',
                                            relation='estoque.produto', string='Produto',
                                            store=False),
        'autpre_codigo_barra': fields.related('codigo_barra_id', 'codigo_barra', type='char',
                                              relation='automacao.codigo.barra',
                                              string='Codigo de barra', store=False),
        'preco_venda': fields.float('Preco venda', digits=(15, 2), required=True),  # Preco de venda
        'data_atualizacao': fields.datetime('Data atualizacao', required=True, select=True),
        # Data da atualizacao do preco
        'ja_listou': fields.boolean('Ja listou'),
        # Flag que indica se este item ja foi listado apos a alteracao do preco
        'autpre_ja_emitiu_etiqueta': fields.boolean('Emitiu etiqueta'),
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'autpre_ja_exportou': fields.boolean('Exportado para o supervisor', select=True),
    }
    _defaults = {
        'ja_listou': lambda *a: False,
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        'autpre_ja_exportou': False,
    }

    _sql_constraints = [
        ('codigo_uniq', 'unique(company_id, codigo_barra_id)',
         'Ja existe outro preco cadastrado para este codigo de barras e empresa.'),
    ]

