# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        def center_title(E, C, D, T=134):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title
        title = center_title('', _('Lista de alteracao de preco'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Lista de alteracao de preco'))
        listagem.informaTamLinha(129)
        listagem.defineFonte(tam=7.25)
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)
        obj_automacao_precos = pooler.get_pool(cr.dbname).get('automacao.precos')
        data = datas.get('data')
        data_original = data
        local_id = datas.get('local_id')
        opcao = datas.get('opcao')
        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                                                     'listagem.precos.alterados.osv', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        data_alteracao = time.strftime("%d/%m/%Y", time.strptime(data_original, "%Y-%m-%d"))
        docs = center_title(data, nome_empresa, 'Pagina: {{ Page }} ')
        listagem.informaCab('Contr.Estoque')
        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab('')
        listagem.informaCab(_('Precos alterados em: %s') % data_alteracao)
        listagem.informaCab('')
        listagem.informaCab(
            '*---------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(
            _('| C o d i g o  | GR | Descricao                                      | Embal. | UNI | LOCAL      | *- Preco -* | Etq | Md | Saldo |'))
        listagem.informaCab(
            '*---------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(
              '|              |    |                                                |        |     |            |             |     |    |       |')
        listagem.rodapePadrao()

        args = [('data_atualizacao', '>=', data_original + ' 00:00:00'),
                ('data_atualizacao', '<=', data_original + ' 23:59:59')]
        if opcao == 'N':
            args.append(('ja_listou', '=', False), )
        automacao_precos_ids = obj_automacao_precos.search(cr, uid, args, context=context)
        if not automacao_precos_ids:
            self.obj = external_pdf(pdf_string.getvalue())
            self.obj.render()
            pdf_string.close()
            return (self.obj.pdf, 'pdf')

        brw_automacao_precos = obj_automacao_precos.browse(cr, uid, automacao_precos_ids,
                                                            context=context)
        if datas.get('ordem') == 'A':
            brw_automacao_precos = sorted(brw_automacao_precos,
                                          key=lambda p: p.codigo_barra_id.produto_id.name)
        elif datas.get('ordem') == 'C':
            brw_automacao_precos = sorted(brw_automacao_precos,
                                          key=lambda p: p.codigo_barra_id.produto_id.codigo)
        aut_preco_ids = []
        for aut_preco in brw_automacao_precos:
            brw_cod_barra = aut_preco.codigo_barra_id
            for brw_local_loc in brw_cod_barra.grade_id.local_locacao_ids:
                if local_id:
                    if brw_local_loc.local_id.id == local_id:
                        self.imprime_valores(aut_preco, brw_local_loc, listagem,datas.get('tipo_codigo'))
                else:
                    self.imprime_valores(aut_preco, brw_local_loc, listagem, datas.get('tipo_codigo'))

                aut_preco_ids.append(aut_preco.id)

        listagem.imprimeLinha('*' + ''.center(129, '-') + '*')
        aut_preco_ids = list(set(aut_preco_ids))
        obj_automacao_precos.write(cr, uid, aut_preco_ids, {'ja_listou': True}, context=context)

        listagem.imprimeLinha(
            '                                                                                               ** Sig Informatica LTDA **           ')
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()

        return (self.obj.pdf, 'pdf')

    def imprime_valores(self, aut_preco, brw_local_loc, listagem, tipo_codigo):
        brw_cod_barra = aut_preco.codigo_barra_id
        local = brw_local_loc.local_id.name
        saldo = brw_cod_barra.grade_id.saldo
        grade = brw_cod_barra.grade_id.grade
        if grade:
            grade = grade[:2]

        codigo = brw_cod_barra.produto_id.codigo
        if tipo_codigo == '2':
            codigo = brw_cod_barra.codigo_barra

        linha = formataString(codigo or '', 14, ' ', 'D', 'N', 'S') + '|'
        linha += ' '
        linha += formataString(grade or '', 3, ' ', 'D', 'N', 'S') + '|'
        linha += ' '
        linha += formataString(brw_cod_barra.produto_id.name or '', 47, ' ', 'D', 'N', 'S') + '|'
        linha += ' '
        linha += formataString(getNumeroEditado(brw_cod_barra.produto_embalagem_id.\
                                                embalagem_id.quantidade_na_embalagem) or 0.0,
                               7, ' ', 'E', 'N', 'S') + '|'
        linha += ' '
        linha += formataString(brw_cod_barra.produto_embalagem_id.embalagem_id.sigla or '',
                                                                     4, ' ', 'E', 'N', 'S') + '|'
        linha += ' '
        linha += formataString(local or '', 11, ' ', 'E', 'N', 'S') + '|'
        linha += ' '
        linha += formataString(getNumeroEditado(aut_preco.preco_venda) or 0.0,
                                                                    12, ' ', 'E', 'N', 'S') + '|'
        linha += ' '
        linha += formataString('S' if brw_cod_barra.emite_etiqueta else 'N',
                                                                     4, ' ', 'E', 'N', 'S') + '|'
        linha += ' '
        linha += formataString(brw_cod_barra.autcba_modelo_etiqueta or '',
                                                                     3, ' ', 'E', 'N', 'S') + '|'
        linha += ' '
        linha += formataString(getNumeroEditado(saldo) or 0.0, 6, ' ', 'E', 'N', 'S') + '|'
        linha += ' '
        listagem.imprimeLinha('|' + linha)

report_custom('report.precos_alterados')


class listagem_precos_alterados_osv(osv.TransientModel):
    _name = 'listagem.precos.alterados.osv'

    def default_local(self, cr, uid, context=None):
        context = context and context.copy() or {}
        obj_adm_utils = self.pool.get('adm.utils')
        local_id = obj_adm_utils.admutl_get_parametros(cr, uid, 'estoque.parametro',
                               'local_venda_padrao_id', context=None).get('local_venda_padrao_id')
        return local_id

    _columns = {
        'data': fields.date('Data da alteracao', required=True),
        'local_id': fields.many2one("estoque.local", 'Local', select=True),
        'opcao': fields.selection([('A', 'Todos atualizados'), ('N', 'Nao listados')], 'Opcao',
                                  size=1),
        'ordem': fields.selection([('C', 'Codigo'), ('A', 'Alfabetica')], 'Ordenar por', size=1),
        'tipo_codigo': fields.selection([('1', 'Codigo de interno'), ('2', 'Codigo de Barras')],
                                        'Codigo a listar', size=1),
    }

    _defaults = {
        'local_id': default_local,
        'tipo_codigo': '1',
    }

    def print_listagem_precos_alterados(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        listagem_precos_alterados_osv_dados = self.read(cr, uid, ids, [], context=context)
        for x in listagem_precos_alterados_osv_dados:
            local_id = x.get('local_id')
            if isinstance(local_id, (list, tuple)):
                local_id = local_id[0]
            datas = {
                'data': x.get('data'),
                'local_id': local_id,
                'opcao': x.get('opcao'),
                'ordem': x.get('ordem'),
                'tipo_codigo': x.get('tipo_codigo'),
            }
            args = [('data_atualizacao', '>=', x.get('data') + ' 00:00:00'),
                    ('data_atualizacao', '<=', x.get('data') + ' 23:59:59')]
            if x.get('opcao') == 'N':
                ja_listou = False
                args.append(('ja_listou', '=', ja_listou))
            preco_alterado = self.pool.get('automacao.precos').search(cr, uid, args, context=context)
            if not preco_alterado:
                raise osv.except_osv(_('Atencao!'),
                                     _('Nenhum preco encontrado para estes filtros!'))
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'precos_alterados',
            'datas': datas,
        }

