#!/usr/bin/python
# -*- encoding: utf-8 -*-

__author__ = 'tiago.santos'

from openerp.tests.common import TransactionCase
from sigaddons.config_teste import set_config
import time


class TestWizardImpressaoEtiqueta(TransactionCase):
    """
    Classe responsavel por testes unitarios dos metodos da classe wizad_impressao_etiqueta
    :author: Tiago Henrique Prates dos Santos <tiago.santos[at]siginformatica.com.br>
    """

    @classmethod
    def setUpClass(cls):
        set_config()

    def setUp(self):
        super(TestWizardImpressaoEtiqueta, self).setUp()
        self.wizard_impressao_etiqueta = self.registry('wizard.impressao.etiqueta')
        self.automacao_codigo_barra = self.registry('automacao.codigo.barra')
        self.impressao_etiqueta_id = self.cria_impressao_etiqueta()

    def cria_impressao_etiqueta(self):
        modelo_etiqueta_id = self.registry('automacao.modelo.etiqueta').search(
            self.cr, self.uid, [], limit=1)[0]
        codigo_barra_id = self.automacao_codigo_barra.search(self.cr, self.uid, [], limit=1)[0]
        brw_automacao_codigo_barra = self.automacao_codigo_barra.browse(
            self.cr, self.uid, codigo_barra_id)
        produto_id = brw_automacao_codigo_barra.produto_id.id
        grade_id = brw_automacao_codigo_barra.grade_id.id
        vals = {'modelo_etiqueta_id': modelo_etiqueta_id,
                'data_alteracao': time.strftime('%Y-%m-%d'),
                'impressao_etiqueta_itens_ids': [
                    (0, 0, {'produto_id': produto_id, 'grade_id': grade_id, 'qtd_item': 1})]
                }
        return self.wizard_impressao_etiqueta.create(self.cr, self.uid, vals)

    def test_button_print(self):
        res = self.wizard_impressao_etiqueta.button_print(
            self.cr, self.uid, [self.impressao_etiqueta_id])
        self.assertTrue(res)
