# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
import base64
from decimal import Decimal

class automacao_importar_peso(osv.TransientModel):
    _name = "automacao.importar.peso"
    _columns = {
        'autipe_peso_file': fields.binary('Arquivo com pesos', filters='*.txt',
                                  filename='Peso de produtos'),
        'autipe_informacao': fields.text('Informacao'),
    }

    def autipe_button_importar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        brw_capa = self.browse(cr, uid, ids[0], context)
        dict_peso = {}
        # cbs = []
        for i in base64.decodestring(brw_capa.autipe_peso_file).split('\n'):
            if not i:
                continue
            codigo, peso = i.split(';')
            dict_peso[codigo] = peso
            # cbs.append(codigo)

        obj_acb = self.pool.get('automacao.codigo.barra')
        acb_ids = obj_acb.search(cr, uid, [('codigo_barra', 'in', dict_peso.keys())], context=context)

        for i in obj_acb.read(cr, uid, acb_ids, ['id', 'codigo_barra'], context, load='_classic_write'):
            codigo = i.get('codigo_barra')
            peso = Decimal(dict_peso.pop(codigo)) / Decimal(1000)
            obj_acb.write(cr, uid, i.get('id'), {'peso_embalagem': peso}, context=context)
            # cbs.remove(codigo)

        txt = 'Pesos importados com sucesso!'
        if dict_peso:
            txt = 'Itens nao encontrados:\n' + '\n'.join(sorted(dict_peso.keys()))

        self.write(cr, uid, ids, {'autipe_informacao': txt}, context)
