# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _


class wizard_impressao_etiqueta_itens(osv.TransientModel):
    _name = 'wizard.impressao.etiqueta.itens'
    _columns = {
        'wizard_impressao_etiqueta_id': fields.many2one('wizard.impressao.etiqueta',
                                                        'Impressao etiqueta'),
        'produto_id': fields.many2one('estoque.produto', 'Produto'),
        'grade_id': fields.many2one('estoque.produto.grade', 'Grade',domain="[('produto_id', '=', produto_id)]"),
        'qtd_item': fields.integer('Quantidade'),
        'codigo_barra': fields.char('Codigo de barras', size=14),
        'emite_etiqueta': fields.boolean('Emite etiqueta'),
    }
    _defaults = {
        'emite_etiqueta': False,
    }
    _defaults = {
        'qtd_item': 1,
    }

    def on_change_qtd_item(self, cr, uid, ids, qtd_item, context=None):
        context = context and context.copy() or {}
        res = {}
        if isinstance(qtd_item, int):
            if qtd_item <= 0:
                res['warning'] = {'title': _('Atencao'),
                                  'message': _("O valor do campo 'Quantidade' deve ser maior que "
                                               "zero!")}
                qtd = self.browse(cr, uid, ids)[0].qtd_item
                res['value'] = {'qtd_item': qtd}
            else:
                self.write(cr, uid, ids, {'qtd_item': qtd_item}, context=context)
        return res

    def onchange_produto(self, cr, uid, ids, produto_id, context=None):
        context = context and context.copy() or {}
        res = {}
        res['value'] = {'grade_id': False}
        if not produto_id:
            return res

        grade_ids = self.pool.get('estoque.produto').read(cr, uid, produto_id,
                                                          ['produto_grade_ids'], context=context).\
                                                            get('produto_grade_ids')
        if len(grade_ids) == 1:
            res['value'] = {'grade_id': grade_ids[0]}
            return res

        return res


