# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_produto(osv.Model):
    _name = 'estoque.produto'
    _inherit = 'estoque.produto'
    _columns = {
        'produto_de_balanca': fields.boolean('Produto de balanca'), # Identifica o produto como produto de balanca
        'peso_unidade': fields.selection([('P', 'Pesavel'),
                                          ('U', 'Unidade'),
                                          ('N', 'Nao se aplica')], 'Peso unidade', size=1,
                                         required=True),
        'tecla': fields.integer('Tecla'), # Tecla da balanca
        'setor_id': fields.many2one("balanca.setor", 'Setor', ondelete="restrict", select=True),
        'nutricionais_ids': fields.one2many('balanca.nutricionais', 'produto_id', 'Nutricionais'),
        'estpro_receita_titulo': fields.char('Titulo da receita', size=100),
        'estpro_receita_corpo': fields.text('Corpo da receita'),
        'estpro_peso_tara': fields.float('Peso da tara', digits=(1, 3),
                                         help="Peso a ser descontado na balanca para o produto."),
        'estpro_peso_tara_flag': fields.boolean('flag tara'),

    }
    _defaults = {
        'produto_de_balanca': lambda *a: False,
        'peso_unidade': lambda *a: 'N',
    }

