# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
import time


class banfin_pixrec(osv.Model):

    _inherit = 'banfin.pixrec'

    def banfin_pixrec_onchange_conta_id(self, cr, uid, ids, conta_id, context=None):
        context = context and context.copy() or {}
        if not conta_id:
            return {'value': {'banfin_pixrec_image_status':''}}
        conta_brw = self.pool.get('financeiro.tesouraria.contas').browse(cr, uid, conta_id, context=context)
        if not conta_brw.banco_id.admbco_codigo_interno_id:
            return {'warning': {'title': _('Aviso'),
                                'message': _('Conta de tesouraria sem integracao bancaria!')}}
        ret = self.pool.get('bf.integracao').status_get(cr, uid,
            conta_brw.banco_id.admbco_codigo_interno_id.banfin_cdin_codigo_interno,
            conta_id,
            'pixrec',
            context=context)
        return {'value':
                    {
                        'banfin_pixrec_tempo_vida': conta_brw.fintco_bf_pix_tempo_vida,
                        'banfin_pixrec_multa': conta_brw.fintco_bf_pix_multa,
                        'banfin_pixrec_juros': conta_brw.fintco_bf_pix_juros,
                        'banfin_pixrec_desconto': conta_brw.fintco_bf_pix_desconto,
                        'banfin_pixrec_desconto_prazo': conta_brw.fintco_bf_pix_desconto_prazo,
                        'banfin_pixrec_centro_custo_id': conta_brw.fintco_bf_pix_centro_custo_id.id,
                        'banfin_pixrec_evento_id': conta_brw.fintco_bf_pix_evento_id.id,
                        'banfin_pixrec_image_status': ret.get('dados').get('imagem'),
                    },
                }

    def banfin_pixrec_btn_consultar(self, cr, uid, ids, context=None):
        brw_linha = self.browse(cr, uid, ids[0], context=context)
        ret = self.pool.get('bf.integracao').pix_rec_consultar(cr, uid,
               brw_linha.banfin_pixrec_conta_id.banco_id.admbco_codigo_interno_id.banfin_cdin_codigo_interno,
               brw_linha.banfin_pixrec_conta_id.id,
               controle=brw_linha.banfin_pixrec_controle,
               hash=brw_linha.banfin_pixrec_hash,
               context=context)
        if ret.get('status'):
            context['financ_baixar_titulo'] = True
            vals = {
                'state': ret.get('dados').get('situacao'),
            }
            if ret.get('dados').get('hash'):
                vals['banfin_pixrec_hash'] = ret.get('dados').get('hash')
            self.write(cr, uid, ids, vals, context=context)
            if vals.get('state') == 'R':
                self.banfin_pixrec_atualizar_financeiro(cr, uid, ids[0], 'C', context=context)
            if vals.get('state') == 'D':
                self.banfin_pixrec_atualizar_financeiro(cr, uid, ids[0], 'D', context=context)
            return True
        raise osv.except_osv(_('Atencao'), ret.get('mensagem'))

    def banfin_pixrec_btn_devolver(self, cr, uid, ids, context=None):
        brw_linha = self.browse(cr, uid, ids[0], context=context)
        ret = self.pool.get('bf.integracao').pix_devolucao(cr, uid,
                brw_linha.banfin_pixrec_conta_id.banco_id.admbco_codigo_interno_id.banfin_cdin_codigo_interno,
                brw_linha.banfin_pixrec_conta_id.id,
                hash=brw_linha.banfin_pixrec_hash,
                controle=brw_linha.banfin_pixrec_controle,
                valor=brw_linha.banfin_pixrec_valor,
                context=context)
        if ret.get('status'):
            vals = {
                'state': 'D',
            }
            self.write(cr, uid, ids, vals, context=context)
            self.banfin_pixrec_atualizar_financeiro(cr, uid, ids[0], 'D', context=context)
            return True
        raise osv.except_osv(_('Atencao'), ret.get('mensagem'))

    def banfin_pixrec_btn_gerar(self, cr, uid, ids, context=None):
        brw_linha = self.browse(cr, uid, ids[0], context=context)
        ret = self.pool.get('bf.integracao').pix_rec_enviar(cr, uid,
                brw_linha.banfin_pixrec_conta_id.banco_id.admbco_codigo_interno_id.banfin_cdin_codigo_interno,
                brw_linha.banfin_pixrec_conta_id.id,
                brw_linha.banfin_pixrec_valor,
                pessoa_id=brw_linha.banfin_pixrec_pessoa_id.id if brw_linha.banfin_pixrec_pessoa_id else False,
                vencimento=brw_linha.banfin_pixrec_vencimento,
                tempoVida=brw_linha.banfin_pixrec_tempo_vida,
                multa=brw_linha.banfin_pixrec_multa,
                juros=brw_linha.banfin_pixrec_juros,
                desconto=brw_linha.banfin_pixrec_desconto,
                prazoDesconto=brw_linha.banfin_pixrec_desconto_prazo,
                context=context)
        if ret.get('status'):
            vals = {
                'banfin_pixrec_qrcode': ret.get('dados').get('qrcode'),
                'banfin_pixrec_hash': ret.get('dados').get('hash'),
                'banfin_pixrec_controle': ret.get('dados').get('controle'),
                'state': 'P',
                'banfin_pixrec_dh_registro': ret.get('dados').get('datahora'),
            }
            self.write(cr, uid, ids[0], vals, context=context)
            return True
        raise osv.except_osv(_('Atencao'), ret.get('mensagem'))

    def create(self, cr, uid, values, context=None):
        parametro_financeiro = self.pool.get('adm.utils').admutl_get_parametros(cr, uid,
                                                        'financeiro', 'usar_centro_custos_e_eventos', context=context)
        _usar_centro_custos = parametro_financeiro.get('usar_centro_custos_e_eventos')
        if _usar_centro_custos:
            if not (values.get('banfin_pixrec_centro_custo_id') and values.get('banfin_pixrec_evento_id')):
                raise osv.except_osv(_('Atencao'), _('E necessario informar o centro de custo e o evento!'))
        res = super(banfin_pixrec, self).create(cr, uid, values, context=context)
        return res

    def write(self, cr, uid, ids, values, context=None):
        res = super(banfin_pixrec, self).write(cr, uid, ids, values, context=context)
        parametro_financeiro = self.pool.get('adm.utils').admutl_get_parametros(cr, uid,
                                                        'financeiro', 'usar_centro_custos_e_eventos', context=context)
        _usar_centro_custos = parametro_financeiro.get('usar_centro_custos_e_eventos')
        if _usar_centro_custos:
            dados = self.read(cr, uid, ids, [], context=context)
            if isinstance(dados, list):
                dados = dados[0]
            if not (dados.get('banfin_pixrec_centro_custo_id') and dados.get('banfin_pixrec_evento_id')):
                raise osv.except_osv(_('Atencao'), _('E necessario informar o centro de custo e o evento!'))
        return res

    def banfin_pixrec_atualizar_financeiro(self, cr, uid, pixrec_id, creditoDebito, context=None):
        context = context and context.copy() or {}
        pixrecBrw = self.browse(cr, uid, pixrec_id, context=context)
        # Se ja foi lancado, não ha maia nada a fazer
        if creditoDebito =='C':
            _historico = pixrecBrw.banfin_pixrec_descricao
            if pixrecBrw.banfin_pixrec_credito_tesouraria_id:
                return {'status': True, 'mensagem': ''}
        else:
            _historico = '%s (Devolucao)' % pixrecBrw.banfin_pixrec_descricao
            if pixrecBrw.banfin_pixrec_debito_tesouraria_id:
                return {'status': True, 'mensagem': ''}
        vals = {
            'conta_id': pixrecBrw.banfin_pixrec_conta_id.id,
            'data_movimento': time.strftime('%Y-%m-%d'),
            'mes_competencia': time.strftime('%m'),
            'ano_competencia': time.strftime('%Y'),
            'valor': pixrecBrw.banfin_pixrec_valor,
            'historico': _historico,
            'debito_credito': creditoDebito,
            'state': 'A',
        }
        if pixrecBrw.banfin_pixrec_centro_custo_id:
            vals['gerencial_movimento_ids'] = [[0, False, {
                'centro_custo_id': pixrecBrw.banfin_pixrec_centro_custo_id.id,
                'evento_id': pixrecBrw.banfin_pixrec_evento_id.id,
                'valor': pixrecBrw.banfin_pixrec_valor,
                'fingmo_data': time.strftime('%Y-%m-%d'),
                'mes_competencia': time.strftime('%m'),
                'ano_competencia': time.strftime('%Y'),
                'fingmo_historico': _historico,
                'fingmo_operacao': 'E' if creditoDebito == 'C' else 'S',
            }]]

        try:
            self.pool.get('financeiro.tesouraria.movimento').create(cr, uid, vals, context=context)
        except:
            return {'status': False, 'mensagem': _('Nao consegui atualizar o movimento da tesouraria')}
        res = {'status': True, 'mensagem': ''}
        return res

