# -*- encoding: utf-8 -*-
# ##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class banfin_pixrec_notificacoes(osv.Model):

    _inherit = 'banfin.pixrec.notificacoes'

    def banfin_not_pr_btn_processar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = self.banfin_not_pr_processar_notificacoes(cr, uid, ids, context=context)
        if not res.get('status'):
            raise osv.except_osv(_('Atencao'), res.get('mensagem'))
        return res

    def banfin_not_pr_processar_notificacoes(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = {'status': False, 'mensagem': _('Nao encontrei nada para processar')}
        for notiDados in self.read(cr, uid, ids, [], context=context):
            _controle = notiDados.get('banfin_not_pr_controle')
            pixrec_ids = self.pool.get('banfin.pixrec').search(cr, uid, [('banfin_pixrec_controle', '=', str(_controle))],
                                                              context=context, limit=1)
            if not pixrec_ids:
                return {'status': False, 'mensagem': _('Nao encontrei PIX para o controle "%s"') % _controle}
            pixrec_id = pixrec_ids[0]
            pixrecBrw = self.pool.get('banfin.pixrec').browse(cr, uid, pixrec_id, context=context)
            # Verifica se ja foi processado
            if pixrecBrw.state == 'R':
                vals = {
                    'state': 'E',
                }
                self.write(cr, uid, notiDados.get('id'), vals, context=context)
                return {'status': True, 'mensagem': ''}
            context['sig_force'] = pixrecBrw.company_id.id
            vals = {
                'state': 'R'
            }
            self.pool.get('banfin.pixrec').write(cr, uid, [pixrec_id], vals, context=context)
            self.pool.get('banfin.pixrec').banfin_pixrec_atualizar_financeiro(cr, uid, pixrec_id, 'C', context=context)
            vals = {
                'state': 'E',
            }
            self.write(cr, uid, notiDados.get('id'), vals, context=context)
            res = {'status': True, 'mensagem': ''}
        return res

