# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class financeiro_tesouraria_contas(osv.Model):

    _inherit = 'financeiro.tesouraria.contas'
    _columns = {
        'fintco_bf_cod_interno': fields.related('banco_id', 'admbco_codigo_interno', type='char',
                                             string='Codigo Interno', store=False),
        'fintco_bf_pix_tempo_vida': fields.integer('Tempo vida Pix(segundos)'),
        'fintco_bf_pix_multa': fields.float('Multa (%)', digits=(1, 1),
                                            help='Percentual de multa para PIX agendado'),
        'fintco_bf_pix_juros': fields.float('Juros (%)', digits=(1, 1),
                                            help='Percentual de juros para Pix agendado'),
        'fintco_bf_pix_desconto': fields.float('Desconto (%)', digits=(1, 1),
                                               help='Percentual de desconto para Pix agendado pago antecipadamente'),
        'fintco_bf_pix_desconto_prazo': fields.integer('Prazo desconto (dias)',
                                                       help='Quantidade de dias antes do vencimento para conceder o desconto'),
        'fintco_bf_pix_centro_custo_id': fields.many2one("adm.empresa.centrocusto", 'Centro de custo p/Pix',
                                                         ondelete="cascade", select=True),
        'fintco_bf_pix_evento_id': fields.many2one('gerencial.evento', 'Evento p/Pix', ondelete="cascade",
                                                   select=True),
        'fintco_bf_pix_chave_conta': fields.char('Chave Pix da conta', size=64),

    }
    _defaults = {
        'fintco_bf_pix_tempo_vida': 86400,
    }

