# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class banfin_bolrec(osv.Model):

    _name = 'banfin.bolrec'
            
    """
        Classe de historico dos boletos de cobranca
        prefixo: banfin_bolrec
    """
    _columns = {
        'id': fields.integer('Id', readonly=True),
        'create_date': fields.datetime('Data Oper.', readonly=True, select=True),
        'create_uid': fields.many2one('res.users', 'Usuario', readonly=True, select=True),
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'banfin_bolrec_conta_id': fields.many2one('financeiro.tesouraria.contas', 'Conta', select=True,
                                                    domain="[('banco_caixa','=','B')]", ondelete="cascade",
                                                    required=True),
        'banfin_bolrec_operacao': fields.selection([('R', 'Registro'), ('B', 'Baixa'), ('C', 'Cancelamento'),
                                                     ('P', 'Prorrogacao'),('N', 'Negativacao')], 'Operacao', select=True, required=True),
        'banfin_bolrec_pessoa_id': fields.many2one("adm.pessoa", 'Cliente', ondelete="cascade", select=True),
        'banfin_bolrec_titulo_id': fields.many2one("financeiro.titulo", 'Titulo', ondelete="cascade", select=True),
        'banfin_bolrec_emissao': fields.date('Emissao'),
        'banfin_bolrec_vencimento': fields.date('Vencimento'),
        'banfin_bolrec_prorrogacao': fields.date('Prorrogacao'),
        'banfin_bolrec_valor': fields.float('Valor', digits=(9, 2)),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }
    _order = 'id desc'

