# -*- encoding: utf-8 -*-
# ##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class banfin_bolrec_notificacoes(osv.Model):

    _name = 'banfin.bolrec.notificacoes'
    """
        Classe de notificacoes de boletos a receber, recebidas dos bancos
        prefixo: banfin_not_br_
    """
    _rec_name = 'banfin_not_br_codigo_cobranca'
    _columns = {
        'id': fields.integer('Id', readonly=True),
        'banfin_not_br_cod_interno_bc': fields.char('Codigo interno', size=20),
        'banfin_not_br_conta_id': fields.many2one('financeiro.tesouraria.contas', 'Conta tesouraria', select=True, ondelete='cascade'),
        'company_id': fields.many2one("res.company", 'Empresa', select=True, ondelete='cascade'),
        'create_date': fields.datetime('Data', readonly=True),
        'create_uid': fields.many2one('res.users', 'Usuario', ondelete='cascade', select=True, readonly=True),
        'banfin_not_br_codigo_cobranca': fields.char('Codigo Cobranca', size=36, select=True),
        'banfin_not_br_seu_numero': fields.char('Seu Numero', size=30),
        'banfin_not_br_situacao': fields.char('Situacao', size=20), # "A_RECEBER" "MARCADO_RECEBIDO" "RECEBIDO" "CANCELADO" "EXPIRADO"
        'banfin_not_br_data_movimento': fields.datetime('Data/Hora situacao'),
        'banfin_not_br_valor': fields.float('Valor Recebido', digits=(10, 2)),
        'banfin_not_br_origem': fields.char("Origem Recebimento", size=20),
        'banfin_not_br_linha_digitavel': fields.char('Codigo barras', size=48),
        'state': fields.selection([('R', 'Recebido'), ('E', 'Executado'), ('X', 'Erro')], 'Estado', size=1),
        'banfin_not_br_mensagem_erro': fields.text('Mensagem'),
    }
    _defaults = {
        'state': 'R',
    }
    _order = 'id desc'
