##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class banfin_extrato_linhas(osv.Model):

    from funcoes import _banfin_exli_get_conciliado

    _name = 'banfin.extrato.linhas'
    """
        Classe de linhas do extrato de uma conta
        prefixo: banfin_exli_
    """
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'banfin_exli_conta_id': fields.many2one('financeiro.tesouraria.contas', 'Conta', ondelete='cascade',
                                                select=True, required=True),
        'banfin_exli_data': fields.date('Data', select=True),
        'banfin_exli_tipo_transacao': fields.char('Transacao', size=20),
        'banfin_exli_credito_debito': fields.selection([('C', 'Credito'), ('D', 'Debito')], 'Operacao'),
        'banfin_exli_valor': fields.float('Valor', digits=(9, 2)),
        'banfin_exli_historico': fields.text('Historico'),
        'banfin_exli_movimento_id': fields.many2one('financeiro.tesouraria.movimento', 'Movimento', ondelete='cascade',
                                                    select=True),
        'banfin_exli_conciliado': fields.function(_banfin_exli_get_conciliado, method=True, string="Conciliado",
                                                type="boolean", store=True),

    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        'banfin_exli_conciliado': False,
    }
