# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class banfin_pixpag_chaves(osv.Model):

    from funcoes import _banfin_pixpg_ch_name_get
    _name = 'banfin.pixpag.chaves'
    """
        Classe de cadastro de chaves de pix
        prefixo: banfin_pixpg_ch_
    """
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'banfin_pixpg_ch_pessoa_id': fields.many2one("adm.pessoa", 'Pessoa', ondelete="cascade", required=True, select=True),
        'banfin_pixpg_ch_chave_tipo': fields.selection([('C', 'Cpf/Cnpj'),
                                                    ('T', 'Telefone'),
                                                    ('E', 'Email'),
                                                    ('A', 'Aleatoria')],
                                                   'Tipo de chave',
                                                   size=1,
                                                   required=True),
        'banfin_pixpg_ch_chave': fields.char('Chave', size=32, required=True),
        'banfin_pixpg_ch_banco': fields.many2one('adm.banco', 'Banco', ondelete="cascade", required=True, select=True),
        'name': fields.function(_banfin_pixpg_ch_name_get, method=True, string='Bco/Chave', type='char', size=64, store=False)
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }

