# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class banfin_pixpag(osv.Model):

    from funcoes import _banfin_pixpag_get_state

    _name = 'banfin.pixpag'
    """
        Classe de pix pagos 
        prefixo: banfin_pixpag_
    """
    _columns = {
        'id': fields.integer('Id', readonly=True),
        'create_date': fields.datetime('Data Criacao', readonly=True),
        'create_uid': fields.many2one('res.users', 'Usuario', readonly=True, select=True),
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'banfin_pixpag_pessoa_id': fields.many2one("adm.pessoa", 'Pessoa', ondelete="cascade", select=True),
        'banfin_pixpag_chave_id': fields.many2one('banfin.pixpag.chaves', 'Chave', ondelete='set null',
                                                    select=True,
                                                    domain="[('banfin_pixpg_ch_pessoa_id','=',banfin_pixpag_pessoa_id)]"),
        'banfin_pixpag_conta_id': fields.many2one('financeiro.tesouraria.contas', 'Conta', ondelete="cascade",
                                               domain="[('banco_caixa', '=', 'B')]", select=True),
        'banfin_pixpag_descricao': fields.text('Descricao p/o Pix'),
        'banfin_pixpag_valor': fields.float('Valor', digits=(7, 2)),
        'banfin_pixpag_data': fields.date('Data pagamento'),
        'banfin_pixpag_codigo_solicitacao': fields.char('Codigo solicitacao', size=36),
        'banfin_pixpag_codigo_endtoend': fields.char('Codigo autorizacao', size=36),
        'state': fields.selection([('E', 'Esboco'), ('V', 'Enviado'), ('R', 'Realizado'), ('U', 'Recusado')],
                                  'Situacao', size=1),
        'banfin_pixpag_saldo': fields.float('Saldo no banco', digits=(9, 2), store=False),
        'banfin_pixpag_conta_destino_id': fields.many2one('financeiro.tesouraria.contas', 'Conta Destino',
                                                        ondelete="cascade", domain="[('banco_caixa', '=', 'B')]",
                                                        help='Conta de destino da tesouraria, caso seja transferencia entre contas',
                                                        select=True),
        'banfin_pixpag_historico': fields.char('Historico SigERP', size=64, required=True),
        'banfin_pixpag_evento_id': fields.many2one("gerencial.evento", 'Evento', ondelete="restrict", select=True),
        'banfin_pixpag_centro_custo_id': fields.many2one("adm.empresa.centrocusto", 'Centro de custo',
                                           ondelete="restrict", select=True),
        'banfin_pixpag_image_status': fields.function(_banfin_pixpag_get_state, method=True, string='Status',
                                                      type='binary', store=False),
        'banfin_pixpag_credito_tesouraria_id': fields.many2one('financeiro.tesouraria.movimento',
                                                               'Lancamento a credito',
                                                               ondelete="set null", select=True),
        'banfin_pixpag_debito_tesouraria_id': fields.many2one('financeiro.tesouraria.movimento',
                                                              'Lancamento a debito',
                                                              ondelete="set null", select=True),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        'banfin_pixpag_data': lambda *a: time.strftime('%Y-%m-%d'),
        'state': 'E'
    }
    _order = 'id desc'

