# -*- encoding: utf-8 -*-
# ##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class banfin_pixpag_notificacoes(osv.Model):

    _name = 'banfin.pixpag.notificacoes'
    """
        Classe de notificacoes recebidas dos bancos
        prefixo: banfin_not_pp_
    """
    _rec_name = 'banfin_not_pp_controle'
    _columns = {
        'banfin_not_pp_cod_interno_bc': fields.char('Codigo interno', size=20),
        'banfin_not_pp_conta_corrente': fields.char('Conta corrente', size=20),
        'id': fields.integer('Id', readonly=True),
        'company_id': fields.many2one("res.company", 'Empresa', select=True, ondelete='cascade'),
        'create_date': fields.datetime('Data', readonly=True),
        'create_uid': fields.many2one('res.users', 'Usuario', ondelete='cascade', select=True, readonly=True),
        'banfin_not_pp_controle': fields.char('Controle', size=36, select=True),
        'banfin_not_pp_endtoend': fields.char('EndToEnd', size=36),
        'banfin_not_pp_chave': fields.char("Chave", size=64),
        'banfin_not_pp_data_movimento': fields.datetime('Data/Hora movimento'),
        'state': fields.selection([('R', 'Recebido'), ('E', 'Executado'), ('X', 'Erro')], 'Estado', size=1),
        'banfin_not_pp_mensagem_erro': fields.text('Mensagem'),
        'banfin_not_pp_recebedor_nome': fields.char('Recebedor', size=64),
        'banfin_not_pp_recebedor_cnpj': fields.char('Cpf/Cnpj', size=14),
        'banfin_not_pp_valor': fields.float('Valor', digits=(10, 2)),
        'banfin_not_pp_status': fields.char('Status da operacao', size=20),
        'banfin_not_pp_tipomovimento': fields.char('Tipo de movimento', size=20),
    }
    _defaults = {
        'state': 'R',
    }
    _order = 'id desc'
