# -*- encoding: utf-8 -*-
# ##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class banfin_pixrec_notificacoes(osv.Model):

    _name = 'banfin.pixrec.notificacoes'
    """
        Classe de notificacoes recebidas dos bancos
        prefixo: banfin_not_pr_
    """
    _rec_name = 'banfin_not_pr_controle'
    _columns = {
        'id': fields.integer('Id', readonly=True),
        'create_date': fields.datetime('Data', readonly=True),
        'create_uid': fields.many2one('res.users', 'Usuario', ondelete='cascade', select=True, readonly=True),
        'banfin_not_pr_controle': fields.char('Controle', size=36),
        'banfin_not_pr_tipo': fields.selection([('R', 'Registro'), ('D', 'Devolucao')], 'Registro/Devolucao', size=1),
        'state': fields.selection([('R', 'Recebido'), ('E', 'Executado'), ('X', 'Erro')], 'Estado', size=1),
        'banfin_not_pr_mensagem_erro': fields.text('Mensagem'),
    }
    _defaults = {
        'state': 'R',
    }
    _order = 'id desc'
