# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class banfin_titulo_pag_historicos(osv.Model):

    _name = 'banfin.titulo.pag.historicos'
    """
        Classe de pagamentos de titulo
        prefixo: banfin_tipg_hs_
    """
    _columns = {
        'id': fields.integer('Id', readonly=True),
        'create_date': fields.datetime('Data Criacao', readonly=True),
        'create_uid': fields.many2one('res.users', 'Usuario', readonly=True, select=True),
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'banfin_tipg_hs_pessoa_id': fields.many2one("adm.pessoa", 'Pessoa', ondelete="cascade", select=True),
        'banfin_tipg_hs_conta_id': fields.many2one('financeiro.tesouraria.contas', 'Conta', ondelete="cascade",
                                                    domain="[('banco_caixa', '=', 'B')]", select=True),
        'banfin_tipg_hs_descricao': fields.text('Descricao p/o Pix'),
        'banfin_tipg_hs_valor': fields.float('Valor', digits=(7, 2)),
        'banfin_tipg_hs_data': fields.date('Data'),
        'state': fields.selection([('A', 'Aguardando autorizacao'), ('T', 'Autorizado'), ('N', 'Nao autorizado')],
                                  'Situacao', size=1),
        'banfin_tipg_hs_autorizacao_data': fields.datetime('Data Autorizacao', readonly=True),
        'banfin_tipg_hs_autorizacao_uid': fields.many2one('res.users', 'Autorizado por', readonly=True, select=True),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        'banfin_tipg_hs_data': lambda *a: time.strftime('%Y-%m-%d'),
        'state': 'A'
    }
    _order = 'id desc'

