# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time
from openerp.tools.translate import _

class wiz_banfin_saldos(osv.TransientModel):

    _name = 'wiz.banfin.saldos'
    """
        Classe de Wizard para consulta de saldos
        prefixo: wiz_banfin_sald_
    """
    _columns = {
        'wiz_banfin_sald_conta_id': fields.many2one('financeiro.tesouraria.contas', 'Conta', ondelete="cascade",
                                                    domain="[('banco_caixa', '=', 'B')]", select=True, required=True),
        'wiz_banfin_sald_saldo': fields.float('Valor', digits=(9, 2)),
        'wiz_banfin_sald_bloqueado': fields.float('Bloqueado', digits=(9, 2)),
        'wiz_banfin_sald_disponivel': fields.float('Disponivel', digits=(9, 2)),
        'wiz_banfin_sald_data': fields.date('Data'),
    }
    _defaults = {
        'wiz_banfin_sald_data': lambda *a: time.strftime('%Y-%m-%d'),
        'wiz_banfin_sald_saldo': 0.0,
    }

    def banfin_wiz_saldos_btn_consultar(self, cr, uid, ids, context=None):
        dados_read = self.read(cr, uid, ids[0], ['wiz_banfin_sald_conta_id', 'wiz_banfin_sald_data'], context=context)
        conta_id = dados_read.get('wiz_banfin_sald_conta_id')[0]
        _data = dados_read.get('wiz_banfin_sald_data')
        conta_brw = self.pool.get('financeiro.tesouraria.contas').browse(cr, uid, conta_id, context=context)
        ret = self.pool.get('bf.integracao').bank_get_saldo(cr, uid,
                                          conta_brw.banco_id.admbco_codigo_interno_id.banfin_cdin_codigo_interno,
                                          conta_id,
                                          _data,
                                          context=context)
        if ret.get('status'):
            saldoDisponivel = ret.get('dados').get('saldoDisponivel')
            saldo = ret.get('dados').get('saldo')
            bloqueado = saldo - saldoDisponivel
            vals = {
                'wiz_banfin_sald_disponivel': saldoDisponivel,
                'wiz_banfin_sald_bloqueado': bloqueado,
                'wiz_banfin_sald_saldo': saldo
            }
            self.write(cr, uid, ids[0], vals, context=context)
            return True
        if ret.get('mensagem'):
            _msg = ret.get('mensagem')
        else:
            _msg = _('Nao consegui conectar com o banco!')
        raise osv.except_osv(_('Atencao'), _msg)


    def banfin_onchange_conta_id(self, cr, uid, ids, conta_id, context=None):
        context = context and context.copy() or {}
        res = {'value': {'wiz_banfin_sald_saldo': 0.0}}
        if not conta_id:
            return res
        conta_brw = self.pool.get('financeiro.tesouraria.contas').browse(cr, uid, conta_id, context=context)
        if not conta_brw.banco_id.admbco_codigo_interno_id:
            return {'warning': {'title': _('Aviso'),
                                'message': _('Conta de tesouraria sem integracao bancaria!')}}
        return res
