# -*- encoding: utf-8 -*-
from openerp import pooler
from openerp.tools.translate import _
from openerp.tools import config
import openerp.addons.web.http as http
from SigUtils.geralogs import geraLogs
from SigUtils import datas, numero, formatastring
from SigUtils.sigerp import db_sig
import re
import uuid
from urllib import urlencode
import json
import requests
import base64
import tempfile
from logging import getLogger
from ..adm.control.utils import admConfiguracao
import xmlrpclib, socket
from datetime import datetime, timedelta

_logger = getLogger("Inter")

class sc_contrecf(http.Controller):
    _cp_path = '/bc/inter'

    @http.httprequest
    def teste(self, req, s_action=None, **kw):
        ip = req.httprequest.environ.get('REMOTE_ADDR')
        print(ip)
        return 'Resposta Teste: ' + ip

    @http.httprequest
    def bolrec(self, req, s_action=None, **kw):
        _cc = req.httprequest.environ.get('HTTP_X_CONTA_CORRENTE', False)
        _logger.info('===> BolRec Params: %s   Data:%s   CC:%s' % (req.params, req.httprequest.data, _cc))
        if not _cc:
            _logger.info('===> Nao consegui identificar a conta corrente!')
            return 'Ok'
        db = req.params.get('db')
        data = json.loads(req.httprequest.data)
        cfg = admConfiguracao('bancos_financeiro', db, cripto=True)
        host = 'http://localhost:%s' % cfg.sigerp_porta
        _server = ('%s/xmlrpc/common' % host)
        sock_common = xmlrpclib.ServerProxy(_server)
        socket.setdefaulttimeout(15)
        uid = sock_common.login(db, cfg.sigerp_user, cfg.sigerp_password)
        _server = ('%s/xmlrpc/object' % host)
        sock = xmlrpclib.ServerProxy(_server)
        _db_sig = db_sig(db, host=cfg.db_host, port=cfg.db_port, pwd=cfg.db_password, user=cfg.db_user)
        _contasDados = _db_sig.dbsSelect('financeiro_tesouraria_contas', ['id', 'company_id'],
                                      [('fintco_bf_inter_conta', '=', _cc)])
        _db_sig.conexao.close()
        if not _contasDados:
            _logger.info('===> Nao consegui identificar a empresa para a conta corrente: %s!' % _cc)
            return 'Ok'
        _company_id = _contasDados[0].get('company_id')
        context = {'sig_force_company': _company_id}
        _conta_id = _contasDados[0].get('id')
        for linha in data:
            vals = {
                'banfin_not_br_cod_interno_bc': 'inter',
                'banfin_not_br_conta_id': _conta_id or '',
                'company_id': _company_id,
                'banfin_not_br_codigo_cobranca': linha.get('codigoSolicitacao'),
                'banfin_not_br_seu_numero': linha.get('seuNumero'),
                'banfin_not_br_situacao':  linha.get('situacao'),
                'banfin_not_br_data_movimento': linha.get('dataHoraSituacao').replace('T', ' ').replace('Z', ''),
                'banfin_not_br_valor': linha.get('valorTotalRecebido', 0),
                'banfin_not_br_origem': linha.get('origemRecebimento', ''),
                'banfin_not_br_linha_digitavel': linha.get('linhaDigitavel'),
            }
            """
            situações disponiveis:
            "A_RECEBER" "MARCADO_RECEBIDO" "RECEBIDO" "CANCELADO" "EXPIRADO"
            """
            not_id = sock.execute(db, uid, cfg.sigerp_password,
                                  'banfin.bolrec.notificacoes',
                                  'create',
                                  vals,
                                  context)
            ret = sock.execute(db, uid, cfg.sigerp_password,
                               'banfin.bolrec.notificacoes',
                               'banfin_not_br_processar_notificacoes',
                               [not_id],
                               context)
            if not ret.get('status'):
                vals = {
                    'state': 'X',
                    'banfin_not_br_mensagem_erro': ret.get('mensagem'),
                }
                sock.execute(db, uid, cfg.sigerp_password,
                             'banfin.bolrec.notificacoes',
                             'write',
                             not_id,
                             vals,
                             context)
                _logger.info('===> Nao consegui processar a notificacao! Erro: %s' % ret.get('mensagem'))
        return 'Ok'

    @http.httprequest
    def pixpag(self, req, s_action=None, **kw):
        _cc = req.httprequest.environ.get('HTTP_X_CONTA_CORRENTE', False)
        _logger.info('===> PixPag Params: %s   Data:%s   CC: %s' % (req.params, req.httprequest.data, _cc))
        if not _cc:
            _logger.info('===> Nao consegui identificar a conta corrente!')
            return 'Ok'
        db = req.params.get('db')
        data = json.loads(req.httprequest.data or '{}')
        cfg = admConfiguracao('bancos_financeiro', db, cripto=True)
        host = 'http://localhost:%s' % cfg.sigerp_porta
        _server = ('%s/xmlrpc/common' % host)
        sock_common = xmlrpclib.ServerProxy(_server)
        socket.setdefaulttimeout(15)
        uid = sock_common.login(db, cfg.sigerp_user, cfg.sigerp_password)
        _server = ('%s/xmlrpc/object' % host)
        sock = xmlrpclib.ServerProxy(_server)
        _db_sig = db_sig(db, host=cfg.db_host, port=cfg.db_port, pwd=cfg.db_password, user=cfg.db_user)
        _company_id = _db_sig.dbsSelect('financeiro_tesouraria_contas', ['company_id'],
                                      [('fintco_bf_inter_conta', '=', _cc)])
        _db_sig.conexao.close()
        if not _company_id:
            _logger.info('===> Nao consegui identificar a empresa para a conta corrente: %s!' % _cc)
            return 'Ok'
        _company_id = _company_id[0].get('company_id')
        context = {'sig_force_company': _company_id}
        for linha in data:
            codigoSolicitacao = linha.get('codigoSolicitacao')
            vals = {
                'banfin_not_pp_cod_interno_bc': 'inter',
                'company_id': _company_id,
                'banfin_not_pp_conta_corrente': _cc,
                'banfin_not_pp_controle': codigoSolicitacao,
                'banfin_not_pp_endtoend': linha.get('endToEnd'),
                'state': 'R',
                'banfin_not_pp_mensagem_erro': '',
                'banfin_not_pp_chave': linha.get('chave', ''),
                'banfin_not_pp_data_movimento': linha.get('dataHoraMovimento')[:19].replace('T', ' '),
                'banfin_not_pp_recebedor_nome': linha.get('recebedor').get('nome'),
                'banfin_not_pp_recebedor_cnpj': linha.get('recebedor').get('cpfCnpj'),
                'banfin_not_pp_valor': linha.get('valor'),
                'banfin_not_pp_status': linha.get('status'),
                'banfin_not_pp_tipomovimento': linha.get('tipoMovimentacao'),
            }
            not_id = sock.execute(db, uid, cfg.sigerp_password,
                                  'banfin.pixpag.notificacoes',
                                  'create',
                                  vals,
                                  context)
            ret = sock.execute(db, uid, cfg.sigerp_password,
                               'banfin.pixpag.notificacoes',
                               'banfin_not_pp_processar_notificacoes',
                               [not_id],
                               context)
            if not ret.get('status'):
                vals = {
                    'state': 'X',
                    'banfin_not_pp_mensagem_erro': ret.get('mensagem'),
                }
                sock.execute(db, uid, cfg.sigerp_password,
                             'banfin.pixpag.notificacoes',
                             'write',
                             not_id,
                             vals,
                             context)
                _logger.info('===> Nao consegui processar a notificacao! Erro: %s' % ret.get('mensagem'))
        return 'Ok'

    @http.httprequest
    def pixrec(self, req, s_action=None, **kw):
        _cc = req.httprequest.environ.get('HTTP_X_CONTA_CORRENTE', False)
        _logger.info('===> PixRec Params: %s   Data:%s   CC:%s' % (req.params, req.httprequest.data, _cc))
        db = req.params.get('db')
        data = json.loads(req.httprequest.data)
        controle = data.get('pix')[0].get('txid') or None
        cfg = admConfiguracao('bancos_financeiro', db, cripto=True)
        host = 'http://localhost:%s' % cfg.sigerp_porta
        _server = ('%s/xmlrpc/common' % host)
        sock_common = xmlrpclib.ServerProxy(_server)
        socket.setdefaulttimeout(15)
        uid = sock_common.login(db, cfg.sigerp_user, cfg.sigerp_password)
        _server = ('%s/xmlrpc/object' % host)
        sock = xmlrpclib.ServerProxy(_server)
        _db_sig = db_sig(db, host=cfg.db_host, port=cfg.db_port, pwd=cfg.db_password, user=cfg.db_user)
        _contasDados = _db_sig.dbsSelect('financeiro_tesouraria_contas', ['id', 'company_id'],
                                      [('fintco_bf_inter_conta', '=', _cc)])
        _db_sig.conexao.close()
        if not _contasDados:
            _logger.info('===> Nao consegui identificar a empresa para a conta corrente: %s!' % _cc)
            return 'Ok'
        _company_id = _contasDados[0].get('company_id')
        context = {'sig_force_company': _company_id}
        if controle:
            vals = {
                'banfin_not_pr_controle': controle,
                'state': 'R',
                'banfin_not_pr_mensagem_erro': '',
                'banfin_not_pr_tipo': 'R',
            }
            not_id = sock.execute(db, uid, cfg.sigerp_password,
                  'banfin.pixrec.notificacoes',
                  'create',
                  vals,
                  context)
            ret = sock.execute(db, uid, cfg.sigerp_password,
                    'banfin.pixrec.notificacoes',
                    'banfin_not_pr_processar_notificacoes',
                    [not_id],
                    context)
            if not ret.get('status'):
                vals = {
                    'state': 'X',
                    'banfin_not_pr_mensagem_erro': ret.get('mensagem'),
                }
                sock.execute(db, uid, cfg.sigerp_password,
                      'banfin.pixrec.notificacoes',
                      'write',
                      not_id,
                      vals,
                      context)
                _logger.info('===> Nao consegui processar a notificacao! Erro: %s' % ret.get('mensagem'))
        return 'Ok'


class Inter(object):
    def __init__(self, cr=False, uid=False, conta_id=False, context=None):
        self.API_URL_PRODUCAO = 'https://cdpj.partners.bancointer.com.br'
        self.API_URL_HOMOLOGACAO = ''
        self.cr = cr
        self.uid = uid
        self.status = True
        self.mensagem = ''
        _poolget = pooler.get_pool(cr.dbname).get
        args = [('id', '=', conta_id)]
        conta_ids = _poolget('financeiro.tesouraria.contas').search(cr, uid, args, context=context)
        if not conta_ids:
            self.status = False
            self.mensagem = _('Nao encontrei a conta informada')
            return
        conta_brw = _poolget('financeiro.tesouraria.contas').browse(cr, uid, conta_ids[0], context=context)
        escopos_ids = _poolget('banfin.inte.escopos').search(cr, uid, [], context=context)
        escopos_brw =_poolget('banfin.inte.escopos').browse(cr, uid, escopos_ids, context=context)
        self.conta_id = conta_id
        self.conta = conta_brw.fintco_bf_inter_conta
        self.client_id = conta_brw.fintco_bf_inter_id_client
        self.client_secret = conta_brw.fintco_bf_inter_client_secret
        self.token = conta_brw.fintco_bf_inter_token
        self.escopos = ' '.join([x.banfin_inte_codigo for x in escopos_brw])
        self.homologacao_producao = conta_brw.banco_id.admbco_producao_homogacao
        if self.homologacao_producao == 'H':
            self.status = False
            self.mensagem = _('Banco Inter nao tem ambiente de homologacao')
            return
        self.habilitar_log = conta_brw.banco_id.admbco_habilitar_logs
        self.certificado = conta_brw.fintco_bf_inter_certificado
        self.certificado_key = conta_brw.fintco_bf_inter_certificado_key
        self.certificado_webhook = conta_brw.fintco_bf_inter_certificado_webhook
        self.pix_chave = conta_brw.fintco_bf_pix_chave_conta
        self.urlCallback = conta_brw.fintco_bf_inter_url_callback

    def _get_arq_log(self):
        _arq_log = 'inter_' + self.cr.dbname
        return _arq_log

    def _gerar_logs(self, mens):
        _diretorio = config.get('logfile')
        if _diretorio:
            _lista = _diretorio.split('/')
            _lista.pop(len(_lista) -1)
            _diretorio = '/'.join(_lista)
        else:
            _diretorio = '/var/log/openerp'
        _arq_log = self._get_arq_log()
        try:
            geraLogs(_arq_log, mens, 'S', _diretorio)
        except:
            try:
                geraLogs(_arq_log, mens.encode('ASCII', 'ignore'), 'S', _diretorio)
            except:
                geraLogs(_arq_log, _('Nao consegui registrar o log'), 'S', _diretorio)
        return True


    def make_path(self, path, params={}):
        # Making Path and add a leading / if not exist
        if self.homologacao_producao == 'H':
            _url = self.API_URL_HOMOLOGACAO
        else:
            _url = self.API_URL_PRODUCAO

        if not (re.search("^http", path)):
            if not (re.search("^\/", path)):
                path = "/" + path
            path = _url + path
        if params:
            path = path + "?" + urlencode(params)
        return path


    def inter_comunicar(self, metodo, url, json=None, data=None, params={}, headers={}):
        def comunicar():
            if self.habilitar_log:
                self._gerar_logs('Inter.%s-> URL:%s -> JSON:%s -> DATA: %s ->HEADERS:%s -> PARAMS:%s' %
                                 (metodo, url, str(json), str(data), _headers, str(params)))
            try:
                nome_arq_certificado = tempfile.NamedTemporaryFile('w', dir='/dev/shm', suffix='.crt')
                nome_arq_certificado.write(base64.b64decode(self.certificado))
                nome_arq_certificado.flush()
                nome_arq_certificado_key = tempfile.NamedTemporaryFile('w', dir='/dev/shm', suffix='.key')
                nome_arq_certificado_key.write(base64.b64decode(self.certificado_key))
                nome_arq_certificado_key.flush()
                _cert = (nome_arq_certificado.name, nome_arq_certificado_key.name)
            except:
                _cert = None
            response = requests.request(metodo, url, json=json, data=data, params=params, headers=_headers, cert=_cert)
            nome_arq_certificado.close()
            nome_arq_certificado_key.close()
            if self.habilitar_log:
                self._gerar_logs(_('Inter.resposta--> %s-%s ') % (response.status_code, response.content))
            return response

            # return resp

        _headers = {
            'x-conta-corrente': self.conta,
        }
        _headers.update(headers)
        url = self.make_path(url)
        metodo = metodo.upper()
        response = comunicar()
        if response.status_code in (401, 403):
            res = self.inter_get_token()
            _headers.update({'AUTHORIZATION': 'Bearer %s' % self.token})
            response = comunicar()
        return response

    def get_callback(self, rota):
        """
        Metodo para retornar a url de callback
        :param rota: roda a ser adicionada à url de callback
        :type rota: str
        :return: Url completa para callback
        :rtype: str
        """
        _url = self.urlCallback.strip()
        _rota = rota.strip()
        if _url[-1:] == '/':
            _url = _url[:-1]
        if _rota[:1] != '/':
            _rota = '/' + _rota
        return _url + _rota

    def get_headers_bearer(self):
        if not self.token:
            res = self.inter_get_token()
            if res.get('status'):
                self.token = res.get('dados').get('access_token')
                pooler.get_pool(self.cr.dbname).get('financeiro.tesouraria.contas').write(self.cr, self.uid,
                                                                                          self.conta_id,
                                                                                        {'fintco_bf_inter_token': self.token})
        headers = {
            'AUTHORIZATION': 'Bearer %s' % self.token
        }

        return headers

    def inter_pix_rec_enviar(self, controle, valor, tempoVida):
        """
        Endpoint para realização de Pix instantaneo(a receber)
        :param controle: codigo de controle da transacao
        :type controle: str
        :param valor: valor a receber
        :type valor: float
        :param tempoVida: tempo de vida da transacao em segundos
        :type tempoVida: int
        :return: {'status': True/False, 'mensagem': '', dados: ''}
        """

        # Validando dados
        if not controle:
            return {'status': False, 'mensagem': _('Falta a identificacao da transacao!')}
        if not valor:
            return {'status': False, 'mensagem': _('Falta o valor da transacao.')}
        if not tempoVida:
            return {'status': False, 'mensagem': _('Falta o tempo de vida da transacao.')}
        vals = {
            'calendario': {
                'expiracao': tempoVida,
            },
            'loc': {
                'tipoCob': 'COB',
            },
            "valor": {
                'original': numero.getNumeroEditado(valor, 2, '.', '',),
                'modalidadeAlteracao': 0,
            },
            'chave': self.pix_chave,
        }
        metodo = 'PUT'
        url = '/pix/v2/cob/%s' % controle
        headers = self.get_headers_bearer()
        res = self.inter_comunicar(metodo, url, json=vals, headers=headers)
        if res.ok:
            return {'status': True, 'dados': json.loads(res.text)}
        _mens = json.loads(res.text)
        if _mens.get('message'):
            _mens = _mens.get('message')
        return {'status': False, 'mensagem': _mens, 'status_code': res.status_code}

    def inter_pix_rec_consultar(self, controle):
        """
        Endpoint para realização da consulta da situacao do Pix
        :param controle: Codigo de controle da transacao
        :type controle: str
        return {'status': True/False, 'mensagem': '', dados: ''}
        """
        # Validando dados
        if not controle:
            return {'status': False, 'mensagem': _('Falta a identificacao da transacao!')}
        vals = {
        }
        metodo = 'GET'
        url = '/pix/v2/cob/%s' % controle
        headers = self.get_headers_bearer()
        res = self.inter_comunicar(metodo, url, json=vals, headers=headers)
        if res.ok:
            return {'status': True, 'dados': json.loads(res.text)}
        _mens = json.loads(res.text)
        # statusCode = res.status_code
        if _mens.get('title'):
            _mens = _mens.get('title')
        return {'status': False, 'mensagem': _mens, 'status_code': res.status_code}

    def inter_pix_rec_devolucao(self, hash, controle, valor):
        """
        Endpoint para realização da devolucao de um Pix instantaneo
        :param hash: Codigo de e2eId da transacao
        :type hash: str
        :param controle: Codigo de controle da transacao
        :type controle: str
        :param valor: Valor da transacao a devolver
        :type valor: float
        return {'status': True/False, 'mensagem': '', dados: ''}
        """

        # Validando dados
        if not hash:
            return {'status': False, 'mensagem': _('Falta o hash de identificacao do Pix')}
        if not controle:
            return {'status': False, 'mensagem': _('Falta o controle da transacao')}
        vals = {
            "valor": numero.getNumeroEditado(valor, 2, '.', '',),
            "natureza": "ORIGINAL"
        }
        metodo = 'PUT'
        url = '/pix/v2/pix/%s/devolucao/%s' % (hash, controle)
        headers = self.get_headers_bearer()
        res = self.inter_comunicar(metodo, url, json=vals, headers=headers)
        if res.ok:
            return {'status': True, 'dados': json.loads(res.text)}
        ret = json.loads(res.text)
        if ret.get('message'):
            _mens = ret.get('message')
        else:
            _mens = res.text
        return {'status': False, 'mensagem': _mens, 'status_code': res.status_code}

    def inter_pix_rec_agendamento(self, controle, valor, vencimento, dadosPessoa=None, multa=None,
                                                       juros=None, desconto=None, prazoDesconto=None):
        """
        Endpoint para realização de Pix agendado (cobranca com vencimento)
        :param controle: codigo de controle da transacao
        :type controle: str
        :param valor: Valor da transacao
        :type valor: float
        :param vencimento: Data de vencimento da cobranca
        :type vencimento: str
        :param dadosPessoa: dados da pessoa
        :type dadosPessoa: dict
        :param multa: valor da multa
        :type multa: float
        :param juros: Valor do juros
        :type juros: float
        :param desconto: valor dos juros
        :type desconto: float
        :param prazoDesconto: prazo para desconto
        :type prazoDesconto: int
        return {'status': True/False, 'mensagem': '', dados: ''}
        """

        # Validando dados
        if not vencimento:
            return {'status': False, 'mensagem': _('Falta o vencimento do PIX ')}
        if not valor:
            return {'status': False, 'mensagem': _('Falta o valor da transacao.')}
        _dataDesconto = datas.calcVencimento(vencimento, (prazoDesconto * -1))
        vals = {
            'calendario': {
                'dataDeVencimento': datas.getDataNoFormato(vencimento, 'I', '-'),
                'validadeAposVencimento': 30,
            },
            'valor': {
                'original': numero.getNumeroEditado(valor, 2, '.', '',),
                'multa': {
                    'modalidade': 2,
                    'valorPerc': numero.getNumeroEditado(multa, 2, '.', '',),
                },
                'juros': {
                    'modalidade': 3,
                    'valorPerc': numero.getNumeroEditado(juros, 2, '.', '', ),
                },
                'descontos': {
                    'modalidade': 2,
                    'descontoDataFixa': {
                        'valorPerc': numero.getNumeroEditado(juros, 2, '.', '', ),
                        'data': datas.getDataNoFormato(_dataDesconto, 'I', '-'),
                    },
                },
            },
            'chave': self.pix_chave,
        }
        if dadosPessoa.get('nome'):
            _cpfCnpj = re.sub('[^0-9]', u'', dadosPessoa.get('cpfCnpj'))
            vals['devedor'] = {
                'nome': dadosPessoa.get('nome')
            }
            if dadosPessoa.get('pessoaTipo') == 'F':
                vals['devedor']['cpf'] = formatastring.formataString(_cpfCnpj, 11, "0", alinhamento="D")
            else:
                vals['devedor']['cnpj'] = formatastring.formataString(_cpfCnpj, 14, "0", alinhamento="D")
        metodo = 'PUT'
        url = '/pix/v2/cobv/%s' % controle
        headers = self.get_headers_bearer()
        res = self.inter_comunicar(metodo, url, data=vals, headers=headers)
        if res.ok:
            return {'status': True, 'dados': json.loads(res.text)}
        return {'status': False, 'mensagem': json.loads(res.text), 'status_code': res.status_code}

    def inter_pix_pag_consultar(self, endToEnd, controle):
        """
        Endpoint para realização da consulta de um Pix de pagamento
        :param endToEnd: endToEnd da transacao
        :type endToEnd: str
        :param controle: Codigo de controle da transacao
        :type controle: str
        return {'status': True/False, 'mensagem': '', dados: ''}
        """
        # if not endToEnd:
        #     return {'status': False, 'mensagem': _('Falta a identificacao da transacao!')}
        _final = datetime.now()
        data_hora_fim = pooler.get_pool(self.cr.dbname).get('adm.utils').admutl_datetime_to_timezone(self.cr, self.uid, _final, formato='%Y-%m-%d %H:%M:%S')
        _final = datetime.strptime(data_hora_fim, '%Y-%m-%d %H:%M:%S')
        data_hora_inicio = str(_final - timedelta(days=15))
        data_hora_inicio = data_hora_inicio.replace(' ', 'T') + '.000Z'
        data_hora_fim = data_hora_fim.replace(' ', 'T') + '.000Z'
        res = self.inter_pix_pag_consultarCallbacks(data_hora_inicio, data_hora_fim, endToEnd)
        if not res.get('status'):
            return res
        _dados = res.get('dados')
        retorno = ''
        for linha in _dados.get('data'):
            if linha.get('payload'):
                for payload in linha.get('payload'):
                    if payload.get('codigoSolicitacao') != controle:
                        continue
                    retorno = payload
                    break
        return {'status': True, 'dados': retorno}

    def inter_pix_pag_consultarCallbacks(self, data_hora_inicio, data_hora_fim, endToEnd):
        """
        Endpoint para realização da consulta da situacao do Pix de pagamento
        :param data_hora_inicio: data e hora de inicio para filtro da pesquina
        :type data_hora_inicio: str
        :param data_hora_fim: data e hora de fim para filtro da pesquina
        :type data_hora_fim: str
        :param endToEnd: Codigo de controle da transacao
        :type endToEnd: str
        return {'status': True/False, 'mensagem': '', dados: ''}
        """
        # Validando dados
        if not data_hora_inicio:
            return {'status': False, 'mensagem': _('Falta a data/hora inicial!')}
        if not data_hora_fim:
            return {'status': False, 'mensagem': _('Falta a data/hora final!')}
        # if not endToEnd:
        #     return {'status': False, 'mensagem': _('Falta a identificacao da transacao!')}
        vals = {
            'dataHoraInicio': data_hora_inicio,
            'dataHoraFim': data_hora_fim,
            'pagina': 0,
            'tamanhoPagina': 50,
        }
        if endToEnd:
            vals['endToEnd'] = endToEnd
        metodo = 'GET'
        url = '/banking/v2/webhooks/pix-pagamento/callbacks'
        headers = self.get_headers_bearer()
        res = self.inter_comunicar(metodo, url, params=vals, headers=headers)
        if res.ok:
            return {'status': True, 'dados': json.loads(res.text)}
        _mens = json.loads(res.text)
        # statusCode = res.status_code
        if _mens.get('title'):
            _mens = _mens.get('title')
        return {'status': False, 'mensagem': _mens, 'status_code': res.status_code}

    def inter_pix_pag_incluir(self, chave, valor, descricao=None, data=None):
        """
        Endpoint para realização de Pix para pagamento
        :param chave: Chave paga pagamento do pix
        :type chave: str
        :param valor: Valor da transacao
        :type valor: float
        :param descricao: Data de vencimento da cobranca
        :type descricao: str
        :param data: data do pagamento
        :type data: str
        return {'status': True/False, 'mensagem': '', dados: ''}
        """

        # Validando dados
        if not chave:
            return {'status': False, 'mensagem': _('Falta a chave para pagamento do PIX ')}
        if not valor:
            return {'status': False, 'mensagem': _('Falta o valor da transacao.')}
        _controle = str(uuid.uuid4())
        vals = {
            'valor': numero.getNumeroEditado(valor, 2, '.', ''),
            'destinatario': {
                'tipo': 'CHAVE',
                'chave': chave,
            },
        }
        if descricao:
            vals['descricao'] = descricao
        if data:
            vals['dataPagamento'] = datas.getDataNoFormato(data, 'I', '-')
        metodo = 'POST'
        url = '/banking/v2/pix'
        headers = self.get_headers_bearer()
        headers['x-id-idempotente'] = _controle
        res = self.inter_comunicar(metodo, url, json=vals, headers=headers)
        if res.ok:
            _dados = json.loads(res.text)
            _dados['controle'] = _controle
            return {'status': True, 'dados': _dados}
        # return {'status': False, 'mensagem': json.loads(res.text), 'status_code': res.status_code}
        _mensagem = '%s. %s' % (json.loads(res.text).get('title', ''),
                               json.loads(res.text).get('detail', ''))
        return {'status': False, 'mensagem': _mensagem, 'status_code': res.status_code}

    def inter_registrar_pix_callback(self, chave):
        """
        Endpoint para buscar registrar uma url para callbacl do pix
        :param chave: url para registro da callback do pix
        :type chave: str
        return {'status': True/False, 'mensagem': '', dados: ''}
        """
        if not chave:
            return {'status': False, 'mensagem': _('Falta a chave Pix co correntista')}
        # Registrar url do Pix
        _url = self.get_callback('/bc/inter/pixrec?db=%s' % self.cr.dbname)
        vals = {
            'webhookUrl': _url,
        }
        metodo = 'PUT'
        url = '/pix/v2/webhook/%s' % chave
        headers = self.get_headers_bearer()
        res = self.inter_comunicar(metodo, url, json=vals, headers=headers)
        if res.ok:
            return {'status': True, 'dados': res.text}
        return {'status': False, 'mensagem': json.loads(res.text), 'status_code': res.status_code}

    def inter_bank_get_extrato(self, dataInicio, dataFim):
        """
        Endpoint para buscar saldo da conta
        :param dataInicio: data inicial para consulta de extrato
        :type dataInicio: str
        :param dataFim: data final para consulta de extrato
        :type dataFim: str
        return {'status': True/False, 'mensagem': '', dados: ''}
        """
        if not dataInicio:
            return {'status': False, 'mensagem': _('Falta a data de inicio')}
        if not dataFim:
            return {'status': False, 'mensagem': _('Falta a data final.')}

        vals = {
            'dataInicio': str(datas.getDataNoFormato(dataInicio, 'I', '-')),
            'dataFim': str(datas.getDataNoFormato(dataFim, 'I', '-')),
        }
        metodo = 'GET'
        url = '/banking/v2/extrato'
        headers = self.get_headers_bearer()
        res = self.inter_comunicar(metodo, url, params=vals, headers=headers)
        if res.ok:
            return {'status': True, 'dados': json.loads(res.text)}
        return {'status': False, 'mensagem': json.loads(res.text), 'status_code': res.status_code}

    def inter_registrar_pag_callback(self):
        """
        Endpoint para buscar registrar uma url para callbacl para pagamentos
        return {'status': True/False, 'mensagem': '', dados: ''}
        """
        # Registrar url de callback do boleto a receber
        _url = self.get_callback('/bc/inter/pixpag?db=%s' % self.cr.dbname)
        vals = {
            'webhookUrl': _url,
        }
        metodo = 'PUT'
        url = '/banking/v2/webhooks/pix-pagamento'
        headers = self.get_headers_bearer()
        res = self.inter_comunicar(metodo, url, json=vals, headers=headers)
        if res.ok:
            return {'status': True, 'dados': res.text}
        try:
            _mens = json.loads(res.text)
        except:
            _mens = res.text
        return {'status': False, 'mensagem': _mens, 'status_code': res.status_code}


    def inter_bank_get_extrato_pdf(self, dataInicio, dataFim):
        """
        Endpoint para buscar extrato em PDF
        :param dataInicio: data inicial para consulta de extrato
        :param dataFim: data final para consulta de extrato
        return {'status': True/False, 'mensagem': '', dados: ''}
        """
        if not dataInicio:
            return {'status': False, 'mensagem': _('Falta a data de inicio')}
        if not dataFim:
            return {'status': False, 'mensagem': _('Falta a data final.')}


        vals = {
            'dataInicio': datas.getDataNoFormato(dataInicio, 'I', '-'),
            'dataFim': datas.getDataNoFormato(dataFim, 'I', '-'),
        }
        metodo = 'GET'
        url = '/banking/v2/extrato/exportar'
        headers = self.get_headers_bearer()
        res = self.inter_comunicar(metodo, url, params=vals, headers=headers)
        if res.ok:
            return {'status': True, 'dados': json.loads(res.text)}
        return {'status': False, 'mensagem': json.loads(res.text), 'status_code': res.status_code}

    def inter_bank_get_saldo(self, data=None):
        """
        Endpoint para buscar saldo da conta
        :param data: data do saldo a ser pesquisada, se não informada sera usada a data do momento da pesquisa
        return {'status': True/False, 'mensagem': '', dados: ''}
        """
        vals = {
        }
        if data:
            vals['dataSaldo'] = datas.getDataNoFormato(data, 'I', '-'),
        metodo = 'GET'
        url = '/banking/v2/saldo'
        headers = self.get_headers_bearer()
        res = self.inter_comunicar(metodo, url, params=vals, headers=headers)
        if res.ok:
            return {'status': True, 'dados': json.loads(res.text)}
        return {'status': False, 'mensagem': json.loads(res.text), 'status_code': res.status_code}

    def inter_get_token(self):
        vals = {
            'client_id': str(self.client_id),
            'client_secret': str(self.client_secret),
            'grant_type': 'client_credentials',
            'scope': str(self.escopos),
        }
        metodo = 'POST'
        url = '/oauth/v2/token'
        res = self.inter_comunicar(metodo, url, data=vals, headers={})
        if res.ok:
            self.token = json.loads(res.text).get('access_token')
            pooler.get_pool(self.cr.dbname).get('financeiro.tesouraria.contas').write(self.cr, self.uid,
                                                                                      self.conta_id,
                                                                                    {'fintco_bf_inter_token': self.token})
            return {'status': True, 'dados': json.loads(res.text)}
        return {'status': False, 'mensagem': json.loads(res.text)}


    def inter_pag_boleto_incluir(self, codbarra, valor, datapagto, vencimento):
        """
        Endpoint para realização de Pagamento/Agendamento de titulos
        :param codbarra: - Codigo de barras do titulo
        :param valor: - NumeroID da empresa
        :param datapagto: - Data do pagamento do titulo
        :param vencimento: - data do vencimento do titulo
        return {'status': True/False, 'mensagem': '', dados: ''}
        """

        # Validando dados
        if not codbarra:
            return {'status': False, 'mensagem': _('Falta o codigo de barras do titulo')}
        if not valor:
            return {'status': False, 'mensagem': _('Falta o valor da transacao.')}
        if not datapagto:
            return {'status': False, 'mensagem': _('Falta a data de pagamento do titulo.')}
        if not vencimento:
            return {'status': False, 'mensagem': _('Falta o vencimento do titulo.')}
        vals = {
            "codBarraLinhaDigitavel": codbarra,
            'valorPagar': valor,
            'dataPagamento': datas.getDataNoFormato(datapagto, 'I', '-'),
            'dataVencimento': datas.getDataNoFormato(vencimento, 'I', '-'),
        }
        metodo = 'POST'
        url = '/banking/v2/pagamento'
        headers = self.get_headers_bearer()
        res = self.inter_comunicar(metodo, url, json=vals, headers=headers)
        if res.ok:
            return {'status': True, 'dados': json.loads(res.text)}
        _mens = json.loads(res.text)
        if _mens.get('message'):
            _mens = _mens.get('message')
        return {'status': False, 'mensagem': _mens, 'status_code': res.status_code}

    def inter_pag_consultar_boleto(self, codigobarra, dataInicio=None, dataFim=None, operacao=None):
        """
        Endpoint para consultar dados de poagamento de titulos
        :param codbarra: - Codigo de barras do titulo
        :param dataInicio: - filtro para data inicial
        :param dataFim: - filtro para data final
        :param operacao: - I=Inclusao, P=Pagamento, V=Vencimento, afeta os filtros de dataInicial e datafinal
        return {'status': True/False, 'mensagem': '', dados: ''}
        """

        # Validando dados
        if not codigobarra:
            return {'status': False, 'mensagem': _('Falta o codigo de barras do titulo')}
        if dataInicio:
            if not dataFim:
                return {'status': False, 'mensagem': _('Informando data inicial, e necessario informar a data final')}
            if not operacao or operacao not in ('I', 'P', 'V'):
                return {'status': False, 'mensagem': _('Informando data inicial, e necessario informar a operacao')}
        vals = {
            "codBarraLinhaDigitavel": codigobarra,
            # 'valorPagar': valor,
            # 'dataPagamento': datas.getDataNoFormato(datapagto, 'I', '-'),
            # 'dataVencimento': datas.getDataNoFormato(vencimento, 'I', '-'),
        }
        _oper = {'I': 'INCLUSAO',
                 'P': 'PAGAMENTO',
                 'V': 'VENCIMENTO'
        }
        if dataInicio:
            vals['dataInicio'] = datas.getDataNoFormato(dataInicio, 'I', '-')
            vals['dataFim'] = datas.getDataNoFormato(dataFim, 'I', '-')
            vals['operacao'] = _oper.get(operacao)
        metodo = 'GET'
        url = '/banking/v2/pagamento'
        headers = self.get_headers_bearer()
        res = self.inter_comunicar(metodo, url, json=vals, headers=headers)
        if res.ok:
            return {'status': True, 'dados': json.loads(res.text)}
        _mens = json.loads(res.text)
        if _mens.get('message'):
            _mens = _mens.get('message')
        return {'status': False, 'mensagem': _mens, 'status_code': res.status_code}

    def inter_registrar_cob_callback(self):
        """
        Endpoint para buscar registrar uma url para callbacl para boletos a receber
        return {'status': True/False, 'mensagem': '', dados: ''}
        """
        # Registrar url de callback do boleto a receber
        _url = self.get_callback('/bc/inter/bolrec?db=%s' % self.cr.dbname)
        vals = {
            'webhookUrl': _url,
        }
        metodo = 'PUT'
        url = '/cobranca/v3/cobrancas/webhook'
        headers = self.get_headers_bearer()
        res = self.inter_comunicar(metodo, url, json=vals, headers=headers)
        if res.ok:
            return {'status': True, 'dados': res.text}
        return {'status': False, 'mensagem': json.loads(res.text), 'status_code': res.status_code}


    def inter_cob_boleto_registrar(self, **kwargs):
        """
        Endpoint para registrar boletos de cobranca
        :param **kwargs: dicionario contendo dados para o registro (veja a documentacao no metodo de chamada)
        return {'status': True/False, 'mensagem': '', dados: ''}
        """

        # Validando dados
        if not kwargs.get('tituloId'):
            return {'status': False, 'mensagem': _('Falta o ID do titulo!')}
        if not kwargs.get('tituloNumero'):
            return {'status': False, 'mensagem': _('Falta o numero do titulo!')}
        if not kwargs.get('emissao'):
            return {'status': False, 'mensagem': _('Falta a data de emissao!')}
        if not kwargs.get('valor'):
            return {'status': False, 'mensagem': _('Falta o valor do titulo!')}
        if not kwargs.get('vencimento'):
            return {'status': False, 'mensagem': _('Falta a data de vencimento!')}
        if not kwargs.get('sacado').get('nome'):
            return {'status': False, 'mensagem': _('Falta o nome do cliente!')}
        if not kwargs.get('sacado').get('cpfCnpj'):
            return {'status': False, 'mensagem': _('Falta o CPF/CNPJ do cliente!')}
        if not kwargs.get('sacado').get('cpfCnpjTipo'):
            return {'status': False, 'mensagem': _('Falta o tipo de inscricao (CPF/CNPJ)!')}
        if not kwargs.get('sacado').get('cep'):
            return {'status': False, 'mensagem': _('Falta o CEP do cliente!')}
        if not kwargs.get('sacado').get('enderecoRua'):
            return {'status': False, 'mensagem': _('Falta o endereco do cliente!')}
        if not kwargs.get('sacado').get('cidade'):
            return {'status': False, 'mensagem': _('Falta a cidade do cliente!')}
        if not kwargs.get('sacado').get('bairro'):
            return {'status': False, 'mensagem': _('Falta o bairro do cliente!')}
        if not kwargs.get('sacado').get('uf'):
            return {'status': False, 'mensagem': _('Falta a UF do cliente!')}
        if kwargs.get('descontoValor'):
            if not kwargs.get('descontoDias'):
                return {'status': False, 'mensagem': _('Falta a data do desconto!')}
        if kwargs.get('tituloParcela'):
            _numeroTitulo = '%s/%s' % (kwargs.get('tituloNumero'), kwargs.get('tituloParcela'))
        else:
            _numeroTitulo = kwargs.get('tituloNumero')
        _cpfCnpj = re.sub('[^0-9]', '', kwargs.get('sacado').get('cpfCnpj'))
        _cpfCnpjCompany = re.sub('[^0-9]', '', kwargs.get('beneficiario').get('cpfCnpj'))
        vals = {
            'seuNumero': str(('%s-%s' % (kwargs.get('tituloId'), kwargs.get('tituloNumero')))[:15]),
            'valorNominal': kwargs.get('valor'),
            'dataVencimento': str(datas.getDataNoFormato(kwargs.get('vencimento'), 'I', '-')),
            'numDiasAgenda': 29,
            'pagador': {
                'cpfCnpj': formatastring.formataString(_cpfCnpj, 14, '0','E'),
                'tipoPessoa': 'FISICA' if kwargs.get('sacado').get('cpfCnpjTipo') == 'CPF' else 'JURIDICA',
                'nome': kwargs.get('sacado').get('nome'),
                'endereco': kwargs.get('sacado').get('enderecoRua'),
                'numero': kwargs.get('sacado').get('enderecoNro') or '',
                'complemento': kwargs.get('sacado').get('enderecoCompl') or '',
                'bairro': kwargs.get('sacado').get('bairro') or '',
                'cidade': kwargs.get('sacado').get('cidade'),
                'uf': kwargs.get('sacado').get('uf'),
                'cep': re.sub('[^0-9]', '', kwargs.get('sacado').get('cep')),
                'email':  kwargs.get('sacado').get('email') or ''
            },
            'beneficiarioFinal': {
                'nome': kwargs.get('beneficiario').get('nome'),
                'cpfCnpj': formatastring.formataString(_cpfCnpjCompany, 14, '0', 'E'),
                'tipoPessoa': 'FISICA' if kwargs.get('beneficiario').get('cpfCnpjTipo') == 'CPF' else 'JURIDICA',
                'cep': re.sub('[^0-9]', '', kwargs.get('beneficiario').get('cep')),
                'endereco': kwargs.get('beneficiario').get('endereco'),
                'bairro': kwargs.get('beneficiario').get('bairro') or '',
                'cidade': kwargs.get('beneficiario').get('cidade'),
                'uf': kwargs.get('beneficiario').get('uf'),
            },
        }
        if kwargs.get('descontoValor'):
            vals['desconto'] = {
                'codigo': 'VALORFIXODATAINFORMADA',
                'valor': numero.getNumeroEditado(kwargs.get('descontoValor'), 2, '.', ''),
                'quantidadeDias': kwargs.get('descontoDias'),
            }
        if kwargs.get('multaValor'):
            vals['multa'] = {
                'codigo': 'VALORFIXO',
                'valor': numero.getNumeroEditado(kwargs.get('multaValor'), 2, '.', ''),
            }
        if kwargs.get('jurosValor'):
            vals['mora'] = {
                'codigo': 'VALORDIA',
                'valor': numero.getNumeroEditado(kwargs.get('jurosValor'), 2, '.', ''),
            }
        if kwargs.get('mensagem1'):
            vals['mensagem'] = {}
            vals['mensagem']['linha1'] = kwargs.get('mensagem1')
            if kwargs.get('mensagem2'):
                vals['mensagem']['linha2'] = kwargs.get('mensagem2')
        metodo = 'POST'
        url = '/cobranca/v3/cobrancas'
        headers = self.get_headers_bearer()
        res = self.inter_comunicar(metodo, url, json=vals, headers=headers)
        if res.ok:
            dados = json.loads(res.text)
            _controle = dados.get('codigoSolicitacao')
            ret_consulta = self.inter_cob_boleto_consultar(_controle)
            if ret_consulta.get('status'):
                _dadosJson = ret_consulta.get('dados')
                dados = {
                        'seuNumero': _dadosJson.get('cobranca').get('seuNumero'),
                        'nossoNumero': _dadosJson.get('boleto').get('nossoNumero'),
                        'linhaDigitavel': _dadosJson.get('boleto').get('linhaDigitavel'),
                        'codigoBarras': _dadosJson.get('boleto').get('codigoBarras'),
                        'urlPdf': '',
                        'urlPagamento': '',
                        'boletoPdf': _dadosJson.get('pdf_boleto'),
                        'pixHash':  _dadosJson.get('pix').get('txid'),
                        'pixQrCode': _dadosJson.get('pix').get('pixCopiaECola'),
                        'controle': _controle,
                    }
            return {'status': True, 'dados': dados}
        try:
            _mens = json.loads(res.text)
            if _mens.get('message'):
                _mens = _mens.get('message')
        except:
            _mens = res.text
        return {'status': False, 'mensagem': _mens, 'status_code': res.status_code}

    def inter_cob_boleto_get_pdf(self, controle):
        """
        Endpoint para pegar um pdf de um boleto de cobranca
        :param controle: valor identificado como controle do titulo no banco
        :type controle: str
        return {'status': True/False, 'mensagem': '', dados: ''}
        """
        if not controle:
            return {'status': False, 'mensagem': _('Falta o "Controle" do titulo!')}
        vals = {
        }
        metodo = 'GET'
        url = '/cobranca/v3/cobrancas/%s/pdf' % controle
        headers = self.get_headers_bearer()
        res = self.inter_comunicar(metodo, url, json=vals, headers=headers)
        if res.ok:
            return {'status': True, 'dados': json.loads(res.text)}
        try:
            _mens = json.loads(res.text)
            if _mens.get('message'):
                _mens = _mens.get('message')
        except:
            _mens = res.text
        return {'status': False, 'mensagem': _mens, 'status_code': res.status_code}

    def inter_cob_boleto_consultar(self, controle):
        """
        Endpoint para consultar a situação de um boleto de cobranca
        :param controle: valor identificado como controle do titulo no banco
        :type controle: str
        return {'status': True/False, 'mensagem': '', dados: ''}
        """
        if not controle:
            return {'status': False, 'mensagem': _('Falta o "Controle" do titulo!')}
        vals = {
        }
        metodo = 'GET'
        url = '/cobranca/v3/cobrancas/%s' % controle
        headers = self.get_headers_bearer()
        res = self.inter_comunicar(metodo, url, json=vals, headers=headers)
        if res.ok:
            _dados = json.loads(res.text)
            res_pdf = self.inter_cob_boleto_get_pdf(controle)
            if res_pdf.get('status'):
                _pdf = res_pdf.get('dados').get('pdf')
                _dados['pdf_boleto'] = _pdf
            return {'status': True, 'dados': _dados}
        try:
            _mens = json.loads(res.text)
            if _mens.get('message'):
                _mens = _mens.get('message')
        except:
            _mens = res.text
        return {'status': False, 'mensagem': _mens, 'status_code': res.status_code}

    def inter_cob_boleto_listar(self, data_inicial, data_final, tipoData='M'):
        """
        Endpoint para listar boletos de cobranca no banco
        :param data_inicial: data de emissao inicial para pesquisa
        :type data_inicial: str
        :param data_final: data de emissao final para pesquisa
        :type data_final: str
        :param tipoData: Tipo de data M=Movimento, E=Emissao
        :type tipoData: str
        :return: {'status': True/False, 'mensagem': '', dados: ''}
        """
        if not data_inicial:
            return {'status': False, 'mensagem': _('Precisa informar a data de inicio!')}
        if not data_final:
            return {'status': False, 'mensagem': _('Precisa informar a data de final!')}
        if not tipoData in ('M', 'E', 'V'):
            return {'status': False, 'mensagem': _('Tipo de data invalida, tem que ser M/Movimento ou E/Emissao!')}
        if tipoData == 'V':
            _tipo = 'VENCIMENTO'
        elif tipoData == 'E':
            _tipo = 'EMISSAO'
        else:
            _tipo = 'SITUACAO'
        vals = {
            'dataInicial': str(datas.getDataNoFormato(data_inicial, 'I', '-')),
            'dataFinal': str(datas.getDataNoFormato(data_final, 'I', '-')),
            "filtrarDataPor": _tipo,
            'itensPorPagina': 1000,
            'paginaAtual': 0
        }
        if _tipo == 'SITUACAO':
            vals['situacao'] = 'EXPIRADO,ATRASADO,A_RECEBER,RECEBIDO,CANCELADO,MARCADO_RECEBIDO'
        metodo = 'GET'
        url = '/cobranca/v3/cobrancas'
        headers = self.get_headers_bearer()
        res = self.inter_comunicar(metodo, url, params=vals, headers=headers)
        if res.ok:
            return {'status': True, 'dados': json.loads(res.text)}
        try:
            _mens = json.loads(res.text)
            if _mens.get('message'):
                _mens = _mens.get('message')
        except:
            _mens = res.text
        return {'status': False, 'mensagem': _mens, 'status_code': res.status_code}

    def inter_cob_boleto_cancelar(self, controle):
        """
        Endpoint para cancelar um boleto de cobranca
        :param controle: valor identificado como controle do titulo no banco
        :type controle: str
        return {'status': True/False, 'mensagem': '', dados: ''}
        """
        if not controle:
            return {'status': False, 'mensagem': _('Falta o "Nosso Numero" do titulo!')}
        vals = {
               'motivoCancelamento': 'ACERTOS'
        }
        metodo = 'POST'
        url = '/cobranca/v3/cobrancas/%s/cancelar' % controle
        headers = self.get_headers_bearer()
        res = self.inter_comunicar(metodo, url, json=vals, headers=headers)
        if res.ok:
            # _dados = json.loads(res.text)
            return {'status': True, 'dados': ''}
        try:
            _mens = json.loads(res.text)
            if _mens.get('message'):
                _mens = _mens.get('message')
        except:
            _mens = res.text
        return {'status': False, 'mensagem': _mens, 'status_code': res.status_code}

    def inter_status_get(self, operacao):
        """
        Endpoint para verificar status
        :param operacao: identifica o tipo de status que deve ser testado. Pode ser bank, pixpag, pixrec, bolrec, bolpag
        :type operacao: str
        return {'status': True/False, 'mensagem': '', dados: ''}
        """
        vals = {
        }
        metodo = 'GET'
        url = '/pix/v2/webhook/%s' % self.pix_chave
        if operacao == 'bolrec':
            url = '/cobranca/v3/cobrancas/webhook'
        # este endpoint está dando erro 404, aguardar correção do inter
        elif operacao in ('pixpag', 'bank'):
            url = '/banking/v2/webhooks/pix-pagamento'
        elif operacao == 'pixrec':
            url = '/pix/v2/webhook/%s' % self.pix_chave
        headers = self.get_headers_bearer()
        res = self.inter_comunicar(metodo, url, params=vals, headers=headers)
        if res.ok:
            return {'status': True, 'dados': {'success': True}}
        return {'status': False, 'mensagem': _('Nao consegui comunicar com o banco!'), 'status_code': res.status_code}

