# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _
from SigUtils.biometria.fingertech.fingertech import Fingertech
import base64
import os


class rh_funcionario(osv.Model):
    _name = 'rh.funcionario'
    _inherit = 'rh.funcionario'

    def _fnc_biometria(self, cr, uid, ids, field_name, args, context=None):
        context = context and context.copy() or {}
        res = {}
        for id in ids:
            res[id] = False
            if self.read(cr, uid, id, ['admpes_biometria'], context=context).get('admpes_biometria'):
                res[id] = True

        return res

    _columns = {
        'rhfunc_biometria': fields.function(_fnc_biometria, string='biometria', type='boolean',
                                            method=True, stored=False),
    }

    def button_cadastrar_biometria(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        pessoa_id = self.read(cr, uid, ids, context=context)[0].get('pessoa')[0]
        context['rh_pessoa_id'] = pessoa_id
        return {
            'name': "Biometria",
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'wizard.rh.biometria',
            'type': 'ir.actions.act_window',
            'ref': 'action_compras_solicitacao_item',
            'context': context,
            'target': 'new',
        }

    def button_testar_biometria(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        pessoa_id = self.read(cr, uid, ids, context=context)[0].get('pessoa')[0]
        obj_pessoa = self.pool.get('adm.pessoa')
        pessoa_ids = obj_pessoa.search(cr, uid, [('id','=',pessoa_id)],
                                                      context=context)
        if not pessoa_ids:
            return True

        str_bio = obj_pessoa.read(cr, uid, pessoa_ids, ['admpes_biometria'],
                                     context=context)[0].get('admpes_biometria')
        str_bio = base64.decodestring(str_bio)
        arq_bio = open('/tmp/fir.txt', 'w')
        arq_bio.write(str_bio)
        arq_bio.close()
        try:
            fingertech = Fingertech()
            fingertech.arq_biometria = '/tmp/fir.txt'
            res = fingertech.compara_biometria()
        except Exception as e:
            raise osv.except_osv(_('Atencao!'),
                                   'Erro ao ler a biometria: ' + str(e))

        msg = 'Digital encontrada'
        if not res:
            msg = 'Digital nao encontrada'

        raise osv.except_osv(_('Atencao!'), msg)
