# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _
from SigUtils.biometria.fingertech.fingertech import Fingertech
import os


class wizard_atualizar_preco_venda_capa(osv.TransientModel):
    """
    Prefixo: wizrbi
    """
    _name = 'wizard.rh.biometria'

    _columns = {
        'wizrbi_controle': fields.boolean('Controle'), # controla invisible dos botoes
    }

    fingertech = Fingertech()

    def wizrbi_ler_biometria(self, cr, uid, ids, context=None):
        '''

        :param cr:
        :param uid:
        :param ids:
        :param context:
        :return:
        '''
        context = context and context.copy() or {}
        #chamada da leitura do fingertech
        try:
            self.fingertech.ler_biometria()
        except Exception as e:
            raise osv.except_osv(_("Atencao!"), str(e))

        self.write(cr, uid, ids, {'wizrbi_controle':True},context=context)
        return {
            'name': "Biometria",
            'view_type': 'form',
            'view_mode': 'form',
            'res_id': ids[0],
            'res_model': 'wizard.rh.biometria',
            'type': 'ir.actions.act_window',
            'context': context,
            'ref': 'action_wizard_rh_biometria_view',
            'target': 'new',
        }

    def wizrbi_confirmar_biometria(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = False
        try:
            res = self.fingertech.compara_biometria()
        except Exception as e:
            raise osv.except_osv(_('Atencao!'), str(e))

        if not res: # as biometrias nao sao iguais
            self.write(cr, uid, ids, {'wizrbi_controle':False},context=context)
            return {
                'name': "Biometria",
                'view_type': 'form',
                'view_mode': 'form',
                'res_id': ids[0],
                'context': context,
                'res_model': 'wizard.rh.biometria',
                'type': 'ir.actions.act_window',
                'ref': 'action_wizard_rh_biometria_view',
                'target': 'new',
            }

        pessoa_id = context.get('rh_pessoa_id')
        obj_pessoa = self.pool.get('adm.pessoa')
        biometria_ids = obj_pessoa.search(cr, uid, [('id','=', pessoa_id)], context=context)
        vals = {'admpes_biometria': self.fingertech.fir}
        if not biometria_ids:
            obj_pessoa.create(cr, uid, vals, context=context)
        else:
            obj_pessoa.write(cr, uid, biometria_ids,vals, context=context)

        return {
            'name': "Cadastro de funcionarios",
            'view_type': 'form',
            'view_mode': 'form',
            'res_id': context.get('active_id'),
            'context': context,
            'res_model': 'rh.funcionario',
            'type': 'ir.actions.act_window',
            'target': 'current',
        }
