# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _
from SigUtils.biometria.fingertech.fingertech import Fingertech


class supervisor_cad_operadores(osv.Model):
    _name = 'supervisor.cad.operadores'
    _inherit = 'supervisor.cad.operadores'

    _columns = {
        'supope_biometria': fields.text('Impressao Digital'),
    }

    def button_cadastrar_biometria(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        context['operador_id'] = ids[0]
        return {
            'name': "Biometria",
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'wizard.supervisor.biometria',
            'type': 'ir.actions.act_window',
            'ref': 'action_compras_solicitacao_item',
            'context': context,
            'target': 'new',
        }

    def button_testar_biometria(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_operadores = self.pool.get('supervisor.cad.operadores')
        operadores_ids = obj_operadores.search(cr, uid, [('id','=',ids[0])],
                                                      context=context)
        if not operadores_ids:
            return True

        str_bio = obj_operadores.read(cr, uid, operadores_ids, ['supope_biometria'],
                                        context=context)[0].get('supope_biometria')
        str_bio = str_bio
        arq_bio = open('/tmp/fir.txt', 'w')
        arq_bio.write(str_bio)
        arq_bio.close()
        try:
            fingertech = Fingertech()
            fingertech.arq_biometria = '/tmp/fir.txt'
            res = fingertech.compara_biometria()
        except Exception as e:
            raise osv.except_osv(_('Atencao!'),
                                   'Erro ao ler a biometria: ' + str(e))

        msg = 'Digital encontrada'
        if not res:
            msg = 'Digital nao encontrada'

        raise osv.except_osv(_('Atencao!'), msg)
