# -*- coding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _


class calcmadeira_pecas_serradas_preco(osv.Model):

    _inherit = 'calcmadeira.pecas.serradas.preco'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        res = super(calcmadeira_pecas_serradas_preco, self).create(cr, uid, vals, context)
        self.cpspre_valida(cr, uid, [res], context=context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        res = super(calcmadeira_pecas_serradas_preco, self).write(cr, uid, ids, vals, context)
        self.cpspre_valida(cr, uid, [ids] if isinstance(ids, (int, long)) else ids, context)
        return res

    def cpspre_valida(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        pecas_serradas_preco_dados = self.read(cr, uid, ids, [], context)
        list_msg = []
        for preco in pecas_serradas_preco_dados:
            msg = ''
            if preco.get('cpspre_espessura') <= 0:
                msg += '\n' + _('Espessura deve ser maior que zero.')
            if preco.get('cpspre_largura') <= 0:
                msg += '\n' + _('Largura deve ser maior que zero.')
            if preco.get('cpspre_preco') < 0:
                msg += _('\nPreco não pode ser menor que zero.')
            msg and list_msg.append((preco.get('name') or _('*Peca sem descricao*')) + ':' + msg)
            if list_msg:
                raise osv.except_osv(_('Atencao'), ' \n'.join(list_msg))
