# -*- coding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _


class calcmadeira_parametro(osv.Model):

    _inherit = 'calcmadeira.parametro'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if self.search(cr, uid, [], context=context):
            raise osv.except_osv(_('Atencao'), _('Cadastro de parametros deve ser unico.'))
        res = super(calcmadeira_parametro, self).create(cr, uid, vals, context)
        self.cmapar_valida(cr, uid, [res], context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        res = super(calcmadeira_parametro, self).write(cr, uid, ids, vals, context)
        self.cmapar_valida(cr, uid, [ids] if isinstance(ids, (int, long)) else ids, context)
        return res

    def cmapar_valida(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        list_msg = []
        obj_calcmadeira_pecas_serradas = self.pool.get('calcmadeira.pecas.serradas')
        obj_calcmadeira_toras = self.pool.get('calcmadeira.toras')

        pecas_serradas_ids = obj_calcmadeira_pecas_serradas.search(
            cr, uid, [], order='cmapse_menor_espessura', limit=1, context=context)
        es_min_pecas = pecas_serradas_ids and obj_calcmadeira_pecas_serradas.read(
            cr, uid, pecas_serradas_ids[0], ['cmapse_menor_espessura'], context).get(
            'cmapse_menor_espessura') or 0

        pecas_serradas_ids = obj_calcmadeira_pecas_serradas.search(
            cr, uid, [], order='cmapse_maior_espessura DESC', limit=1, context=context)
        es_max_pecas = pecas_serradas_ids and obj_calcmadeira_pecas_serradas.read(
            cr, uid, pecas_serradas_ids[0], ['cmapse_maior_espessura'], context).get(
            'cmapse_maior_espessura') or 0

        calcmadeira_parametro_dados = self.read(cr, uid, ids, [], context)
        for parametro in calcmadeira_parametro_dados:
            msg = ''
            if parametro.get('cmapar_es_serra') < 0 or parametro.get('cmapar_es_serra') > 20:
                msg += _('\n"Espessura da serra" deve ser maior que zero e menor que 20 mm.')
            if parametro.get('cmapar_altura_corte') < 0 or parametro.get('cmapar_altura_corte') > 1:
                msg += _('\n"Altura do toco" deve possuir um valor entre 0 e menor que 1.')
            if parametro.get('cmapar_ang_direito') < 0 or parametro.get('cmapar_ang_direito') > 90:
                msg += _('\n"Angulo direito" deve possuir um valor entre 0 e menor que 90.')
            if parametro.get('cmapar_ang_base') < 0 or parametro.get('cmapar_ang_base') > 90:
                msg += _('\n"Angulo base" deve possuir um valor entre 0 e 90.')
            if parametro.get('cmapar_prop_casc') < 0 or parametro.get('cmapar_prop_casc') > 1:
                msg += _('\n"Proporcao da casca" deve possuir um valor entre 0 e menor que 1.')
            if parametro.get('cmapar_proporcao_raio_corte_peca') < 0 or parametro.get(
                    'cmapar_proporcao_raio_corte_peca') > 1:
                msg += _('\n"Proporcao do raio para corte de pecas" deve possuir um valor entre 0 '
                         'e 1.')
            if parametro.get('cmapar_espessura_peca_central') < 0:
                msg += _('\n"Espessura da peca central" nao pode ser menor que zero.')
            if parametro.get('cmapar_laminacao_espessura') < 0 or parametro.get(
                    'cmapar_laminacao_espessura') > 100:
                msg += _('\n"Espessura da folha" deve ser maior que zero e menor ou igual a 100.')
            if parametro.get('cmapar_laminacao_comp_folha') < 0 or parametro.get(
                    'cmapar_laminacao_comp_folha') > 10:
                msg += _('\n"Comprimento da folha" deve ser maior que zero e menor ou igual a 10.')
            msg and list_msg.append(msg)
        if list_msg:
            raise osv.except_osv(_('Atencao'), '\n '.join(list_msg))
