# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class calcmadeira_pecas_rolicas(osv.Model):
    """
    Tabela de Pecas com suas dimencoes
    Prefixo: cmapro
    """
    _inherit = 'calcmadeira.pecas.rolicas'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        res = super(calcmadeira_pecas_rolicas, self).create(cr, uid, vals, context)
        self.cmapro_valida(cr, uid, [res], context=context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        res = super(calcmadeira_pecas_rolicas, self).write(cr, uid, ids, vals, context)
        self.cmapro_valida(cr, uid, [ids] if isinstance(ids, (int, long)) else ids, context)
        return res

    def cmapro_valida(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        pecas_rolicas_dados = self.read(cr, uid, ids, [], context)
        list_msg = []
        for peca in pecas_rolicas_dados:
            msg = ''
            if peca.get('cmapro_diametro_min') > peca.get('cmapro_diametro_max'):
                msg += _('\nDiametro minimo deve ser menor ou igual ao Diametro maximo.')
            if peca.get('cmapro_diametro_min') <= 0:
                msg += _('\nDiametro minimo deve ser maior que zero.')
            if peca.get('cmapro_diametro_max') <= 0:
                msg += _('\nDiametro maximo deve ser maior que zero.')
            if peca.get('cmapro_preco') < 0:
                msg += _('\nPreco nao pode ser menor que zero.')
            if peca.get('cmapro_comprimento_tora') <= 0:
                msg += _('\nComprimento da tora nao pode ser menor que zero.')
            msg and list_msg.append((peca.get('name') or _('*Peca sem descricao*')) + ':' + msg)
        if list_msg:
            raise osv.except_osv(_('Atencao'), ' \n'.join(list_msg))

