# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class calcmadeira_pecas_serradas(osv.Model):
    """
    Tabela de Pecas com suas dimencoes
    Prefixo: cmapse
    """
    _inherit = 'calcmadeira.pecas.serradas'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        res = super(calcmadeira_pecas_serradas, self).create(cr, uid, vals, context)
        self.cmapse_valida(cr, uid, [res], context=context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        res = super(calcmadeira_pecas_serradas, self).write(cr, uid, ids, vals, context)
        self.cmapse_valida(cr, uid, [ids] if isinstance(ids, (int, long)) else ids, context)
        return res

    def cmapse_valida(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        pecas_serradas_dados = self.read(cr, uid, ids, [], context)
        list_msg = []
        for peca in pecas_serradas_dados:
            msg = ''
            if peca.get('cmapse_menor_espessura') > peca.get('cmapse_maior_espessura'):
                msg += _('\nMenor espessura deve ser menor ou igual a Maior espessura.')
            if peca.get('cmapse_menor_largura') > peca.get('cmapse_maior_largura'):
                msg += _('\nMenor largura deve ser menor ou igual a Maior largura.')
            if peca.get('cmapse_menor_espessura') <= 0:
                msg += _('\nMenor espessura deve ser maior que zero.')
            if peca.get('cmapse_maior_espessura') <= 0:
                msg += _('\nMaior espessura deve ser maior que zero.')
            if peca.get('cmapse_menor_largura') <= 0:
                msg += _('\nMenor largura deve ser maior que zero.')
            if peca.get('cmapse_maior_largura') <= 0:
                msg += _('\nMaior largura deve ser maior que zero.')
            msg and list_msg.append((peca.get('name') or _('*Peca sem descricao*')) + ':' + msg)
        if list_msg:
            raise osv.except_osv(_('Atencao'), ' \n'.join(list_msg))

