# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class calcmadeira_toras(osv.Model):
    """
    Tabela de Toras com suas dimencoes
    Prefixo: cmator
    """
    _inherit = 'calcmadeira.toras'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        res = super(calcmadeira_toras, self).create(cr, uid, vals, context)
        self.cmator_valida(cr, uid, [res], context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        res = super(calcmadeira_toras, self).write(cr, uid, ids, vals, context)
        self.cmator_valida(cr, uid, [ids] if isinstance(ids, (int, long)) else ids, context)
        return res

    def cmator_valida(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        list_msg = []
        calcmadeira_toras_dados = self.read(cr, uid, ids, [], context)
        for tora in calcmadeira_toras_dados:
            msg = ''
            if tora.get('cmator_diametro_max') <= 0:
                msg += _('\nDiametro maximo deve ser maior que zero.')
            if tora.get('cmator_diametro_min') <= 0:
                msg += _('\nDiametro minimo deve ser maior que zero.')
            if tora.get('cmator_comprimento_tora') <= 0:
                msg += _('\nComprimento da tora deve ser maior que zero.')
            if tora.get('cmator_diametro_min') > tora.get('cmator_diametro_max'):
                msg += _('\nDiametro minimo não pode ser maior que o Diametro maximo.')
            msg and list_msg.append('Tora: %s' % (str(tora.get('cmator_tora')) if tora.get(
                'cmator_tora') else _('*Tora sem codigo*')) + msg)
        if list_msg:
            raise osv.except_osv(_('Atencao'), '\n '.join(list_msg))
