#Calcula valor bruto de peças de madeira serrada pelo método de desdobro
#de retirada de 1/4 do diâmetro para cada lado (retirada de duas costaneiras)

#Dap- diametro a altura do peito e media da classe de Dap (duas variáveis em uma)
#ht-altura total da árvore e media da classe altura da árvore(duas variáveis em uma)
#hi - comprimento da tora = comprimento da peça
#hi_atual - começa com altura do toco (30 cm)
#es-espessura peça
#min_es - menor espessura por tipo de peça
#max_es - maior espessura por tipo de peça
#di_casc - diâmetro com casca
#di_casc2 - diâmetro com casca para calculo do volume da peça
#di- diâmetro sem casca
#l-largura peça
#difl-sobra peça
#v-volume peça
#vr-volume tora
#vt-volume arvore
#n-num.peças
#narv-numero de árvores da amostra
#codpeca-codigo peça

#Declara a, b, c... - quantidade de peças por tipo por arvore,
#va, vb, vc... - volume de peças por tipo por arvore,
#na, nb, nc... - numero de peças por tipo por arvore

#Declara a2, b2, c2... - quantidade de peças por tipo por amostra (todas as árvores),
#va2, vb2, vc2... - volume de peças por tipo por por amostra,
#na2, nb2, nc2... - numero de peças por tipo por amostra.

import math

def ClasPeca (es_serra,l,hi,vr,ang, R_flecha_base):
    a = b = c = d = e = f = g = h = k = 0
    na = nb = nc = nd = ne = nf = ng = nh = nk = 0
    va = vb = vc = vd = ve = vf = vg = vh = vk = 0
    vra = vrb = vrc = vrd = vre = vrf = vrg = vrh = vrk = 0.0000

    difl=2
    v=0
    v1=0
    npecas=len(linpeca)-1

    # Calcula peças na seção do tronco até limites mínimos (l<2 e min_es por tipo de peça)

    # alteração em 24/11/17
    # artifício para sair do looping quando difl é menor do
    # que es do sarrafo, mas o l enquadra em sarrafo.
    # E não enquadra em tabua, com min_es=1 porque l < 10.
    # para resolver atribui difl menor do que 2 para sair do loop.

    while l >= 2 and difl>=2:

        for p in range(1, (len(linpeca))):
            pecas = linpeca[p]
            codpeca = int(pecas[0])
            min_es = int(pecas[2])
            max_es = int(pecas[3])
            l_min = int(pecas[4])
            l_max = int(pecas[5])

            #alteração no pranchão limite superior inv_es 26/11/17
            if l >= l_min and difl>1:

                if vr > 0:
                    flecha = (di / 2) * (1 - math.cos(ang * math.pi / 180))
                    difl = (di / 2) - flecha

                # desdobra da maior espessura da peça para a menor
                for inv_es in range(0,10):
                    es = max_es - inv_es

                    # Considera espessura da serra (fita, corrente motosserra...)
                    es = es + es_serra

                    #correção sinal while 26/11/17
                    while es > difl:
                        es = es - 1

                        # 1 cm é a menor espessura possível entre todas as peças
                        # min_es não pode ser menor do que es+es_serra!
                        if difl - es_serra < 1 or es < min_es:
                                break
                    if difl - es_serra < 1 or es < min_es:
                            break

                    #segmento que vai do meio da peça até o arco longitudinalmente
                    #flecha = (di / 2) * (1 - math.cos(ang * math.pi / 180))

                    #metade do numero de peças (di/2) considerando desconto de 1/4 de um lado da tora
                    n = math.trunc(((di / 2) - flecha) / es)
                    #sobra da peça para novo aproveitamento (cm)
                    difl = (di / 2) - flecha - n * es
                    #print('l={:.4f}\n, difl={:.4f}\n, flecha={:.4f}\n, ang={:.4f}\n, es={:.4f}\n, n={:.4f}\n'
                    #.format(l, difl, flecha, ang, es, n))
                    #volume das peças
                    for x in range(1, n+1):

                        vp = ((es-es_serra) / 100) * l / 100 * hi

                        # Relatorio por peça
                        print('codpeca:{}, es:{}, l:{}, n:{}, vp:{}'.format(codpeca, es, l, n, vp))

                        #incremento da flecha com espessura da nova peça
                        flecha = flecha + es

                        #novo angulo formado com a nova peça
                        ang = 180 - math.acos((flecha - (di / 2)) / (di / 2)) * 180 / math.pi

                        #largura da nova peça para calculo do seu volume
                        l = (2 * (di / 2) * ((math.tan(ang * math.pi / 180)) * math.cos(ang * math.pi / 180)) / 2) + R_flecha_base

                        v1 = v1 + vp

                    v=v+v1

                    if codpeca == 1:
                        na = na + n
                        va = va + v

                        if vr > 0:
                            a = a + 1
                            vra = vra + vr
                            # relatório por tora
                            print('a:{}, vra:{}'.format(a, vra))
                            vr = 0

                    elif codpeca == 2:
                        nb = nb + n
                        vb = vb + v

                        if vr > 0:
                            b = b + 1
                            vrb = vrb + vr
                            print('b:{}, vrb:{}'.format(b, vrb))
                            vr = 0

                    elif codpeca == 3:
                        nc = nc + n
                        vc = vc + v

                        if vr > 0:
                            c = c + 1
                            vrc = vrc + vr
                            print('c:{}, vrc:{}'.format(c, vrc))
                            vr = 0

                    elif codpeca == 4:
                        nd = nd + n
                        vd = vd + v

                        if vr > 0:
                            d = d + 1
                            vrd = vrd + vr
                            print('d:{}, vrd:{}'.format(d, vrd))
                            vr = 0

                    elif codpeca == 5:
                        ne = ne + n
                        ve = ve + v

                        if vr > 0:
                            e = e + 1
                            vre = vre + vr
                            print('e:{}, vre:{}'.format(e, vre))
                            vr = 0

                    elif codpeca == 6:
                        nf = nf + n
                        vf = vf + v

                        if vr > 0:
                            f = f + 1
                            vrf = vrf + vr
                            print('f:{}, vrf:{}'.format(f, vrf))
                            vr = 0

                    elif codpeca == 7:
                        ng = ng + n
                        vg = vg + v

                        if vr > 0:
                            g = g + 1
                            vrg = vrg + vr
                            print('g:{}, vrg:{}'.format(g, vrg))
                            vr = 0

                    elif codpeca == 8:
                        nh = nh + n
                        vh = vh + v

                        if vr > 0:
                            h = h + 1
                            vrh = vrh + vr
                            print('h:{}, vrh:{}'.format(h, vrh))
                            vr = 0

                    elif codpeca == 9:
                        nk = nk + n
                        vk = vk + v

                        if vr > 0:
                            k = k + 1
                            vrk = vrk + vr
                            print('k:{}, vrk:{}'.format(k, vrk))
                            vr = 0

                    #print('v={:.4f},difl={:.4f},nk={:.4f},vk={:.4f}'.format(v, difl, nk, vk))
                    v1 = 0
                    v = 0
            n=0
            v=0

    return na, va, nb, vb, nc, vc, nd, vd, ne, ve, nf, vf, ng, vg, nh, vh, nk, vk, \
            a, b, c, d, e, f, g, h, k, vra, vrb, vrc, vrd, vre, vrf, vrg, vrh, vrk
#-----------------------------------------------------------------------
print('Calculador de Madeira Serrada_1/4D_Costaneiras')
#arq = open('d:/Thomaz/ADADOS/ILPF_Miguel/Eucalipto.txt', 'r')
#arq=open('D:/Thomaz/ILPF_Miguel/Eucalipto.txt','r')
arq=open('D:/ILPF_Miguel/Eucalipto.txt','r')
linarv=arq.readlines()
narv=len(linarv)-1
print('narv=',narv)

di=di_casc=di_casc2=0

a1 = b1 = c1 = d1 = e1 = f1 = g1 = h1 =k1= 0
vra1=vrb1 = vrc1 = vrd1 = vre1 = vrf1 = vrg1 = vrh1=vrk1 = 0

va1 = vb1 = vc1 = vd1 = ve1 = vf1 = vg1 = vh1 =vk1= 0
na1=nb1=nc1=nd1=ne1=nf1=ng1=nh1=nk1=0

vt = 0
vt1 = 0
cont=0
ntora1=0

#arq1 = open('D:/Thomaz/ILPF_Miguel/DimSerrada.txt', 'r')
#arq1=open('D:/Thomaz/ADADOS/ILPF_Miguel/DimSerrada.txt','r')
arq1=open('D:/ILPF_Miguel/DimSerrada.txt','r')
linpeca=arq1.readlines()
arq1.close

#Executa por árvore
while cont < narv:
    cont = cont + 1
    v=0
    n=0
    vr=0

    a = b = c = d = e = f = g = h =k= 0
    vra = vrb = vrc = vrd = vre = vrf = vrg = vrh = vrk = 0

    va = vb = vc = vd = ve = vf = vg = vh=vk = 0
    na=nb=nc=nd=ne=nf=ng=nh=nk=0

    di_casc = 0
    di = 100
    es_serra = 0.5
    hi_atual = 0.3
    hi = 2
    ntora = 0

#Acessa arquivo texto, armazena dap e ht por árvore, e calcula seu volume (vt)
    dados = linarv[cont].split()
    dap = float(dados[2])
    ht = float(dados[3])
    vt = math.exp(-10.1891 + 1.9424 * math.log(dap) + 1.0299 * math.log(ht))

    difl = 100
    #Calcula peças por seção do tronco até completar altura da árvore
    while hi_atual + hi <= ht:

        # calcula di com casca (di_casc2) na altura do 2o diâmetro, o menor (hi_atual+hi)#ARV 2 CITRIODORA
        di_casc2 = (1.10041792322808 - 1.46182396963 * ((hi_atual + hi) / ht)
                    + 0.77535958077 * ((hi_atual + hi) / ht) ** 2) * dap

        # calcula di com casca (di_casc2) na altura do 2o diâmetro, o menor (hi_atual+hi) ILPF EMBRAPA EUC2011
        # di_casc2 = math.sqrt(1.04975640127245 - 1.48603214408326 * ((hi_atual + hi) / ht)
        # + 0.473173744770541 * ((hi_atual + hi) / ht) ** 2) * dap

        # calcula di com casca superior (di_casc) na altura atual (hi_atual)
        if hi_atual + hi < ht:

            # calcula di com casca(di_casc) na altura atual (hi_atual) ARV 2 CITRIODORA
            di_casc = (1.10041792322808 - 1.46182396963 * (hi_atual / ht)
                       + 0.77535958077 * (hi_atual / ht) ** 2) * dap

            # ILPF EMBRAPA EUC2011
            # di_casc = math.sqrt(1.04975640127245 - 1.48603214408326 * hi_atual / ht
            # + 0.473173744770541 * (hi_atual / ht) ** 2) * dap

            vr = (math.pi * ((di_casc + di_casc2) / 2) ** 2 / 40000) * hi
        else:
            break

        # di sem casca é di_casc2 x
        # (100 - 6.8% de casca, medido no Eucal Maravilhas)
        # (100- 4.8% casca, medido no citriodora Arv 2)
        # (100- 8.5% casca, medido no citriodora Arv 3)
        # (100 - 9.4% casca, medido na tora 2 da Arv 3)
        di = di_casc2 * (1 - 0.048)

        # armazena a linha de gravação dos dados para relatório por peça
        ntora = ntora + 1
        print('di_casc2:{}, di_casc:{}, di:{}, ntora:{}'.format(di_casc2, di_casc, di, ntora))

        #angulo inicial para retirada da costaneira da base
        ang_base=50

        #comprimento da peça, do eixo x até o limite da costaneira da base (R-flecha)
        R_flecha_base=di/2*math.cos(ang_base*math.pi/180)

        #angulo inicial para desconto de 1/4 do di para cada lado (flecha = 1/4*R)
        ang = 45

        #largura da peça (corda)
        l = (2 * (di / 2) * ((math.tan(ang * math.pi / 180)) * math.cos(ang * math.pi / 180))/2)+R_flecha_base

        #print('di_casc2={:.4f}\n di_casc={:.4f}\n vr={:.4f}\n di={:.4f}\n'.format(di_casc2,di_casc,vr,di))

        na, va, nb, vb, nc, vc, nd, vd, ne, ve, nf, vf, ng, vg, nh, vh, nk, vk,\
        a, b, c, d, e, f, g, h, k, vra, vrb, vrc, vrd, vre, vrf, vrg, vrh, vrk = ClasPeca(es_serra,l, hi, vr,ang,R_flecha_base)

        #atualiza hi_atual com o comprimento da peça extraída (hi)
        hi_atual = hi_atual + hi
        #print('hi_atual=',hi_atual)

       #acumula vt arvore e zera vt
        vt1 = vt1 + vt
        vt = 0

        # acumula ntora da arvore e zera ntora
        ntora1 = ntora1 + ntora
        ntora = 0

        #zera hi_atual
        #hi_atual = 0

        #transfere peças calculadas da arvore para a variável final, que armazena peças de todas as árvores da amostra
        a1 = a1 + a
        vra1 = vra1 + vra
        na1 = na1 + na
        va1 = va1 + va

        b1 = b1 + b
        vrb1 = vrb1 + vrb
        nb1 = nb1 + nb
        vb1 = vb1 + vb

        c1 = c1 + c
        vrc1 = vrc1 + vrc
        nc1 = nc1 + nc
        vc1 = vc1 + vc

        d1 = d1 + d
        vrd1 = vrd1 + vrd
        nd1 = nd1 + nd
        vd1 = vd1 + vd

        e1 = e1 + e
        vre1 = vre1 + vre
        ne1 = ne1 + ne
        ve1 = ve1 + ve

        f1 = f1 + f
        vrf1 = vrf1 + vrf
        nf1 = nf1 + nf
        vf1 = vf1 + vf

        g1 = g1 + g
        vrg1 = vrg1 + vrg
        ng1 = ng1 + ng
        vg1 = vg1 + vg

        h1 = h1 + h
        vrh1 = vrh1 + vrh
        nh1 = nh1 + nh
        vh1 = vh1 + vh

        k1 = k1 + k
        vrk1 = vrk1 + vrk
        nk1 = nk1 + nk
        vk1 = vk1 + vk

        vrt = vra1 + vrb1 + vrc1 + vrd1 + vre1 + vrf1 + vrg1 + vrh1 + vrk1

        #zera variáveis das seções da árvore
        a = 0
        vra = 0
        va = 0
        na = 0

        b = 0
        vrb = 0
        vb = 0
        nb = 0

        c = 0
        vrc = 0
        vc = 0
        nc = 0

        d = 0
        vrd = 0
        vd = 0
        nd = 0

        e = 0
        vre = 0
        ve = 0
        ne = 0

        f = 0
        vrf = 0
        vf = 0
        nf = 0

        g = 0
        vrg = 0
        vg = 0
        ng = 0

        h = 0
        vrh = 0
        vh = 0
        nh = 0

        k = 0
        vrk = 0
        vk = 0
        nk = 0

print('Sarrafo:{}, {}, {}, {}'.format(a1,vra1, na1*2, va1*2))
print('Ripão:{}, {}, {}, {}'.format(b1,vrb1, nb1*2, vb1*2))
print('Caibro:{}, {}, {}, {}'.format(c1,vrc1, nc1*2, vc1*2))
print('Pontalete:{}, {}, {}, {}'.format(d1,vrd1, nd1*2, vd1*2))
print('Ripa:{}, {}, {}, {}'.format(e1,vre1, ne1*2, ve1*2))
print('Viga:{}, {}, {}, {}'.format(f1,vrf1, nf1*2, vf1*2))
print('Tabua:{}, {}, {}, {}'.format(g1,vrg1, ng1*2, vg1*2))
print('Prancha:{}, {}, {}, {}'.format(h1,vrh1, nh1*2, vh1*2))
print('Pranchão:{}, {}, {}, {}'.format(k1,vrk1, nk1*2, vk1*2))
print('Volume tora total:{}, Volume total:{}, total de toras:{}'.format(vrt, vt1, ntora1))
arq.close()