# -*-coding: UTF-8-*-
# Calcula valor bruto de peças de madeira serrada pelo método de desdobro radial

# Dap- diametro a altura do peito e media da classe de Dap (duas variáveis em uma)
# ht-altura total da árvore e media da classe altura da árvore(duas variáveis em uma)
# hi - comprimento da tora = comprimento da peça
# hi_atual - começa com altura do toco (30 cm)
# es-espessura peça
# min_es - menor espessura por tipo de peça
# max_es - maior espessura por tipo de peça
# di_casc - diâmetro com casca
# di_casc2 - diâmetro com casca para calculo do volume da peça
# di- diâmetro sem casca
# l-largura peça
# l_d, l_e - larguras direita e esquerda da peça
# l_s, l_i - larguras superior e inferior da peça
# l_d2 - largura direita da próxima peça
# l_s2 - largura superior da próxima peça
# cord_d, cord_e - cordas direita e esquerda da peça
# cord_s, cord_i - cordas superior e inferior da peça
# ang_d, ang_e - angulos direito e esquerdo formados c respectivas cordas
# ang_s, ang_i - angulos superior e inferior formados c respectivas cordas
# difl-sobra peça
# v-volume peça
# vr-volume tora
# vt-volume arvore
# n-num.peças do 2o quadrante
# ntora- num. toras
# narv-numero de árvores da amostra
# codpeca-codigo peça
# nes = n*es - numero de peças vezes sua espessura

# a, b, c... - quantidade de peças por tipo por arvore,
# va, vb, vc... - volume de peças por tipo por arvore,
# na, nb, nc... - numero de peças por tipo por arvore

# a2, b2, c2... - quantidade de peças por tipo por amostra (todas as árvores),
# va2, vb2, vc2... - volume de peças por tipo por por amostra,
# na2, nb2, nc2... - numero de peças por tipo por amostra.

import math

def Fatia1(linpeca,ang_d,vr,es_serra,es1,es2,nes1,nes2,di, hi, l_e,l_d):

    a = b = c = d = e = f = g = h = k = 0
    vra = vrb = vrc = vrd = vre = vrf = vrg = vrh = vrk = 0

    # Para inicio da subrotina
    l_e=l_d-es2
    l_e2=l_e
    ang_d2=ang_d
    es = 0

    # volume de peças por tipo por árvore
    va = vb = vc = vd = ve = vf = vg = vh = vk = 0

    # numero de peças por tipo por árvore
    na = nb = nc = nd = ne = nf = ng = nh = nk = 0

    npecas = len(linpeca) - 1

    for p in range(1, (len(linpeca))):
        pecas = linpeca[p]
        codpeca = int(pecas[0])
        min_es = int(pecas[2])
        max_es = int(pecas[3])
        l_min = int(pecas[4])
        l_max = int(pecas[5])
        l_d = 0

        if ang_d >= float(45) and l_min <= l_e and l_e <= l_max:

            es = max_es+es_serra

            if (nes1 + min_es) > float(di / 2 * math.cos(45 * math.pi / 180)):
                continue

            while (nes1+ es) > float(di / 2 * math.cos(45 * math.pi / 180)):
                es = es - 1

            if es<min_es:
                continue

            # angulos (alfa/2) formados com lado esquerdo e direito da peça para comparar com lmin e calcular volume médio
            # 1o angulo do lado esquerdo da 1a peça é 90 (comprimento de l= R = di/2)
            ang_e = calc_ang_e(nes1, di)
            ang_d = calc_ang_d(nes1,es, di)

            # Cordas esquerda e direita da peça
            cord_e = calc_cord_e(di, ang_e)
            cord_d = calc_cord_d(di, ang_d)

            # larguras esquerda e direita da peça (atualiza com desconto da espessura da peça)
            l_e = calc_l_e(es_serra,cord_e, nes2)
            l_d = calc_l_d(es_serra,cord_d, nes2)

            if l_d<l_min:
                l_e=l_e2
                ang_d=ang_d2
                continue

            # l_d da próxima peça. Para verificação no loop. Continua se largura direita da próxima peça enquadrar no if da peça.
            # motivo: para evitar peças com uma parte fora da padronização da largura.
            #l_d2 = calc_cord_d(di,ang_d)

            # volume da peça
            l_s=l_i=0
            v = calc_v(es_serra,es,l_d,l_e,l_s,l_i,hi)
            n = 1

            print('copeca:{}, es:{}, l_d:{}, n:{}, v:{}, f1'.format(codpeca, es, l_d, n, v))

            # armazena informações da peça selecionada
            if codpeca == 1:
                na = na + n
                va = va + v

                if vr > 0:
                    a = a + 1
                    vra = vra + vr
                    # relatório por tora
                    print('a:{}, vra:{}'.format(a, vra))
                    vr = 0

            elif codpeca == 2:
                nb = nb + n
                vb = vb + v

                if vr > 0:
                    b = b + 1
                    vrb = vrb + vr
                    print('b:{}, vrb:{}'.format(b, vrb))
                    vr = 0

            elif codpeca == 3:
                nc = nc + n
                vc = vc + v

                if vr > 0:
                    c = c + 1
                    vrc = vrc + vr
                    print('c:{}, vrc:{}'.format(c, vrc))
                    vr = 0

            elif codpeca == 4:
                nd = nd + n
                vd = vd + v

                if vr > 0:
                    d = d + 1
                    vrd = vrd + vr
                    print('d:{}, vrd:{}'.format(d, vrd))
                    vr = 0

            elif codpeca == 5:
                ne = ne + n
                ve = ve + v

                if vr > 0:
                    e = e + 1
                    vre = vre + vr
                    print('e:{}, vre:{}'.format(e, vre))
                    vr = 0

            elif codpeca == 6:
                nf = nf + n
                vf = vf + v

                if vr > 0:
                    f = f + 1
                    vrf = vrf + vr
                    print('f:{}, vrf:{}'.format(f, vrf))
                    vr = 0

            elif codpeca == 7:
                ng = ng + n
                vg = vg + v

                if vr > 0:
                    g = g + 1
                    vrg = vrg + vr
                    print('g:{}, vrg:{}'.format(g, vrg))
                    vr = 0

            elif codpeca == 8:
                nh = nh + n
                vh = vh + v

                if vr > 0:
                    h = h + 1
                    vrh = vrh + vr
                    print('h:{}, vrh:{}'.format(h, vrh))
                    vr = 0

            elif codpeca == 9:
                nk = nk + n
                vk = vk + v

                if vr > 0:
                    k = k + 1
                    vrk = vrk + vr
                    print('k:{}, vrk:{}'.format(k, vrk))
                    vr = 0

            #define espessura acumulada na Fatia1(das peças selecionadas)
            nes1=nes1+es
            es1 = es

            # zera variáveis da seção da árvore
            v = 0
            n = 0
            es=0

            return (linpeca,ang_d,vr,es_serra, es1,es2,nes1,nes2,l_d, na, va, nb, vb, nc, vc, nd, vd, ne, ve, nf, vf, ng, vg, nh, vh, nk, vk)

    if l_e<2:
        es1=0

    return (linpeca, ang_d,vr,es_serra, es1, es2, nes1, nes2, l_d, na, va, nb, vb, nc, vc, nd, vd, ne, ve, nf, vf, ng, vg, nh, vh, nk, vk)

# ---------------------------------------------------------------------
def Fatia2(linpeca, ang_s, vr, es_serra,es1,es2,nes1,nes2,di,hi, l_i,l_s):

    a = b = c = d = e = f = g = h = k = 0
    vra = vrb = vrc = vrd = vre = vrf = vrg = vrh = vrk = 0

    codpeca=0
    l_i = l_s - es1
    l_i2=l_i
    ang_s2=ang_s

    # volume de peças por tipo por árvore
    va1 = vb1 = vc1 = vd1 = ve1 = vf1 = vg1 = vh1 = vk1 = 0

    # numero de peças por tipo por árvore
    na1 = nb1 = nc1 = nd1 = ne1 = nf1 = ng1 = nh1 = nk1 = 0

    npecas = len(linpeca) - 1

    for p in range(1, (len(linpeca))):
        pecas = linpeca[p]
        codpeca = int(pecas[0])
        min_es = int(pecas[2])
        max_es = int(pecas[3])
        l_min = int(pecas[4])
        l_max = int(pecas[5])
        l_s = 0

        if ang_s <= 45 and l_min <= l_i and l_i <= l_max:

        #Considera espessura da serra (fita, corrente motosserra...)
            es = max_es + es_serra

            if (nes2 + min_es) > float(di / 2 * math.cos(45 * math.pi / 180)):
                break

            while (nes2+es) > float(di / 2 * math.cos(45 * math.pi / 180)):
                es = es - 1

            if es<min_es:
                continue

            # angulos (alfa/2) formados com lado esquerdo e direito da peça para comparar com lmin e calcular volume médio
            # 1o angulo do lado esquerdo da 1a peça é 90 (comprimento de l= R = di/2)
            ang_i = calc_ang_i(nes2, di)
            ang_s = calc_ang_s(nes2, es, di)
            # goto .Volta_DoUntil

            # Cordas esquerda e direita da peça
            cord_i = calc_cord_i(di, ang_i)
            cord_s = calc_cord_s(di, ang_s)

            # larguras esquerda e direita da peça atual (atualizar com desconto da espessura da peça)
            l_i = calc_l_i(es_serra,cord_i, nes1)
            l_s = calc_l_s(es_serra,cord_s, nes1)

            if l_s < l_min:
                l_i=l_i2
                ang_s=ang_s2
                continue

            # l_s da próxima peça. Para verificação no loop. Continua se largura direita da próxima peça enquadrar no if da peça.
            # motivo: para evitar peças com uma parte fora da padronização da largura.
            #l_s2 = calc_l_s2(cord_s, nes, es)

            # volume da peça
            l_d=l_e=0
            v=calc_v(es_serra,es, l_d, l_e, l_s, l_i, hi)
            n = 1

            print('copeca:{}, es:{}, l_s:{}, n:{}, v:{}, f2'.format(codpeca, es, l_s, n, v))

            # armazena informações da peça selecionada
            if codpeca == 1:
                na1 = na1 + n
                va1 = va1 + v

                if vr > 0:
                    a = a + 1
                    vra = vra + vr
                    # relatório por tora
                    print('a:{}, vra:{}'.format(a, vra))
                    vr = 0

            elif codpeca == 2:
                nb1 = nb1 + n
                vb1 = vb1 + v

                if vr > 0:
                    b = b + 1
                    vrb = vrb + vr
                    print('b:{}, vrb:{}'.format(b, vrb))
                    vr = 0

            elif codpeca == 3:
                nc1 = nc1 + n
                vc1 = vc1 + v

                if vr > 0:
                    c = c + 1
                    vrc = vrc + vr
                    print('c:{}, vrc:{}'.format(c, vrc))
                    vr = 0

            elif codpeca == 4:
                nd1 = nd1 + n
                vd1 = vd1 + v

                if vr > 0:
                    d = d + 1
                    vrd = vrd + vr
                    print('d:{}, vrd:{}'.format(d, vrd))
                    vr = 0

            elif codpeca == 5:
                ne1 = ne1 + n
                ve1 = ve1 + v

                if vr > 0:
                    e = e + 1
                    vre = vre + vr
                    print('e:{}, vre:{}'.format(e, vre))
                    vr = 0

            elif codpeca == 6:
                nf1 = nf1 + n
                vf1 = vf1 + v

                if vr > 0:
                    f = f + 1
                    vrf = vrf + vr
                    print('f:{}, vrf:{}'.format(f, vrf))
                    vr = 0

            elif codpeca == 7:
                ng1 = ng1 + n
                vg1 = vg1 + v

                if vr > 0:
                    g = g + 1
                    vrg = vrg + vr
                    print('g:{}, vrg:{}'.format(g, vrg))
                    vr = 0

            elif codpeca == 8:
                nh1 = nh1 + n
                vh1 = vh1 + v

                if vr > 0:
                    h = h + 1
                    vrh = vrh + vr
                    print('h:{}, vrh:{}'.format(h, vrh))
                    vr = 0

            elif codpeca == 9:
                nk1 = nk1 + n
                vk1 = vk1 + v

                if vr > 0:
                    k = k + 1
                    vrk = vrk + vr
                    print('k:{}, vrk:{}'.format(k, vrk))
                    vr = 0

            # define espessura acumulada na Fatia1(das peças selecionadas)
            nes2=nes2+es
            es2 = es

            # zera variáveis da seção da árvore
            v = 0
            n = 0
            es=0

            return linpeca,ang_s,vr,es_serra,es1,es2, nes1,nes2,l_s, na1, va1, nb1, vb1, nc1, vc1, nd1, vd1, ne1, ve1, nf1, vf1, ng1, vg1, nh1, vh1, nk1, vk1

    if l_s<2:
        es2=0

    return linpeca, ang_s,vr, es_serra, es1, es2, nes1, nes2, l_s, na1, va1, nb1, vb1, nc1, vc1, nd1, vd1, ne1, ve1, nf1, vf1, ng1, vg1, nh1, vh1, nk1, vk1
# -----------------------------------------------------------------
print('Calculador de Madeira Serrada_Radial2')
#Computador Embrapa
arq = open('/hd/fontes/SigErp/trunk/sigaddons/tora/data/2018_07_03/Eucalipto.txt', 'r')
#Computador Casa
#arq = open('D:/Thomaz/ILPF_Miguel/Eucalipto.txt', 'r')
#laptop
# arq=open('D:/Thomaz/ADADOS/ILPF_Miguel/Eucalipto.txt','r')
linarv = arq.readlines()
narv = len(linarv) - 1
print('narv=', narv)

di = di_casc = di_casc2 = 0

# FOI DESATIVADO O CALCULO DE TORAS POR TIPO DE PEÇA, REATIVAR!
# numero de toras por amostra nas primeiras peças selecionadas
a1 = b1 = c1 = d1 = e1 = f1 = g1 = h1 = k1 = 0

# volume de toras por amostra nas primeiras peças selecionadas
vra1 = vrb1 = vrc1 = vrd1 = vre1 = vrf1 = vrg1 = vrh1 = vrk1 = 0

# Fatia 1 volume, numero de peças
va = vb = vc = vd = ve = vf = vg = vh = vk = 0
na = nb = nc = nd = ne = nf = ng = nh = nk = 0

# Fatia 2
va1 = vb1 = vc1 = vd1 = ve1 = vf1 = vg1 = vh1 = vk1 = 0
na1 = nb1 = nc1 = nd1 = ne1 = nf1 = ng1 = nh1 = nk1 = 0

# volume de peças por amostra
va22 = vb22 = vc22 = vd22 = ve22 = vf22 = vg22 = vh22 = vk22 = 0

# numero de pecas por amostra
na22 = nb22 = nc22 = nd22 = ne22 = nf22 = ng22 = nh22 = nk22 = 0

ntora = 0
ntora1=0
vrt = 0

vt = 0
vt1 = 0
cont = 0
codpeca = 0
n = 0
nes1=nes2 = es1 = es2=0

#Computador Embrapa
arq1 = open('/hd/fontes/SigErp/trunk/sigaddons/tora/data/DimSerrada.txt', 'r')
#Computador Casa
#arq1 = open('D:/Thomaz/ILPF_Miguel/DimSerrada.txt', 'r')
#Laptop
# arq1=open('D:/Thomaz/ADADOS/ILPF_Miguel/DimSerrada.txt','r')
linpeca = arq1.readlines()
arq1.close

# Executa por árvore
while cont < narv:
    cont = cont + 1
    v = 0
    vr = 0
    a = b = c = d = e = f = g = h = k = 0
    vra = vrb = vrc = vrd = vre = vrf = vrg = vrh = vrk = 0

    es_serra=0.5
    hi_atual = 0.3
    hi = 2
    di_casc = 0
    di = 100
    ntora=0


    # Acessa arquivo texto, armazena dap e ht por árvore, e calcula seu volume (vt)
    dados = linarv[cont].split()
    dap = float(dados[2])
    ht = float(dados[3])
    vt = math.exp(-10.1891 + 1.9424 * math.log(dap) + 1.0299 * math.log(ht))

    # Calcula peças por seção do tronco até completar altura da árvore
    while hi_atual + hi <= ht:
        # calcula di com casca (di_casc2) na altura do 2o diâmetro, o menor (hi_atual+hi)
        from DadosArvores2 import *

        di_casc2 = calc_di_casc2(hi_atual, hi, ht, dap)

        # print('vt={:.4f}\n hi_atual={:.2f}\n ht={:.2f}\n'
        # .format(vt,hi_atual,hi,ht))

        # calcula di com casca superior (di_casc) na altura atual (hi_atual)
        if hi_atual + hi < ht:
            di_casc = calc_di_casc(hi_atual, ht, dap)
            vr = calc_vr(hi_atual, ht, hi, di_casc, di_casc2)

        else:
            break

        # di sem casca é di_casc2 x
        # (100 - 6.8% de casca, medido no Eucal Maravilhas)
        # (100- 4.8% casca, medido no citriodora Arv 2)
        # (100- 8.5% casca, medido no citriodora Arv 3)
        # (100 - 9.4% casca, medido na tora 2 da Arv 3)
        di = di_casc2 * (1 - 0.048)

        ntora = ntora + 1
        print('di_casc2:{}, di_casc:{}, di:{}, ntora:{}'.format(di_casc2, di_casc, di, ntora))

        vrt = vrt + vr

        l = di / 2

        #se largura < 2, resto da árvore não atende dimensões,
        # mesmo com comprimento suficiente da peça
        if l < 2:
            break

        l_e=l_d=l_i=l_s=l
        nes1=nes2=0
        es1=es2=0
        ang_d=90
        ang_s=0

    # ----------------------------------------------------
        while l_d >=2 and l_s>= 2:

            linpeca, ang_d, vr, es_serra, es1,es2,nes1,nes2,l_d, na, va, nb, vb, nc, vc, nd, vd, ne, ve, nf, vf, ng, vg, nh, vh, nk, vk \
                = Fatia1(linpeca,ang_d,vr,es_serra,es1,es2,nes1,nes2,di, hi, l_e,l_d)

            na22 = na22 + na
            va22 = va22 + va

            nb22 = nb22 + nb
            vb22 = vb22 + vb

            nc22 = nc22 + nc
            vc22 = vc22 + vc

            nd22 = nd22 + nd
            vd22 = vd22 + vd

            ne22 = ne22 + ne
            ve22 = ve22 + ve

            nf22 = nf22 + nf
            vf22 = vf22 + vf

            ng22 = ng22 + ng
            vg22 = vg22 + vg

            nh22 = nh22 + nh
            vh22 = vh22 + vh

            nk22 = nk22 + nk
            vk22 = vk22 + vk

            # zera variáveis das seções da árvore
            va = vb = vc = vd = ve = vf = vg = vh = vk = 0
            na = nb = nc = nd = ne = nf = ng = nh = nk = 0

            # ----------------------------------------------------
            linpeca,ang_s, vr,es_serra,es1,es2,nes1,nes2,l_s, na1, va1, nb1, vb1, nc1, vc1, nd1, vd1, ne1, ve1, nf1, vf1, ng1, vg1, nh1, vh1, nk1, vk1 \
                = Fatia2(linpeca,ang_s, vr, es_serra,es1,es2,nes1,nes2,di,hi,l_i,l_s)

            na22 = na22 + na1
            va22 = va22 + va1

            nb22 = nb22 + nb1
            vb22 = vb22 + vb1

            nc22 = nc22 + nc1
            vc22 = vc22 + vc1

            nd22 = nd22 + nd1
            vd22 = vd22 + vd1

            ne22 = ne22 + ne1
            ve22 = ve22 + ve1

            nf22 = nf22 + nf1
            vf22 = vf22 + vf1

            ng22 = ng22 + ng1
            vg22 = vg22 + vg1

            nh22 = nh22 + nh1
            vh22 = vh22 + vh1

            nk22 = nk22 + nk1
            vk22 = vk22 + vk1

            # zera variáveis das seções da árvore
            va1 = vb1 = vc1 = vd1 = ve1 = vf1 = vg1 = vh1 = vk1 = 0
            na1 = nb1 = nc1 = nd1 = ne1 = nf1 = ng1 = nh1 = nk1 = 0

            if (l_d - es2) >=2:
                continue

            if (l_s-es1) >= 2:
                continue

            l = 0
        # --------------------------------------------
        # atualiza hi_atual com o comprimento da peça extraída (hi)
        hi_atual = hi_atual + hi
        ##print('hi_atual=',hi_atual)
        # input('enterNovaTora')

        # acumula vt arvore e zera vt
        vt1 = vt1 + vt
        vt = 0

        # acumula ntora da arvore e zera ntora
        ntora1=ntora1+ntora
        ntora = 0

        # zera hi_atual
        #hi_atual = 0
        # input('enterNovaArvore')
        # transfere peças calculadas da arvore para a variável final, que armazena peças de todas as árvores da amostra

        # transfere as peças contabilizadas da primeira arvore para a
        # variável final, que armazena peças de todas as árvores da amostra


print('Sarrafo:{}, {}, {}, {}'.format(a1, vra1, na22 * 4, va22 * 4))
print('Ripão:{}, {}, {}, {}'.format(b1, vrb1, nb22 * 4, vb22 * 4))
print('Caibro:{}, {}, {}, {}'.format(c1, vrc1, nc22 * 4, vc22 * 4))
print('Pontalete:{}, {}, {}, {}'.format(d1, vrd1, nd22 * 4, vd22 * 4))
print('Ripa:{}, {}, {}, {}'.format(e1, vre1, ne22 * 4, ve22 * 4))
print('Viga:{}, {}, {}, {}'.format(f1, vrf1, nf22 * 4, vf22 * 4))
print('Tabua:{}, {}, {}, {}'.format(g1, vrg1, ng22 * 4, vg22 * 4))
print('Prancha:{}, {}, {}, {}'.format(h1, vrh1, nh22 * 4, vh22 * 4))
print('Pranchão:{}, {}, {}, {}'.format(k1, vrk1, nk22 * 4, vk22 * 4))
print('Volume tora total:{}, Volume total:{}, total de toras:{}'.format(vrt, vt1,ntora1))
arq.close()
