# -*-coding: UTF-8-*-
import math

#diametro com casca
def calc_di_casc(hi_atual,ht,dap):
    # calcula di com casca(di_casc) na altura atual (hi_atual) ARV 2 CITRIODORA
    di_casc = (1.10041792322808 - 1.46182396963 * (hi_atual / ht)
               + 0.77535958077 * (hi_atual / ht) ** 2) * dap

    # ILPF EMBRAPA EUC2011
    # di_casc = math.sqrt(1.04975640127245 - 1.48603214408326 * hi_atual / ht
    # + 0.473173744770541 * (hi_atual / ht) ** 2) * dap
    return di_casc

def calc_di_casc2(hi_atual,hi,ht,dap):
    # calcula di com casca (di_casc2) na altura do 2o diâmetro, o menor (hi_atual+hi)#ARV 2 CITRIODORA
    di_casc2 = (1.10041792322808 - 1.46182396963 * ((hi_atual + hi) / ht)
                + 0.77535958077 * ((hi_atual + hi) / ht) ** 2) * dap

    # calcula di com casca (di_casc2) na altura do 2o diâmetro, o menor (hi_atual+hi) ILPF EMBRAPA EUC2011
    # di_casc2 = math.sqrt(1.04975640127245 - 1.48603214408326 * ((hi_atual + hi) / ht)
    # + 0.473173744770541 * ((hi_atual + hi) / ht) ** 2) * dap
    return di_casc2

#volume da tora
def calc_vr(hi_atual, ht, hi, di_casc, di_casc2):
    if hi_atual+hi<ht:
        vr = float((math.pi * ((di_casc + di_casc2) / 2) ** 2 / 40000) * hi)
    #else:
        #break
    return vr

#volume da peça
def calc_v(es_serra,es,l_d,l_e,l_s,l_i,hi):
    if l_s==0:
        v = ((es-es_serra) / 100) * ((l_d + l_e) / 2) / 100 * hi
    else:
        v = ((es-es_serra) / 100) * ((l_s + l_i) / 2) / 100 * hi
    return v

#angulos direito, esquerdo (Fatia1), inferior, superior (Fatia2)
def calc_ang_d(nes1,es,di):
    ang_d = math.acos((nes1 +es) / (di / 2)) * 180 / math.pi
    return ang_d

def calc_ang_e(nes1,di):
    ang_e = math.acos(nes1 / (di / 2)) * 180 / math.pi
    return ang_e

def calc_ang_s(nes2,es,di):
    ang_s = math.asin((nes2 + es) / (di / 2)) * 180 / math.pi
    return ang_s

def calc_ang_i(nes2,di):
    ang_i = math.asin(nes2 / (di / 2)) * 180 / math.pi
    return ang_i

#cordas direita, esquerda (Fatia1), inferior, superior (Fatia2)

def calc_cord_d(di,ang_d):
    cord_d = di * math.sin(ang_d * math.pi / 180)
    return cord_d

def calc_cord_e(di,ang_e):
    cord_e = di * math.sin(ang_e * math.pi / 180)
    return cord_e

def calc_cord_s(di,ang_s):
    cord_s = di * math.cos(ang_s * math.pi / 180)
    return cord_s

def calc_cord_i(di,ang_i):
    cord_i = di * math.cos(ang_i * math.pi / 180)
    return cord_i

#larguras esquerda, direita, inferior, superior da peça (atualiza com desconto da espessura da peça)
def calc_l_e(es_serra,cord_e,nes2):
    l_e = (cord_e / 2) - nes2+es_serra
    return l_e

def calc_l_d(es_serra,cord_d,nes2):
    l_d = (cord_d / 2) - nes2+es_serra
    return l_d

def calc_l_s(es_serra,cord_s,nes1):
    l_s = (cord_s / 2) - nes1+es_serra
    return l_s

def calc_l_i(es_serra,cord_i,nes1):
    l_i = (cord_i / 2) - nes1+es_serra
    return l_i
