# -*-coding: UTF-8-*-

import pandas as pd
pd.set_option('display.max_columns', 10)

import FFormaEqFormaCubagem
import Formulas
import SubRotinas
import math


# ------------------------------------------------------------------
# CalculaPecas

# Dap - diametro a altura do peito
# ht - altura total da árvore
# hc - altura comercial da árvore
# hi - comprimento da tora = comprimento da peça
# hi_atual - começa com altura do toco (30 cm)
# es - espessura da peça
# es_serra - espessura da serra (perda de madeira no corte)
# min_es - menor espessura da peça
# max_es - maior espessura da peça
# di_casc - diâmetro com casca
# di_casc2 - diâmetro com casca para calculo do volume da peça
# di- diâmetro sem casca
# l - largura peça
# l_d, l_e - larguras direita e esquerda da peça
# 'l_s, l_i - larguras superior e inferior da peça
# 'l_d2 - largura direita da próxima peça
# 'l_s2 - largura superior da próxima peça
# 'cord_d, cord_e - cordas direita e esquerda da peça
# 'cord_s, cord_i - cordas superior e inferior da peça
# 'ang_d, ang_e - angulos direito e esquerdo formados c respectivas cordas
# 'ang_s, ang_i - angulos superior e inferior formados c respectivas cordas
# es_sobra - sobra peça
# v - volume peça
# vr - volume tora ou peça roliça
# vt - volume arvore
# n - num.peças
# ntora - numero da tora
# narv - numero de árvores da amostra
# codpeca-codigo peça

# a, b, c... - quantidade de peças por tipo por arvore,
# va, vb, vc... - volume de peças por tipo por arvore,
# na, nb, nc... - numero de peças por tipo por arvore

# a1, b1, c1... - quantidade de peças por tipo por amostra (todas as árvores),
# va1, vb1, vc1... - volume de peças por tipo por por amostra,
# na1, nb1, nc1... - numero de peças por tipo por amostra.

# Para madeira roliça
# vra, vrb, vrc... - volume de peças por tipo por arvore,
# vra1,vrb1, vrc1... - volume de peças por tipo por amostra.


def __getitem__(self, item):
    return self.SelecionaPeca[item]


escolhaEqVol = ''
escolhaEqForma = ''

escolha = ''
while (escolha == ''):
    print('Desdobro por Arvores\n'
          'Digite:\n'
          ' 0 para terminar\n'
          ' 1 para CalculaPecasMadSerr_QuadCirun\n'
          ' 2 para CalculaPecasMadSerr_Longitudinal\n'
          ' 3 para CalculaPecasMadSerr_Longitudinal_CostBase\n'
          ' 4 para CalculaPecasMadSerr_Radial\n'
          ' 5 para CalculaMadeiraRolica\n'
          ' 6 para CalculaMadeiraLaminada\n'
          ' 7 para CalculaPecasMadSerr_Gira_180_90\n'
          ' 8 para CalculaPecasMadSerr_Radial_Longitudinal\n')

    escolha = str(input())

# -----------------------------------------------------------------
print('Calculador de Madeira')

# -----------------------
linarv, narv = SubRotinas.learq()
# -----------------------

di_casc = di_casc2 = 0

# numero de toras por amostra nas primeiras peças selecionadas
a1 = b1 = c1 = d1 = e1 = f1 = g1 = h1 = k1 = 0

# volume de toras por amostra nas primeiras peças selecionadas
vra1 = vrb1 = vrc1 = vrd1 = vre1 = vrf1 = vrg1 = vrh1 = vrk1 = 0

# numero de peças por tipo por amostra
na1 = nb1 = nc1 = nd1 = ne1 = nf1 = ng1 = nh1 = nk1 = 0

# volume de peças por tipo por amostra
va1 = vb1 = vc1 = vd1 = ve1 = vf1 = vg1 = vh1 = vk1 = 0.0000

# preço de peças por tipo por amostra
precoa1 = precob1 = precoc1 = precod1 = precoe1 = precof1 = precog1 = precoh1 = precok1 = 0.0000

vt = 0.0000
vt1 = 0.0000
vrt = 0.0000

soma_vr_list = 0.0000
soma_vp_rolic_list = 0.0000

ntora = 0
ntora1 = 0
preco = 0.0000
precot = 0.0000
preco_medula = 0.0000

vol_peca_sum = 0.0000

conic_tora = 0.0000
rend_ptora = 0.0000

va_ptora = 0
vb_ptora = 0
vc_ptora = 0
vd_ptora = 0
ve_ptora = 0
vf_ptora = 0
vg_ptora = 0
vh_ptora = 0
vk_ptora = 0

va_ptora4 = 0
vb_ptora4 = 0
vc_ptora4 = 0
vd_ptora4 = 0
ve_ptora4 = 0
vf_ptora4 = 0
vg_ptora4 = 0
vh_ptora4 = 0
vk_ptora4 = 0

# Para acumulo de peças do Relatorio Detalhado
codpeca_list_r = []
codpeca_list = []
es_list = []
l_div_list = []
n_div_list = []
v_list = []
vr_list = []
vp_rolic_list = []
di_casc2_list = []
di_casc_list = []
di_list = []
ntora_list = []
arv_list = []
parc_list = []
preco_list_r = []
preco_list = []
comp_lamin_list = []

conic_tora_list = []
rend_ptora_list = []

# Var Madeira Laminada
comp_lamin1 = 0.0000
comp_lamin1_eixo = 0.0000

if (escolha == '4'):
    codpeca = 0
    nes1 = nes2 = es1 = es2 = 0
    l = 100

if (escolha == '1' or escolha == '2' or escolha == '3' or escolha == '4' or escolha == '7'
        or escolha == '8'):

    # -----------------------
    linpeca = SubRotinas.learq1()
    # -----------------------

    # print('Calcula Receita (R$)?')
    # receita = input('Entre com valor 1 para calcular!\n')
    # if receita == '1':
    # -----------------------
    linpeca_preco = SubRotinas.learq7()
    # -----------------------
    # else:
    #     linpeca_preco=['codpeca\tPeca\tes\tlarg\tPreco_peca\n','-1\tPeca\t-1\t-1\t-1\n']


if escolha == '5':
    # ----------------------
    linpeca = SubRotinas.learq0()
    # ----------------------

# Parametro da Madeira Laminada
if escolha == '6':
    print('Entre com diametro não aproveitavel para laminar (diametro do rolo resto, mm):')
    di_eixo = float(input())

    print('Entre com o comprimento da folha em metros!')
    comp_folha = float(input())

    l = 100
    t = 0
    comp_lamin_arv = 0
    comp_lamin_total = 0

# declarando variáveis, não necessário no VBA
di = 100

# -------------------------------------------
es_serra, hi_atual, hi, hi_min, prop_casc, l_min_pecas, es_min_pecas, di_min, es_perim, \
flecha_div_r, es_medula = SubRotinas.parametros(escolha)
# -------------------------------------------

if escolhaEqForma == '':
    print('0 para equação de forma interna\n'
          '1 para equação de forma do usuário\n')

    escolhaEqForma = str(input())

if escolhaEqForma == '0':
    B0f = B1f = B2f = 0

if escolhaEqForma == '1':
    # --------------------------------------
    B0f, B1f, B2f = SubRotinas.Forma()
    # --------------------------------------

#---------------------------------
FFormaEqFormaCubagem.cubagemtxt()
#---------------------------------

if escolhaEqVol == '':
    print('0 para equação de volume interna\n'
          '1 para equação de volume do usuário\n')

    escolhaEqVol = str(input())

if escolhaEqVol == '0':
    B0v = B1v = B2v = 0

if escolhaEqVol == '1':
    # --------------------------------------
    B0v, B1v, B2v = SubRotinas.Volume()
    # --------------------------------------

# numero da árvore
arv = 1
cod_arv = 0
arv_proces = 0
parc = 0
falha = 0

# Executa por árvore
while arv <= narv:
    v = 0
    n = 0
    vr = 0

    a = b = c = d = e = f = g = h = k = 0
    vra = vrb = vrc = vrd = vre = vrf = vrg = vrh = vrk = 0.0000
    na = nb = nc = nd = ne = nf = ng = nh = nk = 0
    va = vb = vc = vd = ve = vf = vg = vh = vk = 0.0000
    precoa = precob = precoc = precod = precoe = precof = precog = precoh = precok = 0.0000

    # Acessa arquivo texto, armazena dap e ht por árvore, e calcula seu volume (vt)
    dados = linarv[arv].split()

    parc = dados[0]
    cod_arv = dados[1]
    dap = float(dados[2])
    ht = float(dados[3])
    hc = float(dados[4])

    # conta árvores processadas
    if hc >0 and hc != "" and dap > 0 and ht > 0:
        arv_proces = arv_proces + 1

        if escolhaEqVol == '0':
            # -----------------------------
            # Seleciona equação de volume
            vt = Formulas.EquacaoVolume(dap, ht)
            # -----------------------------

        if escolhaEqVol == '1':
            vt = Formulas.Eqvt(B0v, B1v, B2v, dap, ht)
            # print(vt.vt_result())
            vt = vt.vt_result()

    if dap == 0 or dap == "" or ht == 0 or ht == "":
        falha = falha+1
        print('falha')

    # numero da tora
    ntora = 0

    es_sobra = 100

    # Calcula peças por seção do tronco até completar altura da árvore
    while hi_atual + hi <= hc:

        if escolhaEqForma == '0':
            # -------------------------------------------------
            # Seleciona equação de forma
            di_casc, di_casc2 = Formulas.EquacaoForma(hi_atual, hi, ht, dap, di_casc, di_casc2)
            # -------------------------------------------------

        if escolhaEqForma == '1':
            di_casc2 = Formulas.Eqdi_casc(B0f, B1f, B2f, hi_atual, hi, ht, dap)
            di_casc = Formulas.Eqdi_casc(B0f, B1f, B2f, hi_atual, hi, ht, dap)

            di_casc2 = di_casc2.di_casc2_result()
            di_casc = di_casc.di_casc_result()

        # volume da tora usando formula de Smalian
        vr = math.pi / 40000 * (di_casc ** 2 + di_casc2 ** 2) / 2 * hi
        vr_rend = vr

        # (100 - 6.8% de casca, medido no Eucal Maravilhas)
        # (100- 8.7% casca, medido no citriodora Arv 1)
        # (100- 4.8% casca, medido no citriodora Arv 2)
        # (100- 8.5% casca, medido no citriodora Arv 3)
        # (100 - 9.4% casca, medido na tora 2 da Arv 3)

        if escolha == '5':
            di = di_casc2 * (1 - prop_casc)
        else:
            di = di_casc2 * (1 - prop_casc) * 10

        ntora = ntora + 1

        if escolha != '5':
            # Conicidade da tora (cm/m)
            conic_tora = (di_casc - di_casc2) / hi

        if escolha != '5' and escolha != '6':
            # "" pq estas listas são para peças serradas, não tem código nem preço para a tora
            codpeca = ""
            preco = ""
            vr_list.append(vr)
            di_casc2_list.append(di_casc2)
            di_casc_list.append(di_casc)
            di_list.append(di)
            ntora_list.append(ntora)
            arv_list.append(cod_arv)
            parc_list.append(parc)
            codpeca_list_r.append(codpeca)
            preco_list_r.append(preco)

            conic_tora_list.append(conic_tora)

            preco = 0

            # Se posteriormente interessar preco e identificação para toras para madeira serrada
            print('vr:{}, di_casc2:{}, di_casc:{}, di:{}, ntora:{},arv:{}, codpeca:{}, preco:{}, conic_tora:{}'. \
                  format(vr, di_casc2,di_casc,di,ntora, arv, codpeca, preco, conic_tora))

            vrt = vrt + vr

        flecha = flecha0 = 0
        cord_d1 = 0
        cord_d = 0
        r_flecha_topo = 0
        R_flecha_base = 0
        s = 0

        if escolha != '7':
            es_medula = 0

        if escolha == '1':
            # largura da peça
            l = di / math.sqrt(2)

        if escolha == '2' or escolha == '3' or escolha == '7' or escolha == '8':

            # angulo inicial para desconto do di para cada lado (flecha0) e angulo da base
            ang_d, ang_base = Formulas.ang_costan()

            if escolha == '3':
                # comprimento da peça, do eixo x até o limite da costaneira da base (R-flecha)
                R_flecha_base = di / 2 * math.cos(ang_base * math.pi / 180)

            if escolha != '3':
                ang_base = 0

            if escolha == '8':
                ang_base = 90
                R_flecha_base = 0

            flecha0 = di / 2 * (1 - math.cos(ang_d * math.pi / 180))

            # 'largura da peça (corda)
            # 'Case 2 e 7: Longitudinal completo quando ang_base = 0
            # 'Case 3: quando compara ang_d com ang_base
            # 'Case 8: quando ang_base = 90

            # largura da peça (corda)
            if ang_d < 90 - ang_base or ang_base == 0:
                l = di * math.sin(ang_d * math.pi / 180)
            else:
                l = di * (math.sin(ang_d * math.pi / 180) / 2) + R_flecha_base


        if escolha == '4':
            l = di / 2

        # passado pela função parametros
        # break para sair da árvore. Se tora não atende, demais toras também não.
        # subrai na contagem, porque não adianta contar tora incompleta da árvore.
        # total de toras informa somente toras desdobradas

        if escolha == '1':
            if l < l_min_pecas + es_serra:
                ntora = ntora - 1
                break

        if escolha == '2' or escolha == '3' or escolha == '7':
            if di < l_min_pecas + es_serra:
                ntora = ntora - 1
                break

        if escolha == '4':

            # passado pela função parametros
            if l < l_min_pecas + es_serra or di / 2 < es_min_pecas + es_serra:
                ntora = ntora - 1

                #para tamanho de listas não ficarem diferentes no dataframe, que junta dados de toras e peças (quando não selecionadas)
                rend_ptora_list.append(0)

                break

            l_e = l_d = l
            l_i = l_s = l
            l_sobra = 0.0000
            nes1 = nes2 = 0.0
            es1 = es2 = 0.0
            ang_d = 90.0000
            ang_s = 0.0000
            ang_e = ang_i = 0

            fatia = 0

            a = b = c = d = e = f = g = h = k = 0
            vra = vrb = vrc = vrd = vre = vrf = vrg = vrh = vrk = 0.0000
            na = nb = nc = nd = ne = nf = ng = nh = nk = 0
            va = vb = vc = vd = ve = vf = vg = vh = vk = 0.0000

            n1 = v1 = 0

            # Verifica se pelo menos a menor peça será selecionada
            es = es_min_pecas + es_serra
            # ---------------------------------------------
            ang_e, ang_d, ang_i, ang_s, l_e, l_d, l_i, l_s \
                = Formulas.Formulas(fatia, nes1, nes2, es, es_serra, di, ang_e, ang_d, ang_i, ang_s, l_e, l_d, l_i, l_s)
            # ---------------------------------------------
            es = 0

        if escolha == '5':
            if di < di_min or hi_atual + hi_min > hc:
                ntora = ntora - 1
                break

        if escolha == '6':
            # 'numero de voltas totais
            if es_perim > 0:
                n = int(di / 2 / es_perim)
            else:
                print("escolha espessura da lamina em mm!")
                break

            for t in range(0, n + 1):
                # 'comprimento da lamina (mm)

                comp_lamin = math.pi * (di - t * 2 * es_perim)

                if (di - t * 2 * es_perim) < di_eixo:
                    break

                comp_lamin1 = comp_lamin1 + comp_lamin

        # ----------------------

        if escolha == '1':
            # -----------------------------------------------------
            # Seleciona Peça
            a, vra, na, va, b, vrb, nb, vb, c, vrc, nc, vc, d, vrd, nd, vd, \
            e, vre, ne, ve, f, vrf, nf, vf, g, vrg, ng, vg, h, vrh, nh, vh, k, vrk, nk, vk, vr, ntora, \
            codpeca_list, es_list, l_div_list, n_div_list, v_list, preco_list, \
            precoa, precob, precoc, precod, precoe, precof, precog, precoh, precok \
                = SubRotinas.SelecionaPeca_QuadCircun(a, vra, na, va, b, vrb, nb, vb, c, vrc, nc, vc, d, vrd, nd, vd,
                                                      e, vre, ne, ve, f, vrf, nf, vf, g, vrg, ng, vg, h, vrh, nh, vh, k,
                                                      vrk, nk, vk,
                                                      l_min_pecas, es_min_pecas, es_serra, hi, vr, l, ntora, arv,
                                                      linpeca,
                                                      linpeca_preco,
                                                      cord_d, es_medula, flecha0, escolha,
                                                      codpeca_list, es_list, l_div_list, n_div_list, v_list, preco_list,
                                                      precoa, precob, precoc, precod, precoe, precof, precog, precoh,
                                                      precok)
            #  vt em VBA?
            # -----------------------------------------------------

        if escolha == '2' or escolha == '3' or escolha == '8':
            # l_sobra = l
            # flecha = 0
            # -----------------------------------------------------
            # Seleciona Peça
            a, vra, na, va, b, vrb, nb, vb, c, vrc, nc, vc, d, vrd, nd, vd, \
            e, vre, ne, ve, f, vrf, nf, vf, g, vrg, ng, vg, h, vrh, nh, vh, k, vrk, nk, vk, vr, ntora, \
            l, cord_d1, cord_d, r_flecha_topo, s, \
            codpeca_list, es_list, l_div_list, n_div_list, v_list, preco_list, \
            precoa, precob, precoc, precod, precoe, precof, precog, precoh, precok \
                = SubRotinas.SelecionaPeca_Longitudinal_CostaneiraBase(a, vra, na, va, b, vrb, nb, vb, c, vrc, nc, vc,
                                                                       d, vrd, nd,
                                                                       vd, e, vre, ne, ve, f, vrf, nf, vf, g, vrg, ng,
                                                                       vg, h, vrh, nh, vh, k, vrk, nk, vk,
                                                                       l_min_pecas, es_min_pecas, es_serra, hi, vr, di,
                                                                       flecha0, R_flecha_base, l, ntora, arv, linpeca,
                                                                       linpeca_preco,
                                                                       ang_base, escolha,
                                                                       flecha_div_r, cord_d1, cord_d, r_flecha_topo, s,
                                                                       codpeca_list, es_list, l_div_list, n_div_list,
                                                                       v_list, preco_list,
                                                                       precoa, precob, precoc, precod, precoe, precof,
                                                                       precog, precoh, precok)
            # -----------------------------------------------------------

        if escolha == '7':
            l_sobra = l
            flecha = 0
            r_flecha_topo = 0.0000
            cord_d = 0

            for s in range(0, 1 + 1):
                # -----------------------------------------------------
                # Seleciona Peça
                a, vra, na, va, b, vrb, nb, vb, c, vrc, nc, vc, d, vrd, nd, vd, \
                e, vre, ne, ve, f, vrf, nf, vf, g, vrg, ng, vg, h, vrh, nh, vh, k, vrk, nk, vk, vr, ntora, \
                l, cord_d1, cord_d, r_flecha_topo, s, \
                codpeca_list, es_list, l_div_list, n_div_list, v_list, preco_list, \
                precoa, precob, precoc, precod, precoe, precof, precog, precoh, precok \
                    = SubRotinas.SelecionaPeca_Longitudinal_CostaneiraBase(a, vra, na, va, b, vrb, nb, vb, c, vrc, nc,
                                                                           vc, d, vrd, nd, vd, e, vre, ne, ve, f, vrf,
                                                                           nf, vf, g, vrg, ng, vg, h, vrh, nh, vh, k,
                                                                           vrk, nk, vk,
                                                                           l_min_pecas, es_min_pecas, es_serra, hi, vr,
                                                                           di, flecha0, R_flecha_base, l, ntora, arv,
                                                                           linpeca, linpeca_preco,
                                                                           ang_base, escolha,
                                                                           flecha_div_r, cord_d1, cord_d, r_flecha_topo,
                                                                           s,
                                                                           codpeca_list, es_list, l_div_list,
                                                                           n_div_list, v_list, preco_list,
                                                                           precoa, precob, precoc, precod, precoe,
                                                                           precof, precog, precoh, precok)
                # -----------------------------------------------------------

            # -----------------------------------------------------
            # Seleciona Peça
            a, vra, na, va, b, vrb, nb, vb, c, vrc, nc, vc, d, vrd, nd, vd, \
            e, vre, ne, ve, f, vrf, nf, vf, g, vrg, ng, vg, h, vrh, nh, vh, k, vrk, nk, vk, vr, ntora, \
            codpeca_list, es_list, l_div_list, n_div_list, v_list, preco_list, \
            precoa, precob, precoc, precod, precoe, precof, precog, precoh, precok \
                = SubRotinas.SelecionaPeca_QuadCircun(a, vra, na, va, b, vrb, nb, vb, c, vrc, nc, vc, d, vrd, nd,
                                                      vd, e, vre, ne, ve, f, vrf, nf, vf, g, vrg, ng, vg, h, vrh, nh,
                                                      vh, k, vrk, nk, vk,
                                                      l_min_pecas, es_min_pecas, es_serra, hi, vr, l, ntora, arv,
                                                      linpeca, linpeca_preco,
                                                      cord_d, es_medula, flecha0, escolha,
                                                      codpeca_list, es_list, l_div_list, n_div_list, v_list, preco_list,
                                                      precoa, precob, precoc, precod, precoe, precof, precog, precoh,
                                                      precok)
            #  vt em VBA?
            # -----------------------------------------------------

        if escolha == '4':
            while l_d >= l_min_pecas + es_serra or l_s >= l_min_pecas + es_serra:
                if fatia == 0:
                    # ----------------------------------------------------
                    a, vra, na, va, b, vrb, nb, vb, c, vrc, nc, vc, d, vrd, nd, vd, \
                    e, vre, ne, ve, f, vrf, nf, vf, g, vrg, ng, vg, h, vrh, nh, vh, k, vrk, nk, vk, vr, \
                    linpeca, fatia, ang_e, ang_d, ang_i, ang_s, vr, es_serra, es, es1, es2, nes1, nes2, di, hi, l_e, l_d, l_i, l_s, l_sobra, ntora, \
                    codpeca_list, es_list, l_div_list, n_div_list, v_list, preco_list, \
                    precoa, precob, precoc, precod, precoe, precof, precog, precoh, precok \
                        = SubRotinas.SelecionaPeca_f0(a, vra, na, va, b, vrb, nb, vb, c, vrc, nc, vc, d, vrd, nd, vd,
                                                      e, vre, ne, ve, f, vrf, nf, vf, g, vrg, ng, vg, h, vrh, nh, vh, k,
                                                      vrk, nk, vk,
                                                      l_min_pecas, es_min_pecas, linpeca, linpeca_preco,
                                                      ang_e, ang_d, ang_i, ang_s, vr, es_serra, es, es1, es2, nes1,
                                                      nes2, di,
                                                      hi, l_e, l_d, l_i, l_s, l_sobra, ntora, arv,
                                                      codpeca_list, es_list, l_div_list, n_div_list, v_list, preco_list,
                                                      precoa, precob, precoc, precod, precoe, precof, precog, precoh,
                                                      precok, preco,
                                                      fatia)

                    fatia = 1
                    # -----------------------------------------------------

                if fatia == 1:
                    # ----------------------------------------------------
                    a, vra, na, va, b, vrb, nb, vb, c, vrc, nc, vc, d, vrd, nd, vd, \
                    e, vre, ne, ve, f, vrf, nf, vf, g, vrg, ng, vg, h, vrh, nh, vh, k, vrk, nk, vk, vr, \
                    linpeca, fatia, ang_e, ang_d, ang_i, ang_s, vr, es_serra, es, es1, es2, nes1, nes2, di, hi, l_e, l_d, l_i, l_s, l_sobra, ntora, \
                    codpeca_list, es_list, l_div_list, n_div_list, v_list, preco_list, \
                    precoa, precob, precoc, precod, precoe, precof, precog, precoh, precok \
                        = SubRotinas.SelecionaPeca_f1(a, vra, na, va, b, vrb, nb, vb, c, vrc, nc, vc, d, vrd, nd, vd,
                                                      e, vre, ne, ve, f, vrf, nf, vf, g, vrg, ng, vg, h, vrh, nh, vh, k,
                                                      vrk, nk, vk,
                                                      l_min_pecas, es_min_pecas, linpeca, linpeca_preco,
                                                      ang_e, ang_d, ang_i, ang_s, vr, es_serra, es, es1, es2, nes1,
                                                      nes2, di,
                                                      hi, l_e, l_d, l_i, l_s, l_sobra, ntora, arv,
                                                      codpeca_list, es_list, l_div_list, n_div_list, v_list, preco_list,
                                                      precoa, precob, precoc, precod, precoe, precof, precog, precoh,
                                                      precok, preco,
                                                      fatia)

                    fatia = 0
                    # ----------------------------------------------------
                    if l_d < es_min_pecas + es_serra and l_s < es_min_pecas + es_serra:
                        break

            # --------------------------------------------
            a1, vra1, na1, va1, b1, vrb1, nb1, vb1, c1, vrc1, nc1, vc1, d1, vrd1, nd1, vd1, \
            e1, vre1, ne1, ve1, f1, vrf1, nf1, vf1, g1, vrg1, ng1, vg1, h1, vrh1, nh1, vh1, k1, vrk1, nk1, vk1, vrt, \
            precoa1, precob1, precoc1, precod1, precoe1, precof1, precog1, precoh1, precok1, precot \
                = SubRotinas.RelatorioFinal(a1, vra1, na1, va1, b1, vrb1, nb1, vb1, c1, vrc1, nc1, vc1, d1, vrd1, nd1,
                                            vd1,
                                            e1, vre1, ne1, ve1, f1, vrf1, nf1, vf1, g1, vrg1, ng1, vg1, h1, vrh1, nh1,
                                            vh1, k1, vrk1, nk1, vk1,
                                            a, vra, na, va, b, vrb, nb, vb, c, vrc, nc, vc, d, vrd, nd, vd,
                                            e, vre, ne, ve, f, vrf, nf, vf, g, vrg, ng, vg, h, vrh, nh, vh, k, vrk, nk,
                                            vk,
                                            precoa, precob, precoc, precod, precoe, precof, precog, precoh, precok,
                                            precoa1, precob1, precoc1, precod1, precoe1, precof1, precog1, precoh1,
                                            precok1)
            # --------------------------------------------
            precoa = precob = precoc = precod = precoe = precof = precog = precoh = precok = preco = 0.0000


        if (escolha == '5'):
            # ----------------------------------------------------------------------------------
            # SelecionaPeca
            a, vra, b, vrb, c, vrc, d, vrd, e, vre, f, vrf, g, vrg, h, vrh, k, vrk, hi, ntora, \
            codpeca_list_r, vr_list, di_casc2_list, di_casc_list, di_list, ntora_list, arv_list, parc_list, preco_list_r, \
            vp_rolic_list, \
            conic_tora_list, \
            precoa, precob, precoc, precod, precoe, precof, precog, precoh, precok \
                = SubRotinas.SelecionaPeca(a, vra, b, vrb, c, vrc, d, vrd, e, vre, f, vrf, g, vrg, h, vrh, k, vrk,
                                           dap, ht, hc, hi_atual, hi_min, di_casc, di_casc2, di, prop_casc, ntora, arv, cod_arv,
                                           parc, linpeca,
                                           escolhaEqForma, B0f, B1f, B2f,
                                           conic_tora,
                                           codpeca_list_r, vr_list, di_casc2_list, di_casc_list, di_list, ntora_list,
                                           arv_list, parc_list, preco_list_r,
                                           vp_rolic_list,
                                           conic_tora_list,
                                           precoa, precob, precoc, precod, precoe, precof, precog, precoh, precok)
            # ----------------------------------------------------------------------------------

        # 'Rendimento por tora
        if escolha !='4':
            v_ptora = va - va_ptora + vb - vb_ptora + vc - vc_ptora + \
                      vd - vd_ptora + ve - ve_ptora + vf - vf_ptora + \
                      vg - vg_ptora + vh - vh_ptora + vk - vk_ptora

        if escolha == '1' or escolha == '2' or escolha == '3' or escolha == '7':
            rend_ptora = v_ptora / vr_rend

        if escolha == '4':
            v_ptora = va1 -va_ptora4 + vb1 - vb_ptora4 + vc1 - vc_ptora4 + \
                      vd1 - vd_ptora4 + ve1 - ve_ptora4 + vf1 - vf_ptora4 + \
                      vg1 - vg_ptora4 + vh1 - vh_ptora4 + vk1 - vk_ptora4

            va_ptora4 = va1
            vb_ptora4 = vb1
            vc_ptora4 = vc1
            vd_ptora4 = vd1
            ve_ptora4 = ve1
            vf_ptora4 = vf1
            vg_ptora4 = vg1
            vh_ptora4 = vh1
            vk_ptora4 = vk1

            rend_ptora = v_ptora * 4 / vr_rend
            print(rend_ptora)

        if escolha == '8':
            rend_ptora = v_ptora * 2 / vr_rend

        rend_ptora_list.append(rend_ptora)

        va_ptora = va
        vb_ptora = vb
        vc_ptora = vc
        vd_ptora = vd
        ve_ptora = ve
        vf_ptora = vf
        vg_ptora = vg
        vh_ptora = vh
        vk_ptora = vk

        if escolha == '6':
            # 'Relatório de dimensões da laminação
            comp_lamin_list.append(comp_lamin1 / 1000)
            vr_list.append(vr)
            ntora_list.append(ntora)
            arv_list.append(cod_arv)
            parc_list.append(parc)

            comp_lamin_arv = comp_lamin_arv + comp_lamin1 / 1000
            comp_lamin_total = comp_lamin_total + comp_lamin1 / 1000

            # 'armazena a linha de gravação dos dados em Relat_Serrad
            # print('compr.lamin.(m):{}, vol.tora:{}, num. tora:{},arv{}'.format((comp_lamin1 - comp_lamin1_eixo) / 1000, vr,
            #                                                                    ntora, arv))
            comp_lamin1 = 0

        # atualiza hi_atual com o comprimento da tora calculada (hi)
        hi_atual = hi_atual + hi

        if escolha == '5':
            hi = hi_min

        # print('hi_atual=', hi_atual)

    # 'zera para rendimento de toras da próxima árvore
    va_ptora = 0
    vb_ptora = 0
    vc_ptora = 0
    vd_ptora = 0
    ve_ptora = 0
    vf_ptora = 0
    vg_ptora = 0
    vh_ptora = 0
    vk_ptora = 0

    va_ptora4 = va1
    vb_ptora4 = vb1
    vc_ptora4 = vc1
    vd_ptora4 = vd1
    ve_ptora4 = ve1
    vf_ptora4 = vf1
    vg_ptora4 = vg1
    vh_ptora4 = vh1
    vk_ptora4 = vk1

    # acumula vt da árvore e zera vt
    vt1 = vt1 + vt
    vt = 0
    arv = arv + 1

    # 'acumula numero de toras da arvore (ntora) para resultado total de toras na amostra
    ntora1 = ntora1 + ntora
    ntora = 0

    # retorna altura do toco
    hi_atual = 0.15  # Precisa pegar valor definido pelo usuario não é fixo

    if (escolha == '1' or escolha == '2' or escolha == '3' or escolha == '5' or escolha == '7'
            or escolha == '8'):
        # --------------------------------------------
        a1, vra1, na1, va1, b1, vrb1, nb1, vb1, c1, vrc1, nc1, vc1, d1, vrd1, nd1, vd1, \
        e1, vre1, ne1, ve1, f1, vrf1, nf1, vf1, g1, vrg1, ng1, vg1, h1, vrh1, nh1, vh1, k1, vrk1, nk1, vk1, vrt, \
        precoa1, precob1, precoc1, precod1, precoe1, precof1, precog1, precoh1, precok1, precot \
            = SubRotinas.RelatorioFinal(a1, vra1, na1, va1, b1, vrb1, nb1, vb1, c1, vrc1, nc1, vc1, d1, vrd1, nd1, vd1,
                                        e1, vre1, ne1, ve1, f1, vrf1, nf1, vf1, g1, vrg1, ng1, vg1, h1, vrh1, nh1, vh1,
                                        k1, vrk1, nk1, vk1,
                                        a, vra, na, va, b, vrb, nb, vb, c, vrc, nc, vc, d, vrd, nd, vd,
                                        e, vre, ne, ve, f, vrf, nf, vf, g, vrg, ng, vg, h, vrh, nh, vh, k, vrk, nk, vk,
                                        precoa, precob, precoc, precod, precoe, precof, precog, precoh, precok,
                                        precoa1, precob1, precoc1, precod1, precoe1, precof1, precog1, precoh1, precok1)
        # --------------------------------------------

    # varcolunas

    # Resultado Detalhado
    if escolha != '6':
        data0 = {'vr': vr_list, 'di_casc2': di_casc2_list, 'di_casc': di_casc_list, 'di_list': di_list,
                 'ntora': ntora_list, 'arv': arv_list, 'parc': parc_list, 'codpeca': codpeca_list_r, 'preco': preco_list_r, \
                 'conicidade': conic_tora_list, 'rend': rend_ptora_list}

        print(vr_list)
        soma_vr_list = soma_vr_list + sum(vr_list)

        print(vp_rolic_list)
        soma_vp_rolic_list = soma_vp_rolic_list + sum(vp_rolic_list)

        print(di_casc2_list)
        print(di_casc_list)
        print(di_list)
        print(ntora_list)
        print(arv_list)
        print(parc_list)
        print(codpeca_list_r)
        print(preco_list_r)
        print(conic_tora_list)
        print(rend_ptora_list)


        df0 = pd.DataFrame(data0, columns=data0.keys())

        print(df0)

    if escolha != '5' and escolha != '6':
        data01 = {'codpeca': codpeca_list, 'es': es_list, 'l': l_div_list, 'n': n_div_list, 'v': v_list, \
                  'preco': preco_list}

        df01 = pd.DataFrame(data01)

        print("-" * 70)
        print(df01)
        print("-" * 70)

    if escolha == '6':
        # 'Relatório de dimensões da laminação
        # 'armazena a linha de gravação dos dados em Relat_Serrad
        comp_lamin_list.append(comp_lamin_arv)
        vr_list.append('')
        ntora_list.append('')
        arv_list.append('')
        parc_list.append('')

        comp_lamin_arv = 0

        data02 = {'comp_lamin(m)': comp_lamin_list, 'vol.tora(m3)': vr_list,'num.tora': ntora_list,
                  'arv': arv_list, 'parc': parc_list}

        df02 = pd.DataFrame(data02)

        print(df02)

    print("-" * 70)

    codpeca_list_r = []
    codpeca_list = []
    es_list = []
    l_div_list = []
    n_div_list = []
    v_list = []
    vr_list = []
    vp_rolic_list = []
    di_casc2_list = []
    di_casc_list = []
    di_list = []
    ntora_list = []
    arv_list = []
    parc_list = []
    preco_list_r = []
    preco_list = []
    comp_lamin_list = []

    conic_tora_list = []
    rend_ptora_list = []

num_tora_ha_list = []
vol_tora_ha_list = []
num_peca_ha_list = []
vol_peca_ha_list = []
preco_ha_list = []

preco_tora_ha_list = []

num_tora_ha = vol_tora_ha = num_peca_ha = vol_peca_ha = preco_ha = 0.0000
num_tora_ha1 = vol_tora_ha1 = num_peca_ha1 = vol_peca_ha1 = preco_ha1 = 0.0000

preco_tora_ha1 = 0.0000

# Resultado Sintético
if escolha != '5' and escolha != '6':
    codpeca = [1, 2, 3, 4, 5, 6, 7, 8, 9]

    nomepeca = ['Sarrafo', 'Ripão', 'Caibro', 'Pontalete', 'Ripa', 'Viga', 'Tabua', 'Prancha', 'Pranchão']

if escolha == '5':
    codpeca = [1, 2, 3, 4, 5, 6, 7, 8, 9]
    nomepeca = ['Cercas', 'Escoramento p/ fruticultura', 'Esticador p/ fruticultura/instalação',
                'Esticador intermediário', 'Esticador para cerca', 'Esticador p/cerca,curral intermed.',
                'Esticador p/cerca,curral canto,cancela', 'Poste', 'Madeira Serrada']

num_tora = [a1, b1, c1, d1, e1, f1, g1, h1, k1]

vol_tora = [vra1, vrb1, vrc1, vrd1, vre1, vrf1, vrg1, vrh1, vrk1]

preco_tora = [precoa1, precob1, precoc1, precod1, precoe1, precof1, precog1, precoh1, precok1]


if escolha == '4':
    num_peca = [na1 * 4, nb1 * 4, nc1 * 4, nd1 * 4, ne1 * 4, nf1 * 4, ng1 * 4, nh1 * 4, nk1 * 4]

    vol_peca = [va1 * 4, vb1 * 4, vc1 * 4, vd1 * 4, ve1 * 4, vf1 * 4, vg1 * 4, vh1 * 4, vk1 * 4]

    preco = [precoa1 * 4, precob1 * 4, precoc1 * 4, precod1 * 4, precoe1 * 4, precof1 * 4, precog1 * 4, precoh1 * 4,
             precok1 * 4]

    num_peca_sum = na1 * 4 + nb1 * 4 + nc1 * 4 + nd1 * 4 + ne1 * 4 + nf1 * 4 + ng1 * 4 + nh1 * 4 + nk1 * 4
    vol_peca_sum = va1 * 4 + vb1 * 4 + vc1 * 4 + vd1 * 4 + ve1 * 4 + vf1 * 4 + vg1 * 4 + vh1 * 4 + vk1 * 4

elif escolha == '8':
    num_peca = [na1 * 2, nb1 * 2, nc1 * 2, nd1 * 2, ne1 * 2, nf1 * 2, ng1 * 2, nh1 * 2, nk1 * 2]

    vol_peca = [va1 * 2, vb1 * 2, vc1 * 2, vd1 * 2, ve1 * 2, vf1 * 2, vg1 * 2, vh1 * 2, vk1 * 2]

    preco = [precoa1 * 2, precob1 * 2, precoc1 * 2, precod1 * 2, precoe1 * 2, precof1 * 2, precog1 * 2, precoh1 * 2,
             precok1 * 2]

    num_peca_sum = na1 * 2 + nb1 * 2 + nc1 * 2 + nd1 * 2 + ne1 * 2 + nf1 * 2 + ng1 * 2 + nh1 * 2 + nk1 * 2
    vol_peca_sum = va1 * 2 + vb1 * 2 + vc1 * 2 + vd1 * 2 + ve1 * 2 + vf1 * 2 + vg1 * 2 + vh1 * 2 + vk1 * 2

elif escolha != '5' and escolha != '6':
    num_peca = [na1, nb1, nc1, nd1, ne1, nf1, ng1, nh1, nk1]

    vol_peca = [va1, vb1, vc1, vd1, ve1, vf1, vg1, vh1, vk1]

    preco = [precoa1, precob1, precoc1, precod1, precoe1, precof1, precog1, precoh1, precok1]

    num_peca_sum = na1 + nb1 + nc1 + nd1 + ne1 + nf1 + ng1 + nh1 + nk1
    vol_peca_sum = va1 + vb1 + vc1 + vd1 + ve1 + vf1 + vg1 + vh1 + vk1

# create a dictionary
# create dataframe

if escolha != '5' and escolha != '6':
    data = {'codpeca': codpeca, 'nomepeca': nomepeca, 'numtora': num_tora, 'vol_tora': vol_tora, 'num_peca': num_peca,
            'vol_peca': vol_peca, 'preco_(R$)': preco}

    df = pd.DataFrame(data)
    print(df)
    print('-' * 20)
    print('árvores desdobradas: %s' % arv_proces)

if escolha == '5':
    data = {'codpeca': codpeca, 'nomepeca': nomepeca, 'numtora': num_tora, 'vol_tora': vol_tora,
            'preco(R$)': preco_tora}

    df = pd.DataFrame(data, columns=data.keys())
    print(df)
    print('-' * 20)
    print('árvores para peças roliças: %s' % arv_proces)
    print('-' * 20)

    preco_tora_sum = precoa1 + precob1 + precoc1 + precod1 + precoe1 + precof1 + precog1 + precoh1 + precok1

    print('R($)/m3 Peças Roliças: %s' % (preco_tora_sum/vrt))
    print('-' * 20)
    print('R($)/m3 Arvores: %s' % (preco_tora_sum/vt1))
    print('-' * 20)

    print('Resíduo Volume tora total - Volume peça roliça (%s): %s' % ('%', ((soma_vr_list - soma_vp_rolic_list)/soma_vr_list)))
    print('Volume tora total: %s' % soma_vr_list)
    print('Volume peça roliça: %s' % soma_vp_rolic_list)

print('-' * 70)
print('')
print('-' * 20)
print('Volume tora total: %s' % vrt)
print('-' * 20)
print('Volume total: %s' % vt1)
print('-' * 20)
print('Toras totais: %s' % ntora1)
print('-' * 20)
print('Arvores: %s' % narv)
print('-' * 20)
print('Falhas: %s' % falha)

if escolha != '4' and escolha != '8' and vol_peca_sum != 0 and vrt != 0 and vt1 != 0:
    print('Preço Total (R$): %s' % precot)

    if escolha != '5' and escolha != '6':
        print('Preço Peças (R$/m3): {}'.format(precot / vol_peca_sum))
        print('Preço Toras (R$/m3): {}'.format(precot / vrt))

    print('Preço Arvores (R$/m3): {}'.format(precot / vt1))

if escolha == '4' and vol_peca_sum != 0 and vrt != 0 and vt1 != 0:
    print('Preço Total (R$): %s' % precot*4)
    print('Preço Peças (R$/m3): {}'.format(precot * 4 / vol_peca_sum))
    print('Preço Toras (R$/m3): {}'.format(precot * 4 / vrt))
    print('Preço Arvores (R$/m3): {}'.format(precot * 4 / vt1))

if escolha == '8' and vol_peca_sum != 0 and vrt != 0 and vt1 != 0:
    print('Preço Total (R$): {}'.format(precot * 2))
    print('Preço Peças (R$/m3): {}'.format(precot * 2 / vol_peca_sum))
    print('Preço Toras (R$/m3): {}'.format(precot * 2 / vrt))
    print('Preço Arvores (R$/m3): {}'.format(precot * 2 / vt1))

print('-' * 20)

if escolha == '6' and comp_folha != 0:
    print('comprim. total de laminação (m): %s' % comp_lamin_total)

    print('numero de folhas: ', math.trunc(comp_lamin_total / comp_folha))

# Calculo Sintético por ha

if escolha != '6':
    print("Entre com o número total de árvores plantadas por ha!")
    narv_ha = int(input("arv/ha: "))

if (escolha == '1' or escolha == '2' or escolha == '3' or escolha == '4' or escolha == '7'
        or escolha == '8'):

    for i in range(0, len(codpeca)):
        num_tora_ha = int(num_tora[i] * narv_ha/ narv)
        vol_tora_ha = (vol_tora[i] *narv_ha / narv)

        num_tora_ha_list.append(num_tora_ha)
        vol_tora_ha_list.append(vol_tora_ha)

        num_peca_ha = int(num_peca[i] *narv_ha / narv)
        vol_peca_ha = vol_peca[i] * narv_ha / narv
        preco_ha = int(preco[i] *narv_ha / narv)

        num_peca_ha_list.append(num_peca_ha)
        vol_peca_ha_list.append(vol_peca_ha)
        preco_ha_list.append(preco_ha)

        num_tora_ha1 = num_tora_ha1 + num_tora_ha
        vol_tora_ha1 = vol_tora_ha1 + vol_tora_ha
        num_peca_ha1 = num_peca_ha1 + num_peca_ha
        vol_peca_ha1 = vol_peca_ha1 + vol_peca_ha
        preco_ha1 = preco_ha1 + preco_ha

    codpeca.append('Total')
    nomepeca.append('')
    num_tora_ha_list.append(num_tora_ha1)
    vol_tora_ha_list.append(vol_tora_ha1)
    num_peca_ha_list.append(num_peca_ha1)
    vol_peca_ha_list.append(vol_peca_ha1)
    preco_ha_list.append(preco_ha1)

    if (escolha == '1' or escolha == '2' or escolha == '3' or escolha == '4' or escolha == '7'
            or escolha == '8'):
        data_ha = {'codpeca': codpeca, 'nomepeca': nomepeca, 'numtora': num_tora_ha_list, 'vol_tora': vol_tora_ha_list,
                   'num_peca': num_peca_ha_list, 'vol_peca': vol_peca_ha_list, 'preco_(R$)': preco_ha_list}

    df = pd.DataFrame(data_ha)
    print("-" * 70)
    print(df)
    print("-" * 70)
    print('arvores serradas/ha: ', arv_proces * narv_ha / narv)
    print("-" * 70)
    print('falhas: ', falha*narv_ha/narv)

if escolha == '5':

    for i in range(0, len(codpeca)):
        num_tora_ha = int(num_tora[i] * narv_ha / narv)
        vol_tora_ha = (vol_tora[i] * narv_ha / narv)
        preco_tora_ha = int(preco_tora[i] * narv_ha / narv)

        num_tora_ha_list.append(num_tora_ha)
        vol_tora_ha_list.append(vol_tora_ha)
        preco_tora_ha_list.append(preco_tora_ha)

        num_tora_ha1 = num_tora_ha1 + num_tora_ha
        vol_tora_ha1 = vol_tora_ha1 + vol_tora_ha
        preco_tora_ha1 = preco_tora_ha1 + preco_tora_ha

    codpeca.append('Total')
    nomepeca.append('')
    num_tora_ha_list.append(num_tora_ha1)
    vol_tora_ha_list.append(vol_tora_ha1)
    preco_tora_ha_list.append(preco_tora_ha1)

    data_ha_r = {'codpeca': codpeca, 'nomepeca': nomepeca, 'numtora': num_tora_ha_list, 'vol_tora': vol_tora_ha_list,
                 'preco(R$)': preco_tora_ha_list}

    df = pd.DataFrame(data_ha_r, columns=data_ha_r.keys())
    print("-" * 70)
    print(df)
    print("-" * 70)
    print('arvores roliças/ha: ',arv_proces*narv_ha/narv)
    print("-" * 70)
    print('falhas: ', falha*narv_ha/narv)

print("-" * 70)
print('vol/ha: ', vt1*narv_ha/narv)
print("-" * 70)
