# -*-coding: UTF-8-*-

import pandas as pd
pd.set_option('display.max_columns', 10)
import SubRotinas
from Formulas import *
import math
import numpy as np
# -------------------------------------------------------------------------
# 'CalculaPecas

# hi - comprimento da tora = comprimento da peça
# es - espessura da peça
# es_serra - espessura da serra (perda de madeira no corte)
# min_es - menor espessura da peça
# max_es - maior espessura da peça
# di_casc - diâmetro com casca
# di_casc2 - diâmetro com casca para calculo do volume da peça
# di- diâmetro sem casca
# l - largura peça
# l_d, l_e - larguras direita e esquerda da peça
# 'l_s, l_i - larguras superior e inferior da peça
# 'l_d2 - largura direita da próxima peça
# 'l_s2 - largura superior da próxima peça
# 'cord_d, cord_e - cordas direita e esquerda da peça
# 'cord_s, cord_i - cordas superior e inferior da peça
# 'ang_d, ang_e - angulos direito e esquerdo formados c respectivas cordas
# 'ang_s, ang_i - angulos superior e inferior formados c respectivas cordas
# es_sobra - sobra peça
# v - volume peça
# vr - volume tora
# vt - volume arvore
# n - num.peças
# ntora - numero da tora
# narv - numero de árvores da amostra
# codpeca-codigo peça


# def __getitem__(self, item):
#     return self.SelecionaPeca[item]


escolha = ''
while (escolha == ''):
    print('Desdobro por toras individuais\n'
          'Digite:\n'
          ' 0 para terminar\n'
          ' 1 para CalculaPecasMadSerr_QuadCirun\n'
          ' 2 para CalculaPecasMadSerr_Longitudinal\n'
          ' 3 para CalculaPecasMadSerr_Longitudinal_CostBase\n'
          ' 4 para CalculaPecasMadSerr_Radial\n'
          ' 6 para CalculaMadeiraLaminada\n'
          ' 7 para CalculaPecasMadSerr_Gira_180_90\n'
          ' 8 para CalculaPecasMadSerr_Radial_Longitudinal\n')

    escolha = input()

# -----------------------------------------------------------------
print('Calculador de Madeira por Tora')

# -----------------------
lintora, ntora1 = SubRotinas.learq2()
# -----------------------

codpeca = 0
peca = 0 # nome da peça
di_casc = di_casc2 = 0
ntora = 1 # numero de toras por árvore
cod_arv = 0 # codigo da árvore no inventário

# Alteração 01/08/2023
talh = 0 # para não travar subrotinas, não existe no arquivo Toras.txt
parc = 0 # numero de parcelas
vrt = 0.0000
preco = 0.0000
precot = 0.0000
preco_medula = 0.0000
conic_tora = 0.0000

# Para acumulo de peças do Relatorio Detalhado
codpeca_list = []

# Alteração 01/08/2023
talh_list = []
peca_list = []
es_list = []
l_div_list = []
n_div_list = []
v_list = []
hi_list = []
vr_list = []
di_casc2_list = []
di_casc_list = []
di_list = []
ntora_list = []
arv_list = []
arv_parc_list = []
parc_list = []
parc2_list = []
preco_list = []
conic_tora_list = []

comp_lamin_list = []

# Var Madeira Laminada
comp_lamin1 = 0.0000
comp_lamin1_eixo = 0.0000

nes1 = nes2 = es1 = es2 = 0

# --------------------
linpeca = SubRotinas.learq1()
# --------------------

# Receita (R$)
# -----------------------
linpeca_preco = SubRotinas.learq7()
# -----------------------

# Parametro da Madeira Laminada
if escolha == '6':
    print('Entre com diametro não aproveitavel para laminar (diametro do rolo resto, mm):')
    di_eixo = float(input())

    print('Entre com o comprimento da folha em metros!')
    comp_folha = float(input())

    t = 0
    comp_lamin_total = 0

# declarando variáveis, não necessário no VBA
di = 100
l = 100
# -------------------------------------------
es_serra, hi_atual, hi, hi_min, prop_casc, l_min_pecas, es_min_pecas, di_min, es_perim, \
flecha_div_r, es_medula = SubRotinas.parametros(escolha)
# -------------------------------------------

# Executa por tora
while ntora <= ntora1:
    v = 0.0000
    n = 0
    vr = 0.0000  # volume da tora

    # Acessa arquivo texto, armazena dap e ht por árvore, e calcula seu volume (vt)
    dados = lintora[ntora].split()

    # Alteração 01/08/2023
    # Para criar campos com zero em falhas do Tora.txt
    # procedimento diferente do CalculaPecasRolicas.py
    comp = len(dados)
    if comp < 6:
        for i in range(comp, 6):
            dados.append(0)

    parc0 = float(dados[0])
    parc = int(parc0)
    cod_arv = float(dados[1])
    cod_tora = int(dados[2])
    di_casc2 = float(dados[3])
    di_casc = float(dados[4])
    hi = float(dados[5])

    es_sobra = 100

    # volume da tora usando formula de Smalian
    vr = math.pi / 40000 * (di_casc ** 2 + di_casc2 ** 2) / 2 * hi

    di = di_casc2 * (1 - prop_casc) * 10

    # Alteração 01/08/2023
    if hi != 0 and hi != "":
        # Conicidade da tora (cm/m)
        conic_tora = (di_casc - di_casc2) / hi

    preco = 0

    # Se posteriormente interessar preco e identificação para toras para madeira serrada
    print('vr:{}, di_casc2:{}, di_casc:{}, di:{}, tora:{},arv:{}, parc: {}. conic_tora:{}'. \
          format(vr, di_casc2, di_casc, di, cod_tora, cod_arv, parc, conic_tora))

    vrt = vrt + vr

    flecha = flecha0 = 0
    cord_d1 = 0
    cord_d = 0
    r_flecha_topo = 0
    R_flecha_base = 0
    s = 0

    if escolha != '7':
        es_medula = 0

    if escolha == '1':
        # largura da peça
        l = di / math.sqrt(2)

    if escolha == '2' or escolha == '3' or escolha == '7' or escolha == '8':

        # angulo inicial para desconto do di para cada lado (flecha0) e angulo da base
        ang_d, ang_base = ang_costan()

        if escolha == '3':
            # comprimento da peça, do eixo x até o limite da costaneira da base (R-flecha)
            R_flecha_base = di / 2 * math.cos(ang_base * math.pi / 180)

        if escolha != '3':
            ang_base = 0

        if escolha == '8':
            ang_base = 90
            R_flecha_base = 0

        flecha0 = di / 2 * (1 - math.cos(ang_d * math.pi / 180))

        # 'largura da peça (corda)
        # 'Case 2 e 7: Longitudinal completo quando ang_base = 0
        # 'Case 3: quando compara ang_d com ang_base
        # 'Case 8: quando ang_base = 90

        # largura da peça (corda)
        if ang_d < (90 - ang_base) or ang_base == 0:
            l = di * math.sin(ang_d * math.pi / 180)
        else:
            l = di * (math.sin(ang_d * math.pi / 180) / 2) + R_flecha_base

    if escolha == '4':
        l = di / 2

    # passado pela função parametros
    # continue para passar para a próxima tora.
    # soma na contagem, porque conta tora não desdobrada.
    # total de toras informa toras totais.

    if escolha == '1':
        if l < l_min_pecas + es_serra:
            ntora = ntora + 1
            continue

    if escolha == '2' or escolha == '3' or escolha == '7':
        if di < l_min_pecas + es_serra:
            ntora = ntora + 1
            continue

    if escolha == '4':

        # passado pela função parametros
        if l < l_min_pecas + es_serra or di / 2 < es_min_pecas + es_serra:
            ntora = ntora + 1
            continue

        l_e = l_d = l_i = l_s = l
        l_sobra = 0.0000
        nes1 = nes2 = 0.0
        es1 = es2 = 0.0
        ang_d = 90.0000
        ang_s = 0.0000
        ang_e = ang_i = 0

        fatia = 0

        n1 = v1 = 0

        # Verifica se pelo menos a menor peça será selecionada
        es = es_min_pecas + es_serra
        # ---------------------------------------------
        ang_e, ang_d, ang_i, ang_s, l_e, l_d, l_i, l_s \
            = Formulas(fatia, nes1, nes2, es, es_serra,
                di, ang_e, ang_d, ang_i, ang_s, l_e, l_d, l_i, l_s)
        # ---------------------------------------------
        es = 0

    if escolha == '6':
        # 'numero de voltas totais
        if es_perim > 0:
            n = int(di / 2 / es_perim)
        else:
            print("escolha espessura da lamina em mm!")
            break

        for t in range(0, n + 1):
            # 'comprimento da lamina (mm)

            comp_lamin = math.pi * (di - t * 2 * es_perim)

            if (di - t * 2 * es_perim) < di_eixo:
                break

            comp_lamin1 = comp_lamin1 + comp_lamin

            # ----------------------

    if (escolha == '1'):
        # -----------------------------------------------------
        # Seleciona Peça
        vr, cod_tora, \
        codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list, \
        ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, talh_list, parc_list, conic_tora_list \
            = SubRotinas.SelecionaPeca_QuadCircun(es_serra, hi, vr, l, cod_tora, linpeca, linpeca_preco,
                                                  cord_d, es_medula, escolha,
                                                  di_casc2, di_casc, di, cod_arv, talh, parc, conic_tora,
                                                  ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, talh_list,
                                                  parc_list, conic_tora_list,
                                                  codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list,
                                                  preco_list)
        # -----------------------------------------------------

    if escolha == '2' or escolha == '3' or escolha == '8':
        # -----------------------------------------------------
        # Seleciona Peça
        vr, cod_tora, \
        l, cord_d1, cord_d, r_flecha_topo, s, \
        codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list, \
        ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, parc_list, conic_tora_list \
            = SubRotinas.SelecionaPeca_Longitudinal_CostaneiraBase(
            l_min_pecas, es_min_pecas, es_serra, hi, vr,
            flecha0, R_flecha_base, l, cod_tora, linpeca, linpeca_preco,
            ang_base, escolha, flecha_div_r, cord_d1, cord_d, r_flecha_topo, s,
            di_casc2, di_casc, di, cod_arv, talh, parc, conic_tora,
            ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, talh_list, parc_list, conic_tora_list,
            codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list
        )
        # -----------------------------------------------------------

    if escolha == '7':
        l_sobra = l
        flecha = 0
        r_flecha_topo = 0.0000
        cord_d = 0

        for s in range(0, 1 + 1):
            # -----------------------------------------------------
            # Seleciona Peça
            vr, cod_tora, \
            l, cord_d1, cord_d, r_flecha_topo, s, \
            codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list, \
            ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, talh_list, parc_list, conic_tora_list \
                = SubRotinas.SelecionaPeca_Longitudinal_CostaneiraBase(
                l_min_pecas, es_min_pecas, es_serra, hi, vr,
                flecha0, R_flecha_base, l, cod_tora, linpeca, linpeca_preco,
                ang_base, escolha, flecha_div_r, cord_d1, cord_d, r_flecha_topo, s,
                di_casc2, di_casc, di, cod_arv, talh, parc, conic_tora,
                ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, talh_list, parc_list, conic_tora_list,
                codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list
            )
            # -----------------------------------------------------------

            # -----------------------------------------------------
            # Seleciona Peça
            vr, cod_tora, \
            codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list, \
            ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, talh_list, parc_list, conic_tora_list \
                = SubRotinas.SelecionaPeca_QuadCircun(es_serra, hi, vr, l, cod_tora, linpeca, linpeca_preco,
                                                      cord_d, es_medula, escolha,
                                                      di_casc2, di_casc, di, cod_arv, talh, parc, conic_tora,
                                                      ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list,
                                                      arv_list, talh_list, parc_list, conic_tora_list,
                                                      codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list,
                                                      preco_list)
            # -----------------------------------------------------
    # Alteração 01/08/2023
    if escolha == '4':
        while l_d >= l_min_pecas + es_serra or l_s >= l_min_pecas + es_serra:
            if fatia == 0:
                # ----------------------------------------------------
                linpeca, fatia, ang_e, ang_d, ang_i, ang_s, vr, es_serra, es, es1, es2, nes1, nes2, di, hi, l_e, l_d, l_i, l_s, l_sobra, cod_tora, \
                    codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list, \
                    ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, talh_list, parc_list, conic_tora_list \
                    = SubRotinas.SelecionaPeca_f0(
                    l_min_pecas, es_min_pecas, linpeca, linpeca_preco,
                    ang_e, ang_d, ang_i, ang_s, vr, es_serra, es, es1, es2, nes1,
                    nes2,
                    hi, l_e, l_d, l_i, l_s, l_sobra, cod_tora,
                    di_casc2, di_casc, di, cod_arv, talh, parc, conic_tora,
                    ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, talh_list, parc_list,
                    conic_tora_list,
                    codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list,
                    preco, fatia)

                fatia = 1
                # -----------------------------------------------------

            if fatia == 1:
                # ----------------------------------------------------
                linpeca, fatia, ang_e, ang_d, ang_i, ang_s, vr, es_serra, es, es1, es2, nes1, nes2, di, hi, l_e, l_d, l_i, l_s, l_sobra, cod_tora, \
                codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list, \
                ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, talh_list, parc_list, conic_tora_list \
                    = SubRotinas.SelecionaPeca_f1(
                    l_min_pecas, es_min_pecas, linpeca, linpeca_preco,
                    ang_e, ang_d, ang_i, ang_s, vr, es_serra, es, es1, es2, nes1,
                    nes2,
                    hi, l_e, l_d, l_i, l_s, l_sobra, cod_tora,
                    di_casc2, di_casc, di, cod_arv, talh, parc, conic_tora,
                    ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, talh_list, parc_list, conic_tora_list,
                    codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list,
                    preco, fatia)

                fatia = 0
                # ----------------------------------------------------

                if l_d < es_min_pecas + es_serra and l_s < es_min_pecas + es_serra:
                    break

    if escolha == '6':
        # 'Relatório de dimensões da laminação
        comp_lamin_list.append(comp_lamin1 / 1000)
        hi_list.append(hi)
        vr_list.append(vr)
        ntora_list.append(cod_tora)
        arv_list.append(cod_arv)
        parc_list.append(parc)

        comp_lamin_total = comp_lamin_total + comp_lamin1 / 1000

        # 'armazena a linha de gravação dos dados em Relat_Serrad
        # print('compr.lamin.(m):{}, vol.tora:{}, num. tora:{},arv{}'.format((comp_lamin - comp_lamin_eixo) / 1000, vr,
        #                                                                    cod_tora, arv))
        comp_lamin1 = 0

    # loop da tora
    ntora = ntora + 1

ntora = 0


if escolha == '6':
    # 'Relatório de dimensões da laminação
    # 'armazena a linha de gravação dos dados em Relat_Serrad
    # comp_lamin_list.append(comp_lamin_arv)

    comp_lamin_arv = 0

    data02 = {'comp_lamin(m)': comp_lamin_list}

    df02 = pd.DataFrame(data02)

    print(df02)

    if comp_folha != 0:
        # print('comprim. total de laminação (m): ' + comp_lamin_total)

        print('numero de folhas: ', math.trunc(comp_lamin_total / comp_folha))

    exit()


# ROTINAS 4 e 8 TEM MULTIPLICADORES PARA NÚMERO DE PEÇAS E SEUS RESPECTIVOS VOLUMES E PREÇOS
if escolha == '4':
    n_div_list = np.multiply(n_div_list, 4)
    v_list = np.multiply(v_list, 4)
    preco_list = np.multiply(preco_list, 4)

elif escolha == '8':
    n_div_list = np.multiply(n_div_list, 2)
    v_list = np.multiply(v_list, 2)
    preco_list = np.multiply(preco_list, 2)

# -----------------------------------------------------------------------------------
# CRV (v/vr)
CRV_freq = []
i = 0
j = 0
v = 0
vr = 0

while i < len(ntora_list):

    while i < len(ntora_list) - 1 and \
        ntora_list[i] == ntora_list[i + 1] \
        and arv_list[i] == arv_list[i + 1]\
        and parc_list[i] == parc_list[i + 1]:

        v = v + v_list[i]
        vr = vr + vr_list[i]

        i = i + 1
        j = j + 1

    v = v + v_list[i]
    vr = vr + vr_list[i]

    i = i + 1
    j = j + 1

    # print('-' * 100)
    # print('tora:{}, v: {}, vr: {}, CRV: {}, i: {}, j: {}'. format(ntora_list[i-1], v, vr/j, v/(vr/j), i, j))
    # print('-' * 100)

    for k in range(0,j):
        CRV_freq.append(v/(vr/j))

    j = 0
    v = 0
    vr = 0

# ------------------------------------------------------------------------------------
# RESULTADO DETALHADO

print('')
print('Relatório Detalhado Serrada')
print('-' * 70)

if escolha != '6':
    data0 = {'codpeca': codpeca_list, 'peca': peca_list, 'es': es_list, 'l': l_div_list,
             'n': n_div_list, 'v': v_list, 'tora': ntora_list, 'hi': hi_list, 'vr': vr_list,
             'di_casc2': di_casc2_list, 'di_casc': di_casc_list, 'di': di_list,
             'arv': arv_list, 'parc': parc_list, 'preco': preco_list,
             'conicidade': conic_tora_list, 'CRV': CRV_freq}

print('codpeca:{}'.format(len(codpeca_list)))
print('peca:{}'.format(len(peca_list)))
print('es:{}'.format(len(es_list)))
print('l:{}'.format(len(l_div_list)))
print('n:{}'.format(len(n_div_list)))
print('v:{}'.format(len(v_list)))
print('tora:{}'.format(len(ntora_list)))
print('hi:{}'.format(len(hi_list)))
print('vr:{}'.format(len(vr_list)))
print('di_casc2:{}'.format(len(di_casc2_list)))
print('di_casc:{}'.format(len(di_casc_list)))
print('di:{}'.format(len(di_list)))
print('arv:{}'.format(len(arv_list)))
print('parc:{}'.format(len(parc_list)))
print('preco:{}'.format(len(preco_list)))
print('conic_tora:{}'.format(len(conic_tora_list)))
print('CRV:{}'.format(len(CRV_freq)))

df0 = pd.DataFrame(data0)
print("-" * 70)
print(df0)
print("-" * 70)

saida = df0.shape
print(saida)
print("-" * 70)

# ---------------------------------------------------------------
# RESULTADO SINTÉTICO

vr = 0.0000
n_pecas = 0
preco = 0.0000
n_arv = 0.0000
vr_t = 0.0000
v_t = 0.0000
n_pecas_t = 0
preco_t = 0.0000
ntora_t = 0.0000

# esp_arv = float(input("Entre com espaçamento entre árvores : "))
# esp_lin = float(input("Entre comespaçamento entre linhas : "))

arv_list_unico = np.unique(arv_list)

# # Preço da Floresta (Para preço inverso: valor pago pela madeira utilizada, desconsidera resíduo)
# pf = float(input("Entre com valor da floresta (R$/m3) : "))

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
# "FREQUENCIA DE PEÇAS RESULTADO TOTAL"

codpeca_freq = []
peca_freq = []
# ntora_freq = []
# vr_freq = []
n_pecas_freq = []
v_freq = []
preco_freq = []

codpeca_unico = np.unique(codpeca_list)

i = 0
j = 0

for j in range(0, len(codpeca_unico)):
    while i < len(parc_list):
        if codpeca_list[i] == codpeca_unico[j]:

            peca = peca_list[i]
            # ntora = ntora + ntora_list[i]
            # vr = vr + vr_list[i]
            n_pecas = n_pecas + n_div_list[i]
            v = v + v_list[i]
            preco = preco + preco_list[i]

        i = i + 1
    i = 0

    codpeca_freq.append(codpeca_unico[j])
    peca_freq.append(peca)
    # ntora_freq.append(ntora * fator_ha)
    # vr_freq.append(vr * fator_ha)
    n_pecas_freq.append(n_pecas)
    v_freq.append(v)
    preco_freq.append(preco)

    # ntora = vr = \
    n_pecas = v = preco = 0

data = {'codpeca_freq': codpeca_freq, 'peca_freq': peca_freq,
        'n_pecas_freq': n_pecas_freq, 'v_freq': v_freq, 'preco_freq': preco_freq}

# 'ntora_freq': ntora_freq,'vr_freq':vr_freq,

df = pd.DataFrame(data)
print("-" * 70)
print("Resultado Total")
print(df)
print("-" * 70)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
# "FREQUENCIA DE PEÇAS RESULTADO POR PARCELA"

parc_freq = []
codpeca_freq = []
peca_freq = []
# ntora_freq = []
# vr_freq = []
n_pecas_freq = []
v_freq = []
preco_freq = []

parc_unico = np.unique(parc_list)

arv_parc = 0
i = 0
i2 = 0
i3 = 0
j = 0
k = 0

for k in range(0, len(parc_unico)):

    for j in range(0, len(codpeca_unico)):

        while i < len(parc_list):

            if codpeca_list[i] == codpeca_unico[j] and parc_list[i] == parc_unico[k]:
                peca = peca_list[i]
                # ntora = ntora_list[i]
                # vr = vr + vr_list[i]
                n_pecas = n_pecas + n_div_list[i]
                v = v + v_list[i]
                preco = preco + preco_list[i]

            i = i + 1
        i = 0

        parc_freq.append(parc_unico[k])
        codpeca_freq.append(codpeca_unico[j])
        peca_freq.append(peca)
        # ntora_freq.append(ntora * fator_ha_parc)
        # vr_freq.append(vr * fator_ha_parc)
        n_pecas_freq.append(n_pecas)
        v_freq.append(v)
        preco_freq.append(preco)

        # ntora = vr = \
        n_pecas = v = preco = 0

data = {'parc_freq': parc_freq, 'codpeca_freq':codpeca_freq, 'peca': peca_freq,
      'n_pecas_freq': n_pecas_freq, 'v_freq': v_freq, 'preco_freq': preco_freq}

# 'ntora_freq': ntora_freq, 'vr_freq':vr_freq,

df = pd.DataFrame(data)
print("-" * 70)
print("Resultado Total por Parcela")
print(df)
print("-" * 70)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
# RESULTADO TOTALIZADO POR PARCELA

i = 0
j = 0
while i < len(parc_list):

    while i + 1 < len(parc_list) and parc_list[i] == parc_list[i + 1]:

        if vr_list[i] != vr_list[i - 1] and vr_list[i] is not str:
            vr = vr + vr_list[i]

        n_pecas = n_pecas + n_div_list[i]
        v = v + v_list[i]
        preco = preco + preco_list[i]

        if ntora_list[i] != ntora_list[i + 1]:
            ntora = ntora + 1
        i = i + 1

    if vr_list[i] != vr_list[i - 1] and vr_list[i] is not str:
        vr = vr + vr_list[i]

    n_pecas = n_pecas + n_div_list[i]
    v = v + v_list[i]
    preco = preco + preco_list[i]

    ntora = ntora + 1

    j = j + 1

    parcela = parc_list[i]
    i = i + 1

    # Dados por parcela
    # -------------------------------------------------------------
    print("-" * 70)
    print('parc: {}'.format(parcela))
    print('tora:{}'.format(ntora))
    # print('falha:{}'.format(falha))
    # print('n_pecas:{}'.format(n_pecas))
    print('vr:{}'.format(vr))
    # print('vt:{}'.format(vt))

    print('v:{}'.format(v))
    print('preco:{}'.format(preco))

    # print('Preço Inverso:')
    # print('preco/m3_inv:{}'.format(((pf * vt) / v)))
    # print("-" * 70)

    print('CRV:')
    print('v/vr:{}'.format(v / vr))

    print('Resíduos:')
    # print(f'Resíduo vol total - Vol peca: {vr - v}')
    # print(f'Resíduo Vol total/ha - Vol tora/ha: {vt - vr}')
    print("-" * 70)
    # print('Preço Arvores (R$/m3): {}'.format(preco / vt))
    print('Preço pecas (R$/m3): {}'.format(preco / v))
    print("-" * 70)

    # Total amostra
    vr_t = vr_t + vr
    v_t = v_t + v
    n_pecas_t = n_pecas_t + n_pecas
    preco_t = preco_t + preco
    ntora_t = ntora_t + ntora
    # falha_t = falha_t + falha

    vr = 0.0000
    vt = 0.0000
    v = 0.0000
    n_pecas = 0
    preco = 0.0000
    ntora = 0.0000

# Total/ha
# fator_ha_t = (10000 / (esp_arv * esp_lin * (n_arv_t + falha_t)))

print('Total')
print("-" * 70)
print('n_arv:{}'.format(ntora_t))
# print('falha:{}'.format(falha_t))
print('vr:{}'.format(vr_t))
# print('vt_t/ha:{}'.format(sum(vt_list)))
print('n_pecas:{}'.format(n_pecas_t))
print('v:{}'.format(v_t))
print('preco:{}'.format(preco_t))

print('Preço Inverso:')
# print('preco_inv:{}'.format(pf * sum(vt_list)))
# print('preco/m3_inv:{}'.format(pf * sum(vt_list) / v_t))
print("-" * 70)

# parc ha diversos
# ----------------------------------------------------------------
# print(f'Resíduo Vol tora - Vol peca: {(vr_t - v_t) }')
# print(f'Resíduo Vol total/ha - Vol tora/ha: {(sum(vt_list) - vr_t) }')
# print('Preço Arvores (R$/m3): {}'.format(preco_t / sum(vt_list)))
# print('Preço Toras (R$/m3): {}'.format(preco_t / vr_t))
# print('Preço pecas (R$/m3): {}'.format(preco_t / v_t))
# print('arvores serradas/ha: ', arv_proces )
