# -*-coding: UTF-8-*-

import pandas as pd

pd.set_option('display.max_columns', 10)
from sqlalchemy.dialects.mssql.information_schema import columns

import FFormaEqFormaCubagem
import Formulas
import SubRotinas
import psycopg2
from sqlalchemy import create_engine
import math
import re

import numpy as np

# ------------------------------------------------------------------
# CalculaPecas

# Dap - diametro a altura do peito
# ht - altura total da árvore
# hc - altura comercial da árvore
# hi - comprimento da tora = comprimento da peça
# hi_atual - começa com altura do toco (30 cm)
# di_casc - diâmetro com casca
# di_casc2 - diâmetro com casca para calculo do volume da peça
# di- diâmetro sem casca
# vr - volume tora ou peça roliça
# vt - volume arvore
# cod_tora - numero de toras
# narv - numero de árvores da amostra
# codpeca-codigo peça


# def __getitem__(self, item):
#     return self.SelecionaPeca[item]


escolhaEqVol = ''
escolhaEqForma = ''

escolha = ''
while (escolha == ''):
    print('Desdobro por Arvores\n'
          'Digite:\n'
          ' 0 para terminar\n'
          ' 5 para CalculaMadeiraRolica\n'
          )

    escolha = input()

# -----------------------------------------------------------------
print('Calculador de Madeira Roliça')

# Lê arquivo de árvores
# -----------------------
linarv, narv = SubRotinas.learq()
# -----------------------

codpeca = 0
peca = 0 # nome da peça
es = 0 # variável da madeira serrada (declarada pc modulo serrada + rolica)
l_div = 0 # variável da madeira serrada (declarada pc modulo serrada + rolica)
n_div = 1 # variável da madeira serrada (declarada pc modulo serrada + rolica)
v = 0.0000 # volume da peça (dimensões padronizadas)
di_casc = di_casc2 = 0
# ntora = 0 # numero de toras por árvore
cod_tora = 0 # codigo da tora
cod_arv = 0 # codigo da árvore no inventário
parc = 0 # numero de parcelas
vt = 0.0000 # volume da árvore
arv = 1 # numero de árvores (começa com a 1a)
falha = 0 # numero de falhas
preco = 0.0000 # preço da tora
conic_tora = 0.0000 # conicidade da tora


# Para acumulo de peças do Relatorio Detalhado
codpeca_list = []
peca_list = []
es_list = []
l_div_list = []
n_div_list = []
v_list = []
di_min_list = []
di_max_list = []
hi_list = []
vr_list = []
vt_list = []
di_casc2_list = []
di_casc_list = []
di_list = []
ntora_list = []

cod_arv_list = []
arv_list = []
talh_list = []
parc_list = []

arv_parc_list = []
arv_talh_list = []
arv_falha_list = []

fator_talh_ha = []
fator_parc_ha = []

preco_list = []
conic_tora_list = []
# Alteração 01/08/2023
CRV_list = []

# ----------------------
linpeca = SubRotinas.learq0()
# ----------------------

# declarando variáveis, não necessário no VBA
di = 100

# -------------------------------------------
es_serra, hi_atual, hi, hi_min, prop_casc, l_min_pecas, es_min_pecas, di_min, es_perim, \
flecha_div_r, es_medula = SubRotinas.parametros(escolha)
# -------------------------------------------

if escolhaEqForma == '':
    print('0 para equação de forma interna\n'
          '1 para equação de forma do usuário\n')

    escolhaEqForma = input()

if escolhaEqForma == '0':
    B0f = B1f = B2f = 0

if escolhaEqForma == '1':
    # --------------------------------------
    B0f, B1f, B2f = SubRotinas.Forma()
    # --------------------------------------

#---------------------------------
FFormaEqFormaCubagem.cubagemtxt()
#---------------------------------

if escolhaEqVol == '':
    print('0 para equação de volume interna\n'
          '1 para equação de volume do usuário\n')

    escolhaEqVol = input()

if escolhaEqVol == '0':
    B0v = B1v = B2v = 0

if escolhaEqVol == '1':
    # --------------------------------------
    B0v, B1v, B2v = SubRotinas.Volume()
    # --------------------------------------

# Executa por árvore
while arv <= narv:
    vr = 0.0000

    # Acessa arquivo texto, armazena dap e ht por árvore, e calcula seu volume (vt)
    dados = linarv[arv].split()

    talh = float(dados[0])
    parc0 = float(dados[1])
    parc = int(parc0)
    cod_arv = float(dados[2])
    # Para criar campos com zero em falhas do Arvore.txt
    try:
        dap = float(dados[3])
        ht = float(dados[4])
        hc = float(dados[5])
    except:
        dados.extend([0, 0, 0])
        dap = float(dados[3])
        ht = float(dados[4])
        hc = float(dados[5])

    if hc > 0 and hc != "" and dap > 0 and ht > 0:

        if escolhaEqVol == '0':
            # -----------------------------
            # Seleciona equação de volume
            vt = Formulas.EquacaoVolume(dap, ht)
            # -----------------------------

        if escolhaEqVol == '1':
            vt = Formulas.Eqvt(B0v, B1v, B2v, dap, ht)
            # print(vt.vt_result())
            vt = vt.vt_result()

    # Lista vt
    vt_list.append(vt)
    vt = 0

    #lista de árvores pelo cod_arv
    cod_arv_list.append(cod_arv)

    # Lista falhas
    arv_parc_list.append(parc)
    arv_talh_list.append(talh)

    if dap == 0 or dap == "" or ht == 0 or ht == "":
        arv_falha_list.append(1)
    else:
        arv_falha_list.append(0)

    # numero da tora
    cod_tora = 0

    es_sobra = 100

    # Calcula peças por seção do tronco até completar altura da árvore
    while hi_atual + hi <= hc:

        if escolhaEqForma == '0':
            # -------------------------------------------------
            # Seleciona equação de forma
            di_casc, di_casc2 = Formulas.EquacaoForma(hi_atual, hi, ht, dap, di_casc, di_casc2)
            # -------------------------------------------------

        if escolhaEqForma == '1':
            # ALTERAÇÃO 08/09/2023 hi para hi_min
            di_casc2 = Formulas.Eqdi_casc(B0f, B1f, B2f, hi_atual, hi_min, ht, dap)
            di_casc = Formulas.Eqdi_casc(B0f, B1f, B2f, hi_atual, hi, ht, dap)

            di_casc2 = di_casc2.di_casc2_result()
            di_casc = di_casc.di_casc_result()


            # ALTERAÇÃO 03/12/2023 Calculo derivada di para verificar inconsistência Taper
            di_casc2_deriv = Formulas.Eqdi_casc(B0f, B1f, B2f, hi_atual, hi, ht, dap)
            di_casc_deriv = Formulas.Eqdi_casc(B0f, B1f, B2f, hi_atual, hi, ht, dap)

            di_casc2_deriv = di_casc2_deriv.di_casc2_deriv_result()
            di_casc_deriv = di_casc_deriv.di_casc_deriv_result()

        # ALTERAÇÃO 03/12/2023 Se derivada positiva, diametro começa a aumentar
        # Solução: utilizar a taxa com sinal negativo e deduzir do di_casc2
        if di_casc2_deriv <= 0:
            di = di_casc2 * (1 - prop_casc)
        else:
            di = (di_casc2 - di_casc2_deriv) * (1 - prop_casc)


        cod_tora = cod_tora + 1

        if di < di_min or hi_atual + hi_min > hc:
            cod_tora = cod_tora - 1
            break

        # ----------------------------------------------------------------------------------
        # SelecionaPeca
        # Alteração 01/08/2023 CRV_list
        hi, cod_tora, \
        codpeca_list, peca_list, es_list, l_div_list, n_div_list, di_min_list, di_max_list, hi_list, vr_list, \
        di_casc2_list, di_casc_list, di_list, ntora_list, arv_list, talh_list, parc_list, preco_list, \
        v_list, conic_tora_list, CRV_list\
        = SubRotinas.SelecionaPeca(dap, ht, hc,hi_atual, hi_min, di_casc, di_casc2, di,
                                   prop_casc, cod_tora, arv, cod_arv, talh, parc, linpeca,
                                   escolhaEqForma, B0f, B1f, B2f, conic_tora,
                                   codpeca_list, peca_list, es_list, l_div_list, n_div_list, di_min_list, di_max_list, hi_list,
                                   vr_list, di_casc2_list, di_casc_list, di_list, ntora_list,
                                   arv_list, talh_list, parc_list, preco_list,
                                   v_list, conic_tora_list, CRV_list)
        # ----------------------------------------------------------------------------------

        # atualiza hi_atual com o comprimento da tora calculada (hi)
        hi_atual = hi_atual + hi

        hi = hi_min

        # print('hi_atual=', hi_atual)
    # loop while da arv
    arv = arv + 1

    # retorna altura do toco
    # Precisa pegar valor definido pelo usuario não é fixo
    # -------------------------------------------
    hi_atual = SubRotinas.parametros_hi_atual()
    # -------------------------------------------

# # CRV (v/vr)
# CRV_freq = []
# i = 0
# i2 = 0
# k = 0
# v = 0
#
# arv_unico = np.unique(arv_list) # arv_list identifica o número da árvore na tora
# ntora_unico = np.unique(ntora_list) # identifica o número da tora por árvore
#
# for k in range(0, len(arv_unico)):
#
#     for j in range(0, len(ntora_unico)):
#
#         while i < len(ntora_list) and \
#                 ntora_list[i] == ntora_unico[j] and arv_list[i] == arv_unico[k]:
#
#             v = v + v_list[i]
#
#             i = i + 1
#
#         while i2 < len(ntora_list) and \
#                 ntora_list[i2] == ntora_unico[j] and arv_list[i2] == arv_unico[k]:
            #     CRV_freq.append(v / vr_list[i2])
#             i2 = i2 + 1
#         i2 = i
#         v = 0

# ----------------------------------------------------------------------------
# RESULTADO DETALHADO

print('')
print('RESULTADO DETALHADO ROLIÇA')
print('-'*70)

# data0 = {'codpeca': codpeca_list, 'peca': peca_list, 'di_min_list': di_min_list, 'di_max_list': di_max_list, 'hi_list': hi_list,
#          'vr': vr_list, 'v_list': v_list, 'di_casc2': di_casc2_list, 'di_casc': di_casc_list, 'di_list': di_list,
#          'tora': ntora_list, 'arv': arv_list, 'talh': talh_list, 'parc': parc_list,  'preco': preco_list,
#          'conicidade': conic_tora_list, 'rend': CRV_freq}

data0 = {'codpeca': codpeca_list, 'peca': peca_list, 'di_min': di_min_list, 'di_max': di_max_list, 'hi': hi_list,
         }

data02 = {
         'vr': vr_list, 'v': v_list, 'di_casc2': di_casc2_list, 'di_casc': di_casc_list, 'di': di_list,
         }

data03 = {
         'tora': ntora_list, 'arv': arv_list, 'talh': talh_list, 'parc': parc_list,  'preco': preco_list,
         'conicidade': conic_tora_list, 'rend': CRV_list} # Alteração 01/08/2023

print('codpeca:{}'.format(len(codpeca_list)))
print('peca:{}'.format(len(peca_list)))
print('di_min:{}'.format(len(di_min_list)))
print('di_max:{}'.format(len(di_max_list)))
print('hi:{}'.format(len(hi_list)))
print('vr:{}'.format(len(vr_list)))
print('v:{}'.format(len(v_list)))
print('di_casc2:{}'.format(len(di_casc2_list)))
print('di_casc:{}'.format(len(di_casc_list)))
print('di:{}'.format(len(di_list)))
print('tora:{}'.format(len(ntora_list)))
print('arv:{}'.format(len(arv_list)))
print('talh:{}'.format(len(talh_list)))
print('parc:{}'.format(len(parc_list)))
print('preco:{}'.format(len(preco_list)))
print('conic_tora:{}'.format(len(conic_tora_list)))
print('rend_ptora:{}'.format(len(CRV_list))) # Alteração 01/08/2023

df0 = pd.DataFrame(data0)
df02 = pd.DataFrame(data02)
df03 = pd.DataFrame(data03)

print("-" * 70)
print(df0.head(30))
print("-" * 70)
print(df02.head(30))
print("-" * 70)
print(df03.head(30))
print("-" * 70)

saida = df0.shape
print(saida)
print("-" * 70)

# ---------------------------------------------------------------
# RESULTADO SINTÉTICO

vr_nr = 0.0000
v_nr = 0.0000
n_pecas_nr = 0
vr = 0.0000
v = 0.0000
n_pecas = 0
preco = 0.0000
n_arv = 0.0000

vr_nr_t = 0.0000
v_nr_t = 0.0000
n_pecas_nr_t = 0
vr_t = 0.0000
v_t = 0.0000
n_pecas_t = 0
preco_t = 0.0000
n_arv_t = 0.0000
falha_t = 0

falha_talh = 0
arv_talh = 0

falha_parc = 0
arv_parc = 0

i = 0
j = 0

esp_arv = float(input("Entre com espaçamento entre árvores : "))
esp_lin = float(input("Entre com espaçamento entre linhas : "))

# FATOR TOTAL (ha)
for i in range(0, len(arv_falha_list)):

    if arv_falha_list[i] == 1:
        falha_t = falha_t + 1
    else:
        n_arv_t = n_arv_t + 1

fator_ha = 10000 / (esp_arv * esp_lin * (n_arv_t + falha_t))

talh_unico = np.unique(talh_list)
parc_unico = np.unique(parc_list)

codpeca_peca = {}
for i, j in zip(codpeca_list, peca_list):
    codpeca_peca[i] = j

codpeca_tmp = codpeca_peca.keys()
codpeca_unico = list(codpeca_tmp)
print(codpeca_unico)

peca_tmp = codpeca_peca.values()
peca_unico = list(peca_tmp)
print(peca_unico)

arv_parc_list_t = []
falha_parc_list_t = []

arv_talh_list_t = []
falha_talh_list_t = []

#xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
# FATOR TALHÃO (ha)
for j in range(0, len(talh_unico)):

    for i in range(0, len(arv_falha_list)):

        if arv_falha_list[i] == 1 and arv_talh_list[i] == talh_unico[j]:
            falha_talh = falha_talh + 1

        elif arv_falha_list[i] == 0 and arv_talh_list[i] == talh_unico[j]:
            arv_talh = arv_talh + 1

    fator_talh_ha.append(10000 / (esp_arv * esp_lin * (arv_talh + falha_talh)))

    arv_talh_list_t.append(arv_talh)
    falha_talh_list_t.append(falha_talh)

    arv_talh = 0
    falha_talh = 0

#xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
# FATOR PARCELA (ha)
for j in range(0, len(talh_unico)):

    for k in range(0, len(parc_unico)):

        for i in range(0, len(arv_falha_list)):

            if arv_falha_list[i] == 1 and arv_parc_list[i] == parc_unico[k] and arv_talh_list[i] == talh_unico[j]:
                falha_parc = falha_parc + 1

            elif arv_falha_list[i] == 0 and arv_parc_list[i] == parc_unico[k] and arv_talh_list[i] == talh_unico[j]:
                arv_parc = arv_parc + 1

        if arv_parc == 0 and falha_parc == 0:
            fator_parc_ha.append(0)
        else:
            fator_parc_ha.append(10000 / (esp_arv * esp_lin * (arv_parc + falha_parc)))

        arv_parc_list_t.append(arv_parc)
        falha_parc_list_t.append(falha_parc)

        arv_parc = 0
        falha_parc = 0

#xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
# VOLUME PARCELA (ha)

vt_parc_list = []
vt_parc = 0

for j in range(0, len(talh_unico)):

    for k in range(0, len(parc_unico)):

        for i in range(0, len(arv_parc_list)):

            if arv_parc_list[i] == parc_unico[k] and arv_talh_list[i] == talh_unico[j]:
                    vt_parc = vt_parc + vt_list[i]

        # if vt_parc > 0:
        vt_parc_list.append(vt_parc)

        vt_parc = 0

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
# VOLUME TALHAO (ha)

vt_talh_list = []
vt_talh = 0

for j in range(0, len(talh_unico)):

    for i in range(0, len(arv_talh_list)):

        if arv_talh_list[i] == talh_unico[j]:
                vt_talh = vt_talh + vt_list[i]

    vt_talh_list.append(vt_talh)

    vt_talh = 0

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

# Preço da Floresta (Para preço inverso: valor pago pela madeira utilizada, desconsidera resíduo)
pf = float(input("Entre com valor da floresta (R$/m3) : "))

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
# "FREQUENCIA DE PEÇAS - RESULTADO POR TALHAO (ha)"

talh_freq = []
codpeca_freq = []
peca_freq = []
vr_freq = []
v_freq = []
n_pecas_freq = []
preco_freq = []
crv_freq = []
vr_v_freq = []

i = 0
y = 0

for w in range(0, len(talh_unico)):

    for j in range(0, len(codpeca_unico)):

        while i < len(talh_list):

            if codpeca_list[i] == codpeca_unico[j] and \
                        talh_list[i] == talh_unico[w]:

                vr = vr + vr_list[i]
                v = v + v_list[i]
                n_pecas = n_pecas + 1
                preco = preco + preco_list[i]

            i = i + 1

        i = 0

        talh_freq.append(talh_unico[w])
        codpeca_freq.append(codpeca_unico[j])
        peca_freq.append(peca_unico[j])
        vr_freq.append(vr * fator_talh_ha[y])
        v_freq.append(v * fator_talh_ha[y])
        n_pecas_freq.append(n_pecas * fator_talh_ha[y])
        preco_freq.append(preco * fator_talh_ha[y])

        # if vr > 0:
        #     crv_freq.append(v / vr)
        # else:
        #     crv_freq.append(0)

        # Alteração 17/08/2023
        crv_freq.append(0)
        # vr_v_freq.append((vr - v) * fator_talh_ha[y])
        vr_v_freq.append(0)

        vr = v = n_pecas = preco = 0

    y = y + 1

data = {'talh_freq': talh_freq, 'codpeca_freq':codpeca_freq, 'peca_freq': peca_freq,
        'vr_freq':vr_freq, 'v_freq':v_freq,
      'n_pecas_freq': n_pecas_freq, 'preco_freq': preco_freq, 'crv': crv_freq, 'vr_v': vr_v_freq}

df = pd.DataFrame(data)
print("-" * 70)
print("FREQUENCIA DE PEÇAS - RESULTADO POR TALHAO (ha)")
print(df)
print("-" * 70)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
# "FREQUENCIA DE PEÇAS - RESULTADO POR PARCELA DENTRO DE TALHAO (ha)

talh_freq = []
parc_freq = []
codpeca_freq = []
peca_freq = []
vr_freq = []
v_freq = []
n_pecas_freq = []
preco_freq = []
crv_freq = []
vr_v_freq = []

i = 0
y = 0

for w in range(0, len(talh_unico)):

    for k in range(0, len(parc_unico)):

        for j in range(0, len(codpeca_unico)):

            while i < len(parc_list):

                if codpeca_list[i] == codpeca_unico[j] and parc_list[i] == parc_unico[k] and \
                        talh_list[i] == talh_unico[w]:

                    vr = vr + vr_list[i]
                    v = v + v_list[i]
                    n_pecas = n_pecas + 1
                    preco = preco + preco_list[i]

                i = i + 1

            i = 0

            talh_freq.append(talh_unico[w])
            parc_freq.append(parc_unico[k])
            codpeca_freq.append(codpeca_unico[j])
            peca_freq.append(peca_unico[j])
            vr_freq.append(vr * fator_parc_ha[y])
            v_freq.append(v * fator_parc_ha[y])
            n_pecas_freq.append(n_pecas * fator_parc_ha[y])
            preco_freq.append(preco * fator_parc_ha[y])

            # if vr > 0:
            #     crv_freq.append(v / vr)
            # else:
            #     crv_freq.append(0)

            # Alteração 17/08/2023
            crv_freq.append(0)
            # vr_v_freq.append((vr - v) * fator_parc_ha[y])
            vr_v_freq.append(0)
            vr = v = n_pecas = preco = 0

        y = y + 1

data = {'talh_freq': talh_freq,'parc_freq': parc_freq, 'codpeca_freq':codpeca_freq, 'peca': peca_freq,
        'vr_freq':vr_freq, 'v_freq':v_freq,
      'n_pecas_freq': n_pecas_freq, 'preco_freq': preco_freq, 'crv': crv_freq, 'vr_v': vr_v_freq}

df = pd.DataFrame(data)
print("-" * 70)
print("FREQUENCIA DE PEÇAS - RESULTADO POR PARCELA DENTRO DE TALHAO (ha)")
print(df)
print("-" * 70)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
# "RESULTADO TOTALIZADO POR PARCELA DENTRO DE TALHAO (ha)"

talh_freq = []
parc_freq = []
vr_freq = []
v_freq = []
vr_nr_freq = []
v_nr_freq = []
n_pecas_freq = []
n_pecas_nr_freq = []
preco_freq = []

vt_freq = []
preco_inv_freq = []
preco_arv_freq = []
preco_pecas_freq = []
crv_freq = []
vr_v_freq = []
vt_vr_freq = []

i = 0
j = 0

for w in range(0, len(talh_unico)):

    for k in range(0, len(parc_unico)):

        while i < len(parc_list):

            if parc_list[i] == parc_unico[k] and \
                    talh_list[i] == talh_unico[w]:

                if peca_list[i] == 'NaoRolica':
                    vr_nr = vr_nr + vr_list[i]
                    v_nr = v_nr + v_list[i]
                    n_pecas_nr = n_pecas_nr + 1
                else:
                    vr = vr + vr_list[i]
                    v = v + v_list[i]
                    n_pecas = n_pecas + 1
                    preco = preco + preco_list[i]

            i = i + 1

        i = 0

        talh_freq.append(talh_unico[w])
        parc_freq.append(parc_unico[k])
        vr_freq.append(vr * fator_parc_ha[j])
        v_freq.append(v * fator_parc_ha[j])
        vr_nr_freq.append(vr_nr * fator_parc_ha[j])
        v_nr_freq.append(v_nr * fator_parc_ha[j])
        n_pecas_freq.append(n_pecas * fator_parc_ha[j])
        n_pecas_nr_freq.append(n_pecas_nr * fator_parc_ha[j])
        preco_freq.append(preco * fator_parc_ha[j])
        vt_freq.append(vt_parc_list[j] * fator_parc_ha[j])

        if vr > 0:
            preco_inv_freq.append((pf * vt_parc_list[j])/vr)
            preco_arv_freq.append(preco / vt_parc_list[j])
            preco_pecas_freq.append(preco / vr)
        #   crv_freq.append(v / vr)
        else:
            preco_inv_freq.append(0)
            preco_arv_freq.append(0)
            preco_pecas_freq.append(0)
        #   crv_freq.append(0)

        # Alteração 17/08/2023
        crv_freq.append(0)
        # vr_v_freq.append((vr-v) * fator_parc_ha[j])
        vr_v_freq.append(0)

        vt_vr_freq.append((vt_parc_list[j] - vr) * fator_parc_ha[j])

        vr = v = vr_nr = v_nr = n_pecas = n_pecas_nr = preco = 0
        j = j + 1

# print('talh:{}'.format(len(talh_freq)))
# print('parc:{}'.format(len(parc_freq)))
# print('vr:{}'.format(len(vr_freq)))
# print('v:{}'.format(len(v_freq)))
# print('vr_nr:{}'.format(len(vr_nr_freq)))
# print('v_nr:{}'.format(len(v_nr_freq)))
# print('npecas:{}'.format(len(n_pecas_freq)))
# print('npecas_nr:{}'.format(len(n_pecas_nr_freq)))
# print('preco:{}'.format(len(preco_freq)))
# print('vt:{}'.format(len(vt_freq)))
# print('preco_inv:{}'.format(len(preco_inv_freq)))
# print('preco_arv:{}'.format(len(preco_arv_freq)))
# print('preco_pecas:{}'.format(len(preco_pecas_freq)))
# print('crv:{}'.format(len(crv_freq)))
# print('vr_v:{}'.format(len(vr_v_freq)))
# print('vt_vr:{}'.format(len(vt_vr_freq)))

# data = {'talh': talh_freq,'parc': parc_freq, 'arv': arv_parc_list_t, 'falha': falha_parc_list_t,
#         'vr': vr_freq, 'v': v_freq, 'vr_nr': vr_nr_freq, 'v_nr': v_nr_freq,
#         'n_pecas': n_pecas_freq, 'n_pecas_nr': n_pecas_nr_freq, 'preco_freq': preco_freq,
#         'vt': vt_freq, 'preco_inv': preco_inv_freq, 'preco_arv': preco_arv_freq, 'preco_pecas': preco_pecas_freq,
#         'crv': crv_freq, 'vr_v': vr_v_freq, 'vt_vr': vt_vr_freq}


data = {'talh': talh_freq,'parc': parc_freq, 'arv': arv_parc_list_t, 'falha': falha_parc_list_t,
        'vr': vr_freq, 'v': v_freq, 'vr_nr': vr_nr_freq, 'v_nr': v_nr_freq,
        }

data2 = {
        'n_pecas': n_pecas_freq, 'n_pecas_nr': n_pecas_nr_freq, 'preco_freq': preco_freq,
        'vt': vt_freq, 'preco_inv': preco_inv_freq, 'preco_arv': preco_arv_freq, 'preco_pecas': preco_pecas_freq,
        }

data3 = {
        'crv': crv_freq, 'vr_v': vr_v_freq, 'vt_vr': vt_vr_freq}

df = pd.DataFrame(data)
df2 = pd.DataFrame(data2)
df3 = pd.DataFrame(data3)

print("-" * 70)
print("RESULTADO TOTALIZADO POR PARCELA DENTRO DE TALHAO (ha)")
print(df)
print("-" * 70)
print(df2)
print("-" * 70)
print(df3)
print("-" * 70)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
# "RESULTADO TOTALIZADO POR TALHAO (ha)"

talh_freq = []
vr_freq = []
v_freq = []
vr_nr_freq = []
v_nr_freq = []
n_pecas_freq = []
n_pecas_nr_freq = []
preco_freq = []

vt_freq = []
preco_inv_freq = []
preco_arv_freq = []
preco_pecas_freq = []
crv_freq = []
vr_v_freq = []
vt_vr_freq = []

i = 0
j = 0

for w in range(0, len(talh_unico)):

    while i < len(talh_list):

        if talh_list[i] == talh_unico[w]:

            if peca_list[i] == 'NaoRolica':
                vr_nr = vr_nr + vr_list[i]
                v_nr = v_nr + v_list[i]
                n_pecas_nr = n_pecas_nr + 1
            else:
                vr = vr + vr_list[i]
                v = v + v_list[i]
                n_pecas = n_pecas + 1
                preco = preco + preco_list[i]

        i = i + 1

    i = 0

    talh_freq.append(talh_unico[w])
    vr_freq.append(vr * fator_talh_ha[j])
    v_freq.append(v * fator_talh_ha[j])
    vr_nr_freq.append(vr_nr * fator_talh_ha[j])
    v_nr_freq.append(v_nr * fator_talh_ha[j])
    n_pecas_freq.append(n_pecas * fator_talh_ha[j])
    n_pecas_nr_freq.append(n_pecas_nr * fator_talh_ha[j])
    preco_freq.append(preco * fator_talh_ha[j])
    vt_freq.append(vt_talh_list[j] * fator_talh_ha[j])

    if vr > 0:
        preco_inv_freq.append((pf * vt_talh_list[j])/vr)
        preco_arv_freq.append(preco / vt_talh_list[j])
        preco_pecas_freq.append(preco / vr)
        # crv_freq.append(v / vr)
    else:
        preco_inv_freq.append(0)
        preco_arv_freq.append(0)
        preco_pecas_freq.append(0)
        # crv_freq.append(0)

    # Alteração 17/08/2023
    crv_freq.append(0)
    # vr_v_freq.append((vr-v) * fator_parc_ha[j])
    vr_v_freq.append(0)

    vt_vr_freq.append((vt_talh_list[j] - vr) * fator_talh_ha[j])

    vr = v = vr_nr = v_nr = n_pecas = n_pecas_nr = preco = 0
    j = j + 1

print('talh:{}'.format(len(talh_freq)))
print('vr:{}'.format(len(vr_freq)))
print('v:{}'.format(len(v_freq)))
print('vr_nr:{}'.format(len(vr_nr_freq)))
print('v_nr:{}'.format(len(v_nr_freq)))
print('npecas:{}'.format(len(n_pecas_freq)))
print('npecas_nr:{}'.format(len(n_pecas_nr_freq)))
print('preco:{}'.format(len(preco_freq)))
print('vt:{}'.format(len(vt_freq)))
print('preco_inv:{}'.format(len(preco_inv_freq)))
print('preco_arv:{}'.format(len(preco_arv_freq)))
print('preco_pecas:{}'.format(len(preco_pecas_freq)))
print('crv:{}'.format(len(crv_freq)))
print('vr_v:{}'.format(len(vr_v_freq)))
print('vt_vr:{}'.format(len(vt_vr_freq)))

# data = {'talh': talh_freq,'arv': arv_parc_list_t, 'falha': falha_parc_list_t,
#         'vr': vr_freq, 'v': v_freq, 'vr_nr': vr_nr_freq, 'v_nr': v_nr_freq,
#         'n_pecas': n_pecas_freq, 'n_pecas_nr': n_pecas_nr_freq, 'preco_freq': preco_freq,
#         'vt': vt_freq, 'preco_inv': preco_inv_freq, 'preco_arv': preco_arv_freq, 'preco_pecas': preco_pecas_freq,
#         'crv': crv_freq, 'vr_v': vr_v_freq, 'vt_vr': vt_vr_freq}


data = {'talh': talh_freq, 'arv': arv_talh_list_t, 'falha': falha_talh_list_t,
        'vr': vr_freq, 'v': v_freq, 'vr_nr': vr_nr_freq, 'v_nr': v_nr_freq
        }

data2 = {
        'n_pecas': n_pecas_freq, 'n_pecas_nr': n_pecas_nr_freq, 'preco_freq': preco_freq,
        'vt': vt_freq, 'preco_inv': preco_inv_freq, 'preco_arv': preco_arv_freq, 'preco_pecas': preco_pecas_freq
        }

data3 = {
        'crv': crv_freq, 'vr_v': vr_v_freq, 'vt_vr': vt_vr_freq}

df = pd.DataFrame(data)
df2 = pd.DataFrame(data2)
df3 = pd.DataFrame(data3)

print("-" * 70)
print("RESULTADO TOTALIZADO POR TALHAO (ha)")
print(df)
print("-" * 70)
print(df2)
print("-" * 70)
print(df3)
print("-" * 70)
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx