# -*- coding: utf-8 -*-

from datetime import datetime,date
import pandas as pd
import numpy as np
from numpy.linalg import inv
import math
from decimal import Decimal
from SubRotinas import learq4, learq5
# ----------------------------------------------
# SubExtraiDataIdadeParcDesb

def ExtraiDataIdadeParcDesb(parcela,desbaste,lin,esparv,lin_desb,esparv_desb,parcfix,dataplantio,datainv1,datainv2,dataproj,calc_area):

    print('Lista de datas, idades, parcelas, desbaste')

    # -------------------
    linprojecao, nprojecao1 = learq4()
    # -------------------

    # Captura data, parcela, desbaste de todos os dados de Projecao.txt

    parc = []
    arv = []
    dap = []
    H = []
    data = []
    idade_mes=[]
    desb = []

    cont_list=[]
    dap_min_list=[]
    dap_max_list=[]
    H_min_list=[]
    H_max_list=[]
    G_m2ha_list=[]

    dap_min = 1000
    dap_max = 0

    H_min = 1000
    H_max = 0

    G_m2=0
    G_m2ha=0

    lin_final=0
    cont=cont0=0

    n_falha=0

    for projecao in range(1, nprojecao1 + 1):

        dados_0 = linprojecao[projecao].split()
        itens_0=len(dados_0)
        print(itens_0)

        if itens_0 <7:
            n_falha=n_falha+1
            continue

        try:
            dados_1 = linprojecao[projecao + 1].split()
            itens_1 = len(dados_1)
            print(itens_1)

            if itens_1 < 7:
                continue

        except:
            lin_final=1
            dados_1=dados_0
            pass

        parc_0 = str(dados_0[0])
        arv_0 = str(dados_0[1])
        dap_0 = Decimal(dados_0[2])
        H_0 = Decimal(dados_0[3])
        data_0 = datetime.strptime(dados_0[4], '%d/%m/%Y').date()
        idade_mes_0 = round(((data_0 - dataplantio).days) / 30,0)
        desb_0 = int(dados_0[6])

        if lin_final==0:
            parc_1 = str(dados_1[0])
            arv_1 = str(dados_1[1])
            dap_1 = Decimal(dados_1[2])
            H_1 = Decimal(dados_1[3])
            data_1 = datetime.strptime(dados_1[4],'%d/%m/%Y').date()
            desb_1 = int(dados_1[6])

        else:
            parc.append(parc_0)
            arv.append(arv_0)
            dap.append(dap_0)
            H.append(H_0)
            data.append(data_0)
            desb.append(desb_0)
            cont = cont + 1

        if parc_0 == parc_1 and data_0 == data_1 and desb_0 == desb_1:

            # seleciona Dmin e Dmax por Parc_Data_desbaste
            if dap_1 < dap_0 and dap_1 < dap_min:
                dap_min = dap_1

            elif dap_0 < dap_min:
                dap_min=dap_0

            # elif dap_min == dap_0:
            #     pass

            if dap_1 > dap_0 and dap_1 > dap_max:
                dap_max = dap_1

            elif dap_0 > dap_max:
                dap_max = dap_0

            #elif dap_max==dap_0:
            # pass

            # seleciona Hmin e Hmax por Parc_Data_desbaste
            if H_1 < H_0 and H_1 < H_min:
                H_min = H_1

            elif H_0 < H_min:
                H_min = H_0

            if H_1 > H_0 and H_1 > H_max:
                H_max = H_1

            elif H_0 < H_max:
                H_max = H_0

        #calcula Gm2_ha por Parc_Data_desbaste
        Si_m2 = math.pi * float(dap_0) ** 2 / 40000
        G_m2 = G_m2 + Si_m2

        # 'calcula tamanho da amostra (número de árvores por Parc_Data_desbaste)
        cont0=cont0+1

        if parc_0 != parc_1 or data_0 != data_1 or desb_0 != desb_1 or lin_final==1:

            if lin_final==0:
                parc.append(parc_0)
                arv.append(arv_0)
                dap.append(dap_0)
                H.append(H_0)
                data.append(data_0)
                desb.append(desb_0)

                parc_0 = parc_1
                arv_0 = arv_1
                dap_0 = dap_1
                H_0 = H_1
                data_0 = data_1
                desb_0 = desb_1
            else:
                idade_mes_0 = round(((data_1 - dataplantio).days) / 30,0)
                cont=cont-1
                pass

            cont_list.append(cont0)
            dap_min_list.append(dap_min)
            dap_max_list.append(dap_max)
            H_min_list.append(H_min)
            H_max_list.append(H_max)
            idade_mes.append(idade_mes_0)

            dap_min = 1000
            dap_max = 0

            H_min = 1000
            H_max = 0

            if parcfix=='s':
                if calc_area==0:
                    #cont0 é n no VBA (numero de árvores na amostra)
                    Amostra_m2=lin*esparv*(cont0+n_falha)
                    calc_area=1

            # 'parcela variou de tamanho entre datas
            if parcfix == "n":

                if desbaste == 0:
                    Amostra_m2 = lin * esparv * (cont0 + n_falha)

                if desbaste == 1:
                    Amostra_m2_desb = lin_desb * esparv_desb * (cont0 + n_falha)

            #Area basal/ha
            G_m2ha = G_m2 * 10000 / float(Amostra_m2)

            G_m2ha_list.append(G_m2ha)

            G_m2=0

            cont0=0
            cont = cont + 1

    dados = {'parc': parc, 'arv': arv, 'dap_min': dap_min_list,'dap_max':dap_max_list,
             'H_min': H_min_list,'H_max':H_max_list,
             'data': data,'meses':idade_mes, 'desb': desb,
             'G_m2ha':G_m2ha_list, 'arv_sobrev':cont_list}

    df = pd.DataFrame(data=dados)

    print(df)

    # ---------------------------------------------
    i,j,df2, Hsum=DataIdadeParcDesb(Amostra_m2,df,cont_list, cont, parc, data, idade_mes, desb)
    # ---------------------------------------------

    print('cont {}'.format(cont))

    return i

#-------------------------------------------------------------
def DataIdadeParcDesb( amostra_m2,df, cont_list, cont, parc, data,idade_mes, desb):

    # ----------
    df1=learq5()
    # ----------
    # print(df1)
    # df1.info()

    #converte data string para date para calcular idade pela data
    df1['Data'] = pd.to_datetime(df1['Data'],
                                 errors='coerce', dayfirst=True, yearfirst=False,
                                 utc=None, box=True, format='%d/%m/%Y', exact=True,
                                 infer_datetime_format=True, origin='unix', cache=True)

    # df1=pd.DataFrame(index = [data])

    print(df1)

    #------------------------------------------------------------
    dataplantio, amostra_m2 = ParametrosProj()
    #------------------------------------------------------------

    #calcula coluna meses no DataFrame, a partir das datas
    cont_total = 0
    for i in range(0, cont):
        cont_total = cont_total + cont_list[i]

    df1['meses'] = 0

    for i in range(0,cont_total):

        data =pd.datetime.date(df1.loc[i, 'Data'])

        idade = int(round(((data - dataplantio).days) / 30, 0))

        df1['meses'] = df1['meses'].astype(int)
        df1.loc[i, 'meses'] = int(idade)

    print(df1)

    #ordena Dap por  por período por parcela para calculo da altura dominante
    df2 = df1.sort_values(['Parc','meses','Dap'],ascending=False)
    print(df2)

    df3=df2.reset_index()
    print(df3)

    df4 = df.sort_values(['parc', 'meses', 'dap_min'], ascending=False)
    print(df4)

    df5 = df4.reset_index()
    print(df5)

    # get list of meses
    # meses = df3['meses']
    # desb=df3['Desbaste']

    # df3=df2.groupby(by='meses',axis=0).mean()
    # df3=df2.groupby(by='meses',axis=0).count()
    # df3=df2.groupby(['meses','Desbaste'],axis=0).count()
    # print(df3)

    # df5 = df2.meses.value_counts()
    # print(df5)

    # idx=df2.set_index(['meses'])

    # df4 = df2.groupby(['meses', 'Desbaste']).size()
    # print(df4)

    # '1)Método  Assmann: Hmed de 100 arvores c >dap/ha
    # 'numero de árvores/amostra c > dap, proporcional a 100 arvores/ha
    nArv12 = int(round(((amostra_m2 / 10000) * 100), 0))
    df['Hdom1'] = 0
    Hsum = 0
    i=0
    j=0

    for idx, row in df.iterrows():
        while df3.loc[idx, 'meses']==df5.loc[i,'meses'] and df3.loc[idx,'Desbaste']==df5.loc[i,'desb'] \
                and i<cont:

            if nArv12 == 0:
                df.loc[i, 'Hdom1'] = 0
                i=i+1
                j=j+1
                break

            if j <nArv12:
                Hsum = Hsum + df3.loc[idx, 'H']
                j=j+1

            elif j>= nArv12:
                j=0
                df.loc[i, 'Hdom1'] = Hsum / nArv12
                i=i+1
                Hsum = 0
                # print(df['Hdom1'])
                break

    print(df['Hdom1'])


    # '3)Método Naslund: Hmed das árvores c dap >=dap_med+1DP

    df3 = df2.groupby(['meses', 'Desbaste']).mean()
    print(df3)

    df4 = df2.groupby(['meses', 'Desbaste']).std()
    print(df4)

    df['Hdom3'] = 0
    Hsum = 0
    i = 0
    j = 0
    arv=0
    idx=0

    for idx3, row in df3.iterrows():

        Dmed=df3.loc[idx3,'Dap']
        D_dp=df4.loc[idx3, 'Dap']

        try:
            dap3 = Dmed + D_dp

        except:
            print('Dados inconsistentes!')
        print(df2)
        for idx2, row in df2.iterrows():
            print(idx)
            print(row)
            arv = 0
            if df2.loc[idx2, 'Dap'] >= dap3:
                Hsum = Hsum + df.loc[idx2, 'H']
                arv=arv+1

        if Hsum == 0 or arv == 0:
            Hdom3 = 0
        else:
            Hdom3 = Hsum / arv

    cont = 0
    Hsum = 0
    arv = 0

    df.loc[i, 'Hdom1'] = Hsum / nArv12
    i = i + 1
    Hsum = 0
    # print(df['Hdom1'])
    # break

    # ------------------------------------
    # Hsum, df2['Hdom1'] = S_AltDom(i, j, df2, nArv12, Hsum)
    # ------------------------------------

    #variáveis da lista do DataFrame (indices dos dados inventariados)
    #parc[i], meses[i], desb[i]

    # if parc_df1 == int(parc[i]) and meses_df1 == meses[i] and desbaste_df1 == str(desb[i]):

    # print(parc[i], meses[i], desb[i])
    # print(df1.loc[j, 'Parc'], df1.loc[j, 'meses'], df1.loc[j, 'Desbaste'])


# ---------------------------------------------
def CapturaDadosInventario_Futuro():
    print('Captura dados do inventario e dados observados futuros do arquivo Projecao.txt')

    projecao = 1
    n_inv = n_proj = 0


    # -------------------
    linprojecao, nprojecao1 = learq4()
    # -------------------

    # Captura dados do inventário para DataFrame
    dados = linprojecao[projecao].split()

    parc = str(dados[0])
    arv = str(dados[1])
    dap = Decimal(dados[2])
    H = Decimal(dados[3])
    datinv = str(dados[4])
    desb = str(dados[6])

    while parcela != parc or datainv != datinv or desbaste != desb:
        projecao = projecao + 1
        dados = linprojecao[projecao].split()

    parc1 = []
    arv1 = []
    dap1 = []
    H1 = []
    datinv1 = []
    desb1 = []

    while parcela == parc and datainv == datinv and desbaste == desb:
        n_inv = n_inv + 1
        try:
            dados = linprojecao[projecao].split()
        except:
            break

        projecao = projecao + 1

        if projecao == nprojecao1 + 1:
            break

        parc = str(dados[0])
        arv = str(dados[1])
        dap = Decimal(dados[2])
        H = Decimal(dados[3])
        datinv = str(dados[4])
        desb = str(dados[6])

        if datainv != datinv:
            projecao = projecao - 1
            break

        parc1.append(parc)
        arv1.append(arv)
        dap1.append(dap)
        H1.append(H)
        datinv1.append(datinv)
        desb1.append(desb)

    print('datinv1 {}'.format(datinv1))

    dados_inv = {'parc1': parc1, 'arv1': arv1, 'dap1': dap1, 'H1': H1, 'datinv1': datinv1, 'desb1': desb1}

    df = pd.DataFrame(dados_inv)

    print(df)

    # Captura dados observados futuros para DataFrame
    dados = linprojecao[projecao].split()

    parc = str(dados[0])
    arv = str(dados[1])
    dap = Decimal(dados[2])
    H = Decimal(dados[3])
    datproj = str(dados[4])
    desb = str(dados[6])

    while parcela != parc or dataproj != datproj or desbaste != desb:
        projecao = projecao + 1
        dados = linprojecao[projecao].split()



    parc2 = []
    arv2 = []
    dap2 = []
    H2 = []
    datproj2 = []
    desb2 = []

    while parcela == parc and dataproj == datproj and desbaste == desb:
        n_proj = n_proj + 1
        try:
            dados = linprojecao[projecao].split()
        except:
            break

        projecao = projecao + 1

        if projecao == nprojecao1 + 1:
            break

        parc = str(dados[0])
        arv = str(dados[1])
        dap = Decimal(dados[2])
        H = Decimal(dados[3])
        datproj = str(dados[4])
        desb = str(dados[6])

        if dataproj != datproj:
            projecao = projecao - 1
            break

        parc2.append(parc)
        arv2.append(arv)
        dap2.append(dap)
        H2.append(H)
        datproj2.append(datproj)
        desb2.append(desb)

    mortalid = n_inv - n_proj

    print('datproj2 {}'.format(datproj2))

    dados_proj = {'parc2': parc2, 'arv2': arv2, 'dap2': dap2, 'H2': H2, 'datproj2': datproj2, 'desb2': desb2}

    df1 = pd.DataFrame(dados_proj)

    print(df1)

    return dataplantio, datainv, dataproj, parcela, desbaste, nprojecao1, n_inv, n_proj, mortalid, df, df1


# ----------------------------------------------
# ----------------------------------------------
# 'X matriz
# 'Y vetor
# 't transposta
# 'inv inversa
# 'b vetor (b0,b1,b2)
# 'cte constante da média é a soma de yi^2/n
# 'SQRegres = b'X'Y-cte
# 'SQTotal=Y'Y - cte

def regressao(dado, a, x1, x2, y):
    Y = np.array(y)
    Xt = np.array([a, x1, x2])
    X = Xt.transpose()

    # print('na=', len(a))
    # print('nx1=', len(x1))
    # print('nx2=', len(x2))

    # print('Y',Y)
    # print('Xt',Xt)
    # print('X=',X)

    # dimensoes(matriz):
    tam_Xt = (len(Xt), len(Xt[0]))
    print('{} X {}'.format(tam_Xt[0], tam_Xt[1]))

    tam_X = (len(X), len(X[0]))
    print('{} X {}'.format(tam_X[0], tam_X[1]))


    XtX = Xt.dot(X)
    XtXinv = inv(XtX)
    XtY = Xt.dot(Y)
    B = XtXinv.dot(XtY)
    Bt = B.transpose()
    Yt = Y.transpose()
    YtY = Yt.dot(Y)
    BtXtY = Bt.dot(XtY)

    cte = sum(Y) ** 2 / dado

    SQRegres = BtXtY - cte
    SQTotal = YtY - cte
    SQRes = SQTotal - SQRegres
    # print(sum(y))

    if SQTotal != 0:
        r2 = SQRegres / SQTotal
        print('r2: {}'.format(r2))
        # print('B0:{},B1:{}, B2:{}'.format(B[0],B[1],B[2]))

    else:
        r2 = 0
        print('r2: {}'.format(r2))

    # B,r2=Regressao(a,Xt,Y)
    # --------------------------

    return B, r2


# class Data:
# def __init__(self,dia, mes, ano):
#     self.dia=dia
#     self.mes=mes
#     self.ano=ano
#
# def formatada(self):
#     print('{}/{}/{}'.format(self.dia, self.mes, self.ano))



