# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class calcmadeira_arvores(osv.Model):
    """
    Tabela de arvores
    Prefixo: cmaarv
    """
    _name = 'calcmadeira.arvores'
    _gerar_logs_logs = 'N'
    _columns = {
        'company_id': fields.many2one('res.company', _('Empresa'), ondelete='cascade',
                                      required=True, select=True),
        'cmaarv_talhao': fields.integer(_('Talhao')),
        'cmaarv_linha': fields.integer(_('Parcela')),
        'cmaarv_arvore': fields.integer(_('Arvore')),
        'cmaarv_diametro': fields.float(_('Diametro (cm)'), digits=(3, 2), required=True,
                                        help=_('Diametro a altura do peito em centimetros')),
        'cmaarv_altura': fields.float(_('Altura (m)'), digits=(4, 2), required=True,
                                      help=_('Altura da arvore em metros')),
        'cmaarv_altura_comecial': fields.float(_('Altura (m) comercial'), digits=(4, 2),
                                               required=True,
                                               help=_('Altura comercial da arvore em metros'))
    }
    _order = 'cmaarv_talhao,cmaarv_linha,cmaarv_arvore'
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(
            cr, uid, uid).company_id.id,
    }
