# -*- coding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _


class calcmadeira_cubagem(osv.Model):

    _name = 'calcmadeira.cubagem'

    _columns = {
        'company_id': fields.many2one('res.company', _('Empresa'), ondelete='cascade',
                                      required=True, select=True),
        'cmacub_linha': fields.integer(_('Parcela')),
        'cmacub_arvore': fields.integer(_('Arvore')),
        'cmacub_diametro': fields.float(_('Diametro (cm)'), digits=(3, 2),
                                        help=_('Diametro a altura do peito em centimetros')),
        'cmacub_altura': fields.float(_('Altura (m)'), digits=(4, 2),
                                      help=_('Altura da arvore em metros')),
        'cmacub_altura_comercial': fields.float(_('Altura (m) comercial'), digits=(4, 2),
                                                help=_('Altura comercial da arvore em metros')),
        'cmacub_volume': fields.float(_('Volume'), digits=(2, 9)),
    }

    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(
            cr, uid, uid).company_id.id,
    }
