# -*- coding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _


class calcmadeira_coeficiente_equacao(osv.Model):

    _name = 'calcmadeira.coeficiente.equacao'

    _columns = {
        'company_id': fields.many2one('res.company', _('Empresa'), ondelete='cascade',
                                      required=True, select=True),
        'cmacoe_b0': fields.float('B0', digits=(3, 15), required=True),
        'cmacoe_b1': fields.float('B1', digits=(3, 15), required=True),
        'cmacoe_b2': fields.float('B2', digits=(3, 15), required=True),
        'cmacoe_tipo': fields.selection([('V', _('Volume')), ('F', _('Forma'))], 'Tipo equacao',
                                        size=1, required=True),
        'name': fields.char(_('Descricao'), size=60, required=True),
        'cmacoe_r2': fields.float('R2', digits=(3, 15), required=True),
    }

    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(
            cr, uid, uid).company_id.id,
    }
