# -*- coding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _


class calcmadeira_parametro(osv.Model):
    """
    Classe de parametros do calcmadeira
    Prefixo: cmapar_
    """
    _name = 'calcmadeira.parametro'
    _gerar_logs_logs = 'N'
    _columns = {
        'company_id': fields.many2one('res.company', _('Empresa'), ondelete='cascade',
                                      required=True, select=True),
        'id': fields.integer('ID', readonly=True),
        # 'cmapar_especie_id': fields.many2one('calcmadeira.especies', 'Especie',
        #                                      ondelete="cascade",
        #                                      required=True, select=True),
        'cmapar_altura': fields.float(_('Comprimento das pecas (m)'), digits=(2, 2),
                                      help=_('Comprimento da tora ou comprimento das pecas')),
        'cmapar_altura_corte': fields.float(_('Altura do toco (m)'), digits=(2, 2),
                                            help=_('Altura do corte da arvore')),
        'cmapar_prop_casc': fields.float(_('Proporcao da Casca'), digits=(2, 2),
                                         help=_("Proporcao da Casca")),
        'cmapar_es_serra': fields.float(_('Espessura da Serra (mm)'), digits=(2, 2),
                                        help=_("Espessura da Serra")),
        'cmapar_ang_direito': fields.float(
            _('Angulo direito (define o tamanho da costaneira lateral)'), digits=(3, 2),
            help=_('Define o tamanho da costaneira direita.')),
        'cmapar_ang_base': fields.float(_('Angulo base (define o tamanho da costaneira de baixo)'),
                                        digits=(3, 2),
                                        help=_('Define o tamanho da costaneira de baixo.')),
        'cmapar_laminacao_diametro_minimo': fields.integer(
            _('Parte do diametro nao aproveitavel (rolo resto) (mm)'),
            help=_('Parte do diametro nao aproveitavel (rolo resto) (mm)')),
        'cmapar_laminacao_espessura': fields.float(_('Espessura da folha (mm)'), digits=(3, 2)),
        'cmapar_laminacao_comp_folha': fields.float(
            _('Comprimento da folha (m)'), digits=(3, 2),
            help=_('Lamina guilhotinada em tamanhos iguais.')),
        'cmapar_espessura_peca_central': fields.float(
            _('Espessura da peca central (na medula) (mm)'), digits=(3, 2)),
        'cmapar_proporcao_raio_corte_peca': fields.float(_('Proporcao do raio para corte de pecas'),
                                                         digits=(3, 2)),
    }

    _defaults = {
        'cmapar_altura': 3.10,
        'cmapar_altura_corte': 0.3,
        'cmapar_ang_direito': 45,
        'cmapar_ang_base': 50,
        'cmapar_laminacao_diametro_minimo': 0,
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(
            cr, uid, uid).company_id.id,
    }
