# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class calcmadeira_pecas_rolicas(osv.Model):
    """
    Tabela de Pecas com suas dimencoes
    Prefixo: cmapro
    """
    _name = 'calcmadeira.pecas.rolicas'
    _gerar_logs_logs = 'N'
    _columns = {
        'company_id': fields.many2one('res.company', _('Empresa'), ondelete='cascade',
                                      required=True, select=True),
        'cmapro_sequence': fields.integer(_('Ordem de prioridade'), required=True),
        'cmapro_codigo_peca': fields.integer(_('Codigo da peca'), required=True),
        'name': fields.char(_('Descricao'), size=40, help=_('Descricao da Peca'),
                            placeholder=_('Pranchao')),
        # campos rolica
        #'cmapro_largura': fields.float('Largura', digits=(2, 1), help='Largura da peca'),
        'cmapro_diametro_max': fields.float(_('Diametro maximo'), digits=(2, 1), required=True,
                                            help=_('Diametro maximo da peca')),
        'cmapro_diametro_min': fields.float(_('Diametro minimo'), digits=(2, 1), required=True,
                                            help=_('Diametro minimo da peca')),
        'cmapro_comprimento_tora': fields.float(_('Comprimento da tora'), digits=(2, 1),
                                                required=True, help=_('Comprimento da tora')),
        'cmapro_preco': fields.float(_('Preco'), digits=(5, 2)),
    }
    _order = 'cmapro_sequence'
    _sql_constraints = [
        ('cmapro_prioridade_seq_uniq', 'unique (company_id, cmapro_sequence)',
         _('Ordem de prioridade da peca precisa ser unica!')),
        ('cmapro_prioridade_cod_uniq', 'unique (company_id, cmapro_codigo_peca)',
         _('Codigo da peca precisa ser unico!')),
    ]
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(
            cr, uid, uid).company_id.id,
    }
