# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class calcmadeira_pecas_serradas(osv.Model):
    """
    Tabela de Pecas com suas dimencoes
    Prefixo: cmapse
    """
    _name = 'calcmadeira.pecas.serradas'
    _gerar_logs_logs = 'N'
    _columns = {
        'company_id': fields.many2one('res.company', _('Empresa'), ondelete='cascade',
                                      required=True, select=True),
        'cmapse_sequence': fields.integer(_('Ordem de prioridade'), required=True),
        'cmapse_codigo_peca': fields.integer(_('Codigo da peca'), required=True),
        'name': fields.char(_('Descricao'), size=40, help=_('Descricao da Peca'),
                            placeholder=_('Pranchao')),
        # campos serrada
        'cmapse_menor_espessura': fields.integer(_('Menor espessura'), help=_('Menor espessura'),
                                                 required=True),
        'cmapse_maior_espessura': fields.integer(_('Maior espessura'), help=_('Maior espessura'),
                                                 required=True),
        'cmapse_menor_largura': fields.integer(_('Menor largura'), help=_('Menor largura'),
                                               required=True),
        'cmapse_maior_largura': fields.integer(_('Maior largura'), help=_('Maior Largura'),
                                               required=True),
    }
    _order = 'cmapse_sequence'
    _sql_constraints = [
        ('cmapse_prioridade_seq_uniq', 'unique (company_id, cmapse_sequence)',
         _('Ordem de prioridade da peca precisa ser unica!'))
    ]
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(
            cr, uid, uid).company_id.id,
    }
