# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class calcmadeira_toras(osv.Model):
    """
    Tabela de Toras com suas dimencoes
    Prefixo: cmator
    """
    _name = 'calcmadeira.toras'
    _gerar_logs_logs = 'N'
    _columns = {
        'company_id': fields.many2one('res.company', _('Empresa'), ondelete='cascade',
                                      required=True, select=True),
        'cmator_tora': fields.integer(_('Codigo da tora'), required=True),
        'cmator_arvore': fields.integer(_('Arvore')),
        'cmator_diametro_max': fields.float(_('Diametro maximo'), digits=(2, 1), required=True,
                                            help=_('Diametro maximo da tora')),
        'cmator_diametro_min': fields.float(_('Diametro minimo'), digits=(2, 1), required=True,
                                            help=_('Diametro minimo da peca')),
        'cmator_comprimento_tora': fields.float(_('Comprimento da tora'), digits=(2, 1),
                                                required=True, help=_('Comprimento da tora')),
    }
    _order = 'cmator_arvore'
    _sql_constraints = [
        ('cmator_prioridade_arvore_tora_uniq', 'unique (company_id, cmator_arvore, cmator_tora)',
         _('Arvore e tora precisam ser unicos!')),
    ]
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(
            cr, uid, uid).company_id.id,
    }
