#!/usr/bin/python
# -*- encoding: utf-8 -*-


from openerp.report.render import render
from openerp.report.interface import report_int
from openerp.tools.translate import _
import time
from openerp import pooler
from SigUtils.impressao import Impressora
from SigUtils.formatastring import formataString
import StringIO


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf

class report_custom(report_int):

    def create(self, cr, uid, ids, datas, context=None):

        def center_title(E, C, D, T=157):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        dados_itens = pooler.get_pool(cr.dbname).get('wizard.calcmadeira.calcula')
        brw_calcmadeira_calcula = dados_itens.browse(
            cr, uid, isinstance(ids, list) and ids[0] or ids, context=context)
        tipo_funcao = brw_calcmadeira_calcula.tipo_funcao
        volume_total = brw_calcmadeira_calcula.vt1
        arvores = brw_calcmadeira_calcula.narv
        toras = brw_calcmadeira_calcula.quantidade_tora
        total_vt_vr = brw_calcmadeira_calcula.total_vt_vr
        total_vt_v = brw_calcmadeira_calcula.total_vt_v

        name_funcao = ''
        if tipo_funcao == '1':
            name_funcao = _('Calculo peca rolica')
        elif tipo_funcao == '2':
            name_funcao = _('Calculo desdobro longitudinal base')
        elif tipo_funcao == '3':
            name_funcao = _('Calculo desdobro longitudinal')
        elif tipo_funcao == '4':
            name_funcao = _('Calculo desdobro quadrado circunscrito')
        elif tipo_funcao == '5':
            name_funcao = _('Calculo peca desdobro radial')
        elif tipo_funcao == '6':
            name_funcao = _('Calculo desdobro longitudinal base por tora')
        elif tipo_funcao == '7':
            name_funcao = _('Calculo desdobro longitudinal por tora')
        elif tipo_funcao == '8':
            name_funcao = _('Calculo desdobro quadrado circunscrito por tora')
        elif tipo_funcao == '9':
            name_funcao = _('Calculo desdobro radial por tora')
        elif tipo_funcao == '10':
            name_funcao = _('Calculo de Madeira Laminada')
        elif tipo_funcao == '11':
            name_funcao = _('Calculo de Madeira Laminada por Tora')
        elif tipo_funcao == '12':
            name_funcao = _('Calculo Fator de Forma')

        numtora = 0
        voltora = 0
        numpeca = 0
        volpeca = 0
        totalpeca = 0

        context = context and context.copy() or {}
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='1')
        listagem.informaNome(pdf_string, _('Calcmadeira relatorio pecas'))
        listagem.informaTamLinha(160)
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)
        listagem.defineFonte(tam=8.6)
        title = center_title(_('Calcmadeira'), '', _('Data') + ': %s' % time.strftime('%d/%m/%Y'))
        listagem.informaCab(title)
        listagem.informaCab('--')
        listagem.informaCab(' ' * 71 + _('RELATORIO PECAS') + ' ' * 73)
        listagem.informaCab('--')
        listagem.informaCab(_('Funcao') + ':' + name_funcao)
        listagem.informaCab('--')

        listagem.informaCab('')
        if arvores or toras:
            listagem.imprimeLinha((_('Arvores') + ': %s' % arvores) if arvores > 0
                                  else (_('Toras') + ': %s' % toras))
        listagem.imprimeLinha(_('Volume Total (m³)') + ': %s' % volume_total)
        listagem.imprimeLinha(_('Vt-Vr (m³)') + ': %s' % total_vt_vr)
        listagem.imprimeLinha(_('Vt-v (m³)') + ': %s' % total_vt_v)
        if tipo_funcao in ('10', '11'):
            linha = _('Toras totais') + ': %s' % \
                brw_calcmadeira_calcula.quantidade_tora_total_laminada or 0
            linha += ' ' * 10
            linha += _('Volume tora total') + ': %s' % brw_calcmadeira_calcula.volume_tora_total \
                or 0
            linha += ' ' * 10
            linha += _('Comprimento total laminacao (m)') + ': %s' % \
                     brw_calcmadeira_calcula.comprimento_laminacao_total or 0
            listagem.imprimeLinha(linha)
        if tipo_funcao == '12':
            linha = _('Fator de forma medio') + ': %s' % brw_calcmadeira_calcula.fator_forma_medio \
                or 0
            linha += ' ' * 10
            linha += _('Desvio padrao fator forma') + ': %s' % \
                brw_calcmadeira_calcula.fator_forma_desvio_padrao or 0
            listagem.imprimeLinha(linha)
        listagem.imprimeLinha('')
        listagem.imprimeLinha(_('Nome das variaveis'))
        listagem.imprimeLinha(_('Vr: volume da tora'))
        listagem.imprimeLinha(_('di_casc2: diametro menor da tora'))
        listagem.imprimeLinha(_('di_casc: diametro maior da tora'))
        listagem.imprimeLinha(_('di: diâmetro menor sem casca'))
        listagem.imprimeLinha(_('Tora: numero da tora'))
        listagem.imprimeLinha(_('Arv: numero da arvore'))
        listagem.imprimeLinha('')
        listagem.imprimeLinha('--')
        listagem.imprimeLinha(
            '|  %s|                 %s                 |       %s  '
            '|       %s  |       %s  |       %s  |                 %s  |' % (
                _('CODIGO'), _('NOME'), _('NUMERO TORA'), _('VOLUME TORA'), _('NUMERO PECA'),
                _('VOLUME PECA'), _('PRECO')))
        listagem.imprimeLinha('--')

        for i in brw_calcmadeira_calcula.peca_ids:
            linha = '|'
            linha += formataString(i.codpeca or '', 8, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(i.nomepeca or '', 38, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(i.numtora or 0, 20, ' ', 'E', 'N', 'S')
            numtora += i.numtora
            linha += '|'
            linha += formataString(i.voltora or 0.0, 20, ' ', 'E', 'N', 'S')
            voltora += i.voltora
            linha += '|'
            linha += formataString(i.numpeca or 0, 20, ' ', 'E', 'N', 'S')
            numpeca += i.numpeca
            linha += '|'
            linha += formataString(i.volpeca or 0, 20, ' ', 'E', 'N', 'S')
            volpeca += i.volpeca
            linha += '|'
            linha += formataString(i.preco_item or 0, 24, ' ', 'E', 'N', 'S')
            totalpeca += i.preco_item
            linha += '|'
            listagem.imprimeLinha(linha)
        listagem.imprimeLinha('')
        linha = '|'
        linha += formataString(_('Totais'), 47, ' ', 'D', 'N', 'S')
        linha += '|'
        linha += formataString(numtora or 0, 20, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString(voltora or 0, 20, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString(numpeca or 0, 20, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString(volpeca or 0, 20, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString(totalpeca or 0, 24, ' ', 'E', 'N', 'S')
        linha += '|'
        listagem.imprimeLinha(linha)
        listagem.imprimeLinha('--')
        listagem.imprimeLinha('')

        # RESULTADO ROLICA QUANDO CALCULO 'SERRADA + ROLICA'
        context.get('serrada_e_rolica') and self.listagem_rolica_na_serrada(
            cr, uid, brw_calcmadeira_calcula, listagem, context)

        # CALCULO POR HECTARE
        numtora = 0
        voltora = 0
        numpeca = 0
        volpeca = 0
        totalpeca = 0

        listagem.imprimeLinha('Calculo Por Hectare')
        listagem.imprimeLinha('--')
        listagem.imprimeLinha(
            '|  %s|                 %s                 |       %s  '
            '|       %s  |       %s  |       %s  |                 %s  |' % (
                _('CODIGO'), _('NOME'), _('NUMERO TORA'), _('VOLUME TORA'), _('NUMERO PECA'),
                _('VOLUME PECA'), _('PRECO')))
        listagem.imprimeLinha('--')

        for i in brw_calcmadeira_calcula.itens_hectare_ids:
            linha = '|'
            linha += formataString(i.wcahec_codigo_peca or '', 8, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(i.wcahec_nome_peca or '', 38, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(i.wcahec_numero_tora or 0, 20, ' ', 'E', 'N', 'S')
            numtora += i.wcahec_numero_tora
            linha += '|'
            linha += formataString(i.wcahec_volume_tora or 0.0, 20, ' ', 'E', 'N', 'S')
            voltora += i.wcahec_volume_tora
            linha += '|'
            linha += formataString(i.wcahec_numero_peca or 0, 20, ' ', 'E', 'N', 'S')
            numpeca += i.wcahec_numero_peca
            linha += '|'
            linha += formataString(i.wcahec_volume_peca or 0, 20, ' ', 'E', 'N', 'S')
            volpeca += i.wcahec_volume_peca
            linha += '|'
            linha += formataString(i.wcahec_preco or 0, 24, ' ', 'E', 'N', 'S')
            totalpeca += i.wcahec_preco
            linha += '|'
            listagem.imprimeLinha(linha)
        listagem.imprimeLinha('')
        linha = '|'
        linha += formataString(_('Totais'), 47, ' ', 'D', 'N', 'S')
        linha += '|'
        linha += formataString(numtora or 0, 20, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString(voltora or 0, 20, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString(numpeca or 0, 20, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString(volpeca or 0, 20, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString(totalpeca or 0, 24, ' ', 'E', 'N', 'S')
        linha += '|'
        listagem.imprimeLinha(linha)
        listagem.imprimeLinha('--')

        # RESULTADO ROLICA POR HECTARE QUANDO CALCULO 'SERRADA + ROLICA'
        context.get('serrada_e_rolica') and self.listagem_rolica_na_serrada_hectare(
            cr, uid, brw_calcmadeira_calcula, listagem, context)

        listagem.imprimeLinha('{{ Page }}')

        listagem.cabecalhos = []
        listagem.informaCab('--')
        listagem.informaCab(' ' * 71 + _('RELATORIO PECAS') + ' ' * 73)
        listagem.informaCab('--')

        listagem.imprimeLinha('')
        listagem.imprimeLinha(_('Nome das variaveis'))
        listagem.imprimeLinha(_('es: espessura'))
        listagem.imprimeLinha(
            _('L ou es_reman: largura ou espessura remanescente (depende do modelo de corte)'))
        listagem.imprimeLinha(_('n: numero de pecas'))
        listagem.imprimeLinha(_('v: volume de pecas'))
        listagem.imprimeLinha(_('Tora: numero da tora'))
        listagem.imprimeLinha(_('di_casc2: diametro menor da tora'))
        listagem.imprimeLinha(_('di_casc: diametro maior da tora'))
        tipo_funcao == '1' and listagem.imprimeLinha(_('compr.: comprimento da tora rolica'))
        listagem.imprimeLinha(_('di:  diametro menor sem casca'))
        listagem.imprimeLinha(_('Arv: numero da arvore'))
        # listagem.imprimeLinha('Fatia: fatia (somente para o modelo radial)')
        # listagem.imprimeLinha('l_sobra:  largura de sobra')
        # listagem.imprimeLinha('es_sobra: espessura de sobra (apos o corte da peca)')
        listagem.imprimeLinha(_('comp_lamin: comprimento da lamina (cm)'))
        listagem.imprimeLinha(_('ffarv: fator de forma da arvore'))
        listagem.imprimeLinha('')

        listagem.imprimeLinha('--')
        cabecalho_detalhado = '|%s|       %s        |%s|%s| %s|%s| %s' \
                              '| %s|%s|%s|' % (_('cod'), _('nome'), _('es(mm)'), _('l(mm)'),
                                               _('n'), _('v(m³)'), _('tora'), _('vr(m³)'),
                                               _('di_casc2(cm)'), _('di_casc(cm)'))
        if tipo_funcao == '1':
            cabecalho_detalhado += ' %s|' % _('compr.(m)')
        cabecalho_detalhado += ' %s| %s|%s| %s| %s|%s|%s|%s|' % (
            'di(cm)', 'arv', 'comp_lamin', 'ffarv', 'Preco', 'Conicid.', 'Rendim.', 'parc')
        listagem.imprimeLinha(cabecalho_detalhado)
        listagem.imprimeLinha('--')
        for y in brw_calcmadeira_calcula.result_ids:
            linha = '|'
            linha += formataString(y.codpeca or '', 3, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(y.nomepeca or '', 19, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(y.es_serra or 0, 6, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(y.l or 0, 5, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(y.n or 0, 2, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(y.v or 0, 5, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(y.numtora or 0, 5, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(y.vr or 0, 7, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(y.di_casc2 or 0, 12, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(y.di_casc or 0, 11, ' ', 'E', 'N', 'S')
            linha += '|'
            if tipo_funcao == '1':
                linha += formataString(y.comprimento or 0, 10, ' ', 'E', 'N', 'S')
                linha += '|'
            linha += formataString(y.di or 0, 7, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(y.arv or 0, 4, ' ', 'E', 'N', 'S')
            linha += '|'
            # linha += formataString(y.fatia or 0, 7, ' ', 'E', 'N', 'S')
            # linha += '|'
            # linha += formataString(y.l_sobra or 0, 9, ' ', 'E', 'N', 'S')
            # linha += '|'
            # linha += formataString(y.es_sobra or 0, 10, ' ', 'E', 'N', 'S')
            # linha += '|'
            linha += formataString(y.comp_laminacao or 0, 10, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(y.ffarv or 0, 6, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(y.preco or 0, 6, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(y.conicidade or 0, 8, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(y.rendimento or 0, 7, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(y.parc or 0, 4, ' ', 'E', 'N', 'S')
            linha += '|'
            listagem.imprimeLinha(linha)
        listagem.imprimeLinha('--')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

    def listagem_rolica_na_serrada(self, cr, uid, brw_calcmadeira_calcula, listagem, context=None):
        """
        Metodo de listagem dos dados sinteticos das peças rolicas, quando originado do calculo de
        serradas + rolicas
        @param cr: cursor no banco de dados
        @type cr: object
        @param uid: identificador do usuario na transacao, id da tabela res_users
        @param brw_calcmadeira_calcula: instancia do objeto 'wizard.calcmadeira.calcula'
        @type brw_calcmadeira_calcula: object
        @param listagem: instancia do objeto 'Impressora'
        @type listagem: object
        @param context: dados contextuais
        @type context: dict
        """
        context = context and context.copy() or {}

        numtora = 0
        voltora = 0
        numpeca = 0
        volpeca = 0
        totalpeca = 0

        listagem.imprimeLinha('')
        listagem.imprimeLinha('--')
        listagem.imprimeLinha(
            '|  %s|                 %s                 |       %s  '
            '|       %s  |       %s  |       %s  |                 %s  |' % (
                _('CODIGO'), _('NOME'), _('NUMERO TORA'), _('VOLUME TORA'), _('NUMERO PECA'),
                _('VOLUME PECA'), _('PRECO')))
        listagem.imprimeLinha('--')

        for i in brw_calcmadeira_calcula.peca_rolica_ids:
            linha = '|'
            linha += formataString(i.codpeca or '', 8, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(i.nomepeca or '', 38, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(i.numtora or 0, 20, ' ', 'E', 'N', 'S')
            numtora += i.numtora
            linha += '|'
            linha += formataString(i.voltora or 0.0, 20, ' ', 'E', 'N', 'S')
            voltora += i.voltora
            linha += '|'
            linha += formataString(i.numpeca or 0, 20, ' ', 'E', 'N', 'S')
            numpeca += i.numpeca
            linha += '|'
            linha += formataString(i.volpeca or 0, 20, ' ', 'E', 'N', 'S')
            volpeca += i.volpeca
            linha += '|'
            linha += formataString(i.preco_item or 0, 24, ' ', 'E', 'N', 'S')
            totalpeca += i.preco_item
            linha += '|'
            listagem.imprimeLinha(linha)
        listagem.imprimeLinha('')
        linha = '|'
        linha += formataString(_('Totais'), 47, ' ', 'D', 'N', 'S')
        linha += '|'
        linha += formataString(numtora or 0, 20, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString(voltora or 0, 20, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString(numpeca or 0, 20, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString(volpeca or 0, 20, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString(totalpeca or 0, 24, ' ', 'E', 'N', 'S')
        linha += '|'
        listagem.imprimeLinha(linha)
        listagem.imprimeLinha('--')
        listagem.imprimeLinha('')

    def listagem_rolica_na_serrada_hectare(self, cr, uid, brw_calcmadeira_calcula, listagem,
                                           context=None):
        """
        Metodo de listagem dos dados sinteticos das pecas rolicas por hectare, quando originado do
        calculo de serradas + rolicas
        @param cr: cursor no banco de dados
        @type cr: object
        @param uid: identificador do usuario na transacao, id da tabela res_users
        @param brw_calcmadeira_calcula: instancia do objeto 'wizard.calcmadeira.calcula'
        @type brw_calcmadeira_calcula: object
        @param listagem: instancia do objeto 'Impressora'
        @type listagem: object
        @param context: dados contextuais
        @type context: dict
        """
        context = context and context.copy() or {}

        numtora = 0
        voltora = 0
        numpeca = 0
        volpeca = 0
        totalpeca = 0

        listagem.imprimeLinha('')
        listagem.imprimeLinha('--')
        listagem.imprimeLinha(
            '|  %s|                 %s                 |       %s  '
            '|       %s  |       %s  |       %s  |                 %s  |' % (
                _('CODIGO'), _('NOME'), _('NUMERO TORA'), _('VOLUME TORA'), _('NUMERO PECA'),
                _('VOLUME PECA'), _('PRECO')))
        listagem.imprimeLinha('--')

        for i in brw_calcmadeira_calcula.itens_hectare_rolica_ids:
            linha = '|'
            linha += formataString(i.codigo_peca or '', 8, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(i.nome_peca or '', 38, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(i.numero_tora or 0, 20, ' ', 'E', 'N', 'S')
            numtora += i.numero_tora
            linha += '|'
            linha += formataString(i.volume_tora or 0.0, 20, ' ', 'E', 'N', 'S')
            voltora += i.volume_tora
            linha += '|'
            linha += formataString(i.numero_peca or 0, 20, ' ', 'E', 'N', 'S')
            numpeca += i.numero_peca
            linha += '|'
            linha += formataString(i.volume_peca or 0, 20, ' ', 'E', 'N', 'S')
            volpeca += i.volume_peca
            linha += '|'
            linha += formataString(i.preco or 0, 24, ' ', 'E', 'N', 'S')
            totalpeca += i.preco
            linha += '|'
            listagem.imprimeLinha(linha)
        listagem.imprimeLinha('')
        linha = '|'
        linha += formataString(_('Totais'), 47, ' ', 'D', 'N', 'S')
        linha += '|'
        linha += formataString(numtora or 0, 20, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString(voltora or 0, 20, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString(numpeca or 0, 20, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString(volpeca or 0, 20, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString(totalpeca or 0, 24, ' ', 'E', 'N', 'S')
        linha += '|'
        listagem.imprimeLinha(linha)
        listagem.imprimeLinha('--')
        listagem.imprimeLinha('')

report_custom('report.listagem_pecas')
