# -*- coding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _


class wizard_calcmadeira_arvore_rolica_serrada(osv.TransientModel):
    _name = 'wizard.calcmadeira.arvore.rolica.serrada'
    _columns = {
        'arvore_total': fields.integer(_('Arvores totais na parcela'), readonly=True),
        'proporcao_arvore_rolica': fields.float(_('Proporcao Arvores Para Rolica'), digits=(3, 2),
                                                readonly=True),
        'proporcao_arvore_serrada': fields.float(_('Proporcao Arvores Para Serrada'), digits=(3, 2),
                                                 readonly=True),
        'altura_comercial_igual_total': fields.boolean(
            'Retornar altura comercial igual a altura total'),
    }
    _defaults = {
        'altura_comercial_igual_total': lambda * a: False,
    }

    def gerar_arquivo_arvore(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        altura_comercial_igual_total = self.browse(
            cr, uid, isinstance(ids, list) and ids[0] or ids, context).altura_comercial_igual_total
        obj_calcmadeira_arvore = self.pool.get('calcmadeira.arvores')
        arvore_ids = obj_calcmadeira_arvore.search(cr, uid, [], context=context)
        if not arvore_ids:
            raise osv.except_osv(_('Atencao'), _('Nao ha arvores cadastradas.'))
        arvore_dados = obj_calcmadeira_arvore.read(cr, uid, arvore_ids, [], context)
        obj_calcmadeira_arvore.unlink(cr, uid, arvore_ids, context)
        arv_rolic = 0
        arv_serrad = 0
        for arvore in arvore_dados:
            parc = float(arvore.get('cmaarv_linha'))
            arv = float(arvore.get('cmaarv_arvore'))
            dap = float(arvore.get('cmaarv_diametro'))
            ht = float(arvore.get('cmaarv_altura'))
            hc = float(arvore.get('cmaarv_altura_comecial'))

            if altura_comercial_igual_total:
                hc = ht
            else:
                if hc == 0 or hc == '':
                    arv_rolic += 1
                    hc = ht
                else:
                    arv_serrad += 1
                    hc = 0

            vals_arvore = {
                'cmaarv_linha': parc,
                'cmaarv_arvore': arv,
                'cmaarv_diametro': dap,
                'cmaarv_altura': ht,
                'cmaarv_altura_comecial': hc
            }
            obj_calcmadeira_arvore.create(cr, uid, vals_arvore, context)
        vals = {'arvore_total': len(arvore_dados),
                'proporcao_arvore_rolica': 0 if altura_comercial_igual_total
                else (arv_rolic / float(arv_rolic + arv_serrad)),
                'proporcao_arvore_serrada': 0 if altura_comercial_igual_total
                else (arv_serrad / float(arv_rolic + arv_serrad))
        }
        self.write(cr, uid, ids, vals, context)
