# -*-coding: UTF-8-*-

import pandas as pd
# from ..funcoes import FFormaEqFormaCubagem
# from ..funcoes import Formulas
# from ..funcoes import SubRotinas
import math
import numpy as np
from openerp.osv import osv, fields
from openerp.tools.translate import _
from funcoes import Forma_hi, forma, SelecionaPeca_QuadCircun, SelecionaPeca_f0, Eqdi_casc
from funcoes import SelecionaPeca_Longitudinal_CostaneiraBase, SelecionaPeca_f1, Formulas, Eqhi

pd.set_option('display.max_columns', 10)

# ------------------------------------------------------------------
# CalculaPecas

# Dap - diametro a altura do peito
# ht - altura total da árvore
# hc - altura comercial da árvore
# hi - comprimento da tora = comprimento da peça
# hi_atual - começa com altura do toco (30 cm)
# es - espessura da peça
# es_serra - espessura da serra (perda de madeira no corte)
# min_es - menor espessura da peça
# max_es - maior espessura da peça
# di_casc - diâmetro com casca
# di_casc2 - diâmetro com casca para calculo do volume da peça
# di- diâmetro sem casca
# l - largura peça
# l_d, l_e - larguras direita e esquerda da peça
# 'l_s, l_i - larguras superior e inferior da peça
# 'l_d2 - largura direita da próxima peça
# 'l_s2 - largura superior da próxima peça
# 'cord_d, cord_e - cordas direita e esquerda da peça
# 'cord_s, cord_i - cordas superior e inferior da peça
# 'ang_d, ang_e - angulos direito e esquerdo formados c respectivas cordas
# 'ang_s, ang_i - angulos superior e inferior formados c respectivas cordas
# es_sobra - sobra peça
# v - volume peça
# vr - volume tora ou peça roliça
# vt - volume arvore
# n - num.peças
# cod_tora - numero de toras por árvore
# narv - numero de árvores da amostra
# codpeca-codigo peça


class wizard_calcula_pecas_mad_serr(osv.TransientModel):
    _name = 'wizard.calcula.pecas.mad.serr'
    _description = 'CalculaPecasMadSerr'

    _columns = {
        'calcmadeira_calcula_id': fields.many2one('wizard.calcmadeira.calcula', 'Calculo',
                                                  required=True)
    }

    def executa(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        dados_execucao = {'detalhado': {}, 'sintetico': {}}
        brw_calcmadeira_calcula = self.browse(
            cr, uid, ids[0] if isinstance(ids, (list, tuple)) else ids, context).\
            calcmadeira_calcula_id
        tipo_funcao = brw_calcmadeira_calcula.tipo_funcao
        obj_calcmadeira_parametro = self.pool.get('calcmadeira.parametro')
        calcmadeira_parametro_id = obj_calcmadeira_parametro.search(cr, uid, [], context=context)
        parametro_dados = obj_calcmadeira_parametro.read(cr, uid, calcmadeira_parametro_id[0], [],
                                                         context, '_classic_write')
        cmapar_es_medula = 0
        if parametro_dados.get('cmapar_espessura_peca_central') > parametro_dados.get(
                'cmapar_es_serra'):
            cmapar_es_medula = (parametro_dados.get('cmapar_espessura_peca_central') or 0) + (
                    parametro_dados.get('cmapar_es_serra') or 0)
        parametro_dados.update({'es_medula': cmapar_es_medula})

        escolhaEqVol = ''
        escolhaEqForma = ''

        escolha = ''
        if tipo_funcao == '2':
            escolha = '3'
        elif tipo_funcao == '3':
            escolha = '2'
        elif tipo_funcao == '4':
            escolha = '1'
        elif tipo_funcao == '5':
            escolha = '4'
        elif tipo_funcao == '13':
            escolha = '7'
        elif tipo_funcao == '15':
            escolha = '8'
        # elif tipo_funcao == '10':
        #    escolha = '6'

        # -----------------------------------------------------------------
        print('Calculador de Madeira Serrada')

        # Lê arquivo de árvores
        # -----------------------
        obj_calcmadeira_arvore = self.pool.get('calcmadeira.arvores')
        calcmadeira_arvore_ids = obj_calcmadeira_arvore.search(
            cr, uid, [] + brw_calcmadeira_calcula.calcmadeira_trata_talhao_peca(),
            context=context)
        calcmadeira_arvore_dados = obj_calcmadeira_arvore.read(
            cr, uid, calcmadeira_arvore_ids, [], context)
        linarv, narv = calcmadeira_arvore_dados, len(calcmadeira_arvore_dados)
        # -----------------------

        codpeca = 0
        peca = "" # nome da peça
        di_casc = di_casc2 = 0
        cod_tora = 0 # numero de toras por árvore
        ntora1 = 0
        cod_arv = 0 # codigo da árvore no inventário
        cod_tora = 0 # variavel usada em rotina para tora
        parc = 0 # numero de parcelas
        vt = 0.0000
        vrt = 0.0000
        arv = 1 # numero de árvores (começa com a 1a)
        arv_proces = 0 # numero de árvores aproveitadas
        falha = 0 # numero de falhas
        preco = 0.0000
        precot = 0.0000
        preco_medula = 0.0000
        conic_tora = 0.0000

        # Para acumulo de peças do Relatorio Detalhado
        codpeca_list = []
        peca_list = []
        es_list = []
        l_div_list = []
        n_div_list = []
        v_list = []
        hi_list = []
        vr_list = []
        vt_list = []
        di_casc2_list = []
        di_casc_list = []
        di_list = []
        ntora_list = []

        arv_list = []
        talh_list = []
        parc_list = []

        arv_parc_list = []
        arv_talh_list = []
        arv_falha_list = []

        fator_talh_ha = []
        fator_parc_ha = []

        preco_list = []
        conic_tora_list = []

        comp_lamin_list = []

        # Var Madeira Laminada
        comp_lamin1 = 0.0000
        comp_lamin1_eixo = 0.0000

        if escolha == '1' or escolha == '2' or escolha == '3' or escolha == '4' or escolha == '7' \
                or escolha == '8':

            # -----------------------
            lista_de_pecas = [[0]]
            for p in brw_calcmadeira_calcula.pecas_serradas:
                lista_de_pecas.append([
                    p.cmapse_codigo_peca,  # int(pecas[0])
                    p.name,  # str(pecas[1])
                    p.cmapse_menor_espessura,  # int(pecas[2])
                    p.cmapse_maior_espessura,  # int(pecas[3])
                    p.cmapse_menor_largura,  # int(pecas[4])
                    p.cmapse_maior_largura,  # int(pecas[5])
                    p.cmapse_sequence  # int(pecas[6]
                ])
            linpeca = lista_de_pecas
            # -----------------------

            # Receita (R$)
            # -----------------------
            obj_pecas_serradas_preco = self.pool.get('calcmadeira.pecas.serradas.preco')
            pecas_serradas_precos_ids = obj_pecas_serradas_preco.search(cr, uid, [],
                                                                        context=context)
            peca_preco_list = [0]
            for lp in obj_pecas_serradas_preco.read(cr, uid, pecas_serradas_precos_ids, [],
                                                    context):
                peca_preco_list.append([
                    lp.get('cpspre_codigo_peca'),
                    lp.get('name'),
                    lp.get('cpspre_espessura'),
                    lp.get('cpspre_largura'),
                    lp.get('cpspre_preco')
                ])
            linpeca_preco = peca_preco_list
            # -----------------------

        # Parametro da Madeira Laminada
        if escolha == '6':
            print('Entre com diametro não aproveitavel para laminar (diametro do rolo resto, mm):')
            di_eixo = parametro_dados.get('cmapar_laminacao_diametro_minimo')

            print('Entre com o comprimento da folha em metros!')
            comp_folha = parametro_dados.get('cmapar_laminacao_comp_folha')

            t = 0
            comp_lamin_arv = 0
            comp_lamin_total = 0

        # declarando variáveis, não necessário no VBA
        di = 100
        l = 100
        # -------------------------------------------
        es_serra = parametro_dados.get('cmapar_es_serra')
        hi_atual = parametro_dados.get('cmapar_altura_corte')
        hi = parametro_dados.get('cmapar_altura')
        hi_min = 0.0
        prop_casc = parametro_dados.get('cmapar_prop_casc')
        l_min_pecas, es_min_pecas = brw_calcmadeira_calcula.calmadeira_menor_largura_espessura()
        di_min = 0.0
        es_perim = parametro_dados.get('cmapar_laminacao_espessura')
        flecha_div_r = parametro_dados.get('cmapar_proporcao_raio_corte_peca')
        es_medula = parametro_dados.get('es_medula')
        # -------------------------------------------

        # if escolhaEqForma == '':
        #    print('0 para equação de forma interna\n'
        #          '1 para equação de forma do usuário\n')
        #
        #    escolhaEqForma = str(input())
        #
        # if escolhaEqForma == '0':
        #    B0f = B1f = B2f = 0
        #
        # if escolhaEqForma == '1':
        #    # --------------------------------------
        #    B0f, B1f, B2f = SubRotinas.Forma()
        #    # --------------------------------------

        #---------------------------------
        # FFormaEqFormaCubagem.cubagemtxt()
        #---------------------------------

        # if escolhaEqVol == '':
        #    print('0 para equação de volume interna\n'
        #          '1 para equação de volume do usuário\n')
        #
        #    escolhaEqVol = str(input())
        #
        # if escolhaEqVol == '0':
        #    B0v = B1v = B2v = 0
        #
        # if escolhaEqVol == '1':
        #    # --------------------------------------
        #    B0v, B1v, B2v = SubRotinas.Volume()
        #    # --------------------------------------

        # Executa por árvore
        while arv <= narv:
            v = 0.0000
            n = 0
            vr = 0.0000  # volume da tora

            # Acessa arquivo texto, armazena dap e ht por árvore, e calcula seu volume (vt)
            dados = linarv[arv-1]

            talh = float(dados.get('cmaarv_talhao'))
            parc = int(dados.get('cmaarv_linha'))
            cod_arv = dados.get('cmaarv_arvore')
            dap = float(dados.get('cmaarv_diametro'))
            ht = float(dados.get('cmaarv_altura'))
            hc = float(dados.get('cmaarv_altura_comecial'))

            # conta árvores processadas
            if hc > 0 and dap > 0 and ht > 0:
                arv_proces = arv_proces + 1

                vt = self.pool.get('wizard.calcmadeira.calcula').calcmadeira_get_equacao_volume(
                    cr, uid, brw_calcmadeira_calcula.coeficiente_volume_id, dap, ht, hc, context)

                di_casc, di_casc2, di_casc_deriv, di_casc2_deriv = self.pool.get('wizard.calcmadeira.calcula').\
                    calcmadeira_get_equacao_forma(cr, uid,
                                                  coeficiente_forma=brw_calcmadeira_calcula.coeficiente_forma_id,
                                                  hi_atual=hi_atual,
                                                  hi=hi,
                                                  ht=ht,
                                                  dap=dap,
                                                  di_casc=di_casc,
                                                  di_casc2=di_casc2,
                                                  context=context)

                # ALTERAÇÃO 01/12/2023 Quando usuario não define o di_limite precisa ser calculado pela hc do arquivo
                di_limite = brw_calcmadeira_calcula.altura_comercial_diametro_minimo
                di_limite_tmp = di_limite

                if di_limite > 0:
                    # --------------------------------------
                    sql = """
                    SELECT * FROM calcmadeira_taper WHERE company_id = %s ORDER BY id
                    """ % brw_calcmadeira_calcula.company_id.id
                    cr.execute(sql)
                    taper_dados = cr.dictfetchall()
                    B0f_hi, B1f_hi, B2f_hi = Forma_hi(taper_dados)
                    hi1 = Eqhi(B0f_hi, B1f_hi, B2f_hi, hi_atual, hi, ht, dap, di_limite)
                    hc = hi1.hi_result()
                    # ---------------------------------------

                else:
                    hi0 = hi
                    hi = hc
                    # --------------------------------------
                    sql = """
                    SELECT * FROM calcmadeira_taper WHERE company_id = %s ORDER BY id
                    """ % brw_calcmadeira_calcula.company_id.id
                    cr.execute(sql)
                    taper_dados = cr.dictfetchall()
                    B0f, B1f, B2f, _ = forma(taper_dados)
                    resultado = Eqdi_casc(B0f, B1f, B2f, hi_atual, hi, ht, dap)
                    di_limite = resultado.di_casc2_result()
                    # --------------------------------------
                    hi = hi0

            # Lista vt
            vt_list.append(vt)
            vt = 0

            # Lista falhas
            arv_parc_list.append(parc)
            arv_talh_list.append(talh)

            if dap == 0 or dap == "" or ht == 0 or ht == "":
                arv_falha_list.append(1)
            else:
                arv_falha_list.append(0)

            # ALTERAÇÃO 01/12/2023
            di_limite = di_limite_tmp

            # numero da tora
            cod_tora = 0

            es_sobra = 100

            # Calcula peças por seção do tronco até completar altura da árvore
            while hi_atual + hi <= hc:

                di_casc, di_casc2, di_casc_deriv, di_casc2_deriv = self.pool.get('wizard.calcmadeira.calcula').\
                    calcmadeira_get_equacao_forma(cr, uid,
                                                  coeficiente_forma=brw_calcmadeira_calcula.coeficiente_forma_id,
                                                  hi_atual=hi_atual,
                                                  hi=hi,
                                                  ht=ht,
                                                  dap=dap,
                                                  di_casc=di_casc,
                                                  di_casc2=di_casc2,
                                                  context=context)

                # volume da tora usando formula de Smalian
                vr = math.pi / 40000 * (di_casc ** 2 + di_casc2 ** 2) / 2 * hi

                # ALTERAÇÃO 03/12/2023 Se derivada positiva, diametro começa a aumentar
                # Solução: utilizar a taxa com sinal negativo e deduzir do di_casc2
                if di_casc2_deriv <= 0:
                    di = di_casc2 * (1 - prop_casc) * 10
                else:
                    di = (di_casc2 - di_casc2_deriv) * (1 - prop_casc) * 10

                cod_tora = cod_tora + 1

                # Alteração 01/08/2023
                if hi != 0 and hi != "":
                    # Conicidade da tora (cm/m)
                    conic_tora = (di_casc - di_casc2) / hi

                preco = 0

                print('vr:{}, di_casc2:{}, di_casc:{}, di:{}, tora:{},arv:{}, conic_tora:{}'. \
                      format(vr, di_casc2, di_casc, di, cod_tora, arv, conic_tora))

                vrt = vrt + vr

                flecha = flecha0 = 0
                cord_d1 = 0
                cord_d = 0
                r_flecha_topo = 0
                R_flecha_base = 0
                s = 0

                if escolha != '7':
                    es_medula = 0

                if escolha == '1':
                    # largura da peça
                    l = di / math.sqrt(2)

                if escolha == '2' or escolha == '3' or escolha == '7' or escolha == '8':

                    # angulo inicial para desconto do di para cada lado (flecha0) e angulo da base
                    ang_d = parametro_dados.get('cmapar_ang_direito')
                    ang_base = parametro_dados.get('cmapar_ang_base')

                    if escolha == '3':
                        # comprimento da peça, do eixo x até o limite da costaneira da base
                        # (R-flecha)
                        R_flecha_base = di / 2 * math.cos(ang_base * math.pi / 180)

                    if escolha != '3':
                        ang_base = 0

                    if escolha == '8':
                        ang_base = 90
                        R_flecha_base = 0

                    flecha0 = di / 2 * (1 - math.cos(ang_d * math.pi / 180))

                    # 'largura da peça (corda)
                    # 'Case 2 e 7: Longitudinal completo quando ang_base = 0
                    # 'Case 3: quando compara ang_d com ang_base
                    # 'Case 8: quando ang_base = 90

                    # largura da peça (corda)
                    if ang_d < 90 - ang_base or ang_base == 0:
                        l = di * math.sin(ang_d * math.pi / 180)
                    else:
                        l = di * (math.sin(ang_d * math.pi / 180) / 2) + R_flecha_base

                if escolha == '4':
                    l = di / 2

                # passado pela função parametros
                # break para sair da árvore. Se tora não atende, demais toras também não.
                # subrai na contagem, porque não adianta contar tora incompleta da árvore.
                # total de toras informa somente toras desdobradas

                if escolha == '1':
                    if l < l_min_pecas + es_serra:
                        cod_tora = cod_tora - 1
                        break

                if escolha == '2' or escolha == '3' or escolha == '7':
                    if di < l_min_pecas + es_serra:
                        cod_tora = cod_tora - 1
                        break

                if escolha == '4':

                    # passado pela função parametros
                    if l < l_min_pecas + es_serra or di / 2 < es_min_pecas + es_serra:
                        cod_tora = cod_tora - 1

                        break

                    l_e = l_d = l_i = l_s = l
                    l_sobra = 0.0000
                    nes1 = nes2 = 0.0
                    es1 = es2 = 0.0
                    ang_d = 90.0000
                    ang_s = 0.0000
                    ang_e = ang_i = 0

                    fatia = 0

                    n1 = v1 = 0

                    # Verifica se pelo menos a menor peça será selecionada
                    es = es_min_pecas + es_serra
                    # ---------------------------------------------
                    ang_e, ang_d, ang_i, ang_s, l_e, l_d, l_i, l_s \
                        = Formulas(fatia, nes1, nes2, es, es_serra,
                                            di, ang_e, ang_d, ang_i, ang_s, l_e, l_d, l_i, l_s)
                    # ---------------------------------------------
                    es = 0

                if escolha == '6':
                    # 'numero de voltas totais
                    if es_perim > 0:
                        n = int(di / 2 / es_perim)
                    else:
                        print("escolha espessura da lamina em mm!")
                        break

                    for t in range(0, n + 1):
                        # 'comprimento da lamina (mm)

                        comp_lamin = math.pi * (di - t * 2 * es_perim)

                        if (di - t * 2 * es_perim) < di_eixo:
                            break

                        comp_lamin1 = comp_lamin1 + comp_lamin

                # ----------------------

                if escolha == '1':
                    # -----------------------------------------------------
                    # Seleciona Peça
                    vr, cod_tora, \
                    codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list, \
                    ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, talh_list, parc_list, conic_tora_list \
                        = SelecionaPeca_QuadCircun(es_serra,hi,vr, l, cod_tora,linpeca, linpeca_preco,
                                                              cord_d, es_medula, escolha,
                                                              di_casc2, di_casc, di, cod_arv, talh, parc, conic_tora,
                                                              ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, talh_list, parc_list, conic_tora_list,
                                                              codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list)
                    # -----------------------------------------------------

                if escolha == '2' or escolha == '3' or escolha == '8':
                    # -----------------------------------------------------
                    # Seleciona Peça
                    vr, cod_tora, \
                    l, cord_d1, cord_d, r_flecha_topo, s, \
                    codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list, \
                    ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, talh_list, parc_list, conic_tora_list \
                        = SelecionaPeca_Longitudinal_CostaneiraBase(
                        l_min_pecas, es_min_pecas, es_serra, hi, vr,
                        flecha0, R_flecha_base, l, cod_tora, linpeca,linpeca_preco,
                        ang_base, escolha, flecha_div_r, cord_d1, cord_d, r_flecha_topo, s,
                        di_casc2, di_casc, di, cod_arv, talh, parc, conic_tora,
                        ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, talh_list, parc_list, conic_tora_list,
                        codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list
                    )
                    # -----------------------------------------------------------

                if escolha == '7':
                    l_sobra = l
                    flecha = 0
                    r_flecha_topo = 0.0000
                    cord_d = 0

                    for s in range(0, 1 + 1):
                        # -----------------------------------------------------
                        # Seleciona Peça
                        vr, cod_tora, \
                        l, cord_d1, cord_d, r_flecha_topo, s, \
                        codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list, \
                        ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, talh_list, parc_list, conic_tora_list \
                            = SelecionaPeca_Longitudinal_CostaneiraBase(
                            l_min_pecas, es_min_pecas, es_serra, hi, vr,
                            flecha0, R_flecha_base, l, cod_tora, linpeca, linpeca_preco,
                            ang_base, escolha, flecha_div_r, cord_d1, cord_d, r_flecha_topo, s,
                            di_casc2, di_casc, di, cod_arv, talh, parc, conic_tora,
                            ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, talh_list, parc_list, conic_tora_list,
                            codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list
                        )
                        # -----------------------------------------------------------

                    # -----------------------------------------------------
                    # Seleciona Peça
                    vr, cod_tora, \
                    codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list, \
                    ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, talh_list, parc_list, conic_tora_list \
                        = SelecionaPeca_QuadCircun(es_serra, hi, vr, l, cod_tora, linpeca, linpeca_preco,
                                                              cord_d, es_medula, escolha,
                                                              di_casc2, di_casc, di, cod_arv, talh, parc, conic_tora,
                                                              ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list,
                                                              arv_list, talh_list, parc_list,conic_tora_list,
                                                              codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list)
                    # -----------------------------------------------------

                if escolha == '4':
                    while l_d >= l_min_pecas + es_serra or l_s >= l_min_pecas + es_serra:
                        if fatia == 0:
                            # ----------------------------------------------------
                            linpeca, fatia, ang_e, ang_d, ang_i, ang_s, vr, es_serra, es, es1, es2, nes1, nes2, di, hi, l_e, l_d, l_i, l_s, l_sobra, cod_tora, \
                            codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list, \
                            ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, talh_list, parc_list, conic_tora_list \
                                = SelecionaPeca_f0(
                                l_min_pecas, es_min_pecas, linpeca, linpeca_preco,
                                ang_e, ang_d, ang_i, ang_s, vr, es_serra, es, es1, es2, nes1,
                                nes2,
                                hi, l_e, l_d, l_i, l_s, l_sobra, cod_tora,
                                di_casc2, di_casc, di, cod_arv, talh, parc, conic_tora,
                                ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, talh_list, parc_list, conic_tora_list,
                                codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list,
                                preco, fatia)

                            fatia = 1
                            # -----------------------------------------------------

                        if fatia == 1:
                            # ----------------------------------------------------
                            linpeca, fatia, ang_e, ang_d, ang_i, ang_s, vr, es_serra, es, es1, es2, nes1, nes2, di, hi, l_e, l_d, l_i, l_s, l_sobra, cod_tora, \
                            codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list, \
                            ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, talh_list, parc_list, conic_tora_list \
                                = SelecionaPeca_f1(
                                l_min_pecas, es_min_pecas, linpeca, linpeca_preco,
                                ang_e, ang_d, ang_i, ang_s, vr, es_serra, es, es1, es2, nes1,
                                nes2,
                                hi, l_e, l_d, l_i, l_s, l_sobra, cod_tora,
                                di_casc2, di_casc, di, cod_arv, talh, parc, conic_tora,
                                ntora_list, hi_list, vr_list, di_casc2_list, di_casc_list, di_list, arv_list, talh_list, parc_list, conic_tora_list,
                                codpeca_list, peca_list, es_list, l_div_list, n_div_list, v_list, preco_list,
                                preco, fatia)

                            fatia = 0
                            # ----------------------------------------------------

                            if l_d < es_min_pecas + es_serra and l_s < es_min_pecas + es_serra:
                                break

                if escolha == '6':
                    # Relatório de dimensões da laminação
                    comp_lamin_list.append(comp_lamin1 / 1000)
                    hi_list.append(hi)
                    vr_list.append(vr)
                    ntora_list.append(cod_tora)
                    arv_list.append(cod_arv)
                    parc_list.append(parc)
                    talh_list.append(talh)

                    comp_lamin_arv = comp_lamin_arv + comp_lamin1 / 1000
                    comp_lamin_total = comp_lamin_total + comp_lamin1 / 1000

                    # 'armazena a linha de gravação dos dados em Relat_Serrad
                    # print('compr.lamin.(m):{}, vol.tora:{}, num. tora:{},arv{}'.format((comp_lamin1 - comp_lamin1_eixo) / 1000, vr,
                    #                                                                    cod_tora, arv))
                    comp_lamin1 = 0

                # atualiza hi_atual com o comprimento da tora calculada (hi)
                hi_atual = hi_atual + hi

                # print('hi_atual=', hi_atual)
            # loop while da arv
            arv = arv + 1

            # retorna altura do toco
            # Precisa pegar valor definido pelo usuario não é fixo
            # -------------------------------------------------
            hi_atual = parametro_dados.get('cmapar_altura_corte')
            # -------------------------------------------------

        if escolha == '6':
            # 'Relatório de dimensões da laminação
            # 'armazena a linha de gravação dos dados em Relat_Serrad
            comp_lamin_list.append(comp_lamin_arv)

            comp_lamin_arv = 0

            data02 = {'comp_lamin(m)': comp_lamin_list}

            # 'vol.tora(m3)': vr_list, 'num.tora': ntora_list,
            # 'arv': arv_list, 'parc': parc_list, 'talh': talh_list

            df02 = pd.DataFrame(data02)

            print(df02)

            if comp_folha != 0:
                # print('comprim. total de laminação (m): ' + comp_lamin_total)

                print('numero de folhas: ', math.trunc(comp_lamin_total / comp_folha))

        #  ROTINAS 4 e 8 TEM MULTIPLICADORES PARA NÚMERO DE PEÇAS E SEUS RESPECTIVOS VOLUMES E PREÇOS
        if escolha == '4':
            n_div_list = np.multiply(n_div_list, 4)
            v_list = np.multiply(v_list, 4)
            preco_list = np.multiply(preco_list, 4)

        elif escolha == '8':
            n_div_list = np.multiply(n_div_list, 2)
            v_list = np.multiply(v_list, 2)
            preco_list = np.multiply(preco_list, 2)

        # -----------------------------------------------------------------------------------
        # CRV (v/vr)
        # ALTERAção 06/12/2023
        CRV_freq = []

        # CALCULA ATÉ A PENÚLTIMA TORA
        j = 0
        v = 0

        for i in range(0, len(ntora_list)):

            if i != 0 and vr_list[i - 1] != vr_list[i] and j == 0:
                CRV_freq.append(v_list[i - 1] / vr_list[i - 1])

            elif vr_list[i - 1] == vr_list[i] and ntora_list[i - 1] == ntora_list[i]:
                v = v + v_list[i - 1]
                j = j + 1

            elif vr_list[i - 1] != vr_list[i] and j > 0:
                v = v + v_list[i - 1]
                j = j + 1

                for k in range(0, j):
                    CRV_freq.append(v / vr_list[i - 1])

                print('-' * 100)
                print(
                    'tora:{}, v: {}, vr: {}, CRV: {}, i: {}, j: {}'.format(ntora_list[i - 1], v, vr_list[i - 1],
                                                                           v / vr_list[i - 1], i - 1,
                                                                           j))
                print('-' * 100)

                j = 0
                v = 0

        # CALCULA A ULTIMA TORA
        j = 0
        v = 0

        i = len(ntora_list) - 1
        cont = 0
        while cont == 0:

            if vr_list[i - 1] != vr_list[i] and j == 0:
                CRV_freq.append(v_list[i - 1] / vr_list[i - 1])
                cont = cont + 1

            elif vr_list[i - 1] == vr_list[i] and ntora_list[i - 1] == ntora_list[i]:
                v = v + v_list[i]
                j = j + 1
                i = i - 1

            elif vr_list[i - 1] != vr_list[i] and j > 0:
                v = v + v_list[i]
                j = j + 1

                for k in range(0, j):
                    CRV_freq.append(v / vr_list[i])

                print('-' * 100)
                print(
                    'tora:{}, v: {}, vr: {}, CRV: {}, i: {}, j: {}'.format(ntora_list[i], v, vr_list[i], v / vr_list[i],
                                                                           i - 1, j))
                print('-' * 100)

                cont = cont + 1
                j = 0
                v = 0

        # # Alteração 01/08/2023
        # CRV_freq = []
        #
        # i = 0
        # j = 0
        # v = 0
        # vr = 0
        # while i < len(ntora_list):
        #
        #     while i < len(ntora_list) - 1 and \
        #             ntora_list[i] == ntora_list[i + 1] and arv_list[i] == arv_list[i + 1] \
        #             and parc_list[i] == parc_list[i + 1]:
        #
        #         # es != 0 significa que tem peça para somar (soma por tora)
        #         if es_list[i] != 0:
        #             v = v + v_list[i]
        #             vr = vr + vr_list[i]
        #
        #             i = i + 1
        #             j = j + 1
        #
        #     if ntora_list[i - 1] != ntora_list[i] and es_list[i] != 0:
        #         CRV_freq.append(v_list[i] / vr_list[i])
        #         v = v_list[i]
        #         vr = vr_list[i]
        #         i = i + 1
        #         j = j + 1
        #
        #     elif ntora_list[i - 1] != ntora_list[i] and es_list[i] == 0:
        #         v = vr = 1
        #         CRV_freq.append(1)
        #         i = i + 1
        #         j = j + 1
        #
        #     elif ntora_list[i - 1] == ntora_list[i] and es_list[i] != 0:
        #         v = v + v_list[i]
        #         vr = vr + vr_list[i]
        #
        #         i = i + 1
        #         j = j + 1
        #
        #         for k in range(0, j):
        #             CRV_freq.append(v / (vr / j))
        #
        #     # if escolha == '4':
        #     #     CRV_freq4.append((v / 4) / vr)
        #     #     # preco_list[i] = preco_list[i] / 4
        #     #     # v = v_list[i] / 4
        #     #     # vr = vr_list[i]
        #     #     # i = i + 1
        #     #     # j = j + 1
        #     #
        #     # elif escolha == '8':
        #     #     CRV_freq8.append((v/ 2) / vr)
        #     #     # preco_list[i] = preco_list[i] / 2
        #     #     # v = v_list[i] / 2
        #     #     # vr = vr_list[i]
        #     #     # i = i + 1
        #     #     # j = j + 1
        #
        #     print('-' * 100)
        #     print('tora:{}, v: {}, vr: {}, CRV: {}, i: {}, j: {}'.format(ntora_list[i - 1], v, vr / j, v / (vr / j), i,
        #                                                                  j))
        #     print('-' * 100)
        #
        #     j = 0
        #     v = 0
        #     vr = 0

        # ------------------------------------------------------------------------------------
        # RESULTADO DETALHADO

        print('')
        print('RESULTADO DETALHADO SERRADA')
        print('-'*70)

        # data0 = {'codpeca': codpeca_list, 'peca': peca_list, 'es': es_list, 'l': l_div_list,
        #          'n': n_div_list, 'v': v_list,'tora': ntora_list, 'hi': hi_list, 'vr': vr_list,
        #          'di_casc2': di_casc2_list, 'di_casc': di_casc_list, 'di_list': di_list,
        #          'arv': arv_list, 'talh': talh_list, 'parc': parc_list, 'preco': preco_list,
        #          'conicidade': conic_tora_list, 'CRV': CRV_freq}

        if escolha != '6':
            data0 = {'codpeca': codpeca_list, 'peca': peca_list, 'es': es_list, 'l': l_div_list,
                     'n': n_div_list, 'v': v_list,'tora': ntora_list,'hi': hi_list, 'vr': vr_list
                     }

            data02 = {
                'di_casc2': di_casc2_list, 'di_casc': di_casc_list, 'di': di_list
            }

            data03 = {
                'arv': arv_list, 'talh': talh_list, 'parc': parc_list, 'preco': preco_list,
                'conicidade': conic_tora_list, 'CRV': CRV_freq}

            detalhado = data0
            detalhado.update(data02)
            detalhado.update(data03)
            dados_execucao['detalhado'] = detalhado

        # print('codpeca:{}'.format(len(codpeca_list)))
        # print('peca:{}'.format(len(peca_list)))
        # print('es:{}'.format(len(es_list)))
        # print('l:{}'.format(len(l_div_list)))
        # print('n:{}'.format(len(n_div_list)))
        # print('v:{}'.format(len(v_list)))
        # print('tora:{}'.format(len(ntora_list)))
        # print('vr:{}'.format(len(vr_list)))
        # print('di_casc2:{}'.format(len(di_casc2_list)))
        # print('di_casc:{}'.format(len(di_casc_list)))
        # print('di:{}'.format(len(di_list)))
        # print('arv:{}'.format(len(arv_list)))
        # print('talh:{}'.format(len(talh_list)))
        # print('parc:{}'.format(len(parc_list)))
        # print('preco:{}'.format(len(preco_list)))
        # print('conic_tora:{}'.format(len(conic_tora_list)))
        # print('CRV:{}'.format(len(CRV_freq)))

        df0 = pd.DataFrame(data0)
        df02 = pd.DataFrame(data02)
        df03 = pd.DataFrame(data03)

        print("-" * 70)
        print(df0.head(30))
        print("-" * 70)
        print(df02.head(30))
        print("-" * 70)
        print(df03.head(30))
        print("-" * 70)

        saida = df0.shape
        print(saida)
        print("-" * 70)

        # print(df0.head(20))

        # ---------------------------------------------------------------
        # RESULTADO SINTÉTICO

        vr = 0.0000
        n_pecas = 0
        preco = 0.0000
        n_arv = 0.0000
        vr_t = 0.0000
        v_t = 0.0000
        n_pecas_t = 0
        preco_t = 0.0000
        n_arv_t = 0.0000
        falha_t = 0

        falha_talh = 0
        arv_talh = 0

        falha_parc = 0
        arv_parc = 0

        i = 0
        j = 0

        esp_arv = brw_calcmadeira_calcula.espacamento_entre_arvore or 0.0
        esp_lin = brw_calcmadeira_calcula.espacamento_entre_linha or 0.0
        if not esp_arv:
            raise osv.except_osv(_('Atencao'),
                                 _('Espacamento entre arvores nao informado!'))
        if not esp_lin:
            raise osv.except_osv(_('Atencao'),
                                 _('Espacamento entre linhas nao informado!'))

        # FATOR TOTAL (ha)
        for i in range(0, len(arv_falha_list)):

            if arv_falha_list[i] == 1:
                falha_t = falha_t + 1
            else:
                n_arv_t = n_arv_t + 1

        fator_ha = 10000 / (esp_arv * esp_lin * (n_arv_t + falha_t))


        talh_unico = np.unique(talh_list)
        parc_unico = np.unique(parc_list)

        codpeca_peca = {}
        # converte listas codpeca e peca em um dictionary
        for i, j in zip(codpeca_list, peca_list):
            codpeca_peca[i] = j
        print(codpeca_peca)

        # extrai as chaves do dictionary
        codpeca_tmp = codpeca_peca.keys()
        codpeca_unico = list(codpeca_tmp)
        print(codpeca_unico)

        # extrai os valores do dictionary
        peca_tmp = codpeca_peca.values()
        peca_unico = list(peca_tmp)
        print(peca_unico)

        arv_parc_list_t = []
        falha_parc_list_t = []

        arv_talh_list_t = []
        falha_talh_list_t = []

        #xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        # FATOR TALHÃO (ha)
        for j in range(0, len(talh_unico)):

            for i in range(0, len(arv_falha_list)):

                if arv_falha_list[i] == 1 and arv_talh_list[i] == talh_unico[j]:
                    falha_talh = falha_talh + 1

                elif arv_falha_list[i] == 0 and arv_talh_list[i] == talh_unico[j]:
                    arv_talh = arv_talh + 1

            fator_talh_ha.append(10000 / (esp_arv * esp_lin * (arv_talh + falha_talh)))

            arv_talh_list_t.append(arv_talh)
            falha_talh_list_t.append(falha_talh)

            arv_talh = 0
            falha_talh = 0

        #xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        # FATOR PARCELA (ha)
        for j in range(0, len(talh_unico)):

            for k in range(0, len(parc_unico)):

                for i in range(0, len(arv_falha_list)):

                    if arv_falha_list[i] == 1 and arv_parc_list[i] == parc_unico[k] and arv_talh_list[i] == talh_unico[j]:
                        falha_parc = falha_parc + 1

                    elif arv_falha_list[i] == 0 and arv_parc_list[i] == parc_unico[k] and arv_talh_list[i] == talh_unico[j]:
                        arv_parc = arv_parc + 1

                if arv_parc == 0 and falha_parc == 0:
                    fator_parc_ha.append(0)
                else:
                    fator_parc_ha.append(10000 / (esp_arv * esp_lin * (arv_parc + falha_parc)))

                arv_parc_list_t.append(arv_parc)
                falha_parc_list_t.append(falha_parc)

                arv_parc = 0
                falha_parc = 0

        #xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        # VOLUME PARCELA (ha)

        vt_parc_list = []
        vt_parc = 0

        for j in range(0, len(talh_unico)):

            for k in range(0, len(parc_unico)):

                for i in range(0, len(arv_parc_list)):

                    if arv_parc_list[i] == parc_unico[k] and arv_talh_list[i] == talh_unico[j]:
                        vt_parc = vt_parc + vt_list[i]

                vt_parc_list.append(vt_parc)

                vt_parc = 0

        # xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        # VOLUME TALHAO (ha)

        vt_talh_list = []
        vt_talh = 0

        for j in range(0, len(talh_unico)):

            for i in range(0, len(arv_talh_list)):

                if arv_talh_list[i] == talh_unico[j]:
                    vt_talh = vt_talh + vt_list[i]

            vt_talh_list.append(vt_talh)

            vt_talh = 0

        # xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

        # Preço da Floresta (Para preço inverso: valor pago pela madeira utilizada, desconsidera resíduo)
        pf = brw_calcmadeira_calcula.valor_floresta or 0.0

        # xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        # "FREQUENCIA DE PEÇAS - RESULTADO POR TALHAO (ha)"

        talh_freq = []
        codpeca_freq = []
        peca_freq = []
        n_pecas_freq = []
        v_freq = []
        preco_freq = []
        crv_freq = []
        vr_v_freq = []

        i = 0
        y = 0

        for w in range(0, len(talh_unico)):

            for j in range(0, len(codpeca_unico)):

                while i < len(talh_list):

                    if codpeca_list[i] == codpeca_unico[j] and \
                            talh_list[i] == talh_unico[w]:

                        # vr = vr + vr_list[i]
                        n_pecas = n_pecas + n_div_list[i]
                        v = v + v_list[i]
                        preco = preco + preco_list[i]

                    i = i + 1

                i = 0

                talh_freq.append(talh_unico[w])
                codpeca_freq.append(codpeca_unico[j])
                peca_freq.append(peca_unico[j])
                v_freq.append(v * fator_talh_ha[y])
                n_pecas_freq.append(n_pecas * fator_talh_ha[y])
                preco_freq.append(preco * fator_talh_ha[y])

                # cod_tora = \
                vr = n_pecas = v = preco = 0

            y = y + 1

        data = {'talh_freq': talh_freq, 'codpeca_freq': codpeca_freq, 'peca_freq': peca_freq,
                'n_pecas_freq': n_pecas_freq, 'v_freq': v_freq, 'preco_freq': preco_freq}

        dados_execucao['sintetico']['frequencia_peca_talhao'] = data

        # 'ntora_freq': ntora_freq,'vr_freq':vr_freq,

        df = pd.DataFrame(data)
        print("-" * 70)
        print("FREQUENCIA DE PEÇAS - RESULTADO POR TALHAO (ha)")
        print(df)
        print("-" * 70)

        # xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        # "FREQUENCIA DE PEÇAS - RESULTADO POR PARCELA DENTRO DE TALHAO (ha)

        talh_freq = []
        parc_freq = []
        codpeca_freq = []
        peca_freq = []
        n_pecas_freq = []
        v_freq = []
        preco_freq = []

        i = 0
        y = 0

        for w in range(0, len(talh_unico)):

            for k in range(0, len(parc_unico)):

                for j in range(0, len(codpeca_unico)):

                    while i < len(parc_list):

                        if codpeca_list[i] == codpeca_unico[j] and parc_list[i] == parc_unico[k]and \
                                talh_list[i] == talh_unico[w]:

                            # cod_tora = ntora_list[i]
                            # vr = vr + vr_list[i]
                            n_pecas = n_pecas + n_div_list[i]
                            v = v + v_list[i]
                            preco = preco + preco_list[i]

                        i = i + 1

                    i = 0

                    talh_freq.append(talh_unico[w])
                    parc_freq.append(parc_unico[k])
                    codpeca_freq.append(codpeca_unico[j])
                    peca_freq.append(peca_unico[j])
                    n_pecas_freq.append(n_pecas * fator_parc_ha[y])
                    v_freq.append(v * fator_parc_ha[y])
                    preco_freq.append(preco * fator_parc_ha[y])

                    n_pecas = v = preco = 0

                y = y + 1

        data = {'talh_freq': talh_freq, 'parc_freq': parc_freq, 'codpeca_freq':codpeca_freq, 'peca': peca_freq,
                'n_pecas_freq': n_pecas_freq, 'v_freq': v_freq, 'preco_freq': preco_freq}

        dados_execucao['sintetico']['frequencia_peca_parcela_talhao'] = data

        # 'ntora_freq': ntora_freq, 'vr_freq':vr_freq,

        df = pd.DataFrame(data)
        print("-" * 70)
        print("FREQUENCIA DE PEÇAS - RESULTADO POR PARCELA DENTRO DE TALHAO (ha)")
        print(df)
        print("-" * 70)

        # xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        # RESULTADO TOTALIZADO POR PARCELA DENTRO DE TALHAO (ha)

        talh_freq = []
        parc_freq = []
        vr_freq = []
        v_freq = []
        n_pecas_freq = []
        preco_freq = []

        vt_freq = []
        preco_inv_freq = []
        preco_arv_freq = []
        preco_pecas_freq = []
        crv_freq = []
        vr_v_freq = []
        vt_vr_freq = []

        arv_parc_freq = []
        falha_parc_freq = []

        i = 0
        j = 0

        for w in range(0, len(talh_unico)):

            for k in range(0, len(parc_unico)):

                while i < len(parc_list):

                    if parc_list[i] == parc_unico[k] and \
                            talh_list[i] == talh_unico[w]:

                        v = v + v_list[i]
                        # correção 05/07/2023
                        n_pecas = n_pecas + n_div_list[i]
                        # n_pecas = n_pecas + 1
                        preco = preco + preco_list[i]

                        # ALTERAÇÃO 02/12/2023
                        if vr_list[i - 1] != str and vr_list[i - 1] != vr_list[i]:
                            vr = vr + vr_list[i]
                            print('vr=', vr)

                        # if i < len(parc_list) - 1 and ntora_list[i] != ntora_list[i + 1] \
                        #         or i == len(parc_list) - 1 and ntora_list[i - 1] != ntora_list[i]:
                        #     vr = vr + vr_list[i]

                    i = i + 1

                i = 0

                talh_freq.append(talh_unico[w])
                parc_freq.append(parc_unico[k])
                vr_freq.append(vr * fator_parc_ha[j])
                v_freq.append(v * fator_parc_ha[j])
                n_pecas_freq.append(n_pecas * fator_parc_ha[j])
                preco_freq.append(preco * fator_parc_ha[j])
                vt_freq.append(vt_parc_list[j] * fator_parc_ha[j])

                if vr > 0:
                    preco_inv_freq.append((pf * vt_parc_list[j])/v)
                    preco_arv_freq.append(preco / vt_parc_list[j])
                    preco_pecas_freq.append(preco / v)
                    crv_freq.append(v / vr)
                else:
                    preco_inv_freq.append(0)
                    preco_arv_freq.append(0)
                    preco_pecas_freq.append(0)
                    crv_freq.append(0)

                vr_v_freq.append((vr-v) * fator_parc_ha[j])
                vt_vr_freq.append((vt_parc_list[j] - vr) * fator_parc_ha[j])

                vr = v = vr_nr = v_nr = n_pecas = preco = 0

                arv_parc_freq.append(arv_parc_list_t[j] * fator_parc_ha[j])
                falha_parc_freq.append(falha_parc_list_t[j] * fator_parc_ha[j])

                j = j + 1

        # print('talh:{}'.format(len(talh_freq)))
        # print('parc:{}'.format(len(parc_freq)))
        # print('vr:{}'.format(len(vr_freq)))
        # print('v:{}'.format(len(v_freq)))
        # print('vr_nr:{}'.format(len(vr_nr_freq)))
        # print('v_nr:{}'.format(len(v_nr_freq)))
        # print('npecas:{}'.format(len(n_pecas_freq)))
        # print('npecas_nr:{}'.format(len(n_pecas_nr_freq)))
        # print('preco:{}'.format(len(preco_freq)))
        # print('vt:{}'.format(len(vt_freq)))
        # print('preco_inv:{}'.format(len(preco_inv_freq)))
        # print('preco_arv:{}'.format(len(preco_arv_freq)))
        # print('preco_pecas:{}'.format(len(preco_pecas_freq)))
        # print('crv:{}'.format(len(crv_freq)))
        # print('vr_v:{}'.format(len(vr_v_freq)))
        # print('vt_vr:{}'.format(len(vt_vr_freq)))


        # data = {'talh': talh_freq,'parc': parc_freq, 'arv': arv_parc_list_t, 'falha': falha_parc_list_t,
        #         'vr': vr_freq, 'v': v_freq, 'vr_nr': vr_nr_freq, 'v_nr': v_nr_freq,
        #         'n_pecas': n_pecas_freq, 'n_pecas_nr': n_pecas_nr_freq, 'preco_freq': preco_freq,
        #         'vt': vt_freq, 'preco_inv': preco_inv_freq, 'preco_arv': preco_arv_freq, 'preco_pecas': preco_pecas_freq,
        #         'crv': crv_freq, 'vr_v': vr_v_freq, 'vt_vr': vt_vr_freq}


        data = {'talh': talh_freq,'parc': parc_freq,
                'arv': arv_parc_freq, 'falha': falha_parc_freq,
                'vr': vr_freq, 'v': v_freq
                }

        data2 = {
            'n_pecas': n_pecas_freq, 'preco_freq': preco_freq,
            'vt': vt_freq, 'preco_inv': preco_inv_freq, 'preco_arv': preco_arv_freq, 'preco_pecas': preco_pecas_freq
        }

        data3 = {
            'crv': crv_freq, 'vr_v': vr_v_freq, 'vt_vr': vt_vr_freq}

        parcela_talhao_ha = data
        parcela_talhao_ha.update(data2)
        parcela_talhao_ha.update(data3)
        dados_execucao['sintetico']['resultado_parcela_talhao'] = parcela_talhao_ha

        df = pd.DataFrame(data)
        df2 = pd.DataFrame(data2)
        df3 = pd.DataFrame(data3)

        print("-" * 70)
        print("RESULTADO TOTALIZADO POR PARCELA DENTRO DE TALHAO (ha)")
        print(df)
        print("-" * 70)
        print(df2)
        print("-" * 70)
        print(df3)
        print("-" * 70)

        # xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        # "RESULTADO TOTALIZADO POR TALHAO (ha)"

        talh_freq = []
        vr_freq = []
        v_freq = []
        n_pecas_freq = []
        preco_freq = []

        vt_freq = []
        preco_inv_freq = []
        preco_arv_freq = []
        preco_pecas_freq = []
        crv_freq = []
        vr_v_freq = []
        vt_vr_freq = []

        arv_talh_freq = []
        falha_talh_freq = []

        i = 0
        j = 0

        for w in range(0, len(talh_unico)):

            while i < len(talh_list):

                if talh_list[i] == talh_unico[w]:

                    # vr = vr + vr_list[i]
                    v = v + v_list[i]
                    # correção 05/07/2023
                    n_pecas = n_pecas + n_div_list[i]
                    # n_pecas = n_pecas + 1
                    preco = preco + preco_list[i]

                    # ALTERAÇÃO 02/12/2023
                    if vr_list[i - 1] != str and vr_list[i - 1] != vr_list[i]:
                        vr = vr + vr_list[i]
                        print('vr=', vr)
                    # if i < len(talh_list) - 1 and ntora_list[i] != ntora_list[i + 1] \
                    #         or i == len(talh_list) - 1 and ntora_list[i - 1] != ntora_list[i]:
                    #     vr = vr + vr_list[i]

                i = i + 1

            i = 0

            talh_freq.append(talh_unico[w])
            vr_freq.append(vr * fator_talh_ha[j])
            v_freq.append(v * fator_talh_ha[j])
            n_pecas_freq.append(n_pecas * fator_talh_ha[j])
            preco_freq.append(preco * fator_talh_ha[j])
            vt_freq.append(vt_talh_list[j] * fator_talh_ha[j])

            if vr > 0:
                preco_inv_freq.append((pf * vt_talh_list[j]) / v)
                preco_arv_freq.append(preco / vt_talh_list[j])
                preco_pecas_freq.append(preco / v)
                crv_freq.append(v / vr)
            else:
                preco_inv_freq.append(0)
                preco_arv_freq.append(0)
                preco_pecas_freq.append(0)
                crv_freq.append(0)

            vr_v_freq.append((vr - v) * fator_talh_ha[j])
            vt_vr_freq.append((vt_talh_list[j] - vr) * fator_talh_ha[j])

            vr = v = n_pecas = preco = 0

            arv_talh_freq.append(arv_talh_list_t[j] * fator_talh_ha[j])
            falha_talh_freq.append(falha_talh_list_t[j] * fator_talh_ha[j])

            j = j + 1

        # print('talh:{}'.format(len(talh_freq)))
        # print('vr:{}'.format(len(vr_freq)))
        # print('v:{}'.format(len(v_freq)))
        # print('npecas:{}'.format(len(n_pecas_freq)))
        # print('preco:{}'.format(len(preco_freq)))
        # print('vt:{}'.format(len(vt_freq)))
        # print('preco_inv:{}'.format(len(preco_inv_freq)))
        # print('preco_arv:{}'.format(len(preco_arv_freq)))
        # print('preco_pecas:{}'.format(len(preco_pecas_freq)))
        # print('crv:{}'.format(len(crv_freq)))
        # print('vr_v:{}'.format(len(vr_v_freq)))
        # print('vt_vr:{}'.format(len(vt_vr_freq)))

        # data = {'talh': talh_freq,'arv': arv_parc_list_t, 'falha': falha_parc_list_t,
        #         'vr': vr_freq, 'v': v_freq, 'vr_nr': vr_nr_freq, 'v_nr': v_nr_freq,
        #         'n_pecas': n_pecas_freq, 'n_pecas_nr': n_pecas_nr_freq, 'preco_freq': preco_freq,
        #         'vt': vt_freq, 'preco_inv': preco_inv_freq, 'preco_arv': preco_arv_freq, 'preco_pecas': preco_pecas_freq,
        #         'crv': crv_freq, 'vr_v': vr_v_freq, 'vt_vr': vt_vr_freq}


        data = {'talh': talh_freq, 'arv': arv_talh_freq, 'falha': falha_talh_freq,
                'vr': vr_freq, 'v': v_freq
                }

        data2 = {
            'n_pecas': n_pecas_freq, 'preco_freq': preco_freq,
            'vt': vt_freq, 'preco_inv': preco_inv_freq, 'preco_arv': preco_arv_freq, 'preco_pecas': preco_pecas_freq
        }

        data3 = {
            'crv': crv_freq, 'vr_v': vr_v_freq, 'vt_vr': vt_vr_freq}

        talhao_ha = data
        talhao_ha.update(data2)
        talhao_ha.update(data3)
        dados_execucao['sintetico']['resultado_talhao'] = talhao_ha

        df = pd.DataFrame(data)
        df2 = pd.DataFrame(data2)
        df3 = pd.DataFrame(data3)

        print("-" * 70)
        print("RESULTADO TOTALIZADO POR TALHAO (ha)")
        print(df)
        print("-" * 70)
        print(df2)
        print("-" * 70)
        print(df3)
        print("-" * 70)
        # xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

        return dados_execucao
