# -*- coding: utf-8 -*-

from openerp.osv import osv, fields
import pandas as pd

pd.set_option('display.max_columns', 10)
from funcoes import SelecionaPeca
from openerp.tools.translate import _
import numpy as np

# ------------------------------------------------------------------
# CalculaPecas

# Dap - diametro a altura do peito
# ht - altura total da árvore
# hc - altura comercial da árvore
# hi - comprimento da tora = comprimento da peça
# hi_atual - começa com altura do toco (30 cm)
# di_casc - diâmetro com casca
# di_casc2 - diâmetro com casca para calculo do volume da peça
# di- diâmetro sem casca
# vr - volume tora ou peça roliça
# vt - volume arvore
# cod_tora - numero de toras
# narv - numero de árvores da amostra
# codpeca-codigo peça


class wizard_calcula_pecas_rolicas(osv.TransientModel):
    _name = 'wizard.calcula.pecas.rolicas'
    _description = 'CalculaPecasRolicas'

    _columns = {
        'calcmadeira_calcula_id': fields.many2one('wizard.calcmadeira.calcula', 'Calculo',
                                                  required=True)
    }

    def executa(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        dados_execucao = {'detalhado': {}, 'sintetico': {}}
        brw_calcmadeira_calcula = self.browse(
            cr, uid, ids[0] if isinstance(ids, (list, tuple)) else ids, context). \
            calcmadeira_calcula_id
        tipo_funcao = brw_calcmadeira_calcula.tipo_funcao
        obj_calcmadeira_parametro = self.pool.get('calcmadeira.parametro')
        calcmadeira_parametro_id = obj_calcmadeira_parametro.search(cr, uid, [], context=context)
        parametro_dados = obj_calcmadeira_parametro.read(cr, uid, calcmadeira_parametro_id[0], [],
                                                         context, '_classic_write')
        cmapar_es_medula = 0
        if parametro_dados.get('cmapar_espessura_peca_central') > parametro_dados.get(
                'cmapar_es_serra'):
            cmapar_es_medula = (parametro_dados.get('cmapar_espessura_peca_central') or 0) + (
                    parametro_dados.get('cmapar_es_serra') or 0)
        parametro_dados.update({'es_medula': cmapar_es_medula})
        obj_pecas_rolicas = self.pool.get('calcmadeira.pecas.rolicas')
        pecas_rolicas_ids = obj_pecas_rolicas.search(cr, uid, [], context=context)
        pecas_rolicas_dados = obj_pecas_rolicas.read(
            cr, uid, pecas_rolicas_ids, ['cmapro_comprimento_tora', 'cmapro_diametro_min'],
            context=context)
        hi_min = min(map(lambda x: x.get('cmapro_comprimento_tora'), pecas_rolicas_dados))
        di_min = min(map(lambda x: x.get('cmapro_diametro_min'), pecas_rolicas_dados))

        escolhaEqVol = ''
        escolhaEqForma = ''

        # -----------------------------------------------------------------
        print('Calculador de Madeira Roliça')

        # Lê arquivo de árvores
        # -----------------------
        obj_calcmadeira_arvore = self.pool.get('calcmadeira.arvores')
        calcmadeira_arvore_ids = obj_calcmadeira_arvore.search(
            cr, uid, [] + brw_calcmadeira_calcula.calcmadeira_trata_talhao_peca(),
            context=context)
        calcmadeira_arvore_dados = obj_calcmadeira_arvore.read(
            cr, uid, calcmadeira_arvore_ids, [], context)
        linarv, narv = calcmadeira_arvore_dados, len(calcmadeira_arvore_dados)
        # -----------------------

        codpeca = 0
        peca = 0 # nome da peça
        es = 0 # variável da madeira serrada (declarada pc modulo serrada + rolica)
        l_div = 0 # variável da madeira serrada (declarada pc modulo serrada + rolica)
        n_div = 1 # variável da madeira serrada (declarada pc modulo serrada + rolica)
        v = 0.0000 # volume da peça (dimensões padronizadas)
        di_casc = di_casc2 = 0
        # ntora = 0 # numero de toras por árvore
        cod_tora = 0 # codigo da tora
        cod_arv = 0 # codigo da árvore no inventário
        parc = 0 # numero de parcelas
        vt = 0.0000 # volume da árvore
        arv = 1 # numero de árvores (começa com a 1a)
        falha = 0 # numero de falhas
        preco = 0.0000 # preço da tora
        conic_tora = 0.0000 # conicidade da tora


        # Para acumulo de peças do Relatorio Detalhado
        codpeca_list = []
        peca_list = []
        es_list = []
        l_div_list = []
        n_div_list = []
        v_list = []
        di_min_list = []
        di_max_list = []
        hi_list = []
        vr_list = []
        vt_list = []
        di_casc2_list = []
        di_casc_list = []
        di_list = []
        ntora_list = []

        cod_arv_list = []
        arv_list = []
        talh_list = []
        parc_list = []

        arv_parc_list = []
        arv_talh_list = []
        arv_falha_list = []

        fator_talh_ha = []
        fator_parc_ha = []

        preco_list = []
        conic_tora_list = []
        # Alteração 01/08/2023
        CRV_list = []

        # ----------------------
        lista_de_pecas = [0]
        for p in brw_calcmadeira_calcula.pecas_rolicas:
            lista_de_pecas.append([
                p.cmapro_codigo_peca,  # int(pecas[0])
                p.name,  # str(pecas[1])
                p.cmapro_diametro_min,  # int(pecas[2])
                p.cmapro_diametro_max,  # int(pecas[3])
                p.cmapro_comprimento_tora,  # int(pecas[4])
                p.cmapro_sequence,
                p.cmapro_preco
            ])
        linpeca = lista_de_pecas
        # ----------------------

        # declarando variáveis, não necessário no VBA
        di = 100

        # -------------------------------------------
        es_serra = parametro_dados.get('cmapar_es_serra')
        hi_atual = parametro_dados.get('cmapar_altura_corte')
        # 08/09/2023
        # hi = parametro_dados.get('cmapar_altura')
        hi = hi_min
        #
        prop_casc = parametro_dados.get('cmapar_prop_casc')
        l_min_pecas = 0
        es_min_pecas = 0
        es_perim = parametro_dados.get('cmapar_laminacao_espessura')
        flecha_div_r = parametro_dados.get('cmapar_proporcao_raio_corte_peca')
        es_medula = parametro_dados.get('es_medula')
        # -------------------------------------------

        # if escolhaEqForma == '':
        #    print('0 para equação de forma interna\n'
        #          '1 para equação de forma do usuário\n')
        #
        #    escolhaEqForma = str(input())
        #
        # if escolhaEqForma == '0':
        #    B0f = B1f = B2f = 0
        #
        # if escolhaEqForma == '1':
        #    # --------------------------------------
        #    B0f, B1f, B2f = SubRotinas.Forma()
        #    # --------------------------------------
        #
        ##---------------------------------
        # FFormaEqFormaCubagem.cubagemtxt()
        # #---------------------------------
        #
        # if escolhaEqVol == '':
        #    print('0 para equação de volume interna\n'
        #          '1 para equação de volume do usuário\n')
        #
        #    escolhaEqVol = str(input())
        #
        # if escolhaEqVol == '0':
        #    B0v = B1v = B2v = 0
        #
        # if escolhaEqVol == '1':
        #    # --------------------------------------
        #    B0v, B1v, B2v = SubRotinas.Volume()
        #    # --------------------------------------

        # Executa por árvore
        while arv <= narv:
            vr = 0.0000

            # Acessa arquivo texto, armazena dap e ht por árvore, e calcula seu volume (vt)
            dados = linarv[arv-1]

            talh = float(dados.get('cmaarv_talhao'))
            parc = int(dados.get('cmaarv_linha'))
            cod_arv = dados.get('cmaarv_arvore')
            dap = float(dados.get('cmaarv_diametro'))
            ht = float(dados.get('cmaarv_altura'))
            hc = float(dados.get('cmaarv_altura_comecial'))

            if hc > 0 and hc != "" and dap > 0 and ht > 0:

                vt = self.pool.get('wizard.calcmadeira.calcula').calcmadeira_get_equacao_volume(
                    cr, uid, brw_calcmadeira_calcula.coeficiente_volume_id, dap, ht, hc, context)

            # Lista vt
            vt_list.append(vt)
            vt = 0

            # lista de árvores pelo cod_arv
            cod_arv_list.append(cod_arv)

            # Lista falhas
            arv_parc_list.append(parc)
            arv_talh_list.append(talh)

            if dap == 0 or dap == "" or ht == 0 or ht == "":
                arv_falha_list.append(1)
            else:
                arv_falha_list.append(0)

            # numero da tora
            cod_tora = 0

            es_sobra = 100

            # Calcula peças por seção do tronco até completar altura da árvore
            while hi_atual + hi <= hc:

                di_casc, di_casc2, di_casc_deriv, di_casc2_deriv = self.pool.get('wizard.calcmadeira.calcula'). \
                    calcmadeira_get_equacao_forma(cr, uid,
                                                  coeficiente_forma=brw_calcmadeira_calcula.coeficiente_forma_id,
                                                  hi_atual=hi_atual,
                                                  hi=hi,
                                                  ht=ht,
                                                  dap=dap,
                                                  di_casc=di_casc,
                                                  di_casc2=di_casc2,
                                                  context=context)

                # ALTERAÇÃO 03/12/2023 Se derivada positiva, diametro começa a aumentar
                # Solução: utilizar a taxa com sinal negativo e deduzir do di_casc2
                if di_casc2_deriv <= 0:
                    di = di_casc2 * (1 - prop_casc)
                else:
                    di = (di_casc2 - di_casc2_deriv) * (1 - prop_casc)

                cod_tora = cod_tora + 1

                if di < di_min or hi_atual + hi_min > hc:
                    cod_tora = cod_tora - 1
                    break

                # ----------------------------------------------------------------------------------
                # SelecionaPeca
                hi, cod_tora, \
                codpeca_list, peca_list, es_list, l_div_list, n_div_list, di_min_list, di_max_list, hi_list, vr_list, \
                di_casc2_list, di_casc_list, di_list, ntora_list, arv_list, talh_list, parc_list, preco_list, \
                v_list, conic_tora_list, CRV_list \
                    = SelecionaPeca(dap, ht, hc,hi_atual, hi_min, di_casc, di_casc2, di,
                                               prop_casc, cod_tora, arv, cod_arv, talh, parc, linpeca,
                                               escolhaEqForma, brw_calcmadeira_calcula.coeficiente_forma_id.cmacoe_b0 or 0,
                                               brw_calcmadeira_calcula.coeficiente_forma_id.cmacoe_b1 or 0,
                                               brw_calcmadeira_calcula.coeficiente_forma_id.cmacoe_b2 or 0, conic_tora,
                                               codpeca_list, peca_list, es_list, l_div_list, n_div_list, di_min_list, di_max_list, hi_list,
                                               vr_list, di_casc2_list, di_casc_list, di_list, ntora_list,
                                               arv_list, talh_list, parc_list, preco_list,
                                               v_list, conic_tora_list, CRV_list)
                # ----------------------------------------------------------------------------------

                # atualiza hi_atual com o comprimento da tora calculada (hi)
                hi_atual = hi_atual + hi

                hi = hi_min

                # print('hi_atual=', hi_atual)
            # loop while da arv
            arv = arv + 1

            # retorna altura do toco
            # Precisa pegar valor definido pelo usuario não é fixo
            # -------------------------------------------
            hi_atual = parametro_dados.get('cmapar_altura_corte')
            # -------------------------------------------

        # # CRV (v/vr)
        # # CRV_freq = []
        # i = 0
        # i2 = 0
        # k = 0
        # v = 0
        #
        # arv_unico = np.unique(arv_list)
        # ntora_unico = np.unique(ntora_list)
        #
        # for k in range(0, len(arv_unico)):
        #
        #     for j in range(0, len(ntora_unico)):
        #
        #         while i < len(ntora_list) and \
        #                 ntora_list[i] == ntora_unico[j] and arv_list[i] == arv_unico[k]:
        #
        #             v = v + v_list[i]
        #
        #             i = i + 1
        #
        #         while i2 < len(ntora_list) and \
        #                 ntora_list[i2] == ntora_unico[j] and arv_list[i2] == arv_unico[k]:
        #             CRV_freq.append(v / vr_list[i2])
        #             i2 = i2 + 1
        #         i2 = i
        #         v = 0
        #
        # ----------------------------------------------------------------------------
        # RESULTADO DETALHADO

        print('')
        print('RESULTADO DETALHADO ROLIÇA')
        print('-'*70)

        # data0 = {'codpeca': codpeca_list, 'peca': peca_list, 'di_min_list': di_min_list, 'di_max_list': di_max_list, 'hi_list': hi_list,
        #          'vr': vr_list, 'v_list': v_list, 'di_casc2': di_casc2_list, 'di_casc': di_casc_list, 'di_list': di_list,
        #          'tora': ntora_list, 'arv': arv_list, 'talh': talh_list, 'parc': parc_list,  'preco': preco_list,
        #          'conicidade': conic_tora_list, 'rend': CRV_freq}

        data0 = {'codpeca': codpeca_list, 'peca': peca_list, 'di_min': di_min_list, 'di_max': di_max_list, 'hi': hi_list,
                 }

        data02 = {
            'vr': vr_list, 'v': v_list, 'di_casc2': di_casc2_list, 'di_casc': di_casc_list, 'di': di_list,
        }

        data03 = {
            'tora': ntora_list, 'arv': arv_list, 'talh': talh_list, 'parc': parc_list,  'preco': preco_list,
            'conicidade': conic_tora_list, 'rend': CRV_list} # Alteração 01/08/2023

        detalhado = data0
        detalhado.update(data02)
        detalhado.update(data03)
        dados_execucao['detalhado'] = detalhado

        print('codpeca:{}'.format(len(codpeca_list)))
        print('peca:{}'.format(len(peca_list)))
        print('di_min:{}'.format(len(di_min_list)))
        print('di_max:{}'.format(len(di_max_list)))
        print('hi:{}'.format(len(hi_list)))
        print('vr:{}'.format(len(vr_list)))
        print('v:{}'.format(len(v_list)))
        print('di_casc2:{}'.format(len(di_casc2_list)))
        print('di_casc:{}'.format(len(di_casc_list)))
        print('di:{}'.format(len(di_list)))
        print('tora:{}'.format(len(ntora_list)))
        print('arv:{}'.format(len(arv_list)))
        print('talh:{}'.format(len(talh_list)))
        print('parc:{}'.format(len(parc_list)))
        print('preco:{}'.format(len(preco_list)))
        print('conic_tora:{}'.format(len(conic_tora_list)))
        print('rend_ptora:{}'.format(len(CRV_list)))  # Alteração 01/08/2023

        df0 = pd.DataFrame(data0)
        df02 = pd.DataFrame(data02)
        df03 = pd.DataFrame(data03)

        print("-" * 70)
        print(df0.head(30))
        print("-" * 70)
        print(df02.head(30))
        print("-" * 70)
        print(df03.head(30))
        print("-" * 70)

        saida = df0.shape
        print(saida)
        print("-" * 70)

        # ---------------------------------------------------------------
        # RESULTADO SINTÉTICO

        vr_nr = 0.0000
        v_nr = 0.0000
        n_pecas_nr = 0
        vr = 0.0000
        v = 0.0000
        n_pecas = 0
        preco = 0.0000
        n_arv = 0.0000

        vr_nr_t = 0.0000
        v_nr_t = 0.0000
        n_pecas_nr_t = 0
        vr_t = 0.0000
        v_t = 0.0000
        n_pecas_t = 0
        preco_t = 0.0000
        n_arv_t = 0.0000
        falha_t = 0

        falha_talh = 0
        arv_talh = 0

        falha_parc = 0
        arv_parc = 0

        i = 0
        j = 0

        esp_arv = brw_calcmadeira_calcula.espacamento_entre_arvore or 0.0
        esp_lin = brw_calcmadeira_calcula.espacamento_entre_linha or 0.0

        # FATOR TOTAL (ha)
        for i in range(0, len(arv_falha_list)):

            if arv_falha_list[i] == 1:
                falha_t = falha_t + 1
            else:
                n_arv_t = n_arv_t + 1

        if not esp_arv:
            raise osv.except_osv(_('Atencao'),
                                 _('Espacamento entre arvores nao informado!'))
        if not esp_lin:
            raise osv.except_osv(_('Atencao'),
                                 _('Espacamento entre linhas nao informado!'))
        fator_ha = 10000 / (esp_arv * esp_lin * (n_arv_t + falha_t))

        talh_unico = np.unique(talh_list)
        parc_unico = np.unique(parc_list)

        codpeca_peca = {}
        for i, j in zip(codpeca_list, peca_list):
            codpeca_peca[i] = j

        codpeca_tmp = codpeca_peca.keys()
        codpeca_unico = list(codpeca_tmp)
        print(codpeca_unico)

        peca_tmp = codpeca_peca.values()
        peca_unico = list(peca_tmp)
        print(peca_unico)

        arv_parc_list_t = []
        falha_parc_list_t = []

        arv_talh_list_t = []
        falha_talh_list_t = []

        #xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        # FATOR TALHÃO (ha)
        for j in range(0, len(talh_unico)):

            for i in range(0, len(arv_falha_list)):

                if arv_falha_list[i] == 1 and arv_talh_list[i] == talh_unico[j]:
                    falha_talh = falha_talh + 1

                elif arv_falha_list[i] == 0 and arv_talh_list[i] == talh_unico[j]:
                    arv_talh = arv_talh + 1

            fator_talh_ha.append(10000 / (esp_arv * esp_lin * (arv_talh + falha_talh)))

            arv_talh_list_t.append(arv_talh)
            falha_talh_list_t.append(falha_talh)

            arv_talh = 0
            falha_talh = 0

        #xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        # FATOR PARCELA (ha)
        for j in range(0, len(talh_unico)):

            for k in range(0, len(parc_unico)):

                for i in range(0, len(arv_falha_list)):

                    if arv_falha_list[i] == 1 and arv_parc_list[i] == parc_unico[k] and arv_talh_list[i] == talh_unico[j]:
                        falha_parc = falha_parc + 1

                    elif arv_falha_list[i] == 0 and arv_parc_list[i] == parc_unico[k] and arv_talh_list[i] == talh_unico[j]:
                        arv_parc = arv_parc + 1

                if arv_parc == 0 and falha_parc == 0:
                    fator_parc_ha.append(0)
                else:
                    fator_parc_ha.append(10000 / (esp_arv * esp_lin * (arv_parc + falha_parc)))

                arv_parc_list_t.append(arv_parc)
                falha_parc_list_t.append(falha_parc)

                arv_parc = 0
                falha_parc = 0

        #xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        # VOLUME PARCELA (ha)

        vt_parc_list = []
        vt_parc = 0

        for j in range(0, len(talh_unico)):

            for k in range(0, len(parc_unico)):

                for i in range(0, len(arv_parc_list)):

                    if arv_parc_list[i] == parc_unico[k] and arv_talh_list[i] == talh_unico[j]:
                        vt_parc = vt_parc + vt_list[i]

                # if vt_parc > 0:
                vt_parc_list.append(vt_parc)

                vt_parc = 0

        # xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        # VOLUME TALHAO (ha)

        vt_talh_list = []
        vt_talh = 0

        for j in range(0, len(talh_unico)):

            for i in range(0, len(arv_talh_list)):

                if arv_talh_list[i] == talh_unico[j]:
                    vt_talh = vt_talh + vt_list[i]

            vt_talh_list.append(vt_talh)

            vt_talh = 0

        # xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

        # Preço da Floresta (Para preço inverso: valor pago pela madeira utilizada, desconsidera resíduo)
        pf = brw_calcmadeira_calcula.valor_floresta or 0.0

        # xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        # "FREQUENCIA DE PEÇAS - RESULTADO POR TALHAO (ha)"

        talh_freq = []
        codpeca_freq = []
        peca_freq = []
        vr_freq = []
        v_freq = []
        n_pecas_freq = []
        preco_freq = []
        crv_freq = []
        vr_v_freq = []

        i = 0
        y = 0

        for w in range(0, len(talh_unico)):

            for j in range(0, len(codpeca_unico)):

                while i < len(talh_list):

                    if codpeca_list[i] == codpeca_unico[j] and \
                            talh_list[i] == talh_unico[w]:

                        vr = vr + vr_list[i]
                        v = v + v_list[i]
                        n_pecas = n_pecas + 1
                        preco = preco + preco_list[i]

                    i = i + 1

                i = 0

                talh_freq.append(talh_unico[w])
                codpeca_freq.append(codpeca_unico[j])
                peca_freq.append(peca_unico[j])
                vr_freq.append(vr * fator_talh_ha[y])
                v_freq.append(v * fator_talh_ha[y])
                n_pecas_freq.append(n_pecas * fator_talh_ha[y])
                preco_freq.append(preco * fator_talh_ha[y])

                ## ALTERAção 17/08/2023
                # if vr > 0:
                #     crv_freq.append(v / vr)
                # else:
                #     crv_freq.append(0)
                crv_freq.append(0)
                # vr_v_freq.append((vr - v) * fator_talh_ha[y])
                vr_v_freq.append(0)
                ##

                vr = v = n_pecas = preco = 0

            y = y + 1

        data = {'talh_freq': talh_freq, 'codpeca_freq':codpeca_freq, 'peca_freq': peca_freq,
                'v_freq':vr_freq,
                'n_pecas_freq': n_pecas_freq, 'preco_freq': preco_freq, 'crv': crv_freq, 'vr_v': vr_v_freq}

        dados_execucao['sintetico']['frequencia_peca_talhao'] = data

        df = pd.DataFrame(data)
        print("-" * 70)
        print("FREQUENCIA DE PEÇAS - RESULTADO POR TALHAO (ha)")
        print(df)
        print("-" * 70)

        # xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        # "FREQUENCIA DE PEÇAS - RESULTADO POR PARCELA DENTRO DE TALHAO (ha)

        talh_freq = []
        parc_freq = []
        codpeca_freq = []
        peca_freq = []
        vr_freq = []
        v_freq = []
        n_pecas_freq = []
        preco_freq = []
        crv_freq = []
        vr_v_freq = []

        i = 0
        y = 0

        for w in range(0, len(talh_unico)):

            for k in range(0, len(parc_unico)):

                for j in range(0, len(codpeca_unico)):

                    while i < len(parc_list):

                        if codpeca_list[i] == codpeca_unico[j] and parc_list[i] == parc_unico[k] and \
                                talh_list[i] == talh_unico[w]:

                            vr = vr + vr_list[i]
                            v = v + v_list[i]
                            n_pecas = n_pecas + 1
                            preco = preco + preco_list[i]

                        i = i + 1

                    i = 0

                    talh_freq.append(talh_unico[w])
                    parc_freq.append(parc_unico[k])
                    codpeca_freq.append(codpeca_unico[j])
                    peca_freq.append(peca_unico[j])
                    vr_freq.append(vr * fator_parc_ha[y])
                    v_freq.append(v * fator_parc_ha[y])
                    n_pecas_freq.append(n_pecas * fator_parc_ha[y])
                    preco_freq.append(preco * fator_parc_ha[y])

                    ## ALTERAção 17/08/2023
                    # if vr > 0:
                    #     crv_freq.append(v / vr)
                    # else:
                    #     crv_freq.append(0)
                    #
                    # vr_v_freq.append((vr - v) * fator_parc_ha[y])
                    crv_freq.append(0)
                    vr_v_freq.append(0)
                    ##
                    vr = v = n_pecas = preco = 0

                y = y + 1

        data = {'talh_freq': talh_freq,'parc_freq': parc_freq, 'codpeca_freq':codpeca_freq, 'peca': peca_freq,
                'v_freq':vr_freq,
                'n_pecas_freq': n_pecas_freq, 'preco_freq': preco_freq, 'crv': crv_freq, 'vr_v': vr_v_freq}

        dados_execucao['sintetico']['frequencia_peca_parcela_talhao'] = data

        df = pd.DataFrame(data)
        print("-" * 70)
        print("FREQUENCIA DE PEÇAS - RESULTADO POR PARCELA DENTRO DE TALHAO (ha)")
        print(df)
        print("-" * 70)

        # xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        # "RESULTADO TOTALIZADO POR PARCELA DENTRO DE TALHAO (ha)"

        talh_freq = []
        parc_freq = []
        vr_freq = []
        v_freq = []
        vr_nr_freq = []
        v_nr_freq = []
        n_pecas_freq = []
        n_pecas_nr_freq = []
        preco_freq = []

        vt_freq = []
        preco_inv_freq = []
        preco_arv_freq = []
        preco_pecas_freq = []
        crv_freq = []
        vr_v_freq = []
        vt_vr_freq = []

        i = 0
        j = 0

        for w in range(0, len(talh_unico)):

            for k in range(0, len(parc_unico)):

                while i < len(parc_list):

                    if parc_list[i] == parc_unico[k] and \
                            talh_list[i] == talh_unico[w]:

                        if peca_list[i] == 'NaoRolica':
                            vr_nr = vr_nr + vr_list[i]
                            v_nr = v_nr + v_list[i]
                            n_pecas_nr = n_pecas_nr + 1
                        else:
                            vr = vr + vr_list[i]
                            v = v + v_list[i]
                            n_pecas = n_pecas + 1
                            preco = preco + preco_list[i]

                    i = i + 1

                i = 0

                talh_freq.append(talh_unico[w])
                parc_freq.append(parc_unico[k])
                vr_freq.append(vr * fator_parc_ha[j])
                v_freq.append(v * fator_parc_ha[j])
                vr_nr_freq.append(vr_nr * fator_parc_ha[j])
                v_nr_freq.append(v_nr * fator_parc_ha[j])
                n_pecas_freq.append(n_pecas * fator_parc_ha[j])
                n_pecas_nr_freq.append(n_pecas_nr * fator_parc_ha[j])
                preco_freq.append(preco * fator_parc_ha[j])
                vt_freq.append(vt_parc_list[j] * fator_parc_ha[j])

                if vr > 0:
                    preco_inv_freq.append((pf * vt_parc_list[j])/vr)
                    preco_arv_freq.append(preco / vt_parc_list[j])
                    preco_pecas_freq.append(preco / vr)
                    # crv_freq.append(v / vr)
                else:
                    preco_inv_freq.append(0)
                    preco_arv_freq.append(0)
                    preco_pecas_freq.append(0)
                    # crv_freq.append(0)
                crv_freq.append(0)
                vr_v_freq.append(0)
                # vr_v_freq.append((vr-v) * fator_parc_ha[j])
                vt_vr_freq.append((vt_parc_list[j] - vr) * fator_parc_ha[j])

                vr = v = vr_nr = v_nr = n_pecas = n_pecas_nr = preco = 0
                j = j + 1

        # print('talh:{}'.format(len(talh_freq)))
        # print('parc:{}'.format(len(parc_freq)))
        # print('vr:{}'.format(len(vr_freq)))
        # print('v:{}'.format(len(v_freq)))
        # print('vr_nr:{}'.format(len(vr_nr_freq)))
        # print('v_nr:{}'.format(len(v_nr_freq)))
        # print('npecas:{}'.format(len(n_pecas_freq)))
        # print('npecas_nr:{}'.format(len(n_pecas_nr_freq)))
        # print('preco:{}'.format(len(preco_freq)))
        # print('vt:{}'.format(len(vt_freq)))
        # print('preco_inv:{}'.format(len(preco_inv_freq)))
        # print('preco_arv:{}'.format(len(preco_arv_freq)))
        # print('preco_pecas:{}'.format(len(preco_pecas_freq)))
        # print('crv:{}'.format(len(crv_freq)))
        # print('vr_v:{}'.format(len(vr_v_freq)))
        # print('vt_vr:{}'.format(len(vt_vr_freq)))

        # data = {'talh': talh_freq,'parc': parc_freq, 'arv': arv_parc_list_t, 'falha': falha_parc_list_t,
        #         'vr': vr_freq, 'v': v_freq, 'vr_nr': vr_nr_freq, 'v_nr': v_nr_freq,
        #         'n_pecas': n_pecas_freq, 'n_pecas_nr': n_pecas_nr_freq, 'preco_freq': preco_freq,
        #         'vt': vt_freq, 'preco_inv': preco_inv_freq, 'preco_arv': preco_arv_freq, 'preco_pecas': preco_pecas_freq,
        #         'crv': crv_freq, 'vr_v': vr_v_freq, 'vt_vr': vt_vr_freq}


        data = {'talh': talh_freq,'parc': parc_freq, 'arv': arv_parc_list_t, 'falha': falha_parc_list_t,
                'vr': vr_freq, 'v': v_freq, 'vr_nr': vr_nr_freq, 'v_nr': v_nr_freq,
                }

        data2 = {
            'n_pecas': n_pecas_freq, 'n_pecas_nr': n_pecas_nr_freq, 'preco_freq': preco_freq,
            'vt': vt_freq, 'preco_inv': preco_inv_freq, 'preco_arv': preco_arv_freq, 'preco_pecas': preco_pecas_freq,
        }

        data3 = {
            'crv': crv_freq, 'vr_v': vr_v_freq, 'vt_vr': vt_vr_freq}

        parcela_talhao_ha = data
        parcela_talhao_ha.update(data2)
        parcela_talhao_ha.update(data3)
        dados_execucao['sintetico']['resultado_parcela_talhao'] = parcela_talhao_ha

        df = pd.DataFrame(data)
        df2 = pd.DataFrame(data2)
        df3 = pd.DataFrame(data3)

        print("-" * 70)
        print("RESULTADO TOTALIZADO POR PARCELA DENTRO DE TALHAO (ha)")
        print(df)
        print("-" * 70)
        print(df2)
        print("-" * 70)
        print(df3)
        print("-" * 70)

        # xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        # "RESULTADO TOTALIZADO POR TALHAO (ha)"

        talh_freq = []
        vr_freq = []
        v_freq = []
        vr_nr_freq = []
        v_nr_freq = []
        n_pecas_freq = []
        n_pecas_nr_freq = []
        preco_freq = []

        vt_freq = []
        preco_inv_freq = []
        preco_arv_freq = []
        preco_pecas_freq = []
        crv_freq = []
        vr_v_freq = []
        vt_vr_freq = []

        i = 0
        j = 0

        for w in range(0, len(talh_unico)):

            while i < len(talh_list):

                if talh_list[i] == talh_unico[w]:

                    if peca_list[i] == 'NaoRolica':
                        vr_nr = vr_nr + vr_list[i]
                        v_nr = v_nr + v_list[i]
                        n_pecas_nr = n_pecas_nr + 1
                    else:
                        vr = vr + vr_list[i]
                        v = v + v_list[i]
                        n_pecas = n_pecas + 1
                        preco = preco + preco_list[i]

                i = i + 1

            i = 0

            talh_freq.append(talh_unico[w])
            vr_freq.append(vr * fator_talh_ha[j])
            v_freq.append(v * fator_talh_ha[j])
            vr_nr_freq.append(vr_nr * fator_talh_ha[j])
            v_nr_freq.append(v_nr * fator_talh_ha[j])
            n_pecas_freq.append(n_pecas * fator_talh_ha[j])
            n_pecas_nr_freq.append(n_pecas_nr * fator_talh_ha[j])
            preco_freq.append(preco * fator_talh_ha[j])
            vt_freq.append(vt_talh_list[j] * fator_talh_ha[j])

            ## ALTERAção 17/08/2023
            if vr > 0:
                preco_inv_freq.append((pf * vt_talh_list[j])/vr)
                preco_arv_freq.append(preco / vt_talh_list[j])
                preco_pecas_freq.append(preco / vr)
                # crv_freq.append(v / vr)
            else:
                preco_inv_freq.append(0)
                preco_arv_freq.append(0)
                preco_pecas_freq.append(0)
                # crv_freq.append(0)
            crv_freq.append(0)
            # vr_v_freq.append((vr-v) * fator_talh_ha[j])
            vr_v_freq.append(0)
            ##
            vt_vr_freq.append((vt_talh_list[j] - vr) * fator_talh_ha[j])

            vr = v = vr_nr = v_nr = n_pecas = n_pecas_nr = preco = 0
            j = j + 1

        print('talh:{}'.format(len(talh_freq)))
        print('vr:{}'.format(len(vr_freq)))
        print('v:{}'.format(len(v_freq)))
        print('vr_nr:{}'.format(len(vr_nr_freq)))
        print('v_nr:{}'.format(len(v_nr_freq)))
        print('npecas:{}'.format(len(n_pecas_freq)))
        print('npecas_nr:{}'.format(len(n_pecas_nr_freq)))
        print('preco:{}'.format(len(preco_freq)))
        print('vt:{}'.format(len(vt_freq)))
        print('preco_inv:{}'.format(len(preco_inv_freq)))
        print('preco_arv:{}'.format(len(preco_arv_freq)))
        print('preco_pecas:{}'.format(len(preco_pecas_freq)))
        print('crv:{}'.format(len(crv_freq)))
        print('vr_v:{}'.format(len(vr_v_freq)))
        print('vt_vr:{}'.format(len(vt_vr_freq)))

        # data = {'talh': talh_freq,'arv': arv_parc_list_t, 'falha': falha_parc_list_t,
        #         'vr': vr_freq, 'v': v_freq, 'vr_nr': vr_nr_freq, 'v_nr': v_nr_freq,
        #         'n_pecas': n_pecas_freq, 'n_pecas_nr': n_pecas_nr_freq, 'preco_freq': preco_freq,
        #         'vt': vt_freq, 'preco_inv': preco_inv_freq, 'preco_arv': preco_arv_freq, 'preco_pecas': preco_pecas_freq,
        #         'crv': crv_freq, 'vr_v': vr_v_freq, 'vt_vr': vt_vr_freq}


        data = {'talh': talh_freq, 'arv': arv_talh_list_t, 'falha': falha_talh_list_t,
                'vr': vr_freq, 'v': v_freq, 'vr_nr': vr_nr_freq, 'v_nr': v_nr_freq
                }

        data2 = {
            'n_pecas': n_pecas_freq, 'n_pecas_nr': n_pecas_nr_freq, 'preco_freq': preco_freq,
            'vt': vt_freq, 'preco_inv': preco_inv_freq, 'preco_arv': preco_arv_freq, 'preco_pecas': preco_pecas_freq
        }

        data3 = {
            'crv': crv_freq, 'vr_v': vr_v_freq, 'vt_vr': vt_vr_freq}

        talhao_ha = data
        talhao_ha.update(data2)
        talhao_ha.update(data3)
        dados_execucao['sintetico']['resultado_talhao'] = talhao_ha

        df = pd.DataFrame(data)
        df2 = pd.DataFrame(data2)
        df3 = pd.DataFrame(data3)

        print("-" * 70)
        print("RESULTADO TOTALIZADO POR TALHAO (ha)")
        print(df)
        print("-" * 70)
        print(df2)
        print("-" * 70)
        print(df3)
        print("-" * 70)
        # xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

        return dados_execucao
