# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-NaoComercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv
import hashlib


class usuario_coletor(osv.Model):
    """
    Cadastro de usuarios do modulo coletor.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'usuario.coletor'  # usucol
    _inherit = 'usuario.coletor'  # coletor/model/usuario_coletor_data

    def create(self, cr, uid, values, context=None):
        """

        :param cr: a linha atual do cursor do banco de dados,
        :param uid: ID do usuario utilizado para a verificacao de perfil,
        :param values: dicionario com o nome dos campos e seus respectivos valores,
        :param context: um dicionário padrão para valores contextuais,
        :return: senha criada ou mensagem de erro.
        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}

        senha = values.get('senha_coletor')
        values['senha_coletor'] = hashlib.md5(senha).hexdigest()

        result =  super(usuario_coletor, self).create(cr, uid, values, context)

        return result

    def write(self, cr, uid, ids, values, context=None):
        """

        :param cr: a linha atual do cursor do banco de dados,
        :param uid: ID do usuário utilizado para a verificação de perfil,
        :param values: dicionário com o nome dos campos e seus respectivos valores,
        :param context: um dicionário padrão para valores contextuais,
        :return: senha alterada ou mensagem de erro.
        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}

        if ids and isinstance(ids, (int, long)):
            ids = [ids]

        if 'senha_coletor' in values:
            senha = values.get('senha_coletor')
            values['senha_coletor'] = hashlib.md5(senha).hexdigest()

        result = super(usuario_coletor, self).write(cr, uid, ids, values, context)

        return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
