# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""


# _______________________ modulo.coletor ____________________________________
def modcol_nova_sequencia(self, cr, uid, context):
    """
    Define a nova sequencia dos modulos do coletor. (heranca)

    :param cr: a linha atual do cursor do banco de dados,
    :param uid: ID do usuario utilizado para a verificacao de perfil,
    :param context: um dicionario padrao para valores contextuais,
    :return: nova sequencia.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    # Busca pela maior sequencia
    sequencia_id = self.search(cr, uid, [], limit=1, order='sequence', context=context)

    sequencia = 0
    if sequencia_id:
        dados_sequencia = self.read(cr, uid, sequencia_id, ['sequence'], context=context, load='_classic_read')

        if dados_sequencia and isinstance(dados_sequencia, list):
            dados_sequencia = dados_sequencia[0]

        if dados_sequencia and isinstance(dados_sequencia, dict):
            sequencia = dados_sequencia.get('sequence', 0)

    sequencia += 1

    return sequencia


# _______________________ usuario.coletor ___________________________________
def usucol_fields_function(self, cr, uid, ids, name, arg, context=None):
    """
    Manipulacao de campos. Valores de campos pre-definidos.

    :param cr: a linha atual do cursor do banco de dados,
    :param uid: ID do usuario utilizado para a verificacao de perfil,
    :param ids: lista dos IDs,
    :param name: lista com o nome dos campos,
    :param arg: dicionario com os argumentos e valores,
    :param context: um dicionario padrao para valores contextuais,
    :return: valores das chaves representando registros divergentes e nao divergentes.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    if ids and isinstance(ids, (int, long)):
        ids = [ids]

    result = {}

    for usuario in self.browse(cr, uid, ids, context):
        try:
            if name == 'name':
                valor = usuario.usuario_id.name
            else:
                valor = None
        except Exception as e:
            print '[erro] %s' % e
            valor = None

        result[usuario.id] = valor

    return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
