# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-NaoComercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class modulo_coletor(osv.Model):
    """
    Cadastro de modulos utilizados pelo coletor de dados.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'modulo.coletor'  # modcol

    from funcoes import modcol_nova_sequencia

    _columns = {
        # ___________________________ Char ___________________________________
        'name': fields.char('Nome', size=40, required=True,
                            help='Nome do aplicativo para aparecer na opcao do menu do coletor.'),
        'descricao': fields.char('Descricao', size=100),
        'fonte': fields.char('Nome do arquivo fonte', size=64,
                             help='Nome do arquivo fonte (ex.: modulo.py)'),
        'caminho': fields.char('Caminho', size=255,
                               help='Caminho completo da localizacao do arquivo fonte '
                                    '(ex.: coletor/app/modulo).'),

        # ___________________________ Char ___________________________________
        'sequence': fields.integer('Sequencia',
                                   help='Ordem em que o nome do aplicativo aparece no menu do '
                                        'coletor.'),

        # ___________________________ Char ___________________________________
        'active': fields.boolean('Ativo',
                                 help='Se marcado, o modulo e carregado executado.')
    }

    _defaults = {
        'active': lambda *args: True,
        'sequence': modcol_nova_sequencia
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
