# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-NaoComercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class usuario_coletor(osv.Model):
    """
    Cadastro de usuario do coletor de dados.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    @change: 28.10.2013 - pierre.barbosa
    """

    _name = 'usuario.coletor'  # usucol
    _inherits = {'res.users': 'usuario_id'}
    _rec_name = 'login_usuario'

    from funcoes import usucol_fields_function

    _columns = {
        # ___________________________ Many2One _______________________________
        'usuario_id': fields.many2one('res.users', 'Usuario', required=True, ondelete='restrict', select=True),

        # ___________________________ Many2many ______________________________
        'modulo_ids': fields.many2many('modulo.coletor', 'usuario_id', 'usuario_id', 'modulo_id',
                                       'Modulo',
                                       help='Permissao no modulo. Aparece no menu do coletor se usuario tem a permissao.'),

        # ___________________________ Char ___________________________________
        'login_usuario': fields.char('Login', size=10, required=True,
                                     help='Login do usuario.'),
        'senha_coletor': fields.char('Senha', size=32,
                                     help='Senha do usuario. Maximo de 32 caracteres'),

        # ___________________________ Function _______________________________
        'name': fields.function(usucol_fields_function, type='char', size=100, string='Nome',
                                help='Nome do usuario.'),

        # ___________________________ Boolean ________________________________
        'active': fields.boolean('Ativo'),
    }

    _defaults = {
        'active': lambda *args: True,
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
