#!/usr/bin/python
# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz:siginformatica.com.br>
                                -------

"""

from coletor import termx, xmlrpc

__version__ = (0, 1)

class ConsultaProduto(object):
    """
    Consulta de produtos.

    """
    # Cores utilizadas
    color_input = termx.bold, termx.underline, termx.fg_white  # Branco intenso/sublinhado
    color_title = termx.underline,  # Branco (sublinhado)
    color_header = termx.fg_cyan,  # Azul claro
    color_error = termx.fg_white, termx.bg_red,  # Branco/vermelho
    color_field = termx.underline, termx.fg_green,  # Verde (sublinhado)
    color_info = termx.reverse, termx.fg_cyan,  # Preto/azul claro
    color_list_os = termx.bold, termx.fg_yellow, termx.underline,  # Amarelo claro (sublinhado)
    color_os = termx.fg_yellow,  # Amarelo
    color_msg_ok = termx.fg_green,  # Verde claro
    line_error = termx.max_row  # Linha onde sao mostradas as mensagens de erro
    line_info = line_error  # Linha onde sao mostradas as informacoes
    rec_sucess = True  # Enderecamento efetuado com sucesso
    rec_continue = False  # O enderecamento continua

    def __init__(self):
        self.consulta_produto()
        termx.clear()
        termx.say(1, 1, 'SigERP-Coletor V-%s.%s' % __version__, *self.color_title)
    def remover_acentuacao(self, text, cod='utf-8'):

            '''
                   Funcao Wrapper para remover acentuacao
                   :param text:texto onde sera feita a remocao da acentuacao
                   :param cod:Tipo de codificacao
                   return:string
                 '''
            from unicodedata import normalize, category

            try:
                unicode_string = str(text)
            except UnicodeEncodeError:
                return normalize('NFKD', text).encode('ASCII', 'ignore')

            return unicode(filter(lambda c: category(c) != 'Mn',
                                  normalize('NFKD', unicode_string.decode(cod)))
            )
    def consulta_produto(self):
        context = {}
        __ESC = chr(27)

        termx.clear(1)
        termx.say(1, 1, '- CONSULTA PRODUTO -', *self.color_header)

        while True:
            termx.clear(2)
            termx.say(2,1, 'Local:')
            local = termx.get(2,8, 2)
            if not local:
                continue
            if local == __ESC:
                return False
            if not local.isdigit():
                continue
            args = [('numero', '=', local)]
            id_local = xmlrpc.execute('estoque.local', 'search', args)
            if not id_local:
                continue
            id_local = id_local[0]

            while True:
                termx.clear(4)
                termx.say(3, 1, 'Item:')
                prod = termx.get(3, 7, 14)
                if not prod:
                    continue
                if prod == __ESC:
                    break
                if not prod.isdigit():
                    continue
                prod = str(prod)

                while len(prod) < 14:
                    prod = '0' + prod
                args = [('codigo_barra', '=', prod)]
                automacao_codigo_id = xmlrpc.execute('automacao.codigo.barra', 'search', args)
                if not automacao_codigo_id:
                    termx.say(5,1,'Este Produto nao')
                    termx.say(6,1,'esta cadastrado')
                    termx.say(8,15, 'ENTER', *self.color_input)
                    espera = termx.get(8,20,0)
                    if espera == __ESC:
                        return False
                    continue
                if isinstance(automacao_codigo_id,list):
                    automacao_codigo_id=automacao_codigo_id[0]
                campos = ['produto_id', 'grade_id', 'produto_embalagem_id']
                dados_automacao = xmlrpc.execute('automacao.codigo.barra', 'read', int(automacao_codigo_id), campos)
                args = [('local_id','=',id_local), ('grade_id','=',dados_automacao.get('grade_id')[0]),
                        ('produto_id','=', dados_automacao.get('produto_id')[0])]
                estoque_local_locacao_id = xmlrpc.execute('estoque.local.locacao', 'search', args)
                if not estoque_local_locacao_id:
                    termx.say(5,1,'Este Produto nao')
                    termx.say(6,1,'existe neste local')
                    termx.say(8,15, 'ENTER', *self.color_input)
                    espera = termx.get(8,20,0)
                    if espera == __ESC:
                        return False
                    continue

                while True:
                    campos = ['name','grade']
                    dados_grade = xmlrpc.execute('estoque.produto.grade', 'read', int(dados_automacao.get('grade_id')[0]), campos)
                    prod_embalagem_id = dados_automacao.get('produto_embalagem_id')[0]
                    if isinstance(prod_embalagem_id, list):
                        prod_embalagem_id =prod_embalagem_id[0]
                    dados_prod_embalagem = xmlrpc.execute('estoque.produto.embalagem', 'read', int(prod_embalagem_id), ['embalagem_id'])
                    dados_emb_embalagem = xmlrpc.execute('estoque.embalagem', 'read', int(dados_prod_embalagem.get('embalagem_id')[0]), ['sigla', 'quantidade_na_embalagem'])
                    descricao = xmlrpc.execute('adm.utils', 'admutl_remover_acentuacao', dados_grade.get('name'))
                    termx.say(4,1, str(descricao))
                    termx.say(5,1, 'Qtd.Emb.: ')
                    termx.say(5,11, str(int(dados_emb_embalagem.get('quantidade_na_embalagem'))), *self.color_input)
                    termx.say(5,18, dados_emb_embalagem.get('sigla'), *self.color_input)
                    from datetime import datetime
                    eps_grade_id = int(dados_automacao.get('grade_id')[0])
                    eps_data = datetime.now().strftime('%Y-%m-%d')
                    eps_local_id = id_local
                    context.update({'coletor_estoque_saldo': True})
                    saldo = xmlrpc.execute('estoque.produto.saldo', 'get_saldo_do_dia',
                                           eps_grade_id, eps_data, eps_local_id, False, context)
                    saldo = saldo.get(str(eps_grade_id)).get('disponivel')
                    saldo = float(saldo)/float(dados_emb_embalagem.get('quantidade_na_embalagem'))
                    termx.say(6,1, 'Saldo:')
                    termx.say(6,7, str(saldo).replace('.',','), *self.color_input)
                    grade_sigla = str(dados_grade.get('grade'))
                    termx.say(6,18, str(grade_sigla), *self.color_input)
                    preco = xmlrpc.execute('estoque.produto', 'read', dados_automacao.get('produto_id')[0], ['preco_venda'])
                    if preco and isinstance(preco, list):
                        preco=preco[0]
                    if preco and isinstance(preco, dict):
                        preco=preco.get('preco_venda')
                    preco = str(preco)
                    preco = preco.replace('.', ',')
                    if preco[len(preco)-2:len(preco)-1] == ',':
                        preco += '0'
                    termx.say(7,1, 'Preco:')
                    termx.say(7,7, str(preco), *self.color_input)
                    termx.say(8,15, 'ENTER', *self.color_input)
                    espera = termx.get(8,20,0)
                    if espera == __ESC:
                        return False
                    break

                continue

            return False

        return False

ConsultaProduto()

