#!/usr/bin/python
# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz:siginformatica.com.br>
                                -------

"""

from coletor import termx, xmlrpc

__version__ = (0, 2)
__lastupdate__ = '2017-13-01 15:11:55'
__mantainer__ = 'Pierre Barbosa'

class ColetorInventarioContagem(object):
    """
    Inventario.

    """

    # Cores utilizadas
    color_input = termx.bold, termx.underline, termx.fg_white  # Branco intenso/sublinhado
    color_title = termx.underline,  # Branco (sublinhado)
    color_header = termx.fg_cyan,  # Azul claro
    color_error = termx.fg_white, termx.bg_red,  # Branco/vermelho
    color_field = termx.underline, termx.fg_green,  # Verde (sublinhado)
    color_info = termx.reverse, termx.fg_cyan,  # Preto/azul claro
    color_list_os = termx.bold, termx.fg_yellow, termx.underline,  # Amarelo claro (sublinhado)
    color_os = termx.fg_yellow,  # Amarelo
    color_msg_ok = termx.fg_green,  # Verde claro
    line_error = termx.max_row  # Linha onde sao mostradas as mensagens de erro
    line_info = line_error  # Linha onde sao mostradas as informacoes
    rec_sucess = True  # Enderecamento efetuado com sucesso
    rec_continue = False  # O enderecamento continua

    def __init__(self):
        self.cont_inventario()
        termx.clear()
        termx.say(1, 1, 'SigERP-Coletor V-%s.%s' % __version__, *self.color_title)

    def cont_inventario(self):
        """
        Mostra lista com detalhes das ordens de servico de inventario

        :return:
        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        termx.clear(1)
        termx.say(1, 1, '-CONT.DE INVENTARIO-', *self.color_header)
        inventario = False
        while True:
            inventario = self.inventario()  # Selecao da ordem de servico
            if not inventario:
                break
            inventario = int(inventario)

        return inventario

    def inventario(self):
        """
        Inventarios destinadas ao usuario.

        :return: {int} numero da ordem de servico selecionada.
        """
        # Selecao de uma ordem de servico
        inventario_numero = 0
        __ESC = chr(27)
        qtd_mostra_invent = 0
        while True:
            termx.clear(2)
            termx.say(2, 1, 'Nr', *self.color_list_os)
            termx.say(2, 4, 'DESCRICAO', *self.color_list_os)
            termx.say(2, 14, ' (+  -)')
            lin_inv, lista_inventario = self.lista_inventario()  # Mostra a lista de inventarios
            if not lin_inv or not lista_inventario:
                termx.say(4,1,'Nao ha inventario')
                termx.say(5,1,'disponivel!')
                termx.say(8,15,'ENTER')
                termx.get(8,20,0)
                return False
            lin = 3
            if len(lin_inv) < 1:
                continue
            for i in range(qtd_mostra_invent, len(lin_inv)):
                termx.say(lin, 1, lin_inv[i].get('numero')+' '+lin_inv[i].get('name')[5:7]+'/'+lin_inv[i].get('name')[2:4]+'-'+
                                lin_inv[i].get('name')[10:], *self.color_os)
                lin += 1
                if (lin - 4) > 5:
                    break
            termx.clear(8)
            termx.say(8, 1, 'Nr. inventario: _')
            inventario_numero = termx.get(8, 17, 2)  # Aguarda a selecao
            if inventario_numero == __ESC:
                return False

            if not inventario_numero:
                if qtd_mostra_invent + 5 < len(lin_inv):
                    qtd_mostra_invent+=5
                else:
                    qtd_mostra_invent=0
                continue
            if inventario_numero == '+':
                if qtd_mostra_invent + 5 < len(lin_inv):
                    qtd_mostra_invent+=5
                else:
                    qtd_mostra_invent=0
                continue
            if inventario_numero == '-':
                if qtd_mostra_invent - 5 >= 0:
                    qtd_mostra_invent-=5
                else:
                    qtd_mostra_invent = (len(lin_inv)-len(lin_inv)%4) if len(lin_inv)%4 !=0 else len(lin_inv)-5
                continue
            if not inventario_numero.isdigit():
                continue
            elif not int(inventario_numero) in lista_inventario:
                continue

            self.digitacao(lin_inv[int(inventario_numero)-1].get('id'))

            return 0

        return inventario_numero
    def digitacao(self, inventario_id):
        __ESC = chr(27)
        while True:
            termx.clear(2)
            termx.say(2, 1, 'Local: _')
            local = termx.get(2, 8, 2)
            if not local:
                continue
            if local == __ESC:
                return False
            args = [('numero', '=', local)]
            id_local = xmlrpc.execute('estoque.local', 'search', args)
            if not id_local:
                continue
            if isinstance(id_local, list):
                id_local=id_local[0]
            while True:
                termx.clear(1)
                termx.say(1, 1, '-CONT.DE INVENTARIO-', *self.color_header)
                termx.say(2, 1, 'Local:')
                termx.say(2, 8, str(local), *self.color_input)
                termx.say(3, 1, 'Item:')
                prod = termx.get(3, 7, 14)
                if not prod:
                    continue
                if prod == __ESC:
                    break
                if not prod.isdigit():
                    continue
                prod = str(prod)
                while len(prod) < 14:
                    prod = '0' + prod
                args = [('codigo_barra', '=', prod)]
                automacao_codigo_id = xmlrpc.execute('automacao.codigo.barra', 'search', args)
                if not automacao_codigo_id:
                    continue
                if isinstance(automacao_codigo_id,list):
                    automacao_codigo_id=automacao_codigo_id[0]
                campos = ['produto_id', 'grade_id', 'produto_embalagem_id']
                dados_automacao = xmlrpc.execute('automacao.codigo.barra', 'read', int(automacao_codigo_id), campos)
                args = [('inventario_id', '=', inventario_id),('produto_id', '=', dados_automacao.get('produto_id')[0]),
                        ('grade_id', '=', dados_automacao.get('grade_id')[0]),('local_id', '=', id_local)]
                contagem_invent_id = xmlrpc.execute('estoque.inventario.contagem', 'search', args)
                if not contagem_invent_id:
                    termx.say(4,1, str('Este item nao esta  '))
                    termx.say(5,1, str('no inventario       '))
                    termx.say(6,1, str('Deseja adiciona-lo? '))
                    termx.say(8,15, 'ENTER', *self.color_input)
                    espera = termx.get(8,20,0)
                    if espera == __ESC: # caso cancele
                        continue

                    termx.clear(4)
                    termx.clear(5)
                    termx.clear(6)
                    termx.clear(8)

                while True:
                    campos = ['name']
                    dados_grade = xmlrpc.execute('estoque.produto.grade', 'read', int(dados_automacao.get('grade_id')[0]), campos)
                    prod_embalagem_id = int(dados_automacao.get('produto_embalagem_id')[0])
                    if isinstance(prod_embalagem_id, list):
                        prod_embalagem_id =prod_embalagem_id[0]

                    dados_prod_embalagem = xmlrpc.execute('estoque.produto.embalagem', 'read', int(prod_embalagem_id), ['embalagem_id'])
                    dados_emb_embalagem = xmlrpc.execute('estoque.embalagem', 'read', int(dados_prod_embalagem.get('embalagem_id')[0]), ['sigla', 'quantidade_na_embalagem', 'unidade_id'])
                    emb_unidade_id = dados_emb_embalagem.get('unidade_id')
                    qtde_embalagem = dados_emb_embalagem.get('quantidade_na_embalagem', 1)
                    if emb_unidade_id and isinstance(emb_unidade_id, list):
                        emb_unidade_id=emb_unidade_id[0]

                    fracionado = xmlrpc.execute('estoque.embalagem.unidade', 'read', int(emb_unidade_id), ['fracao'])
                    if isinstance(fracionado, dict):
                        fracionado=fracionado.get('fracao')

                    descricao = xmlrpc.execute('adm.utils', 'admutl_remover_acentuacao', dados_grade.get('name'))
                    termx.say(4,1, str(descricao))
                    termx.say(5,1, 'Qtd.Emb.: ')
                    termx.say(5,11, str(int(qtde_embalagem)), *self.color_input)
                    termx.say(5,18, dados_emb_embalagem.get('sigla'), *self.color_input)
                    args = [('inventario_id', '=', inventario_id),('produto_id', '=', dados_automacao.get('produto_id')[0]),
                            ('grade_id', '=', dados_automacao.get('grade_id')[0]),('local_id', '=', id_local)]
                    contagem_invent_id = xmlrpc.execute('estoque.inventario.contagem', 'search', args)
                    contagem_invent_id = contagem_invent_id and contagem_invent_id[0]
                    print '\n\n\n\n\n\n\n\n\n ID contagem: ', contagem_invent_id
                    usuario_ids = xmlrpc.execute('usuario.coletor', 'search', [('usuario_id', '=', xmlrpc.login_id)])
                    usuario_col_dados = xmlrpc.execute('usuario.coletor', 'read', usuario_ids[0], ['saldo_produto'])
                    if usuario_col_dados and isinstance(usuario_col_dados, list):
                        usuario_col_dados=usuario_col_dados[0]

                    mostra_saldo_produto = False
                    if usuario_col_dados and isinstance(usuario_col_dados, dict):
                        mostra_saldo_produto = usuario_col_dados.get('saldo_produto')

                    if mostra_saldo_produto:
                        if contagem_invent_id:
                            saldo_contagem = xmlrpc.execute(
                                'estoque.inventario.contagem', 'read', contagem_invent_id,
                                ['saldo_cadastro']) or {}
                            saldo = float(saldo_contagem.get('saldo_cadastro')) / qtde_embalagem
                            termx.say(7,1, 'Saldo: ')
                            termx.say(7,8, str(saldo).replace('.', ','), *self.color_input)
                    termx.say(6,1, 'Contagem:')

                    # Mostra o saldo contado
                    saldo_contado = xmlrpc.execute(
                        'estoque.inventario.contagem', 'read', contagem_invent_id,
                        ['saldo_contado']) or {}
                    contagem = str(str(saldo_contado.get('saldo_contado', 0) / qtde_embalagem))
                    contagem = termx.get(6, 11, 10, stand=contagem.replace('.', ','))

                    if contagem == __ESC:
                        break
                    if not contagem:
                        continue
                    contagem = contagem.replace(',', '.')
                    if '.' in contagem and not fracionado:
                        continue
                    try:
                        contagem = float(contagem)
                    except:
                        continue

                    if contagem > 999999.99:
                        contagem = 999999.99

                    args = [('local_id','=',id_local),('grade_id','=',dados_automacao.get('grade_id')[0]),('produto_id','=',dados_automacao.get('produto_id')[0])]
                    local_locacao_id = xmlrpc.execute('estoque.local.locacao', 'search', args)
                    pessoa_id  = xmlrpc.execute('res.users', 'read', xmlrpc.login_id, ['pessoa_id','company_id'])
                    company_id = ''
                    if pessoa_id and isinstance(pessoa_id, list):
                        pessoa_id = pessoa_id[0]
                    if pessoa_id and isinstance(pessoa_id, dict):
                        company_id = pessoa_id.get('company_id')
                        pessoa_id = pessoa_id.get('pessoa_id')
                        if pessoa_id and isinstance(pessoa_id, list):
                            pessoa_id = pessoa_id[0]
                    if company_id and isinstance(company_id, list):
                        company_id=company_id[0]
                    if not local_locacao_id:
                        while True:
                            termx.clear(1)
                            termx.say(2,1,'------ ALERTA ------')
                            termx.say(3,1,' O item selecionado')
                            termx.say(4,1,'nao esta cadastrado')
                            termx.say(5,1,'neste local, deseja')
                            termx.say(6,1,'inclui-lo?')
                            termx.say(7,1,'(0-nao,1-sim)')
                            res = termx.get(7,15, 1)
                            if not res:
                                continue
                            if res == __ESC:
                                break
                            if not res.isdigit():
                                continue
                            if int(res) == 1:
                                dic_local_locacao= {'company_id': company_id,
                                                    'local_id': id_local,
                                                    'produto_id': dados_automacao.get('produto_id')[0],
                                                    'grade_id': dados_automacao.get('grade_id')[0],
                                                    'estllc_produto_embalagem_id': dados_automacao.get('produto_embalagem_id')[0]}
                                xmlrpc.execute('estoque.local.locacao', 'create', dic_local_locacao)
                                break
                            if int(res) == 0:
                                break
                    local_locacao_id = xmlrpc.execute('estoque.local.locacao', 'search', args)
                    if not local_locacao_id:
                        break
                    if isinstance(local_locacao_id, list):
                        local_locacao_id=local_locacao_id[0]

                    custos = xmlrpc.execute('estoque.preco.custo', 'get_custos_do_dia',
                                            dados_automacao.get('produto_id')[0], False, False,
                                            {'chamada_pelo_coletor': True})
                    args = [('pessoa','=',pessoa_id)]
                    funcionario_id = xmlrpc.execute('rh.funcionario', 'search', args)
                    contagem = contagem*int(dados_emb_embalagem.get('quantidade_na_embalagem'))
                    if contagem_invent_id:
                        parametro_id = xmlrpc.execute('estoque.parametro', 'search',
                                                      [('company_id', '=', company_id)])
                        tipo_contagem = 'S' # S = substituir, I = incrementar

                        if parametro_id:
                            if isinstance(parametro_id, list):
                                parametro_id = parametro_id[0]

                            tipo_contagem = xmlrpc.execute('estoque.parametro', 'read',
                                                  parametro_id, ['estpar_inventario_tipo_contagem']).get('estpar_inventario_tipo_contagem')

                        if tipo_contagem == 'I':
                            contagem += saldo_contado.get('saldo_contado') or 0

                        xmlrpc.execute('estoque.inventario.contagem', 'write', contagem_invent_id,
                                       {'saldo_contado':contagem})
                    else:
                        dic_invent_contagem = {  'inventario_id':inventario_id,
                                                 'produto_id': dados_automacao.get('produto_id')[0],
                                                 'grade_id': dados_automacao.get('grade_id')[0],
                                                 'estict_custo_medio_contabil': custos.get('estprc_custo_medio_contabil'),
                                                 'estict_ultimo_custo': custos.get('estprc_ultimo_custo'),
                                                 'conferido': False,
                                                 'saldo_cadastro': 0,
                                                 'saldo_contado': contagem,
                                                 'requisitado': 0,
                                                 'locacao_id': local_locacao_id,
                                                 'local_id': id_local,
                                                 'estict_item_atualizado': False,}
                        if funcionario_id and isinstance(funcionario_id, list):
                            funcionario_id=funcionario_id[0]
                        dic_invent_contagem['funcionario_id'] = funcionario_id
                        # print dic_invent_contagem
                        # import time
                        # time.sleep(100)
                        xmlrpc.execute('estoque.inventario.contagem', 'create', dic_invent_contagem)
                    break
            return

    def lista_inventario(self):
        """
        Lista dos inventarios

        :return: {list} lista com os dados do inventario.
        """

        lin_inv= []  # Lista a ordem dos inventarios
        lista_inventario = []  # Lista com o numero dos inventarios
        dados_inv = []  # Dados do inventario

        # Inventario
        args=[('atualizado','=',False)]
        ids = xmlrpc.execute('estoque.inventario.capa', 'search', args)
        if ids:
            campos = ['id','name', 'company_id']
            dados_inv = xmlrpc.execute('estoque.inventario.capa', 'read', ids, campos)

        if dados_inv and isinstance(dados_inv, list):
            cont = 1
            for inventario in dados_inv:
                lista_inventario.append(cont)  # acrescenta o nr. do inventario a lista
                descricao = xmlrpc.execute('adm.utils', 'admutl_remover_acentuacao', inventario.get('name'))
                lin_inv.append({'numero':str(cont),'name': descricao, 'id':inventario.get('id')})
                cont+=1
        return lin_inv, lista_inventario
ColetorInventarioContagem()

