#!/usr/bin/python
# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz:siginformatica.com.br>
                                -------

"""

from coletor import termx, xmlrpc

__version__ = (0, 1)


class Requisicao(object):
    """
    Requisicao.

    """
    # Cores utilizadas
    color_input = termx.bold, termx.underline, termx.fg_white  # Branco intenso/sublinhado
    color_title = termx.underline,  # Branco (sublinhado)
    color_header = termx.fg_cyan,  # Azul claro
    color_destaque = termx.bold, termx.fg_white,  # Branco em negrito
    color_field = termx.underline, termx.fg_green,  # Verde (sublinhado)
    color_info = termx.reverse, termx.fg_cyan,  # Preto/azul claro
    color_list_os = termx.bold, termx.fg_yellow, termx.underline,  # Amarelo claro (sublinhado)
    color_os = termx.fg_yellow,  # Amarelo
    color_msg_ok = termx.fg_green,  # Verde claro
    line_error = termx.max_row  # Linha onde sao mostradas as mensagens de erro
    line_info = line_error  # Linha onde sao mostradas as informacoes
    rec_sucess = True  # Enderecamento efetuado com sucesso
    rec_continue = False  # O enderecamento continua

    def __init__(self):
        self.requisicao()
    def get_req(self, contexto = {}):
        from datetime import datetime
        __ESC = chr(27)
        ano = datetime.now().year
        termx.clear(2)
        termx.say(2,1, 'Ano:%s' % str(ano))
        flag = True
        while True:
            get_ano = str(ano)
            if contexto and contexto.get('separar_conferir'):
                termx.say(2,1, 'Ano:%s' % str(ano))
            if flag:
                espera = termx.get(2,9, 0)
                if espera == __ESC:
                    return __ESC
                flag = False
                if espera:
                    continue
            else:
                termx.clear(2)
                termx.say(2,1, 'Ano:%s' % str(ano))
                get_ano = termx.get(2,5, 4)
                if not get_ano:
                    continue
                if get_ano == __ESC:
                    return __ESC
                if not get_ano.isdigit():
                    continue
            termx.say(2,10, 'No.:')
            numero_req=''
            while True:
                numero_req = termx.get(2,14,6)
                if not numero_req:
                    return ''
                if numero_req == __ESC:
                    return __ESC
                if not numero_req.isdigit():
                    continue
                break
            termx.clear(3)
            requisicao = ''
            if numero_req:
                for i in range(0,6-len(numero_req)):
                    complemento = '0' + str(numero_req)
                    numero_req = complemento
                requisicao = 'RQ-%s-%s' %(get_ano,numero_req)
            return requisicao

    def requisicao(self):
        __ESC = chr(27)
        checa_modulo =  xmlrpc.execute('adm.utils', 'admutl_check_modulo_instalado', 'estoqueressuprimento', {})
        if not checa_modulo:
            termx.clear(2)
            termx.say(3,1, "Atencao! Modulo:   ")
            termx.say(4,1, 'estoqueressuprimento')
            termx.say(5,1, "nao esta instalado!")
            termx.say(8,15, 'ENTER',*self.color_destaque)
            termx.get(8,20,0)
            return False
        termx.clear(1)
        termx.say(1, 1, '--   REQUISICAO   --', *self.color_header)
        termx.say(2, 1, '1', *self.color_destaque)
        termx.say(2, 2, '-Digitar Requisicao')
        termx.say(3, 1, '2', *self.color_destaque)
        termx.say(3, 2, '-Separar Requisicao')
        termx.say(4, 1, '3', *self.color_destaque)
        termx.say(4, 2, '-Conferir Requisicao')
        termx.say(5, 1, '4', *self.color_destaque)
        termx.say(5, 2, '-Separar e Conferir')
        termx.say(6, 1, '5', *self.color_destaque)
        termx.say(6, 2, '-Requisicao Compra')
        termx.say(8, 12, 'Opcao [ ]', *self.color_destaque)
        while True:
            opcao = termx.get(8,19,1)
            if not opcao:
                continue
            if opcao == __ESC:
                break
            if not opcao.isdigit():
                continue
            if int(opcao) == 1:
                self.digitar_requisicao()
                break
            if int(opcao) == 2:
                self.separar_requisicao()
                break
            if int(opcao) == 3:
                self.conferir_requisicao()
                break
            if int(opcao) == 4:
                self.separar_conferir()
                break
            if int(opcao) == 5:
                self.requisicao_compra()
                break

    def digitar_requisicao(self):
        from datetime import datetime
        __ESC = chr(27)
        termx.clear()
        termx.say(1, 1, '-DIGITAR REQUISICAO-', *self.color_header)
        while True:
            termx.clear(3)
            requisicao = self.get_req()
            if not requisicao:   # Cria uma requisicao se nada for passado
                user_id = xmlrpc.login_id
                company_id = xmlrpc.execute('res.users', 'read', int(user_id), ['company_id'], {},
                                            '_classic_write').get('company_id')
                if isinstance(company_id, list):
                    company_id = company_id[0]

                termx.say(3,1, 'Emp.Sai:')
                termx.say(3, 9, str(company_id), *self.color_input)
                emp_saida = company_id
                while True:
                    termx.clear(4)
                    termx.say(3,11, 'Loc.Sai:')
                    loc_saida = termx.get(3,19, 2)
                    if not loc_saida:
                        continue
                    if loc_saida == __ESC:
                        return False
                    if not loc_saida.isdigit():
                        continue
                    args = [('numero','=',int(loc_saida))]
                    loc_saida_id = xmlrpc.execute('estoque.local', 'search', args)
                    if not loc_saida_id:
                        termx.say(6, 1, 'Local de Saida nao')
                        termx.say(7, 1, 'encontrado!')
                        termx.say(8,15, 'ENTER',*self.color_destaque)
                        termx.get(8,20,0)
                        continue

                    loc_saida_id = loc_saida_id[0]
                    empresa_ids = xmlrpc.execute('res.company', 'search', (), {})
                    while True:
                        termx.clear(4)
                        termx.say(4,1, 'Emp.Ent:')
                        if len(empresa_ids) == 1: # caso tenha apenas uma empresa
                            emp_entrada = empresa_ids[0]
                            termx.say(4, 9, str(emp_entrada), *self.color_input)

                        else: # caso tenha mais de uma empresa
                            emp_entrada = termx.get(4,9, 2)
                            if not emp_entrada:
                                continue
                            if emp_entrada == __ESC:
                                return False
                            if not emp_entrada.isdigit():
                                continue

                            if emp_entrada not in empresa_ids:
                                termx.say(6, 1, 'Empresa nao ')
                                termx.say(7, 1, 'encontrada!')
                                termx.say(8, 15, 'ENTER', *self.color_destaque)
                                termx.get(8, 20, 0)
                                continue

                        termx.say(4,11, 'Loc.Ent:')
                        while True:
                            termx.clear(5)
                            loc_entrada = termx.get(4,19, 2)
                            if not loc_entrada:
                                continue
                            if loc_entrada == __ESC:
                                return False
                            if not loc_entrada.isdigit():
                                continue

                            if isinstance(emp_entrada, list):
                                emp_entrada = emp_entrada[0]

                            args = [('numero','=',int(loc_entrada)),
                                    ('company_id', '=', emp_entrada)]
                            loc_entrada_id = xmlrpc.execute('estoque.local', 'search', args,
                                                            0, 0, '', {'sig_force_company': True})
                            if not loc_entrada_id:
                                termx.say(6, 1, 'Local de Entrada nao')
                                termx.say(7, 1, 'encontrado!')
                                termx.say(8, 15, 'ENTER', *self.color_destaque)
                                termx.get(8, 20, 0)
                                continue

                            loc_entrada_id = loc_entrada_id[0]
                            if loc_saida == loc_entrada:
                                termx.say(6, 1, 'Local de Saida igual')
                                termx.say(7, 1, 'Local de entrada!')
                                termx.say(8, 15, 'ENTER', *self.color_destaque)
                                termx.get(8, 20, 0)
                                continue

                            dic_est_requisicao = {'resrca_empresa_entrada_id': emp_entrada,
                                                  'local_entrada_id': loc_entrada_id,
                                                  'local_saida_id': loc_saida_id,}
                            requisicao_id = xmlrpc.execute('estoqueressuprimento.requisicao.capa', 'create', dic_est_requisicao)
                            if isinstance(requisicao_id, list):
                                requisicao_id=requisicao_id[0]
                            campos = ['local_saida_id','company_id', 'resrca_empresa_entrada_id',
                                      'local_entrada_id', 'numero']
                            requisicao_dados = xmlrpc.execute('estoqueressuprimento.requisicao.capa',
                                                              'read', int(requisicao_id), campos,
                                                              {}, '_classic_write')
                            ano = requisicao_dados.get('numero')[3:7]
                            numero = requisicao_dados.get('numero')[8:]
                            termx.say(2,1, 'Ano:%s' % str(ano))
                            termx.say(2,10, 'No.:')
                            termx.say(2,14, numero,*self.color_input)
                            termx.say(5,1, 'Item:')
                            while True:
                                termx.clear(6)
                                prod = termx.get(5, 7, 14)
                                if not prod:
                                    continue
                                if prod == __ESC:
                                    return False
                                if not prod.isdigit():
                                    continue
                                prod = str(prod)
                                while len(prod) < 14:
                                    prod = '0' + prod
                                args = [('codigo_barra', '=', prod)]
                                automacao_codigo_id = xmlrpc.execute('automacao.codigo.barra', 'search', args)
                                if not automacao_codigo_id:
                                    termx.say(6,1, 'Este item nao esta')
                                    termx.say(7,1, 'cadastrado!')
                                    termx.say(8,15, 'ENTER',*self.color_destaque)
                                    termx.get(8,20,0)
                                    continue

                                automacao_codigo_id = automacao_codigo_id[0]
                                campos = ['produto_id', 'grade_id', 'produto_embalagem_id']
                                dados_automacao = xmlrpc.execute('automacao.codigo.barra', 'read',
                                                                 int(automacao_codigo_id), campos,
                                                                 {}, '_classic_write')

                                grade_id = int(dados_automacao.get('grade_id'))
                                args = [('produto_id', '=', int(dados_automacao.get('produto_id'))),
                                        ('grade_id','=',grade_id),
                                        ('company_id','=',int(requisicao_dados.get('company_id'))),
                                        ('local_id','=',int(requisicao_dados.get('local_saida_id')))]
                                local_saida_locacao_id = xmlrpc.execute('estoque.local.locacao', 'search', args)
                                args = [('produto_id', '=', int(dados_automacao.get('produto_id'))),
                                        ('grade_id','=',grade_id),
                                        ('company_id','=',int(requisicao_dados.get('company_id'))),
                                        ('local_id','=',int(requisicao_dados.get('local_entrada_id')))]
                                local_entrada_locacao_id = xmlrpc.execute('estoque.local.locacao', 'search', args)
                                if not local_saida_locacao_id:
                                    termx.say(6,1, 'Este item nao esta')
                                    termx.say(7,1, 'no local de saida!')
                                    termx.say(8,15, 'ENTER',*self.color_destaque)
                                    termx.get(8,20,0)
                                    continue
                                if not local_entrada_locacao_id:
                                    termx.say(6,1, 'Este item nao esta')
                                    termx.say(7,1, 'no local de entrada!')
                                    termx.say(8,15, 'ENTER',*self.color_destaque)
                                    termx.get(8,20,0)
                                    continue

                                args = [('requisicao_id','=',int(requisicao_id)),
                                        ('produto_id', '=', dados_automacao.get('produto_id')),
                                        ('grade_id','=', grade_id)]
                                item_requisicao_id = xmlrpc.execute('estoqueressuprimento.requisicao.itens', 'search', args)
                                if item_requisicao_id:
                                    termx.say(6,1, 'Este item ja esta na')
                                    termx.say(7,1, 'requisicao!')
                                    termx.say(8,15, 'ENTER',*self.color_destaque)
                                    termx.get(8,20,0)
                                    continue

                                campos = ['name']
                                grade_descricao = xmlrpc.execute('estoque.produto.grade', 'read',
                                                                 grade_id, campos)
                                if grade_descricao and isinstance(grade_descricao, dict):
                                    grade_descricao=xmlrpc.execute('adm.utils',
                                                                   'admutl_remover_acentuacao',
                                                                   grade_descricao.get('name'))

                                eps_data = datetime.now()
                                context = {'coletor_estoque_saldo': True}
                                saldo = xmlrpc.execute('estoque.produto.saldo', 'get_saldo_do_dia',
                                                       grade_id, eps_data,
                                                       requisicao_dados.get('local_saida_id'),
                                                       emp_saida, context)
                                if not saldo or float(saldo.get(str(grade_id)).get('disponivel')) <= 0:
                                    termx.say(6,1,'Este item nao possui')
                                    termx.say(7,1,'saldo!')
                                    termx.say(8,15, 'ENTER',*self.color_destaque)
                                    termx.get(8,20,0)
                                    continue

                                termx.say(6,1, str(grade_descricao))
                                saldo = saldo.get(str(grade_id)).get('disponivel')
                                prod_embalagem_id = int(dados_automacao.get('produto_embalagem_id'))
                                if isinstance(prod_embalagem_id, list):
                                    prod_embalagem_id =prod_embalagem_id[0]
                                dados_prod_embalagem = xmlrpc.execute('estoque.produto.embalagem', 'read', int(prod_embalagem_id), ['embalagem_id'])
                                dados_emb_embalagem = xmlrpc.execute('estoque.embalagem', 'read', int(dados_prod_embalagem.get('embalagem_id')[0]), ['sigla', 'quantidade_na_embalagem'])
                                qtd_embalagem = str(dados_emb_embalagem.get('quantidade_na_embalagem')).replace('.',',')
                                termx.say(7,1, 'Saldo:')
                                mostra_saldo = float(saldo)/dados_emb_embalagem.get('quantidade_na_embalagem')
                                termx.say(7,7, str(mostra_saldo).replace('.',','), *self.color_input)
                                termx.say(7,19-len(qtd_embalagem), 'E:')
                                termx.say(7,21-len(qtd_embalagem), qtd_embalagem, *self.color_input)
                                termx.say(8,1, 'Qtd.Item:')
                                termx.say(8,18, dados_emb_embalagem.get('sigla'), *self.color_destaque)
                                while True:
                                    qts_item = termx.get(8,11,5)      #  ----------       RQ-2014-000001     ---------------
                                    if not qts_item:
                                        continue
                                    if qts_item == __ESC:
                                        break
                                    if not qts_item.isdigit():
                                        continue
                                    if float(str(qts_item).replace(',','.')) > float(mostra_saldo):
                                        continue
                                    requisicao_item= {  'requisicao_id': int(requisicao_id),
                                                        'produto_id': int(dados_automacao.get('produto_id')),
                                                        'grade_id': grade_id,
                                                        'quantidade_requisitada': float(qts_item)*dados_emb_embalagem.get('quantidade_na_embalagem'),
                                                        'embalagem_id': int(prod_embalagem_id),}
                                    xmlrpc.execute('estoqueressuprimento.requisicao.itens', 'create', requisicao_item)
                                    xmlrpc.execute('estoqueressuprimento.requisicao.capa', 'write', int(requisicao_id), {})
                                    break
            if requisicao ==__ESC:
                return False
            args = [('numero','=',str(requisicao)),('state','=', 'R')]
            requisicao_id = xmlrpc.execute('estoqueressuprimento.requisicao.capa', 'search', args)
            if not requisicao_id:
                continue
            if isinstance(requisicao_id, list):
                requisicao_id=requisicao_id[0]
            # Utiliza a requisicao informada
            campos = ['numero','local_saida_id', 'company_id', 'resrca_empresa_entrada_id',
                      'local_entrada_id', 'numero']
            requisicao_dados = xmlrpc.execute('estoqueressuprimento.requisicao.capa',
                                           'read', int(requisicao_id), campos, {}, '_classic_write')
            if requisicao_dados and isinstance(requisicao_dados, list):
                requisicao_dados=requisicao_dados[0]

            sai_local_id = int(requisicao_dados.get('local_saida_id'))
            ent_local_id = int(requisicao_dados.get('local_entrada_id'))
            numero_local_sai = xmlrpc.execute('estoque.local', 'read', sai_local_id, ['numero'],
                                              {}, '_classic_write').get('numero')
            numero_local_ent = xmlrpc.execute('estoque.local', 'read', ent_local_id, ['numero'],
                                              {}, '_classic_write').get('numero')
            numero = requisicao_dados.get('numero')[8:]
            empresa_saida_id = int(requisicao_dados.get('company_id'))
            empresa_entrada_id = int(requisicao_dados.get('resrca_empresa_entrada_id'))
            termx.say(2,10, 'No.:')
            termx.say(2,14, numero,*self.color_input)
            termx.say(3,1, 'Loc.Sai:')
            termx.say(3,9, str(numero_local_sai), *self.color_input)
            termx.say(3,11, 'Emp.Sai:')
            termx.say(3,19, str(empresa_saida_id), *self.color_input)
            termx.say(4,1, 'Loc.Ent:')
            termx.say(4,9, str(numero_local_ent), *self.color_input)
            termx.say(4,11, 'Emp.Ent:')
            termx.say(4,19, str(empresa_entrada_id), *self.color_input)
            termx.say(5,1, 'Item:')

            while True:
                termx.clear(6)
                prod = termx.get(5, 7, 14)
                if not prod:
                    continue
                if prod == __ESC:
                    return False
                if not prod.isdigit():
                    continue
                prod = str(prod)
                while len(prod) < 14:
                    prod = '0' + prod
                args = [('codigo_barra', '=', prod)]
                automacao_codigo_id = xmlrpc.execute('automacao.codigo.barra', 'search', args)
                if not automacao_codigo_id:
                    termx.say(6,1, 'Este item nao esta')
                    termx.say(7,1, 'cadastrado!')
                    termx.say(8,15, 'ENTER',*self.color_destaque)
                    termx.get(8,20,0)
                    continue

                automacao_codigo_id=automacao_codigo_id[0]
                campos = ['produto_id', 'grade_id']
                dados_automacao = xmlrpc.execute('automacao.codigo.barra', 'read',
                                                 int(automacao_codigo_id), campos, {},
                                                 '_classic_write')
                produto_id = int(dados_automacao.get('produto_id'))
                grade_id = int(dados_automacao.get('grade_id'))
                args = [('produto_id', '=', produto_id),
                        ('grade_id','=',grade_id),
                        ('company_id','=',empresa_saida_id),
                        ('local_id','=',sai_local_id)]
                local_saida_locacao_id = xmlrpc.execute('estoque.local.locacao', 'search', args)
                args = [('produto_id', '=', produto_id),
                        ('grade_id','=',grade_id),
                        ('company_id','=',empresa_entrada_id),
                        ('local_id','=',ent_local_id)]
                local_entrada_locacao_id = xmlrpc.execute('estoque.local.locacao', 'search', args)
                if not local_saida_locacao_id:
                    termx.say(6,1, 'Este item nao esta')
                    termx.say(7,1, 'no local de saida!')
                    termx.say(8,15, 'ENTER',*self.color_destaque)
                    termx.get(8,20,0)
                    continue

                if not local_entrada_locacao_id:
                    termx.say(6,1, 'Este item nao esta')
                    termx.say(7,1, 'no local de entrada!')
                    termx.say(8,15, 'ENTER',*self.color_destaque)
                    termx.get(8,20,0)
                    continue

                args = [('requisicao_id','=',int(requisicao_id)),
                        ('produto_id', '=', produto_id),
                        ('grade_id','=', grade_id)]
                item_requisicao_id = xmlrpc.execute('estoqueressuprimento.requisicao.itens', 'search', args)
                if item_requisicao_id:
                    termx.say(6,1, 'Este item ja esta na')
                    termx.say(7,1, 'requisicao!')
                    termx.say(8,15, 'ENTER',*self.color_destaque)
                    termx.get(8,20,0)
                    continue

                campos = ['name']
                grade_descricao = xmlrpc.execute('estoque.produto.grade', 'read', int(grade_id), campos)
                if grade_descricao and isinstance(grade_descricao, dict):
                    grade_descricao=xmlrpc.execute('adm.utils', 'admutl_remover_acentuacao', grade_descricao.get('name'))

                eps_data = datetime.now()
                context = {'coletor_estoque_saldo': True}
                saldo = xmlrpc.execute('estoque.produto.saldo', 'get_saldo_do_dia',
                                       grade_id, eps_data, sai_local_id, empresa_saida_id, context)
                if not saldo or float(saldo.get(str(grade_id)).get('disponivel')) <= 0:
                    termx.say(6,1,'Este item nao possui')
                    termx.say(7,1,'saldo!')
                    termx.say(8,15, 'ENTER',*self.color_destaque)
                    termx.get(8,20,0)
                    continue

                termx.say(6,1, str(grade_descricao))
                saldo = saldo.get(str(grade_id)).get('disponivel')
                prod_embalagem_id = xmlrpc.execute('estoque.produto.embalagem', 'search',
                                                   [('produto_id','=', produto_id)])
                if isinstance(prod_embalagem_id, list):
                    prod_embalagem_id =prod_embalagem_id[0]
                dados_prod_embalagem = xmlrpc.execute('estoque.produto.embalagem', 'read', int(prod_embalagem_id), ['embalagem_id'])
                dados_emb_embalagem = xmlrpc.execute('estoque.embalagem', 'read', int(dados_prod_embalagem.get('embalagem_id')[0]), ['sigla', 'quantidade_na_embalagem'])

                termx.say(7,1, 'Saldo:')
                mostra_saldo = float(saldo)/dados_emb_embalagem.get('quantidade_na_embalagem')
                termx.say(7,7, str(mostra_saldo).replace('.',','), *self.color_input)
                qtd_embalagem = str(dados_emb_embalagem.get('quantidade_na_embalagem')).replace('.',',')
                termx.say(7,19-len(qtd_embalagem), 'E:')
                termx.say(7,21-len(qtd_embalagem), qtd_embalagem, *self.color_input)
                termx.say(8,1, 'Qtd.Item:')
                termx.say(8,18, dados_emb_embalagem.get('sigla'), *self.color_destaque)

                while True:
                    qts_item = termx.get(8,11,5)
                    if not qts_item:
                        continue
                    if qts_item == __ESC:
                        break
                    if not qts_item.isdigit():
                        continue
                    if int(qts_item) == 0:
                        continue
                    if float(str(qts_item).replace(',','.')) > float(mostra_saldo):
                        continue
                    requisicao_item= {  'requisicao_id': int(requisicao_id),
                                        'produto_id': produto_id,
                                        'grade_id': grade_id,
                                        'quantidade_requisitada': float(qts_item)*dados_emb_embalagem.get('quantidade_na_embalagem'),
                                        'embalagem_id': int(prod_embalagem_id),}
                    xmlrpc.execute('estoqueressuprimento.requisicao.itens', 'create', requisicao_item)
                    break

        return False

    def separar_requisicao(self, contexto={}):
        from operator import itemgetter
        from datetime import datetime
        __ESC = chr(27)

        if not contexto:
            termx.clear()
            termx.say(1,1, '-2 REQUISICAO-', *self.color_header)
        while True:
            requisicao = self.get_req(contexto)
            if requisicao == __ESC:
                return False
            if not requisicao:
                args = [('state','=','P')]
            else:
                args = [('numero','=',str(requisicao)),('state','in', ('P','E'))]
            offset=0
            limit=[]
            order= 'data'
            requisicao_id = xmlrpc.execute('estoqueressuprimento.requisicao.capa', 'search', args, offset, limit, order)
            if not requisicao_id:
                continue
            if isinstance(requisicao_id, list):
                requisicao_id=requisicao_id[0]
            context = {'ressuprimento_alterar': True}
            if not contexto:  # o contexto eh passado apenas na opcao 4 (Separar e conferir)
                xmlrpc.execute('estoqueressuprimento.requisicao.capa', 'write', int(requisicao_id), {'state':'E'}, context)

            campos = ['numero','company_id','local_saida_id','requisicao_itens_ids', 'state']
            requisicao_dados = xmlrpc.execute('estoqueressuprimento.requisicao.capa', 'read', int(requisicao_id), campos)
            if isinstance(requisicao_dados, list):
                requisicao_dados=requisicao_dados[0]
            termx.clear(2)
            ano = requisicao_dados.get('numero')[3:7]
            numero = requisicao_dados.get('numero')[8:]
            termx.say(2,1, 'Ano:%s' % str(ano))
            termx.say(2,10, 'No.:')
            termx.say(2,14, numero,*self.color_input)
            termx.say(3,1, 'Emp.Sai.:')
            termx.say(3,11, str(requisicao_dados.get('company_id')[0]), *self.color_input)
            termx.say(3,14, 'LS:')
            termx.say(3,17, str(requisicao_dados.get('local_saida_id')[0]),*self.color_input)
            args = [('id','in',requisicao_dados.get('requisicao_itens_ids')), ('ja_confirmada','=', False)]
            requisicao_itens_ids = xmlrpc.execute('estoqueressuprimento.requisicao.itens', 'search', args)
            campos =['produto_id','grade_id', 'quantidade_requisitada', 'embalagem_id']
            requisicao__itens_dados =  xmlrpc.execute('estoqueressuprimento.requisicao.itens', 'read', requisicao_itens_ids, campos)
            if not requisicao__itens_dados:
                state = {'state': 'S'}
                xmlrpc.execute('estoqueressuprimento.requisicao.capa', 'write', int(requisicao_id), state, context)
            itens_agrupados = {}
            lista_locacao = []
            grade_embalagem = {}
            grade_qtd = {}
            grade_req_item_ids = {}
            for item in requisicao__itens_dados:
                prod_id = int(item.get('produto_id')[0])
                grade_id = int(item.get('grade_id')[0])
                args =  [('company_id','=',int(requisicao_dados.get('company_id')[0])),
                         ('produto_id','=', prod_id),
                         ('grade_id','=', grade_id),
                         ('local_id','=',int(requisicao_dados.get('local_saida_id')[0]))]
                local_locacao_id = xmlrpc.execute('estoque.local.locacao', 'search', args)
                if local_locacao_id and isinstance(local_locacao_id, list):
                    local_locacao_id=local_locacao_id[0]
                campos=['locacao','estllc_produto_embalagem_id']
                local_locacao_dados = xmlrpc.execute('estoque.local.locacao', 'read', local_locacao_id, campos)
                if isinstance(local_locacao_dados, list):
                    local_locacao_dados=local_locacao_dados[0]

                if not itens_agrupados or not str(local_locacao_dados.get('locacao')) in lista_locacao:
                    itens_agrupados[str(local_locacao_dados.get('locacao'))] = []
                itens_agrupados[str(local_locacao_dados.get('locacao'))].append(grade_id)
                grade_embalagem[str(grade_id)] = local_locacao_dados.get('estllc_produto_embalagem_id')[0]
                grade_qtd[str(grade_id)] = item.get('quantidade_requisitada')
                grade_req_item_ids[str(grade_id)] = item.get('id')
                if not local_locacao_dados.get('locacao') in lista_locacao:
                    lista_locacao.append(str(local_locacao_dados.get('locacao')))
            context = {'ressuprimento_alterar': True}
            itens_agrupados = sorted(itens_agrupados.items(), key=itemgetter(0)) # ordena dicionario pelas ordem alfabetica das chaves
            while True:
                if contexto and contexto.get('separar_conferir'):
                    args = [('id','=',requisicao_id),('resrca_com_pendencia','=',True)]
                    if not xmlrpc.execute('estoqueressuprimento.requisicao.capa', 'search', args):
                            state = {'state': 'F'}
                            xmlrpc.execute('estoqueressuprimento.requisicao.capa', 'write', int(requisicao_id), state,context)
                            termx.clear(2)
                            termx.say(3,3,'A requisicao foi')
                            termx.say(4,3,'separada e ')
                            termx.say(5,3,'conferida.')
                            termx.say(8,15,'ENTER', *self.color_destaque)
                            termx.get(8,20,0)
                            break
                else:
                    args = [('id','in',requisicao_dados.get('requisicao_itens_ids')), ('ja_confirmada','=', False)]
                    requisicao_itens_ids = xmlrpc.execute('estoqueressuprimento.requisicao.itens', 'search', args)
                    if not requisicao_itens_ids:
                        state = {'state': 'S'}
                        xmlrpc.execute('estoqueressuprimento.requisicao.capa', 'write', int(requisicao_id), state,context)
                        termx.clear(2)
                        termx.say(3,3,'A requisicao')
                        termx.say(4,3,'    foi')
                        termx.say(5,3,'  separada!')
                        termx.say(8,15,'ENTER', *self.color_destaque)
                        termx.get(8,20,0)
                        break
                for loc in itens_agrupados:
                    for grade in loc[1]:
                        xmlrpc.execute('estoqueressuprimento.requisicao.itens', 'read', int(requisicao_id),campos)
                        campos = ['name','produto_id','grade']
                        grade_dados = xmlrpc.execute('estoque.produto.grade', 'read', int(grade),campos)
                        campos = ['codigo']
                        produto_dados = xmlrpc.execute('estoque.produto', 'read', int(grade_dados.get('produto_id')[0]),campos)
                        dados_prod_embalagem = xmlrpc.execute('estoque.produto.embalagem', 'read', int(grade_embalagem.get(str(grade))), ['embalagem_id'])
                        dados_emb_embalagem = xmlrpc.execute('estoque.embalagem', 'read', int(dados_prod_embalagem.get('embalagem_id')[0]), ['sigla', 'quantidade_na_embalagem'])
                        qtd_embalagem = dados_emb_embalagem.get('quantidade_na_embalagem')
                        qtd_requisitada = grade_qtd.get(str(grade))
                        termx.clear(2)
                        termx.say(2,1, 'Ano:%s' % str(ano))
                        termx.say(2,10, 'No.:')
                        termx.say(2,14, numero,*self.color_input)
                        termx.say(3,1, 'Emp.Sai.:')
                        termx.say(3,11, str(requisicao_dados.get('company_id')[0]), *self.color_input)
                        termx.say(3,14, 'LS:')
                        termx.say(3,17, str(requisicao_dados.get('local_saida_id')[0]),*self.color_input)
                        termx.say(4,1, str(produto_dados.get('codigo')), *self.color_input)
                        descricao = xmlrpc.execute('adm.utils', 'admutl_remover_acentuacao', grade_dados.get('name'))
                        termx.say(5,1, str(descricao))
                        termx.say(6,1, 'E:')
                        termx.say(6,4, str(qtd_embalagem).replace('.',','), *self.color_input)
                        termx.say(6,19, str(grade_dados.get('grade')), *self.color_input)
                        termx.say(7,1, 'Qtd:')
                        termx.say(7,6, str(qtd_requisitada/qtd_embalagem).replace('.',','), *self.color_input)
                        termx.say(8,15, 'ENTER', *self.color_destaque)
                        espera = termx.get(8,20,0)
                        if espera == __ESC:
                            return False
                        if contexto and contexto.get('separar_conferir'):
                            res = self.item_conferir_requisicao(requisicao_id, grade_dados,contexto)
                            # if res ==__ESC:
                            #     return False
                        else:
                            dict_req_item = {'ja_confirmada': True,}
                            xmlrpc.execute('estoqueressuprimento.requisicao.itens', 'write', int(grade_req_item_ids.get(str(grade))), dict_req_item, context)


    #----------- CONFERIR REQUISICAO ---------
    def conferir_requisicao(self):
        __ESC = chr(27)
        requisicao_id = self.inicio_conferir_requisicao()
        if requisicao_id == __ESC:
            return False
        self.item_conferir_requisicao(requisicao_id)

    def inicio_conferir_requisicao(self):
        __ESC = chr(27)
        context = {'ressuprimento_alterar': True}
        termx.clear()
        termx.say(1,1, '-CONFERE REQUISICAO-', *self.color_header)
        while True:
            requisicao = self.get_req()
            if requisicao == __ESC:
                return __ESC
            if not requisicao:
                continue
            args = [('numero','=',str(requisicao)),('state', 'in', ('S','M'))]
            requisicao_id = xmlrpc.execute('estoqueressuprimento.requisicao.capa', 'search', args)
            if not requisicao_id:
                continue
            if isinstance(requisicao_id, list):
                requisicao_id=requisicao_id[0]
            campos = ['numero','company_id','data','local_entrada_id','local_saida_id','requisicao_itens_ids']
            requisicao_dados = xmlrpc.execute('estoqueressuprimento.requisicao.capa', 'read', int(requisicao_id), campos)
            xmlrpc.execute('estoqueressuprimento.requisicao.capa', 'write', int(requisicao_id), {'state': 'M'},context)
            if isinstance(requisicao_dados, list):
                requisicao_dados=requisicao_dados[0]
            numero = requisicao_dados.get('numero')[8:]
            termx.say(2,10, 'No.:')
            termx.say(2,14, numero,*self.color_input)
            data = str(requisicao_dados.get('data'))[8:10] + '/' + str(requisicao_dados.get('data'))[5:7] + '/' + str(requisicao_dados.get('data'))[0:4]
            termx.say(3,1, 'Data:')
            termx.say(3,6, data, *self.color_input)
            termx.say(4,1, 'LS:')
            termx.say(4,4, str(requisicao_dados.get('local_saida_id')[0]), *self.color_input)
            termx.say(4,10, 'LE:')
            termx.say(4,13, str(requisicao_dados.get('local_entrada_id')[0]), *self.color_input)
            return requisicao_id

    def item_conferir_requisicao(self, requisicao_id, grade_dados={},contexto={}):
        __ESC = chr(27)
        context = {'ressuprimento_alterar': True}
        termx.clear(5)
        termx.say(5,1, 'Item:')
        while True:
            termx.clear(6)
            prod = termx.get(5,6,14)
            if prod == __ESC:
                return __ESC
            if not prod:
                continue
            if not prod.isdigit():
                continue
            prod = str(prod)
            while len(prod) < 14:
                prod = '0' + prod
            args = [('codigo_barra', '=', prod)]
            automacao_codigo_id = xmlrpc.execute('automacao.codigo.barra', 'search', args)
            if not automacao_codigo_id:
                termx.say(6,1, 'Este item nao esta')
                termx.say(7,1, 'cadastrado!')
                termx.say(8,15, 'ENTER',*self.color_destaque)
                termx.get(8,20,0)
                continue
            if isinstance(automacao_codigo_id,list):
                automacao_codigo_id=automacao_codigo_id[0]
            campos = ['produto_id', 'grade_id']
            dados_automacao = xmlrpc.execute('automacao.codigo.barra', 'read', int(automacao_codigo_id), campos)
            if dados_automacao and isinstance(dados_automacao, list):
                dados_automacao=dados_automacao[0]

            args = [('requisicao_id','=',int(requisicao_id)),('produto_id', '=', dados_automacao.get('produto_id')[0]),
                    ('grade_id', '=', dados_automacao.get('grade_id')[0])]
            item_requisicao_id = xmlrpc.execute('estoqueressuprimento.requisicao.itens', 'search', args)
            if not item_requisicao_id:
                termx.say(6,1, 'Este item nao esta')
                termx.say(7,1, 'na requisicao!')
                termx.say(8,15, 'ENTER',*self.color_destaque)
                termx.get(8,20,0)
                continue
            if grade_dados and grade_dados.get('id') != dados_automacao.get('grade_id')[0]: # verifica se a grade do item digitado eh a mesma do item da requisicao vindo de Separar e Conferir
                termx.say(6,1, 'Item diferente do')
                termx.say(7,1, 'requerido!')
                termx.say(8,15, 'ENTER',*self.color_destaque)
                termx.get(8,20,0)
                continue
            if isinstance(item_requisicao_id, list):
                item_requisicao_id=item_requisicao_id[0]
            grade_id = dados_automacao.get('grade_id')
            if grade_id and isinstance(grade_id, list):
                grade_id=grade_id[0]
            campos = ['name']
            grade_descricao = xmlrpc.execute('estoque.produto.grade', 'read', int(grade_id), campos)
            if grade_descricao and isinstance(grade_descricao, dict):
                grade_descricao=xmlrpc.execute('adm.utils', 'admutl_remover_acentuacao', grade_descricao.get('name'))
            termx.say(6,1, str(grade_descricao))
            campos = ['embalagem_id','quantidade_confirmada', 'quantidade_requisitada']
            dados_req_itens = xmlrpc.execute('estoqueressuprimento.requisicao.itens', 'read', int(item_requisicao_id), campos)
            if isinstance(dados_req_itens, list):
                dados_req_itens=dados_req_itens[0]
            prod_embalagem_id = dados_req_itens.get('embalagem_id')[0]
            if isinstance(prod_embalagem_id, list):
                prod_embalagem_id =prod_embalagem_id[0]
            dados_prod_embalagem = xmlrpc.execute('estoque.produto.embalagem', 'read', int(prod_embalagem_id), ['embalagem_id'])
            dados_emb_embalagem = xmlrpc.execute('estoque.embalagem', 'read', int(dados_prod_embalagem.get('embalagem_id')[0]), ['sigla', 'quantidade_na_embalagem'])

            qtd_embalagem = dados_emb_embalagem.get('quantidade_na_embalagem')
            qtd_requisitada = dados_req_itens.get('quantidade_requisitada')
            qts_item = 0      # quantidade do item que sera conferida
            while True:
                termx.clear(7)
                termx.say(7,1, 'E:')
                termx.say(7,3, str(qtd_embalagem).replace('.',','), *self.color_input)
                termx.say(7,4+len(str(qtd_embalagem)), dados_emb_embalagem.get('sigla'), *self.color_input)
                termx.say(7,13, 'Qtd:')
                qtd_confirmada = dados_req_itens.get('quantidade_confirmada')/qtd_embalagem+qts_item
                termx.say(8,1, 'Qtd.Conferida:')
                termx.say(8,15, str(qtd_confirmada).replace('.',','), *self.color_input)
                qts_item='1'
                if qtd_requisitada >= 10 :
                    qts_item = termx.get(7,17,4)
                else:
                    termx.say(7,17, '1', *self.color_input)
                    termx.get(8,20,0)
                if not qts_item:
                    qts_item = 0
                    continue
                if qts_item == __ESC:
                    break
                if not qts_item.isdigit():
                    qts_item = 0
                    continue
                qts_item = float(qts_item)
                if qts_item <= 0:
                    qts_item = 0
                    continue
                if qtd_requisitada >= 10 and float(qtd_confirmada)+qts_item > float(qtd_requisitada):
                    qts_item = 0
                    termx.clear(7)
                    termx.say(7,1,'Quantidade acima da')
                    termx.say(8,1,'requisitada!')
                    termx.say(8,15,'ENTER', *self.color_destaque)
                    termx.get(8,20,0)
                    continue
                dict_req_item = {'quantidade_confirmada': float(qtd_confirmada)+qts_item,}
                ja_confirmada = qtd_requisitada - (float(qtd_confirmada)+qts_item)
                if contexto and contexto.get('separar_conferir'):
                    if -0.001 < ja_confirmada and ja_confirmada < 0.001:    # qtd conferida = qtd confirmada
                        dict_req_item['ja_confirmada']= True
                xmlrpc.execute('estoqueressuprimento.requisicao.itens', 'write', int(item_requisicao_id), dict_req_item, context)
                xmlrpc.execute('estoqueressuprimento.requisicao.capa', 'write', int(requisicao_id), {},context)
                campos = ['resrca_com_pendencia']
                pendencia = xmlrpc.execute('estoqueressuprimento.requisicao.capa', 'read', int(requisicao_id), campos)
                if isinstance(pendencia, list):
                    pendencia = pendencia[0]
                if isinstance(pendencia, dict):
                    pendencia = pendencia.get('resrca_com_pendencia')
                if 'separar_conferir' not in contexto:
                    if not pendencia:
                        termx.clear(2)
                        termx.say(4,3,'   Requisicao')
                        termx.say(5,3,'   conferida!')
                        termx.say(8,15,'ENTER', *self.color_destaque)
                        termx.get(8,20,0)
                        return False     # Termina a conferencia da requisicao
                else:
                    args = [('id','=', item_requisicao_id),('ja_confirmada','=',True)]
                    ja_confirmada = xmlrpc.execute('estoqueressuprimento.requisicao.itens', 'search', args)
                    if ja_confirmada:
                        termx.clear(2)
                        termx.say(4,3,'   Separado')
                        termx.say(5,3,'      e')
                        termx.say(6,3,'   Conferido')
                        termx.say(8,15,'ENTER', *self.color_destaque)
                        termx.get(8,20,0)
                        return __ESC      # Pula para o proximo item
                break
        return False
    # ---------------------- FIM DA CONFERENCIA ---------------------------

    def separar_conferir(self):
        termx.clear()
        termx.say(1,1, '-SEPARAR E CONFERIR-', *self.color_header)
        contexto = {'separar_conferir': True}
        self.separar_requisicao(contexto)
        return False

    def requisicao_compra(self):
        __ESC = chr(27)
        user_id = xmlrpc.login_id
        company_id = xmlrpc.execute('res.users', 'read', int(user_id), ['company_id'], {},
                                    '_classic_write').get('company_id')
        requisicao_id = False
        termx.clear()
        termx.say(1,1, '-REQUISICAO COMPRA-', *self.color_header)
        while True:
            termx.clear(2)
            termx.say(2, 1, 'ITEM:')
            prod = termx.get(2, 7, 14)
            if not prod:
                continue
            if prod == __ESC:
                self.show_req_compra(requisicao_id)
                return False
            if not prod.isdigit():
                continue
            prod = str(prod)
            while len(prod) < 14:
                prod = '0' + prod
            args = [('codigo_barra', '=', prod)]
            automacao_codigo_id = xmlrpc.execute('automacao.codigo.barra', 'search', args)
            if not automacao_codigo_id:
                termx.say(6, 1, 'Este item nao esta')
                termx.say(7, 1, 'cadastrado!')
                termx.say(8, 15, 'ENTER', *self.color_destaque)
                termx.get(8, 20, 0)
                continue

            qtd = False
            while not qtd:
                termx.clear(3)
                termx.say(3, 1, 'QUANTIDADE:')
                qtd = termx.get(3, 12, 8)
                if not qtd:
                    continue

                break

            if not qtd or qtd == __ESC:
                continue

            automacao_codigo_id = automacao_codigo_id[0]
            campos = ['produto_id', 'grade_id', 'produto_embalagem_id']
            dados_automacao = xmlrpc.execute('automacao.codigo.barra', 'read',
                                             int(automacao_codigo_id), campos,
                                             {}, '_classic_write')

            grade_id = int(dados_automacao.get('grade_id'))
            prod_embalagem_id = int(dados_automacao.get('produto_embalagem_id'))
            if isinstance(prod_embalagem_id, list):
                prod_embalagem_id = prod_embalagem_id[0]

            if not requisicao_id:
                requisicao_id = xmlrpc.execute('compras.requisicao.capa', 'create', {'company_id': company_id})

            xmlrpc.execute('compras.requisicao.itens', 'create', {'requisicao_id': requisicao_id,
                                                                 'produto_id': dados_automacao.get('produto_id'),
                                                                 'grade_id': grade_id,
                                                                 'comrit_produto_embalagem_id': prod_embalagem_id,
                                                                 'quantidade': qtd})
            termx.say(6, 1, 'Item Adicionado!')
            termx.say(8, 15, 'ENTER', *self.color_destaque)
            termx.get(8, 20, 0)
            continue

        self.show_req_compra(requisicao_id)
        return False

    def show_req_compra(self, req_id):
        if req_id:
            campos = ['numero']
            numero = xmlrpc.execute('compras.requisicao.capa', 'read', int(req_id), campos).get('numero')
            termx.say(5, 1, 'Requisicao de Compra')
            termx.say(6, 1, 'Criada!')
            termx.say(7, 1, 'No.:')
            termx.say(7, 6, str(numero))
            termx.say(8, 15, 'ENTER', *self.color_destaque)
            termx.get(8, 20, 0)
            return False

Requisicao()

