#!/usr/bin/python
# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz:siginformatica.com.br>
                                -------

"""

from coletor import termx, xmlrpc
__version__ = (0, 1)


class Separar_Pedido(object):
    """
    Requisicao.

    """
    # Cores utilizadas
    color_input = termx.bold, termx.underline, termx.fg_white  # Branco intenso/sublinhado
    color_title = termx.underline,  # Branco (sublinhado)
    color_header = termx.fg_cyan,  # Azul claro
    color_destaque = termx.bold, termx.fg_white,  # Branco em negrito
    color_field = termx.underline, termx.fg_green,  # Verde (sublinhado)
    color_info = termx.reverse, termx.fg_cyan,  # Preto/azul claro
    color_list_os = termx.bold, termx.fg_yellow, termx.underline,  # Amarelo claro (sublinhado)
    color_os = termx.fg_yellow,  # Amarelo
    color_msg_ok = termx.fg_green,  # Verde claro
    line_error = termx.max_row  # Linha onde sao mostradas as mensagens de erro
    line_info = line_error  # Linha onde sao mostradas as informacoes
    rec_sucess = True  # Enderecamento efetuado com sucesso
    rec_continue = False  # O enderecamento continua

    def __init__(self):
        self.separar()
        termx.clear()
        termx.say(1, 1, 'SigERP-Coletor V-%s.%s' % __version__, *self.color_title)
    def separar(self):
        from operator import itemgetter
        __ESC = chr(27)

        termx.clear(1)
        termx.say(1, 1, '-- Separar Pedido --', *self.color_header)
        termx.say(2, 1, 'No:')
        while True:
            termx.clear(3)
            numero_pedido = termx.get(2,4,11)
            if numero_pedido == __ESC:
                return False
            if not numero_pedido:
                args = [('state', '=', 'V'), ('tipo', '=', 'V')]
            else:
                aux = 'PVE-'
                while len(aux)+len(str(numero_pedido)) < 14:
                    aux += '0'
                aux += str(numero_pedido)
                numero_pedido=aux
                args = [('numero_pedido', '=', numero_pedido), ('state', 'in', ('V','S'))]
            offset=0
            limit=1
            order='data_emissao'
            pedido_capa_id = xmlrpc.execute('estoquepedidos.pedido.capa', 'search', args, offset, limit, order)
            if not pedido_capa_id:
                continue
            if isinstance(pedido_capa_id, list):
                pedido_capa_id=pedido_capa_id[0]
            campos = ['numero_pedido','pedido_item_ids']
            pedido_capa_dados = xmlrpc.execute('estoquepedidos.pedido.capa', 'read', int(pedido_capa_id), campos)
            pedido_itens_ids = []
            if pedido_capa_dados and isinstance(pedido_capa_dados, list):
                pedido_capa_dados=pedido_capa_dados[0]
            if pedido_capa_dados and isinstance(pedido_capa_dados, dict):
                pedido_itens_ids = pedido_capa_dados.get('pedido_item_ids')
            numero_pedido = pedido_capa_dados.get('numero_pedido')
            termx.say(2,4, str(numero_pedido), *self.color_input)
            if not pedido_itens_ids:
                termx.say(4,1,'Este pedido nao')
                termx.say(5,1,'possui itens')
                termx.say(8,15, 'ENTER',*self.color_destaque)
                termx.get(8,20,0)
                continue
            xmlrpc.execute('estoquepedidos.pedido.capa', 'write', int(pedido_capa_id), {'state':'S'})
            user_id = xmlrpc.login_id
            campos = ['company_id']
            company_id = xmlrpc.execute('res.users', 'read', int(user_id), campos)
            if company_id and isinstance(company_id, list):
                company_id=company_id[0]
            if company_id and isinstance(company_id, dict):
                company_id=company_id.get('company_id')

            campos = ['produto_id','grade_id', 'local_id', 'qtde_atendida','qtde_pedida']
            itens_dados = xmlrpc.execute('estoquepedidos.pedido.item', 'read', pedido_itens_ids, campos)
            locacao = {}
            for item in itens_dados:
                produto_id = item.get('produto_id')[0]
                grade_id = item.get('grade_id')[0]
                local_id = item.get('local_id')[0]
                args = [('company_id', '=', company_id),('produto_id', '=', produto_id),('grade_id', '=', grade_id),('local_id', '=', local_id)]
                local_locacao_id = xmlrpc.execute('estoque.local.locacao', 'search', args)
                if local_locacao_id and isinstance(local_locacao_id, list):
                    local_locacao_id=local_locacao_id[0]
                campos=['locacao']
                local_locacao =  xmlrpc.execute('estoque.local.locacao', 'read', int(local_locacao_id), campos)
                if local_locacao and isinstance(local_locacao, list):
                    local_locacao=local_locacao[0]
                if local_locacao and isinstance(local_locacao, dict):
                    local_locacao=local_locacao.get('locacao')
                if not local_locacao in locacao.keys():
                    locacao[local_locacao] = []
                codigo_item = xmlrpc.execute('estoque.produto', 'read', int(produto_id), ['codigo'])[0].get('codigo')
                descricao = xmlrpc.execute('estoque.produto.grade', 'read', int(grade_id), ['name']).get('name')
                descricao = xmlrpc.execute('adm.utils', 'admutl_remover_acentuacao', descricao)
                qtde_atendida = item.get('qtde_atendida')
                qtd_pedida = item.get('qtde_pedida')
                dict_produto = {'item_id': item.get('id'),
                                'produto_id': produto_id,
                                'grade_id': grade_id,
                                'local_id': local_id,
                                'codigo_item':codigo_item,
                                'descricao':descricao,
                                'qtde_atendida':qtde_atendida,
                                'qtd_pedida':qtd_pedida,
                                }
                locacao[local_locacao].append(dict_produto)
            locacao = sorted(locacao.items(), key=itemgetter(0)) # ordena dicionario pelas ordem alfabetica das chaves

            for loc in locacao:
                for l in loc[1]:
                    while True:
                        campos = ['qtde_atendida']
                        qtde_atendida = xmlrpc.execute('estoquepedidos.pedido.item', 'read', int(l.get('item_id')), campos)
                        if qtde_atendida and isinstance(qtde_atendida, list):
                            qtde_atendida=qtde_atendida[0]
                        if qtde_atendida and isinstance(qtde_atendida, dict):
                            qtde_atendida=qtde_atendida.get('qtde_atendida') or 0
                        alfa = l.get('qtd_pedida') - qtde_atendida
                        if -0.001 < alfa and alfa < 0.001:
                            break
                        termx.clear(3)
                        termx.say(3, 1, 'Locacao:')
                        termx.say(3, 9, str(loc[0]) , *self.color_input)
                        termx.say(4, 1, 'Cod.:')
                        termx.say(4, 6, str(l.get('codigo_item')), *self.color_input)
                        termx.say(5, 1, str(l.get('descricao')) , *self.color_destaque)
                        termx.say(6, 1, 'Qtd. pedida:')
                        termx.say(6, 13, str(l.get('qtd_pedida')).replace('.',','), *self.color_input)
                        termx.say(7, 1, 'Qtd. Separada:')
                        termx.say(7, 15, str(qtde_atendida).replace('.',','), *self.color_input)
                        termx.say(8, 1, 'Item:')
                        cod_bar = termx.get(8, 7, 14)
                        if not cod_bar:
                            continue
                        if cod_bar == __ESC:
                            return
                        if not cod_bar.isdigit():
                            continue
                        cod_bar = str(cod_bar)
                        while len(cod_bar) < 14:
                            cod_bar = '0' + cod_bar
                        args = [('codigo_barra', '=', cod_bar)]
                        automacao_codigo_id = xmlrpc.execute('automacao.codigo.barra', 'search', args)
                        if not automacao_codigo_id:
                            termx.clear(3)
                            termx.say(4,1, 'Este item nao esta')
                            termx.say(5,1, 'cadastrado!')
                            termx.say(8,15, 'ENTER',*self.color_destaque)
                            termx.get(8,20,0)
                            continue
                        if isinstance(automacao_codigo_id,list):
                            automacao_codigo_id=automacao_codigo_id[0]
                        campos = ['produto_id']
                        dados_automacao = xmlrpc.execute('automacao.codigo.barra', 'read', int(automacao_codigo_id), campos)
                        if dados_automacao and isinstance(dados_automacao, list):
                            dados_automacao=dados_automacao[0]
                        if l.get('produto_id') != int(dados_automacao.get('produto_id')[0]):
                            termx.clear(3)
                            termx.say(4, 1, ' Este produdo nao')
                            termx.say(5, 1, ' condiz com o ')
                            termx.say(6, 1, ' solicitado')
                            termx.say(8,15, 'ENTER',*self.color_destaque)
                            termx.get(8,20,0)
                            continue
                        if l.get('qtd_pedida') > 10:
                            while True:
                                qtde_atendida = termx.get(7,15,4)
                                if not qtde_atendida:
                                    continue
                                if qtde_atendida == __ESC:
                                    return False
                                if not qtde_atendida.isdigit():
                                    continue
                                alfa = float(qtde_atendida) - float(l.get('qtd_pedida'))
                                if -0.001 < alfa and alfa < 0.001:
                                    break

                        else:
                            qtde_atendida+=1
                        xmlrpc.execute('estoquepedidos.pedido.item', 'write', int(l.get('item_id')), {'qtde_atendida':qtde_atendida})

            if not locacao:
                termx.clear(3)
                termx.say(4,3, 'Pedido sem itens')
                termx.say(8,15, 'ENTER',*self.color_destaque)
                termx.get(8,20,0)
                continue
            termx.clear(3)
            termx.say(5,2, 'Pedido separado')
            termx.say(6,2, 'com sucesso')
            termx.say(8,15, 'ENTER',*self.color_destaque)
            termx.get(8,20,0)
            xmlrpc.execute('estoquepedidos.pedido.capa', 'write', int(pedido_capa_id), {'state':'D'})

Separar_Pedido()

