# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import base64
import xlrd
import logging
from openerp.tools.translate import _

class compras_cotacoes_capa(osv.Model):
    """
    Tabela de cotacao
    """
    _name = 'compras.cotacoes.capa'
    _inherit = 'compras.cotacoes.capa'
    _log = logging.getLogger(_name)

    def sequence_criar(self, cr, uid, context=None):
        context = context and context.copy() or {}
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
        __code = 'numero_cotacao.compra'
        __name = 'Numero Cotacao'
        vals = {
            'name': __name,
            'code': __code,
            'padding': 6,
            'prefix': 'COT-%(year)s-',
            'company_id': company_id,
            'implementation': 'no_gap',
        }
        # Gerar sequence para orcamento para a empresa
        consulta = self.pool.get('ir.sequence').search(cr, uid, [('code', '=', __code), ('company_id', '=', company_id)], context=context)
        if not consulta:
            self.pool.get('ir.sequence').create(cr, uid, vals, context)
        return True

    def button_gerar_xls(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        for id in ids:
            obj_com_cot_ema = self.pool.get('compras.cotacoes.email.osv')
            xml = obj_com_cot_ema._gerar_xml(cr, uid, id, context)
            self.write(cr, uid, id, {'file_cotacao_xls': xml}, context=context)
        if not context.get('requisicao'):
            res = True
        else:
            obj_model_data = self.pool.get('ir.model.data')
            reference = obj_model_data.get_object_reference(cr, uid, 'compras',
                                                            'view_compras_cotacoes_capa_form')
            view_id = reference and reference[1] or False
            res = {
                'name': 'Cotacao',
                'view_type': 'form',
                'view_mode': 'form',
                'res_model': 'compras.cotacoes.capa',
                'view_id': [view_id],
                'res_id': ids[0],
                'target': 'new',
                'type': 'ir.actions.act_window'
            }
        return res

    def button_enviar_xls_email(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        for id in ids:
            encode_xls = self.read(cr, uid, id, ['file_cotacao_xls'], context=context)
            if not encode_xls['file_cotacao_xls']:
                self.button_gerar_xls(cr, uid, ids, context)
            self.pool.get('compras.cotacoes.email.osv').enviar(cr, uid, id, context)
        return True

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
            # SEQUENCE NRO DA COTACAO
        vals['numero'] = self.pool.get('adm.utils').get_sequence(cr, uid, self._name, 'numero_cotacao.compra')
        res = super(compras_cotacoes_capa, self).create(cr, uid, vals, context)
        self.message_post(cr, uid, res, 'Documento', _('Cotacao criada'))
        return res

    def button_xls(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_iten = self.pool.get('compras.cotacoes.itens')
        for id in ids:
            encode_xls = self.read(cr, uid, id, ['file_import_xls'], context=context)
            if not encode_xls['file_import_xls']:
                raise osv.except_osv(_('Atencao'), _('E necessario carregar o Arquivo de Cotacao'))
            file_decode = base64.decodestring(encode_xls['file_import_xls'])
            filename = self.read(cr, uid, id, ['file_name'], context=context)['file_name']
            try:
                f = open('/tmp/' + filename, 'w')
                f.write(file_decode)
                f.close()
                wb = xlrd.open_workbook('/tmp/' + filename)
            except Exception as e:
                self._log.error(str(e))
                raise osv.except_osv(_('Atencao'), _('Arquivo de Cotacao invalido.\nMais informacoes no log do sistema.'))
            ws = wb.sheet_by_index(0)
            lin = 12
            while True:
                try:
                    cotacao_item_id = int(ws.cell_value(lin, 10)).__abs__()
                except:
                    cotacao_item_id = ""
                if str(cotacao_item_id).isdigit():
                    cotacao_item_id = int(cotacao_item_id)
                    codigo_item = str(ws.cell_value(lin, 0))
                    valor = ws.cell_value(lin, 8)
                    qtd = ws.cell_value(lin, 3)
                    icms = ws.cell_value(lin, 6)
                    ipi = ws.cell_value(lin, 7)
                    valid = ws.cell_value(lin, 5)
                    vals = {'vr_unitario': valor if isinstance(valor, (float, int))  else 0,
                            'quantidade': qtd if isinstance(qtd, (float, int)) else 0,
                            'valor': 0, # Forca o calculo do valor Total.
                            'icms': icms if isinstance(icms, (float, int)) else 0,
                            'ipi': ipi if isinstance(ipi, (float, int)) else 0,
                            'validade': ipi if isinstance(valid, (float, int)) else 0,
                            'state': 'C'}
                    id_s = obj_iten.search(cr, uid, [('id', '=', cotacao_item_id)], context=context)
                    if id_s:
                        obj_iten.write(cr, uid, cotacao_item_id, vals, context)
                    else:
                        raise osv.except_osv(_('Atencao'),
                                             _('Requisicao Item: {0}. Nao encontrado na cotacao').format(codigo_item))
                else:
                    break
                lin += 1
            lin += 4
            data_valid = ws.cell_value(lin + 1, 4)
            if data_valid:
                try:
                    data_valid = xlrd.xldate_as_tuple(ws.cell_value(lin + 1, 4), 0)
                    data_valid = '%s-%s-%s' % (data_valid[2], data_valid[1], data_valid[0])
                except Exception:
                    data_valid = False
            else:
                data_valid = False
            prazo_entrega = ws.cell_value(lin + 2, 4)
            tipo_frete = ws.cell_value(lin, 8)[:1].upper()
            frete_valor = ws.cell_value(lin + 1, 8)
            despesas_acessorias = ws.cell_value(lin + 2, 8)
            outras_despesas = ws.cell_value(lin + 3, 8)
            vals = {'prazo_entrega': prazo_entrega if isinstance(prazo_entrega, (float, int))
                    else 0,
                    'tipo_frete': tipo_frete if tipo_frete.isdigit() else 0,
                    'frete_valor': frete_valor if isinstance(frete_valor, (float, int)) else 0,
                    'despesas_acessorias': despesas_acessorias if isinstance(despesas_acessorias,
                                                                             (float, int)) else 0,
                    'outras_despesas': outras_despesas if isinstance(outras_despesas,
                                                                     (float, int)) else 0,
                    'data_validade': data_valid}
            self.write(cr, uid, id, vals, context)
            self.message_post(cr, uid, id, 'Sincronizacao', _('Cotacao sincronizada com sucesso'))
        return True

    def comcit_aprovar_item(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, list):
            ids = ids[0]
        obj_compras_cotacoes_itens = self.pool.get('compras.cotacoes.itens')
        obj_compras_requisicao_itens = self.pool.get('compras.requisicao.itens')
        cotacoes_capa_dados = self.browse(cr, uid, ids)
        for i in cotacoes_capa_dados.cotacoes_itens_ids:
            if not i.vr_unitario or not i.quantidade:
                raise osv.except_osv(_('Atencao'), _('O valor total do item deve ser maior que zero'))
            obj_compras_cotacoes_itens.write(cr, uid, i.id, {'state': 'T'}, context=context)
            obj_compras_requisicao_itens.write(cr, uid, i.requisicao_itens_id.id,
                                               {'fornecedor': i.cotacao_id.fornecedor_id.pessoa_id.name or '',
                                                'numero_cotacao': i.cotacao_id.numero}, context=context)
        self.write(cr, uid, ids, {'comccp_aprovado': True}, context=context)
        self.message_post(cr, uid, ids, 'Documento', _('Cotacao aprovada'))
        return True

    def botao_atualizar(self, cr, uid, ids, context=None):
        if isinstance(ids, list):
            ids = ids[0]
        context = context and context.copy() or {}
        if not context.get('requisicao'):
            res = True
        else:
            obj_model_data = self.pool.get('ir.model.data')
            reference = obj_model_data.get_object_reference(cr, uid, 'compras',
                                                            'view_compras_cotacoes_capa_form')
            view_id = reference and reference[1] or False
            res = {
                'name': 'Cotacao',
                'view_type': 'form',
                'view_mode': 'form',
                'res_model': 'compras.cotacoes.capa',
                'view_id': [view_id],
                'res_id': ids,
                'target': 'new',
                'type': 'ir.actions.act_window',
                }
        return res

    def botao_salvar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return True
