# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
import email
from lxml import etree
from email.MIMEMultipart import MIMEMultipart
from email.MIMEBase import MIMEBase
from email.MIMEText import MIMEText
from email.Utils import formatdate
from email import Encoders
from smtplib import SMTP
from imaplib import IMAP4, IMAP4_SSL
import xlwt
import os
from datetime import datetime
from openerp.tools.translate import _
import base64


class compras_cotacoes_email_osv(osv.TransientModel):
    _name = "compras.cotacoes.email.osv"

    _html_body_template = "<html><head><title>cotacao</title></head><body><p>Boa tarde,</p><p>Segue anexo formulário para cotacao.</p></body></html>"

    def enviar(self, cr, uid, cotacao_id, context=None):
        context = context and context.copy() or {}

        obj_cotacao = self.pool.get('compras.cotacoes.capa').browse(cr, uid, cotacao_id)
        o_cotacao = self.pool.get('compras.cotacoes.capa')
        # Se os parâmetros para envio de email nao estiverem configurados abandona operacao, sem
        # gerar mensagem de erro.
        if obj_cotacao.company_id.servidor_smtp_id:
            param_ids = [obj_cotacao.company_id.servidor_smtp_id.id]
        else:
            param_ids = self.pool.get('ir.mail_server').search(cr, uid, args=[], order='sequence asc',
                                                               limit=1, context=context)
        if not param_ids:
            raise osv.except_osv(_('Atencao'), _('Configure os parametros de email'))
        filename = (obj_cotacao.numero or 'cotacao')
        msg = MIMEMultipart()
        msg['From'] = obj_cotacao.company_id.rescon_pessoa_id.email
        msg['To'] = obj_cotacao.fornecedor_id.pessoa_id.email
        msg['Date'] = formatdate(localtime=True)
        msg['Subject'] = "Cotacao - %s" % filename
        msg.attach(MIMEText(self._html_body_template, 'html'))
        # anexo / Gera arquivo de cotacao
        anexo = MIMEBase('application', 'octet-stream')
        anexo.set_payload(base64.decodestring(obj_cotacao.file_cotacao_xls))
        Encoders.encode_base64(anexo)
        anexo.add_header('Content-Disposition', 'attachment', filename=filename + '.xls')
        msg.attach(anexo)
        # email do fornecedor nao configurado: bypass
        if not obj_cotacao.fornecedor_id.pessoa_id.email:
            raise osv.except_osv(_('Atencao'),
                                 _('O fornecedor: %s. Nao possui email cadastrado') %
                                 obj_cotacao.fornecedor_id.pessoa_id.name)
        ret = self.mail_send(cr, uid, obj_cotacao.company_id.id, msg, smtp_server_id=param_ids[0], context=context)
        if ret:
            msg = _('E-mail para: %s. Enviado com sucesso!') % \
                  obj_cotacao.fornecedor_id.pessoa_id.email
            self.log(cr, uid, cotacao_id, msg)
            o_cotacao.write(cr, uid, cotacao_id, {'data_email': datetime.now()}, context=context)
        else:
            raise osv.except_osv(_('Atencao'), msg)
        return True

    def _gerar_formulario(self, cr, uid, cotacao_id, context=None):
        #gerar xml
        context = context and context.copy() or {}
        dados_xml = self._gerar_xml(cr, uid, cotacao_id, context)
        return dados_xml

    def _gerar_xml(self, cr, uid, cotacao_id, context=None):
        context = context and context.copy() or {}
        context['retorno_sem_codigo'] = True
        print('*', cotacao_id)
        if cotacao_id:
            obj_cotacao = self.pool.get('compras.cotacoes.capa').browse(cr, uid, cotacao_id, context)
            if obj_cotacao:
                #dados do Cliente;
                razaoSocialCliente = obj_cotacao.company_id.name
                nomeFantasiaCliente = obj_cotacao.company_id.name
                emailCliente = obj_cotacao.company_id.rescon_pessoa_id.email
                enderecoCliente = obj_cotacao.company_id.rescon_pessoa_id.endereco

                #dados Fornecedor
                razaoSocialFornecedor = obj_cotacao.fornecedor_id.company_id.name
                nomeFantasiaFornecedor = obj_cotacao.fornecedor_id.pessoa_id.name
                emailFornecedor = obj_cotacao.fornecedor_id.pessoa_id.email
                enderecoFornecedor = obj_cotacao.fornecedor_id.pessoa_id.endereco
                #### Criacao de Planilha Excel #####
                wb = xlwt.Workbook(encoding='utf8')
                ws = wb.add_sheet('Cotacao')
                ######## Definicao dos Estilos ######
                font0 = xlwt.Font()
                font0.name = 'Times New Roman'
                font0.height = 480
                font0.colour_index = 0
                font0.bold = True
                font0.shadow = True
                font1 = xlwt.Font()
                font1.name = 'Times New Roman'
                font1.height = 200
                font1.bold = False
                font1.shadow = False
                font2 = xlwt.Font()
                font2.name = 'Times New Roman'
                font2.height = 200
                font2.bold = True
                font2.shadow = False
                font3 = xlwt.Font()
                font3.name = 'Times New Roman'
                font3.height = 200
                font3.bold = True
                font3.shadow = False

                # Bloqueia toda a aba da planilha
                ws.protect = True  # defaults to False
                # Define a senha de bloqueio
                ws.password = "1357"
                pattern = xlwt.Pattern() # Create the Pattern
                pattern.pattern = xlwt.Pattern.SOLID_PATTERN
                pattern.pattern_fore_colour = 0x18 # cor de fundo da celula

                borders = xlwt.Borders() # Create Borders
                borders.left = xlwt.Borders.THIN # May be: NO_LINE, THIN, MEDIUM, DASHED, DOTTED, THICK, DOUBLE, HAIR, MEDIUM_DASHED, THIN_DASH_DOTTED, MEDIUM_DASH_DOTTED, THIN_DASH_DOT_DOTTED, MEDIUM_DASH_DOT_DOTTED, SLANTED_MEDIUM_DASH_DOTTED, or 0x00 through 0x0D.
                borders.right = xlwt.Borders.THIN
                borders.top = xlwt.Borders.THIN
                borders.bottom = xlwt.Borders.THIN

                # Cria um estilo para desbloquear uma celula
                styleDesbloqueado1 = xlwt.easyxf("protection: cell_locked false;")  # igual a style4 mas desbloqueado
                styleDesbloqueado1.font = font3
                styleDesbloqueado1.num_format_str = '_(#,##0.00_);(#,##0.00)'
                styleDesbloqueado2 = xlwt.easyxf("protection: cell_locked false;")  # igual a style7 mas desbloqueado
                styleDesbloqueado2.font = font1
                styleDesbloqueado2.alignment.horz = xlwt.Alignment.HORZ_RIGHT
                styleDesbloqueado3 = xlwt.easyxf("protection: cell_locked false;")  # igual a style3 mas desbloqueado
                styleDesbloqueado3.font = font3
                styleDesbloqueado4 = xlwt.easyxf("protection: cell_locked false;")  # igual a style6 mas desbloqueado
                styleDesbloqueado4.font = font3
                styleDesbloqueado4.num_format_str = '_(#,##0_);(#,##0)'
                styleDesbloqueado5 = xlwt.easyxf("protection: cell_locked false;")  # igual a style9 mas desbloqueado
                styleDesbloqueado5.font = font3
                styleDesbloqueado5.num_format_str = '_("%" #,##0_);(#,##0)'
                styleDesbloqueado6 = xlwt.easyxf("protection: cell_locked false;")  # igual a style8 mas desbloqueado
                styleDesbloqueado6.font = font3
                styleDesbloqueado6.num_format_str = 'DD/MM/YYYY'
                styleDesbloqueado1.pattern = pattern
                styleDesbloqueado2.pattern = pattern
                styleDesbloqueado3.pattern = pattern
                styleDesbloqueado4.pattern = pattern
                styleDesbloqueado5.pattern = pattern
                styleDesbloqueado6.pattern = pattern
                styleDesbloqueado1.borders = borders
                styleDesbloqueado2.borders = borders
                styleDesbloqueado3.borders = borders
                styleDesbloqueado4.borders = borders
                styleDesbloqueado5.borders = borders
                styleDesbloqueado6.borders = borders
                # Cria um estilo para bloquear uma celula
                read_only = xlwt.easyxf("")  # "cell_locked true" is default

                style0 = xlwt.XFStyle()
                style0.font = font0
                style0.alignment.horz = xlwt.Alignment.HORZ_CENTER
                style0.alignment.vert = xlwt.Alignment.VERT_CENTER
                style1 = xlwt.XFStyle()
                style1.font = font1
                style2 = xlwt.XFStyle()
                style2.font = font2
                style3 = xlwt.XFStyle()
                style3.font = font3
                #style3.num_format_str = '_("$"* #,##0.00_);_("$"* (#,##0.00))'
                style3.num_format_str = '_("$"* #,##0.00_);_("$"* (#,##0.00))'
                style4 = xlwt.XFStyle()
                style4.font = font3
                style4.num_format_str = '_(#,##0.00_);(#,##0.00)'
                style5 = xlwt.XFStyle()
                style5.font = font3
                style5.alignment.horz = xlwt.Alignment.HORZ_RIGHT
                style6 = xlwt.XFStyle()
                style6.font = font3
                style6.num_format_str = '_(#,##0_);(#,##0)'
                style7 = xlwt.XFStyle()
                style7.font = font1
                style7.alignment.horz = xlwt.Alignment.HORZ_RIGHT
                style8 = xlwt.XFStyle()
                style8.font = font3
                style8.num_format_str = 'DD/MM/YYYY'
                style9 = xlwt.XFStyle()
                style9.font = font3
                style9.num_format_str = '_("%" #,##0_);(#,##0)'
                #####################
                ##### CAbecalho #####
                ws.row(0).height = 500
                ws.col(1).width = 17000
                ws.write_merge(0, 0, 0, 9, 'Cliente', style0)
                ws.write(1, 0, 'Nome :', style1)
                ws.write(2, 0, 'Endereco :', style1)
                ws.write(3, 0, 'E-mail :', style1)
                ws.write_merge(1, 1, 1, 9, '%s' % razaoSocialCliente, style1)
                ws.write_merge(2, 2, 1, 9, '%s' % enderecoCliente, style1)
                ws.write_merge(3, 3, 1, 9, '%s' % emailCliente, style1)
                ws.row(5).height = 500
                ws.write_merge(5, 5, 0, 9, 'Fornecedor', style0)
                ws.write(6, 0, 'Nome :', style1)
                ws.write(7, 0, 'Endereco :', style1)
                ws.write(8, 0, 'E-mail :', style1)
                ws.write_merge(6, 6, 1, 9, '%s' % nomeFantasiaFornecedor, style1)
                ws.write_merge(7, 7, 1, 9, '%s' % enderecoFornecedor, style1)
                ws.write_merge(8, 8, 1, 9, '%s' % emailFornecedor, style1)
                ws.row(10).height = 500
                ws.write_merge(10, 10, 0, 9, 'Itens', style0)
                ws.write_merge(11, 11, 0, 1, 'Produto', style2)
                ws.write(11, 2, 'Grade', style2)
                ws.write(11, 3, 'Quantidade', style2)
                ws.col(4).width = 5000
                ws.write(11, 4, 'Embalagem', style2)
                ws.write(11, 5, 'Validade(Dias)', style2)
                ws.write(11, 6, 'ICMS(%)', style2)
                ws.write(11, 7, 'IPI(%)', style2)
                ws.write(11, 8, 'Preco Un.', style2)
                ws.write(11, 9, 'Preco Total', style2)
                ws.write(11, 10, 'Controle', style2)
                lin = 11
                #Itens da cotacao
                estpar_dados = self.pool.get('estoque.parametro').estpar_get_fields(
                    cr, uid, fields_to_read=['estpar_tamanho_codigo'], context=context
                )
                if isinstance(estpar_dados, list):
                    estpar_dados = estpar_dados[0]
                tamanho_codigo_produto = estpar_dados['estpar_tamanho_codigo']
                for i in obj_cotacao.cotacoes_itens_ids:
                    lin += 1
                    cotacao_item_id = i.id
                    produto_codigo = str(i.requisicao_itens_id.produto_id.codigo).rjust(tamanho_codigo_produto, '0')
                    produto_name = '%s' % (i.requisicao_itens_id.produto_id.name,)
                    produto_grade_sigla = i.requisicao_itens_id.grade_id.grade
                    produto_qtd = i.requisicao_itens_id.quantidade
                    embalagem = i.requisicao_itens_id.comrit_produto_embalagem_id.embalagem_id.name
                    ws.write(lin, 0, produto_codigo)
                    ws.write(lin, 1, produto_name)
                    ws.write(lin, 2, produto_grade_sigla)
                    ws.write(lin, 3, produto_qtd, styleDesbloqueado1)
                    ws.write(lin, 4, embalagem)
                    ws.write(lin, 5, '', styleDesbloqueado4)
                    ws.write(lin, 6, '', styleDesbloqueado4)
                    ws.write(lin, 7, '', styleDesbloqueado5)
                    ws.write(lin, 8, '', styleDesbloqueado3)
                    ws.write(lin, 9,
                             xlwt.Formula("(D%d*I%d)+(D%d*I%d*H%d/100)" % (lin + 1, lin + 1,
                                                                           lin + 1, lin + 1,
                                                                           lin + 1)), style3)
                    ws.write(lin, 10, cotacao_item_id)
                lin += 2
                ws.write_merge(lin, lin, 0, 6, _('Total dos itens do Pedido '), style2)
                ws.write(lin, 8,
                         xlwt.Formula("sum(J13:J%d)" % (lin)), style3)
                lin += 2
                ws.write_merge(lin, lin + 5, 0, 1, u'', style0)
                ws.row(lin).height = 500
                ws.write_merge(lin, lin, 2, 8, _('Resumo'), style0)
                ws.write_merge(lin + 1, lin + 1, 2, 3, _('Nro Cotacao :'), style7)
                ws.write(lin + 1, 4, "%06.0f" % cotacao_id)
                ws.write_merge(lin + 1, lin + 1, 6, 7, _('Tipo Frete ( CIF / FOB )'), style7)
                ws.write_merge(lin + 2, lin + 2, 2, 3, _('Validade Proposta '), style7)
                ws.write_merge(lin + 2, lin + 2, 6, 7, _('Valor do  Frete'), style7)
                ws.write_merge(lin + 3, lin + 3, 2, 3, _('Prazo para Entrega (Dias)'), style7)
                ws.write_merge(lin + 3, lin + 3, 6, 7, _('Despesas Acessorias'), style7)
                ws.write_merge(lin + 4, lin + 4, 6, 7, _('Outras Despesas'), style7)
                ws.write_merge(lin + 5, lin + 5, 2, 3, _('Total do Pedido'), style2)
                ws.write(lin + 2, 4, '', styleDesbloqueado6)
                ws.write(lin + 3, 4, '', styleDesbloqueado4)
                ws.write(lin + 1, 8, '', styleDesbloqueado3)
                ws.write(lin + 2, 8, '', styleDesbloqueado3)
                ws.write(lin + 3, 8, '', styleDesbloqueado3)
                ws.write(lin + 4, 8, '', styleDesbloqueado3)
                ws.write(lin + 5, 4,
                         xlwt.Formula(
                             'IF(I%d ="CIF";I%d;0)+I%d+I%d+I%d' % (lin + 2, lin + 3, lin + 4, lin + 5, lin - 1))
                    , style3)
                ws.write_merge(lin + 6, lin + 7, 0, 8, _('©2015 SIG Solucoes em gestao.'), style5)
                filename = obj_cotacao.numero
                if not os.path.exists('/tmp/enviar'):
                    os.makedirs('/tmp/enviar')
                wb.save('/tmp/enviar/%s.xls' % filename)
                file = open('/tmp/enviar/%s.xls' % filename, 'r')
                xml = open('/tmp/enviar/%s.xls' % filename, 'rb').read().encode('base64')
        return xml

    def mail_send(self, cr, uid, company_id, msg, smtp_server=None, context=None):
        context = context and context.copy() or {}
        try:
            # smtp = SMTP()
            pass
        except:
            raise osv.except_osv(_('Atencao'), _('Falha ao enviar e-mail!'))
        obj_email_server = self.pool.get('ir.mail_server')
        if smtp_server:
            param_id = smtp_server
        else:
            param_ids = obj_email_server.search(cr, uid, args=[], order='sequence asc', limit=1, context=context)
            if not param_ids:
                return False
            param_id = param_ids[0]
        config = obj_email_server.browse(cr, uid, param_id)
        #SMTP nao configurado: nao gera erro
        #SMTP configurado incorretamente: gera erro
        smtp_host = '%s' % config.smtp_host
        smtp_port = config.smtp_port
        smtp_encryption = config.smtp_encryption
        smtp_user = config.smtp_user
        smtp_pass = config.smtp_pass
        if smtp_host and smtp_port:
            try:
                smtp = obj_email_server.connect(smtp_host, smtp_port,
                             user=smtp_user,
                             password=smtp_pass, encryption=smtp_encryption)
                # smtp.timeout = 10
                # smtp.connect(smtp_host, smtp_port)
                # if smtp_encryption != 'none':
                    # smtp.ehlo()
                    # smtp.starttls()
                    # smtp.ehlo_or_helo_if_needed()
                # if smtp_user:
                #     smtp.login(smtp_user, smtp_pass)
                res = smtp.sendmail(msg['From'], msg['To'], msg.as_string())
                smtp.close()
                return (len(res) == 0)
            except Exception as e:
                raise osv.except_osv(_('Atencao'),
                                     _('Falha ao enviar e-mail! Verifique a configuracao de email: %s' % e))
        else:
            return False
        #            Problema:
        #            Como exibir uma mensagem para o usuário pedindo que confirme ou cancele a cotacao?
        #            Possivel exemplo:
        #            crm/crm_lead.py
        #                em eventos do tipo "object", alguns modulos retornam, em alguns casos, um dicionário com atributos parecidos com os de uma action:
        #                res_model, views, view_id, type, etc...
        #            O que fazer:
        #                Criar uma view para o objeto compras_requisicao_capa, como se fosse um confirm box;
        #                criar os metodos para continuar a cotacao sem email, e para cancelar a cotacao;
        #                tentar abrir essa view a partir daqui (falha no envio de e-mail).

    def mail_receive(self, cr, uid):
        obj_email_server = self.pool.get('ir.mail_server')
        param_ids = obj_email_server.search(cr, uid, args=[], order='sequence asc', limit=1, context=None)
        if not param_ids:
            raise osv.except_osv(_('Atencao'), _('Configure os parametros de email'))
            return False
        browse_email_server = obj_email_server.browse(cr, uid, param_ids)
        for config in browse_email_server:
            if config.tipo_servidor_entrada == 'IMAP':
                if config.ssl_entrada:
                    receiver = IMAP4_SSL(config.servidor_entrada, config.porta_entrada)
                else:
                    receiver = IMAP4(config.servidor_entrada, config.porta_entrada)
                if config.login_entrada:
                    receiver.login(config.login_entrada, config.senha_entrada)
                try:
                    if config.pasta_imap:
                        receiver.select(config.pasta_imap or 'Inbox')
                    typ, data = receiver.search(None, 'UNSEEN')
                    msgs = []
                    for num in data[0].split():
                        typ, data = receiver.fetch(num, '(RFC822)')
                        msgs.append(email.message_from_string(data[0][1]))
                        #typ, data = receiver.store(num,'-FLAGS','\\Seen') # marca a mensagem novamente como nao-lida
                except:
                    raise osv.except_osv(_('Atencao'), _('Erro ao receber e-mail'))
                receiver.close()
            elif config.tipo_servidor_entrada == 'POP3':
                #TODO
                raise osv.except_osv(_('Atencao'), _('POP3 nao implementado'))
            else:
                raise osv.except_osv(_('Atencao'), _('Recepcao de email nao configurada'))
        # Lista usada para guardar os ids dos itens. Depois de atualizar os itens,
        # buscaremos as cotacoes correspondentes e avisaremos ao comprador.
        # Pegaremos os ids no for logo abaixo...
        cotacoes_itens_ids = []
        #Emails recebidos, agora vamos à atualizacao dos itens das cotacoes
        #como temos os ids dos itens, faremos as alteracoes diretamente neles, sem ter de verificar as cotacoes em si.
        for msg in msgs:
            for part in msg.walk():
                if part.get_content_type() == 'text/plain':
                    try:
                        xml = etree.fromstring(part.get_payload())
                    except etree.XMLSyntaxError:
                        #Provavelmente o e-mail foi editado, ou trata-se de um e-mail qualquer
                        break
                    for item in xml.findall('item'):
                        #Atualiza valor da cotacao
                        if self.pool.get('compras.cotacoes.itens').write(cr, uid, int(item.get('id')),
                                                                         {'valor': float(item.text)}):
                            #Caso o item tenha sido atualizado, precisamos avisar ao comprador.
                            #Como a oferta pode vir com vários itens, vamos pegar os ids
                            cotacoes_itens_ids.append(int(item.get('id')))
                    break
        # Com as cotacoes já atualizadas, avisaremos aos compradores responsáveis pelas cotacoes sobre
        # o recebimento das mesmas
        usuarios = {}
        if len(cotacoes_itens_ids) > 0:
            for item in self.pool.get('compras.cotacoes.itens').browse(cr, uid, cotacoes_itens_ids):
                # Id de usuário a ser avisado.
                # Caso o comprador nao seja um usuário, ou nao haja comprador definido, avisaremos
                # ao usuário que iniciou a cotacao.
                if item.cotacao_id.comprador_id and item.cotacao_id.comprador_id.pessoa_id.user_ids:
                    user_id = item.cotacao_id.comprador_id.pessoa_id.user_ids[0].id
                else:
                    user_id = item.cotacao_id.create_uid.id
                #Faremos, para cada usuário, uma lista com os numeros das cotacoes respondidas
                if not usuarios.get(user_id, False):
                    usuarios[user_id] = []
                usuarios[user_id].append(item.cotacao_id.numero)
        for user, cotacoes in usuarios.items():
            self.notificar_resposta(cr, uid, user, cotacoes)
        return True

    def notificar_resposta(self, cr, uid, user, cotacoes, context=None):
        """
        Envia ao usuário uma notificacao de resposta de cotacao.
            user: id de usuário do comprador responsável ou criador da cotacao.
            cotacoes: lista com os numeros das cotacoes - campo 'numero'(str) -.
        """
        context = context and context.copy() or {}
        nome_usuario = self.pool.get('res.users').read(cr, uid, [user], ['name'], context=context)[0]['name'].split()[0]
        msg = _("%s,\nAs seguintes cotacoes foram respondidas:\n\n%s\nVerifique os valores cotados em Compras/Cotacao.") % (
            nome_usuario, "\n".join(["\t%s" % s for s in cotacoes]))
        return True

