# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class compras_cotacoes_itens(osv.Model):
    """
    Tabela de itens de uma cotacao.
    """

    _name = 'compras.cotacoes.itens'  # comcit
    _inherit = 'compras.cotacoes.itens'

    def button_vencedor(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_requisicao = self.pool.get('compras.requisicao.itens')
        dados_requisicao = \
        self.read(cr, uid, ids, ['requisicao_itens_id', 'fornecedor', 'cotacao_id'], context=context)[0]
        requisicao_id = dados_requisicao['requisicao_itens_id']
        fonecedo_id = dados_requisicao['fornecedor']
        cotacao_id = dados_requisicao['cotacao_id']
        requisicao_id = requisicao_id and requisicao_id[0] or False
        fonecedo_id = fonecedo_id or False
        cotacao_id = cotacao_id and cotacao_id[1] or False
        requisicao_ids = self.search(cr, uid,
                                     [('requisicao_itens_id', '=', requisicao_id), ('state', 'in', ('C', 'T'))],
                                     context=context)
        if requisicao_ids:
            self.write(cr, uid, requisicao_ids, {'state': 'C'}, context=context)
        self.write(cr, uid, ids, {'state': 'T'}, context=context)
        obj_requisicao.write(cr, uid, requisicao_id, {'fornecedor': fonecedo_id, 'numero_cotacao': cotacao_id},
                             context=context)
        return True

    def button_nvencedor(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_requisicao = self.pool.get('compras.requisicao.itens')
        dados_requisicao = \
        self.read(cr, uid, ids, ['requisicao_itens_id', 'fornecedor', 'cotacao_id'], context=context)[0]
        requisicao_id = dados_requisicao['requisicao_itens_id']
        fonecedo_id = dados_requisicao['fornecedor']
        cotacao_id = dados_requisicao['cotacao_id']
        requisicao_id = requisicao_id and requisicao_id[0] or False
        fonecedo_id = fonecedo_id or False
        cotacao_id = cotacao_id and cotacao_id[1] or False
        requisicao_ids = self.search(cr, uid,
                                     [('requisicao_itens_id', '=', requisicao_id), ('state', 'in', ('C', 'T'))],
                                     context=context)
        self.write(cr, uid, requisicao_ids, {'state': 'C'}, context=context)
        obj_requisicao.write(cr, uid, requisicao_id, {'fornecedor': fonecedo_id, 'numero_cotacao': cotacao_id},
                             context=context)
        return True

    def comcit_onchange_produto(self, cr, uid, ids, requisicao_itens_id, context=None):
        """
        Recupera a embalagem do produto selecionado.

        @param cr: {cursor} a linha atual do cursor do banco de dados,
        @param uid: {int} o ID do usuário utilizado para a verificacao de perfil,
        @param ids: {list} lista dos IDs,
        @param requisicao_itens_id: ID do item da requisicao,
        @return: {dict} embalagem do produto selecionado.

        @change: 03.05.2013 - pierre.barbosa
        """
        context = context and context.copy() or {}
        result = {}
        obj_requisicao_item = self.pool.get('compras.requisicao.itens')
        args = [('id', '=', requisicao_itens_id)]
        requisicao_ids = obj_requisicao_item.search(cr, uid, args, context=context)
        if requisicao_ids:
            requisicao_id = requisicao_ids[0]
            campos = ['comrit_produto_embalagem_id', 'quantidade']
            dados_requisicao = obj_requisicao_item.read(cr, uid, requisicao_id,
                                                        campos, context=context)
            if dados_requisicao and isinstance(dados_requisicao, list):
                dados_requisicao = dados_requisicao[0]
            if dados_requisicao and isinstance(dados_requisicao, dict):
                embalagem_id = dados_requisicao.get('comrit_produto_embalagem_id')
                if embalagem_id:
                    result['comcil_produto_embalagem_id'] = embalagem_id[0]
                quantidade = dados_requisicao.get('quantidade') or 0
                result['quantidade'] = quantidade
        return {'value': result}

    def onchange_calcula_valor_total(self, cr, uid, ids, vr_unitario, quantidade):
        if vr_unitario and quantidade:
            valor_total = vr_unitario * quantidade
        else:
            valor_total = 0
        return {'value': {'valor': valor_total}}

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, list):
            ids = ids[0]
        obj_compras_cotacoes_capa = self.pool.get('compras.cotacoes.capa')
        obj_compras_requisicao_capa = self.pool.get('compras.requisicao.capa')
        obj_compras_requisicao_item = self.pool.get('compras.requisicao.itens')
        cotacoes_itens_dados = self.browse(cr, uid, ids)
        cotacoes_capa_id = cotacoes_itens_dados.cotacao_id.id
        cotacoes_capa_dados = obj_compras_cotacoes_capa.browse(cr, uid, cotacoes_capa_id)
        if 'state' in vals and vals.get('state') == 'T':
            if cotacoes_itens_dados.requisicao_itens_id:
                requisicao_item_id = cotacoes_itens_dados.requisicao_itens_id.id
                _fornecedor = cotacoes_itens_dados.cotacao_id.fornecedor_id.pessoa_id.nome
                vals_req_item = {'cotacao_item_id': cotacoes_itens_dados.id,
                                 'fornecedor': _fornecedor}
                obj_compras_requisicao_item.write(cr, uid, requisicao_item_id, vals_req_item,
                                                  context=context)
            requisicao_capa_id = cotacoes_capa_dados.requisicao_capa_id.id
            requisicao_capa_dados = obj_compras_requisicao_capa.browse(cr, uid, requisicao_capa_id)
            for i in requisicao_capa_dados.comrca_cotacoes_ids:
                if i.id == cotacoes_capa_id:
                    continue
                for j in i.cotacoes_itens_ids:
                    if j.requisicao_itens_id.produto_id.id == cotacoes_itens_dados.\
                        requisicao_itens_id.produto_id.id \
                        and j.requisicao_itens_id.grade_id.id == cotacoes_itens_dados.\
                            requisicao_itens_id.grade_id.id:
                        self.write(cr, uid, j.id, {'state': 'R'}, context=context)
        res = super(compras_cotacoes_itens, self).write(cr, uid, ids, vals, context)
        return res

    def button_ir_para_cotacao(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, list):
            ids = ids[0]
        obj_model_data = self.pool.get('ir.model.data')
        reference = obj_model_data.get_object_reference(cr, uid, 'compras',
                                                        'view_compras_cotacoes_capa_form')
        view_id = reference and reference[1] or False
        brw_cot_item = self.browse(cr, uid, ids, context)
        cotacao_id = brw_cot_item.cotacao_id.id
        _cotacaoNumero = brw_cot_item.cotacao_id.numero
        return {
            'name': 'COTACAO %s' % _cotacaoNumero,
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'compras.cotacoes.capa',
            'view_id': [view_id],
            'res_id': cotacao_id,
            'target': 'new',
            'type': 'ir.actions.act_window',
        }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
