# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################
from openerp.osv import osv
import time
from openerp.tools.translate import _
import xlwt
from dateutil.parser import parse

READ_LOAD = '_classic_write'


class compras_requisicao_capa(osv.Model):
    """
    Tabela de requisicao de compras
    """
    _name = 'compras.requisicao.capa'
    _inherit = 'compras.requisicao.capa'

    def sequence_criar(self, cr, uid, context=None):
        context = context and context.copy() or {}
        obj_ir_sequence_type = self.pool.get('ir.sequence.type')
        obj_ir_sequence = self.pool.get('ir.sequence')
        company_id = context.get('requisicao_company_id') or self.pool.get('adm.empresa.objeto').\
            getEmpresa(cr, uid, self._name, context=context)
        code = 'numero_requisicao.compra'
        nome = 'Numero Requisicao Compra'
        vals = {
            'name': nome,
            'code': code,
            'padding': 6,
            'prefix': 'RCO-%(year)s-',
            'company_id': company_id,
            'implementation': 'no_gap',
        }
        sequence_type_ids = obj_ir_sequence_type.search(cr, uid, [('code', '=', code)],
                                                        context=context)
        if not sequence_type_ids:
            obj_ir_sequence_type.create(cr, uid, {'name': nome, 'code': code}, context)

        # Gerar sequence para orcamento para a empresa
        consulta = obj_ir_sequence.search(cr, uid, [('code', '=', code), ('company_id', '=', company_id)], context=context)
        if not consulta:
            obj_ir_sequence.create(cr, uid, vals, context)
        return True

    def button_definir(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        compras_requisicao_capa_dados = self.read(
            cr, uid, ids[0] if isinstance(ids, (list, tuple)) else ids,
            ['requisicao_itens_ids'], context=context)
        requisicao_itens_ids = compras_requisicao_capa_dados.get('requisicao_itens_ids')
        if not requisicao_itens_ids:
            raise osv.except_osv(_('Atencao'), _('Cadastre itens'))
        obj_estoque_fornecedor = self.pool.get('estoque.fornecedor')
        obj_compras_itens_fornecedores = self.pool.get('compras.itens.fornecedores')
        obj_compras_requisicao_itens = self.pool.get('compras.requisicao.itens')
        compras_requisicao_itens_dados = obj_compras_requisicao_itens.read(
            cr, uid, requisicao_itens_ids, ['produto_id'], context=context, load='_classic_write')
        for x in compras_requisicao_itens_dados:
            for_i = obj_compras_itens_fornecedores.search(
                cr, uid, [('requisicao_itens_id', '=', x.get('id'))], context=context)
            if for_i:
                obj_compras_itens_fornecedores.unlink(cr, uid, for_i, context=context)
            estoque_fornecedor_ids = obj_estoque_fornecedor.search(
                cr, uid, [('produto_id', '=', x.get('produto_id'))], context=context)
            for y in estoque_fornecedor_ids:
                obj_compras_itens_fornecedores.create(cr, uid, {
                    'fornecedor_id': y, 'produto_id': x.get('produto_id'),
                    'requisicao_itens_id': x.get('id')}, context=context)
        context.update({'read_only': 'N'})
        res = self.write(cr, uid, ids, {'state': 'D'}, context)
        return res

    def button_iniciar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_compras_itens_fornecedores = self.pool.get('compras.itens.fornecedores')
        obj_estoque_fornecedor = self.pool.get('estoque.fornecedor')
        obj_compras_requisicao_itens = self.pool.get('compras.requisicao.itens')
        vals = self.read(cr, uid, ids[0], ['company_id', 'requisicao_itens_ids',
                                           'comrca_fornecedor_ids'], context=context)
        requisicao_item_ids = vals['requisicao_itens_ids']
        if not requisicao_item_ids:
            raise osv.except_osv(_('Atencao'), _('A requisicao nao possui nenhum item cadastrado!'))
        fornecedor_capa_ids = list()
        if vals.get('comrca_fornecedor_ids'):
            fornecedor_capa_ids = vals.get('comrca_fornecedor_ids')
        dict_itens = {}
        forn = {}
        for x in requisicao_item_ids:
            comprador_id = obj_compras_requisicao_itens.browse(
                cr, uid, x).produto_id.comprador_id.id
            for_i = obj_compras_itens_fornecedores.search(
                    cr, uid, [('requisicao_itens_id', '=', x), ('cotar', '=', True)],
                    context=context)
            if fornecedor_capa_ids:
                obj_compras_itens_fornecedores.unlink(cr, uid, for_i, context)
                for_i = fornecedor_capa_ids
            dict_itens[x] = {}
            for y in for_i:
                if fornecedor_capa_ids:
                    id_f2 = y
                else:
                    id_f = obj_compras_itens_fornecedores.read(
                        cr, uid, y, ['fornecedor_id'], context=context)['fornecedor_id'][0]
                    dict_itens[x][y] = id_f
                    id_f2 = obj_estoque_fornecedor.read(
                        cr, uid, id_f, ['fornecedor_id'], context=context)['fornecedor_id'][0]
                if (id_f2, comprador_id) in forn:
                    forn[id_f2, comprador_id] += x,
                else:
                    forn[id_f2, comprador_id] = x,
        if not forn:
            raise osv.except_osv(_('Atencao'), _('Selecione os fornecedores para cotacao'))
        obj_compras_cotacoes_capa = self.pool.get('compras.cotacoes.capa')
        obj_compras_cotacoes_itens = self.pool.get('compras.cotacoes.itens')
        for x in forn:
            cot_id = obj_compras_cotacoes_capa.create(cr, uid, {
                'company_id': vals['company_id'][0],
                'requisicao_capa_id': vals['id'],
                'fornecedor_id': x[0],
                'comprador_id': x[1]}, context=context)
            for y in forn[x]:
                compra_fornec_item_dados = obj_compras_requisicao_itens.read(
                    cr, uid, y, ['quantidade', 'comrit_produto_embalagem_id'], context=context)
                if isinstance(compra_fornec_item_dados, list):
                    compra_fornec_item_dados = compra_fornec_item_dados[0]
                quantidade = compra_fornec_item_dados.get('quantidade') or 0
                obj_compras_cotacoes_itens.create(cr, uid, {
                    'cotacao_id': cot_id,
                    'valor': 0,
                    'requisicao_itens_id': y,
                    'quantidade': quantidade,
                    'comcil_produto_embalagem_id': compra_fornec_item_dados[
                        'comrit_produto_embalagem_id'][0],
                }, context)
                #Enviar email's
        context.update({'read_only': 'N'})
        res = self.write(cr, uid, ids, {'state': 'E'}, context)
        return res

    def button_encerrar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = self.write(cr, uid, ids, {'state': 'O'}, context=context.update({'read_only': 'N'}))
        return res

    def button_analizar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        context.update({'read_only': 'N'})
        res = self.write(cr, uid, ids, {'state': 'A'}, context=context)
        return res

    def button_concluir(self, cr, uid, ids, context=None):
        ################ Gerar Pedido  #################
        context = context and context.copy() or {}
        estoque_parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', 'estpar_local_compra_padrao_id', context=context)
        local_id = estoque_parametro_dados.get('estpar_local_compra_padrao_id')
        if not local_id:
            raise osv.except_osv(_('Atencao'), _('Local para entradas nao cadastrado nos '
                                                 'parametros do estoque.'))
        cr.execute("""
            select ff.pessoa_id AS pessoa_id,
                   ccc.transportador_id AS transportador_id,
                   ccc.tipo_frete AS tipo_frete,
                   ccc.frete_valor AS frete_valor,
                   ccc.outras_despesas AS outras_despesas,
                   ccc.despesas_acessorias AS despesas_acessorias,
                   CURRENT_DATE + ccc.prazo_entrega as data_entrega,
                   cri.produto_id AS produto_id,
                   cri.quantidade AS quantidade,
                   cri.grade_id AS grade_id,
                   cci.vr_unitario AS vr_unitario,
                   cri.comrit_produto_embalagem_id AS produto_embalagem_id
              from compras_requisicao_itens cri,
                   compras_cotacoes_itens cci,
                   compras_cotacoes_capa ccc,
                   financeiro_fornecedor ff
              where cri.requisicao_id = %d
                and cri.id = cci.requisicao_itens_id
                and cci.state = 'T'
                and cci.cotacao_id = ccc.id
                and ccc.fornecedor_id = ff.id
           order by ff.pessoa_id,
                    cri.produto_id
             """ % ids[0] if isinstance(ids, (list, tuple)) else ids)
        dados = cr.dictfetchall()
        pessoa_id = False
        pedido_id = False
        obj_pedido = self.pool.get('estoquepedidos.pedido.capa')
        obj_pedido_item = self.pool.get('estoquepedidos.pedido.item')
        for item in dados:
            if pessoa_id != item.get('pessoa_id'):
                pessoa_id = item.get('pessoa_id')
                pedido_id = obj_pedido.create(
                    cr, uid, {'pessoa_id': pessoa_id,
                              'tipo': 'C',
                              'transportador_id': item.get('transportador_id'),
                              'vr_seguro': 0,
                              'vr_despesas_acessorias': item.get('despesas_acessorias'),
                              'vr_desconto': 0,
                              'vr_frete': item.get('frete_valor') or 0,
                              'frete': item.get('tipo_frete'),
                              'data_entrega': item.get('data_entrega')
                              }, context)
            obj_pedido_item.create(cr, uid, {'pedido_id': pedido_id,
                                             'local_id': local_id,
                                             'produto_id': item.get('produto_id'),
                                             'grade_id': item.get('grade_id'),
                                             'produto_embalagem_id': item.get(
                                                 'produto_embalagem_id'),
                                             'vr_unitario': item.get('vr_unitario') or 0,
                                             'qtde_pedida': item.get('quantidade') or 0},
                                   context)
        ############# Altera Status da Requisicao ##########
        res = self.write(cr, uid, ids, {'state': 'L'}, context=context.update({'read_only': 'N'}))
        return res

    def button_rascunho(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = self.write(cr, uid, ids, {'state': 'B'}, context=context.update({'read_only': 'N'}))
        return res

    def button_cancelar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
        requisicao_dados = self.read(cr, uid, ids, ['name', 'state', 'solicitacao_id'], context=context, load=READ_LOAD)
        obj_solicitacao_capa = self.pool.get('compras.solicitacao.capa')
        for i in requisicao_dados:
            state = i.get('state')
            if state == 'B':
                name = i.get('name') or ''
                solicitacao_id = i.get('solicitacao_id')
                if solicitacao_id:
                    values_solicitacao = {
                        'state': 'A',
                        'requisicao_id': False,
                    }
                    obj_solicitacao_capa.write(cr, uid, [solicitacao_id], values_solicitacao, context)
                    obj_solicitacao_capa.message_post(
                        cr, uid, [solicitacao_id], _('Alteracao de Status'),
                        _('Requisicao: %s Cancelada') % name)
        res = self.write(cr, uid, ids, {'state': 'C'}, context=context.update({'read_only': 'N'}))
        return res

    def button_processar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_compras_requisicao_capa = self.pool.get('compras.requisicao.capa')
        compras_requisicao_capa_dados = obj_compras_requisicao_capa.read(cr, uid, ids, ['numero', 'state'], context=context)
        for x in compras_requisicao_capa_dados:
            state = x.get('state')
            numero = x.get('numero')
        if state == 'D':
            return {
                'name': _('Itens da Requisicao: %s') % str(numero),
                'view_type': 'form',
                'view_mode': 'tree,form',
                'res_model': 'compras.requisicao.itens',
                'view_id': False,
                'target': 'new',
                'type': 'ir.actions.act_window',
                'domain': [('requisicao_id', '=', ids)]
            }
        elif state == 'E':
            return {
                'name': _('Cotacoes da Req.: %s') % str(numero),
                'view_type': 'form',
                'view_mode': 'tree,form',
                'res_model': 'compras.cotacoes.capa',
                'view_id': False,
                'target': 'new',
                'type': 'ir.actions.act_window',
                'domain': [('requisicao_capa_id', '=', ids)]
            }
        elif state == 'A':
            return {
                'name': _('Itens da Requisicao'),
                'view_type': 'tree',
                'view_mode': 'tree,form',
                'res_model': 'compras.requisicao.itens',
                'view_id': False,
                'target': 'new',
                'type': 'ir.actions.act_window',
                'context': {'abrir_itens': True},
                'domain': [('requisicao_id', '=', ids)]
            }

    def button_abrir_solicitacao(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = {}
        if context.get('wizard_abrir_sol_req') == 'requisicao':
            obj_compras_requisicao_capa = self.pool.get('compras.solicitacao.capa')
            requisicao_id = None
            compras_requisicao_capa_dados = obj_compras_requisicao_capa.read(cr, uid, ids, ['requisicao_id'], context=context)
            for x in compras_requisicao_capa_dados:
                requisicao_id = x.get('requisicao_id')
            if requisicao_id:
                if isinstance(requisicao_id, tuple):
                    requisicao_id = requisicao_id[0]
                res = {'res_id': requisicao_id,
                       'name': _('Requisicao'),
                       'view_type': 'form',
                       'view_mode': 'form',
                       'res_model': 'compras.requisicao.capa',
                       'target': 'new',
                       'type': 'ir.actions.act_window'
                }
        if context.get('wizard_abrir_sol_req') == 'solicitacao':
            obj_compras_solicitacao_capa = self.pool.get('compras.requisicao.capa')
            solicitacao_id = None
            compras_solicitacao_capa_dados = obj_compras_solicitacao_capa.read(cr, uid, ids, ['solicitacao_id'], context=context)
            for x in compras_solicitacao_capa_dados:
                solicitacao_id = x.get('solicitacao_id')
            if solicitacao_id:
                if isinstance(solicitacao_id, tuple):
                    solicitacao_id = solicitacao_id[0]
                res = {'res_id': solicitacao_id,
                       'name': _('Solicitacao'),
                       'view_type': 'form',
                       'view_mode': 'form',
                       'res_model': 'compras.solicitacao.capa',
                       'target': 'new',
                       'type': 'ir.actions.act_window'
                }
        return res

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        # SEQUENCE NRO REQUISICAO COMPRA
        self.sequence_criar(cr, uid, context)
        vals['numero'] = self.pool.get('adm.utils').get_sequence(cr, uid, self._name, 'numero_requisicao.compra', context)
        res = super(compras_requisicao_capa, self).create(cr, uid, vals, context)
        return res

    def button_gerar_pedido_compra(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            requisicao_capa_ids = [ids]
        else:
            requisicao_capa_ids = ids
        obj_fornecedor = self.pool.get('financeiro.fornecedor')
        obj_pedido_capa = self.pool.get('estoquepedidos.pedido.capa')
        obj_cotacao_capa = self.pool.get('compras.cotacoes.capa')
        obj_pedido_itens = self.pool.get('estoquepedidos.pedido.item')
        obj_produto_grade = self.pool.get('estoque.produto.grade')
        obj_cotacao_itens = self.pool.get('compras.cotacoes.itens')
        obj_requisicao_itens = self.pool.get('compras.requisicao.itens')
        obj_estoque_parametro = self.pool.get('estoque.parametro')
        cotacao_ids = obj_cotacao_capa.search(cr, uid, [('requisicao_capa_id', 'in', requisicao_capa_ids)],
                                              context=context)
        if not cotacao_ids:
            raise osv.except_osv(_('Atencao'), _('Nenhuma cotacao encontrada para a requisicao'))
        else:
            cot_fields_to_read = ['company_id', 'fornecedor_id', 'cotacoes_itens_ids', 'requisicao_capa_id']
            cotacao_capa_dados = obj_cotacao_capa.read(
                cr, uid, cotacao_ids, cot_fields_to_read, context=context, load=READ_LOAD
            )
            cotacoes_autorizadas = False
            for cot_dados in cotacao_capa_dados:
                cot_cotacoes_item_ids = cot_dados.get('cotacoes_itens_ids')
                if cot_cotacoes_item_ids:
                    COTACAO_ITEM_AUTORIZADO = 'T'
                    cotacao_item_autorizado_ids = obj_cotacao_itens.search(
                        cr, uid, [('id', 'in', cot_cotacoes_item_ids), ('state', '=', COTACAO_ITEM_AUTORIZADO)],
                        context=context
                    )
                    if cotacao_item_autorizado_ids:
                        cotacoes_autorizadas = True
                        cot_company_id = cot_dados.get('company_id')
                        cot_requisicao_id = cot_dados.get('requisicao_capa_id')
                        cot_fornecedor_id = cot_dados.get('fornecedor_id')
                        # BUSCA O LOCAL
                        est_parametro_ids = obj_estoque_parametro.search(cr, uid, [('company_id', '=', cot_company_id)],
                                                                         context=context)
                        if not est_parametro_ids:
                            raise osv.except_osv(_('Atencao'), _('Parametro do Estoque nao cadastrado para a empresa'))
                        est_parametro_dados = obj_estoque_parametro.read(
                            cr, uid, est_parametro_ids, ['estpar_local_compra_padrao_id'], context=context, load=READ_LOAD
                        )
                        local_entrada_id = False
                        if est_parametro_dados and isinstance(est_parametro_dados, list):
                            est_parametro_dados = est_parametro_dados[0]
                        if isinstance(est_parametro_dados, dict):
                            local_entrada_id = est_parametro_dados.get('estpar_local_compra_padrao_id')
                        if not local_entrada_id:
                            raise osv.except_osv(_('Atencao'),
                                                 _('Local de Entrada Padao nao cadastrado no Parametro do Estoque'))
                        # BUSCA A PESSOA_ID DO FORNECEDOR
                        fornec_pessoa_id = False
                        if cot_fornecedor_id:
                            fornecedor_dados = obj_fornecedor.read(cr, uid, cot_fornecedor_id, ['pessoa_id'], context=context,
                                                                   load=READ_LOAD)
                            if fornecedor_dados and isinstance(fornecedor_dados, list):
                                fornecedor_dados = fornecedor_dados[0]
                            if isinstance(fornecedor_dados, dict):
                                fornec_pessoa_id = fornecedor_dados.get('pessoa_id')
                        pedcap_prazo = '0'
                        pedcap_prazo_tipo = 'DD'
                        data_emissao = time.strftime('%Y-%m-%d')
                        vals_pedido_capa = {
                            'tipo': 'C',
                            'pessoa_id': fornec_pessoa_id,
                            'company_id': cot_company_id,
                            'data_emissao': data_emissao,
                            'pedcap_prazo': pedcap_prazo,
                            'pedcap_prazo_tipo': pedcap_prazo_tipo,
                            'pedcap_requisicao_compras_id': cot_requisicao_id,
                        }
                        pedido_id = obj_pedido_capa.create(cr, uid, vals_pedido_capa, context)
                        if not pedido_id:
                            raise osv.except_osv(_('Atencao'), _('Pedido nao foi criado para a requisiscao'))
                        else:
                            COTACAO_ITEM_FIELDS_TO_READ = [
                                'vr_unitario', 'quantidade', 'requisicao_itens_id', 'comcil_produto_embalagem_id', 'ipi'
                            ]
                            cotacao_item_dados = obj_cotacao_itens.read(
                                cr, uid, cotacao_item_autorizado_ids, COTACAO_ITEM_FIELDS_TO_READ, context=context, load=READ_LOAD
                            )
                            requisicao_item_ids = filter(
                                None, map(lambda i: i.get('requisicao_itens_id'), cotacao_item_dados)
                            )
                            requisicao_item_dados = obj_requisicao_itens.read(
                                cr, uid, requisicao_item_ids, ['produto_id'], context=context, load=READ_LOAD
                            )
                            dict_reqitem_id_produto = dict(map(
                                lambda i: (i['id'], i.get('produto_id') or False), requisicao_item_dados
                            ))
                            for i in cotacao_item_dados:
                                cot_item_ipi = i.get('ipi') or 0
                                cot_item_quantidade = i.get('quantidade') or 0
                                cot_item_vr_unitario = i.get('vr_unitario') or 0
                                cot_item_req_item_id = i.get('requisicao_itens_id')
                                cot_item_embalagem_id = i.get('comcil_produto_embalagem_id')
                                req_item_produto_id = dict_reqitem_id_produto.get(cot_item_req_item_id) or 0
                                grade_ids = obj_produto_grade.search(cr, uid,
                                                                     [('produto_id', '=', req_item_produto_id)],
                                                                     context=context)
                                if grade_ids:
                                    grade_id = grade_ids[0]
                                else:
                                    grade_id = False
                                vals_pedido_item = {
                                    'grade_id': grade_id,
                                    'local_id': local_entrada_id,
                                    'pedido_id': pedido_id,
                                    'produto_id': req_item_produto_id,
                                    'vr_unitario': cot_item_vr_unitario,
                                    'qtde_pedida': cot_item_quantidade,
                                    'produto_embalagem_id': cot_item_embalagem_id,
                                    'pedite_ipi_aliquota_entrada': cot_item_ipi
                                }
                                obj_pedido_itens.create(cr, uid, vals_pedido_item, context)
                                # WRITE USADO PARA QUE O CAMPO valor_total(FUNCTION) SEJA CALCULO.
                            obj_pedido_capa.write(cr, uid, [pedido_id], {'valor_total': 0}, context)
            if cotacoes_autorizadas:
                self.write(cr, uid, ids, {'state': 'L'}, context)
            else:
                raise osv.except_osv(_('Atencao'), _('Nenhum item contido nas cotacoes encontra-se autorizado'))
        return True

    def comrca_button_gerar_xls(self, cr, uid, ids, context=None):
        """
        O metodo cria um arquivo de planilha xls com os dados da requisicao de compra.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dados com valores contextuais.
        :type context: dict
        :return: Verdadeiro, caso os dados do arquivo seja salvo no banco de dados. Senao, Falso.
        :rtype: bool
        """
        res = list()
        obj_adm_utils = self.pool.get('adm.utils')
        obj_compras_requisicao_itens = self.pool.get('compras.requisicao.itens')
        for requisicao in self.browse(cr, uid, ids, context):
            if not requisicao.requisicao_itens_ids:
                raise osv.except_osv(_('Atencao'), _('Nenhum produto cadastrado na requisicao.'))
            wb = xlwt.Workbook(encoding='utf8')
            ws = wb.add_sheet('Requisicao de Compras')
            linha = 0
            ws.write(linha, 0, 'Requisicao Nro:')
            ws.write(linha, 1, requisicao.numero)
            linha+=1
            data_hora_emissao = obj_adm_utils.admutl_datetime_to_timezone(
                cr, uid, parse(requisicao.data_hora_emissao), '%d-%m-%Y %H:%M:%S')
            ws.write(linha, 0, 'Data/Hora de emissao:')
            ws.write(linha, 1, data_hora_emissao)
            linha += 1
            ws.write(linha, 0, 'Obervacoes:')
            ws.write(linha, 1, requisicao.observacoes)
            linha += 2
            requisicao_item_dados = obj_compras_requisicao_itens.comrit_get_item_dados(
                cr, uid, map(lambda i: i.id, requisicao.requisicao_itens_ids), context)
            colunas = ['', 'PRODUTO', 'GRADE', 'QTD. EMBALAGEM', 'QTD. SOLICITADA',
                       'CUSTO REPOSICAO']
            colunas[0] = requisicao_item_dados.get('codigo')
            for i in range(0, 6):
                ws.write(linha, i, colunas[i])
            linha += 1
            for item in requisicao_item_dados.get('dados'):
                coluna = 0
                ws.write(linha, coluna, item.get('codigo'))
                coluna += 1
                ws.write(linha, coluna, item.get('produto'))
                coluna += 1
                ws.write(linha, coluna, item.get('grade'))
                coluna += 1
                ws.write(linha, coluna, item.get('qtd_embalagem'))
                coluna += 1
                ws.write(linha, coluna, item.get('qtd_solicitada'))
                coluna += 1
                ws.write(linha, coluna, item.get('custo'))

                linha += 1

            filename = '%s.xls' % requisicao.numero
            wb.save('/tmp/'+filename)
            xls_dados = open('/tmp/%s' % filename, 'rb').read().encode('base64')
            res.append(self.write(
                cr, uid, requisicao.id, {'comrca_planilha': xls_dados,
                                         'comrca_nome_planilha': filename}, context))
        return all(res)
