# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################
from openerp.osv import osv
from openerp.tools.translate import _


class compras_requisicao_itens(osv.Model):
    """
    Itens da requisicao de compras
    """
    _name = 'compras.requisicao.itens'
    _inherit = 'compras.requisicao.itens'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        quantidade = vals.get('quantidade') or 0
        if quantidade <= 0:
            raise osv.except_osv(_('Atencao'), _('Informe uma quantidade valida para o item'))
        res = super(compras_requisicao_itens, self).create(cr, uid, vals, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if 'quantidade' in vals and vals.get('quantidade') <= 0:
            raise osv.except_osv(_('Atencao'), _('Informe uma quantidade valida para o item'))
        res = super(compras_requisicao_itens, self).write(cr, uid, ids, vals, context)
        return res

    def button_ok(self, cr, uid, ids, context=None):
        context = {'read_only': 'N'}
        return {
            'type': 'ir.actions.act_window_close',
        }

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not ids:
            return []
        reads = self.read(cr, uid, ids, ['produto_id'], context=context)
        name = [(r['id'], r['produto_id'][1]) for r in reads]
        return name

    def onchange_produto(self, cr, uid, ids, produto_id, company_id, grade_id, context=None):
        context = context and context.copy() or {}
        val = {}
        val['grade_id'] = False
        if produto_id:
            grade_id = self.pool.get('estoque.produto.grade').search(cr, uid, [('produto_id', '=', produto_id)],
                                                                     context=context)
            if grade_id and len(grade_id) == 1:
                val['grade_id'] = grade_id[0]
        embalagem_id = self.pool.get('estoque.produto.embalagem').search(cr, uid, [('produto_id', '=', produto_id)],
                                                                         context=context)
        if len(embalagem_id) == 1:
            if isinstance(embalagem_id, list):
                embalagem_id = embalagem_id[0]
            val['comrit_produto_embalagem_id'] = embalagem_id
            # TODO: Removido embalagem do produto
            #obj_produto_embalagem = self.pool.get('estoque.produto.embalagem')
            #produto_embalagem_id = obj_produto_embalagem.search(cr, uid, [('produto_id', '=', produto_id)])
            #if len(produto_embalagem_id) == 1:
            #    val['produto_embalagem_id'] = produto_embalagem_id[0]
        return {'value': val}

    def button_definir_fornecedores(self, cr, uid, id, context=None):
        context = context and context.copy() or {}
        obj_compras_requisicao_itens = self.pool.get('compras.requisicao.itens')
        requisicao_id = None
        numero = None
        compras_requisicao_itens_dados = obj_compras_requisicao_itens.read(cr, uid, id, ['requisicao_id'], context=context)
        for x in compras_requisicao_itens_dados:
            requisicao_id = x.get('requisicao_id')
        if requisicao_id:
            if isinstance(requisicao_id, tuple):
                requisicao_id = requisicao_id[0]
            if not isinstance(requisicao_id, list):
                requisicao_id = [requisicao_id]
            compras_requisicao_capa_dados = self.pool.get('compras.requisicao.capa').read(cr, uid, requisicao_id,
                                                                                          ['numero'], context=context)
            for x in compras_requisicao_capa_dados:
                numero = x.get('numero')
            if isinstance(id, list):
                id = id[0]
            obj_model_data = self.pool.get('ir.model.data')
            reference = obj_model_data.get_object_reference(cr, uid, 'compras',
                                                            'view_compras_requisicao_itens_form')
            view_id = reference and reference[1] or False
            return {
                'res_id': id,
                'name': _('Definir Fornecedores - Req. No. ( %s )') % str(numero),
                'view_type': 'form',
                'view_mode': 'form',
                'res_model': 'compras.requisicao.itens',
                'view_id': view_id,
                'target': 'new',
                'type': 'ir.actions.act_window',
            }
        return {}

    def button_processar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, list):
            ids = ids[0]
        return {
            'name': _('Itens da Requisicao'),
            'view_type': 'form',
            'view_mode': 'tree, form',
            'res_model': 'compras.cotacoes.itens',
            'view_id': False,
            'target': 'new',
            'type': 'ir.actions.act_window',
            'domain': [('requisicao_itens_id', '=', ids)]
        }

    def button_ver_cotacoes(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, list):
            ids = ids[0]
        obj_model_data = self.pool.get('ir.model.data')
        reference = obj_model_data.get_object_reference(cr, uid, 'compras',
                                                        'view_compras_cotacao_por_itens_form')
        view_id = reference and reference[1] or False
        brw_req_item = self.browse(cr, uid, ids, context)
        produto_codigo = brw_req_item.produto_id.codigo
        produto_nome = brw_req_item.produto_id.name
        return {
            'name': ('Cotacoes para o item %s - %s' % (produto_codigo, produto_nome)),
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'compras.requisicao.itens',
            'view_id': [view_id],
            'res_id': ids,
            'target': 'new',
            'type': 'ir.actions.act_window',
        }

    def onchange_requisicao_vencedora(self, cr, uid, ids, cotacao_item_id, context=None):
        context = context and context.copy() or {}
        val = {}
        if cotacao_item_id:
            obj_cot_item = self.pool.get('compras.cotacoes.itens')
            brw_cot_item = obj_cot_item.browse(cr, uid, cotacao_item_id)
            _fornecedor = brw_cot_item.cotacao_id.fornecedor_id.pessoa_id.nome
            _valor = brw_cot_item.valor
            val['fornecedor'] = _fornecedor
            val['vr_tot_cotacao'] = _valor
        return {'value': val}

    def botao_atualizar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return {}

    def comrit_get_item_dados(self, cr, uid, ids, context=None):
        """
        O metodo reune os dados dos itens da requisicao para montagem da planilha xls.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dados com valores contextuais.
        :type context: dict
        :return: dados dos itens e do tipo de codigo que sera usado.
        :rtype: dict
        """
        context = context and context.copy() or {}
        brw_compras_requisicao_itens = self.browse(cr, uid, ids, context)
        tipo_codigo = 'CODIGO INTERNO'
        automacao_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(
            cr, uid, 'automacao', context)
        obj_automacao_codigo_barra = self.pool.get('automacao.codigo.barra')
        if automacao_instalado:
            tipo_codigo = 'CODIGO DE BARRAS'
        res = {'codigo': tipo_codigo}
        item_dados = list()
        custo_dados = self.pool.get('estoque.preco.custo').get_custos_do_dia(
            cr, uid, list(set(map(lambda i: i.produto_id.id, brw_compras_requisicao_itens))),
            context=context)
        for item in brw_compras_requisicao_itens:
            qtd_embalagem = 1.0
            if item.comrit_produto_embalagem_id.embalagem_id:
                qtd_embalagem = item.comrit_produto_embalagem_id.embalagem_id.\
                    quantidade_na_embalagem or 1.0
            custo = 0.0
            if custo_dados.get(item.produto_id.id):
                custo = custo_dados.get(item.produto_id.id).get('estprc_custo_reposicao') or 0.0
            codigo = item.produto_id.codigo or ''
            if automacao_instalado:
                args_codigo_barra = [('produto_id', '=', item.produto_id.id)]
                if item.grade_id:
                    args_codigo_barra.append(('grade_id', '=', item.grade_id.id))
                codigo_barra_ids = obj_automacao_codigo_barra.search(
                    cr, uid, args_codigo_barra, limit=1, context=context)
                if codigo_barra_ids:
                    codigo = obj_automacao_codigo_barra.browse(
                        cr, uid, codigo_barra_ids[0], context).codigo_barra or ''
                else:
                    codigo = ''
            vals = {'codigo': codigo,
                    'produto': item.grade_id.name or (item.produto_id.name or ''),
                    'grade': item.grade_id.grade or '',
                    'qtd_embalagem': qtd_embalagem,
                    'qtd_solicitada': item.quantidade,
                    'custo': custo}
            item_dados.append(vals)
        res['dados'] = item_dados
        return res
