# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class compras_solicitacao_item(osv.Model):
    """
    Tabela de itens da solicitacao
    """

    _name = 'compras.solicitacao.item'                                              # comsit
    _inherit = 'compras.solicitacao.item'

    def onchange_auto_grade(self, cr, uid, ids, produto_id, context=None):
        context = context and context.copy() or {}
        val = {}
        if not produto_id:
            return {'value': {'grade_id': False}}
        grade_id = self.pool.get('estoque.produto.grade').search(cr, uid, [('produto_id', '=', produto_id)],
                                                                 context=context)
        if len(grade_id) == 1:
            if isinstance(grade_id, list):
                grade_id = grade_id[0]
            val['grade_id'] = grade_id
        else:
            val['grade_id'] = False
        embalagem_id = self.pool.get('estoque.produto.embalagem').search(cr, uid, [('produto_id', '=', produto_id)],
                                                                         context=context)
        if len(embalagem_id) == 1:
            if isinstance(embalagem_id, list):
                embalagem_id = embalagem_id[0]
            val['comsit_produto_embalagem_id'] = embalagem_id
        else:
            val['comsit_produto_embalagem_id'] = False
        return {'value': val}

    def comsit_onchange_quantidade(self, cr, uid, ids, quantidade, context=None):
        """
        Verifica se a quantidade informada e maior que zero.

        @param cr: {cursor} a linha atual do cursor do banco de dados,
        @param uid: {int} o ID do usuário utilizado para a verificacao de perfil,
        @param ids: {list} lista dos IDs,
        @param quantidade: {float} quantidade solicitada,
        @return: {dict} mensagem de erro se a quantidade for igual ou inferior a
        zero.
        """
        context = context and context.copy() or {}
        result = {'value': ''}
        if not quantidade:
            result = {'warning': {'title': _('Aviso'),
                                  'message': _('Quantidade deve ser informada.')}}
        return result

    def create(self, cr, user, vals, context=None):
        context = context and context.copy() or {}
        vals['quantidade_atendida'] = vals['quantidade']
        res = super(compras_solicitacao_item, self).create(cr, user, vals, context)
        return res

    def unlink(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_solicitacao = self.pool.get('compras.solicitacao.capa')
        id = obj_solicitacao.search(cr, uid, [('solicitacao_item_ids', '=', ids[0])], context=context)
        if id:
            state = obj_solicitacao.read(cr, uid, id, ['state'], context=context)[0]['state']
            if state != 'E':
                raise osv.except_osv(_('Atencao'), _(
                    'A alteracao do item e permitida somente quando a solicitacao estiver em Esboco.'))
        res = super(compras_solicitacao_item, self).unlink(cr, uid, ids, context=context)
        return res

