# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class compras_parametros(osv.Model):
    """
    Parâmetros de configuracao de email para o modulo compras.
    O envio automático de cotacao para o fornecedor requer um conta de e-mail
    para envio e recebimento das cotacoes.
    """

    _inherit = 'ir.mail_server'
    _columns = {
        'tipo_servidor_entrada': fields.selection([("IMAP", "IMAP"), ("POP3", "POP3")], "Tipo de servidor de entrada",
                                                  size=4),
        'servidor_entrada': fields.char("Servidor de entrada", size=30),
        'porta_entrada': fields.integer("Porta"),
        'login_entrada': fields.char("Login", size=50),
        'senha_entrada': fields.char("Senha", size=50),
        'ssl_entrada': fields.boolean("Usar conexao segura (SSL)"),
        'pasta_imap': fields.char('Pasta', size=50),
        'dir_cotacao': fields.char('Dir.importacao das Cotacoes ', size=50),
    }

    _defaults = {
        'tipo_servidor_entrada': lambda *a: 'IMAP',
        'porta_entrada': lambda *a: 110,
        'ssl_entrada': lambda *a: True,
    }
