# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
import time


class estoque_produto_grade(osv.Model):

    _inherit = 'estoque.produto.grade'

    def estpgr_get_saldo_menor_minimo(self, cr, uid, company_id=False, context=None):
        """
        O metodo identifica os registros de grade que controlam minimo e maximo e cujo saldo atual
        e menor que o minimo cadastrado.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param company_id: id da tabela res_company, identificador da empresa
        :type company_id: int
        :param context: dados contextuais.
        :type context: dict
        :return: conjunto de registros da tabela desse objeto.
        :rtype: list
        """
        context = context and context.copy() or {}
        if not company_id:
            company_id = self.pool.get('adm.empresa.objeto').getEmpresa(
                cr, uid, 'estoque.produto.saldo')
        produto_grade_ids = self.search(cr, uid, [('minimo', '>', 0), ('maximo', '>', 0)])
        estoque_produto_grade_dados = self.read(cr, uid, produto_grade_ids, ['minimo'],
                                                context=context)
        grade_saldo_dados = self.pool.get('estoque.produto.saldo').get_saldo_do_dia(
            cr, uid, eps_grade_ids=produto_grade_ids, eps_data=time.strftime('%Y-%m-%d'),
            company_id=company_id)
        saldo_grade_ids = grade_saldo_dados.keys()
        grade_ids = list()
        for grade in estoque_produto_grade_dados:
            grade_id = grade.get('id')
            if grade_id not in saldo_grade_ids:
                continue
            if grade_saldo_dados.get(grade_id).get('disponivel') < grade.get('minimo'):
                grade_ids.append(grade_id)
        return grade_ids

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        if context.get('alerta_painel'):
            limit = None
        return super(estoque_produto_grade, self).search(cr, uid, args, offset, limit, order,
                                                         context, count)
