#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv


class estoque_gerar_contagem_osv(osv.TransientModel):
    _name = 'estoque.gerar.contagem.osv'
    _inherit = 'estoque.gerar.contagem.osv'

    def gerar_inventario(self, cr, uid, ids, context=None, **kwargs):
        """
        Este metodo sobrescreve o metodo gerar_inventario da classe estoque.gerar.contagem.osv
        do estoque, para colocar o comprador_id que foi informado pode ser informado ao gerar o
        inventario caso o modulo compras esteja instalado
        :param cr: Cursor do openerp
        :param uid: Id do usuario requisita
        :param ids: Lista de ids gerados pela wizard
        :type cr: Curosr
        :type uid: int
        :type ids: int | long
        :type context: dict
        :rtype: bool
        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        context = context and context.copy() or {}
        brw_gerar_contagem = self.browse(cr, uid, ids[0], context=context)
        comprador_id = False
        if brw_gerar_contagem.comprador_id:
            comprador_id = brw_gerar_contagem.comprador_id.id
        return super(estoque_gerar_contagem_osv, self).gerar_inventario(
            cr, uid, ids, context=context, comprador_id=comprador_id, **kwargs)
