# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
from openerp.report import report_sxw
import time
import base64
import random
import string
from decimal import Decimal, ROUND_DOWN
from SigUtils.datas import calcVencimentos


def random_name():
    random.seed()
    d = [random.choice(string.ascii_letters) for x in xrange(3)]
    name = "".join(d)
    return name


class estsug_compra_capa(osv.Model):

    # prefixo: esgccp_

    _inherit = 'estsug.compra.capa'

    def esgccp_button_gerar_requisicao(self, cr, uid, ids, context=None):
        """
        O metodo cria a requisicao de compra (compras.requisicao.capa) para os itens da sugestao de
        compra.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: id da nova requisicao de compra criada.
        :rtype: int
        """
        context = context and context.copy() or {}
        res = False
        obj_compras_requisicao_capa = self.pool.get('compras.requisicao.capa')
        obj_estoque_local_locacao = self.pool.get('estoque.local.locacao')

        local_venda_padrao_id = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', 'local_venda_padrao_id').get('local_venda_padrao_id')

        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'compras.requisicao.capa', context=context)

        for sugestao in self.browse(cr, uid, ids, context):

            local_id = sugestao.esgccp_local_id.id
            if not local_id:
                local_id = local_venda_padrao_id

            str_produto_sem_embalagem = ''

            item_ids = filter(lambda i: i.esgcit_sugestao, sugestao.esgccp_item_ids)

            company_ids = list(set(map(lambda i: i.esgcit_empresa, item_ids)))

            for company in company_ids:
                company_item_ids = filter(lambda i: i.esgcit_empresa == company, item_ids)
                requisicao_itens_ids = list()
                for item in company_item_ids:

                    produto_id = item.esgcit_produto_id.id
                    grade_id = item.esgcit_grade_id.id

                    locacao_ids = obj_estoque_local_locacao.search(
                        cr, uid, [('local_id', '=', local_id), ('produto_id', '=', produto_id),
                                  ('grade_id', '=', grade_id), ('company_id', '=', company)],
                        context=context)
                    produto_embalagem_id = False
                    if locacao_ids:
                        produto_embalagem_id = obj_estoque_local_locacao.browse(
                            cr, uid, locacao_ids[0]).estllc_produto_embalagem_id.id
                    if not produto_embalagem_id:
                        str_produto_sem_embalagem += '%s \n' % item.esgcit_produto_id.name
                        continue

                    requisicao_itens_ids.append(
                        (0, 0, {'produto_id': produto_id,
                                'grade_id': grade_id,
                                'quantidade': item.esgcit_sugestao,
                                'comrit_produto_embalagem_id': produto_embalagem_id}))

                if str_produto_sem_embalagem:
                    raise osv.except_osv(_('Atencao'),
                                         _('Embalagem nao cadastrada para os produtos: %s' %
                                           str_produto_sem_embalagem))

                if not requisicao_itens_ids:
                    continue
                context.update({'sig_force_company': True, 'requisicao_company_id': company,
                                'force_company': company})

                res = obj_compras_requisicao_capa.create(
                    cr, uid, {'company_id': company, 'requisicao_itens_ids': requisicao_itens_ids},
                    context)
                del context['sig_force_company']
                del context['requisicao_company_id']
                del context['force_company']

        if res:
            self.write(cr, uid, ids, {'esgccp_requisicao_gerada': True}, context)

        return res

    def esgccp_gerar_pedido(self, cr, uid, ids, pessoa_id, data_entrega, prazo, prazo_tipo,
                            vr_frete, prazo_datas, context=None):
        """
        O metodo cria um novo registro de pedido (estoquepedidos_pedido_capa) baseados nos itens
        que foram sugestivos de compra
        :param cr: cursor no banco de dados
        :param uid: id da tabela res_users, identificador do usuario
        :param ids: lista de id dessa tabela
        :param context: dicionario com valores contextuais
        :return: True
        """

        context = context and context.copy() or {}
        obj_estoquepedidos_pedido_capa = self.pool.get('estoquepedidos.pedido.capa')
        obj_res_company = self.pool.get('res.company')
        obj_estsug_compra_item = self.pool.get('estsug.compra.item')
        obj_estoque_local_locacao = self.pool.get('estoque.local.locacao')
        fields_read = ['esgccp_fornecedor_id', 'esgccp_comprador_id', 'esgccp_local_id',
                       'esgccp_item_ids']
        estsug_compra_dados = self.pool.get('estsug.compra.capa').read(
            cr, uid, ids, fields_read, context=context, load='_classic_write')
        pedido_ids = list()
        for x in estsug_compra_dados:
            comprador_id = x.get('esgccp_comprador_id')
            item_ids = x.get('esgccp_item_ids')
            vals_pedido_capa = {'pessoa_id': pessoa_id, 'tipo': 'C', 'comprador_id': comprador_id,
                                'data_entrega': data_entrega, 'pedcap_prazo': prazo,
                                'pedcap_prazo_tipo': prazo_tipo, 'vr_frete': vr_frete}
            fields_read = ['esgcit_produto_id', 'esgcit_grade_id', 'esgcit_sugestao',
                           'esgcit_custo', 'esgcit_empresa']
            estsug_compra_item_dados = obj_estsug_compra_item.read(
                cr, uid, item_ids, fields_read, context=context)
            str_produto_sem_embalagem = ''

            company_ids = list(set(map(lambda i: i.get('esgcit_empresa'),
                                       estsug_compra_item_dados)))
            dict_company_ids = dict()
            map(lambda i: dict_company_ids.update({i.id: '%s-%s' % (i.id, i.name)}),
                obj_res_company.browse(cr, uid, company_ids, context))

            for company in company_ids:

                sql = """
                    SELECT estpar_local_compra_padrao_id
                    FROM estoque_parametro
                    WHERE company_id = %s
                """ % company
                cr.execute(sql)
                estoque_parametro_dados = cr.dictfetchone()
                local_id = estoque_parametro_dados.get('estpar_local_compra_padrao_id')
                if not local_id:
                    raise osv.except_osv(_('Atencao'),
                                         _('Cadastre o "Local para entradas" no parametro do '
                                           'estoque para a empresa:\n %s' % dict_company_ids.get(
                                             company)))

                company_item_ids = filter(lambda i: i.get('esgcit_empresa') == company and
                                          i.get('esgcit_sugestao') > 0,
                                          estsug_compra_item_dados)
                pedido_item_ids = list()
                vals_pedido_capa['company_id'] = company
                for y in company_item_ids:
                    produto_id = y.get('esgcit_produto_id')[0]
                    grade_id = y.get('esgcit_grade_id')[0]
                    locacao_ids = obj_estoque_local_locacao.search(
                        cr, uid, [('local_id', '=', local_id), ('produto_id', '=', produto_id),
                                  ('grade_id', '=', grade_id)], context=context)
                    produto_embalagem_id = False
                    if locacao_ids:
                        produto_embalagem_id = obj_estoque_local_locacao.browse(
                            cr, uid, locacao_ids[0]).estllc_produto_embalagem_id.id
                    if not produto_embalagem_id:
                        str_produto_sem_embalagem += '%s \n' % y.get('esgcit_produto_id')[1]
                        continue
                    quantidade = y.get('esgcit_sugestao')
                    valor = y.get('esgcit_custo')
                    vals_pedido_item = {
                        'local_id': local_id,
                        'produto_id': produto_id,
                        'grade_id': grade_id,
                        'produto_embalagem_id': produto_embalagem_id,
                        'qtde_pedida': quantidade,
                        'vr_unitario': valor
                    }
                    pedido_item_ids.append((0, 0, vals_pedido_item))
                if not pedido_item_ids:
                    continue
                vals_pedido_capa['pedido_item_ids'] = pedido_item_ids
                context.update({'sig_force_company': True, 'pedido_company_id': company,
                                'force_company': company})
                pedido_ids.append(obj_estoquepedidos_pedido_capa.create(cr, uid, vals_pedido_capa,
                                                                        context=context))
                del context['sig_force_company']
                del context['pedido_company_id']
                del context['force_company']
            if str_produto_sem_embalagem:
                raise osv.except_osv(_('Atencao'), _('Embalagem nao cadastrada para os produtos: '
                                                     '%s' % str_produto_sem_embalagem))

        if not pedido_ids:
            return pedido_ids

        obj_estoquepedidos_pedido_capa.write(cr, uid, pedido_ids, context)

        pedido_capa_dados = obj_estoquepedidos_pedido_capa.read(cr, uid, pedido_ids,
                                                                ['valor_total'], context=context)
        for pedido in pedido_capa_dados:
            pedido_id = pedido.get('id')
            valor_total = pedido.get('valor_total') or 0
            obj_pedido_parcelas = self.pool.get('estoquepedidos.pedido.parcela')
            if prazo_datas:
                list_vencimentos = prazo_datas.split(',')
            else:
                prazo = prazo.replace(' ', '').replace('/', ',')
                list_prazos = prazo.split(',')
                list_vencimentos = calcVencimentos(data=time.strftime('%Y-%m-%d'),
                                                   listaPrazos=list_prazos, tipoPrazo=prazo_tipo)
            if list_vencimentos:
                qtde_vencimentos = len(list_vencimentos) or 1
                valor_total_vencimento = valor_total / qtde_vencimentos
                valor_total_vencimento = float(
                    Decimal(str(valor_total_vencimento)).quantize(Decimal('.01'),
                                                                  rounding=ROUND_DOWN))
                context.update({'permiti_gravar': True})
                count_vencimentos = 0
                valor_lancado = 0
                for vencimento in list_vencimentos:
                    count_vencimentos += 1
                    if count_vencimentos == qtde_vencimentos:
                        valor_total_vencimento = str(valor_total - valor_lancado)
                    else:
                        valor_lancado += valor_total_vencimento

                    obj_pedido_parcelas.create(cr, uid,
                                               {'vr_parcela': valor_total_vencimento,
                                                'data_vencimento': vencimento,
                                                'pedido_compra_id': pedido_id}, context=context)

            obj_estoquepedidos_pedido_capa.button_validar(cr, uid, [pedido_id], context)

        self.write(cr, uid, ids, {'esgccp_pedido_gerado': True,
                                  'esgccp_pedidos': str(pedido_ids)}, context)

        return pedido_ids

    def esgccp_abrir_wizard_gerar_pedido(self, cr, uid, ids, context=None):
        """
        O metodo processa uma acao que abri uma nova janela para inserir demais dados dos pedidos.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: dados para execucao de uma acao.
        :rtype: dict
        """
        context = context and context.copy() or {}
        reference = self.pool.get('ir.model.data').get_object_reference(
            cr, uid, 'compras', 'view_wizard_estsug_compra_gerar_pedido_form')
        view_id = reference and reference[1] or False
        return {
            'name': 'Gerar pedido',
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'wizard.estsug.compra.gerar.pedido',
            'view_id': [view_id],
            'target': 'new',
            'type': 'ir.actions.act_window'}

    def esgccp_button_imprimir_pedido(self, cr, uid, ids, context=None):
        """
        O metodo gera os arquivos pdf dos pedidos, para download.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: Verdadeiro.
        :rtype: bool
        """
        context = context and context.copy() or {}
        cr.execute("""DELETE FROM estsug_compra_pedido""")
        obj_ir_act_report_xml = self.pool.get('ir.actions.report.xml')
        obj_estoquepedidos_pedido_capa = self.pool.get('estoquepedidos.pedido.capa')
        report_id = obj_ir_act_report_xml.search(
            cr, uid, [('report_name', '=', 'estoquepedidos.pedido.capa')], context=context)
        report_xml = obj_ir_act_report_xml.browse(cr, uid, report_id[0], context)

        dados_parametro = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', ['estpar_pedido_formato_impressao',
                                 'estpar_pedido_retrato_paisagem'])
        formato = dados_parametro.get('estpar_pedido_formato_impressao')
        modo = dados_parametro.get('estpar_pedido_retrato_paisagem')
        path = '/estoquepedidos/report/rel_estoquepedidos2.rml'
        self.pool.get('estoque.parametro').estpar_converte_formato_impressao(cr, uid, formato, path,
                                                                             'p', modo)

        for sugestao in self.browse(cr, uid, ids, context):
            pedido_ids = eval(sugestao.esgccp_pedidos)
            brw_estoquepedidos_pedido_capa = obj_estoquepedidos_pedido_capa.browse(
                cr, uid, pedido_ids, context)
            vals_report_pedido_ids = list()
            for pedido in brw_estoquepedidos_pedido_capa:
                try:
                    pedido.numero_pedido
                except:
                    continue
                context['pedido_ids'] = [pedido.id]
                report_pdf = report_sxw.report_sxw(
                    'report.' + pedido.numero_pedido + random_name(), 'estoquepedidos.pedido.capa',
                    'estoquepedidos/report/rel_estoquepedidos2.rml',
                    parser=rel_estsug_compra_pedido).create_single_pdf(
                    cr, uid, [pedido.id], {'report_type': 'pdf'}, report_xml, context)
                nome_arquivo = pedido.numero_pedido + ' - ' + str(pedido.company_id.id) + '.pdf'
                vals_report_pedido_ids.append(
                    (0, 0, {'esgped_dado_pedido': base64.encodestring(report_pdf[0]),
                            'esgped_nome_arquivo': nome_arquivo}))
            if not vals_report_pedido_ids:
                continue
            self.write(cr, uid, sugestao.id, {'esgccp_report_pedido_ids': vals_report_pedido_ids},
                       context)
        return True


class rel_estsug_compra_pedido(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context):
        super(rel_estsug_compra_pedido, self).__init__(cr, uid, name, context)

        dados_parametro = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', ['estpar_pedido_tipo_codigo'])
        tipo_codigo = dados_parametro.get('estpar_pedido_tipo_codigo')
        obj_estoquepedidos_pedido_capa = self.pool.get('estoquepedidos.pedido.capa')
        dados_extra = obj_estoquepedidos_pedido_capa.pedcap_get_dado_extra(
            cr, uid, context.get('active_ids') or context.get('pedido_ids'), context) or {}

        self.localcontext.update({
            'time': time,
            'getNumeroEditado': self.pool.get('adm.utils').admutl_get_valor_formatado,
            'int': int,
            'tipo_codigo': tipo_codigo,
            'vendedor_externo': _('Vendedor externo:'),
            'dado_extra': dados_extra,
            'sum': sum
        })
        self.context = context
