# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################


# Funcoes da classe estoquepedidos_pedido_capa
def pedcap_get_informacao_complementar_pessoa(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    if not len(ids):
        return []
    if not isinstance(ids, list):
        ids = [ids]
    for x in ids:
        informacao_complementar_pessoa = self.browse(cr, uid, x).pessoa_id.observacoes
        res[x] = informacao_complementar_pessoa
    return res


def pedcap_compra_get_valor_ipi_total(self, cr, uid, ids, name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    if not isinstance(ids, list):
        ids = [ids]
    for id in ids:
        browse_pedido_item = self.browse(cr, uid, id).pedido_item_ids
        valor_total_ipi = 0.0
        for x in browse_pedido_item:
            valor_total = x.valor_total or 0.0
            pedite_ipi_aliquota_entrada = x.pedite_ipi_aliquota_entrada or 0.0
            if valor_total and pedite_ipi_aliquota_entrada:
                valor_total_ipi_item = valor_total * (pedite_ipi_aliquota_entrada / 100)
                valor_total_ipi += valor_total_ipi_item
        res[id] = valor_total_ipi
    return res


def _pedcap_verifica_itens(self, cr, uid, ids, name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    if ids:
        if not isinstance(ids, list):
            ids = [ids]
        browse_pedido_capa = self.browse(cr, uid, ids)
        for x in browse_pedido_capa:
            if x.pedido_item_ids:
                res[x.id] = True
            else:
                res[x.id] = False
    return res


def _pedcap_compras_get_valor_total_icms(self, cr, uid, ids, name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    if ids:
        if not isinstance(ids, list):
            ids = [ids]
        browse_pedido_capa = self.browse(cr, uid, ids, context)
        for x in browse_pedido_capa:
            total_icms_st = 0.0
            pedido_item_ids = x.pedido_item_ids
            if pedido_item_ids:
                for item in pedido_item_ids:
                    total_icms_st += item.pedite_icms_st or 0.0
            res[x.id] = total_icms_st
    return res


# Funcoes da classe estoquepedidos_pedido_item
def _pedite_get_custos(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    context = context and context.copy() or {}
    obj_estoque_preco_custo = self.pool.get('estoque.preco.custo')
    obj_estoque_preco_venda = self.pool.get('estoque.preco.venda')
    company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
    brw_pedido_item = self.browse(cr, uid, ids, context)
    for x in brw_pedido_item:
        produto_id = x.produto_id.id
        grade_id = x.grade_id.id
        preco_venda = obj_estoque_preco_venda.get_preco_venda(cr, uid, epc_produto_ids=produto_id,
                                                              epc_company_id=company_id,
                                                              epc_grade_ids=grade_id,
                                                              context=context)
        dados_preco_venda = preco_venda.get(produto_id) or {}
        preco_venda = dados_preco_venda.get(grade_id) or dados_preco_venda.get(
            'preco_venda')
        custos = obj_estoque_preco_custo.get_custos_do_dia(cr, uid, produto_id, company_id, None,
                                                           context)
        if custos and custos.get(produto_id):
            custos = custos.get(produto_id)
            res[x.id] = {'pedite_custo_medio': custos.get('estprc_custo_medio_contabil'),
                         'pedite_ultimo_custo': custos.get('estprc_ultimo_custo'),
                         'pedite_custo_reposicao': custos.get('estprc_custo_reposicao'),
                         'pedite_custo_corrigido': custos.get('estprc_custo_corrigido'),
                         'pedite_preco_venda': preco_venda,
                         }
        else:
            res[x.id] = {}.fromkeys(
                ['pedite_custo_corrigido', 'pedite_custo_medio', 'pedite_ultimo_custo', 'pedite_custo_reposicao',
                 'pedite_preco_venda'], 0.0)
    return res


def _pedite_get_estatisticas(self, cr, uid, ids, field_name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    context = context and context.copy() or {}
    obj_estoque_estatisticas_mensal_osv = self.pool.get('estoque.estatisticas.mensal.osv')
    obj_estoque_estatisticas_mensal_itens_osv = self.pool.get(
        'estoque.estatisticas.mensal.itens.osv')
    browse_pedido_item = self.browse(cr, uid, ids)
    for x in browse_pedido_item:
        res[x.id] = list()
        produto_id = x.produto_id.id
        grade_id = x.grade_id.id
        local_id = x.local_id.id
        res[x.id] = []
        if produto_id and local_id and grade_id:
            context['estatisticas_pedido_compra'] = True
            context['local_id'] = local_id
            context['produto_id'] = produto_id
            context['grade_id'] = grade_id
            estatistica_id = obj_estoque_estatisticas_mensal_osv.estesm_funcao_pesquisar(cr, uid, None, context)
            if estatistica_id:
                estatisticas_itens_ids = obj_estoque_estatisticas_mensal_itens_osv.search(cr, uid, [
                    ('estatistica_mensal_id', '=', estatistica_id)], context=context)
                res[x.id] = estatisticas_itens_ids
    return res

def _pedite_get_informacao_complementar_produto(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    if not len(ids):
        return []
    if not isinstance(ids, list):
        ids = [ids]
    for x in ids:
        informacao_complementar_produto = self.browse(cr, uid, x).produto_id.estpro_informacoes_compras
        res[x] = informacao_complementar_produto
    return res


# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

