# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from datetime import date
from decimal import Decimal, ROUND_DOWN
from SigUtils.datas import calcVencimentos
from dateutil.relativedelta import relativedelta
from dateutil.parser import parse
from openerp.tools.translate import _


class estoquepedidos_pedido_capa(osv.Model):
    _name = 'estoquepedidos.pedido.capa'
    _inherit = 'estoquepedidos.pedido.capa'

    def pedcap_onchange_fornecedor(self, cr, uid, ids, pessoa_id, context=None):
        context = context and context.copy() or {}
        res = {}
        if pessoa_id:
            informacao_complementar_pessoa = self.pool.get('adm.pessoa').browse(cr, uid, pessoa_id).observacoes
            res['pedcap_informacao_complementar_pessoa'] = informacao_complementar_pessoa
        return {'value': res}

    def pedcap_button_parcelas_compra(self, cr, uid, ids, context=None):
        res = []
        context = context and context.copy() or {}
        if isinstance(ids, list) and ids:
            ids = ids[0]
        if ids:
            pedido_capa_dados = self.read(cr, uid, ids,
                                          ['pedcap_prazo', 'pedcap_prazo_tipo', 'valor_total', 'data_emissao'], context=context)
            if isinstance(pedido_capa_dados, list) and pedido_capa_dados:
                pedido_capa_dados = pedido_capa_dados[0]
            if isinstance(pedido_capa_dados, dict):
                pedido_id = pedido_capa_dados['id']
                data_emissao = pedido_capa_dados.get('data_emissao')
                prazo = pedido_capa_dados.get('pedcap_prazo')
                prazo_tipo = pedido_capa_dados.get('pedcap_prazo_tipo')
                if not prazo or not prazo_tipo:
                    return res
                valor_total = pedido_capa_dados.get('valor_total') or 0
                obj_pedido_parcelas = self.pool.get('estoquepedidos.pedido.parcela')
                compra_parcela_ids = obj_pedido_parcelas.search(cr, uid, [('pedido_compra_id', '=', pedido_id)],
                                                                context=context)
                if compra_parcela_ids:
                    obj_pedido_parcelas.unlink(cr, uid, compra_parcela_ids, context=context)
                prazo = prazo.replace(' ', '').replace('/', ',')
                list_prazos = prazo.split(',')
                list_vencimentos = calcVencimentos(data=data_emissao, listaPrazos=list_prazos, tipoPrazo=prazo_tipo)
                if list_vencimentos:
                    qtde_vencimentos = len(list_vencimentos) or 1
                    valor_total_vencimento = valor_total / qtde_vencimentos
                    valor_total_vencimento = float(
                        Decimal(str(valor_total_vencimento)).quantize(Decimal('.01'), rounding=ROUND_DOWN))
                    context.update({'permiti_gravar': True})
                    count_vencimentos = 0
                    valor_lancado = 0
                    for vencimento in list_vencimentos:
                        count_vencimentos += 1
                        if count_vencimentos == qtde_vencimentos:
                            valor_total_vencimento = str(valor_total - valor_lancado)
                        else:
                            valor_lancado += valor_total_vencimento

                        parcela_id = obj_pedido_parcelas.create(cr, uid, {'vr_parcela': valor_total_vencimento,
                                                                          'data_vencimento': vencimento,
                                                                          'pedido_compra_id': pedido_id
                        }, context=context)
                        res.append(parcela_id)
        return res

    def pedcap_importar_itens_numero_descricao(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (list, tuple)):
            ids = ids[0]
        obj_estoque_fornecedor = self.pool.get('estoque.fornecedor')
        obj_financeiro_fornecedor = self.pool.get('financeiro.fornecedor')
        obj_estoque_produto_grade = self.pool.get('estoque.produto.grade')
        obj_estoquepedidos_pedido_item = self.pool.get('estoquepedidos.pedido.item')
        obj_estoque_produto_embalagem = self.pool.get('estoque.produto.embalagem')
        if context.get('numero'):
            order = 'id ASC'
        else:
            order = 'name ASC'
        vals = {}
        produto_ids = []
        list_produto_name = []
        ids_produto = []
        pessoa_id = self.browse(cr, uid, ids).pessoa_id.id
        fornecedor_id = obj_financeiro_fornecedor.search(cr, uid, [('pessoa_id', '=', pessoa_id)], context=context)
        if fornecedor_id:
            estoque_fornecedor_ids = obj_estoque_fornecedor.search(cr, uid, [('fornecedor_id', '=', fornecedor_id[0])],
                                                                   0, None, order, context=context)
            if estoque_fornecedor_ids:
                browse_estoque_fornecedor = obj_estoque_fornecedor.browse(cr, uid, estoque_fornecedor_ids)
                for x in browse_estoque_fornecedor:
                    list_produto_name.append(x.produto_id.name)
                    if order == 'name ASC':
                        produto_ids.append(x.produto_id)
                    else:
                        produto_ids.append(x.produto_id.id)
                list_produto_name.sort()
            if order == 'name ASC':
                ids_produto = []
                for x in list_produto_name:
                    for i in produto_ids:
                        if i.name == x:
                            ids_produto.append(i.id)
            if ids_produto:
                produto_ids = ids_produto
            if produto_ids:
                local_id = obj_estoquepedidos_pedido_item.pedite_get_local_venda_padrao(cr, uid, {'tipo': 'C'})
                if not local_id:
                    raise osv.except_osv(_('Atencao'),
                                         _("O 'local para entradas' deve ser configurado nos parametros do estoque."))
                for x in produto_ids:
                    vals['pedido_id'] = ids
                    vals['produto_id'] = x
                    vals['local_id'] = local_id
                    vals['vr_unitario'] = 0.0
                    vals['qtde_pedida'] = 0.0
                    grade_ids = obj_estoque_produto_grade.search(cr, uid, [('produto_id', '=', x)], context=context)
                    for grade_id in grade_ids:
                        vals['grade_id'] = grade_id
                        produto_embalagem_id = obj_estoquepedidos_pedido_item.get_local_embalagem(
                            cr, uid, local_id, x, grade_id)
                        if produto_embalagem_id:
                            vals['produto_embalagem_id'] = produto_embalagem_id
                        else:
                            produto_embalagem_id = obj_estoque_produto_embalagem.search(
                                cr, uid, [('produto_id', '=', x)], context=context)
                            if len(produto_embalagem_id) == 1:
                                vals['produto_embalagem_id'] = produto_embalagem_id[0]
                        context['pedcap_importa_itens'] = True
                        obj_estoquepedidos_pedido_item.create(cr, uid, vals, context)
            else:
                raise osv.except_osv(_('Atencao'), _('Nao ha produtos cadastrados para este fornecedor'))
        return True

    def pedcap_consultar_pedidos(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        pessoa_id = self.browse(cr, uid, ids[0]).pessoa_id.id
        if pessoa_id:
            obj_model_data = self.pool.get('ir.model.data')
            reference = obj_model_data.get_object_reference(cr, uid, 'compras',
                                                            'view_estoquepedidos_pedido_capa_compras_tree')
            view_id = reference and reference[1] or False
            return {
                'name': 'Pedidos de Compra',
                'view_type': 'form',
                'view_mode': 'tree',
                'domain': [('pessoa_id', '=', pessoa_id), ('tipo', '=', 'C')],
                'res_model': 'estoquepedidos.pedido.capa',
                'view_id': [view_id],
                'target': 'new',
                'type': 'ir.actions.act_window',
            }
        return True



    def botao_atualizar_pedido(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if ids:
            self.write(cr, uid, ids, {}, context)
        return True

    def pedcap_verifica_validade_pedido_compra(self, cr, uid, context=None):
        context = context and context.copy() or {}
        obj_estoquepedidos_pedido_capa = self.pool.get('estoquepedidos.pedido.capa')
        obj_estoque_parametro = self.pool.get('estoque.parametro')
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
        parametro_id = obj_estoque_parametro.search(cr, uid, [('company_id', '=', company_id)], context=context)
        if parametro_id:
            estpar_validade_pedido_compra = obj_estoque_parametro.browse(cr, uid,
                                                                         parametro_id[0]).estpar_validade_pedido_compra

            pedido_ids = obj_estoquepedidos_pedido_capa.search(cr, uid, [('state', '=', 'V'),
                                                                         ('data_entrega', '!=', False),
                                                                         ('tipo', '=', 'C')], context=context)
            if pedido_ids:
                data_hoje = str(date.today())
                data_hoje = parse(data_hoje, yearfirst=True)
                dados_pedidos = obj_estoquepedidos_pedido_capa.read(cr, uid, pedido_ids, ['data_entrega'], context=context)
                for pedido in dados_pedidos:
                    data_entrega = parse(pedido.get('data_entrega'), yearfirst=True)
                    data_valida = data_entrega + relativedelta(day=estpar_validade_pedido_compra)
                    if data_valida < data_hoje:
                        obj_estoquepedidos_pedido_capa.button_cancelar(cr, uid, [pedido.get('id')], context=context)
        return True

    def fields_view_get(self, cr, uid, view_id=None, view_type='form', context=None, toolbar=False,
                        submenu=False):
        context = context and context.copy() or {}
        res = super(estoquepedidos_pedido_capa, self).fields_view_get(
            cr, uid, view_id, view_type, context, toolbar, submenu)
        view_name = context.get('view_name')
        toolbar = res.get('toolbar')
        if not toolbar:
            return res
        if view_name == 'estoquepedidos_compra' and toolbar.get('print') and view_type == 'form':
            del res['toolbar']['print']
        if view_name != 'estoquepedidos_venda':
            return res
        if toolbar.get('print'):
            del res['toolbar']['print']
        return res
