# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoquepedidos_pedido_capa(osv.Model):
    from funcoes import pedcap_get_informacao_complementar_pessoa, \
        pedcap_compra_get_valor_ipi_total, _pedcap_verifica_itens, \
        _pedcap_compras_get_valor_total_icms

    _name = 'estoquepedidos.pedido.capa'
    _inherit = 'estoquepedidos.pedido.capa'
    _columns = {
        'pedido_compra_parcela_ids': fields.one2many('estoquepedidos.pedido.parcela', 'pedido_compra_id', 'Parcelas'),
        'comprador_id': fields.many2one("compras.comprador", 'Comprador', ondelete="restrict", select=True),
        'pedcap_prazo': fields.char("Prazo", size=60, help="Prazo em dias, separado por VIRGULA(,) ou BARRA(/)"),
        'pedcap_prazo_tipo': fields.selection([('DD', 'Dias Direto'), ('DFS', 'Dias Fora a Semana'),
                                               ('DFQ', 'Dias fora a quinzena'), ('DFM', 'Dias Fora o Mes')],
                                              'Tipo de prazo', size=3),
        'pedcap_informacao_complementar_pessoa': fields.function(pedcap_get_informacao_complementar_pessoa, method=True,
                                                                 string="Inf. fornecedor", type='text', store=False),
        'pedcap_compra_valor_ipi': fields.function(pedcap_compra_get_valor_ipi_total, method=True,
                                                   string='Valor do IPI', type='float', store=False),
        'pedcap_requisicao_compras_id': fields.many2one('compras.requisicao.capa', 'Requisicao'),
        'pedcap_flag_verifica_itens': fields.function(_pedcap_verifica_itens, method=True, string='Flag',
                                                      type='boolean', store=False),
        'pedcap_icms_st': fields.function(_pedcap_compras_get_valor_total_icms, method=True, strig="Total ICMS ST",
                                          type="float", store=True),
    }
    _defaults = {
        'pedcap_flag_verifica_itens': False,
        'pedcap_prazo_tipo': 'DD',
    }

