# -*- coding: utf-8 -*-

from openerp.osv import osv, fields


class estoquepedidos_pedido_item(osv.Model):
    from funcoes import _pedite_get_custos
    from funcoes import _pedite_get_estatisticas
    from funcoes import _pedite_get_informacao_complementar_produto

    _inherit = 'estoquepedidos.pedido.item'
    _columns = {
        'pedite_custo_medio': fields.function(
            _pedite_get_custos, method=True, multi='custo', string="Custo Medio", digits=(15, 3)),
        'pedite_ultimo_custo': fields.function(
            _pedite_get_custos, method=True, multi='custo', string="Ultimo Custo", digits=(15, 3)),
        'pedite_custo_reposicao': fields.function(
            _pedite_get_custos, method=True, multi='custo', string="Custo de Reposicao",
            digits=(15, 3)),
        'pedite_custo_corrigido': fields.function(
            _pedite_get_custos, method=True, multi='custo', string="Custo Corrigido",
            digits=(15, 3)),
        'pedite_preco_venda': fields.function(
            _pedite_get_custos, method=True, multi='custo', string="Preco Venda", digits=(15, 3)),
        'pedite_estoque_estatisticas_ids': fields.function(
            _pedite_get_estatisticas, method=True, string="Estatisticas", type="one2many",
            relation="estoque.estatisticas.mensal.itens.osv"),
        'pedite_icms_st': fields.float('ICMS ST', digits=(15, 2)),
        'pedite_informacao_complementar_produto': fields.function(_pedite_get_informacao_complementar_produto, method=True,
                                                                 string="Inf.p/Compras", type='text', store=False),
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
