# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class compras_comprador(osv.Model):
    """
    Tabela de Compradores da empresa.

    prefixo: comcpr_
    """

    _name = 'compras.comprador'
    _rec_name = 'pessoa_id'
    _inherits = {
        'adm.pessoa': 'pessoa_id',
    }
    _roteavel = True
    _columns = {
        'pessoa_id': fields.many2one("adm.pessoa", 'Pessoa', ondelete="cascade", required=True, select=True),
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True), # id da empresa
        'estoque_produto_ids': fields.one2many('estoque.produto', 'comprador_id', 'Produto'),
        'estoque_categoria_ids': fields.one2many('estoque.categoria', 'comprador_id', 'Categoria'),
        'estoquepedidos_pedido_capa_ids': fields.one2many('estoquepedidos.pedido.capa', 'comprador_id', 'Capa'),
        'comcpr_supervisor_id': fields.many2one('compras.comprador', 'Supervisor'),
        'comcpr_subordinados_ids': fields.one2many('compras.comprador', 'comcpr_supervisor_id', 'Subordinados'),
        'comcpr_responder_por_id': fields.many2one('compras.comprador', 'Responder por'),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }
