    # -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class compras_cotacoes_capa(osv.Model):
    """
    Tabela de cotacao
    """

    from funcoes import _comccp_get_file_name, _comccp_get_valor_total, _comccp_btn_salvar_visible

    _name = 'compras.cotacoes.capa'
    _inherit = ['mail.thread', 'ir.needaction_mixin']
    _rec_name = 'numero'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True), # Id da empresa
        'numero': fields.char('Numero', size=15, select=True), # Numero da cotacao(Criar sequence COT-AAAA-999999)
        'requisicao_capa_id': fields.many2one("compras.requisicao.capa", 'Requisicao', ondelete="cascade",
                                              required=True, select=True), # Id da requisicao de compras
        'comprador_id': fields.many2one("compras.comprador", 'Comprador', ondelete="restrict", select=True), # id do comprador
        'fornecedor_id': fields.many2one("financeiro.fornecedor", 'Fornecedor', ondelete="cascade", required=True,
                                         select=True), # id do fornecedor
        'comccp_vendedor': fields.char('Nome do vendedor do fornecedor', size=30, select=True),
        'data': fields.date('Data'), # data da cotacao
        'prazo_entrega': fields.integer('Prazo de entrega'), # data de entrega\n
        'data_validade': fields.date('Validade ate'), # Data de validade da cotacao
        'frete_valor': fields.float('Frete valor', digits=(10, 2)), # Valor do Frete
        'tipo_frete': fields.selection([('C', 'Cif'), ('F', 'Fob')], 'Tipo frete', size=1),
        'transportador_id': fields.many2one("adm.transportador", 'Transportador', ondelete="restrict"),
        'despesas_acessorias': fields.float('Despesas acessorias', digits=(10, 2)), # Valor das despesas acessorias
        'outras_despesas': fields.float('Outras despesas', digits=(10, 2)),
        'cotacoes_itens_ids': fields.one2many('compras.cotacoes.itens', 'cotacao_id', 'Itens'),
        'file_name': fields.function(_comccp_get_file_name, method=True, string='Arquivo', type='char', size=22,
                                     store=False),
        'file_cotacao_xls': fields.binary('Arquivo da cotacao', filters='*.xls', readonly=True),
        'file_import_xls': fields.binary('Arquivo Importado', filters='*.xls'),
        'create_uid': fields.many2one('res.users', 'Usuario', readonly=True, ondelete="restrict"),
        'data_email': fields.datetime('Data do ultimo email enviado', readonly=True),
        'comccp_valor_total': fields.function(_comccp_get_valor_total, method=True, string='Valor Total da Cotacao',
                                              type='float', store=False),
        'comccp_btn_salva_visible': fields.function(_comccp_btn_salvar_visible, method=True,
                                                    string='Salvar', type='boolean', store=False),
        'comccp_aprovado': fields.boolean('Cotacao aprovada'),
    }
    _defaults = {
        'data': lambda *a: time.strftime('%Y-%m-%d'),
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        'comccp_aprovado': False,
    }
    _order = "data DESC, numero DESC"


