# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class compras_cotacoes_itens(osv.Model):
    """
    Tabela de itens de uma cotacao
    """

    from funcoes import _comcit_get_prazo, _comcit_get_fornecedor, _comcit_get_vr_total, \
        _comcit_get_name_cotacao, _comcit_get_numero_cotacao, _comcit_get_fornecedor_cotacao

    _name = 'compras.cotacoes.itens'
    _rec_name = 'cotacao_name'

    _columns = {
        # _________________________ integer __________________________
        'validade': fields.integer('Validade do produto'),  # validade do produto em dias

        # _________________________ float __________________________
        'ipi': fields.float('% Ipi', digits=(4, 2)),  # aliquota de ipi
        'icms': fields.float('Icms', digits=(4, 2)),  # aliquota de icms
        'quantidade': fields.float('Quantidade', digits=(9, 2)),  # Valor do item
        'vr_unitario': fields.float('Vr Unitario ', digits=(11, 2)),  # Valor do item

        # _________________________ selection __________________________
        'state': fields.selection([('A', 'Aguardando cotacao'), ('C', 'Cotado'), ('T', 'Autorizada'), ('R', 'Recusado')],
                                  'Situacao', size=1),

        # _________________________ function __________________________
        'prazo': fields.function(
            _comcit_get_prazo, method=True, type='integer', string='Prazo Entrega', readonly=True, store=False
        ),
        'fornecedor': fields.function(
            _comcit_get_fornecedor, method=True, type='char', size=80, string='Fornecedor', readonly=True, store=False
        ),
        'cotacao_name': fields.function(_comcit_get_name_cotacao, method=True, type='char',
                                        size=20, string='Cotacao', store=False),
        'cotacao_numero': fields.function(_comcit_get_numero_cotacao, method=True, type='char',
                                          size=20, string='Numero', store=False),
        'cotacao_fornecedor': fields.function(_comcit_get_fornecedor_cotacao,  string='Fornecedor',
                                              method=True,type='char', store=False),

        # _________________________ many2one __________________________
        'valor': fields.function(
            _comcit_get_vr_total, method=True, type='float', digits=(11, 2), string='Valor Total', readonly=True, store=False
        ),
        'cotacao_id': fields.many2one("compras.cotacoes.capa", 'Cotacao', ondelete="cascade", required=True),
        'requisicao_itens_id': fields.many2one("compras.requisicao.itens", 'Produto', ondelete="cascade", required=True,
            domain="[('requisicao_id','=',parent.requisicao_capa_id)]"),
        'autorizado_por_user_id': fields.many2one("res.users", 'Autorizado por', ondelete="restrict"),
        'comcil_produto_embalagem_id': fields.many2one(
            'estoque.produto.embalagem', 'Embalagem', required=True, ondelete="restrict", select=True,
            domain="[('produto_id', '=', requisicao_itens_id)]"
        ),
    }
    _defaults = {
        'state': lambda *a: 'A',
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4

