# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class compras_itens_fornecedores(osv.Model):
    """
    Tabela de fornecedores a serem cotados para cada item de uma requisicao de compras
    """

    _name = 'compras.itens.fornecedores'
    _description = 'Cadastro de fornecedores para cotacao do item'
    _rec_name = 'fornecedor_id'
    _columns = {
        'requisicao_itens_id': fields.many2one("compras.requisicao.itens", 'Requisicao itens id', ondelete="cascade",
                                               required=True), # Item da requisicao
        'fornecedor_id': fields.many2one("estoque.fornecedor", 'Fornecedor id', ondelete="cascade", required=True,
                                         domain="[('produto_id','=',parent.produto_id)]"),
        'cotar': fields.boolean("Cotar")
    }
    _defaults = {
        'cotar': lambda *a: True
    }
    _sql_constraints = [
        ('fornecedor_id_uniq', 'unique (fornecedor_id,requisicao_itens_id)',
         'Fornecedor ja cadastrado.'.decode('utf-8') ),
    ]


