# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################
from openerp.osv import osv, fields
import time


class compras_requisicao_capa(osv.Model):
    """
    Tabela de requisicao de compras
    """

    from funcoes import _comrca_name_get

    _name = 'compras.requisicao.capa'
    _columns = {
        'name': fields.function(_comrca_name_get, method=True, string='Name', type='char', size=15, store=True),
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True), # Id da empresa
        'solicitacao_id': fields.many2one("compras.solicitacao.capa", 'Solicitacao', ondelete="cascade", select=True),
        'numero': fields.char('Numero', size=15, select=True), # Numero da solicitacao de compras
        'data_hora_emissao': fields.datetime('Data/Hora de Emissao', required=True),
        'state': fields.selection([
                                      ('B', 'Esboco'),
                                      ('D', 'Definindo fornecedores'),
                                      ('E', 'Em cotacao'),
                                      ('O', 'Cotado'),
                                      ('A', 'Analisando cotacoes'),
                                      ('P', 'Gerar Pedido Compra'),
                                      ('C', 'Cancelada'),
                                      ('L', 'Concluido')
                                  ], 'Status', size=1),
        'observacoes': fields.text('Observacoes'),
        'requisicao_itens_ids': fields.one2many('compras.requisicao.itens', 'requisicao_id', 'Itens'),
        'comrca_cotacoes_ids': fields.one2many('compras.cotacoes.capa', 'requisicao_capa_id', 'Cotacoes'),
        'comrca_pedido_ids': fields.one2many('estoquepedidos.pedido.capa', 'pedcap_requisicao_compras_id', 'Pedidos'),
        'comrca_planilha': fields.binary('Planilha'),
        'comrca_nome_planilha': fields.char('Nome planilha', size=30),
        'comrca_fornecedor_ids': fields.many2many(
            'financeiro.fornecedor', 'compras_requisicao_m2m_financeiro_fornecedor',
            'requisicao_id', 'fornecedor_id', 'Fornecedor'),

    }
    _order = 'numero desc'
    _defaults = {
        'data_hora_emissao': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S'),
        'state': lambda *a: 'B',
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }


