# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################
from openerp.osv import osv, fields


class compras_requisicao_itens(osv.Model):
    """
    Itens da requisicao de compras
    """

    from funcoes import _comrit_get_state_capa
    from funcoes import _comrit_get_vr_tot_cot
    _name = 'compras.requisicao.itens'
    _rec_name = 'produto_id'
    _columns = {
        'requisicao_id': fields.many2one("compras.requisicao.capa", 'Requisicao', ondelete="cascade", required=True),
        # id da capa da requisicao
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="restrict", required=True, select=True,
                                      domain="[('tipo', '=', 'P')]"), # Produto
        'grade_id': fields.many2one("estoque.produto.grade", 'Grade', ondelete="restrict", select=True,
                                    domain="[('produto_id', '=', produto_id)]"), # Id do produto a ser pedido\n
        # TODO: Remover embalagem do pedido
        # 'produto_embalagem_id' : fields.many2one("estoque.produto.embalagem", 'Embalagem', ondelete="restrict",  select=True, domain="[('produto_id', '=', produto_id)]"), # id da embalagem pedida
        'quantidade': fields.float('Quantidade', digits=(9, 3), required=True),
        'vr_tot_cotacao': fields.function(_comrit_get_vr_tot_cot, type='float', digits=(11, 2),
                                          store=False, method=True, string='Valor total'),
        'itens_fornecedores_ids': fields.one2many('compras.itens.fornecedores', 'requisicao_itens_id', 'Itens'),
        'fornecedor': fields.char("fornecedor", size=65, readonly=1), #  fornecedor
        #'numero_cotacao': fields.char('Cotacao Vencedora', size=15, readonly=1), # Numero da cotacao
        'cotacao_item_id': fields.many2one('compras.cotacoes.itens', 'Cotacao vencedora',
                                           select=True, domain="[('requisicao_itens_id', '=', id)]"),
        'cotacao_itens_ids': fields.one2many('compras.cotacoes.itens', 'requisicao_itens_id',
                                             'Cotacoes'),
        'state': fields.function(_comrit_get_state_capa, type='char', size=1, method=True, store=False,
                                 string='Estado'),
        'comrit_produto_embalagem_id': fields.many2one('estoque.produto.embalagem', 'Embalagem', required=True,
                                                       ondelete="restrict", select=True,
                                                       domain="[('produto_id', '=', produto_id)]"),
    }
