# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################
from openerp.osv import osv, fields


class compras_requisicao_view(osv.Model):
    """
    View
    """
    _name = 'compras.requisicao.view'
    _description = 'compras_requisicao_view'
    _auto = False
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True,
                                      select=True),
        'solicitacao_id': fields.many2one("compras.solicitacao.capa", 'Solicitacao',
                                          ondelete="cascade", select=True),
        'numero': fields.char('Numero da requisicao', size=15, select=True),
        # numero da requisicao. Deve ser composto da seguinte forma:\nRCO-AAAA-999999
        'data_hora_emissao': fields.datetime('Data/Hora emissao', required=True, select=True),
        # Data de emissao.
        'state': fields.selection([('B', 'Esboco'),
                                   ('C', 'Cancelada'),
                                   ('E', 'Em cotacao'),
                                   ('O', 'Cotado'),
                                   ('D', 'Definindo fornecedores'),
                                   ('A', 'Analisando cotacoes'),
                                   ('L', 'Concluido')
                                  ], 'Status', size=1),
        'observacoes': fields.text('Observacao'),  # Informacoes complementares
        'quantidade': fields.float('Quantidade', digits=(15, 3), required=True),
        # Quantidade solicitada
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="restrict",
                                      required=True, select=True),
        'grade_id': fields.many2one("estoque.produto.grade", 'Grade', ondelete="restrict",
                                    select=True), # Id da grade
        'comrvi_cotacoes_itens_ids': fields.one2many("compras.cotacoes.itens",
                                                     "requisicao_itens_id", "Itens"),
    }
    _order = 'numero desc'

