# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class compras_solicitacao_view(osv.Model):
    _name = 'compras.solicitacao.view'
    _description = 'compras_solicitacao_view'
    _auto = False
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'numero': fields.char('Numero da solicitacao', size=15, select=True), # numero da solicitacao. Deve ser composto da seguinte forma:\nSCO-AAAA-999999
        'data_hora_solicitacao': fields.datetime('Data/Hora solicitacao', required=True, select=True),
        'state': fields.selection([('E', 'Esboco'),
                                   ('A', 'Em analise'),
                                   ('P', 'Aprovado'),
                                   ('R', 'Recusado')
                                  ], 'Estado', required=True, select=True, size=1),
        'funcionario_id': fields.many2one("adm.pessoa", 'Funcionario', ondelete="cascade",
                                          required=True, select=True),
        # Id do funcionario requisitante
        'observacao': fields.text('Observacao'), # Informacoes complementares
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="restrict", required=True, select=True),
        'grade_id': fields.many2one("estoque.produto.grade", 'Grade', ondelete="restrict",
                                    select=True), # Id da grade
        'quantidade': fields.float('Quantidade', digits=(15, 3), required=True), # Quantidade solicitada
        'quantidade_atendida': fields.float('Quantidade atendida', digits=(15, 3)), # Quantidade Atendida
        'aplicacao': fields.text('Aplicacao'), # Finalidade da solicitacao. \nOnde o item será aplicado
        'state_item': fields.selection([('A', 'Aguardando autorizacao'),
                                        ('T', 'Autorizada'),
                                        ('C', 'Cancelada'),
                                        ('N', 'Nao autorizada')
                                       ], 'Estado Produto', required=True, size=1),
        # Estado da solicitacao:\nA=Aguardando autorizacao\nT=Autorizada\nC=Cancelada\nN=Nao autorizada\n
    }


