# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        title = center_title('', _('Listagem de pedidos de compra'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Pedido de Compra'))
        listagem.informaTamLinha(160)
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)

        obj_estoquepedidos_pedido_capa = pooler.get_pool(cr.dbname).get(
            'estoquepedidos.pedido.capa')

        comprador_id = datas.get('comprador_id')
        data_ini = datas.get('data_ini')
        data_fim = datas.get('data_fim')
        company_id = datas.get('company_id')
        pessoa_id = datas.get('pessoa_id')
        states = datas.get('states')

        args = [('tipo', '=', 'C'), ('company_id', '=', company_id)]
        if comprador_id:
            args.append(('comprador_id', '=', comprador_id))
        if data_ini:
            args.append(('data_emissao', '>=', data_ini))
        if data_fim:
            args.append(('data_emissao', '<=', data_fim))
        if pessoa_id:
            args.append(('pessoa_id', '=', pessoa_id))
        if states:
            args.append(('state', 'in', states))

        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        estoquepedidos_pedido_capa_ids = obj_estoquepedidos_pedido_capa.search(
            cr, uid, args, context=context)

        estoquepedidos_pedido_capa_dados = obj_estoquepedidos_pedido_capa.read(
            cr, uid, estoquepedidos_pedido_capa_ids,
            ['numero_pedido', 'data_emissao', 'pessoa_id', 'comprador_id', 'state', 'valor_total'],
            context=context)
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
        if data_ini:
            data_ini = time.strftime("%d/%m/%Y", time.strptime(data_ini, "%Y-%m-%d"))
        else:
            data_ini = ''
        if data_fim:
            data_fim = time.strftime("%d/%m/%Y", time.strptime(data_fim, "%Y-%m-%d"))
        else:
            data_fim = ''
        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab('  ')
        if data_ini or data_fim:
            if len(data_ini) < 2:
                data_ini = '~'
            if len(data_fim) < 2:
                data_fim = '~'
            listagem.informaCab('             ' + _('Periodo: ') + data_ini + _(' a ') + data_fim +
                                '          ')
        listagem.informaCab('*' + '-' * 148 + '*')
        listagem.informaCab(
            _('|    NUMERO    |   DATA    |                      FORNECEDOR                   |'
              '   VALOR     |                COMPRADOR                |    STATUS   |'))
        listagem.informaCab('*' + '-' * 148 + '*')
        listagem.informaCab('|              |           |                                          '
                            '         |             |                                         '
                            '|             |')
        listagem.rodapePadrao()
        total_notas = []
        total_valor = []
        for pedido in estoquepedidos_pedido_capa_dados:
            valor_total = pedido.get('valor_total')
            comprador = pedido.get('comprador_id')
            if comprador:
                comprador = pedido.get('comprador_id')[1]
            pessoa = pedido.get('pessoa_id')
            if pessoa:
                pessoa = pedido.get('pessoa_id')[1]
            estados = obj_estoquepedidos_pedido_capa.pedcap_fields_selection_state(
                cr, uid, context=context)
            state = pedido.get('state')
            dict_state = {}
            for x in estados:
                dict_state[x[0]] = x[1]
            state = dict_state.get(state, 'Nao identificado')
            linha = formataString(pedido.get('numero_pedido') or '', 14, ' ', 'D', 'N', 'S') + '|'
            linha += formataString(
                time.strftime("%d/%m/%Y", time.strptime(
                    pedido.get('data_emissao'), "%Y-%m-%d")) or '', 11, ' ', 'D', 'N', 'S') + '|'
            linha += formataString(pessoa or '', 51, ' ', 'D', 'N', 'S') + '|'
            linha += formataString(getNumeroEditado(valor_total) or 0.0, 13, ' ', 'E', 'N',
                                   'S') + '|'
            linha += formataString(comprador or '', 41, ' ', 'D', 'N', 'S') + '|'
            linha += formataString(state, 13, ' ', 'D', 'N', 'S') + '|'
            listagem.imprimeLinha('|' + linha)
            total_notas.append(1)
            total_valor.append(valor_total)
        listagem.imprimeLinha('*' + '-' * 148 + '*')

        linha = 'TOTAL: ---->  '
        linha += formataString(str(len(total_notas)), 4, ' ', 'E', 'N', 'S')
        linha += formataString(getNumeroEditado(sum(total_valor)), 75, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)
        listagem.imprimeLinha('*' + '-' * 148 + '*')
        listagem.imprimeLinha(' ' * 115 + _('** Sig Informatica LTDA **       '))

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.pedido_compra')
