# -*- coding: utf-8 -*-

from openerp.tests.common import TransactionCase
from sigaddons.config_teste import set_config
from dateutil.parser import parse
from dateutil.relativedelta import relativedelta
import time


class TestWizardEstsugCompraGerarPedido(TransactionCase):
    """
    Classe responsavel por testes unitarios nos metodos da classe wizard_estsug_compra_gerar_pedido
    """

    @classmethod
    def setUpClass(cls):
        set_config()

    def setUp(self):
        super(TestWizardEstsugCompraGerarPedido, self).setUp()
        self.obj_wizard_estsug_compra_gerar_pedido = self.registry(
            'wizard.estsug.compra.gerar.pedido')

    def test_onchange_prazo(self):
        res = self.obj_wizard_estsug_compra_gerar_pedido.onchange_prazo(
            self.cr, self.uid, [], '15,45,75', 'DD', {})
        data_hoje = time.strftime('%Y-%m-%d')
        self.assertEqual('%s,%s,%s' % (
            (parse(data_hoje) + relativedelta(days=15)).strftime('%d/%m/%Y'),
            (parse(data_hoje) + relativedelta(days=45)).strftime('%d/%m/%Y'),
            (parse(data_hoje) + relativedelta(days=75)).strftime('%d/%m/%Y')),
                         res.get('value').get('prazo_datas'))
