# -*- encoding: utf-8 -*-
from openerp import pooler
from openerp.osv import osv
from openerp.tools.translate import _


class wizard_abrir_itens_solicitacao(osv.TransientModel):
    _name = 'wizard.compras.itens.solicitacao'
    _description = 'Compras itens solicitacao'

    def analizar_itens(self, cr, uid, ids, context):
        id = ids[0]
        obj = pooler.get_pool(cr.dbname).get('compras.solicitacao.capa')
        vals = obj.read(cr, uid, id, ['solicitacao_item_ids', 'numero'], context=context)
        if vals and isinstance(vals, list):
            vals = vals[0]
        if not vals['solicitacao_item_ids']:
            raise osv.except_osv(_('Atencao'), _('Para analisar e necessario cadastrar os itens'))
        return {
            'name': _('Itens da Solicitacao: %s') % str(vals['numero']),
            'view_type': 'form',
            'view_mode': 'tree',
            'res_model': 'compras.solicitacao.item',
            'type': 'ir.actions.act_window',
            'ref': 'action_compras_solicitacao_item',
            'domain': [('solicitacao_id', '=', id)],
            'target': 'new',
        }

