# -*- coding: utf-8 -*-

from openerp.osv import fields, osv
from openerp.tools.translate import _


class wizard_relatorio_pedido_compra(osv.TransientModel):

    _name = 'wizard.relatorio.pedido.compra'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa ', required=True),
        'comprador_id': fields.many2one('compras.comprador', 'Comprador'),
        'pessoa_id': fields.many2one('adm.pessoa', 'Fornecedor'),
        'state_ids': fields.many2many('pedido.compra.state', 'relatorio_m2m_pedido_compra_state',
                                      'rel_id', 'compra_state_id', 'Estado do pedido'),
        'data_ini': fields.date('Data inicial'),
        'data_fim': fields.date('Data final')
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, s._name, context=c),
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        brw_wizard_relatorio_pedido_compra = self.browse(cr, uid, ids, context=context)
        for x in brw_wizard_relatorio_pedido_compra:
            if x.data_ini > x.data_fim:
                raise osv.except_osv(_('Atencao'), _('Data inicial nao pode ser maior que a data '
                                                     'final'))
            datas = {
                'company_id': x.company_id.id,
                'comprador_id': x.comprador_id.id,
                'pessoa_id': x.pessoa_id.id,
                'data_ini': x.data_ini,
                'data_fim': x.data_fim,
                'states': map(lambda s: s.state, x.state_ids)
            }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'pedido_compra',
            'datas': datas,
        }
