# -*- coding: utf-8 -*-

from openerp.osv import osv


class compras_mkp_produto(osv.Model):

    _inherit = 'compras.mkp.produto'

    def commkppro_processar_pagina(self, cr, uid, fornecedor_apelido, produto_url_anuncio,
                                   context=None):
        """
        Metodo de consulta de dados de produtos na web, partindo do apelido do fornecedor e url do
        produto especifico.
        :param cr: cursor no banco de dados
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario
        :type uid: int
        :param fornecedor_apelido: descricao do apelido do fornecedor
        :type fornecedor_apelido: str
        :param produto_url_anuncio: descricao completa da pagina de acesso ao anuncio do produto
        :type produto_url_anuncio: str
        :param context: dados contextuais
        :type context: dict
        :return: dados
        """
        return {'status': '1', 'disponibilidade': 'D', 'preco': 0.0, 'mensagem': ''}

    def commkppro_abre_url(self, cr, uid, ids, context=None):
        """
        Metodo do botao 'Abrir URL'. Exibi a pagina de um produto especifico de um fornecedor
        :param cr: cursor no banco de dados
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dados contextuais
        :type context: dict
        :return: acao para abertura da url
        :rtype: dict
        """
        context = context and context.copy() or {}
        url = self.read(cr, uid, ids[0] if isinstance(ids, list) else ids, ['commkppro_url'],
                        context).get('commkppro_url') or ''
        if not url:
            return False
        return {
            'type': 'ir.actions.act_url',
            'url': url,
            'target': 'new'
        }
