# -*- coding: utf-8 -*-

from openerp.osv import osv, fields
from funcoes import commkpfor_get_name


class compras_mkp_fornecedor(osv.Model):

    _name = 'compras.mkp.fornecedor'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True),
        'commkpfor_fornecedor_id': fields.many2one('adm.pessoa', 'Fornecedor', ondelete='cascade',
                                                   select=True),
        'name': fields.function(commkpfor_get_name, method=True, string='Nome', type='char'),
        'commkpfor_apelido': fields.char('Apelido', size=15, required=True, select=True),
        'commkpfor_pesquisando': fields.boolean('Pesquisando'),
        'commkpfor_produto_ids': fields.one2many('compras.mkp.produto', 'commkppro_fornecedor_id',
                                                 'Produtos'),
    }
    _defaults = {
        'commkpfor_pesquisando': False,
        'company_id': lambda s, c, u, x: s.pool.get('adm.empresa.objeto').getEmpresa(
            c, u, s._name, context=x),
    }
