# -*- coding: utf-8 -*-

from openerp.osv import osv, fields
from funcoes import commkppro_get_dados


class compras_mkp_produto(osv.Model):

    _name = 'compras.mkp.produto'
    _columns = {
        'commkppro_fornecedor_id': fields.many2one('compras.mkp.fornecedor', 'Fornecedor',
                                                   required=True, select=True, ondelete='cascade'),
        'commkppro_produto_id': fields.many2one('estoque.produto', 'Produto', select=True,
                                                required=True, ondelete='cascade'),
        'name': fields.function(commkppro_get_dados, method=True, string='Nome', type='char',
                                multi=True),
        'commkppro_alterado': fields.boolean('Alterado'),
        'commkppro_pesquisado': fields.boolean('Pesquisado'),
        'commkppro_url': fields.function(commkppro_get_dados, method=True, string='Anuncio',
                                         type='char', multi=True),
        'commkppro_pesquisa_ids': fields.one2many('compras.mkp.pesquisa', 'commkppes_produto_id',
                                                  'Pesquisas'),
        'commkppro_ultimo_custo': fields.function(commkppro_get_dados, method=True,
                                                  string='Ultimo custo', type='float',
                                                  digits=(9, 2), multi=True),
        'commkppro_saldo': fields.function(commkppro_get_dados, method=True, string='Saldo',
                                           type='integer', multi=True),
        'commkppro_ultima_disponibilidade': fields.function(commkppro_get_dados, method=True,
                                                            string='Disponibilidade', type='char',
                                                            size=11, multi=True),
        'commkppro_ultima_pesquisa': fields.function(commkppro_get_dados, method=True,
                                                     string='Ultima pesquisa', type='date',
                                                     multi=True),
        'commkppro_ultimo_preco': fields.function(commkppro_get_dados, method=True,
                                                  string='Preco no fornecedor', type='float',
                                                  digits=(9, 2), multi=True),
        'commkppro_preco_venda': fields.function(commkppro_get_dados, method=True,
                                                 string='Preco de venda', type='float',
                                                 digits=(14, 5), multi=True),
    }
    _defaults = {
        'commkppro_alterado': False,
        'commkppro_pesquisado': False,
    }
