# -*- coding: utf-8 -*-

from openerp.osv import osv
import urllib2
from openerp.tools.translate import _
from BeautifulSoup import BeautifulSoup


class compras_mkp_produto(osv.Model):

    _inherit = 'compras.mkp.produto'

    def commkppro_processar_pagina(self, cr, uid, fornecedor_apelido, produto_url_anuncio,
                                   context=None):
        """
        Metodo de consulta de dados de produtos na web, partindo do apelido do fornecedor e url do
        produto especifico.
        :param cr: cursor no banco de dados
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario
        :type uid: int
        :param fornecedor_apelido: descricao do apelido do fornecedor
        :type fornecedor_apelido: str
        :param produto_url_anuncio: descricao completa da pagina de acesso ao anuncio do produto
        :type produto_url_anuncio: str
        :param context: dados contextuais
        :type context: dict
        :return: dados
        """
        context = context and context.copy() or {}
        vals = {'disponibilidade': '', 'preco': 0.0, 'status': '', 'mensagem': ''}
        hdr = {
            'User-Agent': 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.11 (KHTML, like Gecko) '
                          'Chrome/23.0.1271.64 Safari/537.11',
            'Accept': 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8',
            'Accept-Charset': 'ISO-8859-1,utf-8;q=0.7,*;q=0.3',
            'Accept-Encoding': 'none',
            'Accept-Language': 'en-US,en;q=0.8',
            'Connection': 'keep-alive'
        }
        try:
            req = urllib2.Request(produto_url_anuncio, headers=hdr)
            pagina = urllib2.urlopen(req, timeout=5)
        except Exception as e:
            vals.update({'mensagem': str(e), 'status': '2'})
            return vals
        parsed_html = BeautifulSoup(pagina)

        preco_dados = parsed_html.body.findAll('h2')
        preco_dados = filter(lambda p: '<h2>R$' in str(p), preco_dados)
        preco = 0
        if preco_dados:
            preco = float(str(preco_dados[0]).replace('<h2>', '').replace('</h2>', '').replace(
                ',', '').replace('R$', '').replace('.', '')) / 100.0

        disponibilidade_dados = parsed_html.body.findAll('ul', attrs={'class': 'list-unstyled'})
        disponibilidade_dados = filter(lambda d: '<li>Disponibilidade: ' in str(d),
                                       disponibilidade_dados)
        disponibilidade = ''
        if disponibilidade_dados:
            disponibilidade = str(disponibilidade_dados[0])
        if 'Em estoque' in disponibilidade:
            disponibilidade = 'D'
        elif 'Out Of Stock' in disponibilidade:
            disponibilidade = 'S'
        vals.update({'disponibilidade': disponibilidade, 'preco': preco, 'status': '1'})

        return vals
