# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class compras_reembolso_controle(osv.Model):
    """
    Tabela de controle de reembolso de compra.

    prefixo: comrct_
    """

    _inherit = 'compras.reembolso.controle'

    def comrct_button_esboco(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = {'state': 'ES'}
        res = self.write(cr, uid, ids, vals, context=context)
        self.message_post(cr, uid, ids, _('Alteracao de Status'), _('Esboco'))
        return res

    def comrct_button_conceder(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = {'state': 'CO'}
        res = self.write(cr, uid, ids, vals, context=context)
        self.message_post(cr, uid, ids, _('Alteracao de Status'), _('Reembolso concedido'))
        return res

    def comrct_button_cancelar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = {'state': 'CA'}
        res = self.write(cr, uid, ids, vals, context=context)
        self.message_post(cr, uid, ids, _('Alteracao de Status'), _('Reembolso cancelado'))
        return res

    def comrct_button_receber(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = {'state': 'RE'}
        res = self.write(cr, uid, ids, vals, context=context)
        self.message_post(cr, uid, ids, _('Alteracao de Status'), _('Reembolso recebido'))
        return res

    def _needaction_domain_get(self, cr, uid, context=None):
        """
        Mostra a quantidade de reembolsos pendentes.

        :param cr: a linha atual do cursor do banco de dados,
        :param uid: o ID do usuario utilizado para a verificacao de perfil,
        :param context: um dicionario padrao para valores contextuais,
        :return: dominio utilizado para contar notificações pendentes.

        :see: openerp/addons/base/ir/ir.needaction (class ir_needaction_mixin)
        :copyright: OpenERP SA.
        """
        context = context and context.copy() or {}
        return [('state', 'in', ('ES','CO'))]


    def comrct_onchange_pedido(self, cr, uid, ids, pedido, context=None):
        context = context and context.copy() or {}
        obj_pedido = self.pool.get('estoquepedidos.pedido.capa')
        pedido_ids = obj_pedido.search(cr, uid, [('id', '=', pedido)], context=context)
        values = {}
        if pedido_ids:
            for _dados_pedido in obj_pedido.read(cr, uid, pedido_ids, ['data_emissao', 'valor_total'], context=context):
                _valor = _dados_pedido.get('valor_total')
                _data = _dados_pedido.get('data_emissao')
                values = {'comrtc_data_compra': _data, 'comrtc_valor_compra': _valor, 'comrtc_valor_reembolso': _valor}
        return {'value': values}

    def comrct_onchange_nf(self, cr, uid, ids, nf, context=None):
        context = context and context.copy() or {}
        obj_nf = self.pool.get('fiscal.nf.capa')
        nf_ids = obj_nf.search(cr, uid, [('id', '=', nf)], context=context)
        values = {}
        if nf_ids:
            for _dados_nf in obj_nf.read(cr, uid, nf_ids, ['data_emissao', 'vr_total_nf'], context=context):
                _valor = _dados_nf.get('vr_total_nf')
                _data = _dados_nf.get('data_emissao')
                values = {'comrtc_data_compra': _data, 'comrtc_valor_compra': _valor, 'comrtc_valor_reembolso': _valor}
        return {'value': values}

