# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class compras_reembolso_controle(osv.Model):
    """
    Tabela de controle de reembolso de compra.

    prefixo: comrct_
    """

    _name = 'compras.reembolso.controle'
    _inherit = ['mail.thread', 'ir.needaction_mixin']
    _columns = {
        'id': fields.integer('Controle', readonly=True),
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True), # id da empresa
        'create_date': fields.datetime('Criacao', readonly=True),
        'comrct_pessoa_id': fields.many2one("adm.pessoa", 'Fornecedor', ondelete="cascade", required=True, select=True),
        'comrct_nf_id': fields.many2one('fiscal.nf.capa', 'NF de compra', ondelete='cascade', select=True,
                                        domain="[('destinatario_id', '=', comrct_pessoa_id),('tipo', '=', 'C')]"),
        'comrct_pedido_id': fields.many2one('estoquepedidos.pedido.capa', 'Pedido de compra', ondelete="restrict",
                                            select=True),
        'comrtc_data_compra': fields.datetime('Data compra', readonly=True),
        'comrtc_valor_compra': fields.float('Valor da compra', digits=(10,2), readonly=True),
        'comrtc_conta_pagamento_id': fields.many2one("financeiro.tesouraria.contas", 'Conta pagamento',
                                                  ondelete="restrict", required=True),
        'comrtc_movimento_pagamento_id': fields.many2one('financeiro.tesouraria.movimento', 'Pagamento',
                                                         domain="[('conta_id', '=', comrtc_conta_pagamento_id)]"),
        'comrtc_autorizacao': fields.char('Codigo de autorizacaoo', size=24),
        'comrtc_data_autorizacao': fields.date('data da autorizacao'),
        'comrtc_valor_reembolso': fields.float('Valor Reembolso', digits=(10,2), required=True),
        'comrtc_obs_origem': fields.text('Informacoes complementares da compra'),
        'comrtc_data_reembolso': fields.date('data da autorizacao'),
        'comrtc_conta_reembolso_id': fields.many2one("financeiro.tesouraria.contas", 'Conta Reembolso',
                                                  ondelete="restrict"),
        'comrtc_movimento_reembolso_id': fields.many2one('financeiro.tesouraria.movimento', 'Reembolso',
                                                        domain="[('conta_id', '=', comrtc_conta_reembolso_id)]"),
        'comrtc_historico_ids': fields.one2many('compras.reembolso.historico', 'comrht_capa_id', 'Historicos'),
        'state': fields.selection([('ES', 'Esboco'),('CO', 'Concedido'), ('RE', 'Recebido'), ('CA', 'Cancelado')],
                                  'Estado', required=True),
        'comrtc_obs_reembolso': fields.text('Informacoes complementares do reembolso'),
        'comrtc_data_proxima_acao': fields.date('Proxima intervencao'),
        'comrtc_protocolo': fields.char('Protocolo de origem', size=25, select=1),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        'state': 'ES',
    }
