# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class concorrencia_concorrente_item(osv.Model):
    _name = 'concorrencia.concorrente.item'
    _inherit = 'concorrencia.concorrente.item'

    def conci_onchange_concorrente(self, cr, uid, ids, company_id):
        return {'value': {'company_id': company_id}}

    def conci_onchange_usa_grade_ou_nao(self, cr, uid, ids, produto_id, usa_grade_ou_nao, context=None):
        context = context and context.copy() or {}
        if produto_id:
            usa_grade_ou_nao = self.pool.get('estoque.produto').browse(cr, uid, produto_id).grade_usar
            grade_id = self.pool.get('estoque.produto.grade').search(cr, uid, [('produto_id', '=', produto_id)],
                                                                     context=context)
            if isinstance(grade_id, list) and len(grade_id) == 1:
                grade_id = grade_id[0]
            else:
                grade_id = False
        else:
            grade_id = False
        return {'value': {'usa_grade_ou_nao': usa_grade_ou_nao, 'grade_id': grade_id}}

    def read(self, cr, uid, ids, fields=None, context=None, load='_classic_read'):
        context = context and context.copy() or {}
        if 'active_model' in context and 'active_id' and context:
            model = context.get('active_model')
            id = context.get('active_id')
            if model == 'wizard.atualizar.preco.venda.itens':
                obj_concorrencia_concorrente_item = self.pool.get('concorrencia.concorrente.item')
                codigo_produto = self.pool.get(model).browse(cr, uid, id).codigo
                produto_id = self.pool.get('estoque.produto').search(cr, uid, [('codigo', '=', codigo_produto)],
                                                                     context=context)
                if not produto_id:
                    raise osv.except_osv(_('Atencao'), _('Produto nao encontrado'))
                elif isinstance(produto_id, list):
                    produto_id = produto_id[0]
                    concorrente_id = obj_concorrencia_concorrente_item.search(cr, uid,
                                                                              [('produto_id', '=', produto_id)],
                                                                              context=context)
                    if not concorrente_id:
                        raise osv.except_osv(_('Atencao'), _('Nao existe concorrente para este produto'))
                    ids = concorrente_id
        res = super(concorrencia_concorrente_item, self).read(cr, uid, ids, fields=fields, context=context, load=load)
        return res

