# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class concorrencia_concorrente(osv.Model):
    """
    Cadastro de concorrentes

    prefixo: concon_
    """
    from funcoes import _concon_nome_pessoa

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = []
        if isinstance(ids, (int, long)):
            ids = [ids]

        browse_concorrente = self.browse(cr, uid, ids, context)
        for i in browse_concorrente:
            pessoa_nome = i.pessoa_id.nome or ''
            res.append((i.id, pessoa_nome),)
        return res

    _name = 'concorrencia.concorrente'
    _roteavel = True
    _rec_name = 'pessoa_id'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True), # Id da empresa
        'pessoa_id': fields.many2one("adm.pessoa", 'Pessoa', ondelete="cascade", required=True, select=True),
        'name': fields.function(_concon_nome_pessoa, method=True, string='Nome', type='char', size=40, store=True),
        'concorrente_item_ids': fields.one2many('concorrencia.concorrente.item', 'concorrente_id', 'Item'),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }

    _sql_constraints = [
        ('concorrente_uniq', 'unique (company_id, pessoa_id)',
         'Ja existe este concorrente cadastrado para essa empresa' ),
    ]

