# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class concorrencia_concorrente_item(osv.Model):
    """
    Cadastro de itens de um concorrente
    """
    _name = 'concorrencia.concorrente.item'
    _rec_name = 'grade_id'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True,
                                      select=True),  # Id da empresa
        'data': fields.date('Data', required=True),  # data da coleta de precos
        'preco': fields.float('Preco', digits=(14, 2), required=True),
        # preco praticado pelo concorrente
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="cascade",
                                      required=True, select=True), # Id do produto
        'grade_id': fields.many2one("estoque.produto.grade", 'Grade', ondelete="cascade",
                                    required=False, select=True), # id da grade/produto
        'concorrente_id': fields.many2one("concorrencia.concorrente", 'Concorrente',
                                          ondelete="cascade", required=True,
                                          select=True), # id do concorrente
        'usa_grade_ou_nao': fields.boolean('usa grade ou nao')
    }
    _order = 'data desc'
    _defaults = {
        'data': lambda *a: time.strftime('%Y-%m-%d'),
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, s._name, context=c),
    }
