# -*- encoding: utf-8 -*-

from SigUtils.impressao import Impressora
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        def center_title(e, c, d, t=153):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        title = center_title('', _('P E S Q U I S A'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato()
        listagem.informaNome(pdf_string, _('concorrencia_listagem_pesquisa'))
        listagem.informaTamLinha(160)
        listagem.defineMargem(0.5,0.5,0.5,0.5)
        listagem.defineFonte(tam=6.6)
        produto_dados = datas.get('produto_dados')
        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'estoque.produto', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        docs = center_title(datas.get('data_emissao'), nome_empresa, _('Pagina: {{ Page }} '))
        docs1 = 'Codigo a listar: %s    So marcados: %s     Agrupar: %s' % (
            datas.get('codigo'), datas.get('so_marcados'), datas.get('agrupar'))
        docs2 = ''
        if datas.get('diaria'):
            docs2 += 'Diario'
        if datas.get('semanal'):
            docs2 += '/Semanal'
        if datas.get('quinzenal'):
            docs2 += '/Quinzenal'
        if datas.get('mensal'):
            docs2 += '/Mensal'
        docs3 = ''
        if datas.get('categoria'):
            docs3 += 'Categoria: %s     ' % datas.get('categoria')
        if datas.get('comprador'):
            docs3 += 'Comprador: %s     ' % datas.get('comprador')
        if datas.get('fabricante'):
            docs3 += 'Fabricante: %s     ' % datas.get('fabricante')
        listagem.informaCab(title)
        listagem.informaCab('')
        listagem.informaCab(docs)
        listagem.informaCab('')
        listagem.informaCab('-' * 143)
        listagem.informaCab(_('|CODIGO DO ITEM      |GR |DESCRICAO                                '
                              '|UND |         |         |         |         |         '
                              '|         |         |'))
        listagem.informaCab('-' * 143)
        listagem.informaCab('')
        listagem.informaCab(docs1)
        if docs2:
            listagem.informaCab('Periodo: ' + docs2)
        if docs3:
            listagem.informaCab(docs3)
        listagem.informaCab('')
        listagem.rodapePadrao()
        linha = u'|{codigo:<20.20}|{grade:<3.3}|{name:<41.41}|{unidade:^4.4}|{n:^9}|{n:^9}' \
                u'|{n:^9}|{n:^9}|{n:^9}|{n:^9}|{n:^9}|'
        for item in produto_dados:
            item['n'] = str()
            listagem.imprimeLinha(linha.format(**item))
            listagem.imprimeLinha('|' + ' ' * 141 + '|')
        listagem.imprimeLinha('-' * 143)
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()

        return self.obj.pdf, 'pdf'


report_custom('report.concorrencia_listagem_pesquisa')
