# -*- encoding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
from collections import OrderedDict
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        def center_title(e, c, d, t=160):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        title = center_title('', 'Resultado da Pesquisa', '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('concorrencia_listagem_resultado'))
        listagem.informaTamLinha(160)

        concorencia_dados = datas.get('concorrencia_dados')
        ordem_resultado = datas.get('ordem_resultado')

        produto_ids = list(set(map(lambda p: p.get('produto_id'), concorencia_dados)))
        grade_ids = list(set(map(lambda g: g.get('grade_id') if g.get('grade_id') else 0,
                                 concorencia_dados)))
        preco_venda_dados = pooler.get_pool(cr.dbname).get('estoque.preco.venda').get_preco_venda(
            cr, uid, epc_produto_ids=produto_ids, epc_grade_ids=grade_ids, context=context)

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'concorrencia.concorrente', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')

        docs = center_title(datas.get('data_emissao'), nome_empresa, _('Pagina: {{ Page }} '))

        docs1 = 'Data inicial: %s     Data final: %s' % (datas.get('data_inicial'),
                                                         datas.get('data_final'))

        docs2 = ''
        if datas.get('fabricante'):
            docs2 += 'Fabricante: %s     ' % datas.get('fabricante')
        if datas.get('produto'):
            docs2 += 'Item: %s     ' % datas.get('produto')

        docs3 = 'Ordem impressao: %s     ' % datas.get('str_ordem_impressao')
        if datas.get('str_ordem_resultado'):
            docs3 += 'Ordem resultado: %s' % datas.get('str_ordem_resultado')

        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab(docs)
        listagem.informaCab('')
        listagem.informaCab(docs1)
        if docs2:
            listagem.informaCab('Periodo: ' + docs2)
        if docs3:
            listagem.informaCab(docs3)
        listagem.informaCab('')
        listagem.informaCab('--')
        listagem.informaCab(_('ITEM/D           GR DESCRICAO                               '
                              '      P.VENDA   P.VENDA-CON   P.VENDA-CON   P.VENDA-CON   '
                              'P.VENDA-CON   P.VENDA-CON   P.VENDA-CON'))
        listagem.informaCab('--')
        listagem.informaCab('')
        listagem.rodapePadrao()

        concorrentes = list(set(map(lambda c: c.get('concorrente'), concorencia_dados)))
        concorrentes.sort()

        itens = list()

        for dado in concorencia_dados:
            chave = '%s-%s-%s' % (dado.get('data'), dado.get('produto_id'), dado.get('grade_id'))
            if chave in itens:
                continue
            itens.append(chave)

            produto_preco_venda = preco_venda_dados.get(dado.get('produto_id')) or {}
            if dado.get('grade_id'):
                preco_venda = produto_preco_venda.get(dado.get('grade_id')) or 0.0
            else:
                preco_venda = produto_preco_venda.get('preco_venda') or 0.0

            dado_concorrencia_dados = filter(
                lambda d: d.get('data') == dado.get('data') and
                          d.get('produto_id') == dado.get('produto_id') and
                          d.get('grade_id') == dado.get('grade_id'), concorencia_dados)
            if ordem_resultado == 'M':
                dado_concorrencia_dados = sorted(dado_concorrencia_dados,
                                                 key=lambda d: d.get('preco_venda'))
            elif ordem_resultado == 'C':
                dado_concorrencia_dados = sorted(dado_concorrencia_dados,
                                                 key=lambda d: d.get('codigo_concorrente'))

            linha = formataString(dado_concorrencia_dados[0].get('item') or '', 16, ' ', 'D', 'N',
                                  'S') + '|'
            linha += formataString(dado_concorrencia_dados[0].get('grade') or '', 2, ' ', 'D', 'N',
                                   'S') + '|'
            linha += formataString(dado_concorrencia_dados[0].get('descricao_grade') or
                                   dado_concorrencia_dados[0].get('descricao_produto'), 39, ' ',
                                   'D', 'N', 'S') + '|'
            linha += formataString(getNumeroEditado(preco_venda, 2), 13, ' ', 'E', 'N', 'S') + '|'

            contador = 0
            for item in dado_concorrencia_dados:
                linha += formataString(getNumeroEditado(
                    item.get('preco_venda_concorrente').replace('.', ','), 2), 13, ' ', 'E', 'N',
                    'S') + '|'
                contador += 1
                if contador == 6:
                    break

            listagem.imprimeLinha(linha)
            listagem.imprimeLinha('-' * 157)

        listagem.imprimeLinha(' ')
        concorrentes = ', '.join(concorrentes)
        while concorrentes:
            listagem.imprimeLinha(concorrentes[:150])
            concorrentes = concorrentes[150:]

        listagem.imprimeLinha('--')
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.concorrencia_listagem_resultado')
