# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class contabil_documentos(osv.Model):
    _name = 'contabil.documentos'
    _inherit = 'contabil.documentos'

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not len(ids):
            return []
        browse_contabil_documentos = self.browse(cr, uid, ids, context)
        res = []
        for record in browse_contabil_documentos:
            documento = record.documento or ''
            if documento:
                documento = str(documento)
            res.append((record.id, documento))
        return res

    def name_search(self, cr, uid, name='', args=None, operator='ilike', context=None, limit=100):
        context = context and context.copy() or {}
        try:
            name = int(name)
        except:
            pass
        if isinstance(name, int):
            ids = self.search(cr, uid, [('documento', '=', name)] + args, limit=limit, context=context)
        else:
            if not name:
                ids = self.search(cr, uid, args, limit=limit, context=context)
            else:
                ids = []
        return self.name_get(cr, uid, ids, context)

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        data_movimento = vals.get('data_movimento')
        context['data_movimento'] = data_movimento
        res = super(contabil_documentos, self).create(cr, uid, vals, context)
        return res

    def button_atualizar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {}, context)
        return True


