# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from datetime import date
from openerp.tools.translate import _


class contabil_lancamentos(osv.Model):
    _name = 'contabil.lancamentos'
    _inherit = 'contabil.lancamentos'

    def _ctblan_lancar_rateio(self, cr, uid, ids, conta_id, contra_partida_id, valor, context=None):
        context = context and context.copy() or {}
        if isinstance(conta_id, list):
            conta_id = conta_id[0]
        if isinstance(ids, list):
            ids = ids[0]
        obj_contabil_conta = self.pool.get('contabil.conta')
        obj_contabil_lancamento_centro_custos = self.pool.get('contabil.lancamento.centro.custos')
        centro_custos_ids = obj_contabil_lancamento_centro_custos.search(cr, uid, [('ctbccu_lancamento_id', '=', ids)],
                                                                         context=context)
        obj_contabil_lancamento_centro_custos.unlink(cr, uid, centro_custos_ids)
        conta_rateio_ids = False
        if conta_id:
            conta_rateio_ids = obj_contabil_conta.browse(cr, uid, conta_id, context).ctbctb_rateio_ids
        if conta_rateio_ids:
            for i in conta_rateio_ids:
                vals = {
                    'ctbccu_lancamento_id': ids,
                    'ctbccu_centro_custos_id': i.ctbccr_centro_custos_id.id,
                    'ctbccu_valor': i.ctbccr_percentual * valor / 100,
                }
                obj_contabil_lancamento_centro_custos.create(cr, uid, vals, context)
        elif contra_partida_id:
            contra_partida_rateio_ids = obj_contabil_conta.browse(cr, uid, contra_partida_id).ctbctb_rateio_ids
            if contra_partida_rateio_ids:
                for i in contra_partida_rateio_ids:
                    vals = {
                        'ctbccu_lancamento_id': ids,
                        'ctbccu_centro_custos_id': i.ctbccr_centro_custos_id.id,
                        'ctbccu_valor': i.ctbccr_percentual * valor / 100,
                    }
                    obj_contabil_lancamento_centro_custos.create(cr, uid, vals, context)

        return True

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        res = super(contabil_lancamentos, self).create(cr, uid, vals, context)
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
        obj_adm_parametro = self.pool.get('adm.parametro')
        adm_parametro_id = obj_adm_parametro.search(cr, uid, [('company_id', '=', company_id)], context=context)
        if adm_parametro_id:
            admpar_ctb_custos = obj_adm_parametro.browse(cr, uid, adm_parametro_id[0]).admpar_ctb_custos
            if admpar_ctb_custos:
                self._ctblan_lancar_rateio(cr, uid, res, vals.get('contabil_conta_id'), vals.get('contra_partida_id'),
                                           vals.get('valor_lancamento'))
        data_movimento = context.get('data_movimento')
        if data_movimento:
            vals['data_movimento'] = data_movimento
        else:
            vals['data_movimento'] = date.today()
        if vals.get('debito_credito') == 'C':
            _conta_credito = vals.get('contabil_conta_id')
            _conta_debito = vals.get('contra_partida_id', False)
        else:
            _conta_debito = vals.get('contabil_conta_id')
            _conta_credito = vals.get('contra_partida_id', False)

        if vals.get('contra_partida_id'):
            _cpartida = vals.get('contra_partida_id')
            vals['contra_partida_id'] = vals['contabil_conta_id']
            vals['contabil_conta_id'] = _cpartida
            if vals.get('debito_credito') == 'C':
                vals['debito_credito'] = 'D'
            else:
                vals['debito_credito'] = 'C'
            res1 = super(contabil_lancamentos, self).create(cr, uid, vals, context)
        self.pool.get('contabil.saldos').ctbsal_atualiza_saldo(cr, uid, _conta_debito, _conta_credito,
                                                               vals.get('valor_lancamento'), vals.get('data_movimento'),
                                                               context)
        return res

    def ctblan_incluir_custos(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_model_data = self.pool.get('ir.model.data')
        reference = obj_model_data.get_object_reference(cr, uid, 'contabil',
                                                        'view_contabil_lancamento_centro_custos_form')
        view_id = reference and reference[1] or False
        return {'name': 'Custos',
                'view_type': 'form',
                'view_mode': 'form',
                'res_model': 'contabil.lancamentos',
                'view_id': [view_id],
                'target': 'new',
                'type': 'ir.actions.act_window'
        }

    def button_salvar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return True

    def default_get(self, cr, uid, fields, context):
        context = context and context.copy() or {}
        res = super(contabil_lancamentos, self).default_get(cr, uid, fields, context)
        if context.get('active_id'):
            lancamento_id = context.get('active_id')
            browse_lancamento = self.browse(cr, uid, lancamento_id)
            contabil_conta_id = browse_lancamento.contabil_conta_id.id
            documento_id = browse_lancamento.documento_id.id
            res['contabil_conta_id'] = contabil_conta_id
            res['documento_id'] = documento_id
            res['id'] = lancamento_id
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        admpar_ctb_custos = False
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
        obj_adm_parametro = self.pool.get('adm.parametro')
        adm_parametro_id = obj_adm_parametro.search(cr, uid, [('company_id', '=', company_id)], context=context)
        browse_contabil_lancamento = self.browse(cr, uid, ids[0])
        if vals.get('valor_lancamento') or vals.get('data_movimento') or vals.get('contabil_conta_id') or vals.get(
                'contra_partida_id') in vals:
            valor_lancamento_anterior = browse_contabil_lancamento.valor_lancamento
            debito_credito = vals.get('debito_credito') or browse_contabil_lancamento.debito_credito
            contabil_conta_id = vals.get('contabil_conta_id') or browse_contabil_lancamento.contabil_conta_id.id
            contra_partida_id = vals.get('contra_partida_id') or browse_contabil_lancamento.contra_partida_id.id
            data_movimento = vals.get('data_movimento') or browse_contabil_lancamento.data_movimento

            if debito_credito == 'C':
                _conta_credito = contabil_conta_id
                _conta_debito = contra_partida_id
            else:
                _conta_debito = contabil_conta_id
                _conta_credito = contabil_conta_id

            if vals.get('valor_lancamento'):
                valor_lancamento = valor_lancamento_anterior if valor_lancamento_anterior == vals.get(
                    'valor_lancamento') else \
                    valor_lancamento_anterior - vals.get('valor_lancamento')
                valor_lancamento = valor_lancamento * -1 if valor_lancamento < 0 else valor_lancamento

            #Atualiza saldo
            self.pool.get('contabil.saldos').ctbsal_atualiza_saldo(cr, uid, _conta_debito, _conta_credito,
                                                                   valor_lancamento, data_movimento, context)

        if adm_parametro_id:
            admpar_ctb_custos = obj_adm_parametro.browse(cr, uid, adm_parametro_id[0]).admpar_ctb_custos
        if admpar_ctb_custos:
            valor = 0.0
            valor_custos_lancados = 0.0
            custos_excluidos = True
            if vals.get('contabil_conta_id') or vals.get('contra_partida_id'):
                self._ctblan_lancar_rateio(cr, uid, ids, vals.get('contabil_conta_id'), vals.get('contra_partida_id'),
                                           valor_lancamento)
            ctblan_custos_ids = browse_contabil_lancamento.ctblan_custos_ids
            for custo in ctblan_custos_ids:
                valor_custos_lancados += custo.ctbccu_valor or 0.0
            if vals.get('ctblan_custos_ids'):
                ctblan_custos_ids = vals.get('ctblan_custos_ids')
                for x in ctblan_custos_ids:
                    for y in x:
                        if isinstance(y, dict):
                            custos_excluidos = False
                            valor += y.get('ctbccu_valor') or 0.0
            valor += valor_custos_lancados
            if not custos_excluidos:
                if round(valor_lancamento, 2) < round(valor, 2):
                    raise osv.except_osv(_('Atencao'), _('O valor dos custos deve ser igual ao valor do lancamento'))
        res = super(contabil_lancamentos, self).write(cr, uid, ids, vals, context)
        return res

    def unlink(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}

        browse_contabil_lancamento = self.browse(cr, uid, ids[0])
        valor_lancamento = browse_contabil_lancamento.valor_lancamento
        debito_credito = browse_contabil_lancamento.debito_credito
        contabil_conta_id = browse_contabil_lancamento.contabil_conta_id.id
        contra_partida_id = browse_contabil_lancamento.contra_partida_id.id
        data_movimento = browse_contabil_lancamento.data_movimento

        if debito_credito == 'C':#Lancando contas inversas pra debitar e creditar corretamente.
            _conta_debito = contabil_conta_id
            _conta_credito = contabil_conta_id
        else:
            _conta_credito = contabil_conta_id
            _conta_debito = contra_partida_id

        #Atualiza saldo
        self.pool.get('contabil.saldos').ctbsal_atualiza_saldo(cr, uid, _conta_debito, _conta_credito, valor_lancamento,
                                                               data_movimento, context)

        res = super(contabil_lancamentos, self).unlink(cr, uid, ids, context)
        return res
