# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp import SUPERUSER_ID


class contabil_saldos(osv.Model):
    """
    Tabela de saldos contabeis
    """

    _name = 'contabil.saldos'
    _inherit = 'contabil.saldos'

    def ctbsal_atualiza_saldo(self, cr, uid, conta_debito_id, conta_credito_id, valor_lancamento, data_lancamento,
                              context=None):
        context = context and context.copy() or {}
        if conta_debito_id and conta_credito_id and valor_lancamento > 0 and data_lancamento:
            #Debito
            conta_debito_ids = self.search(cr, uid, [('contabil_conta_id', '=', conta_debito_id),
                                                     ('data_saldo', '=', data_lancamento)],
                                           order='data_saldo desc', limit=1, context=context)
            if conta_debito_ids:
                saldo = self.browse(cr, uid, conta_debito_ids[-1]).ctbsal_saldo_final or 0.00
                self.write(cr, uid, conta_debito_ids[0], {'ctbsal_saldo_inicial': saldo - valor_lancamento}, context=context)
            else:

                conta_debito_ids = self.search(cr, uid, [('contabil_conta_id', '=', conta_debito_id),
                                                         ('data_saldo', '<', data_lancamento)],
                                               order='data_saldo desc', limit=1, context=context)
                if conta_debito_ids:
                    #Saldo inicial + valor do lancamento
                    saldo = self.browse(cr, uid, conta_debito_ids[-1]).ctbsal_saldo_final or 0.00
                    saldo_inicial = saldo - valor_lancamento
                    self.create(cr, uid, {'contabil_conta_id': conta_debito_id, 'data_saldo': data_lancamento,
                                          'ctbsal_saldo_inicial': saldo_inicial}, context)
                else:
                    #Se nao existe saldo pra a data informada entao = 0
                    self.create(cr, uid, {'contabil_conta_id': conta_debito_id, 'data_saldo': data_lancamento,
                                          'ctbsal_saldo_inicial': 0}, context)

            #Credito
            conta_credito_ids = self.search(cr, uid, [('contabil_conta_id', '=', conta_credito_id),
                                                      ('data_saldo', '=', data_lancamento)],
                                            order='data_saldo desc', limit=1, context=context)

            if conta_credito_ids:
                saldo = self.browse(cr, uid, conta_credito_ids[-1]).ctbsal_saldo_final or 0.00
                self.write(cr, uid, conta_credito_ids[0], {'ctbsal_saldo_inicial': saldo + valor_lancamento}, context=context)
            else:

                conta_credito_ids = self.search(cr, uid, [('contabil_conta_id', '=', conta_credito_id),
                                                          ('data_saldo', '<', data_lancamento)],
                                                order='data_saldo desc', limit=1, context=context)
                if conta_credito_ids:
                    #saldo_anterior + valor_lancado
                    saldo_c = self.browse(cr, uid, conta_credito_ids[-1]).ctbsal_saldo_final or 0.00
                    saldo_inicial = saldo_c - valor_lancamento
                    self.create(cr, uid, {'contabil_conta_id': conta_credito_id, 'data_saldo': data_lancamento,
                                          'ctbsal_saldo_inicial': saldo_inicial}, context)
                else:
                #Se nao existe saldo pra a data informada entao = 0
                    self.create(cr, uid, {'contabil_conta_id': conta_credito_id, 'data_saldo': data_lancamento,
                                          'ctbsal_saldo_inicial': 0}, context)

            contabil_saldos_debito_ids = self.search(cr, uid, [('contabil_conta_id', '=', conta_debito_id),
                                                               ('data_saldo', '>', data_lancamento)], context=context)
            if contabil_saldos_debito_ids:
                browse_contabil_saldos_debito = self.browse(cr, uid, contabil_saldos_debito_ids, context)
                for x in browse_contabil_saldos_debito:
                    saldo_incial = x.ctbsal_saldo_final or 0.0
                    saldo_incial -= valor_lancamento
                    self.write(cr, uid, x.id, {'ctbsal_saldo_inicial': saldo_incial}, context=context)

            contabil_saldos_credito_ids = self.search(cr, uid, [('contabil_conta_id', '=', conta_credito_id),
                                                                ('data_saldo', '>', data_lancamento)], context=context)
            if contabil_saldos_credito_ids:
                browse_contabil_saldos_credito = self.browse(cr, uid, contabil_saldos_credito_ids, context)
                for x in browse_contabil_saldos_credito:
                    saldo_incial = x.ctbsal_saldo_final or 0.0
                    saldo_incial += valor_lancamento
                    self.write(cr, uid, x.id, {'ctbsal_saldo_inicial': saldo_incial}, context=context)
            values = {'ctbsal_saldo_final': ''}
            self.pool.get('contabil.saldos').write(cr, SUPERUSER_ID,
                                                   contabil_saldos_credito_ids + contabil_saldos_debito_ids, values,
                                                   context)
            return True
        else:
            return False
