# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class adm_parametro(osv.Model):
    _name = 'adm.parametro'
    _inherit = 'adm.parametro'
    _columns = {
        'admpar_ctb_registro_junta': fields.char('Registro na junta', size=15, oldname="ctb_registro_junta"), # codigo de registro na junta
        'admpar_ctb_data_registro_junta': fields.date('Data do registro na junta', oldname="ctb_data_registro_junta"), # Data do registro na junta
        'admpar_ctb_mascara_conta': fields.char('Mascara da conta', size=25, required=True, oldname="ctb_mascara_conta"), # Mascara da conta contabil
        'admpar_ctb_integrar_cre': fields.boolean('Integrar Contas a Receber', oldname="ctb_integrar_cre"),
        'admpar_ctb_integrar_cpg': fields.boolean('Integrar Contas a Pagar', oldname="ctb_integrar_cpg"),
        'admpar_ctb_integrar_caixa_bancos': fields.boolean('Integrar Caixa/Bancos', oldname="ctb_integrar_caixa_bancos"),
        'admpar_ctb_integrar_cupons': fields.boolean('Integrar Cupons', oldname="ctb_integrar_cupons"),
        'admpar_ctb_integrar_nf': fields.boolean('Integrar Notas', oldname="ctb_integrar_nf"),
        'admpar_ctb_custos': fields.boolean('Contabilidade por custos'),
    }

    _defaults = {
        'admpar_ctb_integrar_cre': False,
        'admpar_ctb_integrar_cpg': False,
        'admpar_ctb_integrar_caixa_bancos': False,
        'admpar_ctb_integrar_cupons': False,
        'admpar_ctb_integrar_nf': False,
    }
    _sql_constraints = [
        ('empresa_uniq', 'unique (company_id)', 'So posso ter um registro por empresa!'),
    ]

