# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class contabil_conta(osv.Model):
    """
    tabela de contas contabil
    Prefixo: ctbcta_
    """

    _name = 'contabil.conta'
    _parent_store = True
    _roteavel = True
    _columns = {
        'write_date': fields.datetime('Data de atualizacao', readonly=True),
        'create_date': fields.datetime('Data de criacao', readonly=True),
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'conta': fields.char('Conta', size=20, required=True, select=True), # conta contabil
        'digito_conta': fields.char('Digito', size=1), # Digito da conta contabil
        'conta_reduzida': fields.integer('Conta reduzida'), # conta reduzida
        'digito_reduzida': fields.char('Digito reduzida', size=1), # Digito da conta reduzida
        'name': fields.char('Descricao', size=50, required=True), # descricao da conta
        'grau': fields.integer('Grau', required=True), # Grau da conta
        'conta_tipo': fields.selection([('S', 'Sintetica'), ('A', 'Analitica')], 'Sintetica/Analitica', required=True,
                                       size=1),
        'natureza': fields.selection(
            [('A', 'Ativo'), ('P', 'Passivo'), ('R', 'Contas de resultado'), ('L', 'Patrimonio liquido'),
             ('C', 'Compensacao'), ('O', 'Outras')], 'Natureza', required=True, size=1),
        'tipo_saldo': fields.selection([('M', 'Misto'), ('C', 'Credor'), ('D', 'Devedor')], 'Tipo de saldo',
                                       required=True, size=1),
        'ocultar_analiticas': fields.boolean('Ocultar analiticas'), # indica se as contas analiticas devem ser ocultadas
        'saldos_ids': fields.one2many('contabil.saldos', 'contabil_conta_id', 'Saldos'),
        'contas_ids': fields.one2many('contabil.lancamentos', 'contabil_conta_id', 'Lancamentos'),
        'contras_ids': fields.one2many('contabil.lancamentos', 'contra_partida_id', 'Lancamentos'),
        'parent_id': fields.many2one('contabil.conta', 'Conta superior', select=1),
        'parent_left': fields.integer('Conta descendente', select=1),
        'parent_right': fields.integer('Conta ascendente', select=1),
        'ctbctb_rateio_ids': fields.one2many('contabil.centro.custos.rateio', 'ctbccr_conta_id', 'Rateio de custos'),
        'ctbcta_conta_referencial': fields.char('Conta Referencial', size=20),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        'ocultar_analiticas': lambda *a: False,
    }
    _sql_constraints = [
        ('conta_uniq', 'unique (company_id, conta)', 'Conta contabil precisa ser unica!'),
    ]

