# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import ctbdoc_get_total_debito_credito

class contabil_documentos(osv.Model):
    _name = 'contabil.documentos'
    _rec_name = 'documento'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'data_movimento': fields.date('Data do movimento', required=True), # data do movimento\n
        'tipo_lancamento': fields.selection([('N', 'Normal'), ('E', 'Encerramento')], 'Tipo de lancamento',
                                            required=True, size=1),
        'pessoa_id': fields.many2one("adm.pessoa", 'Participante', ondelete="restrict", select=True), # id da pessoa
        'documento': fields.integer('Numero do documento'), # Numero do documento
        'ctbdoc_lote': fields.integer('Numero do lote', oldname='lote'), # Numero do lote
        'lancamentos_ids': fields.one2many('contabil.lancamentos', 'documento_id', 'Lancamentos'),
        'ctbdoc_valor': fields.float('Valor do documento', digits=(14, 2)), # Valor do documento, nao e do lancamento
        'ctbdoc_total_creditos': fields.function(
            ctbdoc_get_total_debito_credito, arg='C', method=True, string='Total de Creditos',
            type='float', digits=(14, 2), store=True
        ),
        'ctbdoc_total_debitos': fields.function(
            ctbdoc_get_total_debito_credito, arg='D', method=True, string='Total de Debitos',
            type='float', digits=(14, 2), store=True
        ),
        'ctbdoc_origem': fields.selection(
            [('N', 'Nota Fiscal'), ('C', 'Cupom Fiscal'), ('T', 'Tesouraria'), ('F', 'Receber/Pagar')],
            'Origem da transacao', size=1),
    }
    _defaults = {
        'tipo_lancamento': lambda *a: 'N',
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }

