# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

READ_LOAD = '_classic_write'


def ctbdoc_get_total_debito_credito(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    if isinstance(ids, (int, long)):
        ids = [ids]

    res = {}.fromkeys(ids, 0)

    debito_credito = arg

    obj_contabil_lacamentos = self.pool.get('contabil.lancamentos')
    lacamento_ids = obj_contabil_lacamentos.search(
        cr, uid, [('documento_id', 'in', ids), ('debito_credito', '=', debito_credito)], context=context
    )
    if lacamento_ids:
        lacamento_dados = obj_contabil_lacamentos.read(
            cr, uid, lacamento_ids, ['documento_id', 'valor_lancamento'], context=context, load=READ_LOAD
        )
        for i in lacamento_dados:
            doc_id = i.get('documento_id')
            valor_lancamento = i.get('valor_lancamento') or 0
            res[doc_id] += valor_lancamento
    return res

# Funcoes da classe contabil_saldos
def ctbsal_get_saldo_final(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    if not ids:
        return res
    if not isinstance(ids, list):
        ids = [ids]
    obj_contabil_lancamentos = self.pool.get('contabil.lancamentos')
    browse_contabil_saldos = self.browse(cr, uid, ids, context)
    for saldo in browse_contabil_saldos:
        saldo_inicial = saldo.ctbsal_saldo_inicial or 0.0
        conta_id = saldo.contabil_conta_id.id
        data = saldo.data_saldo
        credito = 0.0
        debito = 0.0
        contabil_lancamentos_ids = obj_contabil_lancamentos.search(cr, uid, [('contabil_conta_id','=',conta_id),
                                                                             ('create_date','>=',data+' 00:00:00'),
                                                                             ('create_date','<=',data+' 23:59:59')],
                                                                   context=context)
        if contabil_lancamentos_ids:
            browse_contabil_lancamentos = obj_contabil_lancamentos.browse(cr, uid, contabil_lancamentos_ids, context)
            for lancamento in browse_contabil_lancamentos:
                if lancamento.debito_credito == 'D':
                    debito += lancamento.valor_lancamento or 0.0
                else:
                    credito += lancamento.valor_lancamento or 0.0
        res[saldo.id] = saldo_inicial - credito + debito
    return res

def ctbsal_get_debitos(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    if not ids:
        return res
    obj_contabil_lancamentos = self.pool.get('contabil.lancamentos')
    obj_contabil_documentos = self.pool.get('contabil.documentos')
    browse_contabil_saldos = self.browse(cr, uid, ids, context)
    for x in browse_contabil_saldos:
        debito = 0.0
        data_saldo = x.data_saldo
        conta_id = x.contabil_conta_id.id
        documento_ids = obj_contabil_documentos.search(cr, uid, [('data_movimento','=',data_saldo)], context=context)
        contabil_lancamentos_ids = obj_contabil_lancamentos.search(cr, uid, [('contabil_conta_id','=',conta_id),
                                                                             ('documento_id','in', documento_ids)],
                                                                   context=context)
        if contabil_lancamentos_ids:
            browse_contabil_lancamentos = obj_contabil_lancamentos.browse(cr, uid, contabil_lancamentos_ids, context)
            for lancamento in browse_contabil_lancamentos:
                if lancamento.debito_credito == 'D':
                    debito += lancamento.valor_lancamento or 0.0
        res[x.id] = debito
    return res

def ctbsal_get_creditos(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    if not ids:
        return res
    obj_contabil_lancamentos = self.pool.get('contabil.lancamentos')
    obj_contabil_documentos = self.pool.get('contabil.documentos')
    browse_contabil_saldos = self.browse(cr, uid, ids, context)
    for x in browse_contabil_saldos:
        credito = 0.0
        data_saldo = x.data_saldo
        conta_id = x.contabil_conta_id.id
        documento_ids = obj_contabil_documentos.search(cr, uid, [('data_movimento','=',data_saldo)], context=context)
        contabil_lancamentos_ids = obj_contabil_lancamentos.search(cr, uid, [('contabil_conta_id','=',conta_id),
                                                                             ('documento_id','in', documento_ids)],
                                                                   context=context)
        if contabil_lancamentos_ids:
            browse_contabil_lancamentos = obj_contabil_lancamentos.browse(cr, uid, contabil_lancamentos_ids, context)
            for lancamento in browse_contabil_lancamentos:
                if lancamento.debito_credito == 'C':
                    credito += lancamento.valor_lancamento or 0.0
        res[x.id] = credito
    return res

def ctblan_get_admpar_ctb_custos(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    if not ids:
        return res
    admpar_ctb_custos = False
    company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
    obj_adm_parametro = self.pool.get('adm.parametro')
    adm_parametro_id = obj_adm_parametro.search(cr, uid, [('company_id','=',company_id)], context=context)
    if adm_parametro_id:
        admpar_ctb_custos = obj_adm_parametro.browse(cr, uid, adm_parametro_id[0]).admpar_ctb_custos
    browse_contabil_lancamentos = self.browse(cr, uid, ids, context)
    for x in browse_contabil_lancamentos:
        res[x.id] = admpar_ctb_custos
    return res
