# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class contabil_lancamentos(osv.Model):
    """
    tabela de lancamentos contabeis
    """

    from funcoes import ctblan_get_admpar_ctb_custos

    _inherits = {
        'contabil.documentos': 'documento_id',
    }
    _name = 'contabil.lancamentos'
    _columns = {
        'contabil_conta_id': fields.many2one("contabil.conta", 'Conta', ondelete="restrict", required=True,
                                             select=True), # id da conta contabil
        'historico': fields.text('Historico', required=True), # historico do lancamento
        'valor_lancamento': fields.float('Valor do lancamento', digits=(14, 2), required=True), # Valor do lancamento
        'debito_credito': fields.selection([('D', 'Debito'), ('C', 'Credito')], 'Devedor/Credor', required=True,
                                           size=1), # Tipo de lancamento\nD=Debito\nC=Credito\n
        'contra_partida_id': fields.many2one("contabil.conta", 'Contra partida', ondelete="restrict", select=True),
        'documento_id': fields.many2one("contabil.documentos", 'Documento', ondelete="cascade", required=True,
                                        select=True), # id do documento
        'historico_padrao_id': fields.many2one("contabil.historico.padrao", 'Historico padrao', ondelete="restrict",
                                               select=True), # id do historico padrao
        'ctblan_custos_ids': fields.one2many('contabil.lancamento.centro.custos', 'ctbccu_lancamento_id',
                                             'Centro de custos'),
        'ctblan_ctb_custos_ativado': fields.function(ctblan_get_admpar_ctb_custos, string="Custos ativado", method=True,
                                                     type="boolean", store=False),
    }

