# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class contabil_saldos(osv.Model):
    """
    Tabela de saldos contabeis
    """

    #prefixo = ctbsal_

    from funcoes import ctbsal_get_saldo_final, ctbsal_get_creditos, ctbsal_get_debitos

    _name = 'contabil.saldos'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True), # id da empresa
        'contabil_conta_id': fields.many2one("contabil.conta", 'Conta', ondelete="cascade", required=True, select=True),
        'data_saldo': fields.date('Data do saldo', required=True, select=True), # Data do saldo
        'ctbsal_saldo_inicial': fields.float('Saldo inicial', digits=(14, 2), required=True, oldname="saldo"),
        'ctbsal_saldo_final': fields.function(
            ctbsal_get_saldo_final, string="Saldo final", method=True, type="float", store=True, digits=(14, 2)
        ),
        'ctbsal_debitos': fields.function(
            ctbsal_get_debitos, string="Debitos", method=True, type="float", store=True, digits=(14, 2)
        ),
        'ctbsal_creditos': fields.function(
            ctbsal_get_creditos, string="Creditos", method=True, type="float", store=True, digits=(14, 2)
        ),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }

