#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools import drop_view_if_exists


class pgview_contabil_dif_debito_credito(osv.Model):

    _name = 'pgview.contabil.dif.debito.credito'
    _auto = False
    _columns = {
        'id': fields.integer('ID'),
        'company_id': fields.many2one('res.company', 'Empresa', ondelete="cascade"),
        'pgctb_dif_documento': fields.integer('Documento'),
        'pgctb_dif_data_movimento': fields.date('Data Movimento'),
        'pgctb_dif_debito': fields.float('Debito', digits=(14, 2)),
        'pgctb_dif_credito': fields.float('Debito', digits=(14, 2)),
        'pgctb_dif_mes_ano': fields.char('Mes-Ano', size=7),
        # 'pgctb_dif_valor_total':
    }

    def init(self, cr):
        drop_view_if_exists(cr, 'pgview_contabil_dif_debito_credito')
        cr.execute(
            """
            CREATE VIEW pgview_contabil_dif_debito_credito AS (
                SELECT
                    id as id,
                    company_id,
                    documento AS pgctb_dif_documento,
                    to_char(data_movimento, 'DD/MM/YYYY') AS pgctb_dif_data_movimento,
                    to_char(data_movimento, 'MM-YYYY') AS pgctb_dif_mes_ano,
                    ctbdoc_total_creditos AS pgctb_dif_credito,
                    ctbdoc_total_debitos AS pgctb_dif_debito
                FROM
                    contabil_documentos
                WHERE
                    ctbdoc_total_debitos != ctbdoc_total_creditos
                ORDER BY
                    data_movimento
            );
            """
        )
