# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from openerp.osv import osv
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}

        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Listagem Plano Contas'))
        listagem.informaTamLinha(160)

        obj_contabil_contas = pooler.get_pool(cr.dbname).get('contabil.conta')

        natureza = datas.get('natureza')
        ordem = datas.get('ordem')

        if natureza:
            conta_ids = obj_contabil_contas.search(cr, uid, [('natureza', '=', natureza), ('conta_tipo', '=', 'S')],
                                                   order="conta", context=context)
        else:
            conta_ids = obj_contabil_contas.search(cr, uid, [('conta_tipo', '=', 'S')], order="conta", context=context)

        if ordem == 'A':
            ordem = 'name'
        elif ordem == 'N':
            ordem = 'conta'
        else:
            ordem = 'name'

        if conta_ids:
            company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                                                         'wizard.listagem.plano.contas',
                                                                                         context=context)
            res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id, ['name'],
                                                                                   context=context)
            nome_empresa = res_company_dados.get('name')
            data = time.strftime("%d/%m/%Y")
            docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
            title = center_title(_('Contabilidade'), _('Plano de Contas'), '')

            listagem.informaCab('' + title)
            listagem.informaCab('')
            listagem.informaCab('')
            listagem.informaCab('' + docs)
            listagem.informaCab('  ')
            listagem.informaCab(
                '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.informaCab(
                '|       CONTA        | DIGITO |                   DESCRICAO                   |  GRAU  |    TIPO CONTA    | OCULTAR ANALITICAS |    CONTA REDUZIDA   |')
            listagem.informaCab(
                '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.informaCab('  ')
            listagem.rodapePadrao()

            browse_contabil_conta = obj_contabil_contas.browse(cr, uid, conta_ids)

            for x in browse_contabil_conta:
                ocultar_analiticas = x.ocultar_analiticas
                contabil_contas_sinteticas_ids = obj_contabil_contas.search(cr, uid, [('parent_id', '=', x.id),
                                                                                      ('conta_tipo', '=', 'A'),
                                                                                      ], order=ordem, context=context)
                linha = formataString(x.conta or '', 20, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(x.digito_conta or '', 7, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(x.name or '', 46, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(x.grau or '', 7, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(_('Sintetica'), 17, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(_('Sim') if x.ocultar_analiticas else _('Nao'), 19, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(x.conta_reduzida or '', 20, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                listagem.imprimeLinha('|' + linha)
                listagem.imprimeLinha('')

                if not ocultar_analiticas and contabil_contas_sinteticas_ids:
                    browse_contabil_conta_analitica = obj_contabil_contas.browse(cr, uid,
                                                                                 contabil_contas_sinteticas_ids)
                    for y in browse_contabil_conta_analitica:
                        linha = formataString(y.conta or '', 20, ' ', 'D', 'N', 'S') + '|'
                        linha += ' '
                        linha += formataString(y.digito_conta or '', 7, ' ', 'D', 'N', 'S') + '|'
                        linha += ' '
                        linha += formataString(y.name or '', 46, ' ', 'D', 'N', 'S') + '|'
                        linha += ' '
                        linha += formataString(y.grau or '', 7, ' ', 'D', 'N', 'S') + '|'
                        linha += ' '
                        linha += formataString(_('Analitica'), 17, ' ', 'D', 'N', 'S') + '|'
                        linha += ' '
                        linha += formataString(_('Sim') if y.ocultar_analiticas else _('Nao'), 19, ' ', 'D', 'N',
                                               'S') + '|'
                        linha += ' '
                        linha += formataString(y.conta_reduzida or '', 20, ' ', 'D', 'N', 'S') + '|'
                        linha += ' '
                        listagem.imprimeLinha('|' + linha)
                listagem.imprimeLinha('')
                listagem.imprimeLinha('')
            listagem.imprimeLinha(
                '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.imprimeLinha(
                '                                                                                                                   ** Sig Informatica LTDA **       ')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_plano_contas')
