# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}

        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Razao Analitico'))
        listagem.informaTamLinha(160)

        obj_contabil_saldos = pooler.get_pool(cr.dbname).get('contabil.saldos')

        conta_id = datas.get('conta_id')
        data_inicial = datas.get('data_inicial')
        data_final = datas.get('data_final')

        data_inicial_str = time.strftime('%d/%m/%Y', time.strptime(data_inicial, '%Y-%m-%d'))
        data_final_str = time.strftime('%d/%m/%Y', time.strptime(data_final, '%Y-%m-%d'))
        periodo = '%s a %s' % (data_inicial_str, data_final_str)

        sql = """
            select cl.contabil_conta_id,
                   cd.data_movimento,
                   cd.documento,
                   case when cl.contra_partida_id is not null then (select conta from contabil_conta where cl.contra_partida_id = id)
                   else null
                   end as contra_partida,
                   cc.conta,
                   cc.name,
                   cl.historico,
                   case when cl.debito_credito = 'D' then cl.valor_lancamento
                   else 0
                   end as valor_debito,
                   case when cl.debito_credito = 'C' then cl.valor_lancamento
                   else 0
                   end as valor_credito
            from contabil_documentos cd,
                 contabil_conta cc,
                 contabil_lancamentos cl
            where cc.conta_tipo = 'A' and
                  cl.documento_id = cd.id and
                  cd.data_movimento >= '%s' and
                  cd.data_movimento <= '%s' and
        """ % (data_inicial, data_final)
        if conta_id:
            sql += """cl.contabil_conta_id = %s""" % conta_id
        else:
            sql += """cl.contabil_conta_id = cc.id"""
        sql += """ order by cl.contabil_conta_id, cd.data_movimento"""

        cr.execute(sql)
        dict_lancamentos = cr.dictfetchall()

        if dict_lancamentos:
            obj_contabil_conta = pooler.get_pool(cr.dbname).get('contabil.conta')
            company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                                                         'wizard.razao.analitico',
                                                                                         context=context)
            res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id, ['name'],
                                                                                   context=context)
            nome_empresa = res_company_dados.get('name')
            data = time.strftime("%d/%m/%Y")
            docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
            title = center_title(_('Contabilidade'), _('Razao Analitico ') + periodo, '')

            listagem.informaCab('' + title)
            listagem.informaCab('')
            listagem.informaCab('')
            listagem.informaCab('' + docs)
            listagem.informaCab('  ')
            listagem.informaCab(
                '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.informaCab(
                '|   DATA   |  DOCUMENTO  |       C/PART.        |                     HISTORICO                     |    DEBITO    |   CREDITO   |       SALDO       |')
            listagem.informaCab(
                '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.informaCab('  ')
            listagem.rodapePadrao()

            conta_ids = []
            for x in dict_lancamentos:
                conta_id = x.get('contabil_conta_id')
                if not conta_id in conta_ids:
                    conta_ids.append(conta_id)
                    contabil_saldos_id = obj_contabil_saldos.search(cr, uid, [('contabil_conta_id', '=', conta_id),
                                                                              ('data_saldo', '<=', data_inicial)],
                                                                    limit=1, context=context)
                    saldo_inicial = 0.0
                    debito_periodo = 0.0
                    credito_periodo = 0.0
                    if contabil_saldos_id:
                        saldo_inicial = obj_contabil_saldos.browse(cr, uid,
                                                                   contabil_saldos_id[0]).ctbsal_saldo_inicial or 0.0
                    conta = x.get('conta') or ''
                    nome_conta = x.get('name') or ''
                    numero_conta = conta + ' - ' + nome_conta
                    listagem.imprimeLinha(_('CONTA NUMERO    ') + numero_conta)
                    listagem.imprimeLinha('')

                    linha = formataString('', 50, ' ', 'D', 'N', 'S')
                    linha += formataString(_('SALDO ANTERIOR'), 79, ' ', 'D', 'N', 'S')
                    linha += formataString(getNumeroEditado(saldo_inicial, 2) + '  ', 20, ' ', 'E', 'N', 'S')
                    listagem.imprimeLinha(linha)
                    listagem.imprimeLinha('')
                    listagem.imprimeLinha('')

                valor_debito = x.get('valor_debito') or 0.0
                valor_credito = x.get('valor_credito') or 0.0
                data_lancamento = x.get('data_movimento')[:10]
                data_lancamento = time.strftime('%d/%m/%Y', time.strptime(data_lancamento, '%Y-%m-%d'))
                linha = formataString(data_lancamento, 10, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(x.get('documento') or '', 12, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                conta = x.get('conta')
                if conta:
                    conta = obj_contabil_conta.contabil_formatar_conta(cr, uid, conta, company_id, context=context)
                linha += formataString(conta or '', 21, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(x.get('historico') or '', 50, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                debito_periodo += valor_debito
                credito_periodo += valor_credito
                if valor_debito:
                    saldo_inicial += valor_debito
                else:
                    saldo_inicial -= valor_credito
                linha += formataString(getNumeroEditado(valor_debito, 2), 13, ' ', 'E', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(getNumeroEditado(valor_credito, 2), 12, ' ', 'E', 'N', 'S') + '|'
                linha += ' '
                if saldo_inicial < 0:
                    saldo_credor = saldo_inicial * -1
                    linha += formataString(str(getNumeroEditado(saldo_credor, 2)) + 'CR', 18, ' ', 'E', 'N', 'S') + '|'
                else:
                    linha += formataString(getNumeroEditado(saldo_inicial, 2) + '  ', 18, ' ', 'E', 'N', 'S') + '|'
                linha += ' '
                listagem.imprimeLinha('|' + linha)
                try:
                    if dict_lancamentos[dict_lancamentos.index(x) + 1].get('contabil_conta_id') not in conta_ids:
                        listagem.imprimeLinha('')
                        listagem.imprimeLinha('')
                        linha = formataString(_('MOVIMENTO DO MES'), 100, ' ', 'E', 'N', 'S')
                        linha += formataString(getNumeroEditado(debito_periodo, 2), 15, ' ', 'E', 'N', 'S')
                        linha += formataString(getNumeroEditado(credito_periodo, 2), 14, ' ', 'E', 'N', 'S')
                        if saldo_inicial < 0:
                            saldo_credor = saldo_inicial * -1
                            linha += formataString(str(getNumeroEditado(saldo_credor, 2)) + 'CR', 20, ' ', 'E', 'N',
                                                   'S')
                        else:
                            linha += formataString(getNumeroEditado(saldo_inicial, 2) + '  ', 20, ' ', 'E', 'N', 'S')
                        listagem.imprimeLinha(linha)
                        listagem.imprimeLinha('')
                        listagem.imprimeLinha('')
                except:
                    listagem.imprimeLinha('')
                    listagem.imprimeLinha('')
                    linha = formataString(_('MOVIMENTO DO MES'), 100, ' ', 'E', 'N', 'S')
                    linha += formataString(getNumeroEditado(debito_periodo, 2), 15, ' ', 'E', 'N', 'S')
                    linha += formataString(getNumeroEditado(credito_periodo, 2), 14, ' ', 'E', 'N', 'S')
                    if saldo_inicial < 0:
                        saldo_credor = saldo_inicial * -1
                        linha += formataString(str(getNumeroEditado(saldo_credor, 2)) + 'CR', 20, ' ', 'E', 'N', 'S')
                    else:
                        linha += formataString(getNumeroEditado(saldo_inicial, 2) + '  ', 20, ' ', 'E', 'N', 'S')
                    listagem.imprimeLinha(linha)
                    listagem.imprimeLinha('')
                    listagem.imprimeLinha('')
            listagem.imprimeLinha(
                '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.imprimeLinha(
                '                                                                                                                   ** Sig Informatica LTDA **       ')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.razao_analitico')
