# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def trata_data(self, cr, uid, ids, mes, context=None):
        context = context and context.copy() or {}
        primeiro_dia = 01
        if mes == '01' or mes == '03' or mes == '05' or mes == '07' or mes == '08' or mes == '10' or mes == '12':
            ultimo_dia = '31'
        elif mes != '02':
            ultimo_dia = '30'
        else:
            ultimo_dia = '28'
        return {'primeiro_dia': primeiro_dia, 'ultimo_dia': ultimo_dia}

    def create(self, cr, uid, ids, datas_filtro, context=None):
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, 'Diario')
        listagem.informaTamLinha(160)

        dicionario_meses = {
            '01': 'JANEIRO',
            '02': 'FEVEREIRO',
            '03': 'MARCO',
            '04': 'ABRIL',
            '05': 'MAIO',
            '06': 'JUNHO',
            '07': 'JULHO',
            '08': 'AGOSTO',
            '09': 'SETEMBRO',
            '10': 'OUTUBRO',
            '11': 'NOVEMBRO',
            '12': 'DEZEMBRO'
        }

        folha = datas_filtro.get('folha')

        folha = int(folha)

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid, 'wizard.relatorio.diario', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id,
                                                                               ['name', 'rescon_pessoa_id'], context=context)
        nome_empresa = res_company_dados.get('name')
        pessoa_id = res_company_dados.get('rescon_pessoa_id')
        if isinstance(pessoa_id, tuple):
            pessoa_id = pessoa_id[0]
        adm_pessoa_dados = pooler.get_pool(cr.dbname).get('adm.pessoa').read(cr, uid, pessoa_id, ['cidade'], context=context)
        if isinstance(adm_pessoa_dados, list):
            adm_pessoa_dados = adm_pessoa_dados[0]
        cidade = adm_pessoa_dados.get('cidade')

        data = time.strftime("%d/%m/%Y")

        obj_contabil_lancamentos = pooler.get_pool(cr.dbname).get('contabil.lancamentos')

        mes = datas_filtro.get('mes')
        ano = datas_filtro.get('ano')

        dias = self.trata_data(cr, uid, ids, mes)

        primeiro_dia = dias.get('primeiro_dia')
        ultimo_dia = dias.get('ultimo_dia')

        args = []
        args.append(('data_movimento', '>=', (str(ano) + '-' + mes + '-' + str(primeiro_dia))))
        args.append(('data_movimento', '<=', (str(ano) + '-' + mes + '-' + str(ultimo_dia))))

        lancamentos_ids = obj_contabil_lancamentos.search(cr, uid, args,
                                                          order='data_movimento asc, contabil_conta_id asc',
                                                          context=context)

        if lancamentos_ids:

            debitos_pagina = 0
            creditos_pagina = 0
            debitos_total = 0
            creditos_total = 0

            lancamentos_dados = obj_contabil_lancamentos.browse(cr, uid, lancamentos_ids)

            listagem.imprimeLinha('')
            listagem.imprimeLinha('' + center_title(_('Contabilidade'), _('Diario'), 'ctb360'))
            listagem.imprimeLinha('')
            listagem.imprimeLinha('')
            listagem.imprimeLinha('' + center_title(data, nome_empresa, _('Pagina: ') + str(folha)))
            listagem.imprimeLinha('')
            listagem.imprimeLinha(
                '*---------------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.imprimeLinha(
                ' CONTA                                                 C/PART          DOCUMENTO     HISTORICO                                                 VALOR          ')
            listagem.imprimeLinha(
                '*---------------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.imprimeLinha('')
            listagem.rodapePadrao()

            contador = 0
            numero_linhas = 0
            data_registro = lancamentos_dados[0].data_movimento
            listagem.imprimeLinha(
                '                 ' + cidade + '       ' + data_registro[8:10] + ' DE ' + dicionario_meses.get(
                    str(data_registro[5:7])) + ' DE ' + data_registro[:4])
            numero_linhas += 1
            while contador < len(lancamentos_dados):
                if numero_linhas % 112 == 0 and numero_linhas != 0:
                    folha += 1
                    listagem.imprimeLinha(
                        '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
                    listagem.imprimeLinha(
                        '                                            TOTAL DA PAGINA           DEBITOS-        ' + getNumeroEditado(
                            debitos_pagina, 2) + '  CREDITOS-       ' + getNumeroEditado(creditos_pagina, 2))
                    listagem.imprimeLinha(
                        '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
                    listagem.imprimeLinha(
                        '                                                                                                                                                      ')
                    numero_linhas = 0
                    creditos_pagina = 0
                    debitos_pagina = 0
                    listagem.imprimeLinha('' + center_title(_('Contabilidade'), _('Diario'), 'ctb360'))
                    listagem.imprimeLinha('')
                    listagem.imprimeLinha('')
                    listagem.imprimeLinha('' + center_title(data, nome_empresa, _('Pagina: ') + str(folha)))
                    listagem.imprimeLinha('')
                    listagem.imprimeLinha(
                        '*---------------------------------------------------------------------------------------------------------------------------------------------------------*')
                    listagem.imprimeLinha(
                        ' CONTA                                                 C/PART          DOCUMENTO     HISTORICO                                                 VALOR          ')
                    listagem.imprimeLinha(
                        '*---------------------------------------------------------------------------------------------------------------------------------------------------------*')
                    listagem.imprimeLinha('')
                if lancamentos_dados[contador].data_movimento == data_registro:
                    linha = formataString(lancamentos_dados[contador].contabil_conta_id.conta + ' ' + lancamentos_dados[
                        contador].contabil_conta_id.name or '', 54, ' ', 'D', 'N', 'S')
                    linha += formataString(lancamentos_dados[contador].contra_partida_id.conta or '', 18, ' ', 'D', 'N',
                                           'S')
                    linha += formataString(lancamentos_dados[contador].documento_id.documento or '', 13, ' ', 'D', 'N',
                                           'S')
                    indice = 0
                    posicao = 0
                    historico = {}
                    historico_aux = ''
                    while indice < len(lancamentos_dados[contador].historico):
                        if lancamentos_dados[contador].historico[indice] == '\n':
                            historico_aux += ' '
                        else:
                            historico_aux += lancamentos_dados[contador].historico[indice]
                        indice += 1
                    indice = 0
                    while indice < len(historico_aux):
                        if indice % 39 == 0:
                            historico[posicao] = historico_aux[indice:indice + 39]
                            posicao += 1
                        indice += 1
                    if historico:
                        linha += formataString(historico[0] or '', 53, ' ', 'D', 'N', 'S')
                    else:
                        linha += formataString('', 53, ' ', 'D', 'N', 'S')
                    valor_lancamento = lancamentos_dados[contador].valor_lancamento
                    if lancamentos_dados[contador].debito_credito == 'C':
                        creditos_pagina += valor_lancamento
                        creditos_total += valor_lancamento
                        valor_lancamento = getNumeroEditado(valor_lancamento, 2) + 'CR'
                    else:
                        debitos_pagina += valor_lancamento
                        debitos_total += valor_lancamento
                        valor_lancamento = getNumeroEditado(valor_lancamento, 2) + '  '
                    linha += formataString(valor_lancamento or '', 14, ' ', 'E', 'N', 'S')
                    listagem.imprimeLinha(linha)
                    numero_linhas += 1
                    if len(historico) > 1:
                        for i in range(1, len(historico)):
                            if numero_linhas % 112 != 0:
                                linha = formataString('', 85, ' ', 'D', 'N', 'S')
                                linha += historico[i]
                                listagem.imprimeLinha(linha)
                                numero_linhas += 1
                            elif numero_linhas != 0:
                                folha += 1
                                listagem.imprimeLinha(
                                    '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
                                listagem.imprimeLinha(
                                    '                                            TOTAL DA PAGINA           DEBITOS-        ' + getNumeroEditado(
                                        debitos_pagina, 2) + '  CREDITOS-       ' + getNumeroEditado(creditos_pagina,
                                                                                                     2))
                                listagem.imprimeLinha(
                                    '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
                                listagem.imprimeLinha(
                                    '                                                                                                                                                      ')
                                numero_linhas = 0
                                creditos_pagina = 0
                                debitos_pagina = 0
                                listagem.imprimeLinha('' + center_title(_('Contabilidade'), _('Diario'), 'ctb360'))
                                listagem.imprimeLinha('')
                                listagem.imprimeLinha('')
                                listagem.imprimeLinha('' + center_title(data, nome_empresa, _('Pagina: ') + str(folha)))
                                listagem.imprimeLinha('')
                                listagem.imprimeLinha(
                                    '*---------------------------------------------------------------------------------------------------------------------------------------------------------*')
                                listagem.imprimeLinha(
                                    ' CONTA                                                 C/PART          DOCUMENTO     HISTORICO                                                 VALOR          ')
                                listagem.imprimeLinha(
                                    '*---------------------------------------------------------------------------------------------------------------------------------------------------------*')
                                listagem.imprimeLinha('')

                    contador += 1
                else:
                    listagem.imprimeLinha('')
                    numero_linhas += 1
                    data_registro = lancamentos_dados[contador].data_movimento
                    listagem.imprimeLinha(
                        '                 ' + cidade + '       ' + data_registro[8:10] + ' DE ' + dicionario_meses.get(
                            str(data_registro[5:7])) + ' DE ' + data_registro[:4])
                    numero_linhas += 1

            listagem.imprimeLinha(
                '                                                                                                                                                      ')
            listagem.imprimeLinha(
                '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.imprimeLinha(
                _('                                            TOTAL DA PAGINA           DEBITOS-        ') + getNumeroEditado(
                    debitos_pagina, 2) + _('  CREDITOS-       ') + getNumeroEditado(creditos_pagina, 2))
            listagem.imprimeLinha(
                '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.imprimeLinha(
                _('                                            TOTAL GERAL               DEBITOS-        ') + getNumeroEditado(
                    debitos_total, 2) + _('  CREDITOS-       ') + getNumeroEditado(creditos_total, 2))
            listagem.imprimeLinha(
                '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.imprimeLinha(
                '                                                                                                                                                      ')


        db_name = pooler.get_pool(cr.dbname)
        adm_pagina_id = db_name.get('wizard.relatorio.diario').admpag_get_pagina_id(cr, uid, context)
        if adm_pagina_id:
            data_inicial = str(ano) + '-' + str(mes) + '-' + '01'
            folha = listagem.getPage()
            db_name.get('adm.paginas').admpag_set_pagina(cr, uid,
                                                      data_inicial=data_inicial, pag_final=folha, tipo='ctb_diario',
                                                      context=context
            )

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.relatorio_diario')
