#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from datetime import date
from openerp.addons.contabil.report.report_razao_sintetico import NOME_ARQUIVO_DEFAULT
from openerp.tools.translate import _

global MES, READ_LOAD
MES = {
    '01': 'Janeiro', '02': 'Fevereiro', '03': 'Marco', '04': 'Abril',
    '05': 'Maio', '06': 'Junho', '07': 'Julho', '08': 'Agosto',
    '09': 'Setembro', '10': 'Outubro', '11': 'Novembro', '12': 'Dezembro'
}
READ_LOAD = '_classic_write'


class wizard_balancete(osv.TransientModel):

    __mes = MES.items()
    __mes.sort()

    _name = 'wizard.balancete'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True),
        'ano': fields.integer('Ano', required=True),
        'mes': fields.selection(__mes, 'Mes', size=2, required=True),
        }
    _defaults = {
        'ano': date.today().year,
        'mes': str(date.today().month).rjust(2, '0'),
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        context['balancete'] = True
        balancete_dados = self.read(
            cr, uid, ids, ['ano', 'mes', 'company_id'], context=context, load=READ_LOAD
        )
        if balancete_dados and isinstance(balancete_dados, list):
            balancete_dados = balancete_dados[0]
        if isinstance(balancete_dados, dict):

            ano = balancete_dados.get('ano')
            mes = balancete_dados.get('mes')
            natureza = False
            company_id = balancete_dados.get('company_id')
            company_name = _('Empresa nao encontrada')
            if company_id:
                res_company_dados = self.pool.get('res.company').read(cr, uid, company_id, ['name'], context=context)
                if isinstance(res_company_dados, list):
                    res_company_dados = res_company_dados[0]
                company_name = res_company_dados.get('name')

            data = {
                'company_id': company_id,
                'company_name': company_name,
                'ano': ano,
                'mes': mes,
                'natureza': natureza
            }

        # return True
        return {'type': 'ir.actions.report.xml', 'report_name': NOME_ARQUIVO_DEFAULT, 'datas': data, 'context': context}
