#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from datetime import date
from openerp.addons.contabil.report.report_diferenca_debito_credito import NOME_ARQUIVO_DEFAULT

MES = {
    '01': 'Janeiro', '02': 'Fevereiro', '03': 'Marco', '04': 'Abril',
    '05': 'Maio', '06': 'Junho', '07': 'Julho', '08': 'Agosto',
    '09': 'Setembro', '10': 'Outubro', '11': 'Novembro', '12': 'Dezembro'
}
READ_LOAD = '_classic_write'


class wizard_contabil_diff_debito_credito(osv.Model):

    __mes = MES.items()
    __mes.sort()

    _name = 'wizard.contab.dif.debito.credito'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True),
        'wctb_dif_ano': fields.integer('Ano', required=True),
        'wctb_dif_mes': fields.selection(__mes, 'Mes', size=2, required=True),
    }
    _defaults = {
        'wctb_dif_ano': date.today().year,
        'wctb_dif_mes': str(date.today().month).rjust(2, '0'),
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }
    
    def wctb_dif_button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        data = {}
        dif_debito_credito_dados = self.read(
            cr, uid, ids, ['company_id', 'wctb_dif_ano', 'wctb_dif_mes'], context=context,load=READ_LOAD
        )
        if isinstance(dif_debito_credito_dados, list):
            dif_debito_credito_dados = dif_debito_credito_dados[0]
        if isinstance(dif_debito_credito_dados, dict):
            mes = dif_debito_credito_dados.get('wctb_dif_mes')
            ano = dif_debito_credito_dados.get('wctb_dif_ano')
            company_id = dif_debito_credito_dados.get('company_id')
            company_name = 'Empresa nao encontrada'
            if company_id:
                res_company_dados = self.pool.get('res.company').read(cr, uid, company_id, ['name'], context=context)
                if isinstance(res_company_dados, list):
                    res_company_dados = res_company_dados[0]
                company_name = res_company_dados.get('name')
            data.update({
                'ano': ano,
                'mes': mes,
                'company_id': company_id,
                'company_name': company_name
            })

        return {'type': 'ir.actions.report.xml', 'report_name': NOME_ARQUIVO_DEFAULT, 'datas': data}
