#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from datetime import date
from openerp.addons.contabil.report.report_razao_sintetico import NOME_ARQUIVO_DEFAULT


global MES, READ_LOAD
MES = {
    '01': 'Janeiro', '02': 'Fevereiro', '03': 'Marco', '04': 'Abril',
    '05': 'Maio', '06': 'Junho', '07': 'Julho', '08': 'Agosto',
    '09': 'Setembro', '10': 'Outubro', '11': 'Novembro', '12': 'Dezembro'
}
READ_LOAD = '_classic_write'


class wizard_fiscal_razao_sintetico(osv.Model):

    __mes = MES.items()
    __mes.sort()

    _name = 'wizard.razao.sintetico'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True),
        'wraz_sint_ano': fields.integer('Ano', required=True),
        'wraz_sint_mes': fields.selection(__mes, 'Mes', size=2, required=True),
        'wraz_sint_natureza': fields.selection(
            [('A', 'Ativo'), ('P', 'Passivo'), ('R', 'Contas de resultado'), ('L', 'Patrimônio liquido'),
             ('C', 'Compensacao'), ('O', 'Outras')], 'Natureza', size=1
        ),
    }
    _defaults = {
        'wraz_sint_ano': date.today().year,
        'wraz_sint_mes': str(date.today().month).rjust(2, '0'),
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }

    def wraz_sint_button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        razao_sint_dados = self.read(
            cr, uid, ids, ['wraz_sint_ano', 'wraz_sint_mes', 'wraz_sint_natureza', 'company_id'], context=context, load=READ_LOAD
        )
        if razao_sint_dados and isinstance(razao_sint_dados, list):
            razao_sint_dados = razao_sint_dados[0]
        if isinstance(razao_sint_dados, dict):

            ano = razao_sint_dados.get('wraz_sint_ano')
            mes = razao_sint_dados.get('wraz_sint_mes')
            natureza = razao_sint_dados.get('wraz_sint_natureza')
            company_id = razao_sint_dados.get('company_id')
            company_name = 'Empresa nao encontrada'
            if company_id:
                res_company_dados = self.pool.get('res.company').read(cr, uid, company_id, ['name'], context=context)
                if isinstance(res_company_dados, list):
                    res_company_dados = res_company_dados[0]
                company_name = res_company_dados.get('name')

            data = {
                'company_id': company_id,
                'company_name': company_name,
                'ano': ano,
                'mes': mes,
                'natureza': natureza
            }

        # return True
        return {'type': 'ir.actions.report.xml', 'report_name': NOME_ARQUIVO_DEFAULT, 'datas': data}
