#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from datetime import date
from openerp.addons.contabil.report.razao_sintetico_analitico import NOME_ARQUIVO_DEFAULT
from openerp.tools.translate import _


global MES, READ_LOAD
MES = {
    '01': 'Janeiro', '02': 'Fevereiro', '03': 'Marco', '04': 'Abril',
    '05': 'Maio', '06': 'Junho', '07': 'Julho', '08': 'Agosto',
    '09': 'Setembro', '10': 'Outubro', '11': 'Novembro', '12': 'Dezembro'
}
READ_LOAD = '_classic_write'


class wizard_fiscal_razao_sintetico_analitico(osv.TransientModel):
    __mes = MES.items()
    __mes.sort()

    _name = 'wizard.razao.sintetico.analitico'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True),
        'wraz_sint_ana_ano': fields.integer('Ano', required=True),
        'wraz_sint_ana_mes': fields.selection(__mes, 'Mes', size=2, required=True),
        'wraz_sint_ana_conta_id': fields.many2one('contabil.conta', 'Conta'),
    }
    _defaults = {
        'wraz_sint_ana_ano': date.today().year,
        'wraz_sint_ana_mes': str(date.today().month).rjust(2, '0'),
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }

    def wraz_sint_ana_button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        razao_sint_ana_dados = self.read(
            cr, uid, ids, ['wraz_sint_ana_ano', 'wraz_sint_ana_mes', 'wraz_sint_ana_conta_id', 'company_id'], context=context,
            load=READ_LOAD
        )
        if razao_sint_ana_dados and isinstance(razao_sint_ana_dados, list):
            razao_sint_ana_dados = razao_sint_ana_dados[0]
        if isinstance(razao_sint_ana_dados, dict):

            ano = razao_sint_ana_dados.get('wraz_sint_ana_ano')
            mes = razao_sint_ana_dados.get('wraz_sint_ana_mes')
            conta_id = razao_sint_ana_dados.get('wraz_sint_ana_conta_id')
            company_id = razao_sint_ana_dados.get('company_id')
            company_name = _('Empresa nao encontrada')
            if company_id:
                res_company_dados = self.pool.get('res.company').read(cr, uid, company_id, ['name'], context=context)
                if isinstance(res_company_dados, list):
                    res_company_dados = res_company_dados[0]
                company_name = res_company_dados.get('name')

            data = {
                'company_id': company_id,
                'company_name': company_name,
                'ano': ano,
                'mes': mes,
                'conta_id': conta_id,
            }

        return {'type': 'ir.actions.report.xml', 'report_name': NOME_ARQUIVO_DEFAULT, 'datas': data}
