# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from datetime import date


class wizard_relatorio_diario(osv.TransientModel):
    def admpag_get_pagina_id(self, cr, uid, context=None):
        context = context and context.copy() or {}
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'adm.paginas', context=context)
        obj_adm_pagina = self.pool.get('adm.paginas')
        adm_pagina_ids = obj_adm_pagina.search(cr, uid, [
            ('company_id', '=', company_id), ('tipo', '=', 'ctb_diario')
        ], context=context)
        if adm_pagina_ids:
            return max(adm_pagina_ids)
        else:
            return 0

    def onchange_data(self, cr, uid, ids, mes, ano, context=None):
        context = context and context.copy() or {}
        if mes and ano:
            data = str(ano) + '-' + str(mes) + '-' + '01'
            pagina = self.pool.get('adm.paginas').admpag_get_pagina(cr, uid, data=data, tipo='ctb_diario',
                                                                    context=context)
            return {'value': {'folha': pagina}}
        return False

    def _folha_inicial(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        company_id = self.pool.get('res.users').browse(cr, uid, uid, context=context).company_id.id
        obj_pagina = self.pool.get('adm.paginas')
        id_pagina = obj_pagina.search(cr, uid, [('company_id', '=', company_id), ('tipo', '=', 'ctb_diario')],
                                      context=context)
        if id_pagina:
            id_dados = obj_pagina.read(cr, uid, id_pagina, ['inicial'], context=context)
            if isinstance(id_dados, list):
                id_dados = id_dados[0]
                if isinstance(id_dados, dict):
                    id_dados = id_dados.get('inicial')
            grava = id_dados
        else:
            vals = {'data': date.today(),
                    'inicial': '1',
                    'tipo': 'ctb_diario'
                    }
            obj_pagina.create(cr, uid, vals, context={})
            grava = '1'
        return grava

    _name = 'wizard.relatorio.diario'
    _columns = {
        'mes': fields.selection([('01', 'Janeiro'), ('02', 'Fevereiro'), ('03', 'Marco'), ('04', 'Abril'),
                                 ('05', 'Maio'), ('06', 'Junho'), ('07', 'Julho'), ('08', 'Agosto'),
                                 ('09', 'Setembro'), ('10', 'Outubro'), ('11', 'Novembro'), ('12', 'Dezembro')], 'Mes',
                                size=2, required=True),
        'ano': fields.integer('Ano', required=True),
        'folha': fields.integer('Folha', help='Informe a folha inicial'),
    }

    _defaults = {
        'folha': _folha_inicial,
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        browse_relatorio_diario = self.browse(cr, uid, ids)
        for x in browse_relatorio_diario:
            datas = {
                'mes': x.mes,
                'ano': x.ano,
                'folha': x.folha
            }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'relatorio_diario',
            'datas': datas,
        }
