# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class contabil_conta(osv.Model):
    _name = 'contabil.conta'
    _inherit = 'contabil.conta'

    _columns = {
        'ctbcta_conta_cli_for_ccb': fields.selection([('C', 'Clientes'), ('F', 'Fornecedor'), ('B', 'Caixa/Banco')],
                                                     'Tipo de conta', size=1),
        'ctbcta_conta_cliente': fields.many2one('financeiro.cliente', 'Cliente'),
        'ctbcta_conta_fornecedor': fields.many2one('financeiro.fornecedor', 'Fornecedor'),
        'ctbcta_conta_caixa_banco': fields.many2one('financeiro.tesouraria.contas', 'Caixa/Banco'),
    }

    _sql_constraints = [
        ('conta_cliente_uniq', 'unique (company_id, ctbcta_conta_cliente)', 'Cliente precisa ser unico!'),
        ('conta_fornecedor_uniq', 'unique (company_id, ctbcta_conta_fornecedor)', 'Fornecedor precisa ser unico!'),
        ('conta_banco_uniq', 'unique (company_id, ctbcta_conta_caixa_banco)', 'Caixa/Banco precisa ser unico!'),
    ]
