# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import osv
import time
from openerp.tools.translate import _


class crm_br_case(osv.Model):

    _name = "crm_br.case"
    _inherit = "crm_br.case"

    def crmcas_onchange_pessoa(self, cr, uid, ids, pessoa_id, history_line, context=None):
        context = context and context.copy() or {}
        res = {}
        field_value = {'crmcas_faturar': False}
        msg = ''
        if pessoa_id and context.get('object_id') == 'crm_br.help_desk' and \
                (context.get('section_id') in ('HD', 'nivel2') or context.get('all_help_desk')):

            obj_financeiro_cliente = self.pool.get('financeiro.cliente')
            obj_financeiro = self.pool.get('financeiro')
            obj_adm_empresa_objeto = self.pool.get('adm.empresa.objeto')
            obj_contratos_contrato = self.pool.get('contratos.contrato')
            obj_contratos_prazos = self.pool.get('contratos.prazos')
            obj_contratos_tipo = self.pool.get('contratos.tipo')
            obj_vendas_utils = self.pool.get('vendas.utils')
            obj_financeiro_clientes_mensagem_nome = self.pool.get(
                'financeiro.clientes.mensagem.nome')
            obj_financeiro_clientes_mensagem = self.pool.get('financeiro.clientes.mensagem')

            cliente_company_id = obj_adm_empresa_objeto.getEmpresa(cr, uid, 'financeiro.cliente',
                                                                   context=context)
            is_cliente = obj_financeiro_cliente.verificar_incluir_cliente(
                cr, uid, pessoa_id, cliente_company_id, 'verificar', context)
            if not is_cliente:
                nome_pessoa = self.pool.get('adm.pessoa').browse(cr, uid, pessoa_id).nome
                res['pessoa_id'] = False
                res['warning'] = {'title': _('Atencao'),
                                  'message': _('%s nao e um cliente.' % nome_pessoa)}
                return res
            itens_contratos = self._crmcas_get_item_contrato(cr, uid, pessoa_id, context)
            if isinstance(itens_contratos,dict):
                if itens_contratos.get('warning'):
                    warn = itens_contratos['warning']
                    hist_line = [(0, 0, {'description': warn['message']})]
                    itens_contratos['value'].update({'history_line': hist_line})
                return itens_contratos
            else:
                field_value.update({'crmcas_contrato_item_ids':itens_contratos})
            pessoa_com_restricao = obj_financeiro.finutl_verificar_restricao_cliente(
                cr, uid, pessoa_id, context)
            if pessoa_com_restricao:
                msg += _('Cliente possui restricoes financeiras!\n')
                cliente_mensagem_nome_id = obj_vendas_utils.venutl_cliente_bloqueado_por_msg_ids(
                    cr, uid, pessoa_id, context=context).get('pessoa_ids').get(pessoa_id)
                if cliente_mensagem_nome_id:
                    brw_financeiro_clientes_mensagem_nome = obj_financeiro_clientes_mensagem_nome.\
                        browse(cr, uid, cliente_mensagem_nome_id, context)
                    msg += _(brw_financeiro_clientes_mensagem_nome.name+'\n')
            data_abertura = time.strftime('%Y-%m-%d')
            contrato_prazo_ids = obj_contratos_prazos.search(
                cr, uid, [('cttprz_data_inicio', '<=', data_abertura),
                          ('cttprz_data_termino', '>=', data_abertura),
                          ('cttprz_real_provisao', '=', 'R')], context=context)
            contrato_tipo_ids = obj_contratos_tipo.search(cr, uid, [('ctttip_considerar_no_crm',
                                                                     '=', True)], context=context)
            if contrato_prazo_ids and contrato_tipo_ids:
                brw_contrato_prazo = obj_contratos_prazos.browse(cr, uid, contrato_prazo_ids)
                contrato_ids = map(lambda i: i.cttprz_contrato_id.id, brw_contrato_prazo)
                args = [('id', 'in', contrato_ids), ('tipo', '=', 'R'),
                        ('pessoa_id', '=', pessoa_id),
                        ('cttctr_tipo_id', 'in', contrato_tipo_ids)]
                contrato_ids = obj_contratos_contrato.search(cr, uid, args, context=context)
                if not contrato_ids:
                    msg += _('Cliente nao possui contrato ativo\n')
                    field_value['crmcas_faturar'] = True
                elif contrato_ids:
                    #  Verificar se contrato do cliente esta Ativo ou se o mesmo esta cancelado
                    # porem a data limite para atendimento aida nao expirou.
                    hoje = time.strftime('%Y-%m-%d')
                    brw_contratos_contrato = filter(
                        lambda con: con.state in ('A', 'C'), obj_contratos_contrato.browse(
                            cr, uid, contrato_ids))
                    contrato_ativo = filter(lambda con: con.state == 'A', brw_contratos_contrato)
                    for contrato in brw_contratos_contrato:
                        if contrato.state == 'C' and contrato.cttctr_data_limite_atendimento < hoje \
                                and not contrato_ativo:
                            msg += _('Cliente com contrato cancelado\n')
                            field_value['crmcas_faturar'] = True
                        elif contrato.state not in ('A', 'C'):
                            msg += _('Cliente nao possui contrato ativo\n')
                            field_value['crmcas_faturar'] = True
            else:
                msg += _('Cliente sem contrato\n')
                field_value['crmcas_faturar'] = True

            # Buscar mensagens do cliente que nao bloqueiam
            cliente_ids = obj_financeiro.finutl_get_cliente_ids(cr, uid, pessoa_id, context)
            cliente_mensagem_ids = obj_financeiro_clientes_mensagem.search(
                cr, uid, [('cliente_id', 'in', cliente_ids)], context=context)
            for mensagem in obj_financeiro_clientes_mensagem.browse(cr, uid, cliente_mensagem_ids,
                                                                    context):
                if mensagem.mensagens_id.tipo_mensagem == 'B':
                    continue
                msg += mensagem.mensagens_id.name + '\n'

            if msg:
                warning = {'title': _('Atencao'),
                           'message': msg}
                res.update({'warning': warning})
                hist_line = [(0, 0, {'description': msg})]
                field_value.update({'history_line': hist_line})
            elif not ids:
                field_value.update({'history_line': []})
        field_value['crmcas_contato_id'] = ''
        res['value'] = field_value
        return res

    def _crmcas_get_item_contrato(self, cr, uid, pessoa_id, context=None):
        context = context and context.copy() or {}
        item_ids = []
        obj_contratos_contrato = self.pool.get('contratos.contrato')
        contrato_ids = obj_contratos_contrato.search(
            cr, uid, [('pessoa_id', '=', pessoa_id), ('state', '=', 'A'),
                      ('cttctr_vencimento', '>=', time.strftime('%Y-%m-%d')), ('tipo', '=', 'R')], context=context)
        for contrato_id in contrato_ids:
            brw_contratos_contrato = obj_contratos_contrato.browse(cr, uid, contrato_id,
                                                                   context).cttctr_prazos_ids
            brw_contrato_item_valor_ids = []
            for prazo in brw_contratos_contrato:
                if prazo.cttprz_contrato_id.cttctr_vencimento == prazo.cttprz_data_termino:
                    brw_contrato_item_valor_ids = prazo.cttprz_item_valor_ids

            for i in brw_contrato_item_valor_ids:
                if i.cttivl_item_id.cttite_produto_id:
                    item_ids.append((0, 0,
                                     {'cttite_produto_id': i.cttivl_item_id.cttite_produto_id.id,
                                       'cttite_observacao': i.cttivl_item_id.cttite_observacao}))
                else:
                    return {'value':{},'warning':{'title':'Atencao','message':'Servico/Produto nao informado em prazos do contrato.'
                                                                             'Verifique se o item do contrato '
                                                                             'deste cliente esta cadastrado corretamente.'}}
        return item_ids
