# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################


# Funcoes da classe crm_br_case


def crmcas_get_item_contrato(self, cr, uid, ids, field_name, args, context=None):

    """
    Funcao de campo function. Busca os itens dos contratos (contratos.contrato.item) validos para
    uma determinada pessoa, a partir da inclusao de um novo helpdesk (crm_br.case).
    @return: Dicionario, sendo a chave o id do helpdesk e o valor da chave uma lista com os ids dos
    itens.
    """

    context = context and context.copy() or {}
    res = {}
    if isinstance(ids, (int, long)):
        ids = [ids]
    brw_crm_br_case = self.browse(cr, uid, ids, context)
    obj_contratos_contrato = self.pool.get('contratos.contrato')
    for case in brw_crm_br_case:
        item_ids = []
        pessoa_id = case.pessoa_id.id
        data_atendimento = case.date
        contrato_ids = obj_contratos_contrato.search(
            cr, uid, [('pessoa_id', '=', pessoa_id), ('state', '=', 'A'),
                      ('cttctr_vencimento', '>=', data_atendimento), ('tipo', '=', 'R')], context=context)
        for contrato_id in contrato_ids:
            brw_contratos_contrato = obj_contratos_contrato.browse(cr, uid, contrato_id,
                                                                   context).cttctr_prazos_ids
            brw_contrato_item_valor_ids = []
            for prazo in brw_contratos_contrato:
                if prazo.cttprz_contrato_id.cttctr_vencimento == prazo.cttprz_data_termino:
                    brw_contrato_item_valor_ids = prazo.cttprz_item_valor_ids
            for i in brw_contrato_item_valor_ids:
                if i.cttivl_item_id:
                    item_ids.append(i.cttivl_item_id.id)
        res[case.id] = item_ids
    return res
