# -*- encoding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        def center_title(e, c, d, t=160):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        title = center_title('', _('Restricoes dos clientes'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Restricoes dos clientes'))
        listagem.informaTamLinha(160)

        dado = datas.get('dado')
        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'financeiro.cliente', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id,
                                                                               ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab('')
        listagem.informaCab('*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(_('|CLIENTE                                                                  |RESTRICAO                                                                 |'))
        listagem.informaCab('*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab('')
        listagem.rodapePadrao()
        for item in dado:
            linha = formataString(item.get('cliente') or '', 73, ' ', 'D', 'N', 'S') + '|'
            linha += ''
            restricao = item.get('restricao').replace('\n', '/') or ''
            restricao = restricao[:-1]
            linha += formataString(restricao[:74], 74, ' ', 'D', 'N', 'S') + '|'
            linha += ' '
            listagem.imprimeLinha('|' + linha)
            if len(restricao) > 74:
                linha = formataString('', 73, ' ', 'D', 'N', 'S') + '|'
                linha += formataString(restricao[74:], 74, ' ', 'D', 'N', 'S') + '|'
                listagem.imprimeLinha('|' + linha)
        listagem.imprimeLinha('*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.imprimeLinha(_('                                                                                                ** Sig Informatica LTDA **                          '))
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_cliente_pendencia')
