# -*- encoding: utf-8 -*-

from openerp.osv import orm, osv, fields
import time
from openerp.tools.translate import _


class wiz_cliente_pendencia(orm.TransientModel):

    # prefixo: wizclp_

    _name = 'wiz.cliente.pendencia'

    _columns = {
        'wizclp_cliente_id': fields.many2one('financeiro.cliente', 'Cliente'),
        'wizclp_cliente_pendencia_item_ids': fields.one2many('wiz.cliente.pendencia.item',
                                                             'wizcpi_cliente_pendencia_id',
                                                             'Itens'),
        'wizclp_mensagem_ids': fields.one2many('wiz.cliente.pendencia.mensagem',
                                               'wizcpm_cliente_pendencia_id',
                                               'Mensagens de cliente'),
    }

    def default_get(self, cr, uid, fields_list, context=None):
        context = context and context.copy() or {}
        res = super(wiz_cliente_pendencia, self).default_get(cr, uid, fields_list, context=context)
        msg = ['Cliente possui restricoes financeiras', 'Cliente nao possui contrato ativo',
               'Cliente com contrato cancelado', 'Cliente sem contrato']
        obj_financeiro_clientes_mensagem_nome = self.pool.get('financeiro.clientes.mensagem.nome')
        obj_wiz_cliente_pendencia_mensagem = self.pool.get('wiz.cliente.pendencia.mensagem')
        mensagem_nome_ids = obj_financeiro_clientes_mensagem_nome.search(
            cr, uid, [('tipo_mensagem', '=', 'B')], context=context)
        mensagem_nome_dado = obj_financeiro_clientes_mensagem_nome.read(
            cr, uid, mensagem_nome_ids, ['name'], context=context)
        for x in mensagem_nome_dado:
            msg.append(x.get('name'))
        cr.execute("""DELETE FROM wiz_cliente_pendencia_mensagem""")
        for x in msg:
            vals = {'name': x}
            obj_wiz_cliente_pendencia_mensagem.create(cr, uid, vals, context=context)
        cr.commit()
        return res

    def wizclp_button_pesquisar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_adm_pessoa = self.pool.get('adm.pessoa')
        obj_financeiro_cliente = self.pool.get('financeiro.cliente')
        obj_adm_empresa_objeto = self.pool.get('adm.empresa.objeto')
        obj_wiz_cliente_pendencia_item = self.pool.get('wiz.cliente.pendencia.item')
        obj_wiz_cliente_pendencia_mensagem = self.pool.get('wiz.cliente.pendencia.mensagem')

        item_ids = obj_wiz_cliente_pendencia_item.search(cr, uid, [], context=context)
        if item_ids:
            obj_wiz_cliente_pendencia_item.unlink(cr, uid, item_ids)
        wiz_cliente_pendencia_dado = self.read(cr, uid, ids, context=context)
        for x in wiz_cliente_pendencia_dado:
            mensagem_ids = x.get('wizclp_mensagem_ids')
            mensagem_dado = obj_wiz_cliente_pendencia_mensagem.read(cr, uid, mensagem_ids, ['name'], context=context)
            msgs = map(lambda i: i.get('name').replace('\n', ''), mensagem_dado)
            cliente_id = x.get('wizclp_cliente_id')
            if cliente_id:
                if isinstance(cliente_id, (list, tuple)):
                    cliente_id = cliente_id[0]
                cliente_ids = [cliente_id]
            else:
                company_id = obj_adm_empresa_objeto.getEmpresa(cr, uid, 'financeiro.cliente', context=context)
                cliente_ids = obj_financeiro_cliente.search(cr, uid, [('company_id', '=',
                                                                       company_id)], context=context)
            financeiro_cliente_dado = obj_financeiro_cliente.read(cr, uid, cliente_ids,
                                                                  ['pessoa_id'], context=context)
            list_dado_cliente = []
            for cliente in financeiro_cliente_dado:
                pessoa_id = cliente.get('pessoa_id')
                if isinstance(pessoa_id, (list, tuple)):
                    pessoa_id = pessoa_id[0]
                adm_pessoa_dado = obj_adm_pessoa.read(cr, uid, pessoa_id, ['nome',
                                                                           'fantasia_apelido'], context=context)
                if isinstance(adm_pessoa_dado, list):
                    adm_pessoa_dado = adm_pessoa_dado[0]
                nome = adm_pessoa_dado.get('nome') or ''
                apelido = adm_pessoa_dado.get('fantasia_apelido') or ''
                descricao_cliente = ''
                if nome and apelido:
                    descricao_cliente = nome + ' - ' + apelido
                elif nome and not apelido:
                    descricao_cliente = nome
                elif apelido and not nome:
                    descricao_cliente = apelido
                msg = self._wizclp_get_restricao(cr, uid, pessoa_id, msgs, context)
                if not msg:
                    continue
                if context.get('cliente_pendencia_report'):
                    # Monta lista de dicionarios com os dados
                    list_dado_cliente.append({'cliente': descricao_cliente, 'restricao': msg})
                else:
                    # Cria registros em pendencia_item
                    vals = {
                        'wizcpi_cliente_pendencia_id': x.get('id'),
                        'wizcpi_nome_cliente': descricao_cliente,
                        'wizcpi_restricao': msg
                    }
                    obj_wiz_cliente_pendencia_item.create(cr, uid, vals, context)
        return list_dado_cliente

    def _wizclp_get_restricao(self, cr, uid, pessoa_id, list_mensagem, context=None):
        context = context and context.copy() or {}
        obj_financeiro = self.pool.get('financeiro')
        obj_vendas_utils = self.pool.get('vendas.utils')
        obj_financeiro_clientes_mensagem_nome = self.pool.get('financeiro.clientes.mensagem.nome')
        obj_contratos_contrato = self.pool.get('contratos.contrato')
        obj_contratos_prazos = self.pool.get('contratos.prazos')
        obj_contratos_tipo = self.pool.get('contratos.tipo')

        pessoa_com_restricao = obj_financeiro.finutl_verificar_restricao_cliente(cr, uid, pessoa_id,
                                                                                 context)
        msg = ''
        if pessoa_com_restricao:
            string = _('Cliente possui restricoes financeiras')
            if not list_mensagem:
                msg += string + '\n'
            elif string in list_mensagem:
                msg += string + '\n'
            cliente_mensagem_nome_ids = obj_vendas_utils.\
                venutl_cliente_bloqueado_por_msg_ids(cr, uid, pessoa_id, context=context)\
                .get('pessoa_ids').get(pessoa_id)
            if cliente_mensagem_nome_ids:
                brw_financeiro_clientes_mensagem_nome = \
                    obj_financeiro_clientes_mensagem_nome.browse(
                        cr, uid, cliente_mensagem_nome_ids, context)
                for x in brw_financeiro_clientes_mensagem_nome:
                    string = _(x.name)
                    if not list_mensagem:
                        msg += string + '\n'
                    elif string in list_mensagem:
                        msg += string + '\n'
        data_abertura = time.strftime('%Y-%m-%d')
        contrato_prazo_ids = obj_contratos_prazos.search(
            cr, uid, [('cttprz_data_inicio', '<=', data_abertura),
                      ('cttprz_data_termino', '>=', data_abertura),
                      ('cttprz_real_provisao', '=', 'R')], context=context)
        contrato_tipo_ids = obj_contratos_tipo.search(cr, uid, [('ctttip_considerar_no_crm',
                                                                 '=', True)], context=context)
        if contrato_prazo_ids and contrato_tipo_ids:
            brw_contrato_prazo = obj_contratos_prazos.browse(cr, uid, contrato_prazo_ids)
            contrato_ids = map(lambda i: i.cttprz_contrato_id.id, brw_contrato_prazo)
            args = [('id', 'in', contrato_ids), ('tipo', '=', 'R'),
                    ('pessoa_id', '=', pessoa_id),
                    ('cttctr_tipo_id', 'in', contrato_tipo_ids)]
            contrato_ids = obj_contratos_contrato.search(cr, uid, args, context=context)
            if not contrato_ids:
                string = _('Cliente nao possui contrato ativo')
                if not list_mensagem:
                    msg += string + '\n'
                elif string in list_mensagem:
                    msg += string + '\n'
            elif contrato_ids:
                #  Verificar se contrato do cliente esta Ativo ou se o mesmo esta cancelado
                # porem a data limite para atendimento aida nao expirou.
                hoje = time.strftime('%Y-%m-%d')
                brw_contratos_contrato = obj_contratos_contrato.browse(cr, uid,
                                                                       contrato_ids)
                for contrato in brw_contratos_contrato:
                    if contrato.state == 'C' and contrato.\
                            cttctr_data_limite_atendimento < hoje:
                        string = _('Cliente com contrato cancelado')
                        if not list_mensagem:
                            msg += string + '\n'
                        elif string in list_mensagem:
                            msg += string + '\n'
                    elif contrato.state not in ('A', 'C'):
                        string = _('Cliente nao possui contrato ativo')
                        if not list_mensagem:
                            msg += string + '\n'
                        elif string in list_mensagem:
                            msg += string + '\n'
        else:
            string = _('Cliente sem contrato')
            if not list_mensagem:
                msg += string + '\n'
            elif string in list_mensagem:
                msg += string + '\n'
        return msg

    def wizclp_button_print(self, cr, uid, ids, context=None):

        """
        Metodo responsavel por chamar a classe do relatorio que ira imprimir um arquivo pdf com
        as informacoes dos clientes pesquisados
        @return: Dicionario com acao para a classe do relatorio, os dados referentes e o nome.
        """

        context = context and context.copy() or {}
        #context['cliente_pendencia_report'] = True
        #dado = self.wizclp_button_pesquisar(cr, uid, ids, context)
        brw_wizard_pendencia_cliente = self.browse(cr, uid, ids, context)
        list_dado = []
        for x in brw_wizard_pendencia_cliente:
            item_ids = x.wizclp_cliente_pendencia_item_ids
            list_dado = map(lambda i: {'cliente': i.wizcpi_nome_cliente,
                                       'restricao': i.wizcpi_restricao}, item_ids)
        if not list_dado:
            raise osv.except_osv(_('Atencao'), _('Faca a pesquisa dos clientes'))
        datas = {
            'dado': list_dado,
        }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'listagem_cliente_pendencia',
            'datas': datas,
        }


class wiz_cliente_pendencia_item(orm.TransientModel):

    # prefixo: wizcpi_

    _name = 'wiz.cliente.pendencia.item'

    _columns = {
        'wizcpi_cliente_pendencia_id': fields.many2one('wiz.cliente.pendencia', 'Pendencia'),
        'wizcpi_nome_cliente': fields.char('Cliente', size=100),
        'wizcpi_restricao': fields.text('Restricao'),
    }


class wiz_cliente_pendencia_mensagem(orm.TransientModel):

    # prefixo: wizcpm_

    _name = 'wiz.cliente.pendencia.mensagem'

    _columns = {
        'wizcpm_cliente_pendencia_id': fields.many2one('wiz.cliente.pendencia', 'Pendencia'),
        'name': fields.text('Mensagem'),
    }
