# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from dateutil.relativedelta import relativedelta
from datetime import date, datetime
from SigUtils.datas import months_between
from SigUtils.monthdelta import monthdelta
from openerp.tools.translate import _

CLASSIC_WRITE = '_classic_write'


class contratos_contrato(osv.Model):
    _name = 'contratos.contrato'
    _inherit = 'contratos.contrato'

    def default_get(self, cr, uid, fields, context=None):
        context = context and context.copy() or {}
        res = super(contratos_contrato, self).default_get(cr, uid, fields, context)
        if context.get('tipo'):
            res['tipo'] = context.get('tipo')
        obj_adm_utils = self.pool.get('adm.utils')
        financeiro_parametro = obj_adm_utils.admutl_get_parametros(
            cr, uid, 'financeiro', ['numero_automatico_contrato', 'usar_centro_custos_e_eventos'],
            context=context)
        gera_numero_automatico = financeiro_parametro.get('numero_automatico_contrato')
        res.update({'cttctr_gerar_numero_automatico': gera_numero_automatico,
                    'cttctr_gera_centro_custo_evento': financeiro_parametro.get(
                        'usar_centro_custos_e_eventos')})
        return res

    def sequence_criar(self, cr, uid, context=None):
        context = context and context.copy() or {}
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
        __code = 'contratos.contrato.numero'
        __name = 'Sequencia do numero do contrato'
        vals = {
            'name': __name,
            'code': __code,
            'padding': 6,
            'company_id': company_id,
            'prefix': 'CTR-%(year)s-',
            'implementation': 'no_gap',
        }
        consulta = self.pool.get('ir.sequence').search(cr, uid, [('code', '=', __code), ('company_id', '=', company_id)], context=context)
        if not consulta:
            self.pool.get('ir.sequence').create(cr, uid, vals, context)
        return True

    def button_ativar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}

        def _cttctr_button_ativar_software(cr, uid, ids):
            vals = self.read(cr, uid, ids[0], ['pessoa_id',
                                               'orcamento_id',
                                               'company_id',
                                               'software_contrato_ids',
                                               'gerencial_produtos_ids',
                                               'gerencial_sms_ids',
                                               'data_inicio',
                                               'data_termino'], context=context)
            if vals['orcamento_id']:
                # TOTAL GERENCIAL SMS/PRODUTOS ****************************************
                total_soft_produtos, total_soft_sms = 0.0, 0.0
                obj_software_gerencial_produtos = self.pool.get('software.gerencial.produtos')
                obj_software_gerencial_sms = self.pool.get('software.gerencial.sms')
                for x in obj_software_gerencial_produtos.read(cr, uid, vals['gerencial_produtos_ids'], ['valor'],
                                                              context=context):
                    total_soft_produtos += x['valor']
                for x in obj_software_gerencial_sms.read(cr, uid, vals['gerencial_sms_ids'], ['valor'],
                                                         context=context):
                    total_soft_sms += x['valor']
                    # VERIFICAR SE HA NF's P/ O CONTRATO **********************************
                obj_fiscal_nf_capa = self.pool.get('fiscal.nf.capa')
                nf_ids = obj_fiscal_nf_capa.search(cr, uid, [('state', '!=', '1'), ('contrato_id', '=', vals['id'])],
                                                   context=context)
                if nf_ids:
                    if len(nf_ids) > 1:
                        msg_str = _("Existem %d Notas que impedem a ativacao do contrato") % len(nf_ids)
                    else:
                        msg_str = _("Existe %d Nota que impede a ativacao do contrato") % len(nf_ids)
                    raise osv.except_osv('SigERP', msg_str)
                    # TOTAL DO ORCAMENTO/SMS's ********************************************
                obj_orcamentos_orcamento_capa = self.pool.get('orcamentos.orcamento.capa')
                obj_orcamentos_orcamento_itens = self.pool.get('orcamentos.orcamento.itens')
                vals_orcamento = obj_orcamentos_orcamento_capa.read(cr, uid, vals['orcamento_id'][0],
                                                                    ['orcamento_itens_ids', 'valor_liquido'],
                                                                    context=context)
                orcamento_itens = obj_orcamentos_orcamento_itens.read(cr, uid, vals_orcamento['orcamento_itens_ids'],
                                                                      [], context=context)
                total_orcamento, total_orc_sms = vals_orcamento['valor_liquido'], 0.0
                for x in orcamento_itens:
                    total_orc_sms += x['sms'] - x['desconto_sms']
                    # if total_orcamento != total_soft_produtos:
                #    raise osv.except_osv('SigERP', 'A soma dos Produtos [%.2f] e diferente do Total do Orcamento [%.2f].'%(total_soft_produtos,total_orcamento))
                if total_orc_sms != total_soft_sms:
                    raise osv.except_osv(_('Atencao'),
                                         _("A soma dos SMS [%.2f] e diferente do Total dos SMS's Orcamento [%.2f].") % (
                                             total_soft_sms, total_orc_sms))
                    # BUSCAR PARAMETROS (embalagem, servico, grade, etc...) ***************
                obj_software_parametros = self.pool.get('software.parametros')
                par_id = obj_software_parametros.search(cr, uid, [], context=context)
                if not par_id:
                    raise osv.except_osv(_('Atencao'), _('Cadastre parametros para a empresa'))
                else:
                    vals_par = obj_software_parametros.read(cr, uid, par_id[0], [], context=context)
                    # ENDEREÇO DA NF ******************************************************
                obj_adm_pessoa = self.pool.get('adm.pessoa')
                endereco_nf_id = \
                    obj_adm_pessoa.read(cr, uid, vals['pessoa_id'][0], ['endereco_nf_id'], context=context)[0][
                        'endereco_nf_id']
                if not endereco_nf_id:
                    raise osv.except_osv(_('Atencao'), _('Cadastre o Endereco na NF para a Pessoa'))
                    # VERIFICAR SE USUÁRIO É FUNCIONARIO **********************************
                pessoa_id = self.pool.get('res.users').read(cr, uid, uid, ['pessoa_id'], context=context)['pessoa_id']
                if not pessoa_id:
                    raise osv.except_osv(_('Atencao'), _('Pessoa nao cadastrada para o usuario!'))
                obj_rh_funcionario = self.pool.get('rh.funcionario')
                func_id = obj_rh_funcionario.search(cr, uid, [('pessoa', '=', pessoa_id[0])], context=context)
                if not func_id:
                    raise osv.except_osv(_('Atencao'), _('Voce tem que se cadastrar como um Funcionario...'))
                else:
                    func_id = func_id[0]
                    # CRIA NF CAPA ********************************************************
                args_nf_capa = {'company_id': vals['company_id'][0],
                                'tipo': 'S',
                                'destinatario_id': vals['pessoa_id'][0],
                                'destinatario_endereco_id': endereco_nf_id[0],
                                'contrato_id': vals['id'],
                                'natureza_id': 1}
                nf_capa_id = obj_fiscal_nf_capa.create(cr, uid, args_nf_capa, context)
                # CRIA ESTOQUE MOVIMENTO CAPA *****************************************
                obj_estoque_movimento_capa = self.pool.get('estoque.movimento.capa')
                args_mov_capa = {'company_id': vals['company_id'][0],
                                 'data': date.today(),
                                 'operacao': 'S',
                                 'origem': 'N',
                                 'funcionario_id': func_id,
                                 'nf_capa_id': nf_capa_id}
                mov_capa_id = obj_estoque_movimento_capa.create(cr, uid, args_mov_capa, context)
                # CRIA ESTOQUE MOVIMENTO ITENS ****************************************
                obj_estoque_movimento_itens = self.pool.get('estoque.movimento.itens')
                for itens in orcamento_itens:
                    grade_id = False
                    if itens['grade_id']:
                        grade_id = itens['grade_id'][0]
                    local_id = False
                    if itens['local_id']:
                        local_id = itens['local_id'][0]
                    produto_embalagem_id = False
                    if itens['produto_embalagem_id']:
                        produto_embalagem_id = itens['produto_embalagem_id'][0]
                    args_mov_itens = {'capa_id': mov_capa_id,
                                      'nf_id': nf_capa_id,
                                      'produto_id': itens['produto_id'][0],
                                      'grade_id': grade_id,
                                      'local_id': local_id,
                                      'produto_embalagem_id': produto_embalagem_id,
                                      'quantidade': itens['quantidade'],
                                      'vr_unitario': itens['valor_unitario_bruto'],
                                      'vr_desconto': itens['desconto_total']}
                    print args_mov_itens
                    obj_estoque_movimento_itens.create(cr, uid, args_mov_itens, context)
                    # GERAR NOTA'S PRO'S SMS'S ********************************************
                y1, m1, d1 = (int(x) for x in vals['data_inicio'].split('-'))
                data_inicio = date(y1, m1, d1)
                y1, m1, d1 = (int(x) for x in vals['data_termino'].split('-'))
                data_termino = date(y1, m1, d1)

                qtd_meses = months_between(data_termino, data_inicio) - 2
                for d in range(0, qtd_meses):
                    # NF CAPA
                    data_emissao = {'data_emissao': str(data_inicio + monthdelta(d + 1))}
                    args_nf_capa.update(data_emissao)
                    nf_capa_id = obj_fiscal_nf_capa.create(cr, uid, args_nf_capa, context)
                    # MOVIMENTO CAPA
                    capa_id = {'nf_capa_id': nf_capa_id}
                    args_mov_capa.update(capa_id)
                    mov_capa_id = obj_estoque_movimento_capa.create(cr, uid, args_mov_capa, context)
                    # MOVIMENTO ITENS
                    args_mov_itens = {'capa_id': mov_capa_id,
                                      'nf_id': nf_capa_id,
                                      'produto_id': vals_par['produto_id'][0],
                                      'local_id': vals_par['local_id'][0],
                                      'produto_embalagem_id': vals_par['produto_embalagem_id'][0],
                                      'quantidade': 1,
                                      'vr_unitario': total_soft_sms,
                                      'vr_desconto': 0}
                    obj_estoque_movimento_itens.create(cr, uid, args_mov_itens, context)
            return True

        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'software', context):
            _cttctr_button_ativar_software(cr, uid, ids)
        vals = self.read(cr, uid, ids[0], ['numero', 'company_id', 'cttctr_item_ids',
                                           'cttctr_prazos_ids'], context=context)
        args = {'state': 'A'}
        if not vals['numero']:
            sequence = {
                'numero': self.pool.get('adm.utils').get_sequence(cr, uid, self._name,
                                                                  'contratos.contrato.numero')}
            args.update(sequence)
        if vals['cttctr_item_ids'] and vals['cttctr_prazos_ids']:
            res = self.write(cr, uid, ids, args, context=context.update({'read_only': 'N'}))
        else:
            raise osv.except_osv(_('Atencao'), _('Informe itens/prazos para ativar o contrato'))
        self.message_post(cr, uid, ids, _('Alteracao de Status'), _('Ativo'))
        return res

    def button_rascunho(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = self.write(cr, uid, ids, {'state': 'R'}, context=context.update({'read_only': 'N'}))
        self.message_post(cr, uid, ids, _('Alteracao de Status'), _('Esboco'))
        return res

    def button_finalizar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': 'F'}, context=context.update({'read_only': 'N'}))
        self.message_post(cr, uid, ids, _('Alteracao de Status'), _('Finalizado'))
        return True

    def button_suspender(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': 'S'}, context=context.update({'read_only': 'N'}))
        self.message_post(cr, uid, ids, _('Alteracao de Status'), _('Suspenso'))
        return True

    def button_cancelar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_model_data = self.pool.get('ir.model.data')
        reference = obj_model_data.get_object_reference(cr, uid, 'contratos',
                                                        'wizard_cancelar_contrato_view')
        view_id = reference and reference[1] or False
        return {'name': 'Cancelar contrato',
                'view_type': 'form',
                'view_mode': 'form',
                'res_model': 'wiz.cancelar.contrato',
                'view_id': [view_id],
                'target': 'new',
                'type': 'ir.actions.act_window',
                }

    def cttctr_button_reativar(self, cr, uid, ids, context=None):
        """
        Metodo responsavel por reativar os contratos. Altera o status dos registros (ids) para
        'Ativo' (A), como tambem, recria os titulos que foram excluidos no processo de cancelamento.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: registro da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: registros da tabela desse objeto.
        :type ids: list
        :param context: dados com valores contextuais.
        :type context: dict
        :return: Verdadeiro
        :rtype: bool
        """
        context = context and context.copy() or {}
        self.button_ativar(cr, uid, ids, context)
        obj_contratos_prazos = self.pool.get('contratos.prazos')
        context['cttctr_reativa_contrato'] = True
        for contrato in self.browse(cr, uid, ids, context):
            # Contrato do tipo mercadoria (M) nao gera titulos.
            if contrato.cttctr_tipo_contrato == 'M':
                continue
            prazos_ids = map(lambda i: i.id, contrato.cttctr_prazos_ids)
            obj_contratos_prazos.cttprz_button_gerar_titulos(cr, uid, prazos_ids, context)
        self.write(cr, uid, ids, {'cttctr_data_limite_atendimento': False}, context)
        return True

    def cttctr_button_incluir_item_contrato(self, cr, uid, ids, context=None):
        """
        O metodo retorna a chamada de um outro metodo. Esse ultimo abrira uma nova janela para
        inclusao de novos itens ao contrato
        @param cr: cursor do banco de dados
        @param uid: id do usuario responsavel pela transacao
        @param ids: lista de id do modelo atual
        @param context: dicionario com valores contextuais
        @return: Acao para um formulario em nova janela para inclusao de itens
        """
        context = context and context.copy() or {}
        return self.pool.get('contratos.contrato.item').cttite_button_tratar_item_contrato(
            cr, uid, [], context)

    def cttctr_get_pessoa_uf(self, cr, uid, pessoa_id, context=None):
        context = context and context.copy() or {}
        browse_pessoa = self.pool.get('adm.pessoa').browse(cr, uid, pessoa_id, context)
        record_pessoa_endereco_nf = browse_pessoa.endereco_nf_id
        if not record_pessoa_endereco_nf:
            brw_endereco = browse_pessoa.endereco_ids[0] if browse_pessoa.endereco_ids else []
            pessoa_uf_sigla = browse_pessoa.endereco_ids[0].uf_id.sigla if brw_endereco else ''
        else:
            pessoa_uf_sigla = record_pessoa_endereco_nf.uf_id and record_pessoa_endereco_nf.uf_id.sigla or ''
        return pessoa_uf_sigla.upper()

    def cttctr_get_data_vencimento(self, dia_vencimento, sabado=False, domingo=False):

        HOJE = date.today()
        if not HOJE.day < dia_vencimento:
            data_vencimento_parcela = HOJE + relativedelta(day=dia_vencimento, months=1)
        else:
            data_vencimento_parcela = HOJE + relativedelta(day=dia_vencimento)

        # VENCIMENTO NAO PODE OCORRER NO SABADO
        if not sabado and data_vencimento_parcela.isoweekday() == 6:
            data_vencimento_parcela += relativedelta(days=2)
        # VENCIMENTO NAO PODE OCORRER NO DOMINGO
        elif not domingo and data_vencimento_parcela.isoweekday() == 7:
            data_vencimento_parcela += relativedelta(days=1)

        return data_vencimento_parcela

    def cttctr_button_gerar_nf(self, cr, uid, ids, context=None):
        """
        Gera uma nota fiscal a partir de um contrato.

        :param cr: o cursor do banco de dados,
        :param uid: ID do usuario utilizado para a verificacao de perfil,
        :param ids: lista com o ID do formulario de contrato
        :param context: um dicionario padrao para valores contextuais
        :type cr: object
        :type uid: int
        :type ids: list
        :type context: dict
        :return: verdadeiro se a nota fiscal foi gerada
        :rtype: bool
        """

        context = context and context.copy() or {}
        context.update({'fatura_contrato': True})
        context_contrato_nf = context.copy()
        context_contrato_nf['ctx_nf_propria'] = True
        context_contrato_nf['ctx_nf_servico'] = True
        context_contrato_nf.update({
            'nota_fiscal_saida': True,
            'proprio': True
        })
        context_contrato_nf_itens = context.copy()
        context_contrato_nf_itens['proprio'] = True
        context_contrato_nf_itens['nota_fiscal_saida'] = True
        obj_contratos_prazos = self.pool.get('contratos.prazos')
        fields_to_read = ['pessoa_id', 'company_id', 'dia', 'sabado', 'domingo', 'tipo',
                          'cttctr_tipo_contrato', 'cttctr_forma_pagamento_id', 'cttctr_servico_id']
        contrato_id = ids[0]
        brw_contrato = self.browse(cr, uid, contrato_id, context=context)
        ctt_id = brw_contrato.id

        if brw_contrato.cttctr_tipo_contrato == 'S':
            context_contrato_nf.update({
                'nf_servico': True,
                'ctx_nf_servico': True
            })
            context_contrato_nf_itens.update({'nf_servico': True, 'ctx_nf_servico': True})

        if not brw_contrato.cttctr_prazos_ids:
            raise osv.except_osv(_('Atencao!'),
                                 _('Nenhum servico cadastrado para a geracao da nota fiscal.'))

        vals_contrato_prazos = []
        valor_total_prazos = 0
        servico_capa_id = brw_contrato.cttctr_servico_id.id
        for brw_prazo in brw_contrato.cttctr_prazos_ids:
            for item in brw_prazo.cttprz_item_valor_ids:
                servico_dict = {
                    'servico_id': item.cttivl_item_id.cttite_produto_id.id,
                    'valor': item.cttivl_valor
                }
                valor_total_prazos += item.cttivl_valor
                vals_contrato_prazos.append(servico_dict)

        if servico_capa_id:
            vals_contrato_prazos[:] = []
            vals_contrato_prazos.append({
                'servico_id': servico_capa_id,
                'valor': valor_total_prazos
            })

        # Verifica se ja existe uma nota fiscal para o titulo
        obj_financeiro_titulo = self.pool.get('financeiro.titulo')
        doc_id = self.pool.get('documento.documento.tipo'). \
            search(cr, uid, [('sigla', '=', 'PRV')])
        titulo_ids = obj_financeiro_titulo.search(
            cr, uid, [('contrato_id', '=', contrato_id), ('doc_tipo_id', 'in', doc_id)],
            order='data_prorrogacao asc', context=context)

        if titulo_ids:
            data_vencimento_titulo = obj_financeiro_titulo.browse(
                cr, uid, titulo_ids[0]).data_prorrogacao
            sql_busca = """
            -- noinspection SqlDialectInspection
            SELECT capa.id AS nf_id
            FROM   fiscal_nf_capa capa
            INNER  JOIN fiscal_nf_parcelas parcelas ON parcelas.nf_id = capa.id
            WHERE  parcelas.vencimento = '%(data_vencimento_titulo)s'
              AND  capa.fisnfc_contrato_id = %(contrato_id)s
              AND  capa.state != 'C'
            """ % locals()
            cr.execute(sql_busca)
            dados_busca = cr.fetchall()

            if dados_busca:
                raise osv.except_osv(_('Atencao'),
                                     _('Para o titulo em previsao ja existe uma nota fiscal gerada.'))
        else:
            data_vencimento_titulo = False

        ctt_tipo = brw_contrato.tipo
        ctt_sabado = brw_contrato.sabado
        ctt_domingo = brw_contrato.domingo
        ctt_pessoa_id = brw_contrato.pessoa_id.id
        brw_ctt_company_id = brw_contrato.company_id
        ctt_dia_venc_parcelas = brw_contrato.dia or 0
        data_vencimento_parcela = self.cttctr_get_data_vencimento(
            ctt_dia_venc_parcelas, ctt_sabado, ctt_domingo)
        label_pessoa = 'Cliente' if ctt_tipo == 'R' else 'Fornecedor'

        company_pessoa_id = brw_ctt_company_id.rescon_pessoa_id.id

        # Empresa e Pessoa do contrato
        nao_encontrado = []
        company_uf = self.cttctr_get_pessoa_uf(cr, uid, company_pessoa_id)

        if not company_uf:
            nao_encontrado.append('Empresa')

        pessoa_uf = self.cttctr_get_pessoa_uf(cr, uid, ctt_pessoa_id)

        if not pessoa_uf:
            nao_encontrado.append('%s do contrato' % label_pessoa)

        if nao_encontrado:
            raise osv.except_osv(_('Atencao!'),
                                 _('Endereco para nota fiscal nao informado no cadastro de Pessoa '
                                   'para %s.' % ' e '.join(nao_encontrado)))

        # Natureza da operacao para nota fiscal de saida
        label_natureza_tipo = 'fora'
        if company_uf == pessoa_uf:
            label_natureza_tipo = 'dentro'
        campos = ['fispar_natureza_uf_dentro_venda_id', 'fispar_natureza_uf_fora_venda_id',
                  'fispar_natureza_uf_dentro_venda_servico_id', 'fispar_natureza_uf_fora_venda_servico_id']
        obj_fiscal_parametro = self.pool.get('fiscal.parametro')
        fis_parametro_ids = obj_fiscal_parametro.search(
            cr, uid, [('company_id', '=', brw_ctt_company_id.id)], context=context)

        if not fis_parametro_ids:
            raise osv.except_osv(_('Atencao!'),
                                 _('Nenhum parametro do fiscal cadastrado para a empresa'))

        fis_parametro_dados = obj_fiscal_parametro.read(
            cr, uid, fis_parametro_ids[0], campos, context=context,
            load=CLASSIC_WRITE)

        if fis_parametro_dados and isinstance(fis_parametro_dados, list):
            fis_parametro_dados = fis_parametro_dados[0]

        if brw_contrato.cttctr_tipo_contrato == 'M': # Produto
            if label_natureza_tipo == 'fora': # fora do estado
                natureza_id = fis_parametro_dados.get('fispar_natureza_uf_fora_venda_id')
            else: #dentro do estado
                natureza_id = fis_parametro_dados.get('fispar_natureza_uf_dentro_venda_id')
        else: #Servico
            if label_natureza_tipo == 'fora': # fora do estado
                natureza_id = fis_parametro_dados.get('fispar_natureza_uf_fora_venda_servico_id')
            else: #dentro do estado
                natureza_id = fis_parametro_dados.get('fispar_natureza_uf_dentro_venda_servico_id')

        if not natureza_id:
            raise osv.except_osv(
                _('Parametro do Fiscal'),
                _('Natureza para venda %s do Estado nao cadastrada') %
                label_natureza_tipo)

        browse_natureza = self.pool.get('fiscal.cfop.natureza').browse(
            cr, uid, natureza_id, context)
        cfop_tipo = browse_natureza.cfop_id.produto_servico_tipo
        # contrado de servico e cfop da natureza difetente de servico
        if brw_contrato.cttctr_tipo_contrato == 'S' and cfop_tipo != 'S':
            raise osv.except_osv(
                _('Natureza invalida!'),
                _('A natureza de operacao para vendas %s do estado cadastrada no parametro do '
                  'Fiscal, nao possui a transacao do tipo "Servico"') % label_natureza_tipo)
        # contrado de mercadoria/produto e cfop da natureza diferente de mercadoria/produto
        elif brw_contrato.cttctr_tipo_contrato == 'M' and cfop_tipo != 'P':
            raise osv.except_osv(
                _('Natureza invalida!'),
                _('A natureza de operacao para vendas %s do estado cadastrada no parametro do '
                  'Fiscal, nao possui a transacao do tipo "Mercadoria/Produto"') % label_natureza_tipo)


        # Local de saida padrao no parametro do estoque
        local_saida_id = False
        obj_estoque_parametro = self.pool.get('estoque.parametro')
        est_parametro_ids = obj_estoque_parametro.search(
            cr, uid, [('company_id', '=', brw_ctt_company_id.id)], context=context)

        if not est_parametro_ids:
            raise osv.except_osv(_('Atencao!'),
                                 _('Nenhum parametro do estoque cadastrado para a empresa.'))

        est_parametro_dados = obj_estoque_parametro.read(
            cr, uid, est_parametro_ids[0], ['local_venda_padrao_id'], context,
            load=CLASSIC_WRITE)

        if est_parametro_dados and isinstance(est_parametro_dados, list):
            est_parametro_dados = est_parametro_dados[0]

        local_saida_id = est_parametro_dados.get('local_venda_padrao_id')

        if not local_saida_id:
            raise osv.except_osv(_('Parametro do Estoque'),
                                 _('Local de saida padrao nao cadastrado'))

        obj_fiscal_utils = self.pool.get('fiscal.utils')
        erro_fiscal_capa = ''
        vals_condicoes_ids = []
        forma_pagamento_id = False
        condicao_forma_id = False

        if brw_contrato.cttctr_forma_pagamento_id.id:
            forma_pagamento_id = brw_contrato.cttctr_forma_pagamento_id.id
            obj_adm_condicao_forma = self.pool.get('adm.condicao.forma')
            condicao_forma_ids = obj_adm_condicao_forma.search(
                cr, uid, [('forma_pagamento_id', '=', forma_pagamento_id)],
                context=context)
            browse_condicao_forma = obj_adm_condicao_forma.browse(
                cr, uid, condicao_forma_ids)

            for c in browse_condicao_forma:
                if c.adm_condicao_id.qtde_parcelas == 1:
                    condicao_forma_id = c.id

            if condicao_forma_id:
                nf_valor_total = valor_total_prazos
                vals_condicoes_ids.append((0, 0, {
                    'forma_pagto_id': forma_pagamento_id,
                    'condicao_forma_id': condicao_forma_id,
                    'valor': nf_valor_total
                }))
            else:
                raise osv.except_osv(
                    _('Atencao!'),
                    _('E necessario que exista uma condicao de pagamento cadastrada com apenas uma '
                      'parcela para a forma de pagamento selecionada.'))

        nf_id = obj_fiscal_utils.gerar_nf(
            cr, uid, company_id=brw_ctt_company_id.id, destinatario_id=ctt_pessoa_id,
            natureza_id=natureza_id, tipo='S', finan_contrato_id=ctt_id,
            data_saida_entrada=datetime.now().strftime('%Y-%m-%d %H:%M:%S'),
            context=context_contrato_nf
        )

        if not nf_id:
            erro_fiscal_capa += obj_fiscal_utils.fisutl_get_erro()
            raise osv.except_osv(_('Atencao!'), erro_fiscal_capa)

        # Tratamento para condicao/pagamento contrato
        if condicao_forma_id and forma_pagamento_id:
            nf_valor_total = valor_total_prazos
            obj_fiscal_condicao_pagamento = self.pool.get('fiscal.condicao.pagamento')

            # cria condicao
            nf_condicao_id = obj_fiscal_condicao_pagamento.create(
                cr, uid, {
                    'capa_id': nf_id,
                    'forma_pagto_id': forma_pagamento_id,
                    'condicao_forma_id': condicao_forma_id,
                    'valor': nf_valor_total
                })

            vals = {
                'active': True,
                'nf_condicao_id': nf_condicao_id,
                'valor': nf_valor_total,
                'vencimento': data_vencimento_titulo,
                'nf_id': nf_id
            }

            # cria parcelas
            context['criar'] = True
            self.pool.get('fiscal.nf.parcelas').create(cr, uid, vals, context)

        for item in vals_contrato_prazos:
            servico_id = item.get('servico_id')
            preco_venda = item.get('valor')
            obj_fiscal_utils.gerar_nf_itens(
                cr, uid, nf_id, produto_id=servico_id, tipo='S', quantidade=1,
                local_id=local_saida_id, produto_embalagem_id=False,
                vr_unitario=preco_venda, item_preco_venda=preco_venda,
                context=context_contrato_nf_itens)

        self.pool.get('fiscal.nf.capa').write(cr, uid, nf_id, {}, context=context)

        return True

    def cttctr_button_atualizar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = self.write(cr, uid, ids, {}, context)
        return res

    def create(self, cr, user, vals, context=None):
        context = context and context.copy() or {}
        contrato_tipo = vals.get('tipo')
        if contrato_tipo == 'R':
            contrato_dia_vencimento = vals.get('dia') or 0

            erro_contrato = ''
            if not contrato_dia_vencimento:
                erro_contrato += 'Dia de Vencimento invalido, '
            if erro_contrato:
                raise osv.except_osv(_('Erro ao criar o contrato'), erro_contrato)
        if not vals.get('numero'):
            sequence = {
                'numero': self.pool.get('adm.utils').get_sequence(cr, user, self._name, 'contratos.contrato.numero')}
            vals.update(sequence)

        res = super(contratos_contrato, self).create(cr, user, vals, context)
        self.cttctr_atualiza_competencia_gerencial_movimento(
            cr, user, [res], vals.get('cttctr_competencia_por_parcelas'), context)
        return res

    def cttctr_atualiza_competencia_gerencial_movimento(self, cr, uid, ids,
                                                        competencia_por_parcelas, context):
        """
        O metodo reune os dados para que os registros de competencia (mes / ano) da tabela
        gerencial_movimento sejam atualizados. Se competencia_por_parcelas for True, os registros
        serao atualizados baseado na data de vencimento dos titulos, senao, na data de emissao.
        :param cr: cursor no banco de dados
        :param uid: id da tabela res_users, identificador do usuario
        :param ids: lista de id da tabela desse objeto
        :param competencia_por_parcelas: booleano
        :param context: dicionario com valores contextais
        :return: booleano, com True caso algum registro da tabela gerencial_movimento foi
        atualizado e False caso nenhum foi atualizado
        """
        context = context and context.copy() or {}
        if not ids:
            return False
        contratos_contrato_dados = self.read(cr, uid, ids, ['titulos_ids'], context)
        titulo_ids = []
        map(lambda i: titulo_ids.extend(i.get('titulos_ids')), contratos_contrato_dados)
        return self.pool.get('gerencial.movimento').fingmo_atualiza_competencia(
            cr, uid, titulo_ids, competencia_por_parcelas, context)

    def write(self, cr, uid, ids, values, context=None):
        context = context and context.copy() or {}
        fields_read = ['tipo', 'dia', 'state']
        if 'cttctr_controla_nf' in values:
            obj_financeiro_titulo = self.pool.get('financeiro.titulo')
            obj_documento_tipo = self.pool.get('documento.documento.tipo')
            fields_read.append('titulos_ids')
            gerar_nf = False
            if values.get('cttctr_controla_nf'):
                gerar_nf = True
        contrato_dados = self.read(cr, uid, ids, fields_read, context=context)
        for i in contrato_dados:
            if 'cttctr_item_ids' in values:
                if i.get('state') == 'A':
                    for item in values.get('cttctr_item_ids'):
                        if not item[2]:
                            raise osv.except_osv(_('Atencao'), _('Nenhum item informado para o contrato'))
            elif 'cttctr_prazos_ids' in values:
                if i.get('state') == 'A':
                    for prazo in values.get('cttctr_prazos_ids'):
                        if not prazo[2]:
                            raise osv.except_osv(_('Atencao'), _('Nenhum prazo informado para o contrato'))

            if 'tipo' in values:
                vls_tipo = values['tipo']
            else:
                vls_tipo = i.get('tipo')

            if 'dia' in values:
                vls_dia_vencimento = values['dia']
            else:
                vls_dia_vencimento = i.get('dia')

            if vls_tipo == 'R':
                erro_contrato = ''
                if not vls_dia_vencimento:
                    erro_contrato += 'Dia de Vencimento invalido, '
                if erro_contrato:
                    raise osv.except_osv(_('Erro ao criar o contrato'), erro_contrato)
            if i.get('titulos_ids'):
                # if gerar_nf:
                #     arg = [('sigla', '=', 'PRV')]
                # else:
                #     arg = [('sigla', 'in', ('DP', 'DUP'))]
                arg = [('sigla', 'in', ('DP', 'DUP'))]
                doc_tipo_id = obj_documento_tipo.search(cr, uid, arg, context=context)[0]
                titulo_ids = obj_financeiro_titulo.search(
                    cr, uid, [('id', 'in', i.get('titulos_ids')), ('state', '=', 'A')], context=context)
                if titulo_ids:
                    context['cttctr_alterar_tipo_documento_titulo'] = True
                    obj_financeiro_titulo.write(cr, uid, titulo_ids, {'doc_tipo_id': doc_tipo_id},
                                                context)

        res = super(contratos_contrato, self).write(cr, uid, ids, values, context=context)
        if 'cttctr_competencia_por_parcelas' in values:
            self.cttctr_atualiza_competencia_gerencial_movimento(
                cr, uid, ids, values.get('cttctr_competencia_por_parcelas'), context)
        return res

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        context['sig_force_company'] = True
        res = super(contratos_contrato, self).search(cr, uid, args, offset, limit, order, context=context,
                                                     count=count)
        return res
