# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class contratos_contrato_item_valor(osv.Model):

    """
    Tabela de valores dos itens num determinado periodo de tempo
    prefixo: cttivl_
    """

    _name = 'contratos.contrato.item.valor'
    _inherit = 'contratos.contrato.item.valor'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        res = super(contratos_contrato_item_valor, self).create(cr, uid, vals, context)
        # Funcionalidade para recalculo do valor do prazo (contratos.prazos)
        prazo_id = vals.get('cttivl_prazo_id')
        if prazo_id:
            self.pool.get('contratos.prazos').write(cr, uid, [prazo_id], {}, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        res = super(contratos_contrato_item_valor, self).write(cr, uid, ids, vals, context)
        # Funcionalidade para recalculo do valor do prazo (contratos.prazos)
        prazo_id = vals.get('cttivl_prazo_id')
        if not prazo_id:
            prazo_id = self.browse(cr, uid, ids[0]).cttivl_prazo_id.id
        self.pool.get('contratos.prazos').write(cr, uid, [prazo_id], {}, context)
        return res
