# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from SigUtils import datas
from openerp.tools.translate import _
from dateutil.relativedelta import relativedelta
from dateutil.parser import parse
from calendar import isleap
import time

READ_LOAD = '_classic_write'


class contratos_prazos(osv.Model):
    _name = 'contratos.prazos'
    _inherit = 'contratos.prazos'

    def cttprz_button_gerar_titulos(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        titulos_ids = []
        obj_financeiro_titulo = self.pool.get('financeiro.titulo')
        obj_financeiro_utils = self.pool.get('financeiro')
        obj_documento_tipo = self.pool.get('documento.documento.tipo')
        obj_contratos_contrato_item = self.pool.get('contratos.contrato.item')
        dado_custificacao = self._cttprz_get_custo(cr, uid, ids, context)
        dados = self.browse(cr, uid, ids)
        data_hoje = time.strftime('%Y-%m-%d')
        for i in dados:
            contrato_id = i.cttprz_contrato_id.id
            context.update({'contrato_gerar_titulos': 'CTR -' + i.cttprz_contrato_id.numero})
            dia = i.cttprz_contrato_id.dia or 0
            dia_original = i.cttprz_contrato_id.dia or 0
            real_provisao = i.cttprz_real_provisao
            vct = i.cttprz_data_inicio
            dia_vct = int(vct[8:])
            periodo = i.cttprz_contrato_id.periodo or ''
            if dia_vct <= dia and periodo == 'M':
                vct = parse(i.cttprz_data_inicio, yearfirst=True) - relativedelta(months=1)
                vct = vct.strftime('%Y-%m-%d')
            numero_parcela = 1
            dia = i.cttprz_contrato_id.dia or 0
            if periodo == 'D':
                dia = 1
                dia_original = 1
                periodo = 'DD'
            elif periodo == 'S':
                if dia >= 1 and dia <= 7:
                    periodo = 'DFS'
                else:
                    raise osv.except_osv(_('Atencao'), _('Dia deve ser escolhido entre 1 e 7'))
            elif periodo == 'Q':
                if dia >= 1 and dia <= 15:
                    periodo = 'DFQ'
                else:
                    raise osv.except_osv(_('Atencao'), _('Dia deve ser escolhido entre 1 e 15'))
            else:
                if dia >= 1 and dia <= 30:
                    periodo = 'DFM'
                else:
                    raise osv.except_osv(_('Atencao'), _('Dia deve ser escolhido entre 1 e 30'))
            if i.cttprz_contrato_id.tipo_dia == 'U':
                dia_util = 'S'
            else:
                dia_util = 'N'
            vct = datas.sigDatas(vct).getCalculaPrazo(dia, periodo, dia_util)
            vct = datas.sigDatas(vct).getDataNoFormato('I', 'S', '-')
            gerar_nf = i.cttprz_contrato_id.cttctr_controla_nf
            # if gerar_nf or context.get('provisao'):
            #     arg = [('sigla', '=', 'PRV')]
            # else:
            #     arg = [('sigla', 'in', ('DP', 'DUP'))]
            arg = [('sigla', 'in', ('DP', 'DUP'))]
            if real_provisao == 'P':
                arg = [('sigla', '=', 'PRV')]
            fult_tit_doc_tipo_id = obj_documento_tipo.search(cr, uid, arg, context=context)[0]

            count_while = 1

            def _get_valor(count_while, custificacao):
                brw_item_valor_ids = i.cttprz_item_valor_ids
                valor = i.cttprz_valor or 0.0
                for x in brw_item_valor_ids:
                    valor_item = x.cttivl_valor or 0.0
                    carencia = x.cttivl_item_id.cttite_carencia_considerar
                    if carencia >= count_while and custificacao:
                        valor -= valor_item
                        list_custificacao = filter(lambda c: c.get('valor') != valor_item, custificacao)
                        custificacao = list_custificacao
                        obj_contratos_contrato_item.write(cr, uid, x.cttivl_item_id.id,
                                                          {'cttite_carencia_considerar': 0}, context=context)
                return {'valor': valor, 'custificacao': custificacao}

            data_emissao_titulo = i.cttprz_data_inicio > data_hoje and data_hoje or \
                i.cttprz_data_inicio
            while str(vct) <= i.cttprz_data_termino:
                args = [('contrato_id', '=', contrato_id),
                        ('pessoa_id', '=', i.cttprz_contrato_id.pessoa_id.id),
                        ('data_emissao', '=', data_emissao_titulo),
                        ('documento', '=', i.cttprz_contrato_id.numero),
                        ('parcela', '=', numero_parcela), ('state', 'in', ('A', 'B'))]
                financeiro_titulo_ids = obj_financeiro_titulo.search(cr, uid, args, context=context)
                if not financeiro_titulo_ids:
                    custificacao = dado_custificacao.get(i.id) or []
                    valor_e_custo = _get_valor(count_while, custificacao)
                    res_id = obj_financeiro_utils.financ_titulo_entrada(
                        cr, uid,
                        fult_tit_pessoa_id=i.cttprz_contrato_id.pessoa_id.id,
                        fult_tit_emissao=data_emissao_titulo,
                        fult_tit_vencimento=vct,
                        fult_tit_documento=i.cttprz_contrato_id.numero,
                        fult_tit_parcela=numero_parcela,
                        fult_tit_valor=valor_e_custo.get('valor') or 0.0,
                        fult_tit_tipo_lancamento='A',
                        fult_tit_tipo_titulo=i.cttprz_contrato_id.tipo,
                        fult_tit_doc_tipo_id=fult_tit_doc_tipo_id,
                        fult_tit_custificacao_dados=valor_e_custo.get('custificacao'),
                        context=context,
                        **{'contrato_id': i.cttprz_contrato_id.id}
                    )
                    if res_id:
                        titulos_ids.append(res_id)
                numero_parcela += 1
                vct = datas.sigDatas(vct).getCalculaPrazo(dia, periodo, dia_util)
                vct = datas.sigDatas(vct).getDataNoFormato('I', 'S', '-')
                data_vct = parse(vct)
                if data_vct.month == 1 and dia > 28:
                    dia = 28
                    if isleap(data_vct.year):
                        dia = 29
                else:
                    dia = dia_original
                count_while += 1
        if titulos_ids:
            self.write(cr, uid, ids, {'cttprz_titulos_gerados': True}, context=context)
        return {'value': {'titulos_ids': titulos_ids}}

    # def cttprz_get_servico_preco(self, cr, uid, contrato_ids, context=None):
    #     if isinstance(contrato_ids, (int, long)):
    #         contrato_ids = [contrato_ids]
    #     prazos_ids = self.search(cr, uid, [('cttprz_contrato_id', 'in', contrato_ids)])
    #     dados_serv_preco = self.browse(cr, uid, prazos_ids)
    #     list_serv_preco = map(
    #         lambda s: (s.cttprz_contrato_id.cttctr_servico_id.id, s.cttprz_valor),
    #         filter(lambda d: d.cttprz_valor > 0, dados_serv_preco)
    #     )
    #     return dict(list_serv_preco)

    def _valida_data_inicio(self, cr, uid, contrato_id, data_inicio, context=None):
        context = context and context.copy() or {}
        obj_contratos_prazos = self.pool.get('contratos.prazos')
        prazos_ids = obj_contratos_prazos.search(cr, uid, [('cttprz_contrato_id', '=', contrato_id)],
                                                 order='cttprz_data_termino desc', context=context)
        if prazos_ids:
            data_termino = obj_contratos_prazos.browse(cr, uid, prazos_ids[0]).cttprz_data_termino
            if not data_termino or data_inicio < data_termino:
                raise osv.except_osv(_('Atencao'), _('Prazo nao pode sobrepor os prazos existentes'))

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if context.get('real'):
            vals['cttprz_real_provisao'] = 'R'
        elif context.get('provisao'):
            vals['cttprz_real_provisao'] = 'P'
        contrato_id = vals.get('cttprz_contrato_id')
        self._valida_data_inicio(cr, uid, contrato_id, vals.get('cttprz_data_inicio'), context)
        res = super(contratos_prazos, self).create(cr, uid, vals, context)
        # Funcionalidade para recalculo do vencimento do contrato
        if contrato_id:
            self.pool.get('contratos.contrato').write(cr, uid, [contrato_id], {}, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if context.get('real'):
            vals['cttprz_real_provisao'] = 'R'
        elif context.get('provisao'):
            vals['cttprz_real_provisao'] = 'P'
        browse_contratos_prazos = self.browse(cr, uid, ids[0])
        contrato_id = vals.get('cttprz_contrato_id')
        if not contrato_id:
            contrato_id = browse_contratos_prazos.cttprz_contrato_id.id
        if vals.get('cttprz_data_inicio'):
            self._valida_data_inicio(cr, uid, contrato_id, vals.get('cttprz_data_inicio'), context)
        res = super(contratos_prazos, self).write(cr, uid, ids, vals, context=context)
        # Funcionalidade para recalculo do valor do prazo (contratos.prazos)
        self.pool.get('contratos.contrato').write(cr, uid, [contrato_id], {}, context)
        return res

    def default_get(self, cr, uid, fields, context=None):
        context = context and context.copy() or {}
        res = super(contratos_prazos, self).default_get(cr, uid, fields, context)
        res['cttprz_real_provisao'] = 'R'
        if context.get('cttctr_tipo_contrato') == 'M':
            res['cttprz_flag_tipo_contrato'] = True
        contrato_id = context.get('contrato_capa_id')
        res.update(self._cttprz_get_item_valor(cr, uid, contrato_id, context))
        return res

    def unlink(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_financeiro_titulo = self.pool.get('financeiro.titulo')
        browse_prazos = self.browse(cr, uid, ids, context)
        for x in browse_prazos:
            contrato_id = x.cttprz_contrato_id.id
            data_emissao = x.cttprz_data_inicio
            valor = x.cttprz_valor or 0.0
            titulo_ids = obj_financeiro_titulo.search(cr, uid, [('contrato_id', '=', contrato_id),
                                                                ('vr_original', '=', valor),
                                                                ('data_emissao', '=', data_emissao),
                                                                ('state', '=', 'A')], context=context)
            if titulo_ids:
                obj_financeiro_titulo.unlink(cr, uid, titulo_ids)
        res = super(contratos_prazos, self).unlink(cr, uid, ids)
        return res

    def _cttprz_get_item_valor(self, cr, uid, contrato_id, context=None):
        context = context and context.copy() or {}
        res = dict()
        if not contrato_id:
            return res
        obj_contratos_contrato_item = self.pool.get('contratos.contrato.item')
        obj_contratos_contrato_item_valor = self.pool.get('contratos.contrato.item.valor')
        res['cttprz_contrato_id'] = contrato_id
        ultimo_prazo_ids = self.search(cr, uid, [('cttprz_contrato_id', '=', contrato_id)],
                                       order='cttprz_data_termino DESC', limit=1, context=context)
        args_contrato_item_valor = []
        item_nao_cancelado_ids = obj_contratos_contrato_item.search(
            cr, uid, [('cttite_capa_id', '=', contrato_id),
                      ('cttite_data_cancelamento', '=', False)], context=context)
        if item_nao_cancelado_ids:
            args_contrato_item_valor.append(('cttivl_item_id', 'in', item_nao_cancelado_ids),)
        if ultimo_prazo_ids:
            prazo_id = ultimo_prazo_ids[0]
            args_contrato_item_valor.append(('cttivl_prazo_id', '=', prazo_id),)
        if not args_contrato_item_valor:
            return res
        item_valor_ids = obj_contratos_contrato_item_valor.search(cr, uid, args_contrato_item_valor, context=context)
        list_item_valor = []
        if item_valor_ids:
            brw_contratos_contrato_item_valor = obj_contratos_contrato_item_valor.browse(
                cr, uid, item_valor_ids)
            cttprz_valor = 0
            for item_valor in brw_contratos_contrato_item_valor:
                item_id = item_valor.cttivl_item_id.id
                valor = item_valor.cttivl_valor or 0
                cttprz_valor += valor
                dicionario = {'cttivl_item_id': item_id, 'cttivl_valor': valor}
                tupla = (0, 0, dicionario)
                list_item_valor.append(tupla)
            if list_item_valor:
                res['cttprz_item_valor_ids'] = list_item_valor
            if cttprz_valor:
                res['cttprz_valor'] = cttprz_valor
        elif item_nao_cancelado_ids:
            for item in item_nao_cancelado_ids:
                dicionario = {'cttivl_item_id': item}
                tupla = (0, 0, dicionario)
                list_item_valor.append(tupla)
            if list_item_valor:
                res['cttprz_item_valor_ids'] = list_item_valor
        return res

    def _cttprz_get_custo(self, cr, uid, ids, context=None):

        """
        O metodo gera os dados para a custificacao de cada titulo. Os titulos sao gerados pelo
        prazo ativo do contrato, variando a quantidade de acordo com o periodo de duracao.
        Na classificacao/custificacao, sera buscado o centro de custo da categoria do servico,
        caso nao tenha, sera buscado o centro de custo para contrato (parametro financeiro).
        Ja o evento sera sempre buscado o de contratos (parametro financeiro).
        @ids: lista de registros da tabela contratos_prazos
        @return: Dicionario. Sua chave representa um id da tabela contratos_prazos e seu valor uma
        lista de dicionarios contendo as informacoes de centro de custo, evento e valor de cada
        item do prazo.
        """

        context = context and context.copy() or {}
        res = {}
        obj_adm_utils = self.pool.get('adm.utils')
        field_parametro = ['usar_centro_custos_e_eventos', 'finpar_evento_compra_contrato_id',
                           'finpar_evento_venda_contrato_id', 'finpar_centro_custo_venda_id']
        dado_parametro = obj_adm_utils.admutl_get_parametros(
            cr, uid, 'financeiro', field_parametro, context=context)
        if not dado_parametro.get('usar_centro_custos_e_eventos'):
            return res
        brw_contrato_prazo = self.browse(cr, uid, ids, context=context)
        for i in brw_contrato_prazo:
            list_dado = list()
            dict_dado = dict()
            item_valor_ids = i.cttprz_item_valor_ids
            if filter(lambda it: not it.cttivl_item_id, item_valor_ids):
                raise osv.except_osv(_('Atencao'), _('Ha registro de prazo sem item informado'))
            contrato_id = i.cttprz_contrato_id.id
            for item_valor in item_valor_ids:
                categoria_centro_custo_id = False
                categoria_id = item_valor.cttivl_item_id.cttite_produto_id.categoria_id
                if categoria_id:
                    if categoria_id.estcat_centro_custo_id :
                        categoria_centro_custo_id = categoria_id.estcat_centro_custo_id.id
                    else:
                        #Verificando categorias pais
                        while categoria_id:
                            categoria_id = categoria_id.parent_id
                            if categoria_id:
                                if categoria_id.estcat_centro_custo_id:
                                    categoria_centro_custo_id = categoria_id.estcat_centro_custo_id.id
                                    break
                if categoria_centro_custo_id:
                    centro_custo_id = categoria_centro_custo_id
                else:
                    centro_custo_id = dado_parametro.get('finpar_centro_custo_venda_id')
                if not centro_custo_id:
                    raise osv.except_osv(_('Atencao'), _('Cadastre o centro de custo para '
                                                         'vendas nos parametros do financeiro'))
                contrato_dados = self.pool.get('contratos.contrato').read(
                    cr, uid, context.get('contrato_capa_id') or contrato_id, ['tipo'],
                    context=context)
                if isinstance(contrato_dados, list):
                    contrato_dados = contrato_dados[0]
                tipo = contrato_dados.get('tipo')
                if tipo == 'R':
                    evento_id = dado_parametro.get('finpar_evento_venda_contrato_id')
                    if not evento_id:
                        raise osv.except_osv(_('Atencao'), _('Cadastre o evento para contratos cliente nos '
                                                         'parametros do financeiro'))
                else:
                    evento_id = dado_parametro.get('finpar_evento_compra_contrato_id')
                    if not evento_id:
                        raise osv.except_osv(_('Atencao'), _('Cadastre o evento para contratos fornecedor nos '
                                                         'parametros do financeiro'))
                valor = item_valor.cttivl_valor or 0
                chave = '%s-%s' % (centro_custo_id, evento_id)
                if chave in dict_dado:
                    dict_dado[chave]['valor'] += valor
                else:
                    dict_dado[chave] = {'centro_custo_id': centro_custo_id,
                                        'evento_id': evento_id, 'valor': valor,
                                        'custf_historico': 'CTR -' + i.cttprz_contrato_id.numero}
            for x in dict_dado:
                list_dado.append(dict_dado.get(x))
            res[i.id] = list_dado

        return res
