# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import verificar_tipo_prazo_previsao, cttite_get_state_contrato
from funcoes import cttite_get_titulo_gerado


class contratos_contrato_item(osv.Model):

    """
    Tabela de itens dos contratos
    prefixo: cttite_
    """

    _name = 'contratos.contrato.item'
    _rec_name = 'cttite_produto_id'

    _columns = {
        'cttite_capa_id': fields.many2one('contratos.contrato', 'Contrato'),
        'cttite_data_inicio': fields.date('Data inicio', required=True),
        'cttite_data_cancelamento': fields.date('Data cancelamento'),
        'cttite_produto_id': fields.many2one('estoque.produto', 'Servico'),
        'cttite_observacao': fields.text('Informacoes complementares'),
        'cttite_cancelado': fields.boolean('Item cancelado'),
        'cttite_bloquear_data_cancelamento': fields.function(
            verificar_tipo_prazo_previsao, method=True, string='Bloquear data cancelamento',
            type='boolean', store=False),  # Se o prazo em que o item estiver contido for do tipo
            # previsao (P), a data de cancelamento deve estar readonly.
        'cttite_state_contrato': fields.function(
            cttite_get_state_contrato, method=True, string='Estado do contrato', type='char',
            store=False),
        'cttite_titulo_gerado': fields.function(
            cttite_get_titulo_gerado, method=True, string='Titulos gerados', type='boolean',
            store=False),
        'cttite_carencia': fields.integer('Carencia', help='Esta carencia e em meses e sera '
                                                           'considerada na geracao dos titulos'),
        'cttite_carencia_considerar': fields.integer('Carencia'),
    }
