# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import _cttprz_get_valor_total_prazo
from funcoes import _cttprz_check_contrato_validado


class contratos_prazos(osv.Model):
    """
    Tabela de prazos dos contratos
    Prefixo: cttprz_
    """
    _name = 'contratos.prazos'

    _columns = {
        # ____________________________ integer ____________________________
        'id': fields.integer('Id'),
        # ____________________________ many2one ____________________________
        'cttprz_contrato_id': fields.many2one('contratos.contrato', 'Capa', required=False),

        # ____________________________ date ____________________________
        'cttprz_data_inicio': fields.date('Data inicio', required=True),
        'cttprz_data_termino': fields.date('Data termino'),

        # ____________________________ function ____________________________
        'cttprz_valor': fields.function(_cttprz_get_valor_total_prazo, method=True,
                                        string='Valor estimado', type='float', digits=(11, 2),
                                        store=True),
        'cttprz_contrato_validado': fields.function(_cttprz_check_contrato_validado, method=True,
                                                    string='Estado contrato', type='boolean',
                                                    store=False),

        # ____________________________ boolean ____________________________
        'cttprz_titulos_gerados': fields.boolean('Titulos Gerados'),
        'cttprz_flag_tipo_contrato': fields.boolean('Flag tipo contrato'),
        # True: O tipo do contrato e mercadoria(M), portanto, o botao 'Gerar titulos' deve estar invisivel

        # ____________________________ one2many ____________________________
        'cttprz_item_valor_ids': fields.one2many('contratos.contrato.item.valor', 'cttivl_prazo_id',
                                                 'Itens'),

        # ____________________________ selection ___________________________
        'cttprz_real_provisao': fields.selection([('R', 'Real'), ('P', 'Provisao')],
                                                 'Tipo do prazo', size=1),
    }

    _defaults = {
        'cttprz_titulos_gerados': False,
        'cttprz_flag_tipo_contrato': False,
        'cttprz_real_provisao': lambda *a: 'R',
    }

    _order = "cttprz_contrato_id ASC, cttprz_data_inicio DESC"

