# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class contratos_fornecedor_capa(osv.Model):
    """
    Tabela de contratos de proposta de fornecimento.
    O Fornecedor fornece uma relacao dos seus produtos com respectivos precos, para acelerar o processo de compra do cliente.
    Já sabendo o preco, dispensa-se orcamentos .
    """
    _name = 'contratos.fornecedor.capa'
    _columns = {
        'contrato_id': fields.many2one("contratos.contrato", 'Contrato', ondelete="cascade", required=True,
                                       select=True), # id do contrato\n
        'comprador_id': fields.many2one("compras.comprador", 'Comprador', ondelete="restrict", select=True),
        'forma_pagamento': fields.char('Forma pagamento', size=30), # Forma de pagamento negociado
        'frete': fields.char('Frete', size=30), # Frete negociado
        'fornecedor_itens_ids': fields.one2many('contratos.fornecedor.itens', 'contrato_id', 'Itens'),
    }


