# -*- encoding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        def center_title(e, c, d, t=160):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        title = center_title('', _('Contratos Atualizados'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Contratos Atualizados'))
        listagem.informaTamLinha(160)

        obj_wiz_contratos_atualiza_contrato_item = pooler.get_pool(cr.dbname).get(
            'wiz.contratos.atualiza.contrato.item')
        atualiza_contrato_item_ids = datas.get('atualiza_contrato_item_ids')
        brw_wiz_contratos_atualiza_contrato_item = obj_wiz_contratos_atualiza_contrato_item.browse(
            cr, uid, atualiza_contrato_item_ids)
        data_vencimento = ''
        porcentagem_aumento = ''
        if brw_wiz_contratos_atualiza_contrato_item:
            data_vencimento = brw_wiz_contratos_atualiza_contrato_item[0].atualiza_contrato_id.\
                data_vencimento
            data_vencimento = time.strftime('%d/%m/%Y', time.strptime(data_vencimento, '%Y-%m-%d'))
            porcentagem_aumento = brw_wiz_contratos_atualiza_contrato_item[0].atualiza_contrato_id.\
                porcentagem_aumento
            porcentagem_aumento = getNumeroEditado(porcentagem_aumento, 2)
        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'contratos.contrato', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id,
                                                                               ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab('')
        listagem.informaCab('Data vencimento: %s' % data_vencimento+'                                        '+'Perc. de aumento: %s' % porcentagem_aumento)
        listagem.informaCab('*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(_('|                   PESSOA                      |          NUMERO           |   VENCIMENTO   |          VALOR            |        NOVO VALOR         |'))
        listagem.informaCab('*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab('')
        listagem.rodapePadrao()
        for item in brw_wiz_contratos_atualiza_contrato_item:
            vencimento = item.vencimento or ''
            if vencimento:
                vencimento = time.strftime('%d/%m/%Y', time.strptime(vencimento, '%Y-%m-%d'))
            linha = formataString(item.pessoa_id.nome or '', 47, ' ', 'D', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(item.numero or '', 26, ' ', 'D', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(vencimento, 15, ' ', 'D', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(item.valor or 0, 2), 26, ' ', 'E', 'N',
                                   'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(item.novo_valor or 0, 2), 26, ' ', 'E', 'N',
                                   'S') + '|'
            linha += ' '
            listagem.imprimeLinha('|' + linha)
        listagem.imprimeLinha('*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.imprimeLinha(_('                                                                                                ** Sig Informatica LTDA **                          '))
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_contrato_atualizado')
