# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class wiz_cancelar_contrato(osv.TransientModel):

    _name = 'wiz.cancelar.contrato'

    _columns = {
        'data_vencimento': fields.date('Excluir titulos com vencimento apos', required=True),
        'data_limite_atendimento': fields.date('Data limite para atendimento', required=True),
        'titulo_excluido': fields.selection([('S', 'Sim'), ('N', 'Nao')], 'Excluidos', size=1),
    }

    def button_cancelar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not context.get('active_ids'):
            return True
        obj_financeiro_titulo = self.pool.get('financeiro.titulo')
        titulo_excluido = 'N'
        contrato_ids = context.get('active_ids')
        brw_wiz_cancelar_contrato = self.browse(cr, uid, ids, context)

        for x in brw_wiz_cancelar_contrato:
            titulo_ids = obj_financeiro_titulo.search(cr, uid, [('contrato_id', 'in', contrato_ids),
                                                                ('state', '=', 'A'),
                                                                ('data_prorrogacao', '>=',
                                                                 x.data_vencimento)], context=context)

            data_limite_atendimento = x.data_limite_atendimento

            if titulo_ids:
                obj_financeiro_titulo.unlink(cr, uid, titulo_ids, context)
                titulo_excluido = 'S'
            self.write(cr, uid, x.id, {'titulo_excluido': titulo_excluido}, context)

        #  Altera o contrato para cancelado.
        obj_contratos_contrato = self.pool.get('contratos.contrato')
        obj_contratos_contrato.write(cr, uid, contrato_ids,
                                     {'state': 'C',
                                      'cttctr_data_limite_atendimento': data_limite_atendimento},
                                     context=context.update({'read_only': 'N'}))
        obj_contratos_contrato.message_post(cr, uid, contrato_ids, _('Alteracao de Status'),
                                            _('Cancelado'))

        obj_model_data = self.pool.get('ir.model.data')
        reference = obj_model_data.get_object_reference(cr, uid, 'contratos',
                                                        'wizard_cancelar_contrato_log_view')
        view_id = reference and reference[1] or False
        return {'name': '',
                'view_type': 'form',
                'view_mode': 'form',
                'res_model': 'wiz.cancelar.contrato',
                'view_id': [view_id],
                'target': 'new',
                'type': 'ir.actions.act_window',
                'context': {'excluido': titulo_excluido},
                }

    def default_get(self, cr, uid, fields_list, context=None):
        context = context and context.copy() or {}
        res = super(wiz_cancelar_contrato, self).default_get(cr, uid, fields_list, context)
        titulo_excluido = context.get('excluido') or None
        res['titulo_excluido'] = titulo_excluido
        return res
