#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv
import logging
from openerp import SUPERUSER_ID
from openerp.tools.translate import _


class sig_cliente_modulo_versao(osv.Model):
    _name = 'sig.cliente.modulo.versao'
    _inherit = 'sig.cliente.modulo.versao'
    _logger = logging.getLogger(_name)

    def sigclv_recebe_versao(self, cr, uid, dados, context=None):
        context = context and context.copy() or {}
        _cpf_cnpj = dados.get('cnpj_cliente', False)
        if _cpf_cnpj:
            self._logger.info(_('Identificando versao do cliente! CNPJ: %s') % _cpf_cnpj)
        else:
            self._logger.info(
                _('Identificando versao do cliente! CNPJ Nao identificado --> Dados:%s') % str(dados))
            #TODO retornar false, Estou retornando True, porque não está sendo tratado no cliente
            return True
        try:
            modulos = dados['modulos']
            cnpj_cliente = dados['cnpj_cliente']
            data = dados['data']
        except:
            return False
        _pessoa_id = self.pool.get('adm.pessoa').search(cr, SUPERUSER_ID,
                                                        [('cpf_cnpj', '=', cnpj_cliente)], context=context)
        if _pessoa_id and isinstance(_pessoa_id, list):
            _pessoa_id = _pessoa_id[0]
        for _modulo in modulos.keys():
            args = [
                ('sigclv_cliente_cnpj', '=', cnpj_cliente),
                ('sigclv_modulo', '=',_modulo),
                ('sigclv_versao', '=', modulos.get(_modulo))
            ]
            scmv_ids = self.search(cr, uid, args, context=context)
            # Se para o cnpj, modulo e versão já houver registro, não incluir mais
            if not scmv_ids:
                vals = {
                    'sigclv_cliente_cnpj': cnpj_cliente,
                    'sigclv_data': data,
                    'sigclv_modulo': _modulo,
                    'sigclv_versao': modulos.get(_modulo),
                }
                if _pessoa_id:
                    vals['sigclv_pessoa_id'] = _pessoa_id
                self.create(cr, SUPERUSER_ID, vals, context)
        return True

