# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv


class contrecf_fabricante(osv.Model):

    _inherit = 'contrecf.fabricante'

    def name_search(self, cr, uid, name='', args=None, operator='ilike', context=None, limit=100):
        """
        Sobreescricao da classe BaseModel. O metodo busca os registros dessa tabela baseado na
        descricao e operador recebidos em 'name' e 'operator', respectivamente.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param name: string com a descricao da pesquisa.
        :type name: str
        :param args: argumentos de pesquisa.
        :type args: list
        :param operator: descricao do operador de pesquisa.
        :type operator: str
        :param context: dicionario com valores contextuais.
        :type context: dict
        :param limit: quantidade maxima de registros que devem ser encontrados.
        :type limit: int
        :return: lista de tuplas dos registros encontrados.
        :rtype: list
        """
        context = context and context.copy() or {}
        args = []
        if name and isinstance(name, str):
            args.append(('pessoa_id', operator, name))
        ids = self.search(cr, uid, args, context=context, limit=limit)
        return self.name_get(cr, uid, ids, context)
