# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

pkey_sig = """-----BEGIN RSA PRIVATE KEY-----
MIICXQIBAAKBgQDNlPEHacb00nIQ7rrZ3U4kL9QAU+vvXbLLHGR45+7zYb2cBE2s
qmnUpSgf2Jp2HL0Dz/paqxpB4pOxU6kEcDs1QOlTjt5rTsKKiw6Of7g1MsrIEQCz
tF+u8xXyl93JB0M2QBQ4PGVQQsHxyd+jdWHCOj/YpJCA/8rJUbhiVoRaQwIDAQAB
AoGBAMnIdUO3eUb4AGnKSLBq3bX7E/U2ag/KQiHGPn/F9u4Ac6FdP/hIVBQZ/2Yy
rnlb/9JsIuk3pFAi2qBk4zKuDg2V57DY+h31SLVjENZHD3M0MGonFzu1uay+s/m0
X0mMbueNXuWAAYkoAPL/wEjP/ciJkqfCUiOJADcf7PJhXfhxAkEA9F1mdw+z+GPu
tHabZ2WJJSb7JnZtAskG/spFye6UUUw53tC7mLZ7Ye3dESa3l9jtRfC4CSKbNJhX
9JyTkzcabQJBANdezxdVg4gbBbdBm6cf59aT7Y1KIrqkDtQpENBJVMXJUIa2CTEc
QvGE3UwOA37zLRFtkSZk0w1590wC7NkwWW8CQBmr+kjF0I1myjwRPdBF/Xt2tenb
hSZGwkJgM6a8Nr63uFitKxgnC51FJPVZUO5V7s9rM5paFV4YJx1ema5cmp0CQQCo
gwgqS8CEqBAK2Qy+8RnnLQt7t3wA6QipPBBpyFbKAsA9BwWeJWzDqJ+2OGjH1eF3
d3FQxybTrpCuKsPDFC+FAkALWOoMA+liEcsz/n7BardljL0BRDuqMaS2iuQ/RTAH
34xfgVdzAN8XNLA+FOAWMxyDxP1vfoa6SwUsTZsdebGa
-----END RSA PRIVATE KEY-----"""

from openerp.osv import osv
from openerp.tools.translate import _
from SigUtils.crypto import encrypt
import base64

class contrecf_mobile(osv.Model):

    _inherit = 'contrecf.mobile'

    def get_pessoa_id(self, cr, uid, cnpj, context=None):
        context = context and context.copy() or {}
        pessoa_id = self.pool.get('adm.pessoa').search(cr, uid, [('cpf_cnpj', '=', cnpj)],
                                                       context=context)
        return pessoa_id and pessoa_id[0]

    def get_limite_mobile(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        obj_ctr_vendas = self.pool.get('contrecf.vendas')
        args = [('pessoa_id', '=', vals.get('ctrmob_pessoa_id'))]
        venda_ids = obj_ctr_vendas.search(cr, uid, args, context=context)
        campos = ['cefven_qtd_mobile', 'cefven_mobile_ativo']
        dados_vendas = obj_ctr_vendas.read(cr, uid, venda_ids, campos, context=context)
        if not dados_vendas:
            return True


        qtd_mobile_ativos = int(dados_vendas[0].get('cefven_mobile_ativo'))
        qtd_mobile_vendidos = sum(map(lambda x: x.get('cefven_qtd_mobile'), dados_vendas))
        if qtd_mobile_ativos < qtd_mobile_vendidos: # libera para gerar mais uma licensa
            return False

        return True

    def gerar_mobile_licenca(self,cr, uid, vals, context=None):
        context = context and context.copy() or {}
        marca = vals.get('ctrmob_marca') or False
        modelo= vals.get('ctrmob_modelo') or False
        nro_serie = vals.get('ctrmob_nro_serie') or False
        if not all([modelo, marca, nro_serie]):
            return '', _('Dados incompletos cadastrados no Mobile')

        if self.get_limite_mobile(cr, uid, vals, context):
            return '', _('Limite de licencas excedido!')

        chave = "#|#".join([modelo, marca, nro_serie])
        licenca = encrypt(chave, pkey_sig)
        return licenca, ''

    def gerar_mobile(self,cr, uid, vals, context=None):
        context = context and context.copy() or {}
        vals_mobile = {'ctrmob_pessoa_id': vals.get('pessoa_id'),
                       'ctrmob_marca': vals.get('marca'),
                       'ctrmob_modelo': vals.get('modelo'),
                       'ctrmob_nro_serie': vals.get('nro_serie')}
        return [self.create(cr, uid, vals_mobile, context=context)]

    def get_mobile_licenca(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        pessoa_id = self.get_pessoa_id(cr, uid, vals.get('cnpj'), context=context)
        if not pessoa_id:
            return (False, _('Cliente nao cadastrado, favor entrar em contato com o suporte!'))

        vals['pessoa_id'] = pessoa_id
        args = [('ctrmob_pessoa_id', '=', pessoa_id),
                ('ctrmob_marca', '=', vals.get('marca')),
                ('ctrmob_modelo', '=', vals.get('modelo')),
                ('ctrmob_nro_serie', '=', vals.get('nro_serie'))]
        mobile_ids = self.search(cr, uid, args, context=context)
        if not mobile_ids:
            mobile_ids = self.gerar_mobile(cr, uid, vals, context=context)

        dados_mobile = self.read(cr, uid, mobile_ids[0], [], context=context, load='_classic_write')
        licenca = dados_mobile.get('ctrmob_licenca')
        erro = ''
        if not licenca:
            licenca, erro = self.gerar_mobile_licenca(cr, uid, dados_mobile, context=context)
            if not erro:
                self.write(cr, uid, mobile_ids, {'ctrmob_licenca': licenca}, context=context)

        if licenca:
            licenca = base64.encodestring(licenca)

        return (licenca and True or False, licenca or erro)

    def ctrmob_button_gerar_licenca(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        dados_mobile = self.read(cr, uid, ids[0], [], context=context, load='_classic_write')
        licenca, erro = self.gerar_mobile_licenca(cr, uid, dados_mobile, context=context)
        if erro:
            raise osv.except_osv(_('Atencao!'), erro)

        self.write(cr, uid, ids, {'ctrmob_licenca': licenca}, context=context)
        return True
