# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class contrecf_nroseriesecfs(osv.Model):
    _name = 'contrecf.nroseriesecfs'
    _inherit = 'contrecf.nroseriesecfs'

    def _contrecf_calcula_ecfs_vendidas_registradas(self, cr, uid, pessoa_id, context=None):
        context = context and context.copy() or {}
        res = {'vendidas': 0, 'registradas': 0}
        if pessoa_id:
            obj_venda = self.pool.get('contrecf.vendas')
            venda_ids = obj_venda.search(cr, uid, [('pessoa_id', '=', pessoa_id)], context=context)
            dados_vendas = obj_venda.read(cr, uid, venda_ids, ['qtdecfs'], context=context)
            _qtdEcfsVendidas = 0
            for venda in dados_vendas:
                _qtdEcfsVendidas += venda['qtdecfs']
            nro_serie_ids = self.search(cr, uid, [('pessoa_id', '=', pessoa_id)], context=context)
            res['vendidas'] = _qtdEcfsVendidas
            res['registradas'] = len(nro_serie_ids)
        return res

    def onchange_cliente(self, cr, uid, ids, pessoa_id, context=None):
        context = context and context.copy() or {}
        if not pessoa_id:
            return dict()

        res = self._contrecf_calcula_ecfs_vendidas_registradas(cr, uid, pessoa_id, context=context)
        if res['vendidas'] == 0:
            raise osv.except_osv(_('Atencao'), _('Nao ha vendas de ECF''s para este Cliente!'))
        if res['registradas'] >= res['vendidas']:
            raise osv.except_osv(_('Atencao'), _('Todas as ECF''s vendidas para este Cliente ja estao registradas!'))
        return {}

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        res = self._contrecf_calcula_ecfs_vendidas_registradas(cr, uid, vals['pessoa_id'], context=context)
        if res['vendidas'] == 0:
            raise osv.except_osv(_('Atencao'), _('Nao ha vendas de ECF''s para este Cliente!'))
        if res['registradas'] >= res['vendidas']:
            raise osv.except_osv(_('Mensagem:'),
                                 _('Nao posso mais registrar ECF''s para este cliente!\nTodas as ecfs contratadas ja foram registradas!'))
        result = super(contrecf_nroseriesecfs, self).create(cr, uid, vals, context)
        return result

