# -*- encoding: utf-8 -*-
# #############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
# www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class contrecf_vendas(osv.Model):
    _name = 'contrecf.vendas'
    _inherit = 'contrecf.vendas'

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('cefven_incluir_dependencias'):
            vals['cefven_incluir_dependencias'] = False
        res = super(contrecf_vendas, self).write(cr, uid, ids, vals, context)
        modulos_faltantes = self.cefven_achar_dependencias(cr, uid, ids, context=context)
        if modulos_faltantes:
            string = ''
            for x in modulos_faltantes:
                string += x + '\n'
            vals['prazo_validacao'] = 120
            raise osv.except_osv(_('Atencao!'),
                                 _('Os seguintes modulos precisam ser instalados:\n%s') % string)
        return res

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('cefven_incluir_dependencias'):
            vals['cefven_incluir_dependencias'] = False
        res = super(contrecf_vendas, self).create(cr, uid, vals, context)
        modulos_faltantes = self.cefven_achar_dependencias(cr, uid, [res], context=context)
        if modulos_faltantes:
            string = ''
            for x in modulos_faltantes:
                string += x + '\n'
            raise osv.except_osv(_('Atencao'),
                                 _('Os seguintes modulos precisam ser instalados!\n%s' % string))
        return res

    def _cefven_identificar_dependencias(self, cr, uid, lista_modulos, context=None):
        """
        @param lista_modulos: lista que contem os modulos desejados
        @return: uma lista vazia ou uma lista com as dependencias  e os modulos informados
        """
        context = context and context.copy() or {}
        _nova = []
        for x in lista_modulos:
            _nova.append(x)
        dependentes_ids = self.pool.get('ir.module.module').search(cr, uid, [('name', 'in', lista_modulos)],
                                                                   context=context)
        nome_dependencias_anter = []
        while _nova != nome_dependencias_anter:
            nome_dependencias_anter = []
            for x in _nova:
                nome_dependencias_anter.append(x)
            _dep_ids = self.pool.get('ir.module.module.dependency').search(cr, uid,
                                                                           [('module_id', 'in', dependentes_ids)],
                                                                           context=context)
            _dados_dep = self.pool.get('ir.module.module.dependency').read(cr, uid, _dep_ids, [], context=context)
            for x in _dados_dep:
                if x.get('name') not in _nova:
                    _ids = self.pool.get('ir.module.module').search(cr, uid, [('name', '=', x.get('name')),
                                                                              ('license', '=', 'Other proprietary'),
                                                                              ('application', '=', True)],
                                                                    context=context)
                    if _ids:
                        _nova.append(x.get('name'))
                        dependentes_ids.append(_ids[0])
        return _nova

    def cefven_achar_dependencias(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not isinstance(ids, (list, tuple)):
            ids = [ids]
        for venda_dados in self.browse(cr, uid, ids):
            _lista_modulos = []
            for modulo_dados in venda_dados.cefven_modulos_ids:
                _lista_modulos.append(modulo_dados.sigvnd_modulo_id.name)
            modulos_necessarios = self._cefven_identificar_dependencias(cr, uid, _lista_modulos, context=context)
            for x in _lista_modulos:
                if x in modulos_necessarios:
                    modulos_necessarios.remove(x)
        modulos_necessarios.sort()
        return modulos_necessarios

    def cefven_onchange_incluir_dependencias(self, cr, uid, ids, modulos, cefven_incluir_dependencias, context=None):
        context = context and context.copy() or {}
        values = {}
        if not cefven_incluir_dependencias:
            return {'value': values}
        values['cefven_incluir_dependencias'] = False
        ids = []
        for x in modulos:
            if x[0] == 0:
                if x[2] and isinstance(x[2], dict):
                    if x[2].get('sigvnd_modulo_id'):
                        ids.append(x[2].get('sigvnd_modulo_id'))
                        continue
            if x[0] == 4:
                if x[2] and isinstance(x[2], dict):
                    ids.append(x[2].get('sigvnd_modulo_id'))
                else:
                    ids.append(
                        self.pool.get('sig.venda.modulos').read(cr, uid, x[1], context=context).get('sigvnd_modulo_id')[
                            0])
                continue
        _modulos = []
        dados_modulo = self.pool.get('ir.module.module').read(cr, uid, ids, [], context=context)
        for x in dados_modulo:
            _modulos.append(x.get('name'))
        modulos_faltantes = self._cefven_identificar_dependencias(cr, uid, _modulos, context=context)
        for x in _modulos:
            if x in modulos_faltantes:
                modulos_faltantes.remove(x)
        modulos_faltantes.sort()
        if modulos_faltantes:
            _modulos = modulos
            for x in modulos_faltantes:
                _id = self.pool.get('ir.module.module').search(cr, uid, [('name', '=', x)], context=context)[0]
                _modulos.append([0, False, {'sigvnd_modulo_id': _id}])
            values['cefven_modulos_ids'] = _modulos
        return {'value': values}
