# -*- coding: utf-8 -*-
#
# OBS: para funcionar eh preciso que tenha a pasta 'static' dentro do modulo

import openerp.addons.web.http as http
import json
import xmlrpclib, socket

SEM_ERRO = '00'
ERRO_INTERNO = '99'


class MySock(object):
    def __init__(self, params):
        super(MySock, self).__init__()
        user = params.get('user') or ''
        self.pwd = params.get('senha') or ''
        self.host = params.get('url') or ''
        self.port = params.get('port') or ''
        if not self.port:
            raise Exception('Porta não informada na URL!')

        self.db = params.get('db')
        if not self.db:
            raise Exception('Banco de Dados não informado!')

        sock_common = xmlrpclib.ServerProxy('http://' + self.host + ':' + str(self.port) +
                                            '/xmlrpc/common')
        socket.setdefaulttimeout(10)
        self.uid = sock_common.login(self.db, user, self.pwd)
        self.sock = xmlrpclib.ServerProxy('http://{0:>}:{1:>}/xmlrpc/object'.format(self.host,
                                                                                    self.port))

    def execute(self, model, function, *args):
        return self.sock.execute(self.db, self.uid, self.pwd, model, function, *args)


class sc_contrecf(http.Controller):
    _cp_path = '/contrecf'

    @http.httprequest
    def teste(self, req, s_action=None, **kw):
        ip = req.httprequest.environ.get('REMOTE_ADDR')
        print(ip)
        return 'Resposta Teste: ' + ip

    @http.httprequest
    def get_mobile_licenca(self, req, s_action=None, **kw):
        try:
            sock = MySock(req.params)
            vals = {'marca': req.params.get('marca'),
                    'modelo': req.params.get('modelo'),
                    'nro_serie': req.params.get('nro_serie'),
                    'cnpj': req.params.get('cnpj')}
            res = sock.execute('contrecf.mobile', 'get_mobile_licenca', vals, {})
            if not res or not res[0]:
                return json.dumps({'retorno': [],
                                   'codigo': ERRO_INTERNO,
                                   'mensagem': res and res[1] or 'Erro ao na função no serividor '
                                                                 'SIG'})

            return json.dumps({'retorno': [res],
                               'codigo': SEM_ERRO,
                               'mensagem': 'ok'})
        except Exception as e:
            return json.dumps({'codigo': ERRO_INTERNO,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': []})
