#!/usr/bin/python
# -*- coding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _
from re import sub


class wizard_bloquear_licenca(osv.TransientModel):
    """Wizard para bloquear licença dos clites manualmente
       Prefixo: wizbll_
    """

    _name = 'wizard.bloquear.licenca'

    _columns = {
        'wizbll_pessoa_id': fields.many2one("adm.pessoa", 'Cliente', ondelete="cascade",
                                            required=True),
        'wizbll_liberar': fields.boolean('Liberar validacao'),
        'wizbll_prazo': fields.integer('Prazo validacao'),
        'wizbll_alterado': fields.boolean('Alterado'),
    }

    def wizbll_onchange_pessoa_id(self, cr, uid, ids, pessoa_id, context=None):
        context = context and context or {}
        res = {}
        obj_vendas = self.pool.get('contrecf.vendas')
        venda_ids = obj_vendas.search(cr, uid, [('pessoa_id', '=', pessoa_id)], context=context)
        if not venda_ids:
            return res

        dados_venda = obj_vendas.read(cr, uid, venda_ids[0], ['liberar_validacao',
                                                              'prazo_validacao'], context)
        res.update({'value': {'wizbll_liberar': dados_venda.get('liberar_validacao'),
                              'wizbll_prazo': dados_venda.get('prazo_validacao') or 0,}})
        return res

    def wizbll_alterar_licenca(self, cr, uid, ids, context=None):
        context = context and context or {}
        filtro = self.read(cr, uid, ids[0], [], context, '_classic_write')
        pessoa_id = filtro.get('wizbll_pessoa_id')
        obj_vendas = self.pool.get('contrecf.vendas')
        venda_ids = obj_vendas.search(cr, uid, [('pessoa_id', '=', pessoa_id)], context=context)
        if not venda_ids:
            raise osv.except_osv(_('Atencao!'),
                                 _('Nenhuma venda encontrada para este cliente!'))

        obj_vendas.write(cr, uid, venda_ids, {'liberar_validacao': filtro.get('wizbll_liberar'),
                                              'prazo_validacao': filtro.get('wizbll_prazo')})
        self.write(cr, uid, ids, {'wizbll_alterado': True})
        return True