#!/usr/bin/python
# -*- coding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _
from SigUtils import sigerp
from re import sub
import logging


class wizard_validar_licenca(osv.TransientModel):
    """Wizard para validar licença dos clites manualmente
       Prefixo: wizval_
    """

    _name = 'wizard.validar.licenca'
    _logger = logging.getLogger(_name)

    _columns = {
        'wizval_cnpj': fields.char('CNPJ', char=14, required=True),
        'wizval_licenca': fields.char('Licenca', char=14),
        'wizval_validado': fields.boolean('Validado'),
    }

    _defaults = {
        'wizval_validado': False,
    }

    def wizval_validar_licenca(self, cr, uid, ids, context=None):
        context = context and context or {}
        cnpj = sub('[^0-9]', '', self.read(cr, uid, ids[0], ['wizval_cnpj'], context
                                           ).get('wizval_cnpj') or '')
        cripto_licenca = self.pool.get('financeiro.cliente').fincli_gerar_licensa(cr, uid, cnpj,
                                                                           'localhost', context)

        try:
            licenca = sigerp._crypto_sig('d', cripto_licenca)
        except Exception as e:
            self._logger.info(_('Erro ao descriptografar licenca: %s Erro:') % (cripto_licenca, e))
            raise osv.except_osv(_('Atencao!'), _('Criptografia incorreta!'))

        list_licenca = licenca.split(';')
        if list_licenca[1] == '0':
            raise osv.except_osv(_('Atencao!'),
                                 _('Cliente Bloqueado!'))

        self.write(cr, uid, ids, {'wizval_validado': True,
                                  'wizval_licenca': cripto_licenca}, context)
        return True
