#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv
from SigUtils import datas
from SigUtils import sigerp
import logging
from openerp import SUPERUSER_ID
from openerp.tools.translate import _


class financeiro_cliente(osv.Model):
    _name = 'financeiro.cliente'
    _inherit = 'financeiro.cliente'
    _logger = logging.getLogger(_name)

    def fincli_gerar_licensa(self, cr, uid, cnpj_cpf, ip_cliente=False, context=None):
        context = context and context.copy() or {}
        self._logger.info(_('Pedido de licenca para o CNPJ %s') % cnpj_cpf)
        licensa = licensa_c = False
        try:
            cliente_ids = self.search(cr, SUPERUSER_ID, [('cpf_cnpj', '=', cnpj_cpf)], context=context)
            if not cliente_ids:
                self._logger.info(_('Cnpj não localizado como cliente cnpj %s') % cnpj_cpf)
                return False
            cliente_id = cliente_ids
            if isinstance(cliente_ids, list):
                cliente_id = cliente_ids[0]
            _validade = datas.calcVencimento(datas.getDataDeHoje(), 45, 'DD', 'S')
            dados_cliente = self.read(cr, SUPERUSER_ID, cliente_id, [], context=context)
            if dados_cliente:
                vendas_ids = self.pool.get('contrecf.vendas').search(cr, SUPERUSER_ID,
                                            [('pessoa_id', '=', dados_cliente.get('pessoa_id')[0])], context=context)
                _qtd_empresas = _qtd_usuarios = 0
                _modulos = ''
                _liberar_validacao = True
                for brw_venda in self.pool.get('contrecf.vendas').browse(cr, SUPERUSER_ID,
                                                                       vendas_ids):
                    _qtd_empresas += brw_venda.cefven_qtd_empresas
                    _qtd_usuarios += brw_venda.cefven_qtd_usuarios
                    if not brw_venda.liberar_validacao:
                        _liberar_validacao = False
                    for modulo in brw_venda.cefven_modulos_ids:
                        if not modulo.sigvnd_cancelado:
                            _modulos += modulo.sigvnd_modulo_id.name +','
                if _modulos:
                    _modulos = _modulos[:-1]
                if not _liberar_validacao:
                    self._logger.info('Cliente %s bloqueado! Vendas: %s' % (str(dados_cliente.get('pessoa_id')[0]), str(vendas_ids)))
                    _validade = 00000000
                # Licensa composta por cnpj, data validade, qtd empresas, qtd_usuarios, lista de modulos
                licensa = '%s;%s;%s;%s;%s' % (
                    cnpj_cpf, _validade, _qtd_empresas, _qtd_usuarios, _modulos)
                vals = {
                    'sigclv_cliente_id': cliente_id,
                    'sigclv_licensa': licensa,
                    'sigclv_valido_ate': _validade,
                }
                if ip_cliente:
                    vals['sigclv_ip'] = ip_cliente
                self.pool.get('sig.cliente.validacao').create(cr, SUPERUSER_ID, vals, context)
                licensa_c = sigerp._crypto_sig('e', licensa)
        except Exception as e:
            self._logger.error(
                'Nao consegui gerar licenca para o cnpj %s,  -> Erro:%s' % (cnpj_cpf, str(e)))
        self._logger.info('Licenca gerada: %s' % str(licensa))
        return licensa_c
