# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################


#Funcoes da classe contrecf_fabricante
def _nome_fabricante(self, cursor, user, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for fabricante in self.browse(cursor, user, ids):
        if fabricante.pessoa_id:
            res[fabricante.id] = fabricante.pessoa_id.name
        else:
            res[fabricante.id] = False
    return res


#Funcoes da classe contrecf_nroseriesecfs
def _get_cod_nacional(self, cursor, user, ids, name, arg, context=None):
    """
    Metodo para retornar o codigo nacional do ecf
    """
    context = context and context.copy() or {}
    res = {}
    for serie in self.browse(cursor, user, ids):
        if serie.id:
            fab = ''
            mod = ''
            ver = ''
            if serie.fabricante_id.codigo_nacional:
                fab = serie.fabricante_id.codigo_nacional
            if serie.modelo_id.codigo_nacional:
                mod = serie.modelo_id.codigo_nacional
            if serie.versao_id.codigo_nacional:
                ver = serie.versao_id.codigo_nacional
            res[serie.id] = fab + '.' + mod + '.' + ver
        else:
            res[serie.id] = False
    return res


def _cpf_cnpj_cliente(self, cursor, user, ids, name, arg, context=None):
    """
    retorna o cpf_cnpj do cliente. Busca o cpf/cnpj da empresa
    """
    context = context and context.copy() or {}
    res = {}
    for cliente in self.browse(cursor, user, ids):
        if cliente.pessoa_id:
            res[cliente.id] = cliente.pessoa_id.cpf_cnpj
        else:
            res[cliente.id] = False
    return res


#Funcoes da classe sig_parceiros
def _nome_parceiro(self, cursor, user, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for parceiro in self.browse(cursor, user, ids):
        if parceiro.pessoa_id:
            res[parceiro.id] = parceiro.pessoa_id.name
        else:
            res[parceiro.id] = False
    return res


#Funcoes da classe contrecf_usuarios
def _nome_usuario(self, cursor, user, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for usuario in self.browse(cursor, user, ids):
        if usuario.pessoa_id:
            res[usuario.id] = usuario.pessoa_id.name
        else:
            res[usuario.id] = False
    return res


#Funcoes da classe contrecf_vendas
def _nome_cliente(self, cursor, user, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for cliente in self.browse(cursor, user, ids):
        if cliente.pessoa_id:
            res[cliente.id] = cliente.pessoa_id.name
        else:
            res[cliente.id] = False
    return res


def _get_dados(self, cr, uid, ids, name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    for dados in self.read(cr, uid, ids, ['pessoa_id'], context=context):
        pessoa_id = dados['pessoa_id'][0]
        ecfs = self.pool.get('contrecf.nroseriesecfs')
        ecf_ids = ecfs.search(cr, uid, [('pessoa_id', '=', pessoa_id)], context=context)
        args = [('ctrmob_pessoa_id', '=', pessoa_id), ('ctrmob_licenca', 'not in', [False, ''])]
        mobile_ids = self.pool.get('contrecf.mobile').search(cr, uid, args, context=context)
        res[dados.get('id')] = {'ecf_ativo': str(len(ecf_ids)),
                                 'cefven_mobile_ativo': '%s' % len(mobile_ids)}
    return res
