# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class contrecf_nroseriesecfs(osv.Model):
    from funcoes import _get_cod_nacional, _cpf_cnpj_cliente

    _name = 'contrecf.nroseriesecfs'
    _rec_name = 'nroserie'
    _columns = {
        'datainclusao': fields.date('Data inclusao', required=True),
        'fabricante_id': fields.many2one('contrecf.fabricante', 'Fabricante', ondelete="restrict",
                                         select=True),
        'modelo_id': fields.many2one('contrecf.modelosecfs', 'Modelo', ondelete="restrict", select=True),
        'versao_id': fields.many2one('contrecf.versao', 'Versao SB', ondelete="restrict", select=True,
                                     domain="[('modelosecfs_id', '=', modelo_id)]"),
        'data_hora_sb': fields.datetime('Data/hora da versao'),
        'nroserie': fields.char('Nro de serie', size=30),
        'macaddres': fields.char('Nro MacAddres', size=30),
        'nroecf': fields.integer('Nro do ecf'),
        'nroloja': fields.integer('Nro da loja'),
        'pessoa_id': fields.many2one('adm.pessoa', 'Cliente', required=True, ondelete="restrict", select=True,
                                     context={'contrecf_vendas': True}),
        'codigo_nacional': fields.function(_get_cod_nacional, method=True, string='Codigo Nacional', type='text',
                                           store=False), # Codigo nacional do ECF
        'cpf_cnpj': fields.function(_cpf_cnpj_cliente, method=True, string='CPF/CNPJ', type='text', store=False),
        'versao_frente': fields.char('Versao do Frente de Loja', size=10),
        'data_atualizacao_frente': fields.date('Data da Atualizacao do Frente'),
        'desc_os': fields.char('Sistema Operacional', size=15),
        'versao_db': fields.char('Versao do Banco de Dados', size=10),
        'recomposicao_gt_ids': fields.one2many('contrecf.recomposicao.gt', 'nroserie_id', 'Recomposicoes de GT'),
    }
    _sql_constraints = [
        ('ecf_uniq', 'unique(pessoa_id, nroloja, nroecf, macaddres)', ' ECF ja cadastrada para o cliente! Por favor verifique.'),
    ]


