#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _

READ_LOAD = '_classic_write'


class sig_parceiros_produtos(osv.Model):

    _name = 'sig.parceiros.produtos'
    _rec_name = 'sigprp_produto_id'

    def name_get(self, cr, uid, ids, context=None):

        context = context and context.copy() or {}
        res = ({}.fromkeys(ids, '')).items()
        parceiro_produto_dados = self.read(cr, uid, ids, ['sigprp_produto_id'], context=context, load=READ_LOAD)
        if parceiro_produto_dados:
            produto_ids = map(lambda i: i['sigprp_produto_id'], parceiro_produto_dados)
            if produto_ids:
                produto_dados = self.pool.get('estoque.produto').read(
                    cr, uid, produto_ids, ['name'], context=context, load=READ_LOAD
                )
                dict_produto_id_nome = dict(map(lambda i: (i['id'], i['name']), produto_dados))
                res_name = {}
                for i in parceiro_produto_dados:
                    id = i['id']
                    produto_id = i['sigprp_produto_id']
                    produto_nome = dict_produto_id_nome.get(produto_id) or _('*** Erro ao buscar o nome do produto ***')
                    res_name[id] = produto_nome
                res = dict(res)
                res.update(res_name)
                res = res.items()
        return res

    _columns = {
        'sigprp_parceiro_id': fields.many2one('sig.parceiros', 'Parceiro', required=True, ondelete='cascade'),
        'sigprp_produto_id': fields.many2one('estoque.produto', 'Produto', required=True),
        'sigprp_cota_mensal': fields.integer('Cota Mensal'),
        'sigprp_valor_unitario_negociado': fields.float('Valor Unitario Negociado', required=True),
    }