# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from datetime import datetime


class contrecf_recomposicao_gt(osv.Model):
    _name = 'contrecf.recomposicao.gt'
    _rec_name = 'data_alteracao'
    _columns = {
        'data_alteracao': fields.datetime('Data de Atualizacao', required=True, select=True),
        'nroserie_id': fields.many2one('contrecf.nroseriesecfs', 'Nro de Serie', required=True, ondelete="restrict",
                                       select=True),
        'nroserie': fields.char('Nro de serie', size=30, required=True),
        'crz_ecf': fields.integer('CRZ ECF', size=4, required=True, help='Contador de Reducao Z da ECF'),
        'crz_db': fields.integer('CRZ Base', size=4, required=True,
                                 help='Contador de Reducao Z Gravado no Banco do Frente'),
        'cro_ecf': fields.integer('CRO ECF', size=3, required=True, help='Contador de Reinicio de Operacoes da ECF'),
        'cro_db': fields.integer('CRO Base', size=3, required=True,
                                 help='Contador de Reinicio de Operacoes Gravado no Banco do Frente'),
        'vbd_ecf': fields.float("Venda Bruta ECF", required=True, digits=(12, 2), help="Venda Bruta Diaria na ECF"),
        'vbd_db': fields.float("Venda Bruta Base", required=True, digits=(12, 2),
                               help="Venda Bruta Diaria no Banco do Frente"),
        'cecrgt_cliente_ids': fields.one2many('adm.pessoa', 'admpes_contrecf_recomposicao_gt_id', 'Cliente',
                                              required=True, ondelete='restrict'),
    }

    _order = 'data_alteracao desc'

    _defaults = {
        'data_alteracao': datetime.today()
    }