# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class contrecf_vendas(osv.Model):
    from funcoes import _nome_cliente, _get_dados

    _name = 'contrecf.vendas'

    _columns = {
        'pessoa_id': fields.many2one('adm.pessoa', 'Cliente', required=True, ondelete="restrict",
                                     select=True),
        'datadavenda': fields.date('Data da venda', required=True),
        'qtdecfs': fields.integer('Qtd de ECFs', required=True),
        'cefven_qtd_mobile': fields.integer('Qtd de Mobiles', required=True),
        'tef': fields.selection([('N', 'Nao'), ('E', 'Dedicado'), ('I', 'Discado')], 'Usa Tef',
                                size=1),
        'sintegra': fields.boolean('Usa Sintegra'),
        'cefven_comodato': fields.boolean('Comodato'),
        'nome_cliente': fields.function(_nome_cliente, method=True, string='Cliente', type='text',
                                        store=False),
        'ecf_ativo': fields.function(_get_dados, method=True, string='ECF ativo', type='text',
                                     multi='dados'),
        'cefven_mobile_ativo': fields.function(_get_dados, method=True, string='Mobiles ativos',
                                               type='text', multi='dados'),
        'liberar_validacao': fields.boolean('Liberar Validacao'),
        'serie': fields.char('Numero de serie', size=5, help='Numero de serie da licenca do cliente'),
        'prazo_validacao': fields.integer('Prazo para validacao'),
        'cefven_observacao': fields.text('Informacoes complementares'),
        'cefven_modulos_ids': fields.one2many('sig.venda.modulos', 'sigvnd_venda_id', 'Modulos'),
        'cefven_incluir_dependencias': fields.boolean('Incluir dependencias'),
        'cefven_parceiro_id': fields.many2one('sig.parceiros', 'Parceiro'),
        'cefven_qtd_empresas': fields.integer('Quantidade de empresas'),
        'cefven_qtd_usuarios': fields.integer('Quantidade de usuarios'),
        'cefven_qtd_bases': fields.integer('Quantidade de bases'),
        'cefven_produto_id': fields.many2one('crm_br.produto', 'Produto'),
    }

    _sql_constraints = [
        ('ecfcliente_uniq', 'unique(pessoa_id, datadavenda)',
         'Venda ja cadastrada para este Cliente nesta data. \n Por favor verifique.'),
    ]
    _order = 'datadavenda desc'
    _defaults = {
        'cefven_qtd_bases': 1,
    }