#!/usr/bin/python
# -*- encoding: utf-8 -*-


class Html(object):
    """
    Classe responsável por gerar documentação em HTML.

    :author: Dener Luiz Rodrigues da Silva <dl.rodrigues94[at]gmail.com>
    """
    @staticmethod
    def cabecalho():
        cabecalho = """<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
                       <html xmlns="http://www.w3.org/1999/xhtml">
                       <head>
                    """
        return cabecalho

    @staticmethod
    def title(value):
        title = "<title>%s</title>" % value
        return title

    @staticmethod
    def meta():
        meta = """
                <meta charset="UTF-8">
               """
        return meta

    @staticmethod
    def css():
        css = """
            <style type="text/css">
              body {  font-family: verdana, helvetica, sans-serif; margin: 0px; padding: 0; }
              h1 { font-weight: bold; font-size: 150%; border-bottom-style: solid; border-bottom-width: 2px; margin-top: 0px; padding-bottom: 0.5ex; color: #eeeeee; }
              h2 { font-size: 130%; padding-bottom: 0.5ex; color: #009ACE; border-bottom-style: solid; border-bottom-width: 2px; }
              h3 { font-size: 110%; padding-bottom: 0.5ex; color: #000000; }
              th { text-align: left; background-color: #009ACE; color: #eeeeee; }
              #ReportHeader { padding: 10px; background-color: #009ACE; color: #eeeeee; border-bottom-style: solid; border-bottom-width: 2px; border-color: #999999; }
              #ReportHeader th { width: 25%; white-space: nowrap; vertical-align: top; }
              #ReportHeader td { vertical-align: top; color: #eeeeee; }
              #ReportNotes { padding: 10px; background-color: #eeeeee; font-size: 80%; border-bottom-style: solid; border-bottom-width: 2px; border-color: #999999; }
              .ReportSQL { margin-bottom: 10px; padding: 10px; display: block; background-color: #eeeeee; font-family: monospace; }
              #ReportDetails { margin-left: 10px; margin-right: 10px; margin-bottom: 10px; }
              #ReportDetails td, th { font-size: 80%; margin-left: 2px; margin-right: 2px; }
              #ReportDetails th { border-bottom-color: #777777; border-bottom-style: solid; border-bottom-width: 2px; }
              .ReportDetailsOddDataRow { background-color: #dddddd; }
              .ReportDetailsEvenDataRow { background-color: #eeeeee; }
              .ReportTableHeaderCell { background-color: #dddddd; color: #009ACE; vertical-align: top; font-size: 80%; white-space: nowrap; }
              .ReportTableValueCell { vertical-align: top; font-size: 80%; white-space: nowrap; }
              .ReportTableInfo { font-size: 80%; font-style: italic; }
              #ReportFooter { font-weight: bold; font-size: 80%; text-align: right; background-color: #009ACE; color: #eeeeee; margin-top: 10px; padding: 2px; border-bottom-style: solid; border-bottom-width: 2px; border-top-style: solid; border-top-width: 2px; border-color: #999999; }
              #ReportFooter a { color: #ffffff; text-decoration: none; }
            </style>
        """
        return css

    @staticmethod
    def cabecalho_fim():
        cabecalho_fim = """</head>"""
        return cabecalho_fim

    @staticmethod
    def corpo():
        corpo = """
            <body>
            """
        return corpo

    @staticmethod
    def divreportheader(value, data):
        divreportheader = '\n<div id="ReportHeader"><h1>%s</h1><b>Relatorio gerado: </b>%s<br />\
                        </div>' % (value, data)
        return divreportheader

    @staticmethod
    def divereportnotes(value):
        divereportnotes = '\n<div id="ReportNotes"><br />%s.</div>' % value
        return divereportnotes

    @staticmethod
    def detatils(titulo):
        details = '<div id="ReportDetails">\
            <h2> ' + titulo + ' </h2>\
                <table>\
                    <tbody>\
                    <tr>\
                        <th class="ReportTableHeaderCell" width="25%" style="font-size: 12px; ">Biblioteca</th>\
                        <th class="ReportTableHeaderCell" width="25%" style="font-size: 12px; ">Versão</th>\
                    <tr>'
        return details

    @staticmethod
    def detatils_fechado(titulo):
        details_fechado = '<div id="ReportDetails">\
            <h2> ' + titulo + ' </h2>\
                <table>\
                    <tbody>\
                    <tr>\
                        <th class="ReportTableHeaderCell" width="25%" style="font-size: 12px; ">Atendimento</th>\
                        <th class="ReportTableHeaderCell" width="25%" style="font-size: 12px; ">Titulo</th>\
                        <th class="ReportTableHeaderCell" width="25%" style="font-size: 12px; ">Categoria</th>\
                        <th class="ReportTableHeaderCell" width="25%" style="font-size: 12px; ">Versão</th>\
                        <th class="ReportTableHeaderCell" width="25%" style="font-size: 12px; ">Homologador</th>\
                        <th class="ReportTableHeaderCell" width="25%" style="font-size: 12px; ">Fechado </th>\
                    <tr>'
        return details_fechado

    @staticmethod
    def detatils_total_homologador(titulo):
        details_total_homologador = '<div id="ReportDetails">\
            <h2> ' + titulo + ' </h2>\
                <table>\
                    <tbody>\
                    <tr>\
                        <th class="ReportTableHeaderCell" width="25%" style="font-size: 12px; ">Homologador</th>\
                        <th class="ReportTableHeaderCell" width="25%" style="font-size: 12px; ">Quantidade</th>\
                    <tr>'
        return details_total_homologador

    @staticmethod
    def detatils_total_categoria(titulo):
        details_total_categoria = '<div id="ReportDetails">\
            <h2> ' + titulo + ' </h2>\
                <table>\
                    <tbody>\
                    <tr>\
                        <th class="ReportTableHeaderCell" width="25%" style="font-size: 12px; ">Categoria</th>\
                        <th class="ReportTableHeaderCell" width="25%" style="font-size: 12px; ">Quantidade</th>\
                    <tr>'
        return details_total_categoria

    @staticmethod
    def detatils_total_data(titulo):
        details_total_data = '<div id="ReportDetails">\
            <h2> ' + titulo + ' </h2>\
                <table>\
                    <tbody>\
                    <tr>\
                        <th class="ReportTableHeaderCell" width="25%" style="font-size: 12px; ">Data</th>\
                        <th class="ReportTableHeaderCell" width="25%" style="font-size: 12px; ">Quantidade</th>\
                    <tr>'
        return details_total_data

    @staticmethod
    def fimdetails_fechado():
        fim_details_fechado = '\
                             </tbody> \
                            </table'
        return fim_details_fechado

    @staticmethod
    def gerabiblioteca(bibliotecas):
        tr = ''
        for biblioteca in bibliotecas:
            tr += """<tr class="ReportDetailsEvenDataRow">
                        <td class="ReportTableValueCell">%s</td>
                        <td class="ReportTableValueCell"><a href="%s">%s</a></td>
                     </tr>
                  """ % (biblioteca,
                         bibliotecas.get(biblioteca)[1],
                         bibliotecas.get(biblioteca)[0])

        return tr

    @staticmethod
    def fim_details_biblioteca():
        fim_details = '</tbody>' \
                      '</table>'
        return fim_details

    @staticmethod
    def details_atendimento():
        details = '<h2>Atendimentos:</h2>\
                             <table>\
                                <tr>\
                                  <th class="ReportTableHeaderCell" width="25%">Atendimento</th>\
                                  <th class="ReportTableHeaderCell" width="25%">Título</th>\
                                  <th class="ReportTableHeaderCell" width="25%">Categoria</th>\
                                  <th class="ReportTableHeaderCell" width="25%">Atividade Pai</th>\
                                  <th class="ReportTableHeaderCell" width="25%">Parceiro</th>\
                                </tr>'
        return details

    @staticmethod
    def details_atendimento_versao_cliente():
        details = '<h2>Atendimentos:</h2>\
                             <table>\
                                <tr>\
                                  <th class="ReportTableHeaderCell" width="25%">Atendimento</th>\
                                  <th class="ReportTableHeaderCell" width="25%">Título</th>\
                                  <th class="ReportTableHeaderCell" width="25%">Categoria</th>\
                                </tr>'
        return details

    @staticmethod
    def tr():
        tr = '<tr class="ReportDetailsEvenDataRow">'
        return tr

    @staticmethod
    def fim_tr():
        fim_tr = '</tr>'
        return fim_tr

    @staticmethod
    def fim_table():
        fim_table = '</table>'
        return fim_table

    @staticmethod
    def fim_br():
        fim_br = '<br />'
        return fim_br

    @staticmethod
    def fim_div():
        fim_div = '</div>'
        return fim_div

    @staticmethod
    def reportfooter():
        reportfooter = """
                        <div id="ReportFooter">
                        <a href="http://www.siginformatica.com.br" target="_blank">Sig Soluções em Informática</a></div>
                       """
        return reportfooter

    @staticmethod
    def fim_body():
        fim_body = '</body>'
        return fim_body

    @staticmethod
    def fim_html():
        fim_html = '</html>'
        return fim_html
