#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class wizard_gerar_documentacao_bibliotecas(osv.TransientModel):
    _name = 'wizard.gerar.documentacao.bibliotecas'
    _rec_name = 'biblioteca_id'
    _columns = {
        'biblioteca_id': fields.many2one('versionamento.biblioteca', 'Biblioteca',
                                         ondelete='cascade'),
        'versao': fields.char('Versao', size=8),
        'link': fields.char('Link', size=160),
        'wiz_gerar_documentacao_capa_id': fields.many2one('wizard.gerar.documentacao',
                                                          'Documentacao capa', ondelete="cascade")
    }

    def onchange_versao(self, cr, uid, ids, versao, link_id, biblioteca_id, context=None):
        context = context and context.copy() or {}
        if not versao or not link_id or not biblioteca_id:
            return {}
        link = self.pool.get('versionamento.link').read(cr, uid, link_id, {'name'},
                                                        context=context).get('name') or ''
        biblioteca = self.pool.get('versionamento.biblioteca').read(
            cr, uid, biblioteca_id, ['name'], context=context)
        if link[-1] != u'/':
            link += '/'
        if '.' in versao:
            codigo_versao = '.'.join(versao.split('.')[:-1])
        else:
            codigo_versao = versao.split()[0]
        link = link + biblioteca.get('name').lower() + '/' + codigo_versao + \
            '/' + biblioteca.get('name').split('-')[-1].lower() + '-' + versao + '.tar.gz'
        return {'value': {'link': link}}
