#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class wizard_gerar_versao_bibliotecas(osv.TransientModel):
    '''
    Prefixo: wizgvb
    '''
    _name = 'wizard.gerar.versao.bibliotecas'

    _columns = {
        'wizgvb_comando_id': fields.many2one('comando.svn', 'Comando', required=True),
        'diretorio_instalacao': fields.char('Diretorio instalacao', size=160, required=True),
        'comando_svn': fields.char('Comando SVN', size=160, required=True),
        'wiz_gerar_versao_capa_id': fields.many2one('wizard.gerar.versao',
                                                    'Versao capa', ondelete="cascade")
    }

    def onchange_comando_id(self, cr, uid, ids, usuario_servidor, comando_id, versao_id,
                            context=None):
        context = context and context.copy() or {}
        if not comando_id:
            return {'value': {'comando_svn': '',
                              'diretorio_instalacao': ''
                             }
                   }

        brw_comando = self.pool.get('comando.svn').browse(cr, uid, comando_id, context=context)
        comando = brw_comando.comsvn_comando_svn
        if usuario_servidor and '{usuario}' in comando:
            if not '{versao}' in comando:
                comando = comando.format(usuario=usuario_servidor)
            else:
                comando = comando.format(usuario=usuario_servidor,
                                         versao='{versao}')


        if versao_id and '{versao}' in comando:
            nome_versao = self.pool.get('crm_br.case.category2').\
                          browse(cr, uid, versao_id, context=context).name
            if not '{usuario}' in comando:
                comando = comando.format(versao=nome_versao)
            else:
                comando = comando.format(usuario='{usuario}',
                                         versao=nome_versao)

        res = {'comando_svn': comando,
               'diretorio_instalacao': brw_comando.comsvn_diretorio_instalacao}
        return {'value': res}