# -*- coding: utf-8 -*-
from distutils.command.config import config

from openerp.osv import osv, fields
from datetime import datetime
from openerp.tools.translate import _


class wizard_consulta_validacoes(osv.TransientModel):
    'PREFIXO: wizcva'
    _name = 'wizard.consulta.validacoes'

    _columns = {
        'wizcva_cliente_id': fields.many2one('financeiro.cliente', 'Cliente'),
        'wizcva_data_ini': fields.date('Validadoes a partir de'),
        'wizcva_data_fim': fields.date('Validade ate'),
        'wizcva_datalhe_ids': fields.one2many('wizard.consulta.validacoes.detalhe',
                                              'wizcvd_capa_id', 'Valicacoes')
    }

    def wizcva_button_limpar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_detalhe = self.pool.get('wizard.consulta.validacoes.detalhe')
        detalhe_ids = obj_detalhe.search(cr, uid, [], context=context)
        if detalhe_ids:
            obj_detalhe.unlink(cr, uid, detalhe_ids, context=context)

        return True

    def wizcva_button_pesquisar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        load = '_classic_write'
        filtros = self.read(cr, uid, ids[0], [], context, load)
        obj_validacao = self.pool.get('sig.cliente.validacao')
        obj_detalhe = self.pool.get('wizard.consulta.validacoes.detalhe')
        detalhe_ids = obj_detalhe.search(cr, uid, [], context=context)
        if detalhe_ids:
            obj_detalhe.unlink(cr, uid, detalhe_ids, context=context)

        args = []
        if filtros.get('wizcva_cliente_id'):
            args.append(('sigclv_cliente_id', '=', filtros.get('wizcva_cliente_id')))
        if filtros.get('wizcva_data_ini'):
            args.append(('create_date', '>=', '%s 00:00:00' % filtros.get('wizcva_data_ini')))
        if filtros.get('wizcva_data_fim'):
            args.append(('sigclv_valido_ate', '>=', '%s 00:00:00' % datetime.now().date()))
            args.append(('sigclv_valido_ate', '<=', '%s 23:59:59' % filtros.get('wizcva_data_fim')))

        validaxao_ids = obj_validacao.search(cr, uid, args, context=context)
        if not validaxao_ids:
            raise osv.except_osv(_('Atencao!'),
                                 _('Nenhum registro encontrado com os filtros selecionados!'))

        dict_vals = {}
        for i in obj_validacao.read(cr, uid, validaxao_ids, [], context, load):
            if not dict_vals.get(i.get('sigclv_cliente_id')):
                dict_vals[i.get('sigclv_cliente_id')] = i

            elif dict_vals.get(i.get('sigclv_cliente_id')).get('id') < i.get('id'):
                dict_vals[i.get('sigclv_cliente_id')] = i

        for i in dict_vals.values():
            vals = {'wizcvd_capa_id': ids[0],
                    'wizcvd_cliente_id': i.get('sigclv_cliente_id'),
                    'wizcvd_data_validacao': i.get('create_date'),
                    'wizcvd_data_validade': i.get('sigclv_valido_ate'),
                    'wizcvd_licenca': i.get('sigclv_licensa'),
                    }
            obj_detalhe.create(cr, uid, vals, context=context)

        return True




class wizard_consulta_validacoes_detalhe(osv.TransientModel):
    'PREFIXO: wizcvd'

    _name = 'wizard.consulta.validacoes.detalhe'
    _columns = {
        'wizcvd_capa_id': fields.many2one('wizard.consulta.validacoes', 'Capa'),
        'wizcvd_cliente_id': fields.many2one('financeiro.cliente', 'Cliente'),
        'wizcvd_data_validacao': fields.date('Data da validacao'),
        'wizcvd_data_validade': fields.date('Valido ate'),
        'wizcvd_licenca': fields.char('Licenca', size=128)
    }


