# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class convenio_categoria(osv.Model):
    """
    Cadastro de categoria de convenio
    prefixo:covcat
    """
    _name = 'convenio.categoria'
    _columns = {
        'name': fields.char('Descricao', required=True),
        'covcat_categoria_pai_id': fields.many2one("convenio.categoria", 'Categoria pai',
                                                   ondelete="restrict", select=True ),
        'covcat_categoria_ids': fields.one2many('convenio.categoria', 'covcat_categoria_pai_id',
                                                'Categoria'),
        'covcat_convenio_ids': fields.one2many('convenio.convenio', 'covcov_categoria_id',
                                               'Convenio'),
    }

    _sql_constraints = [
        ('name_uniq', 'unique (name, covcat_categoria_pai_id)', 'Esta categoria ja existe '
                                                                'para a categoria pai '),
    ]
