# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class convenio_convenio(osv.Model):
    """
    Cadastro de convenios
    """
    _inherits = {
        'adm.pessoa': 'covcov_conveniado_id'
    }
    _name = 'convenio.convenio'
    _rec_name = 'covcov_descricao'
    _columns = {
        'id': fields.integer('id', readonly=True),
        'covcov_conveniado_id': fields.many2one("adm.pessoa", 'Conveniado', ondelete="restrict",
                                                required=True, select=True),
        'covcov_data_inicio': fields.date('Data de inicio', required=True),
        'covcov_data_fim': fields.date('Data final'),
        'covcov_descricao': fields.char('Descricao', size=45, required=True),
        'active': fields.boolean('Ativo'),
        'covcov_categoria_id': fields.many2one("convenio.categoria", 'Categoria',
                                               ondelete="restrict", select=True),
        'covcov_observacao': fields.text('Observacao'),
        'covcov_dia_pagto': fields.integer('Dia do pagto', help="Dia do pagamento ao conveniado"),
        'covcov_confirmar_uso': fields.boolean('Confirmar uso',
                                               help="Informa se e necessario confirmar o uso"),
        'covcov_usuarios_ids': fields.one2many('convenio.usuarios', 'covusa_convenio_id',
                                               'Usuarios'),
        'covcov_item_ids': fields.one2many('convenio.item', 'covite_convenio_id', 'Itens'),
        'covcov_guia_ids': fields.one2many('convenio.guia', 'covgia_convenio_id', 'Guias'),
    }

    _defaults = {
        'covcov_data_inicio': lambda *a: time.strftime('%Y-%m-%d'),
        'active': lambda *a: True,
        'pessoa_tipo': lambda *a: 'J',
    }

