# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class convenio_dependente(osv.Model):
    """
    Cadastro de dependentes
    Prefixo: covdep
    """
    _inherits = {
        'adm.pessoa': 'covdep_dependente_id'
    }
    _name = 'convenio.dependente'
    _columns = {
        'covdep_usuario_id': fields.many2one("convenio.usuarios", 'Usuario', ondelete="cascade",
                                             required=True, select=True),
        'covdep_dependente_id': fields.many2one("adm.pessoa", 'Dependente', ondelete="restrict",
                                                required=True, select=True),
        'active': fields.boolean('Ativo'),
        'covdep_data_inicio': fields.date('Data de inicio', required=True),
        'covdep_data_afastamento': fields.date('Data de afastamento'),
        'covdep_guia_ids': fields.one2many('convenio.guia', 'covgia_dependente_id', 'Guias'),
    }
    _defaults = {
        'covdep_data_inicio': lambda *a: time.strftime('%Y-%m-%d'),
        'active': lambda *a: True,
    }

