# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class convenio_item(osv.Model): 
    """
    Cadastro de itens dos convenios
    prefixo:covite
    """
    _name = 'convenio.item'
    _columns = {
        'name': fields.char('Item', size=45, required=True),
        'covite_convenio_id': fields.many2one("convenio.convenio", 'Convenio', ondelete="cascade", required=True, select=True),
        'covite_valor_usuario': fields.float('Valor usuario', help="Valor a ser cobrado do usuario!"),
        'covite_valor_conveniado': fields.float('Valor conveniado', help="Valor a ser pago ao conveniado!"),
        'covite_limite_mes': fields.integer('Limite mes'),
        'active': fields.boolean('Ativo'),
        'covite_observacao': fields.text('Observacao'),
    }
    _defaults = {
        'covite_limite_mes': lambda *a: 0,
        'active': lambda *a: True,
    }

