# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class convenio_usuarios(osv.Model):
    """
    Tabela de pessoas usuarias do convenio
    """
    _inherits = {
        'adm.pessoa': 'covusa_usuario_id'
    }
    _name = 'convenio.usuarios'
    _columns = {
        'covusa_convenio_id': fields.many2one("convenio.convenio", 'Convenio', ondelete="cascade",
                                              select=True),
        'covusa_usuario_id': fields.many2one("adm.pessoa", 'Usuario', ondelete="restrict",
                                             required=True, select=True,
                                             help="Identificacao do conveniado"),
        'covusa_data_inicio': fields.date('Data de inicio', required=True),
        'active': fields.boolean('Ativo'),
        'covusa_dependente_ids': fields.one2many('convenio.dependente', 'covdep_usuario_id',
                                                 'Dependente'),
        'covusa_guia_ids': fields.one2many('convenio.guia', 'covgia_usuario_id', 'Guias'),
    }
    _defaults = {
        'covusa_data_inicio': lambda *a: time.strftime('%Y-%m-%d'),
        'active': lambda *a: True,
    }
