# -*- encoding: utf-8 -*-

import time

from openerp.report import report_sxw
from openerp.osv import osv
from SigUtils.datas import sigDatas


class report_encaminhamento_medico(report_sxw.rml_parse):


    def __init__(self, cr, uid,name, context=None):
        context = context and context.copy() or {}
        super(report_encaminhamento_medico, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'data_extenso':self.data_extenso,
            'valor_total_fatura_usuario':self.valor_total_fatura_usuario(cr,uid,context=context)
        })

        obj_convenio_guia = self.pool.get('convenio.guia')
        brw_convenio_guia = obj_convenio_guia.browse(cr, uid, context.get('active_id'))
        state = brw_convenio_guia.state
        if state != 'A':
            titulo = 'Atencao!'
            msg = 'A guia deve estar ativa para que seja impresso o encaminhamento medico. '
            raise osv.except_osv(titulo, msg)

    def data_extenso(self,covgia_data):
        dia =  str(sigDatas(covgia_data).dia)
        mes = sigDatas(covgia_data).nomeDoMes
        ano = str(sigDatas(covgia_data).ano)
        data_por_extenso = dia + ' de ' + mes + ' de ' + ano
        return data_por_extenso

    def valor_total_fatura_usuario(self,cr,uid,context):
        obj_convenio_guia = self.pool.get('convenio.guia')
        brw_convenio_guia = obj_convenio_guia.browse(cr, uid, context.get('active_id'))
        valor_tot = 0
        faturamento_usuarios = brw_convenio_guia.covgia_faturamento_usuario_ids
        if faturamento_usuarios:
            for i in faturamento_usuarios:
                    valor_tot += i.valor
        else:
            brw_convenio_itens = brw_convenio_guia.covgia_guia_item_ids
            for x in brw_convenio_itens:
                valor_tot += x.covite_valor_usuario
        return valor_tot




report_sxw.report_sxw('report.convenio.guia', 'convenio.guia',
                      'addons/convenio/report/encaminhamento_medico.rml', parser=report_encaminhamento_medico, header=False)


