# -*- coding: utf-8 -*-
from openerp.osv import osv, fields


class wiz_confirmar_guia(osv.TransientModel):
    _name = 'wiz.confirmar.guia'
    _columns = {
        'convenio_id': fields.many2one('convenio.convenio', 'Convenio'),
        'usuario_id': fields.many2one('convenio.usuarios', 'Usuario'),
        'item_ids': fields.one2many('wiz.confirmar.guia.itens', 'capa_id', 'Guias'),
        'state': fields.selection([('E', 'Esboco'), ('P', 'Pesquisado')], 'Estado', size=1),
        'data': fields.date('Data da guia'),
    }
    _defaults = {
        'state': lambda *a: 'E',
    }

    def button_marcar_desmarcar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        brw_wizard = self.browse(cr, uid, ids[0], context)
        lista = []
        for item in brw_wizard.item_ids:
            values = {}
            if context.get('acao') == 'marcar':
                values['confirmar'] = True
            if context.get('acao') == 'desmarcar':
                values['confirmar'] = False
            if context.get('acao') == 'inverter':
                if item.confirmar:
                    values['confirmar'] = False
                else:
                    values['confirmar'] = True
            lista.append((1, item.id, values)) # Atualizar a tela
        self.write(cr, uid, ids[0], {'item_ids': lista}, context=context)
        return True

    def button_pesquisar_guia(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        brw_wizard = self.browse(cr, uid, ids[0], context)
        _usuario_id = brw_wizard.usuario_id.id
        _convenio_id = brw_wizard.convenio_id.id
        _data = brw_wizard.data
        args = []
        if _usuario_id:
            args.append(('covgia_usuario_id', '=', _usuario_id))
        if _convenio_id:
            args.append(('covgia_convenio_id', '=', _convenio_id))
        if _data:
            args.append(('covgia_data', '=', _data))

        # Filtrar apenas as guias que nao tem nenhum tipo de fatura: convenio, usuario ou A vista
        args.append(('covgia_faturamento_conveniado_ids', '=', False))
        args.append(('covgia_faturamento_usuario_ids', '=', False))
        args.append(('covgia_faturamento_avista_ids', '=', False))
        args.append(('covgia_quem_confirmou_id', '=', False))
        args.append(('state', '=', 'A'))
        obj_convenio_guia = self.pool.get('convenio.guia')
        items = []
        guia_ids = obj_convenio_guia.search(cr, uid, args, context=context)
        for guia_id in guia_ids:
            values = {'capa_id': ids[0]}
            values['guia_id'] = guia_id,
            values['confirmar'] = False
            items.append((0, 0, values)) # Incluir na tela as guias pesquisadas
        if guia_ids:
            self.write(cr, uid, ids[0], {'item_ids': items, 'state': 'P'}, context)
        return True

    def button_confirmar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        brw_wizard = self.browse(cr, uid, ids[0], context)
        lista = []
        items = []
        for item in brw_wizard.item_ids:
            if item.confirmar:
                lista.append(item.guia_id.id)
                items.append((2, item.id)) # remover da tela as guias confirmadas
        res = self.pool.get('convenio.guia').covgia_confirmar_guias(cr, uid, lista, context)
        self.write(cr, uid, ids[0], {'item_ids': items}, context=context)
        return res

class wiz_confirmar_guia_itens(osv.TransientModel):
    _name = 'wiz.confirmar.guia.itens'
    _inherits = {
        'convenio.guia': 'guia_id',
    }
    _columns = {
        'capa_id': fields.many2one('wiz.confirmar.guia', 'Capa', required=True, ondelete="cascade"),
        'guia_id': fields.many2one('convenio.guia', 'Guia', required=True, ondelete="cascade"),
        'confirmar': fields.boolean('Confirmar'),
    }
