# -*- coding: utf-8 -*-
from openerp.osv import osv, fields
from SigUtils import datas, formatastring
import time


class wiz_faturar_guia(osv.TransientModel):
    _name = 'wiz.faturar.guia'
    _columns = {
        'convenio_id': fields.many2one('convenio.convenio', 'Convenio'),
        'faturar_convenio': fields.boolean('Faturar convenio'),
        'faturar_usuario': fields.boolean('Faturar usuarios'),
        'usuario_id': fields.many2one('convenio.usuarios', 'Usuario'),
        'data_final': fields.date('Data final'),
        'vencimento_usuario': fields.date('Vencimento p/usuarios'),
        'valor_usuario': fields.float('Valor de usuario', readonly=True),
        'valor_convenio': fields.float('Valor do convenio', readonly=True),
        'item_ids': fields.one2many('wiz.faturar.guia.itens', 'capa_id', 'Guias'),
        'state': fields.selection([('E', 'Esboco'), ('P', 'Pesquisado'), ('F', 'Faturado')],
                                  'Estado', size=1),
    }
    _defaults = {
        'state': lambda *a: 'E',
    }

    def button_pesquisar_guia(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        brw_wizard = self.browse(cr, uid, ids[0], context)
        _usuario_id = brw_wizard.usuario_id.id
        _convenio_id = brw_wizard.convenio_id.id
        _necessita_confirmar = brw_wizard.convenio_id.covcov_confirmar_uso
        _data = brw_wizard.data_final
        faturar_convenio = brw_wizard.faturar_convenio
        faturar_usuario = brw_wizard.faturar_usuario
        args = []
        if _usuario_id:
            args.append(('covgia_usuario_id', '=', _usuario_id))
        if _convenio_id:
            args.append(('covgia_convenio_id', '=', _convenio_id))
        if _data:
            args.append(('covgia_data', '<=', _data))
        if _necessita_confirmar:
            args.append(('covgia_quem_confirmou_id', '!=', False))
        args.append(('state', '=', 'A'))
        obj_convenio_guia = self.pool.get('convenio.guia')
        items = []
        _valor_total_conveniado = 0
        _valor_total_usuario = 0
        _order = 'covgia_convenio_id,covgia_usuario_id,covgia_data'
        guia_ids = obj_convenio_guia.search(cr, uid, args, order=_order, context=context)
        brw_convenio_guia = obj_convenio_guia.browse(cr, uid,guia_ids,context=context)
        for guia in brw_convenio_guia:
            values = {'capa_id': ids[0]}
            values['guia_id'] = guia.id
            _valor_item_convenio = 0.00
            _valor_item_usuario = 0.00
            #  Verifica se existe algum registro de convenio fatura ou usuario faturdo para guia.
            #  Assim podendo filtrar apenas as guias que nao teve nenhuma fatura para se.
            fatura_convenio = guia.covgia_faturamento_conveniado_ids
            fatura_usuario = guia.covgia_faturamento_usuario_ids
            fatura_avista = guia.covgia_faturamento_avista_ids
            if not fatura_convenio and not fatura_usuario and not fatura_avista:
                for brw_guia_item in guia.covgia_guia_item_ids:
                    if faturar_convenio:
                        _valor_item_convenio += brw_guia_item.covite_valor_conveniado
                        _valor_total_conveniado += brw_guia_item.covite_valor_conveniado
                    if faturar_usuario:
                        _valor_item_usuario += brw_guia_item.covite_valor_usuario
                        _valor_total_usuario += brw_guia_item.covite_valor_usuario
                values['valor_conveniado'] = _valor_item_convenio
                values['valor_usuario'] = _valor_item_usuario
                if ((brw_wizard.faturar_convenio and _valor_total_conveniado) or
                        (brw_wizard.faturar_usuario and _valor_total_usuario)):
                    items.append((0, 0, values))  # Incluir na tela as guias pesquisadas
        vals = {
            'item_ids': items,
            'state': 'P',
            'valor_usuario': _valor_total_usuario,
            'valor_convenio': _valor_total_conveniado,
        }
        if items:
            self.write(cr, uid, ids[0], vals, context)
        return True

    def button_faturar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        def _faturar_usuario():
            _dados_titulo = {
                'parcela': 1,
                'vencimento': brw_wizard.vencimento_usuario,
                'valor': _valor_usuario,
            }
            _fatura_id = obj_financeiro_utils.financ_incluir_fatura(cr, uid,
                                                                    _ultimo_usuario,
                                                                    _data_hoje,
                                                                    _valor_usuario,
                                                                    'R',
                                                                    futl_fat_titulo_dados = [_dados_titulo],
            )
            for _guia in _lista_guias:
                obj_convenio_guia.write(cr, uid, _guia, {
                    'covgia_faturamento_usuario_ids': [(4, _fatura_id)]
                }, context=context)
            return True

        def _faturar_conveniado():
            _vencimento = datas.calcVencimento(_data_hoje, 0)
            _vencimento = _vencimento[:6] + formatastring.formataString(brw_wizard.convenio_id.covcov_dia_pagto, 2, '0', 'E')
            _dif = datas.calcDiferenca(_data_hoje, _vencimento)
            if _dif < 1:
                _ultimo_dia = str(datas.calcUltimoDiaDoMes(_data_hoje))
                _vencimento = _vencimento[:6] + _ultimo_dia
                _vencimento = datas.calcVencimento(_vencimento, brw_wizard.convenio_id.covcov_dia_pagto)
            _dados_titulo = {
                'parcela': 1,
                'vencimento': _vencimento,
                'valor': brw_wizard.valor_convenio,
            }
            _fatura_id = obj_financeiro_utils.financ_incluir_fatura(cr, uid,
                                                                    brw_wizard.convenio_id.covcov_conveniado_id.id,
                                                                    _data_hoje,
                                                                    brw_wizard.valor_convenio,
                                                                    'P',
                                                                    futl_fat_titulo_dados = [_dados_titulo],
                                                                    futl_fat_documento=str(_data_hoje),
            )
            for item in brw_wizard.item_ids:
                obj_convenio_guia.write(cr, uid, item.guia_id.id, {
                    'covgia_faturamento_conveniado_ids': [(4, _fatura_id)]
                }, context=context)
            return True

        brw_wizard = self.browse(cr, uid, ids[0], context)
        _data_hoje = time.strftime('%Y-%m-%d')
        obj_financeiro_utils = self.pool.get('financeiro')
        obj_convenio_guia = self.pool.get('convenio.guia')
        if brw_wizard.faturar_convenio and brw_wizard.valor_convenio:
            _faturar_conveniado()
        if brw_wizard.faturar_usuario:
            _ultimo_usuario = False
            _valor_usuario = 0
            _lista_guias = []
            for item in brw_wizard.item_ids:
                if not _ultimo_usuario:
                    _ultimo_usuario = item.guia_id.covgia_usuario_id.covusa_usuario_id.id
                if _ultimo_usuario == item.guia_id.covgia_usuario_id.covusa_usuario_id.id:
                    _valor_usuario += item.valor_usuario
                    _lista_guias.append(item.guia_id.id)
                    continue
                if _valor_usuario:
                    _faturar_usuario()
                _ultimo_usuario = item.guia_id.covgia_usuario_id.covusa_usuario_id.id
                _valor_usuario = item.valor_usuario
                _lista_guias = [item.guia_id.id]
            if _ultimo_usuario:
                _faturar_usuario()
        self.write(cr, uid, ids[0], {'state': 'F'}, context=context)
        return True


class wiz_faturar_guia_itens(osv.TransientModel):
    _name = 'wiz.faturar.guia.itens'
    _inherits = {
        'convenio.guia': 'guia_id',
    }
    _columns = {
        'capa_id': fields.many2one('wiz.faturar.guia', 'Capa', required=True, ondelete="cascade"),
        'guia_id': fields.many2one('convenio.guia', 'Guia', required=True, ondelete="cascade"),
        'valor_conveniado': fields.float('Valor conveniado', readonly=True),
        'valor_usuario': fields.float('Valor usuario', readonly=True),
    }
