# -*- encoding: utf-8 -*-

from openerp.osv import osv


class associacao_socios(osv.Model):
    '''Heranca de asssociacao socios'''

    _name = 'associacao.socios'
    _inherit = 'associacao.socios'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        # criando usuario do convenio
        context.update({'criacao_associado': True})
        obj_convenio_convenio = self.pool.get('convenio.convenio')
        res = super(associacao_socios, self).create(cr, uid, vals, context)
        obj_convenio_convenio.covcov_importar_associados(cr, uid, [], context)

        return res

    def write(self, cr, uid, ids, vals, context=None):

        context = context and context.copy() or {}


        # Atualizando o campo active para os usuarios do convenio
        if 'active' in vals:
            id = ids
            if isinstance(ids, list):
                id = ids[0]

            brw_associacao_socios = self.browse(cr, uid, id)
            socio_pessoa_id = brw_associacao_socios.asssoc_pessoa_id.id
            obj_convenio_usuarios = self.pool.get('convenio.usuarios')
            convenio_usuario_ids = obj_convenio_usuarios.search(cr, uid,
                                                                [('covusa_usuario_id', '=', socio_pessoa_id)],
                                                                context=context)
            if not convenio_usuario_ids:
                convenio_usuario_ids = obj_convenio_usuarios.search(cr, uid,
                                                                    [('covusa_usuario_id', '=', socio_pessoa_id),
                                                                     ('active', '=', False)], context=context)

            for i in convenio_usuario_ids:
                obj_convenio_usuarios.write(cr, uid, i, {'active': vals['active']}, context=context)

        res = super(associacao_socios, self).write(cr, uid, ids, vals, context)
        return res

    def unlink(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}

        # excluindo os usuarios q existem no convenio
        id = ids
        if isinstance(ids, list):
            id = ids[0]
        brw_associacao_socios = self.browse(cr, uid, id)
        socio_pessoa_id = brw_associacao_socios.asssoc_pessoa_id.id
        obj_convenio_usuarios = self.pool.get('convenio.usuarios')
        convenio_usuario_ids = obj_convenio_usuarios.search(cr, uid,
                                                            [('covusa_usuario_id', '=',
                                                              socio_pessoa_id)], context=context)
        for x in convenio_usuario_ids:
            obj_convenio_usuarios.unlink(cr, uid, x, context=context)
        res = super(associacao_socios, self).unlink(cr, uid, ids, context)
        return res
