# -*- encoding: utf-8 -*-

from openerp.osv import osv


class convenio_convenio(osv.Model):
    '''Heranca de convenio'''

    _name = 'convenio.convenio'
    _inherit = 'convenio.convenio'

    def covcov_importar_associados(self, cr, uid, ids, context=None):
        """
                Realiza a importação dos sócios para  para os usuários do módulo convênio
                :param cr:
                :param uid:
                :param context:
             """
        context = context and context.copy() or {}
        obj_convenio_usuarios = self.pool.get('convenio.usuarios')
        # Query para separar quais pessoas da associação ainda não existem para este convênio
        sql_convenio_associacao = '''select
                                         asssoc_pessoa_id as pessoa_id
                                     from
                                         associacao_socios
                                     where
                                         asssoc_pessoa_id not in
                                             (
                                                 select
                                                     covusa_usuario_id as pessoa_id
                                                 from
                                                     convenio_usuarios
                                              )
                                         and active = TRUE
                                    '''

        cr.execute(sql_convenio_associacao)
        pessoas_nao_incluidas = cr.dictfetchall()
        # criando usuários ainda não incluídos
        for p in pessoas_nao_incluidas:
            if not ids and context.get('criacao_associado'):
                obj_convenio_convenio = self.pool.get('convenio.convenio')
                ids = obj_convenio_convenio.search(cr, uid, [], context=context)
            for i in ids:
                obj_convenio_usuarios.create(cr, uid,
                                             {'covusa_usuario_id': p.get('pessoa_id'),
                                              'covusa_convenio_id': i}, context=context)

        # verificando pessoas não incluidas para aquele convenio
        if ids:
            convenio_id = ids[0]
            sql_todos = '''select distinct covusa_usuario_id from convenio_usuarios
                              where active = True and covusa_convenio_id is null or covusa_convenio_id != %s

                               EXCEPT ALL
                                  select distinct covusa_usuario_id
                                  from convenio_usuarios
                                  where covusa_convenio_id = %s

                           ''' % (convenio_id, convenio_id)

            cr.execute(sql_todos)
            pessoa_nao_incluidas_convenio = cr.dictfetchall()

            # Inserindo pessoas para o convenio selecionado
            for x in pessoa_nao_incluidas_convenio:
                obj_convenio_usuarios.create(cr, uid,
                                             {'covusa_usuario_id': x.get('covusa_usuario_id'),
                                              'covusa_convenio_id': convenio_id},
                                             context=context)

        return True
