# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

from openerp.osv import osv, fields

class cotacao_produtos(osv.Model):
    _name = 'cotacao.produtos'
    _rec_name = "codigo_produto"
    _columns = {
        'codigo_produto' : fields.char('Codigo produto', size=15, required=True),
        'produtos_grades_ids' : fields.one2many('cotacao.produtos.grades', 'produto_id','Grades'),
        'produtos_fornecedores_ids' : fields.many2many('financeiro.fornecedor','cotacao_fornecedores_produtos',
                        'produto_id', 'fornecedor_id','Fornecedores/Produtos'),
    }
cotacao_produtos()

class cotacao_produtos_grades(osv.Model):
    _name = 'cotacao.produtos.grades'
    _columns = {
        'produto_id' : fields.many2one("cotacao.produtos", 'Produto', ondelete="cascade", required=True, select = True),
        'grade' : fields.char('Grade', size=3, required=True),
        'name' : fields.char('Nome', size=40, required=True),
        'cotacoes_itens_ids' : fields.one2many('cotacao.cotacoes.itens', 'grade_id','Itens'),
    }
cotacao_produtos_grades()

class cotacao_produtos_fornecedores(osv.Model):
    _name = 'cotacao.produtos.fornecedores'
    _columns = {
        'fornecedor_id' : fields.many2one("financeiro.fornecedor", 'Fornecedor', ondelete="cascade", required=True, select = True),
        'produto_id' : fields.many2one("cotacao.produtos", 'Produto id', ondelete="cascade", required=True, select = True),
    }
cotacao_produtos_fornecedores()

