# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp import pooler
import base64
import re


def _get_cotacoes(self, cr, uid, context=None):
    context = context and context.copy() or {}
    req = cr.execute('SELECT distinct nro_cotacao, nro_cotacao from cotacao_cotacoes')
    res = cr.fetchall()
    return res


ask_form = '''<?xml version="1.0"?>
<form string="Exportar cotacao">
    <separator string="Cotacao a exportar" colspan="4"/>
    <!--<label string="Por favor, selecione o arquivo a exportar" colspan="4"/>-->
    <field name="nro_cotacao"/>
</form>
'''

ask_fields = {
    'nro_cotacao': {'string': 'Cotacao', 'type': 'selection', 'selection': _get_cotacoes, 'required': True},
}

view_form_end = """<?xml version="1.0"?>
    <form string="Salvar arquivo">
            <group colspan="2">
                <field name="file" colspan="2"/>
                <field name="data" filename="file"/>
            </group>
    </form>"""

view_fields_end = {'file': {'string': 'Arquivo', 'type': 'char', 'readonly': True},
                   'data': {'string': '', 'type': 'binary', 'readonly': True},
                   }


class exportar_cotacao_wizard(osv.TransientModel):
    _name = 'exportar.cotacao.wizard'

    def exportfile(self, cr, uid, data, context):
        print context
        _nro_cotacao = data['form']['nro_cotacao']
        oResultado = pooler.get_pool(cr.dbname).get('cotacao.resultado')
        _cotacao_ids = oResultado.search(cr, uid, [('nro_cotacao', '=', _nro_cotacao)], context=context)
        oResultadoItens = pooler.get_pool(cr.dbname).get('cotacao.resultado.itens')
        _resultadoItens_ids = oResultadoItens.search(cr, uid, [('resultado_id', '=', _cotacao_ids[0])], context=context)
        file_str = """"nro-cotacao","cgc-for","codigo-item","data-hora","prazo-entrega","validade","prazo1","prazo2","prazo3","prazo4","prazo5","prazo6","comprador","vendedor","cif-fob","transportadora","proposta-com","grade","valor","frete","icms","ipi","outros","desconto","encargos","garantia","despesa-aces","aprovado"\n"""
        for _resultadoItem_id in _resultadoItens_ids:
            oResultadoFornecedor = pooler.get_pool(cr.dbname).get('cotacao.resultado.fornecedores')
            _resultado_fornecedor_ids = oResultadoFornecedor.search(cr, uid,
                                                                    [('resultado_item_id', '=', _resultadoItem_id)],
                                                                    context=context)
            for _resultado_fornecedor_id in _resultado_fornecedor_ids:
                file_str += '"' + str(_nro_cotacao) + '",'
                file_str += '"' + re.sub('[^0-9]', '', oResultadoFornecedor.browse(cr, uid,
                                                                                   _resultado_fornecedor_id).fornecedor_id.pessoa_id.cpf_cnpj) + '",'
                file_str += '"' + str(
                    oResultadoItens.browse(cr, uid, _resultadoItem_id).grade_id.produto_id.codigo_produto) + '",'
                file_str += '"' + str(str(
                    oResultadoFornecedor.browse(cr, uid, _resultado_fornecedor_id).cotacao_item_id.data_hora)) + '",'
                file_str += '"' + str(oResultadoFornecedor.browse(cr, uid,
                                                                  _resultado_fornecedor_id).cotacao_item_id.cotacao_id.prazo_entrega) + '",'
                file_str += '"' + str(oResultadoFornecedor.browse(cr, uid,
                                                                  _resultado_fornecedor_id).cotacao_item_id.cotacao_id.validade) + '",'
                file_str += '"' + str(oResultadoFornecedor.browse(cr, uid,
                                                                  _resultado_fornecedor_id).cotacao_item_id.cotacao_id.prazo_pagto1) + '",'
                file_str += '"' + str(oResultadoFornecedor.browse(cr, uid,
                                                                  _resultado_fornecedor_id).cotacao_item_id.cotacao_id.prazo_pagto2) + '",'
                file_str += '"' + str(oResultadoFornecedor.browse(cr, uid,
                                                                  _resultado_fornecedor_id).cotacao_item_id.cotacao_id.prazo_pagto3) + '",'
                file_str += '"' + str(oResultadoFornecedor.browse(cr, uid,
                                                                  _resultado_fornecedor_id).cotacao_item_id.cotacao_id.prazo_pagto4) + '",'
                file_str += '"' + str(oResultadoFornecedor.browse(cr, uid,
                                                                  _resultado_fornecedor_id).cotacao_item_id.cotacao_id.prazo_pagto5) + '",'
                file_str += '"' + str(oResultadoFornecedor.browse(cr, uid,
                                                                  _resultado_fornecedor_id).cotacao_item_id.cotacao_id.prazo_pagto6) + '",'
                file_str += '"' + str(oResultadoFornecedor.browse(cr, uid,
                                                                  _resultado_fornecedor_id).cotacao_item_id.cotacao_id.comprador) + '",'
                file_str += '"",'
                file_str += '"' + str(oResultadoFornecedor.browse(cr, uid,
                                                                  _resultado_fornecedor_id).cotacao_item_id.cotacao_id.cif_fob) + '",'
                file_str += '"' + str(oResultadoFornecedor.browse(cr, uid,
                                                                  _resultado_fornecedor_id).cotacao_item_id.cotacao_id.transportadora) + '",'
                file_str += '"",'
                file_str += '"' + str(oResultadoItens.browse(cr, uid, _resultadoItem_id).grade_id.grade) + '",'
                file_str += '"' + str(
                    oResultadoFornecedor.browse(cr, uid, _resultado_fornecedor_id).cotacao_item_id.valor) + '",'
                file_str += '"' + str(
                    oResultadoFornecedor.browse(cr, uid, _resultado_fornecedor_id).cotacao_item_id.frete) + '",'
                file_str += '"' + str(
                    oResultadoFornecedor.browse(cr, uid, _resultado_fornecedor_id).cotacao_item_id.icms) + '",'
                file_str += '"' + str(
                    oResultadoFornecedor.browse(cr, uid, _resultado_fornecedor_id).cotacao_item_id.ipi) + '",'
                file_str += '"' + str(
                    oResultadoFornecedor.browse(cr, uid, _resultado_fornecedor_id).cotacao_item_id.outros) + '",'
                file_str += '"' + str(
                    oResultadoFornecedor.browse(cr, uid, _resultado_fornecedor_id).cotacao_item_id.descontos) + '",'
                file_str += '"' + str(
                    oResultadoFornecedor.browse(cr, uid, _resultado_fornecedor_id).cotacao_item_id.encargos) + '",'
                file_str += '"' + str(oResultadoFornecedor.browse(cr, uid,
                                                                  _resultado_fornecedor_id).cotacao_item_id.despesas_acessorias) + '",'
                file_str += '"' + str(
                    oResultadoFornecedor.browse(cr, uid, _resultado_fornecedor_id).cotacao_item_id.garantia_item) + '",'
                if oResultadoFornecedor.browse(cr, uid, _resultado_fornecedor_id).aprovado == True:
                    file_str += '"S"\n'
                else:
                    file_str += '"N"\n'
        file_str = file_str.replace('False', '')
        out = base64.encodestring(file_str)
        return {
            'file': 'cotaweb.csv',
            'data': out
        }

    states = {
        'init': {
            'actions': [],
            'result': {
                'type': 'form',
                'arch': ask_form,
                'fields': ask_fields,
                'state': [
                    ('end', 'Cancelar', 'gtk-cancel'),
                    ('export', 'Exportar cotacao', 'gtk-ok', True)
                ]
            }
        },
        'export': {
            'actions': [exportfile],
            'result': {
                'type': 'form',
                'arch': view_form_end,
                'fields': view_fields_end,
                'state': [('end', '_Concluir', 'gtk-ok')]
            }
        }
    }


exportar_cotacao_wizard()
