# -*- encoding: utf-8 -*-

from openerp.osv import osv
import csv
from openerp import pooler
from openerp import tools
import base64
import re
from mx import DateTime
from SigUtils.formatastring import formataString
from SigUtils.mod import mod
# ----------------------------------------------------------
# get logger
# ----------------------------------------------------------
from openerp import netsvc

finish_form = '''<?xml version="1.0"?>
<form string="Importacao concluida">
    <separator string="Cotacao importada com sucesso !" colspan="4"/>
    <field name="log_env" colspan="4"/>
    <field name="log_err" colspan="4"/>
</form>
'''
finish_fields = {
    'log_env': {'string': 'Emails enviados', 'type': 'char', 'readonly': True},
    'log_err': {'string': 'Emails nao-enviados', 'type': 'char', 'readonly': True},
}

ask_form = '''<?xml version="1.0"?>
<form string="Importar cotacao">
    <separator string="Cotacao a importar" colspan="4"/>
    <label string="Por favor, selecione o arquivo a importar" colspan="4"/>
    <field name="cotacao_file"/>
</form>
'''

ask_fields = {
    'cotacao_file': {
        'string': 'Arquivo de cotacao',
        'type': 'binary',
        'required': True
    }
}


class move_cotacao_wizard(osv.TransientModel):
    _name = 'move.cotacao.wizard'

    def importfile(self, cr, uid, data, context):
        logger = netsvc.Logger()
        html_text = """
                <!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
                <html>
                <head>
                  <meta http-equiv="content-type"
                 content="text/html; charset=ISO-8859-1">
                  <title>Cota&#231;&#227;o</title>
                  <meta content="text/html; charset=utf-8"
                 http-equiv="content-type">
                </head>
                <body>
                <table style="text-align: left; width: 726px; height: 126px;"
                 border="0" cellpadding="0" cellspacing="0">
                  <tbody>
                    <tr>
                      <td><a href="http://www.siginformatica.com.br/"><img
                 style="border: 0px solid ; width: 780px; height: 80px;"
                 alt="SIG Solu&#231;&#245;es"
                 src="http://www.siginformatica.com.br/cab1.jpg"></a></td>
                    </tr>
                    <tr>
                      <td> <span class="Apple-style-span"
                 style="border-collapse: separate; color: rgb(0, 0, 0); font-family: 'Times New Roman'; font-style: normal; font-variant: normal; font-weight: normal; letter-spacing: normal; line-height: normal; orphans: 2; text-indent: 0px; text-transform: none; white-space: normal; widows: 2; word-spacing: 0px; font-size: medium;"><span
                 class="Apple-style-span"
                 style="color: rgb(68, 68, 68); font-family: Tahoma,Verdana,Arial,sans-serif; font-size: 13px;"><span
                 class="ecxApple-style-span"
                 style="border-collapse: separate; color: rgb(0, 0, 0); font-family: 'Times New Roman'; font-style: normal; font-variant: normal; font-weight: normal; letter-spacing: normal; line-height: normal; text-indent: 0px; text-transform: none; white-space: normal; word-spacing: 0px; font-size: medium;"><span
                 class="ecxApple-style-span"
                 style="font-family: Arial; font-size: 12px;"><b
                 style="font-weight: bold;">
                      <div><span class="ecxApple-style-span"><br>
                      </span>
                      <div style="text-align: center;"><span
                 style="color: rgb(255, 153, 0);" class="ecxApple-style-span"><big>Coleta
                de pre&#231;os.</big></span><br>
                      <span class="ecxApple-style-span"></span></div>
                      <span class="ecxApple-style-span"><br>
                      </span></div>
                      <div><span class="ecxApple-style-span"
                 style="font-weight: normal;"><br>
                      </span></div>
                      <div><span class="ecxApple-style-span"
                 style="font-weight: normal;">Caro Fornecedor,</span></div>
                      <div><span class="ecxApple-style-span"
                 style="font-weight: normal;"><br>
                      </span></div>
                      <div><span class="ecxApple-style-span"
                 style="font-weight: normal;">Solicitamos acessar o link
                abaixo para o fornecimento de pre&#231;os e
                condi&#231;&#245;es.</span></div>
                      <div><span class="ecxApple-style-span"
                 style="font-weight: normal;"><br>
                      </span></div>
                      <div><span class="ecxApple-style-span"
                 style="font-weight: normal;"><a
                 href="http://192.168.1.77:8080/form/edit?model=cotacao.cotacoes&#38;id=%s&#38;context={'id_fornecedor':%s}&#38;db=teste&#38;user=admin&#38;password=admin"
                 target="_blank"
                 style="font-weight: inherit; text-decoration: underline; color: rgb(0, 104, 207); cursor: pointer;">Cota&#231;&#227;o
                N&#250;mero: %s</a><br>
                      </span></div>
                      <div><span class="ecxApple-style-span"
                 style="font-weight: normal;"><br>
                Agradecemos a sua aten&#231;&#227;o!</span></div>
                      <div><span class="ecxApple-style-span"
                 style="font-weight: normal;"><br>
                      </span></div>
                      <div><span class="ecxApple-style-span"
                 style="font-weight: normal;"><br>
                      </span></div>
                      </b></span></span><span
                 class="ecxApple-style-span"
                 style="border-collapse: separate; color: rgb(0, 0, 0); font-family: arial,sans-serif; font-style: normal; font-variant: normal; font-weight: normal; letter-spacing: normal; line-height: normal; text-indent: 0px; text-transform: none; white-space: normal; word-spacing: 0px; font-size: small;"><span
                 class="ecxApple-style-span" style="border-collapse: collapse;"><span
                 style="font-style: italic;"></span><span
                 style="font-style: italic;"></span></span></span></span></span></td>
                    </tr>
                    <tr
                 style="color: rgb(255, 255, 255); font-weight: bold; font-style: italic;"
                 align="center">
                      <td style="background-color: rgb(0, 0, 102);"><span
                 class="Apple-style-span"
                 style="border-collapse: separate; font-family: 'Times New Roman'; font-style: normal; font-variant: normal; font-weight: normal; letter-spacing: normal; line-height: normal; orphans: 2; text-indent: 0px; text-transform: none; white-space: normal; widows: 2; word-spacing: 0px; font-size: medium;"><span
                 class="Apple-style-span"
                 style="font-family: Tahoma,Verdana,Arial,sans-serif; font-size: 13px;"><span
                 class="ecxApple-style-span"
                 style="border-collapse: separate; font-family: arial,sans-serif; font-style: normal; font-variant: normal; font-weight: normal; letter-spacing: normal; line-height: normal; text-indent: 0px; text-transform: none; white-space: normal; word-spacing: 0px; font-size: small;"><span
                 class="ecxApple-style-span" style="border-collapse: collapse;"><span
                 style="font-weight: bold;">Rua
                Jo&#227;o Pereira Amorim, 700 - Jardim Arizona :: Sete Lagoas -
                MG, 35700-000</span><br>
                      </span></span></span></span><span
                 class="Apple-style-span"
                 style="font-family: Tahoma,Verdana,Arial,sans-serif; font-size: 13px;"><span
                 class="ecxApple-style-span"
                 style="border-collapse: separate; font-family: 'Times New Roman'; font-style: normal; font-variant: normal; font-weight: normal; letter-spacing: normal; line-height: normal; text-indent: 0px; text-transform: none; white-space: normal; word-spacing: 0px; font-size: medium;"><span
                 class="ecxApple-style-span"
                 style="font-family: Arial; font-size: 12px;">
                      <div style="font-weight: bold;"><small><span
                 class="ecxApple-style-span" style="font-weight: normal;"><span
                 style="font-weight: bold;">CNPJ: 02.124.589.125/0001-45</span></span></small></div>
                      <div style="font-weight: bold;"><span
                 class="ecxApple-style-span" style="font-weight: normal;"><small><span
                 style="font-weight: bold;">I.E: 12.145.254-541</span></small></span></div>
                      </span></span></span></td>
                    </tr>
                  </tbody>
                </table>
                <br>
                </body>
                </html>
        """

        html_text_2 = """
                    <!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
                    <html>
                    <head>
                      <meta content="text/html; charset=ISO-8859-1"
                     http-equiv="content-type">
                      <title></title>
                    </head>
                    <body>
                    <meta http-equiv="content-type"
                     content="text/html; charset=utf-8">
                    <span class="Apple-style-span"
                     style="border-collapse: separate; color: rgb(0, 0, 0); font-family: 'Times New Roman'; font-style: normal; font-variant: normal; font-weight: normal; letter-spacing: normal; line-height: normal; orphans: 2; text-indent: 0px; text-transform: none; white-space: normal; widows: 2; word-spacing: 0px; font-size: medium;"><span
                     class="Apple-style-span"
                     style="font-family: Arial; font-size: 12px;"><b>
                    <div><span class="Apple-style-span">Coleta de
                    pre&ccedil;os.<br>
                    <br>
                    </span></div>
                    <div><span class="Apple-style-span"
                     style="font-weight: normal;"><br>
                    </span></div>
                    <div><span class="Apple-style-span"
                     style="font-weight: normal;">Caro Fornecedor,</span></div>
                    <div><span class="Apple-style-span"
                     style="font-weight: normal;"><br>
                    </span></div>
                    <div><span class="Apple-style-span"
                     style="font-weight: normal;">Solicitamos acessar o link
                    abaixo para o fornecimento de pre&ccedil;os e
                    condi&ccedil;&otilde;es.</span></div>
                    <div><span class="Apple-style-span"
                     style="font-weight: normal;"><br>
                    </span></div>
                    <div><span class="Apple-style-span"
                     style="font-weight: normal;"><a
                     href="http://www.sig.inf.br:8081/tree/open?model=ir.ui.menu&amp;id=113&amp;db=teste&amp;user=cotaweb&amp;password=cotaweb123&amp;cotacao=%s">Cota&ccedil;&atilde;o
                    N&uacute;mero: %s</a><br>
                    </span></div>
                    <div><span class="Apple-style-span"
                     style="font-weight: normal;"><br>
                    </span></div>
                    <div><span class="Apple-style-span"
                     style="font-weight: normal;"><br>
                    <br>
                    Agradecemos a sua aten&ccedil;&atilde;o!</span></div>
                    <div><span class="Apple-style-span"
                     style="font-weight: normal;"><br>
                    </span></div>
                    <div><span class="Apple-style-span"
                     style="font-weight: normal;"><br>
                    </span></div>
                    <div style="color: rgb(0, 0, 153); font-weight: bold;"><big><big><big><span
                     class="Apple-style-span" style="font-weight: normal;">SIG
                    Solu&ccedil;&otilde;es</span></big></big></big></div>
                    <div><small><span class="Apple-style-span"
                     style="font-weight: normal;">CNPF: 02.124.589.125/0001-45</span></small></div>
                    <div><span class="Apple-style-span"
                     style="font-weight: normal;"><small>I.E: 12.145.254-541</small><br>
                    </span></div>
                    <div><span class="Apple-style-span"
                     style="font-weight: normal;"><br>
                    </span></div>
                    </b></span></span>
                    <meta http-equiv="content-type"
                     content="text/html; charset=utf-8">
                    <span class="Apple-style-span"
                     style="border-collapse: separate; color: rgb(0, 0, 0); font-family: arial,sans-serif; font-style: normal; font-variant: normal; font-weight: normal; letter-spacing: normal; line-height: normal; orphans: 2; text-indent: 0px; text-transform: none; white-space: normal; widows: 2; word-spacing: 0px; font-size: small;"><span
                     class="Apple-style-span" style="border-collapse: collapse;"><span
                     style="font-style: italic;">Rua Jo&atilde;o Pereira
                    Amorim, 700</span><br style="font-style: italic;">
                    <span style="font-style: italic;">Jardim Arizona</span><br
                     style="font-style: italic;">
                    <span style="font-style: italic;">Sete Lagoas - MG,
                    35700-000</span><br>
                    </span></span>
                    </body>
                    </html>
        """
        lst_email = []
        empresa_id = 1
        content = base64.decodestring(data['form']['cotacao_file'])
        _arq = '/tmp/cotacao_' + DateTime.now().strftime('%Y%m%d_%H%M%S') + '.tmp'
        fp = file(_arq, 'w').write(content)
        linhas = csv.DictReader(open(_arq), delimiter=';')
        for linha in linhas:
            oPessoa = pooler.get_pool(cr.dbname).get('pessoa.pessoa')
            _cnpj = linha['Cnpj Fornec.'].strip()[1:]
            pessoa_ids = oPessoa.search(cr, uid, [('cpf_cnpj', '=', _cnpj)], context=context)
            if not pessoa_ids:
                pessoa = {'cpf_cnpj': _cnpj,
                          'name': linha['Nome for.'].strip(),
                          'pessoa_tipo': linha['Tipo'].strip()
                          }
                pessoa_id = oPessoa.create(cr, uid, pessoa, context)
            else:
                pessoa_id = pessoa_ids[0]

            oEmail = pooler.get_pool(cr.dbname).get('pessoa.email')
            email_ids = oEmail.search(cr, uid, [('name', '=', linha['email'].strip()), ('pessoa_id', '=', pessoa_id)],
                                      context=context)
            if not email_ids:
                email = {'pessoa_id': pessoa_id,
                         'email_tipo_id': 1,
                         'name': linha['email'].strip(),
                         }
                email_id = oEmail.create(cr, uid, email, context)
            else:
                email_id = email_ids[0]

            oFornecedor = pooler.get_pool(cr.dbname).get('financeiro.fornecedor')
            fornecedor_ids = oFornecedor.search(cr, uid,
                                                [('pessoa_id', '=', pessoa_id), ('empresa_id', '=', empresa_id)],
                                                context=context)
            if not fornecedor_ids:
                fornecedor = {'pessoa_id': pessoa_id,
                              'empresa_id': empresa_id
                              }
                fornecedor_id = oFornecedor.create(cr, uid, fornecedor, context)
            else:
                fornecedor_id = fornecedor_ids[0]

            oProduto = pooler.get_pool(cr.dbname).get('cotacao.produtos')
            produto_ids = oProduto.search(cr, uid, [('codigo_produto', '=', linha['Codigo item'].strip())],
                                          context=context)
            if not produto_ids:
                produto = {'codigo_produto': linha['Codigo item'].strip()}
                produto_id = oProduto.create(cr, uid, produto, context)
            else:
                produto_id = produto_ids[0]

            oGrade = pooler.get_pool(cr.dbname).get('cotacao.produtos.grades')
            grade_ids = oGrade.search(cr, uid,
                                      [('produto_id', '=', produto_id), ('grade', '=', linha['Grade'].strip())],
                                      context=context)
            if not grade_ids:
                grade = {'produto_id': produto_id,
                         'grade': linha['Grade'].strip(),
                         'name': linha['Nome Item'].strip()
                         }
                grade_id = oGrade.create(cr, uid, grade, context)
            else:
                grade_id = grade_ids[0]

            oCotacao = pooler.get_pool(cr.dbname).get('cotacao.cotacoes')
            cotacao_ids = oCotacao.search(cr, uid, [('nro_cotacao', '=', linha['Requisicao'].strip('0')),
                                                    ('fornecedor_id', '=', fornecedor_id),
                                                    ('empresa_id', '=', empresa_id)], context=context)
            oEmpresa = pooler.get_pool(cr.dbname).get('adm.empresa.objeto')
            _cnpj_cliente = oEmpresa.browse(cr, uid, empresa_id).pessoa_id.cpf_cnpj
            _cnpj_cliente = re.sub('[^0-9]', '', _cnpj_cliente)
            _cnpj_fornecedor = oFornecedor.browse(cr, uid, fornecedor_id).pessoa_id.cpf_cnpj
            _cnpj_fornecedor = re.sub('[^0-9]', '', _cnpj_fornecedor)
            _cotacao = linha['Requisicao'].strip()
            peso = '12345678901234'
            resultado_AAA = 0
            i = 0
            for a in _cnpj_cliente:
                resultado_AAA = resultado_AAA + (int(peso[i:i + 1]) * int(a))
                i = i + 1
            resultado_BBB = 0
            i = 0
            for a in _cnpj_fornecedor:
                resultado_BBB = resultado_BBB + (int(peso[i:i + 1]) * int(a))
                i = i + 1
            resultado_CC = 0
            i = 0
            for a in _cotacao:
                resultado_CC = resultado_CC + (int(peso[i:i + 1]) * int(a))
                i = i + 1
            resultado_AAA = formataString(str(resultado_AAA), 5, '0', 'E')[2:5]
            resultado_BBB = formataString(str(resultado_BBB), 5, '0', 'E')[2:5]
            resultado_CC = formataString(str(resultado_CC), 5, '0', 'E')[3:5]
            _codigo = resultado_AAA + resultado_BBB + resultado_CC
            resultado = 0
            i = 0
            for a in _codigo:  # calcular digito verificador
                resultado = resultado + (int(peso[i:i + 1]) * int(a))
                i = i + 1
            if resultado < 10:
                _codigo = _codigo + str(resultado)
            else:
                _codigo = _codigo + str(int(mod(resultado, 10)))
            if not cotacao_ids:
                cotacao = {'fornecedor_id': fornecedor_id,
                           'empresa_id': empresa_id,
                           'nro_cotacao': linha['Requisicao'].strip(),
                           'algoritimo': _codigo,
                           'estado': 'I',
                           }
                cotacao_id = oCotacao.create(cr, uid, cotacao, context)
            else:
                cotacao_id = cotacao_ids[0]

            oCotacaoItem = pooler.get_pool(cr.dbname).get('cotacao.cotacoes.itens')
            cotacao_itens_ids = oCotacaoItem.search(cr, uid,
                                                    [('cotacao_id', '=', cotacao_id), ('grade_id', '=', grade_id)],
                                                    context=context)
            if not cotacao_itens_ids:
                cotacao_itens = {'cotacao_id': cotacao_id,
                                 'grade_id': grade_id,
                                 }
                cotacao_itens_id = oCotacaoItem.create(cr, uid, cotacao_itens, context)
            else:
                cotacao_itens_id = cotacao_itens_ids[0]

            tp = (cotacao_id, linha['email'].strip(), fornecedor_id)
            if tp not in lst_email:
                lst_email.append(tp)

        log_env = 0
        log_err = 0
        for mail in lst_email:
            cod_cotacao = mail[0]
            fornec = mail[2]

            email = mail[1]  # 'christian.alcantara@hotmail.com' #
            enviado = tools.email_send('SIG Solucoes', [email], 'Cotacao',
                                       html_text % (str(cod_cotacao), str(fornec), str(cod_cotacao)), subtype='html')
            if enviado:
                oCotacao.write(cr, uid, cod_cotacao, {'estado': 'E'}, context=context)
                log_env += 1
                logger.notifyChannel("email_send", netsvc.LOG_INFO,
                                     " O email -> %s com a cotacao No. %s. Enviado!!!" % (email, cod_cotacao))
            else:
                logger.notifyChannel("email_send", netsvc.LOG_WARNING,
                                     " O email -> %s com a cotacao No. %s. Nao enviado!!!" % (email, cod_cotacao))

        return {
            'log_env': str(log_env),
            'log_err': str(log_err)
        }

    states = {
        'init': {
            'actions': [],
            'result': {
                'type': 'form',
                'arch': ask_form,
                'fields': ask_fields,
                'state': [
                    ('end', 'Cancelar', 'gtk-cancel'),
                    ('create', 'Importar cotacao', 'gtk-ok', True)
                ]
            }
        },
        'create': {
            'actions': [importfile],
            'result': {
                'type': 'form',
                'arch': finish_form,
                'fields': finish_fields,
                'state': [('end', 'Fechar', 'gtk-quit')]
            }
        },

    }


move_cotacao_wizard()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
