# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


from openerp.osv import osv
from openerp import pooler


def _get_cotacoes(self, cr, uid, context=None):
    context = context and context.copy() or {}
    req = cr.execute('SELECT distinct nro_cotacao, nro_cotacao from cotacao_cotacoes')
    res = cr.fetchall()
    return res


finish_form = '''<?xml version="1.0"?>
<form string="resultado_cotacao">
    <label string="Resultado Gerado !" colspan="4"/>
</form>
'''

ask_form = '''<?xml version="1.0"?>
<form string="Gerar resultado">
    <separator string="Cotacao a gerar" colspan="4"/>
    <label string="Por favor, selecione uma cotacao para gerar o resultado" colspan="4"/>
    <field name="nro_cotacao"/>
</form>
'''

ask_fields = {
    'nro_cotacao': {'string': 'Cotacao', 'type': 'selection', 'selection': _get_cotacoes, 'required': True},
}


class resultado_cotacao_wizard(osv.TransientModel):
    _name = 'resultado.cotacao.wizard'

    def gerar_resultado(self, cr, uid, data, context):
        pool = pooler.get_pool(cr.dbname)
        _nroCotacao = data['form']['nro_cotacao']
        oCotacao = pool.get('cotacao.cotacoes')
        _cotacao_ids = oCotacao.search(cr, uid, [('nro_cotacao', '=', _nroCotacao)], context=context)
        _data_importacao = oCotacao.read(cr, uid, _cotacao_ids, ['data_importacao'], context=context)[0][
            'data_importacao']

        oResultado = pool.get('cotacao.resultado')
        resultado_id = oResultado.search(cr, uid, [('nro_cotacao', '=', _nroCotacao)], context=context)
        if not resultado_id:
            resultado = {'nro_cotacao': _nroCotacao,
                         'data_importacao': _data_importacao,
                         }
            resultado_id = oResultado.create(cr, uid, resultado, context)
        else:
            resultado_id = resultado_id[0]

        for _cotacao_id in _cotacao_ids:
            oCotacaoItens = pool.get('cotacao.cotacoes.itens')
            cotacaoItens_ids = oCotacaoItens.search(cr, uid, [('cotacao_id', '=', _cotacao_id)], context=context)
            for id in cotacaoItens_ids:
                _gradeId = oCotacaoItens.browse(cr, uid, id).grade_id.id
                _fornecedorId = oCotacaoItens.browse(cr, uid, id).cotacao_id.fornecedor_id.id
                _total = oCotacaoItens.browse(cr, uid, id).total
                oResultadoItens = pool.get('cotacao.resultado.itens')
                resultadoItens_id = oResultadoItens.search(cr, uid,
                                                           [('resultado_id', '=', resultado_id),
                                                            ('grade_id', '=', _gradeId)], context=context)
                if not resultadoItens_id:
                    resultadoItens = {'resultado_id': resultado_id, 'grade_id': _gradeId}
                    resultadoItens_id = oResultadoItens.create(cr, uid, resultadoItens, context)
                else:
                    resultadoItens_id = resultadoItens_id[0]

                oResultadoFornecedor = pool.get('cotacao.resultado.fornecedores')
                resultadoFornecedores_id = oResultadoFornecedor.search(cr, uid,
                                                                       [('resultado_item_id', '=', resultadoItens_id),
                                                                        ('fornecedor_id', '=', _fornecedorId)],
                                                                       context=context)
                if not resultadoFornecedores_id:
                    resultadoFornecedores = {'resultado_item_id': resultadoItens_id,
                                             'fornecedor_id': _fornecedorId,
                                             'cotacao_item_id': id,
                                             'aprovado': False,
                                             'total': _total,
                                             }
                    resultadoFornecedores_id = oResultadoFornecedor.create(cr, uid, resultadoFornecedores, context)
                else:
                    vals = {'total': _total, 'aprovado': False}
                    oResultadoFornecedor.write(cr, uid, resultadoFornecedores_id, vals, context=context)
        return {}

    states = {
        'init': {
            'actions': [],
            'result': {
                'type': 'form',
                'arch': ask_form,
                'fields': ask_fields,
                'state': [
                    ('end', 'Cancelar', 'gtk-cancel'),
                    ('gerar', 'Gerar Resultado', 'gtk-ok', True)
                ]
            }
        },
        'gerar': {
            'actions': [gerar_resultado],
            'result': {
                'type': 'form',
                'arch': finish_form,
                'fields': {},
                'state': [('end', 'Fechar')]
            }
        },

    }


resultado_cotacao_wizard()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
