# -*- encoding: utf-8 -*-
from openerp.osv import osv
from openerp import pooler
from openerp import tools
from openerp import netsvc

html_text = """
        <!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
        <html>
        <head>
          <meta content="text/html; charset=ISO-8859-1"
         http-equiv="content-type">
          <title></title>
        </head>
        <body>
        <meta http-equiv="content-type"
         content="text/html; charset=utf-8">
        <span class="Apple-style-span"
         style="border-collapse: separate; color: rgb(0, 0, 0); font-family: 'Times New Roman'; font-style: normal; font-variant: normal; font-weight: normal; letter-spacing: normal; line-height: normal; orphans: 2; text-indent: 0px; text-transform: none; white-space: normal; widows: 2; word-spacing: 0px; font-size: medium;"><span
         class="Apple-style-span"
         style="font-family: Arial; font-size: 12px;"><b>
        <div><span class="Apple-style-span">Coleta de
        pre&ccedil;os.<br>
        <br>
        </span></div>
        <div><span class="Apple-style-span"
         style="font-weight: normal;"><br>
        </span></div>
        <div><span class="Apple-style-span"
         style="font-weight: normal;">Caro Fornecedor,</span></div>
        <div><span class="Apple-style-span"
         style="font-weight: normal;"><br>
        </span></div>
        <div><span class="Apple-style-span"
         style="font-weight: normal;">Solicitamos acessar o link
        abaixo para o fornecimento de pre&ccedil;os e
        condi&ccedil;&otilde;es.</span></div>
        <div><span class="Apple-style-span"
         style="font-weight: normal;"><br>
        </span></div>
        <div><span class="Apple-style-span"
         style="font-weight: normal;"><a
         href="http://www.sig.inf.br:8081/tree/open?model=ir.ui.menu&amp;id=113&amp;db=teste&amp;user=cotaweb&amp;password=cotaweb123&amp;cotacao=%s">Cota&ccedil;&atilde;o
        N&uacute;mero: %s</a><br>
        </span></div>
        <div><span class="Apple-style-span"
         style="font-weight: normal;"><br>
        </span></div>
        <div><span class="Apple-style-span"
         style="font-weight: normal;"><br>
        <br>
        Agradecemos a sua aten&ccedil;&atilde;o!</span></div>
        <div><span class="Apple-style-span"
         style="font-weight: normal;"><br>
        </span></div>
        <div><span class="Apple-style-span"
         style="font-weight: normal;"><br>
        </span></div>
        <div style="color: rgb(0, 0, 153); font-weight: bold;"><big><big><big><span
         class="Apple-style-span" style="font-weight: normal;">SIG
        Solu&ccedil;&otilde;es</span></big></big></big></div>
        <div><small><span class="Apple-style-span"
         style="font-weight: normal;">CNPF: 02.124.589.125/0001-45</span></small></div>
        <div><span class="Apple-style-span"
         style="font-weight: normal;"><small>I.E: 12.145.254-541</small><br>
        </span></div>
        <div><span class="Apple-style-span"
         style="font-weight: normal;"><br>
        </span></div>
        </b></span></span>
        <meta http-equiv="content-type"
         content="text/html; charset=utf-8">
        <span class="Apple-style-span"
         style="border-collapse: separate; color: rgb(0, 0, 0); font-family: arial,sans-serif; font-style: normal; font-variant: normal; font-weight: normal; letter-spacing: normal; line-height: normal; orphans: 2; text-indent: 0px; text-transform: none; white-space: normal; widows: 2; word-spacing: 0px; font-size: small;"><span
         class="Apple-style-span" style="border-collapse: collapse;"><span
         style="font-style: italic;">Rua Jo&atilde;o Pereira
        Amorim, 700</span><br style="font-style: italic;">
        <span style="font-style: italic;">Jardim Arizona</span><br
         style="font-style: italic;">
        <span style="font-style: italic;">Sete Lagoas - MG,
        35700-000</span><br>
        </span></span>
        </body>
        </html>
        """

def _sel_func(self, cr, uid, context=None):
    context = context and context.copy() or {}
    result = []
    obj = pooler.get_pool(cr.dbname).get('cotacao.cotacoes')
    ids = obj.search(cr, uid, [], context=context)
    res = obj.read(cr, uid, ids, ['nro_cotacao',], context=context)
    for i in res:
        if (i['nro_cotacao'], i['nro_cotacao']) not in result:
            result.append((i['nro_cotacao'], i['nro_cotacao']))
    return result


view_form_start = """<?xml version="1.0"?>
    <form string="Envio de emails">
            <field name="nro_cotacao" colspan="4"/>
            <field name="cotacoes" nolabel="1" domain="[('nro_cotacao', '=', nro_cotacao)]" colspan="4"/>
    </form>"""

view_fields_start = {
        'nro_cotacao': {
                    'string': 'No. Cotacao',
                    'type': 'selection',
                    'relation':'cotacao.cotacoes',
                    'required': True,
                    'selection': _sel_func
        },
        'cotacoes': {
                    'relation':'cotacao.cotacoes',
                    'rel': 'cotacao.cotacoes',
                    'field1':'fornecedor_id',
                    'field2':'fornecedor_id',
                    'string':'Cotacoes',
                    'type':'many2many',
                    'required': True
#                    'domain': [('nro_cotacao','=',data['form']['nro_cotacao'])]
        }
}

view_form_end = """<?xml version="1.0"?>
        <form string="Envio concluido">
            <group colspan="2">
                <separator string="Os emails foram enviados" colspan="4"/>
                <field name="log_env" colspan="4"/>
                <field name="log_err" colspan="4"/>
            </group>
        </form>
"""

view_fields_end = {
        'log_env': {'string': 'Emails enviados', 'type': 'char', 'readonly': True},
        'log_err': {'string': 'Emails nao-enviados', 'type': 'char', 'readonly': True},
}


class wiz_enviar_emails(osv.TransientModel):
    _name = 'wiz.enviar.emails'
    def _action_init(self, cr, uid, data, context):
        print data
        return {}

    def _action_create_config(self, cr, uid, data, context):
        logger = netsvc.Logger()
        oCotacao = pooler.get_pool(cr.dbname).get('cotacao.cotacoes')
        oFornecedor = pooler.get_pool(cr.dbname).get('financeiro.fornecedor')
        oPessoa = pooler.get_pool(cr.dbname).get('pessoa.pessoa')
        cotacao_ids = data['form']['cotacoes'][0][2]
        print 'cot', cotacao_ids
        log_env = 0
        log_err = 0
        for cotacao_id in cotacao_ids:
            cotacao = oCotacao.read(cr, uid, cotacao_id, ['fornecedor_id', 'algoritimo'], context=context)
            fornecedor_id = cotacao[0]['fornecedor_id'][0]
            algoritimo = cotacao[0]['algoritimo']
            pessoa_id = oFornecedor.read(cr, uid, fornecedor_id, ['pessoa_id'], context=context)['pessoa_id'][0]
            email_pessoa = oPessoa.read(cr, uid, pessoa_id, ['email'], context=context)[0]['email']
            enviado = tools.email_send('SIG Solucoes', [email_pessoa], 'Cotacao', html_text % (str(algoritimo),str(cotacao_id)),subtype='html')
            if enviado:
                log_env += 1
                logger.notifyChannel('email_send', netsvc.LOG_INFO, 'O email -> %s. Cot. No. %s. Enviado!!!' % (email_pessoa, str(cotacao_id)))
            else:
                log_err += 1
                logger.notifyChannel("email_send", netsvc.LOG_INFO, " O email -> %s. Cot. No. %s. Nao enviado!!!" % (email_pessoa, str(cotacao_id)))
        return {
                'log_env': str(log_env),
                'log_err': str(log_err)
        }

    states = {
            'init': {
                    'actions': [_action_init],
                    'result': {
                            'type': 'form',
                            'arch': view_form_start,
                            'fields': view_fields_start,
                            'state': [('end','Cancel','gtk-cancel'),('create','_Enviar','gtk-apply')]
                    }
            },
            'create': {
                    'actions': [_action_create_config],
                    'result': {
                            'type': 'form',
                            'arch': view_form_end,
                            'fields': view_fields_end,
                            'state': [('end','_Concluir','gtk-ok')]
                    }
            }
    }
wiz_enviar_emails()
