# -*- encoding: utf-8 -*-
##############################################################################
#
# OpenERP, Open Source Management Solution
# Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
# $Id$
#
# This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


import datetime
from openerp.osv import osv


class crm_br_case_atendimentos_capa(osv.Model):
    _name = "crm_br.case.atendimentos.capa"
    _inherit = "crm_br.case.atendimentos.capa"

    def evolucao_atendimentos(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        data = datetime.date.today()
        data = str(data)
        if context.get('data'):
            data = context.get('data')
        section = self.pool.get('crm_br.case.section').search(cr, uid, [('code', '=', 'BugSup')], context=context)
        section_id = 0
        if section:
            section_id = section[0]

        sql = """select p.crmcal_user_id,
                    (select count(distinct(crmcal_case_id))
                       from crm_br_case_log
                       where crmcal_section_id = %s
                        AND crmcal_date between '%s 00:00:00' and '%s 23:59:59'
                        and name in ('Aberto', 'Pendente', 'Fechado', 'Parado')
                        and crmcal_user_id = p.crmcal_user_id) as crmcatc_qtd_trabalhado,
                    (select crmcal_date
                       from crm_br_case_log
                       where crmcal_section_id = %s AND crmcal_date between '%s 00:00:00' and '%s 23:59:59'
                        and name in ('Aberto', 'Pendente', 'Fechado', 'Parado')
                        and crmcal_user_id = p.crmcal_user_id
                       order by crmcal_date asc limit 1) as crmcatc_inicio,
                    (select crmcal_date
                       from crm_br_case_log
                       where crmcal_section_id = %s AND crmcal_date between '%s 00:00:00' and '%s 23:59:59'
                        and name in ('Aberto', 'Pendente', 'Fechado', 'Parado')
                        and crmcal_user_id = p.crmcal_user_id
                       order by crmcal_date desc limit 1) as crmcatc_ultimo,
                    (select sum(crmcal_tempo_atend)
                       from crm_br_case_log
                       where crmcal_section_id = %s AND crmcal_date between '%s 00:00:00' and '%s 23:59:59'
                         and crmcal_user_id = p.crmcal_user_id ) as crmcatc_tempo_utilizado
                    from crm_br_case_log p
                    where crmcal_section_id = %s AND p.crmcal_date between '%s 00:00:00' and '%s 23:59:59'
                        and name in ('Aberto', 'Pendente', 'Fechado', 'Parado')
                    group by crmcal_user_id""" \
                        % (section_id, data, data,
                           section_id, data, data,
                           section_id, data, data,
                           section_id, data, data,
                           section_id, data, data)
        cr.execute(sql)
        registros = cr.fetchall()
        vals = {}
        obj_adm_utils = self.pool.get('adm.utils')
        for reg in registros:
            _primeiro = datetime.datetime.strptime(reg[2], "%Y-%m-%d %H:%M:%S")
            _primeiro = obj_adm_utils.admutl_datetime_to_timezone(cr, uid, _primeiro)[-8:]
            _ultimo = datetime.datetime.strptime(reg[3], "%Y-%m-%d %H:%M:%S")
            _ultimo = obj_adm_utils.admutl_datetime_to_timezone(cr, uid, _ultimo)[-8:]
            vals['crmcatc_user_id'] = reg[0]
            vals['crmcatc_qtd_trabalhado'] = reg[1]
            vals['crmcatc_primeiro'] = _primeiro
            vals['crmcatc_ultimo'] = _ultimo
            vals['crmcatc_tempo_utilizado'] = reg[4]
            vals['crmcatc_data'] = data
            vals['crmcatc_qtd_avancado'] = 0
            vals['crmcatc_qtd_retornado'] = 0
            registro_id = self.search(cr, uid, [('crmcatc_data', '=', vals['crmcatc_data']),
                                                ('crmcatc_user_id', '=', vals['crmcatc_user_id'])], context=context)
            if registro_id:
                self.write(cr, uid, registro_id, vals, context)
            else:
                registro_id = self.create(cr, uid, vals, context)
        ids = self.search(cr, uid, [('crmcatc_data', '=', data)], context=context)
        if not ids:
            return True
        registros = self.read(cr, uid, ids, ['id', 'crmcatc_user_id'], context=context)
        for reg in registros:
            _qtd_retornado = 0
            _qtd_avancado = 0
            id = reg['id']
            _user_id = reg['crmcatc_user_id'][0]
            sql = 'select l.crmcal_case_id, l.name, s.sequence, l.id, l.crmcal_date from crm_br_case_log l left join crm_br_case_stage s on s.id = l.crmcal_stage_id where l.crmcal_section_id = ' \
                  + str(
                section_id) + " and crmcal_date between '" + data + " 00:00:00' and '" + data + " 23:59:59' and l.crmcal_user_id = " + str(
                _user_id) + " and l.name in ('Aberto', 'Pendente', 'Fechado', 'Parado') order by l.crmcal_case_id, crmcal_date"
            cr.execute(sql)
            regsLogs = cr.fetchall()
            ultimo_case = ''
            ultima_sequence = ''
            tempo_ids = self.pool.get('crm_br.case.atendimentos.tempo').search(cr, uid, [
                 ('crmcate_capa_id', '=', id)], context=context)
            if tempo_ids:
                self.pool.get('crm_br.case.atendimentos.tempo').unlink(cr, uid, tempo_ids, context=context)
            for regLogs in regsLogs:
                case_id = regLogs[0]
                tickets_ids = self.pool.get('crm_br.case.atendimentos.tickets').search(cr, uid, [
                    ('crmcatt_capa_id', '=', id), ('crmcatt_case_id', '=', case_id)], context=context)
                if not tickets_ids:
                    tickets_ids = [self.pool.get('crm_br.case.atendimentos.tickets').create(cr, uid,
                                                                                            {
                                                                                                'crmcatt_capa_id': id,
                                                                                                'crmcatt_case_id': case_id},
                                                                                            context)]
                log_id = regLogs[3]
                logs_ids = self.pool.get('crm_br.case.atendimentos.logs').search(cr, uid, [
                    ('crmcatl_ticket_id', '=', tickets_ids[0]), ('crmcatl_log_id', '=', log_id)], context=context)
                if not logs_ids:
                    self.pool.get('crm_br.case.atendimentos.logs').create(cr, uid, {
                        'crmcatl_ticket_id': tickets_ids[0], 'crmcatl_log_id': log_id}, context)
                name = regLogs[1]
                sequence = regLogs[2]
                if name == 'Aberto':
                    ultimo_case = case_id
                    ultima_sequence = sequence
                    vals = {'crmcate_capa_id': id,
                            'crmcate_case_id': case_id,
                            'crmcate_inicio': regLogs[4],
                    }
                    _tempo_id = self.pool.get('crm_br.case.atendimentos.tempo').create(cr, uid, vals, context)
                else:
                    if ultimo_case == case_id:
                        if sequence < ultima_sequence:
                            _qtd_retornado += 1
                        else:
                            if sequence > ultima_sequence or name == 'Fechado':
                                _qtd_avancado += 1
                        vals = {'crmcate_termino': regLogs[4]}
                        self.pool.get('crm_br.case.atendimentos.tempo').write(cr, uid, _tempo_id, vals, context)
            if _qtd_retornado > 0 or _qtd_avancado > 0:
                vals = {
                    'crmcatc_qtd_avancado': _qtd_avancado,
                    'crmcatc_qtd_retornado': _qtd_retornado
                }
                self.write(cr, uid, id, vals, context=context)

        return True

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        res = []
        if context.get('gerar_de_hoje', False):
            context['gerar_de_hoje'] = False
            self.evolucao_atendimentos(cr, uid, None, context)
        res = super(crm_br_case_atendimentos_capa, self).search(cr, uid, args, offset, limit, order,
                                                                context=context, count=count)
        return res
