# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


from openerp.osv import osv
from openerp.tools.translate import _


class crm_br_case_categ(osv.Model):

    _name = "crm_br.case.categ"
    _inherit = "crm_br.case.categ"

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not len(ids):
            return []
        browse = self.browse(cr, uid, ids, context=context)
        res = []
        for record in browse:
            name = record.name
            if name == 'Inbound':
                name = _('Inbound')
            elif name == 'Outbound':
                name = _('Outbound')
            if record.parent_id:
                name = record.parent_id.name + ' / ' + name

            res.append((record.id, name))
        return res
    def name_search(self, cr, uid, name='', args=[], operator='ilike', context=None, limit=100):
        context = context and context.copy() or {}
        ids = []
        ids = self.search(cr, uid, [('name', 'ilike', name)] + args, limit=limit,order='name', context=context)
        return self.name_get(cr, uid, ids)

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        object_id = context and context.get('object_id', False) or False
        if object_id:
            ids = self.pool.get('ir.model').search(cr, uid, [('model', '=', object_id)], context=context)
            inc = 0
            for x in args:
                if x[0] == 'section_id':
                    del args[inc]
                inc += 1
            if ids:
                args.append(('object_id', '=', ids[0]))

            if ( context.get('all_help_desk', False)) or ( context.get('nova_ch_helpdesk', False)):
                args.append(('child_id', '=', False))
                for a in args:
                    if a[0] == 'section_id':
                        args.remove(a)
        if not order:
            order = 'name'
        return super(crm_br_case_categ, self).search(cr, uid, args, offset, limit, order, context=context, count=count)

