# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


import time
from openerp.osv import osv


def _links_get(self, cr, uid, context=None):
    context = context and context.copy() or {}
    obj = self.pool.get('res.request.link')
    ids = obj.search(cr, uid, [], context=context)
    res = obj.read(cr, uid, ids, ['object', 'name'], context=context)
    return [(r['object'], r['name']) for r in res]


class crm_br_case_history(osv.Model):
    _name = "crm_br.case.history"
    _inherit = "crm_br.case.history"

    def create(self, cr, user, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('crmcal_case_id') and vals['crmcal_case_id']:
            case_obj = self.pool.get('crm_br.case')
            cases = case_obj.browse(cr, user, [vals['crmcal_case_id']], context=context)
            case_obj._action(cr, user, cases, '', context=context)
            case_obj.write(cr, user, [vals['crmcal_case_id']],
                           {'date_ultimo_historico': time.strftime('%Y-%m-%d %H:%M:%S')}, context)
        return super(crm_br_case_history, self).create(cr, user, vals, context)
