# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import datetime
from openerp.osv import osv


class crm_br_case_pipeline(osv.Model):
    _name = "crm_br.case.pipeline"
    _inherit = "crm_br.case.pipeline"

    def evolucao_pipeline(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if datetime.date.today().weekday() > 4: # 5 e 6 sao sábado e domingo, nao gerar
            return True

        section = self.pool.get('crm_br.case.section').search(cr, uid, [('code','=','oppor')], context=context)
        if section:
            section_id = section[0]
        fields = ['campo01','campo02','campo03','campo04','campo05',
                  'campo06','campo07','campo08','campo09','campo10'
        ]
        detalhe = self.pool.get('crm_br.case.pipeline.detalhe').read(cr, uid, [1], fields, context=context, load='_classic_write')
        if detalhe:
            detalhe = detalhe[0]
            campo01 = detalhe.get('campo01')
            campo02 = detalhe.get('campo02')
            campo03 = detalhe.get('campo03')
            campo04 = detalhe.get('campo04')
            campo05 = detalhe.get('campo05')
            campo06 = detalhe.get('campo06')
            campo07 = detalhe.get('campo07')
            campo08 = detalhe.get('campo08')
            campo09 = detalhe.get('campo09')
            campo10 = detalhe.get('campo10')
            sql ="select "
            if campo01:
               sql = sql + ' (select sum(planned_revenue) from crm_br_case where stage_id = %s and section_id = %s) ' % (campo01, str(section_id))
            else:
               sql = sql + ' 0 '
            if campo02:
               sql = sql + ', (select sum(planned_revenue) from crm_br_case where stage_id = %s and section_id = %s) ' % (campo02, str(section_id))
            else:
               sql = sql + ', 0 '
            if campo03:
               sql = sql + ', (select sum(planned_revenue) from crm_br_case where  stage_id = %s and section_id = %s) ' % (campo03, str(section_id))
            else:
               sql = sql + ', 0 '
            if campo04:
               sql = sql + ', (select sum(planned_revenue) from crm_br_case where stage_id = %s and section_id = %s) ' % (campo04, str(section_id))
            else:
               sql = sql + ', 0 '
            if campo05:
               sql = sql + ', (select sum(planned_revenue) from crm_br_case where stage_id = %s and section_id = %s) ' % (campo05, str(section_id))
            else:
               sql = sql + ', 0 '
            if campo06:
               sql = sql + ', (select sum(planned_revenue) from crm_br_case where stage_id = %s and section_id = %s) ' % (campo06, str(section_id))
            else:
               sql = sql + ', 0 '
            if campo07:
               sql = sql + ', (select sum(planned_revenue) from crm_br_case where stage_id = %s and section_id = %s) ' % (campo07, str(section_id))
            else:
               sql = sql + ', 0 '
            if campo08:
               sql = sql + ', (select sum(planned_revenue) from crm_br_case where stage_id = %s and section_id = %s) ' % (campo08, str(section_id))
            else:
               sql = sql + ', 0 '
            if campo09:
               sql = sql + ', (select sum(planned_revenue) from crm_br_case where stage_id = %s and section_id = %s) ' % (campo09, str(section_id))
            else:
               sql = sql + ', 0 '
            if campo10:
               sql = sql + ', (select sum(planned_revenue) from crm_br_case where stage_id = %s and section_id = %s) ' % (campo10, str(section_id))
            else:
               sql = sql + ', 0 '
            cr.execute(sql)
            registros = cr.fetchall()
            vals={}
            for reg in registros:
                vals['campo01'] = reg[0]
                vals['campo02'] = reg[1]
                vals['campo03'] = reg[2]
                vals['campo04'] = reg[3]
                vals['campo05'] = reg[4]
                vals['campo06'] = reg[5]
                vals['campo07'] = reg[6]
                vals['campo08'] = reg[7]
                vals['campo09'] = reg[8]
                vals['campo10'] = reg[9]
                vals['data'] =  datetime.date.today()
                registro_id = self.search(cr, uid, [('data','=',vals['data'])], context=context)
                if registro_id:
                    self.write(cr, uid, registro_id, vals, context)
                else:
                    self.create(cr, uid, vals, context)
        return True

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        res=[]
        if context.get('gerar_de_hoje',False):
            context['gerar_de_hoje'] = False
            self.evolucao_pipeline(cr, uid, None, context)
        res = super( crm_br_case_pipeline, self ).search( cr, uid, args, offset, limit, order, context, count )
        return res
