# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import osv
from datetime import datetime


class crm_br_case_tickets(osv.Model):
    _name = "crm_br.case.tickets"
    _inherit = "crm_br.case.tickets"

    def evolucao_tickets(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if datetime.now().weekday() > 4: # 5 e 6 sao sábado e domingo, nao gerar
            return True
        data = str(datetime.now().date())
        sql ="select s.id, \
                (select count(id) from crm_br_case where section_id = s.id and state = 'draft') as draft, \
                (select count(id) from crm_br_case where section_id = s.id and state = 'open') as open, \
                (select count(id) from crm_br_case where section_id = s.id and state = 'done') as done, \
                (select count(id) from crm_br_case where section_id = s.id and state = 'cancel') as cancel, \
                (select count(id) from crm_br_case where section_id = s.id and state = 'pending') as pending, \
                (select count(id) from crm_br_case where section_id = s.id and state = 'parado') as parado, \
                (select count(id) from crm_br_case where section_id = s.id and create_date between '%s 00:00:00' and '%s 23:59:59') as novo \
            from crm_br_case_section s" % (data, data)
        cr.execute(sql)
        registros = cr.fetchall()
        vals={}
        for reg in registros:
            vals['section_id'] = reg[0]
            vals['draft'] = reg[1]
            vals['open'] = reg[2]
            vals['done'] = reg[3]
            vals['cancel'] = reg[4]
            vals['pending'] = reg[5]
            vals['parado'] = reg[6]
            vals['novo'] = reg[7]
            vals['total'] = int(reg[1]) + int(reg[2]) + int(reg[3]) + int(reg[4]) + int(reg[5]) + int(reg[6])
            vals['atendimento'] =  int(reg[1]) + int(reg[2]) + int(reg[5])
            vals['data'] = data
            self.create(cr, uid, vals, context)
        return True
