# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp import tools
from openerp.osv import osv
import os
from openerp import pooler

class crm_br_menu_config_wizard(osv.TransientModel):
    _name = 'crm_br.menu.config_wizard'
    _inherit = 'crm_br.menu.config_wizard'

    def action_create(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        module_proxy = self.pool.get('ir.module.module')
        modid = module_proxy.search(cr, uid, [('name', '=', 'crm_br')], context=context)
        moddemo = module_proxy.browse(cr, uid, modid[0]).demo
        lst = ('data', 'menu')
        if moddemo:
            lst = ('data', 'menu', 'demo')
        res = self.read(cr, uid, ids, context=context)[0]
        idref = {}
        for section in ['meeting', 'lead', 'opportunity', 'jobs', 'bugs', 'fund', 'helpdesk', 'claims', 'phonecall']:
            if (not res[section]):
                continue
            for fname in lst:
                file_name = 'crm_br_' + section + '_' + fname + '.xml'
                try:
                    fp = tools.file_open(os.path.join('crm_br', file_name))
                except IOError as e:
                    fp = None
                if fp:
                    tools.convert_xml_import(cr, 'crm_br', fp, idref, 'init', noupdate=True)
        cr.commit()
        modobj = self.pool.get('ir.module.module')
        modids = modobj.search(cr, uid, [('name', '=', 'crm_br')], context=context)
        modobj.update_translations(cr, 1, modids, None)

        if res['document_ics']:
            ids = module_proxy.search(cr, uid, [('name', '=', 'document_ics')], context=context)
            module_proxy.button_install(cr, uid, ids, context=context)
            cr.commit()
            db, pool = pooler.restart_pool(cr.dbname, update_module=True)

        return {
                'view_type': 'form',
                "view_mode": 'form',
                'res_model': 'ir.actions.configuration.wizard',
                'type': 'ir.actions.act_window',
                'target': 'new',
         }

    def action_cancel(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return {
                'view_type': 'form',
                "view_mode": 'form',
                'res_model': 'ir.actions.configuration.wizard',
                'type': 'ir.actions.act_window',
                'target': 'new',
         }

