# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import osv


class crm_br_segmentation(osv.Model):

    _name = "crm_br.segmentation"
    _inherit = "crm_br.segmentation"
    def process_continue(self, cr, uid, ids, start=False, context=None):
        context = context and context.copy() or {}
        categs = self.read(cr,uid,ids,['categ_id','exclusif','pessoa_id', 'sales_purchase_active', 'profiling_active'], context=context)
        for categ in categs:
            if start:
                if categ['exclusif']:
                    cr.execute('delete from pessoa_categoria where categoria_id=%s', (categ['categ_id'][0],))

            id = categ['id']

            cr.execute('select id from adm_pessoa order by id ')
            pessoas = [x[0] for x in cr.fetchall()]

            if categ['sales_purchase_active']:
                to_remove_list=[]
                cr.execute('select id from crm_br_segmentation_line where segmentation_id=%s', (id,))
                line_ids = [x[0] for x in cr.fetchall()]

                for pid in pessoas:
                    if (not self.pool.get('crm_br.segmentation.line').test(cr, uid, line_ids, pid, context=context)):
                        to_remove_list.append(pid)
                for pid in to_remove_list:
                    pessoas.remove(pid)

            for pessoa_id in pessoas:
                cr.execute('insert into pessoa_categoria (categoria_id,pessoa_id) values (%s,%s)', (categ['categ_id'][0],pessoa_id))
            cr.commit()

            self.write(cr, uid, [id], {'state':'not running', 'pessoa_id':0}, context=context)
            cr.commit()
        return True

    def process_stop(self, cr, uid, ids, context=None, *args):
        return self.write(cr, uid, ids, {'state':'not running', 'pessoa_id':0}, context=context)

    def process_start(self, cr, uid, ids, context=None, *args):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state':'running', 'pessoa_id':0}, context=context)
        return self.process_continue(cr, uid, ids, start=True, context=context)

