# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import osv


class report_crm_br_case_section(osv.Model):
    _name = "report.crm_br.case.section"
    _inherit = "report.crm_br.case.section"

    def init(self, cr):
        cr.execute("""
            create or replace view report_crm_br_case_section as (
                select
                    min(c.id) as id,
                    to_char(c.create_date, 'YYYY-MM-01') as name,
                    c.section_id as section_id,
                    count(*) as nbr_cases,
                    0 as avg_answers,
                    0.0 as perc_done,
                    0.0 as perc_cancel,
                    to_char(avg(date_closed-c.create_date), 'DD"d" HH24:MI:SS') as delay_close
                from
                    crm_br_case c
                group by to_char(c.create_date, 'YYYY-MM-01'),c.section_id
            )""")
