# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import osv

class report_crm_br_case_service_dashboard(osv.Model):
    _name = "report.crm_br.case.service.dashboard"
    _inherit = "report.crm_br.case.service.dashboard"

    def init(self, cr):
        cr.execute("""create or replace view report_crm_br_case_service_dashboard as (
            select
                cse.id as id, cse.date as date, cse.date_deadline as date_deadline,
                cse.name as name, cse.pessoa_id as pessoa_id, cse.user_id as user_id,
                cse.priority as priority, cse.planned_revenue as planned_revenue,
                cse.planned_cost as planned_cost, cse.state as state,
                cse.date_closed as date_closed, cse.create_date as create_date
            from
                crm_br_case cse
            where
                ((to_date(to_char(cse.date_closed, 'YYYY-MM-dd'),'YYYY-MM-dd') <= CURRENT_DATE)
                    AND
                (to_date(to_char(cse.date_closed, 'YYYY-MM-dd'),'YYYY-MM-dd') > (CURRENT_DATE-15)) 
                    AND
                    cse.state='done')
                
                OR
                
                ((to_date(to_char(cse.create_date, 'YYYY-MM-dd'),'YYYY-MM-dd') <= CURRENT_DATE)
                    AND
                (to_date(to_char(cse.create_date, 'YYYY-MM-dd'),'YYYY-MM-dd') > (CURRENT_DATE-15))
                    AND
                    cse.state='open')
            )""")
