# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.sql import drop_view_if_exists
from datetime import date
from dateutil.relativedelta import relativedelta
from time import strftime

class report_view_help(osv.Model):

    _name = 'report.view.help'
    _inherit = 'report.view.help'

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):

        context = context and context.copy() or {}
        if not args:
            args = []

        if context.get('tipo') == 'fechada':
            sdata = 'date_closed'
        else:
            sdata = 'create_date'

        if context.get('dias') == -1 :
            args.append((sdata, '=', (date.today() - relativedelta(days=1)).strftime('%Y-%m-%d')))
        elif context.get('dias') == 0:
            args.append((sdata, '=', strftime('%Y-%m-%d')))
        elif context.get('dias') == 7:
            args.append((sdata, '>=', (date.today() - relativedelta(days=7)).strftime('%Y-%m-%d')))
        elif context.get('dias') == 30:
            args.append((sdata, '>=', (date.today() - relativedelta(days=30)).strftime('%Y-%m-%d')))

        create_date_in_args = filter(lambda i: 'create_date' in i, args)
        if not create_date_in_args:
            args = [('create_date', '=', (date.today() - relativedelta(days=1)).strftime('%Y-%m-%d'))]
        object_in_args = filter(lambda i: 'model' in i, args)
        if not object_in_args:
            ids = self.pool.get('ir.model').search(cr, uid, [('model', '=', 'crm_br.help_desk')], context=context)
            if ids:
                args.append(('object_id', '=', ids[0]))

        return super(report_view_help, self).search(cr, uid, args, offset, limit, order, context, count)

    def init(self, cr):
        drop_view_if_exists(cr, "report_view_help")
        cr.execute("""create or replace view report_view_help  as (
            SELECT cbc.id, cbc.crmcal_user_id, cbc.canal_id, cbc.crmcal_section_id, cbc.categ_id, cbcc.object_id,
                   pes.nome AS user_name,  ccn.name AS canal_name, cbcc.name AS categ_name, cbcs.name as sec_name,
                   cbc.create_date, cbc.date_closed, cbc.atendimentos, cbc.descricao
                           FROM crm_br_case_section cbcs ,
                           ( SELECT  distinct cbc.id, cbc_log.crmcal_user_id, cbc.canal_id, cbc.categ_id, cbc_log.crmcal_section_id, cbc.name descricao,
                                     to_date(to_char(date_trunc('day'::text, cbc.create_date), 'YYYY-MM-dd'::text), 'YYYY-MM-dd'::text) AS create_date,
                                     to_date(to_char(date_trunc('day'::text, cbc.date_closed), 'YYYY-MM-dd'::text), 'YYYY-MM-dd'::text) AS date_closed,
                                     1 AS atendimentos
                                   FROM crm_br_case cbc
                           LEFT JOIN crm_br_case_log cbc_log ON cbc_log.crmcal_case_id = cbc.id) cbc
                           LEFT JOIN crm_br_canal ccn on cbc.canal_id = ccn.id
                           LEFT JOIN crm_br_case_categ cbcc on cbcc.id = cbc.categ_id
                           left join res_users ru on ru.id = cbc.crmcal_user_id
                           left join adm_pessoa pes on pes.id = ru.pessoa_id
                           WHERE cbc.crmcal_user_id = ru.id  and cbc.crmcal_section_id = cbcs.id
                )""")

