# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


from openerp.osv import fields, osv


class crm_br_case_categ(osv.Model):
    from funcoes import _find_object_id, _find_res_model

    _name = "crm_br.case.categ"
    _description = "Category of case"
    _columns = {
        'name': fields.char('Case Category Name', size=64, required=True),
        'probability': fields.float('Probability (%)', required=True),
        'section_id': fields.many2one('crm_br.case.section', 'Case Section'),
        'object_id': fields.many2one('ir.model', 'Object Name'),
        'parent_id': fields.many2one('crm_br.case.categ', 'Parent Category'),
        'tempo': fields.float('Tempo Atendimento',
                              help="Tempo maximo de atendimento por categoria."),
        'user_ids': fields.many2many('res.users', 'crm_br_users_group_rel', 'gid', 'uid', 'Users'),
        'stage_ids': fields.one2many('crm_br.case.stage.rel', 'rel_id', 'Stages'),
        'res_model': fields.char('Model', size=64),
        'child_id': fields.one2many('crm_br.case.categ', 'parent_id', 'Sub Categoria'),
    }

    _defaults = {
        'probability': lambda *args: 0.0,
        'object_id': _find_object_id,
        'res_model': _find_res_model
    }
    _order = 'parent_id'
