# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


from openerp.osv import fields, osv


class crm_br_case_history(osv.Model):
    _name = "crm_br.case.history"
    _description = "Case history"
    _order = "id desc"
    _inherits = {'crm_br.case.log': "log_id"}

    from funcoes import _crmbch_note_get, _crmbch_get_state

    _columns = {
        'description': fields.text('Description'),
        'note': fields.function(_crmbch_note_get, method=True, string="Description", type="text"),
        'email': fields.char('Email', size=84),
        'log_id': fields.many2one('crm_br.case.log', 'Log', required=True, ondelete='cascade'),
        'create_uid': fields.many2one('res.users', 'Creator', readonly=True),
        'crmbch_state': fields.function(_crmbch_get_state, method=True, string="Status",
                                        type="char", store=False),
    }
