# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


import time
from openerp.osv import fields, osv
PRIORIDADES = [
    ('5', 'Mais baixa'),
    ('4', 'Baixa'),
    ('3', 'Normal'),
    ('2', 'Alta'),
    ('1', 'Mais alta')
]



class crm_br_case_log(osv.Model):

    from funcoes import _calcula_atendimento, _crmcal_get_priority

    _name = "crm_br.case.log"
    _description = "Case Communication History"
    _order = "date desc"
    # _inherits = {
    #     'crm_br.case': 'crmcal_case_id',
    # }

    _columns = {
        'id': fields.integer('Id', readonly=True),
        'name': fields.char('Action', size=64),
        'crmcal_som': fields.many2one('crm_br.som', 'State of Mind', oldname='som'),
        'crmcal_date': fields.datetime('Date', select=True, oldname='date'),
        'crmcal_canal_id': fields.many2one('crm_br.canal', 'Channel', oldname='canal_id'),
        'crmcal_section_id': fields.many2one('crm_br.case.section', 'Section', select=True, oldname='section_id'),
        'crmcal_user_id': fields.many2one('res.users', 'User Responsible', readonly=True, select=True, oldname='user_id'),
        'crmcal_case_id': fields.many2one('crm_br.case', 'Case', required=True, ondelete='cascade', select=True, oldname='case_id'),
        'crmcal_tempo_atend': fields.function(_calcula_atendimento, type='float', method=True, string='Tempo Atendimento', store=True, oldname='tempo_atend'),
        'create_uid':  fields.many2one('res.users', 'Creator', readonly=True),
        'crmcal_stage_id': fields.many2one('crm_br.case.stage', 'Stage', select=True, oldname='stage_id'),
        'crmcal_priority': fields.function(_crmcal_get_priority, method=True, string="Prioridade", translate=True,
                                        type="selection", selection=PRIORIDADES, store=True),
        'crmcal_versao_liberar_id': fields.many2one('crm_br.case.category2', 'Liberar na versao'),
    }
    _defaults = {
        'crmcal_date': lambda * a: time.strftime('%Y-%m-%d %H:%M:%S'),
    }
    _order = 'crmcal_date desc'
