# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


from openerp.osv import fields, osv


class crm_br_case_pipeline(osv.Model):

    from funcoes import _pipeline_get

    _name = "crm_br.case.pipeline"
    _description = "pileline"
    _rec_name = 'data'

    _columns = {
        'id': fields.integer('ID', readonly=True),
        'data' : fields.date('Data', select=True),
        'campo01' : fields.float('Abordagem'),
        'campo02' : fields.float('Aprov.Escopo'),
        'campo03' : fields.float('Elab.Proposta'),
        'campo04' : fields.float('Lev./Apresentacao'),
        'campo05' : fields.float('Negociacao/Rev.'),
        'pipeline' : fields.function(_pipeline_get, method=True, string='Pipeline', type='float', store=False),
        'campo06' : fields.float('Standby'),
        'campo07' : fields.float('Fech.Perdido'),
        'campo08' : fields.float('Fech.Vencido'),
        'campo09' : fields.float('Valor'),
        'campo10' : fields.float('Valor'),
    }

    _order = 'data desc'
