# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


from openerp.osv import fields, osv


class crm_br_case_section(osv.Model):

    from funcoes import _check_recursion

    _name = "crm_br.case.section"
    _description = "Case Section"
    _columns = {
        'name': fields.char('Case Section', size=64, required=True, translate=True),
        'code': fields.char('Section Code', size=8),
        'active': fields.boolean('Active'),
        'allow_unlink': fields.boolean('Allow Delete', help="Allows to delete non draft cases"),
        'sequence': fields.integer('Sequence'),
        'user_id': fields.many2one('res.users', 'Responsible User'),
        'reply_to': fields.char('Reply-To', size=64, help="The email endereco put in the 'Reply-To' of all emails sent by Open ERP about cases in this section"),
        'parent_id': fields.many2one('crm_br.case.section', 'Parent Section'),
        'child_ids': fields.one2many('crm_br.case.section', 'parent_id', 'Child Sections'),
    }
    _defaults = {
        'active': lambda * a: 1,
        'allow_unlink': lambda * a: 1,
    }
    _sql_constraints = [
         ('code_uniq', 'unique (code)', 'The code of the section must be unique !')
     ]

    _constraints = [
        (_check_recursion, 'Error ! You cannot create recursive sections.', ['parent_id'])
    ]
