# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


from openerp.osv import fields, osv


class crm_br_case_tickets(osv.Model):
    _name = "crm_br.case.tickets"
    _description = "Tickets"
    _rec_name = 'data'

    _columns = {
        'id': fields.integer('ID', readonly=True),
        'section_id' : fields.many2one('crm_br.case.section', 'Secao', select=True),
        'data' : fields.date('Data', select=True),
        'draft' : fields.integer('Esboco'),
        'open' : fields.integer('Aberto'),
        'done' : fields.integer('Fechado'),
        'pending' : fields.integer('Pendente'),
        'parado' : fields.integer('Parado'),
        'cancel' : fields.integer('Cancelado'),
        'total' : fields.integer('Total', help='E a soma de Esboco, Aberto, Fechado, Pendente, Parado e Cancelado'),
        'novo' : fields.integer('Novos', help='E a soma dos tickets incluidos nesta data'),
        'atendimento' : fields.integer('Total p/Atendimento', help='E a soma de Esboco, Aberto e Pendente'),
    }

    _order = 'section_id, data desc'
