# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


import time
from openerp.osv import fields, osv


class crm_br_event(osv.Model):

    from funcoes import _links_get

    _name = "crm_br.event"
    _columns = {
        'name': fields.char('Events', size=64, required=True),
        'som': fields.many2one('crm_br.som', 'State of Mind'),
        'description': fields.text('Description'),
        'planned_cost': fields.float('Planned Cost'),
        'planned_revenue': fields.float('Planned Revenue'),
        'probability': fields.float('Probability (0.50)'),
        'document': fields.reference('Document', selection=_links_get, size=128),
        'pessoa_id': fields.many2one('adm.pessoa', 'pessoa', select=True),
        'date': fields.datetime('Date', size=16),
        'user_id': fields.many2one('res.users', 'User'),
        'canal_id': fields.many2one('crm_br.canal', 'Channel'),
        'pessoa_type': fields.selection([('customer', 'Customer'), ('retailer', 'Retailer'), ('prospect', 'Commercial Prospect')], 'pessoa Relation'),
        'type': fields.selection([('sale', 'Sale Opportunity'), ('purchase', 'Purchase Offer'), ('prospect', 'Prospect Contact')], 'Type of Event'),
        'event_ical_id': fields.char('iCal id', size=64),
    }
    _order = 'date desc'
    _defaults = {
        'date': lambda * a: time.strftime('%Y-%m-%d %H:%M:%S'),
    }
