# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import fields,osv

AVAILABLE_STATES = [
    ('draft','Draft'),
    ('open','Open'),
    ('cancel', 'Canceled'),
    ('done', 'Closed'),
    ('pending','Pending')
]

class report_crm_br_case_service_dashboard(osv.Model):
    _name = "report.crm_br.case.service.dashboard"
    _description = "Report of Closed and Open crm_br Cases within past 15 days"
    _auto = False
    _columns = {
        'date': fields.datetime('Date', readonly=True),
        'date_deadline': fields.datetime('Deadline', readonly=True),
        'name': fields.char('Description', size=64, readonly=True),
        'pessoa_id': fields.many2one('adm.pessoa', 'Pessoa', readonly=True),
        'user_id': fields.many2one('res.users', 'Responsible', readonly=True),
        'priority': fields.char('Priority', size=64, readonly=True),
        'planned_revenue': fields.float('Planned Revenue', readonly=True),
        'planned_cost': fields.float('Planned Costs', readonly=True),
        'state': fields.selection(AVAILABLE_STATES, 'Status', size=16, readonly=True),
        'date_closed' : fields.datetime('Date Closed', readonly=True),
        'create_date' : fields.datetime('Create Date', readonly=True)
    }
    _order = 'date_closed, create_date'
    
