# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        title = center_title('', _('Atendimentos a faturar'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, 'Atendimentos a faturar')
        listagem.informaTamLinha(160)

        obj_crm_br = pooler.get_pool(cr.dbname).get('crm_br.case')

        args = []
        periodo_inicial = datas.get('periodo_inicial')
        if periodo_inicial:
            periodo_inicial += ' 00:00:00'
            args.append(('date', '>=', periodo_inicial), )
        periodo_final = datas.get('periodo_final')
        if periodo_final:
            periodo_final += ' 23:59:59'
            args.append(('date', '<=', periodo_final), )
        atividades_concluidas = datas.get('atividades_concluidas')
        if atividades_concluidas:
            args.append(('state', '=', 'done'), )
        else:
            args.append(('state', '!=', 'cancel'), )
        args.append(('crmcas_faturar', '=', True), )

        crm_br_ids = obj_crm_br.search(cr, uid, args, context=context)

        if crm_br_ids:
            browse_crm_br = obj_crm_br.browse(cr, uid, crm_br_ids)

            company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid, context=context)
            res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid,
                                                                                   company_id,
                                                                                   ['name'], context=context)
            nome_empresa = res_company_dados.get('name')
            data = time.strftime("%d/%m/%Y")
            docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))

            listagem.informaCab('' + title)
            listagem.informaCab('')
            listagem.informaCab('')
            listagem.informaCab('' + docs)
            listagem.informaCab('  ')
            listagem.informaCab(
                '*---------------------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.informaCab(_(
                '| ATIVIDADE |                   TITULO                    |              CLIENTE              |         DATA        | TEMPO ATEND. |    ATENDENTE    |  ESTADO  |'))
            listagem.informaCab(
                '*---------------------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.informaCab('  ')
            listagem.rodapePadrao()

            total_tempo_atendimento = 0
            for x in browse_crm_br:
                atendente = ''
                user_id = x.user_id
                if user_id:
                    pessoa_id = x.user_id.pessoa_id
                    if pessoa_id:
                        atendente = pessoa_id.name or ''
                data = x.date or ''
                if data:
                    data = data[:19]
                    data = time.strftime('%d/%m/%Y %H:%M:%S',
                                         time.strptime(data, '%Y-%m-%d %H:%M:%S'))

                estado = x.state or ''
                if estado == 'draft':
                    estado = 'Esboco'
                elif estado == 'open':
                    estado = 'Aberto'
                elif estado == 'pending':
                    estado = 'Pendente'
                elif estado == 'cancel':
                    estado = 'Cancelado'
                elif estado == 'done':
                    estado = 'Fechado'
                elif estado == 'parado':
                    estado = 'Parado'

                linha = formataString(x.id or '', 11, ' ', 'E', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(x.name or '', 44, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(x.pessoa_id.name or '', 34, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(data, 20, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(getNumeroEditado(x.total_tempo_atend or 0, 2), 13, ' ', 'E',
                                       'N', 'S') + '|'
                linha += ' '
                linha += formataString(atendente, 16, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(estado, 9, ' ', 'D', 'N', 'S') + '|'
                linha += ''
                listagem.imprimeLinha('|' + linha)
                total_tempo_atendimento += x.total_tempo_atend or 0
            listagem.imprimeLinha('')
            linha = formataString('TOTAL', 118, ' ', 'D', 'N', 'S') + ''
            linha += ''
            linha += formataString(getNumeroEditado(total_tempo_atendimento or 0, 2), 13, ' ', 'E',
                                   'N', 'S') + ''
            linha += ''
            listagem.imprimeLinha('' + linha)
            listagem.imprimeLinha(
                '*---------------------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.imprimeLinha(
                '                                                                                                                   ** Sig Informatica LTDA **       ')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_atendimentos_a_faturar')
