# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################



import time
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils import datas
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import locale


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, sdatas, context=None):
        #-------------------------------------------------------------------------------
        context = context and context.copy() or {}
        if len(ids) == 1:
            ids = '(%s)' % str(ids[0])
        else:
            ids = str(tuple(ids))
        sql = """
                SELECT    c.id,
                          c.name,
                          c.create_date,
                          c.state,
                          s.name,
                          t.name,
                          c.crmcas_duration,
                          c.total_tempo_atend,
                          h.description,
                          h.create_date,
                          a.name
                FROM      crm_br_case_history h
                LEFT JOIN crm_br_case_log l
                ON        l.id = h.log_id
                LEFT JOIN crm_br_case c
                ON        c.id = l.crmcal_case_id
                LEFT JOIN crm_br_case_stage s
                ON        s.id = c.stage_id
                LEFT JOIN crm_br_case_categ t
                ON        t.id = c.categ_id
                LEFT JOIN res_users r
                ON        r.id = h.create_uid
                LEFT JOIN adm_pessoa a
                ON        a.id = r.pessoa_id
                WHERE     c.id IN %s
                ORDER BY  c.id,
                          h.create_date DESC   """ % ids
        cr.execute(sql)
        dados = cr.fetchall()

        pdf_file = StringIO.StringIO()
        cab = '                                                          Listagem de Tarefas    '
        listagem = Impressora()
        listagem.informaNome(pdf_file, 'Listagens de Tarefas')
        listagem.informaTamLinha(160)
        listagem.informaCab(cab)
        listagem.informaCab(' ')
        data = time.strftime('%Y-%m-%d')
        da = time.strftime("%d/%m/%Y", time.strptime(data, "%Y-%m-%d"))
        listagem.informaCab('Emissao: ' + da + 125 * ' ' + 'Pag.' + '{{ Page }}')
        listagem.informaCab(' ')
        listagem.informaCab('--')
        cab = formataString('Tarefa ', 9, ' ', 'E', 'N', 'S')
        cab += formataString('Titulo', 65, ' ', 'D', 'S', 'S')
        cab += formataString('Estado', 15, ' ', 'D', 'S', 'S')
        cab += formataString('Estagio', 15, ' ', 'D', 'S', 'S')
        cab += formataString('Categoria', 30, ' ', 'D', 'S', 'S')
        cab += formataString('H.Prev.', 8, ' ', 'E', 'S', 'S')
        cab += formataString('H.Real.', 8, ' ', 'E', 'S', 'S')
        listagem.informaCab(cab)
        cab = formataString(' ', 10, ' ', 'D', 'N', 'S')
        cab += formataString('  Data ', 11, ' ', 'D', 'N', 'S')
        cab += formataString('Usuario', 30, ' ', 'D', 'S', 'S')
        cab += formataString('Descricao', 107, ' ', 'D', 'S', 'S')
        listagem.informaCab(cab)
        listagem.informaCab('--')
        listagem.rodapePadrao()
        ultima_atividade = 0
        totalPrevisto = totalRealizado = 0
        for reg in dados:
            if ultima_atividade != reg[0]:
                if ultima_atividade != 0:
                    listagem.imprimeLinha(' ')
                ultima_atividade = reg[0]
                linha = formataString(locale.format("%7d", reg[0], 1), 8, ' ', 'E', 'S', 'S')
                linha += ' '
                linha += formataString(reg[1], 65, ' ', 'D', 'S', 'S')
                estado = reg[3]
                if estado == 'done':
                    estado = 'Concluido'
                if estado == 'cancel':
                    estado = 'Cancelado'
                if estado == 'open':
                    estado = 'Aberto'
                if estado == 'pending':
                    estado = 'Pendente'
                linha += formataString(estado, 15, ' ', 'D', 'S', 'S')
                estagio = reg[4]
                linha += formataString(estagio, 15, ' ', 'D', 'S', 'S')
                linha += formataString(reg[5], 30, ' ', 'D', 'S', 'S')
                hrP = reg[6] or 0  # tempo previsto
                totalPrevisto += hrP
                hrR = reg[7] or 0  # tempo realizado
                totalRealizado += hrR
                linha += formataString(locale.format("%7d", hrP, 1), 7, ' ', 'E', 'S', 'S')
                linha += ' '
                linha += formataString(locale.format("%5.2f", hrR, 1), 7, ' ', 'E', 'S', 'S')
                listagem.imprimeLinha(linha)
            dt_hr_criacao = reg[2].split(' ')
            if isinstance(dt_hr_criacao, list):
                dt_hr_criacao = dt_hr_criacao[0]
            data = datas.sigDatas(dt_hr_criacao).getDataNoFormato('N', 'S')
            usuario = reg[10]  # create_uid
            lHistorico = []
            sHistorico = reg[8]  #description
            while len(sHistorico) > 106:
                lHistorico.append(sHistorico[:106])
                sHistorico = sHistorico[106:]
            if sHistorico > 0:
                lHistorico.append(sHistorico)
            for histo in lHistorico:
                linha = formataString(' ', 10, ' ', 'D', 'S', 'S')
                linha += formataString(data, 11, ' ', 'D', 'S', 'S')
                linha += formataString(usuario, 30, ' ', 'D', 'S', 'S')
                linha += formataString(histo, 107, ' ', 'D', 'S', 'S')
                data = ''
                usuario = ''
                listagem.imprimeLinha(linha)
        listagem.imprimeLinha('--')
        linha = formataString('Total ', 134, ' ', 'E', 'S', 'S')
        linha += formataString(locale.format("%7d", totalPrevisto, 1), 7, ' ', 'E', 'S', 'S')
        linha += ' '
        linha += formataString(locale.format("%5.2f", totalRealizado, 1), 7, ' ', 'E', 'S', 'S')
        listagem.imprimeLinha(linha)
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_file.getvalue())
        self.obj.render()
        pdf_file.close()

        return ( self.obj.pdf, 'pdf' )


report_custom('report.listagem_chamados')


# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

