 # -*- encoding: utf-8 -*-

from openerp.osv import fields, osv
from openerp import tools

class view_atendimento_aberto_categoria(osv.Model):

    _name = "view.atendimento.aberto.categoria"
    _description = "Primeiro e segundo nivel aberto por categ."
    _auto = False
    _columns = {
        'vcbcat12ac_categ_id': fields.many2one('crm_br.case.categ', 'Categoria', readonly=True),
        'vcbcat12ac_quantidade': fields.integer('Quantidade', readonly=True),
    }

    def init(self, cr):
        tools.sql.drop_view_if_exists(cr, "view_atendimento_aberto_categoria")
        cr.execute("""create view view_atendimento_aberto_categoria as (
                        SELECT
                            rank() over(order by id) AS id,
                            categ_id as vcbcat12ac_categ_id,
                            count(id) as vcbcat12ac_quantidade
                        FROM crm_br_case
                        WHERE
                            section_id in (SELECT id FROM crm_br_case_section WHERE code in
                            ('HD', 'nivel2'))
                            AND state in ('draft', 'open', 'pending')
                        GROUP BY id, categ_id)
                    """)
