# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
import time


class wizard_logs_atendimentos_capa(osv.TransientModel):
    _name = 'wizard.logs.atendimentos.capa'
    _columns = {
        'wlac_data_inicio': fields.date('Data de inicio', required=True),
        'wlac_data_fim': fields.date('Data final', required=True),
        'wlac_section_id': fields.many2one('crm_br.case.section', 'Sessao'),
        'wlac_stage_id': fields.many2one('crm_br.case.stage', 'Estagio'),
        'wlac_user_id': fields.many2one('res.users', 'Responsavel'),
        'wlac_case_id': fields.many2one('crm_br.case', 'Atendimento'),
        'logs_ids': fields.one2many('wizard.logs.atendimentos.logs', 'wlal_capa_id', 'Logs'),
    }
    _defaults = {
        'wlac_data_inicio': lambda *a: time.strftime('%Y-%m-%d'),
        'wlac_data_fim': lambda *a: time.strftime('%Y-%m-%d'),
    }

    def wlac_button_pesquisar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not ids:
            return True
        #Apagar pesquisa anterior
        logs_ids = self.pool.get('wizard.logs.atendimentos.logs').search(cr, uid,
                                                                [('wlal_capa_id', 'in', ids)], context=context)
        self.pool.get('wizard.logs.atendimentos.logs').unlink(cr, uid, logs_ids)
        #
        dados = self.read(cr, uid, ids[0], [], context=context)
        if not dados:
            return True
        sql = """
                select c.id,
                    c.crmcal_case_id as wlal_case_id,
                    c.crmcal_user_id as wlal_user_id,
                    c.crmcal_stage_id as wlal_stage_ini_id,
                    c.crmcal_section_id as wlal_section_id,
                    c.crmcal_date as wlal_data_inicio,
                    (select x.crmcal_date
                    from crm_br_case_log x
                    where x.id > c.id and x.crmcal_case_id = c.crmcal_case_id and x.name in (
                        'Fechar','Close','Fechado','Fechar','Cancelar','Cancel','Cancelado',
                        'Parado','Pending','Pendente')
                    order by x.id
                    limit 1
                    ) as wlal_data_fim,
                    (select x.crmcal_stage_id
                    from crm_br_case_log x
                    where x.id > c.id and x.crmcal_case_id = c.crmcal_case_id and x.name in (
                        'Fechar','Close','Fechado','Fechar','Cancelar','Cancel','Cancelado',
                        'Parado','Pending','Pendente')
                    order by x.id
                    limit 1
                    ) as wlal_stage_fin_id,
                    (EXTRACT(
                        EPOCH FROM (
                            (select x.crmcal_date
                            from crm_br_case_log x
                            where x.id > c.id
                                  and x.crmcal_case_id = c.crmcal_case_id
                                  and x.name in ('Fechar','Close','Fechado','Fechar','Cancelar',
                                                'Cancel','Cancelado','Parado','Pending','Pendente')
                            order by x.id
                            limit 1) - c.crmcal_date
                            )
                        )
                    ) / 3600 as wlal_diferenca,
                    (CASE
                        WHEN ((EXTRACT(
                            EPOCH FROM (c.crmcal_date -
                                (select x.crmcal_date
                                from crm_br_case_log x
                                where x.crmcal_date < c.crmcal_date
                                  and x.crmcal_user_id = c.crmcal_user_id
                                  and x.name in ('Fechar','Close','Fechado','Fechar','Cancelar',
                                        'Cancel','Cancelado','Parado','Pending','Pendente')
                                order by x.crmcal_date DESC
                                limit 1)
                                )
                            )
                            ) / 3600) > 11 THEN 0
                        ELSE (EXTRACT(
                            EPOCH FROM (c.crmcal_date -
                                (select x.crmcal_date
                                from crm_br_case_log x
                                where x.crmcal_date < c.crmcal_date
                                  and x.crmcal_user_id = c.crmcal_user_id
                                  and x.name in ('Fechar','Close','Fechado','Fechar','Cancelar',
                                        'Cancel','Cancelado','Parado','Pending','Pendente')
                                order by x.crmcal_date DESC
                                limit 1)
                                )
                            )
                            ) / 3600
                    END) as wlal_tempo_ocioso
                 from crm_br_case_log c
                 where crmcal_date between '%s 00:00:00' and '%s 23:59:59' and
                       name = 'Aberto'
                """
        sql = sql % (dados['wlac_data_inicio'], dados['wlac_data_fim'])
        if dados.get('wlac_section_id'):
            sql += ' and crmcal_section_id = %s' % dados['wlac_section_id'][0]
        if dados.get('wlac_user_id'):
            sql += ' and crmcal_user_id = %s' % dados['wlac_user_id'][0]
        if dados.get('wlac_case_id'):
            sql += ' and crmcal_case_id = %s' % dados['wlac_case_id'][0]
        if dados.get('wlac_stage_id'):
            sql += ' and crmcal_stage_id = %s' % dados['wlac_stage_id'][0]
        cr.execute(sql)
        for reg in cr.dictfetchall():
            vals = {
                'wlal_capa_id': ids[0],
                'wlal_case_id': reg['wlal_case_id'],
                'wlal_user_id': reg['wlal_user_id'],
                'wlal_section_id': reg['wlal_section_id'],
                'wlal_stage_ini_id': reg['wlal_stage_ini_id'],
                'wlal_stage_fin_id': reg['wlal_stage_fin_id'],
                'wlal_data_inicio': reg['wlal_data_inicio'],
                'wlal_data_fim': reg['wlal_data_fim'],
                'wlal_diferenca': reg['wlal_diferenca'],
                'wlal_tempo_ocioso': reg['wlal_tempo_ocioso'],
                'create_uid': uid,
                'create_date': time.strftime('%Y-%m-%d %H:%M:%S'),
            }
            # self.pool.get('wizard.logs.atendimentos.logs').create(cr, uid, vals, context)
            _idx = vals.keys()
            _campos = ''
            _values = ''
            for x in _idx:
                if vals.get(x):
                    _campos = _campos + str(x) + ', '
                    _values = _values + "'" + str(vals[x]) + "', "
            sql = "insert into wizard_logs_atendimentos_logs (%s) values (%s)" % (_campos[:-2], _values[:-2])
            cr.execute(sql)
        cr.commit()
        res = {
            'name': 'Logs dos CRM',
            'view_type': 'form',
            'view_mode': 'tree,calendar',
            'res_model': 'wizard.logs.atendimentos.logs',
            'view_id': False,
            'context': context,
            'target': 'current',
            'type': 'ir.actions.act_window',
            'domain': [('wlal_capa_id', '=', ids[0])],
        }
        self.write(cr, uid, ids, {}, context=context)
        return res



class wizard_logs_atendimentos_logs(osv.TransientModel):
    _name = 'wizard.logs.atendimentos.logs'
    _columns = {
        'wlal_capa_id': fields.many2one('wizard.logs.atendimentos.capa', 'Capa', ondelete="cascade",
                                        required=True),
        'wlal_case_id': fields.many2one('crm_br.case', 'Atendimento', select=True),
        'wlal_user_id': fields.many2one('res.users', 'Responsavel', select=True),
        'wlal_section_id': fields.many2one('crm_br.case.section', 'Sessao', select=True),
        'wlal_stage_ini_id': fields.many2one('crm_br.case.stage', 'Estagio inicial', select=True),
        'wlal_stage_fin_id': fields.many2one('crm_br.case.stage', 'Estagio final', select=True),
        'wlal_data_inicio': fields.datetime('Inicio', select=True),
        'wlal_data_fim': fields.datetime('Fim', select=True),
        'wlal_diferenca': fields.float('Tempo atendimento'),
        'wlal_tempo_ocioso': fields.float('Tempo ocioso')
    }
