# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields

VIEW_OPTIONS = [('no', 'Nao Criado'), ('form', 'Formulario'), ('tree', 'Lista'), ('tree,form', 'Lista e Formulario'), ('form,tree', 'Formulario e Lista')]
MENU_LIST = [
    (1,'My ',"[('section_id','=',SECTION_ID),('user_id','=',uid)]", 0, 'tree,form'),
    (2,'My Unclosed ',"[('section_id','=',SECTION_ID),('user_id','=',uid), ('state','not in', ['cancel', 'done'])]", 1, 'tree,form'),
    (5,'My Open ',"[('section_id','=',SECTION_ID),('user_id','=',uid), ('state','=','open')]", 2, 'tree,form'),
    (6,'My Pending ',"[('section_id','=',SECTION_ID),('user_id','=',uid), ('state','=','pending')]", 2, 'tree,form'),
    (7,'My Draft ',"[('section_id','=',SECTION_ID),('user_id','=',uid), ('state','=','draft')]", 2, 'tree,form'),
    (3,'My Late ',"[('section_id','=',SECTION_ID),('user_id','=',uid), ('date_deadline','<=',time.strftime('%Y-%m-%d')), ('state', 'not in', ['cancel', 'done'])]", 1, 'tree,form'),
    (4,'My Canceled ',"[('section_id','=',SECTION_ID),('user_id','=',uid), ('state','=','cancel')]", 1, 'no'),
    (8,'All ',"[('section_id','=',SECTION_ID),]", 0, 'tree,form'),
    (9,'All Unassigned ',"[('section_id','=',SECTION_ID),('user_id','=',False)]", 8, 'no'),
    (10,'All Late ',"[('section_id','=',SECTION_ID),('user_id','=',uid), ('date_deadline','<=',time.strftime('%Y-%m-%d')), ('state', 'not in', ['cancel', 'done'])]", 8, 'no'),
    (11,'All Canceled ',"[('section_id','=',SECTION_ID),('state','=','cancel')]", 8, 'no'),
    (12,'All Unclosed ',"[('section_id','=',SECTION_ID),('state','!=','cancel'), ('state','!=','done')]", 8, 'tree,form'),
    (13,'All Open ',"[('section_id','=',SECTION_ID),('state','=','open')]", 12, 'tree,form'),
    (14,'All Pending ',"[('section_id','=',SECTION_ID),('state','=','pending')]", 12, 'tree,form'),
    (15,'All Draft ',"[('section_id','=',SECTION_ID),('state','=','draft')]", 12, 'tree,form'),
    (16,'All Unclosed and Unassigned ',"[('section_id','=',SECTION_ID),('user_id','=',False),('state', 'not in', ['cancel', 'done'])]", 12, 'no'),
    (17,'New ',"[('section_id','=',SECTION_ID)]", 0, 'form,tree'),
]

class wizard_action_section(osv.TransientModel):

    _name = 'wizard.action.section'
    _columns = {
        'wact_sec_menu_name': fields.char('Nome do Menu',  size=30, required=True),
        'wact_sec_parent_id': fields.many2one('ir.ui.menu', 'Menu Superior', required=True),
        'wact_sec_section_id': fields.many2one('crm_br.case.section', 'Secao', required=True),
        "wact_sec_menu_ok": fields.boolean('Menu definido'),

        'wact_sec_my': fields.char('Meus', size=50),
        'wact_sec_unclosed': fields.char('Meus nao fechados', size=50),
        'wact_sec_open': fields.char('Meus Abertos', size=50),
        'wact_sec_pending': fields.char('Meus pendentes', size=50),
        'wact_sec_draft': fields.char('Meus esbocos', size=50),
        'wact_sec_late': fields.char('Meus atrasados ', size=50),
        'wact_sec_cancelled': fields.char('Meus cancelados', size=50),
        'wact_sec_all': fields.char('Todos', size=50),
        'wact_sec_all_unassigned': fields.char('Todos nao atribuidos', size=50),
        'wact_sec_all_late': fields.char('Todos atrasados', size=50),
        'wact_sec_all_cancelled': fields.char('Todos cancelados', size=50),
        'wact_sec_all_unclosed': fields.char('Todos nao fechados', size=50),
        'wact_sec_all_open': fields.char('Todos abertos', size=50),
        'wact_sec_all_pending': fields.char('Todos pendentes', size=50),
        'wact_sec_all_draft': fields.char('Todos esbocos', size=50),
        'wact_sec_all_unclo_unassig': fields.char('Todos nao fechados e nao atribuidos', size=50),
        'wact_sec_new': fields.char('Novo', size=50),

        'wact_sec_visao_my': fields.selection(VIEW_OPTIONS, 'Visao'),
        'wact_sec_visao_unclosed': fields.selection(VIEW_OPTIONS, 'Visao'),
        'wact_sec_visao_open': fields.selection(VIEW_OPTIONS, 'Visao'),
        'wact_sec_visao_pending': fields.selection(VIEW_OPTIONS, 'Visao'),
        'wact_sec_visao_draft': fields.selection(VIEW_OPTIONS, 'Visao'),
        'wact_sec_visao_late': fields.selection(VIEW_OPTIONS, 'Visao'),
        'wact_sec_visao_cancelled': fields.selection(VIEW_OPTIONS, 'Visao'),
        'wact_sec_visao_all': fields.selection(VIEW_OPTIONS, 'Visao'),
        'wact_sec_visao_a_unassigned': fields.selection(VIEW_OPTIONS, 'Visao'),
        'wact_sec_visao_a_late': fields.selection(VIEW_OPTIONS, 'Visao'),
        'wact_sec_visao_a_cancelled': fields.selection(VIEW_OPTIONS, 'Visao'),
        'wact_sec_visao_a_unclosed': fields.selection(VIEW_OPTIONS, 'Visao'),
        'wact_sec_visao_a_open': fields.selection(VIEW_OPTIONS, 'Visao'),
        'wact_sec_visao_a_pending': fields.selection(VIEW_OPTIONS, 'Visao'),
        'wact_sec_visao_a_draft': fields.selection(VIEW_OPTIONS, 'Visao'),
        'wact_sec_visao_a_unclo_unassig': fields.selection(VIEW_OPTIONS, 'Visao'),
        'wact_sec_visao_new': fields.selection(VIEW_OPTIONS, 'Visao'),
        'wact_informacao': fields.text('Informacoes'),
    }
    _defaults = {
        'wact_sec_menu_ok': False,
        'wact_sec_visao_my': 'tree,form',
        'wact_sec_visao_unclosed': 'tree,form',
        'wact_sec_visao_open': 'tree,form',
        'wact_sec_visao_pending': 'tree,form',
        'wact_sec_visao_draft': 'tree,form',
        'wact_sec_visao_late': 'tree,form',
        'wact_sec_visao_cancelled': 'tree,form',
        'wact_sec_visao_all': 'tree,form',
        'wact_sec_visao_a_unassigned': 'tree,form',
        'wact_sec_visao_a_late': 'tree,form',
        'wact_sec_visao_a_cancelled': 'tree,form',
        'wact_sec_visao_a_unclosed': 'tree,form',
        'wact_sec_visao_a_open': 'tree,form',
        'wact_sec_visao_a_pending': 'tree,form',
        'wact_sec_visao_a_draft': 'tree,form',
        'wact_sec_visao_a_unclo_unassig': 'tree,form',
        'wact_sec_visao_new': 'form,tree'
    }

    def wact_sec_button_menu_selecionado(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        action_section_dados = self.read(cr, uid, ids, ['wact_sec_menu_name'], context=context)
        if action_section_dados and isinstance(action_section_dados, list):
            action_section_dados = action_section_dados[0]
        if isinstance(action_section_dados, dict):
            menu_name = (action_section_dados.get('wact_sec_menu_name') or '').capitalize()
            str_meu = 'Meus %s'%menu_name
            str_meu_nfechado= 'Meus %s nao Fechados'%menu_name
            str_meu_aberto = 'Meus %s Abertos'%menu_name
            str_meu_pendente = 'Meus %s Pendentes'%menu_name
            str_meu_esboco = 'Meus %s Esbocos'%menu_name
            str_meu_atrasados = 'Meus %s Atrasados'%menu_name
            str_meu_cancelado = 'Meus %s Cancelados'%menu_name
            str_todos = 'Todos %s'%menu_name
            str_todos_natribuidos = 'Todos %s nao Atribuidos'%menu_name
            str_todos_atrasados = 'Todos %s Atrasados'%menu_name
            str_todos_cancelados = 'Todos %s Cancelados'%menu_name
            str_todos_nfechados = 'Todos %s nao Fechados'%menu_name
            str_todos_abertos = 'Todos %s Abertos'%menu_name
            str_todos_pendentes = 'Todos %s Pendentes'%menu_name
            str_todos_esbocos = 'Todos %s Esbocos'%menu_name
            str_todos_nfechados_natribuidos = 'Todos %s nao Fechados e nao Atribuidos'%menu_name
            str_novo = 'Novo %s'%menu_name
            vals_actsec = {
                'wact_sec_menu_ok': True,
                'wact_sec_my': str_meu,
                'wact_sec_unclosed': str_meu_nfechado,
                'wact_sec_open': str_meu_aberto,
                'wact_sec_pending': str_meu_pendente,
                'wact_sec_draft': str_meu_esboco,
                'wact_sec_late': str_meu_atrasados,
                'wact_sec_cancelled': str_meu_cancelado,
                'wact_sec_all': str_todos,
                'wact_sec_all_unassigned': str_todos_natribuidos,
                'wact_sec_all_late': str_todos_atrasados,
                'wact_sec_all_cancelled': str_todos_cancelados,
                'wact_sec_all_unclosed': str_todos_nfechados,
                'wact_sec_all_open': str_todos_abertos,
                'wact_sec_all_pending': str_todos_pendentes,
                'wact_sec_all_draft': str_todos_esbocos,
                'wact_sec_all_unclo_unassig': str_todos_nfechados_natribuidos,
                'wact_sec_new': str_novo
            }
            return self.write(cr, uid, ids, vals_actsec, context=context)
        return False

    def wact_sec_button_create_menu(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, list):
            ids = ids[0]

        browse_menus = self.browse(cr, uid, ids)
        vals_create_menu = {

            'menu_name': browse_menus.wact_sec_menu_name,
            'section_id': browse_menus.wact_sec_section_id.id,
            'section_code': browse_menus.wact_sec_section_id.code,
            'menu_parent_id': browse_menus.wact_sec_parent_id.id,

            'view_tree': False,
            'view_form': False,
            'view_calendar': False,

            'menu1': browse_menus.wact_sec_my,
            'menu2': browse_menus.wact_sec_unclosed,
            'menu3': browse_menus.wact_sec_open,
            'menu4': browse_menus.wact_sec_pending,
            'menu5': browse_menus.wact_sec_draft,
            'menu6': browse_menus.wact_sec_late,
            'menu7': browse_menus.wact_sec_cancelled,
            'menu8': browse_menus.wact_sec_all,
            'menu9': browse_menus.wact_sec_all_unassigned,
            'menu10': browse_menus.wact_sec_all_late,
            'menu11': browse_menus.wact_sec_all_cancelled,
            'menu12': browse_menus.wact_sec_all_unclosed,
            'menu13': browse_menus.wact_sec_all_open,
            'menu14': browse_menus.wact_sec_all_pending,
            'menu15': browse_menus.wact_sec_all_draft,
            'menu16': browse_menus.wact_sec_all_unclo_unassig,
            'menu17': browse_menus.wact_sec_new,

            'menu1_option': browse_menus.wact_sec_visao_my,
            'menu2_option': browse_menus.wact_sec_visao_unclosed,
            'menu3_option': browse_menus.wact_sec_visao_open,
            'menu4_option': browse_menus.wact_sec_visao_pending,
            'menu5_option': browse_menus.wact_sec_visao_draft,
            'menu6_option': browse_menus.wact_sec_visao_late,
            'menu7_option': browse_menus.wact_sec_visao_cancelled,
            'menu8_option': browse_menus.wact_sec_visao_all,
            'menu9_option': browse_menus.wact_sec_visao_a_unassigned,
            'menu10_option': browse_menus.wact_sec_visao_a_late,
            'menu11_option': browse_menus.wact_sec_visao_a_cancelled,
            'menu12_option': browse_menus.wact_sec_visao_a_unclosed,
            'menu13_option': browse_menus.wact_sec_visao_a_open,
            'menu14_option': browse_menus.wact_sec_visao_a_pending,
            'menu15_option': browse_menus.wact_sec_visao_a_draft,
            'menu16_option': browse_menus.wact_sec_visao_a_unclo_unassig,
            'menu17_option': browse_menus.wact_sec_visao_new,
        }

        self.write(cr,uid,ids, {'wact_informacao': 'Menu criado com sucesso. Pressione a tecla F5 para atualizar a pagina'}, context=context)
        self.pool.get('crm_br.case.section').menu_create_data(cr, uid, vals_create_menu, MENU_LIST, context)
        return {'type': 'ir.actions.act_window_close'}
