# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from mx.DateTime import now
from openerp.osv import osv, fields

from openerp import pooler
from openerp.tools.translate import _

class make_opportunity(osv.TransientModel):

    _name="make.opportunity"
    _columns = {
        'name': fields.char('Descricao da oportunidade', size=64),
        'planned_revenue': fields.float('Receita esperada', digits=(16,2)),
        'probability': fields.float('Probabilidade de sucesso', digits=(16,2)),
    }

    def selectopportunity(self, cr, uid, ids, context):
        pool = pooler.get_pool(cr.dbname)
        case_obj = pool.get('crm_br.case')
        for case in case_obj.browse(cr, uid, ids):
            if not case.pessoa_id:
                raise osv.except_osv(_('Warning !'),
                    _('You must assign a pessoa to this lead before converting to opportunity.\n' \
                  'You can use the convert to pessoa button.'))
        return {'name': case.name, 'probability': case.probability or 20.0, 'planned_revenue':case.planned_revenue}

    def makeOrder(self, cr, uid, ids, context):
        make_opportunity_dados = self.read(cr, uid, ids, [], context=context)
        for x in make_opportunity_dados:
            data = x
        pool = pooler.get_pool(cr.dbname)
        section_obj = pool.get('crm_br.case.section')
        data_obj = pool.get('ir.model.data')
        id = section_obj.search(cr, uid, [('code','=','oppor')], context=context)
        if not id:
            raise osv.except_osv(_('Error !'),
                _('You did not installed the opportunities tracking when you configured the crm_br module.' \
                  '\nI can not convert the lead to an opportunity, you must create a section with the code \'oppor\'.'
                  ))
        id = id[0]

        id2 = data_obj._get_id(cr, uid, 'crm_br', 'crm_br_case_form_view_oppor')
        if id2:
            id2 = data_obj.browse(cr, uid, id2, context=context).res_id


        case_obj = pool.get('crm_br.case')
        value = {}
        if context.get('active_id'):
            crm_br_case_id = context.get('active_id')
            case_obj._history(cr, uid, case_obj.browse(cr, uid, [crm_br_case_id]), 'convert')
            case_obj.write(cr, uid, crm_br_case_id, {
                'section_id': id,
                'name': data['name'],
                'planned_revenue': data['planned_revenue'],
                'probability': data['probability'],
            }, context=context)
            value = {
                'domain': "[]",
                'name': _('Opportunity'),
                'view_type': 'form',
                'view_mode': 'form,tree',
                'res_model': 'crm_br.case',
                'res_id': crm_br_case_id,
                'view_id': False,
                'views': [(id2,'form'),(False,'tree'),(False,'calendar'),(False,'graph')],
                'type': 'ir.actions.act_window',
            }
        return value


# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
