# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from mx.DateTime import now


case_form = """<?xml version="1.0"?>
<form string="Converter para pessoa">
    <label string="Voce deve verificar se esta pessoa ja esta cadastrada!" colspan="4"/>
    <field name="pessoa" readonly="1"/>
    <newline/>
    <field name="pessoa_tipo"/>
    <newline/>
    <field name="cpf_cnpj"/>
    <newline/>
    <field name="contato"/>
    <newline/>
    <field name="tipo_contato"/>
    <newline/>
    <field name="close"/>
</form>"""

case_fields = {
    'close': {'type':'boolean', 'string':'Close Lead'},
    'pessoa': {'type':'char', 'string':'Pessoa', 'size':64},
    'pessoa_tipo' : {'type':'selection', 'selection': [('F','Fisica'), ('J','Juridica')],'string':'Tipo Pessoa', 'required':True},
    'cpf_cnpj' : {'type':'char', 'string':'CPF/CNPJ', 'size':19},
    'contato' : {'type':'char', 'string':'Contato', 'size':64, 'required':True},
    'tipo_contato': {'type':'many2one', 'relation':'adm.relacionamento.tipo', 'string':'Tipo de relacionamento', 'required':True},
}


#class make_pessoa(wizard.interface):
#
#    def _selectPessoa(self, cr, uid, data, context):
#        pool = pooler.get_pool(cr.dbname)
#        case_obj = pool.get('crm_br.case')
#        for case in case_obj.browse(cr, uid, data['ids']):
#            data['form']['pessoa_tipo']='J'
#            data['form']['pessoa']=case.pessoa_name
#            data['form']['contato']=case.pessoa_name2
#            if case.pessoa_id:
#                raise wizard.except_wizard(_('Warning !'),
#                    _('A pessoa is already defined on this lead.'))
#        return data['form']
#
#    def _makeOrder(self, cr, uid, data, context):
#        pool = pooler.get_pool(cr.dbname)
#        case_obj = pool.get('crm_br.case')
#        pessoa_obj = pool.get('adm.pessoa')
#        relacao_obj = pool.get('adm.pessoa.relacionamento')
#        contact_obj = pool.get('adm.pessoa.endereco')
#        for case in case_obj.browse(cr, uid, data['ids']):
#            pessoa_id = pessoa_obj.search(cr, uid, [('name', '=', case.pessoa_name or case.name)])
#            _cpf_cnpj='';
#            if data['form']['cpf_cnpj']:
#               _cpf_cnpj = data['form']['cpf_cnpj']
#            if not pessoa_id:
#                if _cpf_cnpj:
#                   pessoa_id = pessoa_obj.search(cr, uid, [('cpf_cnpj', '=', _cpf_cnpj)])
#            if pessoa_id:
#                raise wizard.except_wizard(_('Warning !'),_('A pessoa is already existing with the same name.'))
#            else:
#                pessoa_id = pessoa_obj.create(cr, uid, {
#                    'name': case.pessoa_name or case.name,
#                    'cpf_cnpj': _cpf_cnpj,
#                    'pessoa_tipo': data['form']['pessoa_tipo'],
#                }, context)
##
#                if case.pessoa_phone:
#                    tipo_fone_id =  pool.get('adm.telefone.tipo').search(cr, uid, [('name', '=', 'Comercial')])[0]
#                    a={
#                    'pessoa_id': pessoa_id,
#                    'telefone_tipo_id':tipo_fone_id,
#                    'ddd':case.pessoa_phone_ddd,
#                    'numero':case.pessoa_phone,
#                    }
#                    fone_id = pool.get('adm.pessoa.telefone').create(cr, uid, a, context)
#                if case.pessoa_mobile:
#                    tipo_fone_id =  pool.get('adm.telefone.tipo').search(cr, uid, [('name', '=', 'Celular')])[0]
#                    fone_id = pool.get('adm.pessoa.telefone').create(cr, uid, {
#                    'pessoa_id': pessoa_id,
#                    'telefone_tipo_id':tipo_fone_id,
#                    'ddd':case.pessoa_phone_ddd,
#                    'numero':case.pessoa_mobile,
#                    }, context)
#            contact_id = pessoa_obj.search(cr, uid, [('name', '=', data['form']['contato']),('pessoa_tipo', '=', 'F')])
#            if contact_id:
#               contact_id=contact_id[0]
#            else:
#                if data['form']['contato'] == case.pessoa_name or data['form']['contato'] == case.name:
#                    pass
#                else:
#                    contact_id = pessoa_obj.create(cr, uid, {
#                        'name': data['form']['contato'],
#                        'pessoa_tipo': 'F',
#                    }, context)
#            relacao_id = relacao_obj.search(cr, uid, [('pessoa_id', '=', pessoa_id),('dependente_id', '=', contact_id)])
#            if relacao_id:
#               relacao_id=relacao_id=[0]
#            else:
#               relacao_id = relacao_obj.create(cr, uid, {
#                    'pessoa_id':pessoa_id,
#                    'dependente_id':contact_id,
#                    'relacionamento_tipo_id':data['form']['tipo_contato'],
#                }, context)
#
#
#        case_obj.write(cr, uid, data['ids'], {
#            'pessoa_id': pessoa_id,
#        }, context)
#        if data['form']['close']:
#            case_obj.case_close(cr, uid, data['ids'])
#
#        value = {
#            'domain': "[]",
#            'view_type': 'form',
#            'view_mode': 'form,tree',
#            'res_model': 'adm.pessoa',
#            'res_id': int(pessoa_id),
#            'view_id': False,
#            'type': 'ir.actions.act_window',
#        }
#        return value
#
#    states = {
#        'init': {
#            'actions': [_selectPessoa],
#            'result': {'type': 'form', 'arch': case_form, 'fields': case_fields,
#                'state' : [('confirm', 'Confirm', 'gtk-go-forward'),('end', 'Cancel', 'gtk-cancel')]}
#        },
#        'confirm': {
#            'actions': [],
#            'result': {'type': 'action', 'action': _makeOrder, 'state': 'end'}
#        }
#    }
#
#make_pessoa('crm_br.case.pessoa_create')
## vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

