# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import osv


class crm_br_case(osv.Model):

    _inherit = 'crm_br.case'

    def crmcas_button_abri_atividade(self, cr, uid, ids, context=None):
        """
        O metodo cria uma nova atividade (crm_br_case) baseada nos dados dessa (ids). Nessa nova e
        levado os dados do item do checklist.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de registros da tabela dessa classe.
        :type ids: list
        :param context: dados contextuais.
        :type context: dict
        :return: Verdadeiro.
        :rtype: bool
        """
        context = context and context.copy() or {}

        case_id = ids[0] if isinstance(ids, (list, tuple)) else ids
        brw_crm_br_case = self.browse(cr, uid, case_id, context)
        descricao_atividade = brw_crm_br_case.description or ''
        param = '%s*|*%s*|*%s*|*%s' % \
                    (brw_crm_br_case.section_id.id, brw_crm_br_case.stage_id.id,
                     brw_crm_br_case.state, brw_crm_br_case.crmcas_produto_id.id)
        self.pool.get('ir.config_parameter').set_param(cr, uid, 'gerar_checklist', param)
        stage_ids = self.pool.get('crm_br.case.stage').search(
            cr, uid, ['|', ('name', '=', 'Previsão'), ('name', '=', 'Previsao')], context=context)
        stage_id = False
        if stage_ids:
            stage_id = stage_ids[0]
        vals = {
            'name': brw_crm_br_case.crmcas_checklist_item_id.name,
            'sequence': brw_crm_br_case.crmcas_checklist_item_id.sequence,
            'section_id': brw_crm_br_case.section_id.id,
            'user_id': uid,
            'crmcas_produto_id': brw_crm_br_case.crmcas_produto_id.id,
            'crmcas_checklist_item_id': brw_crm_br_case.crmcas_checklist_item_id.id,
            'category2_id': brw_crm_br_case.category2_id.id,
            'versao_liberar_id': brw_crm_br_case.versao_liberar_id.id,
            'stage_id': stage_id,
            'state': 'pending',
            'history_line': [(0, 0, {'description': descricao_atividade})],
            'ref': '%s,%s' % ('crm_br.case', str(case_id))
        }
        new_case_id = self.create(cr, uid, vals, context=context)

        self.write(cr, uid, [case_id], {'description': 'Aberto atividade: %s.' % new_case_id},
                   context)
        context['crmbch_problema'] = True
        self.case_log(cr, uid, [case_id], context)
        return True
