# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################


from openerp.osv import fields, osv


class crm_checklist_checklist_linhas(osv.Model):
    """
    Prefixo crmckl_
    """
    _name = "crm_checklist.checklist.linhas"
    _description = "linhas do checklist"
    _inherits = {'crm_checklist.checklist.capa':'crmckl_capa_id'}
    _columns = {
        'id': fields.integer('Codigo', readonly=True),
        'crmckl_capa_id': fields.many2one('crm_checklist.checklist.capa', 'Capa', required=True, ondelete='cascade', select=True),
        'name': fields.char('Atividade', size=64, required=True),
        'crmckl_descricao': fields.text('Descricao'),
        'sequence': fields.integer('Sequencia', required=True),
        'crmckl_case_ids': fields.one2many('crm_br.case', 'crmcas_checklist_item_id', 'Atividades'),
        'crmckl_anexo_ids': fields.one2many(
            'crm_checklist.anexo', 'cckanx_anexo_id', 'Anexo', help='Anexos da atividade'),
    }
    _defaults = {
        'sequence': lambda * a: 10,
    }
    _order = 'crmckl_capa_id,sequence,id'
