# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
import time
from ...crm_br.model.crm_br_case_data import AVAILABLE_STATES
WCA_STATE = AVAILABLE_STATES




class wizard_crm_checklist_capa(osv.TransientModel):
    _name = 'wizard.crm_checklist.capa'

    def _get_defaults(self, cr, uid, context=None, campo=None):
        """
        Busca parametros default.

        :param cr: cursor no banco de dados
        :param user: id da tabela res_users, identificador do usuario
        :param context: um dicionario padrao para valores contextuais
        :type cr: object
        :type user: int
        :type context: dict
        :return: o valor do atributo ´custo_inventario' definido no parametro do estoque.
        :rtype: str

        """
        # context = context and context.copy() or dict()
        dados = self.pool.get('ir.config_parameter').get_param(cr, uid, 'gerar_checklist', False)
        res = None
        try:
            if dados:
                lista = dados.split('*|*')
                if campo == 'section':
                    res = int(lista[0])
                if campo == 'stage':
                    res = int(lista[1])
                if campo == 'state':
                    res = lista[2]
                if campo == 'produto':
                    res = int(lista[3])
        except:
            pass
        return res

    _columns = {
        'wcca_checklist_id': fields.many2one('crm_checklist.checklist.capa', 'Checklist',
                                             required=True, ondelete='cascade', select=True),
        'wcca_versao_id': fields.many2one('crm_br.case.category2', 'Versao', required=True,
                                          select=True),
        'wcca_section_id': fields.many2one('crm_br.case.section', 'Secao', required=True),
        'wcca_stage_id': fields.many2one('crm_br.case.stage', 'Estagio', required=True),
        'wcca_state': fields.selection(AVAILABLE_STATES, 'Status', size=16, required=True),
        'wcca_produto_id': fields.many2one('crm_br.produto', 'Produto', required=True),
    }
    _defaults = {
        'wcca_section_id': lambda s, cr, uid, c: s._get_defaults(cr, uid, c, 'section'),
        'wcca_stage_id': lambda s, cr, uid, c: s._get_defaults(cr, uid, c, 'stage'),
        'wcca_state': lambda s, cr, uid, c: s._get_defaults(cr, uid, c, 'state'),
        'wcca_produto_id': lambda s, cr, uid, c: s._get_defaults(cr, uid, c, 'produto'),
    }

    def wlac_button_gerar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not ids:
            return True
        obj_crm_br_case = self.pool.get('crm_br.case')
        obj_ir_attachment = self.pool.get('ir.attachment')
        for brw_dados in self.browse(cr, uid, ids, context=context):
            param = '%s*|*%s*|*%s*|*%s' % \
                    (brw_dados.wcca_section_id.id, brw_dados.wcca_stage_id.id, brw_dados.wcca_state,
                     brw_dados.wcca_produto_id.id)
            self.pool.get('ir.config_parameter').set_param(cr, uid, 'gerar_checklist', param)
            for brw_linha in brw_dados.wcca_checklist_id.crmckc_linha_ids:
                vals = {
                    'name': brw_linha.name,
                    'sequence': brw_linha.sequence,
                    'section_id': brw_dados.wcca_section_id.id,
                    'user_id': uid,
                    'crmcas_produto_id': brw_dados.wcca_produto_id.id,
                    'crmcas_checklist_item_id': brw_linha.id,
                    'crmcas_tipo': 'Outros',
                    'category2_id': brw_dados.wcca_versao_id.id,
                    'versao_liberar_id': brw_dados.wcca_versao_id.id,
                    'stage_id': brw_dados.wcca_stage_id.id,
                    'state': brw_dados.wcca_state,
                    'history_line': [(0, 0, {'description': brw_linha.crmckl_descricao})]
                }
                case_id = obj_crm_br_case.create(cr, uid, vals, context=context)
                if not case_id:
                    continue
                for anexo in filter(lambda a: a.cckanx_arquivo, brw_linha.crmckl_anexo_ids):
                    vals_anexo = {'name': anexo.name, 'datas_fname': anexo.name,
                                  'res_model': 'crm_br.case', 'res_id': case_id,
                                  'store_fname': anexo.name, 'datas': anexo.cckanx_arquivo}
                    obj_ir_attachment.create(cr, uid, vals_anexo, context)
        return True



