# -*- encoding: utf-8 -*-

# Funcoes da classe crm_br_case


def crmcas_get_pedido_id(self, cr, uid, ids, field_name, arg, context=None):
    """
    Metodo de campo funcional. Encontra o id do pedido (estoquepedidos_pedido_capa) para esse
    objeto a partir do item do pedido (estoquepedidos_pedido_item).
    :param cr: cursor no banco de dados.
    :type cr: object
    :param uid: id da tabela res_users, identificador do usuario.
    :type uid: int
    :param ids: lista de id da tabela desse objeto.
    :type ids: list
    :param fields_name: descricao do campo funcional (atributo).
    :type fields_name: str
    :param arg: tupla com argumentos de pesquisa.
    :type arg: tuple
    :param context: dicionario com valores contextuais.
    :type context: dict
    :return: dicionario com a descricao dos campos e seus respectivos valores.
    :rtype: dict
    """
    context = context and context.copy() or {}
    res = {}
    for case in self.browse(cr, uid, ids, context):
        res[case.id] = False
        if not case.crmcas_pedido_item_id:
            continue
        res[case.id] = case.crmcas_pedido_item_id.pedido_id.id
    return res
