# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time
from openerp.tools.translate import _


class delivery_entregas(osv.Model):
    _name = 'delivery.entregas'
    _inherit = 'delivery.entregas'

    def sequence_criar(self, cr, uid, context=None):
        context = context and context.copy() or {}
        __code = 'numero_delivery'
        __name = 'Entregas do Delivery'
        company_id = 1
        vals = {
            'name': __name,
            'code': __code,
            'padding': 4,
            'company_id': company_id,
            'prefix': '%(month)s/%(day)s-',
            'implementation': 'no_gap',
        }
        consulta = self.pool.get('ir.sequence').search(cr, uid, [('code', '=', __code), ('company_id', '=', company_id)], context=context)
        if not consulta:
            self.pool.get('ir.sequence.type').create(cr, uid, {'name': __name, 'code': __code}, context)
            #todo: verificar se e possivel isolar a transacao para apenas comitar no ir.sequence
            cr.commit()
        self.pool.get('ir.sequence').create(cr, uid, vals, context)
        #todo: verificar se e possivel isolar a transacao para apenas comitar no ir.sequence
        cr.commit()
        return True

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        vals['dvyeta_numero'] = self.pool.get('adm.utils').get_sequence(cr, uid, self._name, 'numero_delivery')
        res = super(delivery_entregas, self).create(cr, uid, vals, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        """
        a definição do state deve ser automatica, se não saiu para entregar deve ser PE
        Se já saiu e não retornou deve ser EE em entrega
        Se já retornou deve ser ET entregue
        ou CA quando estiver cancelado
        """
        for entrega in self.read(
                cr, uid, ids if isinstance(ids, list) else [ids],
                ['state', 'dvyeta_entrega_saida', 'dvyeta_entrega_retorno'], context=context):
            saida = vals.get('dvyeta_entrega_saida') or entrega.get('dvyeta_entrega_saida')
            retorno = vals.get('dvyeta_entrega_retorno') or entrega.get('dvyeta_entrega_retorno')
            state = vals.get('state') or entrega.get('state')

            if context.get('apontamento_delivery'):
                if state != "CA":  # nao cancelado
                    if saida and retorno and state != 'ET':  # entregue
                        vals['state'] = 'ET'
                    elif saida and state != 'EE':  # em entrega
                        vals['state'] = 'EE'

            if not all([saida, retorno]):
                continue
            if retorno < saida:
                raise osv.except_osv(_('Atencao'),
                                     _('A data de retorno nao pode ser menor que a data de saida.'))

        res = super(delivery_entregas, self).write(cr, uid, ids, vals, context)
        return res

    def button_cancelar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = self.write(cr, uid, ids, {'state':'CA'}, context=context)
        return res

    def button_pendente(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = self.write(cr, uid, ids, {'state':'PE'}, context=context)
        return res

    def button_esboco(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = self.write(cr, uid, ids, {'state':'ES'}, context=context)
        return res

    def _needaction_domain_get(self, cr, uid, context=None):
        """
            Mostra a quantidade de entregas pendentes'

            @param cr: {cursor} a linha atual do cursor do banco de dados,
            @param uid: {int} o ID do usuário utilizado para a verificacao de perfil,
            @param context: {dict} um dicionário padrao para valores contextuais,
            @return: {list} dominio utilizado para contar as entregas pendentes

            @see: openerp/addons/base/ir/ir.needaction (class ir_needaction_mixin)
            @copyright: OpenERP SA.
            """
        context = context and context.copy() or {}
        return [('state', 'in', ['PE', 'EE'])]
