# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009-2014 All Rights Reserved. Luiz Fernando Maciel Franca
#                     www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################


from openerp.osv import osv
from datetime import datetime, timedelta
from dateutil.parser import parse
from openerp.tools.translate import _
from SigUtils.formatastring import formataString
from SigUtils.numero import getNumeroEditado
import uuid
import time
import subprocess


class estoquepedidos_pedido_capa(osv.Model):
    """
    Pedidos
    """
    _inherit = 'estoquepedidos.pedido.capa'

    def default_get(self, cr, uid, fields_list, context=None):
        context = context and context.copy() or {}
        res = super(estoquepedidos_pedido_capa, self).default_get(cr, uid, fields_list, context)
        if context.get('tree_view_ref') == 'delivery.view_delivery_estoquepedidos_pedido_tree':
            raise osv.except_osv(_('Atencao'), _('Nao e possivel criar pedido por esse menu.'))
        return res

    def pedcap_button_delivery_montar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        context.update({'pedcap_write_state': True})
        vals = {'state': 'E', 'pedcap_montagem_inicio': datetime.now()}
        res = self.write(cr, uid, ids, vals, context)
        return res

    def pedcap_button_delivery_checklist(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        _spg = self.pool.get
        if not ids:
            return True
        dados_parametro = _spg('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', ['estpar_comando_guilhotina',
                                 'estpar_dlvr_comando_guilhotina',
                                 'estpar_dlvr_impressora_checklist',
                                 'estpar_dlvr_colunas_por_linha'])
        comando_guilhotina = dados_parametro.get('estpar_comando_guilhotina')
        line_size = dados_parametro.get('estpar_dlvr_colunas_por_linha') or 42
        line_break = '\r\n'
        if not dados_parametro.get('estpar_dlvr_impressora_checklist'):
            raise osv.except_osv(_('Atencao'), _('Impressora para checklist nao configurada!'))

        browse_pedido = _spg('estoquepedidos.pedido.capa').browse(cr, uid, ids[0], context)
        controle = uuid.uuid4().__str__()
        _nome_arq = '/tmp/%s.txt' % controle
        pedido_txt = open(_nome_arq, 'wb')
        data_emissao = browse_pedido.data_emissao or ''
        if data_emissao:
            data_emissao = time.strftime('%d/%m/%Y', time.strptime(data_emissao,
                                                                   '%Y-%m-%d'))
        data_entrega = browse_pedido.data_entrega or ''
        if data_entrega:
            data_entrega = time.strftime('%d/%m/%Y', time.strptime(data_entrega,
                                                                   '%Y-%m-%d'))
        horario_entrega = ''
        if browse_pedido.pedcap_horario_entrega:
           horario_entrega = _spg('adm.utils').admutl_converte_hora_float_to_str(browse_pedido.pedcap_horario_entrega)
        numero_pedido = browse_pedido.numero_pedido
        pedido_txt.write(formataString('-' * line_size, line_size, ' ', 'D', 'N', 'S') + line_break)
        linha = formataString('Checklist para montagem', line_size, ' ', 'C', 'N', 'S')
        pedido_txt.write(linha + line_break)
        pedido_txt.write(line_break)
        linha = formataString('Pedido: %s' % numero_pedido, 23, ' ', 'D', 'N', 'S')
        if (23 + 19) > line_size:
            pedido_txt.write(linha + line_break)
            linha = ''
        linha += formataString('Emissao: %s' % data_emissao, 19, ' ', 'E', 'N', 'S')
        pedido_txt.write(line_break)
        empresa = _spg('adm.utils').admutl_remover_acentuacao(cr, uid, browse_pedido.company_id.name.encode('utf-8'))
        for x in _spg('adm.utils').admutl_quebra_string(empresa, line_size):
            pedido_txt.write(x + line_break)
        pessoa_pedido = browse_pedido.pessoa_id.name or ''
        cliente = _spg('adm.utils').admutl_remover_acentuacao(cr, uid, pessoa_pedido.encode('utf-8'))
        linha = 'CLIENTE: %s' % cliente
        for x in _spg('adm.utils').admutl_quebra_string(linha, line_size):
            pedido_txt.write(x + line_break)
        pedido_txt.write(line_break)
        _entrData = formataString('Entrega: %s' % data_entrega, 20, ' ', 'D', 'N', 'S')
        _entrHora = formataString('Horario: %s' % horario_entrega, 14,
                              ' ', 'D', 'N', 'S') + line_break
        if (20 + 14) > line_size:
            pedido_txt.write(_entrData + line_break)
            pedido_txt.write(_entrHora + line_break)
        else:
            linha = _entrData + \
                    ' ' * (line_size - (20 + 14)) + \
                    _entrHora
            pedido_txt.write(linha + line_break)
        pedido_txt.write(formataString('-' * line_size, line_size, ' ', 'D', 'N', 'S') + line_break)
        if browse_pedido.observacao:
            pedido_txt.write('' + line_break)
            observacao = browse_pedido.observacao
            tam = 12
            linha = 'Observacao: '
            while observacao:
                linha += formataString(observacao[:line_size - tam], line_size - tam, ' ', 'D', 'N',
                                       'S')
                observacao = observacao[line_size - tam:]
                tam = 0
                pedido_txt.write(linha + line_break)
                linha = ''
            pedido_txt.write(formataString('-' * line_size, line_size, ' ', 'D', 'N', 'S') + line_break)

        pedido_txt.write(line_break)
        pedido_txt.write(formataString('Itens para montar', line_size, ' ', 'C', 'N', 'S') + line_break)
        pedido_txt.write(formataString('-' * line_size, line_size, ' ', 'D', 'N', 'S') + line_break)

        itens_pedido = browse_pedido.pedido_item_ids or []
        for x in itens_pedido:
            linha = '[  ] '
            linha += getNumeroEditado(x.qtde_pedida or 0, 0) + 'x'
            descricao_produto = x.grade_id.name.encode('utf-8').replace('°', '')
            descricao_produto = _spg('adm.utils').admutl_remover_acentuacao(cr, uid, descricao_produto)
            linha += descricao_produto
            _primeiro = True
            for lin in _spg('adm.utils').admutl_quebra_string(linha, line_size, line_size - 5):
                if _primeiro:
                    pedido_txt.write(lin + line_break)
                else:
                    pedido_txt.write('     ' + lin + line_break)
                _primeiro = False
            if not x.observacao:
                continue
            descricao_observacao = x.observacao.encode('utf-8').replace('°', '')
            descricao_observacao = _spg('adm.utils').admutl_remover_acentuacao(cr, uid, descricao_observacao)
            for lin in _spg('adm.utils').admutl_quebra_string(descricao_observacao, line_size):
                linha = formataString(lin, line_size, ' ', 'D', 'N', 'S')
                pedido_txt.write(linha + line_break)

        pedido_txt.write(line_break)
        pedido_txt.write(line_break)
        pedido_txt.write(line_break)
        pedido_txt.write(formataString('Qualidade do pedido', line_size, ' ', 'C', 'N', 'S') + line_break)
        pedido_txt.write(formataString('-' * line_size, line_size, ' ', 'D', 'N', 'S') + line_break)
        pedido_txt.write(line_break)
        pedido_txt.write(line_break)
        pedido_txt.write('[  ] Itens corretos' + line_break)
        pedido_txt.write(line_break)
        pedido_txt.write('[  ] Todos os itens' + line_break)
        pedido_txt.write(line_break)
        pedido_txt.write('[  ] Folheto' + line_break)
        pedido_txt.write(line_break)
        pedido_txt.write(line_break)
        pedido_txt.write('Assinatura:..........................' + line_break)
        pedido_txt.write(line_break)

        if comando_guilhotina:
            try:
                pedido_txt.write(''.join(map(lambda x: chr(int(x)), comando_guilhotina.split('-'))))
            except:
                pass
        pedido_txt.close()
        impressora = "-d" + dados_parametro.get('estpar_dlvr_impressora_checklist')
        subprocess.call(["lp", '-n1', impressora, _nome_arq])
        subprocess.call(['rm', _nome_arq])
        return True

    def pedcap_button_delivery_encerrar_montagem(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        context.update({'pedcap_write_state': True})
        vals = {'state': 'O', 'pedcap_montagem_fim': datetime.now()}
        for pedido in self.browse(cr, uid, ids, context):
            pedido_item_ids = list()
            for item in pedido.pedido_item_ids:
                if item.qtde_atendida:
                    continue
                pedido_item_ids.append((1, item.id, {'qtde_atendida': item.qtde_pedida}))
            if pedido_item_ids:
                vals.update({'pedido_item_ids': pedido_item_ids})
            res = self.write(cr, uid, [pedido.id], vals, context)
        return res

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        if context.get('delivery_montagem'):
            order = 'pedcap_origem ASC, pedcap_horario_entrega ASC'
        res = super(estoquepedidos_pedido_capa, self).search(cr, uid, args, offset, limit, order,
                                                             context, count)
        return res

    def pedcap_get_dado_extra(self, cr, uid, ids, context=None):
        """
        O metodo encontra os dados que se encontram nesse modulo, necessarios para a impressao
        dos pedidos.
        :param cr: cursor no banco de dados.
        :type: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type: integer
        :param ids: lista de id da tabela desse objeto.
        :type: list
        :param context: dicionario com valores contextuais.
        :type: dict
        :return: dicionario. Cada chave representa um id de um pedido. Cada valor dessa chave e um
        dicionario com os campos e seus respectivos valores.
        :rtype: dict
        """
        if not isinstance(ids, list):
            ids = [ids]
        context = context and context.copy() or {}
        res = super(estoquepedidos_pedido_capa, self).pedcap_get_dado_extra(cr, uid, ids, context)
        brw_pedido_capa = self.browse(cr, uid, ids, context)
        obj_adm_utils = self.pool.get('adm.utils')
        for pedido in brw_pedido_capa:
            horario_entrega = pedido.pedcap_horario_entrega or ''
            if horario_entrega:
                horario_entrega = obj_adm_utils.admutl_float_to_time(horario_entrega)
            data_entrega = pedido.data_entrega or ''
            if data_entrega:
                data_entrega = parse(data_entrega).strftime('%d/%m/%Y')
            origem = pedido.pedcap_origem or ''
            if origem == '1':
                origem = 'Balcao'
            elif origem == '2':
                origem = 'Externo'
            condicao_ids = {}
            map(lambda i: condicao_ids.update({i.id: i.pedcdc_valor_troco or 0}),
                pedido.pedido_condicao_ids)
            vals = {
                'horario_entrega': horario_entrega,
                'origem': origem,
                'condicao_dados': condicao_ids,
                'data_entrega': data_entrega
            }
            if pedido.id in res.keys():
                res[pedido.id].update(vals)
            else:
                res[pedido.id] = vals
        return res

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if (vals.get('pedcap_rota_entrega') and
                not (vals.get('pedcap_horario_entrega') or vals.get('data_entrega'))):
            args = [('pessoa_id', '=', vals.get('pessoa_id')),
                    ('company_id', '=', vals.get('company_id'))]
            cliente_ids = self.pool.get('financeiro.cliente').search(cr, uid, args, context=context)
            horario_ids = []
            if cliente_ids:
                args = [('dvyhor_cliente_id', '=', cliente_ids[0])]
                horario_ids = self.pool.get('delivery.horarios').search(cr, uid, args, context=context)
            if not horario_ids:
                args = [('dvyhor_rota_id', '=', vals.get('pedcap_rota_entrega'))]
                horario_ids = self.pool.get('delivery.horarios').search(cr, uid, args, context=context)
            if horario_ids:
                horariosBrw = self.pool.get('delivery.horarios').browse(cr, uid, horario_ids, context=context)
                _primeiraHoraEntrega = _horaLimite = _horaEntrega = ''
                for horarioBrw in horariosBrw:
                    if not _primeiraHoraEntrega:
                        _primeiraHoraEntrega = horarioBrw.dvyhor_horario_entrega
                    # Precisa retirar o timezone
                    _horaAgora = self.pool.get('adm.utils').admutl_converte_hora_str_to_float(self.pool.get('adm.utils').admutl_datetime_to_timezone(cr, uid, datetime.now(), formato='%H:%M'))
                    _horaLimite = horarioBrw.dvyhor_horario_limite
                    if _horaAgora > _horaLimite:
                        continue
                    _horaEntrega = horarioBrw.dvyhor_horario_entrega
                    break
                if _horaEntrega:
                    vals['pedcap_horario_entrega'] = _horaEntrega
                    vals['data_entrega'] = datetime.now().strftime('%Y-%m-%d')
                else:
                    # Entrega no dia seguinte
                    vals['pedcap_horario_entrega'] = _primeiraHoraEntrega
                    vals['data_entrega'] = (datetime.strptime(self.pool.get('adm.utils').admutl_datetime_to_timezone(cr, uid, datetime.now()), '%d-%m-%Y %H:%M:%S')+ timedelta(days=1)).strftime('%Y-%m-%d')
        ret = super(estoquepedidos_pedido_capa, self).create(cr, uid, vals, context=context)
        return ret