# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009-2014 All Rights Reserved. Luiz Fernando Maciel Franca
#                     www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################



from openerp.osv import osv, fields
from openerp.tools.translate import _
from funcoes import _pedcap_get_delivery_state


class estoquepedidos_pedido_capa(osv.Model):
    """
    Pedidos
    """
    _name = 'estoquepedidos.pedido.capa'
    _inherit = 'estoquepedidos.pedido.capa'

    def pedcap_fields_selection_state(self, cr, uid, context=None):
        context = context and context.copy() or {}
        res = super(estoquepedidos_pedido_capa, self).pedcap_fields_selection_state(cr, uid,
                                                                                    context)
        res.extend([('E', 'Em montagem'), ('O', 'Montado')])
        return res

    def pedcap_get_mostrar_botao_separar_itens(self, cr, uid, ids, field, args=[], context=None):
        context = context and context.copy() or {}
        res = super(estoquepedidos_pedido_capa, self).pedcap_get_mostrar_botao_separar_itens(cr, uid, ids, field, args, context=None)
        for id in ids:
            state = self.read(cr, uid, id, ['state'], context=context)
            if isinstance(state, list):
                state = state[0]
            state = state.get('state')
            if state == 'O': # 'O' = Montado
                res[id] = True
        return res

    _columns = {
        'pedcap_delivery_id': fields.many2one('delivery.entregas', 'Entrega', select=True),
        'pedcap_delivery_state': fields.function(_pedcap_get_delivery_state, method=True,
                                                 string='Situacao da entrega',
                                                 type='char', store=False, size=15),
        'pedcap_horario_entrega': fields.float('Horario de entrega'),
        'pedcap_montagem_funcionario_id': fields.many2one('rh.funcionario', 'Montador',
                                                          ondelete='restrict'),
        'pedcap_montagem_inicio': fields.datetime('Inicio da montagem'),
        'pedcap_montagem_fim': fields.datetime('Fim da montagem'),
        'state': fields.selection(pedcap_fields_selection_state, 'Estado do Pedido', required=True,
                                  size=1),
        'pedcap_origem': fields.selection([('1', 'Balcao'), ('2', 'Externo')], 'Origem', size=1,
                                          required=False),
        'mostrar_botao_separar_itens': fields.function(pedcap_get_mostrar_botao_separar_itens, method=True,
                                                       string="Mostrar Botao Separar Itens", type='boolean',
                                                       store=False),
    }
    _defaults = {
        'pedcap_origem': '1',
    }