# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2016 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2016, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


# noinspection PyAbstractClass,PyPep8Naming
class relatorio_pedido_venda_osv(osv.TransientModel):
    """
    Heranca na classe ´relatorio_pedido_venda_osv´.
    Formulario de dados de pedido de venda para elaboracao de relatorio.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _inherit = 'relatorio.pedido.venda.osv'

    # noinspection PyMethodMayBeStatic
    def get_pedido_status(self, cr, user, context=None):
        """
        Acrescenta ´Montado´ nas opcoes possiveis para o campo ´state´ do relatorio de pedido de
        venda.

        :param cr: a linha atual do cursor do banco de dados
        :param user: o ID do usuario utilizado para a verificacao de perfil
        :param context: um dicionario padrao para valores contextuais
        :type cr: cursor
        :type user: int
        :type context: dict
        :return: lista dos valores possiveis de selecao para o campo ´status´ (estado do pedico)
        atualizada com a opcao ´O´ (Montado).
        :rtype: list

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}
        result = super(relatorio_pedido_venda_osv, self).get_pedido_status(
            cr, user, context)
        result.append(('O', 'Montado'))

        return result

    _columns = {
        'state': fields.selection(get_pedido_status, 'Estado do pedido', size=1),
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
