# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time
from funcoes import _dvyace_get_valores


class delivery_acertos(osv.Model):
    # prefixo: dvyace_

    _name = 'delivery.acertos'
    _columns = {
        'dvyace_entregador_id': fields.many2one('delivery.entregador', 'Entregador', required=True,
                                                ondelete='restrict', select=True),
        'dvyace_data': fields.date('Data das entregas', required=True),
        'create_date': fields.datetime('Data/hora lancamento', readonly=True),
        'dvyace_valor_recebido': fields.float('Valor recebido', digits=(11, 2), required=True),
        'dvyace_diferenca': fields.function(_dvyace_get_valores, method=True, string='Diferenca',
                                            multi='valor', type='float', digits=(11, 2),
                                            store=True),
        'dvyace_total_entregas': fields.function(_dvyace_get_valores, method=True,
                                                 string='Total das entregas', multi='valor',
                                                 type='float', digits=(11, 2), store=True),
        'dvyace_entrega_ids': fields.many2many('delivery.entregas', 'm2m_delivery_entrega_acerto',
                                               'acerto_id', 'entrega_id', 'Entregas'),
        'state': fields.selection([('E', 'Esboco'), ('F', 'Efetivado'), ('C', 'Cancelado')],
                                  'Estado', size=1),
    }

    _defaults = {
        'dvyace_data': lambda *a: time.strftime('%Y-%m-%d'),
        'state': lambda *a: 'E',
    }
