# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class delivery_entregador(osv.Model):
    _name = 'delivery.entregador'
    _rec_name = 'dvyeto_pessoa_id'
    _columns = {
        'dvyeto_pessoa_id': fields.many2one("adm.pessoa", 'Entregador', ondelete="restrict", required=True, select=True),
        'dvyeto_comissao': fields.float('% de Comissao', digits=(4, 2)),
        'dvyeto_horario_entrada': fields.float('Horario de entrada', digits=(4, 2)),
        'dvyeto_horario_saida': fields.float('Horario de saida', digits=(4, 2)),
        'active': fields.boolean('Active', 'Ativo'),
        'entregas_ids': fields.one2many('delivery.entregas', 'dvyeta_entregador_id', 'Entregas'),
    }
    _defaults = {
        'active': lambda *a: True,
    }
    _sql_constraints = [
        ('entregador_uniq', 'unique(dvyeto_pessoa_id)', 'Este entregador ja esta cadastrado, verifique se nao esta inativo!' )
    ]
