# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import dvyeta_get_quantidade_pedidos as quantidade_pedidos
from funcoes import dvyeta_get_valor_total_pedidos as valor_total_pedidos


class delivery_entregas(osv.Model):
    _name = 'delivery.entregas'
    _rec_name = 'dvyeta_numero'
    _inherit = ['ir.needaction_mixin']
    _columns = {
        'dvyeta_numero': fields.char('Numero da entrega', size=10, select=True),  # Numero da entrega.
        'dvyeta_entregador_id': fields.many2one("delivery.entregador", 'Entregador', ondelete="restrict", select=True),
        'dvyeta_entrega_saida': fields.datetime('Saida'),
        'dvyeta_entrega_retorno': fields.datetime('Retorno'),
        'create_uid': fields.many2one('res.users', 'Criador', readonly=True),
        'create_date': fields.datetime('Data', readonly=True),
        'dvyeta_pedido_ids': fields.one2many('estoquepedidos.pedido.capa', 'pedcap_delivery_id', 'Pedidos'),
        'state': fields.selection([('ES', 'Esboco'), ('PE', 'Pendente'), ('EE', 'Em entrega'), ('ET', 'Entregue'),
                                   ('CA', 'Cancelada')], 'Situacao', required=True, size=2),
        'dvyeta_quantidade_pedidos': fields.function(
            quantidade_pedidos, method=True, type='integer', string='Quantidade de pedidos'),
        'dvyeta_valor_total_pedidos': fields.function(
            valor_total_pedidos, method=True, type='float', digits=(15, 2),
            string='Valor total dos pedidos'),
        'dvyeta_acerto_id': fields.many2one('delivery.acertos', 'Acerto', select=True),
    }
    _defaults = {
        'state': lambda *a: 'ES',
    }
