# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from openerp.osv import osv
from openerp import SUPERUSER_ID

class ir_attachment(osv.Model):
    _inherit = 'ir.attachment'

    def _docfin_get_partner(self, cr, uid, pessoa_id):
        """
        busca o partner_id da pessoa
        """
        brw_pessoa = self.pool.get('adm.pessoa').browse(cr, uid, pessoa_id)
        _partner_id = brw_pessoa.partner_id.id
        return _partner_id

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        _model = context.get('active_model') or False
        _active_ids = context.get('active_ids') or False
        _partner_ids = []
        modelo_util = _model in ('financeiro.cliente', 'financeiro.fornecedor',
                                 'adm.pessoa', 'project_br.project_br')
        id_not_in_args = True
        for x in args:
            if isinstance(x, (list, tuple)):
                for y in x:
                    if y == 'id':
                        id_not_in_args = False
        lista_valida = [_model, _active_ids, modelo_util, id_not_in_args]
        if all(lista_valida):
            for brw_model in self.pool.get(_model).browse(cr, uid, _active_ids):
                if _model == 'adm.pessoa':
                    _partner_ids.append(brw_model.partner_id.id)
                else:
                    _partner_ids.append(brw_model.pessoa_id.partner_id.id)
            if not (context.get('active_model') == 'project_br.project_br' and context.get(
                    'search_disable_custom_filters')):
                args = [('partner_id', 'in', _partner_ids)]
        ids = super(ir_attachment, self).search(cr, uid, args, offset=offset, limit=limit, order=order, context=context, count=False)
        return ids

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if not isinstance(vals, dict):
            vals = {}
        if vals.get('pessoa_id'):
            _partner_id = self._docfin_get_partner(cr, uid, vals.get('pessoa_id'))
            vals.pop('pessoa_id')
            vals['partner_id'] = _partner_id
        res = super(ir_attachment, self).create(cr, uid, vals, context=context)
        return res

    def default_get(self, cr, uid, fields_list, context=None):
        context = context and context.copy() or {}
        if context.get('default_partner_id'):
            _partner_id = self._docfin_get_partner(cr, uid, context.get('default_partner_id'))
            context['default_partner_id'] = _partner_id
        return super(ir_attachment, self).default_get(cr, uid, fields_list, context=context)

    def read(self, cr, uid, ids, fields_to_read=None, context=None, load='_classic_read'):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
        if context.get('group_by'):
            uid = SUPERUSER_ID
        res = super(ir_attachment, self).read(cr, uid, ids, fields_to_read, context=context, load=load)
        return res
