# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class ecf_cupons_finalizacao(osv.Model):
    """
    Tabela de finalizacao dos cupons
    """
    _name = 'ecf.cupons.finalizacao'
    _inherit = 'ecf.cupons.finalizacao'

    def ecfcuf_onchange_tipo_finalizadora(self, cr, uid, ids, tipo_finalizadora, context=None):
        context = context and context.copy() or {}
        res = {}
        if tipo_finalizadora == 'H':
            res['value'] = {
                'valor_taxa_adm': 0,
                'cliente_adm': '',
            }
        elif tipo_finalizadora in ('T', 'C'):
            res['value'] = {
                'numero_banco': '',
                'agencia': '',
                'numero_cheque': '',
                'conta': '',
                'cnpj': '',
            }
        return res

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        cupom_id = vals.get('cupom_id')
        if not vals.get('data') and cupom_id:
            vals['data'] = self.pool.get('ecf.cupons.capa').browse(cr, uid, cupom_id).date_cupom
        res = super(ecf_cupons_finalizacao, self).create(cr, uid, vals, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        brw_finalizacao = self.browse(cr, uid, ids, context)
        for finalizacao in brw_finalizacao:
            cupom_id = finalizacao.cupom_id
            if not vals.get('data') and cupom_id:
                vals['data'] = cupom_id.date_cupom
        res = super(ecf_cupons_finalizacao, self).write(cr, uid, ids, vals, context)
        return res

    def ecffinonchange_fin_na_ecf(self, cr, uid, ids, finalizadora_na_ecf, context=None):
        context = context and context.copy() or {}
        res={}
        if not finalizadora_na_ecf:
            return res

        args = [('finalizadora_na_ecf','=', finalizadora_na_ecf)]
        forma_pgto_ids = self.pool.get('adm.condicao.forma').search(cr, uid, args, context=context)
        if not forma_pgto_ids:
            res.update({'value':{'ecffinonchange_fin_na_ecf': ''},
                        'warning': {'title': _('Atencao!'),
                                    'message':_('Sem forma de pagamento com este codigo!')
                                   }
                        })
            return res

        brw_forma_pgto = self.pool.get('adm.condicao.forma')\
                         .browse(cr, uid, forma_pgto_ids[0], context=context)
        tipo_finalizadora = brw_forma_pgto.tipo_finalizadora
        res.update({'value': {'finalizadora_id': forma_pgto_ids[0],
                              'tipo_finalizadora': tipo_finalizadora}
                             }
                  )
        return res