# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class ecf_cupons_xz(osv.Model):
    _name = 'ecf.cupons.xz'
    _inherit = 'ecf.cupons.xz'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        res = None
        if not context or not context.get('importacao_xz'):
            obj_cupons_xz_totalizadores = self.pool.get('ecf.cupons.xztotalizadores')
            gt_final = vals.get('gt_final') or 0.0
            gt_inicial = vals.get('gt_inicial') or 0.0
            cancelamentos = vals.get('cancelamentos') or 0.0
            descontos = vals.get('descontos') or 0.0
            acrescimos = vals.get('acrescimos') or 0.0
            itens = vals.get('item_ids')
            total_base_valor = 0.0
            cupom_id = vals.get('cupom_id')
            if cupom_id:
                cupons_xz_totalizadores_ids = obj_cupons_xz_totalizadores.search(cr, uid, [('cupom_id', '=', cupom_id)],
                                                                                 context=context)
                if cupons_xz_totalizadores_ids:
                    cupons_xz_totalizadores_dados = obj_cupons_xz_totalizadores.read(cr, uid,
                                                                                     cupons_xz_totalizadores_ids,
                                                                                     ['base_imposto'], context=context)
                    for x in cupons_xz_totalizadores_dados:
                        total_base_valor += x.get('base_imposto') or 0.0
            diferenca = gt_final - gt_inicial - cancelamentos - descontos - acrescimos - total_base_valor
            diferenca = float('%.2f' % diferenca)
            if diferenca == 0:
                res = super(ecf_cupons_xz, self).create(cr, uid, vals, context)
            else:
                if not any([context.get('importacao_automatica'), context.get('importacao_supervisor_erp')]):
                    raise osv.except_osv(_('Atencao'), _('Ha divergencia nos valores da reducao'))
        if not res:
            res = super(ecf_cupons_xz, self).create(cr, uid, vals, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        lista = []
        gt_final = 0.0
        gt_inicial = 0.0
        cancelamentos = 0.0
        descontos = 0.0
        acrescimos = 0.0
        total_base_valor = 0.0
        total = 0.0
        obj_cupons_xz_totalizadores = self.pool.get('ecf.cupons.xztotalizadores')
        if vals.get('gt_final'):
            gt_final = vals.get('gt_final')
        else:
            lista.append('gt_final')
        if vals.get('gt_inicial'):
            gt_inicial = vals.get('gt_inicial')
        else:
            lista.append('gt_inicial')
        if vals.get('cancelamentos'):
            cancelamentos = vals.get('cancelamentos')
        else:
            lista.append('cancelamentos')
        if vals.get('descontos'):
            descontos = vals.get('descontos')
        else:
            lista.append('descontos')
        if vals.get('acrescimos'):
            acrescimos = vals.get('acrescimos')
        else:
            lista.append('acrescimos')
        if lista:
            if not isinstance(ids, list):
                ids = [ids]
            cupons_xz_dados = self.read(cr, uid, ids, lista, context=context)
            for d in cupons_xz_dados:
                for l in lista:
                    if lista.index(l) == 0:
                        total = d.get(l)
                    else:
                        if 'gt_final' in lista:
                            total -= d.get(l)
                        else:
                            total += d.get(l)
            totalizadores_ids = obj_cupons_xz_totalizadores.search(cr, uid, [('cupom_id', '=', vals.get('cupom_id'))],
                                                                   context=context)
            cupons_xztotalizadores_dados = obj_cupons_xz_totalizadores.read(cr, uid, totalizadores_ids,
                                                                            ['base_imposto'], context=context)
            for x in cupons_xztotalizadores_dados:
                total_base_valor += x.get('base_imposto') or 0.0
        if total and not gt_final:
            diferenca = total - gt_final - gt_inicial - cancelamentos - descontos - acrescimos - total_base_valor
        elif gt_final or gt_inicial:
            diferenca = gt_final - gt_inicial - cancelamentos - descontos - acrescimos - total_base_valor - total
        else:
            diferenca = gt_final - gt_inicial - cancelamentos - descontos - acrescimos - total_base_valor
        diferenca = float('%.2f' % diferenca)
        if diferenca == 0:
            res = super(ecf_cupons_xz, self).write(cr, uid, ids, vals, context=context)
        else:
            if not context.get('importacao_automatica'):
                raise osv.except_osv(_('Atencao'), _('Ha divergencia nos valores da reducao'))
        return res
