# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class ecf_mapa_resumo_itens(osv.Model):
    _name = 'ecf.mapa.resumo.itens'
    _inherit = 'ecf.mapa.resumo.itens'

    @staticmethod
    def onchange_imposto_valor(cr, uid, ids, aliquota, base_valor, imposto_valor=0.0):
        """
        Realiza o cálculo do valor do imposto (aliquota / 100 * base_valor)
        Se informar o imposto_valor, é feita uma validação se o mesmo está correto
        """
        res = {}
        warning = {}

        if aliquota and base_valor:
            calc = float('%.2f' % ((float(aliquota) / 100) * float(base_valor)))
            imposto_valor = float('%.2f' % imposto_valor)

            if imposto_valor and imposto_valor != calc:
                warning['title'] = _('Atencao')
                warning['message'] = _('Valor do imposto difere do \nvalor da base * aliquota!')
            else:
                res['imposto_valor'] = calc
        else:
            res['imposto_valor'] = 0

        return {'value': res, 'warning': warning}
