# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2012 All Rights Reserved. Maxwell da Silva Oliveira
#                    www.siginformatica.com.br maxwell.oliveira@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class ecf_tesouraria_movimento(osv.Model):
    """
    Tabela de Movimentacao da Tesouaria do ecf
    """

    _name = 'ecf.tesouraria.movimento'
    _inherit = 'ecf.tesouraria.movimento'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        res = {}
        tipo = vals.get('tipo')
        coo = vals.get('coo')
        capa_id = vals.get('capa_id')
        dados_capa = self.pool.get('ecf.tesouraria.capa').read(cr, uid, capa_id, ['conta_id', 'data_movimento'], context=context)
        data_movimento = dados_capa.get('data_movimento')
        mes = str(data_movimento[5:7])
        ano = str(data_movimento[0:4])
        conta_id = dados_capa.get('conta_id')[0]
        finalizadora = vals.get('finalizadora_id')
        if finalizadora:
            condicao_forma_id = self.pool.get('adm.condicao.forma').read(cr, uid, finalizadora, ['adm_condicao_id'], context=context)
            condicao_forma_id = condicao_forma_id.get('adm_condicao_id')[0]
            tipo_pagamento = self.pool.get('adm.condicao').read(cr, uid, condicao_forma_id, ['tipo'], context=context)
            if tipo_pagamento:
                tipo_pagamento = tipo_pagamento.get('tipo')
                if tipo_pagamento == 'V' or tipo_pagamento == 'C':
                    valores = {
                        'data_movimento': data_movimento,
                        'mes_competencia': mes,
                        'ano_competencia': ano,
                        'conta_id': conta_id,
                        'valor': vals.get('valor'),
                    }
                    if tipo == 'A':
                        valores['debito_credito'] = 'C'
                        valores['historico'] = _('Sangria ECF')
                    else:
                        valores['debito_credito'] = 'D'
                        valores['historico'] = _('Suprimento ECF')
                    vals['financeiro_movimento_id'] = self.pool.get('financeiro.tesouraria.movimento').create(cr, uid,
                                                                                                              valores,
                                                                                                              context)
                    valores['conta_id'] = conta_id
                    valores['conta_destino_id'] = None
                    res = super(ecf_tesouraria_movimento, self).create(cr, uid, vals, context)
                    if tipo_pagamento == 'C':
                        if tipo == 'A':
                            valores['debito_credito'] = 'D'
                            valores['historico'] = _('Transferencia para contas a receber')
                        elif tipo == 'U':
                            valores['debito_credito'] = 'C'
                            valores['historico'] = _('Transferencia para contas a receber')
                        vals['financeiro_movimento_id'] = self.pool.get('financeiro.tesouraria.movimento').create(cr,
                                                                                                                  uid,
                                                                                                                  valores,
                                                                                                                  context)
        if tipo == 'A' and not coo:
            raise osv.except_osv(_('Atencao'), _('Campo COO e obrigatorio para movimento do tipo Sangria'))
        if not res:
            res = super(ecf_tesouraria_movimento, self).create(cr, uid, vals, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        res = {}
        if 'finalizadora_id' in vals:
            capa_id = self.read(cr, uid, ids[0], ['capa_id'], context=context)
            capa_id = capa_id.get('capa_id')[0]
            dados_capa = self.pool.get('ecf.tesouraria.capa').read(cr, uid, capa_id, ['conta_id', 'data_movimento'], context=context)
            data_movimento = dados_capa.get('data_movimento')
            mes = str(data_movimento[5:7])
            ano = str(data_movimento[0:4])
            conta_id = dados_capa.get('conta_id')[0]
            financeiro_movimento_id = self.read(cr, uid, ids[0], ['financeiro_movimento_id'], context=context)
            financeiro_movimento_id = financeiro_movimento_id.get('financeiro_movimento_id')
            finalizadora = vals.get('finalizadora_id')
            condicao_forma_id = self.pool.get('adm.condicao.forma').read(cr, uid, finalizadora, ['adm_condicao_id'], context=context)
            condicao_forma_id = condicao_forma_id.get('adm_condicao_id')[0]
            tipo_pagamento = self.pool.get('adm.condicao').read(cr, uid, condicao_forma_id, ['tipo'], context=context)
            if tipo_pagamento:
                tipo_pagamento = tipo_pagamento.get('tipo')
                if tipo_pagamento == 'V' or tipo_pagamento == 'C':
                    valores = {
                        'data_movimento': data_movimento,
                        'mes_competencia': mes,
                        'ano_competencia': ano,
                        'conta_id': conta_id,
                    }
                    if 'tipo' in vals:
                        if vals.get('tipo') == 'A':
                            valores['debito_credito'] = 'C'
                            valores['historico'] = _('Sangria ECF')
                        else:
                            valores['debito_credito'] = 'D'
                            valores['historico'] = _('Suprimento ECF')
                    if 'valor' in vals:
                        valores['valor'] = vals.get('valor')
                    self.pool.get('financeiro.tesouraria.movimento').write(cr, uid, [financeiro_movimento_id], valores, context=context)
                    valores['conta_id'] = conta_id
                    valores['conta_destino_id'] = None
                    res = super(ecf_tesouraria_movimento, self).write(cr, uid, ids, vals, context)
                    if tipo_pagamento == 'C':
                        if vals.get('tipo') == 'A':
                            valores['debito_credito'] = 'D'
                            valores['historico'] = _('Transferencia para contas a receber')
                        elif vals.get('tipo') == 'U':
                            valores['debito_credito'] = 'C'
                            valores['historico'] = _('Transferencia para contas a receber')
                        financeiro_movimento_id += 1
                        financeiro_tesouraria_movimento_id = self.pool.get('financeiro.tesouraria.movimento').search(cr,
                                                                                                                     uid,
                                                                                                                     [(
                                                                                                                          'id',
                                                                                                                          '=',
                                                                                                                          financeiro_movimento_id)],
                                                                                                                     context=context)
                        if financeiro_tesouraria_movimento_id:
                            vals['financeiro_movimento_id'] = self.pool.get('financeiro.tesouraria.movimento').write(cr,
                                                                                                                     uid,
                                                                                                                     [
                                                                                                                         financeiro_movimento_id],
                                                                                                                     valores, context=context)
                        else:
                            vals['financeiro_movimento_id'] = self.pool.get('financeiro.tesouraria.movimento').create(
                                cr, uid, valores, context)
        if not res:
            res = super(ecf_tesouraria_movimento, self).write(cr, uid, ids, vals, context)
        return res

    def unlink(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        dados_movimento = self.read(cr, uid, ids, ['financeiro_movimento_id', 'finalizadora_id'], context=context)
        if isinstance(dados_movimento, list):
            dados_movimento = dados_movimento[0]
        financeiro_movimento_id = dados_movimento.get('financeiro_movimento_id')
        if financeiro_movimento_id:
            self.pool.get('financeiro.tesouraria.movimento').unlink(cr, uid, financeiro_movimento_id)
        finalizadora = dados_movimento.get('finalizadora_id')[0]
        if finalizadora:
            condicao_forma_id = self.pool.get('adm.condicao.forma').read(cr, uid, finalizadora, ['adm_condicao_id'], context=context)
            condicao_forma_id = condicao_forma_id.get('adm_condicao_id')[0]
            tipo_pagamento = self.pool.get('adm.condicao').read(cr, uid, condicao_forma_id, ['tipo'], context=context)
            if tipo_pagamento:
                tipo_pagamento = tipo_pagamento.get('tipo')
                if tipo_pagamento == 'C' and financeiro_movimento_id:
                    financeiro_movimento_id += 1
                    self.pool.get('financeiro.tesouraria.movimento').unlink(cr, uid, financeiro_movimento_id)
        res = super(ecf_tesouraria_movimento, self).unlink(cr, uid, ids)
        return res
