# -*- coding: utf-8 -*-

from openerp.osv import osv


class wizard_listagem_geral_item(osv.TransientModel):
    _inherit = 'wizard.listagem.geral.item'

    def get_datas_movimento(self, cr, grade_ids, context=None):
        context = context and context.copy() or {}
        sql = """
        SELECT max(data) AS data,
               grade_id,
               tipo_movimento
        FROM (SELECT max(emc.data) AS data,
                     emi.grade_id  AS grade_id,
                     CASE WHEN fnc.tipo is not null  and fnc.tipo = 'E'
                          THEN fnc.tipo
                          ELSE 'S'
                     END           AS tipo_movimento
            FROM estoque_movimento_capa        AS emc
            INNER JOIN estoque_movimento_itens AS emi ON emi.capa_id = emc.id
            LEFT  JOIN fiscal_nf_capa          AS fnc ON fnc.id = emi.nf_id
            LEFT  JOIN ecf_cupons_capa         AS ecc ON ecc.id = emi.cupom_id
            WHERE emi.grade_id IN (%s)
              AND (fnc.state = '3' or ecc.state = 'V')
            GROUP BY emi.grade_id, tipo ) AS tmp
        GROUP BY grade_id, tipo_movimento """ % ','.join(map(lambda x: "%s" % x, list(set(grade_ids))))
        cr.execute(sql)
        res = {}
        for i in cr.dictfetchall():
            grade_id = i.get('grade_id')
            tipo_movimento = i.get('tipo_movimento')
            vals = {'dt_entrada': i.get('data') or ''}
            if tipo_movimento == 'S':
                vals = {'dt_saida': i.get('data') or ''}

            if not res.get(grade_id):
                res[grade_id] = vals
            else:
                res[grade_id].update(vals)

        return res
