# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class estoque_local(osv.Model):
    """
    Tabela de locais de armazenagem.
    """

    _name = 'estoque.local'
    _inherit = 'estoque.local'

    def name_search(self, cr, uid, name='', args=[], operator='ilike', context=None, limit=100):
        context = context and context.copy() or {}
        if context.get('atualizar_precos'):
            obj_estoque_parametro = self.pool.get('estoque.parametro')
            estoque_parametro_id = obj_estoque_parametro.search(cr, uid, [], context=context)
            if estoque_parametro_id:
                dado_estoque_parametro = obj_estoque_parametro.read(
                    cr, uid, estoque_parametro_id[0], ['estpar_super_local_id'], context=context)
                if isinstance(dado_estoque_parametro, list):
                    dado_estoque_parametro = dado_estoque_parametro[0]
                if isinstance(dado_estoque_parametro, dict):
                    local_parametro_ids = dado_estoque_parametro['estpar_super_local_id']
                    args.append(('id', 'in', local_parametro_ids))
        return super(estoque_local, self).name_search(cr, uid, name=name, args=args,
                                                      operator=operator, context=context,
                                                      limit=limit)
