# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv


class estoque_movimento_itens(osv.Model):
    _inherit = 'estoque.movimento.itens'

    def estmvi_get_item_venda_cupom(self, cr, uid, capa_ids, context=None):
        """
        O metodo encontra os ids dos cupons de venda validados a partir dos ids do movimento de
        itens.
        :param cr: cursor no banco de dados.
        :param uid: id da tabela res_users, identificador do usuario.
        :param capa_ids: lista de ids da capa do movimento.
        :param context: dicionario com valores contextuais.
        :return: lista de id da tabela desse objeto.
        """
        context = context and context.copy() or {}
        if not capa_ids:
            return []

        sql = """
            SELECT emi.id                 
            FROM estoque_movimento_itens      AS emi
            INNER JOIN estoque_movimento_capa AS emc ON emc.id = emi.capa_id
            INNER JOIN ecf_cupons_capa        AS ecc ON ecc.id = emc.cupons_capa_id
            WHERE emc.id IN (%s) 
              AND ecc.state = 'V'
              AND ecc.tipo_cupom = 'V'
              AND emi.item_cancelado = False 
              AND ecc.ecfccp_cupom_cancelamento_id IS NULL 
              
        """ % ','.join(map(lambda x: "%s" % x, capa_ids))
        cr.execute(sql)
        return map(lambda x: x.get('id'), cr.dictfetchall())
