# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_parametro(osv.Model):
    _name = "estoque.parametro"
    _inherit = "estoque.parametro"
    _columns = {
        'arquivo_de_clientes': fields.text('Arq. Clientes',
                                           help="Se o diretorio nao for informado, disponibiliza "
                                                "opcao de download na exportacao."),
        'arquivo_de_mensagens': fields.text('Arq. Mensagens',
                                            help="Se o diretorio nao for informado, disponibiliza "
                                                 "opcao de download na exportacao."),
        'arquivo_de_kit': fields.text("Arq. Kit's",
                                      help="Se o diretorio nao for informado, disponibiliza "
                                           "opcao de download na exportacao."),
        'arquivo_de_trib_ecf': fields.text('Arq. Tributacoes',
                                            help="Se o diretorio nao for informado, disponibiliza "
                                                 "opcao de download na exportacao."),
        'arquivo_de_itens_ecf': fields.text('Arqq. Itens',
                                            help="Se o diretorio nao for informado, disponibiliza "
                                                 "opcao de download na exportacao."),
        'arquivo_de_nserie': fields.text('Arq. No. Series',
                                         help="Se o diretorio nao for informado, disponibiliza "
                                              "opcao de download na exportacao."),
        'arquivo_de_fidelidade': fields.text('Arq. Fidelidade',
                                             help="Se o diretorio nao for informado, disponibiliza "
                                                  "opcao de download na exportacao."),
        'arquivo_de_vendedores': fields.text('Arq. Vendedores',
                                             help="Se o diretorio nao for informado, disponibiliza "
                                                  "opcao de download na exportacao."),
        'dir_arq_import': fields.text('Local do Arq. Importacao'),
        'intervalo_import_aut': fields.integer('Intervalo da Importacao Automatica',
                                               help="Valor zero desativa a importacao de cupons"),
        'estpar_ecf_operacao_importacao_id': fields.many2one('estoque.natureza.operacao',
                                                             'Operacao para importacao'),
        # --- CONFIGURAÇÕES DO SUPERVISOR --
        'estpar_super_host': fields.text('Host(Postgres)'),
        'estpar_super_porta': fields.integer('Porta(Postgres)'),
        'estpar_super_db': fields.text('Banco de Dados'),
        'estpar_super_user': fields.text('Usuario(Postgres)'),
        'estpar_super_password': fields.text('Senha(Postgres)'),
        'estpar_super_host_erp': fields.text('Host(ERP)'),
        'estpar_super_porta_erp': fields.integer('Porta(ERP)'),
        'estpar_super_user_erp': fields.text('Usuario(ERP)'),
        'estpar_super_password_erp': fields.text('Senha(ERP)'),
        'estpar_super_loja': fields.integer('Loja'),
        'estpar_super_local_id': fields.many2many(
            'estoque.local', 'estoque_parametro_m2m_local', 'parametro_id', 'local_id',  'Locais'
        ),
        'estpar_tipo_exportacao': fields.selection([('M', 'MySQL'),
                                                    ('P', 'PostgresSQL'),
                                                    ('A', 'Arquivo')],
                                                   'Tipo de exportacao/importacao', size=1),
        'estpar_usar_master': fields.boolean('Usar Supervisor Master'),
        'estpar_somente_ecf': fields.boolean('Apenas ECF',
                                             help='Uso apenas de ECF, sem uso de NFC-e'),
    }
    _defaults = {
        'estpar_super_host': 'localhost',
        'estpar_super_user': 'openerp',
        'estpar_super_porta': 5432,
        'estpar_super_porta_erp': 8069,
        'estpar_super_host_erp': 'localhost',
        'arquivo_de_clientes': 'clientes.txt',
        'arquivo_de_mensagens': 'mesag.txt',
        'arquivo_de_kit': 'kit.txt',
        'arquivo_de_itens_ecf': 'itens.txt',
        'arquivo_de_trib_ecf': 'tributacao.txt',
        'arquivo_de_nserie': 'nseries.txt',
        'arquivo_de_fidelidade': 'fidel.txt',
        'arquivo_de_vendedores': 'vendedor.txt',
        'estpar_tipo_exportacao': 'A',
        'estpar_usar_master': False,
        'estpar_somente_ecf': True,
    }
