# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class wizard_gerencial_documento_sem_classificacao(osv.TransientModel):
    # prefixo: wsemcla_

    _inherit = 'wizard.gerencial.documento.sem.classificacao'

    def wsemcla_get_dados_sem_classificacao(self, cr, uid, ids, context=None):
        """
        O metodo reune os dados de notas fiscais, titulos e movimento da tesouraria que nao tiveram
        classificacao.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: dicionario, com a descricao de nota_fiscal, titulo e tesouraria e seus respectivos
        valores.
        :rtype: dict
        """
        context = context and context.copy() or {}

        dados = super(wizard_gerencial_documento_sem_classificacao, self).\
            wsemcla_get_dados_sem_classificacao(cr, uid, ids, context)
        periodo = self.read(cr, uid, ids[0], ['wsemcla_periodo_inicio', 'wsemcla_periodo_fim'])
        sql = """
            -- noinspection SqlDialectInspectionForFile
            SELECT
                ap.codigo || '-' || ap.nome     AS cliente_fornecedor,
                CASE
                    WHEN ft.tipo_titulo = 'R'
                        THEN 'RECEBER'
                    ELSE
                        'PAGAR'
                END                             AS tipo,
                ft.documento                    AS documento,
                ft.parcela                      AS parcela,
                ft.data_emissao                 AS data_emissao,
                ft.data_prorrogacao             AS data_vencimento,
                ft.saldo                        AS valor
            FROM financeiro_titulo ft
            INNER JOIN adm_pessoa ap
                ON ap.id = ft.pessoa_id
            INNER JOIN financeiro_fatura ff
                ON ff.id = ft.fatura_id
            WHERE
                ff.cupom_id NOT IN (SELECT fingmo_cupom_id
                                    FROM gerencial_movimento
                                    WHERE fingmo_cupom_id IS NOT NULL)
                AND ff.cupom_id IS NOT NULL
                AND ft.data_emissao BETWEEN '{inicio}' AND '{fim}'
        """.format(inicio=periodo.get('wsemcla_periodo_inicio'),
                   fim=periodo.get('wsemcla_periodo_fim'))
        cr.execute(sql)
        titulos = cr.dictfetchall()
        if dados.get('titulo'):
            dados['titulo'].extend(titulos)
        else:
            dados['titulo'] = titulos

        return dados
