# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-218 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2018, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""
from pynfe.nfe.manual_600.nfe_400 import NFRef
from openerp.osv import osv


# noinspection PyPep8Naming
class fiscal_nf_capa(osv.Model):
    _inherit = 'fiscal.nf.capa'

    def _fisnfc_set_nfe_infnfe_ide_nref(self, cr, user, nf, nfe, context=None):
        """
        Cupons referenciados

        :param cr: cursor do banco de dados
        :param user: o ID do usuario utilizado para a verificacao de perfil
        :param nf: dados da nota fiscal
        :param nfe: objeto nota fiscal eletronica - NFe() -- XML --
        :param context: um dicionario padrao para valores contextuais
        :type cr: object
        :type user: int
        :type nf: dict
        :type nfe: NFe
        :type context: dict
        :return: o objeto de nota fiscal eletronica (XML) com os valores de cupons referenciados
        :rtype: NFRef
        """
        context = context and context.copy() or {}

        # Cupons fiscais referenciados
        if not nf.get('fisnfc_cupons_referenciados_ids'):
            return super(fiscal_nf_capa, self)._fisnfc_set_nfe_infnfe_ide_nref(
                cr, user, nf, nfe, context)

        campos = ['coo', 'ecf_id']
        cupom_dados = self.pool.get('ecf.cupons.capa').read(
            cr, user, nf.get('fisnfc_cupons_referenciados_ids'), campos, context, '_classic_write')
        ecf_ids = map(lambda m: m.get('ecf_id'), cupom_dados)
        dict_ecf = {}
        map(lambda m: dict_ecf.update({m.get('id'): m}), self.pool.get('ecf.ecf').read(
            cr, user, ecf_ids, ['caixa'], context))
        for cupom in cupom_dados:
            nf_ref = NFRef()
            nf_ref.refECF.mod.valor = u'2D'
            nf_ref.refECF.nCOO.valor = cupom.get('coo')
            nf_ref.refECF.nECF.valor = dict_ecf.get(cupom.get('ecf_id')).get('caixa')
            nfe.infNFe.ide.NFref.append(nf_ref)

        return super(fiscal_nf_capa, self)._fisnfc_set_nfe_infnfe_ide_nref(
            cr, user, nf, nfe, context)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
