# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2019 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2019, Creative Commons
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""
from openerp.osv import osv


class fiscal_nf_capa(osv.Model):
    _inherit = 'fiscal.nf.capa'

    def abrir_cancelar_nfe(self, cr, user, ids, context=None):
        """
        Elimina a referencia da NF-e no cupom ao realizar o cancelamento da nota

        :param cr: a linha atual do cursor do banco de dados
        :param user: ID do usuario utilizado para a verificacao de perfil
        :param ids: lista com IDs de notas fiscais
        :param context: um dicionario padrao para valores contextuais
        :type cr: object
        :type user: int
        :type ids: list
        :type context: dict
        :return: verdadeiro se a nota foi cancelada.
        :rtype: bool
        """
        context = context and context.copy() or {}
        coo_ids = self.pool.get('ecf.cupons.capa').search(
            cr, user, [('nf_id', '=', ids[0])], context=context)
        coo_id = coo_ids and coo_ids[0] or 0
        if coo_id:
            self.pool.get('ecf.cupons.capa').write(cr, user, coo_id, {'nf_id': False}, context)

        return super(fiscal_nf_capa, self).abrir_cancelar_nfe(cr, user, ids, context)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
