# -*- encoding: utf-8 -*-

from openerp.osv import osv
from sped_sql.sql_sped_fiscal import SqlSpedFiscalECF
from openerp.tools.translate import _
from dateutil.parser import parse
from pythonsped.efd import bloco_c


# noinspection PyProtectedMember,PyAbstractClass,PyPep8Naming,PyShadowingNames
class fiscal_sped(osv.TransientModel):

    _inherit = 'fiscal.sped'

    def gerar_sped(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        val = self.read(cr, uid, ids[0], context=context)
        sped_data_inicial = val.get('sped_data_inicial')
        sped_data_final = val.get('sped_data_final') + ' 23:59:59'
        obj_sql = SqlSpedFiscalECF(cr, sped_data_inicial, sped_data_final, val['company_id'][0])
        if obj_sql.erro:
            raise osv.except_osv(_('Erro'), _(obj_sql.erro))
        movimento_sem_cupons_z = obj_sql.sql_consulta_reducao_z(cr)
        msg_dias_sem_z = ''
        list_datas = movimento_sem_cupons_z.keys()
        list_datas.sort()
        for data in list_datas:
            msg_dias_sem_z += '%s - ECF %s<br/>' % (parse(data[:10]).strftime('%d-%m-%Y'),
                                                    movimento_sem_cupons_z.get(data[:10]))
        if msg_dias_sem_z:
            self.set_mensagem(
                '* Nao existe reducao Z para o(s) dia(s) - caixa(s) abaixo:<br/> %s' %
                msg_dias_sem_z[:-2] + '.')
        return super(fiscal_sped, self).gerar_sped(cr, uid, ids, context)

    def registroC114(self, cr, uid, nf_id, context=None):
        """
        Metodo responsavel por gerar os registros C114. Cupons referenciados nas notas fiscais do
        registro C100.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param nf_id: id da tabela fiscal_nf_capa, identificador da Nota Fiscal.
        :type nf_id: int
        :param context: dados contextuais.
        :type context: dict
        :return: Mensagem da descricao de algum possivel problema perante a geracao.
        :rtype: str
        """
        context = context and context.copy() or {}
        reg_C114 = bloco_c.registro_C114()
        for cupom in self.pool.get('fiscal.nf.capa').browse(
                cr, uid, nf_id, context).fisnfc_cupons_referenciados_ids:
            reg_C114.REG = 'C114'
            reg_C114.COD_MOD = '2D'
            reg_C114.ECF_FAB = cupom.ecf_id.nro_serie[-21:]
            reg_C114.ECF_CX = cupom.ecf_id.caixa
            reg_C114.NUM_DOC = cupom.coo
            reg_C114.DT_DOC = parse(cupom.date_cupom).strftime('%d%m%Y')
            reg_C114.write_line()
        return str()
