# -*- coding: utf-8 -*-

from .....fiscal.wizard.sped_sql.sql_sped_fiscal import SqlSpedFiscal
from dateutil.parser import parse
from dateutil.relativedelta import relativedelta


class SqlSpedFiscalECF(SqlSpedFiscal):

    def sql_consulta_reducao_z(self, cr):
        dict_data_sem_z = dict()
        sql = """
            SELECT emr.data, emr.ecf AS ecf_id, ecf.caixa
            FROM ecf_mapa_resumo_capa emr
            INNER JOIN ecf_ecf ecf
                ON ecf.id = emr.ecf
            WHERE
                emr.data >= '%s'
                AND emr.data <= '%s'
                AND ecf.company_id = %s
        """ % (self.data_inicio, self.data_fim, self.company_id)
        cr.execute(sql)
        movimento_mapa_z = cr.dictfetchall()
        sql = """
            SELECT
                id, caixa
            FROM
                ecf_ecf
            WHERE
                company_id = %s
        """ % self.company_id
        cr.execute(sql)
        ecf_dados = cr.dictfetchall()
        caixas = dict()
        map(lambda e: caixas.update({str(e.get('id')): str(e.get('caixa'))}), ecf_dados)
        ecf_ids = caixas.keys()
        data = self.data_inicio
        while self.data_inicio <= data <= self.data_fim:
            data_movimento_mapa_z = filter(lambda z: z.get('data') == data, movimento_mapa_z)
            if not data_movimento_mapa_z:
                dict_data_sem_z.update({data: ', '.join(caixas.values())})
                data = (parse(data) + relativedelta(days=1)).strftime('%Y-%m-%d')
                continue
            data_ecf_ids = list(set(map(lambda e: str(e.get('ecf_id')), data_movimento_mapa_z)))
            caixas_data = []
            for e in ecf_ids:
                if e not in data_ecf_ids:
                    caixas_data.append(str(caixas.get(e)))
            if len(data_movimento_mapa_z) != len(ecf_ids):
                dict_data_sem_z.update({data: ', '.join(caixas_data)})
            data = (parse(data) + relativedelta(days=1)).strftime('%Y-%m-%d')
        return dict_data_sem_z
