# -*- coding: utf-8 -*-

from openerp.osv import osv, fields


class wizard_documento_emitido(osv.Model):
    # prefixo: wizdoe_

    _inherit = 'wizard.documento.emitido'

    def wizdoe_get_dado(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        dados = super(wizard_documento_emitido, self).wizdoe_get_dado(cr, uid, ids, context)
        brw_wizard_documento_emitido = self.browse(cr, uid, ids[0], context)
        data_inicial = brw_wizard_documento_emitido.wizdoe_data_inicial
        data_final = brw_wizard_documento_emitido.wizdoe_data_final
        pessoa_id = brw_wizard_documento_emitido.wizdoe_pessoa_id.id or False
        documento_tipo_id = brw_wizard_documento_emitido.wizdoe_documento_tipo_id.id or False
        company_id = brw_wizard_documento_emitido.company_id.id
        company_ids = self.pool.get('res.company')._get_company_children(cr, uid, company_id)
        if len(company_ids) == 1:
            company_ids = str(tuple(company_ids)).replace(',', '')
        else:
            company_ids = str(tuple(company_ids))
        sql = """
            SELECT
                ecc.cliente_id                            AS pessoa_id,
                ap.nome                                   AS nome_pessoa,
                'CUP'                                      AS doc,
                ecc.coo                                   AS numero_documento,
                ''                                        AS serie,
                CASE
                    WHEN ecc.alteracao = 'A'
                        THEN ecc.total_cupom - ecc.valor_alteracao
                    WHEN ecc.alteracao = 'D'
                        THEN ecc.total_cupom + ecc.valor_alteracao
                    ELSE ecc.total_cupom
                END                                       AS vr_produto,
                CASE
                    WHEN ecc.alteracao = 'D'
                        THEN ecc.valor_alteracao
                    ELSE 0.00
                END                                       AS vr_desconto,
                ecc.total_cupom                           AS vr_total,
                ecc.date_cupom                            AS data_emissao,
                ddt.descricao                             AS titulo_tipo_documento,
                ft.documento                              AS titulo_documento,
                ft.parcela                                AS titulo_parcela,
                ft.data_prorrogacao                       AS titulo_data_vencimento,
                ft.vr_original                            AS titulo_valor,
                CASE
                    WHEN ft.state = 'A' THEN 'Aberto'
                    WHEN ft.state = 'B' THEN 'Baixado'
                    WHEN ft.state = 'D' THEN 'Devolvido'
                    WHEN ft.state = 'R' THEN 'Reapresentado'
                    WHEN ft.state = 'C' THEN 'Cancelado'
                    ELSe ''
                END                                       AS titulo_state,
                CASE
                    WHEN afp.cartao_credito_debito = True AND
                        afp.admfpg_cartao_pessoa_id IS NOT NULL
                        THEN (SELECT codigo || '-' || nome
                              FROM adm_pessoa
                              WHERE id = afp.admfpg_cartao_pessoa_id
                                    AND ft.pessoa_id = id)
                    ELSE ''
                END                                       AS titulo_operadora,
                CASE
                    WHEN ft.id IS NOT NULL AND ft.fintit_nro_autorizacao_cartao IS NOT NULL
                        THEN ft.fintit_nro_autorizacao_cartao
                    ELSE ''
                END                                       AS titulo_nro_autorizacao,
                (
                    SELECT tipo
                    FROM adm_condicao
                    WHERE
                        id IN (
                            SELECT adm_condicao_id
                            FROM adm_condicao_forma
                            WHERE
                                id = acf.id
                            )
                )                                         AS tipo_pagamento,
                ecc.tipo_cupom                            AS state,
                ft.id                                     AS titulo_id
            FROM ecf_cupons_capa ecc
            LEFT JOIN adm_pessoa ap
                ON ecc.cliente_id = ap.id
            LEFT JOIN financeiro_fatura ff
                ON ff.cupom_id = ecc.id
            LEFT JOIN financeiro_titulo ft
                ON ff.id = ft.fatura_id
            LEFT JOIN documento_documento_tipo ddt
                ON ddt.id = ft.doc_tipo_id
            INNER JOIN ecf_cupons_finalizacao ecf
                ON ecf.cupom_id = ecc.id
            INNER JOIN adm_condicao_forma acf
                ON acf.id = ecf.finalizadora_id
            INNER JOIN adm_forma_pgto afp
                ON afp.id = acf.forma_pagamento_id
            WHERE
                ecc.company_id IN %s
                AND ecc.tipo_cupom IN ('V', 'C')
                AND ecc.state = 'V'
                AND ecc.date_cupom >= '%s'
                AND ecc.date_cupom <= '%s'
        """ % (company_ids, data_inicial, data_final)
        if pessoa_id:
            sql += """
                AND ecc.cliente_id = %s
            """ % pessoa_id
        if documento_tipo_id:
            sql += """
                AND ddt.id = %s
            """ % documento_tipo_id
        sql += """
            ORDER BY /*ecc.date_cupom,*/ ecc.coo, titulo_operadora
        """
        cr.execute(sql)
        dados_ecf = cr.dictfetchall()
        dados['dados'].extend(dados_ecf)
        return dados

    def wizdoe_get_resumo_tipo_documento(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        sql = super(wizard_documento_emitido, self).wizdoe_get_resumo_tipo_documento(
            cr, uid, ids, context)
        brw_wizard_documento_emitido = self.browse(cr, uid, ids[0], context)
        data_inicial = brw_wizard_documento_emitido.wizdoe_data_inicial
        data_final = brw_wizard_documento_emitido.wizdoe_data_final
        pessoa_id = brw_wizard_documento_emitido.wizdoe_pessoa_id.id or False
        documento_tipo_id = brw_wizard_documento_emitido.wizdoe_documento_tipo_id.id or False
        company_id = brw_wizard_documento_emitido.company_id.id
        company_ids = list(set(self.pool.get('res.company')._get_company_children(
            cr, uid, company_id)))
        if len(company_ids) == 1:
            company_ids = str(tuple(company_ids)).replace(',', '')
        else:
            company_ids = str(tuple(company_ids))
        sql_ecf = """
            SELECT
                Sum(CASE
                    WHEN ecc.alteracao = 'A' AND ecc.tipo_cupom = 'V'
                        THEN ecc.total_cupom + ecc.valor_alteracao
                    WHEN ecc.alteracao = 'A' AND ecc.tipo_cupom = 'C'
                        THEN (ecc.total_cupom + ecc.valor_alteracao) * -1
                    WHEN ecc.alteracao = 'D' AND ecc.tipo_cupom = 'V'
                        THEN ecc.total_cupom + ecc.valor_alteracao
                    WHEN ecc.alteracao = 'D' AND ecc.tipo_cupom = 'C'
                        THEN (ecc.total_cupom + ecc.valor_alteracao) * -1
                    WHEN ecc.tipo_cupom = 'V'
                        THEN ecc.total_cupom
                    WHEN ecc.tipo_cupom = 'C'
                        THEN ecc.total_cupom * -1
                    ELSE 0.00
                    END
                )                                        AS vr_produto,
                Sum(CASE
                    WHEN ecc.alteracao = 'D' AND ecc.tipo_cupom = 'V'
                        THEN ecc.valor_alteracao
                    WHEN ecc.alteracao = 'D' AND ecc.tipo_cupom = 'C'
                        THEN ecc.valor_alteracao * -1
                    ELSE 0.00
                    END
                )                                        AS vr_desconto,
                Sum(
                    CASE
                    WHEN ecc.tipo_cupom = 'V'
                        THEN ecc.total_cupom
                    WHEN ecc.tipo_cupom = 'C'
                        THEN ecc.total_cupom * -1
                    ELSE 0.00
                    END
                )                                         AS vr_total,
                (SELECT descricao
                 FROM documento_documento_tipo
                 WHERE id IN (SELECT min(doc_tipo_id) FROM financeiro_titulo WHERE fatura_id IN (
                     SELECT id FROM financeiro_fatura WHERE cupom_id = ecc.id)))
                                                          AS titulo_tipo_documento,
                (
                    SELECT tipo
                    FROM adm_condicao
                    WHERE
                        id IN (
                            SELECT adm_condicao_id
                            FROM adm_condicao_forma
                            WHERE
                                id in (
                                    SELECT max(finalizadora_id)
                                    FROM ecf_cupons_finalizacao
                                    WHERE cupom_id = ecc.id
                                    )
                            )
                )                                         AS tipo_pagamento
            FROM ecf_cupons_capa ecc
            WHERE
                ecc.company_id IN %s
                AND ecc.tipo_cupom IN ('V', 'C')
                AND ecc.state = 'V'
                AND ecc.date_cupom >= '%s'
                AND ecc.date_cupom <= '%s'
        """ % (company_ids, data_inicial, data_final)
        if pessoa_id:
            sql_ecf += """
                AND ecc.cliente_id = %s
            """ % pessoa_id
        if documento_tipo_id:
            sql_ecf += """
                AND ecc.id IN (SELECT cupom_id FROM financeiro_fatura WHERE id IN (
                    SELECT fatura_id FROM financeiro_titulo WHERE doc_tipo_id = %s))
            """ % documento_tipo_id
        sql_ecf += """
            GROUP BY tipo_pagamento, titulo_tipo_documento
        """
        sql += """
            UNION ALL
            %s
        """ % sql_ecf
        return sql
