# *-* encoding: utf-8 *-*

from openerp.osv import osv, fields
from openerp.tools.translate import _

class wizard_resumo_vendas(osv.TransientModel):
    _inherit = 'wizard.resumo.vendas'

    def get_quantidade_venda(self, cr, uid, ids, company_ids, data_inicial_utc, data_final_utc, data_inicial, data_final,
                             context=None):
        context = context and context.copy() or {}
        sql = """
            SELECT sum(quantidade_venda) as quantidade_venda FROM (
            SELECT
                count(capa.id) AS quantidade_venda
            FROM fiscal_nf_capa capa
            INNER JOIN fiscal_cfop_natureza cfop_natureza ON cfop_natureza.id = capa.natureza_id
            INNER JOIN fiscal_cfop cfop ON cfop.id = cfop_natureza.cfop_id
            WHERE
                capa.company_id IN ({company_ids})
                AND capa.tipo = 'S'
                AND capa.state = '3'
                AND cfop.movimento_tipo IN ('C', 'V')
                AND cfop.codigo NOT IN ('5929', '6929')
                AND data_emissao AT TIME ZONE 'UTC' BETWEEN '{data_inicial}'
                    AND '{data_final}'
            UNION
            SELECT
                sum(CASE
                       WHEN capa.tipo_cupom = 'V' THEN 1
                       ELSE  -1
                    END) AS quantidade_venda
            FROM ecf_cupons_capa AS capa
            INNER JOIN ecf_ecf   AS ecf ON ecf.id = capa.ecf_id
            WHERE
                ecf.company_id IN ({company_ids})
                AND tipo_cupom IN ('V', 'C')
                AND capa.state = 'V'
                AND date_cupom BETWEEN '{data_inicial_ecf}' AND '{data_final_ecf}'
            ) as tmp
        """.format(data_inicial=data_inicial_utc, data_final=data_final_utc,
                   company_ids=', '.join(map(lambda c: str(c), company_ids)),
                   data_inicial_ecf=data_inicial[:10], data_final_ecf=data_final[:10])
        cr.execute(sql)
        dados = cr.dictfetchall() or [{}]
        quantidade_venda = 0
        if dados:
            quantidade_venda = dados[0].get('quantidade_venda') or 0
        return quantidade_venda

    def modelo_serie_valor(self, cr, uid, ids, data_inicial_utc, data_final_utc, data_inicial, data_final, company_ids, context=None):
        context = context and context.copy() or {}
        sql = """
                 SELECT fismnf_codigo AS modelo,
                       serie_nf AS serie,                       
                       Sum(vr_total_nf) AS valor
                FROM fiscal_nf_capa capa
                INNER JOIN fiscal_cfop_natureza cfop_natureza ON cfop_natureza.id = capa.natureza_id
                INNER JOIN fiscal_cfop cfop ON cfop.id = cfop_natureza.cfop_id
                INNER JOIN fiscal_modelo_nf modelo_nf ON modelo_nf.id = capa.modelo_nf_id
                WHERE capa.tipo = 'S'
                AND capa.company_id IN ({company_ids})
                AND capa.state = '3'
                AND cfop.movimento_tipo IN ('C', 'V')
                AND data_emissao AT TIME ZONE 'UTC' BETWEEN '{data_inicial}' AND '{data_final}'  
                GROUP BY modelo,
                         serie
                UNION 
                SELECT 'Cupom' AS modelo,
                       'Caixa:' || ecf.caixa AS serie,
                       Sum(CASE
                               WHEN capa.tipo_cupom = 'V' THEN total_cupom
                               ELSE total_cupom * -1
                           END) AS valor
                FROM ecf_cupons_capa AS capa
                INNER JOIN ecf_ecf   AS ecf ON ecf.id = capa.ecf_id
                WHERE tipo_cupom IN ('V', 'C')
                  AND date_cupom BETWEEN '{data_inicial_ecf}' AND '{data_final_ecf}'
                  AND ecf.company_id IN ({company_ids})
                GROUP BY modelo,
                         serie
        """.format(data_inicial=data_inicial_utc, data_final=data_final_utc,
                   data_inicial_ecf=data_inicial[:10], data_final_ecf=data_final[:10],
                   company_ids=', '.join(map(lambda c: str(c), company_ids)))
        cr.execute(sql)
        dados_ecf = cr.dictfetchall()
        return dados_ecf

    def pagamento_condicao_valor(self, cr, uid, ids, data_inicial_utc, data_final_utc, data_inicial, data_final, company_ids,
                                 context=None):
        context = context and context.copy() or {}
        sql = """
            SELECT *
            FROM
              (SELECT forma_pagto.name AS forma_pagto,
                      condicao_forma.name AS condicao_forma,
                      Sum(condicao.valor) AS valor_cond
               FROM fiscal_nf_capa capa
               INNER JOIN fiscal_cfop_natureza cfop_natureza ON cfop_natureza.id = capa.natureza_id
               INNER JOIN fiscal_cfop cfop ON cfop.id = cfop_natureza.cfop_id
               INNER JOIN fiscal_condicao_pagamento condicao ON condicao.capa_id = capa.id
               INNER JOIN adm_forma_pgto forma_pagto ON forma_pagto.id = condicao.forma_pagto_id
               INNER JOIN adm_condicao_forma condicao_forma ON condicao_forma.id = condicao.condicao_forma_id
               WHERE capa.tipo = 'S'
               AND capa.company_id IN ({company_ids})
               AND capa.state = '3'
               AND cfop.movimento_tipo IN ('C', 'V')
                 AND data_emissao AT TIME ZONE 'UTC' BETWEEN '{data_inicial}' AND '{data_final}'
               GROUP BY forma_pagto,
                        condicao_forma
            UNION 
            SELECT forma_pagto.name AS forma_pagto,
                   condicao_forma.name AS condicao_forma,
                   Sum(CASE
                        WHEN ecf_finalizacao.troco > 0 THEN (ecf_finalizacao.valor - ecf_finalizacao.troco)
                        ELSE ecf_finalizacao.valor
                    END) AS valor_cond
            FROM ecf_cupons_capa AS capa
            INNER JOIN ecf_cupons_finalizacao AS  ecf_finalizacao ON ecf_finalizacao.cupom_id = capa.id
            INNER JOIN adm_condicao_forma  AS condicao_forma ON condicao_forma.id = ecf_finalizacao.finalizadora_id
            INNER JOIN adm_forma_pgto  AS forma_pagto ON forma_pagto.id = condicao_forma.forma_pagamento_id
            INNER JOIN ecf_ecf   AS ecf ON ecf.id = capa.ecf_id
            WHERE capa.tipo_cupom = 'V'
              AND date_cupom BETWEEN '{data_inicial_ecf}' AND '{data_final_ecf}'
              AND capa.ecfccp_cupom_cancelamento_id IS NULL
              AND ecf.company_id IN ({company_ids})
            GROUP BY forma_pagto,
                     condicao_forma) AS tmp
            ORDER BY tmp.forma_pagto
        """.format(data_inicial=data_inicial_utc, data_final=data_final_utc,
                   data_inicial_ecf=data_inicial[:10], data_final_ecf=data_final[:10],
                   company_ids=', '.join(map(lambda c: str(c), company_ids)))

        cr.execute(sql)
        dados_ecf = cr.dictfetchall()
        return dados_ecf

    def cfop_natureza_valor(self, cr, uid, ids, data_inicial_utc, data_final_utc, data_inicial, data_final, company_ids,
                            context= None):
        context = context and context.copy() or {}
        sql = """
        SELECT cfop_natureza.fisnat_natureza_fiscal as natureza_fiscal,
               cfop.codigo AS codigo_cfop,
               Sum(vr_total_nf) AS valor
        FROM fiscal_nf_capa capa
        INNER JOIN fiscal_cfop_natureza cfop_natureza ON cfop_natureza.id = capa.natureza_id
        INNER JOIN fiscal_cfop cfop ON cfop.id = cfop_natureza.cfop_id
        WHERE capa.tipo = 'S'
        AND capa.company_id IN ({company_ids})
        AND capa.state = '3'
        AND cfop.movimento_tipo IN ('C', 'V')
          AND data_emissao AT TIME ZONE 'UTC' BETWEEN '{data_inicial}' AND '{data_final}'
        GROUP BY codigo_cfop,
                 natureza_fiscal
        UNION 
        SELECT 'Cupom' AS natureza_fiscal,
               cfop_itens.codigo AS codigo_cfop,
               SUM(vr_total_item_rateado) AS valor
        FROM estoque_movimento_itens AS mov_itens
        INNER JOIN fiscal_cfop AS cfop_itens ON cfop_itens.id = mov_itens.cfop_id
        INNER JOIN ecf_cupons_capa AS ecf_capa ON ecf_capa.id = mov_itens.cupom_id
        INNER JOIN ecf_ecf   AS ecf ON ecf.id = ecf_capa.ecf_id
        WHERE ecf_capa.date_cupom BETWEEN '{data_inicial_ecf}' AND '{data_final_ecf}'
          AND NOT (mov_itens.item_cancelado IS TRUE
                   AND ecf_capa.tipo_cupom = 'V')
          AND ecf_capa.ecfccp_cupom_cancelamento_id IS NULL
          AND mov_itens.cupom_id IS NOT NULL
          AND ecf_capa.tipo_cupom = 'V'
          AND mov_itens.nf_id IS NULL
          AND ecf.company_id IN ({company_ids})
        GROUP BY codigo_cfop,
                 natureza_fiscal
        """.format(data_inicial=data_inicial_utc, data_final=data_final_utc,
                   data_inicial_ecf=data_inicial[:10], data_final_ecf=data_final[:10],
                   company_ids=', '.join(map(lambda c: str(c), company_ids)))

        cr.execute(sql)
        dados_ecf = cr.dictfetchall()
        return dados_ecf
