# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class ecf_cupons_item(osv.Model):
    """
    Tabela contendo os itens do cupom
    """

    # prefixo: ecfcit_

    _description = __doc__
    _name = 'ecf.cupons.item'
    _rec_name = 'capa_id'
    _columns = {
        'capa_id': fields.many2one('ecf.cupons.capa', 'Cupom', required=True, select=True, ondelete='cascade'),
        'item': fields.char('Codigo do Produto', size=14, required=True, help='Codigo de Barras do Produto',select=True),
        'quantidade': fields.float('Quantidade', digits=(8, 3), required=True,
                                   help='Quantidade Vendica/Cancelada com 3 Casas Decimais'),
        'preco_total': fields.float('Preco Total', digits=(10, 2), required=True,
                                    help='Preco Total da Venda/Cancelamento(sem desconto e sem acrescimo) com 2 decimais'),
        'desconto': fields.float('Desconto', digits=(10, 2), required=True,
                                 help='Valor do Desconto Concedido no Item'),
        'acrescimo': fields.float('Acrescimo', digits=(10, 2), required=True,
                                  help='Valor do Acrescimo Concedido no Item'),
        'venda_cancelamento': fields.selection([('V', 'Venda'), ('C', 'Cancelamento')], 'Indicador de Venda',
                                               required=True,
                                               help='Indicado de Venda/Cancelamento do Item Adicionado ao Cupom'),
        'tributacao_ecf': fields.char('tributacao na ECF', size=3, required=True, help='Codigo de Tributacao na ECF'),
        'tributacao_retag': fields.char('Tributacao no Retaguarda', size=2, required=True,
                                        help='Codigo da Tributacao do Produto no Sistema de Gestao'),
        'tributacao_item_ids': fields.one2many('ecf.cupons.item.tributacao', 'ecfcit_cupom_item_id', 'Tributacao', ondelete="cascade", select=True),
        'aliquota': fields.float('Aliquota', digits=(2, 2), required=True, help='Aliquota do ICMS'),
        'base': fields.float('Base de Calculo', digits=(1, 3), required=True, help='Base de Calculo dp ICMS'),
        'sequencia': fields.integer('Sequencia'), # Sequencia do item no cupom
        'ecfcit_cod_vendedor': fields.integer('Cod vendedor'),
        'ecfcit_nome_vendedor': fields.char('Vendedor item', size=40),
    }


