#!/usr/bin/python
# -*- encoding: utf-8 -*-
from openerp.osv import osv, fields


class ecf_cupons_item_tributacao(osv.Model):
    """
    Tabela das tributacoes ocorridas em cada item
    PREFIXO : ecfcit_
    """

    from funcoes import _get_tipo_substituicao

    _name = 'ecf.cupons.item.tributacao'
    _rec_name = 'ecfcit_encargo_id'
    _columns = {
        'ecfcit_nf_item_tributacao_id': fields.many2one("fiscal.nf.item.tributacao", "Id Tributacao", select=True),
        'ecfcit_movimento_itens_id': fields.many2one("estoque.movimento.itens", "Movimento itens", ondelete="cascade", select=True),
        'ecfcit_cupom_item_id': fields.many2one("ecf.cupons.item", 'Item do Cupom', ondelete="cascade", select=True),
        'ecfcit_encargo_id': fields.many2one("fiscal.encargo", 'Encargo', ondelete="restrict", select=True), # Id do encargo
        'ecfcit_cst_id': fields.many2one("fiscal.cst", 'Cst', ondelete="restrict", select=True), # Id do cst do encargo
        'ecfcit_tributacao_id': fields.many2one("fiscal.tributacao", 'Tributacao', ondelete="restrict", select=True),
        'ecfcit_aliquota': fields.float('Aliquota', digits=(6, 3)), # aliquota aplicada ao item
        'ecfcit_vr_base_calculo': fields.float('Vr base calculo', digits=(15, 2)), # Valor da base de calculo
        'ecfcit_vr_encargo': fields.float('Vr encargo', digits=(15, 2)), # Valor calculado do encargo
        'ecfcit_vr_reducao_base': fields.float('Vr reducao base', digits=(15, 2)), # Valor reduzido na base de calculo\n
        'ecfcit_retido': fields.boolean('Retido'), # Informa se o encargo e ou nao retido pelo cliente.
        'ecfcit_percentual_mva': fields.float('Percentual mva', digits=(7, 4)),  # Percentual da margem de valor agregado (MVA) aplicado.
        'ecfcit_modbcst': fields.selection([
            ('0', 'Preco tabelado'),
            ('1', 'Lista negativa'),
            ('2', 'Lista positiva'),
            ('3', 'Lista neutra'),
            ('4', 'Margem valor agregado'),
            ('5', 'Pauta'),
            ('6', 'Valor da operacao')], 'Modal.determ. BC do ICMS ST',
                                           help="Modalidade de determinacao da Base de Calculo do ICMS de Substituicao Tributaria",
                                           size=1),
        'ecfcit_valor_pauta': fields.float('Valor Pauta', digits=(10, 2), required=False),
        'ecfcit_vr_base_icms_substituicao': fields.float('Vr base icms substituicao', digits=(14, 2)),  # Base de substituicao tributaria destacada na nf
        'ecfcit_vr_icms_substituicao': fields.float('Vr icms substituicao', digits=(14, 2)),  # valor do icms da substituicao tributaria
        'ecfcit_vr_icms_substituicao_guia': fields.float('Vr icms substituicao Guia', digits=(14, 2)),  # valor do icms da substituicao tributaria da guia
        'ecfcit_aliquota_venda': fields.float('Aliquota para venda', digits=(5, 2),
                                       help='Aliquota de ICMS na venda para verificacao de calculo do ICMS ST na compra.'),
        'ecfcit_tipo_substituicao': fields.function(_get_tipo_substituicao, type="boolean", method=True, store=True,
                                             string='Tipo Substituicao'),  #flag nao historiado, para que os campos de mva e aliquota para venda se tornem editáveis quando a tributacao for substituicao tributária com os CST's 10,30 e 70.
        'ecfcit_csosn_id': fields.many2one('fiscal.csosn', 'CSOSN'), #Para empresa com Simples Nacional este campo e preenchido e o cst_id ficará vazio
        'ecfcit_nat_rec_pis_cofins': fields.char('Natureza da Receita PIS/COFINS', size=3),

    }

