# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class ecf_cupons_xz(osv.Model):
    _name = 'ecf.cupons.xz'
    _columns = {
        'cupom_id': fields.many2one("ecf.cupons.capa", 'Cupom', ondelete="cascade", required=True, select=True),
        # id do cupom
        'cupom_inicial': fields.float('Cupom inicial', digits=(6, 0)), # Numero do primeiro cupom do dia
        'create_date': fields.datetime('Data'),
        'cupom_final': fields.float('Cupom final', digits=(6, 0)), # Numero do ultimo cupom\n
        'gt_inicial': fields.float('Gt inicial', digits=(18, 2)), # valor do GT inicial
        'gt_final': fields.float('Gt final', digits=(18, 2)), # Valor do GT final
        'cancelamentos': fields.float('Cancelamentos', digits=(14, 2)), # valor dos cancelamentos do dia
        'descontos': fields.float('Descontos', digits=(14, 2)), # Valor dos descontos do dia
        'acrescimos': fields.float('Acrescimos', digits=(14, 2)), # Valor dos acrescimos do dia
        'crz': fields.integer('Crz'), # Contador de reducoes Z,
        'cro': fields.integer('CRO')
    }

