# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class ecf_cupons_xztotalizadores(osv.Model):
    _name = 'ecf.cupons.xztotalizadores'
    _columns = {
        'cupom_id': fields.many2one("ecf.cupons.capa", 'Cupom', ondelete="cascade", required=True, select=True),
        'tipo_totalizador': fields.selection([('I', 'Isentos'),
                                              ('O', 'Outros'),
                                              ('U', 'Substituicao'),
                                              ('D', 'Diferido'),
                                              ('T', 'Tributado')], 'Tipo totalizador', size=1),
        'imposto': fields.selection([('C', 'ICMS'), ('S', 'ISS')], 'Imposto', size=1),
        'aliquota': fields.float('Aliquota', digits=(4, 2)), # aliquota tributaria\n
        'base_imposto': fields.float('Base imposto', digits=(14, 2)), # Valor base para calculo do imposto
        'valor_imposto': fields.float('Valor imposto', digits=(14, 2)), # Valor do Imposto\n
        'base_reduzida_concede_desconto': fields.float('Base reduzida concede desconto', digits=(14, 2)),
        # Valor referente a parte nao tributada(base reduzida)\n
        'tributacao_na_ecf': fields.integer('Tributacao ECF'),
        'tributacao_retag_id': fields.many2one('fiscal.tributacao', 'Tributacao', ondelete="restrict"),
    }


