# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class ecf_cupom_log(osv.Model):
    """
    Classe de dados para registrar os erros decorridos da importacao e validacao dos cupons.
    """

    _name = 'ecf.cupom.log'
    _rec_name = 'txt_erro'
    _columns = {
        'data_criacao': fields.datetime('Data criacao', help="Data da Criacao do registro de log"),
        'nome_arquivo_log': fields.char('Nome arquivo', size=12, help="Nome do arquivo de log que gerou erro"),
        'numero_cupom': fields.integer('Nro cupom', help="Nro do cupom com erro"),
        'numero_linha_log': fields.integer('Nro linha', help="Nro da linha do arquivo de log"),
        'numero_coluna_log': fields.integer('Nro coluna', help="Nro da Coluna do arquivo de log"),
        'txt_log': fields.text('Fragmento', help="Fragmento da linha com erro"),
        'txt_erro': fields.text('Descricao erro'),
        'cupom_id': fields.many2one('ecf.cupons.capa', 'Cupom', select=1, ondelete='cascade')
    }

