# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class ecf_ecf(osv.Model):
    """
    Tabela de cadastro de ECFs
    """

    #prefixo = ecfecf_

    from funcoes import _ecfecf_get_name

    _name = 'ecf.ecf'
    _rec_name = 'name'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'local_id': fields.many2one("estoque.local", 'Local', ondelete="restrict", required=True, select=True),
        'fabricante_id': fields.many2one("adm.pessoa", 'Fabricante', ondelete="restrict", required=True, select=True,
                                         domain=[('pessoa_tipo', '=', 'J')]),
        'ecf_conta_id': fields.many2one("financeiro.tesouraria.contas", "Conta", ondelete="restrict",
                                        domain=[('banco_caixa', '=', 'E')],
                                        help="Conta da tesouraria para lancamento na importacao de "
                                             "cupons. Se nao estiver cadastrada, vai usar a conta "
                                             "definida no parametro do "
                                             "financeiro(Conta caixa recebimento a vista)"),
        'nro_serie': fields.char('Nro serie', size=25, required=True),  # Numero de Serie da ECF
        'ativo': fields.boolean('Ativo'), # Situacao do ECF: Ativo/Inativo\n
        'modelo': fields.char('Modelo', size=10, required=True), # Modelo do ECF
        'loja': fields.integer('Loja', required=True, select=True), # Numero da empresa no ECF(Loja)
        'caixa': fields.integer('Caixa', required=True), # Numero do caixa
        'cupons_capa_ids': fields.one2many('ecf.cupons.capa', 'ecf_id', 'Capa'),
        'name': fields.function(_ecfecf_get_name, method=True, store=False, type="text", string='Name'),
    }
    _defaults = {
        'ativo': lambda *a: True,
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }

    _sql_constraints = [
        ('caixa_uniq', 'unique (company_id, loja, caixa)', 'O caixa precisa ser unico!'),
    ]

#noinspection PyArgumentList

