#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class ecf_exportar_saldo_super(osv.Model):
    """
    Objeto guarda o codigo de barra, loja e o saldo para atualizar o supervisor do caixa.
    Quando o metodo de atualizar saldo(atualizar_saldo_do_dia) for utilizado,
    deverá ser gravado ou atualizado um registro neste objeto.
    Caso o produto já exista, somente o seu saldo será atualizado, pois nao será permitido haver produto em duplicidade.
    """

    def get_company_default(self, cr, uid, context=None):
        context = context and context.copy() or {}
        getEmpresa = self.pool.get('adm.empresa.objeto').getEmpresa
        return getEmpresa(cr, uid, tabela='ecf.exportar.saldo.super', context=context)


    _name = 'ecf.exportar.saldo.super'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True,
                                      select=True),
        'ecfess_loja': fields.integer('Loja', required=True),
        'ecfess_codigo_barra': fields.char('Codigo Barra', size=14, required=True),
        'ecfess_saldo': fields.float('Saldo', digits=(15, 2), required=True),
        'ecfess_exporta_saldo_inicial': fields.boolean('Exportar saldo inicial'),
    }
    _sql_constraints = [(
        'ecfess_codigobarra_uniq',
        'unique (company_id, ecfess_loja, ecfess_codigo_barra)',
        'O Codigo de Barra deve ser unico na a tabela de exportacao de saldo para o supervisor por empresa'
    )]
    _defaults = {
        'company_id': get_company_default,
    }
    _order = 'ecfess_codigo_barra'
