# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class ecf_mapa_resumo_capa(osv.Model):
    # prefixo: ecfmrc_
    _description = 'Dados da capa do mapa de resumo de ECF'
    _name = 'ecf.mapa.resumo.capa'
    _columns = {
        'data': fields.date('Data', required=True),
        'ecf': fields.many2one('ecf.ecf', 'Ecf', required=True),
        'numero_z': fields.integer('Numero Z'),
        'cupom_inicial': fields.integer('Cupom inicial'),
        'cupom_final': fields.integer('Cupom final'),
        'gt_inicial': fields.float('GT inicial', digits=(16, 2)),
        'gt_final': fields.float('GT final', digits=(16, 2)),
        'cancelamentos': fields.float('Cancelamentos', digits=(12, 2)),
        'descontos': fields.float('Descontos', digits=(12, 2)),
        'acrescimos': fields.float('Acrescimos', digits=(12, 2)),
        'coo': fields.integer('Nro cupom'),
        'cro': fields.integer('CRO', size=3),
        'item_ids': fields.one2many('ecf.mapa.resumo.itens', 'capa_id', 'Itens'),
        'ecfmrc_cupom_id': fields.many2one('ecf.cupons.capa', 'Cupom', ondelete='cascade'),
    }
    _order = 'data desc, ecf'
    _sql_constraints = [
        ('data_ecf_uniq', 'unique (data,ecf)', 'A ecf deve ser unica para a data'.decode('utf-8') ),
    ]

