# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class ecf_mapa_resumo_itens(osv.Model):
    _description = 'Dados dos itens do mapa de resumo de ECF'
    _name = 'ecf.mapa.resumo.itens'
    _columns = {
        'capa_id': fields.many2one('ecf.mapa.resumo.capa', 'Capa', required=True, ondelete='cascade'),
        'tipo': fields.selection(
            [('T', 'Tributado'), ('I', 'Isentos'), ('O', 'Outros'), ('F', 'Substituicao'), ('D', 'Diferido')], 'Tipo',
            size=1, required=True),
        'imposto': fields.selection([('C', 'ICMS'), ('S', 'ISS'), ('0', '')], 'Imposto', size=1, required=True),
        'aliquota': fields.float('Aliquota', digits=(2, 2)),
        'base_valor': fields.float('Valor base', digits=(12, 2)),
        'imposto_valor': fields.float('Valor imposto', digits=(12, 2)),
        'base_reduzida': fields.float('Base reduzida', digits=(12, 2))
    }

