# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2012 All Rights Reserved. Maxwell da Silva Oliveira
#                    www.siginformatica.com.br maxwell.oliveira@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class ecf_tesouraria_capa(osv.Model):
    """
    Tabela de Capa da Tesouaria do ecf
    """

    #prefixo = ecftcp_

    from funcoes import _ecftcp_sangria, _ecftcp_suprimento

    _name = 'ecf.tesouraria.capa'
    _rec_name = 'ecf_id'
    _description = 'Capa da Tesouraria por ecf'
    _columns = {
        'id': fields.integer('id'),
        'ecf_id': fields.many2one("ecf.ecf", 'Ecf', ondelete="cascade", required=True, select=True), # ID DO ECF
        'conta_id': fields.many2one("financeiro.tesouraria.contas", 'Conta', ondelete="cascade",
                                    domain="[('banco_caixa', '=', 'T')]", required=True, select=True), # ID DO ECF
        'data_movimento': fields.date('Data movimento', required=True), # data da movimentacao
        'sangria': fields.function(_ecftcp_sangria, string='sangria', type='float', digits=(9, 2), method=True,
                                   stored=False),
        'suprimentos': fields.function(_ecftcp_suprimento, string='Suprimento', type='float', digits=(9, 2),
                                       method=True, stored=False),
        'movimento_ids': fields.one2many('ecf.tesouraria.movimento', 'capa_id', 'Movimento'),
    }
    _defaults = {
        'data_movimento': lambda *a: time.strftime('%Y-%m-%d')
    }
