# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2012 All Rights Reserved. Maxwell da Silva Oliveira
#                    www.siginformatica.com.br maxwell.oliveira@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class ecf_tesouraria_movimento(osv.Model):
    """
    Tabela de Movimentacao da Tesouaria do ecf
    """

    _name = 'ecf.tesouraria.movimento'
    _description = 'Movimento da Tesouraria por ecf'
    _columns = {
        'capa_id': fields.many2one("ecf.tesouraria.capa", 'capa', ondelete="restrict", required=True),
        'finalizadora_id': fields.many2one("adm.condicao.forma", 'Finalizadora', ondelete="cascade", required=True),
        'coo': fields.integer('COO'),
        'tipo': fields.selection([('A', 'Sangria'),
                                  ('U', 'Suprimento'),
                                 ], 'Tipo', size=1, required=True),
        'valor': fields.float('valor', digits=(9, 2), required=True),
        'financeiro_movimento_id': fields.integer('Financeiro Movimento')

    }
