# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################



# Funcoes da classe ecf_cupons_capa
def ecfccp_get_dados_cupom(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for cupom in self.read(cr, uid, ids, ['coo', 'ecf_id', 'date_cupom','tipo_cupom',
                                          'cupom_financeiro_fatura_ids'], context=context,
                           load='_classic_write'):
        res[cupom.get('id')]= {'flag_faturado': bool(cupom.get('cupom_financeiro_fatura_ids')),
                               'ecfccp_cupom_cancelamento_id': False}
        if cupom.get('tipo_cupom') == 'C':
            continue

        cancel_ids = self.search(cr, uid, [('coo','=',cupom.get('coo')+1),
                                           ('ecf_id','=',cupom.get('ecf_id')),
                                           ('date_cupom','=',cupom.get('date_cupom')),
                                           ('tipo_cupom','=','C')],
                                 context=context)
        if not cancel_ids:
            continue

        res[cupom.get('id')]['ecfccp_cupom_cancelamento_id'] = cancel_ids[0]

    return res

# Funcoes da classe ecf_ecf
def _ecfecf_get_name(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}.fromkeys(ids, '-')

    data_ecf = self.read(cr, uid, ids, ['loja', 'caixa', 'modelo'], context=context)
    for ecf in data_ecf:
        id = ecf.get('id', 0)
        if context.get('resumo_importacao'):
            res[id] = '   %s  -   %s ' % (ecf.get('loja'), ecf.get('caixa'))
        else:
            res[id] = '%s/%s - %s ' % (ecf.get('loja'), ecf.get('caixa'), ecf.get('modelo'))
    return res

# Funcoes da classe ecf_tesouraria_capa
def _ecftcp_sangria(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}.fromkeys(ids, 0.0)
    sangia_ids = {}
    if not ids:
        return res
    cr.execute('''SELECT
                capa_id, sum(valor)
            FROM
                ecf_tesouraria_movimento
            WHERE
                capa_id in %s AND
                tipo = 'A'
            GROUP BY
                capa_id''', (tuple(ids),))
    sangia_ids = dict(map(lambda x: (x[0], (x[1])), cr.fetchall()))
    for id in ids:
        s = sangia_ids.get(id, 0.0)
        res[id] = s
    return res


def _ecftcp_suprimento(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}.fromkeys(ids, 0.0)
    suprimentos_ids = {}
    if not ids:
        return res
    cr.execute('''SELECT
                capa_id, sum(valor)
            FROM
                ecf_tesouraria_movimento
            WHERE
                capa_id in %s AND
                tipo = 'U'
            GROUP BY
                capa_id''', (tuple(ids),))
    suprimentos_ids = dict(map(lambda x: (x[0], (x[1])), cr.fetchall()))
    for id in ids:
        s = suprimentos_ids.get(id, 0.0)
        res[id] = s
    return res

#Funcoes da classe ecf_cupons_item_tributacao
def _get_tipo_substituicao(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for p in self.browse(cr, uid, ids):
        res[p.id] = False
        if p.ecfcit_tributacao_id.cst_id.tipo == 'U':
            if p.ecfcit_cst_id.codigo in ('10', '30', '70'):
                res[p.id] = True
    return res

def ecfccp_get_cupom_venda_id(self, cr, uid, ids, context=None):
    '''
    Retorna os ids dos cupons de venda referente aos cupons de cancelamento
    :param ids: ids da classe estoque.preco.custo
    :return:
    '''
    context = context and context.copy() or {}
    res = []
    for cupom in self.read(cr, uid, ids, ['coo', 'ecf_id', 'date_cupom','tipo_cupom',
                                          'cupom_financeiro_fatura_ids'], context=context,
                           load='_classic_write'):
        if cupom.get('tipo_cupom') == 'V':
            continue

        venda_ids = self.search(cr, uid, [('coo','=',cupom.get('coo')-1),
                                           ('ecf_id','=',cupom.get('ecf_id')),
                                           ('date_cupom','=',cupom.get('date_cupom')),
                                           ('tipo_cupom','=','V')],
                                 context=context)
        if not venda_ids:
            continue

        res.extend(venda_ids)

    return res
