# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools import drop_view_if_exists


class ecf_resumo_tributacoes_view(osv.Model):
    _name = "ecf_resumo_tributacoes_view"
    _auto = False
    _columns = {
        'ecfrtv_data': fields.date('Data do movimento'),
        'ecfrtv_ecf_id': fields.many2one('ecf.ecf', 'Ecf'),
        'ecfrtv_tributacao_retag': fields.char('Tributacao', size=2),
        'ecfrtv_aliquota': fields.float('Aliquota', digits=(2, 2)),
        'ecfrtv_base': fields.float('Base', digits=(14, 2))
    }

    def init(self, cr):
        drop_view_if_exists(cr, "ecf_resumo_tributacoes_view")
        cr.execute("""
            CREATE OR REPLACE VIEW ecf_resumo_tributacoes_view AS(
                SELECT
                    rank () over (order by  capa.date_cupom, capa.ecf_id, tributacao.tributacao_id, tributacao.aliquota, tributacao.vr_base_calculo) as id,
                    capa.date_cupom as ecfrtv_data,
                    capa.ecf_id as ecfrtv_ecf_id,
                    tributacao.tributacao_id as ecfrtv_tributacao_retag,
                    tributacao.aliquota as ecfrtv_aliquota,
                    tributacao.vr_base_calculo as ecfrtv_base
                FROM
                    fiscal_nf_item_tributacao tributacao,
                    estoque_movimento_itens item,
                    ecf_cupons_capa capa
                WHERE
                    capa.id = item.cupom_id and
                    item.id = tributacao.movimento_itens_id
                GROUP BY
                    capa.date_cupom,
                    capa.ecf_id,
                    tributacao.tributacao_id,
                    tributacao.aliquota,
                    tributacao.vr_base_calculo
                ORDER BY
                    capa.date_cupom
            )
        """)
