# -*- encoding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.osv import osv
from openerp.tools.translate import _
from dateutil.parser import parse


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        title = center_title('', _('Resumo da Importacao'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Resumo da Importacao'))
        listagem.informaTamLinha(160)

        obj_ecf_cupons_capa = pooler.get_pool(cr.dbname).get('ecf.cupons.capa')
        obj_ecf_ecf = pooler.get_pool(cr.dbname).get('ecf.ecf')
        obj_automacao_codigo_barra = pooler.get_pool(cr.dbname).get('automacao.codigo.barra')
        obj_adm_utils = pooler.get_pool(cr.dbname).get('adm.utils')

        data_inicial = datas.get('data_inicial')
        data_final = datas.get('data_final')
        loja = datas.get('loja')
        caixa = datas.get('caixa')
        cupom_id = datas.get('cupom_id')
        opcao = datas.get('opcao')

        args_cupom = []
        browse_cupom = []
        if cupom_id:
            browse_cupom = obj_ecf_cupons_capa.browse(cr, uid, [cupom_id])
        else:
            args_cupom.append(('date_cupom', '>=', data_inicial), )
            args_cupom.append(('date_cupom', '<=', data_final), )
            ecf_ids = obj_ecf_ecf.search(cr, uid, [('loja', '=', loja), ('caixa', '=', caixa)], context=context)
            if ecf_ids:
                args_cupom.append(('ecf_id', 'in', ecf_ids), )
            cupom_ids = obj_ecf_cupons_capa.search(cr, uid, args_cupom, order='coo ASC', context=context)
            if cupom_ids:
                browse_cupom = obj_ecf_cupons_capa.browse(cr, uid, cupom_ids)
        if browse_cupom:
            company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                                                         'wizard.listagem.cupons',
                                                                                         context=context)
            nome_empresa = pooler.get_pool(cr.dbname).get('res.company').browse(cr, uid, company_id).name
            data = time.strftime("%d/%m/%Y")
            docs = center_title(data, nome_empresa, 'Pagina: {{ Page }} ')

            listagem.informaCab('' + title)
            listagem.informaCab('')
            listagem.informaCab('')
            listagem.informaCab('' + docs)
            listagem.informaCab('  ')
            listagem.informaCab(
                '*--------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.informaCab(
                _(
                    '| LOJA | ECF |   CUPOM   |              C L I E N T E               | HORA |  TIPO CUPOM  | ACR./DESC. | TOTAL CUPOM | OPERADOR |    OBSERVACAO    |'))
            if opcao == 'A':
                listagem.informaCab(
                    _(
                        '|              SEQ | CODIGO DE BARRAS |               DESCRICAO              | QUANTIDADE | PRECO TOTAL | DESCONTO | ACRESCIMO | T |  TRIBUTACAO   |'))
                listagem.informaCab(
                    _(
                        '|              SEQ |     F I N A L I Z A D O R A    | T |   VALOR   |   TROCO   |                                                                  |'))
                listagem.informaCab(
                    _(
                        '|            VENCIM. | PARCELA |  VENCIM.  | PARCELA | VENCIM.   | PARCELA | VENCIM.   | PARCELA | VENCIM.   | PARCELA | VENCIM.   | PARCELA       |'))
            listagem.informaCab(
                '*--------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.informaCab('  ')
            listagem.rodapePadrao()
            list_tributacao = []
            tributacoes = {}
            cr.execute('select distinct tributacao_retag from ecf_cupons_item order by tributacao_retag')
            dict_tributacao = cr.dictfetchall()
            for x in dict_tributacao:
                tributacoes[x.get('tributacao_retag')] = 0.0
            if opcao == 'A':
                for x in browse_cupom:
                    linha = formataString(x.ecf_id.loja or '', 6, ' ', 'D', 'N', 'S') + '|'
                    linha += ' '
                    linha += formataString(x.ecf_id.caixa or '', 4, ' ', 'D', 'N', 'S') + '|'
                    linha += ' '
                    linha += formataString(x.coo or '', 10, ' ', 'D', 'N', 'S') + '|'
                    linha += ' '
                    linha += formataString(x.cliente_id.name or '', 41, ' ', 'D', 'N', 'S') + '|'
                    linha += ' '
                    hora_cupom_fim = ''
                    if x.hora_cupom_fim:
                        hora_cupom_fim = obj_adm_utils.admutl_datetime_to_timezone(
                            cr, uid, parse(x.hora_cupom_fim), '%Y-%m-%d %H:%M:%S')[11:16]
                    linha += formataString(hora_cupom_fim, 5, ' ', 'D', 'N', 'S') + '|'
                    linha += ' '
                    linha += formataString('%s %s' % (x.tipo_cupom, self.get_tipo_cupom(cr, uid, x.tipo_cupom)), 13,
                                           ' ', 'D', 'N', 'S') + '|'
                    linha += ' '
                    linha += formataString(getNumeroEditado(x.valor_alteracao, 2), 11, ' ', 'E', 'N', 'S') + '|'
                    linha += ' '
                    linha += formataString(getNumeroEditado(x.total_cupom, 2), 12, ' ', 'E', 'N', 'S') + '|'
                    linha += ' '
                    linha += formataString(x.operador.ecf_operador, 9, ' ', 'D', 'N', 'S') + '|'
                    linha += ' '
                    if x.state == 'C':
                        observacao = _('Falta Validar')
                    elif x.state == 'D':
                        observacao = _('C/ Divergencia')
                    else:
                        observacao = _('Validado')

                    linha += formataString(observacao, 17, ' ', 'E', 'N', 'S') + '|'
                    linha += ' '
                    listagem.imprimeLinha('|' + linha)
                    if x.ecf_cupons_item_ids:
                        cupom_item_ids = filter(lambda w: w.venda_cancelamento == 'V',
                                                x.ecf_cupons_item_ids)
                        c = 1
                        for i in cupom_item_ids:
                            codigo_barra = i.item or ''
                            produto_name = ''
                            if codigo_barra:
                                codigo_barra_id = obj_automacao_codigo_barra.search(cr, uid, [
                                    ('codigo_barra', '=', codigo_barra)], context=context)
                                if codigo_barra_id:
                                    produto_name = obj_automacao_codigo_barra.browse(cr, uid, codigo_barra_id[
                                        0]).produto_id.name or ''
                            tributacao_retag = i.tributacao_retag or ''
                            linha = formataString('        Item', 12, ' ', 'D', 'N', 'S') + ' '
                            linha += ' '
                            linha += formataString(c, 4, ' ', 'D', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(i.item or '', 17, ' ', 'D', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(produto_name, 37, ' ', 'D', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(getNumeroEditado(i.quantidade or 0.0, 3), 11, ' ', 'E', 'N',
                                                   'S') + '|'
                            linha += ' '
                            linha += formataString(getNumeroEditado(i.preco_total or 0.0, 2), 12, ' ', 'E', 'N',
                                                   'S') + '|'
                            linha += ' '
                            linha += formataString(getNumeroEditado(i.desconto or 0.0, 2), 9, ' ', 'E', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(getNumeroEditado(i.acrescimo or 0.0, 2), 10, ' ', 'E', 'N',
                                                   'S') + '|'
                            linha += ' '
                            linha += formataString(i.venda_cancelamento or '', 2, ' ', 'D', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(i.tributacao_retag or '', 14, ' ', 'D', 'N', 'S') + '|'
                            linha += ' '
                            listagem.imprimeLinha('|' + linha)
                            if tributacao_retag and tributacao_retag not in list_tributacao:
                                list_tributacao.append(tributacao_retag)
                                tributacoes[tributacao_retag] = i.preco_total or 0.0
                            elif tributacao_retag and tributacao_retag in list_tributacao:
                                tributacoes[tributacao_retag] += i.preco_total or 0.0
                            c += 1
                    if x.cupons_finalizacao_ids:
                        cupom_finalizacao_ids = x.cupons_finalizacao_ids
                        c = 1
                        for i in cupom_finalizacao_ids:
                            finalizadora = ''
                            finalizadora_id = i.finalizadora_id
                            if finalizadora_id:
                                forma_pagamento_id = finalizadora_id.forma_pagamento_id
                                if forma_pagamento_id:
                                    finalizadora = forma_pagamento_id.name or ''
                            linha = formataString('Finalizadora', 12, ' ', 'D', 'N', 'S') + ' '
                            linha += ' '
                            linha += formataString(c, 4, ' ', 'D', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(finalizadora, 31, ' ', 'D', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(i.tipo_finalizadora or '', 2, ' ', 'D', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(getNumeroEditado(i.valor or 0.0, 2), 10, ' ', 'E', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(getNumeroEditado(i.troco or 0.0, 2), 10, ' ', 'E', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString('', 65, ' ', 'D', 'N', 'S') + '|'
                            linha += ' '
                            listagem.imprimeLinha('|' + linha)
                            c += 1
                        c = 0
                        for i in cupom_finalizacao_ids:
                            vencimento_ids = i.ecf_cupons_vencimento_ids
                            if vencimento_ids:
                                for i in vencimento_ids:
                                    data_vencimento = time.strftime('%d/%m/%Y',
                                                                    time.strptime(i.data_vencimento, '%Y-%m-%d'))
                                    c += 1
                                    if c == 1:
                                        linha = formataString(data_vencimento or '', 20, ' ', 'E', 'N', 'S') + '|'
                                    else:
                                        linha += formataString(data_vencimento or '', 10, ' ', 'E', 'N', 'S') + '|'
                                    linha += ' '
                                    linha += formataString(getNumeroEditado(i.valor or 0.0, 2), 8, ' ', 'E', 'N',
                                                           'S') + '|'
                                    linha += ' '
                                    if c == 6 or i == vencimento_ids[-1]:
                                        listagem.imprimeLinha('|' + linha)
                                        linha = ''
                                        c = 0
                if tributacoes:
                    listagem.imprimeLinha(
                        '|                                                                                                                                                  |')
                    c = 1
                    for i in tributacoes:
                        if c == 1:
                            linha = formataString(_('Tributacoes        Trib:%s') % i, 25, ' ', 'D', 'N', 'S') + ' '
                        else:
                            linha = formataString(_('Trib:%s') % i, 25, ' ', 'E', 'N', 'S') + ' '
                        linha += ' '
                        linha += formataString(_('Aliq.:0,00'), 20, ' ', 'E', 'N', 'S') + ' '
                        linha += ' '
                        linha += formataString(_('Valor:'), 6, ' ', 'E', 'N', 'S') + ' '
                        linha += ' '
                        linha += formataString(getNumeroEditado(tributacoes.get(i) or 0.0, 2), 10, ' ', 'E', 'N',
                                               'S') + ' '
                        linha += ' '
                        linha += formataString(_('Imposto: 0,00'), 20, ' ', 'E', 'N', 'S') + ' '
                        linha += ' '
                        linha += formataString('', 54, ' ', 'E', 'N', 'S') + ' '
                        linha += '|'
                        listagem.imprimeLinha('|' + linha)
                        c += 1
                    listagem.imprimeLinha(
                        '|                                                                                                                                                  |')
                    listagem.imprimeLinha(
                        _(
                            '| *** Resumo por tributacao ***                                                                                                                    |'))
                    for i in tributacoes:
                        if tributacoes.get(i) > 0:
                            linha = formataString(_('Tributacoes       Trib:%s') % i, 25, ' ', 'D', 'N', 'S') + ' '
                            linha += ' '
                            linha += formataString(_('Valor:'), 6, ' ', 'E', 'N', 'S') + ' '
                            linha += ' '
                            linha += formataString(getNumeroEditado(tributacoes.get(i) or 0.0, 2), 10, ' ', 'E', 'N',
                                                   'S') + ' '
                            linha += ' '
                            linha += formataString('', 98, ' ', 'E', 'N', 'S') + ' '
                            linha += '|'
                            listagem.imprimeLinha('|' + linha)
            else:
                cr.execute('select loja, caixa from ecf_ecf ')
                dados_ecf = cr.dictfetchall()
                dados_ecf.sort()
                dados_ecf = sorted(dados_ecf, key=lambda v: v['caixa'])
                for i in dados_ecf:
                    entrou = False
                    for x in browse_cupom:
                        if i.get('loja') == x.ecf_id.loja and i.get('caixa') == x.ecf_id.caixa:
                            entrou = True
                            linha = formataString(x.ecf_id.loja or '', 6, ' ', 'D', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(x.ecf_id.caixa or '', 4, ' ', 'D', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(x.coo or '', 10, ' ', 'D', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(x.cliente_id.name or '', 41, ' ', 'D', 'N', 'S') + '|'
                            linha += ' '
                            hora_cupom_fim = ''
                            if x.hora_cupom_fim:
                                hora_cupom_fim = obj_adm_utils.admutl_datetime_to_timezone(
                                    cr, uid, parse(x.hora_cupom_fim), '%Y-%m-%d %H:%M:%S')[11:16]
                            linha += formataString(hora_cupom_fim, 5, ' ', 'D', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString('%s %s' % (x.tipo_cupom, self.get_tipo_cupom(cr, uid, x.tipo_cupom)),
                                                   13, ' ', 'D', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(getNumeroEditado(x.valor_alteracao, 2), 11, ' ', 'E', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(getNumeroEditado(x.total_cupom, 2), 12, ' ', 'E', 'N', 'S') + '|'
                            linha += ' '
                            linha += formataString(x.operador.ecf_operador, 9, ' ', 'D', 'N', 'S') + '|'
                            linha += ' '
                            if x.state == 'C':
                                observacao = _('Falta Validar')
                            elif x.state == 'D':
                                observacao = _('C/ Divergencia')
                            else:
                                observacao = _('Validado')

                            linha += formataString(observacao, 17, ' ', 'E', 'N', 'S') + '|'
                            linha += ' '
                            listagem.imprimeLinha('|' + linha)
                            if x.ecf_cupons_item_ids:
                                cupom_item_ids = filter(lambda w: w.venda_cancelamento == 'V',
                                                        x.ecf_cupons_item_ids)
                                for z in cupom_item_ids:
                                    tributacao_retag = z.tributacao_retag or ''
                                    if tributacao_retag and tributacao_retag not in list_tributacao:
                                        list_tributacao.append(tributacao_retag)
                                        tributacoes[tributacao_retag] = z.preco_total or 0.0
                                    elif tributacao_retag and tributacao_retag in list_tributacao:
                                        tributacoes[tributacao_retag] += z.preco_total or 0.0
                    if entrou:
                        if tributacoes:
                            listagem.imprimeLinha(
                                '|                                                                                                                                                  |')
                            c = 1
                            for i in tributacoes:
                                if c == 1:
                                    linha = formataString(_('Tributacoes        Trib:%s') % i, 25, ' ', 'D', 'N',
                                                          'S') + ' '
                                else:
                                    linha = formataString(_('Trib:%s') % i, 25, ' ', 'E', 'N', 'S') + ' '
                                linha += ' '
                                linha += formataString(_('Aliq.:0,00'), 20, ' ', 'E', 'N', 'S') + ' '
                                linha += ' '
                                linha += formataString(_('Valor:'), 6, ' ', 'E', 'N', 'S') + ' '
                                linha += ' '
                                linha += formataString(getNumeroEditado(tributacoes.get(i) or 0.0, 2), 10, ' ', 'E',
                                                       'N', 'S') + ' '
                                linha += ' '
                                linha += formataString(_('Imposto: 0,00'), 20, ' ', 'E', 'N', 'S') + ' '
                                linha += ' '
                                linha += formataString('', 54, ' ', 'E', 'N', 'S') + ' '
                                linha += '|'
                                listagem.imprimeLinha('|' + linha)
                                c += 1
                            listagem.imprimeLinha(
                                '|                                                                                                                                                  |')
                if tributacoes:
                    listagem.imprimeLinha(
                        '|                                                                                                                                                  |')
                    listagem.imprimeLinha(
                        '| *** Resumo por tributacao ***                                                                                                                    |')
                    for i in tributacoes:
                        if tributacoes.get(i) > 0:
                            linha = formataString(_('Tributacoes       Trib:%s') % i, 25, ' ', 'D', 'N', 'S') + ' '
                            linha += ' '
                            linha += formataString(_('Valor:'), 6, ' ', 'E', 'N', 'S') + ' '
                            linha += ' '
                            linha += formataString(getNumeroEditado(tributacoes.get(i) or 0.0, 2), 10, ' ', 'E', 'N',
                                                   'S') + ' '
                            linha += ' '
                            linha += formataString('', 98, ' ', 'E', 'N', 'S') + ' '
                            linha += '|'
                            listagem.imprimeLinha('|' + linha)
            listagem.imprimeLinha(
                '*--------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.imprimeLinha(
                '                                                                                                                          ** Sig Informatica LTDA **       ')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

    def get_tipo_cupom(self, cr, uid, tipo_cupom):
        if tipo_cupom == 'V':
            tipo_cupom = 'Venda'
        elif tipo_cupom == 'A':
            tipo_cupom = 'Sangria'
        elif tipo_cupom == 'b':
            tipo_cupom = 'Correspondente bancario'
        elif tipo_cupom == 'B':
            tipo_cupom = 'Recibo do correspondente bancario'
        elif tipo_cupom == 'C':
            tipo_cupom = 'Cancelamento'
        elif tipo_cupom == 'c':
            tipo_cupom = 'Cancelamento do correspondente bancario'
        elif tipo_cupom == 'F':
            tipo_cupom = 'Fechamento de turno'
        elif tipo_cupom == 'G':
            tipo_cupom = 'Relatorio Gerencial'
        elif tipo_cupom == 'M':
            tipo_cupom = 'Memoria Fiscal'
        elif tipo_cupom == 'N':
            tipo_cupom = 'cupom anulado'
        elif tipo_cupom == 'O':
            tipo_cupom = 'Contra vale'
        elif tipo_cupom == 'P':
            tipo_cupom = 'Promissoria'
        elif tipo_cupom == 'R':
            tipo_cupom = 'Registro de mesas'
        elif tipo_cupom == 'T':
            tipo_cupom = 'Cupom Tef'
        elif tipo_cupom == 'U':
            tipo_cupom = 'Suprimento'
        elif tipo_cupom == 'X':
            tipo_cupom = 'Reducao X'
        elif tipo_cupom == 'W':
            tipo_cupom = 'Recebimentos diversos'
        elif tipo_cupom == 'w':
            tipo_cupom = 'Recibo dos recebimentos diversos'
        elif tipo_cupom == 'Z':
            tipo_cupom = 'Reducao Z'
        else:
            tipo_cupom = ''
        return tipo_cupom


report_custom('report.listagem_cupons')
