# -*- encoding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from openerp.osv import osv
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        title = center_title('', _('Listagem de Inconsistencia'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Listagem de inconsistencia'))
        listagem.informaTamLinha(160)

        obj_ecf_cupom_log = pooler.get_pool(cr.dbname).get('ecf.cupom.log')

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid, 'ecf.cupom.log', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab('  ')
        listagem.informaCab(
            '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(
            _('| CUPOM | LINHA | COLUNA | ARQUIVO  |   LOG                                                                                                          |'))
        listagem.informaCab(
            '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab('')
        listagem.rodapePadrao()
        ecf_cupom_log_ids = obj_ecf_cupom_log.search(cr, uid, [], context=context)
        browse_ecf_cupom_log = obj_ecf_cupom_log.browse(cr, uid, ecf_cupom_log_ids)
        if browse_ecf_cupom_log:
            list_cupom = []
            for x in browse_ecf_cupom_log:
                if x.numero_cupom in list_cupom:
                    linha = formataString('', 7, ' ', 'D', 'N', 'S') + '|'
                else:
                    if browse_ecf_cupom_log.index(x) != 0:
                        listagem.imprimeLinha(
                            '|                                                                                                                                                    |')
                    linha = formataString(x.numero_cupom or '', 7, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(x.numero_linha_log or '', 6, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(x.numero_coluna_log or '', 7, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(x.nome_arquivo_log or '', 9, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(x.txt_log or '', 111, ' ', 'E', 'N', 'S') + '|'
                linha += ' '
                listagem.imprimeLinha('|' + linha)
                if 'Cupom divergente' in x.txt_erro:
                    linha = formataString(x.txt_erro.lstrip() or '', 148, ' ', 'D', 'N', 'S') + '|'
                else:
                    linha = formataString(x.txt_erro or '', 148, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                listagem.imprimeLinha('|' + linha)
                list_cupom.append(x.numero_cupom)
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_inconsistencia')
