# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _
from datetime import datetime, timedelta


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf

class report_custom(report_int):

    def _get_name(self, cr, uid, ids, field_name, args, context=None):
        context = context and context.copy() or {}
        res = {}.fromkeys(ids, '-')

        data_ecf = pooler.get_pool(cr.dbname).get('ecf.ecf').read(cr, uid, ids, ['loja','caixa','modelo'], context=context)
        for ecf in data_ecf:
            id = ecf.get('id', 0)
            if context.get('resumo_importacao'):
                res[id] = ' %s  -  %s ' % (ecf.get('loja'),ecf.get('caixa'))
            elif context.get('resumo_importacao_divergencia'):
                res[id] = ' %s     -       %s ' % (ecf.get('loja'),ecf.get('caixa'))
            else:
                res[id] = '%s/%s - %s ' % (ecf.get('loja'),ecf.get('caixa'),ecf.get('modelo'))
        return res

    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}

        def center_title(E,C,D,T=176):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        title = center_title('',_('Resumo de Importacao'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='1')
        listagem.informaNome(pdf_string, _('Resumo de importacao'))
        listagem.informaTamLinha(160)
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)
        listagem.defineFonte(tam=7.6)

        # ___________________________ Objects ________________________________
        obj_ecf = pooler.get_pool(cr.dbname).get('ecf.ecf')
        obj_rh_funcionario = pooler.get_pool(cr.dbname).get('rh.funcionario')
        obj_ecf_cupom_log = pooler.get_pool(cr.dbname).get('ecf.cupom.log')
        obj_adm_condicao_forma = pooler.get_pool(cr.dbname).get('adm.condicao.forma')
        obj_ecf_cupons_capa = pooler.get_pool(cr.dbname).get('ecf.cupons.capa')
        get_date_timezone = pooler.get_pool(cr.dbname).get('adm.utils').admutl_converte_tz

        pontilhado = '*' + '-' * 177 + '*'
        linha_branco = '|{:^177}|'.format(' ')
        data = datas.get('data')
        data_original = data
        loja = datas.get('loja')
        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'resumo.importacao.osv', context=context)
        ecf_resumo_caixa_dados = self.ecfrim_consulta_resumo_importacao(cr, uid, company_id,
                                                                        data, loja, context)
        ecf_resumo_caixa_dados += self.ecfrim_consulta_resumo_importacao_nfce(
            cr, uid, company_id, data, context)

        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid,
                                                                               company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        _data_cab = time.strftime("%d/%m/%Y", time.strptime(data, "%Y-%m-%d"))
        docs = center_title(_data_cab, nome_empresa, _('Pagina: {{ Page }} '))
        listagem.informaCab(''+title)
        listagem.informaCab('')
        listagem.informaCab(''+docs)
        listagem.informaCab('  ')
        listagem.informaCab(pontilhado)
        listagem.informaCab(_('| LOJA/| ECF/|MOD| INICIAL | FINAL  |   VENDAS    | REC. DIVERSOS | SUPRIMENTO  |   SANGRIA   |  DIFERENCA  |  DINHEIRO   |   CHEQUE    |     PIX     |   CARTAO    |   OUTROS    |'))
        listagem.informaCab('| EMP. |SERIE|' + ' ' * 164 + '|')
        listagem.informaCab(pontilhado)
        listagem.imprimeLinha('|T O T A I S  I M P O R T A D O S' + ' ' * 145 + '|')
        listagem.rodapePadrao()

        total_venda = total_recebimento = total_suprimento = total_sangria = total_diferenca = 0.0
        total_dinheiro = total_cheque = total_ticket = total_cartao = total_outros = 0.0
        participacao_dinheiro = participacao_cheque = participacao_ticket = 0.0
        participacao_cartao = participacao_outros = 0.0

        for x in ecf_resumo_caixa_dados:
            if x.get('ecfrcv_ecf_id'):
                ecfrcv_ecf_id = x.get('ecfrcv_ecf_id')[0] if isinstance(
                    x.get('ecfrcv_ecf_id'), tuple) else x.get('ecfrcv_ecf_id')
                loja_caixa = self._get_name(cr, uid, [ecfrcv_ecf_id], None, None,
                                            context={'resumo_importacao': True})
                loja_caixa = loja_caixa.get(ecfrcv_ecf_id)
            else:
                loja_caixa = ' %s  -  %s ' % (company_id, x.get('ecfrcv_nf_serie') or '')
            x['loja_caixa'] = loja_caixa
        ecf_resumo_caixa_dados = sorted(ecf_resumo_caixa_dados, key=lambda er: er.get('loja_caixa'))

        for x in ecf_resumo_caixa_dados:
            vendas = x.get('ecfrcv_vendas') or 0.0
            vendas -= x.get('ecfrcv_cancelamentos') or 0.0
            recebimento = x.get('ecfrcv_recebimento') or 0.0
            suprimento = x.get('ecfrcv_suprimento') or 0.0
            sangria = x.get('ecfrcv_sangria') or 0.0
            diferenca = vendas + recebimento + suprimento - sangria
            if not x.get('ecfrcv_ecf_id'):
                diferenca = 0.0
            dinheiro = x.get('ecfrcv_dinheiro_valor') or 0.0
            cheque = x.get('ecfrcv_cheque_valor') or 0.0
            ticket = x.get('ecfrcv_ticket_valor') or 0.0
            cartao = x.get('ecfrcv_cartao_valor') or 0.0
            outros = x.get('ecfrcv_outros_valor') or 0.0
            linha = formataString(x.get('loja_caixa') or '', 12, ' ', 'D', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(x.get('modelo') or '', 3, ' ', 'D', 'N', 'S') + '|'
            linha += formataString(x.get('ecfrcv_cupom_inicial') or x.get('ecfrcv_nf_inicial')
                                   or '', 8, ' ', 'D', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(x.get('ecfrcv_cupom_final') or x.get('ecfrcv_nf_final')
                                   or '', 7, ' ', 'D', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(vendas) or 0.0, 12, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(recebimento) or 0.0, 14, ' ', 'E', 'N',
                                   'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(suprimento) or 0.0, 12, ' ', 'E', 'N',
                                   'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(sangria) or 0.0, 12, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(diferenca) or 0.0, 12, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(dinheiro) or 0.0, 12, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(cheque) or 0.0, 12, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(ticket) or 0.0, 12, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(cartao) or 0.0, 12, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(outros) or 0.0, 12, ' ', 'E', 'N', 'S')+'|'
            linha += ' '
            listagem.imprimeLinha('|'+linha)
            total_venda += vendas
            total_recebimento += recebimento
            total_suprimento += suprimento
            total_sangria += sangria
            total_diferenca += diferenca
            total_dinheiro += dinheiro
            total_cheque += cheque
            total_ticket += ticket
            total_cartao += cartao
            total_outros += outros

        if total_venda:
            participacao_dinheiro = (total_dinheiro / total_venda) * 100
            participacao_cheque = (total_cheque / total_venda) * 100
            participacao_ticket = (total_ticket / total_venda) * 100
            participacao_cartao = (total_cartao / total_venda) * 100
            participacao_outros = (total_outros / total_venda) * 100

        listagem.imprimeLinha(pontilhado)
        listagem.imprimeLinha(
            _('|   T o t a i s') +
            formataString('', 23, ' ', 'E', 'N', 'S') +
            formataString(getNumeroEditado(total_venda) or 0.0, 12, ' ', 'E', 'N', 'S') +
            formataString(getNumeroEditado(total_recebimento) or 0.0, 16, ' ', 'E', 'N', 'S') +
            formataString(getNumeroEditado(total_suprimento) or 0.0, 14, ' ', 'E', 'N', 'S') +
            formataString(getNumeroEditado(total_sangria) or 0.0, 14, ' ', 'E', 'N', 'S') +
            formataString(getNumeroEditado(total_diferenca) or 0.0, 14, ' ', 'E', 'N', 'S') +
            formataString(getNumeroEditado(total_dinheiro) or 0.0, 14, ' ', 'E', 'N', 'S') +
            formataString(getNumeroEditado(total_cheque) or 0.0, 14, ' ', 'E', 'N', 'S') +
            formataString(getNumeroEditado(total_ticket) or 0.0, 14, ' ', 'E',' N', 'S') +
            formataString(getNumeroEditado(total_cartao) or 0.0, 14, ' ', 'E', 'N', 'S') +
            formataString(getNumeroEditado(total_outros) or 0.0, 14, ' ', 'E', 'N', 'S') + '|')
        listagem.imprimeLinha(
            _('|   % Participacao') +
            formataString('', 90, ' ', 'E',' N', 'S') +
            formataString(getNumeroEditado(participacao_dinheiro) or 0.0, 14, ' ', 'E', 'N', 'S') +
            formataString(getNumeroEditado(participacao_cheque) or 0.0, 14, ' ', 'E', 'N', 'S') +
            formataString(getNumeroEditado(participacao_ticket) or 0.0, 14, ' ', 'E', 'N', 'S') +
            formataString(getNumeroEditado(participacao_cartao) or 0.0, 14, ' ', 'E', 'N', 'S') +
            formataString(getNumeroEditado(participacao_outros) or 0.0, 14, ' ', 'E', 'N', 'S') +
            '|')
        listagem.imprimeLinha(pontilhado)

        ecf_resumo_finalizadora_dado = self.ecfrim_consulta_resumo_finalizadoras(
            cr, uid, company_id, data, loja, context)
        listagem.imprimeLinha(linha_branco)
        listagem.imprimeLinha('|F I N A L I Z A D O R A S' + ' ' * 152 + '|')
        listagem.imprimeLinha(pontilhado)
        listagem.imprimeLinha(_('|   F I N A L I Z A D O R A        | V/P |      VALOR       |'
                                '     TROCO     | %PART.| T |   F I N A L I Z A D O R A       |'
                                ' V/P |       VALOR      |     TROCO    | %PART.|   T   |'))
        listagem.imprimeLinha(pontilhado)

        total_troco = 0.0
        total_finalizadoras = sum(map(lambda f: f.get('ecfrfv_valor') or 0.0,
                                      ecf_resumo_finalizadora_dado))
        i = 1
        c = [1]
        context['resumo_importacao'] = True

        for x in ecf_resumo_finalizadora_dado:
            ecfrfv_finalizadora_id = x.get('ecfrfv_finalizadora_id')
            finalizadora_na_ecf = x.get('ecfrfv_finalizadora_na_ecf')
            if isinstance(ecfrfv_finalizadora_id, tuple):
                ecfrfv_finalizadora_id = ecfrfv_finalizadora_id[0]

            name_finalizadora = [(0, 'Sem Condicao de Pagamento')]
            if ecfrfv_finalizadora_id:
                name_finalizadora = obj_adm_condicao_forma.name_get(cr, uid, [ecfrfv_finalizadora_id],
                                                                    context)

            finalizadora = ''
            if finalizadora_na_ecf:
                finalizadora += '%s - ' % finalizadora_na_ecf
            for y in name_finalizadora:
                if isinstance(y, tuple):
                    finalizadora += '%s' % (y[1])
            valor = x.get('ecfrfv_valor') or 0
            avista_aprazo = x.get('ecfrfv_avista_aprazo')
            troco = x.get('ecfrfv_troco') or 0.0
            tipo_finalizadora = x.get('ecfrfv_tipo_finalizadora')
            participacao = (valor / total_finalizadoras) * 100 if total_finalizadoras else 0.0
            if i == 2:
                linha += '|' + formataString(finalizadora or '', 33, ' ', 'D', 'N', 'S') + '|'
            else:
                linha = formataString(finalizadora or '', 34, ' ', 'D', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(avista_aprazo or '', 4, ' ', 'D', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(valor) or '', 17, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            if i == 2:
                linha += formataString(getNumeroEditado(troco) or 0.0, 13, ' ', 'E', 'N', 'S') + '|'
            else:
                linha += formataString(getNumeroEditado(troco) or 0.0, 14, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(participacao) or 0.0, 6, ' ', 'E', 'N',
                                   'S') + '|'
            linha += ' '
            linha += formataString(tipo_finalizadora or '', 2, ' ', 'E', 'N', 'S')
            if i == 2 or len(ecf_resumo_finalizadora_dado) == len(c):
                listagem.imprimeLinha(('|'+linha).ljust(178) + '|')
                i = 0
            total_troco += troco
            i += 1
            c.append(1)

        listagem.imprimeLinha(pontilhado)
        linha = _('|   Total finalizadoras......') + \
                formataString('', 13, ' ', 'E', 'N', 'S') + \
                formataString(getNumeroEditado(total_finalizadoras) or 0.0, 18, ' ', 'E', 'N',
                              'S') + \
                formataString(getNumeroEditado(total_troco) or 0.0, 16, ' ', 'E', 'N', 'S')
        linha += '{:^102}|'
        linha = linha.format(' ')
        listagem.imprimeLinha(linha)
        listagem.imprimeLinha(pontilhado)

        listagem.imprimeLinha(linha_branco)
        listagem.imprimeLinha('|C U P O N S  /  N F C - e  F A L T A N T E S' + ' ' * 133 + '|')
        listagem.imprimeLinha(pontilhado)
        listagem.imprimeLinha('| LOJA / EMPRESA   | ECF / SERIE      |MOD| CUPOM | CUPOM | CUPOM | '
                              'CUPOM | CUPOM | CUPOM | CUPOM | CUPOM | CUPOM | CUPOM | CUPOM | '
                              'CUPOM | CUPOM | CUPOM | CUPOM | CUPOM | CUPOM |')
        listagem.imprimeLinha(pontilhado)
        sql_loja = ''
        if loja:
            sql_loja = 'AND ecf.loja = %s' % loja

        date = datetime.strptime(data_original, '%Y-%m-%d').date()
        datas = ['%s' % (date - timedelta(days=1)), data_original]
        sql = """SELECT coo,
                        date_cupom,
                        ecf_id
                 FROM   ecf_cupons_capa AS capa
                 LEFT JOIN ecf_ecf AS ecf
                        ON ecf.id = capa.ecf_id
                 WHERE capa.date_cupom in ('{datas}')
                   AND capa.tipo_cupom = 'Z'
                   AND capa.company_id = {company_id}
                   {sql_loja}
                ORDER BY ecf_id, coo
              """.format(company_id=company_id, datas="','".join(datas), sql_loja=sql_loja)
        cr.execute(sql)
        cond_data = "AND ecc.date_cupom = '%s'" % data_original
        cond_coo_z = ''
        # caso tenha reducao Z do dia anterior e do dia atual, a consulta de cupons sera pelo coos
        ultima_ecf_id = False
        dados = cr.dictfetchall()
        aux_1 = ''
        dif_ecf = False
        cond_aux = cond_data
        z_do_dia = {}
        for i in dados:
            if i.get('ecf_id') != ultima_ecf_id:
                dif_ecf = True
                if aux_1:
                    if not cond_coo_z:
                        cond_coo_z += '(%s AND ecc.ecf_id = %s %s)' % (aux_1, ultima_ecf_id, cond_aux)
                    else:
                        cond_coo_z += ' OR (%s AND ecc.ecf_id = %s %s)' % (aux_1, ultima_ecf_id, cond_aux)

                    cond_aux = cond_data
                    aux_1 = ''

                ultima_ecf_id = i.get('ecf_id')

            if i.get('date_cupom') == '%s' % (date - timedelta(days=1)):  # Z do dia anterior
                if dif_ecf:
                    dif_ecf = False

                if not aux_1:
                    aux_1 += 'ecc.coo > %s ' % i.get('coo')
                else:
                    aux_1 += 'AND ecc.coo > %s ' % i.get('coo')
            elif i.get('date_cupom') == data_original:  # Z do dia do relatorio
                z_do_dia.update({ultima_ecf_id: i.get('coo')})
                cond_aux = ''
                if not aux_1:
                    aux_1 += 'ecc.coo <= %s ' % i.get('coo')
                else:
                    aux_1 += 'AND ecc.coo <= %s ' % i.get('coo')

                if dif_ecf:
                    dif_ecf = False
                    aux_1 += cond_data

            if i == dados[-1] and aux_1:
                if not cond_coo_z:
                    cond_coo_z += '(%s AND ecc.ecf_id = %s %s)' % (aux_1, ultima_ecf_id, cond_aux)
                else:
                    cond_coo_z += ' OR (%s AND ecc.ecf_id = %s %s)' % (aux_1, ultima_ecf_id, cond_aux)

                cond_aux = ''

        if cond_coo_z:
            cond_coo_z = 'AND (%s)' % cond_coo_z
            cond_data = ''

        sql = """
            SELECT ecc.coo,
                   ecf.loja,
                   ecf.caixa
            FROM ecf_cupons_capa AS ecc
            INNER JOIN ecf_ecf   AS ecf ON ecf.id = ecc.ecf_id
            WHERE ecc.company_id = %s
              AND ecc.state in ('V', 'D')
                  %s
                  %s
            ORDER BY ecf.loja, ecf.caixa, ecc.coo
        """ % (company_id, cond_data, cond_coo_z)
        cr.execute(sql)
        lista_cupom = cr.dictfetchall()
        sql = """
            SELECT distinct ecf.loja,
                            ecf.caixa,
                            ecc.ecf_id
            FROM ecf_cupons_capa AS ecc
            INNER JOIN ecf_ecf   AS ecf ON ecf.id = ecc.ecf_id
            WHERE ecc.company_id = %s
              AND ecc.date_cupom = '%s'
            ORDER BY ecf.loja, ecf.caixa
        """ % (company_id, data_original)
        cr.execute(sql)
        lista_loja_caixa = cr.dictfetchall()
        loja_caixa_usada_list = []

        for x in lista_loja_caixa:
            loja = x.get('loja')
            caixa = x.get('caixa')
            ecf_id = x.get('ecf_id')
            if not lista_cupom or not z_do_dia.get(ecf_id):
                loja_caixa = '      %s        -           %s     ' % (loja, caixa)
                linha = formataString(loja_caixa or '', 37, ' ', 'D', 'N', 'S') + '|'
                listagem.imprimeLinha((('|'+ linha + _('Red. Z ')).ljust(178) + '|'))
                if not z_do_dia.get(ecf_id):
                    continue

                break

            lista_cupom_loja_caixa = filter(
                lambda i: i.get('loja') == loja and i.get('caixa') == caixa, lista_cupom)
            coos_do_dia = map(lambda x: x.get('coo'), lista_cupom_loja_caixa)
            lista_cupom_loja_caixa = filter(
                lambda i: i.get('ecfrcv_loja') == loja and i.get('ecfrcv_ecf_id') == ecf_id,
                ecf_resumo_caixa_dados)

            if not lista_cupom_loja_caixa:
                continue

            loja_caixa = '      %s        -           %s     ' % (loja, caixa)
            primeiro_coo_hoje = lista_cupom_loja_caixa[0].get('ecfrcv_cupom_inicial')
            ultimo_coo_hoje = lista_cupom_loja_caixa[0].get('ecfrcv_cupom_final')
            sql = ''' SELECT MAX(ecc.coo)  AS coo
                      FROM ecf_cupons_capa AS ecc
                      INNER JOIN ecf_ecf   AS ecf ON ecf.id = ecc.ecf_id
                      WHERE  ecc.coo < '{coo}'
                        AND ecf.loja = {loja}
                        AND ecf.caixa = {caixa}
                        AND ecc.company_id = {company_id}
                        '''.format(coo=primeiro_coo_hoje,loja=loja, caixa=caixa, company_id=company_id)
            cr.execute(sql) # pega o ultimo coo vendido de antes da data escolhida
            ultimo_coo_dia_anterior = cr.dictfetchall()[0]
            if ultimo_coo_dia_anterior.get('coo'):
                ultimo_coo_dia_anterior = ultimo_coo_dia_anterior.get('coo') + 1
            else:
                ultimo_coo_dia_anterior = 0

            if loja_caixa in loja_caixa_usada_list:
                continue

            loja_caixa_usada_list.append(loja_caixa)
            linha = formataString(loja_caixa or '', 37, ' ', 'D', 'N', 'S')+'|'
            linha += formataString(x.get('modelo') or '', 3, ' ', 'D', 'N', 'S')+'|'
            cont = 0
            faltante = False
            for coo in range(ultimo_coo_dia_anterior or primeiro_coo_hoje, ultimo_coo_hoje):
                if not coo in coos_do_dia:
                    faltante = True
                    cont += 1
                    linha += formataString(coo or '', 7, ' ', 'E', 'N', 'S')+'|'
                    coo += 1
                    if cont == 17 and not coo == ultimo_coo_hoje:
                        listagem.imprimeLinha(('|'+linha).ljust(178))
                        linha = formataString('', 37, ' ', 'D', 'N', 'S')+'|'
                        cont = 0

            if faltante:
                listagem.imprimeLinha(('|'+linha).ljust(178) + '|')

        for nfce in self.ecfrim_consulta_resumo_importacao_nfce_faltante(cr, uid, company_id, data,
                                                                         context):
            numero_inicial = nfce.get('nf_inicial')
            numero_final = nfce.get('nf_final')
            serie = nfce.get('nf_serie')
            modelo = nfce.get('modelo')
            sql = """
                SELECT numero_nf
                FROM fiscal_nf_capa        AS nf
                LEFT JOIN fiscal_modelo_nf AS modelo ON modelo.id = nf.modelo_nf_id 
                WHERE
                    company_id = {company_id}
                    AND data_emissao at time zone 'UTC' BETWEEN '{data} 00:00:00' AND '{data} 23:59:59'
                    AND tipo = 'S'
                    AND fisnfc_consumidor
                    AND numero_nf IS NOT NULL
                    AND serie_nf = '{serie}'
                    AND modelo.fismnf_codigo = '{modelo}' 
                    AND numero_nf > {nf_inicial} 
                    AND numero_nf < {nf_final}
            """.format(company_id=company_id, data=data, serie=serie, modelo=modelo,
                       nf_inicial=numero_inicial, nf_final=numero_final)
            cr.execute(sql)
            list_numero_nfce = cr.dictfetchall()
            list_numero_nfce = map(lambda n: n.get('numero_nf'), list_numero_nfce)
            list_numero_nfce.sort()
            list_nfce_faltante = []
            for numero in range(numero_inicial+1, numero_final):
                if numero in list_numero_nfce:
                    continue
                list_nfce_faltante.append(numero)
            empresa_serie = '      %s        -           %s     ' % (company_id, serie)
            linha = formataString(empresa_serie, 37, ' ', 'D', 'N', 'S') + '|'
            linha += formataString(nfce.get('modelo'), 3, ' ', 'E', 'N', 'S') + '|'
            cont = 0
            for numero_nf in list_nfce_faltante:
                cont += 1
                linha += formataString(numero_nf or '', 7, ' ', 'E', 'N', 'S') + '|'
                if cont == 17:
                    listagem.imprimeLinha(('|' + linha).ljust(178))
                    linha = formataString('', 37, ' ', 'D', 'N', 'S') + '|'
                    cont = 0

            if list_nfce_faltante:
                listagem.imprimeLinha(('|' + linha).ljust(178) + '|')

        listagem.imprimeLinha(pontilhado)

        listagem.imprimeLinha(linha_branco)
        listagem.imprimeLinha(_('|C U P O N S  C O M  D I V E R G E N C I A S' + ' ' * 134 + '|'))
        listagem.imprimeLinha(pontilhado)
        listagem.imprimeLinha(_('|   LOJA   |   ECF   | CUPOM |                C L I E N T E    '
                                '           |  HORA  | TIPO CUPOM | ACR./DESC. | TOTAL CUP. '
                                '| OPER. |                    OBSERVACAO                 |'))
        listagem.imprimeLinha(pontilhado)
        ecf_cupons_ids = obj_ecf_cupons_capa.search(cr, uid, [('date_cupom', '=', data_original),
                                                              ('state', '=', 'D')], context=context)
        if ecf_cupons_ids:
            ecf_cupons_dados = obj_ecf_cupons_capa.read(
                cr, uid, ecf_cupons_ids, ['coo', 'ecf_id', 'cliente_id', 'hora_cupom_inicio',
                                          'tipo_cupom', 'alteracao', 'total_cupom', 'operador'], context=context)
            lista_cupons = []
            for x in ecf_cupons_dados:
                ecf_id = x.get('ecf_id')
                if isinstance(ecf_id, tuple):
                    ecf_id = ecf_id[0]
                if loja:
                    loja_ecf = obj_ecf.browse(cr, uid, ecf_id).loja
                    if loja == loja_ecf:
                        lista_cupons.append(x)
                else:
                    lista_cupons.append(x)
            lista_cupons.sort()
            ecfs_resumo_caixa = []
            if ecf_resumo_caixa_dados:
                ecfs_resumo_caixa = map(lambda c: c.get('ecfrcv_ecf_id'), ecf_resumo_caixa_dados)
            if ecf_cupons_dados:
                if not ecfs_resumo_caixa:
                    ecfs_resumo_caixa = [loja, ecf_id]
                for x in ecfs_resumo_caixa:
                    loja_caixa = self._get_name(cr, uid, [x], None, None,
                                                context={'resumo_importacao_divergencia': True})
                    loja_caixa = loja_caixa.get(x)
                    for y in ecf_cupons_dados:
                        ecf_id = y.get('ecf_id')
                        if isinstance(ecf_id, (list, tuple)):
                            ecf_id = ecf_id[0]
                        if x == ecf_id:
                            cliente = y.get('cliente_id')
                            if isinstance(cliente, tuple):
                                cliente = cliente[1]

                            data = datetime.strptime(y.get('hora_cupom_inicio')[:19], "%Y-%m-%d %H:%M:%S")
                            data = get_date_timezone(cr, uid, data, tz_origem='UTC',
                                                     tz_destino=context.get('tz'), context=context)
                            hora = str(data.time())
                            codigo_operador = ''
                            operador_id = y.get('operador')
                            if isinstance(operador_id, (list, tuple)):
                                operador_id = operador_id[0]
                            if operador_id:
                                rh_funcionario_dados = obj_rh_funcionario.read(cr, uid, operador_id,
                                                                               ['codigo'], context=context)
                                if isinstance(rh_funcionario_dados, list):
                                    rh_funcionario_dados = rh_funcionario_dados[0]
                                codigo_operador = rh_funcionario_dados.get('codigo')
                            log_divergencia = ''
                            cupom_log_ids = obj_ecf_cupom_log.search(
                                cr, uid, [('cupom_id', '=', y.get('id'))], context=context)
                            if cupom_log_ids:
                                log_divergencia = obj_ecf_cupom_log.browse(
                                    cr, uid, cupom_log_ids[0]).txt_erro or ''
                                log_divergencia = log_divergencia.replace('\t', '').\
                                    replace(' Cupom divergente : ', '')
                            linha = formataString(loja_caixa or '', 20, ' ', 'D', 'N', 'S') + '|'
                            linha += formataString(y.get('modelo') or '', 3, ' ', 'D', 'N', 'S') + '|'
                            linha += formataString(y.get('coo') or '', 7, ' ', 'E', 'N', 'S') + '|'
                            linha += formataString(cliente or '', 44, ' ', 'D', 'N', 'S') + '|'
                            linha += formataString(hora or '', 8, ' ', 'E', 'N', 'S') + '|'
                            linha += formataString(y.get('tipo_cupom') or '', 12, ' ', 'E', 'N',
                                                   'S') + '|'
                            linha += formataString(y.get('alteracao') or '', 12, ' ', 'E', 'N',
                                                   'S') + '|'
                            linha += formataString(getNumeroEditado(y.get('total_cupom')) or 0.0,
                                                   12, ' ', 'E', 'N', 'S') + '|'
                            linha += formataString(codigo_operador, 7, ' ', 'E', 'N', 'S') + '|'
                            linha += formataString(log_divergencia, 43, ' ', 'E', 'N', 'S') + '|'
                            listagem.imprimeLinha('|'+linha)
            listagem.imprimeLinha(pontilhado)
        listagem.imprimeLinha(' ' * 146 + _('** Sig Informatica LTDA **       '))
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

    def ecfrim_consulta_resumo_importacao(self, cr, uid, company_id, data, loja=False,
                                          context=None):
        context = context and context.copy() or {}
        sql_loja = ''
        if loja:
            sql_loja = 'AND ecf.loja = %s' % loja

        date = datetime.strptime(data, '%Y-%m-%d').date()
        datas = ['%s' % (date - timedelta(days=1)), data]
        sql = """SELECT coo,
                        date_cupom,
                        ecf_id
                 FROM   ecf_cupons_capa AS capa
                 LEFT JOIN ecf_ecf AS ecf
                        ON ecf.id = capa.ecf_id
                 WHERE capa.date_cupom in ('{datas}')
                   AND capa.tipo_cupom = 'Z'
                   AND capa.company_id = {company_id}
                   {sql_loja}
                ORDER BY ecf_id, coo
              """.format(company_id=company_id, datas="','".join(datas), sql_loja=sql_loja)
        cr.execute(sql)
        cond_data = "AND capa.date_cupom = '%s'" % data
        cond_data2 = "AND date_cupom = capa.date_cupom"
        group_data = ord_data = "capa.date_cupom,"
        cond_coo_z = cond_coo_z2 = ''
        ultima_ecf_id = False
        dados = cr.dictfetchall()
        aux_1 = aux_2 = ''
        dif_ecf = False
        cond_aux = cond_data
        cond_aux2 = "AND date_cupom = '%s'" % data
        for i in dados:
            if i.get('ecf_id') != ultima_ecf_id:
                dif_ecf = True
                if aux_1:
                    if not cond_coo_z:
                        cond_coo_z += '(%s AND capa.ecf_id = %s %s)' % (aux_1, ultima_ecf_id, cond_aux)
                        cond_coo_z2 += '(%s AND ecf_id = %s %s)' % (aux_2, ultima_ecf_id, cond_aux2)
                    else:
                        cond_coo_z += ' OR (%s AND capa.ecf_id = %s %s)' % (aux_1, ultima_ecf_id, cond_aux)
                        cond_coo_z2 += ' OR (%s AND ecf_id = %s %s)' % (aux_2, ultima_ecf_id, cond_aux2)

                    cond_aux = cond_data
                    cond_aux2 = "AND date_cupom = '%s'" % data
                    aux_1 = aux_2 = ''

                ultima_ecf_id = i.get('ecf_id')

            if i.get('date_cupom') == '%s' % (date - timedelta(days=1)): # Z do dia anterior
                if dif_ecf:
                    dif_ecf = False

                if not aux_1:
                    aux_1 += 'capa.coo > %s ' % i.get('coo')
                    aux_2 += 'coo > %s ' % i.get('coo')
                else:
                    aux_1 += 'AND capa.coo > %s ' % i.get('coo')
                    aux_2 += 'AND coo > %s ' % i.get('coo')
            elif i.get('date_cupom') == data: # Z do dia do relatorio
                cond_aux = ''
                cond_aux2 = ''
                if not aux_1:
                    aux_1 += 'capa.coo <= %s ' % i.get('coo')
                    aux_2 += 'coo <= %s ' % i.get('coo')
                else:
                    aux_1 += 'AND capa.coo <= %s ' % i.get('coo')
                    aux_2 += 'AND coo <= %s ' % i.get('coo')

                if dif_ecf:
                    dif_ecf = False
                    aux_1 += "AND capa.date_cupom >= '%s'" % data
                    aux_2 += "AND date_cupom >= '%s'" % data

            if i == dados[-1] and aux_1:
                if not cond_coo_z:
                    cond_coo_z += '(%s AND capa.ecf_id = %s %s)' % (aux_1, ultima_ecf_id, cond_aux)
                    cond_coo_z2 += '(%s AND ecf_id = %s %s)' % (aux_2, ultima_ecf_id, cond_aux2)
                else:
                    cond_coo_z += ' OR (%s AND capa.ecf_id = %s %s)' % (aux_1, ultima_ecf_id, cond_aux)
                    cond_coo_z2 += ' OR (%s AND ecf_id = %s %s)' % (aux_2, ultima_ecf_id, cond_aux2)
                cond_aux = ''
                cond_aux2 = ''


        if cond_coo_z:
            cond_coo_z = 'AND (%s)' % cond_coo_z
            cond_coo_z2 = 'AND (%s)' % cond_coo_z2
            group_data = ord_data = ''

        cond_data = """
            AND capa.hora_cupom_fim at time zone 'UTC' BETWEEN '%s 00:00:00' AND '%s 23:59:59'
        """ % (date, date)
        cond_data2 = """
            AND hora_cupom_fim at time zone 'UTC' BETWEEN '%s 00:00:00' AND '%s 23:59:59'
        """ % (date, date)

        sql = """
                SELECT Rank ()
                         over (
                           ORDER BY {ord_data} capa.ecf_id, ecf.loja) AS id,
                       '{data}'                                             AS ecfrcv_data,
                       capa.ecf_id                                          AS ecfrcv_ecf_id,
                       ecf.loja                                             AS ecfrcv_loja,
                       (SELECT Min(coo)
                        FROM   ecf_cupons_capa
                        WHERE  ecf_id = capa.ecf_id
                               {cond_data2}
                               {cond_coo_z2})                    AS
                       ecfrcv_cupom_inicial,
                       (SELECT Max(coo)
                        FROM   ecf_cupons_capa
                        WHERE  ecf_id = capa.ecf_id
                               {cond_data2}
                               {cond_coo_z2})                    AS
                       ecfrcv_cupom_final,
                       (SELECT SUM(total_cupom)
                        FROM   ecf_cupons_capa
                        WHERE  state = 'V'
                               AND tipo_cupom = 'V'
                               {cond_data2}
                               AND ecf_id = capa.ecf_id
                               {cond_coo_z2})                    AS ecfrcv_vendas,
                       (SELECT SUM(total_cupom)
                        FROM   ecf_cupons_capa
                        WHERE  state = 'V'
                               AND tipo_cupom = 'C'
                               {cond_data2}
                               AND ecf_id = capa.ecf_id
                               {cond_coo_z2})                    AS
                       ecfrcv_cancelamentos,
                       (SELECT SUM(total_cupom)
                        FROM   ecf_cupons_capa
                        WHERE  state = 'V'
                               AND tipo_cupom = 'W'
                               {cond_data2}
                               AND ecf_id = capa.ecf_id
                               {cond_coo_z2})                    AS
                       ecfrcv_recebimento,
                       (SELECT SUM(total_cupom)
                        FROM   ecf_cupons_capa
                        WHERE  state = 'V'
                               AND tipo_cupom = 'U'
                               {cond_data2}
                               AND ecf_id = capa.ecf_id
                               {cond_coo_z2})                    AS ecfrcv_suprimento
                       ,
                       (SELECT SUM(total_cupom)
                        FROM   ecf_cupons_capa
                        WHERE  state = 'V'
                               AND tipo_cupom = 'A'
                               {cond_data2}
                               AND ecf_id = capa.ecf_id
                               {cond_coo_z2})                    AS ecfrcv_sangria,
                       ( SUM(CASE WHEN capa.tipo_cupom = 'C' AND finalizacao.tipo_finalizadora = 'D' 
                                  THEN - finalizacao.valor + COALESCE(finalizacao.troco, 0) 
                                  WHEN capa.tipo_cupom = 'V' AND finalizacao.tipo_finalizadora = 'D'
                                  THEN finalizacao.valor - Coalesce(finalizacao.troco, 0) 
                                  ELSE 0
                             END) )                                         AS
                       ecfrcv_dinheiro_valor,
                       (SELECT Count(valor)
                        FROM   ecf_cupons_finalizacao
                        WHERE  tipo_finalizadora = 'D'
                               --AND data = capa.date_cupom
                               AND ecf.loja = loja :: INT
                               AND ecf.caixa = caixa :: INT)                AS
                       ecfrcv_dinheiro_qtd,
                       ( SUM(CASE WHEN capa.tipo_cupom = 'C' AND finalizacao.tipo_finalizadora = 'H' 
                                  THEN - finalizacao.valor + COALESCE(finalizacao.troco, 0) 
                                  WHEN finalizacao.tipo_finalizadora = 'H' AND finalizacao.valor > 0
                                  THEN finalizacao.valor - COALESCE(finalizacao.troco, 0)
                                  ELSE 0
                             END) )                                         AS
                       ecfrcv_cheque_valor,
                       (SELECT Count(valor)
                        FROM   ecf_cupons_finalizacao
                        WHERE  tipo_finalizadora = 'H'
                               --AND data = capa.date_cupom
                               AND ecf.loja = loja :: INT
                               AND ecf.caixa = caixa :: INT)                AS ecfrcv_cheque_qtd
                       ,
                       ( SUM(CASE
                               WHEN capa.tipo_cupom = 'C' AND finalizacao.tipo_finalizadora = 'T' 
                               THEN - finalizacao.valor + COALESCE(finalizacao.troco, 0) 
                               WHEN finalizacao.tipo_finalizadora = 'T' AND finalizacao.valor > 0
                               THEN finalizacao.valor - COALESCE(finalizacao.troco, 0)
                               ELSE 0
                             END) )                                         AS
                       ecfrcv_ticket_valor,
                       (SELECT Count(valor)
                        FROM   ecf_cupons_finalizacao
                        WHERE  tipo_finalizadora = 'T'
                               --AND data = capa.date_cupom
                               AND ecf.loja = loja :: INT
                               AND ecf.caixa = caixa :: INT)                AS ecfrcv_ticket_qtd
                       ,
                       ( SUM(CASE WHEN capa.tipo_cupom = 'C' AND finalizacao.tipo_finalizadora = 'C' 
                                  THEN - finalizacao.valor + COALESCE(finalizacao.troco, 0)
                                  WHEN finalizacao.tipo_finalizadora = 'C' AND finalizacao.valor > 0 
                                  THEN finalizacao.valor - COALESCE(finalizacao.troco, 0)
                                  ELSE 0
                             END) )                                         AS
                       ecfrcv_cartao_valor,
                       (SELECT Count(valor)
                        FROM   ecf_cupons_finalizacao
                        WHERE  tipo_finalizadora = 'C'
                               --AND data = capa.date_cupom
                               AND ecf.loja = loja :: INT
                               AND ecf.caixa = caixa :: INT)                AS ecfrcv_cartao_qtd
                       ,
                       ( SUM(CASE
                               WHEN capa.tipo_cupom = 'C' AND finalizacao.tipo_finalizadora = 'O' 
                               THEN - finalizacao.valor + COALESCE(finalizacao.troco, 0)
                               WHEN finalizacao.tipo_finalizadora = 'O' AND finalizacao.valor > 0 
                               THEN finalizacao.valor - COALESCE(finalizacao.troco, 0)
                               ELSE 0
                             END) )                                         AS
                       ecfrcv_outros_valor,
                       (SELECT Count(valor)
                        FROM   ecf_cupons_finalizacao
                        WHERE  tipo_finalizadora = 'O'
                               --AND data = capa.date_cupom
                               AND ecf.loja = loja :: INT
                               AND ecf.caixa = caixa :: INT)                AS ecfrcv_outros_qtd
                FROM   ecf_cupons_capa AS capa
                LEFT JOIN ecf_cupons_finalizacao AS finalizacao ON capa.id = finalizacao.cupom_id 
                                                               AND capa.tipo_cupom IN ( 'V', 'C' )
                INNER JOIN ecf_ecf AS ecf ON capa.ecf_id = ecf.id
                WHERE capa.company_id = {company_id}
                  {cond_data}
                  {cond_coo_z}
                  {sql_loja}
                  AND capa.state = 'V'
                GROUP  BY {group_data}
                          capa.ecf_id,
                          ecf.loja,
                          ecf.caixa
                ORDER  BY {ord_data} ecf.loja, ecf.caixa
        """.format(data=data, company_id=company_id, cond_data=cond_data, cond_data2=cond_data2,
                   cond_coo_z=cond_coo_z, cond_coo_z2=cond_coo_z2, sql_loja=sql_loja,
                   group_data=group_data, ord_data=ord_data)
        cr.execute(sql)
        return cr.dictfetchall()

    def ecfrim_consulta_resumo_importacao_nfce(self, cr, uid, company_id, data, context=None):
        context = context and context.copy() or {}
        sql = """
                SELECT serie_nf AS serie,
                       modelo.fismnf_codigo AS modelo
                FROM fiscal_modelo_nf_series AS serie
                INNER JOIN fiscal_modelo_nf  AS modelo ON modelo.id = serie.modelo_nf_id
                INNER JOIN fiscal_parametro  AS par    ON par.id = serie.parametro_id AND par.company_id = {company_id}
                WHERE modelo.fismnf_codigo IN ('65', '91')
                  AND serie.state = 'A'
        """.format(company_id=company_id)
        cr.execute(sql)
        res = []
        for i in cr.dictfetchall():
            serie = int(i.get('serie') or 0)
            modelo = i.get('modelo')
            sql = """
                    SELECT
                           nf.serie_nf                      AS ecfrcv_nf_serie,
                           modelo.fismnf_codigo             AS modelo,
                           modelo.id                        AS modelo_id,
                           (SELECT Min(numero_nf) 
                            FROM fiscal_nf_capa
                            WHERE
                                company_id = {company_id}
                                {cond_data}
                                AND serie_nf = '{serie}'
                                AND tipo = 'S'
                                AND fisnfc_consumidor
                                AND numero_nf IS NOT NULL
                                AND modelo_nf_id = modelo.id
                           )                                 AS ecfrcv_nf_inicial,
                           (SELECT Max(numero_nf) 
                            FROM fiscal_nf_capa
                            WHERE
                                company_id = {company_id}
                                {cond_data}
                                AND serie_nf = '{serie}'
                                AND tipo = 'S'
                                AND fisnfc_consumidor
                                AND numero_nf IS NOT NULL
                                AND modelo_nf_id = modelo.id
                           )                                 AS ecfrcv_nf_final,
                           SUM(condicao.valor)               AS ecfrcv_vendas,
                           ( SUM(CASE WHEN forma.admfpg_tipo = '01' 
                                        THEN condicao.valor 
                                      ELSE 0
                                 END) )                      AS ecfrcv_dinheiro_valor,
                           ( SUM(CASE WHEN forma.admfpg_tipo = '01' 
                                        THEN 1 
                                      ELSE 0
                                 END) )                      AS ecfrcv_dinheiro_qtd,
                           ( SUM(CASE WHEN forma.admfpg_tipo = '02' 
                                        THEN condicao.valor 
                                      ELSE 0
                                 END) )                      AS ecfrcv_cheque_valor,
                           ( SUM(CASE WHEN forma.admfpg_tipo = '02' 
                                        THEN 1 
                                      ELSE 0
                                 END) )                      AS ecfrcv_cheque_qtd,
                           ( SUM(CASE WHEN forma.admfpg_tipo IN ('10', '11', '17') 
                                        THEN condicao.valor 
                                      ELSE 0
                                 END) )                      AS ecfrcv_ticket_valor,
                           ( SUM(CASE WHEN forma.admfpg_tipo IN ('10', '11', '17') 
                                        THEN 1 
                                      ELSE 0
                                 END) )                      AS ecfrcv_ticket_qtd,
                           ( SUM(CASE WHEN forma.admfpg_tipo IN ('03', '04') 
                                        THEN condicao.valor 
                                      ELSE 0
                                 END) )                      AS ecfrcv_cartao_valor,
                           ( SUM(CASE WHEN forma.admfpg_tipo IN ('03', '04') 
                                        THEN 1 
                                      ELSE 0
                                 END) )                      AS ecfrcv_cartao_qtd,
                           ( SUM(CASE WHEN forma.admfpg_tipo NOT IN ('01', '02', '03', '04', '10', '11', '17') 
                                        THEN condicao.valor 
                                      ELSE 0
                                 END) )                      AS ecfrcv_outros_valor,
                           ( SUM(CASE WHEN forma.admfpg_tipo NOT IN ('01', '02', '03', '04', '10', '11', '17') 
                                        THEN 1 
                                      ELSE 0
                                 END) )                      AS ecfrcv_outros_qtd
                    FROM   fiscal_nf_capa AS nf
                    LEFT JOIN fiscal_condicao_pagamento AS condicao ON nf.id = condicao.capa_id
                    LEFT JOIN adm_forma_pgto            AS forma    ON forma.id = condicao.forma_pagto_id
                    LEFT JOIN fiscal_modelo_nf          AS modelo   ON modelo.id = nf.modelo_nf_id
                    WHERE 
                        nf.company_id = {company_id}
                        {cond_data}
                        AND nf.serie_nf = '{serie}'
                        AND modelo.fismnf_codigo = '{modelo}'
                        AND nf.state = '3'
                        AND nf.tipo = 'S'
                        AND nf.fisnfc_consumidor
                        AND nf.numero_nf IS NOT NULL
                        AND natureza_id IN (
                           SELECT id 
                           FROM fiscal_cfop_natureza 
                           WHERE 
                               tipo = 'S' 
                               AND cfop_id IN (
                                   SELECT id 
                                   FROM fiscal_cfop 
                                   WHERE 
                                       tipo = 'S' 
                                       AND movimento_tipo = 'C'
                                   )
                           )
                    GROUP  BY modelo.id, modelo.fismnf_codigo, nf.serie_nf
                    ORDER  BY modelo.id, modelo.fismnf_codigo, nf.serie_nf 
            """.format(data=data, company_id=company_id, serie=serie, modelo=modelo,
                       cond_data="AND data_emissao at time zone 'UTC' BETWEEN '{data} 00:00:00' AND '{data} 23:59:59'".
                       format(data=data))
            cr.execute(sql)
            res.extend(cr.dictfetchall())

        return res

    def ecfrim_consulta_resumo_finalizadoras(self, cr, uid, company_id, data, loja=False,
                                             context=None):
        context = context and context.copy() or {}
        if loja:
            sql_loja = "AND finalizacao.loja = '%s'" % loja
        else:
            sql_loja = ''
        sql = """
        SELECT ecfrfv_finalizadora_id,
               ecfrfv_finalizadora_na_ecf,
               SUM(ecfrfv_valor) AS ecfrfv_valor,
               SUM(ecfrfv_qtd)   AS ecfrfv_qtd,
               SUM(ecfrfv_troco) AS ecfrfv_troco,
               ecfrfv_avista_aprazo,
               ecfrfv_tipo_finalizadora
        FROM (
                SELECT finalizacao.finalizadora_id            AS ecfrfv_finalizadora_id,
                       finalizacao.ecffin_finalizadora_na_ecf AS ecfrfv_finalizadora_na_ecf,
                       SUM(CASE WHEN capa.tipo_cupom = 'C'
                                THEN -finalizacao.valor
                                ELSE finalizacao.valor
                           END)                               AS ecfrfv_valor,
                       Count(finalizacao.valor)               AS ecfrfv_qtd,
                       SUM(CASE
                             WHEN capa.tipo_cupom = 'C'
                             THEN -finalizacao.troco
                             ELSE finalizacao.troco
                           END)                               AS ecfrfv_troco,
                       finalizacao.avista_aprazo              AS ecfrfv_avista_aprazo,
                       finalizacao.tipo_finalizadora          AS ecfrfv_tipo_finalizadora
                FROM  ecf_cupons_capa             AS capa
                INNER JOIN ecf_cupons_finalizacao AS finalizacao ON finalizacao.cupom_id = capa.id
                WHERE capa.company_id = {company_id}
                  AND capa.state = 'V'
                  AND capa.tipo_cupom IN ( 'V', 'C' )
                  AND finalizacao.cupom_id = capa.id
                  AND capa.date_cupom = '{data}'
                  {sql_loja}
                GROUP  BY finalizacao.finalizadora_id,
                          finalizacao.avista_aprazo,
                          finalizacao.tipo_finalizadora,
                          finalizacao.ecffin_finalizadora_na_ecf
                UNION ALL
                SELECT finalizacao.condicao_forma_id            AS ecfrfv_finalizadora_id,
                       condicao_forma.finalizadora_na_ecf       AS ecfrfv_finalizadora_na_ecf,
                       SUM(CASE WHEN finalizacao.valor > 0
                                THEN finalizacao.valor
                                ELSE nf.vr_total_nf
			               END)                                 AS ecfrfv_valor,
                       Count(CASE WHEN finalizacao.valor > 0
                                  THEN finalizacao.valor
                                  ELSE nf.vr_total_nf
			                 END)                               AS ecfrfv_qtd,
                       0.0                                      AS ecfrfv_troco,
                       condicao.tipo                            AS ecfrfv_avista_aprazo,
                       CASE WHEN condicao_forma.name ilike '%PIX%'
                            THEN 'T'
                            ELSE condicao_forma.tipo_finalizadora         
                       END                                      AS ecfrfv_tipo_finalizadora
                FROM  fiscal_nf_capa                AS nf
                LEFT JOIN fiscal_condicao_pagamento AS finalizacao    ON nf.id = finalizacao.capa_id
                LEFT JOIN adm_condicao_forma        AS condicao_forma ON finalizacao.condicao_forma_id = condicao_forma.id
                LEFT JOIN adm_condicao              AS condicao       ON condicao.id = condicao_forma.adm_condicao_id
                WHERE nf.company_id = {company_id}
                  AND nf.data_emissao at time zone 'UTC' BETWEEN '{data} 00:00:00' AND '{data} 23:59:59'
                  AND nf.state = '3'
                  AND nf.tipo = 'S'
                  AND nf.fisnfc_consumidor
                  AND nf.numero_nf IS NOT NULL
                  AND natureza_id IN (SELECT id 
                                      FROM fiscal_cfop_natureza 
                                      WHERE tipo = 'S' 
                                        AND cfop_id IN (SELECT id 
                                                        FROM fiscal_cfop 
                                                        WHERE tipo = 'S' 
                                                        AND movimento_tipo = 'C')
                                      )
                GROUP BY 
                    ecfrfv_finalizadora_id,
                    ecfrfv_avista_aprazo,
                    ecfrfv_tipo_finalizadora,
                    ecfrfv_finalizadora_na_ecf) AS TMP

        GROUP BY ecfrfv_finalizadora_id,
                 ecfrfv_avista_aprazo,
                 ecfrfv_tipo_finalizadora,
                 ecfrfv_finalizadora_na_ecf                    
        ORDER  BY ecfrfv_finalizadora_na_ecf
        """.format(company_id=company_id, data=data, sql_loja=sql_loja)
        cr.execute(sql)
        return cr.dictfetchall()

    def ecfrim_consulta_resumo_importacao_nfce_faltante(self, cr, uid, company_id, data,
                                                        context=None):
        context = context and context.copy() or {}
        sql = """
                SELECT serie_nf AS serie,
                       modelo.fismnf_codigo AS modelo
                FROM fiscal_modelo_nf_series AS serie
                INNER JOIN fiscal_modelo_nf  AS modelo ON modelo.id = serie.modelo_nf_id
                INNER JOIN fiscal_parametro  AS par    ON par.id = serie.parametro_id AND par.company_id = {company_id}
                WHERE modelo.fismnf_codigo IN ('65', '91')
                  AND serie.state = 'A'
        """.format(company_id=company_id)
        cr.execute(sql)
        res = []
        for i in cr.dictfetchall():
            serie = int(i.get('serie') or 0)
            modelo = i.get('modelo')
            sql = """
                    SELECT
                           nf.serie_nf                      AS nf_serie,  
                           modelo.fismnf_codigo             AS modelo,
                           modelo.id                        AS modelo_id,
                           (SELECT Min(numero_nf) 
                            FROM fiscal_nf_capa
                            WHERE
                                company_id = {company_id}
                                {cond_data}
                                AND serie_nf = '{serie}'
                                AND tipo = 'S'
                                AND fisnfc_consumidor
                                AND numero_nf IS NOT NULL
                                AND modelo_nf_id = modelo.id
                           )                                 AS nf_inicial,
                           (SELECT Max(numero_nf) 
                            FROM fiscal_nf_capa
                            WHERE
                                company_id = {company_id}
                                {cond_data}
                                AND serie_nf = '{serie}'
                                AND tipo = 'S'
                                AND fisnfc_consumidor
                                AND numero_nf IS NOT NULL
                                AND modelo_nf_id = modelo.id
                           )                                 AS nf_final
                    FROM   fiscal_nf_capa AS nf
                    LEFT JOIN fiscal_condicao_pagamento AS condicao ON nf.id = condicao.capa_id
                    LEFT JOIN adm_forma_pgto            AS forma    ON forma.id = condicao.forma_pagto_id
                    LEFT JOIN fiscal_modelo_nf          AS modelo   ON modelo.id = nf.modelo_nf_id
                    WHERE 
                        nf.company_id = {company_id}
                        {cond_data}
                        AND nf.serie_nf = '{serie}'
                        AND modelo.fismnf_codigo = '{modelo}'
                        AND nf.state = '3'
                        AND nf.tipo = 'S'
                        AND nf.fisnfc_consumidor
                        AND nf.numero_nf IS NOT NULL
                        AND natureza_id IN (
                           SELECT id 
                           FROM fiscal_cfop_natureza 
                           WHERE 
                               tipo = 'S' 
                               AND cfop_id IN (
                                   SELECT id 
                                   FROM fiscal_cfop 
                                   WHERE 
                                       tipo = 'S' 
                                       AND movimento_tipo = 'C'
                                   )
                           )
                    GROUP  BY modelo.id, modelo.fismnf_codigo, nf.serie_nf
                    ORDER  BY modelo.id, modelo.fismnf_codigo, nf.serie_nf
            """.format(data=data, company_id=company_id, serie=serie, modelo=modelo,
                       cond_data="AND data_emissao at time zone 'UTC' BETWEEN '{data} 00:00:00' AND '{data} 23:59:59'".format(data=data))
            cr.execute(sql)
            res.extend(cr.dictfetchall())

        return res


report_custom('report.resumo_importacao')


# noinspection PyAbstractClass,PyPep8Naming
class resumo_importacao_osv(osv.TransientModel):

    _name = 'resumo.importacao.osv'
    _columns = {
        'data': fields.date('Data', required=True),
        'loja': fields.integer('Loja')
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        resumo_importacao_osv_dados = self.read(cr, uid, ids, [], context=context)
        for x in resumo_importacao_osv_dados:
            datas = {'data': x.get('data'),
                     'loja': x.get('loja')}
        return {'type': 'ir.actions.report.xml',
                'report_name': 'resumo_importacao',
                'datas': datas, }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
