# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _
import time


class ecf_cupom_log_osv(osv.TransientModel):
    """
    Esta classe tem como objetivo criar uma visao dos erros gerados na importacao e validacao dos cupons.
    """

    _name = 'ecf.cupom.log.osv'
    _columns = {
        'txt_log': fields.text('Log', readonly=True)
    }
    _defaults = {
        'txt_log': _("Execute a validacao para exibir o log")
    }

    def button_valida_inconsistencia(self, cr, uid, id, context=None):
        context = context and context.copy() or {}
        cr.execute('truncate ecf_cupom_log')
        cr.commit()
        self.button_validar(cr, uid, id, context)
        return True

    def button_validar(self, cr, uid, id, context=None):
        context = context and context.copy() or {}
        context['inconsistencia'] = True
        try:
            valida = self.pool.get('ecf.importar.cupom.osv').button_importar(cr, uid, id, context, file_erro=True)
            retorno = self.get_cupom_erros(cr, uid, id, context)
        except Exception as err:
            retorno = _(str(err))
        if not retorno:
            retorno = _('**NAO HA INCONSISTENCIAS NOS CUPONS**')
        self.write(cr, uid, id, {'txt_log': retorno}, context)
        return True

    def get_cupom_erros(self, cr, uid, id, context=None):
        context = context and context.copy() or {}
        res = []
        #        if context.get('inconsistencia'):
        log_ids = self.pool.get('ecf.cupom.log').search(cr, uid, [(1, '=', 1)], context=context,
                                                        order='nome_arquivo_log, numero_cupom, numero_linha_log')
        log = self.pool.get('ecf.cupom.log').read(cr, uid, log_ids, [], context=context)
        file_id = ''
        cupom_id = 0
        logs = ""
        for dado in log:
            if file_id != dado.get('nome_arquivo_log'):
                file_id = dado.get('nome_arquivo_log')
                cupom_id = 0
            if cupom_id != dado.get('numero_cupom'):
                cupom_id = dado.get('numero_cupom')
                logs += "Cupom: %s \n" % cupom_id
            if dado.get('numero_linha_log'):
                logs += "Linha: %s \n" % dado.get('numero_linha_log')
            if dado.get('numero_coluna_log'):
                logs += "Coluna: %s \n" % dado.get('numero_coluna_log')
            if dado.get('txt_log'):
                logs += "Erro: %s \n" % dado.get('txt_log')
            logs += "%s \n\n" % dado.get('txt_erro')
        return logs

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_ecf_cupom_log = self.pool.get('ecf.cupom.log')
        ecf_cupom_log_ids = obj_ecf_cupom_log.search(cr, uid, [], context=context)
        data_inconsistencia = ''
        if ecf_cupom_log_ids:
            data_inconsistencia = obj_ecf_cupom_log.browse(cr, uid, ecf_cupom_log_ids[0]).data_criacao
        if time.strftime('%Y-%m-%d') != data_inconsistencia[:10]:
            raise osv.except_osv(_('Atencao'), _('Execute a validacao da inconsistencia'))

        datas = {

        }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'listagem_inconsistencia',
            'datas': datas,
        }

