# -*- coding: utf-8 -*-

import base64
import MySQLdb as mysql
from openerp.osv import osv, fields
from SigUtils.formatastring import unicode_to_ascii
from re import sub as re_sub
import xmlrpclib, socket
from openerp.tools.translate import _
import psycopg2
import psycopg2.extras
from os import path, remove
from datetime import datetime
from psycopg2 import extensions
# noinspection PyUnresolvedReferences
from openerp.addons.financeiro.model.funcoes import fincli_get_bloqueio
from openerp.addons.kit.model.funcoes import get_preco_total_venda_itens_kit
from openerp.addons.financeiro.model.funcoes import _get_total_em_aberto
import itertools as it
import re

f_txt = lambda txt, tam: unicode_to_ascii(txt).ljust(tam)[:tam]
f_num = lambda x, t, d=0: str(long(
    round((x if x and not isinstance(x, str) else 0) * 10 ** d, 2))).rjust(t, '0')[-t:] or False

READ_LOAD = '_classic_write'


class ecf_exportar_osv(osv.TransientModel):
    """
    Wizard de exportacao para ECF.
    """

    def testa_arquivo(self, cr, uid, file):
        res = ''
        obj_adm_utils = self.pool.get('adm.utils')
        try:
            f = open(file, 'w')
            f.close()
        except Exception as e:
            res = _('\n%s') % obj_adm_utils.admutl_remover_acentuacao(cr, uid, str(e))
        return res

    def _gerar_arquivo_itens(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_adm_util = self.pool.get('adm.utils')
        inc_nserie = 0  # QTDA. DE NUMEROS DE SERIE CRIADOS
        # arquivo de apoio
        fl = open('/tmp/example.txt', 'w')
        fl_t = open('/tmp/trib.txt', 'w')
        # nro. de registros exportados
        regs = 0
        log = ''

        # parâmetros de busca
        vals = self.read(cr, uid, ids[0], context=context)
        ep_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'estoque.produto', context=context)
        ap_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'automacao.precos', context=context)
        esp_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'estoqueserie.produto',
                                                                        context=context)
        data = vals.get('data', False)
        exportar_itens = vals.get('exportar_itens')
        o_estoqueserie = self.pool.get('estoqueserie.produto')
        obj_adm_utils = self.pool.get('adm.utils')
        obj_estoque_parametro = self.pool.get('estoque.parametro')
        param_ids = obj_estoque_parametro.search(cr, uid, [], context=context)
        o_param = self.pool.get('estoque.parametro')
        r_param = o_param.read(cr, uid, param_ids[0],
                               ['arquivo_de_itens_ecf', 'arquivo_de_trib_ecf',
                                'arquivo_de_nserie', 'estpar_super_local_id'],
                               context=context)

        file_arq_trib = r_param.get('arquivo_de_trib_ecf', False)
        file_arq_itens = r_param.get('arquivo_de_itens_ecf', False)
        file_arq_nserie = r_param.get('arquivo_de_nserie', False)
        estpar_super_local_id = r_param.get('estpar_super_local_id', False)

        # VERIFICAR SE TEM PERMISSÃO P/ ESCREVER O ARQUIVO
        if file_arq_trib:
            test_file_i = self.testa_arquivo(cr, uid, file_arq_trib)
            if test_file_i:
                log += test_file_i
                return {'log': log}

        if file_arq_itens:
            test_file_i = self.testa_arquivo(cr, uid, file_arq_itens)
            if test_file_i:
                log += test_file_i
                return {'log': log}
                # TESTAR ARQUIVO NSERIE
        if not file_arq_nserie:
            log += _('\nCaminho do arquivo de Numeros de Serie nao configurado.')
            file_arq_nserie = ''
        #                return {'log':log}
        else:
            # VERIFICAR SE TEM PERMISSÃO P/ ESCREVER O ARQUIVO
            test_file_n = self.testa_arquivo(cr, uid, file_arq_nserie)
            if test_file_n:
                log += test_file_n or ''
                file_arq_nserie = ''
                #                    return {'log':log}
        fields_estoque_produto = self.pool.get('estoque.produto').fields_get(cr, uid, ['produto_de_balanca'])
        campos = ''
        if fields_estoque_produto.get('produto_de_balanca'):
            campos += """, ep.produto_de_balanca
            """

        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'balanca', context):
            campos += """, ep.estpro_peso_tara
                        """

        estpro_nserie_tipo = self.pool.get('estoque.produto').fields_get(cr, uid, ['estpro_nserie_tipo'])
        if estpro_nserie_tipo.get('estpro_nserie_tipo'):
            campos += """, ep.estpro_nserie_tipo
                        """
        condicao = ''
        if estpar_super_local_id:
            condicao += """AND ep.id in (SELECT produto_id
                                         FROM estoque_local_locacao AS ell
                                         WHERE ell.local_id IN (%s)) """ % \
                                            ','.join(map(lambda x: '%s' % x, estpar_super_local_id))

        if exportar_itens == 'P':
            condicao += """ AND ap.autpre_ja_exportou = False """

        sql = """
        SELECT acb.codigo_barra,
               ep.name,
               ep.origem_mercadoria,
               ep.active                                                AS produto_ativo,
               ep.grade_usar,
               epg.name                                                 as descricao,
               epg.descricao_resumida,
               1                                                        AS departamento,
               ft.tributacao_ecf,
               (CASE WHEN ep.ncm_id IS NOT NULL
                     THEN fn.codigo
                     ELSE NULL
                END)                                                    AS ncm_codigo,
               cest.fiscest_codigo                                      AS cest_codigo,
               (CASE WHEN ep.origem_mercadoria IN ('0','3','4','5', '8')
                     THEN fn.fisnc_aliq_ibpt_fed_nac
                     WHEN ep.origem_mercadoria IN ('1','2','6','7')
                     THEN fn.fisnc_aliq_ibpt_fed_imp
                     ELSE NULL
                END)                                                    AS aliquota_tributos_fed,
               fn.fisnc_aliq_ibpt_est                                   AS aliquota_tributos_est,
               fn.fisnc_aliq_ibpt_mun                                   AS aliquota_tributos_mun,
               fn.fisnc_ibpt_chave                                      AS chave_ibpt,
               eeu.fracao,
               ap.preco_venda,
               ap.id                                                    AS automacao_precos_id,
               eeu.unidade,
               ee.quantidade_na_embalagem,
               acb.peso_embalagem,
               ep.codigo,
               ep.producao_propria,
               ep.id                                                     AS produto_id,
               acb.grade_id,
               acb.active
               %s
        FROM automacao_precos                 AS ap
        INNER JOIN automacao_codigo_barra     AS acb  ON acb.id = ap.codigo_barra_id
        INNER JOIN estoque_produto            AS ep   ON ep.id = acb.produto_id
        INNER JOIN estoque_produto_grade      AS epg  ON epg.id = acb.grade_id
        INNER JOIN estoque_produto_embalagem  AS epe  ON epe.id = acb.produto_embalagem_id
        INNER JOIN estoque_embalagem          AS ee   ON ee.id = epe.embalagem_id
        INNER JOIN estoque_embalagem_unidade  AS eeu  ON eeu.id = ee.unidade_id
        INNER JOIN fiscal_tributacao_encargos AS fte  ON fte.produto_id = acb.produto_id
        INNER JOIN fiscal_tributacao          AS ft   ON ft.id = fte.tributacao_id
        INNER JOIN fiscal_ncm                 AS fn   ON fn.id = ep.ncm_id
        LEFT  JOIN fiscal_cest                AS cest ON cest.id = ep.estpro_cest_id
        INNER JOIN fiscal_encargo             AS fe   ON fe.id = fte.encargo_id
        WHERE fte.tipo_tributacao = 'T'
          AND fe.sigla IN ('ICMS','ISS')
          AND ap.company_id = %s
          AND ep.company_id = %s
          %s
        ORDER BY acb.codigo_barra
        """ % (campos, ap_company_id, ep_company_id, condicao)
        cr.execute(sql)
        res_preco = cr.dictfetchall()
        arq_nseries = ''
        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'kit', context):
            campos = ''
            if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'balanca', context):
                campos += ", ep.estpro_peso_tara "

            condicao_kit = ''
            if exportar_itens == 'P': # exportacao parcial
                condicao_kit += """ AND ap.autpre_ja_exportou = False """
            else: # exportacao total. '*' no inicio indica que a tabela sera tr
                fl.write("*\r\n")
                fl_t.write("*\r\n")

            sql_kit = """SELECT DISTINCT(acb.codigo_barra),
                                ep.name,
                                ep.origem_mercadoria,
                                fca.fisanp_codigo               AS codigo_anp,
                                ep.active                       AS produto_ativo,
                                ep.grade_usar,
                                epg.name                        as descricao,
                                epg.descricao_resumida,
                                acb.active,
                                ep.kit_de_produtos,
                                epv.preco_venda,
                                acb.peso_embalagem,
                                ep.producao_propria,
                                ep.codigo,
                                ep.id                           AS produto_id,
				                acb.grade_id,
				                fn.codigo                       AS ncm_codigo,
                                cest.fiscest_codigo             AS cest_codigo,
                                ap.id                           AS automacao_precos_id,
                                (CASE WHEN ep.origem_mercadoria IN ( '0', '3', '4', '5', '8' )
                                      THEN fn.fisnc_aliq_ibpt_fed_nac
                                      WHEN ep.origem_mercadoria IN ( '1', '2', '6', '7' )
                                      THEN fn.fisnc_aliq_ibpt_fed_imp
                                      ELSE NULL
                                 END )                          AS aliquota_tributos_fed,
                                fn.fisnc_aliq_ibpt_est          AS aliquota_tributos_est,
                                fn.fisnc_aliq_ibpt_mun          AS aliquota_tributos_mun,
                                fn.fisnc_ibpt_chave             AS chave_ibpt,
                                eeu.fracao,
                                eeu.unidade,
                                ee.quantidade_na_embalagem
                                %s
                         FROM   kit_produto                   AS kp
                         INNER JOIN estoque_produto           AS ep   ON ep.id = kp.kitpro_produto_id
                         INNER JOIN automacao_codigo_barra    AS acb  ON acb.produto_id = kp.kitpro_produto_id
                         INNER JOIN estoque_preco_venda       AS epv  ON epv.produto_id = ep.id
                         INNER JOIN estoque_produto_grade     AS epg  ON acb.grade_id = epg.id
                         INNER JOIN estoque_produto_embalagem AS epe  ON epe.id = acb.produto_embalagem_id
                         INNER JOIN estoque_embalagem         AS ee   ON ee.id = epe.embalagem_id
                         INNER JOIN estoque_embalagem_unidade AS eeu  ON eeu.id = ee.unidade_id
                         INNER JOIN fiscal_ncm                AS fn   ON fn.id = ep.ncm_id
                         LEFT  JOIN fiscal_cest               AS cest ON cest.id = ep.estpro_cest_id
                         LEFT  JOIN fiscal_cadastro_anp       AS fca  ON fca.id = ep.estpro_codigo_anp_id 
                         INNER JOIN automacao_precos          AS ap   ON ap.codigo_barra_id = acb.id
                         WHERE  ep.company_id = %s
                                %s
                         ORDER  BY acb.codigo_barra """ % (campos, ep_company_id, condicao_kit)
            cr.execute(sql_kit)
            res_kits = cr.dictfetchall()
            for res_kit in res_kits:
                res_preco.append(res_kit)
        dict_check = {}  # Usado para verificar duplicidade de codigo de barra
        produto_sem_trib_ecf = ''
        usa_tara = False
        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'balanca', context):
            brw_estoque_param = obj_estoque_parametro.browse(cr, uid, param_ids)
            usa_tara = brw_estoque_param[0].estpar_balanca_usar_tara

        produto_ids = []
        for i in res_preco:
            produto_ids.append('%s' % i.get('produto_id'))

        sql = """
            SELECT ft.id                  AS codigo_trib,
                   ft.aliquota            AS aliquota,
                   ft.base                AS base,
                   ft.fistri_aliquota_fcp AS aliquota_fcp,
                   fc.tipo                AS tipo_tributacao,
                   fc.codigo              AS codigo_cst,
                   fe.sigla               AS encargo,
                   csosn2.codigo          AS csosn_nao,
                   fte.produto_id         AS produto_id,
                   acb.codigo_barra       AS codigo_barra

            FROM fiscal_tributacao                AS ft  
            INNER JOIN fiscal_tributacao_encargos AS fte    ON fte.tributacao_id = ft.id 
            INNER JOIN automacao_codigo_barra     AS acb    ON acb.produto_id = fte.produto_id
            INNER JOIN fiscal_encargo             AS fe     ON fe.id = fte.encargo_id
            INNER JOIN fiscal_cst                 AS fc     ON fc.id = fte.cst_id
            LEFT JOIN fiscal_csosn                AS csosn2 ON csosn2.id = fc.fiscst_csosn_nao_contribuinte_id
            WHERE fte.tipo_tributacao = 'T' -- 'T' = Todas/Consumidor Final
              AND fte.produto_id IN (%s)
              AND fe.sigla IN ('PIS','COFINS','ICMS','ISS')
              """ % ','.join(produto_ids)
        cr.execute(sql)
        dict_encargos = {'PIS': 'P', 'COFINS': 'C', 'ICMS': 'I', 'ISS': 'S'}
        dados_trib_nfce = cr.dictfetchall()
        prod_trib = {}
        for i in dados_trib_nfce:
            codigo_trib = i.get('codigo_trib')
            prod_trib['%s-%s' % (i.get('produto_id'), i.get('encargo'))] = i.get('codigo_trib')
            csosn = ''
            if i.get('csosn_nao'):
                csosn = "%s" % i.get('csosn_nao')

            s_arq = ''
            s_arq += f_num(codigo_trib, 10, 0)
            s_arq += f_num(i.get('aliquota'), 5, 2)
            s_arq += f_num(i.get('base'), 5, 2)
            s_arq += f_txt(dict_encargos.get(i.get('encargo')), 1)
            s_arq += f_txt(i.get('codigo_cst'), 2)
            s_arq += f_txt(csosn, 3)
            s_arq += f_txt(i.get('tipo_tributacao'), 2)
            s_arq += f_txt(i.get('codigo_barra'), 14)
            s_arq += f_num(i.get('aliquota_fcp'), 5, 2)
            s_arq += '\r\n'
            fl_t.write(s_arq)

        auto_ids = map(lambda x: x.get('automacao_precos_id'), res_preco)
        for rec_preco in res_preco:
            valor_unitario = rec_preco.get('preco_venda') or 0.0
            if not dict_check.get(rec_preco.get('codigo_barra')):
                produto_name = rec_preco.get('descricao_resumida') or rec_preco.get('descricao') or 'null'
                produto_name = produto_name.replace("'", '')
                produto_name = obj_adm_utils.admutl_remover_acentuacao(cr, uid, produto_name)[:30]
                produto_name_completo = rec_preco.get('descricao') or 'null'
                produto_name_completo = produto_name_completo.replace("'", '')
                produto_name_completo = obj_adm_utils.admutl_remover_acentuacao(cr, uid, produto_name_completo[:60])
                dict_check[rec_preco.get('codigo_barra')] = True
                kit_pro = []
                if rec_preco.get('kit_de_produtos') == True:
                    sql_tributacao_isento = """ SELECT tributacao_ecf
                                                FROM   fiscal_tributacao trib
                                                INNER JOIN fiscal_cst AS cst ON cst.id = trib.cst_id
                                                WHERE  cst.codigo = '40' """
                    cr.execute(sql_tributacao_isento)
                    kit_pro = cr.dictfetchall()
                    kit_pro = kit_pro[0] if kit_pro and isinstance(kit_pro, list) else kit_pro

                if rec_preco.get('tributacao_ecf') or kit_pro:
                    s_arq = f_txt(rec_preco.get('codigo_barra') or '', 14)
                    s_arq += f_txt(produto_name, 30)
                    # o campo Departamento e obrigatorio no supervisor , esta passando fixo o valor 1
                    s_arq += f_num(01, 2)
                    # caso nao haja tributacao, retornará 0
                    if kit_pro:
                        s_arq += f_txt(kit_pro.get('tributacao_ecf') or '0', 3)
                    else:
                        s_arq += f_txt(rec_preco.get('tributacao_ecf') or '0', 3)
                    produto_pesavel = rec_preco.get('produto_de_balanca')
                    s_arq += 'S' if produto_pesavel else 'N'
                    produto_fracionado = rec_preco.get('fracao')
                    s_arq += 'S' if produto_fracionado else 'N'
                    s_arq += f_num(valor_unitario, 12, 2)
                    s_arq += f_txt(rec_preco.get('unidade') or '', 2)
                    s_arq += f_num(rec_preco.get('peso_embalagem') or 0.0, 4, 3)
                    s_arq += f_txt(rec_preco.get('codigo') or '', 20)
                    # fator multiplicador: quantidade de unidades na embalagem
                    s_arq += f_num((rec_preco.get('quantidade_na_embalagem') or 1) *1000, 11)
                    tipo_producao = rec_preco.get('producao_propria') or False
                    s_arq += 'P' if tipo_producao else 'T'
                    if rec_preco.get('produto_ativo'):
                        if rec_preco.get('active'):
                            s_arq += 'A'
                        else:
                            s_arq += 'I'
                    else:
                        s_arq += 'I'
                    ncm_codigo = rec_preco.get('ncm_codigo') or ''
                    cest_codigo = rec_preco.get('cest_codigo') or ''
                    aliquota_tributos_fed = rec_preco.get('aliquota_tributos_fed') or 0.0
                    aliquota_tributos_est = rec_preco.get('aliquota_tributos_est') or 0.0
                    aliquota_tributos_mun = rec_preco.get('aliquota_tributos_mun') or 0.0
                    chave_ibpt = rec_preco.get('chave_ibpt') or 0.0
                    s_arq += f_txt(ncm_codigo, 8)
                    s_arq += f_num(aliquota_tributos_fed, 5, 2)
                    s_arq += f_txt(produto_name_completo, 60)
                    if usa_tara is True:
                        s_arq += f_num(rec_preco.get('estpro_peso_tara') or 0.0, 4, 3)
                    else:
                        s_arq += f_num(0.0, 4, 3)

                    s_arq += f_num(aliquota_tributos_est, 5, 2)
                    s_arq += f_num(aliquota_tributos_mun, 5, 2)
                    s_arq += f_txt(chave_ibpt, 10)
                    s_arq += f_txt(cest_codigo, 7)
                    s_arq += f_txt(rec_preco.get('origem_mercadoria') or '', 1)
                    s_arq += f_txt(rec_preco.get('codigo_anp') or '', 9)
                    s_arq += '\r\n'
                    fl.write(s_arq)

                    regs += 1
                else:
                    produto_sem_trib_ecf += '\n' + produto_name_completo
                    # GERAR ARQUIVO DE NUMEROS DE SÉRIE
                if len(rec_preco) >= 14:
                    if file_arq_nserie and rec_preco.get('estpro_nserie_tipo') == 'NC':
                        args_nserie = [('company_id', '=', esp_company_id),
                                       ('esepro_produto_id', '=', rec_preco.get('produto_id') or False),
                                       ('esepro_grade_id', '=', rec_preco.get('grade_id') or False),
                                       ('esepro_disponivel', '=', True)]

                        if o_estoqueserie:
                            search_nseries = o_estoqueserie.search(cr, uid, args_nserie, context=context)

                            if search_nseries:
                                res_nseries = o_estoqueserie.read(cr, uid, search_nseries,
                                                                  ['esepro_nro_serie'], context=context)
                                for serie in res_nseries:
                                    arq_nseries += '%s%s\n' % (f_num(rec_preco.get('codigo_barra') or '',
                                                                     14),
                                                               f_txt(serie['esepro_nro_serie'],
                                                                     30)
                                                               )
                                    inc_nserie += 1
        fl_t.close()
        fl_t = open('/tmp/trib.txt', 'r')
        fl_t_read = fl_t.readlines()
        fl_t.close()
        remove('/tmp/trib.txt')
        fl_t = ''.join(map(str, fl_t_read))

        fl.close()
        fl = open('/tmp/example.txt', 'r')
        fl_read = fl.readlines()
        fl.close()
        remove('/tmp/example.txt')
        fl = ''.join(map(str, fl_read))
        if regs:
            if file_arq_trib:
                try:
                    f = open(file_arq_trib, 'w')
                    f.write(fl_t)
                    f.close()
                except IOError as err:
                    raise osv.except_osv(_('Atencao'), _('%s' % str(err)))

            if file_arq_itens:
                try:
                    f = open(file_arq_itens, 'w')
                    f.write(fl)
                    f.close()
                except IOError as err:
                    raise osv.except_osv(_('Atencao'), _('%s' % str(err)))
            if inc_nserie and file_arq_nserie:
                try:
                    f = open(file_arq_nserie, 'w')
                    f.write(arq_nseries)
                    f.close()
                except IOError as err:
                    raise osv.except_osv(_('Atencao'), _('%s' % str(err)))
            else:
                log += _('\nNenhum Numero de Serie Exportado')
        else:
            log += _('\nNenhum item Exportado')
        if produto_sem_trib_ecf:
            log += _('\nOs itens abaixo nao foram exportados. Cadastre a Tributacao na ECF para '
                     'os tributos dos itens.' + produto_sem_trib_ecf)

        if res_preco and auto_ids:
            vals_automacao = {'autpre_ja_exportou': True}
            # o sql foi trocado para evitar erros de concorrencia
            self.pool.get('automacao.precos').write(cr, uid, auto_ids, vals_automacao,
                                                    context=context)

        return {'regs': regs,
                'regs_nserie': inc_nserie,
                'log': log or '',
                'arquivo_itens': base64.encodestring(fl.encode('utf-8', 'strict')),
                'arquivo_tributacao': base64.encodestring(fl_t.encode('utf-8', 'strict')),
                'arquivo_series': base64.encodestring(arq_nseries.encode('utf-8', 'strict'))
                }

    def _gerar_arquivo_clientes(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        # nro. de registros exportados
        regs = 0
        log = ''
        arq = ''
        arq_msg = ''

        vals = self.read(cr, uid, ids[0], context=context)
        fc_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'financeiro.cliente')
        s_arq = []
        s_arq_msg = []
        obj_cliente = self.pool.get('financeiro.cliente')
        cliente_ids = obj_cliente.search(cr, uid, [('company_id', '=', fc_company_id)],
                                                                 context=context)
        if cliente_ids:
            param_ids = self.pool.get('estoque.parametro').search(cr, uid, [], context=context)
            if not param_ids:
                log += _('\nParametros de estoque nao encontrados.')
            else:
                param = self.pool.get('estoque.parametro').read(cr, uid, param_ids[0], ['arquivo_de_clientes'],
                                                                context=context)
                if param['arquivo_de_clientes']:
                    try:
                        arq = open(param['arquivo_de_clientes'], 'w')
                    except IOError as err:
                        raise osv.except_osv(_('Atencao'), _('%s' % str(err)))

        # Gerar Registro de Mensagens de clientes
        if cliente_ids:
            param_ids = self.pool.get('estoque.parametro').search(cr, uid, [], context=context)
            if not param_ids:
                log += _('\nParametros de estoque nao encontrados.')
            else:
                param = self.pool.get('estoque.parametro').read(cr, uid, param_ids[0], ['arquivo_de_mensagens'],
                                                                context=context)
                if param['arquivo_de_mensagens']:
                    try:
                        arq_msg = open(param['arquivo_de_mensagens'], 'w')
                    except IOError as err:
                        raise osv.except_osv(_('Atencao'), _('%s' % str(err)))

        obj_venda_utils = self.pool.get('vendas.utils')
        obj_financeiro_utils = self.pool.get('financeiro')
        obj_adm_util = self.pool.get('adm.utils')
        clientes_bloqueados = fincli_get_bloqueio(self, cr, uid, cliente_ids, context=context)
        dados_clientes = self.get_dados_cliente_arquivo(cr, uid, cliente_ids, vals, context)
        pessoa_ids = map(lambda x: x.get('pessoa_id'), dados_clientes)
        total_titulos_em_atraso = obj_financeiro_utils.finutl_get_valor_em_atraso(cr, uid,
                                                      venutl_pessoa_ids=pessoa_ids, context=context)
        total_docs_em_aberto = _get_total_em_aberto(obj_cliente, cr, uid, pessoa_ids,
                                                    context=context)
        pessoa_endereco = {}
        obj_endereco = self.pool.get('adm.pessoa.endereco')
        endereco_ids = obj_endereco.search(cr, uid, [('pessoa_id', 'in', pessoa_ids)],
                                           context=context)
        map(lambda x: pessoa_endereco.update({x.get('pessoa_id'): x.get('name')}),
                      obj_endereco.read(cr, uid, endereco_ids, ['name', 'pessoa_id'],
                                        context=context, load='_classic_write'))
        for cliente in dados_clientes:
            scpf = (cliente.get('cpf_cnpj') or '').encode('ascii', 'ignore').translate(None, ',.;/\ -+_ {}[]')

            cliente_limite_credito = cliente.get('limite_credito') or 0
            pessoa_id = cliente.get('pessoa_id')
            if cliente_limite_credito:
                total_em_atraso = total_titulos_em_atraso.get(pessoa_id) or 0
                total_debito = total_docs_em_aberto.get(pessoa_id) or 0 + total_em_atraso
                diff = cliente_limite_credito - total_debito
                if diff < 0:
                    cliente_limite_credito = 0
                else:
                    cliente_limite_credito = diff

            pessoa_name = obj_adm_util.admutl_remover_acentuacao(cr, uid, cliente.get('nome')or '')
            pessoa_name = pessoa_name.encode('ascii', 'ignore').translate(None, 'º°ª')
            endereco = pessoa_endereco.get(pessoa_id) or ''
            endereco = obj_adm_util.admutl_remover_acentuacao(cr, uid, endereco).replace("'", '')
            status = 'B' if clientes_bloqueados.get(cliente.get('id')) != 'L' else 'L'
            ## Gerar Registro do arquivo de Mensagens dos Clientes
            linha = '{cpf_cnpj}{nome}{endereco}{status}{limite}{codigo}{jur_ie}\r\n'.format(
                cpf_cnpj=scpf.rjust(15, '0')[:15],
                nome=f_txt(pessoa_name, 40),
                endereco=f_txt(endereco, 40),
                status=f_txt(status, 1),
                limite=f_num(cliente_limite_credito, 12, 2),
                codigo=f_num(int(re.sub('[^0-9]', '', str(cliente.get('codigo') or 0))), 15),
                jur_ie=f_txt(obj_adm_util.admutl_remover_acentuacao( cr, uid,
                             cliente.get('admpes_jur_ie') or ' ').encode('ascii', 'ignore').
                             translate(None, ',.;/\ -+_ {}[]'), 15))
            s_arq.append(linha)
            regs += 1

        if arq and s_arq:
            arq.write(''.join(s_arq))
        else:
            log += _('Nenhum cliente exportado')

        dados_mensagem_clientes = self._get_dados_mensagens(cr, uid, cliente_ids, context=context)
        if arq_msg:
            for msg in dados_mensagem_clientes:
                texto = f_txt(obj_adm_util.admutl_remover_acentuacao(cr, uid, msg.get('name')), 40)
                if msg.get('tipo_mensagem') == 'B': # nao mostra motivo do bloqueio
                    texto = 'Mensagem nro: %s' % msg.get('codigo')

                linha_msg = '%s%s%s%s' % \
                       ((msg.get('cpf_cnpj') or '').rjust(15, '0')[:15],
                        texto,
                        obj_adm_util.admutl_remover_acentuacao(cr, uid, msg.get('modo_exibicao')),
                        '\r\n')
                s_arq_msg.append(linha_msg)

            if s_arq_msg:
                arq_msg.write(''.join(s_arq_msg))

        if arq:
            arq.close()
        if arq_msg:
            arq_msg.close()
        return {'regs': regs, 'log': log,
                'arquivo_clientes': base64.encodestring(''.join(s_arq).encode('utf-8', 'strict')),
                'arquivo_mensagens': base64.encodestring(''.join(s_arq_msg).encode('utf-8', 'strict'))}

    def get_dados_cliente_arquivo(self, cr, uid, cliente_ids, dados_capa, context=None):
        context = context and context.copy() or {}
        res = list()
        if not cliente_ids:
            return res
        if len(cliente_ids) == 1:
            cliente_ids = str(tuple(cliente_ids)).replace(',', '')
        else:
            cliente_ids = str(tuple(cliente_ids))
        sql = """
            SELECT
                fc.id AS id, fc.pessoa_id, ap.cpf_cnpj, ap.nome, fc.limite_credito, ap.codigo,
                ap.admpes_jur_ie
            FROM financeiro_cliente fc
            INNER JOIN adm_pessoa ap
                ON fc.pessoa_id = ap.id
            WHERE fc.id in %s
        """ % cliente_ids
        cr.execute(sql)
        res = cr.dictfetchall()
        return res

    def get_dados_cliente_postgres(self, cr, uid, cliente_ids, dados_capa, context=None):
        context = context and context.copy() or {}
        res = list()
        if not cliente_ids:
            return res
        if len(cliente_ids) == 1:
            cliente_ids = str(tuple(cliente_ids)).replace(',', '')
        else:
            cliente_ids = str(tuple(cliente_ids))

        sql = """
            SELECT ap.id               AS pessoa_id,
                   ap.cpf_cnpj,
                   ap.nome,
                   ap.codigo           AS codigo_interno,
                   ap.admpes_jur_ie,
                   ap.pessoa_tipo,
                   ap.email,
                   ap.endereco,
                   Min(ape.numero)     AS numero,
                   ap.bairro,
                   ap.cidade,
                   ap.codigo_ibge,
                   ap.uf,
                   ap.cep,
                   fc.id               AS cliente_id,
                   fc.limite_credito,
                   fc.fincli_rota,
                   Min(apt.numero)     AS telefone,
                   Sum(ft.saldo)       AS total_em_aberto,
                   fc.active
            FROM   adm_pessoa             AS ap
            INNER JOIN financeiro_cliente AS fc  ON fc.pessoa_id = ap.id
            LEFT JOIN adm_pessoa_endereco AS ape ON ape.pessoa_id = ap.id
            LEFT JOIN adm_cidade          AS ac  ON ac.id = ape.cidade_id
            LEFT JOIN adm_pessoa_telefone AS apt ON apt.pessoa_id = ap.id
            LEFT JOIN financeiro_titulo   AS ft  ON ft.pessoa_id = ap.id
            WHERE fc.id IN %s
            GROUP  BY ap.id,
                      fc.id,
                      ft.pessoa_id
        """ % (cliente_ids)
        cr.execute(sql)
        res = cr.dictfetchall()
        return res

    def _gerar_arquivo_vendedores(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_adm_util = self.pool.get('adm.utils')
        # nro. de registros exportados
        regs = 0
        log = ''
        ep_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, context=context)
        vv_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'vendas.vendedor', context=context)
        s_arq = ''
        s_arq_msg = ''
        arq = True
        param_ids = self.pool.get('estoque.parametro').search(cr, uid, [('company_id', '=', ep_company_id)],
                                                              context=context)
        vendedor_ids = self.pool.get('vendas.vendedor').search(cr, uid, [('company_id', '=', vv_company_id),
                                                                         ('tipo', '=', 'I')], context=context)
        arq = False
        if vendedor_ids:
            if not param_ids:
                log += _('Parametros de estoque nao encontrados.')
            else:
                param = self.pool.get('estoque.parametro').browse(cr, uid, param_ids[0], context).arquivo_de_vendedores
                if param:
                    try:
                        arq = open(param, 'w')
                    except IOError as err:
                        raise osv.except_osv(_('Atencao'), _('%s' % str(err)))

        browse_vendas_vendedor = self.pool.get("vendas.vendedor").browse(cr, uid, vendedor_ids, context=context)
        for vendedor in browse_vendas_vendedor:
            codigo_vendedor = str(vendedor.id)
            codigo_vendedor = (codigo_vendedor or '').encode('ascii', 'ignore').translate(None, ',.;/\ -+_ {}[]')
            s_arq += codigo_vendedor.rjust(6, '0')[:6]
            s_arq += f_txt(obj_adm_util.admutl_remover_acentuacao(
                cr, uid, vendedor.pessoa_id.name), 40)
            s_arq += '\r\n'

            regs = regs + 1
            if not regs % 10:
                if arq:
                    arq.write(s_arq)
                    s_arq = ''

        if regs and arq:
            arq.write(s_arq)

        if arq:
            arq.close()

        return {'regs': regs,
                'log': log,
                'arquivo_vendedores': base64.encodestring(s_arq.encode('utf-8', 'strict')), }

    def _gerar_arquivo_de_kit(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        ep_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'estoque.produto',
                                                                       context=context)
        context['retorno_sem_codigo'] = True
        obj_adm_util = self.pool.get('adm.utils')
        s_arq = []
        # nro. de registros exportados
        regs = 0
        log = ''
        regs_kit = []
        obj_estoque_produto = self.pool.get('estoque.produto')
        # ler kits
        produtos_ids = obj_estoque_produto.search(cr, uid, [('company_id', '=', ep_company_id),
                                                            ('kit_de_produtos', '=', True),
                                                            ('tipo_kit', '=', 'I')],
                                                  context=context)

        kit_preco_venda = self.pool.get('estoque.preco.venda').get_preco_venda(cr, uid,
                                                                      produtos_ids, context=context)
        dados_produtos = obj_estoque_produto.read(cr, uid, produtos_ids, ['name'], context=context)
        for produto in dados_produtos:
            sql_kitpro = """
                SELECT kp.id,
                       kp.kitpro_produto_id         AS kitpro_kit_id,
                       acb.codigo_barra             AS acb_codigo_barra_kit,
                       kp.kitpro_item_produto_id,
                       kp.kitpro_grade_id,
                       kp.kitpro_produto_embalagem_id,
                       -- Busca apenas 1 codigo de barras para grades com mais de 1 cb
                       (SELECT acb2.codigo_barra 
                        FROM automacao_codigo_barra AS acb2
                        WHERE acb2.grade_id = kp.kitpro_grade_id
                          AND acb2.produto_embalagem_id = kp.kitpro_produto_embalagem_id
                          AND acb2.active = True
                        LIMIT 1)                    AS acb_codigo_barra_item_kit,
                       ep.name                      AS estpro_name,
                       kp.kitpro_quantidade         AS kitpro_quantidade,
                       kp.kitpro_preco_venda        AS kitpro_preco_venda
                FROM   kit_produto                AS kp
                INNER JOIN estoque_produto        AS ep  ON ep.id = kp.kitpro_produto_id
                INNER JOIN automacao_codigo_barra AS acb ON acb.produto_id = kp.kitpro_produto_id
                WHERE  kp.kitpro_produto_id = %s """ % produto.get('id')
            cr.execute(sql_kitpro)
            kitpro = cr.dictfetchall()
            if kitpro and isinstance(kitpro, list):
                pular_kit = False
                kit_ids = []
                for i in kitpro:
                    kit_ids.append(i.get('id'))
                    if not i.get('kitpro_preco_venda'):
                        pular_kit = True
                        break

                if pular_kit:
                    continue

                preco_total_kit_itens = get_preco_total_venda_itens_kit(self, cr, uid, kit_ids,
                                       context=context)
                for kit in kitpro:
                    supkit_codigo_barra_kit = kit.get('acb_codigo_barra_kit')
                    supkit_codigo_barra_item = kit.get('acb_codigo_barra_item_kit')
                    supkit_quantidade = kit.get('kitpro_quantidade')
                    supkit_preco_venda = preco_total_kit_itens.get(kit.get('id'))
                    if all([supkit_codigo_barra_kit, supkit_codigo_barra_item, supkit_quantidade,
                            supkit_preco_venda]):
                        s_arq.append(f_txt(supkit_codigo_barra_kit, 14))
                        s_arq.append(f_txt(obj_adm_util.admutl_remover_acentuacao(cr, uid,
                                                                      produto.get('name')), 25))
                        s_arq.append(f_txt(supkit_codigo_barra_item, 14))
                        s_arq.append(f_num(float(supkit_quantidade), 11, 3))
                        s_arq.append(f_num(float(supkit_preco_venda), 15, 2))
                        s_arq.append('\r\n')

                        regs_kit.append(supkit_codigo_barra_kit)
                        regs_kit = list(set(regs_kit))
                        regs = len(regs_kit)

        if regs > 0:
            param_ids = self.pool.get('estoque.parametro').search(cr, uid, [], context=context)
            if not param_ids:
                log += _('\nParametros de estoque nao encontrados.')
            else:
                param = self.pool.get('estoque.parametro').read(cr, uid, param_ids[0],
                                                                ['arquivo_de_kit'], context=context)
                if param['arquivo_de_kit']:
                    try:
                        arq = open(param['arquivo_de_kit'], 'w')
                        arq.write(''.join(s_arq))
                        arq.close()
                    except IOError as err:
                        raise osv.except_osv(_('Atencao'), _('%s' % str(err)))

        return {'regs': regs,
                'log': log,
                'arquivo_kit': base64.encodestring(''.join(s_arq).encode('utf-8', 'strict')), }

    def _criar_kit_supervisor_postgres(self, cr, uid, ids, estpar_company_id, usar_master,
                                       context=None):
        obj_adm_utils = self.pool.get('adm.utils')
        create_date = write_date = datetime.now()
        context = context and context.copy() or {}
        res = False
        fields_to_read = ['estpar_super_host', 'estpar_super_db', 'estpar_super_user',
                          'estpar_super_password', 'estpar_super_porta']
        parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque',
                                                                           fields_to_read, context=context)
        host = parametro_dados.get('estpar_super_host')
        porta = parametro_dados.get('estpar_super_porta') or 8069
        user = parametro_dados.get('estpar_super_user')
        password = parametro_dados.get('estpar_super_password') or ''
        db = parametro_dados.get('estpar_super_db')
        conn = False

        if not all([host, user, db, porta]):
            return res
        try:
            # CONEXAO COM O BANCO DE DADOS
            conn = psycopg2.connect(database=db, user=user, password=password, host=host, #SigLuiz
                                    connect_timeout=3)
            _cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
        except Exception as err:
            msg = _("Host: %s \nPorta: %s\nUsuario: %s \nBanco: %s\n"% (host, porta, user, db))
            if conn:
                conn.close()
            raise osv.except_osv(_('Atencao'),
                                 _('Nao foi possivel conectar ao Postgres do supervisor. \n%s' % msg +
                                                 'Verifique as informacoes nos parametros do '
                                                 'estoque.'))
        ep_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'estoque.produto', context=context)
        obj_estoque_produto = self.pool.get('estoque.produto')
        obj_supervisor_cad_itens = self.pool.get('supervisor.cad.itens')
        # ler kits
        produtos_ids = obj_estoque_produto.search(cr, uid, [('company_id', '=', ep_company_id),
                                                            ('kit_de_produtos', '=', True),
                                                            ('tipo_kit', '=', 'I')],
                                                  context=context)
        if not produtos_ids:
            if conn:
                conn.close()
            return res

        self.bloqueia_acao_pendente(_cr, uid, usar_master=usar_master, context=context)
        campo_kit_empresa = valor_empresa = cond_kit_empresa = cond_ite_empresa = ''
        if usar_master:
            valor_empresa = ', %s' % estpar_company_id
            campo_kit_empresa = ', supkit_nro_empresa'
            cond_kit_empresa = 'WHERE supkit_nro_empresa = %s' % estpar_company_id
            cond_ite_empresa = 'AND supite_nro_empresa = %s' % estpar_company_id

        _cr.execute('DELETE FROM supervisor_cad_kits %s' % cond_kit_empresa)

        kit_preco_venda = self.pool.get('estoque.preco.venda').get_preco_venda(cr, uid,
                                                                      produtos_ids, context=context)
        msg_kit = []
        for produto_id in produtos_ids:
            sql_kitpro = """
                SELECT kp.id,
                       kp.kitpro_quantidade         AS kitpro_quantidade,   
                       kp.kitpro_preco_venda        AS kitpro_preco_venda,
                       kp.kitpro_item_produto_id,
                       kp.kitpro_grade_id,
                       kp.kitpro_produto_embalagem_id,
                       acb.codigo_barra             AS acb_codigo_barra_kit,
                       -- Busca apenas 1 codigo de barras para grades com mais de 1 cb
                       (SELECT acb2.codigo_barra 
                        FROM automacao_codigo_barra AS acb2
                        WHERE acb2.grade_id = kp.kitpro_grade_id
                          AND acb2.produto_embalagem_id = kp.kitpro_produto_embalagem_id
                          AND acb2.active = True
                        LIMIT 1)                    AS acb_codigo_barra_item_kit,
                       ep.name                   AS estpro_name
                FROM   kit_produto                AS kp
                INNER JOIN estoque_produto        AS ep  ON ep.id = kp.kitpro_produto_id
                INNER JOIN automacao_codigo_barra AS acb ON acb.produto_id = kp.kitpro_produto_id
                WHERE  kp.kitpro_produto_id = {produto_id}""".format(produto_id=produto_id)
            cr.execute(sql_kitpro)
            kitpro = cr.dictfetchall()
            if kitpro and isinstance(kitpro, list):
                for kit_cb in list(set(map(lambda x: x.get('acb_codigo_barra_kit'), kitpro))):
                    kit_pro_aux = filter(lambda x: x.get('acb_codigo_barra_kit')==kit_cb, kitpro)
                    kit_ids = []
                    pular_kit = False
                    for i in kit_pro_aux:
                        kit_ids.append(i.get('id'))
                        if not i.get('kitpro_preco_venda'):
                            pular_kit = True
                            break

                    if pular_kit:
                        continue

                    try:
                        preco_total_kit_itens = get_preco_total_venda_itens_kit(self, cr, uid, kit_ids,
                                                              context=context)
                    except Exception as e:
                        msg_kit.append(str(e))
                        continue

                    for kit in kit_pro_aux:
                        supkit_loja = ep_company_id
                        supkit_codigo_barra_kit = kit.get('acb_codigo_barra_kit')
                        supkit_codigo_barra_item = kit.get('acb_codigo_barra_item_kit')
                        supkit_quantidade = kit.get('kitpro_quantidade')
                        supkit_preco_venda = preco_total_kit_itens.get(kit.get('id'))
                        # deve buscar o codigo do kit e do item no supervisor
                        _cr.execute(''' SELECT id
                                        FROM supervisor_cad_itens
                                        WHERE supite_codigo_item = '%s' 
                                          %s''' % (supkit_codigo_barra_kit, cond_ite_empresa))
                        dados_kit = obj_adm_utils.admutl_converts_fetchall_to_dictfetchall(_cr)

                        _cr.execute(''' SELECT id
                                        FROM supervisor_cad_itens
                                        WHERE supite_codigo_item = '%s' 
                                          %s''' % (supkit_codigo_barra_item, cond_ite_empresa))
                        dados_item = obj_adm_utils.admutl_converts_fetchall_to_dictfetchall(_cr)

                        if dados_kit and dados_item:
                            codigo_kit_id = dados_kit[0].get('id')
                            codigo_item_id = dados_item[0].get('id')
                            supkit_codigo_kit = codigo_kit_id
                            supkit_codigo_item = codigo_item_id

                            sql_insert_cad_kits = """
                INSERT INTO supervisor_cad_kits
                            (create_date, create_uid,
                            write_date, write_uid,
                            supkit_loja,
                            supkit_codigo_kit,
                            supkit_codigo_item,
                            supkit_codigo_barra_kit,
                            supkit_codigo_barra_item,
                            supkit_quantidade,
                            supkit_preco_venda {campo_kit_empresa})
                VALUES      ('{create_date}', {create_uid}, '{write_date}', {write_uid},
                              {supkit_loja}, {supkit_codigo_kit}, {supkit_codigo_item},
                             '{supkit_codigo_barra_kit}', '{supkit_codigo_barra_item}',
                              {supkit_quantidade}, {supkit_preco_venda} {supkit_nro_empresa})
                      """.format(campo_kit_empresa=campo_kit_empresa,
                                 create_date=create_date,
                                 create_uid=self.super_user_id,
                                 write_date=write_date,
                                 write_uid = self.super_user_id,
                                 supkit_loja=supkit_loja,
                                 supkit_codigo_kit=supkit_codigo_kit,
                                 supkit_codigo_item=supkit_codigo_item,
                                 supkit_codigo_barra_kit=supkit_codigo_barra_kit,
                                 supkit_codigo_barra_item=supkit_codigo_barra_item,
                                 supkit_quantidade=supkit_quantidade,
                                 supkit_preco_venda=supkit_preco_venda,
                                 supkit_nro_empresa=valor_empresa)
                            _cr.execute(sql_insert_cad_kits)

        _cr.connection.commit()
        self.desbloqueia_acao_pendente(_cr, uid, usar_master=usar_master, context=context)
        if conn:
            conn.close()
        return msg_kit

    def _criar_vendedores_supervisor_postgres(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        create_date = write_date = str(datetime.now())
        res = False
        fields_to_read = ['estpar_super_host', 'estpar_super_db', 'estpar_super_user',
                          'estpar_super_password', 'estpar_super_porta']
        parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque',
                                                                           fields_to_read, context=context)
        host = parametro_dados.get('estpar_super_host')
        porta = parametro_dados.get('estpar_super_porta') or 8069
        user = parametro_dados.get('estpar_super_user')
        password = parametro_dados.get('estpar_super_password') or ''
        db = parametro_dados.get('estpar_super_db')

        obj_adm_utils = self.pool.get('adm.utils')
        conn = False

        if all([host, user, db, porta]):
            try:
                # CONEXAO COM O BANCO DE DADOS
                conn = psycopg2.connect(database=db, user=user, password=password, host=host, #SigLuiz
                                        connect_timeout=3)
                _cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
            except Exception as err:
                if conn:
                    conn.close()
                msg = _("Host: %s \nPorta: %s\nUsuario: %s \nBanco: "% (host, porta, user, db))
                raise osv.except_osv(_('Atencao'),
                                     _('Nao foi possivel conectar ao Postgres do supervisor. \n%s' % msg +
                                       'Verifique as informacoes nos parametros do '
                                       'estoque.'))

            self.bloqueia_acao_pendente(_cr, uid, context=context)
            sql = """
                SELECT vendedor.id,
                       pessoa.nome
                FROM   vendas_vendedor vendedor
                       inner join adm_pessoa pessoa
                               ON pessoa.id = vendedor.pessoa_id
                GROUP  BY vendedor.id,
                          pessoa.nome  """
            cr.execute(sql)
            dados_vendedores = cr.dictfetchall()
            if dados_vendedores:
                for vendedor in dados_vendedores:
                    codigo_vendedor = vendedor.get('id')
                    nome_vendedor = obj_adm_utils.admutl_remover_acentuacao(cr, uid, vendedor.get('nome'))
                    nome_vendedor = nome_vendedor[:40]

                    sql_vend_id = """SELECT supven_codigo
                                     FROM   supervisor_cad_vendedor
                                     WHERE  supven_codigo = '%s' """ % codigo_vendedor
                    _cr.execute(sql_vend_id)
                    vend_id = obj_adm_utils.admutl_converts_fetchall_to_dictfetchall(_cr)

                    if vend_id:
                        update_vendedor = """UPDATE supervisor_cad_vendedor
                                             SET    write_date = '%s',
                                                    write_uid = %s,
                                                    supven_codigo = %s,
                                                    name = '%s'
                                             WHERE supven_codigo = %s
                        """ % (write_date, self.super_user_id, codigo_vendedor, nome_vendedor, codigo_vendedor)
                        _cr.execute(update_vendedor)
                        res = True
                    else:
                        insert_vendedor = """
                            INSERT INTO supervisor_cad_vendedor
                                        (supven_codigo,
                                        name,
                                        create_date, create_uid,
                                        write_date, write_uid)
                            VALUES      (%s, '%s', '%s', %s, '%s', %s)
                    """ % (codigo_vendedor, nome_vendedor, create_date, self.super_user_id, write_date,
                           self.super_user_id)
                        _cr.execute(insert_vendedor)
                        res = True
                        # TODAS AS OPERACOES SAO GRAVADAS EFETIVAMENTE NO BANCO DE DADOS
            _cr.connection.commit()
            self.desbloqueia_acao_pendente(_cr, uid, context=context)
        if conn:
            conn.close()
        return res

    def _criar_clientes_supervisor_postgres(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = self.read(cr, uid, ids[0] if isinstance(ids, list) else ids, context=context)
        create_date = write_date = datetime.now()
        res = False
        obj_adm_utils = self.pool.get('adm.utils')
        obj_financeiro_titulo = self.pool.get('financeiro.titulo')
        fields_to_read = ['estpar_super_host', 'estpar_super_db', 'estpar_super_user',
                          'estpar_super_password', 'estpar_super_porta']
        parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque',
                                                                           fields_to_read, context=context)

        host = parametro_dados.get('estpar_super_host')
        porta = parametro_dados.get('estpar_super_porta') or 8069
        user = parametro_dados.get('estpar_super_user')
        password = parametro_dados.get('estpar_super_password') or ''
        db = parametro_dados.get('estpar_super_db')
        conn= False

        if not all([host, user, db, porta]):
            msg = _("Host: %s \nPorta: %s\nUsuario: %s \nBanco: %s\n"% (host, porta, user, db))
            raise osv.except_osv(_('Atencao'),
                                 _('Nao foi possivel conectar ao Postgres do supervisor. \n%s' % msg +
                                   'Verifique as informacoes nos parametros '
                                   'do estoque.'))
        try:
            # CONEXAO COM O BANCO DE DADOS
            conn = psycopg2.connect(database=db, user=user, password=password, host=host,
                                    connect_timeout=3)
            _cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
        except Exception as err:
            if conn:
                conn.close()
            msg = _("Host: %s \nPorta: %s\nUsuario: %s \nBanco: %s\n"% (host, porta, user, db))
            raise osv.except_osv(_('Atencao'),
                                 _('Nao foi possivel conectar ao Postgres do supervisor. \n%s' % msg +
                                   'Verifique as informacoes nos parametros '
                                   'do estoque.\n %s' % err))

        fc_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'financeiro.cliente', context=context)
        cliente_ids = self.pool.get('financeiro.cliente').search(
            cr, uid, [('company_id', '=', fc_company_id)], context=context)
        if not cliente_ids:
            if conn:
                conn.close()
            return res

        self.bloqueia_acao_pendente(_cr, uid, context=context)
        dados_clientes = self.get_dados_cliente_postgres(cr, uid, cliente_ids, vals, context)
        list_clientes = []
        clientes_bloqueados = fincli_get_bloqueio(self, cr, uid, cliente_ids, context=context)
        if dados_clientes:
            _cr.execute("""TRUNCATE  supervisor_cad_clientes""")
        insert_cliente = """
        INSERT INTO supervisor_cad_clientes
            (supcli_cnpj_cpf, name, supcli_status, supcli_endereco,
            supcli_limite_compras, supcli_total_em_aberto,
            supcli_codigo_interno, supcli_insc_estadual,
            supcli_bairro, supcli_cidade, supcli_estado,
            supcli_cep, supcli_telefone, supcli_rota,
            supcli_tipo_pessoa, supcli_cod_municipio,
            supcli_endereco_numero, supcli_complemento, supcli_email,
            create_date, create_uid, write_date, write_uid)
        VALUES
        """
        inserts = []
        pessoas_ids = map(lambda i: i.get('pessoa_id'), dados_clientes)
        previsao_ids = self.pool.get('documento.documento.tipo').search(
            cr, uid, [('sigla', '=', 'PRV')], context=context)
        args = [('pessoa_id', 'in', pessoas_ids),
                ('state', '=', 'A'),  # Títulos em aberto
                ('tipo_titulo', '=', 'R'),
                ('doc_tipo_id', 'not in', previsao_ids)]  # Títulos à receber
        titulo_ids = obj_financeiro_titulo.search(cr, uid, args, context=context)
        saldo = obj_financeiro_titulo.read(cr, uid, titulo_ids, ['saldo', 'pessoa_id'],
                                           context=context, load='_classic_write')
        total_em_aberto = self._group_saldo(saldo)
        for cliente in dados_clientes:
            cliente_id = cliente.get('cliente_id')
            if not cliente_id in list_clientes:
                cpf_cnpj = cliente.get('cpf_cnpj')
                try:
                    cpf_cnpj_valido = int(obj_adm_utils.admutl_remove_caracter(
                        cpf_cnpj, letras=False, espaco=False))
                except:
                    cpf_cnpj_valido = False
                if cpf_cnpj_valido and cliente.get('nome'):
                    pessoa_id = cliente.get('pessoa_id')
                    cpf_cnpj = re_sub('[^0-9]', '', cpf_cnpj).rjust(15, '0')
                    # B=Bloqueado, L=Liberado
                    supcli_status = 'B' if clientes_bloqueados.get(cliente_id) != 'L' else 'L'
                    list_clientes.append(cliente_id)
                    cep = cliente.get('cep') or 'null'
                    cep = cep.replace('.', '').replace('-', '')
                    nome = cliente.get('nome')[:40].replace("'", '')
                    nome = obj_adm_utils.admutl_remover_acentuacao(cr, uid, nome)
                    endereco = self.remove_numero_endereco(cliente.get('endereco'))
                    endereco = obj_adm_utils.admutl_remover_acentuacao(cr, uid, endereco)
                    endereco = endereco[:90].replace("'", '')
                    total_aberto = total_em_aberto.get(pessoa_id) or 0
                    limite_compras = cliente.get('limite_credito') or 'null'
                    dif = (cliente.get('limite_credito') or 0 ) - total_aberto
                    if dif < 0:
                        limite_compras = 0

                    codigo_interno = int(re.sub('[^0-9]', '', str(cliente.get('codigo_interno') or 0)) or 0)
                    ie = cliente.get('admpes_jur_ie') or 'null'
                    ie = ie[:15]
                    bairro = cliente.get('bairro') or 'null'
                    bairro = obj_adm_utils.admutl_remover_acentuacao(cr, uid, bairro)
                    bairro = obj_adm_utils.admutl_remover_acentuacao(cr, uid, bairro[:20]).replace(
                        "'", " ")
                    cidade = cliente.get('cidade') or 'null'
                    cidade = obj_adm_utils.admutl_remover_acentuacao(cr, uid, cidade)
                    cidade = obj_adm_utils.admutl_remover_acentuacao(cr, uid, cidade[:30]).replace("'", '')
                    estado = obj_adm_utils.admutl_remover_acentuacao(cr, uid, cliente.get('uf') or 'null')
                    if estado != 'null':
                        estado = estado[:2]
                    telefone = cliente.get('telefone') or 'null'
                    telefone = telefone[:14]
                    rota = cliente.get('fincli_rota') or 'null'
                    pessoa_tipo = cliente.get('pessoa_tipo')
                    cod_municipio = cliente.get('codigo_ibge') or 'null'
                    numero = cliente.get('endereco') and cliente.get('endereco').split(', ') or ''
                    complemento = ''
                    if len(numero) > 1:
                        dados_numero = numero[1].split('-')
                        numero = dados_numero[0]
                        if len(dados_numero) > 1:
                            complemento = dados_numero[1]
                    else:
                        numero = False
                        complemento = ''

                    complemento = obj_adm_utils.admutl_remover_acentuacao(cr, uid, complemento or 'null')
                    complemento = obj_adm_utils.admutl_remove_caracter(complemento)
                    endereco_numero = obj_adm_utils.admutl_remover_acentuacao(cr, uid,
                                                                              numero or cliente.get('numero') or 'null')
                    endereco_numero = endereco_numero[:15]
                    email = cliente.get('email') or 'null'
                    email = email[:100]
                    sql = """
                ('{cpf_cnpj}', '{nome}', '{supcli_status}', '{endereco}', {limite_compras},
                {total_em_aberto}, {codigo_interno},
                '{ie}', '{bairro}', $${cidade}$$, '{estado}', '{cep}',
                '{telefone}', {rota}, '{pessoa_tipo}', {cod_municipio}, '{endereco_numero}', '{complemento}', '{email}',
                '{create_date}', {create_uid}, '{write_date}', {write_uid})
                """.format(cpf_cnpj=cpf_cnpj,
                           nome=nome,
                           supcli_status=supcli_status,
                           endereco=endereco,
                           limite_compras=limite_compras,
                           total_em_aberto=total_em_aberto.get(pessoa_id) or 'null',
                           codigo_interno=codigo_interno,
                           ie=ie,
                           bairro=bairro,
                           cidade=cidade,
                           estado=estado,
                           cep=cep,
                           telefone=telefone,
                           rota=rota,
                           pessoa_tipo=pessoa_tipo,
                           cod_municipio=cod_municipio,
                           endereco_numero=endereco_numero,
                           complemento=complemento,
                           email=email,
                           create_date=create_date,
                           create_uid=self.super_user_id,
                           write_date=write_date,
                           write_uid=self.super_user_id)
                    sql = sql.replace("'null'", 'null')
                    inserts.append(sql)
                    res = True

        insert_cliente += ','.join(inserts)
        if inserts:
            _cr.execute(insert_cliente)

        # Criar mensagens de clientes
        self._criar_mensagem_cliente_supervisor_postgres(cr, uid, _cr, cliente_ids, context)

        # TODAS AS OPERACOES SAO GRAVADAS EFETIVAMENTE NO BANCO DE DADOS
        _cr.connection.commit()
        self.desbloqueia_acao_pendente(_cr, uid, context=context)
        if conn:
            conn.close()
        return res

    @staticmethod
    def _group_saldo(dados):
        res = {}
        keyfunc = lambda i: i.get('pessoa_id')
        groups = it.groupby(sorted(dados, key=keyfunc), keyfunc)
        for k, g in groups:
            res.update({k: sum(x['saldo'] for x in g)})
        return res

    def _get_dados_mensagens(self, cr, uid, cliente_ids, context=None):
        context = context and context.copy() or {}
        if not cliente_ids:
            return []

        sql = """
            SELECT ap.cpf_cnpj,
                   fcmn.name,
                   fcmn.tipo_mensagem,
                   fcmn.codigo,
                   fcm.modo_exibicao,
                   fc.active
            FROM   adm_pessoa                            AS ap
            INNER JOIN financeiro_cliente                AS fc   ON fc.pessoa_id = ap.id
            INNER JOIN financeiro_clientes_mensagem      AS fcm  ON fcm.cliente_id = fc.id
            INNER JOIN financeiro_clientes_mensagem_nome AS fcmn ON fcmn.id = fcm.mensagens_id
            WHERE fc.id in (%s)
            GROUP  BY ap.cpf_cnpj,
                      fcmn.name,
                      fcmn.tipo_mensagem,
                      fcmn.codigo,
                      ap.write_date,
                      fc.active,
                      fcm.modo_exibicao
        """ % ','.join(map(lambda x: '%s' % x, cliente_ids))
        cr.execute(sql)
        return cr.dictfetchall()

    def _criar_mensagem_cliente_supervisor_postgres(self, cr, uid, _cr, cliente_ids, context=None):
        """
        Cria ou atualiza as mensagens dos clientes na tabela supervisor_cad_mensagens_clientes
        """
        context = context and context.copy() or {}
        if not cliente_ids:
            return True

        create_date = write_date = datetime.now()
        obj_adm_utils = self.pool.get('adm.utils')
        dados_mensagem_clientes = self._get_dados_mensagens(cr, uid, cliente_ids, context=context)
        if dados_mensagem_clientes:
            _cr.execute("""TRUNCATE  supervisor_cad_mensagens_clientes""")
        insert_mensagem = """
        INSERT INTO supervisor_cad_mensagens_clientes
               (supclm_cnpj_cpf,
                supclm_sequencia,
                supclm_mensagem,
                supclm_tipo,
                create_date, create_uid,
                write_date, write_uid)
        VALUES
        """
        inserts = []
        for msg in dados_mensagem_clientes:
            cnpj_cpf = msg.get('cpf_cnpj') or 'null'
            if cnpj_cpf != 'null':
                cnpj_cpf = re_sub('[^0-9]', '', cnpj_cpf)
                cnpj_cpf = cnpj_cpf[:15]
                sequencia = 0
                mensagem = msg.get('name') or 'null'
                mensagem = obj_adm_utils.admutl_remover_acentuacao(cr, uid, mensagem[:40])
                tipo = msg.get('tipo_mensagem') or 'null'
                tipo = tipo[:1]
                if tipo == 'B': # nao mostra motivo do bloqueio
                    mensagem = 'Mensagem nro: %s' % msg.get('codigo')

                sql = """
                ('{cnpj_cpf}', {sequencia}, '{mensagem}', '{tipo}',
                '{create_date}', {create_uid},
                '{write_date}', {write_uid})""".format(cnpj_cpf=cnpj_cpf,
                                                       sequencia=sequencia,
                                                       mensagem=mensagem,
                                                       tipo=tipo,
                                                       create_date=create_date,
                                                       create_uid=self.super_user_id,
                                                       write_date=write_date,
                                                       write_uid=self.super_user_id)
                sql = sql.replace("'null'", 'null')
                inserts.append(sql)

        if inserts:
            insert_mensagem += ','.join(inserts)
            _cr.execute(insert_mensagem)

        return True

    def bloqueia_acao_pendente(self, _cr, uid, usar_master=False, context=None):
        '''
         1 - Verifica se ja tem alguma acao pendente bloqueada pela ecf, se tiver duplica essta acao
         2 - Muda a situacao de todos os itens na tabela supervisor_mov_acao_pendente para 'B'
             (bloqueado) nao permitindo que o frente faca alguma atualizacao
        :param _cr: este cursor eh do banco do supervisor, que pode estar em outra maquina
        '''
        context = context and context.copy() or {}
        if usar_master: # quando usa o master, nao faz o controle de bloqueio de acao pendente
            return

        obj_adm_utils = self.pool.get('adm.utils')
        create_date = write_date = str(datetime.now())
        # 1
        sql = '''
            SELECT *
            FROM supervisor_mov_acao_pendente
            WHERE supape_situacao = 'B'
              '''
        res = _cr.execute(sql)
        ids_acao_pendente = obj_adm_utils.admutl_converts_fetchall_to_dictfetchall(_cr)
        _cr.execute('''BEGIN; ''')
        for i in ids_acao_pendente:
            supeape_loja = i.get('supeape_loja')
            supeape_pdv = i.get('supeape_pdv')
            supape_tabela = i.get('supape_tabela')
            supape_total_em_aberto_cliente = i.get('supape_total_em_aberto_cliente') or 0.0
            _cr.execute('''
                SELECT id
                FROM supervisor_mov_acao_pendente
                WHERE supeape_loja = {supeape_loja}
                  AND supeape_pdv = {supeape_pdv}
                  AND supape_tabela = '{supape_tabela}'
                  AND supape_situacao = 'B'
                       '''.format(supeape_loja=supeape_loja,
                                  supeape_pdv=supeape_pdv,
                                  supape_tabela=supape_tabela))
            # nao deixa que existam mais de 2 registro para uma mesma loja, pdv e tabela com situacao = 'B'
            if len(obj_adm_utils.admutl_converts_fetchall_to_dictfetchall(_cr)) > 1:
                continue
            sql = '''
                INSERT INTO supervisor_mov_acao_pendente
                    (create_date, create_uid, write_date, write_uid,
                    supeape_loja, supeape_pdv, supape_tabela, supape_situacao, supape_total_em_aberto_cliente)
                VALUES ('{create_date}', {create_uid}, '{write_date}', {write_uid},
                         {supeape_loja},  {supeape_pdv}, '{supape_tabela}', 'B', {supape_total_em_aberto_cliente});
                   '''.format(create_date=create_date,
                              create_uid=self.super_user_id,
                              write_date=write_date,
                              write_uid=self.super_user_id,
                              supeape_loja=supeape_loja,
                              supeape_pdv=supeape_pdv,
                              supape_tabela=supape_tabela,
                              supape_total_em_aberto_cliente=supape_total_em_aberto_cliente)
            _cr.execute(sql)
        # 2
        sql = '''
            UPDATE supervisor_mov_acao_pendente
            SET write_date = '%s',
                write_uid = %s,
                supape_situacao = 'B';
            COMMIT;
              ''' % (write_date, self.super_user_id)
        _cr.execute(sql)
        return

    def desbloqueia_acao_pendente(self, _cr, uid, usar_master=False, context=None):
        '''
        muda a situacao de todos os itens na tabela supervisor_mov_acao_pendente para 'A' permitindo
        o frente fazer atualizacao
        :param _cr: este cursor eh do bando do supervisor, que pode estar em outra maquina
        '''
        context = context and context.copy() or {}
        if usar_master: # quando usa o master, nao faz o controle de desbloqueio de acao pendente
            return

        write_date = datetime.now()
        write_uid = uid
        sql = '''
            BEGIN;
            UPDATE supervisor_mov_acao_pendente
            SET write_date = '%s',
                write_uid = %s,
                supape_situacao = 'A';
            COMMIT;
              ''' % (write_date, self.super_user_id)
        _cr.execute(sql)
        return

    def get_left_local_producao(self, context=None):
        """Implementado por heranca no modulo vendas_cozinha"""
        context = context and context.copy() or {}
        return ''

    def get_camp_local_producao(self, context=None):
        """Implementado por heranca no modulo vendas_cozinha"""
        context = context and context.copy() or {}
        return ''

    def _criar_itens_supervisor_postgres(self, cr, uid, ids, estpar_company_id, usar_master,
                                         context=None):
        context = context and context.copy() or {}
        fields_to_read = ['estpar_super_host', 'estpar_super_db', 'estpar_super_user',
                          'estpar_super_password', 'estpar_super_porta', 'estpar_super_loja']
        parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque',
                                                                           fields_to_read, context=context)
        create_date = write_date = str(datetime.now())

        host = parametro_dados.get('estpar_super_host')
        porta = parametro_dados.get('estpar_super_porta') or 8069
        user = parametro_dados.get('estpar_super_user')
        password = parametro_dados.get('estpar_super_password') or ''
        db = parametro_dados.get('estpar_super_db')
        loja = parametro_dados.get('estpar_super_loja')
        conn = False

        if not all([host, user, db, porta, loja]):
            raise osv.except_osv(_('Atencao'), _('Verifique as informacoes nos parametros '
                                                 'do estoque.'))
        else:
            try:
                # CONEXAO COM O BANCO DE DADOS
                conn = psycopg2.connect(database=db, user=user, password=password, host=host, #SigLuiz
                                        connect_timeout=3)
                _cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
            except Exception as err:
                if conn:
                    conn.close()
                msg = _("Host: %s \nPorta: %s\nUsuario: %s \nBanco: %s\n"% (host, porta, user, db))
                raise osv.except_osv(_('Atencao'),
                                     _('Nao foi possivel conectar ao Postgres do  supervisor. \n%s'
                                       % msg + 'Verifique as informacoes nos parametros '
                                       'do estoque.\n %s' % err))

        res = {'valor': False, 'mensagem': ''}
        mensagem = ''
        itens = False
        tributacao = False
        obj_adm_utils = self.pool.get('adm.utils')
        obj_estoque_produto = self.pool.get('estoque.produto')
        ep_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'estoque.produto', context=context)
        ap_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'automacao.precos', context=context)
        acb_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'automacao.codigo.barra', context=context)
        fields_to_read = ['arquivo_de_itens_ecf', 'arquivo_de_trib_ecf', 'arquivo_de_nserie',
                          'estpar_super_local_id', 'estpar_balanca_usar_tara', 'estpar_somente_ecf']
        parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque',
                                                                           fields_to_read, context=context)
        if not parametro_dados:
            if conn:
                conn.close()
            raise osv.except_osv(_('Atencao'), _('Parametros de estoque nao encontrados'))
        else:
            estpar_super_local_id = parametro_dados.get('estpar_super_local_id', False)

        camp_produto_de_balanca = ''
        camp_peso_tara = ''
        camp_nserie_tipo = ''

        fields_estoque_produto = self.pool.get('estoque.produto').fields_get(cr, uid,
                                                                             ['produto_de_balanca'])
        if fields_estoque_produto.get('produto_de_balanca'):
            camp_produto_de_balanca += """, ep.produto_de_balanca
                      """

        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'balanca', context=context):
            camp_peso_tara += """, ep.estpro_peso_tara
                      """
        estpro_nserie_tipo = obj_estoque_produto.fields_get(cr, uid, ['estpro_nserie_tipo'])
        if estpro_nserie_tipo.get('estpro_nserie_tipo'):
            camp_nserie_tipo += """, ep.estpro_nserie_tipo
                      """

        modulo_kit_instalado = obj_adm_utils.admutl_check_modulo_instalado(cr, uid, 'kit', context)
        cond_kit_produtos = ''
        cond_autpre_ja_exportou = ''
        cond_local_id = ''
        if modulo_kit_instalado:
            cond_kit_produtos += '''AND coalesce(ep.kit_de_produtos, False) = False'''

        exportar_itens = self.read(cr, uid, ids, ['exportar_itens'], context=context)[0].get('exportar_itens')
        if exportar_itens == 'P':
            cond_autpre_ja_exportou += '''AND ap.autpre_ja_exportou = False'''

        if estpar_super_local_id:
            cond_local_id += """AND ell.local_id IN (%s) """ % ','.join(map(lambda x: "%s" % x,
                                                                            estpar_super_local_id))
        camp_local_producao = self.get_camp_local_producao(context)
        sql = """
            SELECT acb.codigo_barra,
                   acb.company_id                               AS company_id,
                   ep.name,
                   ep.origem_mercadoria,
                   ep.active                                    AS produto_ativo,
                   ep.estpro_fator_conversao_unidade_tributavel AS fator_conversao,
                   1                                            AS departamento,
                   ft.tributacao_ecf,
                   epg.name                                     AS descricao,
                   epg.descricao_resumida,
                   (CASE WHEN ep.ncm_id IS NOT NULL
                         THEN fn.codigo
                         ELSE NULL
                    END)                                        AS ncm_codigo,
                   cest.fiscest_codigo                          AS cest_codigo,
                   (CASE WHEN ep.origem_mercadoria IN ('0','3','4','5', '8')
                         THEN fn.fisnc_aliq_ibpt_fed_nac
                         WHEN ep.origem_mercadoria IN ('1','2','6','7')
                         THEN fn.fisnc_aliq_ibpt_fed_imp
                         ELSE NULL
                    END)                                        AS aliquota_tributos_fed,
                   fn.fisnc_aliq_ibpt_est                       AS aliquota_tributos_est,
                   fn.fisnc_aliq_ibpt_mun                       AS aliquota_tributos_mun,
                   fn.fisnc_ibpt_chave                          AS chave_ibpt,
                   fca.fisanp_codigo                            AS codigo_anp,
                   fca.fisanp_adrem                             AS aliq_adrem,
                   fca.fisanp_pglp                              AS pglp, 
                   fca.fisanp_pgnn                              AS pgnn,
                   fca.fisanp_pgni                              AS pgni,
                   fca.fisanp_partida                           AS vpart,
                   eeu.fracao,
                   ap.preco_venda,
                   eeu.unidade,
                   ee.quantidade_na_embalagem,
                   acb.peso_embalagem,
                   ep.codigo                                    AS codigo_retaguarda,
                   ep.producao_propria,
                   ep.id                                        AS produto_id,
                   ep.estpro_med_codigo_anvisa                  AS med_codigo_anvisa,
                   ep.estpro_med_motivo_isencao                 AS med_motivo_isencao,
                   ep.estpro_med_preco_maximo                   AS med_preco_maximo,
                   acb.grade_id,
                   acb.active                                   AS acb_active,
                   acb.autcba_tipo_barra                        AS tipo_gtin,
                   ap.id                                        AS automacao_precos_id,
                   ap.autpre_ja_exportou
                   {camp_produto_de_balanca}
                   {camp_peso_tara}
                   {camp_nserie_tipo}
                   {camp_local_producao}
            FROM automacao_precos                 AS ap
            INNER JOIN automacao_codigo_barra     AS acb  ON acb.id = ap.codigo_barra_id
            INNER JOIN estoque_produto            AS ep   ON ep.id = acb.produto_id
            INNER JOIN estoque_produto_grade      AS epg  ON epg.id = acb.grade_id
            INNER JOIN estoque_produto_embalagem  AS epe  ON epe.id = acb.produto_embalagem_id
            INNER JOIN estoque_embalagem          AS ee   ON ee.id = epe.embalagem_id
            INNER JOIN estoque_embalagem_unidade  AS eeu  ON eeu.id = ee.unidade_id
            INNER JOIN fiscal_tributacao_encargos AS fte  ON fte.produto_id = ep.id
            INNER JOIN fiscal_tributacao          AS ft   ON ft.id = fte.tributacao_id
            INNER JOIN fiscal_ncm                 AS fn   ON fn.id = ep.ncm_id
            LEFT  JOIN fiscal_cest                AS cest ON cest.id = ep.estpro_cest_id
            LEFT  JOIN fiscal_cadastro_anp        AS fca  ON fca.id = ep.estpro_codigo_anp_id 
            INNER JOIN fiscal_encargo             AS fe   ON fe.id = fte.encargo_id
            INNER JOIN estoque_local_locacao      AS ell  ON ell.grade_id = epg.id
            {left_loca_producao}
            WHERE fte.tipo_tributacao = 'T'
              AND fe.sigla IN ('ICMS','ISS')
              AND ap.company_id = {ap_company_id}
              AND acb.company_id = {acb_company_id}
              {cond_kit_produtos}
              {cond_autpre_ja_exportou}
              {cond_local_id}
            ORDER BY acb.codigo_barra
                 """.format(camp_produto_de_balanca = camp_produto_de_balanca,
                            camp_peso_tara = camp_peso_tara,
                            camp_nserie_tipo = camp_nserie_tipo,
                            ap_company_id=ap_company_id,
                            acb_company_id=acb_company_id,
                            cond_kit_produtos=cond_kit_produtos,
                            cond_autpre_ja_exportou=cond_autpre_ja_exportou,
                            cond_local_id=cond_local_id,
                            left_loca_producao=self.get_left_local_producao(context),
                            camp_local_producao=camp_local_producao)
        cr.execute(sql)
        dados_produtos = cr.dictfetchall()

        if modulo_kit_instalado:
            campos_kit = ''
            condicao_kit = ''
            if obj_adm_utils.admutl_check_modulo_instalado(cr, uid, 'balanca', context):
                campos_kit += ''', ep.estpro_peso_tara '''
            if exportar_itens == 'P':
                condicao_kit += '''AND ap.autpre_ja_exportou = False'''

            sql_kit = """SELECT DISTINCT(acb.codigo_barra),
                                acb.company_id          AS company_id,
                                ep.name,
                                ep.origem_mercadoria,
                                CASE WHEN (SELECT COUNT(epe2.id)
                                           FROM estoque_produto AS epe2 
                                           WHERE epe2.id = kp.kitpro_item_produto_id
                                             AND epe2.active = False) > 0 
                                     THEN FALSE 
                                     ELSE ep.active  
                                END                     AS produto_ativo,
                                ep.grade_usar,
                                ft.tributacao_ecf,
                                epg.name                AS descricao,
                                epg.descricao_resumida,
                                acb.active              AS acb_active,
                                ep.kit_de_produtos,
                                acb.peso_embalagem,
                                ap.id                   AS automacao_precos_id,
                                ap.preco_venda,
                                ap.autpre_ja_exportou,
                                ep.producao_propria,
                                ep.codigo               AS codigo_retaguarda,
                                fca.fisanp_codigo       AS codigo_anp,
                                fca.fisanp_adrem        AS aliq_adrem,
                                fca.fisanp_pglp         AS pglp, 
                                fca.fisanp_pgnn         AS pgnn,
                                fca.fisanp_pgni         AS pgni,
                                fca.fisanp_partida      AS vpart,
                                ep.id                   AS produto_id,
				                acb.grade_id,
				                fn.codigo               AS ncm_codigo,
                                cest.fiscest_codigo     AS cest_codigo,
                                (CASE WHEN ep.origem_mercadoria IN ( '0', '3', '4', '5', '8' )
                                      THEN fn.fisnc_aliq_ibpt_fed_nac
                                      WHEN ep.origem_mercadoria IN ( '1', '2', '6', '7' )
                                      THEN fn.fisnc_aliq_ibpt_fed_imp
                                      ELSE NULL
                                  END )                 AS aliquota_tributos_fed,
                                fn.fisnc_aliq_ibpt_est  AS aliquota_tributos_est,
                                fn.fisnc_aliq_ibpt_mun  AS aliquota_tributos_mun,
                                fn.fisnc_ibpt_chave     AS chave_ibpt,
                                eeu.fracao,
                                eeu.unidade,
                                ee.quantidade_na_embalagem
                                {campos_kit}
                                {camp_produto_de_balanca}
                                {camp_peso_tara}
                         FROM kit_produto                      AS kp
                         INNER JOIN estoque_produto            AS ep   ON ep.id = kp.kitpro_produto_id
                         INNER JOIN automacao_codigo_barra     AS acb  ON acb.produto_id = kp.kitpro_produto_id
                         INNER JOIN estoque_produto_grade      AS epg  ON acb.grade_id = epg.id
                         INNER JOIN estoque_produto_embalagem  AS epe  ON epe.id = acb.produto_embalagem_id
                         INNER JOIN estoque_embalagem          AS ee   ON ee.id = epe.embalagem_id
                         INNER JOIN estoque_embalagem_unidade  AS eeu  ON eeu.id = ee.unidade_id
                         INNER JOIN fiscal_tributacao_encargos AS fte  ON fte.produto_id = ep.id
                         INNER JOIN fiscal_tributacao          AS ft   ON ft.id = fte.tributacao_id
                         INNER JOIN fiscal_ncm                 AS fn   ON fn.id = ep.ncm_id
                         INNER JOIN fiscal_encargo             AS fe   ON fe.id = fte.encargo_id
                         LEFT  JOIN fiscal_cest                AS cest ON cest.id = ep.estpro_cest_id
                         LEFT  JOIN fiscal_cadastro_anp        AS fca  ON fca.id = ep.estpro_codigo_anp_id 
                         INNER JOIN automacao_precos           AS ap   ON ap.codigo_barra_id = acb.id
                         WHERE ep.company_id = {ep_company_id}
                           AND ap.company_id = {ap_company_id}
                           AND acb.company_id = {acb_company_id}
                           AND fte.tipo_tributacao = 'T'
                           AND fe.sigla IN ('ICMS','ISS')
                           {condicao_kit}
                         ORDER BY acb.codigo_barra """.format(campos_kit=campos_kit,
                                                              camp_produto_de_balanca=camp_produto_de_balanca,
                                                              camp_peso_tara=camp_peso_tara,
                                                              ap_company_id=ap_company_id,
                                                              acb_company_id=acb_company_id,
                                                              ep_company_id=ep_company_id,
                                                              condicao_kit=condicao_kit)
            cr.execute(sql_kit)
            res_kits = cr.dictfetchall()
            for res_kit in res_kits:
                dados_produtos.append(res_kit)

        self.bloqueia_acao_pendente(_cr, uid, usar_master=True, context=context)
        auto_ids = []
        produto_ids = []
        for i in dados_produtos:
            auto_ids.append(i.get('automacao_precos_id'))
            produto_ids.append('%s' % i.get('produto_id'))

        usa_tara = False
        if obj_adm_utils.admutl_check_modulo_instalado(cr, uid, 'balanca', context):
            usa_tara = parametro_dados.get('estpar_balanca_usar_tara')

        campo_emrpesa = cond_tri_empresa = valor_empresa = cond_ite_empresa = cond_ite2_empresa =\
            cond_kit_empresa = ''
        if usar_master:
            campo_emrpesa = ', supite_nro_empresa'
            cond_tri_empresa = 'WHERE suptri_nro_empresa = %s' % estpar_company_id
            cond_ite_empresa = 'WHERE supite_nro_empresa = %s' % estpar_company_id
            cond_ite2_empresa = 'AND supite_nro_empresa = %s' % estpar_company_id
            cond_kit_empresa = 'AND supkit_nro_empresa = %s' % estpar_company_id
            valor_empresa = ', %s' % estpar_company_id

        sql_insert_supervisor_cad_itens = """
            INSERT INTO supervisor_cad_itens
                (create_date, create_uid, write_date, write_uid, supite_loja,
                 supite_codigo_retaguarda, supite_codigo_item, name, supite_origem_mercadoria,
                 supite_codigo_anp, supite_adrem, supite_pglp, supite_pgnn, supite_pgni, supite_vpart,
                 supite_getin, supite_med_codigo_anvisa, supite_med_motivo_isencao, supite_med_preco_maximo,
                 supite_pesavel, supite_fracionado, supite_unidade,
                 supite_peso_da_embalagem, supite_peso_tara,
                 supite_producao, supite_iat, supite_ncm, supite_cest, supite_preco, active,
                 supite_aliquota_ibpt_fed, supite_aliquota_ibpt_est, supite_aliquota_ibpt_mun,
                 supite_ibpt_chave, supite_tributacao_id,
                 supite_descricao_completa, supite_fator_multiplicador,
                 supite_tributacao_pis_id, supite_tributacao_cofins_id, supite_tributacao_icms_id 
                 {empresa} {codigo_local})
            VALUES
        """.format(empresa=campo_emrpesa, codigo_local=(camp_local_producao and
                                                        ', supite_codigo_local' or ''))
        inserts = list()
        codigo_barra_company = dict()


        sql_tributacao_isento = """
            SELECT id,
                   suptri_tipo_tributacao   AS tipo_trib,
                   suptri_codigo_trib_retag AS cod_retarguarda
            FROM   supervisor_cad_tributacao
            {cond}
            """.format(cond=cond_tri_empresa)

        _cr.execute(sql_tributacao_isento)
        dados_trib = obj_adm_utils.admutl_converts_fetchall_to_dictfetchall(_cr)
        dict_tibutacao = {}
        for trib in dados_trib:
            if trib.get('tipo_trib') in ('I', 'F', 'N'):
                dict_tibutacao[trib.get('tipo_trib')] = trib.get('id')
                dict_tibutacao[trib.get('cod_retarguarda')] = trib.get('id')
            else:
                dict_tibutacao[trib.get('cod_retarguarda')] = trib.get('id')

        codigos_tributacao = []
        if exportar_itens == 'P':
            _cr.execute("SELECT suptnf_codigo, id FROM supervisor_cad_tributacao_nfce;")
            for i in obj_adm_utils.admutl_converts_fetchall_to_dictfetchall(_cr):
                codigos_tributacao.append(i.get('suptnf_codigo'))

        else:
            _cr.execute("TRUNCATE supervisor_cad_tributacao_nfce CASCADE")

        sql = """
            SELECT ft.id                  AS codigo_trib,
                   ft.aliquota            AS aliquota,
                   ft.base                AS base,
                   ft.fistri_aliquota_fcp AS aliquota_fcp,
                   fc.tipo                AS tipo_tributacao,
                   fc.codigo              AS codigo_cst,
                   fe.sigla               AS encargo,
                   csosn2.codigo          AS csosn_nao,
                   fte.produto_id         AS produto_id
        
            FROM fiscal_tributacao                AS ft  
            INNER JOIN fiscal_tributacao_encargos AS fte    ON fte.tributacao_id = ft.id 
            INNER JOIN fiscal_encargo             AS fe     ON fe.id = fte.encargo_id
            INNER JOIN fiscal_cst                 AS fc     ON fc.id = fte.cst_id
            LEFT JOIN fiscal_csosn                AS csosn2 ON csosn2.id = fc.fiscst_csosn_nao_contribuinte_id
            WHERE fte.tipo_tributacao = 'T' -- 'T' = Todas/Consumidor Final
              AND fte.produto_id IN (%s)
              AND fe.sigla IN ('PIS','COFINS','ICMS','ISS')
              """ % ','.join(produto_ids)
        dados_trib_nfce = []
        if produto_ids:
            cr.execute(sql)
            dados_trib_nfce = cr.dictfetchall()

        sql = """
            INSERT INTO supervisor_cad_tributacao_nfce 
                       (create_date, create_uid, write_date, write_uid,
                        suptnf_codigo, suptnf_aliquota, suptnf_base, suptnf_encargo,
                        suptnf_codigo_cst, suptnf_codigo_csosn, suptnf_tipo_tributacao,
                        suptnf_aliquota_fcp, suptnf_motivo_beneficio)
            VALUES %s        
              """
        dados_insert = []
        dict_encargos = {'PIS': 'P', 'COFINS': 'C', 'ICMS': 'I', 'ISS': 'S'}

        prod_trib = {}
        for i in dados_trib_nfce:
            codigo_trib = i.get('codigo_trib')
            prod_trib['%s-%s' % (i.get('produto_id'), i.get('encargo'))] = i.get('codigo_trib')
            if codigo_trib in codigos_tributacao:
                continue

            codigos_tributacao.append(codigo_trib)
            csosn = 'null'
            if i.get('csosn_nao'):
                csosn = "'%s'" % i.get('csosn_nao')

            dados_insert.append("""('{create_date}', {create_uid}, '{write_date}', {write_uid},
                                     {suptnf_codigo}, {suptnf_aliquota}, {suptnf_base}, '{suptnf_encargo}',
                                    '{suptnf_codigo_cst}', {suptnf_codigo_csosn}, '{suptnf_tipo_tributacao}',
                                     {suptnf_aliquota_fcp}, '{suptnf_motivo_beneficio}')"""
                                .format(create_date=create_date,
                                        create_uid=self.super_user_id,
                                        write_date=write_date,
                                        write_uid=self.super_user_id,
                                        suptnf_codigo=codigo_trib,
                                        suptnf_aliquota=i.get('aliquota') or 0,
                                        suptnf_base=i.get('base') or 0,
                                        suptnf_aliquota_fcp=i.get('aliquota_fcp') or 0,
                                        suptnf_encargo=dict_encargos.get(i.get('encargo')),
                                        suptnf_codigo_cst=i.get('codigo_cst'),
                                        suptnf_codigo_csosn=csosn,
                                        suptnf_tipo_tributacao=i.get('tipo_tributacao'),
                                        suptnf_motivo_beneficio='9'))

        if dados_insert:
            _cr.execute(sql % ', \n'.join(dados_insert[:30000]))
            if dados_insert[30000:60000]:
                _cr.execute(sql % ', \n'.join(dados_insert[30000:60000]))
                if dados_insert[60000:]:
                    _cr.execute(sql % ', \n'.join(dados_insert[60000:]))

        dict_trib_nfce = {}
        _cr.execute("SELECT suptnf_codigo, id, suptnf_tipo_tributacao FROM supervisor_cad_tributacao_nfce;")
        for i in obj_adm_utils.admutl_converts_fetchall_to_dictfetchall(_cr):
            dict_trib_nfce[i.get('suptnf_codigo')] = i
        # string com os itens que serao deletados do supervisor para depois serem inseridos
        codigo_itens = []
        msg_sem_preco = []
        msg_sem_ncm = []
        msg_sem_cest = []
        msg_sem_icms = []
        msg_sem_pis = []
        msg_sem_cofins = []
        msg_preco_invalido = []
        msg_anp = []
        somente_ecf = parametro_dados.get('estpar_somente_ecf')
        for produto in dados_produtos:
            key_cb_company = str(produto.get('company_id')) + '-' + produto.get('codigo_barra')
            if codigo_barra_company.get(key_cb_company):
                continue

            chave1 = '%s-%s' % (produto.get('produto_id'), 'ICMS')
            chave2 = '%s-%s' % (produto.get('produto_id'), 'ISS')
            icms_iss_id = False
            tipo_trib = False
            if prod_trib.get(chave1):
                tipo_trib = dict_trib_nfce.get(prod_trib.get(chave1)).get('suptnf_tipo_tributacao')
                icms_iss_id = dict_trib_nfce.get(prod_trib.get(chave1)).get('suptnf_codigo')
            elif prod_trib.get(chave2):
                icms_iss_id = dict_trib_nfce.get(prod_trib.get(chave2)).get('suptnf_codigo')

            chave1 =  '%s-%s' % (produto.get('produto_id'), 'PIS')
            pis_id = False
            if prod_trib.get(chave1):
                pis_id = dict_trib_nfce.get(prod_trib.get(chave1)).get('suptnf_codigo')

            chave1 =  '%s-%s' % (produto.get('produto_id'), 'COFINS')
            cofins_id = False
            if prod_trib.get(chave1):
                cofins_id = dict_trib_nfce.get(prod_trib.get(chave1)).get('suptnf_codigo')

            name_completo = produto.get('descricao') or 'null'
            name_completo = name_completo.replace("'", '')
            supite_descricao_completa = obj_adm_utils.admutl_remover_acentuacao(cr, uid, name_completo[:60])
            supite_codigo_item = produto.get('codigo_barra') or 'null'
            supite_codigo_item = supite_codigo_item[:14]
            tem_msg = False
            if not icms_iss_id and not somente_ecf:
                msg_sem_icms.append('\n%s - %s' % (supite_descricao_completa, supite_codigo_item))
                tem_msg = True

            if not pis_id and not somente_ecf:
                msg_sem_pis.append('\n%s - %s' % (supite_descricao_completa, supite_codigo_item))
                tem_msg = True

            if not cofins_id and not somente_ecf:
                msg_sem_cofins.append('\n%s - %s' % (supite_descricao_completa, supite_codigo_item))
                tem_msg = True

            codigo_barra_company[key_cb_company] = True
            itens = True
            supite_loja = loja
            supite_codigo_retaguarda = produto.get('codigo_retaguarda') or 'null'
            codigo_itens.append(supite_codigo_item)
            supite_fator_multiplicador = produto.get('fator_conversao') or 1
            name = produto.get('descricao_resumida') or produto.get('descricao') or 'null'
            name = name.replace("'", '')
            name = obj_adm_utils.admutl_remover_acentuacao(cr, uid, name)[:30]
            supite_pesavel = produto.get('produto_de_balanca') or 'null'
            supite_fracionado = produto.get('fracao') or 'null'
            supite_unidade = obj_adm_utils.admutl_remover_acentuacao(cr, uid, produto.get('unidade') or 'null')
            supite_peso_da_embalagem = produto.get('peso_embalagem') or 'null'
            supite_codigo_local = ''
            if camp_local_producao:
                supite_codigo_local = ", '%s'" % (produto.get('codigo_local_producao') or 'null')

            kit_de_produtos = produto.get('kit_de_produtos')
            supite_peso_tara = 'null'
            if usa_tara:
                supite_peso_tara = produto.get('estpro_peso_tara') or 'null'

            supite_producao = produto.get('producao_propria') and 'P' or 'T'
            supite_iat = 'A'
            supite_cest = 'null'
            if not produto.get('ncm_codigo') and not somente_ecf:
                msg_sem_ncm.append('\n%s - %s' % (supite_descricao_completa, supite_codigo_item))
                tem_msg = True

            if tipo_trib in ('U', 'TU') and not produto.get('cest_codigo') and not somente_ecf:
                msg_sem_cest.append('\n%s - %s' % (supite_descricao_completa, supite_codigo_item))
                tem_msg = True

            supite_preco = produto.get('preco_venda')
            if not supite_preco:
                msg_sem_preco.append('\n%s - %s' % (supite_descricao_completa, supite_codigo_item))
                tem_msg = True

            elif supite_preco > 10000000 or len(("%s" % (supite_preco * 100)).split('.')) > 1 and \
                            int(("%s" % (supite_preco * 100)).split('.')[1]) >= 1:
                msg_preco_invalido.append(_('\n%s - %s Preco invalido') %
                                          (supite_descricao_completa, supite_codigo_item))
                tem_msg = True

            if produto.get('codigo_anp') == '210203001':
                if (produto.get('pglp') or 0) + (produto.get('pgnn') or 0) + \
                                                                   (produto.get('pgni') or 0) < 100:
                    msg_anp.append(_('%s - %s') % (supite_descricao_completa, supite_codigo_item))
                    tem_msg = True

            supite_ncm = produto.get('ncm_codigo') and (produto.get('ncm_codigo')).ljust(8, '0') or ''
            if produto.get('cest_codigo'):
                supite_cest = f_txt(produto.get('cest_codigo'), 7)

            active = produto.get('produto_ativo') or False
            if active:
                if not produto.get('acb_active') or produto.get('acb_active') == 'F':
                    active = False

            if tem_msg:
                continue

            supite_aliquota_ibpt_fed = produto.get('aliquota_tributos_fed') or 0.0
            supite_aliquota_ibpt_est = produto.get('aliquota_tributos_est') or 0.0
            supite_aliquota_ibpt_mun = produto.get('aliquota_tributos_mun') or 0.0
            supite_ibpt_chave = produto.get('chave_ibpt') or ''
            tributacao_ecf = produto.get('tributacao_ecf') or ''
            tributacao_ecf1 = '0%s' % tributacao_ecf
            tributacao_id = dict_tibutacao.get(tributacao_ecf)
            if not tributacao_id:
                tributacao_id = dict_tibutacao.get(tributacao_ecf1)

            if not tributacao_id:
                auto_ids.remove(produto.get('automacao_precos_id'))
                mensagem += '\n %s - %s' % (supite_descricao_completa, supite_codigo_item)

            else:
                sql_cad_itens = """
                    ('{create_date}', {create_uid}, '{write_date}', {write_uid},
                     {supite_loja}, '{supite_codigo_retaguarda}', '{supite_codigo_item}', '{name}', 
                     '{origem_mercadoria}', {supite_codigo_anp}, {supite_adrem}, {supite_pglp}, {supite_pgnn},
                     {supite_pgni}, {supite_vpart}, {supite_getin},
                     '{supite_med_codigo_anvisa}', '{supite_med_motivo_isencao}', {supite_med_preco_maximo},
                     {supite_pesavel}, {supite_fracionado}, '{supite_unidade}',
                     {supite_peso_da_embalagem}, {supite_peso_tara},
                     '{supite_producao}', '{supite_iat}', '{supite_ncm}', '{supite_cest}', {supite_preco},
                     '{active}',
                     {supite_aliquota_ibpt_fed}, {supite_aliquota_ibpt_est}, {supite_aliquota_ibpt_mun},
                     '{supite_ibpt_chave}', {supite_tributacao_id}, '{supite_descricao_completa}',
                     {supite_fator_multiplicador}, {supite_tributacao_pis_id}, {supite_tributacao_cofins_id}, 
                     {supite_tributacao_icms_id} {valor_empresa} {supite_codigo_local})""".\
                    format(create_date = create_date,
                           create_uid = self.super_user_id,
                           write_date = write_date,
                           write_uid = self.super_user_id,
                           supite_loja = supite_loja,
                           supite_codigo_retaguarda = supite_codigo_retaguarda,
                           supite_codigo_item = supite_codigo_item,
                           name = name,
                           origem_mercadoria=produto.get('origem_mercadoria') or 'null',
                           supite_getin=produto.get('tipo_gtin') != 'OT',
                           supite_med_codigo_anvisa=produto.get('med_codigo_anvisa') or 'null',
                           supite_med_motivo_isencao=produto.get('med_motivo_isencao') or 'null',
                           supite_med_preco_maximo=produto.get('med_preco_maximo') or 0,
                           supite_codigo_anp=int((produto.get('codigo_anp') or '').replace(' ', '') or 0) or 'null',
                           supite_adrem=produto.get('aliq_adrem') or 0,
                           supite_pglp=produto.get('pglp') or 0,
                           supite_pgnn=produto.get('pgnn') or 0,
                           supite_pgni=produto.get('pgni') or 0,
                           supite_vpart=produto.get('vpart') or 0,
                           supite_pesavel = supite_pesavel,
                           supite_fracionado = supite_fracionado,
                           supite_unidade = supite_unidade,
                           supite_peso_da_embalagem = supite_peso_da_embalagem,
                           supite_peso_tara = supite_peso_tara,
                           supite_producao = supite_producao,
                           supite_iat = supite_iat,
                           supite_ncm = supite_ncm,
                           supite_cest = supite_cest,
                           supite_preco = supite_preco,
                           active = active,
                           supite_aliquota_ibpt_fed = supite_aliquota_ibpt_fed,
                           supite_aliquota_ibpt_est = supite_aliquota_ibpt_est,
                           supite_aliquota_ibpt_mun = supite_aliquota_ibpt_mun,
                           supite_ibpt_chave = supite_ibpt_chave,
                           supite_tributacao_id = tributacao_id,
                           supite_descricao_completa = supite_descricao_completa,
                           supite_fator_multiplicador=supite_fator_multiplicador,
                           supite_tributacao_icms_id=icms_iss_id or 'null',
                           supite_tributacao_pis_id=pis_id or 'null',
                           supite_tributacao_cofins_id=cofins_id or 'null',
                           valor_empresa=valor_empresa,
                           supite_codigo_local=supite_codigo_local)
                sql_cad_itens = sql_cad_itens.replace("'null'", 'null')
                inserts.append(sql_cad_itens)
                tributacao = True

        if dados_produtos:
            str_codigo_itens = "'" + "','".join(codigo_itens) + "'"
            sql_delete = """DELETE FROM supervisor_cad_itens {cond}""".format(cond=cond_ite_empresa)
            # para carga Parcial deleta apenas os itens que tiveram alteracao
            if exportar_itens == 'P':
                if cond_ite_empresa:
                    sql_delete += """ AND supite_codigo_item IN (%s)""" % str_codigo_itens
                else:
                    sql_delete += """WHERE supite_codigo_item IN (%s)""" % str_codigo_itens

            # os kits devem ser deletados antes de deletar os itens e a carga deve ser sempre de
            # itens e kits
            _cr.execute("""SELECT id 
                           FROM supervisor_cad_kits 
                           WHERE (supkit_codigo_barra_kit IN ({cb}) 
                              OR supkit_codigo_barra_item IN ({cb})) 
                             {cond}""".format(cb=str_codigo_itens,
                                              cond=cond_kit_empresa))
            dados_kit = obj_adm_utils.admutl_converts_fetchall_to_dictfetchall(_cr)
            if dados_kit:
                self.exporta_kit = True
                kit_ids = map(lambda x: '%s' % x.get('id'), dados_kit)
                _cr.execute("""DELETE FROM supervisor_cad_kits 
                               WHERE id IN ({ids}) 
                                 {cond}
                            """.format(ids=', '.join(kit_ids),
                                       cond=cond_kit_empresa))

            _cr.execute(sql_delete)

        if inserts:
            sql_insert_supervisor_cad_itens += ','.join(inserts)
            open("/tmp/teste.sql","w").write(sql_insert_supervisor_cad_itens)
            _cr.execute(sql_insert_supervisor_cad_itens)

        cr.commit() # este commit foi colocado para evitar acesso concorrente na criacao dos logs
        if dados_produtos and auto_ids:
            vals_automacao = {'autpre_ja_exportou': True}
            # o sql foi trocado para evitar erros de concorrencia
            self.pool.get('automacao.precos').write(cr, uid, auto_ids, vals_automacao, context=context)

        msg = ''
        if not itens or not inserts:
            msg += _('\nNao ha itens para exportacao.')

        if msg_sem_preco:
            msg += _('\nOs itens abaixo nao possuem preco: %s') % ''.join(msg_sem_preco)

        if msg_preco_invalido:
            msg += _('\nOs itens abaixo possuem preco invalido: %s') % ''.join(msg_preco_invalido)

        if msg_sem_ncm:
            msg += _('\nOs itens abaixo nao possuem NCM: %s') % ''.join(msg_sem_ncm)

        if msg_sem_cest:
            msg += _('\nOs itens abaixo nao possuem CEST: %s') % ''.join(msg_sem_cest)

        if msg_sem_icms:
            msg += _('\nOs itens abaixo nao possuem ICMS: %s') % ''.join(msg_sem_icms)

        if msg_sem_pis:
            msg += _('\nOs itens abaixo nao possuem PIS: %s') % ''.join(msg_sem_pis)

        if msg_sem_cofins:
            msg += _('\nOs itens abaixo nao possuem COFINS: %s') % ''.join(msg_sem_cofins)

        if msg_anp:
            msg += _('\n Somatorio percentuais de GLP derivado do petroleo,'
                     ' GLGNn e GLGNi diferente de 100\n%s') % '\n'.join(msg_anp)

        if mensagem:
            msg += _('\nOs itens abaixo nao foram exportados. Verifique a Tributacao na '
                            'ECF para os tributos dos itens. Verifique o cadastro de '
                            'tributacao no supervisor.') + mensagem
        if msg:
            res['mensagem'] = msg

        if itens and tributacao:
            res['valor'] = True

        _cr.execute("""SELECT id 
                       FROM ir_module_module 
                       WHERE name = 'supervisor_comanda'
                         AND state = 'installed';""")
        comanda_instalado = obj_adm_utils.admutl_converts_fetchall_to_dictfetchall(_cr)
        if comanda_instalado:
            sql = """
            UPDATE supervisor_cda_itens_favoritos AS sif SET supifa_item_id = sci.id
            FROM supervisor_cda_itens_favoritos AS sif1
            INNER JOIN supervisor_cad_itens     AS sci  ON sci.supite_codigo_item = sif1.supifa_cod_item
            WHERE sif1.supifa_item_id IS NULL
              AND sif1.id = sif.id
                 """
            _cr.execute(sql)

        # Todas as operações são gravadas efetivamente no banco de dados
        _cr.connection.commit()
        self.desbloqueia_acao_pendente(_cr, uid, usar_master=usar_master, context=context)
        if conn:
            conn.close()
        return res

    def _insere_tabela_acao_pendente_postgres(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        fields_to_read = ['estpar_super_host_erp', 'estpar_super_db', 'estpar_super_user_erp',
                          'estpar_super_password_erp', 'estpar_super_porta_erp', 'company_id',
                          'estpar_usar_master']
        parametro_dados = self._parametro_read_fields(cr, uid, fields_to_read, context=context)

        host = parametro_dados.get('estpar_super_host_erp')
        porta = parametro_dados.get('estpar_super_porta_erp') or 8069
        user = parametro_dados.get('estpar_super_user_erp')
        password = parametro_dados.get('estpar_super_password_erp') or ''
        db = parametro_dados.get('estpar_super_db')
        usar_master = parametro_dados.get('estpar_usar_master')

        pdvs_dados = self.browse(cr, uid, ids[0]).pdv_ids
        if not pdvs_dados:
            return True

        erro_acao = False
        if all([host, user, password, db]):
            try:
                sock_common = xmlrpclib.ServerProxy('http://' + host + ':' + str(porta) + '/xmlrpc/common')
                socket.setdefaulttimeout(3)
                uid_supervisor = sock_common.login(db, user, password)
                sock = xmlrpclib.ServerProxy('http://' + host + ':' + str(porta) + '/xmlrpc/object')
            except Exception as err:
                msg = _("Host: %s \nPorta: %s\nUsuario: %s \n Banco: %s\n"% (host, porta, user, db))
                raise Exception('Nao foi possivel conectar ao ERP do supervisor. \n%s'
                                       % msg + 'Verifique as informacoes nos parametros do '
                                               'estoque.')

            lista_ecf = []
            ecf_ids = self.pool.get('ecf.ecf').search(cr, uid, [], context=context)
            if ecf_ids:
                for i in self.pool.get('ecf.ecf').read(cr, uid, ecf_ids, ['caixa', 'loja'],
                                                       context):
                    lista_ecf.append('%s-%s' % (i.get('loja'), i.get('caixa')))

            for i in pdvs_dados:
                vals = {'supeape_loja': i.ecfexp_loja, 'supeape_pdv': i.ecfexp_caixa,
                        'supape_situacao': 'A'}

                args = [('supeape_loja', '=', i.ecfexp_loja),
                        ('supeape_pdv', '=', i.ecfexp_caixa)]
                if usar_master:
                    vals['supeape_nro_empresa'] = parametro_dados.get('company_id')[0]
                    args.append(('supeape_nro_empresa', '=', parametro_dados.get('company_id')[0]))

                if self.itens_exportados:
                    vals['supape_tabela'] = 'Itens'
                    args.append(('supape_tabela', '=', 'Itens'))
                    context['exporta_sem_retornar_raise'] = True
                    res = sock.execute(db, uid_supervisor, password,
                                       'wizard.supervisor.exporta.para.ecf',
                                       'exporta_verificar_promocoes_tipo4', context)
                    acao_pendente_id = sock.execute(db, uid_supervisor, password,
                                                    'supervisor.mov.acao.pendente', 'search', args)
                    chave = '%s-%s' % (i.ecfexp_loja, i.ecfexp_caixa)
                    if not acao_pendente_id and res:
                        sock.execute(db, uid_supervisor, password, 'supervisor.mov.acao.pendente',
                                     'create', vals, context)
                        if chave not in lista_ecf:
                            vals['supape_tabela'] = 'Tributacao NFC-e'
                            sock.execute(db, uid_supervisor, password, 'supervisor.mov.acao.pendente',
                                         'create', vals, context)
                    if not res:
                        erro_acao = True

                if self.clientes_exportados:
                    vals['supape_tabela'] = 'Mensagem'
                    args.pop()
                    args.append(('supape_tabela', '=', 'Mensagem'))
                    acao_pendente_id = sock.execute(db, uid_supervisor, password,
                                                    'supervisor.mov.acao.pendente', 'search', args)
                    if not acao_pendente_id:
                        sock.execute(db, uid_supervisor, password, 'supervisor.mov.acao.pendente',
                                     'create', vals, context)

                    vals['supape_tabela'] = 'Clientes'
                    args.pop()
                    args.append(('supape_tabela', '=', 'Clientes'))
                    acao_pendente_id = sock.execute(db, uid_supervisor, password,
                                                    'supervisor.mov.acao.pendente', 'search', args)
                    if not acao_pendente_id:
                        sock.execute(db, uid_supervisor, password, 'supervisor.mov.acao.pendente',
                                     'create', vals, context)

                if self.vendedores_exportados:
                    vals['supape_tabela'] = 'Vendedor'
                    args.pop()
                    args.append(('supape_tabela', '=', 'Vendedor'))
                    acao_pendente_id = sock.execute(db, uid_supervisor, password,
                                                    'supervisor.mov.acao.pendente', 'search', args)
                    if not acao_pendente_id:
                        sock.execute(db, uid_supervisor, password, 'supervisor.mov.acao.pendente',
                                     'create', vals, context)

        if erro_acao:
            raise Exception('Erro ao criar acao pendente de Intens, '
                            'problema no valor dos itens na promocao do tipo 4!')

        return True

    def _insere_tabela_acao_pendente_mysql(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        fields_to_read = ['estpar_super_host', 'estpar_super_db', 'estpar_super_user',
                          'estpar_super_password']
        parametro_dados = self._parametro_read_fields(cr, uid, fields_to_read, context=context)

        host = parametro_dados.get('estpar_super_host')
        user = parametro_dados.get('estpar_super_user')
        password = parametro_dados.get('estpar_super_password')
        db = parametro_dados.get('estpar_super_db')

        if all([host, user, password, db]):
            connection = False

            sql = """
                insert into TblMov_AcaoPendente (Loja, Pdv, Tabela, Situacao)
                values (%s, %s, '%s', '%s')
            """

            try:
                connection = mysql.connect(host=host, user=user, passwd=password, db=db)
                cr_mysql = connection.cursor()
                sql_pdvs = """ SELECT IdPdv, Loja FROM TblCad_Pdvs """
                cr_mysql.execute(sql_pdvs)
                pdvs_dados = cr_mysql.fetchall()

                for i in pdvs_dados:
                    dados = (i[1], i[0], 'Itens', 'A')
                    sentenca = sql % dados
                    cr_mysql.execute(sentenca)
                    connection.commit()

                    dados = (i[1], i[0], 'Mensagem', 'A')
                    sentenca = sql % dados
                    cr_mysql.execute(sentenca)
                    connection.commit()

                    dados = (i[1], i[0], 'Operadores', 'A')
                    sentenca = sql % dados
                    cr_mysql.execute(sentenca)
                    connection.commit()

                    dados = (i[1], i[0], 'Clientes', 'A')
                    sentenca = sql % dados
                    cr_mysql.execute(sentenca)
                    connection.commit()

            except Exception as e:
                if connection:
                    connection.rollback()
            finally:
                if connection:
                    connection.close()

        return True

    def _get_parametro_id(self, cr, uid, obj_estoque_parametro=None, context=None):
        context = context and context.copy() or {}
        parametro_id = False
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, context=context)
        if company_id:
            if not obj_estoque_parametro:
                obj_estoque_parametro = self.pool.get('estoque.parametro')
            parametro_id = obj_estoque_parametro.search(cr, uid, [('company_id', '=', company_id)], context=context)
        return parametro_id

    def _parametro_read_fields(self, cr, uid, fields_to_read, context=None):
        context = context and context.copy() or {}
        parametro_dados = {}
        obj_estoque_parametro = self.pool.get('estoque.parametro')
        parametro_id = self._get_parametro_id(cr, uid, obj_estoque_parametro, context)
        if parametro_id and isinstance(fields_to_read, list):
            parametro_dados = obj_estoque_parametro.read(
                cr, uid, parametro_id, fields_to_read, context=context
            )
            if parametro_dados and isinstance(parametro_dados, list):
                parametro_dados = parametro_dados[0]
        return parametro_dados

    def _criar_itens_supervisor_mysql(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        create_date = write_date = datetime.now()
        fields_to_read = ['estpar_super_host', 'estpar_super_db', 'estpar_super_user', 'estpar_super_password']
        parametro_dados = self._parametro_read_fields(cr, uid, fields_to_read, context=context)

        host = parametro_dados.get('estpar_super_host')
        user = parametro_dados.get('estpar_super_user')
        password = parametro_dados.get('estpar_super_password')
        db = parametro_dados.get('estpar_super_db')

        if all([host, user, password, db]):
            context = context and context.copy() or {}

            # parâmetros de busca
            ep_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'estoque.produto', context=context)
            ap_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'automacao.precos', context=context)

            param_ids = self.pool.get('estoque.parametro').search(cr, uid, [], context=context)
            o_param = self.pool.get('estoque.parametro')
            r_param = o_param.read(cr, uid, param_ids[0],
                                   ['arquivo_de_itens_ecf', 'arquivo_de_trib_ecf',
                                    'arquivo_de_nserie', 'estpar_super_local_id'], context=context)

            estpar_super_local_id = r_param.get('estpar_super_local_id', False)
            sql = """
            select
                 acb.codigo_barra, ep.name, ep.active as produto_ativo, 1 as departamento, ft.tributacao_ecf,
                 (case when ep.ncm_id is not null then fn.codigo else null end) as ncm_codigo,
                 (case
                    when ep.origem_mercadoria in ('0','3','4','5', '8') then fn.fisnc_aliq_ibpt_fed_nac
                    when ep.origem_mercadoria in ('1','2','6','7') then fn.fisnc_aliq_ibpt_fed_imp
                    else 0.0
                  end
                 )                          AS aliquota_tributos_fed,
                 fn.fisnc_aliq_ibpt_est     AS aliquota_tributos_est,
                 fn.fisnc_aliq_ibpt_mun     AS aliquota_tributos_mun,
                 fn.fisnc_ibpt_chave        AS chave_ibpt,
                  """
            fields_estoque_produto = self.pool.get('estoque.produto').fields_get(cr, uid, ['produto_de_balanca'])
            if fields_estoque_produto.get('produto_de_balanca'):
                sql += """ep.produto_de_balanca,"""

            sql += """
                 eeu.fracao, ap.preco_venda, eeu.unidade, ee.quantidade_na_embalagem,
                 acb.peso_embalagem,ep.codigo, ep.producao_propria, ep.id as produto_id,
                 acb.grade_id,epg.descricao_resumida,"""

            estpro_nserie_tipo = self.pool.get('estoque.produto').fields_get(cr, uid, ['estpro_nserie_tipo'])
            if estpro_nserie_tipo.get('estpro_nserie_tipo'):
                sql += """ep.estpro_nserie_tipo,"""

            sql += """acb.active
            from
                 automacao_precos ap,
                 automacao_codigo_barra acb,
                 estoque_produto ep,

                 estoque_produto_embalagem epe,
                 estoque_embalagem ee,
                 estoque_embalagem_unidade eeu,
                 estoque_produto_grade epg,

                 fiscal_tributacao_encargos fte,
                 fiscal_tributacao ft,
                 fiscal_ncm fn,
                 fiscal_encargo fe

            where
                 ap.codigo_barra_id = acb.id
                 and acb.produto_id = ep.id
                 and acb.produto_id = fte.produto_id
                 and fte.tributacao_id = ft.id
                 and fte.tipo_tributacao = 'T'
                 and ft.tributacao_ecf is not null
                 and fte.encargo_id = fe.id
                 and ft.encargo_id = fe.id
                 and fe.sigla in ('ICMS','ISS')
                 and acb.produto_embalagem_id = epe.id
                 and epe.embalagem_id = ee.id
                 and ee.unidade_id = eeu.id
                 and ep.ncm_id = fn.id
                 and epg.produto_id = ep.id
                 and ap.company_id = %s
            """ % ap_company_id
            if estpar_super_local_id:
                sql += """and ep.id in (
                 select produto_id from estoque_local_locacao ell
                 where ell.local_id in (%s)) """ % ','.join(map(lambda x: '%s' % x,
                                                                estpar_super_local_id))
            sql += """and ep.company_id = %d
            order by acb.codigo_barra
            """ % ep_company_id

            cr.execute(sql)
            res_preco = cr.dictfetchall()
            tup_check = ()  # Usado para verificar duplicidade de codigo de barra

            ssql = """
                    INSERT INTO TblCad_Itens
                            (Loja, CodigoItem, Descricao, Tributacao, Fracionado, Unidade, PesoDaEmbalagem, Producao,
                             IAT, NCM, Ativo, Preco, Aliquota
                             )
                    VALUES (%s, '%s', '%s', '%s', '%s', '%s', %s, '%s', '%s', '%s', '%s', %s, %s)
                """

            connection = False
            try:
                connection = mysql.connect(host=host, user=user, passwd=password, db=db)
                cr_mysql = connection.cursor()
                for rec_preco in res_preco:
                    if not rec_preco.get('codigo_barra') in tup_check:
                        tup_check += (rec_preco.get('codigo_barra'),)

                        aliquota_ibpt_fed = rec_preco.get('aliquota_tributos_fed') or '0'
                        aliquota_ibpt_est = rec_preco.get('aliquota_tributos_fed') or '0'
                        aliquota_ibpt_mun = rec_preco.get('aliquota_tributos_fed') or '0'
                        chave_ibpt = rec_preco.get('chave_ibpt') or '0'

                        loja = 1
                        codigo_item = rec_preco.get('codigo_barra') or ''
                        name = rec_preco.get('descricao_resumida') or rec_preco.get('descricao')
                        tributacao = rec_preco.get('tributacao_ecf') or ''
                        fracionado = rec_preco.get('fracao') and 'T' or 'F'
                        unidade = rec_preco.get('unidade') or ''
                        peso_da_embalagem = rec_preco.get('peso_embalagem') or 0.0
                        producao = rec_preco.get('producao_propria') and 'P' or 'T'
                        iat = 'A'
                        ncm = rec_preco.get('ncm_codigo') or ''
                        active = rec_preco.get('active')
                        if active:
                            if rec_preco.get('acb.active') == False or rec_preco.get('acb.active') == 'F':
                                active = False
                        preco = rec_preco.get('preco_venda') or 0
                        preco_venda = rec_preco.get('preco_venda') or 0

                        dados = (write_date, uid, loja, codigo_item, name, tributacao, fracionado,
                                 unidade, peso_da_embalagem, producao, iat, ncm, active,
                                 preco_venda, aliquota_ibpt_fed)

                        sentenca = ssql % dados
                        sql_registro_existente = """
                            SELECT * FROM TblCad_Itens WHERE CodigoItem = '%s'
                        """ % (codigo_item)
                        cr_mysql.execute(sql_registro_existente)
                        registro_existente = cr_mysql.fetchall()
                        if not registro_existente:
                            cr_mysql.execute(sentenca)
                        else:
                            dados = (write_date, uid,
                                     loja, codigo_item, name, tributacao, fracionado, unidade, peso_da_embalagem,
                                     producao,
                                     iat, ncm, active, preco, aliquota_ibpt_fed, codigo_item
                                     )
                            sql_update = """
                                UPDATE TblCad_Itens
                                SET write_date = '%s', write_uid = %s, Loja = %s, CodigoItem = '%s',
                                    Descricao = '%s', Tributacao = '%s', Fracionado = '%s',
                                    Unidade = '%s', PesoDaEmbalagem = %s, Producao = '%s',
                                    IAT = '%s', NCM = '%s', Ativo = '%s', Preco = %s, Aliquota = %s
                                WHERE
                                    CodigoItem = '%s'
                            """
                            sentenca_update = sql_update % dados
                            cr_mysql.execute(sentenca_update)
                connection.commit()

            except Exception as e:
                if connection:
                    connection.rollback()
            finally:
                if connection:
                    connection.close()

        return True

    def _criar_clientes_supervisor_mysql(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        fields_to_read = ['estpar_super_host', 'estpar_super_db', 'estpar_super_user', 'estpar_super_password']
        parametro_dados = self._parametro_read_fields(cr, uid, fields_to_read, context=context)

        host = parametro_dados.get('estpar_super_host')
        user = parametro_dados.get('estpar_super_user')
        password = parametro_dados.get('estpar_super_password')
        db = parametro_dados.get('estpar_super_db')

        if all([host, user, password, db]):

            fc_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'financeiro.cliente', context=context)
            cliente_ids = self.pool.get('financeiro.cliente').search(cr, uid, [('company_id', '=', fc_company_id)],
                                                                     context=context)

            sql_cliente = """
                INSERT INTO TblCad_Clientes (CNPJCPF, Nome, Endereco, Status, Limite_Compras, Total_em_aberto, CodigoInterno, Insc_Estadual, Bairro, Cidade, Estado, Cep, Telefone, Rota)
                VALUES ('%s', '%s', '%s', '%s', %s, %s, %s, '%s', '%s', '%s', '%s', '%s', '%s', %s)
                """

            sql_mensagem = """
                    INSERT INTO TblCad_Mensagens_Clientes (CNPJCPF, Sequencia, Mensagem, Tipo)
                    VALUES ('%s', %s, '%s', '%s')
                    """

            connection = False
            try:
                connection = mysql.connect(host=host, user=user, passwd=password, db=db)
                cr_mysql = connection.cursor()

                obj_venda_utils = self.pool.get('vendas.utils')
                obj_financeiro_utils = self.pool.get('financeiro')

                for cliente in self.pool.get("financeiro.cliente").browse(cr, uid, cliente_ids, context=context):
                    cpf_cnpj = cliente.pessoa_id.cpf_cnpj
                    if not cpf_cnpj:
                        continue

                    pessoa_id = cliente.pessoa_id.id

                    total_docs_em_aberto = obj_venda_utils.venutl_get_total_debito_cliente(
                        cr, uid,
                        venutl_pessoa_ids=pessoa_id,
                        context=context,
                    )
                    total_docs_em_aberto = total_docs_em_aberto.get(pessoa_id) or 0
                    total_titulos_em_atraso = obj_financeiro_utils.finutl_get_valor_em_atraso(
                        cr, uid, venutl_pessoa_ids=pessoa_id, context=context
                    )
                    total_titulos_em_atraso = total_titulos_em_atraso.get(pessoa_id) or 0

                    total_debito = total_docs_em_aberto + total_titulos_em_atraso

                    cnpj_cpf = re_sub('[^0-9]', '', cpf_cnpj).rjust(15, '0')
                    name = cliente.pessoa_id.name[:40] or ''
                    endereco = cliente.pessoa_id.endereco_ids and cliente.pessoa_id.endereco_ids[0].name[:40] or ''
                    state = cliente.fincli_status_cliente or ''
                    limite_compras = cliente.limite_credito or 0.0
                    total_em_aberto = total_debito
                    codigo_interno = cliente.pessoa_id.codigo
                    insc_estadual = cliente.pessoa_id.admpes_jur_ie or ''
                    bairro = cliente.pessoa_id.endereco_ids and cliente.pessoa_id.endereco_ids[0].bairro_id.name[
                                                                :20] or ''
                    cidade = cliente.pessoa_id.endereco_ids and cliente.pessoa_id.endereco_ids[0].cidade_id.name[
                                                                :30] or ''
                    estado = cliente.pessoa_id.endereco_ids and cliente.pessoa_id.endereco_ids[0].uf_id.sigla or ''
                    cep = cliente.pessoa_id.endereco_ids and cliente.pessoa_id.endereco_ids[0].cep or ''
                    cep = cep.replace('.', '')
                    cep = cep.replace('-', '')
                    telefone = cliente.pessoa_id.telefones_ids and cliente.pessoa_id.telefones_ids[0].numero or ''
                    rota = cliente.fincli_rota or 0

                    dados_cliente = (
                        cnpj_cpf, name, endereco, state, limite_compras, total_em_aberto, codigo_interno, insc_estadual,
                        bairro, cidade, estado,
                        cep, telefone, rota)

                    sentenca = sql_cliente % dados_cliente
                    sql_registro_existente = """ SELECT CNPJCPF FROM TblCad_Clientes WHERE CNPJCPF = '%s'""" % cnpj_cpf
                    cr_mysql.execute(sql_registro_existente)
                    registro_existente = cr_mysql.fetchall()
                    if not registro_existente:
                        cr_mysql.execute(sentenca)

                    for msg in cliente.mensagem_ids:
                        sequencia = False
                        mensagem = msg.mensagens_id.name
                        tipo = msg.mensagens_id.tipo_mensagem

                        dados_mensagem = (cnpj_cpf, sequencia, mensagem, tipo)

                        sentenca = sql_mensagem % dados_mensagem
                        sql_registro_existente = """ SELECT CNPJCPF FROM TblCad_Mensagens_Clientes WHERE CNPJCPF = '%s'""" % cnpj_cpf
                        cr_mysql.execute(sql_registro_existente)
                        registro_existente = cr_mysql.fetchall()
                        if not registro_existente:
                            cr_mysql.execute(sentenca)

                connection.commit()

            except Exception as e:
                if connection:
                    connection.rollback()
            finally:
                if connection:
                    connection.close()

        return True

    def _criar_vendedores_supervisor_mysql(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        fields_to_read = ['estpar_super_host', 'estpar_super_db', 'estpar_super_user', 'estpar_super_password']
        parametro_dados = self._parametro_read_fields(cr, uid, fields_to_read, context=context)
        obj_adm_utils = self.pool.get('adm.utils')

        host = parametro_dados.get('estpar_super_host')
        user = parametro_dados.get('estpar_super_user')
        password = parametro_dados.get('estpar_super_password')
        db = parametro_dados.get('estpar_super_db')

        if all([host, user, password, db]):
            context = context and context.copy() or {}

            vv_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'vendas.vendedor', context=context)
            vendedor_ids = self.pool.get('vendas.vendedor').search(cr, uid, [('company_id', '=', vv_company_id),
                                                                             ('tipo', '=', 'I')], context=context)

            browse_vendas_vendedor = self.pool.get("vendas.vendedor").browse(cr, uid, vendedor_ids, context=context)

            sql_mensagem = """
                    INSERT INTO TblCad_Vendedor (CodVendedor, Nome)
                    VALUES ('%s', '%s')
                    """

            connection = False
            try:
                connection = mysql.connect(host=host, user=user, passwd=password, db=db)
                cr_mysql = connection.cursor()

                for vendedor in browse_vendas_vendedor:
                    codigo_vendedor = vendedor.id
                    nome_vendedor = obj_adm_utils.admutl_remover_acentuacao(cr, uid, vendedor.pessoa_id.name[:40] or '')

                    dados_vendedor = (codigo_vendedor, nome_vendedor)

                    sentenca = sql_mensagem % dados_vendedor
                    sql_registro_existente = """ SELECT CodVendedor
                                                 FROM TblCad_Vendedor
                                                 WHERE CodVendedor = %s""" % codigo_vendedor
                    cr_mysql.execute(sql_registro_existente)
                    registro_existente = cr_mysql.fetchall()
                    if not registro_existente:
                        cr_mysql.execute(sentenca)
                connection.commit()

            except Exception as e:
                if connection:
                    connection.rollback()
            finally:
                if connection:
                    connection.close()

        return True

    def _criar_kit_supervisor_mysql(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        fields_to_read = ['estpar_super_host', 'estpar_super_db', 'estpar_super_user', 'estpar_super_password']
        parametro_dados = self._parametro_read_fields(cr, uid, fields_to_read, context=context)

        host = parametro_dados.get('estpar_super_host')
        user = parametro_dados.get('estpar_super_user')
        password = parametro_dados.get('estpar_super_password')
        db = parametro_dados.get('estpar_super_db')

        if all([host, user, password, db]):
            context = context and context.copy() or {}
            ep_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'estoque.produto', context=context)
            obj_automacao_codigo_barra = self.pool.get('automacao.codigo.barra')
            # ler kits
            produtos_ids = self.pool.get('estoque.produto').search(cr, uid, [('company_id', '=', ep_company_id),
                                                                             ('kit_de_produtos', '=', True),
                                                                             ('tipo_kit', '=', 'I')],
                                                                   context=context
                                                                   )

            sql_kit = """
                    INSERT INTO TblCad_Kits (Loja, CodigoKit, CodigoItem, Quantidade)
                    VALUES (%s, '%s', '%s', %s)
                    """

            connection = False
            try:
                connection = mysql.connect(host=host, user=user, passwd=password, db=db)
                cr_mysql = connection.cursor()

                for rec_produtos in self.pool.get('estoque.produto').browse(cr, uid, produtos_ids, context=context):
                    codigo_barra = ''
                    codigo_barra_id = obj_automacao_codigo_barra.search(cr, uid, [('produto_id', '=', rec_produtos.id)],
                                                                        context=context)
                    if codigo_barra_id:
                        codigo_barra_dados = obj_automacao_codigo_barra.read(cr, uid, codigo_barra_id[0],
                                                                             ['codigo_barra'], context=context)
                        codigo_barra = codigo_barra_dados.get('codigo_barra') or ''
                    for produto_itens in rec_produtos.produto_kit_ids:
                        codigo_barra_item = ''
                        codigo_barra_item_id = obj_automacao_codigo_barra.search(cr, uid, [
                            ('produto_id', '=', produto_itens.kitpro_item_produto_id.codigo)], context=context)
                        if codigo_barra_item_id:
                            codigo_barra_item_dados = obj_automacao_codigo_barra.read(cr, uid, codigo_barra_item_id[0],
                                                                                      ['codigo_barra'], context=context)
                            codigo_barra_item = codigo_barra_item_dados.get('codigo_barra') or ''

                        loja = 1
                        codigo_kit = codigo_barra
                        codigo_item = codigo_barra_item
                        quantidade = produto_itens.kitpro_quantidade or 0.0

                        dados_kit = (loja, codigo_kit, codigo_item, quantidade)

                        sentenca = sql_kit % dados_kit
                        sql_registro_existente = """ SELECT CodigoKit, CodigoItem FROM TblCad_Kits WHERE CodigoKit = '%s' AND CodigoItem = '%s' """ % (
                            codigo_kit, codigo_item)
                        cr_mysql.execute(sql_registro_existente)
                        registro_existente = cr_mysql.fetchall()
                        if not registro_existente:
                            cr_mysql.execute(sentenca)
                connection.commit()

            except Exception as e:
                if connection:
                    connection.rollback()
            finally:
                if connection:
                    connection.close()

        return True

    def button_exportar(self, cr, uid, ids, context=None):

        # No codigo abaixo o  nivel de isolamento da conexao e alterada para
        # ISOLATION_LEVEL_READ_COMMITTED pelo fato deste methodo realizar conexao externa
        # atraves de xmlrpc para executar as operacoes. Isto e feito desta forma pelo fato de
        # existir supervisores separados do banco do sigerp.
        # Sem alterar este nivel de isolamento, quando o supervisor esta na
        # propria maquina, ocorre erro de concorrencia de dados, devido ao nivel
        # de isolamento do openerp.
        cr.connection.set_isolation_level(extensions.ISOLATION_LEVEL_READ_COMMITTED)

        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]

        self.itens_exportados = False
        self.kits_exportados = False
        self.clientes_exportados = False
        self.vendedores_exportados = False
        log = ''
        log_info_exp = ''
        values_exportacao = {'state': 'C'}

        # OBJETOS
        obj_estoque_parametro = self.pool.get('estoque.parametro')

        # DADOS DO ESTOQUE_PARAMETRO
        estpar_fields_to_read = [
            'estpar_tipo_exportacao', 'arquivo_de_itens_ecf', 'arquivo_de_trib_ecf',
            'arquivo_de_clientes',
            'arquivo_de_vendedores', 'arquivo_de_kit', 'estpar_super_local_id', 'company_id',
            'estpar_usar_master'
        ]
        estpar_dados = obj_estoque_parametro.estpar_get_fields(
            cr, uid, fields_to_read=estpar_fields_to_read, context=context
        )
        if isinstance(estpar_dados, list):
            estpar_dados = estpar_dados[0]

        estpar_tipo_exportacao = estpar_dados.get('estpar_tipo_exportacao') or ''
        estpar_arquivo_ecf_item = estpar_dados.get('arquivo_de_itens_ecf')
        estpar_arquivo_ecf_trib = estpar_dados.get('arquivo_de_trib_ecf')
        estpar_arquivo_cliente = estpar_dados.get('arquivo_de_clientes')
        estpar_arquivo_vendedor = estpar_dados.get('arquivo_de_vendedores')
        estpar_arquivo_kit = estpar_dados.get('arquivo_de_kit')
        estpar_company_id = estpar_dados.get('company_id')
        estpar_local_ids = estpar_dados.get('estpar_super_local_id')
        estpar_usar_master = estpar_dados.get('estpar_usar_master')

        if not estpar_tipo_exportacao:
            raise osv.except_osv(_('Atencao'),
                                 _('Tipo exportacao nao cadastrado no parametro do estoque'))
        estpar_tipo_exportacao = estpar_tipo_exportacao.upper()

        if estpar_tipo_exportacao != 'A':
            fields_to_read = ['estpar_super_host_erp', 'estpar_super_db', 'estpar_super_user_erp',
                              'estpar_super_password_erp', 'estpar_super_porta_erp']
            parametro_dados = self._parametro_read_fields(cr, uid, fields_to_read, context=context)

            host = parametro_dados.get('estpar_super_host_erp')
            porta = parametro_dados.get('estpar_super_porta_erp') or 8069
            user = parametro_dados.get('estpar_super_user_erp')
            password = parametro_dados.get('estpar_super_password_erp') or ''
            db = parametro_dados.get('estpar_super_db')
            if not all([host, user, db, porta, password]):
                raise osv.except_osv(_('Atencao'), _('Verifique as informacoes nos parametros '
                                                     'do estoque.'))

            try:
                sock_common = xmlrpclib.ServerProxy('http://' + host + ':' + str(porta) + '/xmlrpc/common')
                socket.setdefaulttimeout(3)
                uid_supervisor = sock_common.login(db, user, password)
                sock = xmlrpclib.ServerProxy('http://' + host + ':' + str(porta) + '/xmlrpc/object')
                self.super_user_id = sock.execute(db, uid_supervisor, password, 'res.users',
                                                  'get_super_user', [])
            except Exception as err:
                msg = _("Host: %s \nPorta: %s\nUsuario: %s \nBanco: %s\n"% (host, porta, user, db))
                raise osv.except_osv(_('Atencao'),
                                     _('Nao foi possivel conectar ao ERP do supervisor. \n%s' %
                                       msg + 'Verifique as informacoes nos parametros do '
                                       'estoque.'))

        # DADOS DO WIZARD DE EXPORTACAO
        exportar_fields_to_read = [
            'gerar_itens', 'gerar_clientes', 'gerar_vendedores', 'gerar_kit', 'ecfexp_exportar_saldo'
        ]
        exportar_dados = self.read(cr, uid, ids, exportar_fields_to_read, context=context,
                                   load=READ_LOAD)

        kit_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'kit', context=context)
        expo_exportar_saldo = False
        for i in exportar_dados:
            expo_gerar_kit = i.get('gerar_kit')
            expo_gerar_itens = i.get('gerar_itens')
            expo_gerar_clientes = i.get('gerar_clientes')
            expo_gerar_vendedores = i.get('gerar_vendedores')
            expo_exportar_saldo = i.get('ecfexp_exportar_saldo')
            # EXPORTACAO DE ARQUIVOS
            if estpar_tipo_exportacao == 'A':

                # ARQUIVO DE ITENS
                ark_item = {}
                if expo_gerar_itens:
                    ark_item = self._gerar_arquivo_itens(cr, uid, ids, context=context)
                    log += (ark_item.get('log') or '')

                    if ark_item.get('regs'):
                        log_info_exp += _('\n%i Itens Exportados.') % (ark_item['regs'] or 0)
                        if not estpar_arquivo_ecf_item:
                            values_exportacao['dados_itens'] = ark_item.get('arquivo_itens')

                        if not estpar_arquivo_ecf_trib:
                            values_exportacao['dados_tributacao'] = ark_item.get('arquivo_tributacao')

                    if ark_item.get('regs_nserie'):
                        log_info_exp += _('\n%i Numeros de Serie Exportados.') % (ark_item['regs_nserie'] or 0)

                # ARQUIVO DE CLIENTES
                if expo_gerar_clientes:
                    ark_cliente = self._gerar_arquivo_clientes(cr, uid, ids, context=context)
                    log += (ark_cliente.get('log') or '')
                    if not estpar_arquivo_cliente:
                        values_exportacao['dados_clientes'] = ark_cliente.get('arquivo_clientes')
                    if ark_cliente.get('regs'):
                        log_info_exp += _('\n%i Clientes Exportados.') % (ark_cliente['regs'] or 0)

                # ARQUIVO DE VENDEDORES
                if expo_gerar_vendedores:
                    ark_vendedores = self._gerar_arquivo_vendedores(cr, uid, ids, context=context)
                    log += (ark_vendedores.get('log') or '')
                    if not estpar_arquivo_vendedor:
                        values_exportacao['dados_vendedores'] = ark_vendedores.get('arquivo_vendedores')
                    if ark_vendedores.get('regs'):
                        log_info_exp += _('\n%i Vendedores exportados.') % (ark_vendedores['regs'] or 0)

                # ARQUIVO DE KITS
                if expo_gerar_kit:
                    if kit_instalado:
                        ark_kit = self._gerar_arquivo_de_kit(cr, uid, ids, context=context)
                        log += (ark_kit.get('log') or '')
                        if not estpar_arquivo_kit:
                            values_exportacao['dados_kit'] = ark_kit.get('arquivo_kit')
                        if ark_kit.get('regs'):
                            log_info_exp += _('\n%i Kits Exportados.') % (ark_kit['regs'] or 0)
                    else:
                        log_info_exp += _('\nModulo Kit nao instalado.')

                log_info_exp += log

            # EXPORTACAO PARA POSTGRESQL
            elif estpar_tipo_exportacao == 'P':
                if expo_gerar_itens:
                    resultado = self._criar_itens_supervisor_postgres(cr, uid, ids,
                                             estpar_company_id, estpar_usar_master, context=context)
                    if resultado.get('valor'):
                        log_info_exp += _('\nItens Exportados.')
                        self.itens_exportados = True

                    if resultado.get('mensagem'):
                        log_info_exp += resultado.get('mensagem')

                if expo_gerar_clientes:
                    resultado = self._criar_clientes_supervisor_postgres(cr, uid, ids,
                                                                         context=context)
                    if resultado:
                        log_info_exp += _('\nClientes Exportados.')
                        self.clientes_exportados = True
                    else:
                        log_info_exp += _('\nNenhum cliente exportado.')

                if expo_gerar_vendedores:
                    resultado = self._criar_vendedores_supervisor_postgres(cr, uid, ids,
                                                                           context=context)
                    if resultado:
                        log_info_exp += _('\nVendedores Exportados.')
                        self.vendedores_exportados = True
                    else:
                        log_info_exp += _('\nNenhum vendedor exportado.')

                if 'exporta_kit' in self.__dict__ and self.exporta_kit:
                    expo_gerar_kit = True
                    del self.exporta_kit

                if expo_gerar_kit and kit_instalado:
                    resultado = self._criar_kit_supervisor_postgres(cr, uid, ids, estpar_company_id,
                                                                estpar_usar_master, context=context)
                    if isinstance(resultado, list):
                        if resultado:
                            log_info_exp += '\n'.join(resultado)
                        else:
                            log_info_exp += _('\nKits Exportados.')

                        if not context.get('itens'):
                            self.itens_exportados= True
                    else:
                        log_info_exp += _('\nNenhum Kit exportado ou Existem Itens em Kits que nao '
                                          'foram exportados. Realize a exportacao de itens e '
                                          'tente novamente.')

                if self._criar_locais_producao_supervisor_postgres(cr, uid, ids, context=context):
                    log_info_exp += _('\nLocais de Producao Exportados.')

                if expo_gerar_itens or expo_gerar_clientes or expo_gerar_vendedores or \
                                                                                    expo_gerar_kit:
                    try:
                        self._insere_tabela_acao_pendente_postgres(cr, uid, ids, context=context)
                    except Exception as e:
                        try:
                            e = self.pool.get('adm.utils').admutl_remover_acentuacao(cr, uid, str('%s' % e.encode('UTF-8')))
                        except:
                            e = self.pool.get('adm.utils').admutl_remover_acentuacao(cr, uid, str('%s' % e.faultCode.encode('UTF-8')))
                            raise osv.except_osv('', e)
                        log_info_exp += _('\nErro ao criar acao pendente no supervisor:\n%s.') % e

            # EXPORTACAO PARA MYSQL
            else:
                #TODO: o cursor a ser passado deve ser do banco onde esta o supervisor, no caso cursor do mysql
                # self.bloqueia_acao_pendente(cr, uid, context)
                if expo_gerar_itens:
                    self._criar_itens_supervisor_mysql(cr, uid, ids, context=context)
                    log_info_exp += _('\nItens Exportados.')

                if expo_gerar_clientes:
                    self._criar_clientes_supervisor_mysql(cr, uid, ids, context=context)
                    log_info_exp += _('\nClientes Exportados.')

                if expo_gerar_vendedores:
                    self._criar_vendedores_supervisor_mysql(cr, uid, ids, context=context)
                    log_info_exp += _('\nVendedores Exportados.')

                if expo_gerar_kit and kit_instalado:
                    self._criar_kit_supervisor_mysql(cr, uid, ids, context=context)
                    log_info_exp += _('\nKits Exportados.')

                self._insere_tabela_acao_pendente_mysql(cr, uid, ids, context=context)
                #TODO: o cursor a ser passado deve ser do banco onde esta o supervisor, no caso cursor do mysql
                #self.desbloqueia_acao_pendente(cr, uid, context)

        if expo_exportar_saldo:
            self.ecfexp_atualiza_ecf_exportar_saldo_super(cr, uid, estpar_company_id,
                                                          estpar_local_ids, context)
        values_exportacao['informacao'] = log_info_exp
        self.write(cr, uid, ids, values_exportacao, context=context)
        return True

    def _criar_locais_producao_supervisor_postgres(self, cr, uid, ids, context=None):
        '''Implementado por heranca no modulo vendas_cozinha'''
        return False


    def ecfexp_atualiza_ecf_exportar_saldo_super(self, cr, uid, company_id, local_ids,
                                                 context=None):
        """
        Este metodo tem a funcao de gerar uma carga total do saldo dos produtos existentes na
        tabela automacao_codigo_barra, e alimentar a tabela ecf_exportar_saldo_super (CH-85605)

        :param cr: a Vinha atual do cursor do banco de dados
        :param uid: ID do usuario que gerou esta exportacao
        :param company_id: ID da empresa que o usuario esta lagado
        :param local_ids: Lista de ids dos locais cadastrados para o atributo estpar_local_id
        do parametro do estoque (estoque.parametro)
        :param context: Dicionario padrao para valores contextuais
        :type cr: cursor
        :type uid: int
        :type company_id: int
        :type local_ids: list
        :type context: dict
        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        context = context and context.copy() or {}
        obj_aut_cod_barra = self.pool.get('automacao.codigo.barra')
        obj_produto_saldo = self.pool.get('estoque.produto.saldo')
        obj_exp_saldo_super = self.pool.get('ecf.exportar.saldo.super')
        automacao_cob_bar_ids = obj_aut_cod_barra.search(cr, uid, [], context=context)
        fields_to_read = ['grade_id', 'produto_id']
        dados_cod_barras = obj_aut_cod_barra.read(cr, uid, automacao_cob_bar_ids, fields_to_read,
                                                  context=context, load='_classic_write')
        hoje = datetime.today()
        grade_ids = map(lambda i: i.get('grade_id'), dados_cod_barras)
        context.update()
        context_atualiza = context.copy()
        context_atualiza.update({'exporta_saldo_inicial': True,
                                 'ecfexp_exp_total_saldo': True})


        for local_id in local_ids:
            dados_saldo = obj_produto_saldo.get_saldo_do_dia(cr, uid, grade_ids, hoje,
                                                             eps_local_id=local_id, context=context)
            grades_saldo = {}
            map(lambda x: grades_saldo.update({x: dados_saldo.get(x).get('disponivel')}),
                          dados_saldo.keys())

            obj_exp_saldo_super.ecfess_atualizar_registros(cr, uid, company_id, local_id,
                                                           grades_saldo,
                                                           context=context_atualiza)
        return True

    @staticmethod
    def remove_numero_endereco(endereco):
        try:
            endereco = endereco.split(',')
            endereco.remove(endereco[1])
            return " ".join(endereco)[:40]
        except:
            return "null"

    def get_pdv_ids(self, cr, uid, ids=[], context=None):
        '''
        Este funcao busca no supervisor os pdvs cadastrados e tras para a tabela 
        'ecf.exportar.para.pdv.osv'
        '''
        context = context and context.copy() or {}
        obj_adm_utils = self.pool.get('adm.utils')
        obj_exportar_para_pdv = self.pool.get('ecf.exportar.para.pdv.osv')
        campos = ['estpar_super_host', 'estpar_super_db', 'estpar_super_user', 'company_id',
                  'estpar_super_password', 'estpar_tipo_exportacao', 'estpar_usar_master']
        dados_parametros = obj_adm_utils.admutl_get_parametros(cr, uid, 'estoque.parametro', campos,
                                                               context=context)
        host = dados_parametros.get('estpar_super_host')
        if not host:
            return []
        dados_parametros = obj_adm_utils.admutl_get_parametros(cr, uid, 'estoque.parametro', campos,
                                                               context=None)
        if dados_parametros.get('estpar_tipo_exportacao') == "A":
            return []

        user = dados_parametros.get('estpar_super_user')
        password = dados_parametros.get('estpar_super_password') or ''
        db = dados_parametros.get('estpar_super_db')
        usar_master = dados_parametros.get('estpar_usar_master')
        conn = False

        try:
            conn = psycopg2.connect(database=db, user=user, password=password, host=host, #SigLuiz
                                    connect_timeout=3)
            _cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
        except Exception as err:
            if conn:
                conn.close()
            raise osv.except_osv(_('Atencao'), _('Nao foi possivel conectar ao Postgres do supervisor. '
                                                 'Verifique as informacoes nos parametros do '
                                                 'estoque.'))
        cond_pdv = ''
        if usar_master:
            cond_pdv = 'WHERE suppdv_nro_empresa = %s' % dados_parametros.get('company_id')

        _cr.execute('''SELECT suppdv_caixa, suppdv_loja 
                       FROM supervisor_cad_pdvs 
                       %s
                       ORDER BY suppdv_loja, suppdv_caixa ''' % cond_pdv)
        dados_pdv = obj_adm_utils.admutl_converts_fetchall_to_dictfetchall(_cr)
        ecf_exportar_pdv_ids = []
        for pdv in dados_pdv:
            exporta_ids = obj_exportar_para_pdv.search(cr, uid, [('ecfexp_loja','=', pdv.get('suppdv_loja')),
                                                                 ('ecfexp_caixa','=', pdv.get('suppdv_caixa'))])
            if exporta_ids:
                ecf_exportar_pdv_ids.extend(exporta_ids)
                continue

            vals = {'ecfexp_loja': pdv.get('suppdv_loja'),
                    'ecfexp_caixa': pdv.get('suppdv_caixa')}
            id = self.pool.get('ecf.exportar.para.pdv.osv').create(cr, uid, vals, context=context)
            ecf_exportar_pdv_ids.append(id)
        if conn:
            conn.close()
        if not ecf_exportar_pdv_ids:
            return []
        return [[6,False,ecf_exportar_pdv_ids]]

    def default_get(self, cr, uid, fields, context=None):
        context = context and context.copy() or {}
        res = super(ecf_exportar_osv, self).default_get(cr, uid, fields, context=context)
        tipo_exportacao = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque',
                                                                           ['estpar_tipo_exportacao'], context=context)
        if tipo_exportacao.get('estpar_tipo_exportacao') == 'P':
            res['exportacao_postgres'] = True
        return res

    _name = "ecf.exportar.osv"
    _columns = {
        'data': fields.date('Data', required=False),
        'gerar_itens': fields.boolean('Gerar arquivo de itens'),
        'gerar_clientes': fields.boolean('Gerar arquivo de clientes'),
        'gerar_kit': fields.boolean('Gerar arquivo de kits'),
        'gerar_fidelidade': fields.boolean('Gerar arquivo de fidelidade'),
        'gerar_vendedores': fields.boolean('Gerar arquivo de vendedores'),
        'ecfexp_exportar_saldo': fields.boolean('Exportar saldo'),
        'state': fields.selection([('R', 'Esboco'), ('C', 'Concluido'), ('E', 'Erro')], 'Estado'),
        'exportar_itens': fields.selection([('P', 'Parcial'), ('T', 'Todos')], 'Exportar itens', size=1, required=True,
                                           help=_(
                                               "'Parcial' exporta apenas os itens que o preco da tabela 'automacao_precos' ja tenha sido exportada. 'Todos' exporta todos os itens ")),
        'informacao': fields.text('Informacao'),
        'pdv_ids': fields.many2many('ecf.exportar.para.pdv.osv', 'pdv_exporta_para_ecf', 'id', 'pdv_id', 'PDVs'),
        'exportacao_postgres': fields.boolean("Tipo da exportacao"),
        # Arquivos
        'dados_itens': fields.binary('Itens ', readonly=True),
        'dados_tributacao': fields.binary('Tributacao ', readonly=True),
        'dados_clientes': fields.binary('Clientes ', readonly=True),
        'dados_kit': fields.binary('Kit ', readonly=True),
        'dados_fidelidade': fields.binary('Fidelidade ', readonly=True),
        'dados_vendedores': fields.binary('Vendedores ', readonly=True),

        'file_itens': fields.char('Nome do arquivo', size=50, readonly=False),
        'file_tributacao': fields.char('Nome do arquivo', size=50, readonly=False),
        'file_clientes': fields.char('Nome do arquivo', size=50, readonly=False),
        'file_kit': fields.char('Nome do arquivo', size=50, readonly=False),
        'file_vendedores': fields.char('Nome do arquivo', size=50, readonly=False),
    }

    _defaults = {
        'gerar_itens': True,
        'gerar_clientes': True,
        'gerar_kit': False,
        'gerar_fidelidade': False,
        'gerar_vendedores': False,
        'file_itens': 'Itens.txt',
        'file_tributacao': 'Tributacao.txt',
        'file_clientes': 'Clientes.txt',
        'file_kit': 'kit.txt',
        'file_vendedores': 'Vendedores.txt',
        'state': 'R',
        'exportar_itens': 'P',
        'ecfexp_exportar_saldo': False,
        'pdv_ids': get_pdv_ids,
    }


class ecf_exportar_para_pdv_osv(osv.TransientModel):
    _name = "ecf.exportar.para.pdv.osv"
    _columns = {
        'ecfexp_loja': fields.integer('Loja'),
        'ecfexp_caixa': fields.integer('Caixa'),
    }

    def init(self, cr):
        cr.execute("""DELETE FROM ecf_exportar_para_pdv_osv""")

    def name_get(self, cr, uid, ids, context=None):
        res = []
        context = context and context.copy() or {}
        if not len(ids):
            return []
        dados = self.read(cr, uid, ids, ['ecfexp_loja', 'ecfexp_caixa'], context=context)
        for x in dados:
            res.append((x['id'], str(x['ecfexp_loja']) + ' - ' + str(x['ecfexp_caixa'])))
        return res

    def name_search(self, cr, uid, name='', args=[], operator='ilike', context=None, limit=80):
        context = context and context.copy() or {}
        ids = []
        try:
            name = int(name)
        except:
            pass
        if isinstance(name, int):
            ids = self.search(cr, uid, [('ecfexp_loja', '=', name)] + args, limit=limit, context=context)
            if not ids:
                ids = self.search(cr, uid, [('ecfexp_caixa', '=', name)] + args, limit=limit, context=context)
        else:
            ids = self.search(cr, uid, args, limit=limit, context=context)
        return self.name_get(cr, uid, ids)

