# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp.tools.translate import _
from openerp import pooler


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_resumo_ecf(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        pdf_file = StringIO.StringIO()

        obj_pessoa = pooler.get_pool(cr.dbname).get('adm.pessoa')
        obj_pessoa_end = pooler.get_pool(cr.dbname).get('adm.pessoa.endereco')
        obj_mapa_resumo_capa = pooler.get_pool(cr.dbname).get('ecf.mapa.resumo.capa')
        obj_mapa_resumo_itens = pooler.get_pool(cr.dbname).get('ecf.mapa.resumo.itens')
        obj_ecf_ecf = pooler.get_pool(cr.dbname).get('ecf.ecf')
        obj_dados_empresa = pooler.get_pool(cr.dbname).get('adm.pessoa')
        obj_emp = pooler.get_pool(cr.dbname).get("res.company")

        empresa = datas['company_id']
        res = obj_emp.read(cr, uid, empresa, ['name'], context=context)  # Nome da Empresa logada
        for x in res:
            nome = x.get('name')

        if isinstance(empresa, list):
            empresa = empresa[0]

        browse_res_company = obj_emp.browse(cr, uid, empresa)
        pessoa_id = browse_res_company.rescon_pessoa_id.id
        nome_empresa = formataString(nome, 35, ' ', 'D', 'N', 'S')

        # CNPJ da Empresa logada
        empresa_cnpj = obj_dados_empresa.read(cr, uid, pessoa_id, ['cpf_cnpj'], context=context)
        n_cnpj = formataString(empresa_cnpj.get('cpf_cnpj') or '', 18, ' ', 'D', 'N', 'S')
        endereco = ' '
        cep = ' '
        aliquota_dados = dict()

        enderecos = obj_pessoa.read(cr, uid, pessoa_id, ['endereco_ids'], context=context).get(
            'endereco_ids')
        if not enderecos:
            raise osv.except_osv(_('Atencao'), _('Endereco nao cadastrado para a empresa.'))
        else:
            for x in obj_pessoa_end.browse(cr, uid, enderecos):
                if x.endereco_tipo_id.name == 'Comercial':
                    endereco = x.name
                    cep = x.cep
                    break
                elif x.endereco_tipo_id.name == 'Normal':
                    endereco = x.name
                    cep = x.cep
                    continue
            endereco = formataString(endereco, 145, ' ', 'D', 'N', 'S')

        # Inscricao Estadual da Empresa logada, conforme parâmetro search
        insc_est = browse_res_company.rescon_pessoa_id.admpes_jur_ie or ''
        if not insc_est:
            raise osv.except_osv(_('Atencao'),
                                 _('Inscricao estadual nao cadastrada para a empresa.'))

        insc_est = formataString(insc_est, 15, ' ', 'D', 'N', 'S')
        responsavel_nome = datas['responsavel_nome']
        respon = formataString(responsavel_nome, 25, ' ', 'D', 'N', 'S')
        name_cargo = datas['funcao']
        nome_cargo = formataString(name_cargo, 35, ' ', 'D', 'N', 'S')

        # ******************************************************************************************
        # Cabeçário Relatório

        listagem = Impressora()

        if datas['tipo_impressao'] == 'P':
            listagem.defineFormato(orientacao='1')
            listagem.informaNome(pdf_file, _('Registro de entrada'))
            listagem.informaTamLinha(81)
            listagem.defineMargem(2, 1, 1, 1)
        else:
            listagem.defineFormato(orientacao='0')
            listagem.informaNome(pdf_file, _('Registro de entrada'))
            listagem.informaTamLinha(120)
            listagem.defineMargem(1, 1, 1, 1)

        data_inicio = datas['data_ini']
        data_ini = data_inicio[8:10] + data_inicio[4:8] + data_inicio[0:4]
        data_ini = formataString(data_ini, 10, ' ', 'D', 'N', 'S')
        data_dia = time.strftime('%d-%m-%Y')
        listagem.setPage((datas.get('pagina') - 1) or 0)
        listagem.informaCab(
            '|-------------------------------------------------------------------------------------------------------------------------------------------------------|')
        listagem.informaCab(
            '|                                                                      MAPA RESUMO ECF                                                                  |')
        listagem.informaCab(
            '|FIRMA: ' + nome_empresa + u'                   Equipamento emissor de cupom fiscal                              ' + 'PAGINA: {{ Page }}' + '               |')
        listagem.informaCab(
            '|CNPJ: ' + n_cnpj + ' INSCR.ESTADUAL: ' + insc_est + '                                                                      DATA: ' + data_ini + '         |')
        listagem.informaCab(
            '|END.: ' + endereco + '|')
        listagem.informaCab(
            '|CEP: ' + cep + '                                                                                                                                        |')
        listagem.informaCab(
            '|                                                                                                                                                       |')
        listagem.informaCab(
            '|' + data_dia + '                                                                                                                                             |')
        listagem.informaCab(
            '|---------------------------------*----------*------------------------------------------*--------*--------*-------*-------------*-----*-----------------|')
        listagem.informaCab(
            '|     DOCUMENTOS FISCAIS          |          |              VALORES FISCAIS             |        |        |       |             |     |                 |')
        listagem.informaCab(
            '|-----|--------------------|------|          |------------------------------------------|        |        |       |             |     |                 |')
        listagem.informaCab(
            '|     |                    |      |  VALOR   |OP.C/DEB.IMPOSTO|    OP.S/DEB. IMPOSTO    | VALOR  |CANCELA-|DESCON-| TOTALIZADOR | COO.|    OBSERVACAO   |')
        listagem.informaCab(
            '|ECF  |    SERIE           |NUMERO|CONTABIL  |----------------|-------------------------|CONTABIL| MENTOS |  TO   |    GERAL    |     |                 |')
        listagem.informaCab(
            '|     |    (ECF)           |(crZ) |  ICMS    |  %  |  BASE    |ISENTAS |  NAO  | OUTRA. | ISS    |  ICMS  |       |     (GT)    |     |                 |')
        listagem.informaCab(
            '|     |                    |      |          |     | CALCULO  |        |TRIBUT | (ST)   |        |        |       |             |     |                 |')
        listagem.imprimeLinha(
            '|-------------------------------------------------------------------------------------------------------------------------------------------------------|')

        ecf_old = 0
        ISS = 0
        IPI = 0
        PIS = 0
        Cofins = 0
        total1 = 0
        total2 = 0
        total3 = 0
        total4 = 0
        total5 = 0
        total6 = 0
        total7 = 0
        total8 = 0
        total9 = 0
        total10 = 0

        mapa_resumo_capa_ids = obj_mapa_resumo_capa.search(cr, uid, [('data', '=', data_inicio)],
                                                           context=context)
        dados_mapa_resumo_capa = obj_mapa_resumo_capa.read(
            cr, uid, mapa_resumo_capa_ids, ['ecf', 'coo', 'gt_final', 'cancelamentos',
                                            'descontos', 'numero_z'], context=context)
        for resumo_capa in dados_mapa_resumo_capa:
            desconto = resumo_capa.get('descontos') or 0
            id_item = obj_mapa_resumo_itens.search(
                cr, uid, [('capa_id', '=', resumo_capa.get('id'))], context=context)
            base_calc = 0
            total8 += resumo_capa.get('gt_final') or 0
            total9 += resumo_capa.get('cancelamentos') or 0
            if id_item:
                read_mapa_resumo_itens = obj_mapa_resumo_itens.read(
                    cr, uid, id_item, ['imposto', 'tipo',
                                       'imposto_valor',
                                       'aliquota', 'base_valor'], context=context)
                for dados_itens in read_mapa_resumo_itens:
                    isentas = nao_tribut = outros = substituicao = 0
                    ali = dados_itens.get('aliquota')
                    vr_encargo = dados_itens.get('base_valor')
                    if ali:
                        base_calc = vr_encargo
                        if aliquota_dados.get(ali):
                            aliquota_dados[ali] += base_calc
                        else:
                            aliquota_dados[ali] = base_calc
                    if dados_itens.get('imposto') == 'C':
                        tipo_tributacao = dados_itens.get('tipo')
                        if tipo_tributacao == 'I':
                            isentas = vr_encargo
                        elif tipo_tributacao == 'T':
                            tributada = vr_encargo
                        elif tipo_tributacao == 'F':
                            substituicao = vr_encargo
                        elif tipo_tributacao == 'O':
                            nao_tribut = vr_encargo
                        elif tipo_tributacao == 'D':
                            diferido = vr_encargo
                    elif dados_itens.get('imposto') == 'S':
                        ISS = vr_encargo

                    ecf_id = resumo_capa.get('ecf') or False
                    if isinstance(ecf_id, tuple):
                        ecf_id = ecf_id[0]
                    numserie = ''
                    ecf = ''
                    if ecf_id:
                        dados_ecf = obj_ecf_ecf.read(cr, uid, [ecf_id], ['nro_serie', 'caixa'],
                                                        context=context)[0]
                        numserie = dados_ecf.get('nro_serie') or ''
                        ecf = dados_ecf.get('caixa') or ''

                    obs = formataString('', 17, ' ', 'E', 'S', 'S')
                    total1 += vr_encargo
                    total2 += base_calc
                    total3 += isentas
                    total4 += nao_tribut
                    total5 += outros
                    total6 += ISS
                    total7 += desconto

                    numero_z = resumo_capa.get('numero_z') or ''
                    cancelamentos = resumo_capa.get('cancelamentos') or 0
                    coo = resumo_capa.get('coo') or ''
                    gt_final = resumo_capa.get('gt_final') or 0

                    if ecf == ecf_old:
                        ecf = numserie = numero_z = gt_final = coo = cancelamentos = desconto = ' '
                    else:
                        ecf_old = ecf

                    ecfs = formataString(str(ecf), 5, ' ', 'E', 'S', 'S')
                    nserie = formataString(numserie, 20, ' ', 'E', 'S', 'S')
                    crz = formataString(numero_z, 6, ' ', 'E', 'S', 'S')
                    cancel = formataString(getNumeroEditado(cancelamentos, 2), 8, ' ', 'E', 'S', 'S')
                    ecf_coo = formataString(str(coo), 5, ' ', 'E', 'S', 'S')
                    encargo = formataString(getNumeroEditado(vr_encargo, 2), 10, ' ', 'E', 'S', 'S')
                    aliquota = formataString(getNumeroEditado(ali, 2), 5, ' ', 'E', 'S', 'S')
                    bs_calc = formataString(getNumeroEditado(base_calc, 2), 10, ' ', 'E', 'S', 'S')
                    isenta = formataString(getNumeroEditado(isentas, 2), 8, ' ', 'E', 'S', 'S')
                    ntrib = formataString(getNumeroEditado(nao_tribut, 2), 7, ' ', 'E', 'S', 'S')
                    subst = formataString(getNumeroEditado(substituicao, 2), 8, ' ', 'E', 'S', 'S')
                    iss = formataString(getNumeroEditado(ISS, 2), 8, ' ', 'E', 'S', 'S')
                    descont = formataString(getNumeroEditado(desconto, 2), 7, ' ', 'E', 'S', 'S')
                    xz = formataString(getNumeroEditado(gt_final, 2), 13, ' ', 'E', 'S', 'S')

                    listagem.imprimeLinha('|' + ecfs + '|' + nserie + '|' + crz + '|' + encargo +
                                          '|' + aliquota + '|' + bs_calc + '|' + isenta +
                                          '|' + ntrib + '|' + subst + '|' + iss + '|' + cancel +
                                          '|' + descont + '|' + xz + '|' + ecf_coo + '|' + obs +
                                          '|')

                    cancelamentos = desconto = 0

                listagem.imprimeLinha('|' + 151 * '-' + '|')

        total10 = ''
        if aliquota_dados:
            for aliquota in sorted(aliquota_dados):
                listagem.imprimeLinha(
                    '|' + ' ' * 44 +
                    formataString(getNumeroEditado(aliquota, 2), 6, ' ', 'E', 'S', 'S') +
                    formataString(getNumeroEditado(aliquota_dados.get(aliquota), 2), 11, ' ', 'E',
                                  'S', 'S') + ' ' * 90 + '|')
        listagem.imprimeLinha('|                     TOTAL' +
                              '        ' + formataString(getNumeroEditado(total1, 2), 10, ' ', 'E',
                                                         'S', 'S') +
                              '      ' + formataString(getNumeroEditado(total2, 2), 11, ' ', 'E',
                                                       'S', 'S') +
                              ' ' + formataString(getNumeroEditado(total3, 2), 8, ' ', 'E', 'S',
                                                  'S') +
                              ' ' + formataString(getNumeroEditado(total4, 2), 7, ' ', 'E', 'S',
                                                  'S') +
                              ' ' + formataString(getNumeroEditado(total5, 2), 8, ' ', 'E', 'S',
                                                  'S') +
                              ' ' + formataString(getNumeroEditado(total6, 2), 8, ' ', 'E', 'S',
                                                  'S') +
                              ' ' + formataString(getNumeroEditado(total9, 2), 8, ' ', 'E', 'S',
                                                  'S') +
                              ' ' + formataString(getNumeroEditado(total7, 2), 7, ' ', 'E', 'S',
                                                  'S') +
                              ' ' + formataString(getNumeroEditado(total8, 2), 13, ' ', 'E', 'S',
                                                  'S') +
                              '    ' + str(total10) + '                    |')
        listagem.imprimeLinha('|' + 151 * '-' + '|')
        listagem.imprimeLinha('| Observacoes:' + 138 * ' ' + '|')
        if datas['observacao']:
            tamanho_linha = 143
            word = datas['observacao'].split(' ')
            frase = ""
            cont = 0
            len_word = len(word)
            campo = 0
            for j in word:
                cont += 1
                size_i = len(j)
                if size_i + campo < tamanho_linha:
                    frase = frase + j + ' '
                    campo = len(frase)
                elif size_i + campo > tamanho_linha:
                    frase = formataString('' + frase, tamanho_linha, ' ', 'D', 'N', 'S')
                    listagem.imprimeLinha('|' + frase + '|')
                    frase = ''
                    frase = frase + j + ' '
                    campo = len(frase)
                if cont == len_word:
                    frase = formataString('' + frase, tamanho_linha, ' ', 'D', 'N', 'S')
                    listagem.imprimeLinha('|' + frase + '|')

        listagem.imprimeLinha('|' + 151 * '-' + '|')
        listagem.imprimeLinha('|' + 59 * ' ' + 'RESPONSAVEL PELO ESTABELECIMENTO' + 60 * ' ' + '|')
        listagem.imprimeLinha('|' + 151 * '-' + '|')
        listagem.imprimeLinha('| Nome: ' + str(respon) + 119 * ' ' + '|')
        listagem.imprimeLinha('|' + 151 * '-' + '|')
        listagem.imprimeLinha('| Funcao:   ' + nome_cargo + + 32 * ' ' + '|' + ' Assinatura: ' + 50 * '_' + 9 * ' ' + '|')
        listagem.imprimeLinha('|' + 151 * '-' + '|')

        # ****************************************************************************************
        listagem.imprimeLinha('')
        listagem.finalizaImpressao()
        obj_adm_paginas = pooler.get_pool(cr.dbname).get('adm.paginas')
        pagina_id = obj_adm_paginas.search(cr, uid,
                                           [('company_id', '=', empresa),
                                            ('tipo', '=', 'report_resumo_ecf_os'),
                                            ('data', '<=', data_inicio)], 0, 1, 'data DESC',
                                           context=context)
        if pagina_id:
            obj_adm_paginas.write(cr, uid, pagina_id,
                                  {'final': listagem.getPage(), 'tipo': 'report_resumo_ecf_osv'})
        else:
            obj_adm_paginas.create(cr, uid, {'data': data_inicio, 'company_id': empresa,
                                             'inicial': datas.get('pagina') or 1,
                                             'final': listagem.getPage(),
                                             'tipo': 'report_resumo_ecf_osv'}, context)

        self.obj = external_pdf(pdf_file.getvalue())
        self.obj.render()
        pdf_file.close()
        return (self.obj.pdf, 'pdf')


report_resumo_ecf('report.resumo.ecf')


class report_resumo_ecf_osv(osv.TransientModel):
    def parametro_id(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        company_id = self.pool.get('res.users').browse(cr, uid, uid, context=context).company_id.id
        obj_parametro = self.pool.get('adm.paginas')
        parametro_id = obj_parametro.search(cr, uid, [], context=context)
        if parametro_id:
            return parametro_id[0]
        else:
            return []

    def pagina_parametro(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        final = 0
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
        obj_adm_paginas = self.pool.get('adm.paginas')
        id_pagina = obj_adm_paginas.search(cr, uid,
                                           [('company_id', '=', company_id),
                                            ('tipo', '=', 'report_resumo_ecf_os'),
                                            ('data', '<=', time.strftime('%Y-%m-%d'))], 0, 1,
                                           'data DESC', context=context)
        if not id_pagina:
            obj_adm_paginas.create(cr, uid,
                                   {'data': time.strftime('%Y-%m-%d'), 'company_id': company_id,
                                    'inicial': 1, 'tipo': 'report_resumo_ecf_osv'}, context)
        else:
            final = obj_adm_paginas.browse(cr, uid, id_pagina[0]).final
            if not final:
                final = obj_adm_paginas.browse(cr, uid, id_pagina[0]).inicial
            if final:
                final += 1
                obj_adm_paginas.write(cr, uid, id_pagina, {'data': time.strftime('%Y-%m-%d'),
                                                           'final': final}, context)

            else:
                obj_adm_paginas.write(cr, uid, id_pagina, {'data': time.strftime('%Y-%m-%d'),
                                                           'inicial': 1,
                                                           'final': 1}, context)
        return final

    def periodo(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        parametro_id = self.parametro_id(cr, uid, ids, context)
        company_id = self.pool.get('res.users').browse(cr, uid, uid, context=context).company_id.id
        obj_pagina = self.pool.get('adm.paginas')
        id_pagina = obj_pagina.search(cr, uid, [('company_id', '=', company_id),
                                                ('tipo', '=', 'report_resumo_ecf_os')], context=context)
        if id_pagina:
            id_data = obj_pagina.read(cr, uid, parametro_id, ['data'], context=context)
            data = id_data['data']

            return data


    _name = 'resumo.ecf.osv'
    _description = 'Mapa Resumo Ecf'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa'),
        'tipo_impressao': fields.selection([('R', 'Retrato'), ('P', 'Paisagem')], 'Tipo Impressao',
                                           help='Por padrao Retrato A4'),
        'responsavel': fields.many2one('adm.pessoa', 'Responsavel'),
        'funcao': fields.char('Funcao', size=35),
        'data_ini': fields.date('Data', help='Data inicial geracao relatorio'),
        'pagina': fields.integer('Pagina', help='Informe a folha inicial'),
        'observacao': fields.text('Observacao'),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(cr, uid,
                                                                           uid).company_id.id,
        'tipo_impressao': lambda *a: 'R',
        'pagina': pagina_parametro,
        'data_ini': periodo
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = self.read(cr, uid, ids[0], [], context=context)
        company_id = []
        nome_empresa = False
        if vals.get('company_id'):
            company_id = vals.get('company_id')
            if isinstance(company_id, tuple):
                company_id = company_id[0]
            if not isinstance(company_id, list):
                company_id = [company_id]
            res_company_dados = self.pool.get("res.company").read(cr, uid, company_id, ['name'], context=context)
            for x in res_company_dados:
                nome_empresa = x.get("name")
        responsavel_nome = vals['responsavel'][1]
        funcao = vals['funcao'] or ''
        datas = {
            'company_id': company_id,
            'nome_empresa': nome_empresa,
            'tipo_impressao': vals.get('tipo_impressao'),
            'data_ini': vals.get('data_ini'),
            'pagina': vals.get('pagina'),
            'observacao': vals.get('observacao'),
            'responsavel_nome': responsavel_nome,
            'funcao': funcao
        }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'resumo.ecf',
            'datas': datas,
        }


report_resumo_ecf_osv()





