# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class wizard_gerar_nf_cupons(osv.TransientModel):
    from funcoes import _get_cupons_validos

    _name = 'wizard.gerar.nf.cupons'

    _columns = {
        'cupom_ids': fields.function(_get_cupons_validos, method=True, string="Cupons", type="one2many",
                                     relation="ecf.cupons.capa", store=False),
    }

    def default_get(self, cr, uid, fields, context=None):
        context = context and context.copy() or {}
        res = super(wizard_gerar_nf_cupons, self).default_get(cr, uid, fields, context)
        cupom_ids = []
        if context.get('active_ids'):
            cupom_ids = self.pool.get('ecf.cupons.capa').search(cr, uid, [('tipo_cupom', '=', 'V'),
                                                                          ('nf_id', '=', False),
                                                                          ('state', '=', 'V'),
                                                                          ('id', 'in', context.get('active_ids'))],
                                                                context=context)
        res['cupom_ids'] = cupom_ids
        return res

    def gerar_nf_cupons(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_ecf_cupons_capa = self.pool.get('ecf.cupons.capa')

        if context.get('active_ids'):
            cupom_ids = obj_ecf_cupons_capa.search(cr, uid, [('tipo_cupom', '=', 'V'),
                                                             ('nf_id', '=', False),
                                                             ('state', '=', 'V'),
                                                             ('id', 'in', context.get('active_ids'))
                                                             ], context=context)
            if cupom_ids:
                if len(cupom_ids) > 1:
                    brw_cupons = obj_ecf_cupons_capa.browse(cr, uid, cupom_ids)
                    clientes = []
                    for x in brw_cupons:
                        if x.cliente_id:
                            clientes.append(x.cliente_id.id)
                    # verifica se s
                    if clientes and len(list(set(clientes))) == 1:
                        context.update({'cupons_mesmo_cliente': True})

                self.pool.get('fiscal.nf.capa').gerar_nf_cupom(cr, uid, cupom_ids, context)
        return True
