# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _


class wizard_listagem_cupons(osv.TransientModel):
    _name = 'wizard.listagem.cupons'
    _columns = {
        'data_inicial': fields.date('Data incial', required=True),
        'data_final': fields.date('Data final', required=True),
        'loja': fields.integer('Loja', required=True),
        'caixa': fields.integer('Caixa', required=True),
        'cupom_id': fields.many2one('ecf.cupons.capa', 'Cupom'),
        'opcao': fields.selection([('S', 'Sintetico'), ('A', 'Analitico')], 'Opcao', size=1, required=True),
        'ecf_id': fields.many2one('ecf.ecf', 'Ecf'),
    }
    _defaults = {
        'opcao': 'S',
        'loja': False,
        'caixa': False,
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        browse_listagem_cupons = self.browse(cr, uid, ids)
        for x in browse_listagem_cupons:
            if not x.loja or not x.caixa:
                raise osv.except_osv(_('Atencao'), _('Loja e caixa devem ser informados'))
            datas = {
                'data_inicial': x.data_inicial,
                'data_final': x.data_final,
                'loja': x.loja,
                'caixa': x.caixa,
                'cupom_id': x.cupom_id.id,
                'opcao': x.opcao,
            }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'listagem_cupons',
            'datas': datas,
        }

    def onchange_loja_caixa(self, cr, uid, ids, loja, caixa, context=None):
        context = context and context.copy() or {}
        res = {}
        args_ecf = []
        obj_ecf_ecf = self.pool.get('ecf.ecf')
        if loja:
            args_ecf.append(('loja', '=', loja), )
        if caixa:
            args_ecf.append(('caixa', '=', caixa))
        if args_ecf:
            ecf_id = obj_ecf_ecf.search(cr, uid, args_ecf, context=context)
            if ecf_id:
                res['ecf_id'] = ecf_id[0]
        return {'value': res}
