# -*- coding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _


class energia_projeto_consumos(osv.Model):

    _inherit = 'energia.projeto.consumos'

    def enepco_button_get_latitude(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        try:
            from geopy.geocoders import Nominatim
            geolocator = Nominatim()
        except:
            raise osv.except_osv(_('Atencao'), _('Nao consegui obter a latitude/longitude. '
                                                 'Verifique se o modulo "geopy" esta instalado!'))
        brw_projeto_consumos = self.browse(cr, uid, ids, context=context)

        for _consumo in brw_projeto_consumos:
            if not _consumo.enepco_endereco_id:
                raise osv.except_osv(_('Atencao'), _('O endereco da unidade nao esta cadastrado!'))
            _end = u'%s %s, %s, %s, %s' % (
                _consumo.enepco_endereco_id.logradouro_id.descricao,
                _consumo.enepco_endereco_id.numero,
                _consumo.enepco_endereco_id.cidade_id.name,
                _consumo.enepco_endereco_id.uf_id.sigla,
                _consumo.enepco_endereco_id.pais_id.name)
            location = geolocator.geocode(_end)
            _latitude = location.latitude if location else 0
            _longitude = location.longitude if location else 0
            res = self.write(cr, uid, _consumo.id, {'enepco_latitude': _latitude,
                                                    'enepco_longitude': _longitude}, context)
        return res
