# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv


class energia_painel_fotovoltaico(osv.Model):
    _inherit = 'energia.painel.fotovoltaico'

    def enepfv_get_caracteristicas(self, cr, uid, ids, temperatura=None, estrutura=None):
        """
        Retorna caracteristicas tecnicas do painal, já corrigido pela temperatura.
        Se nao for imformada a temperatura, sera retornado as caracteristicas sob condicoes de laboratorio
        @param cr:
        @param uid:
        @param ids:
        @param temperatura: Temperatura em graus
        @param estrutura: Tipo de estrutura, conforme selection do projeto
        @return: dicionario com id e outro dicionario com caracteristicas ex: {05:{....}}
        """
        dados_paineis = self.read(cr, uid, ids)
        res = {}
        _temp = 0
        if temperatura:
            _temp = int(temperatura) or 0
        if estrutura:
            _temp += int(estrutura or 0)
        for x in dados_paineis:
            _pmax = x.get('enepfv_pmax') * ((100 + (x.get('enepfv_temp_pmax') * _temp)) / 100)
            _vmp = x.get('enepfv_vmp') * ((100 + (x.get('enepfv_temp_pmax') * 60)) / 100)
            _imp = x.get('enepfv_imp')
            _voc = x.get('enepfv_voc') * ((100 + (x.get('enepfv_temp_voc') * -35)) / 100)
            _isc = x.get('enepfv_isc') * ((100 + (x.get('enepfv_temp_isc') * 60)) / 100)
            res[x.get('id')] = {
                'enepfv_pmax': _pmax,
                'enepfv_vmp': _vmp,
                'enepfv_imp': _imp,
                'enepfv_voc': _voc,
                'enepfv_isc': _isc,
                'enepfv_tensao_maxima': x.get('enepfv_tensao_maxima'),
                'enepfv_fusivel_maximo': x.get('enepfv_fusivel_maximo'),
                'enepfv_temp_pmax': x.get('enepfv_temp_pmax'),
                'enepfv_temp_voc': x.get('enepfv_temp_voc'),
                'enepfv_temp_isc': x.get('enepfv_temp_isc'),
                'enepfv_comprimento': x.get('enepfv_comprimento'),
                'enepfv_largura': x.get('enepfv_largura'),
                'enepfv_espessura': x.get('enepfv_espessura'),
                'enepfv_peso': x.get('enepfv_peso')
            }
        return res
