#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _

meses = ('Jan', 'Fev', 'Mar', 'Abr', 'Mai', 'Jun', 'Jul', 'Ago', 'Set', 'Out', 'Nov', 'Dez')
dias = {
    '01': 31,
    '02': 28,
    '03': 31,
    '04': 30,
    '05': 31,
    '06': 30,
    '07': 31,
    '08': 31,
    '09': 30,
    '10': 31,
    '11': 30,
    '12': 31,
}


class energia_projetos(osv.Model):
    _inherit = 'energia.projetos'

    def _eneprj_calcular_strings(self, cr, uid, brw_projeto, context=None):
        # Calcular strings dos mppts
        obj_paineis = self.pool.get('energia.painel.fotovoltaico')
        mens_strings = ''
        mens_sobras = ''
        _dInstalacoes = {}
        instalacoes_keys = {}
        _nro_instalacao = 0
        if not brw_projeto.eneprj_instalacao_ids:
            return {'status': False, 'mensagem': _('Sem locais de instalacao cadastrados!')}
        for brw_instalacao in brw_projeto.eneprj_instalacao_ids:
            _nro_instalacao += 1
            _i_ids = []
            for x in brw_instalacao.enepji_projeto_inversor_ids:
                _i_ids.append(x.id)
            if not brw_instalacao.enepji_geradora_id:
                return {'status': False, 'mensagem': _('O local de instalacao "%s", nao tem Unidade geradora cadastrada!') % brw_instalacao.enepji_descricao}
            if not brw_instalacao.enepji_geradora_id.enepco_tipo_estrutura:
                return {'status': False, 'mensagem': _('A unidade geradora "%s", nao tem tipo de estrutura cadastrado!') % brw_instalacao.enepji_geradora_id.name }
            if not brw_instalacao.enepji_geradora_id.enepco_temp_max:
                return {'status': False, 'mensagem': _('A unidade geradora "%s", nao tem temperatura maxima cadastrado!') % brw_instalacao.enepji_geradora_id.name }
            _d = {
                'inversores_ids': _i_ids,
                'painel_id':brw_instalacao.enepji_painel_id.id,
                'qtd_paineis': brw_instalacao.enepji_quantidade_paineis,
                'descricao': brw_instalacao.enepji_descricao,
                'tipo_estrutura': brw_instalacao.enepji_geradora_id.enepco_tipo_estrutura,
                'temp_max': brw_instalacao.enepji_geradora_id.enepco_temp_max,
            }
            _dInstalacoes[_nro_instalacao] = _d                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     
        for _brw_inversor in brw_projeto.eneprj_inversores_ids:
            _vmin = _brw_inversor.enepiv_inversor_id.eneinv_vmpptmin
            _vmax = _brw_inversor.enepiv_inversor_id.eneinv_vmpptmax or _brw_inversor.enepiv_inversor_id.eneinv_vdcmax
            _vdcmax = _brw_inversor.enepiv_inversor_id.eneinv_vdcmax
            _qtd_mppts = len(_brw_inversor.enepiv_inversor_id.eneinv_mppt_ids) or 1
            _qtd_strings = 0
            _mppts = {}
            _nro_mppt = 0
            for brw_mppt in _brw_inversor.enepiv_inversor_id.eneinv_mppt_ids:
                _nro_mppt += 1
                _mppts['mppt-%s' % _nro_mppt] = {
                    'qtd_string': brw_mppt.eneinvmppt_strng_qtd,
                    'imax': brw_mppt.eneinvmppt_string_i_max,
                    'strings': {'qtdp': 0},
                    'bloq': 'N'
                }
                _nro_string = 0
                for i in range(brw_mppt.eneinvmppt_strng_qtd):
                    _nro_string = i + 1
                    _mppts['mppt-%s' % _nro_mppt]['strings']['string-%s' % _nro_string] = {'usado': 'N'}
            instalacoes_keys = _dInstalacoes.keys()
            instalacoes_keys.sort()
            for instalacao_key in instalacoes_keys:
                _instalacao = _dInstalacoes.get(instalacao_key)
                if not _instalacao.get('inversores_ids'):
                    return {'status': False, 'mensagem': _(
                        'Para a instalacao %s nao ha inversor configurado!') % _instalacao.get('descricao')}
                if not _instalacao.get('painel_id'):
                    return {'status': False, 'mensagem': _(
                        'Para a instalacao %s nao ha paineis configurados!') % _instalacao.get('descricao')}
                tem_x = False
                for x in _instalacao.get('inversores_ids'):
                    if x !=  _brw_inversor.id:
                        continue # esta instalação não é deste inversor
                    tem_x = True
                    break
                if not tem_x:
                    continue
                _qtd_paineis_da_instalacao = _instalacao.get('qtd_paineis')
                _dados_painel = obj_paineis.enepfv_get_caracteristicas(cr, uid, [_instalacao.get('painel_id')],
                                                                       temperatura=_instalacao.get('temp_max'),
                                                                       estrutura=_instalacao.get('tipo_estrutura'))
                if _dados_painel:
                    _dados_painel = _dados_painel.get(_instalacao.get('painel_id'))
                    _voc = _dados_painel.get('enepfv_voc')
                    _vmp = _dados_painel.get('enepfv_vmp')
                    _qtd_por_string = int(_vmax / _vmp)
                    while _qtd_por_string * _voc > _vdcmax:
                        _qtd_por_string = _qtd_por_string - 1
                    _mppt_keys = _mppts.keys()
                    _mppt_keys.sort()
                    for _mppt_key in _mppt_keys:
                        if not _mppt_key.startswith('mppt-'):
                            continue
                        _mppt = _mppts.get(_mppt_key)
                        if _mppt.get('bloq') == 'S':
                            continue
                        _qtd_de_strings = _mppt.get('qtd_string')
                        _string_keys = _mppt.get('strings').keys()
                        _string_keys.sort()
                        for _string_key in _string_keys:
                            if not _string_key.startswith('string-'):
                                continue
                            _string = _mppt.get('strings').get(_string_key)
                            _qtdp = _mppt.get('strings').get('qtdp')
                            if _qtdp == 0:
                                _qtdp = _qtd_por_string
                                if _qtd_paineis_da_instalacao < _qtd_por_string:
                                    if (_qtd_paineis_da_instalacao * _vmp) >= _vmin:
                                        _qtdp = _qtd_paineis_da_instalacao
                                else:
                                    if _qtd_paineis_da_instalacao < (_qtd_de_strings * _qtd_por_string):
                                        _qtdp = _qtd_paineis_da_instalacao / _qtd_de_strings
                            if _qtd_paineis_da_instalacao < _qtdp: # Não posso usar nesta string
                                continue
                            if _string.get('usado') != 'N':
                                continue
                            _qtd_paineis_da_instalacao -= _qtdp
                            _mppt['strings']['qtdp'] = _qtdp
                            _string['usado'] = 'S'
                            _mppt['instalacao'] = _instalacao.get('descricao')
                            _mppt['strings'][_string_key] = _string
                        _mppts[_mppt_key] = _mppt
                # fim de um local de instalacao
                for _mppt_key in _mppts:
                    if not _mppt_key.startswith('mppt-'):
                        continue
                    _mppt = _mppts.get(_mppt_key)
                    if _mppt.get('strings').get('qtdp') != 0:
                        _mppt['bloq'] = 'S'
                    _mppts[_mppt_key] = _mppt
                _dInstalacoes[instalacao_key]['qtd_paineis'] =  _qtd_paineis_da_instalacao
            mens_strings += _('-> Inversor: %s\n') % _brw_inversor.enepiv_inversor_id.eneinv_produto_id.name
            _mppt_keys = _mppts.keys()
            _mppt_keys.sort()
            for _mppt_key in _mppt_keys:
                if not _mppt_key.startswith('mppt-'):
                    continue
                _mppt = _mppts.get(_mppt_key)
                if _mppt.get('instalacao'):
                    mens_strings += _('--> Instalacao: %s\n') % _mppt.get('instalacao')
                _string_keys = _mppt.get('strings').keys()
                _string_keys.sort()
                _mens = '---> %s\n' % _mppt_key
                for _string_key in _string_keys:
                    if not _string_key.startswith('string-'):
                        continue
                    _string = _mppt.get('strings').get(_string_key)
                    if _string.get('usado') == 'S':
                        _qtd = _mppt.get('strings').get('qtdp')
                        if _mens:
                            mens_strings += _mens
                            _mens = ''
                        mens_strings += _('----> %s Paineis qtd: %s\n') % (_string_key, _qtd)
                    else:
                        if _mens:
                            mens_strings += _mens
                            _mens = ''
                        mens_strings += _('----> %s Sem uso\n') % _string_key

        for instalacao_key in instalacoes_keys:
            _instalacao = _dInstalacoes.get(instalacao_key)
            if _instalacao.get('qtd_paineis') > 0:
                mens_sobras = mens_sobras + _('====> %s painel(is) do local %s\n') % (_instalacao.get('qtd_paineis'), _instalacao.get('descricao'))
        if mens_sobras:
            mens_strings += _('==> Sobraram:\n') + mens_sobras
        return {'status': True, 'mensagem': '', 'resultado': mens_strings}

    def _eneprj_calcular_linhas(self, cr, uid, brw_projeto, context=None):
        # Calcular linhas de paineis
        obj_instalacao = self.pool.get('energia.projetos.instalacao')
        res = []
        for brw_instalacao in brw_projeto.eneprj_instalacao_ids:
            if not brw_instalacao.enepji_active:
                continue
            _instalacao = {}
            _instalacao['descricao'] = brw_instalacao.enepji_descricao
            # mens += '--> %s\n' % brw_instalacao.enepji_descricao
            _cap_pos = obj_instalacao._enepji_calcular_paineis_por_area(cr, uid, brw_instalacao.id, context=None)
            # _dados_dict = obj_instalacao._enepji_calcular_paineis(cr, uid, [brw_instalacao.id], context)
            if brw_instalacao.enepji_capacidade_posicao == 'R':
                _qtd_largura = _cap_pos.get('qtd_largura_retrato')
                _qtd_comprimento = _cap_pos.get('qtd_comprimento_retrato')
            else:
                _qtd_largura = _cap_pos.get('qtd_largura_paisagem')
                _qtd_comprimento = _cap_pos.get('qtd_comprimento_paisagem')
            _qtd_paineis = brw_instalacao.enepji_quantidade_paineis
            if not _qtd_paineis:
                res = {'status': False, 'mensagem': _('Quantidade de paineis nao informados no local de instalacao "%s"!' % brw_instalacao.enepji_descricao)}
                return res
            if not (_qtd_comprimento and _qtd_largura):
                res = {'status': False, 'mensagem': _('Largura ou comprimento nao informados no local de instalacao "%s"!' % brw_instalacao.enepji_descricao)}
                return res
            _qtd_nas_linhas = int(_qtd_paineis / _qtd_largura)
            if _qtd_nas_linhas != 1.0 * _qtd_paineis / _qtd_largura:  # Forçar resultado em float
                _qtd_nas_linhas += 1
            _qtd_de_linhas = int(_qtd_paineis / _qtd_nas_linhas)
            if _qtd_de_linhas != 1.0 * _qtd_paineis / _qtd_nas_linhas:  # Forçar resultado em float
                _qtd_de_linhas += 1
            if _qtd_de_linhas * _qtd_nas_linhas == _qtd_paineis:
                # mens += '%s linha(s) com %s painel(is).\n' % (_qtd_de_linhas, _qtd_nas_linhas)
                _instalacao['linhas'] = [{'qtd_de_linhas': _qtd_de_linhas,'qtd_na_linha': _qtd_nas_linhas}]
            else:
                _resto = _qtd_paineis - ((_qtd_de_linhas -1) * _qtd_nas_linhas)
                # mens += '%s linha(s) com %s painel(is).\n' % (_qtd_de_linhas-1, _qtd_nas_linhas)
                _instalacao['linhas'] = [{'qtd_de_linhas': _qtd_de_linhas-1,'qtd_na_linha': _qtd_nas_linhas}]
                # mens += '1 linha(s) com %s painel(is).\n' % _resto
                _instalacao['linhas'].append({'qtd_de_linhas': 1, 'qtd_na_linha': _resto})
            res.append(_instalacao)
        if not res:
            return {'status': False, 'mensagemn': _('Nao ha locais de instalacao cadastrados no projeto!')}
        return {'status': True, 'resultado': res}

    def eneprj_button_calcular(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        brw_projetos = self.browse(cr, uid, ids, context=context)
        _tx_minima = 0
        for _projeto in brw_projetos:
            _mens_linhas = ''
            _inst_ids = map(lambda i: i.id, _projeto.eneprj_instalacao_ids)
            self.pool.get('energia.projetos.instalacao').enepji_button_calcular(cr, uid, _inst_ids, context=context)
            res_linhas = self._eneprj_calcular_linhas(cr, uid, _projeto, context=context)
            if res_linhas.get('status') == False:
                raise osv.except_osv(_('Atencao'), res_linhas.get('mensagem'))
            for _instalacao in res_linhas.get('resultado'):
                _mens_linhas += _('--> %s\n') % _instalacao.get('descricao')
                for _linha in _instalacao.get('linhas'):
                    _mens_linhas += _('%s linha(s) com %s painel(is).\n') % (
                        _linha.get('qtd_de_linhas'), _linha.get('qtd_na_linha'))
            res = self._eneprj_calcular_strings(cr, uid, _projeto, context=context)
            if res.get('status') == False:
                raise osv.except_osv(_('Atencao'), res.get('mensagem'))
            _strings = res.get('resultado')
            _itens_ids = _projeto.eneprj_itens_ids or []
            for x in _itens_ids:
                self.pool.get('energia.projetos.itens').unlink(cr, uid, x.id)
            # Calculando o consumo
            vals1 = {
                'enepri_projeto_id': _projeto.id,
                'enepri_sequencia': 1,
                'enepri_descricao': _('Consumo'),
                'enepri_mes_01': _projeto.eneprj_mes_01,
                'enepri_mes_02': _projeto.eneprj_mes_02,
                'enepri_mes_03': _projeto.eneprj_mes_03,
                'enepri_mes_04': _projeto.eneprj_mes_04,
                'enepri_mes_05': _projeto.eneprj_mes_05,
                'enepri_mes_06': _projeto.eneprj_mes_06,
                'enepri_mes_07': _projeto.eneprj_mes_07,
                'enepri_mes_08': _projeto.eneprj_mes_08,
                'enepri_mes_09': _projeto.eneprj_mes_09,
                'enepri_mes_10': _projeto.eneprj_mes_10,
                'enepri_mes_11': _projeto.eneprj_mes_11,
                'enepri_mes_12': _projeto.eneprj_mes_12,
                'enepri_total': _projeto.eneprj_anual,
                'enepri_media': _projeto.eneprj_media,
            }
            vals_prj = {
                'eneprj_itens_ids': [(0, 0, vals1)],
                'eneprj_detalhe_linhas': _mens_linhas,
                'eneprj_detalhe_strings': _strings
            }
            # Calculando a producao
            _prod_total = 0
            vals1 = {
                'enepri_projeto_id': _projeto.id,
                'enepri_sequencia': 2,
                'enepri_descricao': _('Producao'),
            }
            for x in ('01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'):
                exec ('_prod_1_%s = 0' % x)
            for _brw_instalacao in _projeto.eneprj_instalacao_ids:
                if (_brw_instalacao.enepji_geradora_id and
                    _brw_instalacao.enepji_geradora_id.enepco_padrao_id):
                    _tx_minima = _brw_instalacao.enepji_geradora_id.enepco_padrao_id.enepdr_tx_minimo
                if not _brw_instalacao.enepji_active:
                    continue
                for x in ('01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'):
                    exec (
                        '_prod_1 = _brw_instalacao.enepji_potencia_1 * _brw_instalacao.enepji_irradiancia_id.eneirr_mes_%s * %i' % (x, dias.get(x)))
                    exec ('_prod_1_%s += _prod_1 ' % x)
                    _prod_total += _prod_1
                    exec ("vals1['enepri_mes_%s'] = _prod_1_%s" % (x, x))
            try:
                x = _prod_1
            except:
                raise osv.except_osv(_('Atencao'), _('Nao encontrei esta opcao nas instalações!'))

            vals1['enepri_total'] = _prod_total
            vals1['enepri_media'] = _prod_total / 12
            vals_prj['eneprj_itens_ids'].append((0, 0, vals1))
            # Calculando a diferenca
            _dif_total = 0
            vals1 = {
                'enepri_projeto_id': _projeto.id,
                'enepri_sequencia': 3,
                'enepri_descricao': _('Diferenca'),
            }
            for x in ('01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'):
                exec ("_dif_%s = _prod_1_%s - _projeto.eneprj_mes_%s" % (x, x, x))
                exec ("vals1['enepri_mes_%s'] = _dif_%s" % (x, x))
                exec ("_dif_total += _dif_%s" % x)
            vals1['enepri_total'] = _dif_total
            vals1['enepri_media'] = _dif_total / 12
            vals_prj['eneprj_itens_ids'].append((0, 0, vals1))

            # Calculando a debitos
            _deb_total = 0
            vals1 = {
                'enepri_projeto_id': _projeto.id,
                'enepri_sequencia': 4,
                'enepri_descricao': _('Debitos'),
            }
            if not _tx_minima:
                raise osv.except_osv(_('Atencao'), _('Tipo de padrao nao identificado'))
            for x in ('01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'):
                exec ("_deb_%s = _"
                      "dif_%s + _tx_minima if _dif_%s < -_tx_minima else 0" % (x, x, x))
                exec ("vals1['enepri_mes_%s'] = _deb_%s " % (x, x))
                exec ("_deb_total += _deb_%s" % x)
            vals1['enepri_total'] = _deb_total
            vals1['enepri_media'] = _deb_total / 12
            vals_prj['eneprj_itens_ids'].append((0, 0, vals1))

# Calculando a creditos
            _cre_total = 0
            vals1 = {
                'enepri_projeto_id': _projeto.id,
                'enepri_sequencia': 5,
                'enepri_descricao': _('Creditos'),
            }
            for x in ('01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'):
                exec ("_cre_%s = _dif_%s if _prod_1_%s > _projeto.eneprj_mes_%s else 0" % (x, x, x, x))
                exec ("vals1['enepri_mes_%s'] = _cre_%s" % (x, x))
                exec ("_cre_total += _cre_%s" % x)
            vals1['enepri_total'] = _cre_total
            vals1['enepri_media'] = _cre_total / 12
            vals_prj['eneprj_itens_ids'].append((0, 0, vals1))
            _saldo = _cre_total + _deb_total
            if _saldo < 0:
                vals_prj['eneprj_saldo_creditos'] = 0
            else:
                vals_prj['eneprj_saldo_creditos'] = _saldo
            res = self.write(cr, uid, _projeto.id, vals_prj, context)
        return True


    def eneprj_button_grafico(self, cr, uid, ids, tipo, context=None):
        context = context and context.copy() or {}
        obj_grafico = self.pool.get('energia.grafico.ano.osv')
        for brw_projeto in self.browse(cr, uid, ids, context=context):
            linha_ids = obj_grafico.search(cr, uid, [('enegfa_projeto_id', '=', brw_projeto.id)], context=context)
            if linha_ids:
                obj_grafico.unlink(cr, uid, linha_ids, context=context)
            for brw_item in brw_projeto.eneprj_itens_ids:
                if ((tipo == 'Consumo' and brw_item.enepri_sequencia == 1) or
                    (tipo == 'Producao' and brw_item.enepri_sequencia == 2) or
                    (tipo == 'Conjunto' and brw_item.enepri_sequencia in (1,2))):
                    for i in range(1,13):
                        _enepri_mes = 'brw_item.enepri_mes_%s' % '%s' % str(i).rjust(2, '0')
                        vals = {
                            'enegfa_projeto_id': brw_item.enepri_projeto_id.id,
                            'enegfa_mes_nro': i,
                            'enegfa_mes_sigla': meses[i-1],
                        }
                        if tipo == 'Conjunto':
                            if brw_item.enepri_sequencia == 1:
                                vals['enegfa_quantidade1'] = eval(_enepri_mes)
                            if brw_item.enepri_sequencia == 2:
                                vals['enegfa_quantidade2'] = eval(_enepri_mes)
                        else:
                            vals['enegfa_quantidade1'] = eval(_enepri_mes)
                        args = [('enegfa_projeto_id', '=', brw_item.enepri_projeto_id.id),
                                ('enegfa_mes_nro', '=', i)]
                        grafico_ids = obj_grafico.search(cr, uid, args, context=context)
                        if grafico_ids:
                            obj_grafico.write(cr, uid, grafico_ids, vals, context=context)
                        else:
                            obj_grafico.create(cr, uid, vals, context=context)

        obj_model_data = self.pool.get('ir.model.data')
        if tipo == 'Conjunto':
            reference = obj_model_data.get_object_reference(cr, uid, 'energia', 'view_grafico_ano_duplo_graph')
        else:
            reference = obj_model_data.get_object_reference(cr, uid, 'energia', 'view_grafico_ano_unico_graph')
        view_id = reference and reference[1] or False
        _domain = "[('enegfa_projeto_id', '=', %s)]" % brw_item.enepri_projeto_id.id
        view = {
            'view_type': 'form',
            'view_mode': 'graph',
            'res_model': 'energia.grafico.ano.osv',
            'view_id': [view_id],
            'target': 'new',
            'type': 'ir.actions.act_window',
            'domain': _domain,
        }
        if tipo == 'Conjunto':
            view['name'] = 'Combinado'
        else:
            view['name'] = tipo
        return view

    def eneprj_button_grafico_consumo(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return self.eneprj_button_grafico(cr, uid, ids, 'Consumo', context)

    def eneprj_button_grafico_producao(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return self.eneprj_button_grafico(cr, uid, ids, 'Producao', context)

    def eneprj_button_grafico_conjunto(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return self.eneprj_button_grafico(cr, uid, ids, 'Conjunto', context)

    def _eneprj_confere_perc_participacao(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not ids:
            return True
        _mens = u''
        if isinstance(ids, (int, long)):
            ids = [ids]
        for brw_projeto in self.browse(cr, uid, ids, context):
            _perc = 0
            for brw_consumo in brw_projeto.eneprj_consumo_ids:
                if brw_consumo.enepco_tipo == 'UC':
                    _perc += brw_consumo.enepco_percentual_a_receber
            if _perc in (0, 100):
                continue
            _mens += _(u'\nNo projeto %s, a distribuicao do excedente gerado nao e de 100 porcento!' % brw_projeto.name)
        if _mens:
            raise osv.except_osv(_('Atencao:'), _mens)
        return True

    def create(self, cr, uid, vals, context=None):
        res = super(energia_projetos, self).create(cr, uid, vals, context=context)
        if res:
            self._eneprj_confere_perc_participacao(cr, uid, [res], context)
        return res


    def write(self, cr, uid, ids, vals, context=None):
        res = super(energia_projetos, self).write(cr, uid, ids, vals, context=context)
        if res:
            self._eneprj_confere_perc_participacao(cr, uid, ids, context)
        return res
