# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2015 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2015, Creative Commons
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""


def eneirr_get_media(self, cr, user, ids, fild_name, arg, context=None):
    """
    Calcula a media anual

    :param cr: a linha atual do cursor do banco de dados,
    :param user: ID do usuario utilizado para a verificacao de perfil,
    :param ids: lista dos IDs,
    :param fild_name: lista com o nome dos campos,
    :param arg: dicionario com os argumentos e valores,
    :param context: um dicionario padrao para valores contextuais,
    :type cr: cursor
    :type user: int
    :type ids: long|list[long]
    :type arg: dict
    :type context: dict
    :return: media anual calculada
    :rtype: dict
    """

    context = context and context.copy() or {}
    result = {}.fromkeys(ids, 0.0)

    for brw_irradiancia in self.browse(cr, user, ids if isinstance(ids, list) else [ids]):
        result[brw_irradiancia.id] = (brw_irradiancia.eneirr_mes_01 +
                                      brw_irradiancia.eneirr_mes_02 +
                                      brw_irradiancia.eneirr_mes_03 +
                                      brw_irradiancia.eneirr_mes_04 +
                                      brw_irradiancia.eneirr_mes_05 +
                                      brw_irradiancia.eneirr_mes_06 +
                                      brw_irradiancia.eneirr_mes_07 +
                                      brw_irradiancia.eneirr_mes_08 +
                                      brw_irradiancia.eneirr_mes_09 +
                                      brw_irradiancia.eneirr_mes_10 +
                                      brw_irradiancia.eneirr_mes_11 +
                                      brw_irradiancia.eneirr_mes_12) / 12
    return result


def eneirr_get_name(self, cr, user, ids, fild_name, arg, context=None):
    """
    Define nome para irradiancia; composto de Fonte, Latitude, orientacao e inclinacao

    :param cr: a linha atual do cursor do banco de dados,
    :param user: ID do usuario utilizado para a verificacao de perfil,
    :param ids: lista dos IDs,
    :param fild_name: lista com o nome dos campos,
    :param arg: dicionario com os argumentos e valores,
    :param context: um dicionario padrao para valores contextuais,
    :type cr: cursor
    :type user: int
    :type ids: long|list[long]
    :type arg: dict
    :type context: dict
    :return: media anual calculada
    :rtype: dict
    """

    context = context and context.copy() or {}
    result = {}.fromkeys(ids, 0.0)
    for brw_irradiancia in self.browse(cr, user, ids if isinstance(ids, list) else [ids]):
        _desvio = brw_irradiancia.eneirr_desvio
        if _desvio < 0:
            _desvio = _desvio * -1
        result[brw_irradiancia.id] = u'%s / %s /Desv:%s /Inc:%s' % (
        brw_irradiancia.eneirr_descricao, brw_irradiancia.eneirr_fonte, _desvio, brw_irradiancia.eneirr_inclinacao)
        return result


def eneprj_get_dados(self, cr, user, ids, fild_name, arg, context=None):
    """
    Calcula a quantidade produzida, soma da opcao de instalacao escolhida e a potencia total
    Calcula a media anual e o consumo anual
    @param cr:
    @param user:
    @param ids:
    @param fild_name:
    @param arg:
    @param context:
    @return:
    """
    context = context and context.copy() or {}
    result = {}.fromkeys(ids, 0.0)
    for brw_projeto in self.browse(cr, user, ids, context=context):
        _potencia_inversores = _qtd_mppts = _qtd_strings = 0
        for brw_inversores in brw_projeto.eneprj_inversores_ids:
            _potencia_inversores += brw_inversores.enepiv_potencia
            _qtd_mppts += brw_inversores.enepiv_mppt_qtd
            _qtd_strings += brw_inversores.enepiv_mppt_qtd_string
        _potencia = _qtd = _potencia_pico = 0
        _mes_01 = _mes_02 = _mes_03 = _mes_04 = _mes_05 = _mes_06 = 0
        _mes_07 = _mes_08 = _mes_09 = _mes_10 = _mes_11 = _mes_12 = 0
        for _brw_instalacao in brw_projeto.eneprj_instalacao_ids:
            _potencia += _brw_instalacao.enepji_potencia_1
            _potencia_pico += _brw_instalacao.enepji_potencia_pico_1
            _qtd += _brw_instalacao.enepji_quantidade_paineis
        # guardar tarifa das unidades geradoras
        dTarifa = {}
        for brw_consumo in brw_projeto.eneprj_consumo_ids:
            if brw_consumo.enepco_tipo == 'UG':
                dTarifa[brw_consumo.id] = brw_consumo.enepco_tarifa
        for brw_consumo in brw_projeto.eneprj_consumo_ids:
            tarifa_UG = brw_consumo.enepco_geradora_id.id
            if tarifa_UG:
                tarifa_UG = dTarifa.get(tarifa_UG)
            else:
                tarifa_UG = brw_consumo.enepco_tarifa
            if tarifa_UG:
                tarifa_UC = brw_consumo.enepco_tarifa
                if not brw_projeto.eneprj_converter_tarifas:
                    tarifa_UG = tarifa_UC = 1
                for i in ('01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'):
                    exec ("_mes_%s += brw_consumo.enepco_mes_%s *  tarifa_UC / tarifa_UG" % (i, i))
        result[brw_projeto.id] = {'eneprj_potencia_prevista': _potencia,
                                  'eneprj_quantidade_paineis': _qtd,
                                  'eneprj_potencia_pico': _potencia_pico}
        _total = 0
        for i in ('01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12'):
            exec("result[brw_projeto.id]['eneprj_mes_%s'] = _mes_%s" % (i, i))
            exec("_total += _mes_%s" % i)
        result[brw_projeto.id]['eneprj_anual'] = _total
        result[brw_projeto.id]['eneprj_media'] = _total / 12.0
        result[brw_projeto.id]['eneprj_potencia_sugerida'] = (_total / 12 / 30 / 5.0) * 1.25
        result[brw_projeto.id]['eneprj_potencia_inversores'] = _potencia_inversores / 1000.0
        result[brw_projeto.id]['eneprj_qtd_mppts'] = _qtd_mppts
        result[brw_projeto.id]['eneprj_qtd_strings'] = _qtd_strings
        if _potencia_pico > 0 :
            _vl_kwp = brw_projeto.eneprj_valor_proposto / _potencia_pico
        else:
            _vl_kwp = 0
        result[brw_projeto.id]['eneprj_proposta_vl_kwp'] = _vl_kwp

    return result


def enepji_get_dados(self, cr, user, ids, fild_name, arg, context=None):
    """
    Calcula metodos funcionais não estoriados da classe instalacao
    @param cr:
    @param user:
    @param ids:
    @param fild_name:
    @param arg:
    @param context:
    @return:
    """
    context = context and context.copy() or {}
    result = {}.fromkeys(ids, 0.0)
    _campos = ['enepji_potencia_1', 'enepji_potencia_pico_1']
    for dados_instalacao in self.read(cr, user, ids, _campos, context=context):
        _potencia = dados_instalacao.get('enepji_potencia_1')
        _potencia_pico = dados_instalacao.get('enepji_potencia_pico_1')
        result[dados_instalacao.get('id')] = {
                                  'enepji_potencia': _potencia, 'enepji_potencia_pico': _potencia_pico,
        }
    return result

def enepiv_get_dados(self, cr, uid, ids, fild_name, arg, context=None):
    """
    Calcula metodos funcionais não estoriados da classe projet_inversores
    @param cr:
    @param user:
    @param ids:
    @param fild_name:
    @param arg:
    @param context:
    @return:
    """
    context = context and context.copy() or {}
    result = {}.fromkeys(ids, 0)
    for _brw_Pinversores in self.browse(cr, uid, ids, context=context):
        _qtd_mppts = _qtd_strings = 0
        for brw_mppts in _brw_Pinversores.enepiv_inversor_id.eneinv_mppt_ids:
            _qtd_mppts += 1
            _qtd_strings += brw_mppts.eneinvmppt_strng_qtd
        result[_brw_Pinversores.id] = \
            {
                'enepiv_potencia': _brw_Pinversores.enepiv_inversor_id.eneinv_pmax_ca,
                'enepiv_mppt_min': _brw_Pinversores.enepiv_inversor_id.eneinv_vmpptmin,
                'enepiv_mppt_max': _brw_Pinversores.enepiv_inversor_id.eneinv_vmpptmax,
                'enepiv_mppt_qtd': _qtd_mppts,
                'enepiv_mppt_qtd_string': _qtd_strings,
                'enepiv_tensao_maxima': _brw_Pinversores.enepiv_inversor_id.eneinv_vdcmax,
                'enepiv_corrente_maxima': _brw_Pinversores.enepiv_inversor_id.eneinv_idcmax,
            }
    return result


def enepco_get_dados(self, cr, uid, ids, field_name, arg, context=None):
    """
    Calcula a quantidade produzida, soma da opcao de instalacao escolhida e a potencia total
    Calcula a media anual e o consumo anual
    @param cr:
    @param uid:
    @param ids:
    @param field_name:
    @param arg:
    @param context:
    @return:
    """
    context = context and context.copy() or {}
    result = {}.fromkeys(ids, 0.0)
    for brw_consumos in self.browse(cr, uid, ids, context):
        _total = (brw_consumos.enepco_mes_01 +
                  brw_consumos.enepco_mes_02 +
                  brw_consumos.enepco_mes_03 +
                  brw_consumos.enepco_mes_04 +
                  brw_consumos.enepco_mes_05 +
                  brw_consumos.enepco_mes_06 +
                  brw_consumos.enepco_mes_07 +
                  brw_consumos.enepco_mes_08 +
                  brw_consumos.enepco_mes_09 +
                  brw_consumos.enepco_mes_10 +
                  brw_consumos.enepco_mes_11 +
                  brw_consumos.enepco_mes_12)
        result[brw_consumos.id] = {'enepco_anual': _total, 'enepco_media': _total / 12.0,
                                   'enepco_potencia_sugerida': _total / 12 / 30 / 5.0}
    return result
