# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class energia_inversores(osv.Model):
    """
    Tabela de especificações técnicas dos inversores
    Prefixo eneinv_
    """
    _name = 'energia.inversores'
    _description = 'Tabela de inversores'
    _inherits = {'estoque.produto': 'eneinv_produto_id'}
    _columns = {
        'eneinv_produto_id': fields.many2one("estoque.produto", "Produto", required=True, select=True,
                                             help='Identificação do item no estoque', ondelete='restrict'),
        'eneinv_pmax_dc': fields.integer("Potencia maxima(DC (W))", help='Potencia maxima na entrada (DC)'),
        'eneinv_idcmax': fields.float('Corrente maxima(DC (A))', digits=(2, 1), help='Corrente maxima de entrada (DC)'),
        'eneinv_vdcmax': fields.integer('Tensao maxima(DC (V))', required=True, help='Tensao maxima de entrada (DC)'),
        'eneinv_vmpptmin': fields.integer('Tensao minima MPPT (V)', required=True, help='Tensao minima MPPT'),
        'eneinv_vmpptmax': fields.integer('Tensao maxima MPPT (V)', required=True, help='Tensao maxima MPPT'),
        'eneinv_nrostring': fields.integer('Numero de strings', required=True, help='Quantidade de entradas por MPPT'),
        'eneinv_nromppt': fields.integer('Numero de MPPT', required=True, help='Quantidade de MPPTs'),
        'eneinv_pmax_ca': fields.integer("Potencia maxima(AC (W))", help='Potencia maxima na saida (AC)'),
        'eneinv_vsaida': fields.char("Tensao de saida (V)", help='Tensao de saida em Volts', size=15),
        'eneinv_tipo_coneccao': fields.selection([('M', 'Monofasico'), ('B', 'Bifasico'), ('T', 'Trifasico')],
                                                 'Tipo de coneccao', size=1),
        'eneinv_fator_eficiencia': fields.float('Fator de eficiencia (%)', digits=(2, 1), required=True),
        'eneinv_altura': fields.integer('Altura(mm)'),
        'eneinv_largura': fields.integer('Largura(mm)'),
        'eneinv_profundidade': fields.integer('Profundidade(mm)'),
        'eneinv_peso': fields.float('Peso(Kg)', digits=(2, 1)),
        'eneinv_grau_protecao': fields.char("Grau de protecao", size=6),
        'eneinv_mppt_ids':fields.one2many('energia.inversores.mppt','eneinvmppt_inversor_id', 'Mppts'),

    }
    _defaults = {
        'eneinv_nrostring': 1,
        'eneinv_tipo_coneccao': 'M',
    }
