# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class energia_inversores_mppt(osv.Model):
    """
    Tabela de especificações de mpps dos inversores
    Prefixo eneinvmppt_
    """
    _name = 'energia.inversores.mppt'
    _description = 'Tabela de mppts dos inversores'
    _columns = {
        'eneinvmppt_inversor_id': fields.many2one("energia.inversores", "Inversor", required=True, select=True,
                                             ondelete='cascade'),
        'sequence': fields.integer('Sequencia'),
        'eneinvmppt_strng_qtd': fields.integer('Qtd strings'),
        'eneinvmppt_string_i_max': fields.integer('Corrente maxima'),
    }
    _defaults = {
        'sequence': 1,
    }
    _order = 'eneinvmppt_inversor_id,sequence'
