# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import eneirr_get_media, eneirr_get_name


class energia_irradiancia(osv.Model):
    """
    Tabela de irradiancia solar
    Prefixo eneirr_
    """
    _name = 'energia.irradiancia'
    _description = 'Tabela de irrradiancia solar'
    _columns = {
        'name': fields.function(eneirr_get_name, method=True, type='char', size=50, string='Descricao', store=True),
        'eneirr_descricao': fields.char("Descricao", required=True, select=True, size=30, help='Identificacao da irradiancia'),
        'eneirr_desvio': fields.integer("Desvio", required=True, select=True, help='Desvio azimutal'),
        'eneirr_inclinacao': fields.integer("Inclinacao", required=True, select=True, help='Inclinacao dos paineis'),
        'eneirr_mes_01': fields.float('Janeiro', digits=(1, 3)),
        'eneirr_mes_02': fields.float('Fevereiro', digits=(1, 3)),
        'eneirr_mes_03': fields.float('Marco', digits=(1, 3)),
        'eneirr_mes_04': fields.float('Abril', digits=(1, 3)),
        'eneirr_mes_05': fields.float('Maio', digits=(1, 3)),
        'eneirr_mes_06': fields.float('Junho', digits=(1, 3)),
        'eneirr_mes_07': fields.float('Julho', digits=(1, 3)),
        'eneirr_mes_08': fields.float('Agosto', digits=(1, 3)),
        'eneirr_mes_09': fields.float('Setembro', digits=(1, 3)),
        'eneirr_mes_10': fields.float('Outubro', digits=(1, 3)),
        'eneirr_mes_11': fields.float('Novembro', digits=(1, 3)),
        'eneirr_mes_12': fields.float('Dezembro', digits=(1, 3)),
        'eneirr_media': fields.function(eneirr_get_media, method=True, type='float', digits=(1, 3), string='Irradiancia media', store=True),
        'eneirr_fonte': fields.char('Fonte de dados', size=15, help='Fonte que forneceu estes dados. Swera ou Cresesb')
    }

    _order = 'eneirr_descricao'
