# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import eneprj_get_dados


class energia_orcamentos(osv.Model):
    """
    Tabela de orcamentos
    Prefixo eneorc_
    """
    _name = 'energia.orcamentos'
    _description = 'Tabela de orcamentos a fornecedores'
    _columns = {
        'create_date': fields.datetime('Data Criacao', readonly=1),
        'eneorc_projeto_id': fields.many2one("energia.projetos", "Projeto", required=True, select=True,
                                             ondelete='cascade'),
        'eneorc_fornecedor_id': fields.many2one('adm.pessoa', 'Fornecedor', required=1, ondelete='restrict'),
        'eneorc_painel_qtd': fields.integer('Quantidade de paineis'),
        'eneorc_painel_id': fields.many2one('energia.painel.fotovoltaico', 'Painel', ondelete="restrict"),
        'eneorc_potencia_total': fields.float('Potencia total Kwp', digits=(4,2), readonly=1),
        'eneorc_inversor_qtd': fields.integer('Quantidade de inversores'),
        'eneorc_inversor_potencia': fields.float('Potencia do inversor', digits=(4,1), readonly=1),
        'eneorc_inversor_id': fields.many2one('energia.inversores', 'Inversor', ondelete="restrict"),
        'eneorc_complemento': fields.text('Informacoes complementares'),
        'eneorc_valor': fields.float('Valor orcamento', digits=(11,2)),
    }
    order = 'eneorc_projeto_id desc'
    _defaults = {
        'eneorc_inversor_qtd': 1
    }
