# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class energia_painel_fotovoltaico(osv.Model):
    """
    Tabela de especificações técnicas de paineis fotovoltaicos
    Prefixo enepfv_
    """
    _name = 'energia.painel.fotovoltaico'
    _description = 'Tabela de paineis fotovoltaicos'
    _inherits = {'estoque.produto': 'enepfv_produto_id'}
    _columns = {
        'enepfv_produto_id': fields.many2one("estoque.produto", "Produto", required=True, select=True, help='Identificação do iten no estoque', ondelete='restrict'),
        'enepfv_pmax': fields.integer("Potencia maxima(Pmax)", required=True, help='Potencia maxima gerada pelo painel'),
        'enepfv_vmp': fields.float('Tensao de operacao(Vmp)', digits=(2, 1), required=True, help='Tensao de operacao do painel'),
        'enepfv_imp': fields.float('Corrente de operacao(Imp)', digits=(2,2), required=True, help='Corrente de operacao do painel'),
        'enepfv_voc': fields.float('Tensao de cirtuito aberto(Voc)', digits=(2,1), required=True),
        'enepfv_isc': fields.float('Corrente de curto circuito(Isc)', digits=(2, 2), required=True),
        'enepfv_tensao_maxima':fields.integer('Tensao maxima'),
        'enepfv_fusivel_maximo': fields.integer('Fusivel maximo(Amperes)'),
        'enepfv_temp_pmax': fields.float('Coeficente de temperatura p/Pmax', digits=(2, 3)),
        'enepfv_temp_voc': fields.float('Coeficente de temperatura p/Voc', digits=(2, 3)),
        'enepfv_temp_isc': fields.float('Coeficente de temperatura p/Isc', digits=(2, 3)),
        'enepfv_comprimento': fields.integer('Comprimento(mm)'),
        'enepfv_largura': fields.integer('Largura(mm)'),
        'enepfv_espessura': fields.integer('Espessura(mm)'),
        'enepfv_peso': fields.float('Peso(Kg)', digits=(2, 1)),
    }