# -*- coding: utf-8 -*-

from openerp.osv import osv, fields
from funcoes import enepco_get_dados


class energia_projeto_consumos(osv.Model):

    _name = 'energia.projeto.consumos'

    _columns = {
        'id': fields.integer('id', readonly=True),
        'sequence': fields.integer('Seq'),
        'enepco_projeto_id': fields.many2one('energia.projetos', 'Projeto', required=True,
                                             select=True, ondelete='cascade'),
        'enepco_pessoa_id': fields.related('enepco_projeto_id', 'eneprj_pessoa_id', type='many2one',
                                           relation="adm.pessoa", string='Cliente', readonly=True, store=True),
        'enepco_endereco_id': fields.many2one("adm.pessoa.endereco", "Endereco", ondelete='restrict',
                                              domain="[('pessoa_id','=', enepco_pessoa_id)]"),
        'enepco_tipo': fields.selection([('UC', 'UC'), ('UG', 'UG')], 'TU', size=2, required=True,
                                        help="Selecione o tipo mde unidade, UG-Unidade Geradora ou UC-Unidade Consumidora"),
        'name': fields.char('Descricao', size=30, required=True),
        'enepco_nro_instalacao': fields.char('Nro instalacao', size=15, help='Numero da instalacao na distribuidora'),
        'enepco_geradora_id': fields.many2one('energia.projeto.consumos', 'UG', select=True, ondelete='set null',
                                              help='Selecione a Unidade geradora de creditos'),
        'enepco_mes_01': fields.integer('Janeiro'),
        'enepco_mes_02': fields.integer('Fevereiro'),
        'enepco_mes_03': fields.integer('Marco'),
        'enepco_mes_04': fields.integer('Abril'),
        'enepco_mes_05': fields.integer('Maio'),
        'enepco_mes_06': fields.integer('Junho'),
        'enepco_mes_07': fields.integer('Julho'),
        'enepco_mes_08': fields.integer('Agosto'),
        'enepco_mes_09': fields.integer('Setembro'),
        'enepco_mes_10': fields.integer('Outubro'),
        'enepco_mes_11': fields.integer('Novembro'),
        'enepco_mes_12': fields.integer('Dezembro'),
        'enepco_anual': fields.function(enepco_get_dados, method=True, multi="dados",
                                        type='integer', string='Cons.anual', store=True),
        'enepco_media': fields.function(enepco_get_dados, method=True, multi="dados", type='integer',
                                        string='Media', store=True),
        'enepco_tarifa': fields.float('Valor Tarifa', digits=(2, 9)),
        'enepco_padrao_id': fields.many2one("energia.padrao", "Tipo de padrao", ondelete='restrict'),
        'enepco_potencia_sugerida': fields.function(enepco_get_dados, method=True, multi="dados",
                                                    type='float', digits=(6, 2),
                                                    string='Potencia pico sugerida', store=True),
        'enepco_latitude': fields.float('Latitude', digits=(2, 6), select=True,
                                        help='Latitude da instalacao'),
        'enepco_longitude': fields.float('Longitude', digits=(2, 6), select=True,
                                         help='Latitude da instalacao'),
        'enepco_temp_max': fields.integer('Temperatura maxima'),
        'enepco_tipo_estrutura': fields.selection(
            [('-3', '-3º Totalmente elevada'), ('+3', '+3º Laje ou telhado'),
             ('+4', '+4º Sobre telhado c/ventiliacao'),
             ('+7', '+7º Integrado s/ventilacao')], 'Tipo de estrutura', size=2),
        'enepco_demanda_contratada': fields.integer('Demanda contratada'),
        'enepco_valor_conta': fields.float('Valor da conta', digits=(9,2)),
        'enepco_valor_iluminacao_publica': fields.float('Iluminacao publica', digits=(9,2)),
        'enepco_dia_vencimento': fields.integer("Venc.", help='Dia de vencimento da conta'),
        'enepco_dia_leitura': fields.integer("Leitura", help='Dia da leitura da conta'),
        'enepco_observacoes': fields.text('Informacoes complementares'),
        'enepco_percentual_a_receber': fields.integer('Percentual a receber',
                                                      help='Percentual de participacao na distribuicao do excesso da producao'),

    }
    _defaults = {
        'enepco_tipo': 'UC',
        'sequence': 10,
        'enepco_tipo_estrutura': '+3',
    }
    _order = 'enepco_projeto_id,sequence'
