# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import eneprj_get_dados


class energia_projetos_inversores(osv.Model):
    """
    Tabela de inversores do projeto
    Prefixo enepiv
    """
    _name = 'energia.projetos.inversores'
    _description = 'Tabela de inversores dos projetos'
    from funcoes import enepiv_get_dados
    _columns = {
        'enepiv_projeto_id': fields.many2one("energia.projetos", "Projeto", required=True, select=True, ondelete='cascade'),
        'name': fields.related('enepiv_inversor_id', 'eneinv_produto_id', type="many2one", relation='estoque.produto', store=False),
        'enepiv_sequencia': fields.integer('Sequencia', select=True),
        'enepiv_inversor_id': fields.many2one('energia.inversores', 'Inversor', ondelete="restrict", select=True),
        'enepiv_potencia': fields.function(enepiv_get_dados, method=True, multi="dados", type='integer',
                                        string='Potencia', store=True),
        'enepiv_mppt_min': fields.function(enepiv_get_dados, method=True, multi="dados", type='integer',
                                           string='Mppt min', store=True),
        'enepiv_mppt_max': fields.function(enepiv_get_dados, method=True, multi="dados", type='integer',
                                           string='Mppt max', store=True),
        'enepiv_mppt_qtd': fields.function(enepiv_get_dados, method=True, multi="dados", type='integer',
                                           string='Qtd.Mppts', store=True),
        'enepiv_mppt_qtd_string': fields.function(enepiv_get_dados, method=True, multi="dados", type='integer',
                                           string='Qtd.strings p/Mppt', store=True),
        'enepiv_tensao_maxima': fields.function(enepiv_get_dados, method=True, multi="dados", type='integer',
                                           string='Max VDC', store=True),
        'enepiv_corrente_maxima': fields.function(enepiv_get_dados, method=True, multi="dados", type='integer',
                                                string='Max IDC', store=True),

    }
    order='enepiv_projeto_id,enepiv_sequencia'

