# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class entrega_item_devolvido(osv.Model):

    _name = 'entrega.item.devolvido'
    _inherit = 'entrega.item.devolvido'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        res = super(entrega_item_devolvido, self).create(cr, uid, vals, context)
        brw_item_devolvido = self.browse(cr, uid, res)
        _qtd_entregue = brw_item_devolvido.entitd_item_id.entvei_qtd_separada
        _qtd = _qtd_entregue - brw_item_devolvido.entitd_qtd_devolvida
        if _qtd < 0:
            raise osv.except_osv(_('Atencao!'), _('A quantidade devolvida e maior do que a entregue!'))
        self.pool.get('entrega.vendas.item').write(cr, uid,
                                                   brw_item_devolvido.entitd_item_id.id,
                                                   {'entvei_qtd_separada': _qtd}, context=context)

        self.pool.get('entrega.vendas.capa').entvec_ajustar_state(cr, uid,
                                                                  [brw_item_devolvido.entitd_item_id.entvei_capa_id.id],
                                                                   context=context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if not isinstance(ids, (list, tuple)):
            ids = [ids]
        for brw_item_devolvido in self.browse(cr, uid, ids): # Estornar devolucao antes da atualizacao
            _qtd_entregue = brw_item_devolvido.entitd_item_id.entvei_qtd_separada
            _qtd = _qtd_entregue + brw_item_devolvido.entitd_qtd_devolvida
            self.pool.get('entrega.vendas.item').write(cr, uid,
                                                       brw_item_devolvido.entitd_item_id.id,
                                                       {'entvei_qtd_separada': _qtd}, context=context)
        res = super(entrega_item_devolvido, self).write(cr, uid, ids, vals, context)
        _lista_capas = []
        for brw_item_devolvido in self.browse(cr, uid, ids): # Registrar a devolucao novamente
            _qtd_entregue = brw_item_devolvido.entitd_item_id.entvei_qtd_separada
            _qtd = _qtd_entregue - brw_item_devolvido.entitd_qtd_devolvida
            _lista_capas.append(brw_item_devolvido.entitd_item_id.entvei_capa_id.id)
            if _qtd < 0:
                raise osv.except_osv(_('Atencao!'), _('A quantidade devolvida e maior do que a entregue!'))
            self.pool.get('entrega.vendas.item').write(cr, uid,
                                                       brw_item_devolvido.entitd_item_id.id,
                                                       {'entvei_qtd_separada': _qtd}, context=context)
        self.pool.get('entrega.vendas.capa').entvec_ajustar_state(cr, uid, [_lista_capas],
                                                                  context=context)
        return res

    def unlink(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not isinstance(ids, (list, tuple)):
            ids = [ids]
        _lista_capas = []
        for brw_item_devolvido in self.browse(cr, uid, ids): # Estornar devolucao antes da atualizacao
            _qtd_entregue = brw_item_devolvido.entitd_item_id.entvei_qtd_separada
            _qtd = _qtd_entregue - brw_item_devolvido.entitd_qtd_devolvida
            _lista_capas.append(brw_item_devolvido.entitd_item_id.entvei_capa_id.id)
            self.pool.get('entrega.vendas.item').write(cr, uid,
                                                       brw_item_devolvido.entitd_item_id.id,
                                                       {'entvei_qtd_separada': _qtd}, context=context)
        res = super(entrega_item_devolvido, self).unlink(cr, uid, ids, context)
        self.pool.get('entrega.vendas.capa').entvec_ajustar_state(cr, uid, [_lista_capas],
                                                                  context=context)
        return res


