# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class entrega_vendas_capa(osv.Model):
    _name = 'entrega.vendas.capa'
    _inherit = 'entrega.vendas.capa'

    def entvec_ajustar_state(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        for brw_entrega_vendas_capa in self.browse(cr, uid, ids, context=context):
            if brw_entrega_vendas_capa.state == 'CA':
                continue
            _qtd_pedida = _qtd_separada = _qtd_entregue = 0
            for brw_entrega_vendas_item in brw_entrega_vendas_capa.entvec_vendas_item_ids:
                _qtd_pedida += brw_entrega_vendas_item.entvei_qtd_pedida
                _qtd_separada += brw_entrega_vendas_item.entvei_qtd_separada
                _list = [(x.id) for x in brw_entrega_vendas_item.entvei_viagem_item_ids]
                for dados_viagem_item in self.pool.get('entrega.viagem.item').read(cr, uid, _list,
                                                                                   ['entvit_quantidade'],
                                                                                   context=context):
                    _qtd_entregue += dados_viagem_item.get('entvit_quantidade') or 0
                obj_entrega_item_devolvido = self.pool.get('entrega.item.devolvido')
                _devolucoes_ids = obj_entrega_item_devolvido.search(cr, uid,
                                                                    [('entitd_item_id', '=',
                                                                      brw_entrega_vendas_item.id)], context=context)
                for dados_devolucao in obj_entrega_item_devolvido.read(cr, uid, _devolucoes_ids,
                                                                       ['entitd_qtd_devolvida'], context=context):
                    _qtd_entregue -= dados_devolucao.get('entitd_qtd_devolvida') or 0

            if _qtd_separada == 0:
                _state = 'PE'
            elif _qtd_pedida == _qtd_entregue:
                _state = 'ET'
            elif _qtd_separada == _qtd_pedida:
                _state = 'SP'
            else:
                _state = 'PA'
            if brw_entrega_vendas_capa.state != _state:
                self.write(cr, uid, brw_entrega_vendas_capa.id, {'state': _state}, context=context)
        return True

    def _needaction_domain_get(self, cr, uid, context=None):
        """
            Mostra a quantidade de vendas ainda nao entregues'

            @param cr: {cursor} a linha atual do cursor do banco de dados,
            @param uid: {int} o ID do usuário utilizado para a verificacao de perfil,
            @param context: {dict} um dicionário padrao para valores contextuais,
            @return: {list} dominio utilizado para as Vendas ainda não entregues

            @see: openerp/addons/base/ir/ir.needaction (class ir_needaction_mixin)
            @copyright: OpenERP SA.
            """
        context = context and context.copy() or {}
        return [('state', 'in', ['PE', 'PA', 'SP'])]
