# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
import time
from openerp.tools.translate import _


class entrega_viagem(osv.Model):
    _name = 'entrega.viagem'
    _inherit = 'entrega.viagem'

    def entvig_button_carregar_inicio(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        for brw_entrega_viagem in self.browse(cr, uid, ids, context=context):
            _entregas = {}
            for brw_entrega_viagem_item in brw_entrega_viagem.entvig_item_ids:
                _qtd_inicial = brw_entrega_viagem_item.entvit_item_id.entvei_qtd_separada or 0
                _qtd = brw_entrega_viagem_item.entvit_quantidade or 0
                vals = {'entvei_qtd_separada': _qtd_inicial + _qtd}
                self.pool.get('entrega.vendas.item').write(cr, uid,
                                                           brw_entrega_viagem_item.entvit_item_id.id,
                                                           vals, context=context)
                _entregas[
                    brw_entrega_viagem_item.entvit_item_id.entvei_capa_id.id] = True  #Criando dicionario entregas
            for _entrega_id in _entregas.keys():
                self.pool.get('entrega.vendas.capa').entvec_ajustar_state(cr, uid, [_entrega_id],
                                                                          context=context)
        vals = {
            'state': 'A',
            'entvig_carregamento_inicio': time.strftime("%Y-%m-%d %H:%M:%S"),
        }
        return self.write(cr, uid, ids, vals, context=context)

    def entvig_button_carregar_fim(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = {
            'entvig_carregamento_termino': time.strftime("%Y-%m-%d %H:%M:%S"),
        }
        return self.write(cr, uid, ids, vals, context=context)

    def entvig_button_liberar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        _nfs = {}
        _pedidos = {}
        for brw_entrega_viagem in self.browse(cr, uid, ids, context=context):
            for brw_entrega_viagem_item in brw_entrega_viagem.entvig_item_ids:
                if brw_entrega_viagem_item.entvit_item_id.entvei_capa_id.entvec_nf_id:
                    if not (brw_entrega_viagem_item.entvit_item_id.entvei_capa_id.entvec_nf_id and
                                    brw_entrega_viagem_item.entvit_item_id.entvei_capa_id.entvec_nf_id.state == '3'):
                        _nfs[
                            brw_entrega_viagem_item.entvit_item_id.entvei_capa_id.entvec_nf_id.name] = True
                else:
                    _pedidos[brw_entrega_viagem_item.entvit_item_id.entvei_capa_id.entvec_pedido_id.numero_pedido] = True
        _msg = _('A(s) seguinte(s) nota(s)/pedido(s) ainda nao foram faturados:\n')
        if _nfs:
            _msg += str(_nfs.keys())
        if _pedidos:
            _msg += str(_pedidos.keys())
        if _nfs or _pedidos:
            raise osv.except_osv(_('Atencao!'), _msg)

        vals = {
            'state': 'L',
            'entvig_liberou_user_id': uid,
            'entvig_liberou_data_hora': time.strftime("%Y-%m-%d %H:%M:%S"),
        }
        return self.write(cr, uid, ids, vals, context=context)

    def entvig_button_saida(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = {
            'entvig_data_hora_saida': time.strftime("%Y-%m-%d %H:%M:%S"),
            'state': 'V',
        }
        return self.write(cr, uid, ids, vals, context=context)

    def entvig_button_retorno(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = {
            'entvig_data_hora_retorno': time.strftime("%Y-%m-%d %H:%M:%S"),
            'state': 'E',
        }
        return self.write(cr, uid, ids, vals, context=context)

    def entvig_button_encerrar_entrega(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = {
            'state': 'R',
        }
        return self.write(cr, uid, ids, vals, context=context)

    def entvig_button_data_entrega(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        for brw_entrega_viagem in self.browse(cr, uid, ids):
            _data = brw_entrega_viagem.entvig_data_hora_retorno[:10]
            _vendas = []
            for brw_entrega_viagem_venda in brw_entrega_viagem.entvig_venda_ids:
                _vendas.append((1, brw_entrega_viagem_venda.id, {'entviv_data_entrega': _data}))
            self.write(cr, uid, brw_entrega_viagem.id, {'entvig_venda_ids': _vendas}, context=context)
        return True

    def entvig_button_cancelar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        for brw_entrega_viagem in self.browse(cr, uid, ids, context=context):
            if brw_entrega_viagem.state == 'M':
                continue
            _entregas = {}
            for brw_entrega_viagem_item in brw_entrega_viagem.entvig_item_ids:
                _qtd_inicial = brw_entrega_viagem_item.entvit_item_id.entvei_qtd_separada or 0
                _qtd = brw_entrega_viagem_item.entvit_quantidade or 0
                vals = {'entvei_qtd_separada': _qtd_inicial - _qtd}
                self.pool.get('entrega.vendas.item').write(cr, uid,
                                                           brw_entrega_viagem_item.entvit_item_id.id,
                                                           vals, context=context)
                _entregas[
                    brw_entrega_viagem_item.entvit_item_id.entvei_capa_id.id] = True  #Criando dicionario entregas
            for _entrega_id in _entregas.keys():
                self.pool.get('entrega.vendas.capa').entvec_ajustar_state(cr, uid, [_entrega_id],
                                                                          context=context)
        vals = {
            'state': 'C',
        }
        return self.write(cr, uid, ids, vals, context=context)

    def entvig_onchange_veiculo(self, cr, uid, ids, veiculo_id, context=None):
        context = context and context.copy() or {}
        res = {'value': {}}
        if not veiculo_id:
            return res
        _campos = ['carga_maxima_peso', 'carga_altura', 'carga_largura', 'carga_comprimento',
                   'motorista_id']
        dados_veiculos_veiculo = self.pool.get('veiculos.veiculo').read(cr, uid, veiculo_id,
                                                                        _campos, context=context)
        _vol = ((dados_veiculos_veiculo.get('carga_altura') or 0) *
                (dados_veiculos_veiculo.get('carga_largura') or 0) *
                (dados_veiculos_veiculo.get('carga_comprimento') or 0))
        vals = {
            'entvig_veiculo_volume': _vol,
            'entvig_veiculo_peso': dados_veiculos_veiculo.get('carga_maxima_peso') or 0,
            'entvig_motorista_id': dados_veiculos_veiculo.get('motorista_id')
        }
        res['value'] = vals
        return res


    def _needaction_domain_get(self, cr, uid, context=None):
        """
            Mostra a quantidade de viagens ainda nao concluidas'

            @param cr: {cursor} a linha atual do cursor do banco de dados,
            @param uid: {int} o ID do usuário utilizado para a verificacao de perfil,
            @param context: {dict} um dicionário padrao para valores contextuais,
            @return: {list} dominio utilizado para as Viagens ainda não concluidas

            @see: openerp/addons/base/ir/ir.needaction (class ir_needaction_mixin)
            @copyright: OpenERP SA.
            """
        context = context and context.copy() or {}
        return [('state', 'in', ['M', 'A', 'L', 'V', 'E'])]