# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class estoquepedidos_pedido_capa(osv.Model):
    _name = 'estoquepedidos.pedido.capa'
    _inherit = 'estoquepedidos.pedido.capa'

    def button_validar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not super(estoquepedidos_pedido_capa, self).button_validar(cr, uid, ids, context):
            return False
        _campos = ['estpro_gerar_controle_entrega']
        dados_parametro = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque',
                                                                           _campos, context=context)
        if dados_parametro.get('estpro_gerar_controle_entrega') != 'P':  # o default é nota fiscal
            return True
        for brw_estoquepedidos_pedido_capa in self.browse(cr, uid, ids, context=context):
            vals = {
                'entvec_pedido_id': brw_estoquepedidos_pedido_capa.id,
                'entvec_data_prevista': brw_estoquepedidos_pedido_capa.data_entrega,
                'state': 'PE',
            }
            item = []
            for brw_estoquepedidos_pedido_item in brw_estoquepedidos_pedido_capa.pedido_item_ids:
                vals_item = {
                    'entvei_pedidos_item_id': brw_estoquepedidos_pedido_item.id,
                    'entvei_qtd_pedida': brw_estoquepedidos_pedido_item.qtde_atendida or brw_estoquepedidos_pedido_item.qtde_pedida,
                    'entvei_qtd_separada': 0,
                    'entvei_embalagem_id': brw_estoquepedidos_pedido_item.produto_embalagem_id.id,
                }
                item.append((0, 0, vals_item))
            vals['entvec_vendas_item_ids'] = item
            self.pool.get('entrega.vendas.capa').create(cr, uid, vals, context=context)
        return True

    def __estped_cancelar_controle_entrega(self, cr, uid, ids, context):
        obj_entrega_vendas_capa = self.pool.get('entrega.vendas.capa')
        if not isinstance(ids, (list, tuple)):
            ids = [ids]
        vendas_capa_ids = obj_entrega_vendas_capa.search(cr, uid, [('entvec_pedido_id', 'in', ids)],
                                                         context=context)
        for brw_entrega_vendas_capa in obj_entrega_vendas_capa.browse(cr, uid, vendas_capa_ids):
            if brw_entrega_vendas_capa.state != 'PE':
                raise osv.except_osv(_('Atencao!'),
                                     _('O pedido %s ja tem itens entregues.\nFaca a devolucao antes de cancelar.')
                                          % brw_entrega_vendas_capa.entvec_pedido_id.numero_pedido)
            obj_entrega_vendas_capa.unlink(cr, uid, brw_entrega_vendas_capa.id)
        return True

    def button_cancelar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        _campos = ['estpro_gerar_controle_entrega']
        dados_parametro = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque',
                                                                           _campos, context=context)
        if dados_parametro.get('estpro_gerar_controle_entrega') == 'P':  # o default é nota fiscal
            self.__estped_cancelar_controle_entrega(cr, uid, ids, context)
        res = super(estoquepedidos_pedido_capa, self).button_cancelar(cr, uid, ids, context=context)
        return res

    def button_rascunho(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        _campos = ['estpro_gerar_controle_entrega']
        dados_parametro = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque',
                                                                           _campos, context=context)
        res = super(estoquepedidos_pedido_capa, self).button_rascunho(cr, uid, ids, context=context)
        if dados_parametro.get('estpro_gerar_controle_entrega') != 'P':  # o default é nota fiscal
            return True

        self.__estped_cancelar_controle_entrega(cr, uid, ids, context)
        return res

    def button_faturar_pedido(self, cr, uid, ids, context=None, destinatario_id=False, pedido_ids=[]):
        context = context and context.copy() or {}
        #executa a funcao principal primeiro
        res = super(estoquepedidos_pedido_capa, self).button_faturar_pedido(cr, uid, ids, context=context,
                                                                            destinatario_id=destinatario_id,
                                                                            pedido_ids=pedido_ids)
        _campos = ['estpro_gerar_controle_entrega']
        dados_parametro = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque',
                                                                           _campos, context=context)
        if dados_parametro.get('estpro_gerar_controle_entrega') != 'P':  # o default é nota fiscal
            return res
        for brw_pedido_capa in self.browse(cr, uid, ids):
            _nf_id = brw_pedido_capa.pedcap_nf_ids[0].id
            _pedido_id = brw_pedido_capa.id
            obj_vendas_capa = self.pool.get('entrega.vendas.capa')
            _vendas_ids = obj_vendas_capa.search(cr, uid, [('entvec_pedido_id', '=', _pedido_id)], context=context)
            obj_vendas_capa.write(cr, uid, _vendas_ids, {'entvec_nf_id': _nf_id}, context=context)
        return res
