# -*- encoding: utf-8 -*-
# #############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class fiscal_nf_capa(osv.Model):
    _name = 'fiscal.nf.capa'
    _inherit = 'fiscal.nf.capa'

    def button_validar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        super(fiscal_nf_capa, self).button_validar(cr, uid, ids, context)

        def __fisnfc_gerar_controle_entrega():
            brw_fiscal_nf = self.browse(cr, uid, ids, context=context)
            for brw_fiscal_nf_capa in brw_fiscal_nf:
                vals = {
                    'entvec_nf_id': brw_fiscal_nf_capa.id,
                    'entvec_data_prevista': brw_fiscal_nf_capa.fisnfc_previsao_entrega,
                    'state': 'PE',
                }
                item = []
                for brw_estoque_movimento_item in brw_fiscal_nf_capa.estoque_movimento_itens_ids:
                    vals_item = {
                        'entvei_nf_item_id': brw_estoque_movimento_item.id,
                        'entvei_qtd_pedida': brw_estoque_movimento_item.quantidade,
                        'entvei_qtd_separada': 0,
                        'entvei_embalagem_id': brw_estoque_movimento_item.produto_embalagem_id.id,
                    }
                    item.append([0, 0, vals_item])
                vals['entvec_vendas_item_ids'] = item
                self.pool.get('entrega.vendas.capa').create(cr, uid, vals, context=context)
            return True

        def __fisnfc_verificar_itens_controle_entrega():  #TODO
            # _dict_nf = {}
            # _dict_vendas = {}
            # for brw_nf_capa in self.browse(cr, uid, ids):
            #     _lista = []
            #     for brw_estoque_movimento_item in brw_nf_capa.estoque_movimento_itens_ids:
            #         _lista.append((
            #             brw_estoque_movimento_item.grade_id.id, brw_estoque_movimento_item.quantidade))
            #         _dict_nf[brw_nf_capa.id] = _lista
            #
            # entrega_capa_ids = self.pool.get('entrega.vendas.capa').search(cr, uid, [
            #     ('entvec_nf_id', 'in', ids)])
            # for brw_entrega_capa in self.pool.get('entrega.vendas.capa').browse(cr, uid,
            #                                                                     entrega_capa_ids):
            #     _lista = []
            #     for brw_venda_item in brw_entrega_capa.entvec_vendas_item_ids:
            #         _item = brw_venda_item.entvei_pedidos_item_id.grade_id.id or brw_venda_item.entvei_nf_item_id.grade_id.id
            #         _lista.append((_item, brw_venda_item.entvei_qtd_pedida))
            #         _dict_vendas[brw_entrega_capa.entvec_nf_id.id] = _lista
            # #Verificar se todas as entregas estão na nf, se não tiver excluir caso ainda não esteja separado
            # for _venda_key in _dict_vendas.keys():
            #     _vendas = _dict_vendas.get(_venda_key) or []
            #     _notas = _dict_nf.get(_venda_key) or []
            #     for x in _notas:
            #         if x in _vendas:
            #             _vendas.remove(x)
            #             _notas.remove(x)
            #     #Excluir vendas que sobraram
            #     for x in _vendas:
            #         _args = [('entvec_nf_id', '=', _venda_key)]  #TODO
            #         _ids = self.pool.get('entrega.vendas.item').search(cr, uid, _args)
            #
            #         pass
            return True

        context = context and context.copy() or {}
        for brw_fiscal_nf_capa in self.browse(cr, uid, ids):
            if brw_fiscal_nf_capa.tipo == 'E':  #somente nf de saida
                return True
        if not super(fiscal_nf_capa, self).button_validar(cr, uid, ids, context):
            return False
        _campos = ['estpro_gerar_controle_entrega']
        dados_parametro = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque',
                                                                           _campos, context=context)
        if dados_parametro.get('estpro_gerar_controle_entrega') == 'P':  # o default é nota fiscal
            __fisnfc_verificar_itens_controle_entrega()
        else:
            __fisnfc_gerar_controle_entrega()
        return True

    def __fiscal_cancelar_controle_entrega(self, cr, uid, ids, context):
        obj_entrega_vendas_capa = self.pool.get('entrega.vendas.capa')
        if not isinstance(ids, (list, tuple)):
            ids = [ids]
        vendas_capa_ids = obj_entrega_vendas_capa.search(cr, uid, [('entvec_nf_id', 'in', ids)],
                                                         context=context)
        brw_entrega_vendas = obj_entrega_vendas_capa.browse(cr, uid, vendas_capa_ids)
        for brw_entrega_vendas_capa in brw_entrega_vendas:
            if brw_entrega_vendas_capa.state != 'PE':
                raise osv.except_osv(_('Atencao!'),
                                     _(
                                         'A nf %s ja tem itens entregues.\nFaca a devolucao antes de cancelar.')
                                     % brw_entrega_vendas_capa.entvec_nf_id.name)
            obj_entrega_vendas_capa.unlink(cr, uid, brw_entrega_vendas_capa.id)
        return True

    def button_cancelar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.__fiscal_cancelar_controle_entrega(cr, uid, ids, context)
        if not super(fiscal_nf_capa, self).button_cancelar(cr, uid, ids, context=context):
            return False
        return True

    def button_rascunho(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not super(fiscal_nf_capa, self).button_rascunho(cr, uid, ids, context=context):
            return False
        _campos = ['estpro_gerar_controle_entrega']
        dados_parametro = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque',
                                                                           _campos, context=context)
        if dados_parametro.get('estpro_gerar_controle_entrega') != 'P':  # o default é nota fiscal
            self.__fiscal_cancelar_controle_entrega(cr, uid, ids, context)
        return True