# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################



def entvit_get_entrega(self, cr, uid, ids, name, arg, context=None):
    """
    Metodo para retornar os dados da entrega realizada
    """
    context = context and context.copy() or {}
    res = {}
    for _id in ids:
        res[_id] = {}
        for brw_entrega_viagem_item in self.browse(cr, uid, ids):
            _data = _horas = _quem = False
            for brw_entrega_viagem_venda in brw_entrega_viagem_item.entvig_venda_ids:
                _data = brw_entrega_viagem_venda.entviv_data_entrega
                _horas = brw_entrega_viagem_venda.entviv_hora_entrega
                _quem = brw_entrega_viagem_venda.entviv_quem_recebeu
            res[_id].update({'entvit_data_entrega': _data})
            res[_id].update({'entvit_hora_entrega': _horas})
            res[_id].update({'entvit_quem_recebeu': _quem})
    return res

def entvit_get_devolucao(self, cr, uid, ids, name, arg, context=None):
    """
    Metodo para retornar a quantidade devolvida da entrega
    """
    context = context and context.copy() or {}
    res = {}
    for brw_entrega_viagem_item in self.browse(cr, uid, ids):
        _qtd = 0.0
        _viagem_id = brw_entrega_viagem_item.entvit_capa_id.id
        _item_id = brw_entrega_viagem_item.entvit_item_id.id
        _args = [('entitd_viagem_id', '=', _viagem_id), ('entitd_item_id', '=', _item_id)]
        _devolucao_ids = self.pool.get('entrega.item.devolvido').search(cr, uid, _args, context=context)
        for brw_item_devolvido in self.pool.get('entrega.item.devolvido').browse(cr, uid,
                                                                            _devolucao_ids):
            _qtd += brw_item_devolvido.entitd_qtd_devolvida
        res[brw_entrega_viagem_item.id] = _qtd
    return res

def entvig_get_carga(self, cr, uid, ids, name, arg, context=None):
    """
    Metodo Calcular a carga dos itens identificados para a viagem
    Deve buscar o peso e o volume de cada item identificado na viagem para
    apurar a carga total
    """
    context = context and context.copy() or {}
    res = {}
    for _id in ids:
        res[_id] = {}
        for brw_entrega_viagem in self.browse(cr, uid, ids):
            _volume = _peso = 0.00
            for brw_entrega_viagem_item in brw_entrega_viagem.entvig_item_ids:
                _volume += (brw_entrega_viagem_item.entvit_quantidade *
                          brw_entrega_viagem_item.entvit_item_id.entvei_embalagem_id.estpre_cubagem)
                _peso += (brw_entrega_viagem_item.entvit_quantidade *
                          brw_entrega_viagem_item.entvit_item_id.entvei_embalagem_id.peso_bruto)
            res[_id].update({'entvig_carga_volume': _volume})
            res[_id].update({'entvig_carga_peso': _peso})
    return res


def _entvec_get_name(self, cr, uid, ids, name, arg, context=None):
    """
    Identifica o controle de entrega
    @param cr:
    @param uid:
    @param ids:
    @param name:
    @param arg:
    @param context:
    @return: text
    """
    context = context and context.copy() or {}
    res = {}
    for i in self.browse(cr, uid, ids):
        if i.entvec_pedido_id:
            res.update({i.id: i.entvec_pedido_id.pessoa_id.nome + ' - ' +str(i.entvec_pedido_id.numero_pedido)})
        elif i.entvec_nf_id:
            res.update({i.id: i.entvec_nf_id.destinatario_id.nome + ' - ' + str(i.entvec_nf_id.numero_nf) + '-' + str(i.entvec_nf_id.serie_nf)})
        else:
            res.update({i.id: False})
    return res

def _entvei_get_produto(self, cr, uid, ids, name, arg, context=None):
    """
    Identifica o produto do controle de entrega
    @param cr:
    @param uid:
    @param ids:
    @param name:
    @param arg:
    @param context:
    @return: dict {id: produto_id}
    """
    context = context and context.copy() or {}
    res = {}
    for i in self.browse(cr, uid, ids):
        res[i.id] = {}
        if i.entvec_pedido_id:
            _produto_id = i.entvei_pedidos_item_id.produto_id.id
            _name = i.entvei_pedidos_item_id.produto_id.name
        elif i.entvec_nf_id:
            _produto_id = i.entvei_nf_item_id.produto_id.id
            _name = i.entvei_nf_item_id.produto_id.name
        else:
            _produto_id = False
            _name = False
        res[i.id].update({'name': _name})
        res[i.id].update({'entvei_produto_id': _produto_id})
    return res