# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class entrega_item_devolvido(osv.Model):
    """
    Tabela de itens devolvidos
    Prefixo: entitd_
    """
    _name = 'entrega.item.devolvido'
    _rec_name = 'entitd_item_id'
    _columns = {
        'entitd_viagem_id': fields.many2one('entrega.viagem', 'Viagem', required=True, select=True),
        'entitd_viagem_venda_id': fields.many2one('entrega.viagem.venda', 'Venda', required=True,
                                                  select=True,
                                                  domain="[('entviv_capa_id','=',entitd_viagem_id)]"),
        'entitd_item_id': fields.many2one("entrega.vendas.item", 'Item', ondelete="cascade",
                                          required=True, select=True,
                                          domain="[]",
                                          context="{'entitd_viagem_venda_id': entitd_viagem_venda_id}"),
        'entitd_qtd_devolvida': fields.float('Quantidade devolvida', required=True),
        'entitd_data_devolucao': fields.date('Data devolucao', required=True),
        'entitd_obs': fields.text('Informacoes complementares'),
    }
    _defaults = {
        'entitd_data_devolucao': lambda *a: time.strftime('%Y-%m-%d'),
    }

