# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class entrega_vendas_capa(osv.Model):
    """
    Tabela de entregas, contem os dados do que tem que ser/foi entregue
    Prefixo: entvec
    """
    from funcoes import _entvec_get_name

    _name = 'entrega.vendas.capa'
    _inherit = ['ir.needaction_mixin']
    _columns = {
        'name': fields.function(_entvec_get_name, method=True, string='Descricao',
                                type='text', store=True),
        'entvec_pedido_id': fields.many2one("estoquepedidos.pedido.capa", 'Pedido',
                                            ondelete="restrict", select=True),
        'entvec_nf_id': fields.many2one("fiscal.nf.capa", 'Nota', ondelete="restrict",
                                        select=True),
        'entvec_data_prevista': fields.date('Data prevista'),
        'entvec_vendas_item_ids': fields.one2many('entrega.vendas.item', 'entvei_capa_id', 'Itens'),
        'state': fields.selection([('PE', 'Pendente'), ('PA', 'Parcial'), ('SP', 'Separado'),
                                   ('ET', 'Entregue'), ('CA', 'Cancelada')], 'Situacao', size=2),
    }
    _order = 'id desc'

