# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class entrega_vendas_item(osv.Model):
    """
    Tabela de itens a serem/foram entregues
    Prefixo: entvei_
    """
    from funcoes import _entvei_get_produto

    _name = 'entrega.vendas.item'
    _inherits = {
        'entrega.vendas.capa': 'entvei_capa_id',
    }

    _columns = {
        'id': fields.integer('Numero', reqdonly=True),
        'name': fields.function(_entvei_get_produto, method=True, string='Produto',
                                             type='text', store=True, multi='name'),
        'entvei_capa_id': fields.many2one("entrega.vendas.capa", 'Capa', ondelete="cascade",
                                          required=True, select=True),
        'entvei_pedidos_item_id': fields.many2one("estoquepedidos.pedido.item", 'Item do pedido',
                                                  ondelete="cascade", select=True),
        'entvei_nf_item_id': fields.many2one("estoque.movimento.itens", 'Item da nf',
                                             ondelete="restrict", select=True),
        'entvei_produto_id': fields.function(_entvei_get_produto, method=True, string='Produto',
                                             type="many2one", relation="estoque.produto",
                                             store=True, multi='produto_id'),
        'entvei_qtd_pedida': fields.float('Quantidade pedida', required=True),
        'entvei_qtd_separada': fields.float('Quantidade separada'),
        'entvei_embalagem_id': fields.many2one('estoque.produto.embalagem', 'Embalagem',
                                               ondelete='restrict', required=True),
        'entvei_viagem_item_ids': fields.one2many('entrega.viagem.item', 'entvit_item_id',
                                                  'Viagens'),
    }

