# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class entrega_viagem(osv.Model):
    """
    Tabela de viagens realizdas/a realizar
    Prefixo: entvig_
    """
    from funcoes import entvig_get_carga

    _name = 'entrega.viagem'
    _inherit = ['ir.needaction_mixin']
    _rec_name = 'id'
    _columns = {
        'id': fields.integer('Numero', readonly=True),
        'entvig_data': fields.date('Data prevista', required=True),
        'entvig_veiculo_volume': fields.float('Volume(Veic)', readonly=True),
        'entvig_veiculo_peso': fields.float('Peso(Veic)', readonly=True),
        'entvig_veiculo_id': fields.many2one("veiculos.veiculo", 'Veiculo', ondelete="cascade",
                                             required=True, select=True),
        'entvig_motorista_id': fields.many2one("veiculos.motorista", 'Motorista',
                                               ondelete="cascade", required=True, select=True),
        'entvig_ajudante_ids': fields.many2many("rh.funcionario", "entrega_ajudantes", "viagem_id",
                                                "funcionario_id", 'Ajudantes'),
        'state': fields.selection([('M', 'Montando'), ('A', 'Carregando'), ('L', 'Liberada'),
                                   ('V', 'Em viagem'), ('E', 'Registro'), ('R', 'Realizada'),
                                   ('C', 'Cancelada')],
                                  'Situacao', size=1, required=True),
        'entvig_carregamento_inicio': fields.datetime('Inicio do carregamento'),
        'entvig_carregamento_termino': fields.datetime('Termino do carregamento'),
        'entvig_data_hora_saida': fields.datetime('Data/Hora da saida'),
        'entvig_data_hora_retorno': fields.datetime('Data/Hora do retorno'),
        'entvig_obs': fields.text('Informacoes complementares'),
        'entvig_item_ids': fields.one2many("entrega.viagem.item", "entvit_capa_id", "Itens da viagem"),
        'entvig_venda_ids': fields.one2many("entrega.viagem.venda", "entviv_capa_id", "Vendas"),
        'entvig_liberou_user_id': fields.many2one('res.users', 'Liberado por', ondelete='restrict'),
        'entvig_liberou_data_hora': fields.datetime('Data/Hora da liberacao'),
        'entvig_carga_volume': fields.function(entvig_get_carga, multi='volume', method=True,
                                               string='Volume(Carga)', type='float', store=True),
        'entvig_carga_peso': fields.function(entvig_get_carga, multi='peso', method=True,
                                               string='Peso(Carga)', type='float', store=True),
    }
    _defaults = {
        'state': lambda *a: 'M',
    }
    _order = 'id desc'

