# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class entrega_viagem_item(osv.Model):
    """
    Tabela de itens das viagens realizadas/a realizar
    Prefixo: entvit_
    """

    _name = 'entrega.viagem.item'
    _rec_name = 'entvit_item_id'
    _inherits = {
        'entrega.viagem': 'entvit_capa_id',
        'entrega.vendas.item': 'entvit_item_id',
    }
    from funcoes import entvit_get_entrega
    from funcoes import entvit_get_devolucao
    _columns = {
        'id': fields.integer('Numero', readonly=True),
        'entvit_capa_id': fields.many2one('entrega.viagem', 'Viagem', ondelete="cascade", required=True, select=True),
        'entvit_venda_id': fields.many2one('entrega.vendas.capa', 'Venda', ondelete="cascade", required=True, select=True),
        'entvit_item_id': fields.many2one('entrega.vendas.item', 'Item', ondelete="cascade", required=True, select=True),
        'entvit_embalagem_id': fields.many2one('estoque.produto.embalagem', 'Embalagem',
                                               ondelete='restrict', required=True),
        'entvit_quantidade': fields.float('Quantidade', required=True),
        'entvit_qtd_devolvida': fields.function(entvit_get_devolucao, method=True,
                                               string='Devolucao', type='float', store=False),
        'entvit_data_entrega': fields.function(entvit_get_entrega, multi='data', method=True,
                                               string='Data da entrega', type='date', store=False),
        'entvit_hora_entrega': fields.function(entvit_get_entrega, multi='hora', method=True,
                                               string='Horario', type='float', store=False),
        'entvit_quem_recebeu': fields.function(entvit_get_entrega, multi='quem', method=True,
                                               string='Recebido por', type='text', store=False),
    }
