# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class estoque_categoria(osv.Model):
    """
    Tabela de Categoria de produtos (Segmentacao)
    """
    _name = 'estoque.categoria'
    _inherit = 'estoque.categoria'

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not len(ids):
            return []
        reads = self.read(cr, uid, ids, ['name', 'parent_id'], context=context)
        res = []
        for record in reads:
            name = record['name']
            if record.get('parent_id'):
                name = record['parent_id'][1] + '/' + name
            res.append((record['id'], name))
        return res

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if 'parent_id' in vals:
            parent_id = vals['parent_id']
        else:
            parent_id = False
        vals['controle'] = self.pool.get('adm.utils').get_controle(cr, uid, self._name, parent_id, False, context)
        result = super(estoque_categoria, self).create(cr, uid, vals, context)
        return result

    def unlink(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        record = self.search(cr, uid, [('parent_id', 'child_of', ids)], context=context)
        if record != ids:
            raise osv.except_osv(_('Atencao'), _('Categoria contem filho!'))
        result = super(estoque_categoria, self).unlink(cr, uid, ids, context)
        return result

    def name_search(self, cr, uid, name='', args=None, operator='ilike', context=None, limit=100):
        #  Esta alteracao foi realizada, pelo fato do open, utilizar por padrao um limit de 160
        #  no name_search, porem foi orientando pelo Luiz, para que na situacao da categoria,
        #  mostre todas as categorias caso a pessoa click no botao pesquisar mais de campos
        #  Many2one. Chamado 99775
        if limit == 160:
            limit = None
        return super(estoque_categoria, self).name_search(cr, uid, name, args, operator, context,
                                                          limit)
