# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class estoque_embalagem(osv.Model):
    _name = 'estoque.embalagem'
    _inherit = 'estoque.embalagem'

    def name_get(self, cr, uid, ids, context=None):
        if not len(ids):
            return {}
        context = context and context.copy() or {}
        reads = self.read(cr, uid, ids, ['sigla', 'name'], context=context)
        res = []
        for record in reads:
            name = '%s - %s' % (record['sigla'], record['name'])
            res.append((record['id'], name))
            if context.get('estemb_so_codigo'):
                res.append((record['id'], record['sigla']))
        return res

    def create(self, cr, uid, vals, context=None):
        """
        Metodo para alteracao do registro
        Converte a sigla para maiusculas antes da gravacao
        """
        context = context and context.copy() or {}
        if vals.get('sigla'):
            if isinstance(vals['sigla'], str):
                vals['sigla'] = vals['sigla'].upper()
        if 'quantidade_na_embalagem' in vals:
            if vals.get('quantidade_na_embalagem') <= 0.0:
                raise osv.except_osv(_('Atencao'), _('Quantidade na embalagem nao pode ser igual '
                                                     'ou menor que zero.'))
        # Bloco inserido na versao 3G1, para evitar erro na insercao de dados do arquivo local.xml
        # em bases que ja tem local cadastrado.
        # TODO: Pode ser removido apos a versao  4A1
        if context.get('install_mode') and context['install_mode']:
            args = [('sigla', '=', vals['sigla'])]
            _id = self.search(cr, uid, args, context=context)
            if _id:
                return _id[0]
            # Fim do Bloco #
        return super(estoque_embalagem, self).create(cr, uid, vals, context)

    def write(self, cr, uid, ids, vals, context=None):
        """
        Metodo para alteracao do registro
        Converte a sigla para maiusculas antes da gravacao
        """
        context = context and context.copy() or {}
        if vals.get('sigla'):
            if isinstance(vals['sigla'], str):
                vals['sigla'] = vals['sigla'].upper()
        if 'quantidade_na_embalagem' in vals:
            if vals.get('quantidade_na_embalagem') <= 0.0:
                raise osv.except_osv(_('Atencao'), _('Quantidade na embalagem nao pode ser igual '
                                                     'ou menor que zero.'))
        return super(estoque_embalagem, self).write(cr, uid, ids, vals, context)

    def name_search(self, cr, user, name='', args=None, operator='ilike', context=None, limit=100):
        context = context and context.copy() or {}
        ids = []
        if len(name) > 0 and len(name) <= 6:
            ids = self.search(cr, user, [('sigla', '=', name.upper())] + args, limit=limit, context=context)
        if not ids:
            ids = self.search(cr, user, [('name', operator, name)] + args, limit=limit, context=context)
        return self.name_get(cr, user, ids, context)
