# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class estoque_embalagem_unidade(osv.Model):
    """
    Tabela de Unidades.
    """

    _name = 'estoque.embalagem.unidade'
    _inherit = 'estoque.embalagem.unidade'

    def search(self, cr, user, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        _new_args = []
        for arg in args:
            if arg[0] == 'unidade':
                _new_args.append((arg[0], arg[1], arg[2].upper()))
            else:
                _new_args.append(arg)
        res = super(estoque_embalagem_unidade, self).search(
            cr, user, _new_args, offset=offset, limit=limit, order=order, context=context,
            count=count)
        return res

    def name_search(self, cr, user, name='', args=None, operator='ilike', context=None, limit=100):
        """
           Pesquisa unidade da embalagem
        """
        context = context and context.copy() or {}
        ids = []
        if len(name) > 0 and len(name) <= 3:
            ids = self.search(cr, user, [('unidade', '=', name.upper())] + args, limit=limit, context=context)
        if not ids:
            ids = self.search(cr, user, [('name', operator, name)] + args, limit=limit, context=context)
        return self.name_get(cr, user, ids, context)

    def create(self, cr, uid, vals, context=None):
        """
        Metodo para criacao do registro
        Converte a unidade para maiusculas antes da gravacao
        """

        context = context and context.copy() or {}
        vals['unidade'] = vals['unidade'].upper()
        if vals['unidade'] == vals['name']:
            raise osv.except_osv(_('Atencao'), _('Descricao invalida. Nao pode ser igual a unidade'))
            # Bloco inserido na versao 3G1, para evitar erro na insercao de dados do arquivo local.xml
        # em bases que ja tem local cadastrado.
        # TODO: Pode ser removido apos a versao  4A1
        if context.get('install_mode') and context['install_mode']:
            args = [('unidade', '=', vals['unidade'])]
            _id = self.search(cr, uid, args, context=context)
            if _id:
                return _id[0]
            # Fim do Bloco #
        result = super(estoque_embalagem_unidade, self).create(cr, uid, vals, context)
        return result

    def write(self, cr, uid, ids, vals, context=None):
        """
        Metodo para alteracao do registro
        Converte a unidade para maiusculas antes da gravacao
        """
        context = context and context.copy() or {}
        if 'unidade' in vals:
            vals['unidade'] = vals['unidade'].upper()
        result = super(estoque_embalagem_unidade, self).write(cr, uid, ids, vals, context)
        return result
