# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
from dateutil.relativedelta import relativedelta
from dateutil.parser import parse
from datetime import datetime
import math
import base64
from dateutil.parser import parse
import time
from SigUtils.numero import getNumeroEditado

LOAD = '_classic_write'


class estsug_compra_capa(osv.Model):
    # prefixo: esgccp_
    _inherit = 'estsug.compra.capa'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if not vals.get('esgccp_prazo_sugestao') or vals.get('esgccp_prazo_sugestao') <= 0:
            raise osv.except_osv(_('Atencao'), _('"Prazo estoque para sugestao" possui um '
                                                 'valor invalido'))
        if not vals.get('esgccp_prazo_media') or vals.get('esgccp_prazo_media') <= 0:
            raise osv.except_osv(_('Atencao'), _('"Prazo para calculo em media" possui um '
                                                 'valor invalido'))
        res = super(estsug_compra_capa, self).create(cr, uid, vals, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if 'esgccp_prazo_sugestao' in vals and vals.get('esgccp_prazo_sugestao') <= 0:
            raise osv.except_osv(_('Atencao'), _('"Prazo estoque para sugestao" possui um '
                                                 'valor invalido'))
        if 'esgccp_prazo_media' in vals and vals.get('esgccp_prazo_media') <= 0:
            raise osv.except_osv(_('Atencao'), _('"Prazo para calculo em media" possui um '
                                                 'valor invalido'))
        res = super(estsug_compra_capa, self).write(cr, uid, ids, vals, context)
        return res

    def esgccp_button_pesquisar(self, cr, uid, ids, context=None):
        """
        O metodo realiza a busca dos produtos e suas informacoes de acordo com os filtros
        selecionados. Para o tipo de sugestao estatistica a busca eh feita basicamente pela tabela
        de movimento de itens. Ja a sugestao minimo/maximo pela tabela da grade dos produtos.
        :param cr: cursor no banco de dados
        :param uid: id do usuario
        :param ids: lista de id da tabela
        :param context: dicionario com valores contextuais
        :return: True
        """
        context = context and context.copy() or {}
        estsug_compra_capa_dados = self.read(cr, uid, ids, [], context=context,
                                             load='_classic_write')
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name,
                                                                    context=context)
        empresa_fiscal = self.pool.get('res.company').browse(cr, uid, company_id, context).\
            rescon_fiscal
        if empresa_fiscal:
            raise osv.except_osv(_('Atencao'), _('Empresa fiscal nao gera sugestao de compras!'))
        for sugestao in estsug_compra_capa_dados:
            capa_id = sugestao.get('id')
            cr.execute("""DELETE FROM estsug_compra_item WHERE esgcit_capa_id = %s""" % capa_id)
            prazo_sugestao = sugestao.get('esgccp_prazo_sugestao') or 0  # Prazo em dias
            prazo_media = sugestao.get('esgccp_prazo_media') or 0  # Prazo em meses
            fornecedor_id = sugestao.get('esgccp_fornecedor_id') or False
            comprador_id = sugestao.get('esgccp_comprador_id') or False
            representante_id = sugestao.get('esgccp_representante_id') or False
            fabricante_id = sugestao.get('esgccp_fabricante_id') or False
            categoria_id = sugestao.get('esgccp_categoria_id') or False
            categoria_ids = []
            if categoria_id:
                categoria_ids = self.pool.get('estoque.categoria').search(cr, uid,
                                                          [('parent_id', 'child_of', categoria_id)])
            local_id = sugestao.get('esgccp_local_id') or False
            codigo_imprimir = sugestao.get('esgccp_codigo_imprimir')
            tipo_sugestao = sugestao.get('esgccp_sugestao')
            curva = sugestao.get('esgccp_curva')
            custo = sugestao.get('esgccp_custo')
            considera_mes_atual = sugestao.get('esgccp_mes_atual') or False
            listar_estatistica = sugestao.get('esgccp_lista_estatistica') or False
            todas_empresas = sugestao.get('esgccp_considera_empresa') or False
            gerar_por_empresa = False
            if todas_empresas and sugestao.get('esgccp_gerar_por_empresa'):
                gerar_por_empresa = True

            considera_pedidos = sugestao.get('esgccp_considera_pedidos') or False
            so_sugestao = sugestao.get('esgccp_so_sugestao') or False
            produto_ids = self._esgccp_get_list_produto(cr, uid, ids, fornecedor_id, comprador_id,
                                                        representante_id, categoria_ids,
                                                        fabricante_id, context)
            if any([fornecedor_id, comprador_id, representante_id, categoria_id]) and not \
                    produto_ids:
                return True

            data_final = datetime.now()
            if considera_mes_atual:
                data_inicial = data_final - relativedelta(days=data_final.day - 1)
                if prazo_media > 1:
                    prazo_media -= 1
                    data_inicial = (data_final - relativedelta(months=prazo_media)) - relativedelta(
                        days=data_final.day - 1)
            else:
                data_final = data_final - relativedelta(days=data_final.day)
                data_inicial = (data_final - relativedelta(months=prazo_media)) + relativedelta(
                    days=1)

            data_final = data_final.strftime('%Y-%m-%d')
            data_inicial = data_inicial.strftime('%Y-%m-%d')
            select_custo = ''
            if tipo_sugestao == 'E':  # Opcao estatistica
                if custo == 'C':
                    select_custo = 'custo_corrigido'
                elif custo == 'M':
                    select_custo = 'custo_medio_contabil'
                elif custo == 'R':
                    select_custo = 'custo_reposicao'
                elif custo == 'U':
                    select_custo = 'ultimo_custo'

                item_ids = self._esgccp_get_dado_estatistica(
                    cr, uid, capa_id, select_custo, data_inicial, data_final, local_id,
                    todas_empresas, company_id, produto_ids, prazo_sugestao, prazo_media, curva,
                    listar_estatistica, codigo_imprimir, considera_pedidos, so_sugestao,
                    gerar_por_empresa, comprador_id, context)
                if item_ids:
                    self.write(cr, uid, sugestao.get('id'), {'esgccp_item_ids': item_ids}, context=context)

            elif tipo_sugestao == 'M':  # Opcao minimo/maximo
                if custo == 'C':
                    select_custo = 'custo_corrigido'
                elif custo == 'M':
                    select_custo = 'custo_medio_contabil'
                elif custo == 'R':
                    select_custo = 'custo_reposicao'
                elif custo == 'U':
                    select_custo = 'ultimo_custo'
                item_ids = self._esgccp_get_dado_minimo_maximo(
                    cr, uid, capa_id, select_custo, data_inicial, data_final, local_id,
                    todas_empresas, company_id, produto_ids, prazo_media, curva, listar_estatistica,
                    codigo_imprimir, considera_pedidos, so_sugestao, gerar_por_empresa, comprador_id,
                    context)
                if item_ids:
                    self.write(cr, uid, sugestao.get('id'), {'esgccp_item_ids': item_ids}, context=context)

            obj_estsug_compra_item = self.pool.get('estsug.compra.item')
            if sugestao.get('esgccp_ordem') == 'D':
                obj_estsug_compra_item._order = 'esgcit_item_descricao'
            elif sugestao.get('esgccp_ordem') == 'O':
                obj_estsug_compra_item._order = 'esgcit_item_codigo'
            elif sugestao.get('esgccp_ordem') == 'U':
                obj_estsug_compra_item._order = 'esgcit_classificacao'
            else:
                obj_estsug_compra_item._order = 'esgcit_produto_id, esgcit_grade_id, esgcit_empresa'

        return True

    def _esgccp_get_quantidade_pedido_minimo_maximo(self, query_empresa_nao_fiscal):
        sql = """
            (select sum(qtde_pedida)
             from estoquepedidos_pedido_item i
             left join estoquepedidos_pedido_capa c on c.id = i.pedido_id
             where i.grade_id = epg.id and c.tipo = 'C' and c.state = 'V' and c.%s
            ) as pedidos,
        """ % query_empresa_nao_fiscal
        return sql

    def _esgccp_get_sql_saidas_minimo_maximo(self, data_inicial, data_final, cond_operacao,
                                             local, empresa):
        sql = """
                (
                select sum(i.quantidade) from estoque_movimento_capa c
                    inner join estoque_movimento_itens i on i.capa_id = c.id
                    inner join fiscal_nf_capa f on f.id = c.nf_capa_id
                    where
                        c.state = 'F'
                        and i.produto_id = epg.produto_id
                        and i.grade_id = epg.id
                        and c.data between '{data_inicial}' AND '{data_final}'
                        {cond_operacao}
                        {_local}
                        {_empresa}) as saidas,
        """.format(data_inicial=data_inicial,
                   data_final=data_final,
                   cond_operacao=cond_operacao,
                   _local=local,
                   _empresa=empresa)
        return sql

    def _esgccp_get_dado_minimo_maximo(self, cr, uid, sugestao_id, custo, data_inicial, data_final,
                                       local_id, considera_todas_empresas, company_id, produto_ids,
                                       prazo_media, tipo_curva, listar_estatistica,
                                       codigo_imprimir, considera_pedidos, so_sugestao,
                                       gerar_por_empresa, comprador_id, context=None):
        """
        O metodo realiza a busca dos produtos e suas informacoes de acordo com os parametros
        passados. Para o tipo de sugestao minimo/maximo a busca eh feita basicamente pela tabela
        de grade dos produtos.
        :param cr: cursor no banco de dados
        :param uid: id do usuario
        :param sugestao_id: id da tabela
        :param custo: char de descricao do custo que sera considerado
        :param data_inicial: data inicial do periodo relacionado ao movimento de itens
        :param data_final: data final do periodo relacionado ao movimento de itens
        :param local_id: id da tabela estoque_local
        :param considera_todas_empresas: booleano que identifica se sera usada todas as empresas
        ou somente a que esta relacionada a tabela, para a busca dos dados
        :param company_id: id da tabela res_company
        :param produto_ids: lista de id dos produtos
        :param prazo_media: inteiro que identifica o periodo em meses
        :param tipo_curva: char que identifica a curva, sendo A , B, C ou T (Todas)
        :param listar_estatistica: booleano que identica se as estatisticas de venda de cada
        produto sera exibida
        :param codigo_imprimir: char para definir se sera impresso o codigo do item (I) ou do
        fabricante (F)
        :param gerar_por_empresa: lista os itens e seus detalhes separados por empresa. Boolean.
        :return: Lista com os dados que serao incluidos na tree de itens, tabela estsug_compra_item
        """

        context = context and context.copy() or {}
        # ___________________________ Objects ________________________________
        obj_estoque_preco_custo = self.pool.get('estoque.preco.custo')
        obj_estoque_preco_venda = self.pool.get('estoque.preco.venda')
        obj_estoque_produto_saldo = self.pool.get('estoque.produto.saldo')
        obj_estoque_produto = self.pool.get('estoque.produto')
        obj_estoque_produto_grade = self.pool.get('estoque.produto.grade')

        res = []

        query_empresa_nao_fiscal = self.esgccp_get_query_empresa_nao_fiscal(
            cr, uid, company_id, considera_todas_empresas, gerar_por_empresa, context)

        brw_estsug_compra_capa = self.browse(cr, uid, sugestao_id, context)
        dias_mes_atual = brw_estsug_compra_capa.esgccp_dias_mes_atual

        sql = """
        SELECT id
          FROM estoque_natureza_operacao
          WHERE estnto_atualizar_saldo = True
                AND estnto_tipo_operacao = 'S'
                AND active = True
                AND estnto_movimento_origem_id
                    IN (SELECT id FROM estoque_movimento_origem WHERE estmog_codigo IN (%s))
        """ % ("'" + "','".join(self.esgccp_get_origem_codigo(cr, uid, sugestao_id, context)) + "'")
        cr.execute(sql)
        operacao_ids = tuple([x[0] for x in cr.fetchall()])
        if len(operacao_ids) == 1:
            operacao_ids = str(operacao_ids).replace(',', '')
        else:
            operacao_ids = str(operacao_ids)
        _local = ''
        if local_id:
            _local = ' AND local_id = %s' % local_id
        _empresa = ' AND c.' + query_empresa_nao_fiscal

        sql = """
            SELECT
                epg.produto_id,
                epg.id AS grade_id,
                epg.grade AS sigla_grade,
                epg.codigo_no_fabricante AS codigo_fabricante,
                epg.name as item_nome,
                {quantidade_pedido}
                (select current_date - max(c.data_emissao)
                 from estoquepedidos_pedido_item i
                 left join estoquepedidos_pedido_capa c on c.id = i.pedido_id
                 where i.grade_id = epg.id and c.tipo = 'C' and c.state = 'V' and c.{nao_fiscal}
                ) as pedido_dias,
        """.format(quantidade_pedido=self._esgccp_get_quantidade_pedido_minimo_maximo(
                   query_empresa_nao_fiscal),
                   nao_fiscal=query_empresa_nao_fiscal)
        if gerar_por_empresa:
            sql += """
                ep.company_id AS company_id,
            """
        cond_operacao = ""
        if operacao_ids and operacao_ids != '()':
            cond_operacao = "AND estmvc_operacao_id in %s" % operacao_ids

        sql += self._esgccp_get_sql_saidas_minimo_maximo(data_inicial, data_final, cond_operacao,
                                                         _local, _empresa)

        sql += """
                (
                    SELECT sum(emi.vr_total_item)
                    FROM estoque_movimento_itens emi
                    INNER JOIN estoque_movimento_capa emc
                        ON emc.id = emi.capa_id
                    INNER JOIN estoque_natureza_operacao eno
                        ON eno.id = emc.estmvc_operacao_id
                    WHERE emc.%s
        """ % query_empresa_nao_fiscal
        if local_id:
            sql += """
                        AND emi.local_id = %s
            """ % local_id
        sql += """
                        AND emi.produto_id = epg.produto_id
                        AND emi.grade_id = epg.id
                        AND emc.data >= '%s'
                        AND emc.data <= '%s'
                        %s

        """ % (data_inicial, data_final, self.esgccp_get_query_cfop(cr, uid, sugestao_id, context))
        cond_eno = ""
        if operacao_ids and operacao_ids != '()':
            cond_eno += "AND eno.id IN %s" % operacao_ids

        sql += """
                        {cond_eno}
                ) AS vr_total_item,
        """.format(cond_eno=cond_eno)
        sql += """
                (
                select max(data) from estoque_movimento_capa c
                    inner join estoque_movimento_itens i on i.capa_id = c.id
                    inner join fiscal_nf_capa f on f.id = c.nf_capa_id
                    where i.produto_id = epg.produto_id and i.grade_id = epg.id
                        and c.data between '%s' AND '%s'
                        and f.state = '3' and f.tipo = 'E'
                        %s %s ) as ult_entrada,
                """ % (data_inicial, data_final, _local, _empresa)
        sql += """
                (
                SELECT i.quantidade 
                FROM estoque_movimento_capa        AS c
                INNER JOIN estoque_movimento_itens AS i ON i.capa_id = c.id
                INNER JOIN fiscal_nf_capa          AS f ON f.id = c.nf_capa_id
                WHERE c.data between '%s' AND '%s' 
                  AND i.grade_id = epg.id
                  AND i.produto_id = epg.produto_id
                  AND f.state = '3' 
                  AND f.tipo = 'E'
                  %s %s 
                ORDER BY c.data DESC
                LIMIT 1) AS qtd_entrada,
                """ % (data_inicial, data_final, _local, _empresa)
        sql += """
                (
                    SELECT min(epe.estpre_unidade_produto)
                    FROM estoque_produto_embalagem epe
                    WHERE
                    epe.produto_id = epg.produto_id
                    AND active = True
                ) AS sigla_uni,
                (
                    SELECT min(ee.quantidade_na_embalagem)
                    FROM estoque_embalagem ee
                    WHERE
                    id IN (
                        SELECT epe.embalagem_id
                        FROM estoque_produto_embalagem epe
                        WHERE
                        epe.produto_id = epg.produto_id
                        )
                ) AS qtd_emb,
                epg.minimo,
                epg.maximo
            FROM estoque_produto_grade epg
            INNER JOIN estoque_produto ep
                ON ep.id = epg.produto_id
            WHERE
                epg.active = True
                --AND epg.minimo > 0
                --AND epg.maximo > 0
        """
        if produto_ids:
            sql += """
                AND epg.produto_id IN %s
            """ % produto_ids
        if comprador_id:
            sql += ' and comprador_id = %s ' % comprador_id
        cr.execute(sql)
        dados = cr.dictfetchall()
        if not dados:
            return res
        dados = sorted(dados, key=lambda i: i['produto_id'])
        #print '------------------------- LISTA PRODUTOS -----------------------'
        list_produto_id = list(set(map(lambda i: i.get('produto_id'), dados)))
        #print '------------------------- LISTA GRADES -----------------------'
        list_grade_id = list(set(map(lambda i: i.get('grade_id'), dados)))
        # Preco custo
        #print '------------------------- CUSTOS -----------------------'
        custos = obj_estoque_preco_custo.get_custos_do_dia(cr, uid, list_produto_id, company_id)
        # Preco venda
        #print '------------------------- PRECOS DE VENDA -----------------------'
        precos_venda = obj_estoque_preco_venda.get_preco_venda(
            cr, uid, epc_produto_ids=list_produto_id, epc_grade_ids=list_grade_id,
            epc_company_id=company_id)

        # Empresas envolvidas, caso opcao considerar todas as empresas esteja selecionada
        mm_company_ids = list(set(map(lambda rc: rc.get('company_id'), dados)))
        mm_company_ids = filter(lambda rc: rc, mm_company_ids)

        # Saldo produto
        # print '------------------------- SALDO PRODUTOS -----------------------'
        saldo_company = {}
        data_hoje = datetime.today().strftime('%Y-%m-%d')
        saldo_company_ids = self.pool.get('res.company').search(cr, uid, [], context=context)
        if (considera_todas_empresas or gerar_por_empresa) and len(saldo_company_ids) > 1:
            for c in saldo_company_ids:
                saldo_company.update({c: obj_estoque_produto_saldo.get_saldo_do_dia(
                    cr, uid, list_grade_id, data_hoje, local_id, c, context=context)})
        else:
            saldo_company = {company_id: obj_estoque_produto_saldo.get_saldo_do_dia(
                cr, uid, list_grade_id, data_hoje, local_id, context=context)}
        #print '------------------------- CURVA ABC -----------------------'
        # CURVA ABC
        dict_curva = obj_estoque_produto_grade.estpgr_calcula_curvaabc(cr, uid, tipo_curva, dados)
        if not dict_curva:
            return res
        if tipo_curva in ('A', 'B', 'C'):
            list_produto_id = list(dict_curva)
            dados = filter(lambda i: i.get('produto_id') in list_produto_id, dados)
            list_produto_id = list(set(map(lambda i: i.get('produto_id'), dados)))
            list_grade_id = list(set(map(lambda i: i.get('grade_id'), dados)))
        #print '------------------------- FIM CURVA ABC -----------------------'

        data_inicial_item_estatistica = str(parse(data_final) - relativedelta(months=11))[:8] + '01'

        count = 1
        list_produto_grade = []
        correlacao_empresa_fiscal = False
        if len(mm_company_ids) == 1:
            correlacao_empresa_fiscal = self.pool.get('res.company').browse(
                cr, uid, mm_company_ids[0], context).rescon_fiscal
        for x in dados:
            #print '------------------------- PERCORRENDO: %s -----------------------' % count
            count += 1
            minimo = x.get('minimo') or 0
            maximo = x.get('maximo') or 0
            produto_id = x.get('produto_id')
            grade_id = x.get('grade_id')
            # Valor saldo
            valor_saldo = sum(map(lambda c: saldo_company.get(c).get(grade_id)
                                  and saldo_company.get(c).get(grade_id).get('disponivel') or 0.0,
                                  saldo_company.keys()))
            pedidos = x.get('pedidos') or 0
            pedido_dias = x.get('pedido_dias') or 0
            # Sugestao
            sugestao = 0
            if valor_saldo <= 0:
                valor_saldo = 0

            if considera_pedidos:
                saldo_a_considerar = valor_saldo + pedidos
            else:
                saldo_a_considerar = valor_saldo
            if saldo_a_considerar < minimo:
                sugestao = maximo - saldo_a_considerar
            else:
                sugestao = 0
            if so_sugestao and sugestao == 0:
                continue
            sugestao = math.ceil(sugestao)
            grade_id = x.get('grade_id')
            produto_grade = '%s-%s' % (produto_id, grade_id)
            if produto_grade in list_produto_grade:
                continue
            list_produto_grade.append(produto_grade)
            movimento_dados = filter(
                lambda i: i.get('produto_id') == produto_id
                and i.get('grade_id') == grade_id, dados)
            curva = dict_curva.get(produto_id)
            sigla_grade = x.get('sigla_grade')
            grade_id = x.get('grade_id')
            ult_entrada = x.get('ult_entrada')
            qtd_entrada = x.get('qtd_entrada') or 0.0
            sigla_unidade = x.get('sigla_uni')
            quantidade_embalagem = x.get('qtd_emb')
            # Saidas
            qtd_total_saida = sum(map(lambda i: i.get('saidas') or 0.0, movimento_dados))
            # Valor custo
            dict_custo = custos.get(produto_id) or {}
            valor_custo = dict_custo.get('estprc_%s' % custo) or 0.0
            # Valor preco venda
            dados_preco_venda = precos_venda.get(produto_id) or {}
            valor_preco_venda = dados_preco_venda.get(grade_id) or dados_preco_venda.get(
                'preco_venda')

            # Calcular media
            prazo = prazo_media
            if dias_mes_atual:
                prazo = dias_mes_atual
            media = qtd_total_saida / (prazo * 30)

            # Dias calculo
            dias = 0
            if qtd_total_saida > 0 and valor_saldo > 0:
                dias = valor_saldo / media

            # Codigo no fabricante
            codigo_fabricante = x.get('codigo_fabricante') or ''
            item_nome = x.get('item_nome') or ''
            item_codigo = ''
            if codigo_imprimir == 'F':
                item_codigo = codigo_fabricante
            elif codigo_imprimir == 'I':
                context = {'estpro_codigo_e_digito': True}
                produto_name = obj_estoque_produto.name_get(cr, uid, [produto_id], context)
                item_codigo = produto_name[0][1]
            vals = {'esgcit_capa_id': sugestao_id,
                    'esgcit_empresa': x.get('company_id')
                    if not correlacao_empresa_fiscal and x.get('company_id') else company_id,
                    'esgcit_classificacao': curva,
                    'esgcit_produto_id': produto_id,
                    'esgcit_sigla_grade': sigla_grade,
                    'esgcit_grade_id': grade_id,
                    'esgcit_ult_entrada': ult_entrada,
                    'esgcit_qtd_entrada': qtd_entrada,
                    'esgcit_sigla_uni': sigla_unidade,
                    'esgcit_qtd_emb': quantidade_embalagem,
                    'esgcit_saidas': qtd_total_saida,
                    'esgcit_media': media,
                    'esgcit_custo': valor_custo,
                    'esgcit_preco_venda': valor_preco_venda,
                    'esgcit_saldo': valor_saldo,
                    'esgcit_pedidos': pedidos,
                    'esgcit_pedido_dias': pedido_dias,
                    'esgcit_dias': dias,
                    'esgcit_sugestao': sugestao,
                    'esgcit_minimo': minimo,
                    'esgcit_maximo': maximo,
                    'esgcit_codigo_fabricante': codigo_fabricante,
                    'esgcit_item_codigo': item_codigo,
                    'esgcit_item_descricao': item_nome,
                    'esgcit_item_estatistica_ids': self._esgccp_get_dado_item_estatistica(
                        cr, uid, sugestao_id, company_id, local_id, produto_id, grade_id,
                        data_inicial_item_estatistica, data_final) if listar_estatistica else []}
            res.append((0, 0, vals))
        return res

    def _esgccp_get_curva(self, cr, uid, tipo_curva, dados):
        """
        O metodo classifica a importancia de cada um dos produtos no estoque, baseado no total geral
        vendido e no total de cada item. A classificacao A representa um valor < 71%, a B representa
        >= 71% e < 86% e a C representa >= 86%.
        :param cr: cursor do banco de dados
        :param uid: id do usuario
        :param tipo_curva: char com uma das opcoes A, B, C ou T (todas)
        :param dados: lista de dicionarios com pelo menos as informacoes de id do produto e seu
        total vendido num periodo
        :return: dicionario com a chave representando o id do produto e o valor da mesma a
        classificacao da curva
        """
        dict_curva = {}
        total_valor_geral = sum(map(lambda i: i.get('vr_total_item') or 0.0, dados))
        list_produto_vr_total = sorted(dados, key=lambda i: i['vr_total_item'],
                                       reverse=True)
        acumulado = 0
        for x in list_produto_vr_total:
            total_item = x.get('vr_total_item') or 0.0
            acumulado += total_item
            porcentagem = 0
            if total_valor_geral:
                porcentagem = (acumulado / total_valor_geral) * 100
            if porcentagem < 71 and tipo_curva in ('T', 'A', False):
                dict_curva[x.get('produto_id')] = 'A'
            elif 71 <= porcentagem < 86 and tipo_curva in ('T', 'B', False):
                dict_curva[x.get('produto_id')] = 'B'
            elif porcentagem >= 86 and tipo_curva in ('T', 'C', False):
                dict_curva[x.get('produto_id')] = 'C'
        return dict_curva

    def _esgccp_get_quantidade_pedido_estatistica(self, separar_company):
        sql = """
                , (select sum(qtde_pedida)
                        from estoquepedidos_pedido_item epi
                        left join estoquepedidos_pedido_capa epc on epc.id = epi.pedido_id
                        where epi.grade_id = epg.id and epc.tipo = 'C'
                              and epc.state = 'V' AND {separar_company}) as pedidos
        """.format(separar_company=separar_company)
        return sql

    def _esgccp_get_dados_ajusta_media(self, cr, uid, sugestao_id, data_inicial, data_final,
                                       grade_ids, considera_todas_empresas, company_id, local_id,
                                       query_company, context=None):
        """
        O metodo encontra a quantidade de dias em que houve saldo para cada grade
        recebida, num determinado periodo
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id do objeto 'res.users', identificador do usuario.
        :type uid: int
        :param sugestao_id: id desse objeto, identificador da sugestao de compra.
        :type sugestao_id: int
        :param data_inicial: representacao da data inicial que compoe o periodo de busca.
        :type data_inicial: str
        :param data_final: representacao da data final que compoe o periodo de busca.
        :type data_final: str
        :param grade_ids: lista de id do objeto 'estoque.produto.grade', identificadores dos
        produtos
        :type grade_ids: list
        :param considera_todas_empresas: valor que representa a busca das datas para todas as
        empresas
        :type considera_todas_empresas: bool
        :param company_id: id do objeto 'res.company', identificador da empresa.
        :type company_id: int
        :param local_id: id do objeto 'estoque.local', idenficador da localidade do produto no
        estoque
        :param context: dados contextuais.
        :type context: dict
        :return: dados da identificacao das grades e suas respectivas quantidades.
        :rtype: dict
        """
        context = context and context.copy() or {}
        dados = {}
        periodo_total = (parse(data_final) - parse(data_inicial)).days
        for grade_id in grade_ids:
            sql_saldo_anterior = """
                SELECT
                    data_movimento,
                    saldo
                FROM
                    estoque_produto_saldo
                WHERE
                    grade_id = {grade_id}
                    AND data_movimento <= '{data_inicial}'
                    {company}
                    {local}
                ORDER BY data_movimento DESC
                LIMIT 1
            """.format(grade_id=grade_id, data_inicial=data_inicial,
                       company='AND ' + query_company,
                       local='AND local_id = %s' % local_id if local_id else '')

            cr.execute(sql_saldo_anterior)
            saldo_anterior_dados = cr.dictfetchall() or {}
            periodo_anterior_sem_saldo = 0
            data_anterior_sem_saldo = ''
            if saldo_anterior_dados:
                saldo_anterior_dados = saldo_anterior_dados[0]
                if saldo_anterior_dados.get('saldo') <= 0:
                    data_anterior_sem_saldo = saldo_anterior_dados.get('data_movimento')

            sql = """
                SELECT
                    data_movimento,
                    saldo
                FROM
                    estoque_produto_saldo
                WHERE
                    grade_id = {grade_id}
                    AND data_movimento BETWEEN '{data_inicial}' AND '{data_final}'
                    {company}
                    {local}
                ORDER BY data_movimento, id
            """.format(grade_id=grade_id, data_inicial=data_inicial, data_final=data_final,
                       company='AND ' + query_company,
                       local='AND local_id = %s' % local_id if local_id else '')
            cr.execute(sql)
            lista_datas = cr.dictfetchall()
            qtd_dia = 0
            if not lista_datas and data_anterior_sem_saldo:
                qtd_dia = 0
            elif not lista_datas and saldo_anterior_dados.get('saldo') > 0:
                qtd_dia = periodo_total + 1
            data_dict = {}
            sem_saldo_anterior = False
            for data in lista_datas:
                data_anterior = data_inicial
                if lista_datas.index(data) > 0:
                    data_anterior = data_dict.get('data_movimento')

                if (data_anterior_sem_saldo and (data_anterior_sem_saldo < data.get(
                        'data_movimento')) and lista_datas.index(data) == 0) \
                        or data.get('saldo') <= 0:
                    if sem_saldo_anterior:
                        periodo_anterior_sem_saldo += (parse(data.get('data_movimento')) -
                                                       parse(data_anterior)).days
                    if not saldo_anterior_dados and lista_datas.index(data) == 0:
                        pass
                    elif not sem_saldo_anterior:
                        qtd_dia += (parse(data.get('data_movimento')) - parse(data_anterior)).days
                    sem_saldo_anterior = True
                else:
                    if not saldo_anterior_dados and lista_datas.index(data) == 0:
                        pass
                    elif not sem_saldo_anterior:
                        qtd_dia += (parse(data.get('data_movimento')) - parse(data_anterior)).days
                    sem_saldo_anterior = False
                data_dict = data

                if (lista_datas.index(data) + 1) == len(lista_datas) and data.get('saldo') > 0:
                    qtd_dia += (parse(data_final) - parse(data.get('data_movimento'))).days
            dados.update({grade_id: qtd_dia + 1 if qtd_dia >= 0 else 0})
        return dados

    def _esgccp_get_dado_estatistica(self, cr, uid, sugestao_id, custo, data_inicial, data_final,
                                     local_id, considera_todas_empresas, company_id, produto_ids,
                                     prazo_sugestao, prazo_media, tipo_curva, listar_estatistica,
                                     codigo_imprimir, considera_pedidos, so_sugestao,
                                     gerar_por_empresa, comprador_id, context=None):
        """
        O metodo realiza a busca dos produtos e suas informacoes de acordo com os parametros
        passados. Para o tipo de sugestao estatistica a busca eh feita basicamente pela tabela
        de movimento de itens, mais especificamente no que foi vendido.

        :param cr: cursor no banco de dados
        :param uid: id do usuario
        :param sugestao_id: id da tabela
        :param custo: char de descricao do custo que sera considerado
        :param data_inicial: data inicial do periodo relacionado ao movimento de itens
        :param data_final: data final do periodo relacionado ao movimento de itens
        :param local_id: id da tabela estoque_local
        :param considera_todas_empresas: booleano que identifica se sera usada todas as empresas
        ou somente a que esta relacionada a tabela, para a busca dos dados
        :param company_id: id da tabela res_company
        :param produto_ids: lista de id dos produtos
        :param prazo_sugestao: inteiro que identifica um periodo em dias
        :param prazo_media: inteiro que identifica um periodo de movimentacao, em meses
        :param tipo_curva: char que identifica a curva, sendo A , B, C ou T (Todas)
        :param listar_estatistica: booleano que identica se as estatisticas de venda de cada
        produto sera exibida
        :param codigo_imprimir: char para definir se sera impresso o codigo do item (I) ou do
        fabricante (F)
        :param gerar_por_empresa: lista os itens e seus detalhes separados por empresa. Boolean.
        :return: Lista com os dados que serao incluidos na tree de itens, tabela estsug_compra_item
        """

        # ___________________________ Objects ________________________________
        context = context and context.copy() or {}
        obj_estoque_preco_custo = self.pool.get('estoque.preco.custo')
        obj_estoque_preco_venda = self.pool.get('estoque.preco.venda')
        obj_estoque_produto_saldo = self.pool.get('estoque.produto.saldo')
        obj_estoque_produto = self.pool.get('estoque.produto')
        obj_estoque_produto_grade = self.pool.get('estoque.produto.grade')
        obj_estoque_movimento_itens = self.pool.get('estoque.movimento.itens')
        obj_adm_util = self.pool.get('adm.utils')

        context = context and context.copy() or {}
        brw_estsug_compra_capa = self.browse(cr, uid, sugestao_id, context)
        dias_mes_atual = brw_estsug_compra_capa.esgccp_dias_mes_atual

        query_empresa_nao_fiscal = self.esgccp_get_query_empresa_nao_fiscal(
            cr, uid, company_id, considera_todas_empresas, gerar_por_empresa, context)

        madeireira_instalado = obj_adm_util.admutl_check_modulo_instalado(
            cr, uid, 'madeireira', context)
        ecf_instalado = obj_adm_util.admutl_check_modulo_instalado(
            cr, uid, 'ecf', context)

        res = []
        separar_company = query_empresa_nao_fiscal

        sql = """
            SELECT epg.produto_id                 AS produto_id
                 , epg.id                         AS grade_id
                 , SUM(emi.vr_total_item)         AS vr_total_item
                 , epg.grade                      AS sigla_grade
                 , epg.codigo_no_fabricante       AS codigo_fabricante
                 , epg.minimo                     AS minimo
                 , epg.maximo                     AS maximo
                 , epe.estpre_unidade_produto     AS sigla_uni
                 , ee.quantidade_na_embalagem     AS qtd_emb
                 , epg.name                       AS item_nome
                 {quantidade_pedido}
                 , (select current_date - max(epc.data_emissao)
                    from estoquepedidos_pedido_item i
                    left join estoquepedidos_pedido_capa epc on epc.id = i.pedido_id
                    where i.grade_id = epg.id and epc.tipo = 'C'
                          and epc.state = 'V' AND %s) as pedido_dias
        """ % separar_company
        if gerar_por_empresa:
            sql += """
                , emc.company_id                 AS company_id
            """
        sql_quantidade_pedido = self._esgccp_get_quantidade_pedido_estatistica(separar_company)
        sql = sql.format(quantidade_pedido=sql_quantidade_pedido)

        if madeireira_instalado:
            if ecf_instalado:
                sql += """
                 , SUM(
                   CASE
                       WHEN emi.estmvi_volume > 0 AND ecc.tipo_cupom = 'C' THEN
                           -emi.estmvi_volume
                       WHEN emi.estmvi_volume > 0 AND ecc.tipo_cupom != 'C' THEN
                           emi.estmvi_volume
                       WHEN emi.estmvi_volume = 0 AND ecc.tipo_cupom = 'C' THEN
                           -emi.quantidade
                       WHEN emi.estmvi_volume > 0 THEN
                           emi.estmvi_volume
                       ELSE
                           emi.quantidade
                       END
                   )                             AS saidas
                """
            else:
                sql += """
                 , SUM(
                   CASE WHEN  emi.estmvi_volume > 0 THEN
                       emi.estmvi_volume
                   ELSE
                       emi.quantidade
                   END)                           AS saidas
                """
        else:
            if ecf_instalado:
                sql += """
                 , SUM(
                       CASE WHEN ecc.tipo_cupom = 'C' THEN
                           -emi.quantidade
                       ELSE
                           emi.quantidade
                       END
                   )                           AS saidas
                """
            else:
                sql += """
                 , SUM(emi.quantidade)         AS saidas
                """

        if custo:
            sql += """
                , SUM(emi.estmvi_saidas_%s_total)  AS custo
            """ % custo

        sql += """
            from estoque_produto_grade            AS epg
            left  join estoque_movimento_itens   AS emi on emi.grade_id = epg.id
                  %s
            left  JOIN estoque_movimento_capa    AS emc  ON emc.id  = emi.capa_id
                  and emc.estmvc_operacao_id IN (
                     SELECT id FROM estoque_natureza_operacao WHERE estnto_movimento_origem_id IN (
                         SELECT id FROM estoque_movimento_origem WHERE estmog_codigo IN (%s)
                     )  AND  estnto_gerar_estatistica = TRUE AND estnto_tipo_operacao = 'S'
                  )
                  AND  emc.data BETWEEN '%s' AND  '%s'
            left  JOIN estoque_produto           AS ep   ON ep.id   = epg.produto_id
            left  JOIN estoque_produto_embalagem AS epe  ON epe.id  = emi.produto_embalagem_id
            left  JOIN estoque_embalagem         AS ee   ON ee.id   = epe.embalagem_id
        """ % (self.esgccp_get_query_cfop(cr, uid, sugestao_id, context),
               "'" + "','".join(self.esgccp_get_origem_codigo(cr, uid, sugestao_id, context)) + "'",
               data_inicial, data_final)
        if local_id:
            sql += """
                inner join estoque_local_locacao as ell on ell.grade_id = epg.id and ell.local_id = %s
                """ % local_id

        if ecf_instalado:
            sql += """
            LEFT   JOIN ecf_cupons_capa           AS ecc ON ecc.id = emi.cupom_id
            """

        _where = "epg.active = True AND emc.state = 'F' AND emc." + separar_company

        if produto_ids:
            if _where:
                _where += ' and '
            _where += """ epg.produto_id IN %s """ % produto_ids

        if ecf_instalado:
            if _where:
                _where += ' and '
            _where += """ not (emi.item_cancelado is True AND ecc.tipo_cupom = 'V') """

        if comprador_id:
            _where += ' and ep.comprador_id = %s ' % comprador_id
        if _where:
            sql += ' where ' + _where
        sql += """
            GROUP  BY epg.produto_id, epg.id, epg.name, epg.grade, epg.codigo_no_fabricante,
                      epg.minimo, epg.maximo, epe.estpre_unidade_produto,
                      ee.quantidade_na_embalagem
        """
        if gerar_por_empresa:
            sql += """
                      , emc.company_id
            """
        cr.execute(sql)
        dados = cr.dictfetchall()

        if not so_sugestao:
            dados = self._esgccp_get_itens_sem_movimento(
                cr, uid, dados, produto_ids, gerar_por_empresa, company_id, comprador_id, context)

        dados = sorted(dados, key=lambda i: i.get('produto_id'))  # Ordena por produto

        #  LISTA PRODUTOS
        list_produto_id = list(set(map(lambda i: i.get('produto_id'), dados)))

        #  LISTA GRADES
        list_grade_id = list(set(map(lambda i: i.get('grade_id'), dados)))

        # Preco custo
        custos = obj_estoque_preco_custo.get_custos_do_dia(cr, uid, list_produto_id, company_id)

        # Preco venda
        precos_venda = obj_estoque_preco_venda.get_preco_venda(
            cr, uid, epc_produto_ids=list_produto_id, epc_grade_ids=list_grade_id,
            epc_company_id=company_id)

        # Empresas envolvidas, caso opcao considerar todas as empresas esteja selecionada
        e_company_ids = self.pool.get('res.company').search(cr, uid, [], context=context)

        # Saldo produto
        # print '------------------------- SALDO PRODUTOS -----------------------'
        saldo_company = {}
        data_hoje = datetime.today().strftime('%Y-%m-%d')
        if (considera_todas_empresas or gerar_por_empresa) and len(e_company_ids) > 1:
            for c in e_company_ids:
                saldo_company.update({c: obj_estoque_produto_saldo.get_saldo_do_dia(
                    cr, uid, list_grade_id, data_hoje, local_id, c, context=context)})
        else:
            saldo_company = {company_id: obj_estoque_produto_saldo.get_saldo_do_dia(
                cr, uid, list_grade_id, data_hoje, local_id, context=context)}

        # CURVA ABC
        dict_curva = obj_estoque_produto_grade.estpgr_calcula_curvaabc(cr, uid, tipo_curva, dados)

        if tipo_curva in ('A', 'B', 'C'):  # Filtra os produtos da Curva ABC selecionada
            dados = filter(lambda i: i.get('produto_id') in dict_curva.keys(), dados)

        # Ajusta media caso campo 'esgccp_ajusta_media' esteja marcado
        dados_ajusta_media = self._esgccp_get_dados_ajusta_media(
            cr, uid, sugestao_id, data_inicial, data_final, list_grade_id, considera_todas_empresas,
            company_id, local_id, separar_company, context) \
            if brw_estsug_compra_capa.esgccp_ajusta_media else {}

        data_inicial_item_estatistica = str(parse(data_final) - relativedelta(months=11))[:8] + '01'

        for item in dados:
            if not item:
                continue
            if item.get('produto_id'):
                produto_id = item.get('produto_id')
                grade_id = item.get('grade_id')
                sigla_grade = item.get('sigla_grade')
                sigla_unidade = item.get('sigla_uni')
                quantidade_embalagem = item.get('qtd_emb')

                # Valor custo
                dict_custo = custos.get(produto_id) or {}
                valor_custo = dict_custo.get('estprc_%s' % custo) or 0.0

                # Valor preco venda
                dados_preco_venda = precos_venda.get(produto_id) or {}
                valor_preco_venda = dados_preco_venda.get(grade_id) or dados_preco_venda.get(
                    'preco_venda')

                # Data da ultima entrada
                dados_ultima_entrada = sorted(
                    obj_estoque_movimento_itens.estmvi_get_data_ultima_entrada(
                        cr, local_id, produto_id, grade_id, item.get('company_id') or company_id),
                    key=lambda ut: ut.get('ult_entrada'), reverse=True)
                ult_entrada = dados_ultima_entrada[0].get('ult_entrada')

                # Quantidade de entrada
                quantidade = ult_entrada and obj_estoque_movimento_itens.\
                    estmvi_get_quantidade_entrada(cr, ult_entrada, ult_entrada, local_id,
                                                  item.get('company_id') or company_id, produto_id,
                                                  grade_id) or [{}]
                quantidade = quantidade[0].get('quantidade') or 0.0

                # Saidas

                qtd_total_saida = item.get('saidas') or 0.0

                # Calcular media
                if grade_id in dados_ajusta_media:
                    prazo = dados_ajusta_media.get(grade_id)
                else:
                    prazo = prazo_media * 30
                    if dias_mes_atual:
                        prazo += dias_mes_atual

                media = 0
                if prazo:
                    media = qtd_total_saida / (prazo)

                # Valor saldo
                if gerar_por_empresa:
                    saldo = saldo_company.get(item.get('company_id')).get(grade_id) \
                            and saldo_company.get(item.get('company_id')).get(grade_id).get(
                        'disponivel') or 0.0
                else:
                    saldo = sum(map(lambda c: saldo_company.get(c).get(grade_id)
                                    and saldo_company.get(c).get(grade_id).get('disponivel') or 0.0,
                                    saldo_company.keys()))
                pedidos = item.get('pedidos') or 0
                pedido_dias = item.get('pedido_dias') or 0

                if considera_pedidos:
                    _saldo_mais_pedidos = saldo + pedidos
                else:
                    _saldo_mais_pedidos = saldo
                # Dias calculo
                # if qtd_total_saida > 0 and _saldo_mais_pedidos > 0:
                #     dias = _saldo_mais_pedidos / prazo
                # else:
                #     dias = 0

                if qtd_total_saida > 0 and saldo > 0 and media > 0:
                    dias = saldo / media
                else:
                    dias = 0
                # Sugestao
                sugestao = 0
                if prazo:
                    sugestao = (qtd_total_saida / prazo) * prazo_sugestao - _saldo_mais_pedidos
                # if considera_pedidos:
                #     if sugestao >= pedidos:
                #         sugestao -= pedidos
                #     else:
                #         sugestao = 0

                if not sugestao > 0:
                    if so_sugestao:
                        continue

                sugestao = math.ceil(sugestao)
                # Codigo no fabricante
                codigo_fabricante = item.get('codigo_fabricante')
                item_nome = item.get('item_nome')

                item_codigo = ''
                if codigo_imprimir == 'F':
                    item_codigo = codigo_fabricante
                elif codigo_imprimir == 'I':
                    context = {'estpro_codigo_e_digito': True}
                    produto_name = obj_estoque_produto.name_get(cr, uid, [produto_id], context)
                    item_codigo = produto_name[0][1]

                vals = {
                    'esgcit_capa_id': sugestao_id,
                    'esgcit_empresa': item.get('company_id') or company_id,
                    'esgcit_classificacao': dict_curva.get(produto_id),
                    'esgcit_produto_id': produto_id,
                    'esgcit_sigla_grade': sigla_grade,
                    'esgcit_grade_id': grade_id,
                    'esgcit_ult_entrada': ult_entrada,
                    'esgcit_qtd_entrada': quantidade,
                    'esgcit_sigla_uni': sigla_unidade,
                    'esgcit_qtd_emb': quantidade_embalagem,
                    'esgcit_saidas': qtd_total_saida,
                    'esgcit_media': media,
                    'esgcit_custo': valor_custo,
                    'esgcit_preco_venda': valor_preco_venda,
                    'esgcit_saldo': saldo,
                    'esgcit_pedidos': pedidos,
                    'esgcit_pedido_dias': pedido_dias,
                    'esgcit_dias': dias,
                    'esgcit_sugestao': sugestao,
                    'esgcit_minimo': 0,
                    'esgcit_maximo': 0,
                    'esgcit_codigo_fabricante': codigo_fabricante,
                    'esgcit_item_codigo': item_codigo,
                    'esgcit_item_descricao': item_nome,
                    'esgcit_prazo_media': dados_ajusta_media.get(grade_id) or 0,
                    'esgcit_item_estatistica_ids': self._esgccp_get_dado_item_estatistica(
                        cr, uid, sugestao_id, item.get('company_id') or company_id, local_id, produto_id,
                        grade_id, data_inicial_item_estatistica, data_final) if
                    listar_estatistica else []
                }

                res.append((0, 0, vals))

        return res

    def esgccp_get_query_cfop(self, cr, uid, sugestao_id, context=None):
        """
        O metodo inclui tratamento pelo CFOP. Sobreescrito no modulo fiscal.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param sugestao_id: id da tabela desse objeto.
        :type sugestao_id: int
        :param context: dados contextuais.
        :type context: dict
        :return: dados SQL.
        :rtype: str
        """
        context = context and context.copy() or {}
        return ''

    def esgccp_get_origem_codigo(self, cr, uid, sugestao_id, context=None):
        """
        O metodo define a origem da operacao do estoque. Sobreescrito no modulo estoquealmoxarifado.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param sugestao_id: id da tabela desse objeto.
        :type sugestao_id: int
        :param context: dados contextuais.
        :type context: dict
        :return: dados da identicacao das origens.
        :rtype: list
        """
        context = context and context.copy() or {}
        return ['N', 'C']

    def _esgccp_get_itens_sem_movimento(self, cr, uid, dados, all_produto_ids, gerar_por_empresa,
                                        company_id, comprador_id, context=None):
        """
        O metodo encontra os dados, para sugestao, dos itens que nao foram movimentados (vendidos).
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param dados: lista com os dados dos itens que foram movimentados (vendidos).
        :type dados: list
        :param all_produto_ids: lista com o id dos produtos que satisfazem aos filtros selecionados.
        :type all_produto_ids: list
        :param gerar_por_empresa: dado que informa se os itens serao sugeridos ou nao, por empresa.
        :type gerar_por_empresa: bool
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: lista com os dados dos itens que foram movimentados (vendidos) mais os que nao
        foram.
        :rtype: list
        """
        context = context and context.copy() or {}
        sql = """
            SELECT
            epg.produto_id                   AS produto_id
            , epg.id                         AS grade_id
            , 0                              AS vr_total_item
            , epg.grade                      AS sigla_grade
            , epg.codigo_no_fabricante       AS codigo_fabricante
            , epg.minimo                     AS minimo
            , epg.maximo                     AS maximo
            , (select estpre_unidade_produto from estoque_produto_embalagem where id in (
                 select min(estllc_produto_embalagem_id)
                 from estoque_local_locacao
                 where produto_id = epg.produto_id and grade_id = epg.id)
             )     AS sigla_uni
            , (select min(quantidade_na_embalagem) from estoque_embalagem where id in (
                 select embalagem_id from estoque_produto_embalagem where produto_id = epg.produto_id)
             )     AS qtd_emb
            , epg.name                       AS item_nome
        """
        if gerar_por_empresa:
            sql += """
            , ep.company_id                  AS company_id
            """
        sql += """
            , 0                              AS saidas
            from estoque_produto_grade       AS epg
            inner join estoque_produto       AS ep   ON ep.id   = epg.produto_id
            where epg.active = True {produto_ids} """
        if comprador_id:
            sql += ' and comprador_id = %s ' % comprador_id
        sql +=  """
            GROUP  BY epg.produto_id, epg.id, epg.name, epg.grade, epg.codigo_no_fabricante,
                epg.minimo, epg.maximo, sigla_uni,
                qtd_emb
        """
        str_produto_ids = ''
        if all_produto_ids:
            str_produto_ids = 'and  epg.produto_id IN %s' % all_produto_ids
            str_produto_ids = 'and  epg.produto_id IN %s' % all_produto_ids
        sql = sql.format(produto_ids=str_produto_ids)
        if gerar_por_empresa:
            sql += """
                , ep.company_id
            """
        cr.execute(sql)
        new_dados = cr.dictfetchall()
        correlacao_company_ids = [company_id]
        if gerar_por_empresa:
            ir_model_ids = self.pool.get('ir.model').search(
                cr, uid, [('model', '=', 'estoque.produto')], context=context)
            obj_adm_empresa_objeto = self.pool.get('adm.empresa.objeto')
            adm_empresa_objeto_ids = obj_adm_empresa_objeto.search(
                cr, uid, [('ir_model_id', 'in', ir_model_ids)])
            brw_adm_empresa_objeto = obj_adm_empresa_objeto.browse(cr, uid, adm_empresa_objeto_ids,
                                                                   context)
            correlacao_company_ids = map(lambda i: i.empresa_escolhida_id.id,
                                         brw_adm_empresa_objeto)
            correlacao_company_ids.extend(map(lambda i: i.empresa_a_usar_id.id,
                                              brw_adm_empresa_objeto))
            correlacao_company_ids = list(set(correlacao_company_ids))
            correlacao_company_ids = map(lambda c: c.id, filter(
                lambda rc: not rc.rescon_fiscal, self.pool.get('res.company').browse(
                    cr, uid, correlacao_company_ids, context)))
        new_itens_dados = list()
        new_dados = sorted(new_dados, key=lambda i: i.get('produto_id'))
        for company in correlacao_company_ids:
            for item in new_dados:
                if gerar_por_empresa:
                    if filter(lambda i: i.get('produto_id') == item.get('produto_id') and
                              i.get('grade_id') == item.get('grade_id') and
                              i.get('company_id') == company, dados):
                        continue
                else:
                    if filter(lambda i: i.get('produto_id') == item.get('produto_id') and
                              i.get('grade_id') == item.get('grade_id'), dados):
                        continue
                dict_dado = item.copy()
                dict_dado['company_id'] = company

                sql = """
                    SELECT
                        sum(epi.qtde_pedida)                   AS pedidos,
                        CURRENT_DATE - max(epc.data_emissao)   AS pedido_dias
                    FROM
                        estoquepedidos_pedido_item epi
                    INNER JOIN
                        estoquepedidos_pedido_capa epc ON epc.id = epi.pedido_id
                    WHERE
                        epi.grade_id = %s AND epc.tipo = 'C' AND epc.state = 'V'
                        AND epc.company_id = %s
                """ % (item.get('grade_id'), company)
                cr.execute(sql)
                pedido_dados = cr.dictfetchone()
                dict_dado['pedidos'] = pedido_dados.get('pedidos') or 0
                dict_dado['pedido_dias'] = pedido_dados.get('pedido_dias') or 0

                new_itens_dados.append(dict_dado)
        dados.extend(new_itens_dados)
        return dados

    def _esgccp_get_dado_item_estatistica(self, cr, uid, sugestao_id, company, local, produto,
                                          grade, data_inicial, data_final, context=None):
        """
        O metodo realiza a busca mensal da quantidade vendida dos produtos - num periodo total de
        um ano, contados da data atual, ou do ultimo mes, para tras - de acordo com os
        parametros passados. A busca eh feita basicamente pela tabela de movimento de itens.

        :param cr: cursor no banco de dados
        :param uid: id da tabela res_users, identificador do usuario
        :param sugestao_id: id da tabela desse objeto
        :type sugestao_id: int
        :param local: id da tabela estoque_local, representa o local da onde o produto foi
        movimentado
        :param company: id da tabela res_company, identificador da empresa que movimentou o
        produto
        :param data_inicial: data incial do periodo de estatistica do item.
        :param data_final: data final do periodo da sugestao.
        :param produto: lista de id dos produtos
        :param grade: lista de id das grades
        :return: Lista com os dados que serao incluidos na tree de itens, tabela estsug_compra_item
        """
        # ___________________________ Objects ________________________________
        obj_adm_util = self.pool.get('adm.utils')
        obj_compra_item_estatistica_diaria = self.pool.get('estsug.compra.item.estatistica.diaria')

        if not isinstance(produto, list):
            produto = [produto]
        if not isinstance(grade, list):
            grade = [grade]
        if len(produto) == 1:
            produto = str(tuple(produto)).replace(',', '')
        else:
            produto = str(tuple(produto))
        if len(grade) == 1:
            grade = str(tuple(grade)).replace(',', '')
        else:
            grade = str(tuple(grade))

        context = context and context.copy() or {}
        madeireira_instalado = obj_adm_util.admutl_check_modulo_instalado(
            cr, uid, 'madeireira', context)
        ecf_instalado = obj_adm_util.admutl_check_modulo_instalado(
            cr, uid, 'ecf', context)

        sql = """
            SELECT emi.local_id
                 , emi.produto_id
                 , emi.grade_id
                 , DATE_PART('month', emc.data) AS mes_movimento
                 , SUM(
        """

        if madeireira_instalado:
            if ecf_instalado:
                sql += """
                   CASE WHEN eno.estnto_tipo_operacao = 'S' and emi.estmvi_volume > 0 THEN
                       CASE WHEN ecc.tipo_cupom = 'C' THEN
                           -emi.estmvi_volume
                       ELSE
                           emi.estmvi_volume
                       END
                   ELSE
                       CASE WHEN ecc.tipo_cupom = 'C' THEN
                           -emi.quantidade
                       ELSE
                           emi.quantidade
                       END
                """
            else:
                sql += """
                   CASE WHEN eno.estnto_tipo_operacao = 'S' and emi.estmvi_volume > 0 THEN
                       emi.estmvi_volume
                   ELSE
                       emi.quantidade
                """
        else:
            if ecf_instalado:
                sql += """
                   CASE WHEN eno.estnto_tipo_operacao = 'S' THEN
                       CASE WHEN ecc.tipo_cupom = 'C' THEN
                           -emi.quantidade
                       ELSE
                           emi.quantidade
                       END
                   ELSE
                       0
                """
            else:
                sql += """
                   CASE WHEN eno.estnto_tipo_operacao = 'S' THEN
                       emi.quantidade
                   ELSE
                       0
                """

        sql += """
                   END)                           AS quantidade
            from estoque_produto_grade as epg
            inner join  estoque_movimento_itens        AS emi on emi.grade_id = epg.id
            INNER  JOIN estoque_movimento_capa    AS emc ON emc.id = emi.capa_id
            INNER  JOIN estoque_natureza_operacao AS eno ON emc.estmvc_operacao_id = eno.id
            """

        if ecf_instalado:
            sql += """
            LEFT   JOIN ecf_cupons_capa           AS ecc ON ecc.id = emi.cupom_id
            """
        condicao = ''' '''
        if local:
            condicao = """AND  emi.local_id = %s """ % local
        sql += """
            WHERE 
              emc.data BETWEEN '%s' AND '%s'
              AND emc.estmvc_operacao_id IN (
                   SELECT id
                   FROM   estoque_natureza_operacao
                   WHERE  estnto_tipo_operacao = 'S'
                     AND  estnto_atualizar_saldo = True
                     AND  active = True
                     AND estnto_movimento_origem_id
                        IN (SELECT id FROM estoque_movimento_origem
                        WHERE estmog_codigo IN (%s) )
                   )
              %s
              AND  emc.company_id = %s
              %s
              AND emi.produto_id IN %s
              AND emi.grade_id IN %s
        """ % (data_inicial, data_final,
               "'" + "','".join(self.esgccp_get_origem_codigo(cr, uid, sugestao_id, context)) + "'",
               condicao, company, self.esgccp_get_query_cfop(cr, uid, sugestao_id, context),
               produto, grade)

        if ecf_instalado:
            sql += """
              AND not (emi.item_cancelado is True AND ecc.tipo_cupom = 'V')
            """

        sql += """
            GROUP  BY emi.local_id, emi.produto_id, emi.grade_id, epg.name, mes_movimento
        """

        cr.execute(sql)
        dados = cr.dictfetchall() or []
        mes = [0] * 12  # Os doze meses

        for dado in dados:
            mes[int(dado.get('mes_movimento')) - 1] += dado.get('quantidade') or 0.0

        vals = dict(esgcie_janeiro=mes[0], esgcie_fevereiro=mes[1], esgcie_marco=mes[2],
                    esgcie_abril=mes[3], esgcie_maio=mes[4], esgcie_junho=mes[5],
                    esgcie_julho=mes[6], esgcie_agosto=mes[7], esgcie_setembro=mes[8],
                    esgcie_outubro=mes[9], esgcie_novembro=mes[10], esgcie_dezembro=mes[11])

        sql = sql.replace(", DATE_PART('month', emc.data) AS mes_movimento",
                          ", DATE_PART('month', emc.data) AS mes_movimento"
                          ", DATE_PART('day', emc.data) AS dia_movimento"
                          ", DATE_PART('year', emc.data) AS ano_movimento")
        sql = sql.replace("GROUP  BY emi.local_id, emi.produto_id, emi.grade_id, epg.name, "
                          "mes_movimento", "GROUP  BY emi.local_id, emi.produto_id, emi.grade_id, "
                                           "epg.name, mes_movimento, dia_movimento, ano_movimento "
                                           "ORDER BY mes_movimento, dia_movimento, ano_movimento")
        cr.execute(sql)
        dados_diario = cr.dictfetchall()

        estatistica_diaria_item_ids = list()
        list_mes_movimento = list(set(map(lambda i: i.get('mes_movimento'), dados_diario)))
        for mes in list_mes_movimento:
            for dado in filter(lambda i: i.get('mes_movimento') == mes, dados_diario):
                field_dia_semana = obj_compra_item_estatistica_diaria.esgcit_get_field_dia_semana(
                    cr, uid, dado.get('ano_movimento'), mes, dado.get('dia_movimento'), context)
                data_movimento = '%s-%s-%s' % (int(dado.get('ano_movimento')),
                                               int(dado.get('mes_movimento')),
                                               int(dado.get('dia_movimento')))
                estatistica_diaria_item_ids.append((
                    0, 0, {'esgcid_dia': str(int(dado.get('dia_movimento'))),
                           field_dia_semana: dado.get('quantidade'),
                           'esgcid_mes': str(int(dado.get('mes_movimento'))),
                           'esgcid_data_movimento': data_movimento}))
        if estatistica_diaria_item_ids:
            vals['esgcie_estatistica_diaria_item_ids'] = estatistica_diaria_item_ids
        return [(0, 0, vals)]

    def _esgccp_get_list_produto(self, cr, uid, ids, fornecedor_id, comprador_id, representante_id,
                                 categoria_ids, fabricante_id, context=None):
        """
        O metodo realiza a busca dos ids dos produtos que estao relacionados a cada um dos
        parametros.
        :param cr: cursor no banco de dados
        :param uid: id da tabela res_users, identificador do usuario
        :param fornecedor_id: id da tabela financeiro_fornecedor, identificador do fornecedor do
        produto
        :param comprador_id: id da tabela compras_comprador, identificador do comprador do produto
        :param representante_id: id da tabela financeiro_representante, identificador do
        representante do fornecedor
        :param categoria_ids: id da tabela estoque_categoria, identificador da categoria do produto
        :param fabricante_id: id da tabela adm_pessoa, identificador da pessoa que e um fabricante
        :param context: dicionario com valores contextuais
        :return: caso encontre produtos com os parametros, retorna string de tupla de ids dos
        produtos. Senao, retorna string vazia
        """
        context = context and context.copy() or {}
        produto_ids = []
        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'compras',
                                                                 context=context)  and comprador_id:
            compras_comprador_dados = self.pool.get('compras.comprador').read(cr, uid, comprador_id,
                                                 ['estoque_produto_ids'], context=context,load=LOAD)
            produto_ids.extend(compras_comprador_dados.get('estoque_produto_ids'))

        args_fornecedor = []
        fornecedor_id and args_fornecedor.append(('fornecedor_id', '=', fornecedor_id))
        representante_id and args_fornecedor.append(('representante_id', '=', representante_id))
        if args_fornecedor:
            obj_estoque_fornecedor = self.pool.get('estoque.fornecedor')
            estoque_fornecedor_ids = obj_estoque_fornecedor.search(cr, uid, args_fornecedor,
                                                                   context=context)
            estoque_fornecedor_dados = obj_estoque_fornecedor.read(cr, uid, estoque_fornecedor_ids,
                                                         ['produto_id'], context=context, load=LOAD)
            produto_ids.extend(map(lambda i: i.get('produto_id'), estoque_fornecedor_dados))

        args_produto = []
        produto_ids and args_produto.append(('id', 'in', produto_ids))
        categoria_ids and  args_produto.append(('categoria_id', 'in',categoria_ids))
        fabricante_id and args_produto.append(('fabricante_id', '=', fabricante_id))
        context['super_estoque_produto_search'] = True
        # caso tenha apenas os produtos como argumento, nao faz o seach
        res = list()
        if produto_ids and len(args_produto) == 1:
            res = produto_ids
        elif args_produto:
            res = self.pool.get('estoque.produto').search(cr, uid, args_produto, context=context)

        res = list(set(res))
        if len(res) == 1:
            res = str(tuple(res)).replace(',', '')
        elif len(res) > 1:
            res = str(tuple(res))
        else:
            res = ''
        return res

    def esgccp_button_print(self, cr, uid, ids, context=None):
        """
        O metodo realiza a chamada para processamento de um relatorio, de acordo com dados passados
        :param cr: cursor no banco de dados
        :param uid: id da tabela res_users, identificador do usuario
        :param ids: lista de id dessa tabela
        :param context: dicionario com valores contextuais
        :return: dicionario com acao para processamento da classe do relatorio
        """
        context = context and context.copy() or {}

        estrutura, dados = self.get_dados_rel(cr, uid, ids, context)
        context['estrutura'] = estrutura
        context['dados'] = dados
        return self.pool.get('wizard.relatorios.impressao').get_tela_relatorios(cr, uid, context)

    def get_dados_rel(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_estsug_compra_item = self.pool.get('estsug.compra.item')
        obj_estsug_compra_item_estatistica = self.pool.get('estsug.compra.item.estatistica')
        pagina = {
            'relpag_nome_rel': _('Sugestao de Compra'),
            'relpag_tam_linha': 195,
            'relpag_fonte_tamanho': 6.8,
            'relpag_margem_esquerda': 0.5,
            'relpag_margem_direita': 0.5,
            'relpag_margem_superior': 0.5,
            'relpag_margem_inferior': 0.5,
            'relpag_cabecalhos': [
                {'relcab_name': 'cab1',
                 'relcab_colunas': [{'relcol_name': 'contr_estoque',
                                     'relcol_dados_tam': 65,
                                     'relcol_dados_alinhamento': 'D'},
                                    {'relcol_name': 'titulo',
                                     'relcol_nao_separa_coluna': True,
                                     'relcol_dados_tam': 65,
                                     'relcol_dados_alinhamento': 'C'},
                                    {'relcol_name': 'vazio1',
                                     'relcol_nao_separa_coluna': True,
                                     'relcol_dados_tam': 65,
                                     'relcol_dados_alinhamento': 'D'}]},
                {'relcab_name': 'cab2',
                 'relcab_colunas': [{'relcol_name': 'data',
                                     'relcol_dados_tam': 65,
                                     'relcol_dados_alinhamento': 'D'},
                                    {'relcol_name': 'empresa',
                                     'relcol_dados_tam': 65,
                                     'relcol_dados_alinhamento': 'C',
                                     'relcol_nao_separa_coluna': True},
                                    {'relcol_name': 'pagina',
                                     'relcol_dados_tam': 65,
                                     'relcol_dados_alinhamento': 'E',
                                     'relcol_nao_separa_coluna': True}]
                 },
                {'relcab_name': 'cab3',
                 'relcab_colunas': [{'relcol_name': 'local',
                                     'relcol_dados_tam': 65,
                                     'relcol_dados_alinhamento': 'D'},
                                    {'relcol_name': 'descricao',
                                     'relcol_nao_separa_coluna': True,
                                     'relcol_dados_tam': 65,
                                     'relcol_dados_alinhamento': 'C'},
                                    {'relcol_name': 'vazio1',
                                     'relcol_nao_separa_coluna': True,
                                     'relcol_dados_tam': 65,
                                     'relcol_dados_alinhamento': 'D'}]},
                {'relcab_name': 'cab4',
                 'relcab_divide_linha': True,
                 'relcab_colunas': [{'relcol_name': 'filtro',
                                     'relcol_dados_tam': 195,
                                     'relcol_dados_alinhamento': 'D'}]},
                {'relcab_name': 'cabcol1',
                 'relcab_separa_coluna': '|',
                 'relcab_cor': 'Blue',
                 'relcab_colunas': [
                     {'relcol_name': 'col1',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_dados_tam': 4},
                     {'relcol_name': 'col2',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 12},
                     {'relcol_name': 'col3',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 3},
                     {'relcol_name': 'col4',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 41},
                     {'relcol_name': 'col5',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 11},
                     {'relcol_name': 'col6',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'col7',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 4},
                     {'relcol_name': 'col8',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 4},
                     {'relcol_name': 'col9',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 7},
                     {'relcol_name': 'col10',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'col11',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 8},
                     {'relcol_name': 'col12',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 16},
                     {'relcol_name': 'col13',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 9},
                     {'relcol_name': 'col14',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 9},
                     {'relcol_name': 'col15',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 1},
                     {'relcol_name': 'col16',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'col17',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 7},
                     {'relcol_name': 'col18',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10}
                 ]
                 },
                {'relcab_name': 'cabcol2',
                 'relcab_separa_coluna': '|',
                 'relcab_cor': 'Blue',
                 'relcab_colunas': [
                     {'relcol_name': 'col1',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_dados_tam': 4},
                     {'relcol_name': 'col2',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 12},
                     {'relcol_name': 'col3',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 3},
                     {'relcol_name': 'col4',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 41},
                     {'relcol_name': 'col5',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 11},
                     {'relcol_name': 'col6',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'col7',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 4},
                     {'relcol_name': 'col8',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 4},
                     {'relcol_name': 'col9',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 7},
                     {'relcol_name': 'col10',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'col11',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 8},
                     {'relcol_name': 'col12',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 16},
                     {'relcol_name': 'col13',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 9},
                     {'relcol_name': 'col14',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 6},
                     {'relcol_name': 'col15',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 4},
                     {'relcol_name': 'col16',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'col17',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 7},
                     {'relcol_name': 'col18',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10}
                 ]
                 },
                {'relcab_name': 'cabcol3',
                 'relcab_divide_linha': True,
                 'relcab_separa_coluna': '|',
                 'relcab_cor': 'Blue',
                 'relcab_colunas': [
                     {'relcol_name': 'col1',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'col2',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'col3',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'col4',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'col5',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'col6',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'col7',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'col8',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'col9',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'col10',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'col11',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'col12',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'col13',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 12},
                     {'relcol_name': 'col14',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 12},
                     {'relcol_name': 'col15',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 12},
                     {'relcol_name': 'col16',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 12},
                     {'relcol_name': 'col17',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 9}
                 ]
                 }
            ],
            'relpag_linhas': [
                {'rellin_name': 'linha1',
                 'rellin_separa_coluna': '|',
                 'rellin_colunas': [
                     {'relcol_name': 'curva',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_dados_tam': 4},
                     {'relcol_name': 'cod_item',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 12},
                     {'relcol_name': 'grade',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 3},
                     {'relcol_name': 'descricao',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 41},
                     {'relcol_name': 'entrada_data',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 11},
                     {'relcol_name': 'entrada_quantidade',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'unidade',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 4},
                     {'relcol_name': 'cst_tipo',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 4},
                     {'relcol_name': 'embalagem',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 7},
                     {'relcol_name': 'saida',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'media',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 8},
                     {'relcol_name': 'custo',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 16},
                     {'relcol_name': 'preco_venda',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 9},
                     {'relcol_name': 'pedido_quantidade',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 6},
                     {'relcol_name': 'pedido_dias',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 4},
                     {'relcol_name': 'saldo',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'dias',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 7},
                     {'relcol_name': 'sugestao',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10}
                 ]
                 },
                {'rellin_name': 'linha2',
                 'rellin_separa_coluna': '|',
                 'rellin_colunas': [
                     {'relcol_name': 'janeiro',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'fevereiro',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'marco',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'abril',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'maio',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'junho',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'julho',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'agosto',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'setembro',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'outubro',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'novembro',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'dezembro',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'col13',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 12},
                     {'relcol_name': 'col14',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 12},
                     {'relcol_name': 'col15',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 12},
                     {'relcol_name': 'col16',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 12},
                     {'relcol_name': 'col17',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_nao_separa_coluna': True,
                      'relcol_dados_tam': 9}
                 ]
                 },
                {'rellin_name': 'linha_total',
                 'rellin_separa_coluna': ' ',
                 'rellin_colunas': [
                     {'relcol_name': 'curva',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_dados_tam': 4},
                     {'relcol_name': 'cod_item',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_dados_tam': 12},
                     {'relcol_name': 'grade',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_dados_tam': 3},
                     {'relcol_name': 'descricao',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_dados_tam': 47},
                     {'relcol_name': 'entrada_data',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_dados_tam': 15},
                     {'relcol_name': 'entrada_quantidade',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'unidade',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_dados_tam': 4},
                     {'relcol_name': 'cst_tipo',
                      'relcol_dados_alinhamento': 'D',
                      'relcol_dados_tam': 4},
                     {'relcol_name': 'embalagem',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_dados_tam': 7},
                     {'relcol_name': 'saida',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'media',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_dados_tam': 8},
                     {'relcol_name': 'custo',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_dados_tam': 16},
                     {'relcol_name': 'preco_venda',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_dados_tam': 9},
                     {'relcol_name': 'pedido_quantidade',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_dados_tam': 6},
                     {'relcol_name': 'pedido_dias',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_dados_tam': 4},
                     {'relcol_name': 'saldo',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_dados_tam': 10},
                     {'relcol_name': 'dias',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_dados_tam': 7},
                     {'relcol_name': 'sugestao',
                      'relcol_dados_alinhamento': 'E',
                      'relcol_dados_tam': 16}
                 ]
                 }
            ]
        }

        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'estsug.compra.capa',
                                                                    context=context)
        res_company_dados = self.pool.get('res.company').read(cr, uid, company_id, ['name'],
                                                              context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        sugestao_compra_capa_dados = self.read(cr, uid, ids[0] if isinstance(ids, list) else ids,
                                               [], context=context)
        if isinstance(sugestao_compra_capa_dados, list):
            sugestao_compra_capa_dados = sugestao_compra_capa_dados[0]
        local = sugestao_compra_capa_dados.get('esgccp_local_id') or ''
        if local and isinstance(local, tuple):
            local = local[1]
        descricao = sugestao_compra_capa_dados.get('name') or ''
        item_ids = sugestao_compra_capa_dados.get('esgccp_item_ids')
        listar_estatistica = sugestao_compra_capa_dados.get('esgccp_lista_estatistica')
        tipo_sugestao = sugestao_compra_capa_dados.get('esgccp_sugestao')
        if tipo_sugestao == 'M':
            sugestao = 'minimo/maximo'
            desc1 = 'MINIMO'
            desc2 = 'MAXIMO'
        else:
            sugestao = 'estatisticas'
            desc1 = 'SAIDAS'
            desc2 = 'MEDIA'
        prazo_sugestao = sugestao_compra_capa_dados.get('esgccp_prazo_sugestao')
        prazo_media = sugestao_compra_capa_dados.get('esgccp_prazo_media')
        filtro = 'Sugestao por %s.     Estoque para %s dias.      Media de vendas de %s meses' % \
                 (sugestao, prazo_sugestao, prazo_media)
        custo = sugestao_compra_capa_dados.get('esgccp_custo')
        desc_custo = ''
        if custo == 'C':
            desc_custo = 'CUSTO CORRIGIDO'
        elif custo == 'M':
            desc_custo = 'CUSTO MED. CTB.'
        elif custo == 'R':
            desc_custo = 'CUSTO DE REPOS.'
        elif custo == 'U':
            desc_custo = '   ULTIMO CUSTO'
        if not desc_custo:
            desc_custo = '               '

        dados = {'cab1': {'contr_estoque': 'Contr. Estoque',
                          'titulo': 'Sugestao de Compra',
                          'vazio1': ''},
                 'cab2': {'data': data,
                          'empresa': nome_empresa,
                          'pagina': '|pag|'},
                 'cab3': {'local': 'Local: ' + local,
                          'descricao': descricao,
                          'vazio1': ''},
                 'cab4': {'filtro': filtro},
                 'cabcol1': {'col1': 'ABC',
                             'col2': 'ITEM',
                             'col3': 'GR',
                             'col4': 'DESCRICAO',
                             'col5': '*ENTRADAS*',
                             'col6': '',
                             'col7': 'UNI',
                             'col8': '', # coluna ICMS inserida via heranca
                             'col9': 'EMB',
                             'col10': desc1,
                             'col11': desc2,
                             'col12': desc_custo,
                             'col13': 'P.VENDA',
                             'col14': '*PEDIDOS*',
                             'col15': '',
                             'col16': 'SALDO',
                             'col17': 'DIAS',
                             'col18': 'SUGESTAO'},
                 'cabcol2': {'col1': '',
                             'col2': '',
                             'col3': '',
                             'col4': '',
                             'col5': 'DATA',
                             'col6': 'QUANTID.',
                             'col7': '',
                             'col8': '',
                             'col9': '',
                             'col10': '',
                             'col11': '',
                             'col12': '',
                             'col13': '',
                             'col14': 'QTD.',
                             'col15': 'DIAS',
                             'col16': '',
                             'col17': '',
                             'col18': ''}
                 }
        if listar_estatistica:
            dados.update({
                 'cabcol3': {'col1': 'JANEIRO',
                             'col2': 'FEVEREIRO',
                             'col3': 'MARCO',
                             'col4': 'ABRIL',
                             'col5': 'MAIO',
                             'col6': 'JUNHO',
                             'col7': 'JULHO',
                             'col8': 'AGOSTO',
                             'col9': 'SETEMBRO',
                             'col10': 'OUTUBRO',
                             'col11': 'NOVEMBRO',
                             'col12': 'DEZEMBRO',
                             'col13': '',
                             'col14': '',
                             'col15': '',
                             'col16': '',
                             'col17': '',
                             'col18': ''}
                 })

        linhas = []
        codigo_imprimir = sugestao_compra_capa_dados.get('esgccp_codigo_imprimir') or 'I'
        ordem_listar = sugestao_compra_capa_dados.get('esgccp_ordem')
        context['estpro_codigo_e_digito'] = True
        sugestao_compra_item_dados = obj_estsug_compra_item.read(cr, uid, item_ids, [],
                                                                 context=context)
        if ordem_listar:
            if ordem_listar == 'O':
                sugestao_compra_item_dados = sorted(sugestao_compra_item_dados,
                                                    key=lambda i: i.get('esgcit_item_codigo'))
            elif ordem_listar == 'D':
                sugestao_compra_item_dados = sorted(sugestao_compra_item_dados,
                                                    key=lambda i: i.get('esgcit_item_descricao'))
            elif ordem_listar == 'U':
                sugestao_compra_item_dados = sorted(sugestao_compra_item_dados,
                                                    key=lambda i: i.get('esgcit_classificacao'))

        total_geral = 0
        for x in sugestao_compra_item_dados:
            ultima_entrada = x.get('esgcit_ult_entrada') or ''
            if ultima_entrada:
                ultima_entrada = time.strftime('%d/%m/%Y', time.strptime(ultima_entrada,
                                                                         '%Y-%m-%d'))
            preco_venda = x.get('esgcit_preco_venda') or 0
            preco_custo = x.get('esgcit_custo') or 0
            valor_sugestao = x.get('esgcit_sugestao') or 0
            total = preco_custo * valor_sugestao
            total_geral += total
            if codigo_imprimir == 'F':
                codigo_item = x.get('esgcit_codigo_fabricante') or ''
            else:
                codigo_item = x.get('esgcit_produto_id')[1] or ''
            if tipo_sugestao == 'E':
                saida_ou_minimo = x.get('esgcit_saidas') or 0
                media_ou_maximo = x.get('esgcit_media') or 0
            else:
                saida_ou_minimo = x.get('esgcit_minimo') or 0
                media_ou_maximo = x.get('esgcit_maximo') or 0

            linhas.append({'linha1': {
                'curva': x.get('esgcit_classificacao') or '',
                'cod_item': codigo_item,
                'grade': x.get('esgcit_sigla_grade') or '',
                'descricao': x.get('esgcit_item_descricao'),
                'entrada_data': ultima_entrada,
                'entrada_quantidade': getNumeroEditado(x.get('esgcit_qtd_entrada') or 0, 2),
                'unidade': x.get('esgcit_sigla_uni') or '',
                'cst_tipo': x.get('esgcit_cst_tipo') or '',
                'embalagem': getNumeroEditado(x.get('esgcit_qtd_emb') or 0, 2),
                'saida': saida_ou_minimo,
                'media': media_ou_maximo,
                'custo': getNumeroEditado(x.get('esgcit_custo') or 0, 2),
                'preco_venda': getNumeroEditado(preco_venda, 2),
                'pedido_quantidade': getNumeroEditado(x.get('esgcit_pedidos') or 0, 0),
                'pedido_dias': getNumeroEditado(x.get('esgcit_pedido_dias') or 0, 0),
                'saldo': getNumeroEditado(x.get('esgcit_saldo') or 0, 2),
                'dias': x.get('esgcit_dias') or 0,
                'sugestao': getNumeroEditado(valor_sugestao, 2)}})

            if not listar_estatistica:
                continue
            item_estatistica_ids = obj_estsug_compra_item_estatistica.search(
                cr, uid, [('esgcie_item_id', '=', x.get('id'))], context=context)
            if item_estatistica_ids:
                item_estatistica_dados = obj_estsug_compra_item_estatistica.read(
                    cr, uid, item_estatistica_ids, [], context=context)
                if isinstance(item_estatistica_dados, list):
                    item_estatistica_dados = item_estatistica_dados[0]
                y = item_estatistica_dados
            else:
                y = {}

            linhas.append({'linha2': {'janeiro': getNumeroEditado(y.get('esgcie_janeiro') or 0, 0),
                                      'fevereiro': getNumeroEditado(y.get('esgcie_fevereiro') or 0,
                                                                    0),
                                      'marco': getNumeroEditado(y.get('esgcie_marco') or 0, 0),
                                      'abril': getNumeroEditado(y.get('esgcie_abril') or 0, 0),
                                      'maio': getNumeroEditado(y.get('esgcie_maio') or 0, 0),
                                      'junho': getNumeroEditado(y.get('esgcie_junho') or 0, 0),
                                      'julho': getNumeroEditado(y.get('esgcie_julho') or 0, 0),
                                      'agosto': getNumeroEditado(y.get('esgcie_agosto') or 0, 0),
                                      'setembro': getNumeroEditado(y.get('esgcie_setembro') or 0,
                                                                   0),
                                      'outubro': getNumeroEditado(y.get('esgcie_outubro') or 0, 0),
                                      'novembro': getNumeroEditado(y.get('esgcie_novembro') or 0,
                                                                   0),
                                      'dezembro': getNumeroEditado(y.get('esgcie_dezembro') or 0,
                                                                   0)
                                      }})

        linhas.append({'linha_total': {'descricao': 'TOTAL GERAL(Custo * sugestao)    ---->',
                                       'entrada_data': getNumeroEditado(total_geral, 2)}})

        dados.update({'linhas': linhas})

        return pagina, dados

    def esgccp_get_dados_produto_codigo_barras(self, cr, uid, sug_itens, context=None):
        """
        O metodo recupera o codigo de barra e os dados de produto e grade da tabela
        automacao_codigo_barra.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid:int
        :param sug_itens_ids: lista de id da tabela desse objeto.
        :type sug_itens_ids: list
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: dicionario com dados de produto, grade e codigo de barras.
        :rtype: dict
        """
        context = context and context.copy() or {}
        obj_automacao_codigo_barra = self.pool.get('automacao.codigo.barra')
        estoque_parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', ['usa_digito', 'codigo_numerico'], context=context)
        if estoque_parametro_dados.get('usa_digito') and \
                estoque_parametro_dados.get('codigo_numerico'):
            context.update({'estpro_codigo_e_digito': True})
        elif not estoque_parametro_dados.get('usa_digito') and \
                estoque_parametro_dados.get('codigo_numerico'):
            context.update({'estpro_so_codigo': True})
        elif estoque_parametro_dados.get('usa_digito') and not \
                estoque_parametro_dados.get('codigo_numerico'):
            context.update({'retorno_sem_codigo': True})
        else:
            context.update({'retorno_sem_codigo': True})
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name,
                                                                    context=context)
        dados = dict()
        load = '_classic_write'
        produto_ids = []
        grade_ids = []
        for i in sug_itens:
            produto_ids.append(i.get('esgcit_produto_id'))
            grade_ids.append(i.get('esgcit_grade_id'))

        codigo_barra_ids = obj_automacao_codigo_barra.search(
            cr, uid, [('produto_id', 'in', produto_ids), ('grade_id', 'in', grade_ids),
                      ('company_id', '=', company_id)], context=context)
        codigo_barra_dados = obj_automacao_codigo_barra.read(cr, uid, codigo_barra_ids,
                                       ['grade_id', 'codigo_barra'], context=context, load=load)
        grade_cb = {}
        map(lambda x: grade_cb.update({x.get('grade_id'): x}), codigo_barra_dados)
        for i in self.pool.get('estoque.produto.grade').read(cr, uid, grade_ids, ['name',
                                                     'produto_id'], context=context, load=load):
            chave = '%s-%s' % (i.get('produto_id'), i.get('id'))
            descricao = ''
            if grade_cb.get(i.get('id')):
                descricao = grade_cb.get(i.get('id')).get('codigo_barra') or ''

            dados[chave] = {'codigo_barra': descricao,
                            'descricao': i.get('name')}
        return dados

    def esgccp_gera_arquivo_csv(self, cr, uid, ids, context=None):
        """
        O metodo processa os dados da sugestao de compras incluindo no atributo binario
        'esgccp_arquivo_csv' os dados dos itens. Esse sera disponibilizado para download no formato
        CSV.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid:int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: Verdadeiro, caso consiga disponibilizar o arquivo para download, senao, Falso.
        :rtype: bool
        """
        context = context and context.copy() or {}
        res = False
        # Faz 'read' ao inves de 'browse' para melhorar a performance
        campos = ['esgcit_produto_id', 'esgcit_grade_id', 'esgcit_sigla_uni', 'esgcit_sugestao']
        for sugestao in self.read(cr, uid, ids, ['esgccp_item_ids'], context=context):
            arquivo = open('/tmp/sugestao_compra.csv', 'w')
            arquivo.write('codigo_barras;descricao_produto;unidade;quantidade\n')
            sug_itens = self.pool.get('estsug.compra.item').read(cr, uid,
                                                            sugestao.get('esgccp_item_ids'), campos,
                                                            context=context, load='_classic_write')

            produto_codigo_barra_dados = self.esgccp_get_dados_produto_codigo_barras(cr, uid,
                                                                                 sug_itens, context)
            for item in sug_itens:

                descricao = '%s-%s' % (item.get('esgcit_produto_id'), item.get('esgcit_grade_id'))
                codigo_descricao = produto_codigo_barra_dados.get(descricao) or {}
                linha = [codigo_descricao.get('codigo_barra') or '',
                         ';',
                         (codigo_descricao.get('descricao') or '').replace(';', ''),
                         ';',
                         item.get('esgcit_sigla_uni') or '',
                         ';',
                         str(item.get('esgcit_sugestao')),
                         '\r\n']
                linha = self.pool.get('adm.utils').admutl_remover_acentuacao(cr, uid,
                                                                             ''.join(linha))
                arquivo.write(linha)

            arquivo.close()
            arquivo = open('/tmp/sugestao_compra.csv', 'r')
            read_arquivo = arquivo.readlines()
            read_arquivo = ''.join(map(str, read_arquivo))
            arquivo.close()
            res = self.write(
                cr, uid, sugestao.get('id'),
                {'esgccp_arquivo_csv': base64.encodestring(read_arquivo.encode('utf-8', 'strict'))},
                context)
        return res

    def esgccp_get_query_empresa_nao_fiscal(self, cr, uid, company_id, considera_todas_empresas,
                                            gera_por_empresa, context=None):
        if not any([considera_todas_empresas, gera_por_empresa]):
            company_ids = [company_id]
        else:
            sql = """
                SELECT id FROM res_company WHERE rescon_fiscal IS FALSE
            """
            cr.execute(sql)
            dados = cr.dictfetchall()
            company_ids = map(lambda c: c.get('id'), dados)
        return """company_id IN ({company_ids})""".format(company_ids=', '.join(map(
            lambda s: str(s), company_ids)))
