# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estsug_compra_item_estatistica(osv.Model):
    # prefixo: esgcie_
    _inherit = 'estsug.compra.item.estatistica'

    def esgcie_get_estatistica_diaria(self, cr, uid, ids, context=None):
        """
        O metodo retorna acao para abertura de uma nova janela com os dados da estatistica diaria
        para o mes selecionado.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: acao para abertura de uma nova janela
        :rtype: dict
        """
        context = context and context.copy() or {}
        reference = self.pool.get('ir.model.data').get_object_reference(
                cr, uid, 'estoque', 'view_estsug_compra_item_estatistica_form')
        view_id = reference and reference[1] or False
        return {
            'name': 'Estatistica diaria',
            'res_id': ids[0],
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'estsug.compra.item.estatistica',
            'view_id': [view_id],
            'target': 'new',
            'type': 'ir.actions.act_window',
            'context': context
        }
