# -*- coding: utf-8 -*-

from openerp.osv import fields, osv
from datetime import date


class estsug_compra_item_estatistica_diaria(osv.Model):
    # prefixo: esgcid_
    _inherit = 'estsug.compra.item.estatistica.diaria'

    def esgcit_get_field_dia_semana(self, cr, uid, ano, mes, dia, context=None):
        """
        O metodo encontra a descricao do campo a partir do numero que representa o dia da semana.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ano: numero que representa o ano.
        :type ano: float
        :param mes: numero que representa o mes.
        :type mes: float
        :param dia: numero que representa o dia.
        :type dia: float
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: descricao do campo para o dia da semana.
        :rtype: str
        """
        context = context and context.copy() or {}
        data_movimento = date(int(ano), int(mes), int(dia))
        dia_semana = data_movimento.weekday()
        if dia_semana == 0:
            field_name = 'esgcid_segunda'
        elif dia_semana == 1:
            field_name = 'esgcid_terca'
        elif dia_semana == 2:
            field_name = 'esgcid_quarta'
        elif dia_semana == 3:
            field_name = 'esgcid_quinta'
        elif dia_semana == 4:
            field_name = 'esgcid_sexta'
        elif dia_semana == 5:
            field_name = 'esgcid_sabado'
        else:
            field_name = 'esgcid_domingo'
        return field_name

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        if context.get('esgcie_mes'):
            args.append(('esgcid_mes', '=', context.get('esgcie_mes')))
        res = super(estsug_compra_item_estatistica_diaria, self).search(
            cr, uid, args, offset, limit, order, context, count)
        return res
