# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from datetime import datetime
from openerp.tools.translate import _
from openerp import SUPERUSER_ID
import psycopg2

class estoque_inventario_capa(osv.Model):
    """
    Tabela de inventario (capa)
    """
    _inherit = 'estoque.inventario.capa'

    def name_search(self, cr, uid, name='', args=None, operator='ilike', context=None, limit=100):
        context = context and context.copy() or {}
        if name:
            args += [('descricao', operator, name)]
        ids = self.search(cr, uid, args, limit=limit)
        return self.name_get(cr, uid, ids, context)

    def button_digitar(self, cr, uid, data, context=None):
        context = context and context.copy() or {}
        inventario_id = data.get('id')
        local_id = data.get('local_id')
        if isinstance(local_id, tuple):
            local_id = local_id[0]
        id_capa = self.pool.get('digitacao.inventario.capa.osv').create(cr, uid, {'local_id': local_id,
                                                                                  'inventario_id': inventario_id},
                                                                        context)
        return {
            'res_id': id_capa,
            'name': 'Digitacao de inventario',
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'digitacao.inventario.capa.osv',
            'view_id': False,
            'target': 'inline',
            'type': 'ir.actions.act_window'}

    def onchange_flag_produto_id(self, cr, uid, ids, flag_produto_id, context=None):
        context = context and context.copy() or {}
        vals = {}
        obj_estoque_inventario_contagem = self.pool.get('estoque.inventario.contagem')
        if flag_produto_id:
            inventario_contagem_ids = obj_estoque_inventario_contagem.search(cr, uid,
                                                                             [('produto_id', '=', flag_produto_id),
                                                                              ('inventario_id', 'in', ids)],
                                                                             context=context)
            vals['inventario_contagem_ids'] = inventario_contagem_ids
        else:
            inventario_contagem_ids = obj_estoque_inventario_contagem.search(cr, uid, [
                ('inventario_id', 'in', ids)], context=context)
        vals['inventario_contagem_ids'] = inventario_contagem_ids
        return {'value': vals}

    def fields_view_get(self, cr, uid, view_id=None, view_type='form', context=None, toolbar=False,
                        submenu=False):
        context = context and context.copy() or {}
        res = super(estoque_inventario_capa, self).fields_view_get(cr, uid, view_id=view_id,
                                                                   view_type=view_type,
                                                                   context=context,
                                                                   toolbar=toolbar, submenu=False)

        if view_type == 'form' and (context.get('manutencao_inventario') or
                                    context.get('consulta_inventario')):
            # Campo criado dinamicamente somente para pesquisa
            field_atributos = {'domain': [], 'string': u'Produto :', 'views': {},
                               'required': False,
                               'relation': 'estoque.produto', 'context': {},
                               'selectable': True, 'type': 'many2one', 'select': True}

            # Criar o campo e seus atributos no item fields
            res['fields']['flag_produto_id'] = field_atributos
            if context.get('manutencao_inventario'):
                res['arch'] = '''
                <form string="Manutencao Inventario" version="7.0">
                    <group string="Manutencao Inventario" colspan="4" col="4">
                        <newline/>
                        <field name="company_id" colspan="4" readonly="1"
                            modifiers="{&quot;readonly&quot;: true, &quot;required&quot;: true}"/>
                        <field name="ano" readonly="1"
                        modifiers="{&quot;readonly&quot;: true, &quot;required&quot;: true}"/>
                        <field name="mes" readonly="1"
                        modifiers="{&quot;readonly&quot;: true, &quot;required&quot;: true}"/>
                        <field name="descricao" readonly="1"
                        modifiers="{&quot;readonly&quot;: true, &quot;required&quot;: true}"/>
                        <field name="local_id" modifiers="{&quot;readonly&quot;: true}"/>
                        <newline/>
                        <field name="total_saldo_ultimo_custo"
                        modifiers="{&quot;readonly&quot;: true}"/>
                        <field name="total_saldo_custo_medio"
                        modifiers="{&quot;readonly&quot;: true}"/>
                        <field name="atualizado" invisible="1" modifiers="{&quot;invisible&quot;: true}"/>
                         <newline/>
                        <group string="Pesquisa por produto" colspan="4" col="4">
                        <field name="flag_produto_id"
                        on_change="onchange_flag_produto_id(flag_produto_id)"
                        context="{'local_id':local_id}" />
                        </group>
                    </group>
                    <group colspan="4">
                        <div colspan="4">
                            <font color="red">
                                <strong>
                                    <center>
                                        <br>
                                            <field name="esticp_text" nolabel="1" readonly="1" attrs="{'invisible':[('atualizado','!=',True)]}"
                                            modifiers="{&quot;invisible&quot;: [[&quot;atualizado&quot;, &quot;!=&quot;, true]], &quot;readonly&quot;: true}"/>
                                        </br>
                                    </center>
                                </strong>
                             </font>
                        </div>
                    </group>
                    <group colspan="4">
                    <field name="inventario_contagem_ids" nolabel="1" colspan="6" modifiers="{}" >
                        <tree string="Digitacao Inventario" editable="top" create="0" delete="0">
                        <field name="local_id" modifiers="{&quot;readonly&quot;: true}"/>
                            <field name="produto_id" context="{'local_id':parent.local_id}"
                                modifiers="{&quot;readonly&quot;: true}" />
                            <field name="grade_id" domain="[('produto_id','=',produto_id)]"
                            modifiers="{&quot;readonly&quot;: true}"/>
                            <field name="estict_custo_medio_contabil" />
                            <field name="estict_ultimo_custo"  />
                            <field name="saldo_cadastro"
                            attrs="{'readonly':[('estict_atualizado','=',True)]}"
                            modifiers="{&quot;readonly&quot;: [[&quot;estict_item_atualizado&quot;, &quot;=&quot;, True]]}"/>
                            <field name="saldo_contado"
                            attrs="{'readonly':[('estict_atualizado','=',True)]}"
                            modifiers="{&quot;readonly&quot;: [[&quot;estict_item_atualizado&quot;, &quot;=&quot;, True]]}"/>
                          <field name="estict_item_atualizado" invisible="1" />
                        </tree>
                    </field>
                    </group>
                </form>'''
            else:
                str_arch = '''&quot;readonly&quot;: true}"/>
                    </group>'''
                str_arch1 = '''&quot;readonly&quot;: true}"/>
                    </group>
                    <group string="Pesquisa por produto" colspan="4" col="4">
                        <field name="flag_produto_id"
                            on_change="onchange_flag_produto_id(flag_produto_id)"
                            context="{'local_id': local_id}"/>
                    </group>'''
                res['arch'] = res['arch'].replace(str_arch, str_arch1)

        return res

    def button_gera_mov(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        inv_capa = self.browse(cr, uid, ids)
        obj_estoque_produto_saldo = self.pool.get('estoque.produto.saldo')
        for capa in inv_capa:
            grade_qtd_entrada = {}
            grade_qtd_saida = {}
            for itens in capa.inventario_contagem_ids:
                # verifica se vai ter ajuste
                saldo_anterior = obj_estoque_produto_saldo.get_saldo_do_dia(cr,
                                                                            uid,
                                                                            itens.grade_id.id,
                                                                            capa.date,
                                                                            itens.local_id.id,
                                                                            context=context)
                saldo_anterior = saldo_anterior.get(itens.grade_id.id).get('saldo', 0.0)

                if itens.saldo_contado != (saldo_anterior + itens.requisitado):
                    qtde = itens.saldo_contado - (saldo_anterior + itens.requisitado)
                    # saida
                    if qtde > 0:
                        grade_qtd_entrada[itens.grade_id.id] = abs(qtde)
                    else:
                        grade_qtd_saida[itens.grade_id.id] = abs(qtde)

                self.pool.get('estoque.inventario.contagem').write(cr, uid, itens.id, {'state': 'A'}, context=context)

            if grade_qtd_entrada:
                obj_estoque_produto_saldo.atualizar_saldo_do_dia(cr, uid,
                                                                 capa.company_id.id,
                                                                 grade_qtd_entrada,
                                                                 capa.date,
                                                                 'E',
                                                                 capa.local_id.id,
                                                             context=context)

                if grade_qtd_saida:
                    obj_estoque_produto_saldo.atualizar_saldo_do_dia(cr, uid,
                                                                     capa.company_id.id,
                                                                     grade_qtd_saida,
                                                                     capa.date,
                                                                     'S',
                                                                     capa.local_id.id,
                                                                     context=context)
                # Colocando true no atributo atualizar
                #        self.write(cr, uid, ids, {'state': 'A'}, context=context)

        return True

    def unlink(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        atualizado = self.read(cr, uid, ids[0], ['atualizado'], context=context)['atualizado']
        if atualizado and uid != SUPERUSER_ID:
            raise osv.except_osv(_('Atencao'), _('Inventario ja atualizado, exclusao nao permitida.'))
        return super(estoque_inventario_capa, self).unlink(cr, uid, ids, context=context)

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if 'flag_produto_id' in vals:
            del vals['flag_produto_id']
        return super(estoque_inventario_capa, self).create(cr, uid, vals, context=context)

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, list):
            ids = ids[0]
        atualizado = self.read(cr, uid, ids, ['atualizado'], context=context)['atualizado']
        if 'flag_produto_id' in vals:
            del vals['flag_produto_id']
        if atualizado and not any([context.get('manutencao_inventario'),
                                  context.get('atualizacao_inventario'),
                                  context.get('registro_inventario'),
                                  context.get('gerar_contagem_inventario')]):
            raise osv.except_osv(_('Atencao'),
                                 _('Inventario ja atualizado. Alteracao nao permitida.'))
        return super(estoque_inventario_capa, self).write(cr, uid, ids, vals, context=context)

    def insert_itens_sql(self, cr, vals, capa_id, context=None):
        '''
        Insere o movimento de itens via SQL para melhorar a performance, como os campos funcionais
        nao sao usados no inventario eles nao precisam ser calculados
        :param cr:
        :param vals:
        :param capa_id:
        :param context:
        :return:
        '''
        context = context and context.copy() or {}
        tam_itens = len(vals)
        MAX = 30000 # maximo de registros inseridos em massa para evitar estouro de memoria
        partes = tam_itens / MAX
        resto = tam_itens % MAX
        ultimo_intervalo = 0
        sql = """
            INSERT INTO estoque_movimento_itens
            (create_date, create_uid, write_date, write_uid,
            produto_id, grade_id, local_id, produto_embalagem_id, quantidade, capa_id)
            VALUES %s
              """
        for i in range(0, partes):
            cr.execute(sql % ',\n'.join(vals[i*MAX: (i+1)*MAX]).format(capa_id=capa_id))

        if resto: # insere a ultima parte
            cr.execute(sql % ',\n'.join(vals[ultimo_intervalo:]).format(capa_id=capa_id))

        return True

    def esticp_bloqueia_concorrencia(self, cr, uid, ids, context):
        '''
        Bloqueia a classe inventario capa ateh que um commit ou rollback seja realizado para evitar
        que outro usuario atualize o inventario ao mesmo tempo.
        :param cr: 
        :param uid: 
        :param ids: 
        :param context: 
        :return: 
        '''
        sql = """
                BEGIN;
                SELECT * FROM estoque_inventario_capa WHERE id = %s FOR UPDATE NOWAIT;
              """ % ids[0]
        try:
            cr.execute(sql)
            if self.read(cr, uid, ids[0], ['atualizado'], context=context).get('atualizado'):
                raise Exception('')

        except Exception as e:
            raise osv.except_osv(_("Atencao!"),
                                 _("Este inventario esta sendo atualizado por outro usuario!"))

    def atualizar_inventario(self, cr, uid, ids, context=None):
        """
        Este metodo tem a funcionalidade de atualizar o saldo dos itens, e criar a movimentacao
        dos produtos digitados no inventario

        Informacoes importantes: Neste metodo o islation_level da conexao do cursor eh setada de
        ISOLATION_LEVEL_REPEATABLE_READ para ISOLATION_LEVEL_READ_COMMITTED, isso eh feito desta
        forma pelo fato de em alguns momentos ocorrer erro de chave duplicada ao chamar o metodo
        atualizar_saldo_do_dia da classe 'estoque.produto.saldo'. Isso ocorre quando o saldo do item
        nao existe no dia e o metodo atualizar_saldo_do_dia eh chamado ao mesmo tempo no inventario
        e em outra classe que movimente saldo.
        Conforme orientacao do Luiz esta alteracao foi realizada apenas no inventario para que o
        impacto nao seja muito grande caso ocorra algum erro nao esperado.

        :param cr: a linha atual do cursor do banco de dados
        :param uid: o ID do usuario que esta realizando a operacao
        :param ids: lista de IDs
        :param context: Dicionario de contextos
        :type cr: Cursor
        :type uid: int
        :type ids: list
        :type context: dict
        :rtype: bool
        """
        context = context and context.copy() or {}
        # Alterando o level da conexao para visualizar alteracoes feitas no saldo por
        # outras classes
        cr.connection.set_isolation_level(
            psycopg2.extensions.ISOLATION_LEVEL_READ_COMMITTED)

        self.esticp_bloqueia_concorrencia(cr, uid, ids, context)
        read_inventario = self.read(cr, uid, ids[0], context=context)
        if not read_inventario.get('inventario_contagem_ids'):
            return True

        # padrao de empresa que foi lancado no gerar contagem anteriormente, no caso
        # de multi-empresa
        funct_get_empresa = self.pool.get('adm.empresa.objeto').getEmpresa
        locacao_company_id = funct_get_empresa(cr, uid, 'estoque.local.locacao', context=context)
        movimento_capa_company_id = funct_get_empresa(cr, uid, 'estoque.movimento.capa', context=context)
        obj_estoque_produto_saldo = self.pool.get('estoque.produto.saldo')
        obj_estoque_movimento_capa = self.pool.get('estoque.movimento.capa')
        obj_estoque_local_locacao = self.pool.get('estoque.local.locacao')
        obj_adm_utils = self.pool.get('adm.utils')
        load = '_classic_write'
        context.update({'atualizacao_inventario': True})
        if read_inventario.get('inventario_contagem_ids'):
            obj_estoque_inventario_contagem = self.pool.get('estoque.inventario.contagem')
            inventario_contagem_id = read_inventario['inventario_contagem_ids'][0]
            func = obj_estoque_inventario_contagem.read(cr, uid, inventario_contagem_id,
                               ['funcionario_id'], context=context, load=load).get('funcionario_id')
            if not func:
                func = self.pool.get("digitacao.inventario.capa.osv")._get_funcionario(cr, uid)

            estpar_company_id = funct_get_empresa(cr, uid, 'estoque.parametro', context=context)
            estoque_par = self.pool.get('adm.utils').admutl_get_parametros(cr, uid,
                           'estoque.parametro', ['estpar_inventario_operacao_saida_id',
                         'estpar_inventario_operacao_entrada_id'], company_id=estpar_company_id,
                           context=context)
            operacao_saida_id =  estoque_par.get('estpar_inventario_operacao_saida_id')
            operacao_entrada_id =  estoque_par.get('estpar_inventario_operacao_entrada_id')
            if estoque_par:
                if not operacao_saida_id:
                    raise osv.except_osv(_('Atencao'),
                                         _(
                                             'A "Operacao de saida para inventario" nao esta cadastrada nos parametros do estoque'))

                if not operacao_entrada_id:
                    raise osv.except_osv(_('Atencao'),
                                         _(
                                             'A "Operacao de entrada para inventario" nao esta cadastrada nos parametros do estoque'))
            else:
                raise osv.except_osv(_('Atencao'), _('Os parametros do estoque nao estao cadastrados'))

            vals_capa = {'inventario_id': read_inventario.get('id'),
                         'company_id': movimento_capa_company_id,
                         'data': read_inventario.get('create_date'),
                         'funcionario_id': func,
                         'estmvc_operacao_id': operacao_saida_id,
                         'state': 'F'}

            sql = '''
                SELECT eic.id,
                       eic.saldo_cadastro                                AS saldo_cadastro,
                       eic.saldo_contado                                 AS saldo_contado,
                       eic.produto_id                                    AS produto_id,
                       eic.grade_id                                      AS grade_id,
                       eic.local_id                                      AS local_id,
                       epe.id                                            AS produto_embalagem_id,
                       epe.active                                        AS active,
                       CASE WHEN eic.saldo_contado < saldo_cadastro
                            THEN 'S'
                            ELSE 'E'
                       END                                               AS tipo,
                       CASE WHEN eic.saldo_contado = saldo_cadastro
                            THEN eic.saldo_contado
                            ELSE eic.saldo_contado - eic.saldo_cadastro
                       END                                               AS novo_saldo,
                       ell.id                                            AS existe_local_locacao
                FROM estoque_inventario_contagem     AS eic
            INNER JOIN estoque_local_locacao     AS ell ON ell.grade_id = eic.grade_id AND ell.local_id = eic.local_id
            INNER JOIN estoque_produto_embalagem AS epe ON epe.id = ell.estllc_produto_embalagem_id
            INNER JOIN estoque_embalagem         AS ee  ON ee.id = epe.embalagem_id
                WHERE eic.inventario_id = %s
                  AND ell.company_id = %s
                    ''' % (ids[0], locacao_company_id)

            cr.execute(sql)
            dados_inventario = cr.dictfetchall()

            # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
            #   Gravar os dados da Capa na Estoque_movimento_capa   #
            # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
            saldo_company_id = funct_get_empresa(cr, uid, 'estoque.produto.saldo', context=context)
            inventario_contagem_ids = map(lambda i: i.get('id'), dados_inventario)
            dados_sald_dif = filter(lambda i: i.get('saldo_contado') != i.get('saldo_cadastro'),
                                    dados_inventario)
            dados_sem_local_locacao = filter(lambda i: not i.get('existe_local_locacao'),
                                             dados_inventario)
            mov_itens_entrada = []
            mov_itens_saida = []
            grade_qtd_entrada = {}
            grade_qtd_saida = {}
            for i in dados_sald_dif:
                tipo = i.get('tipo')
                produto_id = i.get('produto_id')
                grade_id = i.get('grade_id')
                local_id = i.get('local_id')
                novo_saldo = i.get('novo_saldo') or 0.0
                if novo_saldo < 0:
                    novo_saldo = novo_saldo * -1
                dados_sql = """((now() at time zone 'UTC'), {create_uid}, (now() at time zone 'UTC'), {write_uid},
                                 {produto_id}, {grade_id}, {local_id}, {produto_embalagem_id},
                                 {quantidade}, {capa_id})""".\
                                 format(
                                 create_uid=uid,
                                 write_uid=uid,
                                 produto_id=produto_id,
                                 grade_id=grade_id,
                                 local_id=local_id,
                                 produto_embalagem_id=i.get('produto_embalagem_id'),
                                 quantidade=novo_saldo,
                                 capa_id='{capa_id}', # em outro momento sera atribuido a capa_id
                                 )
                if tipo == 'E':  # entrada de movimento
                    grade_qtd_entrada[str(grade_id) + '-' + str(local_id)] = abs(
                        (i.get('novo_saldo') or 0.0))
                    mov_itens_entrada.append(dados_sql)
                else:  # saida de movimento
                    grade_qtd_saida[str(grade_id) + '-' + str(local_id)] = abs(
                        (i.get('novo_saldo') or 0.0))
                    mov_itens_saida.append(dados_sql)

            if mov_itens_entrada:# movimentacao de entrada
                vals_capa['estmvc_operacao_id'] = operacao_entrada_id
                entrada_capa_id = obj_estoque_movimento_capa.create(cr, uid, vals_capa,
                                                                    context=context)
                self.insert_itens_sql(cr, mov_itens_entrada, entrada_capa_id, context)

            if mov_itens_saida: # movimentacao de saida
                vals_capa['estmvc_operacao_id'] = operacao_saida_id
                saida_capa_id = obj_estoque_movimento_capa.create(cr, uid, vals_capa,
                                                                  context=context)
                self.insert_itens_sql(cr, mov_itens_saida, saida_capa_id, context)

            data_inventario = obj_adm_utils.admutl_converte_tz(cr, uid,
                       datetime.strptime(read_inventario.get('create_date'), '%Y-%m-%d %H:%M:%S'),
                                                         'UTC', 'America/Sao_Paulo', context).date()
            # O processo abaixo eh feito para solucionar o problema de outra classe alem
            # do inventario chamar o metodo atualizar_saldo_do_dia ao mesmo tempo para um
            # item que ainda nao tem saldo no dia. (Atendimento 92888)
            for grade in grade_qtd_entrada:
                cr.execute('BEGIN; SAVEPOINT atualizacao_inventario;')  # Cria um save point
                grade_id = int(grade.split('-')[0])
                local_id = int(grade.split('-')[1])
                try:
                    if grade_qtd_entrada:
                        obj_estoque_produto_saldo.atualizar_saldo_do_dia(
                            cr, uid, saldo_company_id,
                            {grade_id: grade_qtd_entrada.get(grade)},
                            data_inventario,
                            'E',
                            local_id,
                            context=context)

                except cr.connection.IntegrityError as e:
                    if '23505' == e.pgcode:  # 23505 eh o codigo do erro de duplicate key
                        cr.execute("ROLLBACK TO SAVEPOINT atualizacao_inventario;")
                        obj_estoque_produto_saldo.atualizar_saldo_do_dia(
                            cr, uid, saldo_company_id,
                            {grade_id: grade_qtd_entrada.get(grade)},
                            data_inventario,
                            'E',
                            local_id,
                            context=context)
                finally:
                    cr.execute("RELEASE SAVEPOINT atualizacao_inventario;")
                    # Destroi o save point

            for grade in grade_qtd_saida:
                cr.execute('BEGIN; SAVEPOINT atualizacao_inventario;')  # Cria um save point
                grade_id = int(grade.split('-')[0])
                local_id = int(grade.split('-')[1])
                try:
                    if grade_qtd_saida:
                        obj_estoque_produto_saldo.atualizar_saldo_do_dia(
                            cr, uid, saldo_company_id,
                            {grade_id: grade_qtd_saida.get(grade)},
                            data_inventario,
                            'S',
                            local_id,
                            context=context)

                except cr.connection.IntegrityError as e:
                    if '23505' == e.pgcode:  # 23505 eh o codigo do erro de duplicate key
                        cr.execute("ROLLBACK TO SAVEPOINT atualizacao_inventario;")
                        obj_estoque_produto_saldo.atualizar_saldo_do_dia(
                            cr, uid, saldo_company_id,
                            {grade_id: grade_qtd_saida.get(grade)},
                            data_inventario,
                            'S',
                            local_id,
                            context=context)
                finally:
                    cr.execute("RELEASE SAVEPOINT atualizacao_inventario;")
                    # Destroi o save point

            for i in dados_sem_local_locacao:
                obj_estoque_local_locacao.create(cr, uid, {'produto_id': i['produto_id'],
                                                           'company_id': locacao_company_id,
                                                           'grade_id': i['grade_id'],
                                                           'local_id': i['local_id'],
                                                           'estllc_produto_embalagem_id':
                                                               i['produto_embalagem_id']
                                                           }, context)
            sql = """
                    UPDATE estoque_inventario_contagem
                    SET    write_uid = %s,
                           write_date=(now() at time zone 'UTC'),
                           estict_item_atualizado = true
                    WHERE  id IN (%s)
                   """ % (uid, ','.join(map(lambda x: '%s' % x, inventario_contagem_ids)))
            cr.execute(sql)
            obj_digitacao_inventario_capa_osv = self.pool.get('digitacao.inventario.capa.osv')
            digitacao_inventario_ids = obj_digitacao_inventario_capa_osv. \
                search(cr, uid, [('inventario_id', '=', read_inventario['id'])])
            # Excluindo das da digitacao do inventario
            if digitacao_inventario_ids:
                obj_digitacao_inventario_capa_osv.unlink(cr, uid, digitacao_inventario_ids)

            self.write(cr, uid, ids[0], {'atualizado': True}, context=context)

        return True
