#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv


class estoque_inventario_oficial(osv.Model):

    _inherit = 'estoque.inventario.oficial'

    def estiof_gerar_inventario_oficial(self, cr, uid, contagem_id, saldo, ultimo_custo,
                                        custo_medio_contabil, context=None):
        """
        Este metodo tem como objetivo gerar os valores para a classe estoque.inventario.oficial
        Os valores de saldo, ultimo_custo, custo_medio_contabil, nao sao buscados diratamente
        da classe estoque.inventario.contagem pelo de fato poder haver alguma alteracao nos valores,
        conforme implementacao do livro registro de inventario, que chama este metodo.
        :param cr: Cursor do openerp
        :param uid: Id do usuario do openerp
        :param contagem_id: Id da contagem salva em estoque.inventario.contagem
        :param saldo: Saldo contado para o inventario oficial
        :param ultimo_custo: Ultimo cuso para o inventario oficial
        :param custo_medio_contabil: Custo medio contabil para o inventario oficial
        :param context: Dicionario contendo valores contextuais
        :type cr: Cursor
        :type uid: int
        :type contagem_id: int | long
        :type saldo: float
        :type ultimo_custo: float
        :type custo_medio_contabil: float
        :type context: dict
        :return: Retorna o id do registro criado
        :rtype: long
        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        context = context and context.copy() or {}
        contagem = self.pool.get('estoque.inventario.contagem').browse(cr, uid, contagem_id,
                                                                       context=context)
        vals = {
            'saldo': saldo,
            'estiof_custo_medio_contabil': custo_medio_contabil,
            'estiof_ultimo_custo': ultimo_custo,
            'capa_id': contagem.inventario_id.id,
            'produto_id': contagem.produto_id.id,
            'grade_id': contagem.grade_id.id
        }
        return self.create(cr, uid, vals, context=context)