# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
from datetime import datetime
from decimal import Decimal, ROUND_HALF_UP


class estoque_movimento_itens(osv.Model):
    """
    Tabela com itens movimentados
    """
    _inherit = 'estoque.movimento.itens'

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = []
        if not ids:
            return res
        brw_movimento_item = self.browse(cr, uid, ids, context)
        for record in brw_movimento_item:
            res.append((record.id, record.name or record.grade_id.name))
        return res

    def get_item_preco_venda(self, cr, uid, produto_ids, company_id=None, pessoa_id=None,
                             grade_id=False, context=None):
        """
        BUSCA O PRECO DE VENDA DO PRODUTO
        """
        context = context and context.copy() or {}
        cliente_id = None
        if pessoa_id:
            cliente_id = self.pool.get('financeiro.cliente').search(cr, uid, [('pessoa_id', '=', pessoa_id)],
                                                                    context=context)
            if cliente_id:
                cliente_id = cliente_id[0]

        preco_venda = self.pool.get('estoque.preco.venda').get_preco_venda(cr, uid, produto_ids,
                        epc_grade_ids=grade_id,
                        epc_company_id=company_id,
                        epc_cliente_id=cliente_id,
                        context=context)
        return preco_venda

    def get_qtde_embalagem(self, cr, uid, produto_embalagem_id, context=None):
        """
        BUSCA A QUANTIDADE NA EMBALAGEM
        Troca para funcao 'get_grade_qtd_embalagem' em estoque.utils para melhorar performance
        """
        print "-------->'get_qtde_embalagem()' esta depreciada, utilizar a funcao 'get_grade_qtd_embalagem()'"
        context = context and context.copy() or {}
        embalagem_quantidade = 1
        if produto_embalagem_id:
            embalagem_quantidade = self.pool.get('estoque.produto.embalagem').browse(cr, uid,
                                                                                     produto_embalagem_id).embalagem_id.quantidade_na_embalagem
        return embalagem_quantidade or 1

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if context.get('atualizacao_inventario'):
            res = super(estoque_movimento_itens, self).create(cr, uid, vals, context)
            return res

        def _estmvi_create_madeireira(cr, uid, vals, context):
            #  Todo: Levar esta funcionalida para o modulo madeireira
            context.update({'calculo_com_volume': True})
            quantidade = vals.get('quantidade')
            comprimento = vals.get('estmvi_comprimento') or 0
            largura = vals.get('estmvi_largura') or 0
            espessura = vals.get('estmvi_espessura') or 0

            volume = self.pool.get('madeireira.utils').madutl_calcula_volume(
                quantidade, comprimento, largura, espessura, self, 'estmvi_volume')
            vr_total_item = vals.get('vr_total_item') or 0
            if not context.get('fisnfc_nfe_de_nfce'):
                vr_total_item = float(Decimal(str(
                    ((volume or quantidade) * vals.get('vr_unitario', 0)) -
                    vals.get('vr_desconto', 0))).quantize(Decimal('.01'), rounding=ROUND_HALF_UP))
            vals.update({'estmvi_comprimento': comprimento,
                         'estmvi_largura': largura,
                         'estmvi_espessura': espessura,
                         'estmvi_volume': volume,
                         'vr_total_item': vr_total_item})
            res = self.pool.get('madeireira.utils').madutl_verifica_medidas(cr, uid,
                                                                            vals.get('produto_embalagem_id'),
                                                                            vals.get(
                                                                                'estmvi_comprimento'),
                                                                            vals.get(
                                                                                'estmvi_largura'),
                                                                            vals.get(
                                                                                'estmvi_espessura'))
            if not context.get('fatura_pedido'):
                if isinstance(res, basestring):
                    raise osv.except_osv(_('Atencao'), res)
                if vals.get('produto_id') and context.get('nota_fiscal_saida'):
                    obj_madeireira_utils = self.pool.get('madeireira.utils')
                    valida_variacao = obj_madeireira_utils.madpro_valida_variacao(cr, uid, vals.get(
                        'produto_id'), vals.get('estmvi_comprimento'), vals.get('estmvi_espessura'),
                                                                                  context)
                    if valida_variacao.get('warning'):
                        mensagem = valida_variacao['warning']['message']
                        raise osv.except_osv(_('Atencao'), mensagem)
                    else:
                        vr_variacao = valida_variacao.get('vr_variacao')
                        if vals.get('estmvi_volume'):
                            pessoa_id = False
                            if vals.get('nf_id'):
                                pessoa_id = self.pool.get('fiscal.nf.capa').browse(
                                    cr, uid, vals.get('nf_id'), context).pessoa_id.id
                            vals['vr_unitario'] = \
                                self.pool.get('madeireira.utils').madutl_get_valor_com_fator(
                                    cr, uid, vals.get('produto_id'), vr_variacao or 0, pessoa_id,
                                    context)
            return vals, context

        context = context and context.copy() or {}
        if isinstance(vals, tuple):
            vals = vals[0]

        produto_id = vals.get('produto_id') or []
        grade_id = vals.get('grade_id')
        item_produto_embalagem_id = vals.get('produto_embalagem_id')
        item_quantidade = vals.get('quantidade') or 0
        item_vr_unitario = vals.get('vr_unitario') or 0
        item_desconto = vals.get('vr_desconto') or 0
        if not 'vr_total_item' in vals:
            if any([context.get('importacao_supervisor_erp'), context.get('importacao_automatica'),
                    context.get('valida_cupom'), context.get('inconsistencia')]):
                vals['vr_total_item'] = item_quantidade * item_vr_unitario
            else:
                vals['vr_total_item'] = (item_quantidade * item_vr_unitario) - item_desconto

        if grade_id and item_produto_embalagem_id and item_quantidade:
            obj_est_produto_embalagem = self.pool.get('estoque.produto.embalagem')
            if isinstance(item_produto_embalagem_id, (tuple, list)):
                produto_embalagem_id = item_produto_embalagem_id[0]
            else:
                produto_embalagem_id = item_produto_embalagem_id

            dict_qtd_emb = self.pool.get('estoque.utils').get_grade_qtd_embalagem(cr, [grade_id],
                                                                                  context)
            chave = '%s-%s' % (grade_id, produto_embalagem_id)
            quantidade_na_embalagem = (dict_qtd_emb.get(chave) or {}).get('qtd')
            if not quantidade_na_embalagem:
                nome_embalagem = obj_est_produto_embalagem.browse(cr, uid, produto_embalagem_id
                                                                  ).embalagem_id.name
                raise osv.except_osv(_('Atencao'),
                                     _('A quantidade para a embalagem ') + nome_embalagem.decode('utf-8') + _(
                                         ' nao pode ser zero, realize a alteracao no cadastro de embalagens.'))

            vals['quantidade'] = vals['quantidade'] * quantidade_na_embalagem

        if context.get('entrada_producao') or context.get('ctx_pcp_perda_producao'):
            if produto_id:
                company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
                preco_venda = self.pool.get('estoque.preco.venda').get_preco_venda(
                    cr, uid, epc_produto_ids=produto_id, epc_company_id=company_id, context=context)
                preco_venda = preco_venda.get(produto_id) or {}
                preco_venda = preco_venda.get('preco_venda') or 0.0
                vals['vr_preco_venda'] = preco_venda
                # busca os custos
                custos = self.pool.get('estoque.preco.custo').get_custos_do_dia(cr, uid, produto_id, None, None,
                                                                                context)
                if custos.get(produto_id):
                    custos = custos.get(produto_id)
                else:
                    custos = {}
                if custos:
                    vals['estmvi_saidas_custo_corrigido_total'] = custos.get('estprc_custo_corrigido') or 0.0
                    vals['estmvi_saidas_custo_medio_contabil_total'] = custos.get('estprc_custo_medio_contabil') or 0.0
                    vals['estmvi_saidas_ultimo_custo_total'] = custos.get('estprc_ultimo_custo') or 0.0
                    vals['estmvi_saidas_custo_reposicao_total'] = custos.get('estprc_custo_reposicao') or 0.0

                    estoque_parametro_obj = self.pool.get('estoque.parametro')
                    parametro_id = estoque_parametro_obj.search(cr, uid, [('company_id', '=', company_id)],
                                                                context=context)
                    if parametro_id:
                        estpar_custo_entrada_producao = \
                            estoque_parametro_obj.read(cr, uid, parametro_id[0], ['estpar_custo_entrada_producao'],
                                                       context=context)[
                                'estpar_custo_entrada_producao']
                        if estpar_custo_entrada_producao:
                            if 'U' in estpar_custo_entrada_producao:
                                vals['vr_unitario'] = vals['estmvi_saidas_ultimo_custo_total']
                            if 'C' in estpar_custo_entrada_producao:
                                vals['vr_unitario'] = vals['estmvi_saidas_custo_medio_contabil_total']
                            if 'O' in estpar_custo_entrada_producao:
                                vals['vr_unitario'] = vals['estmvi_saidas_custo_corrigido_total']
                            if 'R' in estpar_custo_entrada_producao:
                                vals['vr_unitario'] = vals['estmvi_saidas_custo_reposicao_total']
                            if vals.get('vr_unitario'):
                                vals['vr_total_item'] = (vals.get('vr_unitario') or 0) * \
                                                        (vals.get('quantidade') or 0)

        grade = vals.get('grade_id') or []
        embalagem = vals.get('produto_embalagem_id') or []
        if not grade and not context.get('importacao_nfe') and not context.get('nota_referenciada'):
            produto = self.pool.get('estoque.produto').read(cr, uid, produto_id, ['tipo', 'name'],
                                                            context=context)
            if isinstance(produto, list):
                produto = produto[0]

            if produto.get('tipo', '') == 'P':
                raise osv.except_osv(_('Atencao'),
                                     _(
                                     'Na movimentacao de itens o campo "GRADE" deve ser informado no cadastro do produto'))

        if not embalagem and not context.get('nota_referenciada'):
            produto = self.pool.get('estoque.produto').read(cr, uid, produto_id, ['tipo', 'name'],
                                                            context=context)
            if isinstance(produto, list):
                produto = produto[0]

            if produto.get('tipo', '') == 'P':
                raise osv.except_osv(_('Atencao'),
                                     _('Na movimentacao de itens o campo "EMBALAGEM" deve ser '
                                       'informado: \n%s' % produto.get('name')))
        if vals.get('locacao_id'):
            # buscar local_id pelo locacao_id
            local = self.pool.get('estoque.local.locacao').read(cr, uid, vals['locacao_id'],
                                                                ['local_id'], context=context)
            if isinstance(local, list):
                local = local[0]
            if isinstance(local, dict):
                if local.get('local_id'):
                    try:
                        local_id = local['local_id'][0]
                    except:
                        local_id = []
                    if local_id:
                        vals['local_id'] = local_id

        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'madeireira', context):
            if not context.get('terceiro') and not context.get('entrada_producao') \
                    and not context.get('atualizacao_inventario') and not context.get('ctx_nf_servico'):
                vals, context = _estmvi_create_madeireira(cr, uid, vals, context)

        # contexto para otimizar o tempo de notas com muitos itens, ao gravar o log esta fazendo
        # um read na classe
        context['super_read_estoque_movimento_itens'] = True
        res = super(estoque_movimento_itens, self).create(cr, uid, vals, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        # 'super_write_estoque_movimento_itens' contexto para realizar o write direto sem fazer contas.
        if context.get('atualizacao_inventario') or context.get('super_write_estoque_movimento_itens'):
            return super(estoque_movimento_itens, self).write(cr, uid, ids, vals, context)

        def _estmvi_write_estoqueserie(cr, uid, ids, values, context):
            # SE O PRODUTO_ID DO MOVIMENTO FOR ALTERADO E O MOVIMENTO DE SERIE DEVE SER APAGADO, POIS A SERIE QUE FOI
            # ESCOLHIDA PERTENCIA AO PRODUTO SELECIONADO.
            if 'estmvi_produto_nserie_controle' in values:
                if values.get('estmvi_produto_nserie_controle') is False:
                    obj_serie_movimento = self.pool.get('estoqueserie.movimento')
                    serie_mov_ids = obj_serie_movimento.search(
                        cr, uid, [('esemov_movimento_itens_id', 'in', ids)], context=context
                    )
                    if serie_mov_ids:
                        obj_serie_movimento.unlink(cr, uid, serie_mov_ids, context)
            return True

        def _estmvi_write_fiscal(cr, uid, ids, vals, context):
            if context.get('entrada_producao'):
                if context.get('fiscal'):
                    del context['fiscal']
                if context.get('calculo_com_volume'):
                    del context['calculo_com_volume']
            if context.get('fiscal') or context.get('nota_fiscal_entrada') or context.get(
                    'nota_fiscal_saida') or context.get('importacao_nfe'):
                fields_to_read = ['nf_id', 'tributacoes_ids', 'quantidade', 'produto_embalagem_id',
                                  'local_id', 'nf_propria', 'produto_id', 'vr_total_item_rateado',
                                  'grade_id', 'vr_preco_venda', 'vr_unitario', 'vr_desconto',
                                  'vr_total_item']
                dados_item = self.read(cr, uid, ids, fields_to_read, context=context,
                                       load='_classic_write')
                if isinstance(dados_item, list):
                    dados_item = dados_item[0]

                # Atribui valores que estao vindo no vals se nao vierem o valor antigo do campo e acessado.
                if vals.get('local_id'):
                    item_local_id = vals['local_id']
                else:
                    item_local_id = dados_item.get('local_id')

                if vals.get('produto_id'):
                    item_produto_id = vals['produto_id']
                else:
                    item_produto_id = dados_item.get('produto_id')

                if vals.get('grade_id'):
                    item_grade_id = vals['grade_id']
                else:
                    item_grade_id = dados_item.get('grade_id')

                if vals.get('produto_embalagem_id'):
                    embalagem_id = vals.get('produto_embalagem_id')
                    item_produto_embalagem_id = \
                        embalagem_id[0] if isinstance(embalagem_id, (list, tuple)) else \
                            embalagem_id
                else:
                    item_produto_embalagem_id = dados_item.get('produto_embalagem_id')

                if vals.get('quantidade'):
                    item_quantidade = vals['quantidade']
                else:
                    item_quantidade = dados_item.get('quantidade') or 0

                if vals.get('vr_unitario'):
                    item_valor_unitario = vals['vr_unitario']
                else:
                    item_valor_unitario = dados_item.get('vr_unitario') or 0

                if vals.get('vr_preco_venda'):
                    item_preco_venda = vals.get('vr_preco_venda')
                elif item_produto_id == dados_item.get('produto_id') :
                    item_preco_venda = dados_item.get('vr_preco_venda') or 0
                else:
                    item_preco_venda = 0

                if vals.get('vr_desconto'):
                    item_desconto = vals.get('vr_desconto')
                else:
                    item_desconto = dados_item.get('vr_desconto') or 0

                if vals.get('nf_propria'):
                    item_nf_propria = vals.get('nf_propria')
                else:
                    item_nf_propria = dados_item.get('nf_propria') or 0

                nf_referencia_ids = dados_nf.get('fisnfc_nf_referencia_ids') if dados_nf else False

                if not item_quantidade > 0 and not nf_referencia_ids:
                    raise osv.except_osv(_('Atencao!'),
                                         _('A quantidade informada para o produto deve ser '
                                           'maior que zero!'))
                if not item_valor_unitario > 0 and context.get('entrada_producao') and \
                        not nf_referencia_ids:
                    raise osv.except_osv(_('Atencao!'),
                                         _('O valor unitario do item deve ser maior que zero!'))
                if item_desconto < 0:
                    raise osv.except_osv(_('Atencao!'),
                                         _('O valor desconto nao pode ser negativo, dever ser '
                                           'igual ou maior que zero.'))

                # Verificacao para nota fiscal referenc
                if dados_nf:
                    nf_company_id = dados_nf.get('company_id')
                    natureza_id = dados_nf.get('natureza_id')
                    obj_estoque_produto = self.pool.get('estoque.produto')
                    produto_dados = obj_estoque_produto.read(cr, uid, item_produto_id,
                                                             ['tipo', 'origem_mercadoria'],
                                                             context=context)
                    if produto_dados and isinstance(produto_dados, list):
                        produto_dados = produto_dados[0]

                    produto_tipo = produto_dados.get('tipo')
                    if produto_tipo == 'P':
                        nf_capa_fornecedor_id = dados_nf.get('destinatario_id')
                        # verifica se o produto possui o local informado, se nao tiver, adiciona o local para o produto
                        self.check_nf_item_local_produto(cr, uid, company_id=nf_company_id, local_id=item_local_id,
                                                         produto_id=item_produto_id, grade_id=item_grade_id,
                                                         embalagem_id=item_produto_embalagem_id, context=context)
                        if nf_capa_fornecedor_id and not dados_nf.get('nf_propria'):
                            # verifica se o fornecedor esta cadastrado para o produto, se nao estiver, realiza o cadastro
                            obj_estoque_produto.estoque_produto_in_fornecedor(cr, uid, company_id=nf_company_id,
                                                                              fornecedor_id=nf_capa_fornecedor_id,
                                                                              produto_id=item_produto_id,
                                                                              produto_embalagem_id=item_produto_embalagem_id,
                                                                              context=context)
                        if not context.get('nota_referenciada') and not context.get('calculo_com_volume') \
                                and 'fatura_pedido' not in context:

                            if not context.get('terceiro'):
                                vals['vr_unitario'] = item_valor_unitario

                        # Recalculo Valores Fiscais para nota fiscal de saida que e de devolucao
                        if 'produto_id' in vals and context.get('nota_fiscal_saida') \
                                        or context.get('nota_fiscal_entrada') and not \
                                        dados_nf.get('fisnfc_nf_devolucao'):
                            if not natureza_id:
                                raise osv.except_osv(_('Atencao'),
                                                     _('Para fazer a validacao informe o natureza da operacao.'))

                            if not context.get('importacao_nfe') and not context.get('nota_referenciada') \
                                    and 'fatura_pedido' not in context:
                                destinatario_id = dados_nf.get('destinatario_id')
                                destinatario_endereco_id = dados_nf.get(
                                                                     'destinatario_endereco_id')
                                # Quando a nota for modelo 02 e serie D a fatura sera gerada com o pessoa_id do emitente
                                if not destinatario_id and dados_nf.get('fisnfc_modelo_serie') == '02D':
                                    destinatario_id = self.pool.get('res.company').read(cr, uid,
                                                             nf_company_id, ['rescon_pessoa_id']
                                                             ).get('rescon_pessoa_id')
                                if 'vr_total_item_rateado' in vals or vals.get('vr_total_item'):
                                    vr_rateado = vals.get('vr_total_item_rateado') or vals.get('vr_total_item') or 0
                                else:
                                    vr_rateado = dados_item.get('vr_total_item_rateado') or \
                                                 dados_item.get('vr_total_item') or 0

                                if item_nf_propria:
                                    if context.get('nota_fiscal_entrada'):
                                        tipo_tributacao = 'E'
                                    if context.get('nota_fiscal_saida'):
                                        tipo_tributacao = False

                                    load = '_classic_write'
                                    obj_pessoa = self.pool.get('adm.pessoa')
                                    dados_destinatario = obj_pessoa.read(cr, uid,
                                                                         destinatario_id,
                                                                         ['cpf_cnpj',
                                                                          'endereco_ids',
                                                                          'admpes_jur_tipo_atividade'],
                                                                         context)
                                    campos = ['cfop_id', 'natureza_encargos_ids', 'tipo']
                                    dados_natureza = self.pool.get('fiscal.cfop.natureza').read(
                                        cr, uid, natureza_id,
                                        campos,
                                        context, load)
                                    campos = ['movimento_tipo', 'codigo', 'sigla']
                                    dados_cfop_nat = self.pool.get('fiscal.cfop').read(cr, uid,
                                                                                       dados_natureza.get(
                                                                                           'cfop_id'),
                                                                                       campos,
                                                                                       context)
                                    campos = ['encargo_id', 'sobrepor_tributacao_id',
                                              'fiscne_sobrepoe_so_tributados']
                                    dados_nat_encargo = self.pool.get(
                                        'fiscal.cfop.natureza.encargos').read(cr, uid,
                                                                              dados_natureza.get(
                                                                                  'natureza_encargos_ids'),
                                                                              campos, context,
                                                                              load)

                                    encargo_ids = map(lambda x: x.get('encargo_id'),
                                                      dados_nat_encargo)
                                    dict_encargos_nat = {}
                                    map(lambda x: dict_encargos_nat.update({x.get('id'): x}),
                                        self.pool.get('fiscal.encargo').read(cr, uid,
                                                                             encargo_ids,
                                                                             ['sigla'],
                                                                             context))
                                    uf_id = self.pool.get('adm.pessoa.endereco').read(cr, uid,
                                                                                      destinatario_endereco_id,
                                                                                      ['uf_id'],
                                                                                      context,
                                                                                      load).get('uf_id')
                                    tributos = self.calcular_tributo_itens(cr, uid, produto_dados,
                                                  dados_natureza, dados_nat_encargo, dados_cfop_nat,
                                                  encargo_ids, dados_destinatario, tipo_tributacao,
                                                  vr_rateado, vals.get('tributacoes_ids', []),
                                                  uf_id, context)
                                    if tributos:
                                        obj_fiscal_nf_item_tributacao = self.pool.get('fiscal.nf.item.tributacao')
                                        tributos_itens_ids = obj_fiscal_nf_item_tributacao.search(cr, uid, [
                                            ('movimento_itens_id', 'in', ids)], context=context)
                                        obj_fiscal_nf_item_tributacao.unlink(cr, uid, tributos_itens_ids)
                                        vals['tributacoes_ids'] = tributos

            if vals.get(
                    'tributacoes_ids'):  # passando itens excluidos pelo context para one2many  devido um erro no framework
                verifica_tributo_excluido = filter(lambda i: (i[0] == 2), vals['tributacoes_ids']) or []
                tributos_excluidos_ids = [x[1] for x in verifica_tributo_excluido]
                context['tributos_excluidos'] = tributos_excluidos_ids
            if context.get('calculo_com_volume'):
                id = ids
                if ids and isinstance(ids, list):
                    id = ids[0]
                if 'estmvi_volume' in vals:
                    volume = vals.get('estmvi_volume')
                else:
                    volume = self.browse(cr, uid, id).estmvi_volume
                if 'vr_unitario' in vals:
                    vr_unitario = vals['vr_unitario']
                else:
                    vr_unitario = dados_item.get('vr_unitario')
                if volume:
                    vr_total_item = (vr_unitario * volume) - item_desconto
                    vals['vr_total_item'] = vr_total_item
            return vals, context

        def _estmvi_write_madeireira(cr, uid, ids, vals, context=None):
            context = context and context.copy() or {}
            obj_madeireira_utils = self.pool.get('madeireira.utils')
            fields = ['estmvi_comprimento', 'estmvi_largura', 'estmvi_espessura', 'quantidade',
                      'vr_unitario', 'vr_desconto', 'produto_id']
            dados_movimento_item = self.read(cr, uid, ids, fields, context=context,
                                             load='_classic_write')
            if isinstance(dados_movimento_item, list):
                dados_movimento_item = dados_movimento_item[0]

            if not 'quantidade' in vals:
                quantidade = dados_movimento_item.get('quantidade') or 0
            else:
                quantidade = vals.get('quantidade')

            if not 'estmvi_comprimento' in vals:
                estmvi_comprimento = dados_movimento_item.get('estmvi_comprimento') or 0
            else:
                estmvi_comprimento = vals.get('estmvi_comprimento')

            if not 'estmvi_largura' in vals:
                estmvi_largura = dados_movimento_item.get('estmvi_largura') or 0
            else:
                estmvi_largura = vals.get('estmvi_largura')

            if not 'estmvi_espessura' in vals:
                estmvi_espessura = dados_movimento_item.get('estmvi_espessura') or 0
            else:
                estmvi_espessura = vals.get('estmvi_espessura')

            if not 'vr_desconto' in vals:
                vr_desconto = dados_movimento_item.get('vr_desconto') or 0
            else:
                vr_desconto = vals.get('vr_desconto')

            if not 'produto_id' in vals:
                produto_id = dados_movimento_item.get('produto_id')
            else:
                produto_id = vals.get('produto_id')

            if not 'produto_embalagem_id' in vals:
                produto_embalagem_id = dados_movimento_item.get('produto_embalagem_id')
            else:
                produto_embalagem_id = vals.get('produto_embalagem_id')
            if isinstance(produto_id, (list, tuple)):
                produto_embalagem_id = produto_id[0]

            # A verificacao de variacao somente sera realizada em notas fiscais de saida
            if context.get('nota_fiscal_saida'):
                res = obj_madeireira_utils.madutl_verifica_medidas(
                    cr, uid, produto_embalagem_id, estmvi_comprimento, estmvi_largura,
                    estmvi_espessura)
                if isinstance(res, basestring):
                    raise osv.except_osv(_('Atencao!'), res)
                valida_variacao = obj_madeireira_utils.madpro_valida_variacao(
                    cr, uid, produto_id, estmvi_comprimento, estmvi_espessura, context)
                if valida_variacao.get('warning'):
                    mensagem = valida_variacao['warning']['message']
                    raise osv.except_osv(_('Atencao'), mensagem)

            if 'vr_unitario' in vals:
                quantidade_na_embalagem = self.pool.get('estoque.produto.embalagem').browse(
                    cr, uid, produto_embalagem_id).embalagem_id.quantidade_na_embalagem
                vr_unitario = vals.get('vr_unitario') * quantidade_na_embalagem
            else:
                vr_unitario = dados_movimento_item.get('vr_unitario') or 0
            volume = self.pool.get('madeireira.utils').madutl_calcula_volume(quantidade,
                                                                             estmvi_comprimento,
                                                                             estmvi_largura,
                                                                             estmvi_espessura,
                                                                             self, 'estmvi_volume'
                                                                             )
            qtde = volume or quantidade
            vr_total_item = float(Decimal(str((qtde * vr_unitario) - vr_desconto)).quantize(
                Decimal('.01'), rounding=ROUND_HALF_UP))
            vals.update({'vr_total_item': vr_total_item})
            context.update({'calculo_com_volume': True, 'fiscal': True})
            return vals, context

        context = context and context.copy() or {}
        valor_unitario = vals.get('vr_unitario')
        nf_id = vals.get('nf_id')
        destinatario_id = None
        nf_tipo_movimentacao = None
        dados_nf = False
        if nf_id:
            campos_nf = ['destinatario_id', 'fisnfc_tipo_servico', 'tipo', 'fisnfc_modelo_serie',
                         'company_id', 'natureza_id',  'destinatario_endereco_id',  'nf_propria',
                         'fisnfc_nf_devolucao', 'fisnfc_nf_referencia_ids']
            dados_nf = self.pool.get('fiscal.nf.capa').read(cr, uid, nf_id, campos_nf,
                                                            context=context, load='_classic_write')
            destinatario_id = dados_nf.get('destinatario_id') or None
            nf_tipo_servico = dados_nf.get('fisnfc_tipo_servico')
            nf_tipo_movimentacao = dados_nf.get('tipo')

        # SE O MOVIMENTO E DE SAIDA E NAO FOI ALTERADO PELO WIZARD PARA ALTERAR VENDA,
        # BUSCA O PRECO DE VENDA
        if nf_tipo_movimentacao == 'S' and not context.get('preco_venda_fiscal') \
                and not context.get('fatura_pedido') and not nf_tipo_servico:
            preco = self.get_item_preco_venda(cr, uid, vals.get('produto_id'),
                                                       grade_id=vals.get('grade_id'),
                                                       company_id=None,
                                                       pessoa_id=destinatario_id,
                                                       context=context).get(vals.get('produto_id')) or {}
            valor_unitario = preco.get(vals.get('grade_id')) or preco.get('preco_venda') or 0
            qtde_embalagem = self.get_qtde_embalagem(cr, uid, vals.get('produto_embalagem_id'),
                                                     context=context)
            valor_unitario *= qtde_embalagem
        if any((context.get('vr_unitario', False),
                context.get('quantidade', False), context.get('vr_desconto', False))) and not \
                context.get('importacao_nfe'):
            vals['vr_unitario'] = valor_unitario

            if nf_tipo_movimentacao == 'S':
                vals['vr_total_item'] = valor_unitario * vals.get('quantidade') -\
                                        vals.get('vr_desconto')
        id = isinstance(ids, list) and ids[0] or ids
        dados_item = self.read(cr, uid, id, ['produto_embalagem_id', 'quantidade'], context=context,
                               load='_classic_write')
        if 'produto_embalagem_id' in vals:
            item_produto_embalagem_id = vals.get('produto_embalagem_id')
        else:
            item_produto_embalagem_id = dados_item.get('produto_embalagem_id')

        if 'quantidade' in vals:
            item_quantidade = vals.get('quantidade')
        else:
            item_quantidade = dados_item.get('quantidade')

        if 'quantidade' in vals or 'produto_embalagem_id' in vals\
                                                               and not context.get('fatura_pedido'):
            if item_produto_embalagem_id and item_quantidade:
                obj_est_produto_embalagem = self.pool.get('estoque.produto.embalagem')
                if isinstance(item_produto_embalagem_id, (tuple, list)):
                    produto_embalagem_id = item_produto_embalagem_id[0]
                else:
                    produto_embalagem_id = item_produto_embalagem_id
                quantidade_na_embalagem = obj_est_produto_embalagem.browse(cr, uid,
                                          produto_embalagem_id).embalagem_id.quantidade_na_embalagem
                vals['quantidade'] = item_quantidade * quantidade_na_embalagem

        p_id = vals.get('produto_id', False)
        produto = self.pool.get('estoque.produto').read(cr, uid, p_id, ['tipo'], context=context)
        # SE HOUVE ALGUMA ALTERACAO NA GRADE, A CHAVE grade_id ESTARA PRESENTE EM VALS
        if 'grade_id' in vals and not vals.get('grade_id') and produto.get('tipo') == 'P':
            raise osv.except_osv(_('Atencao'), _('A "GRADE" deve ser informada'))

        if 'locacao_id' in vals and vals.get('locacao_id'):
            # buscar local_id pelo locacao_id
            vals['local_id'] = self.pool.get('estoque.local.locacao').read(cr, uid,
                                             vals.get('locacao_id'), ['local_id'], context=context,
                                             load='_classic_write').get('local_id')

        if context.get('preco_venda_fiscal') and 'vr_preco_venda' in vals and not context.get('importacao_nfe'):
            vals['vr_unitario'] = vals['vr_preco_venda']

            if nf_tipo_movimentacao == 'S':
                vals['vr_total_item'] = vals['vr_unitario'] * item_quantidade - \
                                        vals.get('vr_desconto')

        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'fiscal', context=context):
            vals, context = _estmvi_write_fiscal(cr, uid, ids, vals, context=context)

        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'estoqueserie', context=context):
            _estmvi_write_estoqueserie(cr, uid, ids, vals, context=context)

        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'madeireira', context=context):
            if not context.get('terceiro') and not context.get('nf_servico'):
                vals, context = _estmvi_write_madeireira(cr, uid, ids, vals, context=context)

        # Joga a tributacao que sera excluida para o inicio da lista, evitando erro de gravar uma
        # tributacao com encargo que ja existe (Felipe)
        if 'tributacoes_ids' in vals:
            aux = []
            for i in vals.get('tributacoes_ids'):
                if i[0] == 2: # 2 = Tributacao a ser exluida
                    aux.append(i)
                    vals['tributacoes_ids'].remove(i)

            aux.extend(vals.get('tributacoes_ids'))
            vals['tributacoes_ids'] = aux

        return super(estoque_movimento_itens, self).write(cr, uid, ids, vals, context=context)

    def read(self, cr, uid, ids, fields=[], context=None, load='_classic_read'):
        context = context and context.copy() or {}
        # este contexto serve para melhorar a performace, tomar cuidado ao usa-lo
        if context.get('super_read_estoque_movimento_itens'):
            return super(estoque_movimento_itens, self).read(cr, uid, ids, fields, context=context,
                                                             load=load)

        if fields:
            if 'quantidade' not in fields:
                fields.append('quantidade')
            if 'produto_embalagem_id' not in fields:
                fields.append('produto_embalagem_id')

        res = super(estoque_movimento_itens, self).read(
            cr, uid, ids if isinstance(ids, list) else [ids], fields, context=context, load=load)
        obj_est_produto_embalagem = self.pool.get('estoque.produto.embalagem')

        for x in res:
            if x.get('produto_embalagem_id', False):
                if isinstance(x['produto_embalagem_id'], (tuple, list)):
                    produto_embalagem_id = x['produto_embalagem_id'][0]
                else:
                    produto_embalagem_id = x['produto_embalagem_id']
                quantidade_na_embalagem = obj_est_produto_embalagem.browse(
                    cr, uid, produto_embalagem_id).embalagem_id.quantidade_na_embalagem
                if quantidade_na_embalagem == 0:
                    quantidade_na_embalagem = 1
                x['quantidade'] = x['quantidade'] / quantidade_na_embalagem

        return res if isinstance(ids, list) else res[0]

    def estmvi_onchange_busca_grade(self, cr, uid, ids, produto_id, local_id, context=None):
        context = context and context.copy() or {}
        res = {}
        est_prod_grad_obj = self.pool.get('estoque.produto.grade')
        obj_estoque_local_locacao = self.pool.get('estoque.local.locacao')
        produto_grade_id = est_prod_grad_obj.search(cr, uid, [('produto_id', '=', produto_id)], context=context)

        if produto_grade_id and len(produto_grade_id) == 1:
            res['value'] = {'grade_id': produto_grade_id[0]}
        else:
            res['value'] = {'grade_id': ''}
        if produto_grade_id and produto_id:
            local_locacao_id = obj_estoque_local_locacao.search(cr, uid, [('produto_id', '=', produto_id),
                                                                          ('grade_id', '=', produto_grade_id[0]),
                                                                          ('local_id', '=', local_id)], context=context)
            if local_locacao_id:
                produto_embalagem_id = obj_estoque_local_locacao.browse(cr, uid, local_locacao_id[
                    0]).estllc_produto_embalagem_id.id or False
                res['value']['produto_embalagem_id'] = produto_embalagem_id
        else:
            res['value']['produto_embalagem_id'] = ''
        return res

    def estmvi_onchange_quantidade(self, cr, uid, ids, quantidade, produto_embalagem_id, context=None):
        context = context and context.copy() or {}
        res = {}
        fracao_unidade = False
        if produto_embalagem_id:
            obj_produto_embalagem = self.pool.get('estoque.produto.embalagem')
            embalagem_id = obj_produto_embalagem.browse(cr, uid, produto_embalagem_id).embalagem_id
            if embalagem_id:
                unidade_id = embalagem_id.unidade_id
                if unidade_id:
                    fracao_unidade = unidade_id.fracao or False
        if quantidade <= 0 or not fracao_unidade and isinstance(quantidade, float):
            res['warning'] = {'title': _('Atencao'), 'message': _('Informe uma quantidade valida.')}
            res['value'] = {'quantidade': ''}
        return res

    def estmvi_onchange_local(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = {
            'produto_id': '',
            'grade_id': '',
            'produto_embalagem_id': '',
        }
        return {'value': res}

    def fields_view_get(self, cr, uid, view_id=None, view_type='form', context=None, toolbar=False, submenu=False):
        def _estmvi_fields_view_get_fiscal(res, context):
            if context.get('exibe_tributos') and context.get('active_id'):
                res['fields']['tributacoes_ids']['views']['tree']['fields']['tributacao_id']['context']['active_id'] = \
                    context['active_id']
            return res

        context = context and context.copy() or {}
        res = super(estoque_movimento_itens, self).fields_view_get(cr, uid, view_id, view_type, context, toolbar,
                                                                   submenu)
        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'fiscal', context):
            res = _estmvi_fields_view_get_fiscal(res, context)
        return res

    def default_get(self, cr, uid, fields, context=None):
        def _estmvi_default_get_fiscal_inicial(fields):
            if not 'estmvi_state_nf' in fields:
                fields.append('estmvi_state_nf')
            return fields

        def _estmvi_default_get_fiscal_final(cr, uid, res, context):
            res['estmvi_item_nao_salvo'] = True
            if context.get('nf_id'):
                try:
                    if isinstance(context['nf_id'], (long, int)):
                        nf_id = context['nf_id']
                        browse_nf_capa = self.pool.get('fiscal.nf.capa').browse(cr, uid, nf_id)
                        res['estmvi_state_nf'] = False
                        if browse_nf_capa.natureza_id:
                            if browse_nf_capa.nf_propria and browse_nf_capa.tipo == 'S':
                                if browse_nf_capa.natureza_id.cfop_id.movimento_tipo == 'D' \
                                        and browse_nf_capa.state == '1':
                                    res['estmvi_state_nf'] = False
                                else:
                                    res['estmvi_state_nf'] = True
                            else:
                                if browse_nf_capa.state in ('2', '2E', '3'):
                                    res['estmvi_state_nf'] = True
                except:
                    return res
            return res

        context = context and context.copy() or {}
        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'fiscal', context):
            fields = _estmvi_default_get_fiscal_inicial(fields)
        res = super(estoque_movimento_itens, self).default_get(cr, uid, fields, context)
        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'fiscal', context):
            res = _estmvi_default_get_fiscal_final(cr, uid, res, context)
        return res

    def estmvi_onchange_qtde_valor_unitario(self, cr, uid, ids, produto_id, natureza_id, destinatario_id, tipo,
                                            quantidade=0, vr_unitario=0, vr_desconto=0, produto_embalagem_id=False,
                                            vr_total_item=0,
                                            context=None):
        def _estmvi_onchange_qtde_valor_unitario_fiscal(cr, uid, res, produto_id, natureza_id, destinatario_id, tipo,
                                                        quantidade, vr_unitario, vr_desconto, produto_embalagem_id,
                                                        vr_total_item,
                                                        context):
            if not produto_id:
                res['value'] = {}
                return res, context

            if isinstance(vr_total_item, dict):
                vr_total_item = vr_total_item.get('vr_total_item')
            if context.get('onchange_vr_total'):  # este contexo vem da nota de entrada de terceiros
                if vr_total_item and quantidade:
                    vr_unitario = float(vr_total_item + vr_desconto) / float(quantidade)
            if context.get('entrada_terceiros') and quantidade:
                if 'vr_total_item' in context:
                    vr_unitario = (float(context['vr_total_item']) + float(vr_desconto)) / float(quantidade)
                    res['value'].update({'vr_unitario': vr_unitario})
                    res['value'].update({'vr_total_item': context['vr_total_item']})
                else:
                    res['value'].update(
                        {'vr_total_item': context.get('vr_total_item') or 0, 'vr_unitario': vr_unitario})
            else:
                res['value'].update({'vr_total_item': (quantidade * vr_unitario) - vr_desconto})
            fracao_unidade = False
            mensagem = ''
            tipo_tributacao = ''
            if tipo == 'S':
                tipo_tributacao = 'T'
            elif tipo == 'E':
                tipo_tributacao = 'E'
                context.update({'onchange_terceiro': True})
            tributacoes_ids = context.get('tributacoes_ids')
            destinatario_endereco_id = context.get('destinatario_endereco_id', False)
            load = '_classic_write'
            campos = ['origem_mercadoria']
            dados_produto = self.pool.get('estoque.produto').read(cr, uid, produto_id, campos, context)
            obj_pessoa = self.pool.get('adm.pessoa')
            dados_destinatario = obj_pessoa.read(cr, uid, destinatario_id, ['cpf_cnpj', 'endereco_ids',
                                                                         'admpes_jur_tipo_atividade'],
                                                 context)
            if not destinatario_endereco_id:
                destinatario_endereco_id = dados_destinatario.get('endereco_ids') and \
                                           dados_destinatario.get('endereco_ids')[0]
            campos = ['cfop_id', 'natureza_encargos_ids', 'tipo']
            dados_natureza = self.pool.get('fiscal.cfop.natureza').read(cr, uid, natureza_id,
                                                                        campos,
                                                                        context, load)
            campos = ['movimento_tipo', 'codigo', 'sigla']
            dados_cfop_nat = self.pool.get('fiscal.cfop').read(cr, uid,
                                                               dados_natureza.get('cfop_id'),
                                                               campos, context)
            campos = ['encargo_id', 'sobrepor_tributacao_id', 'fiscne_sobrepoe_so_tributados']
            dados_nat_encargo = self.pool.get('fiscal.cfop.natureza.encargos').read(cr, uid,
                                 dados_natureza.get('natureza_encargos_ids'), campos, context, load)

            encargo_ids = map(lambda x: x.get('encargo_id'), dados_nat_encargo)
            dict_encargos_nat = {}
            map(lambda x: dict_encargos_nat.update({x.get('id'): x}),
                self.pool.get('fiscal.encargo').read(cr, uid, encargo_ids, ['sigla'], context))
            uf_id = False
            if destinatario_endereco_id:
                uf_id = self.pool.get('adm.pessoa.endereco').read(cr, uid, destinatario_endereco_id,
                                                              ['uf_id'], context, load).get('uf_id')
            res['value'].update(
                {'tributacoes_ids': self.calcular_tributo_itens(cr, uid,
                                                                dados_produto, dados_natureza,
                                                                dados_nat_encargo, dados_cfop_nat,
                                                                encargo_ids, dados_destinatario, tipo_tributacao,
                                                                res.get('value').get('vr_total_item'),
                                                                tributacoes_ids, uf_id=uf_id, context=context)})
            if produto_embalagem_id:
                embalagem_id = self.pool.get('estoque.produto.embalagem').browse(cr, uid,
                                                                                 produto_embalagem_id).embalagem_id
                if embalagem_id:
                    unidade_id = embalagem_id.unidade_id
                    if unidade_id:
                        fracao_unidade = unidade_id.fracao or False
            if quantidade:
                if not fracao_unidade and (int(quantidade) != quantidade) \
                        and not context.get('nf_servico'):
                    mensagem = _('A embalagem nao aceita fracionamento. \n')
                    res['value'].update({'quantidade': 0.0})
            if vr_desconto and vr_desconto < 0:
                mensagem = _('Valor do desconto invalido.')
            if mensagem:
                res['warning'] = {'title': _("Atencao"), 'message': mensagem}
            context.update({'vr_unitario': vr_unitario})
            return res, context

        def _estmvi_onchange_qtde_valor_unitario_madeireira(res, quantidade, vr_desconto, context):
            obj_madeireira_utils = self.pool.get('madeireira.utils')
            comprimento = context.get('comprimento', 0)
            largura = context.get('largura', 0)
            espessura = context.get('espessura', 0)
            volume = self.pool.get('madeireira.utils').madutl_calcula_volume(quantidade, comprimento, largura,
                                                                             espessura)
            if context.get('entrada_terceiros'):
                return res
            quantidade = volume or quantidade
            value = res.get('value')
            vr_unitario = value.get('vr_unitario') or 0.0
            if not vr_unitario:
                vr_unitario = context.get('vr_unitario') or 0.0
            if vr_unitario:
                res['value']['vr_unitario'] = vr_unitario
                res['value']['vr_total_item'] = (vr_unitario * quantidade) - vr_desconto
            res['value'].update({'estmvi_volume': volume})
            return res

        context = context and context.copy() or {}
        res = {'value': {}, 'warning': {}}
        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'fiscal', context):
            res, context = _estmvi_onchange_qtde_valor_unitario_fiscal(cr, uid, res, produto_id, natureza_id,
                                                                       destinatario_id, tipo,
                                                                       quantidade, vr_unitario, vr_desconto,
                                                                       produto_embalagem_id, vr_total_item,
                                                                       context)
        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'madeireira', context):
            res = _estmvi_onchange_qtde_valor_unitario_madeireira(res, quantidade, vr_desconto, context)
        return res

    def onchange_produto_embalagem_propria(self, cr, user, ids, company_id, local_id, nf_tipo,
                                           produto_id, embalagem_id, pessoa_id=False, quantidade=0,
                                           natureza_id=False, grade_id=False, vr_desconto=0,
                                           vr_total_item=0, context=None):
        quantidade = 1 if not embalagem_id else quantidade

        # Verifica se a embalagem permite fracionamento
        estoque_embalagem_id = embalagem_id and self.pool.get('estoque.produto.embalagem').read(
            cr, user, embalagem_id, ['embalagem_id'], context, '_classic_write').get(
            'embalagem_id') or False
        unidade_dados = estoque_embalagem_id and self.pool.get('estoque.embalagem').read(
            cr, user, estoque_embalagem_id, ['unidade_id', 'quantidade_na_embalagem'], context,
            '_classic_write')
        unidade_id = unidade_dados and unidade_dados.get('unidade_id')
        qtde_embalagem = unidade_dados and unidade_dados.get('quantidade_na_embalagem') or 1
        fracao = unidade_id and self.pool.get('estoque.embalagem.unidade').read(
            cr, user, unidade_id, ['fracao'], context).get('fracao') or False
        if fracao and int(quantidade) != quantidade:
            return {'value': {'produto_embalagem_id': False, 'quantidade': 1, 'vr_unitario': 0},
                    'warning': {'title': _('Aviso.'),
                                'message': _('Unidade nao permite quantidade fracionada.')}}

        # Valor unitario
        item_id = embalagem_id and self.pool.get('estoque.produto.grade').read(
            cr, user, grade_id, ['produto_id'], context, '_classic_write').get('produto_id')
        preco_dados = item_id and self.pool.get('estoque.preco.venda').get_preco_venda(
            cr, user, item_id, epc_grade_ids=grade_id, context=context) or {}
        vr_preco_venda = preco_dados and preco_dados.get(item_id).get(grade_id) or 0
        vr_preco_venda *= qtde_embalagem

        return {'value': {'vr_unitario': vr_preco_venda}}

    def onchange_produto_embalagem(self, cr, uid, ids, company_id, nf_tipo_movimentacao, produto_id,
                                   produto_embalagem_id, vr_preco_venda, pessoa_id=None,
                                   quantidade=0, natureza_id=False, grade_id=False, vr_desconto=0,
                                   vr_total_item=0, local_id=False, context=None):
        context = context and context.copy() or {}
        if all([produto_id, grade_id]):
            preco = self.get_item_preco_venda(cr, uid, produto_id, grade_id=grade_id,
                                              company_id=company_id,
                                              pessoa_id=pessoa_id, context=context).get(produto_id) or {}
            vr_preco_venda = preco.get(grade_id) or preco.get('preco_venda') or 0

        if produto_embalagem_id:
            brw_produto_embalagem = self.pool.get('estoque.produto.embalagem').browse(cr, uid, produto_embalagem_id,
                                                              context=context)
            if not brw_produto_embalagem.embalagem_id.unidade_id.fracao and int(quantidade) != quantidade:
                return dict(value=dict(quantidade=1),
                            warning=dict(title=_('Atencao!'),
                                         message=_('Unidade da embalagem nao permite quantidade fracionada!')))

        def _estmvi_onchange_produto_embalagem_fiscal(
                cr, uid, res, company_id, nf_tipo_movimentacao, produto_id, produto_embalagem_id,
                vr_preco_venda, pessoa_id, vr_desconto, vr_total_item, context):
            if produto_id:
                val = self.calcula_vr_produto_embalagem(
                    cr, uid, company_id, nf_tipo_movimentacao, produto_id, produto_embalagem_id,
                    pessoa_id, natureza_id, grade_id, quantidade, vr_desconto,
                    vr_total_item, context=context)
                res['value'].update(val)
            return res

        def _estmvi_onchange_produto_embalagem_madeireira_inicial(cr, uid, produto_id,
                                                                  produto_embalagem_id, vr_preco_venda, quantidade,
                                                                  context):
            obj_madeireira_utils = self.pool.get('madeireira.utils')
            sigla = ''
            if produto_embalagem_id:
                embalagem_id = brw_produto_embalagem.embalagem_id
                if embalagem_id:
                    sigla = embalagem_id.sigla or ''
            comprimento = context.get('comprimento') or 0
            largura = context.get('largura') or 0
            espessura = context.get('espessura') or 0
            if sigla == 'M2':
                espessura = 0
            elif sigla == 'ML':
                largura = espessura = 0
            elif sigla != 'M3':
                comprimento = largura = espessura = 0
            obj_madeireira_utils = self.pool.get('madeireira.utils')
            volume = obj_madeireira_utils.madutl_calcula_volume(quantidade, comprimento, largura, espessura)
            quantidade = volume or quantidade
            if produto_id:
                valida_variacao = obj_madeireira_utils.madpro_valida_variacao(cr, uid, produto_id,
                                                                              comprimento,
                                                                              espessura,
                                                                              context)
                vr_variacao = valida_variacao.get('vr_variacao', 0)
            if vr_preco_venda:
                vr_preco_venda = obj_madeireira_utils.madutl_get_valor_com_fator(
                    cr, uid, produto_id, vr_variacao or 0, pessoa_id, context
                )
            return vr_preco_venda, espessura, largura, comprimento, volume, sigla

        def _estmvi_onchange_produto_embalagem_madeireira_final(espessura, largura, comprimento,
                                                                volume, sigla, res):
            res['value']['estmvi_sigla_embalagem'] = sigla
            res['value']['estmvi_volume'] = volume
            res['value']['estmvi_comprimento'] = comprimento
            res['value']['estmvi_largura'] = largura
            res['value']['estmvi_espessura'] = espessura
            return res

        context = context and context.copy() or {}
        res = {'value': {}, 'warning': {}}
        _madeireira_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'madeireira', context)
        if _madeireira_instalado:
            vr_preco_venda, espessura, largura, comprimento, volume, sigla = (
                _estmvi_onchange_produto_embalagem_madeireira_inicial(cr, uid, produto_id,
                                                                      produto_embalagem_id,
                                                                      vr_preco_venda, quantidade,
                                                                      context)
            )
        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'fiscal', context):
            res = _estmvi_onchange_produto_embalagem_fiscal(
                cr, uid, res, company_id, nf_tipo_movimentacao, produto_id, produto_embalagem_id,
                vr_preco_venda, pessoa_id, vr_desconto, vr_total_item, context)
        if _madeireira_instalado:
            res = _estmvi_onchange_produto_embalagem_madeireira_final(espessura, largura, comprimento,
                                                                      volume, sigla, res)
        return res

    def estmvi_onchange_item_movimento_manutencao(self, cr, user, ids, item, context=None):
        """
        Ajusta o valor da grade em funcao do item.

        :param cr: o cursor do banco de dados
        :param user: o ID do usuario utilizado para a verificacao de perfil
        :param ids: lista com o ID do item de movimentacao
        :param item: o ID do item
        :param context: um dicionario padrao para valores contextuais,
        :type cr: object
        :type user: int
        :type ids: list
        :type item: long
        :type context: dict
        :return: o ID da grade relacionada ao produto
        :rtype: float

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """
        context = context and context.copy() or dict()
        grade_ids = self.pool.get('estoque.produto.grade').search(
            cr, user, [('produto_id', '=', item)], context=context)
        grade_id = grade_ids[0] if len(grade_ids) == 1 else False

        return dict(value=dict(grade_id=grade_id))

    def estmvi_onchange_local_manutencao(self, cr, user, ids, local, context=None):
        """
        Ajusta o valor do item em funcao do local.

        :param cr: o cursor do banco de dados
        :param user: o ID do usuario utilizado para a verificacao de perfil
        :param ids: lista com o ID do item de movimentacao
        :param local: o ID do local
        :param context: um dicionario padrao para valores contextuais,
        :type cr: object
        :type user: int
        :type ids: list
        :type local: long
        :type context: dict
        :return: nenhum item (produto_id = False).
        :rtype: float

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """
        context = context and context.copy() or dict()

        return dict(value=dict(produto_id=False))

    def estmvi_onchange_item_movimento(self, cr, uid, ids, empresa, natureza, nf_tipo, destinatario,
                                       item, local, preco_venda, total, nf_propria, nf_devolucao,
                                       endereco=False, grade_id=False, tributacao=None,
                                       context=None):
        context = context and context.copy() or {}
        res = {'value': {}, 'warning': {}}

        # Mostra a grade se o produto tiver apenas uma
        grade_ids = self.pool.get('estoque.produto.grade').search(
            cr, uid, [('produto_id', '=', item)], context=context)
        if len(grade_ids) == 1:
            res['value']['grade_id'] = grade_ids[0]
        else:
            res['value']['grade_id'] = False

        # Saldo do produto (todas as grades)
        saldos = grade_ids and self.pool.get('estoque.produto.saldo').get_saldo_do_dia(
            cr, uid, grade_ids, str(datetime.now())[:10], local, context=context) or dict()
        saldo = saldos and sum([saldos[x].get('saldo') or 0 for x in saldos]) or 0
        res['value']['estmvi_saldo'] = saldo

        return res

    @staticmethod
    def estmvi_get_data_ultima_entrada(cr, local=False, produto=False, grade=False,
                                       company_id=False):
        """
        Recupera a data da ultima entrada de um produto (item). Metodo sobrescrito no modulo fiscal.

        :param cr: cursor do banco de dados
        :param local: lista com ID do local a ser consultado
        :param produto: lista com ID dos produtos a serem consultados
        :param grade:  lista com o ID das grades dos produtos a serem consultados
        :param company_id: id da tabela res_company, identificador da empresa
        :type cr: cursor
        :type local: long|list[long]
        :type produto: long|list[long]
        :type grade: long|list[long]
        :type company_id: int
        :return: lista de dicionarios com os dados do produt, grade, local e ultima data de entrada
        :rtype: list[dict]

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        sql = """
            SELECT emi.produto_id
                 , emi.grade_id
                 , emi.local_id
                 , MAX(emc.data)                AS ult_entrada
            FROM   estoque_movimento_capa       AS emc
            INNER  JOIN estoque_movimento_itens AS emi ON emc.id = emi.capa_id
            WHERE  emc.estmvc_operacao_id IN (
                       SELECT id
                       FROM estoque_natureza_operacao
                       WHERE estnto_tipo_operacao = 'E'
                         AND estnto_atualizar_saldo = True
                         AND active = True
                         AND estnto_movimento_origem_id IN (
                            Select id from estoque_movimento_origem
                                WHERE estmog_codigo = 'N')
                   )
        """
        if company_id:
            sql += """
                AND emc.company_id = %s
            """ % company_id

        if local:
            sql += """
              AND  emi.local_id = %s
            """ % local

        if produto:
            sql += """
              AND  emi.produto_id IN (%s)
            """ % ', '.join(
                [str(_id) for _id in (produto if isinstance(produto, list) else [produto])])

        if grade:
            sql += """
              AND  emi.grade_id IN (%s)
            """ % ', '.join(
                [str(_id) for _id in (grade if isinstance(grade, list) else [grade])])

        sql += """
            GROUP BY emi.local_id, emi.produto_id, emi.grade_id
        """
        cr.execute(sql)

        return cr.dictfetchall() or [{}]

    @staticmethod
    def estmvi_get_quantidade_entrada(cr, dt_inicio, dt_fim, local=False, company=False,
                                      produto=False, grade=False):
        """
        Recupera ultima quantidade de entrada para um determinado produto (item).  Metodo
        sobrescrito no modulo fiscal.

        :param cr: cursor do banco de dados
        :param local: lista com ID do local a ser consultado
        :param produto: lista com ID dos produtos a serem consultados
        :param grade:  lista com o ID das grades dos produtos a serem consultados
        :type cr: cursor
        :type local: long|list[long]
        :type produto: long|list[long]
        :type grade: long|list[long]
        :return: lista de dicionarios com os dados do produt, grade, local e ultima data de entrada
        :rtype: list[dict]

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        sql = """
            SELECT emi.produto_id
                 , emi.grade_id
                 , emi.quantidade         AS quantidade
            FROM   estoque_movimento_itens     AS emi
            INNER  JOIN estoque_movimento_capa AS emc ON emi.capa_id = emc.id
            WHERE  emc.estmvc_origem = 'N'
        """

        if local:
            sql += """
              AND  emi.local_id IN (%s)
            """ % ', '.join(
                [str(_id) for _id in (local if isinstance(local, list) else [local])])

        if company:
            sql += """
              AND  emc.company_id IN (%s)
            """ % ', '.join(
                [str(_id) for _id in (company if isinstance(company, list) else [company])])

        sql += """
              AND  emc.estmvc_operacao_id in (
                       SELECT id
                       FROM   estoque_natureza_operacao
                       WHERE  estnto_tipo_operacao = 'E'
                         AND  estnto_atualizar_saldo = True
                         AND  active = True
                   )
              AND  emc.data BETWEEN '%s' AND '%s'
        """ % (dt_inicio, dt_fim)

        if produto:
            sql += """
              AND  emi.produto_id IN (%s)
            """ % ', '.join(
                [str(_id) for _id in (produto if isinstance(produto, list) else [produto])])

        if grade:
            sql += """
              AND  emi.grade_id = (%s)
            """ % ', '.join(
                [str(_id) for _id in (grade if isinstance(grade, list) else [grade])])

        sql += """
            --GROUP BY emi.local_id, emi.produto_id, emi.grade_id
            ORDER BY emi.id desc
            LIMIT 1
        """

        cr.execute(sql)

        return cr.dictfetchall() or [{}]

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
