# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time
from openerp.tools.translate import _
import sys
import openerp

READ_LOAD = '_classic_write'


class estoque_parametro(osv.Model):
    _name = 'estoque.parametro'
    _inherit = 'estoque.parametro'

    def estpar_get_company_id(self, cr, uid, args=None, context=None):
        context = context and context.copy() or {}
        estpar_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'estoque.parametro', args,
                                                                           context=context)
        return estpar_company_id

    def estpar_get_id(self, cr, uid, context=None):
        context = context and context.copy() or {}

        company_id = self.estpar_get_company_id(cr, uid, context=context)
        estpar_ids = self.search(cr, uid, [('company_id', '=', company_id)], context=context)
        return estpar_ids

    def estpar_get_fields(self, cr, uid, fields_to_read=None, context=None):
        context = context and context.copy() or {}
        if not isinstance(fields_to_read, list):
            fields_to_read = []
        context = context and context.copy() or {}

        estpar_ids = self.estpar_get_id(cr, uid, context)
        if not estpar_ids:
            raise osv.except_osv(_('Atencao'), _('Nenhum parametro do estoque cadastrado para a empresa logada!'))
        estpar_dados = self.read(cr, uid, estpar_ids, fields_to_read, context=context, load=READ_LOAD)
        if not isinstance(estpar_dados, list):
            estpar_dados = [estpar_dados]
        return estpar_dados

    def ler(self, cr, uid, args=[], context=None):
        context = context and context.copy() or {}
        if args == []:
            company_id = self.estpar_get_company_id(cr, uid, context=context)
            args = [('company_id', '=', company_id)]
        try:
            ids = self.search(cr, uid, args, context=context)
            vals = self.read(cr, uid, ids, [], context=context)
            return vals
        except:
            return []

    def get_indexador_para_hoje(self, cr, uid, context=None):
        context = context and context.copy() or {}
        company_id = self.estpar_get_company_id(cr, uid, context=context)
        args = [('company_id', '=', company_id)]
        ids = self.search(cr, uid, args, context=context)
        if ids:
            moeda_id = self.read(cr, uid, ids[0], ['indexador_id'], context=context)['indexador_id']
            if moeda_id:
                moeda_valor_id = self.pool.get('adm.moeda.valor').search(cr, uid, [('moeda_id', '=', moeda_id[0]),
                                                                                   ('data_movimento', '<=',
                                                                                    time.strftime(
                                                                                        '%Y-%m-%d %H:%M:%S'))],
                                                                         order='data_movimento', limit=1,
                                                                         context=context)
                if moeda_valor_id:
                    return \
                    self.pool.get('adm.moeda.valor').read(cr, uid, moeda_valor_id[0], ['valor'], context=context)[
                        'valor']
                else:
                    return 1
        else:
            return 1

    def onchange_codigo_numerico(self, cr, uid, ids, codigo_numerico):
        usa_digito = True
        if not codigo_numerico:
            usa_digito = False
        return {'value': {'usa_digito': usa_digito}}

    def estpar_converte_formato_impressao(self, cr, uid, formato_impressao, path, tipo,
                                          modo_impressao=False):
        """
        O metodo altera dentro do proprio arquivo rml do relatorio de orcamentos/pedidos, o seu
        formato de impressao.
        @param cr: cursor do banco de dados
        @param uid: id do usuario
        @param formato_impressao: '1' representa o A4 e '2' representa meia pagina de A4
        @param path: caminho do arquivo rml dentro do sigaddons
        @param tipo: 'p', para pedidos e 'o', para orcamentos
        @param modo_impressao: 'P' para paisagem e 'R' para retrato
        @return: True
        """
        openerp.tools.config.parse_config(sys.argv[1:])
        config = openerp.tools.config
        addons_path = config['addons_path']
        addons_path += path
        rel_rml = open(addons_path, 'r')
        rel_str = rel_rml.read()
        rel_rml.close()

        if formato_impressao == '2':
            rel_str = rel_str.replace('pageSize="(29.7cm, 21cm)"', 'pageSize="(21cm, 14.8cm)"')
            rel_str = rel_str.replace('pageSize="(21cm, 29.7cm)"', 'pageSize="(21cm, 14.8cm)"')

            rel_str = rel_str.replace(
                '<drawCentredString x="10.5cm" y="0.5cm">',
                '<drawCentredString x="10.5cm" y="1cm">')

            rel_str = rel_str.replace(
                '<frame id="first" x1="1cm" y1="2cm" width="19cm" height="27.4cm"/>',
                '<frame id="first" x1="1cm" y1="2cm" width="19cm" height="12.8cm"/>')

            rel_str = rel_str.replace('<drawString x="530" y="820">',
                                      '<drawString x="530" y="403">')

            if modo_impressao == 'P' or formato_impressao == 2:
                rel_str = rel_str.replace('pageSize="(14.8cm, 21cm)"', 'pageSize="(21cm, 14.8cm)"')

                rel_str = rel_str.replace('<drawString x="530" y="830">',
                                          '<drawString x="530" y="403">')
                rel_str = rel_str.replace('<drawString x="360" y="580">',
                                          '<drawString x="530" y="403">')
                rel_str = rel_str.replace('<drawString x="730" y="565">',
                                          '<drawString x="530" y="403">')
                rel_str = rel_str.replace('<drawString x="384" y="580">',
                                          '<drawString x="530" y="403">')

                rel_str = rel_str.replace('<drawCentredString x="10.5cm" y="15.8cm">',
                                          '<drawCentredString x="10.5cm" y="1cm">')
                rel_str = rel_str.replace('<drawCentredString x="7.4cm" y="1cm">',
                                          '<drawCentredString x="10.5cm" y="1cm">')
                rel_str = rel_str.replace('<drawCentredString x="14.8cm" y="1cm">',
                                          '<drawCentredString x="10.5cm" y="1cm">')

                rel_str = rel_str.replace(
                    '<frame id="first" x1="1cm" y1="15.8cm" width="19cm" height="13.8cm"/>',
                    '<frame id="first" x1="1cm" y1="2cm" width="19cm" height="12.8cm"/>')
                rel_str = rel_str.replace(
                    '<frame id="first" x1="0.4cm" y1="2cm" width="14.1cm" height="19cm"/>',
                    '<frame id="first" x1="1cm" y1="2cm" width="19cm" height="12.8cm"/>')
                rel_str = rel_str.replace(
                    '<frame id="first" x1="0.3cm" y1="1.5cm" width="28.7cm" height="19cm"/>',
                    '<frame id="first" x1="1cm" y1="2cm" width="19cm" height="12.8cm"/>')

                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="80,255,65" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="80,395,80" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="160,465,160" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="80,395,80" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="248,132,57,40,62,82,82,82" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="210,100,25,40,30,50,50,50" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="5" colWidths="288,132,57,62,82,82,82" style="tableMain">',
                    '<blockTable repeatRows="5" colWidths="250,100,25,30,50,50,50" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="120,70,20,40,30,45,40,40" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="210,100,25,40,30,50,50,50" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="6" colWidths="200,75,25,28,33,28,37,48,43,48" style="tableMain">',
                    '<blockTable repeatRows="6" colWidths="100,58,48,40,45,40,49,60,55,60" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="6" colWidths="220,75,50,53,58,53,62,73,68,73" style="tableMain">',
                    '<blockTable repeatRows="6" colWidths="100,58,48,40,45,40,49,60,55,60" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="6" colWidths="100,48,20,23,30,23,32,43,38,43" style="tableMain">',
                    '<blockTable repeatRows="6" colWidths="100,58,48,40,45,40,49,60,55,60" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="5" colWidths="160,70,20,30,40,40,40" style="tableMain">',
                    '<blockTable repeatRows="5" colWidths="250,100,25,30,50,50,50" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="134,22,25,30,25,34,45,40,45" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="169,37,40,45,40,49,60,55,60" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="295,50,53,58,53,62,73,68,73" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="169,37,40,45,40,49,60,55,60" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="95,60,25,40,30,50,50,50" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="210,100,25,40,30,50,50,50" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="5" colWidths="135,60,25,30,50,50,50" style="tableMain">',
                    '<blockTable repeatRows="5" colWidths="250,100,25,30,50,50,50" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="230,120,63,40,68,88,88,88" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="210,100,25,40,30,50,50,50" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="5" colWidths="270,120,63,68,88,88,88" style="tableMain">',
                    '<blockTable repeatRows="5" colWidths="250,100,25,30,50,50,50" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="288,132,57,62,82,82,82" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="250,100,25,30,50,50,50" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="160,70,20,30,40,40,40" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="250,100,25,30,50,50,50" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="135,60,25,30,50,50,50" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="250,100,25,30,50,50,50" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="270,120,63,68,88,88,88" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="250,100,25,30,50,50,50" style="tableMain">'
                )

                rel_str = rel_str.replace(
                    '<blockTable colWidths="405" style="tableDateHour">',
                    '<blockTable colWidths="555" style="tableDateHour">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="785" style="tableDateHour">',
                    '<blockTable colWidths="555" style="tableDateHour">')

                rel_str = rel_str.replace('<blockTable colWidths="285,285," style="tableSeller">',
                                          '<blockTable colWidths="277,278" style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="392,393" style="tableSeller">',
                                          '<blockTable colWidths="277,278," style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="200,205" style="tableSeller">',
                                          '<blockTable colWidths="277,278" style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="290,250,40" style="tableSeller">',
                                          '<blockTable colWidths="257,258,40" style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="200,160,40" style="tableSeller">',
                                          '<blockTable colWidths="257,258,40" style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="280,250,40" style="tableSeller">',
                                          '<blockTable colWidths="257,258,40" style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="375,370,40" style="tableSeller">',
                                          '<blockTable colWidths="257,258,40" style="tableSeller">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="100,100,60,60,75" style="tableCondition">',
                    '<blockTable colWidths="132,132,92,92,107" style="tableCondition">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="178,178,138,138,153" style="tableCondition">',
                    '<blockTable colWidths="132,132,92,92,107" style="tableCondition">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="101,101,61,61,81" style="tableCondition">',
                    '<blockTable colWidths="132,132,92,92,107" style="tableCondition">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="205,205,70,85" style="tableCondition">',
                    '<blockTable colWidths="165,165,95,130" style="tableCondition">'
                )
                rel_str = rel_str.replace(
                    '<blockTable colWidths="120,120,70,90" style="tableCondition">',
                    '<blockTable colWidths="165,165,95,130" style="tableCondition">'
                )
                rel_str = rel_str.replace(
                    '<blockTable colWidths="250,250,110,175" style="tableCondition">',
                    '<blockTable colWidths="165,165,95,130" style="tableCondition">'
                )

                rel_str = rel_str.replace('<blockTable colWidths="580" style="tableDefault">',
                                          '<blockTable colWidths="555" style="tableDefault">')
                rel_str = rel_str.replace('<blockTable colWidths="570" style="tableDefault">',
                                          '<blockTable colWidths="555" style="tableDefault">')
                rel_str = rel_str.replace('<blockTable colWidths="785" style="tableDefault">',
                                          '<blockTable colWidths="555" style="tableDefault">')
                rel_str = rel_str.replace('<blockTable colWidths="405" style="tableDefault">',
                                          '<blockTable colWidths="555" style="tableDefault">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="80,485" style="tableCompany">',
                    '<blockTable colWidths="80,475" style="tableCompany">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="80,325" style="tableCompany">',
                    '<blockTable colWidths="80,475" style="tableCompany">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="80,705" style="tableCompany">',
                    '<blockTable colWidths="80,475" style="tableCompany">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="580" style="tableClient">',
                    '<blockTable colWidths="569" style="tableClient">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="280,125" style="tableClient">',
                    '<blockTable colWidths="376,193" style="tableClient">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="403,382" style="tableClient">',
                    '<blockTable colWidths="376,193" style="tableClient">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="120,130,150" style="tableInfo">',
                    '<blockTable colWidths="172,188,195" style="tableInfo">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="230,260,295" style="tableInfo">',
                    '<blockTable colWidths="172,188,195" style="tableInfo">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="405" style="tableObservacoes">',
                    '<blockTable colWidths="555" style="tableObservacoes">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="785" style="tableObservacoes">',
                    '<blockTable colWidths="555" style="tableObservacoes">')
            elif modo_impressao == 'R':
                rel_str = rel_str.replace('pageSize="(21cm, 14.8cm)"', 'pageSize="(14.8cm, 21cm)"')

                rel_str = rel_str.replace('<drawString x="530" y="830">',
                                          '<drawString x="530" y="403">')
                rel_str = rel_str.replace('<drawString x="384" y="580">',
                                          '<drawString x="530" y="403">')
                rel_str = rel_str.replace('<drawString x="530" y="403">',
                                          '<drawString x="360" y="580">')
                rel_str = rel_str.replace('<drawString x="730" y="565">',
                                          '<drawString x="360" y="580">')
                if tipo == 'o':
                    rel_str = rel_str.replace('<drawString x="360" y="580">',
                                              '<drawString x="384" y="580">')

                rel_str = rel_str.replace('<drawCentredString x="10.5cm" y="15.8cm">',
                                          '<drawCentredString x="10.5cm" y="1cm">')
                rel_str = rel_str.replace('<drawCentredString x="7.4cm" y="1cm">',
                                          '<drawCentredString x="10.5cm" y="1cm">')
                rel_str = rel_str.replace('<drawCentredString x="10.5cm" y="1cm">',
                                          '<drawCentredString x="7.4cm" y="1cm">')
                rel_str = rel_str.replace('<drawCentredString x="14.8cm" y="1cm">',
                                          '<drawCentredString x="7.4cm" y="1cm">')

                rel_str = rel_str.replace(
                    '<frame id="first" x1="1cm" y1="15.8cm" width="19cm" height="13.8cm"/>',
                    '<frame id="first" x1="1cm" y1="2cm" width="19cm" height="12.8cm"/>')
                rel_str = rel_str.replace(
                    '<frame id="first" x1="0.4cm" y1="2cm" width="14.1cm" height="19cm"/>',
                    '<frame id="first" x1="1cm" y1="2cm" width="19cm" height="12.8cm"/>')
                rel_str = rel_str.replace(
                    '<frame id="first" x1="1cm" y1="2cm" width="19cm" height="12.8cm"/>',
                    '<frame id="first" x1="0.4cm" y1="2cm" width="14.1cm" height="19cm"/>')
                rel_str = rel_str.replace(
                    '<frame id="first" x1="0.3cm" y1="1.5cm" width="28.7cm" height="19cm"/>',
                    '<frame id="first" x1="0.4cm" y1="2cm" width="14.1cm" height="19cm"/>')

                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="80,395,80" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="80,255,65" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="288,132,57,62,82,82,82" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="160,70,20,30,40,40,40" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="5" colWidths="288,132,57,62,82,82,82" style="tableMain">',
                    '<blockTable repeatRows="5" colWidths="160,70,20,30,40,40,40" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="210,100,25,40,30,50,50,50" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="120,70,20,40,30,45,40,40" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="5" colWidths="250,100,25,30,50,50,50" style="tableMain">',
                    '<blockTable repeatRows="5" colWidths="160,70,20,30,40,40,40" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="275,25,28,33,28,37,48,43,48" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="134,22,25,30,25,34,45,40,45" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="295,50,53,58,53,62,73,68,73" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="134,22,25,30,25,34,45,40,45" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="169,37,40,45,40,49,60,55,60" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="134,22,25,30,25,34,45,40,45" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="6" colWidths="200,75,25,28,33,28,37,48,43,48" style="tableMain">',
                    '<blockTable repeatRows="6" colWidths="100,48,20,23,30,23,32,43,38,43" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="6" colWidths="100,58,48,40,45,40,49,60,55,60" style="tableMain">',
                    '<blockTable repeatRows="6" colWidths="100,48,20,23,30,23,32,43,38,43" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="6" colWidths="220,75,50,53,58,53,62,73,68,73" style="tableMain">',
                    '<blockTable repeatRows="6" colWidths="100,48,20,23,30,23,32,43,38,43" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="210,100,25,40,30,50,50,50" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="95,60,25,40,30,50,50,50" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="5" colWidths="250,100,25,30,50,50,50" style="tableMain">',
                    '<blockTable repeatRows="5" colWidths="135,60,25,30,50,50,50" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="6" colWidths="390,63,68,88,88,88" style="tableMain">',
                    '<blockTable repeatRows="6" colWidths="195,25,30,50,50,50" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="250,100,25,30,50,50,50" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="160,70,20,30,40,40,40" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="250,100,25,30,50,50,50" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="135,60,25,30,50,50,50" style="tableMain">'
                )

                rel_str = rel_str.replace('<blockTable colWidths="285,285" style="tableSeller">',
                                          '<blockTable colWidths="200,205" style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="277,278" style="tableSeller">',
                                          '<blockTable colWidths="200,205" style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="290,250,40" style="tableSeller">',
                                          '<blockTable colWidths="200,160,40" style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="280,250,40" style="tableSeller">',
                                          '<blockTable colWidths="200,160,40" style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="257,258,40" style="tableSeller">',
                                          '<blockTable colWidths="200,160,40" style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="375,370,40" style="tableSeller">',
                                          '<blockTable colWidths="200,160,40" style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="270,260,40" style="tableSeller">',
                                          '<blockTable colWidths="200,160,40" style="tableSeller">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="100,100,60,60,75" style="tableCondition">',
                    '<blockTable colWidths="101,101,61,61,81" style="tableCondition">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="132,132,92,92,107" style="tableCondition">',
                    '<blockTable colWidths="101,101,61,61,81" style="tableCondition">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="178,178,138,138,153" style="tableCondition">',
                    '<blockTable colWidths="101,101,61,61,81" style="tableCondition">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="205,205,70,85" style="tableCondition">',
                    '<blockTable colWidths="120,120,70,90" style="tableCondition">'
                )
                rel_str = rel_str.replace(
                    '<blockTable colWidths="250,250,110,175" style="tableCondition">',
                    '<blockTable colWidths="120,120,70,90" style="tableCondition">'
                )
                rel_str = rel_str.replace(
                    '<blockTable colWidths="170,170,90,125" style="tableCondition">',
                    '<blockTable colWidths="120,120,70,90" style="tableCondition">'
                )
                rel_str = rel_str.replace(
                    '<blockTable colWidths="165,165,95,130" style="tableCondition">',
                    '<blockTable colWidths="120,120,70,90" style="tableCondition">'
                )

                rel_str = rel_str.replace('<blockTable colWidths="570" style="tableDefault">',
                                          '<blockTable colWidths="405" style="tableDefault">')
                rel_str = rel_str.replace('<blockTable colWidths="555" style="tableDefault">',
                                          '<blockTable colWidths="405" style="tableDefault">')
                rel_str = rel_str.replace('<blockTable colWidths="785" style="tableDefault">',
                                          '<blockTable colWidths="405" style="tableDefault">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="555" style="tableDateHour">',
                    '<blockTable colWidths="405" style="tableDateHour">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="80,485" style="tableCompany">',
                    '<blockTable colWidths="80,325" style="tableCompany">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="80,475" style="tableCompany">',
                    '<blockTable colWidths="80,325" style="tableCompany">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="80,705" style="tableCompany">',
                    '<blockTable colWidths="80,325" style="tableCompany">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="376,193" style="tableClient">',
                    '<blockTable colWidths="280,125" style="tableClient">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="386,193" style="tableClient">',
                    '<blockTable colWidths="280,125" style="tableClient">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="403,382" style="tableClient">',
                    '<blockTable colWidths="280,125" style="tableClient">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="782" style="tableClient">',
                    '<blockTable colWidths="405" style="tableClient">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="172,188,195" style="tableInfo">',
                    '<blockTable colWidths="120,130,150" style="tableInfo">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="555" style="tableObservacoes">',
                    '<blockTable colWidths="405" style="tableObservacoes">')
        else:
            rel_str = rel_str.replace('pageSize="(14.8cm, 21cm)"', 'pageSize="(21cm, 29.7cm)"')
            rel_str = rel_str.replace('pageSize="(21cm, 14.8cm)"', 'pageSize="(21cm, 29.7cm)"')

            rel_str = rel_str.replace(
                '<drawCentredString x="10.5cm" y="1cm">',
                '<drawCentredString x="10.5cm" y="0.5cm">')

            rel_str = rel_str.replace(
                '<frame id="first" x1="1cm" y1="2cm" width="19cm" height="12.8cm"/>',
                '<frame id="first" x1="1cm" y1="2cm" width="19cm" height="27.4cm"/>')

            rel_str = rel_str.replace('<drawString x="530" y="403">',
                                      '<drawString x="530" y="820">')

            if modo_impressao == 'P':
                rel_str = rel_str.replace('pageSize="(21cm, 29.7cm)"', 'pageSize="(29.7cm, 21cm)"')

                rel_str = rel_str.replace('<drawString x="530" y="830">',
                                          '<drawString x="730" y="565">')
                rel_str = rel_str.replace('<drawString x="384" y="580">',
                                          '<drawString x="730" y="565">')
                rel_str = rel_str.replace('<drawString x="350" y="580">',
                                          '<drawString x="730" y="565">')
                rel_str = rel_str.replace('<drawString x="530" y="820">',
                                          '<drawString x="730" y="565">')
                rel_str = rel_str.replace('<drawString x="360" y="580">',
                                          '<drawString x="730" y="565">')

                rel_str = rel_str.replace('<drawCentredString x="10.5cm" y="15.8cm">',
                                          '<drawCentredString x="14.8cm" y="1cm">')
                rel_str = rel_str.replace('<drawCentredString x="7.4cm" y="1cm">',
                                          '<drawCentredString x="14.8cm" y="1cm">')
                rel_str = rel_str.replace('<drawCentredString x="10.5cm" y="0.5cm">',
                                          '<drawCentredString x="14.8cm" y="1cm">')

                rel_str = rel_str.replace(
                    '<frame id="first" x1="1cm" y1="15.8cm" width="19cm" height="13.8cm"/>',
                    '<frame id="first" x1="0.3cm" y1="1.5cm" width="28.7cm" height="19cm"/>')
                rel_str = rel_str.replace(
                    '<frame id="first" x1="0.4cm" y1="2cm" width="14.1cm" height="19cm"/>',
                    '<frame id="first" x1="0.3cm" y1="1.5cm" width="28.7cm" height="19cm"/>')
                rel_str = rel_str.replace(
                    '<frame id="first" x1="1cm" y1="2cm" width="19cm" height="27.4cm"/>',
                    '<frame id="first" x1="0.3cm" y1="1.5cm" width="28.7cm" height="19cm"/>')

                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="80,255,65" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="160,465,160" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="80,395,80" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="160,465,160" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="210,100,25,40,30,50,50,50" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="248,132,57,40,62,82,82,82" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="5" colWidths="250,100,25,30,50,50,50" style="tableMain">',
                    '<blockTable repeatRows="5" colWidths="288,132,57,62,82,82,82" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="160,70,20,30,40,40,40" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="288,132,57,62,82,82,82" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="6" colWidths="200,75,25,28,33,28,37,48,43,48" style="tableMain">',
                    '<blockTable repeatRows="6" colWidths="220,75,50,53,58,53,62,73,68,73" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="6" colWidths="100,48,20,23,30,23,32,43,38,43" style="tableMain">',
                    '<blockTable repeatRows="6" colWidths="220,75,50,53,58,53,62,73,68,73" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="5" colWidths="160,70,20,30,40,40,40" style="tableMain">',
                    '<blockTable repeatRows="5" colWidths="288,132,57,62,82,82,82" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="275,25,28,33,28,37,48,43,48" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="295,50,53,58,53,62,73,68,73" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="169,37,40,45,40,49,60,55,60" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="295,50,53,58,53,62,73,68,73" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="210,100,25,40,30,50,50,50" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="230,120,63,40,68,88,88,88" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="5" colWidths="250,100,25,30,50,50,50" style="tableMain">',
                    '<blockTable repeatRows="5" colWidths="270,120,63,68,88,88,88" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="250,100,25,30,50,50,50" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="288,132,57,62,82,82,82" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="250,100,25,30,50,50,50" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="270,120,63,68,88,88,88" style="tableMain">'
                )

                rel_str = rel_str.replace('<blockTable colWidths="285,285," style="tableSeller">',
                                          '<blockTable colWidths="392,393" style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="200,205," style="tableSeller">',
                                          '<blockTable colWidths="392,393" style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="290,250,40" style="tableSeller">',
                                          '<blockTable colWidths="375,370,40" style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="200,160,40" style="tableSeller">',
                                          '<blockTable colWidths="375,370,40" style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="257,258,40" style="tableSeller">',
                                          '<blockTable colWidths="375,370,40" style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="280,250,40" style="tableSeller">',
                                          '<blockTable colWidths="375,370,40" style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="270,260,40" style="tableSeller">',
                                          '<blockTable colWidths="375,370,40" style="tableSeller">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="100,100,60,60,75" style="tableCondition">',
                    '<blockTable colWidths="178,178,138,138,153" style="tableCondition">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="132,132,92,92,107" style="tableCondition">',
                    '<blockTable colWidths="178,178,138,138,153" style="tableCondition">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="101,101,61,61,81" style="tableCondition">',
                    '<blockTable colWidths="178,178,138,138,153" style="tableCondition">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="205,205,70,85" style="tableCondition">',
                    '<blockTable colWidths="250,250,110,175" style="tableCondition">'
                )
                rel_str = rel_str.replace(
                    '<blockTable colWidths="120,120,70,90" style="tableCondition">',
                    '<blockTable colWidths="250,250,110,175" style="tableCondition">'
                )
                rel_str = rel_str.replace(
                    '<blockTable colWidths="165,165,95,130" style="tableCondition">',
                    '<blockTable colWidths="250,250,110,175" style="tableCondition">'
                )
                rel_str = rel_str.replace(
                    '<blockTable colWidths="170,170,90,125" style="tableCondition">',
                    '<blockTable colWidths="250,250,110,175" style="tableCondition">'
                )

                rel_str = rel_str.replace('<blockTable colWidths="580" style="tableDefault">',
                                          '<blockTable colWidths="785" style="tableDefault">')
                rel_str = rel_str.replace('<blockTable colWidths="570" style="tableDefault">',
                                          '<blockTable colWidths="785" style="tableDefault">')
                rel_str = rel_str.replace('<blockTable colWidths="405" style="tableDefault">',
                                          '<blockTable colWidths="785" style="tableDefault">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="405" style="tableDateHour">',
                    '<blockTable colWidths="785" style="tableDateHour">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="555" style="tableDateHour">',
                    '<blockTable colWidths="785" style="tableDateHour">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="80,485" style="tableCompany">',
                    '<blockTable colWidths="80,705" style="tableCompany">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="80,325" style="tableCompany">',
                    '<blockTable colWidths="80,705" style="tableCompany">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="80,475" style="tableCompany">',
                    '<blockTable colWidths="80,705" style="tableCompany">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="580" style="tableClient">',
                    '<blockTable colWidths="782" style="tableClient">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="280,125" style="tableClient">',
                    '<blockTable colWidths="403,382" style="tableClient">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="376,193" style="tableClient">',
                    '<blockTable colWidths="403,382" style="tableClient">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="120,130,150" style="tableInfo">',
                    '<blockTable colWidths="230,260,295" style="tableInfo">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="172,188,195" style="tableInfo">',
                    '<blockTable colWidths="230,260,295" style="tableInfo">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="405" style="tableObservacoes">',
                    '<blockTable colWidths="785" style="tableObservacoes">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="555" style="tableObservacoes">',
                    '<blockTable colWidths="785" style="tableObservacoes">')

            elif modo_impressao == 'R':
                rel_str = rel_str.replace('pageSize="(29.7cm, 21cm)"', 'pageSize="(21cm, 29.7cm)"')

                rel_str = rel_str.replace('<drawString x="350" y="580">',
                                          '<drawString x="530" y="820">')
                rel_str = rel_str.replace('<drawString x="730" y="565">',
                                          '<drawString x="530" y="820">')
                rel_str = rel_str.replace('<drawString x="384" y="580">',
                                          '<drawString x="530" y="820">')

                rel_str = rel_str.replace('<drawCentredString x="10.5cm" y="15.8cm">',
                                          '<drawCentredString x="10.5cm" y="1cm">')
                rel_str = rel_str.replace('<drawCentredString x="7.4cm" y="1cm">',
                                          '<drawCentredString x="10.5cm" y="1cm">')
                rel_str = rel_str.replace('<drawCentredString x="14.8cm" y="1cm">',
                                          '<drawCentredString x="10.5cm" y="1cm">')

                rel_str = rel_str.replace(
                    '<frame id="first" x1="1cm" y1="2cm" width="19cm" height="27.4cm"/>',
                    '<frame id="first" x1="1cm" y1="2cm" width="19cm" height="27.4cm"/>')
                rel_str = rel_str.replace(
                    '<frame id="first" x1="0.4cm" y1="2cm" width="14.1cm" height="19cm"/>',
                    '<frame id="first" x1="1cm" y1="2cm" width="19cm" height="27.4cm"/>')
                rel_str = rel_str.replace(
                    '<frame id="first" x1="0.3cm" y1="1.5cm" width="28.7cm" height="19cm"/>',
                    '<frame id="first" x1="1cm" y1="2cm" width="19cm" height="27.4cm"/>')

                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="80,255,65" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="80,395,80" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="160,465,160" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="80,395,80" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="248,132,57,40,62,82,82,82" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="210,100,25,40,30,50,50,50" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="5" colWidths="288,132,57,62,82,82,82" style="tableMain">',
                    '<blockTable repeatRows="5" colWidths="250,100,25,30,50,50,50" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="120,70,20,40,30,45,40,40" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="210,100,25,40,30,50,50,50" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="5" colWidths="160,70,20,30,40,40,40" style="tableMain">',
                    '<blockTable repeatRows="5" colWidths="250,100,25,30,50,50,50" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="295,50,53,58,53,62,73,68,73" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="275,25,28,33,28,37,48,43,48" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="134,22,25,30,25,34,45,40,45" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="275,25,28,33,28,37,48,43,48" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="6" colWidths="100,48,20,23,30,23,32,43,38,43" style="tableMain">',
                    '<blockTable repeatRows="6" colWidths="200,75,25,28,33,28,37,48,43,48" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="230,120,63,40,68,88,88,88" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="210,100,25,40,30,50,50,50" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="5" colWidths="270,120,63,68,88,88,88" style="tableMain">',
                    '<blockTable repeatRows="5" colWidths="250,100,25,30,50,50,50" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="95,60,25,40,30,50,50,50" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="210,100,25,40,30,50,50,50" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="5" colWidths="135,60,25,30,50,50,50" style="tableMain">',
                    '<blockTable repeatRows="5" colWidths="250,100,25,30,50,50,50" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="288,132,57,62,82,82,82" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="250,100,25,30,50,50,50" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="160,70,20,30,40,40,40" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="250,100,25,30,50,50,50" style="tableMain">')
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="270,120,63,68,88,88,88" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="250,100,25,30,50,50,50" style="tableMain">'
                )
                rel_str = rel_str.replace(
                    '<blockTable repeatRows="7" colWidths="135,60,25,30,50,50,50" style="tableMain">',
                    '<blockTable repeatRows="7" colWidths="250,100,25,30,50,50,50" style="tableMain">'
                )

                rel_str = rel_str.replace('<blockTable colWidths="392,393" style="tableSeller">',
                                          '<blockTable colWidths="285,285" style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="200,205" style="tableSeller">',
                                          '<blockTable colWidths="285,285" style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="375,370,40" style="tableSeller">',
                                          '<blockTable colWidths="270,260,40" style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="280,250,40" style="tableSeller">',
                                          '<blockTable colWidths="270,260,40" style="tableSeller">')
                rel_str = rel_str.replace('<blockTable colWidths="200,160,40" style="tableSeller">',
                                          '<blockTable colWidths="270,260,40" style="tableSeller">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="178,178,138,138,153" style="tableCondition">',
                    '<blockTable colWidths="132,132,92,92,107" style="tableCondition">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="100,100,60,60,75" style="tableCondition">',
                    '<blockTable colWidths="132,132,92,92,107" style="tableCondition">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="101,101,61,61,81" style="tableCondition">',
                    '<blockTable colWidths="132,132,92,92,107" style="tableCondition">')

                rel_str = rel_str.replace('<blockTable colWidths="785" style="tableDefault">',
                                          '<blockTable colWidths="570" style="tableDefault">')
                rel_str = rel_str.replace('<blockTable colWidths="405" style="tableDefault">',
                                          '<blockTable colWidths="555" style="tableDefault">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="100,100,60,60,75" style="tableCondition">',
                    '<blockTable colWidths="132,132,92,92,107" style="tableCondition">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="178,178,138,138,153" style="tableCondition">',
                    '<blockTable colWidths="132,132,92,92,107" style="tableCondition">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="101,101,61,61,81" style="tableCondition">',
                    '<blockTable colWidths="132,132,92,92,107" style="tableCondition">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="250,250,110,175" style="tableCondition">',
                    '<blockTable colWidths="170,170,90,125" style="tableCondition">'
                )
                rel_str = rel_str.replace(
                    '<blockTable colWidths="205,205,70,85" style="tableCondition">',
                    '<blockTable colWidths="170,170,90,125" style="tableCondition">'
                )
                rel_str = rel_str.replace(
                    '<blockTable colWidths="120,120,70,90" style="tableCondition">',
                    '<blockTable colWidths="170,170,90,125" style="tableCondition">'
                )

                rel_str = rel_str.replace('<blockTable colWidths="570" style="tableDefault">',
                                          '<blockTable colWidths="555" style="tableDefault">')
                rel_str = rel_str.replace('<blockTable colWidths="785" style="tableDefault">',
                                          '<blockTable colWidths="555" style="tableDefault">')
                rel_str = rel_str.replace('<blockTable colWidths="405" style="tableDefault">',
                                          '<blockTable colWidths="555" style="tableDefault">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="405" style="tableDateHour">',
                    '<blockTable colWidths="555" style="tableDateHour">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="785" style="tableDateHour">',
                    '<blockTable colWidths="555" style="tableDateHour">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="80,325" style="tableCompany">',
                    '<blockTable colWidths="80,475" style="tableCompany">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="80,705" style="tableCompany">',
                    '<blockTable colWidths="80,475" style="tableCompany">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="405" style="tableClient">',
                    '<blockTable colWidths="569" style="tableClient">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="280,125" style="tableClient">',
                    '<blockTable colWidths="376,193" style="tableClient">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="403,382" style="tableClient">',
                    '<blockTable colWidths="376,193" style="tableClient">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="120,130,150" style="tableInfo">',
                    '<blockTable colWidths="172,188,195" style="tableInfo">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="230,260,295" style="tableInfo">',
                    '<blockTable colWidths="172,188,195" style="tableInfo">')

                rel_str = rel_str.replace(
                    '<blockTable colWidths="405" style="tableObservacoes">',
                    '<blockTable colWidths="555" style="tableObservacoes">')
                rel_str = rel_str.replace(
                    '<blockTable colWidths="785" style="tableObservacoes">',
                    '<blockTable colWidths="555" style="tableObservacoes">')
        rel_rml = open(addons_path, 'w')
        rel_rml.write(rel_str)
        rel_rml.close()

        return True

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        res = super(estoque_parametro, self).search(cr, uid, args, offset, limit, order, context, count)
        return res

    def create(self, cr, uid, vals, context=None):
        def _estpar_create_balanca(vals):
            """
            Conversao dos caminhos dos arquivos para minusculo.
            """
            if vals.get('arquivo_de_itens', False):
                vals['arquivo_de_itens'] = vals['arquivo_de_itens'].lower()
            if vals.get('arquivo_de_setor', False):
                vals['arquivo_de_setor'] = vals['arquivo_de_setor'].lower()
            if vals.get('arquivo_de_nutricionais', False):
                vals['arquivo_de_nutricionais'] = vals['arquivo_de_nutricionais'].lower()
            return vals

        def _estpar_create_ecf(cr, uid, vals):
            """
            Conversao dos nomes dos arquivos para minusculo
            """
            if vals.get('arquivo_de_clientes', False):
                vals['arquivo_de_clientes'] = vals['arquivo_de_clientes'].lower()
            if vals.get('arquivo_de_mensagens', False):
                vals['arquivo_de_mensagens'] = vals['arquivo_de_mensagens'].lower()
            if vals.get('arquivo_de_kit', False):
                vals['arquivo_de_kit'] = vals['arquivo_de_kit'].lower()
            if vals.get('arquivo_de_itens', False):
                vals['arquivo_de_itens'] = vals['arquivo_de_itens'].lower()
            if vals.get('arquivo_de_fidelidade', False):
                vals['arquivo_de_fidelidade'] = vals['arquivo_de_fidelidade'].lower()
            if vals.get('arquivo_de_vendedores', False):
                vals['arquivo_de_vendedores'] = vals['arquivo_de_vendedores'].lower()
                # Localizar acao agendada - Importar Cupom
            o_cron = self.pool.get('ir.cron')
            id_crontab = o_cron.search(cr, uid, [('name', 'ilike', 'Importar Cupom'), ('active', 'in', [False, True])],
                                       context=context)
            if vals.get('intervalo_import_aut', 0) > 0:  # Ativar importacao automatica no cron do sistema
                vals_cron = {'active': True,
                             'interval_number': vals['intervalo_import_aut']}
            else:
                vals_cron = {'active': False}
            if id_crontab:
                o_cron.write(cr, uid, id_crontab, vals_cron, context=context)
            return vals

        context = context and context.copy() or {}
        obj_adm_util = self.pool.get('adm.utils')
        obj_ir_cron = self.pool.get('ir.cron')
        if obj_adm_util.admutl_check_modulo_instalado(cr, uid, 'oservico', context):
            if 'estpar_oservico_tempo_minimo_os' in vals and vals.get(
                    'estpar_oservico_tempo_minimo_os') <= 0:
                raise osv.except_osv(_('Atencao'), _('Valor invalido para o campo "Tempo minimo"'))
        if obj_adm_util.admutl_check_modulo_instalado(cr, uid, 'balanca', context):
            vals = _estpar_create_balanca(vals)
        if obj_adm_util.admutl_check_modulo_instalado(cr, uid, 'ecf', context):
            vals = _estpar_create_ecf(cr, uid, vals)
        prime_madeireira = obj_adm_util.admutl_check_modulo_instalado(cr, uid, 'prime_madeireira',
                                                                      context)
        madeireira = obj_adm_util.admutl_check_modulo_instalado(cr, uid, 'madeireira', context)
        if prime_madeireira or madeireira:
            formato_impressao = vals.get('estpar_pedido_formato_impressao')
            if formato_impressao:
                path = '/madeireira/report/rel_impressao_estoquepedidos.rml'
                self.estpar_converte_formato_impressao(cr, uid, formato_impressao, path, 'p')
        if vals.get('numero'):
            vals['numero'] = vals['numero']
            # Bloco inserido na versao 3G1, para evitar erro na insercao de dados do arquivo local.xml
        # em bases que ja tem local cadastrado.
        # TODO: Pode ser removido apos a versao  4A1
        if context.get('install_mode') and context['install_mode']:
            args = [('company_id', '=', 1)]
            _id = self.search(cr, uid, args, context=context)
            if _id:
                return _id[0]
                # Fim do Bloco #
        if 'estpar_periodo' in vals and vals.get('estpar_periodo') <= 0 and \
                        vals.get('estpar_tipo_curva') == 'V':
            raise osv.except_osv(_('Atencao'), _('Valor invalido para o campo "Periodo (dias)"'))
        curva_abc_cron_ids = obj_ir_cron.search(
            cr, uid, [('model', '=', 'estoque.produto.grade'),
                      ('function', '=', 'estpgr_calcula_curvaabc'),
                      ('name', '=', 'Calcular curva ABC')], context=context)
        if vals.get('estpar_forma_execucao_curva') == 'M' and curva_abc_cron_ids:
            obj_ir_cron.write(cr, uid, curva_abc_cron_ids, {'active': False}, context)
        if vals.get('estpar_forma_execucao_curva') == 'A' and not curva_abc_cron_ids:
            sql = """
                SELECT id
                FROM ir_cron
                WHERE
                    model = 'estoque.produto.grade'
                    AND function = 'estpgr_calcula_curvaabc'
                    AND name = 'Calcular curva ABC'
            """
            cr.execute(sql)
            dict_cron = cr.dictfetchone()
            if dict_cron:
                cron_id = dict_cron.get('id')
                obj_ir_cron.write(cr, uid, [cron_id], {'active': True}, context)
        result = super(estoque_parametro, self).create(cr, uid, vals, context)
        return result

    def write(self, cr, uid, ids, values, context=None):
        def _estpar_write_balanca(vals):
            """
            Conversao dos caminhos dos arquivos para minusculo.
            """
            if vals.get('arquivo_de_itens', False):
                vals['arquivo_de_itens'] = vals['arquivo_de_itens'].lower()
            if vals.get('arquivo_de_setor', False):
                vals['arquivo_de_setor'] = vals['arquivo_de_setor'].lower()
            if vals.get('arquivo_de_nutricionais', False):
                vals['arquivo_de_nutricionais'] = vals['arquivo_de_nutricionais'].lower()
            return vals

        def _estpar_write_ecf(cr, uid, ids, vals):
            """
            Conversao dos nomes dos arquivos para minusculo
            """
            if vals.get('arquivo_de_clientes', False):
                vals['arquivo_de_clientes'] = vals['arquivo_de_clientes'].lower()
            if vals.get('arquivo_de_mensagens', False):
                vals['arquivo_de_mensagens'] = vals['arquivo_de_mensagens'].lower()
            if vals.get('arquivo_de_kit', False):
                vals['arquivo_de_kit'] = vals['arquivo_de_kit'].lower()
            if vals.get('arquivo_de_itens', False):
                vals['arquivo_de_itens'] = vals['arquivo_de_itens'].lower()
            if vals.get('arquivo_de_fidelidade', False):
                vals['arquivo_de_fidelidade'] = vals['arquivo_de_fidelidade'].lower()
            if vals.get('arquivo_de_vendedores', False):
                vals['arquivo_de_vendedores'] = vals['arquivo_de_vendedores'].lower()
                # Localizar acao agendada - Importar Cupom
            o_cron = self.pool.get('ir.cron')
            id_crontab = o_cron.search(cr, uid, [('name', 'ilike', 'Importar Cupom'), ('active', 'in', [False, True])],
                                       context=context)
            if vals.get('intervalo_import_aut'):
                intervalo_import_aut = vals['intervalo_import_aut']
            else:
                intervalo_import_aut = self.read(cr, uid, ids[0], ['intervalo_import_aut'], context=context)[
                    'intervalo_import_aut']

            if intervalo_import_aut > 0:  # Ativar importacao automatica no icron do sistema
                vals_cron = {'active': True,
                             'interval_number': intervalo_import_aut}
                if id_crontab:
                    # agora para edicao do ir_cron ao inves de enviar um id (inteiro), dever enviado uma lista, pois o tratamento mudou com versao 6.1
                    o_cron.write(cr, uid, id_crontab, vals_cron, context=context)
            return vals

        context = context and context.copy() or {}
        obj_adm_util = self.pool.get('adm.utils')
        obj_ir_cron = self.pool.get('ir.cron')
        if obj_adm_util.admutl_check_modulo_instalado(cr, uid, 'oservico', context=context):
            if 'estpar_oservico_tempo_minimo_os' in values and values.get(
                    'estpar_oservico_tempo_minimo_os') <= 0:
                raise osv.except_osv(_('Atencao'), _('Valor invalido para o campo "Tempo minimo"'))
        if obj_adm_util.admutl_check_modulo_instalado(cr, uid, 'balanca', context=context):
            values = _estpar_write_balanca(values)
        if obj_adm_util.admutl_check_modulo_instalado(cr, uid, 'ecf', context=context):
            values = _estpar_write_ecf(cr, uid, ids, values)
        prime_madeireira = obj_adm_util.admutl_check_modulo_instalado(cr, uid, 'prime_madeireira',
                                                                      context)
        madeireira = obj_adm_util.admutl_check_modulo_instalado(cr, uid, 'madeireira', context)
        if prime_madeireira or madeireira:
            formato_impressao = values.get('estpar_pedido_formato_impressao')
            if formato_impressao:
                path = '/madeireira/report/rel_impressao_estoquepedidos.rml'
                self.estpar_converte_formato_impressao(cr, uid, formato_impressao, path, 'p')
        if 'estpar_tamanho_codigo' in values:
            parametro_tamanho_novo = values['estpar_tamanho_codigo']

            obj_estoque_produto = self.pool.get('estoque.produto')
            produto_ids = obj_estoque_produto.search(cr, uid, [], context=context)
            if produto_ids:
                produto_dados = obj_estoque_produto.read(cr, uid, produto_ids, ['codigo'], context=context)

                produto_max_cod = max(map(lambda i: i['codigo'], produto_dados))

                max_codigo_len = str(int(produto_max_cod)).__len__()

                if parametro_tamanho_novo < max_codigo_len:
                    raise osv.except_osv(
                        _('Atencao'), _('Informe um tamanho de codigo para o produto maior ou igual a %d, '
                                        'pois existe um produto com %d digitos no codigo.') % (
                                      max_codigo_len, max_codigo_len)
                    )
                else:
                    estpar_dados = self.estpar_get_fields(
                        cr, uid, fields_to_read=['estpar_tamanho_codigo'], context=context
                    )
                    if isinstance(estpar_dados, list):
                        estpar_dados = estpar_dados[0]
                    parametro_tamanho_antigo = estpar_dados['estpar_tamanho_codigo']

                    if parametro_tamanho_novo > parametro_tamanho_antigo:
                        # SQL PARA AUMENTAR O CODIGO DO PRODUTO
                        sql = """
                            update estoque_produto set codigo = lpad(codigo, %s, '0');
                        """ % str(parametro_tamanho_novo)
                    # O INDICE DE STRING NO POSTGRESQL COMECA A PARTIR DE 1, POR ISSO E ADD +1 NO CODIGO ABAIXO.
                    elif parametro_tamanho_novo < parametro_tamanho_antigo:
                        inicio = parametro_tamanho_antigo - parametro_tamanho_novo + 1
                        fim = parametro_tamanho_antigo
                        # SQL PARA DIMINUIR O CODIGO DO PRODUTO
                        sql = """
                            update estoque_produto set codigo = substring(codigo from %s for %s)
                        """ % (str(inicio), str(fim))
                    else:
                        sql = False

                    if sql:
                        # ATUALIZA O CODIGO DOS PRODUTOS
                        cr.execute(sql)
                        # ATUALIZA O PADDING NO IR_SEQUENCE PARA A EMPRESA DO PARAMETRO
                        parametro_company_id = self.estpar_get_company_id(cr, uid, context=context)
                        cr.execute("""
                            update ir_sequence set padding = %s where company_id = %s and code = 'estoque.produto'
                        """ % (parametro_tamanho_novo, parametro_company_id))
                        cr.commit()
        if 'estpar_periodo' in values and values.get('estpar_periodo') <= 0 and \
                        values.get('estpar_tipo_curva') == 'V':
            raise osv.except_osv(_('Atencao'), _('Valor invalido para o campo "Periodo (dias)"'))
        curva_abc_cron_ids = obj_ir_cron.search(
            cr, uid, [('model', '=', 'estoque.produto.grade'),
                      ('function', '=', 'estpgr_calcula_curvaabc'),
                      ('name', '=', 'Calcular curva ABC')], context=context)
        if values.get('estpar_forma_execucao_curva') == 'M' and curva_abc_cron_ids:
            obj_ir_cron.write(cr, uid, curva_abc_cron_ids, {'active': False}, context)
        if values.get('estpar_forma_execucao_curva') == 'A' and not curva_abc_cron_ids:
            sql = """
                SELECT id
                FROM ir_cron
                WHERE
                    model = 'estoque.produto.grade'
                    AND function = 'estpgr_calcula_curvaabc'
                    AND name = 'Calcular curva ABC'
            """
            cr.execute(sql)
            dict_cron = cr.dictfetchone()
            if dict_cron:
                cron_id = dict_cron.get('id')
                obj_ir_cron.write(cr, uid, [cron_id], {'active': True}, context)
        return super(estoque_parametro, self).write(cr, uid, ids, values, context)

    def copy(self, cr, uid, id, default=None, context=None):
        context = context and context.copy() or {}
        if not isinstance(default, dict):
            default = {}
        default['company_id'] = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, context=context)
        return super(estoque_parametro, self).copy(cr, uid, id, default, context)
