# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class estoque_produto_codigo_fornecedor(osv.Model):
    _name = 'estoque.produto.codigo.fornecedor'
    _inherit = 'estoque.produto.codigo.fornecedor'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if not vals.get('produto_id', False):
            # funcao utilizada para cadastro de produto_num. de serie na grade
            if 'grade_id' in vals:
                o_grade = self.pool.get('estoque.produto.grade')
                vals['produto_id'] = o_grade.browse(cr, uid, vals['grade_id']).produto_id.id
        self.estpcf_check_codigo_fornecedor(cr, uid, vals.get('fornecedor_id'),
                                            vals.get('codigo_fornecedor'), context)
        res = super(estoque_produto_codigo_fornecedor, self).create(cr, uid, vals, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        self.estpcf_check_codigo_fornecedor(cr, uid, vals.get('fornecedor_id'),
                                            vals.get('codigo_fornecedor'), context)
        res = super(estoque_produto_codigo_fornecedor, self).write(cr, uid, ids, vals, context)
        return res

    def estpcf_check_codigo_fornecedor(self, cr, uid, fornecedor_id, codigo_fornecedor,
                                       context=None):
        """
        O metodo verifica se algum registro da tabela 'estoque_produto_codigo_fornecedor' possui o
        fornecedor e o codigo informados. Caso encontre, o processo eh impedido e o usuario eh
        informado que um outro produto e grade ja os possuem.
        :param cr: cursor no banco de dados
        :param uid: id da tabela res_users, identificador do usuario
        :param fornecedor_id: id da tabela 'financeiro_fornecedor'
        :param codigo_fornecedor: char que representa o codigo do fornecedor
        :param context: dicionario com valores contextuais
        :return: booleano True, caso fornecedor_id e codigo_fornecedor nao forem informados ou se
        esses nao estiverem num outro registro. Raise, caso eles estejam num outro registro
        """
        context = context and context.copy() or {}
        if not all([fornecedor_id, codigo_fornecedor]):
            return True
        cod_fornecedor_ids = self.search(cr, uid, [('fornecedor_id', '=', fornecedor_id),
                                                   ('codigo_fornecedor', '=', codigo_fornecedor)])
        if not cod_fornecedor_ids:
            return True
        brw_codigo_fornecedor = self.browse(cr, uid, cod_fornecedor_ids[0], context)
        raise osv.except_osv(_('Atencao'),
                             _('O codigo ja esta cadastrado para o produto e grade: %s') %
                             brw_codigo_fornecedor.produto_id.codigo + ' ' +
                             brw_codigo_fornecedor.produto_id.name + ' - ' +
                             brw_codigo_fornecedor.grade_id.descricao or '')
