#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.tools.translate import _
from openerp.addons.web_sig.executor.descricao_funcoes import dic_funcoes

NOME_FUNCOES = [
    ('est_001', _('EST_001-Renumerar codigo do cadastro de produtos.')),
    ('est_002', _('EST_002-Copiar locacoes de uma empresa para outra')),
]
"""
chaves permitidas para o dicionario "campos"
    tipo - tipo de campo: date, many2one, many2many, selection - Obrigatorio
    label - String da descricao do campo - Obrigatorio
    seq - Sequencia do campo na tela (numerico, nao string) - Opcional
    attrs - para definicao de atributo. Aceitos: required, readonly - Opcional
            para readonly e necessario  informar um string, com 4 argumentos separados por ","
            ex.: attrs: 'readonly,teste,=,T'
    help - String com o help para o campo - Opcional
    colspan - quantidade de colunas para usar no colspan
    relation - nome da relacao no caso de campos relacionais - Obrigatorio se campo relacional
    widget - widget a ser utilizado - Opcional
    default - Valor default para o campo - Opcional
    lista - lista de duplas para os campos selection - obrigatorio se selection
"""
dic_funcoes_estoque = {
    'est_001': {'name': _('Renumerar codigo do cadastro de produtos'),
                'obs': _("""Esta funcao substitui o codigo de todos os produtos por numeros inteiros, em ordem sequencial. A ordem original dos produtos e mantida."""),
                },
    'est_002': {'name': _('Copiar locacoes de uma empresa para outra'),
                'obs': _("Esta funcao copia as locacoes de um empresa para outra empresa"),
                'campos': {
                    'origem_company_id': {'tipo': 'many2one', 'label': _('Empresa origem'), 'seq': 1,
                                          'attrs': 'required', 'help': _('Empresa de origem'),
                                          'relation': 'res.company'},
                    'origem_local_id': {'tipo': 'many2one', 'label': _('Local origem'), 'seq': 2,
                                        'attrs': 'required', 'help': _('Local de origem'),
                                        'relation': 'estoque.local',
                                        'domain':[('company_id', '=', 'origem_company_id')]},
                    'destino_company_id': {'tipo': 'many2one', 'label': _('Empresa destino'), 'seq': 3,
                                          'attrs': 'required', 'help': _('Empresa de destino'),
                                          'relation': 'res.company'},
                    'destino_local_id': {'tipo': 'many2one', 'label': _('Local destino'), 'seq': 4,
                                        'attrs': 'required', 'help': _('Local de destino'),
                                        'relation': 'estoque.local',
                                         'domain':[('company_id', '=', 'destino_company_id')]},
                    }
                },
}

dic_funcoes.update(dic_funcoes_estoque)
