#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _


# noinspection PyAbstractClass,PyAbstractClass,PyPep8Naming
class websig_executor_tela_osv(osv.TransientModel):
    _name = 'websig.executor.tela.osv'
    _inherit = 'websig.executor.tela.osv'

    def websig_exec_est_001(self, cr, uid, ids, context):
        """
        Esta funcao substitui o codigo de todos os produtos por numeros inteiros, em ordem
        sequencial. A ordem original dos produtos e mantida.
        """

        msg = ''

        # Aqui comeca a parte especifica da funcao
        # Se houver algum erro, muda o ´´state´´ para 4 e informa a mensagem de erro

        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'estoque.produto',
                                                                    context=context)
        list_field = ['codigo_numerico', 'estpar_tamanho_codigo']
        estoque_parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', list_field, context)

        if not estoque_parametro_dados.get('codigo_numerico'):
            self.write(cr, uid, ids, {
                'state': '4',
                'mensagem': _('<h1>Parametro do estoque nao esta configurado para usar codigo '
                              'numerico!</h1>')}, context)
            return False

        sql = """
            SELECT
                id AS produto_id
            FROM
                estoque_produto
            WHERE
                company_id = %s
            ORDER BY
                codigo
        """ % company_id
        cr.execute(sql)
        produto_dados = cr.dictfetchall()

        msg += _('    Selecionado %s produtos.<br>') % len(produto_dados)

        # Altera o cadastro para nao haver duplicidade.
        sql = """
            UPDATE
                estoque_produto
            SET
                codigo = 'a' || codigo
        """
        cr.execute(sql)

        qtd = 0
        codigo = 1
        sql = """
                UPDATE
                    estoque_produto
                SET
                    codigo = '%s'
                WHERE
                    id = %s
            """
        # Altera o cadastro renumerando os codigos.
        for produto in produto_dados:
            sql_update = sql % (str(codigo).zfill(estoque_parametro_dados.get(
                'estpar_tamanho_codigo')), produto.get('produto_id'))
            cr.execute(sql_update)
            qtd += 1
            codigo += 1

        # Ajusta o sequence
        sql = """
            UPDATE
                ir_sequence
            SET
                number_next = %s
            WHERE
                code = 'estoque.produto'
                AND name = 'Codigo de Produto/Servico'
                AND company_id = %s
        """ % (codigo, company_id)
        cr.execute(sql)

        msg += _('    Produtos atualizados: %s<br>') % qtd

        # Aqui termina a parte especifica da funcao
        msg += _('<h1>Concluido sem erro!</h1>')
        res = self.write(cr, uid, ids, {'state': '3', 'mensagem': msg}, context)

        return res

