#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _
from datetime import datetime, date
from openerp.osv.fields import float_round


class websig_executor_tela_osv(osv.TransientModel):
    _name = 'websig.executor.tela.osv'
    _inherit = 'websig.executor.tela.osv'

    def websig_exec_est_002(self, cr, uid, ids, context):
        """
        Esta funcao substitui/inclui o codigo da natureza da receita do PIS/COFINS no movimento da
        tributacao para as NFC-e emitidas no periodo, de acordo com o cadastro do produto.
        """
        context = context and context.copy() or {}
        load = '_classic_write'
        obj_locacao = self.pool.get('estoque.local.locacao')
        msg = []
        executor_tela_id = ids[0] if isinstance(ids, list) else ids
        funcao_escolhida = eval(self.browse(cr, uid, executor_tela_id, context).dados).get(
            'est_002')

        origem_company_id = funcao_escolhida.get('campos').get('origem_company_id').get('value', False)
        origem_local_id = funcao_escolhida.get('campos').get('origem_local_id').get('value', False)
        destino_company_id = funcao_escolhida.get('campos').get('destino_company_id').get('value', False)
        destino_local_id = funcao_escolhida.get('campos').get('destino_local_id').get('value', False)
        context_force = context.copy()
        context_force['sig_force_company'] = True
        origem_locacao_ids = obj_locacao.search(cr, uid, [('company_id', '=', origem_company_id),
                                         ('local_id', '=', origem_local_id)], context=context_force)
        if not origem_locacao_ids:
            msg = _('<h1>Sem locacoes cadastradas na empresa e local de entrada!</h1>')

        if origem_company_id == destino_company_id:
            msg = _('<h1>Empresas de origem e destino sao iguais!</h1>')

        if msg:
            self.write(cr, uid, ids, {'state': '1', 'mensagem': msg}, context)
            return False

        destino_locacao_ids = obj_locacao.search(cr, uid, [('company_id', '=', destino_company_id),
                                         ('local_id', '=', destino_local_id)], context=context_force)
        destino_locacao = []
        if destino_locacao_ids:
            for i in obj_locacao.read(cr, uid, destino_locacao_ids, ['local_id', 'produto_id',
                                                                     'grade_id'], context, load):
                chave = '%s-%s-%s' % (i.get('local_id'),
                                      i.get('produto_id'),
                                      i.get('grade_id'))
                destino_locacao.append(chave)

        campos = []
        valores = []
        # fiz read com os campos para nao chamar os campos funcionais que aumentam o tempo de processamento
        for i in obj_locacao.read(cr, uid, origem_locacao_ids, ['company_id','locacao','altura',
                    'largura','profundidade','data_validade','repositor_id','local_id','active',
                    'flag','create_date','produto_id','grade_id','estllc_produto_embalagem_id'], context, load):
            chave = '%s-%s-%s' % (i.get('local_id'),
                                  i.get('produto_id'),
                                  i.get('grade_id'))
            # caso as locacoes ja esteja na empresa de destino, nao cria novamente
            if chave in destino_locacao:
                continue

            del(i['id'])
            dados = []
            for j in i.items():
                if j[0] not in campos:
                    campos.append(j[0])

                if j[1]:
                    if isinstance(j[1], (str, unicode, datetime, date)):
                        dados.append("'%s'" %j[1])
                    else:
                        if j[0] == 'company_id':
                            dados.append("%s" % destino_company_id)
                        elif j[0] == 'local_id':
                            dados.append("%s" % destino_local_id)
                        else:
                            dados.append("%s" % j[1])

                else:
                    dados.append("Null")

            valores.append('(%s)' % ', '.join(dados))

        if valores:
            sql = """INSERT INTO estoque_local_locacao
                                ({campos})
                     VALUES {values};
                  """.format(campos=', '.join(campos),
                             values=',\n'.join(valores))
            try:
                cr.execute(sql)
            except Exception as e:
                self.write(cr, uid, ids, {'state': '1', 'mensagem': _('<h1>Erro ao inserir locacoes<h2>:\n%s') % e}, context)
                return False

        msg.append(_('<h1>Concluido sem erro!</h1>'))
        res = self.write(cr, uid, ids, {'state': '3',
                                        'mensagem': '\n'.join(msg)}, context)
        return res

