# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_embalagem(osv.Model):
    """
    Descricao dos tipos de embalagem usado para armazenar os produtos
    prefixo estemb_
    """

    _name = 'estoque.embalagem'
    _columns = {
        'name': fields.char('Descricao', required=True, size=30), # Descricao do tipo embalagem
        'sigla': fields.char('Sigla', size=7, select=True),
        'unidade_id': fields.many2one("estoque.embalagem.unidade", 'Unidade', ondelete="restrict", required=True,
                                      select=True), # id da Unidade utilizada
        'quantidade_na_embalagem': fields.float('Quantidade na Embalagem', digits=(8, 3), required=True),
        # Quantidade de itens que compoem esta embalagem
    }
    _defaults = {
        'quantidade_na_embalagem': lambda *a: 1,
    }

    _sql_constraints = [
        ('sigla_uniq', 'unique (sigla)', 'A sigla deve ser unica'),
    ]
