# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_embalagem_unidade(osv.Model):
    _name = 'estoque.embalagem.unidade'
    _columns = {
        'unidade': fields.char('Unidade', size=3, required=True, select=True),
        'name': fields.char('Descricao', size=30, required=True), # Descricao da unidade de medida
        'fracao': fields.boolean('Fracao'), # Flag que indica se os produtos desta unidade podem ser movimentados com unidade fracionaria.
        'embalagem_ids': fields.one2many('estoque.embalagem', 'unidade_id', 'Embalagem'),
    }
    _defaults = {
        'fracao': lambda *a: False,
    }
    _sql_constraints = [
        ('unidade_uniq', 'unique (unidade)', 'A unidade precisa ser unica!'),
    ]
