# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _


class estoque_inventario_correcao(osv.Model):
    # prefixo: estico_

    from funcoes import _estico_get_company_id

    _name = 'estoque.inventario.correcao'

    _columns = {
        'company_id': fields.function(_estico_get_company_id, method=True, type='many2one', store=True,
                                      relation='res.company', string='Empresa', select=True),  # id da empresa\n
        'estico_inventario_id': fields.many2one('estoque.inventario.capa', 'Inventario', ondelete="cascade",
                                                required=True, select=True),
        'estico_custo_qtd': fields.selection([('C', 'Custo'), ('Q', 'Quantidade')], 'Tipo',
                                             size=1, required=True),
        'estico_percentual': fields.float('Percentual', digits=(6, 4), required=True),
        'estico_mais_menos': fields.selection([('A', 'Aumentar'), ('D', 'Diminuir')], 'Operacao',
                                              size=1, required=True),
    }

    _defaults = {
        'estico_custo_qtd': lambda *a: 'C',
    }

    _order = 'estico_inventario_id DESC'

    _sql_constraints = [
        ('inventario_id_uniq', 'unique (estico_inventario_id)', _('O inventario deve ser unico.'))
    ]