# -*- coding: utf-8 -*-

from openerp.osv import osv, fields


# noinspection PyAbstractClass,PyPep8Naming
class estoque_natureza_operacao(osv.Model):
    _name = "estoque.natureza.operacao"  # estnto

    _columns = {
        # ___________________________ Char ___________________________________
        'name': fields.char('Descricao', size=40, required=True),

        # ___________________________ Selection ______________________________
        'estnto_tipo_operacao': fields.selection(
            [('E', 'Entrada'), ('S', 'Saida')], 'Tipo de operacao', size=1, required=True),

        # ___________________________ Boolean ________________________________
        'estnto_atualizar_saldo': fields.boolean('Atualizar saldo', select=True),
        'estnto_gerar_financeiro': fields.boolean('Gerar financeiro'),
        'estnto_gerar_estatistica': fields.boolean('Gerar estatisticas'),
        'active': fields.boolean('Ativo'),
        'estnto_atualizar_custos': fields.boolean('Atualizar custos'),

        # ___________________________ Many2one _______________________________
        'estnto_movimento_origem_id': fields.many2one(
            'estoque.movimento.origem', 'Origem', ondelete='restrict',
            help='Identifica a origem do movimento para operacoes de entrada ou saida.')

    }

    _defaults = {
        'estnto_atualizar_custos': True,
        'estnto_atualizar_saldo': True,
        'estnto_gerar_financeiro': True,
        'estnto_gerar_estatistica': True,
        'active': True,
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
