# -*- coding: utf-8 -*-

from openerp.osv import osv, fields


class estoque_produto_descricao_anterior(osv.Model):
    _name = 'estoque.produto.descricao.anterior'
    _columns = {
        'create_date': fields.datetime('Data criacao', readonly=True),
        'esteda_descricao_anterior': fields.char('Descricao anterior', size=60),
        'esteda_data_inicio': fields.date('Data de inicio'),
        'esteda_data_fim': fields.date('Data final', select=True),
        'esteda_produto_id': fields.many2one('estoque.produto', 'Item', required=True,
                                             ondelete='cascade', select=True),
    }
    _order = 'esteda_produto_id, esteda_data_fim'
    _sql_constraints = [
        ('produto_data_fim_uniq', 'unique(esteda_produto_id, esteda_data_fim)',
         'O item e a data final devem ser unicos.')
    ]
