# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estsug_compra_item(osv.Model):
    # prefixo: esgcit_
    _name = 'estsug.compra.item'
    _gerar_logs_logs = 'N'

    _columns = {
        # ------------ MANY2ONE ------------
        'esgcit_capa_id': fields.many2one('estsug.compra.capa', 'Capa'),
        'esgcit_produto_id': fields.many2one('estoque.produto', 'Item'),
        'esgcit_grade_id': fields.many2one('estoque.produto.grade', 'Grade',
                                           domain="[('produto_id', '=', esgcit_produto_id)]"),

        # ----------- CHAR -----------------
        'esgcit_classificacao': fields.char('ABC', size=1),
        'esgcit_sigla_grade': fields.char('GR', size=2),
        'esgcit_sigla_uni': fields.char('Uni.', size=7),
        'esgcit_codigo_fabricante': fields.char('Codigo no fabricante', size=20),
        'esgcit_item_codigo': fields.char('Item'),
        'esgcit_item_descricao': fields.char('Descricao', size=60),

        # ----------- DATE -----------------
        'esgcit_ult_entrada': fields.date('Ult. entrada'),

        # ----------- FLOAT ----------------
        'esgcit_qtd_entrada': fields.float('Qtd. Entr.', digits=(12, 3)),
        'esgcit_qtd_emb': fields.float('Qtd. Emb.', digits=(8, 3)),
        'esgcit_saidas': fields.float('Saidas', digits=(15, 2)),
        'esgcit_pedidos': fields.integer('Pedidos'),
        'esgcit_pedido_dias': fields.integer('Ult. Ped. dias'),
        'esgcit_media': fields.float('Media', digits=(15, 2)),
        'esgcit_custo': fields.float('Custo', digits=(15, 2)),
        'esgcit_preco_venda': fields.float('Preco venda', digits=(14, 2)),
        'esgcit_saldo': fields.float('Saldo', digits=(14, 3)),
        'esgcit_sugestao': fields.float('Sugestao'),

        # ----------- INTEGER --------------
        'esgcit_dias': fields.integer('Dias'),
        'esgcit_minimo': fields.integer('Minimo'),
        'esgcit_maximo': fields.integer('Maximo'),
        'esgcit_empresa': fields.integer('Empresa'),
        'esgcit_prazo_media': fields.integer('Prazo para media', readonly=True),

        # ----------- ONE2MANY -------------
        'esgcit_item_estatistica_ids': fields.one2many('estsug.compra.item.estatistica',
                                                       'esgcie_item_id', 'Estatisticas'),
    }

    _defaults = {
        'esgcit_prazo_media': 0,
    }
