# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_fornecedor(osv.Model):
    """
    tabela de fornecedores de um produto
    """

    from funcoes import _estfor_nome_fornecedor, _estfor_get_data_pedido

    _name = 'estoque.fornecedor'
    _columns = {
        'name': fields.function(_estfor_nome_fornecedor, method=True, string='Fornecedor', type='text', store=False),
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="cascade", required=True, select=True),
        'embalagem_id': fields.many2one("estoque.embalagem", 'Embalagem', ondelete="restrict", required=False,
                                        select=True), # identificacao da embalagem / produto\n
        'fornecedor_id': fields.many2one("financeiro.fornecedor", 'Fornecedor', ondelete="cascade", required=True,
                                         select=True), # id do fornecedor
        'representante_id': fields.many2one("financeiro.representante", 'Representante', ondelete="set null",
                                            select=True, domain="[('fornecedor_id', '=', fornecedor_id)]"),
        'tempo_reposicao': fields.integer('Tempo de reposicao'),
        'data_da_ultima_compra': fields.function(_estfor_get_data_pedido, type='date', method=True,
                                                 string='Data da ultima compra'),
        'estfor_anuncio': fields.char('URL no fornecedor', size=256),

    }
    _sql_constraints = [
        ('produto_fornecedor_uniq', 'unique (fornecedor_id, produto_id)',
         'Este fornecedor ja encontra-se cadastrado para este produto!'),
    ]
    _defaults = {
        'tempo_reposicao': lambda *a: 0,
    }


