# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

import time
from SigUtils import formatastring
from datetime import datetime
from openerp.osv.fields import float_round
from dateutil.relativedelta import relativedelta

#Funcoes da classe estoque_categoria
def _estcat_get_codigo(self, cr, uid, ids, name_field, args, context=None):
    return self.pool.get('adm.utils').get_nome_conta(cr, uid, ids, self._name, False, context)


def _estcat_tem_filho(self, cr, uid, ids, name_fields, args, context=None):
    context = context and context.copy() or {}
    res = {}
    for x in ids:
        record = self.search(cr, uid, [('parent_id', 'child_of', ids)], context=context)
        if record != ids:
            res[x] = True
    return res

def _estcat_nome_completo(self, cr, uid, ids, prop, unknow_none, context=None):
    """
    Metodo para retornar a estrutura da arvore das categorias
    """
    context = context and context.copy() or {}
    res = self.name_get(cr, uid, ids, context=context)
    return dict(res)


# Funcoes da classe estoque_fornecedor
def _estfor_nome_fornecedor(self, cursor, user, ids, name, arg, context=None):
    """
    Retorna o nome do fornecedor
    """
    context = context and context.copy() or {}
    res = {}
    for fornecedor in self.browse(cursor, user, ids):
        if fornecedor.id:
            res[fornecedor.id] = fornecedor.fornecedor_id.pessoa_id.name
        else:
            res[fornecedor.id] = False
    return res


def _estfor_get_data_pedido(self, cr, uid, ids, arg, name, context=None):
    context = context and context.copy() or {}
    res = {}
    vals = self.read(cr, uid, ids, ['fornecedor_id', 'produto_id'], context=context)
    produto_id = str(vals[-1]['produto_id'][0])
    fornecedor = self.pool.get('estoque.fornecedor').browse(cr, uid, ids, context=context)
    for x in fornecedor:
        pessoa_id = x.fornecedor_id.pessoa_id.id
        req = self.pool.get('adm.utils').ultima_data_pedido(cr, uid, ids, produto_id, pessoa_id)

        res[x.id] = req
    return res

# Funcoes da classe estoque_inventario_capa
def _esticp_getAnoMesDescricao(self, cursor, user, ids, name, arg, context=None):
    """
    Retorna o AAAA/MM do inventario
    """
    context = context and context.copy() or {}
    res = {}
    for item in self.browse(cursor, user, ids):
        if item.id:
            res[item.id] = item.ano + '/' + item.mes + ' - ' + item.descricao
        else:
            res[item.id] = False
    return res


def _esticp_get_total_custo(self, cr, uid, ids, name, arg, context=None):
    """
    Calcula os totais saldo_contado x ultimo_custo e saldo_contado x custo_medio
    """
    context = context and context.copy() or {}
    res = {}
    map(lambda x: res.update({x:{'total_saldo_ultimo_custo': 0,
                                 'total_saldo_custo_medio': 0}}), ids)
    obj_contagem = self.pool.get('estoque.inventario.contagem')
    contagem_ids = obj_contagem.search(cr, uid, [('inventario_id', 'in', ids)], context=context)
    load = '_classic_write'
    campos = ['saldo_contado', 'requisitado', 'estict_ultimo_custo', 'estict_custo_medio_contabil',
              'inventario_id']
    # foi mudado de browse para read para melhorar performance ao atualizar o inventario
    for contagem in obj_contagem.read(cr, uid, contagem_ids, campos, context=context, load=load):
        capa_id = contagem.get('inventario_id')
        ultimo_custo = 0
        custo_medio = 0
        if contagem.get('saldo_contado') + contagem.get('requisitado') > 0:
            ultimo_custo += (contagem.get('saldo_contado') + contagem.get('requisitado')) * \
                            contagem.get('estict_ultimo_custo')
            custo_medio += (contagem.get('saldo_contado') + contagem.get('requisitado')) * \
                           contagem.get('estict_custo_medio_contabil')

        res[capa_id]['total_saldo_ultimo_custo'] += float(float_round(ultimo_custo,2))
        res[capa_id]['total_saldo_custo_medio'] +=  float(float_round(custo_medio,2))

    return res


def esticp_get_texto(self, cr, uid, ids, field_name, args, context=None):
    """
    O metodo retorna a mensagem padrao a ser exibida caso o inventario ja esteja atualizado.
    Usado na tela de manutencao de inventario.
    :param cr: cursor no banco de dados
    :param uid: registro da tebale res_users, identificador do usuario
    :param ids: lista de registros da tabela estoque_inventario_capa
    :param field_name: descricao do atributo
    :param args:
    :param context: dicionario com valores contextuais
    :return: dicionario, com suas chaves e valores representando os registros da tabela e a string
    da mensagem, respectivamente.
    """
    context = context and context.copy() or {}
    res = {}
    for inventario_id in ids:
        res[inventario_id] = 'INVENTARIO JA ATUALIZADO, ALTERACOES NOS CAMPOS DE SALDO NAO SERAO ' \
                             'APLICADAS A BASE DE DADOS'
    return res

# Funcoes da classe estoque_inventario_contagem
def _estict_getItem(self, cursor, user, ids, name, arg, context=None):
    """
    Retorna o nome do item
    """
    context = context and context.copy() or {}
    res = {}
    for item in self.browse(cursor, user, ids):
        if item.id:
            res[item.id] = item.produto_id.name
        else:
            res[item.id] = False
    return res

# Funcoes da classe estoque_inventario_oficial
def _estiof_getItem(self, cursor, user, ids, name, arg, context=None):
    """
    Retorna o nome do item
    """
    context = context and context.copy() or {}
    res = {}
    for item in self.browse(cursor, user, ids):
        if item.id:
            res[item.id] = item.produto_id.name
        else:
            res[item.id] = False
    return res

# Funcoes da classe estoque_local_locacao
def _estllc_get_saldo(self, cr, user, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    o_saldo = self.pool.get('estoque.produto.saldo')
    locais_grades = {}
    dados_locacao = self.read(cr, user, ids, ['grade_id', 'local_id'], context, '_classic_write')
    for x in dados_locacao:
        grade_id = x.get('grade_id')
        local_id = x.get('local_id')
        if not locais_grades.get(local_id):
            locais_grades[local_id] = [grade_id]
        else:
            locais_grades[local_id].append(grade_id)

    saldo_local = {}
    context['estoque_produto_grade'] = True
    for local_id in locais_grades:
        grade_ids = locais_grades.get(local_id)
        dict_saldo = o_saldo.get_saldo_do_dia(cr, user, grade_ids, time.strftime('%Y-%m-%d'),
                                              local_id, context=context)
        saldo_local[local_id] = dict_saldo

    for x in dados_locacao:
        grade_id = x.get('grade_id')
        local_id = x.get('local_id')
        saldos = saldo_local.get(local_id)
        saldo = saldos.get(grade_id).get('saldo', 0.0)
        qtde_reservada = saldos.get(grade_id).get('qtd_reservada', 0.0)
        res[x.get('id')] = {
            'saldo': saldo,
            'estllc_qtd_reservada': qtde_reservada
        }

    return res


# Funcoes da classe estoque_movimento_capa
def _estmvc_name_data(self, cursor, user, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for NomeD in self.browse(cursor, user, ids):
        if NomeD.estmvc_operacao_id and NomeD.estmvc_operacao_id.estnto_movimento_origem_id:
            if NomeD.estmvc_operacao_id.estnto_tipo_operacao == 'E':
                oper = 'ENT'
            else:
                oper = 'SAI'
            res[NomeD.id] = NomeD.data + '/' + oper + '-' + NomeD.estmvc_operacao_id.\
                estnto_movimento_origem_id.estmog_codigo
        else:
            res[NomeD.id] = None
    return res

def _estmvi_get_local_venda_padrao(self, cr, uid, context=None):
    context = context and context.copy() or {}
    res = False
    emp_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
    obj_estoque_parametro = self.pool.get('estoque.parametro')
    par_id = obj_estoque_parametro.search(cr, uid, [('company_id', '=', emp_id)], context=context)
    if par_id:
        if isinstance(par_id, list):
            par_id = par_id[0]
        brw_estoque_parametro = obj_estoque_parametro.browse(cr, uid, par_id, context)
        if context.get('entrada_producao') or context.get('entrada_terceiros') or context.get('tipo_nota') == 'E':
            transferencia_local_id = context.get('nf_transferencia') and \
                brw_estoque_parametro.estpar_local_entrada_transf_padrao_id.id
            res = transferencia_local_id or brw_estoque_parametro.estpar_local_compra_padrao_id.id
        else:
            res = brw_estoque_parametro.local_venda_padrao_id.id
    return res

def _estmvi_get_dados_stored_false(self, cr, uid, ids, name, arg, context=None):
    """
    Busca o dados dos campos funcionais da classe 'estoque.movimento.itens'
    para os campos com stored=False
    @param uid: id do usuario
    @param ids: lista de id da tabela estoquemovimentos_movimento_item
    @param name: nome do atributo
    @param arg: argumentos
    @param context: dicionario com valores contextuais
    """
    context = context and context.copy() or {}
    res = {}
    for id in ids:
        res[id] = {'estmvi_saldo': 0, 'estmvi_reservada': 0}

    obj_estoque_produto_saldo = self.pool.get('estoque.produto.saldo')
    context_aux = context.copy()
    context_aux['super_read_estoque_movimento_itens'] = True
    dados_movimento_item = self.read(cr, uid, ids, ['local_id', 'capa_id', 'nf_id', 'grade_id'],
                                     context=context_aux, load='_classic_write')
    local_id = dados_movimento_item[0].get('local_id')
    data = time.strftime('%Y-%m-%d')
    comapany_id = False
    if dados_movimento_item[0].get('capa_id'):
        comapany_id = self.pool.get('estoque.movimento.capa').read(cr, uid, dados_movimento_item[0].
           get('capa_id'),['company_id'], context=context, load='_classic_write').get('comapany_id')
    if not comapany_id:
        comapany_id = self.pool.get('fiscal.nf.capa').read(cr, uid, dados_movimento_item[0].
           get('nf_id'), ['comapany_id'], context=context, load='_classic_write').get('comapany_id')

    grade_ids = map(lambda x: x.get('grade_id'), dados_movimento_item)
    saldos = obj_estoque_produto_saldo.get_saldo_do_dia(cr, uid, grade_ids, data, local_id,
                                                           company_id=comapany_id,
                                                           context=context)
    for movimento in dados_movimento_item:
        res[movimento['id']] = {
            'estmvi_saldo': saldos.get(movimento['grade_id']).get('saldo', 0.0),
            'estmvi_reservada': saldos.get(movimento['grade_id']).get('qtd_reservada', 0.0)}

    return res

# Funcoes da classe estoque_movimento_itens

def _estmvi_get_dados_stored_true(self, cr, uid, ids, name, arg, context=None):
    """
    Busca o dados dos campos funcionais da classe 'estoque.movimento.itens'
    para os campos com stored=True
    @param cr: cursor do banco de dados
    @param uid: id do usuario
    @param ids: lista de id da tabela estoquemovimentos_movimento_item
    @param name: nome do atributo
    @param arg: argumentos
    @param context: dicionario com valores contextuais
    """
    context = context and context.copy() or {}
    res = {}
    # para o inventario nao calcula os custos
    if context.get('atualizacao_inventario'):
        return res

    res.update(_estmvi_get_custos_movimento(self, cr, uid, ids, context))
    return res

def _estmvi_get_custos_movimento(self, cr, uid, ids, context=None):
    """
    Busca os custos para o movimento
    :param cr: a linha atual do cursor do banco de dados
    :param uid: o ID do usuario utilizado para a verificacao de perfil
    :param ids: lista de IDs
    :param context: Dicionario de contextos
    :type cr: object
    :type uid: int
    :type ids: list
    :type context: dict
    :rtype: dict
    :author: Felipe <felipe.franca[at]siginformatica.com.br>
    """
    context = context and context.copy() or {}
    res = {}
    for id in ids:
        res[id] = dict(estmvi_operacao_custo_corrigido_unitario=0.0,
                        estmvi_operacao_custo_medio_contabil_unitario=0.0,
                        estmvi_operacao_ultimo_custo_unitario=0.0,
                        estmvi_operacao_custo_reposicao_unitario=0.0)

    campos = ['capa_id', 'estmvi_entrada_preco_custo_id', 'quantidade',
              'estmvi_saidas_custo_corrigido_total', 'grade_id', 'produto_embalagem_id',
              'estmvi_saidas_custo_medio_contabil_total',
              'estmvi_saidas_ultimo_custo_total', 'estmvi_saidas_custo_reposicao_total']
    dados_itens = self.read(cr, uid, ids, campos, context=context, load='_classic_write')
    # caso os itens nao tenham capa, nao calcula nada
    if not dados_itens[0].get('capa_id'):
        return res

    operacao_id = self.pool.get('estoque.movimento.capa').read(cr, uid,
                     dados_itens[0].get('capa_id'), ['estmvc_operacao_id'], context=context,
                     load='_classic_write').get('estmvc_operacao_id')
    tipo_operacao = self.pool.get('estoque.natureza.operacao').read(cr, uid, operacao_id,
                      ['estnto_tipo_operacao'], context=context).get('estnto_tipo_operacao')
    if tipo_operacao == 'E':
        preco_custo = {}
        preco_custo_ids = list(set(map(lambda x: x.get('estmvi_entrada_preco_custo_id'),
                                       dados_itens)))
        if False in preco_custo_ids:
            preco_custo_ids.remove(False)

        dados_preco_custo = self.pool.get('estoque.preco.custo').read(cr, uid, preco_custo_ids,
                                  ['estprc_custo_corrigido','estprc_custo_medio_contabil',
                                  'estprc_ultimo_custo', 'estprc_custo_reposicao'], context=context)
        map(lambda x: preco_custo.update({x.get('id'): x}), dados_preco_custo)

    grade_ids = map(lambda x: x.get('grade_id'), dados_itens)
    grade_nomes = {}
    map(lambda x: grade_nomes.update({x.get('id'): x.get('name')}),
        self.pool.get('estoque.produto.grade').read(cr, uid, grade_ids, context))
    grade_qtd_emb = self.pool.get('estoque.utils').get_grade_qtd_embalagem(cr, grade_ids, context)
    for item in dados_itens:
        id = item.get('id')
        chave = '%s-%s' % (item.get('grade_id'), item.get('produto_embalagem_id'))
        qtd = item.get('quantidade') * grade_qtd_emb.get(chave).get('qtd')
        custo_corrigido = custo_medio = ultimo_custo = custo_reposicao = 0
        if tipo_operacao == 'E':
            custo_corrigido = preco_custo.get('estprc_custo_corrigido') or 0.0
            custo_medio = preco_custo.get('estprc_custo_medio_contabil') or 0.0
            ultimo_custo = preco_custo.get('estprc_ultimo_custo') or 0.0
            custo_reposicao = preco_custo.get('estprc_custo_reposicao') or 0.0
        elif qtd: # saida e com quantidade
            custo_corrigido = (item.get('estmvi_saidas_custo_corrigido_total') or 0) / qtd
            custo_medio = (item.get('estmvi_saidas_custo_medio_contabil_total') or 0) / qtd
            ultimo_custo = (item.get('estmvi_saidas_ultimo_custo_total') or 0) / qtd
            custo_reposicao = (item.get('estmvi_saidas_custo_reposicao_total') or 0) / qtd

        res[id] = dict(estmvi_operacao_custo_corrigido_unitario=custo_corrigido,
                       estmvi_operacao_custo_medio_contabil_unitario=custo_medio,
                       estmvi_operacao_ultimo_custo_unitario=ultimo_custo,
                       estmvi_operacao_custo_reposicao_unitario=custo_reposicao)

        res[id]['name'] = grade_nomes.get(item.get('grade_id')) or ''

    return res

# Funcoes da classe estoque_preco_custo
def _estprc_nome_name(self, cursor, user, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for produto in self.browse(cursor, user, ids):
        if produto.produto_id:
            res[produto.id] = produto.produto_id.name
        else:
            res[produto.id] = False
    return res

# Funcoes da classe estoque_preco_venda
def _estprv_nome_name(self, cursor, user, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for venda in self.browse(cursor, user, ids):
        if venda.produto_id:
            res[venda.id] = venda.produto_id.name
        else:
            res[venda.id] = False
    return res

# Funcoes da classe estoque_produto


def estpro_get_regime_tributario(self, cr, uid, ids, field_name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'estoque.produto',
                                                                context=context)
    regime_tributario = self.pool.get('res.company').browse(
        cr, uid, company_id, context).rescon_pessoa_id.admpes_jur_regime_tributario
    res = res.fromkeys(ids, regime_tributario)
    return res


def _estpro_preco_venda_produto(self, cr, uid, ids, field, args, context=None):
    context = context and context.copy() or {}
    preco_venda = self.pool.get('estoque.preco.venda').get_preco_venda(cr, uid, ids)
    dict_preco_venda = {}
    map(lambda i: dict_preco_venda.update({i: preco_venda.get(i).get('preco_venda')}), preco_venda)
    return dict_preco_venda


def _estpro_saldo_produto(self, cr, uid, ids, field, args, context=None):
    """
    Funcao para calcular o saldo, requisitados, ou disponivel de uma lista de produtos
    @param self:
    @param cr:
    @param uid:
    @param ids: lista de ids dos produtos
    @param field:
    @param args:
    @param context:
    @return: dicionario de produtos com o resultado da pesquisa(saldo, requisitado ou disponivel)
    """
    context = context and context.copy() or {}
    res = self.estpro_get_saldo(cr, uid, ids, pesquisar="S", local=None, context=None)
    return res


def estpro_function_get_estparametro(self, cr, uid, ids, fields_name, args, context=None):
    context = context and context.copy() or {}
    if isinstance(ids, (int, long)):
        ids = [ids]
    codigo_parametro = self.pool.get('estoque.produto').estpro_get_estoque_parametro_codigo(cr, uid, context=context)
    res = {}.fromkeys(ids, codigo_parametro)
    return res


def _estpro_get_parametro_comercializa_combustivel_lubrificante(self, cr, uid, ids, field, args, context=None):
    res = {}
    context = context and context.copy() or {}
    company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name)
    obj_estoque_parametro = self.pool.get('estoque.parametro')
    estoque_parametro_id = obj_estoque_parametro.search(cr, uid, [('company_id', '=', company_id)], context=context)
    parametro = obj_estoque_parametro.browse(cr, uid, estoque_parametro_id[
        0]).estpar_comercializa_combustivel_lubrificante or False
    for x in ids:
        res[x] = parametro
    return res


def _estpro_get_locais(self, cr, uid, ids, field_names, arg=None, context=None):
    context = context and context.copy() or {}
    result = {}
    if not ids: return result
    itens = self.browse(cr, uid, ids)
    for item in itens:
        locais = ''
        for locacao in item.locacao_ids:
            locais += formatastring.formataString(locacao.local_id.numero, 3, '0', 'E') + ','
        if locais:
            locais = locais[:-1]
        result[item.id] = locais
    return result


def _estpro_ajuste_locais(self, cr, uid, ids, context=None):
    result = {}
    if not ids: return result
    context = context and context.copy() or {}
    itens = {}
    for locacao in self.pool.get('estoque.local.locacao').browse(cr, uid, ids, context):
        itens[locacao.produto_id.id] = True
    for item_id in list(itens):
        locais = ''
        locacao_ids = self.pool.get('estoque.local.locacao').search(cr, uid, [('produto_id', '=', item_id)],
                                                                    context=context)
        for locacao in self.pool.get('estoque.local.locacao').browse(cr, uid, locacao_ids, context):
            locais += formatastring.formataString(locacao.local_id.numero, 3, '0', 'E') + ','
    if locais:
        locais = locais[:-1]
    result[item_id] = locais
    return result


def _estpro_verifica_pcp_instalado(self, cr, uid, ids, field, args, context=None):
    context = context and context.copy() or {}
    _pcp = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'pcp', context)
    res = {}.fromkeys(ids, _pcp)
    return res


def _estpro_get_unidade_para_inventario(self, cr, uid, ids, field_name, args, context=None):

    """
    A funcao vai retornar a unidade que possuir a menor quantidade na embalagem, ou se possuir
    somente uma embalagem, retorna a unidade da mesma. Se houver o caso onde as embalagens
    possuem a mesma quantidade na embalagem, considerar a primeira encontrada.
    """

    context = context and context.copy() or {}
    res = {}
    brw_estoque_produto = self.browse(cr, uid, ids, context)
    servico_embalagem_id = self.pool.get('adm.utils').admutl_get_parametros(
        cr, uid, 'estoque', 'estpar_embalagem_servico_id', context=context).get(
        'estpar_embalagem_servico_id')
    servico_embalagem_unidade = str()
    if servico_embalagem_id:
        servico_embalagem_unidade = self.pool.get('estoque.embalagem').browse(
            cr, uid, servico_embalagem_id, context).unidade_id.unidade or ''
    for produto in brw_estoque_produto:
        unidade = ''
        produto_embalagem_ids = produto.produto_embalagem_ids
        if produto.tipo == 'S':
            unidade = servico_embalagem_unidade
        elif len(produto_embalagem_ids) == 1:
            unidade = produto_embalagem_ids[0].embalagem_id.unidade_id.unidade or ''
        else:
            dict_qtd_embalagem_unidade = dict()
            list_qtd_embalagem = list()
            for produto_embalagem in produto_embalagem_ids:
                embalagem_id = produto_embalagem.embalagem_id
                qtd_embalagem = embalagem_id.quantidade_na_embalagem
                list_qtd_embalagem.append(qtd_embalagem)
                if not qtd_embalagem in dict_qtd_embalagem_unidade:
                    dict_qtd_embalagem_unidade[qtd_embalagem] = embalagem_id.\
                        unidade_id.unidade or ''
            list_qtd_embalagem.sort()
            if list_qtd_embalagem:
                unidade = dict_qtd_embalagem_unidade.get(list_qtd_embalagem[0])
        res[produto.id] = unidade
    return res


def _estpro_check_cadastro_produto(self, cr, uid, ids, context=None):
    """
    Metodo para validar o cadastro do produto
    """
    context = context and context.copy() or {}
    res = True
    for produto in self.read(cr, uid, ids, ['active', 'name', 'company_id'], context=context,
                             load='_classic_write'):
        active = produto.get('active')
        if not active:
            continue
        name = produto.get('name')
        company_id = produto.get('company_id')
        produto_ids = self.search(cr, uid, [('company_id', '=', company_id),
                                            ('name', '=', name)], context=context)
        if len(produto_ids) > 1:
            res = False
    return res


def _estpro_get_codigo_fornecedor(self, cr, user, ids, field_name, args, context=None):
    """
    Recupera o codigo do produto de um fornecedor proprio. Eh o codigo interno do produto para o
    fornecedor.

    :param cr: o cursor do banco de dados
    :param user: o ID do usuario utilizado para a verificacao de perfil
    :param ids: lista com o ID dos itens
    :param field_name:
    :param args:
    :param context: um dicionario padrao para valores contextuais,
    :type cr: object
    :type user: int
    :type ids: list
    :type field_name: str
    :type args: list
    :type context: dict
    :return: os codigos do produto (no fornecedor)
    :rtype: list

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """
    context = context and context.copy() or {}
    result = {}.fromkeys(ids, list())
    for brw_item in self.browse(cr, user, ids, context=context):
        codigo_ids = list()  # Lista com o ID dos codigos do item nos fornecedores
        for brw_grade in brw_item.produto_grade_ids:
            codigo_ids.extend(map(lambda m: m.codigo_fornecedor, brw_grade.produto_codigo_fornecedor_ids))
        result[brw_item.id] = list(set(codigo_ids))

    return result


def _estpro_search_codigo_fornecedor(self, cr, user, obj, name, args, context=None):
    """
    Permite definir a pesquisa que serah realizada para o metodo da classe (campo da tabela).

    :param cr: o cursor do banco de dados
    :param user: o ID do usuario utilizado para a verificacao de perfil
    :param obj: a classe que representa a tabela ´estoque_produto´
    :param field_name: o nome ou os nomes dos atributos (campos)
    :param args: uma lista de argumentos utilizada na consulta
    :param context: um dicionario padrao para valores contextuais,
    :type cr: object
    :type user: int
    :type obj: object
    :type name: str | list
    :type arg: list
    :type context: dict
    :return: uma nova lista de argumentos para a consulta.
    :rtype: list

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """
    context = context and context.copy() or {}
    sql = unicode("""
        SELECT
            DISTINCT produto_id
        FROM
            estoque_produto_codigo_fornecedor
        WHERE
            codigo_fornecedor {operador} '{codigo_fornecedor}'
    """).format(operador=args[0][1], codigo_fornecedor=args[0][2])
    cr.execute(sql)
    produto_ids = cr.dictfetchall()
    produto_ids = map(lambda p: p.get('produto_id'), produto_ids)
    return [('id', 'in', produto_ids)]

# Funcoes da classe estoque_produto_grade
def _estpgr_get_dados(self, cr, user, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    o_saldo = self.pool.get('estoque.produto.saldo')
    res_saldo = o_saldo.get_saldo_do_dia(cr, user, ids, time.strftime('%Y-%m-%d'), context=context)
    estoque_parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(
        cr, user, 'estoque', ['estpar_forma_execucao_curva'])
    forma_execucao_curva = estoque_parametro_dados.get('estpar_forma_execucao_curva')
    for grade_id in ids:
        res[grade_id] = {
            'saldo': res_saldo.get(grade_id).get('disponivel', 0.0),
            'estpgr_qtd_reservada': res_saldo.get(grade_id).get('qtd_reservada', 0.0),
            'estpgr_forma_curva': forma_execucao_curva
        }

    return res


def _estpgr_get_name(self, cr, uid, ids, field, args, context=None):
    res = {}
    context = context and context.copy() or {}
    obj_estoque_produto = self.pool.get('estoque.produto')
    estoque_parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(
        cr, uid, 'estoque', ['estpar_descricao_grade'])
    descricao_grade = None
    if estoque_parametro_dados.get('estpar_descricao_grade') == 'P':
        descricao_grade = True
    produto_grade_dados = self.read(cr, uid, ids, ['id', 'grade', 'descricao', 'produto_id'],
                                    context=context)
    for record in produto_grade_dados:
        nome_produto = ''
        id = record.get('id')
        descricao = str(record.get('descricao').encode('utf-8') or '*** Grade sem Descricao ***')
        result = '%s' % descricao
        if descricao_grade:
            produto_id = record.get('produto_id')
            if produto_id and isinstance(produto_id, tuple):
                produto_id = produto_id[0]

            dados_produto = obj_estoque_produto.read(cr, uid, produto_id, ['name'], context=context)
            nome_produto = str(dados_produto.get('name').encode('utf-8'))
            if record.get('grade') == 'UN':
                descricao = ''

            result = '%s%s%s' % (nome_produto, ' - ' if descricao else '', descricao)

        if len(result) > 63:
            result = result[0:63]
        res[id] = result
    return res


#Funcoes da classe estoque_inventario_central_itens
def _estici_get_qtd_acerto(self, cr, uid, ids, name_fields, args, context=None):
    res = {}
    context = context and context.copy() or {}
    obj_estoque_inventario_central_acertos = self.pool.get('estoque.inventario.central.acertos')
    for id in ids:
        soma_acertos = 0
        acertos_ids = obj_estoque_inventario_central_acertos.search(cr, uid, [('estica_item_id', '=', id)],
                                                                    context=context)
        acertos_dados = obj_estoque_inventario_central_acertos.browse(cr, uid, acertos_ids)
        for i in acertos_dados:
            soma_acertos += i.estica_qtd_acerto
        res[id] = soma_acertos

    return res

#Funcoes da classe estoque_inventario_central_empresas
def _get_atualizado(self, cr, uid, ids, arg, name, context=None):
    res = {}
    context = context and context.copy() or {}
    obj_estoque_inventario_capa = self.pool.get('estoque.inventario.capa')
    estice_dados = self.pool.get('estoque.inventario.central.empresas').browse(cr, uid, ids)
    for i in estice_dados:
        empresa_id = i.estice_empresa_id.id
        ano = i.estice_capa_id.esticc_ano
        mes = i.estice_capa_id.esticc_mes
        capa_id = obj_estoque_inventario_capa.search(cr, uid, [('company_id', '=', empresa_id), ('ano', '=', ano),
                                                               ('mes', '=', mes)], context=context)
        atualizado = False
        if capa_id:
            atualizado = obj_estoque_inventario_capa.read(cr, uid, capa_id[0], ['atualizado'], context=context)
            atualizado = atualizado.get('atualizado')
        res[i.id] = atualizado

    return res

#Fucoes da classe estoque.produto.embalagem
def _estpre_unidade_produto(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for est in self.browse(cr, uid, ids, context=context):
        res[est.id] = False
        if est.embalagem_id:
            res[est.id] = est.embalagem_id.unidade_id.unidade
    return res

def _estpre_cubagem(self, cr, uid, ids, name, arg, context=None):
    """
    Calculo do volume da embalagem. (em metros cubicos - m3)

    @param cr: {cursor} a linha atual do cursor do banco de dados,
    @param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    @param ids: {list} lista dos IDs,
    @param name: {list} lista com o nome dos campos,
    @param arg: {dict} dicionario com os argumentos e valores,
    @param context: {dict} um dicionario padrao para valores contextuais,
    @return: {dict} produto entre a altura, largura e profundidade da embalagem.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    context = context and context.copy() or {}

    if ids and isinstance(ids, (int, long)):
        ids = [ids]

    result = {}

    for embalagem in self.browse(cr, uid, ids):
        altura = embalagem.altura or 0.00  # Altura em centimetros
        largura = embalagem.largura or 0.00  # Largura em centimetros
        profundidade = embalagem.profundidade or 0.00  # Profundidade em centimetros

        result[embalagem.id] = altura * largura * profundidade / 1000000  # Volume em m3

    return result

# Funcoes da classe estsug_compra_capa


def esgccp_verificar_estoquepedidos_instalado(self, cr, uid, ids, fields_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    estoquepedidos_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(
        cr, uid, 'estoquepedidos', context)
    brw_estsug_compra_capa = self.browse(cr, uid, ids, context)
    for x in brw_estsug_compra_capa:
        res[x.id] = estoquepedidos_instalado
    return res

def estmvc_get_dados_capa_stored_true(self, cr, uid, ids, fields_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    if not ids:
        return res

    for capa in self.browse(cr, uid, ids, context=context):
        id = capa.id
        res[id] = {}
        origem = capa.estmvc_operacao_id.estnto_movimento_origem_id.estmog_codigo
        res[id].update({'estmvc_origem': origem})
        # NOTAS FISCAIS
        if origem == 'N':
            try:
                res[id].update({'pessoa_id': capa.nf_capa_id.destinatario_id.id})
                res[id].update({'numero_documento': 'NF: %d / %s' % (capa.nf_capa_id.numero_nf,
                                                                       capa.nf_capa_id.serie_nf)})
            except:
                pass
        # CUPONS
        elif origem == 'C':
            try:
                res[id].update({'pessoa_id': capa.cupons_capa_id.cliente_id.id})
                numero_documento = capa.cupons_capa_id.coo
                if not numero_documento:
                    numero_documento = id
                res[id].update({'numero_documento': 'COO: %s' % numero_documento})
            except:
                pass
        # REQUISICAO ALMOXARIFADO
        elif origem == 'R':
            try:
                res[id].update({'pessoa_id': capa.requisicao_id.funcionario_id.pessoa.id})
                numero_documento = capa.requisicao_id.numero
                if not numero_documento:
                    numero_documento = id
                res[id].update({'numero_documento': 'REQUISICAO: %s' % numero_documento})
            except:
                pass
            # REQUISICAO RESSUPRIMENTO (NAO POSSUI FUNCIONARIO OU CLIENTE)
        elif origem == 'S':
            try:
                numero_documento = capa.requisicaoressuprimento_id.numero
                if not numero_documento:
                    numero_documento = id
                res[id].update({'numero_documento': 'RESSUPRIMENTO: %s' % numero_documento})
            except:
                pass

        elif origem == 'I':
            try:
                numero_documento = capa.inventario_id.descricao
                if not numero_documento:
                    numero_documento = id
                res[id].update({'numero_documento': 'INVENTARIO: %s' % numero_documento})
            except:
                pass
        elif origem == 'P':
            try:
                numero_documento = capa.estmvc_ordem_producao_id.pcpopr_numero
                if not numero_documento:
                    numero_documento = id
                res[id].update({'numero_documento': 'ORDEM PRODUCAO: %s' % numero_documento})
            except:
                pass
        elif context.get('composicao_capa_id'):
            res[id].update({'numero_documento': 'COMPOSICAO-%s-%s' % (
                context.get('composicao_movimento_tipo'), context.get('composicao_capa_id'))})
        else:
            try:
                res[id].update({'numero_documento': '%s' % id})
            except:
                pass

    return res

def esgccp_get_dias_mes_atual(self, cr, uid, ids, field_name, arg, context=None):
    """
    Metodo de atributo funcional. Busca o dia da data atual que representa a quantidade de dias que
    serao considerados para a sugestao.
    :param cr: cursor no banco de dados.
    :type cr: object
    :param uid: id da tabela res_users, identificador do usuario.
    :type uid: int
    :param ids: registros da tabela desse objeto.
    :type ids: list
    :param field_name: descricao do atributo funcional.
    :type field_name: str
    :param arg: argumentos de pesquisa.
    :type arg: list
    :param context: dicionario com valores contextuais.
    :type context: dict
    :return: dados dos registros da tabela com suas respectivas quantidades.
    :rtype: dict
    """
    context = context and context.copy() or {}
    res = {}
    for sugestao in self.browse(cr, uid, ids, context):
        res[sugestao.id] = 0
        if not sugestao.esgccp_mes_atual:
            continue
        res[sugestao.id] = datetime.now().day
    return res


#Funcoes para a classe estoque_produt_saldo
def _estpsa_get_reservada(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    if not ids:
        return res
    grade_ids = []
    brw_saldo = self.browse(cr, uid, ids, context=context)
    for x in brw_saldo:
        grade_ids.append(x.grade_id.id)
    dados = self.pool.get('estoque.produto.grade').estgrd_get_requisitado(cr, uid, grade_ids, context=None)
    for x in brw_saldo:
        _qtd = 0.0
        if dados and dados.get(x.grade_id.id):
            dados_grade = dados.get(x.grade_id.id)
            _qtd = dados_grade.get(x.local_id.id, 0.0)
        res[x.id] = _qtd
    return res

# classe estoque_inventario_correcao
def _estico_get_company_id(self, cr, uid, ids, field_name, args, context=None):
    res = {}
    load = '_classic_write'
    dados = self.read(cr, uid, ids, ['estico_inventario_id'], context=context, load=load)
    inventario_ids = map(lambda x: x.get('estico_inventario_id'), dados)
    dict_inventario = {}
    map(lambda x: dict_inventario.update({x.get('id'): x.get('company_id')}),
        self.pool.get('estoque.inventario.capa').read(cr, uid, inventario_ids,
                                                      ['company_id'], context, load))
    for correcao in dados:
        res[correcao.get('id')] = dict_inventario.get(correcao.get('estico_inventario_id'))

    return res


