# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_inventario_capa(osv.Model):
    """
      Prefixo da Classe estoque_inventario_capa: ESTICP
      """

    _name = 'estoque.inventario.capa'

    from funcoes import _esticp_getAnoMesDescricao, _esticp_get_total_custo, esticp_get_texto

    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True,
                                      select=True),  # id da empresa\n
        'name': fields.function(_esticp_getAnoMesDescricao, method=True, string='Inventario',
                                type='text', store=False),
        'descricao': fields.char('Descricao', size=30, required=True),  # Descricao do Inventario
        'ano': fields.char('Ano', size=4, required=True),  # Ano do inventario
        'mes': fields.char('Mes', size=2, required=True),  # Mes do inventario
        'local_id': fields.many2one('estoque.local', 'Local',
                                    domain="[('company_id', '=', company_id)]"),
        'create_date': fields.datetime('Data Criacao Inventario'),  # Data da criacao do inventario
        'id': fields.integer('ID'),
        'inventario_contagem_ids': fields.one2many('estoque.inventario.contagem', 'inventario_id',
                                                   'Contagem'),
        'inventario_oficial_ids': fields.one2many('estoque.inventario.oficial', 'capa_id',
                                                  'Oficial'),
        'atualizado': fields.boolean('Saldo Atualizado'),
        'create_uid': fields.many2one('res.users', 'Usuario', readonly=True, ondelete="restrict"),
        'total_saldo_ultimo_custo': fields.function(_esticp_get_total_custo, method=True,
                                                    multi='custo',
                                                    string='Total Saldo x Ultimo Custo',
                                                    type='float', store=True),
        'total_saldo_custo_medio': fields.function(_esticp_get_total_custo, method=True,
                                                   multi='custo',
                                                   string='Total Saldo x Custo Medio', type='float',
                                                   store=True),
        'esticp_data_livro_inventario': fields.date('Data livro inventario'),
        'esticp_text': fields.function(esticp_get_texto, method=True, string='Texto', type='char',
                                       size=92, store=False),

    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }
    _order = 'create_date DESC'
