# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_inventario_contagem(osv.Model):
    """
    Tabela de itens do inventario
    Prefixo da Classe estoque_inventario_contagem: ESTICT
    """
    _name = 'estoque.inventario.contagem'

    from funcoes import _estict_getItem

    _columns = {
        'name': fields.function(_estict_getItem, method=True, string='Inventario', type='text', store=False),
        'inventario_id': fields.many2one("estoque.inventario.capa", 'Inventario', ondelete="cascade", required=True,
                                         select="1"), # id do inventario
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="restrict", required=True,
                                      domain="[('tipo', '=', 'P')]"), # Produto
        'grade_id': fields.many2one("estoque.produto.grade", 'Grade', ondelete="cascade", required=True,
                                    domain="[('produto_id', '=', produto_id)]"), # Id do produto a ser pedido\n
        'estict_custo_medio_contabil': fields.float('Custo Medio Contabil', digits=(15, 5), oldname="custo_medio_contabil"), # Custo medio Contabil do produto
        'estict_ultimo_custo': fields.float('ultimo Custo', digits=(15, 5), oldname="ultimo_custo"), # Ultimo custo do produto
        'funcionario_id': fields.many2one("rh.funcionario", 'Funcionario', ondelete="set null"),
        'conferido': fields.boolean('Conferido'), #verifica se o registro esta conferido(informacao)
        'saldo_cadastro': fields.float('Saldo Cadastro', digits=(14, 5)), # Saldo no cadastro na hora da contagem
        'saldo_contado': fields.float('Saldo contado', digits=(15, 5)), # saldo contado
        'requisitado': fields.float('Requisitado', digits=(14, 5)), # Quantidade requisitada no momento da contagem\n
        'locacao_id': fields.many2one("estoque.local.locacao", 'Locacao', ondelete="no action", required=False,
                                      domain="[('grade_id', '=', grade_id)]"), # Locacao do produto
        'local_id': fields.many2one('estoque.local', 'Local', ondelete='restrict', required=True), # Id do local
        'estict_item_atualizado':fields.boolean('Item atualizado'),

    }

    _order = 'local_id , produto_id'

    _defaults = {
        'estict_item_atualizado':False
    }