# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_inventario_oficial(osv.Model):
    """
    Tabela oficial para emissao do livro Registro de inventario
    """
    _name = 'estoque.inventario.oficial'

    from funcoes import _estiof_getItem

    _columns = {
        'name': fields.function(_estiof_getItem, method=True, string='Inventario', type='text', store=False),
        'saldo': fields.float('Saldo', digits=(14, 5), required=True), # quantidade contada\n
        'estiof_custo_medio_contabil': fields.float('Custo Medio Contabil', digits=(15, 5),
                                                    oldname="custo_medio_contabil"),
        'estiof_ultimo_custo': fields.float('ultimo custo', digits=(15, 5), oldname="ultimo_custo"), # Valor do ultimo custo do item\n
        'capa_id': fields.many2one("estoque.inventario.capa", 'Capa', ondelete="cascade", required=True, select=True),
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="restrict", required=True, select=True,
                                      domain="[('tipo', '=', 'P')]"), # Produto
        'grade_id': fields.many2one("estoque.produto.grade", 'Grade', ondelete="cascade", required=True, select=True,
                                    domain="[('produto_id', '=', produto_id)]"), # Id do produto a ser pedido\n
    }

