# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_local(osv.Model):
    """
    Tabela de locais de armazenagem.

    prefixo: estlcl_
    """
    _name = 'estoque.local'
    _roteavel = True
    _columns = {
        'id': fields.integer(),
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'name': fields.char('Nome local', size=30, required=True), # Descricao, nome do local
        'excluir_consultas': fields.boolean('Excluir Consultas'), # Flag que indica se nas consultas os produtos deste local serao excluidos.
        'aceita_saldo_negativo': fields.boolean('Aceita Saldo Negativo'), # Flag que indica se o local aceita Saldo Negativo
        'local_locacao_ids': fields.one2many('estoque.local.locacao', 'local_id', 'Locacao'),
        'movimento_itens_ids': fields.one2many('estoque.movimento.itens', 'local_id', 'Itens'),
        'active': fields.boolean('Ativo'), # Indica que o local esta ativo
        'numero': fields.integer('Numero', required=True, select=True),
        'centrocusto_id': fields.many2one("adm.empresa.centrocusto", 'Centro de custo', ondelete="restrict", select=True), # Centro de custo do rateio
    }
    _sql_constraints = [
        ('numero_uniq', 'unique (company_id, numero)', 'O numero do local precisa ser unico!'), ]
    _defaults = {
        'active': lambda *a: True,
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }
