# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_local_locacao(osv.Model):
    from funcoes import _estllc_get_saldo

    _name = 'estoque.local.locacao'
    _roteavel = True
    _rec_name = 'locacao'
    _columns = {
        'id': fields.integer(),
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True),
        'locacao': fields.char('Locacao', size=15, required=False), # locacao
        'altura': fields.integer('Altura'), # altura em centimetros\n
        'largura': fields.integer('Largura'), # largura em cm
        'profundidade': fields.integer('Profundidade'), # profundidade em centimetros\n
        'data_validade': fields.date('Data Validade'), # data de validade do produto\n
        'repositor_id': fields.many2one("rh.funcionario", 'Repositor', ondelete="set null"), # id do repositor
        'local_id': fields.many2one("estoque.local", 'Local', ondelete="restrict", required=True, select=True),
        'active': fields.boolean('Ativa'),
        'flag': fields.boolean('Flag'),
        'create_date': fields.datetime('Data Criacao'), # Data da criacao
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="cascade", required=True, select=True),
        'grade_id': fields.many2one("estoque.produto.grade", 'Grade', ondelete="cascade", required=True,
                                    domain="[('produto_id', '=', produto_id)]", select=True), # Id do produto
        'inventario_contagem_ids': fields.one2many('estoque.inventario.contagem', 'locacao_id', 'Contagem'),
        'estllc_produto_embalagem_id': fields.many2one('estoque.produto.embalagem', 'Embalagem', ondelete="restrict",
                                                       required=False, oldname='embalagem_id'),
        'saldo': fields.function(_estllc_get_saldo, multi='saldo', method=True, string='Saldo', type='float',
                                 store=False),
        'estllc_qtd_reservada': fields.function(_estllc_get_saldo, multi='saldo', method=True,
                                                string='Quantidade reservada', type='float', store=False),
    }
    _defaults = {
        'active': lambda *a: True,
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }

    _order = 'local_id'
