# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class estoque_movimento_capa(osv.Model):
    """
    Tabela de movimento do estoque(Capa)
    """

    from funcoes import _estmvc_name_data, estmvc_get_dados_capa_stored_true


    _name = 'estoque.movimento.capa'
    _roteavel = True
    _order = 'data desc'
    _columns = {
        # ___________________________ Integer ________________________________
        'id': fields.integer('id', readonly="1"),

        # ___________________________ Many2One _______________________________
        'company_id': fields.many2one('res.company', 'Empresa', ondelete='cascade', required=True,
                                      select=True),
        'funcionario_id': fields.many2one('rh.funcionario', 'Funcionario', ondelete='restrict',
                                          required=True, select=True,
                                          domain="[('company_id', '=', company_id)]"),
        'inventario_id': fields.many2one('estoque.inventario.capa', 'Inventario',
                                         ondelete='set null', required=False),
        'estmvc_operacao_id': fields.many2one('estoque.natureza.operacao', 'Operacao',
                                              required=True, select=True, ondelete='restrict'),

        # ___________________________ One2Many _______________________________
        'movimento_itens_ids': fields.one2many('estoque.movimento.itens', 'capa_id', 'Itens'),

        # ___________________________ Date ___________________________________
        'data': fields.date('Data movimento', required=True, select=True),  # Data movimento
        'create_date': fields.datetime('Data lancamento', readonly=True),

        # ___________________________ Function _______________________________
        'name': fields.function(_estmvc_name_data, method=True, string='name', type='char',
                                size=24),
        'pessoa_id': fields.function(estmvc_get_dados_capa_stored_true, method=True, string='Pessoa',
                                     multi='get_dados', type='integer', store=True, select=True),
        'numero_documento': fields.function(estmvc_get_dados_capa_stored_true, method=True,
                                            multi='get_dados',
                                            string='Nro documento', type='char', store=True),
        'estmvc_origem': fields.function(estmvc_get_dados_capa_stored_true, method=True,
                                         type='char',multi='get_dados',string='Origem', store=True),

        # ___________________________ Selection ______________________________

        'state': fields.selection([('E', 'Esboco'), ('F', 'Efetivada'), ('C', 'Cancelada')],
                                  'Estado', size=1),
    }

    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, s._name, context=c),
        'data': time.strftime("%Y-%m-%d"),
        'state': 'E'
    }

