# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2015 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2015, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


# noinspection PyAbstractClass,PyPep8Naming
class estoque_movimento_origem(osv.Model):
    """
    Identifica a origem do movimento para operacoes de entrada ou saida.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'estoque.movimento.origem'  # estmog

    _columns = {
        # ___________________________ Char ___________________________________
        'estmog_codigo': fields.char('Codigo', size=1, required=True, select=True),
        'name': fields.char('Descricao', size=20, required=True, select=True)
    }

    _sql_constraints = [
        ('estmog_codigo_unique', 'unique (estmog_codigo)', 'Este codigo ja esta cadastrado.')
    ]

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
