# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_preco_custo(osv.Model):
    """
    Tabela de precos de custos dos produtos

    prefixo: estprc_
    """
    _name = 'estoque.preco.custo'

    from funcoes import _estprc_nome_name

    _roteavel = True
    _columns = {
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="cascade", required=True, select=True),
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True), # Id da empresa
        'create_date': fields.datetime('Data criacao', readonly=True, select=True),
        # Data da criacao dos custos
        'estprc_custo_corrigido': fields.float('Custo Corrigido', digits=(15, 5), oldname="custo_corrigido"), # Custo corrigido do produto(medio)
        'estprc_custo_medio_contabil': fields.float('Custo Medio Contabil', digits=(15, 5), oldname="custo_medio_contabil"), # Custo medio contabil
        'estprc_ultimo_custo': fields.float('ultimo Custo', digits=(15, 5), oldname="ultimo_custo"), # Ultimo custo. Custo da ultima nota
        'estprc_custo_reposicao': fields.float('Custo Reposicao', digits=(15, 5), oldname="custo_reposicao"), # Custo de reposicao
        'name': fields.function(_estprc_nome_name, method=True, string='name', type='text', store=False),
        'active': fields.boolean('Active'),
        'estprc_data': fields.datetime('Data', required=True, select=True)
        # Data da geracao dos custos
    }
    # =======> Atencao <======== #
    # =======> Nunca buscar os custos direto de um read, usar a funcao get_custos_do_dia <=====================================================================
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        'estprc_custo_corrigido': lambda *a: 0,
        'estprc_custo_medio_contabil': lambda *a: 0,
        'estprc_ultimo_custo': lambda *a: 0,
        'estprc_custo_reposicao': lambda *a: 0,
        'active': True,
    }
    _order = 'estprc_data desc'
