# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_preco_venda(osv.Model):
    """
    Tabela de preco de venda dos produtos

    prefixo: estprv_
    """
    _name = 'estoque.preco.venda'
    _order = 'create_date desc, id desc'

    from funcoes import _estprv_nome_name

    _roteavel = True
    _columns = {
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="cascade", required=True, select=True),
        # id do produto
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'create_date': fields.datetime('Data'), # Data da criacao do preco
        'create_uid': fields.many2one('res.users', 'Usuario', readonly=True, select=True),
        'preco_venda': fields.float('Preco venda', digits=(14, 5)), # Preco de venda do produto
        'name': fields.function(_estprv_nome_name, method=True, string='name', type='text', store=False),
    }
    # =======> Atencao <======== #
    # =======> Nunca buscar o preco de venda direto de um read, usar a funcao get_preco_venda <=====================================================================
    _defaults = {
        'preco_venda': lambda *a: 0,
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }
