# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_produto_codigo_fornecedor(osv.Model):
    """
    Tabela de codigos de fabricantes
    """
    _name = 'estoque.produto.codigo.fornecedor'
    _roteavel = True
    _rec_name = 'codigo_fornecedor'
    _columns = {
        # A empresa para essa tabela deve seguir a empresa do produto.
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True),
        'fornecedor_id': fields.many2one("financeiro.fornecedor", 'Fornecedor', ondelete="cascade",
                                         required=True),
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="cascade",
                                      required=True, select=True,
                                      domain="[('tipo', '=', 'P')]"),  # Produto
        'grade_id': fields.many2one("estoque.produto.grade", 'Grade', ondelete="cascade",
                                    required=True, select=True,
                                    domain="[('produto_id', '=', produto_id)]"),  # Grade
        'codigo_fornecedor': fields.char('Codigo Fornecedor', size=20, required=True, select=True),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'estoque.produto.codigo.fornecedor', context=c),
    }
