# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_produto_embalagem(osv.Model):

    """
        Produto e Embalagens.
        prefixo :ESTPRE
        """
    from funcoes import _estpre_unidade_produto
    from funcoes import _estpre_cubagem

    _name = 'estoque.produto.embalagem'
    _rec_name = 'embalagem_id'

    _columns = {
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="cascade", select=True,
                                      domain="[('tipo', '=', 'P')]", required=True), # Produto
        'embalagem_id': fields.many2one("estoque.embalagem", 'Embalagem', ondelete="restrict", required=True),
        'peso_liquido': fields.float('Peso Liquido (Kg)', digits=(9, 3)), # Peso liquido da embalagem
        'peso_bruto': fields.float('Peso Bruto (Kg)', digits=(9, 3)), # Peso bruto da embalagem
        'active': fields.boolean('Ativo'), # Active
        'altura': fields.float('Altura (cm)', digits=(9, 2), help="*Altura da embalagem medida em cm "),
        'largura': fields.float('Largura (cm)', digits=(9, 2), help="Largura da embalagem medidoa em cm "),
        'profundidade': fields.float('Profundidade (cm)', digits=(9, 2),
                                     help="Profundidade da embalagem medida em cm "),
        'estpre_cubagem': fields.function(_estpre_cubagem, method=True, store=False, type='float',
                                          digits=(15, 6), string='Volume(m3)'),
        #  ATENCAO: O atributo 'estpre_unidade_produto' abaixo eh usado em demais pontos do codigo.
        # Caso seja preciso altera-lo ou ate remove-lo, atentar-se para adaptar nos outros locais.
        'estpre_unidade_produto': fields.function(_estpre_unidade_produto, type="char", size=3,
                                                  method=True, store=True, string='Unidade'),
    }

    _defaults = {
        'active': lambda *a: True,
    }
