# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_produto_saldo(osv.Model):
    """
    Tabela de Saldos dos produtos
    """
    from funcoes import _estpsa_get_reservada

    _name = 'estoque.produto.saldo'
    _columns = {
        'data_movimento': fields.date('Data Movimento', required=True, select=True),
        # Data do saldo | Nao trocar nome desta coluna, usado no metodo _auto_init
        'saldo': fields.float('Saldo', digits=(14, 5), required=True), # Saldo do produto
        'local_id': fields.many2one("estoque.local", "Local", required=True,select=True),
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True,select=True), # id da empresa\n
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="cascade", select=True, required=True,
                                      domain="[('tipo', '=', 'P')]"), # Produto
        'grade_id': fields.many2one("estoque.produto.grade", 'Grade', ondelete="cascade", required=True,
                                    domain="[('produto_id', '=', produto_id)]",select=True),
        'estpsa_qtd_reservada': fields.function(_estpsa_get_reservada, method=True, type='float', digits=(14, 3),
                                             string='Quantidade reservada', store=False),
    }
    _order = 'company_id,local_id,produto_id,grade_id,data_movimento desc'
    _sql_constraints = [
        ('estoque_produto_saldo_uniq', 'unique (company_id,local_id,produto_id,grade_id,data_movimento)',
         'Empresa,local,produto, grade e data precisam ser unicos!'),
    ]
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }

