# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_produto_similaridade(osv.Model):
    _name = 'estoque.produto.similaridade'
    _inherits = {'estoque.produto': 'produto_similar_id'}
    _rec_name = 'produto_original_id'
    _columns = {
        'produto_original_id': fields.many2one("estoque.produto", 'Produto Original', ondelete="restrict",
                                               required=True),
        'produto_similar_id': fields.many2one("estoque.produto", 'Produto Similar', ondelete="restrict", required=True,
                                              domain="[('tipo', '=', 'P')]")
    }
    _sql_constraints = [
        ('similar_uniq', 'unique (produto_original_id, produto_similar_id)', 'Somente um produto por similaridade')
    ]


