# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools import drop_view_if_exists


class estoque_inventario_contagem_pgview(osv.Model):

    _name = "estoque.inventario.contagem.pgview"
    _auto = False
    _columns = {
        'esticp_inventario_id': fields.many2one("estoque.inventario.capa", 'Inventario',
                                                sequence=True),
        'esticp_locacao_id': fields.many2one('estoque.local.locacao', 'Locacao', sequence=True),
        'esticp_locacao': fields.char('Locacao', size=15),
        'esticp_local_id': fields.many2one('estoque.local', 'Local'),
        'esticp_produto_id': fields.many2one('estoque.produto', 'Produto'),
        'esticp_codigo_item': fields.char('Codigo item', size=20),
        'esticp_grade_id': fields.many2one('estoque.produto.grade', 'Grade'),
        'esticp_descricao': fields.char('Descricao', size=50),
        'esticp_codigo_fabricante': fields.char('Codigo fabricante', size=20),
        'esticp_saldo_contado': fields.float('Saldo contado', digits=(15, 5)),
        'esticp_saldo_cadastro': fields.float('Saldo cadastro', digits=(15, 5)),
        'esticp_nivel_categoria': fields.char('Codigo fabricante', size=20),
        'esticp_categoria_id': fields.many2one('estoque.categoria', 'Categoria', sequence=True),
    }

    def init(self, cr):
        sql = """
            CREATE OR REPLACE VIEW estoque_inventario_contagem_pgview AS(
                SELECT
                    Row_number() OVER (ORDER BY contagem.id) AS id,
                    inventario.id AS esticp_inventario_id,
                    contagem.locacao_id AS esticp_locacao_id,
                    ell.locacao as esticp_locacao, 
                    contagem.local_id AS esticp_local_id,
                    contagem.produto_id AS esticp_produto_id,
                    produto.name AS esticp_descricao,
                    produto.codigo AS esticp_codigo_item,
                    contagem.grade_id AS esticp_grade_id,
                    grade.codigo_no_fabricante AS esticp_codigo_fabricante,
                    contagem.saldo_contado AS esticp_saldo_contado,
                    contagem.saldo_cadastro AS esticp_saldo_cadastro,
                    categoria.conta AS esticp_nivel_categoria,
                    categoria.id AS esticp_categoria_id
                FROM estoque_inventario_contagem contagem
                    INNER JOIN estoque_inventario_capa inventario
                        ON contagem.inventario_id = inventario.id
                    INNER JOIN estoque_produto produto
                        ON contagem.produto_id = produto.id
                    INNER JOIN estoque_produto_grade grade
                        ON contagem.grade_id = grade.id
                    LEFT JOIN estoque_categoria categoria
                        ON categoria.id = produto.categoria_id
                    left join estoque_local_locacao ell
                        on ell.id = contagem.locacao_id
            );
        """
        drop_view_if_exists(cr, 'estoque_inventario_contagem_pgview')
        cr.execute(sql)
