# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def get_categoria_ids(self, cr, uid, categoria_ids, context=None):
        """Retorna uma lista da caideia de categoria da pai ate as filhas
        """
        context = context and context.copy() or {}
        obj_estoque_categoria = pooler.get_pool(cr.dbname).get('estoque.categoria')
        res = []
        if isinstance(categoria_ids, list):
            res.extend(categoria_ids)
        else:
            res.append(categoria_ids)

        child_ids = obj_estoque_categoria.search(cr, uid, [('parent_id', 'in', res)],
                                                 context=context)
        if not child_ids:
            return res

        res.extend(self.get_categoria_ids(cr, uid, child_ids, context=context))
        return res

    def get_dados_pgview(self, cr, uid, local_id, inventario_id, categoria_id, ordem, context=None):
        """
        Este metodo foi criado para melhorar a perfomance, com o read gastava muito tempo para ler
        os dados da pgview
        :param cr:
        :param uid:
        :param local_id:
        :param inventario_id:
        :param categoria_id:
        :param ordem:
        :param context:
        :return:
        """
        context = context and context.copy() or {}
        cond_categoria = ''
        if categoria_id:
            categoria_ids = ', '.join(
                map(
                    lambda it: str(it), pooler.get_pool(cr.dbname).get('estoque.categoria').search(
                        cr, uid, [('parent_id', 'child_of', categoria_id)], context=context)))
            cond_categoria = 'esticp_categoria_id IN (%(categoria_ids)s)\n           AND' % locals()

        order_by = ''
        if ordem:
            order_by = 'ORDER BY %(ordem)s' % locals()

        sql = """
            SELECT pgv.*, ell.locacao
            FROM estoque_inventario_contagem_pgview pgv
            left join estoque_local_locacao ell on ell.id = pgv.esticp_locacao_id
            WHERE %(cond_categoria)s esticp_inventario_id = %(inventario_id)s
              AND esticp_local_id = %(local_id)s
            %(order_by)s
         """ % locals()
        cr.execute(sql)
        return cr.dictfetchall()

    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}

        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        title = center_title('', _('Listagem para Conferencia'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Listagem para Conferencia'))
        listagem.informaTamLinha(160)
        inventario_id = datas.get('inventario_id')
        codigo = datas.get('codigo')
        local_id = datas.get('local_id')
        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'wizard.listagem.conferencia.osv', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))

        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab('  ')
        listagem.informaCab('*-------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(_('| LOCACAO |   CODIGO   |        GRADE        |                           DESCRICAO                           | UNIDADE | QTD. EMBALAGEM | SALDO CONTADO |'))
        listagem.informaCab('*-------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.rodapePadrao()
        order = {'A': 'esticp_descricao ASC',
                 'C': 'esticp_codigo_item ASC',
                 'T': 'esticp_nivel_categoria ASC',
                 'L': 'locacao ASC'}.get(datas.get('ordem'))
        dados_pgview = self.get_dados_pgview(cr, uid, local_id, inventario_id,
                                             datas.get('categoria_id'), order)
        obj_produto = pooler.get_pool(cr.dbname).get('estoque.produto')
        obj_grade = pooler.get_pool(cr.dbname).get('estoque.produto.grade')
        obj_locacao = pooler.get_pool(cr.dbname).get('estoque.local.locacao')
        produto_ids = []
        grade_ids = []
        locacao_ids = []
        for pgview in dados_pgview:
            produto_ids.append(pgview.get('esticp_produto_id'))
            grade_ids.append(pgview.get('esticp_grade_id'))
            locacao_ids.append(pgview.get('esticp_locacao_id'))

        load = '_classic_write'
        id_dados_grade = {} # chave=id da grade, valor=read da grade
        id_dados_locacao = {} # chave=id da locacao, valor=read da locacao
        map(lambda x: id_dados_grade.update({x.get('id'): x}),
            obj_grade.read(cr, uid, grade_ids, ['name', 'grade'], context=context, load=load))
        map(lambda x: id_dados_locacao.update({x.get('id'): x}),
            obj_locacao.read(cr, uid, locacao_ids, ['locacao', 'estllc_produto_embalagem_id'],
                             context=context, load=load))

        obj_estoque_utils = pooler.get_pool(cr.dbname).get('estoque.utils')
        grade_embalagem = obj_estoque_utils.get_grade_qtd_embalagem(cr, grade_ids, context=context)
        for pgview in dados_pgview:
            grade = id_dados_grade.get(pgview.get('esticp_grade_id'))
            descricao = grade.get('name') or ''

            locacao = id_dados_locacao.get(pgview.get('esticp_locacao_id')) or {}
            produto_emb_id = locacao.get('estllc_produto_embalagem_id') or False
            chave = '%s-%s' % (pgview.get('esticp_grade_id'), produto_emb_id)
            quantidade_embalagem = 1
            unidade = str()
            if grade_embalagem.get(chave):
                quantidade_embalagem = grade_embalagem.get(chave).get('qtd')
                unidade = (grade_embalagem.get(chave) or {}).get('unidade') or ''

            if pgview.get('esticp_inventario_id'):
                linha = ['|%s|' %
                         formataString(locacao.get('locacao') or '', 9, ' ', 'D', 'N', 'S')]
                if codigo == 'I':
                    linha.append('%s | ' %
                                 formataString(pgview.get('esticp_codigo_item') or '', 11, ' ', 'E', 'N', 'S'))
                elif codigo == 'F':
                    linha.append('%s | ' %
                                 formataString(
                        pgview.get('esticp_codigo_fabricante') or '', 11, ' ', 'E', 'N', 'S'))
                else:
                    linha.append('%s | '
                                 % formataString(pgview.get('esticp_codigo_item') or '', 11, ' ', 'E', 'N', 'S'))

                linha.append('%s| ' %
                             formataString(grade.get('grade') or '', 20, ' ', 'D', 'N', 'S'))
                linha.append('%s| ' % formataString(descricao, 62, ' ', 'D', 'N', 'S'))
                linha.append('%s| ' % formataString(unidade, 8, ' ', 'D', 'N', 'S'))
                linha.append('%s| ' %
                             formataString(getNumeroEditado(quantidade_embalagem, 3), 15, ' ', 'E', 'N', 'S'))
                linha.append('%s| ' % formataString(getNumeroEditado(
                    pgview.get('esticp_saldo_contado') or 0.0, 2), 14, ' ', 'E', 'N', 'S'))
                listagem.imprimeLinha(''.join(linha))

        listagem.imprimeLinha('*-------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.imprimeLinha('                                                                                                                      ** Sig Informatica LTDA **       ')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_conferencia')
