# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=141):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        dados = datas.get('dados')
        categoria_ids = list(set(map(lambda c: c.get('categoria_id'),
                                     filter(lambda ca: ca.get('categoria_id'), dados))))
        dict_descricao_categoria = {}
        brw_estoque_categoria = pooler.get_pool(cr.dbname).get('estoque.categoria').browse(
            cr, uid, categoria_ids, context)
        for categoria in brw_estoque_categoria:
            nome = ''
            parent = categoria.parent_id
            while parent:
                nome += parent.name + ' / '
                parent = parent.parent_id
            nome += categoria.name
            dict_descricao_categoria.update({categoria.id: nome})

        context = context and context.copy() or {}
        title = center_title('', _('Listagem para Contagem'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Listagem para Contagem'))
        listagem.defineMargem(0.5, 0.5, 1, 1)
        listagem.informaTamLinha(115)

        obj_estoque_preco_venda = pooler.get_pool(cr.dbname).get('estoque.preco.venda')
        obj_estoque_parametro = pooler.get_pool(cr.dbname).get('estoque.parametro')
        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'wizard.listagem.conferencia.osv', context=context)

        produto_ids = list(set(map(lambda c: c.get('produto_id'), dados)))
        grade_ids = list(set(map(lambda c: c.get('grade_id'), dados)))
        preco_venda_dados = obj_estoque_preco_venda.get_preco_venda(
            cr, uid, produto_ids, epc_company_id=company_id, epc_grade_ids=grade_ids,
            context=context)

        codigo = datas.get('codigo')
        ordem = datas.get('ordem')
        saldo = datas.get('saldo')
        listar_separacao = datas.get('separar_entre_linhas')
        listar_preco_venda = datas.get('preco_venda')

        estoque_parametro_id = obj_estoque_parametro.search(
            cr, uid, [('company_id', '=', company_id)], context=context)
        estoque_parametro_dados = obj_estoque_parametro.read(
            cr, uid, estoque_parametro_id, ['estpar_descricao_grade'], context=context)
        descricao_grade = None
        for x in estoque_parametro_dados:
            if x.get('estpar_descricao_grade') == 'P':
                descricao_grade = True

        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))

        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab('  ')
        listagem.informaCab(
            '*-----------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(_(
            '|    LOCACAO    |   CODIGO     |GR|                DESCRICAO                 |UND |QTD. EMBALAGEM|    SALDO     |CONTAGEM |P. VENDA |'))
        listagem.informaCab(
            '*-----------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(_(
            '|               |              |  |                                          |    |              |              |         |         |'))
        listagem.informaRodape(
            '*-----------------------------------------------------------------------------------------------------------------------------------*')
        dict_categoria = {}
        for x in dados:
            preco_venda = ''
            if listar_preco_venda:
                produto_id = x.get('produto_id')
                grade_id = x.get('grade_id')
                dados_preco_venda = preco_venda_dados.get(produto_id) or {}
                preco_venda = dados_preco_venda.get(grade_id) or dados_preco_venda.get(
                    'preco_venda')
                preco_venda = getNumeroEditado(preco_venda, 2)
            saldo_cadastro = ''
            if saldo:
                saldo_cadastro = x.get('saldo_cadastro')
            quantidade_embalagem = x.get('quantidade_embalagem')
            unidade = x.get('unidade')
            if ordem == 'T':
                if x.get('categoria_id'):
                    categoria = dict_descricao_categoria.get(x.get('categoria_id'))
                else:
                    categoria = 'Sem categoria'
                if not dict_categoria.get(categoria):
                    dict_categoria[categoria] = True
                    linha = '|' + formataString(categoria or '', 131, '-', 'C', 'N', 'S') + '|'
                    listagem.imprimeLinha(linha)
            linha = formataString(x.get('locacao') or '', 15, ' ', 'D', 'N', 'S')
            linha += '|'
            if codigo == 'I':
                linha += formataString(x.get('produto_codigo') or '', 14, ' ', 'D', 'N', 'S')
                linha += '|'
            elif codigo == 'F':
                linha += formataString(x.get('codigo_fabricante') or '', 14, ' ', 'D', 'N',
                                       'S')
                linha += '|'
            else:
                linha += formataString(x.get('produto_codigo') or '', 14, ' ', 'D', 'N', 'S')
                linha += '|'
            linha += formataString(x.get('grade_grade') or '', 2, ' ', 'D', 'N', 'S')
            linha += '|'
            if descricao_grade:
                descricao = x.get('produto_descricao') + ' - ' + x.get('grade_descricao')
            else:
                descricao = x.get('grade_descricao')
            linha += formataString(descricao or '', 42, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(unidade, 4, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(quantidade_embalagem, 3), 14, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(saldo_cadastro, 3), 14, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString('', 9, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(preco_venda, 9, ' ', 'E', 'N', 'S')
            linha += '|'
            listagem.imprimeLinha('|' + linha)
            if listar_separacao:
                listagem.imprimeLinha(
                    '*-----------------------------------------------------------------------------------------------------------------------------------*'
                )
        listagem.imprimeLinha(
            '*-----------------------------------------------------------------------------------------------------------------------------------*')
        listagem.imprimeLinha(
            '                                                                                                    ** Sig Informatica LTDA **       ')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_contagem')
