# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        title = center_title('', _('Listagem de diferencas'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Listagem de diferencas inventario'))
        listagem.defineMargem(0.5,0.5,0.5,0.5,)
        listagem.defineFonte(tam=6.3)
        diferenca = datas.get('diferenca')
        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid,
                                               'inventario.listagem.diferenca.osv', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id,
                                                                          ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))

        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab('  ')
        listagem.informaCab('*%s*' % ''.ljust(148, '-'))
        listagem.informaCab(_(
            '|  COD. ITEM   |GRADE|              DESCRICAO                   |EMBALAGEM| SALDO CADASTRO | SALDO CONTADO |    DIFERENCA   |   DIFERENCA FINANCEIRA |'))
        listagem.informaCab('*%s*' % ''.ljust(148, '-'))
        listagem.rodapePadrao()
        total_positivo = 0
        total_negativo = 0
        total_geral = 0
        local_id = False
        for x in datas.get('dados'):
            if x.get('saldo_contado') is None:
                x['saldo_contado'] = 0
            if x.get('saldo_cadastro') is None:
                x['saldo_cadastro'] = 0
            diferenca_saldo = x.get('saldo_contado') - x.get('saldo_cadastro')
            if not diferenca_saldo:
                continue

            if local_id != x.get('local_id'):
                if local_id:
                    listagem.imprimeLinha('*%s*' % ''.ljust(148, '-'))

                local_id = x.get('local_id')
                listagem.imprimeLinha(_('|LOCAL: %s|') % ('%03d-%s' % (x.get('numero_local'),
                                                                       x.get('local'))
                                                          ).ljust(141,' '))

            diferenca_financeira = diferenca_saldo * x.get('custo') or 0.0
            linha = ['|',
                     formataString(x.get('codigo') or '', 14, ' ', 'D', 'N', 'S') , '| ',
                     formataString(x.get('grade') or '', 4, ' ', 'D', 'N', 'S') , '| ',
                     formataString(x.get('descricao') or '', 41, ' ', 'D', 'N', 'S') , '| ',
                     formataString(x.get('embalagem') or '', 8, ' ', 'D', 'N', 'S') , '| ',
                     formataString(getNumeroEditado(x.get('saldo_cadastro') or 0), 15, ' ', 'E',
                                   'N', 'S') , '| ',
                     formataString(getNumeroEditado(x.get('saldo_contado') or 0), 14, ' ', 'E', 'N',
                                   'S') , '| ',
                     formataString(getNumeroEditado(diferenca_saldo or 0), 15, ' ', 'E', 'N', 'S'),
                     '| ',
                     formataString(getNumeroEditado(diferenca_financeira), 23, ' ', 'E', 'N', 'S'),
                     '|']

            if diferenca:
                if diferenca == 'P':
                    if diferenca_saldo > 0:
                        listagem.imprimeLinha(''.join(linha))
                        total_positivo += diferenca_financeira
                        total_geral += diferenca_financeira
                elif diferenca == 'N':
                    if diferenca_saldo < 0:
                        listagem.imprimeLinha(''.join(linha))
                        total_negativo += diferenca_financeira
                        total_geral += diferenca_financeira
                elif diferenca == 'S':
                    if diferenca_saldo != 0:
                        listagem.imprimeLinha(''.join(linha))
                        if diferenca_financeira > 0:
                            total_positivo += diferenca_financeira
                        elif diferenca_financeira < 0:
                            total_negativo += diferenca_financeira
                        total_geral += diferenca_financeira
            else:
                listagem.imprimeLinha(''.join(linha))
                if diferenca_financeira > 0:
                    total_positivo += diferenca_financeira
                elif diferenca_financeira < 0:
                    total_negativo += diferenca_financeira
                total_geral += diferenca_financeira

        listagem.imprimeLinha('*%s*' % ''.ljust(148, '-'))
        listagem.imprimeLinha(_('|TOTAL POSITIVO: ') +
                              getNumeroEditado(total_positivo).rjust(132, ' ')+ '|')
        listagem.imprimeLinha(_('|TOTAL NEGATIVO: ') +
                                getNumeroEditado(total_negativo).rjust(132, ' ')+ '|')
        listagem.imprimeLinha(_('|TOTAL GERAL:    ') +
                              getNumeroEditado(total_geral).rjust(132, ' ')+ '|')
        listagem.imprimeLinha('*%s*' % ''.ljust(148, '-'))
        listagem.imprimeLinha('** Sig Informatica LTDA **       '.rjust(150, ' '))

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.inventario_listagem_diferenca')


class inventario_listagem_diferenca_osv(osv.TransientModel):
    _name = 'inventario.listagem.diferenca.osv'
    _columns = {
        'inventario_id': fields.many2one("estoque.inventario.capa", 'Inventario', required=True, ondelete='cascade'),  # id do inventario
        'local_id': fields.many2one('estoque.local', 'Local'),
        'diferenca': fields.selection([('P', 'Positiva'), ('N', 'Negativa'), ('S', 'So diferenca')], 'Diferenca', size=1),
        'codigo': fields.selection([('B', 'Barra'), ('F', 'Fabricante')], 'Codigo', size=1),
        'preco': fields.selection([('M', 'Medio'), ], 'Precos', size=1),
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        load = '_classic_write'
        for x in self.read(cr, uid, ids, [], context=context, load=load):
            dados = self.get_dados(cr, x.get('inventario_id'), x.get('local_id'), x.get('codigo'),
                           x.get('preco'), context)
            if not dados:
                raise osv.except_osv(_('Atencao!'),
                                     _('Nenhum registro encontrado para estes Filtros.'))

            datas = {'dados': dados,
                     'diferenca': x.get('diferenca'),
                     }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'inventario_listagem_diferenca',
            'datas': datas,
        }

    def get_dados(self, cr, inventario_id, local_id, codigo, preco, context=None):
        context = context and context.copy() or {}
        cond_local = ''
        codigo = codigo and codigo or 'TT'
        preco = preco and preco or 'TT'
        if local_id:
            cond_local = "AND eic.local_id = %s" % local_id

        sql = """
    SELECT * 
    FROM ( 
        SELECT DISTINCT
               COALESCE(eic.saldo_cadastro, 0) AS saldo_cadastro,
               COALESCE(eic.saldo_contado, 0)  AS saldo_contado,
               ep.name                         AS descricao,
               epg.grade                       AS grade,
               el.name                         AS local,
               el.numero                       AS numero_local,
               ell.local_id                    AS local_id,
               ee.name                         AS embalagem,
               CASE WHEN '{codigo}' = 'F'
                    THEN epg. codigo_no_fabricante
                    WHEN '{codigo}' = 'B' 
                    THEN (SELECT codigo_barra
                          FROM automacao_codigo_barra
                          WHERE grade_id = epg.id AND produto_embalagem_id = epe.id
                          LIMIT 1)
                    ELSE ep.codigo
               END                             AS codigo,
               CASE WHEN '{preco}' = 'M'
                    THEN COALESCE (eic.estict_custo_medio_contabil, 0)
                    ELSE COALESCE (estict_ultimo_custo, 0)
               END                             AS custo 
                    
        FROM estoque_inventario_contagem     AS eic
        INNER JOIN estoque_produto           AS ep  ON ep.id = eic.produto_id
        INNER JOIN estoque_produto_grade     AS epg ON epg.id = eic.grade_id 
        INNER JOIN estoque_local             AS el  ON el.id = eic.local_id
        INNER JOIN estoque_local_locacao     AS ell ON ell.local_id = el.id AND 
                                                       ell.grade_id = epg.id
        INNER JOIN estoque_produto_embalagem AS epe ON epe.id = ell.estllc_produto_embalagem_id
        INNER JOIN estoque_embalagem         AS ee  ON ee.id = epe.embalagem_id
        WHERE inventario_id = {inventario_id}
           {cond_local}
           ) AS tmp
           
    ORDER by local_id, codigo 
              """.format(inventario_id=inventario_id,
                         cond_local=cond_local,
                         codigo=codigo,
                         preco=preco)
        cr.execute(sql)
        return cr.dictfetchall()


