# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from dateutil.parser import parse
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(e, c, d, t=160):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        context = context and context.copy() or {}
        title = center_title('', _('Itens parados'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('itens_parados'))
        listagem.informaTamLinha(160)

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'estoque.produto', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")

        itens = datas.get('itens')
        grade_ids = list(set(map(lambda i: i.get('grade_id'), itens)))
        produto_ids = list(set(map(lambda i: i.get('produto_id'), itens)))
        produto_saldos = pooler.get_pool(cr.dbname).get('estoque.produto.saldo').get_saldo_do_dia(
            cr, uid, grade_ids, time.strftime('%Y-%m-%d'), datas.get('local_id'), context=context)
        produto_custos = pooler.get_pool(cr.dbname).get('estoque.preco.custo').get_custos_do_dia(
            cr, uid, produto_ids, context=context)
        produto_preco_venda = pooler.get_pool(cr.dbname).get('estoque.preco.venda').get_preco_venda(
            cr, uid, epc_produto_ids=produto_ids, epc_grade_ids=grade_ids, context=context)
        calcula_lucro = pooler.get_pool(cr.dbname).get('estoque.produto').estpro_calcula_lucro

        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
        docs1 = formataString('Itens parados desde: %s' % datas.get('data'), 45, ' ', 'D', 'N', 'S')
        docs1 += formataString('Considerar entradas: %s' % datas.get('considera_entrada'), 45,
                               ' ', 'D', 'N', 'S')
        docs2 = formataString('Local: %s' % datas.get('desc_local'), 45, ' ', 'D', 'N', 'S')
        docs2 += formataString('Fabricante: %s' % datas.get('fabricante'), 45, ' ', 'D', 'N', 'S')
        docs3 = formataString('Fornecedor: %s' % datas.get('fornecedor'), 45, ' ', 'D', 'N', 'S')
        docs3 += formataString('Categoria: %s' % datas.get('categoria'), 45, ' ', 'D', 'N', 'S')
        docs4 = formataString('Custo a listar: %s' % datas.get('desc_custo'), 45, ' ', 'D', 'N',
                              'S')

        listagem.informaCab(''+title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab(''+docs)
        listagem.informaCab('')
        listagem.informaCab(docs1)
        listagem.informaCab(docs2)
        listagem.informaCab(docs3)
        listagem.informaCab(docs4)
        listagem.informaCab('')
        listagem.informaCab('*' + '-' * 155 + '*')
        listagem.informaCab('| CODIGO    | GRADE | DESCRICAO                      | UNIDADE | QTD. EMBALAGEM |      SALDO | ULT. ENTRADA | ULT. SAIDA |      CUSTO | PRECO VENDA | LUCRO |')
        listagem.informaCab('*' + '-' * 155 + '*')
        listagem.rodapePadrao()

        if datas.get('somente_com_saldo'):
            saldo_grade_ids = filter(lambda p: produto_saldos.get(p).get('saldo') > 0,
                                     produto_saldos)
            itens = filter(lambda it: it.get('grade_id') in saldo_grade_ids, itens)
        for x in itens:

            saldo = 0
            if produto_saldos.get(x.get('grade_id')):
                saldo = produto_saldos.get(x.get('grade_id')).get('disponivel')

            custo = 0
            if produto_custos.get(x.get('produto_id')):
                custo = produto_custos.get(x.get('produto_id')).get(datas.get('custo'))

            preco_venda = 0
            if produto_preco_venda.get(x.get('produto_id')):
                if produto_preco_venda.get(x.get('produto_id')).get(x.get('grade_id')):
                    preco_venda = produto_preco_venda.get(x.get('produto_id')).get(x.get(
                        'grade_id'))
                else:
                    preco_venda = produto_preco_venda.get(x.get('produto_id')).get('preco_venda')

            lucro = 0
            if preco_venda:
                lucro = calcula_lucro(cr, uid, x.get('produto_id'), preco_venda,
                                      x.get('codigo_custo'), context=context)

            ultima_entrada = x.get('ultima_entrada') or ''
            if ultima_entrada:
                ultima_entrada = parse(ultima_entrada).strftime('%d/%m/%Y')
            ultima_saida = x.get('ultima_saida') or ''
            if ultima_saida:
                ultima_saida = parse(ultima_saida).strftime('%d/%m/%Y')

            qtd_emb = x.get('quantidade_embalagem') or 1
            linha = '|'
            linha += formataString(x.get('codigo') or '', 11, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('grade') or '', 7, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('descricao'), 32, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('unidade') or '', 9, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(qtd_emb, 16, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(saldo / qtd_emb, 5), 12, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(ultima_entrada, 14, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(ultima_saida, 12, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(custo, 5), 12, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(preco_venda, 5), 13, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(lucro), 7, ' ', 'E', 'N', 'S')
            linha += '|'
            listagem.imprimeLinha(linha)

        listagem.imprimeLinha('*' + '-' * 155 + '*')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.item_parado')
