# -*- encoding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}

        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        opcao = datas.get('opcao')
        ordem = datas.get('ordem')
        custo = datas.get('custo')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='1')
        listagem.informaNome(pdf_string, _('Participacao nas Vendas'))
        listagem.informaTamLinha(160)
        listagem.defineFonte(tam=8.4)
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)
        data_inicial = datas.get('data_inicial')
        data_final = datas.get('data_final')
        porcentagem_listar = datas.get('porcentagem_listar')
        dados_movimento_itens = datas.get('dados')
        valor_total = sum(map(lambda d: d.get('vr_total_item_rateado') or 0, dados_movimento_itens))

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'wizard.listagem.participacao.vendas', context=context)
        nome_empresa = pooler.get_pool(cr.dbname).get('res.company').browse(
            cr, uid, company_id).name
        data_inicial = time.strftime("%d/%m/%Y", time.strptime(data_inicial,
                                                               '%Y-%m-%d'))
        data_final = time.strftime("%d/%m/%Y", time.strptime(data_final, '%Y-%m-%d'))
        periodo = _('Periodo: %s a %s') % (data_inicial, data_final)
        docs = center_title(periodo, nome_empresa, 'Pagina: {{ Page }} ')
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab('  ')
        if opcao == 'I':
            item = 'ITEM      '
            listagem.informaCab(
                '*---------------------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.informaCab(_(
                '| SEQ | COD ' + item + ' |  GR  |              DESCRICAO               |   QUANT    |  VL TOTAL  |  VL ACUMUL  | % INDIV | % ACUMUL | VL AGREGADO | % VL AGREGADO |'))
            listagem.informaCab(_(
                '|                                                                                                                                                     S/ VENDAS |'))
            listagem.informaCab(
                '*---------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        else:
            if opcao == 'C':
                item = 'CATEGORIA '
            if opcao == 'F':
                item = 'FABRICANTE'
            if opcao == 'V':
                item = 'VENDEDOR  '
            listagem.informaCab(
                '*--------------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.informaCab(_(
                '| SEQ | COD ' + item + ' |              DESCRICAO               |   QUANT    |  VL TOTAL  |  VL ACUMUL  | % INDIV | % ACUMUL | VL AGREGADO | % VL AGREGADO |'))
            listagem.informaCab(_(
                '|                                                                                                                                              S/ VENDAS |'))
            listagem.informaCab(
                '*--------------------------------------------------------------------------------------------------------------------------------------------------------*')

        listagem.rodapePadrao()
        i = 1
        porcentagem_acumulada = 0.00
        total_agregado = 0.00
        total_acumulado = 0
        for movimento in dados_movimento_itens:
            if movimento.get('vr_total_item_rateado') == 0:
                movimento['valor_agregado'] = 0
                continue

            total_item = movimento.get('vr_total_item_rateado') or 0
            if custo == 'CC':
                preco_custo = movimento.get('custo_corrigido') or 0.0
            elif custo == 'UC':
                preco_custo = movimento.get('ultimo_custo') or 0.0
            elif custo == 'CM':
                preco_custo = movimento.get('custo_medio') or 0.0
            else:
                preco_custo = movimento.get('custo_reposicao') or 0.0

            valor_agregado = round(total_item - preco_custo, 2)
            movimento['valor_agregado'] = valor_agregado
        if ordem == 'F':
            dados_movimento_itens = sorted(dados_movimento_itens,
                                           key=lambda v: v.get('vr_total_item_rateado'),
                                           reverse=True)
        elif ordem == 'V':
            dados_movimento_itens = sorted(dados_movimento_itens, key=lambda v: (
                v.get('valor_agregado'), v.get('vr_total_item_rateado')), reverse=True)
        for movimento in dados_movimento_itens:
            if movimento.get('vr_total_item_rateado') == 0:
                continue
            quantidade = movimento.get('quantidade') or 0
            total_item = movimento.get('vr_total_item_rateado') or 0
            total_acumulado += total_item
            grade = ''
            codigo_item = ''
            item_name = ''
            if opcao == 'I':
                codigo_item = movimento.get('codigo')
                grade = movimento.get('grade') or ''
                item_name = movimento.get('produto_name') or ''
            elif opcao == 'C':
                codigo_item = movimento.get('conta') or ''
                item_name = movimento.get('categoria_name') or 'SEM CATEGORIA'
            elif opcao == 'F':
                codigo_item = movimento.get('fabricante_codigo') or ''
                item_name = movimento.get('fabricante_name') or 'SEM FABRICANTE'
            elif opcao == 'V':
                codigo_item = movimento.get('vendedor_id') or ''
                item_name = movimento.get('nome') or 'SEM VENDEDOR'

            valor_agregado = movimento.get('valor_agregado')
            porcentagem_individual = (total_item / valor_total) * 100 if valor_total else 0
            porcentagem_valor_agregado_venda = (valor_agregado / total_item) * 100 if total_item \
                                                                                   else 0

            if int(porcentagem_acumulada) >= porcentagem_listar:
                break
            porcentagem_acumulada += porcentagem_individual
            if int(porcentagem_acumulada) > porcentagem_listar:
                break
            total_agregado += valor_agregado
            linha = formataString(i, 5, ' ', 'D', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(codigo_item or '', 15, ' ', 'D', 'N', 'S') + '|'
            linha += ' '
            if opcao == 'I':
                linha += formataString(grade or '', 5, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
            linha += formataString(item_name or '', 37, ' ', 'D', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(quantidade, 2), 11, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(total_item, 2), 11, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(total_acumulado, 2), 12, ' ', 'E', 'N',
                                   'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(porcentagem_individual, 3), 8, ' ', 'E', 'N',
                                   'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(porcentagem_acumulada, 3), 9, ' ', 'E', 'N',
                                   'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(valor_agregado, 2), 12, ' ', 'E', 'N',
                                   'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(porcentagem_valor_agregado_venda, 3), 14, ' ',
                                   'E', 'N', 'S') + '|'
            linha += ' '
            listagem.imprimeLinha('|' + linha)
            i += 1
        if opcao == 'I':
            listagem.imprimeLinha(
                '*---------------------------------------------------------------------------------------------------------------------------------------------------------------*')
            linha = formataString(getNumeroEditado(total_acumulado, 2), 109, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(total_agregado, 2), 35, ' ', 'E', 'N', 'S')
            agregado_venda = (total_agregado / total_acumulado) * 100 if total_acumulado else 0
            porcentagem_valor_agregado_venda = agregado_venda
            linha += formataString(getNumeroEditado(porcentagem_valor_agregado_venda, 2), 16, ' ', 'E', 'N', 'S')
            listagem.imprimeLinha(linha)
            listagem.imprimeLinha(
                '*---------------------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.imprimeLinha(
                '                                                                                                                          ** Sig Informatica LTDA **       ')
        else:
            listagem.imprimeLinha(
                '*--------------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.imprimeLinha(
                formataString(getNumeroEditado(total_agregado, 2), 137, ' ', 'E', 'N', 'S'))
            listagem.imprimeLinha(
                '*--------------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.imprimeLinha(
                '                                                                                                                   ** Sig Informatica LTDA **       ')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_participacao_vendas')
