# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from openerp.osv import osv, fields
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=201):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        title = center_title(_('Contr.Estoque'), _('Rel. Produtos nos locais'), ' ')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='1')
        listagem.defineFonte(tam=6.95)
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)
        listagem.informaNome(pdf_string, _('Listagem Produtos nos locais'))

        obj_estoque_produto = pooler.get_pool(cr.dbname).get('estoque.produto')
        obj_estoque_categoria = pooler.get_pool(cr.dbname).get('estoque.categoria')
        obj_adm_empresa_objeto = pooler.get_pool(cr.dbname).get('adm.empresa.objeto')

        company_id = obj_adm_empresa_objeto.getEmpresa(cr, uid, 'estoque.produto', context=context)
        locacao_company_id = obj_adm_empresa_objeto.getEmpresa(
            cr, uid, 'estoque.local.locacao', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id,
                                                                               ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))

        args = list()
        args.append(('company_id', '=', company_id))
        if datas.get('categoria_ids'):
            args.append(('categoria_id', 'in', datas.get('categoria_ids')))
        if datas.get('fabricante_id'):
            args.append(('fabricante_id', '=', datas.get('fabricante_id')))

        produto_ids = obj_estoque_produto.search(cr, uid, args, context=context)
        tuple_produto_ids = tuple(produto_ids)
        if len(tuple_produto_ids) == 1:
            tuple_produto_ids = str(tuple_produto_ids).replace(',', '')
        else:
            tuple_produto_ids = str(tuple_produto_ids)
        list_produto_grade = []
        locacao_dados = []

        if produto_ids:
            sql = """
                SELECT ep.id AS produto_id,
                       epg.id AS grade_id,
                       ep.codigo AS codigo,
                       ep.name AS name,
                       epg.grade AS grade,
                       ec.name AS categoria,
                       ec.id AS categoria_id,
                       ec.parent_id AS categoria_pai_id,
                       ap1.nome AS fabricante,
                       ee.name AS embalagem,
                       ee.quantidade_na_embalagem AS quantidade_na_embalagem,
                       el.name AS local,
                       el.id AS local_id,
                       ap.nome AS repositor

                FROM estoque_produto                AS ep
                INNER JOIN estoque_local_locacao    AS ell ON ell.produto_id = ep.id
                INNER JOIN estoque_produto_grade    AS epg ON epg.produto_id = ep.id
                LEFT JOIN estoque_categoria         AS ec  ON ec.id = ep.categoria_id 
                LEFT JOIN adm_pessoa                AS ap1 ON ap1.id = ep.fabricante_id
                LEFT JOIN estoque_produto_embalagem AS epe ON epe.id = ell.estllc_produto_embalagem_id  
                LEFT JOIN estoque_embalagem         AS ee  ON ee.id = epe.embalagem_id 
                INNER JOIN estoque_local            AS el  ON el.id = ell.local_id
                LEFT JOIN rh_funcionario            AS rf  ON rf.id = ell.repositor_id
                LEFT JOIN adm_pessoa                AS ap  ON ap.id = rf.pessoa 
                WHERE 
                  ell.company_id = %s
                  AND epg.id = ell.grade_id  
                  AND el.id = ell.local_id 
                  AND ell.produto_id IN %s

                GROUP BY ep.id,
                         epg.id,
                         el.id,
                         ell.grade_id,
                         ep.codigo,
                         ep.name,
                         epg.grade,
                         ec.id,
                         ec.parent_id,
                         ec.name,
                         ap1.nome,
                         ee.name,
                         ee.quantidade_na_embalagem,
                         el.name,
                         ap.nome
                ORDER BY ep.id ASC
            """ % (locacao_company_id, tuple_produto_ids)

            cr.execute(sql)
            locacao_dados = cr.dictfetchall()

        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab('  ')
        listagem.informaCab(
            '*-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(
            _('* Codigo    Grade     Descricao                                                   Categoria                                                       Fabricante                                      *'))
        listagem.informaCab(
            _('* Embalagem                   Local                          Saldo Disponivel     Repositor                                                                                                                            *'))
        listagem.informaCab(
            '*-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.rodapePadrao()
        categoria_pai_ids = list(set(map(lambda x: x.get('categoria_pai_id'), locacao_dados)))
        local_ids = list(set(map(lambda x: x.get('local_id'), locacao_dados)))
        grade_ids = list(set(map(lambda x: x.get('grade_id'), locacao_dados)))
        produto_saldo_local = {}
        for i in local_ids:
            produto_saldo_local[i] = pooler.get_pool(cr.dbname).get('estoque.produto.saldo').get_saldo_do_dia(
            cr, uid, grade_ids, time.strftime("%Y-%m-%d"), i, context=context)

        categoria_pai_dados = {}
        if categoria_pai_ids:
            map(lambda x: categoria_pai_dados.update({x[0]: x[1]}),
                          obj_estoque_categoria.name_get(cr, uid, categoria_pai_ids, context))
        for i in locacao_dados:
            produto_saldo = produto_saldo_local.get(i.get('local_id'))
            str_produto_grade = '%s-%s' % (i.get('produto_id'), i.get('grade_id'))
            if not str_produto_grade in list_produto_grade:
                if locacao_dados.index(i) != 0:
                    listagem.imprimeLinha(''.ljust(195, '-'))
                categoria = i.get('categoria') or ''
                categoria_pai_id = i.get('categoria_pai_id') or False
                categoria_pai = ''
                if categoria_pai_id:
                    categoria_pai = categoria_pai_dados.get(categoria_pai_id) or ''
                linha = ['  ',
                         formataString(i.get('codigo') or '', 10, ' ', 'D', 'N', 'S'),
                         formataString(i.get('grade') or '', 10, ' ', 'D', 'N', 'S'),
                         formataString(i.get('name') or '', 60, ' ', 'D', 'N', 'S')]
                if categoria and categoria_pai:
                    categoria_name = categoria_pai + ' / ' + categoria
                elif categoria_pai and not categoria:
                    categoria_name = categoria_pai + ' / '
                elif categoria and not categoria_pai:
                    categoria_name = categoria
                else:
                    categoria_name = ''

                linha.extend([formataString(categoria_name or ' ', 63, ' ', 'D', 'N', 'S'),
                              ' ',
                              formataString(i.get('fabricante') or ' ', 54, ' ', 'D', 'N', 'S')])
                listagem.imprimeLinha(''.join(linha))
                list_produto_grade.append(str_produto_grade)

            linha = ['  ',
                     formataString(i.get('embalagem') or '', 28, ' ', 'D', 'N', 'S'),
                     formataString(i.get('local') or '', 31, ' ', 'D', 'N', 'S'),
                     formataString(getNumeroEditado(produto_saldo.get(i.get('grade_id')).get('disponivel') / i.get('quantidade_na_embalagem'), 5), 20, ' ', 'D', 'N', 'S'),
                     formataString(i.get('repositor') or '', 55, ' ', 'D', 'N', 'S')]
            listagem.imprimeLinha(''.join(linha))

        listagem.imprimeLinha(''.ljust(195, '-'))

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_produtos_locais')
