# -*- coding: utf-8 -*-

from dateutil.parser import parse
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
from openerp import pooler
import time
from openerp.tools.translate import _
from openerp.osv.fields import float_round

class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.informaNome(pdf_string, _('Registro de Inventario'))
        listagem.rodapePadrao()
        listagem.informaTamLinha(150)

        # VARIAVEIS GLOBAIS
        self.col_classific_fiscal = 17
        self.col_discriminacao = 62
        self.col_unidade = 9
        self.col_quantidade = 12
        self.col_valores = 41
        ## colunas abaixo estao dentro da coluna self.col_valores
        self.col_unitario = 20
        self.col_total = 20

        self.db_name = pooler.get_pool(cr.dbname) # PERMITE ACESSO AS TABELAS.
        self.traco_linha = 145 # QUANTIDADE DE CARACTERES NA HORIZONTAL QUE SERAO ESCRITOS.
        listagem.setPage((datas.get('folha') - 1) or 0)
        self.space = ' ' * self.traco_linha # ESPACO DE LINHA.
        self.space_pontilhado = '|' + (' ' * self.col_classific_fiscal) + \
                                '|' + (' ' * self.col_discriminacao) + \
                                '|' + (' ' * self.col_unidade) + \
                                '|' + (' ' * self.col_quantidade) + \
                                '|' + (' ' * self.col_unitario) + \
                                '|' + (' ' * self.col_total) + '|'

        registros = self.get_registros(cr, uid, datas, context=context)
        if registros:
            self.listar_itens(listagem, registros, datas, context=context)

            #ATUALIZA NUMERO DA FOLHA E DATA FINAL DA TABELA adm.paginas

        inventario_company_id = datas.get('company_id')
        obj_adm_paginas = self.db_name.get('adm.paginas')
        adm_paginas_ids = obj_adm_paginas.search(cr, uid, [('company_id', '=', inventario_company_id),
                                                           ('tipo', '=', 'inventario'),
                                                           ('write_date', '<=', time.strftime('%Y-%m-%d %H:%M:%S'))], 0,
                                                 1,
                                                 'write_date DESC', context)
        adm_paginas_ids2 = obj_adm_paginas.search(cr, uid, [('company_id', '=', inventario_company_id),
                                                            ('tipo', '=', 'inventario'),
                                                            ('create_date', '<=', time.strftime('%Y-%m-%d %H:%M:%S'))],
                                                  0, 1,
                                                  'create_date DESC', context)
        if adm_paginas_ids and adm_paginas_ids2:
            data_adm_paginas_ids = obj_adm_paginas.browse(cr, uid, adm_paginas_ids[0], context=context).write_date
            data_adm_paginas_ids2 = obj_adm_paginas.browse(cr, uid, adm_paginas_ids2[0], context=context).create_date
            if data_adm_paginas_ids < data_adm_paginas_ids2:
                adm_paginas_ids = adm_paginas_ids2
        elif adm_paginas_ids2 and not adm_paginas_ids:
            adm_paginas_ids = adm_paginas_ids2
        vals = {
            'inicial': datas.get('folha'),
            'final': listagem.getPage(),
            'data': datas.get('inventario_data'),
            'tipo': 'inventario',
            'company_id': inventario_company_id
        }
        if not adm_paginas_ids:
            obj_adm_paginas.create(cr, uid, vals, context=context)
        else:
            obj_adm_paginas.write(cr, uid, adm_paginas_ids, vals, context=context)

        #        .admpag_set_pagina(cr, uid, data_inicial=datas.get('inventario_data'), pag_final=listagem.getPage(), tipo='inventario', context=context)

        listagem.finalizaImpressao()
        self.obj_external_pdf = external_pdf(pdf_string.getvalue())
        self.obj_external_pdf.render()
        pdf_string.close()
        return (self.obj_external_pdf.pdf, 'pdf')

    def definir_cabecalho(self, listagem, datas, context=None):
        context = context and context.copy() or {}
        company_cnpj = _('CNPJ: ') + datas.get('company_cnpj')
        company_ie = _('           INSCR. ESTADUAL: ') + datas.get('company_ie')
        data_inventario = datas.get('inventario_data')

        str_titulo = formataString(_('REGISTRO DE INVENTARIO'), self.traco_linha, ' ', 'C', 'N', 'S')
        str_company_name = formataString(_('EMPRESA: ') + datas.get('company_name'), self.traco_linha, ' ', 'D', 'N', 'S')
        str_company_cnpj = formataString(company_cnpj, len(company_cnpj), ' ', 'D', 'N', 'S')
        str_company_ie = formataString(company_ie, self.traco_linha - len(str_company_cnpj), ' ', 'D', 'N', 'S')
        str_folha = formataString(_('Folha: {{ Page , 5 }}'), self.traco_linha + 9, ' ', 'E', 'N', 'S')
        str_inventario_data = formataString(_('ESTOQUE EXISTENTE EM: ') + data_inventario, self.traco_linha, ' ', 'C', 'N',
                                            'S')

        listagem.informaCab('*' + ('-' * self.traco_linha) + '*')
        listagem.informaCab('|' + str_titulo + '|')
        listagem.informaCab('|' + self.space + '|')
        listagem.informaCab('|' + str_company_name + '|')
        listagem.informaCab('|' + self.space + '|')
        listagem.informaCab('|' + str_company_cnpj + str_company_ie + '|')
        listagem.informaCab('|' + self.space + '|')
        listagem.informaCab('|' + str_folha + '|')
        listagem.informaCab('|' + self.space + '|')
        listagem.informaCab('|' + str_inventario_data + '|')
        listagem.informaCab('|' + self.space + '|')
        listagem.informaCab('|' + ('-' * self.traco_linha) + '|')
        listagem.informaCab(
            _('|  CLASSIFICACAO  |                       DISCRIMINACAO                          | UNIDADE | QUANTIDADE |                 VALORES                 |'))
        listagem.informaCab(
            _('|      FISCAL     |                                                              |         |            |     UNITARIO       |      TOTAL         |'))
        listagem.informaCab(
            '|-------------------------------------------------------------------------------------------------------------------------------------------------|')

    #                            012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456
    #                            |         |         |         |         |         |         |         |         |         |         |         |         |         |         |         |
    #                            0         10        20        30        40        50        60        70        80        90       100       110       120       130       140       150

    def get_registros(self, cr, uid, datas, context=None):
        context = context and context.copy() or {}
        registros = {}
        itens_sem_custo = []
        tipo_custo = datas.get('preco_listar')
        obj_estoque_local_locacao = self.db_name.get('estoque.local.locacao')
        contagem_dados = datas.get('inventario_contagem_dados')
        tributacao_dados = datas.get('tributacao_produto_dados')
        ncm_dados = datas.get('ncm_produto_dados')

        # Todo: Levar pro modulo fiscal atribuicoes do fiscal
        fiscal_instalado = self.db_name.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'fiscal', context)

        inventario_id = datas.get('inventario_id')
        obj_inventario_oficial = self.db_name.get('estoque.inventario.oficial')
        if not inventario_id:
            raise osv.except_osv(_('Atencao'),
                                 _('Nenhum inventario foi selecionado para a geracao do Registro de Inventario!'))
        # pesquisa os inventarios oficiais relacionados ao inventario selecionado na tela
        # e faz a exclusao dos mesmos
        sql = """
            DELETE FROM estoque_inventario_oficial WHERE capa_id = %s
        """ % inventario_id
        cr.execute(sql)

        inventario_correcao_ids = self.db_name.get('estoque.inventario.correcao').search(
            cr, uid, [('estico_inventario_id', '=', inventario_id)], context=context)
        correcao_custo_qtd = ''
        correcao_percentual = ''
        correcao_operacao = ''
        if inventario_correcao_ids:
            brw_inventario_correcao = self.db_name.get('estoque.inventario.correcao').browse(
                cr, uid, inventario_correcao_ids[0], context)
            correcao_custo_qtd = brw_inventario_correcao.estico_custo_qtd
            correcao_percentual = brw_inventario_correcao.estico_percentual
            correcao_operacao = brw_inventario_correcao.estico_mais_menos

        def _get_valor_correcao(custo_qtd, valor):
            res = 0.0
            if not inventario_correcao_ids:
                return res
            if custo_qtd != correcao_custo_qtd:
                return res
            res = valor * (correcao_percentual / 100)
            if correcao_operacao == 'D':
                res *= -1
            return res

        total_geral = 0
        if contagem_dados:
            produto_ids = list(set(map(lambda m: m.get('produto_id'), contagem_dados)))
            grade_ids = list(set(map(lambda m: m.get('grade_id'), contagem_dados)))
            dict_contagem_produto_dados = dict()
            for contagem in contagem_dados:
                produto_grade = '%s%s' % (contagem.get('produto_id'), contagem.get('grade_id'))
                if contagem.get('local_id'):
                    produto_grade += str(contagem.get('local_id'))
                if dict_contagem_produto_dados.get(produto_grade):
                    dict_contagem_produto_dados[produto_grade] += \
                        ((contagem.get('saldo_contado') or 0) + (contagem.get('requisitado') or 0))
                    continue
                dict_contagem_produto_dados[produto_grade] = \
                    ((contagem.get('saldo_contado') or 0) + (contagem.get('requisitado') or 0))

            if tipo_custo != 'P':
                custo_dados = self.db_name.get('estoque.preco.custo').get_custos_do_dia(
                    cr, uid, produto_ids)
                precos_venda = dict()
            else:
                precos_venda = self.db_name.get('estoque.preco.venda').get_preco_venda(
                    cr, uid, epc_produto_ids=produto_ids, epc_grade_ids=grade_ids,
                    epc_company_id=datas.get('company_id'))
                custo_dados = dict()
            list_produto_grade = list()
            for i in contagem_dados:
                if i.get('saldo_contado') <= 0:
                    continue

                produto_grade = '%s%s' % (i.get('produto_id'), i.get('grade_id'))
                if i.get('local_id'):
                    produto_grade += str(i.get('local_id'))
                if not datas.get('local_id') and produto_grade in list_produto_grade:
                    continue

                ## _________ CLASSIFICACAO FISCAL ____________
                inv_produto_ncm = ''
                ## _________ DISCRIMINACAO ________________
                produto_codigo = i.get('codigo') or ''
                grade = i.get('grade') or ''
                inv_produto_name = '%s %s %s' % (produto_codigo, grade, i.get('name') or '')
                ## _________ UNIDADE ________________
                inv_produto_unidade = i.get('unidade_inventario') or ''
                ## _________ QUANTIDADE _____________
                if not datas.get('local_id'):
                    inv_produto_quantidade = dict_contagem_produto_dados.get(produto_grade) or 0
                else:
                    inv_produto_quantidade = i.get('saldo_contado') + i.get('requisitado') or 0.0
                ## _________ VALOR UNITARIO ____________
                inv_produto_valor_unitario = 0
                ## _________ VALOR TOTAL _____________

                ultimo_custo = i.get('ultimo_custo') or 0
                custo_medio_contabil = i.get('custo_medio_contabil') or 0
                ultimo_custo += _get_valor_correcao('C', ultimo_custo)
                ultimo_custo = float(obj_inventario_oficial._float_persist('estiof_ultimo_custo',
                                                                           ultimo_custo))
                custo_medio_contabil += _get_valor_correcao('C', custo_medio_contabil)
                custo_medio_contabil = float(obj_inventario_oficial._float_persist(
                    'estiof_custo_medio_contabil', custo_medio_contabil))

                if inv_produto_quantidade <= 0:
                    continue

                inv_produto_quantidade += _get_valor_correcao('Q', inv_produto_quantidade)
                inv_produto_quantidade = float(obj_inventario_oficial._float_persist(
                    'saldo', inv_produto_quantidade))

                if not i.get('fracionamento'):
                    inv_produto_quantidade = int(round(inv_produto_quantidade, 1))
                custos = tipo_custo != 'P' and custo_dados.get(i.get('produto_id'))
                if tipo_custo == 'U':
                    inv_produto_valor_unitario = ultimo_custo
                elif tipo_custo == 'C':
                    inv_produto_valor_unitario = custo_medio_contabil
                elif tipo_custo == 'O':
                    custo_corrigido = custos and custos.get('estprc_custo_corrigido') or 0
                    inv_produto_valor_unitario = custo_corrigido
                elif tipo_custo == 'R':
                    custo_reposicao = custos and custos.get('estprc_custo_reposicao') or 0
                    inv_produto_valor_unitario = custo_reposicao
                elif tipo_custo == 'P':
                    preco_venda = precos_venda.get(i.get('produto_id'))
                    preco_venda = preco_venda and (preco_venda.get('grade_id') or
                                                   preco_venda.get('preco_venda'))
                    inv_produto_valor_unitario = preco_venda or 0
                else:
                    inv_produto_valor_unitario = 0

                produto_valor_total = float(
                    float_round(inv_produto_quantidade * inv_produto_valor_unitario, 2))
                total_geral += produto_valor_total

                chave = ''
                if datas.get('ordem_listar') == 'C':
                    chave = i.get('categoria_conta')
                elif fiscal_instalado:
                    chave = tributacao_dados.get(str(i.get('produto_id'))) or ''
                    inv_produto_ncm = ncm_dados.get(str(i.get('produto_id'))) or ''

                itens = {
                    'classificacao': inv_produto_ncm,
                    'discriminacao': inv_produto_name,
                    'unidade': inv_produto_unidade,
                    'quantidade': inv_produto_quantidade,
                    'valor_unitario': inv_produto_valor_unitario,
                    'valor_total': produto_valor_total,
                    'categoria_name': i.get('categoria_name') or ''
                }

                if inv_produto_name:
                    if not registros.get(chave):
                        registros[chave] = []
                    registros[chave].append(itens)
                obj_inventario_oficial.estiof_gerar_inventario_oficial(
                    cr, uid, i.get('contagem_id'), inv_produto_quantidade, ultimo_custo,
                    custo_medio_contabil, context=context)
                if not inv_produto_valor_unitario:
                    itens_sem_custo.append(inv_produto_name)
        else:
            obj_estoque_produto = self.db_name.get('estoque.produto')
            produto_ids = obj_estoque_produto.search(cr, uid, [('active', '=', True)], context=context)
            browse_estoque_produto = obj_estoque_produto.browse(cr, uid, produto_ids)
            for produto in browse_estoque_produto:
                chave = ''
                if fiscal_instalado:
                    produto_tributacao_ids = produto.tributacao_ids
                    if produto_tributacao_ids:
                        for t in produto_tributacao_ids:
                            encargo = t.tributacao_id.encargo_id
                            if encargo:
                                if encargo.sigla == 'ICMS' and t.tipo_tributacao == 'T':
                                    chave = t.tributacao_id.name

                itens = {
                    'classificacao': '',
                    'discriminacao': '',
                    'unidade': '',
                    'quantidade': 0,
                    'valor_unitario': 0,
                    'valor_total': 0
                }

                if not registros.get(chave):
                    registros[chave] = []
                    registros[chave].append(itens)
        registros.update({'total_geral': total_geral, 'itens_sem_custo': itens_sem_custo})
        return registros

    def listar_itens(self, listagem, registros, datas, context=None):
        context = context and context.copy() or {}
        first_page = True
        total_geral = registros.get('total_geral')
        itens_sem_custo = registros.get('itens_sem_custo')
        del registros['itens_sem_custo']
        del registros['total_geral']
        chaves = registros.keys()
        descricao_subtotal = 'tributacao'
        if datas.get('ordem_listar') == 'C':
            chaves.sort()
            descricao_subtotal = 'categoria'
        for key in chaves:
            total_quantidade = 0
            total_valor_unitario = 0
            total_valor_total = 0
            if datas.get('ordem_listar') == 'C':
                categoria_name = ''
                if registros.get(key):
                    categoria_name = registros.get(key)[0].get('categoria_name')
                chave = formataString('Categoria: %s-%s' % (key or '', categoria_name),
                                      self.traco_linha, ' ', 'C', 'N', 'S')
            else:
                chave = formataString('Tributacao: ' + key, self.traco_linha, ' ', 'C', 'N', 'S')
            self.definir_cabecalho(listagem, datas, context)
            listagem.informaCab('|' + ('-' * self.traco_linha) + '|')
            listagem.informaCab('|' + chave + '|')
            listagem.informaCab('|' + ('-' * self.traco_linha) + '|')
            ## Controle para quebra de paginas.
            if not first_page:
                listagem.imprimeLinha('{{ Page }}')
            else:
                first_page = False
            for itens in registros[key]:
                classificacao = itens.get('classificacao') or ''
                dicriminacao = itens.get('discriminacao') or ''
                unidade = itens.get('unidade') or ''
                quantidade = getNumeroEditado(itens.get('quantidade') or 0.0, 3)
                valor_unitario = getNumeroEditado(itens.get('valor_unitario') or 0.0, 2)
                valor_total = getNumeroEditado(itens.get('valor_total') or 0.0, 2)

                str_classificao = formataString(classificacao, self.col_classific_fiscal, ' ', 'D', 'N', 'S')
                str_discriminacao = formataString(dicriminacao, self.col_discriminacao, ' ', 'D', 'N', 'S')
                str_unidade = formataString(unidade, self.col_unidade, ' ', 'D', 'N', 'S')
                str_quantidade = formataString(str(quantidade), self.col_quantidade, ' ', 'E', 'N', 'S')
                str_valor_unitario = formataString(str(valor_unitario), self.col_unitario, ' ', 'E', 'N', 'S')
                str_valor_total = formataString(str(valor_total), self.col_total, ' ', 'E', 'N', 'S')
                total_quantidade += itens.get('quantidade') or 0.0
                total_valor_unitario += itens.get('valor_unitario') or 0.0
                total_valor_total += itens.get('valor_total') or 0.0

                listagem.imprimeLinha(
                    '|' + str_classificao + '|' + str_discriminacao + '|' + str_unidade + '|' +
                    str_quantidade + '|' + str_valor_unitario + '|' + str_valor_total + '|')

            del registros[key]
            if total_quantidade or total_valor_unitario or total_valor_total:
                listagem.imprimeLinha('*' + ('-' * self.traco_linha) + '*')
                linha = '|'
                linha += formataString('Sub Total por %s: %s' % (descricao_subtotal, key or ''),
                                       self.col_classific_fiscal + self.col_discriminacao + self.col_unidade + 2,
                                       ' ', 'C', 'N', 'S') + '|'
                linha += formataString(getNumeroEditado(total_quantidade, 3), self.col_quantidade,
                                       ' ', 'E', 'N', 'S')  + '|'
                linha += formataString(getNumeroEditado(total_valor_unitario, 2), self.col_unitario,
                                       ' ', 'E', 'N', 'S')  + '|'
                linha += formataString(getNumeroEditado(total_valor_total, 2), self.col_total,
                                       ' ', 'E', 'N', 'S')  + '|'
                listagem.imprimeLinha(linha)

            listagem.cabecalhos = []
            listagem.imprimeLinha('*' + ('-' * self.traco_linha) + '*')

        listagem.imprimeLinha('')
        listagem.imprimeLinha(' TOTAL' + (' ' * (self.traco_linha - 19)) +
                              formataString(getNumeroEditado(total_geral, 2), 14, ' ', 'E', 'N',
                                            'S') + ' ')
        if itens_sem_custo:
            listagem.imprimeLinha('')
            listagem.imprimeLinha('')
            listagem.imprimeLinha('')
            listagem.imprimeLinha('ITENS SEM CUSTO:')
            listagem.imprimeLinha('')
            for item in itens_sem_custo:
                listagem.imprimeLinha(item)


report_custom('report.registro_inventario')


class rel_registro_inventario_osv(osv.TransientModel):
    def pagina_parametro(self, cr, uid, fields, context=None):
        context = context and context.copy() or {}
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
        obj_adm_paginas = self.pool.get('adm.paginas')
        id_pagina = obj_adm_paginas.search(cr, uid, [('company_id', '=', company_id), ('tipo', '=', 'inventario'),
                                                     ('write_date', '<=', time.strftime('%Y-%m-%d %H:%M:%S'))], 0, 1,
                                           'write_date DESC', context=context)
        id_pagina2 = obj_adm_paginas.search(cr, uid, [('company_id', '=', company_id), ('tipo', '=', 'inventario'),
                                                      ('create_date', '<=', time.strftime('%Y-%m-%d %H:%M:%S'))], 0, 1,
                                            'create_date DESC', context=context)
        if id_pagina and id_pagina2:
            if id_pagina[0] <= id_pagina2[0]:
                id_pagina = id_pagina2
        elif id_pagina2 and not id_pagina:
            id_pagina = id_pagina2
        if id_pagina:
            final = obj_adm_paginas.browse(cr, uid, id_pagina[0]).final
            if final:
                final += 1
            else:
                final = obj_adm_paginas.browse(cr, uid, id_pagina[0]).inicial
                if final:
                    final += 1
        else:
            final = 1
        return final

    # noinspection PyMethodMayBeStatic
    def _get_preco_listar(self, cr, user, context=None):
        """
        Retorna lista com os tipos de precos a listar no inventario.

        :param cr: cursor no banco de dados
        :param user: id da tabela res_users, identificador do usuario
        :param context: um dicionario padrao para valores contextuais
        :return: lista com os tipos de precos a listar
        :rtype: list

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """
        context = context and context.copy() or dict()
        return [('U', 'Ultimo custo'), ('C', 'Custo medio contabil'), ('O', 'Custo corrigido'),
                ('R', 'Custo de reposicao'), ('P', 'Preco de venda')]

    def get_ordem_listar(self, cr, uid, context=None):
        """
        Retorna lista com os tipos de ordenacao para listagem do inventario.
        :param cr: cursor no banco de dados
        :param uid: id da tabela res_users, identificador do usuario
        :param context: um dicionario padrao para valores contextuais
        :return: lista com os tipos de precos a listar
        :rtype: list
        """
        context = context and context.copy() or dict()
        return [('C', 'Categoria')]

    def _set_preco_listar(self, cr, user, context=None):
        """
        Define o valor padrao do "preco a listar" em funcao do valor definido no parametro do
        Estoque.

        :param cr: cursor no banco de dados
        :param user: id da tabela res_users, identificador do usuario
        :param context: um dicionario padrao para valores contextuais
        :type cr: object
        :type user: int
        :type context: dict
        :return: o valor do atributo ´custo_inventario' definido no parametro do estoque.
        :rtype: str

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """
        context = context and context.copy() or dict()
        estoque_parametro = self.pool.get('adm.utils').admutl_get_parametros(
            cr, user, 'estoque', ['custo_inventario'], context)
        return estoque_parametro.get('custo_inventario') or str()

    def set_ordem_listar(self, cr, user, context=None):
        """
        Define o valor padrao da "orden a listar" para 'C', categoria.
        :param cr: cursor no banco de dados
        :param user: id da tabela res_users, identificador do usuario
        :param context: um dicionario padrao para valores contextuais
        :type cr: object
        :type user: int
        :type context: dict
        :return: caracter 'C' que se refere a categoria.
        :rtype: str
        """
        context = context and context.copy() or dict()
        return 'C'

    _name = 'rel.registro.inventario.osv'
    _description = ''
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', required=True),
        'inventario_id': fields.many2one('estoque.inventario.capa', 'Inventario', ondelete='cascade',
                                         domain="[('company_id', '=', company_id)]", required=True),
        'inventario_data': fields.date('Data do Inventario', required=True),
        'pagina': fields.integer('Pagina', help='Informe a folha inicial', required=True),
        'local_id': fields.many2one('estoque.local', 'Local',
                                    help='Filtra pelo local selecionado.'),
        'preco_listar': fields.selection(_get_preco_listar, 'Preco a listar',
                                         help='Informa o preco a ser mostrado no inventario.'),
        'ordem_listar': fields.selection(get_ordem_listar, 'Ordem a listar', size=1),
        'categoria_id': fields.many2one('estoque.categoria', 'Categoria'),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(cr, uid, uid).company_id.id,
        'pagina': pagina_parametro,
        'preco_listar': lambda s, c, u, x: s._set_preco_listar(c, u, x),
        'ordem_listar': lambda s, c, u, x: s.set_ordem_listar(c, u, x),
    }

    def button_estoque_inventario_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}

        estrutura, dados = self.get_dados_rel(cr, uid, ids, context)
        context['estrutura'] = estrutura
        context['dados'] = dados
        return self.pool.get('wizard.relatorios.impressao').get_tela_relatorios(cr, uid, context)

    def get_dados_rel(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        dados_inventario = self.estoque_inventario_get_dados(cr, uid, ids, context)

        pagina = {'relpag_nome_rel': _('Registro de Inventario'),
                  'relpag_num': dados_inventario.get('folha'),
                  'relpag_tam_linha': 150,
                  'relpag_fonte_tamanho': 9.0,
                  'relpag_margem_esquerda': 0.5,
                  'relpag_margem_direita': 0.5,
                  'relpag_margem_superior': 0.5,
                  'relpag_margem_inferior': 0.5,
                  'relpag_cabecalhos': [{'relcab_name': 'cab1',
                                         'relcab_separa_coluna': '|',
                                         'relcab_colunas': [{'relcol_name': 'titulo',
                                                             'relcol_dados_tam': 148,
                                                             'relcol_dados_alinhamento': 'C'}]},
                                        {'relcab_name': 'cab2',
                                         'relcab_separa_coluna': '|',
                                         'relcab_colunas': [{'relcol_name': 'empresa',
                                                             'relcol_dados_alinhamento': 'D',
                                                             'relcol_dados_tam': 148}]},
                                        {'relcab_name': 'cab3',
                                         'relcab_separa_coluna': '|',
                                         'relcab_colunas': [{'relcol_name': 'cnpj',
                                                             'relcol_dados_tam': 35},
                                                            {'relcol_name': 'ie',
                                                             'relcol_nao_separa_coluna': True,
                                                             'relcol_dados_tam': 50},
                                                            {'relcol_name': 'pagina',
                                                             'relcol_nao_separa_coluna': True,
                                                             'relcol_dados_alinhamento': 'E',
                                                             'relcol_dados_tam': 54}], },
                                        {'relcab_name': 'cab4',
                                         'relcab_separa_coluna': '|',
                                         'relcab_divide_linha': True,
                                         'relcab_colunas': [{'relcol_name': 'data_estoque',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 148}]},
                                        {'relcab_name': 'cab_col',
                                         'relcab_separa_coluna': '|',
                                         'relcab_cor': 'Blue',
                                         'relcab_colunas': [{'relcol_name': 'col1',
                                                             'relcol_dados_alinhamento': 'D',
                                                             'relcol_dados_tam': 19},
                                                            {'relcol_name': 'col2',
                                                             'relcol_dados_alinhamento': 'D',
                                                             'relcol_dados_tam': 62},
                                                            {'relcol_name': 'col3',
                                                             'relcol_dados_alinhamento': 'D',
                                                             'relcol_dados_tam': 9},
                                                            {'relcol_name': 'col4',
                                                             'relcol_dados_alinhamento': 'E',
                                                             'relcol_dados_tam': 12},
                                                            {'relcol_name': 'col5',
                                                             'relcol_dados_alinhamento': 'E',
                                                             'relcol_dados_tam': 20},
                                                            {'relcol_name': 'col6',
                                                             'relcol_dados_alinhamento': 'E',
                                                             'relcol_dados_tam': 21}
                                                            ], },
                                        {'relcab_name': 'cab_col1',
                                         'relcab_separa_coluna': '|',
                                         'relcab_divide_linha': True,
                                         'relcab_cor': 'Blue',
                                         'relcab_colunas': [{'relcol_name': 'col1',
                                                             'relcol_dados_alinhamento': 'D',
                                                             'relcol_dados_tam': 19},
                                                            {'relcol_name': 'col2',
                                                             'relcol_dados_alinhamento': 'D',
                                                             'relcol_dados_tam': 62},
                                                            {'relcol_name': 'col3',
                                                             'relcol_dados_alinhamento': 'D',
                                                             'relcol_dados_tam': 9},
                                                            {'relcol_name': 'col4',
                                                             'relcol_dados_alinhamento': 'E',
                                                             'relcol_dados_tam': 12},
                                                            {'relcol_name': 'col5',
                                                             'relcol_dados_alinhamento': 'E',
                                                             'relcol_dados_tam': 20},
                                                            {'relcol_name': 'col6',
                                                             'relcol_dados_alinhamento': 'E',
                                                             'relcol_dados_tam': 21}
                                                            ], },
                                        ],

                  'relpag_linhas': [{'rellin_name': 'linha1',
                                     'rellin_separa_coluna': '|',
                                     'rellin_divide_linha': True,
                                     'rellin_nova_pagina': True,
                                     'rellin_colunas': [{'relcol_name': 'tributacao',
                                                         'relcol_dados_alinhamento': 'C',
                                                         'relcol_dados_tam': 148}]
                                     },
                                    {'rellin_name': 'linha2',
                                     'rellin_separa_coluna': '|',
                                     'rellin_colunas': [{'relcol_name': 'classificacao',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 19},
                                                        {'relcol_name': 'discriminacao',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 62},
                                                        {'relcol_name': 'unidade',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 9},
                                                        {'relcol_name': 'quantidade',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 12},
                                                        {'relcol_name': 'unitario',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 20},
                                                        {'relcol_name': 'total',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 21}]
                                     },
                                    {'rellin_name': 'linha3',
                                     'rellin_separa_coluna': '|',
                                     'rellin_divide_linha': True,
                                     'rellin_divide_linha_anterior': True,
                                     'rellin_colunas': [{'relcol_name': 'descr_subtotal',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 19},
                                                        {'relcol_name': 'discriminacao',
                                                         'relcol_nao_separa_coluna': True,
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 62},
                                                        {'relcol_name': 'unidade',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 9},
                                                        {'relcol_name': 'quantidade',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 12},
                                                        {'relcol_name': 'unitario',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 20},
                                                        {'relcol_name': 'total',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 21}]
                                    },
                                    {'rellin_name': 'linha_total',
                                     'rellin_colunas': [{'relcol_name': 'descr_total',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 19},
                                                        {'relcol_name': 'discriminacao',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 62},
                                                        {'relcol_name': 'unidade',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 9},
                                                        {'relcol_name': 'quantidade',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 12},
                                                        {'relcol_name': 'unitario',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 20},
                                                        {'relcol_name': 'total',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 27}]
                                     },
                                    {'rellin_name': 'linha_item_sem_custo',
                                     'rellin_colunas': [{'relcol_name': 'descr_sem_custo',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 16},
                                                        {'relcol_name': 'item',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 80}]
                                     }
                                    ],
                  }

        dados = {'cab1': {'titulo': _('Registro de Inventario')},
                 'cab2': {'empresa': 'Empresa: ' + dados_inventario.get('company_name')},
                 'cab3': {'cnpj': 'CNPJ: ' + dados_inventario.get('company_cnpj'),
                          'ie': 'Inscr. Estadual: ' + dados_inventario.get('company_ie'),
                          'pagina': '|pag|'},
                 'cab4': {'data_estoque': 'ESTOQUE EXISTENTE EM: ' + dados_inventario.get(
                     'inventario_data')},
                 'cab_col': {'col1': _('Classificacao'),
                             'col2': _('Discriminacao'),
                             'col3': _('Unidade'),
                             'col4': _('Quantidade'),
                             'col5': _('Valores'),
                             'col6': ''},
                 'cab_col1': {'col1': 'Fiscal',
                              'col2': '',
                              'col3': '',
                              'col4': '',
                              'col5': 'Unitario',
                              'col6': 'Total'}
                 }

        registros = self.get_registros(cr, uid, dados_inventario, context=context)
        dados['linhas'] = self.listar_itens(registros, dados_inventario, context=context) or []

        return pagina, dados

    def atualiza_paginacao(self, cr, uid, num_pagina_ini, num_pagina_fin, data, context=None):
        context = context and context.copy() or {}
        # ATUALIZA NUMERO DA FOLHA E DATA FINAL DA TABELA adm.paginas

        inventario_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'estoque.inventario.capa', context=context)
        obj_adm_paginas = self.pool.get('adm.paginas')
        adm_paginas_ids = obj_adm_paginas.search(cr, uid,
                                                 [('company_id', '=', inventario_company_id),
                                                  ('tipo', '=', 'inventario'),
                                                  ('write_date', '<=',
                                                   time.strftime('%Y-%m-%d %H:%M:%S'))], 0,
                                                 1,
                                                 'write_date DESC', context)
        adm_paginas_ids2 = obj_adm_paginas.search(cr, uid,
                                                  [('company_id', '=', inventario_company_id),
                                                   ('tipo', '=', 'inventario'),
                                                   ('create_date', '<=',
                                                    time.strftime('%Y-%m-%d %H:%M:%S'))],
                                                  0, 1,
                                                  'create_date DESC', context)
        if adm_paginas_ids and adm_paginas_ids2:
            data_adm_paginas_ids = obj_adm_paginas.browse(cr, uid, adm_paginas_ids[0],
                                                          context=context).write_date
            data_adm_paginas_ids2 = obj_adm_paginas.browse(cr, uid, adm_paginas_ids2[0],
                                                           context=context).create_date
            if data_adm_paginas_ids < data_adm_paginas_ids2:
                adm_paginas_ids = adm_paginas_ids2
        elif adm_paginas_ids2 and not adm_paginas_ids:
            adm_paginas_ids = adm_paginas_ids2
        vals = {
            'inicial': num_pagina_ini,
            'final': num_pagina_fin,
            'data': data,
            'tipo': 'inventario',
            'company_id': inventario_company_id
        }
        if not adm_paginas_ids:
            obj_adm_paginas.create(cr, uid, vals, context=context)
        else:
            obj_adm_paginas.write(cr, uid, adm_paginas_ids, vals, context=context)
        return True

    def get_registros(self, cr, uid, datas, context=None):
        context = context and context.copy() or {}
        registros = {}
        itens_sem_custo = []
        tipo_custo = datas.get('preco_listar')
        contagem_dados = datas.get('inventario_contagem_dados')
        tributacao_dados = datas.get('tributacao_produto_dados')
        ncm_dados = datas.get('ncm_produto_dados')

        # Todo: Levar pro modulo fiscal atribuicoes do fiscal
        fiscal_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'fiscal', context)

        inventario_id = datas.get('inventario_id')
        obj_inventario_oficial = self.pool.get('estoque.inventario.oficial')
        if not inventario_id:
            raise osv.except_osv(_('Atencao'),
                                 _('Nenhum inventario foi selecionado para a geracao do Registro de Inventario!'))
        # pesquisa os inventarios oficiais relacionados ao inventario selecionado na tela
        # e faz a exclusao dos mesmos
        sql = """
            DELETE FROM estoque_inventario_oficial WHERE capa_id = %s
        """ % inventario_id
        cr.execute(sql)

        inventario_correcao_ids = self.pool.get('estoque.inventario.correcao').search(
            cr, uid, [('estico_inventario_id', '=', inventario_id)], context=context)
        correcao_custo_qtd = ''
        correcao_percentual = ''
        correcao_operacao = ''
        if inventario_correcao_ids:
            brw_inventario_correcao = self.pool.get('estoque.inventario.correcao').browse(
                cr, uid, inventario_correcao_ids[0], context)
            correcao_custo_qtd = brw_inventario_correcao.estico_custo_qtd
            correcao_percentual = brw_inventario_correcao.estico_percentual
            correcao_operacao = brw_inventario_correcao.estico_mais_menos

        def _get_valor_correcao(custo_qtd, valor):
            res = 0.0
            if not inventario_correcao_ids:
                return res
            if custo_qtd != correcao_custo_qtd:
                return res
            res = valor * (correcao_percentual / 100)
            if correcao_operacao == 'D':
                res *= -1
            return res

        total_geral = 0
        if contagem_dados:
            produto_ids = list(set(map(lambda m: m.get('produto_id'), contagem_dados)))
            grade_ids = list(set(map(lambda m: m.get('grade_id'), contagem_dados)))
            dict_contagem_produto_dados = dict()
            for contagem in contagem_dados:
                produto_grade = '%s%s' % (contagem.get('produto_id'), contagem.get('grade_id'))
                if contagem.get('local_id'):
                    produto_grade += str(contagem.get('local_id'))
                if dict_contagem_produto_dados.get(produto_grade):
                    dict_contagem_produto_dados[produto_grade] += \
                        ((contagem.get('saldo_contado') or 0) + (contagem.get('requisitado') or 0))
                    continue
                dict_contagem_produto_dados[produto_grade] = \
                    ((contagem.get('saldo_contado') or 0) + (contagem.get('requisitado') or 0))

            if tipo_custo != 'P':
                custo_dados = self.pool.get('estoque.preco.custo').get_custos_do_dia(
                    cr, uid, produto_ids)
                precos_venda = dict()
            else:
                precos_venda = self.pool.get('estoque.preco.venda').get_preco_venda(
                    cr, uid, epc_produto_ids=produto_ids, epc_grade_ids=grade_ids,
                    epc_company_id=datas.get('company_id'))
                custo_dados = dict()
            list_produto_grade = list()
            for i in contagem_dados:
                if i.get('saldo_contado') <= 0:
                    continue

                produto_grade = '%s%s' % (i.get('produto_id'), i.get('grade_id'))
                if i.get('local_id'):
                    produto_grade += str(i.get('local_id'))
                if not datas.get('local_id') and produto_grade in list_produto_grade:
                    continue
                list_produto_grade.append(produto_grade)

                ## _________ CLASSIFICACAO FISCAL ____________
                inv_produto_ncm = ''
                ## _________ DISCRIMINACAO ________________
                produto_codigo = i.get('codigo') or ''
                grade = i.get('grade') or ''
                inv_produto_name = '%s %s %s' % (produto_codigo, grade, i.get('name') or '')
                ## _________ UNIDADE ________________
                inv_produto_unidade = i.get('unidade_inventario') or ''
                ## _________ QUANTIDADE _____________
                if not datas.get('local_id'):
                    inv_produto_quantidade = dict_contagem_produto_dados.get(produto_grade) or 0
                else:
                    inv_produto_quantidade = i.get('saldo_contado') + i.get('requisitado') or 0.0
                ## _________ VALOR UNITARIO ____________
                inv_produto_valor_unitario = 0
                ## _________ VALOR TOTAL _____________

                ultimo_custo = i.get('ultimo_custo') or 0
                custo_medio_contabil = i.get('custo_medio_contabil') or 0
                ultimo_custo += _get_valor_correcao('C', ultimo_custo)
                ultimo_custo = float(obj_inventario_oficial._float_persist('estiof_ultimo_custo',
                                                                           ultimo_custo))
                custo_medio_contabil += _get_valor_correcao('C', custo_medio_contabil)
                custo_medio_contabil = float(obj_inventario_oficial._float_persist(
                    'estiof_custo_medio_contabil', custo_medio_contabil))

                if inv_produto_quantidade <= 0:
                    continue

                inv_produto_quantidade += _get_valor_correcao('Q', inv_produto_quantidade)
                inv_produto_quantidade = float(obj_inventario_oficial._float_persist(
                    'saldo', inv_produto_quantidade))

                if not i.get('fracionamento'):
                    inv_produto_quantidade = int(round(inv_produto_quantidade, 1))
                custos = tipo_custo != 'P' and custo_dados.get(i.get('produto_id'))
                if tipo_custo == 'U':
                    inv_produto_valor_unitario = ultimo_custo
                elif tipo_custo == 'C':
                    inv_produto_valor_unitario = custo_medio_contabil
                elif tipo_custo == 'O':
                    custo_corrigido = custos and custos.get('estprc_custo_corrigido') or 0
                    inv_produto_valor_unitario = custo_corrigido
                elif tipo_custo == 'R':
                    custo_reposicao = custos and custos.get('estprc_custo_reposicao') or 0
                    inv_produto_valor_unitario = custo_reposicao
                elif tipo_custo == 'P':
                    preco_venda = precos_venda.get(i.get('produto_id'))
                    preco_venda = preco_venda and (preco_venda.get('grade_id') or
                                                   preco_venda.get('preco_venda'))
                    inv_produto_valor_unitario = preco_venda or 0
                else:
                    inv_produto_valor_unitario = 0

                produto_valor_total = float(
                    float_round(inv_produto_quantidade * inv_produto_valor_unitario, 2))
                total_geral += produto_valor_total

                chave = ''
                if datas.get('ordem_listar') == 'C':
                    chave = i.get('categoria_conta')
                elif fiscal_instalado:
                    chave = tributacao_dados.get(i.get('produto_id')) or ''
                    inv_produto_ncm = ncm_dados.get(i.get('produto_id')) or ''

                itens = {
                    'classificacao': inv_produto_ncm,
                    'discriminacao': inv_produto_name,
                    'unidade': inv_produto_unidade,
                    'quantidade': inv_produto_quantidade,
                    'valor_unitario': inv_produto_valor_unitario,
                    'valor_total': produto_valor_total,
                    'categoria_name': i.get('categoria_name') or ''
                }

                if inv_produto_name:
                    if not registros.get(chave):
                        registros[chave] = []
                    registros[chave].append(itens)
                obj_inventario_oficial.estiof_gerar_inventario_oficial(
                    cr, uid, i.get('contagem_id'), inv_produto_quantidade, ultimo_custo,
                    custo_medio_contabil, context=context)
                if not inv_produto_valor_unitario:
                    itens_sem_custo.append(inv_produto_name)
        else:
            obj_estoque_produto = self.pool.get('estoque.produto')
            produto_ids = obj_estoque_produto.search(cr, uid, [('active', '=', True)], context=context)
            browse_estoque_produto = obj_estoque_produto.browse(cr, uid, produto_ids)
            for produto in browse_estoque_produto:
                chave = ''
                if fiscal_instalado:
                    produto_tributacao_ids = produto.tributacao_ids
                    if produto_tributacao_ids:
                        for t in produto_tributacao_ids:
                            encargo = t.tributacao_id.encargo_id
                            if encargo:
                                if encargo.sigla == 'ICMS' and t.tipo_tributacao == 'T':
                                    chave = t.tributacao_id.name

                itens = {
                    'classificacao': '',
                    'discriminacao': '',
                    'unidade': '',
                    'quantidade': 0,
                    'valor_unitario': 0,
                    'valor_total': 0
                }

                if not registros.get(chave):
                    registros[chave] = []
                    registros[chave].append(itens)
        registros.update({'total_geral': total_geral, 'itens_sem_custo': itens_sem_custo})
        return registros

    def listar_itens(self, registros, datas, context=None):
        context = context and context.copy() or {}
        # first_page = True
        total_geral = registros.get('total_geral')
        itens_sem_custo = registros.get('itens_sem_custo')
        del registros['itens_sem_custo']
        del registros['total_geral']
        chaves = registros.keys()
        descricao_subtotal = 'tributacao'
        if datas.get('ordem_listar') == 'C':
            chaves.sort()
            descricao_subtotal = 'categoria'
        linhas = []
        for key in chaves:
            total_quantidade = 0
            total_valor_unitario = 0
            total_valor_total = 0
            if datas.get('ordem_listar') == 'C':
                categoria_name = ''
                if registros.get(key):
                    categoria_name = registros.get(key)[0].get('categoria_name')
                chave = 'Categoria: %s-%s' % (key or '', categoria_name)
            else:
                chave = 'Tributacao: ' + key
            linhas.append({'linha1': {
                'tributacao': chave
            }})
            for itens in registros[key]:
                classificacao = itens.get('classificacao') or ''
                discriminacao = itens.get('discriminacao') or ''
                unidade = itens.get('unidade') or ''
                quantidade = getNumeroEditado(itens.get('quantidade') or 0.0, 3)
                valor_unitario = getNumeroEditado(itens.get('valor_unitario') or 0.0, 2)
                valor_total = getNumeroEditado(itens.get('valor_total') or 0.0, 2)

                total_quantidade += itens.get('quantidade') or 0.0
                total_valor_unitario += itens.get('valor_unitario') or 0.0
                total_valor_total += itens.get('valor_total') or 0.0

                linhas.append({'linha2': {
                    'classificacao': classificacao,
                    'discriminacao': discriminacao,
                    'unidade': unidade,
                    'quantidade': quantidade,
                    'unitario': valor_unitario,
                    'total': valor_total
                }})

            del registros[key]
            if total_quantidade or total_valor_unitario or total_valor_total:
                linhas.append({'linha3': {
                    'descr_subtotal': 'Sub Total por:',
                    'discriminacao': key or '',
                    'quantidade': getNumeroEditado(total_quantidade, 3),
                    'unitario': getNumeroEditado(total_valor_unitario, 2),
                    'total': getNumeroEditado(total_valor_total, 2)
                }})

        linhas.append({'linha_total': {
            'descr_total': 'TOTAL',
            'total': getNumeroEditado(total_geral, 2)
        }})

        if itens_sem_custo:
            linhas.append({'linha_item_sem_custo': {
                'descr_sem_custo': 'ITENS SEM CUSTO:',
                'item': ''
            }})

            for item in itens_sem_custo:
                linhas.append({'linha_item_sem_custo': {
                    'descr_sem_custo': '',
                    'item': item
                }})
        return linhas

    def estoque_inventario_get_dados(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        osv_inventario_dados = self.read(cr, uid, ids, [], context=context)
        if not osv_inventario_dados:
            raise osv.except_osv(_('Atencao!'), _('Nenhum filtro foi passado.'))

        if isinstance(osv_inventario_dados, list):
            osv_inventario_dados = osv_inventario_dados[0]

        inventario_id = osv_inventario_dados.get('inventario_id')
        if isinstance(inventario_id, (list, tuple)):
            inventario_id = inventario_id[0]
        data_inventario = osv_inventario_dados.get('inventario_data') or ''
        vals = {'esticp_data_livro_inventario': data_inventario}

        # Se o preco a listar nao for informado rececupera do parametro do Estoque
        preco_listar = osv_inventario_dados.get('preco_listar')
        preco_listar = preco_listar or self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', ['custo_inventario'], context).get('custo_inventario')
        if not preco_listar:
            raise osv.except_osv(_('Atencao!'),
                                 _('O custo para inventario nao foi informado no parametro do '
                                   'Estoque.'))
        context.update({'registro_inventario': True})
        self.pool.get('estoque.inventario.capa').write(cr, uid, inventario_id, vals, context=context)
        data_inventario = parse(data_inventario).date().strftime('%d-%m-%Y')

        if not inventario_id:
            raise osv.except_osv(_('Atencao!'),
                                 _('Nenhum inventario foi selecionado para a impressao.'))
        browse_inventario = self.pool.get('estoque.inventario.capa').browse(
            cr, uid, inventario_id, context)
        inventario_company_id = browse_inventario.company_id.id
        company_name = browse_inventario.company_id.name
        if not inventario_company_id:
            raise osv.except_osv(_('Atencao!'),
                                 _('Nenhuma empresa foi localizada para o inventario '
                                   'escolhido.'))
        companny_cnpj = browse_inventario.company_id.rescon_pessoa_id.cpf_cnpj or ''
        companny_ie = browse_inventario.company_id.rescon_pessoa_id.admpes_jur_ie or ''
        folha = osv_inventario_dados.get('pagina')
        local_id = osv_inventario_dados.get('local_id')
        local_id = local_id[0] if isinstance(local_id, tuple) else local_id
        registro_inventario_id = osv_inventario_dados.get('id')
        inventario_contagem = self.get_dados_inventario_contagem(
            cr, uid, registro_inventario_id, inventario_id, local_id, context)
        if not inventario_contagem:
            raise osv.except_osv(_('Atencao!'),
                                 _('Nenhum registro foi encontrado para impressao do livro.'))
        datas = dict(company_id=inventario_company_id, company_name=company_name,
                     company_ie=companny_ie, company_cnpj=companny_cnpj, folha=folha,
                     inventario_data=data_inventario, inventario_id=inventario_id,
                     preco_listar=preco_listar, inventario_contagem_dados=inventario_contagem,
                     ordem_listar=osv_inventario_dados.get('ordem_listar'))
        return datas

    # noinspection PyMethodMayBeStatic
    def get_dados_inventario_contagem(self, cr, uid, registro_inventario_id, inventario_id,
                                      local_id, context=None):
        context = context and context.copy()
        locacao_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'estoque.local.locacao', context=context)
        brw_registro_inventario = self.browse(cr, uid, registro_inventario_id, context)
        sql = """
            -- noinspection SqlDialectInspectionForFile
            SELECT  eic.id                              AS contagem_id,
                    --eic.local_id                        AS local_id,
                    ep.codigo                           AS codigo,
                    epg.grade                           AS grade,
                    ep.name                             AS name,
                    ep.estpro_unidade_inventario        AS unidade_inventario,
                    eic.saldo_contado                   AS saldo_contado,
                    COALESCE(eic.requisitado, 0)        AS requisitado,
                    eic.estict_ultimo_custo             AS ultimo_custo,
                    eic.estict_custo_medio_contabil     AS custo_medio_contabil,
                    ep.id                               AS produto_id,
                    epg.id                              AS grade_id,
                    eeu.fracao				            AS fracionamento
        """
        if brw_registro_inventario.ordem_listar == 'C':
            sql += """
                    ,
                    ec.conta                            AS categoria_conta,
                    ec.name                             AS categoria_name
            """
        sql += """
            FROM    estoque_inventario_contagem         AS eic
            INNER JOIN estoque_produto                  AS ep
                    ON ep.id = eic.produto_id
            INNER JOIN estoque_produto_grade            AS epg
                    ON epg.id = eic.grade_id
        """
        if brw_registro_inventario.ordem_listar == 'C':
            sql += """
            LEFT JOIN estoque_categoria                 AS ec
                    ON ec.id = ep.categoria_id
            """
        sql += """
            LEFT JOIN estoque_local_locacao ell 
                    ON epg.id = ell.grade_id AND eic.local_id = ell.local_id 
                       AND ell.active IS TRUE AND ell.company_id = {company_id}
            LEFT JOIN estoque_produto_embalagem epe 
                    ON epe.id = ell.estllc_produto_embalagem_id
            LEFT JOIN estoque_embalagem ee 
                    ON ee.id = epe.embalagem_id
            LEFT JOIN estoque_embalagem_unidade eeu 
                    ON eeu.id = ee.unidade_id
            WHERE
                inventario_id = {inventario_id}
        """.format(inventario_id=inventario_id, company_id=locacao_company_id)
        if brw_registro_inventario.categoria_id:
            categoria_ids = self.pool.get('estoque.categoria').search(
                cr, uid, [('parent_id', 'child_of', brw_registro_inventario.categoria_id.id)],
                context=context)
            if len(categoria_ids) == 1:
                categoria_ids = str(tuple(categoria_ids)).replace(',', '')
            else:
                categoria_ids = str(tuple(categoria_ids))
            sql += """
                AND ep.categoria_id IN %s
            """ % categoria_ids
        if local_id:
            sql += """
                AND eic.local_id = %s
            """ % local_id
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
