# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        def center_title(E,C,D,T=180):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title
        title = center_title('Contr. Estoque', _('Sugestao de Compra'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        # listagem.defineFormato(orientacao='1')
        listagem.informaTamLinha(180)
        listagem.informaNome(pdf_string, _('Sugestao de compra'))
        listagem.defineFonte(fonte='Courier', tam=7.0)

        obj_estsug_compra_capa = pooler.get_pool(cr.dbname).get('estsug.compra.capa')
        obj_estsug_compra_item = pooler.get_pool(cr.dbname).get('estsug.compra.item')
        obj_estsug_compra_item_estatistica = pooler.get_pool(cr.dbname).get(
            'estsug.compra.item.estatistica')

        sugestao_compra_id = datas.get('sugestao_compra_id')
        sugestao_compra_capa_dados = obj_estsug_compra_capa.read(cr, uid, sugestao_compra_id, [], context=context)
        if isinstance(sugestao_compra_capa_dados, list):
            sugestao_compra_capa_dados = sugestao_compra_capa_dados[0]
        item_ids = sugestao_compra_capa_dados.get('esgccp_item_ids')
        local = sugestao_compra_capa_dados.get('esgccp_local_id') or ''
        if local and isinstance(local, tuple):
            local = local[1]
        descricao =  sugestao_compra_capa_dados.get('name') or ''
        tipo_sugestao = sugestao_compra_capa_dados.get('esgccp_sugestao')
        if tipo_sugestao == 'M':
            sugestao = 'minimo/maximo'
            desc1 = 'MINIMO'
            desc2 = 'MAXIMO'
        else:
            sugestao = 'estatisticas'
            desc1 = 'SAIDAS'
            desc2 = 'MEDIA '
        prazo_sugestao = sugestao_compra_capa_dados.get('esgccp_prazo_sugestao')
        prazo_media = sugestao_compra_capa_dados.get('esgccp_prazo_media')
        custo = sugestao_compra_capa_dados.get('esgccp_custo')
        desc_custo = ''
        if custo == 'C':
            desc_custo = 'CUSTO CORRIGIDO'
        elif custo == 'M':
            desc_custo = 'CUSTO MED. CTB.'
        elif custo == 'R':
            desc_custo = 'CUSTO DE REPOS.'
        elif custo == 'U':
            desc_custo = '   ULTIMO CUSTO'
        if not desc_custo:
            desc_custo = '               '
        codigo_imprimir = sugestao_compra_capa_dados.get('esgccp_codigo_imprimir') or 'I'
        ordem_listar = sugestao_compra_capa_dados.get('esgccp_ordem')
        listar_estatistica = sugestao_compra_capa_dados.get('esgccp_lista_estatistica')
        context['estpro_codigo_e_digito'] = True
        sugestao_compra_item_dados = obj_estsug_compra_item.read(cr, uid, item_ids, [], context=context)
        if ordem_listar:
            if ordem_listar == 'O':
                sugestao_compra_item_dados = sorted(sugestao_compra_item_dados,
                                                    key=lambda i: i.get('esgcit_item_codigo'))
            elif ordem_listar == 'D':
                sugestao_compra_item_dados = sorted(sugestao_compra_item_dados,
                                                    key=lambda i: i.get('esgcit_item_descricao'))
            elif ordem_listar == 'U':
                sugestao_compra_item_dados = sorted(sugestao_compra_item_dados,
                                                    key=lambda i: i.get('esgcit_classificacao'))

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'estsug.compra.capa', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id,
                                                                               ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
        docs1 = center_title('Local: %s' % local, descricao, '')
        docs2 = 'Sugestao por %s.     Estoque para %s dias.      Media de vendas de %s meses' % \
                (sugestao, prazo_sugestao, prazo_media)

        listagem.informaCab(''+title)
        listagem.informaCab('')
        listagem.informaCab(''+docs)
        listagem.informaCab('')
        listagem.informaCab(''+docs1)
        listagem.informaCab(''+docs2)
        listagem.informaCab('*--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(_('|ABC ITEM        GR DESCRICAO                                                *  E n t r a d a s * UNI    EMB    %s   %s %s P.VENDA *Pedidos*     SALDO   DIAS   SUGESTAO|' % (desc1, desc2, desc_custo)))
        listagem.informaCab(_('|                                                                               Data     Quantid.                                                       Qtd. Dias                            |'))
        if listar_estatistica:
            listagem.informaCab(_('|    JANEIRO  FEVEREIRO      MARCO      ABRIL       MAIO      JUNHO      JULHO     AGOSTO   SETEMBRO    OUTUBRO   NOVEMBRO   DEZEMBRO') + ' ' * 56 + '|')
        listagem.informaCab('*--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab('  ')
        listagem.rodapePadrao()

        total_geral = 0
        for x in sugestao_compra_item_dados:
            ultima_entrada = x.get('esgcit_ult_entrada') or ''
            if ultima_entrada:
                ultima_entrada = time.strftime('%d/%m/%Y', time.strptime(ultima_entrada,
                                                                         '%Y-%m-%d'))
            preco_venda = x.get('esgcit_preco_venda') or 0
            preco_custo = x.get('esgcit_custo') or 0
            valor_sugestao = x.get('esgcit_sugestao') or 0
            total = preco_custo * valor_sugestao
            total_geral += total

            linha = formataString(x.get('esgcit_classificacao') or '', 3, ' ', 'C', 'N', 'S')+' '
            linha += ''
            if codigo_imprimir == 'F':
                linha += formataString(x.get('esgcit_codigo_fabricante') or '', 11, ' ', 'D', 'N', 'S')+' '
                linha += ''
            else:
                linha += formataString(x.get('esgcit_produto_id')[1] or '', 11, ' ', 'D', 'N', 'S')+' '
                linha += ''
            linha += formataString(x.get('esgcit_sigla_grade') or '', 2, ' ', 'D', 'N', 'S')+' '
            linha += ''
            linha += formataString(x.get('esgcit_item_descricao'), 56, ' ', 'D', 'N', 'S')+' '
            linha += ''
            linha += formataString(ultima_entrada, 10, ' ', 'D', 'N', 'S')+' '
            linha += ''
            linha += formataString(getNumeroEditado(x.get('esgcit_qtd_entrada') or 0, 2), 9, ' ', 'E', 'N', 'S')+' '
            linha += ''
            linha += formataString(x.get('esgcit_sigla_uni') or '', 3, ' ', 'D', 'N', 'S')+' '
            linha += ''
            linha += formataString(getNumeroEditado(x.get('esgcit_qtd_emb') or 0, 2), 6, ' ', 'E', 'N', 'S')+' '
            linha += ''
            if tipo_sugestao == 'E':
                linha += formataString(getNumeroEditado(x.get('esgcit_saidas') or 0, 2), 9, ' ', 'E', 'N', 'S')+' '
                linha += ''
                linha += formataString(getNumeroEditado(x.get('esgcit_media') or 0, 2), 7, ' ', 'E', 'N', 'S')+' '
                linha += ''
            else:
                linha += formataString(getNumeroEditado(x.get('esgcit_minimo') or 0, 2), 9, ' ', 'E', 'N', 'S')+' '
                linha += ''
                linha += formataString(getNumeroEditado(x.get('esgcit_maximo') or 0, 2), 7, ' ', 'E', 'N', 'S')+' '
                linha += ''
            linha += formataString(getNumeroEditado(x.get('esgcit_custo') or 0, 2), 15, ' ', 'E', 'N', 'S')+' '
            linha += ''
            linha += formataString(getNumeroEditado(preco_venda, 2), 8, ' ', 'E', 'N', 'S')+' '
            linha += ''
            linha += formataString(getNumeroEditado(x.get('esgcit_pedidos') or 0, 0), 5, ' ', 'E', 'N', 'S')+' '
            linha += ''
            linha += formataString(getNumeroEditado(x.get('esgcit_pedido_dias') or 0, 0), 3, ' ', 'E', 'N', 'S')+' '
            linha += ''
            linha += formataString(getNumeroEditado(x.get('esgcit_saldo') or 0, 2), 9, ' ', 'E', 'N', 'S')+' '
            linha += ''
            linha += formataString(x.get('esgcit_dias') or 0, 6, ' ', 'E', 'N', 'S')+' '
            linha += ''
            linha += formataString(getNumeroEditado(valor_sugestao, 2), 10, ' ', 'E', 'N', 'S')+'|'
            linha += ''
            listagem.imprimeLinha('|'+linha)
            if not listar_estatistica:
                continue
            item_estatistica_ids = obj_estsug_compra_item_estatistica.search(
                cr, uid, [('esgcie_item_id', '=', x.get('id'))], context=context)
            if item_estatistica_ids:
                item_estatistica_dados = obj_estsug_compra_item_estatistica.read(
                    cr, uid, item_estatistica_ids, [], context=context)
                if isinstance(item_estatistica_dados, list):
                    item_estatistica_dados = item_estatistica_dados[0]
                y = item_estatistica_dados
            else:
                y = {}
            linha = formataString(y.get('esgcie_janeiro') or 0, 10, ' ', 'E', 'N', 'S')+' '
            linha += ''
            linha += formataString(y.get('esgcie_fevereiro') or 0, 10, ' ', 'E', 'N', 'S')+' '
            linha += ''
            linha += formataString(y.get('esgcie_marco') or 0, 10, ' ', 'E', 'N', 'S')+' '
            linha += ''
            linha += formataString(y.get('esgcie_abril') or 0, 10, ' ', 'E', 'N', 'S')+' '
            linha += ''
            linha += formataString(y.get('esgcie_maio') or 0, 10, ' ', 'E', 'N', 'S')+' '
            linha += ''
            linha += formataString(y.get('esgcie_junho') or 0, 10, ' ', 'E', 'N', 'S')+' '
            linha += ''
            linha += formataString(y.get('esgcie_julho') or 0, 10, ' ', 'E', 'N', 'S')+' '
            linha += ''
            linha += formataString(y.get('esgcie_agosto') or 0, 10, ' ', 'E', 'N', 'S')+' '
            linha += ''
            linha += formataString(y.get('esgcie_setembro') or 0, 10, ' ', 'E', 'N', 'S')+' '
            linha += ''
            linha += formataString(y.get('esgcie_outubro') or 0, 10, ' ', 'E', 'N', 'S')+' '
            linha += ''
            linha += formataString(y.get('esgcie_novembro') or 0, 10, ' ', 'E', 'N', 'S')+' '
            linha += ''
            linha += formataString(y.get('esgcie_dezembro') or 0, 10, ' ', 'E', 'N', 'S')+' '
            linha += ''
            listagem.imprimeLinha('|' + linha + ' ' * 56 + '|')
        listagem.imprimeLinha('*--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.imprimeLinha('                                                                                     TOTAL GERAL(Custo * sugestao)    ---->           %s' % getNumeroEditado(total_geral, 2))
        listagem.imprimeLinha('*--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.imprimeLinha('                                                                                                                                     ** Sig Informatica LTDA **                 ')
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

report_custom('report.listagem_sugestao_compra')
