#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.tests.common import TransactionCase
from sigaddons.config_teste import set_config


class TestEstoqueMovimentoItens(TransactionCase):
    """
    Classe responsavel por testes unitarios dos metodos da classe estoque_movimento_itens
    :author: Tiago Henrique Prates dos Santos <tiago.santos[at]siginformatica.com.br>
    """

    @classmethod
    def setUpClass(cls):
        set_config()

    def setUp(self):
        super(TestEstoqueMovimentoItens, self).setUp()
        self.estoque_movimento_itens = self.registry('estoque.movimento.itens')
        self.estoque_local_locacao = self.registry('estoque.local.locacao')
        self.locacao_dados = self.get_locacao_dados()

    def test_create(self):
        vals = {'produto_id': self.locacao_dados.get('produto_id'),
                'grade_id': self.locacao_dados.get('grade_id'),
                'local_id': self.locacao_dados.get('local_id'),
                'produto_embalagem_id': self.locacao_dados.get('estllc_produto_embalagem_id'),
                'quantidade': self.locacao_dados.get('quantidade')
                }
        res = self.estoque_movimento_itens.create(self.cr, self.uid, vals)
        self.assertEqual(type(res), long)

    def get_locacao_dados(self):
        locacao_ids = self.estoque_local_locacao.search(self.cr, self.uid, [], limit=1)
        locacao_dados = self.estoque_local_locacao.read(self.cr, self.uid, locacao_ids[0],
                                                        ['produto_id', 'grade_id', 'local_id',
                                                         'estllc_produto_embalagem_id'],
                                                        load='_classic_write')
        locacao_dados.update({'quantidade': 5.0})
        return locacao_dados
