# -*- encoding: utf-8 -*-


from openerp.tests.common import TransactionCase
from sigaddons.config_teste import set_config


class TestEstoqueProdutoGrade(TransactionCase):
    """
    Classe responsavel por testes unitarios dos metodos da classe estoque_produto_grade
    :author: Tiago Henrique Prates dos Santos <tiago.santos[at]siginformatica.com.br>
    """

    @classmethod
    def setUpClass(cls):
        set_config()

    def setUp(self):
        super(TestEstoqueProdutoGrade, self).setUp()
        self.estoque_produto_grade = self.registry('estoque.produto.grade')
        self.quantidade_inativa = self.get_quantidade_grade_inativa()

    def test_search(self):
        res = self.estoque_produto_grade.search(self.cr, self.uid, [],
                                                context={'active_test': False})
        self.assertEqual(len(res), self.quantidade_inativa)

    def get_quantidade_grade_inativa(self):
        sql = """
            SELECT
                count(id) AS quantidade
            FROM
                estoque_produto_grade
        """
        self.cr.execute(sql)
        return self.cr.dictfetchone().get('quantidade')
