# -*- coding: utf-8 -*-

from openerp.tests.common import TransactionCase
from sigaddons.config_teste import set_config
from datetime import date


class TestEstoqueProduto(TransactionCase):
    """
    Classe responsavel por testes unitarios dos metodos da classe estoque_produto
    :author: Tiago Henrique Prates dos Santos <tiago.santos[at]siginformatica.com.br>
    """

    @classmethod
    def setUpClass(cls):
        set_config()

    def setUp(self):
        super(TestEstoqueProduto, self).setUp()
        self.obj_estoque_produto = self.registry('estoque.produto')
        self.vals = {'name': 'Teste produto', 'tipo_item': '00'}
        self.produto_ids = self.obj_estoque_produto.search(self.cr, self.uid, [], limit=1)
        self.grade_ids = map(lambda i: i.id, self.obj_estoque_produto.browse(
            self.cr, self.uid, self.produto_ids[0], {}).produto_grade_ids)
        self.saldo = self._get_saldo_grade_ids()

    def _get_saldo_grade_ids(self):
        saldos = self.registry('estoque.produto.saldo').get_saldo_do_dia(
            self.cr, self.uid, self.grade_ids, date.today(), context={})
        return sum(map(lambda i: saldos.get(i).get('saldo'), saldos))

    def test_create(self):
        res = self.obj_estoque_produto.create(self.cr, self.uid, self.vals, {})
        self.assertTrue(res)

    def test_write(self):
        res = self.obj_estoque_produto.write(self.cr, self.uid, self.produto_ids, self.vals, {})
        self.assertTrue(res)

    def test_estpro_get_saldo(self):
        res = self.obj_estoque_produto.estpro_get_saldo(self.cr, self.uid, self.produto_ids)
        self.assertEqual(res.get(self.produto_ids[0]), self.saldo)

    def test_copy(self):
        res = self.obj_estoque_produto.copy(self.cr, self.uid, self.produto_ids[0])
        self.assertEqual(long, type(res))
