#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.tests.common import TransactionCase
from config_teste import set_config
from random import randint
from datetime import date
import calendar


# noinspection PyUnresolvedReferences
class TestWizardInventarioContagem(TransactionCase):
    @classmethod
    def setUpClass(cls):
        set_config()

    def setUp(self):
        super(TestWizardInventarioContagem, self).setUp()
        self.invcap = self.registry('estoque.inventario.capa')
        self.invcont = self.registry('estoque.inventario.contagem')
        self.wizgerarcontagem = self.registry('estoque.gerar.contagem.osv')
        descricao = 'teste' + str(randint(1, 1000))
        ano = str(date.today().year)
        mes = str(date.today().month).zfill(2)
        vals_inventario = dict(name=descricao, descricao=descricao,
                               local=self.get_local_id('LOJA')[0], mes=mes, ano=ano, company_id=1)
        self.wizcontagem_id = self.wizgerarcontagem.create(self.cr, self.uid, vals_inventario,
                                                           context={})
        self.brw_wiz_contagem = self.wizgerarcontagem.browse(self.cr, self.uid, self.wizcontagem_id)

    def test_gerar_inventario(self):
        self.assertTrue(
            self.wizgerarcontagem.gerar_inventario(self.cr, self.uid, [self.wizcontagem_id]))

    def test_gerar_inventario_capa(self):
        self.assertTrue(
            self.wizgerarcontagem._gerar_inventario_capa(self.cr, self.uid, self.wizcontagem_id))

    def test_gerar_inventario_capa_company_id(self):
        company_inventario_id = self.registry('adm.empresa.objeto').getEmpresa(
            self.cr, self.uid, 'estoque.inventario.capa')
        inventario_id = self.wizgerarcontagem._gerar_inventario_capa(self.cr, self.uid,
                                                                     self.wizcontagem_id)
        self.assertEqual(self.invcap.browse(self.cr, self.uid, inventario_id).company_id.id,
                         company_inventario_id)

    def get_local_id(self, nome_local):
        return self.registry('estoque.local').search(self.cr, self.uid, [('name', '=', nome_local)])