#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.tests.common import TransactionCase
from sigaddons.config_teste import set_config


class TestWizardListagemMovimentoAnalitico(TransactionCase):
    """
    Classe responsavel por testes unitarios dos metodos da classe
    wizard_listagem_movimento_analitico
    :author: Tiago Henrique Prates dos Santos <tiago.santos[at]siginformatica.com.br>
    """

    @classmethod
    def setUpClass(cls):
        set_config()

    def setUp(self):
        super(TestWizardListagemMovimentoAnalitico, self).setUp()
        self.estoque_movimento_capa = self.registry('estoque.movimento.capa')
        self.wizard_listagem_movimento_analitico = self.registry(
            'wizard.listagem.movimento.analitico.osv')
        self.movimento_capa_dados = self.get_movimento_capa_dados()
        self.listagem_movimento_analitico_id = self.cria_wizard_listagem_movimento_analitico()

    def get_movimento_capa_dados(self):
        movimento_capa_id = self.estoque_movimento_capa.search(
            self.cr, self.uid, [('state', '=', 'F')], limit=1, order='id')[0]
        brw_movimento_capa = self.estoque_movimento_capa.browse(self.cr, self.uid,
                                                                movimento_capa_id)
        return {'data': brw_movimento_capa.data,
                'numero_documento': brw_movimento_capa.numero_documento}

    def cria_wizard_listagem_movimento_analitico(self):
        vals = {'periodo_inicial': self.movimento_capa_dados.get('data'),
                'periodo_final': self.movimento_capa_dados.get('data'),
                'documento': self.movimento_capa_dados.get('numero_documento')}
        return self.wizard_listagem_movimento_analitico.create(self.cr, self.uid, vals)

    def test_button_print(self):
        res = self.wizard_listagem_movimento_analitico.button_print(
            self.cr, self.uid, [self.listagem_movimento_analitico_id])
        self.assertEqual(type(res), dict)
