# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################


# Funcoes da classe wizard_estoque_consulta_movimento_itens
def get_movimento_item_tributacao(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    obj_fiscal_nf_item_tributacao = self.pool.get('fiscal.nf.item.tributacao')
    res = {}
    tributacao_ids = []
    list_tributacao = []
    browse_consulta_movimento_itens = self.browse(cr, uid, ids)
    for x in browse_consulta_movimento_itens:
        movimento_id = x.movimento_id.id
        if obj_fiscal_nf_item_tributacao and movimento_id:
            tributacao_ids = obj_fiscal_nf_item_tributacao.search(cr, uid, [('movimento_itens_id', '=', movimento_id)],
                                                                  context=context)
        if tributacao_ids:
            browse_tributacao = obj_fiscal_nf_item_tributacao.browse(cr, uid, tributacao_ids)
            for tributacao in browse_tributacao:
                cst = tributacao.cst_id
                desc_cst = '%s - %s' % (cst.codigo, cst.name)
                vals_tributacao = {
                    'consulta_movimento_item_id': x.id,
                    'encargo': tributacao.encargo_id.name,
                    'cst': desc_cst,
                    'tributacao': tributacao.tributacao_id.name,
                    'aliquota': tributacao.aliquota or 0.0,
                    'vr_base_calculo': tributacao.vr_base_calculo or 0.0,
                    'vr_encargo': tributacao.vr_encargo or 0.0,
                }
                tributacao_id = self.pool.get('wizard.estoque.consulta.movimento.tributacao').create(cr, uid,
                                                                                                     vals_tributacao,
                                                                                                     context
                                                                                                     )
                list_tributacao.append(tributacao_id)
        res[x.id] = list_tributacao
    return res


def get_sigla_embalagem(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    browse_consulta_movimento_itens = self.browse(cr, uid, ids, context=context)
    for item in browse_consulta_movimento_itens:
        sigla = ''
        produto_embalagem_id = item.produto_embalagem_id
        if produto_embalagem_id:
            embalagem_id = produto_embalagem_id.embalagem_id
            if embalagem_id:
                sigla = embalagem_id.sigla or ''
        res[item.id] = sigla
    return res


def get_numero_local(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    browse_consulta_movimento_itens = self.browse(cr, uid, ids, context=context)
    for item in browse_consulta_movimento_itens:
        numero = None
        local_id = item.local_id
        if local_id:
            numero = local_id.numero or None
        res[item.id] = numero
    return res


def get_name_origem(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    for item in self.browse(cr, uid, ids, context=context):
            codigo = item.movimento_id.capa_id.estmvc_operacao_id.estnto_movimento_origem_id.\
                estmog_codigo
            name = item.movimento_id.capa_id.estmvc_operacao_id.estnto_movimento_origem_id. \
                name
            if all([codigo, name]):
                res[item.id] = codigo + '-' + name
    return res


# Funcoes da classe digitacao_inventario_osv


def get_state_capa(self, cr, uid, ids, field_name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for digitacao in self.browse(cr, uid, ids, context):
        res[digitacao.id] = digitacao.digitacao_inventario_id.state_id.state
    return res
