# -*- encoding: utf-8 -*-
from operator import itemgetter

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _
from calendar import isleap
from dateutil.parser import parse
from dateutil.relativedelta import relativedelta


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def trata_data(self, cr, uid, ids, mes, ano, context=None):
        context = context and context.copy() or {}
        primeiro_dia = str(ano + '-' + mes + '-' + '01')
        if mes == '01' or mes == '03' or mes == '05' or mes == '07' or mes == '08' or mes == '10' or mes == '12':
            ultimo_dia = '31'
        elif mes != '02':
            ultimo_dia = '30'
        else:
            ultimo_dia = '29' if isleap(int(ano)) else '28'
        ultimo_dia = str(ano + '-' + mes + '-' + ultimo_dia)
        return {'primeiro_dia': primeiro_dia, 'ultimo_dia': ultimo_dia}

    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        def center_title(E, C, D, T=190):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        title = center_title('', _('Balanco Financeiro'), '', 174)
        # passa uma lista com os as contas(categoria) pais e outra com os possiveis filhos, e retorna um dicionario
        # onde as chaves sao os pais e os valores sao os filhos com seus respectivos filhos se houver e assim pode diante
        def mapa_categoria(pais, filhos):
            if not pais:
                return {'itens':{}}
            categoria = {}
            categoria['itens'] = {}
            for pai in pais:
                _filhos_especificos = list(set(map(lambda x: x if pai == x[:len(pai)] and x.count('.') == pai.count('.')+1
                                                               else '0', filhos)))
                _netos = list(set(map(lambda x: x if pai == x[:len(pai)] and x.count('.') > pai.count('.')+1
                                                               else '0', filhos)))
                _filhos_especificos.sort()
                _netos.sort()
                # tirar o zero(0) das listas de _filhos e _netos
                if _filhos_especificos and _filhos_especificos[0] == '0':
                    _filhos_especificos= _filhos_especificos[1:]
                if _netos and _netos[0]=='0':
                    _netos=_netos[1:]
                categoria['itens'][pai] = mapa_categoria(_filhos_especificos, _netos)
            return categoria

        # recebe a conta(categoria) e a arvore de categorias, popula a arvores com os valores torais e custos por categoria
        def get_totais_custos(conta, categoria, custo, total_produto):
            if not categoria or not categoria.get('itens'):
                return {}
            if not conta: # produtos sem categoria
                if not categoria.get('itens').get('99999'):
                    categoria['itens'][u'99999'] = {}
                if not categoria['itens']['99999'].get('custo'):
                    categoria['itens'][u'99999']['custo'] = custo
                else:
                    categoria['itens'][u'99999']['custo'] += custo
                if not categoria['itens']['99999'].get('total'):
                    categoria['itens'][u'99999']['total'] = total_produto
                else:
                    categoria['itens'][u'99999']['total'] += total_produto
                return categoria
            aux = categoria.get('itens')
            for cat in aux:
                if cat == conta:
                    if not aux.get(cat).get('custo'):
                        categoria['itens'][cat]['custo'] = custo
                    else:
                        categoria['itens'][cat]['custo'] = aux.get(cat).get('custo') + custo
                    if not aux.get(cat).get('total'):
                        categoria['itens'][cat]['total'] = total_produto
                    else:
                        categoria['itens'][cat]['total'] = aux.get(cat).get('total') + total_produto
                    return categoria
                if len(cat) <= len(conta) and cat == conta[:len(cat)]:
                    categoria['itens'][cat] = get_totais_custos(conta, categoria.get('itens').get(cat), custo, total_produto)
                    if not categoria.get('itens').get(cat).get('custo'):
                        categoria['itens'][cat]['custo'] = custo
                    else:
                        categoria['itens'][cat]['custo'] += custo
                    if not categoria.get('itens').get(cat).get('total'):
                        categoria['itens'][cat]['total'] = total_produto
                    else:
                        categoria['itens'][cat]['total'] += total_produto
                    break
            return categoria

        # passa a conta(categoria) e a arvore de categoria e retorna o galho da arvore referente a conta
        def get_categoria(conta, categoria):
            for cat in categoria.get('itens'):
                if cat == conta:
                    return categoria.get('itens').get(cat)
                elif len(cat) <= len(conta) and cat == conta[:len(cat)]:
                    return get_categoria(conta, categoria.get('itens').get(cat))


        mes = datas.get('mes')
        ano = datas.get('ano')
        ordem = datas.get('ordem')
        fabricante_id = datas.get('fabricante_id')
        fornecedor_id = datas.get('fornecedor_id')
        listar_itens = datas.get('listar_itens')
        sql_filtro_categoria = ''
        if datas.get('categoria_id'):
            filtro_categoria_ids = pooler.get_pool(cr.dbname).get('estoque.categoria').search(
                cr, uid, [('parent_id', 'child_of', datas.get('categoria_id'))])
            if len(filtro_categoria_ids) == 1:
                filtro_categoria = str(tuple(filtro_categoria_ids)).replace(',', '')
            else:
                filtro_categoria = str(tuple(filtro_categoria_ids))
            sql_filtro_categoria = """
                AND ep.categoria_id IN %s
            """ % filtro_categoria

        if datas.get('preco') == 'PV':
            descricao_custo = formataString('Preco Venda', 13, ' ', 'E', 'S', 'S')
        elif datas.get('preco') == 'CC':
            descricao_custo = formataString('C.Corrigido', 13, ' ', 'E', 'S', 'S')
        elif datas.get('preco') == 'CM':
            descricao_custo = formataString('Med.Contabil', 13, ' ', 'E', 'S', 'S')
        elif datas.get('preco') == 'UC':
            descricao_custo = formataString('Ultimo Custo', 13, ' ', 'E', 'S', 'S')
        elif datas.get('preco') == 'CR':
            descricao_custo = formataString('C.Reposicao', 13, ' ', 'E', 'S', 'S')
        else:
            descricao_custo = formataString('', 13, ' ', 'E', 'S', 'S')

        dias = self.trata_data(cr, uid, ids, mes, ano)

        primeiro_dia = dias.get('primeiro_dia')
        ultimo_dia = dias.get('ultimo_dia')

        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='1')
        listagem.informaTamLinha(100)
        listagem.defineFonte(tam=8.05)
        listagem.defineMargem(0.5,0.5,0.5,0.5)
        listagem.informaNome(pdf_string, _('Balanco Financeiro'))

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                                                     'wizard.balanco.financeiro.osv', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, 'Pagina: {{ Page }} ',178)

        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab('  ')
        listagem.informaCab(_('Mes/Ano: ') + mes + '/' + ano)
        listagem.informaCab('  ')

        estpar_dados = pooler.get_pool(cr.dbname).get('estoque.parametro').estpar_get_fields(
            cr, uid, fields_to_read=['estpar_tamanho_codigo'], context=context
        )
        if isinstance(estpar_dados, list):
            estpar_dados = estpar_dados[0]

        tamanho_codigo_produto = estpar_dados['estpar_tamanho_codigo']

        listagem.rodapePadrao()
        cabecalho1 = '*'
        cabecalho1 += formataString('-', tamanho_codigo_produto + 2, '-', 'D', 'S', 'S')
        cabecalho1 += ('-' * 156 + '*')
        listagem.informaCab(cabecalho1)
        cabecalho2 = '|'
        cabecalho2 += formataString(_('Produto'), tamanho_codigo_produto + 2, ' ', 'D', 'S', 'S')
        cabecalho2 += 'D Grade Produto                                              Embal. UND   '\
                      'Saldo Anterior   Qtd Entrada   Qtd Saida     Saldo Final %s       '\
                      'Total|' % descricao_custo
        listagem.informaCab(cabecalho2)
        cabecalho3 = '*'
        cabecalho3 += formataString('-', tamanho_codigo_produto + 2, '-', 'D', 'S', 'S')
        cabecalho3 += ('-' * 156 + '*')
        listagem.informaCab(cabecalho3)
        cabecalho4 = '|'
        cabecalho4 += formataString(' ', tamanho_codigo_produto + 2, ' ', 'D', 'S', 'S')
        cabecalho4 += (' ' * 156 + '|')
        listagem.informaCab(cabecalho4)

        obj_estoque_preco_custo = pooler.get_pool(cr.dbname).get('estoque.preco.custo')
        obj_estoque_produto_saldo = pooler.get_pool(cr.dbname).get('estoque.produto.saldo')
        obj_estoque_preco_venda = pooler.get_pool(cr.dbname).get('estoque.preco.venda')
        order_by = 'ep.name, epg.grade'
        if ordem == '02':
            order_by = 'ep.codigo, epg.grade'
        elif ordem == '03':
            order_by = 'ec.conta, ep.codigo, epg.grade'
        ecf_instalado = pooler.get_pool(cr.dbname).get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'ecf', context)
        inner_join_cupons_capa = ''' '''
        and_cupom = ''' '''
        case_when = ''' '''
        if ecf_instalado:
            inner_join_cupons_capa = '''
                    LEFT  JOIN ecf_cupons_capa           AS ecc ON ecc.id = emi.cupom_id
                                     '''
            and_cupom = '''
                   AND not (emi.item_cancelado is True AND  ecc.tipo_cupom = 'V')
                        '''
            case_when = '''
                WHEN eno.estnto_tipo_operacao = 'S' and ecc.tipo_cupom = 'C' THEN -emi.quantidade 
            '''

        company_ids = pooler.get_pool(cr.dbname).get('res.company').search(
            cr, uid, [('parent_id', 'child_of', company_id)], context=context)

        # Empresas para classes correlacionaveis
        obj_adm_empresa = pooler.get_pool(cr.dbname).get('adm.empresa.objeto')

        locacao_company_ids = company_ids if len(company_ids) > 1 else \
            [obj_adm_empresa.getEmpresa(cr, uid, 'estoque.local.locacao', context=context)]
        str_locacao_company_ids = ', '.join(map(lambda c: str(c), locacao_company_ids))

        movimento_capa_company_ids = company_ids if len(company_ids) > 1 else \
            [obj_adm_empresa.getEmpresa(cr, uid, 'estoque.movimento.capa', context=context)]
        str_movimento_capa_company_ids = ', '.join(map(lambda c: str(c),
                                                       movimento_capa_company_ids))

        produto_company_ids = company_ids if len(company_ids) > 1 else \
            [obj_adm_empresa.getEmpresa(cr, uid, 'estoque.produto', context=context)]
        str_produto_company_ids = ', '.join(map(lambda c: str(c), produto_company_ids))

        # Movimento dos produtos
        sql = """
                SELECT emi.produto_id             AS produto_id,
                       epg.id                     AS grade_id,
                       ep.codigo                  AS codigo,
                       ep.digito                  AS digito,
                       epg.grade                  AS grade,
                       ep.name                    AS nome,
                       ec.conta                   AS conta,
		               (select ee.quantidade_na_embalagem
                        from estoque_embalagem as ee, estoque_produto_embalagem as epe
                        where ee.id = epe.embalagem_id
                          and epe.produto_id = emi.produto_id
                         order by ee.quantidade_na_embalagem
                         limit 1) as qtd_embalagem,
                       (select ee.sigla
                        from estoque_embalagem as ee, estoque_produto_embalagem as epe
                        where ee.id = epe.embalagem_id
                          and epe.produto_id = emi.produto_id
                        order by ee.quantidade_na_embalagem
                        limit 1) as sigla_emb,
                       sum(CASE WHEN eno.estnto_tipo_operacao = 'E'
                                THEN emi.quantidade
                                ELSE 0
                           END) AS qtd_entrada,
                       sum(CASE %s
                                WHEN eno.estnto_tipo_operacao = 'S'
                                THEN emi.quantidade
                                ELSE 0
                           END) AS qtd_saida
                FROM           estoque_movimento_itens   AS emi
                    INNER JOIN estoque_movimento_capa    AS emc ON emc.id = emi.capa_id
                    INNER JOIN estoque_produto           AS ep  ON ep.id  = emi.produto_id
                    INNER JOIN estoque_produto_grade     AS epg ON epg.id = emi.grade_id
                    INNER JOIN estoque_natureza_operacao AS eno ON eno.id = emc.estmvc_operacao_id
                    INNER JOIN estoque_local_locacao     AS ell ON emi.local_id = ell.local_id 
                        AND epg.id = ell.grade_id AND ep.id = ell.produto_id
                    LEFT  JOIN estoque_categoria         AS ec  ON ec.id  = ep.categoria_id
                    %s
                WHERE  emc.data >= '%s'
                   AND emc.data <= '%s'
                   AND emc.company_id IN (%s)
                   AND ell.company_id IN (%s)
                   %s
                   %s
                       """ % (case_when, inner_join_cupons_capa, primeiro_dia, ultimo_dia,
                              str_movimento_capa_company_ids, str_locacao_company_ids,
                              and_cupom, sql_filtro_categoria)

        if datas.get('local_id'):
            sql += """
                   AND emi.local_id = %s
                   """ % datas.get('local_id')
        sql += """
                   AND emc.state = 'F'
                GROUP BY emi.produto_id, epg.grade, ep.codigo, ep.digito, ep.name, epg.id, ec.conta
                ORDER BY %s
              """ % (order_by)
        cr.execute(sql)
        dados_sql = cr.dictfetchall()
        sub_quere = '''
                        (select sell.id
                         from estoque_local_locacao as sell
                         inner join estoque_produto_embalagem as sepe on sepe.id = sell.estllc_produto_embalagem_id
                         inner join estoque_embalagem as see on see.id = sepe.embalagem_id
                         where sell.grade_id = epg.id
                         order by see.quantidade_na_embalagem
                         limit 1) as est_loc_loc_id,
                    ''' if not datas.get('local_id') else ''
        condicao_sub_quere = """
            ell.company_id IN (%s) AND epe.id = ell.estllc_produto_embalagem_id
        """ % str_locacao_company_ids if datas.get('local_id') else 'epe.produto_id = ep.id'
        inner_join = 'INNER JOIN estoque_local_locacao AS ell ON ell.grade_id = epg.id' if datas.get('local_id') else ''
        condicao = '''
            AND ell.grade_id = epg.id
            AND ell.local_id = %s
            AND ell.company_id IN (%s)''' % (datas.get('local_id'), str_locacao_company_ids) \
            if datas.get('local_id') else ''
        if fabricante_id:
            condicao += """
                   AND ep.fabricante_id = %s
            """ % fabricante_id
        if fornecedor_id:
            condicao += """
                   AND ep.id IN (SELECT produto_id FROM estoque_fornecedor WHERE fornecedor_id = %s)
            """ % fornecedor_id
        # Todos os podutos ativos do estoque
        sql_produtos = '''
                            SELECT ep.id     AS produto_id,
                                   ep.codigo AS codigo,
                                   ep.digito AS digito,
                                   ep.name   AS nome,
                                   epg.id    AS grade_id,
                                   epg.grade AS grade,
                                   ec.conta  AS conta,
                                   %s
                                   (select ee.quantidade_na_embalagem
                                    from estoque_embalagem AS ee, estoque_produto_embalagem AS epe
                                    where ee.id = epe.embalagem_id
                                      and %s
                                    order by ee.quantidade_na_embalagem
                                    limit 1) AS qtd_embalagem,
                                   (select ee.sigla
                                    from estoque_embalagem AS ee, estoque_produto_embalagem AS epe
                                    where ee.id = epe.embalagem_id
                                      and %s
                                    order by ee.quantidade_na_embalagem
                                    limit 1) AS sigla_emb,
                                    0 AS qtd_entrada,
                                    0 AS qtd_saida
                            FROM estoque_produto AS ep
                            INNER JOIN estoque_produto_grade AS epg ON epg.produto_id = ep.id
                            LEFT JOIN estoque_categoria          AS ec  ON ec.id = ep.categoria_id
                            %s
                            WHERE 
                            ep.active = True
                            AND ep.company_id IN (%s)
                            %s
                            %s
                            ORDER BY %s
                        ''' % (sub_quere, condicao_sub_quere,condicao_sub_quere,inner_join,
                               str_produto_company_ids, condicao, sql_filtro_categoria, order_by)
        cr.execute(sql_produtos)
        dados_todos_produtos = cr.dictfetchall()
        produto_id_list = map(lambda i: i.get('produto_id'), dados_todos_produtos)
        grade_id_list = map(lambda i: i.get('grade_id'), dados_todos_produtos)
        dict_prod_movimentados = {}
        for j in dados_sql:
            dict_prod_movimentados[j.get('grade_id')] = j

        local_id = datas.get('local_id') or False
        total_geral = 0.0
        if dados_todos_produtos:
            saldo_i = obj_estoque_produto_saldo.get_saldo_do_dia(
                cr, uid, grade_id_list, (parse(primeiro_dia) - relativedelta(days=1)).strftime(
                    '%Y-%m-%d'), local_id, context=context)
            saldo_f = obj_estoque_produto_saldo.get_saldo_do_dia(
                cr, uid, grade_id_list, ultimo_dia, local_id, context=context)
            inicial_dict_saldo = {}
            final_dict_saldo = {}
            for _grade_id in saldo_i.keys():
                inicial_dict_saldo[_grade_id] = saldo_i.get(_grade_id).get('saldo')
            for _grade_id in saldo_f.keys():
                final_dict_saldo[_grade_id] = saldo_f.get(_grade_id).get('saldo')
            ultimo_dia_mes = ultimo_dia + ' 23:59:59'

            custos = {}
            if datas.get('preco') == 'PV':
                precos_venda = obj_estoque_preco_venda.get_preco_venda(
                    cr, uid, epc_produto_ids=produto_id_list, epc_grade_ids=grade_id_list,
                    context=context)
            elif datas.get('preco'):
                custos = obj_estoque_preco_custo.get_custos_do_dia(cr, uid, produto_id_list, None,
                                                                   ultimo_dia_mes)

            if ordem == '03':
                sql_categoria = '''
                                        SELECT conta
                                        FROM estoque_categoria
                                        ORDER BY conta
                                   '''
                cr.execute(sql_categoria)
                dados_categoria = cr.dictfetchall()
                categoria = list(set(map(lambda x: x.get('conta') ,dados_categoria)))
                categoria.sort()
                if categoria and categoria[0] == '0':
                    categoria = categoria[1:]
                tam_pai = len(categoria[0])
                pais = list(set(map(lambda x: x if len(x) == tam_pai else '0', categoria)))
                pais.sort()
                filhos = list(set(map(lambda x: x if len(x) != tam_pai else '0', categoria)))
                filhos.sort()
                if pais and pais[0] == '0':
                    pais=pais[1:]
                if filhos and filhos[0] == '0':
                    filhos=filhos[1:]
                categoria = mapa_categoria(pais, filhos)
                for i in dados_todos_produtos:
                    produto_id = i.get('produto_id')
                    grade_id = i.get('grade_id')
                    saldo_final = float(final_dict_saldo.get(grade_id) or 0.0)
                    custo = custos.get(produto_id)
                    if not custo:
                        custo = {}
                    if datas.get('preco') == 'CC':
                        custo = custo.get('estprc_custo_corrigido', 0.0)
                    elif datas.get('preco') == 'CM':
                        custo = custo.get('estprc_custo_medio_contabil', 0.0)
                    elif datas.get('preco') == 'UC':
                        custo = custo.get('estprc_ultimo_custo', 0.0)
                    elif datas.get('preco') == 'CR':
                        custo = custo.get('estprc_custo_reposicao', 0.0)
                    elif datas.get('preco') == 'PV':
                        preco_venda = precos_venda.get(produto_id)
                        custo = preco_venda.get(grade_id) or preco_venda.get('preco_venda')
                    custo = round(custo,2)
                    total_produto = saldo_final * custo
                    conta = i.get('conta')
                    categoria = get_totais_custos(conta, categoria, custo, total_produto)
            categoria_impressa = {}
            for i in dados_todos_produtos:
                qtd_entrada = 0.0
                qtd_saida = 0.0
                produto_id = i.get('produto_id')
                grade_id = i.get('grade_id')
                if grade_id in dict_prod_movimentados:
                    qtd_entrada = float(dict_prod_movimentados.get(grade_id).get('qtd_entrada', 0.0))
                    qtd_saida = float(dict_prod_movimentados.get(grade_id).get('qtd_saida', 0.0))
                saldo_final = float(final_dict_saldo.get(grade_id) or 0.0)

                saldo_inicial = float(inicial_dict_saldo.get(grade_id) or 0.0)

                if not any([saldo_inicial, qtd_entrada, qtd_saida, saldo_final]):
                    continue

                if listar_itens == '2' and saldo_final <= 0:
                    continue
                if listar_itens == '3' and saldo_final:
                    continue
                if listar_itens == '4' and saldo_final >= 0:
                    continue

                custo = custos.get(produto_id)
                if not custo:
                    custo = {}

                if datas.get('preco') == 'CC':
                    custo = custo.get('estprc_custo_corrigido', 0.0)
                elif datas.get('preco') == 'CM':
                    custo = custo.get('estprc_custo_medio_contabil', 0.0)
                elif datas.get('preco') == 'UC':
                    custo = custo.get('estprc_ultimo_custo', 0.0)
                elif datas.get('preco') == 'CR':
                    custo = custo.get('estprc_custo_reposicao', 0.0)
                elif datas.get('preco') == 'PV':
                        preco_venda = precos_venda.get(produto_id)
                        custo = preco_venda.get(grade_id) or preco_venda.get('preco_venda')
                custo = round(custo,2)
                total = saldo_final * custo
                qtd_embalagem = i.get('qtd_embalagem') or 1.0
                sigla_embalagem = i.get('sigla_emb') or ''
                conta = i.get('conta')
                if ordem == '03':   # imprime o nome da categoria se a ordem for por categoria
                    if not categoria_impressa.get(conta):
                        sql_cat_id = '''
                                        SELECT id
                                        FROM estoque_categoria
                                        WHERE conta = '%s'
                                     ''' % (conta)
                        cr.execute(sql_cat_id)
                        categoria_id = cr.dictfetchall()
                        if categoria_id and isinstance(categoria_id, list):
                            categoria_id = categoria_id[0]
                        if categoria_id and isinstance(categoria_id, dict):
                            categoria_id = categoria_id.get('id')
                        if not conta:
                            nome_categoria = 'Sem categoria'
                            categoria_da_conta = get_categoria('99999', categoria)
                        else:
                            nome_categoria = pooler.get_pool(cr.dbname).get('estoque.categoria').browse(cr, uid, categoria_id).nome_completo
                            categoria_da_conta = get_categoria(conta, categoria)
                        descricao_categoria = formataString(nome_categoria, 166, ' ', 'C', 'S', 'S')[:136]
                        linha = '|' + descricao_categoria
                        total_categ = categoria_da_conta.get('total')
                        linha += formataString(getNumeroEditado(total_categ), 30, ' ', 'E', 'S', 'S')
                        linha += '|'
                        listagem.imprimeLinha(linha)
                        listagem.imprimeLinha('--') # linha continua
                        categoria_impressa[conta] = True
                linha = '|'
                linha += formataString(i.get('codigo'), tamanho_codigo_produto + 2, ' ', 'D', 'S', 'S')
                linha += formataString(i.get('digito'), 1, ' ', 'E', 'S', 'S')
                linha += formataString(i.get('grade'), 7, ' ', 'C', 'S', 'S')
                linha += formataString(i.get('nome'), 53, ' ', 'D', 'S', 'S')
                linha += formataString(qtd_embalagem , 5, ' ', 'E', 'S', 'S')
                linha += formataString(sigla_embalagem, 7, ' ', 'C', 'S', 'S')
                linha += formataString(getNumeroEditado(saldo_inicial/qtd_embalagem), 13, ' ', 'E', 'S', 'S')
                linha += formataString(getNumeroEditado(qtd_entrada/qtd_embalagem), 14, ' ', 'E', 'S', 'S')
                linha += formataString(getNumeroEditado(qtd_saida/qtd_embalagem), 12, ' ', 'E', 'S', 'S')
                linha += formataString(getNumeroEditado(saldo_final/qtd_embalagem), 16, ' ', 'E', 'S', 'S')
                linha += formataString(getNumeroEditado(custo*qtd_embalagem), 13, ' ', 'E', 'S', 'S')
                linha += formataString(getNumeroEditado(total), 15, ' ', 'E', 'S', 'S')
                linha += '|'
                total_geral += total
                listagem.imprimeLinha(linha)
                # imprimi linha continua ao passar pela categoria e linha pontilhada quando passa pelo produto
                if i != dados_todos_produtos[-1]: # verifica se o item nao eh o ultimo
                    indice = dados_todos_produtos.index(i)+1
                    proximo_item = dados_todos_produtos[indice]
                    proxima_conta = proximo_item.get('conta')
                    if categoria_impressa.get(proxima_conta):
                        listagem.imprimeLinha('*----------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
                else:
                    listagem.imprimeLinha('*----------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        posicao = 1 + (tamanho_codigo_produto + 2) + 1+7+53+5+7+13+14+10+14
        linha = formataString(' ', posicao)
        linha += formataString('Total geral', 15)
        linha += formataString(getNumeroEditado(total_geral), 17, ' ', 'E')
        print total_geral
        listagem.imprimeLinha(linha)
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.balanco_financeiro')


class wizard_balanco_financeiro_osv(osv.TransientModel):
    _name = 'wizard.balanco.financeiro.osv'
    _columns = {
        'local_id': fields.many2one('estoque.local', 'Local'),
        'mes': fields.selection([
                                    ('01', 'Janeiro'), ('02', 'Fevereiro'), ('03', 'Marco'),
                                    ('04', 'Abril'), ('05', 'Maio'), ('06', 'Junho'),
                                    ('07', 'Julho'), ('08', 'Agosto'), ('09', 'Setembro'),
                                    ('10', 'Outubro'), ('11', 'Novembro'), ('12', 'Dezembro')],
                                'Mes', required=True),
        'ano': fields.char('Ano', size=4, required=True),
        'preco': fields.selection([('CC', 'Custo Corrigido'), ('CM', 'Custo Medio Contabil'),
                                   ('UC', 'Ultimo Custo'), ('CR', 'Custo Reposicao'),
                                   ('PV', 'Preco de Venda')], 'Preco', required=True, size=2),
        'ordem': fields.selection([
                                ('01', 'Alfabetica'), ('02', 'Codigo'), ('03', 'Categoria')],
                            'Ordem de listagem', required=True),
        'fabricante_id': fields.many2one('adm.pessoa', 'Fabricante'),
        'fornecedor_id': fields.many2one('financeiro.fornecedor', 'Fornecedor'),
        'categoria_id': fields.many2one('estoque.categoria', 'Categoria'),
        'listar_itens': fields.selection([('1', 'Todos'), ('2', 'Com saldo'), ('3', 'Sem saldo'),
                                          ('4', 'Negativo')], 'Listar itens', size=1),
    }
    _defaults = {
        'ordem': '01',
        'listar_itens': lambda *a: '1',
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        browse_balanco_financeiro = self.browse(cr, uid, ids)
        for x in browse_balanco_financeiro:
            local_id = x.local_id.id
            datas = {
                'local_id': local_id,
                'mes': x.mes,
                'ano': x.ano,
                'preco': x.preco,
                'ordem': x.ordem,
                'fabricante_id': x.fabricante_id.id,
                'fornecedor_id': x.fornecedor_id.id,
                'categoria_id': x.categoria_id.id,
                'listar_itens': x.listar_itens
            }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'balanco_financeiro',
            'datas': datas,
        }

    def button_limpar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {
            'local_id': False,
            'mes': [],
            'ano': '',
            'preco': [],
            'ordem': [],
            'categoria_id': False,
        })
        return True

