# -*- encoding: utf-8 -*-

from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
import time
from datetime import date
from openerp.tools.translate import _


class estoque_estatisticas_mensal_osv(osv.TransientModel):
    def _getMes(self, cr, uid, mes):
        if mes == 1:
            mes = _('Janeiro')
        elif mes == 2:
            mes = _('Fevereiro')
        elif mes == 3:
            mes = _('Marco')
        elif mes == 4:
            mes = _('Abril')
        elif mes == 5:
            mes = _('Maio')
        elif mes == 6:
            mes = _('Junho')
        elif mes == 7:
            mes = _('Julho')
        elif mes == 8:
            mes = _('Agosto')
        elif mes == 9:
            mes = _('Setembro')
        elif mes == 10:
            mes = _('Outubro')
        elif mes == 11:
            mes = _('Novembro')
        elif mes == 12:
            mes = _('Dezembro')
        return mes

    _name = 'estoque.estatisticas.mensal.osv'
    _columns = {
        # Campos produto_id, local_id, grade_id nao podem ser required=True, senao o botao limpar (button_limpar)
        # ira gerar erro de integridade.
        'company_id': fields.many2one('res.company', 'Empresa', required=False),
        'local_id': fields.many2one('estoque.local', 'Local', required=False),
        'produto_id': fields.many2one('estoque.produto', 'Produto', required=False),
        'grade_id': fields.many2one('estoque.produto.grade', 'Grade', required=False),
        'estatistica_mensal_itens_ids': fields.one2many('estoque.estatisticas.mensal.itens.osv',
                                                        'estatistica_mensal_id', 'Itens'),
        'saldo_local': fields.float('Saldo local', digits=(10, 2)),
        'saldo_total': fields.float('Saldo total', digits=(10, 2)),
        'min': fields.float('Min.', digits=(10, 2)),
        'max': fields.float('Max.', digits=(10, 2)),
        'unidade': fields.char('Unidade', size=3),
        'qtd_embalagem': fields.float('Embalagem', digits=(6, 3)),
        'qtd_ultima_entrada': fields.float('Qtd. Ultima Entrada', digits=(16, 2)),
        'qtd_ultima_saida': fields.float('Qtd. Ultima Saida', digits=(16, 2)),
        'data_ultima_entrada': fields.date('Data Ultima Entrada'),
        'data_ultima_saida': fields.date('Data Ultima Saida'),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c)
    }

    def default_get(self, cr, uid, fields_list, context=None):
        context = context and context.copy() or {}
        res = super(estoque_estatisticas_mensal_osv, self).default_get(cr, uid, fields_list,
                                                                       context)
        if context.get('active_model') == 'estoque.produto.grade':
            if context.get('produto_id'):
                res['produto_id'] = context.get('produto_id')
            if context.get('active_id'):
                res['grade_id'] = context.get('active_id')
        return res

    def estesm_onchange_produto(self, cr, uid, ids, produto_id, context=None):
        context = context and context.copy() or {}
        res = {}
        if context.get('active_model') == 'estoque.produto.grade' and context.get('active_id'):
            return res
        if produto_id:
            grade_ids = self.pool.get('estoque.produto.grade').search(cr, uid, [('produto_id', '=', produto_id)],
                                                                      context=context)
            if len(grade_ids) == 1:
                grade_id = grade_ids[0]
                res['grade_id'] = grade_id
            else:
                res['grade_id'] = ''
        return {'value': res}

    def estesm_onchange_grade(self, cr, uid, ids, produto_id, grade_id, local_id, itens_ids, context=None):
        context = context and context.copy() or {}
        if grade_id:
            if not ids:
                ids = self.create(cr, uid, {'produto_id': produto_id, 'local_id': local_id,
                                            'grade_id': grade_id}, context)
            else:
                vals= {'produto_id': produto_id,
                       'grade_id':grade_id,
                       'local_id': local_id,
                       'estatistica_mensal_itens_ids': []}
                self.write(cr, uid, ids, vals, context)

            context['estesm_retorna_valores'] = True
            context['estatistica_mensal_itens_ids'] = itens_ids
            return {'value': self.estesm_funcao_pesquisar(cr, uid, ids, context=context)}

        return {}

    def button_limpar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]

        keep_m2o = context.get('wiz_keep_m2o')

        fields_float = ['saldo_local', 'saldo_total', 'min', 'max', 'unidade', 'qtd_embalagem',
                        'qtd_ultima_entrada', 'qtd_ultima_saida']
        fields_m2o = ['local_id', 'produto_id', 'grade_id']

        values = {}.fromkeys(fields_float, 0)
        # REMOVE A LISTAGEM DAS ESTATISTICAS
        cr.execute("""
            DELETE FROM estoque_estatisticas_mensal_itens_osv
            WHERE estatistica_mensal_id IN (%s)
            """ % ','.join(map(lambda x: '%s' % x, ids)))
        if not keep_m2o:
            values.update({}.fromkeys(fields_m2o, False))

        values.update({'data_ultima_entrada': False,
                       'data_ultima_saida': False,
                       'estatistica_mensal_itens_ids': []})
        res = self.write(cr, uid, ids, values, context)
        return res

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return self.estesm_funcao_pesquisar(cr, uid, ids, context)

    def estesm_funcao_pesquisar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if ids and isinstance(ids, (list, tuple)):
            ids = ids[0]

        dict_dia_semana = {0: 'Domingo', 1: 'Segunda-feira', 2: _('Terca-feira'), 3: 'Quarta-feira',
                           4: 'Quinta-feira', 5: 'Sexta-feira', 6: _('Sabado')}

        obj_estoque_local_locacao = self.pool.get('estoque.local.locacao')
        obj_estoque_produto_saldo = self.pool.get('estoque.produto.saldo')
        obj_est_mensal = self.pool.get('estoque.estatisticas.mensal.itens.osv')
        obj_estoque_produto_grade = self.pool.get('estoque.produto.grade')
        obj_estoque_utils = self.pool.get('estoque.utils')

        data = time.strftime('%Y-%m-%d')

        browse_estatisticas_mensal = self.browse(cr, uid, ids)
        record_company_id = browse_estatisticas_mensal.company_id
        company_id = record_company_id and record_company_id.id or False
        if not company_id:
            company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, context=context)

        qtd_embalagem = 0
        if not context.get('estatisticas_pedido_compra'):

            produto_id = browse_estatisticas_mensal.produto_id.id
            local_id = browse_estatisticas_mensal.local_id.id
            grade_id = browse_estatisticas_mensal.grade_id.id

            context.update({'wiz_keep_m2o': True})
            self.button_limpar(cr, uid, ids, context=context)

            saldo_local = obj_estoque_produto_saldo.get_saldo_do_dia(cr, uid, grade_id, data, local_id, context=context)
            saldo_local = saldo_local.get(grade_id).get('saldo')
            saldo_total = obj_estoque_produto_saldo.get_saldo_do_dia(cr, uid, grade_id, data, False, context=context)
            saldo_total = saldo_total.get(grade_id).get('saldo')

            args_locacao = [
                ('produto_id', '=', produto_id), ('grade_id', '=', grade_id), ('local_id', '=', local_id),
                ('company_id', '=', company_id)
            ]
            local_locacao_id = obj_estoque_local_locacao.search(cr, uid, args_locacao, context=context)
            unidade_descricao = ' '
            if local_locacao_id:
                for x in obj_estoque_local_locacao.browse(cr, uid, local_locacao_id):
                    produto_embalagem_id = x.estllc_produto_embalagem_id
                    if produto_embalagem_id:
                        embalagem_id = produto_embalagem_id.embalagem_id
                        if embalagem_id:
                            unidade_descricao = embalagem_id.unidade_id.unidade
                            qtd_embalagem = embalagem_id.quantidade_na_embalagem or 1
        else:
            local_id = context.get('local_id')
            produto_id = context.get('produto_id')
            grade_id = context.get('grade_id')
            ids = self.create(cr, uid, {'produto_id': produto_id, 'local_id': local_id,
                                        'grade_id': grade_id}, context)
            self.button_limpar(cr, uid, int(ids), context)

        estatistica_movimento_dado = obj_estoque_utils.estutl_get_estatistica_movimento(
            cr, uid, company_id, produto_id, grade_id, context)
        if not estatistica_movimento_dado:
            if context.get('estatisticas_pedido_compra'):
                return False
            else:
                raise osv.except_osv(
                    _('Atencao'), _('Com os filtros selecionados nao ha dados a serem impressos'))
        estatistica_movimento_dado = sorted(
            estatistica_movimento_dado, key=lambda i: i['data_movimento'], reverse=True)
        dict_dados = {}

        ultima_entrada = (0, False)
        ultima_saida = (0, False)
        for x in estatistica_movimento_dado:
            mes_estatistica = str(x.get('data_movimento'))
            data_mes_estatistica = mes_estatistica[5:7]
            dia = mes_estatistica[8:]
            if not ultima_entrada[0] or \
                (x.get('total_entrada') and x.get('data_movimento') > ultima_entrada[1]):
                ultima_entrada = (x.get('total_entrada'), x.get('data_movimento'))

            if not ultima_saida[0] or \
                (x.get('total_saida') and x.get('data_movimento') > ultima_saida[1]):
                ultima_saida = (x.get('total_saida'), x.get('data_movimento'))

            mes_estatistica = mes_estatistica[5:7]
            estatistica_ano = x.get('data_movimento')[0:4]
            data = '%s-%s' % (estatistica_ano, mes_estatistica)
            mes_ano = '%s/%s' % (mes_estatistica, estatistica_ano)
            if dict_dados.get(data):
                dict_dados[data]['total_mes_entrada'] += x.get('total_entrada') or 0.0
                dict_dados[data]['total_mes_saida'] += x.get('total_saida') or 0.0
            else:
                dict_dados[data] = {
                    'estatistica_mensal_id': ids,
                    'data_estatistica_entrada': mes_ano,
                    'data_estatistica_saida': mes_ano,
                    'total_mes_entrada': x.get('total_entrada') or 0.0,
                    'total_mes_saida': x.get('total_saida') or 0.0,
                    'data': estatistica_ano + '-' + data_mes_estatistica + '-' + '01',
                    'diario': {dia: 0, },
                }
            if dict_dados[data]['diario'].get(dia):
                dict_dados[data]['diario'][dia] += x.get('total_saida') or 0.0
            else:
                dict_dados[data]['diario'][dia] = x.get('total_saida') or 0.0

        vals_mensal = []
        if dict_dados:
            estatistica_diaria_dados = obj_estoque_utils.\
                estutl_get_estatistica_movimento_saida_diario(cr, uid, company_id, produto_id,
                                                              grade_id, context)
            for key in dict_dados:
                dados = dict_dados[key]
                estatisticas_diaria_itens_ids = list()
                vals = {
                    'estatistica_mensal_id': ids,
                    'data_estatistica_entrada': dados.get('data_estatistica_entrada'),
                    'data_estatistica_saida': dados.get('data_estatistica_saida'),
                    'total_mes_entrada': dados.get('total_mes_entrada'),
                    'total_mes_saida': dados.get('total_mes_saida'),
                    'data': dados.get('data'),
                }
                if estatistica_diaria_dados.get(key):
                    for ds in range(0, 7):
                        dia_semana_dados = filter(
                            lambda d: d.get('dia_semana') == dict_dia_semana.get(ds),
                            estatistica_diaria_dados.get(key))
                        dia_semana_dados = sorted(dia_semana_dados, key=lambda dsd: dsd.get('dia'))
                        contador = 1
                        vals_diaria = {'dia_semana': dict_dia_semana.get(ds)}
                        com_primeiro = False
                        for d in dia_semana_dados:
                            if any([ds == 0 and int(d.get('dia')) > 1,
                                    ds == 1 and int(d.get('dia')) > 2,
                                    ds == 2 and int(d.get('dia')) > 3,
                                    ds == 3 and int(d.get('dia')) > 4,
                                    ds == 4 and int(d.get('dia')) > 5,
                                    ds == 5 and int(d.get('dia')) > 6,
                                    ds == 6 and int(d.get('dia')) > 7]):
                                if contador == 1:
                                    contador += 1
                            vals_diaria.update(
                                {'dia%s' % contador: d.get('dia'),
                                 'qtd%s_entrada' % contador: d.get('quantidade_entrada'),
                                 'qtd%s_saida' % contador: d.get('quantidade_saida')})
                            contador += 1
                        estatisticas_diaria_itens_ids.append((0, 0, vals_diaria))

                if estatisticas_diaria_itens_ids:
                    vals.update({'estatisticas_diaria_itens_ids': estatisticas_diaria_itens_ids})

                obj_est_mensal.create(cr, uid, vals, context)
                vals_mensal.append([0, 0, vals])

        if not context.get('estatisticas_pedido_compra'):
            minimo = obj_estoque_produto_grade.browse(cr, uid, grade_id).minimo or 0
            maximo = obj_estoque_produto_grade.browse(cr, uid, grade_id).maximo or 0
            vals = {
                'min': minimo,
                'max': maximo,
                'saldo_local': saldo_local / (qtd_embalagem or 1),
                'saldo_total': saldo_total,
                'unidade': unidade_descricao,
                'qtd_embalagem': qtd_embalagem,
            }
            if ultima_entrada[0]:
                vals.update({'qtd_ultima_entrada': ultima_entrada[0],
                             'data_ultima_entrada': ultima_entrada[1]})

            if ultima_saida[0]:
                vals.update({'qtd_ultima_saida': ultima_saida[0],
                             'data_ultima_saida': ultima_saida[1]})

            self.write(cr, uid, ids, vals, context)
            if context.get('estesm_retorna_valores'):
                vals_mensal = sorted(vals_mensal, key=lambda x: x[2].get('data'))
                vals_mensal.reverse()
                if context.get('estatistica_mensal_itens_ids'):
                    for i in context.get('estatistica_mensal_itens_ids'):
                        i[0] = 2
                    vals_mensal.extend(context.get('estatistica_mensal_itens_ids'))

                vals.update({'estatistica_mensal_itens_ids': vals_mensal})
                return vals

        if context.get('active_model') in ('estoque.produto.grade', self._name):
            return {
                'res_id': ids,
                'name': _('Estoque Estatisticas Mensal'),
                'view_type': 'form',
                'view_mode': 'form',
                'res_model': 'estoque.estatisticas.mensal.osv',
                'view_id': False,
                'target': 'new',
                'type': 'ir.actions.act_window'
            }

        return ids

    def create(self, cr, user, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('estatistica_mensal_itens_ids'):
            aux = []
            for i in vals.get('estatistica_mensal_itens_ids'):
                if i[0] == 2:
                    continue

                aux.append(i)
            vals['estatistica_mensal_itens_ids'] = aux
        res = super(estoque_estatisticas_mensal_osv, self).create(cr, user, vals, context)
        return res

    def write(self, cr, user, ids, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('estatistica_mensal_itens_ids'):
            aux = []
            for i in vals.get('estatistica_mensal_itens_ids'):
                if i[0] == 2 and not i[1]:
                    continue

                aux.append(i)
            vals['estatistica_mensal_itens_ids'] = aux
        res = super(estoque_estatisticas_mensal_osv, self).write(cr, user, ids, vals, context)
        return res

class estoque_estatisticas_mensal_itens_osv(osv.TransientModel):
    _name = 'estoque.estatisticas.mensal.itens.osv'
    _columns = {
        'estatistica_mensal_id': fields.many2one('estoque.estatisticas.mensal.osv', 'Estatistica', required=True,
                                                 ondelete='cascade'),
        'data_estatistica_entrada': fields.char('Mes entrada', size=12, required=True),
        'data_estatistica_saida': fields.char('Mes saida', size=12, required=True),
        'total_mes_entrada': fields.float('Total Entradas', digits=(16, 2), required=True),
        'total_mes_saida': fields.float('Total Saidas', digits=(16, 2), required=True),
        'data': fields.date('Data'),
        'estatisticas_diaria_itens_ids': fields.one2many('estoque.estatisticas.diaria.itens.osv',
                                                         'estatistica_mensal_itens_id', 'Estatistica diaria'),
    }
    _order = 'data DESC'


class estoque_estatisticas_diaria_itens_osv(osv.TransientModel):
    _name = 'estoque.estatisticas.diaria.itens.osv'
    _columns = {
        'estatistica_mensal_itens_id': fields.many2one('estoque.estatisticas.mensal.itens.osv', 'Estatistica Mensal',
                                                       required=True, ondelete='cascade'),
        'dia_semana': fields.char('Semana', size=20),
        'dia1': fields.char('Dia', size=2),
        'qtd1_entrada': fields.float('Qtd Entrada', digits=(12, 3)),
        'qtd1_saida': fields.float('Qtd Saida', digits=(12, 3)),
        'dia2': fields.char('Dia', size=2),
        'qtd2_entrada': fields.float('Qtd Entrada', digits=(12, 3)),
        'qtd2_saida': fields.float('Qtd Saida', digits=(12, 3)),
        'dia3': fields.char('Dia', size=2),
        'qtd3_entrada': fields.float('Qtd Entrada', digits=(12, 3)),
        'qtd3_saida': fields.float('Qtd Saida', digits=(12, 3)),
        'dia4': fields.char('Dia', size=2),
        'qtd4_entrada': fields.float('Qtd Entrada', digits=(12, 3)),
        'qtd4_saida': fields.float('Qtd Saida', digits=(12, 3)),
        'dia5': fields.char('Dia', size=2),
        'qtd5_entrada': fields.float('Qtd Entrada', digits=(12, 3)),
        'qtd5_saida': fields.float('Qtd Saida', digits=(12, 3)),
        'dia6': fields.char('Dia', size=2),
        'qtd6_entrada': fields.float('Qtd Entrada', digits=(12, 3)),
        'qtd6_saida': fields.float('Qtd Saida', digits=(12, 3)),
    }
    _defaults = {
        # 'qtd1_entrada': 0.00,
        'qtd2_entrada': 0.00,
        'qtd3_entrada': 0.00,
        'qtd4_entrada': 0.00,
        'qtd5_entrada': 0.00,
        'qtd6_entrada': 0.00,
        'qtd1_saida': 0.00,
        'qtd2_saida': 0.00,
        'qtd3_saida': 0.00,
        'qtd4_saida': 0.00,
        'qtd5_saida': 0.00,
        'qtd6_saida': 0.00,
    }
    def create(self, cr, user, vals, context=None):
        return super(estoque_estatisticas_diaria_itens_osv, self).create(cr, user, vals, context)
