# -*- coding: utf-8 -*-

from openerp.osv import osv, fields

class wizard_estoque_produto_saldo(osv.TransientModel):

    _name = 'wizard.estoque.produto.saldo'
    _columns = {
        'wizeps_data_movimento': fields.date('Data Movimento', required=True, select=True),
        'wizeps_saldo': fields.float('Saldo', digits=(14, 5), required=True),
        'wizeps_company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade",
                                             required=True, select=True),
        'wizeps_produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="restrict",
                                              select=True, required=True,
                                             domain="[('tipo', '=', 'P')]"),  # Produto
        'wizeps_grade_id': fields.many2one("estoque.produto.grade", 'Grade', ondelete="restrict",
                                           domain="[('produto_id', '=', produto_id)]",
                                           required=True, select=True),
        'wizeps_qtd_reservada': fields.float('Quantidade reservada', digits=(14, 3), required=True),
        'wizeps_disponivel': fields.float('Quantidade disponivel', digits=(14, 3), required=True),
    }
    _order = 'wizeps_company_id'