# -*- coding: utf-8 -*-
import time
from openerp import pooler
from openerp.osv import osv, fields
from openerp.tools.translate import _


class wizard_listagem_categoria(osv.TransientModel):
    _name = 'wizard.listagem_categoria'
    _description = 'Listagem de Produto x Grade'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', required=True, select=True),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(cr, uid, uid).company_id.id,

    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        estrutura, dados = self.get_dados_rel(cr, uid, ids, context)
        context['estrutura'] = estrutura
        context['dados'] = dados
        return self.pool.get('wizard.relatorios.impressao').get_tela_relatorios(cr, uid, context)

    def get_dados_rel(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        pagina = {'relpag_nome_rel': _('Listagem de Categorias'),
                  'relpag_tam_linha': 91,
                  'relpag_cabecalhos': [{'relcab_name': 'cab1',
                                         'relcab_colunas': [{'relcol_name': 'data',
                                                             'relcol_dados_tam': 11},
                                                            {'relcol_name': 'titulo',
                                                             'relcol_dados_tam': 71,
                                                             'relcol_fonte_tamanho': 18,
                                                             'relcol_dados_alinhamento': 'C'},
                                                            {'relcol_name': 'pagina',
                                                             'relcol_dados_tam': 9}]},
                                        {'relcab_name': 'cab2',
                                         'relcab_divide_linha': True,
                                         'relcab_colunas': [{'relcol_name': 'empresa',
                                                             'relcol_dados_tam': 91,}],},
                                        {'relcab_name': 'cab3',
                                         'relcab_divide_linha': True,
                                         'relcab_colunas': [{'relcol_name': 'col1',
                                                             'relcol_dados_tam': 20},
                                                            {'relcol_name': 'col2',
                                                             'relcol_dados_tam': 60},
                                                            {'relcol_name': 'col3',
                                                             'relcol_dados_tam': 11}]
                                         },],
                  'relpag_linhas': [{'rellin_name': 'linha1',
                                     'rellin_colunas': [{'relcol_name': 'conta',
                                                         'relcol_dados_tam': 20},
                                                        {'relcol_name': 'descricao',
                                                         'relcol_dados_tam': 60},
                                                        {'relcol_name': 'ncm',
                                                         'relcol_dados_tam': 11},]
                                     },],
                  }
        obj_fiscal_ncm = pooler.get_pool(cr.dbname).get('fiscal.ncm')
        linhas = []
        obj_categoria = self.pool.get('estoque.categoria')
        categ_ids = obj_categoria.search(cr, uid, [], order='conta', context=context)
        dict_categ = {}
        # por algum motivo ao fazer o read, os ids estao saindo da ordem
        map(lambda x: dict_categ.update({x.get('id'): x}),
            obj_categoria.read(cr, uid, categ_ids, ['name', 'conta', 'parent_id', 'ncm_id'],
                               context=context))
        for id in categ_ids:
            records = dict_categ.get(id)
            codigo_ncm = ''
            if 'conta' in records:
                conta = records.get('conta')

            if records.get('parent_id'):
                parente = records.get('parent_id')[1] + ' / ' + records.get('name')
                descricao = parente
            else:
                descricao = records.get('name')
            if records.get('ncm_id') and records.get('ncm_id'):
                ncm_id = records.get('ncm_id')
                if isinstance(ncm_id, (list, tuple)):
                    ncm_id = ncm_id[0]
                fiscal_ncm_dados = obj_fiscal_ncm.read(cr, uid, ncm_id, ['codigo'], context)
                if fiscal_ncm_dados and isinstance(fiscal_ncm_dados, list):
                    fiscal_ncm_dados = fiscal_ncm_dados[0]
                codigo_ncm = fiscal_ncm_dados.get('codigo') or ''

            linhas.append({'linha1': {'conta': conta,
                                      'descricao': descricao,
                                      'ncm': codigo_ncm}})


        vals = self.read(cr, uid, ids[0], context=context)
        nome_empresa = self.pool.get("res.company").read(cr, uid, vals['company_id'][0], ['name'],
                                                         context=context).get('name')

        dados = {'cab1': {'data': _('Data: ') + time.strftime('%d/%m/%Y'),
                          'titulo': _("Listagem de Categorias"),
                          'pagina': '|pag|'},
                 'cab2': {'empresa': nome_empresa},
                 'cab3': {'col1': _('Conta'),
                          'col2': _('Descricao'),
                          'col3': _('Codigo NCM')},
                 'linhas': linhas}

        return pagina, dados

