# -*- encoding: utf-8 -*-
from openerp.osv import osv, fields


class wizard_listagem_conferencia_osv(osv.TransientModel):
    _name = 'wizard.listagem.conferencia.osv'
    _columns = {
        'inventario_id': fields.many2one("estoque.inventario.capa", 'Inventario', required=True, ondelete='cascade',
                                         domain="[('atualizado','=',False)]"), # id do inventario
        'local_id': fields.many2one('estoque.local', 'Local', required=True),
        'codigo': fields.selection([('I', 'Item'), ('F', 'Fabricante')], 'Codigo', size=1),
        'ordem': fields.selection([('A', 'Alfabetica'), ('C', 'Codigos'), ('T', 'Categoria'),
                                   ('L', 'Locacao')], 'Ordem', size=1),
        'categoria_id': fields.many2one('estoque.categoria', 'Categoria'),
    }
    _defaults = {
        'codigo': 'I',
        'ordem': 'C',
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        listagem_conferencia_dados = self.read(cr, uid, ids, [], context=context,
                                               load='_classic_write')
        for x in listagem_conferencia_dados:
            datas = {
                'inventario_id': x.get('inventario_id'),
                'codigo': x.get('codigo'),
                'ordem': x.get('ordem'),
                'local_id': x.get('local_id'),
                'categoria_id': x.get('categoria_id')
            }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'listagem_conferencia',
            'datas': datas,
        }
