# -*- encoding: utf-8 -*-
from openerp.osv import osv, fields
from openerp.tools.translate import _


class wizard_listagem_contagem_osv(osv.TransientModel):
    _name = 'wizard.listagem.contagem.osv'
    _columns = {
        'inventario_id': fields.many2one("estoque.inventario.capa", 'Inventario', required=True, ondelete='cascade',
                                         domain="[('atualizado','=',False)]"), # id do inventario
        'local_id': fields.many2one('estoque.local', 'Local', required=True),
        'codigo': fields.selection([('I', 'Item'), ('F', 'Fabricante')], 'Codigo a listar', size=1),
        'ordem': fields.selection([('A', 'Alfabetica'), ('C', 'Codigos'), ('T', 'Categoria'),
                                   ('L', 'Locacao')], 'Ordem a listar', size=1),
        'saldo': fields.boolean('Listar saldo'),
        'preco_venda': fields.boolean('Listar preco de venda'),
        'separar_entre_linhas': fields.boolean('Separar linhas'),
    }
    _defaults = {
        'codigo': 'I',
        'ordem': 'C',
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        listagem_contagem_dados = self.read(cr, uid, ids[0] if isinstance(ids, list) else ids,
                                            [], context, '_classic_write')
        inventario_id = listagem_contagem_dados.get('inventario_id')
        local_id = listagem_contagem_dados.get('local_id')
        tipo_codigo = listagem_contagem_dados.get('codigo')

        ordem = listagem_contagem_dados.get('ordem')
        order = None
        if ordem == 'A':
            order = 'produto_descricao ASC'
        elif ordem == 'C':
            order = 'produto_codigo ASC'
            if tipo_codigo == 'F':
                order = 'codigo_fabricante ASC'
        elif ordem == 'T':
            order = 'nivel_categoria ASC'
        elif ordem == 'L':
            order = 'locacao ASC'

        sql = """
            SELECT
                inventario.id AS inventario_id,
                contagem.locacao_id AS locacao_id,
                local_locacao.locacao as locacao,
                contagem.local_id AS local_id,
                contagem.produto_id AS produto_id,
                produto.name AS produto_descricao,
                produto.codigo AS produto_codigo,
                contagem.grade_id AS grade_id,
                grade.codigo_no_fabricante AS codigo_fabricante,
                grade.grade AS grade_grade,
                grade.descricao AS grade_descricao,
                contagem.saldo_contado AS saldo_contado,
                contagem.saldo_cadastro AS saldo_cadastro,
                categoria.conta AS nivel_categoria,
                categoria.id AS categoria_id,
                COALESCE(estoque_embalagem.quantidade_na_embalagem, 1.0) AS quantidade_embalagem,
                estoque_embalagem.sigla AS unidade
            FROM estoque_inventario_contagem contagem
                INNER JOIN estoque_inventario_capa inventario
                    ON contagem.inventario_id = inventario.id
                INNER JOIN estoque_produto produto
                    ON contagem.produto_id = produto.id
                INNER JOIN estoque_produto_grade grade
                    ON contagem.grade_id = grade.id
                LEFT JOIN estoque_categoria categoria
                    ON categoria.id = produto.categoria_id
                LEFT JOIN estoque_local_locacao local_locacao
                    ON local_locacao.id = contagem.locacao_id
                LEFT JOIN estoque_produto_embalagem produto_embalagem
                ON produto_embalagem.id = local_locacao.estllc_produto_embalagem_id
                LEFT JOIN estoque_embalagem estoque_embalagem
                ON estoque_embalagem.id = produto_embalagem.embalagem_id
            WHERE
                inventario.id = {inventario_id}
                AND contagem.local_id = {local_id}
                AND produto.active IS TRUE 
        """.format(inventario_id=inventario_id, local_id=local_id)
        if order:
            sql += """
            ORDER BY %s
            """ % order
        cr.execute(sql)
        dados = cr.dictfetchall()
        if not dados:
            raise osv.except_osv(_('Atencao'), _('Nao ha dados para listagem.'))

        datas = {
            'inventario_id': inventario_id,
            'local_id': local_id,
            'codigo': tipo_codigo,
            'saldo': listagem_contagem_dados.get('saldo'),
            'preco_venda': listagem_contagem_dados.get('preco_venda'),
            'separar_entre_linhas': listagem_contagem_dados.get('separar_entre_linhas'),
            'dados': dados
        }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'listagem_contagem',
            'datas': datas,
        }
