# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _
from openerp import SUPERUSER_ID


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}

        def center_title(E, C, D, T=186):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            if (T - len(C)) % 2 >= 1:
                D = ' ' + D
            title += D
            return title

        from datetime import datetime
        inicio_total = inicio = datetime.now()
        title = center_title(_('|Contr.Estoque'), _('Listagem de Movimento'), _('est310|'))
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.informaTamLinha(186)
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)
        listagem.defineFonte(tam=7.3)
        listagem.defineFormato(orientacao='1')
        listagem.informaNome(pdf_string, _('Listagem Movimento Analitico'))

        obj_estoque_local = pooler.get_pool(cr.dbname).get('estoque.local')
        obj_estoque_produto_embalagem = pooler.get_pool(cr.dbname).get('estoque.produto.embalagem')
        obj_fiscal_tributacao_encargos = pooler.get_pool(cr.dbname).get('fiscal.tributacao.encargos')

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                                                     'wizard.listagem.movimento.analitico.osv',
                                                                                     context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id, ['name'],
                                                                               context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title('|' + data, nome_empresa, _('Pagina: {{ Page }} |'), 195)

        company_ids = datas.get('company_ids')
        empresas = pooler.get_pool(cr.dbname).get('res.company').browse(cr, uid, company_ids)
        local_ids = datas.get('local_ids')
        locais = obj_estoque_local.browse(cr, uid, local_ids)
        periodo_inicial = datas.get('periodo_inicial')
        periodo_final = datas.get('periodo_final')
        ordem = datas.get('ordem')
        dados = datas.get('dados')
        ordem_imprimir = _('ORDEM POR ')
        if ordem == 'Doc':
            ordem_imprimir += _('DOCUMENTO')
        elif ordem == 'Pro':
            ordem_imprimir += _('PRODUTO')
        elif ordem == 'Cat':
            ordem_imprimir += _('CATEGORIA')
        elif ordem == 'Dat':
            ordem_imprimir += _('DATA')
        elif ordem == 'Loc':
            ordem_imprimir += _('LOCAL')
        elif ordem == 'Cli':
            ordem_imprimir += _('FORNECEDOR/CLIENTE')
        else:
            ordem_imprimir = _('NENHUMA ORDEM')

        tam = 0
        cont=0
        local_names = [[]]
        for local in locais:
            if tam + len(", %s" % local.name) >= 175:
                local_names[cont][-1] = '%s,' % local_names[cont][-1]
                local_names.append([])
                cont += 1
                tam = 0

            local_names[cont].append(local.name)
            tam += len(local.name) + 2

        empresa_names = []
        cont_linha = 0
        for empresa in empresas:
            if not empresa_names:
                empresa_names.append(empresa.name)
                continue

            empresa_names[cont_linha] += ', '

            if len(empresa_names[cont_linha] + empresa.name) >= 173 and not cont_linha:
                cont_linha += 1
                empresa_names.append(empresa.name)
                continue

            if len(empresa_names[cont_linha] + empresa.name) >= 184:
                cont_linha += 1
                empresa_names.append(empresa.name)
                continue

            empresa_names[cont_linha] += empresa.name


        listagem.informaCab(
            '*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(title)
        listagem.informaCab(
            '|                                                                                                                                                                                        |')
        listagem.informaCab(
            '|                                                                                                                                                                                        |')
        listagem.informaCab(docs)
        listagem.informaCab(
            '|                                                                                                                                                                                        |')
        periodo = _('|Periodo: ') + time.strftime("%d/%m/%Y",
                                                  time.strptime(periodo_inicial, "%Y-%m-%d")) + ' a ' + time.strftime(
            "%d/%m/%Y", time.strptime(periodo_final, "%Y-%m-%d")) + '   ' + ordem_imprimir
        periodo = center_title(periodo, '', '|')
        listagem.informaCab(periodo)
        for i in local_names:
            local_names = ((i == local_names[0] and _('|Locais: %s') or '|        %s')
                            % ', '.join(i) ).ljust(185) + '|'
            listagem.informaCab(local_names)

        for nomes in empresa_names:
            if nomes == empresa_names[0]:
                listagem.informaCab((_('|Empresas: ') + nomes).ljust(185) + '|')
                continue

            listagem.informaCab(('|' +nomes).ljust(185) + '|')

        listagem.informaCab(
            '*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(_(
            '| Sq |CM|LC|  Cod. do Item |GR|                 DESCRICAO                |CL/FO|   DATA   |SER|   DOCUMENTO    |QUANTIDADE|UNI|QTD.EMB.|QTD.UND.|VR.UNITAR.| VR.TOTAL |   IPI  | ALQ.IPI |'))
        listagem.informaCab(
            '*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(
            '|                                                                                                                                                                                        |')
        listagem.rodapePadrao()

        ensubtotal_valor = 0.0
        etsubtotal_valor = 0.0
        epsubtotal_valor = 0.0
        edsubtotal_valor = 0.0
        ersubtotal_valor = 0.0
        eisubtotal_valor = 0.0
        essubtotal_valor = 0.0
        snsubtotal_valor = 0.0
        stsubtotal_valor = 0.0
        sdsubtotal_valor = 0.0
        srsubtotal_valor = 0.0
        sisubtotal_valor = 0.0
        sssubtotal_valor = 0.0
        ensubtotal_quantidade = 0.0
        ensubtotal_quantidade_unidade = 0.0
        etsubtotal_quantidade = 0.0
        etsubtotal_quantidade_unidade = 0.0
        epsubtotal_quantidade = 0.0
        epsubtotal_quantidade_unidade = 0.0
        edsubtotal_quantidade = 0.0
        edsubtotal_quantidade_unidade = 0.0
        ersubtotal_quantidade = 0.0
        ersubtotal_quantidade_unidade = 0.0
        eisubtotal_quantidade = 0.0
        eisubtotal_quantidade_unidade = 0.0
        essubtotal_quantidade = 0.0
        essubtotal_quantidade_unidade = 0.0
        snsubtotal_quantidade = 0.0
        snsubtotal_quantidade_unidade = 0.0
        stsubtotal_quantidade = 0.0
        stsubtotal_quantidade_unidade = 0.0
        sdsubtotal_quantidade = 0.0
        sdsubtotal_quantidade_unidade = 0.0
        srsubtotal_quantidade = 0.0
        srsubtotal_quantidade_unidade = 0.0
        sisubtotal_quantidade = 0.0
        sisubtotal_quantidade_unidade = 0.0
        sssubtotal_quantidade = 0.0
        sssubtotal_quantidade_unidade = 0.0

        quantidade_parcial = 0.0
        quantidade_unidade_parcial = 0.0
        total_ipi = 0.0
        total_parcial = 0.0

        contador = 1
        if ordem == 'Doc':
            documento_aux = dados[0].get('nf_capa_id')
            if not documento_aux:
                documento_aux = dados[0].get('cupons_capa_id')
            if not documento_aux:
                documento_aux = dados[0].get('requisicao_ressuprimento_id')
            if not documento_aux:
                documento_aux = dados[0].get('requisicao_id')
            if not documento_aux:
                documento_aux = dados[0].get('data')
        elif ordem == 'Pro':
            documento_aux = dados[0].get('produto_id')
        elif ordem == 'Cat':
            documento_aux = dados[0].get('categoria_id')
            categoria_id = documento_aux
        elif ordem == 'Cli':
            documento_aux = dados[0].get('pessoa_id')
            pessoa_id = documento_aux
        elif ordem == 'Loc':
            documento_aux = dados[0].get('local_id')
        else:
            documento_aux = dados[0].get('data')
        count = 0
        ecf_instalado = pooler.get_pool(cr.dbname).get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'ecf',
                                                                                                  context)
        coo_dados = map(lambda z: {z.get('coo'): z}, dados)
        aux = {}
        for i in coo_dados:
            for j in i:
                aux[j] = i.get(j)
        coo_dados = aux
        from datetime import timedelta
        a = timedelta(days=0)
        tempo = {1:a,2:a,3:a,4:a}
        inicio = datetime.now()
        madeireira_instalado = pooler.get_pool(cr.dbname).get('adm.utils').admutl_check_modulo_instalado(
            cr, uid, 'madeireira', context)
        for i in dados:
            if ecf_instalado:
                if i.get('coo'):
                    if i.get('coo') + 1 in coo_dados and coo_dados.get(i.get('coo') + 1).get('tipo_cupom') == 'C':
                        continue
                if i.get('tipo_cupom') == 'C':
                    continue
            count += 1
            numero_documento_aux = i.get('numero_documento')
            if not numero_documento_aux:
                numero_documento = ''
            else:

                if numero_documento_aux.find(':') != -1:
                    copiar = False
                    numero_documento = ''
                    for x in numero_documento_aux:
                        if x == ':':
                            copiar = True
                            continue
                        if copiar:
                            numero_documento += x
                else:
                    numero_documento = numero_documento_aux

            if i.get('nf_capa_id'):
                tipo_doc = 'nf_capa_id'

            if i.get('cupons_capa_id'):
                tipo_doc = 'cupons_capa_id'

            if i.get('requisicao_id'):
                tipo_doc = 'requisicao_id'

            if i.get('requisicaoressuprimento_id'):
                tipo_doc = 'requisicaoressuprimento_id'

            if i.get('inventario_id'):
                tipo_doc = 'inventario_id'

            linha = ''
            if (ordem == 'Doc' and documento_aux != i.get(tipo_doc) and quantidade_parcial):
                linha = _('|' + formataString('T O T A L   P O R   D O C U M E N T O', 93, ' ', 'C', 'N', 'S') + '|')
                documento_aux = i.get(tipo_doc)

            elif ordem == 'Pro' and documento_aux != i.get('produto_id') and quantidade_parcial:
                linha = _('|' + formataString('T O T A L   D O   P R O D U T O', 93, ' ', 'C', 'N', 'S') + '|')
                documento_aux = i.get('produto_id')

            elif ordem == 'Cat' and documento_aux != i.get('categoria_id') and quantidade_parcial:
                linha = _('|' + formataString('T O T A L   D A   C A T E G O R I A', 93, ' ', 'C', 'N', 'S') + '|')
                documento_aux = i.get('categoria_id')

            elif ordem == 'Dat' and documento_aux != i.get('data') and quantidade_parcial:
                linha = _('|' + formataString('T O T A L   P O R   D A T A', 93, ' ', 'C', 'N', 'S') + '|')
                documento_aux = i.get('data')

            elif ordem == 'Cli' and documento_aux != i.get('pessoa_id') and quantidade_parcial:
                linha = _(
                    '|' + formataString('T O T A L   P O R   F O R N E C E D O R / C L I E N T E', 93, ' ', 'C', 'N',
                                        'S') + '|')
                documento_aux = i.get('pessoa_id')

            elif ordem == 'Loc' and documento_aux != i.get('local_id') and quantidade_parcial:
                linha = _('|' + formataString('T O T A L   P O R   L O C A L: %s' % (i.get('local_nome')), 93, ' ', 'C', 'N',
                                              'S') + '|')
                documento_aux = i.get('local_id')

            if linha:
                linha += formataString(getNumeroEditado(quantidade_parcial, 3), 27, ' ', 'E', 'N', 'S')
                linha += formataString(getNumeroEditado(quantidade_unidade_parcial, 3), 22, ' ', 'E', 'N', 'S')
                linha += formataString(getNumeroEditado(total_parcial, 2), 22, ' ', 'E', 'N', 'S') + ' '
                linha += formataString(getNumeroEditado(total_ipi, 2), 8, ' ', 'E', 'N', 'S') + '          |'
                listagem.imprimeLinha(linha)
                listagem.imprimeLinha(
                    '*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')

                contador = 1
                total_parcial = 0.0
                quantidade_parcial = 0.0
                quantidade_unidade_parcial = 0.0
                total_ipi = 0.0
            quantidade_embalagem = 0
            quantidade = 0
            vr_unitario = 0
            unidade = ''
            if i.get('produto_embalagem_id'):
                cr.execute('''SELECT ee.quantidade_na_embalagem,
                                     eeu.unidade
                              FROM estoque_embalagem               AS ee
                              INNER JOIN estoque_produto_embalagem AS epe ON epe.embalagem_id = ee.id
                              INNER JOIN estoque_embalagem_unidade AS eeu ON eeu.id = ee.unidade_id
                              WHERE epe.id = %s
                           ''' % i.get('produto_embalagem_id'))
                dados_embalagem = cr.dictfetchall()
                if dados_embalagem:
                    quantidade_embalagem = dados_embalagem[0].get('quantidade_na_embalagem')
                    unidade = dados_embalagem[0].get('unidade')

                if quantidade_embalagem:
                    if i.get('tipo_movimento') == 'S' and madeireira_instalado and i.get('volume'):
                        quantidade = i.get('volume') or 0.0
                    else:
                        quantidade = i.get('quantidade') or 0.0

                    if quantidade:
                        quantidade /= quantidade_embalagem

                vr_unitario = i.get('vr_unitario') or 0.0
            quantidade_unidade = quantidade * quantidade_embalagem
            cm = self.get_cm(i.get('tipo_movimento'), i.get('origem'), i.get('cfop_movimento'))

            valor_total = (i.get('vr_total_item') or 0.0) + (i.get('vr_icms_st') or 0.0)
            produto_id = i.get('produto_id')

            cr.execute('''SELECT aliquota
                          FROM fiscal_tributacao                AS ft
                          INNER JOIN fiscal_tributacao_encargos AS fte ON fte.tributacao_id = ft.id
                          INNER JOIN fiscal_encargo             AS fe  ON fe.id = fte.encargo_id
                          WHERE fte.produto_id = %s
                            AND fe.sigla = 'IPI' ''' % produto_id)
            dados_aliquota = cr.dictfetchall()
            aliquota = 0
            if dados_aliquota:
                aliquota = dados_aliquota[0].get('aliquota') or 0.0

            calculo_ipi = i.get('vr_ipi') or 0.0
            valor_total += calculo_ipi

            if ordem == 'Cat':
                categoria = pooler.get_pool(cr.dbname).get('estoque.produto').browse(
                    cr, uid, produto_id).categoria_id
                if not i.get('categoria_id') == categoria_id or dados.index(i) == 0:
                    categoria_id = i.get('categoria_id')
                    categoria_name = "SEM CATEGORIA"
                    if categoria:
                        categoria_name = categoria.nome_completo
                    listagem.imprimeLinha(
                        '|                                                                                                                                                                                        |')
                    categoria_nome = '|Categoria: ' + categoria_name
                    while len(categoria_nome) < 185:
                        categoria_nome += ' '
                    listagem.imprimeLinha(categoria_nome + '|')
                    listagem.imprimeLinha(
                        '|                                                                                                                                                                                        |')
            elif ordem == 'Cli':
                if not i.get('pessoa_id') == pessoa_id or dados.index(i) == 0:
                    pessoa_id = i.get('pessoa_id')
                    pessoa_name = "SEM CLIENTE/FORNECEDOR"
                    if i.get('pessoa_nome'):
                        pessoa_name = i.get('pessoa_nome').replace('\t', '')
                    listagem.imprimeLinha(
                        '|                                                                                                                                                                                        |')
                    pessoa_name = '|Cliente/Fornecedor: ' + pessoa_name
                    if len(pessoa_name) < 185:
                        dif = 185 - len(pessoa_name)
                        pessoa_name += ' ' * dif
                    listagem.imprimeLinha(pessoa_name + '|')
                    listagem.imprimeLinha(
                        '|                                                                                                                                                                                        |')

            linha = ''
            linha += formataString(contador, 4, ' ', 'E', 'N', 'S') + '|'
            linha += formataString(cm, 2, ' ', 'D', 'N', 'S') + '|'
            linha += formataString(i.get('local_numero'), 2, ' ', 'E', 'N', 'S') + '|'
            linha += formataString(i.get('produto_codigo'), 15, ' ', 'E', 'N', 'S') + '|'
            linha += formataString(i.get('grade_grade') or '', 2, ' ', 'E', 'N', 'S') + '|'
            linha += formataString(i.get('grade_name') or '', 42, ' ', 'D', 'N', 'S') + '|'
            linha += formataString(i.get('pessoa_codigo') or '', 5, ' ', 'E', 'N', 'S') + '|'
            linha += formataString(time.strftime("%d/%m/%Y", time.strptime(i.get('data'),
                                                                           "%Y-%m-%d")),
                                   10, ' ', 'E', 'N', 'S') + '|'
            linha += formataString(i.get('serie_nf') or '', 3, ' ', 'D', 'N', 'S') + '|'
            linha += formataString(numero_documento, 16, ' ', 'D', 'N', 'S') + '|'
            linha += formataString(getNumeroEditado(quantidade, 3), 10, ' ', 'E', 'N', 'S') + '|'
            linha += formataString(unidade, 3, ' ', 'D', 'N', 'S') + '|'
            linha += formataString(getNumeroEditado(quantidade_embalagem, 3), 8, ' ', 'E', 'N',
                                   'S') + '|'
            linha += formataString(getNumeroEditado(quantidade_unidade, 3), 8, ' ', 'E', 'N',
                                   'S') + '|'
            linha += formataString(getNumeroEditado(vr_unitario, 2), 10, ' ', 'E', 'N', 'S') + '|'
            linha += formataString(getNumeroEditado(valor_total, 2), 10, ' ', 'E', 'N', 'S') + '|'
            linha += formataString(getNumeroEditado(calculo_ipi, 2), 8, ' ', 'E', 'N', 'S') + '|'
            linha += formataString(getNumeroEditado(aliquota, 2), 9, ' ', 'E', 'N', 'S') + '|'
            quantidade_parcial += quantidade
            quantidade_unidade_parcial += quantidade_unidade
            total_parcial += valor_total
            total_ipi += calculo_ipi
            if cm == 'EN':
                ensubtotal_valor += valor_total
                ensubtotal_quantidade += quantidade
                ensubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'ET':
                etsubtotal_valor += valor_total
                etsubtotal_quantidade += quantidade
                etsubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'EP':
                epsubtotal_valor += valor_total
                epsubtotal_quantidade += quantidade
                epsubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'ED':
                edsubtotal_valor += valor_total
                edsubtotal_quantidade += quantidade
                edsubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'ER':
                ersubtotal_valor += valor_total
                ersubtotal_quantidade += quantidade
                ersubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'EI':
                eisubtotal_valor += valor_total
                eisubtotal_quantidade += quantidade
                eisubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'ES':
                essubtotal_valor += valor_total
                essubtotal_quantidade += quantidade
                essubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'SN':
                snsubtotal_valor += valor_total
                snsubtotal_quantidade += quantidade
                snsubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'ST':
                stsubtotal_valor += valor_total
                stsubtotal_quantidade += quantidade
                stsubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'SD':
                sdsubtotal_valor += valor_total
                sdsubtotal_quantidade += quantidade
                sdsubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'SR':
                srsubtotal_valor += valor_total
                srsubtotal_quantidade += quantidade
                srsubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'SI':
                sisubtotal_valor += valor_total
                sisubtotal_quantidade += quantidade
                sisubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'SS':
                sssubtotal_valor += valor_total
                sssubtotal_quantidade += quantidade
                sssubtotal_quantidade_unidade += quantidade_unidade

            listagem.imprimeLinha('|' + linha)
            contador += 1
        if ordem == 'Doc':
            linha = _('|' + formataString('T O T A L   D A   N O T A', 93, ' ', 'C', 'N', 'S') + '|')

        elif ordem == 'Pro':
            linha = _('|' + formataString('T O T A L   D O   P R O D U T O', 93, ' ', 'C', 'N', 'S') + '|')

        elif ordem == 'Cat':
            linha = _('|' + formataString('T O T A L   D A   C A T E G O R I A', 93, ' ', 'C', 'N', 'S') + '|')

        elif ordem == 'Dat':
            linha = _('|' + formataString('T O T A L   P O R   D A T A', 93, ' ', 'C', 'N', 'S') + '|')

        elif ordem == 'Cli':
            linha = _('|' + formataString('T O T A L   P O R   F O R N E C E D O R / C L I E N T E', 93, ' ', 'C', 'N',
                                          'S') + '|')
        elif ordem == 'Loc':
            linha = _(
                '|' + formataString('T O T A L   P O R   L O C A L: %s' % (i.get('local_nome')), 93, ' ', 'C', 'N', 'S') + '|')

        linha += formataString(getNumeroEditado(quantidade_parcial, 3), 27, ' ', 'E', 'N', 'S')
        linha += formataString(getNumeroEditado(quantidade_unidade_parcial, 3), 22, ' ', 'E', 'N', 'S')
        linha += formataString(getNumeroEditado(total_parcial, 2), 22, ' ', 'E', 'N', 'S') + ' '
        linha += formataString(getNumeroEditado(total_ipi, 2), 8, ' ', 'E', 'N', 'S') + '          |'
        listagem.imprimeLinha(linha)
        listagem.imprimeLinha(
            '*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')

        listagem.imprimeLinha(
            '|                                                                                                                                                                                        |')
        if ensubtotal_quantidade or ensubtotal_valor:
            linha = _('|' + formataString('ENSubTotal', 93, ' ', 'E', 'N', 'S') + '|')
            linha += formataString(getNumeroEditado(ensubtotal_quantidade, 3), 27, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(ensubtotal_quantidade_unidade, 3), 22, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(ensubtotal_valor, 2), 22, ' ', 'E', 'N',
                                   'S') + '                   |'
            listagem.imprimeLinha(linha)
        if etsubtotal_quantidade or etsubtotal_valor:
            linha = _('|' + formataString('ETSubTotal', 93, ' ', 'E', 'N', 'S') + '|')
            linha += formataString(getNumeroEditado(etsubtotal_quantidade, 3), 27, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(etsubtotal_quantidade_unidade, 3), 22, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(etsubtotal_valor, 2), 22, ' ', 'E', 'N',
                                   'S') + '                   |'
            listagem.imprimeLinha(linha)
        if epsubtotal_quantidade or epsubtotal_valor:
            linha = _('|' + formataString('EPSubTotal', 93, ' ', 'E', 'N', 'S') + '|')
            linha += formataString(getNumeroEditado(epsubtotal_quantidade, 3), 27, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(epsubtotal_quantidade_unidade, 3), 22, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(epsubtotal_valor, 2), 22, ' ', 'E', 'N',
                                   'S') + '                   |'
            listagem.imprimeLinha(linha)
        if edsubtotal_quantidade or edsubtotal_valor:
            linha = _('|' + formataString('EDSubTotal', 93, ' ', 'E', 'N', 'S') + '|')
            linha += formataString(getNumeroEditado(edsubtotal_quantidade, 3), 27, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(edsubtotal_quantidade_unidade, 3), 22, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(edsubtotal_valor, 2), 22, ' ', 'E', 'N',
                                   'S') + '                   |'
            listagem.imprimeLinha(linha)
        if ersubtotal_quantidade or ersubtotal_valor:
            linha = _('|' + formataString('ERSubTotal', 93, ' ', 'E', 'N', 'S') + '|')
            linha += formataString(getNumeroEditado(ersubtotal_quantidade, 3), 27, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(ersubtotal_quantidade_unidade, 3), 22, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(ersubtotal_valor, 2), 22, ' ', 'E', 'N',
                                   'S') + '                   |'
            listagem.imprimeLinha(linha)
        if eisubtotal_quantidade or eisubtotal_valor:
            linha = _('|' + formataString('EISubTotal', 93, ' ', 'E', 'N', 'S') + '|')
            linha += formataString(getNumeroEditado(eisubtotal_quantidade, 3), 27, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(eisubtotal_quantidade_unidade, 3), 22, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(eisubtotal_valor, 2), 22, ' ', 'E', 'N',
                                   'S') + '                   |'
            listagem.imprimeLinha(linha)
        if essubtotal_quantidade or essubtotal_valor:
            linha = _('|' + formataString('ESSubTotal', 93, ' ', 'E', 'N', 'S') + '|')
            linha += formataString(getNumeroEditado(essubtotal_quantidade, 3), 27, ' ', 'E', 'N',
                                   'S')
            linha += formataString(getNumeroEditado(essubtotal_quantidade_unidade, 3), 22, ' ',
                                   'E', 'N', 'S')
            linha += formataString(getNumeroEditado(essubtotal_valor, 2), 22, ' ', 'E', 'N',
                                   'S') + '                   |'
            listagem.imprimeLinha(linha)
        if snsubtotal_quantidade or snsubtotal_valor:
            linha = _('|' + formataString('SNSubTotal', 93, ' ', 'E', 'N', 'S') + '|')
            linha += formataString(getNumeroEditado(snsubtotal_quantidade, 3), 27, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(snsubtotal_quantidade_unidade, 3), 22, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(snsubtotal_valor, 2), 22, ' ', 'E', 'N',
                                   'S') + '                   |'
            listagem.imprimeLinha(linha)
        if stsubtotal_quantidade or stsubtotal_valor:
            linha = _('|' + formataString('STSubTotal', 93, ' ', 'E', 'N', 'S') + '|')
            linha += formataString(getNumeroEditado(stsubtotal_quantidade, 3), 27, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(stsubtotal_quantidade_unidade, 3), 22, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(stsubtotal_valor, 2), 22, ' ', 'E', 'N',
                                   'S') + '                   |'
            listagem.imprimeLinha(linha)
        if sdsubtotal_quantidade or sdsubtotal_valor:
            linha = _('|' + formataString('SDSubTotal', 93, ' ', 'E', 'N', 'S') + '|')
            linha += formataString(getNumeroEditado(sdsubtotal_quantidade, 3), 27, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(sdsubtotal_quantidade_unidade, 3), 22, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(sdsubtotal_valor, 2), 22, ' ', 'E', 'N',
                                   'S') + '                   |'
            listagem.imprimeLinha(linha)
        if srsubtotal_quantidade or srsubtotal_valor:
            linha = _('|' + formataString('SRSubTotal', 93, ' ', 'E', 'N', 'S') + '|')
            linha += formataString(getNumeroEditado(srsubtotal_quantidade, 3), 27, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(srsubtotal_quantidade_unidade, 3), 22, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(srsubtotal_valor, 2), 22, ' ', 'E', 'N',
                                   'S') + '                   |'
            listagem.imprimeLinha(linha)
        if sisubtotal_quantidade or sisubtotal_valor:
            linha = _('|' + formataString('SISubTotal', 93, ' ', 'E', 'N', 'S') + '|')
            linha += formataString(getNumeroEditado(sisubtotal_quantidade, 3), 27, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(sisubtotal_quantidade_unidade, 3), 22, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(sisubtotal_valor, 2), 22, ' ', 'E', 'N',
                                   'S') + '                   |'
            listagem.imprimeLinha(linha)
        if sssubtotal_quantidade or sssubtotal_valor:
            linha = _('|' + formataString('SSSubTotal', 93, ' ', 'E', 'N', 'S') + '|')
            linha += formataString(getNumeroEditado(sssubtotal_quantidade, 3), 27, ' ', 'E', 'N',
                                   'S')
            linha += formataString(getNumeroEditado(sssubtotal_quantidade_unidade, 3), 22, ' ',
                                   'E', 'N', 'S')
            linha += formataString(getNumeroEditado(sssubtotal_valor, 2), 22, ' ', 'E', 'N',
                                   'S') + '                   |'
            listagem.imprimeLinha(linha)

        listagem.imprimeLinha(
            '|                                                                                                                                                                                        |')
        total_entrada = ensubtotal_valor + etsubtotal_valor + epsubtotal_valor + edsubtotal_valor\
            + ersubtotal_valor + eisubtotal_valor + essubtotal_valor
        total_saida = snsubtotal_valor + stsubtotal_valor + sdsubtotal_valor + srsubtotal_valor \
            + sisubtotal_valor + sssubtotal_valor
        quantidade_total_entrada = ensubtotal_quantidade + etsubtotal_quantidade + \
            epsubtotal_quantidade + edsubtotal_quantidade + ersubtotal_quantidade + \
            eisubtotal_quantidade + essubtotal_quantidade
        quantidade_total_saida = snsubtotal_quantidade + stsubtotal_quantidade + \
            sdsubtotal_quantidade + srsubtotal_quantidade + sisubtotal_quantidade + \
            sssubtotal_quantidade
        quantidade_total_unidade_saida = snsubtotal_quantidade_unidade + \
            sdsubtotal_quantidade_unidade + sisubtotal_quantidade_unidade + \
            srsubtotal_quantidade_unidade + stsubtotal_quantidade_unidade + \
            sssubtotal_quantidade_unidade
        quantidade_total_unidade_entrada = ensubtotal_quantidade_unidade + \
            edsubtotal_quantidade_unidade + eisubtotal_quantidade_unidade + \
            ersubtotal_quantidade_unidade + etsubtotal_quantidade_unidade + \
            epsubtotal_quantidade_unidade + essubtotal_quantidade_unidade
        listagem.imprimeLinha(
            '*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        if total_entrada or quantidade_total_entrada:
            linha = _('|' + formataString('T O T A L   E N T R A D A', 93, ' ', 'C', 'N', 'S') + '|')
            linha += formataString(getNumeroEditado(quantidade_total_entrada, 3), 27, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(quantidade_total_unidade_entrada, 3), 22, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(total_entrada, 2), 22, ' ', 'E', 'N', 'S') + '                   |'
            listagem.imprimeLinha(linha)
        if total_saida or quantidade_total_saida:
            linha = _('|' + formataString('T O T A L   S A I D A', 93, ' ', 'C', 'N', 'S') + '|')
            linha += formataString(getNumeroEditado(quantidade_total_saida, 3), 27, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(quantidade_total_unidade_saida, 3), 22, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(total_saida, 2), 22, ' ', 'E', 'N', 'S') + '                   |'
            listagem.imprimeLinha(linha)
        listagem.imprimeLinha(
            '*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

    @staticmethod
    def get_cm(tipo_movimento, origem, cfop_movimento):
        cm = tipo_movimento or ''
        if cfop_movimento:
            cm += cfop_movimento or '' if cfop_movimento not in 'UC' else 'N'
        cm += origem or '' if len(cm) < 2 and origem != 'U' else 'N' if len(cm) < 2 else ''

        return cm


report_custom('report.listagem_movimento_analitico')


class wizard_listagem_movimento_analitico_osv(osv.TransientModel):
    _name = 'wizard.listagem.movimento.analitico.osv'
    _columns = {
        'company_ids': fields.many2many('res.company', 'estoque_movimento_company', 'id',
                                        'company_id', 'Empresa'),
        'local_ids': fields.many2many('estoque.local', 'estoque_movimento_local', 'id',
                                      'local_id', 'Local'),
        'periodo_inicial': fields.date('Periodo inicial', required=True),
        'periodo_final': fields.date('Periodo final', required=True),
        'ordem': fields.selection([('Doc', 'Documento'), ('Pro', 'Produto'),
                                   ('Cat', 'Categoria'), ('Dat', 'Data'), ('Loc', 'Local'),
                                   ('Cli', 'Fornecedor/Cliente')], 'Ordem'),
        'entradas': fields.boolean('Entradas'),
        'saidas': fields.boolean('Saidas'),
        'normal': fields.boolean('Normal'),
        'transferencias': fields.boolean('Transferencias'),
        'devolucoes': fields.boolean('Devolucoes'),
        'requisicoes': fields.boolean('Requisicoes'),
        'inventario': fields.boolean('Inventario'),
        'produto_id': fields.many2one('estoque.produto', 'Produto'),
        'grade_id': fields.many2one('estoque.produto.grade', 'Grade'),
        'pessoa_id': fields.many2one('adm.pessoa', 'Cliente/Fornecedor'),
        'categoria_id': fields.many2one('estoque.categoria', 'Categoria'),
        'grau_categoria': fields.integer('Grau a listar'),
        'documento': fields.char('Documento', size=10),
        'origem_ids': fields.many2many('estoque.movimento.origem',
                                       'wiz_listagem_mov_ana_m2m_est_mov_origem',
                                       'wiz_mov_analitico_id', 'origem_id',
                                       string='Origem'),

        'fabricante_id': fields.many2one('adm.pessoa', 'Fabricante',
                                         domain="[('pessoa_tipo', '=', 'J')]")
    }
    _defaults = {
        'periodo_inicial': time.strftime('%Y-%m-%d'),
        'periodo_final': time.strftime('%Y-%m-%d'),
        'ordem': 'Pro',
        'entradas': True,
        'saidas': True,
        'normal': True,
        'transferencias': True,
        'devolucoes': True,
        'requisicoes': True,
        'inventario': True,
    }

    def write(self, cr, user, ids, vals, context=None):
        res = super(wizard_listagem_movimento_analitico_osv, self).write(
            cr, SUPERUSER_ID, ids, vals, context)
        return res

    def read(self, cr, uid, ids, fields=None, context=None, load='_classic_read'):
        context = context and context.copy() or {}
        res = super(wizard_listagem_movimento_analitico_osv, self).read(
            cr, SUPERUSER_ID, ids, fields, context, load)
        return res

    def onchange_wzd_list_mov_ana_produto(self, cr, uid, ids, produto_id, context=None):
        context = context and context.copy() or {}
        res = {'value': {}}
        grades_ids = self.pool.get('estoque.produto.grade').search(cr, uid, [('produto_id', '=', produto_id)],
                                                                   context=context)
        if len(grades_ids) == 1:  # se o produto tiver apenas uma grade, retona a grade, se nao, o campo fica vazio
            res['value'] = {'grade_id': grades_ids[0]}
        else:
            res['value'] = {'grade_id': ''}
        return res

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}

        estrutura, dados = self.get_dados_rel(cr, uid, ids, context)
        context['estrutura'] = estrutura
        context['dados'] = dados
        return self.pool.get('wizard.relatorios.impressao').get_tela_relatorios(cr, uid, context)

    def get_dados_rel(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        dados_movimento_analitico = self.get_dados_movimento_analitico(cr, uid, ids, context)
        pagina = {'relpag_nome_rel': _('Listagem de Movimento'),
                  'relpag_tam_linha': 186,
                  'relpag_fonte_tamanho': 7.2,
                  'relpag_margem_esquerda': 0.5,
                  'relpag_margem_direita': 0.5,
                  'relpag_margem_superior': 0.5,
                  'relpag_margem_inferior': 0.5,
                  'relpag_cabecalhos': [{'relcab_name': 'cab1',
                                         'relcab_separa_coluna': '|',
                                         'relcab_colunas': [{'relcol_name': 'contr_estoque',
                                                             'relcol_dados_tam': 62,
                                                             'relcol_dados_alinhamento': 'D'},
                                                            {'relcol_name': 'titulo',
                                                             'relcol_dados_tam': 62,
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_nao_separa_coluna': True},
                                                            {'relcol_name': 'est',
                                                             'relcol_dados_tam': 58,
                                                             'relcol_dados_alinhamento': 'E',
                                                             'relcol_nao_separa_coluna': True}]},
                                        {'relcab_name': 'cab2',
                                         'relcab_separa_coluna': '|',
                                         'relcab_colunas': [{'relcol_name': 'data',
                                                             'relcol_dados_tam': 62,
                                                             'relcol_dados_alinhamento': 'D'},
                                                            {'relcol_name': 'empresa',
                                                             'relcol_dados_tam': 62,
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_nao_separa_coluna': True},
                                                            {'relcol_name': 'pagina',
                                                             'relcol_dados_tam': 54,
                                                             'relcol_dados_alinhamento': 'E',
                                                             'relcol_nao_separa_coluna': True}]
                                         },
                                        {'relcab_name': 'cab3',
                                         'relcab_separa_coluna': '|',
                                         'relcab_colunas': [{'relcol_name': 'periodo',
                                                             'relcol_dados_tam': 184,
                                                             'relcol_dados_alinhamento': 'D'}]},
                                        {'relcab_name': 'cab4',
                                         'relcab_separa_coluna': '|',
                                         'relcab_colunas': [{'relcol_name': 'locais',
                                                             'relcol_dados_tam': 184,
                                                             'relcol_dados_alinhamento': 'D'}]
                                         },
                                        {'relcab_name': 'cab5',
                                         'relcab_separa_coluna': '|',
                                         'relcab_divide_linha': True,
                                         'relcab_colunas': [{'relcol_name': 'empresas',
                                                             'relcol_dados_tam': 184,
                                                             'relcol_dados_alinhamento': 'D'}]
                                         },
                                        {'relcab_name': 'cabcol1',
                                         'relcab_separa_coluna': '|',
                                         'relcab_divide_linha': True,
                                         'relcab_cor': 'Blue',
                                         'relcab_colunas': [{'relcol_name': 'col1',
                                                             'relcol_dados_alinhamento': 'E',
                                                             'relcol_dados_tam': 4},
                                                            {'relcol_name': 'col2',
                                                             'relcol_dados_alinhamento': 'D',
                                                             'relcol_dados_tam': 2},
                                                            {'relcol_name': 'col3',
                                                             'relcol_dados_alinhamento': 'E',
                                                             'relcol_dados_tam': 2},
                                                            {'relcol_name': 'col4',
                                                             'relcol_dados_alinhamento': 'E',
                                                             'relcol_dados_tam': 15},
                                                            {'relcol_name': 'col5',
                                                             'relcol_dados_alinhamento': 'D',
                                                             'relcol_dados_tam': 2},
                                                            {'relcol_name': 'col6',
                                                             'relcol_dados_alinhamento': 'D',
                                                             'relcol_dados_tam': 42},
                                                            {'relcol_name': 'col7',
                                                             'relcol_dados_alinhamento': 'E',
                                                             'relcol_dados_tam': 5},
                                                            {'relcol_name': 'col8',
                                                             'relcol_dados_alinhamento': 'E',
                                                             'relcol_dados_tam': 10},
                                                            {'relcol_name': 'col9',
                                                             'relcol_dados_alinhamento': 'D',
                                                             'relcol_dados_tam': 3},
                                                            {'relcol_name': 'col10',
                                                             'relcol_dados_alinhamento': 'D',
                                                             'relcol_dados_tam': 16},
                                                            {'relcol_name': 'col11',
                                                             'relcol_dados_alinhamento': 'E',
                                                             'relcol_dados_tam': 10},
                                                            {'relcol_name': 'col12',
                                                             'relcol_dados_alinhamento': 'D',
                                                             'relcol_dados_tam': 3},
                                                            {'relcol_name': 'col13',
                                                             'relcol_dados_alinhamento': 'E',
                                                             'relcol_dados_tam': 8},
                                                            {'relcol_name': 'col14',
                                                             'relcol_dados_alinhamento': 'E',
                                                             'relcol_dados_tam': 8},
                                                            {'relcol_name': 'col15',
                                                             'relcol_dados_alinhamento': 'E',
                                                             'relcol_dados_tam': 10},
                                                            {'relcol_name': 'col16',
                                                             'relcol_dados_alinhamento': 'E',
                                                             'relcol_dados_tam': 10},
                                                            {'relcol_name': 'col17',
                                                             'relcol_dados_alinhamento': 'E',
                                                             'relcol_dados_tam': 8},
                                                            {'relcol_name': 'col18',
                                                             'relcol_dados_alinhamento': 'E',
                                                             'relcol_dados_tam': 9}]
                                         },
                                        ],
                  'relpag_linhas': [{'rellin_name': 'linha1',
                                     'rellin_separa_coluna': '|',
                                     'rellin_colunas': [{'relcol_name': 'sequencia',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 4},
                                                        {'relcol_name': 'cm',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 2},
                                                        {'relcol_name': 'local',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 2},
                                                        {'relcol_name': 'codigo_item',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 15},
                                                        {'relcol_name': 'grade',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 2},
                                                        {'relcol_name': 'descricao',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 42},
                                                        {'relcol_name': 'cliente_fornecedor',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 5},
                                                        {'relcol_name': 'data',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 10},
                                                        {'relcol_name': 'serie',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 3},
                                                        {'relcol_name': 'documento',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 16},
                                                        {'relcol_name': 'quantidade',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 10},
                                                        {'relcol_name': 'unidade',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 3},
                                                        {'relcol_name': 'qtd_embagagem',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 8},
                                                        {'relcol_name': 'qtd_unidade',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 8},
                                                        {'relcol_name': 'vr_unitario',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 10},
                                                        {'relcol_name': 'vr_total',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 10},
                                                        {'relcol_name': 'ipi',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 8},
                                                        {'relcol_name': 'aliq_ipi',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 9}]
                                     },
                                    {'rellin_name': 'linha_total',
                                     # 'rellin_divide_linha': True,
                                     'rellin_colunas': [{'relcol_name': 'sequencia',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 5},
                                                        {'relcol_name': 'cm',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 3},
                                                        {'relcol_name': 'local',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 3},
                                                        {'relcol_name': 'codigo_item',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 16},
                                                        {'relcol_name': 'grade',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 3},
                                                        {'relcol_name': 'descricao',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 43},
                                                        {'relcol_name': 'cliente_fornecedor',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 6},
                                                        {'relcol_name': 'data',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 11},
                                                        {'relcol_name': 'serie',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 4},
                                                        {'relcol_name': 'documento',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 17},
                                                        {'relcol_name': 'quantidade',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 11},
                                                        {'relcol_name': 'unidade',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 4},
                                                        {'relcol_name': 'qtd_embagagem',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 9},
                                                        {'relcol_name': 'qtd_unidade',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 9},
                                                        {'relcol_name': 'vr_unitario',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 11},
                                                        {'relcol_name': 'vr_total',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 11},
                                                        {'relcol_name': 'ipi',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 9},
                                                        {'relcol_name': 'aliq_ipi',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 9}]
                                     },
                                    {'rellin_name': 'linha5',
                                     'rellin_separa_coluna': '|',
                                     'rellin_colunas': [{'relcol_name': 'ordem_filtro',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 184}]
                                     }
                                    ]
                  }

        obj_estoque_local = self.pool.get('estoque.local')

        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'wizard.listagem.movimento.analitico.osv', context=context)
        res_company_dados = self.pool.get('res.company').read(cr, uid, company_id, ['name'],
                                                              context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        company_ids = dados_movimento_analitico.get('company_ids')
        empresas = self.pool.get('res.company').browse(cr, uid, company_ids)
        local_ids = dados_movimento_analitico.get('local_ids')
        locais = obj_estoque_local.browse(cr, uid, local_ids)
        periodo_inicial = dados_movimento_analitico.get('periodo_inicial')
        periodo_final = dados_movimento_analitico.get('periodo_final')
        ordem = dados_movimento_analitico.get('ordem')
        ordem_imprimir = _('ORDEM POR ')
        if ordem == 'Doc':
            ordem_imprimir += _('DOCUMENTO')
        elif ordem == 'Pro':
            ordem_imprimir += _('PRODUTO')
        elif ordem == 'Cat':
            ordem_imprimir += _('CATEGORIA')
        elif ordem == 'Dat':
            ordem_imprimir += _('DATA')
        elif ordem == 'Loc':
            ordem_imprimir += _('LOCAL')
        elif ordem == 'Cli':
            ordem_imprimir += _('FORNECEDOR/CLIENTE')
        else:
            ordem_imprimir = _('NENHUMA ORDEM')

        tam = 0
        cont = 0
        local_names = [[]]
        for local in locais:
            if tam + len(", %s" % local.name) >= 175:
                local_names[cont][-1] = '%s,' % local_names[cont][-1]
                local_names.append([])
                cont += 1
                tam = 0

            local_names[cont].append(local.name)
            tam += len(local.name) + 2

        empresa_names = []
        cont_linha = 0
        for empresa in empresas:
            if not empresa_names:
                empresa_names.append(empresa.name)
                continue

            empresa_names[cont_linha] += ', '

            if len(empresa_names[cont_linha] + empresa.name) >= 173 and not cont_linha:
                cont_linha += 1
                empresa_names.append(empresa.name)
                continue

            if len(empresa_names[cont_linha] + empresa.name) >= 184:
                cont_linha += 1
                empresa_names.append(empresa.name)
                continue

            empresa_names[cont_linha] += empresa.name

        periodo = _('|Periodo: ') + time.strftime(
            "%d/%m/%Y", time.strptime(periodo_inicial, "%Y-%m-%d")) + ' a ' + time.strftime(
            "%d/%m/%Y", time.strptime(periodo_final, "%Y-%m-%d")) + '   ' + ordem_imprimir
        locais = ''
        for i in local_names:
            locais += ', '.join(i)

        empresas = ''
        for nome in empresa_names:
            empresas += ', ' + nome

        dados = {'cab1': {'contr_estoque': 'Contr. Estoque',
                          'titulo': 'Listagem de movimento',
                          'est': 'est310'},
                 'cab2': {'data': data,
                          'empresa': nome_empresa,
                          'pagina': '|pag|'},
                 'cab3': {'periodo': 'Periodo: ' + periodo},
                 'cab4': {'locais': 'Locais: ' + locais},
                 'cab5': {'empresas': 'Empresas: ' + empresas},
                 'cabcol1': {'col1': 'Sq',
                             'col2': 'CM',
                             'col3': 'LC',
                             'col4': 'Cod. do Item',
                             'col5': 'GR',
                             'col6': 'DESCRICAO',
                             'col7': 'CL/FO',
                             'col8': 'DATA',
                             'col9': 'SER',
                             'col10': 'DOCUMENTO',
                             'col11': 'QUANTIDADE',
                             'col12': 'UNI',
                             'col13': 'QTD.EMB.',
                             'col14': 'QTD.UND.',
                             'col15': 'VR.UNITAR.',
                             'col16': 'VR.TOTAL',
                             'col17': 'IPI',
                             'col18': 'ALQ.IPI'}
                 }
        dados['linhas'] = self.get_linha_dados(cr, uid, ids, dados_movimento_analitico,
                                               context) or []
        return pagina, dados

    def get_linha_dados(self, cr, uid, ids, dados_movimento_analitico, context=None):
        context = context and context.copy() or {}
        ordem = dados_movimento_analitico.get('ordem')
        dados = dados_movimento_analitico.get('dados')
        linhas = []

        ensubtotal_valor = 0.0
        etsubtotal_valor = 0.0
        epsubtotal_valor = 0.0
        edsubtotal_valor = 0.0
        ersubtotal_valor = 0.0
        eisubtotal_valor = 0.0
        essubtotal_valor = 0.0
        snsubtotal_valor = 0.0
        stsubtotal_valor = 0.0
        sdsubtotal_valor = 0.0
        srsubtotal_valor = 0.0
        sisubtotal_valor = 0.0
        sssubtotal_valor = 0.0
        ensubtotal_quantidade = 0.0
        ensubtotal_quantidade_unidade = 0.0
        etsubtotal_quantidade = 0.0
        etsubtotal_quantidade_unidade = 0.0
        epsubtotal_quantidade = 0.0
        epsubtotal_quantidade_unidade = 0.0
        edsubtotal_quantidade = 0.0
        edsubtotal_quantidade_unidade = 0.0
        ersubtotal_quantidade = 0.0
        ersubtotal_quantidade_unidade = 0.0
        eisubtotal_quantidade = 0.0
        eisubtotal_quantidade_unidade = 0.0
        essubtotal_quantidade = 0.0
        essubtotal_quantidade_unidade = 0.0
        snsubtotal_quantidade = 0.0
        snsubtotal_quantidade_unidade = 0.0
        stsubtotal_quantidade = 0.0
        stsubtotal_quantidade_unidade = 0.0
        sdsubtotal_quantidade = 0.0
        sdsubtotal_quantidade_unidade = 0.0
        srsubtotal_quantidade = 0.0
        srsubtotal_quantidade_unidade = 0.0
        sisubtotal_quantidade = 0.0
        sisubtotal_quantidade_unidade = 0.0
        sssubtotal_quantidade = 0.0
        sssubtotal_quantidade_unidade = 0.0

        quantidade_parcial = 0.0
        quantidade_unidade_parcial = 0.0
        total_ipi = 0.0
        total_parcial = 0.0

        contador = 1
        if ordem == 'Doc':
            documento_aux = dados[0].get('nf_capa_id')
            if not documento_aux:
                documento_aux = dados[0].get('cupons_capa_id')
            if not documento_aux:
                documento_aux = dados[0].get('requisicao_ressuprimento_id')
            if not documento_aux:
                documento_aux = dados[0].get('requisicao_id')
            if not documento_aux:
                documento_aux = dados[0].get('data')
        elif ordem == 'Pro':
            documento_aux = dados[0].get('produto_id')
        elif ordem == 'Cat':
            documento_aux = dados[0].get('categoria_id')
            categoria_id = documento_aux
        elif ordem == 'Cli':
            documento_aux = dados[0].get('pessoa_id')
            pessoa_id = documento_aux
        elif ordem == 'Loc':
            documento_aux = dados[0].get('local_id')
        else:
            documento_aux = dados[0].get('data')
        count = 0
        ecf_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(
            cr, uid, 'ecf',
            context)
        coo_dados = map(lambda z: {z.get('coo'): z}, dados)
        aux = {}
        for i in coo_dados:
            for j in i:
                aux[j] = i.get(j)
        coo_dados = aux
        madeireira_instalado = self.pool.get(
            'adm.utils').admutl_check_modulo_instalado(
            cr, uid, 'madeireira', context)
        for i in dados:
            if ecf_instalado:
                if i.get('coo'):
                    if i.get('coo') + 1 in coo_dados and coo_dados.get(i.get('coo') + 1).get(
                            'tipo_cupom') == 'C':
                        continue
                if i.get('tipo_cupom') == 'C':
                    continue
            count += 1
            numero_documento_aux = i.get('numero_documento')
            if not numero_documento_aux:
                numero_documento = ''
            else:

                if numero_documento_aux.find(':') != -1:
                    copiar = False
                    numero_documento = ''
                    for x in numero_documento_aux:
                        if x == ':':
                            copiar = True
                            continue
                        if copiar:
                            numero_documento += x
                else:
                    numero_documento = numero_documento_aux

            if i.get('nf_capa_id'):
                tipo_doc = 'nf_capa_id'

            if i.get('cupons_capa_id'):
                tipo_doc = 'cupons_capa_id'

            if i.get('requisicao_id'):
                tipo_doc = 'requisicao_id'

            if i.get('requisicaoressuprimento_id'):
                tipo_doc = 'requisicaoressuprimento_id'

            if i.get('inventario_id'):
                tipo_doc = 'inventario_id'

            descr_subtotal = ''
            if (ordem == 'Doc' and documento_aux != i.get(tipo_doc) and quantidade_parcial):
                descr_subtotal = 'T O T A L   P O R   D O C U M E N T O'
                documento_aux = i.get(tipo_doc)

            elif ordem == 'Pro' and documento_aux != i.get('produto_id') and quantidade_parcial:
                descr_subtotal = 'T O T A L   D O   P R O D U T O'
                documento_aux = i.get('produto_id')

            elif ordem == 'Cat' and documento_aux != i.get('categoria_id') and quantidade_parcial:
                descr_subtotal = 'T O T A L   D A   C A T E G O R I A'
                documento_aux = i.get('categoria_id')

            elif ordem == 'Dat' and documento_aux != i.get('data') and quantidade_parcial:
                descr_subtotal = 'T O T A L   P O R   D A T A'
                documento_aux = i.get('data')

            elif ordem == 'Cli' and documento_aux != i.get('pessoa_id') and quantidade_parcial:
                descr_subtotal = 'T O T A L   P O R   F O R N E C E D O R / C L I E N T E'
                documento_aux = i.get('pessoa_id')

            elif ordem == 'Loc' and documento_aux != i.get('local_id') and quantidade_parcial:
                descr_subtotal = 'T O T A L   P O R   L O C A L: %s' % i.get('local_nome')
                documento_aux = i.get('local_id')

            if descr_subtotal:
                linhas.append({'linha1': {
                    'descricao': descr_subtotal,
                    'quantidade': getNumeroEditado(quantidade_parcial, 3),
                    'qtd_unidade': getNumeroEditado(quantidade_unidade_parcial, 3),
                    'vr_total': getNumeroEditado(total_parcial, 2),
                    'ipi': getNumeroEditado(total_ipi, 2)
                }})

                contador = 1
                total_parcial = 0.0
                quantidade_parcial = 0.0
                quantidade_unidade_parcial = 0.0
                total_ipi = 0.0
            quantidade_embalagem = 0
            quantidade = 0
            vr_unitario = 0
            unidade = ''
            if i.get('produto_embalagem_id'):
                cr.execute('''SELECT ee.quantidade_na_embalagem,
                                             eeu.unidade
                                      FROM estoque_embalagem               AS ee
                                      INNER JOIN estoque_produto_embalagem AS epe ON epe.embalagem_id = ee.id
                                      INNER JOIN estoque_embalagem_unidade AS eeu ON eeu.id = ee.unidade_id
                                      WHERE epe.id = %s
                                   ''' % i.get('produto_embalagem_id'))
                dados_embalagem = cr.dictfetchall()
                if dados_embalagem:
                    quantidade_embalagem = dados_embalagem[0].get('quantidade_na_embalagem')
                    unidade = dados_embalagem[0].get('unidade')

                if quantidade_embalagem:
                    if i.get('tipo_movimento') == 'S' and madeireira_instalado and i.get('volume'):
                        quantidade = i.get('volume') or 0.0
                    else:
                        quantidade = i.get('quantidade') or 0.0

                    if quantidade:
                        quantidade /= quantidade_embalagem

                vr_unitario = i.get('vr_unitario') or 0.0
            quantidade_unidade = quantidade * quantidade_embalagem
            cm = self.get_cm(i.get('tipo_movimento'), i.get('origem'), i.get('cfop_movimento'))

            valor_total = (i.get('vr_total_item') or 0.0) + (i.get('vr_icms_st') or 0.0)
            produto_id = i.get('produto_id')

            cr.execute('''SELECT aliquota
                                  FROM fiscal_tributacao                AS ft
                                  INNER JOIN fiscal_tributacao_encargos AS fte ON fte.tributacao_id = ft.id
                                  INNER JOIN fiscal_encargo             AS fe  ON fe.id = fte.encargo_id
                                  WHERE fte.produto_id = %s
                                    AND fe.sigla = 'IPI' ''' % produto_id)
            dados_aliquota = cr.dictfetchall()
            aliquota = 0
            if dados_aliquota:
                aliquota = dados_aliquota[0].get('aliquota') or 0.0

            calculo_ipi = i.get('vr_ipi') or 0.0
            valor_total += calculo_ipi

            if ordem == 'Cat':
                categoria = self.pool.get('estoque.produto').browse(
                    cr, uid, produto_id).categoria_id
                if not i.get('categoria_id') == categoria_id or dados.index(i) == 0:
                    categoria_id = i.get('categoria_id')
                    categoria_name = "SEM CATEGORIA"
                    if categoria:
                        categoria_name = categoria.nome_completo
                    linhas.append({'linha5': {}})
                    categoria_nome = 'Categoria: ' + categoria_name
                    while len(categoria_nome) < 185:
                        categoria_nome += ' '
                    linhas.append({'linha5': {'ordem_filtro': categoria_nome}})
                    linhas.append({'linha5': {}})
            elif ordem == 'Cli':
                if not i.get('pessoa_id') == pessoa_id or dados.index(i) == 0:
                    pessoa_id = i.get('pessoa_id')
                    pessoa_name = "SEM CLIENTE/FORNECEDOR"
                    if i.get('pessoa_nome'):
                        pessoa_name = i.get('pessoa_nome').replace('\t', '')
                    linhas.append({'linha5': {}})
                    pessoa_name = 'Cliente/Fornecedor: ' + pessoa_name
                    if len(pessoa_name) < 185:
                        dif = 185 - len(pessoa_name)
                        pessoa_name += ' ' * dif
                    linhas.append({'linha5': {'ordem_filtro': pessoa_name}})
                    linhas.append({'linha5': {}})

            data = time.strftime("%d/%m/%Y", time.strptime(i.get('data'), "%Y-%m-%d"))

            linhas.append({'linha1': {'sequencia': contador,
                                      'cm': cm,
                                      'local': i.get('local_numero'),
                                      'codigo_item': i.get('produto_codigo'),
                                      'grade': i.get('grade_grade') or '',
                                      'descricao': i.get('grade_name') or '',
                                      'cliente_fornecedor': i.get('pessoa_codigo') or '',
                                      'data': data,
                                      'serie': i.get('serie_nf') or '',
                                      'documento': numero_documento,
                                      'quantidade': getNumeroEditado(quantidade, 3),
                                      'unidade': unidade,
                                      'qtd_embalagem': getNumeroEditado(quantidade_embalagem, 3),
                                      'qtd_unidade': getNumeroEditado(quantidade_unidade, 3),
                                      'vr_unitario': getNumeroEditado(vr_unitario, 2),
                                      'vr_total': getNumeroEditado(valor_total, 2),
                                      'ipi': getNumeroEditado(calculo_ipi, 2),
                                      'aliq_ipi': getNumeroEditado(aliquota, 2)}})

            quantidade_parcial += quantidade
            quantidade_unidade_parcial += quantidade_unidade
            total_parcial += valor_total
            total_ipi += calculo_ipi
            if cm == 'EN':
                ensubtotal_valor += valor_total
                ensubtotal_quantidade += quantidade
                ensubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'ET':
                etsubtotal_valor += valor_total
                etsubtotal_quantidade += quantidade
                etsubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'EP':
                epsubtotal_valor += valor_total
                epsubtotal_quantidade += quantidade
                epsubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'ED':
                edsubtotal_valor += valor_total
                edsubtotal_quantidade += quantidade
                edsubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'ER':
                ersubtotal_valor += valor_total
                ersubtotal_quantidade += quantidade
                ersubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'EI':
                eisubtotal_valor += valor_total
                eisubtotal_quantidade += quantidade
                eisubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'ES':
                essubtotal_valor += valor_total
                essubtotal_quantidade += quantidade
                essubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'SN':
                snsubtotal_valor += valor_total
                snsubtotal_quantidade += quantidade
                snsubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'ST':
                stsubtotal_valor += valor_total
                stsubtotal_quantidade += quantidade
                stsubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'SD':
                sdsubtotal_valor += valor_total
                sdsubtotal_quantidade += quantidade
                sdsubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'SR':
                srsubtotal_valor += valor_total
                srsubtotal_quantidade += quantidade
                srsubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'SI':
                sisubtotal_valor += valor_total
                sisubtotal_quantidade += quantidade
                sisubtotal_quantidade_unidade += quantidade_unidade
            elif cm == 'SS':
                sssubtotal_valor += valor_total
                sssubtotal_quantidade += quantidade
                sssubtotal_quantidade_unidade += quantidade_unidade

            contador += 1

        descr_subtotal = ''
        if ordem == 'Doc':
            descr_subtotal = 'T O T A L   D A   N O T A'

        elif ordem == 'Pro':
            descr_subtotal = 'T O T A L   D O   P R O D U T O'

        elif ordem == 'Cat':
            descr_subtotal = 'T O T A L   D A   C A T E G O R I A'

        elif ordem == 'Dat':
            descr_subtotal = 'T O T A L   P O R   D A T A'

        elif ordem == 'Cli':
            descr_subtotal = 'T O T A L   P O R   F O R N E C E D O R / C L I E N T E'
        elif ordem == 'Loc':
            descr_subtotal = 'T O T A L   P O R   L O C A L: %s' % i.get('local_nome')

        if descr_subtotal:
            linhas.append({'linha1': {
                'descricao': descr_subtotal,
                'quantidade': getNumeroEditado(quantidade_parcial, 3),
                'qtd_unidade': getNumeroEditado(quantidade_unidade_parcial, 3),
                'vr_total': getNumeroEditado(total_parcial, 2),
                'ipi': getNumeroEditado(total_ipi, 2)
            }})
        linhas.append({'linha1': {}})

        if ensubtotal_quantidade or ensubtotal_valor:
            linhas.append({'linha1': {
                'descricao': 'ENSubTotal',
                'quantidade': getNumeroEditado(ensubtotal_quantidade, 3),
                'qtd_unidade': getNumeroEditado(ensubtotal_quantidade_unidade, 3),
                'vr_total': getNumeroEditado(ensubtotal_valor, 2)
            }})
        if etsubtotal_quantidade or etsubtotal_valor:
            linhas.append({'linha1': {
                'descricao': 'ETSubTotal',
                'quantidade': getNumeroEditado(etsubtotal_quantidade, 3),
                'qtd_unidade': getNumeroEditado(etsubtotal_quantidade_unidade, 3),
                'vr_total': getNumeroEditado(etsubtotal_valor, 2)
            }})
        if epsubtotal_quantidade or epsubtotal_valor:
            linhas.append({'linha1': {
                'descricao': 'EPSubTotal',
                'quantidade': getNumeroEditado(epsubtotal_quantidade, 3),
                'qtd_unidade': getNumeroEditado(epsubtotal_quantidade_unidade, 3),
                'vr_total': getNumeroEditado(epsubtotal_valor, 2)
            }})
        if edsubtotal_quantidade or edsubtotal_valor:
            linhas.append({'linha1': {
                'descricao': 'EDSubTotal',
                'quantidade': getNumeroEditado(edsubtotal_quantidade, 3),
                'qtd_unidade': getNumeroEditado(edsubtotal_quantidade_unidade, 3),
                'vr_total': getNumeroEditado(edsubtotal_valor, 2)
            }})
        if ersubtotal_quantidade or ersubtotal_valor:
            linhas.append({'linha1': {
                'descricao': 'ERSubTotal',
                'quantidade': getNumeroEditado(ersubtotal_quantidade, 3),
                'qtd_unidade': getNumeroEditado(ersubtotal_quantidade_unidade, 3),
                'vr_total': getNumeroEditado(ersubtotal_valor, 2)
            }})
        if eisubtotal_quantidade or eisubtotal_valor:
            linhas.append({'linha1': {
                'descricao': 'EISubTotal',
                'quantidade': getNumeroEditado(eisubtotal_quantidade, 3),
                'qtd_unidade': getNumeroEditado(eisubtotal_quantidade_unidade, 3),
                'vr_total': getNumeroEditado(eisubtotal_valor, 2)
            }})
        if essubtotal_quantidade or essubtotal_valor:
            linhas.append({'linha1': {
                'descricao': 'ESSubTotal',
                'quantidade': getNumeroEditado(essubtotal_quantidade, 3),
                'qtd_unidade': getNumeroEditado(essubtotal_quantidade_unidade, 3),
                'vr_total': getNumeroEditado(essubtotal_valor, 2)
            }})
        if snsubtotal_quantidade or snsubtotal_valor:
            linhas.append({'linha1': {
                'descricao': 'SNSubTotal',
                'quantidade': getNumeroEditado(snsubtotal_quantidade, 3),
                'qtd_unidade': getNumeroEditado(snsubtotal_quantidade_unidade, 3),
                'vr_total': getNumeroEditado(snsubtotal_valor, 2)
            }})
        if stsubtotal_quantidade or stsubtotal_valor:
            linhas.append({'linha1': {
                'descricao': 'STSubTotal',
                'quantidade': getNumeroEditado(stsubtotal_quantidade, 3),
                'qtd_unidade': getNumeroEditado(stsubtotal_quantidade_unidade, 3),
                'vr_total': getNumeroEditado(stsubtotal_valor, 2)
            }})
        if sdsubtotal_quantidade or sdsubtotal_valor:
            linhas.append({'linha1': {
                'descricao': 'SDSubTotal',
                'quantidade': getNumeroEditado(sdsubtotal_quantidade, 3),
                'qtd_unidade': getNumeroEditado(sdsubtotal_quantidade_unidade, 3),
                'vr_total': getNumeroEditado(sdsubtotal_valor, 2)
            }})
        if srsubtotal_quantidade or srsubtotal_valor:
            linhas.append({'linha1': {
                'descricao': 'SRSubTotal',
                'quantidade': getNumeroEditado(srsubtotal_quantidade, 3),
                'qtd_unidade': getNumeroEditado(srsubtotal_quantidade_unidade, 3),
                'vr_total': getNumeroEditado(srsubtotal_valor, 2)
            }})
        if sisubtotal_quantidade or sisubtotal_valor:
            linhas.append({'linha1': {
                'descricao': 'SISubTotal',
                'quantidade': getNumeroEditado(sisubtotal_quantidade, 3),
                'qtd_unidade': getNumeroEditado(sisubtotal_quantidade_unidade, 3),
                'vr_total': getNumeroEditado(sisubtotal_valor, 2)
            }})
        if sssubtotal_quantidade or sssubtotal_valor:
            linhas.append({'linha1': {
                'descricao': 'SSSubTotal',
                'quantidade': getNumeroEditado(sssubtotal_quantidade, 3),
                'qtd_unidade': getNumeroEditado(sssubtotal_quantidade_unidade, 3),
                'vr_total': getNumeroEditado(sssubtotal_valor, 2)
            }})

        linhas.append({'linha1': {}})

        total_entrada = ensubtotal_valor + etsubtotal_valor + epsubtotal_valor + edsubtotal_valor \
                        + ersubtotal_valor + eisubtotal_valor + essubtotal_valor
        total_saida = snsubtotal_valor + stsubtotal_valor + sdsubtotal_valor + srsubtotal_valor \
                      + sisubtotal_valor + sssubtotal_valor
        quantidade_total_entrada = ensubtotal_quantidade + etsubtotal_quantidade + \
                                   epsubtotal_quantidade + edsubtotal_quantidade + ersubtotal_quantidade + \
                                   eisubtotal_quantidade + essubtotal_quantidade
        quantidade_total_saida = snsubtotal_quantidade + stsubtotal_quantidade + \
                                 sdsubtotal_quantidade + srsubtotal_quantidade + sisubtotal_quantidade + \
                                 sssubtotal_quantidade
        quantidade_total_unidade_saida = snsubtotal_quantidade_unidade + \
                                         sdsubtotal_quantidade_unidade + sisubtotal_quantidade_unidade + \
                                         srsubtotal_quantidade_unidade + stsubtotal_quantidade_unidade + \
                                         sssubtotal_quantidade_unidade
        quantidade_total_unidade_entrada = ensubtotal_quantidade_unidade + \
                                           edsubtotal_quantidade_unidade + eisubtotal_quantidade_unidade + \
                                           ersubtotal_quantidade_unidade + etsubtotal_quantidade_unidade + \
                                           epsubtotal_quantidade_unidade + essubtotal_quantidade_unidade

        if total_entrada or quantidade_total_entrada:
            linhas.append({'linha_total': {
                'descricao': 'T O T A L   E N T R A D A',
                'quantidade': getNumeroEditado(quantidade_total_entrada, 3),
                'qtd_unidade': getNumeroEditado(quantidade_total_unidade_entrada, 3),
                'vr_total': getNumeroEditado(total_entrada, 2)
            }})
        if total_saida or quantidade_total_saida:
            linhas.append({'linha_total': {
                'descricao': 'T O T A L   S A I D A',
                'quantidade': getNumeroEditado(quantidade_total_saida, 3),
                'qtd_unidade': getNumeroEditado(quantidade_total_unidade_saida, 3),
                'vr_total': getNumeroEditado(total_saida, 2)
            }})
        return linhas

    def get_dados_movimento_analitico(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        brw_mov_analitico = self.browse(cr, uid, ids[0], context=context)
        if brw_mov_analitico.periodo_inicial > brw_mov_analitico.periodo_final:
            raise osv.except_osv(_('Atencao'), _('Data inicial nao pode ser maior que a data '
                                                 'final'))
        
        movimento_list = list()
        obj_res_company = pooler.get_pool(cr.dbname).get('res.company')
        company_ids = map(lambda i: i.id, brw_mov_analitico.company_ids)
        local_ids = map(lambda i: i.id, brw_mov_analitico.local_ids)
        if not company_ids:
            company_ids = obj_res_company.search(cr, uid, [], context=context)
        else:
            child_company_ids = []
            for c in company_ids:
                child_company_ids += obj_res_company.search(cr, uid, [('parent_id', 'child_of', c)],
                                                            context=context)
            company_ids = list(set(child_company_ids))
        str_company_ids = ', '.join(map(lambda c: str(c), company_ids))

        if not local_ids:
            context.update({'sig_force_company': True})
            local_ids = self.pool.get('estoque.local').search(
                cr, uid, [('company_id', 'in', company_ids)], context=context)

        cond_origem = ''
        grade_ids = self.pool.get('estoque.produto.grade').search(cr, uid, [('name', '=', False)], context=context)
        if grade_ids:  # se houver grade sem 'name' grava automaticamente o 'name'
            self.pool.get('estoque.produto.grade').write(cr, uid, grade_ids, {}, context=context)
            
        origem_ids = map(lambda i: i.id, brw_mov_analitico.origem_ids)
        if origem_ids:
            cond_origem += """AND emo.id IN %s""" % str(origem_ids).replace('[', '(').replace(']', ')')
            
        obj_estoque_produto = self.pool.get('estoque.produto')
        obj_adm_utils = self.pool.get('adm.utils')

        cond_modelo_nf = ''
        if brw_mov_analitico.modelo_nf_id:
            cond_modelo_nf = """ AND (fnc.modelo_nf_id = %s OR fnc.modelo_nf_series_id =
            %s)""" % (brw_mov_analitico.modelo_nf_id.id, brw_mov_analitico.modelo_nf_id.id)

        cond_inventario = ''
        if brw_mov_analitico.inventario and not brw_mov_analitico.documento:
            movimento_list.append('inventario')
            cond_inventario = """
                AND emc.inventario_id IS NOT NULL
            """

        filtro_cfop_ids = map(lambda i: i.id, brw_mov_analitico.cfop_ids)

        ecf_instalado = obj_adm_utils.admutl_check_modulo_instalado(cr, uid, 'ecf', context)
        estoquealmoxarifado_instalado = obj_adm_utils.admutl_check_modulo_instalado(
            cr, uid, 'estoquealmoxarifado', context)
        estoqueressuprimento_instalado = obj_adm_utils.admutl_check_modulo_instalado(
            cr, uid, 'estoqueressuprimento', context)
        madeireira_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(
            cr, uid, 'madeireira', context
        )
        campo_volume = ''
        if madeireira_instalado:
            campo_volume += 'mov_item.estmvi_volume         AS volume,'
        
        campo_cupom_capa_id = ''               
        campo_tipo_cupom_coo = ''
        left_join_ecf = ''
        cond_item_cancelado = ''
        coo = ''
        if ecf_instalado:
            campo_cupom_capa_id += '''emc.cupons_capa_id 	           AS cupons_capa_id, '''
            campo_tipo_cupom_coo += '''ecc.tipo_cupom,
                   ecc.coo,'''
            left_join_ecf += '''LEFT JOIN ecf_cupons_capa            AS ecc ON ecc.id = mov_item.cupom_id '''
            cond_item_cancelado += '''AND not ((mov_item.item_cancelado is True AND  ecc.tipo_cupom = 'V')'''
            coo = ''', ecc.coo, ecc.id '''
            
        campo_requisicao_id = ''
        if estoquealmoxarifado_instalado:
            campo_requisicao_id += """emc.requisicao_id  	           AS requisicao_id, """
            
        campo_requisicaoressuprimento_id = ''
        if estoqueressuprimento_instalado:
            campo_requisicaoressuprimento_id += '''emc.requisicaoressuprimento_id AS requisicaoressuprimento_id,'''

        cr.execute('''SELECT id FROM fiscal_encargo WHERE sigla = 'ICMS' ''')
        encargo_icms_id = ','.join(map(lambda brw_mov_analitico: str(brw_mov_analitico.get('id')), cr.dictfetchall() ))
        cr.execute('''SELECT id FROM fiscal_encargo WHERE sigla = 'IPI' ''')
        encargo_ipi_id = ','.join(map(lambda brw_mov_analitico: str(brw_mov_analitico.get('id')), cr.dictfetchall() ))

        tipo_movimento = []
        cond_numero_documento = ''
        cond_estmvc_operacao_id = ''
        cond_pessoa_id = ''
        cond_local_id = ''
        cond_grade_id = ''
        cond_produto_id = ''
        if brw_mov_analitico.documento:
            if brw_mov_analitico.documento.find('/') >= 0 and brw_mov_analitico.documento.find(' / ') == -1:
                documento = ''
                inserir_espaco = False
                for i in brw_mov_analitico.documento:
                    if i == '/':
                        documento += ' '
                        inserir_espaco = True
                    documento += i

                    if inserir_espaco:
                        documento += ' '
                        inserir_espaco = False

            else:
                documento = brw_mov_analitico.documento

            cond_numero_documento += """AND emc.numero_documento LIKE '%s'""" % \
                                     ('% ' + documento + '%')

        else:
            tipo_operacao = []
            if brw_mov_analitico.entradas:
                tipo_operacao.append('E')

            if brw_mov_analitico.saidas:
                tipo_operacao.append('S')

            if tipo_operacao:
                natureza_operacao_ids = self.pool.get('estoque.natureza.operacao').search(
                    cr, uid, [('estnto_tipo_operacao', 'in', tipo_operacao)], context=context)
                if natureza_operacao_ids:
                    if len(natureza_operacao_ids) == 1:
                        natureza_operacao_ids = str(tuple(natureza_operacao_ids)).replace(',',
                                                                                          '')
                    else:
                        natureza_operacao_ids = str(tuple(natureza_operacao_ids))

                    cond_estmvc_operacao_id += """ AND emc.estmvc_operacao_id in %s""" % natureza_operacao_ids

            if brw_mov_analitico.pessoa_id:
                cond_pessoa_id += """ AND emc.pessoa_id = %s""" % brw_mov_analitico.pessoa_id.id

            if brw_mov_analitico.normal:
                movimento_list.append('normal')
                tipo_movimento.append('C')
                tipo_movimento.append('U')

            if brw_mov_analitico.transferencias:
                movimento_list.append('transferencias')
                tipo_movimento.append('T')

            if brw_mov_analitico.devolucoes:
                movimento_list.append('devolucoes')
                tipo_movimento.append('D')

            if local_ids:
                if not isinstance(local_ids, list):
                    local_ids = [local_ids]
                cond_local_id = """AND mov_item.local_id in (%s)""" % \
                                ','.join(map(lambda x: '%s' % x, local_ids))

            if brw_mov_analitico.categoria_id:
                categoria_ids = self.pool.get('estoque.categoria').search(
                    cr, uid, [('parent_id', 'child_of', brw_mov_analitico.categoria_id.id)],
                    context=context)
                if categoria_ids:
                    if len(categoria_ids) == 1:
                        categoria_ids = str(tuple(categoria_ids)).replace(',', '')
                    else:
                        categoria_ids = str(tuple(categoria_ids))

                    cond_produto_id = """ AND mov_item.produto_id IN (
                        SELECT id FROM estoque_produto WHERE categoria_id IN %s)""" % categoria_ids

                else:
                    cond_produto_id = '''AND mov_item.produto_id IS NULL '''

            elif brw_mov_analitico.produto_id:
                cond_produto_id = """AND mov_item.produto_id = %s""" % brw_mov_analitico.produto_id.id

            if brw_mov_analitico.grade_id:
                cond_grade_id += """AND mov_item.grade_id = %s""" % brw_mov_analitico.grade_id.id

            if brw_mov_analitico.fabricante_id:
                fabricante_produto_ids = obj_estoque_produto.search(
                    cr, uid, [('fabricante_id', '=', brw_mov_analitico.fabricante_id.id)], context=context)
                if fabricante_produto_ids:
                    if len(fabricante_produto_ids) == 1:
                        str_fabricante_produto_ids = str(tuple(
                            fabricante_produto_ids)).replace(',', '')
                    else:
                        str_fabricante_produto_ids = str(tuple(fabricante_produto_ids))

                    cond_produto_id = '''AND mov_item.produto_id in %s ''' % str_fabricante_produto_ids

                else:
                    cond_produto_id = '''AND mov_item.produto_id IS NULL '''

            if brw_mov_analitico.produto_id and brw_mov_analitico.fabricante_id:
                if brw_mov_analitico.produto_id.fabricante_id != brw_mov_analitico.fabricante_id:
                    cond_produto_id = '''AND mov_item.produto_id IS NULL '''

        # O tratamento abaixo foi incluido pois movimentacao de itens de requisicao e inventario
        # nao possui cfop
        cond_cfop_id = ''
        if tipo_movimento and not (brw_mov_analitico.requisicoes or brw_mov_analitico.inventario) \
                and not filtro_cfop_ids:
            cfop_ids = self.pool.get('fiscal.cfop').search(
                cr, uid, [('movimento_tipo', 'in', tipo_movimento)], context=context)
            if cfop_ids:
                cfop_ids.extend(filtro_cfop_ids)
                cfop_ids = list(set(cfop_ids))
                if len(cfop_ids) == 1:
                    cfop_ids = str(tuple(cfop_ids)).replace(',', '')
                else:
                    cfop_ids = str(tuple(cfop_ids))
                cond_cfop_id += """ AND mov_item.cfop_id IN %s""" % cfop_ids

        elif filtro_cfop_ids:
            if len(filtro_cfop_ids) == 1:
                cfop_ids = str(tuple(filtro_cfop_ids)).replace(',', '')
            elif len(filtro_cfop_ids) > 1:
                cfop_ids = str(tuple(filtro_cfop_ids))

            cond_cfop_id += """ AND mov_item.cfop_id IN %s """ % cfop_ids

        cond_requisicao = ''
        if brw_mov_analitico.requisicoes and \
                (estoqueressuprimento_instalado or estoquealmoxarifado_instalado) and not \
                brw_mov_analitico.documento:
            if cond_item_cancelado:
                cond_requisicao += ')'
            if cond_cfop_id:
                cond_cfop_id = """ AND (mov_item.cfop_id IN {cfop_ids} {almoxarifado}
                {ressuprimento}) """.format(
                    cfop_ids=cfop_ids,
                    almoxarifado='OR emc.requisicao_id IS NOT NULL' if estoquealmoxarifado_instalado
                                 else '',
                    ressuprimento='OR emc.requisicaoressuprimento_id IS NOT NULL' if
                                  estoqueressuprimento_instalado else '')
            elif cond_estmvc_operacao_id and brw_mov_analitico.normal:
                cond_estmvc_operacao_id = """ AND (emc.estmvc_operacao_id in {natureza_operacao_ids}
                 {almoxarifado} {ressuprimento})
                 """.format(natureza_operacao_ids=natureza_operacao_ids,
                            almoxarifado='OR emc.requisicao_id IS NOT NULL' if
                            estoquealmoxarifado_instalado else '',
                            ressuprimento='OR emc.requisicaoressuprimento_id IS NOT NULL' if
                            estoqueressuprimento_instalado else '')
            elif cond_estmvc_operacao_id and not brw_mov_analitico.normal:
                cond_estmvc_operacao_id = """ AND (emc.estmvc_operacao_id in {natureza_operacao_ids}
                 AND ({almoxarifado} OR {ressuprimento}))
                 """.format(natureza_operacao_ids=natureza_operacao_ids,
                            almoxarifado='emc.requisicao_id IS NOT NULL' if
                            estoquealmoxarifado_instalado else 'TRUE',
                            ressuprimento='emc.requisicaoressuprimento_id IS NOT NULL' if
                            estoqueressuprimento_instalado else 'FALSE')
            else:
                cond_requisicao += """
                    AND ({almoxarifado} OR {ressuprimento})
                """.format(almoxarifado='emc.requisicao_id IS NOT NULL' if
                           estoquealmoxarifado_instalado else 'TRUE',
                           ressuprimento='emc.requisicaoressuprimento_id IS NOT NULL' if
                           estoqueressuprimento_instalado else 'FALSE')
        else:
            if cond_item_cancelado:
                cond_item_cancelado += ')'

        if brw_mov_analitico.requisicoes:
            movimento_list.append('requisicoes')

        if cond_inventario and cond_estmvc_operacao_id and len(movimento_list) == 1:
            cond_inventario = """ AND (emc.estmvc_operacao_id in %s
                                       AND emc.inventario_id IS NOT NULL)
            """ % natureza_operacao_ids
        elif cond_inventario and cond_estmvc_operacao_id and len(movimento_list) > 1:
            cond_inventario = """ AND (emc.estmvc_operacao_id in %s
                                       OR emc.inventario_id IS NOT NULL)
            """ % natureza_operacao_ids
        ordem = brw_mov_analitico.ordem
        if ordem == 'Doc':
            order_by = '''fnc.serie_nf, fnc.numero_nf, fnc.id %s, ep.name, epg.grade ''' % (coo)

        elif ordem == 'Pro':
            order_by = '''ep.name, epg.grade, emc.data, fnc.serie_nf, fnc.numero_nf, fnc.id %s ''' % (coo)

        elif ordem == 'Cat':
            order_by = '''ec.name, ep.name, epg.grade, emc.data, fnc.serie_nf, fnc.numero_nf, fnc.id %s ''' % (coo)

        elif ordem == 'Cli':
            order_by = '''ap.nome, ep.name, epg.grade, emc.data, fnc.serie_nf, fnc.numero_nf, fnc.id %s ''' % (coo)

        elif ordem == 'Loc':
            order_by = '''el.name, ep.name, epg.grade, emc.data, fnc.serie_nf, fnc.numero_nf, fnc.id %s ''' % (coo)

        else:
            order_by = '''emc.data, ep.name, epg.grade, fnc.serie_nf, fnc.numero_nf, fnc.id %s ''' % (coo)

        estoque_requisicao = " AND %s AND %s" % (
            'emc.requisicao_id IS NULL' if estoquealmoxarifado_instalado else 'TRUE',
            'emc.requisicaoressuprimento_id IS NULL' if estoqueressuprimento_instalado else 'TRUE')

        sql = """
            SELECT emc.numero_documento           AS numero_documento,
                   {campo_volume}
                   emc.nf_capa_id                 AS nf_capa_id,
                   mov_item.vr_total_item_rateado AS vr_total_item,
                   mov_item.vr_unitario           AS vr_unitario,
                   {origem_movimento}
                   fnc.serie_nf 	  	          AS serie_nf,
                   {campo_cupom_capa_id}
                   {campo_requisicaoressuprimento_id}
                   emc.inventario_id	          AS inventario_id,
                   emc.pessoa_id 		          AS pessoa_id,
                   ap.nome                        AS pessoa_nome,
                   ap.codigo 		              AS pessoa_codigo,
                   emc.data 		              AS data,
                   emc.estmvc_operacao_id 	      AS operacao_id,
                   {tipo_movimento}
                   mov_item.local_id  	          AS local_id,
                   mov_item.produto_id 	          AS produto_id,
                   ep.codigo 	                  AS produto_codigo,
                   ep.categoria_id 	              AS categoria_id,
                   ec.conta                       AS conta,
                   mov_item.grade_id 	          AS grade_id,
                   epg.grade 		              AS grade_grade,
                   epg.name		                  AS grade_name,
                   mov_item.produto_embalagem_id  AS produto_embalagem_id,
                   mov_item.quantidade 	          AS quantidade,
                   el.name                        AS local_nome,
                   el.numero                      AS local_numero,
                   {campo_tipo_cupom_coo}
                   (SELECT vr_icms_substituicao
                    FROM fiscal_nf_item_tributacao
                    WHERE movimento_itens_id = mov_item.id
                      AND encargo_id IN ({encargo_icms_id})
                   )                              AS vr_icms_st,
                   (SELECT vr_encargo
                    FROM fiscal_nf_item_tributacao
                    WHERE movimento_itens_id = mov_item.id
                      AND encargo_id IN ({encargo_ipi_id})
                   )                              AS vr_ipi,
                   emo.estmog_codigo              AS origem
            FROM estoque_movimento_itens         AS mov_item
            INNER JOIN estoque_movimento_capa    AS emc ON emc.id = mov_item.capa_id
            LEFT  JOIN fiscal_nf_capa            AS fnc ON fnc.id = emc.nf_capa_id
            LEFT  JOIN adm_pessoa                AS ap  ON ap.id  = emc.pessoa_id
            INNER JOIN estoque_produto           AS ep  ON ep.id  = mov_item.produto_id
            INNER JOIN estoque_produto_grade     AS epg ON epg.id = mov_item.grade_id
            LEFT  JOIN estoque_categoria         AS ec  ON ec.id  = ep.categoria_id
            INNER JOIN estoque_local             AS el  ON el.id  = mov_item.local_id
            INNER JOIN estoque_natureza_operacao AS eno ON eno.id = emc.estmvc_operacao_id
            LEFT  JOIN estoque_movimento_origem  AS emo ON emo.id = eno.estnto_movimento_origem_id
            LEFT  JOIN fiscal_cfop               AS fc  on fc.id  = mov_item.cfop_id
            {left_join_ecf}
            WHERE emc.data >= '{data_inicial}'
              AND emc.data <= '{data_final}'
              AND emc.state = 'F'
              AND CASE 
                      WHEN emc.inventario_id IS NULL {estoque_requisicao}
                          THEN fc.codigo NOT IN ('5929', '6929') 
                      ELSE TRUE 
                  END
              {cond_grade_id}
              {cond_produto_id}
              {cond_pessoa_id}
              {cond_local_id}
              {cond_cfop_id}
              {cond_origem}
              {cond_numero_documento}
              {cond_estmvc_operacao_id}
              {cond_item_cancelado}
              {cond_requisicao}
              {cond_modelo_nf}
              {cond_inventario}
              AND emc.company_id IN ({str_company_ids})
            ORDER BY {order_by}
        """.format(campo_volume=campo_volume,
                   campo_cupom_capa_id=campo_cupom_capa_id,
                   campo_requisicao_id=campo_requisicao_id,
                   campo_requisicaoressuprimento_id=campo_requisicaoressuprimento_id,
                   campo_tipo_cupom_coo=campo_tipo_cupom_coo,
                   encargo_icms_id=encargo_icms_id,
                   encargo_ipi_id=encargo_ipi_id,
                   left_join_ecf=left_join_ecf,
                   data_inicial=brw_mov_analitico.periodo_inicial,
                   data_final=brw_mov_analitico.periodo_final,
                   str_company_ids=str_company_ids,
                   cond_origem=cond_origem,
                   cond_numero_documento=cond_numero_documento,
                   cond_estmvc_operacao_id=cond_estmvc_operacao_id,
                   cond_pessoa_id=cond_pessoa_id,
                   cond_local_id=cond_local_id,
                   cond_grade_id=cond_grade_id,
                   cond_produto_id=cond_produto_id,
                   cond_cfop_id=cond_cfop_id,
                   cond_item_cancelado=cond_item_cancelado,
                   cond_modelo_nf=cond_modelo_nf,
                   cond_inventario=cond_inventario,
                   cond_requisicao=cond_requisicao,
                   order_by=order_by,
                   origem_movimento=self.get_origem_movimento_analitico(cr, uid, context),
                   tipo_movimento=self.get_tipo_movimento_analitico(cr, uid, context),
                   estoque_requisicao=estoque_requisicao
                   )

        cr.execute(sql)

        dados = cr.dictfetchall()
        if dados and brw_mov_analitico.grau_categoria > 0:
            dados = filter(
                lambda c: (len((c.get('conta') or '').split('.')) if c.get('conta') else -1) ==
                          brw_mov_analitico.grau_categoria, dados)

        if not dados:
            raise osv.except_osv(_('Atencao'), _('Nao ha dados com esses filtros para gerar o relatorio!'))

        datas = {'dados': dados}
        datas.update({'company_ids': company_ids,
                      'local_ids': local_ids,
                      'periodo_inicial': brw_mov_analitico.periodo_inicial,
                      'periodo_final': brw_mov_analitico.periodo_final,
                      'ordem': ordem,
                      })
        return datas

    @staticmethod
    def get_cm(tipo_movimento, origem, cfop_movimento):
        cm = tipo_movimento or ''
        if cfop_movimento:
            cm += cfop_movimento or '' if cfop_movimento not in 'UC' else 'N'
        cm += origem or '' if len(cm) < 2 and origem != 'U' else 'N' if len(cm) < 2 else ''

        return cm

    def get_origem_movimento_analitico(self, cr, uid, context=None):
        """
        O metodo identifica a origem do item movimentado no estoque.
        Se nota ou cupom fiscal, eh identificado pelo tipo de movimento do CFOP.
        Se inventario, eh identificado pelo id desse (inventario_id) na capa do movimento.
        Metodo sobreescrito nos modulos estoquealmoxarifado e estoqueressuprimento.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param context: dados com valores contextuais.
        :type context: dict
        :return: query para busca dos dados no movimento
        :rtype: str
        """
        context = context and context.copy() or {}
        sql = """
            CASE
                WHEN emc.inventario_id IS NOT NULL THEN 'I'
                ELSE fc.movimento_tipo
            END   AS cfop_movimento,
        """
        return sql

    def get_tipo_movimento_analitico(self, cr, uid, context=None):
        """
        O metodo identifica o tipo da natureza da operacao do movimento.
        Metodo sobreescrito no modulo estoquealmoxarifado.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param context: dados com valores contextuais.
        :type context: dict
        :return: query para busca dos dados no movimento
        :rtype: str
        """
        context = context and context.copy() or {}
        sql = """
                eno.estnto_tipo_operacao       AS tipo_movimento,
        """
        return sql
