# -*- encoding: utf-8 -*-
import time
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
import StringIO
from openerp import pooler
from openerp.report.interface import report_int
from openerp.report.render import render
from openerp.osv import osv, fields
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):

        def center_title(E, C, D, T=190):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.informaTamLinha(187)
        listagem.informaNome(pdf_string, _('Listagem de grade de produtos'))
        listagem.defineMargem(1, 1, 1, 1)
        obj_preco_custo = pooler.get_pool(cr.dbname).get('estoque.preco.custo')
        obj_preco_venda = pooler.get_pool(cr.dbname).get('estoque.preco.venda')
        obj_estoque_parametro = pooler.get_pool(cr.dbname).get('estoque.parametro')

        company_id = datas.get('company_id')
        local_id = datas.get('local_id')
        fabricante_id = datas.get('fabricante_id')
        categoria_id = datas.get('categoria_id')

        produto_company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, tabela='estoque.produto', args=company_id, context=context
        )

        local1 = local2 = local3 = local4 = ''
        if local_id:
            local1 = ', l.local_id'
            local2 = ', l.local_id as local_id'
            local3 = 'estoque_local_locacao l,'
            local4 = ' g.produto_id = l.produto_id and g.id = l.grade_id and l.local_id = el.id and'

        sql = """
            SELECT Rank ()
                     over (
                       ORDER BY p.codigo, g.produto_id, p.digito, g.descricao, p.name,
                     g.name,
                     g.grade, p.categoria_id, c.name, p.tempo_reposicao, p.margem_ideal,
                     p.margem_bruta,
                     p.margem_minima, g.minimo, g.maximo %s ) AS id,
                   g.id                                       AS grade_id,
                   p.company_id                               AS company_id,
                   p.fabricante_id                            AS fabricante_id,
                   g.produto_id                               AS produto_id,
                   p.codigo                                   AS codigo,
                   p.digito                                   AS digito,
                   g.descricao                                AS descricao,
                   p.name                                     AS produto_name,
                   g.grade                                    AS grade,
                   g.name                                     AS grade_name,
                   p.categoria_id                             AS categoria_id,
                   c.name                                     AS categoria_name,
                   p.tempo_reposicao                          AS tempo_reposicao,
                   p.margem_ideal                             AS margem_ideal,
                   p.margem_bruta                             AS margem_bruta,
                   p.margem_minima                            AS margem_minima,
                   g.minimo                                   AS minimo,
                   g.maximo                                   AS maximo
                   %s
            FROM   estoque_produto_grade g
                   inner join estoque_produto p
                           ON g.produto_id = p.id
                   inner join estoque_local_locacao l
                           ON g.produto_id = l.produto_id
                              AND g.id = l.grade_id
                   inner join estoque_local el
                           ON l.local_id = el.id
                   left join adm_pessoa ap
                          ON p.fabricante_id = ap.id
                   left join estoque_categoria c
                          ON p.categoria_id = c.id
            WHERE  
                    p.company_id = %s
                    AND p.active IS TRUE
        """ % (local1, local2, produto_company_id)

        if local_id:
            sql += """and l.local_id = %s""" % local_id
        if fabricante_id:
            sql += """and p.fabricante_id = %s""" % fabricante_id
        if categoria_id:
            sql += """and p.categoria_id = %s""" % categoria_id

        sql += """
            GROUP  BY p.company_id,
                      p.fabricante_id,
                      p.codigo,
                      g.produto_id,
                      g.id,
                      p.digito,
                      g.descricao,
                      p.name,
                      g.grade,
                      g.name,
                      p.categoria_id,
                      c.name,
                      p.tempo_reposicao,
                      p.margem_ideal,
                      p.margem_bruta,
                      p.margem_minima,
                      g.minimo,
                      g.maximo %s
            """ % (local1)

        cr.execute(sql)
        rs_prod = cr.dictfetchall()

        produto_ids = map(lambda i: i['produto_id'], rs_prod)
        produto_ids = list(set(produto_ids))
        grade_ids = list(set(map(lambda i: i.get('grade_id'), rs_prod)))

        dict_preco_venda = obj_preco_venda.get_preco_venda(cr, uid, produto_ids,
                                                           epc_company_id=produto_company_id,
                                                           epc_grade_ids=grade_ids,
                                                           context=context)
        context['listagem_produto_grade'] = True
        dict_preco_custo = obj_preco_custo.get_custos_do_dia(cr, uid, epc_produto_ids=produto_ids,
                                                             epc_company_id=produto_company_id, context=context)

        #         1         2         3         4         5         6         7         8         9         10        20        30        40
        #1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890

        # EMPRESA
        obj_emp = pooler.get_pool(cr.dbname).get("res.company")
        nome_empresa = obj_emp.browse(cr, uid, company_id).name or ''
        listagem.informaCab(
            center_title(_('Data: ') + time.strftime('%d/%m/%Y'), _('Listagem de produtos'), _('Pag. ') + '{{ Page }}'))
        listagem.informaCab(_('Empresa: ') + nome_empresa)
        listagem.informaCab('-' * 186)
        listagem.informaCab(
              '                                                                                                      |---------- Margem ----------|                                                    ')
        listagem.informaCab(
            _('        Codigo  Digito  Grade  Nome completo                       Categoria            T. Reposicao   Ideal       Bruta     Minima     Ult. custo  Preco venda     Minimo       Maximo'))
        listagem.informaCab('-' * 186)
        listagem.informaCab(' ')
        listagem.informaRodape('-' * 186)
        listagem.informaRodape(
              '                                                                                                              Sig Informatica Ltda')

        descricao_grade = None
        estoque_parametro_id = obj_estoque_parametro.search(cr, uid, [('company_id', '=', company_id)], context=context)
        if estoque_parametro_id:
            estpar_descricao_grade = obj_estoque_parametro.browse(cr, uid,
                                                                  estoque_parametro_id[0]).estpar_descricao_grade
            if estpar_descricao_grade == 'P':
                descricao_grade = True

        #LISTAGEM
        # Imprimindo o corpo do relatorio
        linha = ''
        for lista in rs_prod:
            produto_id = lista.get('produto_id')
            grade_id = lista.get('grade_id')
            #codigo do produto
            codigo = lista.get('codigo')
            if not codigo:
                codigo = 0
            linha = formataString(int(codigo) or '', 15, ' ', 'E', 'N', 'S')
            linha += ' '
            #digito
            linha += formataString(lista.get('digito') or '', 8, ' ', 'D', 'N', 'S')
            linha += ' '
            # grade
            linha += formataString(lista.get('grade') or '', 5, ' ', 'D', 'N', 'S')
            linha += ' '
            if descricao_grade:
                descricao = lista.get('grade_name') or ''
                if not descricao:
                    descricao = '%s - %s' % (lista.get('descricao') or '', lista.get('grade') or '')
            else:
                descricao = lista.get('descricao') or ''
            linha += formataString(descricao, 35, ' ', 'D', 'N', 'S')
            linha += ' '
            # categoria
            if lista.get('categoria_id'):
                categoria = lista.get('categoria_name') or ''
            else:
                categoria = ''
            linha += formataString(categoria, 20, ' ', 'D', 'N', 'S')
            linha += ' '
            #tempo de reposicao
            linha += formataString(getNumeroEditado(lista.get('tempo_reposicao') or 0.0), 8, ' ', 'C', 'N', 'S')
            linha += ' '
            #margem ideal
            linha += formataString(getNumeroEditado(lista.get('margem_ideal') or 0.0), 11, ' ', 'E', 'N', 'S')
            linha += ' '
            #margem bruta
            linha += formataString(getNumeroEditado(lista.get('margem_bruta') or 0.0), 10, ' ', 'E', 'N', 'S')
            linha += ' '
            #margem minima
            linha += formataString(getNumeroEditado(lista.get('margem_minima') or 0.0), 10, ' ', 'E', 'N', 'S')
            linha += ' '

            val_ult_preco = 0.0
            if dict_preco_custo.get(produto_id):
                val_ult_preco = dict_preco_custo.get(produto_id).get('estprc_ultimo_custo') or 0.0
            dados_preco_venda = dict_preco_venda.get(produto_id) or {}
            preco_venda = dados_preco_venda.get(grade_id) or dados_preco_venda.get(
                'preco_venda')

            # ultimo custo
            linha += formataString(getNumeroEditado(val_ult_preco, 2), 12, ' ', 'E', 'N', 'S')
            linha += ' '
            # preco venda
            linha += formataString(getNumeroEditado(preco_venda or 0.0, 2), 12, ' ', 'E', 'N', 'S')
            linha += ' '
            #minimo
            linha += formataString(getNumeroEditado(lista.get('minimo') or 0), 12, ' ', 'E', 'N', 'S')
            linha += ' '
            #maximo
            linha += formataString(getNumeroEditado(lista.get('maximo') or 0), 12, ' ', 'E', 'N', 'S')
            listagem.imprimeLinha(linha)
        listagem.imprimeLinha('')
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_prod_grade')


class wizard_listagem_prod_grade(osv.TransientModel):
    _name = 'wizard.listagem_prod_grade'
    _description = 'Listagem de Produto x Grade'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', required=True, select=True),
        'fabricante_id': fields.many2one("adm.pessoa", 'Fabricante'),
        'categoria_id': fields.many2one("estoque.categoria", 'Categoria'),
        'local_id': fields.many2one("estoque.local", 'Local'),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = self.browse(cr, uid, ids[0])

        datas = {
            'company_id': vals.company_id.id,
            'categoria_id': vals.categoria_id.id or False,
            'fabricante_id': vals.fabricante_id.id or False,
            'local_id': vals.local_id.id or False,
        }

        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'listagem_prod_grade',
            'datas': datas,
        }
