# -*- encoding: utf-8 -*-
from openerp.osv import osv, fields


class wizard_listagem_produtos_locais(osv.TransientModel):
    _name = 'wizard.listagem.produtos.locais.osv'
    _columns = {
        'company_id': fields.many2one('res.company', 'Empresa'),
        'categoria_id': fields.many2one('estoque.categoria', 'Categoria'),
        'fabricante_id': fields.many2one("adm.pessoa", 'Fabricante', select=True, ondelete="restrict"),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c)
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        browse_listagem_produto_locais = self.browse(cr, uid, ids, context=context)
        datas = {}
        for x in browse_listagem_produto_locais:
            categoria_ids = []
            if x.categoria_id:
                categoria_ids = self.pool.get('estoque.categoria').search(cr, uid,
                    [('parent_id', 'child_of', x.categoria_id.id)], context=context)
            datas = {
                'company_id': x.company_id.id,
                'categoria_ids': categoria_ids,

                'fabricante_id': x.fabricante_id.id,
            }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'listagem_produtos_locais',
            'datas': datas,
        }

