# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}

        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            if (T - len(C)) % 2 >= 1:
                D = ' ' + D
            title += D
            return title

        title = center_title(_('|Contr.Estoque'), _('Rel. Rentabilidade p/ familia'), _('Est445|'),
                             180)
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='1')
        listagem.informaTamLinha(160)
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)
        listagem.defineFonte(tam=7.525)
        listagem.informaNome(pdf_string, _('Listagem Rentabilidade'))

        company_id = datas.get('company_id')
        if not company_id:
            company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                                                         context=context)

        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id,
                                                                               ['name'],
                                                                               context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title('|' + data, nome_empresa, _('Pagina: {{ Page }} |'), 189)

        obj_estoque_categoria = pooler.get_pool(cr.dbname).get('estoque.categoria')
        ecf_instalado = pooler.get_pool(cr.dbname).get('adm.utils').admutl_check_modulo_instalado(
            cr, uid, 'ecf', context=context)

        periodo_inicial = datas.get('periodo_inicial')
        periodo_final = datas.get('periodo_final')
        custo_utilizado = datas.get('custo')
        if custo_utilizado == 'M':
            custo_extenso = _('Medio')
        elif custo_utilizado == 'C':
            custo_extenso = _('Corrigido')
        elif custo_utilizado == 'R':
            custo_extenso = _('Reposicao')
        else:
            custo_extenso = _('Ultimo Custo')

        ordem = datas.get('ordem')
        if ordem == 'Val':
            ordem_extenso = _('Valor Agregado')
        elif ordem == 'Par':
            ordem_extenso = _('% Participacao')
        elif ordem == 'Ven':
            ordem_extenso = _('% Venda')
        else:
            ordem_extenso = _('% Custo')

        categoria_ids = datas.get('categoria_ids')
        sql_and = ''' '''
        if categoria_ids:
            sql_and += '''AND ep.categoria_id IN (%s)
                          ''' % ','.join(map(lambda x: '%s' % x, categoria_ids))
        fabricante_id = datas.get('fabricante_id')
        if fabricante_id:
            sql_and += '''AND ep.fabricante_id = %s
                          ''' % (fabricante_id)
        rentabilidade_por_familia = datas.get('rentabilidade_por_familia')
        sql = '''
                SELECT nome_produto,
                       categoria_id,
                       codigo_produto,
                       grade_id,
                       grade,
                       sum(quantidade)   	     AS quantidade,
                       qtd_na_embalagem,
                       sum(custo_corrigido)	     AS total_custo_corrigido,
                       sum(ultimo_custo)         AS total_ultimo_custo,
                       sum(custo_medio_contabil) AS total_custo_medio_contabil,
                       sum(custo_reposicao)      AS total_custo_reposicao,
                       sum(vr_total_item) 	     AS vr_total_item
                FROM (
                        SELECT epg.name        		      AS nome_produto,
                               ep.categoria_id            AS categoria_id,
                               ep.codigo       		      AS codigo_produto,
                               emi.grade_id               AS grade_id,
                               epg.grade     		      AS grade,
                               %s
                               ee.quantidade_na_embalagem AS qtd_na_embalagem,
                               emi.estmvi_saidas_custo_corrigido_total AS custo_corrigido,
                               emi.estmvi_saidas_ultimo_custo_total    AS ultimo_custo,
                               emi.estmvi_saidas_custo_medio_contabil_total AS custo_medio_contabil,
                               emi.estmvi_saidas_custo_reposicao_total AS custo_reposicao,
                               emi.vr_total_item_rateado     AS vr_total_item,
                               emi.produto_id
                        FROM estoque_movimento_itens         AS emi
                        INNER JOIN estoque_movimento_capa    AS emc ON emc.id = emi.capa_id
                        INNER JOIN estoque_produto           AS ep  ON ep.id  = emi.produto_id
                        INNER JOIN estoque_produto_grade     AS epg ON epg.id = emi.grade_id
                        INNER JOIN estoque_produto_embalagem AS epe ON epe.id = emi.produto_embalagem_id
                        INNER JOIN estoque_embalagem 	     AS ee  ON ee.id  = epe.embalagem_id
                        INNER JOIN estoque_natureza_operacao AS eno ON eno.id = emc.estmvc_operacao_id
                        INNER JOIN fiscal_cfop               AS fc  ON fc.id  = emi.cfop_id
                        WHERE emc.data >= '%s'
                          AND emc.data <= '%s'
                          AND emc.state = 'F'
                          AND emc.company_id = %s
                          AND eno.estnto_tipo_operacao = 'S'
                          AND fc.movimento_tipo = 'C'
                          AND emi.nf_id IS NOT NULL
                          %s
                ''' % (datas.get('query_quantidade'), periodo_inicial, periodo_final, company_id,
                       sql_and)
        if ecf_instalado:
            sql += '''
                        UNION ALL
                  '''
            sql += '''
                        SELECT epg.name        		       AS nome_produto,
                               ep.categoria_id             AS categoria_id,
                               ep.codigo       		       AS codigo_produto,
                               emi.grade_id                AS grade_id,
                               epg.grade     		       AS grade,
                               (CASE WHEN ecc.tipo_cupom = 'C'
                                     THEN -emi.quantidade
                                     ELSE emi.quantidade
                                END) AS quantidade ,
                               ee.quantidade_na_embalagem  AS qtd_na_embalagem,
                               (CASE WHEN ecc.tipo_cupom = 'C'
                                     THEN -emi.estmvi_saidas_custo_corrigido_total
                                     ELSE emi.estmvi_saidas_custo_corrigido_total
                                END)                       AS custo_corrigido ,
                               (CASE WHEN ecc.tipo_cupom = 'C'
                                     THEN -emi.estmvi_saidas_ultimo_custo_total
                                     ELSE emi.estmvi_saidas_ultimo_custo_total
                                END)                       AS ultimo_custo ,
                               (CASE WHEN ecc.tipo_cupom = 'C'
                                     THEN -emi.estmvi_saidas_custo_medio_contabil_total
                                     ELSE emi.estmvi_saidas_custo_medio_contabil_total
                                END)                       AS custo_medio_contabil ,
                               (CASE WHEN ecc.tipo_cupom = 'C'
                                     THEN -emi.estmvi_saidas_custo_reposicao_total
                                     ELSE emi.estmvi_saidas_custo_reposicao_total
                                END)                       AS custo_reposicao,
                               (CASE WHEN ecc.tipo_cupom = 'C'
                                     THEN -emi.vr_total_item_rateado
                                     ELSE emi.vr_total_item_rateado
                                END)                       AS vr_total_item,
                               emi.produto_id
                        FROM estoque_movimento_itens         AS emi
                        INNER JOIN estoque_movimento_capa    AS emc ON emc.id = emi.capa_id
                        INNER JOIN estoque_produto           AS ep  ON ep.id  = emi.produto_id
                        INNER JOIN estoque_produto_grade     AS epg ON epg.id = emi.grade_id
                        INNER JOIN estoque_produto_embalagem AS epe ON epe.id = emi.produto_embalagem_id
                        INNER JOIN estoque_embalagem 	     AS ee  ON ee.id  = epe.embalagem_id
                        INNER JOIN estoque_natureza_operacao AS eno ON eno.id = emc.estmvc_operacao_id
                        LEFT  JOIN ecf_cupons_capa 	         AS ecc ON ecc.id = emi.cupom_id
                        INNER JOIN fiscal_cfop               AS fc  ON fc.id  = emi.cfop_id
                        WHERE emc.data >= '%s'
                          AND emc.data <= '%s'
                          AND emc.state = 'F'
                          AND emc.company_id = %s
                          AND eno.estnto_tipo_operacao = 'S'
                          AND fc.movimento_tipo = 'C'
                          AND emi.cupom_id IS NOT NULL
                          AND not (emi.item_cancelado IS True AND ecc.tipo_cupom = 'V')
                          %s
                      ) AS tmp
                GROUP BY categoria_id, nome_produto, codigo_produto, qtd_na_embalagem, produto_id, grade_id,grade
                ORDER BY categoria_id, produto_id, grade
              ''' % (periodo_inicial, periodo_final, company_id, sql_and)
        else:
            sql += ''') AS tmp
                GROUP BY categoria_id, nome_produto, codigo_produto, qtd_na_embalagem, produto_id, grade_id,grade
                ORDER BY categoria_id, produto_id, grade
                   '''
        cr.execute(sql)
        dados_mov_intens = cr.dictfetchall()

        listagem.informaCab(
            '*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(title)
        listagem.informaCab(docs)
        listagem.informaCab(
            '|                                                                                                                                                                                  |')
        periodo = _('|    Periodo: ') + time.strftime("%d/%m/%Y", time.strptime(periodo_inicial,
                                                                                "%Y-%m-%d")) + ' a ' + time.strftime(
            "%d/%m/%Y", time.strptime(periodo_final, "%Y-%m-%d")) + \
                  _(
                      '                   Custo Utilizado: ') + custo_extenso + '                Ordem: ' + ordem_extenso
        listagem.informaCab(periodo.ljust(179) + '|')
        listagem.informaCab(
            '|                                                                                                                                                                                  |')
        listagem.informaCab(
            '*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(
            center_title('|', _('>>>>>>>>>>>>>>>>>>>>>> SAIDAS <<<<<<<<<<<<<<<<<<<<<<<'), '|', 180))
        listagem.informaCab(_(
            '|                                             Codigo                 >>>> PRECO CUSTO <<<<    >>>> PRECO VENDA <<<<      %        %          %       VALOR                 VALOR   |'))
        listagem.informaCab(_(
            '|P r o d u t o                                Interno GR     Quantid.     Unitar.     Total     Unitar.        Total    Part.    Venda      Custo    Agregado  Impostos  Agreg.Liqu|'))
        listagem.informaCab(
            '*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(
            '|                                                                                                                                                                                  |')
        listagem.rodapePadrao()

        total_quantidade = 0
        total_custo = 0
        total_valor = sum(map(lambda x: x.get('vr_total_item'), dados_mov_intens))  # total da venda
        total_valor_agregado = 0
        total_impostos = 0
        total_valor_agreg_liq = 0
        if rentabilidade_por_familia:
            categorias = list(set(map(lambda x: x.get('categoria_id'), dados_mov_intens)))
            aux = {}
            # pega o tatal de cada categoria e o nome da categoria
            for categ in categorias:
                aux[categ] = {}
                aux[categ]['total_categoria'] = sum(
                    map(lambda x: x.get('vr_total_item') if x.get('categoria_id') == categ else 0,
                        dados_mov_intens))
                nome_completo = obj_estoque_categoria.browse(cr, uid, categ).nome_completo
                aux[categ]['nome_categoria'] = nome_completo or 'Sem categoria'
                aux[categ]['ja_imprimiu'] = False
            categorias = aux.copy()

        totais_por_categoria = {'quantidade': 0, 'custo_total': 0, 'venda_total': 0,
                                'valor_agreg': 0, 'impostos': 0,
                                'valor_agreg_liq': 0}
        categoria_inicial = ''

        for i in dados_mov_intens:
            quantidade = i.get('quantidade')
            # retira os itens onde os cupons foram cancelados, logo a quantidade eh zero
            if not quantidade:
                continue

            grade_id = i.get('grade_id')
            sql = '''
                    SELECT emi.id
                    FROM estoque_movimento_itens         AS emi
                    INNER JOIN estoque_movimento_capa    AS emc ON emc.id = emi.capa_id
                    INNER JOIN estoque_produto           AS ep  ON ep.id  = emi.produto_id
                    INNER JOIN estoque_natureza_operacao AS eno ON eno.id = emc.estmvc_operacao_id
                    INNER JOIN fiscal_cfop               AS fc  ON fc.id  = emi.cfop_id
                    WHERE emc.data >= '%s'
                      AND emc.data <= '%s'
                      AND emi.grade_id = %s
                      AND emc.company_id = %s
                      AND emc.state = 'F'
                      AND eno.estnto_tipo_operacao = 'S'
                      AND fc.movimento_tipo = 'C'
                      AND emi.nf_id IS NOT NULL
                      %s
                  ''' % (periodo_inicial, periodo_final, grade_id, company_id, sql_and)
            cr.execute(sql)
            aux = cr.dictfetchall()
            mov_item_ids = []
            if aux:
                mov_item_ids = map(lambda x: x.get('id'), aux)
            if ecf_instalado:
                sql = '''
                    SELECT emi.id, ee.caixa, ee.loja, ecc.coo, ecc.tipo_cupom
                    FROM estoque_movimento_itens         AS emi
                    INNER JOIN estoque_movimento_capa    AS emc ON emc.id = emi.capa_id
                    INNER JOIN estoque_produto           AS ep  ON ep.id  = emi.produto_id
                    INNER JOIN estoque_natureza_operacao AS eno ON eno.id = emc.estmvc_operacao_id
                    LEFT  JOIN ecf_cupons_capa 	         AS ecc ON ecc.id = emi.cupom_id
                    LEFT  JOIN ecf_ecf                   AS ee  ON ee.id  = ecc.ecf_id
                    INNER JOIN fiscal_cfop               AS fc  ON fc.id  = emi.cfop_id
                    WHERE emc.data >= '%s'
                      AND emc.data <= '%s'
                      AND emi.grade_id = %s
                      AND emc.company_id = %s
                      AND emc.state = 'F'
                      AND eno.estnto_tipo_operacao = 'S'
                      AND fc.movimento_tipo = 'C'
                      AND emi.cupom_id IS NOT NULL
                      AND not (emi.item_cancelado IS True AND ecc.tipo_cupom = 'V')
                      %s
                  ''' % (periodo_inicial, periodo_final, grade_id, company_id, sql_and)
                cr.execute(sql)
                aux = cr.dictfetchall()
                if aux:
                    aux = map(
                        lambda x: {'id': x.get('id'), 'coo': x.get('coo'), 'loja': x.get('loja'),
                                   'caixa': x.get('caixa'), 'tipo_cupom': x.get('tipo_cupom')}, aux)
                    aux = sorted(aux, key=lambda x: (x.get('loja'), x.get('caixa'), x.get('coo')))
                    for j in aux:
                        if j.get('tipo_cupom') == 'C':
                            continue
                        indice_atual = aux.index(j)
                        if j != aux[-1] and aux[indice_atual + 1].get('tipo_cupom') == 'C':
                            continue
                        mov_item_ids.append(j.get('id'))
            total_custo_corrigido = i.get('total_custo_corrigido') or 0
            total_ultimo_custo = i.get('total_ultimo_custo') or 0
            total_medio_contabil = i.get('total_custo_medio_contabil') or 0
            total_custo_reposicao = i.get('total_custo_reposicao') or 0
            vr_total_item = i.get('vr_total_item')
            custo_corrigido = total_custo_corrigido / quantidade
            ultimo_custo = total_ultimo_custo / quantidade
            medio_contabil = total_medio_contabil / quantidade
            custo_reposicao = total_custo_reposicao / quantidade
            vr_unitario_item = vr_total_item / quantidade
            i['vr_unitario_item'] = vr_unitario_item
            if custo_utilizado == 'C':
                custo_unitario = custo_corrigido
                custo_total = total_custo_corrigido
            elif custo_utilizado == 'M':
                custo_unitario = medio_contabil
                custo_total = total_medio_contabil
            elif custo_utilizado == 'R':
                custo_unitario = custo_reposicao
                custo_total = total_custo_reposicao
            else:
                custo_unitario = ultimo_custo
                custo_total = total_ultimo_custo
            i['custo_unitario'] = custo_unitario
            i['custo_total'] = custo_total
            if rentabilidade_por_familia:
                percent_part = vr_total_item / categorias.get(i.get('categoria_id')).get(
                    'total_categoria') * 100
            else:
                percent_part = vr_total_item / total_valor * 100
            i['percent_part'] = percent_part
            valor_agregado = vr_total_item - custo_total
            percent_venda = 0.0
            if vr_total_item:
                percent_venda = valor_agregado / (vr_total_item * 100)
            i['percent_venda'] = percent_venda
            percent_custo = (valor_agregado) / custo_total * 100 if custo_total else 0.0
            i['percent_custo'] = percent_custo
            impostos = 0
            if len(mov_item_ids) == 1:
                mov_item_ids = '''
                            WHERE movimento_itens_id = %s
                               ''' % (str(mov_item_ids).replace('[', '').replace(']', ''))
            else:
                mov_item_ids = '''
                            WHERE movimento_itens_id in %s
                               ''' % (str(mov_item_ids).replace('[', '(').replace(']', ')'))
            sql_vr_encargos = '''
                            SELECT sum(vr_encargo) AS vr_encargo
                            FROM fiscal_nf_item_tributacao %s
                            ''' % (mov_item_ids)
            cr.execute(sql_vr_encargos)
            vr_encargos = cr.dictfetchall()
            if vr_encargos and isinstance(vr_encargos, list):
                vr_encargos = vr_encargos[0]
            if vr_encargos and isinstance(vr_encargos, dict):
                vr_encargos = vr_encargos.get('vr_encargo')
            if vr_encargos:
                impostos = vr_encargos
            valor_agreg_liq = valor_agregado - impostos
            i['valor_agregado_liquido'] = valor_agreg_liq
            i['impostos'] = impostos
            i['valor_agregado'] = valor_agregado

        if ordem == 'Val':
            if rentabilidade_por_familia:
                new_dados_mov_itens = list()
                dados_mov_intens = sorted(dados_mov_intens,
                                          key=lambda i: i.get('categoria_id'))
                for categoria in categorias:
                    dados = filter(lambda i: i.get('categoria_id') == categoria, dados_mov_intens)
                    dados = sorted(dados, key=lambda i: i.get('valor_agregado_liquido'),
                                   reverse=True)
                    new_dados_mov_itens.extend(dados)
                dados_mov_intens = new_dados_mov_itens
            else:
                dados_mov_intens = sorted(dados_mov_intens,
                                          key=lambda i: i.get('valor_agregado_liquido'),
                                          reverse=True)

        for i in dados_mov_intens:
            if not categoria_inicial:
                categoria_inicial = i.get('categoria_id')
            # imprime totais por categoria
            if rentabilidade_por_familia and (
                    categoria_inicial != i.get('categoria_id') or i == dados_mov_intens[-1]):
                listagem.imprimeLinha(
                    '|                                                                                                                                                                                  |')
                linha = _('| Total da categoria                                      ')
                linha += formataString(getNumeroEditado(totais_por_categoria.get('quantidade'), 3),
                                       10, ' ', 'E', 'N', 'S')
                linha += formataString(getNumeroEditado(totais_por_categoria.get('custo_total')),
                                       24, ' ', 'E', 'N', 'S')
                linha += formataString(getNumeroEditado(totais_por_categoria.get('venda_total')),
                                       25, ' ', 'E', 'N', 'S')
                linha += ''.rjust(30, ' ')
                linha += formataString(getNumeroEditado(totais_por_categoria.get('valor_agreg')),
                                       10, ' ', 'E', 'N', 'S')
                linha += formataString(getNumeroEditado(totais_por_categoria.get('impostos')), 11,
                                       ' ', 'E', 'N', 'S')
                linha += formataString(
                    getNumeroEditado(totais_por_categoria.get('valor_agreg_liq')), 11, ' ', 'E',
                    'N', 'S')
                linha += '|'
                listagem.imprimeLinha(linha)
                if not i == dados_mov_intens[-1]:
                    listagem.imprimeLinha(
                        '*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
                categoria_inicial = i.get('categoria_id')
                totais_por_categoria = {'quantidade': 0, 'custo_total': 0, 'venda_total': 0,
                                        'valor_agreg': 0, 'impostos': 0,
                                        'valor_agreg_liq': 0}
            quantidade = i.get('quantidade')
            # nao imprime os movimentos com com zero na quantidade devido a anulacao dos cupons cancelados
            if not quantidade:
                continue

            # imprime nome da categoria
            if rentabilidade_por_familia and not categorias.get(i.get('categoria_id')).get(
                    'ja_imprimiu'):
                if i == dados_mov_intens[-1]:
                    listagem.imprimeLinha(
                        '*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
                categorias[i.get('categoria_id')]['ja_imprimiu'] = True
                linha = '|'
                nome_categoria = categorias.get(i.get('categoria_id')).get('nome_categoria')
                if not nome_categoria:
                    nome_categoria = 'Sem categoria'
                nome_categoria = ' Categoria: ' + nome_categoria
                linha += formataString(nome_categoria, 178, ' ', 'D', 'N', 'S') + '|'
                listagem.imprimeLinha(linha)

            nome = i.get('nome_produto') or False
            codigo = i.get('codigo_produto') or False
            grade = i.get('grade') or False

            linha = '| '
            linha += formataString(nome, 40, ' ', 'D', 'N', 'S')
            linha += formataString(codigo, 10, ' ', 'E', 'N', 'S')
            linha += formataString(' ', 2, ' ', 'E', 'N', 'S')
            linha += formataString(grade, 6, ' ', 'D', 'N', 'S')
            linha += formataString(getNumeroEditado(quantidade, 3), 8, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(i.get('custo_unitario')), 13, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(i.get('custo_total')), 11, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(i.get('vr_unitario_item')), 10, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(i.get('vr_total_item')), 15, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(i.get('percent_part')), 8, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(i.get('percent_venda')), 10, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(i.get('percent_custo')), 12, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(i.get('valor_agregado')), 10, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(i.get('impostos')), 11, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(i.get('valor_agregado_liquido')), 11, ' ', 'E', 'N', 'S')
            linha += '|'
            listagem.imprimeLinha(linha)

            total_quantidade += quantidade
            total_custo += (i.get('custo_total') or 0)
            total_valor_agregado += i.get('valor_agregado')
            total_impostos += i.get('impostos')
            total_valor_agreg_liq += i.get('valor_agregado_liquido')
            totais_por_categoria['quantidade'] += quantidade
            totais_por_categoria['custo_total'] += custo_total
            totais_por_categoria['venda_total'] += i.get('vr_total_item')
            totais_por_categoria['valor_agreg'] += i.get('valor_agregado')
            totais_por_categoria['impostos'] += i.get('impostos')
            totais_por_categoria['valor_agreg_liq'] += i.get('valor_agregado_liquido')

            if i == dados_mov_intens[-1]:
                # imprime totais por categoria
                if rentabilidade_por_familia:
                    listagem.imprimeLinha(
                        '|                                                                                                                                                                                  |')
                    linha = _('| Total da categoria                                      ')
                    linha += formataString(
                        getNumeroEditado(totais_por_categoria.get('quantidade'), 3), 10, ' ', 'E',
                        'N', 'S')
                    linha += formataString(
                        getNumeroEditado(totais_por_categoria.get('custo_total')), 24, ' ', 'E',
                        'N', 'S')
                    linha += formataString(
                        getNumeroEditado(totais_por_categoria.get('venda_total')), 25, ' ', 'E',
                        'N', 'S')
                    linha += ''.rjust(30, ' ')
                    linha += formataString(
                        getNumeroEditado(totais_por_categoria.get('valor_agreg')), 10, ' ', 'E',
                        'N', 'S')
                    linha += formataString(getNumeroEditado(totais_por_categoria.get('impostos')),
                                           11, ' ', 'E', 'N', 'S')
                    linha += formataString(
                        getNumeroEditado(totais_por_categoria.get('valor_agreg_liq')), 11, ' ', 'E',
                        'N', 'S')
                    linha += '|'
                    listagem.imprimeLinha(linha)

        listagem.imprimeLinha(
            '*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.imprimeLinha(
            '|                                                                                                                                                                                  |')

        linha = _('| Totais                                                  ')
        linha += formataString(getNumeroEditado(total_quantidade, 3), 10, ' ', 'E', 'N', 'S')
        linha += formataString(getNumeroEditado(total_custo), 24, ' ', 'E', 'N', 'S')
        linha += formataString(getNumeroEditado(total_valor), 25, ' ', 'E', 'N', 'S')
        linha += ''.rjust(30, ' ')
        linha += formataString(getNumeroEditado(total_valor_agregado), 10, ' ', 'E', 'N', 'S')
        linha += formataString(getNumeroEditado(total_impostos), 11, ' ', 'E', 'N', 'S')
        linha += formataString(getNumeroEditado(total_valor_agreg_liq), 11, ' ', 'E', 'N', 'S')
        linha += '|'

        listagem.imprimeLinha(linha)
        listagem.imprimeLinha(
            '*----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_rentabilidade')


class wizard_listagem_rentabilidade_osv(osv.TransientModel):
    _name = 'wizard.listagem.rentabilidade.osv'
    _columns = {
        'company_id': fields.many2one('res.company', 'Empresa'),
        'periodo_inicial': fields.date('Periodo inicial', required=True),
        'periodo_final': fields.date('Periodo final', required=True),
        'ordem': fields.selection(
            [('Val', 'Valor Agregado'), ('Par', '% Participacao'), ('Ven', '% Venda'),
             ('Cus', '% Custo')], 'Ordem a Listar'),
        'custo': fields.selection(
            [('M', 'Medio'), ('C', 'Corrigido'), ('R', 'Reposicao'), ('U', 'Ultimo Custo')],
            'Custo a Utilizar'),
        'categoria_id': fields.many2one('estoque.categoria', 'Categoria'),
        'rentabilidade_por_familia': fields.boolean('Rentabilidade por categoria'),
        'fabricante_id': fields.many2one("adm.pessoa", 'Fabricante', select=True,
                                         ondelete="restrict"),

    }
    _defaults = {
        'periodo_inicial': time.strftime('%Y-%m-%d'),
        'periodo_final': time.strftime('%Y-%m-%d'),
        'ordem': 'Val',
        'custo': 'M',
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        estrutura, dados = self.get_dados_rel(cr, uid, ids, context)
        context['estrutura'] = estrutura
        context['dados'] = dados
        return self.pool.get('wizard.relatorios.impressao').get_tela_relatorios(cr, uid, context)

    def get_query_quantidade(self, cr, uid, context=None):
        """
        O metodo encontra a forma de trazer a quantidade movimentada.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param context: dados com valores contextuais.
        :type context: dict
        :return: query responsavel pela quantidade movimentada.
        :rtype: str
        """
        context = context and context.copy() or {}
        sql = """
            emi.quantidade   	      AS quantidade ,
        """
        return sql

    def get_movimento(self, cr, uid, brw_filtro, context):
        context = context and context.copy() or {}
        periodo_inicial = brw_filtro.periodo_inicial
        periodo_final = brw_filtro.periodo_final
        custo_utilizado = brw_filtro.custo
        ordem = brw_filtro.ordem
        company_id = brw_filtro.company_id.id
        if not company_id:
            company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                                                    context=context)
        categoria_ids = []
        if brw_filtro.categoria_id:
            categoria_ids = self.pool.get('estoque.categoria').search(
                cr, uid, [('parent_id', 'child_of', brw_filtro.categoria_id.id)], context=context)

        sql_and = ''' '''
        if categoria_ids:
            sql_and += '''AND ep.categoria_id IN (%s)
                                  ''' % ','.join(map(lambda x: '%s' % x, categoria_ids))
        fabricante_id = brw_filtro.fabricante_id
        if fabricante_id:
            sql_and += '''AND ep.fabricante_id = %s
                                  ''' % (fabricante_id)
        rentabilidade_por_familia = brw_filtro.rentabilidade_por_familia
        sql = '''
                        SELECT nome_produto,
                               categoria_id,
                               codigo_produto,
                               grade_id,
                               grade,
                               sum(quantidade)   	     AS quantidade,
                               sum(custo_corrigido)	     AS total_custo_corrigido,
                               sum(ultimo_custo)         AS total_ultimo_custo,
                               sum(custo_medio_contabil) AS total_custo_medio_contabil,
                               sum(custo_reposicao)      AS total_custo_reposicao,
                               sum(vr_total_item) 	     AS vr_total_item
                        FROM (
                                SELECT epg.name        		      AS nome_produto,
                                       ep.categoria_id            AS categoria_id,
                                       ep.codigo       		      AS codigo_produto,
                                       emi.grade_id               AS grade_id,
                                       epg.grade     		      AS grade,
                                       %s
                                       emi.estmvi_saidas_custo_corrigido_total AS custo_corrigido,
                                       emi.estmvi_saidas_ultimo_custo_total    AS ultimo_custo,
                                       emi.estmvi_saidas_custo_medio_contabil_total AS custo_medio_contabil,
                                       emi.estmvi_saidas_custo_reposicao_total AS custo_reposicao,
                                       emi.vr_total_item_rateado     AS vr_total_item,
                                       emi.produto_id
                                FROM estoque_movimento_itens         AS emi
                                INNER JOIN estoque_movimento_capa    AS emc ON emc.id = emi.capa_id
                                INNER JOIN estoque_produto           AS ep  ON ep.id  = emi.produto_id
                                INNER JOIN estoque_produto_grade     AS epg ON epg.id = emi.grade_id
                                INNER JOIN estoque_produto_embalagem AS epe ON epe.id = emi.produto_embalagem_id
                                INNER JOIN estoque_embalagem 	     AS ee  ON ee.id  = epe.embalagem_id
                                INNER JOIN estoque_natureza_operacao AS eno ON eno.id = emc.estmvc_operacao_id
                                INNER JOIN fiscal_cfop               AS fc  ON fc.id  = emi.cfop_id
                                WHERE emc.data >= '%s'
                                  AND emc.data <= '%s'
                                  AND emc.state = 'F'
                                  AND emc.company_id = %s
                                  AND eno.estnto_tipo_operacao = 'S'
                                  AND fc.movimento_tipo = 'C'
                                  AND emi.nf_id IS NOT NULL
                                  %s
                        ''' % (self.get_query_quantidade(cr, uid, context), periodo_inicial,
                               periodo_final, company_id, sql_and)

        ecf_instalado = pooler.get_pool(cr.dbname).get('adm.utils').admutl_check_modulo_instalado(
            cr, uid, 'ecf', context=context)
        if ecf_instalado:

            sql += '''
                                UNION ALL
                          '''
            sql += '''
                                SELECT epg.name        		       AS nome_produto,
                                       ep.categoria_id             AS categoria_id,
                                       ep.codigo       		       AS codigo_produto,
                                       emi.grade_id                AS grade_id,
                                       epg.grade     		       AS grade,
                                       (CASE WHEN ecc.tipo_cupom = 'C'
                                             THEN -emi.quantidade
                                             ELSE emi.quantidade
                                        END) AS quantidade ,
                                       (CASE WHEN ecc.tipo_cupom = 'C'
                                             THEN -emi.estmvi_saidas_custo_corrigido_total
                                             ELSE emi.estmvi_saidas_custo_corrigido_total
                                        END)                       AS custo_corrigido ,
                                       (CASE WHEN ecc.tipo_cupom = 'C'
                                             THEN -emi.estmvi_saidas_ultimo_custo_total
                                             ELSE emi.estmvi_saidas_ultimo_custo_total
                                        END)                       AS ultimo_custo ,
                                       (CASE WHEN ecc.tipo_cupom = 'C'
                                             THEN -emi.estmvi_saidas_custo_medio_contabil_total
                                             ELSE emi.estmvi_saidas_custo_medio_contabil_total
                                        END)                       AS custo_medio_contabil ,
                                       (CASE WHEN ecc.tipo_cupom = 'C'
                                             THEN -emi.estmvi_saidas_custo_reposicao_total
                                             ELSE emi.estmvi_saidas_custo_reposicao_total
                                        END)                       AS custo_reposicao,
                                       (CASE WHEN ecc.tipo_cupom = 'C'
                                             THEN -emi.vr_total_item_rateado
                                             ELSE emi.vr_total_item_rateado
                                        END)                       AS vr_total_item,
                                       emi.produto_id
                                FROM estoque_movimento_itens         AS emi
                                INNER JOIN estoque_movimento_capa    AS emc ON emc.id = emi.capa_id
                                INNER JOIN estoque_produto           AS ep  ON ep.id  = emi.produto_id
                                INNER JOIN estoque_produto_grade     AS epg ON epg.id = emi.grade_id
                                INNER JOIN estoque_produto_embalagem AS epe ON epe.id = emi.produto_embalagem_id
                                INNER JOIN estoque_embalagem 	     AS ee  ON ee.id  = epe.embalagem_id
                                INNER JOIN estoque_natureza_operacao AS eno ON eno.id = emc.estmvc_operacao_id
                                LEFT  JOIN ecf_cupons_capa 	         AS ecc ON ecc.id = emi.cupom_id
                                INNER JOIN fiscal_cfop               AS fc  ON fc.id  = emi.cfop_id
                                WHERE emc.data >= '%s'
                                  AND emc.data <= '%s'
                                  AND emc.state = 'F'
                                  AND emc.company_id = %s
                                  AND eno.estnto_tipo_operacao = 'S'
                                  AND fc.movimento_tipo = 'C'
                                  AND emi.cupom_id IS NOT NULL
                                  AND not (emi.item_cancelado IS True AND ecc.tipo_cupom = 'V')
                                  %s
                              ) AS tmp
                        GROUP BY categoria_id, nome_produto, codigo_produto, produto_id, grade_id,
                                 grade
                        ORDER BY categoria_id, produto_id, grade
                      ''' % (periodo_inicial, periodo_final, company_id, sql_and)
        else:
            sql += ''') AS tmp
                        GROUP BY categoria_id, nome_produto, codigo_produto, produto_id, grade_id,
                                 grade
                        ORDER BY categoria_id, produto_id, grade
                           '''
        cr.execute(sql)
        dados_mov_intens = cr.dictfetchall()
        total_quantidade = 0
        total_custo = 0
        total_valor = sum(map(lambda x: x.get('vr_total_item'), dados_mov_intens))  # total da venda
        total_valor_agregado = 0
        total_impostos = 0
        total_valor_agreg_liq = 0
        obj_estoque_categoria = self.pool.get('estoque.categoria')
        if rentabilidade_por_familia:
            categorias = list(set(map(lambda x: x.get('categoria_id'), dados_mov_intens)))
            aux = {}
            # pega o tatal de cada categoria e o nome da categoria
            for categ in categorias:
                aux[categ] = {}
                aux[categ]['total_categoria'] = sum(
                    map(lambda x: x.get('vr_total_item') if x.get('categoria_id') == categ else 0,
                        dados_mov_intens))
                nome_completo = obj_estoque_categoria.browse(cr, uid, categ).nome_completo
                aux[categ]['nome_categoria'] = nome_completo or 'Sem categoria'
                aux[categ]['ja_imprimiu'] = False
            categorias = aux.copy()

        totais_por_categoria = {'quantidade': 0, 'custo_total': 0, 'venda_total': 0,
                                'valor_agreg': 0, 'impostos': 0,
                                'valor_agreg_liq': 0}
        categoria_inicial = ''

        for i in dados_mov_intens:
            quantidade = i.get('quantidade')
            # retira os itens onde os cupons foram cancelados, logo a quantidade eh zero
            if not quantidade:
                continue

            grade_id = i.get('grade_id')
            sql = '''
                            SELECT emi.id
                            FROM estoque_movimento_itens         AS emi
                            INNER JOIN estoque_movimento_capa    AS emc ON emc.id = emi.capa_id
                            INNER JOIN estoque_produto           AS ep  ON ep.id  = emi.produto_id
                            INNER JOIN estoque_natureza_operacao AS eno ON eno.id = emc.estmvc_operacao_id
                            INNER JOIN fiscal_cfop               AS fc  ON fc.id  = emi.cfop_id
                            WHERE emc.data >= '%s'
                              AND emc.data <= '%s'
                              AND emi.grade_id = %s
                              AND emc.company_id = %s
                              AND emc.state = 'F'
                              AND eno.estnto_tipo_operacao = 'S'
                              AND fc.movimento_tipo = 'C'
                              AND emi.nf_id IS NOT NULL
                              %s
                          ''' % (periodo_inicial, periodo_final, grade_id, company_id, sql_and)
            cr.execute(sql)
            aux = cr.dictfetchall()
            mov_item_ids = []
            if aux:
                mov_item_ids = map(lambda x: x.get('id'), aux)
            if ecf_instalado:
                sql = '''
                            SELECT emi.id, ee.caixa, ee.loja, ecc.coo, ecc.tipo_cupom
                            FROM estoque_movimento_itens         AS emi
                            INNER JOIN estoque_movimento_capa    AS emc ON emc.id = emi.capa_id
                            INNER JOIN estoque_produto           AS ep  ON ep.id  = emi.produto_id
                            INNER JOIN estoque_natureza_operacao AS eno ON eno.id = emc.estmvc_operacao_id
                            LEFT  JOIN ecf_cupons_capa 	         AS ecc ON ecc.id = emi.cupom_id
                            LEFT  JOIN ecf_ecf                   AS ee  ON ee.id  = ecc.ecf_id
                            INNER JOIN fiscal_cfop               AS fc  ON fc.id  = emi.cfop_id
                            WHERE emc.data >= '%s'
                              AND emc.data <= '%s'
                              AND emi.grade_id = %s
                              AND emc.company_id = %s
                              AND emc.state = 'F'
                              AND eno.estnto_tipo_operacao = 'S'
                              AND fc.movimento_tipo = 'C'
                              AND emi.cupom_id IS NOT NULL
                              AND not (emi.item_cancelado IS True AND ecc.tipo_cupom = 'V')
                              %s
                          ''' % (periodo_inicial, periodo_final, grade_id, company_id, sql_and)
                cr.execute(sql)
                aux = cr.dictfetchall()
                if aux:
                    aux = map(
                        lambda x: {'id': x.get('id'), 'coo': x.get('coo'), 'loja': x.get('loja'),
                                   'caixa': x.get('caixa'), 'tipo_cupom': x.get('tipo_cupom')}, aux)
                    aux = sorted(aux, key=lambda x: (x.get('loja'), x.get('caixa'), x.get('coo')))
                    for j in aux:
                        if j.get('tipo_cupom') == 'C':
                            continue
                        indice_atual = aux.index(j)
                        if j != aux[-1] and aux[indice_atual + 1].get('tipo_cupom') == 'C':
                            continue
                        mov_item_ids.append(j.get('id'))
            total_custo_corrigido = i.get('total_custo_corrigido') or 0
            total_ultimo_custo = i.get('total_ultimo_custo') or 0
            total_medio_contabil = i.get('total_custo_medio_contabil') or 0
            total_custo_reposicao = i.get('total_custo_reposicao') or 0
            vr_total_item = i.get('vr_total_item')
            custo_corrigido = total_custo_corrigido / quantidade
            ultimo_custo = total_ultimo_custo / quantidade
            medio_contabil = total_medio_contabil / quantidade
            custo_reposicao = total_custo_reposicao / quantidade
            vr_unitario_item = vr_total_item / quantidade
            i['vr_unitario_item'] = vr_unitario_item
            if custo_utilizado == 'C':
                custo_unitario = custo_corrigido
                custo_total = total_custo_corrigido
            elif custo_utilizado == 'M':
                custo_unitario = medio_contabil
                custo_total = total_medio_contabil
            elif custo_utilizado == 'R':
                custo_unitario = custo_reposicao
                custo_total = total_custo_reposicao
            else:
                custo_unitario = ultimo_custo
                custo_total = total_ultimo_custo

            i['custo_unitario'] = custo_unitario
            i['custo_total'] = custo_total
            if rentabilidade_por_familia:
                percent_part = vr_total_item / categorias.get(i.get('categoria_id')).get(
                    'total_categoria') * 100
            else:
                percent_part = vr_total_item / total_valor * 100
            i['percent_part'] = percent_part
            valor_agregado = vr_total_item - custo_total
            percent_venda = 0.0
            if vr_total_item:
                percent_venda = (valor_agregado / vr_total_item) * 100
            i['percent_venda'] = percent_venda
            percent_custo = (valor_agregado) / custo_total * 100 if custo_total else 0.0
            i['percent_custo'] = percent_custo
            impostos = 0
            if len(mov_item_ids) == 1:
                mov_item_ids = '''
                                    WHERE movimento_itens_id = %s
                                       ''' % (str(mov_item_ids).replace('[', '').replace(']', ''))
            else:
                mov_item_ids = '''
                                    WHERE movimento_itens_id in %s
                                       ''' % (str(mov_item_ids).replace('[', '(').replace(']', ')'))
            sql_vr_encargos = '''
                                    SELECT sum(vr_encargo) AS vr_encargo
                                    FROM fiscal_nf_item_tributacao %s
                                    ''' % (mov_item_ids)
            cr.execute(sql_vr_encargos)
            vr_encargos = cr.dictfetchall()
            if vr_encargos and isinstance(vr_encargos, list):
                vr_encargos = vr_encargos[0]
            if vr_encargos and isinstance(vr_encargos, dict):
                vr_encargos = vr_encargos.get('vr_encargo')
            if vr_encargos:
                impostos = vr_encargos
            valor_agreg_liq = valor_agregado - impostos
            i['valor_agregado_liquido'] = valor_agreg_liq
            i['impostos'] = impostos
            i['valor_agregado'] = valor_agregado

        if ordem == 'Val':
            if rentabilidade_por_familia:
                new_dados_mov_itens = list()
                dados_mov_intens = sorted(dados_mov_intens,
                                          key=lambda i: i.get('categoria_id'))
                for categoria in categorias:
                    dados = filter(lambda i: i.get('categoria_id') == categoria, dados_mov_intens)
                    dados = sorted(dados, key=lambda i: i.get('valor_agregado_liquido'),
                                   reverse=True)
                    new_dados_mov_itens.extend(dados)
                dados_mov_intens = new_dados_mov_itens
            else:
                dados_mov_intens = sorted(dados_mov_intens,
                                          key=lambda i: i.get('valor_agregado_liquido'),
                                          reverse=True)

        return dados_mov_intens

    def get_dados_rel(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        brw_filtro = self.browse(cr, uid, ids[0], context)
        dados_mov_intens = self.get_movimento(cr, uid, brw_filtro, context)
        pagina = {'relpag_nome_rel': _('Listagem Rentabilidade'),
                  'relpag_tam_linha': 180,
                  'relpag_fonte_tamanho': 7.9,
                  'relpag_margem_esquerda': 0.5,
                  'relpag_margem_direita': 0.5,
                  'relpag_margem_superior': 0.5,
                  'relpag_margem_inferior': 0.5,
                  'relpag_cabecalhos': [{'relcab_name': 'cab1',
                                         'relcab_colunas': [{'relcol_name': 'descricao1',
                                                             'relcol_dados_tam': 16},
                                                            {'relcol_name': 'titulo',
                                                             'relcol_dados_tam': 155,
                                                             'relcol_dados_alinhamento': 'C'},
                                                            {'relcol_name': 'descricao2',
                                                             'relcol_dados_tam': 9}]},
                                        {'relcab_name': 'cab2',
                                         'relcab_colunas': [{'relcol_name': 'data',
                                                             'relcol_dados_tam': 16},
                                                            {'relcol_name': 'empresa',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 153},
                                                            {'relcol_name': 'pagina',
                                                             'relcol_dados_tam': 9}], },
                                        {'relcab_name': 'cab3',
                                         'relcab_divide_linha': True,
                                         'relcab_colunas': [{'relcol_name': 'periodo',
                                                             'relcol_dados_tam': 35},
                                                            {'relcol_name': 'custo_usado',
                                                             'relcol_dados_tam': 35},
                                                            {'relcol_name': 'ordem',
                                                             'relcol_dados_tam': 110}], },
                                        {'relcab_name': 'cab4',
                                         'relcab_colunas': [{'relcol_name': 'saidas',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 180},], },
                                        {'relcab_name': 'cab5',
                                         'relcab_cor': 'Blue',
                                         'relcab_colunas': [{'relcol_name': 'col1',
                                                             'relcol_dados_alinhamento': 'D',
                                                             'relcol_dados_tam': 40},
                                                            {'relcol_name': 'col2',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 10},
                                                            {'relcol_name': 'col3',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 6},
                                                            {'relcol_name': 'col4',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 8},
                                                            {'relcol_name': 'col5',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 24},
                                                            {'relcol_name': 'col6',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 25},
                                                            {'relcol_name': 'col7',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 8},
                                                            {'relcol_name': 'col8',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 10},
                                                            {'relcol_name': 'col9',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 12},
                                                            {'relcol_name': 'col10',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 10},
                                                            {'relcol_name': 'col11',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 11},
                                                            {'relcol_name': 'col12',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 11},
                                                            {'relcol_name': 'col13',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 11},
                                                            {'relcol_name': 'col14',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 11}
                                                            ], },
                                        {'relcab_name': 'cab_col',
                                         'relcab_divide_linha': True,
                                         'relcab_cor': 'Blue',
                                         # 'relcab_separa_coluna': '|',
                                         'relcab_colunas': [{'relcol_name': 'col1',
                                                             'relcol_dados_alinhamento': 'D',
                                                             'relcol_dados_tam': 40},
                                                            {'relcol_name': 'col2',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 10},
                                                            {'relcol_name': 'col3',
                                                             'relcol_dados_alinhamento': 'D',
                                                             'relcol_dados_tam': 6},
                                                            {'relcol_name': 'col4',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 8},
                                                            {'relcol_name': 'col5',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 13},
                                                            {'relcol_name': 'col6',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 11},
                                                            {'relcol_name': 'col7',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 10},
                                                            {'relcol_name': 'col8',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 15},
                                                            {'relcol_name': 'col9',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 8},
                                                            {'relcol_name': 'col10',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 10},
                                                            {'relcol_name': 'col11',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 12},
                                                            {'relcol_name': 'col12',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 10},
                                                            {'relcol_name': 'col13',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 11},
                                                            {'relcol_name': 'col14',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 11},]
                                         }, ],

                  'relpag_linhas': [{'rellin_name': 'linha1',
                                     # 'rellin_separa_coluna': '|',
                                     'rellin_colunas': [{'relcol_name': 'nome',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 40},
                                                        {'relcol_name': 'codigo',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 10},
                                                        {'relcol_name': 'grade',
                                                         'relcol_dados_alinhamento': 'D',
                                                         'relcol_dados_tam': 6},
                                                        {'relcol_name': 'quantidade',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 8},
                                                        {'relcol_name': 'custo_unitario',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 13},
                                                        {'relcol_name': 'custo_total',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 11},
                                                        {'relcol_name': 'vr_unitario',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 10},
                                                        {'relcol_name': 'vr_total',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 15},
                                                        {'relcol_name': 'percent_part',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 8},
                                                        {'relcol_name': 'percent_venda',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 10},
                                                        {'relcol_name': 'percent_custo',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 12},
                                                        {'relcol_name': 'valor_agregado',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 10},
                                                        {'relcol_name': 'imposto',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 11},
                                                        {'relcol_name': 'valor_agregado_liquido',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 11},]
                                     }, ],
                  }
        if brw_filtro.rentabilidade_por_familia:
            categorias = list(set(map(lambda x: x.get('categoria_id'), dados_mov_intens)))
            aux = {}
            # pega o tatal de cada categoria e o nome da categoria
            for categ in categorias:
                aux[categ] = {}
                aux[categ]['total_categoria'] = sum(
                    map(lambda x: x.get('vr_total_item') if x.get('categoria_id') == categ else 0,
                        dados_mov_intens))
                nome_completo = self.pool.get('estoque.categoria').browse(cr, uid, categ).nome_completo
                aux[categ]['nome_categoria'] = nome_completo or 'Sem categoria'
                aux[categ]['ja_imprimiu'] = False

            categorias = aux.copy()
            pagina['relpag_linhas'] = [{'rellin_name': 'linha_categ',
                                        'rellin_colunas': [{'relcol_name': 'nome_categoria',
                                                            'relcol_dados_alinhamento': 'D',
                                                            'relcol_dados_tam': 40},]
                                        }] + [pagina['relpag_linhas'][0].copy()] + \
                                             [pagina['relpag_linhas'][0].copy()] + \
                                             [pagina['relpag_linhas'][0].copy()]
            pagina['relpag_linhas'][2].update({'rellin_name': 'linha_tot_categ',
                                               'rellin_divide_linha': True})

        pagina['relpag_linhas'] += [pagina['relpag_linhas'][0].copy()]
        pagina['relpag_linhas'][-1].update({'rellin_name': 'linha_total'})

        totais_por_categoria = {'quantidade': 0, 'custo_total': 0, 'venda_total': 0,
                                'valor_agreg': 0, 'impostos': 0,
                                'valor_agreg_liq': 0}
        categoria_inicial = ''
        periodo_inicial = brw_filtro.periodo_inicial
        periodo_final = brw_filtro.periodo_final
        custo_utilizado = brw_filtro.custo
        if custo_utilizado == 'M':
            custo_extenso = _('Medio')
        elif custo_utilizado == 'C':
            custo_extenso = _('Corrigido')
        elif custo_utilizado == 'R':
            custo_extenso = _('Reposicao')
        else:
            custo_extenso = _('Ultimo Custo')

        ordem = brw_filtro.ordem
        if ordem == 'Val':
            ordem_extenso = _('Valor Agregado')
        elif ordem == 'Par':
            ordem_extenso = _('% Participacao')
        elif ordem == 'Ven':
            ordem_extenso = _('% Venda')
        else:
            ordem_extenso = _('% Custo')

        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, context=context)
        nome_empresa = self.pool.get("res.company").read(cr, uid, company_id, ['name'],
                                                         context).get('name')
        dados = {'cab1': {'descricao1': _('Contr.Estoque'),
                          'titulo': _('Rel. Rentabilidade p/ familia'),
                          'descricao2': _('Est445')},
                 'cab2': {'data': _('Data: ') + time.strftime('%d/%m/%Y'),
                          'empresa': nome_empresa,
                          'pagina': '|pag|'},
                 'cab3': {'periodo': 'Periodo: %s' % (time.strftime("%d/%m/%Y",
                                                      time.strptime(periodo_inicial, "%Y-%m-%d")) + ' a ' +
                                                      time.strftime("%d/%m/%Y", time.strptime(periodo_final, "%Y-%m-%d"))),
                          'custo_usado': 'Custo Utilizado: %s' % custo_extenso,
                          'ordem': 'Ordem: %s' % ordem_extenso},
                 'cab4': {'saidas': _('>>>>>>>>>>>>>>>>>>>>>> SAIDAS <<<<<<<<<<<<<<<<<<<<<<<')},
                 'cab5': {'col1': '',
                          'col2': _('Codigo'),
                          'col3': '',
                          'col4': '',
                          'col5': _('>>>> PRECO CUSTO <<<<'),
                          'col6': _('>>>> PRECO VENDA <<<<'),
                          'col7': _('%'),
                          'col8': _('%'),
                          'col9': _('%'),
                          'col10': _('Valor'),
                          'col11': _('Valor'),
                          'col12': _('Valor'),
                          'col13': '',
                          'col14': ''},
                 'cab_col': {'col1': _('P r o d u t o'),
                             'col2': _('Interno'),
                             'col3': _('GR'),
                             'col4': _('Quantid.'),
                             'col5': _('Unitar.'),
                             'col6': _('Total'),
                             'col7': _('Unitar.'),
                             'col8': _('Total.'),
                             'col9': _('Part.'),
                             'col10': _('Venda'),
                             'col11': _('Custo'),
                             'col12': _('Agregado'),
                             'col13': _('Impostos'),
                             'col14': _('Agreg.Liqu')},
                 }
        linhas = []
        total_quantidade = total_venda = total_custo = total_valor_agregado = total_impostos = \
                           total_valor_agreg_liq = 0
        for i in self.read(cr, uid, ids, [], context=context):
            for item in dados_mov_intens:
                if brw_filtro.rentabilidade_por_familia:
                    if item.get('categoria_id') != categoria_inicial:
                        if categoria_inicial:
                            linhas.append({'linha_tot_categ': {'nome':  _('Total da categoria'),
                                                               'codigo': '',
                                                               'grade': '',
                                                               'quantidade': getNumeroEditado(totais_por_categoria.get('quantidade'), 3),
                                                               'custo_unitario': '',
                                                               'custo_total': getNumeroEditado(totais_por_categoria.get('custo_total')),
                                                               'vr_unitario': '',
                                                               'vr_total': getNumeroEditado(totais_por_categoria.get('venda_total')),
                                                               'percent_part': '',
                                                               'percent_venda': '',
                                                               'percent_custo': '',
                                                               'valor_agregado': getNumeroEditado(totais_por_categoria.get('valor_agreg')),
                                                               'imposto': getNumeroEditado(totais_por_categoria.get('impostos')),
                                                               'valor_agregado_liquido': getNumeroEditado(totais_por_categoria.get('valor_agreg_liq'))}})

                        categoria_inicial = item.get('categoria_id')

                    if not categorias.get(item.get('categoria_id')).get('ja_imprimiu'):
                        categorias[item.get('categoria_id')]['ja_imprimiu'] = True
                        nome_categoria = categorias.get(item.get('categoria_id')).get('nome_categoria')
                        if not nome_categoria:
                            nome_categoria = 'Sem categoria'

                        nome_categoria = 'Categoria: ' + nome_categoria
                        linhas.append({'linha_categ': {'nome_categoria': nome_categoria}})
                        totais_por_categoria = {'quantidade': 0, 'custo_total': 0, 'venda_total': 0,
                                                'valor_agreg': 0, 'impostos': 0,
                                                'valor_agreg_liq': 0}

                quantidade = item.get('quantidade')
                custo_total = item.get('custo_total') or 0.0
                preco_total = item.get('vr_total_item') or 0.0
                linhas.append({'linha1': {'nome': item.get('nome_produto'),
                                          'codigo': item.get('codigo_produto'),
                                          'grade': item.get('grade'),
                                          'quantidade': getNumeroEditado(quantidade, 3),
                                          'custo_unitario': getNumeroEditado(item.get(
                                              'custo_unitario') or 0.0),
                                          'custo_total': getNumeroEditado(custo_total),
                                          'vr_unitario': getNumeroEditado(item.get(
                                              'vr_unitario_item') or 0.0),
                                          'vr_total': getNumeroEditado(preco_total),
                                          'percent_part': getNumeroEditado(item.get(
                                              'percent_part') or 0.0),
                                          'percent_venda': getNumeroEditado(item.get(
                                              'percent_venda') or 0.0),
                                          'percent_custo': getNumeroEditado(item.get(
                                              'percent_custo') or 0.0),
                                          'valor_agregado': getNumeroEditado(item.get(
                                              'valor_agregado') or 0.0),
                                          'imposto': getNumeroEditado(item.get('impostos') or 0.0),
                                          'valor_agregado_liquido': getNumeroEditado(item.get(
                                              'valor_agregado_liquido') or 0.0)}})
                total_quantidade += quantidade
                total_custo += (custo_total or 0)
                total_venda += preco_total
                total_valor_agregado += (item.get('valor_agregado') or 0.0)
                total_impostos += (item.get('impostos') or 0.0)
                total_valor_agreg_liq += (item.get('valor_agregado_liquido') or 0.0)
                totais_por_categoria['quantidade'] += quantidade
                totais_por_categoria['custo_total'] += custo_total
                totais_por_categoria['venda_total'] += preco_total
                totais_por_categoria['valor_agreg'] += (item.get('valor_agregado') or 0)
                totais_por_categoria['impostos'] += (item.get('impostos') or 0)
                totais_por_categoria['valor_agreg_liq'] += (item.get(
                    'valor_agregado_liquido') or 0.0)
                if item == dados_mov_intens[-1]:
                    # imprime totais por categoria
                    if brw_filtro.rentabilidade_por_familia:
                        linhas.append({'linha_tot_categ': {'nome':  _('Total da categoria'),
                                                           'quantidade': getNumeroEditado(totais_por_categoria.get('quantidade'), 3),
                                                           'custo_total': getNumeroEditado(totais_por_categoria.get('custo_total')),
                                                           'vr_total': getNumeroEditado(totais_por_categoria.get('venda_total')),
                                                           'valor_agregado': getNumeroEditado(totais_por_categoria.get('valor_agreg')),
                                                           'imposto': getNumeroEditado(totais_por_categoria.get('impostos')),
                                                           'valor_agregado_liquido': getNumeroEditado(totais_por_categoria.get('valor_agreg_liq'))}})

        linhas.append({'linha_total': {'nome': _('Totais'),
                                       'quantidade': getNumeroEditado(total_quantidade, 3),
                                       'custo_total': getNumeroEditado(total_custo),
                                       'vr_total': getNumeroEditado(total_venda),
                                       'valor_agregado': getNumeroEditado(total_valor_agregado),
                                       'imposto': getNumeroEditado(total_impostos),
                                       'valor_agregado_liquido': getNumeroEditado(total_valor_agreg_liq)}})

        dados['linhas'] = linhas
        return pagina, dados
