# -*- encoding: utf-8 -*-
from SigUtils.impressao import Impressora
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
import locale
from openerp import pooler
# noinspection PyProtectedMember
from openerp.tools.translate import _


# noinspection PyPep8Naming
class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


# noinspection PyPep8Naming,PyMethodMayBeStatic,PyAttributeOutsideInit
class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        # ___________________________ Objects ________________________________
        obj_estoque_parametro = pooler.get_pool(cr.dbname).get('estoque.parametro')
        obj_estoque_local = pooler.get_pool(cr.dbname).get('estoque.local')
        obj_estoque_movimento_itens = pooler.get_pool(cr.dbname).get('estoque.movimento.itens')
        obj_estoque_categoria = pooler.get_pool(cr.dbname).get('estoque.categoria')

        company_ids = datas.get('company_ids')
        empresas = pooler.get_pool(cr.dbname).get('res.company').browse(cr, uid, company_ids)
        local_ids = datas.get('local_ids')
        locais = obj_estoque_local.browse(cr, uid, local_ids)
        periodo_inicial = datas.get('periodo_inicial')
        periodo_final = datas.get('periodo_final')
        somente_primeiro_grau = datas.get('somente_primeiro_grau')
        context['sig_force_company'] = True
        custos = dict(U='estmpg_ultimo_custo', M='estmpg_custo_medio_contabil',
                      R='estmpg_custo_reposicao', C= 'estmpg_custo_corrigido')
        porcentagem_custo_fixo_venda = 0.0
        porcentagem_comissao = 0.0
        estoque_parametro_id = obj_estoque_parametro.search(cr, uid, [('company_id','in',company_ids)], context=context)

        if estoque_parametro_id:
            browse_estoque_parametro = obj_estoque_parametro.browse(cr, uid, estoque_parametro_id[0])
            porcentagem_custo_fixo_venda = browse_estoque_parametro.custo_fixo or 0.0
            porcentagem_comissao = browse_estoque_parametro.comissoes or 0.0
            custo_preco_venda = browse_estoque_parametro.estpar_custo_para_precovenda
            custo_preco_venda = custos.get(custo_preco_venda) or ''
        else:
            custo_preco_venda = ''

        dict_categorias = {}
        categoria_pai_ids = []

        # Realiza a consulta
        cr.execute(datas.get('sql'))
        dados = cr.dictfetchall()
        dict_conta_cat_pai = {}
        for x in dados:
            movimento_tipo = x.get('estmpg_cfop_movimento')
            natureza_tipo = x.get('estmpg_tipo_movimento')
            quantidade = x.get('estmpg_quantidade') or 0.0
            custo_selecao = (x.get(custo_preco_venda) or 0.0) * quantidade
            valor = x.get('estmpg_vr_total_item') or 0.0
            comissao = (porcentagem_comissao/100) * valor
            custo_fixo_venda = (porcentagem_custo_fixo_venda/100) * valor

            valor_tributos = x.get('estmp_valor_tributos') or 0.0
            vr_icms_substituicao = x.get('estmp_icms_substituicao') or 0.0

            valor += vr_icms_substituicao
            encargos = valor_tributos + comissao + custo_fixo_venda
            produto_categoria_id = obj_estoque_categoria.browse(
                cr, uid, x.get('estmpg_categoria_id'))
            categoria_id = produto_categoria_id
            categoria_pai_id = list()
            if not categoria_id:
                categoria_pai_id.append('SEM CATEGORIA')
                produto_categoria_id = 'SEM CATEGORIA'
            while categoria_id:
                if categoria_id.parent_id:
                    nivel_pai = categoria_id.parent_id.conta
                    if nivel_pai not in dict_conta_cat_pai:
                        categoria_pai_id.append(categoria_id.parent_id)
                        dict_conta_cat_pai[nivel_pai] = categoria_id.parent_id
                    else:
                        categoria_pai_id.append(dict_conta_cat_pai.get(nivel_pai))
                else:
                    categoria_pai_id.append(categoria_id)
                categoria_id = categoria_id.parent_id

            categoria_pai_id = sorted(categoria_pai_id, key=lambda w: w.conta if not
                                      isinstance(w, basestring) else w)
            id_categoria_pai = categoria_pai_id[0]
            if not categoria_pai_id[0] in categoria_pai_ids:
                categoria_pai_ids.append(categoria_pai_id[0])
            if not somente_primeiro_grau:
                categoria_pai_id.append(produto_categoria_id)
            categoria_pai_id = list(set(categoria_pai_id))

            for e in categoria_pai_id:
                categoria_id = e.conta if not isinstance(e,basestring) else e
                categoria_name = e.name if not isinstance(e,basestring) else e

                if dict_categorias.get(categoria_id):
                    if natureza_tipo == 'E':
                        if movimento_tipo == 'D':
                            dict_categorias[categoria_id]['entrada_devolucao'] += valor or 0.0
                        elif movimento_tipo == 'T':
                            dict_categorias[categoria_id]['entrada_transferencia'] += valor or 0.0
                        elif movimento_tipo == 'C':
                            dict_categorias[categoria_id]['entrada'] += valor or 0.0
                    elif natureza_tipo == 'S':
                        if movimento_tipo == 'D':
                            dict_categorias[categoria_id]['saida_devolucao'] += valor or 0.0
                        elif movimento_tipo == 'T':
                            dict_categorias[categoria_id]['saida_transferencia'] += valor or 0.0
                        elif movimento_tipo in ('C','U') :
                            dict_categorias[categoria_id]['saida'] += valor or 0.0

                        dict_categorias[categoria_id]['custo_medio'] += x.get('estmpg_custo_medio_contabil') or 0.0
                        dict_categorias[categoria_id]['custo_corrigido'] += x.get('estmpg_custo_corrigido') or 0.0
                        porcentagem_lucratividade = (valor - custo_selecao - encargos) * (valor / 100)
                        dict_categorias[categoria_id]['lucratividade'] += porcentagem_lucratividade or 0.0
                else:
                    dict_dados = {}
                    nvl = e.conta if not isinstance(e,basestring) else 'NT'
                    nvl = nvl.split('.')
                    count = 1

                    for c in nvl:
                        if count < 5:
                            dict_dados['gr'+str(count)] = c
                        count += 1

                    dict_dados['id_categoria_pai'] = id_categoria_pai
                    dict_dados['categoria_name'] = categoria_name
                    dict_dados['entrada_devolucao'] = 0.0
                    dict_dados['entrada_transferencia'] = 0.0
                    dict_dados['entrada'] = 0.0
                    dict_dados['saida_devolucao'] = 0.0
                    dict_dados['saida_transferencia'] = 0.0
                    dict_dados['saida'] = 0.0
                    dict_dados['custo_medio'] = 0.0
                    dict_dados['custo_corrigido'] = 0.0
                    dict_dados['lucratividade'] = 0.0

                    if natureza_tipo == 'E':
                        if movimento_tipo == 'D':
                            dict_dados['entrada_devolucao'] = valor or 0.0
                        elif movimento_tipo == 'T':
                            dict_dados['entrada_transferencia'] = valor or 0.0
                        elif movimento_tipo == 'C':
                            dict_dados['entrada'] = valor or 0.0
                    elif natureza_tipo == 'S':
                        if movimento_tipo == 'D':
                            dict_dados['saida_devolucao'] = valor or 0.0
                        elif movimento_tipo == 'T':
                            dict_dados['saida_transferencia'] = valor or 0.0
                        elif movimento_tipo in ('C','U'):
                            dict_dados['saida'] = valor  or 0.0

                        dict_dados['custo_medio'] = x.get('estmpg_custo_medio_contabil') or 0.0
                        dict_dados['custo_corrigido'] = x.get('estmpg_custo_corrigido') or 0.0
                        porcentagem_lucratividade = (valor - custo_selecao - encargos) * (valor / 100)
                        dict_dados['lucratividade'] = porcentagem_lucratividade or 0.0

                    if not isinstance(e, basestring):
                        conta = e.conta
                    else:
                        conta = e
                    dict_categorias[conta] = dict_dados

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid, 'wizard.listagem.conferencia.osv', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data=time.strftime("%d/%m/%Y")

        title = ' {:^152} '.decode('utf-8').format(_('Totais por Categoria'))
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        det_format = '|{:^5}|{:^5}|{:^5}|{:^5}|{:<21}|{:>11}|{:>10}|{:>11}|{:>11}|{:>10}|{:>11}|{:>9}|{:>13}|{:>12}|'.decode('utf-8')
        tot_format = '|{:^45}|{:>11}|{:>10}|{:>11}|{:>11}|{:>10}|{:>11}|{:>9}|{:>13}|{:>12}|'.decode('utf-8')

        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Listagem Totais por Categoria'))
        listagem.informaTamLinha(160)
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)

        # Define a fomatacao dos numeros
        locale.setlocale(locale.LC_ALL, str('%s.UTF-8' % context.get('lang')))

        listagem.informaCab(title)
        listagem.informaCab('')
        listagem.informaCab(' {:<10} {:^130} {:>10} '.decode('utf-8').format(
            data[:10], nome_empresa[:130], _('Pagina: ')[:10] + '{{ Page }}'))
        listagem.informaCab('')
        listagem.informaCab(' {:<10} {:^10} {:^3} {:^10}'.decode('utf-8').format(
            _('Periodo:'), time.strftime("%d/%m/%Y", time.strptime(periodo_inicial, "%Y-%m-%d")),
            _(' a '), time.strftime("%d/%m/%Y", time.strptime(periodo_final, "%Y-%m-%d"))))
        listagem.informaCab(' {:<10} {:<135}'.decode('utf-8').format(
            _('Locais:')[:12], ', '.join(map(lambda m: m.name, locais) or [_('Todos')])[:135]))
        listagem.informaCab(' {:<10} {:<135}'.decode('utf-8').format(
            _('Empresas:')[:12], ', '.join(map(lambda m: m.name, empresas))[:135]))
        listagem.informaCab('')
        listagem.informaCab('*' + '-' * 152 + '*')
        listagem.informaCab('|{:^45}|{:^34}|{:^34}|{:^36}|'.decode('utf-8').format(
            '', _('E N T R A D A S')[:34], _('S A I D A S')[:34], ''))
        listagem.informaCab('*' + '-' * 152 + '*')
        listagem.informaCab(det_format.format(
            _('GR1')[:5], _('GR2')[:5], _('GR3')[:5], _('GR4')[:5], _('GRUPO')[:21],
            _('DEVOLUCAO')[:11], _('TRANSF.')[:10], _('ENTRADA')[:11], _('DEVOLUCAO')[:11],
            _('TRANSF.')[:10], _('SAIDA')[:11], _('C. MEDIO')[:9], _('C. CORRIGIDO')[:13],
            _('% LUCRAT.')[:12]))
        listagem.informaCab('*' + '-' * 152 + '*')

        listagem.rodapePadrao()

        total_entrada_devolucao = total_entrada_transferencia = total_entrada = 0.0
        total_saida_devolucao = total_saida_transferencia = total_saida = 0.0
        total_custo_medio = total_custo_corrigido = total_lucratividade = 0.0

        if dict_categorias:
            list_categorias = list(dict_categorias)
            list_categorias.sort()

            for y in categoria_pai_ids:
                for categoria in list_categorias:
                    e_devolucao = dict_categorias.get(categoria).get('entrada_devolucao')
                    e_transferencia = dict_categorias.get(categoria).get('entrada_transferencia')
                    entrada = dict_categorias.get(categoria).get('entrada')
                    s_devolucao = dict_categorias.get(categoria).get('saida_devolucao')
                    s_transferencia = dict_categorias.get(categoria).get('saida_transferencia')
                    saida = dict_categorias.get(categoria).get('saida')
                    custo_medio = dict_categorias.get(categoria).get('custo_medio')
                    custo_corrigido = dict_categorias.get(categoria).get('custo_corrigido')
                    lucratividade = dict_categorias.get(categoria).get('lucratividade')

                    if y == dict_categorias.get(categoria).get('id_categoria_pai'):
                        linha = det_format.format(
                            dict_categorias.get(categoria).get('gr1') or '',
                            dict_categorias.get(categoria).get('gr2') or '',
                            dict_categorias.get(categoria).get('gr3') or '',
                            dict_categorias.get(categoria).get('gr4') or '',
                            dict_categorias.get(categoria).get('categoria_name')[:21],
                            locale.format('%.2f', e_devolucao, grouping=True)[:11],
                            locale.format('%.2f', e_transferencia, grouping=True)[:10],
                            locale.format('%.2f', entrada, grouping=True)[:11],
                            locale.format('%.2f', s_devolucao, grouping=True)[:11],
                            locale.format('%.2f', s_transferencia, grouping=True)[:10],
                            locale.format('%.2f', saida, grouping=True)[:11],
                            locale.format('%.2f', custo_medio, grouping=True)[:9],
                            locale.format('%.2f', custo_corrigido, grouping=True)[:13],
                            locale.format('%.2f', lucratividade, grouping=True)[:12])

                        listagem.imprimeLinha(linha)

                        if dict_categorias.get(categoria).get('gr1'):
                            if not dict_categorias.get(categoria).get('gr2'):
                                if not dict_categorias.get(categoria).get('gr3'):
                                    if not dict_categorias.get(categoria).get('gr4'):
                                        total_entrada_devolucao += e_devolucao
                                        total_entrada_transferencia += e_transferencia
                                        total_entrada += entrada
                                        total_saida_devolucao += s_devolucao
                                        total_saida_transferencia += s_transferencia
                                        total_saida += saida
                                        total_custo_medio += custo_medio
                                        total_custo_corrigido += custo_corrigido
                                        total_lucratividade += lucratividade

                if y != categoria_pai_ids[-1]:
                    listagem.imprimeLinha('|' + ' ' * 152 + '|')
                else:
                    listagem.imprimeLinha('*' + '=' * 152 + '*')

            linha = tot_format.format(
                _('T O T A I S')[:45],
                locale.format('%.2f', total_entrada_devolucao, grouping=True)[:11],
                locale.format('%.2f', total_entrada_transferencia, grouping=True)[:10],
                locale.format('%.2f', total_entrada, grouping=True)[:11],
                locale.format('%.2f', total_saida_devolucao, grouping=True)[:11],
                locale.format('%.2f', total_saida_transferencia, grouping=True)[:10],
                locale.format('%.2f', total_saida, grouping=True)[:11],
                locale.format('%.2f', total_custo_medio, grouping=True)[:9],
                locale.format('%.2f', total_custo_corrigido, grouping=True)[:13],
                locale.format('%.2f', total_lucratividade, grouping=True)[:12])

            listagem.imprimeLinha(linha)
            listagem.imprimeLinha('*' + '-' * 152 + '*')

        listagem.finalizaImpressao()

        self.obj = external_pdf(pdf_string.getvalue())

        self.obj.render()
        pdf_string.close()

        return self.obj.pdf, 'pdf'

report_custom('report.listagem_totais_por_categoria')


# noinspection PyAbstractClass
class wizard_listagem_totais_por_categoria_osv(osv.TransientModel):
    _name = 'wizard.listagem.totais.por.categoria.osv'
    _columns = {
        'company_ids': fields.many2many('res.company', 'estoque_listagem_company', 'id',
                                        'company_id', 'Empresa', ondelete='cascade'),
        'local_ids': fields.many2many('estoque.local', 'estoque_listagem_local', 'id', 'local_id',
                                      'Local'),
        'periodo_inicial': fields.date('Periodo inicial', required=True),
        'periodo_final': fields.date('Periodo final', required=True),
        'somente_primeiro_grau': fields.boolean('Somente primeiro grau'),
    }
    _defaults = {
        'periodo_inicial': time.strftime('%Y-%m-%d'),
        'periodo_final': time.strftime('%Y-%m-%d'),
        'somente_primeiro_grau': True,
        }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        datas = dict()
        company_ids = pooler.get_pool(cr.dbname).get('res.company').search(cr, uid, [], context=context)

        for item in self.browse(cr, uid, ids):
            if item.periodo_inicial > item.periodo_final:
                raise osv.except_osv(_('Atencao'), _('Data inicial nao pode ser maior que a data '
                                                     'final'))
            company_ids = map(lambda m: m.id, item.company_ids) if item.company_ids else company_ids
            local_ids = map(lambda m: m.id, item.local_ids)

            datas = {
                'company_ids': company_ids,
                'local_ids': local_ids,
                'periodo_inicial': item.periodo_inicial,
                'periodo_final': item.periodo_final,
                'somente_primeiro_grau': item.somente_primeiro_grau,
                'sql': self.sql_report(item.periodo_inicial, item.periodo_final, company_ids, local_ids)
            }

        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'listagem_totais_por_categoria',
            'datas': datas,
        }

    @staticmethod
    def sql_report(dt_inicio, dt_fim, company, local):
        """
        Retorna a sentenca SQL de consulta do relatorio. Movimento de notas fiscais.

        :param dt_inicio: data inicial da consulta
        :param dt_fim: data final utilizada na consulta
        :param company: lista com o ID das empresas
        :param local: lista com o ID dos locais (locacao)
        :type dt_inicio: str
        :type dt_fim: str
        :type company: list[long]
        :type local: list[long]
        :return: a sentenca SQL utilizada na consulta do relatorio.
        :rtype: str

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        args = dict(dt_inicio=dt_inicio, dt_fim=dt_fim,
                    company=', '.join([str(_id) for _id in company]))
        cond_local = ''

        if local:
            cond_local = """
                  AND emi.local_id IN (%s) """ % ', '.join([str(_id) for _id in local])

        args = dict(args, local=cond_local)

        sql = """
            SELECT  nf.tipo                                   AS estmpg_tipo_movimento
                  , emi.produto_id                            AS estmpg_produto_id
                  , ep.categoria_id                           AS estmpg_categoria_id
                  , emi.quantidade                            AS estmpg_quantidade
                  , emi.vr_total_item_rateado                 AS estmpg_vr_total_item
                  , cfop.movimento_tipo                       AS estmpg_cfop_movimento
                  , emi.id                                    AS estmpg_movimento_id
                  , emi.estmvi_saidas_custo_corrigido_total / emi.quantidade AS estmpg_custo_corrigido
                  , emi.estmvi_saidas_custo_medio_contabil_total / emi.quantidade AS estmpg_custo_medio_contabil
                  , emi.estmvi_saidas_custo_reposicao_total / emi.quantidade AS estmpg_custo_reposicao
                  , emi.estmvi_saidas_ultimo_custo_total / emi.quantidade  AS estmpg_ultimo_custo
                  , (SELECT SUM (fnit.vr_encargo)
                     FROM fiscal_nf_item_tributacao            AS fnit
                     INNER JOIN fiscal_encargo                 AS fe   ON fe.id = fnit.encargo_id
                     WHERE fnit.movimento_itens_id = emi.id
                       AND fe.sigla IN ('PIS','COFINS', 'ICMS')) AS estmp_valor_tributos
                  , (SELECT SUM (fnit.vr_icms_substituicao)
                     FROM fiscal_nf_item_tributacao            AS fnit
                     INNER JOIN fiscal_encargo                 AS fe   ON fe.id = fnit.encargo_id
                     WHERE fnit.movimento_itens_id = emi.id
                       AND fe.sigla IN ('PIS','COFINS', 'ICMS')) AS estmp_icms_substituicao
            FROM  estoque_movimento_itens                     AS emi
              INNER JOIN fiscal_nf_capa                       AS nf   ON nf.id = emi.nf_id
              INNER JOIN fiscal_cfop                          AS cfop ON cfop.id = emi.cfop_id
              INNER JOIN estoque_produto                      AS ep   ON ep.id = emi.produto_id
              INNER JOIN estoque_movimento_capa               AS emc  ON emc.id = emi.capa_id
            WHERE   emc.data        BETWEEN '%(dt_inicio)s 00:00:00' AND '%(dt_fim)s 23:59:59'
              AND   nf.state = '3'
              AND   emc.state = 'F'
              AND   cfop.movimento_tipo != 'U'
              AND   nf.company_id   IN (%(company)s)
              %(local)s
            """ % args

        return sql

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
