# -*- coding: utf-8 -*-
from openerp.osv import osv, fields

UNIDADES = [()]
class estoque_atributos_produtos(osv.Model):
    # prefixo: estatp_
    _name = 'estoque.atributos.produtos'
    _columns = {
        'estatp_produto_id': fields.many2one('estoque.produto', 'Produto', required=True,
                                             ondelete='cascade', select=True),
        'estatp_atributo_id': fields.many2one('estoque.atributos', 'Atributo', required=True,
                                              ondelete='cascade', select=True),
        'estatp_atributo_valor': fields.char('Valor do atributo', size=128),
        'estatp_atributo_valor_id': fields.many2one('estoque.atributos.valores',
                                                    'Valor do atributo'),
        'estap_atributo_unidade': fields.char('Valor do atributo', size=20),
        'estatp_atributo_unidade_id': fields.many2one('estoque.atributos.unidades',
                                                    'Unidade'),
        'estatp_valor_fixo': fields.related('estatp_atributo_id', 'estatr_valores_fixos',
                                            type='boolean', relation='estoque.atributos',
                                            string='Valores fixos', store=False),
        'estatp_tem_unidade': fields.related('estatp_atributo_id', 'estatr_tem_unidade',
                                            type='boolean', relation='estoque.atributos',
                                            string='Tem unidade', store=False),
        'estatp_obrigatorio': fields.related('estatp_atributo_id', 'estatr_obrigatorio',
                                            type='boolean', relation='estoque.atributos',
                                            string='Obrigatorio', store=False)
    }
