# -*- coding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _
import time


class estoque_composicao_item_origem(osv.Model):
    _inherit = 'estoque.composicao.item.origem'

    def estcio_gera_movimento_itens_saida(self, cr, uid, ids, context=None):
        """
        O metodo gera a movimentacao dos itens do estoque da origem. Operacao de saida.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dados contextuais.
        :type context: dict
        :return:
        """
        context = context and context.copy() or {}
        brw_composicao_item_origem = self.browse(cr, uid, ids, context)
        company_id = brw_composicao_item_origem[0].estcio_capa_id.company_id.id
        composicao_capa_id = brw_composicao_item_origem[0].estcio_capa_id.id
        obj_estoque_composicao_capa = self.pool.get('estoque.composicao.capa')
        obj_estoque_movimento_itens = self.pool.get('estoque.movimento.itens')
        obj_estoque_produto_saldo = self.pool.get('estoque.produto.saldo')

        # Cria a capa do movimento do estoque
        funcionario_id = self.pool.get('rh.funcionario').get_id_func(cr, uid, context)
        if not funcionario_id:
            raise osv.except_osv(_('Atencao!'), _('Usuario nao esta cadastrado como funcionario.'))
        operacao_id = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', 'estpar_composicao_nat_sai', context=context).get(
            'estpar_composicao_nat_sai')
        if not operacao_id:
            raise osv.except_osv(_('Atencao'),
                                 _('"Operacao de saida" nao cadastrada nos parametros do estoque.'
                                   ' Aba "Composicao".'))
        vals_movimento_capa = {
            'company_id': company_id,
            'funcionario_id': funcionario_id,
            'estmvc_operacao_id': operacao_id,
            'state': 'F'
        }
        context.update({'composicao_capa_id': composicao_capa_id, 'composicao_movimento_tipo': 'S'})
        movimento_capa_id = self.pool.get('estoque.movimento.capa').create(
            cr, uid, vals_movimento_capa, context)
        obj_estoque_composicao_capa.write(
            cr, uid, composicao_capa_id, {'estcoc_origem_movimento_capa_id': movimento_capa_id},
            context)
        produto_ids = list(set(map(lambda p: p.estcio_produto_id.id, brw_composicao_item_origem)))
        custos = self.pool.get('estoque.preco.custo').get_custos_do_dia(
            cr, uid, epc_produto_ids=produto_ids, context=context)
        # Cria o movimento de itens do estoque
        for item in brw_composicao_item_origem:
            custo_produto = custos.get(item.estcio_produto_id.id) or {}
            brw_produto_embalagem = item.estcio_produto_embalagem_id
            grade_id = item.estcio_grade_id.id
            quantidade = item.estcio_quantidade * \
                (brw_produto_embalagem.quantidade_na_embalagem_get()[0].get(
                    'quantidade_na_embalagem') or 1)
            local_id = item.estcio_local_id.id
            vals_movimento_itens = {
                'capa_id': movimento_capa_id,
                'produto_id': item.estcio_produto_id.id,
                'grade_id': grade_id,
                'local_id': local_id,
                'produto_embalagem_id': brw_produto_embalagem.id,
                'quantidade': quantidade,
                'vr_total_item': item.estcio_custo_medio_contabil,
                'vr_total_item_rateado': item.estcio_custo_medio_contabil,
                'vr_unitario': item.estcio_custo_medio_contabil / quantidade,
                'estmvi_saidas_custo_corrigido_total': item.estcio_custo_corrigido,
                'estmvi_saidas_custo_medio_contabil_total': item.estcio_custo_medio_contabil,
                'estmvi_saidas_ultimo_custo_total': (custo_produto.get(
                    'estprc_ultimo_custo') or 0) * quantidade,
                'estmvi_saidas_custo_reposicao_total': (custo_produto.get(
                    'estprc_custo_reposicao') or 0) * quantidade,
            }
            movimento_item_id = obj_estoque_movimento_itens.create(cr, uid, vals_movimento_itens,
                                                                   context)
            self.write(cr, uid, item.id, {'estcio_movimento_item_id': movimento_item_id}, context)

            # Atualiza o saldo dos itens movimentados
            obj_estoque_produto_saldo.atualizar_saldo_do_dia(
                cr, uid, eps_company_id=company_id, grade_qtd={grade_id: quantidade},
                eps_data=time.strftime('%Y-%m-%d'), eps_entrada_saida='S', eps_local_id=local_id,
                context=context)
        return True

    def estcio_onchange_produto(self, cr, uid, ids, produto_id, quantidade, context=None):
        context = context and context.copy() or {}
        res = {}
        vals = {'estcio_grade_id': False, 'estcio_produto_embalagem_id': False}
        if not produto_id:
            res = {'value': vals}
            return res
        epc_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'estoque.preco.custo', context=context)
        grade_ids = self.pool.get('estoque.produto.grade').search(
            cr, uid, [('produto_id', '=', produto_id)], context=context)
        if len(grade_ids) == 1:
            vals.update({'estcio_grade_id': grade_ids[0]})
        obj_estoque_produto_embalagem = self.pool.get('estoque.produto.embalagem')
        produto_embalagem_ids = obj_estoque_produto_embalagem.search(
            cr, uid, [('produto_id', '=', produto_id)], context=context)
        if len(produto_embalagem_ids) == 1:
            vals.update({'estcio_produto_embalagem_id': produto_embalagem_ids[0]})
            if quantidade:
                quantidade *= obj_estoque_produto_embalagem.quantidade_na_embalagem_get(
                    cr, uid, produto_embalagem_ids[0], context)[0].get('quantidade_na_embalagem')
        custos = self.pool.get('estoque.preco.custo').get_custos_do_dia(
            cr, uid, epc_produto_ids=produto_id, epc_company_id=epc_company_id, context=context)
        produto_custo = custos.get(produto_id)
        if produto_custo:
            vals.update({
                'estcio_custo_medio_contabil': (produto_custo.get(
                    'estprc_custo_medio_contabil') or 1) * (quantidade if quantidade else 1),
                'estcio_custo_corrigido': (produto_custo.get(
                    'estprc_custo_corrigido') or 1) * (quantidade if quantidade else 1)
            })
        if vals:
            res.update({'value': vals})
        return res

    def estcio_onchange_produto_embalagem_quantidade(
            self, cr, uid, ids, produto_id, produto_embalagem_id, quantidade, context=None):
        context = context and context.copy() or {}
        res = {}
        if not produto_embalagem_id or not produto_id:
            return res
        epc_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'estoque.preco.custo', context=context)
        quantidade = quantidade or 1.0
        quantidade *= self.pool.get('estoque.produto.embalagem').quantidade_na_embalagem_get(
            cr, uid, produto_embalagem_id, context)[0].get('quantidade_na_embalagem')
        custos = self.pool.get('estoque.preco.custo').get_custos_do_dia(
            cr, uid, epc_produto_ids=produto_id, epc_company_id=epc_company_id, context=context)
        produto_custo = custos.get(produto_id)
        if produto_custo:
            res['value'] = {
                'estcio_custo_medio_contabil': (produto_custo.get(
                    'estprc_custo_medio_contabil') or 0) * (quantidade if quantidade else 1),
                'estcio_custo_corrigido': (produto_custo.get(
                    'estprc_custo_corrigido') or 0) * (quantidade if quantidade else 1)
            }
        return res
