# -*- coding: utf-8 -#-

from openerp.osv import osv, fields
import time


class estoque_composicao_capa(osv.Model):
    _name = 'estoque.composicao.capa'
    _columns = {
        # CHAR
        'name': fields.char('Descricao', size=60, required=True),
        # DATETIME
        'write_date': fields.datetime('Data', readonly=True),
        # SELECTION
        'state': fields.selection([('E', 'Esboco'), ('F', 'Efetivado'), ('C', 'Cancelado')],
                                  'Status', size=1),
        # MANY2ONE
        'id': fields.integer('Controle', readonly=True),
        'company_id': fields.many2one('res.company', 'Empresa', ondelete='cascade', required=True,
                                      select=True),
        'estcoc_origem_movimento_capa_id': fields.many2one(
            'estoque.movimento.capa', 'Movimento capa origem', ondelete='restrict'),
        'estcoc_destino_movimento_capa_id': fields.many2one(
            'estoque.movimento.capa', 'Movimento capa destino', ondelete='restrict'),
        'write_uid': fields.many2one('res.users', 'Usuario', readonly=True),
        # ONE2MANY
        'estcoc_item_origem_ids': fields.one2many('estoque.composicao.item.origem',
                                                  'estcio_capa_id', 'Itens origem'),
        'estcoc_item_destino_ids': fields.one2many('estoque.composicao.item.destino',
                                                   'estcid_capa_id', 'Itens destino'),
    }
    _defaults = {
        'state': lambda *a: 'E',
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, s._name, context=c),
    }
    _order = 'id DESC'
