# -*- coding: utf-8 -*-

from openerp.osv import osv, fields


class estoque_composicao_item_destino(osv.Model):
    _name = 'estoque.composicao.item.destino'
    _columns = {
        # MANY2ONE
        'estcid_capa_id': fields.many2one('estoque.composicao.capa', 'Capa', ondelete='cascade'),
        'estcid_local_id': fields.many2one('estoque.local', 'Local', required=True,
                                           ondelete='restrict'),
        'estcid_produto_id': fields.many2one('estoque.produto', 'Produto', required=True,
                                             ondelete='restrict'),
        'estcid_grade_id': fields.many2one('estoque.produto.grade', 'Grade', required=True,
                                           domain="[('produto_id', '=', estcid_produto_id)]",
                                           ondelete='restrict'),
        'estcid_produto_embalagem_id': fields.many2one(
            'estoque.produto.embalagem', 'Embalagem',
            domain="[('produto_id', '=', estcid_produto_id)]", ondelete='restrict', required=True),
        'estcid_movimento_item_id': fields.many2one(
            'estoque.movimento.itens', 'Movimento item destino', ondelete='restrict'),
        # FLOAT
        'estcid_quantidade': fields.float('Quantidade', digits=(12, 3), required=True),
        'estcid_custo_medio_contabil': fields.float('Custo Medio Contabil', digits=(15, 5),
                                                    required=True),
        'estcid_custo_corrigido': fields.float('Custo Corrigido', digits=(15, 5), required=True),
    }
