# -*- coding: utf-8 -*-

from openerp.osv import osv, fields


class estoque_composicao_item_origem(osv.Model):
    _name = 'estoque.composicao.item.origem'
    _columns = {
        # MANY2ONE
        'estcio_capa_id': fields.many2one('estoque.composicao.capa', 'Capa', ondelete='cascade'),
        'estcio_local_id': fields.many2one('estoque.local', 'Local', required=True,
                                           ondelete='restrict'),
        'estcio_produto_id': fields.many2one('estoque.produto', 'Produto', required=True,
                                             ondelete='restrict'),
        'estcio_grade_id': fields.many2one('estoque.produto.grade', 'Grade', required=True,
                                           domain="[('produto_id', '=', estcio_produto_id)]",
                                           ondelete='restrict'),
        'estcio_produto_embalagem_id': fields.many2one(
            'estoque.produto.embalagem', 'Embalagem',
            domain="[('produto_id', '=', estcio_produto_id)]", ondelete='restrict', required=True),
        'estcio_movimento_item_id': fields.many2one(
            'estoque.movimento.itens', 'Movimento item origem', ondelete='restrict'),
        # FLOAT
        'estcio_quantidade': fields.float('Quantidade', digits=(12, 3), required=True),
        'estcio_custo_medio_contabil': fields.float('Custo Medio Contabil', digits=(15, 5),
                                                    readonly=True),
        'estcio_custo_corrigido': fields.float('Custo Corrigido', digits=(15, 5), readonly=True),
    }
