# -*- coding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(e, c, d, t=110):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        context = context and context.copy() or {}
        title = center_title('', _('Conferencia de Entrada'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('estoque_conferencia_entrada'))
        listagem.informaTamLinha(110)
        listagem.defineFonte(tam=8.6)
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'wizard.estoque.conferencia.entrada', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        itens = datas.get('dados')
        local_dados = datas.get('local')

        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
        docs1 = formataString('Local: %s - %s' % (
            local_dados.get('numero'), local_dados.get('name')), 45, ' ', 'D', 'N', 'S')

        listagem.informaCab(''+title)
        listagem.informaCab('')
        listagem.informaCab(docs)
        listagem.informaCab('')
        listagem.informaCab(docs1)
        listagem.informaCab('')
        listagem.informaCab('--')
        listagem.informaCab(_(' LOCACAO         CODIGO               DESCRICAO                     '
                              '           GRADE            QUANTIDADE '))
        listagem.informaCab('--')
        listagem.rodapePadrao()

        for item in itens:
            linha = ' '
            linha += formataString(item.get('westcoi_locacao') or '', 15, ' ', 'D', 'N', 'S')
            linha += ' '
            linha += formataString(item.get('westcoi_produto_codigo') or '', 20, ' ', 'D', 'N', 'S')
            linha += ' '
            linha += formataString(item.get('westcoi_grade_descricao') or '', 40, ' ', 'D', 'N',
                                   'S')
            linha += ' '
            linha += formataString(item.get('westcoi_grade') or '', 6, ' ', 'D', 'N', 'S')
            linha += ' '
            linha += formataString(getNumeroEditado(item.get('westcoi_quantidade') or 0, 3), 20,
                                   ' ', 'E', 'N', 'S')
            listagem.imprimeLinha(linha)

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.estoque_conferencia_entrada')
