# -*- coding:utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _
from funcoes import estdcc_check_porcentagem_participacao


class estoque_decomposicao_capa(osv.Model):

    _name = 'estoque.decomposicao.capa'

    _columns = {
        'estdcc_produto_id': fields.many2one('estoque.produto', 'Produto', ondelete='cascade',
                                             select=True, required=True),
        'estdcc_grade_id': fields.many2one('estoque.produto.grade', 'Grade', ondelete='cascade',
                                           select=True, required=True,
                                           domain="[('produto_id', '=', estdcc_produto_id)]"),
        'estdcc_itens_ids': fields.one2many('estoque.decomposicao.partes', 'estdep_capa_id',
                                            'Partes'),
    }

    _sql_constraints = [
        ('decomposicao_capa_uniq', 'unique (estdcc_produto_id, estdcc_grade_id)',
         'Produto e grade devem ser unicos para cada decomposicao!'.decode('utf-8')),
    ]

    _constraints = [
        (estdcc_check_porcentagem_participacao, _('A soma deve ser igual a 100,00.'),
         ['Percentual de participacao'])
    ]
