# -*- coding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _
from funcoes import estdep_check_item_duplicado


class estoque_decomposicao_partes(osv.Model):

    _name = 'estoque.decomposicao.partes'

    _columns = {
        'estdep_capa_id': fields.many2one('estoque.decomposicao.capa', 'Capa', ondelete='cascade',
                                          required=True, select=True),
        'estdep_produto_id': fields.many2one('estoque.produto', 'Item', ondelete='cascade',
                                             required=True, select=True),
        'estdep_grade_id': fields.many2one('estoque.produto.grade', 'Grade', ondelete='cascade',
                                           required=True, select=True,
                                             domain="[('produto_id', '=', estdep_produto_id)]"),
        'estdep_produto_embalagem_id': fields.many2one(
            'estoque.produto.embalagem', 'Embalagem', ondelete='cascade', required=True,
            select=True, domain="[('produto_id', '=', estdep_produto_id)]"),
        'estdep_percentual': fields.float('Percentual de participacao', digits=(3, 2),
                                          required=True),
    }

    _sql_constraints = [
        ('decomposicao_partes_uniq', 'unique (estdep_capa_id, estdep_produto_id, estdep_grade_id)',
         _('Item e grade devem ser unicos para cada decomposicao!')),
    ]

    _constraints = [
        (estdep_check_item_duplicado,
         _('Item da decomposicao nao pode ser igual ao item que sera decomposto.'),
         ['Item'])
    ]
