# -*- coding: utf-8 -*-

from openerp.osv import osv, fields


class estoque_fiscal_itens(osv.Model):
    # prefixo: estfit_

    _inherit = 'estoque.fiscal.itens'

    def estfit_button_esboco(self, cr, uid, ids, context=None):
        """
        O metodo atualiza todos os registros recebidos (ids) para o estado de esboco.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dados contextuais.
        :type context: dict
        :return: Verdadeiro, caso consigo realizar a atualizacao, senao, Falso.
        :rtype: bool
        """
        context = context and context.copy() or {}
        return self.write(cr, uid, ids, {'state': 'E'}, context)

    def estfit_button_nao_atualizar(self, cr, uid, ids, context=None):
        """
        O metodo atualiza todos os registros recebidos (ids) para o estado de nao atualizar.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dados contextuais.
        :type context: dict
        :return: Verdadeiro, caso consigo realizar a atualizacao, senao, Falso.
        :rtype: bool
        """
        context = context and context.copy() or {}
        return self.write(cr, uid, ids, {'state': 'N'}, context)

    def estfit_button_atualizar(self, cr, uid, ids, context=None):
        """
        O metodo atualiza todos os registros recebidos (ids) para o estado de atualizado.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dados contextuais.
        :type context: dict
        :return: Verdadeiro, caso consigo realizar a atualizacao, senao, Falso.
        :rtype: bool
        """
        context = context and context.copy() or {}
        itens_dados = self.read(cr, uid, ids, [], context, '_classic_write')
        obj_adm_utils = self.pool.get('adm.utils')
        list_fiscal_parametro = ['fispar_integracao_fiscal_inclui_tributacao']
        fiscal_parametro_dados = obj_adm_utils.admutl_get_parametros(
            cr, uid, 'fiscal', list_fiscal_parametro, context=context)
        inclui_tributacao = fiscal_parametro_dados.get('fispar_integracao_fiscal_inclui_tributacao')
        self.pool.get('fiscal.utils').fisutl_atualizar_tributacao_produtos(
            cr, uid, itens_dados, inclui_tributacao, context)
        res = self.write(cr, uid, ids, {'state': 'A'}, context)
        capa_id = False
        if itens_dados and isinstance(itens_dados, list):
            capa_id = itens_dados[0].get('estfit_capa_id')
        elif itens_dados and isinstance(itens_dados, dict):
            capa_id = itens_dados.get('estfit_capa_id')
        if capa_id:
            self.pool.get('estoque.fiscal.capa').estfca_get_status(cr, uid, [capa_id], context)
        return res
