# -*- coding: utf-8 -*-

from openerp.osv import osv, fields


class estoque_fiscal_itens(osv.Model):
    # prefixo: estfit_

    _name = 'estoque.fiscal.itens'
    _columns = {
        'estfit_capa_id': fields.many2one('estoque.fiscal.capa', 'Capa', required=True,
                                          ondelete='cascade'),
        'estfit_produto_id': fields.many2one('estoque.produto', 'Produto', required=True,
                                             ondelete='cascade'),
        'estfit_cad_ncm': fields.char('NCM cadastro', size=8),
        'estfit_cad_cest': fields.char('CEST cadastro', size=7),
        'estfit_cad_icms_cst': fields.char('ICMS CST cadastro', size=2),
        'estfit_cad_icms_aliquota': fields.float('ICMS aliquota cadastro', digits=(5, 2)),
        'estfit_cad_icms_fcp_aliquota': fields.float('FCP aliquota cadastro', digits=(5, 2)),
        'estfit_cad_icms_base': fields.float('ICMS % base cadastro', digits=(5, 2)),
        'estfit_cad_pis_cst_entrada': fields.char('PIS CST cadastro entradas', size=2),
        'estfit_cad_pis_cst_saida': fields.char('PIS CST cadastro saidas', size=2),
        'estfit_cad_pis_aliquota_entrada': fields.float('PIS aliquota cadastro entradas',
                                                        digits=(5, 2)),
        'estfit_cad_pis_aliquota_saida': fields.float('PIS aliquota cadastro saidas',
                                                      digits=(5, 2)),
        'estfit_cad_pis_nat_rec': fields.char('PIS natureza receitas cadastros', size=3),
        'estfit_cad_cofins_cst_entrada': fields.char('COFINS CST cadastro entradas', size=2),
        'estfit_cad_cofins_cst_saida': fields.char('COFINS CST cadastro saidas', size=2),
        'estfit_cad_cofins_aliquota_entrada': fields.float('COFINS aliquota cadastro entradas',
                                                           digits=(5, 2)),
        'estfit_cad_cofins_aliquota_saida': fields.float('COFINS aliquota cadastro saidas',
                                                         digits=(5, 2)),
        'estfit_cad_cofins_nat_rec': fields.char('COFINS natureza receitas cadastro', size=3),
        'estfit_cad_cod_ben_fis_uf': fields.char('Codigo beneficio fiscal cadastro', size=8),

        'estfit_novo_ncm': fields.char('NCM novo', size=8),
        'estfit_novo_cest': fields.char('CEST novo', size=7),
        'estfit_novo_icms_cst': fields.char('ICMS CST novo', size=2),
        'estfit_novo_icms_cont_cst': fields.char('ICMS CST contribuinte novo', size=2),
        'estfit_novo_icms_aliquota': fields.float('ICMS aliquota novo', digits=(5, 2)),
        'estfit_novo_icms_fcp_aliquota': fields.float('FCP aliquota novo', digits=(5, 2)),
        'estfit_novo_icms_cont_aliquota': fields.float('ICMS aliquota contribuinte novo',
                                                       digits=(5, 2)),
        'estfit_novo_icms_base': fields.float('ICMS % base novo', digits=(5, 2)),
        'estfit_novo_icms_red_base_cont': fields.float('ICMS reducao base contribuinte novo',
                                                       digits=(5, 2)),
        'estfit_novo_pis_cst_entrada': fields.char('PIS CST novo entradas', size=2),
        'estfit_novo_pis_cst_saida': fields.char('PIS CST novo saidas', size=2),
        'estfit_novo_pis_aliquota_entrada': fields.float('PIS aliquota novo entradas',
                                                         digits=(5, 2)),
        'estfit_novo_pis_aliquota_saida': fields.float('PIS aliquota novo saidas', digits=(5, 2)),
        'estfit_novo_pis_nat_rec': fields.char('PIS natureza receitas novo', size=3),
        'estfit_novo_cofins_cst_entrada': fields.char('COFINS CST novo entradas', size=2),
        'estfit_novo_cofins_cst_saida': fields.char('COFINS CST novo saidas', size=2),
        'estfit_novo_cofins_aliquota_entrada': fields.float('COFINS aliquota novo entradas',
                                                            digits=(5, 2)),
        'estfit_novo_cofins_aliquota_saida': fields.float('COFINS aliquota novo saidas',
                                                          digits=(5, 2)),
        'estfit_novo_cofins_nat_rec': fields.char('COFINS natureza receitas novo', size=3),
        'estfit_novo_cod_ben_fis_uf': fields.char('Codigo beneficio fiscal novo', size=8),

        'estfit_novo_ncm_id': fields.many2one('fiscal.ncm', 'NCM', select=True, ondelete='cascade'),
        'estfit_novo_cest_id': fields.many2one('fiscal.cest', 'CEST', select=True,
                                               ondelete='cascade'),
        'estfit_novo_icms_tribut_id': fields.many2one('fiscal.tributacao', 'ICMS tributacao',
                                                      select=True, ondelete='cascade',
                                                      readonly=True),
        'estfit_novo_icms_cont_tribut_id': fields.many2one(
            'fiscal.tributacao', 'ICMS tributacao contribuinte', select=True, ondelete='cascade',
            readonly=True),
        'estfit_novo_pis_tribut_id': fields.many2one('fiscal.tributacao', 'PIS tributacao',
                                                     select=True, ondelete='cascade',
                                                     readonly=True),
        'estfit_novo_cofins_tribut_id': fields.many2one('fiscal.tributacao', 'COFINS tributacao',
                                                        select=True, ondelete='cascade',
                                                        readonly=True),
        'state': fields.selection([('E', 'Esboco'), ('N', 'Nao atualizar'), ('A', 'Atualizado')],
                                  'Status', size=1),
    }
    _defaults = {
        'state': lambda *a: 'E',
    }
