# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
from unicodedata import normalize
from SigUtils.formatastring import formataString
import time
import socket


class estger_faceamento_capa(osv.Model):
    """
    Tabela de faceamento da gerencia do estoque
    """
    # prefixo: egefcc_

    _name = 'estger.faceamento.capa'
    _inherit = 'estger.faceamento.capa'

    def egefcc_button_atualizar_lastro(self, cr, uid, ids, context=None):
        """
        Metodo responsavel por atualizar lastro no proprio SigERP ou no SigGestão
        @cr: cursor do banco de dados
        @uid: id do usuario
        @ids: lista de registros identificadores da tabela
        @context: dicionario com valores contextuais
        @return: True, se o registro foi atualizado. False, caso contrario
        """
        def _egefcc_atualizar_siggestao(_adm_parametros_dados):
            """
            Método utilizado para atualizar o lastro no siggestao
            @_adm_parametros_dados: dicionario contendo os dados para coneção com o gestão
            @Return: True
            """
            client_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            servidor = _adm_parametros_dados.get('admpar_siggestao_servidor')
            diretorio = _adm_parametros_dados.get('admpar_siggestao_diretorio')
            exportar = _adm_parametros_dados.get('admpar_siggestao_lastro_exportar')
            address = (servidor, 5019)
            try:
                client_socket.connect(address)
            except Exception as e:
                mensagem = str(e)
                raise osv.except_osv(_('Atencao'), _('Erro na conexao com o servidor:') + str(
                    servidor) + '\nMensagem:' + normalize('NFKD', mensagem.decode(
                        'utf-8')).encode('ASCII', 'ignore'))
            client_socket.send('ESTA AI?')
            mensagem = client_socket.recv(2048)
            if not mensagem.startswith('OK'):
                raise osv.except_osv(_('Atencao'), mensagem)
            client_socket.send('DIR:' + diretorio)
            mensagem = client_socket.recv(2048)
            if not mensagem.startswith('OK'):
                raise osv.except_osv(_('Atencao'), _("Diretorio '%s' nao encontrado" % diretorio))
            c = exportar
            a = str(time.time())
            n = a.find('.')
            _arquivoCMD = 'lt' + a[n - 5:n] + a[n + 1:n + 2] + '.cmd'
            for _capa in self.browse(cr, uid, ids):
                empresa = self.pool.get('legado.empresa').ler(
                    cr, uid, [('company_id', '=', _capa.company_id.id)], context=context)[0]['empresa_legado']
            admpar_siggestao_exportar = c[:c.find('{')] \
                                        + formataString(empresa, 3, '0', 'E') \
                                        + ' ' \
                                        + _arquivoCMD \
                                        + ' ' \
                                        + diretorio \
                                        + c[c.find('}') + 1:]
            client_socket.send('ARQ NOME:' + diretorio + '/' + _arquivoCMD)
            mensagem = client_socket.recv(2048)
            if not mensagem.startswith('OK'):
                raise osv.except_osv(_('Atencao'), mensagem)
            arquivo = []
            for _capa in self.browse(cr, uid, ids):
                for _item in _capa.egefcc_item_ids:
                    codigo = self.pool.get('estoque.produto').browse(
                        cr, uid, _item.egefci_produto_id.id, context).codigo or 0
                    grade = self.pool.get('estoque.produto.grade').browse(
                        cr, uid, _item.egefci_grade_id.id, context).grade or '  '
                    if grade == 'UN':
                        grade = '  '
                    local = self.pool.get('estoque.local').browse(
                        cr, uid, _capa.egefcc_local_id.id, context).numero or 0
                    lastro = _item.egefci_sugestao
                    perLastro = _item.egefci_sugestao_percentual
                    linha = 'LASTRO'
                    linha += formataString(codigo, 10, '0', 'E')
                    linha += formataString(grade, 2, ' ', 'D')
                    linha += formataString(local, 3, '0', 'E')
                    linha += formataString(lastro, 6, '0', 'E')
                    linha += formataString(perLastro, 3, '0', 'E')
                    linha += formataString(uid, 10, '0', 'E')
                    arquivo.append(linha)
            for linha in arquivo:
                comando = 'ARQ DADOS:' + linha
                client_socket.send(comando)
                mensagem = client_socket.recv(2048)
                if not mensagem.startswith('OK'):
                    raise osv.except_osv(_('Atencao'), mensagem)
            client_socket.send('ARQ FECHAR:')
            mensagem = client_socket.recv(2048)
            if not mensagem.startswith('OK'):
                raise osv.except_osv(_('Atencao'), mensagem)
            comando = 'EXECUTAR:' + admpar_siggestao_exportar
            client_socket.send(comando)
            mensagem = client_socket.recv(2048)
            if not mensagem.startswith('OK'):
                if mensagem.startswith('ERRO!'):
                    mensagem = _('Sem permissao para execucao')
                raise osv.except_osv(_('Atencao'), mensagem)
            return True

        def _egefcc_atualizar_sigerp():
            """
            Método utilizado para atualizar o lastro no SigERP
            @return: True
            """
            for _capa in self.browse(cr, uid, ids):
                for _item in _capa.egefcc_item_ids:
                    _obj_local_locacao = self.pool.get('estoque.local.locacao')
                    _local_locacao_ids = _obj_local_locacao.search(cr, uid, [
                        ('produto_id', '=', _item.egefci_produto_id.id),
                        ('grade_id', '=', _item.egefci_grade_id.id),
                        ('local_id', '=', _capa.egefcc_local_id.id)
                    ], context=context)
                    vals = {
                        'estllc_lastro': _item.egefci_sugestao,
                        'estllc_percentual_lastro': _item.egefci_sugestao_percentual
                    }
                    _obj_local_locacao.write(cr, uid, _local_locacao_ids, vals, context=context)
            return True

        context = context and context.copy() or {}
        _adm_parametros_dados = self.pool.get('adm.utils').admutl_get_parametros(
                cr, uid, 'adm', ['admpar_siggestao_lastro_exportar', 'admpar_siggestao_servidor',
                                 'admpar_siggestao_diretorio'])
        if not _adm_parametros_dados:
            return False
        if _adm_parametros_dados.get('admpar_siggestao_lastro_exportar'):
            res = _egefcc_atualizar_siggestao(_adm_parametros_dados)
        else:
            res = _egefcc_atualizar_sigerp()
        return res

    def egefcc_button_atualizar(self, cr, uid, ids, context=None):
        """
        Metodo responsavel por atualizar determinados registros com as informacoes do faceamento
        @cr: cursor do banco de dados
        @uid: id do usuario
        @ids: lista de registros identificadores da tabela
        @context: dicionario com valores contextuais
        @return: True, se o registro foi atualizado. False, caso contrario
        """
        context = context and context.copy() or {}
        res = super(estger_faceamento_capa, self).write(cr, uid, ids, {}, context)
        return res

    def egefcc_button_imprimir(self, cr, uid, ids, context=None):
        """
        Metodo responsavel por chamar a classe do relatorio que ira imprimir um arquivo pdf com
        as informacoes do faceamento
        @cr: cursor do banco de dados
        @uid: id do usuario
        @ids: lista de registros identificadores da tabela
        @context: dicionario com valores contextuais
        @return: Dicionario com acao para a classe do relatorio, os dados referentes e o nome.
        """
        context = context and context.copy() or {}
        item_ids = self.browse(cr, uid, ids[0]).egefcc_item_ids
        item_ids = map(lambda i: i.id, item_ids)
        dado_capa = self.read(cr, uid, ids, [], context=context)
        if isinstance(dado_capa, list):
            dado_capa = dado_capa[0]
        list_dado_item = self.pool.get('estger.faceamento.item').read(cr, uid, item_ids, [],
                                                                      context=context)
        datas = {
            'dado_capa': dado_capa,
            'dado_item': list_dado_item
        }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'faceamento',
            'datas': datas,
        }

    def create(self, cr, uid, vals, context=None):
        """
        Metodo responsavel por criar registros com as informacoes do faceamento
        @cr: cursor do banco de dados
        @uid: id do usuario
        @vals: dicionario com os valores a serem incluidos na tabela
        @context: dicionario com valores contextuais
        @return: id do novo registro criado
        """
        context = context and context.copy() or {}
        # pesquisa todos os itens que satisfazem aos criterios da capa e inclui cada um na classe
        # estger_faceamento_item
        dado_item = self.egefcc_get_item(cr, uid, vals, context)
        if dado_item:
            vals['egefcc_item_ids'] = dado_item
        res = super(estger_faceamento_capa, self).create(cr, uid, vals, context)
        return res

    def egefcc_get_item(self, cr, uid, vals, context=None):
        """
        Metodo responsavel por realizar a busca dos itens do faceamento (egefcc_item_ids -
        estger_faceamento_item), baseado nas informacoes da capa (estger_faceamento_capa)
        @cr: cursor do banco de dados
        @uid: id do usuario
        @ids: lista de registros identificadores da tabela
        @context: dicionario com valores contextuais
        @return: Caso encontre itens que satisfacam as informacoes da capa, retorna lista de tuplas.
        Senao, lista vazia.
        """
        context = context and context.copy() or {}
        obj_local_locacao = self.pool.get('estoque.local.locacao')
        obj_estoque_produto_saldo = self.pool.get('estoque.produto.saldo')
        obj_estoque_produto = self.pool.get('estoque.produto')
        obj_adm_util = self.pool.get('adm.utils')
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'estoque.local.locacao', context=context)
        dado_item = []
        prazo = vals.get('egefcc_prazo')
        local_id = vals.get('egefcc_local_id')
        categoria_id = vals.get('egefcc_categoria_id')
        ano = vals.get('egefcc_ano')
        mes = vals.get('egefcc_mes')
        ano_ini = ano
        mes_ini = mes
        if prazo:
            mes_ini -= prazo
            if mes_ini <= 0:
                mes_ini += 12
                ano_ini -= 1
        else:
            prazo = 1.0
        mes -= 1
        if mes <= 0:
            mes += 12
            ano -= 1
        mes = str(mes)
        mes_ini = str(mes_ini)
        if len(mes) == 1:
            mes = '0' + mes
        if len(mes_ini) == 1:
            mes_ini = '0' + mes_ini
        data_ini = '%s-%s-01' % (ano_ini, mes_ini)
        if mes in ['01', '03', '05', '07', '08', '10', '12']:
            data_fim = '%s-%s-31' % (ano, mes)
        elif mes in ['04', '06', '09', '11']:
            data_fim = '%s-%s-30' % (ano, mes)
        else:
            data_fim = '%s-%s-28' % (ano, mes)
        categoria_ids = self.pool.get('estoque.categoria').search(
            cr, uid, [('parent_id', 'child_of', categoria_id)], context=context)
        produto_ids = obj_estoque_produto.search(cr, uid, [('categoria_id', 'in', categoria_ids)], context=context)
        locacao_ids = obj_local_locacao.search(cr, uid, [('local_id', '=', local_id),
                                                         ('produto_id', 'in', produto_ids)],
                                               context=context)
        if len(categoria_ids) == 1:
            categoria_ids = str(tuple(categoria_ids)).replace(',', '')
        else:
            categoria_ids = str(tuple(categoria_ids))
        locacao_dado = obj_local_locacao.read(cr, uid, locacao_ids, ['produto_id'], context=context)
        produto_ids = map(lambda i: i.get('produto_id')[0], locacao_dado)
        if produto_ids:
            produto_saldo = obj_estoque_produto_saldo.get_saldo_do_dia(
                cr, uid, eps_grade_ids=False, eps_data=time.strftime('%Y-%m-%d'), context=context)
        else:
            produto_saldo = {}
        origens_ids = self.pool.get('estoque.movimento.origem').search(
            cr, uid, [('estmog_codigo', 'in', ('N', 'C'))]
        )
        operacao_ids = self.pool.get('estoque.natureza.operacao').search(
            cr, uid, [('estnto_tipo_operacao', '=', 'S'),
                      ('estnto_atualizar_saldo', '=', True),
                      ('estnto_movimento_origem_id', 'in', origens_ids)], context=context)
        estoque_movimento_capa_ids = self.pool.get('estoque.movimento.capa').search(
            cr, uid, [('company_id', '=', company_id),
                      ('data', '>=', data_ini), ('data', '<=', data_fim),
                      ('estmvc_operacao_id', 'in', operacao_ids)],
            limit=1,
            context=context.update({'sig_force_company': True}))
        if not estoque_movimento_capa_ids:
            raise osv.except_osv(_('Atencao'), _('Nao ha movimentacao no periodo'))
        if len(operacao_ids) == 1:
            operacao_ids = str(tuple(operacao_ids)).replace(',', '')
        else:
            operacao_ids = str(tuple(operacao_ids))
        local_wms_id = False
        wms_instalado = obj_adm_util.admutl_check_modulo_instalado(cr, uid, 'wms', context)
        if wms_instalado:
            estoque_parametro_dados = obj_adm_util.admutl_get_parametros(
                cr, uid, 'estoque', ['estpar_local_id', 'estpar_empresa_id'])
            local_wms_id = estoque_parametro_dados.get('estpar_local_id')
            empresa_wms_id = estoque_parametro_dados.get('estpar_empresa_id')
        sql = """
            SELECT
                ell.produto_id as egefci_produto_id,
                ell.grade_id as egefci_grade_id,
                ell.estllc_lastro as egefci_lastro,
                ell.estllc_percentual_lastro as egefci_percentual_lastro,
                ell.company_id,
        """
        if local_wms_id and empresa_wms_id:
            sql += """
                (
                    select max(estllc_produto_embalagem_id)
                    from estoque_local_locacao
                    where
                        produto_id = ell.produto_id
                        and grade_id = ell.grade_id
                        and company_id = %s
                        and local_id = %s
                ) as egefci_embalagem_id
            """ % (empresa_wms_id, local_wms_id)
        else:
            sql += """
                (select max(id)
                    from estoque_produto_embalagem
                    where embalagem_id in
                        (select id
                        from estoque_embalagem
                        where quantidade_na_embalagem = (
                            select max(quantidade_na_embalagem)
                            from estoque_embalagem
                            where id in (
                                select embalagem_id
                                from estoque_produto_embalagem
                                where produto_id = ell.produto_id and active = True)))
                    and produto_id = ell.produto_id and active = True) as egefci_embalagem_id
            """
        sql += """
            FROM
                estoque_local_locacao ell
            WHERE
                ell.local_id = %s
                AND ell.produto_id in (
                    SELECT id
                    FROM estoque_produto
                    WHERE categoria_id in %s and active = True)
                AND ell.grade_id in (
                    SELECT id
                    FROM estoque_produto_grade
                    WHERE active = True)
                AND ell.active = True
                AND ell.company_id = %s
        """ % (local_id, categoria_ids, company_id)
        cr.execute(sql)
        dado = cr.dictfetchall()

        sql = """
            SELECT
                produto_id, grade_id, SUM(quantidade) AS quantidade
            FROM
                estoque_movimento_itens emi
            WHERE
                emi.local_id = %s AND
                emi.capa_id IN (SELECT id
                                FROM estoque_movimento_capa
                                WHERE
                                    origem IN ('N','C') AND
                                    company_id = %s AND
                                    data >= '%s' AND
                                    data <= '%s' AND
                                    estmvc_operacao_id IN %s) AND
                emi.cfop_id IN (SELECT id
                                FROM fiscal_cfop
                                WHERE
                                    tipo = 'S' AND
                                    movimento_tipo = 'C')
            GROUP BY produto_id, grade_id
        """ % (local_id, company_id, data_ini, data_fim, operacao_ids)
        cr.execute(sql)
        dado_movimento = cr.dictfetchall()

        if dado:
            for x in dado:
                del x['company_id']
                venda_media = sum(map(lambda i:
                                      i.get('quantidade')
                                      if i.get('produto_id') == x.get('egefci_produto_id') and
                                      i.get('grade_id') == x.get('egefci_grade_id')
                                      else 0, dado_movimento))
                venda_media /= (prazo * 30)
                lastro = x.get('egefci_lastro') or 0
                percentual_lastro = x.get('egefci_percentual_lastro') or 0
                x['egefci_venda_media'] = venda_media
                saldo = produto_saldo.get(x.get('egefci_grade_id')).get('saldo') or 0
                x['egefci_saldo'] = saldo
                dia_estoque = 0
                dia_estoque_lastro = 0
                if venda_media:
                    dia_estoque = saldo / venda_media
                    dia_estoque_lastro = lastro / venda_media
                x['egefci_dia_estoque'] = dia_estoque
                x['egefci_dia_estoque_lastro'] = dia_estoque_lastro
                x['egefci_dia_estoque_sugestao'] = dia_estoque_lastro
                x['egefci_percentual_lastro'] = percentual_lastro
                x['egefci_sugestao'] = lastro
                x['egefci_sugestao_percentual'] = percentual_lastro
            dado_item = filter(lambda i: i.get('egefci_embalagem_id'), dado)
            dado_item = map(lambda i: (0, 0, i), dado_item)
        return dado_item
