# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv


class estger_faceamento_item(osv.Model):
    """
    Tabela de itens do faceamento
    """
    # prefixo: egefci_

    _name = 'estger.faceamento.item'
    _inherit = 'estger.faceamento.item'

    def egefci_onchange_sugestao(self, cr, uid, ids, sugestao, venda_media, context=None):
        """
        Metodo para calculo do atributo egefci_dia_estoque_sugestao com base nos valores da
        sugestao (egefci_sugestao) e venda media (egefci_venda_media)
        @cr: cursor do banco de dados
        @uid: id do usuario
        @ids: lista de id ta tabela
        @sugestao: valor inteiro
        @venda_media: valor float
        @context: valores contextuais
        @return: Dicionario com a chave 'value'. Essa chave armazena um outro dicionario com os
        atributos da classe e seus respectivos valores
        """
        context = context and context.copy() or {}
        res = {}
        if sugestao >= 0 and venda_media:
            res['value'] = {'egefci_dia_estoque_sugestao': float(sugestao) / float(venda_media)}
        elif sugestao < 0:
            res['value'] = {'egefci_dia_estoque_sugestao': 0, 'egefci_sugestao': 0}
        else:
            res['value'] = {'egefci_dia_estoque_sugestao': 0}
        return res
