# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import egefcc_get_mes_anterior
from funcoes import egefcc_get_ano_anterior


class estger_faceamento_capa(osv.Model):
    """
    Tabela de faceamento da gerencia do estoque
    """
    # prefixo: egefcc_

    _name = 'estger.faceamento.capa'

    _columns = {
        # __________ integer __________
        'id': fields.integer('Id', readonly=True),
        'egefcc_mes': fields.integer('Mes referencia', required=True),
        'egefcc_ano': fields.integer('Ano referencia', required=True),
        'egefcc_prazo': fields.integer('Prazo para media', required=True, help='Prazo em meses'),

        # __________ many2one __________
        'egefcc_usuario_id': fields.many2one('res.users', 'Usuario', ondelete='cascade',
                                             readonly=True),
        'egefcc_categoria_id': fields.many2one('estoque.categoria', 'Categoria', required=True),
        'egefcc_local_id': fields.many2one('estoque.local', 'Local', required=True),
        'company_id': fields.many2one('res.company', 'Empresa'),

        # __________ date __________
        'create_date': fields.datetime('Data do faceamento', readonly=True),

        # __________ char __________
        'name': fields.char('Descricao', size=60, required=True),

        # __________ one2many __________
        'egefcc_item_ids': fields.one2many('estger.faceamento.item', 'egefci_capa_id', 'Itens'),
    }

    _defaults = {
        'egefcc_usuario_id': lambda s, cr, uid, c: uid,
        'egefcc_mes': egefcc_get_mes_anterior,
        'egefcc_ano': egefcc_get_ano_anterior,
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, context=c)
    }

    _order = 'id DESC'
