# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estger_faceamento_item(osv.Model):
    """
    Tabela de itens do faceamento
    """
    # prefixo: egefci_

    _name = 'estger.faceamento.item'

    _columns = {
        # __________ many2one __________
        'egefci_capa_id': fields.many2one('estger.faceamento.capa', 'Capa', ondelete='cascade', select=True),
        'egefci_produto_id': fields.many2one('estoque.produto', 'Produto', ondelete='cascade',
                                             required=True, select=True),
        'egefci_grade_id': fields.many2one('estoque.produto.grade', 'Grade', ondelete='cascade', select=True,
                                           required=True),
        'egefci_embalagem_id': fields.many2one('estoque.produto.embalagem', 'Embalagem',
                                               ondelete='cascade', required=True),

        # __________ float __________
        'egefci_venda_media': fields.float('Venda media', required=True),
        'egefci_saldo': fields.float('Estoque total'),
        'egefci_dia_estoque': fields.float('Dias de estoque'),
        'egefci_dia_estoque_lastro': fields.float('Dias estoque(Lastro)'),
        'egefci_dia_estoque_sugestao': fields.float('Dias de estoque(sugestao)'),

        # __________ integer __________
        'egefci_lastro': fields.integer('Lastro'),
        'egefci_percentual_lastro': fields.integer('% do Lastro'),
        'egefci_sugestao': fields.integer('Sug.Lastro'),
        'egefci_sugestao_percentual': fields.integer('Sug.% do Lastro'),
    }
