# -*- encoding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.numero import getNumeroEditado
from SigUtils.impressao import Impressora
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _
from dateutil.parser import parse


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(e, c, d, t=160):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        context = context and context.copy() or {}
        title = center_title('', _('Faceamento'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('listagem_faceamento'))
        listagem.informaTamLinha(160)

        dado_capa = datas.get('dado_capa')
        dado_item = datas.get('dado_item')
        data_faceamento = parse(dado_capa.get('create_date'), yearfirst=True)
        data_faceamento = data_faceamento.strftime('%d/%m/%Y')
        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'estoque.local.locacao', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id,
                                                                               ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('       Pagina: {{ Page }} '))
        docs1 = center_title(_('Faceamento: %s' % dado_capa.get('id')), '', '')
        docs2 = center_title(_('Descricao: %s' % dado_capa.get('name')),
                             _('Data do faceamento: %s' % data_faceamento),
                             '')
        docs3 = center_title(_('Usuario: %s' % dado_capa.get('egefcc_usuario_id')[1]),
                             _('Categoria: %s' % dado_capa.get('egefcc_categoria_id')[1]),
                             '')
        docs4 = center_title(_('Local: %s' % dado_capa.get('egefcc_local_id')[1]),
                             _('Ano referencia: %s' % dado_capa.get('egefcc_ano')),
                             '')
        docs5 = center_title(_('Mes referencia: %s' % dado_capa.get('egefcc_mes')),
                             _('Prazo para media: %s' % dado_capa.get('egefcc_prazo')),
                             '')
        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab('')
        listagem.informaCab('' + docs1)
        listagem.informaCab('' + docs2)
        listagem.informaCab('' + docs3)
        listagem.informaCab('' + docs4)
        listagem.informaCab('' + docs5)
        listagem.informaCab('')
        listagem.informaCab('*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(_('|Produto                       |Grade        |Embalagem     |Venda media|Est. total|Dias est.|%Lastro|  Lastro|Dias est.(Lastro)|Sugestao|Dias est.(Sugestao)|'))
        listagem.informaCab('*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab('')
        listagem.rodapePadrao()
        for item in dado_item:
            linha = formataString(item.get('egefci_produto_id')[1] or '', 30, ' ', 'D', 'N', 'S') + '|'
            linha += ''
            linha += formataString(item.get('egefci_grade_id')[1], 13, ' ', 'D', 'N', 'S') + '|'
            linha += ''
            linha += formataString(item.get('egefci_embalagem_id')[1], 14, ' ', 'D', 'N', 'S') + '|'
            linha += ''
            linha += formataString(getNumeroEditado(item.get('egefci_venda_media'), 2), 11, ' ', 'E', 'N', 'S') + '|'
            linha += ''
            linha += formataString(getNumeroEditado(item.get('egefci_saldo'), 2), 10, ' ', 'E', 'N', 'S') + '|'
            linha += ''
            linha += formataString(getNumeroEditado(item.get('egefci_dia_estoque'), 2), 9, ' ', 'E', 'N', 'S') + '|'
            linha += ''
            linha += formataString(getNumeroEditado(item.get('egefci_percentual_lastro'), 2), 8, ' ', 'E', 'N', 'S') + '|'
            linha += ''
            linha += formataString(getNumeroEditado(item.get('egefci_lastro'), 2), 8, ' ', 'E', 'N', 'S') + '|'
            linha += ''
            linha += formataString(getNumeroEditado(item.get('egefci_dia_estoque_lastro'), 2), 17, ' ', 'E', 'N', 'S') + '|'
            linha += ''
            linha += formataString(getNumeroEditado(item.get('egefci_sugestao'), 2), 8, ' ', 'E', 'N', 'S') + '|'
            linha += ''
            linha += formataString(getNumeroEditado(item.get('egefci_dia_estoque_sugestao'), 2), 19, ' ', 'E', 'N', 'S') + '|'
            linha += ''
            listagem.imprimeLinha('|' + linha)
        listagem.imprimeLinha('*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.imprimeLinha(_('                                                                                                ** Sig Informatica LTDA **                          '))
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.faceamento')
