# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_img_produto(osv.Model):
    """
    Tabela de imagens de produto
    """
    _name = 'estoque_img.produto'
    _description = 'Tabela de imagens dos produtos do estoque'
    _rec_name = 'sequence'
    from funcoes import _estimg_get_dados
    _columns = {
        'id': fields.integer('Id', readonly=1),
        'estimg_produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="restrict", select=True,
                                                  required=True),
        'estimg_grade_id': fields.many2one("estoque.produto.grade", 'Grade', ondelete="restrict", select=True,
                                                 domain="[('produto_id', '=', estimg_produto_id)]"),
        'sequence' : fields.integer('Ordem'),
        'estimg_foto': fields.binary('Foto', filters='*.png,*.gif,*.jpeg'),
        'estimg_dimensoes': fields.function(_estimg_get_dados, type='char', size=10, string='Dimensoes', method=True,
                                            multi='dados'),
        'estimg_formato': fields.function(_estimg_get_dados, type='char', size=10, string='Formato', method=True,
                                            multi='dados'),
        'estimg_tamanho': fields.function(_estimg_get_dados, type='char', size=10, string='Tamanho', method=True,
                                          multi='dados'),
    }
    _defaults = {
        'sequence': 10,
    }
    _order = 'estimg_produto_id,sequence,estimg_grade_id'

