# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.addons.adm import messagebox
from openerp.tools.translate import _


class estoque_inventario_central_capa(osv.Model):
    _name = 'estoque.inventario.central.capa'
    _inherit = 'estoque.inventario.central.capa'

    def ajustar_diferencas(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, list):
            ids = ids[0]
        item_acertos = {}
        cr.execute('select max(estica_controle_transacao) from estoque_inventario_central_acertos')
        _transacao = cr.fetchall()[0][0]
        if not _transacao:
            _transacao = 0
        obj_estoque_inventario_central_acertos = self.pool.get('estoque.inventario.central.acertos')
        obj_estoque_inventario_central_itens = self.pool.get('estoque.inventario.central.itens')
        itens_ids = obj_estoque_inventario_central_itens.search(cr, uid, [('estice_capa_id', '=', ids)],
                                                                context=context)
        itens_dados = obj_estoque_inventario_central_itens.browse(cr, uid, itens_ids)
        for i in itens_dados:
            item_acertos[i.id] = {'difer': i.estici_diferenca_inventario + i.estici_qtd_acerto,
                                  'emb': i.estici_qtd_embalagem}
        empresas_dados = self.browse(cr, uid, ids).esticc_empresas_ids
        for i in range(0, len(empresas_dados)):
            empresa_id1 = empresas_dados[i].estice_empresa_id.id
            item_ids1 = empresas_dados[i].estice_itens_ids
            for j in item_ids1:
                grade_id = j.estici_grade_id.id
                for x in range(i + 1, len(empresas_dados)):
                    empresa_id2 = empresas_dados[x].estice_empresa_id.id
                    item_ids_search = obj_estoque_inventario_central_itens.search(cr, uid, [
                        ('estici_empresas_id.estice_empresa_id', '=', empresa_id2), ('estici_grade_id', '=', grade_id)],
                                                                                  context=context)
                    item_ids2 = obj_estoque_inventario_central_itens.browse(cr, uid, item_ids_search)
                    for y in item_ids2:
                        if y.estici_grade_id.id == grade_id:
                            item_acertos_j = item_acertos.get(j.id) or {}
                            item_acertos_y = item_acertos.get(y.id) or {}
                            if item_acertos_j.get('emb') > item_acertos_y.get('emb'):
                                _emb_maior = item_acertos_j.get('emb') or 1
                            else:
                                _emb_maior = item_acertos_y.get('emb') or 1
                            diferenca1 = int(((item_acertos_j.get('difer') or 0) * (item_acertos_j.get('emb') or 0)) / _emb_maior)
                            diferenca2 = int(((item_acertos_y.get('difer') or 0) * (item_acertos_y.get('emb') or 0)) / _emb_maior)
                            if diferenca1 < 0 < diferenca2 or diferenca2 < 0 < diferenca1:
                                _transacao += 1
                                if abs(diferenca1) <= abs(diferenca2):
                                    diferenca1 = diferenca1 * _emb_maior / (item_acertos_j.get('emb') or 1)
                                    obj_estoque_inventario_central_acertos.create(cr, uid, {
                                        'estica_local_id': y.estici_local_id.id,
                                        'estica_controle_transacao': _transacao,
                                        'estica_item_id': j.id,
                                        'estica_qtd_acerto': -diferenca1,
                                        'estica_empresa_orig_dest_id': empresa_id2}, context)
                                    obj_estoque_inventario_central_acertos.create(cr, uid, {
                                        'estica_local_id': j.estici_local_id.id,
                                        'estica_controle_transacao': _transacao,
                                        'estica_item_id': y.id,
                                        'estica_qtd_acerto': diferenca1,
                                        'estica_empresa_orig_dest_id': empresa_id1}, context)
                                    item_acertos[j.id]['difer'] += -diferenca1
                                    item_acertos[y.id]['difer'] += diferenca1
                                else:
                                    diferenca2 = diferenca2 * _emb_maior / item_acertos[y.id]['emb']
                                    obj_estoque_inventario_central_acertos.create(cr, uid, {
                                        'estica_local_id': y.estici_local_id.id,
                                        'estica_controle_transacao': _transacao,
                                        'estica_item_id': j.id,
                                        'estica_qtd_acerto': diferenca2,
                                        'estica_empresa_orig_dest_id': empresa_id2}, context)
                                    obj_estoque_inventario_central_acertos.create(cr, uid, {
                                        'estica_local_id': j.estici_local_id.id,
                                        'estica_controle_transacao': _transacao,
                                        'estica_item_id': y.id,
                                        'estica_qtd_acerto': -diferenca2,
                                        'estica_empresa_orig_dest_id': empresa_id1}, context)
                                    item_acertos[j.id]['difer'] += diferenca2
                                    item_acertos[y.id]['difer'] += -diferenca2
        return messagebox(_("DIFERENCAS AJUSTADAS COM SUCESSO"))

    def esticc_onchange_mes(self, cr, uid, ids, mes, context=None):
        # FUNCAO FOI CRIADA PARA COMPLETAR O ZERO O MES CASO SEJA INFORMADO APENAS UM DIGITO, POIS SE FICAR
        # APENAS COM UM DIGITO, NAO LISTAVA OS INVENTARIO PORQUE O MES CADASTRADO NELES POSSUEM DOIS DIGITOS.
        # TENTEI TRATAR NO METODO SEARCH DA CLASS ESTOQUE_INVENTARIO_CAPA, MAS O METODO NAO ERA
        # CHAMADO QUANDO CLICAVA PARA LISTAR OS INVENTARIOS, APENAS QNDO CLICAVA NA OPCAO - PESQUISAR MAIS.
        context = context and context.copy() or {}
        if mes:
            mes = str(mes).rjust(2, '0')
        return {'value': {'esticc_mes': mes}}

    def esticc_button_importa_inventarios(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_estoque_inventario_central_empresas = self.pool.get('estoque.inventario.central.empresas')
        browse_empresas = self.browse(cr, uid, ids[0]).esticc_empresas_ids
        for empresa in browse_empresas:
            if empresa.estice_atualizado and not empresa.estice_importado:
                obj_estoque_inventario_central_empresas.button_importar(cr, uid, empresa.id, context)
        return True

    def esticc_button_gerar_todas_notas_transferencia(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_estoque_inventario_central_empresas = self.pool.get('estoque.inventario.central.empresas')
        browse_empresas = self.browse(cr, uid, ids[0]).esticc_empresas_ids
        for empresa in browse_empresas:
            if not empresa.estice_nf_transferencia:
                obj_estoque_inventario_central_empresas.button_gerar_nota_transferencia(cr, uid, empresa.id, context)
        return True

    def esticc_button_gerar_todas_notas_acerto(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_estoque_inventario_central_empresas = self.pool.get('estoque.inventario.central.empresas')
        browse_empresas = self.browse(cr, uid, ids[0]).esticc_empresas_ids
        for empresa in browse_empresas:
            if not empresa.estice_nf_acerto:
                obj_estoque_inventario_central_empresas.button_gerar_nota_acerto(cr, uid, empresa.id, context)
        return True
