# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.addons.adm import messagebox
import socket
from SigUtils.formatastring import formataString
from openerp.tools.translate import _


class estoque_inventario_central_empresas(osv.osv):
    _name = 'estoque.inventario.central.empresas'
    _inherit = 'estoque.inventario.central.empresas'

    def estice_get_qtd_itens_nf(self, cr, uid):
        _qtd = 0
        modulo_ressuprimento_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid,
                                                                                                  'estoqueressuprimento',
                                                                                                  context={})
        if modulo_ressuprimento_instalado:
            _dados = self.pool.get('estoque.parametro').estpar_get_fields(
                cr, uid, ['ressuprimento_item_qtde_max'], context=None)
            if isinstance(_dados, list):
                _dados = _dados[0]
            _qtd = _dados['ressuprimento_item_qtde_max']
        if _qtd == 0:
            _qtd = 100
        return _qtd

    def button_desatualizado(self, cr, uid, ids, context=None):
        """
        @param cr:
        @param uid:
        @param ids:
        @param context:
        @return:
        """
        context = context and context.copy() or {}
        return False

    def button_atualizado(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return False

    def button_importar(self, cr, uid, ids, context=None):
        """
        Importa a contagem(estoque.inventario.contagem) para os controle de itens(estoque.inventario.central.itens)
        Para cada item que estiver na contagem, havendo diferenca entre a contagem e o saldo, gera um registro no controle de itens
        @param cr:
        @param uid:
        @param ids:
        @param context:
        @return: True
        """
        context = context and context.copy() or {}
        if isinstance(ids, list):
            ids = ids[0]
        obj_estoque_inventario_capa = self.pool.get('estoque.inventario.capa')
        obj_estoque_inventario_central_itens = self.pool.get('estoque.inventario.central.itens')
        obj_estoque_inventario_central_excluir_item = self.pool.get('estoque.inventario.central.excluir.item')
        obj_estoque_inventario_central_excluir_local = self.pool.get('estoque.inventario.central.excluir.local')
        estice_dados = self.browse(cr, uid, ids, context)
        estice_empresa_id = estice_dados.estice_empresa_id.id
        local_excluidos_ids = obj_estoque_inventario_central_excluir_local.search(cr, uid,
                                                                                  [('estcel_empresa_id', '=',
                                                                                    estice_empresa_id)], context=context
                                                                                  )
        if local_excluidos_ids:
            browse_excluir_local = obj_estoque_inventario_central_excluir_local.browse(cr, uid, local_excluidos_ids)
            local_excluidos_ids = map(lambda i: i.estcel_local_id.id, browse_excluir_local)
        produto_excluidos_ids = obj_estoque_inventario_central_excluir_item.search(cr, uid, [], context=context)
        if produto_excluidos_ids:
            browse_excluir_item = obj_estoque_inventario_central_excluir_item.browse(cr, uid, produto_excluidos_ids)
            produto_excluidos_ids = map(lambda i: i.estcei_produto_id.id, browse_excluir_item)
        capa_id = estice_dados.estice_inventario_id.id
        if isinstance(capa_id, list):
            capa_id = capa_id[0]
        contagem_dados = []
        if capa_id:
            contagem_dados = obj_estoque_inventario_capa.browse(cr, uid, capa_id).inventario_contagem_ids
            contagem_dados = filter(lambda i: (i['saldo_cadastro'] != i['saldo_contado']),
                                    contagem_dados)  # Se nao tem diferenca nao precisa importar
        for i in contagem_dados:
            if i.local_id.excluir_consultas:  # Nao considerar locais excluidos
                continue
            if i.produto_id.tipo == 'S':  # Nao considerar servicos
                continue
            local_id = i.local_id.id
            produto_id = i.produto_id.id
            vals = {
                'estici_empresas_id': ids,
                'estici_local_id': local_id,
                'estici_produto_id': produto_id,
                'estici_grade_id': i.grade_id.id,
                'estici_diferenca_inventario': i.saldo_contado - i.saldo_cadastro,
                'estici_inventario_item_id': i.id,
            }
            if not produto_id in produto_excluidos_ids and not local_id in local_excluidos_ids:
                obj_estoque_inventario_central_itens.create(cr, uid, vals, context=context)
        self.write(cr, uid, ids, {'estice_importado': True}, context=context)
        return True

    def _get_parametros_envio(self, cr, uid, company_id, context=None):
        context = context and context.copy() or {}
        obj_adm_parametro = self.pool.get('adm.parametro')
        adm_parametro_id = obj_adm_parametro.search(cr, uid, [('company_id', '=', company_id)], context=context)
        if adm_parametro_id and isinstance(adm_parametro_id, list):
            adm_parametro_id = adm_parametro_id[0]
        adm_parametros = obj_adm_parametro.read(cr, uid, adm_parametro_id,
                                                ['admpar_siggestao_servidor', 'admpar_siggestao_diretorio',
                                                 'admpar_siggestao_dav_exportar'], context=context)
        admpar_siggestao_servidor = adm_parametros.get('admpar_siggestao_servidor')
        admpar_siggestao_diretorio = adm_parametros.get('admpar_siggestao_diretorio')
        admpar_siggestao_dav_exportar = adm_parametros.get('admpar_siggestao_dav_exportar')
        return {'admpar_siggestao_servidor': admpar_siggestao_servidor,
                'admpar_siggestao_diretorio': admpar_siggestao_diretorio,
                'admpar_siggestao_dav_exportar': admpar_siggestao_dav_exportar}

    def _envia_arquivo_nf(self, admpar_siggestao_dav_exportar, admpar_siggestao_diretorio, admpar_siggestao_servidor,
                          arquivo):
        """
        Efetua a comunicacao com o SigGestao, transferindo as notas geradas
        @param admpar_siggestao_dav_exportar:
        @param admpar_siggestao_diretorio:
        @param admpar_siggestao_servidor:
        @param arquivo:
        @return: String - a Mensagem devolvida pelo TcpServer.py
        """
        client_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        address = ((admpar_siggestao_servidor, 5019))
        try:
            client_socket.connect(address)
        except Exception as e:
            return e
        client_socket.send('ESTA AI?')
        mensagem = client_socket.recv(2048)
        if not mensagem.startswith('OK'):
            raise osv.except_osv('Atencao', mensagem)

        client_socket.send('DIR:' + admpar_siggestao_diretorio)
        mensagem = client_socket.recv(2048)
        if not mensagem.startswith('OK'):
            raise osv.except_osv('Atencao', 'Diretorio nao existe ou sem permissao: Diretorio: %s'
                                 % admpar_siggestao_diretorio)

        client_socket.send('ARQ NOME:' + admpar_siggestao_diretorio + '/nf.cmd')
        mensagem = client_socket.recv(2048)
        if not mensagem.startswith('OK'):
            raise osv.except_osv('Atencao', mensagem)

        for linha in arquivo:
            comando = 'ARQ DADOS:' + linha
            client_socket.send(comando)
            mensagem = client_socket.recv(2048)
            if not mensagem.startswith('OK'):
                raise osv.except_osv('Atencao', mensagem)

        client_socket.send('ARQ FECHAR:')
        mensagem = client_socket.recv(2048)
        if not mensagem.startswith('OK'):
            raise osv.except_osv('Atencao', mensagem)

        comando = 'EXECUTAR:' + admpar_siggestao_dav_exportar
        client_socket.send(comando)
        mensagem = client_socket.recv(2048)
        if not mensagem.startswith('OK'):
            if mensagem.startswith('ERRO!'):
                mensagem = 'Sem permissao para execucao'
            raise osv.except_osv('Atencao', mensagem)

        client_socket.send('LER:' + admpar_siggestao_diretorio + '/nf.ret')
        mensagem = client_socket.recv(2048)
        if mensagem.startswith('OK'):
            return 'OK'
        else:
            return mensagem

    def _criar_registro_1(self, cr, uid, empresa_dados, natureza_acerto_codigo, context=None):
        """
        Gera o registro de capa da nf
        @param cr:
        @param uid:
        @param empresa_dados: browse do estoque.inventario.central.empresas
        @param natureza_acerto_codigo: CFOP da nota
        @return: o Registro gerado (String)
        """
        context = context and context.copy() or {}
        linha = "1"
        linha += formataString(natureza_acerto_codigo, 4, '0', 'E')
        empresa_legado = empresa_dados.estice_empresa_id.id
        try:
            # e_ids = self.pool.get('legado.empresa').search(cr, uid, [('LEGEMP_COMPANY_ID', '=', empresa_dados.estice_empresa_id.id)])
            e_ids = self.pool.get('legado.empresa').search(cr, uid, [('company_id', '=', empresa_legado)],
                                                           context=context)
            if e_ids:
                # empresa_legado = self.pool.get('legado.empresa').read(cr, uid, e_ids)[0]['LEGEMP_EMPRESA_LEGADO']
                empresa_legado = self.pool.get('legado.empresa').read(cr, uid, e_ids, context=context)[0][
                    'empresa_legado']
        except:
            pass
        linha += formataString(empresa_legado, 3, '0', 'E')
        return linha

    def _criar_registro_2(self, i):
        """
        Criar o registro de itens da nf
        @param i: browse de estoque.inventario.central.itens
        @return: O registro gerado(String)
        """
        linha = "2"
        linha += formataString(i.estici_produto_id.codigo, 10, '0', 'E')
        linha += formataString('', 5, '', 'E')
        if i.estici_produto_id.grade_usar:
            linha += formataString(i.estici_grade_id.grade, 2, '', 'E')
        else:
            linha += '  '
        quantidade = "%.3f" % abs(i.estici_diferenca_inventario + i.estici_qtd_acerto)
        linha += formataString(str(quantidade).replace('.', '').replace(',', ''), 9, '0', 'E')
        linha += formataString(str(i.estici_local_id.numero), 2, '0', 'E')
        return linha

    def _criar_arquivo_nota_acerto_saida(self, cr, uid, empresa_dados, natureza_acerto_saida_codigo, context=None):
        """
        Gerar arquivo para emissao de notas de acerto de saida
        @param cr:
        @param uid:
        @param empresa_dados: browse do arquivo estoque.inventario.central.empresas
        @param natureza_acerto_saida_codigo: CFOP para a nf
        @return: Arquivo completo com capa e itens,
        """
        context = context and context.copy() or {}
        arquivo = []
        linha1 = self._criar_registro_1(cr, uid, empresa_dados, natureza_acerto_saida_codigo, context=context)
        _qtd = 0
        for i in empresa_dados.estice_itens_ids:
            if i.estici_diferenca_inventario + i.estici_qtd_acerto < 0:
                if _qtd == 0:
                    arquivo.append(linha1)
                _qtd += 1
                linha = self._criar_registro_2(i)
                arquivo.append(linha)
                if _qtd == self.estice_get_qtd_itens_nf(cr, uid):  # limita a qtd de itens
                    _qtd = 0
        return arquivo

    def _criar_arquivo_nota_acerto_entrada(self, cr, uid, empresa_dados, natureza_acerto_entrada_codigo, context=None):
        """
        Gerar arquivo para emissao de notas de acerto de entrada
        @param cr:
        @param uid:
        @param empresa_dados: browse do arquivo estoque.inventario.central.empresas
        @param natureza_acerto_entrada_codigo: CFOP da nota
        @return: Arquivo completo com capa e itens,
        """
        context = context and context.copy() or {}
        arquivo = []
        linha1 = self._criar_registro_1(cr, uid, empresa_dados, natureza_acerto_entrada_codigo, context=context)
        _qtd = 0
        for i in empresa_dados.estice_itens_ids:
            if i.estici_diferenca_inventario + i.estici_qtd_acerto > 0:
                if _qtd == 0:
                    arquivo.append(linha1)
                _qtd += 1
                linha = self._criar_registro_2(i)
                arquivo.append(linha)
                if _qtd == self.estice_get_qtd_itens_nf(cr, uid):  # Limita a qtd de itens na nf
                    _qtd = 0
        return arquivo

    def button_gerar_nota_acerto(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, list):
            ids = ids[0]
        empresa_dados = self.browse(cr, uid, ids)
        empresa_id = empresa_dados.estice_empresa_id.id
        itens_dados = empresa_dados.estice_itens_ids
        if not itens_dados:
            raise osv.except_osv(_('Atencao'), _('Nao existem dados para gerar a nota'))
        obj_fiscal_parametro = self.pool.get('fiscal.parametro')
        obj_fiscal_utils = self.pool.get('fiscal.utils')
        obj_estoque_produto_embalagem = self.pool.get('estoque.produto.embalagem')
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
        parametros_envio = self._get_parametros_envio(cr, uid, company_id, context=context)
        admpar_siggestao_servidor = parametros_envio.get('admpar_siggestao_servidor')
        admpar_siggestao_diretorio = parametros_envio.get('admpar_siggestao_diretorio')
        admpar_siggestao_dav_exportar = parametros_envio.get('admpar_siggestao_dav_exportar')
        fiscal_parametro_id = obj_fiscal_parametro.search(cr, uid, [('company_id', '=', company_id)], context=context)
        if not fiscal_parametro_id:
            raise osv.except_osv(_('Atencao'), _('Parametro do fiscal nao cadastrado'))
        if isinstance(fiscal_parametro_id, list):
            fiscal_parametro_id = fiscal_parametro_id[0]
        fispar_natureza_acerto_entrada = obj_fiscal_parametro.browse(cr, uid,
                                                                     fiscal_parametro_id).fispar_natureza_acerto_entrada
        if not fispar_natureza_acerto_entrada:
            raise osv.except_osv(_('Atencao'),
                                 _('Natureza para acerto de entrada nao cadastrada no parametro do fiscal'))
        fispar_natureza_acerto_entrada_codigo = fispar_natureza_acerto_entrada.cfop_id.codigo
        fispar_natureza_acerto_entrada = fispar_natureza_acerto_entrada.id
        fispar_natureza_acerto_saida = obj_fiscal_parametro.browse(cr, uid,
                                                                   fiscal_parametro_id).fispar_natureza_acerto_saida
        if not fispar_natureza_acerto_saida:
            raise osv.except_osv(_('Atencao'), _('Natureza para acerto de saida nao cadastrada no parametro do fiscal'))
        fispar_natureza_acerto_saida_codigo = fispar_natureza_acerto_saida.cfop_id.codigo
        fispar_natureza_acerto_saida = fispar_natureza_acerto_saida.id
        if not admpar_siggestao_dav_exportar or not admpar_siggestao_servidor or not admpar_siggestao_diretorio:
            nf_saida_id = obj_fiscal_utils.gerar_nf(cr, uid, company_id=empresa_id,
                                                    destinatario_id=empresa_id,
                                                    natureza_id=fispar_natureza_acerto_saida,
                                                    nf_condicao_ids=[],
                                                    tipo='S')
            if not nf_saida_id:
                raise osv.except_osv(_('Atencao'), _('Erro ao gerar nota fiscal de saida'))
            nf_entrada_id = obj_fiscal_utils.gerar_nf(cr, uid, company_id=empresa_id,
                                                      destinatario_id=empresa_id,
                                                      natureza_id=fispar_natureza_acerto_entrada,
                                                      nf_condicao_ids=[],
                                                      tipo='E',
                                                      context={'criar': True})
            if not nf_entrada_id:
                raise osv.except_osv(_('Atencao'), _('Erro ao gerar nota fiscal de entrada'))
            for i in itens_dados:
                produto_embalagem_id = obj_estoque_produto_embalagem.search(cr, uid, [
                    ('produto_id', '=', i.estici_produto_id.id)], context=context)
                if produto_embalagem_id:
                    if isinstance(produto_embalagem_id, list):
                        produto_embalagem_id = produto_embalagem_id[0]
                else:
                    produto_embalagem_id = False
                if i.estici_diferenca_inventario + i.estici_qtd_acerto > 0:
                    obj_fiscal_utils.gerar_nf_itens(cr, uid, nf_saida_id,
                                                    produto_id=i.estici_produto_id.id,
                                                    tipo='P',
                                                    local_id=i.estici_local_id.id,
                                                    produto_embalagem_id=produto_embalagem_id,
                                                    grade_id=i.estici_grade_id.id,
                                                    quantidade=i.estici_diferenca_inventario + i.estici_qtd_acerto,
                                                    vr_desconto=0,
                                                    vr_unitario=0,
                                                    vendedor_id=False,
                                                    vendedor_externo_id=False,
                                                    item_preco_venda=0, context={})
                elif i.estici_diferenca_inventario + i.estici_qtd_acerto < 0:
                    obj_fiscal_utils.gerar_nf_itens(cr, uid, nf_entrada_id,
                                                    produto_id=i.estici_produto_id.id,
                                                    tipo='P',
                                                    local_id=i.estici_local_id.id,
                                                    produto_embalagem_id=produto_embalagem_id,
                                                    grade_id=i.estici_grade_id.id,
                                                    quantidade=i.estici_diferenca_inventario + i.estici_qtd_acerto,
                                                    vr_desconto=0,
                                                    vr_unitario=0,
                                                    vendedor_id=False,
                                                    vendedor_externo_id=False,
                                                    item_preco_venda=0, context={})
        else:
            # gerar arquivo para nf de saida
            arquivo = self._criar_arquivo_nota_acerto_saida(cr, uid, empresa_dados, fispar_natureza_acerto_saida_codigo)
            mensagem1 = self._envia_arquivo_nf(admpar_siggestao_dav_exportar,
                                               admpar_siggestao_diretorio,
                                               admpar_siggestao_servidor,
                                               arquivo, context=context)
            if mensagem1 != 'OK':
                raise osv.except_osv(_('Atencao'), (mensagem1))
                # gerar arquivo para nf de entrada
            arquivo = self._criar_arquivo_nota_acerto_entrada(cr, uid, empresa_dados,
                                                              fispar_natureza_acerto_entrada_codigo, context=context)
            mensagem2 = self._envia_arquivo_nf(admpar_siggestao_dav_exportar, admpar_siggestao_diretorio,
                                               admpar_siggestao_servidor, arquivo)
            if mensagem2 != 'OK':
                raise osv.except_osv(_('Atencao'), (mensagem1))
        self.write(cr, uid, ids, {'estice_nf_acerto': True}, context=context)
        return messagebox(_('Notas de acerto geradas'))

    def _criar_arquivo_nota_transferencia(self, cr, uid, empresa_id, empresa_destino_id, acertos_dados,
                                          natureza_transferencia_codigo, context=None):
        """
        Criar arquivo para notas de transferencia
        Agrupar por empresa de origem e de destino para saber para quantas empresas terá que emitir nf.
        @param cr:
        @param uid:
        @param empresa_id: id da empresa
        @param acertos_dados:
        @param natureza_transferencia_codigo: Codigo do CFOP
        @return:
        """
        context = context and context.copy() or {}
        arquivo = []
        linha1 = "1"
        linha1 += formataString(natureza_transferencia_codigo, 4, '0', 'E')
        empresa_legado = empresa_id
        try:
            e_ids = self.pool.get('legado.empresa').search(cr, uid, [('company_id', '=', empresa_legado)],
                                                           context=context)
            if e_ids:
                empresa_legado = self.pool.get('legado.empresa').read(cr, uid, e_ids, context=context)[0][
                    'empresa_legado']
        except:
            pass
        linha1 += formataString(empresa_legado, 3, '0', 'E')
        empresa_legado = empresa_destino_id
        try:
            e_ids = self.pool.get('legado.empresa').search(cr, uid, [('company_id', '=', empresa_legado)],
                                                           context=context)
            if e_ids:
                empresa_legado = self.pool.get('legado.empresa').read(cr, uid, e_ids, context=context)[0][
                    'empresa_legado']
        except:
            pass
        linha1 += formataString(empresa_legado, 3, '0', 'E')
        _qtd = 0
        for i in acertos_dados:
            if i.estica_item_id.estici_empresas_id.estice_empresa_id.id == empresa_id and \
                            i.estica_empresa_orig_dest_id.id == empresa_destino_id and \
                            i.estica_qtd_acerto > 0:  # so saidas
                if _qtd == 0:
                    arquivo.append(linha1)
                _qtd += 1
                linha = "2"
                linha += formataString(i.estica_item_id.estici_produto_id.codigo, 10, '0', 'E')
                linha += formataString('', 5, '', 'E')
                if i.estica_item_id.estici_produto_id.grade_usar:
                    linha += formataString(i.estica_item_id.estici_grade_id.grade, 2, '', 'E')
                else:
                    linha += '  '
                quantidade = "%.3f" % abs(i.estica_qtd_acerto)
                linha += formataString(str(quantidade).replace('.', '').replace(',', ''), 9, '0', 'E')
                linha += formataString(str(i.estici_local_id.numero), 2, '0', 'E')
                _transacao = i.estica_controle_transacao
                _dest_ids = self.pool.get('estoque.inventario.central.acertos').search(cr, uid,
                                                                                       [('estica_controle_transacao',
                                                                                         '=', _transacao),
                                                                                        ('estica_qtd_acerto', '<', 0)],
                                                                                       context=context)
                if not _dest_ids:
                    raise osv.except_osv(('Atencao'),
                                         (
                                         'Sua base esta corrompida. Foi encontrado uma transacao sem seu par correspondente. Transacao: %s' % _transacao))
                _local_destino_brw = self.pool.get('estoque.inventario.central.acertos').browse(cr, uid, _dest_ids)[0]
                linha += formataString(str(_local_destino_brw.estici_local_id.numero), 2, '0', 'E')
                arquivo.append(linha)
            if _qtd == self.estice_get_qtd_itens_nf(cr, uid):
                _qtd = 0
        return arquivo

    def button_gerar_nota_transferencia(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, list):
            ids = ids[0]
        read_dados = self.read(cr, uid, ids, ['estice_itens_ids'], context=context)
        if not read_dados:
            raise osv.except_osv(('Atencao'), ('Nao existem dados para gerar a nota'))
        obj_fiscal_parametro = self.pool.get('fiscal.parametro')
        obj_fiscal_utils = self.pool.get('fiscal.utils')
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
        parametro_id = obj_fiscal_parametro.search(cr, uid, [('company_id', '=', company_id)], context=context)
        if not parametro_id:
            raise osv.except_osv(('Atencao'), ('Parametro do fiscal nao cadastrado'))
        if isinstance(parametro_id, list):
            parametro_id = parametro_id[0]
        obj_natureza_transferencia = obj_fiscal_parametro.browse(
            cr, uid, parametro_id).fispar_natureza_transferencia_saida_id
        if not obj_natureza_transferencia:
            raise osv.except_osv(('Atencao'), ('Natureza para transferencia nao cadastrada no parametro do fiscal'))
        natureza_transferencia_id = obj_natureza_transferencia.id
        obj_estoque_inventario_central_acertos = self.pool.get('estoque.inventario.central.acertos')
        read_dados = read_dados.get('estice_itens_ids')
        acertos_ids = obj_estoque_inventario_central_acertos.search(cr, uid, [('estica_item_id', 'in', read_dados),
                                                                              ('estica_qtd_acerto', '>', 0)],
                                                                    context=context)
        empresa_ids = []
        acertos_dados = obj_estoque_inventario_central_acertos.browse(cr, uid, acertos_ids)
        for i in acertos_dados:
            empresa_ids.append(i.estica_empresa_orig_dest_id.id)
        empresa_ids = list(set(empresa_ids))
        empresa_dados = self.browse(cr, uid, ids)
        parametros_envio = self._get_parametros_envio(cr, uid, empresa_dados.estice_empresa_id.id, context=context)
        admpar_siggestao_servidor = parametros_envio.get('admpar_siggestao_servidor')
        admpar_siggestao_diretorio = parametros_envio.get('admpar_siggestao_diretorio')
        admpar_siggestao_dav_exportar = parametros_envio.get('admpar_siggestao_dav_exportar')
        for j in empresa_ids:
            if not admpar_siggestao_dav_exportar or not admpar_siggestao_servidor or not admpar_siggestao_diretorio:
                nf_id = obj_fiscal_utils.gerar_nf(cr, uid, company_id=empresa_dados.estice_empresa_id.id,
                                                  destinatario_id=j, natureza_id=natureza_transferencia_id)
                if not nf_id:
                    raise osv.except_osv(('Atencao'), ('Erro ao gerar nota fiscal'))
                for i in acertos_dados:
                    if i.estica_empresa_orig_dest_id.id == j:
                        obj_fiscal_utils.gerar_nf_itens(cr, uid, nf_id,
                                                        i.estica_item_id.estici_produto_id.id,
                                                        tipo='P',
                                                        local_id=i.estica_local_id.id,
                                                        produto_embalagem_id=False,
                                                        grade_id=i.estica_item_id.estici_grade_id.id,
                                                        quantidade=abs(i.estica_qtd_acerto),
                                                        vr_desconto=0,
                                                        vr_unitario=0,
                                                        vendedor_id=False,
                                                        vendedor_externo_id=False,
                                                        item_preco_venda=0, context={})
            else:
                arquivo = self._criar_arquivo_nota_transferencia(cr, uid,
                                                                 empresa_dados.estice_empresa_id.id,
                                                                 j,
                                                                 acertos_dados,
                                                                 obj_natureza_transferencia.cfop_id.codigo,
                                                                 context=context)
                mensagem1 = self._envia_arquivo_nf(admpar_siggestao_dav_exportar,
                                                   admpar_siggestao_diretorio,
                                                   admpar_siggestao_servidor,
                                                   arquivo)
                if mensagem1 != 'OK':
                    raise osv.except_osv(_('Atencao'), (mensagem1))
        self.write(cr, uid, ids, {'estice_nf_transferencia': True}, context=context)
        return messagebox('Notas de transferencia geradas!')
