from openerp.osv import osv, fields


class estoque_inventario_central_capa(osv.Model):
    _name = 'estoque.inventario.central.capa'

    from funcoes import _check_empresas_importadas, _check_notas_transferencia_geradas, _check_notas_acerto_geradas

    _columns = {
        'esticc_ano': fields.char('Ano', size=4, required=True),
        'esticc_mes': fields.char('Mes', size=2, required=True),
        'name': fields.char('Descricao', size=30, required=True),
        'esticc_empresas_ids': fields.one2many('estoque.inventario.central.empresas', 'estice_capa_id', 'Empresas'),
        'esticc_empresas_importadas': fields.function(_check_empresas_importadas, method=True,
                                                      string="Empresas importadas",
                                                      type="boolean", store=False),
        'esticc_notas_transferencia_geradas': fields.function(_check_notas_transferencia_geradas, method=True,
                                                              string="Notas de transferencia geradas", type="boolean",
                                                              store=False),
        'esticc_notas_acerto_geradas': fields.function(_check_notas_acerto_geradas, method=True,
                                                       string="Notas de acerto geradas", type="boolean", store=False),
    }

    _order = 'esticc_ano desc, esticc_mes desc'
