# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_inventario_central_empresas(osv.Model):
    from funcoes import _get_atualizado

    _name = 'estoque.inventario.central.empresas'
    _inherits = {
        'estoque.inventario.central.capa': 'estice_capa_id',
    }
    _columns = {
        'estice_capa_id': fields.many2one("estoque.inventario.central.capa", 'Capa', required=True, select=True,
                                          ondelete='cascade'),
        'estice_inventario_id': fields.many2one("estoque.inventario.capa", 'Inventario', required=True, select=True,
                                                ondelete='cascade'),
        'estice_empresa_id': fields.many2one("res.company", 'Empresa', required=True),
        'estice_importado': fields.boolean('Itens importados'),
        'estice_atualizado': fields.function(_get_atualizado, type='boolean', method=True, string='Atualizado',
                                             store=False),
        'estice_itens_ids': fields.one2many('estoque.inventario.central.itens', 'estici_empresas_id', 'Itens'),
        'estice_nf_transferencia': fields.boolean('Nf transferencia gerada'),
        'estice_nf_acerto': fields.boolean('Nota fiscal de acerto gerada'),
    }
    _defaults = {
        'estice_importado': False,
        'estice_nf_transferencia': False,
        'estice_nf_acerto': False,
    }
