# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_inventario_central_itens(osv.osv):
    from funcoes import _estici_get_qtd_acerto, _estici_get_qtd_emb

    _name = 'estoque.inventario.central.itens'
    _inherits = {
        'estoque.inventario.central.empresas': 'estici_empresas_id',
    }
    _columns = {
        'estici_empresas_id': fields.many2one("estoque.inventario.central.empresas", 'Empresa', required=True,
                                              select=True, ondelete='cascade'),
        'estici_local_id': fields.many2one("estoque.local", 'Local', required=True, select=True),
        'estici_produto_id': fields.many2one("estoque.produto", 'Produto', required=True, select=True),
        'estici_grade_id': fields.many2one('estoque.produto.grade', 'Item', required=True, select=True),
        'estici_inventario_item_id': fields.many2one("estoque.inventario.contagem", 'Inventario', select=True,
                                                     ondelete='cascade'),
        'estici_qtd_embalagem': fields.function(_estici_get_qtd_emb, method=True, string='Qtd.Embalagem',
                                                type="integer", store=True),
        'estici_diferenca_inventario': fields.float('Diferenca', digits=(11, 3)),
        'estici_qtd_acerto': fields.function(_estici_get_qtd_acerto, method=True, string='Quantidade Acertada',
                                             type='float', store=False),
        'estici_acerto_ids': fields.one2many('estoque.inventario.central.acertos', 'estica_item_id', 'Acertos')
    }
