# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

import time
from openerp.osv import osv, fields


#Funcoes da classe estoque_inventario_central_itens
def _estici_get_qtd_emb(self, cr, uid, ids, name_fields, args, context=None):
    res = {}
    context = context and context.copy() or {}
    item_dados = self.browse(cr, uid, ids)
    for i in item_dados:
        _emb = 1
        for _locacoes in i.estici_grade_id.local_locacao_ids:
            if _locacoes.local_id.numero == i.estici_local_id.numero:
                record_embalagem = _locacoes.estllc_produto_embalagem_id.embalagem_id
                _emb = record_embalagem and record_embalagem.quantidade_na_embalagem or 0
        res[i.id] = _emb
    return res


def _estici_get_qtd_acerto(self, cr, uid, ids, name_fields, args, context=None):
    context = context and context.copy() or {}
    obj_estoque_inventario_central_acertos = self.pool.get('estoque.inventario.central.acertos')
    acertos_ids = obj_estoque_inventario_central_acertos.search(cr, uid, [('estica_item_id', 'in', ids)],
                                                                context=context)
    res = {}.fromkeys(ids, 0)
    for acertos_dados in obj_estoque_inventario_central_acertos.browse(cr, uid, acertos_ids):
        res[acertos_dados.estica_item_id.id] += acertos_dados.estica_qtd_acerto
    return res


#Funcoes da classe estoque_inventario_central_empresas
def _get_atualizado(self, cr, uid, ids, arg, name, context=None):
    res = {}
    context = context and context.copy() or {}
    obj_estoque_inventario_capa = self.pool.get('estoque.inventario.capa')
    estice_dados = self.pool.get('estoque.inventario.central.empresas').browse(cr, uid, ids)
    for i in estice_dados:
        empresa_id = i.estice_empresa_id.id
        ano = i.estice_capa_id.esticc_ano
        mes = i.estice_capa_id.esticc_mes
        capa_id = obj_estoque_inventario_capa.search(cr, uid, [('company_id', '=', empresa_id), ('ano', '=', ano),
                                                               ('mes', '=', mes)], context=context)
        atualizado = False
        if capa_id:
            atualizado = obj_estoque_inventario_capa.read(cr, uid, capa_id[0], ['atualizado'], context=context)
            atualizado = atualizado.get('atualizado')
        res[i.id] = atualizado
    return res


def _check_empresas_importadas(self, cr, uid, ids, name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    for id in ids:
        var = True
        browse_empresas = self.browse(cr, uid, id).esticc_empresas_ids
        for empresa in browse_empresas:
            if not empresa.estice_importado:
                var = False
        res[id] = var
    return res


def _check_notas_transferencia_geradas(self, cr, uid, ids, name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    for id in ids:
        var = True
        browse_empresas = self.browse(cr, uid, id).esticc_empresas_ids
        for empresa in browse_empresas:
            if not empresa.estice_nf_transferencia:
                var = False
        res[id] = var
    return res


def _check_notas_acerto_geradas(self, cr, uid, ids, name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    for id in ids:
        var = True
        browse_empresas = self.browse(cr, uid, id).esticc_empresas_ids
        for empresa in browse_empresas:
            if not empresa.estice_nf_acerto:
                var = False
        res[id] = var
    return res
