# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields

class wizard_demonstrativo_resultado(osv.TransientModel):

    _name = 'wizard.demonstrativo.resultado'

    _columns = {
        'inventario_id': fields.many2one('estoque.inventario.central.capa', 'Inventario', required=True),
        'resultado_itens_ids': fields.one2many('wizard.demonstrativo.resultado.itens', 'capa_id','Itens'),
    }

    def button_pesquisar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_wizard_demonstrativo_resultado_itens = self.pool.get('wizard.demonstrativo.resultado.itens')
        itens_ids = obj_wizard_demonstrativo_resultado_itens.search(cr, uid, [], context=context)
        obj_wizard_demonstrativo_resultado_itens.unlink(cr, uid, itens_ids)
        sql = """select estice_empresa_id, estica_empresa_orig_dest_id, sum(estict_custo_medio_contabil * estica_qtd_acerto) as valor , count(a.id) as qtd
                    from estoque_inventario_central_acertos a
                    left join estoque_inventario_central_itens i on i.id = estica_item_id
                    left join estoque_inventario_contagem c on c.id = estici_inventario_item_id
                    left join estoque_inventario_central_empresas e on e.id = estici_empresas_id
                    where estica_qtd_acerto > 0
                    group by estice_empresa_id, estica_empresa_orig_dest_id"""
        cr.execute(sql)
        registros = cr.dictfetchall()
        for registro in registros:
            vals = {
                'capa_id': ids[0],
                'operacao': 'T',
                'empresa_saida_id': registro['estice_empresa_id'],
                'empresa_entrada_id': registro['estica_empresa_orig_dest_id'],
                'valor': registro['valor'],
                'qtd': registro['qtd'],
                'qtd_nf': int(registro['qtd'] / 100) + 1,
            }
            self.pool.get('wizard.demonstrativo.resultado.itens').create(cr, uid, vals, context)
        sql = """select estice_empresa_id, sum(estict_custo_medio_contabil * (estici_diferenca_inventario + estica_qtd_acerto)) as valor, count(i.id) as qtd
                     from estoque_inventario_central_acertos
                     left join estoque_inventario_central_itens i on i.id = estica_item_id
                     left join estoque_inventario_contagem c on c.id = estici_inventario_item_id
                     left join estoque_inventario_central_empresas e on e.id = estici_empresas_id
                     where (estici_diferenca_inventario + estica_qtd_acerto) < 0
                     group by estice_empresa_id"""
        cr.execute(sql)
        registros = cr.dictfetchall()
        for registro in registros:
            vals = {
                'capa_id': ids[0],
                'operacao': 'S',
                'empresa_saida_id': registro['estice_empresa_id'],
                'valor': abs(registro['valor']),
                'qtd': registro['qtd'],
                'qtd_nf': int(registro['qtd'] / 100) + 1,
            }
            self.pool.get('wizard.demonstrativo.resultado.itens').create(cr, uid, vals, context)
        sql = """select estice_empresa_id, sum(estict_custo_medio_contabil * (estici_diferenca_inventario + estica_qtd_acerto)) as valor, count(i.id) as qtd
                     from estoque_inventario_central_acertos
                     left join estoque_inventario_central_itens i on i.id = estica_item_id
                     left join estoque_inventario_contagem c on c.id = estici_inventario_item_id
                     left join estoque_inventario_central_empresas e on e.id = estici_empresas_id
                     where (estici_diferenca_inventario + estica_qtd_acerto) > 0
                     group by estice_empresa_id"""
        cr.execute(sql)
        registros = cr.dictfetchall()
        for registro in registros:
            vals = {
                'capa_id': ids[0],
                'operacao': 'E',
                'empresa_saida_id': registro['estice_empresa_id'],
                'valor': registro['valor'],
                'qtd': registro['qtd'],
                'qtd_nf': int(registro['qtd'] / 100) + 1,
            }
            self.pool.get('wizard.demonstrativo.resultado.itens').create(cr, uid, vals, context)
        return True

class wizard_demonstrativo_resultado_itens(osv.TransientModel):

    _name = 'wizard.demonstrativo.resultado.itens'
    _columns = {
        'capa_id': fields.many2one('wizard.demonstrativo.resultado', 'Capa'),
        'operacao': fields.selection([('T','Transferencia'),('E','Acerto Entrada'),('S','Acerto Saida')],'Operacao', size=1),
        'empresa_saida_id': fields.many2one('res.company', 'Emp. Saida'),
        'empresa_entrada_id': fields.many2one('res.company', 'Emp. Entrada'),
        'valor': fields.float('Valor', digits=(10,2)),
        'qtd': fields.integer('Qtd itens'),
        'qtd_nf': fields.integer('Qtd nfs'),
        }
