# -*- coding: utf-8 -*-

from openerp.osv import osv


class fiscal_nf_capa(osv.Model):
    _inherit = 'fiscal.nf.capa'

    def nfe_infnfe_det_infadprod(self, cr, user, item, context=None):
        """
        Acrescenta informacoes adicionais aos dados do item.

        :param cr: cursor do banco de dados
        :param user: o ID do usuario utilizado para a verificacao de perfil
        :param item: o ID do item da nota fiscal
        :param context: um dicionario padrao para valores contextuais
        :type cr: object
        :type user: int
        :type item: long
        :type context: dict
        :return: lista com as informacoes adicionais do item.
        :rtype: list
        """
        # //NFe.infNFe.det.infAdProd - Informacoes adicionais do produto
        context = context and context.copy() or {}
        res = super(fiscal_nf_capa, self).nfe_infnfe_det_infadprod(cr, user, item, context)
        lote = self.pool.get('estoque.movimento.itens').read(cr, user, item, ['estmvi_lote'],
                                                             context).get('estmvi_lote') or ''
        lote and res.append('Lote: ' + lote)
        return res
