# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _
from datetime import datetime


class estoquealmoxarifado_requisicao_item(osv.Model):
    _name = 'estoquealmoxarifado.requisicao.item'
    _inherit = 'estoquealmoxarifado.requisicao.item'

    def onchange_quantidade_embalagem(self, cr, uid, ids, quantidade_requisitada, produto_id,
                                      grade_id, local_id, produto_embalagem_id):
        warning = {}
        val = {}

        if local_id:
            if all([produto_id, grade_id, local_id, produto_embalagem_id]):
                local_locacao_ids = self.pool.get('estoque.local.locacao').search(
                    cr, uid, [('produto_id', '=', produto_id), ('grade_id', '=', grade_id),
                              ('local_id', '=', local_id),
                              ('estllc_produto_embalagem_id', '=', produto_embalagem_id)])
                if not local_locacao_ids:
                    return {'value': {'produto_id': False, 'grade_id': False,
                                      'produto_embalagem_id': False,
                                      'quantidade_requisitada': 0},
                            'warning': {'title': _('Atencao'),
                                        'message': _('Produto, grade e embalagem nao cadastrados '
                                                     'para o local informado')}}
            aceita_saldo_negativo = self.pool.get('estoque.local').browse(
                cr, uid, local_id).aceita_saldo_negativo

            if not aceita_saldo_negativo:
                if grade_id:
                    saldo = self.pool.get('estoque.produto.saldo').get_saldo_do_dia(
                        cr, uid, grade_id, datetime.today(), eps_local_id=local_id, context={})
                    _saldo_disponivel = saldo.get(grade_id).get('disponivel')
                    if quantidade_requisitada > _saldo_disponivel:
                        warning = {
                            'title': _('Atencao'),
                            'message': _('Quantidade requisitada maior que o saldo disponivel')}

            if produto_embalagem_id:
                fracao = self.pool.get('estoque.produto.embalagem').browse(
                    cr, uid, produto_embalagem_id).embalagem_id.unidade_id.fracao

                qt = quantidade_requisitada % 1
                if qt != 0.0 and not fracao:
                    warning['title'] = _('Atencao')
                    warning['message'] = _('Esta unidade nao aceita valor fracionado')
                    val['quantidade_requisitada'] = 0

        return {'value': val, 'warning': warning}

    def onchange_produto(self, cr, uid, ids, produto_id, local_id, context=None):
        context = context and context.copy() or {}
        val = {}
        warning = {}
        if produto_id and local_id:
            evento_id = self.pool.get('estoque.categoria').estcat_get_evento(cr, uid, ids, produto_id, context=context)
            if evento_id:
                val['evento_id'] = evento_id
            else:
                val['evento_id'] = False
                ############################### BUSCAR GRADE DO PRODUTO ##################################
            grade_id = self.pool.get('estoque.produto.grade').search(cr, uid, [('produto_id', '=', produto_id)], context=context)
            if grade_id and len(grade_id) == 1:
                if isinstance(grade_id, list):
                    grade_id = grade_id[0]
                val['grade_id'] = grade_id
                aceita_saldo_negativo = self.pool.get('estoque.local').browse(cr, uid, local_id, context=context).aceita_saldo_negativo
                if not aceita_saldo_negativo:
                    saldo = self.pool.get('estoque.produto.saldo').get_saldo_do_dia(cr, uid,
                                grade_id, datetime.today(), eps_local_id=local_id, context=context)
                    saldo = saldo.get(grade_id).get('saldo')
                    if saldo <= 0:
                        warning = {'title': _('Atencao'), 'message': _('Produto possui saldo insuficiente')}
                    ########################### BUSCAR EMBALAGEM DO LOCAL
                local_locacao_id = self.pool.get('estoque.local.locacao').search(cr, uid, [('local_id', '=', local_id),
                                                                                           ('grade_id', '=', grade_id)],
                                                                                 context=context)
                if local_locacao_id:
                    estllc_produto_embalagem_id = \
                        self.pool.get('estoque.local.locacao').read(cr, uid, local_locacao_id[0],
                                                                    ['estllc_produto_embalagem_id'], context=context)[
                            'estllc_produto_embalagem_id']
                    if estllc_produto_embalagem_id:
                        if isinstance(estllc_produto_embalagem_id, (list, tuple)):
                            estllc_produto_embalagem_id = estllc_produto_embalagem_id[0]
                        embalagem_id = \
                            self.pool.get('estoque.produto.embalagem').read(cr, uid, estllc_produto_embalagem_id,
                                                                            ['embalagem_id'], context=context)['embalagem_id']
                        if embalagem_id:
                            embalagem = self.pool.get('estoque.embalagem').read(cr, uid, embalagem_id[0],
                                                                                ['name', 'sigla'], context=context)

                        val['produto_embalagem_id'] = estllc_produto_embalagem_id
                ################## ONCHANE_EMBALAGEM - BUSCAR EMBALAGEM SE FOR UNICA #####################
            produto_embalagem_id = self.pool.get('estoque.produto.embalagem').search(cr, uid,
                                                                                     [('produto_id', '=', produto_id)],
                                                                                     context=context)
            if len(produto_embalagem_id) == 1:
                if isinstance(produto_embalagem_id, list):
                    produto_embalagem_id = produto_embalagem_id[0]
                val['produto_embalagem_id'] = produto_embalagem_id
            val['local_id'] = local_id
        # SE O PRODUTO FOR DELETADO, OS CAMPOS ABAIXO SUMIRAM DA TELA
        else:
            val['grade_id'] = False
            val['produto_embalagem_id'] = False
            val['local_id'] = False
        return {'value': val, 'warning': warning}

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if not vals.get('quantidade_requisitada'):
            raise osv.except_osv(_('Atencao'), _('A quantidade informada para o produto deve ser maior que zero!'))
        if 'aplicacao' in vals:
            aplicacao = vals.get('aplicacao')
            contador = 0
            if aplicacao and len(aplicacao) > 30:
                for x in range(len(aplicacao)):
                    if aplicacao[x] == ' ':
                        contador = 0
                    if contador == 30:
                        aplicacao = aplicacao[:x] + '- ' + aplicacao[x:]
                        contador = 0
                    contador += 1
            vals['aplicacao'] = aplicacao
        res = super(estoquealmoxarifado_requisicao_item, self).create(cr, uid, vals, context)
        self._valida_dados_locacao(cr, uid, [res], context)
        return res

    def _valida_dados_locacao(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        brw_estoquealmoxarifado_requisicao_item = self.browse(cr, uid, ids, context)
        obj_estoque_local_locacao = self.pool.get('estoque.local.locacao')
        msg = ''
        for item in brw_estoquealmoxarifado_requisicao_item:
            local_locacao_ids = obj_estoque_local_locacao.search(
                    cr, uid, [('produto_id', '=', item.produto_id.id),
                              ('grade_id', '=', item.grade_id.id),
                              ('local_id', '=', item.local_id.id),
                              ('estllc_produto_embalagem_id', '=', item.produto_embalagem_id.id)],
                    context=context)
            if local_locacao_ids:
                continue
            msg += '%s-%s\n' % (item.produto_id.codigo, item.produto_id.name)
        if msg:
            raise osv.except_osv(_('Atencao'), _('Os produtos a seguir nao estao cadastrados para '
                                                 'o local informado:\n %s' % msg))
        return True

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if 'aplicacao' in vals:
            aplicacao = vals.get('aplicacao')
            contador = 0
            if len(aplicacao) > 30:
                for x in range(len(aplicacao)):
                    if aplicacao[x] == ' ':
                        contador = 0
                    if contador == 30:
                        aplicacao = aplicacao[:x] + '- ' + aplicacao[x:]
                        contador = 0
                    contador += 1
            vals['aplicacao'] = aplicacao

        if 'quantidade_requisitada' in vals:
            quantidade_requisitada = vals.get('quantidade_requisitada')
            if not quantidade_requisitada:
                raise osv.except_osv(_('Atencao'), _('A quantidade informada para o produto deve ser maior que zero!'))
        res = super(estoquealmoxarifado_requisicao_item, self).write(cr, uid, ids, vals, context)
        self._valida_dados_locacao(cr, uid, ids if isinstance(ids, list) else [ids], context)
        return res
