# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools import drop_view_if_exists


class estoquealmoxarifado_requisicao_view(osv.Model):
    _name = 'estoquealmoxarifado.requisicao.view'
    _inherit = 'estoquealmoxarifado.requisicao.view'

    def init(self, cr):
        drop_view_if_exists(cr, 'estoquealmoxarifado_requisicao_view')
        cr.execute("""
            CREATE OR REPLACE VIEW estoquealmoxarifado_requisicao_view AS (
                SELECT
                    capa.company_id,
                    capa.local_id,
                    capa.numero,
                    capa.data_emissao,
                    capa.state,
                    capa.motivo_cancelamento,
                    capa.observacao,
                    capa.funcionario_id,
                    capa.recebeu_id,
                    capa.data_hora_recebimento,
                    capa.centrocusto_id,
                    item.id,
                    item.quantidade_requisitada,
                    item.aplicacao,
                    item.produto_id,
                    item.grade_id,
                    item.produto_embalagem_id
                FROM almoxarifado_requisicao_capa AS capa
                INNER JOIN estoquealmoxarifado_requisicao_item AS item
                ON capa.id = item.requisicao_id
            )
        """)
