# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv


class estsug_compra_capa(osv.Model):
    # prefixo: esgccp_

    _inherit = 'estsug.compra.capa'

    def esgccp_get_origem_codigo(self, cr, uid, sugestao_id, context=None):
        """
        O metodo define a origem da operacao do estoque.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param sugestao_id: id da tabela desse objeto.
        :type sugestao_id: int
        :param context: dados contextuais.
        :type context: dict
        :return: dados da identicacao das origens.
        :rtype: list
        """
        context = context and context.copy() or {}
        res = super(estsug_compra_capa, self).esgccp_get_origem_codigo(cr, uid, context)
        estsug_compra_capa_dados = self.read(cr, uid, sugestao_id, ['esgccp_incluir_requisicao'],
                                             context)
        if not estsug_compra_capa_dados.get('esgccp_incluir_requisicao'):
            return res
        res.append('R')
        return res
