# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv


class estoque_produto_grade(osv.Model):

    _inherit = 'estoque.produto.grade'


    def estgrd_get_requisitado(self, cr, uid, ids, context=None, company_id=False):
        context = context and context.copy() or {}
        dados = super(estoque_produto_grade, self).estgrd_get_requisitado(cr, uid, ids, context,
                                                                          company_id)
        if not company_id:
            company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                                     'almoxarifado.requisicao.capa')

        str_grade_ids = '('+','.join(str(e) for e in ids)+')'
        # State da requisicao - R=Esboco, E=Entregue, C=Cancelada
        _sql = """select i.grade_id, i.local_id, sum(quantidade_requisitada) as quantidade
                     from estoquealmoxarifado_requisicao_item i
                     left join almoxarifado_requisicao_capa c on c.id = i.requisicao_id
                     where grade_id in %s and state not in ('R', 'E', 'C') and almrqc_devolucao = False and company_id = %s
                     group by grade_id, i.local_id""" % (str_grade_ids, company_id)
        dados = self._estgrd_requisitado_acumular_valores(cr, uid, _sql, dados)
        return dados
