# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class estoque_parametro(osv.Model):
    """
    Tabela de parametros do almoxarifado
    """
    _name = 'estoque.parametro'
    _inherit = 'estoque.parametro'
    _columns = {
        'gerar_solicitacao_compras': fields.boolean('Gerar solicitacao compras'),
        # flag que indica se quando houver uma solicitacao de almoxarifado e nao houver saldo disponivel no estoque, se deve gerar ou nao uma solicitacao de compra
        'custo_a_utilizar': fields.selection(
            [('1', 'Preco de Custo'), ('2', 'Preco de Reposicao'), ('3', 'Custo Medio'), ('4', 'Preco de Venda')], 'Custo a Utilizar',
            help='Preco de Custo a utilizar na gestao do estoque.', required=True, size=1),
        'estpar_almoxarifadorequisicao_operacao_id': fields.many2one('estoque.natureza.operacao',
                                                                     'Operacao para a requisicao'),
    }
    _defaults = {
        'custo_a_utilizar': lambda *a: '1'
    }


