# -*- coding: utf-8 -*-

from openerp.osv import osv


class wizard_listagem_movimento_analitico_osv(osv.TransientModel):
    _inherit = 'wizard.listagem.movimento.analitico.osv'

    def get_origem_movimento_analitico(self, cr, uid, context=None):
        """
        O metodo identifica a origem do item movimentado no estoque.
        Se nota ou cupom fiscal, eh identificado pelo tipo de movimento do CFOP.
        Se almoxarifado, eh identificado pelo id desse (requisicao_id) na capa do movimento.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param context: dados com valores contextuais.
        :type context: dict
        :return: query para busca dos dados no movimento
        :rtype: str
        """
        context = context and context.copy() or {}
        sql = super(wizard_listagem_movimento_analitico_osv, self).get_origem_movimento_analitico(
            cr, uid, context)
        sql = sql.replace("ELSE fc.movimento_tipo",
                          "WHEN emc.requisicao_id IS NOT NULL THEN 'R' "
                          "ELSE fc.movimento_tipo")
        return sql

    def get_tipo_movimento_analitico(self, cr, uid, context=None):
        """
        O metodo identifica o tipo da natureza da operacao do movimento.
        Se requsicao de almoxarifado, e identificado se esse e de devolucao ou nao. Se sim o tipo
        de movimento da natureza e 'E' (entrada), senao 'S' (saida).
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param context: dados com valores contextuais.
        :type context: dict
        :return: query para busca dos dados no movimento
        :rtype: str
        """
        context = context and context.copy() or {}
        sql = """
                CASE
                    WHEN emc.requisicao_id IS NOT NULL THEN (
                        SELECT
                            CASE
                                WHEN almrqc_devolucao IS TRUE THEN 'E'
                                ELSE 'S'
                            END
                        FROM almoxarifado_requisicao_capa
                        WHERE id = emc.requisicao_id
                        )
                    ELSE eno.estnto_tipo_operacao
                END AS tipo_movimento,
        """
        return sql
