# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoquealmoxarifado_requisicao_item(osv.Model):
    """
    Tabela de itens da requisicao

    """
    from funcoes import _almrqi_get_dados
    _name = 'estoquealmoxarifado.requisicao.item'
    _rec_name = 'aplicacao'
    _columns = {
        'requisicao_id': fields.many2one('almoxarifado.requisicao.capa', 'Requisicao', ondelete="cascade",
                                         required=True, select=True), # id da requisicao
        'quantidade_requisitada': fields.float('Quantidade requisitada', digits=(15, 3), required=False),
        # Quantidade requisitada.
        'aplicacao': fields.text('Aplicacao'), # Indica onde/em que este item será  aplicado
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="restrict", required=True, select=True,
                                      domain="[('tipo', '=', 'P'), ('company_id', '=', company_id)]"), # Id do produto
        'grade_id': fields.many2one('estoque.produto.grade', 'Grade', required=False, ondelete="restrict", select=True,
                                    domain="[('produto_id', '=', produto_id)]"),
        'local_id': fields.many2one('estoque.local', 'Local', ondelete="restrict", required=False, select=True),
        # Id do local requisitado
        'produto_embalagem_id': fields.many2one('estoque.produto.embalagem', 'Embalagem', ondelete="restrict",
                                                required=False, select=True,
                                                domain="[('produto_id', '=', produto_id)]"), # id da embalagem pedida
        'evento_id': fields.many2one("gerencial.evento", 'Evento', ondelete="restrict", select=True),
        'almrqi_locacao': fields.function(_almrqi_get_dados, method=True, type='char', size=515,
                                string='Locacao', store=False),
    }