# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoquealmoxarifado_requisicao_view(osv.Model):
    _name = 'estoquealmoxarifado.requisicao.view'
    _description = 'estoquealmoxarifado_requisicao_view'
    _auto = False
    _columns = {
        'company_id': fields.many2one('res.company', 'Empresa', ondelete="cascade", required=True, select=True),
        'local_id': fields.many2one('estoque.local', 'Local', ondelete="restrict", required=True,
                                    select=True),  # Id do local requisitado
        'numero': fields.char('Numero', size=20, required=False, select=True),
        # Numero da requisicao. Usar formato:\nRAL-AAAA-999999
        'data_emissao': fields.datetime('Data emissao', select=True),
        'state': fields.selection([('R', 'Esboco'), ('D', 'Requerido'), ('A', 'Aprovado'), ('S', 'Em Separacao'),
                                   ('E', 'Entregue'), ('C', 'Cancelada')], 'Status', required=True, size=1),
        # Estado da requisicao:\nA=Rascunho\nE=Entregue\nC=Cancelada
        'motivo_cancelamento': fields.char('Motivo cancelamento', size=70),
        # Motivo do cancelamento\nRelacionar a uma ocorrência.
        'observacao': fields.text('Observacao'),
        'funcionario_id': fields.many2one('rh.funcionario', 'Requerente', ondelete="restrict", required=True,
                                          select=True), # id do funcionario requisitante
        'recebeu_id': fields.many2one('rh.funcionario', 'Recebeu', ondelete="restrict", select=True,
                                      domain="[('company_id', '=', company_id)]"),
        # Id do funcionario que recebeu a mercadoria
        'data_hora_recebimento': fields.datetime('Data hora recebimento'), # Data e hora do recebimento\n
        'centrocusto_id': fields.many2one('adm.empresa.centrocusto', 'Centrocusto', ondelete="restrict", required=True,
                                          select=True), # id do centro de custo
        'quantidade_requisitada': fields.float('Quantidade requisitada', digits=(15, 3), required=True),
        # Quantidade requisitada.
        'aplicacao': fields.text('Aplicacao'), # Indica onde/em que este item será  aplicado
        'produto_id': fields.many2one('estoque.produto', 'Produto', ondelete="no action", required=True, select=True),
        # Id do produto
        'grade_id': fields.many2one('estoque.produto.grade', 'Grade', required=False, ondelete="no action",
                                    select=True),
        'produto_embalagem_id': fields.many2one("estoque.produto.embalagem", 'Embalagem', ondelete="restrict",
                                                required=True, select=True, domain="[('produto_id', '=', produto_id)]"),
        # id da embalagem pedida
    }

