# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from time import strftime
from datetime import date
from openerp.tools.translate import _


class wizard_almoxarifado_entrega(osv.TransientModel):
    _name = 'wizard.almoxarifado.entrega'
    _columns = {
        'recebeu_id': fields.many2one('rh.funcionario', 'Funcionario', help="Funcionario que ira receber a requisicao"),
        'data': fields.datetime('Data', help="Data do recebimento da requisicao")
    }
    _defaults = {
        'data': lambda *a: strftime('%Y-%m-%d %H:%M:%S')
    }

    def button_wizard_entregar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(context, dict):
            almoxarif_capa_id = context.get('active_id') or []
            obj_estoquealmoxarifado_requisicao_capa = self.pool.get('almoxarifado.requisicao.capa')
            obj_estoque_preco_custo = self.pool.get('estoque.preco.custo')
            almoxarif_capa_dados = obj_estoquealmoxarifado_requisicao_capa.read(cr, uid, almoxarif_capa_id,
                                                                                ['company_id', 'funcionario_id',
                                                                                 'requisicao_item_ids',
                                                                                 'almrqc_devolucao'], context=context)
            if almoxarif_capa_dados and isinstance(almoxarif_capa_dados, list):
                almoxarif_capa_dados = almoxarif_capa_dados[0]
            log = ''
            if almoxarif_capa_dados and isinstance(almoxarif_capa_dados, dict):
                almrqc_devolucao = almoxarif_capa_dados.get('almrqc_devolucao')
                try:
                    company_id = almoxarif_capa_dados['company_id'][0]
                except:
                    log = _("*Excecao: O campo EMPRESA nao pode ser acessado, ")
                try:
                    funcionario_id = almoxarif_capa_dados['funcionario_id'][0]
                except:
                    log = _("*Excecao: O campo FUNCIONARIO nao pode ser acessado, ")
                if log:
                    raise osv.except_osv(_('Atencao'), (log))
                else:
                    obj_estoque_parametro = self.pool.get('estoque.parametro')
                    estoque_parametro_id = obj_estoque_parametro.search(cr, uid, [('company_id', '=', company_id)],
                                                                        context=context)
                    if estoque_parametro_id:
                        estpar_almoxarifadorequisicao_operacao_id = obj_estoque_parametro.browse(cr, uid,
                                                                                                 estoque_parametro_id[
                                                                                                     0]).estpar_almoxarifadorequisicao_operacao_id.id
                        custo_a_utilizar = obj_estoque_parametro.browse(cr, uid,
                                                                        estoque_parametro_id[0]).custo_a_utilizar
                        if not estpar_almoxarifadorequisicao_operacao_id:
                            raise osv.except_osv(_('Atencao'),
                                                 _(
                                                     'A "Operacao para a requisicao" nao esta cadastrada nos parametros do estoque'))
                    else:
                        raise osv.except_osv(_('Atencao'), _('Os parametros do estoque nao estao cadastrados'))
                    almoxarif_item_ids = almoxarif_capa_dados.get('requisicao_item_ids') or []
                    mov_capa_id = self.pool.get('estoque.movimento.capa').create(cr, uid, {'company_id': company_id,
                                                                                           'funcionario_id': funcionario_id,
                                                                                           'requisicao_id': almoxarif_capa_dados.get(
                                                                                               'id'),
                                                                                           'data': date.today(),
                                                                                           'estmvc_operacao_id': estpar_almoxarifadorequisicao_operacao_id},
                                                                                 context)
                    if not mov_capa_id:
                        raise osv.except_osv(_('Atencao'), _(
                            'Nao foi possivel gerar o movimento no estoque para requisicao selecionada'))
                    if not almoxarif_item_ids:
                        raise osv.except_osv(_('Atencao'),
                                             _('A requisicao selecionada nao possui nenhum item cadastrado!'))
                    else:
                        almoxarif_item_dados = self.pool.get('estoquealmoxarifado.requisicao.item').read(cr, uid,
                                                                                                         almoxarif_item_ids,
                                                                                                         ['produto_id',
                                                                                                          'grade_id',
                                                                                                          'local_id',
                                                                                                          'produto_embalagem_id',
                                                                                                          'quantidade_requisitada'],
                                                                                                         context=context)
                        if isinstance(almoxarif_item_dados, list):
                            try:
                                produto_ids = map(lambda i: i['produto_id'][0], almoxarif_item_dados)
                            except:
                                raise osv.except_osv(_('Atencao'), _(
                                    'Nao foi possivel realizar o mapeamento dos itens da requisicao, houve um erro no acesso aos mesmos.'))
                            custo_item = 0
                            grade_ids = list(set(map(lambda i: i.get('produto_id')[0],
                                                     almoxarif_item_dados)))
                            preco_custo_dados = obj_estoque_preco_custo.get_custos_do_dia(
                                cr, uid, produto_ids, context=context)
                            if custo_a_utilizar == '4':
                                dict_produto_preco = self.pool.get('estoque.preco.venda'). \
                                    get_preco_venda(cr, uid, produto_ids, epc_company_id=company_id,
                                                    epc_grade_ids=grade_ids)

                            obj_estoque_produto_saldo = self.pool.get('estoque.produto.saldo')
                            obj_estoque_embalagem = self.pool.get('estoque.embalagem')
                            obj_estoque_movimento_itens = self.pool.get('estoque.movimento.itens')
                            obj_estoque_produto_embalagem = self.pool.get('estoque.produto.embalagem')
                            itens_criados = []
                            grade_qtd_entrada = {}
                            grade_qtd_saida = {}
                            for i in almoxarif_item_dados:
                                try:
                                    produto_id = i['produto_id'][0]
                                except:
                                    continue

                                try:
                                    grade_id = i['grade_id'][0]
                                except:
                                    continue

                                try:
                                    produto_embalagem_id = i['produto_embalagem_id'][0]
                                except:
                                    continue

                                try:
                                    local_id = i['local_id'][0]
                                except:
                                    continue

                                custo_dia = preco_custo_dados.get(produto_id)
                                if not custo_dia:
                                    custo_dia = {}

                                if custo_a_utilizar == '1':
                                    custo_item = custo_dia.get('estprc_ultimo_custo') or 0
                                if custo_a_utilizar == '2':
                                    custo_item = custo_dia.get('estprc_custo_reposicao') or 0
                                if custo_a_utilizar == '3':
                                    custo_item = custo_dia.get('estprc_custo_medio_contabil') or 0

                                produto_embalagem_dados = obj_estoque_produto_embalagem.read(cr, uid,
                                                                                             produto_embalagem_id,
                                                                                             ['embalagem_id'],
                                                                                             context=context)
                                if isinstance(produto_embalagem_dados, list):
                                    produto_embalagem_dados = produto_embalagem_dados[0]
                                if isinstance(produto_embalagem_dados, dict):
                                    try:
                                        embalagem_id = produto_embalagem_dados['embalagem_id'][0]
                                    except:
                                        embalagem_id = []

                                    embalagem_qtde = obj_estoque_embalagem.read(cr, uid, embalagem_id,
                                                                                ['quantidade_na_embalagem'],
                                                                                context=context)
                                    if isinstance(embalagem_qtde, list):
                                        embalagem_qtde = embalagem_qtde[0]
                                    if isinstance(embalagem_qtde, dict):
                                        if custo_a_utilizar == '4':
                                            dados_preco_venda = dict_produto_preco.get(produto_id) or {}
                                            custo_item = dados_preco_venda.get(grade_id) or dados_preco_venda.get(
                                                'preco_venda')
                                        embalagem_qtde = embalagem_qtde.get('quantidade_na_embalagem') or 1
                                        quantidade = i.get('quantidade_requisitada') or 0
                                        vr_total_item = embalagem_qtde * custo_item * (i.get(
                                            'quantidade_requisitada') or 0)
                                        vals_movimento = {
                                            'capa_id': mov_capa_id,
                                            'produto_id': produto_id,
                                            'grade_id': grade_id,
                                            'local_id': local_id,
                                            'produto_embalagem_id': produto_embalagem_id,
                                            'quantidade': quantidade,
                                            'vr_unitario': embalagem_qtde * custo_item,
                                            'vr_preco_venda': custo_item,
                                            'vr_total_item': vr_total_item,
                                            'vr_total_item_rateado': vr_total_item
                                        }

                                        ultimo_custo = custo_dia.get(
                                            'estprc_ultimo_custo', 0) * quantidade
                                        custo_corrigido = custo_dia.get(
                                            'estprc_custo_corrigido', 0) * quantidade
                                        custo_medio = custo_dia.get(
                                            'estprc_custo_medio_contabil', 0) * quantidade
                                        custo_reposicao = custo_dia.get(
                                            'estprc_custo_reposicao', 0) * quantidade
                                        vals_movimento.update({
                                            'estmvi_saidas_ultimo_custo_total': ultimo_custo,
                                            'estmvi_saidas_custo_corrigido_total': custo_corrigido,
                                            'estmvi_saidas_custo_medio_contabil_total': custo_medio,
                                            'estmvi_saidas_custo_reposicao_total': custo_reposicao,
                                        })

                                        mov_item_id = obj_estoque_movimento_itens.create(
                                            cr, uid, vals_movimento, context)
                                        if almrqc_devolucao:
                                            if grade_id in grade_qtd_entrada:
                                                grade_qtd_entrada[grade_id] += i.get('quantidade_requisitada') or 0
                                            else:
                                                grade_qtd_entrada[grade_id] = i.get('quantidade_requisitada') or 0

                                        else:
                                            if grade_id in grade_qtd_saida:
                                                grade_qtd_saida[grade_id] += i.get('quantidade_requisitada') or 0
                                            else:
                                                grade_qtd_saida[grade_id] = i.get('quantidade_requisitada') or 0

                                        itens_criados.append(mov_item_id)

                            if grade_qtd_entrada:
                                saldo_id = obj_estoque_produto_saldo.atualizar_saldo_do_dia(
                                    cr, uid, company_id, grade_qtd_entrada,
                                    strftime('%Y-%m-%d'), 'E', local_id, # o local eh o mesmo para todos itens
                                    context=context)
                                itens_criados.append(saldo_id)

                            if grade_qtd_saida:
                                saldo_id = obj_estoque_produto_saldo.atualizar_saldo_do_dia(
                                    cr, uid, company_id, grade_qtd_saida,
                                    strftime('%Y-%m-%d'), 'S', local_id, # o local eh o mesmo para todos itens
                                    context=context)
                                itens_criados.append(saldo_id)

                            if all(itens_criados):
                                wizard_entrega = self.read(
                                    cr, uid, ids, ['recebeu_id', 'data'],
                                    context=context)
                                if wizard_entrega and isinstance(wizard_entrega, list):
                                    wizard_entrega = wizard_entrega[0]
                                if wizard_entrega and isinstance(wizard_entrega, dict):
                                    funcinario_recebeu_id = wizard_entrega.get('recebeu_id') and \
                                                            wizard_entrega['recebeu_id'][0] or False
                                    if not funcinario_recebeu_id:
                                        raise osv.except_osv(_('Atencao'),
                                                             _('Nenhum funcionario localizado '
                                                               'para receber a entrega do '
                                                               'almoxarifado!'))
                                    obj_estoquealmoxarifado_requisicao_capa.write(
                                        cr, uid, almoxarif_capa_id,
                                        {'recebeu_id': funcinario_recebeu_id,
                                         'data_hora_recebimento': wizard_entrega.get(
                                             'data') or date.today()},
                                        context=context)
                                    obj_estoquealmoxarifado_requisicao_capa.button_entregar(
                                        cr, uid, [almoxarif_capa_id], context)
                                    self.pool.get('estoque.movimento.capa').write(
                                        cr, uid, mov_capa_id, {'state': 'F'}, context=context)

        return {'type': 'ir.actions.act_window_close'}
