# -*- encoding: utf-8 -*-
from openerp.osv import osv, fields
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
from openerp import pooler
import time
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        STATUS = {'R': 'Esboco', 'D': 'Requerido',
                  'A': 'Aprovado', 'S': 'Em Separacao',
                  'E': 'Entregue', 'C': 'Cancelada',
                  'P': 'Reprovado'}

        pdf_file = StringIO.StringIO()
        empresa = datas['form']['company_id']
        data_fim = datas['form']['data_final']
        data_ini = datas['form']['data_ini']
        state = datas['form']['state']
        centrocusto_id = datas['form']['centrocusto_id']
        centrocusto = False
        argumentos = []
        if centrocusto_id:
            if isinstance(centrocusto_id, list):
                centrocusto_id = centrocusto_id[0]
            centrocusto = \
                pooler.get_pool(cr.dbname).get('adm.empresa.centrocusto').read(cr, uid, centrocusto_id, ['name'], context=context)[
                    'name']
            argumentos.append(('centrocusto_id', '=', centrocusto_id))
        if not centrocusto:
            centrocusto = ''
        obj_emp = pooler.get_pool(cr.dbname).get("res.company")
        if isinstance(empresa, list):
            empresa = empresa[0]
        nome_empresa = obj_emp.read(cr, uid, empresa, ['name'], context=context)['name']
        filhas_emp = obj_emp.search(cr, uid, [('parent_id', '=', empresa)], context=context)
        obj_req = pooler.get_pool(cr.dbname).get('almoxarifado.requisicao.capa')
        ids_emp_filhas = [empresa]

        if filhas_emp:
            ids_emp_filhas += filhas_emp

        argumentos.append(('company_id', 'in', ids_emp_filhas))
        if state == 'T' or not state:
            state = ('Todos')
        if state == 'R':
            state = _('Rascunho')
            argumentos.append(('state', '=', 'R'))
        if state == 'E':
            state = _('Entregue')
            argumentos.append(('state', '=', 'E'))
        if state == 'C':
            state = _('Cancelada')
            argumentos.append(('state', '=', 'C'))
        if state == 'S':
            state = _('Em Separacao')
            argumentos.append(('state', '=', 'S'))

        if data_ini != False and data_fim != False:
            data_ini = time.strftime("%d-%m-%Y", time.strptime(datas['form']['data_ini'], "%Y-%m-%d"))

            argumentos.append(('data_emissao', '>=', datas['form']['data_ini']))

            data_fim = time.strftime("%d-%m-%Y", time.strptime(datas['form']['data_final'], "%Y-%m-%d"))

            argumentos.append(('data_emissao', '<=', datas['form']['data_final']))
        if data_ini == False and data_fim == False:
            data_ini = ' '
            data_fim = ' '

        ids_req = obj_req.search(cr, uid, argumentos, order='company_id,data_emissao desc', context=context)

        listagem = Impressora()
        listagem.defineFormato(orientacao='1')
        listagem.informaNome(pdf_file, _('Listagem de Requisicao Almoxarifado'))
        listagem.informaTamLinha(100)
        listagem.defineMargem(1, 1, 1, 1)
        cab = u'Requisicao Almoxarifado                                           ' + nome_empresa + u'                                                                                               Pagina:  {{ Page }}'
        listagem.informaCab(cab)
        listagem.informaCab(' ')
        data = time.strftime('%d-%m-%Y')
        listagem.informaCab(
            _('Data: ') + data + _(
                '                                                  Listagem de Requisicao Almoxarifado                             '))
        listagem.informaCab(' ')
        listagem.informaCab(_('Status: ') + state + _(' Centro de custo: ') + centrocusto)
        listagem.informaCab(' ')
        listagem.informaCab(_('Periodo: ') + str(data_ini) + ' a ' + str(data_fim))
        listagem.informaCab(' ')
        listagem.informaCab('=' * 150)
        cab = formataString(_('Numero'), 25, ' ', 'D', 'S', 'S')
        cab += formataString(_('Data Emissao '), 16, ' ', 'D', 'S', 'S')
        cab += formataString(_('Local'), 30, ' ', 'D', 'S', 'S')
        cab += formataString(_('Status'), 19, ' ', 'D', 'S', 'S')
        cab += formataString(_('Recebeu'), 32, ' ', 'D', 'S', 'S')
        cab += formataString(_('Data Hora Recebimento'), 25, ' ', 'D', 'S', 'S')
        listagem.informaCab(cab)
        listagem.informaCab('=' * 150)
        listagem.informaCab(' ')
        listagem.rodapePadrao()
        #        qtdRequisicao=0;

        id_empresa = False
        for req in obj_req.browse(cr, uid, ids_req):
            if id_empresa != req.company_id:
                listagem.imprimeLinha(_('Empresa : %s') % req.company_id.name)
                listagem.imprimeLinha(' ')

                id_empresa = req.company_id

            linha = formataString(req.numero, 24, ' ', 'D', 'S', 'S')
            linha += ' '
            dt_emissao = req.data_emissao
            linha += formataString(dt_emissao[:10], 15, ' ', 'D', 'S', 'S')
            linha += ' '
            linha += formataString(req.local_id.name, 29, ' ', 'D', 'S', 'S')
            linha += ' '
            try:
                states = STATUS[req.state]
            except:
                states = str(req.state)

            linha += formataString(states, 18, ' ', 'D', 'S', 'S')
            linha += ' '

            if req.recebeu_id.name == None:
                recebeu = ' '
            else:
                recebeu = req.recebeu_id.name
                linha += formataString(recebeu, 31, ' ', 'D', 'S', 'S')
                linha += ' '
            if req.data_hora_recebimento == False:
                dt_h_rec = ' '
            else:
                dt_h_rec = req.data_hora_recebimento[:19]
                linha += formataString(dt_h_rec, 24, ' ', 'D', 'S', 'S')
                linha += ' '
            listagem.imprimeLinha(linha)
            #        qtdRequisicao=qtdRequisicao+1
        listagem.imprimeLinha('=' * 150)
        #        listagem.imprimeLinha('Quantidade de Requisicao Almoxarifado: '+str(qtdRequisicao))
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_file.getvalue())
        self.obj.render()
        pdf_file.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_de_requisicao')


class listagem_de_requisicao_osv(osv.TransientModel):
    _name = 'listagem.de.requisicao.osv'
    _description = 'Listagem de requisicao'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', required=True),
        'data_ini': fields.date('Data Inicial'),
        'data_final': fields.date('Data Final'),
        'centrocusto_id': fields.many2one("adm.empresa.centrocusto", 'Centro de Custo'),
        'state': fields.selection(
            [('R', 'Rascunho'), ('E', 'Entregue'), ('C', 'Cancelada'), ('S', 'Em Separacao'), ('T', 'Todos')], 'Status',
            required=True),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(cr, uid, uid).company_id.id,
        'state': lambda *a: 'T'
    }

    def button_listagem(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        data = {}
        if ids:
            dados = self.read(cr, uid, ids, context=context)[0]
            if dados.get('data_ini') > dados.get('data_final'):
                raise osv.except_osv(_('Atencao'), _('Data inicial nao pode ser maior que a data '
                                                     'final'))
            data['form'] = dados
            data['ids'] = ids

        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'listagem_de_requisicao',
            'datas': data
        }

