# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class estoquecorrecao_produto_cliente(osv.Model):
    """
    Tabela de Correcao de precos.
    """
    _name = 'estoquecorrecao.produto.cliente'
    _inherit = 'estoquecorrecao.produto.cliente'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if not vals.get('cliente_id'):
            if not vals.get('produto_id') and not vals.get('grade_id'):
                raise osv.except_osv(_('Atencao'), _('Cliente e/ou produto com a grade devem ser informados'))
        res = super(estoquecorrecao_produto_cliente, self).create(cr, uid, vals, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        dados = self.browse(cr, uid, ids, context=context)
        for x in dados:
            if 'cliente_id' in vals:
                cliente_id = vals.get('cliente_id')
            else:
                cliente_id = x.cliente_id.id
            if 'produto_id' in vals:
                produto_id = vals.get('produto_id')
            else:
                produto_id = x.produto_id.id
            if 'grade_id' in vals:
                grade_id = vals.get('grade_id')
            else:
                grade_id = x.grade_id.id
            if not cliente_id:
                if not produto_id and not grade_id:
                    raise osv.except_osv(_('Atencao'), _('Cliente e/ou produto com a grade devem ser informados'))
        res = super(estoquecorrecao_produto_cliente, self).write(cr, uid, ids, vals, context)
        return res

    def onchange_estpcl_produto(self, cr, uid, ids, produto_id, context=None):
        context = context and context.copy() or {}
        res = {}
        if not produto_id:
            res['grade_id'] = ''
            return {'value': res}
        brw_produto = self.pool.get('estoque.produto').browse(cr, uid, produto_id)
        grade_ids = brw_produto.produto_grade_ids
        if len(grade_ids) == 1:
            res['grade_id'] = grade_ids[0].id
        else:
            res['grade_id'] = ''
        return {'value': res}
