# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from datetime import datetime, timedelta
import time
from openerp.tools.translate import _


class estoque_preco_venda(osv.Model):
    _name = 'estoque.preco.venda'
    _inherit = 'estoque.preco.venda'

    def get_preco_venda_estoquecorrecao(self, cr, uid, dict_preco, epc_company_id=None,
                        epc_cliente_id=None, epc_grade_ids=[], context=None):
        super(estoque_preco_venda, self).get_preco_venda_estoquecorrecao(cr, uid, dict_preco, epc_company_id,
                        epc_cliente_id, epc_grade_ids, context)

        obj_estoquecorrecao_produto_cliente = self.pool.get('estoquecorrecao.produto.cliente')
        if epc_grade_ids and len(dict_preco) == 1 and not isinstance(dict_preco.get(dict_preco.keys()[0]), dict):
            for key in dict_preco:
                for grade_id in epc_grade_ids:
                    valor = dict_preco.get(key)
                    dict_preco[key] = {'preco_venda': valor}
                    dict_preco[key][grade_id] = valor
        lista_produto_cliente_ids = []
        for produto_id in dict_preco:
            if epc_cliente_id:
                if isinstance(dict_preco.get(produto_id), dict): # se tem grade_id
                    for grade_id in dict_preco.get(produto_id):
                        args = [('produto_id', '=', produto_id),
                                ('cliente_id', '=', epc_cliente_id),
                                ('grade_id','=', grade_id)]
                        produto_cliente_ids = obj_estoquecorrecao_produto_cliente.search(cr, uid, args,
                                                                            context=context) #(cliente, produto e grade)
                        if not produto_cliente_ids:
                            args = [('produto_id', '=', produto_id),
                                    ('cliente_id', '=', epc_cliente_id),
                                    ('grade_id','=', False)]
                            produto_cliente_ids = obj_estoquecorrecao_produto_cliente.search(cr, uid, args,
                                                                                   context=context) #(cliente e produto)
                        if not produto_cliente_ids:
                            args = [('produto_id', '=', False),
                                    ('cliente_id', '=', epc_cliente_id)]
                            produto_cliente_ids = obj_estoquecorrecao_produto_cliente.search(cr, uid, args,
                                                                                     context=context) #(somente cliente)
                        if not produto_cliente_ids:
                            args = [('produto_id', '=', produto_id),
                                    ('cliente_id', '=', False),
                                    ('grade_id','=', grade_id)]
                            produto_cliente_ids = obj_estoquecorrecao_produto_cliente.search(cr, uid, args,
                                                                                     context=context) #(produto e grade)
                        if not produto_cliente_ids:
                            args = [('produto_id', '=', produto_id),
                                    ('cliente_id', '=', False),
                                    ('grade_id','=', False)]
                            produto_cliente_ids = obj_estoquecorrecao_produto_cliente.search(cr, uid, args,
                                                                                     context=context) #(somente produto)
                        lista_produto_cliente_ids.extend(produto_cliente_ids)
                else:
                    args = [('produto_id', '=', produto_id),
                            ('cliente_id', '=', epc_cliente_id),
                            ('grade_id','=', False)]
                    produto_cliente_ids = obj_estoquecorrecao_produto_cliente.search(cr, uid, args,
                                                                                   context=context) #(cliente e produto)
                    if not produto_cliente_ids:
                        args = [('cliente_id', '=', epc_cliente_id),
                                ('produto_id', '=', False)]
                        produto_cliente_ids = obj_estoquecorrecao_produto_cliente.search(cr, uid, args,
                                                                                     context=context) #(somente cliente)
                    if not produto_cliente_ids:
                        args = [('cliente_id', '=', False),
                                ('produto_id', '=', produto_id),
                                ('grade_id','=', False)]
                        produto_cliente_ids = obj_estoquecorrecao_produto_cliente.search(cr, uid, args,
                                                                                     context=context) #(somente produto)
                    lista_produto_cliente_ids.extend(produto_cliente_ids)
            else:
                grade_ids = filter(lambda g: g != 'preco_venda', dict_preco.get(produto_id).keys())
                arg_grade = ('grade_id', 'in', grade_ids)
                if not grade_ids:
                    arg_grade = ('grade_id', '=', False)
                args = [('produto_id', '=', produto_id), ('cliente_id', '=', False), arg_grade]
                produto_cliente_ids = obj_estoquecorrecao_produto_cliente.search(
                    cr, uid, args, context=context) #(produto e grade)
                lista_produto_cliente_ids.extend(produto_cliente_ids)

            lista_produto_cliente_ids = list(set(lista_produto_cliente_ids))
            if lista_produto_cliente_ids:
                browse_produto_cliente = obj_estoquecorrecao_produto_cliente.browse(cr, uid, lista_produto_cliente_ids)
                for x in browse_produto_cliente:
                    if not x.produto_id:
                        if x.tabela_correcao_id.cortab_fator:
                            dict_preco[produto_id] = {
                                'preco_venda': round(dict_preco.get(produto_id).get('preco_venda') *
                                                     x.tabela_correcao_id.cortab_fator, 6)}
                    elif x.grade_id:
                        produto_id = x.produto_id.id
                        grade_id = x.grade_id.id
                        if x.tabela_correcao_id.cortab_fator:
                            dict_preco[produto_id][grade_id] = round(dict_preco.get(produto_id).get(grade_id) *
                                                                     x.tabela_correcao_id.cortab_fator, 6)
                    else:
                        produto_id = x.produto_id.id
                        if x.tabela_correcao_id.cortab_fator:
                            dict_preco[produto_id] = {
                                'preco_venda': round(dict_preco.get(produto_id).get('preco_venda')
                                                     * x.tabela_correcao_id.cortab_fator, 6)}
        return dict_preco
