# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoquecorrecao_produto_cliente(osv.Model):
    """
    Tabela associativa de produtos / clientes para correcao de precos
    """
    _name = 'estoquecorrecao.produto.cliente'
    _description = 'Cadastro de tabela de correcao de precos para Produto/Cliente'
    _recname = 'tabela_correcao_id'
    _columns = {
        'cliente_id': fields.many2one("financeiro.cliente", 'Cliente', ondelete="cascade", select=True), # id do cliente
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="cascade", select=True,
                                      domain="[]"),
        'grade_id': fields.many2one("estoque.produto.grade", 'Grade', ondelete="cascade", select=True,
                                    domain="[('produto_id', '=', produto_id)]"), # Id do produto a ser pedido\n
        'tabela_correcao_id': fields.many2one("estoquecorrecao.tabela", 'Tabela correcao', ondelete="cascade",
                                              required=True, select=True), # id da tabela de correcao
    }


