# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class estoquecorrecao_tabela(osv.Model):
    """
    Tabela de Correcao de precos.
    """
    _name = 'estoquecorrecao.tabela'
    _columns = {
        'name': fields.char('Descricao', size=50, required=True), # Descricao da tabela de correcao
        'cortab_fator': fields.float('Fator', digits=(11, 8), required=True,
                                     help="Fator a ser multiplicado pelo preco original para calcular o novo preco"),
        # Indice de correcao do preco de venda\nPode ser positivo ou negativo\nNegativo funciona como desconto
        'sigla': fields.char('Sigla', size=5, required=True, select=True), # Sigla para identificacao da tabela\n
        'taxa_prazo': fields.float('Taxa prazo', digits=(5, 2)), # Taxa para calculo de juros para venda a prazo\n
        'produto_cliente_ids': fields.one2many('estoquecorrecao.produto.cliente', 'tabela_correcao_id', 'Cliente'),
    }

