# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009-2014 All Rights Reserved. Luiz Fernando Maciel Franca
#                     www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from SigUtils import datas
from datetime import date, datetime
from openerp.osv import osv
import time
from openerp.tools.translate import _
from openerp.report import report_sxw
import subprocess
import random
import string
from utils import synchronized_method
from ...fiscal.control.utils import log_debug
from openerp import SUPERUSER_ID

READ_LOAD = '_classic_write'


def random_name():
    random.seed()
    d = [random.choice(string.ascii_letters) for x in xrange(3)]
    name = "".join(d)
    return name


# noinspection PyAbstractClass,PyPep8Naming
class estoquepedidos_pedido_capa(osv.Model):
    """
    Pedidos
    """
    _name = 'estoquepedidos.pedido.capa'
    _inherit = 'estoquepedidos.pedido.capa'

    def init(self, cr):
        modulo_madeireira_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, 1, 'madeireira',
                                                                                               context=None)
        if modulo_madeireira_instalado:
            cr.execute("""delete
                          from ir_act_report_xml
                          where model = 'estoquepedidos.pedido.capa' and
                          report_rml != 'addons/madeireira/report/rel_impressao_estoquepedidos.rml'
                          """)
        else:
            cr.execute("""SELECT    id
                          FROM      ir_act_report_xml
                          WHERE     model = 'estoquepedidos.pedido.capa'
                            AND     report_rml = 'addons/estoquepedidos/report/rel_estoquepedidos2.rml'
                          """)
            report_id = cr.dictfetchone()
            if not report_id:
                cr.execute("""INSERT INTO   ir_act_report_xml (
                                            name,
                                            type,
                                            model,
                                            report_name,
                                            auto,
                                            header,
                                            report_type,
                                            report_file,
                                            report_rml,
                                            multi,
                                            attachment_use
                            ) VALUES (
                                            'Impressao de pedidos',
                                            'ir.actions.report.xml',
                                            'estoquepedidos.pedido.capa',
                                            'estoquepedidos.pedido.capa',
                                            False,
                                            False,
                                            'pdf',
                                            'addons/estoquepedidos/report/rel_estoquepedidos2.rml',
                                            'addons/estoquepedidos/report/rel_estoquepedidos2.rml',
                                            False,
                                            False
                           )""")

    def pedcap_states_que_permitem_alteracao(self, cr, uid):
        res = ['R']
        return res

    def _needaction_domain_get(self, cr, uid, context=None):
        """
        Mostra a quantidade de pedidos ainda nao concluidos.

        :param cr: a linha atual do cursor do banco de dados,
        :param uid: o ID do usuario utilizado para a verificacao de perfil,
        :param context: um dicionario padrao para valores contextuais,
        :return: dominio utilizado para contar pedidos pendentes.

        :see: openerp/addons/base/ir/ir.needaction (class ir_needaction_mixin)
        :copyright: OpenERP SA.
        """
        context = context and context.copy() or {}
        return [('state', 'in', ['R', 'V', 'S', 'D'])]

    def _auto_init(self, cr, context=None):
        context = context and context.copy() or {}
        super(estoquepedidos_pedido_capa, self)._auto_init(cr, context)
        cr.execute("SELECT 1 FROM pg_indexes WHERE indexname='estoquepedidos_pedido_state_tipo_exportado_frente_idx'")
        if not cr.fetchone():
            cr.execute(
        'CREATE INDEX estoquepedidos_pedido_state_tipo_exportado_frente_idx  ON estoquepedidos_pedido_capa  (state, tipo, exportado_frente)')

    def copy(self, cr, uid, id, default=None, context=None):
        # Forcar atualização dos campos, porque quando usa _inherits ao gravar os campos one2many dos itens ele altera os valores
        # default passado, mantendo os valores do pedido de origem
        # Não deve ser invocado o super do copy()
        context = context and context.copy() or {}
        if not isinstance(default, dict):
            default = {}

        data_hoje = date.today()
        if not 'state' in default:
            default.update({'state': 'R'})
        default.update({'pedcap_ja_impresso': False})
        if not context.get('estoquepedidos_importacao'):
            default.update({'data_emissao': data_hoje})
        dados_read = self.read(cr, uid, [id], [], context=context, load='_classic_write')[0]
        dados_read.update(default)
        estoque_parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', 'estpar_vendedor_eh_usuario', context)
        vendedor_id = self.pool.get('vendas.vendedor').venven_get_vendedor_id(cr, uid,
                                                                              context=context)
        if estoque_parametro_dados.get('estpar_vendedor_eh_usuario') and vendedor_id:
            dados_read.update({'vendedor_id': vendedor_id})
        campos_da_capa = dados_read.keys()
        _item_ids = dados_read.get('pedido_item_ids', [])
        lista = []
        local_id = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', 'local_venda_padrao_id', context=context).get(
            'local_venda_padrao_id')
        for dados_item in self.pool.get('estoquepedidos.pedido.item').read(cr, uid, _item_ids, [], context=context,
                                                                           load='_classic_write'):
            dados_item['local_id'] = local_id
            if estoque_parametro_dados.get('estpar_vendedor_eh_usuario') and vendedor_id:
                    dados_item.update({'vendedor_id': vendedor_id})
            for _idx in campos_da_capa: # remover os campos que já estão na capa e que vem por causa da heranca _inherits
                if _idx not in ('vr_desconto', 'valor_total', 'vendedor_id', 'vendedor_externo_id'): # campos que tem o mesmo nome na capa e nos itens
                    dados_item.pop(_idx, False)
            lista.append([0, 0, dados_item])
        dados_read['pedido_item_ids']= lista

        _condicao_ids = dados_read.get('pedido_condicao_ids')
        lista = []
        for dados_condicao in self.pool.get('estoquepedidos.pedido.condicao').read(cr, uid, _condicao_ids, [],
                                                                                   context=context,
                                                                                   load='_classic_write'):
            _parcela_ids = dados_condicao.get('pedido_parcela_ids')
            lista_parcelas = []
            for dados_parcelas in self.pool.get('estoquepedidos.pedido.parcela').read(cr, uid, _parcela_ids, [],
                                                                                      context=context,
                                                                                      load='_classic_write'):
                dados_parcelas.pop('pedido_condicao_id', False)
                dados_parcelas.pop('id', False)
                dados_parcelas.pop('pedido_id', False)
                dados_parcelas.pop('pedido_compra_id', False)
                lista_parcelas.append([0, 0, dados_parcelas])
            dados_condicao.pop('capa_id', False)
            dados_condicao.pop('id', False)
            dados_condicao['pedido_parcela_ids'] = lista_parcelas
            lista.append([0, 0, dados_condicao])
        dados_read['pedido_condicao_ids']= lista
        dados_read.pop('message_follower_ids', False)
        dados_read.pop('message_ids', False)
        dados_read.pop('message_is_follower', False)
        dados_read.pop('message_summary', False)
        dados_read.pop('message_unread', False)
        dados_read.pop('create_date', False)
        dados_read.pop('write_date', False)
        dados_read.pop('exportado_frente', False)
        dados_read.pop('id', False)
        dados_read.pop('orcamento_id', False)
        dados_read.pop('pedcap_nf_ids', False)
        dados_read.pop('pedcap_parcela_ids', False)
        dados_read.pop('pedido_parcela_ids', False)
        dados_read.pop('data_entrega', False)
        dados_read.pop('pedido_compra_parcela_ids', False)

        # Como nao deve ser chamado o super desse metodo (como foi descrito la no inicio) nao deve
        # ser feito sobreescricao dele (heranca do modulo kit). Por isso foi forcado aqui.
        pedido_kit_item_ids = list()
        if dados_read.get('pedido_kit_item_ids'):
            fields_kit_mov = ['kitmov_produto_id', 'kitmov_quantidade', 'kitmov_lancado']
            for kitmov in self.pool.get('kit.movimento').read(
                    cr, uid, dados_read.get('pedido_kit_item_ids'), fields_kit_mov, context,
                    '_classic_write'):
                kitmov.pop('id', False)
                pedido_kit_item_ids.append((0, 0, kitmov))
        if pedido_kit_item_ids:
            dados_read['pedido_kit_item_ids'] = pedido_kit_item_ids

        res = self.create(cr, uid, dados_read, context)
        self.calcular_parcelas_pedido(cr, uid, [res], context)
        return res

    def sequence_criar(self, cr, uid, context=None):
        context = context and context.copy() or {}
        obj_ir_sequence_type = self.pool.get('ir.sequence.type')
        obj_ir_sequence = self.pool.get('ir.sequence')
        company_id = context.get('pedido_company_id') or self.pool.get('adm.empresa.objeto').\
            getEmpresa(cr, uid, self._name, context=context)
        code = 'numero_pedido.compra'
        nome = 'Pedido Compra'
        vals = {
            'name': nome,
            'code': code,
            'padding': 10,
            'company_id': company_id,
            'prefix': 'PCO-',
            'implementation': 'no_gap',
        }
        sequence_type_ids = obj_ir_sequence_type.search(cr, uid, [('code', '=', code)],
                                                        context=context)
        if not sequence_type_ids:
            obj_ir_sequence_type.create(cr, uid, {'name': nome, 'code': code}, context)
        sequence_ids = obj_ir_sequence.search(
            cr, uid, [('name', '=', nome), ('code', '=', code),
                      ('company_id', '=', company_id)], context=context)
        if not sequence_ids:
            self.pool.get('ir.sequence').create(cr, uid, vals, context)

        code = 'numero_pedido.venda'
        nome = 'Pedido Venda'
        vals = {
            'name': nome,
            'code': code,
            'padding': 10,
            'company_id': company_id,
            'prefix': 'PVE-',
            'implementation': 'no_gap',
        }
        sequence_type_ids = self.pool.get('ir.sequence.type').search(
            cr, uid, [('code', '=', code)], context=context)
        if not sequence_type_ids:
            self.pool.get('ir.sequence.type').create(cr, uid, {'name': nome, 'code': code},
                                                     context)
        sequence_ids = obj_ir_sequence.search(
            cr, uid, [('name', '=', nome), ('code', '=', code),
                      ('company_id', '=', company_id)], context=context)
        if not sequence_ids:
            self.pool.get('ir.sequence').create(cr, uid, vals, context)
        return True

    def pedcap_button_salvar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = super(estoquepedidos_pedido_capa, self).write(cr, uid, ids, {}, context)

        return res

    def default_get(self, cr, uid, fields, context=None):
        context = context and context.copy() or {}
        res = super(estoquepedidos_pedido_capa, self).default_get(cr, uid, fields, context)

        if context.get('view_name') == 'estoquepedidos_venda' or context.get('contexto_orcamentos'):
            res.update({'tipo': 'V'})
        elif context.get('view_name') == 'estoquepedidos_compra':
            res.update({'tipo': 'C'})
        res['pedcap_simp_state'] = 'I'
        if res.get('tipo') == 'V':
            estoque_parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(
                cr, uid, 'estoque', 'estpar_pedido_mensagem_padrao', context=context)
            estoque_parametro_dados.get('estpar_pedido_mensagem_padrao') and res.update(
                {'observacao': estoque_parametro_dados.get('estpar_pedido_mensagem_padrao')})
        return res

    def fields_get(self, cr, uid, fields=None, context=None):
        context = context and context.copy() or {}
        res = super(estoquepedidos_pedido_capa, self).fields_get(cr, uid, fields, context)
        view_name = context.get('view_name', False)
        if view_name == 'estoquepedidos_venda' and 'pessoa_id' in res:
            res['pessoa_id']['string'] = 'Cliente'
        elif view_name == 'estoquepedidos_compra' and 'pessoa_id' in res:
            res['pessoa_id']['string'] = 'Fornecedor'
        return res

    def pedcap_simplificado_button_cliente(self, cr, uid, ids, context=None):
        """
        Metodo exlusivo do pedido de venda simplificado. Realiza a chamada de uma nova janela para
        selecao/inclusao de um cliente.
        :param cr: cursor no banco de dados
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dados contextuais
        :type context: dict
        :return: dados de acao para abertura de um novo formulario.
        :rtype: dict
        """
        context = context and context.copy() or {}
        super(estoquepedidos_pedido_capa, self).write(cr, uid, ids, {}, context)
        reference = self.pool.get('ir.model.data').get_object_reference(
            cr, uid, 'estoquepedidos', 'view_pedido_capa_simplificado_pessoa_endereco_form')
        view_id = reference and reference[1] or False

        return {'res_id': ids[0],
                'name': 'Selecao do Cliente',
                'view_type': 'form',
                'view_mode': 'form',
                'res_model': 'estoquepedidos.pedido.capa',
                'view_id': [view_id],
                'target': 'new',
                'type': 'ir.actions.act_window',
                }

    def pedcap_simplificado_button_condicao_pagamento(self, cr, uid, ids, context=None):
        """
        Metodo exlusivo do pedido de venda simplificado. Realiza a chamada de uma nova janela para
        inclusao das condicoes/formas de pagamento.
        :param cr: cursor no banco de dados
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dados contextuais
        :type context: dict
        :return: dados de acao para abertura de um novo formulario.
        :rtype: dict
        """
        context = context and context.copy() or {}
        super(estoquepedidos_pedido_capa, self).write(cr, uid, ids, {}, context)
        reference = self.pool.get('ir.model.data').get_object_reference(
            cr, uid, 'estoquepedidos', 'view_pedido_capa_simplificado_condicao_pagamento_form')
        view_id = reference and reference[1] or False

        return {'res_id': ids[0],
                'name': 'Condicoes de Pagamento',
                'view_type': 'form',
                'view_mode': 'form',
                'res_model': 'estoquepedidos.pedido.capa',
                'view_id': [view_id],
                'target': 'new',
                'type': 'ir.actions.act_window',
                }

    def pedcap_simplificado_trata_pessoa_endereco(self, cr, uid, ids, vals, context=None):
        """
        Metodo exlusivo do pedido de venda simplificado. Realiza a inclusao de uma nova pessoa,
        alem da inclusao do endereco, caso nao encontrado.
        :param cr: cursor no banco de dados
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param vals: dados para inclusao de um novo resgistro de pedido
        :type vals: dict
        :param context: dados contextuais
        :type context: dict
        :return: dados do id de pessoa (adm_pessoa) e endereco (adm_pessoa_endereco)
        """
        context = context and context.copy() or {}
        brw_estoquepedidos_pedido_capa = self.browse(cr, uid, ids[0] if ids else False, context)
        obj_adm_pessoa = self.pool.get('adm.pessoa')
        pessoa_ids = obj_adm_pessoa.search(
            cr, uid, [('cpf_cnpj', '=', vals.get('pedcap_simp_cpf_cnpj'))], context=context)
        pessoa_id = pessoa_ids and pessoa_ids[0]
        if not pessoa_id:
            vals_pessoa = {'name': vals.get('pedcap_simp_pessoa_nome'),
                           'cpf_cnpj': vals.get('pedcap_simp_cpf_cnpj'),
                           'pessoa_tipo': 'F' if len(vals.get('pedcap_simp_cpf_cnpj')) == 11 else
                           'J'}
            if vals.get('pedcap_simp_email'):
                email_tipo_id = self.pool.get('adm.email.tipo').search(
                    cr, uid, [('name', '=', 'Comum')], context=context)[0]
                vals_pessoa.update({'email_ids': [(0, 0, {'email_tipo_id': email_tipo_id,
                                                          'name': vals.get('pedcap_simp_email')})]})
            if vals.get('pedcap_simp_telefone_numero'):
                if vals.get('pedcap_simp_telefone_numero')[0] in '987':
                    telefone_tipo_id = self.pool.get('adm.telefone.tipo').search(
                        cr, uid, [('name', '=', 'Celular')], context=context)[0]
                else:
                    telefone_tipo_id = self.pool.get('adm.telefone.tipo').search(
                        cr, uid, [('name', '=', 'Residencial')], context=context)[0]
                vals_pessoa.update({'telefones_ids': [
                    (0, 0, {'telefone_tipo_id': telefone_tipo_id,
                            'numero': vals.get('pedcap_simp_telefone_numero')})]})
            pessoa_id = obj_adm_pessoa.create(cr, uid, vals_pessoa, context)

        numero = vals.get('pedcap_simp_numero') or brw_estoquepedidos_pedido_capa. \
            pedcap_endereco_id.numero

        pais_id = self.pool.get('adm.pais').search(
            cr, uid, [('name', '=', 'Brasil'), ('sigla', '=', 'BRA')],
            context=context)[0]

        vals_endereco = {'pessoa_id': pessoa_id, 'pais_id': pais_id,
                         'endereco_tipo_id': self.pool.get('adm.endereco.tipo').search(
                             cr, uid, [('name', '=', 'Normal')], context=context)[0]}
        args_endereco = [('pessoa_id', '=', pessoa_id)]

        endereco_id = False
        cep = (vals.get('pedcap_simp_cep') or '').replace('.', '').replace('-', '')
        if cep:
            endereco_ids = self.pool.get('adm.pessoa.endereco').search(
                cr, uid, [('cep', '=', cep), ('pessoa_id', '=', pessoa_id),
                          ('numero', '=', numero)], context=context)
            if endereco_ids:
                endereco_id = endereco_ids[0]
            vals_endereco.update({'cep': cep})
            args_endereco.append(('cep', '=', cep))
        if endereco_id:
            return {'pessoa_id': pessoa_id, 'pedcap_endereco_id': endereco_id}

        uf_id = False
        uf = vals.get('pedcap_simp_uf') or brw_estoquepedidos_pedido_capa.pedcap_simp_uf
        if uf:
            uf_ids = self.pool.get('adm.uf').search(
                cr, uid, [('name', 'ilike', uf),
                          ('pais_id', '=', pais_id)], context=context)
            uf_id = uf_ids and uf_ids[0]
            vals_endereco.update({'uf_id': uf_id})
            args_endereco.append(('uf_id', '=', uf_id))

        cidade = vals.get('pedcap_simp_cidade') or brw_estoquepedidos_pedido_capa.pedcap_simp_cidade
        if uf_id and cidade:
            obj_adm_cidade = self.pool.get('adm.cidade')
            cidade_ids = obj_adm_cidade.search(
                cr, uid, [('uf_id', '=', uf_id), ('name', 'ilike', cidade)], context=context)
            cidade_id = cidade_ids and cidade_ids[0]
            if not cidade_id:
                cidade_id = obj_adm_cidade.create(cr, uid, {'uf_id': uf_id, 'name': cidade},
                                                  context)
            vals_endereco.update({'cidade_id': cidade_id})
            args_endereco.append(('cidade_id', '=', cidade_id))

        bairro = vals.get('pedcap_simp_bairro') or brw_estoquepedidos_pedido_capa.pedcap_simp_bairro
        if bairro:
            obj_adm_bairro = self.pool.get('adm.bairro')
            bairro_ids = obj_adm_bairro.search(cr, uid, [('name', 'ilike', bairro)],
                                               context=context)
            bairro_id = bairro_ids and bairro_ids[0]
            if not bairro_id:
                bairro_id = obj_adm_bairro.create(cr, uid, {'name': bairro}, context)
            vals_endereco.update({'bairro_id': bairro_id})
            args_endereco.append(('bairro_id', '=', bairro_id))

        logradouro = vals.get('pedcap_simp_logradouro') or \
                     brw_estoquepedidos_pedido_capa.pedcap_simp_logradouro
        if logradouro:
            obj_adm_logradouro = self.pool.get('adm.logradouro')
            logradouro = logradouro.replace('  ', '').split(' ')
            titulo = logradouro[0]
            descricao = ' '.join(logradouro[1:])
            logradouro_ids = obj_adm_logradouro.search(
                cr, uid, [('descricao', 'ilike', descricao)], context=context)
            logradouro_id = logradouro_ids and logradouro_ids[0]
            if not logradouro_id:
                logradouro_id = obj_adm_logradouro.create(
                    cr, uid, {'titulo': titulo, 'descricao': descricao}, context)
            vals_endereco.update({'logradouro_id': logradouro_id})
            args_endereco.append(('logradouro_id', '=', logradouro_id))

        vals_endereco.update({'numero': numero})
        args_endereco.append(('numero', '=', numero))
        obj_adm_pessoa_endereco = self.pool.get('adm.pessoa.endereco')
        endereco_ids = obj_adm_pessoa_endereco.search(cr, uid, args_endereco, context=context)
        endereco_id = endereco_ids and endereco_ids[0]
        if not endereco_id:
            endereco_id = obj_adm_pessoa_endereco.create(cr, uid, vals_endereco, context)
        return {'pessoa_id': pessoa_id, 'pedcap_endereco_id': endereco_id}

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('pedcap_simp_state') == 'B' and not vals.get('pedcap_state_id'):
            vals['pedcap_state_id'] = self.pool.get('estoquepedidos.pedido.capa.state').search(
                cr, uid, [('state', '=', 'B')], context=context)[0]
        elif vals.get('pedcap_simp_state') == 'I' and not vals.get('pedcap_state_id'):
            vals['pedcap_state_id'] = self.pool.get('estoquepedidos.pedido.capa.state').search(
                cr, uid, [('state', '=', 'I')], context=context)[0]
        produtos_sem_quantidade = ''
        produtos_sem_valor_unitario = ''

        if vals.get('tipo') == 'C':
            tipo_pedido = 'numero_pedido.compra'
        else:
            tipo_pedido = 'numero_pedido.venda'
        if context.get('sig_force_company') and context.get('sig_force_company') != True:
            context['force_company'] = context.get('sig_force_company')
        self.sequence_criar(cr, uid, context)
        vals['numero_pedido'] = self.pool.get('adm.utils').get_sequence(cr, uid, self._name,
                                                                        tipo_pedido, context)
        if context.get('force_company'):
            context.pop('force_company')
        if context.get('copy_estoque_pedidos'):
            if not vals.get('pedido_item_ids'):
                raise osv.except_osv(_('Atencao'), _('Nao posso duplicar um pedido sem itens.'))
            for pedido in vals['pedido_item_ids']:
                pedido[2].update({'qtde_atendida': 0})

        if produtos_sem_quantidade:
            raise osv.except_osv(
                _('Atencao'),
                _('O(s) produto(s):\n %s nao possue(m) quantidade pedida valida!') % produtos_sem_quantidade
            )
        if produtos_sem_valor_unitario:
            raise osv.except_osv(
                _('Atencao'),
                _('O(s) produto(s):\n %s nao possue(m) valor unitario valido!') % produtos_sem_valor_unitario
            )
        if context.get('pedcap_simplificado'):
            obj_financeiro_cliente = self.pool.get('financeiro.cliente')
            if vals.get('pessoa_id'):
                obj_financeiro_cliente.verificar_incluir_cliente(
                    cr, uid, vals.get('pessoa_id'), vals.get('company_id'), 'incluir', context)
            elif vals.get('pedcap_simp_cpf_cnpj'):
                dados_pessoa_endereco = self.pedcap_simplificado_trata_pessoa_endereco(
                    cr, uid, [], vals, context)
                vals.update(dados_pessoa_endereco)
                obj_financeiro_cliente.verificar_incluir_cliente(
                    cr, uid, dados_pessoa_endereco.get('pessoa_id'), vals.get('company_id'),
                    'incluir', context)
        if vals.get('tipo') == 'V' and vals.get('pedcap_percentual_desconto') and vals.get(
                'pedido_item_ids'):
            vals['vr_desconto'] = round(sum(map(lambda i: i[2].get('valor_total') * (vals.get(
                'pedcap_percentual_desconto') / 100.0), vals.get('pedido_item_ids'))), 2)
        pedido_id = super(estoquepedidos_pedido_capa, self).create(cr, uid, vals, context)

        self.pool.get('adm.transacao.capa').admtrc_criar_transacao(cr, uid, 'pedi', pedido_id, context=None)
        for inv_id, name in self.name_get(cr, uid, [pedido_id], context=context):
            self.message_post(cr, uid, pedido_id, _('Pedido: %s - Criado') % name, _('Aguardando validacao'))
        return pedido_id

    def pedcap_valida_estado_kanban(self, cr, uid, ids, state, context=None):
        """
        O metodo realiza a validacao do estado dos pedidos quando e feita no tipo de visao kanban.
        Nessa visao, o estado do pedido e alterado com um arraste do registro desejado.
        :param cr: cursor no banco de dados.
        :param uid: id da tabela res_users, identificador do usuario.
        :param ids: lista de id da tabela desse objeto.
        :param state: string que representa o novo estado do pedido.
        :param context: dicionario com valores contextuais.
        :return: booleano True.
        """
        if not isinstance(ids, list):
            ids = [ids]
        context = context and context.copy() or {}
        old_state = self.browse(cr, uid, ids[0], context).state

        estado_valido = False
        estoque_parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', 'estpar_pedido_separar', context=context)
        separar_pedido = estoque_parametro_dados.get('estpar_pedido_separar')
        if (old_state == 'V' and not separar_pedido) or (separar_pedido and old_state == 'D'):
            estado_valido = True

        if state == 'R' and old_state == 'V':
            self.button_rascunho(cr, uid, ids, context)
        elif state == 'V' and old_state == 'R':
            self.button_validar(cr, uid, ids, context)
        elif state == 'S' and old_state == 'V':
            self.button_separar(cr, uid, ids, context=context)
        elif state == 'D' and old_state == 'S':
            self.pedcap_button_separar_tudo(cr, uid, ids, context=context)
            self.pedcap_button_separado(cr, uid, ids, context)
        elif state == 'F' and estado_valido:
            self.button_faturar_pedido(cr, uid, ids, context=context)
        elif state == 'C' and old_state != 'F':
            self.button_cancelar(cr, uid, ids, context=context)
        else:
            raise osv.except_osv(_('Atencao'), _('Mudanca de estado invalida!'))
        return True

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if not ids:
            return True

        pedido_id = ids[0] if ids and isinstance(ids, (list, tuple)) else ids
        brw_pedido = self.browse(cr, uid, pedido_id, context=context)
        if vals.get('state') and len(vals) == 1 and not context.get('pedcap_write_state')\
                and brw_pedido.tipo != 'C':
            self.pedcap_valida_estado_kanban(cr, uid, ids, vals.get('state'), context)

        produtos_sem_quantidade = ''
        produtos_sem_valor_unitario = ''
        obj_estoque_produto = self.pool.get('estoque.produto')
        obj_estoquepedido_item = self.pool.get('estoquepedidos.pedido.item')

        if not vals.get('exportado_frente'):
            vals.update({'exportado_frente': False})  # Se sofre alguma alteracao marcar exportado com falso
        if vals.get('tipo', False) == 'C':  # verificar o fornecedor escolhido e gravar caso nao existe
            if 'company_id' in vals and 'pessoa_id' in vals:
                obj_forn = self.pool.get('financeiro.fornecedor')
                res = obj_forn.search(cr, uid,
                                      [('company_id', '=', vals['company_id']), ('pessoa_id', '=', vals['pessoa_id'])],
                                      context=context)
                if not res:
                    obj_forn.create(cr, uid, {'company_id': vals['company_id'], 'pessoa_id': vals['pessoa_id']},
                                    context=context)
        if vals.get('pedido_item_ids'):
            pedido_item_ids = vals.get('pedido_item_ids')
            for x in pedido_item_ids:
                for y in x:
                    if isinstance(y, dict):
                        if y.get('qtde_pedida'):
                            if not y.get('qtde_pedida') > 0:
                                if y.get('produto_id'):
                                    produto_name = obj_estoque_produto.browse(cr, uid, y.get('produto_id')).name
                                else:
                                    produto_name = obj_estoquepedido_item.browse(cr, uid, x[1]).produto_id.name
                                produtos_sem_quantidade += '%s,\n' % produto_name
                            if not y.get('qtde_pedida') > 0:
                                if y.get('produto_id'):
                                    produto_name = obj_estoque_produto.browse(cr, uid, y.get('produto_id')).name
                                else:
                                    produto_name = obj_estoquepedido_item.browse(cr, uid, x[1]).produto_id.name
                                produtos_sem_quantidade += '%s,\n' % produto_name
                        if y.get('vr_unitario'):
                            if not y.get('vr_unitario') > 0:
                                if y.get('produto_id'):
                                    produto_name = obj_estoque_produto.browse(cr, uid, y.get('produto_id')).name
                                else:
                                    produto_name = obj_estoquepedido_item.browse(cr, uid, x[1]).produto_id.name
                                produtos_sem_valor_unitario += '%s,\n' % produto_name
        if produtos_sem_quantidade:
            raise osv.except_osv(_('Atencao'), _(
                'O(s) produto(s):\n %s nao possue(m) quantidade pedida valida!') % produtos_sem_quantidade)
        if produtos_sem_valor_unitario:
            raise osv.except_osv(_('Atencao'), _(
                'O(s) produto(s):\n %s nao possue(m) valor unitario valido!') % produtos_sem_valor_unitario)
        if context.get('pedcap_simplificado'):
            obj_financeiro_cliente = self.pool.get('financeiro.cliente')
            if vals.get('pessoa_id'):
                obj_financeiro_cliente.verificar_incluir_cliente(
                    cr, uid, vals.get('pessoa_id'),
                    vals.get('company_id') or brw_pedido.company_id.id, 'incluir', context)
            elif 'pessoa_id' in vals or ('pedcap_endereco_id' in vals and not vals.get(
                                         'pedcap_endereco_id')) or vals.get('pedcap_simp_cpf_cnpj'):
                dados_pessoa_endereco = self.pedcap_simplificado_trata_pessoa_endereco(
                    cr, uid, ids, vals, context)
                vals.update(dados_pessoa_endereco)
                obj_financeiro_cliente.verificar_incluir_cliente(
                    cr, uid, dados_pessoa_endereco.get('pessoa_id'), vals.get('company_id'),
                    'incluir', context)
        pedido_data = self.pool.get('estoquepedidos.pedido.capa').read(cr, uid, ids, ['state', 'tipo'], context=context)
        for pedido in pedido_data:
            if (pedido.get('tipo') == 'C' and vals.get('observacao')) or \
                pedido.get('tipo') == 'V': # Permitir salvar observacao para pedidos de compras mesmo cancelados
                context['salvar_forcado'] = True
            if not pedido.get('state') == 'C' or context.get('salvar_forcado'):
                super(estoquepedidos_pedido_capa, self).write(cr, uid, pedido.get('id'),
                                                              vals, context=context)
        return True  # se o pedido ja estiver cancelado, a nota pode ser cancela normalmente

    def unlink(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if ids:
            estoquepedidos_pedido_capa_obj = self.pool.get('estoquepedidos.pedido.capa')
            dados_pedido_capa = estoquepedidos_pedido_capa_obj.read(cr, uid, ids, ['state'], context=context)
            for dado in dados_pedido_capa:
                state = dado.get('state')
                if state == 'V':
                    raise osv.except_osv(_('Atencao'), _('Nao e permitido excluir pedido validado'))

        return super(estoquepedidos_pedido_capa, self).unlink(cr, uid, ids, context=context)

    ######## FUNÇÃO PARA ATUALIZAR O VALOR TOTAL DA CAPA A MEDIDA QUE OS VALORES SÃO ALTERADOS
    def onchange_valores_capa(self, cr, uid, ids, itens, vr_seguro, vr_despesas_acessorias, vr_desconto, vr_frete,
                              pedcap_valor_ipi=0, context=None):
        context = context and context.copy() or {}
        res = {'value': {}}
        val = {}
        if not itens:
            vr_despesas_acessorias = 0

        if vr_desconto < 0:
            return {'value': {'vr_desconto': 0, 'pedcap_percentual_desconto': 0},
                    'warning': {'title': _('Atencao'), 'message': _('Desconto invalido')}}

        elif not vr_desconto:
            val['pedcap_percentual_desconto'] = 0
        valor_total = 0
        if ids:
            obj_ped_item = self.pool.get('estoquepedidos.pedido.item')
            ped_item_id = obj_ped_item.search(cr, uid, [('pedido_id', '=', ids[0])], context=context)
            for i in ped_item_id:
                valor_total += obj_ped_item.read(cr, uid, i, ['valor_total'], context=context)['valor_total']
                val[
                    'valor_total'] = valor_total + vr_seguro + vr_frete + vr_despesas_acessorias + pedcap_valor_ipi - vr_desconto


        res['value'].update(val)
        if itens:
            res['value'].update(self.pool.get('estoquepedidos.pedido.item').pedite_ratear_despesa_itens(
                                                   cr, uid, itens, vr_despesas_acessorias, context))
        return res

    def pedcap_onchange_itens(self, cr, uid, ids, itens, context=None):
        context = context and context.copy() or {}
        despesas = 0
        itens = filter(lambda x: x[0] in (0, 1, 4), itens)
        for i in self.resolve_2many_commands(cr, uid, 'pedido_item_ids', itens, ['pedite_despesas'],
                                             context):
            despesas += (i.get('pedite_despesas') or 0.0)

        res = {'value': {'vr_despesas_acessorias': despesas}}
        return res

    def onchange_pagamento(self, cr, uid, id, condicao_id, context=None):
        context = context and context.copy() or {}
        res = False
        if condicao_id:
            context['condicao_id'] = condicao_id
        if id:
            res = self.button_parcelas(cr, uid, id, context=context)
        return res

    def pedcap_simplificado_onchange_cep(self, cr, uid, ids, cep, context=None):
        """
        Metodo para validar o cep na perda de foco da tela. Eclusivo para pedido de venda
        simplificado.
        """
        context = context and context.copy() or {}
        if not cep:
            return {'value': {}.fromkeys(['pedcap_simp_cidade', 'pedcap_simp_uf',
                                          'pedcap_simp_bairro', 'pedcap_simp_logradouro'], '')}
        dados_cep = self.pool.get('adm.pessoa.endereco').admend_get_cep(cr, uid, cep, context)
        if not dados_cep.get('value'):
            return dados_cep
        cidade_id = dados_cep.get('value').get('cidade_id')
        uf_id = dados_cep.get('value').get('uf_id')
        bairro_id = dados_cep.get('value').get('bairro_id')
        logradouro_id = dados_cep.get('value').get('logradouro_id')
        return {'value': {
            'pedcap_simp_cidade': cidade_id[1] if isinstance(cidade_id, tuple) else self.pool.get(
                'adm.cidade').read(cr, uid, cidade_id, ['name'], context).get('name'),
            'pedcap_simp_uf': uf_id[1] if isinstance(uf_id, tuple) else self.pool.get(
                'adm.uf').read(cr, uid, uf_id, ['name'], context).get('name'),
            'pedcap_simp_bairro': bairro_id[1] if isinstance(bairro_id, tuple) else self.pool.get(
                'adm.bairro').read(cr, uid, bairro_id, ['name'], context).get('name'),
            'pedcap_simp_logradouro': logradouro_id[1] if isinstance(logradouro_id, tuple) else
            self.pool.get('adm.logradouro').read(cr, uid, logradouro_id, ['name'], context).get(
                'name')}}

    def onchange_cliente_pedido(self, cr, uid, ids, pessoa_id, context=None):
        """
        Metodo para buscar o endereco cadastrado para o cliente, se houver.
        """
        context = context and context.copy() or {}
        res = {'observacao_pessoa': None, 'pedcap_endereco_id': False}
        warning = {}
        obj_financeiro_cliente = self.pool.get('financeiro.cliente')
        obj_adm_empresa_objeto = self.pool.get('adm.empresa.objeto')
        obj_financeiro = self.pool.get('financeiro')
        if ids:
            self.pedcap_remove_restricao_venda_autorizada(cr, uid, ids, context)
        if not pessoa_id:
            if context.get('pedcap_simplificado'):
                res.update({'pedcap_simp_pessoa_nome': '', 'pedcap_simp_cpf_cnpj': '',
                            'pedcap_simp_uf': '', 'pedcap_simp_cidade': '',
                            'pedcap_simp_bairro': '', 'pedcap_simp_logradouro': '',
                            'pedcap_simp_numero': None, 'pedcap_simp_cep': '',
                            'pedcap_simp_email': '', 'pedcap_simp_telefone_numero': ''
                            })
            return {'value': res, 'warning': warning}
        observacao_cliente = obj_financeiro.finutl_observacao_cliente(cr, uid, pessoa_id,
                                                                      context=context)
        res['observacao_pessoa'] = observacao_cliente.get(pessoa_id)
        dados_pessoa = self.pool.get('adm.pessoa').read(
            cr, uid, pessoa_id, ['nome', 'cpf_cnpj', 'endereco_nf_id', 'endereco_ids'],
            context=context)
        if isinstance(dados_pessoa, list):
            dados_pessoa = dados_pessoa[0]
        cliente_company_id = obj_adm_empresa_objeto.getEmpresa(cr, uid, 'financeiro.cliente',
                                                               context=context)
        is_cliente = obj_financeiro_cliente.verificar_incluir_cliente(
            cr, uid, pessoa_id, cliente_company_id, 'incluir', context=context)
        if is_cliente:
            pessoa_com_restricao = self.pool.get('financeiro'). \
                finutl_verificar_restricao_cliente(cr, uid, finutl_pessoa_id=pessoa_id,
                                                   context=context)
            if pessoa_com_restricao:
                warning['title'] = _('Atencao')
                warning['message'] = _('Cliente possui restricoes de venda!')
        elif not context.get('pedcap_simplificado'):
            warning['title'] = _('Atencao')
            warning['message'] = _('%s nao e um cliente.' % dados_pessoa.get('nome'))
            res['pessoa_id'] = False
        id_end = False
        if dados_pessoa:
            endereco_id = dados_pessoa.get('endereco_nf_id')
            if endereco_id:
                if isinstance(endereco_id, (list, tuple)):
                    id_end = endereco_id[0]
            else:
                endereco_ids = dados_pessoa.get('endereco_ids')
                if endereco_ids:
                    id_end = endereco_ids and endereco_ids[0] or False
            res['pedcap_endereco_id'] = id_end
        if context.get('pedcap_simplificado'):
            res.update({'pedcap_simp_pessoa_nome': dados_pessoa.get('nome'),
                        'pedcap_simp_cpf_cnpj': dados_pessoa.get('cpf_cnpj')})
            if id_end:
                brw_pessoa_endereco = self.pool.get('adm.pessoa.endereco').browse(cr, uid, id_end,
                                                                                  context)
                res.update(
                    {'pedcap_simp_uf': brw_pessoa_endereco.uf_id.name or '',
                     'pedcap_simp_cidade': brw_pessoa_endereco.cidade_id.name or '',
                     'pedcap_simp_bairro': brw_pessoa_endereco.bairro_id.name or '',
                     'pedcap_simp_logradouro': brw_pessoa_endereco.logradouro_id.descricao or '',
                     'pedcap_simp_numero': brw_pessoa_endereco.numero,
                     'pedcap_simp_cep': brw_pessoa_endereco.cep or '',
                     }
                )
            obj_adm_pessoa_email = self.pool.get('adm.pessoa.email')
            email_ids = obj_adm_pessoa_email.search(
                cr, uid, [('pessoa_id', '=', pessoa_id)], limit=1, context=context)
            if email_ids:
                res.update({'pedcap_simp_email': obj_adm_pessoa_email.read(
                    cr, uid, email_ids[0], ['name'], context).get('name') or ''})

            obj_adm_pessoa_telefone = self.pool.get('adm.pessoa.telefone')
            telefone_ids = obj_adm_pessoa_telefone.search(
                cr, uid, [('pessoa_id', '=', pessoa_id)], limit=1, context=context)
            if telefone_ids:
                res.update({'pedcap_simp_telefone_numero': obj_adm_pessoa_telefone.browse(
                    cr, uid, telefone_ids[0], context).numero or ''})
        return {'value': res, 'warning': warning}

    def pedcap_check_state(self, cr, uid, ids, state, context=None):
        """
        O metodo verifica se a mudanca de estado do pedido e possivel. Caso nao seja, e exibida ao
        usuario uma mensagem para que atualize o pedido.
        :param cr: cursor no banco de dados.
        :param uid: id da tabela res_users, identificador do usuario.
        :param ids: lista de id da tabela desse objeto. Representa pedidos com seu estado atual.
        :param state: char que representa o estado para qual o pedido pretende ir.
        :param context: dicionario com valores contextuais.
        :return: booleano True caso a mudanca do estado do pedido seja possivel, senao um raise para
        informar a inviabilidade.
        """
        context = context and context.copy() or {}
        # quando o uma nota fiscal for cancelada, o pedido deve ser cancelado.
        if context.get('cancelamento_nf') or context.get('cancelar_nota_fiscal') \
                or context.get('nao_verificar_state_pedido'):
            return True

        if not isinstance(ids, list):
            ids = [ids]
        brw_pedido_capa = self.browse(cr, uid, ids, context)
        msg = ''
        for pedido in brw_pedido_capa:
            if pedido.state == 'F':
                msg += pedido.numero_pedido + '\n'
                continue
            if state != pedido.state and ((state in ('R', 'V') and pedido.state in ('R', 'V')) or
                    (state == 'C' and pedido.state in ('R', 'V', 'S', 'D')) or
                    (state == 'F' and pedido.state == 'V') or
                    (state == 'S' and pedido.state == 'V') or
                    (state == 'D' and pedido.state == 'S') or
                    (state == 'F' and pedido.state == 'D') or
                    (state == 'E' and pedido.state == 'V') or
                    (state == 'O' and pedido.state == 'E') or
                    (state == 'F' and pedido.state == 'O')):
                continue
            msg += pedido.numero_pedido + '\n'
        if msg:
            raise osv.except_osv(_('Atencao'),
                                 _('Os pedidos a seguir foram alterados, atualize-os: \n%s' % msg))
        return True

    def set_rascunho_pedido(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.pedcap_check_state(cr, uid, ids, 'R', context)
        pedido_capa_dados = self.read(cr, uid, ids, ['state', 'numero_pedido', 'data_emissao'],
                                      context=context)
        obj_estoque_parametro = self.pool.get('estoque.parametro')
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name,
                                                                    context=context)
        estoque_parametro_id = obj_estoque_parametro.search(cr, uid, [('company_id', '=',
                                                                       company_id)],
                                                            context=context)
        if estoque_parametro_id:
            somente_maneger = obj_estoque_parametro.browse(cr, uid,
                                                           estoque_parametro_id[
                                                               0]).estpar_esboco_somente_manager
            if somente_maneger and context.get('view_name') != 'estoquepedidos_compra':
                obj_ir_model_access = self.pool.get('ir.model.access')
                permissao = obj_ir_model_access.check_groups(cr, uid,
                                                             'estoquepedidos.group_estoquepedidos_manager.')
                if not permissao:
                    permissao = obj_ir_model_access.check_groups(cr, uid,
                                                                 'prime.group_prime_manager')
                if not permissao:
                    raise osv.except_osv(_('Atencao'),
                                         _('Operacao nao permitida para este usuario'))
        for x in pedido_capa_dados:
            if not context.get('nao_verificar_state_pedido') and x.get('state') == 'F':
                raise osv.except_osv(_('Atencao'), _('O pedido ja foi faturado'))

            # Excluindo previsoes de financeiro_titulos
            self.pedcap_exclui_titulo_prv_financeiro(cr, uid, ids, context)

        self.pedcap_remove_restricao_venda_autorizada(cr, uid, ids, context)
        context.update({'pedcap_write_state': True})
        self.write(cr, uid, ids, {'state': 'R'}, context=context)
        self.message_post(cr, uid, ids, _('Alteracao de Status'), _('Pedido em Esboco'))
        return True

    def pedcap_remove_restricao_venda_autorizada(self, cr, uid, ids, context=None):
        """
        O metodo exclui possivel restricao de venda ja autorizada, uma vez que, ao voltar o pedido
        para esboco ou o pedido ainda em esboco, o cliente pode ser alterado.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dados contextuais.
        :type context: dict
        :return:
        """
        context = context and context.copy() or {}
        obj_liberar_restricoes = self.pool.get('venlre.liberar.restricoes')
        restricao_ids = obj_liberar_restricoes.search(
            cr, uid, [('venlre_pedido_id', 'in', ids), ('venlre_autorizado', '=', True)],
            context=context)
        if not restricao_ids:
            return False
        return obj_liberar_restricoes.unlink(cr, uid, restricao_ids, context)

    #### BUTTONS________________________________________________________________
    def button_rascunho(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return self.set_rascunho_pedido(cr, uid, ids, context)

    def pedcap_button_separar_itens(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.pedcap_check_state(cr, uid, ids, 'S', context)
        if isinstance(ids, (int, long)):
            ids = [ids]
        obj_ped_item = self.pool.get('estoquepedidos.pedido.item')
        pedido_item_ids = obj_ped_item.search(cr, uid, [('pedido_id', 'in', ids)], context=context)
        if pedido_item_ids:
            item_ids = obj_ped_item.read(cr, uid, pedido_item_ids, ['qtde_pedida', 'qtde_atendida'], context=context)
            for produto in item_ids:
                item_id = produto['id']
                quantidade_atendida = produto.get('qtde_pedida') or 0
                obj_ped_item.write(cr, uid, [item_id], {'qtde_atendida': quantidade_atendida}, context=context)
            context.update({'pedcap_write_state': True})
            self.write(cr, uid, ids, {'state': 'S'}, context=context)
            self.message_post(cr, uid, ids, _('Alteracao de Status'), _('Pedido em Separacao'))
            return True
        else:
            raise osv.except_osv(_('Atencao'), _('O pedido nao possui itens lancados!'))

    def button_separar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.pedcap_check_state(cr, uid, ids, 'S', context)
        context.update({'pedcap_write_state': True})
        self.write(cr, uid, ids, {'state': 'S'}, context=context)
        self.message_post(cr, uid, ids, _('Alteracao de Status'), _('Pedido em Separacao'))
        return True

    def pedcap_button_separado(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.pedcap_check_state(cr, uid, ids, 'D', context)
        brw_estoquepedidos_pedido_capa = self.browse(cr, uid, ids, context)
        pedido_item_ids = []
        msg = ''
        map(lambda i: pedido_item_ids.extend(i.pedido_item_ids), brw_estoquepedidos_pedido_capa)
        qtd_maior_pedido_item_ids = filter(lambda i: i.qtde_atendida > i.qtde_pedida,
                                           pedido_item_ids)
        if qtd_maior_pedido_item_ids:
            msg += 'O(s) produto(s) a seguir possue(m) quantidade atendida superior a pedida: \n'
            for item in qtd_maior_pedido_item_ids:
                msg += item.produto_id.codigo + ' - ' + item.produto_id.name + '\n'
        qtd_zerada_pedido_item_ids = filter(lambda i: i.qtde_atendida == 0, pedido_item_ids)
        if qtd_zerada_pedido_item_ids:
            if msg:
                msg += '\n'
            msg += 'O(s) produto(s) a seguir possue(m) quantidade atendida igual a zero: \n'
            for item in qtd_zerada_pedido_item_ids:
                msg += item.produto_id.codigo + ' - ' + item.produto_id.name + '\n'
        if msg:
            raise osv.except_osv(_('Atencao'), msg)
        context.update({'pedcap_write_state': True})
        self.write(cr, uid, ids, {'state': 'D'}, context=context)
        self.message_post(cr, uid, ids, _('Alteracao de Status'), _('Pedido Separado'))
        return True

    def pedcap_button_separar_tudo(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        brw_pedido = self.browse(cr, uid, ids, context=context)
        item_ids = []
        map(lambda i: item_ids.extend(i.pedido_item_ids), brw_pedido)
        for item in item_ids:
            qtd_atendida = item.qtde_pedida
            self.pool.get('estoquepedidos.pedido.item').write(
                cr, uid, item.id, {'qtde_atendida': qtd_atendida}, context=context)
        return True

    def calcular_parcelas_pedido(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = []
        if isinstance(ids, (int, long)):
            ids = [ids]
        context['criar'] = "parcelas"
        obj_condicao_pag = self.pool.get('estoquepedidos.pedido.condicao')
        pedido_condicao_ids = obj_condicao_pag.search(cr, uid, [('capa_id', 'in', ids)],
                                                      context=context)
        obj_parcelas = self.pool.get('estoquepedidos.pedido.parcela')
        # BUSCA O ID_PARCELA EM FUNÇÃO
        if pedido_condicao_ids:
            pedido_condicao_id = obj_parcelas.search(
                cr, uid, [('pedido_condicao_id', 'in', pedido_condicao_ids)], context=context)
            # DELETAR AS PARCELAS EXISTENTES
            if pedido_condicao_id:
                obj_parcelas.unlink(cr, uid, pedido_condicao_id, context)
                # BUSCAR VALOR TOTAL DO PEDIDO
            valor_total = self.browse(cr, uid, ids[0]).valor_total or 0.0
            dados_condicao = obj_condicao_pag.read(
                cr, uid, pedido_condicao_ids, ['condicao_forma_id', 'valor', 'id'], context=context)
            obj_condicao_forma = self.pool.get('adm.condicao.forma')
            valor_total_parcelas = sum(map(lambda x: x['valor'], dados_condicao)) or 0
            dados_extra = self.pedcap_get_dado_extra(cr, uid, ids, context)
            valor_troco = sum(map(
                lambda p: sum((dados_extra.get(p).get('condicao_dados') or {}).values()),
                dados_extra))

            valor_total_parcelas -= valor_troco
            if not context.get('gerando_pedido'):
                if round(valor_total, 2) != round(valor_total_parcelas, 2):
                    raise osv.except_osv(
                        _('Atencao'), _('O valor total das condicoes de pagamento deve ser igual '
                                        'ao valor total do pedido.'))
            for x in dados_condicao:
                # DIVIDIR PELAS PARCELAS
                if x['condicao_forma_id']:
                    condicao_id = obj_condicao_forma.browse(
                        cr, uid, x['condicao_forma_id'][0]).adm_condicao_id.id
                    parcelas_condicao = self.pool.get('adm.condicao').read(
                        cr, uid, condicao_id, ['qtde_parcelas', 'dias_primeira_parcela',
                                               'tipo_prazo', 'dias_incremento',
                                               'admcnd_dia_fechamento'], context=context)
                    if parcelas_condicao.get('qtde_parcelas', False) > 0:
                        valor_parcela = (x.get('valor') or 0) - valor_troco
                        valor_cada_parcela = round(
                            valor_parcela / parcelas_condicao['qtde_parcelas'], 2)
                        # CRIAR PARCELAS COM NOVOS VALORES
                        i = 1
                        vct = self.pool.get('adm.utils').admutl_converte_tz(cr, uid, datetime.now(),
                                                      'UTC', context=context).date()
                        while i <= parcelas_condicao['qtde_parcelas']:
                            if i == parcelas_condicao['qtde_parcelas']:  # SE FOR A ULTIMA PARCELA
                                valor_cada_parcela = valor_parcela - (valor_cada_parcela * (i - 1))
                                # NO CASO DA ULTIMA PARCELA, É SUBTRAIDO DO VALOR TOTAL AS PARCELAS
                                # JA FEITAS.
                            if i == 1:  # SE FOR A PRIMERIA PARCELA, vct RECEBE O DIA ATUAL
                                vct = datas.sigDatas(vct).getCalculaPrazo(
                                    parcelas_condicao['dias_primeira_parcela'],
                                    parcelas_condicao['tipo_prazo'], 'N',
                                    parcelas_condicao['admcnd_dia_fechamento'])
                            else:
                                vct = datas.sigDatas(vct).getCalculaPrazo(
                                    parcelas_condicao['dias_incremento'],
                                    parcelas_condicao['tipo_prazo'], 'N',
                                    parcelas_condicao['admcnd_dia_fechamento'])
                            vct = datetime.strptime(vct, "%Y%m%d")  # CONVERTENDO DE STR P/ DATETIME
                            vct = datetime.date(vct)
                            # CONVERTENDO DE DATETIME P/ DATE, SE PASSAR DATETIME PARA A FUNÇÃO
                            # sigDatas NÃO CALCULA A DATA CORRETA
                            vals = {
                                'pedido_condicao_id': x['id'],
                                'vr_parcela': valor_cada_parcela,
                                'data_vencimento': vct,
                            }
                            i += 1
                            # GRAVAR PARCELAS
                            res.append(obj_parcelas.create(cr, uid, vals, context=context))
        return res

    def button_parcelas(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = self.calcular_parcelas_pedido(cr, uid, ids, context)
        return res

    def button_validar(self, cr, uid, ids, context=None):
        """
        Efetua a validacao do pedido de venda.

        :param cr:  a linha atual do cursor do banco de dados,
        :param uid:  ID do usuario utilizado para a verificacao de perfil,
        :param ids:  lista de IDs,
        :param context:  um dicionario padrao para valores contextuais,
        :return: verdadeiro se o pedido foi validado
        :raise: mensagem de erro se o pedido nao foi validado.
        """

        context = context and context.copy() or {}

        if ids and isinstance(ids, (int, long)):
            ids = [ids]

        # ___________________________ Objects ________________________________
        obj_estoque_produto = self.pool.get('estoque.produto')
        obj_estoque_produto_saldo = self.pool.get('estoque.produto.saldo')
        obj_estoquepedidos_pedido_item = self.pool.get('estoquepedidos.pedido.item')
        obj_pedido_utils = self.pool.get('pedido.utils')
        obj_estoque_produto = self.pool.get('estoque.produto')
        obj_estoquepedidos_pedido_item = self.pool.get('estoquepedidos.pedido.item')
        obj_estoquepedidos_pedido_condicao = self.pool.get('estoquepedidos.pedido.condicao')
        obj_estoque_parametro = self.pool.get('estoque.parametro')
        obj_estoque_preco_venda = self.pool.get('estoque.preco.venda')
        obj_adm_utils = self.pool.get('adm.utils')
        obj_adm_empresa_objeto = self.pool.get('adm.empresa.objeto')
        obj_pedido_parcela = self.pool.get('estoquepedidos.pedido.parcela')
        obj_condicao_pag = self.pool.get('estoquepedidos.pedido.condicao')
        obj_cliente = self.pool.get('financeiro.cliente')
        obj_financeiro_fornecedor = self.pool.get('financeiro.fornecedor')
        obj_estoque_produto_saldo = self.pool.get('estoque.produto.saldo')
        obj_estoque_local_locacao = self.pool.get('estoque.local.locacao')
        obj_estoque_local = self.pool.get('estoque.local')

        self.pedcap_check_state(cr, uid, ids, 'V', context)

        def _pedcap_button_validar_estoqueserie():
            """
            Verifica se a quantide de numeros de serie inseridos e igual a quantidade do produto.

            :return:  True
            """

            if obj_estoque_produto.estpro_get_parametro_serie(cr, uid, context=context):
                browse_pedido_capa = self.browse(cr, uid, ids)
                serie_divergente = []  # Lista com os IDs dos produtos com numero de serie divergente
                nao_possui_serie = []  # Lista com os IDs dos produtos que nao possuem numero de serie

                for pedido_item in browse_pedido_capa.pedido_item_ids:
                    produto_utiliza_serie = pedido_item.produto_id.estpro_nserie_tipo
                    item_serie_ids = pedido_item.pei_movserie_ids or []

                    # Se o produto possui controle de serie
                    if produto_utiliza_serie in ('NS', 'NC'):
                        item_quantidade = pedido_item.qtde_pedida or 0

                        # Pedido de venda
                        if browse_pedido_capa.tipo == 'V':
                            if int(item_quantidade) != len(item_serie_ids):
                                serie_divergente.append(pedido_item.produto_id.id)
                    elif item_serie_ids:
                        nao_possui_serie.append(pedido_item.produto_id.id)

                if serie_divergente:
                    msg_divergente = _('Os produtos a seguir possuem os numeros de series '
                                       'diferentes da quantidade inserida no item')
                    self.estoqueserie_raise_msg_produtos(
                        cr, uid, produto_ids=serie_divergente, message=msg_divergente,
                        context=context)
                if nao_possui_serie:
                    msg_numero_serie = _('Os produtos a seguir nao possuem controle de '
                                         'numero de serie')
                    self.estoqueserie_raise_msg_produtos(
                        cr, uid, produto_ids=nao_possui_serie, message=msg_numero_serie,
                        context=context)
            return True

        if isinstance(ids, (list, tuple)):
            ids = ids[0]

        browse_pedido = self.browse(cr, uid, ids)
        tipo_pedido = browse_pedido.tipo or ''
        valor_total = browse_pedido.valor_total or 0.0
        if not valor_total or valor_total < 0:
            raise osv.except_osv(_('Atencao'), _('O Total do pedido deve ser um valor valido'))
        msg = ''
        pedido_itens_dados = browse_pedido.pedido_item_ids or []
        for item in pedido_itens_dados:
            produto_id = item.produto_id
            if produto_id:
                nome_item = produto_id.name
            if not item.qtde_pedida or not item.vr_unitario:
                msg += '%s, \n' % nome_item
        if msg:
            raise osv.except_osv(_('Atencao'), _(
                'Os produtos nao possuem quantidade pedida e/ou valor unitario cadastrado: \n%s' % msg))

        # Verifica Kit
        modulo_kit_instalado = obj_adm_utils.admutl_check_modulo_instalado(cr, uid, 'kit', context)
        if modulo_kit_instalado:
            if isinstance(ids, list):
                ped_id = ids[0]
            else:
                ped_id = ids
            kit_item_ids = self.browse(cr, uid, ped_id).pedido_kit_item_ids
            for k in kit_item_ids:
                if not k.kitmov_lancado:
                    raise osv.except_osv(_('Atencao'),
                                         _('Existe um Kit informado mas os itens do Kit nao foram '
                                           'inseridos. Para inserir clique no botao '
                                           '"Inserir Kit de Item" .'))

        company_id = obj_adm_empresa_objeto.getEmpresa(cr, uid, self._name, context=context)
        estoque_parametro_id = obj_estoque_parametro.search(
            cr, uid, [('company_id', '=', company_id)], context=context)
        estpar_pvenda_menor_pcusto = False

        if estoque_parametro_id:
            estpar_pvenda_menor_pcusto = obj_estoque_parametro.browse(
                cr, uid, estoque_parametro_id[0]).estpar_pvenda_menor_pcusto

        if tipo_pedido == 'V':
            # Liberacao de desconto
            if not obj_pedido_utils.pedutl_venda_liberacao_desconto(cr, uid, ids, context):
                erro_pedido = obj_pedido_utils.pedutl_get_erro()
            else:
                erro_pedido = ''

            # Se houver condicoes a prazo, verifica se ha restricoes para o cliente.
            if filter(lambda i: not i.forma_pagto_id.cartao_credito_debito and
                    i.condicao_forma_id.adm_condicao_id.tipo not in ('V', 'S'),
                      browse_pedido.pedido_condicao_ids or []):
                if not obj_pedido_utils.pedutl_validar_condicoes_pgto_valor_prazo(
                        cr, uid, ids, context):
                    erro_pedido += obj_pedido_utils.pedutl_get_erro()

                # Restricao de venda
                if not obj_pedido_utils.pedutl_restricao_venda(cr, uid, ids, context):
                    erro_pedido += obj_pedido_utils.pedutl_get_erro()

            if erro_pedido:
                raise osv.except_osv(_('Erro na validacao do pedido'), erro_pedido)

            itens_custo_maior_precovenda = ''

            if not estpar_pvenda_menor_pcusto and estoque_parametro_id:
                for item in pedido_itens_dados:
                    preco_venda = item.valor_total / item.qtde_pedida or 0.0
                    produto_id = item.produto_id.id
                    produto_name = item.produto_id.name
                    custo_maior_precovenda = \
                        obj_estoque_preco_venda.estpve_verificar_custo_maior_pvenda(
                            cr, uid, preco_venda, produto_id, [], context)

                    if custo_maior_precovenda:
                        itens_custo_maior_precovenda += '\n %s, \n' % produto_name

            if itens_custo_maior_precovenda:
                raise osv.except_osv(_('Atencao'),
                                     _('Os produtos a seguir possuem preco de venda menor que o '
                                       'de custo: %s') % itens_custo_maior_precovenda)

            # Verifica se vendedor tem evento cadastrado se o parametro do Financeiro "Usar centro
            # de custo e evento" estiver marcado
            parametro_financeiro_dados = self.pool.get('adm.utils').admutl_get_parametros(
                cr, uid, 'financeiro', ['usar_centro_custos_e_eventos'], context=context)
            if parametro_financeiro_dados.get('usar_centro_custos_e_eventos'):
                if browse_pedido.vendedor_id:
                    if not browse_pedido.vendedor_id.venven_evento_id:
                        raise osv.except_osv(_('Atencao!'),
                                             _('O vendedor nao possui evento cadastrado.'))

        pedido_id = browse_pedido.id
        pedido_company_id = browse_pedido.company_id.id
        pedido_pessoa_id = browse_pedido.pessoa_id.id
        pedido_tipo = browse_pedido.tipo
        pedido_valor_total = browse_pedido.valor_total

        if isinstance(pedido_pessoa_id, (list, tuple)):
            pedido_pessoa_id = pedido_pessoa_id[0]

        parcela_ids = []

        # PEDIDO DE VENDA
        if pedido_tipo == 'V':
            ### _______________________ VERFICAÇÃO NA CONDIÇÃO DE PAGAMENTO _____________________________
            record_pedido_condicao_ids = browse_pedido.pedido_condicao_ids
            if not record_pedido_condicao_ids:
                raise osv.except_osv(_('Atencao'), _('Nenhuma condicao de pagamento cadastrada no Pedido de Venda!'))
            else:
                pedido_condicao_ids = obj_condicao_pag.search(cr, uid, [('capa_id', '=', ids)], context=context)
                valor_total = self.browse(cr, uid, ids).valor_total or 0.0
                dados_condicao = obj_condicao_pag.read(cr, uid, pedido_condicao_ids,
                                                       ['condicao_forma_id', 'valor', 'id'], context=context)
                valor_total_parcelas = 0
                for i in browse_pedido.pedido_parcela_ids:
                    if i.vr_parcela <= 0:
                        raise osv.except_osv(_('Atencao!'),
                                             _('O valor das parcelas deve ser maior que zero.'))
                    valor_total_parcelas += i.vr_parcela

                if not context.get('gerando_pedido'):
                    if round(valor_total, 2) != round(valor_total_parcelas, 2):
                        raise osv.except_osv(
                            _('Atencao!'), _('O valor total das condicoes de pagamento deve ser '
                                            'igual ao valor total do pedido.'))
                for pedido in record_pedido_condicao_ids:
                    if not pedido.forma_pagto_id.cartao_credito_debito:
                        if pedido.forma_pagto_id.condicao_forma_ids[0].adm_condicao_id.tipo != 'V':
                            # filtra todas as condicoes que nao sao do tipo venda.
                            adm_condicao_a_prazo = filter(lambda i: i.condicao_forma_id.adm_condicao_id.tipo != 'V',
                                                          record_pedido_condicao_ids)
                            qtde_parcelas_diferentes = ''
                            for i in record_pedido_condicao_ids:
                                adm_condicao_qtde_parcelas = i.condicao_forma_id.adm_condicao_id.qtde_parcelas
                                pedido_condicao_qtde_parcelas = len(map(lambda i: i.id, i.pedido_parcela_ids))
                                if adm_condicao_qtde_parcelas != pedido_condicao_qtde_parcelas:
                                    adm_condicao_name = i.condicao_forma_id.adm_condicao_id.name
                                    qtde_parcelas_diferentes = adm_condicao_name + ' - nao possui' + str(
                                        adm_condicao_qtde_parcelas) + 'parcela(s), '
                            if qtde_parcelas_diferentes:
                                raise osv.except_osv(_('Atencao'), _(
                                    'As condicoes a seguir encontram-se divergentes: ' + qtde_parcelas_diferentes))

            # ________________________ VERIFICAÇÃO SE A PESSOA ESTA CADASTRADA COMO CLIENTE ____________________________
            cliente_ids = obj_cliente.search(cr, uid, [('company_id', '=', pedido_company_id),
                                                       ('pessoa_id', '=', pedido_pessoa_id)], context=context)
            if not cliente_ids and pedido_pessoa_id:
                obj_cliente.create(cr, uid, {'company_id': pedido_company_id, 'pessoa_id': pedido_pessoa_id}, context)

            parcela_ids = obj_pedido_parcela.search(cr, uid, [('pedido_id', '=', pedido_id)], context=context)
            if not parcela_ids:
                parcela_ids = self.button_parcelas(cr, uid, ids, context)

        # PEDIDO DE COMPRA
        elif pedido_tipo == 'C':
            # _________________________ VERIFICAÇÃO SE A QUANTIDADE DE PRAZO É IGUAL A QUANTIDADE DE PARCELAS
            pedido_prazos = browse_pedido.pedcap_prazo or ''
            pedido_prazos = pedido_prazos.replace(' ', '').replace('/', ',')
            list_prazos = pedido_prazos.split(',')

            total_parcelas_lancadas = len(map(lambda i: i.id, browse_pedido.pedido_compra_parcela_ids))
            if len(list_prazos) != total_parcelas_lancadas:
                raise osv.except_osv(_('Atencao'), _('A quantidade de parcelas inseridas no Pedido de Compra \
                                                   e diferente do prazo informado!'))
                # ________________________ VERIFICAÇÃO SE A PESSOA ESTA CADASTRADA COMO FORNECEDOR ____________________________
            financeiro_fornecedor_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(
                cr, uid, 'financeiro.fornecedor')
            fornecedor_ids = obj_financeiro_fornecedor.search(
                cr, uid, [('company_id', '=', financeiro_fornecedor_company_id),
                          ('pessoa_id', '=', pedido_pessoa_id)], context=context)
            if not fornecedor_ids:
                obj_financeiro_fornecedor.create(cr, uid, {'company_id': pedido_company_id, 'pessoa_id': pedido_pessoa_id}, context)

            parcela_ids = obj_pedido_parcela.search(cr, uid, [('pedido_compra_id', '=', pedido_id)], context=context)
            if not parcela_ids:
                parcela_ids = self.pedcap_button_parcelas_compra(cr, uid, ids, context)

        # __________________________ VERIFICAÇÃO SE O PEDIDO CONTEM ITENS ___________________________
        pedido_item_ids = map(lambda i: i.id, browse_pedido.pedido_item_ids)
        if not pedido_item_ids:
            raise osv.except_osv(_('Atencao'), _(
                'E necessario inserir itens no Pedido de %s!' % 'Venda' if pedido_tipo == 'V' else 'Compra'))

        # ____________________________ VERIFICAÇÃO SE O VALOR TOTAL DAS PARCELAS É IGUAL AO VALOR TOTAL DO PEDIDO ________________________________
        if not parcela_ids:
            raise osv.except_osv(_('Atencao'), _(
                'Nenhuma parcela cadastrada para o Pedido de %s' % 'Venda' if pedido_tipo == 'V' else 'Compra'))
        else:
            parcela_dados = obj_pedido_parcela.browse(cr, uid, parcela_ids)
            parcelas_valor_total = sum(map(lambda i: i.vr_parcela or 0.0, parcela_dados))
            pedido_condicao_ids = browse_pedido.pedido_condicao_ids or []
            if len(pedido_condicao_ids) == 1:
                parcelas_valor_total = pedido_valor_total or 0.0
                vals = {'valor': parcelas_valor_total}
                obj_estoquepedidos_pedido_condicao.write(cr, uid, pedido_condicao_ids[0].id, vals, context=context)
            if round(pedido_valor_total, 2) != round(parcelas_valor_total, 2):
                raise osv.except_osv(_('Atencao'), _('O valor das parcela(s) R$ ' + str(
                    parcelas_valor_total) + ' e diferente do valor total do Pedido R$ ' + str(pedido_valor_total)))

        list_grade_qtde = []
        modulo_madeireira_instalado = False
        if pedido_tipo == 'V':
            pedido_itens_dados = obj_estoquepedidos_pedido_item.browse(cr, uid, pedido_item_ids)
            list_local_ids = []
            for i in pedido_itens_dados:
                local_id = i.local_id.id
                if local_id:
                    list_local_ids.append(local_id)

            dict_local_saldo_negativo = obj_estoque_local.get_permite_saldo_negativo(cr, uid,
                                                                                                  list_local_ids,
                                                                                                  company_id=pedido_company_id,
                                                                                                  context=context)
            # lendo os itens
            log = ''
            log_produtos_sem_grades = ''
            reservar_qtde_pedida = True
            for item in pedido_itens_dados:
                # PEGA O PRODUTO_ID
                qtde_pedida_item = item.qtde_pedida

                data_item = [item]
                for i in data_item:
                    produto_id = i.produto_id.id or None
                    try:
                        qtd_embalagem = i.produto_embalagem_id.embalagem_id.quantidade_na_embalagem
                        qnt_real_item = i.qtde_pedida * qtd_embalagem  # quantidade pedida vezes quantidade da embalagem
                    except:
                        grade_id = i.grade_id.id or False
                        local_locacao_id = obj_estoque_local_locacao.search(cr, uid, [('produto_id', '=', produto_id),
                                                                                      ('grade_id', '=', grade_id),
                                                                                      ('company_id', '=',
                                                                                       pedido_company_id),
                                                                                      ('local_id', 'in',
                                                                                       list_local_ids)],
                                                                            context=context)
                        qtd_embalagem = 1.0
                        if local_locacao_id:
                            browse_local_locacao = obj_estoque_local_locacao.browse(cr, uid, local_locacao_id[0])
                            produto_embalagem_id = browse_local_locacao.estllc_produto_embalagem_id
                            if produto_embalagem_id:
                                embalagem_id = produto_embalagem_id.embalagem_id
                                if embalagem_id:
                                    qtd_embalagem = embalagem_id.quantidade_na_embalagem or 1.0
                        qnt_real_item = i.quantidade * qtd_embalagem * qtde_pedida_item  # quantidade pedida vezes quantidade da embalagem
                    produto_name = i.produto_id.name or ''
                    # VERIFICA SE EXISTE GRADE PARA O PRODUTO
                    if not i.grade_id.id:
                        log_produtos_sem_grades += _('* PRODUTO: %s sem GRADE cadastrada; ') % produto_name
                        reservar_qtde_pedida = False
                        continue
                        # PEGA A GRADE_ID
                    grade_id = i.grade_id.id or None
                    # LE O TIPO DO ITEM
                    if produto_id and grade_id:
                        tipo_produto = obj_estoque_produto.browse(cr, uid, produto_id).tipo or ''
                        # SE FOR PRODUTO
                        if tipo_produto == 'P':
                            try:
                                local_id = i.local_id.id or []
                                local_name = i.local_id.name or ''
                            except:
                                local_id = browse_local_locacao.local_id.id or []
                                local_name = browse_local_locacao.local_id.name or ''
                                # VERIFICA SE O LOCAL PERMITE SALDO NEGATIVO
                            aceita_saldo_negativo = dict_local_saldo_negativo.get(local_id) or False
                            # SE NÃO PERMITIR SALDO NEGATIVO

                            # BUSCA O SALDO DO DIA PARA O PRODUTO
                            saldo = obj_estoque_produto_saldo.get_saldo_do_dia(cr, uid,
                                                                               eps_grade_ids=grade_id,
                                                                               eps_data=str(date.today()),
                                                                               eps_local_id=local_id,
                                                                               context=context)
                            saldo = saldo.get(grade_id)
                            qtd_reservada = saldo.get('qtd_reservada')
                            saldo = saldo.get('saldo')
                            if not aceita_saldo_negativo:
                                # SE A QUANTIDADE PEDIDA FOR MAIOR QUE O SALDO DISPONÍVEL
                                if not obj_estoquepedidos_pedido_item. \
                                        pedite_valida_disponibilidade_saldo(saldo, qtd_reservada, i,
                                                                            qtd_embalagem):
                                    reservar_qtde_pedida = False
                                    _qt_disponivel = (saldo / qtd_embalagem) - (qtd_reservada /
                                                                                qtd_embalagem)
                                    log += obj_estoquepedidos_pedido_item. \
                                        pedite_get_mensagem_saldo_indisp(produto_name, local_name,
                                                                         i, _qt_disponivel)
                            list_grade_qtde.append({'grade_id': grade_id, 'item_qtde': qnt_real_item or 0,
                                                    'local_id': local_id, 'produto_id': produto_id})
                            #### VERIFICA SE EXISTEM ERROS
            modulo_madeireira_instalado = obj_adm_utils.admutl_check_modulo_instalado(cr, uid,
                                                                                                   'madeireira',
                                                                                                   context={})
            ## PRODUTOS SEM GRADES
            if log_produtos_sem_grades:
                raise osv.except_osv(_('Atencao'), (log_produtos_sem_grades))
            ## PRODUDOS COM SALDO INDISPONÍVEL
            elif log:
                raise osv.except_osv(_('Atencao'), (log))
        # Cliente (pessoa_id) nao eh mais obrigatorio no lancamento do pedido de venda. Porem, caso
        # seja informado ou ha condicoes a prazo, eh preciso gerar financeiro.
        if any(map(lambda con: con.condicao_forma_id.adm_condicao_id.tipo == 'C' and not
                   con.forma_pagto_id.cartao_credito_debito, pedido_condicao_ids)) \
                or pedido_pessoa_id:
            self.pedcap_gera_titulo_prv_financeiro(cr, uid, ids, context)
        context.update({'permite_alterar': True, 'pedcap_write_state': True})
        # grava status da capa para Validado
        res = self.write(cr, uid, ids, {'state': 'V'}, context)
        self.message_post(cr, uid, ids, _('Alteracao de Status'), _('Pedido Validado'))
        if obj_adm_utils.admutl_check_modulo_instalado(cr, uid, 'estoqueserie', context):
            _pedcap_button_validar_estoqueserie()
        if modulo_madeireira_instalado and list_grade_qtde and reservar_qtde_pedida:
            result = list_grade_qtde
        else:
            result = res
        return result

    def _pedcap_verifica_permissao_cancelamento(self, cr, uid, context=None):
        """
        O metodo verifica se o usuario logado possui permissao nos grupos manager dos modulos
        estoquepedidos e prime, como tambem se o parametro do estoque
        'estpar_so_admin_cancela_pedido' esta selecionado. Caso alguma dessas situacoes seja
        verdadeira - na ordem descrita - o usuario pode cancelar o pedido.
        :param cr: cursor no banco de dados.
        :type: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type: integer
        :param context: dicionario com valores contextuais.
        :type: dict
        :return: True, caso o usuario tenha permissao para cancelamento, senao, False.
        :rtype: bool
        """
        context = context and context.copy() or {}
        group_ids = self.pool.get('res.groups').search(
            cr, uid, [('name', 'in', ('Estoquepedidos / Manager', 'Prime / Manager'))],
            context=context)
        if len(group_ids) == 1:
            group_ids = str(tuple(group_ids)).replace(',', '')
        elif len(group_ids) > 1:
            group_ids = str(tuple(group_ids))
        sql = """
            SELECT gid
            FROM res_groups_users_rel
            WHERE uid = %s AND gid IN %s
        """ % (uid, group_ids or ())
        cr.execute(sql)
        if cr.dictfetchall():
            return True
        estoque_parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', 'estpar_so_admin_cancela_pedido', context=context)
        if not estoque_parametro_dados.get('estpar_so_admin_cancela_pedido'):
            return True
        return False

    def button_cancelar(self, cr, uid, ids, context=None):
        """
        Solicita o motivo de cancelamento se for pedido de venda.
        :param cr: cursor no banco de dados
        :param uid: registro da tebale res_users, identificador do usuario
        :param ids: lista de registros da tabela estoque_inventario_capa
        :param context: dicionario com valores contextuais
        :type cr: cursor
        :type uid: int
        :type ids: long|list[long]
        :type context: dict
        :return: verdadeiro se o pedido de venda foi cancelado.
        :rtype: bool

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}

        if not self._pedcap_verifica_permissao_cancelamento(cr, uid, context):
            raise osv.except_osv(_('Atencao'), _('Usuario nao possui permissao para cancelamento'))

        self.pedcap_check_state(cr, uid, ids, 'C', context)
        vendas_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(
            cr, uid, 'vendas', context)

        if vendas_instalado and context.get('view_name') == 'estoquepedidos_venda':
            obj_model_data = self.pool.get('ir.model.data')
            reference = obj_model_data.get_object_reference(
                cr, uid, 'vendas', 'view_estoquepedidos_motivo_cancelamento_form')
            view_id = reference and reference[1] or False

            return {'res_id': ids[0],
                    'name': 'Motivo cancelamento',
                    'view_type': 'form',
                    'view_mode': 'form',
                    'res_model': 'estoquepedidos.pedido.capa',
                    'view_id': [view_id],
                    'target': 'new',
                    'type': 'ir.actions.act_window',
                    }

        return self.pedcap_cancelar_pedido(cr, uid, ids, context)

    def pedcap_cancelar_pedido(self, cr, uid, ids, context=None):
        """
        Cancelamento de pedido.

        :param cr: cursor no banco de dados
        :param uid: registro da tebale res_users, identificador do usuario
        :param ids: lista de registros da tabela estoque_inventario_capa
        :param context: dicionario com valores contextuais
        :type cr: cursor
        :type uid: int
        :type ids: long|list[long]
        :type context: dict
        :return: verdadeiro se o pedido foi cancelado.
        :rtype: bool
        """

        context = context and context.copy() or {}
        pedcapa_dados = self.read(cr, uid, ids, ['state', 'numero_pedido', 'data_emissao', 'tipo'], context=context)
        obj_financeiro_titulo = self.pool.get('financeiro.titulo')
        obj_orcamentos_orcamento_capa = self.pool.get('orcamentos.orcamento.capa')

        if 'cancelar_nota_fiscal' not in context.keys():
            if 'pedcap_cancelamento' not in context.keys():
                context['pedcap_cancelamento'] = True

        for i in pedcapa_dados:
            id = i['id']
            state = i.get('state')

            # Exclui previsoes
            titulo_ids = obj_financeiro_titulo.search(
                cr, uid, [('documento', '=', i.get('numero_pedido')),
                          ('data_emissao', '=', i.get('data_emissao')),
                          ('doc_tipo_id.sigla', '=', 'PRV')], context=context)
            if titulo_ids:
                obj_financeiro_titulo.unlink(cr, uid, titulo_ids)

            # Cancela orcamentos, se pedido de venda
            if i.get('tipo') == 'V':
                orcamento_ids = obj_orcamentos_orcamento_capa.search(
                    cr, uid, [('pedido_id', '=', id)], context=context)

                for o_id in orcamento_ids:
                    obj_orcamentos_orcamento_capa.button_cancelado(cr, uid, o_id, context=context)

        self.message_post(cr, uid, ids, _('Alteracao de Status'), _('Pedido Cancelado'))

        # Grava status de cancelamento
        context.update({'pedcap_write_state': True})
        self.write(cr, uid, ids, {'state': 'C'}, context=context)

        return True

    def read(self, cr, uid, ids, fields=None, context=None, load='_classic_read'):
        context = context and context.copy() or {}
        if not fields:
            fields = []
        if isinstance(ids, (int, long)):
            ids = [ids]
        if fields and not 'numero_pedido' in fields:
            fields.append('numero_pedido')
        res = super(estoquepedidos_pedido_capa, self).read(cr, uid, ids, fields, context=context, load=load)
        madeireira_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(
            cr, uid, 'madeireira', context)
        if len(ids) == 1 and context and madeireira_instalado:
            numero_pedido = res[0].get('numero_pedido')
            obj_ir_translation = self.pool.get('ir.translation')
            translation_id = obj_ir_translation.search(
                cr, uid, [('src', '=', 'Impressao de Pedidos'), ('module', '=', 'madeireira')], context=context)
            if translation_id:
                obj_ir_translation.write(cr, uid, translation_id[0],
                                         {'value': numero_pedido, 'source': 'Impressao de Pedidos'}, context=context)
        return res

    def fields_view_get(self, cr, uid, view_id=None, view_type='form', context=None, toolbar=False,
                        submenu=False):
        def _pedcap_fields_view_get_compras(res, context):
            view_name = context.get('view_name')
            if view_name:
                if view_name != 'estoquepedidos_compra':
                    toolbar = res.get('toolbar')
                    if toolbar:
                        relate = toolbar.get('relate')
                        for x in relate:
                            res_model = x.get('res_model')
                            if res_model == 'estoque.produto.osv':
                                res['toolbar']['relate'].pop(relate.index(x))
            return res

        context = context and context.copy() or {}
        res = super(estoquepedidos_pedido_capa, self).fields_view_get(cr, uid, view_id, view_type,
                                                                      context, toolbar, submenu)
        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'compras', context):
            res = _pedcap_fields_view_get_compras(res, context)
        obj_ir_translation = self.pool.get('ir.translation')
        translation_id = obj_ir_translation.search(
            cr, uid, [('src', '=', 'Impressao de Pedidos'), ('module', '=', 'madeireira')], context=context)
        if translation_id:
            obj_ir_translation.write(cr, uid, translation_id[0],
                                     {'value': 'Impressao de Pedidos',
                                      'source': 'Impressao de Pedidos'}, context=context)
        return res

    def _pedcap_get_modelo_nf(self, cr, uid, id, context=None):
        """
        Metodo para ser sobrescrito por outros módulos. para informar o modelo da nf
        Se não houver, por default retorna False, porque não tendo especifico, o método gerar nf vai pegar no parametro
        :param cr:
        :param uid:
        :param id: id do pedido
        :param context:
        :return: modelo nf id or False
        """
        return False

    @log_debug
    def button_faturar_pedido(self, cr, uid, ids, context=None, destinatario_id=False, pedido_ids=[]):
        load = '_classic_write'

        def _pedcap_button_faturar_pedido_kit(cr, uid, ids, context):
            nf_id = []
            obj_adm_utils = self.pool.get('adm.utils')
            modulo_kit_categoria_instalado = obj_adm_utils.admutl_check_modulo_instalado(
                cr, uid, modulo='kit_categoria', context=context
            )
            fields_to_read = ['pedido_kit_item_ids', 'pedcap_nf_ids', 'tipo']
            if modulo_kit_categoria_instalado:
                fields_to_read.append('pedido_kit_categoria_ids')
                obj_kit_categoria_mov = self.pool.get('kit.categoria.movimento')
            else:
                obj_kit_categoria_mov = None
            pedido_dados = self.read(cr, uid, ids, fields_to_read, context=context, load=READ_LOAD)
            pedido_venda_dados = filter(lambda i: i.get('tipo') == 'V', pedido_dados)
            obj_kit_mov = self.pool.get('kit.movimento')
            for i in pedido_venda_dados:
                nf_ids = i.get('pedcap_nf_ids')
                kit_item_ids = i.get('pedido_kit_item_ids')
                kit_categoria_ids = i.get('pedido_kit_categoria_ids')
                if nf_ids:
                    nf_id = nf_ids[0]
                    if kit_item_ids:
                        values = {'kitmov_nf_id': nf_id}
                        obj_kit_mov.write(cr, uid, kit_item_ids, values, context=context)
                    if kit_categoria_ids and obj_kit_categoria_mov:
                        values = {'kitcatmov_nf_id': nf_id}
                        obj_kit_categoria_mov.write(cr, uid, kit_categoria_ids, values, context=context)
                # EH UTILIZADO O BREAK PORQUE UM PEDIDO IRA GERAR UMA UNICA NOTA FISCAL
                break
            if context.get('faturar_diversos_pedidos'):
                return nf_id
            return True

        def _pedcap_button_faturar_pedido_fiscal(cr, uid, dados_pedidos, context, destinatario_id, pedido_ids):
            self.pedcap_check_state(cr, uid, pedido_ids, 'F', context)
            context['fatura_pedido'] = True
            obj_adm_utils = self.pool.get('adm.utils')
            dict_pedidos = {}
            item_ids = []
            vendedor_ids = []
            dict_pedido_vendedor = {}
            for i in dados_pedidos:
                i.get('pedido_item_ids') and item_ids.extend(i.get('pedido_item_ids'))
                dict_pedidos.update({i.get('id'): i})
                i.get('vendedor_id') and vendedor_ids.append(i.get('vendedor_id'))
                dict_pedido_vendedor.update({i.get('id'): i.get('vendedor_id')})

            list_itens = []  # mudei para lista para nao perder a ordem que os itens foram adiciondos
            campos = ['qtde_atendida', 'qtde_pedida', 'produto_id', 'vr_desconto', 'grade_id',
                      'local_id', 'vendedor_id', 'vendedor_externo_id', 'produto_embalagem_id',
                      'vr_desconto', 'valor_total', 'vr_unitario','pei_preco_venda',
                      'pedite_pedido_cliente_nro', 'pedite_pedido_cliente_linha', 'pedite_volume',
                      'pedite_comprimento', 'pedite_largura', 'pedite_espessura',
                      'pedite_kit_produto_id', 'pedite_despesas', 'pedido_id']

            produto_ids = []
            for i in  self.pool.get('estoquepedidos.pedido.item').read(cr, uid, item_ids, campos,
                                                                       context, load):
                i['vendedor_id'] = i.get('vendedor_id') or dict_pedido_vendedor.get(
                    i.get('pedido_id'))
                del i['pedido_id']
                list_itens.append(i)
                produto_ids.append(i.get('produto_id'))
                i.get('vendedor_id') and vendedor_ids.append(i.get('vendedor_id'))

            dict_produtos = {}
            map(lambda x: dict_produtos.update({x.get('id'): x}),
                self.pool.get('estoque.produto').read(cr, uid, produto_ids, ['tipo'], context))

            dict_vendedores = {}
            if vendedor_ids:
                map(lambda x: dict_vendedores.update({x.get('id'): x}),
                    self.pool.get('vendas.vendedor').read(cr, uid, vendedor_ids,
                                                          ['venven_evento_id'], context, load))
            dados_pedido = dados_pedidos[0]
            observacao_pedido = ''

            if not context.get('faturar_diversos_pedidos'):
                status_pedido = dados_pedido.get('state') or ''
                if status_pedido == 'F':
                    raise osv.except_osv(_('Atencao'), _('O pedido ja foi faturado!'))

                # Em pedidos de venda, verifica se vendedor tem evento cadastrado se o parametro do
                # Financeiro "Usar centro de custo e evento" estiver marcado
                parametro_financeiro_dados = obj_adm_utils.admutl_get_parametros(
                    cr, uid, 'financeiro', ['usar_centro_custos_e_eventos'], context=context)
                if parametro_financeiro_dados.get('usar_centro_custos_e_eventos'):
                    vendedor = dict_vendedores.get(dados_pedido.get('vendedor_id')) or {}
                    if vendedor:
                        if not vendedor.get('venven_evento_id'):
                            raise osv.except_osv(_('Atencao!'),
                                                 _('O vendedor nao possui evento cadastrado.'))

                observacao_pedido += dados_pedido.get('observacao') or ''
                # data_entrega = dados_pedido.get('data_entrega')
                # if data_entrega:
                #     data_entrega += str(datetime.strftime(datetime.now(), " %H:%M:%S"))
            else:
                for p in dados_pedidos:
                    vendedor = dict_vendedores.get(p.get('vendedor_id')) or {}
                    status_pedido = p.get('state') or ''
                    if status_pedido == 'F':
                        raise osv.except_osv(_('Atencao'),
                                             _('O pedido %s ja foi faturado!' %
                                               p.get('numero_pedido')))

                    # Em pedidos de venda, verifica se vendedor tem evento cadastrado se o
                    # parametro do Financeiro "Usar centro de custo e evento" estiver marcado
                    parametro_financeiro_dados = obj_adm_utils.admutl_get_parametros(
                        cr, uid, 'financeiro', ['usar_centro_custos_e_eventos'], context=context)
                    if parametro_financeiro_dados.get('usar_centro_custos_e_eventos'):
                        if vendedor and not vendedor.get('venven_evento_id'):
                            raise osv.except_osv(_('Atencao!'),
                                                 _('O vendedor nao possui evento cadastrado.'))

                    observacao_pedido += '\n' + (p.get('observacao') or '')

            company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name,
                                                                        context=context)
            pessoa_id = self.pool.get('res.users').read(cr, uid, uid, ['pessoa_id'], context,
                                                        load).get('pessoa_id')
            if not pessoa_id:
                raise osv.except_osv(_('Atencao'), _('Pessoa nao cadastrada para o usuario!'))

            obj_rh_funcionario = self.pool.get('rh.funcionario')
            if not obj_rh_funcionario.search(
                    cr, uid, [('pessoa', '=', pessoa_id)], context=context):
                raise osv.except_osv(_('Atencao'),
                                     _('Voce tem que se cadastrar como um Funcionario...'))
            pars_estoque = obj_adm_utils.admutl_get_parametros(
                cr, uid, 'estoque.parametro', ['estpar_pedido_separar'], context=context)
            pars_fiscais = obj_adm_utils.admutl_get_parametros(
                cr, uid, 'fiscal.parametro', [
                    'fispar_nota_conjugada', 'fispar_natureza_uf_dentro_venda_servico_id',
                    'fispar_natureza_uf_fora_venda_servico_id', 'modelo_nf_series_id'],
                context=context)
            separacao_pedido = pars_estoque.get('estpar_pedido_separar')
            nota_conjugada = False
            natureza_servico_dentro_estado, natureza_servico_fora_estado = False, False

            if not list_itens:
                raise osv.except_osv(_('Atencao'), _('Nao ha itens para gerar a NF.'))

            # Se no pedido tiver apenas itens com qtd atendida = zero, nao gerar a nf
            itens_qtd_atendida = map(lambda i: i.get('qtde_atendida'), list_itens)
            if not any(itens_qtd_atendida) and separacao_pedido:
                raise osv.except_osv(_('Atencao'),
                                     _('Nenhum item do pedido possui quantidade atendida.'))

            existe_servico = False
            tipo_item = []
            for i in list_itens:
                tipo = dict_produtos.get(i.get('produto_id')).get('tipo')
                tipo_item.append(tipo)
                if tipo == 'S':
                    existe_servico = True

            if existe_servico:
                nota_conjugada = pars_fiscais.get('fispar_nota_conjugada')
                natureza_servico_dentro_estado = \
                    pars_fiscais.get('fispar_natureza_uf_dentro_venda_servico_id')
                natureza_servico_fora_estado = \
                    pars_fiscais.get('fispar_natureza_uf_fora_venda_servico_id')

            obj_estoque_movimento_capa = self.pool.get('estoque.movimento.capa')
            obj_fiscal_nf_capa = self.pool.get('fiscal.nf.capa')
            obj_fiscal_utils = self.pool.get('fiscal.utils')
            obj_pessoa = self.pool.get('adm.pessoa')
            obj_adm_pessoa_endereco = self.pool.get('adm.pessoa.endereco')
            pessoa_id = dados_pedido.get('pessoa_id') if not context.get(
                'faturar_diversos_pedidos') else destinatario_id

            # Ao faturar o pedido o endereco sempre serah o informado no pedido
            id_end = dados_pedido.get('pedcap_endereco_id')

            # LOCALIZA NATUREZA
            estado_emitente = None
            nf_destinatario_id = pessoa_id
            uf_id = id_end and obj_adm_pessoa_endereco.read(cr, uid, id_end, ['uf_id'], context,
                                                             load).get('uf_id') or False
            estado_destinatario = False
            if uf_id:
                estado_destinatario = self.pool.get('adm.uf').read(cr, uid, uf_id, ['sigla'],
                                                                   context).get('sigla') or False
            msg = ''
            modelo_nf_serie_id = pars_fiscais.get('modelo_nf_series_id')
            nota_gerencial = False
            if modelo_nf_serie_id and self.pool.get('fiscal.modelo.nf.series').browse(cr, uid,
                        modelo_nf_serie_id, context).modelo_nf_id.fismnf_codigo >= '90':
                nota_gerencial = True
            if not context.get('faturar_pedido_nfce') and not estado_destinatario and \
                    not nota_gerencial:
                msg += _('Nao existe estado informado para o endereco da nota fiscal.\n')

            dados_company = self.pool.get('res.company').read(cr, uid, company_id,
                                                                ['rescon_pessoa_id'], context, load)
            dados_pessoa_company = {}
            if dados_company.get('rescon_pessoa_id'):
                campos = ['endereco_nf_id', 'endereco_ids']
                dados_pessoa_company = obj_pessoa.read(cr, uid,
                                       dados_company.get('rescon_pessoa_id'), campos, context, load)

            endereco_emitente_id = dados_pessoa_company.get('endereco_nf_id')
            if endereco_emitente_id:
                uf_id = obj_adm_pessoa_endereco.read(cr, uid, endereco_emitente_id,
                                               ['uf_id'], context, load).get('uf_id') or  False
                estado_emitente = self.pool.get('adm.uf').read(cr, uid, uf_id, ['sigla'],
                                                               context).get('sigla') or False
                if not estado_emitente:
                    msg += _('Nao existe estado informado para o endereco do emitente.\n')

            else:
                estado_emitente = False
                for x in obj_adm_pessoa_endereco.browse(cr, uid,
                                                 dados_pessoa_company.get('endereco_ids'), context):
                    if x.endereco_tipo_id.name == 'Comercial':
                        estado_emitente = x.uf_id.sigla
                        break

                    if x.endereco_tipo_id.name == 'Normal':
                        estado_emitente = x.uf_id.sigla
                        continue
                if not estado_emitente:
                    raise osv.except_osv(_('Atencao'),
                                         _('Cadastre um endereco valido para a empresa.'))
            if msg:
                raise osv.except_osv(_('Atencao'), msg)

            # Recupera a Natureza
            pars_fiscais = obj_adm_utils.admutl_get_parametros(
                cr, uid, 'fiscal.parametro', ['fispar_natureza_uf_dentro_venda_id',
                                              'fispar_natureza_uf_fora_venda_id',
                                              'fispar_gera_nfe_esboco'], context=context)
            if context.get('faturar_pedido_nfce') or estado_destinatario == estado_emitente:
                nf_natureza_id = pars_fiscais.get('fispar_natureza_uf_dentro_venda_id')
                nf_natureza_servico_id = natureza_servico_dentro_estado
                if not nf_natureza_id:
                    raise osv.except_osv(_('Atencao!'),
                                         _('A natureza de venda para dentro do estado nao '
                                           'se encontra cadastrada no parametro do Fiscal.'))
                if existe_servico and not nota_conjugada and not nf_natureza_servico_id:
                    raise osv.except_osv(_('Atencao!'),
                                         _('A natureza de venda/servico para dentro do estado '
                                           'nao se encontra cadastrada no parametro do Fiscal.'))
            else:
                nf_natureza_id = pars_fiscais.get('fispar_natureza_uf_fora_venda_id')
                nf_natureza_servico_id = natureza_servico_fora_estado
                if not nf_natureza_id:
                    raise osv.except_osv(_('Atencao!'),
                                         _('A natureza de venda para fora do estado nao se '
                                           'encontra cadastrada no parametro do Fiscal.'))
                if existe_servico and not nota_conjugada and not nf_natureza_servico_id:
                    raise osv.except_osv(_('Atencao!'),
                                         _('A natureza de venda/servico para fora do estado nao '
                                           'se encontra cadastrada no parametro do Fiscal.'))

            if nf_natureza_id and \
                    not self.pool.get('fiscal.cfop.natureza').read(cr, uid, nf_natureza_id, ['active'],
                                                               context):
                raise osv.except_osv(_('Atencao!'),
                                     _('A natureza cadastrada no parametro do Fiscal esta '
                                       'inativa no seu cadastro!'))
            condicao_tipo = ''
            str_pedido_ids = (','.join(map(lambda x: '%s' % x, pedido_ids)))

            # Se a nota nao for conjugada, desconsidera o filtro abaixo
            if tipo_item and 'P' in tipo_item:
                condicao_tipo = ''' 'P' '''
            if tipo_item and 'S' in tipo_item:
                if condicao_tipo and nota_conjugada:
                    condicao_tipo += ''' ,'S' '''
                elif not condicao_tipo:
                    condicao_tipo = ''' 'S' '''
            if condicao_tipo:
                condicao_tipo = ''' AND ep.tipo in (%s) ''' % (condicao_tipo)
            sql_forma_cond = '''
                            SELECT sum(epcon.valor) as valor,
                                   epcon.condicao_forma_id,
                                   epcon.pedcdc_nro_autorizacao_cartao AS aut_cartao,
                                   epcon.forma_pagto_id,
                                   epcon.pedcdc_chq_banco,
                                   epcon.pedcdc_chq_agencia,
                                   epcon.pedcdc_chq_numero,
                                   epcon.pedcdc_chq_conta,
                                   epcon.pedcdc_chq_emitente,
                                   (CASE WHEN epcon.pedcdc_flag_pgto_chq
                                    THEN 'CH'
                                    ELSE ''
                                    END) AS sigla_forma_pagamento
                            FROM estoquepedidos_pedido_capa epc
                                LEFT JOIN estoquepedidos_pedido_condicao AS epcon ON epcon.capa_id = epc.id
                            WHERE epc.id IN (%s)
                            GROUP BY epcon.condicao_forma_id,
                                     epcon.pedcdc_nro_autorizacao_cartao,
                                     epcon.forma_pagto_id,
                                     epcon.pedcdc_chq_banco,
                                     epcon.pedcdc_chq_agencia,
                                     epcon.pedcdc_chq_numero,
                                     epcon.pedcdc_chq_conta,
                                     epcon.pedcdc_chq_emitente,
                                     epcon.pedcdc_flag_pgto_chq
                            ORDER BY epcon.condicao_forma_id, epcon.forma_pagto_id
                              ''' % str_pedido_ids
            sql_prod_serv = '''
                SELECT sum(epi.valor_total - epc.vr_desconto  * epi.valor_total /
                          (epc.valor_total+epc.vr_desconto - 
                           COALESCE(epc.vr_despesas_acessorias, 0) - 
                           COALESCE(epc.vr_seguro, 0) - 
                           COALESCE(epc.vr_frete, 0) - %s))    as valor
                FROM estoquepedidos_pedido_capa epc
                LEFT JOIN estoquepedidos_pedido_item AS epi ON epi.pedido_id = epc.id
                LEFT JOIN estoque_produto AS ep ON ep.id = epi.produto_id
                WHERE epc.id IN (%s)
                %s
                            '''
            sql_parcelas = '''
                                SELECT epcon.condicao_forma_id,
                                       epcon.pedcdc_nro_autorizacao_cartao AS aut_cartao,
                                       epcon.forma_pagto_id,
                                       epcon.pedcdc_flag_pgto_chq,
                                       epcon.pedcdc_chq_numero,
                                       CASE
                                           WHEN epc.data_emissao = epp.data_vencimento
                                               THEN CURRENT_DATE
                                           ELSE
                                               epp.data_vencimento
                                       END                 AS data_vencimento,
                                       SUM(epp.vr_parcela) AS vr_parcela
                                FROM estoquepedidos_pedido_capa epc
                                LEFT JOIN estoquepedidos_pedido_condicao AS epcon ON epcon.capa_id = epc.id
                                LEFT JOIN estoquepedidos_pedido_parcela  AS epp   ON epp.pedido_condicao_id = epcon.id
                                WHERE epc.id IN (%s)
                                GROUP BY epcon.forma_pagto_id,
                                         epcon.condicao_forma_id,
                                         epcon.pedcdc_nro_autorizacao_cartao,
                                         epcon.pedcdc_flag_pgto_chq,
                                         epcon.pedcdc_chq_numero,
                                         epp.data_vencimento,
                                         epc.data_emissao
                                ORDER BY epp.data_vencimento
                           '''
            cr.execute(sql_forma_cond)
            dados_condicao = cr.dictfetchall()
            cr.execute(sql_parcelas % str_pedido_ids)
            dados_parcelas = cr.dictfetchall()
            despesas_acessorias = 0
            seguro = 0
            frete = 0
            ipi = 0
            transportador_ids = []
            list_placa = []
            list_frete = []
            for ped in dados_pedidos:
                despesas_acessorias += ped.get('vr_despesas_acessorias') or 0
                seguro += ped.get('vr_seguro') or 0
                frete += ped.get('vr_frete') or 0
                ipi += ped.get('pedcap_valor_ipi') or 0
                if ped.get('transportador_id'):
                    transportador_ids.append(ped.get('transportador_id'))
                ped.get('pedcap_placa') and list_placa.append(ped.get('pedcap_placa'))
                ped.get('frete') and list_frete.append(ped.get('frete'))

            transportador_ids = list(set(transportador_ids))
            list_placa = list(set(list_placa))
            if nota_conjugada:
                cr.execute(sql_prod_serv % (ipi, str_pedido_ids, condicao_tipo))
                dados_prod_serv = cr.dictfetchall()
                total_prod_serv = dados_prod_serv[0].get('valor') or 0
                total_prod_serv += despesas_acessorias + seguro + frete + ipi
            else:
                cr.execute(sql_prod_serv % (ipi, str_pedido_ids, '''AND ep.tipo = 'P' '''))
                dados_produto = cr.dictfetchall()
                cr.execute(sql_prod_serv % (ipi, str_pedido_ids, '''AND ep.tipo = 'S' '''))
                dados_servico = cr.dictfetchall()
                valor_produtos = dados_produto[0].get('valor') or 0
                valor_servicos = dados_servico[0].get('valor') or 0
                if valor_produtos:
                    valor_produtos += despesas_acessorias + seguro + frete + ipi
                else:
                    valor_servicos += despesas_acessorias + seguro + frete + ipi
            if not dados_condicao:
                raise osv.except_osv(_('Atencao!'), _('Condicao de pagamento nao cadastrada.'))
            lista_condicoes = []  # condicoes de produto e servico juntos quando a nota eh conjugada
            lista_condicoes_produto = []
            lista_condicoes_servicos = []
            vals = {}  # valores de produto e servico juntos quando a nota eh conjugada
            vals_produto = {}
            vals_servico = {}
            if nota_conjugada:
                # Produtos e servicos
                dict_forma_condicao = {}
                lista_valor_conds_rateado = map(
                    lambda x: [str(x.get('condicao_forma_id')) + '-' +
                               str(x.get('forma_pagto_id')), x.get('valor')]
                    if not x.get('pedcdc_chq_numero') else [
                        str(x.get('condicao_forma_id')) + '-' + str(x.get('forma_pagto_id')) +
                        '-' + str(x.get('pedcdc_chq_numero')), x.get('valor')], dados_condicao)
                lista_valor_conds_rateado = obj_adm_utils.efetuar_rateio(
                    total_prod_serv, lista_valor_conds_rateado)
                for cond in dados_condicao:
                    # Quando for cheque, a chave deve conter o numero do cheque para nao juntar as
                    # condicoes repetidas
                    if not cond.get('pedcdc_chq_numero'):
                        chave = str(cond.get('condicao_forma_id')) + '-' + \
                                str(cond.get('forma_pagto_id'))
                        lista_parcelas = map(lambda x: [
                            x.get('data_vencimento'),x.get('vr_parcela')]
                        if chave==str(x.get('condicao_forma_id'))+ '-' +
                           str(x.get('forma_pagto_id')) else [], dados_parcelas)
                    else:
                        chave = str(cond.get('condicao_forma_id')) + '-' + \
                                str(cond.get('forma_pagto_id')) + \
                                '-' + str(cond.get('pedcdc_chq_numero'))
                        lista_parcelas = map(lambda x: [
                            x.get('data_vencimento'),x.get('vr_parcela')]
                        if chave== str(x.get('condicao_forma_id'))+ '-' +
                           str(x.get('forma_pagto_id')) + '-' + str(x.get('pedcdc_chq_numero'))
                        else [], dados_parcelas)

                    aux_parcelas = {}
                    # soma as parcelas da mesma condicao com a mesma data de vencimento
                    for i in lista_parcelas:
                        if not i:
                            continue

                        if not aux_parcelas.get(i[0]):
                            aux_parcelas[i[0]] = i[1]
                        else:
                            aux_parcelas[i[0]] += i[1]

                    lista_parcelas = map(lambda x: [x[0], x[1]], aux_parcelas.items())
                    valor = 0.0
                    for i in lista_valor_conds_rateado:
                        if chave == i[0]:
                            valor = i[1]
                            break
                    if not dict_forma_condicao.get(chave):
                        vals = {'condicao_forma_id': cond.get('condicao_forma_id'),
                                'fiscpg_nro_autorizacao_cartao': cond.get('aut_cartao'),
                                'forma_pagto_id': cond.get('forma_pagto_id'),
                                'valor': valor or 0.0,
                                'fiscpg_chq_banco': cond.get('pedcdc_chq_banco') or 0,
                                'fiscpg_chq_agencia': cond.get('pedcdc_chq_agencia') or 0,
                                'fiscpg_chq_numero': cond.get('pedcdc_chq_numero') or '',
                                'fiscpg_chq_conta': cond.get('pedcdc_chq_conta') or '',
                                'fiscpg_chq_emitente': cond.get('pedcdc_chq_emitente') or '',
                                'fiscpg_forma_pagamento_cheque': cond.get('pedcdc_flag_pgto_chq'),
                                'nf_parcela_ids': [],
                                }
                    lista_parcelas = obj_adm_utils.efetuar_rateio(valor, lista_parcelas)
                    for parc in lista_parcelas:
                        vals_parcelas = {'active': True,
                                         'valor': parc[1],
                                         'vencimento': parc[0]
                                         }
                        vals['nf_parcela_ids'].append([0, False, vals_parcelas])
                    dict_forma_condicao[chave] = vals
                for chave in dict_forma_condicao:
                    lista_condicoes.append([0, False, dict_forma_condicao.get(chave)])
            else:  # Nota nao conjugada
                # produtos
                if valor_produtos:
                    dict_forma_condicao = {}
                    lista_valor_conds_rateado = map(
                        lambda x: [str(x.get('condicao_forma_id')) + '-' +
                                   str(x.get('forma_pagto_id')), x.get('valor')]
                        if not x.get('pedcdc_chq_numero')
                        else [str(x.get('condicao_forma_id')) + '-' +
                              str(x.get('forma_pagto_id')) + '-' +
                              str(x.get('pedcdc_chq_numero')), x.get('valor')], dados_condicao)
                    lista_valor_conds_rateado = obj_adm_utils.efetuar_rateio(
                        valor_produtos, lista_valor_conds_rateado)
                    for cond in dados_condicao:
                        # Quando for cheque, a chave deve conter o numero do cheque para nao juntar
                        # as condicoes repetidas
                        if not cond.get('pedcdc_chq_numero'):
                            chave = str(cond.get('condicao_forma_id')) + '-' + str(cond.get('forma_pagto_id'))
                            lista_parcelas = map(lambda x: [x.get('data_vencimento'),x.get('vr_parcela')]
                                                       if chave==str(x.get('condicao_forma_id'))+ '-' +
                                                                 str(x.get('forma_pagto_id')) else [], dados_parcelas)
                        else:
                            chave = str(cond.get('condicao_forma_id')) + '-' + str(cond.get('forma_pagto_id')) + \
                                        '-' + str(cond.get('pedcdc_chq_numero'))
                            lista_parcelas = map(lambda x: [x.get('data_vencimento'),x.get('vr_parcela')]
                                                           if chave== str(x.get('condicao_forma_id'))+ '-' +
                                                                      str(x.get('forma_pagto_id')) + '-' +
                                                                      str(x.get('pedcdc_chq_numero'))
                                                           else [], dados_parcelas)

                        aux_parcelas = {}
                        # soma as parcelas da mesma condicao com a mesma data de vencimento
                        for i in lista_parcelas:
                            if not i:
                                continue

                            if not aux_parcelas.get(i[0]):
                                aux_parcelas[i[0]] = i[1]
                            else:
                                aux_parcelas[i[0]] += i[1]

                        lista_parcelas = map(lambda x: [x[0], x[1]], aux_parcelas.items())
                        valor = 0.0
                        for i in lista_valor_conds_rateado:
                            if chave == i[0]:
                                valor = i[1]
                                break
                        if not dict_forma_condicao.get(chave):
                            vals_produto = {
                                'condicao_forma_id': cond.get('condicao_forma_id'),
                                'fiscpg_nro_autorizacao_cartao': cond.get('aut_cartao'),
                                'forma_pagto_id': cond.get('forma_pagto_id'),
                                'valor': valor or 0.0,
                                'nf_parcela_ids': [],}

                            # Quando tiver produto e servico, o cheque nao pode ser dividido para
                            # as duas notas
                            if not valor_servicos:
                                vals_produto['fiscpg_chq_banco'] = cond.get('pedcdc_chq_banco') or 0
                                vals_produto['fiscpg_chq_agencia'] = cond.get('pedcdc_chq_agencia') or 0
                                vals_produto['fiscpg_chq_numero'] = cond.get('pedcdc_chq_numero') or ''
                                vals_produto['fiscpg_chq_conta'] = cond.get('pedcdc_chq_conta') or ''
                                vals_produto['fiscpg_chq_emitente'] = cond.get('pedcdc_chq_emitente') or ''
                                vals_produto['fiscpg_forma_pagamento_cheque'] = cond.get('pedcdc_flag_pgto_chq')

                        for parc in obj_adm_utils.efetuar_rateio(valor, lista_parcelas):
                            vals_parcelas = {'active': True,
                                             'valor': parc[1],
                                             'vencimento': parc[0]
                                             }
                            vals_produto['nf_parcela_ids'].append((0, 0, vals_parcelas))
                        dict_forma_condicao[chave] = vals_produto
                    for chave in dict_forma_condicao:
                        lista_condicoes_produto.append([0, False, dict_forma_condicao.get(chave)])
                if valor_servicos:
                    # servicos
                    dict_forma_condicao = {}
                    lista_valor_conds_rateado = map(lambda x: [str(x.get('condicao_forma_id')) + '-' +
                                                               str(x.get('forma_pagto_id')), x.get('valor')]
                                                               if not x.get('pedcdc_chq_numero')
                                                               else [str(x.get('condicao_forma_id')) + '-' +
                                                               str(x.get('forma_pagto_id')) + '-' +
                                                               str(x.get('pedcdc_chq_numero')), x.get('valor')],
                                                    dados_condicao)
                    lista_valor_conds_rateado = obj_adm_utils.efetuar_rateio(valor_servicos,
                                                                                          lista_valor_conds_rateado)
                    for cond in dados_condicao:
                        # quando for cheque, a chave deve conter o numero do cheque para nao juntar as condicoes repetidas
                        if not cond.get('pedcdc_chq_numero'):
                            chave = str(cond.get('condicao_forma_id')) + '-' + str(cond.get('forma_pagto_id'))
                            lista_parcelas = map(lambda x: [x.get('data_vencimento'),x.get('vr_parcela')]
                                                       if chave==str(x.get('condicao_forma_id'))+ '-' +
                                                                 str(x.get('forma_pagto_id')) else [], dados_parcelas)
                        else:
                            chave = str(cond.get('condicao_forma_id')) + '-' + str(cond.get('forma_pagto_id')) + \
                                        '-' + str(cond.get('pedcdc_chq_numero'))
                            lista_parcelas = map(lambda x: [x.get('data_vencimento'),x.get('vr_parcela')]
                                                           if chave== str(x.get('condicao_forma_id'))+ '-' +
                                                                      str(x.get('forma_pagto_id')) + '-' +
                                                                      str(x.get('pedcdc_chq_numero'))
                                                           else [], dados_parcelas)

                        aux_parcelas = {}
                        # soma as parcelas da mesma condicao com a mesma data de vencimento
                        for i in lista_parcelas:
                            if not i:
                                continue

                            if not aux_parcelas.get(i[0]):
                                aux_parcelas[i[0]] = i[1]
                            else:
                                aux_parcelas[i[0]] += i[1]

                        lista_parcelas = map(lambda x: [x[0], x[1]], aux_parcelas.items())
                        valor = 0.0
                        for i in lista_valor_conds_rateado:
                            if chave == i[0]:
                                valor = i[1]
                                break
                        if not dict_forma_condicao.get(chave):
                            vals_servico = {
                                'condicao_forma_id': cond.get('condicao_forma_id'),
                                'fiscpg_nro_autorizacao_cartao': cond.get('aut_cartao'),
                                'forma_pagto_id': cond.get('forma_pagto_id'),
                                'valor': valor or 0.0,
                                'nf_parcela_ids': [],}
                            # Quando tiver produto e servico, o cheque nao pode ser dividido para
                            # as duas notas
                            if not valor_produtos:
                                vals_servico['fiscpg_chq_banco'] = cond.get('pedcdc_chq_banco') or 0
                                vals_servico['fiscpg_chq_agencia'] = cond.get('pedcdc_chq_agencia') or 0
                                vals_servico['fiscpg_chq_numero'] = cond.get('pedcdc_chq_numero') or ''
                                vals_servico['fiscpg_chq_conta'] = cond.get('pedcdc_chq_conta') or ''
                                vals_servico['fiscpg_chq_emitente'] = cond.get('pedcdc_chq_emitente') or ''
                                vals_servico['fiscpg_forma_pagamento_cheque'] = cond.get('pedcdc_flag_pgto_chq')

                        for parc in obj_adm_utils.efetuar_rateio(valor, lista_parcelas):
                            vals_parcelas = {'active': True,
                                             'valor': parc[1],
                                             'vencimento': parc[0]
                                             }
                            vals_servico['nf_parcela_ids'].append((0, 0, vals_parcelas))
                        dict_forma_condicao[chave] = vals_servico
                    for chave in dict_forma_condicao:
                        lista_condicoes_servicos.append((0, 0, dict_forma_condicao.get(chave)))

            nf_vr_desconto_itens = 0
            if context.get('faturar_diversos_pedidos'):
                nf_vr_desconto, nf_vr_seguro, nf_vr_desp_acessorias, nf_vr_frete = 0, 0, 0, 0
                for x in dados_pedidos:
                    nf_vr_desconto += x.get('vr_desconto') or 0
                    nf_vr_seguro += x.get('vr_seguro') or 0
                    nf_vr_desp_acessorias += x.get('vr_despesas_acessorias') or 0
                    nf_vr_frete += x.get('vr_frete') or 0

                nf_vendedor_id = False
                nf_vendedor_externo_id = False
            else:
                nf_vr_desconto = dados_pedido.get('vr_desconto') or 0.0
                nf_vr_seguro = dados_pedido.get('vr_seguro') or 0.0
                nf_vr_desp_acessorias = dados_pedido.get('vr_despesas_acessorias') or 0.0
                nf_vr_frete = dados_pedido.get('vr_frete') or 0.0
                nf_vendedor_id = dados_pedido.get('vendedor_id') or False
                nf_vendedor_externo_id = dados_pedido.get('vendedor_externo_id') or False


            if nf_vr_desconto and nf_vr_desconto_itens:
                context['pedcap_desconto_ja_concedido'] = True

            for item in list_itens:
                nf_vr_desconto_itens += item.get('vr_desconto') or 0

                # Verificacao modulo madeireira
            modulo_madeireira_instalado = obj_adm_utils.admutl_check_modulo_instalado(cr, uid,
                                                                           'madeireira', context={})
            if modulo_madeireira_instalado:
                context.update({'modulo_madeireira_instalado': True, 'calculo_com_volume': True})

            if not context.get('faturar_diversos_pedidos'):
                nf_pedido_id = dados_pedido.get('id')
                if dados_pedido.get('tipo') == 'C':
                    nf_tipo = 'E'
                    context['nota_fiscal_entrada'] = True
                else:
                    nf_tipo = 'S'
                    context['nota_fiscal_saida'] = True
            else:
                if context.get('tipo') == 'C':
                    nf_tipo = 'E'
                    context['nota_fiscal_entrada'] = True
                else:
                    nf_tipo = 'S'
                    context['nota_fiscal_saida'] = True

            # CREATE ESTOQUE NF CAPA
            context['proprio'] = True
            if not lista_condicoes and lista_condicoes_produto:
                lista_condicoes = lista_condicoes_produto


            # CRIA OS ITENS DA NOTA FISCAL
            modulo_serie_instalado = obj_adm_utils.admutl_check_modulo_instalado(cr, uid, 'estoqueserie',
                                                                                              context)
            if modulo_serie_instalado:
                obj_serie_movimento = self.pool.get('estoqueserie.movimento')
            modulo_kit_instalado = obj_adm_utils.admutl_check_modulo_instalado(
                cr, uid, 'kit', context)

            diferenca_quantidade = False
            nf_itens_produto = []
            nf_itens_servico = []
            sequencia = 1
            for item in list_itens:
                pedido_item_id = item.get('id')
                context['pedido_item_id'] = pedido_item_id
                grade_id = item.get('grade_id') or False
                local_id = item.get('local_id') or False
                item_vendedor_id = item.get('vendedor_id') or dict_pedidos.get('vendedor_id') or False
                item_vendedor_externo_id = item.get('vendedor_externo_id') or False
                produto_embalagem_id = item.get('produto_embalagem_id') or False
                preco_venda = item.get('pei_preco_venda') or 0.0
                # Usar a qtd atendida como quantidade para a nf. Se ela for zero nao gerar o item.
                mov_item_id = False
                qtd_atendida = item.get('qtde_atendida') or 0
                qtd_pedida = item.get('qtde_pedida') or 0
                # Se no parametro estiver marcado que nao vai trabalhar com separacao, forcar antes de gerar o item da nf para que a qtd atendida seja igual a pedida
                if not separacao_pedido:
                    qtd_atendida = qtd_pedida
                if qtd_atendida:
                    # Se houver diferenca entre quantidade pedida e quantidade atendida, esta diferenca deve ser diminuida da reserva.
                    if qtd_atendida != qtd_pedida:
                        diferenca_quantidade = True
                        quantidade = qtd_atendida - qtd_pedida
                        if quantidade < 0:
                            quantidade *= -1
                    xPed = item.get('pedite_pedido_cliente_nro') or dados_pedido.get('pedcap_nro_pedido_externo')
                    skyhub_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'marketplace_skyhub', context)
                    if skyhub_instalado and xPed > 15 and '-' in xPed:
                        xPed = xPed.split('-')[1]
                    vals_itens = dict(produto_id=item.get('produto_id'),
                                      local_id=local_id,
                                      produto_embalagem_id=produto_embalagem_id,
                                      grade_id=grade_id,
                                      natureza_id=nf_natureza_id,
                                      quantidade=qtd_atendida,
                                      vr_desconto=item.get('vr_desconto') or 0.0,
                                      vr_unitario=item.get('vr_unitario') or 0.0,
                                      vendedor_id=item_vendedor_id,
                                      vendedor_externo_id=item_vendedor_externo_id,
                                      vr_total_item=item.get('valor_total'),
                                      estmvi_pedido_cliente_nro=xPed,
                                      estmvi_pedido_cliente_linha=item.get('pedite_pedido_cliente_linha'),
                                      sequencia=sequencia,
                                      vr_despesas_rateado=item.get('pedite_despesas') or 0,
                                      )
                    sequencia += 1
                    vals_medidas_volume = {}
                    if modulo_madeireira_instalado:
                        context.update({'calculo_com_volume': True})
                        vals_medidas_volume.update(
                            {'estmvi_comprimento': item.get('pedite_comprimento'),
                             'estmvi_largura': item.get('pedite_largura'),
                             'estmvi_espessura': item.get('pedite_espessura'),
                             'estmvi_volume': item.get('pedite_volume')
                             })
                        vals_itens['estmvi_comprimento'] = item.get('pedite_comprimento') or 0.0
                        vals_itens['estmvi_largura'] = item.get('pedite_largura') or 0.0
                        vals_itens['estmvi_espessura'] = item.get('pedite_espessura') or 0.0
                    if modulo_kit_instalado:
                        if item.get('pedite_kit_produto_id'):
                            vals_itens['estmvi_kit_produto_id'] = item.get('pedite_kit_produto_id')

                    # nota nao conjugada contendo produto e servico
                    produto = dict_produtos.get(item.get('produto_id'))
                    if produto.get('tipo') == 'S' and not nota_conjugada:
                        nf_itens_servico.append([0, False, vals_itens])
                    else:
                        nf_itens_produto.append([0, False, vals_itens])
                else:
                    diferenca_quantidade = True
                # podendo assim executar a funcao abaixo
                if modulo_serie_instalado and pedido_item_id and mov_item_id:
                    produto_serie_ids = obj_serie_movimento.search(cr, uid,
                                                                   [('esemov_pedido_item_id', '=', pedido_item_id)],
                                                                   context=context)
                    if produto_serie_ids:
                        # se o contexto for passado no write nao deve conter a chave 'listagem_series_produto',
                        # pois isso indicaria que a alteracao esta sendo feita da tela de lancamento de series,
                        # presente nos itens do pedido e na nota fiscal. Quando a alteracao vem desta tela,
                        # o id utilizado e o active_id do contexto.
                        obj_serie_movimento.write(cr, uid, produto_serie_ids,
                                                  {'esemov_movimento_itens_id': mov_item_id}, context=context)

            nf_id = ''
            context_nota = context.copy()
            context_nota['ctx_nf_propria'] = True
            if lista_condicoes:  # nota conjugada ou nota nao conjugada com produto
                nf_id = obj_fiscal_utils.gerar_nf(
                    cr, uid, company_id=company_id,
                    destinatario_id=nf_destinatario_id,
                    natureza_id=nf_natureza_id,
                    nf_condicao_ids=lista_condicoes,
                    tipo=nf_tipo,
                    modelo_nf_id=self._pedcap_get_modelo_nf(cr, uid, pedido_ids[0], context=context),
                    end_entrega=False,
                    end_coleta=False,
                    numero_nf=False,
                    serie_nf=False,
                    vendedor_id=nf_vendedor_id,
                    vendedor_externo_id=nf_vendedor_externo_id,
                    vr_desconto=nf_vr_desconto,
                    vr_seguro=nf_vr_seguro,
                    vr_despesas_acessorias=nf_vr_desp_acessorias,
                    vr_frete=nf_vr_frete,
                    tipo_frete='D', # frete sempre por dentro no pedido
                    estoque_movimento_itens_ids=nf_itens_produto,
                    nota_pedido_ids=[nf_pedido_id] if not context.get(
                      'faturar_diversos_pedidos') else pedido_ids,
                    destinatario_endereco_id=dados_pedido.get('pedcap_endereco_id'),
                    context=context_nota)

            nf_servico_id = False
            if lista_condicoes_servicos: # nota nao conjugada com servico
                context_servico = {'nf_servico': True, 'ctx_nf_servico': True}
                context_servico.update(context_nota)
                pedido_endereco_id = dados_pedido.get('pedcap_endereco_id') or False
                nf_servico_id = obj_fiscal_utils.gerar_nf(
                    cr, uid, company_id=company_id,
                    destinatario_id=nf_destinatario_id,
                    natureza_id=nf_natureza_servico_id,
                    nf_condicao_ids=lista_condicoes_servicos,
                    tipo=nf_tipo,
                    vendedor_id=nf_vendedor_id,
                    vendedor_externo_id=nf_vendedor_externo_id,
                    vr_desconto=nf_vr_desconto,
                    vr_seguro=nf_vr_seguro,
                    estoque_movimento_itens_ids=nf_itens_servico,
                    vr_despesas_acessorias=nf_vr_desp_acessorias,
                    vr_frete=nf_vr_frete,
                    nota_pedido_ids=[nf_pedido_id] if not context.get(
                        'faturar_diversos_pedidos') else pedido_ids,
                    destinatario_endereco_id=pedido_endereco_id,
                    context=context_servico)
            # nota nao conjugada sem produto, apenas com servico
            if nf_servico_id and not nf_id:
                nf_id = nf_servico_id
                nf_servico_id = False
            if not nf_id:
                raise osv.except_osv(_('Atencao'), _('A Nota Fiscal nao foi gerada!'))
            context['super_write_fiscal_nf_capa'] = True
            vals_nf = {'fisnfc_infcomp_contribuinte': observacao_pedido}
            if context.get('faturar_pedido_nfce'):
                vals_nf.update({'finalidade_emissao': '1', 'nfe_forma_emissao': '1'})
            if len(transportador_ids) == 1:
                vals_nf.update({'transportador_id': transportador_ids[0]})
            len(list_placa) == 1 and vals_nf.update({'fisnfc_placa_frete': list_placa[0]})
            len(list_frete) == 1 and vals_nf.update({'frete': '0' if list_frete[0] == 'C' else '1'})

            obj_fiscal_nf_capa.write(cr, uid, nf_id, vals_nf, context=context)
            context['super_write_fiscal_nf_capa']=True
            context_n = context.copy()
            context_n['super_write_fiscal_nf_capa'] = True
            obj_fiscal_nf_capa.write(cr,uid, nf_id, {'fisnfc_infcomp_contribuinte':observacao_pedido}, context=context_n)
            obj_liberar_restricoes = self.pool.get('venlre.liberar.restricoes')
            liberar_restricoes_ids = obj_liberar_restricoes.search(cr, uid,
                                            [('venlre_pedido_id', 'in', [pedido_ids] if not isinstance(pedido_ids, list) else pedido_ids)])
            if liberar_restricoes_ids:
                vals_restricao_venda = {
                    'venlre_nf_id': nf_id,
                }
                obj_liberar_restricoes.write(cr, uid, liberar_restricoes_ids[0], vals_restricao_venda, context)
            if nf_natureza_id:
                fisnat_operacao_id = self.pool.get('fiscal.cfop.natureza').read(cr, uid,
                                                    nf_natureza_id, ['fisnat_operacao_id'], context,
                                                                     load).get('fisnat_operacao_id')
                if fisnat_operacao_id:
                    vals_movimento_capa = {'estmvc_operacao_id': fisnat_operacao_id}
                    mov_capa_ids = obj_estoque_movimento_capa.search(cr, uid, [('nf_capa_id','=', nf_id)])
                    obj_estoque_movimento_capa.write(cr, uid, mov_capa_ids,vals_movimento_capa, context=context)
                    if nf_servico_id and not nota_conjugada:
                        vals_movimento_capa.update({'nf_capa_id': nf_servico_id})
                        mov_capa_ids = obj_estoque_movimento_capa.search(cr, uid, [('nf_capa_id','=', nf_servico_id)])
                        obj_estoque_movimento_capa.write(cr, uid, mov_capa_ids,vals_movimento_capa, context=context)

            data_faturamento = obj_adm_utils.admutl_converte_tz(cr, uid,
                                                      datetime.now(), 'UTC', context=context).date()
            if context.get('faturar_diversos_pedidos'):
                ids = pedido_ids
                for i in ids:
                    res = self.write(cr, uid, i, {
                        'state': 'F',
                        'pedcap_nf_ids': [(6, 0, [nf_id])],
                        'pedcap_data_faturamento': data_faturamento
                    }, context=context)
                    self.message_post(cr, uid, i, _('Alteracao de Status'), _('Pedido Faturado'))
            else:
                ids = map(lambda x: x.get('id'), dados_pedidos)
                nf_ids = [nf_id]
                if nf_servico_id:
                    nf_ids.append(nf_servico_id)
                res = self.write(cr, uid, pedido_ids, {
                    'state': 'F',
                    'pedcap_nf_ids': [(6, 0, nf_ids)],
                    'pedcap_data_faturamento': data_faturamento
                }, context=context)
                self.message_post(cr, uid, pedido_ids, _('Alteracao de Status'),
                                  _('Pedido Faturado'))

            arg_valor_liberar = ('venauv_pedido_id', 'in', ids) if isinstance(ids, (list, tuple)) else (
                'venauv_pedido_id', '=', ids)
            autorizacao_capa_id = self.pool.get('vendas.liberar.desconto').search(cr, uid, [arg_valor_liberar],
                                                                                  context=context)
            if autorizacao_capa_id:
                vals_autorizacao = {
                    'venauv_nf_id': nf_id,
                }
                self.pool.get('vendas.liberar.desconto').write(cr, uid, autorizacao_capa_id, vals_autorizacao, context)
            context['criar'] = 'parcelas'
            if diferenca_quantidade:
                context['pedcap_gerando_nf'] = True

            # Verificar nota
            nota_id = [nf_id] if not isinstance(nf_id, list) else nf_id
            if not pars_fiscais.get('fispar_gera_nfe_esboco') or \
                    context.get('nota_fiscal_consumidor'):
                    obj_fiscal_nf_capa.fisnfc_verificar_nota_fiscal(cr, uid, nf_id, context=context)
                    obj_fiscal_nf_capa.fisnfc_validar_nota_fiscal(cr, uid, nf_id, context=context)
                    obj_fiscal_nf_capa.write(cr, uid, nota_id, {'state': '2'}, context=context_n)
                    if context.get('pedcap_simplificado'):
                        obj_fiscal_nf_capa.button_faturar(cr, uid, nota_id, context)
                    if nf_servico_id:
                        obj_fiscal_nf_capa.fisnfc_verificar_nota_fiscal(
                            cr, uid, nf_servico_id, context=context)
                        obj_fiscal_nf_capa.fisnfc_validar_nota_fiscal(
                            cr, uid, nf_servico_id, context=context)
                        obj_fiscal_nf_capa.write(
                            cr, uid, nf_servico_id, {'state': '2'}, context=context_n)

            if res or context.get('button_faturar_form'):
                if context.get('faturar_diversos_pedidos'):
                    return nf_id
                context['nf_id'] = nf_id
                if not obj_fiscal_nf_capa.read(cr, uid, nf_id, ['nf_parcelas_ids'], context
                                               ).get('nf_parcelas_ids'):
                    obj_fiscal_nf_capa.button_parcelas(cr, uid, nf_id)

                obj_fiscal_nf_capa.write(cr, uid, nf_id, {}, context=context)
                if nf_servico_id:
                    context['nf_id'] = nf_servico_id
                    obj_fiscal_nf_capa.button_parcelas(cr, uid, nf_servico_id)
                    obj_fiscal_nf_capa.write(cr, uid, nf_servico_id, {}, context=context)

                return self.abrir_nf_pedido(cr, uid, dados_pedidos, context=context)
            else:
                return res

        obj_produto = self.pool.get('estoque.produto')
        # Se houver condicoes a prazo, verifica se ha restricoes para o cliente.
        obj_pedido_utils = self.pool.get('pedido.utils')
        campos = ['pedido_item_ids', 'vendedor_id', 'state', 'vr_despesas_acessorias',
                  'vr_seguro', 'vr_frete', 'pedcap_valor_ipi', 'vr_desconto','pedido_condicao_ids',
                  'transportador_id', 'observacao', 'data_entrega', 'pessoa_id',
                  'pedcap_endereco_id', 'vendedor_externo_id', 'tipo', 'numero_pedido',
                  'pedcap_placa', 'frete', 'pedcap_nro_pedido_externo']
        if not pedido_ids:
            pedido_ids = ids

        dados_pedidos = self.read(cr, uid, ids, campos, context, load)
        pedido_sem_cliente = ''
        condicao_ids = []
        for i in dados_pedidos:
            condicao_ids.extend(i.get('pedido_condicao_ids'))
            if not i.get('pessoa_id'):
                pedido_sem_cliente += i.get('numero_pedido') + '\n'
        if not context.get('faturar_pedido_nfce') and pedido_sem_cliente:
            obj_adm_utils = self.pool.get('adm.utils')
            modelo_nf_serie_id = obj_adm_utils.admutl_get_parametros(cr, uid, 'fiscal.parametro',
                                ['modelo_nf_series_id'], context=context).get('modelo_nf_series_id')
            if not modelo_nf_serie_id  or self.pool.get('fiscal.modelo.nf.series').browse(cr, uid,
                        modelo_nf_serie_id, context).modelo_nf_id.fismnf_codigo < '90':
                raise osv.except_osv(_('Atencao'), _('O cliente deve ser informado para os pedidos '
                                                     'a seguir:\n' + pedido_sem_cliente))

        dict_condicoes = {}
        cond_forma_ids = []
        forma_pgto_ids = []
        campos = ['condicao_forma_id', 'forma_pagto_id']
        for i in self.pool.get('estoquepedidos.pedido.condicao').read(cr, uid, condicao_ids, campos,
                                                                      context, load):
            dict_condicoes[i.get('id')] = i
            cond_forma_ids.append(i.get('condicao_forma_id'))
            forma_pgto_ids.append(i.get('forma_pagto_id'))

        dict_cond_forma = {}
        adm_condicao_ids = []
        campos = ['adm_condicao_id']
        for i in self.pool.get('adm.condicao.forma').read(cr, uid, cond_forma_ids, campos, context,
                                                          load):
            dict_cond_forma[i.get('id')] = i
            adm_condicao_ids.append(i.get('adm_condicao_id'))

        dict_forma_pgto = {}
        campos = ['cartao_credito_debito']
        for i in self.pool.get('adm.forma.pgto').read(cr, uid, forma_pgto_ids, campos, context,
                                                          load):
            dict_forma_pgto[i.get('id')] = i

        dict_adm_condicao = {}
        map(lambda x: dict_adm_condicao.update({x.get('id'): x}),
            self.pool.get('adm.condicao').read(cr, uid, adm_condicao_ids, ['tipo'],
                                               context))

        erro_pedido_ids = []
        for pedido in dados_pedidos:
            if not pedido.get('pedido_condicao_ids'):
                continue

            for condicao_id in pedido.get('pedido_condicao_ids'):
                condicao = dict_condicoes.get(condicao_id)
                cond_forma = dict_cond_forma.get(condicao.get('condicao_forma_id'))
                forma_pgto = dict_forma_pgto.get(condicao.get('forma_pagto_id'))
                adm_condicao = dict_adm_condicao.get(cond_forma.get('adm_condicao_id'))
                if not forma_pgto.get('cartao_credito_debito') and adm_condicao.get('tipo') not in (
                        'V', 'S'):
                    erro_pedido_ids.append(pedido.get('id'))
                    break


        if erro_pedido_ids and not obj_pedido_utils.pedutl_restricao_venda(cr, uid, erro_pedido_ids,
                                                                           context):
            raise osv.except_osv(_('Erro na validacao do pedido'),
                                 _(obj_pedido_utils.pedutl_get_erro()))

        context = context and context.copy() or {}
        context[
            'fintit_titulo_sem_custificacao'] = True  # nao precisa de custificacao pois este titulo esta em previsao
        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'fiscal', context):
            res = _pedcap_button_faturar_pedido_fiscal(cr, uid, dados_pedidos, context,
                                                       destinatario_id, pedido_ids)

        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'kit', context):
            res = _pedcap_button_faturar_pedido_kit(cr, uid, ids, context)

        # Exclui os pedidos em previsao do pedido
        self.pedcap_exclui_titulo_prv_financeiro(cr, uid, ids, context)

        # Funcionalidade especifica para o pedido simplificado. Ao faturar pedido, ja realizar a
        # impressao, de acordo com parametro do estoque, aba 'Pedido'.
        self.pedcap_simplificado_realiza_impressao(cr, uid, ids, context)

        if context.get('faturar_diversos_pedidos'):
            return res

        return True

    @log_debug
    def pedcap_simplificado_realiza_impressao(self, cr, uid, ids, context=None):
        """
        O metodo realiza a impressao do pedido simplificado. Impressao fisica.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: id da tabela desse objeto.
        :type ids: list
        :param context: dados contextuais.
        :type context: dict
        :return: Verdadeiro, caso o pedido tenha sido impresso. Senao, Falso.
        :rtype: bool
        """
        context = context and context.copy() or {}
        if not context.get('pedcap_simplificado'):
            return False
        estoquepedidos_pedido_dados = self.read(cr, uid, ids, ['numero_pedido'], context)
        if isinstance(estoquepedidos_pedido_dados, list):
            estoquepedidos_pedido_dados = estoquepedidos_pedido_dados[0]
        numero_pedido = estoquepedidos_pedido_dados.get('numero_pedido') or ''
        dados_parametro = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque',
            ['estpar_impressora_pedido', 'estpar_pedido_formato_impressao',
             'estpar_pedido_retrato_paisagem', 'estpar_vias_pedido'], context=context)
        formato_impressao = dados_parametro.get('estpar_pedido_formato_impressao')
        modo = dados_parametro.get('estpar_pedido_retrato_paisagem')
        estpar_impressora_pedido = dados_parametro.get('estpar_impressora_pedido')
        quantidade_vias = "-n" + str(dados_parametro.get('estpar_vias_pedido') or 1)
        aleatorio = random_name()
        documento = 'report.pedido.' + numero_pedido
        documento += aleatorio
        obj_ir_act_report_xml = self.pool.get('ir.actions.report.xml')
        report_id = obj_ir_act_report_xml.search(
            cr, uid, [('report_name', '=', 'estoquepedidos.pedido.capa')], context=context)
        report_xml = obj_ir_act_report_xml.browse(cr, uid, report_id[0])
        report_pdf = False
        path = '/estoquepedidos/report/rel_estoquepedidos2.rml'
        self.pool.get('estoque.parametro').estpar_converte_formato_impressao(
            cr, uid, formato_impressao, path, 'p', modo)
        if formato_impressao == '3':  # bobina
            if isinstance(ids, (list, tuple)):
                ids = ids[0]

            context.update({'active_id': ids,
                            'active_ids': [ids],
                            'active_model': 'estoquepedidos.pedido.capa'})
            from ..report.rel_estoquepedidos2 import rel_estoquepedidos2
            rel_estoquepedidos2(cr, uid, self.browse(cr, uid, ids, context).numero_pedido,
                                context)
            return True

        if not context.get('impressao_pedido'):
            context.update({'impressao_pedido': True, 'active_ids': ids})
            report_pdf = report_sxw.report_sxw(
                documento, 'estoquepedidos.pedido.capa',
                'estoquepedidos/report/rel_estoquepedidos2.rml',
                parser=rel_estoquepedidos_simplificado).create_single_pdf(
                cr, uid, ids, {'report_type': 'pdf'}, report_xml, context)
            del context['active_ids']
        if report_pdf and estpar_impressora_pedido:
            p = open('/tmp/%s.pdf' % documento, 'wb')
            p.write(report_pdf[0])
            p.close()
            impressora = "-d" + estpar_impressora_pedido
            subprocess.call(
                ["lp", quantidade_vias, impressora, "/tmp/%s.pdf" % documento])
            subprocess.call(['rm', "/tmp/%s.pdf" % documento])
        return True

    def pedcap_simp_onchange_produto(self, cr, uid, ids, produto_id, context=None):
        context = context and context.copy() or {}
        context['retorno_sem_codigo'] = True
        res = {'value': {'pedcap_simp_grade_id': False}}
        if not produto_id:
            return res
        # BUSCAR A GRADE SE FOR UNICA
        grade_ids = self.pool.get('estoque.produto.grade').search(
            cr, uid, [('produto_id', '=', produto_id)], context=context)
        res['value']['pedcap_simp_grade_id'] = grade_ids[0] if grade_ids and len(
            grade_ids) == 1 else False
        return res

    def pedcap_simp_onchange_grade(self, cr, uid, ids, company_id, produto_id, grade_id,
                                   quantidade, item_ids, context=None):
        context = context and context.copy() or {}
        res = {}
        if not all([grade_id, quantidade]):
            return res
        value = {'pedcap_simp_produto_id': False, 'pedcap_simp_grade_id': False}
        produto_preco_venda = self.pool.get('estoque.preco.venda').get_preco_venda(
            cr, uid, produto_id, epc_grade_ids=grade_id, epc_company_id=company_id)
        dados_preco_venda = produto_preco_venda.get(produto_id) or {}
        preco_venda = dados_preco_venda.get(grade_id) or dados_preco_venda.get('preco_venda')
        if not preco_venda:
            produto_dados = self.pool.get('estoque.produto').read(cr, uid, produto_id, ['name'],
                                                                  context=context)
            if isinstance(produto_dados, list):
                produto_dados = produto_dados[0]
            produto_name = produto_dados.get('name') or ''
            return {
                'warning': {'title': _('Atencao'),
                            'message': _('O produto: %s, nao possui preco de venda '
                                         'cadastrado!') % produto_name},
                'value': value
            }

        local_id = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', 'local_venda_padrao_id', context=context).get(
            'local_venda_padrao_id')
        if not local_id:
            return {
                'warning': {'title': _('Atencao'),
                            'message': _('Local para saida nao cadastrado nos parametros do '
                                         'estoque')},
                'value': value
            }
        produto_embalagem_id = self.pool.get('estoquepedidos.pedido.item').get_local_embalagem(
            cr, uid, local_id, produto_id, grade_id)
        vals_pedido_item = {
            'produto_id': produto_id,
            'grade_id': grade_id,
            'qtde_pedida': quantidade,
            'vr_unitario': preco_venda,
            'pei_preco_venda': preco_venda,
            'local_id': local_id,
            'produto_embalagem_id': produto_embalagem_id
        }
        item_ids.append([0, False, vals_pedido_item])
        value.update({'pedido_item_ids': item_ids})
        res['value'] = value
        return res

    def pedcap_onchange_percentual_desconto_capa(self, cr, uid, ids, percentual, frete, ipi,
                                                 context=None):
        """
        Calcula o valor do desconto e o valor total do pedido em funcao do desconto, frete e IPI.

        :param cr: a linha atual do cursor do banco de dados
        :param uid: o ID do usuario utilizado para a verificacao de perfil
        :param ids: lista de registros da tabela estoque_inventario_capa
        :param percentual: o valor percentual utilizado no calculo do desconto
        :param frete: o valor do frete
        :param ipi: o valor do IPI
        :param context: um dicionario padrao para valores contextuais,
        :type cr: object
        :type uid: int
        :type ids: long|list[long]
        :type percentual: float
        :type frete: float
        :type ipi: float
        :type context: dict
        :return: o valor total dos itens
        :rtype: float
        """

        context = context and context.copy() or {}

        # ___________________________ Objects ________________________________
        obj_pedido_item = self.pool.get('estoquepedidos.pedido.item')

        if percentual < 0:
            return {'value': {'pedcap_percentual_desconto': 0.0},
                    'warning': {'title': _('Atencao'), 'message': _('Desconto invalido')}}

        # Recupera ID dos itens do pedido
        args = [('pedido_id', 'in', ids if isinstance(ids, list) else [ids])]
        item_ids = obj_pedido_item.search(cr, uid, args, context=context)

        # Valor total dos itens
        valor_total_itens = obj_pedido_item.calcula_total_items_pedido(cr, uid, item_ids, context)

        # Valor do desconto e total do pedido em funcao do percentual do desconto
        desconto = (valor_total_itens + frete + ipi) * percentual / 100.0
        valor_total_pedido = valor_total_itens + frete + ipi - desconto
        result = dict(value=dict(vr_desconto=desconto, valor_total=valor_total_pedido))

        return result

    def pedcap_button_ajustar_quantidade(self, cr, uid, ids, context=None):
        """
        O método ajusta a quantidade pedida do item para que fique igual a quantidade atendida.
        Como essa alteração afeta o valor das condições de pagamento já definidas, o método também
        as recalculará.
        :param cr:
        :param uid:
        :param ids:
        :param context:
        :return:
        """
        context = context and context.copy() or {}
        res = True
        brw_pedido_capa = self.browse(cr, uid, ids, context)
        # Objetos
        obj_estoquepedidos_pedido_item = self.pool.get('estoquepedidos.pedido.item')
        obj_estoquepedidos_pedido_condicao = self.pool.get('estoquepedidos.pedido.condicao')
        obj_estoque_produto_saldo = self.pool.get('estoque.produto.saldo')
        # Lista das condicoes de pagamento definidas
        brw_pedido_condicao = []
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'estoquepedido.pedido.capa')
        map(lambda i: brw_pedido_condicao.extend(i.pedido_condicao_ids), brw_pedido_capa)
        # Total dos pedidos antes do ajuste nas quantidades
        total_inicial = sum(map(lambda i: i.valor, brw_pedido_condicao))
        # Dicionario cuja chave representa o id da condicao e seu valor representa qual a proporcao
        # dessa condicao no total do pedido (percentual)
        dict_percentual_condicao = {}
        map(lambda i: dict_percentual_condicao.update({i.id: i.valor / total_inicial}),
            brw_pedido_condicao)
        # Lista de ids de estoquepedidos_pedido_condicao
        pedido_condicao_ids = []
        map(lambda i: pedido_condicao_ids.append(i.id), brw_pedido_condicao)
        # Percorre os pedidos e seus itens para identificar quantidades atendidas diferente de
        # pedidas. Identificando diferenca, atualiza o item.
        for pedido in brw_pedido_capa:
            brw_pedido_item = pedido.pedido_item_ids
            brw_pedido_item_divergente = filter(lambda i: i.qtde_pedida != i.qtde_atendida,
                                                brw_pedido_item)
            for item in brw_pedido_item_divergente:
                qtde_atendida = item.qtde_atendida
                qtde_reservada = item.qtde_pedida - qtde_atendida
                obj_estoquepedidos_pedido_item.write(cr, uid, item.id,
                                                     {'qtde_pedida': qtde_atendida}, context)
                qtde_atendida
        # Total dos pedidos apos o ajuste nas quantidades
        dados_total_final = self._pedcap_get_field_stored(cr, uid, ids, None, None, context)
        total_final = sum(map(lambda vt: vt.get('valor_total'), dados_total_final.values()))
        # Percorre as condicoes de pagamento atualizando-as proporcionalmente de acordo com o novo
        # valor do pedido
        for condicao in brw_pedido_condicao:
            valor = total_final * dict_percentual_condicao.get(condicao.id)
            obj_estoquepedidos_pedido_condicao.write(cr, uid, condicao.id, {'valor': valor},
                                                     context)
        # Atualizacao do pedido para recalculos, como o total do pedido
        self.write(cr, uid, ids, {}, context)
        # Contexto passado para que as parcelas sejam excluidas e recriadas. Normalmente as
        # parcelas nao podem ser excluidas. Esse contexto ja e verificado no metodo button_parcelas
        context.update({'criar': True})
        self.button_parcelas(cr, uid, ids, context)
        return res

    @synchronized_method
    def pedcap_button_imprimir(self, cr, uid, ids, context=None):
        '''
        Imprime o pedido
        :param cr:
        :param uid:
        :param ids:
        :param context:
        :return:
        '''
        context = context and context.copy() or {}
        context.update({'pedcap_pedido_venda_convertido': True})
        self.write(cr, uid, ids, {'pedcap_ja_impresso': True}, context)

        dados_parametro = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', ['estpar_pedido_formato_impressao',
                                 'estpar_pedido_retrato_paisagem'])
        formato = dados_parametro.get('estpar_pedido_formato_impressao')
        modo = dados_parametro.get('estpar_pedido_retrato_paisagem')
        path = '/estoquepedidos/report/rel_estoquepedidos2.rml'
        self.pool.get('estoque.parametro').estpar_converte_formato_impressao(cr, uid, formato, path,
                                                                             'p', modo)
        if isinstance(ids, (list, tuple)):
            ids = ids[0]

        if context.get('active_id'): # limpa o id quando o pedido vem do orcamento
            context.update({'active_id': ids,
                            'active_ids': [ids],
                            'active_model': 'estoquepedidos.pedido.capa'})
        return {
                'type': 'ir.actions.report.xml',
                'report_name': 'estoquepedidos.pedido.capa',
                'name': self.browse(cr, uid, ids, context).numero_pedido,
                'context': context
        }

    def pedcap_button_print_confirm(self, cr, uid, ids, context=None):
        """
        Metodo chamado por botao da view, faz a chamada do metodo responsavel pela impressao do
        pedido.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: chamada do metodo que realiza a impressao do arquivo PDF.
        :rtype: dict
        """
        context = context and context.copy() or {}
        return self.pedcap_button_imprimir(cr, uid, ids, context)


    def pedcap_gera_titulo_prv_financeiro(self, cr, uid, ids, context=None):
        """
        Gera titulo em previsao no financeiro

        :param cr: a Vinha atual do cursor do banco de dados
        :param uid: ID do usuario utilizado para a verificacao de perfil
        :param ids: lista com o ID dos pedidos
        :param context: um dicionario padrao para valores contextuais
        :type cr: cursor
        :type uid: int
        :type ids: list[long]
        :type context: dict
        :rtype: long
        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        context = context and context.copy() or {}
        context[
            'fintit_titulo_sem_custificacao'] = True  # nao precisa de custificacao pois este titulo esta em previsao
        res = False
        # Instanciado objetos
        obj_adm_utl = self.pool.get('adm.utils')
        obj_estped_par = self.pool.get('estoquepedidos.pedido.parcela')
        obj_doc_doc = self.pool.get('documento.documento.tipo')

        read_pedido = self.read(cr, uid, ids, context=context)
        fields_to_read_finpar = ['moeda_id', 'local_cobranca_id']
        parametros_dados = obj_adm_utl.admutl_get_parametros(cr, uid, 'financeiro',
                                                             fields_to_read_finpar)

        moeda_id = parametros_dados.get('moeda_id', False)
        localcobranca_id = parametros_dados.get('local_cobranca_id', False)
        doc_tipo_id = obj_doc_doc.search(cr, uid, [('sigla', '=', 'PRV')], context=context)[0]
        # Gerar titulos em previsao apenas para pedidos de venda
        for pedido_capa in read_pedido:
            tipo = pedido_capa['tipo']
            vals_titulo = {}
            pessoa_id = pedido_capa.get('pessoa_id')
            if isinstance(pessoa_id, (list, tuple)):
                pessoa_id = pessoa_id[0]
            if tipo == 'V':
                tipo_titulo = 'R'
            else:
                tipo_titulo = 'P'
            vals_titulo['fintit_pedido_id'] = pedido_capa.get('id')
            vals_titulo['company_id'] = pedido_capa.get('company_id')
            vals_titulo['pessoa_id'] = pessoa_id
            vals_titulo['local_cobranca_id'] = localcobranca_id
            vals_titulo['natureza_cobranca_id'] = ''
            vals_titulo['moeda_id'] = moeda_id
            vals_titulo['state'] = 'A'
            vals_titulo['tipo_lancamento'] = 'A'
            vals_titulo['doc_tipo_id'] = doc_tipo_id
            vals_titulo['data_emissao'] = pedido_capa.get('data_emissao')
            vals_titulo['tipo_titulo'] = tipo_titulo
            vals_titulo['documento'] = pedido_capa['numero_pedido']
            vals_titulo['fatura_id'] = False
            if tipo == 'V':
                parcela_ids = pedido_capa.get('pedido_parcela_ids', [])
            else:
                parcela_ids = pedido_capa.get('pedido_compra_parcela_ids', [])
            if parcela_ids:
                for parcela in obj_estped_par.browse(cr, uid, parcela_ids):
                    if parcela.pedido_condicao_id and \
                            parcela.pedido_condicao_id.forma_pagto_id.sigla == 'DN' and not \
                            pessoa_id:
                        continue
                    vals_titulo['pessoa_id'] = pessoa_id
                    vals_titulo['data_vencimento'] = parcela.data_vencimento
                    vals_titulo['vr_original'] = parcela.vr_parcela
                    vals_titulo['saldo'] = parcela.vr_parcela
                    if parcela.pedido_condicao_id:
                        forma_pgto_cartao = parcela.pedido_condicao_id.forma_pagto_id. \
                            cartao_credito_debito
                        if forma_pgto_cartao:
                            oper_cartao = parcela.pedido_condicao_id.forma_pagto_id. \
                                admfpg_cartao_pessoa_id.id
                            vals_titulo['pessoa_id'] = oper_cartao
                            condicao_forma_id = parcela.pedido_condicao_id.condicao_forma_id.id
                            self.pedcap_crete_titulo_prv_taxa_cartao(cr, uid, condicao_forma_id,
                                                                     vals_titulo, context)
                    res = self.pedcap_criar_titulo(cr, uid, vals_titulo, context)
            else:
                vals_titulo['data_vencimento'] = pedido_capa['data_emissao']
                vals_titulo['vr_original'] = pedido_capa.get('valor_total')
                vals_titulo['saldo'] = pedido_capa.get('valor_total')
                res = self.pedcap_criar_titulo(cr, uid, vals_titulo, context)
        return res

    def pedcap_crete_titulo_prv_taxa_cartao(self, cr, uid, condicao_forma_id, vals, context):
        """
        Gera titulo em previsao para as formas que possuem taxa no financeiro

        :param cr: a Vinha atual do cursor do banco de dados
        :param uid: ID do usuario utilizado para a verificacao de perfil
        :param condicao_forma_id: ID da forma de pagamento
        :param vals: Dicionario contendo os valores do titulo de origem da taxa
        :param context: um dicionario padrao para valores contextuais
        :type cr: cursor
        :type uid: int
        :type condicao_forma_id: long
        :type vals: dict
        :type context: dict
        :rtype: long
        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        # Instanciando objetos
        obj_adm_cond_forma = self.pool.get('adm.condicao.forma')
        context = context and context.copy() or {}
        vals_taxa_cartao = vals.copy()
        if not isinstance(condicao_forma_id, list):
            condicao_forma_id = [condicao_forma_id]
        res = True
        for condicao in obj_adm_cond_forma.browse(cr, uid, condicao_forma_id, context):
            if condicao.taxa > 0.0:
                taxa = condicao.taxa
                vals_taxa_cartao['tipo_titulo'] = 'P'
                vr_original = vals.get('vr_original', 0.0)
                saldo = vals.get('saldo', 0.0)
                vals_taxa_cartao['vr_original'] = vr_original * (taxa / 100)
                vals_taxa_cartao['saldo'] = saldo * (taxa / 100)
                res = self.pedcap_criar_titulo(cr, uid, vals_taxa_cartao, context)
        return res

    @log_debug
    def pedcap_exclui_titulo_prv_financeiro(self, cr, uid, ids, context):
        """
        Exclui titulos gerados em previsao no financeiro

        :param cr: a Vinha atual do cursor do banco de dados
        :param uid: ID do usuario utilizado para a verificacao de perfil
        :param ids: lista com o ID dos pedidos
        :param context: um dicionario padrao para valores contextuais
        :type cr: cursor
        :type uid: int
        :type ids: list[long]
        :type context: dict
        :rtype: bool
        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        context = context and context.copy() or {}
        # Instanciando objetos
        obj_fin_tit = self.pool.get('financeiro.titulo')
        obj_doc_doc = self.pool.get('documento.documento.tipo')

        res = True
        doc_tipo_id = obj_doc_doc.search(cr, uid, [('sigla', '=', 'PRV')], context=context)[0]
        pedido_ids = ids
        if not isinstance(pedido_ids, list):
            pedido_ids = [pedido_ids]
        args_fintit_ids = [('fintit_pedido_id', 'in', pedido_ids), ('doc_tipo_id', '=', doc_tipo_id)]
        fintit_ids = obj_fin_tit.search(cr, uid, args_fintit_ids, context=context)
        if fintit_ids:
            res = obj_fin_tit.unlink(cr, uid, fintit_ids, context)
        return res

    def pedcap_criar_titulo(self, cr, uid, vals_titulo, context=None):
        """
        Gera titulo no financeiro

        :param cr: a Vinha atual do cursor do banco de dados
        :param uid: ID do usuario utilizado para a verificacao de perfil
        :param vals_titulo: Dicionario contendo os valores do titulo a serem criados
        :param context: um dicionario padrao para valores contextuais
        :type cr: cursor
        :type uid: int
        :type vals_titulo: dict
        :type context: dict
        :rtype: long
        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        context = context and context.copy() or {}
        context['fintit_manter_prv'] = True
        if len(vals_titulo['data_emissao']) > 10:
            vals_titulo['data_emissao'] = vals_titulo['data_emissao'][:10]
        res = self.pool.get('financeiro.titulo').create(cr, uid, vals_titulo, context)
        return res

    def pedcap_get_dado_extra(self, cr, uid, ids, context=None):
        """
        O metodo encontra os dados que se encontram em outros modulos, necessarios para a impressao
        dos pedidos. Ele so e declarado aqui para que seja sobrescrito na herança dessa classe nos
        demais modulos.
        :param cr: cursor no banco de dados.
        :type: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type: integer
        :param ids: lista de id da tabela desse objeto.
        :type: list
        :param context: dicionario com valores contextuais.
        :type: dict
        :return: Dicionario vazio
        :rtype: dict
        """
        return dict()

    def pedcap_get_email_pessoa(self, cr, uid, ids, context=None):
        """
        O metodo exibe uma nova janela com todos os e-mails do cliente.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: Acao para chamada de uma nova tela.
        :rtype: dict
        """
        context = context and context.copy() or {}
        tipo_pessoa = 'Cliente'
        if context.get('view_name') == 'estoquepedidos_compra':
            tipo_pessoa = 'Fornecedor'
        if not self.browse(cr, uid, ids[0], context).pessoa_id:
            raise osv.except_osv(_('Atencao'), _('%s nao informado.' % tipo_pessoa))
        if not self.browse(cr, uid, ids[0], context).pessoa_id.email:
            raise osv.except_osv(_('Atencao'), _('%s sem e-mail cadastrado.' % tipo_pessoa))
        reference = self.pool.get('ir.model.data').get_object_reference(
            cr, uid, 'estoquepedidos', 'view_wizard_email_pessoa_form')
        view_id = reference and reference[1] or False
        return {'name': '',
                'view_type': 'form',
                'view_mode': 'form',
                'res_model': 'wizard.email.pessoa',
                'view_id': [view_id],
                'context': context,
                'target': 'new',
                'type': 'ir.actions.act_window',
                }

    def pedcap_open_url(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        dados_pedidos = self.read(cr, uid, ids, ['pedcap_endereco_eletronico'], context=context)[0]
        url = dados_pedidos.get('pedcap_endereco_eletronico')
        if url:
            return {
                'type': 'ir.actions.act_url',
                'url': url,
                'target': 'new'
            }

    def pedcap_onchange_transportador(self, cr, uid, ids, transportador_id, context=None):
        context = context and context.copy() or {}
        res = {}
        if transportador_id:
            return res
        res.update({'value': {'pedcap_placa': ''}})
        return res

    def pedcap_button_print_separacao(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}

        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'estoquepedidos_separacao',
            'datas': {'ids': ids},
        }


class rel_estoquepedidos_simplificado(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context):
        super(rel_estoquepedidos_simplificado, self).__init__(cr, uid, name, context)
        dados_parametro = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', ['estpar_pedido_tipo_codigo'])
        tipo_codigo = dados_parametro.get('estpar_pedido_tipo_codigo')
        obj_estoquepedidos_pedido_capa = self.pool.get(
            'estoquepedidos.pedido.capa')
        dados_extra = obj_estoquepedidos_pedido_capa.pedcap_get_dado_extra(
            cr, uid, context.get('active_ids'), context) or {}
        self.localcontext.update({
            'time': time,
            'getNumeroEditado': self.pool.get('adm.utils').admutl_get_valor_formatado,
            'int': int,
            'tipo_codigo': tipo_codigo,
            'vendedor_externo': _('Vendedor externo:'),
            'dado_extra': dados_extra,
            'sum': sum
        })
        self.context = context
