# -*- coding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _

READ_LOAD = '_classic_write'


class estoquepedidos_pedido_condicao(osv.Model):
    _name = 'estoquepedidos.pedido.condicao'
    _inherit = 'estoquepedidos.pedido.condicao'

    # funcao codio - descricao  do produto
    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
        res = []
        pedido_condicao_dados = self.browse(cr, uid, ids)
        for i in pedido_condicao_dados:
            id = i.id
            condicao_forma = i.condicao_forma_id.adm_condicao_id.name
            forma_pagamento = i.forma_pagto_id.name
            name = '%s - %s' % (forma_pagamento, condicao_forma)
            res.append((id, name))
        return res

    def pedcdc_onchange_forma_pgto(self, cr, uid, ids, forma_pagto_id, context=None):
        context = context and context.copy() or {}
        res = dict(condicao_forma_id=False)
        if forma_pagto_id:
            obj_adm_condicao_forma = self.pool.get('adm.condicao.forma')
            adm_condicao_forma_ids = obj_adm_condicao_forma.search(
                cr, uid, [('forma_pagamento_id', '=', forma_pagto_id)], context=context)
            if len(adm_condicao_forma_ids) == 1:
                res.update({'condicao_forma_id': adm_condicao_forma_ids[0]})
            else:
                res.update({'condicao_forma_id': False})
            brw_forma_pgto = self.pool.get('adm.forma.pgto').browse(
                cr, uid, forma_pagto_id, context)
            sigla = brw_forma_pgto.admfpg_documento_tipo_id.sigla
            if sigla == 'CHQ':
                pagamento_cheque = True
                clear_cheque_dados = False
            else:
                pagamento_cheque = False
                clear_cheque_dados = True
            res.update({'pedcdc_flag_pgto_chq': pagamento_cheque})
            if clear_cheque_dados:
                fields_char = ['pedcdc_chq_emitente', 'pedcdc_chq_numero', 'pedcdc_chq_conta']
                fields_integer = ['pedcdc_chq_banco', 'pedcdc_chq_agencia']
                res.update({}.fromkeys(fields_char, ''))
                res.update({}.fromkeys(fields_integer, 0))

        return {'value': res}

    def pedcdc_validar_cpf_emitente_cheque(self, cpf_emitente):
        if not cpf_emitente:
            return True
        pessoa_tipo = ''
        if len(cpf_emitente) == 11:
            pessoa_tipo = 'F'
        elif len(cpf_emitente) == 14:
            pessoa_tipo = 'J'
        res = self.pool.get('adm.utils').admutl_cpf_cnpj_testar(pessoa_tipo, cpf_emitente)
        return res

    def pedcdc_onchange_cpf_emitente_cheque(self, cr, uid, ids, cpf_emitente, context=None):
        context = context and context.copy() or {}
        res = self.pedcdc_validar_cpf_emitente_cheque(cpf_emitente)
        if not res:
            warning = {
                'title': _('Atencao'),
                'message': _('CPF/CNPJ do emitente do cheque invalido!'),
            }
            return {'warning': warning}
        else:
            return {'value': {}}

    def pedcdc_onchange_condicao_pgto(self, cr, uid, ids, forma_pagto_id, context=None):
        context = context and context.copy() or {}
        res = {}
        if not forma_pagto_id:
            res['pedcdc_nro_autorizacao_cartao'] = ''
            return res

        obj_adm_condicao_forma = self.pool.get('adm.condicao.forma')
        adm_condicao_forma_ids = obj_adm_condicao_forma.search(
            cr, uid, [('forma_pagamento_id', '=', forma_pagto_id)], context=context)
        if len(adm_condicao_forma_ids) == 1:
            res.update({'condicao_forma_id': adm_condicao_forma_ids[0]})
        browse_forma_pagamento = self.pool.get('adm.forma.pgto').browse(
            cr, uid, forma_pagto_id, context)
        res['pedcdc_forma_pagamento_cheque'] = \
            browse_forma_pagamento.admfpg_documento_tipo_id.sigla == 'CHQ'
        tipo_cartao = browse_forma_pagamento.cartao_credito_debito
        res['pedcdc_tipo_cartao'] = tipo_cartao
        if tipo_cartao:
            res['pedcdc_nro_autorizacao_cartao'] = '-'

        return {'value': res}

    def create(self, cr, user, vals, context=None):
        context = context and context.copy() or {}
        cpf_emitente_cheque = vals.get('pedcdc_chq_emitente')
        if cpf_emitente_cheque:
            cpf_valido = self.pedcdc_validar_cpf_emitente_cheque(cpf_emitente_cheque)
            if not cpf_valido:
                raise osv.except_osv(_('Atencao'), _('CPF/CNPJ do emitente do cheque invalido!'))
        res = super(estoquepedidos_pedido_condicao, self).create(cr, user, vals, context)
        return res

    def write(self, cr, user, ids, vals, context=None):
        context = context and context.copy() or {}
        cpf_emitente_cheque = vals.get('pedcdc_chq_emitente')
        if cpf_emitente_cheque:
            cpf_valido = self.pedcdc_validar_cpf_emitente_cheque(cpf_emitente_cheque)
            if not cpf_valido:
                raise osv.except_osv(_('Atencao'), _('CPF/CNPJ do emitente do cheque invalido!'))
        res = super(estoquepedidos_pedido_condicao, self).write(cr, user, ids, vals, context)
        return res
