# -*- coding: utf-8 -*-

from openerp.osv import osv
from openerp.osv.fields import float_round
from openerp.tools.translate import _
from ..model.funcoes import pedite_func_get_saldo_empresas
import time


class estoquepedidos_pedido_item(osv.Model):
    _name = 'estoquepedidos.pedido.item'
    _inherit = 'estoquepedidos.pedido.item'

    def default_get(self, cr, uid, fields, context=None):
        context = context and context.copy() or {}
        res = super(estoquepedidos_pedido_item, self).default_get(cr, uid, fields, context)
        if context.get("vendedor"):
            vendedor_id = context.get("vendedor")
            res['vendedor_id'] = vendedor_id
        if context.get("vendedor_externo"):
            vendedor_externo_id = context.get("vendedor_externo")
            res['vendedor_externo_id'] = vendedor_externo_id
        obj_ir_model_access = self.pool.get('ir.model.access')
        permissao = obj_ir_model_access.check_groups(cr, uid, 'estoque.group_estoque_alterar_preco')
        if not permissao:
            permissao = obj_ir_model_access.check_groups(cr, uid, 'prime.group_prime_manager')
        res['pedite_altera_preco_venda'] = permissao
        if context.get('state_id'):
            res['pedite_tipo_state'] = self.pool.get('estoquepedidos.pedido.capa.state').browse(
                cr, uid, context.get('state_id'), context).state
        return res

    def check_pedido_item_local_produto(self, cr, uid, company_id, local_id, produto_id, grade_id,
                                        produto_embalagem_id=False, context=None):
        ## verifica se o produto esta no local informado, caso nao esteja, e adiconado
        context = context and context.copy() or {}
        local_locacao_id = 0
        local_produto_ids = self.pool.get('estoque.produto').estoque_check_produto_in_local(
            cr, uid, company_id=company_id, produto_id=produto_id, local_id=local_id,
            context=context)
        if not local_produto_ids:
            vals = {'local_id': local_id, 'produto_id': produto_id, 'company_id': company_id,
                    'grade_id': grade_id}
            if produto_embalagem_id:
                vals.update({'estllc_produto_embalagem_id': produto_embalagem_id})
            local_locacao_id = self.pool.get('estoque.local.locacao').create(
                cr, uid, vals, context)
        return local_locacao_id

    def get_local_embalagem(self, cr, uid, local_id, produto_id, grade_id, context=None):
        context = context and context.copy() or {}
        obj_adm_util = self.pool.get('adm.utils')
        obj_estoque_produto = self.pool.get('estoque.produto')
        obj_local_locacao = self.pool.get('estoque.local.locacao')
        obj_produto_embalagem = self.pool.get('estoque.produto.embalagem')
        if not produto_id:
            return ''
        tipo_produto = obj_estoque_produto.browse(cr, uid, produto_id, context).tipo

        # Se for um Serviço, deverá buscar a embalagem cadastrada no parâmetro do estoque
        if tipo_produto == u'S':
            embalagem_servico_id = obj_adm_util.admutl_get_parametros(cr, uid, 'estoque',
                                                                      ['estpar_embalagem_servico_id'])

            embalagem_id = embalagem_servico_id.get('estpar_embalagem_servico_id')

            if not embalagem_id:
                raise osv.except_osv(_('Atencao'), _('Nao existe embalagem para servico cadastrada '
                                                     'no parametro do estoque'))

            produto_embalagem_id = obj_produto_embalagem.search(cr, uid,
                                                                [('produto_id', '=', produto_id),
                                                                 ('embalagem_id', '=', embalagem_id)], context=context)

            # Se nao existir embalagem cadastrada para o servico, cadastrar
            if not produto_embalagem_id:
                produto_embalagem_id = obj_produto_embalagem.create(cr, uid,
                                                                    {'produto_id': produto_id,
                                                                     'embalagem_id': embalagem_id},
                                                                    context=context)
            if isinstance(produto_embalagem_id, list):
                produto_embalagem_id = produto_embalagem_id[0]
            return produto_embalagem_id
        produto_embalagem_id = False
        local_locacao_ids = obj_local_locacao.search(cr, uid, [('local_id', '=', local_id),
                                                               ('produto_id', '=', produto_id),
                                                               ('grade_id', '=', grade_id)], context=context)
        if local_locacao_ids:
            local_locacao_id = local_locacao_ids[0]
            local_locacao_dados = obj_local_locacao.read(cr, uid, local_locacao_id, ['estllc_produto_embalagem_id'],
                                                         context=context)
            if isinstance(local_locacao_dados, list) and local_locacao_dados:
                local_locacao_dados = local_locacao_dados[0]
            if isinstance(local_locacao_dados, dict):
                produto_embalagem_id = local_locacao_dados.get('estllc_produto_embalagem_id') and \
                                       local_locacao_dados['estllc_produto_embalagem_id'][0]
                if produto_embalagem_id:
                    return produto_embalagem_id
        produto_embalagem_ids = obj_produto_embalagem.search(cr, uid, [('produto_id', '=', produto_id)],
                                                             context=context)
        if produto_embalagem_ids:
            produto_embalagem_id = produto_embalagem_ids[0]
        return produto_embalagem_id

    def get_preco_venda_embalagem(self, cr, uid, company_id, produto_id, grade_id,
                                  produto_embalagem_id, pei_preco_venda, pessoa_id=None,
                                  context=None):
        context = context and context.copy() or {}
        cliente_id = None
        if pessoa_id:
            cliente_id = self.pool.get('financeiro.cliente').search(cr, uid, [('pessoa_id', '=', pessoa_id)],
                                                                    context=context)
            if cliente_id:
                cliente_id = cliente_id[0]
        ## BUSCA O VALOR UNITARIO DO PRODUTO
        if not pei_preco_venda:
            preco_venda = self.pool.get('estoque.preco.venda').get_preco_venda(
                cr, uid, produto_id, epc_grade_ids=grade_id, epc_company_id=company_id,
                epc_cliente_id=cliente_id)
            dados_preco_venda = preco_venda.get(produto_id) or {}
            preco_venda = dados_preco_venda.get(grade_id) or dados_preco_venda.get(
                'preco_venda')
        else:
            preco_venda = pei_preco_venda
        valor_unitario = preco_venda
        ## SE ALGUMA EMBALAGEM FOR ESCOLHIDA
        if produto_embalagem_id:
            ## BUSCA A QUANTIDADE PRESENTE NA EMBALAGEM
            qtde_embalagem = self.pool.get('estoque.produto.embalagem').browse(cr, uid,
                                                                               produto_embalagem_id).embalagem_id.quantidade_na_embalagem
            valor_unitario = preco_venda * (qtde_embalagem or 1)
        return valor_unitario

    def pedite_ratear_despesa_itens(self, cr, uid, itens, despesas, context=None):
        """
        Rateia as despesas da capa do pedido no itens proporcionalmente ao total de cada item.
        :param cr: 
        :param uid: 
        :param itens: lista no formato de campos one2many [[1,1,{...}], [0, False, {...}], ...]
        :param despesas: valor das respesas que serah rateada nos itens
        :param context: 
        :return: dict
        """
        context = context and context.copy() or {}
        item_ids = []
        ids_valor = []
        ids_desp = []
        total_itens = 0
        total_despesas_itens = 0
        for i in itens:
            if i[0] not in (0, 1, 4):
                continue

            if i[0] == 4:
                i[0] = 1

            if not i[2]:
                i[1] and item_ids.append(i[1])
                ids_desp.append(i[1])
                ids_valor.append(i[1])
            else:
                if 'valor_total' not in i[2]:
                    i[1] and item_ids.append(i[1])
                    ids_valor.append(i[1])
                else:
                    total_itens += i[2].get('valor_total') or 0

                if 'pedite_despesas' not in i[2]:
                    i[1] and i[1] not in item_ids and item_ids.append(i[1])
                    ids_desp.append(i[1])
                else:
                    total_despesas_itens += i[2].get('pedite_despesas') or 0

        dict_itens = {}
        if item_ids:
            for i in self.read(cr, uid, item_ids, ['valor_total', 'pedite_despesas'], context,
                               '_classic_write'):
                dict_itens[i.get('id')] = i
                if i.get('id') in ids_valor:
                    total_itens += i.get('valor_total')
                if i.get('id') in ids_desp:
                    total_despesas_itens += i.get('pedite_despesas')

        dif_desp = despesas - total_despesas_itens
        # controle para nao recalcular quando a despesas eh alterada no item
        if -0.01 < dif_desp and dif_desp < 0.01:
            return {}

        maior_item = []
        percentual = despesas / total_itens
        total_calculado = 0
        # rateia o valor da despesa proporcional ao valor total do item
        for item in itens:
            if item[0] not in (0, 1, 4):
                continue

            valor_total = item[2] and item[2].get('valor_total') or \
                          dict_itens.get(item[1]).get('valor_total')
            despesa_item = float_round((valor_total * percentual), 2)
            total_calculado += despesa_item
            if not item[2]:
                item[2] = {'pedite_despesas': despesa_item}
            else:
                item[2]['pedite_despesas'] = despesa_item

            if not maior_item or maior_item[2].get('pedite_despesas') < despesa_item:
                maior_item = item

        dif = despesas - total_calculado
        # joga a diferenca do calculo do rateio no item de maior valor
        if dif < -0.009 or 0.009 < dif:
            maior_item[2]['pedite_despesas'] += dif

        return {'pedido_item_ids': itens}

    def read(self, cr, uid, ids, fields=None, context=None, load='_classic_read'):
        context = context and context.copy() or {}
        if fields and isinstance(fields, list):
            if not 'produto_embalagem_id' in fields:
                fields.append('produto_embalagem_id')
                'grade_id' not in fields and fields.append('grade_id')

            if not 'produto_embalagem_id' in fields:
                fields.append('grade_id')

            if not 'qtde_pedida' in fields:
                fields.append('qtde_pedida')

        res = super(estoquepedidos_pedido_item, self).read(cr, uid, ids, list(set(fields)),
                                                           context, load)
        if isinstance(res, list):
            grade_ids = []
            for i in res:
                if i.get('grade_id'):
                    if isinstance(i.get('grade_id'), (list, tuple)):
                        grade_ids.append(i.get('grade_id')[0])
                    else:
                        grade_ids.append(i.get('grade_id'))

        else:
            grade_id = res.get('grade_id')
            if isinstance(grade_id, (list, tuple)):
                grade_id = grade_id[0]

            grade_ids = grade_id and [grade_id] or []

        grade_qtd_emb = self.pool.get('estoque.utils').get_grade_qtd_embalagem(cr, grade_ids,
                                                                               context)
        if type(res) is list:
            for x in res:
                produto_embalagem_id = x['produto_embalagem_id']
                if isinstance(produto_embalagem_id, (list, tuple)):
                    produto_embalagem_id = produto_embalagem_id[0]

                if produto_embalagem_id:
                    grade_id = x.get('grade_id')
                    if isinstance(grade_id, (list, tuple)):
                        grade_id = grade_id[0]

                    if grade_id:
                        chave = '%s-%s' % (grade_id, produto_embalagem_id)
                        quantidade_embalagem = (grade_qtd_emb.get(chave) or {}).get('qtd') or 1
                        if quantidade_embalagem:
                            x['qtde_pedida'] = x.get('qtde_pedida') / quantidade_embalagem

        elif type(res) is dict:
            produto_embalagem_id = res['produto_embalagem_id']
            if isinstance(produto_embalagem_id, (list, tuple)):
                produto_embalagem_id = produto_embalagem_id[0]
            if produto_embalagem_id:
                grade_id = res.get('grade_id')
                if isinstance(grade_id, list):
                    grade_id = grade_id[0]

                if grade_id:
                    chave = '%s-%s' % (grade_id, produto_embalagem_id)
                    quantidade_embalagem = (grade_qtd_emb.get(chave) or {}).get('qtd') or 1
                    if quantidade_embalagem:
                        res['qtde_pedida'] = res.get('qtde_pedida') / quantidade_embalagem
        return res

    def create(self, cr, uid, vals, context=None):
        def _pedite_create_madeireira(cr, uid, vals, context):
            obj_madeireira_utils = self.pool.get('madeireira.utils')
            produto_embalagem_id = vals.get('produto_embalagem_id')
            comprimento = vals.get('pedite_comprimento') or 0
            largura = vals.get('pedite_largura') or 0
            espessura = vals.get('pedite_espessura') or 0
            pedido_id = vals.get('pedido_id')
            tipo_pedido = self.pool.get('estoquepedidos.pedido.capa').browse(
                cr, uid, pedido_id).tipo
            if tipo_pedido == 'V':
                res = obj_madeireira_utils.madutl_verifica_medidas(cr, uid, produto_embalagem_id,
                                                                   comprimento,
                                                                   largura,
                                                                   espessura)
                if isinstance(res, basestring):
                    raise osv.except_osv(_('Atencao'), res)

            if context.get('orcamento_item_id'):
                orcamento_item_id = context.get('orcamento_item_id')
                fields = ['orcori_comprimento', 'orcori_largura', 'orcori_espessura', 'quantidade',
                          'produto_id']
                dados_orcamento = self.pool.get('orcamentos.orcamento.itens').read(cr, uid, [orcamento_item_id], fields,
                                                                                   context=context)
                for dado in dados_orcamento:
                    produto_id = dado.get('produto_id')[0]
                    quantidade = dado.get('quantidade') or 0
                    comprimento = dado.get('orcori_comprimento') or 0
                    largura = dado.get('orcori_largura') or 0
                    espessura = dado.get('orcori_espessura') or 0
                    volume = obj_madeireira_utils.madutl_calcula_volume(quantidade, comprimento, largura, espessura)
                    vals.update({'pedite_comprimento': comprimento,
                                 'pedite_largura': largura,
                                 'pedite_espessura': espessura,
                                 'pedite_volume': volume})

            if vals.get('vr_unitario') and tipo_pedido == 'V':
                vr_variacao = 0
                if vals.get('produto_id'):
                    valida_variacao = obj_madeireira_utils.madpro_valida_variacao(cr, uid,
                                                                                  vals.get('produto_id'),
                                                                                  comprimento,
                                                                                  espessura,
                                                                                  context)
                    if valida_variacao.get('warning'):
                        mensagem = valida_variacao['warning']['message']
                        raise osv.except_osv(_('Atencao'), mensagem)
                    else:
                        vr_variacao = valida_variacao.get('vr_variacao')

                if vr_variacao:
                    pessoa_id = False
                    if vals.get('pedido_id'):
                        pessoa_id = self.pool.get('estoquepedidos.pedido.capa').browse(
                            cr, uid, vals.get('pedido_id'), context).pessoa_id.id
                    vals['vr_unitario'] = self.pool.get('madeireira.utils').\
                        madutl_get_valor_com_fator(cr, uid, vals.get('produto_id'),
                                                   vr_variacao or 0, pessoa_id, context)
            return vals

        context = context and context.copy() or {}
        pedido_capa_id = vals.get('pedido_id')
        local_id = vals.get('local_id') or 0
        produto_id = vals.get('produto_id') or 0
        grade_id = vals.get('grade_id') or 0
        produto_embalagem_id = vals.get('produto_embalagem_id')
        quantidade_pedida = vals.get('qtde_pedida') or 0
        produto_preco_venda = vals.get('pei_preco_venda') or 0
        embalagem_quantidade = 1

        if not quantidade_pedida > 0 and not context.get('pedcap_importa_itens'):
            raise osv.except_osv(_('Atencao'), _('A quantidade informada deve ser maior que zero!'))

        obj_produto = self.pool.get('estoque.produto')
        obj_estoque_produto_embalagem = self.pool.get('estoque.produto.embalagem')
        tipo_produto = obj_produto.browse(cr, uid, produto_id).tipo
        if tipo_produto == 'P':
            if not grade_id:
                raise osv.except_osv(_('Atencao'), _('A grade do produto deve ser lancada!'))
            if not produto_embalagem_id:
                raise osv.except_osv(_('Atencao'), _('A embalagem do produto deve ser lancada!'))
            embalagem_quantidade = self.pool.get('estoque.produto.embalagem').browse(cr, uid,
                                                                                     produto_embalagem_id).embalagem_id.quantidade_na_embalagem or 1

        browse_pedido_capa = self.pool.get('estoquepedidos.pedido.capa').browse(cr, uid, pedido_capa_id)
        pedido_tipo = browse_pedido_capa.tipo
        company_id = browse_pedido_capa.company_id.id
        if pedido_tipo == 'C' and tipo_produto == 'P':
            pedido_fornecedor_id = browse_pedido_capa.pessoa_id.id
            # verifica se o produto possui o local informado, se nao tiver, adiciona o local para o produto
            self.check_pedido_item_local_produto(cr, uid, company_id=company_id, local_id=local_id,
                                                 produto_id=produto_id, grade_id=grade_id,
                                                 produto_embalagem_id=produto_embalagem_id,
                                                 context=context)
            # verifica se o fornecedor esta cadastrado para o produto, se nao estiver, realiza o cadastro
            obj_produto.estoque_produto_in_fornecedor(cr, uid, company_id=company_id,
                                                      fornecedor_id=pedido_fornecedor_id,
                                                      produto_id=produto_id, produto_embalagem_id=produto_embalagem_id,
                                                      context=context)
        elif pedido_tipo == 'V' and tipo_produto == 'P':
            if not vals.get('vr_unitario'):
                vals['vr_unitario'] = produto_preco_venda * embalagem_quantidade
            saida_produto_local = obj_produto.estoque_check_produto_in_local(cr, uid, company_id=company_id,
                                                                             produto_id=produto_id, local_id=local_id,
                                                                             context=context)
            if not saida_produto_local:
                raise osv.except_osv(_('Atencao'), _('O produto nao encontra-se cadastrado para o local informado!'))
        if tipo_produto == 'P':
            quantidade_na_embalagem = obj_estoque_produto_embalagem.browse(cr, uid,
                                                                           produto_embalagem_id).embalagem_id.quantidade_na_embalagem
            vals['qtde_pedida'] = quantidade_pedida * quantidade_na_embalagem
        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'madeireira', context) \
                and not context.get('orcamento_gera_pedido'):
            vals = _pedite_create_madeireira(cr, uid, vals, context)
        return super(estoquepedidos_pedido_item, self).create(cr, uid, vals, context=context)

    def write(self, cr, uid, ids, values, context=None):
        def _pedite_write_madeireira(cr, uid, ids, vals):
            if isinstance(ids, list):
                ids = ids[0]
            fields = ['produto_id', 'pedite_comprimento', 'pedite_comprimento', 'pedite_largura',
                      'pedite_espessura', 'produto_embalagem_id', 'pedido_id']
            dados_pedido_item = self.read(cr, uid, ids, fields, context=context)
            produto_id = vals.get('produto_id')
            if not produto_id:
                produto_id = dados_pedido_item.get('produto_id')
            if isinstance(produto_id, (list, tuple)):
                produto_id = produto_id[0]
            pedite_comprimento = vals.get('pedite_comprimento')
            if not pedite_comprimento:
                pedite_comprimento = dados_pedido_item.get('pedite_comprimento')
            if 'pedite_largura' in vals:
                pedite_largura = vals.get('pedite_largura')
            else:
                pedite_largura = dados_pedido_item.get('pedite_largura')
            if 'pedite_espessura' in vals:
                pedite_espessura = vals.get('pedite_espessura')
            else:
                pedite_espessura = dados_pedido_item.get('pedite_espessura')
            pedido_id = vals.get('pedido_id')
            if not pedido_id:
                pedido_id = dados_pedido_item.get('pedido_id')
            if isinstance(pedido_id, (list, tuple)):
                pedido_id = pedido_id[0]
            tipo_pedido = self.pool.get('estoquepedidos.pedido.capa').browse(
                cr, uid, pedido_id).tipo
            if 'produto_id' not in vals:
                if dados_pedido_item.get('produto_id'):
                    produto_id = dados_pedido_item.get('produto_id')[0]
                obj_madeireira_utils = self.pool.get('madeireira.utils')
                valida_variacao = obj_madeireira_utils.madpro_valida_variacao(cr, uid, produto_id,
                                                                              pedite_comprimento,
                                                                              pedite_espessura,
                                                                              context)
                if valida_variacao.get('warning'):
                    mensagem = valida_variacao['warning']['message']
                    raise osv.except_osv(_('Atencao'),
                                         _(mensagem))

            produto_embalagem_id = vals.get('produto_embalagem_id') or \
                dados_pedido_item.get('produto_embalagem_id') or False
            if produto_embalagem_id and isinstance(produto_embalagem_id, (tuple, list)):
                produto_embalagem_id = produto_embalagem_id[0]
            if tipo_pedido == 'V':
                verifica_medidas = self.pool.get('madeireira.utils').madutl_verifica_medidas(
                    cr, uid, produto_embalagem_id, pedite_comprimento, pedite_largura,
                    pedite_espessura)
                if isinstance(verifica_medidas, basestring):
                    raise osv.except_osv(_('Atencao'), verifica_medidas)
            return vals

        context = context and context.copy() or {}
        res_write = []
        if isinstance(ids, (int, long)):
            ids = [ids]

        if values.get('qtde_pedida'):
            if not values.get('qtde_pedida') > 0:
                raise osv.except_osv(_('Atencao'), _('A quantidade informada deve ser maior que zero!'))

        if values.get('local_id'):
            local_id = values['local_id']
        else:
            local_id = False
        if values.get('produto_id'):
            produto_id = values['produto_id']
        else:
            produto_id = False
        if values.get('grade_id'):
            grade_id = values['grade_id']
        else:
            grade_id = False

        if values.get('pei_preco_venda'):
            preco_venda = values['pei_preco_venda']
        else:
            preco_venda = 0

        ## se o desconto nao for maior que zero.
        if values.get('vr_desconto') and values.get('vr_desconto') < 0:
            raise osv.except_osv(_('Atencao'), _('O desconto informado deve ser maior que zero!'))

        # se o valor unitario nao for maior que zero
        if values.get('vr_unitario') and not values.get('vr_unitario') > 0:
            raise osv.except_osv(_('Atencao'), _('O valor unitario informado deve ser maior que zero!'))

        browse_pedido_itens = self.browse(cr, uid, ids)
        obj_estoque_produto = self.pool.get('estoque.produto')
        obj_produto_embalagem = self.pool.get('estoque.produto.embalagem')
        obj_embalagem = self.pool.get('estoque.embalagem')
        obj_estoque_preco = self.pool.get('estoque.preco.venda')
        for i in browse_pedido_itens:
            id = i.id
            pedido_capa_tipo = i.pedido_id.tipo
            pedido_capa_company_id = i.pedido_id.company_id.id

            item_local_id = local_id or i.local_id.id
            item_produto_id = produto_id or i.produto_id.id
            item_grade_id = grade_id or i.grade_id.id

            produto_tipo = i.produto_id.tipo
            produto_name = i.produto_id.name

            embalagem_quantidade = 1
            ## se o item for um produto, deve possuir grade e embalagem cadastradas.
            if produto_tipo == 'P':
                if values.get('grade_id') and not values.get('grade_id'):
                    raise osv.except_osv(_('Atencao'), _('Grade nao informada para o item do pedido!'))
                if values.get('produto_embalagem_id') and not values.get('produto_embalagem_id'):
                    raise osv.except_osv(_('Atencao'), _('Embalagem nao informada para o item do pedido!'))
                ## busca a quantidade na embalagem selecionada.
                item_produto_embalagem_id = values.get('produto_embalagem_id') or i.produto_embalagem_id.id
                produto_embalagem_dados = obj_produto_embalagem.read(cr, uid, item_produto_embalagem_id,
                                                                     ['embalagem_id'], context=context)
                if produto_embalagem_dados and isinstance(produto_embalagem_dados, list):
                    produto_embalagem_dados = produto_embalagem_dados[0]
                if isinstance(produto_embalagem_dados, dict):
                    embalagem_id = produto_embalagem_dados.get('embalagem_id') and \
                                   produto_embalagem_dados['embalagem_id'][0] or False
                    if not embalagem_id:
                        raise osv.except_osv(_('Atencao'), _('Nenhuma embalagem foi encontrada associada ao produto!'))
                    else:
                        embalagem_dados = obj_embalagem.read(cr, uid, embalagem_id, ['quantidade_na_embalagem'],
                                                             context=context)
                        if isinstance(embalagem_dados, list):
                            embalagem_dados = embalagem_dados[0]
                        if isinstance(embalagem_dados, dict):
                            embalagem_quantidade = embalagem_dados.get('quantidade_na_embalagem') or 1
                ## se o item for produto e for uma venda.
                if pedido_capa_tipo == 'V':
                    ## verifica se o produto a ser vendido, esta no local informado
                    saida_produto_local = obj_estoque_produto.estoque_check_produto_in_local(cr, uid,
                                                                                             company_id=pedido_capa_company_id,
                                                                                             produto_id=item_produto_id,
                                                                                             local_id=item_local_id,
                                                                                             context=context)
                    if not saida_produto_local:
                        raise osv.except_osv(_('Atencao'), _(
                            'O produto: %s nao encontra-se cadastrado para o local informado!') % produto_name)
                ## se o item for produto e for uma compra.
                elif pedido_capa_tipo == 'C':
                    ## verifica se o produto esta cadastrado para o fornecedor. Caso nao esteja realiza o cadastrado
                    pedido_capa_fornecedor_id = i.pedido_id.pessoa_id.id
                    self.check_pedido_item_local_produto(
                        cr, uid, company_id=pedido_capa_company_id, local_id=item_local_id,
                        produto_id=item_produto_id, grade_id=item_grade_id,
                        produto_embalagem_id=item_produto_embalagem_id, context=context)
                    obj_estoque_produto.estoque_produto_in_fornecedor(cr, uid, company_id=pedido_capa_company_id,
                                                                      produto_id=item_produto_id,
                                                                      fornecedor_id=pedido_capa_fornecedor_id,
                                                                      produto_embalagem_id=item_produto_embalagem_id,
                                                                      context=context)

            ## se for pedido de venda.
            if pedido_capa_tipo == 'V':
                ## busca o preco de venda do item.
                item_preco = preco_venda or i.pei_preco_venda
                if not item_preco:
                    preco_venda = obj_estoque_preco.get_preco_venda(
                        cr, uid, item_produto_id, epc_grade_ids=item_grade_id,
                        epc_company_id=pedido_capa_company_id)
                    dados_preco_venda = preco_venda.get(item_produto_id) or {}
                    item_preco = dados_preco_venda.get(item_grade_id) or \
                                 dados_preco_venda.get('preco_venda')
                    if not item_preco:
                        raise osv.except_osv(_('Atencao'),
                                             _('Preco de venda nao cadastrado para o item %s' % produto_name))
                    values['pei_preco_venda'] = item_preco
                ## quando o preco de venda for alterado pelo button de alterar preco venda.
                if context.get('pedido_preco_venda'):
                    values['vr_unitario'] = item_preco
                    values['pei_preco_venda'] = item_preco / embalagem_quantidade
            else:
                item_preco = values.get('vr_unitario') or 0

            if values and values.get('vr_unitario'):
                if not item_preco > 0:
                    raise osv.except_osv(_('Atencao'), _('O preco de venda deve ser maior que zero!'))
            if values.get('qtde_pedida'):
                values['qtde_pedida'] = values.get('qtde_pedida') * embalagem_quantidade
            elif values.get('produto_embalagem_id'):
                values['qtde_pedida'] = i.qtde_pedida * embalagem_quantidade

            if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'madeireira', context):
                values = _pedite_write_madeireira(cr, uid, ids, values)
            res = super(estoquepedidos_pedido_item, self).write(cr, uid, id, values, context=context)
            res_write.append(res)

        return all(res_write)

    def unlink(self, cr, uid, id, context=None):
        context = context and context.copy() or {}
        pedido_item_dados = \
            self.pool.get('estoquepedidos.pedido.item').read(cr, uid, id, ['pedido_id'],
                                                             context=context)
        if isinstance(pedido_item_dados, list):
            pedido_item_dados = pedido_item_dados[0]
        pedido_id = pedido_item_dados.get('pedido_id')
        if isinstance(pedido_id, (list, tuple)):
            pedido_id = pedido_id[0]
        obj_pedido_capa = self.pool.get('estoquepedidos.pedido.capa')
        # lendo o valor da capa do pedido
        dados_capa = obj_pedido_capa.read(cr, uid, pedido_id, ['state'], context=context)
        if isinstance(dados_capa, list):
            dados_capa = dados_capa[0]
        state = dados_capa.get('state')
        if state not in obj_pedido_capa.pedcap_states_que_permitem_alteracao(cr, uid):
            raise osv.except_osv(_('Atencao'), _('O pedido nao pode ser deletado.'))
        res = super(estoquepedidos_pedido_item, self).unlink(cr, uid, id, context=context)
        return res

    def onchange_local(self, cr, uid, ids, local_id, produto_id, grade_id):
        val = {}
        val['vr_unitario'] = 0
        val['produto_id'] = False
        val['grade_id'] = False
        val['produto_embalagem_id'] = False
        val['valor_total'] = 0
        val['qtde_pedida'] = 0
        val['vr_desconto'] = 0
        val['pedite_percentual_desconto'] = 0
        val['observacao'] = ''
        val['pedite_saldo'] = 0
        return {'value': val}

    def pedite_get_saldo(self, cr, uid, local_id, grade_id, produto_emb_id, context=None):
        """
        O metodo fara a busca do saldo em estoque de um produto, baseados no produto, grade e no
        local em que se encontra. Retorna dicionario com as informacoes de saldo e quantidade
        reservada
        @param cr: cursor do banco de dados
        @param uid: id do usuario
        @param local_id: id da tabela estoque_local
        @param grade_id: id da tabela estoque_produto_grade
        @param context: dicionario com valores contextuais
        """
        context = context and context.copy() or {}
        vals = {'pedite_saldo': 0}
        if not all([local_id, grade_id]):
            return vals
        obj_estoque_produto_saldo = self.pool.get('estoque.produto.saldo')
        data = time.strftime('%Y-%m-%d')
        saldo = obj_estoque_produto_saldo.get_saldo_do_dia(cr, uid, grade_id, data,
                                                           eps_local_id=local_id, context=context)
        saldo = saldo.get(grade_id).get('saldo_na_embalagem').get(produto_emb_id)
        if saldo:
            vals['pedite_saldo'] = saldo.get('disponivel') or 0

        return vals

    def onchange_grade(self, cr, uid, ids, produto_id, grade_id, local_id, pessoa_id=None,
                       tipo_state='I', context=None):
        val = {}
        context = context and context.copy() or {}
        if tipo_state == 'B':
            return {}
        cliente_id = False
        if pessoa_id:
            cliente_id = self.pool.get('financeiro.cliente').search(cr, uid, [('pessoa_id', '=', pessoa_id)],
                                                                    context=context)
            if cliente_id:
                cliente_id = cliente_id[0]
        if context.get('tipo') != 'C' and produto_id:
            preco_venda = self.pool.get('estoque.preco.venda').get_preco_venda(
                cr, uid, produto_id, epc_grade_ids=grade_id, epc_cliente_id=cliente_id)
            dados_preco_venda = preco_venda.get(produto_id) or {}
            preco_venda = dados_preco_venda.get(grade_id) or dados_preco_venda.get(
                'preco_venda')
            val.update({'vr_unitario': preco_venda})
        else:
            obj_estoque_estatisticas_mensal_osv = self.pool.get('estoque.estatisticas.mensal.osv')
            obj_estoque_estatisticas_mensal_itens_osv = self.pool.get('estoque.estatisticas.mensal.itens.osv')
            if produto_id and local_id and grade_id:
                context['estatisticas_pedido_compra'] = True
                context['local_id'] = local_id
                context['produto_id'] = produto_id
                context['grade_id'] = grade_id
                estatistica_id = obj_estoque_estatisticas_mensal_osv.estesm_funcao_pesquisar(cr, uid, None, context)

                if estatistica_id:
                    estatisticas_itens_ids = obj_estoque_estatisticas_mensal_itens_osv.search(cr, uid, [
                        ('estatistica_mensal_id', '=', estatistica_id)], context=context)
                    val['pedite_estoque_estatisticas_ids'] = estatisticas_itens_ids
        produto_embalagem_id = self.get_local_embalagem(cr, uid, local_id, produto_id, grade_id)
        if produto_embalagem_id:
            val['produto_embalagem_id'] = produto_embalagem_id
            val.update(self.pedite_get_saldo(cr, uid, local_id, grade_id, produto_embalagem_id,
                                             context=context))

        # Recupera a locacao do item
        locacao_ids = self.pool.get('estoque.local.locacao').search(
            cr, uid, [('local_id', '=', local_id), ('grade_id', '=', grade_id)],
            context=context)
        locacao_dados = locacao_ids and self.pool.get('estoque.local.locacao').read(
            cr, uid, locacao_ids[0], ['locacao'], context)
        val['pedite_pedido_item_locacao'] = locacao_dados and locacao_dados.get('locacao') or str()
        vals_item = {'produto_id': produto_id,
                     'grade_id': grade_id,
                     'id': 1}
        saldos = {}
        if produto_id and grade_id:
            saldos = pedite_func_get_saldo_empresas(self, cr, uid, [produto_id], [grade_id],
                                                    [vals_item], context=context)
        if saldos.get(1):
            val.update(saldos.get(1))

        return {'value': val}

    ## RETORNA O VALOR UNITÁRIO DO PRODUTO, CASO NÃO HAJA, EXIBE ALERTA DIZENDO QUE O PREÇO NÃO ESTA CADASTRADO
    def onchange_produto(self, cr, uid, ids, produto_id, company_id, tipo, qtde_pedida, vr_unitario, vr_desconto,
                         produto_embalagem_id, local_id, pei_preco_venda=0, pessoa_id=None,
                         tipo_state='I', context=None):
        context = context and context.copy() or {}
        if tipo_state == 'B':
            return {}

        def _pedite_onchange_produto_estoqueserie(cr, uid, res, produto_id):
            controle_serie = False
            if produto_id:
                obj_produto = self.pool.get('estoque.produto')
                controla_numero_serie = obj_produto.estpro_get_parametro_serie(cr, uid, context=context)
                if controla_numero_serie:
                    produto_dados = self.pool.get('estoque.produto').read(cr, uid, produto_id, ['estpro_nserie_tipo'],
                                                                          context=context)
                    if produto_dados and isinstance(produto_dados, list):
                        produto_dados = produto_dados[0]
                    if isinstance(produto_dados, dict):
                        produto_controle_serie = produto_dados.get('estpro_nserie_tipo')
                        controle_serie = produto_controle_serie in ('NS', 'NC')
                if not res.get('value'):
                    res['value'] = {'pei_produto_nserie_controle': controle_serie}
                else:
                    res['value']['pei_produto_nserie_controle'] = controle_serie
            return res

        pei_preco_venda = 0.0
        context['retorno_sem_codigo'] = True
        val = {}
        warning = {}
        cliente_id = None
        if pessoa_id:
            cliente_id = self.pool.get('financeiro.cliente').search(cr, uid, [('pessoa_id', '=', pessoa_id)],
                                                                    context=context)
            if cliente_id:
                cliente_id = cliente_id[0]
        ##### SE O PRODUTO FOR TROCADO, OS CAMPOS ABAIXO SÃO APAGADOS DA TELA
        if not produto_id:
            val = {}.fromkeys(['grade_id', 'produto_embalagem_id'], False)
            val.update({}.fromkeys(['qtde_pedida', 'vr_unitario', 'vr_desconto', 'valor_total',
                                    'pedite_percentual_desconto', 'pei_preco_venda'], 0))
            val['observacao'] = ''
        else:
            _brw_produto = self.pool.get('estoque.produto').browse(cr, uid, produto_id)
            modulo_kit_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(
                cr, uid, 'kit', context)
            if modulo_kit_instalado:
                kit_de_produto = _brw_produto.kit_de_produtos
                if kit_de_produto:
                    val = {}.fromkeys(['produto_id', 'grade_id', 'produto_embalagem_id'], False)
                    mensagem = _('\n Este e um item kit e deve ser informado na aba "Kit por '
                                 'itens"')
                    warning['title'] = _('Atencao')
                    warning['message'] = mensagem
                    return {'value': val, 'warning': warning}
            ## verifica se o produto esta cadastrado para o local, caso nao esteja, e mostrado um alerta informando.
            elif local_id:  ## deve verificar o local apenas em pedido de compra
                pedido_produto_local = self.pool.get('estoque.produto').estoque_check_produto_in_local(cr, uid,
                                                                                                       company_id=company_id,
                                                                                                       produto_id=produto_id,
                                                                                                       local_id=local_id,
                                                                                                       context=context)
                if not pedido_produto_local:
                    ## a mensagem deve ser somente um alerta.
                    warning.update({'title': _('Atencao'), 'message': _(
                        'Este Produto/Servico nao encontra-se cadastrado para o local informado! Ao gravar o item, o local sera adicionado no cadastro do Produto/Servico!')})

            ##### BUSCAR A GRADE SE FOR UNICA
            grade_id = self.pool.get('estoque.produto.grade').search(cr, uid, [('produto_id', '=', produto_id)],
                                                                     context=context)
            if len(grade_id) == 1:
                if isinstance(grade_id, list):
                    grade_id = grade_id[0]
                val['grade_id'] = grade_id
            else:
                val['grade_id'] = ''
            preco_venda = 0.0
            if val.get('grade_id'):
                # Se o pedido nao for de compra, busca o preco de venda
                if tipo != 'C':
                    if not pei_preco_venda:
                        produto_preco_venda = self.pool.get('estoque.preco.venda').get_preco_venda(
                            cr, uid, produto_id, epc_grade_ids=val.get('grade_id'),
                            epc_company_id=company_id, epc_cliente_id=cliente_id)
                        dados_preco_venda = produto_preco_venda.get(produto_id) or {}
                        preco_venda = dados_preco_venda.get(val.get('grade_id')) or \
                                      dados_preco_venda.get('preco_venda')
                        if not preco_venda:
                            produto_dados = self.pool.get('estoque.produto').read(cr, uid, produto_id, ['name'],
                                                                                  context=context)
                            if isinstance(produto_dados, list):
                                produto_dados = produto_dados[0]
                            if isinstance(produto_dados, dict):
                                produto_name = produto_dados.get('name') or ''
                                return {'warning': {'title': _('Atencao'), 'message': _(
                                    'O produto: %s, nao possui preco de venda cadastrado!') % produto_name}}
                    else:
                        preco_venda = pei_preco_venda
                    val['vr_unitario'] = preco_venda
                    val['pei_preco_venda'] = preco_venda

            val['pedite_foto'] = self.pool.get('estoque.produto').browse(cr, uid, produto_id).estpro_foto
        if tipo == 'C':
            obj_estoque_preco_custo = self.pool.get('estoque.preco.custo')
            obj_estoque_estatisticas_mensal_osv = self.pool.get('estoque.estatisticas.mensal.osv')
            obj_estoque_estatisticas_mensal_itens_osv = self.pool.get('estoque.estatisticas.mensal.itens.osv')
            if produto_id:
                custos = obj_estoque_preco_custo.get_custos_do_dia(cr, uid, produto_id, company_id, None, context)
                if custos.get(produto_id):
                    custos = custos.get(produto_id)
                else:
                    custos = {}
                if custos:
                    val['pedite_custo_corrigido'] = custos.get('estprc_custo_corrigido')
                    val['pedite_custo_medio'] = custos.get('estprc_custo_medio_contabil')
                    val['pedite_ultimo_custo'] = custos.get('estprc_ultimo_custo')
                    val['pedite_custo_reposicao'] = custos.get('estprc_custo_reposicao')

                # Verificando se io modulo concorrencia
                modulo_concorrencia_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid,
                                                                                                         'concorrencia',
                                                                                                         context={})
                if modulo_concorrencia_instalado:
                    obj_concorrencia_concorrente_item = self.pool.get('concorrencia.concorrente.item')
                    concorrente_item_ids = obj_concorrencia_concorrente_item.search(cr, uid,
                                                                                    [('produto_id', '=', produto_id)],
                                                                                    context=context)
                    val['pedite_concorrente_item_ids'] = concorrente_item_ids
                    if local_id and isinstance(grade_id, int):
                        context['estatisticas_pedido_compra'] = True
                        context['local_id'] = local_id
                        context['produto_id'] = produto_id
                        context['grade_id'] = grade_id
                        estatistica_id = obj_estoque_estatisticas_mensal_osv.estesm_funcao_pesquisar(cr, uid, None, context)
                        if estatistica_id:
                            estatisticas_itens_ids = obj_estoque_estatisticas_mensal_itens_osv.search(cr, uid, [
                                ('estatistica_mensal_id', '=', estatistica_id)], context=context)
                            val['pedite_estoque_estatisticas_ids'] = estatisticas_itens_ids
        if 'produtos_similares' in context and produto_id:
            brw_similaridade = _brw_produto.produto_similaridade_ids
            simi_ids = []
            for simi in brw_similaridade:
                simi_ids.append(simi.id)
            val['pedite_prod_similares'] = simi_ids
        res = {'value': val, 'warning': warning}
        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'estoqueserie', context):
            res = _pedite_onchange_produto_estoqueserie(cr, uid, res, produto_id)
        return res

    def onchange_embalagem(self, cr, uid, ids, qtde_pedida, vr_unitario, vr_desconto,
                           produto_embalagem_id, company_id, produto_id, grade_id, tipo,
                           pei_preco_venda=0, pessoa_id=None, local_id=False, context={}):
        def _pedite_onchange_embalagem_madeireira_inicial(cr, uid, qtde_pedida,
                                                          produto_embalagem_id, produto_id, pei_preco_venda, context):
            obj_madeireira_utils = self.pool.get('madeireira.utils')
            sigla = ''
            if produto_embalagem_id:
                obj_estoque_produto_embalagem = self.pool.get('estoque.produto.embalagem')
                browse_produto_embalagem = obj_estoque_produto_embalagem.browse(cr, uid,
                                                                                produto_embalagem_id)
                embalagem_id = browse_produto_embalagem.embalagem_id
                if embalagem_id:
                    sigla = embalagem_id.sigla or ''
            comprimento = context.get('pedite_comprimento') or 0
            largura = context.get('pedite_largura') or 0
            espessura = context.get('pedite_espessura') or 0
            if sigla == 'M2':
                espessura = 0
            elif sigla == 'ML':
                largura = espessura = 0
            elif sigla != 'M3':
                comprimento = largura = espessura = 0
            volume = self.pool.get('madeireira.utils').madutl_calcula_volume(qtde_pedida, comprimento, largura,
                                                                             espessura)
            qtde_pedida = volume or qtde_pedida
            if produto_id:
                valida_variacao = obj_madeireira_utils.madpro_valida_variacao(cr, uid, produto_id,
                                                                              comprimento,
                                                                              espessura,
                                                                              context)
                if valida_variacao.get('warning'):
                    valida = valida_variacao['value']
                    value = {'pedite_comprimento': valida['comprimento'],
                             'pedite_espessura': valida['espessura']}
                    valida_variacao['value'] = value
                    return valida_variacao
                else:
                    vr_variacao = valida_variacao.get('vr_variacao')
            if pei_preco_venda:
                pei_preco_venda = obj_madeireira_utils.madutl_get_valor_com_fator(
                    cr, uid, produto_id, vr_variacao or 0, pessoa_id, context
                )
            return qtde_pedida, pei_preco_venda, sigla, volume, comprimento, largura, espessura

        def _pedite_onchange_embalagem_madeireira_final(res, sigla, volume, comprimento, largura,
                                                        espessura):
            res['value']['pedite_sigla_embalagem'] = sigla
            res['value']['pedite_volume'] = volume
            res['value']['pedite_comprimento'] = comprimento
            res['value']['pedite_largura'] = largura
            res['value']['pedite_espessura'] = espessura
            return res

        obj_estoque_preco_custo = self.pool.get('estoque.preco.custo')
        madeireira_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid,
                                                                                        'madeireira',
                                                                                        context)
        if madeireira_instalado:
            qtde_pedida, pei_preco_venda, sigla, volume, comprimento, largura, espessura = (
                _pedite_onchange_embalagem_madeireira_inicial(cr, uid, qtde_pedida,
                                                              produto_embalagem_id, produto_id,
                                                              pei_preco_venda, context)
            )
        """
        1 - SE O PEDIDO FOR DE VENDA
            1.1 - BUSCA O PRECO DE VENDA DO PRODUTO E MULTIPLICA PELA QUANTIDADE NA EMBALAGEM ESCOLHIDA
            1.2 - RECALCULA O VALOR TOTAL.
        """
        val = {'vr_unitario': 0.0, 'valor_total': 0.0}
        if tipo != 'C' and produto_id:
            valor_unitario = self.get_preco_venda_embalagem(cr, uid, company_id=company_id,
                                                            produto_id=produto_id,
                                                            grade_id=grade_id,
                                                            produto_embalagem_id=produto_embalagem_id,
                                                            pei_preco_venda=pei_preco_venda,
                                                            pessoa_id=pessoa_id, context=context)
            val['vr_unitario'] = valor_unitario
            ## RECALCULA O VALOR TOTAL
            valor_total = valor_unitario * (qtde_pedida or 0) - (vr_desconto or 0)
            val['valor_total'] = valor_total
            val['pei_preco_venda'] = valor_total
        elif produto_id and produto_embalagem_id:
            custos = obj_estoque_preco_custo.get_custos_do_dia(cr, uid, produto_id, company_id,
                                                               None, context)
            vr_unitario = custos.get(produto_id) and\
                          custos.get(produto_id).get('estprc_ultimo_custo') or 0
            qtde_embalagem = self.pool.get('estoque.produto.embalagem').browse(cr, uid,
                                          produto_embalagem_id).embalagem_id.quantidade_na_embalagem
            valor_unitario = vr_unitario * (qtde_embalagem or 1)
            val['vr_unitario'] = valor_unitario
            valor_total = valor_unitario * (qtde_pedida or 0) - (vr_desconto or 0)
            val['valor_total'] = valor_total
            preco_venda = self.get_preco_venda_embalagem(cr, uid, company_id=company_id,
                                                         produto_id=produto_id,
                                                         grade_id=grade_id,
                                                         produto_embalagem_id=produto_embalagem_id,
                                                         pei_preco_venda=pei_preco_venda,
                                                         pessoa_id=pessoa_id, context=context)
            val['pei_preco_venda'] = preco_venda or 0

        val.update(self.pedite_get_saldo(cr, uid, local_id, grade_id, produto_embalagem_id,
                                    context=context))
        res = {'value': val}
        if madeireira_instalado:
            res = _pedite_onchange_embalagem_madeireira_final(res, sigla, volume, comprimento,
                                                              largura, espessura)

        return res

    # RECALCULA O VALOR UNITARIO CASO ALTERADO E MOSTRA AVISO (Pedido de compra)
    def onchange_valor_unitario(self, cr, uid, ids, qtde_pedida, vr_unitario, vr_desconto, produto_embalagem_id,
                                company_id, produto_id, tipo, pei_preco_venda=0, context=None):
        context = context and context.copy() or {}
        vals = {}
        warning = {}
        if tipo == 'C':
            vals['valor_total'] = qtde_pedida * vr_unitario - vr_desconto
        return {'value': vals, 'warning': warning}

    def pedite_calcula_total_item(self, cr, uid, ids, qtde_pedida, vr_unitario, vr_desconto,
                                  produto_embalagem_id, context=None):
        def _pedite_onchange_qtd_madeireira(cr, uid, res, qtde_pedida, vr_unitario, vr_desconto,
                                            produto_embalagem_id, context):
            comprimento = context.get('pedite_comprimento') or 0
            largura = context.get('pedite_largura') or 0
            espessura = context.get('pedite_espessura') or 0
            volume = self.pool.get('madeireira.utils').madutl_calcula_volume(qtde_pedida,
                                                                    comprimento, largura, espessura)
            value = res.get('value')
            if value.get('vr_unitario'):
                res['value']['valor_total'] = (value['vr_unitario'] * qtde_pedida) - vr_desconto

            res['value']['pedite_volume'] = volume
            return res

        context = context and context.copy() or {}
        val = {}
        warning = {}
        if produto_embalagem_id:
            fracao = self.pool.get('estoque.produto.embalagem').browse(
                cr, uid, produto_embalagem_id).embalagem_id.unidade_id.fracao
            qt = qtde_pedida % 1
            if qt != 0.0 and not fracao:
                warning['title'] = _('Atencao')
                warning['message'] = _('Esta unidade nao aceita valor fracionado')
                val['qtde_pedida'] = 0
        val['valor_total'] = qtde_pedida * vr_unitario - (vr_desconto or 0)
        res = {'value': val, 'warning': warning}
        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'madeireira', context):
            res = _pedite_onchange_qtd_madeireira(cr, uid, res, qtde_pedida, vr_unitario,
                                                  vr_desconto, produto_embalagem_id, context)

        return res


    def onchange_qtd(self, cr, uid, ids, qtde_pedida, vr_unitario, vr_desconto,
                     produto_embalagem_id, context=None):
        context = context and context.copy() or {}
        return self.pedite_calcula_total_item(cr, uid, ids, qtde_pedida, vr_unitario, vr_desconto,
                                              produto_embalagem_id, context)

    def onchange_pedite_vr_unitario(self, cr, uid, ids, qtde_pedida, vr_unitario, vr_desconto,
                     produto_embalagem_id, context=None):
        'Pedido de vendas'
        context = context and context.copy() or {}
        return self.pedite_calcula_total_item(cr, uid, ids, qtde_pedida, vr_unitario, vr_desconto,
                                              produto_embalagem_id, context)

    # CALCULA O VALOR TOTAL
    def onchange_calc(self, cr, uid, ids, qtde_pedida, vr_unitario, vr_desconto,
                      produto_embalagem_id, vr_bonificacao=0, context=None):
        def _pedite_onchange_calc_madeireira(
                cr, uid, ids, qtde_pedida, vr_unitario, vr_desconto, produto_embalagem_id, context):
            obj_madeireira_utils = self.pool.get('madeireira.utils')
            comprimento = context.get('pedite_comprimento') or 0
            largura = context.get('pedite_largura') or 0
            espessura = context.get('pedite_espessura') or 0
            volume = obj_madeireira_utils.madutl_calcula_volume(qtde_pedida, comprimento, largura,
                                                                espessura, self, 'pedite_volume')
            quantidade = volume or qtde_pedida
            return quantidade

        context = context and context.copy() or {}
        madeireira_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(
            cr, uid, 'madeireira', context)
        if madeireira_instalado:
            qtde_pedida = _pedite_onchange_calc_madeireira(
                cr, uid, ids, qtde_pedida, vr_unitario, vr_desconto, produto_embalagem_id, context)

        val = {}
        valor_total = qtde_pedida * vr_unitario - vr_desconto
        pedite_ipi_aliquota_entrada = context.get('pedite_ipi_aliquota_entrada')
        if pedite_ipi_aliquota_entrada:
            vr_total_ipi = self.pedite_onchange_valor_ipi(cr, uid, ids, valor_total,
                                                          pedite_ipi_aliquota_entrada, context=None)
            vr_total_ipi = vr_total_ipi['value']['pedite_ipi_valor_entrada']
            if vr_total_ipi:
                val['pedite_ipi_valor_entrada'] = vr_total_ipi
        val['valor_total'] = qtde_pedida * vr_unitario - vr_desconto - vr_bonificacao
        if not vr_desconto > 0:
            val['pedite_percentual_desconto'] = 0
        return {'value': val}

    def onchange_operacao(self, cr, uid, ids, qtde_atendida, qtde_pedida):
        v = {}
        v['qtde_pedida'] = self._get_qtde_pedida(qtde_atendida)
        return {'value': v}

    def pedite_onchange_valor_ipi(self, cr, uid, ids, valor_total, pedite_ipi_aliquota_entrada, context=None):
        context = context and context.copy() or {}
        res = {'pedite_ipi_valor_entrada': False}
        if valor_total and pedite_ipi_aliquota_entrada:
            pedite_ipi_valor_entrada = valor_total * (float(pedite_ipi_aliquota_entrada) / 100)
            res['pedite_ipi_valor_entrada'] = pedite_ipi_valor_entrada
        return {'value': res}

    def pedite_onchange_percentual_desconto(self, cr, uid, ids, quantidade, valor_unitario,
                                            percentual_desconto_item, context=None):

        def _pedite_onchange_percentual_desconto_madeireira(
                cr, uid, ids, quantidade, valor_unitario, percentual_desconto_item, context):
            obj_madeireira_utils = self.pool.get('madeireira.utils')
            comprimento = context.get('pedite_comprimento') or 0
            largura = context.get('pedite_largura') or 0
            espessura = context.get('pedite_espessura') or 0
            volume = obj_madeireira_utils.madutl_calcula_volume(quantidade, comprimento, largura,
                                                                espessura)
            quantidade = volume or quantidade
            return quantidade

        context = context and context.copy() or {}
        madeireira_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(
            cr, uid, 'madeireira', context)
        if madeireira_instalado:
            quantidade = _pedite_onchange_percentual_desconto_madeireira(
                cr, uid, ids, quantidade, valor_unitario, percentual_desconto_item, context)

        vals = {}
        valor_total = valor_unitario * quantidade
        desconto_total_aux = float(valor_total) * percentual_desconto_item / 100
        vals.update({'vr_desconto': desconto_total_aux})
        vals.update({'valor_total': valor_total - desconto_total_aux})
        return {'value': vals}

    def calcula_total_items_pedido(self, cr, uid, ids, context=None):
        """
        Calcula o valor total dos itens do pedido

        :param cr: a linha atual do cursor do banco de dados,
        :param uid: o ID do usuario utilizado para a verificacao de perfil,
        :param ids: lista de registros da tabela estoque_inventario_capa
        :param context: um dicionario padrao para valores contextuais,
        :type cr: object
        :type uid: int
        :type ids: long|list[long]
        :type context: dict
        :return: o valor total dos itens
        :rtype: float

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}
        item_dados = self.read(
            cr, uid, ids if isinstance(ids, list) else [ids or 0], ['valor_total'], context=context)

        result = sum(map(lambda m: m.get('valor_total') or 0.0, item_dados))

        return result

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        # se contexto identificar o tipo de pedido, incluir no args
        if context.get('pedido_compra'):
            args.append(('tipo', '=', 'C'))
        elif context.get('pedido_venda'):
            args.append(('tipo', '=', 'V'))
        # Pedidos ativos são os pedidos que não estao em esboço, cancelado ou faturado
        if context.get('pedido_ativo'):
            args.append(('state', 'not in', ('R','F','C')))
        res = super(estoquepedidos_pedido_item, self).search(cr, uid, args, offset=offset, limit=limit,
                                                             order=order, context=context, count=count)
        return res

    @staticmethod
    def pedite_valida_disponibilidade_saldo(saldo, qtd_reservada, brw_pedido_item, qtd_embalagem):
        """
        Verifica a disponibilidade do saldo do item

        :param saldo: saldo do item
        :param qtd_reservada: qtd_reservada_do_item
        :param brw_pedido_item: browse do item da nota (estoquepedidos.pedido.item)
        :param qtd_embalagem: Quantidade da embalagem do item
        :type saldo: float
        :type qtd_reservada: float
        :type brw_pedido_item: browser
        :type qtd_embalagem: float
        :rtype: bool
        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        if 0 > saldo - (qtd_reservada + (brw_pedido_item.qtde_pedida * qtd_embalagem) or 0):
            return False
        return True

    @staticmethod
    def pedite_get_mensagem_saldo_indisp(produto_nome, local_nome, brw_pedido_item, qt_disponivel):
        """
        Retorna a mensagem de saldo indisponivel

        :param produto_nome: Nome do produto
        :param local_nome: Nome do local informado para o produto
        :param brw_pedido_item: browse do item da nota (estoquepedidos.pedido.item)
        :param qt_disponivel: Quantidade disponivel no estoque
        :type produto_nome: str
        :type local_nome: str
        :type brw_pedido_item: browser
        :type qt_disponivel: float
        :rtype: str
        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        msg = '* Saldo indisponivel para o produto: (%s) no local: (%s) - qtde. pedida: %f - ' \
              'disponivel: %f;\n\n   ' % (produto_nome, local_nome, brw_pedido_item.qtde_pedida
                                          or 0, qt_disponivel)
        return msg

    @staticmethod
    def pedite_get_query_item_requisitado_pedido(grade_ids, company_id, esboco=False):
        """
        Retorna a query para verificar a quantidade reservada do item para os pedidos de venda
        :param grade_ids: Os ids das grades para ser verificada
        :param company_id:
        :type grade_ids: list
        :type company_id: int
        :rtype: str
        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        if esboco:
            _state = "('F', 'C')"
        else:
            _state = "('R', 'F', 'C')"
        str_grade_ids = '(' + ','.join(str(e) for e in grade_ids) + ')'
        _sql = """
                    SELECT grade_id,
                           local_id,
                           Sum(qtde_pedida) AS quantidade
                    FROM   estoquepedidos_pedido_item i
                           LEFT JOIN estoquepedidos_pedido_capa c
                                  ON c.id = i.pedido_id
                    WHERE  grade_id IN {grade_ids}
                           AND state NOT IN {state}
                           AND tipo = 'V'
                           AND company_id = {company_id}
                    GROUP  BY grade_id,
                              local_id
        """.format(grade_ids=str_grade_ids, state=_state, company_id=company_id)
        return _sql
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
