# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _


class estoquepedidos_pedido_parcela(osv.Model):
    _name = 'estoquepedidos.pedido.parcela'
    _inherit = 'estoquepedidos.pedido.parcela'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if context.get('permiti_gravar', False):
            """
            Adicionei essa restricao ao contexto para poder lancar do orcamento
            Verificar como vai ficar
            christian 20/09/2010 - 15:34
            """
            return super(estoquepedidos_pedido_parcela, self).create(cr, uid, vals, context)

        #result = super(estoquepedidos_pedido_parcela, self).create(cr, uid, vals, context=context)
        if vals.get('pedido_condicao_id'):
            obj_pedido_condicao = self.pool.get('estoquepedidos.pedido.condicao')
            pedido_condicao_dados = obj_pedido_condicao.read(cr, uid, vals['pedido_condicao_id'], ['capa_id'], context=context)
            if isinstance(pedido_condicao_dados, list):
                pedido_condicao_dados = pedido_condicao_dados[0]
            capa_id = pedido_condicao_dados.get('capa_id')
            if isinstance(capa_id, tuple):
                capa_id = capa_id[0]
            pedido_capa_dados = self.pool.get('estoquepedidos.pedido.capa').read(
                cr, uid, capa_id, ['state', 'valor_total', 'tipo'], context=context)
            if isinstance(pedido_capa_dados, list):
                pedido_capa_dados = pedido_capa_dados[0]
            state = pedido_capa_dados.get('state')
            # lendo o valor da capa do pedido
            if context.get('criar', False):
                return super(estoquepedidos_pedido_parcela, self).create(cr, uid, vals, context=context)
            elif state not in self.pool.get('estoquepedidos.pedido.capa').pedcap_states_que_permitem_alteracao(cr, uid):
                raise osv.except_osv(_('Atencao'), _('O pedido nao pode ser mais alterado.'))
            else:
                # return True
                if not vals.get('pedido_compra_id') and pedido_capa_dados.get('tipo') == 'C':
                    vals['pedido_compra_id'] = pedido_capa_dados.get('id')
                if not vals.get('pedido_id'):
                    vals['pedido_id'] = pedido_capa_dados.get('id')
                return super(estoquepedidos_pedido_parcela, self).create(cr, uid, vals, context=context)
        elif context.get('copy_estoque_pedidos'):
            return super(estoquepedidos_pedido_parcela, self).create(cr, uid, vals, context=context)
        else:
            raise osv.except_osv(_('Atencao'), _(
                'A parcela nao pode ser criada, somente os valores das parcelas existentes podem ser alterados!'))

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        obj_ped_capa = self.pool.get('estoquepedidos.pedido.capa')
        obj_ped_condicao = self.pool.get('estoquepedidos.pedido.condicao')

        if 'pedido_condicao_id' in vals:
            pedido_condicao_dados = obj_ped_condicao.read(cr, uid, vals['pedido_condicao_id'], ['capa_id'], context=context)
            if isinstance(pedido_condicao_dados, list):
                pedido_condicao_dados = pedido_condicao_dados[0]
            capa_id = pedido_condicao_dados.get('capa_id')
            pedido_capa_dados = obj_ped_capa.read(cr, uid, capa_id, ['state', 'valor_total'], context=context)
            if isinstance(pedido_capa_dados, list):
                pedido_capa_dados = pedido_capa_dados[0]
            state = pedido_capa_dados.get('state')
            if state not in self.pool.get('estoquepedidos.pedido.capa').pedcap_states_que_permitem_alteracao(cr, uid):
                raise osv.except_osv(_('Atencao'), _('O pedido nao pode ser mais alterado.'))
        else:
            pedido_parcela_dados = self.read(cr, uid, ids, ['pedido_condicao_id'], context=context)
            if isinstance(pedido_parcela_dados, list):
                pedido_parcela_dados = pedido_parcela_dados[0]
            pedido_condicao_id = pedido_parcela_dados.get('pedido_condicao_id')
            if pedido_condicao_id:
                pedido_condicao_dados = obj_ped_condicao.read(cr, uid, pedido_condicao_id[0], ['capa_id'], context=context)
                if isinstance(pedido_condicao_dados, list):
                    pedido_condicao_dados = pedido_condicao_dados[0]
                capa_id = pedido_condicao_dados.get('capa_id')
                pedido_capa_dados = obj_ped_capa.read(cr, uid, capa_id[0], ['state', 'valor_total'], context=context)
                if isinstance(pedido_capa_dados, list):
                    pedido_capa_dados = pedido_capa_dados[0]
                state = pedido_capa_dados.get('state')
                if state not in self.pool.get('estoquepedidos.pedido.capa').pedcap_states_que_permitem_alteracao(cr, uid):
                    raise osv.except_osv(_('Atencao'), _('O pedido nao pode ser mais alterado.'))
        result = super(estoquepedidos_pedido_parcela, self).write(cr, uid, ids, vals, context)
        return result

    def unlink(self, cr, uid, ids, context=None):
        def _pedpar_unlink_compras(context):
            context.update({'criar': True})
            return context
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'compras', context):
            context = _pedpar_unlink_compras(context)
        browse_parcelas = self.browse(cr, uid, ids)
        pedidos_not_in_esboco = ''
        for i in browse_parcelas:
            pedido_capa_state = i.pedido_id.state
            if pedido_capa_state and pedido_capa_state not in ('R', 'D'):
                numero_pedido = i.pedido_id.numero_pedido or ''
                if numero_pedido:
                    numero_pedido += ', '
                    pedidos_not_in_esboco += numero_pedido
        if pedidos_not_in_esboco and not context.get('criar'):
            raise osv.except_osv(_('Atencao'), (_('Os pedidos a seguir nao podem ser excluidos pois nao \
                                               encontram-se em esboco: ') + pedidos_not_in_esboco))

        if context.get('criar', False):
            return super(estoquepedidos_pedido_parcela, self).unlink(cr, uid, ids, context=context)
        else:
            raise osv.except_osv(_('Atencao'), _('A parcela nao pode ser Excluida!'))

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        res = []
        if context.get('exibi_parcelas'):
            active_id = context.get('active_id') or 0
            active_model = context.get('active_model')
            field = ''
            if active_model == 'estoquepedidos.pedido.condicao':
                field = 'pedido_condicao_id'
            if field:
                res = super(estoquepedidos_pedido_parcela, self).search(cr, uid, [(field, '=', active_id)],
                                                                        context=context)
        else:
            res = super(estoquepedidos_pedido_parcela, self).search(cr, uid, args, offset=offset, limit=limit,
                                                                    order=order, context=context, count=count)
        return res

