# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools import drop_view_if_exists

class estoquepedidos_pedido_view(osv.Model):

    _name = 'estoquepedidos.pedido.view'
    _inherit = 'estoquepedidos.pedido.view'

    def _pedcap_get_sql_init(self, sql):
        return sql % ('','')

    def init(self, cr):
        drop_view_if_exists(cr, 'estoquepedidos_pedido_view')
        sql = """
            CREATE OR REPLACE VIEW estoquepedidos_pedido_view AS (
                SELECT
                    capa.company_id,
                    capa.numero_pedido,
                    capa.data_emissao,
                    capa.transportador_id,
                    capa.data_entrega,
                    capa.frete,
                    capa.vr_seguro,
                    capa.vr_despesas_acessorias,
                    capa.vr_frete,
                    capa.vr_desconto,
                    capa.tipo,
                    capa.pedcap_contato_id AS contato_id,
                    capa.pessoa_id,
                    sum(item.valor_total) as valor_total,
                    capa.state,
                    item.id,
                    item.qtde_pedida,
                    item.qtde_atendida,
                    item.vr_unitario,
                    item.observacao,
                    item.vr_desconto as vr_desconto_item,
                    item.produto_id,
                    item.produto_embalagem_id,
                    item.grade_id,
                    item.local_id,
                    item.valor_total as valor_total_item,
                    %s
                    current_date - capa.data_emissao as dias_do_pedido
                   
                FROM estoquepedidos_pedido_capa AS capa
                INNER JOIN estoquepedidos_pedido_item AS item
                ON capa.id = item.pedido_id
                GROUP BY
                    capa.company_id,
                    capa.numero_pedido,
                    capa.data_emissao,
                    capa.transportador_id,
                    capa.data_entrega,
                    capa.frete,
                    capa.vr_seguro,
                    capa.vr_despesas_acessorias,
                    capa.vr_frete,
                    capa.vr_desconto,
                    capa.tipo,
                    capa.pedcap_contato_id,
                    capa.pessoa_id,
                    capa.state,
                    item.id,
                    item.observacao,
                    item.qtde_pedida,
                    item.qtde_atendida,
                    item.vr_unitario,
                    item.vr_desconto,
                    item.produto_id,
                    item.produto_embalagem_id,
                    item.grade_id,
                    item.local_id,
                    item.valor_total,
                    %s
                    dias_do_pedido
            )
        """
        _sql = self._pedcap_get_sql_init(sql)
        cr.execute(_sql)

    def pedido_view_button_abrir_pedido(self, cr, uid, ids, context=None):
        """
        O metodo encontra o pedido do qual esse objeto pertence, para que seja retornada acao que
        abrira o formulario do mesmo.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids:list
        :param context: dados contextuais.
        :type context: dict
        :return: acao para abertura do pedido.
        :rtype: dict
        """
        context = context and context.copy() or {}
        pedido_id = self.pool.get('estoquepedidos.pedido.item').read(
            cr, uid, ids[0] if isinstance(ids, list) else ids, ['pedido_id'], context,
            '_classic_write').get('pedido_id')
        reference = self.pool.get('ir.model.data').get_object_reference(
            cr, uid, 'estoquepedidos', 'view_estoquepedidos_pedido_capa_form')
        view_id = reference and reference[1] or False
        return {
            'res_id': pedido_id,
            'name': 'Pedidos de venda',
            'type': 'ir.actions.act_window',
            'view_mode': 'form',
            'target': 'new',
            'res_model': 'estoquepedidos.pedido.capa',
            'view_id': view_id
        }
