# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class estoque_parametro(osv.Model):

    _inherit = 'estoque.parametro'

    def estpar_onchange_pedido_tipo_codigo(self, cr, uid, ids, tipo_codigo, context=None):
        """
        Metodo chamado ao selecionar uma das opcoes do campo 'Codigo a imprimir'
        (estpar_pedido_tipo_codigo).
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela dessa classe.
        :type ids: list
        :param tipo_codigo: letra que define o tipo de codigo do produto que sera impresso no
        pedido.
        :type tipo_codigo: str
        :param context: dados contextuais.
        :type context: dict
        :return: dados com a descricao dos campos e seus respectivos valores.
        :rtype: dict
        """
        context = context and context.copy() or {}
        res = {}
        if tipo_codigo != 'B':
            return res
        automacao_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(
            cr, uid, 'automacao', context)
        if not automacao_instalado:
            res['value'] = {'estpar_pedido_tipo_codigo': False}
            res['warning'] = {'title': _('Atencao'),
                             'message': _('Essa opcao requer o modulo "automacao" instalado.')}
        return res
