# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

import time
from SigUtils import datas
from decimal import Decimal, ROUND_HALF_UP


# Funcoes da classe estoquepedidos_pedido_view
def _get_dias(self, cr, uid, ids, field_name, arg, context=None):
    context = context and context.copy() or {}
    data_hoje = datas.getDataDeHoje(formato="I")
    res = {}
    for brw_view in self.browse(cr, uid, ids, context=context):
        dias = datas.calcDiferenca(brw_view.data_emissao, data_hoje)
        res[brw_view.id] = dias
    return res

# Funcoes da classe estoquepedidos_pedido_condicao
def pedcon_get_valor_restante(self, cr, uid, context=None):
    context = context and context.copy() or {}
    valor_total = 0
    if context.get('pedido_id'):
        capa_id = context.get('pedido_id')
        estoquepedidos_pedido_capa_brw = self.pool.get('estoquepedidos.pedido.capa').browse(cr, uid, capa_id,
                                                                                            context=context)
        valor_total = estoquepedidos_pedido_capa_brw.valor_total
        for condicao in estoquepedidos_pedido_capa_brw.pedido_condicao_ids:
            valor_total -= condicao.valor or 0.0
    return valor_total

def pedcdc_get_forma_pagto(self, cr, uid, context=None):
    context = context and context.copy() or {}
    if not context.get('cliente_id'):
        return ''
    sql = ''' SELECT fincli_forma_pgto_id
              FROM financeiro_cliente
              WHERE pessoa_id = %s
          ''' % (context.get('cliente_id'))
    cr.execute(sql)
    cliente_dados = cr.dictfetchall()
    if not cliente_dados:
        return ''
    if isinstance(cliente_dados, list):
        cliente_dados = cliente_dados[0]
    return cliente_dados.get('fincli_forma_pgto_id')

def pedcdc_get_condicao_forma(self, cr, uid, context=None):
    context = context and context.copy() or {}
    if not context.get('cliente_id'):
        return ''
    sql = ''' SELECT fincli_condicao_forma_id
              FROM financeiro_cliente
              WHERE pessoa_id = %s
          ''' % (context.get('cliente_id'))
    cr.execute(sql)
    cliente_dados = cr.dictfetchall()
    if not cliente_dados:
        return ''
    if isinstance(cliente_dados, list):
        cliente_dados = cliente_dados[0]
    return cliente_dados.get('fincli_condicao_forma_id')

def _pedcdc_get_cartao_credito_debito(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for p in self.browse(cr, uid, ids, context):
        res[p.id] = False
        if p.forma_pagto_id:
            if p.forma_pagto_id.cartao_credito_debito:
                res[p.id] = True
    return res

# Funcoes da classe estoquepedidos_pedido_capa
def _pedcap_get_divergencia_qtd(self, cr, uid, ids, field_name, arg, context=None):
    """
    O método verifica em cada item do pedido se a algum cuja qtd_atendida não é igual a pedida,
    sendo igual retorna False, uma única diferente retorna True
    :param cr: cursor no banco de dados
    :param uid: id do usuario
    :param ids: lista de registros da tabela estoquepedidos_pedido_capa
    :param field_name: nome do atributo
    :param arg: lista de argumentos de pesquisa para o atributo
    :param context: dicionario com valores contextuais
    :return: dicionario, suas chaves representam os ids dos pedidos e os valores das chaves, um
    booleano
    """
    context = context and context.copy() or {}
    res = {}
    brw_pedido_capa = self.browse(cr, uid, ids, context)
    for pedido in brw_pedido_capa:
        brw_pedido_item = pedido.pedido_item_ids
        item_qtd_divergente = filter(lambda i: i.qtde_pedida != i.qtde_atendida, brw_pedido_item)
        res[pedido.id] = False
        if item_qtd_divergente:
            res[pedido.id] = True
    return res


def _pedcap_get_premite_alterar(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = self.pool.get('estoque.parametro').estpar_get_permite_alterar_condicoes_pgto(cr, uid, ids, context)
    return res

def _pedcap_get_field_stored(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    if isinstance(ids, (int, long)):
        ids = [ids]
    res = {}.fromkeys(ids, 0)
    if not isinstance(ids, list):
        ids = [ids]

    modulo_fiscal = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid,
                                                                             'fiscal', context)
    load = '_classic_write'
    campos = ['orcamento_id', 'pessoa_id', 'pedcap_valor_ipi', 'pedido_item_ids', 'vr_frete',
              'vr_seguro', 'vr_desconto', 'vr_despesas_acessorias']
    dados_pedidos = self.read(cr, uid, ids, campos, context, load)
    pessoa_ids = []
    orcamento_ids = []
    pedido_item_ids = []
    for i in dados_pedidos:
        i.get('pessoa_id') and pessoa_ids.append(i.get('pessoa_id'))
        i.get('orcamento_id') and orcamento_ids.append(i.get('orcamento_id'))
        i.get('pedido_item_ids') and pedido_item_ids.extend(i.get('pedido_item_ids'))

    dict_pessoas = {}
    context['super_read_adm_pessoa'] = True
    map(lambda x: dict_pessoas.update({x.get('id'): x}),
        self.pool.get('adm.pessoa').read(cr, uid, pessoa_ids, ['pessoa_tipo'], context))

    dict_cliente = {}
    if pessoa_ids:
        cr.execute("""SELECT id,
                             pessoa_id
                      FROM financeiro_cliente 
                      WHERE pessoa_id in (%s) """ % ','.join(map(lambda x: '%s' % x, pessoa_ids)))
        for i in cr.dictfetchall():
            dict_cliente[i.get('pessoa_id')] = False
            if i.get('pessoa_id'):
                dict_cliente[i.get('pessoa_id')] = i.get('id')

    dict_orcamento = {}
    if orcamento_ids and context.get('orccap_nao_altera_valor'):
        map(lambda x: dict_orcamento.update({x.get('id'): x}),
            self.pool.get('orcamentos.orcamento.capa').read(cr, uid, orcamento_ids,
                                                            ['valor_liquido'], context))

    dict_itens = {}
    campos = ['valor_total', 'pedite_ipi_valor_entrada']
    map(lambda x: dict_itens.update({x.get('id'): x}),
        self.pool.get('estoquepedidos.pedido.item').read(cr, uid, pedido_item_ids, campos, context))

    for pedido in dados_pedidos:
        vals = {}
        pessoa = dict_pessoas.get(pedido.get('pessoa_id')) or {}
        if context.get('orccap_nao_altera_valor'):
            orcamento = dict_orcamento.get(pedido.get('orcamento_id'))
            vals['valor_total'] = orcamento.get('valor_liquido') or 0
            vals['pedcap_pj_pf'] = 'P%s' % (pessoa.get('pessoa_tipo') or '')
            res[pedido.get('id')] = vals
        else:
            pedcap_valor_ipi = 0
            valor_total_ipi = 0
            if pedido.get('pedcap_valor_ipi'):
                pedcap_valor_ipi = pedido.get('pedcap_valor_ipi')

            vr_frete = pedido.get('vr_frete') or 0
            vr_seguro = pedido.get('vr_seguro') or 0
            vr_desconto = pedido.get('vr_desconto') or 0
            vr_despesas_acessorias = pedido.get('vr_despesas_acessorias') or 0
            valor_total_item = 0
            for item_id in pedido.get('pedido_item_ids'):
                item = dict_itens.get(item_id)
                valor_total_item += item.get('valor_total')
                if modulo_fiscal:
                    valor_total_ipi = item.get('pedite_ipi_valor_entrada') or 0

            vals['valor_total'] = valor_total_item + valor_total_ipi + vr_seguro + vr_frete + \
                vr_despesas_acessorias + pedcap_valor_ipi - vr_desconto
            vals['pedcap_pj_pf'] = 'P%s' % (pessoa.get('pessoa_tipo') or '')
            if dict_cliente.get(pedido.get('pessoa_id')):
                vals['pedcap_pessoa_clientes_id'] = dict_cliente.get(pedido.get('pessoa_id'))

            res[pedido.get('id')] = vals


    return res


def pedcap_get_ocorrencias(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    browse_pedido_capa = self.browse(cr, uid, ids)
    obj_adm_ocorrencia = self.pool.get('adm.ocorrencia')
    for pedido in browse_pedido_capa:
        ocorrencia_ids = obj_adm_ocorrencia.search(cr, uid, [('admoco_pessoa_id', '=', pedido.pessoa_id.id)],
                                                   context=context)
        res[pedido.id] = ocorrencia_ids
    return res


def pedcap_simp_get_pedido_state(self, cr, uid, ids, field_name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    map(lambda i: res.update({i.id: i.pedcap_state_id.state}), self.browse(cr, uid, ids, context))
    return res


# Funcoes da classe estoquepedidos_pedido_item


def pedite_get_state_capa(self, cr, uid, ids, field_name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for item in self.browse(cr, uid, ids, context):
        res[item.id] = item.pedido_id.pedcap_state_id.state
    return res


def pedite_get_item_valor_total(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    browse_pedido_item = self.browse(cr, uid, ids)
    madeireira_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'madeireira', context={})
    obj_madeireira_utils = self.pool.get('madeireira.utils')
    modulo_fiscal = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'fiscal',
                                                                             context)
    for i in browse_pedido_item:

        sigla = ''
        if i.produto_embalagem_id:
            embalagem_id = i.produto_embalagem_id.embalagem_id
            if embalagem_id:
                sigla = embalagem_id.sigla or ''

        id = i.id
        vr_unitario = i.vr_unitario or 0
        qtde_pedida = i.qtde_pedida or 0
        vr_desconto = i.vr_desconto or 0
        icms_st = 0
        # Todo: quando cria um pedido sem o modulo fiscal ocorre erro, implementar por heranca
        if modulo_fiscal:
            icms_st = i.pedite_icms_st or 0

        vr_bonificacao = i.pedite_vr_bonificacao or 0
        valor_total = vr_unitario * qtde_pedida - vr_desconto + icms_st - vr_bonificacao
        if madeireira_instalado:
            comprimento = i.pedite_comprimento or 0.0
            largura = i.pedite_largura or 0.0
            espessura = i.pedite_espessura or 0.0
            volume = obj_madeireira_utils.madutl_calcula_volume(qtde_pedida, comprimento,
                                                                largura, espessura, self,
                                                                'pedite_volume')
            qtde_pedida = volume or qtde_pedida
            valor_total = float(Decimal(str(
                vr_unitario * qtde_pedida - vr_desconto + icms_st - vr_bonificacao)).quantize(
                Decimal('.01'), rounding=ROUND_HALF_UP))
        res[id] = valor_total
    return res


def pedite_get_local_venda_padrao(self, cr, uid, context=None):
    context = context and context.copy() or {}
    local_id = False
    obj_estoque_parametro = self.pool.get('estoque.parametro')
    estoque_parametro_ids = obj_estoque_parametro.search(cr, uid, [], context=context)
    if estoque_parametro_ids:
        estoque_parametro_id = estoque_parametro_ids[0]
        if context.get('tipo') == 'V':
            local_id = obj_estoque_parametro.browse(cr, uid, estoque_parametro_id).local_venda_padrao_id.id
        else:
            local_id = obj_estoque_parametro.browse(cr, uid, estoque_parametro_id).estpar_local_compra_padrao_id.id
    return local_id


def pedite_get_ipi_valor(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    if not isinstance(ids, list):
        ids = [ids]
    for x in ids:
        browse_pedido_item = self.browse(cr, uid, x)
        valor_total = browse_pedido_item.valor_total or 0.0
        pedite_ipi_aliquota_entrada = browse_pedido_item.pedite_ipi_aliquota_entrada or 0.0
        if valor_total and pedite_ipi_aliquota_entrada:
            valor_total_ipi = valor_total * (pedite_ipi_aliquota_entrada / 100)
            res[x] = valor_total_ipi
        else:
            res[x] = 0.0
    return res


def _pedite_get_foto(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    load = '_classic_write'
    res = {}
    dados_itens = self.read(cr, uid, ids, ['produto_id'] ,context, load)
    produto_ids = map(lambda x: x.get('produto_id'), dados_itens)
    dict_produtos = {}
    map(lambda x: dict_produtos.update({x.get('id'): x}),
        self.pool.get('estoque.produto').read(cr, uid, produto_ids, ['estpro_foto'], context))
    for i in dados_itens:
        foto = dict_produtos.get(i.get('produto_id')).get('estpro_foto')
        res[i.get('id')] = False
        if foto:
            res[i.get('id')] = foto

    return res


def pedite_get_state(self, cr, uid, ids, name, arg, context=None):
    """
    Verificar o status do pedido.
    """
    context = context and context.copy() or {}
    res = {}
    load = '_classic_write'
    dados_itens = self.read(cr, uid, ids, ['pedido_id'], context, load)
    capa_ids = map(lambda x: x.get('pedido_id'), dados_itens)
    dict_capa = {}
    map(lambda x: dict_capa.update({x.get('id'): x}),
        self.pool.get('estoquepedidos.pedido.capa').read(cr, uid, capa_ids, ['state'], context))
    for item in dados_itens:
        res[item.get('id')] = dict_capa.get(item.get('pedido_id')).get('state')

    return res


def _pedite_get_saldo_produto(self, cr, uid, ids, name, arg, context=None):
    """
    Busca o saldo e a quantidade reservada dos produtos
    @param cr: cursor do banco de dados
    @param uid: id do usuario
    @param ids: lista de id da tabela estoquepedidos_pedido_item
    @param name: nome do atributo
    @param arg: argumentos
    @param context: dicionario com valores contextuais
    """
    context = context and context.copy() or {}
    res = {}
    obj_estoque_produto_saldo = self.pool.get('estoque.produto.saldo')
    dados_itens = self.read(cr, uid, ids, ['grade_id', 'local_id'], context, '_classic_write')
    dict_locais_grades = {}
    for i in dados_itens:
        if not dict_locais_grades.get(i.get('local_id')):
            dict_locais_grades[i.get('local_id')] = [i.get('grade_id')]
        else:
            dict_locais_grades[i.get('local_id')].append(i.get('grade_id'))

    data = time.strftime('%Y-%m-%d')
    saldos_locais = {}
    for local_id, grade_ids in dict_locais_grades.items():
        saldos_locais[local_id] =  obj_estoque_produto_saldo.get_saldo_do_dia(cr, uid, grade_ids,
                                                                    data, local_id, context=context)
    for x in dados_itens:
        grade_id = x.get('grade_id')
        local_id = x.get('local_id')
        saldos = saldos_locais.get(local_id)
        vals = {'pedite_saldo': 0, 'pedite_reservada': 0}
        res[x.get('id')] = vals
        saldo = saldos.get(grade_id)
        if saldo:
            vals['pedite_saldo'] = saldo.get('disponivel') or 0
            vals['pedite_reservada'] = saldo.get('qtd_reservada')
            res[x.get('id')] = vals

    return res

def pedite_func_get_saldo_empresas(self, cr, uid, produto_ids, grade_ids, vals_itens, context=None):
    """
    Busca o saldo do produto de todas as empresas
    @param cr: cursor do banco de dados
    @param uid: id do usuario
    @param ids: lista de id da tabela estoquepedidos_pedido_item
    @param name: nome do atributo
    @param arg: argumentos
    @param context: dicionario com valores contextuais
    """
    context = context and context.copy() or {}
    obj_estoque_produto_saldo = self.pool.get('estoque.produto.saldo')
    load = '_classic_write'
    res = {}

    data = time.strftime('%Y-%m-%d')
    obj_wiz_saldo = self.pool.get('wizard.estoque.produto.saldo')
    company_ids = self.pool.get('res.company').search(cr, uid, [], context=context)
    args = [('wizeps_data_movimento', '=', data),
            ('wizeps_company_id', 'in', company_ids),
            ('wizeps_produto_id', 'in', produto_ids),
            ('wizeps_grade_id', 'in', grade_ids)]
    wiz_saldo_ids = obj_wiz_saldo.search(cr, uid, args, context=context, order='wizeps_company_id')
    dados_wiz_saldo = {}
    for i in obj_wiz_saldo.read(cr, uid, wiz_saldo_ids, context=context, load=load):
        chave = '%s-%s-%s-%s' % (i.get('wizeps_data_movimento'),
                                 i.get('wizeps_company_id'),
                                 i.get('wizeps_produto_id'),
                                 i.get('wizeps_grade_id'))
        dados_wiz_saldo[chave] = i.get('id')

    sql = """
        SELECT DISTINCT company_id 
        FROM estoque_produto_saldo 
        WHERE 
            grade_id IN %s
            AND (saldo > 0 OR saldo < 0) 
    """ % str(grade_ids).replace('[', '(').replace(']', ')')
    cr.execute(sql)
    possui_saldo_company_ids = cr.dictfetchall()
    possui_saldo_company_ids = possui_saldo_company_ids and map(
        lambda i: i.get('company_id'), possui_saldo_company_ids) or []

    for j in sorted(company_ids):
        company_id = j
        saldos = {}
        if company_id in possui_saldo_company_ids:
            saldos = obj_estoque_produto_saldo.get_saldo_do_dia(
                cr, uid, grade_ids, data, company_id=company_id, context=context)
        for i in vals_itens:
            grade_id = i.get('grade_id')
            produto_id = i.get('produto_id')
            chave = '%s-%s-%s-%s' % (data,
                                     company_id,
                                     produto_id,
                                     grade_id)
            saldo = saldos.get(grade_id) or False
            wiz_saldo = dados_wiz_saldo.get(chave)
            wiz_saldo_ids = []
            vals = {'wizeps_data_movimento': data,
                    'wizeps_company_id': company_id,
                    'wizeps_produto_id': produto_id,
                    'wizeps_grade_id': grade_id}

            if saldo:
                vals.update({'wizeps_saldo': saldo.get('saldo') or 0,
                             'wizeps_qtd_reservada': saldo.get('qtd_reservada') or 0,
                             'wizeps_disponivel': saldo.get('disponivel') or 0})
            else:
                vals.update({'wizeps_saldo': 0,
                             'wizeps_qtd_reservada': 0,
                             'wizeps_disponivel': 0})
            if not wiz_saldo:
                id = obj_wiz_saldo.create(cr, uid, vals, context=context)
                wiz_saldo_ids.append(id)

            else:
                obj_wiz_saldo.write(cr, uid, wiz_saldo, vals, context=context)
                wiz_saldo_ids.append(wiz_saldo)

            if not res.get(i.get('id')):
                res[i.get('id')] = {'pedite_saldo_empresas': wiz_saldo_ids}
            else:
                res[i.get('id')]['pedite_saldo_empresas'].extend(wiz_saldo_ids)
    return res

def _pedite_func_get_saldo_empresas(self, cr, uid, ids, name, arg, context=None):
    """
    Busca o saldo do produto de todas as empresas
    @param cr: cursor do banco de dados
    @param uid: id do usuario
    @param ids: lista de id da tabela estoquepedidos_pedido_item
    @param name: nome do atributo
    @param arg: argumentos
    @param context: dicionario com valores contextuais
    """
    context = context and context.copy() or {}
    dados_itens = self.read(cr, uid, ids, ['produto_id', 'grade_id'], context=context,
                            load='_classic_write')
    produto_ids = map(lambda x: x.get('produto_id'), dados_itens)
    grade_ids = map(lambda x: x.get('grade_id'), dados_itens)
    return pedite_func_get_saldo_empresas(self, cr, uid, produto_ids, grade_ids, dados_itens,
                                          context=context)

def _pedite_get_prod_similares(self, cr, uid, ids, fields_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    load = '_classic_write'
    dados_itens = self.read(cr, uid, ids, ['produto_id'] ,context, load)
    produto_ids = map(lambda x: x.get('produto_id'), dados_itens)
    dict_produtos = {}
    map(lambda x: dict_produtos.update({x.get('id'): x}),
        self.pool.get('estoque.produto').read(cr, uid, produto_ids, ['produto_similaridade_ids'],
                                              context))
    for i in dados_itens:
        produto = dict_produtos.get(i.get('produto_id'))
        res[i.get('id')] = ''
        if produto and produto.get('produto_similaridade_ids'):
            res[i.get('id')] = produto.get('produto_similaridade_ids')

    return res

def get_par_similaridade(self, cr, uid, ids):
    par = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque.parametro','usar_similaridade')
    return par.get('usar_similaridade')

def default_get_pedite_par_similaridade(self, cr, uid, ids, context=None):
    context = context and context.copy() or {}
    return get_par_similaridade(self, cr, uid, ids)

def _pedite_get_par_similaridade(self, cr, uid, ids, fields_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    for id in ids:
        par = get_par_similaridade(self, cr, uid, ids)
        if par:
            res[id] = par
        else:
            res[id] = False
    return res


def pedite_check_permissao_altera_preco(self, cr, uid, ids, field_name, arg, context=None):
    context = context and context.copy() or {}
    res = dict()
    obj_ir_model_access = self.pool.get('ir.model.access')
    permissao = obj_ir_model_access.check_groups(cr, uid, 'estoque.group_estoque_alterar_preco')
    if not permissao:
        permissao = obj_ir_model_access.check_groups(cr, uid, 'prime.group_prime_manager')
    map(lambda i: res.update({i: permissao}), ids)
    return res


def pedcap_get_foto_cliente(self, cr, uid, ids, fields_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    for id in ids:
        res[id] = self.browse(cr, uid, id, context=context).pessoa_id.foto
    return res


def _pedite_get_qtd_pedida_compra(self, cr, uid, ids, fields_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    pedido_compra_ids = self.pool.get('estoquepedidos.pedido.capa').search(cr, uid,
                                                                           [('state', '=', 'V'),
                                                                            ('tipo', '=', 'C')],
                                                                           context=context)
    dados_itens = self.read(cr, uid, ids, ['produto_id', 'grade_id'], context, '_classic_write')
    produto_ids = []
    grade_ids = []
    for i in dados_itens:
        produto_ids.append(i.get('produto_id'))
        grade_ids.append(i.get('grade_id'))

    item_compra_ids = self.search(cr, uid, [('pedido_id', 'in', pedido_compra_ids),
                                            ('produto_id', 'in', produto_ids),
                                            ('grade_id', 'in', grade_ids)], context=context)

    dict_qtd = {}
    for i in self.read(cr, uid, item_compra_ids, ['qtde_pedida', 'qtde_atendida'], context=context):
        chave = '%s-%s' % (i.get('produto_id'), i.get('grade_id'))
        qtd = (i.get('qtde_pedida') or 0.0) - (i.get('qtde_atendida') or 0)
        if not dict_qtd.get(chave):
            dict_qtd[chave] = qtd
        else:
            dict_qtd[chave] += qtd

    for item in dados_itens:
        chave = '%s-%s' % (item.get('poduto_id'), item.get('grade_id'))
        res[item.get('id')] = dict_qtd.get(chave)

    return res


def _pedite_get_item_locacao(self, cr, user, ids, name, arg, context=None):
    """
    Retorna a locacao do item em funcao do local e grade.

    :param cr: a linha atual do cursor do banco de dados
    :param user: ID do usuario utilizado para a verificacao de perfil
    :param ids: lista dos IDs
    :param name: lista com o nome dos campos
    :param arg: dicionario com os argumentos e valores
    :param context: um dicionario padrao para valores contextuais
    :type cr: object
    :type user: int
    :type ids: list
    :type name: list
    :type arg: dict
    :type context: dict
    :return: a locacao do item
    :rtype: dict

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """
    context = context and context.copy() or {}
    load = '_classic_write'
    result = {}.fromkeys(ids, None)
    for item in self.read(cr, user, ids, ['local_id', 'grade_id'], context, load):
        locacao_ids = self.pool.get('estoque.local.locacao').search(
            cr, user, [('local_id', '=', item.get('local_id')),
                       ('grade_id', '=', item.get('grade_id'))],
            context=context)
        locacao_dados = locacao_ids and self.pool.get('estoque.local.locacao').read(
            cr, user, locacao_ids[0], ['locacao'], context)
        result[item.get('id')] = locacao_dados and locacao_dados.get('locacao') or str()

    return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
