# -*- coding: utf-8 -*-

from openerp.osv import osv, fields


class estoquepedidos_pedido_condicao(osv.Model):
    """
    Condicoes de pagamento do pedido
    """

    from funcoes import pedcon_get_valor_restante, pedcdc_get_forma_pagto, \
        pedcdc_get_condicao_forma, _pedcdc_get_cartao_credito_debito

    _name = 'estoquepedidos.pedido.condicao'
    _rec_name = 'condicao_forma_id'
    _columns = {
        'capa_id': fields.many2one(
            'estoquepedidos.pedido.capa', 'Capa', ondelete="cascade", required=True, select=True),
        'valor': fields.float('Valor', digits=(15, 2), required=True),
        'condicao_forma_id': fields.many2one(
            'adm.condicao.forma', 'Condicao pagamento', ondelete="cascade", required=True,
            select=True),
        'forma_pagto_id': fields.many2one(
            'adm.forma.pgto', 'Forma Pagamento', ondelete="restrict", select=True, required=True),
        'pedido_parcela_ids': fields.one2many(
            'estoquepedidos.pedido.parcela', 'pedido_condicao_id', 'Parcela'),
        'pedcdc_chq_numero': fields.char('Numero Cheque', size=9),
        'pedcdc_chq_banco': fields.integer('Banco'),
        'pedcdc_chq_agencia': fields.integer('Agencia'),
        'pedcdc_chq_emitente': fields.char(
            'CPF/CNPJ Emitente', size=19,
            help='Informe o CPF/CNPJ do Emitente quando nao for o cliente.'
        ),
        'pedcdc_chq_conta': fields.char('Numero da Conta', size=10),
        'pedcdc_flag_pgto_chq': fields.boolean('Pagamento Tipo Cheque'),
        'pedcdc_tipo_cartao': fields.function(_pedcdc_get_cartao_credito_debito, type="boolean",
                                              method=True, store=False, string='Tipo cartao'),
        'pedcdc_nro_autorizacao_cartao': fields.char('Nro da Autorizacao do Cartao', size=10),
    }
    _defaults = {
        'valor': pedcon_get_valor_restante,
        'pedcdc_chq_banco': 0,
        'pedcdc_chq_agencia': 0,
        'pedcdc_flag_pgto_chq': False,
        'forma_pagto_id': pedcdc_get_forma_pagto,
        'condicao_forma_id': pedcdc_get_condicao_forma,
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
