# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class estoquepedidos_pedido_parcela(osv.Model):
    """
    tabela de vencimentos dos pedidos
    """
    _name = 'estoquepedidos.pedido.parcela'
    _columns = {
        'vr_parcela': fields.float('Valor da Parcela', digits=(15, 2), required=True), # Valor da parcela
        'pedido_condicao_id': fields.many2one('estoquepedidos.pedido.condicao', 'Condicao Pagamento',
                                              ondelete="cascade", select=True),
        'data_vencimento': fields.date('Data de Vencimento', required=True), # Data de vencimento
        ## campo pedido_id precisa ser historiado, caso nao seja, nao e mostrado na tree do pedido.
        #TODO o atributo pedido_id é tem o mesmo efeito do atributo pedido_compra_id implementado no modulo compras, unificalos
        'pedido_id': fields.related('pedido_condicao_id', 'capa_id', type="many2one",
                                    relation="estoquepedidos.pedido.capa", store=True),
    }

