# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class estoquepedidos_pedido_view(osv.Model):
    _name = 'estoquepedidos.pedido.view'
    _description = 'estoquepedidos_pedido_view'
    _auto = False
    from funcoes import _get_dias
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'numero_pedido': fields.char('Numero do pedido', size=20), # Numero do pedido.
        'data_emissao': fields.date('Data de Emissao', required=True), # Data de emissao do pedido
        'transportador_id': fields.many2one("adm.transportador", 'Transportador', ondelete="set null", select=True),
        'data_entrega': fields.date('Data de Entrega', select=True), # Data da previsao a ser entregue o pedido.
        'frete': fields.selection([('C', 'CIF'), ('F', 'FOB')], 'Frete', size=1), # Tipo de frete: C=CIF, F=FOB
        'vr_seguro': fields.float('Valor do seguro', digits=(15, 2)), # Valor do seguro
        'vr_despesas_acessorias': fields.float('Valor das despesas acessorias', digits=(15, 2)),
        'vr_frete': fields.float('Valor do Frete', digits=(15, 2)), # Valor do frete
        'vr_desconto': fields.float('Valor do Desconto', digits=(15, 2)), # Desconto em valor, isto e, a bonificacao.
        'observacao': fields.text('Observacao'),
        'tipo': fields.selection([('C', 'Compra'), ('V', 'Venda')], 'Tipo', required=True, size=1),
        'contato_id': fields.many2one('adm.pessoa', 'Contato',  context="{'contatos_de': pessoa_id}"),
        'pessoa_id': fields.many2one("adm.pessoa", 'Pessoa', ondelete="restrict", required=True, select=True),
        'valor_total': fields.float(string='Valor Total Pedido'),
        'state': fields.selection([('R', 'Esboco'), ('C', 'Cancelado'), ('V', 'Validado'), ('F', 'Faturado')],
                                  'Estado do Pedido', required=True, size=1),
        'qtde_pedida': fields.float('Qtd. Pedida', digits=(15, 3), required=True), # Quantidade pedida
        'qtde_atendida': fields.float('Qtd. Atendida', digits=(15, 3)), # Quantidade ja entregue
        'vr_unitario': fields.float('Valor Unit.', digits=(15, 4)), # Valor unitario do item
        'vr_desconto_item': fields.float('Valor Desc.', digits=(15, 2)), # Valor do desconto
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="restrict", required=True, select=True,
                                      domain="[('tipo', '=', 'P')]"), # Produto
        'grade_id': fields.many2one("estoque.produto.grade", 'Grade', ondelete="restrict", required=False, select=True,
                                    domain="[('produto_id', '=', produto_id)]"), # Id do produto a ser pedido\n
        'local_id': fields.many2one("estoque.local", 'Local', ondelete="restrict", required=True, select=True),
        'valor_total_item': fields.float(string='Valor Total'),
        'dias_do_pedido': fields.integer('Dias'),
    }

