# -*- coding: utf-8 -*-

import time
from openerp import pooler, osv
from openerp.report import report_sxw
import subprocess
from SigUtils.formatastring import formataString
from SigUtils.numero import getNumeroEditado
from openerp.report.render import render
import StringIO
import random
import string
from openerp.tools.translate import _


def random_name():
    random.seed()
    d = [random.choice(string.ascii_letters) for x in xrange(3)]
    name = "".join(d)
    return name


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class rel_estoquepedidos2(report_sxw.rml_parse):

    # COMANDOS IMPRESSORA MATRICIAL
    reseta_configuracao_impressora = chr(27)+chr(120)+chr(48)
    condensado = chr(15)
    modo_negrito_on = chr(27)+chr(71)
    modo_negrito_off = chr(27)+chr(72)

    def __init__(self, cr, uid, name, context):
        super(rel_estoquepedidos2, self).__init__(cr, uid, name, context)
        dados_parametro = pooler.get_pool(cr.dbname).get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque',
            ['estpar_impressora_pedido', 'estpar_pedido_matricial', 'estpar_pedido_tipo_codigo',
             'estpar_pedido_formato_impressao', 'estpar_comando_guilhotina',
             'estpar_pedido_retrato_paisagem', 'estpar_vias_pedido'])
        tipo_codigo = dados_parametro.get('estpar_pedido_tipo_codigo')
        obj_estoquepedidos_pedido_capa = pooler.get_pool(cr.dbname).get(
            'estoquepedidos.pedido.capa')
        dados_extra = obj_estoquepedidos_pedido_capa.pedcap_get_dado_extra(
            cr, uid, context.get('active_ids'), context) or {}
        self.localcontext.update({
            'time': time,
            'getNumeroEditado': self.pool.get('adm.utils').admutl_get_valor_formatado,
            'int': int,
            'tipo_codigo': tipo_codigo,
            'vendedor_externo': _('Vendedor externo:'),
            'dado_extra': dados_extra,
            'sum': sum
        })
        self.context = context
        estpar_impressora_pedido = dados_parametro.get('estpar_impressora_pedido')
        estpar_pedido_matricial = dados_parametro.get('estpar_pedido_matricial')
        formato_impressao = dados_parametro.get('estpar_pedido_formato_impressao')
        modo = dados_parametro.get('estpar_pedido_retrato_paisagem')
        comando_guilhotina = dados_parametro.get('estpar_comando_guilhotina')
        quantidade_vias = "-n" + str(dados_parametro.get('estpar_vias_pedido') or 1)
        pedido = obj_estoquepedidos_pedido_capa.browse(cr, uid, context.get('active_id'))
        if pedido.tipo == 'V':
            if estpar_impressora_pedido and (estpar_pedido_matricial or formato_impressao == '3'):
                ids = context.get('active_id')
                browse_pedido = obj_estoquepedidos_pedido_capa.browse(cr, uid, ids)
                madeireira_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(
                    cr, uid, 'madeireira', context)
                if madeireira_instalado:
                    context['madeireira'] = True
                if estpar_pedido_matricial:
                    self.imprimir_pedido_impressora_matricial(cr, uid, ids, tipo_codigo,
                                                              formato_impressao, context)
                    diretorio = "/tmp/%s.txt" % browse_pedido.numero_pedido
                else:
                    self.processa_pedido_bobina(cr, uid, ids, tipo_codigo, comando_guilhotina,
                                                context)
                    diretorio = "/tmp/%s_bobina.txt" % browse_pedido.numero_pedido
                if estpar_impressora_pedido:
                    impressora = "-d" + estpar_impressora_pedido
                    subprocess.call(["lp", quantidade_vias, impressora, diretorio])
            else:
                aleatorio = random_name()
                documento = 'report.pedido.' + pedido.numero_pedido or ''
                documento += aleatorio
                obj_ir_act_report_xml = pooler.get_pool(cr.dbname).get('ir.actions.report.xml')
                report_id = obj_ir_act_report_xml.search(
                    cr, uid, [('report_name', '=', 'estoquepedidos.pedido.capa')], context=context)
                report_xml = obj_ir_act_report_xml.browse(cr, uid, report_id[0])
                report_pdf = False
                path = '/estoquepedidos/report/rel_estoquepedidos2.rml'
                not context.get('pedcap_pedido_venda_convertido') and pooler.get_pool(
                    cr.dbname).get('estoque.parametro').estpar_converte_formato_impressao(
                    cr, uid, formato_impressao, path, 'p', modo)
                if not context.get('impressao_pedido'):
                    context.update({'impressao_pedido': True})
                    report_pdf = report_sxw.report_sxw(
                        documento, 'estoquepedidos.pedido.capa',
                        'estoquepedidos/report/rel_estoquepedidos2.rml',
                        parser=rel_estoquepedidos2).create_single_pdf(
                        cr, uid, context.get('active_ids'), {'report_type': 'pdf'}, report_xml,
                        context)
                if report_pdf and estpar_impressora_pedido:
                    p = open('/tmp/%s.pdf' % documento, 'wb')
                    p.write(report_pdf[0])
                    p.close()
                    impressora = "-d" + estpar_impressora_pedido
                    subprocess.call(
                        ["lp", quantidade_vias, impressora, "/tmp/%s.pdf" % documento])
                    subprocess.call(['rm', "/tmp/%s.pdf" % documento])

    def imprimir_pedido_impressora_matricial(self, cr, uid, ids, tipo_codigo, formato_impressao,
                                             context=None):
        context = context and context.copy() or {}

        def center_title(E,C,D,T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title
        txt_string = StringIO.StringIO()
        obj_estoquepedidos_pedido_capa = pooler.get_pool(cr.dbname).get(
            'estoquepedidos.pedido.capa')
        obj_adm_utils = pooler.get_pool(cr.dbname).get('adm.utils')
        qtd_linhas_arquivo = 67
        if formato_impressao == '2':
            qtd_linhas_arquivo = 34
        count = 0
        if ids:
            dados_extra = obj_estoquepedidos_pedido_capa.pedcap_get_dado_extra(
                cr, uid, ids, context) or {}
            dados_extra = dados_extra.get(ids)
            browse_pedido = obj_estoquepedidos_pedido_capa.browse(cr, uid, ids)
            pedido_txt = open('/tmp/%s.txt' % browse_pedido.numero_pedido, 'wb')
            pedido_txt.write(self.reseta_configuracao_impressora+self.condensado)
            data_emissao = browse_pedido.data_emissao or ''
            if data_emissao:
                data_emissao = time.strftime('%d/%m/%Y', time.strptime(data_emissao, '%Y-%m-%d'))
            data_entrega = browse_pedido.data_entrega or ''
            if data_entrega:
                data_entrega = time.strftime('%d/%m/%Y', time.strptime(data_entrega, '%Y-%m-%d'))

            pedido_txt.write(('                                                              '
                              ' PEDIDO            EMISSAO: %s     Entrega: %s' %
                              (('%s' % data_emissao).ljust(10),  ('%s' % data_entrega).ljust(10)))
                             + '\r\n')
            count += 1
            status = {'V': 'VALIDADO', 'R': 'ESBOCO', 'S': 'EM SEPERACAO', 'D': 'SEPARADO',
                      'F': 'FATURADO'}.get(browse_pedido.state) or 'CANCELADO'
            descricao = '               NAO E DOCUMENTO FISCAL. NAO E VALIDO COMO RECIBO E COMO ' \
                        'GARANTIA DE MERCADORIA. NAO COMPROVA PAGAMENTO.              '
            pedido_txt.write(self.modo_negrito_on)
            pedido_txt.write(descricao.encode('utf-8')+'\r\n')
            pedido_txt.write(self.modo_negrito_off)
            count += 1
            vendedor = ''
            vendedor_id = browse_pedido.vendedor_id
            if vendedor_id:
                vendedor = obj_adm_utils.admutl_remover_acentuacao(
                    cr, uid, vendedor_id.pessoa_id.name.encode('utf-8')) or ''
            comprador = ''
            comprador_id = browse_pedido.comprador_id
            if comprador_id:
                comprador = obj_adm_utils.admutl_remover_acentuacao(
                    cr, uid, comprador_id.pessoa_id.name.encode('utf-8')) or ''
            if browse_pedido.tipo == 'V':
                pessoa = 'CLIENTE'
                pedido_txt.write(('NUMERO: %s' % browse_pedido.numero_pedido +
                                  '        STATUS: %s                     ' %
                                  status.encode('utf-8') + 'VENDEDOR: %s' %
                                  vendedor + '\r\n').encode('utf-8'))
                count += 1
            else:
                pessoa = 'FORNECEDOR'
                pedido_txt.write(
                    'NUMERO: %s' % browse_pedido.numero_pedido +
                    '        STATUS: %s                     ' %
                    status.encode('utf-8') + 'COMPRADOR: %s' % comprador + '\r\n')
                count += 1
            empresa = obj_adm_utils.admutl_remover_acentuacao(
                cr, uid, browse_pedido.company_id.name.encode('utf-8'))
            pedido_txt.write(
                '%s                                   CNPJ: %s\r\n' % (
                    empresa.encode('utf-8') or '',
                    browse_pedido.company_id.rescon_pessoa_id.cpf_cnpj or ''))
            count += 1
            endereco = obj_adm_utils.admutl_remover_acentuacao(
                cr, uid, ('ENDERECO: %s - %s, %s - %s - %s' % (
                    browse_pedido.company_id.rescon_pessoa_id.endereco,
                    browse_pedido.company_id.rescon_pessoa_id.bairro,
                    browse_pedido.company_id.rescon_pessoa_id.cidade,
                    browse_pedido.company_id.rescon_pessoa_id.uf,
                    browse_pedido.company_id.rescon_pessoa_id.cep)).encode('utf-8'))
            endereco = endereco.encode('utf-8')
            telefone = browse_pedido.company_id.rescon_pessoa_id.telefone or ''
            pedido_txt.write(endereco+'         TELEFONE: %s\r\n' % telefone)
            count += 1
            linha_traco = '-' * 132 + '\r\n'
            pedido_txt.write(linha_traco)
            count += 1
            pessoa_pedido = browse_pedido.pessoa_id.name or ''
            cliente = obj_adm_utils.admutl_remover_acentuacao(
                cr, uid, pessoa_pedido.encode('utf-8'))
            count += 1
            pedido_txt.write('%s: %s - %s     CPF/CNPJ: %s\r\n' % (
                pessoa, browse_pedido.pessoa_id.codigo or '', cliente,
                browse_pedido.pessoa_id.cpf_cnpj or ''))
            count += 1
            endereco_id = browse_pedido.pedcap_endereco_id
            endereco = obj_adm_utils.admutl_remover_acentuacao(
                cr, uid, ('ENDERECO: %s, %s - %s. %s - %s - %s\r\n' % (
                    (endereco_id and endereco_id.logradouro_id.name) or '',
                    (endereco_id and endereco_id.numero) or '',
                    (endereco_id and endereco_id.bairro_id.name) or '',
                    (endereco_id and endereco_id.cidade_id.name) or '',
                    (endereco_id and endereco_id.uf_id.sigla) or '',
                    (endereco_id and endereco_id.cep) or '',)).encode(
                    'utf-8'))

            endereco = endereco.encode('utf-8')
            pedido_txt.write(endereco)
            count += 1
            telefones = browse_pedido.pessoa_id and ', '.join(
                map(lambda m: '(%s) %s' % (m.ddd or ' ', m.numero),
                    browse_pedido.pessoa_id.telefones_ids)) or ''
            pedido_txt.write('TELEFONE: %s \r\n' % telefones.encode('utf-8'))
            count += 1
            pedido_txt.write(linha_traco)
            count += 1
            observacao = browse_pedido.observacao or ''
            observacao = observacao.encode('utf-8')
            if observacao:
                count += 1
                pedido_txt.write('OBSERVACAO: %s\r\n' % observacao)
                pedido_txt.write(linha_traco)
                count += 1
            if context.get('madeireira'):
                pedido_txt.write('PRODUTO                           EMBALAGEM  QTD.PEDIDA  COMPR. '
                                 ' LARG.  ESPES.  VALOR PECA  VALOR DESCONTO     VALOR TOTAL' +
                                 '\r\n')
            else:
                pedido_txt.write('DESCRICAO DO ITEM                                    '
                                 'EMBALAGEM LOCACAO         '
                                 'QUANTIDADE  VALOR BRUTO  VALOR DESCONTO  VALOR TOTAL\r\n')
            count += 1
            total = 0
            itens_pedido = browse_pedido.pedido_item_ids or []
            for x in itens_pedido:
                descricao_produto = x.grade_id.name.encode('utf-8').replace('°', '')
                descricao_produto = obj_adm_utils.admutl_remover_acentuacao(
                    cr, uid, descricao_produto)
                if tipo_codigo == 'I':
                    codigo = x.produto_id.codigo or ''
                elif tipo_codigo == 'F':
                    codigo = x.grade_id.codigo_no_fabricante or ''
                elif tipo_codigo == 'B':
                    codigo = x.produto_id.automacao_ids and \
                             x.produto_id.automacao_ids[0].codigo_barra or str()
                else:
                    codigo = str()

                descricao_produto = ('%s-%s' % (codigo, descricao_produto or ''))

                # Verifica o parametro do estoque que informa se a descricao do item sera impresso
                # em apenas uma linha
                if obj_adm_utils.admutl_get_parametros(
                        cr, uid, 'estoque', ['estpar_item_em_uma_linha'], context=context).get(
                    'estpar_item_em_uma_linha'):
                    descricao_produto = descricao_produto[:52]

                linha = formataString(descricao_produto, 52, ' ', 'D', 'N', 'S') + ' ' + \
                        formataString(x.produto_embalagem_id.embalagem_id.name or '', 9, ' ', 'D',
                                      'N','S') + ' '
                if not context.get('madeireira'):
                    linha += formataString(x.pedite_pedido_item_locacao or '', 14, ' ', 'D',
                                           'N', 'S') + ' '
                linha += formataString(getNumeroEditado(x.qtde_pedida or 0, 2), 11, ' ', 'E', 'N',
                                      'S') + ' '
                if context.get('madeireira'):
                    linha += formataString(getNumeroEditado(x.pedite_comprimento or 0, 2), 7, ' ',
                                           'E', 'N', 'S') + ' ' + \
                             formataString(getNumeroEditado(x.pedite_largura or 0, 2), 6, ' ', 'E',
                                           'N','S') + ' ' + \
                             formataString(getNumeroEditado(x.pedite_espessura or 0, 2), 7, ' ',
                                           'E', 'N', 'S') + ' ' + \
                             formataString(getNumeroEditado((x.valor_total/x.qtde_pedida), 2), 11,
                                           ' ', 'E', 'N', 'S') + ' ' + \
                             formataString(getNumeroEditado(x.vr_desconto or 0, 2), 15, ' ', 'E',
                                           'N', 'S') + ' ' + \
                             formataString(getNumeroEditado(x.valor_total or 0, 2), 15, ' ', 'E',
                                           'N', 'S') + '\r\n'
                else:
                    linha += formataString(getNumeroEditado(x.vr_unitario or 0, 2), 12, ' ', 'E',
                                           'N', 'S') + ' ' + \
                             formataString(getNumeroEditado(x.vr_desconto or 0, 2), 15, ' ', 'E',
                                           'N', 'S') + ' ' + \
                             formataString(getNumeroEditado(x.valor_total or 0, 2), 12, ' ', 'E',
                                           'N', 'S') + '\r\n'
                pedido_txt.write(linha)
                count = self.calcula_quebra_de_linha(
                    cr, uid, count, pedido_txt, formato_impressao, browse_pedido)

                if len(descricao_produto) > 52:
                    descricao_produto = descricao_produto[52:]
                    while descricao_produto:
                        linha = formataString(descricao_produto[:52], 132, ' ', 'D', 'N', 'S')
                        pedido_txt.write(linha + '\r\n')
                        count = self.calcula_quebra_de_linha(cr, uid, count, pedido_txt,
                                                             formato_impressao, browse_pedido)
                        descricao_produto = descricao_produto[52:]

                total += x.valor_total or 0
            tamanho_linha_total = 85
            if context.get('madeireira'):
                tamanho_linha_total = 104
            if browse_pedido.pedcap_percentual_desconto:
                perc_desconto = browse_pedido.pedcap_percentual_desconto
            else:
                if not total:
                    perc_desconto = 0
                else:
                    perc_desconto = ((browse_pedido.vr_desconto or 0) / total) * 100

            linha = formataString('TOTAL BRUTO', tamanho_linha_total, ' ', 'D', 'N', 'S') + \
                    formataString(getNumeroEditado(total, 2), 27, ' ', 'E', 'N', 'S') + '\r\n'
            pedido_txt.write(linha)
            count = self.calcula_quebra_de_linha(
                cr, uid, count, pedido_txt, formato_impressao, browse_pedido)
            linha = formataString('TOTAL', tamanho_linha_total, ' ', 'D', 'N', 'S') + \
                    formataString(getNumeroEditado(browse_pedido.valor_total or 0, 2), 27, ' ',
                                  'E', 'N', 'S') + '\n\r'
            pedido_txt.write(linha)
            count = self.calcula_quebra_de_linha(cr, uid, count, pedido_txt, formato_impressao,
                                                 browse_pedido)
            pedido_txt.write(linha_traco)
            count = self.calcula_quebra_de_linha(cr, uid, count, pedido_txt, formato_impressao,
                                                 browse_pedido)

            # Espacamento especial para impressao meia-pagina. Evita a sensacao de cabecalho
            # repetido.
            if formato_impressao == '2' and count in (25, 26):
                var = count
                for cc in range(var, 29):
                    pedido_txt.write('\r\n')
                    count = self.calcula_quebra_de_linha(cr, uid, count, pedido_txt,
                                                         formato_impressao, browse_pedido)

            pedido_txt.write('VALOR SEGURO: %s        VALOR DESP. ACESSORIAS: %s         VALOR '
                             'DESCONTO: %s  %% DESCONTO: %s       VALOR FRETE: %s       '  % (
                getNumeroEditado(browse_pedido.vr_seguro or 0, 2),
                getNumeroEditado(browse_pedido.vr_despesas_acessorias or 0, 2),
                getNumeroEditado(browse_pedido.vr_desconto or 0, 2),
                getNumeroEditado(perc_desconto, 2),
                getNumeroEditado(browse_pedido.vr_frete or 0, 2)) + '\r\n')
            count = self.calcula_quebra_de_linha(cr, uid, count, pedido_txt, formato_impressao,
                                                 browse_pedido)
            pedido_txt.write(linha_traco)
            count = self.calcula_quebra_de_linha(cr, uid, count, pedido_txt, formato_impressao,
                                                 browse_pedido)
            pedido_txt.write(('FORMA PAGAMENTO               CONDICAO PAGAMENTO                   '
                              '    VALOR                                       DATA VENCIMENTO' +
                              '\r\n'))
            count = self.calcula_quebra_de_linha(cr, uid, count, pedido_txt, formato_impressao,
                                                 browse_pedido)
            parcelas_pedido = browse_pedido.pedido_parcela_ids
            for p in parcelas_pedido:
                data_vencimento = time.strftime(
                    '%d/%m/%Y', time.strptime(p.data_vencimento, '%Y-%m-%d'))
                linha = formataString(p.pedido_condicao_id.forma_pagto_id.name, 29, ' ', 'D', 'N',
                                      'S') + ' ' + \
                        formataString(p.pedido_condicao_id.condicao_forma_id.adm_condicao_id.name,
                                      30,' ','D','N','S') + ' ' + \
                        formataString(getNumeroEditado(p.vr_parcela or 0, 2), 15,' ', 'E', 'N',
                                      'S') + ' ' + \
                        formataString(data_vencimento or '', 53, ' ', 'E', 'N', 'S') + '\r\n'
                pedido_txt.write(linha)
                count = self.calcula_quebra_de_linha(
                    cr, uid, count, pedido_txt, formato_impressao, browse_pedido)
            pedido_txt.write(linha_traco)
            count = self.calcula_quebra_de_linha(
                cr, uid, count, pedido_txt, formato_impressao, browse_pedido)
            pedido_txt.write(' ' * 85 + '  ** Sig Informatica LTDA **                  ')
            if count == 28 and formato_impressao == '2':
                context['end'] = True
            count = self.calcula_quebra_de_linha(
                cr, uid, count, pedido_txt, formato_impressao, browse_pedido, context)
        txt_string.close()
        if count and count < qtd_linhas_arquivo:
            var = qtd_linhas_arquivo - count
            for c in range(0, var):
                pedido_txt.write('\r\n')
        pedido_txt.write(self.reseta_configuracao_impressora)
        pedido_txt.close()

        return True

    def calcula_quebra_de_linha(self, cr, uid, count, txt, formato_impressao, browse_pedido=None,
                                context=None):
        context = context and context.copy() or {}
        count += 1
        if (formato_impressao == '2' and count != 29) or (formato_impressao == '1' and count != 63):
            return count
        count = 0
        if formato_impressao == '2':
            for c in range(0, 5):
                txt.write('\r\n')
        elif formato_impressao == '1':
            for c in range(0, 3):
                txt.write('\r\n')
        if context.get('end'):
            return 34
        txt.write(self.reseta_configuracao_impressora+self.condensado)
        vendedor = ''
        vendedor_id = browse_pedido.vendedor_id
        if vendedor_id:
            vendedor = vendedor_id.pessoa_id.name or ''
        comprador = ''
        comprador_id = browse_pedido.comprador_id
        obj_adm_utils = self.pool.get('adm.utils')
        if comprador_id:
            comprador = obj_adm_utils.admutl_remover_acentuacao(cr, uid,
                comprador_id.pessoa_id.name.encode('utf-8')) or ''
        data_emissao = browse_pedido.data_emissao or ''
        if data_emissao:
            data_emissao = time.strftime('%d/%m/%Y', time.strptime(
                browse_pedido.data_emissao, '%Y-%m-%d'))
        status = {'V': 'VALIDADO', 'R': 'ESBOCO', 'S': 'EM SEPERACAO', 'D': 'SEPARADO',
                  'F': 'FATURADO'}.get(browse_pedido.state) or 'CANCELADO'
        txt.write(('                                                               PEDIDO         '
                   '                              EMISSAO: %s' % data_emissao) + '\r\n')
        txt.write(self.modo_negrito_on)
        descricao = '               NAO E DOCUMENTO FISCAL. NAO E VALIDO COMO RECIBO E COMO ' \
                    'GARANTIA DE MERCADORIA. NAO COMPROVA PAGAMENTO.              '
        txt.write(descricao + '\r\n')
        txt.write(self.modo_negrito_off)
        if browse_pedido.tipo == 'V':
            txt.write(('NUMERO: %s' % browse_pedido.numero_pedido +
                       '        STATUS: %s                     ' % status.encode('utf-8') +
                       'VENDEDOR: %s' % vendedor+'\r\n').encode('utf-8'))
        else:
            txt.write('NUMERO: %s' % browse_pedido.numero_pedido +
                      '        STATUS: %s                     ' % status.encode('utf-8') +
                      'COMPRADOR: %s' % comprador+'\r\n')
        empresa = obj_adm_utils.admutl_remover_acentuacao(
            cr, uid, browse_pedido.company_id.name.encode('utf-8'))
        txt.write('%s                                   CNPJ: %s\r\n'
                  % (empresa.encode('utf-8') or '',
                     browse_pedido.company_id.rescon_pessoa_id.cpf_cnpj or ''))
        desc_cidade = obj_adm_utils.admutl_remover_acentuacao(
            cr, uid, browse_pedido.company_id.rescon_pessoa_id.cidade.encode('utf-8'))
        endereco = 'ENDERECO: %s - %s, %s - %s - %s' % (
            browse_pedido.company_id.rescon_pessoa_id.endereco,
            browse_pedido.company_id.rescon_pessoa_id.bairro,
            desc_cidade,
            browse_pedido.company_id.rescon_pessoa_id.uf,
            browse_pedido.company_id.rescon_pessoa_id.cep)
        endereco = endereco.encode('utf-8')
        telefone = browse_pedido.company_id.rescon_pessoa_id.telefone or ''
        txt.write(endereco+'         TELEFONE: %s\r\n' % str(telefone))
        txt.write('-' * 132 + '\r\n')
        count += 6

        return count

    def processa_pedido_bobina(self, cr, uid, ids, tipo_codigo, comando_guilhotina, context=None):
        """
        Organiza os dados do pedido num arquivo txt (/tmp/numeropedido_bobina.txt). O arquivo e
        formatado em 42 caracteres por linha, padrao bobina. Posteriormente, caso a impressora
        esteja cadastrada nos parametros do estoque, o arquivo e impresso.
        :param cr: cursor no banco de dados
        :param uid: id da tabela res_users, identificador do usuario
        :param ids: id da tabela estoquepedidos_pedido_capa, identificador do pedido
        :param tipo_codigo: char 'I' para interno e 'F' para fabricante. Codigo que sera impresso a
        respeito do item (produto)
        :param comando_guilhotina: char com comando para corte do papel
        :param context: dicionario com valores contextuais
        :return: booleano True
        """
        context = context and context.copy() or {}
        obj_estoquepedidos_pedido_capa = pooler.get_pool(cr.dbname).get(
            'estoquepedidos.pedido.capa')
        obj_adm_utils = pooler.get_pool(cr.dbname).get('adm.utils')
        obj_financeiro_cliente = pooler.get_pool(cr.dbname).get('financeiro.cliente')
        obj_financeiro_clientes_mensagem = pooler.get_pool(cr.dbname).get(
            'financeiro.clientes.mensagem')
        obj_financeiro_clientes_mensagem_nome = pooler.get_pool(cr.dbname).get(
            'financeiro.clientes.mensagem.nome')
        dados_extra = obj_estoquepedidos_pedido_capa.pedcap_get_dado_extra(
            cr, uid, ids, context) or {}
        dados_extra = dados_extra.get(ids)
        if not ids:
            return True
        browse_pedido = obj_estoquepedidos_pedido_capa.browse(cr, uid, ids, context)
        pedido_txt = open('/tmp/%s_bobina.txt' % browse_pedido.numero_pedido, 'wb')
        data_emissao = browse_pedido.data_emissao or ''
        if data_emissao:
            data_emissao = time.strftime('%d/%m/%Y', time.strptime(data_emissao,
                                                                   '%Y-%m-%d'))
        data_entrega = browse_pedido.data_entrega or ''
        if data_entrega:
            data_entrega = time.strftime('%d/%m/%Y', time.strptime(data_entrega,
                                                                   '%Y-%m-%d'))
        line_size = 42
        line_break = '\r\n'
        numero_pedido = browse_pedido.numero_pedido
        pedido_txt.write(formataString('-' * line_size, line_size, ' ', 'D', 'N', 'S') + line_break)
        linha = formataString('Pedido: %s' % numero_pedido, 23, ' ', 'D', 'N', 'S')
        linha += formataString('Emissao: %s' % data_emissao, 19, ' ', 'E', 'N', 'S')
        pedido_txt.write(linha + line_break)
        pedido_txt.write('' + line_break)
        pedido_txt.write(formataString('NAO E DOCUMENTO FISCAL. NAO E VALIDO COMO ',
                                       line_size, ' ', 'C', 'N', 'S') + line_break)
        pedido_txt.write(formataString('RECIBO E COMO GARANTIA DE MERCADORIA.', line_size, ' ', 'C', 'N',
                                       'S') + line_break)
        pedido_txt.write(formataString('NAO COMPROVA PAGAMENTO.', line_size, ' ', 'C', 'N', 'S') +
                         line_break)
        pedido_txt.write('' + line_break)
        empresa = obj_adm_utils.admutl_remover_acentuacao(
            cr, uid, browse_pedido.company_id.name.encode('utf-8'))
        pedido_txt.write(formataString(empresa, line_size, ' ', 'D', 'N', 'S') + line_break)
        linha = 'CNPJ: %s' % browse_pedido.company_id.rescon_pessoa_id.cpf_cnpj or ''
        linha = formataString(linha, line_size, ' ', 'D', 'N', 'S')
        pedido_txt.write(linha + line_break)
        linha = obj_adm_utils.admutl_remover_acentuacao(
            cr, uid, '%s' % browse_pedido.company_id.rescon_pessoa_id.endereco).encode('utf-8')
        linha = formataString(linha, line_size, ' ', 'D', 'N', 'S')
        pedido_txt.write(linha + line_break)
        if len(browse_pedido.company_id.rescon_pessoa_id.endereco) > 42:
            linha = obj_adm_utils.admutl_remover_acentuacao(
                cr, uid, browse_pedido.company_id.rescon_pessoa_id.endereco).encode('utf-8')
            linha = formataString(linha[42:], line_size, ' ', 'D', 'N', 'S')
            pedido_txt.write(linha + line_break)
        endereco = obj_adm_utils.admutl_remover_acentuacao(cr, uid, ('%s - %s - %s' % (
            browse_pedido.company_id.rescon_pessoa_id.cep,
            browse_pedido.company_id.rescon_pessoa_id.cidade,
            browse_pedido.company_id.rescon_pessoa_id.uf)).encode('utf-8'))
        linha = formataString(endereco, line_size, ' ', 'D', 'N', 'S')
        pedido_txt.write(linha + line_break)
        telefone = 'Telefone: %s' % browse_pedido.company_id.rescon_pessoa_id.telefone
        linha = formataString(telefone, line_size, ' ', 'D', 'N', 'S')
        pedido_txt.write(linha + line_break)
        pedido_txt.write('' + line_break)
        if browse_pedido.tipo == 'V':
            pessoa = 'CLIENTE'
        else:
            pessoa = 'FORNECEDOR'
        pessoa_pedido = browse_pedido.pessoa_id.name or ''
        cliente = obj_adm_utils.admutl_remover_acentuacao(cr, uid, pessoa_pedido.encode('utf-8'))
        linha = formataString('CODIGO: %s' % browse_pedido.pessoa_id.codigo, line_size, ' ', 'D', 'N', 'S')
        pedido_txt.write(linha + line_break)
        linha = pessoa + ': %s' % cliente
        linha = formataString(linha, line_size, ' ', 'D', 'N', 'S')
        pedido_txt.write(linha + line_break)
        linha = formataString('CPF/CNPJ:%s' % (browse_pedido.pessoa_id.cpf_cnpj or ''), 26, ' ',
                              'D', 'N', 'S') + ' ' + \
            formataString('IE:%s' % (browse_pedido.pessoa_id.admpes_jur_ie or ''), 16, ' ',
                          'D', 'N', 'S') + line_break
        pedido_txt.write(linha)
        endereco_id = browse_pedido.pedcap_endereco_id
        endereco = (endereco_id and endereco_id.logradouro_id.name) or ''
        if endereco_id:
            if endereco_id.numero:
                endereco += ', ' + endereco_id.numero
            if endereco_id.complemento:
                endereco += '-' + endereco_id.complemento

        linha_end_pes = 'Endereco: %s' % endereco or ''
        linha_end_pes = obj_adm_utils.admutl_remover_acentuacao(
            cr, uid, linha_end_pes).encode('utf-8')
        linha = formataString(linha_end_pes, line_size, ' ', 'D', 'N', 'S')
        pedido_txt.write(linha + line_break)
        if len(linha_end_pes) > 42:
            linha = obj_adm_utils.admutl_remover_acentuacao(cr, uid, linha_end_pes).encode('utf-8')
            linha = formataString(linha[42:], line_size, ' ', 'D', 'N', 'S')
            pedido_txt.write(linha + line_break)
        linha = 'Bairro: %s' % (endereco_id and endereco_id.bairro_id.name) or ''
        linha = obj_adm_utils.admutl_remover_acentuacao(
            cr, uid, linha).encode('utf-8')
        linha = formataString(linha, line_size, ' ', 'D', 'N', 'S')
        pedido_txt.write(linha + line_break)
        endereco = obj_adm_utils.admutl_remover_acentuacao(cr, uid, ('%s - %s - %s' % (
            ((endereco_id and endereco_id.cep) or ''),
            ((endereco_id and endereco_id.cidade_id.name) or ''),
            ((endereco_id and endereco_id.uf_id.sigla) or ''))).encode('utf-8'))
        linha = formataString(endereco, line_size, ' ', 'D', 'N', 'S')
        pedido_txt.write(linha + line_break)

        telefones = browse_pedido.pessoa_id and ', '.join(
            map(lambda m: 'Telefone: (%s) %s' % (m.ddd or ' ', m.numero),
                browse_pedido.pessoa_id.telefones_ids)) or ''
        linha = formataString(telefones, line_size, ' ', 'D', 'N', 'S')
        pedido_txt.write(linha + line_break + line_break)

        if dados_extra:
            linha = formataString('Origem: %s' % (dados_extra.get('origem') or ''), line_size,
                                  ' ', 'D', 'N', 'S') + line_break
            pedido_txt.write(linha)
            linha = formataString('Vendedor: %s' % (dados_extra.get('vendedor')), line_size,
                                  ' ', 'D', 'N', 'S') + line_break
            pedido_txt.write(linha)
            linha = formataString('Vendedor externo: %s' % (dados_extra.get('vendedor_externo')),
                                  line_size, ' ', 'D', 'N', 'S') + line_break
            pedido_txt.write(linha)
            linha = formataString('Entrega: %s' % data_entrega, 20, ' ', 'D', 'N', 'S') + ' ' + \
                    formataString('Horario: %s' % (dados_extra.get('horario_entrega') or ''), 21,
                                  ' ', 'D', 'N', 'S') + line_break
            pedido_txt.write(linha)

        pedido_txt.write(formataString('-' * line_size, line_size, ' ', 'D', 'N', 'S') + line_break)

        pedido_txt.write(formataString('Produto', line_size, ' ', 'D', 'N', 'S') + line_break)
        linha = formataString('Codigo', 10, ' ', 'D', 'N', 'S') + ' ' + \
                formataString('emb', 6, ' ', 'D', 'N', 'S') + ' ' + \
                formataString('qtd', 6, ' ', 'E', 'N', 'S') + ' ' + \
                formataString('vunit', 6, ' ', 'E', 'N', 'S') + ' ' + \
                formataString('vtotal', 10, ' ', 'E', 'N', 'S')
        pedido_txt.write(linha + line_break)
        linha = formataString('Observacao', line_size, ' ', 'D', 'N', 'S')
        pedido_txt.write(linha + line_break)
        pedido_txt.write(formataString('-' * line_size, line_size, ' ', 'D', 'N', 'S') + line_break)
        total = 0
        itens_pedido = browse_pedido.pedido_item_ids or []
        for x in itens_pedido:
            descricao_produto = x.grade_id.name.encode('utf-8').replace('°', '')
            descricao_produto = obj_adm_utils.admutl_remover_acentuacao(cr, uid, descricao_produto)
            codigo = ''
            if tipo_codigo == 'I':
                codigo = x.produto_id.codigo or ''
            elif tipo_codigo == 'F':
                codigo = x.grade_id.codigo_no_fabricante or ''
            linha = formataString(descricao_produto, line_size, ' ', 'D', 'N', 'S')
            pedido_txt.write(linha + line_break)
            linha = formataString(codigo, 10, ' ', 'D', 'N', 'S') + ' ' + \
                formataString(x.produto_embalagem_id.embalagem_id.unidade_id.unidade or '', 6, ' ',
                              'D', 'N', 'S') + ' ' + \
                formataString(getNumeroEditado(x.qtde_pedida or 0, 2), 6, ' ', 'E', 'N',
                              'S') + ' ' + \
                formataString(getNumeroEditado(x.vr_unitario or 0, 2), 6, ' ', 'E', 'N',
                              'S') + ' ' + \
                formataString(getNumeroEditado(x.valor_total or 0, 2), 10, ' ', 'E', 'N', 'S')
            pedido_txt.write(linha + line_break)
            total += x.valor_total or 0
            if not x.observacao:
                continue
            descricao_observacao = x.observacao.encode('utf-8').replace('°', '')
            descricao_observacao = obj_adm_utils.admutl_remover_acentuacao(cr, uid,
                                                                           descricao_observacao)
            linha = formataString(descricao_observacao, line_size, ' ', 'D', 'N', 'S')
            pedido_txt.write(linha + line_break)
        pedido_txt.write(formataString('-' * line_size, line_size, ' ', 'D', 'N', 'S') + line_break)
        linha = formataString('Subtotal', 21, ' ', 'D', 'N', 'S')
        linha += formataString(getNumeroEditado(total, 2), 21, ' ', 'E', 'N', 'S')
        pedido_txt.write(linha + line_break)
        linha = formataString('Desconto', 21, ' ', 'D', 'N', 'S')
        linha += formataString(getNumeroEditado(browse_pedido.vr_desconto or 0, 2), 21, ' ', 'E',
                               'N', 'S')
        pedido_txt.write(linha + line_break)
        if browse_pedido.pedcap_percentual_desconto:
            perc_desconto = browse_pedido.pedcap_percentual_desconto
        else:
            perc_desconto = ((browse_pedido.vr_desconto or 0) / total) * 100
        linha = formataString('% Desconto', 21, ' ', 'D', 'N', 'S')
        linha += formataString(getNumeroEditado(perc_desconto, 2), 21, ' ', 'E',
                               'N', 'S')
        pedido_txt.write(linha + line_break)

        if browse_pedido.vr_despesas_acessorias:
            linha = formataString('Despesas acessorias', 21, ' ', 'D', 'N', 'S')
            linha += formataString(getNumeroEditado(browse_pedido.vr_despesas_acessorias, 2), 21,
                                   ' ', 'E', 'N', 'S')
            pedido_txt.write(linha + line_break)

        if browse_pedido.vr_seguro:
            linha = formataString('Seguro', 21, ' ', 'D', 'N', 'S')
            linha += formataString(getNumeroEditado(browse_pedido.vr_seguro, 2), 21,
                                   ' ', 'E', 'N', 'S')
            pedido_txt.write(linha + line_break)

        if browse_pedido.vr_frete:
            linha = formataString('Frete', 21, ' ', 'D', 'N', 'S')
            linha += formataString(getNumeroEditado(browse_pedido.vr_frete, 2), 21,
                                   ' ', 'E', 'N', 'S')
            pedido_txt.write(linha + line_break)

        linha = formataString('Total', 21, ' ', 'D', 'N', 'S')
        linha += formataString(getNumeroEditado(browse_pedido.valor_total, 2), 21, ' ', 'E', 'N',
                               'S')
        pedido_txt.write(linha + line_break)

        pedido_txt.write('' + line_break)
        linha = formataString('Forma de pag.', 13, ' ', 'D', 'N', 'S') + ' ' + \
                formataString('Vencimento', 10, ' ', 'D', 'N', 'S') + ' ' + \
                formataString('Valor', 10, ' ', 'E', 'N', 'S') + ' '
        if dados_extra:
            linha += formataString('Troco', 6, ' ', 'E', 'N', 'S')
        else:
            linha += formataString('', 6, ' ', 'E', 'N', 'S')
        pedido_txt.write(linha + line_break)
        pedido_txt.write(formataString('-' * line_size, line_size, ' ', 'D', 'N', 'S') + line_break)
        parcelas_pedido = browse_pedido.pedido_parcela_ids
        for p in parcelas_pedido:
            data_vencimento = time.strftime(
                '%d/%m/%Y', time.strptime(p.data_vencimento, '%Y-%m-%d'))
            linha = formataString(p.pedido_condicao_id.condicao_forma_id.adm_condicao_id.name, 13,
                                  ' ', 'D', 'N', 'S') + ' ' + \
                    formataString(data_vencimento or '', 10, ' ', 'E', 'N', 'S') + ' ' + \
                    formataString(getNumeroEditado(p.vr_parcela or 0, 2), 10, ' ', 'E', 'N',
                                  'S') + ' '
            if dados_extra.get('condicao_dados'):
                linha += formataString(getNumeroEditado(dados_extra.get('condicao_dados').get(
                    p.pedido_condicao_id.id) or 0, 2), 6, ' ', 'E', 'N', 'S')
            else:
                linha += formataString('', 6, ' ', 'E', 'N', 'S')
            pedido_txt.write(linha + line_break)
        if browse_pedido.observacao:
            pedido_txt.write('' + line_break)
            observacao = browse_pedido.observacao
            tam = 12
            linha = 'Observacao: '
            while observacao:
                linha += formataString(observacao[:line_size - tam], line_size - tam, ' ', 'D', 'N',
                                       'S')
                observacao = observacao[line_size - tam:]
                tam = 0
                pedido_txt.write(linha + line_break)
                linha = ''
        pedido_txt.write(formataString('-' * line_size, line_size, ' ', 'D', 'N', 'S') + line_break)

        pedido_txt.write(line_break)
        cliente_ids = obj_financeiro_cliente.search(
            cr, uid, [('pessoa_id', '=', browse_pedido.pessoa_id.id)], context=context)
        mensagem_ids = cliente_ids and obj_financeiro_cliente.read(
            cr, uid, cliente_ids[0], ['mensagem_ids'], context, '_classic_write').get(
            'mensagem_ids') or []
        cliente_mensagem_dados = obj_financeiro_clientes_mensagem.read(
            cr, uid, mensagem_ids, ['modo_exibicao', 'mensagens_id'], context, '_classic_write')
        cliente_mensagem_dados = filter(lambda m: m.get('modo_exibicao') == 'I',
                                        cliente_mensagem_dados)
        cliente_mensagem_dados and pedido_txt.write('Mensagens:' + line_break)
        for m in cliente_mensagem_dados:
            mensagem_nome_id = m.get('mensagens_id')
            mensagem = obj_financeiro_clientes_mensagem_nome.read(
                cr, uid, mensagem_nome_id, ['name'], context).get('name')
            pedido_txt.write(
                formataString(mensagem[:42], line_size, ' ', 'D', 'N', 'S') + line_break)
            mensagem = mensagem[42:]
            mensagem and pedido_txt.write(formataString(
                mensagem, line_size, ' ', 'D', 'N', 'S') + line_break)

        for c in range(1, 8):
            pedido_txt.write('' + line_break)
        if comando_guilhotina:
            try:
                pedido_txt.write(''.join(map(lambda x: chr(int(x)),comando_guilhotina.split('-'))))
            except:
                pass
        pedido_txt.close()

        return True

report_sxw.report_sxw('report.estoquepedidos.pedido.capa', 'estoquepedidos.pedido.capa',
                      'estoquepedidos/report/rel_estoquepedidos2.rml', parser=rel_estoquepedidos2,
                      header=False)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

