# -*- coding: utf-8 -*-

from openerp.osv import fields, osv
from openerp.tools.translate import _


class wizard_alterar_preco_venda_estoquepedidos(osv.TransientModel):
    _name = 'wizard.alterar.preco.venda.estoquepedidos'
    _description = 'Alterar preco de venda'

    _columns = {
        'login': fields.char('Login', size=30),
        'senha': fields.char('Senha', size=30),
        'produto_id': fields.many2one('estoque.produto', 'Produto'),
        'preco_venda': fields.float('Preco', digits=(9, 2)),
        'altera': fields.boolean('pode alterar Preco de venda'),
        'texto': fields.text('log'),
        'altera_login': fields.boolean('precisa alterar login e senha'),
    }
    _defaults = {
        'altera': lambda *a: False,
        'altera_login': lambda *a: True,
    }

    def default_get(self, cr, uid, fields_list, context=None):
        context = context and context.copy() or {}
        res = osv.osv_memory.default_get(self, cr, uid, fields_list, context=context)
        item_id = context.get('active_id', False)
        if item_id:
            produto = self.pool.get('estoquepedidos.pedido.item').read(cr, uid, item_id, ['produto_id', 'vr_unitario'], context=context)
            if produto and produto.get('produto_id', False):
                res['produto_id'] = produto['produto_id'][0]
                res['preco_venda'] = produto['vr_unitario']
            #        obj = self.pool.get('ir.model.access')
            #        usuario_pertence_grupo = obj.check_groups(cr, uid, 'estoque.group_estoque_alterar_preco')
            #        if usuario_pertence_grupo:
            #            res['altera']=True
            #            res['altera_login']=False

        return res

    def onchange_dados(self, cr, uid, ids, login, senha, context=None):
        context = context and context.copy() or {}
        val = {
            'value': {'altera': False, 'altera_login': True},
            'texto': False,
        }
        obj_ir_model_access = self.pool.get('ir.model.access')
        if not login or not senha:
            return val
        obj_res_users = self.pool.get('res.users')
        usuario_ids = obj_res_users.search(
            cr, uid, [('login', '=', login)], context=context)
        if not usuario_ids:
            val = {'value': {'texto': _('Usuario nao cadastrado')}}
            return val
        list_usuario = list()
        for user_id in usuario_ids:
            try:
                obj_res_users.check_credentials(cr, user_id, senha)
                list_usuario.append(user_id)
            except:
                pass
        if list_usuario:
            usuario = list_usuario[0]
            res = obj_ir_model_access.check_groups(cr, usuario,
                                                   'estoque.group_estoque_alterar_preco')
            if not res:
                res = obj_ir_model_access.check_groups(cr, usuario, 'prime.group_prime_manager')
            if res:
                val = {'value': {'altera': True}}
            else:
                val = {'value': {'texto': _('Usuario sem permissao')}}
        else:
                val = {'value': {'texto': _('Usuario sem permissao')}}
        return val

    def altera_preco_venda(self, cr, uid, ids, context=None):
        """
            Contexto criado pois o metodo 'write' usa um metodo onchange que recalcula o preco de venda
        """
        context = context and context.copy() or {}
        context['pedido_preco_venda'] = True
        preco_venda = self.read(cr, uid, ids, ['preco_venda'], context=context)
        if preco_venda:
            preco_venda = preco_venda[0]['preco_venda']
            item_id = context.get('active_id', False)
            if item_id:
                self.pool.get('estoquepedidos.pedido.item').write(cr, uid, item_id, {'pei_preco_venda': preco_venda},
                                                                  context=context)
        return {'type': 'ir.actions.act_window_close'}


