# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
import random
import string
from openerp.report import report_sxw
from openerp.tools.translate import _
import time
from openerp import pooler


def random_name():
    random.seed()
    d = [random.choice(string.ascii_letters) for x in xrange(3)]
    name = "".join(d)
    return name


class impressao_pedido(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context):
        super(impressao_pedido, self).__init__(cr, uid, name, context=context)

        dados_parametro = pooler.get_pool(cr.dbname).get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', 'estpar_pedido_tipo_codigo', context=context)
        tipo_codigo = dados_parametro.get('estpar_pedido_tipo_codigo')
        obj_estoquepedidos_pedido_capa = pooler.get_pool(cr.dbname).get(
            'estoquepedidos.pedido.capa')
        dados_extra = obj_estoquepedidos_pedido_capa.pedcap_get_dado_extra(
            cr, uid, context.get('active_ids'), context=context) or {}

        self.localcontext.update({
            'time': time,
            'getNumeroEditado': self.pool.get('adm.utils').admutl_get_valor_formatado,
            'int': int,
            'tipo_codigo': tipo_codigo,
            'vendedor_externo': _('Vendedor externo:'),
            'dado_extra': dados_extra
        })
        self.context = context


class wizard_email_pessoa(osv.TransientModel):
    # prefixo: wizemp_
    _name = 'wizard.email.pessoa'
    _columns = {
        'wizemp_pessoa_id': fields.many2one('adm.pessoa', 'Pessoa'),
        'wizemp_email_ids': fields.one2many('wizard.email.pessoa.item', 'wizemi_capa_id', 'Itens'),
    }

    def default_get(self, cr, uid, fields_list, context=None):
        """
        O metodo carrega valores padrão para os campos da tela.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param fields_list: lista com os campos da tela.
        :type fields_list: list
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: dicionario com a descricao dos campos e seus respectivos valores.
        :rtype: dict
        """
        context = context and context.copy() or {}
        res = super(wizard_email_pessoa, self).default_get(cr, uid, fields_list, context)
        obj_adm_pessoa_email = self.pool.get('adm.pessoa.email')
        brw_pedido = self.pool.get('estoquepedidos.pedido.capa').browse(
            cr, uid, context.get('active_id'), context)
        if not brw_pedido.pessoa_id:
            return res
        email_ids = obj_adm_pessoa_email.search(
            cr, uid, [('pessoa_id', '=', brw_pedido.pessoa_id.id)], context=context)
        wizemp_email_ids = []
        for email in obj_adm_pessoa_email.browse(cr, uid, email_ids, context):
            wizemp_email_ids.append((0, 0, {'wizemi_email': email.name,
                                            'wizemi_setor_ids': map(lambda i: i.id,
                                                                    email.admpem_setor_ids)}))
        res['wizemp_email_ids'] = wizemp_email_ids
        res['wizemp_pessoa_id'] = brw_pedido.pessoa_id.id
        return res

    def wizemp_send_email(self, cr, uid, ids, context=None):
        """
        O metodo realiza o envio dos e-mails dos pedidos.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dicionario com valores contextuais.
        :return: True, para sucesso no envio do e-mail. Raise, caso contrario.
        :rtype: bool
        """
        context = context and context.copy() or {}
        obj_adm_util = self.pool.get('adm.utils')
        obj_financeiro_emails_cadastro = self.pool.get('financeiro.emails.cadastro')
        obj_estoquepedidos_pedido_capa = self.pool.get('estoquepedidos.pedido.capa')
        brw_estoquepedidos_pedido_capa = obj_estoquepedidos_pedido_capa.browse(
            cr, uid, context.get('active_id'), context)
        numero_pedido = brw_estoquepedidos_pedido_capa.numero_pedido or ''
        mail_server_id = brw_estoquepedidos_pedido_capa.company_id.servidor_smtp_id.id or None
        aleatorio = random_name()
        documento = 'report.pedido.' + numero_pedido
        documento += aleatorio
        obj_ir_act_report_xml = self.pool.get('ir.actions.report.xml')
        report_id = obj_ir_act_report_xml.search(
            cr, uid, [('report_name', '=', 'estoquepedidos.pedido.capa')], context=context)
        report_xml = obj_ir_act_report_xml.browse(cr, uid, report_id[0])
        report_pdf = report_sxw.report_sxw(
            documento, 'estoquepedidos.pedido.capa',
            'estoquepedidos/report/rel_estoquepedidos2.rml',
            parser=impressao_pedido).create_single_pdf(cr, uid, context.get('active_ids'),
                                                       {'report_type': 'pdf'}, report_xml, context=context)
        report_pdf = report_pdf[0].encode('base64')
        estoque_parametro_dados = obj_adm_util.admutl_get_parametros(
            cr, uid, 'estoque', 'estpar_email_mensagem_id', context=context)
        email_cadastro_id = estoque_parametro_dados.get('estpar_email_mensagem_id')
        if not email_cadastro_id:
            raise osv.except_osv(_('Atencao'), _("Cadastre o 'E-mail' nos parametros do estoque"))
        brw_financeiro_emails_cadastro = obj_financeiro_emails_cadastro.browse(
            cr, uid, email_cadastro_id, context=context)
        assunto_email = brw_financeiro_emails_cadastro.fineca_assunto
        texto_email = brw_financeiro_emails_cadastro.fineca_corpo
        list_email = map(lambda i: i.wizemi_email,
                         self.browse(cr, uid, ids[0], context=context).wizemp_email_ids)
        mail_id = obj_adm_util.admutl_send_email(
            cr, uid, email=list_email[0], assunto=assunto_email, corpo=texto_email,
            destinatarios=','.join(list_email[1:]), anexo=report_pdf, nome_anexo=numero_pedido,
            mail_server_id=mail_server_id,
            context=context)
        if not mail_id:
            raise osv.except_osv(_('Atencao'), _('E-mail nao enviado. Verifique as configuracoes '
                                                 'realizadas para envio de e-mail.'))
        obj_estoquepedidos_pedido_capa.message_post(
            cr, uid, context.get('active_id'),
            _('Para: %s') % str(list_email).replace('[', '').replace(']', ''),
            _('Pedido enviado por e-mail'))
        return True


class wizard_email_pessoa_item(osv.TransientModel):
    # prefixo: wizemi_
    _name = 'wizard.email.pessoa.item'
    _columns = {
        'wizemi_capa_id': fields.many2one('wizard.email.pessoa', 'Capa'),
        'wizemi_email': fields.char('Email', size=50),
        'wizemi_setor_ids': fields.many2many("adm.setor", 'wizard_email_pessoa_m2m_email_setor',
                                             'email_pessoa_id', 'setor_id', 'Setor'),
    }
