#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
import time


class wizard_separacao_produto_capa(osv.TransientModel):
    _name = 'wizard.separacao.produto.capa'

    def wsepa_get_dados(self, cr, uid, ids, name, arg, context=None):
        res = {}
        context = context and context.copy() or {}
        if not ids:
            return res
        for x in self.browse(cr, uid, ids, context=context):
            for itens in x.wsepa_itens_ids:
                vals = {
                    'wsepa_item_codigo': itens.wseit_codigo,
                    'wsepa_locacao': itens.wseit_locacao,
                    'wsepa_item_grade': itens.wseit_grade,
                    'wsepa_item_descricao': itens.wseit_descricao,
                    'state': itens.state,
                    'wsepa_qtd': itens.wseit_quantidade,
                }
                res[x.id] = vals
                if itens.state == 'A':
                    break
        return res

    def wsepa_preparar(self, cr, uid, context=None):
        obj_pedidos = self.pool.get('estoquepedidos.pedido.capa')
        obj_wspi = self.pool.get('wizard.separacao.produto.itens')
        obj_wspp = self.pool.get('wizard.separacao.produto.pedidos')
        args = [('state', '=', 'V')]
        _seq = 0
        estoque_parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, tabela='estoque', campos=['local_venda_padrao_id'], context=context
        )
        local_id = estoque_parametro_dados.get('local_venda_padrao_id', False)
        pedido_ids = obj_pedidos.search(cr, uid, args, context=context)
        for brw_pedido in obj_pedidos.browse(cr, uid, pedido_ids, context=context):
            vals = {
                'wsepa_data': time.strftime('%Y-%m-%d'),
            }
            capa_id = self.create(cr, uid, vals, context=context)
            for brw_ped_itens in brw_pedido.pedido_item_ids:
                _grade_id = brw_ped_itens.grade_id.id
                args = [('wseit_capa_id', '=', capa_id), ('wseit_grade_id', '=', _grade_id)]
                wspi_ids = obj_wspi.search(cr, uid, args, context=context)
                if not wspi_ids:
                    _locacao = ''
                    for brw_locacao in brw_ped_itens.produto_id.locacao_ids:
                        if brw_locacao.local_id == local_id:
                            _locacao  = brw_locacao.locacao
                            break
                    _seq += 1
                    vals_itens = {
                        'wseit_sequencia': _seq,
                        'wseit_capa_id': capa_id,
                        'wseit_codigo': brw_ped_itens.produto_id.codigo,
                        'wseit_grade': brw_ped_itens.grade_id.grade,
                        'wseit_descricao': brw_ped_itens.grade_id.name,
                        'wseit_locacao': _locacao,
                        'state': 'S' if brw_ped_itens.state == 'D' else 'A',
                        'wseit_quantidade': brw_ped_itens.qtde_pedida,
                    }
                    wspi_id = obj_wspi.create(cr, uid, vals_itens, context=context)
                else:
                    wspi_id = wspi_ids[0]
                    vals_itens = {
                        'wseit_quantidade': 'wseit_quantidade + %s' % brw_ped_itens.qtde_pedida
                    }
                    obj_wspi.write(cr, uid, wspi_id, vals_itens, context=context)
                vals_ped = {
                    'wsepe_capa_id': capa_id,
                    'wsepe_item_id': wspi_id,
                    'wsepe_grade_id': brw_ped_itens.grade_id.id,
                    'wsepe_pedido_id': brw_pedido.id,
                    'wsepe_quantidade': brw_ped_itens.qtde_pedida,
                }
                obj_wspp.create(cr, uid, vals_ped, context=context)
        return time.strftime('%Y-%m-%d')

    _columns = {
        'wsepa_data': fields.date('Data da separacao'),
        'wsepa_itens_ids': fields.one2many('wizard.separacao.produto.itens', 'wseit_capa_id', 'Itens'),
        'wsepa_pedidos_ids': fields.one2many('wizard.separacao.produto.pedidos', 'wsepe_capa_id', 'Pedidos'),
        'wsepa_locacao': fields.function(wsepa_get_dados, method=True, string='Locacao', multi="dados", type='char',
                                             size=15, store=False),
        'wsepa_item_codigo': fields.function(wsepa_get_dados, method=True, string='Codigo', multi="dados", type='char',
                                             size=15, store=False),
        'wsepa_item_grade': fields.function(wsepa_get_dados, method=True, string='Grade', multi="dados", type='char',
                                             size=2, store=False),
        'wsepa_item_descricao': fields.function(wsepa_get_dados, method=True, string='Descricao', multi="dados",
                                                type='char', size=60, store=False),
        'state': fields.function(wsepa_get_dados, method=True, string='State', multi="dados",
                                selection=[('A', 'A separar'), ('S', 'Separado')], store=False),
        'wsepa_qtd': fields.function(wsepa_get_dados, method=True, string='Qtd', multi="dados", type='float',
                                    digits=(8,3), store=False),
    }
    _defaults = {
        'wsepa_data': lambda s, cr, uid, c: s.wsepa_preparar(cr, uid, context=c)
    }

class wizard_separacao_produto_itens(osv.TransientModel):
    _name = 'wizard.separacao.produto.itens'
    _columns = {
        'wseit_sequencia': fields.integer('Sequencia'),
        'wseit_capa_id': fields.many2one('wizard.separacao.produto.capa', 'Capa', select=True, ondelete='cascade'),
        'wseit_grade_id': fields.many2one('estoque.produto.grade', 'Grade', select=True, ondelete='cascade'),
        'wseit_codigo': fields.char('Item', size=15),
        'wseit_grade': fields.char('Grade', size=2),
        'wseit_descricao': fields.char('Descricao', size=60),
        'wseit_locacao': fields.char('Locacao', size=15, select=True),
        'state': fields.selection([('A', 'A separar'), ('S', 'Separado')], 'Estado', size=1),
        'wseit_quantidade': fields.float('Quantidade', digits=(8, 3)),
        'wseit_pedido_ids': fields.one2many('wizard.separacao.produto.pedidos', 'wsepe_item_id', 'Pedidos'),
    }
    _order = 'wseit_locacao'

class wizard_separacao_produto_pedidos(osv.TransientModel):
    _name = 'wizard.separacao.produto.pedidos'
    _columns = {
        'wsepe_capa_id': fields.many2one('wizard.separacao.produto.capa', 'Capa', select=True, ondelete='cascade'),
        'wsepe_item_id': fields.many2one('wizard.separacao.produto.itens', 'Item', select=True, ondelete='cascade'),
        'wsepe_pedido_id': fields.many2one('estoquepedidos.pedido.capa', 'Pedido'),
        'wsepe_quantidade': fields.float('Quantidade', digits=(8, 3)),
        # 'wsepe_cliente': fields.related('wsepe_pedido_id', 'pessoa_id', 'Cliente', type="many2one",
        #                                     relation="adm.pessoa", store=True),
        'wsepe_grade_id': fields.many2one('estoque.produto.grade', 'Grade', select=True, ondelete='cascade'),
    }
    _order = 'wsepe_pedido_id'
