# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class estoquepedidos_pedido_capa(osv.Model):

    _inherit = 'estoquepedidos.pedido.capa'

    def fields_view_get(self, cr, uid, view_id=None, view_type='form', context=None, toolbar=False,
                        submenu=False):
        context = context and context.copy() or {}
        res = super(estoquepedidos_pedido_capa, self).fields_view_get(
            cr, uid, view_id, view_type, context, toolbar, submenu)
        view_name = context.get('view_name')
        toolbar = res.get('toolbar')
        if not toolbar:
            return res
        if (view_name == 'estoquepedidos_compra' or not context.get(
                'estoquepedidos_importacao')) and toolbar.get('relate'):
            res['toolbar']['relate'] = filter(
                lambda r: r.get('res_model') != 'wizard.importa.pedido.empresa.atual',
                toolbar.get('relate'))
        return res

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        if context.get('estoquepedidos_importacao'):
            logada_company_id = self.pool.get('res.users').browse(cr, uid, uid, context).company_id.id
            args.append(('company_id', '!=', logada_company_id))

        res = super(estoquepedidos_pedido_capa, self).search(
            cr, uid, args, offset, limit, order, context, count)
        return res

    def pedcap_verificar_empresa_pedido_empresa_origem(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        logada_company_id = self.pool.get('res.users').browse(cr, uid, uid, context).company_id.id
        if context.get('sig_force_company'):
            if context.get('sig_force_company') != True:
                logada_company_id = context.get('sig_force_company')
        for dados_pedido in self.read(cr, uid, ids, context=context):
            if dados_pedido.get('company_id')[0] != logada_company_id:
                return False
        if context.get('estoquepedidos_importacao'):
            return False
        return True

    def button_faturar_pedido(self, cr, uid, ids, context=None, destinatario_id=False, pedido_ids=[]):
        context = context and context.copy() or {}
        if not self.pedcap_verificar_empresa_pedido_empresa_origem(cr, uid, ids, context=context):
                raise osv.except_osv(_('Atencao'), _('Nao posso faturar pedido de outra empresa!'))
        res = super(estoquepedidos_pedido_capa, self).button_faturar_pedido(cr, uid, ids, context=context,
                                                                            destinatario_id=destinatario_id,
                                                                            pedido_ids=pedido_ids)
        return res

    def button_rascunho(self, cr, uid, ids, context=None):
        if not self.pedcap_verificar_empresa_pedido_empresa_origem(cr, uid, ids, context=context):
                raise osv.except_osv(_('Atencao'), _('Nao posso retornar para esboco pedido de outra empresa!'))
        res = super(estoquepedidos_pedido_capa, self).button_rascunho(cr, uid, ids, context=context)
        return res

    def pedcap_button_separar_itens(self, cr, uid, ids, context=None):
        if not self.pedcap_verificar_empresa_pedido_empresa_origem(cr, uid, ids, context=context):
                raise osv.except_osv(_('Atencao'), _('Nao posso separar itens de pedido de outra empresa!'))
        res = super(estoquepedidos_pedido_capa, self).pedcap_button_separar_itens(cr, uid, ids, context=context)
        return res

    def button_separar(self, cr, uid, ids, context=None):
        if not self.pedcap_verificar_empresa_pedido_empresa_origem(cr, uid, ids, context=context):
                raise osv.except_osv(_('Atencao'), _('Nao posso separar itens de pedido de outra empresa!'))
        res = super(estoquepedidos_pedido_capa, self).button_separar(cr, uid, ids, context=context)
        return res

    def pedcap_button_separado(self, cr, uid, ids, context=None):
        if not self.pedcap_verificar_empresa_pedido_empresa_origem(cr, uid, ids, context=context):
                raise osv.except_osv(_('Atencao'), _('Nao posso separar itens de pedidos de outra empresa!'))
        res = super(estoquepedidos_pedido_capa, self).pedcap_button_separado(cr, uid, ids, context=context)
        return res

    def pedcap_button_separar_tudo(self, cr, uid, ids, context=None):
        if not self.pedcap_verificar_empresa_pedido_empresa_origem(cr, uid, ids, context=context):
                raise osv.except_osv(_('Atencao'), _('Nao posso separar itens de pedidos de outra empresa!'))
        res = super(estoquepedidos_pedido_capa, self).pedcap_button_separar_tudo(cr, uid, ids, context=context)
        return res

    def button_validar(self, cr, uid, ids, context=None):
        if not self.pedcap_verificar_empresa_pedido_empresa_origem(cr, uid, ids, context=context):
                raise osv.except_osv(_('Atencao'), _('Nao posso validar pedidos de outra empresa!'))
        res = super(estoquepedidos_pedido_capa, self).button_validar(cr, uid, ids, context=context)
        return res

    def button_cancelar(self, cr, uid, ids, context=None):
        if not self.pedcap_verificar_empresa_pedido_empresa_origem(cr, uid, ids, context=context):
                raise osv.except_osv(_('Atencao'), _('Nao posso cancelar de pedidos de outra empresa!'))
        res = super(estoquepedidos_pedido_capa, self).button_cancelar(cr, uid, ids, context=context)
        return res
