# -*- coding: utf-8 -*-

from openerp.osv import osv
import time
from openerp.tools.translate import _


class estoqueressuprimento_lista_itens(osv.Model):

    _inherit = 'estoqueressuprimento.lista.itens'


    def reslit_button_consulta_estatistica(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        load = '_classic_write'
        dados_itens = self.read(cr, uid, ids, [], context, load)[0]
        capa_id = dados_itens.get('reslit_capa_id')
        dados_capa = self.pool.get('estoqueressuprimento.lista.capa').read(cr, uid, capa_id,
                                           ['company_id', 'reslca_local_entrada_id'], context, load)
        obj_est_mensal = self.pool.get('estoque.estatisticas.mensal.osv')

        vals = {'company_id': dados_capa.get('company_id'),
                'local_id': dados_capa.get('reslca_local_entrada_id'),
                'produto_id': dados_itens.get('reslit_produto_id'),
                'grade_id': dados_itens.get('reslit_grade_id')}
        est_id = obj_est_mensal.create(cr, uid, vals, context)
        obj_est_mensal.estesm_funcao_pesquisar(cr, uid, est_id, context)
        view = self.pool.get('ir.model.data').get_object_reference(
            cr, uid, 'estoque', 'view_estoque_estatisticas_mensal')

        return {'view_type': 'form',
                'view_mode': 'form',
                'view_id': [view and view[1] or False],
                'res_model': 'estoque.estatisticas.mensal.osv',
                'type': 'ir.actions.act_window',
                'name': _('Estoque Estatisticas Mensal'),
                'res_id': est_id,
                'target': 'new',
                'context': context}

    def reslit_onchange_produto(self, cr, uid, ids, produto_id, context=None):
        context = context and context.copy() or {}
        res = {'value': {'reslit_grade_id': False}}
        if not produto_id:
            return res
        grade_ids = self.pool.get('estoque.produto.grade').search(
            cr, uid, [('produto_id', '=', produto_id)], context=context)
        if not grade_ids or len(grade_ids) > 1:
            return res
        res['value'].update({'reslit_grade_id': grade_ids[0]})
        return res

    def reslit_onchange_grade(self, cr, uid, ids, grade_id, company_id, empresa_saida_id,
                              local_entrada_id, local_saida_id, data_inicial, data_final,
                              context=None):
        context = context and context.copy() or {}
        res = {'value': {'reslit_saldo_saida': 0, 'reslit_saldo_entrada': 0,
                         'reslit_qtd_vendida': 0, 'reslit_produto_embalagem_id': False}}
        if not grade_id:
            return res

        obj_estoque_local_locacao = self.pool.get('estoque.local.locacao')
        context.update({'sig_force_company': True})
        locacao_ids = obj_estoque_local_locacao.search(
            cr, uid, [('company_id', '=', empresa_saida_id), ('local_id', '=', local_saida_id),
                      ('grade_id', '=', grade_id)], context=context)
        del context['sig_force_company']
        if not locacao_ids:
            res.update(
                {'warning': {'title': _('Atencao'),
                             'message': _('Nao ha locacao cadastrada para empresa de saida, local '
                                          'de saida, produto e grade selecionados.')}})
            return res
        produto_embalagem_id = obj_estoque_local_locacao.read(
            cr, uid, locacao_ids[0], ['estllc_produto_embalagem_id'], context,
            '_classic_write').get('estllc_produto_embalagem_id')
        res['value'].update({'reslit_produto_embalagem_id': produto_embalagem_id})

        obj_estoque_produto_saldo = self.pool.get('estoque.produto.saldo')
        empresa_saida_saldos = obj_estoque_produto_saldo.get_saldo_do_dia(
            cr, uid, grade_id, time.strftime('%Y-%m-%d'), local_saida_id, empresa_saida_id,
            context)
        empresa_entrada_saldos = obj_estoque_produto_saldo.get_saldo_do_dia(
            cr, uid, grade_id, time.strftime('%Y-%m-%d'), local_entrada_id, company_id,
            context)
        empresa_entrada_vendas_dict = self.pool.get('estoqueressuprimento.lista.capa').\
            reslca_get_quantidade_vendida_empresa_entrada(cr, uid, company_id, [grade_id],
                                                          local_entrada_id, data_inicial,
                                                          data_final, context)
        res['value'].update({
            'reslit_saldo_saida': empresa_saida_saldos.get(grade_id) and empresa_saida_saldos.get(
                grade_id).get('disponivel') or 0,
            'reslit_saldo_entrada': empresa_entrada_saldos.get(grade_id) and
            empresa_entrada_saldos.get(grade_id).get('disponivel') or 0,
            'reslit_qtd_vendida': empresa_entrada_vendas_dict.get(grade_id) or 0
        })
        return res
