# -*- coding: utf-8 -*-

from openerp.osv import osv, fields
from funcoes import reslca_get_empresa_correlacao_local


class estoqueressuprimento_lista_capa(osv.Model):
    # prefixo: reslca_
    _name = 'estoqueressuprimento.lista.capa'

    _columns = {
        'create_date': fields.datetime('Data de criacao', select=True, readonly=True),
        'name': fields.char('Descricao', required=True),
        'company_id': fields.many2one('res.company', 'Empresa', select=True, required=True),
        'create_uid': fields.many2one('res.users', 'Usuario', readonly=True),
        'reslca_empresa_saida_id': fields.many2one('res.company', 'Empresa de saida', select=True,
                                                   required=True, ondelete='restrict'),
        'reslca_local_saida_id': fields.many2one('estoque.local', 'Local de saida', select=True,
                                                 required=True, ondelete='restrict'),
        'reslca_local_entrada_id': fields.many2one('estoque.local', 'Local de entrada', select=True,
                                                   required=True, ondelete='restrict'),
        'reslca_data_inicial': fields.date('Data inicial', required=True,
                                           help='Data inicial das vendas'),
        'reslca_data_final': fields.date('Data final', required=True,
                                         help='Data final das vendas'),
        'reslca_requisicao_id': fields.many2one('estoqueressuprimento.requisicao.capa',
                                                'Requisicao', readonly=True),
        'reslca_itens_ids': fields.one2many('estoqueressuprimento.lista.itens', 'reslit_capa_id',
                                            'Itens'),
        'reslca_local_empresa_saida_id': fields.function(
            reslca_get_empresa_correlacao_local, method=True,
            string='Empresa correlacao local saida', type='many2one', relation='res.company')
    }
    _order = 'create_date desc'
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, s._name, context=c),
    }
