# -*- coding: utf-8 -*-

from openerp.osv import osv, fields


class estoqueressuprimento_lista_itens(osv.Model):
    # prefixo: reslit_
    _name = 'estoqueressuprimento.lista.itens'

    _columns = {
        'reslit_capa_id': fields.many2one('estoqueressuprimento.lista.capa', 'Capa', required=True,
                                          select=True, ondelete='cascade'),
        'reslit_produto_id': fields.many2one('estoque.produto', 'Produto', required=True,
                                             select=True, ondelete='restrict'),
        'reslit_grade_id': fields.many2one('estoque.produto.grade', 'Grade', required=True,
                                           select=True, ondelete='restrict'),
        'reslit_produto_embalagem_id': fields.many2one('estoque.produto.embalagem', 'Embalagem',
                                                       required=True, select=True,
                                                       ondelete='restrict', readonly=True),
        'reslit_saldo_saida': fields.float('Saldo saida', digits=(9, 3)),
        'reslit_saldo_entrada': fields.float('Saldo entrada', digits=(9, 3)),
        'reslit_qtd_vendida': fields.float('Quantidade vendida', digits=(9, 3)),
        'reslit_qtd_transferir': fields.float('Quantidade a transferir', digits=(9, 3)),
    }

    _defaults = {
        'reslit_saldo_saida': 0.0,
        'reslit_saldo_entrada': 0.0,
    }

