# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoqueressuprimento_requisicao_itens(osv.Model):
    from funcoes import resrca_get_dia

    _name = 'estoqueressuprimento.nao.atendido.itens'
    _description = "Itens nao atendidos"
    _defaults = {
    }
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa de Entrada', ondelete="cascade", required=True,
                                      select=True), # Id da empresa
        'resnat_data': fields.date('Data', required=True ,select=True),
        'resnat_dia':  fields.function(resrca_get_dia, method=True, string="Dia",
                                                type="integer", store=True),
        'resnat_saida_empresa_id': fields.many2one("res.company", 'Empresa de saida', ondelete="cascade", required=True,
                                      select=True),
        'resnat_saida_local_id': fields.many2one("estoque.local", 'Local de saida', ondelete="cascade", required=True,
                                      select=True, restrict=True),
        'resnat_entrada_local_id': fields.many2one("estoque.local", 'Local de entrada', ondelete="cascade", required=True,
                                      select=True, restrict=True),
        'resnat_produto_id': fields.many2one("estoque.produto", 'Item', ondelete="cascade", required=True, restrict=True,
                                      select=True, domain="[('tipo', '=', 'P')]"),
        'resnat_grade': fields.char('Grade', required=True, size=2),
        'resnat_qtd_pedido': fields.float('Quantidade pedida'),
        'resnat_qtd_atendida': fields.float('Quantidade atendida'),
        'resnat_qtd_diferenca': fields.float('Quantidade nao atendida'),
    }
    _order = 'resnat_data desc, resnat_produto_id, resnat_grade'
