# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from time import strftime
from funcoes import resrca_get_pendencia
from funcoes import resrca_get_empresa_a_usar


class estoqueressuprimento_requisicao_capa(osv.Model):
    # prefixo: resrca_

    _name = 'estoqueressuprimento.requisicao.capa'
    _inherit = ['mail.thread']
    _rec_name = 'numero'
    _track = {'state': {
        'estoqueressuprimento.mt_r': lambda self, cr, uid, obj, ctx=None: obj['state'] == 'Esboco',
        'estoqueressuprimento.mt_p': lambda self, cr, uid, obj, ctx=None: obj['state'] == 'Aprovado',
        'estoqueressuprimento.mt_e': lambda self, cr, uid, obj, ctx=None: obj['state'] == 'Em Separacao',
        'estoqueressuprimento.mt_s': lambda self, cr, uid, obj, ctx=None: obj['state'] == 'Separado',
        'estoqueressuprimento.mt_m': lambda self, cr, uid, obj, ctx=None: obj['state'] == 'Em Conferencia',
        'estoqueressuprimento.mt_f': lambda self, cr, uid, obj, ctx=None: obj['state'] == 'conferido',
        'estoqueressuprimento.mt_o': lambda self, cr, uid, obj, ctx=None: obj['state'] == 'Entregue',
        'estoqueressuprimento.mt_c': lambda self, cr, uid, obj, ctx=None: obj['state'] == 'Cancelado'
    }}
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa de Saida', ondelete="cascade", required=True,
                                      select=True),
        'numero': fields.char('Numero', size=14, required=False),
        'data': fields.date('Data', required=True),
        'resrca_empresa_entrada_id': fields.many2one("res.company", 'Empresa de Entrada',
                                                     ondelete="cascade", select=True,
                                                     oldname="empresa_saida_id"),
        'local_entrada_id': fields.many2one("estoque.local", 'Local entrada', ondelete="restrict", select=True),
        'local_saida_id': fields.many2one("estoque.local", 'Local saida', ondelete="restrict", select=True),
        'movimento_capa_id': fields.many2one("estoque.movimento.capa", 'Capa', ondelete="restrict",
                                             select=True),
        'state': fields.selection([('R', 'Esboco'), ('P', 'Aprovado'), ('E', 'Em Separacao'),
                                   ('S', 'Separado'), ('M', 'Em Conferencia'), ('F', 'Conferido'),
                                   ('O', 'Entregue'), ('C', 'Cancelado')], 'Estado', required=True, size=1,
                                  select=True, track_visibility='onchange'),
        'requisicao_itens_ids': fields.one2many('estoqueressuprimento.requisicao.itens', 'requisicao_id',
                                                'Itens'),
        'tipo': fields.selection([('TR', 'TROCA MERCADORIA'), ('QR', 'REQUISICAO')], 'Tipo', required=True,
                                 size=2),
        'nf_id': fields.many2one('fiscal.nf.capa', "Nro da Nota Fiscal", ondelete="cascade"),
        'resrca_com_pendencia': fields.function(resrca_get_pendencia, method=True, type="boolean", store=True,
                                                string="Requisicao com pendencia"),
        'resrca_tipo_codigo': fields.selection([('I', 'Interno'), ('B', 'Barras')], 'Tipo codigo',
                                               size=1),
        'resrca_a_usar_company_id': fields.function(resrca_get_empresa_a_usar, method=True,
                                                    type='many2one', relation='res.company',
                                                    string='Empresa a usar'),
    }
    _defaults = {
        'state': lambda *a: 'R',
        'data': lambda *a: strftime('%Y-%m-%d'),
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, s._name, context=c),
        'resrca_empresa_entrada_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, s._name, context=c),
        'tipo': 'QR',
        'resrca_tipo_codigo': lambda *a: 'I',
    }
    _order = 'numero desc'
