# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import get_tipo_codigo_item


class estoqueressuprimento_requisicao_itens(osv.Model):
    _name = 'estoqueressuprimento.requisicao.itens'
    _rec_name = "requisicao_id"
    _columns = {
        'requisicao_id': fields.many2one("estoqueressuprimento.requisicao.capa", 'Requisicao',
                                         ondelete="cascade", required=True, select=True),
        # id da requisicao
        'codigo_barra_id': fields.many2one('automacao.codigo.barra', 'Codigo barras'),
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="restrict",
                                      select=True, domain="[('tipo', '=', 'P')]"),
        # Id do produto
        'grade_id': fields.many2one("estoque.produto.grade", 'Grade', ondelete="restrict",
                                    select=True, domain="[('produto_id', '=', produto_id)]"),
        # id da grade
        'quantidade_requisitada': fields.float('Quantidade requisitada', digits=(9, 3),
                                               required=True),
        'quantidade_confirmada': fields.float('Quantidade confirmada', digits=(9, 3)),
        'embalagem_id': fields.many2one('estoque.produto.embalagem', 'Embalagem',
                                        ondelete="restrict", required=True,
                                        domain="[('produto_id', '=', produto_id)]"),
        'saldo': fields.float('Saldo Atual', digits=(9, 3), required=False),
        'ja_confirmada': fields.boolean(string='Requisicao de item confirmada'),
        'tipo_codigo': fields.function(get_tipo_codigo_item, method='True', string='Tipo codigo',
                                       type='char', size=1)
    }
    _defaults = {
        'quantidade_confirmada': lambda *a: 0,
        'ja_confirmada': lambda *a: False,
    }


