# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoqueressuprimento_requisicao_view(osv.Model):
    """
    View
    """
    _name = 'estoqueressuprimento.requisicao.view'
    _description = 'estoqueressuprimento_requisicao_view'
    _auto = False
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa Saida', ondelete="cascade", required=True, select=True),
        'numero': fields.char('Numero', size=14, required=False), # Numero da requisicao RQ-AAAA-999999
        'data': fields.date('Data', required=True), # Data da Requisicao
        'empresa_entrada_id': fields.many2one("res.company", 'Empresa entrada', ondelete="cascade", required=True,
                                            select=True), # id da empresa de onde vai sair a mercadoria\n
        'local_entrada_id': fields.many2one("estoque.local", 'Local entrada', ondelete="restrict", required=True,
                                            select=True), # id do local de entrada
        'local_saida_id': fields.many2one("estoque.local", 'Local saida', ondelete="restrict", required=True,
                                          select=True), # Id do local de saida
        'state': fields.selection([
                                      ('R', 'Rascunho'),
                                      ('T', 'Transferido'),
                                      ('C', 'Cancelado')], 'Estado', required=True, size=1),
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="no action", required=True, select=True),
        'grade_id': fields.many2one("estoque.produto.grade", 'Grade', ondelete="no action", required=True, select=True),
        'quantidade_requisitada': fields.float('Quantidade requisitada', digits=(9, 3), required=True),
        'quantidade_confirmada': fields.float('Quantidade confirmada', digits=(9, 3)),
    }

