# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools import drop_view_if_exists


class estoqueressuprimento_report_view(osv.Model):
    _name = 'estoqueressuprimento.report.view'
    _auto = False
    _columns = {
        'id': fields.many2one('estoqueressuprimento.requisicao.capa', 'Requisicao'),
        'locacao': fields.char('Locacao', size=15),
        'produto_id': fields.integer('Produto_id'),
        'codigo': fields.char('Codigo', size=20),
        'digito': fields.char('Digito', size=1),
        'descricao': fields.char('Descricao', size=60),
        'grade': fields.char('Grade', size=2),
        'grade_id': fields.integer('Id grade'),
        'quantidade_requisitada': fields.float('Quantidade Requisitada', digits=(9, 3)),
        'unidade': fields.char('Unidade', size=3),
        'qtde_embalagem': fields.float('Qtde. Embalagem', digits=(8, 3))
    }

    def init(self, cr):
        drop_view_if_exists(cr, 'estoqueressuprimento_report_view')
        sql = """CREATE OR REPLACE VIEW estoqueressuprimento_report_view AS
            select
                ressupri_itens.requisicao_id as id,
                locacao.locacao as locacao,
                produto.id as produto_id,
                produto.codigo as codigo,
                produto.digito as digito,
                produto.name as descricao,
                grade.grade as grade,
                grade.id as grade_id,
                sum(ressupri_itens.quantidade_requisitada) as quantidade_requisitada,
                unidade.unidade as unidade,
                embalagem.quantidade_na_embalagem as qtde_embalagem
            from
                estoqueressuprimento_requisicao_itens ressupri_itens,
                estoqueressuprimento_requisicao_capa ressupri_capa,
                estoque_produto produto,
                estoque_produto_grade grade,
                estoque_produto_embalagem produto_embalagem,
                estoque_embalagem embalagem,
                estoque_embalagem_unidade unidade,
                estoque_local_locacao locacao
            where
                ressupri_itens.requisicao_id = ressupri_capa.id and
                ressupri_itens.produto_id = produto.id and
                ressupri_itens.grade_id = grade.id and
                ressupri_itens.embalagem_id = produto_embalagem.id and
                ressupri_itens.produto_id = locacao.produto_id and
                ressupri_itens.grade_id = locacao.grade_id and
                ressupri_capa.local_saida_id = locacao.local_id and
                ressupri_capa.company_id = locacao.company_id and
                produto_embalagem.embalagem_id = embalagem.id and
                embalagem.unidade_id = unidade.id
            group by
                ressupri_itens.requisicao_id,
                locacao.locacao,
                produto.id,
                produto.codigo,
                produto.digito,
                produto.name,
                grade.grade,
                grade.id,
                unidade.unidade,
                embalagem.quantidade_na_embalagem
            order by
                ressupri_itens.requisicao_id,
                locacao.locacao,
                produto.name
        """
        cr.execute(sql)

