# -*- coding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _
from dateutil.parser import parse


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(e, c, d, t=140):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        context = context and context.copy() or {}
        title = center_title('', _('Lista para Ressuprimento'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('lista_para_ressuprimento'))
        listagem.informaTamLinha(150)
        listagem.defineFonte(tam=6.5)
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)

        capa_dados = datas.get('capa')
        itens = datas.get('itens')

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'estoqueressuprimento.lista.capa', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        local_dados = datas.get('local')

        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
        docs1 = center_title('Empresa saida: ' + capa_dados.get('empresa_saida'), '', '')
        docs2 = center_title('Local saida: ' + capa_dados.get('local_saida'), '',
                             'Local entrada: ' + capa_dados.get('local_entrada'))
        docs3 = center_title('Descricao: ' + capa_dados.get('descricao'), '', '')
        docs4 = center_title(
            'Data inicial: ' + parse(capa_dados.get('data_inicial')).strftime('%d/%m/%Y'), '',
            'Data final: ' + parse(capa_dados.get('data_final')).strftime('%d/%m/%Y'))
        docs5 = center_title('Usuario: ' + capa_dados.get('usuario'), '', '')

        listagem.informaCab(''+title)
        listagem.informaCab('')
        listagem.informaCab(docs)
        listagem.informaCab('')
        listagem.informaCab(docs1)
        listagem.informaCab(docs2)
        listagem.informaCab(docs3)
        listagem.informaCab(docs4)
        listagem.informaCab(docs5)
        listagem.informaCab('')
        listagem.informaCab('--')
        listagem.informaCab(_(' LOCACAO         CODIGO               DESCRICAO                     '
                              '           GRADE    SALDO SAIDA  SALDO ENTRADA    QTD VENDIDA'
                              ' QTD TRANSFERIR '))
        listagem.informaCab('--')
        listagem.rodapePadrao()
        qtd_itens = 0
        qtd_transferir = 0

        for item in itens:
            linha = ' '
            linha += formataString(item.get('locacao') or '', 15, ' ', 'D', 'N', 'S')
            linha += ' '
            linha += formataString(item.get('produto_codigo') or '', 20, ' ', 'D', 'N', 'S')
            linha += ' '
            linha += formataString(item.get('produto_name') or '', 40, ' ', 'D', 'N', 'S')
            linha += ' '
            linha += formataString(item.get('grade_grade') or '', 5, ' ', 'D', 'N', 'S')
            linha += ' '
            linha += formataString(getNumeroEditado(item.get('saldo_saida') or 0, 3), 14,
                                   ' ', 'E', 'N', 'S')
            linha += ' '
            linha += formataString(getNumeroEditado(item.get('saldo_entrada') or 0, 3), 14,
                                   ' ', 'E', 'N', 'S')
            linha += ' '
            linha += formataString(getNumeroEditado(item.get('qtd_vendida') or 0, 3), 14,
                                   ' ', 'E', 'N', 'S')
            linha += ' '
            linha += formataString(item.get('qtd_transferir') > 0 and getNumeroEditado(item.get(
                'qtd_transferir'), 3) or '', 14, ' ', 'E', 'N', 'S')
            listagem.imprimeLinha(linha)
            qtd_itens += 1
            qtd_transferir += item.get('qtd_transferir')

        listagem.imprimeLinha('--')
        linha = ' '
        linha += (37 * ' ')
        x = 'T o t a i s     Qtd Itens: %s' % qtd_itens
        linha += formataString(x, 40, ' ', 'D', 'N', 'S')
        linha += ((5 + 5 + 14 + 14 + 14) * ' ')
        linha += formataString(getNumeroEditado(qtd_transferir, 3), 14, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.lista_para_ressuprimento')
