# -*- coding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
from openerp import netsvc
from openerp import pooler
import time
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, data, context=None):
        context = context and context.copy() or {}
        o_locacao = pooler.get_pool(cr.dbname).get('estoque.local.locacao')
        o_est_emb = pooler.get_pool(cr.dbname).get('estoque.embalagem')
        o_p_est_emb = pooler.get_pool(cr.dbname).get('estoque.produto.embalagem')
        o_est_prod_cod_for = pooler.get_pool(cr.dbname).get('estoque.produto.codigo.fornecedor')
        locacao_ids = data['locacao_ids']

        pdf_string = StringIO.StringIO()

        def center_title(nome_relatorio, nome_empresa, data, T=147):
            title_c = (T - len(nome_empresa)) / 2
            title = nome_relatorio
            for i in range(title_c - len(nome_relatorio)):
                title += ' '
            title += nome_empresa
            for i in range(title_c - len(data)):
                title += ' '
            title += data
            return title

        listagem = Impressora()
        listagem.defineFormato()
        listagem.informaTamLinha(174)
        listagem.informaNome(pdf_string, _('Listagem de Ressuprimento Manual'))
        listagem.defineMargem(1, 1, 1, 1)
        # CABECALHO
        listagem.informaCab(
            center_title(_('Requisicao para Ressuprimento'), data['nome_empresa'], time.strftime('%d-%m-%Y')))
        listagem.informaCab('')
        listagem.informaCab(
            _('Entrada / Saida: ') + data['nomes_local']['entrada'].upper() + ' / ' + data['nomes_local'][
                'saida'].upper())
        listagem.informaCab('*' + '-' * 185 + '*')
        listagem.informaCab(
            _(
                '|LOCACAO        |CODIGO |PRODUTO                                 |GRADE                  |     COD. FORNECEDOR|EMB|       QTDA.|              SALDO|         |         |         |        |'))
        listagem.informaCab(
            '|               |       |                                        |                       |                    |   |            |                   |         |         |         |        |')
        listagem.informaCab('*' + '-' * 185 + '*')
        # RODAPE
        listagem.informaRodape('*' + '-' * 185 + '*')
        listagem.informaRodape(' ' * 159 + _('**  Sig Informatica Ltda  **'))

        # CORPO

        o_locacao_browse = (o_locacao.browse(cr, uid, data['locacao_ids']))
        count, inc = len(o_locacao_browse), 1
        for x in o_locacao_browse:
            args = [('produto_id', '=', x.produto_id.id), ('grade_id', '=', x.grade_id.id),
                    ('local_id', '=', data['local_saida_id'])]
            locacao_saida_ids = o_locacao.search(cr, uid, args, context=context)
            dados_saida = o_locacao.browse(cr, uid, locacao_saida_ids)
            locacao = x.locacao or ''
            grade = x.grade_id.name
            try:
                produto = x.produto_id.name
            except:
                produto = ''
            try:
                codigo_produto = x.produto_id.codigo
            except:
                codigo_produto = ''
            if isinstance(dados_saida, list):
                dados_saida = dados_saida[0]
            saldo = dados_saida._estllc_get_saldo(cr, uid)[dados_saida.id]
            saldo = o_locacao._estllc_get_saldo(cr, uid, [dados_saida.id], None, None, context)
            try:
                fabricante_id = x.produto_id.fabricante_id
            except:
                fabricante_id = None
            if fabricante_id and type(fabricante_id) != osv.orm.browse_null:
                cod_forn_id = o_est_prod_cod_for.search(
                    cr, uid, [('grade_id', '=', x.grade_id.id),
                              ('fornecedor_id', '=', x.produto_id.fabricante_id.id)],
                    context=context)
                if cod_forn_id:
                    cod_forn = o_est_prod_cod_for.read(cr, uid, cod_forn_id[0], ['codigo_fornecedor'], context=context)[
                        'codigo_fornecedor']
                else:
                    cod_forn = ''
            else:
                cod_forn = ''

            if type(dados_saida.estllc_produto_embalagem_id) != osv.orm.browse_null:
                embalagem = dados_saida.estllc_produto_embalagem_id.embalagem_id.unidade_id.unidade
                qtda = dados_saida.estllc_produto_embalagem_id.embalagem_id.quantidade_na_embalagem
            else:
                embalagem = 'UND'
                qtda = 1
            ln = '|'
            ln += formataString(locacao, 15, ' ', 'D', 'N', 'S')
            ln += '|'
            ln += formataString(codigo_produto, 7, ' ', 'D', 'N', 'S')
            ln += '|'
            ln += formataString(produto, 40, ' ', 'D', 'N', 'S')
            ln += '|'
            ln += formataString(grade, 23, ' ', 'D', 'N', 'S')
            ln += '|'
            ln += formataString(cod_forn, 20, ' ', 'E', 'N', 'S')
            ln += '|'
            ln += formataString(embalagem, 3, ' ', 'D', 'N', 'S')
            ln += '|'
            ln += formataString('%.3f' % qtda, 12, ' ', 'E', 'N', 'S')
            ln += '|'
            saldo_1 = 0
            saldo = saldo.get(dados_saida.id).get('saldo') or 0.0
            if not qtda == 0:
                saldo_1 = saldo / qtda

            ln += formataString(getNumeroEditado(saldo_1), 19, ' ', 'E', 'N', 'S')
            ln += '|         |         |         |        |'
            listagem.imprimeLinha(ln)
            if inc < count:
                listagem.imprimeLinha(
                    '|---------------|-------|----------------------------------------|--------------------------------------------|---|------------|-------------------|---------|---------|------------------|')
                inc += 1
        listagem.imprimeLinha('*' + '=' * 185 + '*')
        listagem.finalizaImpressao()

        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_ressuprimento')


class listagem_ressuprimento_osv(osv.TransientModel):
    _name = 'listagem.ressuprimento.osv'
    _description = 'Listagem de Ressuprimento'
    _columns = {
        'empresa_entrada_id': fields.many2one("res.company", 'Empresa', required=True, select=True),
        'local_entrada_id': fields.many2one("estoque.local", 'Local entrada', required=True,
                                            domain="[('company_id', '=', empresa_entrada_id)]"),
        'locacao_entrada': fields.char('Locacao', size=15),
        'local_saida_id': fields.many2one("estoque.local", 'Local saida', required=True),
        'avanco_pagina': fields.boolean('Avanco de pagina',
                                        help="Se marcado, a cada mudanca de local sera efetuado a quebra da pagina")
    }
    _defaults = {
        'avanco_pagina': lambda *a: True,
        'empresa_entrada_id': lambda *a: 1,
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = self.read(cr, uid, ids[0], [], context=context)
        if vals.get('local_entrada_id') == vals.get('local_saida_id'):
            raise osv.except_osv(_('Atencao'), _('Locais de Entrada e Saida nao podem ser iguais!'))
        args_search = ()
        o_locacao = self.pool.get('estoque.local.locacao')
        o_local = self.pool.get('estoque.local')
        local_entrada_id = vals.get('local_entrada_id')
        if isinstance(local_entrada_id, tuple):
            local_entrada_id = local_entrada_id[0]
        empresa_entrada_id = vals.get('empresa_entrada_id')
        if isinstance(empresa_entrada_id, tuple):
            empresa_entrada_id = empresa_entrada_id[0]
        args_search = [('local_id', '=', local_entrada_id),
                       ('company_id', '=', empresa_entrada_id),
                       ]

        local_entrada_ids = o_locacao.search(cr, uid, args_search, context=context)
        local_saida_id = vals.get('local_saida_id')
        if isinstance(local_saida_id, tuple):
            local_saida_id = local_saida_id[0]
        local_saida_ids = o_locacao.search(cr, uid, [('local_id', '=', local_saida_id)], context=context)

        entrada_ids = set(
            [x['grade_id'][0] for x in o_locacao.read(cr, uid, local_entrada_ids, ['grade_id'], context=context)])
        saida_ids = set([x['grade_id'][0] if x.get('grade_id') else None for x in
                         o_locacao.read(cr, uid, local_saida_ids, ['grade_id'], context=context)])
        grade_ids = list(entrada_ids.intersection(saida_ids))
        args_search_locacao = [('grade_id', 'in', grade_ids),
                               ('local_id', '=', local_entrada_id)]

        locacao_entrada = vals.get('locacao_entrada')
        if locacao_entrada:
            args_search_locacao.append(('locacao', '=', locacao_entrada))
        locacao_ids = o_locacao.search(cr, uid, args_search_locacao, context=context, order='locacao')

        vals_locacao = o_locacao.read(cr, uid, locacao_ids,
                                      ['produto_id', 'locacao', 'grade_id', 'estllc_produto_embalagem_id'],
                                      context=context)
        groupy_locacao = tuple(
            set([x['locacao'] for x in o_locacao.read(cr, uid, locacao_ids, ['locacao'], context=context)]))
        nomes_local = {'entrada': o_local.read(cr, uid, local_entrada_id, ['name'], context=context)['name'],
                       'saida': o_local.read(cr, uid, local_saida_id, ['name'], context=context)['name']}
        if not locacao_ids:
            raise osv.except_osv(_('Atencao'), _('Nao ha dados para gerar o relatorio'))
        nome_empresa = self.pool.get("res.company").read(cr, uid, empresa_entrada_id, ['name'], context=context)['name']
        data = {'form': vals,
                'locacao_ids': locacao_ids,
                'vals_locacao': vals_locacao,
                'groupy_locacao': groupy_locacao,
                'nomes_local': nomes_local,
                'nome_empresa': nome_empresa,
                'ids': ids,
                'local_saida_id': local_saida_id, }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'listagem_ressuprimento',
            'datas': data,
        }
