# -*- coding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _
from SigUtils import calcDigito


class wizard_conferencia_ressuprimento_itens(osv.TransientModel):
    def fields_get(self, cr, user, fields=None, context=None):
        """
        CRIA CAMPOS VIRTUAIS PARA RECEBEREM O VALOR DOS CAMPOS RELACIONAIS CRIADOS NA CLASSE.
        OS CAMPOS DA CLASSE FICAM READONLY NA TELA E NÃO SÃO PASSADOS PARA A FUNÇÃO DE CREATE E WRITE
        ASSIM ESTES CAMPOS FICAM INVISIVEIS NA TELA RECEBENDO TBM O VALOR DOS CAMPOS READONLY
        """
        context = context and context.copy() or {}
        res = super(wizard_conferencia_ressuprimento_itens, self).fields_get(cr, user, fields, context)
        res['temp_grade_id'] = {'selectable': True, 'type': 'integer', 'string': 'Grade'}
        res['temp_produto_id'] = {'selectable': True, 'type': 'integer', 'string': 'Grade'}
        res['temp_produto_embalagem_id'] = {'selectable': True, 'type': 'integer', 'string': 'Grade'}
        return res

    def get_fields_readonly(self, cr, uid, valores, context=None):
        """
        BUSCA OS VALORES DOS CAMPOS QUE ESTÃO READONLY NA TELA,
        POIS SEU VALORES NÃO SÃO PASSADOS NO CREATE OU NO WRITE
        """
        context = context and context.copy() or {}
        if isinstance(valores, dict):
            if valores.get('temp_produto_id'):
                valores['produto_id'] = valores['temp_produto_id']
            if valores.get('temp_grade_id'):
                valores['grade_id'] = valores['temp_grade_id']
            if valores.get('temp_produto_embalagem_id'):
                valores['produto_embalagem_id'] = valores['temp_produto_embalagem_id']
                # utilizado para retirar do dicionario no caso de um write, pois os campos temp_ nao estao criados fisicamente.
            if valores.get('temp_produto_id'):
                del valores['temp_produto_id']
            if valores.get('temp_grade_id'):
                del valores['temp_grade_id']
            if valores.get('temp_produto_embalagem_id'):
                del valores['temp_produto_embalagem_id']
        return valores

    def onchange_quantidade_confirmada(self, cr, uid, ids, produto_id, requisicao_id, quantidade_confirmada, grade_id,
                                       produto_embalagem_id, codigo_barra_id, context=None):
        context = context and context.copy() or {}
        res = {}
        obj_requisicao_capa = self.pool.get('estoqueressuprimento.requisicao.capa')
        obj_wizard_conferencia = self.pool.get('wizard.conferencia')
        if requisicao_id and produto_id and quantidade_confirmada and grade_id and produto_embalagem_id and codigo_barra_id:
            wizard_conferencia_requisicao_id = obj_wizard_conferencia.search(cr, uid,
                                                                             [('requisicao_id', '=', requisicao_id)],
                                                                             context=context)
            if ids:
                self.write(cr, uid, wizard_conferencia_requisicao_id, context=context)
            requisicao_capa_dados = obj_requisicao_capa.read(cr, uid, [requisicao_id], ['requisicao_itens_ids'],
                                                             context=context)
            for x in requisicao_capa_dados:
                requisicao_itens_ids = x.get('requisicao_itens_ids')
            if requisicao_itens_ids:
                requisicao_itens_dados = self.pool.get('estoqueressuprimento.requisicao.itens').read(cr, uid,
                                                                                                     requisicao_itens_ids,
                                                                                                     ['produto_id',
                                                                                                      'quantidade_requisitada'],
                                                                                                     context=context)
                for x in requisicao_itens_dados:
                    requisicao_produto_id = x.get('produto_id')
                    if isinstance(requisicao_produto_id, tuple):
                        requisicao_produto_id = requisicao_produto_id[0]
                    if produto_id == requisicao_produto_id:
                        if quantidade_confirmada > x.get('quantidade_requisitada'):
                            raise osv.except_osv(_('Atencao'),
                                                 _(
                                                     'A quantidade confirmada e maior que a quantidade requisitada para este produto!'))
                        else:
                            if not wizard_conferencia_requisicao_id:
                                wizard_conferencia_requisicao_id = obj_wizard_conferencia.create(cr, uid, {
                                    'requisicao_id': requisicao_id}, context)
                            if isinstance(wizard_conferencia_requisicao_id, list):
                                wizard_conferencia_requisicao_id = wizard_conferencia_requisicao_id[-1]
                            vals = {
                                'wizard_capa_id': wizard_conferencia_requisicao_id,
                                'produto_id': produto_id,
                                'quantidade_confirmada': quantidade_confirmada,
                                'grade_id': grade_id,
                                'produto_embalagem_id': produto_embalagem_id,
                                'codigo_barra_id': codigo_barra_id,
                            }
                            context.update({'salvar_item_a_item': True})
                            self.create(cr, uid, vals, context=context)
        return res

    def check_produto_requisicao(self, cr, uid, wizard_capa_id=0, produto_id=0, qtd_linha_wizard_confirmada=0,
                                 context=None):
        """
        VERIFICA SE O PRODUTO A SER GRAVADO ESTA LANÇADO NA REQUISIÇÃO SELECIONADA.
        SE NÃO ESTIVER, RAISE É LEVANTADO MOSTRANDO A MENSAGEM.
        """
        context = context and context.copy() or {}
        if wizard_capa_id and produto_id:
            requisicao = self.pool.get('wizard.conferencia').read(cr, uid, wizard_capa_id, ['requisicao_id'],
                                                                  context=context)
            if isinstance(requisicao, list):
                requisicao = requisicao[0]
            if isinstance(requisicao, dict):
                obj_ressuprimento_itens = self.pool.get('estoqueressuprimento.requisicao.itens')
                requisicao_itens_ids = obj_ressuprimento_itens.search(cr, uid, [
                    ('requisicao_id', '=', requisicao.get('requisicao_id')[0] or 0),
                    ('produto_id', '=', produto_id)], context=context)
                if not requisicao_itens_ids:
                    raise osv.except_osv(_('Atencao'),
                                         _('Este produto nao encontra-se cadastrado na requisicao selecionada!'))
                else:
                    requisicao_dados = obj_ressuprimento_itens.read(cr, uid, requisicao_itens_ids,
                                                                    ['quantidade_requisitada', 'quantidade_confirmada'],
                                                                    context=context)
                    # BUSCA A QUANTIDADE REQUISITADA DOS ITENS DO RESSUPRIMENTO
                    if isinstance(requisicao_dados, dict):
                        requisicao_dados = [requisicao_dados]
                    if isinstance(requisicao_dados, list):
                        quantidade_requisitada = 0
                        quantidade_confirmada = 0
                        for i in requisicao_dados:
                            quantidade_requisitada += i.get('quantidade_requisitada') or 0
                            quantidade_confirmada += i.get('quantidade_confirmada') or 0
                            # BUSCA A QUANTIDADE CONFIRMADA DOS ITENS DO GRID DO OSV_MEMORY
                            #                    wizard_itens_ids = self.search(cr, uid, [('wizard_capa_id', '=', wizard_capa_id), ('produto_id','=',produto_id)])
                    quantidade_confirmada += qtd_linha_wizard_confirmada  # qtd confirmada da requisicao + qtd do wizard
                    #                    if wizard_itens_ids:
                    #                        wizard_itens_qtdes = self.read(cr, uid, wizard_itens_ids, ['quantidade_confirmada'])
                    #                        if isinstance(wizard_itens_qtdes, list):
                    #                            wizard_itens_confirmados = 0
                    #                            for i in wizard_itens_qtdes:
                    #                                wizard_itens_confirmados += i.get('quantidade_confirmada') or 0
                    #                            quantidade_confirmada += wizard_itens_confirmados
                    if round(quantidade_confirmada, 2) > round(quantidade_requisitada, 2):
                        raise osv.except_osv(_('Atencao'), _(
                            'A quantidade confirmada e maior que a quantidade requisitada para este produto!'))
                    else:
                        return True
        return 0

    def onchange_codigo_barra(self, cr, uid, ids, codigo_barra, requisicao_id, context=None):
        """
        AO DIGITAR UM CÓDIGO DE BARRAS É FEITO UM SEARCH NA TABELA DE AUTOMACAO.CODIGO.BARRA.
        CASO EXISTA O CÓDIGO DE BARRAS OS CAMPOS DE PRODUTO, GRADE E EMBALAGEM SÃO PREENCHIDOS COM O RESULTADO.
        """
        context = context and context.copy() or {}
        res = {'produto_id': [], 'grade_id': [], 'produto_embalagem_id': [], 'quantidade_confirmada': 0}
        if context.get('codigo_barra_balanca'):
            del res['quantidade_confirmada']
        if codigo_barra:
            company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, context=context)
            obj_codigo_barra = self.pool.get('automacao.codigo.barra')
            codigo_barra_id = obj_codigo_barra.search(cr, uid, [('codigo_barra', '=', codigo_barra),
                                                                ('company_id', '=', company_id)], context=context)
            if not codigo_barra_id:
                return {
                    'warning': {'title': _('Atencao'),
                                'message': _('Codigo de barras nao cadastrado para a Empresa de entrada!')}}
            else:
                codigo_barra_dados = obj_codigo_barra.read(cr, uid, codigo_barra_id[0],
                                                           ['produto_id', 'grade_id', 'produto_embalagem_id'],
                                                           context=context)
                if isinstance(codigo_barra_dados, list):
                    codigo_barra_dados = codigo_barra_dados[0]
                if isinstance(codigo_barra_dados, dict):
                    try:
                        produto_id = codigo_barra_dados['produto_id'][0]
                        grade_id = codigo_barra_dados['grade_id'][0]
                        produto_embalagem_id = codigo_barra_dados['produto_embalagem_id'][0]
                    except:
                        return {'value': res}
                    obj_requisicao_itens = self.pool.get('estoqueressuprimento.requisicao.itens')
                    requisicao_itens_ids = obj_requisicao_itens.search(cr, uid, [('requisicao_id', '=', requisicao_id),
                                                                                 ('produto_id', '=', produto_id),
                                                                                 ('grade_id', '=', grade_id)],
                                                                       context=context)
                    if not requisicao_itens_ids:
                        return {
                            'warning': {'title': _('Atencao'), 'message': _('Produto nao cadastrado na requisicao!')}}
                    else:
                        res['produto_id'] = produto_id
                        res['grade_id'] = grade_id
                        res['produto_embalagem_id'] = produto_embalagem_id
                        # NÃO RETIRAR OS CAMPOS ABAIXO.
                        res['temp_produto_id'] = produto_id
                        res['temp_grade_id'] = grade_id
                        res['temp_produto_embalagem_id'] = produto_embalagem_id
        return {'value': res}

    _name = 'wizard.conferencia.itens'
    _description = 'Busca itens da requisicao'
    _columns = {
        'wizard_capa_id': fields.many2one('wizard.conferencia', "Requisicao", ondelete='cascade'),
        'codigo_balanca': fields.char('Codigo balanca', size=13),
        'leitura_codigo_balanca': fields.boolean('Leitura codigo balanca'),
        'codigo_barra_id': fields.char("Cod. Barra", size=14),
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="cascade", required=True, select=True),
        # Id do produto
        'grade_id': fields.many2one("estoque.produto.grade", 'Grade', ondelete="cascade", required=True, select=True,
                                    domain="[('produto_id', '=', produto_id)]"),  # id da grade
        'produto_embalagem_id': fields.many2one('estoque.produto.embalagem', 'Embalagem', ondelete="cascade",
                                                required=True, domain="[('produto_id', '=', produto_id)]"),
        'quantidade_confirmada': fields.float('Quantidade confirmada', digits=(9, 3)),
    }

    def default_get(self, cr, uid, fields_list, context=None):
        context = context and context.copy() or {}
        res = super(wizard_conferencia_ressuprimento_itens, self).default_get(cr, uid, fields_list,
                                                                              context)
        res.update({'leitura_codigo_balanca': context.get('codigo_barra_balanca') or False})
        return res

    def onchange_codigo_balanca(self, cr, uid, ids, codigo_balanca, context=None):
        context = context and context.copy() or {}
        res = {'value': {'codigo_barra_id': False}}
        if not codigo_balanca:
            return res
        if not codigo_balanca.startswith('2') or len(codigo_balanca) != 13:
            res['value'].update({'codigo_balanca': ''})
            res.update({'warning': {'title': _('Atencao'),
                                    'message': _('Codigo lido nao e de balanca.')}})
            return res
        codigo_barra = codigo_balanca[1:6]
        codigo_barra += str(calcDigito.ean(codigo_barra))
        codigo_barra = codigo_barra.zfill(14)
        res['value'].update({'codigo_barra_id': codigo_barra,
                             'quantidade_confirmada': int(codigo_balanca[7:12]) / 1000.0})
        return res

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        res = 0
        if context.get('salvar_item_a_item'):
            if 0 > vals.get('quantidade_confirmada') or 0:
                raise osv.except_osv(_('Atencao'), _('A quantidade confirmada deve ser maior ou igual a zero!'))
            vals = self.get_fields_readonly(cr, uid, vals, context)
            if vals.get(
                    'wizard_capa_id'):  # NÃO RETIRAR ABAIXO A NOMEAÇÃO DOS PARAMETROS QUE SÃO PASSADOS PARA A FUNÇÃO (Luis)
                res = self.check_produto_requisicao(cr, uid, wizard_capa_id=vals['wizard_capa_id'],
                                                    produto_id=vals.get('produto_id')
                                                    , qtd_linha_wizard_confirmada=vals.get('quantidade_confirmada'))
                if not res:
                    raise osv.except_osv(_('Atencao'),
                                         _('O produto inserido nao encontra-se cadastrado para a requisicao!'))
                else:
                    wizard_quantidade_confirmada = round(vals.get('quantidade_confirmada') or 0, 2)
                    if wizard_quantidade_confirmada:
                        wizard_requisicao_capa = self.pool.get('wizard.conferencia').read(cr, uid,
                                                                                          vals['wizard_capa_id'],
                                                                                          ['requisicao_id'],
                                                                                          context=context)
                        if isinstance(wizard_requisicao_capa, list):
                            wizard_requisicao_capa = wizard_requisicao_capa[0]
                        if isinstance(wizard_requisicao_capa, dict):
                            requisicao_id = wizard_requisicao_capa.get('requisicao_id')
                            if requisicao_id:
                                obj_ressuprimento_itens = self.pool.get('estoqueressuprimento.requisicao.itens')
                                ressup_itens_ids = obj_ressuprimento_itens.search(cr, uid, [
                                    ('produto_id', '=', vals.get('produto_id') or 0),
                                    ('requisicao_id', '=', requisicao_id[0])], context=context)
                                if not ressup_itens_ids:
                                    raise osv.except_osv(_('Atencao'), _(
                                        'O item digitado nao foi encontrado em na requisicao selecionada acima!'))
                                else:
                                    ressup_itens = obj_ressuprimento_itens.read(cr, uid, ressup_itens_ids,
                                                                                ['id', 'quantidade_requisitada',
                                                                                 'quantidade_confirmada'],
                                                                                context=context)
                                    context['ressuprimento_alterar'] = True
                                    for i in ressup_itens:
                                        if wizard_quantidade_confirmada:
                                            confirmado = i.get('quantidade_confirmada') or 0
                                            quantidade_restante = round(
                                                (i.get('quantidade_requisitada') or 0) - confirmado, 2)
                                            if quantidade_restante:
                                                if quantidade_restante > wizard_quantidade_confirmada:
                                                    diferenca = quantidade_restante - wizard_quantidade_confirmada
                                                    confirmado += wizard_quantidade_confirmada
                                                    wizard_quantidade_confirmada = 0
                                                elif quantidade_restante < wizard_quantidade_confirmada:
                                                    diferenca = wizard_quantidade_confirmada - quantidade_restante
                                                    confirmado += wizard_quantidade_confirmada - diferenca
                                                    wizard_quantidade_confirmada = diferenca
                                                else:
                                                    confirmado += wizard_quantidade_confirmada
                                                    wizard_quantidade_confirmada = 0
                                                obj_ressuprimento_itens.write(cr, uid, i.get('id') or [],
                                                                              {'quantidade_confirmada': confirmado},
                                                                              context)

                                    return super(wizard_conferencia_ressuprimento_itens, self).create(cr, uid, vals,
                                                                                                      context)
        return res

    def write(self, cr, uid, ids, values, context=None):
        context = context and context.copy() or {}
        raise osv.except_osv(_('Atencao'), _('Nao e permitido alterar o item ja lancado!'))


class wizard_conferencia_ressuprimento(osv.TransientModel):
    _name = 'wizard.conferencia'
    _description = 'Busca requisicao'
    _columns = {
        'requisicao_id': fields.many2one('estoqueressuprimento.requisicao.capa', 'Requisicao', ondelete='cascade', help="REQUISICAO A SER CONFERIDA. \
                AO LANCAR UM PRODUTO NO GRID ABAIXO, A QUANTIDADE CONFIRMADA DA REQUISICAO SELECIONADA SERA ALTERADA AUTOMATICAMENTE."),
        # Numero da requisicao RQ-AAAA-999999
        'wizard_itens_ids': fields.one2many('wizard.conferencia.itens', 'wizard_capa_id', 'Itens'),
        'leitura_codigo_barra_balanca': fields.boolean(
            'Leitura codigo barras balanca', help='A selecao desse campo indica que o usuario fara '
                                                  'a leitura de codigo de barras de balanca, por '
                                                  'meio de um scanner.'),
    }
    _defaults = {
        'leitura_codigo_barra_balanca': lambda *a: False,
    }

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('wizard_itens_ids'):
            wizard_itens_ids = vals.get('wizard_itens_ids')
            for y in wizard_itens_ids:
                for i in y:
                    if isinstance(i, dict):
                        if not i.get('quantidade_confirmada'):
                            raise osv.except_osv(_('Atencao'), _('A quantidade confirmada deve ser maior que zero!'))
        res = super(wizard_conferencia_ressuprimento, self).create(cr, uid, vals, context)
        return res

    def button_finalizar_conferencia(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        conferencia_ressuprimento_dados = self.read(cr, uid, ids, ['requisicao_id', 'wizard_itens_ids'],
                                                    context=context)
        obj_ressuprimento_capa = self.pool.get('estoqueressuprimento.requisicao.capa')
        for x in conferencia_ressuprimento_dados:
            wizard_requisicao_id = x.get('requisicao_id')
            if isinstance(wizard_requisicao_id, tuple):
                wizard_requisicao_id = wizard_requisicao_id[0]
            requisicao_ids = obj_ressuprimento_capa.search(cr, uid,
                                                           [('id', '=', wizard_requisicao_id), ('state', '=', 'M')],
                                                           context=context)
            if not requisicao_ids:
                raise osv.except_osv(_('atencao'),
                                     _(
                                         'A requisicao a ser finalizada nao foi localizada ou ja encontra-se finalizada!'))
            else:
                obj_ressuprimento_capa.button_conferido(cr, uid, requisicao_ids, context=context)
        return False
