#-*- encoding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from openerp.report.interface import report_int
from openerp.report.render import render
from openerp.osv import osv, fields
import StringIO
from openerp import pooler
import time
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        pdf_file = StringIO.StringIO()
        context['retorno_sem_codigo'] = True
        state = datas['state']
        nome_empresa = datas['nome_empresa']
        data_inicial = str(datas['data_inicial'])
        data_final = str(datas['data_final'])
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_file, _('Listagem de Requisicoes Pendentes'))
        listagem.informaTamLinha(140)
        listagem.defineMargem(1, 1, 1, 1)
        cab = _(u'Controle Estoque Pendentes                           ') + nome_empresa + _(u'                                         Pagina:  {{ Page }}')
        listagem.informaCab(cab)
        listagem.informaCab(' ')
        data_hoje = time.strftime('%d-%m-%Y')
        listagem.informaCab(
            _('Data: ') + data_hoje + _('                                      Listagem de Requisicoes Pendentes                                         '))
        listagem.informaCab(' ')
        listagem.informaCab(_('Status: ') + state + ' ')
        listagem.informaCab(' ')
        if data_inicial and data_final:
            vogal_a = ' a '
        else:
            vogal_a = ''
        listagem.informaCab(('Periodo: ') + data_inicial + vogal_a + data_final)
        listagem.informaCab(' ')
        listagem.informaCab(
            '=============================================================================================================================================')
        cab = formataString(_('Requisicao'), 15, ' ', 'D', 'S', 'S')
        cab += formataString(_('|---Entrada---|'), 17, ' ', 'D', 'S', 'S')
        cab += formataString(_('|---Saida---|'), 15, ' ', 'D', 'S', 'S')
        cab += formataString(_('Cod.Item'), 10, ' ', 'D', 'S', 'S')
        cab += formataString(_('Grade'), 8, ' ', 'D', 'S', 'S')
        cab += formataString(_('Cod.Fabricante'), 17, ' ', 'D', 'S', 'S')
        cab += formataString(_('Descricao'), 25, '  ', 'D', 'S', 'S')
        cab += formataString(_('Requisitado'), 13, ' ', 'D', 'S', 'S')
        cab += formataString(_('Pendencia'), 10, ' ', 'D', 'S', 'S')
        listagem.informaCab(cab)
        listagem.informaCab(
            '=============================================================================================================================================')
        listagem.informaCab(_('                    Local       Emp     Local'))
        listagem.informaCab(
            '=============================================================================================================================================')

        listagem.informaCab(' ')
        listagem.rodapePadrao()
        #        qtdRequisicao=0;

        obj_requisicao = pooler.get_pool(cr.dbname).get('estoqueressuprimento.requisicao.capa')
        for req in obj_requisicao.browse(cr, uid, datas['requisicao_ids'], context):
            linha = formataString(req.numero, 19, ' ', 'D', 'S', 'S')
            linha += ' '
            linha += formataString('%02d' % req.local_entrada_id.id, 11, ' ', 'D', 'S', 'S')
            linha += ' '
            saida = str('%03d' % req.company_id.id) + '        ' + str('%02d' % req.local_saida_id.id)
            linha += formataString(saida, 14, ' ', 'D', 'S', 'S')
            linha += ' '
            #            ids_itens= obj_itens.search(cr,uid,)
            for itens in req.requisicao_itens_ids:
                linha += formataString(itens.produto_id.id, 9, ' ', 'D', 'S', 'S')
                linha += ' '
                linha += formataString(itens.grade_id.grade, 7, ' ', 'D', 'S', 'S')
                linha += ' '
                linha += formataString(itens.produto_id.fabricante_id.id or '', 16, ' ', 'D', 'S', 'S')
                linha += ' '
                linha += formataString(itens.produto_id.name, 24, ' ', 'D', 'S', 'S')
                linha += ' '
                linha += formataString(itens.quantidade_requisitada, 11, ' ', 'E', 'S', 'S')
                linha += ' '
                linha += formataString(itens.quantidade_confirmada, 10, ' ', 'E', 'S', 'S')
                linha += ' '
                listagem.imprimeLinha(linha)
                linha = '                                               '

            #        qtdRequisicao=qtdRequisicao+1
        listagem.imprimeLinha(
            '=============================================================================================================================================')
        #        listagem.imprimeLinha('Quantidade de Requisicao Almoxarifado: '+str(qtdRequisicao))
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_file.getvalue())
        self.obj.render()
        pdf_file.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_de_requisicoes_pendentes')


class wizard_listagem_requisicoes_pendentes(osv.TransientModel):
    _name = 'listagem.requisicoes.pendentes'
    _columns = {
        'company_id': fields.many2one('res.company', "Empresa", required=True),
        'data_inicial': fields.date('Data Inicial'),
        'data_final': fields.date('Data Final'),
        'state': fields.selection([('R', 'Esboco'), ('T', 'Transferido'), ('C', 'Cancelada'), ('TD', 'Todos')],
                                  "Status")
    }
    _defaults = {
        'state': 'TD',
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(cr, uid, uid).company_id.id,
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        data = {}
        requisicoes_pendentes = self.read(cr, uid, ids, context=context)
        if isinstance(requisicoes_pendentes, list):
            requisicoes_pendentes = requisicoes_pendentes[0]
        if isinstance(requisicoes_pendentes, dict):
            data_inicial = ''
            data_final = ''
            company_id = requisicoes_pendentes.get('company_id', [])
            nome_empresa = self.pool.get('res.company').read(cr, uid, company_id[0], ['name'], context=context)
            data['nome_empresa'] = ''
            if isinstance(nome_empresa, list):
                nome_empresa = nome_empresa[0]
            if isinstance(nome_empresa, dict):
                nome_empresa = nome_empresa.get('name', '')
                data['nome_empresa'] = nome_empresa
            args = []
            data['state'] = _("Todos")
            data['data_inicial'] = ''
            data['data_final'] = ''
            if requisicoes_pendentes.get('R'):
                args.append(('state', '=', 'R'))
                data['state'] = _("Esboco")
            elif requisicoes_pendentes.get('T'):
                args.append(('state', '=', 'T'))
                data['state'] = _("Transferido")
            elif requisicoes_pendentes.get('C'):
                args.append(('state', '=', 'C'))
                data['state'] = _("Cancelada")
            if requisicoes_pendentes.get('data_inicial'):
                args.append(('data', '>=', requisicoes_pendentes['data_inicial']))
                data['data_inicial'] = time.strftime("%d-%m-%Y",
                                                     time.strptime(requisicoes_pendentes['data_inicial'], "%Y-%m-%d"))
                data_inicial = data.get('data_inicial')
            if requisicoes_pendentes.get('data_final'):
                args.append(('data', '<=', requisicoes_pendentes['data_final']))
                data['data_final'] = time.strftime("%d-%m-%Y",
                                                   time.strptime(requisicoes_pendentes['data_final'], "%Y-%m-%d"))
                data_final = data.get('data_final')

            if data_inicial and data_final:
                if data_final < data_inicial:
                    raise osv.except_osv(_('Atencao'), _('Data final deve ser maior ou igual a data inicial'))

            requisicoes_ids = self.pool.get('estoqueressuprimento.requisicao.capa').search(cr, uid, args,
                                                                                           context=context)
            if not requisicoes_ids:
                raise osv.except_osv(_('Atencao'), _('Nao ha dados para gerar o Relatorio'))
            data['requisicao_ids'] = requisicoes_ids

            return {'type': 'ir.actions.report.xml', 'report_name': 'listagem_de_requisicoes_pendentes', 'datas': data}
        return False

