# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from time import strftime
from openerp.tools.translate import _


class wizard_ressuprimento_total(osv.TransientModel):
    _name = 'wizard.ressuprimento.total'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa de Entrada'),
        'saida_company_id': fields.many2one("res.company", 'Empresa de Saida'),
        'local_entrada_id': fields.many2one("estoque.local", 'Local entrada', ondelete="restrict", select=True,
                                            domain="[('company_id', '=', company_id)]"), # id do local de entrada
        'local_saida_id': fields.many2one("estoque.local", 'Local saida', ondelete="restrict", select=True,
                                          domain="[('company_id', '=', saida_company_id)]"), # Id do local de saida
        'mensagem': fields.text(''),
        'flag': fields.boolean('Flag'),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        'saida_company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        'mensagem': '',
        'flag': False,
    }

    def onchange_saida_company_id(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return {'value': {'flag': False,
                          'local_saida_id': False}}

    def onchange_local_saida_id(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return {'value': {'flag': False}}

    def onchange_local_entrada_id(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return {'value': {'flag': False}}

    def _get_dados_embalagem(self, cr, uid, produto_embalagem_ids, context=None):
        """
        Retorna um dicionario onde os ids de 'estoque.produto.embalagem' sao as chaves e os valores
        outro dicionario onde qtd_unidade e fracionado como chaves, ex:
        {1:{'qtd_na_embalagem':10, 'fracionado':False}, 2:{'qtd_na_embalagem':1, 'fracionado':True}}
        """
        res = {}
        sql = """SELECT epe.id,
                        ee.quantidade_na_embalagem AS qtd,
                        eeu.fracao AS fracao
                 FROM estoque_produto_embalagem AS epe
                 INNER JOIN estoque_embalagem AS ee ON ee.id = epe.embalagem_id
                 INNER JOIN estoque_embalagem_unidade AS eeu on eeu.id = ee.unidade_id
                 WHERE epe.id in (%s)
              """ % (','.join(map(lambda x: '%s' % x, produto_embalagem_ids)))
        cr.execute(sql)
        map(lambda x: res.update({x.get('id'):{'qtd_embalagem': x.get('qtd'),
                                               'fracionado': x.get('fracao')}}), cr.dictfetchall())
        return res

    def button_criar_ressuprimento(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        _spg = self.pool.get
        # BUSCA NO ESTOQUE PARAMETRO A QUANTIDADE DE ITENS PARA UM RESSUPRIMENTO
        parametro_ids = _spg('estoque.parametro').search(cr, uid, [], context=context)
        if not parametro_ids:
            raise osv.except_osv(_('Atencao'), _(
                'Nao foi encontrado nenhum parametro de estoque para a empresa logada!'))

        wizard_total_capa = self.read(cr, uid, ids, context=context, load='_classic_write')[0]
        saida_company_id = wizard_total_capa.get('saida_company_id') or 0
        local_saida_id = wizard_total_capa.get('local_saida_id') or []
        entrada_company_id = wizard_total_capa.get('company_id') or 0
        local_entrada_id = wizard_total_capa.get('local_entrada_id') or []
        obj_produto_grade = self.pool.get('estoque.produto.grade')
        obj_estoque_produto_saldo = self.pool.get('estoque.produto.saldo')
        obj_local_locacao = self.pool.get('estoque.local.locacao')
        obj_requisicao_capa = self.pool.get('estoqueressuprimento.requisicao.capa')
        saida_locacao_ids = obj_local_locacao.search(cr, uid, [('local_id','=',local_saida_id)],
                                                     context=context)
        if not saida_locacao_ids:
            raise osv.except_osv(_('Atencao!'),
                                 _('Sem produtos no local de saida!'))

        entrada_locacao_ids = obj_local_locacao.search(cr, uid, [('local_id','=',local_entrada_id)],
                                                       context=context)
        if not entrada_locacao_ids:
            raise osv.except_osv(_('Atencao!'),
                                 _('Sem produdos no local de entrada!'))

        dados_local_locacao_saida = obj_local_locacao.read(cr, uid,  saida_locacao_ids,
                ['grade_id', 'estllc_produto_embalagem_id'], context=context, load='_classic_write')

        dados_local_locacao_entrada = obj_local_locacao.read(cr, uid, entrada_locacao_ids,
                         ['produto_id', 'grade_id', 'estllc_produto_embalagem_id'], context=context,
                         load='_classic_write')
        saida_grade_embalagem = {}
        map(lambda x: saida_grade_embalagem.update({x.get('grade_id'):
                                                    x.get('estllc_produto_embalagem_id')}),
            dados_local_locacao_saida)
        entrada_grade_embalagem = {}
        map(lambda x: entrada_grade_embalagem.update({x.get('grade_id'):
                                                      x.get('estllc_produto_embalagem_id')}),
            dados_local_locacao_entrada)
        saida_produto_embalagem_ids = map(lambda x:  x.get('estllc_produto_embalagem_id'),
                                    dados_local_locacao_saida)
        entrada_produto_embalagem_ids = map(lambda x:  x.get('estllc_produto_embalagem_id'),
                                    dados_local_locacao_entrada)
        _grade_ids = []
        while False in entrada_produto_embalagem_ids:
            i = entrada_produto_embalagem_ids.index(False)
            entrada_produto_embalagem_ids.pop(i)
            _grade_ids.append(dados_local_locacao_entrada[i].get('grade_id'))
        if _grade_ids:
            mens = _('Estes produtos estao sem embalagem no local de entrada:\n')
            for dados_grade in obj_produto_grade.read(cr, uid, _grade_ids, ['produto_id', 'grade'], context=context):
                _codigo = _spg('estoque.produto').read(cr, uid, dados_grade.get('produto_id')[0], ['codigo'],
                                                       context=context).get('codigo')
                mens += _('Produto: %s Grade: %s\n') % (_codigo, dados_grade.get('grade'))
            raise osv.except_osv(_('Atencao!'), mens)
        saida_grade_ids = map(lambda x: x.get('grade_id'), dados_local_locacao_saida)
        entrada_produto_ids = map(lambda x: x.get('produto_id'), dados_local_locacao_entrada)
        saldos = obj_estoque_produto_saldo.get_saldo_do_dia(cr, uid, saida_grade_ids,
                                                           strftime('%Y-%m-%d'),
                                                           local_saida_id,
                                                           context=context)
        limite = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque.parametro',
                                             ['ressuprimento_item_qtde_max'], context=context).\
                                             get('ressuprimento_item_qtde_max') or 0
        cont = 0
        itens_requisicao = []
        dados_embalagem_saida = self._get_dados_embalagem(cr, uid, saida_produto_embalagem_ids,
                                                          context=context)
        dados_embalagem_entrada = self._get_dados_embalagem(cr, uid, entrada_produto_embalagem_ids,
                                                          context=context)

        produtos_sem_embalagem_saida = []
        msg = 'Sem itens para requisicao'
        requisicao_capa_ids = []
        context['super_estoqueressuprimento_requisicao_itens'] = True
        for grade in obj_produto_grade.read(cr, uid, saida_grade_ids, ['produto_id', 'name',
                                                'codigo'], context=context, load='_classic_write'):
            produto_id = grade.get('produto_id')
            grade_id = grade.get('id')
            saida_produto_embalagem_id = saida_grade_embalagem.get(grade_id)
            if not saida_produto_embalagem_id:
                produtos_sem_embalagem_saida.append('%s - %s' % (grade.get('codigo'), grade.get('name')))
                continue

            # SE O PRODUTO NÃO ESTIVER CADASTRADOS PARA AMBAS EMPRESAs, EXIBIRÁ MSG.
            if produto_id not in entrada_produto_ids:
                entrada_grade_embalagem[grade_id] = saida_produto_embalagem_id
                dados_embalagem_entrada[saida_produto_embalagem_id] = dados_embalagem_saida.get(saida_produto_embalagem_id)
                obj_local_locacao.create(cr, uid, {'company_id': entrada_company_id,
                                                   'local_id': local_entrada_id,
                                                   'produto_id': produto_id,
                                                   'grade_id': grade_id,
                                                   'estllc_produto_embalagem_id': saida_produto_embalagem_id})

            entrada_produto_embalagem_id = entrada_grade_embalagem.get(grade_id)
            # cria locacao de entrada para o produto
            if not entrada_produto_embalagem_id:
                entrada_produto_embalagem_id = saida_produto_embalagem_id
                dados_embalagem_entrada[entrada_produto_embalagem_id] = dados_embalagem_saida.get(entrada_produto_embalagem_id)
                obj_local_locacao.create(cr, uid, {'company_id': entrada_company_id,
                                                   'local_id': local_entrada_id,
                                                   'produto_id': produto_id,
                                                   'grade_id': grade_id,
                                                   'estllc_produto_embalagem_id': saida_produto_embalagem_id})

            saldo = saldos.get(grade_id).get('disponivel')
            if saldo <= 0:
                continue

            # retira os produtos onde a quantidade nao eh multipla da embalagem e nao aceitao fracao
            # no local de SAIDA
            if saldo % dados_embalagem_saida.get(saida_produto_embalagem_id).get('qtd_embalagem') > 0:
                if not dados_embalagem_saida.get(saida_produto_embalagem_id).get('fracionado'):
                    continue

            # retira os produtos onde a quantidade nao eh multipla da embalagem e nao aceitao fracao
            # no local de ENTRADA
            if saldo % dados_embalagem_entrada.get(entrada_produto_embalagem_id).get('qtd_embalagem') > 0:
                if not dados_embalagem_entrada.get(entrada_produto_embalagem_id).get('fracionado'):
                    continue

            cont += 1
            itens_requisicao.append((0,0,{'produto_id': produto_id,
                                          'grade_id': grade_id,
                                          'embalagem_id': saida_produto_embalagem_id,
                                          'saldo': saldo,
                                          'quantidade_requisitada': saldo}))
            # cria a requisicao com no maaximo o limite de itens definido no parametro
            if limite and cont >= limite:
                requisicao_capa_ids.append(obj_requisicao_capa.create(cr, uid,
                                              {'resrca_empresa_entrada_id': saida_company_id,
                                               'local_saida_id': local_saida_id,
                                               'company_id': entrada_company_id,
                                               'local_entrada_id': local_entrada_id,
                                               'tipo': 'QR',
                                               'requisicao_itens_ids': itens_requisicao}, context))
                itens_requisicao = []
                cont = 0
                msg = 'Requisicao Concluida!'


        # cria a requisicao com os itens restantes
        if itens_requisicao:
            requisicao_capa_ids.append(obj_requisicao_capa.create(cr, uid,
                                              {'resrca_empresa_entrada_id': saida_company_id,
                                               'local_saida_id': local_saida_id,
                                               'company_id': entrada_company_id,
                                               'local_entrada_id': local_entrada_id,
                                               'tipo': 'QR',
                                               'requisicao_itens_ids': itens_requisicao}, context))
            msg = 'Requisicao Concluida!'

        if produtos_sem_embalagem_saida:
            msg += '\n\nOs produtos a seguir nao possuem embalagem no local de saida: \n%s' % \
              ('\n'.join(produtos_sem_embalagem_saida))

        self.write(cr, uid, ids, {'flag': True,
                                  'mensagem': msg}, context)
        # calcula os metodos funcionais da capa
        if requisicao_capa_ids:
            obj_requisicao_capa.write(cr, uid, requisicao_capa_ids, {}, context=context)

        return True

