#!/usr/bin/python
# -*- encoding: utf-8 -*-

##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from datetime import datetime


class serie_movimento(osv.Model):
    _name = 'estoqueserie.movimento'
    _inherit = 'estoqueserie.movimento'

    def esemov_atualizar_disponibilidade_serie(self, cr, uid, serie_ids, operacao, context):
        if isinstance(serie_ids, (int, long)):
            serie_ids = [serie_ids]
        if serie_ids and operacao:
        ## metodo e utilizado apenas para forcar uma alteracao na tabela estoqueserie.produto
        ## com a finalidade de executar a funcao do campo 'esepro_disponivel'. Aqui esta sendo
        ## passado true para o campo mas a funcao irá verificar a disponibilidade para o campo.
        #            self.pool.get('estoqueserie.produto').write(cr, uid, serie_ids, {'esepro_disponivel': True})
            if operacao in ('E', 'C'):
                operacao = 'E'
            else:
                operacao = 'S'
            self.pool.get('estoqueserie.produto').write(cr, uid, serie_ids, {'esepro_disponivel': operacao}, context)
            return True
        return False

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        vals['esemov_data'] = datetime.today()
        mov_item_id = vals.get('esemov_movimento_itens_id')
        if mov_item_id:
            browse_mov_item = self.pool.get('estoque.movimento.itens').browse(cr, uid, mov_item_id)
            nf_operacao = browse_mov_item.nf_id.tipo
            vals['esemov_operacao'] = nf_operacao
        pedido_item_id = vals.get('esemov_pedido_item_id')
        if pedido_item_id:
            browse_pedido_item = self.pool.get('estoquepedidos.pedido.item').browse(cr, uid, pedido_item_id)
            pedido_operacao = browse_pedido_item.pedido_id.tipo
            vals['esemov_operacao'] = 'E' if pedido_operacao == 'C' else 'S'
        res = super(serie_movimento, self).create(cr, uid, vals, context=context)
        # [IMPORTANTE] - NÃO REMOVER ESTA FUNÇÃO ABAIXO. É UTILIZADA PARA FORÇAR O WRITE EM ESTOQUESERIE.PRODUTO,
        # MESMO TENDO O STORE = {}.
        self.esemov_atualizar_disponibilidade_serie(cr, uid, serie_ids=vals.get('esemov_serie_id'),
                                                    operacao=vals['esemov_operacao'], context=context)
        return res

    def write(self, cr, uid, ids, values, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
        new_serie_id = values.get('esemov_serie_id') or []
        serie_ids = []
        if new_serie_id:
            ## Antes de alterar o registro e necessário atualizar o registro de serie anterior e o novo registro.
            ## O codigo abaixo busca o registro de serie anterior e depois junta com o novo, para fazer a atualizacao
            ## de disponibilidade.
            browse_serie_movimento = self.browse(cr, uid, ids)
            serie_ids = map(lambda i: i.esemov_serie_id.id, browse_serie_movimento)
            if not isinstance(new_serie_id, list):
                new_serie_id = [new_serie_id]
            serie_ids.extend(new_serie_id)
        res = super(serie_movimento, self).write(cr, uid, ids, values, context=context)
        return res

    def unlink(self, cr, uid, ids, context=None):
        """
        Nao mudar a ordem abaixo.
        1 - Buscar o serie_id do movimento
        2 - Realizar o super
        3 - Utilizar a funcao para atualizar disponibilidade
        """
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
        serie_ids = []
        browse_serie_mov = self.browse(cr, uid, ids)
        if browse_serie_mov:
            serie_ids = filter(None, map(lambda i: i.esemov_serie_id.id, browse_serie_mov))
        res = super(serie_movimento, self).unlink(cr, uid, ids, context)
        return res
