#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv
from string import punctuation, maketrans
from re import sub as re_sub
from openerp.tools.translate import _


class serie_utils(osv.Model):
    _name = 'serie.utils'
    _auto = False
    _messagem_erro = u''
    _tem_erro = u''

    def serutl_get_erro(self):
        return self._messagem_erro

    def serutl_generate_msg_serie_produtos(self, cr, uid, dict_msg, context=None):
        """
        dict_msg = {key: {'msg': 'Erro .....', 'produto_ids': [1,2,3, ......]}}
        RETORNA MENSAGEM DE ERRO 'PRODUTO ....: NUMEROS DE SÉRIE'
        """
        context = context and context.copy() or {}
        msg = u''
        obj_estoque_produto = self.pool.get('estoque.produto')
        for i in dict_msg:
            produto_ids = dict_msg[i]['produto_ids']
            serie_msg = dict_msg[i]['msg']

            res_name_get = obj_estoque_produto.name_get(cr, uid, produto_ids, context) or [('', '')]
            dict_name_get = dict(res_name_get)
            produto_names = u''

            for t in produto_ids:
                produto_names += u'%s, ' % (dict_name_get.get(t) or _('** Produto nao encontrado **'))
            msg += u'%s: %s' % (produto_names, serie_msg)
        return msg.replace(', :', ':')

    def serutl_restricao_entrada(self, cr, uid, list_series, grade_id, context=None):
        """
        VERIFICA SE O NÚMERO DE SÉRIE JA ENCONTRA-SE CADASTRADO PARA A GRADE.
        ESSA VERIFICAÇÃO É FEITA PORQUE PODE HAVER A DEVOLUÇÃO DO NUMERO DE SÉRIE,
        GERANDO UMA NOTA ENTRADA. ESTA ENTRADA SO PODERÁ SER FEITA, SE O NUMERO DE SÉRIE NÃO ESTIVER DISPONÍVEL,
        CARACTERIZANDO QUE HOUVE UMA SAIDA DO MESMO.
        """
        context = context and context.copy() or {}
        res = u''
        obj_serie_produto = self.pool.get('estoqueserie.produto')
        args = [('esepro_grade_id', '=', grade_id), ('esepro_disponivel', '=', True)]
        serie_no_banco_ids = obj_serie_produto.search(cr, uid, args, context=context)
        if not serie_no_banco_ids:
            return res
        else:
            serie_banco_dados = obj_serie_produto.read(cr, uid, serie_no_banco_ids, ['esepro_nro_serie'],
                                                       context=context)
            serie_banco = filter(None, map(lambda i: i.get('esepro_nro_serie') or False, serie_banco_dados))
            if serie_banco:
                series_ja_cadastradas = list(set(serie_banco).intersection(list_series))
                for i in series_ja_cadastradas:
                    res += u'%s, ' % i
            return res

    def serutl_get_prefix_number(self, number):
        """
        RETORNA O PREFIXO(ALFANUMÉRICO) E O DIGITO(NUMÉRICO) DO NUMERO DE SÉRIE PASSADO.
        """
        reverse_number = number[::-1]
        previx = ''
        digits = ''
        for i in reverse_number:
            if i.isdigit():
                digits += i
            else:
                break
        if digits:
            digits = digits[::-1]
            previx = number.replace(digits, '').upper()
        return previx, digits

    def serutl_clean_serial_number(self, list_serial_number, table_to_translate):
        """
        FUNÇÃO REMOVE CARACTERES PASSADOS NO PARAMETRO table_to_translate (string.maketrans)
        """
        # REMOVE TODOS OS CARACTERES ESPECIAIS E ESPAÇOS DO NUMERO DE SÉRIE
        res = filter(None, map(lambda s: re_sub(' ', '', s.encode('ascii', 'ignore').translate(table_to_translate)),
                               list_serial_number))
        return res

    def serutl_generate_range_serie(self, list_serie, context=None):
        """
        FORMATO DE list_serie:
        [-Inicio|Fim-1-2-3-.......N-InicioN|FimN-.....]
        RETORNA
         * UMA LISTA COM OS NUMEROS DE SÉRIES TRATADOS(INTERVALO, CARACTERES ESPECIAIS REMOVIDOS) OU
         * FALSE EM CASO DE ERRO
        """
        context = context and context.copy() or {}
        self._tem_erro = False
        self._messagem_erro = u''

        pontuacao = punctuation
        new_caracteres = len(pontuacao) * ' '
        table = maketrans(pontuacao, new_caracteres)

        pontuacao_pipe = punctuation.replace('|', '')
        new_caracteres_pipe = len(pontuacao_pipe) * ' '
        table_pipe = maketrans(pontuacao_pipe, new_caracteres_pipe)

        list_serial_numbers = []
        for str_serie in list_serie:
            slice_serial_hifen = filter(None, str_serie.split('-'))
            slice_serial_pipe = filter(lambda i: '|' in i, slice_serial_hifen)
            for i in slice_serial_pipe:
                inicio_fim = self.serutl_clean_serial_number(filter(None, i.split('|')), table_pipe)
                if len(inicio_fim) == 2:
                    inicio = (inicio_fim[0] or '')
                    fim = (inicio_fim[1] or '')

                    if not inicio.isdigit() or not fim.isdigit():
                        if len(inicio) != len(fim):
                            self._messagem_erro += _('* Numeros de Serie com tamanho diferente - %s; ') % i
                            self._tem_erro = True

                    inicio_prefix, str_inicio_number = self.serutl_get_prefix_number(inicio)
                    fim_prefix, str_fim_number = self.serutl_get_prefix_number(fim)

                    if inicio_prefix != fim_prefix:
                        self._messagem_erro += _('* Prefixo diferente para o intervalo - %s; ') % i

                    if not str_inicio_number.isdigit():
                        self._messagem_erro += _('* Nro Inicial nao possui digito valido no intervalo - %s; ') % i
                        self._tem_erro = True
                    if not str_inicio_number.isdigit():
                        self._messagem_erro += _('* Nro Final nao possui digito valido no intervalo - %s; ') % i
                        self._tem_erro = True

                    if not self._tem_erro:
                        width_serie = len(str_inicio_number)

                        if int(str_inicio_number) > int(str_fim_number):
                            self._messagem_erro += _('* Digito inicial maior que o digito final no intervalo - %s; ') % i
                            self._tem_erro = True
                        else:
                            for n in range(int(str_inicio_number), int(str_fim_number) + 1):
                                number = str(n).rjust(width_serie, '0')
                                serial = '%s%s' % (inicio_prefix, number)
                                list_serial_numbers.append(serial)
            if not self._tem_erro:
                if slice_serial_hifen:
                    # REMOVE TODOS OS CARACTERES ESPECIAIS E ESPAÇOS DO NUMERO DE SÉRIE
                    numbers_cleaned = self.serutl_clean_serial_number(
                        filter(lambda i: not '|' in i, slice_serial_hifen), table)
                    list_serial_numbers.extend(numbers_cleaned)
        if self._tem_erro:
            return False
        else:
            return list_serial_numbers