#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class estoque_produto_grade(osv.Model):
    _name = 'estoque.produto.grade'
    _inherit = 'estoque.produto.grade'

    def estpgr_get_parametro_serie(self, cr, uid, context=None):
        context = context and context.copy() or {}
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'estoque.produto', context=context)
        controla_numero_serie = False
        obj_estoque_parametro = self.pool.get('estoque.parametro')
        estoque_parametro_ids = obj_estoque_parametro.search(cr, uid, [('company_id', '=', company_id)], context=context)
        if estoque_parametro_ids:
            estoque_parametro_dados = obj_estoque_parametro.read(cr, uid, estoque_parametro_ids,
                                                                 ['estpar_controle_serie'], context=context)
            if estoque_parametro_dados and isinstance(estoque_parametro_dados, list):
                estoque_parametro_dados = estoque_parametro_dados[0]
            if isinstance(estoque_parametro_dados, dict):
                controla_numero_serie = estoque_parametro_dados.get('estpar_controle_serie')
        return controla_numero_serie

    def estpgr_get_controlar_serie(self, cr, uid, ids, name, arg, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
        controla_numero_serie = self.estpgr_get_parametro_serie(cr, uid, context=context)
        res = {}.fromkeys(ids, controla_numero_serie)
        return res

    def estpgr_default_controlar_serie(self, cr, uid, context=None):
        context = context and context.copy() or {}
        controla_numero_serie = self.estpgr_get_parametro_serie(cr, uid, context=context)
        return controla_numero_serie

    _columns = {
        'estpgr_nserie_controle': fields.function(estpgr_get_controlar_serie, method=True, string="Parametro Serie",
                                                  store=False, type="boolean"),
        'estpgr_serie_ids': fields.one2many('estoqueserie.produto', 'esepro_grade_id', 'Numeros de Serie')
        #, domain=[('estpgr_disponivel', '=', True)]
    }
    _defaults = {
        'estpgr_nserie_controle': estpgr_default_controlar_serie
    }
