# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_movimento_itens(osv.Model):
    _inherit = 'estoque.movimento.itens'

    def _get_serie_parametro(self, cr, uid, ids, name, arg, context=None):
        """
        Busca informacoes do parâmetro do estoque verificando se controla serie,
        e se o produto está sendo controlado pelo numero de serie ou nao.  Return: True or False.
        """
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
            # Nao remover pois gera erro ao listar os itens no grid da nf.
        # Os ids passados devem ser retornados
        res = {}.fromkeys(ids, False)
        if ids:
            obj_estoque_parametro = self.pool.get('estoque.parametro')
            browse_mov_itens = self.browse(cr, uid, ids)
            for i in browse_mov_itens:
                nf_id = i.nf_id.id
                if nf_id:
                    estoque_parametro_id = obj_estoque_parametro.search(
                        cr, uid, [], context=context)
                    if estoque_parametro_id:
                        controla_numero_serie = obj_estoque_parametro.browse(
                            cr, uid, estoque_parametro_id[0], context).estpar_controle_serie
                        if controla_numero_serie:
                            produto_id = i.produto_id.id
                            if produto_id:
                                produto_controla_serie = i.produto_id.estpro_nserie_tipo
                                if produto_controla_serie in ('NS', 'NC'):
                                    res[i.id] = True
        return res

    _columns = {
        'movimento_serie_ids': fields.one2many(
            'estoqueserie.movimento', 'esemov_movimento_itens_id', 'Nro Serie'),
        'parametro_controle_serie': fields.function(
            _get_serie_parametro, method=True, type="boolean", string="Parametro Controle de Serie",
            store=False)
    }

    def estmvi_onchange_item_movimento(self, cr, uid, ids, empresa, natureza, nf_tipo, destinatario,
                                       item, local, preco_venda, total, nf_propria, nf_devolucao,
                                       endereco=False, grade_id=False, tributacao=None,
                                       context=None):
        context = context and context.copy() or dict()
        controle_serie = False
        res = super(estoque_movimento_itens, self).estmvi_onchange_item_movimento(
            cr, uid, ids, empresa, natureza, nf_tipo, destinatario, item, local, preco_venda, total,
            nf_propria, nf_devolucao, endereco, grade_id, tributacao, context)
        if item:
            obj_produto = self.pool.get('estoque.produto')
            controla_numero_serie = obj_produto.estpro_get_parametro_serie(
                cr, uid, context=context)
            if controla_numero_serie:
                produto_dados = self.pool.get('estoque.produto').read(
                    cr, uid, item, ['estpro_nserie_tipo'], context)
                produto_controle_serie = produto_dados.get('estpro_nserie_tipo')
                controle_serie = produto_controle_serie in ('NS', 'NC')
            res['value'].update({
                'estmvi_produto_nserie_controle': controle_serie,
                'estmvi_movserie_ids': []
            })

        return res

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
