# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_produto(osv.Model):
    _name = 'estoque.produto'
    _inherit = 'estoque.produto'

    def estpro_get_parametro_serie(self, cr, uid, context=None):
        context = context and context.copy() or {}
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'estoque.produto', context=context)
        controla_numero_serie = False
        obj_estoque_parametro = self.pool.get('estoque.parametro')
        estoque_parametro_ids = obj_estoque_parametro.search(cr, uid, [('company_id', '=', company_id)],
                                                             context=context)
        if estoque_parametro_ids:
            estoque_parametro_dados = obj_estoque_parametro.read(cr, uid, estoque_parametro_ids,
                                                                 ['estpar_controle_serie'], context=context)
            if estoque_parametro_dados and isinstance(estoque_parametro_dados, list):
                estoque_parametro_dados = estoque_parametro_dados[0]
            if isinstance(estoque_parametro_dados, dict):
                controla_numero_serie = estoque_parametro_dados.get('estpar_controle_serie')
        return controla_numero_serie

    def estpro_get_controlar_serie(self, cr, uid, ids, name, arg, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
        controla_numero_serie = self.estpro_get_parametro_serie(cr, uid, context=context)
        res = {}.fromkeys(ids, controla_numero_serie)
        return res

    def estpro_default_controlar_serie(self, cr, uid, context=None):
        context = context and context.copy() or {}
        controla_numero_serie = self.estpro_get_parametro_serie(cr, uid)
        return controla_numero_serie

    _columns = {
        'estpro_nserie_controle': fields.function(estpro_get_controlar_serie, method=True, string="Parametro Serie",
                                                  store=False, type="boolean"),
        'estpro_nserie_tipo': fields.selection([
                                                   ('SN', 'Sem Numero de Serie'),
                                                   ('NS', 'Com Numero de Serie / sem Impressao'),
                                                   ('NC', 'Com Numero de Serie / com Impressao')], 'Numero Serie',
                                               size=2, help="Controle de Numero de Serie")
    }
    _defaults = {
        'estpro_nserie_tipo': 'SN',
        'estpro_nserie_controle': estpro_default_controlar_serie
    }


