# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoqueserie_produto(osv.Model):
    from funcoes import esepro_get_disponibilidade, _esepro_get_disponibilidade_movimento

    _name = 'estoqueserie.produto'
    _rec_name = 'esepro_nro_serie'
    _columns = {
        ## ________________________ char ________________________________
        'esepro_nro_serie': fields.char('Nro Serie', size=30, required=True), # Numero de Serie
        ## ________________________ function ________________________________
        'esepro_disponivel': fields.function(esepro_get_disponibilidade, method=True, type="boolean",
                                             string="Disponivel", select=1,
                                             # store=True
                                             store={
                                                 'estoqueserie.movimento': (
                                                     _esepro_get_disponibilidade_movimento, ['esemov_serie_id'], 10),
                                                 'estoqueserie.produto': (esepro_get_disponibilidade,
                                                                          ['esepro_disponivel', 'esepro_nro_serie',
                                                                           'esepro_grade_id'], 10)
                                             }
        ),
        ## ________________________ one2many ________________________________
        'esepro_movimento_ids': fields.one2many('estoqueserie.movimento', 'esemov_serie_id', 'Movimentacao'),
        ## ________________________ many2one ________________________________
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True), # Id da empresa
        'esepro_produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="restrict", required=True, select=True),
        # id do produto
        'esepro_grade_id': fields.many2one("estoque.produto.grade", 'Grade', ondelete="restrict", required=True,
                                           domain="[('produto_id', '=', esepro_produto_id)]", select=1), # id da grade
    }
    _order = 'esepro_produto_id, esepro_nro_serie'
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        'esepro_disponivel': False,
    }