# -*- coding: utf-8 -*-

from openerp.osv import osv, fields
from time import strftime


class estoqueserie_movimento(osv.Model):
    from funcoes import _esemov_get_destinatario_nota

    _name = 'estoqueserie.movimento'
    _rec_name = 'esemov_serie_id'

    _columns = {
        'esemov_serie_id': fields.many2one('estoqueserie.produto', 'Numero de Serie', required=True,
                                           ondelete='cascade'),
        'esemov_data': fields.datetime('Data Operacao', required=True),
        'esemov_operacao': fields.selection([('E', 'ENTRADA'), ('S', 'SAiDA')], 'Operacao', size=1, required=True),
        'esemov_movimento_itens_id': fields.many2one('estoque.movimento.itens', 'Movimento Estoque',
                                                     ondelete='cascade'),
        'esemov_pedido_item_id': fields.many2one('estoquepedidos.pedido.item', 'Item Pedido', ondelete='cascade'),
        'esemov_nf_numero': fields.related('esemov_movimento_itens_id', 'nf_id', 'numero_nf', type='integer',
                                           relation='fiscal.nf.capa', string="Nro Nota Fiscal", store=False),
        'esemov_pessoa_id': fields.function(_esemov_get_destinatario_nota, method=True, type='char',
                                            string="Cliente/Fornecedor", store=False),
        'esemov_nf_state': fields.related('esemov_movimento_itens_id', 'nf_id', 'state', type='char',
                                          relation='fiscal.nf.capa', string="Status NF", store=False),
    }
    _sql_constraints = [('serie_mov_item_uniq', 'unique(esemov_serie_id, esemov_movimento_itens_id)',
                         'O Numero de Serie deve ser unico para a Produto!')]
    _order = 'esemov_data desc'
    _defaults = {
        'esemov_data': lambda *a: strftime('%Y-%m-%d'),
    }
