# -*- encoding: utf-8 -*-

from openerp.report.interface import report_int
from openerp.report.render import render
from SigUtils.impressao import Impressora
import StringIO
from openerp import pooler
import time
from SigUtils.formatastring import formataString
from openerp.osv import osv, fields
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        title = center_title(_('                                   ITENS & NUMEROS DE SERIE'), '', '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Listagem de Itens e Numeros de Serie'))
        listagem.informaTamLinha(160)

        obj_estoque_produto = pooler.get_pool(cr.dbname).get('estoque.produto')
        obj_estoqueserie_produto = pooler.get_pool(cr.dbname).get('estoqueserie.produto')
        obj_estoqueserie_movimento = pooler.get_pool(cr.dbname).get('estoqueserie.movimento')

        args_estoque_produto = []
        args_estoqueserie_produto = []
        estoqueserie_produto_ids = []

        categoria_id = datas.get('categoria_id')
        impressao = datas.get('impressao')
        produto_id = datas.get('produto_id')
        grade_id = datas.get('grade_id')
        disponibilidade = datas.get('disponibilidade')
        movimento = datas.get('movimento')

        if categoria_id:
            args_estoque_produto.append(('categoria_id', '=', categoria_id), )
        if impressao == 'TO':
            args_estoque_produto.append(('estpro_nserie_tipo', 'in', ('NS', 'NC')), )
        else:
            args_estoque_produto.append(('estpro_nserie_tipo', '=', impressao), )
        if args_estoque_produto and not produto_id:
            produto_ids = obj_estoque_produto.search(cr, uid, args_estoque_produto, context=context)
            if produto_ids:
                args_estoqueserie_produto.append(('esepro_produto_id', 'in', produto_ids), )

        if produto_id:
            args_estoqueserie_produto.append(('esepro_produto_id', '=', produto_id), )
        if grade_id:
            args_estoqueserie_produto.append(('esepro_grade_id', '=', grade_id), )
        if disponibilidade:
            args_estoqueserie_produto.append(('esepro_disponivel', '=', disponibilidade), )

        entrada_saida = False
        if args_estoqueserie_produto:
            context['listagem_itens_numero_serie'] = True
            estoqueserie_produto_ids = obj_estoqueserie_produto.search(cr, uid, args_estoqueserie_produto,
                                                                       context=context)
            if estoqueserie_produto_ids:
                if movimento in ('E', 'S'):
                    estoqueserie_movimento_ids = obj_estoqueserie_movimento.search(cr, uid, [
                        ('esemov_serie_id', 'in', estoqueserie_produto_ids),
                        ('esemov_operacao', '=', movimento)], context=context)
                    if estoqueserie_movimento_ids:
                        browse_estoqueserie_movimento = obj_estoqueserie_movimento.browse(cr, uid,
                                                                                          estoqueserie_movimento_ids)
                        estoqueserie_produto_ids = []
                        for x in browse_estoqueserie_movimento:
                            if not x.esemov_serie_id.id in estoqueserie_produto_ids:
                                estoqueserie_produto_ids.append(x.esemov_serie_id.id)
                        if estoqueserie_produto_ids:
                            entrada_saida = True
                elif movimento == 'T':
                    entrada_saida = True

        browse_estoqueserie_produto = obj_estoqueserie_produto.browse(cr, uid, estoqueserie_produto_ids, context)

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                                                     'wizard.listagem.itens.numero.serie', context=context)
        nome_empresa = pooler.get_pool(cr.dbname).get('res.company').browse(cr, uid, company_id).name
        data = time.strftime("%d/%m/%Y")
        docs = center_title('%s                     %s' % (data, nome_empresa), _('                Pagina: {{ Page }} '),
                            '')

        listagem.informaCab(title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab(docs)
        listagem.informaCab('  ')
        listagem.informaCab(
            '|--------------------------------------------------------------------------------------------|')
        listagem.informaCab(
            _('|   CODIGO   |      GRADE      |                DESCRICAO              |  TIPO NUMERO SERIE  |'))
        listagem.informaCab(
            '|--------------------------------------------------------------------------------------------|')
        listagem.informaCab(
            _('|         NUMERO SERIE         |   DISPONIVEL  |                                             |'))
        listagem.informaCab(
            '|--------------------------------------------------------------------------------------------|')
        if movimento != 'N':
            listagem.informaCab(
                _('| DATA OPERACAO | OPERACAO | NUMERO PEDIDO | NUMERO NF |          CLIENTE/FONECEDOR          |'))
            listagem.informaCab(
                '|--------------------------------------------------------------------------------------------|')
        listagem.informaCab('')
        listagem.informaCab(
            '|                                                                                            |')
        listagem.rodapePadrao()
        if browse_estoqueserie_produto:
            for i in browse_estoqueserie_produto:
                if i.esepro_produto_id:
                    linha = '|'
                    linha += formataString(i.esepro_produto_id.codigo or '', 12, ' ', 'D', 'S', 'S')
                    linha += '|'
                    linha += formataString(i.esepro_grade_id.descricao or '', 17, ' ', 'D', 'S', 'S')
                    linha += '|'
                    linha += formataString(i.esepro_produto_id.name, 39, ' ', 'D', 'S', 'S')
                    linha += '|'
                    if i.esepro_produto_id.estpro_nserie_tipo == 'NC':
                        nserie_tipo = _('Com impressao')
                    elif i.esepro_produto_id.estpro_nserie_tipo == 'NS':
                        nserie_tipo = _('Sem impressao')
                    linha += formataString(nserie_tipo, 21, ' ', 'D', 'S', 'S')
                    linha += '|'
                    listagem.imprimeLinha(linha)

                    linha = '|'
                    linha += formataString(i.esepro_nro_serie or '', 30, ' ', 'D', 'S', 'S')
                    linha += '|'
                    linha += formataString(_('Sim') if i.esepro_disponivel else _('Nao'), 15, ' ', 'D', 'S', 'S')
                    linha += '|'
                    linha += formataString('', 45, ' ', 'D', 'S', 'S')
                    linha += '|'
                    listagem.imprimeLinha(linha)

                    if movimento != 'N' and entrada_saida:
                        estoqueserie_movimento_ids = i.esepro_movimento_ids or []
                        if estoqueserie_movimento_ids:
                            for x in estoqueserie_movimento_ids:
                                if x.esemov_operacao == movimento or movimento == 'T':
                                    linha = '|'
                                    linha += formataString(x.esemov_data[:10] or '', 15, ' ', 'D', 'S', 'S')
                                    linha += '|'
                                    operacao = _('Entrada') if x.esemov_operacao == 'E' else _('Saida')
                                    linha += formataString(operacao or '', 10, ' ', 'D', 'S', 'S')
                                    linha += '|'
                                    pedido_numero = ''
                                    pedido_item_id = x.esemov_pedido_item_id
                                    if pedido_item_id:
                                        pedido_numero = pedido_item_id.pedido_id.numero_pedido or ''
                                    linha += formataString(pedido_numero, 15, ' ', 'D', 'S', 'S')
                                    linha += '|'
                                    nf_numero = ''
                                    pessoa = ''
                                    movimento_itens_id = x.esemov_movimento_itens_id
                                    if movimento_itens_id:
                                        nf_id = movimento_itens_id.nf_id
                                        if nf_id:
                                            nf_numero = nf_id.numero_nf or ''
                                            pessoa = nf_id.destinatario_id.name or ''
                                    linha += formataString(nf_numero, 11, ' ', 'D', 'S', 'S')
                                    linha += '|'
                                    linha += formataString(pessoa, 37, ' ', 'D', 'S', 'S')
                                    linha += '|'
                                    listagem.imprimeLinha(linha)

                listagem.imprimeLinha(
                    '|--------------------------------------------------------------------------------------------|')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_itens_numero_serie')
