# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class wizard_listagem_itens_numero_serie(osv.TransientModel):
    _name = 'wizard.listagem.itens.numero.serie'
    _description = u'Listagem de itens e seus numeros de serie'
    _columns = {
        'categoria_id': fields.many2one('estoque.categoria', 'Categoria'), #Id da categoria
        'impressao': fields.selection([
                                          ('TO', 'Todos'),
                                          ('NS', 'Numero de Serie / sem Impressao'),
                                          ('NC', 'Numero de Serie / com Impressao')], 'Impressao', size=2,
                                      required=True),
        'produto_id': fields.many2one('estoque.produto', 'Produto', domain="[('estpro_nserie_tipo','in',('NS','NC'))]"),
        'grade_id': fields.many2one('estoque.produto.grade', 'Grade', domain="[('produto_id','=',produto_id)]"),
        'disponibilidade': fields.boolean('Numeros disponiveis'),
        'movimento': fields.selection([('T', 'Todos'), ('N', 'Nenhum'), ('E', 'Entradas'), ('S', 'Saidas')],
                                      'Movimento', size=1, required=True),
    }
    _defaults = {
        'impressao': 'TO',
        'movimento': 'T',
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = self.browse(cr, uid, ids)
        for x in vals:
            datas = {
                'categoria_id': x.categoria_id.id or False,
                'impressao': x.impressao,
                'produto_id': x.produto_id.id or False,
                'grade_id': x.grade_id.id or False,
                'disponibilidade': x.disponibilidade or False,
                'movimento': x.movimento
            }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'listagem_itens_numero_serie',
            'datas': datas,
        }
