# -*- coding: utf-8 -*-

from openerp.osv import osv, fields
from datetime import date
from openerp.tools.translate import _

class wizard_serie_lancadas(osv.Model):
    _name = 'wizard.serie.lancadas'
    _columns = {
        'wserielan_cadastro_id': fields.many2one('wizard.serie.cadastro', 'Produto/Grade'),
        'wserielan_numero_serie': fields.char('Nro de Serie', size=300, required=True)
    }


class wizard_serie_cadastro(osv.Model):
    _name = 'wizard.serie.cadastro'
    _columns = {
        'wseriecad_produto_id': fields.many2one('estoque.produto', 'Produto', required=True,
                                                domain="[('tipo', '=', 'P')]"),
        'wseriecad_grade_id': fields.many2one('estoque.produto.grade', 'Grade', required=True,
                                              domain="[('produto_id', '=', wseriecad_produto_id)]"),
        'wseriecad_serie_ids': fields.one2many('wizard.serie.lancadas', 'wserielan_cadastro_id', 'Series'),
        'wseriecad_show_inf': fields.boolean('Mostrar informacoes sobre lancamento de Nro de Serie')
    }
    _defaults = {
        'wseriecad_show_inf': False,
    }

    def wseriecad_onchange_produto(self, cr, uid, ids, wseriecad_produto_id, context=None):
        context = context and context.copy() or {}
        res = {}
        if wseriecad_produto_id:
            grade_ids = self.pool.get('estoque.produto.grade').search(cr, uid,
                                                                      [('produto_id', '=', wseriecad_produto_id)],
                                                                      context=context)
            if len(grade_ids) == 1:
                res.update({'wseriecad_grade_id': grade_ids[0]})
        return {'value': res}

    def wseriecad_button_cadastrar_series(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        msg_wserie_erro = u''
        serie_entrada_invalida = {}
        serie_cadastro_dados = self.read(cr, uid, ids,
                                         ['wseriecad_produto_id', 'wseriecad_grade_id', 'wseriecad_serie_ids',
                                          'wseriecad_data_operacao'], context=context)
        if isinstance(serie_cadastro_dados, list) and serie_cadastro_dados:
            serie_cadastro_dados = serie_cadastro_dados[0]
        if isinstance(serie_cadastro_dados, dict):
            produto_id = serie_cadastro_dados.get('wseriecad_produto_id') and \
                         serie_cadastro_dados['wseriecad_produto_id'][0] or False
            grade_id = serie_cadastro_dados.get('wseriecad_grade_id') and serie_cadastro_dados['wseriecad_grade_id'][
                0] or False
            serie_lancada_ids = serie_cadastro_dados.get('wseriecad_serie_ids') or False
            if not serie_lancada_ids:
                raise osv.except_osv(_('Atencao'),
                                     _('Nenhum Numero de Serie encontra-se lancado para o Produto e Grade selecionado!'))
            else:
                obj_serie_movimento = self.pool.get('estoqueserie.movimento')
                obj_serie_produto = self.pool.get('estoqueserie.produto')
                data_operacao = date.today()
                serie_lancada_dados = self.pool.get('wizard.serie.lancadas').read(cr, uid, serie_lancada_ids,
                                                                                  ['wserielan_numero_serie'], context=context)
                obj_serie_utils = self.pool.get('serie.utils')

                vals_serie_produto = {
                    'esepro_produto_id': produto_id,
                    'esepro_grade_id': grade_id
                }
                vals_serie_mov = {
                    'esemov_data': data_operacao,
                    'esemov_operacao': 'E',
                }
                list_serie_numeros = filter(None, map(lambda i: i.get('wserielan_numero_serie'), serie_lancada_dados))
                list_series = obj_serie_utils.serutl_generate_range_serie(list_serie_numeros)
                if not list_series:
                    msg_wserie_erro += obj_serie_utils.serutl_get_erro()
                else:
                    # VERIFICA SE O NÚMERO DE SÉRIE JA ENCONTRA-SE CADASTRADO PARA A GRADE.
                    serie_entrada_cadastrada = obj_serie_utils.serutl_restricao_entrada(
                        cr, uid, list_series=list_series, grade_id=grade_id, context=context
                    )
                    if serie_entrada_cadastrada:
                        if produto_id in serie_entrada_invalida:
                            serie_entrada_invalida[produto_id] += serie_entrada_cadastrada
                        else:
                            serie_entrada_invalida[produto_id] = serie_entrada_cadastrada
                    else:
                        for serie in list_series:
                            # CREATE ESTOQUESERIE.PRODUTO ______________________________________
                            vals_serie_produto['esepro_nro_serie'] = serie
                            serie_produto_id = obj_serie_produto.create(cr, uid, vals_serie_produto, context=context)

                            # CREATE ESTOQUESERIE.MOVIMENTO ______________________________________
                            vals_serie_mov['esemov_serie_id'] = serie_produto_id
                            obj_serie_movimento.create(cr, uid, vals_serie_mov, context=context)

        if serie_entrada_invalida:
            produto_ids = serie_entrada_invalida.keys()
            res_name = self.pool.get('estoque.produto').name_get(cr, uid, produto_ids, context=context) or [('', '')]
            dict_produto_names = dict(res_name)
            msg = ''
            for i in serie_entrada_invalida:
                produto_name = (dict_produto_names.get(i) or '').encode('utf-8') or _('** Produto nao encontrado **')
                series = serie_entrada_invalida[i]
                msg += '%s: %s' % (produto_name, series)
            raise osv.except_osv(_('Numeros de Series ja cadastrados'), msg)
        if msg_wserie_erro:
            raise osv.except_osv(_('Numeros de Series invalidos %s') % msg_wserie_erro)
        else:
            return {'type': 'ir.actions.act_window_close'}
