##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class eventos_adesoes_acertos(osv.Model):
    """
    Tabela de controle de acertos das adesoes dos eventos
    """
    _name = 'eventos.adesoes.acertos'
    _inherit = 'eventos.adesoes.acertos'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        _adesoes_id = vals.get('eveada_adesoes_id')
        if _adesoes_id:
            x = self.pool.get('eventos.adesoes').browse(cr, uid, _adesoes_id)
            _qtd = 0
            for _acerto in x.eveads_acertos_ids:
                _qtd += _acerto.eveada_quantidade
            _qtd += vals.get('eveada_quantidade')
            if _qtd > x.eveads_quantidade_fornecida:
                raise osv.except_osv(_('Atencao'), _('Quantidade maior do que a entregue!'))
        res = super(eventos_adesoes_acertos, self).create(cr, uid, vals, context=context)
        self.pool.get('eventos.adesoes').write(cr, uid, _adesoes_id, {}, context=context)
        _acerto = self.browse(cr, uid, res)

        valor = 0
        if _acerto.eveada_tipo == 'V':
            if _acerto.eveada_com_desconto:
                valor = _acerto.eveada_quantidade * _acerto.eveada_adesoes_id.eveads_evento_id.\
                    eveeve_valor_com_desconto
            else:
                valor = _acerto.eveada_quantidade * _acerto.eveada_adesoes_id.eveads_evento_id.\
                    eveeve_valor_normal

        vals = {
            'evecax_acertos_id': _acerto.id,
            'evecax_data': _acerto.eveada_data,
            'evecax_tipo': 'R',
            'evecax_valor': valor,
        }
        self.pool.get('eventos.caixa').create(cr, uid, vals, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
        _brw_acertos = self.browse(cr, uid, ids)
        for _brw_acerto in _brw_acertos:
            _qtd = 0
            for _acerto in _brw_acerto.eveada_adesoes_id.eveads_acertos_ids:
                if _brw_acerto.id == _acerto.eveada_adesoes_id.id:
                    _qtd -= _acerto.eveada_quantidade
                else:
                    _qtd += _acerto.eveada_quantidade
            if vals.get('eveada_quantidade'):
                _qtd += vals.get('eveada_quantidade')
            if _qtd > _brw_acerto.eveads_quantidade_fornecida:
                raise osv.except_osv(_('Atencao'), _('Quantidade maior do que a entregue!'))
        res = super(eventos_adesoes_acertos, self).write(cr, uid, ids, vals, context=context)
        _brw_acertos = self.browse(cr, uid, ids)
        for _brw_acerto in _brw_acertos:
            _evc_ids = self.pool.get('eventos.caixa').search(cr, uid, [('evecax_acertos_id', '=', _brw_acerto.id)],
                                                             context=context)
            cax_vals = {
                'evecax_acertos_id': _brw_acerto.id,
                'evecax_data': _brw_acerto.eveada_data,
                'evecax_tipo': 'R',
                'evecax_valor': _brw_acerto.eveada_valor_acerto,
            }
            if _evc_ids:
                self.pool.get('eventos.caixa').write(cr, uid, _evc_ids, cax_vals, context=context)
            else:
                self.pool.get('eventos.caixa').create(cr, uid, cax_vals, context=context)
            self.pool.get('eventos.adesoes').write(cr, uid, _brw_acerto.eveada_adesoes_id.id, {}, context=context)
        return res

