# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class eventos_caixa(osv.Model):
    _name = 'eventos.caixa'
    _inherit = 'eventos.caixa'

    def unlink(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
        serie_ids = []
        for browse_serie_mov in self.browse(cr, uid, ids):
            if browse_serie_mov and browse_serie_mov.evecax_acertos_id and context.get('evecax_manual'):
                raise osv.except_osv(_('Atencao'), _('Nao posso excluir lancamentos automaticos!'))
        res = super(eventos_caixa, self).unlink(cr, uid, ids, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
        for browse_serie_mov in self.browse(cr, uid, ids):
            if browse_serie_mov and browse_serie_mov.evecax_acertos_id and context.get('evecax_manual'):
                raise osv.except_osv(_('Atencao'), _('Nao posso alterar lancamentos automaticos!'))
        res = super(eventos_caixa, self).write(cr, uid, ids, vals, context=context)
        return res

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        fvalor = vals.get('evecax_valor')
        if fvalor < 0:
            fvalor = fvalor * -1
        if vals.get('evecax_tipo') == 'T':
            vals['evecax_valor'] = fvalor * -1
        res = super(eventos_caixa, self).create(cr, uid, vals, context=context)
        return res