# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class eventos_adesoes_acertos(osv.Model):
    """
    Tabela de controle de acertos das adesoes dos eventos
    """
    from funcoes import _eveada_get_valor

    _name = 'eventos.adesoes.acertos'
    _rec_name = 'eveada_data'
    _inherits = {'eventos.adesoes': 'eveada_adesoes_id'}
    _columns = {
        'eveada_adesoes_id': fields.many2one('eventos.adesoes', 'Adesoes', ondelete="restrict", required=True, select=True),
        'eveada_data': fields.date('Data', required=True),
        'eveada_tipo': fields.selection([('D', 'Devolvida'), ('V', 'Vendida')], 'Vendida/Devolvida', required=True),
        'eveada_quantidade': fields.integer('Quantidade acertada', required=True),
        'eveada_com_desconto': fields.boolean('Com desconto'),
        'eveada_valor_acerto': fields.function(_eveada_get_valor, multi='acerto', method=True, string='Valor p/acerto', type='float', store=True),
        'create_uid': fields.many2one("res.users", 'Quem acertou', ondelete="restrict", select=True, readonly="1"),
    }
    _order = 'eveada_adesoes_id,eveada_data'
    _defaults = {
        'eveada_data': lambda *a: time.strftime('%Y-%m-%d'),
        'eveada_tipo': lambda *a: 'V',
    }
