# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class eventos_adesoes(osv.Model):
    """
    Tabela de controle de adesoes dos eventos
    """
    from funcoes import _eveads_get_qtd_pendente

    _name = 'eventos.adesoes'
    _rec_name = 'eveads_responsavel_id'
    _columns = {
        'eveads_evento_id': fields.many2one('eventos.eventos', 'Evento', required=True, select=True, domain="[('eveeve_tipo_inscricao','=','A')]"),
        'eveads_responsavel_id': fields.many2one("adm.pessoa", 'Inscrito', ondelete="restrict",
                                                 select=True, domain="[('pessoa_tipo', '=', 'F')]", required=True),
        'eveads_data': fields.date('Data', required=True),
        'eveads_quantidade_fornecida': fields.integer('Quantidade fornecida', required=True),
        'eveads_quantidade_pendente': fields.function(_eveads_get_qtd_pendente, multi='pendente', method=True, string='Quantidade acertada', type='integer', store=True),
        'eveads_valor_acerto': fields.function(_eveads_get_qtd_pendente, multi='pendente', method=True, string='Valor acertado', type='float', store=True),
        'eveads_pendente': fields.function(_eveads_get_qtd_pendente, multi='pendente', method=True, string='Pendente', type='integer', store=True),
        'eveads_acertos_ids': fields.one2many('eventos.adesoes.acertos', 'eveada_adesoes_id', 'Acertos'),
        'create_uid': fields.many2one("res.users", 'Quem entregou', ondelete="restrict", select=True, readonly="1"),
    }
    _order = 'eveads_evento_id desc,eveads_responsavel_id'
    _defaults = {
        'eveads_data': lambda *a: time.strftime('%Y-%m-%d'),
    }
