# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class eventos_caixa(osv.Model):
    """
    Tabela de controle de caixa dos eventos
    """
    from funcoes import _eveada_get_valor

    _name = 'eventos.caixa'
    _rec_name = 'evecax_data'
    _columns = {
        'evecax_acertos_id': fields.many2one('eventos.adesoes.acertos', 'Acerto', ondelete="restrict", select=True),
        'create_uid': fields.many2one("res.users", 'Usuario', ondelete="restrict", select=True),
        'evecax_data': fields.date('Data', required=True),
        'evecax_tipo': fields.selection([('R', 'Recebimento'), ('T', 'Tranferencia')], 'Recebimento/Transferencia', required=True),
        'evecax_valor': fields.float('Valor', required=True),
    }
    _order = 'evecax_data desc'
    _defaults = {
        'evecax_data': lambda *a: time.strftime('%Y-%m-%d'),
        'evecax_tipo': lambda *a: 'T',
    }
