# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class eventos_eventos(osv.Model):
    """
    Tabela de eventos
    """
    from funcoes import _eveeve_get_qtd_vendida

    _name = 'eventos.eventos'
    _columns = {
        'name': fields.char('Descricao', size=50, required=True),  # descricao
        'eveeve_categoria_id': fields.many2one("eventos.tipo", 'Categoria', ondelete="restrict",  select=True),
        'eveeve_data_inicio': fields.datetime('Inicio do evento', required=True),
        'eveeve_data_fim': fields.datetime('Termino do evento', required=True),
        'eveeve_obs': fields.text('Informacoes complementares'),
        'eveeve_local_id': fields.many2one('adm.pessoa', 'Local', domain="[('pessoa_tipo', '=', 'J')]"),
        'eveeve_qtd_inscricoes': fields.integer('Quantidade de inscricoes/adesoes'),
        'eveeve_qtd_vendida': fields.function(_eveeve_get_qtd_vendida, multi='vendida', method=True, string='Quantidade vendida', type='integer', store=False),
        'eveeve_valor_normal': fields.float('Valor Normal', digits=(8, 2)),
        'eveeve_valor_com_desconto': fields.float('Valor com desconto', digits=(8, 2)),
        'eveeve_tipo_inscricao': fields.selection([('A', 'Ingresso/Adesao'), ('I', 'Inscricao')], 'Tipo de incricao'),
        'eveeve_adesoes_ids': fields.one2many('eventos.adesoes', 'eveads_evento_id','Adesoes'),
        'eveeve_inscricoes_ids': fields.one2many('eventos.inscricoes', 'eveinc_evento_id','Inscricoes'),
        'eveeve_materiais_ids': fields.one2many('eventos.materiais', 'evemat_evento_id', 'Materiais'),
    }
    _order = 'eveeve_data_inicio desc, name'