# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class eventos_inscricoes(osv.Model):
    """
    Tabela de inscritos nos eventos
    """
    _name = 'eventos.inscricoes'
    _rec_name = 'eveinc_pessoa_id'
    _columns = {
        'eveinc_evento_id': fields.many2one('eventos.eventos', 'Evento', required=True, select=True, domain="[('eveeve_tipo_inscricao','=','I')]"),
        'eveinc_pessoa_id': fields.many2one("adm.pessoa", 'Inscrito', ondelete="restrict",
                                            select=True, domain="[('pessoa_tipo', '=', 'F')]", required=True),
        'eveinc_instituicao_id': fields.many2one("adm.pessoa", 'Instituicao', ondelete="restrict",
                                                 select=True, domain="[('pessoa_tipo', '=', 'J')]"),
        'eveinc_data': fields.datetime('Data', required=True),
        'eveinc_tipo_valor': fields.selection([('N', 'Valor normal'), ('D', 'Valor com desconto')], 'Valor normal/Com desconto'),
        'eveinc_valor': fields.float('Valor Normal', digits=(8, 2), readonly=True),
        'eveinc_data_pgto': fields.date('Data do Pagamento'),
    }
    _order = 'eveinc_evento_id desc, eveinc_pessoa_id'
    _defaults = {
        'eveinc_data': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S'),
        'eveinc_tipo_valor': lambda *a: 'N',
    }
