# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class eventos_materais(osv.Model):
    """
    Tabela de materiais necessarios ao evento
    """
    from funcoes import _evemat_get_qtd_conseguida

    _name = 'eventos.materiais'
    _columns = {
        'name': fields.char('Descricao', size=50, required=True),  # descricao
        'evemat_evento_id': fields.many2one("eventos.eventos", 'Evento', ondelete="restrict",  select=True),
        'evemat_responsavel_id': fields.many2one('adm.pessoa', 'Responsavel', domain="[('pessoa_tipo', '=', 'F')]"),
        'evemat_qtd_necessaria': fields.integer('Quantidade necessaria'),
        'evemat_qtd_conseguida': fields.function(_evemat_get_qtd_conseguida, multi='conseguida', method=True, string='Quantidade conseguida', type='integer', store=True),
        'evemat_pendente': fields.function(_evemat_get_qtd_conseguida, multi='conseguida', method=True, string='Pendencia', type='boolean', store=True),
        'evemat_fornecedores_ids': fields.one2many('eventos.materiais.fornecedores', 'evemtf_material_id', 'Fornecedores'),
        'evemat_valor': fields.float('Valor unitario', digits=(8, 2), help='Valor unitario medio do material'),
        'evemat_observacao': fields.text('Informacoes complementares'),
    }
    _order = 'name'
