# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from datetime import datetime
from openerp.tools.translate import _

class expedicao_vendas_capa(osv.Model):
    _name = 'expedicao.vendas.capa'
    _inherit = 'expedicao.vendas.capa'

    def search(self, cr, user, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        if not order:
            order = 'expvec_data desc'
        for arg in args:
            if 'expvec_data' not in arg or count:
                continue
            if ('expvec_data' in arg and '<=' in arg) or ('expvec_data' in arg and '>=' in arg):
                continue
            arg[1] = '>='
            arg[2] = arg[2][:10] + ' 00:00:00'
            args.append(['expvec_data', '<=', arg[2][:10] + ' 23:59:59'])
            break
        res = super(expedicao_vendas_capa, self).search(cr, user, args, offset, limit, order, context, count)
        return res

    def write(self, cr, user, ids, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('expvec_data_prevista'):
            self._data_prevista = vals.get('expvec_data_prevista')
        res = super(expedicao_vendas_capa, self).write(cr, user, ids, vals, context)
        return res

    def fields_get(self, cr, user, allfields=None, context=None, write_access=True):
        context = context and context.copy() or {}
        res = super(expedicao_vendas_capa, self).fields_get(cr, user, allfields=allfields, context=context,
                                                              write_access=write_access)
        res['expvec_data_prevista'] = dict(selectable=True,
                                           string='Data prevista',
                                           type='date')
        return res

    def button_aplicar_data(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        write_date = datetime.utcnow()
        if not ids:
            return True
        if not self._data_prevista:
            return True
        data_prevista = self._data_prevista
        self._data_prevista = ''
        sql = '''
                UPDATE expedicao_vendas_itens
                SET write_date = '{write_date}',
                    write_uid = {write_uid},
                    expvei_data = '{expvei_data}'
                WHERE expvei_capa_id = {expvei_capa_id}
                  AND status != 'E'
              '''.format(write_date=write_date,
                         write_uid=uid,
                         expvei_data=data_prevista,
                         expvei_capa_id=ids[0])
        cr.execute(sql)
        return True

    def expvec_entregar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        context['venda_id'] = ids[0] if ids and isinstance(ids, list) else ids
        brw_venda = self.browse(cr, uid, ids)
        if brw_venda and isinstance(brw_venda, list):
            brw_venda = brw_venda[0]
        vals_wizard_capa = {'wizvec_documento': brw_venda.expvec_documento,
                            'wizvec_data': brw_venda.expvec_data,
                            'wizvec_pessoa_id': brw_venda.expvec_pessoa_id.id,
                            'wizvec_nf_id': brw_venda.expvec_nf_id.id or '',
                            'status': brw_venda.status,
        }
        expedicao_ecf_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'expedicao_ecf', context)
        if expedicao_ecf_instalado:
            vals_wizard_capa['wizvec_cupom_id'] = brw_venda.expvec_cupom_id.id or ''
        wizard_capa_id = self.pool.get('wizard.vendas.capa').create(cr, uid, vals_wizard_capa, context)
        if wizard_capa_id:
            for item in brw_venda.expvec_vendas_itens_ids:
                vals_wizard_itens = {'wizvei_capa_id': wizard_capa_id,
                                     'wizvei_vendas_itens_id': item.id,
                                     'wizvei_quantidade_vendida': item.expvei_quantidade_vendida,
                                     'wizvei_quantidade_entregue': item.expvei_quantidade_entregue,
                                     'wizvei_quantidade_a_entreguar': 0.0,
                                     'status': item.status,
                }
                self.pool.get('wizard.vendas.itens').create(cr, uid, vals_wizard_itens, context)
        return {
            'name': _('Entregar'),
            'view_type': 'form',
            'view_mode': 'form',
            'res_id': wizard_capa_id,
            'res_model': 'wizard.vendas.capa',
            'view_id': False,
            'context': context,
            'target': 'new',
            'type': 'ir.actions.act_window'
        }
