# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
######################################49087########################################

from openerp.osv import osv
from openerp.tools.translate import _


class fiscal_nf_capa(osv.Model):
    _name = 'fiscal.nf.capa'
    _inherit = 'fiscal.nf.capa'

    def fisnfc_faturar_nf_erp(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = super(fiscal_nf_capa, self).fisnfc_faturar_nf_erp(cr, uid, ids, context)
        if res.get('state') != '3':  # Se a nota nao estiver faturada
            return res

        self.fisnfc_gera_venda_expedicao(cr, uid, ids[0], context)
        return res

    def fisnfc_gera_venda_expedicao(self, cr, uid, nf_id, context=None):
        context = context and context.copy() or {}
        brw_nf = self.browse(cr, uid, nf_id, context)

        # Desconsidera notas fiscais sem cliente
        if any((brw_nf.fisnfc_modelo_serie == '02D', not brw_nf.destinatario_id)):
            return True

        expedicao_vendas_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'expedicao.vendas.capa', context=context)
        obj_expedicao_vendas_capa = self.pool.get('expedicao.vendas.capa')
        expedicao_vendas_capa_ids = obj_expedicao_vendas_capa.search(
            cr, uid, [('expvec_nf_id', '=', brw_nf.id)], context=context)
        state = brw_nf.state
        if any([state != '3', brw_nf.fisnfc_tipo_servico is True,
                brw_nf.tipo == 'E', brw_nf.natureza_id.cfop_id.movimento_tipo == 'D',
                expedicao_vendas_capa_ids,
                brw_nf.natureza_id.cfop_id.codigo in ('5929', '6929')]):
            return False
        brw_itens = brw_nf.estoque_movimento_itens_ids
        documento = str(brw_nf.serie_nf) + '-' + str(brw_nf.numero_nf)
        vals_capa = {'company_id': expedicao_vendas_company_id,
                     'expvec_documento': documento,
                     'expvec_data': brw_nf.data_emissao,
                     'expvec_pessoa_id': brw_nf.destinatario_id.id,
                     'expvec_nf_id': brw_nf.id,
        }
        exp_vendas_capa_id = obj_expedicao_vendas_capa.create(cr, uid, vals_capa, context)
        for item in brw_itens:
            vals_item = {'expvei_capa_id': exp_vendas_capa_id,
                         'expvei_grade_id': item.grade_id.id,
                         'expvei_embalagem_id': item.produto_embalagem_id.id,
                         'status': 'A',
            }
            if brw_nf.fisnfc_pedido_ids:
                for pedido in brw_nf.fisnfc_pedido_ids:
                    for item_pedido in pedido.pedido_item_ids:
                        if item.grade_id.id == item_pedido.grade_id.id:
                            vals_item['expvei_data'] = pedido.data_entrega
                            break
            madereira_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'madeireira', context)
            if madereira_instalado:
                vals_item['expvei_quantidade_vendida'] = item.quantidade * (item.estmvi_volume
                                                                            or 1.0)
            else:
                vals_item['expvei_quantidade_vendida'] = item.quantidade
            self.pool.get('expedicao.vendas.itens').create(cr, uid, vals_item, context)
        return True

    def abrir_cancelar_nfe(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not isinstance(ids, list):
            ids = [ids]
        args = [('expvec_nf_id', 'in', ids)]
        obj_expedicao_vendas_capa = self.pool.get('expedicao.vendas.capa')
        exp_vendas_capa_id = obj_expedicao_vendas_capa.search(cr, uid, args, context=context)
        brw_exp_vendas_capa = obj_expedicao_vendas_capa.browse(cr, uid, exp_vendas_capa_id, context)
        if brw_exp_vendas_capa:
            if isinstance(brw_exp_vendas_capa, list):
                brw_exp_vendas_capa = brw_exp_vendas_capa[0]
            if brw_exp_vendas_capa.status != 'A':
                raise osv.except_osv(_('Atencao'),
                                     _('Existe expedicao de venda com itens entregues para esta '
                                       'nota. Cancele-as primeiro.'))
        return super(fiscal_nf_capa, self).abrir_cancelar_nfe(cr, uid, ids, context)

    def write(self, cr, uid, ids, values, context=None):
        context = context and context.copy() or {}
        res = super(fiscal_nf_capa, self).write(cr, uid, ids, values, context)
        if context.get('cancelamento_nf'):
            if not isinstance(ids, list):
                ids = [ids]
            args = [('expvec_nf_id', 'in', ids)]
            exp_vendas_capa_id = self.pool.get('expedicao.vendas.capa').search(cr, uid, args, context=context)
            if exp_vendas_capa_id:
                self.pool.get('expedicao.vendas.capa').unlink(cr, uid, exp_vendas_capa_id, context)
        return res
