# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import _get_vendedor_id
from funcoes import _expetc_permissao_cancelar


class expedicao_entregas_capa(osv.Model):
    """
    Tabela que contem todas as entregas já realizadas
    """

    def get_informacoes_complementares(self, cr, uid, ids, field, args, context=None):
        context = context and context.copy() or {}
        res = {}
        obj_estoque_ped = self.pool.get('estoquepedidos.pedido.capa')
        for entrega in self.browse(cr, uid, ids, context=context):
            res[entrega.id] = ''
            if not entrega.expetc_vendas_capa_id.expvec_nf_id.id:
                continue
            if entrega.expetc_vendas_capa_id.expvec_nf_id.fisnfc_infcomp_contribuinte:
                res[entrega.id] = entrega.expetc_vendas_capa_id.expvec_nf_id.\
                    fisnfc_infcomp_contribuinte
            else:
                numero_nf = entrega.expetc_vendas_capa_id.expvec_nf_id.numero_nf
                serie_nf = entrega.expetc_vendas_capa_id.expvec_nf_id.serie_nf
                args = [('coo', '=', numero_nf), ('caixa', '=', serie_nf)]
                pedido_ids = obj_estoque_ped.search(cr, uid, args, context=context)
                res[entrega.id] = ''
                if pedido_ids:
                    res[entrega.id] = obj_estoque_ped.browse(cr, uid, pedido_ids[0], context).\
                        observacao or ''
        return res

    _name = 'expedicao.entregas.capa'
    _inherit = ['ir.needaction_mixin', 'mail.thread']
    _columns = {
        'company_id': fields.many2one('res.company', 'Empresa', ondelete='restrict', select=True),
        'expetc_vendas_capa_id': fields.many2one("expedicao.vendas.capa", 'Venda',
                                                 ondelete="cascade", required=True, select=True),
        'expetc_data_entrega': fields.datetime('Data de entrega'),
        'expetc_quem_recebeu': fields.char('Quem recebeu', size=45),
        'expetc_quem_entregou_id': fields.many2one("adm.pessoa", 'Quem entregou',
                                                   ondelete="restrict", select=True),
        'entregas_itens_ids': fields.one2many('expedicao.entregas.itens', 'expeti_capa_id',
                                              'Itens'),
        'expetc_impresso': fields.boolean('Entrega impressa'),
        'expetc_vendedor_id': fields.function(_get_vendedor_id, method=True, string='Vendedor',
                                              type='many2one', relation='vendas.vendedor', store=True),
        'expetc_informacoes_complementares': fields.function(get_informacoes_complementares,
                                                             string='Informacoes complementares',
                                                             method=True, type='text', store=True),
        'state': fields.selection([('P', 'Pendente'), ('S', 'Separada'), ('E', 'Entregue'),
                                   ('C', 'Cancelada')], string='Estado'),
        'expetc_cancel_user_id': fields.many2one('res.users', 'Quem cancelou'),
        'expetc_cancel_data': fields.datetime('Data do cancelamento'),
        'expetc_cancel_motivo': fields.text('Motivo do cancelamento'),
        'expetc_permissao_cancelar': fields.function(_expetc_permissao_cancelar, method=True,
                                                     store=False, string='Permissao para cancelar',
                                                     multi='permissao', type='boolean'),
        'expetc_view_por_estado': fields.function(_expetc_permissao_cancelar, method=True,
                                                  store=False, string='View por estado',
                                                  multi='permissao', type='char', size=1),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, s._name, context=c),
        'state': 'P'
    }
