# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from datetime import date, datetime
import time
from openerp.tools.translate import _
from dateutil.parser import parse
from SigUtils import datas


def expvei_function_search_status(self, cr, uid, obj, name, args, context=None):
    context = context and context.copy() or {}
    capa_ids = self.search(cr, uid, [], context=context)
    if not capa_ids or not args:
        return [('id', 'in', [])]
    dict_status = expvei_get_status(self, cr, uid, capa_ids, None, None, context)
    capa_ids = filter(lambda i: dict_status[i] in (args[0][2]), dict_status)
    return [('id', 'in', capa_ids)]


def expvei_get_status(self, cr, uid, ids, field, args, context=None):
    context = context and context.copy() or {}
    res = {}
    brw_capa = self.browse(cr, uid, ids)
    for capa in brw_capa:
        brw_itens = capa.expvec_vendas_itens_ids
        id = capa.id
        A = E = True
        for item in brw_itens:
            if item.status == 'A':
                E = False
            elif item.status == 'E':
                A = False
            else:
                A = False
                E = False
        if A:
            status = 'A'
        elif E:
            status = 'E'
        else:
            status = 'P'
        res[id] = status
    return res

def _get_data_proxima_entrega(self, cr, uid, ids, field, args, context=None):
    context = context and context.copy() or {}
    res = {}
    if not ids:
        return {}
    for id in ids:
        sql = '''
                SELECT MIN(expvei_data) AS expvei_data
                FROM expedicao_vendas_itens
                WHERE expvei_capa_id = {expvei_capa_id}
                  AND status != 'E'
              '''.format(expvei_capa_id=id)
        cr.execute(sql)
        data = cr.dictfetchall()[0].get('expvei_data') or ''
        res[id] = data
    return res

def _get_expvei_codigo_barra(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    if not ids:
        return res
    for _id in ids:
        sql = '''
            SELECT acb.codigo_barra    AS codigo_barra
            FROM automacao_codigo_barra       AS acb
            INNER JOIN expedicao_vendas_itens AS evi ON evi.expvei_grade_id = acb.grade_id
            WHERE evi.id = %s
          ''' % _id
        cr.execute(sql)
        item = cr.dictfetchall() or {}
        if item and isinstance(item, (list, tuple)):
            item = item[0]
        res[_id] = item.get('codigo_barra') or ''
    return res

def _get_expvei_codigo_fabricante(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    if not ids:
        return res
    itens_ids = str(ids).replace('[','').replace(']','')
    sql = '''
            SELECT evi.id                   AS id,
                   epg.codigo_no_fabricante AS codigo_fabricante
            FROM estoque_produto_grade        AS epg
            INNER JOIN expedicao_vendas_itens AS evi ON evi.expvei_grade_id = epg.id
            WHERE evi.id in (%s)
          ''' % itens_ids
    cr.execute(sql)
    for item in cr.dictfetchall():
        res[item.get('id')] = item.get('codigo_fabricante')
    return res

def _get_expvei_produto(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for item in self.browse(cr, uid, ids, context):
        res[item.id] = {'expvei_produto_id': item.expvei_grade_id.produto_id.id,
                        'expvei_codigo_produto': item.expvei_grade_id.produto_id.codigo,}
    return res

def _get_vendedor_id(self, cr, uid, ids, field, args, context=None):
    context = context and context.copy() or {}
    # Ocorre erro quando a base eh levantada com all pela primeira vez e o modulo 'expedicao_ecf' nao esta instalado,
    # nao acha id da nota entao verificar o do cupom, mas a coluna expvec_cupom_id nao existe sem o modulo
    # 'expedicao_ecf' instalado entao da erro no terminal
    # Todo: Tirar a verificacao de modulo instalado, verificar como fazer isso para este metodo.
    ecf_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'expedicao_ecf', context)
    res = {}
    for id in ids:
        venda = self.browse(cr, uid, id, context=context)
        if venda.expetc_vendas_capa_id.expvec_nf_id.id:
            vendedor_id = venda.expetc_vendas_capa_id.expvec_nf_id.vendedor_id.id
        elif ecf_instalado:
            vendedor_id = venda.expetc_vendas_capa_id.expvec_cupom_id.ecc_vendedor_id.id
        else:
            vendedor_id = False
        res[id] = vendedor_id
    return res

def _expetc_permissao_cancelar(self, cr, uid, ids, field, args, context=None):
    """
    Este metodo tem o objetivo de alterar o atributo expetc_permissao_cancelar para
    True quando o usuario for do grupo group_expedicao_manager, se nao sera setado para False
    :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
    """
    context = context and context.copy() or {}
    obj_ir_model_acess = self.pool.get('ir.model.access')
    res = {}
    tem_permissao = obj_ir_model_acess.check_groups(cr, uid, 'expedicao.group_expedicao_manager')
    for entrega_capa_id in ids:
        view_por_estado = ''
        if context.get('expedicao_entrega'):
            view_por_estado = 'S'
        elif context.get('expedicao_separacao'):
            view_por_estado = 'P'
        res[entrega_capa_id] = {'expetc_permissao_cancelar': tem_permissao,
                                'expetc_view_por_estado': view_por_estado}
    return res

