# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import expvei_get_status, _get_data_proxima_entrega, expvei_function_search_status

STATUS = [('A', 'A entregar'),
          ('P', 'Entregue parcialmente'),
          ('E', 'Entregue')]

class expedicao_vendas_capa(osv.Model):
    """
    Tabela que contem as vendas realizadas(nfs e cupons) para controlar a entrega
    """
    _name = 'expedicao.vendas.capa'
    _rec_name = 'expvec_documento'
    _columns = {
        'company_id': fields.many2one('res.company', 'Empresa', ondelete='restrict', select=True),
        'expvec_documento': fields.char('Documento', size=20, required=True),
        'expvec_data': fields.datetime('Data'),
        'expvec_pessoa_id': fields.many2one("adm.pessoa", 'Cliente', ondelete="restrict", select=True),
        'expvec_nf_id': fields.many2one("fiscal.nf.capa", 'Nota fiscal', ondelete="cascade", select=True),
        'expvec_vendas_itens_ids': fields.one2many('expedicao.vendas.itens', 'expvei_capa_id', 'Itens'),
        'expvec_entregas_capa_ids': fields.one2many('expedicao.entregas.capa', 'expetc_vendas_capa_id', 'Entregas'),
        'status': fields.function(expvei_get_status, string="Status", selection=STATUS,
                                  type='selection', method=True, store=False,
                                  fnct_search=expvei_function_search_status),
        'expvec_data_proxima_entrega': fields.function(_get_data_proxima_entrega, method=True,
                                                       string='Data da proxima entrega', type='date', store=False),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, s._name, context=c)
    }


