# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import _get_expvei_codigo_barra, _get_expvei_codigo_fabricante, _get_expvei_produto



class expedicao_vendas_itens(osv.Model): 
    """
    Tabela que contem os itens que foram vendidos (por nf e cupom) para controlar as entregas
    """
    _name = 'expedicao.vendas.itens'
    _columns = {
        'expvei_capa_id': fields.many2one("expedicao.vendas.capa", 'Capa', ondelete="cascade",
                                          required=True, select=True),
        'expvei_produto_id': fields.function(_get_expvei_produto, method=True, string='Produto',
                                               type='integer', store=False, multi='dados_produto'),
        'expvei_codigo_produto': fields.function(_get_expvei_produto, method=True, string='Codigo',
                                               type='char', store=False, multi='dados_produto'),
        'expvei_grade_id': fields.many2one("estoque.produto.grade", 'Item', ondelete="restrict",
                                           required=True, select=True,
                                           domain="[('produto_id', '=', expvei_produto_id)]"),
        'expvei_codigo_barra': fields.function(_get_expvei_codigo_barra, method=True, string='Codigo de barras',
                                               type='char', store=False),
        'expvei_codigo_fabricante': fields.function(_get_expvei_codigo_fabricante, method=True,
                                                    string='Codigo no fabricante', type='char', store=False),
        'expvei_embalagem_id': fields.many2one("estoque.produto.embalagem", 'Embalagem', ondelete="restrict",
                                            domain="[('produto_id', '=', expvei_produto_id)]",
                                            required=True, select=True), # id da embalagem pedida
        'expvei_quantidade_vendida': fields.float('Quantidade vendida', digits=(8,3), required=True),
        'expvei_quantidade_entregue': fields.float('Quantidade entregue', digits=(8,3)),
        'status': fields.selection([('A', 'A entregar'),
                                    ('P', 'Entregue parcialmente'),
                                    ('E', 'Entregue')],
                                   'Estado', size=1, required=True),
        'entregas_itens_ids': fields.one2many('expedicao.entregas.itens', 'expeti_vendas_itens_id', 'Itens'),
        'expvei_data': fields.date('Data agendada'),
    }
    _defaults = {
        'status': lambda *a: 'A',
    }

