# -*- encoding: utf-8 -*-

from openerp.report import report_sxw
from openerp import pooler
from dateutil.parser import parse
import random
import string
import subprocess
from datetime import datetime


def random_name():
    random.seed()
    d = [random.choice(string.ascii_letters) for x in xrange(6)]
    name = "".join(d)
    return name


class rel_entrega(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context):
        super(rel_entrega, self).__init__(cr, uid, name, context)

        dados_parametro = pooler.get_pool(cr.dbname).get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque',
            ['estpar_impressora_pedido', 'estpar_pedido_matricial', 'estpar_pedido_tipo_codigo',
             'estpar_pedido_formato_impressao', 'estpar_comando_guilhotina',
             'estpar_impressora_expedicao'])
        tipo_codigo = dados_parametro.get('estpar_pedido_tipo_codigo')

        def converte_datetime(data, formato):
            try:
                if not isinstance(data, datetime):
                    data = parse(data)
                data = pooler.get_pool(cr.dbname).get(
                    'adm.utils').admutl_datetime_to_timezone(cr, uid, data, formato)
            except:
                data = ''
            return data

        def get_vendedor(brw_vendas_capa):
            vendedor = ''
            if brw_vendas_capa.expvec_nf_id and brw_vendas_capa.expvec_nf_id.vendedor_id:
                vendedor = brw_vendas_capa.expvec_nf_id.vendedor_id.pessoa_id.nome
            elif brw_vendas_capa.expvec_cupom_id and brw_vendas_capa.expvec_cupom_id.\
                    ecc_vendedor_id:
                vendedor = brw_vendas_capa.expvec_cupom_id.ecc_vendedor_id.pessoa_id.nome
            return vendedor

        self.localcontext.update({
            'tipo_codigo': tipo_codigo,
            'converte_datetime': converte_datetime,
            'get_vendedor': get_vendedor,
            'datetime': datetime
        })
        self.context = context

        impressora_expedicao = dados_parametro.get('estpar_impressora_expedicao')
        # Contexto incluido no metodo 'expetc_button_print'. E testado aqui para que nao ocorra a
        # situacao de gerar a opcao de download do arquivo e impressao direta dele na impressora.
        if impressora_expedicao and not context.get('expetc_nao_enviar_impressora'):
            self.imprimi_expedicao_entrega(cr, uid, impressora_expedicao, context)

    def imprimi_expedicao_entrega(self, cr, uid, impressora_expedicao, context=None):
        """
        O metodo manda para a impressora definida em 'impressora_expedicao' o arquivo pdf gerado a
        partir da entrega da expedicao
        :param cr: cursor no banco de dados
        :param uid: id da tabela res_users, identificador do usuario
        :param impressora_expedicao: char com a descricao do nome da impressora
        :param context: dicionario com valores contextuais
        :return: booleano True
        """
        context = context and context.copy() or {}
        documento = 'report.' + random_name()
        obj_ir_act_report_xml = pooler.get_pool(cr.dbname).get('ir.actions.report.xml')
        report_id = obj_ir_act_report_xml.search(
            cr, uid, [('report_name', '=', 'expedicao.entregas.capa')], context=context)
        report_xml = obj_ir_act_report_xml.browse(cr, uid, report_id[0])
        report_pdf = False
        if not context.get('impressao_expedicao_entrega'):
            context.update({'impressao_expedicao_entrega': True})
            report_pdf = report_sxw.report_sxw(
                documento, 'expedicao.entregas.capa',
                'addons/expedicao/report/entrega.rml', parser=rel_entrega,).create_single_pdf(
                cr, uid, context.get('active_ids'), {'report_type': 'pdf'}, report_xml,
                context)
        if report_pdf and impressora_expedicao:
            nome_arquivo = 'CE-%s.pdf' % context.get('active_id')
            p = open('/tmp/%s' % nome_arquivo, 'wb')
            p.write(report_pdf[0])
            p.close()
            impressora = "-d" + impressora_expedicao
            subprocess.call(["lp", "-n1", impressora, "/tmp/%s" % nome_arquivo])
            subprocess.call(['rm', "/tmp/%s" % nome_arquivo])
        return True

report_sxw.report_sxw('report.expedicao.entregas', 'expedicao.entregas.capa',
                      'addons/expedicao/report/entrega.rml', parser=rel_entrega,
                      header=False)
