# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _
from dateutil.parser import parse


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):

    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}

        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        title = center_title('', _('Demonstrativo de Entregas'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()

        dados_parametro = pooler.get_pool(cr.dbname).get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', ['estpar_expedicao_retrato_paisagem'])
        modo = dados_parametro.get('estpar_expedicao_retrato_paisagem')
        orientacao = '0'
        if modo == 'P':
            orientacao = '1'

        listagem.defineFormato(orientacao=orientacao)
        listagem.informaNome(pdf_string, _('demonstrativo_de_entregas'))
        listagem.informaTamLinha(160)
        listagem.defineFonte(tam=6.3)

        venda_ids = list(set(datas.get('venda_ids')))
        totais = datas.get('totais')

        brw_expedicao_vendas_capa = pooler.get_pool(cr.dbname).get('expedicao.vendas.capa').browse(
            cr, uid, venda_ids, context)
        datetime_to_timezone = pooler.get_pool(cr.dbname).get(
            'adm.utils').admutl_datetime_to_timezone
        data_inicial = datas.get('data_inicial')
        if data_inicial:
            data_inicial = datetime_to_timezone(cr, uid, parse(data_inicial), '%d/%m/%Y')
        data_final = datas.get('data_final')
        if data_final:
            data_final = datetime_to_timezone(cr, uid, parse(data_final), '%d/%m/%Y')

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id,
                                                                               ['name'])
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
        filtro1 = formataString('Cliente: %s' % datas.get('cliente'), 100, ' ', 'D', 'N', 'S')
        filtro1 += formataString('Venda: %s' % datas.get('venda'), 50, ' ', 'D', 'N', 'S')
        filtro2 = formataString('Data inicial: %s' % data_inicial, 100, ' ', 'D', 'N', 'S')
        filtro2 += formataString('Data final: %s' % data_final, 50, ' ', 'D', 'N', 'S')

        listagem.informaCab(''+title)
        listagem.informaCab('')
        listagem.informaCab(''+docs)
        listagem.informaCab('')
        listagem.informaCab(filtro1)
        listagem.informaCab(filtro2)
        listagem.informaCab('*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(_('| DOCUMENTO       |        DATA        | CLIENTE                                                                        |          TOTAL NA NF/CUPOM |'))
        listagem.informaCab(_('| PRODUTO            | GRADE                                                           |           QUANTIDADE VENDIDA |   QUANTIDADE ENTR./NAO ENTR. |'))
        listagem.informaCab('*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.rodapePadrao()

        for venda in brw_expedicao_vendas_capa:
            if brw_expedicao_vendas_capa.index(venda) != 0:
                listagem.imprimeLinha('*' + '-' * 148 + '*')

            linha = ' '
            linha += formataString(venda.expvec_documento or '', 16, ' ', 'D', 'N', 'S')+'|'
            linha += ' '
            linha += formataString(datetime_to_timezone(
                cr, uid, parse(venda.expvec_data), '%d/%m/%Y %H:%M:%S'), 19, ' ', 'D', 'N', 'S')+'|'
            linha += ' '
            linha += formataString(venda.expvec_pessoa_id.nome, 79, ' ', 'D', 'N', 'S')+'|'
            linha += ' '
            linha += formataString(getNumeroEditado(totais.get(str(venda.id)), 2), 27, ' ', 'E',
                                   'N', 'S')+'|'
            linha += ' '
            listagem.imprimeLinha('|'+linha)

            for item in venda.expvec_vendas_itens_ids:
                linha = ' '
                linha += formataString(item.expvei_grade_id.produto_id.codigo or '', 19, ' ', 'D',
                                       'N', 'S')+'|'
                linha += ' '
                linha += formataString(item.expvei_grade_id.name or '', 64, ' ', 'D', 'N', 'S')+'|'
                linha += ' '
                linha += formataString(getNumeroEditado(item.expvei_quantidade_vendida, 2), 29, ' ',
                                       'E', 'N', 'S')+'|'
                linha += ' '
                linha += formataString(getNumeroEditado(item.expvei_quantidade_entregue, 2), 29,
                                       ' ', 'E', 'N', 'S')+'|'
                linha += ' '
                listagem.imprimeLinha('|'+linha)
            if not venda.expvec_entregas_capa_ids:
                continue

            entrega_capa_ids = filter(lambda ent: ent.state == 'E',
                                      venda.expvec_entregas_capa_ids)
            if entrega_capa_ids:
                listagem.imprimeLinha('|' + ' ' * 148 + '|')
                listagem.imprimeLinha('| *** ENTREGAS ***' + 131 * ' ' + '|')
                listagem.imprimeLinha('|' + ' ' * 148 + '|')
            for entrega in entrega_capa_ids:
                linha = formataString('DATA: %s' % datetime_to_timezone(
                    cr, uid, parse(entrega.expetc_data_entrega), '%d/%m/%Y %H:%M:%S'), 35, ' ', 'D',
                    'N', 'S')
                linha += formataString('QUEM RECEBEU: %s' % entrega.expetc_quem_recebeu,
                                       55, ' ', 'D', 'N', 'S')
                linha += formataString('QUEM ENTREGOU: %s' % entrega.expetc_quem_entregou_id.nome,
                                       57, ' ', 'D', 'N', 'S') + '|'
                listagem.imprimeLinha('| ' + linha)
                for entrega_item in entrega.entregas_itens_ids:
                    linha = ' '
                    linha += formataString(entrega_item.expeti_vendas_itens_id.expvei_grade_id.produto_id.codigo or '', 19, ' ', 'D',
                                           'N', 'S')+'|'
                    linha += ' '
                    linha += formataString(entrega_item.expeti_vendas_itens_id.expvei_grade_id.name or '', 64, ' ', 'D', 'N', 'S')+'|'
                    linha += ' '
                    linha += formataString('', 29, ' ', 'E', 'N', 'S')+'|'
                    linha += ' '
                    linha += formataString(getNumeroEditado(entrega_item.expeti_quantidade, 2), 29,
                                           ' ', 'E', 'N', 'S')+'|'
                    linha += ' '
                    listagem.imprimeLinha('|'+linha)
                listagem.imprimeLinha('|' + ' ' * 148 + '|')
            item_nao_entregue = filter(lambda i: i.status != 'E', venda.expvec_vendas_itens_ids)
            if not item_nao_entregue:
                continue
            listagem.imprimeLinha('| *** NAO ENTREGUES ***' + 126 * ' ' + '|')
            listagem.imprimeLinha('|' + ' ' * 148 + '|')
            for item in item_nao_entregue:
                linha = ' '
                linha += formataString(item.expvei_grade_id.produto_id.codigo or '', 19, ' ', 'D',
                                       'N', 'S')+'|'
                linha += ' '
                linha += formataString(item.expvei_grade_id.name or '', 64, ' ', 'D', 'N', 'S')+'|'
                linha += ' '
                linha += formataString('', 29, ' ', 'E', 'N', 'S')+'|'
                linha += ' '
                linha += formataString(getNumeroEditado(item.expvei_quantidade_vendida -
                                                        item.expvei_quantidade_entregue, 2), 29,
                                       ' ', 'E', 'N', 'S')+'|'
                linha += ' '
                listagem.imprimeLinha('|'+linha)
        listagem.imprimeLinha('*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.imprimeLinha('                                                                                                                   ** Sig Informatica LTDA **       ')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

report_custom('report.listagem_demonstrativo_entrega')
