#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from datetime import datetime


class wizard_cancelamento_entrega(osv.TransientModel):
    _name = 'wizard.cancelamento.entrega'
    _columns = {
        'wizcae_motivo_cancelamento': fields.text(string='Motivo do cancelamento', required=True)
    }

    def wizcae_button_cancelar_entrega(self, cr, uid, ids, context=None):
        """
        Este metodo tem a funcionalidade de chamar preparar os dados
        e chamar os metodos

        :param cr: a Vinha atual do cursor do banco de dados
        :param uid: ID do usuario utilizado para a verificacao de perfil
        :param ids: lista com o ID dos itens vendidos
        :param context: um dicionario padrao para valores contextuais
        :type cr: cursor
        :type uid: int
        :type ids:list
        :type context: dict
        :rtype: bool

        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        context = context and context.copy() or {}
        capa_id = context.get('expedicao_entrega_id')
        if not capa_id:
            return False

        obj_exp_entrega_capa = self.pool.get('expedicao.entregas.capa')
        obj_exp_entrega_itens = self.pool.get('expedicao.entregas.itens')
        obj_exp_venda_itens = self.pool.get('expedicao.vendas.itens')
        dados_capa = obj_exp_entrega_capa.read(cr, uid, capa_id[0], ['entregas_itens_ids', 'state'],
                                               context)
        fields_to_read = ['expeti_vendas_itens_id', 'expeti_quantidade']
        exp_ent_itens_dados = obj_exp_entrega_itens.read(cr, uid,
                                                         dados_capa.get('entregas_itens_ids'),
                                                         fields_to_read, context,
                                                         load='_classic_write')
        for itens in exp_ent_itens_dados:
            # se a entrega nao foi realizada, nao alterou a quantidade entregue da venda, entao nao
            # precisa deduzir a quantidade da entrega
            if dados_capa.get('state') != 'E':
                break

            item_id = [itens.get('expeti_vendas_itens_id')]
            qtd = itens.get('expeti_quantidade')
            obj_exp_venda_itens.expvei_deduzir_quantidade_entregue(cr, uid, item_id, qtd, context)

        motivo = False
        for i in self.browse(cr, uid, ids, context):
            motivo = i.wizcae_motivo_cancelamento
        obj_exp_entrega_capa.expetc_cancelar_entregas(cr, uid, capa_id, motivo, context)