#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class expedicao_entregas_capa(osv.Model):
    _name = 'expedicao.entregas.capa'
    _inherit = 'expedicao.entregas.capa'

    def get_informacoes_complementares(self, cr, uid, ids, field, args, context=None):
        """
        Se a entrega for referente a um cupom fiscal, verifica se existe algum pedido para o
        mesmo (caixa, loja, coo) que o cupom referenciado em expedicao.vendas.capa e armazena no
        atributo expetc_informacoes_complementaresa a observacao gravada no pedido.

        Caso a entrega nao seja referente a cupom, realiza um super no
        get_informacoes_complementares da classe mae e aramazena no atributo
        expetc_informacoes_complementares a informacao complementar informada na nota fiscal

        :rtype: dict
        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        context = context and context.copy() or {}
        res = {}
        for entrega in self.browse(cr, uid, ids, context=context):
            if entrega.expetc_vendas_capa_id.expvec_cupom_id:
                obj_estoque_ped = self.pool.get('estoquepedidos.pedido.capa')
                coo = entrega.expetc_vendas_capa_id.expvec_cupom_id.coo
                caixa = entrega.expetc_vendas_capa_id.expvec_cupom_id.ecf_id.caixa
                loja = entrega.expetc_vendas_capa_id.expvec_cupom_id.ecf_id.loja
                args = [('coo', '=', coo), ('caixa', '=', caixa), ('loja', '=', loja)]
                pedido_ids = obj_estoque_ped.search(cr, uid, args, context=context)
                if pedido_ids:
                    dados_pedido = obj_estoque_ped.read(cr, uid, pedido_ids, ['observacao'],
                                                        context=context)
                    for dado in dados_pedido:
                        res[entrega.id] = dado.get('observacao') or ''
            else:
                res = super(expedicao_entregas_capa, self). \
                    get_informacoes_complementares(cr, uid, ids, field, args, context=context)
        return res

    _columns = {
        'expetc_informacoes_complementares': fields.function(get_informacoes_complementares,
                                                             string='Informacoes complementares',
                                                             method=True, type='text', store=True),
    }
