# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv


class wiz_expedicao_demonstrativo_entrega(osv.TransientModel):
    # prefixo: wizede_
    _inherit = 'wiz.expedicao.demonstrativo.entrega'

    def wizede_get_total_documento(self, cr, uid, venda_ids, context=None):
        """
        O metodo busca o valor do cupom fiscal de cada uma das vendas identificadas em 'venda_ids'
        :param cr: cursor no banco de dados
        :param uid: id da tabela res_users, identificador do usuario
        :param venda_ids: lista de id da tabela 'expedicao_vendas_capa'
        :param context: dicionario com valores contextuais
        :return: dicionario. Cada chave representa um id da tabela 'expedicao_vendas_capa' e seu
        valor representa o total do cupom fiscal
        """
        context = context and context.copy() or {}
        if not venda_ids:
            return {}
        res = super(wiz_expedicao_demonstrativo_entrega, self).wizede_get_total_documento(
            cr, uid, venda_ids, context)
        brw_expedicao_venda_capa = self.pool.get('expedicao.vendas.capa').browse(cr, uid, venda_ids,
                                                                                 context)
        for venda in brw_expedicao_venda_capa:
            if venda.expvec_cupom_id:
                res[venda.id] = venda.expvec_cupom_id.total_cupom or 0.0
        return res
