# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from datetime import datetime
from dateutil.relativedelta import relativedelta


class fidelidade_movimento(osv.Model):
    """
    Tabela de movimento do controle de fidelidade

    prefixo: fidmov_
    """
    _inherit = 'fidelidade.movimento'

    def fidmov_get_dados_documento(self, cr, uid, movimento_id, context=None):
        """
        O metodo encontra os dados referente ao documento que gerou o movimento.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param movimento_id: id da tabela desse objeto.
        :type movimento_id: int
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: dicionario com os dados do documento.
        :rtype: dict
        """
        context = context and context.copy() or {}
        campos = {'movimento_id': ['numero_documento']}
        movimento = self.pool.get('adm.utils').admutl_read_browse(cr, uid, movimento_id, self._name,
                                                                  campos, context=context) or {}
        if movimento and isinstance(movimento, list):
            movimento = movimento[0]
        documento = ''
        if movimento.get('movimento_id'):
            documento = movimento.get('movimento_id').get('numero_documento')
        return {'documento': documento,
                'serie': '000',
                'caixa': '000'}

    def cron_fidmov_limpar_pontuacao(self, cr, uid, meses, context=None):
        context = context and context.copy() or {}
        if meses == 0:
            return True

        data = datetime.now() - relativedelta(months=meses)
        ids = self.search(cr, uid, [('data', '<', str(data))], context=context)
        if not ids:
            return True

        self.unlink(cr, uid, ids, context=context)
        return True