# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class fidelidade_produtos(osv.Model):
    """
    Tabela de pontos extra por produto
    """

    _inherit = 'fidelidade.produtos'

    def onchange_fidprod_produto_id(self, cr, uid, ids, produto_id, context=None):
        context = context and context.copy() or {}
        res = {'value': {'grade_id': ''}}
        if not produto_id:
            return res
        dados_produto = self.pool.get('estoque.produto').read(cr, uid, produto_id,
                                       ['produto_grade_ids'], context=context, load='_classic_write')

        if len(dados_produto.get('produto_grade_ids')) == 1:
            res['value']['grade_id'] = dados_produto.get('produto_grade_ids')[0]

        return res

    def get_pontos_extras(self, cr, uid, estmvi_ids, data_movimento, context=None):
        context = context and context.copy() or {}
        pontos = 0
        dados_estmvi = self.pool.get('estoque.movimento.itens').read(cr, uid, estmvi_ids,
                                 ['grade_id', 'quantidade'], context=context, load='_classic_write')
        grade_ids = map(lambda x: x.get('grade_id'), dados_estmvi)
        if not grade_ids:
            return pontos

        fidelidade_grade_ids = self.search(cr, uid, [('grade_id', 'in', grade_ids),
                                                     ('data_inicio', '<=', data_movimento),
                                                     ('data_termino', '>=', data_movimento)],
                                           context=context)
        if not fidelidade_grade_ids:
            return pontos

        grade_id_qtd = {}
        for fidelidade in self.read(cr, uid, fidelidade_grade_ids, ['grade_id', 'pontuacao'],
                                    context=context, load='_classic_write'):
            grade_id_qtd[fidelidade.get('grade_id')] = fidelidade.get('pontuacao')

        for emi in dados_estmvi:
            if not grade_id_qtd.get(emi.get('grade_id')):
                continue

            pontos += int(grade_id_qtd.get(emi.get('grade_id')) * emi.get('quantidade'))

        return pontos