# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class fidelidade_parametros(osv.Model):
    """
    Tabela de parametros do controle de fidelidade
    """
    _name = 'fidelidade.parametros'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'valor_pontos': fields.float('Valor pontos', digits=(5, 2)), # Valor de um ponto para conversao
    }
    _defaults = {
        'valor_pontos': lambda *a: 1.00,
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }

    _sql_constraints = [
        ('company_id_uniq', 'unique (company_id)', 'Permitido apenas um parametro por empresa'),
    ]



