# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class fidelidade_produtos(osv.Model):
    """
    Tabela de pontos extra por produto
    """
    _name = 'fidelidade.produtos'
    _columns = {
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="cascade", required=True, select=True),
        'grade_id': fields.many2one("estoque.produto.grade", 'Grade', ondelete="cascade", required=True, select=True,
                                    domain="[('produto_id', '=', produto_id)]"), # id da grade / produto
        'data_inicio': fields.date('Data inicio', required=True, select=True), # data de inicio da pontuacao extra\n
        'data_termino': fields.date('Data termino', required=True, select=True), # Data de Termino da pontuacao extra\n
        'pontuacao': fields.integer('Pontuacao', help='Quantidade de pontos extra pelo produto', required=True),
        'descricao': fields.char('Descricao', size=64),
    }


