# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _
from dateutil.parser import parse


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):

    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}

        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        title = center_title('', _('Extrato de Fidelidade'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()

        datetime_to_timezone = pooler.get_pool(cr.dbname).get(
            'adm.utils').admutl_datetime_to_timezone

        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('fidelidade_extrato'))
        listagem.informaTamLinha(160)

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id,
                                                                               ['name'])
        nome_empresa = res_company_dados.get('name')
        docs = center_title(datas.get('data_impressao') or '', nome_empresa, _('Pagina: {{ Page }} '))
        docs1 = formataString('Periodo: %s a %s' % (datas.get('data_inicial') or '',
                                                    datas.get('data_final') or ''), 50, ' ', 'D', 'N',
                              'S')

        listagem.informaCab(''+title)
        listagem.informaCab('')
        listagem.informaCab(''+docs)
        listagem.informaCab('')
        listagem.informaCab(docs1)
        listagem.informaCab('*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(_('|DATA           |DOCUMENTO                     |SERIE     |CAIXA     |        PONTOS|DESCRICAO                                                       |'))
        listagem.informaCab('*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab('  ')
        listagem.rodapePadrao()

        list_codigo = list()
        total_cliente = 0
        total_geral = 0

        dados_movimento = sorted(datas.get('dados_movimento'), key=lambda i: i.get('codigo'))
        for extrato in dados_movimento:
            if extrato.get('codigo') not in list_codigo:
                if dados_movimento.index(extrato) != 0:
                    linha = '|'
                    linha += formataString('Total do Cliente', 68, ' ', 'D', 'N', 'S')
                    linha += '|'
                    linha += formataString(total_cliente, 14, ' ', 'E', 'N', 'S')
                    linha += '|'
                    linha += ' ' * 64 + '|'
                    listagem.imprimeLinha(linha)
                    total_cliente = 0

                list_codigo.append(extrato.get('codigo'))
                listagem.imprimeLinha(' ' * 150)
                listagem.imprimeLinha(' %s    %s' % (extrato.get('codigo'), extrato.get('nome')))
                listagem.imprimeLinha(' ' * 150)

            total_cliente += extrato.get('pontos') or 0
            total_geral += extrato.get('pontos') or 0

            linha = '|'
            linha += formataString(datetime_to_timezone(cr, uid, parse(extrato.get('data')),
                                                        '%d/%m/%Y'), 15, ' ', 'D', 'N', 'S')+'|'
            linha += formataString(extrato.get('documento'), 30, ' ', 'D', 'N', 'S')+'|'
            linha += formataString(extrato.get('serie') or '', 10, ' ', 'D', 'N', 'S')+'|'
            linha += formataString(extrato.get('caixa') or '', 10, ' ', 'D', 'N', 'S')+'|'
            linha += formataString(extrato.get('pontos'), 14, ' ', 'E', 'N', 'S')+'|'
            linha += formataString(extrato.get('descricao') or '', 64, ' ', 'D', 'N', 'S')+'|'
            listagem.imprimeLinha(linha)

            if dados_movimento.index(extrato) == len(dados_movimento) - 1:
                linha = '|'
                linha += formataString('Total do Cliente', 68, ' ', 'D', 'N', 'S')
                linha += '|'
                linha += formataString(total_cliente, 14, ' ', 'E', 'N', 'S')
                linha += '|'
                linha += ' ' * 64 + '|'
                listagem.imprimeLinha(linha)
                total_cliente = 0

        listagem.imprimeLinha('')
        listagem.imprimeLinha('*' + '-' * 148 + '*')
        linha = formataString(' TOTAL GERAL', 68, ' ', 'D', 'N', 'S')
        linha += formataString(total_geral, 16, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)

        listagem.imprimeLinha('*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.imprimeLinha('                                                                                                                   ** Sig Informatica LTDA **         ')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

report_custom('report.fidelidade_extrato')
