# -*- coding: utf-8 -*-

from openerp.osv import osv, fields


class ecf_exportar_osv(osv.TransientModel):
    """
    Wizard de exportacao para ECF.
    """
    _inherit = "ecf.exportar.osv"
    _columns = {
        'cliente_tipo_codigo': fields.selection([('I', 'Interno'), ('F', 'Fidelidade')],
                                                'Codigo cliente', size=1),
    }
    _defaults = {
        'cliente_tipo_codigo': lambda *a: 'I',
    }

    def get_dados_cliente_arquivo(self, cr, uid, cliente_ids, dados_capa, context=None):
        context = context and context.copy() or {}
        res = list()
        if not cliente_ids:
            return res
        if len(cliente_ids) == 1:
            cliente_ids = str(tuple(cliente_ids)).replace(',', '')
        else:
            cliente_ids = str(tuple(cliente_ids))
        codigo = 'ap.codigo AS codigo'
        if dados_capa.get('cliente_tipo_codigo') == 'F':
            codigo = 'fc.codigo_fidelidade AS codigo'
        sql = """
            SELECT
                fc.id AS id,fc.pessoa_id, ap.cpf_cnpj, ap.nome, fc.limite_credito, %s,
                ap.admpes_jur_ie
            FROM financeiro_cliente fc
            INNER JOIN adm_pessoa ap
                ON fc.pessoa_id = ap.id
            WHERE fc.id in %s
        """ % (codigo, cliente_ids)
        cr.execute(sql)
        res = cr.dictfetchall()
        return res

    def get_dados_cliente_postgres(self, cr, uid, cliente_ids, dados_capa, context=None):
        context = context and context.copy() or {}
        res = list()
        if not cliente_ids:
            return res
        if len(cliente_ids) == 1:
            cliente_ids = str(tuple(cliente_ids)).replace(',', '')
        else:
            cliente_ids = str(tuple(cliente_ids))
        codigo = 'ap.codigo AS codigo_interno'
        if dados_capa.get('cliente_tipo_codigo') == 'F':
            codigo = 'fc.codigo_fidelidade AS codigo_interno'
        sql = """
            SELECT ap.id               AS pessoa_id,
                   ap.cpf_cnpj,
                   ap.nome,
                   %s,
                   ap.admpes_jur_ie,
                   ap.pessoa_tipo,
                   ap.email,
                   ap.endereco,
                   Min(ape.numero)     AS numero,
                   ap.bairro,
                   ap.cidade,
                   ap.codigo_ibge,
                   ap.uf,
                   ap.cep,
                   fc.id               AS cliente_id,
                   fc.limite_credito,
                   fc.fincli_rota,
                   Min(apt.numero)     AS telefone,
                   Sum(ft.saldo)       AS total_em_aberto,
                   fc.active
            FROM   adm_pessoa             AS ap
            INNER JOIN financeiro_cliente AS fc  ON fc.pessoa_id = ap.id
            LEFT JOIN adm_pessoa_endereco AS ape ON ape.pessoa_id = ap.id
            LEFT JOIN adm_cidade          AS ac  ON ac.id = ape.cidade_id
            LEFT JOIN adm_pessoa_telefone AS apt ON apt.pessoa_id = ap.id
            LEFT JOIN financeiro_titulo   AS ft  ON ft.pessoa_id = ap.id
            WHERE  fc.id IN %s
            GROUP  BY ap.id,
                      fc.id,
                      ft.pessoa_id
        """ % (codigo, cliente_ids)
        cr.execute(sql)
        res = cr.dictfetchall()
        return res
