# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv


class fidelidade_movimento(osv.Model):
    """
    Tabela de movimento do controle de fidelidade

    prefixo: fidmov_
    """
    _inherit = 'fidelidade.movimento'

    def fidmov_get_dados_documento(self, cr, uid, movimento_id, context=None):
        """
        O metodo encontra os dados referente a nota fiscal que gerou o movimento.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param movimento_id: id da tabela desse objeto.
        :type movimento_id: int
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: dicionario com os dados dos documento.
        :rtype: dict
        """
        context = context and context.copy() or {}
        res = super(fidelidade_movimento, self).fidmov_get_dados_documento(cr, uid, movimento_id,
                                                                           context)
        brw_fidelidade_movimento = self.browse(cr, uid, movimento_id, context)
        if not brw_fidelidade_movimento.movimento_id.nf_capa_id:
            return res

        res['documento'] = str(brw_fidelidade_movimento.movimento_id.nf_capa_id.numero_nf)
        res['serie'] = brw_fidelidade_movimento.movimento_id.nf_capa_id.serie_nf.zfill(3)
        return res
