# -*- encoding: utf-8 -*-


import time

from openerp.osv import fields
from openerp.osv import osv
from openerp.tools.sql import drop_view_if_exists




class report_listagem_clientes(osv.Model):
    _name = "report.listagem.clientes"
    _description = "Relatorio de Clientes Contas a Receber"
    _auto = False
    _columns = {
        'name': fields.char('Nome', size=50),
        'pessoa_id': fields.many2one("adm.pessoa", 'Pessoa', ondelete="cascade", select=True), # id da pessoa
        'cliente_id': fields.many2one("financeiro.cliente", 'Cliente', ondelete="cascade", select=True), # id do cliente
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True), # id da empresa onde e cliente
        'data_inclusao': fields.date('Data inclusao', required=True), # Data de inclusao do cliente
        'limite_credito': fields.float('Limite credito'), # Limite de credito do cliente
        'forma_pgto': fields.char('Formas pagamento', size=20), # Fromas de pagamento normalm
        'condicoes_forma': fields.char('Condicoes pagamento', size=20), # Condicoes de pagamento normalm
        'cpf_cnpj': fields.char('CPF/CNPJ', size=19, select=True), # Numero do Cpf ou CNPJ da pessoa
        'codigo': fields.integer('Codigo'), # codigo para identificacao da pessoa
        'fantasia_apelido':  fields.char('Nome', size=50),
        'cidade': fields.char('Cidade', size=50),
        'data_nascimento': fields.date('Data de nascimento'),  # Data de nascimento
        'ultima_compra_data': fields.date('Data da ultima compra'),
    }


    def init(self, cr):
        drop_view_if_exists(cr, "report_listagem_clientes")
        cr.execute(""" create or replace view report_listagem_clientes  as (
                  select
                        a.company_id as company_id,
                        a.pessoa_id as pessoa_id,
                        a.id as cliente_id,
                        a.data_inclusao as data_inclusao,
                        a.limite_credito as limite_credito,
                        a.fincli_forma_pgto_id as forma_pgto,
                        a.fincli_condicao_forma_id as condicoes_forma,
                        b.id as id,
                        b.cpf_cnpj as cpf_cnpj,
                        b.nome as name,
                        b.fantasia_apelido as fantasia_apelido,
                        b.codigo as codigo,
                        b.pessoa_tipo as pessoa_tipo,
                        b.cidade as cidade,
                        b.admpes_fis_data_nascimento as data_nascimento,
                        (SELECT max(data_emissao)
                         FROM financeiro_titulo
                         WHERE pessoa_id = a.pessoa_id AND tipo_titulo = 'R'
                               AND company_id = a.company_id) as ultima_compra_data


                    from
                        financeiro_cliente a
                    left join
                        adm_pessoa b on  b.id = a.pessoa_id  )""")






























































































































































































################################################################################

