# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv


class financeiro_local_cobranca(osv.Model):
    _inherit = 'financeiro.local.cobranca'

    def onchange_tipo_conta(self, cr, uid, ids, tipo):
        '''
         Quando for selecionado o tipo carteira mostra somente contas =Caixa,
         quando o tipo for banco somento contas do tipo banco.
        '''
        if tipo:
            if tipo == 'C':
                t_conta = 'C'
            elif tipo == 'B':
                t_conta = 'B'
            return {'domain': {'finloc_conta_id': [('banco_caixa', '=', t_conta)]}}

    def name_search(self, cr, uid, name='', args=[], operator='ilike', context=None, limit=100):
        context = context and context.copy() or {}
        ids = []
        try:
            name = int(name)
        except:
            pass
        if isinstance(name, int):
            ids = self.search(cr, uid, [('id', '=', name)] + args, limit=limit, context=context)
        if not ids:
            ids = self.search(cr, uid, [('descricao', operator, name)] + args, limit=limit, context=context)
        return self.name_get(cr, uid, ids)

    def finloc_get_locais_cobranca_por_banco(self, cr, uid, nroBancoBC, context=None):
        """
        Retorna lista de locais de cobranca de um banco especifico
        Args:
            cr:
            uid:
            nroBancoBC: Numero do banco no BC
            context:

        Returns: Lista de locais

        """
        res = []
        if nroBancoBC:
            sql = """
                select flc.id from financeiro_local_cobranca flc
                  left join adm_banco ab on ab.id = finloc_banco_id
                  where admbco_codigo_bc = %s
             """ % nroBancoBC
            cr.execute(sql)
            res = [x[0] for x in cr.fetchall()]
        return res


