# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp import tools


#----------------------------------------------------------
# Titulos vencidos com mais de 5 dias
#----------------------------------------------------------
class report_financeiro_titulos(osv.Model):
    _name = "report_financeiro.titulos"
    _inherit = "report_financeiro.titulos"

    def init(self, cr):
        tools.drop_view_if_exists(cr, 'report_financeiro_titulos')
        cr.execute("""
            create or replace view report_financeiro_titulos AS (
                SELECT
                  t.id,
                  t.tipo_titulo,
                  t.doc_tipo_id,
                  t.company_id,
                  t.documento,
                  t.parcela,
                  t.data_emissao,
                  t.data_prorrogacao,
                  t.vr_original,
                  t.pessoa_id,
                  t.repasse_pessoa_id,
                  CASE
                  WHEN t.tipo_titulo = 'P' THEN t.vr_original ELSE 0 END AS vr_pagar,
                  CASE
                  WHEN t.tipo_titulo = 'R' THEN t.vr_original ELSE 0 END AS vr_receber,
                  CASE
                  WHEN t.data_prorrogacao BETWEEN (CURRENT_DATE - INTERVAL '5 day') AND (CURRENT_DATE - INTERVAL '1 day') THEN 'VENCIDO'
                WHEN t.data_prorrogacao = CURRENT_DATE THEN 'HOJE'
                WHEN t.data_prorrogacao BETWEEN (CURRENT_DATE + INTERVAL '1 day') AND (CURRENT_DATE + INTERVAL '5 day') THEN 'VENCER'
                ELSE 'OUTROS'
                END AS state
                FROM
                financeiro_titulo t
                WHERE t.data_prorrogacao BETWEEN (CURRENT_DATE - INTERVAL '5 day') AND (CURRENT_DATE + INTERVAL '5 day')
                AND t.state = 'A'
                AND t.repasse_pessoa_id IS NULL)
        """)

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        if not args:
            args = []
        context = context and context.copy() or {}
        company = self.pool.get('res.users')._get_company(cr, uid)
        ids_empresa = self.pool.get('res.company')._get_company_children(cr, uid, company)
        args += [('company_id', 'in', ids_empresa)]
        res = super(report_financeiro_titulos, self).search(cr, uid, args, offset, limit, order, context, count)
        return res
