# -*- coding: utf-8 -*-
# #############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
# www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################
import StringIO
from reportlab.lib.utils import ImageReader

from PIL import Image
from openerp.osv import osv
from openerp.tools.translate import _
from openerp.report import report_sxw
from openerp.addons.adm import messagebox

import base64

READ_LOAD = '_classic_write'
from openerp.report.render import render
from SigUtils.boleto import boleto
from SigUtils.numero import getNumeroEditado
from datetime import datetime
import subprocess


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class financeiro_titulo(osv.Model):
    _name = 'financeiro.titulo'
    _inherit = 'financeiro.titulo'

    def _fintit_incluir_historico_gerencial(self, cr, uid, ids, context):
        if not isinstance(ids, list):
            ids = [ids]
        for brw_financeiro_titulo in self.browse(cr, uid, ids, context=context):
            if brw_financeiro_titulo.tipo_titulo == 'R':
                if context.get('contrato_gerar_titulos'):
                    _historico = context['contrato_gerar_titulos']
                else:
                    _historico = 'Titulo a receber'
            else:
                _historico = 'Titulo a pagar'
            vals = {'fingmo_historico': _historico}
            _gerencial_movimento_ids = []
            for brw_gerencial_movimento in brw_financeiro_titulo.fintit_gerencialmov_ids:
                _gerencial_movimento_ids.append(brw_gerencial_movimento.id)
            if _gerencial_movimento_ids:
                self.pool.get('gerencial.movimento').write(cr, uid, _gerencial_movimento_ids, vals,
                                                           context=context)
        return True

    def _fintit_verificar_custificacao(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_adm_utils = self.pool.get('adm.utils')
        parametro_financeiro = obj_adm_utils.admutl_get_parametros(
            cr, uid, 'financeiro', 'usar_centro_custos_e_eventos', context=context)
        _usar_centro_custos = parametro_financeiro.get('usar_centro_custos_e_eventos')
        if not _usar_centro_custos:
            return True
        if not isinstance(ids, list):
            ids = [ids]
        for brw_financeiro_titulo in self.browse(cr, uid, ids, context=context):
            _valor_movimento = brw_financeiro_titulo.vr_original or 0
            # _valor_movimento += brw_financeiro_titulo.fintit_encargos or 0
            _valor_custos = 0
            if brw_financeiro_titulo.state == 'C':
                return True
            for brw_gerencial_movimento in brw_financeiro_titulo.fintit_gerencialmov_ids:
                _valor_custos += brw_gerencial_movimento.valor
            # Qdo houver conta de destino e os custos forem zero, não tem erro.
            delta_valor = _valor_movimento - _valor_custos
            if delta_valor < -0.0001 or 0.0001 < delta_valor:
                raise osv.except_osv(_('Atencao'),
                                     _('Soma dos custos nao confere com o valor do titulo!\n%s') % str(ids))
        return True

    def _fintit_inserir_custos(self, cr, uid, ids, doc_tipo_id, valor, tipo_titulo,
                               operacao_id=None, context=None):
        """
        - Este método insere na tela a custificação conforme a classificação que está no parametro ou
        conforme a classificação está no tipo de documento.
        - Se já existir uma classificação, ele substitui
        - Este método só deve ser chamado por um métod onchange
        @param cr:
        @param uid:
        @param ids:
        @param doc_tipo_id: tipo de documento, id da classe  'documento.documento.tipo'
        @param valor: valor do titulo
        @param operacao_id: Campo que contem o id da operação da tesouraria, quando o titulo for  a pagar
        @param context:
        @return:
        """

        def __fintit_custifica_entrada_a_receber():
            _campos = ['finpar_centro_custo_entr_tit_rec_id', 'finpar_evento_entr_tit_rec_id']
            _campos_par = obj_adm_utils.admutl_get_parametros(cr, uid, 'financeiro',
                                                              _campos, context=context)
            if _campos_par:
                _par_cc_id = _campos_par.get('finpar_centro_custo_entr_tit_rec_id', False)
                _par_evento_id = _campos_par.get('finpar_evento_entr_tit_rec_id', False)
            else:
                _par_cc_id = _par_evento_id = False
            obj_documento_documento_tipo = self.pool.get('documento.documento.tipo')
            _campos = ['docdot_centro_custo_id', 'docdot_evento_id']
            dados_documento_documento_tipo = obj_documento_documento_tipo.read(cr, uid, doc_tipo_id,
                                                                               _campos,
                                                                               context=context)
            _doc_cc_id = dados_documento_documento_tipo.get('docdot_centro_custo_id', False)
            if _doc_cc_id:
                _doc_cc_id = _doc_cc_id[0]
            _doc_evento_id = dados_documento_documento_tipo.get('docdot_evento_id', False)
            if _doc_evento_id:
                _doc_evento_id = _doc_evento_id[0]
            _cc_id = _doc_cc_id or _par_cc_id
            _evento_id = _doc_evento_id or _par_evento_id
            return _cc_id, _evento_id

        def __fintit_custifica_entrada_a_pagar():
            obj_financeiro_operacoes = self.pool.get('financeiro.operacoes')
            browse_financeiro_operacoes = obj_financeiro_operacoes.browse(cr, uid, operacao_id,
                                                                          context=context)
            _cc_id = browse_financeiro_operacoes.finope_centro_custo_id.id or False
            _evento_id = browse_financeiro_operacoes.finope_evento_id.id or False
            return _cc_id, _evento_id

        context = context and context.copy() or {}
        res = {'value': {}}
        if not valor:
            return res
        obj_adm_utils = self.pool.get('adm.utils')
        _campos_par = obj_adm_utils.admutl_get_parametros(cr, uid, 'financeiro',
                                                          ['usar_centro_custos_e_eventos']
                                                          , context=context)
        if not _campos_par.get('usar_centro_custos_e_eventos'):
            return res
        _evento_id = _cc_id = False
        if operacao_id:
            _cc_id, _evento_id = __fintit_custifica_entrada_a_pagar()
        elif tipo_titulo == 'R':
            _cc_id, _evento_id = __fintit_custifica_entrada_a_receber()
        if _evento_id and _cc_id:
            vals = {
                'centro_custo_id': _cc_id,
                'evento_id': _evento_id,
                'valor': valor,
            }
            res['value'] = {'fintit_gerencialmov_ids': [(0, 0, vals)]}
            # Excluindo possivel movimento anterior
            if ids:
                obj_gerencial_movimento = self.pool.get('gerencial.movimento')
                gerencial_movimento_ids = self.browse(cr, uid, ids[0], context=context).fintit_gerencialmov_ids
                if gerencial_movimento_ids:
                    gerencial_movimento_ids = map(lambda i: i.id, gerencial_movimento_ids)
                    if gerencial_movimento_ids:
                        obj_gerencial_movimento.unlink(cr, uid, gerencial_movimento_ids)
        return res

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
        res = []
        titulo_dados = self.read(cr, uid, ids, ['documento', 'parcela'], context=context)
        for i in titulo_dados:
            id = i['id']
            documento = i['documento']
            parcela = str(i['parcela'])
            res.append((id, '%s/%s' % (documento, parcela)))
        return res

    def fields_view_get(self, cr, uid, view_id=None, view_type='form', context=None, toolbar=False,
                        submenu=False):
        context = context and context.copy() or {}
        if isinstance(view_id, tuple):
            view_id = view_id[0]
        res = super(financeiro_titulo, self).fields_view_get(cr, uid, view_id, view_type, context,
                                                             toolbar, submenu)
        if (context.get('entrada_titulo_pagar', False)) or (
                context.get('titulos_a_pagar_todos', False)):
            '''Para mostrar onde for contas a pagar a string do pessoa_id = Fornecedor'''
            res['fields']['pessoa_id']['string'] = res['fields']['pessoa_id']['string'].replace(
                'Cliente', 'Fornecedor')
        if view_type == 'tree':
            self.fintit_trata_exclusao_baixa(cr, uid, context)
        return res

    def default_get(self, cr, uid, fields, context=None):
        context = context and context.copy() or {}
        res = super(financeiro_titulo, self).default_get(cr, uid, fields, context)
        if res.get('company_id'):
            _campos = ['alterar_multa_juros', 'usar_centro_custos_e_eventos', 'local_cobranca_id']
            parametro_financeiro = self.pool.get('adm.utils').admutl_get_parametros(
                cr, uid, 'financeiro', _campos, context=context)
            flag = parametro_financeiro.get('alterar_multa_juros')
            usar_centro_custos_e_eventos = parametro_financeiro.get('usar_centro_custos_e_eventos')
            usar_centro_custos_e_eventos = parametro_financeiro.get('usar_centro_custos_e_eventos')
            res['local_cobranca_id'] = parametro_financeiro.get('local_cobranca_id')
            res['flag'] = True if flag else False
            res['usar_centro_custos_e_eventos'] = True if usar_centro_custos_e_eventos else False
        if context.get('lancamento_cheque'):
            doc_tipo_id = self.pool.get('documento.documento.tipo').search(cr, uid, [
                ('descricao', 'ilike', 'cheque')], context=context)
            if doc_tipo_id:
                res['doc_tipo_id'] = doc_tipo_id[0]
            res['tipo_titulo'] = 'R'
        return res

    def fintit_onchange_local(self, cr, uid, ids, local_cobranca_id, natureza_cobranca_id):
        res = {'fintit_parametro_local_cobranca': True, 'fintit_tipo_local_cobranca': ''}
        if local_cobranca_id:
            tipo_local_cobranca = self.pool.get('financeiro.local.cobranca').browse(cr, uid,
                                                                                    local_cobranca_id).tipo
            if tipo_local_cobranca != 'C':
                res.update({'fintit_parametro_local_cobranca': False})
            else:
                res.update({'natureza_cobranca_id': False})
            res['fintit_tipo_local_cobranca'] = tipo_local_cobranca

        return {'value': res}

    def fintit_onchange_tipo(self, cr, uid, ids, doc_tipo_id, valor, fintit_operacao_id,
                             tipo_titulo, context=None):
        '''Para entrada de titulos a receber, se o tipo escolhido for "CHQ", e informado ao usuario que
           deve ser usada a tela de lancamento de cheque'''
        context = context and context.copy() or {}
        res = {'value': {}}
        if not doc_tipo_id:
            return res
        tipo = self.pool.get('documento.documento.tipo').search(cr, uid, [('sigla', '=', 'CHQ')], context=context)
        tipo2 = self.pool.get('documento.documento.tipo').search(cr, uid, [('sigla', '=', 'PRV')], context=context)
        if tipo:
            if tipo[0] == doc_tipo_id:
                raise osv.except_osv(_('Atencao'),
                                     _(
                                         'Para lancamento de cheque, voce deve usar o formulario "Lancamento de Cheque"'))
        if tipo2:
            if tipo2[0] == doc_tipo_id:
                raise osv.except_osv(_('Atencao'),
                                     _(
                                         'Para lancamento de previsao, voce deve usar o formulario "Previsao"'))
        if not valor:
            return res
        res = self._fintit_inserir_custos(cr, uid, ids, doc_tipo_id, valor, tipo_titulo,
                                          fintit_operacao_id)
        return res

    def onchange_prorrogacao(self, cr, uid, ids, data):
        if not data:
            return {}
        return {
            'value': {
                'data_vencimento': data,
            }
        }

    def calcula_multa_juros(self, cr, uid, valor, context=None):
        context = context and context.copy() or {}
        dados_parametros = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'financeiro', ['juros_atraso', 'multa_atraso', 'prazo_perdao'], context=context)
        _juros = round(dados_parametros['juros_atraso'] / 30 / 100 * valor, 2)
        _multa = round(dados_parametros['multa_atraso'] / 100 * valor, 2)
        res = {'juros': _juros, 'multa': _multa}
        return res

    def fintit_onchange_valor(self, cr, uid, ids, doc_tipo_id, valor, fintit_operacao_id,
                              tipo_titulo, context=None):
        context = context and context.copy() or {}
        if not valor:
            return {'value': {}}
        res = self._fintit_inserir_custos(cr, uid, ids, doc_tipo_id, valor, tipo_titulo,
                                          fintit_operacao_id)
        # Titulos a pagar nao devem gerar juros e multa
        if tipo_titulo == 'P':
            return res
        _multa_juros = self.calcula_multa_juros(cr, uid, valor, context=context)
        if _multa_juros:
            res['value']['vr_juros_dia'] = _multa_juros['juros']
            res['value']['vr_multa'] = _multa_juros['multa']
        return res

    def onchange_data_vencimento(self, cr, uid, ids, data_vencimento, data_emissao):
        '''A data de vencimento nao deve ser anterior a data de emissao '''
        if data_vencimento and data_emissao != '':
            if data_vencimento < data_emissao:
                raise osv.except_osv(_('Atencao'),
                                     _(
                                         'Data de vencimento nao pode ser menor que a data de emissao'))

    def fintit_onchange_operacao(self, cr, uid, ids, fintit_operacao_id,
                                 fintit_usar_centro_custos_e_eventos, valor,
                                 context=None):
        context = context and context.copy() or {}
        res = {}
        obj_financeiro_operacoes = self.pool.get('financeiro.operacoes')
        obj_gerencial_movimento = self.pool.get('gerencial.movimento')
        if ids:
            gerencial_movimento_ids = self.browse(cr, uid, ids[0], context=context).fintit_gerencialmov_ids
            if gerencial_movimento_ids:
                gerencial_movimento_ids = map(lambda i: i.id, gerencial_movimento_ids)
                if gerencial_movimento_ids:
                    obj_gerencial_movimento.unlink(cr, uid, gerencial_movimento_ids)
        if fintit_operacao_id and fintit_usar_centro_custos_e_eventos:
            browse_financeiro_operacoes = obj_financeiro_operacoes.browse(cr, uid,
                                                                          fintit_operacao_id,
                                                                          context=context)
            centro_custo_id = browse_financeiro_operacoes.finope_centro_custo_id.id or False
            evento_id = browse_financeiro_operacoes.finope_evento_id.id or False
            valor = valor or 0
            if evento_id and centro_custo_id:
                vals = {
                    'centro_custo_id': centro_custo_id,
                    'evento_id': evento_id,
                    'valor': valor
                }
                res['value'] = {'fintit_gerencialmov_ids': [(0, 0, vals)]}
            else:
                res['value'] = {'fintit_gerencialmov_ids': []}
        else:
            res['value'] = {'fintit_gerencialmov_ids': []}
        return res

    def button_print_boleto(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_financeiro_util = self.pool.get('financeiro')
        obj_financeiro_titulo_boleto = self.pool.get('financeiro.titulo.boleto')
        obj_local_natureza = self.pool.get('financeiro.local.natureza')
        pode, mensagem = self.fintit_ver_se_pode_emitir_boleto(cr, uid, ids[0], context=context)
        if not pode:
            raise osv.except_osv(_('Atencao:'), mensagem)
        brw_titulo = self.browse(cr, uid, ids, context=context)
        arq_boleto = boleto.Boleto()
        if isinstance(brw_titulo, list):
            brw_titulo = brw_titulo[0]
        local_cobranca_id = brw_titulo.local_cobranca_id.id
        natureza_cobranca_id = brw_titulo.natureza_cobranca_id.id
        endereco_id = self.pool.get('adm.pessoa').admpes_get_cobranca_endereco_id(
            cr, uid, brw_titulo.pessoa_id.id, context)
        brw_pessoa_endereco = filter(lambda end: end.id == endereco_id,
                                     brw_titulo.pessoa_id.endereco_ids)
        brw_pessoa_endereco = brw_pessoa_endereco[0] if brw_pessoa_endereco else False
        args = [('finlon_local_cobranca_id', '=', local_cobranca_id),
                ('finlon_natureza_cobranca_id', '=', natureza_cobranca_id)]
        local_natureza_ids = obj_local_natureza.search(cr, uid, args, context=context)
        local_natureza_ids = local_natureza_ids[0]
        nosso_numero = obj_local_natureza.finlon_get_set_nosso_numero(cr, uid, brw_titulo.id,
                                                                      local_natureza_ids, context=context)
        data_vencimento = brw_titulo.data_vencimento
        brw_loc_nat = self.pool.get('financeiro.local.natureza').browse(cr, uid, local_natureza_ids)
        logo = brw_titulo.company_id.logo or ''
        if logo:
            logo = base64.decodestring(logo)
            logo = StringIO.StringIO(logo)
            logo.seek(0)
            max_size = 1920
            im = Image.open(logo)
            im = im.convert('RGB')
            nova_logo = StringIO.StringIO()
            im.thumbnail([max_size, max_size], Image.BILINEAR)
            im.save(nova_logo, format='JPEG')
            nova_logo.seek(0)
            logo = ImageReader(nova_logo)

        dados_financeiro_parametro = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'financeiro',
                                                                                      ['finpar_mensagem_boleto',
                                                                                       'finpar_imprimir_informacoes_titulo_boleto'])
        if isinstance(dados_financeiro_parametro, list):
            dados_financeiro_parametro = dados_financeiro_parametro[0]
        observacoes = []
        if dados_financeiro_parametro.get('finpar_mensagem_boleto'):
            observacoes.extend(obj_financeiro_util.finutl_formata_observacao(
                67, dados_financeiro_parametro.get('finpar_mensagem_boleto')))
        imprimir_inf_titulo_boleto = dados_financeiro_parametro.get('finpar_imprimir_informacoes_titulo_boleto')
        if imprimir_inf_titulo_boleto:
            if brw_titulo.observacoes:
                observacoes.extend(obj_financeiro_util.finutl_formata_observacao(
                    67, brw_titulo.observacoes))
        if brw_titulo.fatura_id and brw_titulo.fatura_id.nf_id:
            brw_nota = brw_titulo.fatura_id.nf_id
            nf_no_titulo = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'fiscal',
                                                                            ['fispar_numero_nf_no_titulo'], context=context)
            if nf_no_titulo and isinstance(nf_no_titulo, list):
                nf_no_titulo = nf_no_titulo[0]
            if nf_no_titulo and isinstance(nf_no_titulo, dict):
                nf_no_titulo = nf_no_titulo.get('fispar_numero_nf_no_titulo')
            if nf_no_titulo:
                obs = 'Referente a nota fiscal ' + str(brw_nota.numero_nf or '') + ' serie ' + str(brw_nota.serie_nf) + \
                      ' de ' + brw_nota.data_emissao[8:10] + '/' + brw_nota.data_emissao[
                                                                   5:7] + '/' + brw_nota.data_emissao[:4]
                observacoes.extend(obj_financeiro_util.finutl_formata_observacao(67, obs))
        data_emissao = brw_titulo.data_emissao[8:10] + '/' + brw_titulo.data_emissao[
                                                             5:7] + '/' + brw_titulo.data_emissao[:4]
        vencimento = brw_titulo.data_prorrogacao[8:10] + '/' + brw_titulo.data_prorrogacao[
                                                               5:7] + '/' + brw_titulo.data_prorrogacao[:4]
        # Dados para formacao do boleto
        # Banco
        arq_boleto.banco.formato = 'B'  # 'B'= Boleto
        arq_boleto.banco.numeroBacen = str(brw_loc_nat.finlon_local_cobranca_id.finloc_banco_id.admbco_codigo_bc)
        arq_boleto.banco.convenio = brw_loc_nat.finlon_convenio or ''
        arq_boleto.banco.agencia = brw_loc_nat.finlon_agencia or ''
        arq_boleto.banco.agencia_dv = brw_loc_nat.finlon_agencia_dv or ''
        arq_boleto.banco.conta = brw_loc_nat.finlon_conta or ''
        arq_boleto.banco.conta_dv = brw_loc_nat.finlon_conta_dv or ''
        arq_boleto.banco.carteira = brw_loc_nat.finlon_carteira or ''

        # Cedente
        arq_boleto.cedente.nome = brw_titulo.company_id.rescon_pessoa_id.name
        arq_boleto.cedente.CpfCnpj = brw_titulo.company_id.rescon_pessoa_id.cpf_cnpj or ''
        arq_boleto.cedente.telefone = brw_titulo.company_id.rescon_pessoa_id.telefone
        arq_boleto.cedente.cedente_logo = logo

        # Titutlo
        arq_boleto.titulo.sacadoNome = brw_titulo.pessoa_id.name
        arq_boleto.titulo.sacadoCodigo = brw_titulo.pessoa_id.codigo
        arq_boleto.titulo.nossoNroSeq = nosso_numero  # nosso numero deve ser no titulo e não no cedende, para o numero nao sair repetido na impressao
        arq_boleto.titulo.sacadoCpfCnpj = brw_titulo.pessoa_id.cpf_cnpj
        arq_boleto.titulo.enderecoRua = brw_pessoa_endereco.logradouro_id.name if \
            brw_pessoa_endereco else ''
        arq_boleto.titulo.enderecoNumero = brw_pessoa_endereco.numero if brw_pessoa_endereco else ''
        arq_boleto.titulo.enderecoBairro = brw_pessoa_endereco.bairro_id.name if \
            brw_pessoa_endereco else ''
        arq_boleto.titulo.enderecoCidade = brw_pessoa_endereco.cidade_id.name if \
            brw_pessoa_endereco else ''
        arq_boleto.titulo.enderecoEstado = brw_pessoa_endereco.uf_id.sigla if brw_pessoa_endereco \
            else ''
        arq_boleto.titulo.enderecoCep = brw_pessoa_endereco.cep if brw_pessoa_endereco else ''
        arq_boleto.titulo.documento = brw_titulo.documento or ''
        arq_boleto.titulo.emissao = data_emissao

        arq_boleto.titulo.valor = getNumeroEditado(brw_titulo.vr_original or 0, 2)
        arq_boleto.titulo.vencimento = vencimento
        arq_boleto.titulo.parcela = brw_titulo.parcela or 1
        arq_boleto.titulo.observacoes = observacoes or ''

        arq_boleto.cedente.impressora = 'arquivo/tmp/boleto.pdf'

        # Processa titulo
        arq_boleto.processaTitulo()
        arq_boleto.gerarBoleto()

        nome_arquivo = arq_boleto.cedente.impressora[12:]
        local_arquivo = arq_boleto.cedente.impressora[7:]
        codigo_barras = arq_boleto.titulo.codigoBarras or ''
        codigo_barras = codigo_barras.replace('.', '').replace(' ', '')
        arquivo = open(local_arquivo, 'r')
        arquivos = arquivo.read()
        arquivo = base64.encodestring(arquivos)
        titulo_boleto_ids = obj_financeiro_titulo_boleto.search(
            cr, uid, [('fintib_titulo_id', '=', brw_titulo.id),
                      ('fintib_nosso_numero', '=', nosso_numero),
                      ('fintib_local_cobranca_id', '=', local_cobranca_id),
                      ('fintib_codigo_barras', '=', codigo_barras)],
            context=context)
        if not titulo_boleto_ids:
            obj_financeiro_titulo_boleto.create(
                cr, uid, {'fintib_titulo_id': brw_titulo.id,
                          'fintib_nosso_numero': nosso_numero,
                          'fintib_boleto_impresso': True,
                          'fintib_local_cobranca_id': local_cobranca_id,
                          'fintib_natureza_cobranca_id': natureza_cobranca_id,
                          'fintib_codigo_barras': codigo_barras}, context)
        vals = {
            'wizbtn_dado_boleto': arquivo,
            'wizbtn_arquivo_boleto': nome_arquivo,
        }
        boletos_ids = self.pool.get('wizard.boleto.titulo.nota').search(cr, uid, [], context=context)
        self.pool.get('wizard.boleto.titulo.nota').unlink(cr, uid, boletos_ids)
        self.pool.get('wizard.boleto.titulo.nota').create(cr, uid, vals, context)
        value = {
            'view_type': 'form',
            'view_mode': 'tree',
            'res_model': 'wizard.boleto.titulo.nota',
            'type': 'ir.actions.act_window',
            'target': 'new',
            'context': context
        }
        dados_fiscal_parametro = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'fiscal',
                                                                                  ['impressora_danfe',
                                                                                   'quantidade_vias_danfe'])
        if isinstance(dados_fiscal_parametro, list):
            dados_fiscal_parametro = dados_fiscal_parametro[0]
        if isinstance(dados_fiscal_parametro, dict):
            # Verifica se existe configuracao para impressao do DANFE no parâmetro, se existir envia direto para impressora informada.
            if dados_fiscal_parametro['impressora_danfe'] and dados_fiscal_parametro[
                'quantidade_vias_danfe'] > 0:
                vias = "-n" + str(dados_fiscal_parametro['quantidade_vias_danfe'])
                nome_impressora = "-d" + dados_fiscal_parametro['impressora_danfe']
                try:
                    return subprocess.call(["lp", vias, nome_impressora, local_arquivo])
                except OSError:
                    osv.except_osv(_('Atencao'),
                                   _(
                                       'Impressora nao encontrada, verifique se as configuracoes de impressao estao corretas.'))
            else:
                return value

    def fintit_ver_se_pode_emitir_boleto(self, cr, uid, titulo_id, context=None):
        context = context and context.copy() or {}
        res = (True, False) # O retorno deve ser uma lista primeiro elemento True ou False segundo elemento mensagem se False no primeiro
        # todo: Incluir aqui todos os testes para saber se é possivel gerar o boleto
        bws_titulo = self.browse(cr, uid, titulo_id, context=context)
        obj_financeiro_local_natureza = self.pool.get('financeiro.local.natureza')
        args = [('finlon_local_cobranca_id', '=', bws_titulo.local_cobranca_id.id),
                ('finlon_natureza_cobranca_id', '=', bws_titulo.natureza_cobranca_id.id)]
        local_natureza_ids = obj_financeiro_local_natureza.search(cr, uid, args, context=context)
        if local_natureza_ids:
            dados_local_natureza = obj_financeiro_local_natureza.read(cr, uid, local_natureza_ids[0],
                                                                      ['finlon_registro_banco', 'finlon_boleto_emissao'],
                                                                      load='_classic_write', context=context)
            finlon_boleto_emissao = dados_local_natureza.get('finlon_boleto_emissao')
            if finlon_boleto_emissao != '2':  # 1 = Banco emite, 2 = Cedente emite
                res = (False, _('No Local & Natureza deste titulo, nao esta configurado '
                                       'para o cedente emitir o boleto!'))
            else:
                titulo_situacao_registro = dados_local_natureza.get('finlon_registro_banco') # 1 = com registro, 2 = sem registro
                if not titulo_situacao_registro:
                    res = (False, _('No Local & Natureza deste titulo, nao esta cadastrado '
                                      'se o boleto vai ser com ou sem registro no banco!'))
                else:
                    args = [
                        ('fintib_titulo_id', '=', titulo_id),
                        ('state', '=', 'A'),
                        '|', ('fintib_local_cobranca_id', '!=', bws_titulo.local_cobranca_id.id),
                        ('fintib_natureza_cobranca_id', '!=', bws_titulo.natureza_cobranca_id.id),
                    ]
                    # boleto_ids = self.pool.get('financeiro.titulo.boleto').search(cr, uid, args, context=context)
                    # if boleto_ids:
                    #     res = (False, _('Ja existe boleto ativo para este titulo!'))
        else:
            res = (False, _("Nao ha registro de 'Local & Natureza' para o local e para "
                                "natureza de cobranca do titulo "))
        return res

    def button_imprimir_boleto(self, cr, uid, ids, context=None):
        # Ids aqui é sempre uma lista de 1 id por isto nao usou for
        context = context and context.copy() or {}
        obj_financeiro_local_natureza = self.pool.get('financeiro.local.natureza')
        bws_titulo = self.browse(cr, uid, ids, context=context)
        if isinstance(bws_titulo, list):
            bws_titulo = bws_titulo[0]
        args = [('finlon_local_cobranca_id', '=', bws_titulo.local_cobranca_id.id),
                ('finlon_natureza_cobranca_id', '=', bws_titulo.natureza_cobranca_id.id)]
        local_natureza_ids = obj_financeiro_local_natureza.search(cr, uid, args, context=context)
        if not local_natureza_ids:
            raise osv.except_osv(_('Atencao!'),
                                 _('Nao ha Local e Natureza cadastrado para Local: %s e Natureza: '
                                   '%s') % (bws_titulo.local_cobranca_id.descricao,
                                            bws_titulo.natureza_cobranca_id.name))

        dados_local_natureza = obj_financeiro_local_natureza.read(cr, uid, local_natureza_ids[0],
                                                                      ['finlon_registro_banco', 'finlon_boleto_emissao'],
                                                                      load='_classic_write', context=context)
        titulo_situacao_registro = dados_local_natureza.get('finlon_registro_banco')
        pode, mensagem = self.fintit_ver_se_pode_emitir_boleto(cr, uid, ids[0], context=context)
        if not pode:
            raise osv.except_osv(_('Atencao:'), mensagem)
        nosso_numero = self.fintit_get_nosso_numero(cr, uid, ids, bws_titulo.local_cobranca_id.id,
                                                    bws_titulo.natureza_cobranca_id.id, context=context).get(ids[0])
        data_vencimento = bws_titulo.data_prorrogacao
        titulo_vencido = False
        if datetime.strptime(data_vencimento, '%Y-%M-%d') < datetime.now():
            titulo_vencido = True
        data = {
            'wgb_local_cobranca_id': bws_titulo.local_cobranca_id.id,
            'wgb_natureza_cobranca_id': bws_titulo.natureza_cobranca_id.id,
            'wgb_nosso_numero': nosso_numero,
            'wgb_data_vencimento': data_vencimento,
            'wgb_vr_original': bws_titulo.vr_original,
            'wgb_vr_juros_dia': bws_titulo.vr_juros_dia,
            'wgb_vr_multa': bws_titulo.vr_multa,
            'wgb_vr_desconto': bws_titulo.vr_desconto,
            'wgb_titulo_vencido': titulo_vencido,
            'multa_apos': bws_titulo.multa_apos_data,
            'limite_desconto': bws_titulo.data_limite_desconto,
        }
        # Qdo tem nosso numero e é cobrança registrada, não pode recalcular o boleto
        if nosso_numero and titulo_situacao_registro == '1':
            data['wgb_vr_total'] = bws_titulo.vr_original
        context['dados'] = data

        reference = self.pool.get('ir.model.data').get_object_reference(
                cr, uid, 'financeiro', 'view_gerar_boleto_titulo_form')
        view_id = reference and reference[1] or False

        value = {
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'wizard.gerar.boleto.titulo',
            'view_id': [view_id],
            'type': 'ir.actions.act_window',
            'target': 'new',
            'context': context
        }
        return value

    def read(self, cr, uid, ids, fields=None, context=None, load='_classic_read'):
        '''Para leitura dos flags de Titulos a Receber e Registro de Titulo'''
        context = context and context.copy() or {}
        original_ids = ids
        if not isinstance(ids, list):
            ids = [ids]
        if not fields:
            fields = []
        res = super(financeiro_titulo, self).read(cr, uid, ids, fields=fields, context=context,
                                                  load=load)
        if not res:
            return res
        if context.get('entrada_titulo_receber') or context.get('view_name'):
            if 'local_cobranca_id' in res[0]:
                local = res[0].get('local_cobranca_id')
                if isinstance(local, tuple):
                    local = local[0]
                tipo = self.pool.get('financeiro.local.cobranca').read(cr, uid, local, ['tipo']
                                                                       , context=context)[
                    'tipo']
                res[0]['parametro_local_cobranca'] = True if tipo == 'C' else False
        if res[0].get('company_id'):
            ids = self.pool.get('financeiro.parametros').search(cr, uid, [], context=context)
            if not ids:
                raise osv.except_osv(_('Atencao'),
                                     _('Nao existe parametro do financeiro cadastrado!'))
            dados_parametros = self.pool.get('financeiro.parametros').read(cr, uid, ids[0],
                                                                           ['alterar_multa_juros',
                                                                            'usar_centro_custos_e_eventos'],
                                                                           context=context)
            flag = dados_parametros['alterar_multa_juros']
            res[0]['flag'] = True if flag else False
            usar_centro_custos_e_eventos = dados_parametros['usar_centro_custos_e_eventos']
            res[0]['usar_centro_custos_e_eventos'] = True if usar_centro_custos_e_eventos else False
        if isinstance(original_ids, (int, long)):
            return res[0]
        else:
            return res

    def fintit_trata_exclusao_baixa(self, cr, uid, context=None):
        """
        O metodo exclui as baixas (financeiro_titulo_baixa) que se encontram inativas devido o
        processo de cancelamento. As baixas estao relacionadas com os titulos. O metodo tambem
        exclui o movimento da tesouraria (financeiro_tesouraria_movimento) que esta relacionado com
        a baixa.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: Verdadeiro, caso tenha excluido baixas ou movimento da tesouraria. Senao, Falso.
        :rtype: bool
        """
        context = context and context.copy() or {}
        obj_financeiro_titulo_baixa = self.pool.get('financeiro.titulo.baixa')
        baixa_ids = obj_financeiro_titulo_baixa.search(cr, uid, [('active', '=', False)],
                                                       context=context)
        if not baixa_ids:
            return False
        tesouraria_movimento_ids = map(lambda i: i.tesouraria_movimento_id.id,
                                       obj_financeiro_titulo_baixa.browse(cr, uid, baixa_ids,
                                                                          context))
        tesouraria_movimento_ids = filter(lambda i: i, tesouraria_movimento_ids)
        obj_financeiro_titulo_baixa.unlink(cr, uid, baixa_ids, context)
        self.pool.get('financeiro.tesouraria.movimento').unlink(cr, uid, tesouraria_movimento_ids,
                                                                context)
        return True

    def fintit_get_nosso_numero(self, cr, uid, ids, local_cobranca_id, natureza_cobranca_id, context=None):
        """
        Recupera nosso numero de varios titulos para um local de cobranca e uma natureza de cobranca
        :param cr:
        :param uid:
        :param ids: ids dos titulos
        :param local_cobranca_id:  id do local de cobranca desejado
        :param natureza_cobranca_id: id da natureza de cobranca desejada
        :param context:
        :return: dicionario com id do titulo e o nosso_numero Ex.: {titulo_id:nosso_numero}
        """
        context = context and context.copy() or {}
        boletos = self.fintit_get_dados_boleto(cr, uid, ids, local_cobranca_id, natureza_cobranca_id, context=context)
        res = {}
        for titulo_id in boletos.keys():
            res[titulo_id] = boletos.get(titulo_id).get('fintit_boleto_nosso_numero')
        return res


    def fintit_get_dados_boleto(self, cr, uid, ids, local_cobranca_id=False, natureza_cobranca_id=False, context=None):
        """
        Método que retorna o nosso numero e o codigo de barras de um titulo
        Se não informado o local de cobrnca, busca o primeiro boleto encontrado(o mais recente)
        Se informado o local busta o primeiro boleto do local de cobranca informado(o mais recente)
        Args:
            cr:
            uid:
            ids: ids dos titulos
            local_cobranca_id: local de cobrança a ser considerado
            Natureza_cobranca_id: Natureza de cobrança a ser considaderada
            context:

        Returns:
            Dicionacio contendo titulo con dicionario de nosso numero e codigo de barras
            Ex. {titulo_id: {'nosso_numero': nosso_numero, 'codigo_barras': codigo_de_barras
        """
        context = context and context.copy() or {}
        res = {}
        for titulo in self.browse(cr, uid, ids, context):
            res[titulo.id] = {'fintit_boleto_nosso_numero': '',
                              'fintit_boleto_codigo_barras': ''}
            for brw_boleto in titulo.fintit_boleto_ids:
                if local_cobranca_id:
                    if (brw_boleto.fintib_local_cobranca_id.id != local_cobranca_id or
                       brw_boleto.fintib_natureza_cobranca_id.id != natureza_cobranca_id):
                        continue
                res[titulo.id] = {'fintit_boleto_nosso_numero': brw_boleto.fintib_nosso_numero or '',
                                  'fintit_boleto_codigo_barras': brw_boleto.fintib_codigo_barras or ''}
                break
        return res

    def fintit_check_condicao_pessoa(self, cr, uid, pessoa_id, valor_titulo, context=None):
        """
        O metodo verifica se eh possivel lancar um novo titulo a receber para o cliente, devido seu
        limite de credito.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param pessoa_id: id da tabela adm_pessoa, identificador da pessoa.
        :type pessoa_id: int
        :param valor_titulo: valor a receber da pessoa_id (cliente).
        :type valor_titulo: float
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: Verdadeiro, caso a pessoa_id seja um cliente que possua limite de credito
        disponivel para o atual lancamento. Senao, eh retornado um raise que informa que a pessoa
        nao eh um cliente ou nao possui limite de credito.
        :rtype: bool
        """

        context = context and context.copy() or {}
        obj_financeiro_cliente = self.pool.get('financeiro.cliente')
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name,
                                                                    context=context)

        # Verifica parametro para limite de credito
        financeiro_parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'financeiro', ['verificar_limite_credito'])
        if not financeiro_parametro_dados.get('verificar_limite_credito'):
            return True

        # Titulos em aberto para a pessoa
        titulo_ids = self.search(cr, uid, [('pessoa_id', '=', pessoa_id), ('state', '=', 'A'),
                                           ('tipo_titulo', '=', 'R')],
                                 context=context)

        # Soma do saldo que ja se encontra em aberto mais valor do novo titulo
        vr_total_aberto = sum(map(lambda i: i.saldo or 0,
                                  self.browse(cr, uid, titulo_ids, context))) + float(valor_titulo)

        # Identifica se a pessoa eh um cliente e seu limite de credito
        if not obj_financeiro_cliente.verificar_incluir_cliente(cr, uid, pessoa_id, company_id,
                                                                context=context):
            nome_pessoa = self.pool.get('adm.pessoa').browse(cr, uid, pessoa_id, context).nome
            raise osv.except_osv(_('Atencao'), _('%s nao e um cliente.' % nome_pessoa))
        cliente_ids = obj_financeiro_cliente.search(cr, uid, [('pessoa_id', '=', pessoa_id)],
                                                    context=context)
        vr_limite_credito = obj_financeiro_cliente.browse(
            cr, uid, cliente_ids[0]).limite_credito or 0

        # Se o total em aberto a receber do cliente for maior que seu limite de credito, o processo
        # eh impedido de seguir
        if vr_total_aberto > vr_limite_credito:
            raise osv.except_osv(_('Atencao'), _('Cliente nao possui limite de credito.'))
        return True

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        obj_documento_tipo = self.pool.get('documento.documento.tipo')
        doc_tipo_previsao_ids = obj_documento_tipo.search(cr, uid, [('sigla', '=', 'PRV')],
                                                          context=context)

        if context.get('futil_super'):
            del context['futil_super']
            id = super(financeiro_titulo, self).create(cr, uid, vals, context)
            return id
        gerencial_valores = []
        if vals.get('fintit_gerencialmov_ids'):
            for i in vals.get('fintit_gerencialmov_ids'):
                if len(i) >= 3 and i[2] and i[2].get('valor'):
                    gerencial_valores.append({'valor': i[2].get('valor')})
                self._fintit_verificar_custificacao(cr, uid, [], context)
        if (vals.get('fatura_id') or False) and not (vals.get('doc_tipo_id') or False):
            vals['doc_tipo_id'] = self.pool.get('financeiro.fatura').browse(
                cr, uid, vals.get('fatura_id'), context=context).finfat_documento_tipo_id.id or False
        # VALIDAÇÕES DE CONTEXTO:
        # Passar o context no create.
        # No create do cliente, caso nao tenha a chave 'pessoa_nao_validar' no contexto, e feita a validacao para pessoa.
        if (vals.get('vr_original') or 0) is 0:
            raise osv.except_osv(_('Atencao'), _('Informe o valor do Titulo'))

        # SE TENTAR LANÇAR UM CHEQUE NA TELA DE TITULO.
        doc_tipo_cheque_ids = obj_documento_tipo.search(cr, uid, [('sigla', '=', 'CHQ')], context=context)
        if not context.get('lancamento_cheque'):
            if doc_tipo_cheque_ids:
                if doc_tipo_cheque_ids[0] == vals.get('doc_tipo_id') or False:
                    raise osv.except_osv(_('Atencao'),
                                         _(
                                             'Para lancamento de cheque, voce deve usar o formulario "Lancamento de Cheques"'))
        else:
            vals['doc_tipo_id'] = doc_tipo_cheque_ids[0]

        if context.get('ViewName') != 'Previsao' and not context.get('fintit_manter_prv'):
            if doc_tipo_previsao_ids:
                if doc_tipo_previsao_ids[0] == (vals.get('doc_tipo_id') or False):
                    raise osv.except_osv(_('Atencao'),
                                         _('Para lancamento de previsao, voce deve usar o formulario "Previsao"'))

        obj_financeiro_utils = self.pool.get('financeiro')
        list_custificacao_dados = []
        _custificacao = vals.get('fintit_gerencialmov_ids') or []
        if context.get('lancamento_cheque'):
            vals['tipo_titulo'] = 'R'
        for _x in _custificacao:
            _a = _x[2]
            list_custificacao_dados.append(_a)
        res_id = obj_financeiro_utils.financ_titulo_entrada(
            cr, uid, fult_tit_pessoa_id=vals.get('pessoa_id') or False,
            fult_tit_emissao=context.get('nfe_xml_dhRecbto', '')[:10] or vals.get('data_emissao'),
            fult_tit_vencimento=vals.get('data_vencimento') or vals.get('data_prorrogacao'),
            fult_tit_documento=vals.get('documento') or '', fult_tit_parcela=vals.get('parcela'),
            fult_tit_valor=vals.get('vr_original'),
            fult_tit_tipo_lancamento=vals.get('tipo_lancamento'),
            fult_tit_tipo_titulo=vals.get('tipo_titulo'), fult_tit_obs=vals.get('observacoes'),
            fult_tit_fatura_id=vals.get('fatura_id') or False,
            fult_tit_moeda=vals.get('adm_moeda_id') or False,
            fult_tit_doc_tipo_id=vals.get('doc_tipo_id') or False,
            fult_tit_previsao_id=vals.get('previsao_id') or False,
            fult_tit_tipo_sacado=vals.get('tipo_sacado'),
            fult_tit_vendedor_id=vals.get('vendedor_id') or False,
            fult_tit_vendedor_externo_id=vals.get('vendedor_externo_id') or False,
            fult_tit_chq_banco_id=vals.get('fintit_chq_banco') or False,
            fult_tit_chq_agencia_id=vals.get('fintit_chq_agencia') or False,
            fult_tit_chq_conta=vals.get('fintit_chq_conta'),
            fult_tit_chq_emitente_id=vals.get('fintit_chq_emitente') or False,
            fult_tit_custificacao_dados=list_custificacao_dados,
            fult_tit_operacao_id=vals.get('fintit_operacao_id') or False,
            filt_tit_local_cobranca_id=vals.get('local_cobranca_id'),
            filt_tit_natureza_cobranca_id=vals.get('natureza_cobranca_id'), context=context,
            fintit_pedido_id=vals.get('fintit_pedido_id', False),
            company_id=vals.get('company_id'),
            vr_juros_dia=vals.get('vr_juros_dia') or 0,
            vr_multa=vals.get('vr_multa') or 0,
            )
        if not res_id:
            msg = obj_financeiro_utils.financ_get_erro()
            raise osv.except_osv(_('Atencao'), msg)

        #checka vencimento e valor do codigo de barras
        titulo_id = res_id
        if not isinstance(titulo_id, list) and isinstance(titulo_id, (int, long)):
            titulo_id = [titulo_id]
        if not context.get('custifica_contrato'):
            self._fintit_incluir_historico_gerencial(cr, uid, res_id, context)
        return res_id

    def action_cancela(self, cr, uid, ids, context=None):
        '''Acao do botao para limpar campos repasse_pessoa_id, repasse_data'''
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'repasse_pessoa_id': False, 'repasse_data': False},
                   context=context)
        return True

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
        ## Passar o context no create. No create do cliente, caso nao tenha a chave 'pessoa_nao_validar' no contexto,
        ## e feita a validacao para pessoa.

        obj_financeiro_titulo_historico = self.pool.get('financeiro.titulo.historico')
        dados_parametros = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'financeiro',
                                                                            ['cadastro_automatico_cliente',
                                                                             'cadastro_automatico_cliente'],
                                                                            context=context)
        tipo_chq = self.pool.get('documento.documento.tipo').search(cr, uid, [('sigla', '=', 'CHQ')], context=context)
        tipo_prv = self.pool.get('documento.documento.tipo').search(cr, uid, [('sigla', '=', 'PRV')], context=context)

        if context.get('lancamento_cheque') and vals.get('vr_original') > 0:
            # O campo saldo nao aparece na tela do cheque. Por isso receber o valor do campo vr_original na alteracao.
            vals['saldo'] = vals.get('vr_original')

        # Remover campos que não existem no modelo ###########
        # Ajustando vals
        if 'parametro_local_cobranca' in vals:
            del vals['parametro_local_cobranca']
        if 'tipo_cobranca' in vals:
            del vals['tipo_cobranca']
        if 'flag' in vals:
            del vals['flag']
        if 'usar_centro_custos_e_eventos' in vals:
            del vals['usar_centro_custos_e_eventos']
        if 'local_cobranca_id' in vals:
            if isinstance(vals['local_cobranca_id'], tuple):
                vals['local_cobranca_id'] = vals['local_cobranca_id'][0]
        if 'company_id' in vals:
            vals['company_id'] = self.pool.get('res.company')._company_default_get(cr, uid,
                                                                                   self._name)
        ###################

        # Testes para restringir alterações  ###############
        if context.get('titulo_baixado', False):
            raise osv.except_osv(_('Atencao'),
                                 _('Titulo baixado, nao posso alterar!'))
        if 'doc_tipo_id' in vals:
            if tipo_chq[0] == vals['doc_tipo_id']:
                raise osv.except_osv(_('Atencao'),
                                     _('Para lancamento de cheque, voce deve usar o formulario "Lancamento de Cheque"'))

            if tipo_prv[0] == vals['doc_tipo_id'] and not context.get('cttctr_alterar_tipo_documento_'
                                                                      'titulo'):
                raise osv.except_osv(_('Atencao'),
                                     _('Para lancamento de previsao, voce deve usar o formulario "Previsao"'))
        data_vencimento = vals.get('data_vencimento')
        if data_vencimento and data_vencimento < vals.get('data_emissao'):
            raise osv.except_osv(_('Atencao'),
                                 _('Data de vencimento nao pode ser menor que a data de emissao.'))
        ###################

        financeiro_titulo_dados = self.read(cr, uid, ids, [], context=context, load=READ_LOAD)
        if vals.get('fintit_gerencialmov_ids'):
            for dados_titulo in financeiro_titulo_dados:
                for i in vals.get('fintit_gerencialmov_ids'):
                    if i[0] == 2:
                        continue
                    i[2]['fingmo_data'] = dados_titulo.get('data_emissao')
                    i[2]['pessoa_id'] = dados_titulo.get('pessoa_id')

        result = super(financeiro_titulo, self).write(cr, uid, ids, vals, context=context)
        for dados_titulo in financeiro_titulo_dados:

            fatura_id = dados_titulo.get('fatura_id')

            # Testes para restringir alterações por titulo ###############
            if fatura_id and (vals.get('vendedor_id') or vals.get('vendedor_externo_id')):
                raise osv.except_osv(_('Atencao'), _('Nao e permitido alterar os vendedores!'))
            if 'vr_original' in vals and not context.get('altera_operadora_cartao'):
                if fatura_id:
                    raise osv.except_osv(_('Atencao'), _(
                        'Nao e permitido alterar o valor dos Titulos que possuem Faturas'))

            ###########################
            # Cadastramento automatico de clientes/fornecedores ###########
            if 'pessoa_id' in vals:
                if (context.get('entrada_titulo_receber', False) and
                        dados_parametros.get('cadastro_automatico_cliente', False)):
                    cliente_ids = self.pool.get('financeiro.cliente').search(cr, uid,
                                            [('pessoa_id', '=',vals['pessoa_id'])], context=context)
                    if not cliente_ids:
                        empresa = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                              'financeiro.cliente', context=context)
                        self.pool.get('financeiro.cliente').create(cr, uid,
                                                           {'pessoa_id': vals['pessoa_id'],
                                                            'company_id': empresa}, context=context)
                if (context.get('entrada_titulo_pagar', False) and
                        dados_parametros.get('cadastro_automatico_fornecedor', False)):
                    forncedor_ids = self.pool.get('financeiro.fornecedor').search(cr, uid,
                                            [('pessoa_id', '=',vals['pessoa_id'])], context=context)
                    if not forncedor_ids:
                        empresa = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                            'financeiro.fornecedor',context=context)
                        self.pool.get('financeiro.fornecedor').create(cr, uid,
                                                           {'pessoa_id': vals['pessoa_id'],
                                                            'company_id': empresa}, context=context)
            #########################
            if dados_titulo.get('doc_tipo_id', False) != tipo_prv:
                if ('local_cobranca_id' in vals or
                            'natureza_cobranca_id' in vals or
                            'data_prorrogacao' in vals or
                            'state' in vals or
                            'saldo' in vals):
                    operacao = 'A'
                    if 'state' in vals:
                        if vals['state'] == 'B':
                            operacao = 'B'
                            if context.get('baixa_renegociacao'):
                                operacao = 'BR'
                        elif vals['state'] == 'C':
                            operacao = 'C'
                    elif 'saldo' in vals:
                        operacao = 'BP'
                    if 'local_cobranca_id' in vals:
                        local = vals['local_cobranca_id']
                        operacao = 'R'
                    else:
                        local = dados_titulo.get('local_cobranca_id')
                    if 'natureza_cobranca_id' in vals:
                        natureza = vals['natureza_cobranca_id']
                        operacao = 'R'
                    else:
                        natureza = dados_titulo.get('natureza_cobranca_id')
                    if 'data_prorrogacao' in vals:
                        prorrogacao = vals['data_prorrogacao']
                        operacao = 'PR'
                    else:
                        prorrogacao = dados_titulo.get('data_prorrogacao')
                    data = {
                        'titulo_id': dados_titulo.get('id'),
                        'local_cobranca_id': local,
                        'data_prorrogacao': prorrogacao,
                        'natureza_cobranca_id': natureza,
                        'operacao': operacao,
                    }
                    obj_financeiro_titulo_historico.create(cr, uid, data, context)

            if not context.get('financ_baixar_titulo'):
                if dados_titulo.get('tipo_lancamento') == 'M': # M = manual, A = automatico
                    self._fintit_verificar_custificacao(cr, uid, ids, context=context)
                    # caso a data de emissao do cheque seja alterada manualmente, se houver
                    # gerencial movimento, altera a data dele tambem(chamado: 122154)
                    if tipo_chq[0] == dados_titulo.get('doc_tipo_id') and vals.get('data_emissao'):
                        obj_ge_mov = self.pool.get('gerencial.movimento')
                        gerencial_ids = obj_ge_mov.search(cr, uid,
                                      [('titulo_id', '=', dados_titulo.get('id'))], context=context)
                        if gerencial_ids:
                            vals_gm = {'fingmo_data': vals.get('data_emissao'),
                                       'mes_competencia': vals.get('data_emissao')[5:7],
                                       'ano_competencia': vals.get('data_emissao')[:4]}
                            obj_ge_mov.write(cr, uid, gerencial_ids, vals_gm, context=context)

                self._fintit_incluir_historico_gerencial(cr, uid, ids, context=context)

        obj_gerencial_movimento = self.pool.get('gerencial.movimento')
        gerencial_movimento_ids = obj_gerencial_movimento.search(
            cr, uid, [('titulo_id', 'in', ids)], context=context)
        if gerencial_movimento_ids and vals.get('data_emissao'):
            for movimento_id in gerencial_movimento_ids:
                vals_gerencial_movimento = {
                    'fingmo_data': vals.get('data_emissao'),
                    'mes_competencia': obj_gerencial_movimento.fingmo_get_mes_ano(
                        cr, uid, [movimento_id], 'mes_competencia', context=context),
                    'ano_competencia': obj_gerencial_movimento.fingmo_get_mes_ano(
                        cr, uid, [movimento_id], 'ano_competencia', context=context)
                }
                obj_gerencial_movimento.write(cr, uid, movimento_id, vals_gerencial_movimento,
                                              context)

        return result

    def unlink(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not ids:
            return True
        if 'fisnfc_tratar_exclusao' not in context and not context.get('cumpom_de_cancelamento'):
            doc_tipo_id = \
                self.pool.get('documento.documento.tipo').search(cr, uid, [('sigla', '=', 'PRV')], context=context)[0]
            if not doc_tipo_id:
                raise osv.except_osv(_('Atencao'),
                                     _('Nao e permitido excluir Titulos, somente cancelar.'))
            financeiro_titulo_dados = self.read(cr, uid, ids, ['fatura_id', 'documento', 'state'], context=context)
            if not financeiro_titulo_dados:
                return True
            if not isinstance(financeiro_titulo_dados, list):
                financeiro_titulo_dados = [financeiro_titulo_dados]
            msg_erro = ''
            for titulo in financeiro_titulo_dados:
                fatura_id = titulo.get('fatura_id')
                if fatura_id:
                    raise osv.except_osv(_('Atencao'),
                                         _('Nao e permitido excluir Titulos que possuem Faturas'))
                if titulo.get('state') not in ['A', 'C']:  # Titulos em aberto ou cancelado
                    msg_erro += titulo.get('documento') + ','
            if msg_erro:
                raise osv.except_osv(_('Atencao!'),
                                     _('O(s) titulo(s):') + '\n%s\n' % msg_erro[:-1]  +
                                     _('nao podem ser excluidos pois nao estao mais em aberto!'))
        res = super(financeiro_titulo, self).unlink(cr, uid, ids, context=context)
        return res

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        """
        Filtro do Registro de Titulos a Receber.

        @since: 24.04.2013
        """

        if not args:
            args = []

        context = context and context.copy() or {}
        # ___________________________ Objects ________________________________
        obj_documento_tipo = self.pool.get('documento.documento.tipo')

        doc_tipo_id_chq = obj_documento_tipo.search(cr, uid,
                                                    [('sigla', '=', 'CHQ')], context=context)[0]
        doc_tipo_id_prv = obj_documento_tipo.search(cr, uid,
                                                    [('sigla', '=', 'PRV')], context=context)[0]

        if context.get('view_name', False) == 'Registro de Titulos a Receber':
            doc_tipo_ids = []

            if doc_tipo_id_chq:
                doc_tipo_ids.append(doc_tipo_id_chq)

            if doc_tipo_id_prv:
                doc_tipo_ids.append(doc_tipo_id_prv)

            args += [('tipo_titulo', '=', 'R'),
                     ('doc_tipo_id', 'not in', doc_tipo_ids)]
            return super(financeiro_titulo, self).search(cr, uid, args, offset,
                                                         limit, order, context,
                                                         count)

        # Nao exibir na ´´tree´´ titulos do tipo cheque
        # Mostrar apenas os titulos relacionados a receber e em aberto em local
        # de cobranca
        if any((context.get('local_cobranca', False),
                context.get('natureza_cobranca', False))):
            args += [('tipo_titulo', '=', 'R'), ('state', '=', 'A')]

        # Nao deixa mostrar o tipo previsao
        if any((context.get('entrada_titulo_receber', False),
                context.get('entrada_titulo_pagar', False))):
            args += [('doc_tipo_id', '!=', doc_tipo_id_prv)]

        # Mostra somente tipo cheque
        if any((context.get('cheque_repasse', False),
                context.get('cheque_repasse_cancelar', False),
                context.get('cheque_devolucao', False))):
            args += [('doc_tipo_id', '=', doc_tipo_id_chq)]
        obj_adm_pessoa = self.pool.get('adm.pessoa')
        args_temp = []
        for i in args:
            # Foi feito o tratamento do 'not ilike' e do '!=' porque o open nao estava convertendo
            # os ids de pessoa_id para estas condicoes, ao contrario do 'like' e '='
            if 'pessoa_id' in i:
                if 'not ilike' in i:
                    args_pessoa_id = [('nome', 'ilike', i[-1])]
                    pessoa_ids = obj_adm_pessoa.search(cr, uid, args_pessoa_id, context=context)
                    args_temp.append(['pessoa_id', 'not in', pessoa_ids])
                elif '!=' in i:
                    args_pessoa_id = [('nome', '=', i[-1])]
                    pessoa_ids = obj_adm_pessoa.search(cr, uid, args_pessoa_id, context=context)
                    args_temp.append(['pessoa_id', '!=', pessoa_ids])
                else:
                    args_temp.append(i)
            else:
                args_temp.append(i)
        args = args_temp
        res = super(financeiro_titulo, self).search(cr, uid, args, offset,
                                                    limit, order, context,
                                                    count)

        return res

    def button_imprimir_baixa(self, cr, uid, ids, context=None):
        """
        Funcao realiza a impressao de recibos dos titulos baixados
        """
        context = context and context.copy() or {}
        if isinstance(ids, list):
            baixa_titulo_id = ids[0]
        else:
            baixa_titulo_id = ids
        browse_baixa = self.browse(cr, uid, baixa_titulo_id, context=context)

        if not browse_baixa.fintit_baixa_ids:
            raise osv.except_osv(_('Atencao'), _('Nenhum pagamento encontrado!'))

        hoje = datetime.now()
        documento = 'report.recibo_titulo.' + str(hoje)
        obj_ir_act_report_xml = self.pool.get('ir.actions.report.xml')
        report_id = obj_ir_act_report_xml.search(cr, uid,
                                                 [('report_name', '=', 'financeiro_recibo_titulo')],
                                                 context=context)
        report_xml = obj_ir_act_report_xml.browse(cr, uid, report_id[0], context=context)
        report_xml._data.get(report_id[0])['name'] = _('Recibo baixa')

        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid)
        brw_company_id = self.pool.get('res.company').browse(cr, uid, company_id)
        company_endereco = '%s - %s, %s/%s - %s' % (brw_company_id.rescon_pessoa_id.endereco,
                                                    brw_company_id.rescon_pessoa_id.bairro,
                                                    brw_company_id.rescon_pessoa_id.cidade,
                                                    brw_company_id.rescon_pessoa_id.uf,
                                                    brw_company_id.rescon_pessoa_id.cep)
        context.update({'company_name': brw_company_id.name,
                        'company_endereco': company_endereco,
                        'company_cnpj': brw_company_id.rescon_pessoa_id.cpf_cnpj,
                        'company_telefone': brw_company_id.rescon_pessoa_id.telefone})

        report_pdf = report_sxw.report_sxw(
            documento, 'financeiro.titulo',
            'financeiro/report/recibo_titulo.rml').create_single_pdf(cr, uid, ids,
                                                                     {'report_type': 'pdf'},
                                                                     report_xml, context=context)
        obj_messagebox = self.pool.get('adm.messagebox')
        # criando arquivo em messagebox para efetuar download
        id_messagebox = obj_messagebox.create(cr, uid,
                                              {'dados': base64.encodestring(report_pdf[0])}, context)
        context.update({'id_messagebox': id_messagebox, 'exibir_download': True})
        return messagebox('teste', context=context)

    def fintit_onchange_pessoa_id(self, cr, uid, ids, pessoa, context=None):
        """
        Verifica se o cliente/fornecedor informado esta ou nao ativo. Avisa se estiver inativo.

        :param cr: a linha atual do cursor do banco de dados
        :param uid: ID do usuario utilizado para a verificacao de perfil
        :param ids: lista dos IDs,
        :param pessoa: ID do cliente/fornecedor
        :param context: um dicionario padrao para valores contextuais
        :type cr: object
        :type uid: int
        :type ids: long|list[long]
        :type context: dict
        :return: aviso se o cliente/fornecedor estiver inativo.
        :rtype: dict

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}

        # ___________________________ Objects ________________________________
        obj_adm_pessoa = self.pool.get('adm.pessoa')
        obj_financeiro_cliente = self.pool.get('financeiro.cliente')
        obj_financeiro_fornecedor = self.pool.get('financeiro.fornecedor')

        if pessoa and not obj_adm_pessoa.pessoa_ativa(cr, uid, pessoa, context):
            msg = _('Cliente/Fornecedor selecionado consta como inativo.')
        elif pessoa and not obj_financeiro_cliente.cliente_ativo(cr, uid, pessoa, context):
            msg = _('Cliente selencionado consta como inativo.')
        elif pessoa and not obj_financeiro_fornecedor.fornecedor_ativo(cr, uid, pessoa, context):
            msg = _('Fornecedor selencionado consta como inativo.')
        else:
            msg = None

        result = dict(warning=dict(title=_('Aviso.'), message=msg)) if msg else dict()

        return result

    def fintit_get_total_em_aberto(self, cr, uid, pessoa_ids, tipo_titulo='R', context=None):
        """
        Verifica total em aberto para as pessoas informadas no parametro

        :param cr: a linha atual do cursor do banco de dados
        :param uid: ID do usuario utilizado para a verificacao de perfil
        :param pessoa_ids: lista dos IDs,
        :param pessoa_ids: ID do cliente/fornecedor
        :param tipo_titulo: lista dos IDs,
        :param tipo_titulo: R - Receber / P - Pagar
        :param context: um dicionario padrao para valores contextuais
        :type cr: object
        :type uid: int
        :type pessoa_ids: list
        :type tipo_titulo: str
        :type context: dict
        :return: aviso se o cliente/fornecedor estiver inativo.
        :rtype: dict

        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        context = context and context.copy() or {}
        titulos_ids = self.search(cr, uid, [('pessoa_id', 'in', pessoa_ids), ('state', '=', 'A'),
                                            ('tipo_titulo', '=', tipo_titulo)], context=context)
        titulos = self.read(cr, uid, titulos_ids, ['saldo', 'pessoa_id'], context=context, load='_classic_write')
        res = {}
        for pessoa in pessoa_ids:
            res[pessoa] = sum(
                map(lambda i: i.get('saldo') if i.get('pessoa_id') == pessoa else 0.0, titulos))
        return res

    def fintit_onchange_tipo_titulo(self, cr, uid, ids, tipo_titulo, context=None):
        context = context and context.copy() or {}
        res = {'vr_juros_dia': 0, 'vr_multa': 0}
        if tipo_titulo == 'R':
            parametros = self.pool.get('adm.utils').admutl_get_parametros(cr, uid,
                          'financeiro.parametros', ['multa_atraso','juros_atraso'], context=context)
            res['vr_juros_dia'] = parametros.get('juros_atraso')
            res['vr_multa'] = parametros.get('multa_atraso')

        return {'value': res}

    def fintit_button_estornar_baixa(self, cr, uid, ids, context=None):
        """
        O metodo atualiza os titulos para o estado de aberto (state 'A'), como também os saldos.
        Deleta os historicos de baixa.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dados contextuais.
        :type context: dict
        :return: Lista de id dos titulos estornados.
        :rtype: list
        """
        context = context and context.copy() or {}
        obj_financeiro_titulo_baixa = self.pool.get('financeiro.titulo.baixa')
        obj_financeiro_titulo_historico = self.pool.get('financeiro.titulo.historico')
        estorno_titulo_ids = []
        for titulo in self.browse(cr, uid, ids, context):
            estorno_realizado = obj_financeiro_titulo_baixa.fintib_estorna_baixa(
                cr, uid, map(lambda t: t.id, titulo.fintit_baixa_ids), context)
            if not estorno_realizado:
                continue
            estorno_titulo_ids.append(titulo.id)
            sql = """
                UPDATE financeiro_titulo SET state = 'A', saldo = %s WHERE id = %s
            """ % (titulo.vr_original, titulo.id)
            cr.execute(sql)
            obj_financeiro_titulo_historico.create(
                cr, uid, {'titulo_id': titulo.id,
                          'local_cobranca_id': titulo.local_cobranca_id.id or False,
                          'natureza_cobranca_id': titulo.natureza_cobranca_id.id or False,
                          'data_prorrogacao': titulo.data_prorrogacao,
                          'operacao': 'EB'}, context)
        return estorno_titulo_ids

    # vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
