# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.sql import drop_view_if_exists


class financeiro_titulo_baixa_view(osv.Model):
    _name = "financeiro.titulo.baixa.view"
    _inherit = "financeiro.titulo.baixa.view"

    def init(self, cr):
        drop_view_if_exists(cr, 'financeiro_titulo_baixa_view')
        cr.execute(""" create or replace view financeiro_titulo_baixa_view  as (
                select
                    b.id as id,
                    a.company_id as company_id,
                    a.tipo_titulo as tipo_titulo,
                    a.local_cobranca_id as local_cobranca_id,
                    a.natureza_cobranca_id as natureza_cobranca_id,
                    a.pessoa_id as pessoa_id,
                    a.documento as documento,
                    a.parcela as parcela,
                    a.data_emissao as data_emissao,
                    a.doc_tipo_id as doc_tipo_id,
                    (select fintib_nosso_numero from financeiro_titulo_boleto where id in (
                        select max(id) from financeiro_titulo_boleto where fintib_titulo_id = a.id)
                    ) as nosso_numero,
                    a.state as state,
                    a.data_prorrogacao as data_prorrogacao,
                    a.vr_original as vr_original,
                    a.taxa_adm as taxa_adm,
                    b.data_baixa as data_baixa,
                    b.data_pgto as data_pgto,
                    b.valor_pago as valor_pago,
                    b.valor_juros as valor_juros,
                    b.valor_multa as valor_multa,
                    b.valor_desconto as valor_desconto,
                    b.fintib_vr_acrescimo as valor_acrescimo,
                    b.titulo_id as titulo_id,
                    c.codigo as codigo,
                    c.id as id_pessoa,
                    c.nome as nome_pessoa

                from
                    financeiro_titulo a
                left join
                    financeiro_titulo_baixa b on b.titulo_id = a.id
                left join
                    adm_pessoa c  on c.id=a.pessoa_id
                where
                    b.titulo_id is not null

              )""")
