# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class financeiro_gerencial_dre(osv.Model):

    _name = "financeiro.gerencial.dre"
    _inherit = "financeiro.gerencial.dre"

    def _fingerdre_testar_formula(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not isinstance(ids, (list, tuple)):
            ids = [ids]
        _err = False
        _mens = _('Erro ao processar a(s) formula(s):\r\n')
        for brw_dre in self.browse(cr, uid, ids, context=context):
            _formulas = []
            for brw_dre_linhas in brw_dre.fingerdre_linha_ids:
                if brw_dre_linhas.fingerdrl_formula and \
                        any(['C' in brw_dre_linhas.fingerdrl_formula,
                             'E' in brw_dre_linhas.fingerdrl_formula]):
                    continue
                exec('L%d = %d' % (brw_dre_linhas.fingerdrl_linha, 100))
                if brw_dre_linhas.fingerdrl_conta_formula == 'F':
                    _formulas.append(brw_dre_linhas.fingerdrl_formula)
            for x in _formulas:
                try:
                    eval(x.upper())
                except:
                    _err = True
                    _mens += str(x) + '\r\n'
        if _err:
            raise osv.except_osv(_('Atencao!'), _mens)
        else:
            return True

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        vals['fingerdre_sigla'] = vals.get('fingerdre_sigla').upper()
        res = super(financeiro_gerencial_dre, self).create(cr, uid, vals, context)
        self._fingerdre_testar_formula(cr, uid, res, context=context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('fingerdre_sigla'):
            vals['fingerdre_sigla'] = vals.get('fingerdre_sigla').upper()
        res = super(financeiro_gerencial_dre, self).write(cr, uid, ids, vals, context)
        self._fingerdre_testar_formula(cr, uid, ids, context=context)
        return res

    def fisgerdre_button_reorganizar_seq(self, cr, uid, ids, context=None):
        """
        Este metodo tem o objetivo de atualizar as linhas do dre
        enumerando a sequencia de 10 em 10, seguindo a mesma ordem definida no
        campo sequencia (atendimento - 81354)
        """
        context = context and context.copy() or {}
        super(financeiro_gerencial_dre, self).write(cr, uid, ids, vals={}, context=context)
        context.update({'reorganizar_linhas': True})
        obj_dre_linhas = self.pool.get('financeiro.gerencial.dre.linhas')
        dados_nova_sequencia = self.fisgerdre_get_dados_nova_sequencia(cr, uid, ids, context)
        for brw_dre in self.browse(cr, uid, ids, context=context):
            for linhas in brw_dre.fingerdre_linha_ids:
                vals = {
                    'fingerdrl_linha': dados_nova_sequencia.get(linhas.id).get('nova_sequencia'),
                    'fingerdrl_formula': dados_nova_sequencia.get(linhas.id).get('formula', '')
                }
                obj_dre_linhas.write(cr, uid, [linhas.id], vals, context)
        return True

    def fisgerdre_get_dados_nova_sequencia(self, cr, uid, ids, context):
        """
        Este metodo retorna um dicionario contendo informacoes da sequencia
        que a linha possui, a nova sequencia na qual ela sera atualizada e a nova
        formula apos a reorganizacao das linhas, esta nova formula sera alimentada caso
        o atributo fingerdrl_conta_formula de financeiro.gerencial.dre.linhas seja 'F'
        :return: dict
        """
        context = context and context.copy() or {}
        obj_dre_linhas = self.pool.get('financeiro.gerencial.dre.linhas')
        dict_sequencias = {}
        nova_sequencia = 0
        linha_ids = []
        for dado in self.browse(cr, uid, ids, context=context):
            args = [('fingerdrl_dre_id', '=', dado.id)]
            linha_ordernada_ids = obj_dre_linhas.search(cr, uid, args, order='fingerdrl_linha asc',
                                                        context=context)
            if linha_ordernada_ids:
                for linha in obj_dre_linhas.browse(cr, uid, linha_ordernada_ids):
                    linha_ids.append(linha.id)
                    nova_sequencia += 10
                    dict_sequencias[linha.id] = {'sequencia': linha.fingerdrl_linha,
                                                 'nova_sequencia': nova_sequencia,
                                                 'conta_formula': linha.fingerdrl_conta_formula,
                                                 'formula': linha.fingerdrl_formula}
        for linha_id in linha_ids:
            dados = dict_sequencias.get(linha_id)
            nova_formula = ''
            if dados.get('conta_formula') == 'F':
                formula = dados.get('formula')
                cont = 0
                for f in range(len(formula)):
                    if f < cont:
                        continue
                    if formula[f] == 'L':
                        sequencia = ''
                        cont = f
                        for x in range(f, len(formula)):
                            cont += 1
                            if len(formula) > x + 1 and formula[x + 1].isdigit():
                                sequencia += formula[x + 1]
                            else:
                                for i in dict_sequencias.values():
                                    if i.get('sequencia') == int(sequencia):
                                        sequencia = i.get('nova_sequencia')
                                        break
                                nova_formula += 'L' + str(sequencia)
                                break
                    else:
                        nova_formula += formula[f]
                dados['formula'] = nova_formula
        return dict_sequencias

