# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class financeiro_gerencial_dre_linhas(osv.Model):

    _name = 'financeiro.gerencial.dre.linhas'
    _inherit = 'financeiro.gerencial.dre.linhas'

    def _fingerdrl_verifica_formula(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not isinstance(ids, (list, tuple)):
            ids = [ids]
        if ids:
            for brw_dre_linhas in self.browse(cr, uid, ids, context=context):
                _natureza_id = brw_dre_linhas.fingerdrl_natureza_id.id if brw_dre_linhas.fingerdrl_natureza_id else False
                _evento_id = brw_dre_linhas.fingerdrl_evento_id.id if brw_dre_linhas.fingerdrl_evento_id else False
                if _natureza_id and _evento_id:
                    raise osv.except_osv(_('Atencao'),
                                         _('Nao pode informar conta e natureza na mesma linha!'))
        return True

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        # vals['fingerdrl_codigo'] = self.pool.get('adm.utils').get_sequence(cr, uid, self._name,
        #                                                                    'gerencial.dre.linhas.sequencia')
        res = super(financeiro_gerencial_dre_linhas, self).create(cr, uid, vals, context)
        if res:
            self._fingerdrl_valida_linha_repetidas(cr, uid, [res], context=context)
        self._fingerdrl_verifica_formula(cr, uid, res, context=context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        res = super(financeiro_gerencial_dre_linhas, self).write(cr, uid, ids, vals,
                                                                 context=context)
        self._fingerdrl_verifica_formula(cr, uid, ids, context=context)
        self._fingerdrl_valida_linha_repetidas(cr, uid, ids, context)
        return res

    def _fingerdrl_linhas_repedidas(self, cr, uid, ids, context):
        """
        Restorna um boolean informando se existe mais de uma linha cadastrada
        com a mesma sequencia, se sim retorna True
        """
        context = context and context.copy() or {}
        for dado in self.browse(cr, uid, ids, context=context):
            dre_id = dado.fingerdrl_dre_id.id
            sequencia = dado.fingerdrl_linha
            args = [('fingerdrl_dre_id', '=', dre_id),
                    ('fingerdrl_linha', '=', sequencia)]
            dados = self.search(cr, uid, args, context=context)
            if len(dados) > 1:
                return False
        return True

    def _fingerdrl_valida_linha_repetidas(self, cr, uid, ids, context):
        """
        Valida se existe linha com sequencia repetida
        """
        context = context and context.copy() or {}
        if not context.get('reorganizar_linhas'):
            if not self._fingerdrl_linhas_repedidas(cr, uid, ids, context):
                raise osv.except_osv(_('Atencao'), _('O numero da linha nao pode ser repetido!'))
        return True

#TODO calcular a formula da seguinte maneira
# eval('L%d = %s' % (linha, valor)) onde linha é o numero da linha e valor é o valor da linha
# Esta linha cria as variaves em tempo de execução tipo: L1, L3, L10, etc
# em seguida dê um eval na formula que ela será calculada