# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class gerencial_evento(osv.Model):
    _name = 'gerencial.evento'
    _inherit = 'gerencial.evento'

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not len(ids):
            return []
        res = []
        for brw in  self.browse(cr, uid, ids, context=context):
            _codigo = brw.codigo
            _name = brw.name
            brw_parent_id = brw.parent_id
            while brw_parent_id:
                _name = brw_parent_id.name + '/' + _name
                brw_parent_id = brw_parent_id.parent_id
            res.append((brw.id, '%s-%s' % (_codigo, _name)))
        return res

    def onchange_tipo(self, cr, uid, ids, parent_id):
        res = {}
        if parent_id:
            if self.browse(cr, uid, parent_id).evento_natureza_id.id != False:
                natureza = self.browse(cr, uid, parent_id).evento_natureza_id
                res = {'value': {'evento_natureza_id': natureza.id}}
        return res

    def create(self, cr, uid, vals, context=None):
        """
        Metodo para inclusao de registros
        Atribui valor sequencial para o codigo reduzido
        """
        context = context and context.copy() or {}
        context['force_company'] = self.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, tabela=self._name, context=context)
        if vals.get('parent_id', False):
            natureza = self.browse(cr, uid, vals['parent_id']).evento_natureza_id
            vals['evento_natureza_id'] = natureza.id
            parent_id = vals['parent_id']
        else:
            parent_id = False

        vals['controle'] = self.pool.get('adm.utils').get_controle(cr, uid, self._name, parent_id, vals.get('company_id'),
                                                                   context)
        return super(gerencial_evento, self).create(cr, uid, vals, context=context)

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        context['force_company'] = self.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, tabela=self._name, context=context)
        if vals.get('parent_id', False):
            natureza = self.browse(cr, uid, vals['parent_id']).evento_natureza_id
            vals['evento_natureza_id'] = natureza.id
            vals['controle'] = self.pool.get('adm.utils').get_controle(
                cr, uid, self._name, vals.get('parent_id'), vals.get('company_id'), context)
        res = super(gerencial_evento, self).write(cr, uid, ids, vals, context)
        if 'evento_natureza_id' in vals and vals.get('evento_natureza_id'):
            evento_ids = self.search(cr, uid, [('parent_id', 'child_of', ids)], context=context)
            super(gerencial_evento, self).write(
                cr, uid, evento_ids, {'evento_natureza_id': vals.get('evento_natureza_id')},
                context)
        return res

    def unlink(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        record = self.search(cr, uid, [('parent_id', 'child_of', ids)], context=context)
        if record != ids:
            raise osv.except_osv(_('Atencao'), _('Evento contem filho!'))
        result = super(gerencial_evento, self).unlink(cr, uid, ids, context)
        return result

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        if context.get('filter', False):
            states = []
            remove_index = []
            cont = 0
            for i in args:
                if isinstance(i, tuple):
                    if i[0] == 'evento_natureza_id':
                        states.append(str(i[2]))
                        remove_index.append(cont)
                elif isinstance(i, str):
                    remove_index.append(cont)
                cont += 1
            if remove_index:
                search = []
                remove_index.reverse()
                for i in remove_index:
                    args.pop(i)
                search.append('evento_natureza_id')
                search.append('in')
                search.append(states)
                args.append(tuple(search))
        return super(gerencial_evento, self).search(cr, uid, args, offset, limit, order, context, count)

    def name_search(self, cr, uid, name='', args=None, operator='ilike', context=None, limit=100):
        if not args:
            args = []
        context = context and context.copy() or {}
        ids = self.search(cr, uid, [('codigo', '=', name)] + args, limit=limit, context=context)
        if not ids:
            ids = self.search(cr, uid, [('name', operator, name)] + args, limit=limit, context=context)

        return self.name_get(cr, uid, ids, context)
