# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class gerencial_previsao(osv.Model):
    _name = 'gerencial.previsao'
    _inherit = 'gerencial.previsao'

    def onchange_ano(self, cr, uid, ids, ano):
        vals = {'value': {'ano': ano}}
        if ano:
            if ano > 2100 or ano < 2011:
                warning = {
                    'title': _("Atencao"),
                    'message': _("Ano Invalido!")
                }
                vals = {'value': {'ano': 2012}, 'warning': warning}
        return vals

    def onchange_mes(self, cr, uid, ids, mes):
        vals = {'value': {'mes': mes}}
        if mes:
            if mes > 12 or mes < 1:
                warning = {
                    'title': _("Atencao"),
                    'message': _("Mes Invalido!")
                }
                vals = {'value': {'mes': 1}, 'warning': warning}
        return vals

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        _ano = vals.get('ano', False)
        if _ano < 2011 or _ano > 2100:
            raise osv.except_osv(_('Atencao'),
                                 _('Ano invalido!'))
        _mes = vals.get('mes', False)
        if _mes < 1 or _mes > 12:
            raise osv.except_osv(_('Atencao'),
                                 _('Mes invalido!'))
        return super(gerencial_previsao, self).create(cr, uid, vals, context=context)

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        _ano = vals.get('ano', False)
        if _ano:
            if _ano < 2011 or _ano > 2100:
                raise osv.except_osv(_('Atencao'),
                                     _('Ano invalido!'))
        _mes = vals.get('mes', False)
        if _mes:
            if _mes < 1 or _mes > 12:
                raise osv.except_osv(_('Atencao'),
                                     _('Mes invalido!'))
        return super(gerencial_previsao, self).write(cr, uid, ids, vals, context=context)


