# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class financeiro_gerencial_dre_linhas(osv.Model):

    _name = 'financeiro.gerencial.dre.linhas'

    _columns = {
        'fingerdrl_dre_id': fields.many2one('financeiro.gerencial.dre', 'DRE', required=True),
        'fingerdrl_linha': fields.integer('Sequencia', required=True),
        # 'fingerdrl_codigo': fields.char('Controle', size=5, readonly=True),
        'name': fields.char('Descricao', size=40, required=True,
                            help='Para que a descricao seja impressa de forma destacada na listagem'
                                 ' do DRE, cadastre-a inserindo o caracter "<B>". Sera impresso em'
                                 ' letra maiuscula e com "*" no inicio e fim.'),
        'fingerdrl_conta_formula': fields.selection([('C', 'Conta'), ('F', 'Formula')], 'Conta/Formula', size=1,
            help="Este campo pode conter: campo controle, sinais de operacao e valores numericos quaisquer \
                 \nControle = codigo numerico com 5 digitos Precedido pela letra 'C' \
                 \nSinais de operacao: +=Soma, -=Subtracao, /=Divisao *=Multiplicacao", required=True),
        'fingerdrl_formula': fields.text('Formula'),
        'fingerdrl_natureza_id': fields.many2one('gerencial.evento.natureza', 'Natureza'),
        'fingerdrl_evento_id': fields.many2one('gerencial.evento', 'Evento'),
        'fingerdrl_centro_custo_id': fields.many2one('adm.empresa.centrocusto', 'Centro de custo'),
    }

    _order = 'fingerdrl_linha asc'
