# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class gerencial_evento(osv.Model):
    """
    Tabela que contem os eventos financeiros para classificacao dos valores de
     receitas e despesas.
     prefixo: gereve
    """
    from funcoes import _gereve_get_codigo
    from funcoes import _gereve_tem_filho


    _name = 'gerencial.evento'
    _parent_store = True
    _roteavel = True
    _columns = {
        'name': fields.char('Descricao', size=40, required=True), # Descricao do evento
        'codigo': fields.function(_gereve_get_codigo, method=True, string='Codigo', type='char', size=20, store=True),
        # Codigo da estrutura conta.
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True), # Id da Empresa
        'parent_id': fields.many2one('gerencial.evento', 'Evento pai', ondelete="cascade", select=True,
                                     domain="[('company_id', '=', company_id)]"), # id do evento pai
        # 'planejamento_evento_ids': fields.one2many('gerencial.planejamento.evento', 'evento_id', 'Evento'),
        'child_ids': fields.one2many('gerencial.evento', 'parent_id', 'Contas filhas'),
        'parent_left': fields.integer('Evento Descendente', select=1),
        'parent_right': fields.integer('Evento ascendente', select=1),
        'controle': fields.integer('Controle'),
        'verifica_filho': fields.function(_gereve_tem_filho, method=True, string='Contem filho', type='boolean'),
        'active': fields.boolean('Ativo'),
        'evento_natureza_id': fields.many2one('gerencial.evento.natureza', 'Evento natureza', required=True,
                                              restrict=True),
        'gereve_movimento_ids': fields.one2many('gerencial.movimento', 'evento_id', 'Custificacao'),
    }
    _sql_constraints = [
        ('codigo_uniq', 'unique (company_id, codigo)', 'O codigo precisa ser unico!'),
    ]
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        'active': True,
    }
    _order = 'parent_left'


