# -*- encoding: utf-8 -*-
##############################################################################
#                                                                            #
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca        #
#                    www.siginformatica.com.br luiz@siginformatica.com.br    #
#                                                                            #
##############################################################################

from openerp.osv import osv, fields


class gerencial_movimento(osv.Model):
    """
    Classe gerencial_movimento
    prefixo:fingmo_
    """

    _name = 'gerencial.movimento'
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }
    _columns = {
        'create_date': fields.datetime('Data de criacao', readonly=1),
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", select=True),
        'valor': fields.float('Valor', digits=(15, 2), required=True),
        # Valor do rateio para o centro de custo.
        'titulo_id': fields.many2one("financeiro.titulo", 'Titulo', ondelete="cascade",
                                     select=True),  # Id do Titulo
        'tesouraria_movimento_id': fields.many2one("financeiro.tesouraria.movimento", 'Movimento',
                                                   ondelete="cascade", select=True),  # Id do movimento da tesouraria
        'evento_id': fields.many2one("gerencial.evento", 'Evento', ondelete="restrict", select=True,
                                     required=True),
        'centro_custo_id': fields.many2one("adm.empresa.centrocusto", 'Centro de custo',
                                           ondelete="restrict", select=True, required=True),  # Id do centro de custo
        'fingmo_data': fields.date('Data', oldname='data', required=True),
        'mes_competencia': fields.char(string='Mes competencia', size=2, store=True),  # Mes de competencia
        'ano_competencia': fields.char(string='Ano competencia', size=4, store=True),  # Ano de competencia   _fingmo_get_data
        'pessoa_id': fields.many2one("adm.pessoa", 'Pessoa', ondelete="restrict"),
        # Id do parceiro(cliente/Fornecedor)
        'fingmo_historico': fields.text("Historico"),
        'fingmo_operacao': fields.selection([('E', 'Entradas'), ('S', 'Saidas')], 'Operacao',
                                            size=1),
    }
    _order = 'fingmo_data desc'
