# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class gerencial_previsao(osv.Model):
    """
    Tabela de previsao de custos.
    """
    _name = 'gerencial.previsao'
    _columns = {
        'centro_custo_id': fields.many2one("adm.empresa.centrocusto", 'Centro de custo', ondelete="restrict",
                                           required=True, select=True),
        'evento_id': fields.many2one("gerencial.evento", 'Evento', ondelete="restrict", required=True, select=True),
        'ano': fields.integer('Ano', required=True), #Ano da previsao
        'mes': fields.integer('Mes', required=True), #Mes da previsao
        'valor': fields.float('Valor', digits=(10, 2), required=True), # Valor.
    }
    _order = 'ano, mes, centro_custo_id, evento_id'

