# -*- coding: utf-8 -*-

from SigUtils.impressao import Impressora
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _
from dateutil.parser import parse
import locale


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(e, c, d, t=160):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        # Define a fomatacao dos numeros
        locale.setlocale(locale.LC_ALL, str('%s.UTF-8' % context.get('lang')))

        context = context and context.copy() or {}
        title = '{:^160}'.format(_('Documentos Sem Classificacao'))
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato()
        listagem.informaNome(pdf_string, _('documentos_sem_classificacao'))
        listagem.informaTamLinha(160)
        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'wizard.gerencial.evolucao.conta', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
        listagem.informaCab(title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab(docs)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.rodapePadrao()

        # Titulos
        cab = u'|{:^52}|{:^7}|{:^30}|{:^9}|{:^10}|{:^12}|{:^22}|'
        if datas.get('titulo'):
            listagem.imprimeLinha(_('TITULOS'))
            listagem.imprimeLinha('')
            listagem.imprimeLinha('*' + ('-' * 148) + '*')
            listagem.imprimeLinha(cab.format(_('CLIENTE/FORNECEDOR'), _('TIPO'), _('DOCUMENTO'),
                                  _('PARCELA'), _('EMISSAO'), _('VENCIMENTO'), _('VALOR')))
            listagem.imprimeLinha('*' + ('-' * 148) + '*')
        linha = u'|{wgdtit_cliente_fornecedor:<52}|{wgdtit_tipo:^7}' \
                u'|{wgdtit_documento:<30}|{wgdtit_parcela:>9}|{wgdtit_data_emissao:^10}' \
                u'|{wgdtit_data_vencimento:^12}|{wgdtit_valor:>22}|'
        for titulo in datas.get('titulo', []):
            # Formatacao dos valores
            titulo = dict([(t[0], '{:%x}'.format(parse(t[1]))) if 'data' in t[0] else
                           (t[0], locale.format('%.2f', t[1], True)) if 'valor' in t[0] else
                           t for t in titulo.items()])

            listagem.imprimeLinha(linha.format(**titulo))
        if datas.get('titulo'):
            listagem.imprimeLinha('*' + ('-' * 148) + '*')

        # Tesouraria
        cab = u'|{:^20}|{:^16}|{:^5}|{:^20}|{:^83}|'
        if datas.get('tesouraria'):
            listagem.imprimeLinha('')
            listagem.imprimeLinha(_('TESOURARIA'))
            listagem.imprimeLinha('')
            listagem.imprimeLinha('*' + ('-' * 148) + '*')
            listagem.imprimeLinha(cab.format(_('CONTA'), _('DATA MOVIMENTO'), _('D/C'), _('VALOR'),
                                             _('HISTORICO')))
            listagem.imprimeLinha('*' + ('-' * 148) + '*')
        linha = u'|{wgdtes_conta:<20}|{wgdtes_data:^16}|{wgdtes_debito_credito:^5}' \
                u'|{wgdtes_valor:>20}|{wgdtes_historico:<83}|'
        for tesouraria in datas.get('tesouraria', []):
            # Formata as datas
            tesouraria = dict([(t[0], '{:%x}'.format(parse(t[1]))) if 'data' in t[0] else
                               (t[0], locale.format('%.2f', t[1], True)) if 'valor' in t[0] else
                               t for t in tesouraria.items()])

            listagem.imprimeLinha(linha.format(**tesouraria))
        if datas.get('tesouraria'):
            listagem.imprimeLinha('*' + ('-' * 148) + '*')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()

        return self.obj.pdf, 'pdf'


report_custom('report.documento_sem_classificacao')

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
