# -*- encoding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _
from dateutil.parser import parse
from dateutil.relativedelta import relativedelta


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):

    def get_sequencia_mes_ano(self, cr, uid, mes, ano, context=None):
        context = context and context.copy() or {}
        res = {}
        list_range = range(1, 12)
        list_range.sort(reverse=True)
        data = ano + '-' + mes + '-' + '01'
        res[12] = parse(data).strftime('%m/%Y')
        for i in list_range:
            data = parse(data) - relativedelta(months=1)
            data1 = data.strftime('%m/%Y')
            data = data.strftime('%Y-%m-%d')
            res[i] = data1
        return res

    def create(self, cr, uid, ids, datas, context=None):
        def center_title(e, c, d, t=208):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        context = context and context.copy() or {}
        title = center_title('', _('Evolucao de Contas'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='1')
        listagem.informaNome(pdf_string, _('evolucao_de_contas'))
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)
        listagem.defineFonte(tam=6.8)

        seq_mes_ano = self.get_sequencia_mes_ano(cr, uid, datas.get('mes'), datas.get('ano'),
                                                 context)
        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'wizard.gerencial.evolucao.conta', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
        tipo_conta = 'Centro de custos' if datas.get('tipo_conta') == 'C' else 'Eventos'
        tipo_classificacao = 'Competencia' if datas.get('tipo_classificacao') == 'C' else \
            'Fato gerador'

        listagem.informaCab(''+title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab(''+docs)
        listagem.informaCab('')
        listagem.informaCab('Mes/Ano: %s/%s' % (datas.get('mes'), datas.get('ano')))
        listagem.informaCab('Tipo de conta: %s' % tipo_conta)
        listagem.informaCab(_('Tipo de classificacao')+': %s' % tipo_classificacao)
        listagem.informaCab('')
        listagem.informaCab('*' + ('-' * 197) + '*')
        listagem.informaCab('| CONTA                    |    %s |    %s |    %s |    %s |    %s'
                            ' |    %s |    %s |    %s |    %s |    %s |    %s |    %s '
                            '|        TOTAL |' %
                            (seq_mes_ano.get(1), seq_mes_ano.get(2), seq_mes_ano.get(3),
                             seq_mes_ano.get(4), seq_mes_ano.get(5), seq_mes_ano.get(6),
                             seq_mes_ano.get(7), seq_mes_ano.get(8), seq_mes_ano.get(9),
                             seq_mes_ano.get(10), seq_mes_ano.get(11), seq_mes_ano.get(12)))
        listagem.informaCab('*' + ('-' * 197) + '*')
        listagem.informaCab('')
        listagem.rodapePadrao()

        for x in datas.get('item_ids'):
            linha = ' '
            linha += formataString(x.get('wgerei_descricao_conta') or '', 25, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(x.get('wgerei_mes1_valor') or 0.0, 2), 12, ' ',
                                   'E', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(x.get('wgerei_mes2_valor') or 0.0, 2), 12, ' ',
                                   'E', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(x.get('wgerei_mes3_valor') or 0.0, 2), 12, ' ',
                                   'E', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(x.get('wgerei_mes4_valor') or 0.0, 2), 12, ' ',
                                   'E', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(x.get('wgerei_mes5_valor') or 0.0, 2), 12, ' ',
                                   'E', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(x.get('wgerei_mes6_valor') or 0.0, 2), 12, ' ',
                                   'E', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(x.get('wgerei_mes7_valor') or 0.0, 2), 12, ' ',
                                   'E', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(x.get('wgerei_mes8_valor') or 0.0, 2), 12, ' ',
                                   'E', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(x.get('wgerei_mes9_valor') or 0.0, 2), 12, ' ',
                                   'E', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(x.get('wgerei_mes10_valor') or 0.0, 2), 12, ' ',
                                   'E', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(x.get('wgerei_mes11_valor') or 0.0, 2), 12, ' ',
                                   'E', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(x.get('wgerei_mes12_valor') or 0.0, 2), 12, ' ',
                                   'E', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(x.get('wgerei_vr_total') or 0.0, 2), 13, ' ',
                                   'E', 'N', 'S')
            linha += ' |'
            listagem.imprimeLinha('|'+linha)
        listagem.imprimeLinha('*' + ('-' * 197) + '*')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

report_custom('report.gerencial_evolucao_conta')
