# -*- encoding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(e, c, d, t=125):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        context = context and context.copy() or {}
        title = center_title('', _('Listagem DRE'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('listagem_DRE'))
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)
        listagem.defineFonte(tam=8)
        # listagem.informaTamLinha(160)

        linhas_dre = datas.get('linhas_dre')
        data_inicial = datas.get('data_inicial')
        data_final = datas.get('data_final')
        dre_name = datas.get('dre_name')
        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'wizard.gerencial.listagem.dre', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
        filtro = center_title(_('Periodo') + ': %s a %s' % (data_inicial, data_final), '', '')
        filtro1 = center_title('DRE: %s' % dre_name, '', '')

        listagem.informaCab(''+title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab(''+docs)
        listagem.informaCab('')
        listagem.informaCab(filtro)
        listagem.informaCab(filtro1)
        if datas.get('classificacao_origem'):
            listagem.informaCab(_('Classificacao da origem'))
        listagem.informaCab('')
        listagem.informaCab('*----------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(_('| DESCRICAO                                                       |                                        VALOR |'))
        listagem.informaCab('*----------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab('')
        listagem.rodapePadrao()

        for x in linhas_dre:
            descricao = x.get('name') or ''
            if '<B>' in descricao:
                descricao = '*' + descricao.replace('<B>', '').upper() + '*'

            linha = ' '
            linha += formataString(descricao, 64, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(x.get('valor') or 0.0, 2), 45, ' ', 'E', 'N', 'S')
            linha += ' |'
            listagem.imprimeLinha('|'+linha)
        listagem.imprimeLinha('*----------------------------------------------------------------------------------------------------------------*')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

report_custom('report.listagem_dre')
