# -*- encoding: utf-8 -*-

import time
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
import StringIO
from openerp import pooler
from openerp.report.interface import report_int
from openerp.report.render import render
from openerp.osv import fields, osv
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class wizard_gerencial_listagem_orcamento(osv.TransientModel):
    _name = "wizard.gerencial.listagem.orcamento"
    _description = "Wizard de relatorio gerencial listade de orcamento"
    def get_ano(self, cr, uid, context=None):
        ano = time.localtime().tm_year
        context = context and context.copy() or {}
        return ano
    _columns = {
        'wizglo_company_id':  fields.many2one('res.company', 'Empresa', required=True),
        'wizglo_ano': fields.char('Ano', required=True),
        'wizglo_evento_natureza_id': fields.many2one('gerencial.evento.natureza', 'Natureza'),
        'wizglo_previsao': fields.boolean('Previsao'),
        'wizglo_valor_anterior': fields.boolean('% sobre valor anterior'),
        'wizglo_valor_grupo': fields.boolean('% sobre valor do grupo'),
        'wizglo_centro_custo_id': fields.many2one('adm.empresa.centrocusto', 'Centro de Custo'),

    }
    _defaults = {
        'wizglo_company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        'wizglo_ano': get_ano,
    }
    def wizglo_button_limpar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = {'wizglo_ano': '',
                'wizglo_evento_natureza_id': False,
                'wizglo_previsao': '',
                'wizglo_valor_anterior': '',
                'wizglo_valor_grupo': '',
                'wizglo_centro_custo_id': False,
                }
        self.write(cr, uid, ids, vals, context)
        return True

    def wizglo_button_imprimir(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        wizard_listagem_orcamento = self.browse(cr, uid, ids)
        datas = {}
        company = False
        nome_empresa = ""
        for x in wizard_listagem_orcamento:
            company_id = x.wizglo_company_id.id
            if not isinstance(company_id, list):
                company_id = [company_id]
            res_company_dados = self.pool.get("res.company").read(cr, uid, company_id, ['name'], context=context)
            for i in res_company_dados:
                nome_empresa = i.get('name')
            ano = x.wizglo_ano
            evento_natureza_id = x.wizglo_evento_natureza_id.id
            previsao = x.wizglo_previsao
            valor_anterior = x.wizglo_valor_anterior
            valor_grupo = x.wizglo_valor_grupo
            centro_custo_id = x.wizglo_centro_custo_id.id
            datas = {
                'company_id': company_id[0],
                'nome_empresa': nome_empresa,
                'ano': ano,
                'evento_natureza_id': evento_natureza_id,
                'previsao': previsao,
                'valor_anterior': valor_anterior,
                'valor_grupo': valor_grupo,
                'centro_custo_id': centro_custo_id,
            }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'relatorio.gerencial.listagem.orcamento',
            'datas': datas,
        }

class report_relatorio_gerencial_listagem_orcamento(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=100):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            if (T - len(C)) % 2 == 1:
                D = ' ' + D
            title += D
            return title
        context = context and context.copy() or {}
        pdf_file = StringIO.StringIO()
        company_id = datas.get('company_id')
        centro_custo_id = datas.get('centro_custo_id')
        nome_empresa = datas.get('nome_empresa')
        db_name = pooler.get_pool(cr.dbname)
        if centro_custo_id:
            centro_custo = formataString(db_name.get('adm.empresa.centrocusto').name_get(cr, uid, [centro_custo_id])[0][1], 50, ' ', 'C', 'N', 'S')
        else:
            centro_custo=''
        ano = datas.get('ano')
        listagem = Impressora()
        # listagem.defineFormato('A4',1)
        listagem.informaTamLinha(206)
        listagem.defineFonte(tam=6.5)
        listagem.defineMargem(0.5, 0.5, 0.25, 0.5)
        listagem.informaNome(pdf_file, _('Gerencial Listagem de Orcamento'))
        cab = center_title('|Fluxo de caixa', 'Orcamento de Caixa', 'Pag.:' + '{{ Page }}|', 216)

        listagem.informaCab('*------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(cab)
        listagem.informaCab('|                                                                                                                                                                                                            |')
        listagem.informaCab(center_title('|', nome_empresa, '|', 206))
        listagem.informaCab('|                                                                                                                                                                                                            |')
        listagem.informaCab(formataString(center_title('|Centro de custo: ' + str(centro_custo), '', ('Ano: ' + str(ano) + '|'), 206), 206, ' ', 'D', 'N', 'S'))
        listagem.informaCab('|============================================================================================================================================================================================================|')
        listagem.informaCab('|Grupo/Conta             |   Janeiro    |  Fevereiro   |    Marco     |     Abril    |     Maio     |     Junho    |     Julho    |    Agosto    |   Setembro   |   Outubro    |   Novembro   |   Dezembro   |')
        listagem.informaCab('|============================================================================================================================================================================================================|')
        listagem.informaCab('|                        |              |              |              |              |              |              |              |              |              |              |              |              |')
        listagem.rodapePadrao()

        sql_ano = ''' '''
        sql_centro_custo = ''' '''
        sql_natureza = ''' '''
        natureza_id = datas.get('evento_natureza_id')
        if natureza_id:
            sql_natureza = '''
                            AND gen.id = %s
                           ''' % natureza_id
        if ano:
            sql_ano = '''
                         AND gp.ano = '%s'
                      ''' % str(ano)
        if centro_custo_id:
            sql_centro_custo = '''
                         AND gp.centro_custo_id = %s
                      ''' % str(centro_custo_id)
        sql_previsao = '''
                         SELECT gp.evento_id,
                                gp.ano,
                                gp.mes,
                                gp.valor,
                                ge.evento_natureza_id
                         FROM gerencial_previsao              AS gp
                         INNER JOIN adm_empresa_centrocusto   AS aec ON aec.id = gp.centro_custo_id
                         INNER JOIN gerencial_evento          AS ge  ON ge.id = gp.evento_id
                         INNER JOIN gerencial_evento_natureza AS gen ON gen.id = ge.evento_natureza_id
                         WHERE aec.company_id = %s
                               %s
                               %s
                               %s
                        ORDER BY gp.mes, gen.name, ge.name
                        ''' % (company_id, sql_ano, sql_centro_custo, sql_natureza)
        cr.execute(sql_previsao)
        dados_previsao = cr.dictfetchall()
        if ano:
            sql_ano = '''
                          AND gm.ano_competencia = '%s'
                      ''' % str(ano)
        if centro_custo_id:
            sql_centro_custo = '''
                                  AND gm.centro_custo_id = %s
                               ''' % centro_custo_id
        if natureza_id:
            sql_natureza = '''
                              AND gen.id = %s
                           ''' % natureza_id
        sql_movimento = '''
                        SELECT gm.evento_id,
                               gm.fingmo_data AS data,
                               gm.valor,
                               ge.evento_natureza_id
                        FROM gerencial_movimento             AS gm
                        INNER JOIN adm_empresa_centrocusto   AS aec ON aec.id = gm.centro_custo_id
                        INNER JOIN gerencial_evento          AS ge  ON ge.id = gm.evento_id
                        INNER JOIN gerencial_evento_natureza AS gen ON gen.id = ge.evento_natureza_id
                        WHERE gm.company_id = %s
                              %s
                              %s
                              %s
                        ORDER BY gm.fingmo_data, gen.name, ge.name
                        ''' % (company_id, sql_ano, sql_centro_custo, sql_natureza)
        cr.execute(sql_movimento)
        dados_movimento = cr.dictfetchall()
        meses = {1:'jan', 2:'fev', 3:'mar',  4:'abr',  5:'mai',  6:'jun',
                 7:'jul', 8:'ago', 9:'sep', 10:'out', 11:'nov', 12:'dec'}
        aux = list(set(map(lambda x: x.get('evento_id'), dados_movimento)))
        aux += list(set(map(lambda x: x.get('evento_id'), dados_previsao)))
        evento_mov={}
        for i in aux:
            evento_mov[i]={}
        aux = list(set(map(lambda x: x.get('evento_natureza_id'), dados_movimento)))
        aux += list(set(map(lambda x: x.get('evento_natureza_id'), dados_previsao)))
        natureza_mov={}
        for i in aux:
            natureza_mov[i]={}
        # totais por evento
        for even in evento_mov:
            for mes in meses:
                evento_mov[even][meses.get(mes)] = {}
                evento_mov[even][meses.get(mes)]['movimento'] = sum(map(lambda x: x.get('valor')
                                                                        if x.get('evento_id') == even
                                                                        and int(x.get('data')[5:7]) == mes else 0.0,
                                                                        dados_movimento))
                if datas.get('previsao'):
                    evento_mov[even][meses.get(mes)]['previsao'] = sum(map(lambda x: x.get('valor')
                                                                            if x.get('evento_id') == even
                                                                            and int(x.get('mes')) == mes else 0.0,
                                                                            dados_previsao))
                natureza = map(lambda x: x.get('evento_natureza_id')
                                                            if x.get('evento_id') == even else 0, dados_movimento)
                natureza += map(lambda x: x.get('evento_natureza_id')
                                                            if x.get('evento_id') == even else 0, dados_previsao)
                natureza = list(set(natureza))
                if 0 in natureza:
                    natureza.remove(0)
                if natureza:
                    natureza=natureza[0]
                evento_mov[even]['natureza'] = natureza
        # totais por natureza
        for nat in natureza_mov:
            for mes in meses:
                natureza_mov[nat][meses.get(mes)] = {}
                natureza_mov[nat][meses.get(mes)]['movimento'] = sum(map(lambda x: x.get('valor')
                                                                         if x.get('evento_natureza_id') == nat
                                                                         and int(x.get('data')[5:7]) == mes else 0.0,
                                                                                                 dados_movimento))
                if datas.get('previsao'):
                    natureza_mov[nat][meses.get(mes)]['previsao'] = sum(map(lambda x: x.get('valor')
                                                                            if x.get('evento_natureza_id') == nat
                                                                            and int(x.get('mes')) == mes else 0.0,
                                                                            dados_previsao))
        # impressao
        for nat in natureza_mov:
            natureza_nome=''
            brw_evento_nat = db_name.get('gerencial.evento.natureza').browse(cr, uid, nat)
            if brw_evento_nat:
                natureza_nome = brw_evento_nat.name or ''
            natureza_nome = 'G-' + formataString(natureza_nome, 22, ' ', 'D', 'N', 'S')
            linha = '|'
            linha += natureza_nome + '|              |              |              |              |              |              |              |              |              |              |              |              |'
            listagem.imprimeLinha(linha)
            linha_prev = '|            '
            linha_prev += formataString('Prevista', 11, ' ', 'E', 'N', 'S') + ' |'
            linha = '|            '
            linha += formataString('Realizada', 11, ' ', 'E', 'N', 'S') + ' |'
            linha_ant = '|'
            linha_ant += formataString('', 12, ' ', 'D', 'N', 'S') + formataString('%Sobre Ant.', 11, ' ', 'E', 'N', 'S') + ' |'
            for i in range(1, 13):
                # previsao
                if datas.get('previsao'):
                    total = getNumeroEditado(natureza_mov.get(nat).get(meses.get(i)).get('previsao'), 2)
                    linha_prev += formataString(total, 14, ' ', 'E', 'N', 'S') + '|'
                # realizada
                total = getNumeroEditado(natureza_mov.get(nat).get(meses.get(i)).get('movimento'), 2)
                linha += formataString(total, 14, ' ', 'E', 'N', 'S') + '|'
                # % sobre valor anterior
                if datas.get('valor_anterior'):
                    if i != 1:
                        total_ant = natureza_mov.get(nat).get(meses.get(i-1)).get('movimento')
                        total = natureza_mov.get(nat).get(meses.get(i)).get('movimento')
                        if total_ant != 0:
                            percentual = ((total-total_ant)/total_ant)*100
                        else:
                            percentual = 0
                        linha_ant += formataString(getNumeroEditado(percentual, 2), 14, ' ', 'E', 'N', 'S') + '|'
                    else:
                        linha_ant += formataString(getNumeroEditado(0, 2), 14, ' ', 'E', 'N', 'S') + '|'
            if datas.get('previsao'):
                listagem.imprimeLinha(linha_prev)
            listagem.imprimeLinha(linha)
            if datas.get('valor_anterior'):
                listagem.imprimeLinha(linha_ant)
            linha = '*------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*'
            listagem.imprimeLinha(linha)

            # contas da natureza(evento)
            for even in evento_mov:
                if evento_mov.get(even).get('natureza') == nat:
                    evento_nome = db_name.get('gerencial.evento').name_get(cr, uid, [even])[0][1] or ''
                    evento_nome = 'C-' + formataString(evento_nome, 22, ' ', 'D', 'N', 'S')
                    linha = '|'
                    linha += evento_nome + '|              |              |              |              |              |              |              |              |              |              |              |              |'
                    listagem.imprimeLinha(linha)
                    linha_prev = '|            '
                    linha_prev += formataString('Prevista', 11, ' ', 'E', 'N', 'S') + ' |'
                    linha = '|            '
                    linha += formataString('Realizada', 11, ' ', 'E', 'N', 'S') + ' |'
                    linha_ant = '|'
                    linha_ant += formataString('', 12, ' ', 'D', 'N', 'S') + formataString('%Sobre Ant.', 11, ' ', 'E', 'N', 'S') + ' |'
                    linha_grup = '|'
                    linha_grup += formataString('', 12, ' ', 'D', 'N', 'S') + formataString('%Sobre Grp.', 11, ' ', 'E', 'N', 'S') + ' |'
                    for i in range(1, 13):
                        # previsao
                        if datas.get('previsao'):
                            total = getNumeroEditado(evento_mov.get(even).get(meses.get(i)).get('previsao'), 2)
                            linha_prev += formataString(total, 14, ' ', 'E', 'N', 'S') + '|'
                        # realizada
                        total = getNumeroEditado(evento_mov.get(even).get(meses.get(i)).get('movimento'), 2)
                        linha += formataString(total, 14, ' ', 'E', 'N', 'S') + '|'
                        # % sobre valor anterior
                        if datas.get('valor_anterior'):
                            if i != 1:
                                total_ant = evento_mov.get(even).get(meses.get(i-1)).get('movimento')
                                total = evento_mov.get(even).get(meses.get(i)).get('movimento')
                                if total_ant != 0:
                                    percentual = ((total-total_ant)/total_ant)*100
                                else:
                                    percentual = 0
                                linha_ant += formataString(getNumeroEditado(percentual, 2), 14, ' ', 'E', 'N', 'S') + '|'
                            else:
                                linha_ant += formataString(getNumeroEditado(0, 2), 14, ' ', 'E', 'N', 'S') + '|'
                        # % sobre valor do grupo
                        if datas.get('valor_grupo'):
                            total_grupo = natureza_mov.get(nat).get(meses.get(i)).get('movimento')
                            total = evento_mov.get(even).get(meses.get(i)).get('movimento')
                            if total_grupo != 0:
                                percentual = (total/total_grupo)*100
                            else:
                                percentual = 0
                            linha_grup += formataString(getNumeroEditado(percentual,2), 14, ' ', 'E', 'N', 'S') + '|'

                    if datas.get('previsao'):
                        listagem.imprimeLinha(linha_prev)
                    listagem.imprimeLinha(linha)
                    if datas.get('valor_anterior'):
                        listagem.imprimeLinha(linha_ant)
                    if datas.get('valor_grupo'):
                        listagem.imprimeLinha(linha_grup)
                    linha = '*------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*'
                    listagem.imprimeLinha(linha)

        listagem.imprimeLinha(' ')
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_file.getvalue())
        self.obj.render()
        pdf_file.close()
        return (self.obj.pdf, 'pdf')

report_relatorio_gerencial_listagem_orcamento('report.relatorio.gerencial.listagem.orcamento')

