# -*- coding: utf-8 -*-

__author__ = 'felipe.franca'

import time
from openerp.osv import fields, osv
from openerp.tools.translate import _
from datetime import datetime
from SigUtils.numero import getNumeroEditado


class wizard_gerencial_receita_despesas(osv.TransientModel):
    _name = 'wizard.gerencial.receita.despesas'
    _description = 'Relatorio gerencial receitas e despesas.'

    _columns = {
        'name': fields.text('Descricao'),
        'wizgrd_data_ini': fields.date('Data inicial', required=True),
        'wizgrd_data_fim': fields.date('Data final', required=True),
        'wizgrd_centro_custo_id': fields.many2one('adm.empresa.centrocusto', 'Centro de Custo'),
        'wizgrd_tipo': fields.selection([('A', _('Analitico')),
                                         ('S', _('Sintetico'))], 'Tipo', required=True),
    }

    _defaults = {
        'name': 'Listagem de receitas e despesas'
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        estrutura, dados = self.get_dados_rel(cr, uid, ids, context)
        context['estrutura'] = estrutura
        context['dados'] = dados
        return self.pool.get('wizard.relatorios.impressao').get_tela_relatorios(cr, uid, context)

    def get_dados_rel(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        pagina = {'relpag_nome_rel': _('Relatorio gerencial Receitas e Despesas.'),
                  'relpag_tam_linha': 177,
                  'relpag_fonte_tamanho': 8.2,
                  'relpag_margem_esquerda': 0.5,
                  'relpag_margem_direita': 0.5,
                  'relpag_cabecalhos': [{'relcab_name': 'cab1',
                                         'relcab_colunas': [{'relcol_name': 'data',
                                                             'relcol_dados_tam': 14},
                                                            {'relcol_name': 'titulo',
                                                             'relcol_dados_tam': 152,
                                                             'relcol_dados_alinhamento': 'C'},
                                                            {'relcol_name': 'pagina',
                                                             'relcol_dados_tam': 9}]},
                                        {'relcab_name': 'cab2',
                                         'relcab_divide_linha': True,
                                         'relcab_colunas': [{'relcol_name': 'empresa',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 177,}],},
                                        {'relcab_name': 'cab3',
                                         'relcab_colunas': [{'relcol_name': 'data_ini',
                                                             'relcol_dados_tam': 14},
                                                            {'relcol_name': 'valor_data_ini',
                                                             'relcol_dados_alinhamento': 'D',
                                                             'relcol_dados_tam': 12},
                                                            {'relcol_name': 'data_fim',
                                                             'relcol_dados_tam': 12},
                                                            {'relcol_name': 'valor_data_fim',
                                                             'relcol_dados_alinhamento': 'D',
                                                             'relcol_dados_tam': 12},]
                                         },
                                        {'relcab_name': 'cab4',
                                         'relcab_colunas': [{'relcol_name': 'centro_custo',
                                                             'relcol_dados_tam': 17},
                                                            {'relcol_name': 'valor_centro_custo',
                                                             'relcol_dados_tam': 40},]
                                         },
                                        {'relcab_name': 'cab5',
                                         'relcab_divide_linha': True,
                                         'relcab_colunas': [{'relcol_name': 'tipo',
                                                             'relcol_dados_tam': 6},
                                                            {'relcol_name': 'valor_tipo',
                                                             'relcol_dados_tam': 9},]
                                         },
                                        {'relcab_name': 'cab6',
                                         'relcab_divide_linha': True,
                                         'relcab_separa_coluna': '|',
                                         'relcab_colunas': [{'relcol_name': 'col1',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 35},
                                                            {'relcol_name': 'col2',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 100},
                                                            {'relcol_name': 'col3',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 12},
                                                            {'relcol_name': 'col4',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 12},
                                                            {'relcol_name': 'col5',
                                                             'relcol_dados_alinhamento': 'C',
                                                             'relcol_dados_tam': 12},]
                                         },],
                  'relpag_linhas': [{'rellin_name': 'linha1',
                                     'rellin_separa_coluna': '|',
                                     'rellin_colunas': [{'relcol_name': 'evento',
                                                         'relcol_dados_tam': 35},
                                                        {'relcol_name': 'historico',
                                                         'relcol_dados_tam': 100},
                                                        {'relcol_name': 'data',
                                                         'relcol_dados_alinhamento': 'C',
                                                         'relcol_dados_tam': 12},
                                                        {'relcol_name': 'receitas',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 12},
                                                        {'relcol_name': 'despesas',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 12},]
                                     },
                                    {'rellin_name': 'linha2',
                                     'rellin_colunas': [{'relcol_name': 'linha',
                                                         'relcol_dados_tam': 177},
                                                        ],
                                     },
                                    {'rellin_name': 'linha3',
                                     'rellin_separa_coluna': '|',
                                     'rellin_colunas': [{'relcol_name': 'total',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 149},
                                                        {'relcol_name': 'vr_total_receitas',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 12},
                                                        {'relcol_name': 'vr_total_despesas',
                                                         'relcol_dados_alinhamento': 'E',
                                                         'relcol_dados_tam': 12},
                                                        ],
                                     },
                                    ],
                  }

        filtros = self.read(cr, uid, ids[0], [], context=context)
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, context=context)
        nome_empresa = self.pool.get("res.company").read(cr, uid, company_id, ['name'],
                                                         context=context).get('name')
        linhas = self.get_linhas(cr, uid, filtros, company_id, context=context)
        data_ini = datetime.strptime(filtros.get('wizgrd_data_ini'), '%Y-%m-%d').strftime('%d/%m/%Y')
        data_fim = datetime.strptime(filtros.get('wizgrd_data_fim'), '%Y-%m-%d').strftime('%d/%m/%Y')
        cc = ''
        if filtros.get('wizgrd_centro_custo_id'):
            cc = filtros.get('wizgrd_centro_custo_id')[1]
        dados = {'cab1': {'data': _('Data: ') + time.strftime('%d/%m/%Y'),
                          'titulo': _("Listagem de Categorias"),
                          'pagina': '|pag|'},
                 'cab2': {'empresa': nome_empresa},
                 'cab3': {'data_ini': _('Data Inicial:'),
                          'valor_data_ini': data_ini,
                          'data_fim': _('Data Final:'),
                          'valor_data_fim': data_fim},
                 'cab4': {'centro_custo': _('Centro de Custo:'),
                          'valor_centro_custo': cc},
                 'cab5': {'tipo': _('Tipo:'),
                          'valor_tipo': {'A': _('Analitico'),
                                         'S': _('Sintetico')}.get(filtros.get('wizgrd_tipo')),},
                 'cab6': {'col1': _('Evento'),
                          'col2': _('Historico'),
                          'col3': _('Data'),
                          'col4': _('Receitas'),
                          'col5': _('Despesas'),
                          },
                'linhas': linhas,
                 }

        return pagina, dados

    def get_linhas(self, cr, uid, filtros, company_id, context=None):
        context = context and context.copy() or {}
        cp_ids = map(lambda x: '%s' % x,
                     self.pool.get('res.company').search(cr, uid,
                                          [('parent_id', 'child_of', company_id)], context=context))
        cond_cc = ''
        if filtros.get('wizgrd_centro_custo_id'):
            cond_cc = 'AND gm.centro_custo_id = %s' % filtros.get('wizgrd_centro_custo_id')[0]

        campo1 = 'gm.fingmo_historico AS historico,'
        campo2 = 'gm.valor            AS valor'
        group = ''
        if filtros.get('wizgrd_tipo') == 'S':
            campo1 = ''
            campo2 = 'SUM(gm.valor)       AS valor'
            group = 'GROUP BY ge.id, gm.fingmo_data, ge.name, gm.fingmo_operacao'

        cr.execute("""
            SELECT gm.fingmo_data      AS data,
                   {campo1}
                   gm.fingmo_operacao  AS tipo,
                   ge.id               AS evento_id,
                   ge.name             AS evento,
                   {campo2}
                   
            FROM gerencial_movimento             AS gm
            INNER JOIN gerencial_evento          AS ge  ON ge.id = gm.evento_id
            INNER JOIN gerencial_evento_natureza AS gen ON gen.id = ge.evento_natureza_id            
            WHERE gm.fingmo_data >= '{ini}'
              AND gm.fingmo_data <= '{fim}'
              {cond}
              AND (gen.name ILIKE '%receita%' OR gen.name ILIKE '%despesa%')
              AND gm.company_id in ({company_ids})
            {group}
            ORDER BY gm.fingmo_data, ge.name 
                   """.format(campo1=campo1,
                              campo2=campo2,
                              ini=filtros.get('wizgrd_data_ini'),
                              fim=filtros.get('wizgrd_data_fim'),
                              cond=cond_cc,
                              group=group,
                              company_ids=','.join(cp_ids))
                   )
        res = []
        dados = cr.dictfetchall()
        if not dados:
            raise osv.except_osv(_('Atencao!'),
                                 _('Nenhum registro encontrado para os filtros selecionados!'))
        evento_ids = map(lambda x: x.get('evento_id'), dados)
        dict_evento = {}
        map(lambda x: dict_evento.update({x.get('id'): x}),
            self.pool.get('gerencial.evento').read(cr, uid, evento_ids, ['codigo'], context=context))

        totais = {'r': 0, 'd': 0}
        if filtros.get('wizgrd_tipo') == 'A':
            for i in dados:
                data = datetime.strptime(i.get('data'), '%Y-%m-%d').strftime('%d/%m/%Y')
                receita = despesa = 0
                if i.pop('tipo') == 'E':
                    receita = i.pop('valor')
                else:
                    despesa = i.pop('valor')
                res.append({'linha1': {'evento': dict_evento.get(i.get('evento_id')).get('codigo') + '-' + i.get('evento'),
                                       'historico': i.get('historico'),
                                       'data': data,
                                       'receitas': getNumeroEditado(receita, 2),
                                       'despesas': getNumeroEditado(despesa, 2),}
                                 })
                totais['r'] += receita
                totais['d'] += despesa
        else:  # Sintetico
            for i in dados:
                receita = despesa = 0
                if i.get('tipo') == 'E':
                    receita = i.pop('valor')
                else:
                    despesa = i.pop('valor')

                eve_id = i.get('evento_id')
                dict_evento[eve_id].update(i)
                if not dict_evento.get(eve_id).get('receita'):
                    dict_evento[eve_id]['receita'] = receita
                else:
                    dict_evento[eve_id]['receita'] += receita

                if not dict_evento.get(eve_id).get('despesa'):
                    dict_evento[eve_id]['despesa'] = despesa
                else:
                    dict_evento[eve_id]['despesa'] += despesa

            for i, j in dict_evento.items():
                receita = dict_evento[i]['receita']
                despesa = dict_evento[i]['despesa']
                res.append({'linha1': {
                    'evento': dict_evento.get(i).get('codigo') + '-' + j.get('evento'),
                    'historico': j.get('historico'),
                    'data': '',
                    'receitas': getNumeroEditado(receita, 2),
                    'despesas': getNumeroEditado(despesa, 2),}
                            })
                totais['r'] += receita
                totais['d'] += despesa

        if res:
            res.extend([{'linha2': {'linha': '*' + ''.ljust(175,'-') + '*',}
                        },
                        {'linha3': {'total': _('Totais'),
                                    'vr_total_receitas': getNumeroEditado(totais.get('r') or 0, 2),
                                    'vr_total_despesas': getNumeroEditado(totais.get('d') or 0, 2),
                                    }
                        }]
                       )

        return res


