# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class financeiro_cheque_devolucao(osv.Model):
    """
    Tabela de controle de cheques devolvidos
    Previxo: finchd
    """
    from funcoes import finchd_conta_devolucao

    _name = 'financeiro.cheque.devolucao'
    _columns = {
        'cheque_id': fields.many2one("financeiro.titulo", 'Cheque', ondelete="cascade", required=True, select=True),
        'data_devolucao': fields.date('Data devolucao', required=True), # data de devolucao do cheque
        'motivo_devol_id': fields.many2one("financeiro.cheque.motivo.devolucao", 'Motivo', ondelete="restrict",
                                           required=True, select=True), # Motivo de devolucao do cheque
        'observacao': fields.text('Observacoes'), # observacoes
        'quant_devolucao': fields.function(finchd_conta_devolucao, method=True, string='Quant. Devolucoes',
                                           type='integer', store=True)
    }


