# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import fineme_get_mensagem
from funcoes import fineme_get_state


class financeiro_emails_mensagens(osv.Model):
    # prefixo: fineme_

    _name = 'financeiro.emails.mensagens'
    _columns = {
        'create_date': fields.datetime('Data', readonly=True),
        'fineme_texto_id': fields.many2one('financeiro.emails.cadastro', 'Mensagem', required=True,
                                           select=True),
        'create_uid': fields.many2one('res.users', 'Usuario', readonly=True),
        'fineme_pessoa_id': fields.many2one('adm.pessoa', 'Cliente', required=True, select=True),
        'fineme_titulo_ids': fields.many2many(
            'financeiro.titulo', 'financeiro_mensagens_m2m_titulos', 'mensagem_id', 'titulo_id',
            'Titulos'),
        'fineme_assunto': fields.function(fineme_get_mensagem, method=True, string='Assunto',
                                          size=64, type='char', multi='email'),
        'fineme_texto': fields.function(fineme_get_mensagem, method=True, string='Texto do e-mail',
                                        type='text', multi='email'),
        'fineme_email_carta': fields.selection([('E', 'E-mail'), ('C', 'Carta')], 'Tipo mensagem',
                                               size=1),
        'fineme_mail_id': fields.many2one('mail.mail', 'E-mail'),
        'state': fields.function(fineme_get_state, method=True, string='Estado', type='char',
                                 size=15, store=False),
    }
