# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class financeiro_fatura(osv.Model):
    """
    Tabela de faturas
    """
    from funcoes import finfat_get_dados
    from funcoes import finfat_gerar_centro_custo_evento

    _name = 'financeiro.fatura'
    _rec_name = 'documento'
    _order = 'data_emissao desc'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True), # Id da empresa
        'documento': fields.char('Documento', size=30, required=False, select=True), # Numero do documento.
        'pessoa_id': fields.many2one("adm.pessoa", 'Cliente/Fornecedor', ondelete="restrict", required=True,
                                     select=True), # Id do parceiro(cliente/Fornecedor)
        'tipo_fatura': fields.selection([('R', 'Receber'), ('P', 'Pagar')], 'Tipo fatura', required=True, size=1),
        'data_emissao': fields.date('Data emissao', required=True), # data de emissao do titulo
        'qtd_parcelas': fields.function(finfat_get_dados, method=True, string='Quantidade de Parcelas',
                                        type='integer', store=False, multi='dados_fatura'), # Quantidade de parcelas desta fatura.
        'valor': fields.function(finfat_get_dados, method=True, string='Valor', type='float', store=False,
                                 multi='dados_fatura'), # valor total da fatura
        'titulo_ids': fields.one2many('financeiro.titulo', 'fatura_id', 'Parcelas'),
        # Relacao das parcelas de uma fatura
        'cancelada': fields.boolean('Cancelada'),
        'finfat_documento_tipo_id': fields.many2one('documento.documento.tipo', 'Tipo de documento'),
        'finfat_competencia_por_parcelas': fields.boolean('Competencia e emissao por parcelas'),
        'finfat_gera_centro_custo_evento': fields.function(
            finfat_gerar_centro_custo_evento, method=True, string='Gera centro de custos e eventos',
            type='boolean', store=False),
        'finfat_renegociacao_titulo_ids': fields.many2many(
            'financeiro.titulo', 'fatura_renegociacao_titulo', 'fatura_id', 'titulo_id'),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        'cancelada': False,
    }


