# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import _finloc_name_get


class financeiro_local_cobranca(osv.Model):
    """
    Tabela de locais de cobranca
    Prefixo: finloc
    """

    _name = 'financeiro.local.cobranca'
    _columns = {
        'company_id': fields.many2one('res.company', 'Empresa', ondelete="cascade", required=True, select=True),
        'tipo': fields.selection([('B', 'Banco'), ('C', 'Carteira')], 'Tipo', required=True, size=1),
        'descricao': fields.char('Descricao', size=20, required=True), # Descricao do local de cobranca
        'active': fields.boolean('Ativo'), # Indica se o local de cobranca esta ativo
        'titulo_ids': fields.one2many('financeiro.titulo', 'local_cobranca_id', 'Titulo'),
        # 'titulo_movimento_ids': fields.one2many('financeiro.titulo.movimento', 'local_cobranca_id', 'Movimento'),
        'id': fields.integer('Nro', readonly=True),
        'name': fields.function(_finloc_name_get, method=True, string='Name', type='char', size=26, store=False),
        'finloc_conta_id': fields.many2one("financeiro.tesouraria.contas", 'Conta do financeiro', select=True,
                                           ondelete="restrict", oldname='conta_id',
                                           domain="[('company_id', '=', company_id)]"), # Conta financeira do movimento.
        'finloc_banco_id': fields.many2one('adm.banco', 'Banco'),
        'finloc_local_natureza_ids': fields.one2many('financeiro.local.natureza', 'finlon_local_cobranca_id',
                                                     'Naturezas'),
    }
    _defaults = {
        'active': lambda *a: True,
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }

