# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class financeiro_natureza_cobranca(osv.Model):
    """
    Tabela de natureza de cobranca
    """
    _name = 'financeiro.natureza.cobranca'
    _columns = {
        'name': fields.char('Descricao', size=30, required=True), # Descricao da natureza
        'recebimento_antecipado': fields.boolean('Recebimento antecipado',
                                                 help="Se marcado, informa que o titulo foi negociado e no seu vencimento o valor nao estara mais disponivel!"),
        # Flag que indica se os documentos que tem esta natureza entram no fluxo de caixa.Ex.Duplicatas descontadas nao entram.
        'titulo_ids': fields.one2many('financeiro.titulo', 'natureza_cobranca_id', 'Titulo'),
        # relacao de titulos registrados em uma natureza de cobranca
    }
    _defaults = {
        'recebimento_antecipado': lambda *a: False,
    }


