# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class financeiro_operacoes(osv.Model):

    _name = 'financeiro.operacoes'

    _columns = {
        'company_id': fields.many2one('res.company', 'Empresa', required=True),
        'finope_codigo': fields.integer('Codigo', required=True),
        'name': fields.char('Descricao', size=64, required=True),
        'finope_centro_custo_id': fields.many2one('adm.empresa.centrocusto', 'Centro de custo'),
        'finope_evento_id': fields.many2one('gerencial.evento', 'Evento'),
    }

    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }
    _sql_constraints = [
        ('codigo_uniq', 'unique (finope_codigo, company_id)', 'O codigo precisa ser unico para a empresa'),
    ]
