# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import fields
from openerp.osv import osv


class financeiro_titulo_baixa_view(osv.Model):
    _name = "financeiro.titulo.baixa.view"
    _description = "Titulos liquidados"
    _auto = False
    _columns = {'id': fields.integer('id'),
                'company_id': fields.many2one("res.company", 'Empresa'), # Id da empresa
                'tipo_titulo': fields.selection([('R', 'Receber'), ('P', 'Pagar')], 'Tipo titulo', size=1),
                'local_cobranca_id': fields.many2one("financeiro.local.cobranca", 'Local cobranca',
                                                     domain="[('company_id', '=', company_id)]"),
                'natureza_cobranca_id': fields.many2one("financeiro.natureza.cobranca", 'Natureza cobranca'),
                'pessoa_id': fields.many2one("adm.pessoa", 'Cliente'), # Id do parceiro(cliente/Fornecedor)
                'documento': fields.char('Documento', size=30), # Numero do documento.
                'parcela': fields.integer('Parcela'), # Numero da parcela do documento.
                'data_emissao': fields.date('Data emissao'), # data de emissao do titulo
                'doc_tipo_id': fields.many2one("documento.documento.tipo", 'Tipo de documento'),
                'nosso_numero': fields.char('Nosso numero', size=20), # Numero do boleto (nosso numero).
                'state': fields.selection([('A', 'Em aberto'), ('B', 'Baixado'), ('C', 'Cancelado')], 'Situacao',
                                          required=True, readonly=True, size=1),
                'data_prorrogacao': fields.date('Data prorrogacao'),
                'vr_original': fields.float('Valor original', digits=(15, 2)),
                'data_baixa': fields.date('Data baixa'), # Data da baixa na empresa.
                'data_pgto': fields.char('Data pgto', size=45), # Data do pagamento efetuado pelo sacado.
                'valor_pago': fields.float('Valor Pago', digits=(15, 2)),
                'valor_juros': fields.float('Valor Juros', digits=(5, 2)),
                'valor_multa': fields.float('Valor Multa', digits=(5, 2)),
                'valor_desconto': fields.float('Valor Desconto', digits=(5, 2)),
                'valor_acrescimo': fields.float('Valor acrescimo', digits=(15, 2)),
                'taxa_adm': fields.float('Taxa de administracao', digits=(15, 2)),
                # Valor cobrado pela administradora do cartao, a ser deduzida do valor do titulo na baixa do documento.
                'codigo': fields.integer('Codigo'), # codigo para identificacao da pessoa
                'nome_pessoa': fields.char('Nome', size=50), # Nome da pessoa
                'titulo_id': fields.many2one("financeiro.titulo", 'Titulo'),
    }

