# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from funcoes import fintib_get_tipo_titulo


class financeiro_titulo_boleto(osv.Model):
    # prefixo: fintib_

    _name = 'financeiro.titulo.boleto'
    _rec_name = 'fintib_nosso_numero'
    _inherits = {
        'financeiro.titulo': 'fintib_titulo_id',
    }
    _columns = {
        'id': fields.integer('Id', readonly=True),
        'fintib_titulo_id': fields.many2one('financeiro.titulo', 'Titulo', select=True,
                                            required=True, ondelete='cascade'),
        'fintib_nosso_numero': fields.char('Nosso numero', size=20, select=True),
        'fintib_codigo_barras': fields.char('Codigo de barras', size=48),
        'fintib_local_cobranca_id': fields.many2one('financeiro.local.cobranca',
                                                    'Local de cobranca', required=True),
        'fintib_natureza_cobranca_id': fields.many2one(
            "financeiro.natureza.cobranca", 'Natureza cobranca', ondelete="restrict", select=True,
            required=False),
        'create_date': fields.datetime('Data da criacao', readonly=True),
        'create_uid': fields.many2one('res.users', 'Usuario', readonly=True),
        'state': fields.selection([('A', 'Ativo'), ('I', 'Inativo')], 'Situacao', required=True, size=1),
        'fintib_boleto_impresso': fields.boolean('Boleto impresso'),
        'fintib_tipo_titulo': fields.function(fintib_get_tipo_titulo, method=True,
                                              string='Tipo titulo', type='char', size=1),
    }
    _order = 'fintib_titulo_id,id desc'
    _defaults = {
        'state': 'A',
        'fintib_boleto_impresso': False,
    }
