# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import fields
from openerp.osv import osv
from openerp.tools.sql import drop_view_if_exists
from openerp.tools.translate import _


class financeiro_titulo_historico(osv.Model):
    """
    Tabela com a historico da movimentacao fisica do documento.
    """
    _name = 'financeiro.titulo.historico'
    _columns = {
        'id': fields.integer('Id'),
        'create_uid': fields.many2one('res.users', 'Usuario', readonly=True, ondelete="restrict"),
        'create_date': fields.datetime('Data historico', readonly=True), #Data que ocorreu o historico
        'titulo_id': fields.many2one("financeiro.titulo", 'Titulo', ondelete="cascade", required=True, select=True),
        'local_cobranca_id': fields.many2one("financeiro.local.cobranca", 'Local cobranca', ondelete="restrict",
                                             select=True), # id do local de cobranca
        'natureza_cobranca_id': fields.many2one("financeiro.natureza.cobranca", 'Natureza', ondelete="restrict",
                                                select=True), # id da natureza de cobranca
        'data_prorrogacao': fields.date('Prorrogacao'), #Data de prorrogacao do titulo
        'tipo_titulo': fields.char('Tipo', size=1),
        'operacao': fields.selection(
            [('I', 'Entrada'), ('A', 'Alteracao'), ('R', 'Registro'), ('B', 'Baixa'),
             ('BP', 'Baixa Parcial'), ('PR', 'Prorrogacao'), ('C', 'Cancelamento'),
             ('TR', 'Transformacao'), ('BR', 'Baixa por Renegociacao'), ('EB', 'Estorno de Baixa')],
            'Operacao', required=True,
            size=2),
        # Operacao ocorrida em financeiro_titulo. \nI=Inclusao, \nA=Alteracao, \nE=Exclusao
    }
    _order = 'id desc'

