# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler


class financeiro_fornecedor(osv.Model):
    """
    Tabela de fornecedores

    prefixo: finfor
    """

    from funcoes import _finfor_nome_fornecedor

    _name = 'financeiro.fornecedor'
    _rec_name = 'pessoa_id'
    _inherits = {
        'adm.pessoa': 'pessoa_id',
    }
    _roteavel = True
    _rec_name = 'pessoa_id'
    _columns = {
        'id': fields.integer('Id'),
        'pessoa_id': fields.many2one("adm.pessoa", 'Pessoa', ondelete="cascade", required=True,
                                     select=True), # id da pessoa
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True), # Codigo de identificacao da empresa
        'active': fields.boolean('Ativo'), # Flag que indica que o fornecedor esta ativo
        'frete': fields.selection([('C', 'CIF'), ('F', 'FOB')], 'Frete', size=1),
        'representante_ids': fields.one2many('financeiro.representante', 'fornecedor_id', 'Representantes'),
    }
    _order = 'company_id, pessoa_id'
    _defaults = {
        'active': lambda *a: True,
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        'pessoa_tipo': lambda *a: 'J',
    }

    _sql_constraints = [
        ('fornecedor_empresa_uniq', 'unique(pessoa_id,company_id)', 'O fornecedor deve ser unico!' )
    ]


