# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from datetime import date, datetime, timedelta
import time
from openerp.tools.translate import _
from dateutil.parser import parse
from SigUtils import datas
from calendar import isleap



#Funcoes da classe financeiro_fatura
def finfat_get_dados(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    map(lambda x: res.update({x: {'valor': 0,
                                  'qtd_parcelas': 0}
                             }), ids)
    o_titulo = self.pool.get('financeiro.titulo')
    titulo_ids = o_titulo.search(cr, uid, [('fatura_id', 'in', ids)], context=context)
    for titulo in o_titulo.read(cr, uid, titulo_ids, ['vr_original', 'fatura_id'], context=context,
                                load='_classic_write'):
        res[titulo.get('fatura_id')]['valor'] += titulo.get('vr_original') or 0
        res[titulo.get('fatura_id')]['qtd_parcelas'] += 1

    return res

def finfat_gerar_centro_custo_evento(self, cr, uid, ids, field_name, args, context=None):
    """
    Funcao de campo funcional (function). Verifica nos parametros do financeiro se a empresa usa
    centro de custos e eventos.
    :param cr: cursor no banco de dados
    :param uid: id da tabela res_users, identificador do usuario
    :param ids: lista de id da tabela financeiro_fatura
    :param field_name: string com o nome do campo
    :param args: lista de argumentos de pesquisa
    :param context: didcionario com valores contextuais
    :return: dicionario. Para cada chave um id, da lista recebida como parametro (ids), e seu valor
    um booleano com: - True, usa centro de custos e eventos / - False, nao usa centro de custos e
    eventos
    """
    context = context and context.copy() or {}
    res = {}
    financeiro_parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(
        cr, uid, 'financeiro', 'usar_centro_custos_e_eventos', context=context)
    usa_centro_custo_evento = financeiro_parametro_dados.get('usar_centro_custos_e_eventos')
    map(lambda i: res.update({i.id: usa_centro_custo_evento}), self.browse(cr, uid, ids, context=context))
    return res


# funcoes da classe financeiro_cheque_devolucao
def finchd_conta_devolucao(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    chq_id = self.pool.get('financeiro.cheque.devolucao').read(cr, uid, ids, ['cheque_id'], context=context)[0]['cheque_id'][0]
    id_s = self.pool.get('financeiro.cheque.devolucao').search(cr, uid, [('cheque_id', '=', chq_id)], context=context)
    for a in self.pool.get('financeiro.cheque.devolucao').browse(cr, uid, id_s):
        res[a.id] = len(id_s)
    return res

def fincli_get_bloqueio(self, cr, uid, ids, context=None):
    '''
    Retorna um dicionario onde a chave eh o id do cliente e o valor eh uma mensagem sobre
    o status do cliente
    :param cr:
    :param uid:
    :param ids: ids dos clientes
    :param context:
    :return: dict
    '''
    context = context and context.copy() or {}
    obj_financeiro_titulo = self.pool.get('financeiro.titulo')
    obj_adm_utils = self.pool.get('adm.utils')
    res = {}
    obj_financeiro_utils = self.pool.get('financeiro')
    list_parametro = ['verificar_limite_credito']
    financeiro_parametro_dados = obj_adm_utils.admutl_get_parametros(
        cr, uid, 'financeiro', list_parametro, context=context)
    verifica_limite_credito = financeiro_parametro_dados.get('verificar_limite_credito')
    financeiro_cli_dados = self.pool.get('financeiro.cliente').read(
        cr, uid, ids, ['pessoa_id'], context=context, load='_classic_write')
    cliente_id_pessoa_id = {}
    pessoas_ids = []
    map(lambda x: (cliente_id_pessoa_id.update({x.get('id'): x.get('pessoa_id')}),
                   pessoas_ids.append(x.get('pessoa_id'))),
        financeiro_cli_dados)
    bloqueado_por_mensagem = {}
    bloqueado_por_credito = {}
    obj_venda_utils = self.pool.get('vendas.utils')
    # se tiver 'vendas' instalado
    if obj_venda_utils:
        cliente_limite_credito = obj_venda_utils.venutl_get_limite_credito_cliente(
                cr, uid, [], cliente_ids=ids, context=context).get('cliente_ids') if \
            verifica_limite_credito else dict()
        totais_em_aberto = obj_financeiro_titulo.fintit_get_total_em_aberto(
            cr, uid, pessoas_ids, tipo_titulo='R', context=context)
        for cliente_id in cliente_limite_credito:
            pessoa_id = cliente_id_pessoa_id.get(cliente_id)
            cliente_debito = totais_em_aberto.get(pessoa_id) or 0.0
            if cliente_debito > cliente_limite_credito.get(cliente_id):
                bloqueado_por_credito[cliente_id] = True

        #BLOQUEADO POR MENSAGEM
        bloqueado_por_mensagem = obj_venda_utils.venutl_cliente_bloqueado_por_msg(cr, uid, [],
                                                cliente_ids=ids, context=context).get('cliente_ids')

    titulos_em_atraso = obj_financeiro_utils.finutl_get_valor_em_atraso(cr, uid,
                                                     venutl_pessoa_ids=pessoas_ids, context=context)
    for i in financeiro_cli_dados:
        pessoa_id = i.get('pessoa_id') or False
        titulo_em_atraso = titulos_em_atraso.get(pessoa_id) or 0
        cliente_com_restricoes = any([titulo_em_atraso, bloqueado_por_mensagem.get(i['id']),
                                      bloqueado_por_credito.get(i['id'])])
        res[i['id']] = 'L'
        if cliente_com_restricoes:
            if bloqueado_por_mensagem.get(i['id']):
                res[i['id']] = 'B1'
            if titulo_em_atraso > 0:
                res[i['id']] = 'B2'
            if bloqueado_por_credito.get(i['id']):
                res[i['id']] = 'B3'
    return res

#Funcoes da classe financeiro_cliente
def _fincli_verificar_status_cliente(self, cr, uid, ids, name_fields, args, context=None):
    context = context and context.copy() or {}
    tipos_mensagem = {'L': _('Venda liberada!'),
                      'B1': _('Mensagem de Bloqueio! '),
                      'B2': _('Titulos em atraso! '),
                      'B3': _('Limite credito excedido! ')}
    res = fincli_get_bloqueio(self, cr, uid, ids, context=context)
    for i in res:
        res[i] = tipos_mensagem.get(res[i])

    return res


def _fincli_get_dados_adicionais_cliente(self, cr, uid, ids, fields, args, context=None):
    context = context and context.copy() or {}
    if not ids:
        return {}
    res = {}
    company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name,
                                                                context=context)
    data = time.strftime('%Y-%m-%d')
    par_praso_medio_atraso = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'financeiro_parametros', 'finpar_prazo_media_atraso')
    par_praso_medio_atraso = par_praso_medio_atraso.get('finpar_prazo_media_atraso')
    data_praso = datas.calcVencimento(data, par_praso_medio_atraso*-30)
    data_praso = datas.getDataNoFormato(data_praso, 'I', '-')
    for cliente in self.read(cr, uid, ids, ['pessoa_id'], context, load='_classic_write'):
        dados = {}
        pessoa_id = cliente.get('pessoa_id')
        cliente_compra_dados = self.fincli_get_compra_dados(cr, uid, pessoa_id, context)
        sql = '''
              SELECT id,
                     data_emissao,
                     vr_original,
                     fatura_id
              FROM financeiro_titulo
              WHERE pessoa_id = %s
                AND tipo_titulo = 'R'
                AND state = 'B'
                AND company_id = %s
              ORDER BY vr_original DESC
              ''' % (pessoa_id, company_id)
        cr.execute(sql)
        dados_titulos = cr.dictfetchall() or [{}]
        sql_compra = '''
              SELECT data_emissao,
                     data_vencimento,
                     vr_original
              FROM financeiro_titulo
              WHERE pessoa_id = %s
                AND tipo_titulo = 'R'
                AND company_id = %s
              ORDER BY data_emissao
              ''' % (pessoa_id, company_id)
        cr.execute(sql_compra)
        dados_compra = cr.dictfetchall() or [{}]
        sql_titulos_atrasados = '''
              SELECT id
              FROM financeiro_titulo
              WHERE pessoa_id = %s
                AND tipo_titulo = 'R'
                AND data_emissao >= '%s'
                AND state = 'A'
                AND company_id = %s
              ORDER BY data_emissao
              ''' % (pessoa_id, data_praso, company_id)
        cr.execute(sql_titulos_atrasados)
        ids_atrasados = cr.dictfetchall()
        if dados_titulos:
            dados['fincli_primeira_compra_data'] = cliente_compra_dados.get(
                'primeira_compra_data') or dados_compra[0].get('data_emissao') or ''
            dados['fincli_primeira_compra_valor'] = cliente_compra_dados.get(
                'primeira_compra_valor') or dados_compra[0].get('vr_original') or 0.0
            dados['fincli_ultima_compra_data'] = cliente_compra_dados.get('ultima_compra_data') or \
                                                 dados_compra[-1].get('data_emissao') or ''
            dados['fincli_ultima_compra_valor'] = cliente_compra_dados.get(
                'ultima_compra_valor') or dados_compra[-1].get('vr_original') or 0.0
            data_maior_compra = cliente_compra_dados.get('maior_compra_data') or \
                                dados_titulos[0].get('data_emissao') or ''
            titulos_ids = map(lambda x: x.get('id'), dados_titulos)
            ids_atrasados = map(lambda x: x.get('id'), ids_atrasados)
            media_compra_prazo = sum(map(lambda x: datas.calcDiferenca(x.get('data_emissao'), x.get('data_vencimento')), dados_compra))

            lista_atraso = fincli_get_dados_atraso(self, cr, uid, titulos_ids, None, None, context)
            dias_maior_atraso = lista_atraso[1]
            data_maior_atraso = lista_atraso[2]
            media_compra_atraso = fincli_get_dados_atraso(self, cr, uid, ids_atrasados, None, None, context)[3]
            valor_maior_compra = cliente_compra_dados.get('maior_compra_valor') or \
                                 dados_titulos[0].get('vr_original') or 0
            media_compra_valor = round(sum(map(lambda x: x.get('vr_original') or 0,
                                               dados_titulos)),2)

            dados['fincli_maior_compra_data'] = data_maior_compra
            dados['fincli_maior_compra_valor'] = valor_maior_compra
            dados['fincli_media_compra_valor'] = cliente_compra_dados.get('media_compra_valor') or \
                                                 (media_compra_valor / len(dados_titulos))
            dados['fincli_media_compra_atraso'] = int(media_compra_atraso / len(dados_titulos))
            dados['fincli_maior_compra_data_atraso'] = data_maior_atraso
            dados['fincli_maior_compra_dias_atraso'] = dias_maior_atraso
            dados['fincli_media_compra_prazo'] = (media_compra_prazo  / len(dados_titulos))
            dados['fincli_media_compra_prorrogacao'] = 0.0

        res[cliente.get('id')] = dados

    return res


def fincli_get_titulo(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    brw_financeiro_cliente = self.browse(cr, uid, ids, context)
    obj_financeiro_titulo = self.pool.get('financeiro.titulo')
    for cliente in brw_financeiro_cliente:
        titulo_ids = obj_financeiro_titulo.search(cr, uid,
                                                  [('pessoa_id', '=', cliente.pessoa_id.id),
                                                   ('state', '=', 'A')], context=context)
        res[cliente.id] = titulo_ids
    return res


def _fincli_get_clientes_estatisticas_compras(self, cr, uid, ids, fields, args, context=None):
    context = context and context.copy() or {}
    res = {}
    company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name,
                                                                context=context)
    dict_mes = {1: 'Janeiro', 2: 'Fevereiro', 3: 'Marco', 4: 'Abril', 5: 'Maio', 6: 'Junho',
                7: 'Julho', 8: 'Agosto', 9: 'Setembro', 10: 'Outubro', 11: 'Novembro',
                12: 'Dezembro'}
    obj_cliente_estatisticas_compras_osv = self.pool.get('cliente.estatisticas.compras.osv')
    browse_cliente = self.browse(cr, uid, ids)
    for y in browse_cliente:
        cliente_estatisticas_compras_ids = obj_cliente_estatisticas_compras_osv.search(cr, uid,
                                                                                       [('cliente_id', '=', y.id)],
                                                                                       context=context)
        if cliente_estatisticas_compras_ids:
            obj_cliente_estatisticas_compras_osv.unlink(cr, uid, cliente_estatisticas_compras_ids)
        pessoa_id = y.pessoa_id.id
        data = time.strftime('%Y-%m-%d')
        date_parse = parse(data)
        mes_dia = data[4:]
        if date_parse.month == 2 and date_parse.day == 29 and not isleap(int(data[0:4])-1):
            mes_dia = '-02-28'
        data_emissao = str(int(data[0:4])-1) + mes_dia
        sql = """
            SELECT
                date(date_part('year', data_emissao) || '-' ||
                    date_part('month', data_emissao) || '-' || '01') AS data,
                sum(vr_original)	                                 AS total_mes
            FROM financeiro_titulo
            WHERE
                pessoa_id = %s
                AND data_emissao > '%s'
                AND tipo_titulo = 'R'
                AND company_id = %s
            GROUP BY data
            ORDER BY data DESC;
        """ % (pessoa_id, data_emissao, company_id)
        cr.execute(sql)
        dados_titulos = cr.dictfetchall()
        est_ids = []
        for vals in dados_titulos:
            data = parse(vals.get('data'))
            vals['cliente_id'] = y.id,
            vals['data_estatistica'] = dict_mes.get(data.month) + '/' + str(data.year)[2:]
            est_ids.append(obj_cliente_estatisticas_compras_osv.create(cr, uid, vals, context))
        res[y.id] = est_ids
    return res

#Funcoes da classe financeiro_local_cobranca
def _finloc_name_get(self, cr, uid, ids, name, args, context=None):
    context = context and context.copy() or {}
    if not len(ids):
        return []
    reads = self.read(cr, uid, ids, ['id', 'descricao'], context=context)
    res = {}
    for record in reads:
        name = '%03d - %s' % (record['id'], record['descricao'])
        res[record['id']] = name
    return res

#Funcoes Financeiro_titulo
def _fintit_sacado(self, cr, uid, context=None):
    ''' C(Cliente)para Contas a Receber e F(Fornecedor) para Contas a pagar,
         insere no campo tipo_sacado o valor com default'''
    context = context and context.copy() or {}
    id = 'C'
    if context.get('entrada_titulo_pagar'):
        id = 'F'
    return id


def _fintit_tipo(self, cr, uid, context):
    ''' De acordo com o contexto ele define o valor para o campo tipo_tipo se e a pagar ou a receber'''
    id = 'R'
    if context.get('entrada_titulo_pagar', False):
        id = 'P'
    return id


def _fintit_baixa(self, cr, uid, ids, name_fields, args, context=None):
    context = context and context.copy() or {}
    if ids:
        res = {}
        obj_baixa = self.pool.get('financeiro.titulo.baixa')
        baixa_ids = obj_baixa.search(cr, uid, [('titulo_id', 'in', ids)], context=context)
        if baixa_ids:
            baixa_dados = obj_baixa.read(cr, uid, baixa_ids,
                                         ['titulo_id', 'valor_juros', 'valor_desconto', 'data_pgto', 'valor_multa',
                                          'data_baixa'], context=context)
            multa = 0
            juros = 0
            desconto = 0
            data_pgto = []
            data_baixa = []
            for i in baixa_dados:
                juros += i['valor_juros']
                multa += i['valor_multa']
                desconto += i['valor_desconto']
                data_pgto.append(i['data_pgto'])
                data_baixa.append(i['data_baixa'])
            data_pgto = max(data_pgto)
            data_baixa = max(data_baixa)
            res[i['titulo_id'][0]] = {'data_pagamento': data_pgto, 'juros': juros,
                                      'desconto': desconto, 'multa': multa,
                                      'data_baixa': data_baixa}
        return res
    else:
        res = {}.fromkeys(ids, 0)
    return res

    # Retorna o valor pago de cada titulo
def _fintit_vr_pago(self, cr, uid, ids, name_fields, args, context=None):
    context = context and context.copy() or {}
    res = {}
    sql = '''SELECT valor_pago, titulo_id
             FROM financeiro_titulo_baixa
             WHERE titulo_id IN %s
          '''  % (str(ids).replace('[','(').replace(']',')'))
    cr.execute(sql)
    for baixa in cr.dictfetchall():
        valor_pago = 0.0
        if baixa.get('valor_pago'):
            valor_pago = baixa.get('valor_pago')
        if res.get(baixa.get('titulo_id')):
            valor_pago = res.get(baixa.get('titulo_id')) + valor_pago
        res[baixa.get('titulo_id')] = valor_pago
    for titulo_id in ids:
        if not titulo_id in res:
            res[titulo_id] = 0.00
    return res

def _fintit_get_parametro(self, cr, uid, ids, name_fields, args, context=None):
    '''Verifica se e permitido ao usuário logado alterar a multa, desconto e os juros
       dependendo do parâmetro do financeiro'''
    context = context and context.copy() or {}
    if isinstance(ids, (int, long)):
        ids = [ids]
    ocorrencia_ids = self.pool.get('adm.ocorrencia').search(
        cr, uid, [('admoco_titulo_id', 'in', ids)], context=context)
    res = {}.fromkeys(ids, {
        'fintit_flag': False,
        'fintit_parametro_local_cobranca': False,
        'fintit_usar_centro_custos_e_eventos': False,
        'fintit_ocorrencia_ids': ocorrencia_ids
    })
    obj_financeiro_parametro = self.pool.get('financeiro.parametros')
    parametro_ids = obj_financeiro_parametro.search(cr, uid, [], context=context)
    if parametro_ids:
        financeiro_parametro_dados = obj_financeiro_parametro.read(cr, uid, parametro_ids[0],
                                                                   ['alterar_multa_juros', 'local_cobranca_id',
                                                                    'usar_centro_custos_e_eventos'], context=context)
        if isinstance(financeiro_parametro_dados, list) and financeiro_parametro_dados:
            financeiro_parametro_dados = financeiro_parametro_dados[0]
        if isinstance(financeiro_parametro_dados, dict):
            alterar_multa_juros = True if financeiro_parametro_dados.get('alterar_multa_juros') else False
            local_cobranca = True if financeiro_parametro_dados.get('local_cobranca_id') else False
            usar_custo_e_evento = True if financeiro_parametro_dados.get('usar_centro_custos_e_eventos') else False
            res.update({}.fromkeys(ids, {
                'fintit_flag': alterar_multa_juros,
                'fintit_parametro_local_cobranca': local_cobranca,
                'fintit_usar_centro_custos_e_eventos': usar_custo_e_evento,
                'fintit_ocorrencia_ids': ocorrencia_ids
            }))
    return res


def _fintit_moeda_empresa(self, cr, uid, ids, context=None):
    context = context and context.copy() or {}
    obj_parametro = self.pool.get('financeiro.parametros')
    id_parametro = obj_parametro.search(cr, uid, [], context=context)
    if id_parametro:
        id_moeda = obj_parametro.read(cr, uid, id_parametro[0], ['moeda_id'], context=context)
        if id_moeda.get('moeda_id', False):
            return id_moeda['moeda_id'][0]
        else:
            raise osv.except_osv(_('Atencao'),
                                 _('Em Cadastro/Financeiro nao esta cadastro a moeda !'))
    return False


def _fintit_get_flag(self, cr, uid, context=None):
    '''Verifica se e permitido ao usuário logado alterar a multa e os juros
       dependendo do parâmetro do financeiro'''
    context = context and context.copy() or {}
    fl = False
    titulo_obj = self.pool.get('financeiro.titulo')
    adm_empresa_obj = self.pool.get('adm.empresa.objeto')
    financeiro_parametros_obj = self.pool.get('financeiro.parametros')
    if context.get("entrada_titulo_receber"):
        empresa = adm_empresa_obj.getEmpresa(cr, uid, self._name, context=context)
        if empresa:
            id_parametro = financeiro_parametros_obj.search(cr, uid, [], context=context)
            if id_parametro:
                financeiro_parametros_dados = financeiro_parametros_obj.read(cr, uid, id_parametro,
                                                                             ['alterar_multa_juros',
                                                                              'local_cobranca_id',
                                                                              'usar_centro_custos_e_eventos'], context=context)
                for x in financeiro_parametros_dados:
                    if context.get('fintit_flag'):
                        fl = x.get('alterar_multa_juros')
                    if context.get('fintit_parametro_local_cobranca'):
                        fl = True if x.get('local_cobranca_id') else False
                    if context.get('fintit_usar_centro_custos_e_eventos'):
                        fl = True if x.get('usar_centro_custos_e_eventos') else False
    else:
        fl = True
    return fl


def _fintit_get_local_cobranca_tipo(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    if isinstance(ids, (int, long)):
        ids = [ids]
    res = {}.fromkeys(ids, '')
    browse_financeiro = self.browse(cr, uid, ids)
    for i in browse_financeiro:
        id = i.id
        tipo_local_cobranca = i.local_cobranca_id.tipo or ''
        res[id] = tipo_local_cobranca
    return res

def fincli_get_dados_atraso(self, cr, uid, ids, field_name, args, context):
    if isinstance(ids, (int, long)):
        ids = [ids]
    today = date.today()
    res = {}.fromkeys(ids, 0)
    atraso_total = 0
    titulo_dados = self.read(cr, uid, ids, ['data_prorrogacao', 'data_emissao', 'tipo_titulo',
                                            'state'], context=context)
    titulo_dados = filter(lambda i: i.get('state') == 'A', titulo_dados)
    maior_atraso = 0
    data_maior_atraso = ''
    for titulo in titulo_dados:
        id = titulo.get('id')
        titulo_data_prorrogacao = titulo.get('data_prorrogacao') or str(today)
        date_titulo_prorrogacao = parse(titulo_data_prorrogacao, yearfirst=True).date()
        dias_atraso = (today - date_titulo_prorrogacao).days
        if dias_atraso > 0:
            # titulo vencendo no sabado ou domingo e a data de hoje for segunda, nao tem atraso
            if date_titulo_prorrogacao.weekday() in [5,6] and today.weekday() == 0 and dias_atraso < 3:
                continue

            res[id] = dias_atraso
            atraso_total += dias_atraso
            if dias_atraso > maior_atraso:
                maior_atraso = dias_atraso
                data_maior_atraso = titulo.get('data_emissao')

    return [res, maior_atraso, data_maior_atraso, atraso_total]

def _fintit_get_valores(self, cr, uid, ids, field_name, args, context):
    '''
    Esta funcao calcula dias em atraso, encargos e saldo corrigido do titulo
    '''
    res = {}
    dias_atraso_titulos = fincli_get_dados_atraso(self, cr, uid, ids, field_name, args, context)[0]
    prazo_perdao = self.pool.get('adm.utils').admutl_get_parametros(cr, uid,
            'financeiro.parametros', ['prazo_perdao'], context=context).get('prazo_perdao') or 0
    for brw_titulo in self.browse(cr, uid, ids, context):
        multa = brw_titulo.vr_multa or 0
        dias_atraso = dias_atraso_titulos.get(brw_titulo.id) or 0
        juros = brw_titulo.vr_juros_dia * dias_atraso
        if brw_titulo.multa_apos_data and brw_titulo.multa_apos_data >= str(datetime.now().date()):
            multa = 0

        if brw_titulo.tipo_titulo == 'R' and prazo_perdao >= dias_atraso:
            multa = 0
            juros = 0

        encargos = juros + multa
        saldo_corrigido = encargos + brw_titulo.saldo - brw_titulo.vr_desconto
        res[brw_titulo.id] = {'fintit_atraso_dias': dias_atraso,
                              'fintit_encargos': encargos,
                              'fintit_saldo_corrigido': saldo_corrigido}
    return res


def _fintit_is_cheque(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    doc_tipo_id = self.pool.get('documento.documento.tipo').search(cr, uid, [('descricao', 'ilike', 'cheque')],
                                                                   context=context)
    browse_titulos = self.browse(cr, uid, ids, context)
    for titulo in browse_titulos:
        titulo_doc_tipo_id = titulo.doc_tipo_id.id or False
        if doc_tipo_id and doc_tipo_id[0] == titulo_doc_tipo_id:
            res[titulo.id] = True
        else:
            res[titulo.id] = False
    return res


def _fintit_get_documento(self, cr, uid, context=None):
    context = context and context.copy() or {}
    if context.get('criar_titulo'):
        return context.get('numero_documento')
    else:
        return False


def _fintit_is_cheque(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    doc_tipo_id = self.pool.get('documento.documento.tipo').search(cr, uid,
                                                       [('sigla', 'ilike', 'CHQ')], context=context)
    for titulo in self.read(cr, uid, ids, ['doc_tipo_id'], context=context, load='_classic_write'):
        res[titulo.get('id')] = False
        if doc_tipo_id and doc_tipo_id[0] == titulo.get('doc_tipo_id'):
            res[titulo.get('id')] = True

    return res


def _fintit_boleto_dados(self, cr, uid, ids, field_names, arg, context=None):
    """
    O metodo atribui valor aos campos fintit_boleto_nosso_numero e fintit_boleto_codigo_barras de
    acordo com o ultimo registro na tabela financeiro_titulo_boleto para os titulos recebidos
    em ids.
    :param cr: cursor no banco de dados.
    :type: object
    :param uid: id da tabela res_users, identificador do usuario.
    :type: integer
    :param ids: lista de id da tabela desse objeto.
    :type: list
    :param field_names: lista com a descricao dos campos.
    :type: list
    :param arg:
    :param context: dicionario com valores contextuais.
    :return: dicionario com os campos e seus respectivos valores.
    :rtype: dict
    """
    context = context and context.copy() or {}
    res = self.fintit_get_dados_boleto(cr, uid, ids, local_cobranca_id=False, natureza_cobranca_id=False,
                                       context=context)
    return res

def _constraint_data_prorrogacao(self, cr, uid, ids, context=None):
    """
    Verifica se a data de emissao e menor que a data de prorrogacao (data bom para - Cheque)

    @retorna: True se a quantidade palete for menor que um
    """
    context = context and context.copy() or {}
    res = True
    if isinstance(ids, list):
        titulo_id = ids[0]
    else:
        titulo_id = ids
    titulo_dados = self.read(cr, uid, titulo_id, ['data_prorrogacao', 'data_emissao'], context=context)
    if titulo_dados and isinstance(titulo_dados, list):
        titulo_dados = titulo_dados[0]
    if isinstance(titulo_dados, dict):
        data_emissao = titulo_dados.get('data_emissao')
        data_prorrogacao = titulo_dados.get('data_prorrogacao')

        date_prorrogacao = parse(data_prorrogacao, yearfirst=True).date()
        date_emissao = parse(data_emissao, yearfirst=True).date()
        res = date_emissao <= date_prorrogacao
    return res

#Funcoes da classe financeiro_fornecedor
def _finfor_nome_fornecedor(self, cursor, user, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for fornecedor in self.browse(cursor, user, ids):
        if fornecedor.pessoa_id:
            res[fornecedor.id] = fornecedor.pessoa_id.name
        else:
            res[fornecedor.id] = False
    return res


#Funcoes da classe cliente_mensagem
def _finclm_nome_cliente(self, cursor, user, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for cliente in self.browse(cursor, user, ids):
        if cliente.cliente_id:
            res[cliente.id] = cliente.cliente_id.pessoa_id.name
        else:
            res[cliente.id] = False
    return res


#Funcoes da classe financeiro_titulo_baixa
def _fintib_get_forma_pagamento_baixa(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    obj_financeiro_titulo = self.pool.get('financeiro.titulo')
    obj_adm_forma_pgto = self.pool.get('adm.forma.pgto')
    forma_pagamento_id = obj_adm_forma_pgto.search(cr, uid, [('sigla', '=', 'CH')], context=context)
    browse_titulo_baixa = self.browse(cr, uid, ids, context)
    for titulo_baixa in browse_titulo_baixa:
        vals = {'fintib_chq_banco': False, 'fintib_chq_agencia': False, 'fintib_chq_conta': '',
                'fintib_chq_emitente': '', 'fintib_documento': '',
                'fintib_forma_pagamento_baixa': '', 'fintib_baixa_ids': list()}
        titulo_id = titulo_baixa.titulo_id
        titulo_parent_id = obj_financeiro_titulo.search(cr, uid, [('titulo_parent_id', '=',
                                                                   titulo_id.id)], context=context)
        forma_pagamento_ids = titulo_baixa.baixa_forma_pgto_ids
        if forma_pagamento_ids:
            vals['fintib_forma_pagamento_baixa'] = forma_pagamento_ids[0].forma_pgto_id.name
        elif titulo_parent_id:
            titulo_parent_id = obj_financeiro_titulo.browse(cr, uid, titulo_parent_id[0])
            is_cheque = titulo_parent_id.fintit_cheque
            if is_cheque:
                vals['fintib_is_cheque'] = True
                vals['fintib_forma_pagamento_baixa'] = forma_pagamento_id[0].name
                vals['fintib_chq_banco'] = titulo_parent_id.fintit_chq_banco or False
                vals['fintib_chq_agencia'] = titulo_parent_id.fintit_chq_agencia or False
                vals['fintib_chq_conta'] = titulo_parent_id.fintit_chq_conta or ''
                vals['fintib_chq_emitente'] = titulo_parent_id.fintit_chq_emitente or ''
                vals['fintib_documento'] = titulo_parent_id.documento or ''
        if not vals.get('fintib_forma_pagamento_baixa'):
            vals['fintib_forma_pagamento_baixa'] = 'Refinanciamento'
        if titulo_baixa.tesouraria_movimento_id:
            vals['fintib_baixa_ids'] = self.search(
                cr, uid,
                [('tesouraria_movimento_id', '=', titulo_baixa.tesouraria_movimento_id.id)],
                context=context)
        res[titulo_baixa.id] = vals
    return res


# Funcoes da classe financeiro_cliente
def _get_total_em_aberto(self, cr, uid, ids, context=None):
    context = context and context.copy() or {}
    res = {}
    obj_financeiro_titulo = self.pool.get('financeiro.titulo')
    load = '_classic_write'
    previsao_ids = self.pool.get('documento.documento.tipo').search(
        cr, uid, [('sigla', '=', 'PRV')], context=context)
    dict_cliente_pessoa = {}
    dados_cliente = self.read(cr, uid, ids, ['pessoa_id'], context=context, load=load)
    pessoa_ids = []
    for i in dados_cliente:
        dict_cliente_pessoa.update({i.get('id'): i.get('pessoa_id')})
        pessoa_ids.append(i.get('pessoa_id'))

    # Uma vez que o cadastro de cliente seja compartilhado com outras empresas e o limite de
    # credito, nesse caso, deve ser unico, o total em aberto tambem deve ser unico. Ou seja, deve
    # ser a soma nas empresas envolvidas.
    obj_adm_empresa_objeto = self.pool.get('adm.empresa.objeto')
    cliente_company_id = obj_adm_empresa_objeto.getEmpresa(cr, uid, 'financeiro.cliente',
                                                           context=context)
    cliente_company_ids = obj_adm_empresa_objeto.admemp_get_empresa_escolhida_ids(
        cr, uid, 'financeiro.cliente', cliente_company_id, context)
    context['sig_force_company'] = True
    args = [('pessoa_id', 'in', pessoa_ids), ('state', '=', 'A'),
            ('tipo_titulo', '=', 'R'), ('doc_tipo_id', 'not in', previsao_ids),
            ('company_id', 'in', cliente_company_ids)]
    titulo_ids = obj_financeiro_titulo.search(cr, uid, args, context=context)
    del context['sig_force_company']
    dict_pessoa_titulo = {}
    # nao tirar o read, pois a performance eh maior que browse e nao executar read ou search dentro
    # do 'for' que fica mais lento
    for i in obj_financeiro_titulo.read(cr, uid, titulo_ids, ['saldo', 'pessoa_id'],
                                        context=context, load=load):
        if not dict_pessoa_titulo.get(i.get('pessoa_id')):
            dict_pessoa_titulo[i.get('pessoa_id')] = [i]
        else:
            dict_pessoa_titulo[i.get('pessoa_id')].append(i)

    for cliente in dados_cliente:
        read_financeiro_titulo = dict_pessoa_titulo.get(cliente.get('pessoa_id'))
        if not read_financeiro_titulo:
            res[cliente.get('id')] = 0
        else:
            res[cliente.get('id')] = sum(map(lambda t: t.get('saldo') or 0.0,
                                             read_financeiro_titulo))
    return res

def _fincli_get_total_em_aberto(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    return _get_total_em_aberto(self, cr, uid, ids, context)


#Funcoes da classe financeiro_local_natureza
def _finlon_get_default_par_centro_custo(self, cr, uid, context=None):
    context = context and context.copy() or {}
    parametro_ids = self.pool.get('financeiro.parametros').search(cr, uid, [], context=context)
    if not parametro_ids:
        return False
    if isinstance(parametro_ids, list):
        parametro_ids=parametro_ids[0]
    centro_custo = self.pool.get('financeiro.parametros').browse(cr, uid, parametro_ids)
    if not centro_custo:
        return False
    centro_custo = centro_custo.usar_centro_custos_e_eventos
    return centro_custo


def _finlon_get_par_centro_custo(self, cr, uid, ids, name='', args=None, context=None):
    context = context and context.copy() or {}
    res = {}
    for id in ids:
        res[id] = self._finlon_get_default_par_centro_custo(cr, uid, context)
    return res


def _finlon_get_local_tipo(self, cr, uid, ids, name='', args=None, context=None):
    context = context and context.copy() or {}
    res = {}
    tipo = self.browse(cr, uid, ids)[0].finlon_local_cobranca_id.tipo
    if tipo == 'B':
        tipo=True
    else:
        tipo=False
    for id in ids:
        res[id] = tipo
    return res
def _finlon_get_default_local_tipo(self, cr, uid, context=None):
    context = context and context.copy() or {}
    return False

def _finlon_get_conta_agencia(self, cr, uid, ids, fields, args, context=None):
    context = context and context.copy() or {}
    res = get_conta_agencia(self, cr, uid, ids, context)
    return res

def _finlon_verificar_carteira(self, cr, uid, ids, context=None):
    context = context and context.copy or {}
    for brw_local_natureza in self.browse(cr, uid, ids):
        _conta = brw_local_natureza.finlon_conta
        _carteira = brw_local_natureza.finlon_carteira
        _banco_id = brw_local_natureza.finlon_local_cobranca_id.finloc_banco_id.id
        if not _carteira:
            continue
        sql = """select count(fln.id) from financeiro_local_natureza fln
                    left join financeiro_local_cobranca flc on flc.id = fln.finlon_local_cobranca_id
                    left join financeiro_tesouraria_contas ftc on ftc.id = flc.finloc_conta_id
                    where finlon_carteira = '%s' and ftc.nro_conta = '%s' and finloc_banco_id = %s
              """ % (_carteira, _conta, _banco_id)
        cr.execute(sql)
        res = cr.fetchone()
        if res[0] > 1:
            return False
    return True


def get_conta_agencia(self, cr, uid, ids, context=None):
    context = context and context.copy() or {}
    res = {}
    dados = {
        'finlon_conta': '',
        'finlon_conta_dv': '',
        'finlon_agencia': '',
        'finlon_agencia_dv': ''
    }
    if 'finlon_local_cobranca' in context:
        brw_local_cobranca = self.pool.get('financeiro.local.cobranca').browse(cr, uid, ids)
        brw_tesouraria_contas = brw_local_cobranca.finloc_conta_id
        if brw_tesouraria_contas:
            if brw_tesouraria_contas.nro_conta:
                dados['finlon_conta'] = brw_tesouraria_contas.nro_conta
            if brw_tesouraria_contas.conta_dv:
                dados['finlon_conta_dv'] = brw_tesouraria_contas.conta_dv
            brw_banco_agencia = brw_tesouraria_contas.agencia_id
            if brw_banco_agencia:
                if brw_banco_agencia.admbag_codigo_agencia:
                    dados['finlon_agencia'] = brw_banco_agencia.admbag_codigo_agencia
                if brw_banco_agencia.admbag_dv_agencia:
                    dados['finlon_agencia_dv'] = brw_banco_agencia.admbag_dv_agencia
        res = dados
    else:
        for brw_local_natureza in self.browse(cr, uid, ids, context=context):
            brw_tesouraria_contas = brw_local_natureza.finlon_local_cobranca_id.finloc_conta_id
            if brw_tesouraria_contas:
                if brw_tesouraria_contas.nro_conta:
                    dados['finlon_conta'] = brw_tesouraria_contas.nro_conta
                if brw_tesouraria_contas.conta_dv:
                    dados['finlon_conta_dv'] = brw_tesouraria_contas.conta_dv
                brw_banco_agencia = brw_tesouraria_contas.agencia_id
                if brw_banco_agencia:
                    if brw_banco_agencia.admbag_codigo_agencia:
                        dados['finlon_agencia'] = brw_banco_agencia.admbag_codigo_agencia
                    if brw_banco_agencia.admbag_dv_agencia:
                        dados['finlon_agencia_dv'] = brw_banco_agencia.admbag_dv_agencia
            res[brw_local_natureza.id] = dados
    return res


def _fincli_verifica_duplicidade(self, cr, uid, ids, context=None):
    context = context and context.copy or {}
    context['active_test'] = False
    for cliente in self.browse(cr, uid, ids):
        cpf_cnpj = str(cliente.cpf_cnpj).replace('/', '').replace('.', '').replace('-', '')
        qtd_cliente = self.search(cr, uid, [('cpf_cnpj', '=', cpf_cnpj)], context=context)
        if len(qtd_cliente) > 1:
            return False
    return True


# Funcoes da classe financeiro_emails_mensagens


def fineme_get_mensagem(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    brw_financeiro_emails_mensagens = self.browse(cr, uid, ids, context)
    map(lambda i: res.update({i.id: {'fineme_assunto': i.fineme_texto_id.fineca_assunto or '',
                                     'fineme_texto': i.fineme_texto_id.fineca_corpo or ''}}),
        brw_financeiro_emails_mensagens)
    return res

def fineme_get_state(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    for x in self.browse(cr, uid, ids, context):
        state = x.fineme_mail_id.state
        if state == 'outgoing':
            state = 'Na fila'
        elif state == 'sent':
            state = 'Enviado'
        elif state == 'received':
            state = 'Recebido'
        elif state == 'exception':
            state = 'Erro na entrega'
        else:
            state = 'Cancelado'
        res[x.id] = state
    return res


# Funcoes da classe financeiro_titulo_boleto


def fintib_get_tipo_titulo(self, cr, uid, ids, field_name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    map(lambda b: res.update({b.id: b.fintib_titulo_id.tipo_titulo}),
        self.browse(cr, uid, ids, context))
    return res
