# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler
import time


class financeiro_clientes_mensagem(osv.Model):
    """
    Tabela contendo as mensagens que estao associadas aos clientes
    prefixo: finclm
    """
    from funcoes import _finclm_nome_cliente

    _name = 'financeiro.clientes.mensagem'
    _columns = {
        'cliente_id': fields.many2one("financeiro.cliente", 'Cliente', ondelete="cascade", required=True, select=True),
        'name': fields.function(_finclm_nome_cliente, method=True, string='Cliente', type='text', store=False),
        'mensagens_id': fields.many2one("financeiro.clientes.mensagem.nome", 'Mensagem', ondelete="restrict",
                                        required=True), # id da mensagem
        'modo_exibicao': fields.selection([('I', 'Impressora'), ('V', 'Video'), ('A', 'Video/Impressora')],
                                          'Modo Exibicao Mensagem', required=True, size=1),
        'data_inclusao': fields.date('Data inclusao', required=True), # Data de inclusao da mensagem
    }
    _defaults = {
        'data_inclusao': lambda *a: time.strftime('%Y-%m-%d'),
        'modo_exibicao': lambda *a: 'I'
    }
    _order = 'cliente_id'

