# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler


class financeiro_clientes_mensagem_nome(osv.Model):
    """
    Tabela  contendo o cadastro de mensagens
    """
    _name = 'financeiro.clientes.mensagem.nome'
    _columns = {
        'name': fields.char('Descricao', size=60, required=True), # Descricao, nome da mensagem
        'tipo_mensagem': fields.selection([('N', 'Nao bloqueia venda'), ('B', 'Bloqueia venda')], 'Tipo mensagem',
                                          required=True, size=1),
        'codigo': fields.integer('Codigo', select=True, help='Codigo para identificacao da mensagem!', required=True),
        'mensagem_ids': fields.one2many('financeiro.clientes.mensagem', 'mensagens_id', 'Mensagens'),
    }
    _order = 'name'
    _defaults = {
        'tipo_mensagem': lambda *a: 'N',
    }
    _sql_constraints = [
        ('codigo_uniq', 'unique (codigo)', 'O Codigo da mensagem deve ser unico !')
    ]

