# -*- encoding: utf-8 -*-
from openerp.osv import fields
from openerp.osv import osv
from openerp.tools.sql import drop_view_if_exists


class rel_periodo_view(osv.Model):
    _name = "rel.periodo.view"
    _description = "Painel Financeiro periodo"
    _auto = False
    _columns = {
        'id': fields.integer('id'),
        'vnc': fields.char('Status', size=10),
        'vncper': fields.char('Periodo', size=10),
        'tipo_titulo': fields.selection([('R', 'Receber'), ('P', 'Pagar')], 'Tipo titulo', size=1),
        'vrl_acumulado': fields.float('Valor', digits=(15, 2)),
    }

    def init(self, cr):
        drop_view_if_exists(cr, "rel_periodo_view")
        cr.execute("""create or replace view rel_periodo_view  as(
        select rank () over (order by  tipo_titulo , vnc, vncper) as id ,xx.*
        from        (select   case
        when ft.data_prorrogacao >=  current_date Then 'A Vencer'
        else 'Vencida' end as vnc,
        case
		when abs(current_date - ft.data_prorrogacao)  <= 005 Then '000 - 005'
		when abs(current_date - ft.data_prorrogacao)  <= 010 Then '006 - 010'
		when abs(current_date - ft.data_prorrogacao)  <= 015 Then '011 - 015'
		when abs(current_date - ft.data_prorrogacao)  <= 030 Then '016 - 030'
		when abs(current_date - ft.data_prorrogacao)  <= 060 Then '031 - 060'
		when abs(current_date - ft.data_prorrogacao)  <= 090 Then '061 - 090'
		when abs(current_date - ft.data_prorrogacao)  <= 120 Then '091 - 120'
		when abs(current_date - ft.data_prorrogacao)   > 120 Then '120 >'
		else ' A Vencer < 0' end as vncper,
        tipo_titulo ,
               sum(ft.saldo ) as vrl_acumulado

        from financeiro_titulo ft
        where ft.State = 'A'
        group By tipo_titulo , vnc, vncper
        ) as xx
        )

            """)
