# -*- encoding: utf-8 -*-

from openerp.osv import fields, osv
#----------------------------------------------------------
# Titulos vencidos com mais de 5 dias
#----------------------------------------------------------
class report_financeiro_titulos(osv.Model):
    _name = "report_financeiro.titulos"
    _description = "Vizualizar Titulos"
    _auto = False
    _columns = {
        'tipo_titulo': fields.selection([('R', 'Receber'), ('P', 'Pagar')], 'Tipo titulo', readonly=True, size=1),
        'doc_tipo_id': fields.many2one("documento.documento.tipo", 'Tipo de documento', ondelete="restrict",
                                       required=True, select=True), # id do Tipo de documento
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade"),
        'pessoa_id': fields.many2one("adm.pessoa", 'Cliente/Fornecedor'),
        'documento': fields.char('Documento', size=30, ), # Numero do documento.
        'parcela': fields.integer('Parcela', ), # Numero da parcela do documento.
        'data_emissao': fields.date('Data emissao'), # data de emissao do titulo
        'data_prorrogacao': fields.date('Data prorrogacao'),
        'vr_original': fields.float('Valor original', digits=(15, 2)),
        'vr_receber': fields.float('Valor a Receber', digits=(15, 2)),
        'vr_pagar': fields.float('Valor a Pagar', digits=(15, 2)),
        'state': fields.selection([('VENCIDO', 'Vencidos'), ('HOJE', 'Vencem hoje'), ('VENCER', 'A vencer')],
                                  'Situacao'),
        'repasse_pessoa_id': fields.many2one("adm.pessoa", 'Pessoa', ondelete="restrict"),
    }
    _order = 'data_prorrogacao'
