# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler


class financeiro_representante(osv.Model):
    """
    Tabela de representantes dos fornecedores
    """
    _name = 'financeiro.representante'
    _rec_name = 'pessoa_id'
    _columns = {
        'fornecedor_id': fields.many2one("financeiro.fornecedor", 'Fornecedor', ondelete="cascade", required=True,
                                         select=True), # id do fornecedor
        'pessoa_id': fields.many2one("adm.pessoa", 'Representante', ondelete="cascade", required=True, select=True),
    }
    _order = 'fornecedor_id, pessoa_id'

    _sql_constraints = [
        ('fornecedor_pessoa_uniq', 'unique (fornecedor_id, pessoa_id)',
         'Ja existe este representante para este fornecedor' ),
    ]
