# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools import drop_view_if_exists


class financeiro_analitico_pgview(osv.Model):
    _name = "financeiro.analitico.pgview"
    _inherit = "financeiro.analitico.pgview"
    _auto = False

    def init(self, cr):
        drop_view_if_exists(cr, 'financeiro_analitico_pgview')
        cr.execute("""
        CREATE OR REPLACE VIEW financeiro_analitico_pgview AS(
            SELECT
                row_number() over (ORDER BY xx.data) AS id,
                xx.*
            FROM    (SELECT
                        titulo.company_id as company_id,
                        titulo.pessoa_id as pessoa_id,
                        titulo.doc_tipo_id as doc_tipo_id,
                        titulo.tipo_titulo as tipo,
                        titulo.saldo as valor,
                        titulo.data_prorrogacao as data,
                        titulo.documento as historico,
                        titulo.natureza_cobranca_id as natureza_cobranca_id,
                        titulo.local_cobranca_id as local_cobranca_id
                    FROM
                        financeiro_titulo titulo
                    WHERE
                        state = 'A'
                    UNION ALL
                    SELECT
                        (
                            select company_id
                            from financeiro_tesouraria_contas
                            where id = movimento.conta_id
                        ) as company_id,
                        null as pessoa_id,
                        null as doc_tipo_id,
                        movimento.debito_credito as tipo,
                        movimento.valor as valor,
                        movimento.data_movimento as data,
                        movimento.historico as historico,
                        null as natureza_cobranca_id,
                        null as local_cobranca_id
                    FROM
                        financeiro_tesouraria_movimento movimento
                    WHERE
                        state = 'A'
                    ORDER BY
                        data
                    )
                    AS xx
            )
        """)
