# -*- encoding: utf-8 -*-


import time

from openerp.osv import fields
from openerp.osv import osv
from openerp.tools.sql import drop_view_if_exists


class report_listagem_fornecedores(osv.Model):
    _name = "report.listagem.fornecedores"
    _description = "Listagem de Fornecedores"
    _auto = False
    _columns = {

        'name': fields.char('Nome', size=50),
        'pessoa_id': fields.many2one("adm.pessoa", 'Pessoa', ondelete="cascade", select=True), # id da pessoa
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'cpf_cnpj': fields.char('CPF/CNPJ', size=19, select=True), # Numero do Cpf ou CNPJ da pessoa
        'codigo': fields.integer('Codigo'), # codigo para identificacao da pessoa
        'fantasia_apelido': fields.char('Nome', size=50),
        'cidade': fields.char('Cidade', size=50)

    }


    def init(self, cr):
        drop_view_if_exists(cr, "report_listagem_fornecedores")
        cr.execute(""" create or replace view report_listagem_fornecedores  as (
                  select


                        a.company_id as company_id,
                        a.pessoa_id as pessoa_id,
                        b.id as id,
                        b.cpf_cnpj as cpf_cnpj,
                        b.nome as name,
                        b.fantasia_apelido as fantasia_apelido,
                        b.codigo as codigo,
                        b.pessoa_tipo as pessoa_tipo,
                        b.cidade as cidade


                    from
                        financeiro_fornecedor a
                    left join
                        adm_pessoa b on  b.id = a.pessoa_id )""")



