# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(e, c, d, t=160):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        context = context and context.copy() or {}
        title = center_title('', _('Listagem Movimento de Titulos'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Movimento de Titulos'))
        listagem.informaTamLinha(160)

        obj_financeiro_movimento_historico = pooler.get_pool(cr.dbname).\
            get('wizard.financeiro.movimento.historico')
        historico_ids = datas.get('historico_ids')
        movimento_historico_dados = obj_financeiro_movimento_historico.browse(
            cr, uid, historico_ids)
        if movimento_historico_dados:
            company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
                cr, uid, 'financeiro.titulo', context=context)
            res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
                cr, uid, company_id, ['name'], context=context)
            nome_empresa = res_company_dados.get('name')
            data = time.strftime("%d/%m/%Y")
            docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))

            listagem.informaCab(''+title)
            listagem.informaCab('')
            listagem.informaCab('')
            listagem.informaCab(''+docs)
            listagem.informaCab('  ')
            listagem.informaCab('*--------------------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.informaCab(_('|     EMPRESA     |   USUARIO   |    DATA HIS.   |  CLIENTE/FORNECEDOR  | TIPO  |    TITULO   | LOCAL COB. | NATUREZA COB. |   VALOR  | PRORROGACAO | OPERACAO |'))
            listagem.informaCab('*--------------------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.informaCab('  ')
            listagem.rodapePadrao()

            for x in movimento_historico_dados:
                if x.tipo_titulo == 'R':
                    tipo_titulo = 'Receber'
                else:
                    tipo_titulo = 'Pagar'
                data_prorrogacao = x.data_prorrogacao or ''
                if data_prorrogacao:
                    data_prorrogacao = '%s-%s-%s' % (data_prorrogacao[8:], data_prorrogacao[5:7],
                                                     data_prorrogacao[:4])
                data_criacao = x.data_criacao or ''
                if data_criacao:
                    hora = data_criacao[10:]
                    data_criacao = '%s-%s-%s' % (data_criacao[8:10], data_criacao[5:7],
                                                 data_criacao[:4])
                    data_criacao += hora

                linha = formataString(x.company_id.name or '', 17, ' ', 'D', 'N', 'S')+'|'
                linha += ''
                linha += formataString(x.user_id.pessoa_id.name or '', 13, ' ', 'D', 'N', 'S')+'|'
                linha += ''
                linha += formataString(data_criacao, 16, ' ', 'D', 'N', 'S')+'|'
                linha += ''
                linha += formataString(x.pessoa_id.name or '', 22, ' ', 'D', 'N', 'S')+'|'
                linha += ''
                linha += formataString(tipo_titulo, 7, ' ', 'E', 'N', 'S')+'|'
                linha += ''
                linha += formataString(x.titulo_id.documento or '', 13, ' ', 'E', 'N', 'S')+'|'
                linha += ''
                linha += formataString(x.local_cobranca_id.descricao or '', 12, ' ', 'E', 'N', 'S')+'|'
                linha += ''
                linha += formataString(x.natureza_cobranca_id.name or '', 15, ' ', 'E', 'N', 'S')+'|'
                linha += ''
                linha += formataString(getNumeroEditado(x.valor or 0, 2), 10, ' ', 'E', 'N', 'S')+'|'
                linha += ''
                linha += formataString(data_prorrogacao, 13, ' ', 'E', 'N', 'S')+'|'
                linha += ''
                linha += formataString(self._get_operacao(x.operacao), 10, ' ', 'E', 'N', 'S')+'|'
                linha += ''
                listagem.imprimeLinha('|'+linha)
            listagem.imprimeLinha('*--------------------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.imprimeLinha('                                                                                                                   ** Sig Informatica LTDA **                   ')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

    def _get_operacao(self, operacao):
        if operacao:
            if operacao == 'I':
                operacao = 'Entrada'
            elif operacao == 'A':
                operacao = 'Alteracao'
            elif operacao == 'R':
                operacao = 'Registro'
            elif operacao == 'B':
                operacao = 'Baixa'
            elif operacao == 'BP':
                operacao = 'Baixa parcial'
            elif operacao == 'PR':
                operacao = 'Prorrogacao'
            elif operacao == 'C':
                operacao = 'Cancelamento'
        else:
            operacao = ''
        return operacao

report_custom('report.listagem_movimento_titulo')
