# -*- encoding: utf-8 -*-
import time
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
import StringIO
from datetime import date
from openerp import pooler
from openerp.report.interface import report_int
from openerp.report.render import render
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):

    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='1')
        listagem.informaNome(pdf_string, _('Posicao Diaria Sintetico'))
        listagem.defineMargem(1, 1, 1, 1)
        data_ini = time.strftime("%d/%m/%Y", time.strptime(datas.get('data_inicial'), "%Y-%m-%d"))
        data_fim = time.strftime("%d/%m/%Y", time.strptime(datas.get('data_final'), "%Y-%m-%d"))
        #                                1         2         3         4         5         6         7         8         9         10        20        30        40
        #                    1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890
        listagem.informaCab(
            _('Posicao Financeira                                     Sintetico                                   Periodo: ') + data_ini + _(' a ') + data_fim)
        listagem.informaCab(_('Data: ') + time.strftime("%d/%m/%Y"))
        listagem.informaCab('--')
        listagem.informaCab(
            _('Data         Entrada            Saida               Saldo       Prev. a Receb       Prev. a Pagar       Sld. C/Previs    Acumulado'))
        listagem.informaCab('--')
        listagem.informaCab('')
        # RODAPe
        listagem.informaRodape('--')
        listagem.informaRodape(
            '                                                                                                              Sig Informatica Ltda')
        #LISTAGEM
        string = formataString(_('Disponivel: ' + getNumeroEditado(datas['vr_disponivel'])),
                              27, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(string)
        listagem.imprimeLinha('')



        # listando o periodo para a pesquisa
        obj_movimentacao_diaria_movimento = pooler.get_pool(cr.dbname).get('wizard.movimentacao.diaria.movimento')
        dados_diaria_movimento = obj_movimentacao_diaria_movimento.read(cr,uid,datas['movimento_diario_ids'], context=context)

        # VARIAVEIS
        saldo = datas.get('vr_disponivel')
        # imprimindo o relatorio
        for lista in dados_diaria_movimento:
            # Data .vencimento
            data_venc = time.strftime("%d/%m/%Y", time.strptime(lista['data_prorrogacao'], "%Y-%m-%d"))
            linha = formataString(data_venc, 10, ' ', 'E', 'N', 'S')
            # Valor de entrada
            linha += formataString(getNumeroEditado(lista['valor_receber']), 10, ' ', 'E', 'S', 'S')
            # Valor de saida
            linha += formataString(getNumeroEditado(lista['valor_pagar']), 17, ' ', 'E', 'S', 'S')
            # Saldo
            saldo += lista['valor_receber'] - lista['valor_pagar']
            linha += formataString(getNumeroEditado(lista['valor_receber'] - lista['valor_pagar']), 20, ' ', 'E', 'S', 'S')
            # Previsao a receber
            linha += formataString(getNumeroEditado(lista['vr_previsao_receber']), 20, ' ', 'E', 'S', 'S')
            # Previsao a pagar
            linha += formataString(getNumeroEditado(lista['vr_previsao_pagar']), 20, ' ', 'E', 'S', 'S')
            # Saldo com Previsao
            saldo += lista['vr_previsao_receber'] - lista['vr_previsao_pagar']
            linha += formataString(getNumeroEditado((lista['valor_receber'] - lista['valor_pagar']) + (lista['vr_previsao_receber'] - lista['vr_previsao_pagar'])), 20, ' ', 'E', 'S',
                                   'S')
            # acumulado
            linha += formataString(getNumeroEditado(saldo), 13, ' ', 'E', 'S', 'S')
            listagem.imprimeLinha(linha)
            listagem.imprimeLinha('')
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.posicao_diario_sintetico_osv')







