# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from dateutil.parser import parse
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(e, c, d, t=160):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        context = context and context.copy() or {}
        title = center_title('', _('Duplicatas movimentadas'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('duplicatas_movimentadas'))
        listagem.informaTamLinha(160)

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'financeiro.titulo.historico', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        movimento_dados = datas.get('dado_movimento')
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
        docs0 = 'Cliente/Fornecedor: %s' % datas.get('pessoa')
        docs1 = formataString('Data inicial: %s' % datas.get('data_inicial'), 45, ' ', 'D', 'N',
                              'S')
        docs1 += formataString('Data final: %s' % datas.get('data_final'), 45, ' ', 'D', 'N', 'S')
        docs2 = formataString('Tipo do titulo: %s' % datas.get('tipo_titulo'), 45, ' ', 'D', 'N',
                              'S')
        docs2 += formataString('Tipo do documento: %s' % datas.get('doc_tipo'), 45, ' ', 'D', 'N',
                               'S')
        docs3 = formataString('Movimento: %s' % datas.get('movimento'), 45, ' ', 'D', 'N', 'S')
        docs3 += formataString('Ordem: %s' % datas.get('ordem'), 45, ' ', 'D', 'N', 'S')

        docs4 = ''
        if datas.get('vendedor'):
            docs4 += formataString('Vendedor: %s' % datas.get('vendedor') or '', 45, ' ', 'D', 'N',
                                   'S')
        if datas.get('vendedor_externo'):
            docs4 += formataString('Vendedor externo: %s' % datas.get('vendedor_externo') or '', 45,
                                   ' ', 'D', 'N', 'S')

        docs5 = 'Data do periodo: %s' % (datas.get('tipo_periodo') or '')

        listagem.informaCab(''+title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab(''+docs)
        listagem.informaCab('')
        listagem.informaCab(docs0)
        listagem.informaCab(docs1)
        listagem.informaCab(docs5)
        listagem.informaCab(docs2)
        listagem.informaCab(docs3)
        if docs4:
            listagem.informaCab(docs4)
        listagem.informaCab('')
        listagem.informaCab('*--------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(_('|   CODIGO   NOME                                                     ENDERECO                                                 MUNICIPIO                 UF    |'))
        listagem.informaCab(_('|P/R OPE  DUPLICATA        DT EMISSAO        VALOR  DATA VENCIMENTO   DT LANCAMENTO   BCO       DEBITO       CREDITO   JUROS   DESCONTOS   OBS.                |'))
        listagem.informaCab('*--------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab('')
        listagem.rodapePadrao()

        pessoa = ''
        total_valor_movimento_c = 0
        total_valor_movimento_d = 0
        total_geral_valor_movimento_c = 0
        total_geral_valor_movimento_d = 0
        for x in movimento_dados:
            emissao = parse(x.get('titulo_emissao')).strftime('%d/%m/%Y')
            vencimento = parse(x.get('titulo_vencimento')).strftime('%d/%m/%Y')
            lancamento = parse(x.get('movimento_lancamento')).strftime('%d/%m/%Y')
            valor_movimento_c = 0
            valor_movimento_d = 0
            if x.get('titulo_tipo') == 'P':
                if x.get('operacao') in ('I', 'TR'):
                    valor_movimento_c = x.get('titulo_valor') or 0
                if x.get('operacao') in ('B', 'BP', 'BR'):
                    valor_movimento_d = x.get('movimento_valor_pago') or 0
                if x.get('operacao') == 'C':
                    valor_movimento_d = x.get('titulo_valor') or 0
            if x.get('titulo_tipo') == 'R':
                if x.get('operacao') in ('I', 'TR'):
                    valor_movimento_d = x.get('titulo_valor') or 0
                if x.get('operacao') in ('B', 'BP', 'BR'):
                    valor_movimento_c = x.get('movimento_valor_pago') or 0
                if x.get('operacao') == 'C':
                    valor_movimento_c = x.get('titulo_valor') or 0
            if pessoa != x.get('pessoa_nome'):
                if movimento_dados.index(x) != 0:
                    self.imprimi_total(cr, uid, listagem, total_valor_movimento_c,
                                       total_valor_movimento_d, context=context)
                    total_valor_movimento_c = 0
                    total_valor_movimento_d = 0
                linha = '|'
                linha += formataString(x.get('pessoa_codigo') or '', 9, ' ', 'E', 'N', 'S')
                linha += '   '
                linha += formataString(x.get('pessoa_nome') or '', 55, ' ', 'D', 'N', 'S')
                linha += '  '
                linha += formataString(x.get('pessoa_endereco'), 55, ' ', 'D', 'N', 'S')
                linha += '  '
                linha += formataString(x.get('pessoa_cidade') or '', 24, ' ', 'D', 'N', 'S')
                linha += '  '
                linha += formataString(x.get('pessoa_uf'), 6, ' ', 'D', 'N', 'S')
                linha += '|'
                listagem.imprimeLinha(linha)
                pessoa = x.get('pessoa_nome')
            total_valor_movimento_c += valor_movimento_c
            total_valor_movimento_d += valor_movimento_d
            total_geral_valor_movimento_c += valor_movimento_c
            total_geral_valor_movimento_d += valor_movimento_d
            linha = '| '
            linha += formataString(x.get('titulo_tipo'), 3, ' ', 'D', 'N', 'S')
            linha += ' '
            linha += formataString(x.get('operacao'), 2, ' ', 'D', 'N', 'S')
            linha += '  '
            linha += formataString(x.get('titulo_documento') or '', 15, ' ', 'D', 'N', 'S')
            linha += '  '
            linha += formataString(emissao, 12, ' ', 'D', 'N', 'S')
            linha += ' '
            linha += formataString(getNumeroEditado(x.get('titulo_valor') or 0, 2), 10, ' ', 'E',
                                   'N', 'S')
            linha += '  '
            linha += formataString(vencimento, 16, ' ', 'D', 'N', 'S')
            linha += '  '
            linha += formataString(lancamento, 14, ' ', 'D', 'N', 'S')
            linha += '  '
            linha += formataString(x.get('movimento_bco'), 3, ' ', 'E', 'N', 'S')
            linha += '  '
            linha += formataString(getNumeroEditado(valor_movimento_d, 2), 11, ' ', 'E', 'N', 'S')
            linha += '  '
            linha += formataString(getNumeroEditado(valor_movimento_c, 2), 12, ' ', 'E', 'N', 'S')
            linha += '  '
            linha += formataString(getNumeroEditado(x.get('movimento_valor_juros') or 0, 2), 6, ' ',
                                   'E', 'N', 'S')
            linha += '  '
            linha += formataString(getNumeroEditado(x.get('movimento_valor_desconto') or 0, 2), 10,
                                   ' ', 'E', 'N', 'S')
            linha += '  '
            linha += formataString(x.get('titulo_observacao') or '', 19, ' ', 'D', 'N', 'S')
            linha += '  |'
            listagem.imprimeLinha(linha)
            if x == movimento_dados[-1]:
                self.imprimi_total(cr, uid, listagem, total_valor_movimento_c,
                                   total_valor_movimento_d, context=context)
        listagem.imprimeLinha('|Operacao: I=Entrada, TR=Entrada Transferencia, B=Baixa, BP=Baixa parcial, BR=Baixa Renegociacao,C=Cancelamento, A=Alteracao, R=Registro, PR=Prorrogacao       |')
        listagem.imprimeLinha('*--------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        self.imprimi_total(cr, uid, listagem, total_geral_valor_movimento_c,
                           total_geral_valor_movimento_d, total_geral=True, context=context)
        listagem.imprimeLinha('*--------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.imprimeLinha('                                                                                                                   ** Sig Informatica LTDA **                   ')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

    def imprimi_total(self, cr, uid, listagem, total_credito, total_debito, total_geral=False,
                      context=None):
        context = context and context.copy() or {}
        str_tipo_total = 'CLIENTE/FORNECEDOR'
        if total_geral:
            str_tipo_total = 'GERAL'
        linha = '|'
        linha += formataString('TOTAL %s -->' % str_tipo_total, 84, ' ', 'D', 'N', 'S')
        linha += ' '
        linha += formataString(getNumeroEditado(total_debito, 2), 16, ' ',
                               'E', 'N', 'S')
        linha += '  '
        linha += formataString(getNumeroEditado(total_credito, 2), 12, ' ',
                               'E', 'N', 'S')
        linha += '  '
        linha += ' ' * 41
        linha += '|'
        listagem.imprimeLinha(linha)
        if not total_geral:
            listagem.imprimeLinha('|' + ' ' * 158 + '|')
        return True

report_custom('report.titulo_movimentado')
