# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.tools.translate import _
from openerp.osv import osv
from SigUtils.numero import getNumeroEditado


class financeiro_tesouraria_conciliacao_capa_osv(osv.TransientModel):
    _name = 'financeiro.tesouraria.conciliacao.capa.osv'
    _inherit = 'financeiro.tesouraria.conciliacao.capa.osv'

    def button_confirm(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_tes_mov = self.pool.get('financeiro.tesouraria.movimento')
        movimento_osv_ids = self.pool.get('financeiro.tesouraria.conciliacao.itens.osv').search(
            cr, uid, [('movimento_conciliacao_osv_id', '=', ids[0]), ('conciliado', '=', True)], context=context)
        if not movimento_osv_ids:
            raise osv.except_osv(_('Atencao'), _('Nenhum movimento encontrado!'))
        movimento_conciliacao_osv_dados = self.read(cr, uid, ids, ['conta_id'], context=context,
                                                    load='_classic_write')
        if not movimento_conciliacao_osv_dados:
            raise osv.except_osv(_('Atencao'), _('Nenhuma conta encontrada!'))
        if isinstance(movimento_conciliacao_osv_dados, list):
            movimento_conciliacao_osv_dados = movimento_conciliacao_osv_dados[0]
        conta_id = movimento_conciliacao_osv_dados.get('conta_id')
        if isinstance(conta_id, (list, tuple)):
            conta_id = conta_id[0]
        for movimento in movimento_osv_ids:
            mov = self.pool.get('financeiro.tesouraria.conciliacao.itens.osv').read(
                cr, uid, movimento, ['mov_cod', 'valor', 'debito_credito'], context=context)
            self.pool.get('financeiro.tesouraria.contas').fintco_atualizar_saldo_conciliado(
                cr, uid, conta_id, mov['valor'], mov['debito_credito'])
            context['conciliado'] = True
            obj_tes_mov.write(cr, uid, [mov['mov_cod']], {'conciliado': True},
                              context=context)
        self.log(cr, uid, ids[0], _('Finalizado com sucesso!'))
        res = self.write(cr, uid, ids, {'state': '2'}, context)
        return res

    def button_concluido(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        id = ids
        if id and isinstance(id, list):
            id = id[0]
        conciliacao_itens_ids = self.pool.get('financeiro.tesouraria.conciliacao.itens.osv').search(cr, uid,
                                                                                                    [('movimento_conciliacao_osv_id','=',id)],
                                                                                                    context=context)
        self.pool.get('financeiro.tesouraria.conciliacao.itens.osv').unlink(cr, uid, conciliacao_itens_ids)
        vals = {'state': '0',
                'conta_id': '',
                'saldo_conciliado': 0.0}
        self.write(cr, uid, ids, vals, context)
        return True

    def button_atualizar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return True

    def button_localizar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj = self.pool.get('financeiro.tesouraria.movimento')
        mov = self.read(cr, uid, ids, [], context=context)
        for x in mov:
            conta_id = x.get('conta_id')
            if isinstance(conta_id, (list, tuple)):
                conta_id = conta_id[0]
        saldo = self.pool.get('financeiro.tesouraria.contas').read(
            cr, uid, conta_id, ['fintco_saldo_conciliado'], context=context).get(
            'fintco_saldo_conciliado') or 0.0
        tesouraria_movimento_ids = obj.search(
            cr, uid, [('conta_id', '=', conta_id), ('conciliado', '=', False)], context=context)
        if not tesouraria_movimento_ids:
            raise osv.except_osv(_('Atencao'),
                                 _('Nao ha movimentos a serem conciliados para esta conta!\n'
                                   'Saldo conciliado: R$%s' % getNumeroEditado(saldo)))
        self.write(cr, uid, ids, {'state': '1', 'saldo_conciliado': saldo}, context=context)
        for movimento_id in tesouraria_movimento_ids:
            res_mov = obj.read(cr, uid, movimento_id, ['data_movimento', 'historico', 'valor',
                               'conciliado', 'debito_credito'], context=context)
            vals = {
                'mov_cod': movimento_id,
                'data_movimento': res_mov['data_movimento'],
                'valor': res_mov['valor'],
                'historico': res_mov['historico'],
                'conciliado': res_mov['conciliado'],
                'debito_credito': res_mov['debito_credito'],
                'movimento_conciliacao_osv_id': ids[0]
            }
            tesouraria_movimento_id = self.pool.get(
                'financeiro.tesouraria.conciliacao.itens.osv').create(cr, uid, vals)
            self.pool.get('financeiro.tesouraria.conciliacao.itens.osv').write(
                cr, uid, tesouraria_movimento_id, {'cod': tesouraria_movimento_id}, context=context)
        return True

    def onchange_conta_id(self, cr, uid, ids, conta_id, context=None):
        context = context and context.copy() or {}
        res = dict()
        if not conta_id:
            res['value'] = {'saldo_conciliado': 0.0}
            return res
        saldo = self.pool.get('financeiro.tesouraria.contas').read(
            cr, uid, conta_id, ['fintco_saldo_conciliado'], context=context).get(
            'fintco_saldo_conciliado') or 0.0
        res['value'] = {'saldo_conciliado': saldo}
        return res
