# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv


class financeiro_tesouraria_conciliacao_itens_osv(osv.TransientModel):
    _name = 'financeiro.tesouraria.conciliacao.itens.osv'
    _inherit = 'financeiro.tesouraria.conciliacao.itens.osv'

    def button_conciliar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        # saldo = context.get('saldo', 0)
        vals = self.read(cr, uid, ids, ['debito_credito', 'valor', 'conciliado'], context=context)[0]
        conciliado = True if not vals['conciliado'] else False
        self.write(cr, uid, ids, {'conciliado': conciliado}, context)
        res = self.conciliar_saldo(cr, uid, ids, vals['debito_credito'],
                                 vals['valor'], conciliado, context=context)
        return res

    def conciliar_saldo(self, cr, uid, ids, debito_credito, valor, conciliado, context=None):
        context = context and context.copy() or {}
        codigo = self.browse(cr, uid, ids[0]).movimento_conciliacao_osv_id.id
        saldo = \
            self.pool.get('financeiro.tesouraria.conciliacao.capa.osv').read(cr, uid, codigo, ['saldo_conciliado'], context=context)[
                'saldo_conciliado']
        if conciliado and ids:
            next_id = self.browse(cr, uid, ids[0]).movimento_conciliacao_osv_id.id
            if debito_credito == 'C':
                saldo += valor
            elif debito_credito == 'D':
                saldo -= valor
            self.pool.get('financeiro.tesouraria.conciliacao.capa.osv').write(
                cr, uid, [next_id], {'saldo_conciliado': saldo}, context)
        elif not conciliado and ids: # ao desmarcar o booleano, desfaz a operacao
            next_id = self.browse(cr, uid, ids[0]).movimento_conciliacao_osv_id.id
            if debito_credito == 'C':
                saldo -= valor
            elif debito_credito == 'D':
                saldo += valor
            self.pool.get('financeiro.tesouraria.conciliacao.capa.osv').write(
                cr, uid, [next_id], {'saldo_conciliado': saldo}, context)
        dict_value = {'conciliado': conciliado,
                      'saldo_conciliado': saldo}
        return {'value': dict_value}