# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class financeiro_tesouraria_conciliacao_itens_osv(osv.TransientModel):
    _name = 'financeiro.tesouraria.conciliacao.itens.osv'
    _columns = {
        'cod': fields.integer("Codigo"), # id da conta da tesouraria
        'mov_cod': fields.integer("Codigo"), # id da conta da tesouraria
        'data_movimento': fields.date('Data'), # Data do movimento
        'valor': fields.float('Valor', digits=(14, 2)), # Valor do lancamento
        'historico': fields.text('Historico'), # Historico do lancamento
        'conciliado': fields.boolean('Conciliado'), # Flag que indica que o lancamento foi conciliado
        'debito_credito': fields.selection([('D', 'Debito'), ('C', 'Credito')], 'Debito/Credito', required=True,
                                           size=1),
        'movimento_conciliacao_osv_id': fields.many2one("financeiro.tesouraria.conciliacao.capa.osv",
                                                        'Movimento conciliacao', ondelete="cascade")
    }
    _defaults = {
        'conciliado': lambda *a: False,
        'debito_credito': lambda *a: 'D',
        'cod': lambda *a: '1',
    }
    _order = 'data_movimento,valor'


