# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
from dateutil.parser import parse
from datetime import datetime
from SigUtils.numero import getNumeroEditado

#Funcoes da classe financeiro.tesouraria.saldos
def fintsa_get_saldo_final(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    _brw_financeiro_tesouraria_saldos = self.browse(cr, uid, ids)
    for saldo in _brw_financeiro_tesouraria_saldos:
        saldo_inicial = saldo.fintsa_saldo_inicial or 0.0
        data_movimento = saldo.data_movimento
        conta_id = saldo.conta_id.id
        sql = """
            SELECT
                valor,
                debito_credito
            FROM
                financeiro_tesouraria_movimento
            WHERE
                data_movimento = '{data_movimento}'
                AND conta_id = {conta_id}
        """.format(data_movimento=data_movimento, conta_id=conta_id)
        cr.execute(sql)
        tesouraria_movimento_dados = cr.dictfetchall()
        for movimento in tesouraria_movimento_dados:
            valor = movimento.get('valor') or 0.0
            debito_credito = movimento.get('debito_credito')
            if debito_credito == 'D':
                saldo_inicial -= valor
            else:
                saldo_inicial += valor
        res[saldo.id] = saldo_inicial
    return res


def tesmov_check_criacao_movimento_conta(self, cr, uid, ids, context=None):
    context = context and context.copy() or {}
    if isinstance(ids, list):
        id = ids[0]
    else:
        id = ids
    browse_tesouraria_mov = self.pool.get('financeiro.tesouraria.movimento').browse(cr, uid, id, context)

    tesouraria_data_movimento = browse_tesouraria_mov.data_movimento
    conta_data_conciliacao = browse_tesouraria_mov.conta_id.fintco_data_conciliacao

    if conta_data_conciliacao:
        date_movimento = parse(tesouraria_data_movimento, yearfirst=True)
        date_conciliacao = parse(conta_data_conciliacao, yearfirst=True)

        if date_movimento <= date_conciliacao:
            return False
    return True

#Funcoes da classe financeiro_tesouraria_contas
def fintco_get_saldo(self, cr, uid, ids, name_field, args, context=None):
    context = context and context.copy() or {}
    res = {}

    # ___________________________ Objects ________________________________
    obj_financeiro_tesouraria_saldos = self.pool.get('financeiro.tesouraria.saldos')
    obj_financeiro_tesouraria_contas = self.pool.get('financeiro.tesouraria.contas')

    from datetime import datetime, timedelta

    # Futuro: hoje + 1 dia
    futuro = datetime.date(datetime.now() + timedelta(days=1)).strftime('%Y-%m-%d')

    for id in ids:
        conta_filha_ids = self.pool.get('financeiro.tesouraria.contas')._get_contas_filhas(
                                                                                cr, uid, id, context=context)
        saldo_conta = 0.0
        for conta_id in conta_filha_ids: # id conta e das contas filhas, netas, etc..
            saldo_ids = obj_financeiro_tesouraria_saldos.search(
                cr, uid, [('conta_id', '=', conta_id), ('data_movimento', '<', futuro)], 0, limit=1,
                order="data_movimento desc", context=context)
            if not saldo_ids:
                continue

            for brw_saldo in obj_financeiro_tesouraria_saldos.browse(cr, uid, saldo_ids):
                saldo_conta += brw_saldo.fintsa_saldo_final

        res[id] = {'fintco_saldo_final': saldo_conta}

    return res


#Funcoes da classe financeiro_tesouraria_movimento
def _fintem_get_parametro_centro_custo_evento(self, cr, uid, ids, name, arg, context=None):
    """
    Busca informacoes do parâmetro do financeiro verificando se usa ou nao centro de custos e eventos.
    Return: True or False.
    """
    context = context and context.copy() or {}
    res = {}
    for brw in self.browse(cr, uid, ids, context):
        company_id = brw.conta_id.company_id.id
        if company_id:
            obj_fin_parametro = self.pool.get('financeiro.parametros')
            parametro_id = obj_fin_parametro.search(cr, uid, [('company_id','=',company_id)], context=context)
            if parametro_id:
                usar_centro_custos_e_eventos = obj_fin_parametro.browse(cr, uid,
                                                                        parametro_id[0]).usar_centro_custos_e_eventos
                if usar_centro_custos_e_eventos:
                    res[brw.id] = True
                else:
                    res[brw.id] = False
    return res


def _fintem_get_parametro_esconde_forma_pgto(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for id in ids:
        company_id = self.browse(cr, uid, id).conta_id.company_id.id
        if company_id:
            obj_fin_parametro = self.pool.get('financeiro.parametros')
            parametro_id = obj_fin_parametro.search(cr, uid, [('company_id','=',company_id)], context=context)
            if parametro_id:
                finpar_esconde_forma_pgto = obj_fin_parametro.browse(cr, uid, parametro_id[0]).finpar_esconde_forma_pgto
                if finpar_esconde_forma_pgto:
                    res[id] = True
                else:
                    res[id] = False
    return res


def _fintem_get_dados_tesouraria(self, cr, uid, ids, field_name, args, context=None):
    """Funcao que retorna os dados dos campos funcionais nao estoriados da classe 
       financeiro.tesouraria.movimento"""
    context = context and context.copy() or {}
    res = {}
    for x in self.read(cr, uid, ids, ['fintem_titulo_ids', 'data_movimento', 'valor'], context):
        res[x.get('id')] = {'fintem_possui_titulo': True,
                            'name': '%s-%s-%s' % (x.get('id'),
                                                  datetime.strptime(x.get('data_movimento'),
                                                                    '%Y-%m-%d').strftime('%d/%m/%Y'),
                                                  getNumeroEditado(x.get('valor')),)}
        titulo_ids = x.get('fintem_titulo_ids')
        if not titulo_ids:
            res[x.get('id')]['fintem_possui_titulo'] = False

    return res
