# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class financeiro_tesouraria_baixa_forma_pgto(osv.Model):
    """
    Tabela com os valores analisados pelas formas de pagamento.
    Identifica as formas de pagamento utilizadas na movimentacao
    """
    _name = 'financeiro.tesouraria.baixa.forma.pgto'
    _columns = {
        'tesouraria_baixa_id': fields.many2one("financeiro.titulo.baixa", 'Baixa', ondelete="cascade", required=False,
                                               select=True), # Id que identifica a baixa de um titulo
        'tesouraria_movimento_id': fields.many2one("financeiro.tesouraria.movimento", 'Movimento', ondelete="cascade",
                                                   required=True, select=True),
        # Id que identifica o movimento da tesouraria
        'forma_pgto_id': fields.many2one("adm.forma.pgto", 'Forma Pagto.', ondelete="restrict", required=True,
                                         select=True), #Identifica a forma de pagamento utilizada
        'valor': fields.float('Valor', digits=(15, 2), required=True), # Valor da forma de pagamento utilizada.
    }

