# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class financeiro_tesouraria_saldos(osv.Model):
    """
    Tabela que armazena os saldos diarios das contas
        Obs.: nao recuperar o saldo direto do metodo read,
              usar o metodo get_saldo_do_dia
    """
    from funcoes import fintsa_get_saldo_final

    _name = 'financeiro.tesouraria.saldos'
    _columns = {
        'conta_id': fields.many2one("financeiro.tesouraria.contas", 'Conta', ondelete="cascade", required=True,
                                    select=True), # id da conta
        'data_movimento': fields.date('Data movimento', required=True, select=True), # Data do saldo
        'fintsa_saldo_inicial': fields.float('Saldo Inicial', digits=(14, 2), required=True, oldname="saldo"),
        'fintsa_saldo_final': fields.function(fintsa_get_saldo_final, method=True, string='Saldo Final', type='float',
                                              store=True)
    }
    _sql_constraints = [
        ('fintsa_saldo_inicial_uniq', 'unique (conta_id, data_movimento)', 'O saldo tem que ser unico por dia!'),
    ]
    _order = 'conta_id, data_movimento desc'


