# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from datetime import date, timedelta
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
from openerp import netsvc
from openerp import pooler
import time
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_extrato_bancario(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        vals_report = datas['vals_report']


        def center_title(E, C, D, T=90):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title = title
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            D = D
            title += D
            return title

        def diff_days(data_ini, data_fim):
            di = date(int(data_ini[0:4]), int(data_ini[5:7]), int(data_ini[8:10]))
            df = date(int(data_fim[0:4]), int(data_fim[5:7]), int(data_fim[8:10]))
            return (df - di).days

        pdf_string = StringIO.StringIO()

        listagem = Impressora()
        listagem.defineFormato()
        listagem.informaNome(pdf_string, _('Extrato Bancario'))
        listagem.defineMargem(1, 1, 1, 1)
        listagem.informaCab(center_title(_('Cta.Corr.Banc'), _('Extrato Bancario '), _('ccb300')))
        listagem.informaCab('')
        listagem.informaCab(
            center_title(time.strftime('%d-%m-%Y'), vals_report['nome_empresa'], _('Pag. ') + '{{ Page }}'))
        listagem.informaCab(
            _('*----------------------------------------------------------------------------------------*'))
        listagem.informaCab(
            _('   DATA    Conciliado H I S T O R I C O                                     *-- VALOR ---*'))
        listagem.informaCab(
            _('*----------------------------------------------------------------------------------------*'))
        listagem.informaCab('')
        listagem.informaRodape(
            _('*----------------------------------------------------------------------------------------*'))
        listagem.informaRodape(
            _('                                                              **  Sig Informatica Ltda  **'))
        #LISTAGEM
        periodo = formataString(_('Periodo de: ') + time.strftime("%d/%m/%Y", time.strptime(datas['vals']['data_ini'],
                                                                                         "%Y-%m-%d")) + _(' a ') + time.strftime(
            "%d/%m/%Y", time.strptime(datas['vals']['data_fim'], "%Y-%m-%d")), 90, ' ', 'C', 'S', 'S')
        banco = vals_report.get('banco')
        if isinstance(banco, list):
            banco = banco[1]
        conta = formataString(
            _('Conta Nro: ') + vals_report['nro_conta'] + _('    Banco: ') + banco + _('    Apelido: ') + vals_report['apelido'],
            90, ' ', 'C', 'S', 'S')
        listagem.imprimeLinha(periodo)
        listagem.imprimeLinha(conta)
        saldo_dia = _('                                                       SALDO ANTERIOR  ')
        saldo_dia += formataString(getNumeroEditado(vals_report['saldo_dia']), 15, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(saldo_dia)

        oMov = pooler.get_pool(cr.dbname).get('financeiro.tesouraria.movimento')
        s_atual = vals_report['saldo_dia']
        movimento_ids = vals_report.get('movimento_ids')
        for x in oMov.browse(cr, uid, movimento_ids):
            historico = x.historico
            ln = formataString(time.strftime("%d/%m/%Y", time.strptime(x.data_movimento, "%Y-%m-%d")), 10, ' ', 'D',
                               'N', 'S')
            ln += ' '
            conciliado = 'S' if x.conciliado == True else 'N'
            ln += formataString(conciliado, 10, ' ', 'C', 'S', 'S')
            ln += ' '
            ln += formataString(historico, 53, ' ', 'D', 'S', 'S')
            ln += ' '
            valor = x.valor if x.debito_credito == 'C' else x.valor * -1
            s_atual += valor
            ln += formataString(getNumeroEditado(valor), 14, ' ', 'E', 'N', 'S')
            listagem.imprimeLinha(ln)
            historico = historico[53:]
            while historico:
                ln = formataString('', 22, ' ', 'D', 'N', 'S')
                ln += formataString(historico[:53], 53, ' ', 'D', 'S', 'S')
                ln += formataString('', 15, ' ', 'E', 'N', 'S')
                listagem.imprimeLinha(ln)
                historico = historico[53:]
            # IMPRIME OS SALDOS
        saldo_atual = _('                                                       SALDO ATUAL      ')
        saldo_atual += formataString(getNumeroEditado(s_atual), 14, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(saldo_atual)
        s_conci = '%1.2f' % vals_report['fintco_saldo_conciliado']
        saldo_conci = _('                                                       SALDO CONCILIADO ')
        saldo_conci += formataString(getNumeroEditado(vals_report['fintco_saldo_conciliado']), 14, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(saldo_conci)
        saldo_hoje = _('                                                       SALDO HOJE       ')
        saldo_hoje += formataString(getNumeroEditado(vals_report['saldo_hoje']), 14, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(getNumeroEditado(saldo_hoje))

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()

        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_extrato_bancario('report.extrato.bancario')


class extrato_bancario_osv(osv.TransientModel):
    _name = 'extrato.bancario.osv'
    _description = 'Extrato Bancario'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', required=True, select=True),
        'conta_id': fields.many2one("financeiro.tesouraria.contas", 'Conta', required=True,
                                    domain="[('banco_caixa','=','B'), ('company_id','=',company_id)]"),
        'data_ini': fields.date('Emissao inicio', required=True),
        'data_fim': fields.date('Emissao fim', required=True),
        'opcao': fields.selection([('T', 'Todos'), ('C', 'Conciliados'), ('N', 'Nao Conciliados')], 'Opcao'),

    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(cr, uid, uid).company_id.id,
        'opcao': lambda *a: 'T'

    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        extrato_bancario_osv_dados = self.read(cr, uid, ids, [], context=context)
        for x in extrato_bancario_osv_dados:
            company_id = x.get('company_id')
            if isinstance(company_id, tuple):
                company_id = company_id[0]
                company = company_id
            if not isinstance(company_id, list):
                company_id = [company_id]
            res_company_dados = self.pool.get("res.company").read(cr, uid, company_id, ['name'], context=context)
            for i in res_company_dados:
                nome_empresa = i.get('name')

            if x.get('data_ini') > x.get('data_fim'):
                raise osv.except_osv(_('Atencao'), _('A Data inicial nao poder ser maior que a Data final.'))

            # DADOS DA CONTA
            oConta = pooler.get_pool(cr.dbname).get('financeiro.tesouraria.contas')
            _saldo_conciliado = 0
            apelido = '-'
            nro_conta = '-'
            banco = '-'
            if x.get('conta_id'):
                conta_id = x.get('conta_id')
                if isinstance(conta_id, tuple):
                    conta_id = conta_id[0]
                    conta = conta_id
                if not isinstance(conta_id, list):
                    conta_id = [conta_id]
                financeiro_tesouraria_contas_dados = oConta.read(cr, uid, conta_id, ['nro_conta', 'banco_id', 'apelido',
                                                                                     'fintco_saldo_conciliado'], context=context)
                for c in financeiro_tesouraria_contas_dados:
                    banco = c.get('banco_id') or ''
                    nro_conta = c.get('nro_conta') or ''
                    apelido = c.get('apelido', '') or ''
                    _saldo_conciliado = c.get('fintco_saldo_conciliado') or 0.0

            # GET SALDOS
            y1, m1, d1 = (int(z) for z in x.get('data_ini').split('-'))
            data_ini = date(y1, m1, d1) - timedelta(days=1)
            obj_financeiro_tesouraria_saldos = pooler.get_pool(cr.dbname).get('financeiro.tesouraria.saldos')

            saldo_dia = obj_financeiro_tesouraria_saldos.get_saldo_do_dia(cr, uid, conta, str(data_ini))

            saldo_hoje = obj_financeiro_tesouraria_saldos.get_saldo_do_dia(cr, uid, conta, time.strftime('%Y-%m-%d'))

            # BUSCAR OS MOVIMENTOS
            if x.get('opcao') == 'C':
                arg_conciliado = True
            elif x.get('opcao') == 'N':
                arg_conciliado = False
            args_search = [
                ('conta_id', '=', conta),
                ('data_movimento', '>=', x.get('data_ini')),
                ('data_movimento', '<=', x.get('data_fim')),
            ]
            if x.get('opcao') != 'T':
                args_search.append(('conciliado', '=', arg_conciliado))
            oMov = pooler.get_pool(cr.dbname).get('financeiro.tesouraria.movimento')
            sMov = oMov.search(cr, uid, args_search, order="data_movimento ASC", context=context)
            # DICIONARIO DE DADOS QUE SERa PASSADO P A CLASSE REPORT_CUSTOM
            datas = {}
            datas['vals_report'] = {
                'movimento_ids': sMov,
                'nome_empresa': nome_empresa,
                'saldo_dia': saldo_dia,
                'saldo_hoje': saldo_hoje,
                'fintco_saldo_conciliado': _saldo_conciliado,
                'nro_conta': nro_conta,
                'banco': banco,
                'apelido': apelido
            }
            datas['vals'] = {
                'data_ini': x.get('data_ini'),
                'data_fim': x.get('data_fim'),
                'opcao': x.get('opcao'),
                'company_id': company,
                'conta_id': conta
            }

        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'extrato.bancario',
            'datas': datas,
        }
