# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
from openerp import netsvc
from openerp import pooler
import time
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_relatorio_disponibilidade(report_int):
    def create(self, cr, uid, ids, datas, context=None):

        context = context and context.copy() or {}
    #        print datas
        pdf_string = StringIO.StringIO()

        parent_id = datas['parent_id']

        #        -----------------------------------------------------------------------

        obj_tesousaria_contas = pooler.get_pool(cr.dbname).get('financeiro.tesouraria.contas')
        obj_financeiro_tesouraria_saldos = pooler.get_pool(cr.dbname).get('financeiro.tesouraria.saldos')
        res = obj_tesousaria_contas.search(cr, uid, [('company_id', '=', parent_id),('integra_fluxo','=',True)],
                                           context=context)

        # Nome no Cabecalho ----------------------------------------------------------------------

        obj_nome = pooler.get_pool(cr.dbname).get("res.company")
        ress = obj_nome.read(cr, uid, parent_id, ['name'], context=context)
        nome_empresa = formataString(ress['name'], 40, '  ', 'D', 'S', 'S')
        #         ----------------------------------------------------------------------
        #inic
        listagem = Impressora()
        listagem.defineFormato(orientacao='1')

        listagem.informaNome(pdf_string, _('Relatorio Disponibilidade'))
        listagem.informaTamLinha(100)
        listagem.defineMargem(1, 1, 1, 1)
        cab = _('Tesouraria                                                              Disponibilidade                                                                                           Pagina: {{ Page }}')
        listagem.informaCab(cab)
        listagem.informaCab(_('ccb300'))
        listagem.informaCab(' ')
        data = time.strftime('%d-%m-%Y')
        listagem.informaCab(
            _('Data: ') + data + _('                                   Empresa Selecionada: ') + nome_empresa + '                              ')
        listagem.informaCab(' ')
        listagem.informaCab('--')
        listagem.informaCab(
            _('  Apelido                     *-- Conta --*                       *-- Saldo --*           *-- Limite Especial --*           *-- Disponivel --*     '))
        listagem.informaCab('--')
        listagem.informaCab(' ')
        listagem.informaRodape('--')
        listagem.informaRodape(
            '                                                                                                                                                             **  Sig Informatica Ltda  **')

        a = 0
        b = 0
        c = 0
        for x in obj_tesousaria_contas.browse(cr, uid, res):
            saldo = obj_financeiro_tesouraria_saldos.get_saldo_do_dia(cr, uid, x.id, datas.get('data_movimento'),
                                                                      context)
            apelido = formataString(x.apelido, 20, ' ', 'D', 'S', 'S')
            apelido += ' '
            apelido += formataString(x.nro_conta or '', 12, ' ', 'D', 'S', 'S')
            apelido += formataString(x.banco_id.admbco_codigo_bc or '', 03, ' ', 'E', 'S', 'S')
            apelido += formataString(x.banco_id.name or '', 15, ' ', 'E', 'S', 'S')
            apelido += ' '
            apelido += formataString(getNumeroEditado(saldo or 0.0), 25, ' ', 'E', 'S',
                                     'S') # usando funcao SigUtils numero
            apelido += ' '
            apelido += formataString(getNumeroEditado(x.limite_especial), 33, ' ', 'E', 'S', 'C')
            apelido += ' '
            apelido += formataString(getNumeroEditado(saldo or 0.0 + x.limite_especial or 0.0), 28, ' ', 'E', 'S', 'S')
            listagem.imprimeLinha(apelido)

            a += saldo or 0.0
            b += x.limite_especial or 0.0
            c += saldo or 0.0 + x.limite_especial or 0.0
            #fim
        listagem.imprimeLinha('--')
        ln = _('Disponibilidade para hoje!                          ')
        ln += formataString(getNumeroEditado(a), 25, ' ', 'E', 'S', 'S')
        ln += formataString(getNumeroEditado(b), 34, ' ', 'E', 'S', 'S')
        ln += formataString(getNumeroEditado(c), 29, ' ', 'E', 'S', 'S')
        listagem.imprimeLinha(ln)
        listagem.imprimeLinha('--')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_relatorio_disponibilidade('report.relatorio.disponibilidade')


class relatorio_disponibilidade_osv(osv.TransientModel):
    _name = 'relatorio.disponibilidade.osv'
    _description = 'Relatorio Disponibilidade'
    _columns = {
        'parent_id': fields.many2one("res.company", 'Empresa', required=True, select=True),
        'data_movimento': fields.date('Data Movimentacao', required=True)

    }
    _defaults = {
        'parent_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(cr, uid, uid).company_id.id,
        'data_movimento': lambda *a: time.strftime('%Y-%m-%d'),

    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        relatorio_disponibilidade_osv_dados = self.read(cr, uid, ids, [], context=context)
        for x in relatorio_disponibilidade_osv_dados:
            parent_id = x.get('parent_id')
            if isinstance(parent_id, tuple):
                parent_id = parent_id[0]
                parent = parent_id
            if not isinstance(parent_id, list):
                parent_id = [parent_id]
            res_company_dados = self.pool.get("res.company").read(cr, uid, parent_id, ['name'], context=context)
            for i in res_company_dados:
                nome_empresa = i.get('name')
            datas = {
                'parent_id': parent,
                'nome_empresa': nome_empresa,
                'data_movimento': x.get('data_movimento'),

            }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'relatorio.disponibilidade',
            'datas': datas,
        }
