# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from datetime import date, timedelta
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
from openerp import netsvc
from openerp import pooler
import time
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_relatorio_movimento(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        pdf_file = StringIO.StringIO()
        vals_report = {}
        empresa = datas['company_id']
        data = datas['data']
        data_fim = datas['data_fim']
        conta_ids = datas['conta_ids']
        _listar_classificacao = datas.get('listar_classificacao', False)
        _classificacao_origem = datas.get('classificacao_origem') or False
        obj_emp = pooler.get_pool(cr.dbname).get("res.company")
        nome_empresa = obj_emp.read(cr, uid, empresa, ['name'], context=context)['name']
        obj_conta = pooler.get_pool(cr.dbname).get('financeiro.tesouraria.contas')
        apelido_conta = ''
        tesouraria_contas_dados = obj_conta.read(cr, uid, conta_ids, ['apelido'], context=context)
        for apelido in tesouraria_contas_dados:
            apelido_conta += apelido.get('apelido')
            if apelido != tesouraria_contas_dados[-1]:
                apelido_conta += ', '
        obj_mov = pooler.get_pool(cr.dbname).get('financeiro.tesouraria.movimento')
        obj_gerencial = pooler.get_pool(cr.dbname).get('gerencial.movimento')
        ids_movimentos = obj_mov.search(
            cr, uid, [('conta_id', 'in', conta_ids), ('data_movimento', '>=', data),
                      ('data_movimento', '<=', data_fim)], order='data_movimento asc',
            context=context)
        listagem = Impressora()
        listagem.informaTamLinha(87)
        listagem.defineMargem(2, 2, 1, 1)
        listagem.informaNome(pdf_file, _('Movimento Tesouraria'))
        cab = _(' ' * 40 + 'Movimento Tesouraria' + ' ' * 38 + 'Pag.' + '{{ Page }}')
        listagem.informaCab(cab)
        listagem.informaCab(' ')
        data_emi = time.strftime('%d-%m-%Y')
        listagem.informaCab(data_emi + '                    ' + nome_empresa)
        listagem.informaCab(' ')

        listagem.informaCab(_('Periodo: %s a %s') % (
            time.strftime("%d/%m/%Y", time.strptime(data, "%Y-%m-%d")),
            time.strftime("%d/%m/%Y", time.strptime(data_fim, "%Y-%m-%d"))))

        listagem.informaCab('Conta(s): %s' % apelido_conta)

        listagem.informaCab(' ')
        listagem.informaCab(_('======================================================================================================='))
        cab = formataString(_('Data Movimento'), 16, ' ', 'D', 'S', 'S')
        cab += formataString(_('C  '), 5, ' ', 'D', 'N', 'S')
        cab += formataString(_('Historico '), 49, ' ', 'D', 'S', 'S')
        cab += formataString(_('Valor'), 15, ' ', 'D', 'S', 'S')
        listagem.informaCab(cab)
        if _listar_classificacao:
            cab = '   '
            cab += formataString(_('Centro de custo'), 20, ' ', 'D', 'S', 'S')
            cab += formataString(_('Evento'), 20, ' ', 'D', 'S', 'S')
            cab += formataString(_('Mes'), 4, ' ', 'D', 'S', 'S')
            cab += formataString(_('Ano'), 5, ' ', 'D', 'S', 'S')
            cab += formataString(_('Valor'), 10, ' ', 'D', 'S', 'S')
            cab += formataString(_('Historico'), 21, ' ', 'D', 'S', 'S')
            listagem.informaCab(cab)
        listagem.informaCab(_('======================================================================================================='))
        listagem.informaCab(' ')
        listagem.rodapePadrao()
        y1, m1, d1 = (int(x) for x in data.split('-'))
        data_ini = date(y1, m1, d1) - timedelta(days=1)
        saldos = pooler.get_pool(cr.dbname).get('financeiro.tesouraria.saldos')
        saldo_anterior = 0
        saldo_hoje = 0
        for conta_id in conta_ids:
            saldo_anterior += saldos.get_saldo_do_dia(cr, uid, conta_id, str(data_ini))
            saldo_hoje += saldos.get_saldo_do_dia(cr, uid, conta_id, time.strftime('%Y-%m-%d'))
        brw_financeiro_tesouraria_movimento = obj_mov.browse(cr, uid, ids_movimentos)
        recebimentos = sum(
            map(lambda r: r.valor, filter(lambda rr: rr.debito_credito == 'C',
                                          brw_financeiro_tesouraria_movimento)))
        pagamentos = sum(
            map(lambda r: r.valor, filter(lambda rr: rr.debito_credito == 'D',
                                          brw_financeiro_tesouraria_movimento)))
        for movimento in brw_financeiro_tesouraria_movimento:
            data_movimento = date(int(movimento.data_movimento[0:4]), int(movimento.data_movimento[5:7]),
                                  int(movimento.data_movimento[8:10]))
            linha = formataString(time.strftime("%d/%m/%Y", time.strptime(str(data_movimento), "%Y-%m-%d")), 15, ' ',
                                  'D', 'S', 'S')
            linha += ' '
            if movimento.conciliado == True:
                conc = 'C'
            else:
                conc = ' '
            linha += formataString(conc, 4, ' ', 'D', 'N', 'S')
            linha += ' '
            linha += formataString(movimento.historico, 70, ' ', 'D', 'S', 'S')
            linha += ' '
            valor = movimento.valor
            if movimento.debito_credito == 'D':
                valor = valor * -1

            linha += formataString(getNumeroEditado(valor), 10, ' ', 'E', 'S', 'S')
            linha += ' '

            listagem.imprimeLinha(linha)
            if _listar_classificacao:
                outra_conta_gerencial_mov_ids = []
                _gerencial_ids = obj_gerencial.search(
                    cr, uid, [('tesouraria_movimento_id', '=', movimento.id)], 0, None,
                    context=context)
                if _classificacao_origem:
                    _gerencial_ids, outra_conta_gerencial_mov_ids = obj_gerencial. \
                        fingmo_get_gerencial_movimento_classificacao_origem(
                            cr, uid, _gerencial_ids, context)

                for _gerencial in obj_gerencial.browse(
                        cr, uid, _gerencial_ids or outra_conta_gerencial_mov_ids, context=context):
                    linha = '   '
                    linha += formataString('%s-%s' % (_gerencial.centro_custo_id.codigo,_gerencial.centro_custo_id.name), 19, ' ', 'D', 'S', 'S')
                    linha += ' '
                    linha += formataString('%s-%s' % (_gerencial.evento_id.codigo,_gerencial.evento_id.name), 19, ' ', 'D', 'S', 'S')
                    linha += ' '
                    linha += formataString(_gerencial.mes_competencia, 4, ' ', 'D', 'S', 'S')
                    linha += formataString(_gerencial.ano_competencia, 5, ' ', 'D', 'S', 'S')
                    linha += formataString(getNumeroEditado(_gerencial.valor), 10, ' ', 'E', 'S', 'S')
                    linha += ' '
                    linha += formataString(_gerencial.fingmo_historico,20, ' ', 'D', 'S', 'S')
                    listagem.imprimeLinha(linha)
        saldo_anterior = _(' ' * 63 + 'Saldo Anterior.............') + formataString(
            getNumeroEditado(saldo_anterior), 12, ' ', 'E', 'S', 'S')
        listagem.imprimeLinha(saldo_anterior)
        recebimentos = _(' ' * 63 + 'Recebimentos...............') + formataString(
            getNumeroEditado(recebimentos), 12, ' ', 'E', 'S', 'S')
        listagem.imprimeLinha(recebimentos)
        pagamentos = _(' ' * 63 + 'Pagamentos.................') + formataString(
            getNumeroEditado(pagamentos), 12, ' ', 'E', 'S', 'S')
        listagem.imprimeLinha(pagamentos)
        saldo_fim = 0
        for conta_id in conta_ids:
            saldo_fim += saldos.get_saldo_do_dia(cr, uid, conta_id, data_fim)
        saldo_final = _(' ' * 63 + 'Saldo Final................') + formataString(
            getNumeroEditado(saldo_fim), 12, ' ', 'E', 'S', 'S')
        listagem.imprimeLinha(saldo_final)
        tesouraria_contas_dados = obj_conta.read(cr, uid, conta_ids, ['fintco_saldo_conciliado'],
                                                 context=context)
        saldo_conc = sum(map(lambda c: c.get('fintco_saldo_conciliado') or 0.0,
                             tesouraria_contas_dados))
        _saldo_conciliado = _(' ' * 63 + 'Saldo Conciliado...........') + formataString(
            getNumeroEditado(saldo_conc), 12, ' ', 'E', 'S', 'S')
        listagem.imprimeLinha(_saldo_conciliado)
        saldo_hoje = _(' ' * 63 + 'Saldo Hoje.................') + formataString(
            getNumeroEditado(saldo_hoje), 12, ' ', 'E', 'S', 'S')
        listagem.imprimeLinha(saldo_hoje)

        listagem.imprimeLinha(_('======================================================================================================='))

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_file.getvalue())
        self.obj.render()
        pdf_file.close()
        return (self.obj.pdf, 'pdf')


report_relatorio_movimento('report.relatorio.movimento')


class relatorio_movimento_osv(osv.TransientModel):
    _name = 'relatorio.movimento.osv'
    _description = 'Relatorio Movimento'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', required=True, select=True),
        'data': fields.date('Data Inicial', required=True),
        'data_fim': fields.date('Data Final', required=True),
        'listar_classificacao': fields.boolean('Listar classificacao gerencial'),
        'classificacao_origem': fields.boolean('Classificacao da origem'),
        'conta_ids': fields.many2many('financeiro.tesouraria.contas',
                                      'relatorio_movimento_m2m_tesouraria_contas',
                                      'relatorio_movimento_id',
                                      'conta_id', 'Conta', required=True,
                                      domain="[('company_id','=',company_id)]")
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(cr, uid, uid).company_id.id,
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_financeiro_tesouraria_movimento = self.pool.get('financeiro.tesouraria.movimento')
        obj_financeiro_tesouraria_contas = self.pool.get('financeiro.tesouraria.contas')
        relatorio_movimento_osv_dados = self.read(cr, uid, ids, [], context=context)
        for x in relatorio_movimento_osv_dados:
            company_id = x.get('company_id')
            if isinstance(company_id, tuple):
                company_id = company_id[0]
                company = company_id
            if not isinstance(company_id, list):
                company_id = [company_id]
            res_company_dados = self.pool.get("res.company").read(cr, uid, company_id, ['name'], context=context)
            for i in res_company_dados:
                nome_empresa = i.get('name')
            if x.get('data_fim') < x.get('data'):
                raise osv.except_osv(_('Atencao'), _('Data  final maior que data inicial'))
            conta_ids = x.get('conta_ids')

            list_contas = list()
            for conta_id in conta_ids:
                list_contas.extend(obj_financeiro_tesouraria_contas._get_contas_filhas(
                    cr, uid, conta_id, context))
            ids_movimentos = obj_financeiro_tesouraria_movimento.search(
                cr, uid, [('conta_id', 'in', list_contas), ('data_movimento', '>=', x.get('data')),
                          ('data_movimento', '<=', x.get('data_fim'))], order='data_movimento asc',
                context=context)
            if not ids_movimentos:
                raise osv.except_osv(_('Atencao'), _('Nao ha dados para gerar o relatorio.'))

            datas = {
                'company_id': company,
                'nome_empresa': nome_empresa,
                'data': x.get('data'),
                'data_fim': x.get('data_fim'),
                'conta_ids': list_contas,
                'listar_classificacao': x.get('listar_classificacao'),
                'classificacao_origem': x.get('classificacao_origem')
            }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'relatorio.movimento',
            'datas': datas,
        }

