# -*- encoding: utf-8 -*-
#Testes para a classe financeiro_cheque_devolucao
# É necessário a instalação do pacote pytest-oerp
# Para executar use: py.test --oerp-server=/usr/local/lib/python2.7/dist-packages/openerp-7.0_5B2-py2.7.egg --oerp-db=teste /tmp/example.py

from datetime import date, timedelta
import test_titulo
from openerp import SUPERUSER_ID

def _financeiro_cheque_devolucao_criar(oerp, vals=None):
    _fcd = oerp.pool.get('financeiro.cheque.devolucao')
    _md_id = oerp.pool.get('financeiro.cheque.motivo.devolucao').search(oerp.cr, SUPERUSER_ID, [])[0]
    _vals_fcd = {
        'data_devolucao': str(date.today()),
        'motivo_devol_id': _md_id,
    }
    if vals:
        _vals_fcd.update(vals)
    _fcd_id = _fcd.create(oerp.cr, SUPERUSER_ID, _vals_fcd)
    return _fcd_id

def test_financeiro_cheque_devolucao_create(oerp):
    # Criar o cheque, baixar o cheque e devolver
    # Quando lança um devolução de cheque, o saldo precisa ser retornado e o state tambem
    _chq_id = test_titulo._financeiro_cheque_criar(oerp)
    _vals = {
        'state': 'B',
        'saldo': 0,
    }
    _ft = oerp.pool.get('financeiro.titulo')
    _ft.write(oerp.cr, SUPERUSER_ID, _chq_id, _vals)
    vals = {
        'cheque_id': _chq_id,
    }
    _fcd_id = _financeiro_cheque_devolucao_criar(oerp, vals)
    _fcd = oerp.pool.get('financeiro.cheque.devolucao')
    _dados_cheque = _ft.read(oerp.cr, SUPERUSER_ID, _chq_id, [])
    assert _dados_cheque.get('state') == 'A'
    assert _dados_cheque.get('saldo') == _dados_cheque.get('vr_original')
    #


