# -*- coding: utf-8 -*-

from openerp.tests.common import TransactionCase
from sigaddons.config_teste import set_config


class TestFinanceiroTituloBaixa(TransactionCase):
    """
    Classe responsavel por testes unitarios nos metodos da classe financeiro_titulo_baixa
    :author: Tiago Henrique Prates dos Santos <tiago.santos[at]siginformatica.com.br>
    """

    @classmethod
    def setUpClass(cls):
        set_config()

    def setUp(self):
        super(TestFinanceiroTituloBaixa, self).setUp()
        self.financeiro_titulo_baixa = self.registry('financeiro.titulo.baixa')
        self.titulo_ids = self.get_titulo_ids()
        self.titulo_baixa_ids = self.get_titulo_baixa_ids()

    def get_titulo_ids(self):
        return self.registry('financeiro.titulo').search(
            self.cr, self.uid, [('tipo_titulo', '=', 'R'), ('state', '=', 'B')], limit=2)

    def get_titulo_baixa_ids(self):
        return self.financeiro_titulo_baixa.search(
            self.cr, self.uid, [('titulo_id', 'in', self.titulo_ids)])

    def test_fintib_efetua_cancelamento(self):
        res = self.financeiro_titulo_baixa.fintib_efetua_cancelamento(
            self.cr, self.uid, self.titulo_baixa_ids, {})
        self.assertTrue(res)
