# -*- encoding: utf-8 -*-
#Testes para a classe financeiro_titulo
# É necessário a instalação do pacote pytest-oerp
# Para executar use: py.test --oerp-server=/usr/local/lib/python2.7/dist-packages/openerp-7.0_5B2-py2.7.egg --oerp-db=teste /tmp/example.py

from datetime import date, timedelta
from openerp import SUPERUSER_ID

def _financeiro_titulo_criar(oerp, vals=None):
    if isinstance(vals, dict):
        vals = {}
    if not vals.get('pessoa_id', False):
        _pessoa_id = oerp.pool.get('adm.pessoa').search(oerp.cr, SUPERUSER_ID, [])[0]
        vals['pessoa_id']= _pessoa_id
    _ft = oerp.pool.get('financeiro.titulo')
    _venc = str(date.today()+timedelta(days=30))
    _lc_id = oerp.pool.get('financeiro.local.cobranca').search(oerp.cr, SUPERUSER_ID, [])[0]
    _vals_ft = {
        'parcela': 1,
        'saldo': 115.16,
        'vr_multa': 2.30,
        'vr_original': 115.16,
        'vr_juros_dia': 0.12,
        'documento': 758941,
        'data_vencimento': _venc,
        'multa_apos_data': _venc,
        'tipo_titulo': 'R',
        'tipo_sacado': 'C',
        'local_cobranca': _lc_id,
        'data_emissao': _venc,
    }
    if vals:
        _vals_ft.update(vals)
    _ft_id = _ft.create(oerp.cr, SUPERUSER_ID, _vals_ft)
    return _ft_id

def _financeiro_cheque_criar(oerp, vals=None):
    if not isinstance(vals, dict):
        vals = {}
    if not vals.get('fintit_chq_banco'):
        vals.update({'fintit_chq_banco': '001'})
    if not vals.get('fintit_chq_agencia'):
        vals.update({'fintit_chq_agencia': '1234'})
    if not vals.get('fintit_chq_conta'):
        vals.update({'fintit_chq_conta': '445566'})
    _ft_id = _financeiro_titulo_criar(oerp, vals)
    return _ft_id
