# -*- coding: utf-8 -*-

from openerp.tests.common import TransactionCase
from sigaddons.config_teste import set_config


class TestTitulosLiquidadosOsv(TransactionCase):
    """
    Classe responsavel por testes unitarios dos metodos da classe titulos_liquidados_osv
    :author: Tiago Henrique Prates dos Santos <tiago.santos[at]siginformatica.com.br>
    """

    @classmethod
    def setUpClass(cls):
        set_config()

    def setUp(self):
        super(TestTitulosLiquidadosOsv, self).setUp()
        self.titulos_liquidados_osv = self.registry('titulos.liquidados.osv')
        self.financeiro_titulo_baixa_view = self.registry('financeiro.titulo.baixa.view')
        self.titulo_liquidado_id = self.cria_titulo_liquidado()

    def cria_titulo_liquidado(self):
        company_id = self.registry('adm.empresa.objeto').getEmpresa(self.cr, self.uid,
                                                                    'financeiro.titulo')
        sql = """
            SELECT
                data_pgto,
                pessoa_id
            FROM
                financeiro_titulo_baixa_view
            WHERE
                tipo_titulo = 'R'
                AND pessoa_id > 0
                AND state IN ('A', 'B')
                AND company_id = %s
            LIMIT 1
        """ % company_id
        self.cr.execute(sql)
        titulo_baixa_view_dados = self.cr.dictfetchone()

        vals = {'tipo_titulo': 'R', 'data_ini': titulo_baixa_view_dados.get('data_pgto'),
                'data_fim': titulo_baixa_view_dados.get('data_pgto'),
                'pessoa_id': titulo_baixa_view_dados.get('pessoa_id')}
        return self.titulos_liquidados_osv.create(self.cr, self.uid, vals)

    def test_button_print(self):
        res = self.titulos_liquidados_osv.button_print(self.cr, self.uid,
                                                       [self.titulo_liquidado_id])
        self.assertEqual(type(res), dict)
