# -*- encoding: utf-8 -*-
from openerp.osv import osv, fields
import time
from openerp.tools.translate import _


class cancelamento_titulo_osv(osv.TransientModel):
    _name = 'cancelamento.titulo.osv'

    def _wizcto_check_titulo_aberto(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, dict):
            if ids.get('active_id'):
                id = ids['active_id']
                estado = self.pool.get('financeiro.titulo').read(cr, uid, id, ['state'], context=context)['state']
                if estado == 'A':
                    estado = True
                else:
                    estado = False
                return estado

    _columns = {
        'state': fields.selection([('init', 'init'), ('salvar', 'salvar')], 'status'),
        'wizcto_titulo_aberto': fields.boolean('titulo aberto'),
    }

    _defaults = {
        'wizcto_titulo_aberto': _wizcto_check_titulo_aberto,
    }

    def testa_titulo_avista(self, cr, uid, titulo, context=None):
        '''
        Retorna True se o titulo eh a vista(data emissao=data vencimento) e False se nao for
        '''
        context = context and context.copy() or {}
        return titulo.data_emissao == titulo.data_vencimento

    def salvar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        titulos_ids = context.get('active_ids', False)
        if not titulos_ids:
            return {'type': 'ir.actions.act_window_close'}
        obj_financeiro_titulo_baixa = self.pool.get('financeiro.titulo.baixa')
        obj_financeiro_titulo_historico = self.pool.get('financeiro.titulo.historico')
        obj_financeiro_titulo = self.pool.get('financeiro.titulo')
        brw_financeiro_titulo = obj_financeiro_titulo.browse(cr, uid, titulos_ids, context)
        msg_erro_cancelado = msg_erro = ''
        for titulo in filter(lambda f: f.state != 'C' if context.get(
                'cancelamento_nf') else True, brw_financeiro_titulo):
            if not self.testa_titulo_avista(cr, uid, titulo, context=context):
                if titulo.data_baixa and titulo.state != 'A':
                    msg_erro_cancelado += titulo.documento + ','
                if titulo.state != 'A':
                    msg_erro += titulo.documento + ','

        if (msg_erro_cancelado or msg_erro) and not context.get('cumpom_de_cancelamento'):
            raise osv.except_osv(_('Atencao'),
                                 _('Titulo ja baixado. Nao pode ser cancelado') + ':\n' +
                                 msg_erro_cancelado[:-1] + '\n' + _('Os titulos:') +
                                 '\n%s\n' % msg_erro[:-1] +
                                 _('nao podem ser cancelados pois nao estao mais em aberto!'))

        data = time.strftime('%Y-%m-%d')
        for titulo in brw_financeiro_titulo:
            valor_pago = sum(map(lambda b: b.valor_pago + b.valor_juros + b.valor_multa +
                                           b.fintib_vr_acrescimo - b.valor_desconto,
                                 titulo.fintit_baixa_ids))

            estorno_realizado = obj_financeiro_titulo_baixa.fintib_estorna_baixa(
                cr, uid, map(lambda t: t.id, titulo.fintit_baixa_ids), context)
            if not estorno_realizado:
                continue

            self.pool.get('financeiro.titulo').write(cr, uid, titulo.id, {
                'state': 'C',
                'data_cancelamento': data,
                'fintit_cancel_user_id': uid,
                'saldo': titulo.saldo + valor_pago
            }, context=context)

            titulo_historico_ids = obj_financeiro_titulo_historico.search(
                cr, uid, [('titulo_id', '=', titulo.id),
                          ('operacao', 'in', ('B', 'BP'))], context=context)
            if not titulo_historico_ids:
                continue
            obj_financeiro_titulo_historico.unlink(cr, uid, titulo_historico_ids, context)

        return {'type': 'ir.actions.act_window_close'}
