# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2010 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import fields, osv


class cliente_debitos_capa_wizard(osv.TransientModel):

    def _get_itens(self, cr, uid, context=None):
        context = context and context.copy() or {}
        titulos_ids = []
        pessoa_id = self._get_pessoa(cr, uid, context)
        if not pessoa_id:
            return  titulos_ids
        obj_financeiro_titulo = self.pool.get('financeiro.titulo')
        titulos_ids = obj_financeiro_titulo.search(cr, uid, [('pessoa_id', '=', pessoa_id),
                                                             ('state', '=', 'A'),
                                                             ('tipo_titulo', '=', 'R')],
                                                   context=context)
        return titulos_ids

    def _get_pessoa(self, cr, uid, context=None):
        context = context and context.copy() or {}
        pessoa_id = False
        active_model = context.get('active_model')
        if not active_model:
            return pessoa_id
        obj_do_modelo_ativo = self.pool.get(active_model)
        active_id = context.get('active_id')
        if active_model == 'fiscal.nf.capa':
            pessoa_id = obj_do_modelo_ativo.browse(cr, uid, active_id).destinatario_id.id or False
        else:
            pessoa_id = obj_do_modelo_ativo.browse(cr, uid, active_id).pessoa_id.id or False
        return pessoa_id

    _name = "cliente.debitos.capa.wizard"
    _columns = {
        'pessoa_id': fields.many2one("adm.pessoa", 'Cliente'),
        'debitos_itens_ids': fields.one2many('financeiro.titulo', 'pessoa_id', 'Titulos'),
        'vr_limite_credito': fields.float('Limite de credito', digits=(12, 2), readonly=True),
        'vr_titulo_a_vencer': fields.float('Titulos a vencer', digits=(15, 2), readonly=True),
        'vr_titulo_vencido': fields.float('Titulos vencidos', digits=(15, 2), readonly=True),
        'vr_total_aberto': fields.float('Titulos em aberto', digits=(15, 2), readonly=True)
    }

    _defaults = {
        'pessoa_id': _get_pessoa,
        'debitos_itens_ids': _get_itens
    }

    def default_get(self, cr, uid, fields_list, context=None):
        context = context and context.copy() or {}
        res = super(cliente_debitos_capa_wizard, self).default_get(cr, uid, fields_list, context)
        if not res.get('pessoa_id'):
            return res
        pessoa_id = res.get('pessoa_id')
        obj_financeiro_cliente = self.pool.get('financeiro.cliente')
        obj_financeiro_util = self.pool.get('financeiro')
        cliente_ids = obj_financeiro_cliente.search(
            cr, uid, [('pessoa_id', '=', pessoa_id)], context=context)
        if cliente_ids:
            res.update({'vr_limite_credito': obj_financeiro_cliente.read(
                cr, uid, cliente_ids[0], ['limite_credito'], context).get('limite_credito') or 0.0})
        res.update({'vr_titulo_a_vencer': obj_financeiro_util.finutl_get_valor_a_vencer(
            cr, uid, pessoa_id, context).get(pessoa_id) or 0.0,
                    'vr_titulo_vencido': obj_financeiro_util.finutl_get_valor_em_atraso(
            cr, uid, pessoa_id, context).get(pessoa_id) or 0.0})
        res.update({'vr_total_aberto': res.get('vr_titulo_a_vencer') + res.get(
            'vr_titulo_vencido')})
        return res
