# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
from openerp import netsvc
from openerp import pooler
import time
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_listagem_cheques_devolvidos(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        pdf_file = StringIO.StringIO()

        vals_report = {}
        empresa = datas['company_id']
        data_ini = datas['data_ini']
        data_fim = datas['data_fim']
        obj_emp = pooler.get_pool(cr.dbname).get("res.company")
        emp_filhas = obj_emp.search(cr, uid, [('parent_id', '=', empresa)], context=context)
        ids_emp_filhas = [empresa]
        if emp_filhas:
            ids_emp_filhas += emp_filhas

        obj_titulo = pooler.get_pool(cr.dbname).get('financeiro.titulo')
        ids_tit = obj_titulo.search(cr, uid, [('company_id', 'in', ids_emp_filhas), ('doc_tipo_id', '=', 'CHQ')],
                                    context=context)

        obj_dev = pooler.get_pool(cr.dbname).get('financeiro.cheque.devolucao')

        def dictfetchall(cr, sql):
            """Retorna todas as linhas de um cursor como um dicionario"""
            cr.execute(sql)
            desc = cr.description
            return [dict(zip([col[0] for col in desc], row)) for row in cr.fetchall()]

        sql = """
            select
                min(data_devolucao) as data_min,
                max(data_devolucao) as data_max
            from financeiro_cheque_devolucao
              """
        min_max_date = dictfetchall(cr, sql)
        vals_report['min_max_date'] = min_max_date

        data_ini = datas['data_ini'] if datas['data_ini'] != False else min_max_date[0]['data_min']
        data_fim = datas['data_fim'] if datas['data_fim'] != False else min_max_date[0]['data_max']

        res = obj_emp.read(cr, uid, empresa, ['name'], context=context)
        nome_empresa = formataString(res['name'], 40, '  ', 'C', 'S', 'S')
        ids_titulos = []
        for titulo in obj_titulo.browse(cr, uid, ids_tit):#separando titulos em que ocorreu devolucao de chq
            id = titulo.id
            a = obj_dev.search(cr, uid, [('cheque_id', '=', id)], context=context)
            if a:
                ids_titulos.append(titulo.id)
        ids_chq = obj_dev.search(cr, uid, [('cheque_id', 'in', ids_titulos), ('data_devolucao', '>=', data_ini),
                                           ('data_devolucao', '<=', data_fim)], context=context) ####----------
        busca_tit = []
        for i in obj_dev.browse(cr, uid, ids_chq):
            busca_tit.append(i.cheque_id.id)

        lista_arg = _('Criterios de Pesquisa: ')

        if datas['data_ini'] != False:
            lista_arg += '|Data Inicial: ' + datas['data_ini']
        if datas['data_fim'] != False:
            lista_arg += '|Data Final: ' + datas['data_fim']

        listagem = Impressora()
        listagem.defineFormato(orientacao='1')

        listagem.informaNome(pdf_file, _('Listagem de Cheques Devolvidos'))
        listagem.informaTamLinha(160)
        listagem.defineMargem(1, 1, 1, 1)
        cab = _('Contas a Receber                                     ') + nome_empresa + _('                                                                                                       Pagina: {{ Page }}')
        listagem.informaCab(cab)
        listagem.informaCab(' ')
        data = time.strftime('%d-%m-%Y')
        listagem.informaCab(
            _('Data: ') + data + _('                                                   Listagem de Cheques Devolvidos                              '))
        listagem.informaCab(' ')
        listagem.informaCab(lista_arg)
        listagem.informaCab(' ')
        listagem.informaCab('--')
        cab = formataString(_('Nro Doc.'), 10, '  ', 'D', 'N', 'S')
        cab += formataString(_('Banco'), 29, ' ', 'D', 'S', 'S')
        cab += formataString(_('Cliente'), 37, ' ', 'D', 'S', 'S')
        cab += formataString(_('CPF / CNPJ'), 20, ' ', 'D', 'S', 'S')
        cab += formataString(_('Emissao'), 12, ' ', 'D', 'S', 'S')
        cab += formataString(_('Vencimento'), 12, ' ', 'D', 'S', 'S')
        cab += formataString(_('Valor'), 12, ' ', 'D', 'S', 'S')
        cab += formataString(_('Stat.'), 8, ' ', 'D', 'S', 'S')
        cab += formataString(_('Qt.Dev.'), 8, ' ', 'D', 'S', 'S')
        cab += formataString(_('Data Devol.'), 12, ' ', 'D', 'S', 'S')
        cab += formataString(_('Motivo Devol.'), 14, ' ', 'D', 'N', 'S')
        listagem.informaCab(cab)
        listagem.informaCab('--')
        listagem.informaCab(' ')
        listagem.rodapePadrao()

        for empresa in obj_titulo.browse(cr, uid, busca_tit):

            id_chq_dev = obj_dev.search(cr, uid, [('cheque_id', '=', empresa.id)], context=context)
            linha = formataString(empresa.documento, 10, ' ', 'D', 'N', 'S')
            linha += ' '
            linha += formataString(empresa.fintit_chq_banco, 28, ' ', 'D', 'S', 'S')
            linha += ' '
            linha += formataString(empresa.pessoa_id.name, 36, ' ', 'D', 'N', 'S')
            linha += ' '
            if empresa.pessoa_id.cpf_cnpj:
                linha += formataString(empresa.pessoa_id.cpf_cnpj, 19, ' ', 'D', 'S', 'S')
            else:
                linha += formataString(' ', 19, ' ', 'D', 'N', 'S')
            linha += ' '
            linha += formataString(empresa.data_emissao, 11, ' ', 'D', 'S', 'S')
            linha += ' '
            linha += formataString(empresa.data_prorrogacao, 11, ' ', 'D', 'S', 'S')
            linha += ' '
            linha += formataString(empresa.vr_original, 12, ' ', 'D', 'S', 'S')
            linha += ' '
            linha += formataString(empresa.state, 6, ' ', 'D', 'S', 'S')
            linha += ' '
            for devolucao in obj_dev.browse(cr, uid, id_chq_dev):
                qt_dev = devolucao.quant_devolucao
                data_dev = devolucao.data_devolucao
                mot_dev = devolucao.motivo_devol_id.name
            linha += formataString(qt_dev, 7, ' ', 'D', 'S', 'S')
            linha += ' '
            linha += formataString(data_dev, 11, ' ', 'D', 'S', 'S')
            linha += ' '
            linha += formataString(mot_dev, 42, ' ', 'D', 'S', 'S')
            linha += ' '
            listagem.imprimeLinha(linha)

        listagem.imprimeLinha('--')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_file.getvalue())
        self.obj.render()
        pdf_file.close()
        return (self.obj.pdf, 'pdf')


report_listagem_cheques_devolvidos('report.listagem.cheques.devolvidos')


class listagem_cheques_devolvidos_osv(osv.TransientModel):
    _name = 'listagem.cheques.devolvidos.osv'
    _description = 'Listagem de Cheques Devolvidos'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', required=True, select=True),
        'data_ini': fields.date('Data Inicial'),
        'data_fim': fields.date('Data Final')

    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(cr, uid, uid).company_id.id,

    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        listagem_cheques_devolvidos_osv_dados = self.read(cr, uid, ids, [], context=context)
        for x in listagem_cheques_devolvidos_osv_dados:
            company_id = x.get('company_id')
            if isinstance(company_id, tuple):
                company_id = company_id[0]
                company = company_id
            if not isinstance(company_id, list):
                company_id = [company_id]
            res_company_dados = self.pool.get("res.company").read(cr, uid, company_id, ['name'], context=context)
            for i in res_company_dados:
                nome_empresa = i.get('name')
            datas = {
                'company_id': company,
                'nome_empresa': nome_empresa,
                'data_ini': x.get('data_ini'),
                'data_fim': x.get('data_fim')
            }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'listagem.cheques.devolvidos',
            'datas': datas,
        }
