# -*- encoding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
from openerp import netsvc
from openerp import pooler
import time
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_listagem_cheques_receber(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        pdf_file = StringIO.StringIO()

        # NOME DA EMPRESA
        oEmp = pooler.get_pool(cr.dbname).get("res.company")

        nome_empresa = datas['vals'][0]['company_id']

        data_emi_ini = datas['vals'][0]['data_emi_ini']
        data_emi_fim = datas['vals'][0]['data_emi_fim']
        data_vct_ini = datas['vals'][0]['data_vct_ini']
        data_vct_fim = datas['vals'][0]['data_vct_fim']
        if data_emi_ini:
            data_emi_ini = time.strftime("%d/%m/%Y", time.strptime(datas['vals'][0]['data_emi_ini'], "%Y-%m-%d"))
        else:
            data_emi_ini = ""
        if data_emi_fim:
            data_emi_fim = time.strftime("%d/%m/%Y", time.strptime(datas['vals'][0]['data_emi_fim'], "%Y-%m-%d"))
        else:
            data_emi_fim = ""
        if data_vct_ini:
            data_vct_ini = time.strftime("%d/%m/%Y", time.strptime(datas['vals'][0]['data_vct_ini'], "%Y-%m-%d"))
        else:
            data_vct_ini = ""
        if data_vct_fim:
            data_vct_fim = time.strftime("%d/%m/%Y", time.strptime(datas['vals'][0]['data_vct_fim'], "%Y-%m-%d"))
        else:
            data_vct_fim = ""

        lista_arg = _('|Emissao: ') + data_emi_ini + _(' a ') + data_emi_fim + _('     Vencimento:') + data_vct_ini + _(
            ' a ') + data_vct_fim
        total = 0

        listagem = Impressora()
        listagem.defineFormato(orientacao='1')

        listagem.informaNome(pdf_file, _('Listagem de Cheques a Receber'))
        listagem.informaTamLinha(160)
        listagem.defineMargem(1, 1, 1, 1)
        cab = u'                                                         ' + nome_empresa + _(
            '                                                                                                       Pagina: {{ Page }}')
        listagem.informaCab(cab)
        listagem.informaCab(' ')
        data = time.strftime('%d-%m-%Y')
        listagem.informaCab(_('Data: ') + data + _(
            '                                                   Listagem de Cheques a Receber                               '))
        listagem.informaCab(' ')
        listagem.informaCab(lista_arg)
        listagem.informaCab(' ')
        listagem.informaCab('--')
        cab = formataString(_('Nro Doc.'), 10, '  ', 'D', 'N', 'S')
        cab += formataString('', 19, ' ', 'D', 'S', 'S')
        cab += formataString(_('Cliente'), 32, ' ', 'D', 'S', 'S')
        cab += formataString('', 20, ' ', 'D', 'S', 'S')
        cab += formataString(_('Emissao'), 15, ' ', 'D', 'S', 'S')
        cab += formataString(_('Vencimento'), 15, ' ', 'D', 'S', 'S')
        cab += formataString(_('Valor'), 12, ' ', 'D', 'S', 'S')
        listagem.informaCab(cab)
        listagem.informaCab('--')
        listagem.informaCab(' ')
        listagem.rodapePadrao()

        vals = datas.get('vals')
        if vals:
            for x in vals:
                total += x.get('vr_original') or 0.0
                linha = formataString(x.get('documento') or '', 10, ' ', 'D', 'N', 'S')
                linha += ' '
                linha += formataString('', 18, ' ', 'D', 'S', 'S')
                linha += ' '
                linha += formataString(x.get('pessoa_id') or '', 31, ' ', 'D', 'N', 'S')
                linha += ' '
                linha += formataString(' ', 19, ' ', 'D', 'N', 'S')
                linha += ' '
                linha += formataString(x.get('data_emissao') or '', 14, ' ', 'D', 'S', 'S')
                linha += ' '
                linha += formataString(x.get('data_prorrogacao') or '', 14, ' ', 'D', 'S', 'S')
                linha += ' '
                linha += formataString(float(x.get('vr_original')) or 0.0, 12, ' ', 'D', 'S', 'S')
                linha += ' '
                listagem.imprimeLinha(linha)
            listagem.imprimeLinha(
                _('          TOTAL: ---->  ' + '                                                                                        ') + str(
                    float(total)))
        listagem.imprimeLinha('--')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_file.getvalue())
        self.obj.render()
        pdf_file.close()
        return (self.obj.pdf, 'pdf')


report_listagem_cheques_receber('report.listagem.cheques.receber')


class listagem_cheques_receber_osv(osv.TransientModel):
    _name = 'listagem.cheques.receber.osv'
    _description = 'Listagem de Cheques a Receber'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', required=True, select=True),
        'cliente_id': fields.many2one("adm.pessoa", 'Cliente', ondelete="cascade", select=False), # id da pessoa
        'cliente_ini': fields.char('Comece com', size=50),
        'cliente_fim': fields.char('Termina com', size=50),
        'data_emi_ini': fields.date('Emissao inicio'),
        'data_emi_fim': fields.date('Emissao fim'),
        'data_vct_ini': fields.date('Vencimento inicio'),
        'data_vct_fim': fields.date('Vencimento fim', ),

    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(cr, uid, uid).company_id.id,
        'cliente_ini': lambda *a: 'a',
        'cliente_fim': lambda *a: 'z',

    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = self.read(cr, uid, ids[0], [], context=context)

        company_id = vals.get('company_id')
        if isinstance(company_id, tuple):
            company_id = company_id[0]
        vals_report = {}
        # BUSCAR EMPRESAS FILHAS
        oEmp = pooler.get_pool(cr.dbname).get("res.company")
        sEmpFilhas = oEmp.search(cr, uid, [('parent_id', '=', company_id)], context=context)
        EmpFilhasIds = [company_id]
        if sEmpFilhas:
            EmpFilhasIds += sEmpFilhas
            # NOME DA EMPRESA
        nome_empresa = oEmp.read(cr, uid, company_id, ['name'], context=context)['name']
        vals['nome_empresa'] = nome_empresa
        # BUSCAR OS TITULOS
        oTit = pooler.get_pool(cr.dbname).get('financeiro.titulo')

        args_search = [
            ('tipo_titulo', '=', 'R'),
            ('state', '=', 'A'),
            ('tipo_lancamento', '!=', 'A'),
            ('doc_tipo_id', '=', 6), # doc_tipo_id = 6 -> CHEQUE
            ('company_id', 'in', EmpFilhasIds)]

        if vals['data_vct_ini']:
            args_search.append(
                ('data_prorrogacao', '>=', vals['data_vct_ini']))
            if vals['data_vct_fim']:
                args_search.append(
                    ('data_prorrogacao', '<=', vals['data_vct_fim']))
        if vals['data_emi_ini']:
            args_search.append(
                ('data_emissao', '>=', vals['data_emi_ini']))
            if vals['data_emi_fim']:
                args_search.append(
                    ('data_emissao', '<=', vals['data_emi_fim']))
        if vals.get('cliente_id'):
            cliente_id = vals.get('cliente_id')
            if isinstance(cliente_id, tuple):
                cliente_id = cliente_id[0]
            args_search.append(
                ('pessoa_id', '=', cliente_id))

        sTit = oTit.search(cr, uid, args_search, context=context)
        # LISTAGEM DO RELATORIO
        datas = {}

        vals1 = []
        for lista in oTit.browse(cr, uid, sTit):
            vals1.append({
                'company_id': lista.company_id.name,
                'documento': lista.documento,
                'local_cobranca_id': lista.local_cobranca_id.name,
                'agencia_id': lista.agencia_id.admbag_codigo_agencia,
                'pessoa_id': lista.pessoa_id.name,
                'cpf_cnpj': lista.pessoa_id.cpf_cnpj,
                'data_emissao': time.strftime("%d/%m/%Y", time.strptime(lista.data_emissao, "%Y-%m-%d")),
                'data_prorrogacao': time.strftime("%d/%m/%Y", time.strptime(lista.data_prorrogacao, "%Y-%m-%d")),
                'vr_original': lista.vr_original,
                'data_vct_ini': vals['data_vct_ini'],
                'data_vct_fim': vals['data_vct_fim'],
                'data_emi_ini': vals['data_emi_ini'],
                'data_emi_fim': vals['data_emi_fim'],
                'cliente_id': vals['cliente_id'],

            })

        datas['vals'] = vals1

        if not vals1:
            raise osv.except_osv(_('Atencao'), _('Nao ha dados para gerar o relatorio'))
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'listagem.cheques.receber',
            'datas': datas
        }
