# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
from openerp import netsvc
from openerp import pooler
import time
from openerp.tools.translate import _
from SigUtils.numero import Numero
from SigUtils.datas import calcUltimoDiaDoMes
from dateutil.parser import parse


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_listagem_clientes(report_int):
    _mes_do_ano = {
        1: 'Janeiro',
        2: 'Fevereiro',
        3: _('Marco'),
        4: 'Abril',
        5: 'Maio',
        6: 'Junho',
        7: 'Julho',
        8: 'Agosto',
        9: 'Setembro',
        10: 'Outubro',
        11: 'Novembro',
        12: 'Dezembro'
    }

    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        pdf_file = StringIO.StringIO()
        empresa = datas['company_id']
        tipo_pessoa = datas['tipo_pessoa']
        data_nasc = datas['data_nasc']
        sexo = datas['sexo']
        categoria_id = datas['categoria_id']
        pais_id = datas['pais_id']
        uf_id = datas['uf_id']
        cidade_id = datas['cidade_id']
        bairro_id = datas['bairro_id']
        ordem = datas['ordem']
        situacao = datas.get('situacao')
        data_referencia = datas.get('data_referencia')

        obj_emp = pooler.get_pool(cr.dbname).get("res.company")
        res = obj_emp.read(cr, uid, empresa, ['name'], context=context)
        nome_empresa = formataString(res['name'], 40, '  ', 'C', 'S', 'S')

        obj_cli = pooler.get_pool(cr.dbname).get('report.listagem.clientes')
        obj_financeiro_cliente = pooler.get_pool(cr.dbname).get('financeiro.cliente')

        # Buscar clientes ativos
        cliente_ativo_ids = obj_financeiro_cliente.search(cr, uid, [], context=context)
        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'financeiro.cliente', context=context)
        argumentos = [('company_id', '=', company_id), ('cliente_id', 'in', cliente_ativo_ids)]
        lista_arg = _('Criterios de Pesquisa: ')

        if tipo_pessoa == 'T':
            argumentos.append(('pessoa_id.pessoa_tipo', '!=', tipo_pessoa))
            lista_arg += _('|Tipo Pessoa: ') + _('Todos') + ' '
        else:
            argumentos.append(('pessoa_id.pessoa_tipo', '=', tipo_pessoa))
            lista_arg += _('|Tipo Pessoa: ') + tipo_pessoa + ' '

        if data_nasc:
            sql = """
                SELECT id
                FROM   adm_pessoa
                WHERE  date_part('month', admpes_fis_data_nascimento) = %d
            """ % data_nasc
            cr.execute(sql)
            pessoa_ids = cr.dictfetchall()
            pessoa_ids = map(lambda p: p.get('id'), pessoa_ids)
            argumentos.append(('pessoa_id', 'in', pessoa_ids))
            lista_arg += _('|Mes Nasc.: %s') % self._mes_do_ano.get(data_nasc) + ' '

        if tipo_pessoa == 'F' and sexo == 'T':
            lista_arg += _('|Sexo: ') + _('Todos') + ' '

        if tipo_pessoa == 'F' and sexo != 'T':
            argumentos.append(('pessoa_id.admpes_fis_sexo', '=', sexo))
            lista_arg += _('|Sexo: ') + sexo + ' '

        if tipo_pessoa == 'T' and sexo != 'T':
            argumentos.append(('pessoa_id.admpes_fis_sexo', '=', sexo))
            lista_arg += _('|Sexo:') + sexo + ' '

        if categoria_id != False:
            if categoria_id and isinstance(categoria_id, (list, tuple)):
                categoria_id = categoria_id[0]
                cat = pooler.get_pool(cr.dbname).get('adm.pessoa.categoria.nome').read(cr, uid, categoria_id, ['name'], context=context)[
                    'name']
                lista_arg += _('|Categoria: ') + u'%s' % cat + u' '
                argumentos.append(('pessoa_id.categoria_ids', '=', categoria_id))

        if pais_id != False:
            if pais_id and isinstance(pais_id, (list, tuple)):
                pais_id = pais_id[0]
                pais = pooler.get_pool(cr.dbname).get('adm.pais').read(cr, uid, pais_id, ['name'], context=context)['name']
                lista_arg += _('|Pais: ') + u'%s' % pais + u' '
                argumentos.append(('pessoa_id.endereco_ids.pais_id', '=', pais_id))

        if uf_id != False:
            if uf_id and isinstance(uf_id, (list, tuple)):
                uf_id = uf_id[0]
                uf = pooler.get_pool(cr.dbname).get('adm.uf').read(cr, uid, uf_id, ['name'], context=context)['name']
                lista_arg += _('|UF: ') + u'%s' % uf + u' '
                argumentos.append(('pessoa_id.endereco_ids.uf_id', '=', uf_id))

        if cidade_id != False:
            if cidade_id and isinstance(cidade_id, (list, tuple)):
                cidade_id = cidade_id[0]
                cidade = pooler.get_pool(cr.dbname).get('adm.cidade').read(cr, uid, cidade_id, ['name'], context=context)['name']
                lista_arg += _('|Cidade: ') + u'%s' % cidade + u' '
                argumentos.append(('pessoa_id.endereco_ids.cidade_id', '=', cidade_id))

        if bairro_id != False:
            if bairro_id and isinstance(bairro_id, (list, tuple)):
                bairro_id = bairro_id[0]
                bairro = pooler.get_pool(cr.dbname).get('adm.bairro').read(cr, uid, bairro_id, ['name'], context=context)['name']
                lista_arg += _('|Bairro: ') + u'%s' % bairro + u' '
                argumentos.append(('pessoa_id.endereco_ids.bairro_id', '=', bairro_id))

        order = 'id'
        if ordem == 'A':
            order = 'name'
            lista_arg += _('|Ordem:') + _('Alfabetica') + ' '
        elif ordem == 'E':
            order = 'cidade'
            lista_arg += _('|Ordem:') + _('Estado/Cidade') + ' '
        elif ordem == 'N':
            order = 'data_nascimento'
            lista_arg += '|Ordem:' + _('Aniversario ')

        context.update({'sig_force_company': True})
        report_listagem_cliente_ids = obj_cli.search(cr, uid, argumentos, order=order,
                                                     context=context)
        del context['sig_force_company']

        if ordem == 'N' and report_listagem_cliente_ids:
            if len(report_listagem_cliente_ids) == 1:
                str_listagem_cliente_ids = str(tuple(report_listagem_cliente_ids)).replace(',', '')
            else:
                str_listagem_cliente_ids = str(tuple(report_listagem_cliente_ids))
            sql = """
                SELECT id
                FROM report_listagem_clientes
                WHERE id IN %s
                ORDER BY substring(data_nascimento::varchar from 6 for 5)
            """ % str_listagem_cliente_ids
            cr.execute(sql)
            report_listagem_cliente_ids = map(lambda _id: _id.get('id'), cr.dictfetchall())

        listagem = Impressora()
        listagem.defineFormato(orientacao='1')

        listagem.informaNome(pdf_file, _('Listagem de Clientes'))
        listagem.informaTamLinha(160)
        #        listagem.defineMargem(1,1,1,1)
        cab = _('Contas a Receber            ') + nome_empresa + _('            Pagina: {{ Page }}')
        listagem.informaCab(cab)
        listagem.informaCab(' ')
        data = time.strftime('%d-%m-%Y')
        listagem.informaCab(_('Data: ') + data + _('                 Listagem de Clientes                              '))
        listagem.informaCab(' ')
        listagem.informaCab(lista_arg)
        listagem.informaCab(' ')
        listagem.informaCab('--')
        cab = formataString(_('Seq.'), 5, '  ', 'D', 'N', 'S')
        cab += formataString(_('Cod.'), 6, '  ', 'D', 'N', 'S')
        cab += formataString(_('Nome'), 46, ' ', 'D', 'S', 'S')
        cab += _('Tipo ')
        cab += formataString(_('CPF / CNPJ'), 20, ' ', 'D', 'S', 'S')
        cab += formataString(_('Endereco'), 45, ' ', 'D', 'S', 'S')
        cab += formataString(_('CEP'), 12, ' ', 'D', 'N', 'S')
        cab += formataString(_('Cidade'), 25, ' ', 'D', 'S', 'S')
        cab += formataString(_('UF'), 4, ' ', 'D', 'S', 'S')
        cab += formataString(_('Dt.Inclus.'), 13, ' ', 'D', 'S', 'S')
        cab += formataString(_('Lim.de credito'), 17, ' ', 'D', 'S', 'S')
        cab += formataString(_('Telefone '), 15, ' ', 'D', 'N', 'S')
        cab += formataString(_('Dt.Ult.Mov.'), 11, ' ', 'E', 'N', 'S')
        listagem.informaCab(cab)
        listagem.informaCab('--')
        listagem.informaCab(' ')
        listagem.rodapePadrao()
        qtd_cliente = 0

        brw_report_listagem_cliente = obj_cli.browse(cr, uid, report_listagem_cliente_ids)
        list_dia = list()
        for cliente in brw_report_listagem_cliente:
            qtd_cliente += 1
            ultima_compra_data = cliente.ultima_compra_data or ''
            ultima_compra_data_o = ultima_compra_data
            if ultima_compra_data:
                ultima_compra_data = parse(ultima_compra_data).strftime('%d/%m/%Y')
            if situacao == 'I':
                if not ultima_compra_data_o or ultima_compra_data_o > data_referencia:
                    qtd_cliente -= 1
                    continue
            elif situacao == 'A':
                if not ultima_compra_data_o or ultima_compra_data_o < data_referencia:
                    qtd_cliente -= 1
                    continue

            if ordem == 'N' and data_nasc:
                data_nascimento = cliente.data_nascimento
                if int(data_nascimento[:4]) < 1900:
                    data_nascimento = '1900' + data_nascimento[4:]
                dia_nascimento = parse(data_nascimento).strftime('%d/%m')
                if list_dia and dia_nascimento not in list_dia:
                    listagem.imprimeLinha('')
                if dia_nascimento not in list_dia:
                    list_dia.append(dia_nascimento)
                    listagem.imprimeLinha('NASCIMENTO: ' + dia_nascimento)
                    listagem.imprimeLinha('')

            linha = formataString(qtd_cliente, 4, ' ', 'D', 'N', 'S')
            linha += ' '
            linha += formataString(cliente.pessoa_id.codigo, 6, ' ', 'D', 'N', 'S')
            linha += ' '
            linha += formataString(cliente.pessoa_id.partner_id.name, 46, ' ', 'D', 'S', 'S')
            linha += ' '
            linha += ' '
            linha += formataString(cliente.pessoa_id.pessoa_tipo, 3, ' ', 'D', 'N', 'S')
            linha += ' '
            if cliente.pessoa_id.cpf_cnpj:
                linha += formataString(cliente.pessoa_id.cpf_cnpj, 19, ' ', 'D', 'S', 'S')
            else:
                linha += formataString(' ', 19, ' ', 'D', 'N', 'S')
            linha += ' '
            linha += formataString(cliente.pessoa_id.endereco, 44, ' ', 'D', 'S', 'S')
            linha += ' '

            if cliente.pessoa_id.cep:
                linha += formataString(cliente.pessoa_id.cep, 11, ' ', 'D', 'N', 'S')
                linha += ' '

            else:
                linha += formataString(' ', 11, ' ', 'D', 'N', 'S')
                linha += ' '
            if cliente.pessoa_id.cidade:
                linha += formataString(cliente.pessoa_id.cidade, 24, ' ', 'D', 'S', 'S')
                linha += ' '
            else:
                linha += formataString(' ', 24, ' ', 'D', 'N', 'S')
                linha += ' '

            linha += formataString(cliente.pessoa_id.uf, 3, ' ', 'D', 'S', 'S')
            linha += ' '

            dt_inc = cliente.data_inclusao
            linha += formataString(dt_inc[8:] + '/' + dt_inc[5:7] + '/' + dt_inc[:4], 12, ' ', 'D', 'S', 'S')
            linha += ' '
            if cliente.limite_credito > 999999999.99:
                limite = '000000000.00'
            else:
                limite = str(Numero(cliente.limite_credito).numeroToStr(9, 2))
            linha += "%s.%s.%s,%s" % ( limite[0:3], limite[3:6], limite[6:9], limite[10:] )
            linha += ' '
            linha += formataString(cliente.pessoa_id.telefone, 14, ' ', 'D', 'N', 'S')
            linha += ' '
            linha += formataString(ultima_compra_data, 10, ' ', 'D', 'S', 'S')
            linha += ' '
            listagem.imprimeLinha(linha)
        listagem.imprimeLinha('--')
        listagem.imprimeLinha(_('Quantidade de clientes: ') + str(qtd_cliente))
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_file.getvalue())
        self.obj.render()
        pdf_file.close()
        return (self.obj.pdf, 'pdf')


report_listagem_clientes('report.listagem.clientes')


class listagem_clientes_osv(osv.TransientModel):
    _name = 'listagem.clientes.osv'
    _description = 'Listagem de Clientes'
    _mes_do_ano = [
        (1, 'Janeiro'),
        (2, 'Fevereiro'),
        (3, _('Marco')),
        (4, 'Abril'),
        (5, 'Maio'),
        (6, 'Junho'),
        (7, 'Julho'),
        (8, 'Agosto'),
        (9, 'Setembro'),
        (10, 'Outubro'),
        (11, 'Novembro'),
        (12, 'Dezembro')
    ]
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', required=True, select=True),
        'categoria_id': fields.many2one("adm.pessoa.categoria.nome", 'Categoria'),
        'pais_id': fields.many2one("adm.pais", 'Pais'),
        'uf_id': fields.many2one("adm.uf", 'Estado'),
        'cidade_id': fields.many2one("adm.cidade", 'Cidade'),
        'bairro_id': fields.many2one("adm.bairro", 'Bairro'),
        'tipo_pessoa': fields.selection([('F', 'Fisica'), ('J', 'Juridica'), ('T', 'Todos')], 'Tipo Pessoa'),
        'ordem': fields.selection([('A', 'Alfabetica'), ('N', 'Aniversario'),
                                   ('E', 'Estado/Cidade')], 'Ordem'),
        'data_nasc': fields.selection(_mes_do_ano, 'Mes de nasc.', size=1),
        'sexo': fields.selection([('F', 'Feminino'), ('M', 'Masculino'), ('T', 'Todos')], 'Sexo'),
        'situacao': fields.selection(
            [('T', 'Todos'), ('A', 'Movimentados'), ('I', 'Nao movimentados')],
            'Movimentados e Nao movimentados', size=1),
        'data_referencia': fields.date('Data referencia')
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(cr, uid, uid).company_id.id,
        'tipo_pessoa': lambda *a: 'T',
        'ordem': lambda *a: 'A',
        'sexo': lambda *a: 'T'
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        listagem_clientes_osv_dados = self.read(cr, uid, ids, [], context=context)
        for x in listagem_clientes_osv_dados:
            company_id = x.get('company_id')
            if isinstance(company_id, tuple):
                company_id = company_id[0]
                company = company_id
            if not isinstance(company_id, list):
                company_id = [company_id]
            res_company_dados = self.pool.get("res.company").read(cr, uid, company_id, ['name'], context=context)
            for i in res_company_dados:
                nome_empresa = i.get('name')
            datas = {
                'company_id': company,
                'nome_empresa': nome_empresa,
                'categoria_id': x.get('categoria_id'),
                'pais_id': x.get('pais_id'),
                'uf_id': x.get('uf_id'),
                'cidade_id': x.get('cidade_id'),
                'bairro_id': x.get('bairro_id'),
                'tipo_pessoa': x.get('tipo_pessoa') or 'T',
                'ordem': x.get('ordem') or 'A',
                'data_nasc': x.get('data_nasc'),
                'sexo': x.get('sexo') or 'T',
                'situacao': x.get('situacao'),
                'data_referencia': x.get('data_referencia')
            }

        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'listagem.clientes',
            'datas': datas,
        }
