# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
from openerp import netsvc
from openerp import pooler
import time
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_listagem_fornecedores(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        pdf_file = StringIO.StringIO()

        empresa = datas['company_id']
        tipo_pessoa = datas['tipo_pessoa']
        categoria_id = datas['categoria_id']
        pais_id = datas['pais_id']
        uf_id = datas['uf_id']
        cidade_id = datas['cidade_id']
        bairro_id = datas['bairro_id']
        ordem = datas['ordem']
        #*******************************************************************************
        obj_emp = pooler.get_pool(cr.dbname).get("res.company")
        company_id = pooler.get_pool(cr.dbname).get("adm.empresa.objeto").getEmpresa(
            cr, uid, 'financeiro.fornecedor', context=context, user_company_id=empresa)
        res = obj_emp.read(cr, uid, empresa, ['name'], context=context)
        nome_empresa = formataString(res['name'], 20, ' ', 'E', 'S', 'S')

        obj_emp = pooler.get_pool(cr.dbname).get('report.listagem.fornecedores')

        #*******************************************************************************
        argumentos = [('company_id', '=', company_id)]
        lista_arg = _('Criterios de Pesquisa: ')

        if datas['tipo_pessoa'] == 'T':
            argumentos.append(('pessoa_id.pessoa_tipo', '!=', tipo_pessoa))
            lista_arg += _('|Tipo Pessoa: ') + _('Todos') + ' '
        else:
            argumentos.append(('pessoa_id.pessoa_tipo', '=', tipo_pessoa))
            lista_arg += _('|Tipo Pessoa: ') + tipo_pessoa + ' '

        if datas['categoria_id'] != False:
            argumentos.append(('pessoa_id.categoria_ids', '=', categoria_id))
            if datas['categoria_id']:
                cat = pooler.get_pool(cr.dbname).get('adm.pessoa.categoria.nome').read(cr, uid, categoria_id, ['name'], context=context)[
                    'name']
                lista_arg += _('|Categoria: ') + cat.encode('utf-8') + ' '

        if datas['pais_id'] != False:
            argumentos.append(('pessoa_id.endereco_ids.pais_id', '=', pais_id))
            if datas['pais_id']:
                pais = pooler.get_pool(cr.dbname).get('adm.pais').read(cr, uid, pais_id, ['name'], context=context)['name']
                lista_arg += _('|Pais: ') + pais.encode('utf-8') + ' '

        if datas['uf_id'] != False:
            argumentos.append(('pessoa_id.endereco_ids.uf_id', '=', uf_id))
            if datas['uf_id']:
                uf = pooler.get_pool(cr.dbname).get('adm.uf').read(cr, uid, uf_id, ['name'], context=context)['name']
                lista_arg += _('|UF: ') + uf.encode('utf-8') + ' '

        if datas['cidade_id'] != False:
            argumentos.append(('pessoa_id.endereco_ids.cidade_id', '=', cidade_id))
            if datas['cidade_id']:
                cidade = pooler.get_pool(cr.dbname).get('adm.cidade').read(cr, uid, cidade_id, ['name'], context=context)['name']
                lista_arg += _('|Cidade: ') + cidade.encode('utf-8') + ' '

        if datas['bairro_id'] != False:
            argumentos.append(('pessoa_id.endereco_ids.bairro_id', '=', bairro_id))
            if datas['bairro_id']:
                bairro = pooler.get_pool(cr.dbname).get('adm.bairro').read(cr, uid, bairro_id, ['name'], context=context)['name']
                lista_arg += _('|Bairro: ') + bairro.encode('utf-8') + ' '

        if datas['ordem'] == 'A':
            ord = 'name'
            lista_arg += _('|Ordem:') + _('Alfabetica') + ' '
        elif datas['ordem'] == 'E':
            ord = 'cidade'
            lista_arg += _('|Ordem:') + _('Estado/Cidade') + ' '
        #*******************************************************************************
        context['sig_force_company'] = True
        cliente_ids = obj_emp.search(cr, uid, argumentos, order=ord, context=context)

        listagem = Impressora()
        listagem.defineFormato(orientacao='1')

        listagem.informaNome(pdf_file, _('Listagem de Fornecedores'))
        listagem.informaTamLinha(160)
        listagem.defineMargem(1, 1, 1, 1)
        cab = _('Fornecedores                                                ') + nome_empresa + _('                                                                                                                                Pagina:  {{ Page }}')
        listagem.informaCab(cab)
        listagem.informaCab(' ')
        data = time.strftime('%d-%m-%Y')
        listagem.informaCab(
            _('Data: ') + data + _('                                                     Listagem de Fornecedores                              '))
        listagem.informaCab(' ')
        listagem.informaCab(lista_arg)
        listagem.informaCab(' ')
        listagem.informaCab('--')
        cab = formataString(_('Cod.'), 6, '  ', 'D', 'N', 'S')
        cab += formataString(_('Nome'), 46, ' ', 'D', 'S', 'S')
        cab += 'T   '
        cab += formataString(_('CPF / CNPJ'), 20, ' ', 'D', 'S', 'S')
        cab += formataString(_('Endereco'), 45, ' ', 'D', 'S', 'S')
        cab += formataString(_('CEP'), 12, ' ', 'D', 'N', 'S')
        cab += formataString(_('Cidade'), 25, ' ', 'D', 'S', 'S')
        cab += formataString(_('UF'), 4, ' ', 'D', 'S', 'S')
        cab += formataString(_('Telefone '), 10, ' ', 'E', 'N', 'S')
        listagem.informaCab(cab)
        listagem.informaCab('--')
        listagem.informaCab(' ')
        listagem.rodapePadrao()
        qtdCliente = 0;


        #*******************************************************************************

        for cliente in obj_emp.browse(cr, uid, cliente_ids):
            linha = formataString(cliente.pessoa_id.codigo, 7, ' ', 'D', 'N', 'S')
            linha += ' '
            linha += formataString(cliente.name, 45, ' ', 'D', 'S', 'S')
            linha += ' '
            linha += formataString(cliente.pessoa_id.pessoa_tipo, 3, ' ', 'D', 'N', 'S')
            linha += ' '
            if cliente.pessoa_id.cpf_cnpj:
                linha += formataString(cliente.pessoa_id.cpf_cnpj, 19, ' ', 'D', 'S', 'S')
            else:
                linha += formataString(' ', 19, ' ', 'D', 'N', 'S')
            linha += ' '
            linha += formataString(cliente.pessoa_id.endereco, 43, ' ', 'D', 'S', 'S')
            linha += ' '

            if cliente.pessoa_id.cep:
                linha += formataString(cliente.pessoa_id.cep, 12, ' ', 'D', 'N', 'S')
                linha += ' '

            else:
                linha += formataString(' ', 12, ' ', 'D', 'N', 'S')
                linha += ' '
            if cliente.pessoa_id.cidade:
                linha += formataString(cliente.pessoa_id.cidade, 24, ' ', 'D', 'S', 'S')
                linha += ' '
            else:
                linha += formataString(' ', 24, ' ', 'D', 'N', 'S')
                linha += ' '
            #*******************************************************************************
            linha += formataString(cliente.pessoa_id.uf, 2, ' ', 'D', 'S', 'S')
            linha += ' '

            linha += formataString(cliente.pessoa_id.telefone, 14, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
            qtdCliente = qtdCliente + 1
        listagem.imprimeLinha('--')
        listagem.imprimeLinha(_('Quantidade de Fornecedores: ') + str(qtdCliente))
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_file.getvalue())
        self.obj.render()
        pdf_file.close()
        return (self.obj.pdf, 'pdf')


report_listagem_fornecedores('report.listagem.fornecedores')


class listagem_fornecedores_osv(osv.TransientModel):
    _name = 'listagem.fornecedores.osv'
    _description = 'Listagem de Fornecedores'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', required=True, select=True),
        'categoria_id': fields.many2one("adm.pessoa.categoria.nome", 'Categoria'),
        'pais_id': fields.many2one("adm.pais", 'Pais'),
        'uf_id': fields.many2one("adm.uf", 'Estado'),
        'cidade_id': fields.many2one("adm.cidade", 'Cidade'),
        'bairro_id': fields.many2one("adm.bairro", 'Bairro'),
        'tipo_pessoa': fields.selection([('F', 'Fisica'), ('J', 'Juridica'), ('T', 'Todos')], 'Tipo Pessoa'),
        'ordem': fields.selection([('A', 'Alfabetica'), ('E', 'Estado/Cidade')], 'Ordem')
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(cr, uid, uid).company_id.id,
        'tipo_pessoa': lambda *a: 'T',
        'ordem': lambda *a: 'A'
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        listagem_fornecedores_osv_dados = self.read(cr, uid, ids, [], context=context)
        for x in listagem_fornecedores_osv_dados:
            company_id = x.get('company_id')
            if isinstance(company_id, tuple):
                company_id = company_id[0]
                company = company_id
            if not isinstance(company_id, list):
                company_id = [company_id]
            res_company_dados = self.pool.get("res.company").read(cr, uid, company_id, ['name'], context=context)
            for i in res_company_dados:
                nome_empresa = i.get('name')
            categoria_id = x.get('categoria_id')
            if isinstance(categoria_id, tuple):
                categoria_id = categoria_id[0]
            pais_id = x.get('pais_id')
            if isinstance(pais_id, tuple):
                pais_id = pais_id[0]
            uf_id = x.get('uf_id')
            if isinstance(uf_id, tuple):
                uf_id = uf_id[0]
            cidade_id = x.get('cidade_id')
            if isinstance(cidade_id, tuple):
                cidade_id = cidade_id[0]
            bairro_id = x.get('bairro_id')
            if isinstance(bairro_id, tuple):
                bairro_id = bairro_id[0]
            datas = {
                'company_id': company,
                'nome_empresa': nome_empresa,
                'categoria_id': categoria_id,
                'pais_id': pais_id,
                'uf_id': uf_id,
                'cidade_id': cidade_id,
                'bairro_id': bairro_id,
                'tipo_pessoa': x.get('tipo_pessoa') or 'T',
                'ordem': x.get('ordem') or 'A'


            }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'listagem.fornecedores',
            'datas': datas,
        }
