# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
from openerp import netsvc
from openerp import pooler
import time
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_participacao_clientes_fornecedores(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=118):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato()
        listagem.informaNome(pdf_string, datas['titulo_report'][1])
        listagem.defineFonte(tam=8)
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)
        # CABECALHO

        listagem.informaCab(center_title(datas['titulo_report'][0], datas['titulo_report'][1], '125'))
        listagem.informaCab('')
        listagem.informaCab(center_title(time.strftime('%d-%m-%Y'), datas['nome_empresa'], _('Pagina: ' + '{{ Page }}')))
        listagem.informaCab('')
        listagem.informaCab('*' + '-' * 116 + '*')
        listagem.informaCab(
            _(' CODIGO NOME                                        TELEFONE                ') +
            datas['titulo_report'][2] + _('       ACUMULADO % INDIV. % ACUMUL'))
        listagem.informaCab('*' + '-' * 116 + '*')
        # RODAPE
        listagem.informaRodape('*' + '-' * 116 + '*')
        listagem.informaRodape(
            _('                                                                                    **  Sig Informatica Ltda  **'))
        obj_pag = pooler.get_pool(cr.dbname).get('adm.paginas')
        # ------------------------------------------------------------------------
        for x in datas['dados_report']:
            ln = ' '
            ln += formataString(x[0], 6, ' ', 'E', 'S', 'S')
            ln += ' '
            ln += formataString(x[1], 43, ' ', 'D', 'S', 'S')
            ln += ' '
            ln += formataString(x[2], 15, ' ', 'D', 'S', 'S')
            ln += ' '
            ln += formataString(getNumeroEditado(x[3]), 15, ' ', 'E', 'N', 'S')
            ln += ' '
            ln += formataString(getNumeroEditado(x[4]), 15, ' ', 'E', 'N', 'S')
            ln += ' '
            ln += formataString(getNumeroEditado(x[5]), 8, ' ', 'E', 'N', 'S')
            ln += ' '
            ln += formataString(getNumeroEditado(x[6]), 8, ' ', 'E', 'N', 'S')
            listagem.imprimeLinha(ln)
        listagem.finalizaImpressao()

        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_participacao_clientes_fornecedores('report.participacao.clientes.fornecedores')


class participacao_clientes_fornecedores_osv(osv.TransientModel):
    _name = 'participacao.clientes.fornecedores.osv'
    _description = 'Participacao Clientes / Fornecedores'

    def _get_tipo_titulo(self, cr, uid, data, context=None):
        context = context and context.copy() or {}
        if data['tipo'] == 'R':
            return 'R'
        if data['tipo'] == 'P':
            return 'P'

    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', required=True, select=True),
        'data_ini': fields.date('Emissao Inicio', required=True, select=True, readonly=False),
        'data_fim': fields.date('Emissao Fim', required=True, select=True, readonly=False),
        'tipo_titulo': fields.selection([('R', 'Receber'), ('P', 'Pagar')], 'Tipo Titulo', required=True),
        'percentual': fields.float('Percentual a imprimir', required=True),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        'percentual': lambda *a: 100,
        'tipo_titulo': _get_tipo_titulo,

    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        participacao_clientes_fornecedores_osv_dados = self.read(cr, uid, ids, [], context=context)
        for x in participacao_clientes_fornecedores_osv_dados:
            company_id = x.get('company_id')
            if isinstance(company_id, tuple):
                company_id = company_id[0]
                company = company_id
            if not isinstance(company_id, list):
                company_id = [company_id]
            res_company_dados = self.pool.get("res.company").read(cr, uid, company_id, ['name'], context=context)
            for i in res_company_dados:
                nome_empresa = i.get('name')
            datas = {
                'company_id': company,
                'nome_empresa': nome_empresa,
                'data_ini': x.get('data_ini'),
                'data_fim': x.get('data_fim'),
                'tipo_titulo': x.get('tipo_titulo'),
                'percentual': x.get('percentual'),

            }

            oPessoa = pooler.get_pool(cr.dbname).get('adm.pessoa')
            oEmp = pooler.get_pool(cr.dbname).get("res.company")
            sEmpFilhas = oEmp.search(cr, uid, [('parent_id', 'child_of', company_id)], context=context)
            if x.get('data_fim') < x.get('data_ini'):
                raise osv.except_osv(_('Atencao'), _('Data Final nao pode ser Menor que Data Inicial'))
            if x.get('percentual') < 0 or x.get('percentual') > 100:
                raise osv.except_osv(_('Atencao'), _('Digite um percentual de 0-100'))
            sql = self.get_query_dados(cr, uid, sEmpFilhas, x.get('data_ini'), x.get('data_fim'),
                                       x.get('tipo_titulo'), context)
            cr.execute(sql)
            vals = cr.fetchall()
            if not vals:
                raise osv.except_osv(_('Atencao'), _('Nao ha dados para gerar o relatorio'))

            dados = []
            total = 0.0
            for y in vals:
                total += y[-1]
            valor = vals[0][-1]
            inc = 1
            for z in vals:
                if z[0]:
                    vals_pessoa = oPessoa.read(cr, uid, z[0], ['name', 'codigo', 'telefone'],
                                               context=context)
                else:
                    vals_pessoa = {'name': 'Consumidor final'}
                if (valor * 100 / total) > x.get('percentual'):
                    break
                dados.append((vals_pessoa.get('codigo', ''), vals_pessoa.get('name'),
                              vals_pessoa.get('telefone') or '', z[1], valor,
                              (z[1] * 100 / total), (valor * 100 / total)))
                try:
                    valor += vals[inc][-1]
                    inc += 1
                except:
                    pass
            if not dados:
                raise osv.except_osv(_('Atencao'), _('Nao ha dados para gerar o relatorio'))
            if x.get('tipo_titulo') == 'R':
                datas['titulo_report'] = (_('Ctas a Receber'), _('Participacao nas Vendas'), _(' VENDAS'))
            else:
                datas['titulo_report'] = (_('Ctas a Pagar'), _('Participacao nas Compras'), _('COMPRAS'))
            datas['dados_report'] = dados
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'participacao.clientes.fornecedores',
            'datas': datas,
        }

    def get_query_dados(self, cr, uid, company_ids, data_inicial, data_final, tipo_titulo,
                        context=None):
        """
        O metodo forma a query sql para a busca dos dados dos titulos.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param company_ids: lista de id da tabela res_company, identificadores das empresas.
        :type company_ids: list
        :param data_inicial: descricao da data inicial do periodo de pesquisa.
        :type data_inicial: str
        :param data_final: descricao da data final do periodo de pesquisa.
        :type data_final: str
        :param tipo_titulo: caracter de identificação do tipo do titulo. 'R' a receber e 'P' a
        pagar.
        :type tipo_titulo: str
        :param context: dados com valores conxtuais.
        :type context: dict
        :return: query sql
        :rtype: str
        """
        context = context and context.copy() or {}
        sql = """
            SELECT
                  DISTINCT f.pessoa_id,
                  SUM(f.vr_original) AS valor
            FROM  financeiro_titulo f
            WHERE data_emissao BETWEEN DATE('{data_ini}') AND   DATE('{data_fim}')
              AND tipo_titulo = '{tipo_titulo}'
              AND company_id in ({company_id})
            GROUP BY pessoa_id
            ORDER BY valor desc
        """.format(company_id=','.join(map(str, company_ids)),
                   data_ini=data_inicial,
                   data_fim=data_final,
                   tipo_titulo=tipo_titulo)
        return sql
