# -*- encoding: utf-8 -*-
from openerp.osv import osv, fields
from openerp.tools.translate import _


class prorrogacao_titulo_osv(osv.TransientModel):
    _name = 'prorrogacao.titulo.osv'

    def _wizpto_check_titulo_aberto(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, dict):
            if ids.get('active_id'):
                id = ids['active_id']
                estado = self.pool.get('financeiro.titulo').read(cr, uid, id, ['state'], context=context)['state']
                if estado == 'A':
                    estado = True
                else:
                    estado = False
                return estado

    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa'),
        'pessoa_id': fields.many2one('adm.pessoa', 'Cliente'),
        'documento': fields.char('Documento', size=30),
        'parcela': fields.integer('Parcela'),
        'data_emissao': fields.date('Emissao'),
        'vr_original': fields.float('Valor', digits=(15, 2)),
        'data_vencimento': fields.date('Data vencimento'),
        'data_prorrogacao': fields.date('Data prorrogacao', required=True),
        'titulo_id': fields.integer('titulo'),
        'state': fields.selection([('init', 'init'), ('salvar', 'salvar')], 'status'),
        'wizpto_titulo_aberto': fields.boolean('titulo aberto'),
    }
    _defaults = {
        'wizpto_titulo_aberto': _wizpto_check_titulo_aberto,
    }

    def default_get(self, cr, uid, fields, context=None):
        context = context and context.copy() or {}
        titulo_pool = self.pool.get('financeiro.titulo')
        obj_titulo = titulo_pool.browse(cr, uid, context.get('active_id', False))

        res = super(prorrogacao_titulo_osv, self).default_get(cr, uid, fields, context=context)

        if 'company_id' in fields:
            res.update({'company_id': obj_titulo.company_id.id})
        if 'pessoa_id' in fields:
            res.update({'pessoa_id': obj_titulo.pessoa_id.id})
        if 'documento' in fields:
            res.update({'documento': obj_titulo.documento})
        if 'parcela' in fields:
            res.update({'parcela': obj_titulo.parcela})
        if 'data_emissao' in fields:
            res.update({'data_emissao': obj_titulo.data_emissao})
        if 'vr_original' in fields:
            res.update({'vr_original': obj_titulo.vr_original})
        if 'data_vencimento' in fields:
            res.update({'data_vencimento': obj_titulo.data_vencimento})
        if 'titulo_id' in fields:
            res.update({'titulo_id': context.get('active_id', False)})

        return res

    def salvar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        brw_prorrogacao_titulo = self.browse(
            cr, uid, ids[0] if isinstance(ids, (list, tuple)) else ids, context)
        data_prorrogacao = brw_prorrogacao_titulo.data_prorrogacao
        titulo_id = brw_prorrogacao_titulo.titulo_id
        if self.pool.get('financeiro.titulo').write(
                cr, uid, titulo_id, {'data_prorrogacao': data_prorrogacao}, context):
            return {'type': 'ir.actions.act_window_close'}

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        if not args:
            args = []
        context = context and context.copy() or {}
        company = self.pool.get('res.users')._get_company(cr, uid)
        ids_empresa = self.pool.get('res.company')._get_company_children(cr, uid, company)
        args += [('company_id', 'in', ids_empresa)]
        res = super(prorrogacao_titulo_osv, self).search(cr, uid, args, offset, limit, order, context, count)
        return res
