# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
from openerp import netsvc
from openerp import pooler
import time
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        cartao_de_credito = datas.get('cartao_de_credito')
        data_ref, local_cobranca, natureza_cobranca, pessoa_id, company_id, diff_datas_vencimento, \
        diff_datas_emissao = ' ', ' ', ' ', ' ', ' ', ' ', ' '
        ordem_relatorio = datas.get('ordem_relatorio')
        if datas['ordem_relatorio'] == 'name':
            ordem = 'pp.nome,ft.data_prorrogacao '
        else:
            ordem = 'ft.data_prorrogacao,pp.nome '

        if datas['data_ref']:
            data_refer = datas.get('data_ref')
            if isinstance(data_refer, (list, tuple)):
                data_refer = data_refer[0]
            data_ref = 'and ft.data_emissao=' + "'" + str(data_refer) + "'"

        if datas.get('local_cobranca_ids'):
            local_cobranca_ids = datas.get('local_cobranca_ids')
            if len(local_cobranca_ids) == 1:
                str_local_cobranca_ids = str(tuple(local_cobranca_ids)).replace(',', '')
            else:
                str_local_cobranca_ids = str(tuple(local_cobranca_ids))
            local_cobranca = 'and ft.local_cobranca_id IN %s' % str_local_cobranca_ids

        if datas.get('natureza_cobranca_ids'):
            natureza_cobranca_ids = datas.get('natureza_cobranca_ids')
            if len(natureza_cobranca_ids) == 1:
                str_natureza_cobranca_ids = str(tuple(natureza_cobranca_ids)).replace(',', '')
            else:
                str_natureza_cobranca_ids = str(tuple(natureza_cobranca_ids))
            natureza_cobranca = 'AND ft.natureza_cobranca_id IN %s ' % str_natureza_cobranca_ids

        adm_cartao_pessoa_ids = []
        if not cartao_de_credito:
            adm_cartao_pessoa_ids = pooler.get_pool(cr.dbname).get('adm.pessoa').search(
                cr, uid, [('admpes_jur_tipo_empresa', '=', 'A')], context=context)
            if adm_cartao_pessoa_ids:
                if len(adm_cartao_pessoa_ids) == 1:
                    str_pessoa_ids = str(tuple(adm_cartao_pessoa_ids)).replace(',', '')
                else:
                    str_pessoa_ids = str(tuple(adm_cartao_pessoa_ids))
                pessoa_id = ' AND ft.pessoa_id NOT IN %s' % str_pessoa_ids + ' '

        if datas.get('pessoa_id'):
            id_pessoa = datas.get('pessoa_id')
            if isinstance(id_pessoa, (list, tuple)):
                id_pessoa = id_pessoa[0]
            pessoa_id = ' AND ft.pessoa_id=' + str(id_pessoa) + ' '
            if id_pessoa in adm_cartao_pessoa_ids and not cartao_de_credito:
                pessoa_id = ' AND ft.pessoa_id IS NULL' + ' '

        if datas['company_id']:
            id_company = datas.get('company_id')
            if isinstance(id_company, (list, tuple)):
                id_company = id_company[0]
            if not context.get('sig_search_sem_filhos'):
                _sql = 'select id from res_company where id = %s or parent_id = %s' % (
                    id_company, id_company)
                cr.execute(_sql)
                company_ids = map(lambda i: i[0], cr.fetchall())
                company_id = ' and ft.company_id in %s' % str(company_ids)
                company_id = company_id.replace('[', '(').replace(']', ')')
            else:
                company_id = ' and ft.company_id = ' + str(id_company) + ' '

        if datas['data_vct_ini'] and datas['data_vct_fim']:
            diff_datas_vencimento = 'and ft.data_prorrogacao>=' + "'" + datas['data_vct_ini'] + "'"\
                                    + 'and ft.data_prorrogacao<=' + "'" + datas[
                                        'data_vct_fim'] + "'"
        elif datas['data_vct_ini'] and not  datas['data_vct_fim']:
            diff_datas_vencimento = 'and ft.data_prorrogacao>=' + "'" + datas['data_vct_ini']+ "'"

        elif not datas['data_vct_ini'] and datas['data_vct_fim']:
            diff_datas_vencimento =  'and ft.data_prorrogacao<=' + "'" + datas[
                                        'data_vct_fim'] + "'"

        if datas['data_emi_ini'] and datas['data_emi_fim']:
            diff_datas_emissao = 'and ft.data_emissao>=' + "'" + datas['data_emi_ini'] + "'" \
                                 + 'and ft.data_emissao<=' + "'" + datas['data_emi_fim'] + "'"
        elif datas['data_emi_ini'] and not datas['data_emi_fim']:
            diff_datas_emissao = 'and ft.data_emissao>=' + "'" + datas['data_emi_ini'] + "'"
        elif not datas['data_emi_ini'] and datas['data_emi_fim']:
            diff_datas_emissao = 'and ft.data_emissao<=' + "'" + datas['data_emi_fim'] + "'"

        doc_previsao_id = '0'
        sql_doc_tipo_id = """
                            SELECT id
                            FROM documento_documento_tipo
                            WHERE sigla = 'PRV'
                          """
        cr.execute(sql_doc_tipo_id)
        dados_doc_tipo_id = cr.dictfetchall()

        if not datas.get('considera_previsao'):
            if dados_doc_tipo_id and isinstance(dados_doc_tipo_id, list):
                dados_doc_tipo_id = dados_doc_tipo_id[0]
                doc_previsao_id = dados_doc_tipo_id.get('id')
        doc_tipo_ids = datas.get('doc_tipo_ids')
        if len(doc_tipo_ids) == 1:
            str_doc_tipo_ids = str(tuple(doc_tipo_ids)).replace(',', '')
        elif len(doc_tipo_ids) > 1:
            str_doc_tipo_ids = str(tuple(doc_tipo_ids))

        categoria_ids = str()
        if datas.get('clientes_cat'):
            if len(datas.get('clientes_cat')) == 1:
                categoria_ids = str(tuple(datas.get('clientes_cat'))).replace(',', '')
            else:
                categoria_ids = str(tuple(datas.get('clientes_cat')))
            categoria_ids = """
                      AND ft.pessoa_id IN (select pessoa_id
                                           from pessoa_categoria
                                           where categoria_id in %s) """ % categoria_ids

        sql = """
               SELECT ft.id          AS titulo_id,
                      ft.company_id,
                      ft.pessoa_id,
                      pp.nome,
                      pp.codigo AS codigo_pessoa,
                      pp.cpf_cnpj AS cpf_cnpj,
                      ft.documento,
                      ft.doc_tipo_id,
                      ddt.name       AS documento_tipo,
                      ft.data_emissao,
                      ( CASE
                          WHEN ft.saldo IS NOT NULL THEN ft.saldo
                          ELSE 0
                        end )                            AS saldo,
                      ft.vr_original,
                      ft.data_vencimento,
                      ft.data_prorrogacao,
                      ft.local_cobranca_id,
                      flc.descricao AS nome_local_cobranca,"""
        if datas.get('imprime_obs', False):
            sql += "ft.observacoes,"
        if datas.get('desconto_juros', False):
            sql += """ ft.vr_desconto,
                       ft.data_limite_desconto,
                       (CURRENT_DATE - ft.data_prorrogacao) * ft.vr_juros_dia AS vr_juros_dia,
                       CASE 
                           WHEN ft.multa_apos_data < CURRENT_DATE 
                               THEN ft.vr_multa 
                       ELSE 0 
                       END 
                           AS vr_multa,
                       ft.multa_apos_data,"""

        sql += """
                      ft.natureza_cobranca_id,
                      CURRENT_DATE - ft.data_prorrogacao Atraso,
                      ft.parcela
               FROM   financeiro_titulo ft,
                      adm_pessoa pp,
                      financeiro_local_cobranca flc,
                      documento_documento_tipo ddt
               WHERE  ft.state = 'A'
                      AND ft.pessoa_id = pp.id
                      AND ft.local_cobranca_id = flc.id
                      AND ft.doc_tipo_id = ddt.id
                      AND ft.tipo_titulo = '%s'
                      AND ddt.id != %s
                      %s

               """ % (datas['tipo_titulo'], doc_previsao_id, categoria_ids)
        if doc_tipo_ids:
            sql += """
                      AND ddt.id IN %s
            """ % str_doc_tipo_ids

        sql += company_id + \
               pessoa_id + \
               data_ref + \
               local_cobranca + \
               natureza_cobranca + \
               diff_datas_vencimento + \
               diff_datas_emissao + \
               """ order by """ + ordem

        cr.execute(sql)
        dados = cr.dictfetchall()
        pessoa_ids = list(set(map(lambda p: p.get('pessoa_id'), dados)))
        endereco_dados = {}
        if datas.get('tipo_relatorio') == '2' and pessoa_ids:
            sql = """
                SELECT
                    DISTINCT
                    ap.id AS pessoa_id,
                    ape.cep AS cep,
                    al.descricao || ', ' || ape.numero AS endereco,
                    au.sigla AS uf,
                    ac.name AS municipio,
                    (SELECT numero FROM adm_pessoa_telefone WHERE pessoa_id = ape.pessoa_id 
                     LIMIT 1) AS telefone,
                    ap.cpf_cnpj AS cpf_cnpj,
                    ap.pessoa_tipo AS pessoa_tipo 
                FROM adm_pessoa ap
                LEFT JOIN adm_pessoa_endereco ape
                    ON ap.id = ape.pessoa_id
                LEFT JOIN adm_endereco_tipo aet
                    ON aet.id = ape.endereco_tipo_id
                LEFT JOIN adm_logradouro al
                    ON ape.logradouro_id = al.id
                LEFT JOIN adm_uf au
                    ON au.id = ape.uf_id
                LEFT JOIN adm_cidade ac
                    ON ape.cidade_id = ac.id
                WHERE 
                    ap.id IN ({pessoa_ids})
                    AND CASE 
                            WHEN aet.name = 'Cobranca' THEN TRUE
                            ELSE TRUE
                        END
            """.format(pessoa_ids=', '.join(map(lambda p: str(p), pessoa_ids)))
            cr.execute(sql)
            pessoa_endereco = cr.dictfetchall()
            map(lambda e: endereco_dados.update({e.get('pessoa_id'): e}), pessoa_endereco)

        title_report = _('Contas a Receber') if datas['tipo_titulo'] == 'R' \
            else _('Contas a Pagar')
        title = center_title(title_report, _('Listagem de Duplicatas em Aberto'), '')

        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='1')
        listagem.informaNome(pdf_string, title_report)
        listagem.informaTamLinha(160)
        listagem.defineFonte(fonte='Courier', tam=8.7)

        cab_1 = _('* Relatorio')
        if datas['tipo_relatorio'] == '0':
            cab_1 += _('[So totais] ')
        elif datas.get('tipo_relatorio') == '1':
            cab_1 += '[Resumido] '
        else:
            cab_1 += _('[Completo] ')
        cab_1 += _('* Ordenar por')
        if datas['ordem_relatorio'] == 'name':
            cab_1 += _('[Cliente (Ascendente)] ')
        else:
            cab_1 += _('[Data de Vencimento] ')
        cab_1 += _('* Tipo titulo')
        if datas['tipo_titulo'] == 'R':
            cab_1 += _('[Receber] ')
        else:
            cab_1 += _('[Pagar] ')
        if datas['data_ref']:
            cab_1 += _('* Data de ref:')
            cab_1 += '[' + time.strftime("%d/%m/%Y", time.strptime(datas['data_ref'],
                                                                   "%Y-%m-%d")) + ']'

        tot_saldo = tot_saldo_corr = tot_saldo_cliente = tot_saldo_corr_cliente = 0

        # Vencidas
        at_m_120 = at_91_120 = at_61_90 = at_31_60 = at_16_30 = at_11_15 = at_6_10 = at_0_5 = 0
        atcliente_m_120 = atcliente_91_120 = atcliente_61_90 = atcliente_31_60 = 0
        atcliente_16_30 = atcliente_11_15 = atcliente_6_10 = atcliente_0_5 = 0
        t_m_120 = t_91_120 = t_61_90 = t_31_60 = t_16_30 = t_11_15 = t_6_10 = t_0_5 = 0
        tcliente_m_120 = tcliente_91_120 = tcliente_61_90 = tcliente_31_60 = tcliente_16_30 = 0
        tcliente_11_15 = tcliente_6_10 = tcliente_0_5 = 0

        # A vencer
        aat_m_120 = aat_91_120 = aat_61_90 = aat_31_60 = aat_16_30 = aat_11_15 = aat_6_10 = 0
        aat_0_5 = 0
        aatcliente_m_120 = aatcliente_91_120 = aatcliente_61_90 = aatcliente_31_60 = 0
        aatcliente_16_30 = aatcliente_11_15 = aatcliente_6_10 = aatcliente_0_5 = 0
        tt_m_120 = tt_91_120 = tt_61_90 = tt_31_60 = tt_16_30 = tt_11_15 = tt_6_10 = tt_0_5 = 0
        ttcliente_m_120 = ttcliente_91_120 = ttcliente_61_90 = ttcliente_31_60 = ttcliente_16_30 = 0
        ttcliente_11_15 = ttcliente_6_10 = ttcliente_0_5 = 0

        if datas['tipo_relatorio'] in ('1', '2'):
            listagem.informaCab(title)
            listagem.informaCab('  ')
            data_emi = time.strftime('%d/%m/%Y')
            listagem.informaCab(data_emi + center_title(
                '', datas['nome_empresa'], _('Pagina: {{ Page }}'), 150))
            listagem.informaCab(' ')
            listagem.informaCab(' ')
            listagem.informaCab('*' + '-' * 154 + '*')
            if datas.get('tipo_relatorio') == '2':
                cab_dados_pessoa = '|'
                cab_dados_pessoa += formataString('CPF/CNPJ', 19, ' ', 'D', 'N', 'S') + ' '
                cab_dados_pessoa += formataString('ENDERECO', 56, ' ', 'D', 'N', 'S') + ' '
                cab_dados_pessoa += formataString('MUNICIPIO', 49, ' ', 'D', 'N', 'S') + ' '
                cab_dados_pessoa += formataString('UF', 2, ' ', 'D', 'N', 'S') + ' '
                cab_dados_pessoa += formataString('CEP', 8, ' ', 'D', 'N', 'S') + ' '
                cab_dados_pessoa += formataString('TELEFONE', 15, ' ', 'D', 'N', 'S')
                cab_dados_pessoa += '|'
                listagem.informaCab(cab_dados_pessoa)
            listagem.informaCab(_('|*----- Cliente------ *        Tipo Documento Duplicata        '
                                  '  P  Emissao          Saldo    Saldo Corr. Vencimento  Local '
                                  'Cobranca   Natureza      Atraso|'))
            listagem.informaCab('|' + ' ' * 130 + _('*------OBSERVACAO------*') + '|')
            listagem.informaCab('|' + ' ' * 154 + '|')
            listagem.informaCab('*' + '-' * 154 + '*')
            listagem.rodapePadrao()
        pessoa = ''
        if dados:
            pessoa_id_aux = dados[0]['pessoa_id']
        list_data_vencimento = list()
        verificado = False
        dict_local_cobranca = dict()
        titulo_ids = map(lambda x: x.get('titulo_id'), dados)
        dados_titulo = pooler.get_pool(cr.dbname).get('financeiro.titulo').read(cr, uid,
                                  titulo_ids, ['fintit_saldo_corrigido'], context=context)
        saldo_corr_tit = {}
        map(lambda x: saldo_corr_tit.update({x.get('id'): x.get('fintit_saldo_corrigido')}),
            dados_titulo)
        for x in dados:
            if ordem_relatorio == 'data_prorrogacao':
                verificado = False
                if x.get('data_prorrogacao') not in list_data_vencimento:
                    if dados.index(x) != 0:
                        verificado = True
                    list_data_vencimento.append(x.get('data_prorrogacao'))
            else:
                if pessoa_id_aux != x['pessoa_id']:
                    verificado = True

            if datas['tipo_relatorio'] in ('1', '2'):
                if verificado:
                    verificado = False
                    valor_tot_vencidas_cliente = sum((
                            tcliente_m_120, tcliente_91_120, tcliente_61_90, tcliente_31_60,
                            tcliente_16_30, tcliente_11_15, tcliente_6_10, tcliente_0_5))
                    valor_tot_avencer_cliente = sum((
                        ttcliente_m_120, ttcliente_91_120, ttcliente_61_90, ttcliente_31_60,
                        ttcliente_16_30, ttcliente_11_15, ttcliente_6_10, ttcliente_0_5))
                    cabecalho = ('%s%s%s%s%s%s' % (
                        _('|                        Totais --> GERAL:        '),
                        formataString(getNumeroEditado(tot_saldo_cliente), 13, ' ', 'E', 'S', 'S'),
                        _(' VENCIDAS:         '), formataString(
                            getNumeroEditado(valor_tot_vencidas_cliente), 13, ' ', 'E', 'S', 'S'),
                        _(' A VENCER:       '), formataString(
                            getNumeroEditado(valor_tot_avencer_cliente), 13, ' ', 'E', 'S',
                            'S'))).ljust(153, ' ') + '|'
                    listagem.imprimeLinha('|%s|' % cabecalho)
                    listagem.imprimeLinha('*' + '-' * 154 + '*')
                    pessoa_id_aux = x['pessoa_id']
                    tot_saldo_cliente = 0
                    tot_saldo_corr_cliente = 0
                    aatcliente_m_120 = aatcliente_91_120 = aatcliente_61_90 = aatcliente_31_60 = 0
                    aatcliente_16_30 = aatcliente_11_15 = aatcliente_6_10 = aatcliente_0_5 = 0
                    atcliente_m_120 = atcliente_91_120 = atcliente_61_90 = atcliente_31_60 = 0
                    atcliente_16_30 = atcliente_11_15 = atcliente_6_10 = atcliente_0_5 = 0
                    tcliente_m_120 = tcliente_91_120 = tcliente_61_90 = tcliente_31_60 = 0
                    tcliente_16_30 = tcliente_11_15 = tcliente_6_10 = tcliente_0_5 = 0
                    ttcliente_m_120 = ttcliente_91_120 = ttcliente_61_90 = ttcliente_31_60 = 0
                    ttcliente_16_30 = ttcliente_11_15 = ttcliente_6_10 = ttcliente_0_5 = 0
                    valor_tot_vencidas_cliente = valor_tot_avencer_cliente = 0

            dias_vencer = abs(x['atraso'])
            nome_local_cobranca = x.get('nome_local_cobranca') or ''
            if x['data_prorrogacao'] >= time.strftime('%Y-%m-%d'):
                if nome_local_cobranca not in dict_local_cobranca:
                    dict_local_cobranca[nome_local_cobranca] = {
                        'vencer': x.get('saldo') or 0.0,
                        'qtd_vencer': 1, 'vencido': 0.0,
                        'qtd_vencido': 0
                    }
                else:
                    dict_local_cobranca[nome_local_cobranca]['vencer'] += x.get('saldo') or 0.0
                    dict_local_cobranca[nome_local_cobranca]['qtd_vencer'] += 1
                if dias_vencer <= 5:
                    aat_0_5 += 1
                    tt_0_5 += x['saldo']
                    aatcliente_0_5 += 1
                    ttcliente_0_5 += x['saldo']
                elif dias_vencer <= 10:
                    aat_6_10 += 1
                    tt_6_10 += x['saldo']
                    aatcliente_6_10 += 1
                    ttcliente_6_10 += x['saldo']
                elif dias_vencer <= 15:
                    aat_11_15 += 1
                    tt_11_15 += x['saldo']
                    aatcliente_11_15 += 1
                    ttcliente_11_15 += x['saldo']
                elif dias_vencer <= 30:
                    aat_16_30 += 1
                    tt_16_30 += x['saldo']
                    aatcliente_16_30 += 1
                    ttcliente_16_30 += x['saldo']
                elif dias_vencer <= 60:
                    aat_31_60 += 1
                    tt_31_60 += x['saldo']
                    aatcliente_31_60 += 1
                    ttcliente_31_60 += x['saldo']
                elif dias_vencer <= 90:
                    aat_61_90 += 1
                    tt_61_90 += x['saldo']
                    aatcliente_61_90 += 1
                    ttcliente_61_90 += x['saldo']
                elif dias_vencer <= 120:
                    aat_91_120 += 1
                    tt_91_120 += x['saldo']
                    aatcliente_91_120 += 1
                    ttcliente_91_120 += x['saldo']
                else:
                    aat_m_120 += 1
                    tt_m_120 += x['saldo']
                    aatcliente_m_120 += 1
                    ttcliente_m_120 += x['saldo']
            else:
                if nome_local_cobranca not in dict_local_cobranca:
                    dict_local_cobranca[nome_local_cobranca] = {
                        'vencido': x.get('saldo') or 0.0,
                        'qtd_vencido': 1, 'vencer': 0.0,
                        'qtd_vencer': 0
                    }
                else:
                    dict_local_cobranca[nome_local_cobranca]['vencido'] += x.get('saldo') or 0.0
                    dict_local_cobranca[nome_local_cobranca]['qtd_vencido'] += 1

                if dias_vencer <= 5:
                    at_0_5 += 1
                    t_0_5 += x['saldo']
                    atcliente_0_5 += 1
                    tcliente_0_5 += x['saldo']
                elif dias_vencer <= 10:
                    at_6_10 += 1
                    t_6_10 += x['saldo']
                    atcliente_6_10 += 1
                    tcliente_6_10 += x['saldo']
                elif dias_vencer <= 15:
                    at_11_15 += 1
                    t_11_15 += x['saldo']
                    atcliente_11_15 += 1
                    tcliente_11_15 += x['saldo']
                elif dias_vencer <= 30:
                    at_16_30 += 1
                    t_16_30 += x['saldo']
                    atcliente_16_30 += 1
                    tcliente_16_30 += x['saldo']
                elif dias_vencer <= 60:
                    at_31_60 += 1
                    t_31_60 += x['saldo']
                    atcliente_31_60 += 1
                    tcliente_31_60 += x['saldo']
                elif dias_vencer <= 90:
                    at_61_90 += 1
                    t_61_90 += x['saldo']
                    atcliente_61_90 += 1
                    tcliente_61_90 += x['saldo']
                elif dias_vencer <= 120:
                    at_91_120 += 1
                    t_91_120 += x['saldo']
                    atcliente_91_120 += 1
                    tcliente_91_120 += x['saldo']
                else:
                    at_m_120 += 1
                    t_m_120 += x['saldo']
                    atcliente_m_120 += 1
                    tcliente_m_120 += x['saldo']
            if datas['tipo_relatorio'] in ('1', '2'):
                try:
                    data_emissao = time.strftime("%d/%m/%Y", time.strptime(x['data_emissao'],
                                                                           "%Y-%m-%d"))
                except:
                    data_emissao = ''
                if pessoa == x['pessoa_id']:
                    nome_codigo_pessoa = ' '
                else:
                    nome_codigo_pessoa = str(x.get('codigo_pessoa')) + ' ' + x.get('nome')
                    if datas['tipo_relatorio'] == '2':
                        cpf_cnpj = endereco_dados.get(x.get('pessoa_id')).get('cpf_cnpj')
                        if endereco_dados.get(x.get('pessoa_id')).get('pessoa_tipo') == 'J' and len(
                                cpf_cnpj) == 14:
                            cpf_cnpj = "%s.%s.%s/%s-%s" % (cpf_cnpj[0:2], cpf_cnpj[2:5],
                                                           cpf_cnpj[5:8], cpf_cnpj[8:12],
                                                           cpf_cnpj[12:14])
                        elif endereco_dados.get(x.get('pessoa_id')).get('pessoa_tipo') == 'F' and \
                                len(cpf_cnpj) == 11:
                            cpf_cnpj = "%s.%s.%s-%s" % (cpf_cnpj[0:3], cpf_cnpj[3:6], cpf_cnpj[6:9],
                                                        cpf_cnpj[9:11])
                        linha = '|'
                        linha += formataString(cpf_cnpj, 19, ' ', 'D', 'N', 'S') + ' '
                        linha += formataString(endereco_dados.get(x.get('pessoa_id')).get(
                            'endereco') or '', 56, ' ', 'D', 'N', 'S') + ' '
                        linha += formataString(endereco_dados.get(x.get('pessoa_id')).get(
                            'municipio') or '', 49, ' ', 'D', 'N', 'S') + ' '
                        linha += formataString(endereco_dados.get(x.get('pessoa_id')).get(
                            'uf') or '', 2, ' ', 'D', 'N', 'S') + ' '
                        linha += formataString(endereco_dados.get(x.get('pessoa_id')).get(
                            'cep') or '', 8, ' ', 'D', 'N', 'S') + ' '
                        linha += formataString(endereco_dados.get(x.get('pessoa_id')).get(
                            'telefone') or '', 15, ' ', 'D', 'N', 'S')
                        linha += '|'
                        listagem.imprimeLinha(linha)
                pessoa = x['pessoa_id']
                linha = []
                linha.append(formataString(nome_codigo_pessoa, 30, ' ', 'D', 'N', 'S'))
                linha.append(' ')
                linha.append(formataString(x.get('documento_tipo'), 14, ' ', 'D', 'N', 'S'))
                linha.append(' ')
                linha.append(formataString(x['documento'], 16, ' ', 'D', 'N', 'S'))
                linha.append(' ')
                linha.append(formataString(x['parcela'], 2, ' ', 'E', 'N', 'S'))
                linha.append(' ')
                linha.append(formataString(data_emissao, 10, ' ', 'D', 'N', 'S'))
                linha.append(' ')
                linha.append(formataString(getNumeroEditado(x['saldo']), 13, ' ', 'E', 'S', 'S'))
                linha.append(' ')
                linha.append(formataString(getNumeroEditado(saldo_corr_tit.get(x.get('titulo_id'))),
                                       13, ' ', 'E', 'S', 'S'))
                linha.append(' ')
                linha.append(formataString(
                    time.strftime("%d/%m/%Y", time.strptime(x['data_prorrogacao'], "%Y-%m-%d")), 11,
                    ' ', 'D', 'N', 'S'))
                linha.append(' ')
                linha.append(formataString(nome_local_cobranca, 13, ' ', 'D', 'N', 'S'))
                linha.append('     ')
                if not x['natureza_cobranca_id']:
                    natureza = ' '
                else:
                    natureza = pooler.get_pool(
                        cr.dbname).get('financeiro.natureza.cobranca').read(
                        cr, uid, x['natureza_cobranca_id'], ['name'], context=context)['name']
                linha.append(formataString(natureza, 12, ' ', 'D', 'N', 'S'))
                linha.append(' ')
                linha.append(formataString(x['atraso'] > 0 and x['atraso'] or '', 5, ' ', 'E', 'S',
                                           'S'))
                linha.append(' ')
                tot_saldo += x['saldo']
                tot_saldo_corr += saldo_corr_tit.get(x.get('titulo_id'))
                tot_saldo_cliente += x['saldo']
                tot_saldo_corr_cliente += saldo_corr_tit.get(x.get('titulo_id'))
                listagem.imprimeLinha('|%s|' % ''.join(linha))
                if datas.get('desconto_juros', False):
                    linha = list()
                    linha.append(formataString('|     Desconto Valor:', 21, ' ', 'E', 'S', 'S'))
                    linha.append(formataString(getNumeroEditado(x['vr_desconto'] or 0), 10, ' ',
                                               'E', 'S', 'S'))
                    linha.append('   ')
                    linha.append(formataString('Data Limite: ', 12, ' ', 'E', 'S', 'S'))
                    data = ''
                    if x['data_limite_desconto']:
                        data = x['data_limite_desconto'][8:10] + '/' + \
                               x['data_limite_desconto'][5:7] + '/' + x['data_limite_desconto'][0:4]
                    linha.append(' ')
                    linha.append(formataString(data, 10, ' ', 'E', 'S', 'S'))
                    linha.append('   ')
                    linha.append(formataString('Juros p/ dia: ', 14, ' ', 'E', 'S', 'S'))
                    linha.append(formataString(getNumeroEditado(x['vr_juros_dia'] or 0.00), 6, ' ',
                                               'E', 'S', 'S'))
                    linha.append('   ')
                    linha.append(formataString('Multa Valor: ', 13, ' ', 'E', 'S', 'S'))
                    linha.append(formataString(getNumeroEditado(x['vr_multa'] or 0), 10, ' ', 'E',
                                               'S', 'S'))
                    linha.append('   ')
                    linha.append(formataString('Apos data: ', 11, ' ', 'E', 'S', 'S'))
                    linha.append(' ')
                    data = ''
                    if x['multa_apos_data']:
                        data = x['multa_apos_data'][8:10] + '/' + x['multa_apos_data'][5:7] + \
                               '/' + x['multa_apos_data'][0:4]
                    linha.append(' ')
                    linha.append(formataString(data, 10, ' ', 'E', 'S', 'S'))
                    linha.append(' ' * 23 + '|')
                    listagem.imprimeLinha(''.join(linha))
                    listagem.imprimeLinha('|' + ' ' * 154 + '|')
                if x.get('observacoes', False):
                    obs = x['observacoes']
                    espaco = ' ' * 40
                    tamanho_linha = 106
                    word = obs.split(' ')
                    frase = ""
                    cont = 0
                    len_word = len(word)
                    campo = 0
                    for i in word:
                        cont += 1
                        size_i = len(i)
                        if size_i + campo < tamanho_linha:
                            frase = frase + i + ' '
                            campo = len(frase)
                        elif size_i + campo > tamanho_linha:
                            frase = formataString('' + frase, tamanho_linha, ' ', 'D', 'N', 'S')
                            listagem.imprimeLinha(espaco + frase)
                            frase = ''
                            frase = frase + i + ' '
                            campo = len(frase)
                        if cont == len_word:
                            frase = formataString('' + frase, tamanho_linha, ' ', 'D', 'N', 'S')
                            listagem.imprimeLinha(espaco + frase)
                if dados.index(x) == (len(dados) - 1):
                    valor_tot_vencidas_cliente = sum((
                        tcliente_m_120, tcliente_91_120, tcliente_61_90, tcliente_31_60,
                        tcliente_16_30, tcliente_11_15, tcliente_6_10, tcliente_0_5))

        if datas['tipo_relatorio'] in ('1', '2'):
            valor_tot_vencidas_cliente = tcliente_m_120 + tcliente_91_120 + tcliente_61_90 + \
                                         tcliente_31_60 + tcliente_16_30 + tcliente_11_15 + \
                                         tcliente_6_10 + tcliente_0_5
            valor_tot_avencer_cliente = ttcliente_m_120 + ttcliente_91_120 + ttcliente_61_90 + \
                                        ttcliente_31_60 + ttcliente_16_30 + ttcliente_11_15 + \
                                        ttcliente_6_10 + ttcliente_0_5
            listagem.imprimeLinha(_('|                  Totais --> GERAL:        ') +
                                  formataString(getNumeroEditado(tot_saldo_cliente), 13, ' ',
                                                'E', 'S', 'S') + _(' VENCIDAS:         ') +
                                  formataString(getNumeroEditado(valor_tot_vencidas_cliente), 13,
                                                ' ', 'E', 'S', 'S') + _(' A VENCER:       ') +
                                  formataString(getNumeroEditado(valor_tot_avencer_cliente), 13,
                                                ' ', 'E', 'S', 'S') + ' ' * 36 + '|')
            listagem.imprimeLinha('*' + '-' * 154 + '*')
            listagem.imprimeLinha('|' + ' ' * 62 + _('Totais:     ') + formataString(
                getNumeroEditado(tot_saldo), 13, ' ', 'E', 'S', 'S') + ' ' + formataString(
                getNumeroEditado(tot_saldo_corr), 13, ' ', 'E', 'S', 'S') + ' ' * 53 + '|')
            listagem.imprimeLinha('*' + '-' * 154 + '*')
            listagem.imprimeLinha(' ')
            listagem.cabecalhos = []
            listagem.imprimeLinha('{{ Page }}')
        total_qt_vencidas = sum((at_m_120, at_91_120, at_61_90, at_31_60, at_16_30, at_11_15,
                                 at_6_10, at_0_5))
        valor_tot_vencidas = sum((t_m_120, t_91_120, t_61_90, t_31_60, t_16_30, t_11_15, t_6_10,
                                  t_0_5))
        total_qt_avencer = sum((aat_m_120, aat_91_120, aat_61_90, aat_31_60, aat_16_30, aat_11_15,
                                aat_6_10, aat_0_5))
        valor_tot_avencer = sum((tt_m_120, tt_91_120, tt_61_90, tt_31_60, tt_16_30, tt_11_15,
                                 tt_6_10, tt_0_5))

        listagem.imprimeLinha('*' + '-' * 88 + '*')
        listagem.imprimeLinha(_('|                        *** RESUMO DE DUPLICATAS EM ABERTO *** '
                                '                         |'))
        listagem.imprimeLinha('|' + '-' * 88 + '|')
        listagem.imprimeLinha(_('|            VENCIDAS                      *              '
                                'A VENCER                       |'))
        listagem.imprimeLinha('|' + '-' * 88 + '|')
        listagem.imprimeLinha(_('|  QUANT.    INTERVALO              VALOR  *   QUANT.     '
                                'INTERVALO                VALOR |'))
        listagem.imprimeLinha('|' + '-' * 88 + '|')
        listagem.imprimeLinha(_('|     ') + formataString(str(at_m_120), 3, ' ', 'E', 'S', 'S') +
                              _('    Mais de 120     ') + formataString(
            getNumeroEditado(t_m_120), 13, ' ', 'E', 'S', 'S') + _(' |     ') +
                              formataString(str(aat_m_120), 3, ' ', 'E', 'S', 'S') +
                              _('      Mais de 120     ') + formataString(
            getNumeroEditado(tt_m_120), 13, ' ', 'E', 'S', 'S') + _('  |'))
        listagem.imprimeLinha(_('|     ') + formataString(str(at_91_120), 3, ' ', 'E', 'S', 'S') +
                              _('    De 91 a 120     ') + formataString(
            getNumeroEditado(t_91_120), 13, ' ', 'E', 'S', 'S') + _(' |     ') +
                              formataString(str(aat_91_120), 3, ' ', 'E', 'S', 'S') +
                              _('      De 91 a 120     ') + formataString(
            getNumeroEditado(tt_91_120), 13, ' ', 'E', 'S', 'S') + _('  |'))
        listagem.imprimeLinha(_('|     ') + formataString(str(at_61_90), 3, ' ', 'E', 'S', 'S') +
                              _('    De 61 a 90      ') + formataString(
            getNumeroEditado(t_61_90), 13, ' ', 'E', 'S', 'S') + _(' |     ') +
                              formataString(str(aat_61_90), 3, ' ', 'E', 'S', 'S') +
                              _('      De 61 a 90      ') + formataString(
            getNumeroEditado(tt_61_90), 13, ' ', 'E', 'S', 'S') + _('  |'))
        listagem.imprimeLinha(_('|     ') + formataString(str(at_31_60), 3, ' ', 'E', 'S', 'S') +
                              _('    De 31 a 60      ') + formataString(
            getNumeroEditado(t_31_60), 13, ' ', 'E', 'S', 'S') + _(' |     ') +
                              formataString(str(aat_31_60), 3, ' ', 'E', 'S', 'S') +
                              _('      De 31 a 60      ') + formataString(
            getNumeroEditado(tt_31_60), 13, ' ', 'E', 'S', 'S') + _('  |'))
        listagem.imprimeLinha(_('|     ') + formataString(str(at_16_30), 3, ' ', 'E', 'S', 'S') +
                              _('    De 16 a 30      ') + formataString(
            getNumeroEditado(t_16_30), 13, ' ', 'E', 'S', 'S') + _(' |     ') +
                              formataString(str(aat_16_30), 3, ' ', 'E', 'S', 'S') +
                              _('      De 16 a 30      ') + formataString(
            getNumeroEditado(tt_16_30), 13, ' ', 'E', 'S', 'S') + _('  |'))
        listagem.imprimeLinha(_('|     ') + formataString(str(at_11_15), 3, ' ', 'E', 'S', 'S') +
                              _('    De 11 a 15      ') + formataString(
            getNumeroEditado(t_11_15), 13, ' ', 'E', 'S', 'S') + _(' |     ') +
                              formataString(str(aat_11_15), 3, ' ', 'E', 'S', 'S') +
                              _('      De 11 a 15      ') + formataString(
            getNumeroEditado(tt_11_15), 13, ' ', 'E', 'S', 'S') + _('  |'))
        listagem.imprimeLinha(_('|     ') + formataString(str(at_6_10), 3, ' ', 'E', 'S', 'S') +
                              _('    De 6  a 10      ') + formataString(
            getNumeroEditado(t_6_10), 13, ' ', 'E', 'S', 'S') + _(' |     ') +
                              formataString(str(aat_6_10), 3, ' ', 'E', 'S', 'S') +
                              _('      De 6  a 10      ') + formataString(
            getNumeroEditado(tt_6_10), 13, ' ', 'E', 'S', 'S') + _('  |'))
        listagem.imprimeLinha(_('|     ') + formataString(str(at_0_5), 3, ' ', 'E', 'S', 'S') +
                              _('    De 0  a  5      ') + formataString(
            getNumeroEditado(t_0_5), 13, ' ', 'E', 'S', 'S') + _(' |     ') +
                              formataString(str(aat_0_5), 3, ' ', 'E', 'S', 'S') +
                              _('      De 0  a  5      ') + formataString(
            getNumeroEditado(tt_0_5), 13, ' ', 'E', 'S', 'S') + _('  |'))
        listagem.imprimeLinha('|' + '-' * 88 + '|')
        listagem.imprimeLinha(_('|TOTAIS:  ') +
                              formataString(str(total_qt_vencidas), 3, ' ', 'E', 'S', 'S') +
                              '                ' + formataString(
            getNumeroEditado(valor_tot_vencidas), 13, ' ', 'E', 'S', 'S') + '       ' +
                              formataString(str(total_qt_avencer), 3, ' ', 'E', 'S', 'S') +
                              '                      ' + formataString(
            getNumeroEditado(valor_tot_avencer), 13, ' ', 'E', 'S', 'S') + _('  |'))
        listagem.imprimeLinha('|' + '-' * 88 + '|')
        listagem.imprimeLinha(_('|                                  TOTAL GERAL: ') +
                              formataString(str(total_qt_vencidas + total_qt_avencer), 4, ' ', 'E',
                                            'S', 'S') + '                      ' +
                              formataString(getNumeroEditado(valor_tot_vencidas +
                                                             valor_tot_avencer),
                                            13, ' ', 'E', 'S', 'S') + _('  |'))
        listagem.imprimeLinha('*' + '-' * 88 + '*')
        listagem.imprimeLinha('')
        listagem.imprimeLinha('')
        listagem.imprimeLinha('*' + '-' * 88 + '*')
        listagem.imprimeLinha(_('|                         *** RESUMO POR LOCAL DE COBRANCA *** '
                                '                          |'))
        listagem.imprimeLinha('|' + '-' * 88 + '|')
        listagem.imprimeLinha(_('|            VENCIDAS                      *              '
                                'A VENCER                       |'))
        listagem.imprimeLinha('|' + '-' * 88 + '|')
        listagem.imprimeLinha(_('|  QUANT. DESCRICAO                 VALOR  *   QUANT. DESCRICAO '
                                '                   VALOR |'))
        listagem.imprimeLinha('|' + '-' * 88 + '|')
        qtd_total_vencido = sum(
            map(lambda i: i.get('qtd_vencido') if i.get('qtd_vencido') > 0 else 0,
                dict_local_cobranca.values()))
        qtd_total_vencer = sum(
            map(lambda i: i.get('qtd_vencer') if i.get('qtd_vencer') > 0 else 0,
                dict_local_cobranca.values()))
        valor_total_vencido = sum(
            map(lambda i: i.get('vencido') if i.get('vencido') > 0 else 0,
                dict_local_cobranca.values()))
        valor_total_vencer = sum(
            map(lambda i: i.get('vencer') if i.get('vencer') > 0 else 0,
                dict_local_cobranca.values()))
        qtd_total_geral = qtd_total_vencido + qtd_total_vencer
        valor_total_geral = valor_total_vencido + valor_total_vencer
        for x in dict_local_cobranca:
            dado = dict_local_cobranca.get(x)
            linha = '|'
            linha += formataString(dado.get('qtd_vencido'), 8, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString(x, 17, ' ', 'D', 'S', 'S')
            linha += ' '
            linha += formataString(getNumeroEditado(dado.get('vencido'), 2), 13, ' ', 'E', 'S', 'S')
            linha += '  | '
            linha += formataString(dado.get('qtd_vencer'), 8, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString(x, 20, ' ', 'D', 'S', 'S')
            linha += ' '
            linha += formataString(getNumeroEditado(dado.get('vencer'), 2), 13, ' ', 'E', 'S', 'S')
            linha += ' |'
            listagem.imprimeLinha(linha)
        listagem.imprimeLinha('|' + '-' * 88 + '|')
        linha = '|TOTAIS:  '
        linha += formataString(qtd_total_vencido, 3, ' ', 'E', 'S', 'S')
        linha += formataString(getNumeroEditado(valor_total_vencido, 2), 28, ' ', 'E', 'S', 'S')
        linha += formataString(qtd_total_vencer, 12, ' ', 'E', 'S', 'S')
        linha += formataString(getNumeroEditado(valor_total_vencer, 2), 35, ' ', 'E', 'S', 'S')
        linha += ' |'
        listagem.imprimeLinha(linha)
        listagem.imprimeLinha('|' + '-' * 88 + '|')
        linha = '|                                  TOTAL GERAL: '
        linha += formataString(qtd_total_geral, 5, ' ', 'E', 'S', 'S')
        linha += formataString(getNumeroEditado(valor_total_geral, 2), 35, ' ', 'E', 'S', 'S')
        linha += ' |'
        listagem.imprimeLinha(linha)
        listagem.imprimeLinha('*' + '-' * 88 + '*')
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.report_titulos_abertos')


class titulos_abertos_osv(osv.TransientModel):
    _name = 'titulos.abertos.osv'
    _description = 'Titulos em Abertos'

    def fields_get(self, cr, uid, fields=None, context=None):
        context = context and context.copy() or {}
        res = super(titulos_abertos_osv, self).fields_get(cr, uid, fields, context)
        if context.get('tipo', True) == 'R':
            res['pessoa_id']['string'] = _('Cliente')
        elif context.get('tipo', True) == 'P':
            res['pessoa_id']['string'] = _('Fornecedor')
        return res

    def _default_get(self, cr, uid, data, context=None):
        context = context and context.copy() or {}
        if data['tipo'] == 'R':
            return 'R'
        if data['tipo'] == 'P':
            return 'P'

    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', required=True, select=True),
        'tipo_titulo': fields.selection([('R', 'Receber'), ('P', 'Pagar')], 'Tipo titulo',
                                        required=True),
        'natureza_cobranca_ids': fields.many2many('financeiro.natureza.cobranca',
                                                  'natureza_cobranca_titulo_aberto',
                                                  'titulo_aberto_id',
                                                  'natureza_cobranca_id', 'Natureza cobranca'),
        'local_cobranca_ids': fields.many2many('financeiro.local.cobranca',
                                               'local_cobranca_titulo_aberto', 'titulo_aberto_id',
                                               'local_cobranca_id', 'Local cobranca'),
        # ids do local de cobranca
        'doc_tipo_ids': fields.many2many('documento.documento.tipo', 'titulo_aberto_documento_tipo',
                                         'titulo_aberto_id', 'documento_tipo_id',
                                         'Tipo de documento'),
        'tipo_relatorio': fields.selection(
            [('0', 'So totais'), ('1', 'Resumido'), ('2', 'Completo')], 'Tipo Relatorio',
            required=True),
        'ordem_relatorio': fields.selection(
            [('name', 'Cliente (Alfabetica)'), ('data_prorrogacao', 'Data de Vencimento')],
            'Ordem Relatorio', required=True),
        'clientes_cat': fields.many2many(
            'adm.pessoa.categoria.nome', 'titulo_aberto_m2m_pessoa_categoria', 'titulo_aberto_id',
            'categoria_id', 'Categorias'), # Relacao das categorias a que uma pessoa pertence
        'data_emi_ini': fields.date('Emissao Inicio', select=True),
        'data_emi_fim': fields.date('Emissao Fim', select=True),
        'data_vct_ini': fields.date('Vencimento Inicio', select=True),
        'data_vct_fim': fields.date('Vencimento Fim', select=True),
        'data_ref': fields.date('Data Referencia', select=True),
        'pessoa_id': fields.many2one('adm.pessoa'),
        'imprime_obs': fields.boolean("Imprimir Observacao"),
        'desconto_juros': fields.boolean("Imprimir desconto/juros"),
        'considera_previsao': fields.boolean("Considerar Previsao"),
        'cartao_de_credito': fields.boolean('Cartao de credito',
                                            help='Se marcado, incluir cartoes de credito')
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(
            cr, uid, uid, c).company_id.id,
        'ordem_relatorio': lambda *a: 'data_prorrogacao',
        'tipo_titulo': _default_get,
        'tipo_relatorio': lambda *a: '1',
        'considera_previsao': False,
        'cartao_de_credito': lambda *a: True,
    }

    def bt_print(self, cr, uid, ids, context):
        titulos_abertos_osv_dados = self.read(cr, uid, ids, [], context=context)
        vals = {}
        for x in titulos_abertos_osv_dados:
            company_id = x.get('company_id')
            if isinstance(company_id, tuple):
                company_id = company_id[0]
            if not isinstance(company_id, list):
                company_id = [company_id]
            res_company_dados = self.pool.get("res.company").read(
                cr, uid, company_id, ['name'], context=context)
            for i in res_company_dados:
                nome_empresa = i.get('name')
            if 'id' in x:
                del x['id']
                x['nome_empresa'] = nome_empresa
            vals = x
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'report_titulos_abertos',
            'datas': vals,
        }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
