# -*- coding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
from openerp.tools.translate import _
import StringIO
from openerp import netsvc
from openerp import pooler
import time


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_titulos_liquidados(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        pdf_file = StringIO.StringIO()

        ids_tit_baixa = datas.get('titulo_baixa_ids')
        tipo = datas['tipo_titulo']
        nome_pagamento = datas.get('nome_pagamento')
        ordem = datas.get('ordem_a_listar')
        condicao_tipo = datas.get('condicao_tipo')

        nome_empresa = datas['nome_empresa']
        obj_tit_baixa = pooler.get_pool(cr.dbname).get('financeiro.titulo.baixa.view')

        lista_arg = datas.get('lista_argumentos')

        listagem = Impressora()
        listagem.defineFormato(orientacao='1')
        listagem.informaNome(pdf_file, _('Titulos Liquidados'))
        listagem.informaTamLinha(106)
        cab = _('                                                                       TITULOS LIQUIDADOS                                                                              Pag.' + '{{ Page }}')
        listagem.informaCab(cab)
        listagem.informaCab(' ')
        data_emi = time.strftime('%d-%m-%Y')
        if tipo == 'R':
            t = _('Tipo Titulo: Receber')
        if tipo == 'P':
            t = _('Tipo Titulo:Pagar')
        listagem.informaCab(_('Empresa: ') + _(nome_empresa))
        listagem.informaCab(t)
        if nome_pagamento:
            nome_pagamento = 'Forma de pagamento: %s' % nome_pagamento
            listagem.informaCab(nome_pagamento)

        listagem.informaCab(lista_arg)
        listagem.informaCab(_(' '))
        listagem.informaCab('--')
        cab = formataString(_('Cod.P. '), 8, '  ', 'E', 'N', 'S')
        cab += formataString(_('Nome'), 46, ' ', 'D', 'N', 'S')
        cab += formataString(_('Tipo Documento '), 16, ' ', 'C', 'N', 'S')
        cab += formataString(_('Emissao '), 11, ' ', 'C', 'N', 'S')
        cab += formataString(_('Documento '), 18, ' ', 'E', 'N', 'S')
        cab += ' P '
        cab += formataString(_('Vencimento'), 11, ' ', 'E', 'S', 'S')
        cab += formataString(_('Pagamento'), 11, ' ', 'E', 'S', 'S')
        cab += formataString(_('Valor'), 13, ' ', 'E', 'S', 'S')
        cab += formataString(_('T/P'), 4, ' ', 'E', 'S', 'S')
        cab += formataString(_('Juros'), 9, ' ', 'E', 'S', 'S')
        cab += formataString(_('Multa'), 9, ' ', 'E', 'S', 'S')
        cab += formataString(_('Desconto'), 9, ' ', 'E', 'S', 'S')
        cab += formataString(_('Acrescimo'), 10, ' ', 'E', 'S', 'S')
        cab += formataString(_('Vr. Pago'), 15, ' ', 'E', 'S', 'S')
        listagem.informaCab(cab)
        listagem.informaCab('--')
        listagem.informaCab(' ')
        listagem.rodapePadrao()
        valor_pago = 0
        valor_juros = 0
        valor_multa = 0
        valor_desconto = 0
        valor_acrescimo = 0
        valor_total = 0
        browse_titulos_baixa = obj_tit_baixa.browse(cr, uid, ids_tit_baixa)

        ids_tit_baixa_renegociacao = []
        if not datas.get('titulo_renegociado'):
            sql = """
                    SELECT
                        distinct ftb.id AS id
                    FROM financeiro_titulo_baixa ftb
                    INNER JOIN financeiro_titulo ft
                        ON ft.id = ftb.titulo_id
                    INNER JOIN financeiro_titulo_historico fth
                        ON ft.id = fth.titulo_id
                    WHERE
                        ftb.id IN ({titulo_baixa_ids})
                        AND fth.operacao IN ('BR')
                """.format(titulo_baixa_ids=', '.join(map(lambda tbi: str(tbi),
                                                          ids_tit_baixa or [-1])))
            cr.execute(sql)
            ids_tit_baixa_renegociacao = map(lambda x: x.get('id'), cr.dictfetchall())
        if ids_tit_baixa_renegociacao:
            browse_titulos_baixa = filter(lambda ftb: ftb.id not in ids_tit_baixa_renegociacao,
                                          browse_titulos_baixa)

        # Se a condicacao for a vista, deve filtrar os titulos para que exiba somente os que possuem
        # data de emissao igual a prorrogacao
        if condicao_tipo == 'V':
            browse_titulos_baixa = filter(lambda i: i.data_emissao == i.data_prorrogacao,
                                          browse_titulos_baixa)
        # Se a condicacao for a prazo, deve filtrar os titulos para que exiba somente os que possuem
        # data de emissao diferente a prorrogacao
        elif condicao_tipo == 'P':
            browse_titulos_baixa = filter(lambda i: i.data_emissao != i.data_prorrogacao,
                                          browse_titulos_baixa)
        if ordem == 'P':
            pessoa_list = []
            valor_pago_pessoa = 0
            valor_juros_pessoa = 0
            valor_multa_pessoa = 0
            valor_desconto_pessoa = 0
            valor_acrescimo_pessoa = 0
            valor_total_pessoa = 0
            for tit in browse_titulos_baixa:
                data_emissao = tit.data_emissao or ''
                if data_emissao:
                    data_emissao = time.strftime('%d/%m/%Y', time.strptime(data_emissao, '%Y-%m-%d'))
                pessoa_id = tit.pessoa_id.id
                if pessoa_id not in pessoa_list:
                    pessoa_list.append(pessoa_id)
                    linha = formataString(tit.codigo, 7, ' ', 'E', 'N', 'S')
                    linha += ' '
                    linha += formataString(tit.pessoa_id.partner_id.name, 45, ' ', 'D', 'N', 'S')
                    linha += ' '
                else:
                    linha = formataString('', 7, ' ', 'E', 'N', 'S')
                    linha += ' '
                    linha += formataString('', 45, ' ', 'D', 'N', 'S')
                    linha += ' '
                linha += formataString(tit.doc_tipo_id.name, 15, ' ', 'D', 'S', 'S')
                linha += ' '
                linha += formataString(data_emissao, 10, ' ', 'D', 'S', 'S')
                linha += ' '
                linha += formataString(tit.documento, 17, ' ', 'E', 'S', 'S')
                linha += ' '
                linha += formataString(tit.parcela, 3, ' ', 'C', 'N', 'S')
                linha += ' '
                linha += formataString(time.strftime("%d/%m/%Y", time.strptime(tit.data_prorrogacao, "%Y-%m-%d")), 10, ' ',
                                       'E', 'N', 'S')
                linha += ' '
                linha += formataString(time.strftime("%d/%m/%Y", time.strptime(tit.data_pgto, "%Y-%m-%d")), 10, ' ', 'E',
                                       'N', 'S')
                linha += ' '
                linha += formataString(getNumeroEditado(tit.vr_original), 12, ' ', 'E', 'S', 'S')
                linha += ' '
                linha += formataString('P' if tit.vr_original > tit.valor_pago else 'T', 3, ' ', 'C', 'S', 'S')
                linha += ' '
                linha += formataString(getNumeroEditado(tit.valor_juros), 8, ' ', 'E', 'S', 'S')
                linha += ' '
                linha += formataString(getNumeroEditado(tit.valor_multa), 8, ' ', 'E', 'S', 'S')
                linha += ' '
                linha += formataString(getNumeroEditado(tit.valor_desconto), 8, ' ', 'E', 'S', 'S')
                linha += ' '
                linha += formataString(getNumeroEditado(tit.valor_acrescimo), 9, ' ', 'E', 'S', 'S')
                linha += ' '
                linha += formataString(getNumeroEditado(tit.valor_pago), 14, ' ', 'E', 'S', 'S')

                # Valores do total geral
                valor_pago += tit.valor_pago
                valor_juros += tit.valor_juros
                valor_multa += tit.valor_multa
                valor_desconto += tit.valor_desconto
                valor_acrescimo += tit.valor_acrescimo

                # Valores do total por pessoa
                valor_pago_pessoa += tit.valor_pago
                valor_juros_pessoa += tit.valor_juros
                valor_multa_pessoa += tit.valor_multa
                valor_desconto_pessoa += tit.valor_desconto
                valor_acrescimo_pessoa += tit.valor_acrescimo

                listagem.imprimeLinha(linha)
                try:
                    pessoa_id_proximo_titulo = browse_titulos_baixa[browse_titulos_baixa.
                                                                    index(tit)+1].pessoa_id.id
                except:
                    pessoa_id_proximo_titulo = False
                if pessoa_id != pessoa_id_proximo_titulo:
                    listagem.imprimeLinha(
                        ' ' * 141 +
                        _(' ________') +
                        _(' ________') +
                        _(' ________') +
                        _(' _________') +
                        _(' ______________'))
                    listagem.imprimeLinha(
                        ' ' * 141 +
                        formataString(str(getNumeroEditado(valor_juros_pessoa)), 9, ' ', 'E', 'S', 'S') + ' ' +
                        formataString(str(getNumeroEditado(valor_multa_pessoa)), 8, ' ', 'E', 'S', 'S') + ' ' +
                        formataString(str(getNumeroEditado(valor_desconto_pessoa)), 8, ' ', 'E', 'S', 'S') + ' ' +
                        formataString(str(getNumeroEditado(valor_acrescimo_pessoa)), 9, ' ', 'E', 'S', 'S') + ' ' +
                        formataString(str(getNumeroEditado(valor_pago_pessoa)), 14, ' ', 'E', 'S', 'S') + ' ')
                    valor_pago_pessoa = 0
                    valor_juros_pessoa = 0
                    valor_multa_pessoa = 0
                    valor_desconto_pessoa = 0
                    valor_acrescimo_pessoa = 0
                    valor_total_pessoa = 0
                    listagem.imprimeLinha('')
        else:
            for tit in browse_titulos_baixa:
                data_emissao = tit.data_emissao or ''
                if data_emissao:
                    data_emissao = time.strftime('%d/%m/%Y', time.strptime(data_emissao, '%Y-%m-%d'))
                linha = formataString(tit.codigo, 7, ' ', 'E', 'N', 'S')
                linha += ' '
                linha += formataString(tit.pessoa_id.partner_id.name, 45, ' ', 'D', 'N', 'S')
                linha += ' '
                linha += formataString(tit.doc_tipo_id.name, 15, ' ', 'D', 'S', 'S')
                linha += ' '
                linha += formataString(data_emissao, 10, ' ', 'D', 'S', 'S')
                linha += ' '
                linha += formataString(tit.documento, 17, ' ', 'E', 'S', 'S')
                linha += ' '
                linha += formataString(tit.parcela, 3, ' ', 'C', 'N', 'S')
                linha += ' '
                linha += formataString(time.strftime("%d/%m/%Y", time.strptime(tit.data_prorrogacao, "%Y-%m-%d")), 10, ' ',
                                       'E', 'N', 'S')
                linha += ' '
                linha += formataString(time.strftime("%d/%m/%Y", time.strptime(tit.data_pgto, "%Y-%m-%d")), 10, ' ', 'E',
                                       'N', 'S')
                linha += ' '
                linha += formataString(getNumeroEditado(tit.vr_original), 12, ' ', 'E', 'S', 'S')
                linha += ' '
                linha += formataString('P' if tit.vr_original > tit.valor_pago else 'T', 3, ' ', 'C', 'S', 'S')
                linha += ' '
                linha += formataString(getNumeroEditado(tit.valor_juros), 8, ' ', 'E', 'S', 'S')
                linha += ' '
                linha += formataString(getNumeroEditado(tit.valor_multa), 8, ' ', 'E', 'S', 'S')
                linha += ' '
                linha += formataString(getNumeroEditado(tit.valor_desconto), 8, ' ', 'E', 'S', 'S')
                linha += ' '
                linha += formataString(getNumeroEditado(tit.valor_acrescimo), 9, ' ', 'E', 'S', 'S')
                linha += ' '
                linha += formataString(getNumeroEditado(tit.valor_pago), 14, ' ', 'E', 'S', 'S')
                valor_pago += tit.valor_pago
                valor_juros += tit.valor_juros
                valor_multa += tit.valor_multa
                valor_desconto += tit.valor_desconto
                valor_acrescimo += tit.valor_acrescimo
                listagem.imprimeLinha(linha)
        if ordem == 'P':
            listagem.imprimeLinha('')
            listagem.imprimeLinha(_('TOTAL') + ' ' * 136 +
                formataString(str(getNumeroEditado(valor_juros)), 9, ' ', 'E', 'S', 'S') + ' ' +
                formataString(str(getNumeroEditado(valor_multa)), 8, ' ', 'E', 'S', 'S') + ' ' +
                formataString(str(getNumeroEditado(valor_desconto)), 8, ' ', 'E', 'S', 'S') + ' ' +
                formataString(str(getNumeroEditado(valor_acrescimo)), 9, ' ', 'E', 'S', 'S') + ' ' +
                formataString(str(getNumeroEditado(valor_pago)), 14, ' ', 'E', 'S', 'S') + ' ')
        else:
            listagem.imprimeLinha(
                ' ' * 141 +
                _(' ________') +
                _(' ________') +
                _(' ________') +
                _(' _________') +
                _(' ______________'))
            listagem.imprimeLinha(
                ' ' * 141 +
                formataString(str(getNumeroEditado(valor_juros)), 9, ' ', 'E', 'S', 'S') + ' ' +
                formataString(str(getNumeroEditado(valor_multa)), 8, ' ', 'E', 'S', 'S') + ' ' +
                formataString(str(getNumeroEditado(valor_desconto)), 8, ' ', 'E', 'S', 'S') + ' ' +
                formataString(str(getNumeroEditado(valor_acrescimo)), 9, ' ', 'E', 'S', 'S') + ' ' +
                formataString(str(getNumeroEditado(valor_pago)), 14, ' ', 'E', 'S', 'S') + ' ')
        listagem.imprimeLinha('--')
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_file.getvalue())
        self.obj.render()
        pdf_file.close()
        return (self.obj.pdf, 'pdf')


report_titulos_liquidados('report.titulos.liquidados')


class titulos_liquidados_osv(osv.TransientModel):
    _name = 'titulos.liquidados.osv'
    _description = 'Titulos Liquidados'

    def _default_get(self, cr, uid, data, context=None):
        context = context and context.copy() or {}
        if data['tipo'] == 'R':
            return 'R'
        if data['tipo'] == 'P':
            return 'P'

    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', required=True, select=True),
        'tipo_titulo': fields.selection([('R', 'Receber'), ('P', 'Pagar')], 'Tipo titulo', required=True),
        'natureza_cobranca_id': fields.many2one("financeiro.natureza.cobranca", 'Natureza cobranca', select=True),
        'local_cobranca_id': fields.many2one("financeiro.local.cobranca", 'Local cobranca', select=True,
                                             domanin="[('company_id', '=', company_id)]"),
        'doc_tipo_ids': fields.many2many('documento.documento.tipo', 'titulo_liquidado_documento_tipo',
                                         'titulo_liquidado_id', 'documento_tipo_id',
                                         'Tipo de documento'),
        'data_ini': fields.date('Data Inicio'),
        'data_fim': fields.date('Data Fim'),
        'pessoa_id': fields.many2one("adm.pessoa", 'Pessoa', ondelete="restrict", select=True),
        'ordem_a_listar': fields.selection([('P', 'Pessoa')], string='Ordem', size=1),
        'condicao_tipo': fields.selection([('V', 'A vista'), ('P', 'A prazo'), ('T', 'Todos')],
                                          'Condicao tipo', size=1),
        'categoria_id': fields.many2one('adm.pessoa.categoria.nome', 'Categoria'),
        'pagamento_id': fields.many2one('adm.forma.pgto', 'Forma de Pagamento'),
        'titulo_renegociado': fields.boolean('Incluir titulos renegociados'),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(cr, uid, uid).company_id.id,
        'tipo_titulo': _default_get,
        'condicao_tipo': lambda *a: 'T',
        'titulo_renegociado': lambda *a: False,
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        titulos_liquidados_osv_dados = self.read(cr, uid, ids, [], context=context)
        obj_tit_baixa = pooler.get_pool(cr.dbname).get('financeiro.titulo.baixa.view')
        obj_adm_pessoa_categoria_nome = self.pool.get('adm.pessoa.categoria.nome')
        for x in titulos_liquidados_osv_dados:
            company_id = x.get('company_id')
            if isinstance(company_id, tuple):
                company_id = company_id[0]
                company = company_id
            if not isinstance(company_id, list):
                company_id = [company_id]
            res_company_dados = self.pool.get("res.company").read(cr, uid, company_id, ['name'], context=context)
            for i in res_company_dados:
                nome_empresa = i.get('name')
            natureza_cobranca_id = x.get("natureza_cobranca_id")
            if isinstance(natureza_cobranca_id, tuple):
                natureza_cobranca_id = natureza_cobranca_id[0]
            doc_tipo_ids = x.get("doc_tipo_ids")
            local_cobranca_id = x.get("local_cobranca_id")
            if isinstance(local_cobranca_id, tuple):
                local_cobranca_id = local_cobranca_id[0]
            pessoa_id = x.get('pessoa_id')
            if isinstance(pessoa_id, tuple):
                pessoa_id = pessoa_id[0]
                pessoa = pessoa_id
            else:
                pessoa = pessoa_id
            condicao_tipo = x.get('condicao_tipo')
            categoria_id = x.get('categoria_id')
            if isinstance(categoria_id, tuple):
                categoria_id = categoria_id[0]

            # -------------------------------------------------
            obj_emp = pooler.get_pool(cr.dbname).get('res.company')
            emp_filhas = obj_emp.search(cr, uid, [('parent_id', '=', company)], context=context)
            emp_filhas.append(company)
            argumentos = [('company_id', 'in', list(set(emp_filhas))),
                          ('tipo_titulo', '=', x.get('tipo_titulo')),
                          ('state', '!=', 'C')]
            lista_arg = _('Criterios de Pesquisa: ')
            if local_cobranca_id:
                argumentos.append(('local_cobranca_id', '=', local_cobranca_id))
                loc = pooler.get_pool(cr.dbname).get('financeiro.local.cobranca').read(
                    cr, uid, local_cobranca_id, ['name'], context=context)['name']
                lista_arg += _('|Local Cobranca: ') + _(loc) + ' '

            if natureza_cobranca_id:
                argumentos.append(('natureza_cobranca_id', '=', natureza_cobranca_id))
                nat = pooler.get_pool(cr.dbname).get('financeiro.natureza.cobranca').read(
                    cr, uid, natureza_cobranca_id, ['name'], context=context)['name']
                lista_arg += _('|Natureza Cobranca: ') + _(nat) + ' '

            if doc_tipo_ids:
                argumentos.append(('doc_tipo_id', 'in', doc_tipo_ids))
                doc = ''
                for doc_tipo_id in doc_tipo_ids:
                    doc += '%s | ' % pooler.get_pool(cr.dbname).get(
                        'documento.documento.tipo').read(cr, uid, doc_tipo_id, ['name'],
                                                         context=context)['name']
                lista_arg += _('|Tipo Documento: ') + _(doc[:-2]) + ' '

            if x.get('data_ini') and x.get('data_fim'):
                argumentos.append(('data_pgto', '>=', x.get('data_ini')))
                argumentos.append(('data_pgto', '<=', x.get('data_fim')))
                lista_arg += _('|Periodo: ') + time.strftime("%d/%m/%Y", time.strptime(x.get(
                    'data_ini'), "%Y-%m-%d")) + _(' a ') + time.strftime(
                    "%d/%m/%Y", time.strptime(x.get('data_fim'), "%Y-%m-%d")) + ' '

            if pessoa and not categoria_id:
                argumentos.append(('pessoa_id', '=', pessoa))
                pes = pooler.get_pool(cr.dbname).get('adm.pessoa').browse(
                    cr, uid, pessoa, context).name
                lista_arg += '|Pessoa: ' + _(pes) + ' '

            if categoria_id:
                sql = """
                    SELECT  pessoa_id
                    FROM    pessoa_categoria
                    WHERE   categoria_id = %s
                """ % categoria_id
                if pessoa:
                    sql += """
                            AND pessoa_id = %s
                    """ % pessoa

                cr.execute(sql)
                argumentos.append(('pessoa_id', 'in', map(lambda p: p.get('pessoa_id'),
                                                          cr.dictfetchall())))
                lista_arg += '|Categoria: %s ' % obj_adm_pessoa_categoria_nome.browse(
                    cr, uid, categoria_id, context).name or ''
            if not local_cobranca_id and not natureza_cobranca_id and not doc_tipo_ids and (
                    not x.get('data_ini') and not x.get('data_fim') and not pessoa):
                lista_arg = ' '
            argumentos.append(('id', '!=', None))
            order = None
            if x.get('ordem_a_listar') == 'P':
                order = 'pessoa_id'

            ids_tit_baixa = obj_tit_baixa.search(cr, uid, argumentos, order=order, context=context)
            if not ids_tit_baixa:
                raise osv.except_osv(_('Atencao'),
                                     _('Nenhum valor encontrado.'))
            # -------------------------------------------------

            pagamento_id = False
            nome_pagamento = False
            if x.get('pagamento_id'):
                pagamento_id = x.get('pagamento_id')[0]
                nome_pagamento = x.get('pagamento_id')[1]
                sql = """
            SELECT ftb.id
            FROM financeiro_titulo_baixa AS ftb
            INNER JOIN financeiro_tesouraria_baixa_forma_pgto AS ftbfp ON ftbfp.tesouraria_baixa_id = ftb.id
            WHERE ftb.id IN (%s)
              AND ftbfp.forma_pgto_id = %s""" % \
                      (','.join(map(lambda x: '%s' % x, ids_tit_baixa)), pagamento_id)
                cr.execute(sql)
                dados = map(lambda x: x.get('id'), cr.dictfetchall())
                if not dados:
                    raise osv.except_osv(_('Atencao'),
                                         _('Nenhum valor encontrado.'))

                ids_tit_baixa = dados

            datas = {
                'nome_empresa': nome_empresa,
                'tipo_titulo': x.get('tipo_titulo'),
                'ordem_a_listar': x.get('ordem_a_listar') or None,
                'condicao_tipo': condicao_tipo,
                'titulo_baixa_ids': ids_tit_baixa,
                'lista_argumentos': lista_arg,
                'nome_pagamento': nome_pagamento,
                'titulo_renegociado': x.get('titulo_renegociado'),
            }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'titulos.liquidados',
            'datas': datas,
        }
