# -*- coding: utf-8 -*-

from openerp.osv import osv, fields
from time import strftime
from dateutil.parser import parse
from openerp.report import report_sxw
from datetime import datetime, date, timedelta
from openerp.tools.translate import _
import base64
from dateutil.relativedelta import relativedelta
READ_LOAD = '_classic_write'
from random import randint
from SigUtils.formatastring import formataString
from SigUtils.numero import getNumeroEditado
from datetime import datetime, timedelta
import subprocess


class wizard_baixa_multipla(osv.TransientModel):

    def wbt_get_total_receber_pagar(self, cr, uid, ids, name, args, context=None):
        context = context and context.copy() or {}
        FIELD_TOTAL_PAGAR = 'wbt_titulo_pagar_total'
        FIELD_TOTAL_RECEBER = 'wbt_titulo_receber_total'
        FIELD_TOTAL_LIQUIDO_PAGAR = 'wbt_total_liquido_pagar'
        FIELD_TOTAL_LIQUIDO_RECEBER = 'wbt_total_liquido_receber'

        if isinstance(ids, (int, long)):
            ids = [ids]

        res = {}.fromkeys(ids, {}.fromkeys(
            [FIELD_TOTAL_LIQUIDO_RECEBER, FIELD_TOTAL_PAGAR, FIELD_TOTAL_RECEBER, FIELD_TOTAL_LIQUIDO_PAGAR], 0)
        )

        browse_baixa_titulo = self.browse(cr, uid, ids, context)
        desconto = 0
        for i in browse_baixa_titulo:
            id = i.id
            desconto = i.wbt_valor_desconto or 0
            record_titulo_ids = i.wbt_titulo_detalhe_ids or []
            record_titulos_selecionados = filter(lambda ts: ts.wbtd_flag_selecionado is True,
                                                 record_titulo_ids)
            for ti in record_titulos_selecionados:
                titulo_tipo = ti.wbtd_titulo_tipo
                titulo_valor_total = ti.wbtd_valor_total or 0
                if titulo_tipo == 'R':
                    res[id][FIELD_TOTAL_RECEBER] += titulo_valor_total
                else:
                    res[id][FIELD_TOTAL_PAGAR] += titulo_valor_total
        for i in res:
            total_receber = res[i][FIELD_TOTAL_RECEBER]
            total_pagar = res[i][FIELD_TOTAL_PAGAR]

            res[i][FIELD_TOTAL_LIQUIDO_RECEBER] = total_receber - total_pagar - desconto
            res[i][FIELD_TOTAL_LIQUIDO_PAGAR] = total_pagar - total_receber - desconto

        return res

    def wbt_get_forma_pagamento_dinheiro(self, cr, uid, context=None):
        context = context and context.copy() or {}
        forma_pagamento_id = self.pool.get('adm.forma.pgto').search(
            cr, uid, [('name', 'ilike', 'dinheiro')] , context=context
        )
        if forma_pagamento_id:
            return forma_pagamento_id[0]
        else:
            return False

    def wbt_get_conta_tipo_caixa(self, cr, uid, context=None):
        context = context and context.copy() or {}
        conta_id = self.pool.get('financeiro.tesouraria.contas').search(
            cr, uid, [('banco_caixa','=','C')], limit=1, context=context)
        if conta_id:
            return conta_id[0]

        raise osv.except_osv(_('Atenção!'),_('Sem conta na tesouraria com "Banco/Caixa" '
                                                 'igual a "Caixa" cadastrada!'))


    _name = 'wizard.baixa.titulo'
    _rec_name = 'wbt_cliente_id'
    _columns = {
        # _________________integer________________________________
        'id': fields.integer('ID', readonly=True),
        # _________________selection______________________________
        'state': fields.selection(
            [('TL', 'Titulo Listado'), ('VA', 'Valores Atualizados'), ('BA', 'Titulo Baixado')], 'Status', size=2
        ),
        'wbt_titulo_tipo': fields.selection([('P', 'Pagar'), ('R', 'Receber')], 'Tipo Titulo', size=1),
        'wbt_order': fields.selection([('id', _('Titulo/Parcela')),
                                       ('pessoa_id', 'Cliente/Fornecedor'),
                                       ('data_emissao', _('Data de emissao')),
                                       ('data_prorrogacao', _('Data de prorrogacao'))],
                                      'Ordenar por', size=16),
        'wbt_order_type': fields.selection([('asc', 'Crescente'), ('desc', 'Decrescente')],
                                           _('Tipo ordenacao'), size=4),
        # _________________boolean______________________________
        'wbt_pagamento_em_cheque': fields.boolean('Pagamento Cheque'),
        'wbt_listar_cheque': fields.boolean('Lista cheques'),
        'wbt_baixa_refinanciamento': fields.boolean('Refinanciamento', invisible=True),

        # _________________char______________________________
        'wbt_tipo_conta': fields.char('Tipo conta'),
        'wbt_file_name': fields.char('Arquivo', size=10),
        'wbt_documento': fields.char('Documento', size=30),

        # _________________date______________________________
        'wbt_data_emissao_ini': fields.date('Emissao Inicial'),
        'wbt_data_emissao_fim': fields.date('Emissao Final'),
        'wbt_data_prorrogacao_ini': fields.date('Vencimento Inicial'),
        'wbt_data_prorrogacao_fim': fields.date('Vencimento Final'),
        'wbt_data_pagamento': fields.date('Data Pagamento', required=True),

        # _________________function__________________________
        'wbt_titulo_receber_total': fields.function(wbt_get_total_receber_pagar, method=True, string="Titulos a Receber",
                                                    multi="funct_total_tipo", type="float", store=True),
        'wbt_titulo_pagar_total': fields.function(wbt_get_total_receber_pagar, method=True, string="Titulos a Pagar",
                                                  multi="funct_total_tipo", type="float", store=True),
        # NÃO UTILIZAR ESTE CAMPO.
        # SERVE SOMENTE PARA SER MOSTRADO NA TELA QUANDO EXISTE VALOR A RECEBER, É APENAS UM INFORMATIVO
        'wbt_total_liquido_receber': fields.function(wbt_get_total_receber_pagar, method=True, string="Liquido a Receber",
                                                     multi="funct_total_tipo", type="float", store=True),
        # NÃO UTILIZAR ESTE CAMPO.
        # SERVE SOMENTE PARA SER MOSTRADO NA TELA QUANDO EXISTE VALOR A PAGAR, É APENAS UM INFORMATIVO
        'wbt_total_liquido_pagar': fields.function(wbt_get_total_receber_pagar, method=True, string="Liquido a Pagar",
                                                   multi="funct_total_tipo", type="float", store=True),
        # _________________float______________________________
        'wbt_valor_pago': fields.float('Valor a Receber/Pagar', digits=(15, 2), required=True,
                                       help="Ao mudar o valor, clicar no botao (Atualizar Valores)"),
        'wbt_valor_saldo_restante': fields.float('Valor Total', digitis=(15, 2), readonly=True),
        'wbt_valor_desconto': fields.float('Desconto', digitis=(15, 2)),
        'wbt_total_condicao_pagamento': fields.float('Total pagamento', digitis=(15, 2)),

        # _________________many2one______________________________
        'wbt_conta_id': fields.many2one('financeiro.tesouraria.contas', 'Conta', required=True),
        'wbt_cliente_id': fields.many2one('adm.pessoa', 'Cliente/Fornecedor', required=False),
        'wbt_forma_pgto_id': fields.many2one('adm.forma.pgto', 'Forma Pagto.', required=True),
        'wbt_local_cobranca_id': fields.many2one('financeiro.local.cobranca', 'Local cobranca'),
        # TITULOS COM DOCUMENTO IGUAL A PREVISAO FINANCEIRA NAO PODEM SER BAIXADOS.
        'wbt_documento_tipo_ids': fields.many2many(
            'documento.documento.tipo', 'baixa_titulo_m2m_documento_tipo', 'baixa_titulo_id',
            'documento_tipo_id', 'Tipo de documento', domain="[('sigla','!=','PRV')]"),

        # _________________one2many______________________________
        'wbt_titulo_detalhe_ids': fields.one2many('wizard.baixa.titulo.detalhe', 'wbtd_baixa_id',
                                                  'Titulos'),
        'wbt_pagamento_ids': fields.one2many('wizard.baixa.titulo.pagamento', 'wizbtp_baixa_id',
                                             'Pagamentos'),

        # O campo abaixo server para exibir o recibo da baixa em arquivo do tipo pdf para usuario
        'dados': fields.binary('Clique para baixar o arquivo', readonly=True),
    }

    _defaults = {
        'wbt_data_pagamento': lambda s, cr, uid, c:
        s.pool.get('adm.utils').admutl_datetime_to_timezone(
            cr, uid, parse(strftime('%Y-%m-%d %H:%M:%S')), '%Y-%m-%d'),
        'wbt_pagamento_em_cheque': False,
        'wbt_listar_cheque': False,
        'wbt_forma_pgto_id': wbt_get_forma_pagamento_dinheiro,
        'wbt_conta_id': wbt_get_conta_tipo_caixa,
        'wbt_tipo_conta': 'B,C,E',
        'wbt_file_name': 'Recibo.pdf',
    }

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if 'wbt_valor_pago' not in vals:
            vals['wbt_valor_pago'] = 0
        res = super(wizard_baixa_multipla, self).create(cr, uid, vals, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('wbt_valor_desconto'):
            valor_pago = vals.get('wbt_valor_pago') or 0
            if not valor_pago:
                valor_pago = self.read(
                    cr, uid, ids[0] if isinstance(ids, list) else ids, ['wbt_valor_pago'],
                    context=context).get('wbt_valor_pago') or 0
            vals['wbt_valor_pago'] = valor_pago - (vals.get('wbt_valor_desconto') or 0)
        res = super(wizard_baixa_multipla, self).write(cr, uid, ids, vals, context)
        return res

    def wbt_onchange_pessoa_id(self, cr, uid, ids, pessoa_id, context=None):
        """
        Metodo chamado apos informar o 'cliente/fornecedor'. Identifica se essa pessoa esta inativa,
        informacoes complementares do cliente, e caso esteja, e exibido uma mensagem com essa
        informacao.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela dessa classe.
        :type ids: list
        :param pessoa_id: id da tabela adm_pessoa, identificador da pessoa.
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: caso pessoa_id esteja inativo, dicionario com dados para exibicao da mensagem,
        senao, dicionario vazio.
        :rtype: dict
        """
        context = context and context.copy() or {}
        res = dict()
        if not pessoa_id:
            return res

        mensagem = str()
        pessoa_ids = self.pool.get('adm.pessoa').search(cr, uid, [('id', '=', pessoa_id)],
                                                        context=context)
        if not pessoa_ids:
            mensagem += _('Esse cliente/fornecedor encontra-se inativo.\n')

        cliente_ids = self.pool.get('financeiro').finutl_get_cliente_ids(cr, uid, pessoa_id,
                                                                         context)
        brw_financeiro_cliente = self.pool.get('financeiro.cliente').browse(cr, uid, cliente_ids,
                                                                            context)
        brw_financeiro_cliente = filter(lambda c: c.observacoes, brw_financeiro_cliente)
        if brw_financeiro_cliente:
            mensagem += _('Informacoes complementares:\n')
        for cliente in brw_financeiro_cliente:
            mensagem += cliente.observacoes + '\n'

        if mensagem:
            res['warning'] = {'title': _('Atencao'), 'message': mensagem}
        return res

    def wbt_onchange_forma_pgto_id(self, cr, uid, ids, pagamento_ids, tipo_titulo,
                                   context=None):
        """
        Funcao verifica:
        * Se a sigla do pagamento e cheque.
        True - Caso seja, mostra na tela os campos para informar os dados do cheque.
        False - Mantem os campos ocultados.
        """
        res = {}
        context = context and context.copy() or {}
        cheque = refinanciamento = False
        if pagamento_ids:
            total_pagamentos = sum(map(lambda i: i.get('wizbtp_valor'), self.resolve_2many_commands(
                cr, uid, 'wbt_pagamento_ids', pagamento_ids, context=context)))
            if ids:
                self.write(cr, uid, ids, {'wbt_total_condicao_pagamento': total_pagamentos},
                           context)
        for pagamento in pagamento_ids:
            for item_pagamento in pagamento:
                if isinstance(item_pagamento, dict):
                    cheque = self.pool.get('adm.utils').admutl_forma_pgto_tipo_cheque(
                        cr, uid, item_pagamento.get('wizbtp_forma_pgto_id'), context) == 'cheque'

                    if (item_pagamento.get('wizbtp_condicao_pgto_tipo') != 'V' or
                        item_pagamento.get('wizbtp_forma_pgto_tipo') == 'cheque'):
                        refinanciamento = True

        res['wbt_tipo_conta'] = 'B,C,E'

        res['wbt_baixa_refinanciamento'] = refinanciamento

        if cheque and tipo_titulo == 'P':
            res['wbt_tipo_conta'] = 'B,E'
            res['wbt_conta_id'] = False
        return {'value': res}

    def wbt_onchange_valor_pago(self, cr, uid, ids, valor_pago, context=None):
        context = context and context.copy() or {}
        res = {}
        if valor_pago:
            res['value'] = {'wbt_valor_desconto': 0.00}
        return res

    def wbt_onchange_valor_desconto(self, cr, uid, ids, valor_desconto, total_liquido_receber,
                                    total_liquido_pagar, context=None):
        context = context and context.copy() or {}
        res = {}
        brw_wizard_baixa_titulo = self.browse(cr, uid, ids[0], context)
        original_wbt_total_liquido_receber = brw_wizard_baixa_titulo.wbt_total_liquido_receber
        original_wbt_total_liquido_pagar = brw_wizard_baixa_titulo.wbt_total_liquido_pagar
        if valor_desconto > 0 and (total_liquido_pagar or total_liquido_receber):
            if total_liquido_receber > 0:
                if valor_desconto <= total_liquido_receber:
                    res['value'] = {'wbt_total_liquido_receber': original_wbt_total_liquido_receber -
                                    valor_desconto}
                else:
                    res['value'] = {'wbt_total_liquido_receber': original_wbt_total_liquido_receber}
            elif total_liquido_pagar > 0:
                if valor_desconto <= total_liquido_pagar:
                    res['value'] = {'wbt_total_liquido_pagar': original_wbt_total_liquido_pagar -
                                    valor_desconto}
                else:
                    res['value'] = {'wbt_total_liquido_pagar': original_wbt_total_liquido_pagar}
        if valor_desconto <= 0:
            if total_liquido_receber > 0:
                res['value'] = {
                    'wbt_total_liquido_receber': original_wbt_total_liquido_receber}
            elif total_liquido_pagar > 0:
                res['value'] = {
                    'wbt_total_liquido_pagar': original_wbt_total_liquido_pagar}
        return res

    def wbt_button_selecao(self, cr, uid, ids, booleano, context=None):
        """
        Funcao altera: campo - wbtd_flag_selecionado, na tabela - tabela wizard.baixa.titulo.detalhe
        * Indica se o titulo esta selecionado ou nao
        """
        context = context and context.copy() or {}
        if isinstance(ids, list):
            baixa_titulo_id = ids[0]
        else:
            baixa_titulo_id = ids
        obj_baixa_titulo_detalhe = self.pool.get('wizard.baixa.titulo.detalhe')
        titulo_detalhe_ids = obj_baixa_titulo_detalhe.search(
            cr, uid, [('wbtd_baixa_id', '=', baixa_titulo_id)], context=context
        )
        if titulo_detalhe_ids:
            obj_baixa_titulo_detalhe.write(
                cr, uid, titulo_detalhe_ids, {'wbtd_flag_selecionado': booleano}, context=context
            )
        return True

    def wbt_button_marcar_todos(self, cr, uid, ids, context=None):
        """
        Marca todos os titulos listados no grid.
        """
        context = context and context.copy() or {}
        res = self.wbt_button_selecao(cr, uid, ids, booleano=True, context=context)
        self.write(cr, uid, ids, {}, context)
        return res

    def wbt_button_desmarcar_todos(self, cr, uid, ids, context=None):
        """
        Desmarca todos os titulos listados no grid.
        """
        context = context and context.copy() or {}
        res = self.wbt_button_selecao(cr, uid, ids, booleano=False, context=context)
        self.write(cr, uid, ids, {}, context)
        return res

    def wbt_raise_msg_titulos(self, cr, uid, titulo_ids, message, context=None):
        context = context and context.copy() or {}
        message = unicode(message)
        res_name_get = self.pool.get('financeiro.titulo').name_get(cr, uid, titulo_ids, context)
        if res_name_get:
            msg_titulos = u''
            dict_titulo_name = dict(res_name_get)
            for i in titulo_ids:
                msg_titulos += u'%s, ' % dict_titulo_name.get(i) or ''
            if msg_titulos:
                raise osv.except_osv(_('Atencao'), u'%s: %s' % (message, msg_titulos))
        return True

    def wbt_get_titulo_selecionados_saldo(self, cr, uid, titulo_selecionado_ids, context=None):
        """
        Funcao soma:
        * Valor total de todos os titulos indicados.
        """
        context = context and context.copy() or {}
        if titulo_selecionado_ids:

            wiz_baixa_detalhe_dados = self.pool.get('wizard.baixa.titulo.detalhe').read(
                cr, uid, titulo_selecionado_ids, ['wbtd_valor_total'], context=context
            )

            somatorio_titulos = sum(map(lambda i: i.get('wbtd_valor_total') or 0, wiz_baixa_detalhe_dados))
        else:
            somatorio_titulos = 0
        return somatorio_titulos

    def wbt_validar_valor_pago_titulos(self, cr, uid, valor_pago, titulo_selecionado_ids, context=None):
        """
        Funcao verifica:
        * Se valor pago e menor ou igual a zero
        * Se foi selecionado mais do que um titulo, o valor pago deve ser igual ao somatorio desses titulos
        * Se o valor pago e maior que o valor dos titulos
        """
        context = context and context.copy() or {}
        convert_2_decimal = self.pool.get('financeiro').financ_convert_to_decimal

        total_titulos_selecionados = len(titulo_selecionado_ids or [])
        somatorio_titulos = self.wbt_get_titulo_selecionados_saldo(
            cr, uid, titulo_selecionado_ids=titulo_selecionado_ids, context=context
        )

        deci_somatorio_titulos = convert_2_decimal(somatorio_titulos)
        deci_valor_pago = convert_2_decimal(valor_pago)

        if total_titulos_selecionados == 1:
            if not deci_valor_pago > 0:
                raise osv.except_osv(_('Atencao!'), _('Informe um valor pago maior que zero.'))

            if deci_valor_pago > deci_somatorio_titulos:
                raise osv.except_osv(
                    _('Atencao!'),
                    _('O valor pago de R$ %(deci_valor_pago).2f, e maior que o valor do titulo: R$ '
                      '%(deci_somatorio_titulos).2f. Informe um valor menor ou igual a soma dos '
                      'valores dos titulos.') % locals()
                )

        return True

    def calcula_dias_atraso(self, cr, uid, ids, data_prorrogacao, context=None):
        context = context and context.copy() or {}
        dados_baixa = self.read(cr, uid, ids, ['state', 'wbt_data_pagamento'], context=context)[0]

        data_baixa = parse(dados_baixa.get('wbt_data_pagamento'), yearfirst=True).date()
        data_prorrogacao =  parse(data_prorrogacao, yearfirst=True).date()
        dias_atraso = (data_baixa - data_prorrogacao).days
        if (data_prorrogacao.weekday() in [5, 6] and
                (data_baixa.weekday() == 0 and dias_atraso in [1, 2])) or dias_atraso < 0:
            dias_atraso = 0

        return dias_atraso

    def wbt_button_listar_titulos(self, cr, uid, ids, context=None):
        """
        Funcao cria:
        * Lista todos os titulos em aberto para o cliente selecianado.
        """
        context = context and context.copy() or {}
        if isinstance(ids, list):
            baixa_titulo_id = ids[0]
        else:
            baixa_titulo_id = ids

        cr.execute("""DELETE FROM wizard_baixa_titulo_pagamento WHERE wizbtp_baixa_id = %s""" %
                   baixa_titulo_id)

        args_financeiro = []
        fields_to_read = [
            'wbt_titulo_tipo', 'wbt_cliente_id', 'wbt_data_pagamento', 'wbt_data_prorrogacao_ini',
            'wbt_data_prorrogacao_fim', 'wbt_data_emissao_ini', 'wbt_data_emissao_fim',
            'wbt_valor_pago', 'wbt_local_cobranca_id', 'wbt_documento_tipo_ids', 'wbt_listar_cheque',
            'wbt_documento', 'wbt_order', 'wbt_order_type'
        ]
        baixa_titulo_dados = self.read(cr, uid, baixa_titulo_id, fields_to_read, context=context, load=READ_LOAD)
        if baixa_titulo_dados and isinstance(baixa_titulo_dados, list):
            baixa_titulo_dados = baixa_titulo_dados[0]
        if isinstance(baixa_titulo_dados, dict):
            baixa_data_pagamento = baixa_titulo_dados.get('wbt_data_pagamento') or ''
            baixa_filtro_cliente_id = baixa_titulo_dados.get('wbt_cliente_id') or False
            baixa_filtro_titulo_tipo = baixa_titulo_dados.get('wbt_titulo_tipo')
            baixa_filtro_data_emissao_ini = baixa_titulo_dados.get('wbt_data_emissao_ini') or ''
            baixa_filtro_data_emissao_fim = baixa_titulo_dados.get('wbt_data_emissao_fim') or ''
            baixa_filtro_data_prorrogacao_ini = baixa_titulo_dados.get('wbt_data_prorrogacao_ini') or ''
            baixa_filtro_data_prorrogacao_fim = baixa_titulo_dados.get('wbt_data_prorrogacao_fim') or ''
            baixa_filtro_local_cobranca_id = baixa_titulo_dados.get('wbt_local_cobranca_id') \
                or False
            baixa_filtro_documento_tipo_ids = baixa_titulo_dados.get('wbt_documento_tipo_ids') \
                or False
            baixa_filtro_lista_cheque = baixa_titulo_dados.get('wbt_listar_cheque')
            baixa_filtro_documento = baixa_titulo_dados.get('wbt_documento')

            # CONVERTE A DATA DE PAGAMENTO PARA OBJETO DO TIPO DATE (VERIFICA SE É UMA DATA VÁLIDA)
            date_baixa_pagamento = self.pool.get('financeiro').financ_convert_str_date(
                str_data=baixa_data_pagamento, str_data_name='pagamento', context=context
            )

            obj_financeiro = self.pool.get('financeiro.titulo')

            # PROCURA POR TODOS OS TITULOS QUE ESTAO EM ABERTO PARA O CLIENTE INDICADO
            args_financeiro.append(('state', '=', 'A'))  # A - Aberto.
            if not baixa_filtro_lista_cheque:
                args_financeiro.append(('fintit_cheque', '=', False))
            if baixa_filtro_cliente_id:
                args_financeiro.append(('pessoa_id', '=', baixa_filtro_cliente_id))
            if baixa_filtro_data_emissao_ini:
                args_financeiro.append(('data_emissao', '>=', baixa_filtro_data_emissao_ini))
            if baixa_filtro_data_emissao_fim:
                args_financeiro.append(('data_emissao', '<=', baixa_filtro_data_emissao_fim))
            if baixa_filtro_data_prorrogacao_ini:
                args_financeiro.append(('data_prorrogacao', '>=', baixa_filtro_data_prorrogacao_ini))
            if baixa_filtro_data_prorrogacao_fim:
                args_financeiro.append(('data_prorrogacao', '<=', baixa_filtro_data_prorrogacao_fim))
            if baixa_filtro_titulo_tipo:
                args_financeiro.append(('tipo_titulo', '=', baixa_filtro_titulo_tipo))
            if baixa_filtro_local_cobranca_id:
                args_financeiro.append(('local_cobranca_id', '=', baixa_filtro_local_cobranca_id))
            if baixa_filtro_documento:
                args_financeiro.append(('documento', '=', baixa_filtro_documento))
            if baixa_filtro_documento_tipo_ids:
                args_financeiro.append(('doc_tipo_id', 'in', baixa_filtro_documento_tipo_ids))
            else:
                # TITULOS COM DOCUMENTO IGUAL A PREVISAO FINANCEIRA NAO PODEM SER BAIXADOS.
                doc_previsao_financ_ids = self.pool.get('documento.documento.tipo').search(
                    cr, uid, [('sigla', '=', 'PRV')], context=context)
                if doc_previsao_financ_ids:
                    args_financeiro.append(('doc_tipo_id', '!=', doc_previsao_financ_ids[0]))

            ordem = None
            if baixa_titulo_dados.get('wbt_order'):
                ordem = baixa_titulo_dados.get('wbt_order')
            if baixa_titulo_dados.get('wbt_order') and baixa_titulo_dados.get('wbt_order_type'):
                ordem = '%s %s' % (baixa_titulo_dados.get('wbt_order'),
                                   baixa_titulo_dados.get('wbt_order_type'))

            financeiro_ids = obj_financeiro.search(cr, uid, args_financeiro, order=ordem,
                                                   context=context)
            if not financeiro_ids:
                msg = _('Nenhum titulo encontrado!')
                raise osv.except_osv(_('Atencao'), msg)
            else:
                # PARA CADA TITULO ENCONTRADO SERÁ CRIADO UM REGISTRO NO WIZARD (DETALHE)
                browse_titulo = obj_financeiro.browse(cr, uid, financeiro_ids)

                # EXCLUI DA TREEVIEW OS TITULOS JA LISTADOS.
                obj_baixa_titulo_detalhe = self.pool.get('wizard.baixa.titulo.detalhe')
                baixa_titulo_detalhe_ids = obj_baixa_titulo_detalhe.search(
                    cr, uid, [('wbtd_baixa_id', '=', baixa_titulo_id)], context=context
                )
                if baixa_titulo_detalhe_ids:
                    obj_baixa_titulo_detalhe.unlink(cr, uid, baixa_titulo_detalhe_ids, context)

                financeiro_parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(
                    cr, uid, 'financeiro', ['prazo_perdao'])
                prazo_perdao = financeiro_parametro_dados.get('prazo_perdao') or 0.0

                for i in browse_titulo:
                    titulo_id = i.id
                    titulo_pessoa_id = i.pessoa_id and i.pessoa_id.id or False
                    titulo_tipo = i.tipo_titulo
                    titulo_saldo = i.saldo or 0
                    titulo_multa = i.vr_multa or 0
                    titulo_desconto = i.vr_desconto or 0
                    titulo_acrescimo = i.fintit_vr_acrescimo or 0
                    titulo_data_emissao = i.data_emissao
                    titulo_juros_por_dia = i.vr_juros_dia or 0
                    titulo_valor_original = i.vr_original or 1
                    titulo_multa_apos_data = i.multa_apos_data
                    titulo_data_prorrogacao = i.data_prorrogacao
                    titulo_data_limite_desconto = i.data_limite_desconto
                    percentual = titulo_saldo / titulo_valor_original * 100
                    dias_atraso = self.calcula_dias_atraso(cr, uid, ids, i.data_prorrogacao,
                                                           context=context)
                    valor_desconto = titulo_desconto
                    if titulo_tipo == 'R' and  prazo_perdao >= dias_atraso:
                        titulo_multa = 0
                        titulo_juros_por_dia = 0

                    if titulo_data_limite_desconto:
                        date_titulo_limite_desconto = parse(titulo_data_limite_desconto, yearfirst=True).date()
                        if date_baixa_pagamento > date_titulo_limite_desconto:
                            valor_desconto = 0
                    if titulo_multa_apos_data:
                        y, m, d = (int(x) for x in titulo_multa_apos_data.split('-'))
                        dat = date(y, m, d)
                        nro_semana = date.weekday(dat)
                        date_multa = parse(titulo_multa_apos_data, yearfirst=True).date()
                        diferenca = (date_baixa_pagamento - date_multa).days
                        if (diferenca == 1 and nro_semana == 6) or (diferenca == 2
                                                                    and nro_semana == 5):
                            if nro_semana == 5:  # Sabado
                                date_multa = (parse(titulo_multa_apos_data, yearfirst=True) +
                                              relativedelta(days=+2)).date()
                            elif nro_semana == 6:  # Domingo
                                date_multa = (parse(titulo_multa_apos_data, yearfirst=True) +
                                              relativedelta(days=+1)).date()
                        if prazo_perdao > 0 and titulo_tipo == 'R':
                            data_aux = date_multa + relativedelta(days=prazo_perdao)
                            if date_multa <= date_baixa_pagamento <= data_aux:
                                date_multa += relativedelta(days=prazo_perdao)
                        if date_multa >= date_baixa_pagamento:
                            titulo_multa = 0

                    vals_detalhe = {
                        'wbtd_baixa_id': baixa_titulo_id,
                        'wbtd_titulo_id': titulo_id,
                        'wbtd_pessoa_id': titulo_pessoa_id,
                        'wbtd_data_emissao': titulo_data_emissao,
                        'wbtd_data_prorrogacao': titulo_data_prorrogacao,
                        'wbtd_dias_atraso': dias_atraso,
                        'wbtd_juros_por_dia': titulo_juros_por_dia * percentual / 100,
                        'wbtd_multa_total': titulo_multa * percentual / 100,
                        'wbtd_desconto_total': valor_desconto * percentual / 100,
                        'wbtd_vr_acrescimo': titulo_acrescimo * percentual / 100,
                        'wbtd_saldo': titulo_saldo,
                        'wbtd_titulo_tipo': titulo_tipo,
                    }
                    if titulo_multa_apos_data:
                        vals_detalhe['wbtd_multa_apos_data'] = titulo_multa_apos_data

                    # _________________________[CREATE] WIZARD BAIXA TITULO DETALHE__________________________________
                    obj_baixa_titulo_detalhe.create(cr, uid, vals_detalhe, context)
                self.write(cr, uid, ids, {'state': 'TL', 'wbt_valor_saldo_restante': 0,
                                          'wbt_valor_pago': 0, 'wbt_total_condicao_pagamento': 0},
                           context)
        return True

    def wbt_button_atualizar_valor_titulos_selecionados(self, cr, uid, ids, context=None):
        """
        Funcao atualiza:
        * O valor total dos titulos selecionados na tela para informar o usuario.
        * Valor proporcional dos juros, multa e desconto de acordo com o valor do pagamento.

        Funcao cria:
        * Custificacao dos Titulos
        """

        context = context and context.copy() or {}
        brw_baixa = self.browse(cr, uid, ids[0], context)
        baixa_valor_pago = brw_baixa.wbt_valor_pago or 0
        prazo_perdao = self.pool.get('adm.utils').admutl_get_parametros(cr, uid,
                'financeiro.parametros', ['prazo_perdao'], context=context).get('prazo_perdao') or 0

        # Filtra todos os titulos
        brw_titulos_selecionados = filter(
            lambda s: s.wbtd_flag_selecionado is True, brw_baixa.wbt_titulo_detalhe_ids
        )
        if not brw_titulos_selecionados:
            raise osv.except_osv(_('Atencao!'), _('Nenhum titulo encontra-se selecionado!'))

        is_baixa_multipla = True if len(brw_titulos_selecionados) > 1 else False

        # Muda o state para "VA" (valores validados) para que o usuario nao altere o valor de
        # pagamento
        values_baixa_titulo = {'state': 'VA'}

        total_titulos = sum(map(lambda i: i.wbtd_valor_total, brw_titulos_selecionados))

        # Se o usuario nao informou nenhum valor a pagar ou o valor a pagar eh maior que o saldo do
        # titulo, o valor pago eh igual ao total do saldo.
        if is_baixa_multipla:
            values_baixa_titulo.update({'wbt_valor_pago': 0})
        elif not baixa_valor_pago or baixa_valor_pago > total_titulos:
            values_baixa_titulo.update({'wbt_valor_pago': total_titulos})
            baixa_valor_pago = total_titulos

        obj_titulo_detalhe = self.pool.get('wizard.baixa.titulo.detalhe')
        valor_saldo_restante = 0

        # caso nao seja baixa parcial('brw_baixa.wbt_valor_pago' com valor) pula o passo a baixo
        if not is_baixa_multipla and brw_baixa.wbt_valor_pago:
            convert_2_decimal = self.pool.get('financeiro').financ_convert_to_decimal

            # Atualiza os campos de juros, multa e desconto, aplicando a proporcao em relação ao
            # valor pago.
            for brw_det_titulo in brw_titulos_selecionados:
                # Dados do wizard titulo detalhe
                total_titulo = brw_det_titulo.wbtd_valor_total
                percentual = baixa_valor_pago / total_titulo
                wtbd_id = brw_det_titulo.id
                dec_multa = brw_det_titulo.wbtd_multa_total or 0
                dec_saldo = brw_det_titulo.wbtd_saldo or 0
                dec_desconto = brw_det_titulo.wbtd_desconto_total or 0
                dec_acrescimo = brw_det_titulo.wbtd_vr_acrescimo or 0
                btd_dias_atraso = brw_det_titulo.wbtd_dias_atraso or 0
                dec_juros_total = brw_det_titulo.wbtd_juros_total

                nova_multa = float(obj_titulo_detalhe._float_persist('wbtd_multa_total',
                                                 (dec_multa * percentual)))
                novo_juros_total = float(obj_titulo_detalhe._float_persist(
                    'wbtd_juros_total', dec_juros_total * percentual))
                novo_juros_por_dia = 0
                if btd_dias_atraso:
                    novo_juros_por_dia = float(obj_titulo_detalhe._float_persist(
                        'wbtd_juros_por_dia', (novo_juros_total / btd_dias_atraso)))

                novo_desconto = float(obj_titulo_detalhe._float_persist('wbtd_desconto_total',
                                                    (dec_desconto * percentual)))
                novo_juros_total = novo_juros_por_dia * btd_dias_atraso
                novo_acrescimo = float(obj_titulo_detalhe._float_persist('wbtd_vr_acrescimo',
                                                    (dec_acrescimo * percentual)))
                novo_saldo = baixa_valor_pago - novo_juros_total - nova_multa + novo_desconto - novo_acrescimo
                novo_saldo = float(obj_titulo_detalhe._float_persist('wbtd_saldo', novo_saldo))
                total_calculado = novo_saldo + novo_juros_por_dia * btd_dias_atraso + nova_multa\
                                  - novo_desconto + novo_acrescimo
                dif = baixa_valor_pago - total_calculado
                if dif <= -0.01:
                    novo_desconto += dif * -1
                elif 0.01 >= dif:
                    novo_acrescimo += dif

                values_detalhe = {
                    'wbtd_juros_por_dia': novo_juros_por_dia,
                    'wbtd_multa_total': nova_multa,
                    'wbtd_desconto_total': novo_desconto,
                    'wbtd_vr_acrescimo': novo_acrescimo,
                    'wbtd_saldo': novo_saldo
                }
                obj_titulo_detalhe.write(cr, uid, [wtbd_id], values_detalhe, context=context)
                if dec_saldo > novo_saldo:
                    valor_saldo_restante = dec_saldo - novo_saldo

            values_baixa_titulo.update({'wbt_valor_saldo_restante': valor_saldo_restante})

        self.write(cr, uid, ids, values_baixa_titulo, context)
        # pega a forma de pagamento default
        vals = self.wbt_get_defout_pagamento(cr, uid, ids, context=context)
        self.write(cr, uid, ids, vals, context)
        return True

    def wbt_get_defout_pagamento(self, cr, uid, ids, context=None):
        '''
        Pega como defalt as os parametros do financeiro para criar o pagamento
        :param cr: 
        :param uid: 
        :param vals: dict
        :param total: float
        :param context: 
        '''
        context = context and context.copy() or {}
        campos = ['finpar_conta_para_baixa_titulos', 'finpar_forma_pagto_baixa_titulos',
                  'finpar_condicao_forma_baixa_titulos']
        par =self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'financeiro.parametros',
                                                              campos, context=context)
        if not par or not all([par.get('finpar_conta_para_baixa_titulos'),
                               par.get('finpar_forma_pagto_baixa_titulos'),
                               par.get('finpar_condicao_forma_baixa_titulos')]):
            return {}

        dados = self.read(cr, uid, ids, ['wbt_total_liquido_receber', 'wbt_total_liquido_pagar'],
                          context=context)
        dados = isinstance(dados, list) and dados[0] or dados
        if dados.get('wbt_total_liquido_receber') > 0:
            total = dados.get('wbt_total_liquido_receber')
        else:
            total = dados.get('wbt_total_liquido_pagar')

        vals_pgto = {'wizbtp_conta_id': par.get('finpar_conta_para_baixa_titulos'),
                     'wizbtp_forma_pgto_id': par.get('finpar_forma_pagto_baixa_titulos'),
                     'wizbtp_condicao_id': par.get('finpar_condicao_forma_baixa_titulos'),
                     'wizbtp_valor': total,
                     }
        return {'wbt_pagamento_ids': [[0, 0, vals_pgto]]}

    def wbt_calcula_desconto(self, cr, uid, baixa_titulo_detalhe_ids, valor_desconto_capa):
        dict_titulo_desconto = {}
        total_desconto_rateado = 0
        valor_total_titulo = sum(map(lambda i: i.wbtd_valor_total or 0,
                                 baixa_titulo_detalhe_ids))
        for i in baixa_titulo_detalhe_ids:
            desconto_rateado = (i.wbtd_valor_total / valor_total_titulo) * valor_desconto_capa
            dict_titulo_desconto[i.id] = desconto_rateado
            total_desconto_rateado += desconto_rateado
        if valor_desconto_capa != total_desconto_rateado:
            for i in dict_titulo_desconto:
                dict_titulo_desconto[i] += valor_desconto_capa - total_desconto_rateado
                break
        return dict_titulo_desconto

    def wbt_button_baixar_titulo(self, cr, uid, ids, context=None):
        """
        Realiza a baixa de titulos
        """

        context = context and context.copy() or {}
        brw_baixa_titulo = self.browse(cr, uid, ids[0], context)
        if brw_baixa_titulo.wbt_total_liquido_pagar > 0:
            for brw_pgto in brw_baixa_titulo.wbt_pagamento_ids:
                if self.pool.get('adm.forma.pgto').admfpg_forma_pgto_tipo_cheque(
                    cr, uid, brw_pgto.wizbtp_forma_pgto_id.id, context):
                    raise osv.except_osv(_('Atencao!'),
                            _('A forma de pagamento cheque nao pode ser usada para pagar titulos!'))

        # Somente os titulos selecionados
        brw_titulos = filter(lambda f: f.wbtd_flag_selecionado,
                             brw_baixa_titulo.wbt_titulo_detalhe_ids)

        titulos_nao_abertos = filter(lambda f: f.wbtd_titulo_id.state != 'A', brw_titulos)

        if titulos_nao_abertos:
            if titulos_nao_abertos.__len__() > 1:
                msg = _('Os titulos %s nao podem ser baixados pois nao estao mais em aberto.')
            else:
                msg = _('O titulo %s nao pode ser baixado pois nao esta mais em aberto.')

            msg %= ', '.join(map(lambda m: m.wbtd_titulo_id.documento, titulos_nao_abertos))
            raise osv.except_osv(_('Atencao!'), msg)

        # Se renegociacao (pagamentos a prazo), nao permite baixa multipla para diferentes
        # clientes/fornecedores
        if list(set(map(lambda m: m.wbtd_pessoa_id.id, brw_titulos))).__len__() > 1:
            if filter(lambda f: f.wizbtp_condicao_id.adm_condicao_id.tipo != 'V',
                      self.browse(cr, uid, ids[0], context).wbt_pagamento_ids):
                raise osv.except_osv(_('Atencao!'),
                                     _('Nao e possivel renegociar titulos de clientes/fornecedores '
                                       'diferentes.'))
            else:
                # Verifica se pagamento foi realizado com cheque ou cartao credito/debito
                if filter(lambda f: f.wizbtp_forma_pgto_id.cartao_credito_debito or
                                f.wizbtp_forma_pgto_tipo == 'cheque',
                          self.browse(cr, uid, ids[0], context).wbt_pagamento_ids):
                    raise osv.except_osv(
                        _('Atencao!'),
                        _('Nao e possivel renegociar titulos de clientes/fornecedores diferentes.'))

        return self._wbt_baixar_titulos(cr, uid, ids[0], context)

    def _wbt_baixar_titulos(self, cr, user, baixa, context=None):
        """
        Baixa de titulos.

        :param cr: cursor do banco de dados
        :param user: ID do usuario utilizado para a verificacao de perfil
        :param baixa: ID do formulario de baixa de titulos
        :param context: um dicionario padrao para valores contextuais
        :type cr: object
        :type user: int
        :type baixa: long
        :type context: dict
        :return:
        :rtype:

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        obj_wizard_baixa_parcelas = self.pool.get('wizard.baixa.parcelas')
        brw_baixa = self.browse(cr, user, baixa, context)
        baixa_conta_tesouraria_id = brw_baixa.wbt_conta_id.id
        baixa_valor_pago = abs(brw_baixa.wbt_valor_pago or
                               brw_baixa.wbt_total_liquido_receber or
                               brw_baixa.wbt_total_liquido_pagar)
        baixa_titulo_tipo = brw_baixa.wbt_titulo_tipo
        valor_desconto = brw_baixa.wbt_valor_desconto or 0.0
        pessoa_id = brw_baixa.wbt_cliente_id.id

        # Filtra os titulos marcados para serem baixados
        record_baixa_titulo_detalhe_ids = filter(
            lambda i: i.wbtd_flag_selecionado is True, brw_baixa.wbt_titulo_detalhe_ids)
        if not record_baixa_titulo_detalhe_ids:
            raise osv.except_osv(_('Atencao!'),
                                 _('Para realizar a baixa, e necessario marcar ao menos um '
                                   'titulo.'))

        # Verifica se o valor total dos pagamentos eh diferente do valor a ser pago
        browse_baixa_titulo_pagamento = brw_baixa.wbt_pagamento_ids
        pagamento_ids = map(lambda p: p.id, browse_baixa_titulo_pagamento)
        total_pagamentos = sum(map(lambda i: i.wizbtp_valor or 0.0, browse_baixa_titulo_pagamento))
        if round(total_pagamentos, 2) != round(baixa_valor_pago, 2):
            raise osv.except_osv(_('Atencao'), _('O total dos pagamentos informados difere do '
                                                 'total a receber / a pagar'))

        # Dados dos pagamentos
        list_pagamentos = list()

        for pagamento in browse_baixa_titulo_pagamento:
            condicao = pagamento.wizbtp_condicao_id.adm_condicao_id
            administradora_cartao_pessoa_id = False

            if pagamento.wizbtp_forma_pgto_id.cartao_credito_debito:
                administradora_cartao_pessoa_id = pagamento.wizbtp_forma_pgto_id.\
                    admfpg_cartao_pessoa_id.id
                condicao_tipo = 'C'  # Pagamento com cartao sempre sera considarado a prazo
            elif pagamento.wizbtp_forma_pgto_tipo == 'cheque':
                condicao_tipo = 'C'  # Pagamento com cheque tambem sempre sera considerado a prazo
            else:
                condicao_tipo = condicao.tipo

            vals_pagamentos = dict(
                tesouraria_conta_id=pagamento.wizbtp_conta_id.id,
                forma_pagamento_id=pagamento.wizbtp_forma_pgto_id.id,
                condicao_tipo=condicao_tipo,
                valor=pagamento.wizbtp_valor,
                pessoa_id=pessoa_id,)
            if pagamento.wizbtp_parcelas_ids:
                obj_wizard_baixa_parcelas.wizbpa_verifica_parcelas(
                    cr, user, map(lambda pa: pa.id, pagamento.wizbtp_parcelas_ids), context)
                parcelas = []
                for i in pagamento.wizbtp_parcelas_ids:
                    parcelas.append({'valor': i.wizbpa_vr_parcela,
                                     'data': i.wizbpa_data_vencimento})
                vals_pagamentos['parcelas'] = parcelas

            if condicao_tipo == 'C':  # Acrescenta os dados de pagamento a prazo
                vals_pagamentos = dict(
                    vals_pagamentos,
                    qtd_parcelas=condicao.qtde_parcelas or 0,
                    dias_incremento=condicao.dias_incremento or 0,
                    dias_primeira_parcela=condicao.dias_primeira_parcela or 0,
                    administradora_cartao_pessoa_id=administradora_cartao_pessoa_id,
                    taxa=pagamento.wizbtp_condicao_id.taxa or 0.0,
                    banco=pagamento.wizbtp_cheque_banco,
                    agencia=pagamento.wizbtp_cheque_agencia,
                    conta=pagamento.wizbtp_cheque_conta,
                    numero=pagamento.wizbtp_cheque_numero,
                    bom_para=pagamento.wizbtp_cheque_bom_para)

            list_pagamentos.append(vals_pagamentos)

        baixa_titulo_detalhe_ids = map(lambda i: i.id, record_baixa_titulo_detalhe_ids)
        # Valida o valor a ser pago em relacao aos titulos. Se for selecionado apenas um titulo, o
        # valor pago pode ser menor que o valor total do titulo (baixa parcial). Se for selecionado
        # mais de um titulo, o valor a ser pago deve ser igual ao somatorio dos valores dos titulos
        # selecionados
        self.wbt_validar_valor_pago_titulos(
            cr, user, valor_pago=baixa_valor_pago, titulo_selecionado_ids=baixa_titulo_detalhe_ids,
            context=context)

        # ___________________________ Objects ________________________________
        obj_financeiro_utils = self.pool.get('financeiro')
        obj_finaceiro_titulo = self.pool.get('financeiro.titulo')
        obj_titulo_detalhe = self.pool.get('wizard.baixa.titulo.detalhe')

        total_titulos_a_ser_baixados = len(baixa_titulo_detalhe_ids or [])
        baixa_multipla = True if total_titulos_a_ser_baixados > 1 else False
        msg_erro = u''
        msg_erro_many_titulos = {}
        convert_2_decimal = obj_financeiro_utils.financ_convert_to_decimal
        dict_desconto = self.wbt_calcula_desconto(
            cr, user, record_baixa_titulo_detalhe_ids, valor_desconto)
        titulos = []
        titulo_ids = [titulo.id for titulo in record_baixa_titulo_detalhe_ids]

        for titulo in record_baixa_titulo_detalhe_ids:
            desconto_rateado = dict_desconto.get(titulo.id) or 0.0
            titulos.append({
                'titulo_id': titulo.wbtd_titulo_id.id,
                'valor_pago': titulo.wbtd_valor_total - desconto_rateado,
                'valor_multa': titulo.wbtd_multa_total,
                'valor_juros': titulo.wbtd_juros_total,
                'valor_desconto': titulo.wbtd_desconto_total + desconto_rateado,
                'valor_acrescimo': titulo.wbtd_vr_acrescimo or 0.0,
                'tipo_titulo': titulo.wbtd_titulo_id.tipo_titulo,
                'pessoa_id': titulo.wbtd_titulo_id.pessoa_id.id,
                'saldo_baixado': titulo.wbtd_saldo,
            })

        forma_pagamento_id = brw_baixa.wbt_forma_pgto_id.id
        if list_pagamentos:
            forma_pagamento_id = list_pagamentos[0].get('forma_pagamento_id')

        res_baixa = obj_financeiro_utils.financ_baixar_titulo(
            cr, user,
            futl_bxti_titulos=titulos,
            futl_bxti_data_pagamento=brw_baixa.wbt_data_pagamento,
            ftul_bxti_forma_pgto_id=forma_pagamento_id,
            futl_bxti_tesouraria_conta_id=baixa_conta_tesouraria_id,
            futl_bxti_baixa_multipla=baixa_multipla,
            futl_bxti_pessoa_id=pessoa_id,
            futl_bxti_pagamento_dados=list_pagamentos,
            context=context)

        if not res_baixa:
            baixa_erro = obj_financeiro_utils.financ_get_erro()
            if isinstance(baixa_erro, basestring):
                if 'ctx_util_baixa_lt' in baixa_erro:
                    baixa_erro = baixa_erro.replace('ctx_util_baixa_lt', '')
                    key = hash(baixa_erro)
                    if key in msg_erro_many_titulos:
                        msg_erro_many_titulos[key]['titulo_ids'].extend(titulo_ids)
                    else:
                        msg_erro_many_titulos[key] = {'titulo_ids': titulo_ids, 'msg': baixa_erro}
                else:
                    if baixa_erro.strip().endswith(':'):
                        res_name_get = obj_finaceiro_titulo.name_get(
                            cr, user, titulo_ids, context) or [('', '')]
                        dict_name_get = dict(res_name_get)
                        titulo_name = ''
                        for x in dict_name_get:
                            titulo_name += '%s, ' % \
                                           dict_name_get.get(x) or _('** Titulo nao encontrado **')
                    else:
                        titulo_name = ''
                    msg_erro += '%s %s' % (baixa_erro, titulo_name)
        else:
            for titulo in record_baixa_titulo_detalhe_ids:
                desconto_rateado = dict_desconto.get(titulo.id) or 0
                BTD_TITULO_DESCONTO = titulo.wbtd_desconto_total + desconto_rateado
                dec_desconto = convert_2_decimal(BTD_TITULO_DESCONTO, places=5)
                values_detalhe = {
                    'wbtd_desconto_total': dec_desconto,
                }
                obj_titulo_detalhe.write(cr, user, [titulo.id], values_detalhe, context=context)

        if msg_erro_many_titulos:
            new_msg = self.wbt_generate_msg_titulos(cr, user, dict_msg=msg_erro_many_titulos, context=context)
            msg_erro += new_msg

        if msg_erro:
            raise osv.except_osv(_('Atencao'), msg_erro)
        else:
            self.write(cr, user, [baixa], {
                'state': 'BA',
                'wbt_valor_pago': 0,
                'wbt_valor_desconto': 0
            }, context=context)
            self.pool.get('wizard.baixa.titulo.pagamento').unlink(cr, user, pagamento_ids, context)
            self.wbt_button_imprimir_baixas(cr, user, [baixa], context=context)

        return True

    def wbt_button_imprimir_baixas(self, cr, uid, ids, context=None):
        """
        Funcao realiza a impressao de recibos dos titulos baixados
        """

        context = context and context.copy() or {}
        obj_wizard_baixa_titulo_recibo_capa = self.pool.get('wizard.baixa.titulo.recibo.capa')
        obj_wizard_baixa_titulo_detalhe = self.pool.get('wizard.baixa.titulo.detalhe')
        obj_wiz_baixa_titulo_rec_documento = self.pool.get('wizard.baixa.titulo.recibo.documentos')
        get_parametros = self.pool.get('adm.utils').admutl_get_parametros
        financeiro_parametros = get_parametros(
            cr, uid, 'financeiro', ['finpar_recibo_baixa_laser_matricial',
                                    'finpar_recibo_impressora'], context=context)
        args_recibo_capa_ids = [('wbtrc_wiz_baixa_titulo_id', '=', ids[0])]
        recibo_capa_ids = obj_wizard_baixa_titulo_recibo_capa.search(
            cr, uid, args_recibo_capa_ids, context=context)
        args_documentos_ids = [('wbtrd_capa_id', 'in', recibo_capa_ids)]
        recibo_documentos_ids = obj_wiz_baixa_titulo_rec_documento.search(
            cr, uid, args_documentos_ids, context=context)
        if recibo_capa_ids:
            if recibo_documentos_ids:
                obj_wiz_baixa_titulo_rec_documento.unlink(cr, uid, recibo_documentos_ids)
            obj_wizard_baixa_titulo_recibo_capa.unlink(cr, uid, recibo_capa_ids)

        args_detalhe_ids = [('wbtd_baixa_id', 'in', ids), ('wbtd_flag_selecionado', '=', True)]
        detalhe_ids = obj_wizard_baixa_titulo_detalhe.search(cr, uid, args_detalhe_ids, context=context)
        brw_baixa_titulo_detalhe = obj_wizard_baixa_titulo_detalhe.browse(cr, uid, detalhe_ids)
        pessoa_ids = map(lambda i: i.wbtd_pessoa_id.id, brw_baixa_titulo_detalhe)
        pessoa_ids = list(set(pessoa_ids))

        # Grava recibo capa
        for pessoa_id in pessoa_ids:
            vals_recibo_capa = {
                'wbtrc_pessoa_id': pessoa_id,
                'wbtrc_wiz_baixa_titulo_id': ids[0],
            }
            recibo_capa_id = obj_wizard_baixa_titulo_recibo_capa.create(
                cr, uid, vals_recibo_capa, context=None)
            vr_total_recibo = 0
            vr_total_juros = 0
            vr_total_recebido = 0.00
            vr_total_pago = 0.00

            # Grava recibo documentos
            for detalhe in brw_baixa_titulo_detalhe:
                if detalhe.wbtd_baixa_id.id == ids[0]:
                    if detalhe.wbtd_pessoa_id.id == pessoa_id:
                        vals_recibo_documentos = {
                            'wbtrd_capa_id': recibo_capa_id,
                            'wbtrd_titulo_tipo': detalhe.wbtd_titulo_tipo,
                            'wbtrd_titulo_id': detalhe.wbtd_titulo_id.id,
                            'wbtrd_valor_total': detalhe.wbtd_valor_total,
                            'wbtrd_juros_total': detalhe.wbtd_juros_total
                        }
                        obj_wiz_baixa_titulo_rec_documento.create(
                            cr, uid, vals_recibo_documentos, context=None)
                        vr_total_recibo += detalhe.wbtd_valor_total
                        vr_total_juros += detalhe.wbtd_juros_total
                        if detalhe.wbtd_titulo_tipo == 'R':
                            vr_total_recebido += detalhe.wbtd_valor_total
                        else:
                            vr_total_pago += detalhe.wbtd_valor_total
            if vr_total_recebido > vr_total_pago:
                vals_recibo_capa['wbtrc_recibo_tipo'] = 'R'
                vr_total_liquido = vr_total_recebido - vr_total_pago
            else:
                vals_recibo_capa['wbtrc_recibo_tipo'] = 'P'
                vr_total_liquido = vr_total_pago - vr_total_recebido
            vals_recibo_capa['wbtrc_vr_total'] = vr_total_liquido
            vals_recibo_capa['wbtrc_vr_total_recebido'] = vr_total_recebido
            vals_recibo_capa['wbtrc_vr_total_pago'] = vr_total_pago
            vals_recibo_capa['wbtrc_vr_total_juros'] = vr_total_juros
            obj_wizard_baixa_titulo_recibo_capa.write(
                cr, uid, recibo_capa_id, vals_recibo_capa, context)
        recibo_capa_ids = obj_wizard_baixa_titulo_recibo_capa.search(
            cr, uid, args_recibo_capa_ids, context=context)
        hoje = datetime.now()
        documento = 'report.recibo_baixa.' + str(hoje)
        obj_ir_act_report_xml = self.pool.get('ir.actions.report.xml')
        report_id = obj_ir_act_report_xml.search(
            cr, uid, [('report_name', '=', 'wizard.baixa.titulo')], context=context)
        report_xml = obj_ir_act_report_xml.browse(cr, uid, report_id[0])
        report_xml._data.get(report_id[0])['name'] = _('Recibo baixa')

        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid)
        brw_company_id = self.pool.get('res.company').browse(cr, uid, company_id)
        context.update({'company_id': brw_company_id})

        vals = {'baixa_gerada': True}

        impressora_recibo = financeiro_parametros.get('finpar_recibo_impressora')
        if financeiro_parametros.get('finpar_recibo_baixa_laser_matricial') == 'M':
            report_dados = self.wbt_get_recibo_baixa_formato_bobina(cr, uid, ids, recibo_capa_ids,
                                                                    context)
            vals.update({'wbt_file_name': 'Recibo.txt'})
            if impressora_recibo:
                diretorio = '/tmp/Recibo.txt'
                arquivo = open(diretorio, 'wb')
                arquivo.write(report_dados)
                arquivo.close()
        else:
            report_dados = report_sxw.report_sxw(
                documento, 'wizard.baixa.titulo.recibo.capa',
                'financeiro/report/recibo_baixa.rml').create_single_pdf(
                cr, uid, recibo_capa_ids, {'report_type': 'pdf'}, report_xml, context=context)[0]
            vals.update({'wbt_file_name': 'Recibo.pdf'})
            if impressora_recibo:
                diretorio = '/tmp/Recibo.pdf'
                arquivo = open(diretorio, 'wb')
                arquivo.write(report_dados)
                arquivo.close()

        if impressora_recibo:
            impressora = "-d" + impressora_recibo
            subprocess.call(["lp", "-n1", impressora, diretorio])
        else:
            vals.update({'dados': base64.encodestring(report_dados)})

        self.write(cr, uid, ids, vals, context)

        return report_dados

    def wbt_get_recibo_baixa_formato_bobina(self, cr, uid, ids, recibo_capa_ids, context=None):
        """
        Organiza os dados do recibo da baixa num arquivo txt (/tmp/recibo_baixa_bobina.txt).
        O arquivo e formatado em 48 caracteres por linha, padrao bobina.
        :param cr: cursor no banco de dados
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario
        :type uid: int
        :param ids: lista de id da tabela dessa classe
        :type ids: list
        :param recibo_capa_ids: lista de id da tabela da classe wizard_baixa_titulo_recibo_capa
        :type recibo_capa_ids: list
        :param context: dicionario com valores contextuais
        :type context: dict
        :return: Dados do arquivo de recibo criado.
        :rtype: str
        """
        context = context and context.copy() or {}
        obj_adm_utils = self.pool.get('adm.utils')
        obj_financeiro_titulo = self.pool.get('financeiro.titulo')

        brw_res_company = context.get('company_id')
        arquivo = '/tmp/recibo_baixa_bobina-%s.txt' % randint(1, 1000)
        recibo_baixa = open('%s' % arquivo, 'wb')

        line_size = 48
        line_break = '\r\n'

        doc_tipo_ids = self.pool.get('documento.documento.tipo').search(
            cr, uid, [('sigla', '=', 'PRV')], context=context)
        args_titulo = [('state', '=', 'A'), ('tipo_titulo', '=', 'R'),
                       ('doc_tipo_id', 'not in', doc_tipo_ids)]

        for recibo_capa in self.pool.get('wizard.baixa.titulo.recibo.capa').browse(
                cr, uid, recibo_capa_ids, context):
            args_titulo.append(('pessoa_id', '=', recibo_capa.wbtrc_pessoa_id.id))
            titulo_em_aberto_ids = obj_financeiro_titulo.search(cr, uid, args_titulo,
                                                                context=context)
            valor_debito = sum(map(lambda s: s.saldo or 0, obj_financeiro_titulo.browse(
                cr, uid, titulo_em_aberto_ids, context)))
            for tipo_titulo in ['R', 'P']:
                documentos_por_tipo_titulo = filter(lambda t: t.wbtrd_titulo_tipo == tipo_titulo,
                                                    recibo_capa.wbtrc_recibo_documentos_ids)
                if not documentos_por_tipo_titulo:
                    continue
                linha = 'Ctas. a Receber/Pagar' + ' ' * 17 + strftime('%d/%m/%Y') + line_break
                recibo_baixa.write(linha)

                linha = formataString('Demonstrativo de Pagamento/Recebimento', line_size, ' ', 'C',
                                      'N', 'S') + line_break
                recibo_baixa.write(linha)
                recibo_baixa.write(line_break)

                recibo_baixa.write(obj_adm_utils.admutl_remover_acentuacao(
                    cr, uid, brw_res_company.name[:line_size]) + line_break)

                brw_pessoa_empresa = brw_res_company.rescon_pessoa_id
                endereco = '%s - %s, %s / %s - %s' % (brw_pessoa_empresa.endereco,
                                                      brw_pessoa_empresa.bairro,
                                                      brw_pessoa_empresa.cidade,
                                                      brw_pessoa_empresa.uf, brw_pessoa_empresa.cep)
                while endereco:
                    recibo_baixa.write(formataString(obj_adm_utils.admutl_remover_acentuacao(
                        cr, uid, endereco[:48]), 48, ' ', 'D', 'N', 'S') + line_break)
                    endereco = endereco[48:]

                recibo_baixa.write('CNPJ: %s' % brw_pessoa_empresa.cpf_cnpj + line_break)

                recibo_baixa.write('Telefone: %s' % brw_pessoa_empresa.telefone or '' + line_break)
                recibo_baixa.write(line_break)

                recibo_baixa.write('Codigo: %s' % recibo_capa.wbtrc_pessoa_id.codigo + line_break)

                recibo_baixa.write(formataString('Cliente: %s' % recibo_capa.wbtrc_pessoa_id.nome,
                                   line_size, ' ', 'D', 'N', 'S') + line_break)

                endereco_cliente = recibo_capa.wbtrc_pessoa_id.endereco
                while endereco_cliente:
                    recibo_baixa.write(formataString('Endereco: %s' % endereco_cliente[:48],
                                                     line_size, ' ', 'D', 'N', 'S') + line_break)
                    endereco_cliente = endereco_cliente[48:]

                recibo_baixa.write(formataString('Cidade: %s' % recibo_capa.wbtrc_pessoa_id.cidade,
                                                 48, ' ', 'D', 'N', 'S') + line_break)

                recibo_baixa.write(formataString('CEP: %s' % recibo_capa.wbtrc_pessoa_id.cep, 48,
                                                 ' ', 'D', 'N', 'S') + line_break)
                recibo_baixa.write(line_break)

                recibo_baixa.write('-' * line_size + line_break)

                recebidos_pagos = 'RECEBIDOS' if tipo_titulo == 'R' else 'PAGOS'
                recibo_baixa.write('%s:' % recebidos_pagos + line_break)

                linha = formataString('Documento', 20, ' ', 'D', 'N', 'S')
                linha += formataString('Vencimento', 10, ' ', 'D', 'N', 'S')
                linha += formataString('Valor', 10, ' ', 'E', 'N', 'S')
                linha += formataString('Juros', 8, ' ', 'E', 'N', 'S')
                recibo_baixa.write(linha + line_break)

                saldo = 0
                for documento in documentos_por_tipo_titulo:
                    linha = formataString(documento.wbtrd_titulo_id.documento, 20, ' ', 'D', 'N',
                                          'S')
                    linha += formataString(parse(
                        documento.wbtrd_titulo_id.data_prorrogacao).strftime('%d/%m/%Y'), 10, ' ',
                                           'D', 'N', 'S')
                    linha += formataString(getNumeroEditado(
                        documento.wbtrd_valor_total - documento.wbtrd_juros_total), 10, ' ', 'E',
                        'N', 'S')
                    linha += formataString(getNumeroEditado(documento.wbtrd_juros_total), 8, ' ',
                                           'E', 'N', 'S')

                    recibo_baixa.write(linha + line_break)
                    saldo += documento.wbtrd_titulo_id.saldo or 0

                recibo_baixa.write('-' * line_size + line_break)
                recibo_baixa.write(line_break)

                recibo_baixa.write('Total recebido: %s' % getNumeroEditado(
                    recibo_capa.wbtrc_vr_total) + line_break)
                recibo_baixa.write('Vlr. em debito: %s' % getNumeroEditado(
                    valor_debito if tipo_titulo == 'R' else 0) + line_break)

                for x in range(0, 5):
                    recibo_baixa.write(line_break)

        recibo_baixa.close()

        return open(arquivo, 'r').read()

    def wbt_generate_msg_titulos(self, cr, uid, dict_msg, context=None):
        context = context and context.copy() or {}
        msg = u''
        obj_finaceiro_titulo = self.pool.get('financeiro.titulo')
        for i in dict_msg:
            titulo_ids = dict_msg[i]['titulo_ids']
            titulo_msg = dict_msg[i]['msg']

            res_name_get = obj_finaceiro_titulo.name_get(cr, uid, titulo_ids, context) or [('', '')]
            dict_name_get = dict(res_name_get)
            titulo_names = ''
            for t in titulo_ids:
                titulo_names += '%s, ' % (dict_name_get.get(t) or _('** Titulo nao encontrado **'))
            msg += '%s%s' % (titulo_msg, titulo_names)
        return msg


class wizard_baixa_parcelas(osv.TransientModel):

    _name = 'wizard.baixa.parcelas'

    _columns = {
        'wizbpa_pagamento_id': fields.many2one('wizard.baixa.titulo.pagamento', 'Pagamento',
                                               ondelete="cascade", select=True),
        'wizbpa_vr_parcela': fields.float('Valor da Parcela', digits=(15, 2), required=True),
        'wizbpa_data_vencimento': fields.date('Data de Vencimento', required=True),
    }

    def wizbpa_verifica_parcelas(self, cr, uid, ids, context=None):
        """
        O metodo valida o total das parcelas com o valor da condicao de pagamento.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dados contextuais.
        :type context: dict
        :return: Se o total das parcelas for compativel com o valor da condicao, verdadeiro. Senao,
        raise com informacao da diferenca de valores.
        """
        context = context and context.copy() or {}
        if not isinstance(ids, list):
            ids = [ids]
        brw_wizard_baixa_parcelas = self.browse(cr, uid, ids, context)
        total_parcelas = sum(map(lambda x: x.wizbpa_vr_parcela or 0, brw_wizard_baixa_parcelas))
        valor_condicao = brw_wizard_baixa_parcelas[0].wizbpa_pagamento_id.wizbtp_valor or 0
        dif = valor_condicao - total_parcelas
        if not -0.01 < dif and dif < 0.01:
            raise osv.except_osv(
                _('Atencao!'),
                _('A soma das parcelas difere do valor do pagamento:\n Pagamento: %.2f\n'
                  'Total Parcelas: %.2f' % (valor_condicao, total_parcelas)))
        return True


# Formas de pagamento
CHEQUE, CARTAO, OUTROS = ['cheque', 'cartao', 'outros']
# Condicoes de pagamento
A_VISTA, A_PRAZO = ['V', 'P']

class wizard_baixa_titulo_pagamento(osv.TransientModel):
    """
    Baixa/pagamento de titulos
    """
    _name = 'wizard.baixa.titulo.pagamento'  # wizbtp_
    _columns = {
        'wizbtp_baixa_id': fields.many2one('wizard.baixa.titulo', 'Baixa'),
        'wizbtp_conta_id': fields.many2one('financeiro.tesouraria.contas', 'Conta tesouraria',
                                           required=True),
        'wizbtp_forma_pgto_id': fields.many2one('adm.forma.pgto', 'Forma de pagamento',
                                                required=True),
        'wizbtp_forma_pgto_tipo': fields.selection(
            [(CHEQUE, 'Cheque'), (CARTAO, 'Cartao credito/debito'), (OUTROS, 'Outros')],
            'Forma de pagamento'),
        'wizbtp_condicao_id': fields.many2one('adm.condicao.forma', 'Condicao', required=True),
        'wizbtp_condicao_pgto_tipo': fields.selection(
            [(A_VISTA, 'A vista'), (A_PRAZO, 'A prazo')], 'Condicao de pagamento', size=1),
        'wizbtp_valor': fields.float('Valor', digits=(15, 2), required=True),
        'wizbtp_cheque_banco': fields.integer('Banco', help='Numero do banco no Banco Central.'),
        'wizbtp_cheque_agencia': fields.integer('Agencia', help='Numero da agencia bancaria.'),
        'wizbtp_cheque_conta': fields.char('Conta', size=10),
        'wizbtp_cheque_numero': fields.char('Numero do cheque', size=30),
        'wizbtp_cheque_emitente': fields.char('CPF/CNPJ', size=19),
        'wizbtp_cheque_bom_para': fields.date('Bom para'),
        'wizbtp_cartao_autorizacao': fields.char('Numero da autorizacao', size=10,
                                                 help='Numero da autorizacao do cartao de credito.'),
        'wizbtp_parcelas_ids': fields.one2many('wizard.baixa.parcelas', 'wizbpa_pagamento_id',
                                               'Parcelas'),
    }

    def wizbtp_onchange_valor(self, cr, uid, ids, valor, condicao_id, parcela_ids, context=None):
        context = context and context.copy() or {}
        res = {}
        if not parcela_ids or not condicao_id:
            return res
        if not valor or valor < 0:
            res['value'] = {'wizbtp_parcelas_ids': []}
            return res
        obj_adm_utils = self.pool.get('adm.utils')
        brw_condicao = self.pool.get('adm.condicao.forma').browse(cr, uid, condicao_id,
                                                                  context).adm_condicao_id
        parcelas = []
        elementos = [[i, 0] for i in range(0, len(parcela_ids))]
        data = (datetime.now() + timedelta(days=brw_condicao.dias_primeira_parcela or 0)).date()
        obj_adm_utils.efetuar_rateio(valor, elementos=elementos)
        for i in elementos:
            parcelas.append([0, False, {'wizbpa_vr_parcela': i[1],
                                        'wizbpa_data_vencimento': '%s' % data
                                        }
                             ])
            data += timedelta(days=brw_condicao.dias_incremento)

        res['value'] = {'wizbtp_parcelas_ids': parcelas}
        return res

    def onchange_wizbtp_parcelas_ids(self, cr, uid, ids, parcelas, valor, context=None):
        context = context and context.copy() or {}
        res = {}
        if not parcelas:
            return res
        total_parcelas = sum(map(lambda x: x[2].get('wizbpa_vr_parcela'), parcelas))
        dif = (valor or 0) - total_parcelas
        if not -0.01 < dif and dif < 0.01:
            res['warning'] = {
                'title': _('Atencao!'),
                'message': _('A soma das parcelas difere do valor do pagamento:\nPagamento: %.2f\n'
                             'Total Parcelas: %.2f' % ((valor or 0), total_parcelas))
            }
        return res

    def default_get(self, cr, uid, fields_list, context=None):
        """
        O metodo atribui aos campos recebidos em 'fields_list' valores default.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param fields_list: lista com a descricao dos campos que receberao valores default.
        :type fields_list: list
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: dicionario com a descricao do campo e seu respectivo valor.
        :rtype: dict
        """
        context = context and context.copy() or {}
        res = super(wizard_baixa_titulo_pagamento, self).default_get(cr, uid, fields_list, context)
        if not context.get('baixa_id'):
            return res
        baixa_titulo_dados = self.pool.get('wizard.baixa.titulo').read(
            cr, uid, context.get('baixa_id'), ['wbt_total_condicao_pagamento',
                                               'wbt_total_liquido_receber',
                                               'wbt_total_liquido_pagar'], context=context)
        valor_liquido = (baixa_titulo_dados.get('wbt_total_liquido_receber') or
                         baixa_titulo_dados.get('wbt_total_liquido_pagar'))
        if valor_liquido < 0:
            valor_liquido *= -1
        res['wizbtp_valor'] = valor_liquido - (baixa_titulo_dados.get(
            'wbt_total_condicao_pagamento') or 0) - (context.get('valor_desconto') or 0)
        return res

    def wizbtp_onchange_forma_pagamento(self, cr, uid, ids, forma_pgto_id, total_liquido_pagar=None,
                                        context=None):
        context = context and context.copy() or {}
        res = {'value': {'wizbtp_condicao_id': False}}

        if not forma_pgto_id:
            return res

        condicao_ids = self.pool.get('adm.condicao.forma').search(
            cr, uid, [('forma_pagamento_id', '=', forma_pgto_id)], context=context)

        if len(condicao_ids) == 1:
            res['value'] = {'wizbtp_condicao_id': condicao_ids[0]}

        # Condicao de pagamento
        if self.pool.get('adm.forma.pgto').admfpg_forma_pgto_tipo_cheque(
                cr, uid, forma_pgto_id, context):
            if total_liquido_pagar > 0.0:
                warning={'title':  _('Atencao!'),
                         'message': _('Esta forma de pagamento nao pode ser usada para pagar titulos!')}
                res['warning']= warning
                res['value']['wizbtp_forma_pgto_id'] = ''
            else:
                res['value']['wizbtp_forma_pgto_tipo'] = CHEQUE
        elif self.pool.get('adm.forma.pgto').admfpg_forma_pgto_tipo_cartao(
                cr, uid, forma_pgto_id, context):
            res['value']['wizbtp_forma_pgto_tipo'] = CARTAO
        else:
            res['value']['wizbtp_forma_pgto_tipo'] = OUTROS

        return res

    def wizbtp_onchange_condicao(self, cr, user, ids, forma, condicao, valor, context=None):
        """
        Atribui a condicao de pagamento "a vista" ou a prazo. Se a forma de pagamento for cheque e
        a condicao a prazo, atualiza o vencimento do cheque, ou seja, "bom para" na data de hoje
        acrescida dos dias da primeira parcela.

        :param cr: o cursor do banco de dados
        :param user: ID do usuario utilizado para a verificacao de perfil
        :param ids: lista com o ID do formulario
        :param forma: tipo da forma de pagamento: ´cheque´, ´cartao´ ou ´outros´
        :param condicao: ID da condicao de pagamento
        :param context: um dicionario padrao para valores contextuais
        :type cr: object
        :type user: int
        :type ids: list
        :type forma: str
        :type condicao: long
        :type context: dict
        :return: dicionario com o valor do tipo da condicao: "a vista" (V) ou a prazo (P)
        :rtype: dict

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}
        obj_adm_utils = self.pool.get('adm.utils')
        brw_condicao =  condicao and self.pool.get('adm.condicao.forma').browse(cr, user, condicao,
                                                                  context).adm_condicao_id or False
        tipo = 'V' if brw_condicao and brw_condicao.tipo == 'V' else 'P'

        if forma == 'cheque' and tipo == 'P' and condicao:
            bom_para = (date.today() + timedelta(days=self.pool.get('adm.condicao.forma').browse(
                cr, user, condicao, context).adm_condicao_id.dias_primeira_parcela or 0)).__str__()
        else:
            bom_para = None

        vals = dict(wizbtp_condicao_pgto_tipo=tipo, wizbtp_cheque_bom_para=bom_para)
        if tipo == 'P' and brw_condicao and brw_condicao.qtde_parcelas:
            parcelas = []
            elementos = [[i, 0] for i in range(0, brw_condicao.qtde_parcelas)]
            data = (datetime.now() + timedelta(days=brw_condicao.dias_primeira_parcela or 0)).date()
            obj_adm_utils.efetuar_rateio(valor, elementos=elementos)
            for i in elementos:
                parcelas.append([0, False, {'wizbpa_vr_parcela': i[1],
                                            'wizbpa_data_vencimento': '%s' % data
                                            }
                                 ])
                data += timedelta(days=brw_condicao.dias_incremento)

            vals['wizbtp_parcelas_ids'] = parcelas
        else:
            vals['wizbtp_parcelas_ids'] = []

        return dict(value=vals)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
