# -*- coding: utf-8 -*-

from openerp.osv import fields, osv
from openerp.tools.translate import _
from SigUtils.boleto import boleto
from SigUtils.numero import getNumeroEditado
from SigUtils import datas
import time
from dateutil.parser import parse


class wizard_gerar_boleto_titulo(osv.TransientModel):
    def _fintit_get_documento(self, cr, uid, context=None):
        context = context and context.copy() or {}
        return context.get('numero_documento')

    _name = 'wizard.gerar.boleto.titulo'
    _description = 'Gerar Boleto do Titulo'
    _inicio = True

    def wgb_onchange_data_vencimento(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        dados = self.read(cr, uid, ids, [], context=context)
        res = {}
        if not self._inicio:
            res['value'] = {'wgb_vr_total': 0}
        self._inicio = False
        return res

    def _get_wgb_local_cobranca_id(self, cr, uid, context=None):
        context = context and context.copy() or {}
        dados = context.get('dados')
        loc_cobranca = dados.get('wgb_local_cobranca_id') or ''
        return loc_cobranca

    def _get_wgb_natureza_cobranca_id(self, cr, uid, context=None):
        context = context and context.copy() or {}
        dados = context.get('dados')
        natureza_cobranca = dados.get('wgb_natureza_cobranca_id') or ''
        return natureza_cobranca

    def _get_wgb_nosso_numero(self, cr, uid, context=None):
        context = context and context.copy() or {}
        dados = context.get('dados')
        wgb_nosso_numero = dados.get('wgb_nosso_numero')
        return wgb_nosso_numero

    def _get_wgb_data_vencimento(self, cr, uid, context=None):
        context = context and context.copy() or {}
        dados = context.get('dados')
        wgb_data_vencimento = dados.get('wgb_data_vencimento')
        return wgb_data_vencimento

    def _get_wgb_novo_vencimento(self, cr, uid, context=None):
        context = context and context.copy() or {}
        _hoje = time.strftime("%Y-%m-%d")
        dados = context.get('dados')
        if not dados:
            return

        # ter dados.get('wgb_vr_original') significa que o boleto eh registrado e tem nosso numero
        # portanto nao pode alterar a data
        if dados.get('wgb_data_vencimento') > _hoje or dados.get('wgb_vr_original'):
            wgb_novo_vencimento = dados.get('wgb_data_vencimento')
        else:
            wgb_novo_vencimento = _hoje

        return wgb_novo_vencimento

    def _get_wgb_vr_original(self, cr, uid, context=None):
        context = context and context.copy() or {}
        dados = context.get('dados')
        wgb_vr_original = dados.get('wgb_vr_original')
        return wgb_vr_original

    def _get_wgb_vr_total(self, cr, uid, context=None):
        context = context and context.copy() or {}
        dados = context.get('dados')
        wgb_vr_total = dados.get('wgb_vr_total')
        self._inicio = True
        return wgb_vr_total

    def _get_wgb_vr_juros_dia(self, cr, uid, context=None):
        context = context and context.copy() or {}
        dados = context.get('dados')
        wgb_vr_juros_dia = dados.get('wgb_vr_juros_dia')
        return wgb_vr_juros_dia

    def _get_wgb_vr_multa(self, cr, uid, context=None):
        context = context and context.copy() or {}
        dados = context.get('dados')
        wgb_vr_multa = dados.get('wgb_vr_multa')
        return wgb_vr_multa


    def _get_wgb_vr_desconto(self, cr, uid, context=None):
        context = context and context.copy() or {}
        dados = context.get('dados')
        wgb_vr_desconto = dados.get('wgb_vr_desconto')
        return wgb_vr_desconto

    def _get_wgb_multa_apos(self, cr, uid, context=None):
        context = context and context.copy() or {}
        dados = context.get('dados')
        if not dados:
            return
        wgb_multa_apos = dados.get('multa_apos')
        return wgb_multa_apos

    def _get_wgb_limite_desconto(self, cr, uid, context=None):
        context = context and context.copy() or {}
        dados = context.get('dados')
        if not dados:
            return
        wgb_limite_desconto = dados.get('limite_desconto')
        return wgb_limite_desconto

    def _wgb_get_par_observacoes(self, cr, uid, context=None):
        context = context and context.copy() or {}
        obs = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'financeiro.parametros', 'finpar_mensagem_boleto')
        if not obs:
            obs = ''
        if isinstance(obs, dict):
            obs = obs.get('finpar_mensagem_boleto')
        return obs
    _columns = {
        'wgb_local_cobranca_id': fields.many2one("financeiro.local.cobranca", 'Local cobranca', ondelete="restrict",
                                             required=True, readonly=True),
        'wgb_natureza_cobranca_id': fields.many2one("financeiro.natureza.cobranca", 'Natureza cobranca',
                                                ondelete="restrict", readonly=True),
        'wgb_nosso_numero': fields.char('Nosso numero', size=20, readonly=True),
        'wgb_data_vencimento': fields.date('Vencimento', required=True, readonly=True),
        'wgb_vr_original': fields.float('Valor original', digits=(15, 2), required=True),
        'wgb_vr_juros_dia': fields.float('Valor juros p/dia', digits=(15, 4)), # Valor dos juros por dia de atraso
        'wgb_vr_multa': fields.float('Valor multa', digits=(15, 2)), # Valor da multa pelo atraso
        'wgb_vr_desconto': fields.float('Vr desconto', digits=(15, 2)), # Valor do desconto
        'wgb_novo_vencimento': fields.date('Novo vencimento', required=True),
        'wgb_multa_apos': fields.date('Multa apos'),
        'wgb_limite_desconto': fields.date('Limite desconto'),
        'wgb_vr_total': fields.float('Valor total', digits=(15, 2), readonly=True),
        'wgb_arquivo_ids': fields.one2many('wizard.gerar.boleto.arquivo',
                                           'wizgba_gerar_boleto_titulo_id', 'Arquivos'),
        'wgb_observacoes': fields.text('Observacoes', help='As observacoes descritas aqui serao '
                                                             'impressas no boleto'),
    }

    _defaults = {
        'wgb_local_cobranca_id': _get_wgb_local_cobranca_id,
        'wgb_natureza_cobranca_id': _get_wgb_natureza_cobranca_id,
        'wgb_nosso_numero': _get_wgb_nosso_numero,
        'wgb_data_vencimento': _get_wgb_data_vencimento,
        'wgb_vr_original': _get_wgb_vr_original,
        'wgb_vr_juros_dia': _get_wgb_vr_juros_dia,
        'wgb_vr_multa': _get_wgb_vr_multa,
        'wgb_vr_desconto': _get_wgb_vr_desconto,
        'wgb_multa_apos': _get_wgb_multa_apos,
        'wgb_limite_desconto': _get_wgb_limite_desconto,
        'wgb_novo_vencimento': _get_wgb_novo_vencimento,
        'wgb_vr_total': _get_wgb_vr_total,
        'wgb_observacoes': _wgb_get_par_observacoes
    }



    def wgb_button_calcular(self, cr, uid, ids, context=None):

        """
        Calcular valor total do titulo
        @return: True
        """
        context = context and context.copy() or {}
        for dados in self.browse(cr, uid, ids):
            valor_original = dados.wgb_vr_original
            juros_dia = dados.wgb_vr_juros_dia
            multa_apos = dados.wgb_multa_apos
            data_vencimento = dados.wgb_data_vencimento
            novo_vencimento = dados.wgb_novo_vencimento
            if novo_vencimento < data_vencimento:
                raise osv.except_osv(_('Atencao!'),
                                     _("Novo vencimento nao pode ser anterior ao vencimento original!"))

            multa = 0.0
            if multa_apos and multa_apos < novo_vencimento:
                    multa = dados.wgb_vr_multa
            elif data_vencimento < novo_vencimento:
                multa = dados.wgb_vr_multa
            limite_desconto = dados.wgb_limite_desconto
            desconto = dados.wgb_vr_desconto
            if limite_desconto and limite_desconto < novo_vencimento:
                desconto = 0.0
            elif data_vencimento < novo_vencimento:
                desconto = 0.0
            _dias = 0
            if novo_vencimento > data_vencimento:
                _dias = datas.calcDiferenca(data_vencimento, novo_vencimento)
            juros_total = _dias * juros_dia
            valor_total = valor_original + juros_total + multa - desconto
            self.write(cr, uid, ids, {'wgb_vr_total': valor_total}, context)

        reference = self.pool.get('ir.model.data').get_object_reference(
            cr, uid, 'financeiro', 'view_gerar_boleto_titulo_form')
        view_id = reference and reference[1] or False

        return {
            'view_type': 'form',
            'view_mode': 'form',
            'res_id': ids[0],
            'res_model': 'wizard.gerar.boleto.titulo',
            'view_id': [view_id],
            'type': 'ir.actions.act_window',
            'target': 'new',
            'context': context
        }

    def wgb_button_imprimir(self, cr, uid, ids, context=None):

        """
        Realiza a impressao dos boletos
        @return: True
        """

        context = context and context.copy() or {}
        context['wizard_gerar_boleto_titulo'] = ids[0]
        obj_financeiro_util = self.pool.get('financeiro')
        wizard_gerar_boleto = self.pool.get('wizard.gerar.boleto')
        obj_financeiro_titulo = self.pool.get('financeiro.titulo')
        obj_financeiro_titulo_boleto = self.pool.get('financeiro.titulo.boleto')
        obj_local_natureza = self.pool.get('financeiro.local.natureza')
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'financeiro.titulo', context=context)
        self.write(cr, uid, ids, vals={}, context=context)
        brw_wizard_gerar_boleto = self.browse(cr, uid, ids, context=context)
        for capa in brw_wizard_gerar_boleto:
            local_cobranca_id = capa.wgb_local_cobranca_id.id
            nat_id = capa.wgb_natureza_cobranca_id.id
            _loc_nat_id = obj_local_natureza.search(cr, uid, [
                ('finlon_local_cobranca_id', '=', local_cobranca_id),
                ('finlon_natureza_cobranca_id', '=', nat_id)])
            if not _loc_nat_id:
                raise osv.except_osv(_('Atencao!'),
                                     _("Nao ha Local e Natureza cadastrado para o local de cobranca "
                                       "e natureza de cobranca deste titulo!"))
            # Titulos
            item_id = context.get('active_ids')
            nosso_numero_informado = obj_local_natureza.finlon_get_set_nosso_numero(cr, uid, item_id,
                                                                                    _loc_nat_id[0], context=context)
            if nosso_numero_informado == False:
                raise osv.except_osv(_('Atencao!'),
                                     _("Nao ha Local e Natureza cadastrado para o local de cobranca "
                                       "e natureza de cobranca deste titulo!"))

            brw_item = self.pool.get('financeiro.titulo').browse(cr, uid, item_id)
            via_impressora = False
            impressora = ''
            gerar_separado = False
            imprimir = 'arquivo'
            if via_impressora and impressora:
                imprimir = impressora
            # Instancia de boleto
            arq1_boleto = arq_boleto = boleto.Boleto()
            for item in brw_item:
                # Trabalhando com a observacao do boleto
                lista_observacoes = []
                _multa = item.vr_multa
                _juros = item.vr_juros_dia
                _desconto = item.vr_desconto
                data_vencimento = capa.wgb_data_vencimento
                novo_vencimento = capa.wgb_novo_vencimento
                if _multa and novo_vencimento == data_vencimento:
                    _multa = getNumeroEditado(_multa, decimals=2, dec_point=',')
                    _obs = "MULTA DE R$ %s " % _multa
                    if item.multa_apos_data:
                        _data_multa = time.strptime(item.multa_apos_data, '%Y-%m-%d')
                        _data_multa = time.strftime('%d/%m/%Y', _data_multa)
                        _obs += " APOS %s" % _data_multa
                    lista_observacoes.append(_obs)

                if _juros:
                    _juros = getNumeroEditado(_juros, decimals=2, dec_point=',')
                    _obs = "JUROS DE R$ %s   AO DIA." % _juros
                    lista_observacoes.append(_obs)
                if _desconto:
                    _desconto = getNumeroEditado(_desconto, decimals=2, dec_point=',')
                    _data_limite_desconto = item.data_limite_desconto
                    if all([_desconto, _data_limite_desconto]):
                        _data_limite_desconto = time.strptime(_data_limite_desconto, '%Y-%m-%d')
                        _data_limite_desconto = time.strftime('%d/%m/%Y', _data_limite_desconto)
                        _obs = "DESCONTO DE R$%s    ATE %s." % (_desconto, _data_limite_desconto)
                    else:
                        _obs = "DESCONTO DE R$%s    ATE VENCIMENTO." % _desconto
                    lista_observacoes.append(_obs)
                    lista_observacoes.append(" ")
                if capa.wgb_observacoes:
                    _obs = obj_financeiro_util.finutl_formata_observacao(67, capa.wgb_observacoes)
                    lista_observacoes += map(None, _obs)
                imprimir_obs_tit = self.get_imprimir_inf_titulo(cr, uid)
                if item.observacoes:
                    if imprimir_obs_tit:
                        _obs = obj_financeiro_util.finutl_formata_observacao(67, item.observacoes)
                        lista_observacoes += map(None, _obs)
                # Instancia com os dados do boleto
                vals =  {
                        'wizgbo_bol_banco_id': local_cobranca_id,
                        'wizgbo_bol_natureza_cobranca_id': capa.wgb_natureza_cobranca_id.id,
                        'wizgbo_modelo': 'B',
                        'wizgbo_nosso_numero': nosso_numero_informado,
                }
                wgb_id = self.pool.get('wizard.gerar.boleto').create(cr, uid, vals, context)
                vals = {
                        'wizgbi_gerar_boleto_id': wgb_id,
                        'wizgbi_pessoa_id': item.pessoa_id.id,
                        'wizgbi_titulo_id': item.id,
                }
                vals['wizgbi_data_prorrogacao'] = capa.wgb_novo_vencimento
                vals['wizgbi_vr_original'] = capa.wgb_vr_total
                wgb_item_id = self.pool.get('wizard.gerar.boleto.item').create(cr, uid, vals, context)
                brw_wgb_item = self.pool.get('wizard.gerar.boleto.item').browse(cr, uid, wgb_item_id)
                context['titulo_vencido'] = True
                arq1_boleto = arq_boleto = wizard_gerar_boleto._wizgbo_gerar_boleto(
                    cr, uid, arq_boleto, brw_wgb_item, imprimir, company_id, gerar_separado,
                    nosso_numero_informado, lista_observacoes, context)
                titulo_id = item.id
                banco_id = capa.wgb_local_cobranca_id.finloc_banco_id.id
                if not banco_id:
                    raise osv.except_osv(_('Atencao!'),
                                         _("Este local de cobrancao nao e do tipo 'Banco'!"))
                # Gera o boleto separado (1 por arquivo)
                if gerar_separado:
                    arq_boleto.gerarBoleto()
                    codigo_barras = arq_boleto.titulo.codigoBarras or ''
                    wizard_gerar_boleto._wizgbo_inclui_titulo_boleto(
                        cr, uid, [titulo_id], nosso_numero_informado, local_cobranca_id,
                        codigo_barras, gerar_separado, context)
                if gerar_separado and imprimir == 'arquivo':
                    # inserir na tabela wizard_gerar_boleto_arquivo se impressao for do tipo
                    # arquivo
                    impressao = arq_boleto.cedente.impressora
                    wizard_gerar_boleto._wizgbo_criar_arquivo_download(cr, uid, capa.id, impressao, context)

                # Registrar titulo para o banco informado
                #nosso_numero_completo = arq_boleto.nossoNumeroCompleto
                #Testado para a CEF, não registra nosso numero completo, porque no retorno não é ele que vem
                wizard_gerar_boleto._wizgbo_registrar_titulo(cr, uid, titulo_id, local_cobranca_id, nat_id,
                                              nosso_numero_informado, context)

            # Gera os boletos (todos em um arquivo)
            if not gerar_separado and arq1_boleto:
                arq1_boleto.gerarBoleto()
                for bol in arq1_boleto._Boleto__titulos:
                    titulo_boleto_ids = obj_financeiro_titulo_boleto.search(
                        cr, uid, [('fintib_nosso_numero', '=', bol.nossoNroSeq)], context=context)
                    titulo_ids = map(lambda i: i.fintib_titulo_id.id,
                                     obj_financeiro_titulo_boleto.browse(cr, uid, titulo_boleto_ids,
                                                                         context))
                    args = [('documento', '=', bol.documento),
                            ('data_emissao', '=', bol.emissao[6:] + '-' + bol.emissao[3:5] + '-' +
                             bol.emissao[:2])]
                    if titulo_ids:
                        args.append(('id', 'in', titulo_ids))
                    titulo_ids = obj_financeiro_titulo.search(cr, uid, args, context=context)
                    if titulo_ids:
                        wizard_gerar_boleto._wizgbo_inclui_titulo_boleto(
                            cr, uid, titulo_ids, bol.nossoNroSeq, local_cobranca_id,
                            bol.codigoBarras or '', gerar_separado, context=context)

            # inserir na tabela wizard_gerar_boleto_arquivo se impressao for do tipo arquivo
            if imprimir == 'arquivo' and not gerar_separado:
                impressao = arq_boleto.cedente.impressora
                wizard_gerar_boleto._wizgbo_criar_arquivo_download(cr, uid, wgb_id, impressao, context=context)

        reference = self.pool.get('ir.model.data').get_object_reference(
            cr, uid, 'financeiro', 'view_gerar_boleto_titulo_form')
        view_id = reference and reference[1] or False

        return {
            'view_type': 'form',
            'view_mode': 'form',
            'res_id': ids[0],
            'res_model': 'wizard.gerar.boleto.titulo',
            'view_id': [view_id],
            'type': 'ir.actions.act_window',
            'target': 'new',
            'context': context
        }

    def get_imprimir_inf_titulo(self, cr, uid):
        obj_adm_utils = self.pool.get('adm.utils')
        field_parametro_imprimir = ['finpar_imprimir_informacoes_titulo_boleto']
        imprimir_inf_tit = obj_adm_utils.admutl_get_parametros(cr, uid, 'financeiro',
                                                               field_parametro_imprimir)
        if imprimir_inf_tit:
            if imprimir_inf_tit.get('finpar_imprimir_informacoes_titulo_boleto'):
                return True
        return False
