# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler
import time
from openerp.tools.translate import _
from SigUtils import datas


class financeiro_tesouraria_contas(osv.Model):

    _inherit = 'financeiro.tesouraria.contas'

    def fintco_btn_filtrar(self, cr, uid, ids, context=None):
        return True

    def fintco_btn_conciliar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not ids:
            return True
        dados_contas = self.read(cr, uid, ids[0], context=context)
        obj_mov_tes = self.pool.get('financeiro.tesouraria.movimento')
        obj_mov_imp = self.pool.get('fincon.arq.importado.corpo')

        # ler movimento da tesouraria
        args =[('conta_id', '=', dados_contas.get('id')),('fintem_fincon_conciliar', '=', True)]
        _mov_tes_ids = obj_mov_tes.search(cr, uid, args, context=context)
        if not _mov_tes_ids:
            return True
        _total_mov_tes = _total_mov_imp = 0
        for dados_mov_tes in obj_mov_tes.read(cr, uid, _mov_tes_ids, [], context=context):
            if dados_mov_tes.get('debito_credito') == 'D':
                _total_mov_tes -= dados_mov_tes.get('valor')
            else:
                _total_mov_tes += dados_mov_tes.get('valor')

        # Ler movimento importado
        args =[('finconaio_conta_id', '=', dados_contas.get('id')),('finconaio_conciliar', '=', True)]
        _mov_imp_ids = obj_mov_imp.search(cr, uid, args, context=context)
        for dados_mov_imp in obj_mov_imp.read(cr, uid, _mov_imp_ids, [], context=context):
            _total_mov_imp += dados_mov_imp.get('finconaio_valor')
        if _total_mov_tes != _total_mov_imp:
            raise osv.except_osv(_('Atencao!'),
                                 _('Não posso conciliar, valores diferem!'))
        vals = {
            'conciliado': True,
            'fintem_fincon_conciliado': True,
            'fintem_fincon_conciliar': False,
        }
        obj_mov_tes.write(cr, uid, _mov_tes_ids, vals, context=context)
        self.pool.get('financeiro.tesouraria.contas').fintco_atualizar_saldo_conciliado(
            cr, uid, dados_contas.get('id'), dados_mov_tes.get('valor'), dados_mov_tes.get('debito_credito'))
        vals = {
            'finconaio_status': 'C',
            'finconaio_conciliar': False,
        }
        obj_mov_imp.write(cr,uid, _mov_imp_ids, vals, context=context)
        return True

    def fintco_btn_conciliacao_automatica(self, cr, uid, ids, context=None):
        def __fintco_conciliar():
            context['conciliado'] = True # Para não checar custificacao
            obj_mov_tes.write(cr, uid, _mov_tes_id, {'conciliado': True, 'fintem_fincon_conciliado': True},
                              context=context)
            obj_mov_tes.write(cr, uid, _mov_imp_id, {'finconaio_status': 'C', 'finconaio_lanc_tes_ids': ()},
                              context=context)
            pass
        context = context and context.copy() or {}
        if not ids:
            return True
        dados_contas = self.read(cr, uid, ids[0], context=context)
        obj_mov_tes = self.pool.get('financeiro.tesouraria.movimento')
        obj_mov_imp = self.pool.get('fincon.arq.importado.corpo')

        # Ler movimento da tesouraria
        args =[('conta_id', '=', dados_contas.get('id')),('fintem_fincon_conciliado', '=', False)]
        _mov_tes_ids = obj_mov_tes.search(cr, uid, args, context=context)
        _total_mov_tes = _total_mov_imp = 0
        dados_mov_tes = obj_mov_tes.read(cr, uid, _mov_tes_ids, ['data_movimento','valor','debito_credito'], context=context)
        _tam_mov_tes = len(dados_mov_tes)

        # Ler movimento importado
        args =[('finconaio_conta_id', '=', dados_contas.get('id')),('finconaio_status', '=', 'A')]
        _mov_imp_ids = obj_mov_imp.search(cr, uid, args, context=context)
        dados_mov_imp = obj_mov_imp.read(cr, uid, _mov_imp_ids, ['finconaio_valor','finconaio_data',''], context=context)
        _tam_mov_imp = len(dados_mov_imp)
        if _tam_mov_tes > _tam_mov_imp:
            for _mov_tes in dados_mov_tes:
                _dt_ini = datas.getDataNoFormato(datas.calcVencimento(_mov_tes.get('data_movimento'), -7), 'I', '-')
                _dt_fim = datas.getDataNoFormato(datas.calcVencimento(_mov_tes.get('data_movimento'), 7), 'I', '-')
                _valor = _mov_tes.get('valor')
                _mov_tes_id = _mov_tes.get('id')
                if _mov_tes.get('debito_credito') == 'D':
                    _valor = _valor * -1
                for _mov_imp in dados_mov_imp:
                    _mov_imp_id = _mov_imp.get('id')
                    if _mov_imp.get('finconaio_status') != 'C' and \
                            _mov_imp.get('finconaio_valor') == _valor and \
                            _mov_imp.get('finconaio_data') > _dt_ini and  \
                            _mov_imp.get('finconaio_data') < _dt_fim:
                        vals = {'conciliado': True, 'fintem_fincon_conciliado':True, 'fintem_fincon_conciliar': False}
                        obj_mov_tes.write(cr, uid, [_mov_tes_id], vals, context=context)
                        self.pool.get('financeiro.tesouraria.contas').fintco_atualizar_saldo_conciliado(
                            cr, uid, dados_contas.get('id'), _valor, _mov_tes.get('debito_credito'))
                        vals = {'finconaio_status':'C', 'finconaio_conciliar':False}
                        obj_mov_imp.write(cr, uid, [_mov_imp_id], vals, context=context)
                        _mov_imp['finconaio_status'] = 'C'
                        break
        else:
            for _mov_imp in dados_mov_imp:
                _dt_ini = datas.getDataNoFormato(datas.calcVencimento(_mov_imp.get('finconaio_data')[:10], -7), 'I', '-')
                _dt_fim = datas.getDataNoFormato(datas.calcVencimento(_mov_imp.get('finconaio_data')[:10], 7), 'I', '-')
                _mov_imp_id = _mov_imp.get('id')
                for _mov_tes in dados_mov_tes:
                    _mov_tes_id = _mov_tes.get('id')
                    _valor = _mov_tes.get('valor')
                    if _mov_tes.get('debito_credito') == 'D':
                        _valor = _valor * -1
                    if not _mov_tes.get('fintem_fincon_conciliado') and \
                            _mov_imp.get('finconaio_valor') == _valor and \
                            _mov_tes.get('data_movimento') > _dt_ini and  \
                            _mov_tes.get('data_movimento') < _dt_fim:
                        vals = {'conciliado': True, 'fintem_fincon_conciliado':True, 'fintem_fincon_conciliar': False}
                        obj_mov_tes.write(cr, uid, [_mov_tes_id], vals, context=context)
                        self.pool.get('financeiro.tesouraria.contas').fintco_atualizar_saldo_conciliado(
                            cr, uid, dados_contas.get('id'), _valor, _mov_tes.get('debito_credito'))
                        vals = {'finconaio_status':'C', 'finconaio_conciliar':False}
                        obj_mov_imp.write(cr, uid, [_mov_imp_id], vals, context=context)
                        _mov_tes['fintem_fincon_conciliado'] = True
                        break
