# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler
import time


class fincon_arq_importado_capa(osv.Model):
    """
    Tabela contendo os arquivos importados
    prefixo: finconaia_
    """
    from funcoes import _finconaia_get_dados

    _name = 'fincon.arq.importado.capa'
    _gerar_logs_logs = 'N'
    _columns = {
        'id': fields.integer('Controle'),
        'finconaia_data': fields.date('Data de importacao', require=True, select=1),
        'finconaia_conta_id': fields.many2one("financeiro.tesouraria.contas", "Conta", ondelete="cascade",
                                        domain=[('banco_caixa', '=', 'B')], select=1),
        'finconaia_status': fields.function(_finconaia_get_dados, method=True, string='Situacao', type='selection',
                                            store=False,selection=[('A', 'A conciliar'), ('C', 'Conciliado'),
                                                                   ('E', 'Em conciliacao')], size=1, multi='dados'),
        'finconaia_linha_ids': fields.one2many('fincon.arq.importado.corpo', 'finconaio_capa_id', 'Linhas'),
    }
    _order = 'finconaia_conta_id,finconaia_data,id'

