# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class fincon_arq_importado_corpo(osv.Model):
    """
    Tabela contendo os arquivos importados
    prefixo: finconaio_
    """

    _name = 'fincon.arq.importado.corpo'
    _gerar_logs_logs = 'N'
    _columns = {
        'finconaio_capa_id': fields.many2one('fincon.arq.importado.capa', 'Capa', ondelete='cascade', select=1),
        'finconaio_conta_id': fields.many2one("financeiro.tesouraria.contas", "Conta", ondelete="cascade", select=1),
        'finconaio_data': fields.datetime('Data do lancamento', require=True, select=1),
        'finconaio_historico': fields.char("Historico", size=40),
        'finconaio_cod_doc': fields.char('Codigo documento', char=20, select=1),
        'finconaio_valor': fields.float('Valor lancamento', digits=(9, 2), required=True),
        'finconaio_saldo': fields.float('Saldo', digits=(9, 2), required=True),
        'finconaio_lanc_tes_ids': fields.many2many('financeiro.tesouraria.movimento', 'finconaio_m2m_corpo_lancamento',
                                                   'finconaio_corpo_id', 'finconaio_lanc_id', 'Lancamentos'),
        'finconaio_status': fields.selection([('A', 'A conciliar'), ('C', 'Conciliado')], 'Situacao', size=1),
        'finconaio_conciliar': fields.boolean('Conciliar', select=1),
    }
    _defaults = {
        'finconaio_status': 'A',
        'finconaio_conciliar': False,
    }
