# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class fincon_controle(osv.Model):
    """
    Tabela de controle associando a conta da tesouraria ao extrato importado
    """
    _name = 'fincon.controle'
    _columns = {
        'finconct_conta_id': fields.many2one("financeiro.tesouraria.contas", 'Conta', ondelete="cascade", select=True),
        'create_date': fields.datetime('Data da importacao', readonly=True),
        'create_uid': fields.many2one("res.users", 'Usuario que importou', readonly=True, select=True),
        'finconct_extrato_ids': fields.one2many('fincon.extrato','finconext_controle_id',)
    }
    _order = 'finconct_conta_id,create_date desc'
