# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class fincon_extrato(osv.Model):
    """
    Tabela de extrato importado
    """
    _name = 'fincon.extrato'
    _inherits =  {'fincon.controle':'finconex_controle_id'}
    _columns = {
        'finconex_controle_id': fields.many2one('fincon.controle', 'Controle', required=True, ondelete='cascade',
                                                select=True),
        'finconex_data_lancamento': fields.date('Data lancamento', required=True, select=True),
        'finconex_sequencia': fields.integer('Ordem'),
        'finconex_historico': fields.char("Historico", size=64),
        'finconex_valor': fields.float('Valor', digits=(9,2), required=True),
        'finconex_mov_deb_cre': fields.selection([('D', 'Debito'), ('C', 'Credito')], 'Mov. a Debito/Credito', required=True,
                                           size=1),
        'finconex_saldo': fields.float('Saldo', digits=(9,2), required=True),
        'finconex_saldo_deb_cre': fields.selection([('D', 'Debito'), ('C', 'Credito')], 'Saldo Devedor/Credor', required=True,
                                           size=1),
        'finconex_situacao': fields.boolean('Conciliado'),
        'finconex_mov_tesouraria_ids': fields.many2many('financeiro.tesouraria.movimento',
                                                        'finconex_extrato_movtes_m2m',
                                                        'finconex_extrato_id',
                                                        'finconex_movtes_id',
                                                        'Movimentos'),
    }
    _order = 'finconex_conta_id,finconex_data_lancamento,finconex_sequencia'
