# -*- coding: utf-8 -*-
from openerp.osv import fields, osv
from datetime import date, datetime
import base64
import xlrd
from SigUtils.sigerp import db_sig

class fincon_import_file_osv(osv.Model):

    _name = "fincon.import.file.osv"
    _description = "Importacao de arquivos do Mercado Pago"
    _rec_name = 'xml_file'
    _transient = False
    _gerar_logs_logs = 'N'
    _columns = {
        'xml_file': fields.binary('Arquivo MP', filters='*.xml',
                                  filename='MercadoPago File'),
        'conta_id': fields.many2one("financeiro.tesouraria.contas", 'Conta', ondelete="cascade", required=True),
        'xml_proc': fields.text('Xml'),
        'status': fields.selection([('A', 'A importar'), ('I', 'Importado')], string='Status', size=1),
    }

    _defaults = {
        'status': 'A',
    }

    def create(self, cr, uid, vals, context=None):
        _id = super(fincon_import_file_osv, self).create(cr, uid, vals, context)
        if not vals.get('xml_file'):
            return _id
        self.upload_xml(cr, uid, _id, context)
        return _id

    def button_upload_xml(self, cr, user, ids, context=None):
        """
        Realiza a carga do arquivo XML

        :param cr: o cursor do banco de dados
        :param user: o ID do usuario utilizado para a verificacao de perfil
        :param ids: lista com o ID do formulario
        :param context: um dicionario padrao para valores contextuais
        :type cr: object
        :type user: int
        :type ids: list
        :type context: dict
        :return: verdadeiro se a carga do arquivo XML foi realizada com sucesso
        :rtype: bool
        """

        return True

    def upload_xml(self, cr, uid, ids, context=None):
        """
        Realiza a carga (upload) do arquivo XML atribuindo os valores das ´tag´ aos respectivos
        valores da nota fiscal.

        :param cr: o cursor do banco de dados
        :param uid: o ID do usuario utilizado para a verificacao de perfil
        :param ids: lista com o ID do formulario
        :param context: um dicionario padrao para valores contextuais
        :type cr: object
        :type uid: int
        :type ids: list
        :type context: dict
        :return: verdadeiro se a carga do arquivo XML foi realizada com sucesso
        :rtype: bool
        """
        context = context and context.copy() or {}

        _dados = self.read(cr, uid, ids[0] if isinstance(ids, list) else ids, [], context, '_classic_write')
        xls = _dados.get('xml_file')
        file_decode = base64.decodestring(xls)
        tmp_file = ('/tmp/' + str(datetime.now())).replace(' ', '_')

        f = open(tmp_file, 'w')
        f.write(file_decode)
        f.close()
        wb = xlrd.open_workbook(tmp_file)
        ws = wb.sheet_by_index(0)
        lin = 0
        _capa_id = False
        _dt_hoje = str(datetime.now())[:10]
        _db_sig = db_sig(self.pool.db_name)
        while True:
            lin += 1
            print lin
            try:
                _data = ws.cell_value(lin, 0)[:10]
            except:
                break

            _histo = ws.cell_value(lin, 1)
            _doc = str(int(ws.cell_value(lin,2)))
            _oper_rel = str(int(ws.cell_value(lin,3)))
            _valor = float(ws.cell_value(lin, 4))
            _saldo = float(ws.cell_value(lin, 5))
            args = [('finconaio_data', '=', ws.cell_value(lin, 0)),
                    ('finconaio_cod_doc', '=', _doc),
                    ('finconaio_conta_id', '=',  _dados.get('conta_id'))]

            _lanc_ids = _db_sig.dbsSelect('fincon_arq_importado_corpo', ['id'], args)
            if _lanc_ids:
                continue
            if not _capa_id:
                vals = {
                    'finconaia_data': _dt_hoje,
                    'finconaia_conta_id': _dados.get('conta_id'),
                }
                _capa_id = _db_sig.dbsInsert('fincon_arq_importado_capa', vals)
            vals = {
                'finconaio_capa_id': _capa_id,
                'finconaio_conta_id': _dados.get('conta_id'),
                'finconaio_data': ws.cell_value(lin, 0),
                'finconaio_historico': _histo,
                'finconaio_cod_doc': _doc,
                'finconaio_cod_oper_relacionada': _oper_rel,
                'finconaio_valor': _valor,
                'finconaio_saldo': _saldo,
                'finconaio_status': 'A',
                'finconaio_conciliar': False,
            }
            _corpo_id = _db_sig.dbsInsert('fincon_arq_importado_corpo', vals)
        _db_sig.conexao.commit()
        _db_sig.conexao.close()
        return self.write(cr, uid, ids, {'status': 'I'}, context)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
