# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from decimal import Decimal
import time
from datetime import datetime, timedelta
from SigUtils.numero import getNumeroEditado
from SigUtils.formatastring import unicode_to_ascii, formataString
from SigUtils.calcDigito import baseModulo
from SigUtils import boleto
from SigUtils import cnab as cnabUtils
from openerp.tools.translate import _
from dateutil.parser import parse


class cnab_cnab(osv.TransientModel):
    # prefixo = 'cnbcnb_

    _name = "cnab.cnab"

    def cnbcnb_get_data_from_dict(self, cr, uid, cobranca_magnetica_id, local_natureza_id, context=None):
        def _get_nosso_numero_sicredi():
            # Emissao do boleto pelo banco
            _nn = _nn_compl = '000000000'
            _nn_dv = '0'
            _nossoNumeroNovo = False
            # Emissao do boleto pelo emitente
            if brw_local_natureza.finlon_boleto_emissao == '2':
                local_cobranca_id = brw_local_natureza.finlon_local_cobranca_id.id
                natureza_cobranca_id = brw_local_natureza.finlon_natureza_cobranca_id.id
                dados_boleto = obj_financeiro_titulo.fintit_get_dados_boleto(
                    cr, uid, [brw_titulo.titulo_id.id], local_cobranca_id=local_cobranca_id,
                    natureza_cobranca_id=natureza_cobranca_id, context=context)
                if dados_boleto.get(brw_titulo.titulo_id.id).get('fintit_boleto_nosso_numero'):
                    _nn = dados_boleto.get(brw_titulo.titulo_id.id).get(
                        'fintit_boleto_nosso_numero')
                    _nossoNumeroNovo = False
                else:
                    _nossoNumeroNovo = True
                    _nn = obj_financeiro_local_natureza.finlon_get_set_nosso_numero(
                        cr, uid, brw_titulo.titulo_id.id, local_natureza_id, context=context)
                _nn_c = str(_nn).zfill(5)[-5:]
                sequencia_dv = str(brw_local_natureza.finlon_agencia).zfill(4) \
                    + brw_local_natureza.finlon_agencia_dv.zfill(2) \
                    + brw_local_natureza.finlon_conta.zfill(5) \
                    + datetime.now().strftime('%y') \
                    + '0' \
                    + _nn_c
                _nn_compl = datetime.now().strftime('%y') + '2' + _nn_c
                constante = '98765432'
                while len(sequencia_dv) > len(constante):
                    constante += '98765432'
                constante = constante[-len(sequencia_dv):]
                i = 0
                soma = 0
                for n in sequencia_dv:
                    soma += int(n) * int(constante[i])
                    i += 1
                resto_mod_11 = soma % 11
                if resto_mod_11 in (0, 1):
                    digito_verificador = 0
                else:
                    digito_verificador = 11 - resto_mod_11
                _nn_dv = str(digito_verificador)
                _nn_compl = str(_nn_compl).zfill(8) + _nn_dv
            return _nn, _nn_compl, _nn_dv, _nossoNumeroNovo

        def _get_nosso_numero_sicoob():
            if brw_local_natureza.finlon_boleto_emissao == '2': #Emissao do boleto pelo emitente
                local_cobranca_id = brw_local_natureza.finlon_local_cobranca_id.id
                natureza_cobranca_id = brw_local_natureza.finlon_natureza_cobranca_id.id
                dados_boleto = obj_financeiro_titulo.fintit_get_dados_boleto(cr, uid, [brw_titulo.titulo_id.id],
                                                              local_cobranca_id=local_cobranca_id,
                                                              natureza_cobranca_id=natureza_cobranca_id, context=context)
                if dados_boleto.get(brw_titulo.titulo_id.id).get('fintit_boleto_nosso_numero'):
                    _nn = dados_boleto.get(brw_titulo.titulo_id.id).get('fintit_boleto_nosso_numero')
                    _nossoNumeroNovo = False
                else:
                    _nossoNumeroNovo = True
                    _nn = obj_financeiro_local_natureza.finlon_get_set_nosso_numero(cr, uid, brw_titulo.titulo_id.id,
                                                                                    local_natureza_id, context=context)
                codigo_cliente = str(brw_local_natureza.finlon_convenio or 0).zfill(10)
                _nn_c = str(_nn).zfill(7)[-7:]
                _nn_compl = str(brw_local_natureza.finlon_agencia).zfill(4) + codigo_cliente + _nn_c
                constante = '3197'
                while len(_nn_compl) > len(constante):
                    constante += '3197'
                constante = constante[:len(_nn_compl)]
                i = 0
                soma = 0
                for n in _nn_compl:
                    soma += int(n) * int(constante[i])
                    i += 1
                resto_mod_11 = soma % 11
                if resto_mod_11 in (0, 1):
                    digito_verificador = 0
                else:
                    digito_verificador = 11 - resto_mod_11
                _nn_dv = str(digito_verificador)
                parcela = str(brw_titulo.titulo_id.parcela or 1).zfill(2)[:2]
                _nn_compl = str(_nn).zfill(9) + _nn_dv
                _nn_compl += parcela  # Parcela
                _nn_compl += '01' # Modalidade 01 simples com registro 03 caucionada
                _nn_compl += '4' # 4= Formato a4 sem envelopamento
                _nn_compl += '     '
            else: # Emissao do boleto pelo banco
                _nn = _nn_compl = '000000000'
                _nn_dv = '0'
                _nossoNumeroNovo = False
            return _nn, _nn_compl, _nn_dv, _nossoNumeroNovo

        def _get_nosso_numero_itau():
            if carteira_numero in ('148', '149', '153', '108', '180', '280', '121', '221', '210', '150', '109', '110',
                                   '111', '168'):
                # Carteiras para cobrança direta enviar nosso numero, o banco não vai gerar
                local_cobranca_id = brw_local_natureza.finlon_local_cobranca_id.id
                natureza_cobranca_id = brw_local_natureza.finlon_natureza_cobranca_id.id
                dados_boleto = obj_financeiro_titulo.fintit_get_dados_boleto(cr, uid, [brw_titulo.titulo_id.id],
                                                            local_cobranca_id=local_cobranca_id,
                                                            natureza_cobranca_id=natureza_cobranca_id, context=context)
                if dados_boleto.get(brw_titulo.titulo_id.id).get('fintit_boleto_nosso_numero'):
                    _nn = dados_boleto.get(brw_titulo.titulo_id.id).get('fintit_boleto_nosso_numero')
                    _nossoNumeroNovo = False
                else:
                    _nossoNumeroNovo = True
                    _nn = obj_financeiro_local_natureza.finlon_get_set_nosso_numero(cr, uid, brw_titulo.titulo_id.id,
                                                                                    local_natureza_id, context=context)
                if carteira_numero in ('150', '168'):
                    _nn_compl = '%s%s' % (carteira_numero, str(_nn))
                else:
                    _nn_compl = '%s%s%s%s' % (
                    cedente_agencia, cedente_conta, carteira_numero, str(_nn).zfill(8))
                _nn_dv = baseModulo(_nn_compl, 12, Base=10, subResto='S', somaDigitos='S')
                _nn_dv = '0' if _nn_dv.__len__() > 1 else _nn_dv
            else:
                # Carteiras para cobrança escritural, enviar nosso numero zerado(o banco vai gerar o nosso numero)
                _nn = _nn_compl = '00000000'
                _nn_dv = '0'
                _nossoNumeroNovo = False
            return _nn, _nn_compl, _nn_dv, _nossoNumeroNovo

        def _get_nosso_numero_cef():
            # Carteiras para cobrança direta enviar nosso numero, o banco não vai gerar
            local_cobranca_id = brw_local_natureza.finlon_local_cobranca_id.id
            natureza_cobranca_id = brw_local_natureza.finlon_natureza_cobranca_id.id
            dados_boleto = obj_financeiro_titulo.fintit_get_dados_boleto(cr, uid, [brw_titulo.titulo_id.id],
                                                        local_cobranca_id=local_cobranca_id,
                                                        natureza_cobranca_id=natureza_cobranca_id, context=context)
            if dados_boleto.get(brw_titulo.titulo_id.id).get('fintit_boleto_nosso_numero'):
                _nn = dados_boleto.get(brw_titulo.titulo_id.id).get('fintit_boleto_nosso_numero')
                _nossoNumeroNovo = False
            else:
                _nossoNumeroNovo = True
                _nn = obj_financeiro_local_natureza.finlon_get_set_nosso_numero(cr, uid, brw_titulo.titulo_id.id,
                                                                                local_natureza_id, context=context)
            _nn = str(_nn).zfill(15)
            if brw_local_natureza.finlon_registro_banco == '1': # Titulo com registro
                if brw_local_natureza.finlon_boleto_emissao == '1': # Emissao do boleto pela caixa
                    _nn_compl = '11%s' % _nn
                else: # Emissao do boleto pelo cedente
                    _nn_compl = '14%s' % _nn
            else: # Titulo sem registro
                _nn_compl = '24%s' % _nn
            _nn_dv = baseModulo(_nn_compl, 12, Base=10, subResto='S', somaDigitos='S')
            _nn_dv = '0' if _nn_dv.__len__() > 1 else _nn_dv
            return _nn, _nn_compl, _nn_dv, _nossoNumeroNovo

        def _get_nosso_numero_bradesco():
            if brw_local_natureza.finlon_boleto_emissao == '2':  # Emissao do boleto pelo emitente
                local_cobranca_id = brw_local_natureza.finlon_local_cobranca_id.id
                natureza_cobranca_id = brw_local_natureza.finlon_natureza_cobranca_id.id
                dados_boleto = obj_financeiro_titulo.fintit_get_dados_boleto(
                    cr, uid, [brw_titulo.titulo_id.id], local_cobranca_id=local_cobranca_id,
                    natureza_cobranca_id=natureza_cobranca_id, context=context)
                if dados_boleto.get(brw_titulo.titulo_id.id).get('fintit_boleto_nosso_numero'):
                    _nn = dados_boleto.get(brw_titulo.titulo_id.id).get(
                        'fintit_boleto_nosso_numero')
                    _nossoNumeroNovo = False
                else:
                    _nossoNumeroNovo = True
                    _nn = obj_financeiro_local_natureza.finlon_get_set_nosso_numero(
                        cr, uid, brw_titulo.titulo_id.id, local_natureza_id, context=context)
                _nn = str(_nn).zfill(11)
                _nn_dv = baseModulo(_nn, 12, Base=10, subResto='S', somaDigitos='S')
                _nn_dv = '0' if _nn_dv.__len__() > 1 else _nn_dv
                _nn = '00000000' + _nn + _nn_dv
            else:  # Emissao do boleto pelo banco
                _nn = '00000000000000000000'
                _nossoNumeroNovo = False
            return _nn, _nossoNumeroNovo

        context = context and context.copy() or {}
        _nossoNumeroNovo = ''
        qtd_titulo_escritural = qtd_titulo_simples = qtd_titulo_vinculado = 0
        vr_titulo_escritural = vr_titulo_simples = vr_titulo_vinculado = 0
        obj_adm_empresa_objeto = self.pool.get('adm.empresa.objeto')
        obj_res_company = self.pool.get('res.company')
        obj_wizard_cobranca_magnetica = self.pool.get('wizard.cobranca.magnetica')
        browse_cobranca_magnetica = obj_wizard_cobranca_magnetica.browse(cr, uid, cobranca_magnetica_id)
        obj_financeiro_local_natureza = self.pool.get('financeiro.local.natureza')
        obj_financeiro_titulo = self.pool.get('financeiro.titulo')
        brw_local_natureza = obj_financeiro_local_natureza.browse(cr, uid, local_natureza_id)
        dict_hsbc_arquivo = {}
        banco = brw_local_natureza.finlon_local_cobranca_id.finloc_banco_id.\
            admbco_codigo_bc or 0
        if banco:
            banco = str(banco)
        cedente_conta = brw_local_natureza.finlon_conta
        cedente_conta_dv = brw_local_natureza.finlon_conta_dv or ''
        cedente_agencia = unicode(brw_local_natureza.finlon_agencia)
        cedente_agencia_dv = cedente_agencia_conta_dv = brw_local_natureza.finlon_agencia_dv or 0
        cedente_convenio = brw_local_natureza.finlon_convenio or ''
        dict_cef_arquivo = {}
        if banco == '104':
            dict_cef_arquivo = {
                'codigo_convenio': brw_local_natureza.finlon_convenio
            }
        if banco == '341':
            cedente_agencia_conta_dv = int(brw_local_natureza.finlon_conta_dv or 0)
        if banco == '399':
            dict_hsbc_arquivo = {
                'cedente_agencia_dv': brw_local_natureza.finlon_agencia_dv or '',
                'cedente_conta_dv': cedente_conta_dv,
                'arquivo_densidade': 1600,
            }
        dict_sicoob_arquivo = {}
        if banco == '756':
            cedente_agencia_conta_dv = ' '
            dict_sicoob_arquivo = {
                'mensagem1': browse_cobranca_magnetica.mensagem1,
                'mensagem2': browse_cobranca_magnetica.mensagem2
            }
        company_id = obj_adm_empresa_objeto.getEmpresa(cr, uid, self._name, context=context)
        pessoa_id = obj_res_company.browse(cr, uid, company_id).rescon_pessoa_id
        pessoa_tipo = pessoa_id.pessoa_tipo or ''
        if not pessoa_tipo:
            tipo_inscricao = 0
            numero_inscricao = ''
        elif pessoa_tipo == 'J':
            tipo_inscricao = 2
            numero_inscricao = pessoa_id.cpf_cnpj or ''
        else:
            tipo_inscricao = 1
            numero_inscricao = pessoa_id.cpf_cnpj or ''
        numero_inscricao = numero_inscricao.replace('.', '')
        numero_inscricao = numero_inscricao.replace('/', '')
        numero_inscricao = int(numero_inscricao.replace('-', ''))
        codigo_banco = int(banco)
        cedente_agencia = int(cedente_agencia)
        cedente_conta = int(cedente_conta)
        cedente_conta_dv = int(cedente_conta_dv)

        banco_data = dict()
        dict_arquivo = {
            'nome_empresa': unicode_to_ascii(pessoa_id.name[:30]),
            'controle_banco': codigo_banco,
            'cedente_inscricao_tipo': tipo_inscricao,
            'cedente_inscricao_numero': numero_inscricao,
            'cedente_convenio': cedente_convenio,
            'cedente_agencia': cedente_agencia,
            'cedente_agencia_dv': cedente_agencia_dv,
            'cedente_conta': cedente_conta,
            'cedente_conta_dv': cedente_conta_dv,
            'cedente_agencia_conta_dv': cedente_agencia_dv,
            'cedente_nome': unicode_to_ascii(pessoa_id.name[:30]),
            'arquivo_data_de_geracao': int(time.strftime('%d%m%Y')),
            'arquivo_hora_de_geracao': int(time.strftime('%H%M%S')),
            'arquivo_sequencia': 900002,
        }

        if dict_hsbc_arquivo:
            dict_arquivo.update(dict_hsbc_arquivo)
        if dict_sicoob_arquivo:
            dict_arquivo.update(dict_sicoob_arquivo)
            dict_arquivo['cedente_convenio'] = ''
            cedente_convenio = ''

        list_cobranca = []
        brw_titulo_ids = browse_cobranca_magnetica.titulo_selecionado_ids
        clientes_sem_endereco = ''
        for brw_titulo in brw_titulo_ids:
            if not brw_titulo.pessoa_id.endereco_ids \
                    and brw_titulo.pessoa_id.name not in clientes_sem_endereco:
                clientes_sem_endereco += '\n%s,' % brw_titulo.pessoa_id.name
        if clientes_sem_endereco:
            raise osv.except_osv(_('Atencao'),
                                 _('O(s) cliente(s): %s \n nao possui(em) endereco cadastrado') %
                                 clientes_sem_endereco)
        if brw_local_natureza.finlon_padrao_cnab == '400':
            dict_arquivo.update({
                'data_gravacao_arquivo': dict_arquivo.get('arquivo_data_de_geracao'),
                'arquivo_sequencia': dict_arquivo.get('arquivo_sequencia'),
                'numero_sequencial_registro': 1
            })
        contador_inter = 2
        for brw_titulo in brw_titulo_ids:
            agencia_cobradora = 0
            carteira_numero = brw_local_natureza.finlon_carteira or '0'
            if carteira_numero:
                carteira_numero = carteira_numero[:3]
            if banco == '341':
                if carteira_numero in ('104', '109', '112', '150', '180'):
                    qtd_titulo_escritural += 1
                    vr_titulo_escritural += brw_titulo.vr_original
                else:
                    qtd_titulo_simples += 1
                    vr_titulo_simples += brw_titulo.vr_original

            pessoa_tipo = brw_titulo.pessoa_id.pessoa_tipo or ''
            if not pessoa_tipo:
                sacado_tipo_inscricao = 0
                sacado_numero_inscricao = '0'
            elif pessoa_tipo == 'J':
                sacado_tipo_inscricao = 2
                sacado_numero_inscricao = brw_titulo.pessoa_id.cpf_cnpj or '0'
            else:
                sacado_tipo_inscricao = 1
                sacado_numero_inscricao = brw_titulo.pessoa_id.cpf_cnpj or '0'
            sacado_numero_inscricao = sacado_numero_inscricao.replace('.', '')
            sacado_numero_inscricao = sacado_numero_inscricao.replace('/', '')
            sacado_numero_inscricao = int(sacado_numero_inscricao.replace('-', ''))
            endereco = brw_titulo.pessoa_id.endereco_ids
            endereco = endereco[0]
            sacado_endereco = endereco.logradouro_id.descricao + ', ' + endereco.numero
            sacado_endereco = unicode_to_ascii(sacado_endereco)
            sacado_bairro = unicode_to_ascii(endereco.bairro_id.name)
            sacado_cep = endereco.cep or ''
            sacado_cep = sacado_cep.replace('.', '')
            sacado_cep = sacado_cep.replace('-', '')
            cep = sacado_cep
            sacado_cep = sacado_cep[:5]
            sacado_cep_sufixo = cep[5:]
            sacado_cidade = unicode_to_ascii(endereco.cidade_id.name)
            sacado_uf = ''
            if endereco.cidade_id:
                sacado_uf = endereco.cidade_id.uf_id.sigla

            dict_hsbc_cobranca = {}
            nosso_numero = False
            if banco == '399':
                dict_hsbc_cobranca = {
                    'cedente_nome': pessoa_id.nome[:30],
                    'cedente_convenio': cedente_convenio,
                    'cedente_agencia_dv': brw_local_natureza.finlon_agencia_dv or '',
                    'cobranca_carteira': 1,
                    'cobranca_cadastramento': 1,
                    'cobranca_emissao_bloqueto': 2,
                    'valor_iof': Decimal('0.00'),
                    'depositaria_nome_banco': brw_local_natureza.
                    finlon_local_cobranca_id.finloc_banco_id.name[:20],
                    'depositaria_codigo_agencia': str(cedente_agencia)
                }
            dict_itau_cobranca = {}
            if banco == '341':
                dict_arquivo['cedente_agencia_conta_dv'] = cedente_agencia_conta_dv
                dict_itau_cobranca = {
                    'cedente_agencia_conta_dv': cedente_conta_dv
                }
                cedente_agencia_conta_dv = cedente_conta_dv
                if brw_local_natureza.finlon_padrao_cnab == '400':
                    dict_itau_cobranca = {
                        'cedente_agencia_conta_dv': cedente_agencia_conta_dv
                    }
                    cedente_agencia_conta_dv = cedente_agencia_conta_dv
                _nn, _nn_compl, _nn_dv, _nossoNumeroNovo = _get_nosso_numero_itau()
                dict_itau_cobranca['nosso_numero'] = _nn
                dict_itau_cobranca['nosso_numero_dv'] = _nn_dv
                if brw_local_natureza.finlon_padrao_cnab == '400':
                    dict_arquivo['arquivo_data_de_geracao'] = int(time.strftime('%d%m%y'))

            if banco == '104':
                dict_cef_cobranca = {
                    'cedente_agencia_conta_dv': cedente_conta_dv
                }
                cedente_agencia_conta_dv = cedente_conta_dv
                _nn, _nn_compl, _nn_dv, _nossoNumeroNovo = _get_nosso_numero_cef()
                dict_itau_cobranca['nosso_numero'] = _nn
                dict_itau_cobranca['nosso_numero_dv'] = _nn_dv

            juros_mora_multa_data = datetime.strptime(brw_titulo.titulo_id.data_prorrogacao, '%Y-%m-%d')
            codigo_protesto = browse_cobranca_magnetica.codigo_protesto
            dict_sicoob_cobranca = {}
            if banco == '756':  # SICOOB
                _nn, _nn_compl, _nn_dv, _nossoNumeroNovo = _get_nosso_numero_sicoob()
                dict_sicoob_cobranca['nosso_numero'] = _nn_compl
                _nn = _nn_compl
                dict_sicoob_cobranca['agencia_cobradora_dv'] = ' '
                if brw_titulo.titulo_id.vr_juros_dia > 0:
                    dict_sicoob_cobranca['juros_mora_codigo'] = 1 # Informa que sera valor de juros por dia
                else:
                    dict_sicoob_cobranca['juros_mora_codigo'] = 0 # sem cobranca de juros
                if brw_titulo.titulo_id.vr_desconto > 0:
                    dict_sicoob_cobranca['desconto1_codigo'] = 1 # Informa que sera valor fixo do desconto ate uma data
                else:
                    dict_sicoob_cobranca['desconto1_codigo'] = 0 # sem desconto

                if codigo_protesto not in ['1', '3', '9']:
                    raise osv.except_osv(_('Atencao!'),
                                         _('Codigo do protesto deve ser "Protestar(dias corridos)" ou "Nao protestar"'))

                juros_mora_multa_data = (juros_mora_multa_data + timedelta(days=1)).strftime('%d%m%Y')
            else:
                juros_mora_multa_data = juros_mora_multa_data.strftime('%d%m%Y')

            dict_sicredi_cobranca = {}
            if banco == '748':
                _nn, _nn_compl, _nn_dv, _nossoNumeroNovo = _get_nosso_numero_sicredi()
                dict_sicredi_cobranca['nosso_numero'] = _nn_compl

            if banco == '341':  # Itau
                if brw_local_natureza.finlon_padrao_cnab == '400':
                    codigos_itau = {'0': '  ',
                                    '1': '34',
                                    '2': '35',
                                    '3': '09',
                                    '7': '  ',
                                    '8': '67'}
                    codigo_protesto = codigos_itau.get(codigo_protesto)
                    if codigo_protesto not in ('09', '34', '35'):
                        prazo_protesto = '00'
                    dict_itau_cobranca['prazo_protesto'] = prazo_protesto
            dict_bradesco_cobranca = dict()
            if banco == '237':  # BRADESCO
                _nn, _nossoNumeroNovo = _get_nosso_numero_bradesco()
                bra_boleto_emissao = brw_local_natureza.finlon_boleto_emissao \
                    and int(brw_local_natureza.finlon_boleto_emissao) or 0
                bra_boleto_distribuicao = brw_local_natureza.finlon_boleto_distribuicao \
                    and int(brw_local_natureza.finlon_boleto_distribuicao) or 0
                dict_bradesco_cobranca.update({
                    'nosso_numero': _nn,
                    'cobranca_emissao_bloqueto': bra_boleto_emissao,
                    'cobranca_distribuicao_bloqueto': bra_boleto_distribuicao,
                })

            dict_cobranca = {
                'servico_codigo_movimento': 1 if brw_titulo.operacao == 'E' else 2,
                'cedente_inscricao_tipo': tipo_inscricao,
                'cedente_inscricao_numero': numero_inscricao,
                'cedente_agencia': cedente_agencia,
                'cedente_agencia_dv': cedente_agencia_dv,
                'cedente_conta': cedente_conta,
                'cedente_conta_dv': cedente_conta_dv,
                'cedente_agencia_conta_dv': cedente_agencia_dv,
                'carteira_numero': int(carteira_numero),
                'nosso_numero': 99999999,
                'nosso_numero_dv': 9,
                'numero_documento': brw_titulo.documento[:10],
                'vencimento_titulo': int(time.strftime('%d%m%Y', time.strptime(brw_titulo.data_prorrogacao, '%Y-%m-%d'))),
                'valor_titulo': Decimal(getNumeroEditado(brw_titulo.vr_original, 2, '.', '')),
                'agencia_cobradora': agencia_cobradora,
                'agencia_cobradora_dv': '0',
                'especie_titulo': browse_cobranca_magnetica.especie.finffe_codigo,
                'aceite_titulo': u'A',
                'data_emissao_titulo': int(
                    time.strftime('%d%m%Y', time.strptime(brw_titulo.titulo_id.data_emissao, '%Y-%m-%d'))),
                'juros_mora_data': int(juros_mora_multa_data),
                'juros_mora_taxa_dia': Decimal(getNumeroEditado(brw_titulo.titulo_id.vr_juros_dia or 0, 2, '.', '')),
                'desconto1_data': int(time.strftime('%d%m%Y', time.strptime(brw_titulo.titulo_id.data_limite_desconto,
                                                                            '%Y-%m-%d'))) if brw_titulo.titulo_id.data_limite_desconto else 0,
                'desconto1_percentual': Decimal(getNumeroEditado(brw_titulo.titulo_id.vr_desconto or 0, 2, '.', '')),
                'valor_abatimento': Decimal('0.00'),
                'identificacao_titulo': brw_titulo.id,
                'codigo_protesto': codigo_protesto,
                'prazo_protesto': browse_cobranca_magnetica.dias_protesto,
                'codigo_baixa': browse_cobranca_magnetica.codigo_baixa,
                'prazo_baixa': browse_cobranca_magnetica.dias_baixa,
                'sacado_inscricao_tipo': sacado_tipo_inscricao,
                'sacado_inscricao_numero': sacado_numero_inscricao,
                'sacado_nome': unicode_to_ascii(brw_titulo.pessoa_id.name[:30]),
                'sacado_endereco': sacado_endereco[:40],
                'sacado_bairro': sacado_bairro[:15],
                'sacado_cep': sacado_cep,
                'sacado_cep_sufixo': sacado_cep_sufixo,
                'sacado_cidade': sacado_cidade[:15],
                'sacado_uf': sacado_uf,
            }
            if brw_titulo.titulo_id.vr_multa > 0:
                dict_cobranca['multa_data'] = int(juros_mora_multa_data) if brw_titulo.titulo_id.multa_apos_data else 0
                dict_cobranca['multa_codigo'] = '1'
                dict_cobranca['multa_valor'] = brw_titulo.titulo_id.vr_multa

            if dict_sicredi_cobranca:
                dict_cobranca.update(dict_sicredi_cobranca)
            if dict_sicoob_cobranca:
                dict_cobranca.update(dict_sicoob_cobranca)
            if dict_itau_cobranca:
                dict_cobranca.update(dict_itau_cobranca)
            if dict_hsbc_cobranca:
                dict_cobranca.update(dict_hsbc_cobranca)
            if dict_hsbc_arquivo:
                dict_cobranca.update(dict_hsbc_arquivo)
            if dict_bradesco_cobranca:
                dict_cobranca.update(dict_bradesco_cobranca)

            if brw_local_natureza.finlon_padrao_cnab == '400':
                if banco == '341':
                    dict_cobranca['data_emissao_titulo'] = int(
                        time.strftime('%d%m%y', time.strptime(brw_titulo.titulo_id.data_emissao, '%Y-%m-%d')))
                dict_cobranca.update({
                    'identificacao_empresa_beneficiaria': int(
                        '1120001' + (str(dict_cobranca.get('cedente_conta')) +
                                     str(dict_cobranca.get('cedente_conta_dv'))).zfill(10)),
                    'numero_documento': dict_cobranca.get('numero_documento'),
                    'data_vencimento_titulo': parse(brw_titulo.data_prorrogacao).strftime('%d%m%y'),
                    'valor_titulo': dict_cobranca.get('valor_titulo'),
                    'data_limite_pagamento': 30,
                    'tipo_identificacao_pagador': dict_cobranca.get('sacado_inscricao_tipo'),
                    'numero_inscricao_pagador': dict_cobranca.get('sacado_inscricao_numero'),
                    'nome_pagador': dict_cobranca.get('sacado_nome').upper(),
                    'endereco_completo_pagador': dict_cobranca.get('sacado_endereco'),
                    'cep_pagador': dict_cobranca.get('sacado_cep'),
                    'sufixo_cep_pagador': dict_cobranca.get('sacado_cep_sufixo'),
                    'numero_controle_participante': brw_titulo.titulo_id.id,
                    'numero_sequencial_registro': contador_inter,
                    'nome_empresa': unicode_to_ascii(pessoa_id.name[:30]),

                })
                contador_inter += 1
                if brw_titulo.titulo_id.vr_multa > 0:
                    dict_cobranca.update({
                        'tipo_multa': 1,
                        'valor_multa': Decimal(getNumeroEditado(brw_titulo.titulo_id.vr_multa, 2,
                                                                '.', '')),
                        'data_multa': str(dict_cobranca.get('multa_data'))[:4]+str(dict_cobranca.get('multa_data'))[-2:],
                    })
                if brw_titulo.titulo_id.vr_juros_dia:
                    dict_cobranca.update({
                        'tipo_juros_mora': 1,
                        'valor_juros_mora_dia': dict_cobranca.get('juros_mora_taxa_dia'),
                        'data_juros_mora': str(dict_cobranca.get('juros_mora_data'))[:4]+str(dict_cobranca.get('juros_mora_data'))[-2:]

                    })
                if brw_titulo.titulo_id.vr_desconto:
                    dict_cobranca.update({
                        'tipo_desconto': 1,
                        'valor_desconto': Decimal(getNumeroEditado(brw_titulo.titulo_id.vr_desconto,
                                                                   2, '.', '')),
                        'data_limite_desconto': brw_titulo.titulo_id.data_limite_desconto
                        and int(parse(brw_titulo.titulo_id.data_limite_desconto).strftime(
                            '%d%m%y'))
                    })

            list_cobranca.append(dict_cobranca)
            vals_titulo = {
                'local_cobranca_id': brw_local_natureza.finlon_local_cobranca_id.id,
                'natureza_cobranca_id': brw_local_natureza.finlon_natureza_cobranca_id.id,
                'state_banco': 'E',
            }
            if _nossoNumeroNovo:
                res, digitavel, scaneavel = cnabUtils.cnab_get_codigo_barra(
                    brw_local_natureza, brw_titulo.titulo_id, _nn)
                vals_titulo['fintit_boleto_ids'] = [(0,0,{
                        'fintib_codigo_barras': digitavel,
                        'fintib_local_cobranca_id':brw_local_natureza.finlon_local_cobranca_id.id,
                        'fintib_natureza_cobranca_id': brw_local_natureza.finlon_natureza_cobranca_id.id,
                        'fintib_nosso_numero': _nn,
                    })]
            obj_financeiro_titulo.write(cr, uid, brw_titulo.titulo_id.id, vals_titulo, context=context)
        if banco == '341':
            dict_arquivo.update({
                'quantidade_tit_cob_vinculada': qtd_titulo_vinculado,
                'valor_total_cob_vinculada': vr_titulo_vinculado,
                'quantidade_tit_cob_escritural': qtd_titulo_escritural,
                'valor_total_cob_escritural': vr_titulo_escritural,
                'quantidade_tit_cob_simples': qtd_titulo_simples,
                'valor_total_cob_simples': vr_titulo_simples
            })
        dict_lote = dict_arquivo.copy()
        dict_lote['cedente_agencia_conta_dv'] = cedente_agencia_conta_dv
        banco_data['arquivo'] = dict_arquivo
        banco_data['lote'] = dict_lote
        if brw_local_natureza.finlon_padrao_cnab == '400':
            banco_data['lote']['numero_sequencial_registro'] = contador_inter + 1
            banco_data['arquivo']['quantidade_boleto'] = len(list_cobranca)
            banco_data['arquivo']['valor_total'] = vr_titulo_simples + vr_titulo_escritural + vr_titulo_vinculado

        banco_data['cobranca'] = list_cobranca
        # arq_boleto = boleto.Boleto()
        return banco_data

    def get_itau_file_remessa(self):
        arquivo_remessa = open('/tmp/arquivo_remessa.txt', 'w')
        arquivo_remessa.close()
        return arquivo_remessa

