# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import base64
from tipos import Arquivo
from bancos import bb
import time
from openerp.tools.translate import _


class wizard_cobranca_magnetica_retorno(osv.TransientModel):
    _name = "wizard.cobranca.magnetica.retorno"
    _inherit = "wizard.cobranca.magnetica.retorno"

    def button_carregar_retorno(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_adm_forma_pgto = self.pool.get('adm.forma.pgto')
        obj_financeiro_titulo = self.pool.get('financeiro.titulo')
        obj_financeiro_utils = self.pool.get('financeiro')
        obj_financeiro_tesouraria_contas = self.pool.get('financeiro.tesouraria.contas')
        obj_financeiro_titulo_boleto = self.pool.get('financeiro.titulo.boleto')
        obj_adm_banco = self.pool.get('adm.banco')
        retorno_dados = self.read(cr, uid, ids[0], ['arquivo_retorno'], context=context)
        dados_arquivo = base64.b64decode(retorno_dados.get('arquivo_retorno'))
        f = open('/tmp/cobranca.processa.ret', 'w')
        f.write(dados_arquivo)
        f.close()
        fi = open('/tmp/cobranca.processa.ret')
        arquivo = fi.readlines()
        identificador_banco = arquivo[0][76:94]
        banco_id = obj_adm_banco.search(cr, uid, [('admbco_codigo_bc', '=', 643)], context=context)
        instance_arquivo = False
        msg_erro = u''
        if identificador_banco == '748BANSICREDIUNICR' or identificador_banco == '001BANCO DO BRASIL':
            instance_arquivo = Arquivo(bb, **{})
        if instance_arquivo:
            titulos_baixa = instance_arquivo.carregar_retorno(arquivo)
            data_pagamento = time.strftime('%Y-%m-%d')
            forma_pagamento_id = obj_adm_forma_pgto.search(cr, uid, [('name', 'ilike', 'dinheiro')],
                                                           context=context)
            list_identificacao_titulo = []
            total_titulo_pago = 0.0
            for x in titulos_baixa:
                local_natureza_id = self._get_local_natureza(cr, uid, banco_id, x.get('carteira'), context=context)
                numero_documento = x.get('numero_titulo_cedente')
                if numero_documento:
                    titulo_id = obj_financeiro_titulo.search(cr, uid,
                                                             [('documento', '=', numero_documento.replace(' ', '')),
                                                              ('state', '=', 'A'),
                                                              ('tipo_titulo', '=', 'R')
                                                             ], context=context)
                    x['titulo_id'] = titulo_id
                    list_identificacao_titulo.append(titulo_id)
                valor_recebido = float(x.get('valor_recebido')) / 100
                total_titulo_pago += valor_recebido
            if not list_identificacao_titulo:
                raise osv.except_osv(_('Atencao'), _('Os titulos de retorno nao existem na base de dados'))
            baixa_multipla = True if len(list_identificacao_titulo) > 1 else False
            msg_erro_many_titulos = {}
            titulos = []
            titulo_ids = []
            conta_ids = []
            for titulo in titulos_baixa:
                conta = titulo.get('codigo_cedente')
                conta = conta.split()[0]
                conta = str(int(conta))
                conta_id = obj_financeiro_tesouraria_contas.search(cr, uid,
                                                                   [('nro_conta', 'like', '%s%s' % ('%', conta))],
                                                                   context=context)
                titulo_id = titulo.get('titulo_id')
                if titulo_id and conta_id:
                    titulo_id = titulo_id[0]
                    conta_id = conta_id[0]
                    brw_financeiro_titulo = obj_financeiro_titulo.browse(cr, uid, titulo_id,
                                                                         context)
                    valor_recebido = float(titulo.get('valor_recebido') or 0) / 100
                    desconto_concedido = float(titulo.get('desconto_concedido') or 0) / 100
                    tipo_titulo = brw_financeiro_titulo.tipo_titulo
                    pessoa_id = brw_financeiro_titulo.pessoa_id.id
                    local_cobranca_id = brw_financeiro_titulo.local_cobranca_id.id
                    natureza_id = brw_financeiro_titulo.natureza_cobranca_id.id
                    titulos.append({'titulo_id': titulo_id, 'valor_pago': valor_recebido,
                                    'saldo_baixado': valor_recebido,
                                    'valor_multa': 0, 'valor_juros': 0,
                                    'valor_desconto': desconto_concedido,
                                    'tipo_titulo': tipo_titulo,
                                    'pessoa_id': pessoa_id})
                    titulo_boleto_ids = obj_financeiro_titulo_boleto.search(
                        cr, uid, [('fintib_titulo_id', '=', titulo_id),
                                  ('fintib_nosso_numero', '=', titulo.get('nosso_numero')),
                                  ('fintib_local_cobranca_id', '=', local_cobranca_id)],
                        context=context)
                    if not titulo_boleto_ids:
                        obj_financeiro_titulo_boleto.create(
                            cr, uid, {'fintib_titulo_id': titulo_id,
                                      'fintib_nosso_numero': titulo.get('nosso_numero'),
                                      'fintib_boleto_impresso': True,
                                      'fintib_local_cobranca_id': local_cobranca_id,
                                      'fintib_natureza_cobranca_id': natureza_id},
                            context)
                    titulo_ids.append(titulo_id)
                    conta_ids.append(conta_id)
            conta_id = False
            if conta_ids:
                conta_id = conta_ids[0]
            res_baixa = obj_financeiro_utils.financ_baixar_titulo(
                cr, uid,
                futl_bxti_titulos=titulos,
                futl_bxti_data_pagamento=data_pagamento,
                ftul_bxti_forma_pgto_id=forma_pagamento_id[0],
                futl_bxti_tesouraria_conta_id=conta_id,
                futl_bxti_baixa_multipla=baixa_multipla,
                context=context
            )
            if not res_baixa:
                baixa_erro = obj_financeiro_utils.financ_get_erro()
                if isinstance(baixa_erro, basestring):
                    if 'ctx_util_baixa_lt' in baixa_erro:
                        baixa_erro = baixa_erro.replace('ctx_util_baixa_lt', '')
                        key = hash(baixa_erro)
                        if key in msg_erro_many_titulos:
                            msg_erro_many_titulos[key]['titulo_ids'].extend(titulo_ids)
                        else:
                            msg_erro_many_titulos[key] = {'titulo_ids': titulo_ids,
                                                          'msg': baixa_erro}
                    else:
                        if baixa_erro.strip().endswith(':'):
                            res_name_get = obj_financeiro_titulo.name_get(
                                cr, uid, titulo_ids, context) or [('', '')]
                            dict_name_get = dict(res_name_get)
                            titulo_name = ''
                            for x in dict_name_get:
                                titulo_name += '%s, ' % \
                                    dict_name_get.get(x) or _('** Titulo nao encontrado **')
                        else:
                            titulo_name = ''
                        msg_erro += '%s %s' % (baixa_erro, titulo_name)
            else:
                self.write(cr, uid, ids[0], {'baixa_realizada': True}, context)
                obj_financeiro_titulo.write(cr, uid, map(lambda t: t.get('titulo_id'), titulos),
                                            {'fintit_baixa_arquivo_retorno': True}, context)
            if msg_erro_many_titulos:
                new_msg = self.generate_msg_erro_titulos(cr, uid, dict_msg=msg_erro_many_titulos, context=context)
                msg_erro += new_msg
        if msg_erro:
            raise osv.except_osv(_('Atencao'), msg_erro)
        return super(wizard_cobranca_magnetica_retorno, self).button_carregar_retorno(cr, uid, ids, context)

    def button_retorno_busca_titulos(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_financeiro_titulo = self.pool.get('financeiro.titulo')
        obj_adm_banco = self.pool.get('adm.banco')
        obj_wizard_cobranca_magnetica_retorno_titulos = self.pool.get('wizard.cobranca.magnetica.retorno.titulos')
        ids_titulos = obj_wizard_cobranca_magnetica_retorno_titulos.search(cr, uid, [
            ('cobranca_magnetica_retorno_id', '=', ids[0])
        ], context=context)
        if ids_titulos:
            obj_wizard_cobranca_magnetica_retorno_titulos.unlink(cr, uid, ids_titulos)
        retorno_dados = self.read(cr, uid, ids[0], ['arquivo_retorno'], context=context)
        dados_arquivo = base64.b64decode(retorno_dados.get('arquivo_retorno'))
        f = open('/tmp/cobranca.ret', 'w')
        f.write(dados_arquivo)
        f.close()
        fi = open('/tmp/cobranca.ret')
        arquivo = fi.readlines()
        identificador_banco = arquivo[0][76:94]
        banco_id = obj_adm_banco.search(cr, uid, [('admbco_codigo_bc', '=', 643)], context=context)
        instance_arquivo = False
        if identificador_banco == '748BANSICREDIUNICR' or identificador_banco == '001BANCO DO BRASIL':
            instance_arquivo = Arquivo(bb, **{})
        if instance_arquivo:
            titulos_arquivo_retorno = instance_arquivo.carregar_retorno(arquivo)
            total_titulo_pago = 0.0
            for x in titulos_arquivo_retorno:
                local_natureza_id = self._get_local_natureza(cr, uid, banco_id, x.get('carteira'), context=context)
                numero_documento = x.get('numero_titulo_cedente')
                if numero_documento:
                    titulo_id = obj_financeiro_titulo.search(cr, uid,
                                                             [('documento', '=', numero_documento.replace(' ', '')),
                                                              ('tipo_titulo', '=', 'R')], context=context)
                    if titulo_id:
                        titulo_id = titulo_id[0]
                    x['titulo_id'] = titulo_id
                valor_recebido = float(x.get('valor_recebido')) / 100
                total_titulo_pago += valor_recebido
            ids_titulos = obj_wizard_cobranca_magnetica_retorno_titulos.search(cr, uid, [
                ('cobranca_magnetica_retorno_id', '=', ids[0])
            ], context=context)
            if ids_titulos:
                obj_wizard_cobranca_magnetica_retorno_titulos.unlink(cr, uid, ids_titulos)
            if titulos_arquivo_retorno:
                for titulo in titulos_arquivo_retorno:
                    browse_financeiro_titulo = obj_financeiro_titulo.browse(cr, uid, titulo.get('titulo_id'))
                    if browse_financeiro_titulo:
                        vals = {
                            'local_natureza_id': local_natureza_id,
                            'cobranca_magnetica_retorno_id': ids[0],
                            'pessoa_id': browse_financeiro_titulo.pessoa_id.id,
                            'documento': browse_financeiro_titulo.documento or '',
                            'parcela': browse_financeiro_titulo.parcela or False,
                            'data_emissao': browse_financeiro_titulo.data_emissao or False,
                            'vr_original': browse_financeiro_titulo.vr_original or 0.0,
                            'data_prorrogacao': browse_financeiro_titulo.data_prorrogacao or False,
                            'titulo_id': browse_financeiro_titulo.id,
                            'state': browse_financeiro_titulo.state,
                        }
                    else:
                        vencimento = titulo.get('vencimento_titulo') or False
                        if vencimento:
                            vencimento = '%s-%s-%s' % (vencimento[4:8], vencimento[2:4], vencimento[:2])
                        vals = {
                            'local_natureza_i228978d': local_natureza_id,
                            'cobranca_magnetica_retorno_id': ids[0],
                            'documento': titulo.get('numero_documento') or '',
                            'vr_original': titulo.get('valor_titulo') or 0.0,
                            'data_prorrogacao': vencimento,
                        }
                    obj_wizard_cobranca_magnetica_retorno_titulos.create(cr, uid, vals, context)
            else:
                raise osv.except_osv(_('Atencao'), _('Nao ha titulos para o a arquivo selecionado'))
        return super(wizard_cobranca_magnetica_retorno, self).button_retorno_busca_titulos(cr, uid, ids, context)

