# -*- coding: utf-8 -*-

from openerp.osv import osv


class financeiro_febraban_dda_titulo(osv.Model):

    _inherit = 'financeiro.febraban.dda.titulo'

    def fifdda_atualiza_titulo(self, cr, uid, ids, context=None):
        """
        O metodo atualiza nos titulos identificados, as informações do boleto.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dados contextuais.
        :type context: dict
        :return: Verdadeiro.
        :rtype: bool
        """
        context = context and context.copy() or {}
        context.update({'sig_force_company': True})
        obj_financeiro_titulo = self.pool.get('financeiro.titulo')
        obj_financeiro_local_cobranca = self.pool.get('financeiro.local.cobranca')
        obj_adm_pessoa = self.pool.get('adm.pessoa')
        obj_adm_banco = self.pool.get('adm.banco')
        obj_financeiro_titulo_boleto = self.pool.get('financeiro.titulo.boleto')
        for dda in self.read(cr, uid, ids, [], context, '_classic_write'):
            vals = {'fifdda_observacao': ''}
            observacoes = ''
            titulo_id = dda.get('fifdda_titulo_id') or False
            pessoa_ids = obj_adm_pessoa.search(
                cr, uid, [('cpf_cnpj', '=', dda.get('fifdda_cpf_cnpj_fornecedor'))])
            if not pessoa_ids:
                observacoes += 'Fornecedor (Nome - CPF/CNPJ) nao cadastrado: %s - %s.\n' \
                    % (dda.get('fifdda_nome_fornecedor'), dda.get('fifdda_cpf_cnpj_fornecedor'))
            banco_ids = obj_adm_banco.search(
                cr, uid, [('admbco_codigo_bc', '=', dda.get('fifdda_codigo_banco'))],
                context=context)
            if not banco_ids:
                observacoes += 'Banco (Codigo) nao cadastrado: %s.\n' % str(dda.get(
                    'fifdda_codigo_banco'))
            local_cobranca_ids = obj_financeiro_local_cobranca.search(
                cr, uid, [('tipo', '=', 'B'), ('finloc_banco_id', 'in', banco_ids)],
                context=context) if banco_ids else []
            if not local_cobranca_ids:
                observacoes += 'Local de cobranca para o banco codigo %s, nao cadastrado.\n' % str(
                    dda.get('fifdda_codigo_banco'))
            if all([pessoa_ids, dda.get('fifdda_valor_titulo'), dda.get('fifdda_vencimento'),
                    dda.get('fifdda_emissao')]) and not titulo_id:
                vals.update({'fifdda_pessoa_id': pessoa_ids[0]})
                args_titulo = [('company_id', '=', dda.get('company_id')),
                               ('pessoa_id', 'in', pessoa_ids),
                               ('data_emissao', '=', dda.get('fifdda_emissao')),
                               ('data_prorrogacao', '=', dda.get('fifdda_vencimento')),
                               ('tipo_titulo', '=', 'P'),
                               ('vr_original', '=', dda.get('fifdda_valor_titulo'))]
                titulo_ids = obj_financeiro_titulo.search(cr, uid, args_titulo, context=context)
                if titulo_ids:
                    titulo_id = titulo_ids[0]
                    vals.update({'fifdda_titulo_id': titulo_id})
                else:
                    observacoes += 'Titulo nao identificado. Deve ser informado manualmente.\n'
            if local_cobranca_ids and titulo_id and not observacoes:
                vals.update({'state': 'I'})
                obj_financeiro_titulo_boleto.create(
                    cr, uid, {'fintib_titulo_id': titulo_id,
                              'fintib_codigo_barras': dda.get('fifdda_codigo_barra'),
                              'fintib_local_cobranca_id': local_cobranca_ids[0]})
            if observacoes:
                vals.update({'fifdda_observacao': observacoes})
            self.write(cr, uid, dda.get('id'), vals, context)
        return True
