# -*- coding: utf-8 -*-
# #############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
# www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv


class financeiro_titulo(osv.Model):
    _inherit = 'financeiro.titulo'

    def fintit_button_estornar_baixa(self, cr, uid, ids, context=None):
        """
        O metodo atualiza os titulos para o estado de aberto (state 'A'), como também os saldos.
        Deleta os historicos de baixa. Nessa sobreescrição, atualiza o campo que identifica uma
        baixa realizada por importação do arquivo de retorno para False.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dados contextuais.
        :type context: dict
        :return: Lista de id dos titulos estornados.
        :rtype: list
        """
        context = context and context.copy() or {}
        estorno_titulo_ids = super(financeiro_titulo, self).fintit_button_estornar_baixa(
            cr, uid, ids, context)
        if not estorno_titulo_ids:
            return estorno_titulo_ids
        self.write(cr, uid, estorno_titulo_ids, {'fintit_baixa_arquivo_retorno': False}, context)
        return estorno_titulo_ids
