# -*- coding: utf-8 -*-

from openerp.osv import osv, fields


class financeiro_febraban_dda_titulo(osv.Model):

    _name = 'financeiro.febraban.dda.titulo'
    _columns = {
        'company_id': fields.many2one('res.company', 'Empresa', required=True, select=True,
                                      readonly=True),
        'state': fields.selection([('P', 'Pendente'), ('I', 'Identificado')], 'Status', size=1,
                                  select=True, readonly=True),
        'fifdda_nome_fornecedor': fields.char('Fornecedor', size=128, select=True, readonly=True),
        'fifdda_emissao': fields.date('Emissao', select=True, readonly=True),
        'fifdda_vencimento': fields.date('Vencimento', select=True, readonly=True),
        'fifdda_codigo_barra': fields.char('Codigo de Barras', size=48, readonly=True),
        'fifdda_titulo_id': fields.many2one('financeiro.titulo', 'Titulo', select=True),
        'fifdda_valor_titulo': fields.float('Valor', digits=(15, 2), readonly=True),
        'fifdda_cpf_cnpj_fornecedor': fields.char('CPF/CNPJ', size=19, select=True, readonly=True),
        'fifdda_numero_documento': fields.char('Documento', size=30, select=True, readonly=True),
        'fifdda_observacao': fields.text('Observacoes', readonly=True),
        'fifdda_codigo_banco': fields.integer('Codigo', select=True, readonly=True),
        'fifdda_nome_banco': fields.char('Banco', size=60, select=True, readonly=True),
        'fifdda_pessoa_id': fields.many2one('adm.pessoa', 'Fornecedor', readonly=True),
    }
