#!/usr/bin/python
# -*- coding: utf-8 -*-

from openerp.tests.common import TransactionCase
from sigaddons.config_teste import set_config


class TestWizardBaixaTitulo(TransactionCase):
    """
    Classe responsavel por testes unitarios dos metodos da classe wizard_cobranca_magnetica
    """

    @classmethod
    def setUpClass(cls):
        set_config()

    def setUp(self):
        super(TestWizardBaixaTitulo, self).setUp()
        self.obj_cobranca_magnetica = self.registry('wizard.cobranca.magnetica')
        self.cobranca_magnetica_id = self.create_cobranca_magnetica()

    def create_cobranca_magnetica(self):
        local_cobranca_id = False
        local_cobranca_ids = self.registry('financeiro.local.cobranca').search(
            self.cr, self.uid, [], limit=1)
        if local_cobranca_ids:
            local_cobranca_id = local_cobranca_ids[0]
        local_natureza_id = False
        local_natureza_ids = self.registry('financeiro.local.natureza').search(
            self.cr, self.uid, [('finlon_local_cobranca_id', '=', local_cobranca_id)], limit=1)
        if local_natureza_ids:
            local_natureza_id = local_natureza_ids[0]
        vals = {'local_cobranca_id': local_cobranca_id, 'local_natureza_id': local_natureza_id,
                'operacao': 'B', 'titulo_selecionado_ids': self.get_dados_titulo_selecionado()}
        return self.obj_cobranca_magnetica.create(self.cr, self.uid, vals)

    def get_dados_titulo_selecionado(self):
        pessoa_id = False
        pessoa_ids = self.registry('adm.pessoa').search(self.cr, self.uid, [], order='id', limit=1)
        if pessoa_ids:
            pessoa_id = pessoa_ids[0]
        titulo_id = False
        titulo_ids = self.registry('financeiro.titulo').search(
            self.cr, self.uid, [('tipo_titulo', '=', 'R'), ('state', '=', 'A')], limit=1)
        if titulo_ids:
            titulo_id = titulo_ids[0]
        return [(0, 0, {'pessoa_id': pessoa_id, 'documento': '123456', 'vr_original': 225.00,
                        'data_prorrogacao': '2016-10-11', 'titulo_id': titulo_id, 'operacao': 'B'})]

    def test_button_gerar_remessa(self):
        res = self.obj_cobranca_magnetica.button_gerar_remessa(self.cr, self.uid,
                                                               [self.cobranca_magnetica_id], {})
        self.assertEqual(type(res), dict)
