# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from SigUtils.cnab import bancos
# Não remover este import, está sendo usado via eval()
from SigUtils.cnab.bancos import itau, cef, bradesco
from datetime import datetime
from SigUtils.cnab.tipos import ArquivoPag
import base64
from openerp.tools.translate import _
from SigUtils.datas import sigDatas


class wizard_pagamento(osv.TransientModel):
    _name = "wizard.pagamento"
    _columns = {
        'id': fields.integer('Id'),
        'operacao': fields.selection([('000', '000-Inclusao de pagamento'),
                                      ('517', '517-Alteracao de valor de pagamento'),
                                      ('519', '519-Alteracao de data de pagamento'),
                                      ('999', '999-Exclusao de pagamento incluido')], 'Operacao',
                                     required=1, size=3),
        'tesouraria_conta_id': fields.many2one('financeiro.tesouraria.contas',
                                               'Pagamento pela conta', required=True,
                                               domain="[('banco_caixa','=','B')]"),
        'data_de_pagamento': fields.selection([('T', 'Do titulo'), ('E', 'Especifica')],
                                              'Data de pagamento', size=1),
        'data_a_pagar': fields.date('Data a pagar'),
        'data_hora_remessa': fields.datetime('Data/Hora da remessa', readonly=1),
        'local_cobranca_id': fields.many2one('financeiro.local.cobranca', 'Local cobranca'),
        'titulo_ids': fields.one2many('wizard.pagamento.titulos', 'pagamento_id',
                                      'Titulos'),
        'titulo_selecionado_ids': fields.one2many('wizard.pagamento.titulos.selecionados',
                                                  'pagamento_id', 'Titulos selecionados'),
        'fornecedor_id': fields.many2one('adm.pessoa', 'Fornecedor'),
        'vencimento_inicial': fields.date('Vencimento inicial'),
        'vencimento_final': fields.date('Vencimento final'),
        'doc_tipo_id': fields.many2one('documento.documento.tipo', 'Tipo de documento', domain=[('sigla', '!=', 'PRV')]),
        'remessa_gerada': fields.boolean('Remessa gerada'),
        'titulos_selecionados': fields.boolean('Titulos gerados'),
        'log': fields.char('Log', size=50),
        'banco_bc': fields.integer('Codigo no BC', readonly=True),
        'banco_nome': fields.char('Nome', size=10, readonly=True),
        'agencia_nro': fields.integer('Agencia Nro', readonly=True),
        'agencia_nome': fields.char('Nome', size=10, readonly=True),
        'conta_nro': fields.char('Conta corrente', size=10, readonly=True),
        'conta_dv': fields.char('Dv', size=1, readonly=True),
        'dados_remessa': fields.binary('Clique para baixar o arquivo', readonly=True),
        'file_name': fields.char('Arquivo', size=20, readonly=False),
    }
    _defaults = {
        'remessa_gerada': False,
        'titulos_selecionados': False,
        'log': 'REMESSA GERADA COM SUCESSO',
        'data_de_pagamento': 'T',
        'operacao': '000',
    }

    def onchange_operacao(self, cr, uid, ids, operacao, titulos_ids):
        res = {'value': {}}
        for _brw_dados in self.browse(cr, uid, ids):
            _a_selecionar_ids = map(lambda i: i.id, _brw_dados.titulo_ids)
            # self.pool.get('wizard.pagamento.titulos').unlink(cr, uid, _a_selecionar_ids)
            _novo_titulo_ids = []
            for x in titulos_ids:
                _novo_titulo_ids.append([2, x[1]])
            res['value']['titulo_ids'] = _novo_titulo_ids
        return res

    def onchange_conta_id(self, cr, uid, ids, tesouraria_conta_id):
        res = {'value': {}}
        if tesouraria_conta_id:
            brw_financeiro_tesouraria_conta = self.pool.get('financeiro.tesouraria.contas').browse(
                cr, uid, tesouraria_conta_id)
            banco_nome = False
            for x in bancos.bancos_cadastrados:
                try:
                    if eval(
                            x).codigoBC == brw_financeiro_tesouraria_conta.banco_id.admbco_codigo_bc:
                        banco_nome = x
                        break
                except:
                    pass

            if not banco_nome:
                res = {'value': {'tesouraria_conta_id': False},
                       'warning': {'title': _('Atencao'),
                                   'message': _(
                                       'Nao ha layout estabelecido para o banco selecionado!')}}
                return res
            res['value']['banco_bc'] = brw_financeiro_tesouraria_conta.banco_id.admbco_codigo_bc
            res['value']['banco_nome'] = banco_nome
            res['value'][
                'agencia_nro'] = brw_financeiro_tesouraria_conta.agencia_id.admbag_codigo_agencia
            res['value']['conta_dv'] = brw_financeiro_tesouraria_conta.conta_dv
            res['value']['agencia_nome'] = brw_financeiro_tesouraria_conta.agencia_id.name
            res['value']['conta_nro'] = brw_financeiro_tesouraria_conta.nro_conta
        return res

    def button_busca_titulos(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_financeiro_titulo = self.pool.get('financeiro.titulo')
        obj_wizard_pagamento_titulos = self.pool.get('wizard.pagamento.titulos')
        args_titulo = []
        ids_titulos = obj_wizard_pagamento_titulos.search(
            cr, uid, [('pagamento_id', '=', ids[0])], context=context)
        if ids_titulos:
            obj_wizard_pagamento_titulos.unlink(cr, uid, ids_titulos)
        browse_pagamento = self.browse(cr, uid, ids[0])
        fornecedor_id = browse_pagamento.fornecedor_id.id or False
        vencimento_inicial = browse_pagamento.vencimento_inicial or ''
        vencimento_final = browse_pagamento.vencimento_final or ''
        local_cobranca_id = browse_pagamento.local_cobranca_id.id or False
        doc_tipo_id = browse_pagamento.doc_tipo_id.id or False
        operacao = browse_pagamento.operacao or ''
        if local_cobranca_id:
            args_titulo.append(('local_cobranca_id', '=', local_cobranca_id))
        if fornecedor_id:
            args_titulo.append(('pessoa_id', '=', fornecedor_id), )
        if vencimento_inicial and vencimento_final:
            if vencimento_inicial > vencimento_final:
                raise osv.except_osv(_('Atencao'), _('Informe um periodo de vencimento valido'))
        if vencimento_inicial:
            args_titulo.append(('data_prorrogacao', '>=', vencimento_inicial), )
        if vencimento_final:
            args_titulo.append(('data_prorrogacao', '<=', vencimento_final), )
        _doc_prv_id = self.pool.get('documento.documento.tipo').search(cr, uid, [('sigla', '=', 'PRV')],
                                                                       context=context)[0]
        if doc_tipo_id:
            args_titulo.append(('doc_tipo_id', '=', doc_tipo_id), )
        else:
            args_titulo.append(('doc_tipo_id', '!=', _doc_prv_id), )
        local_cobranca_ids = []
        if local_cobranca_id:
            args_titulo.append(('local_cobranca_id', '=', local_cobranca_id), )
        if local_cobranca_ids:
            args_titulo.append(('local_cobranca_id', 'in', local_cobranca_ids), )
        args_titulo.extend([('state', '=', 'A'), ('tipo_titulo', '=', 'P')])
        if operacao == '000':
            args_titulo.append('|')
            args_titulo.append(('fintit_pgm_banco_pagador', '=', False))
            args_titulo.append('&')
            args_titulo.append(('fintit_pgm_banco_pagador', '=', browse_pagamento.banco_bc))
            args_titulo.append(('fintit_pgm_retorno_confirmado', '=', False))
        if operacao in ('517', '519'):
            args_titulo.append(('fintit_pgm_banco_pagador', '=', browse_pagamento.banco_bc))
            args_titulo.append(('fintit_pgm_retorno_confirmado', '=', True))
        if operacao =='999':
            args_titulo.append(('fintit_pgm_banco_pagador', '=', browse_pagamento.banco_bc))
        titulo_ids = obj_financeiro_titulo.search(cr, uid, args_titulo, context=context)
        if titulo_ids:
            browse_financeiro_titulo = obj_financeiro_titulo.browse(cr, uid, titulo_ids)
            for titulo in browse_financeiro_titulo:
                vals = {
                    'pagamento_id': ids[0],
                    'pessoa_id': titulo.pessoa_id.id,
                    'documento': titulo.documento or '',
                    'parcela': titulo.parcela or False,
                    'vr_original': titulo.vr_original or 0.0,
                    'saldo': titulo.saldo or 0.0,
                    'data_prorrogacao': titulo.data_prorrogacao or False,
                    'titulo_id': titulo.id,
                }
                if titulo.fintit_boleto_codigo_barras:
                    vals['cb'] = True
                obj_wizard_pagamento_titulos.create(cr, uid, vals, context)
        else:
            raise osv.except_osv(_('Atencao'), _('Nao ha titulos para os filtros selecionados'))
        return True

    def button_adiciona_titulos(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_wizard_pagamento_titulos_selecionados = self.pool.get(
            'wizard.pagamento.titulos.selecionados')
        browse_pagamento = self.browse(cr, uid, ids[0])
        browse_pagamento_titulos = browse_pagamento.titulo_ids
        if browse_pagamento_titulos:
            for x in browse_pagamento_titulos:
                titulo_id = x.titulo_id.id
                titulos_selecionados_id = obj_wizard_pagamento_titulos_selecionados.search(
                    cr, uid, [('titulo_id', '=', titulo_id), ('pagamento_id', 'in', ids)], context=context)
                if not titulos_selecionados_id and x.cb:
                    _dt = x.data_prorrogacao if browse_pagamento.data_de_pagamento == 'T' else browse_pagamento.data_a_pagar
                    vals = {
                        'operacao': browse_pagamento.operacao,
                        'pagamento_id': ids[0],
                        'pessoa_id': x.pessoa_id.id,
                        'documento': x.documento or '',
                        'vr_original': x.saldo or 0.0,
                        'valor_a_pagar': x.saldo or 0.0,
                        'data_prorrogacao': x.data_prorrogacao or False,
                        'data_a_pagar': _dt,
                        'titulo_id': titulo_id,
                    }
                    obj_wizard_pagamento_titulos_selecionados.create(cr, uid, vals, context)
        else:
            raise osv.except_osv(_('Atencao'), _('Nao ha titulos a selecionar'))
        self.write(cr, uid, ids, {'titulos_selecionados': True}, context)
        return True

    def button_gerar_remessa(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        browse_pagamento = self.browse(cr, uid, ids[0])
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, context=context)
        brw_empresa = self.pool.get('res.company').browse(cr, uid, company_id)
        arq = ArquivoPag(eval(browse_pagamento.banco_nome), 240)
        _data_hora = datetime.now()
        _x = self.pool.get('adm.utils').admutl_datetime_to_timezone(cr, uid, _data_hora)
        arq.header.arquivo_data_de_geracao = int(_x[:2] + _x[3:5] + _x[6:10])
        arq.header.arquivo_hora_de_geracao = int(_x[11:13] + _x[14:16] + _x[17:])
        _pessoa_id = brw_empresa.rescon_pessoa_id.id
        dict_endereco = self.pool.get('adm.pessoa').admpes_endereco_fiscal(cr, uid, _pessoa_id, context=context)
        arq.setDadosEmpresa(brw_empresa.rescon_pessoa_id.cpf_cnpj,
                            brw_empresa.rescon_pessoa_id.nome,
                            dict_endereco.get(_pessoa_id).get('logradouro'),
                            dict_endereco.get(_pessoa_id).get('numero'),
                            dict_endereco.get(_pessoa_id).get('complemento'),
                            dict_endereco.get(_pessoa_id).get('cidade'),
                            dict_endereco.get(_pessoa_id).get('cep'),
                            dict_endereco.get(_pessoa_id).get('uf_sigla')
        )
        arq.setDadosConta(browse_pagamento.conta_nro, browse_pagamento.agencia_nro,
                          browse_pagamento.conta_dv)

        for brw_titulos_selecionados in browse_pagamento.titulo_selecionado_ids:
            _cb = brw_titulos_selecionados.titulo_id.fintit_boleto_codigo_barras
            _tipo_pagamento = 20
            if _cb[:1] == '8':  # Tributos ou concessionarias
                _cb_gerar = _cb[:11] + _cb[12:23] + _cb[24:35] + _cb[36:47]
                _segO = {
                    "tipo_movimento": int(brw_titulos_selecionados.operacao),
                    "codigo_barras": _cb_gerar,
                    "nome_concessionaria": brw_titulos_selecionados.titulo_id.pessoa_id.nome,
                    "data_vencimento": sigDatas(
                        brw_titulos_selecionados.data_prorrogacao).getDataNoFormato(),
                    "quantidade_moeda": brw_titulos_selecionados.valor_a_pagar,
                    "valor_pagamento": brw_titulos_selecionados.valor_a_pagar,
                    "data_pagamento": sigDatas(
                        brw_titulos_selecionados.data_a_pagar).getDataNoFormato(),
                    "nota_fiscal": brw_titulos_selecionados.titulo_id.documento,
                    "seu_numero": brw_titulos_selecionados.titulo_id.id,
                    "nosso_numero": brw_titulos_selecionados.titulo_id.fintit_boleto_nosso_numero
                }
                _seg = eval(browse_pagamento.banco_nome).registros.SegmentoO_240()
                _seg.fromdict(_segO)
                _forma_pagamento = 13
            else:
                _segJ = {
                    "tipo_movimento": int(brw_titulos_selecionados.operacao),
                    "codbar_banco_favorecido": _cb[:3],
                    "codbar_moeda": _cb[3:4],
                    "codbar_dv": _cb[32:33],
                    "codbar_vencimento": _cb[33:37],
                    "codar_valor": float(_cb[37:45] + '.' + _cb[45:]),
                    "codbar_campo_livre": _cb[4:9] + _cb[10:20] + _cb[21:31],
                    "favorecido": brw_titulos_selecionados.titulo_id.pessoa_id.nome,
                    "data_vencimento": sigDatas(
                        brw_titulos_selecionados.titulo_id.data_prorrogacao).getDataNoFormato(),
                    "valor_titulo": brw_titulos_selecionados.titulo_id.vr_original,
                    "data_pagamento": sigDatas(
                        brw_titulos_selecionados.data_a_pagar).getDataNoFormato(),
                    "valor_pagamento": brw_titulos_selecionados.valor_a_pagar,
                    "seu_numero": brw_titulos_selecionados.titulo_id.id,
                    "nosso_numero": brw_titulos_selecionados.titulo_id.fintit_boleto_nosso_numero
                }
                if brw_titulos_selecionados.valor_a_pagar < brw_titulos_selecionados.titulo_id.vr_original:
                    _segJ['descontos'] = brw_titulos_selecionados.titulo_id.vr_original \
                                         - brw_titulos_selecionados.valor_a_pagar
                if brw_titulos_selecionados.valor_a_pagar > brw_titulos_selecionados.titulo_id.vr_original:
                    _segJ['acrescimos'] = brw_titulos_selecionados.valor_a_pagar \
                                          - brw_titulos_selecionados.titulo_id.vr_original
                _seg = eval(browse_pagamento.banco_nome).registros.SegmentoJ_240()
                _seg.fromdict(_segJ)
                if int(_segJ.get('codbar_banco_favorecido')) == eval(
                        browse_pagamento.banco_nome).codigoBC:
                    _forma_pagamento = 30
                else:
                    _forma_pagamento = 31
            arq.incluir_pagamento(_seg, _tipo_pagamento, _forma_pagamento)
            vals_titulo = {
                'fintit_pgm_banco_pagador': browse_pagamento.banco_bc,
                'fintit_pgm_data_pagamento': sigDatas(
                    brw_titulos_selecionados.data_a_pagar).getDataNoFormato('I', 'S', '-'),
                'fintit_pgm_valor': brw_titulos_selecionados.valor_a_pagar,
                'fintit_pgm_data_hora_geracao': _data_hora,
                'fintit_pgm_retorno_confirmado': False,
                'fintit_pgm_operacao': brw_titulos_selecionados.operacao,
            }
            self.pool.get('financeiro.titulo').write(cr, uid, brw_titulos_selecionados.titulo_id.id,
                                                     vals_titulo, context)
        _arquivo = arq.__unicode__()
        self.write(cr, uid, ids, {'remessa_gerada': True,
                                  'dados_remessa': base64.encodestring(_arquivo),
                                  'file_name': browse_pagamento.banco_nome + '.rem',
                                  'data_hora_remessa': _data_hora,
        }, context)
        obj_model_data = self.pool.get('ir.model.data')
        reference = obj_model_data.get_object_reference(cr, uid, 'financeiro_febraban',
                                                        'wizard_pagamento_form_log')
        view_id = reference and reference[1] or False
        obj_wizard_pagamento_titulos = self.pool.get('wizard.pagamento.titulos')
        titulo_ids = obj_wizard_pagamento_titulos.search(cr, uid, [], context=context)
        obj_wizard_pagamento_titulos.unlink(cr, uid, titulo_ids)
        obj_wizard_pagamento_titulos_selecionados = self.pool.get(
            'wizard.pagamento.titulos.selecionados')
        titulo_selecionado_ids = obj_wizard_pagamento_titulos_selecionados.search(cr, uid, [], context=context)
        obj_wizard_pagamento_titulos_selecionados.unlink(cr, uid, titulo_selecionado_ids)
        return True


class wizard_pagamento_titulos(osv.TransientModel):
    _name = "wizard.pagamento.titulos"
    def _wiz_gerado_nao_confirmado(self, cr, uid, ids, name_fields, args, context=None):
        context = context and context.copy() or {}
        res = {}
        if ids:
            for brw_dados in self.browse(cr, uid, ids):
                if brw_dados.titulo_id.fintit_pgm_banco_pagador and not brw_dados.titulo_id.fintit_pgm_retorno_confirmado:
                    res[brw_dados.id] = True
                else:
                    res[brw_dados.id] = False
        return res

    _columns = {
        'pagamento_id': fields.many2one('wizard.pagamento', 'Pagamento'),
        'pessoa_id': fields.many2one("adm.pessoa", 'Fornecedor'),
        'documento': fields.char('Documento', size=30),
        'parcela': fields.integer('Parc.'),
        'vr_original': fields.float('Valor', digits=(15, 2)),
        'saldo': fields.float('Saldo', digits=(15, 2)),
        'data_prorrogacao': fields.date('Vencimento'),
        'titulo_id': fields.many2one('financeiro.titulo', 'Titulo'),
        'cb': fields.boolean('CB'),
        'gnc': fields.function(_wiz_gerado_nao_confirmado, type="boolean",
                               method=True, store=True, string='Gerado/Nao confirmado'),
    }


class wizard_pagamento_titulos_selecionados(osv.TransientModel):
    _name = "wizard.pagamento.titulos.selecionados"
    _columns = {
        'operacao': fields.char('Operacao', size=3),
        'pagamento_id': fields.many2one('wizard.pagamento', 'Cobranca magnetica'),
        'pessoa_id': fields.many2one("adm.pessoa", 'Fornecedor'),
        'documento': fields.char('Documento', size=30),
        'vr_original': fields.float('Valor original', digits=(15, 2)),
        'valor_a_pagar': fields.float('Valor a pagar', digits=(15, 2)),
        'data_prorrogacao': fields.date('Vencimento'),
        'data_a_pagar': fields.date('Data a pagar'),
        'titulo_id': fields.many2one('financeiro.titulo', 'Titulo'),
    }
