# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from SigUtils.cnab import bancos
# Não remover este import, está sendo usado via eval()
from SigUtils.cnab.bancos import itau
from datetime import datetime
from SigUtils.cnab.tipos import ArquivoPag
import base64
from openerp.tools.translate import _
from SigUtils.datas import sigDatas
from SigUtils.formatastring import formataString
from SigUtils.cnab import OCORRENCIAS_PGTO


OCORRENCIAS = []
keys = OCORRENCIAS_PGTO.keys()
keys.sort()
for key in keys:
    OCORRENCIAS.append((key, key+'-'+OCORRENCIAS_PGTO[key]))


class wizard_pagamento_retorno(osv.TransientModel):
    _name = "wizard.pagamento.retorno"
    _columns = {
        'arquivo_retorno': fields.binary('Arquivo de retorno', required=True),
        'banco': fields.char('Banco', size=3),
        'cnpj': fields.char('CNPJ', size=15),
        'nome_empresa': fields.char('Empresa', size=30),
        'agencia': fields.char('Agencia', size=5),
        'conta': fields.char('Conta', size=12),
        'dv': fields.char('Digito', size=1),
        'data_hora_geracao': fields.datetime('Data/Hora da geracao'),
        'segmento_ids': fields.one2many('wizard.pagamento.retorno.segmentos', 'capa_id',
                                        'Segmentos'),
        'state': fields.selection([('I', 'Inicio'), ('C', 'Carregado'), ('P', 'Processado')],
                                  'Estado', size=1),
    }

    _defaults = {
        'state': 'I'
    }

    def button_carregar_retorno(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        retorno_dados = self.read(cr, uid, ids[0], ['arquivo_retorno'], context=context)
        dados_arquivo = base64.b64decode(retorno_dados.get('arquivo_retorno'))
        linhas = dados_arquivo.split('\r\n')
        banco_nome = False
        try:
            _banco = int(linhas[0][:3])
        except:
            _banco = 0
        for x in bancos.bancos_cadastrados:
            try:
                if eval(x).codigoBC == _banco:
                    banco_nome = x
                    break
            except:
                pass
        if not banco_nome:
            raise osv.except_osv(_('Atencao'),
                                 _('Nao ha layout estabelecido para o banco %s!') % _banco)
        arq = ArquivoPag(eval(banco_nome))
        retorno = arq.carregar_retorno(linhas)
        if retorno['header']['arquivo_codigo'] != 2:
            raise osv.except_osv(_('Atencao'), _('Arquivo nao e de retorno!'))
        _d = formataString(str(retorno['header']['arquivo_data_de_geracao']), 8, '0', 'E')
        _h = formataString(str(retorno['header']['arquivo_hora_de_geracao']), 6, '0', 'E')
        _dt = _d[4:] + '-' + _d[2:4] + '-' + _d[:2] + ' ' + _h[:2] + ':' + _h[2:4] + ':' + _h[4:]
        _dt = datetime.strptime(_dt, '%Y-%m-%d %H:%M:%S')
        _dt = self.pool.get('adm.utils').admutl_converte_tz(cr, uid, _dt, tz_destino='UTC',
                                                            context=context)
        _nova_dt = _dt.strftime('%Y-%m-%d %H:%M:%S')
        seg_ids = self.pool.get('wizard.pagamento.retorno.segmentos').search(cr, uid, [
            ('capa_id', '=', ids[0])], context=context)
        if seg_ids:
            self.pool.get('wizard.pagamento.retorno.segmentos').unlink(cr, uid, seg_ids)
        vals = {
            'banco': retorno['header']['controle_banco'],
            'cnpj': retorno['header']['inscricao_numero'],
            'nome_empresa': retorno['header']['empresa'],
            'agencia': retorno['header']['agencia'],
            'conta': retorno['header']['conta'],
            'dv': retorno['header']['agencia_conta_dv'],
            'data_hora_geracao': _nova_dt,
        }
        for segmento in retorno['segmentos']:
            vals_l = {
                'capa_id': ids[0],
                'operacao': formataString(str(segmento['tipo_movimento']), 3, '0', 'E'),
                'segmento': segmento['servico_segmento']
            }
            _a = segmento['ocorrencias']
            _o1 = _a[:2]
            _o2 = _a[2:4]
            _o3 = _a[4:6]
            _o4 = _a[6:8]
            _o5 = _a[8:]
            vals_l['ocorrencia1'] = _o1
            vals_l['ocorrencia2'] = _o2
            vals_l['ocorrencia3'] = _o3
            vals_l['ocorrencia4'] = _o4
            vals_l['ocorrencia5'] = _o5
            vals_l['seu_numero'] = segmento['seu_numero']
            vals_l['nosso_numero'] = segmento['nosso_numero']
            _ocorrencias = (_o1, _o2, _o3, _o4, _o5)
            if '00' in _ocorrencias or 'AE' in _ocorrencias or 'BD' in _ocorrencias or 'CE' in _ocorrencias or 'IR' in _ocorrencias:
                vals_l['state'] = 'A'
                if not vals_l['seu_numero']:
                    vals_l['state'] = 'I'
            else:
                vals_l['state'] = 'N'
            if vals_l['segmento'] == 'J':
                vals_l['favorecido'] = segmento['favorecido']
                vals_l['vencimento'] = sigDatas(
                    formataString(segmento['data_vencimento'], 8, '0', 'E')).getDataNoFormato('I',
                                                                                              'S',
                                                                                              '-')
                vals_l['valor_previsto'] = str(segmento['valor_titulo'])
                vals_l['data_pagamento'] = sigDatas(
                    formataString(segmento['data_pagamento'], 8, '0', 'E')).getDataNoFormato('I',
                                                                                             'S',
                                                                                             '-')
                vals_l['valor_pago'] = str(segmento['valor_pagamento'])
                self.pool.get('wizard.pagamento.retorno.segmentos').create(cr, uid, vals_l, context)
            if vals_l['segmento'] == 'O':
                vals_l['favorecido'] = segmento['nome_concessionaria']
                vals_l['vencimento'] = sigDatas(
                    formataString(segmento['data_vencimento'], 8, '0', 'E')).getDataNoFormato('I',
                                                                                              'S',
                                                                                              '-')
                vals_l['valor_previsto'] = str(segmento['valor_pagamento'])
                vals_l['data_pagamento'] = sigDatas(
                    formataString(segmento['data_pagamento'], 8, '0', 'E')).getDataNoFormato('I',
                                                                                             'S',
                                                                                             '-')
                vals_l['valor_pago'] = str(segmento['valor_pagamento'])
                self.pool.get('wizard.pagamento.retorno.segmentos').create(cr, uid, vals_l, context)
        vals['state'] = 'C'
        self.write(cr, uid, ids, vals, context)
        return True

    def button_processar_retorno(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = {'state': 'P'}
        self.write(cr, uid, ids, vals, context)
        _forma_pgto_id = self.pool.get('adm.forma.pgto').search(cr, uid, [('sigla', '=', 'DN')], context=context)
        if isinstance(_forma_pgto_id, (list, tuple)):
            _forma_pgto_id = _forma_pgto_id[0]
        _banco_bc = _agencia = _conta = ''

        for brw_wizard in self.browse(cr, uid, ids):
            _banco_bc = brw_wizard.banco
            _agencia = brw_wizard.agencia
            _conta = brw_wizard.conta
        try:
            _banco_id = \
                self.pool.get('adm.banco').search(cr, uid, [('admbco_codigo_bc', '=', _banco_bc)], context=context)[0]
            _agencia_id = self.pool.get('adm.banco.agencia').search(cr, uid, [
                ('admbag_banco_id', '=', _banco_id), ('admbag_codigo_agencia', '=', _agencia)], context=context)[0]
            _conta_id = self.pool.get('financeiro.tesouraria.contas').search(cr, uid, [
                ('banco_id', '=', _banco_id), ('agencia_id', '=', _agencia_id),
                ('nro_conta', 'like', _conta)], context=context)[0]
            if not _conta_id:
                int('a')  # forçar o except
        except:
            raise osv.except_osv(_('Atencao'), _(
                'Nao consegui identificar a conta da tesouraria!\nBanco:%s, Agencia:%s, Conta:%s'
                % (_banco_bc, _agencia, _conta)))

        titulo_ids = self.pool.get('wizard.pagamento.retorno.segmentos').search(cr, uid,
                                                                                [('capa_id', '=',
                                                                                  ids[0])], context=context)
        titulos = []
        datas_pagamento = []
        for brw_segmento in self.pool.get('wizard.pagamento.retorno.segmentos').browse(cr, uid,
                                                                                       titulo_ids):
            _ocorrencias = (brw_segmento.ocorrencia1, brw_segmento.ocorrencia2,
                            brw_segmento.ocorrencia3, brw_segmento.ocorrencia4,
                            brw_segmento.ocorrencia5)
            if brw_segmento.operacao == '000':
                if '00' in _ocorrencias:  # Pagamento efetuado, baixar titulo
                    brw_financeiro_titulo = self.pool.get('financeiro.titulo').browse(
                        cr, uid, brw_segmento.seu_numero)
                    _saldo = brw_financeiro_titulo.saldo
                    _juros = _descontos = 0
                    if _saldo > brw_segmento.valor_pago:
                        _descontos = _saldo - brw_segmento.valor_pago
                    elif _saldo < brw_segmento.valor_pago:
                        _juros = brw_segmento.valor_pago - _saldo
                    titulo_id = brw_segmento.seu_numero
                    valor_pago = brw_segmento.valor_pago
                    tipo_titulo = brw_financeiro_titulo.tipo_titulo
                    pessoa_id = brw_financeiro_titulo.pessoa_id.id
                    titulos.append({'titulo_id': titulo_id, 'valor_pago': valor_pago,
                                    'saldo_baixado': valor_pago,
                                    'valor_multa': 0, 'valor_juros': _juros,
                                    'valor_desconto': _descontos, 'tipo_titulo': tipo_titulo,
                                    'pessoa_id': pessoa_id})
                    data_pagamento = brw_segmento.data_pagamento
                    datas_pagamento.append(data_pagamento)
        datas_pagamento.sort()
        res_baixa = self.pool.get('financeiro').financ_baixar_titulo(
            cr, uid,
            futl_bxti_titulos=titulos,
            futl_bxti_data_pagamento=datas_pagamento[0],
            futl_bxti_forma_pgto_id=_forma_pgto_id,
            futl_bxti_tesouraria_conta_id=_conta_id,
            context=context)
        if res_baixa and titulos:
            self.pool.get('financeiro.titulo').write(
                cr, uid, map(lambda t: t.get('titulo_id'), titulos),
                {'fintit_baixa_arquivo_retorno': True}, context)
        return True


    class wizard_pagamento_retorno_segmentos(osv.TransientModel):
        _name = "wizard.pagamento.retorno.segmentos"
        _columns = {
            'capa_id': fields.many2one('wizard.pagamento.retorno', 'Capa', ondelete='cascade'),
            'operacao': fields.selection([('000', '000-Inclusao de pagamento'),
                                          ('517', '517-Alteracao de valor de pagamento'),
                                          ('519', '519-Alteracao de data de pagamento'),
                                          ('999', '999-Exclusao de pagamento incluido')],
                                         'Operacao',
                                         required=1, size=3),
            'segmento': fields.char('Segmento', size=1),
            'favorecido': fields.char('Favorecido', size=30),
            'vencimento': fields.date('Vencimento'),
            'valor_previsto': fields.float('Valor previsto'),
            'data_pagamento': fields.date('Data do pagamento'),
            'valor_pago': fields.float('Valor pago'),
            'seu_numero': fields.char('Seu numero', size=20),
            'nosso_numero': fields.char('Nosso numero', size=15),
            'ocorrencia1': fields.selection(OCORRENCIAS, 'Ocor-1', size=02),
            'ocorrencia2': fields.selection(OCORRENCIAS, 'Ocor-2', size=02),
            'ocorrencia3': fields.selection(OCORRENCIAS, 'Ocor-3', size=02),
            'ocorrencia4': fields.selection(OCORRENCIAS, 'Ocor-4', size=02),
            'ocorrencia5': fields.selection(OCORRENCIAS, 'Ocor-5', size=02),
            'state': fields.char('Estado', size=1),  # A = Aceito, N=Nao aceito, i=Invalido
        }

