# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class fiscal_csosn(osv.Model):
    _name = 'fiscal.csosn'
    _inherit = 'fiscal.csosn'

    def name_get(self, cr, uid, ids, context=None):
        res = []
        context = context and context.copy() or {}
        if not len(ids):
            return []
        reads = self.read(cr, uid, ids, ['name', 'codigo'], context=context)

        for record in reads:
            res.append((record['id'], record['codigo'] + ' - ' + record['name']))
        return res

    def name_search(self, cr, uid, name='', args=[], operator='ilike', context=None, limit=100):
        """
        Metodo utilizado para localizar o nome do CSOSN pelo codigo e descricao
        """
        context = context and context.copy() or {}
        if name.isdigit():
            name = str(name)
        ids = self.search(cr, uid, [('codigo', '=', name)] + args, limit=limit,
                          context=context)
        if not ids:
            ids = self.search(cr, uid, [('name', operator, name)] + args, limit=limit,
                              context=context)
        return self.name_get(cr, uid, ids)
