# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2018 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2018, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""
from openerp.tools import config as openerp_config
from openerp.tools.translate import _
from openerp.osv import osv
import logging


# noinspection PyPep8Naming,PyAbstractClass,PyAbstractClass
class fiscal_cte(osv.Model):
    """
    Nota Fiscal de Conhecimento de Transporte Eletronico (CT-e)
    """
    _inherit = 'fiscal.nf.capa'
    _logger = logging.getLogger(_inherit)
    _logger.level = logging._levelNames[openerp_config.get('log_level').upper()]

    def verifica_cfop_fora_estado_cte(self, cr, uid, natureza_id, uf_origem_id, uf_destino_id,
                                      context=None):
        context = context and context.copy() or {}
        brw_cfop_natureza = self.pool.get('fiscal.cfop.natureza').browse(
            cr, uid, natureza_id, context)
        uf_origem = self.pool.get('adm.uf').read(
            cr, uid, uf_origem_id, ['sigla'],context).get('sigla')
        uf_destino = self.pool.get('adm.uf').read(
            cr, uid, uf_destino_id, ['sigla'], context).get('sigla')
        msg = None
        if uf_origem == uf_destino:
            if brw_cfop_natureza.cfop_id.codigo[0] != '1':
                msg = _("Natureza da operacao invalida para operacoes no mesmo estado.")
        else:
            if brw_cfop_natureza.cfop_id.codigo[0] not in '23':
                msg = _("Natureza da operacao invalida para operacoes fora do estado.")
        if msg:
            raise osv.except_osv(_('Atencao!'), msg)

        return True

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
