# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class fiscal_encargo(osv.Model):
    _name = 'fiscal.encargo'
    _inherit = 'fiscal.encargo'

    def name_search(self, cr, uid, name='', args=None, operator='ilike', context=None, limit=100):

        '''Funcao manipulada para que seja exibida somente os encargos cadastrados
           para a empresa selecionada.(Nesse caso na tela de cadastro de produto.)'''

        if not args:
            args = []

        # quando os encargos ids sao passados no context, retorna apenas os encargos ainda nao
        # selecionados para nao repetir o encargo
        if context.get('encargo_ids'):
            encargo_ids = []
            for i in self.pool.get('fiscal.import.nfe.itens.osv').resolve_2many_commands(cr, uid,
                                               'encargo_ids', context.get('encargo_ids'),
                                                                          ['encargo_id'], context):
                if isinstance(i.get('encargo_id'), tuple):
                    encargo_ids.append(i.get('encargo_id')[0])
                else:
                    encargo_ids.append(i.get('encargo_id'))

            for i in args:
                if i[0] == 'id' and i[1] == 'not in':
                    i[2] = encargo_ids

            return super(fiscal_encargo, self).name_search( cr, uid, name, args, operator, context, limit)


        context = context and context.copy() or {}
        ids = []

        if context.get('company_id_verifica', False):
            company_id = self.pool.get('res.users').read(cr, uid, uid, ['company_id'],
                                           context=context, load='_classic_write').get('company_id')
            ids_enc = self.pool.get('fiscal.encargo.empresa').search(cr, uid, [('company_id', '=', company_id)],
                                                                     context=context)
            if ids_enc:
                for id in ids_enc:
                    id_encargo = \
                        self.pool.get('fiscal.encargo.empresa').read(cr, uid, id, ['encargo_id'], context=context)['encargo_id'][0]
                    ids.append(id_encargo)
            if ids:
                args = [('id', 'in', ids)] + args
        if name:
            args1 = [('sigla', '=', name.upper())] + args
            ids = self.search(cr, uid, args1, limit=limit, context=context)
            if not ids:
                args1 = [('name', operator, name)] + args
                ids = self.search(cr, uid, args1, limit=limit, context=context)
        else:
            ids = self.search(cr, uid, args, limit=limit, context=context)
        return self.name_get(cr, uid, ids, context)

    def search(self, cr, uid, args=[], offset=0, limit=None, order=None, context=None, count=False):
        res = []
        context = context and context.copy() or {}
        if context.get('cfop_natureza') or context.get('company_id_verifica'):
            company_id = self.pool.get('res.users').read(cr, uid, uid, ['company_id'],
                                           context=context, load='_classic_write').get('company_id')

            ids_enc = self.pool.get('fiscal.encargo.empresa').search(cr, uid, [('company_id', '=', company_id)],
                                                                     context=context)
            if ids_enc:
                for id in ids_enc:
                    id_encargo = \
                        self.pool.get('fiscal.encargo.empresa').read(cr, uid, id, ['encargo_id'], context=context)['encargo_id'][0]
                    res.append(id_encargo)
            if args:
                res = super(fiscal_encargo, self).search(cr, uid, args, offset, limit, order, context, count)
        else:
            res = super(fiscal_encargo, self).search(cr, uid, args, offset, limit, order, context, count)

        return res

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if 'sigla' in vals and vals['sigla']:
            vals['sigla'] = vals['sigla'].upper()
        res = super(fiscal_encargo, self).create(cr, uid, vals, context=context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if 'sigla' in vals:
            if vals['sigla']:
                vals['sigla'] = vals['sigla'].upper()
        res = super(fiscal_encargo, self).write(cr, uid, ids, vals, context)
        return res

    def unlink(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        raise osv.except_osv(_('Atencao'), _('Desative o encargo ao inves de exclui-lo!'))
