# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class fiscal_encargo_empresa(osv.Model):
    _name = 'fiscal.encargo.empresa'
    _inherit = 'fiscal.encargo.empresa'

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not len(ids):
            return []
        reads = self.read(cr, uid, ids, ['encargo_id', 'id'], context=context)
        res = []
        for record in reads:
            name = record['encargo_id'][1]
            res.append((record['id'], name))
        return res

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        # Bloco inserido na versao 3G1, para evitar erro na insercao de dados do arquivo local.xml
        # em bases que já tem local cadastrado.
        # TODO: Pode ser removido apos a versao  4A1
        if context.get('install_mode') and context['install_mode']:
            args = [('company_id', '=', vals['company_id']), ('encargo_id', '=', vals['encargo_id'])]
            _id = self.search(cr, uid, args, context=context)
            if _id:
                return _id[0]
        # Fim do Bloco #

        context['sig_force_company'] = True
        result = super(fiscal_encargo_empresa, self).create(cr, uid, vals, context)

        return result

    def search(self, cr, user, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        context['sig_force_company'] = True
        return super(fiscal_encargo_empresa, self).search(
            cr, user, args, offset, limit, order, context, count)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
