# -*- encoding: utf-8 -*-
__author__ = 'marcilene.ribeiro'

from openerp.osv import fields, osv


class fiscal_condicao_pagamento_pgview(osv.Model):
    _name = "fiscal.condicao.pagamento.pgview"
    _description = "View para visualizar condicao de pagamento."
    _auto = False
    _columns = {
        'id': fields.integer(),
        'data_cupom': fields.date('Data'),
        'data_nf': fields.date('Data'),
        'condicao_forma_id': fields.many2one('adm.condicao.forma', "Condicao Forma"),
        'forma_pagamento_id': fields.many2one('adm.forma.pgto', 'Forma de Pagamento'),
        'adm_condicao_id': fields.many2one('adm.condicao', "Condicao de Pagamento"),
        'valor_nf': fields.float('Valor', digits=(15, 2)),
        'valor_cupom': fields.float('Valor', digits=(15, 2)),
        'nf_id': fields.many2one('fiscal.nf.capa', 'NF ID'),
        'pessoa_id': fields.many2one('adm.pessoa'),
        'tipo_finalizadora': fields.selection([('D', 'Dinheiro'),
                                               ('H', 'Cheque'),
                                               ('T', 'Ticket'),
                                               ('C', 'Cartao'),
                                               ('O', 'Outros')], 'Tipo Finalizadora'),
        'tipo_cartao': fields.selection([('D', 'Debito'), ('C', 'Credito')], 'Tipo do Cartao'),

    }

    def init(self, cr):
        #user eh 1 pois eh fixo e o open nao permite remover o usuário root
        #aqui codigo copiado do open onde mostra a fixacao o id

        #The hard-coded super-user id (a.k.a. administrator, or root user).
        #SUPERUSER_ID = 1'''

        modulo_ecf_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, 1, 'ecf', context={})
        col_cupom_id = '' if not modulo_ecf_instalado else '  ecf_cupons_finalizacao.cupom_id as cupom_id, ecf_cupons_finalizacao.data as data_cupom, ecf_cupons_finalizacao.valor as valor_cupom,'
        cupom_left_join = '' if not modulo_ecf_instalado else 'left join ecf_cupons_finalizacao on ecf_cupons_finalizacao.finalizadora_id = adm_condicao_forma.id'
        cupom_finalizadora = '' if not modulo_ecf_instalado else ',adm_condicao_forma.tipo_finalizadora as tipo_finalizadora'
        cupom_over1 = '' if not modulo_ecf_instalado else ', xx.data_cupom'
        cupom_over2 = '' if not modulo_ecf_instalado else ', xx.cupom_id'
        cupom_orderby1 = '' if not modulo_ecf_instalado else ', data_cupom'
        cupom_orderby2 = '' if not modulo_ecf_instalado else ', cupom_id'

        sql = """
                    DROP VIEW IF EXISTS fiscal_condicao_pagamento_pgview;
                    CREATE OR REPLACE VIEW fiscal_condicao_pagamento_pgview AS
                                   ( SELECT  row_number() over (ORDER BY xx.data_nf""" + cupom_over1 + """,xx.condicao_forma_id""" + cupom_over2 + """,xx.pessoa_id) AS id,
                                            xx.*
                                   FROM (   select
                                       adm_condicao_forma.id as condicao_forma_id,
                                       adm_condicao_forma.forma_pagamento_id as forma_pagamento_id,
                                       adm_condicao_forma.id as adm_condicao_id,
                                       fiscal_condicao_pagamento.valor as valor_nf ,
                                       fiscal_condicao_pagamento.capa_id as nf_id,
                                       adm_forma_pgto.admfpg_cartao_pessoa_id as pessoa_id,
                                       adm_forma_pgto.tipo_cartao as tipo_cartao,
                                       """ + \
              col_cupom_id \
              + \
              """
                                       fiscal_nf_capa.data_emissao as data_nf
                                       """ + cupom_finalizadora + """
                                    from adm_condicao_forma

                                    left join adm_forma_pgto on adm_forma_pgto.id = adm_condicao_forma.forma_pagamento_id
                                    left join  fiscal_condicao_pagamento    on  fiscal_condicao_pagamento.condicao_forma_id = adm_condicao_forma.id
                                    left join   adm_condicao on adm_condicao.id = adm_condicao_forma.adm_condicao_id
                                    left join fiscal_nf_capa on fiscal_nf_capa.id = fiscal_condicao_pagamento.capa_id
                                    """ + cupom_left_join + """
                                    order by data_nf""" + cupom_orderby1 + """, condicao_forma_id""" + cupom_orderby2 + """, pessoa_id
                                            )
                                            AS xx
                                   );"""
        cr.execute(sql)
