# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv

class fiscal_modelo_nf(osv.Model):
    _name = 'fiscal.modelo.nf'
    _inherit = 'fiscal.modelo.nf'

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not len(ids):
            return {}
        reads = self.read(cr, uid, ids, ['fismnf_codigo', 'name'], context=context)
        res = []
        for record in reads:
            name = '%s - %s' % (record['fismnf_codigo'], record['name'])
            res.append((record['id'], name))
        return res

    def name_search(self, cr, uid, name='', args=[], operator='ilike', context=None, limit=100):
        context = context and context.copy() or {}
        ids = []
        ids = self.search(cr, uid, [('fismnf_codigo', operator, name)] + args, limit=limit, context=context)
        return self.name_get(cr, uid, ids)

    def verifica_codigo_modelo_fiscal(self, cr, uid, modelo_nf_id, context=None):

        """
                Verifica se o modelo eh fiscal ou nao
            :param cr:
            :param uid:
            :param modelo_nf_id: id do modelo
            :param context:
            return: boolean
              """
        context = context and context.copy() or {}
        if not modelo_nf_id:
            return False
        modelo_fiscal = True
        codigo_modelo = self.read(cr, uid, modelo_nf_id, ['fismnf_codigo']).get('fismnf_codigo')
        try:
            if int(codigo_modelo) >= 90:
                modelo_fiscal = False
        except ValueError:
            pass

        return modelo_fiscal

    def atualiza_flag_modelo_nfe(self, cr, uid, ids, flag_modelo_nfe, context=None):
        context = context and context.copy() or {}
        res = True
        if isinstance(ids, (int, long)):
            ids = [ids]
        obj_fis_mod_nf_ser = self.pool.get('fiscal.modelo.nf.series')
        mod_nf_series_ids = obj_fis_mod_nf_ser.search(cr, uid, [('modelo_nf_id', 'in', ids)],
                                                      context=context)
        if mod_nf_series_ids:
            res = obj_fis_mod_nf_ser.write(cr, uid, mod_nf_series_ids,
                                           {'flag_modelo_nfe': flag_modelo_nfe},
                                           context=context)
        return res

    def ajusta_tipo_modelo(self, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('fismnf_tipo_nfe'):
            vals['fismnf_tipo_nfe_servico'] = False

        if vals.get('fismnf_tipo_nfe_servico'):
            vals['fismnf_tipo_nfe'] = False

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        res = super(fiscal_modelo_nf, self).create(cr, uid, vals, context=context)
        if 'fismnf_tipo_nfe' in vals:
            self.atualiza_flag_modelo_nfe(cr, uid, res, vals.get('fismnf_tipo_nfe'), context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if 'fismnf_tipo_nfe' in vals:
            self.atualiza_flag_modelo_nfe(cr, uid, ids, vals.get('fismnf_tipo_nfe'), context)
        return super(fiscal_modelo_nf, self).write(cr, uid, ids, vals, context=context)

    def onchange_fismnf_tipo_nfe(self, cr, uid, ids, tipo_nfe, context=None):
        context = context and context.copy() or {}
        res = {}
        if tipo_nfe:
            res['fismnf_tipo_nfe_servico'] = False

        return {'value': res}

    def onchange_fismnf_tipo_nfe_servico(self, cr, uid, ids, tipo_nfse, context=None):
        context = context and context.copy() or {}
        res = {}
        if tipo_nfse:
            res['fismnf_tipo_nfe'] = False

        return {'value': res}