# -*- coding: utf-8 -*-

from openerp.osv import osv
from SigUtils import cpf, cnpj
from openerp.tools.translate import _


class nf_condicao_pagamento(osv.Model):
    _inherit = 'fiscal.condicao.pagamento'

    def fiscpg_onchange_condicao_pgto(self, cr, uid, ids, forma_pagto_id, condicao_forma_id,
                                      destinatario_id,fisnfc_modelo_serie,context={}):
        if ids and isinstance(ids, (list, tuple)):
            ids = ids[0]
        tipo_nota = None
        warning = {}
        res = {}
        if ids and isinstance(ids, int):
            tipo_nota = self.browse(cr, uid, ids).capa_id.tipo
        if not context.get('vindo_da_condicao'):
            res.update({'condicao_forma_id': False, 'fiscpg_tipo_cartao': False,
                        'fiscpg_nro_autorizacao_cartao': None})
        if forma_pagto_id:
            obj_adm_condicao_forma = self.pool.get('adm.condicao.forma')
            adm_condicao_forma_ids = obj_adm_condicao_forma.search(
                cr, uid, [('forma_pagamento_id', '=', forma_pagto_id)], context=context)
            if len(adm_condicao_forma_ids) == 1:
                res.update({'condicao_forma_id': adm_condicao_forma_ids[0]})
            browse_forma_pagamento = self.pool.get('adm.forma.pgto').browse(
                cr, uid, forma_pagto_id, context)
            res['fiscpg_forma_pagamento_cheque'] = \
                browse_forma_pagamento.admfpg_documento_tipo_id.sigla == 'CHQ'
            tipo_cartao = browse_forma_pagamento.cartao_credito_debito
            res['fiscpg_tipo_cartao'] = tipo_cartao
            if tipo_cartao and tipo_nota == 'S':
                if res.get('fiscpg_nro_autorizacao_cartao'):
                    del res['fiscpg_nro_autorizacao_cartao']
                else:
                    res['fiscpg_nro_autorizacao_cartao'] = None
            if tipo_nota == 'E':
                res['fiscpg_nro_autorizacao_cartao'] = '-'
            else:
                res['fiscpg_nro_autorizacao_cartao'] = '-'
            if condicao_forma_id  and fisnfc_modelo_serie == '02D':
                if not destinatario_id and not tipo_cartao:
                    tipo = obj_adm_condicao_forma.browse(
                        cr, uid, condicao_forma_id, context).adm_condicao_id.tipo
                    if tipo != 'V':
                        warning = {'title':'Aviso.',
                                   'message': 'Para nota fiscal modelo 02 e serie D sem cliente '
                                              'informado sao permitidas somente condicoes de '
                                              'pagamento a vista.'}
                        res['condicao_forma_id'] = False
        return {'value': res, 'warning': warning}

    def fiscpg_onchange_cpf_cnpj(self, cr, uid, ids, cpf_cnpj):
        """
        Metodo invocado na saida do campo cpf/cnpj da tela.
        Valida o cpf/cnpj e caso esteja correto, devolve o cpf/cnpj formatado
        """
        warning = {}
        import re

        if cpf_cnpj:
            res = True
            cpf_cnpj = re.sub('[^0-9]', '', cpf_cnpj)

            if len(cpf_cnpj) == 11:
                nr = cpf.Cpf()
                msg = _('CPF Invalido!  Digite Novamente!')
                res = nr.validar(cpf_cnpj)
            if len(cpf_cnpj) == 14:
                nr = cnpj.Cnpj()
                msg = _('CNPJ Invalido!  Digite Novamente!')
                res = nr.validar(cpf_cnpj)
            if not res:
                warning = {'title': _('Erro na validacao')}
                warning['message'] = msg
            else:
                val = re.sub('[^0-9]', '', cpf_cnpj)
                if len(val) == 14:
                    cpf_cnpj = "%s.%s.%s/%s-%s" % (val[0:2], val[2:5], val[5:8], val[8:12], val[12:14])
                elif len(val) == 11:
                    cpf_cnpj = "%s.%s.%s-%s" % (val[0:3], val[3:6], val[6:9], val[9:11])
                return {'value': {'fiscpg_chq_emitente': cpf_cnpj}}

        return {'warning': warning, 'value': {'fiscpg_chq_emitente': ''}}

