# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class fiscal_nf_parcelas(osv.Model):
    _name = 'fiscal.nf.parcelas'
    _inherit = 'fiscal.nf.parcelas'

    def onchange_vencimento(self, cr, uid, ids, vencimento):
        res = {}
        if vencimento:
            res['prazo'] = False
            res['prazo_tipo'] = False
        return {'value': res}

    def onchange_prazo(self, cr, uid, ids, prazo):
        res = {}
        if prazo:
            res['vencimento'] = False
        else:
            res['prazo_tipo'] = False
        return {'value': res}

    def onchange_prazo_tipo(self, cr, uid, ids, prazo_tipo):
        res = {}
        if prazo_tipo:
            res['vencimento'] = False
        else:
            res['prazo'] = False
        return {'value': res}

    # Deve-se verificar a condicao da exclusao de parcelas. Se a exclusao for exclusiva do sistema
    # e nao por intervensao do usuario, nao ha motivo para impedir a delecao dos registros;
    def desativar_parcelas(self, cr, user, ids, context=None):
        """
        Desativa as parcelas. As parcelas nao podem ser excluidas.

        :param cr: a linha atual do cursor do banco de dados,
        :param uid: o ID do usuario utilizado para a verificacao de perfil,
        :param ids: lista dos IDs,
        :param context: um dicionario padrao para valores contextuais,
        :type cr: object
        :type uid: int
        :type ids: long|list[long]
        :type context: dict
        :return: verdadeiro se a desativacao dos registos das parcelas foi efetuado com sucesso.
        :rtype: bool
        """

        context = context and context.copy() or {}

        return self.write(cr, user, ids, dict(active=False), context)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
