# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class fiscal_tributacao(osv.Model):
    _name = 'fiscal.tributacao'
    _inherit = 'fiscal.tributacao'

    def unlink(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        raise osv.except_osv(_('Atencao'), _('Desative a tributacao ao inves de exclui-la!'))

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if context.get('install_mode') and context['install_mode']:
            args = [('cst_id', '=', vals['cst_id']), ('encargo_id', '=', vals['encargo_id'])]
            _id = self.search(cr, uid, args, context=context)
            if _id:
                return _id[0]
        result = super(fiscal_tributacao, self).create(cr, uid, vals, context)
        return result

    def search(self, cr, user, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        res = super(fiscal_tributacao, self).search(
            cr, user, args, offset, limit, order, context, count)
        if context.get('fisnat_filtrar_por_tipo') and not count:
            ids = []
            for _id in res:
                brw_cst = self.browse(cr, user, _id).cst_id
                if brw_cst and (
                        brw_cst.fiscst_tipo_movimento == context.get('fisnat_filtrar_por_tipo') or
                        brw_cst.fiscst_tipo_movimento == 'A'):
                    ids.append(_id)
            res = ids
        return res

    def name_search(self, cr, user, name='', args=None, operator='ilike', context=None, limit=100):
        context = context and context.copy() or {}
        ids = self.search(cr, user, args, context=context)
        if ids:
            args.append(('id', 'in', ids))
        else:
            return []
        res = super(fiscal_tributacao,self).name_search(
            cr, user, name, args, operator, context, limit)

        return res

    def fistri_onchange_encargo(self, cr, uid, ids, encargo_id, context=None):
        """
        Metodo responsavel por fazer alteracoes em atribuos ao alterar o encargo
        :param cr: Cursor do openerp
        :type uid: Usuario que esta executando a operacao
        :type ids: Lista de ids dos registros
        :type encargo_id: Id do encargo
        :type context: Dicionario com valores contextuais
        :return: Retorna um dicionario com as alteracoes para os campos desejados
        :rtype: dict
        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        res = {'cst_id': False}
        if encargo_id:
            res['fistri_encargo_sigla'] = self.pool.get('fiscal.encargo').browse(
                cr, uid, encargo_id, context).sigla

        return {'value': res}

    def fistri_onchange_cst(self, cr, uid, ids, cst_id, context=None):
        res = {}
        brw_cst = self.pool.get('fiscal.cst').browse(cr, uid, cst_id, context=context)
        res['fistri_cst_tipo_movimento'] = False
        res['fistri_cst_tipo'] = False
        if cst_id:
            res['fistri_cst_tipo_movimento'] = brw_cst.fiscst_tipo_movimento
            res['fistri_cst_tipo'] = brw_cst.tipo

        return {'value': res}


# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
