# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools import drop_view_if_exists


class fiscal_tributacao_agrupar_pgview(osv.Model):
    _inherit = "fiscal.tributacao.agrupar.pgview"

    def init(self, cr):
        drop_view_if_exists(cr, 'fiscal_tributacao_agrupar_pgview')
        cr.execute(""" create or replace view fiscal_tributacao_agrupar_pgview  as (
            select
                c.id as id,
                c.fisnit_capa_id as nf_id,
                c.fisnit_cfop_id as cfop_id,
                c.encargo_id as encargo_id,
                c.aliquota as aliquota,
                d.tipo as tipo,
                c.vr_base_calculo as vr_base_calculo,
                c.vr_encargo as vr_encargo,
                c.vr_reducao_base as vr_reducao_base,
                c.vr_icms_substituicao as vr_icms_substituicao
            from
                fiscal_nf_capa a
                left join fiscal_nf_item_tributacao c  on c.fisnit_capa_id = a.id
                left join fiscal_cst d on d.id = c.cst_id
            where c.id is not null
            );""")


    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        if not context.get('search_normal'):
            nf_id = args[0][2] if args else False
            if nf_id:
                nf_id = nf_id[0] or False
                if nf_id:
                    sql = '''select
                           min(id) as id
                          from fiscal_tributacao_agrupar_pgview
                           where nf_id =  %s
                          group by nf_id, cfop_id, encargo_id, aliquota,tipo''' % str(nf_id)
                    cr.execute(sql)
                    dados = cr.dictfetchall()
                    ids = [x['id'] for x in dados]
                    return ids
        res = super(fiscal_tributacao_agrupar_pgview, self).search(cr, uid, args, offset, limit, order, context, count)
        return res

    def read(self, cr, uid, ids, fields=[], context=None, load='_classic_read'):
        context = context and context.copy() or {}

        if context.get('nf_id'):
            sql_1 = '''select
                           id
                          from fiscal_tributacao_agrupar_pgview
                           where nf_id =  %s
                          ''' % str(context.get('nf_id'))
            cr.execute(sql_1)
            dados_1 = cr.dictfetchall()
            ids_tributos = [i['id'] for i in dados_1]

            sql = '''SELECT  nf_id,
                             CASE
                                  WHEN cfop_id IS NOT NULL THEN cfop_id
                                  ELSE (SELECT cfop_id
                                        FROM   fiscal_cfop_natureza
                                        WHERE  id =(  SELECT natureza_id
                                                      FROM   fiscal_nf_capa
                                                      WHERE  id = pgview.nf_id limit 1)limit 1)
                             END AS cfop_id,
                             encargo_id,
                             aliquota,
                             tipo,
                             sum(CASE
                                      WHEN vr_base_calculo > 0 THEN vr_base_calculo
                                      ELSE 0
                                 END) AS vr_base_calculo,
                             sum(CASE
                                      WHEN vr_encargo > 0 THEN vr_encargo
                                      ELSE 0
                                 END) AS vr_encargo,
                             sum(CASE
                                      WHEN vr_reducao_base > 0 THEN vr_reducao_base
                                      ELSE 0
                                 END) AS vr_reducao_base,
                             sum(CASE
                                      WHEN vr_icms_substituicao > 0 THEN vr_icms_substituicao
                                      ELSE 0
                                 END) AS vr_icms_substituicao
                     FROM     fiscal_tributacao_agrupar_pgview pgview
                     WHERE    id IN %s
                     GROUP BY nf_id,
                              aliquota,
                              cfop_id,
                              encargo_id,
                              tipo
                  ''' % (str(ids_tributos).replace('[', '(').replace(']', ')'))
            if ids_tributos:
                cr.execute(sql)
            dados = cr.dictfetchall()
            if dados:
                return dados
        res = super(fiscal_tributacao_agrupar_pgview, self).read(cr, uid, ids, fields, context=context, load=load)
        import time
        time.sleep(1)
        return res
