# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class fiscal_tributacao_encargos(osv.Model):
    """
    Tabela de tributacao
    """
    _name = 'fiscal.tributacao.encargos'
    _inherit = 'fiscal.tributacao.encargos'

    def on_change_encargo_id(self, cr, uid, ids, encargo_id):
        ret_val = {}
        return {'value': ret_val}

    def onchange_modbcst(self, cr, uid, ids, modbcst):
        val = {}
        if modbcst:
            if modbcst == '4':
                val = {'value': {'valor_pauta': False, 'mva': False}}
            if modbcst == '5':
                val = {'value': {'mva': False, 'valor_pauta': False}}
        return val

    def onchange_verifica_encargo(self, cr, uid, ids, encargo, empresa=False, context=None):
        context = context and context.copy() or {}
        res = {}
        value = {}
        value['tributacao_id'] = False
        value['cst_id'] = False
        if encargo:
            encargo_tipo = self.pool.get('fiscal.encargo').read(cr, uid, encargo, ['cst_ids', 'tipo_encargo'], context=context)
            # mudou o encargo, limpa os campos abaixo


            #            cst_ids =self.pool.get('fiscal.cst').search(cr,uid,[('encargo_id', '=', encargo)])
            if len(encargo_tipo.get('cst_ids', [])) == 1:
                value['cst_id'] = encargo_tipo.get('cst_ids', [])[0]
                value.update(self.onchange_verifica_cst(cr, uid, ids, encargo, value['cst_id']).get('value', {}))

            if 'tipo_encargo' in encargo_tipo:
                if encargo_tipo['tipo_encargo'] == 'E':
                    value['encargo_cidade'] = True
                if encargo_tipo['tipo_encargo'] == 'F':
                    value['encargo_uf'] = True
                    value['encargo_cidade'] = True
            res['value'] = value
        return res

    def onchange_verifica_cst(self, cr, uid, ids, encargo_id, cst_id, context=None):
        context = context and context.copy() or {}
        res = {}
        value = {}
        value['tributacao_id'] = False
        if cst_id:
            tributos_ids = self.pool.get('fiscal.tributacao').search(cr, uid, [('encargo_id', '=', encargo_id),
                                                                               ('cst_id', '=', cst_id)],
                                                                     context=context)
            if tributos_ids and len(tributos_ids) == 1:
                value['tributacao_id'] = tributos_ids[0]
        res['value'] = value
        return res

    def read(self, cr, uid, ids, fields=None, context=None, load='_classic_read'):
        if not fields:
            fields = []
        context = context and context.copy() or {}
        res = super(fiscal_tributacao_encargos, self).read(cr, uid, ids, fields=fields, context=context, load=load)
        return res

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        obj_fiscal_cst = self.pool.get('fiscal.cst')
        obj_fiscal_encargo = self.pool.get('fiscal.encargo')
        obj_fiscal_tributacao = self.pool.get('fiscal.tributacao')
        encargo_id = vals.get('encargo_id')
        tributacao_id = vals.get('tributacao_id')
        if not self.valida_encargo_tributacao(cr, uid, encargo_id, tributacao_id):
            encargo_sigla = obj_fiscal_encargo.browse(cr, uid, encargo_id).sigla
            encargo_tributacao_sigla = obj_fiscal_tributacao.browse(
                cr, uid, tributacao_id, context).encargo_id.sigla
            raise osv.except_osv(_('Atencao'), _ ('O encargo informado e diferente do encargo '
                                                  'cadastrado na tributacao!'
                                                  '\nEncargo informado: %s '
                                                  '\nEncargo tributacao: %s'
                                                  % (encargo_sigla, encargo_tributacao_sigla)))
        encargo = encargo_id and obj_fiscal_encargo.browse(cr, uid, encargo_id).name or str()
        if not vals.get('cst_id'):
            brw_item = vals.get('produto_id') and self.pool.get('estoque.produto').browse(
                cr, uid, vals.get('produto_id'), context)
            codigo = brw_item and brw_item.codigo or str()
            item = brw_item and brw_item.name or str()
            item = '{0} - {1}'.format(codigo, item) if item else '** Nao informado **'
            raise osv.except_osv(_('Atencao!'),
                                 _('Nao existe CST cadastrado para o encargo %s do item %s.' %
                                   (encargo, item)))
        cst = obj_fiscal_cst.browse(cr, uid, vals.get('cst_id')).name
        if vals.get('tipo_tributacao'):
            brw_fiscal_cst = obj_fiscal_cst.browse(cr, uid, vals.get('cst_id'))
            fiscst_tipo_movimento = brw_fiscal_cst.fiscst_tipo_movimento
            tipo_tributacao = vals.get('tipo_tributacao')
            if (tipo_tributacao == 'E' and fiscst_tipo_movimento not in ('E', 'A')) or \
                    (tipo_tributacao == 'T' and fiscst_tipo_movimento not in ('S', 'A')):
                raise osv.except_osv(_('Atencao!'),
                                     _('O tipo de tributacao diverge do tipo de movimento do cst'))
        else:
            raise osv.except_osv(_('Atencao!'),
                                 _('O encargo: %s e o cst: %s nao encontram-se cadastrados na '
                                   'tributacao.') % (encargo, cst))
        res = super(fiscal_tributacao_encargos, self).create(cr, uid, vals, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, list):
            id = ids[0]
        else:
            id = ids
        if vals.get('cst_id'):
            cst_id = vals.get('cst_id')
            fiscst_tipo_movimento = self.pool.get('fiscal.cst').browse(cr, uid,
                                                                       cst_id).fiscst_tipo_movimento
        else:
            fiscst_tipo_movimento = self.browse(cr, uid, id).cst_id.fiscst_tipo_movimento
        if vals.get('tipo_tributacao'):
            tipo_tributacao = vals.get('tipo_tributacao')
        else:
            tipo_tributacao = self.browse(cr, uid, id).tipo_tributacao
        if fiscst_tipo_movimento and tipo_tributacao:
            if (tipo_tributacao == 'E' and fiscst_tipo_movimento not in ('E', 'A')) or \
                    (tipo_tributacao == 'T' and fiscst_tipo_movimento not in ('S', 'A')):
                raise osv.except_osv(_('Atencao'), _('O tipo de tributacao diverge do tipo de movimento do cst'))
        if (vals.get('encargo_id') or vals.get('cst_id')) and not vals.get('tributacao_id'):
            browse_tributacao_encargo = self.browse(cr, uid, id)
            if vals.get('encargo_id'):
                encargo = self.pool.get('fiscal.encargo').browse(cr, uid, vals.get('encargo_id')).name
            else:
                encargo = browse_tributacao_encargo.encargo_id.name
            if vals.get('cst_id'):
                cst = self.pool.get('fiscal.cst').browse(cr, uid, vals.get('cst_id')).name
            else:
                cst = browse_tributacao_encargo.cst_id.name
            raise osv.except_osv(_('Atencao'), _('O encargo: %s e o cst: %s nao encontram-se cadastrados na tributacao.') % (
                encargo, cst))
        if vals.get('encargo_id') or vals.get('tributacao_id'):
            if all([vals.get('encargo_id'), vals.get('tributacao_id')]):
                encargo_id = vals.get('encargo_id')
                tributacao_id = vals.get('tributacao_id')
            elif vals.get('encargo_id'):
                tributacao_id = self.browse(cr, uid, id).tributacao_id.id
                encargo_id = vals.get('encargo_id')
            else:
                tributacao_id = vals.get('tributacao_id')
                encargo_id = self.browse(cr, uid, id).encargo_id.id
            encargo_valido = self.valida_encargo_tributacao(cr, uid, encargo_id, tributacao_id)
            if not encargo_valido:
                encargo_sigla = self.browse(cr, uid, id).encargo_id.sigla
                obj_fiscal_tributacao = self.pool.get('fiscal.tributacao')
                encargo_tributacao_sigla = obj_fiscal_tributacao.browse(cr, uid,
                                                                        tributacao_id).encargo_id.sigla
                raise osv.except_osv(_('Atencao'), _ ('O encargo informado e diferente do encargo '
                                                      'cadastrado na tributacao!\n'
                                                      'Encargo informado: %s '
                                                      '\nEncargo tributacao: %s'
                                                      % (encargo_sigla, encargo_tributacao_sigla)))
        res = super(fiscal_tributacao_encargos, self).write(cr, uid, ids, vals, context)
        return res

    def valida_encargo_tributacao(self, cr, uid, encargo_id, tributacao_id):
        """
        @Parametros: id do encargo (fiscal.encargo) - Tipo int
                     id da tributacao (fiscal.tributacao) - Tipo int
        @Funcao: Verifica se o encargo que esta sendo cadastrado no item eh o mesmo
                 cadastrado para tributacao
        @Retorno: boolean sendo verdadeiro caso encargo seja igual ao encargo_id cadastrado
                  na tributacao
        """

        obj_fiscal_tributacao = self.pool.get('fiscal.tributacao')
        fis_trib_encargo_id = \
            tributacao_id and obj_fiscal_tributacao.browse(cr, uid, tributacao_id).encargo_id.id

        return encargo_id == fis_trib_encargo_id

    def valida_cst_pis_cofins(self, cr, uid, produto_id, context=None):
        """
        @Parametros: id do produto - Tipo int
        @Funcao: Verifica se o codigo do cst de PIS eh igual ao codigo do cst de COFINS
        @Retorno: Retorna um dicionario contendo o tipo de tributacao como chave onde o valor
                  da chave eh True caso sejam iguais, se nao o valor da chave eh False
        """
        def valida(tributacao_ids):
            cst_list = []
            for tributacao_id in tributacao_ids:
                cst_codigo = self.browse(cr, uid, tributacao_id).cst_id.codigo
                cst_list.append(cst_codigo)
            for cst in cst_list:
                if len(cst_list) == cst_list.count(cst):
                    return True
            return False
        context = context and context.copy() or {}
        obj_fiscal_encargo = self.pool.get('fiscal.encargo')
        encargo_ids = obj_fiscal_encargo.search(cr, uid, [('sigla', 'in', ['PIS', 'COFINS'])], context=context)
        tribenca_ids = self.search(cr, uid, [('produto_id', '=', produto_id),
                                             ('encargo_id', 'in', encargo_ids)], context=context)
        tipo_tributacoes = self.read_group(cr, uid, [('id', 'in', tribenca_ids)],
                                           ['tipo_tributacao'], ['tipo_tributacao'], context=context)
        res = {}
        for tipo_trib in tipo_tributacoes:
            tipo_tributacao = tipo_trib.get('tipo_tributacao')
            tributacao_for_tipo = self.search(cr, uid, [('id', 'in', tribenca_ids),
                                                        ('tipo_tributacao', '=', tipo_tributacao)], context=context)
            cst_valido = valida(tributacao_for_tipo)
            res.update({tipo_tributacao: cst_valido})
        return res

    def fisten_onchange_tipo_tributacao(self, cr, uid,  ids, tipo_tributacao, context):
        context = context and context.copy() or {}
        return {'value': {'cst_id': False,
                          'tributacao_id': False,
                          'fisten_tip_trib_cst': self.fisten_get_tipo_trib_cst(cr, uid, ids,
                                                                               tipo_tributacao,
                                                                               context)}}

    def fisten_get_tipo_trib_cst(self, cr, uid, ids, tipo_tributacao, context):
        if tipo_tributacao == 'E':
            res = ("E", "A")
        elif tipo_tributacao in ('P', 'C'):
            res = ("S", "A")
        elif tipo_tributacao == 'T':
            res = ("E", "A", "S")
        else:
            res = False
        return res

    def fisten_get_cst_tributacao(self, cr, user, item, encargo, tipo, context=None):
        """
        Retorna o CST e a tributacao em funcao do item (produto ou servico), encargo (PIS, COFINS, ICMS,
        IPI) e do tipo de tributacao (entrada, contribuinte, produtor rural ou todos/consumidor final).

        :param cr: o cursor do banco de dados
        :param user: o ID do usuario utilizado para a verificacao de perfil
        :param item: o ID do item (produto ou servico)
        :param encargo: o ID do encargo
        :param tipo: o tipo de tributacao ("E", "C", "P" ou "T")
        :param context: um dicionario padrao para valores contextuais
        :type cr: object
        :type user: int
        :type item: long
        :type encargo: long
        :type tipo: str
        :type context: dict
        :return: o ID do CST e o ID da tributacao
        :rtype: tuple

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """
        context = context and context.copy() or {}
        tributacao_encargo_ids = self.search(
            cr, user, [('produto_id', '=', item), ('encargo_id', '=', encargo),
                       ('tipo_tributacao', '=', tipo)], context=context)

        # Desconsidera as tributacoes de NCM (produto_id = False)
        if item and tributacao_encargo_ids:
            dados_tributacao = self.read(
                cr, user, tributacao_encargo_ids[0], ['cst_id', 'tributacao_id'],
                context, '_classic_write')
            cst_id, tributacao_id = \
                dados_tributacao.get('cst_id'), dados_tributacao.get('tributacao_id')
        else:
            cst_id = tributacao_id = False

        return cst_id, tributacao_id

    def fisten_get_tributos(self, cr, uid, produto_id, pessoa_id, encargo, entrada=False,
                            context=None):
        """
        Metodo responsavel por retornar os ids dos tributos de acordo com o tipo de pessoa e
        produto informado.
        :param cr: a Vinha atual do cursor do banco de dados
        :param uid: ID do usuario utilizado para a verificacao de perfil
        :param produto_id: ID do produto a verificar o cfop
        :param pessoa_id: ID da pessoa a verificar
        :param encargo: Sigla do encargo a consultar
        :param entrada: Boolean informando se a movimentacao e de entrada ou nao
        :param context: um dicionario padrao para valores contextuais
        :type cr: cursor
        :type uid: int
        :type produto_id: int | long
        :type pessoa_id: int | long
        :type entrada: bool
        :type context: dict
        :return: Retorna a lista de ids dos encargos filtrados
        :rtype: int | long
        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        context = context and context.copy() or {}
        obj_pessoa = self.pool.get('adm.pessoa')
        encargo_id = self.pool.get('fiscal.encargo').search(cr, uid, [('sigla', '=', encargo)])
        if entrada:
            return self.fisten_get_tributo_entrada(cr, uid, produto_id, encargo_id, context)
        # usando 'read' para economizar muito mais tempo para notas com muitos itens ao contrario
        # de 'browse'
        context['super_read_adm_pessoa'] = True
        if pessoa_id and obj_pessoa.read(
                cr, uid, pessoa_id, ['admpes_fis_produtor_rural'], context=context)\
                .get('admpes_fis_produtor_rural'):
            return self.fisten_get_tributo_produtor_rural(cr, uid, produto_id, encargo_id,
                                                          context=context)
        elif pessoa_id and obj_pessoa.admpes_get_tipo_consumidor_final(
                cr, uid, pessoa_id, context) is False:
            return self.fisten_get_tributo_contribuinte(cr, uid, produto_id, encargo_id,
                                                        context=context)
        else:
            return self.fisten_get_tributo_todos(cr, uid, produto_id, encargo_id,
                                                 context=context)

    def fisten_get_tributo_contribuinte(self, cr, uid, produto_id, encargo_id, context=None):
        """
        Metodo responsavel por retornar os ids dos tributos para contribuinte de acordo com o
        produto_id e o encargo_id. Caso nao tenha tributo para contribuinte, retorna o tributo
        cadastrado como Todos/Consumidor Final
        :param cr: a Vinha atual do cursor do banco de dados
        :param uid: ID do usuario utilizado para a verificacao de perfil
        :param produto_id: ID do produto a verificar o cfop
        :param encargo_id: ID do encargo a filtrar
        :param context: um dicionario padrao para valores contextuais
        :type cr: cursor
        :type uid: int
        :type produto_id: int | long
        :type encargo_id: int
        :type context: dict
        :return: Retorna lista de ids dos tributos encontrados
        :rtype: int | long

        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        context = context and context.copy() or {}
        args = [('produto_id', '=', produto_id), ('encargo_id', 'in', encargo_id),
                ('tipo_tributacao', '=', 'C')]
        res = self.search(cr, uid, args, context=context)
        if not res:
            return self.fisten_get_tributo_todos(cr, uid, produto_id, encargo_id, context=context)
        return res

    def fisten_get_tributo_produtor_rural(self, cr, uid, produto_id, encargo_id, context=None):
        """
        Metodo responsavel por retornar os ids dos tributos para produtor_rural de acordo com o
        produto_id e o encargo_id. Caso nao tenha tributo para produtor_rural, retorna o tributo
        cadastrado como Todos/Consumidor Final
        :param cr: a Vinha atual do cursor do banco de dados
        :param uid: ID do usuario utilizado para a verificacao de perfil
        :param produto_id: ID do produto a verificar o cfop
        :param encargo_id: ID do encargo a filtrar
        :param context: um dicionario padrao para valores contextuais
        :type cr: cursor
        :type uid: int
        :type produto_id: int | long
        :type encargo_id: int
        :type context: dict
        :return: Retorna lista de ids dos tributos encontrados
        :rtype: int | long

        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        context = context and context.copy() or {}
        args = [('produto_id', '=', produto_id), ('encargo_id', 'in', encargo_id),
                ('tipo_tributacao', '=', 'P')]
        res = self.search(cr, uid, args, context=context)
        if not res:
            return self.fisten_get_tributo_todos(cr, uid, produto_id, encargo_id, context=context)
        return res

    def fisten_get_tributo_entrada(self, cr, uid, produto_id, encargo_id, context=None):
        """
        Metodo responsavel por retornar os ids dos tributos para entrada de acordo com o
        produto_id e o encargo_id. Caso nao tenha tributo para contribuinte, retorna o tributo
        cadastrado como Todos/Consumidor Final
        :param cr: a Vinha atual do cursor do banco de dados
        :param uid: ID do usuario utilizado para a verificacao de perfil
        :param produto_id: ID do produto a verificar o cfop
        :param encargo_id: ID do encargo a filtrar
        :param context: um dicionario padrao para valores contextuais
        :type cr: cursor
        :type uid: int
        :type produto_id: int | long
        :type encargo_id: int
        :type context: dict
        :return: Retorna lista de ids dos tributos encontrados
        :rtype: int | long

        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        context = context and context.copy() or {}
        args = [('produto_id', '=', produto_id), ('encargo_id', 'in', encargo_id),
                ('tipo_tributacao', '=', 'E')]
        res = self.search(cr, uid, args, context=context)
        if not res:
            return self.fisten_get_tributo_todos(cr, uid, produto_id, encargo_id, context=context)
        return res

    def fisten_get_tributo_todos(self, cr, uid, produto_id, encargo_id, context=None):
        """
        Metodo responsavel por retornar os ids dos tributos tributos cadastrado como
        Todos/Consumidor Final
        :param cr: a Vinha atual do cursor do banco de dados
        :param uid: ID do usuario utilizado para a verificacao de perfil
        :param produto_id: ID do produto a verificar o cfop
        :param encargo_id: ID do encargo a filtrar
        :param context: um dicionario padrao para valores contextuais
        :type cr: cursor
        :type uid: int
        :type produto_id: int | long
        :type encargo_id: int
        :type context: dict
        :return: Retorna lista de ids dos tributos encontrados
        :rtype: int | long

        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        context = context and context.copy() or {}
        args = [('produto_id', '=', produto_id), ('encargo_id', 'in', encargo_id),
                ('tipo_tributacao', '=', 'T')]
        return self.search(cr, uid, args, context=context)

    def fisten_getvalor_impostos(self, cr, uid, grade_ids, precos_venda, context=None):
        '''
        Calcula os impostos do produto retornando de cada tributacao cadastrada e o total
        :param cr: 
        :param uid: 
        :param grade_ids: 
        :param precos_venda: 
        :param context: 
        :return: dicionario onde a chave eh a grade que contem outro dicionario, onde as siglas dos 
        encargos + a palavra 'total' sao as chaves e o valor eh o proprio valor do imposto 
        '''
        context = context and context.copy() or {}
        if not isinstance(grade_ids, list):
            grade_ids = [grade_ids]

        SIGLAS = {'IRPJ': 'fistsn_aliq_irpj',
                  'CSLL': 'fistsn_aliq_csll',
                  'COFINS': 'fistsn_aliq_cofins',
                  'PIS' : 'fistsn_aliq_pis',
                  'INSS': 'fistsn_aliq_inss',
                  'ICMS': 'fistsn_aliq_icms'}
        obj_adm_utils = self.pool.get('adm.utils')
        res = {}
        simple_nacional = self.pool.get('adm.pessoa').verificar_empresa_simples_nacional(cr, uid)
        if simple_nacional:
            receita_anual = obj_adm_utils.admutl_get_parametros(cr, uid, 'fiscal.parametro',
                              ['fispar_receita_anual'], context=context).get('fispar_receita_anual')
            obj_trib_simples = self.pool.get('fiscal.tributacao.simples.nacional')
            trib_siples_ids = obj_trib_simples.search(cr, uid,
                                                 [('fistsn_valor_faturamento', '>', receita_anual)],
                                                  context=context, order='fistsn_valor_faturamento')
            if not trib_siples_ids:
                raise osv.except_osv(_('Atencao!'),
                                   _('Sem tributacao pelo simples nacional para faturamento de: %s')
                                     % receita_anual)

            dados_trib_simples = obj_trib_simples.read(cr, uid, trib_siples_ids[0],
                                   ['fistsn_aliq_irpj', 'fistsn_aliq_csll', 'fistsn_aliq_cofins',
                                    'fistsn_aliq_pis', 'fistsn_aliq_inss', 'fistsn_aliq_icms'],
                                                       context=context)

        campos = {'produto_id': {'tributacao_ids': {'tipo_tributacao': [],
                                                    'encargo_id': ['sigla'],
                                                    'tributacao_id': ['base', 'aliquota',
                                                                      'fistri_cst_tipo_movimento',
                                                                      'fistri_cst_tipo'],
                                                    'mva': {},
                                                    'fisten_aliquota_venda': {},
                                                   },
                                },
                 }
        sql = '''
            SELECT epg.id                                  AS grade_id,
                   ep.id                                   AS produto_id,
                   fte.tipo_tributacao                     AS tipo_tributacao,
                   fte.mva                                 AS mva,
                   COALESCE (fte.fisten_aliquota_venda, 0) AS aliquota_venda,
                   fe.sigla                                AS sigla,
                   ft.base                                 AS base, 
                   ft.aliquota                             AS aliquota, 
                   cst.fiscst_tipo_movimento               AS cst_tipo_movimento, 
                   cst.tipo                                AS cst_tipo                   
            FROM estoque_produto_grade            AS epg
            INNER JOIN estoque_produto            AS ep  ON ep.id = epg.produto_id
            INNER JOIN fiscal_tributacao_encargos AS fte ON fte.produto_id = ep.id
            INNER JOIN fiscal_tributacao          AS ft  ON ft.id = fte.tributacao_id
            INNER JOIN fiscal_encargo             AS fe  ON fe.id = fte.encargo_id
            INNER JOIN fiscal_cst                 AS cst ON cst.id = fte.cst_id
            WHERE epg.id IN ({grade_ids})
              AND cst.tipo IN ('T','TU')
              AND cst.fiscst_tipo_movimento != 'E'
              AND fte.tipo_tributacao = 'T'
              '''.format(grade_ids= ','.join(map(lambda x: "%s" % x, grade_ids)))
        cr.execute(sql)
        for dados in cr.dictfetchall():
            produto_id = dados.get('produto_id')
            grade_id = dados.get('grade_id')
            preco_venda_produto = precos_venda.get(produto_id)
            preco_venda = 0
            if preco_venda_produto:
                preco_venda = preco_venda_produto.get(grade_id) or \
                              preco_venda_produto.get('preco_venda')

            if not preco_venda:
                continue

            if simple_nacional and not dados.get('cst_tipo') == 'TU':
                campo = SIGLAS.get(dados.get('sigla'))
                aliquota = (dados_trib_simples.get(campo) or 0) / 100.0
            else:
                aliquota = (dados.get('aliquota') or 0) / 100.0

            base = (dados.get('base') or 0) / 100.0
            vr_tributacao = preco_venda * base * aliquota
            if dados.get('cst_tipo') == 'TU': # Tributado com substiuicao
                aliquota_venda = (dados.get('aliquota_venda') or 0) / 100.0
                mva = (dados.get('mva') or 0) / 100.0
                vr_trib_subs = (base + mva) * aliquota_venda
                vr_tributacao =  vr_trib_subs - vr_tributacao

            if not res.get(grade_id):
                res[grade_id] = {'total': 0.0 }

            res[grade_id][dados.get('sigla')] = vr_tributacao
            res[grade_id]['total'] += vr_tributacao

        return res

    def get_tributacao_encargos(self, cr, user, item_id, tipo_tributacao, context=None):
        tributacao_ids = item_id and self.search(
            cr, user, [('produto_id', '=', item_id), ('tipo_tributacao', '=', tipo_tributacao)],
            context=context)
        campos = ['encargo_id', 'cst_id', 'tributacao_id', 'modbcst', 'mva',
                  'fisten_aliquota_venda', 'valor_pauta']
        encargos = tributacao_ids and self.read(
            cr, user, tributacao_ids, campos, context, '_classic_write') or []
        encargo_ids = [encargo.get('encargo_id') for encargo in encargos]

        # Todos/Consumidor final se nao houver encargos para produtor rural ou contribuinte
        encargos += tipo_tributacao and tipo_tributacao in 'PC' and not encargos and self.read(
            cr, user, self.search(
                cr, user, [('produto_id', '=', item_id), ('tipo_tributacao', '=', 'T'),
                           ('encargo_id', 'not in', encargo_ids)], context=context) or 0, campos,
            context, '_classic_write') or []

        return encargos

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
