# -*- encoding: utf-8 -*-

import openerp.addons.web.http as http
from logging import getLogger
from openerp.tools import config
from SigUtils.sigerp import db_sig
from SigUtils import cpf, cnpj, datas, numero

_logger = getLogger("get_nfe")
_senha = 'estimg_remoto_767891'


_html_nao_encontrei = """
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
	<meta http-equiv="content-type" content="text/html; charset=utf-8"/>
	<title>SigERP - NFe</title>
</head>
<body lang="pt-BR" dir="ltr">
<p><font color="#00b6bd"><font face="DejaVu Sans, sans-serif"><font size="7" style="font-size: 56pt">OOPS!!!</font></font></font></p>
<p><font color="#00b6bd"><font face="DejaVu Sans, sans-serif"><font size="7" style="font-size: 32pt">Chave
de Nfe não encontrada!</font></font></font></p>
</body>
</html>
"""
_html_pagina_retorno = u"""
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
	<meta http-equiv="content-type" content="text/html; charset=utf-8"/>
	<title>SigERP - NFe</title>
</head>
<body lang="pt-BR" dir="ltr">
<p><font size="6" style="font-size: 26pt">Dados da Nfe</font></p>
<p><font size="4" style="font-size: 16pt">Destinatário: {destinatario}</font></p>
<p><font size="4" style="font-size: 16pt">Data: {data}</font></p>
<p><font size="4" style="font-size: 16pt">Valor: {valor}</font></p>
<p><font size="4" style="font-size: 16pt">Número / Série: {numero_nfe} / {serie_nfe}</font></p>
<p><a href="{link}"><font size="4" style="font-size: 16pt">Baixar XML</font></a></p>
<p><br/>
<br/>
</p>
</body>
</html>
"""
def _get_argdb():
    _db_user = config.get('db_user')
    _db_password = config.get('db_password')
    _db_host = config.get('db_host')
    _db_port = config.get('db_port')
    if not _db_password:
        _db_password = 'franca'
    if not _db_host:
        _db_host = '127.0.0.1'
    arg_db = {}
    if _db_host:
        arg_db.update({'host': _db_host})
    else:
        arg_db.update({'host': 'localhost'})
    if _db_port:
        arg_db.update({'port': _db_port or '5431'})
    if _db_user:
        arg_db.update({'user': _db_user})
    if _db_password:
        arg_db.update({'pwd': _db_password})
    return arg_db

class sc(http.Controller):
    _cp_path = '/nfe'

    @http.httprequest
    def xml(self, req, s_action=None, **kw):
        def _get_sem_nfe():
            dados = _html_nao_encontrei
            return dados

        """
        Modelo de url:
        http://localhost:8069/nfe/xml/mlapi/l/31210306272709000122550010000244491000919360.xml
        """

        arg_db = _get_argdb()
        _url = req.httprequest.base_url
        _logger.info('Buscar xml em: %s' % _url)
        _lista = _url.split('/')
        if len(_lista) < 8 or _lista[3].lower() != 'nfe' or _lista[4].lower() != 'xml':
            _logger.warn('Link da nfe invalido!')
            return _get_sem_nfe()

        _server = '%s//%s' % (_lista[0], _lista[2])
        _base = _lista[5]
        _link_download = _lista[6].lower()
        _chave = _lista[7]
        _id = ''
        for x in _chave:
            if x in ['0', '1','2','3','4','5','6','7','8','9']:
                _id += x
            else:
                break
        if not _id or len(_id) != 44:
            _logger.warn('Sem chave da nfe')
            return _get_sem_nfe()
        _db = db_sig(_base, **arg_db)
        _fields = ['nfe_xml_gerado', 'nfe_xml_auto', 'data_emissao', 'numero_nf', 'serie_nf', 'destinatario_id',
                   'vr_total_nf']
        _where = [('nfe_chave_acesso', '=', _id)]
        dados_nfe = _db.dbsSelect('fiscal_nf_capa', _fields, _where)
        if not dados_nfe:
            _logger.warn('NFe nao cadastrada')
            _db.conexao.close()
            return _get_sem_nfe()
        dados_nfe = dados_nfe[0]
        xml_gerado = dados_nfe.get('nfe_xml_gerado')
        _pos = xml_gerado.find('>') + 1
        xml_cab = xml_gerado[:_pos]
        xml_gerado = xml_gerado[_pos:]
        xml = xml_cab
        xml += '<nfeProc xmlns="http://www.portalfiscal.inf.br/nfe" versao="4.00">'
        xml += xml_gerado
        xml += dados_nfe.get('nfe_xml_auto')
        xml += '</nfeProc>'
        if _link_download == 'd':
            headers = [
                ('Content-Type', 'application/file'),
            ]
            _db.conexao.close()
            return req.make_response(xml, headers)

        _fields = ['cpf_cnpj', 'pessoa_tipo']
        _where = [('id', '=', dados_nfe.get('destinatario_id'))]
        dados_pessoa = _db.dbsSelect('adm_pessoa', _fields, _where)
        if dados_pessoa:
            dados_pessoa = dados_pessoa[0]
            if dados_pessoa.get('pessoa_tipo') == 'F':
                _cpf_cnpj = cpf.Cpf()
            else:
                _cpf_cnpj = cnpj.Cnpj()
            _destinatario = _cpf_cnpj.format(dados_pessoa.get('cpf_cnpj'))
        else:
            _destinatario = '1'
        _data = datas.getDataNoFormato(dados_nfe.get('data_emissao')[:10])
        _valor = numero.getNumeroEditado(dados_nfe.get('vr_total_nf'))
        _numero_nfe = numero.getNumeroEditado(dados_nfe.get('numero_nf'), 0)
        _serie_nfe = dados_nfe.get('serie_nf')
        _link = str('%s//%s/%s/%s/%s/d/%s' % (_lista[0], _lista[2], _lista[3], _lista[4], _lista[5], _lista[7]))
        headers = [
            ('Content-Type', 'text/html'),
        ]
        _pagina = _html_pagina_retorno.replace('{destinatario}', _destinatario)
        _pagina = _pagina.replace('{data}', _data)
        _pagina = _pagina.replace('{valor}', _valor)
        _pagina = _pagina.replace('{numero_nfe}', _numero_nfe)
        _pagina = _pagina.replace('{serie_nfe}', _serie_nfe)
        _pagina = _pagina.replace('{link}', _link)
        _db.conexao.close()
        return req.make_response(_pagina, headers)



