# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class adm_forma_pgto(osv.Model):
    """
    Heranca da classe adm_forma_pgto.
    """
    _inherit = 'adm.forma.pgto'  # admfpg

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        obj_adm_util = self.pool.get('adm.utils')
        obj_adm_condicao_forma = self.pool.get('adm.condicao.forma')
        fiscal_parametros = obj_adm_util.admutl_get_parametros(
            cr, uid, 'fiscal', ['condicao_pgto_id', 'cupom_nota_condicao_id',
                                'condicao_pgto_transferencia_id'])
        condicao_padrao_id = fiscal_parametros.get('condicao_pgto_id')
        condicao_cupom_id = fiscal_parametros.get('cupom_nota_condicao_id')
        condicao_transferencia_id = fiscal_parametros.get('condicao_pgto_transferencia_id')
        condicao_forma_ids = [condicao_padrao_id, condicao_cupom_id, condicao_transferencia_id]
        if 'active' in vals and not vals.get('active') and any(condicao_forma_ids):
            condicao_forma_ids = filter(lambda i: i, condicao_forma_ids)
            list_forma = []
            adm_condicao_forma_dados = obj_adm_condicao_forma.read(
                cr, uid, condicao_forma_ids, ['forma_pagamento_id'], context=context, load='_classic_write')
            map(lambda i: list_forma.append(i.get('forma_pagamento_id')), adm_condicao_forma_dados)
            str_forma = ''
            for forma_id in ids:
                if forma_id in list_forma:
                    name = self.browse(cr, uid, forma_id).name
                    str_forma += '\n %s' % name
            if str_forma:
                raise osv.except_osv(_('Atencao'),
                                     _('A(s) forma(s) de pagamento abaixo nao pode(m) ser '
                                       'inativada(s) pois esta(ao) em uso nas condicoes de '
                                       'pagamento do parametro fiscal: %s' % str_forma))
        res = super(adm_forma_pgto, self).write(cr, uid, ids, vals, context)

        return res

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
