# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields

MEIO_PAGAMENTO = [
    ('01', 'Dinheiro'),
    ('02', 'Cheque'),
    ('03', 'Cartao de credito'),
    ('04', 'Cartao de debito'),
    ('05', 'Credito loja'),
    ('10', 'Vale alimentacao'),
    ('11', 'Vale refeicao'),
    ('12', 'Vale presente'),
    ('13', 'Vale combustivel'),
    ('14', 'Duplicata mercantil'),
    ('15', 'Boleto bancario'),
    ('16', 'Deposito bancario'),
    ('17', 'Pagamento instantaneo (PIX)'),
    ('18', 'Transferencia bancaria, Carteira digital'),
    ('19', 'Programa de fidelidade, Cashback, Credito virtual'),
    ('90', 'Sem pagamento'),
    ('99', 'Outros')
]


class adm_forma_pgto(osv.Model):
    """
    Heranca da classe adm_forma_pgto.
    """
    _inherit = 'adm.forma.pgto'  # admfpg
    _columns = {
        'admfpg_boleto': fields.boolean('Imprimir boleto', help="Imprimir boleto automaticamente ao emitir uma nota fiscal"),
        'admfpg_local_cobranca_id': fields.many2one("financeiro.local.cobranca", 'Local de cobranca',
                                                   domain=[('tipo', '=', 'B')]),
        'admfpg_natureza_id': fields.many2one('financeiro.natureza.cobranca', 'Natureza de cobranca'),
        'admfpg_documento_tipo_id': fields.many2one('documento.documento.tipo', 'Tipo de documento',
                                                    ondelete='restrict'),
        'admfpg_promissoria': fields.boolean('Imprimir promissoria'),
        'admfpg_tipo': fields.selection(MEIO_PAGAMENTO, 'Forma de pagamento'),
        'admfpg_conta_tesouraria_id': fields.many2one('financeiro.tesouraria.contas',
                                                      'Conta tesouraria', select=True),
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
