# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class adm_condicao(osv.Model):
    """
    Tabela que contem as condicoes de pagamentos.
    """
    _inherit = 'adm.condicao'

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        obj_adm_util = self.pool.get('adm.utils')
        obj_adm_condicao_forma = self.pool.get('adm.condicao.forma')
        fiscal_parametros = obj_adm_util.admutl_get_parametros(
            cr, uid, 'fiscal', ['condicao_pgto_id', 'cupom_nota_condicao_id',
                                'condicao_pgto_transferencia_id'])
        condicao_padrao_id = fiscal_parametros.get('condicao_pgto_id')
        condicao_cupom_id = fiscal_parametros.get('cupom_nota_condicao_id')
        condicao_transferencia_id = fiscal_parametros.get('condicao_pgto_transferencia_id')
        condicao_forma_ids = [condicao_padrao_id, condicao_cupom_id, condicao_transferencia_id]
        if 'active' in vals and not vals.get('active') and any(condicao_forma_ids):
            condicao_forma_ids = filter(lambda i: i, condicao_forma_ids)
            list_condicao = []
            adm_condicao_forma_dados = obj_adm_condicao_forma.read(
                cr, uid, condicao_forma_ids, ['adm_condicao_id'], context=context, load='_classic_write')
            map(lambda i: list_condicao.append(i.get('adm_condicao_id')), adm_condicao_forma_dados)
            str_condicao = ''
            for condicao_id in ids:
                if condicao_id in list_condicao:
                    name = self.browse(cr, uid, condicao_id).name
                    str_condicao += '\n %s' % name
            if str_condicao:
                raise osv.except_osv(_('Atencao'),
                                     _('A(s) condicao(oes) de pagamento abaixo nao pode(m) ser '
                                       'inativada(s) pois esta(ao) em uso nas condicoes de '
                                       'pagamento do parametro fiscal: %s' % str_condicao))
        res = super(adm_condicao, self).write(cr, uid, ids, vals, context=context)
        return res
