# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2014 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2014, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


# noinspection PyPep8Naming,PyAbstractClass
class compras_ultima_compra(osv.TransientModel):
    """
    Ultimas compras de um item.
    """
    _name = 'compras.ultima.compra'
    _columns = {
        'produto_id': fields.many2one('estoque.produto', 'Item'),
        'grade_id': fields.many2one('estoque.produto.grade', 'Grade'),
        'pessoa_id': fields.many2one('adm.pessoa', 'Fornecedor'),
        'nf_id': fields.many2one('fiscal.nf.capa', 'Nota fiscal'),
        'data': fields.date('Data da compra'),
        'quantidade': fields.float('Quantidade'),  # Em unidade simples
        'valor': fields.float('Valor do item'),   # Valor unitario
    }

    _order = 'data desc'

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
