# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv


class estoque_categoria(osv.Model):
    """
    Tabela de Categoria de produtos (Segmentacao)
    """
    _inherit = 'estoque.categoria'

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not len(ids):
            return []
        reads = self.read(cr, uid, ids, ['name', 'parent_id', 'ncm_id'], context=context)
        res = []
        for record in reads:
            name = record['name']
            if record.get('parent_id'):
                name = record['parent_id'][1] + '/' + name
            if record.get('ncm_id') and 'cadastro_produto_categoria' in context:
                ncm_id = record['ncm_id']
                ncm_id = ncm_id[0]
                codigo = self.pool.get('fiscal.ncm').read(cr, uid, ncm_id, ['codigo'],
                                                          context=context)
                name = name + ' - NCM: ' + codigo[0]['codigo']
            res.append((record['id'], name))
        return res
