#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv


class estoque_inventario_contagem(osv.Model):
    _name = 'estoque.inventario.contagem'
    _inherit = 'estoque.inventario.contagem'


    def atualiza_vals_com_trib(self, vals, produto_id, dict_trib, context=None):
        context = context and context.copy() or {}
        super(estoque_inventario_contagem, self).atualiza_vals_com_trib(vals, produto_id, dict_trib,
                                                                        context)
        if dict_trib.get(produto_id):
            vals['estict_tributacao_id'] = dict_trib.get(produto_id)

    def get_dict_trib(self, cr, uid, produto_ids, dict_trib, context=None):
        context = context and context.copy() or {}
        super(estoque_inventario_contagem, self).get_dict_trib(cr, uid, produto_ids, dict_trib,
                                                               context)
        icms_id = self.pool.get('fiscal.encargo').search(cr, uid, [('sigla', '=', 'ICMS')],
                                                         context=context)
        args = [('produto_id', 'in', produto_ids), ('tipo_tributacao', '=', 'T'),
                ('encargo_id', 'in', icms_id)]
        tributacao_ids = self.pool.get('fiscal.tributacao.encargos').search(cr, uid, args,
                                                                            context=context)
        # Na regra de negocio atual, existe apenas um tributo para o tipo de tributacao e encargo
        if not tributacao_ids:
            return

        for i in self.pool.get('fiscal.tributacao.encargos').read(cr, uid, tributacao_ids,
                           ['tributacao_id', 'produto_id'], context=context, load='_classic_write'):
            dict_trib[i.get('produto_id')] = i.get('tributacao_id')

    # def salvar_contagem(self, cr, uid, inventario_id, produto_id, grade_id, local_id, vals,
    #                     tipo_contagem, contagem_id, grade_ids_sem_contagem=[], context=None):
    #     """
    #     Este metodo salva a contagem gerada, para o modulo fiscal este metodo e
    #     sobrescrito para salvar tambem a tributacao do item
    #     :param cr: Cursor do banco
    #     :param uid: Usuario que esta executando a operacao:
    #     :param inventario_id: Id do inventario gerado
    #     :param produto_id: Id do produto
    #     :param grade_id: Id da grade
    #     :param local_id: Id do local
    #     :param context: Dicionario contendo os valores contextuais
    #     :type cr: Cursor
    #     :type uid: int
    #     :type inventario_id: int
    #     :type produto_id: int
    #     :type grade_id: int
    #     :type local_id: int
    #     :type context: dict
    #     :return: Retorna o id do registro que foi criado ou alterado
    #     :rtype: long
    #     :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
    #     """
    #     icms_id = self.pool.get('fiscal.encargo').search(cr, uid, [('sigla', '=', 'ICMS')],
    #                                                      context=context)
    #     args = [('produto_id', '=', produto_id), ('tipo_tributacao', '=', 'T'),
    #             ('encargo_id', 'in', icms_id)]
    #     tributos = self.pool.get('fiscal.tributacao.encargos').search(cr, uid, args,
    #                                                                   context=context)
    #     # Na regra de negocio atual, existe apenas um tributo para o tipo de tributacao e encargo
    #     if tributos:
    #         vals['estict_tributacao_id'] = self.pool.get('fiscal.tributacao.encargos').read(
    #             cr, uid, tributos[0], ['tributacao_id'], context=context).get('tributacao_id')[0]
    #     return super(estoque_inventario_contagem, self).salvar_contagem(
    #         cr, uid, inventario_id, produto_id, grade_id, local_id, vals, tipo_contagem,
    #         contagem_id, grade_ids_sem_contagem=grade_ids_sem_contagem, context=context)
