#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv


class estoque_inventario_oficial(osv.Model):

    _inherit = 'estoque.inventario.oficial'

    def estiof_gerar_inventario_oficial(self, cr, uid, contagem_id, saldo, ultimo_custo,
                                        custo_medio_contabil, context=None):
        """
        Este metodo sobrescreve o metodo estiof_gerar_inventario_oficial do modulo estoque
        acrescentando a tributacao a ser gravada em estoque.inventario.oficial.
        :param cr: Cursor do openerp
        :param uid: Id do usuario do openerp
        :param contagem_id: Id da contagem salva em estoque.inventario.contagem
        :param saldo: Saldo contado para o inventario oficial
        :param ultimo_custo: Ultimo cuso para o inventario oficial
        :param custo_medio_contabil: Custo medio contabil para o inventario oficial
        :param context: Dicionario contendo valores contextuais
        :type cr: Cursor
        :type uid: int
        :type contagem_id: int | long
        :type saldo: float
        :type ultimo_custo: float
        :type custo_medio_contabil: float
        :type context: dict
        :return: Retorna o id do registro criado
        :rtype: long
        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        context = context and context.copy() or {}
        tributacao_id = self.pool.get('estoque.inventario.contagem').browse(
            cr, uid, contagem_id, context=context).estict_tributacao_id.id
        res = super(estoque_inventario_oficial, self).estiof_gerar_inventario_oficial(
            cr, uid, contagem_id, saldo, ultimo_custo, custo_medio_contabil, context)
        self.write(cr, uid, res, {'estiof_tributacao_id': tributacao_id}, context=context)
        return res