# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class estoque_parametro(osv.Model):
    _name = 'estoque.parametro'
    _inherit = 'estoque.parametro'
    _columns = {
        'estpar_preco_para_transferencia': fields.selection(
            [('U', 'Ultimo custo'),
             ('M', 'Custo medio'),
                 ('R', 'Reposicao'),
             ('C', 'Corrigido'),
             ('V', 'Venda')], 'Preco para transferencia'),
        'estpar_cancel_nf_pedido_validado': fields.boolean(
            'Cancel. NF voltar pedido p/Validado',
            help=u'Se marcado, ao cancelar uma NF de venda o pedido será retornado para o estado '
                 u'validado'),
        'estpar_local_entrada_transf_padrao_id': fields.many2one(
            'estoque.local', _('Entrada padrao por transferencia'), ondelete='restrict',
            help='Informe um local para entradas por transferencia.'),
        'estpar_local_entrada_devol_padrao_id': fields.many2one(
            'estoque.local', _('Entrada padrao por devolucao'), ondelete='restrict',
            help='Informe um local para entradas por devolucao.'),
        'estpar_desc_complementar_grade_nota': fields.boolean(
            'Exibir Desc. Complementar da grade na NF',
            help=u'Se marcado, ao emitir uma nota, vai cocatenar o nome do produto com '
                 u'a descricao complementar na grade para ser mostrado no Danfe'),
    }
    _defaults = {
        'estpar_cancel_nf_pedido_validado': False,
        'estpar_local_entrada_devol_padrao_id': lambda s, cr, u, c: s.pool.get(
            'adm.utils').admutl_get_parametros(cr, u, 'estoque', 'local_venda_padrao_id',
                                               context=c).get('local_venda_padrao_id') or False,
        'estpar_desc_complementar_grade_nota': False,
    }
