# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv


class estsug_compra_capa(osv.Model):
    # prefixo: esgccp_

    _inherit = 'estsug.compra.capa'

    def esgccp_get_query_cfop(self, cr, uid, sugestao_id, context=None):
        """
        O metodo inclui tratamento pelo CFOP.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param sugestao_id: id da tabela desse objeto.
        :type sugestao_id: int
        :param context: dados contextuais.
        :type context: dict
        :return: dados SQL.
        :rtype: str
        """
        context = context and context.copy() or {}
        estsug_compra_capa_dados = self.read(cr, uid, sugestao_id, ['esgccp_incluir_requisicao'],
                                             context)
        if estsug_compra_capa_dados.get('esgccp_incluir_requisicao'):
            sql = """
                AND CASE 
                        WHEN emi.cfop_id IS NOT NULL THEN 
                            emi.cfop_id IN (SELECT id 
                                            FROM fiscal_cfop 
                                            WHERE tipo = 'S')
                    ELSE TRUE
                    END         
            """
        else:
            sql = """
                AND emi.cfop_id IN (SELECT id 
                                    FROM fiscal_cfop 
                                    WHERE tipo = 'S')
            """
        return sql

    def get_dados_rel(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        pagina, dados = super(estsug_compra_capa, self).get_dados_rel(cr, uid, ids, context)
        dados['cabcol1']['col8'] = 'ICMS'
        return pagina, dados
