# -*- coding: utf-8 -*-

# Funcoes da classe estoque_preco_custo


def estprc_get_nf_dados(self, cr, uid, ids, field_name, arg, context=None):
    """
    O metodo encontra as notas fiscais que geraram os custos na movimentacao dos itens.
    :param cr: cursor no banco de dados.
    :type cr: object
    :param uid: id da tabela res_users, identificador do usuario.
    :type uid: int
    :param ids: lista de id da tabela desse objeto.
    :type ids: list
    :param field_name: descricao do campo funcional.
    :type field_name: str
    :param arg: argumentos de pesquisa.
    :type arg: list
    :param context: dados contextuais.
    :type context: dict
    :return: dados da identificacao do custo e sua respectiva lista de notas fiscais que o originou.
    :rtype: dict
    """
    context = context and context.copy() or {}
    res = {}
    obj_estoque_movimento_itens = self.pool.get('estoque.movimento.itens')
    for custo in self.browse(cr, uid, ids, context):
        res[custo.id] = list()
        movimento_item_ids = obj_estoque_movimento_itens.search(
            cr, uid, [('estmvi_entrada_preco_custo_id', '=', custo.id)], context=context)
        if not movimento_item_ids:
            continue
        brw_estoque_movimento_itens = obj_estoque_movimento_itens.browse(
            cr, uid, movimento_item_ids, context)
        res[custo.id] = map(lambda i: i.nf_id.id, filter(lambda x: x.nf_id,
                                                         brw_estoque_movimento_itens))
    return res

# funcoes da classe estsug_compra_item


def esgcit_get_tipo_cst(self, cr, uid, ids, field_name, arg, context=None):
    context = context and context.copy() or {}
    encargo_ids = self.pool.get('fiscal.encargo').search(cr, uid, [('sigla', '=', 'ICMS')],
                                                         context=context)
    cst_ids = self.pool.get('fiscal.cst').search(
        cr, uid, [('encargo_id', 'in', encargo_ids), ('fiscst_tipo_movimento', 'in', ('E', 'A'))],
        context=context)
    sugestao_compra_item_dados = self.read(cr, uid, ids, ['esgcit_produto_id'], context,
                                           '_classic_write')
    produto_ids = list(set(map(lambda p: p.get('esgcit_produto_id'), sugestao_compra_item_dados)))
    obj_fiscal_tributacao_encargos = self.pool.get('fiscal.tributacao.encargos')
    tributacao_encargo_ids = obj_fiscal_tributacao_encargos.search(
        cr, uid, [('produto_id', 'in', produto_ids), ('encargo_id', 'in', encargo_ids),
                  ('cst_id', 'in', cst_ids), ('tipo_tributacao', '=', 'E')], context=context)
    brw_tributacao_encargos = obj_fiscal_tributacao_encargos.browse(
        cr, uid, tributacao_encargo_ids, context)
    produto_cst_tipo = {}
    for pct in brw_tributacao_encargos:
        if pct.produto_id.id in produto_cst_tipo:
            continue
        produto_cst_tipo.update({pct.produto_id.id: pct.cst_id.tipo})
    res = {}
    for item in sugestao_compra_item_dados:
        res.update({item.get('id'): produto_cst_tipo.get(item.get('esgcit_produto_id')) or ''})
    return res
