# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv


class estoque_produto_grade(osv.Model):

    _inherit = 'estoque.produto.grade'

    def estgrd_get_requisitado(self, cr, uid, ids, context=None, company_id=False):
        context = context and context.copy() or {}
        if not company_id:
            company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'fiscal.nf.capa')

        _esboco_na_reserva = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', 'estpar_esboco_na_reserva', context=context).get(
            'estpar_esboco_na_reserva')
        obj_estmvi = self.pool.get('estoque.movimento.itens')
        dados = super(estoque_produto_grade, self).estgrd_get_requisitado(cr, uid, ids, context,
                                                                          company_id)
        # state da nf - 1-Esboço, 3-Faturada, C-Cancelada, D-Denegada
        _sql = obj_estmvi.estmvi_get_query_item_requisitado(ids, company_id, _esboco_na_reserva)
        dados = self._estgrd_requisitado_acumular_valores(cr, uid, _sql, dados)
        return dados

    def name_search(self, cr, user, name='', args=None, operator='ilike', context=None, limit=100):
        context = context and context.copy() or dict()
        if 'fo=' == name[0:3]:
            obj_codigo_fornecedor = self.pool.get('estoque.produto.codigo.fornecedor')
            codigo_fornecedor_ids = obj_codigo_fornecedor.search(
                cr, user, [('codigo_fornecedor', '=', name[3:])], limit=limit, context=context)
            if codigo_fornecedor_ids:
                brw_codigo_fornecedor = obj_codigo_fornecedor.browse(
                    cr, user, codigo_fornecedor_ids, context)
                grade_ids = map(lambda g: g.grade_id.id, brw_codigo_fornecedor)
                return self.name_get(cr, user, grade_ids, context)
        elif 'usar_codigo_barra_na_grade_produto_id' in context:
            cb_ids = self.pool.get('automacao.codigo.barra').search(
                cr, user, [('codigo_barra', '=', name.zfill(14))], context=context)
            if cb_ids:
                cb_dados = self.pool.get('automacao.codigo.barra').read(
                    cr, user, cb_ids[0], ['grade_id'], context, '_classic_write')
                if context.get('nao_pesquisa_kit'):
                    produto_id = self.read(cr, user, cb_dados.get('grade_id'), ['produto_id'],
                                           context=context, load='_classic_write').get('produto_id')
                    produto_ids = self.pool.get('estoque.produto').search(cr, user,
                                                         [('id', '=', produto_id)], context=context)
                    if not produto_ids:
                        return super(estoque_produto_grade, self).name_search(cr, user, name, args,
                                                                           operator, context, limit)

                return self.name_get(cr, user, [cb_dados.get('grade_id')], context)

        return super(estoque_produto_grade, self).name_search(
            cr, user, name, args, operator, context, limit)

    def get_embalagem(self, cr, user, ids, context=None):
        """
        Recupera a embalagem em funcao da grade e do local (se houver).
        
        :param cr: o cursor do banco de dados
        :param user: o ID do usuario utilizado para a verificacao de perfil
        :param ids: o ID da grade ou lista com o ID das grades
        :param local_id: o ID do local
        :param context: um dicionario padrao para valores contextuais
        :type cr: object
        :type user: int
        :type ids: long|list
        :type local_id: long
        :type context: dict
        :return: a emb
        :rtype:
        """
        context = context and context.copy() or {}
        result = {}.fromkeys(ids if isinstance(ids, (list, tuple)) else [ids], {
            'embalagem_ids': []})

        if local and isinstance(local, (int, long)):
            local_ids = [local]
        elif local and isinstance(local, (list, tuple)):
            local_ids = local
        else:
            local_ids = []
        self.pool.get('estoque.local.locacao').search(
            cr, user, [('grade_id')]
        )


