# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2016 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2016, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


# noinspection PyAbstractClass,PyPep8Naming
class wizard_estoque_consulta_movimento_itens(osv.TransientModel):
    """
    Heranca da classe wizard_estoque_consulta_movimento_itens.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _inherit = "wizard.estoque.consulta.movimento.itens"

    _columns = {'vendedor_id': fields.many2one('vendas.vendedor', 'Vendedor')}


# noinspection PyAbstractClass,PyPep8Naming
class wizard_estoque_consulta_movimento(osv.TransientModel):
    """
    Heranca da classe estoque_consulta_movimento.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _inherit = "wizard.estoque.consulta.movimento"

    def executar_sql_consulta_movimento(self, cr, sql):
        """
        Executa sentenca SQL e retorna os dados da consulta.
        Sobrepoe o metodo e acrescenta o campo ´vendedor_id´ ao resultado da consulta

        :param cr: cursor do banco de dados,
        :param sql: a sentenca sql a ser executada
        :type cr: cursor
        :type sql: str
        :return: lista de dicionario com os dados da consulta
        :rtype: list

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        return super(wizard_estoque_consulta_movimento, self).executar_sql_consulta_movimento(
            cr, sql.replace('SELECT', 'SELECT mov_item.vendedor_id, ', 1))

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

