# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2017 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2017, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class wizard_estoque_gerar_nf_perda(osv.TransientModel):
    _name = 'wizard.estoque.gerar.nf.perda'  # wizgnp
    _columns = {
        'wizgnp_inventario_id': fields.many2one('estoque.inventario.capa', 'Inventario',
                                                ondelete='restrict', required=True, select=True),
        'wizgnp_preco': fields.selection([
            ('MC', 'Medio contabil'), ('UC', 'Ultimo custo'), ('CR', 'Custo de reposicao'),
            ('PV', 'Preco de venda')], 'Preco a utilizar', required=True,
            help='Utilizado no calculo do valor do item.'),
        'wizgnp_item_preco': fields.selection([
            ('1', 'Considerar 0,01'), ('2', 'Nao incluir na nota fiscal')], 'Item sem preco',
            required=True, help='Preco a ser considerado para o item cujo valor for zero.'),
        'wizgnp_qtde_itens': fields.integer('Quantidade de itens', help='Quantidade de itens por '
                                                                        'nota fiscal.')
    }

    _defaults = {
        'wizgnp_item_preco': '1',
        'wizgnp_qtde_itens': 120,
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
