# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv


# noinspection PyPep8Naming,PyAbstractClass,PyUnresolvedReferences
class estoquepedidos_pedido_item(osv.Model):
    _inherit = 'estoquepedidos.pedido.item'

    def onchange_grade(self, cr, uid, ids, produto, grade, local, pessoa=None, tipo_state='I',
                       context=None):
        context = context and context.copy() or {}
        result = super(estoquepedidos_pedido_item, self).onchange_grade(
            cr, uid, ids, produto, grade, local, pessoa, context)

        # Saldos
        result['value']['pedite_saldo_ids'] = self.pool.get('estoque.local.locacao').search(
            cr, uid, [('grade_id', '=', grade)], context=context)

        # Ultimas compras
        if grade:
            obj_compras_ultima_compra = self.pool.get('compras.ultima.compra')
            ultima_compra_ids = obj_compras_ultima_compra.search(
                cr, uid, [('grade_id', '=', grade)], context=context)
            if ultima_compra_ids:
                obj_compras_ultima_compra.unlink(cr, uid, ultima_compra_ids, context)
            self.pedite_get_ultima_compra(cr, uid, [grade], context)
        result['value']['pedite_ultima_compra_ids'] = self.pool.get('compras.ultima.compra').search(
            cr, uid, [('grade_id', '=', grade)], context=context)

        return result

    def pedite_get_ultima_compra(self, cr, uid, grade_ids, context=None):
        """
        Insere na tabela temporaria os valores das ultimas compras efetuada para um item.

        :param cr: o cursor do banco de dados
        :param uid: o ID do usuario utilizado para a verificacao de perfil
        :param grade_ids: lista com o ID das grades, tabela estoque_produto_grade
        :param context: um dicionario padrao para valores contextuais,
        :type cr: object
        :type uid: int
        :type context: dict
        """
        context = context and context.copy() or {}
        if len(grade_ids) == 1:
            str_grade_ids = str(tuple(grade_ids)).replace(',', '')
        else:
            str_grade_ids = str(tuple(grade_ids))
        _sql = """
            -- noinspection SqlDialectInspectionForFile
            INSERT INTO compras_ultima_compra (
                        create_uid,
                        create_date,
                        write_date,
                        write_uid,
                        produto_id,
                        grade_id,
                        pessoa_id,
                        nf_id,
                        data,
                        quantidade,
                        valor) (
            SELECT  %(uid)d                                   AS create_uid,
                    now()                                     AS create_date,
                    now()                                     AS write_date,
                    %(uid)d                                   AS write_uid,
                    emi.produto_id                            AS produto_id,
                    emi.grade_id                              AS grade_id,
                    fnc.destinatario_id                       AS pessoa_id,
                    fnc.id                                    AS nf_id,
                    fnc.data_saida_entrada AT TIME ZONE 'UTC' AS data,
                    emi.quantidade                            AS quantidade,
                    emi.vr_unitario                           AS valor
            FROM    estoque_movimento_itens                   AS emi
            INNER JOIN fiscal_nf_capa                         AS fnc
                    ON fnc.id = emi.nf_id
            INNER JOIN adm_pessoa                             AS pes
                    ON pes.id = fnc.destinatario_id
            INNER JOIN fiscal_cfop_natureza                   AS fcn
                    ON fcn.id = fnc.natureza_id
            INNER JOIN fiscal_cfop                            AS cfop
                    ON cfop.id = fcn.cfop_id
            WHERE fnc.tipo = 'E'
              AND fnc.state = '3'
              AND emi.grade_id IN %(str_grade_ids)s
              AND cfop.movimento_tipo = 'C'
            ORDER BY fnc.data_saida_entrada DESC LIMIT 10)
            """ % locals()
        cr.execute(_sql)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
