# -*- coding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _
from dateutil.parser import parse


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(e, c, d, t=130):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        context = context and context.copy() or {}
        nova_pagina = False
        nivel2 = ' ' * 2
        nivel3 = ' ' * 4
        nivel4 = ' ' * 6
        title = center_title('', _('Listagem para Conferencia'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('gerencial_listagem_conferencia'))
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)
        listagem.defineFonte(tam=7.7)
        # listagem.informaTamLinha(160)

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'wizard.gerencial.listagem.dre', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
        filtro = center_title('Data inicial do movimento: %s  /  Data final do movimento: %s' %
                              (parse(datas.get('data_movimento_i')).strftime('%d/%m/%Y'),
                              parse(datas.get('data_movimento_f')).strftime('%d/%m/%Y')), '', ''
                              )
        listagem.informaCab(title)
        listagem.informaCab('')
        listagem.informaCab(docs)
        listagem.informaCab('')
        listagem.informaCab(filtro)
        listagem.informaCab('')
        listagem.informaCab('--')
        # listagem.informaCab('')
        # listagem.informaCab('--')
        # listagem.informaCab('')
        listagem.rodapePadrao()

        # DADOS REFERENTE A NOTA FISCAL
        if datas.get('nf').get('nivel1'):
            listagem.cabecalhos[5] = center_title('', 'NOTAS FISCAIS', '')
            nova_pagina = True
        for nf in datas.get('nf').get('nivel1'):
            nf_id = nf.get('nf_id')
            linha = formataString('NF', 2, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(nf.get('tipo'), 1, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(nf.get('modelo'), 2, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(nf.get('serie'), 3, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(nf.get('numero'), 10, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(nf.get('cliente'), 30, ' ', 'D', 'N', 'S')
            linha += '|'
            data_emissao = parse(nf.get('data_emissao')).strftime('%Y/%m/%d')
            linha += formataString(data_emissao, 10, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(nf.get('valor') or 0.0, 2), 10, ' ', 'E', 'N',
                                   'S')
            linha += ''
            listagem.imprimeLinha(linha)

            nf_gerencial_dados = filter(lambda n: n.get('nf_id') == nf_id, datas.get('nf').get(
                'nivel2_gerencial'))
            for nf_gerencial in nf_gerencial_dados:
                linha = nivel2
                linha += formataString('GM', 2, ' ', 'D', 'N', 'S')
                linha += '|'
                linha += formataString(nf_gerencial.get('centro_custo'), 20, ' ', 'D', 'N', 'S')
                linha += '|'
                linha += formataString(nf_gerencial.get('evento'), 20, ' ', 'D', 'N', 'S')
                linha += '|'
                linha += formataString(getNumeroEditado(nf_gerencial.get('valor') or 0.0, 2), 10,
                                       ' ', 'E', 'N', 'S')
                linha += '|'
                linha += formataString((nf_gerencial.get('historico') or '').replace('\n', ' '), 60,
                                       ' ', 'D', 'N', 'S')
                linha += ''
                listagem.imprimeLinha(linha)

            nf_titulo_dados = filter(lambda n: n.get('nf_id') == nf_id, datas.get('nf').get(
                'nivel2_titulo'))
            for nf_titulo in nf_titulo_dados:
                nf_titulo_id = nf_titulo.get('titulo_id')
                linha = nivel2
                linha += formataString('TT', 2, ' ', 'D', 'N', 'S')
                linha += '|'
                linha += formataString(nf_titulo.get('tipo'), 1, ' ', 'D', 'N', 'S')
                linha += '|'
                linha += formataString(nf_titulo.get('documento'), 20, ' ', 'D', 'N', 'S')
                linha += '|'
                linha += formataString(nf_titulo.get('parcela'), 2, ' ', 'E', 'N', 'S')
                linha += '|'
                data_vencimento = parse(nf_titulo.get('vencimento')).strftime('%Y/%m/%d')
                linha += formataString(data_vencimento, 10, ' ', 'D', 'N', 'S')
                linha += '|'
                linha += formataString(getNumeroEditado(nf_titulo.get('valor') or 0.0, 2), 10,
                                       ' ', 'E', 'N', 'S')
                linha += ''
                listagem.imprimeLinha(linha)

                nf_titulo_gerencial_dados = filter(lambda tg: tg.get('titulo_id') == nf_titulo_id,
                                                   datas.get('nf').get('nivel3_gerencial'))
                for nf_titulo_gerencial in nf_titulo_gerencial_dados:
                    linha = nivel3
                    linha += formataString('GM', 2, ' ', 'D', 'N', 'S')
                    linha += '|'
                    linha += formataString(nf_titulo_gerencial.get('centro_custo'), 20, ' ', 'D',
                                           'N', 'S')
                    linha += '|'
                    linha += formataString(nf_titulo_gerencial.get('evento'), 20, ' ', 'D', 'N',
                                           'S')
                    linha += '|'
                    linha += formataString(getNumeroEditado(nf_titulo_gerencial.get('valor') or 0.0,
                                                            2), 10, ' ', 'E', 'N', 'S')
                    linha += '|'
                    linha += formataString((nf_titulo_gerencial.get('historico') or '').replace(
                        '\n', ' '), 60, ' ', 'D', 'N', 'S')
                    linha += ''
                    listagem.imprimeLinha(linha)

                nf_titulo_tesouraria_dados = filter(lambda tt: tt.get('titulo_id') == nf_titulo_id,
                                                    datas.get('nf').get('nivel3_tesouraria'))
                for nf_titulo_tesouraria in nf_titulo_tesouraria_dados:
                    nf_titulo_tesouraria_id = nf_titulo_tesouraria.get('tesouraria_id')
                    linha = nivel3
                    linha += formataString('TE', 2, ' ', 'D', 'N', 'S')
                    linha += '|'
                    linha += formataString(nf_titulo_tesouraria.get('debito_credito'), 1, ' ', 'D',
                                           'N', 'S')
                    linha += '|'
                    linha += formataString(nf_titulo_tesouraria.get('conta'), 20, ' ', 'D', 'N',
                                           'S')
                    linha += '|'
                    linha += formataString(getNumeroEditado(
                        nf_titulo_tesouraria.get('valor') or 0.0, 2), 10, ' ', 'E', 'N', 'S')
                    linha += '|'
                    linha += formataString(nf_titulo_tesouraria.get('conta_destino') or '', 20, ' ',
                                           'D', 'N', 'S')
                    linha += '|'
                    linha += formataString((nf_titulo_tesouraria.get('historico')).replace(
                        '\n', ' '), 60, ' ', 'D', 'N', 'S')
                    linha += ''
                    listagem.imprimeLinha(linha)

                    nf_titulo_tesouraria_gerencial_dados = filter(
                        lambda ttg: ttg.get('tesouraria_id') == nf_titulo_tesouraria_id, datas.get(
                            'nf').get('nivel4'))
                    for nf_titulo_tesouraria_gerencial in nf_titulo_tesouraria_gerencial_dados:
                        linha = nivel4
                        linha += formataString('GM', 2, ' ', 'D', 'N', 'S')
                        linha += '|'
                        linha += formataString(nf_titulo_tesouraria_gerencial.get('centro_custo'),
                                               20, ' ', 'D', 'N', 'S')
                        linha += '|'
                        linha += formataString(nf_titulo_tesouraria_gerencial.get('evento'), 20,
                                               ' ', 'D', 'N', 'S')
                        linha += '|'
                        linha += formataString(
                            getNumeroEditado(nf_titulo_tesouraria_gerencial.get('valor') or 0.0,
                                             2), 10, ' ', 'E', 'N', 'S')
                        linha += '|'
                        linha += formataString((nf_titulo_tesouraria_gerencial.get(
                            'historico') or '').replace('\n', ' '), 60, ' ', 'D', 'N', 'S')
                        linha += ''
                        listagem.imprimeLinha(linha)
            listagem.imprimeLinha('')

        # DADOS REFERENTE AO TITULO
        if datas.get('titulo').get('nivel1'):
            listagem.cabecalhos[5] = center_title('', 'TITULOS', '')
            nova_pagina and listagem.imprimeLinha('{{ Page }}')
            nova_pagina = True
        for titulo in datas.get('titulo').get('nivel1'):
            titulo_id = titulo.get('titulo_id')
            linha = formataString('TT', 2, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(titulo.get('tipo'), 1, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(titulo.get('documento'), 20, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(titulo.get('parcela'), 2, ' ', 'E', 'N', 'S')
            linha += '|'
            data_vencimento = parse(titulo.get('vencimento')).strftime('%Y/%m/%d')
            linha += formataString(data_vencimento, 10, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(titulo.get('valor') or 0.0, 2), 10,
                                   ' ', 'E', 'N', 'S')
            linha += ''
            listagem.imprimeLinha(linha)

            titulo_gerencial_dados = filter(lambda tg: tg.get('titulo_id') == titulo_id, datas.get(
                'titulo').get('nivel2_gerencial'))
            for titulo_gerencial in titulo_gerencial_dados:
                linha = nivel2
                linha += formataString('GM', 2, ' ', 'D', 'N', 'S')
                linha += '|'
                linha += formataString(titulo_gerencial.get('centro_custo'), 20, ' ', 'D', 'N', 'S')
                linha += '|'
                linha += formataString(titulo_gerencial.get('evento'), 20, ' ', 'D', 'N', 'S')
                linha += '|'
                linha += formataString(getNumeroEditado(titulo_gerencial.get('valor') or 0.0, 2),
                                       10, ' ', 'E', 'N', 'S')
                linha += '|'
                linha += formataString((titulo_gerencial.get('historico') or '').replace('\n', ' '),
                                       60, ' ', 'D', 'N', 'S')
                linha += ''
                listagem.imprimeLinha(linha)

            titulo_tesouraria_dados = filter(lambda tt: tt.get('titulo_id') == titulo_id,
                                             datas.get('titulo').get('nivel2_tesouraria'))
            for titulo_tesouraria in titulo_tesouraria_dados:
                titulo_tesouraria_id = titulo_tesouraria.get('tesouraria_id')
                linha = nivel2
                linha += formataString('TE', 2, ' ', 'D', 'N', 'S')
                linha += '|'
                linha += formataString(titulo_tesouraria.get('debito_credito'), 1, ' ', 'D',
                                       'N', 'S')
                linha += '|'
                linha += formataString(titulo_tesouraria.get('conta'), 20, ' ', 'D', 'N',
                                       'S')
                linha += '|'
                linha += formataString(getNumeroEditado(
                    titulo_tesouraria.get('valor') or 0.0, 2), 10, ' ', 'E', 'N', 'S')
                linha += '|'
                linha += formataString(titulo_tesouraria.get('conta_destino') or '', 20, ' ', 'D',
                                       'N', 'S')
                linha += '|'
                linha += formataString((titulo_tesouraria.get('historico') or '').replace(
                    '\n', ' '), 60, ' ', 'D', 'N', 'S')
                linha += ''
                listagem.imprimeLinha(linha)

                titulo_tesouraria_gerencial_dados = filter(
                    lambda ttg: ttg.get('tesouraria_id') == titulo_tesouraria_id, datas.get(
                        'titulo').get('nivel3_gerencial'))
                for titulo_tesouraria_gerencial in titulo_tesouraria_gerencial_dados:
                    linha = nivel3
                    linha += formataString('GM', 2, ' ', 'D', 'N', 'S')
                    linha += '|'
                    linha += formataString(titulo_tesouraria_gerencial.get('centro_custo'),
                                           20, ' ', 'D', 'N', 'S')
                    linha += '|'
                    linha += formataString(titulo_tesouraria_gerencial.get('evento'), 20,
                                           ' ', 'D', 'N', 'S')
                    linha += '|'
                    linha += formataString(
                        getNumeroEditado(titulo_tesouraria_gerencial.get('valor') or 0.0,
                                         2), 10, ' ', 'E', 'N', 'S')
                    linha += '|'
                    linha += formataString((titulo_tesouraria_gerencial.get(
                        'historico') or '').replace('\n', ' '), 60, ' ', 'D', 'N', 'S')
                    linha += ''
                    listagem.imprimeLinha(linha)
            listagem.imprimeLinha('')

        # DADOS REFERENTE A TESOURARIA
        if datas.get('tesouraria').get('nivel1'):
            listagem.cabecalhos[5] = center_title('', 'TESOURARIA', '')
            nova_pagina and listagem.imprimeLinha('{{ Page }}')
            nova_pagina = True
        for tesouraria in datas.get('tesouraria').get('nivel1'):
            tesouraria_id = tesouraria.get('tesouraria_id')
            linha = formataString('TE', 2, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(tesouraria.get('debito_credito'), 1, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(tesouraria.get('conta'), 20, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(tesouraria.get('valor') or 0.0, 2), 10, ' ',
                                   'E', 'N', 'S')
            linha += '|'
            linha += formataString(tesouraria.get('conta_destino') or '', 20, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString((tesouraria.get('historico') or '').replace('\n', ' '), 60, ' ',
                                   'D', 'N', 'S')
            linha += ''
            listagem.imprimeLinha(linha)

            tesouraria_gerencial_dados = filter(
                lambda tg: tg.get('tesouraria_id') == tesouraria_id, datas.get('tesouraria').get(
                    'nivel2'))
            for tesouraria_gerencial in tesouraria_gerencial_dados:
                linha = nivel2
                linha += formataString('GM', 2, ' ', 'D', 'N', 'S')
                linha += '|'
                linha += formataString(tesouraria_gerencial.get('centro_custo'), 20, ' ', 'D', 'N',
                                       'S')
                linha += '|'
                linha += formataString(tesouraria_gerencial.get('evento'), 20, ' ', 'D', 'N', 'S')
                linha += '|'
                linha += formataString(getNumeroEditado(tesouraria_gerencial.get('valor') or 0.0,
                                                        2), 10, ' ', 'E', 'N', 'S')
                linha += '|'
                linha += formataString((tesouraria_gerencial.get('historico') or '').replace(
                    '\n', ' '), 60, ' ', 'D', 'N', 'S')
                linha += ''
                listagem.imprimeLinha(linha)
            listagem.imprimeLinha('')

        # DADOS REFERENTE AO MOVIMENTO GERENCIAL
        if datas.get('gerencial').get('nivel1'):
            listagem.cabecalhos[5] = center_title('', 'GERENCIAL', '')
            nova_pagina and listagem.imprimeLinha('{{ Page }}')
            nova_pagina = True
        for gerencial in datas.get('gerencial').get('nivel1'):
            linha = formataString('GM', 2, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(gerencial.get('centro_custo'), 20, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(gerencial.get('evento'), 20, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(gerencial.get('valor') or 0.0, 2), 10, ' ',
                                   'E', 'N', 'S')
            linha += '|'
            linha += formataString((gerencial.get('historico') or '').replace('\n', ' '), 40, ' ',
                                   'D', 'N', 'S')
            linha += '|'
            linha += formataString(gerencial.get('requisicao') or '', 20, ' ', 'D', 'N', 'S')
            linha += ''
            listagem.imprimeLinha(linha)

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.gerencial_listagem_conferencia')
