#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv


class fiscal_manutencao_nf_complemento(osv.Model):
    _name = 'fiscal.nf.capa'
    _inherit = 'fiscal.nf.capa'

    def default_get(self, cr, uid, fields_list, context=None):
        """
        Este methodo ira sobrescrever o metodo default get original
        e de acordo com o manutencao_complemento_nf, ira setar
        o estado da nota para faturado, o tipo saida e a finalidade de
        emissao para complemento. Esta situacao eh especifica da
        manutencao de nota fiscal de complemento de saida.

        :param cr: a linha atual do cursor do banco de dados
        :param uid: o ID do usuario utilizado para a verificacao de perfil
        :param fields_list: lista de campos para tratar o valor default
        :param context: Dicionario de contextos
        :type cr: object
        :type uid: int
        :type fields_list: list
        :type context: dict
        :rtype: dict

        :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
        """
        res = super(fiscal_manutencao_nf_complemento, self).default_get(cr, uid, fields_list,
                                                                        context)
        if context.get('manutencao_complemento_nf'):
            res['state'] = '3'
            res['finalidade_emissao'] = '2'
        return res

