# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2015 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2015, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


# noinspection PyPep8Naming
class vendas_wizard_exportar_rps(osv.TransientModel):
    """
    Cria o modelo de dados temporario que recupera todas as notas fiscais de servico sem numero mas
    com numero de RPS. Exportacao para xml.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """


    _name = 'vendas.wizard.exportar.rps'  # vwerps
    _columns = {
        'vwers_nf_lote': fields.integer('Lote',
                                        help='Informe um lote para reexportar ou 0 para as nfs que ainda nao foram exportadas'),
        # ___________________________ Many2One _______________________________
        'vwerps_nf_ids': fields.many2many('fiscal.nf.capa', 'exportar_rps_m2m_fiscal_nf_capa',
                                          'rps_id', 'nf_id', 'Nota fiscal de servico'),
        # ___________________________ Char ___________________________________
        'vwerps_arquivo': fields.char('Arquivo de exportacao', size=255,
                                      help='Caminho completo do arquivo de exportacao (.xml).'),

        # ___________________________ Text ___________________________________
        'vwerps_mensagem': fields.text('Mensagem'),

        # ___________________________ Binary _________________________________
        'vwerps_download': fields.binary('Arquivo de exportacao', readonly=True,
                                         help='Arquivo de exportacao (.xml).'),
        'vwerps_exportar': fields.boolean('Exportar'),
        'state': fields.selection([('E', 'Esboco'), ('S', 'Selecionado')], 'Estado', size=1)
    }

    _defaults = {
        'state': 'E',
    }



# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
