# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2015 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2015, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


# noinspection PyPep8Naming
class vendas_wizard_importar_nfe(osv.TransientModel):
    """
    Cria o modelo de dados temporario que recupera todas as notas fiscais de servico com numero de
    RPS importadas do arquivo cvs.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'vendas.wizard.importar.nfe'  # vwinfe
    _columns = {
        # ___________________________ One2Many _______________________________
        'vwinfe_nf_servico_ids': fields.one2many('vendas.wizard.importar.nfe.itens',
                                                 'vwinfi_nfe_id',
                                                 'Nota fiscal de servico - Item de Importacao'),

        # ___________________________ Datetime _______________________________
        'vwinfe_data_importacao': fields.datetime('Data de importacao', readonly=True),

        # ___________________________ Binary _________________________________
        'vwinfe_arquivo': fields.binary('Arquivo de importacao', required=True,
                                        help='Caminho completo do arquivo de importacao (.csv).'),

        # ___________________________ Text ___________________________________
        'vwinfe_mensagem': fields.text('Mensagem'),

        # ___________________________ Boolean ________________________________
        'vwinfe_faturamento': fields.boolean('Faturamento efetuado')
    }


# noinspection PyPep8Naming
class vendas_wizard_importar_nfe_itens(osv.TransientModel):
    """
    Notas fiscais de servico com numero de RPS importadas do arquivo cvs.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'vendas.wizard.importar.nfe.itens'  # vwinfi
    _columns = {
        # ___________________________ Many2One _______________________________
        'vwinfi_nfe_id': fields.many2one('vendas.wizard.importar.nfe',
                                         'Nota fiscal de servico - Item de Importacao',
                                         ondelete='cascade', required=True,  select=True),

        # ___________________________ Integer ________________________________
        'vwinfi_nfe_numero_rps': fields.integer('Numero do RPS'),

        # ___________________________ Float __________________________________
        'vwinfi_nfe_valor_total': fields.float('Valor total', digits=(19, 2)),

        # ___________________________ Char ___________________________________
        'vwinfi_nfe_numero': fields.char('Nota fiscal', size=20),
        'vwinfi_nfe_codigo_verificacao': fields.char('Codigo de verificacao', size=15),
        'vwinfi_nfe_state': fields.char('Situacao', size=20),

        # ___________________________ Datetime _______________________________
        'vwinfi_nfe_data_emissao': fields.datetime('Data de emissao'),
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
