# -*- coding: utf-8 -*-

from openerp.tools.translate import _
from openerp.addons.web_sig.executor.descricao_funcoes import dic_funcoes
from openerp.addons.web_sig.executor.descricao_funcoes import NOME_FUNCOES

FISCAL_NOME_FUNCOES = [
    ('fis_001', _('FIS_001-Corrigir natureza da receita PIS/COFINS no movimento de NFC-e.')),
    ('fis_002', _('FIS_002-Trocar CST do PIS/COFINS no movimento')),
    ('fis_003', _('FIS_003-Corrigir natureza da receita PIS/COFINS no movimento de notas.')),
]
NOME_FUNCOES.extend(FISCAL_NOME_FUNCOES)
dic_funcoes_fiscal = {
    'fis_001': {'name': _('Corrigir natureza da receita PIS/COFINS no movimento de NFC-e'),
                'obs': _("Esta funcao substitui/inclui o codigo da natureza da receita do "
                         "PIS/COFINS no movimento da tributacao para as NFC-e emitidas no periodo, "
                         "de acordo com o cadastro do produto."),
                'campos': {
                    'data_inicial': {'tipo': 'date', 'label': _('Data inicial'), 'seq': 1,
                                     'attrs': 'required', 'help': _('Data inicial para selecao')},
                    'data_final': {'tipo': 'date', 'label': _('Data final'), 'seq': 2,
                                   'attrs': 'required', 'help': _('Data final para selecao')},
                    }
                },
    'fis_002': dict(
        name=_('Trocar CST do PIS/COFINS no movimento'),
        obs=_('Esta funcao troca os CSTs do PIS e do COFINS dos itens de movimento conforme '
              'periodo, categoria e NCM informado.'),
        campos=dict(
            data_inicial=dict(tipo='date', label='Data inical', seq=1, attrs='required'),
            data_final=dict(tipo='date', label='Data final', seq=2, attrs='required'),
            categoria_id=dict(
                tipo='many2one', label=_('Categoria'), seq=3, relation='estoque.categoria',
                help=_('Categoria a ser utilizada no filtro para alteracao do CST PIS/COFINS.')),
            ncm_id=dict(
                tipo='many2one', label=_('NCM'), seq=4, relation='fiscal.ncm',
                help=_('NCM a ser utilizado no filtro para alteracao do CST PIS/COFINS.')),
            produto_id=dict(
                tipo='many2one', label=_('Produto'), seq=5, relation='estoque.produto',
                help=_('Produto a ser utilizado no filtro para a alteracao do CST PIS/CONFINS.')),
            cst_pis_id=dict(
                tipo='many2one', label=_('CST/PIS'), seq=6, relation='fiscal.cst',
                help=_('Encargo que ira substituir o anterior.')),
            cst_cofins_id=dict(
                tipo='many2one', label=_('CST/COFINS'), seq=7, relation='fiscal.cst',
                help=_('Encargo utilizado que ira substituir o anterior.')),
        )
    ),
    'fis_003': {'name': _('Corrigir natureza da receita PIS/COFINS no movimento de notas'),
                'obs': _("Esta funcao substitui/inclui o codigo da natureza da receita do "
                         "PIS/COFINS no movimento da tributacao para as notas fiscais."),
                'campos': {
                    'data_inicial': {'tipo': 'date', 'label': _('Data inicial'), 'seq': 1,
                                     'attrs': 'required', 'help': _('Data inicial para selecao')},
                    'data_final': {'tipo': 'date', 'label': _('Data final'), 'seq': 2,
                                   'attrs': 'required', 'help': _('Data final para selecao')},
                    'cst': {'tipo': 'char', 'size': 2, 'label': 'CST', 'seq': 3,
                            'attrs': 'required', 'help': _('CST utilizado no movimento das notas')},
                    'natureza_receita_movimento': {'tipo': 'char', 'size': 3, 'seq': 4,
                                                   'label': 'Natureza receita movimento'},
                    'natureza_receita_substituta': {'tipo': 'char', 'size': 3, 'seq': 5,
                                                    'attrs': 'required',
                                                    'label': 'Natureza receita substituta'},
                    }
                },
}

dic_funcoes.update(dic_funcoes_fiscal)
