#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _
from datetime import datetime
from openerp.osv.fields import float_round


class websig_executor_tela_osv(osv.TransientModel):
    _name = 'websig.executor.tela.osv'
    _inherit = 'websig.executor.tela.osv'

    def websig_exec_fis_001(self, cr, uid, ids, context):
        """
        Esta funcao substitui/inclui o codigo da natureza da receita do PIS/COFINS no movimento da
        tributacao para as NFC-e emitidas no periodo, de acordo com o cadastro do produto.
        """
        context = context and context.copy() or {}
        msg = []
        executor_tela_id = ids[0] if isinstance(ids, list) else ids
        funcao_escolhida = eval(self.browse(cr, uid, executor_tela_id, context).dados).get(
            'fis_001')

        company_id = self.pool.get('res.users').browse(cr, uid, uid).company_id.id
        _data_inicial = funcao_escolhida.get('campos').get('data_inicial').get('value', False)
        _data_final = funcao_escolhida.get('campos').get('data_final').get('value', False)
        if _data_inicial > _data_final:
            msg.append(_('<h1>Atencao!</h1>'))
            msg.append(_('<h2>Data inicial deve ser menor ou igual a data final!</h2>'))
            self.write(cr, uid, ids, {'state': '4', 'mensagem': '\n'.join(msg)}, context)
            return False

        for encargo, natureza in [('PIS', 'estpro_pis_nat_rec'),
                                  ('COFINS', 'estpro_cofins_nat_rec')]:
            sql = """
                UPDATE
                    fiscal_nf_item_tributacao tributacao
                SET
                    fisnit_nat_rec_pis_cofins = produto.{natureza}
                FROM
                    estoque_movimento_itens movimento,
                    estoque_produto produto,
                    fiscal_encargo encargo,
                    fiscal_nf_capa nf
                WHERE
                    movimento.id = tributacao.movimento_itens_id
                    AND produto.id = movimento.produto_id
                    AND encargo.id = tributacao.encargo_id
                    AND nf.id = tributacao.fisnit_capa_id
                    AND encargo.sigla = '{encargo}'
                    AND produto.{natureza} IS NOT NULL
                    AND nf.company_id = {company_id}
                    AND nf.data_emissao between '{data_inicial} 00:00:00' 
                        AND '{data_final} 23:59:59'
                    AND nf.fisnfc_consumidor IS TRUE
                    AND nf.state = '3'
            """.format(encargo=encargo, data_inicial=_data_inicial, data_final=_data_final,
                       company_id=company_id, natureza=natureza)
            cr.execute(sql)

        msg.append(_('<h1>Concluido sem erro!</h1>'))
        res = self.write(cr, uid, ids, {'state': '3',
                                        'mensagem': '\n'.join(msg)}, context)
        return res

