# -*- coding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _
from datetime import datetime
from openerp.osv.fields import float_round


class websig_executor_tela_osv(osv.TransientModel):
    _name = 'websig.executor.tela.osv'
    _inherit = 'websig.executor.tela.osv'

    def websig_exec_fis_003(self, cr, uid, ids, context):
        """
        Esta funcao substitui/inclui o codigo da natureza da receita do PIS/COFINS no movimento da
        tributacao para as notas emitidas no periodo.
        """
        context = context and context.copy() or {}
        msg = []
        executor_tela_id = ids[0] if isinstance(ids, list) else ids
        funcao_escolhida = eval(self.browse(cr, uid, executor_tela_id, context).dados).get(
            'fis_003')

        company_id = self.pool.get('res.users').browse(cr, uid, uid).company_id.id
        data_inicial = funcao_escolhida.get('campos').get('data_inicial').get('value', False)
        data_final = funcao_escolhida.get('campos').get('data_final').get('value', False)
        cst = funcao_escolhida.get('campos').get('cst').get('value', '')
        natureza_receita_movimento = funcao_escolhida.get('campos').get(
            'natureza_receita_movimento').get('value', '')
        natureza_receita_substituta = funcao_escolhida.get('campos').get(
            'natureza_receita_substituta').get('value', '')
        if data_inicial > data_final:
            msg.append(_('<h1>Atencao!</h1>'))
            msg.append(_('<h2>Data inicial deve ser menor ou igual a data final!</h2>'))
            self.write(cr, uid, ids, {'state': '4', 'mensagem': '\n'.join(msg)}, context)
            return False

        sql = """
            UPDATE
                fiscal_nf_item_tributacao tributacao
            SET
                fisnit_nat_rec_pis_cofins = '{natureza_receita_substituta}'
            FROM
                fiscal_nf_capa nf,
                fiscal_encargo encargo,
                fiscal_cst cst
            WHERE
                nf.id = tributacao.fisnit_capa_id
                AND nf.company_id = {company_id}
                AND nf.state = '3'
                AND CASE 
                    WHEN nf.tipo = 'S' 
                        THEN nf.data_emissao between '{data_inicial} 00:00:00' 
                             AND '{data_final} 23:59:59'
                    ELSE
                        nf.data_saida_entrada between '{data_inicial} 00:00:00' 
                             AND '{data_final} 23:59:59'
                    END
                AND cst.id = tributacao.cst_id
                AND encargo.id = tributacao.encargo_id
                AND encargo.sigla IN ('PIS', 'COFINS')
                AND cst.codigo = '{cst}'
                {nat_rec_mov_informado}
                {nat_rec_mov_nao_informado}
            RETURNING tributacao.id
        """.format(data_inicial=data_inicial, data_final=data_final, company_id=company_id,
                   cst=cst, natureza_receita_substituta=natureza_receita_substituta,
                   nat_rec_mov_informado=natureza_receita_movimento and
                   "AND tributacao.fisnit_nat_rec_pis_cofins = '%s'" %
                   natureza_receita_movimento or '',
                   nat_rec_mov_nao_informado=not natureza_receita_movimento and
                   "AND (tributacao.fisnit_nat_rec_pis_cofins IN ('0', '00', '000') "
                   "OR fisnit_nat_rec_pis_cofins IS NULL OR fisnit_nat_rec_pis_cofins = '')" or '')
        cr.execute(sql)
        registros_atualizados = cr.fetchall()

        msg.append(_('<h1>Concluido sem erro!</h1>'))

        registros_atualizados and msg.append(
            str(len(registros_atualizados)) + ' registros atualizado(s).')
        not registros_atualizados and msg.append('Nenhum registro atualizado.')

        res = self.write(cr, uid, ids, {'state': '3',
                                        'mensagem': '\n'.join(msg)}, context)
        return res

