# -*- coding: utf-8 -*-

from openerp.osv import fields, osv
from openerp.tools.translate import _

ESTADOS = [
    ('AC', _('Acre')),
    ('AL', _('Alagoas')),
    ('AP', _('Amapa')),
    ('AM', _('Amazonas')),
    ('BA', _('Bahia')),
    ('CE', _('Ceara')),
    ('DF', _('Distrito Federal')),
    ('ES', _('Espirito Santo')),
    ('RR', _('Roraima')),
    ('GO', _('Goias')),
    ('MA', _('Maranhao')),
    ('MT', _('Mato Grosso')),
    ('MS', _('Mato Grosso do Sul')),
    ('MG', _('Minas Gerais')),
    ('PA', _('Para')),
    ('PB', _('Paraiba')),
    ('PR', _('Parana')),
    ('PE', _('Pernambuco')),
    ('PI', _('Piaui')),
    ('RJ', _('Rio de Janeiro')),
    ('RN', _('Rio Grande do Norte')),
    ('RS', _('Rio Grande do Sul')),
    ('RO', _('Rondonia')),
    ('TO', _('Tocantins')),
    ('SC', _('Santa Catarina')),
    ('SP', _('Sao Paulo')),
    ('SE', _('Sergipe'))]


class wizard_adm_pessoa_estado(osv.TransientModel):
    _name = 'wizard.adm.pessoa.estado'
    _description = 'Selecionar Estado'
    _columns = {
        'uf': fields.selection(ESTADOS, 'Selecione um Estado', size=2),
    }

    def carregar_informacao(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_adm_pessoa = self.pool.get('adm.pessoa')
        id_pessoa = context.get('active_id', False)
        if id_pessoa and ids:
            if isinstance(ids, list):
                ids = ids[0]
            uf = self.browse(cr, uid, ids).uf
            obj_adm_pessoa.carregar_informacao_cnpj_sefaz(cr, uid, id_pessoa, uf, context)

        return {}
