# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class wizard_estoque_consulta_movimento(osv.TransientModel):

    _inherit = "wizard.estoque.consulta.movimento"

    _columns = {
        'nf_id': fields.many2one('fiscal.nf.capa', 'Nota fiscal'),
        'cfop_ids': fields.many2many('fiscal.cfop', 'consulta_movimento_m2m_fiscal_cfop',
                                     'consulta_movimento_id', 'cfop_id', 'CFOP'),
    }

    def executar_sql_consulta_movimento(self, cr, sql):
        """
        Executa sentenca SQL e retorna os dados da consulta.

        :param cr: cursor do banco de dados,
        :param sql: a sentenca sql a ser executada
        :type cr: cursor
        :type sql: str
        :return: lista de dicionario com os dados da consulta
        :rtype: list

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        sql_vr_item_rateado = """
            coalesce(mov_item.vr_total_item_rateado, 0) +
            coalesce((SELECT Sum(COALESCE(vr_icms_substituicao, 0))
             FROM fiscal_nf_item_tributacao
             WHERE movimento_itens_id = mov_item.id), 0) +
            coalesce((SELECT Sum(COALESCE(vr_encargo, 0))
             FROM fiscal_nf_item_tributacao
             WHERE encargo_id IN (SELECT min(id)
                                  FROM fiscal_encargo
                                  WHERE sigla = 'IPI')
                   AND movimento_itens_id = mov_item.id), 0)
            AS vr_total_item,
        """

        sql = sql.replace('mov_item.vr_total_item_rateado AS vr_total_item,', sql_vr_item_rateado)

        return super(wizard_estoque_consulta_movimento, self).executar_sql_consulta_movimento(
            cr, sql)
