# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class wizard_gerencial_documento_sem_classificacao(osv.TransientModel):
    # prefixo: wsemcla_

    _inherit = 'wizard.gerencial.documento.sem.classificacao'

    def wsemcla_get_dados_sem_classificacao(self, cr, uid, ids, context=None):
        """
        O metodo reune os dados de notas fiscais, titulos e movimento da tesouraria que nao tiveram
        classificacao.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: dicionario, com a descricao de nota_fiscal, titulo e tesouraria e seus respectivos
        valores.
        :rtype: dict
        """
        context = context and context.copy() or {}

        dados = super(wizard_gerencial_documento_sem_classificacao, self).\
            wsemcla_get_dados_sem_classificacao(cr, uid, ids, context)

        periodo = self.read(cr, uid, ids[0], ['wsemcla_periodo_inicio', 'wsemcla_periodo_fim'])
        sql = """
            -- noinspection SqlDialectInspectionForFile
            SELECT
                ap.codigo || '-' || ap.nome     AS cliente_fornecedor,
                nf.numero_nf                    AS documento,
                nf.data_emissao                 AS data_emissao,
                nf.vr_total_nf                  AS valor
            FROM fiscal_nf_capa nf
            INNER JOIN adm_pessoa ap
                ON ap.id = nf.destinatario_id
            WHERE
                nf.id NOT IN (SELECT fingmo_nf_id
                              FROM gerencial_movimento
                              WHERE fingmo_nf_id IS NOT NULL)
                AND nf.state = '3'
                AND nf.data_emissao BETWEEN '{inicio}' AND '{fim}'
            ORDER by nf.data_emissao desc
        """.format(inicio=periodo.get('wsemcla_periodo_inicio'),
                   fim=periodo.get('wsemcla_periodo_fim'))
        cr.execute(sql)
        notas_fiscais = cr.dictfetchall()
        if dados.get('nota_fiscal'):
            dados['nota_fiscal'].extend(notas_fiscais)
        else:
            dados['nota_fiscal'] = notas_fiscais

        return dados

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

