# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from datetime import date

MES = [(1, 'Janeiro'),
       (2, 'Fevereiro'),
       (3, 'Marco'),
       (4, 'Abril'),
       (5, 'Maio'),
       (6, 'Junho'),
       (7, 'Julho'),
       (8, 'Agosto'),
       (9, 'Setembro'),
       (10, 'Outubro'),
       (11, 'Novembro'),
       (12, 'Dezembro')]


class fiscal_apuracao_imposto(osv.Model):
    from funcoes import _get_name_imposto

    _name = 'fiscal.apuracao.imposto'
    _columns = {
        'tipo': fields.selection([('C', 'ICMS'), ('I', 'IPI'), ('P', 'PIS'), ('O', 'COFINS')],
                                 'Tipo'),
        'mes': fields.selection(MES, 'Mes'),
        'ano': fields.char('Ano', size=4),
        'observacao': fields.char('Observacao', size=512),
        'saldo_credor': fields.float('Saldo credor', digits=(16, 2),
                                     help='Saldo credor do mes anterior',
        ),
        'data_apuracao': fields.date('Data da apuracao', help='1o. dia do mes da apuracao'),
        'name': fields.function(_get_name_imposto, method=True, string='Descricao', type='char',
                                size=30, store=False),
        'outros_debitos_ids': fields.one2many('fiscal.apuracao.imposto.outros.debitos',
                                              'apuracao_id',
                                              "Outros Debitos"),
        'estorno_creditos_ids': fields.one2many('fiscal.apuracao.imposto.estorno.creditos',
                                                'apuracao_id',
                                                "Estorno Creditos"),
        'outros_creditos_ids': fields.one2many('fiscal.apuracao.imposto.outros.creditos',
                                               'apuracao_id',
                                               "Outros Creditos"),
        'estorno_debitos_ids': fields.one2many('fiscal.apuracao.imposto.estorno.debitos',
                                               'apuracao_id',
                                               "Estorno Debitos"),
        'deducoes_ids': fields.one2many('fiscal.apuracao.imposto.deducoes', 'apuracao_id',
                                        "Deducoes"),
        'company_id': fields.many2one('res.company', 'Empresa', ondelete='cascade'),
    }
    _sql_constraints = [
        ('apuracao_uniq', 'unique(tipo,mes,ano, company_id)', 'Periodo de apuracao ja cadastrado')]
    _order = 'data_apuracao desc'
    _defaults = {
        'ano': date.today().year,
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                                                        s._name,
                                                                                        context=c),
    }


