# -*- coding: utf-8 -*-

from openerp.osv import osv, fields

HELP_COD_AJUS = """
Deve ser informado nete campo o codigo utilizado para controle de creditos
fiscais de ICMS, conforme campo 02-COD_AJ_APUR do registro 1200 do Sped Fiscal
de acordo com a Tabela 5.1.1
"""

HELP_TIPO_UTL = """
Deve ser informado neste campo o codigo referente a utilizacao de creditos fiscais
de ICMS, conforme campo 02-TIPO_UTIL do registro 1210 do Sped Fiscal
de acordo com a Tabela 5.5
"""


class fiscal_apuracao_imposto_outros_creditos(osv.Model):
    _name = 'fiscal.apuracao.imposto.outros.creditos'
    _columns = {
        'descricao': fields.char('Descricao', size=512),
        'valor': fields.float('Valor', digits=(9, 2)),
        'fisapuoc_codigo_ajuste': fields.char('Codigo de ajuste', size=8, help=HELP_COD_AJUS),
        'fisapuoc_tipo_utilizacao': fields.char('Tipo de utilizacao', size=4, help=HELP_TIPO_UTL),
        'apuracao_id': fields.many2one('fiscal.apuracao.imposto', "Apuracao ID"),
        'fisapuoc_numero_doc': fields.char('Numero do documento',
                                           help='Numero do documento utilizado na baixa de '
                                                'creditos'),
        'fisapuoc_chave_doc_eletronico': fields.char('Chave do documento', size=44,
                                                     help='Chave do documento eletronico'),
        'fisapuoc_nf_id': fields.many2one("fiscal.nf.capa", 'Nota fiscal', ondelete="cascade"),
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

