# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class fiscal_cadastro_anp(osv.Model):
    _name = 'fiscal.cadastro.anp'
    _columns = {
        'fisanp_codigo': fields.char('Codigo', size=9, required=True),
        'name': fields.char('Descricao', size=64, required=True),
        'fisanp_data_inicio': fields.date('Data de inicio'),
        'fisanp_data_fim': fields.date('Data de termino'),
        'fisanp_pglp': fields.float('% do GLP', digits=(7, 4),
                                    help='Percentual do GLP derivado do petroleo no produto GLP '
                                         '(codigo ANP=210203001).'),
        'fisanp_pgnn': fields.float('% Gas natural nacional', digits=(7, 4),
                                    help='Percentual de Gás Natural Nacional - GLGNn para o '
                                         'produto GLP (codigo ANP=210203001).'),
        'fisanp_pgni': fields.float('% Gas natural importado', digits=(7, 4),
                                    help='Percentual de Gás Natural Importado - GLGNi para o '
                                         'produto GLP (codigo ANP=210203001).'),
        'fisanp_partida': fields.float('Valor de partida', digits=(13, 2),
                                       help='Deve ser informado neste campo o valor por quilograma '
                                            'sem ICMS.'),
        'fisanp_adrem': fields.float('Aliquota adRemICMSRet', digits=(6, 4))
    }

    _sql_constraints = [
        ('fisanp_codigo_uniq', 'unique (fisanp_codigo)', 'O codigo do ANP deve ser unico'),
    ]
