# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class fiscal_cest(osv.Model):
    """
    Tabela CEST-Codigo Especificador da Substituicao Tributaria
    prefixo: fiscest_
    """
    _name = 'fiscal.cest'
    _columns = {
        'name': fields.text('Descricao', required=False),
        'fiscest_codigo': fields.char('Codigo', size=7, required=True),
        'fiscest_ncms': fields.text('NCM/SH', help='Informe os NCMs, separados por virgula'),
        'fiscest_ncm_ids': fields.one2many('fiscal.ncm', 'fisnc_cest_id', 'NCMs'),
        'fiscest_produto_ids': fields.one2many('estoque.produto', 'estpro_cest_id', 'Itens'),
    }
    _sql_constraints = [
        ('cest_codigo_uniq', 'unique (fiscest_codigo)', 'Codigo CEST ja cadastrado!')
    ]
