# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class fiscal_cfop_natureza_encargos(osv.Model):
    """
    Tabela de Naturezas do CFOP

    """

    from funcoes import _get_pis_cofins

    _name = 'fiscal.cfop.natureza.encargos'
    _rec_name = 'encargo_id'

    _columns = {
        'encargo_id': fields.many2one('fiscal.encargo', 'Encargo', required=True, ondelete="restrict"),
        'natureza_id': fields.many2one('fiscal.cfop.natureza', 'Natureza da Operacao', ondelete="restrict"),
        'sobrepor_tributacao_id': fields.many2one('fiscal.tributacao', 'Sobrepor Tributacao',
                                                  help="Tributacao a ser utilizada ao inves da tributacao do produto"),
        'fiscne_sobrepoe_so_tributados': fields.boolean('Sobrepoe so tributados',
                                                        help='Se marcado, somente sobrepoe a tributacao para os itens que sao tributados pelo encargo'),
        'fiscne_verifica_pis_cofins': fields.function(_get_pis_cofins, type="boolean", method=True, store=False,
                                                      string='Encargo PIS/COFINS'),
        #flag nao historiado, para verificacao de PIS/COFINS
    }

    _sql_constraints = [
        ('encargo_natureza_uniq', 'unique (encargo_id,natureza_id)', 'Encargo ja cadastrado para esta natureza.')
    ]

