# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class fiscal_codigo_consumo(osv.Model):
    """
    Tabela com os dados dos codigos de consumo da nota.
    PREFIXO: fiscco_ - Todo campo novo deve ser iniciado com fisnfc. Ex.: fisnfc_nf_terceiro_id.
    """

    _name = 'fiscal.codigo.consumo'
    _rec_name = 'fiscco_descricao'
    _columns = {
        'fiscco_modelo_id': fields.many2one("fiscal.modelo.nf", 'Modelo de NF', ondelete="restrict",
                                            required=True, select=True),
        'fiscco_codigo': fields.char('Codigo', size=2, required=True),
        'fiscco_descricao': fields.char('Descricao', size=120, required=True),
    }


