# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class fiscal_encargo(osv.Model):
    """
    Tabela que contem os encargos (PIS, Cofins, INSS, IR, comissoes, perdas, etc.)

    prefixo: fisenc_
    """
    _name = 'fiscal.encargo'
    _roteavel = True
    _columns = {
        'name': fields.char('Descricao', size=45, required=True), # Percentual maximo de comissao a ser pago
        'sigla': fields.char('Sigla', size=6, select=True, required=True), # Identifica o encargo\n
        'compoe_valor_doc': fields.boolean('Compoe valor doc'),
        'active': fields.boolean('Ativo'), # Indica se o encargo esta ativo
        'encargo_company_ids': fields.one2many('fiscal.encargo.empresa', 'encargo_id', 'Empresas'),
        'cst_ids': fields.one2many('fiscal.cst', 'encargo_id', 'Cst'),
        'tipo_encargo': fields.selection([('F', 'Federal'), ('E', 'Estadual'), ('M', 'Municipal')], 'Tipo encargo',
                                         size=1),
        'tributacao_ids': fields.one2many('fiscal.tributacao', 'encargo_id', 'Tributacao'),
        'produto_tributacao_ids': fields.one2many('fiscal.tributacao.encargos', 'encargo_id', 'Tributacao'),
        'fisenc_evento_id':fields.many2one('gerencial.evento','Evento', help="Evento para classificacao da custificacao dos encargos. "
                                                                             "Nao havendo evento, nao classificar apenas os encargos."),
    }
    _sql_constraints = [
        ('sigla_uniq', 'unique (sigla)', 'A sigla precisa ser unica'),
    ]
    _defaults = {
        'active': lambda *a: True,
    }
