# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class fiscal_encargo_empresa(osv.Model):
    """
    Tabela associativa de encargos para a empresa

    prefixo: fiseem_
    """
    _name = 'fiscal.encargo.empresa'
    _rec_name = 'encargo_id'
    _roteavel = True
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'encargo_id': fields.many2one("fiscal.encargo", 'Encargo', ondelete="cascade", required=True, select=True),
        'fiseem_encargo_obrigatorio': fields.boolean('Encargo Obrigatorio', oldname="fiseen_encargo_obrigatorio"),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }
    _sql_constraints = [
        ('encargo_company_uniq', 'unique (company_id,encargo_id)', 'Encargo ja cadastrado para esta empresa.')
    ]
