# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2019 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2019, Creative Commons
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""
# noinspection PyProtectedMember
from openerp.tools.translate import _
from openerp.osv import fields
from datetime import datetime
from openerp.osv import osv


# noinspection PyAbstractClass,PyPep8Naming
class fiscal_evento(osv.Model):
    """
    Classe evento de documentos fiscais eletronicos
    """
    class ParamToObject(object):
        """
        Converte valores de dicionarios em objetos
        """
        def __init__(self, **entries):
            self.__dict__.update(entries)

    def parametro(self, cr, uid, company=False, context=None):
        context = context and context.copy() or {}
        company = self.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, self._name, None, context, company)
        parametros = dict([(mod, self.ParamToObject(
            **self.pool.get('adm.utils').admutl_get_parametros(
                cr, uid, mod, [], company))) for mod in [
            'financeiro', 'fiscal', 'estoque', 'adm', 'rh']])

        return self.ParamToObject(**parametros)

    # noinspection PyMethodMayBeStatic,PyUnusedLocal
    def fiseve_get_evento(self, cr, user, context=None):
        context = context and context.copy() or {}
        return [('00110100', _('Autorizacao')),
                ('00110110', _('Carta de correcao')),
                ('00110111', _('Cancelamento')),
                ('00999100', _('Consulta servico (disponibilidade)')),
                ('00999101', _('Consulta por chave de acesso')),
                ('00999102', _('Envio de lote')),
                ('00999103', _('Consulta por numero de lote/recibo')),
                ('00999200', _('Consulta do cadastro de contribuinte'))
                ]

    _name = 'fiscal.evento'  # Prefix: fiseve
    _columns = {
        'fiseve_tipo': fields.selection(fiseve_get_evento, 'Evento'),
        'fiseve_data': fields.datetime('Data do evento', select=True),
        'fiseve_status': fields.integer('Codigo do status', size=3),
        'fiseve_motivo': fields.char('Evento', size=255),
        'fiseve_lote': fields.char('Lote SEFAZ (recibo)', size=15),
        'fiseve_protocolo': fields.char('Protocolo', size=15),
        'fiseve_xml_env': fields.text('XML de envio'),
        'fiseve_xml_ret': fields.text('XML de retorno'),
        'fiseve_nf_id': fields.many2one(
            'fiscal.nf.capa', 'Nota fiscal', ondelete='restrict', select=True),
    }
    _defaults = {
        'fiseve_data': datetime.now().strftime('%Y-%m-%d %H:%M:%S'),
    }
    _order = 'id DESC, fiseve_data DESC'

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
