#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class fiscal_ajuste_item(osv.Model):
    """
    Classe responsavel por ajustes fiscais dos itens movimentados na nota fiscal
    :prefix: fisaji
    """
    _name = 'fiscal.ajuste.item'
    _columns = {
        'fisaji_codigo_ajuste': fields.char(string='Codigo do ajuste fiscal', required=True,
                                            size=10, help='Codigo do ajustes/beneficio/incentivo, '
                                                          'conforme tabela indicada no item 5.3.'),
        'fisaji_movimento_item_id': fields.many2one('estoque.movimento.itens', 'Item'),
        'fisaji_valor_base_ajuste': fields.float('Valor da base de ICMS/ICMS ST',
                                                 help='Base de calculo do ICMS ou do ICMS ST'),
        'fisaji_aliquota_ajuste': fields.float('Aliquota de ICMS', help='Aliquota do ICMS'),
        'fisaji_valor_ajuste':  fields.float('Valor de ICMS/ICMS ST',
                                             help='Valor do ICMS ou do ICMS ST'),
        'fisaji_valor_outros': fields.float('Outros valores', help='Outros valores')
    }