# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2013 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class fiscal_cst_correlacao(osv.Model):
    _name = 'fiscal.cst.correlacao'
    _columns = {
        'encargo_id': fields.many2one("fiscal.encargo", 'Encargo', required=True),
        'cst_entrada_id': fields.many2one('fiscal.cst', 'CST de Entrada', required=True),
        'cst_saida_id': fields.many2one('fiscal.cst', 'CST de Saida', required=True),
    }
    _sql_constraints = [
        ('cst_correlacao_unique', 'unique (encargo_id, cst_saida_id)',
         'Cada CST pode ter somente uma correlacao de saida!'),
    ]


