# -*- coding: utf-8 -*-

__author__ = 'marcilene.ribeiro'

from openerp.osv import osv, fields


class fiscal_tributacao_entrada(osv.Model):
    _name = 'fiscal.tributacao.entrada'
    _columns = {
        'produto_id': fields.many2one('estoque.produto', 'Produto', ondelete="restrict",
                                      required=True, select=True), #id do produto
        'fornecedor_id': fields.many2one("financeiro.fornecedor", 'Fornecedor', ondelete="cascade",
                                         required=True, select=True),
        'tributacao_entrada_ids': fields.one2many('fiscal.tributacao.entrada.encargos',
                                                  'tributacao_entrada_id',
                                                  'Tributacao Entrada Encargos'),
    }

    _sql_constraints = [
        ('fornecedor_id_unique', 'unique (produto_id, fornecedor_id)',
         'Fornecedor deve ser cadastrado apenas uma vez para cada produto' ),
    ]

