# -*- coding: utf-8 -*-

__author__ = 'marcilene.ribeiro'

from openerp.osv import osv, fields


class fiscal_tributacao_entrada_encargos(osv.Model):
    """
    Tabela de encargos de entrada de um produto pata um fornecedor
    Prefixo: fistee
    """
    _name = 'fiscal.tributacao.entrada.encargos'
    _columns = {
        'tributacao_entrada_id': fields.many2one('fiscal.tributacao.entrada', ondelete="cascade"),
        'encargo_id': fields.many2one("fiscal.encargo", 'Encargo', ondelete="restrict",
                                      required=True),  # Id do encargo
        'tributacao_id': fields.many2one(
            "fiscal.tributacao", 'Tributacao', ondelete="restrict", required=True,
            domain="[('cst_id','=',cst_id),('fistri_cst_tipo_movimento','in',('E','A'))]"),
        # Id da tributacao
        'cst_id': fields.many2one(
            "fiscal.cst", 'CST ', ondelete="restrict", required=True, select=True,
            domain="[('encargo_id','=',encargo_id), ('fiscst_tipo_movimento', 'in', "
                   "('E', 'A'))]"),  # id do cst
        'fistee_mva': fields.float('MVA', digits=(5, 2)),
        'fistee_valor_pauta': fields.float('Valor Pauta', digits=(10, 2)),
        'fistee_modbcst': fields.selection([('0', 'Preco tabelado'),
                                            ('1', 'Lista negativa'),
                                            ('2', 'Lista positiva'),
                                            ('3', 'Lista neutra'),
                                            ('4', 'Margem valor agregado'),
                                            ('5', 'Pauta'),
                                            ('6', 'Valor da operacao')
                                            ], 'Modal.determ. BC do ICMS ST',
                                    help="Modalidade de determinacao da Base de Calculo do ICMS de Substituicao Tributaria",
                                    size=1),
        'fistee_aliquota_venda': fields.float('Aliquota para venda', digits=(5, 2),
                                              help='Aliquota de ICMS na venda para verificacao de calculo do ICMS ST na compra.'),
    }
