#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from funcoes import fistin_get_encargo


class fiscal_tributacao_interestadual(osv.Model):
    """
    Cadastro de tributacoes interestaduais

    :prefixo: fistin
    """

    _domain_tributacao = "[('encargo_id', '=', fistin_encargo)]"
    _name = 'fiscal.tributacao.interestadual'
    _columns = {
        'fistin_uf': fields.many2one('adm.uf', required=True, select=True, string='UF'),
        'fistin_encargo': fields.many2one('fiscal.encargo', required=True, string='Encargo', select=True),
        'fistin_cod_tribut_interestadual_nac': fields.many2one(
            'fiscal.tributacao', domain=_domain_tributacao,
            string='Tributacao interestadual prod.nacionais'),
        'fistin_cod_tribut_interno': fields.many2one('fiscal.tributacao', domain=_domain_tributacao,
                                                     string='Tributacao interna UF destino'),
        'fistin_cod_tribut_interestadual_imp': fields.many2one(
            'fiscal.tributacao', domain=_domain_tributacao,
            string='Tributacao interestadual prod.importados'),
        'fistin_difal_base_dupla': fields.boolean('Base dupla', help="Se marcado, calcula o difal com base dupla"),
    }

    _defaults = {
        'fistin_encargo': fistin_get_encargo(
            lambda s, cr, uid, c: s.pool.get('fiscal.encargo').search(cr, uid,
                                                                      [('sigla', '=', 'ICMS')]))
    }
    _sql_constraints = [
        ('fistin_uf_encargo_uniq', 'unique(fistin_uf, fistin_encargo)',
         'Encargo ja cadastrado para a UF informada')
    ]
