# -*- coding: utf-8 -*-

from openerp.osv import osv, fields


class fiscal_tributacao_simples_nacional(osv.Model):
    from funcoes import _soma_total_aliquota

    _name = 'fiscal.tributacao.simples.nacional'
    _columns = {
        'fistsn_valor_faturamento': fields.float('Receita ate', digits=(15, 2), required=True,
                                                 help='Valor limite para aplicar os percentuais desta faixa'),
        'fistsn_aliq_irpj': fields.float('IRPJ', digits=(5, 3), help='Aliquota para calculo do IRPJ'),
        'fistsn_aliq_csll': fields.float('CSLL', digits=(5, 3), help='Aliquota para calculo do CSLL'),
        'fistsn_aliq_cofins': fields.float('Cofins', digits=(5, 3), help='Aliquota para calculo do Cofins'),
        'fistsn_aliq_pis': fields.float('PIS', digits=(5, 3), help='Aliquota para calculo do PIS'),
        'fistsn_aliq_inss': fields.float('INSS', digits=(5, 3), help='Aliquota para calculo do INSS'),
        'fistsn_aliq_icms': fields.float('ICMS', digits=(5, 3), help='Aliquota para calculo do ICMS'),
        'fistsn_aliq_total': fields.function(_soma_total_aliquota, method=True, string='Valor Total Aliquota',
                                             type='float', digits=(15, 2), store=False),
    }
