# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class fiscal_guia(osv.Model):
    '''PREFIXO:FISGUI'''

    from funcoes import _get_simples_nacional, get_local_cobranca

    _name = 'fiscal.guia'
    _rec_name = 'nf_id'
    _columns = {
        'ano': fields.char('Ano', size=4, required=True),
        'mes': fields.selection([('1', 'Janeiro'),
                                 ('2', 'Fevereiro'),
                                 ('3', 'Marco'),
                                 ('4', 'Abril'),
                                 ('5', 'Maio'),
                                 ('6', 'Junho'),
                                 ('7', 'Julho'),
                                 ('8', 'Agosto'),
                                 ('9', 'Setembro'),
                                 ('10', 'Outubro'),
                                 ('11', 'Novembro'),
                                 ('12', 'Dezembro')], 'Mes', required=True, size=2),
        'data_vencimento': fields.date('Data Vencimento', required=True),
        'data_pagamento': fields.date('Data Pagamento'),
        'local_cobranca_id': fields.many2one("financeiro.local.cobranca", 'Local cobranca', ondelete="restrict",
                                             select=True, required=True), # id do local de cobranca
        'agencia_id': fields.many2one("adm.banco.agencia", 'Agencia', ondelete="restrict", select=True,
                                      domain="[('admbag_banco_id','=', local_cobranca_id)]"), # Id da agencia de cobranca
        'autenticacao': fields.char('Autenticacao', size=25),
        'convenio': fields.char('Convenio', size=30, required=True),
        'base': fields.float('Base', digits=(15, 2), required=True),
        'valor': fields.float('Valor', digits=(15, 2), required=True),
        'guia_recomp_aliq': fields.boolean('Guia de Recomp. de Aliquota'),
        'codigo_antecipa': fields.char('Cod. Antecipacao', size=1),
        'nf_id': fields.many2one('fiscal.nf.capa', 'Nota', ondelete="cascade"),
        'fisgui_fornecedor_reembolsar': fields.boolean('Reembolsar Fornecedor'),
        'fisgui_fornecedor_vencimento': fields.date('Vencimento'),
        'fisgui_simples_nacional': fields.function(_get_simples_nacional, type="boolean", method=True, store=False,
                                                   string='Simples nacional'),
        #flag nao historiado,para verificar simples nacional
    }

    _defaults = {
        'local_cobranca_id': get_local_cobranca,
    }
