# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields

class fiscal_modelo_nf(osv.Model):
    """
    Tabela de modelos de nf
    """

    def fismnf_get_modelo_nf_tipo(self, cr, user, context=None):
        """
        Retorna os tipos de modelo de uma nota fiscal
        """
        context = context and context.copy() or {}
        result = [('T', 'Transporte'), ('N', 'Nota Fiscal'), ('E', 'Energia'), ('P', 'Passagem'),
                  ('C', 'Comunicacao'), ('G', 'Gas'), ('A', 'Agua')]

        return result

    _name = 'fiscal.modelo.nf'
    _columns = {
        'fismnf_codigo': fields.char('Codigo', size=2, required=True, select=True, oldname='codigo'), # codigo do modelo de nf
        'name': fields.char('Nome', size=50, required=True), # Descricao do modelo de nf
        'active': fields.boolean('Ativo'), # Identifica se esta ativo ou nao
        'fismnf_tipo_nfe': fields.boolean('NF-e', oldname='tipo_nfe',
                                          help='Se marcado, indica que e um modelo de nf eletronica'),
        'fismnf_tipo_nfe_servico': fields.boolean('NFS-e',
                                         help='Indica que e um modelo de nf eletronica de Servico'),
        'fismnf_padrao_nfs': fields.selection([('1', 'ABRASF-2.02')], 'Padrao NFS-e',
                                              size=1),
        'fismnf_tipo': fields.selection(
            fismnf_get_modelo_nf_tipo, required=True,  size=1, oldname='tipo')

    }
    _defaults = {
        'active': lambda *a: True,
        'fismnf_tipo': 'N',
    }

    _sql_constraints = [('codigo_uniq', 'unique (fismnf_codigo)', 'O codigo precisa ser unico!')]


