# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import _fismnfs_get_tipo_modelo, _fismnfs_get_mod_serie_ids
STATUS = [('1', 'NF-e'),
          ('2', 'NFS-e')]


class fiscal_modelo_nf_series(osv.Model):
    """
    Tabela de Series de nf
    """
    def fmnfs_get_versao_xml(self, cr, user, context=None):
        """
        Versoes utilizadas dos arquivos XML
        """
        context = context and context.copy() or {}
        result = [('4.00', '4.00')]

        return result

    _name = 'fiscal.modelo.nf.series'  # fismnfs
    _rec_name = 'modelo_nf_id'
    _order = 'modelo_nf_id'
    _columns = {
        'modelo_nf_id': fields.many2one("fiscal.modelo.nf", 'Modelo NF', ondelete="restrict", required=True),   # Id do modelo da nf
        'serie_nf': fields.char('Serie', size=3, required=True), # serie nf
        'subserie_nf': fields.char('Subserie', size=3), # Sub serie da nf
        'numero_nf': fields.integer('Numero NF', required=True),
        'state': fields.selection([('A', 'Ativo'), ('E', 'Esboco'), ('D', 'Desabilitado')], 'Status', required=True,
                                  size=1),
        'versao_xml': fields.selection(fmnfs_get_versao_xml, 'Versao Xml', size=5),
        'ambiente': fields.selection([(1, 'Producao'), (2, 'Homologacao')], 'Ambiente', size=1),
        'tipo_contingencia': fields.selection(
            [('SVC-AN', 'Contingencia SVC-AN'), ('SVC-RS', 'Contingencia SVC-RS')], 'Contingencia',
            size=6),
        'motivo_scan': fields.char('Motivo Contigencia', size=256),  #motivo de contigência scan que deve ser especificado para contigência scan
        'data_scan': fields.datetime('Data Contigencia'), #data de entrada em contigência scan
        'flag_modelo_nfe': fields.boolean('flag_readonly'),
        'tipo_modelo': fields.function(
            _fismnfs_get_tipo_modelo, string="Tipo modelo", selection=STATUS, type='selection',
            method=True, store={'fiscal.modelo.nf': (
                _fismnfs_get_mod_serie_ids, ['fismnf_tipo_nfe', 'fismnf_tipo_nfe_servico'], 10)}),
        'parametro_id': fields.many2one("fiscal.parametro", 'Parametro Fiscal', ondelete="cascade"),
    }
    _defaults = {
        'state': lambda *a: 'E',
        'ambiente': lambda *a: 2,
        'flag_modelo_nfe': False,
        'tipo_modelo': '',
    }
