# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2011 All Rights Reserved. Larissa Franca Borges
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class fiscal_ncm(osv.Model):
    """
    Tabela de NCM
    """
    _name = 'fiscal.ncm'
    _rec_name = 'descricao'
    _columns = {
        'codigo': fields.char('Codigo', size=8, required=True),
        'descricao': fields.char('Descricao', size=200, required=False),
        'tributos_ids': fields.one2many('fiscal.tributacao.encargos', 'ncm_id', 'Tributos'),
        'fisnc_aliq_ibpt_fed_nac': fields.float('Aliquota de Tributos Federais(Nacional)', digits=(3, 2),
                                                help='Aliquota aproximada de tributos Federais em cumprimento a lei 12.741/2012. Produtos adquiridos no mercado nacional'),
        'fisnc_aliq_ibpt_fed_imp': fields.float('Aliquota de Tributos Federais(Importados)', digits=(3, 2),
                                                help='Aliquota aproximada de tributos Federais em cumprimento a lei 12.741/2012. Produtos adquiridos no mercado externo'),
        'fisnc_aliq_ibpt_est': fields.float('Aliquota de Tributos Estaduais', digits=(3, 2),
                                                help='Aliquota aproximada de tributos Estaduais em cumprimento a lei 12.741/2012.'),
        'fisnc_aliq_ibpt_mun': fields.float('Aliquota de Tributos Municipais', digits=(3, 2),
                                                help='Aliquota aproximada de tributos Municipais em cumprimento a lei 12.741/2012.'),
        'fisnc_ibpt_chave': fields.char('Chave da tabela', size=10),
        'fisnc_cest_id': fields.many2one('fiscal.cest', 'Codigo CEST', ondelete='restrict', select=True),
    }
