# -*- encoding: utf-8 -*-


__author__ = 'marcilene.ribeiro'

from openerp.osv import osv, fields


class fiscal_condicao_pagamento(osv.Model):
    from funcoes import _get_forma_pagamento_cheque, _get_cartao_credito_debito, get_valor_restante

    def default_get(self, cr, uid, fields, context=None):
        context = context and context.copy() or {}
        res = super(fiscal_condicao_pagamento, self).default_get(cr, uid, fields, context=context)
        obj_fiscal_parametro = self.pool.get('fiscal.parametro')
        fiscal_parametro_ids = obj_fiscal_parametro.search(cr, uid, [], context=context)
        if fiscal_parametro_ids:
            fiscal_parametro_dados = obj_fiscal_parametro.read(
                cr, uid, fiscal_parametro_ids[0], ['condicao_pgto_id'], context=context)
            if isinstance(fiscal_parametro_dados, list):
                fiscal_parametro_dados = fiscal_parametro_dados[0]
            if isinstance(fiscal_parametro_dados, dict):
                if fiscal_parametro_dados.get('condicao_pgto_id'):
                    condicao_pagamento_id = fiscal_parametro_dados['condicao_pgto_id'][0]
                    obj_adm_condicao_forma = self.pool.get('adm.condicao.forma')
                    browse_condicao_forma = obj_adm_condicao_forma.browse(
                        cr, uid, condicao_pagamento_id, context)
                    res['forma_pagto_id'] = browse_condicao_forma.forma_pagamento_id.id
                    res['condicao_forma_id'] = condicao_pagamento_id
        return res

    """
    PREFIXO = fiscpg_
    """
    _name = 'fiscal.condicao.pagamento'
    _rec_name = 'condicao_forma_id'
    _columns = {
        'capa_id': fields.many2one("fiscal.nf.capa", 'Capa', ondelete="cascade", required=True,
                                   select=True),
        'condicao_forma_id': fields.many2one('adm.condicao.forma', 'Condicao pagamento',
                                             ondelete="cascade", required=True, select=True),
        'valor': fields.float('Valor', digits=(15, 2), required=True),
        'forma_pagto_id': fields.many2one('adm.forma.pgto', 'Forma Pagamento', ondelete="restrict",
                                          select=True, required=True),
        'fiscpg_forma_pagamento_cheque': fields.function(
            _get_forma_pagamento_cheque, method=True, string="Pagamento em cheque", type="boolean",
            store=False),
        'nf_parcela_ids': fields.one2many('fiscal.nf.parcelas', 'nf_condicao_id', 'Parcela'),
        'fiscpg_nro_autorizacao_cartao': fields.char('Nro da Autorizacao do Cartao', size=10),
        'fiscpg_tipo_cartao': fields.function(
            _get_cartao_credito_debito, type="boolean", method=True, store=False,
            string='Tipo cartao'),
        'fiscpg_chq_numero': fields.char('Numero cheque', size=10),
        'fiscpg_chq_banco': fields.integer('Banco'),
        'fiscpg_chq_agencia': fields.integer('Agencia'),
        'fiscpg_chq_emitente': fields.char('CPF/CNPJ Emitente', size=19,
                                           help='Informe o CPF/CNPJ do Emitente quando nao for o '
                                                'cliente'),
        'fiscpg_chq_conta': fields.char('Conta', size=10,
                                        help='Conta bancaria referente ao cheque.')
    }
    _defaults = {
        'valor': get_valor_restante
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
