# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


# noinspection PyAbstractClass,PyPep8Naming
class fiscal_nf_parcelas(osv.Model):
    """
    Parcelas da nota fiscal.
    """

    _name = 'fiscal.nf.parcelas'
    _order = 'vencimento'
    _columns = {
        'active': fields.boolean('Ativo'),
        'valor': fields.float('Valor', digits=(14, 2), required=True),
        'vencimento': fields.date('Vencimento', required=True),
        'prazo': fields.integer('Prazo'),
        'prazo_tipo': fields.selection([('', ''), ('DD', 'Dias Direto'),
                                        ('DFS', 'Dias Fora a Semana'),
                                        ('DFQ', 'Dias fora a quinzena'),
                                        ('DFM', 'Dias Fora o Mes')], 'Prazo tipo', size=3),
        'nf_condicao_id': fields.many2one('fiscal.condicao.pagamento', 'Condicao Pagamento',
                                          ondelete='cascade', select=True),
        'fisnfc_nf_terceiro_id': fields.many2one('fiscal.nf.capa', 'Capa NF', ondelete='cascade',
                                                 select=True),
    }
    _defaults = {'active': True}

    _order = 'vencimento'
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

