# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2018 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2018, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""
from openerp.osv import osv, fields
from funcoes_nfce import _fisnfc_get_percentual_tempo


class fiscal_nfce(osv.Model):
    """
    nota fiscal de consumidor eletronica.
    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """
    def default_get(self, cr, uid, fields, context=None):
        context = context and context.copy() or {}
        res = super(fiscal_nfce, self).default_get(cr, uid, fields, context)
        if not context.get('import_nfe') and not context.get('nota_referenciada'):
            if res.get('modelo_nf_series_id') and res.get('nf_propria') or \
                    context.get('ctx_nf_propria'):
                nf_propria = self._fisnfc_nota_propria(cr, uid, context)
                vals = self.onchange_modelo_nf(
                    cr, uid, [], res['modelo_nf_series_id'], res['tipo'], nf_propria, context)
                if vals['value'].get('fisnfc_consumidor'):
                    res['nfe_forma_emissao'] = '1'
        return res

    _inherit = 'fiscal.nf.capa'
    _columns = {
        'fisnfc_consumidor': fields.boolean('Nota fiscal de consumidor', select=True),
        'fisnfc_nfce_contingencia_offline': fields.boolean('Contingencia offline'),
        'fisnfc_nfce_min_percent_tempo_cancelamento': fields.function(
            _fisnfc_get_percentual_tempo, multi='nfce_tempo'),
        'fisnfc_nfce_max_percent_tempo_cancelamento': fields.function(
            _fisnfc_get_percentual_tempo, multi='nfce_tempo'),
        'fisnfc_nfce_min_percent_tempo_envio_contingencia': fields.function(
            _fisnfc_get_percentual_tempo, multi='nfce_tempo'),
        'fisnfc_nfce_max_percent_tempo_envio_contingencia': fields.function(
            _fisnfc_get_percentual_tempo, multi='nfce_tempo'),
    }
    _defaults = {
        'fisnfc_consumidor': False,
        'fisnfc_nfce_contingencia_offline': False,
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:


