# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools import drop_view_if_exists


class fiscal_tributacao_agrupar_pgview(osv.Model):
    _name = "fiscal.tributacao.agrupar.pgview"
    _description = "Agrupamento da Tributacao dos Itens da Nota Fiscal"
    _auto = False
    _columns = {
        'nf_id': fields.many2one("fiscal.nf.capa", 'Nota fiscal'), # id da capa da nf
        'encargo_id': fields.many2one("fiscal.encargo", 'Encargo'), # Id do encargo
        'cfop_id': fields.many2one("fiscal.cfop", 'CFOP'), # Id do CFOP
        'aliquota': fields.float('Aliquota', digits=(6, 3)), # aliquota aplicada ao item
        'vr_encargo': fields.float('Valor Encargo', digits=(15, 2)), # Valor calculado do encargo
        'vr_base_calculo': fields.float('Base', digits=(15, 2)), # Valor da base de calculo
        'vr_reducao_base': fields.float('Valor reducao base', digits=(15, 2)), # Valor reduzido na base de calculo\n
        'vr_icms_substituicao': fields.float('Valor ST', digits=(15, 2)),
        'tipo': fields.selection(
            [('T', 'Tributado'), ('U', 'Substituicao'), ('I', 'Isento'), ('O', 'Outros'), ('D', 'Diferido'),
             ('S', 'Servico'), ('TU', 'Tributado com substituicao')], 'Tipo', required=True, size=2),
    }

    _order = 'nf_id,encargo_id,tipo,aliquota'