# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class fiscal_tributacao_excecao(osv.Model):
    """
    Tabela de excecao tributaria. Identifica ao que foge da normalidade
    """
    _name = 'fiscal.tributacao.excecao'
    _columns = {
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="cascade", select=True),
        'pessoa_id': fields.many2one("adm.pessoa", 'Pessoa', ondelete="restrict", select=True),
        'cst_id': fields.many2one("fiscal.cst", 'Cst', ondelete="restrict", select=True),
        'base_reducao': fields.float('Base reducao', digits=(9, 3)), # Percentual a ser reduzido da base de calculo do encargo\n]
        'aliquota': fields.float('Aliquota', digits=(6, 3)), # Percentual a aplicar sobre a base de calculo
    }
