# -*- encoding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.numero import getNumeroEditado
from SigUtils.impressao import Impressora
from openerp.osv import osv
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):

        dict_cfop_movimento = {
            16: 'Compras', 17: 'Transferencias', 18: 'Devolucao', 19: 'Ener. Eletrica',
            20: 'Comunicacao', 21: 'Transportes', 22: 'Ativo Perm.', 23: 'Uso consumo',
            24: 'Outras',
            26: 'Compras', 27: 'Transferencias', 28: 'Devolucao', 29: 'Ener. Eletrica',
            30: 'Comunicacao', 31: 'Transportes', 32: 'Ativo Perm.', 33: 'Uso consumo',
            34: 'Outras',
            36: 'Compras', 37: 'Transferencias', 38: 'Com/Trans/E. El', 39: 'Ativo Perm.',
            40: 'Uso consumo', 41: 'Outras',
            44: 'Vendas', 45: 'Transferencias', 46: 'Devolucao', 47: 'Ener. Eletrica',
            48: 'Comunicacao', 49: 'Transportes', 50: 'Outras',
            52: 'Vendas', 53: 'Transferencias', 54: 'Devolucao', 55: 'Ener. Eletrica',
            56: 'Comunicacao', 57: 'Transportes', 58: 'Outras',
            60: 'Vendas', 61: 'Devolucao', 62: 'Com/Trans/E. El', 63: 'Outras'
        }

        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato()
        listagem.informaNome(pdf_string, _('DAPI'))
        # self.name2 = _('DAPI_%s' % time.strftime('%H%M%S'))
        listagem.informaTamLinha(160)

        substituicao = datas.get('substituicao')
        periodo_inicial = datas.get('periodo_inicial')
        periodo_final = datas.get('periodo_final')
        data_limite = datas.get('data_limite')
        regime_recolhimento = datas.get('regime_recolhimento')
        escrituracao_centralizada = datas.get('escrituracao_centralizada')
        fundese = datas.get('fundese')
        movimento_dados = datas.get('movimento_dados')
        if movimento_dados:
            movimento_dados = sorted(movimento_dados, key=lambda i: i.get('dapi'))

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'wizard.gerar.dapi', context=context)
        brw_res_company = pooler.get_pool(cr.dbname).get('res.company').browse(
            cr, uid, company_id, context=context)
        nome_empresa = brw_res_company.name
        ie = brw_res_company.rescon_pessoa_id.admpes_jur_ie or ''
        cnpj = brw_res_company.rescon_pessoa_id.cpf_cnpj
        cidade = brw_res_company.rescon_pessoa_id.cidade or ''
        uf = brw_res_company.rescon_pessoa_id.uf
        data = time.strftime("%d/%m/%Y")

        adm_parametro_dados = pooler.get_pool(cr.dbname).get('adm.utils').admutl_get_parametros(
            cr, uid, 'adm', 'socio_id')
        socio_id = adm_parametro_dados.get('socio_id')
        if socio_id and isinstance(socio_id, (list, tuple)):
            socio_id = socio_id[0]
        resp_cpf_cnpj = ''
        resp_cargo = ''
        resp_nome = ''
        resp_telefone = ''
        if socio_id:
            brw_adm_pessoa_socio = pooler.get_pool(cr.dbname).get('adm.pessoa').browse(
                cr, uid, socio_id, context)
            resp_cpf_cnpj = brw_adm_pessoa_socio.cpf_cnpj or ''
            resp_nome = brw_adm_pessoa_socio.nome or ''
            resp_telefone = brw_adm_pessoa_socio.telefone or ''
            funcionario_ids = pooler.get_pool(cr.dbname).get('rh.funcionario').search(
                cr, uid, [('pessoa', '=', socio_id)], context=context)
            if funcionario_ids:
                resp_cargo = pooler.get_pool(cr.dbname).get('rh.funcionario').browse(
                    cr, uid, funcionario_ids[0], context).cargo.name or ''

        title = center_title('', _('SECRETARIA DA FAZENDA DO ESTADO DE MINAS GERAIS'), '')
        title1 = center_title('', _('DAPI 1 (Declaracao de Apuracao e Informacao do ICMS)'), '')

        listagem.informaCab(center_title(data, '', _('Pagina: {{ Page }} ')))
        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab('' + title1)
        listagem.informaCab(' I  -  ' + '-' * 61 + ' INFORMACOES DA DAPI ' + '-' * 61)
        listagem.informaCab(center_title('CNAE-F',
                                         'Regime de Recolhimento: %s' % regime_recolhimento, ''))
        linha = formataString('[01] Substitui DAPI ja entregue: [%s]' % substituicao, 75, ' ', 'D',
                              'N', 'S')
        linha += formataString('[02] DAPI sem movimento: [%s]' % (
            'N' if movimento_dados else 'S'), 75, ' ', 'D', 'N', 'S')
        listagem.informaCab(linha)

        linha = formataString('[03] Periodo de Referencia: %s a %s' % (
            periodo_inicial, periodo_final), 75, ' ', 'D', 'N', 'S')
        linha += formataString('[04] Data limite para pagamento: %s' % data_limite, 75, ' ', 'D',
                               'N', 'S')
        listagem.informaCab(linha)

        listagem.informaCab(' II  -  ' + '-' * 55 + ' IDENTIFICACAO DO CONTRIBUINTE  ' + '-' * 55)

        linha = formataString('[05] Inscricao Estadual: %s' % ie, 75, ' ', 'D', 'N', 'S')
        linha += formataString('[06] CNPJ: %s' % cnpj, 75, ' ', 'D', 'N', 'S')
        listagem.informaCab(linha)

        linha = formataString('[07] Nome Comercial: %s' % nome_empresa, 150, ' ', 'D', 'N', 'S')
        listagem.informaCab(linha)

        linha = formataString('[08] Municipio: %s' % cidade, 60, ' ', 'D', 'N', 'S')
        linha += formataString('[09] UF: %s' % uf, 15, ' ', 'D', 'N', 'S')
        linha += formataString('[10] CNAE-F:', 15, ' ', 'D', 'N', 'S')
        linha += formataString('[11] Regime de Recolhimento: %s' % regime_recolhimento, 60, ' ',
                               'D', 'N', 'S')
        listagem.informaCab(linha)

        listagem.informaCab(' III  -  ' + '-' * 55 + ' RESPONSAVEL PELAS INFORMACOES ' + '-' * 55)

        linha = formataString('[12] CPF/CNPJ: %s' % resp_cpf_cnpj, 75, ' ', 'D', 'N', 'S')
        linha += formataString('[13] Cargo: %s' % resp_cargo, 75, ' ', 'D', 'N', 'S')
        listagem.informaCab(linha)

        linha = formataString('[14] Responsavel: %s' % resp_nome, 75, ' ', 'D', 'N', 'S')
        linha += formataString('[15] Telefone: %s' % resp_telefone, 75, ' ', 'D', 'N', 'S')
        listagem.informaCab(linha)

        listagem.informaCab('-' * 150)

        info = 'Declaro serem verdadeiras as informacoes aqui prestadas e confesso ser ' \
               'devedor das obrigacoes a recolher constantes no Quadro Obrigacoes do ' \
               'Periodo desta DAPI, as quais serao recolhidas no prazo estabelecido na ' \
               'legislacao tributaria, sob pena de protesto e inscricao em divida ativa.'
        listagem.informaCab(info[:148])
        listagem.informaCab(info[148:])

        listagem.informaCab(' ')
        listagem.rodapePadrao()

        listagem.imprimeLinha('| IV  -  ' + '-' * 43 + ' DEMONSTRATIVO DAS OPERACOES / PRESTACOES '
                                                       'DE ENTRADA  ' + '-' * 43 + '|')
        linha = '|'
        linha += formataString(' ', 60, ' ', 'D', 'N', 'S')
        linha += '   '
        linha += formataString('Imposto s/', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Isentas', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Parc. Base', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString(' ', 46, ' ', 'E', 'N', 'S')
        linha += '|'
        listagem.imprimeLinha(linha)

        linha = '|'
        linha += formataString(' ', 22, ' ', 'D', 'N', 'S')
        linha += '   '
        linha += formataString('Valores', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Base', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Imposto', 9, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Aproveit.', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('e Nao', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('de Calculo', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString(' ', 21, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Substit.', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString(' ', 9, ' ', 'E', 'N', 'S')
        linha += '|'
        listagem.imprimeLinha(linha)

        linha = '|'
        linha += formataString(' ', 22, ' ', 'D', 'N', 'S')
        linha += '   '
        linha += formataString('Contabeis', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Calculo', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Creditado', 9, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('de Credito', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Tributadas', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Reduzida', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Diferidas', 9, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Suspensas', 9, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Tribut.', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Outras', 9, ' ', 'E', 'N', 'S')
        linha += '|'
        listagem.imprimeLinha(linha)

        linha = '|'
        linha += formataString(' ', 22, ' ', 'D', 'N', 'S')
        linha += '   '
        linha += formataString('[1]', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('[2]', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('[3]', 9, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('[4]', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('[5] e [6]', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('[7]', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('[8]', 9, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('[9]', 9, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('[10]', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('[11]', 9, ' ', 'E', 'N', 'S')
        linha += '|'
        listagem.imprimeLinha(linha)

        # DEMONSTRATIVO DE ENTRADAS

        entrada_total_vr_contabil = 0
        entrada_total_base_calculo = 0
        entrada_total_imp_creditado = 0
        entrada_total_imp_sem_ap_credito = 0
        entrada_total_isento_nao_trib = 0
        entrada_total_base_reduzida = 0
        entrada_total_diferida = 0
        entrada_total_suspensa = 0
        entrada_total_subs_tributaria = 0
        entrada_total_outras = 0

        entrada_subtotal_vr_contabil = 0
        entrada_subtotal_base_calculo = 0
        entrada_subtotal_imp_creditado = 0
        entrada_subtotal_imp_sem_ap_credito = 0
        entrada_subtotal_isento_nao_trib = 0
        entrada_subtotal_base_reduzida = 0
        entrada_subtotal_diferida = 0
        entrada_subtotal_suspensa = 0
        entrada_subtotal_subs_tributaria = 0
        entrada_subtotal_outras = 0
        for x in range(16, 44):
            if x in (25, 35, 42, 43):
                if x == 43:
                    linha = '|'
                    linha += formataString('[%s] Total das Entradas' % x, 22, ' ', 'D', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(entrada_total_vr_contabil), 10, ' ', 'E',
                                           'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(entrada_total_base_calculo), 10, ' ',
                                           'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(entrada_total_imp_creditado), 9, ' ',
                                           'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(entrada_total_imp_sem_ap_credito), 10,
                                           ' ', 'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(entrada_total_isento_nao_trib), 10, ' ',
                                           'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(entrada_total_base_reduzida), 10, ' ',
                                           'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(entrada_total_diferida), 9, ' ', 'E',
                                           'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(entrada_total_suspensa), 9, ' ', 'E',
                                           'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(entrada_total_subs_tributaria), 10, ' ',
                                           'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(entrada_total_outras), 9, ' ', 'E', 'N',
                                           'S')
                    linha += '|'
                    listagem.imprimeLinha(linha)
                else:
                    linha = '|'
                    linha += formataString('[%s] Sub-total' % x, 22, ' ', 'D', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(entrada_subtotal_vr_contabil), 10, ' ',
                                           'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(entrada_subtotal_base_calculo), 10, ' ',
                                           'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(entrada_subtotal_imp_creditado), 9, ' ',
                                           'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(entrada_subtotal_imp_sem_ap_credito),
                                           10, ' ', 'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(entrada_subtotal_isento_nao_trib), 10,
                                           ' ', 'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(entrada_subtotal_base_reduzida), 10,
                                           ' ', 'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(entrada_subtotal_diferida), 9, ' ', 'E',
                                           'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(entrada_subtotal_suspensa), 9, ' ', 'E',
                                           'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(entrada_subtotal_subs_tributaria), 10,
                                           ' ', 'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(entrada_subtotal_outras), 9, ' ', 'E',
                                           'N', 'S')
                    linha += '|'
                    listagem.imprimeLinha(linha)

                entrada_subtotal_vr_contabil = 0
                entrada_subtotal_base_calculo = 0
                entrada_subtotal_imp_creditado = 0
                entrada_subtotal_imp_sem_ap_credito = 0
                entrada_subtotal_isento_nao_trib = 0
                entrada_subtotal_base_reduzida = 0
                entrada_subtotal_diferida = 0
                entrada_subtotal_suspensa = 0
                entrada_subtotal_subs_tributaria = 0
                entrada_subtotal_outras = 0

                continue

            if x in (16, 26, 36):
                listagem.imprimeLinha('|' + '-' * 66 + self._get_tipo_compra_venda(
                    cr, uid, x, context) + '-' * 66 + '|')
            dapi_movimento_dados = filter(lambda i: i.get('dapi') == x, movimento_dados)

            vr_contabil = sum(map(lambda i: i.get('vr_contabil') or 0, dapi_movimento_dados)) + sum(
                map(lambda i: i.get('vr_fcp') or 0, dapi_movimento_dados))
            entrada_subtotal_vr_contabil += vr_contabil
            entrada_total_vr_contabil += vr_contabil

            vr_base_calculo = sum(map(lambda i: i.get('vr_base_calculo') or 0,
                                  dapi_movimento_dados))
            entrada_subtotal_base_calculo += vr_base_calculo
            entrada_total_base_calculo += vr_base_calculo

            vr_imposto_creditado = sum(map(lambda i: i.get('vr_encargo') or 0,
                                       dapi_movimento_dados))
            entrada_subtotal_imp_creditado += vr_imposto_creditado
            entrada_total_imp_creditado += vr_imposto_creditado

            vr_imposto_sem_ap_credito = sum(map(lambda i: i.get('vr_imposto_sem_ap_credito') or 0,
                                                dapi_movimento_dados))
            entrada_subtotal_imp_sem_ap_credito += vr_imposto_sem_ap_credito
            entrada_total_imp_sem_ap_credito += vr_imposto_sem_ap_credito

            vr_isento_nao_tributado = sum(map(lambda i: i.get('vr_isento_nao_tributado') or 0,
                                              dapi_movimento_dados))
            entrada_subtotal_isento_nao_trib += vr_isento_nao_tributado
            entrada_total_isento_nao_trib += vr_isento_nao_tributado

            vr_base_reduzida = sum(map(lambda i: i.get('vr_base_reduzida') or 0,
                                       dapi_movimento_dados))
            entrada_subtotal_base_reduzida += vr_base_reduzida
            entrada_total_base_reduzida += vr_base_reduzida

            vr_diferido = sum(map(lambda i: i.get('vr_diferido') or 0, dapi_movimento_dados))
            entrada_subtotal_diferida += vr_diferido
            entrada_total_diferida += vr_diferido

            vr_suspenso = sum(map(lambda i: i.get('vr_suspenso') or 0, dapi_movimento_dados))
            entrada_subtotal_suspensa += vr_suspenso
            entrada_total_suspensa += vr_suspenso

            vr_icms_substituicao = sum(map(lambda i: i.get('vr_icms_substituicao') or 0,
                                           dapi_movimento_dados))
            entrada_subtotal_subs_tributaria += vr_icms_substituicao
            entrada_total_subs_tributaria += vr_icms_substituicao

            vr_outros = sum(map(lambda i: i.get('vr_outros') or 0, dapi_movimento_dados))
            entrada_subtotal_outras += vr_outros
            entrada_total_outras += vr_outros

            cfop_movimento = dict_cfop_movimento.get(x)

            linha = '|'
            linha += formataString('[%s] %s' % (x, cfop_movimento), 22, ' ', 'D', 'N', 'S')
            linha += '   '
            linha += formataString(getNumeroEditado(vr_contabil), 10, ' ', 'E', 'N', 'S')
            linha += '   '
            linha += formataString(getNumeroEditado(vr_base_calculo), 10, ' ', 'E', 'N', 'S')
            linha += '   '
            linha += formataString(getNumeroEditado(vr_imposto_creditado), 9, ' ', 'E', 'N', 'S')
            linha += '   '
            linha += formataString(getNumeroEditado(vr_imposto_sem_ap_credito), 10, ' ', 'E', 'N',
                                   'S')
            linha += '   '
            linha += formataString(getNumeroEditado(vr_isento_nao_tributado), 10, ' ', 'E', 'N',
                                   'S')
            linha += '   '
            linha += formataString(getNumeroEditado(vr_base_reduzida), 10, ' ', 'E', 'N', 'S')
            linha += '   '
            linha += formataString(getNumeroEditado(vr_diferido), 9, ' ', 'E', 'N', 'S')
            linha += '   '
            linha += formataString(getNumeroEditado(vr_suspenso), 9, ' ', 'E', 'N', 'S')
            linha += '   '
            linha += formataString(getNumeroEditado(vr_icms_substituicao), 10, ' ', 'E', 'N', 'S')
            linha += '   '
            linha += formataString(getNumeroEditado(vr_outros), 9, ' ', 'E', 'N', 'S')
            linha += '|'
            listagem.imprimeLinha(linha)

        # DEMONSTRATIVO DE SAIDAS

        listagem.imprimeLinha('| V  -  ' + '-' * 44 + '  DEMONSTRATIVO DAS OPERACOES / PRESTACOES '
                                                      'DE SAIDA  ' + '-' * 44 + '|')
        linha = '|'
        linha += formataString(' ', 60, ' ', 'D', 'N', 'S')
        linha += '   '
        linha += formataString('Imposto s/', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Isentas', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Parc. Base', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString(' ', 46, ' ', 'E', 'N', 'S')
        linha += '|'
        listagem.imprimeLinha(linha)

        linha = '|'
        linha += formataString(' ', 22, ' ', 'D', 'N', 'S')
        linha += '   '
        linha += formataString('Valores', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Base', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Imposto', 9, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Aproveit.', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('e Nao', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('de Calculo', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString(' ', 21, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Substit.', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString(' ', 9, ' ', 'E', 'N', 'S')
        linha += '|'
        listagem.imprimeLinha(linha)

        linha = '|'
        linha += formataString(' ', 22, ' ', 'D', 'N', 'S')
        linha += '   '
        linha += formataString('Contabeis', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Calculo', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Creditado', 9, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('de Credito', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Tributadas', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Reduzida', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Diferidas', 9, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Suspensas', 9, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Tribut.', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('Outras', 9, ' ', 'E', 'N', 'S')
        linha += '|'
        listagem.imprimeLinha(linha)

        linha = '|'
        linha += formataString(' ', 22, ' ', 'D', 'N', 'S')
        linha += '   '
        linha += formataString('[1]', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('[2]', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('[3]', 9, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('[4]', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('[5] e [6]', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('[7]', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('[8]', 9, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('[9]', 9, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('[10]', 10, ' ', 'E', 'N', 'S')
        linha += '   '
        linha += formataString('[11]', 9, ' ', 'E', 'N', 'S')
        linha += '|'
        listagem.imprimeLinha(linha)

        saida_total_vr_contabil = 0
        saida_total_base_calculo = 0
        saida_total_imp_creditado = 0
        saida_total_imp_sem_ap_credito = 0
        saida_total_isento_nao_trib = 0
        saida_total_base_reduzida = 0
        saida_total_diferida = 0
        saida_total_suspensa = 0
        saida_total_subs_tributaria = 0
        saida_total_outras = 0

        saida_subtotal_vr_contabil = 0
        saida_subtotal_base_calculo = 0
        saida_subtotal_imp_creditado = 0
        saida_subtotal_imp_sem_ap_credito = 0
        saida_subtotal_isento_nao_trib = 0
        saida_subtotal_base_reduzida = 0
        saida_subtotal_diferida = 0
        saida_subtotal_suspensa = 0
        saida_subtotal_subs_tributaria = 0
        saida_subtotal_outras = 0
        saida_subtotal_fcp = 0.0
        for x in range(44, 66):
            if x in (51, 59, 64, 65):
                if x == 65:
                    linha = '|'
                    linha += formataString('[%s] Total das Saidas' % x, 22, ' ', 'D', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(saida_total_vr_contabil), 10, ' ', 'E',
                                           'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(saida_total_base_calculo), 10, ' ',
                                           'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(saida_total_imp_creditado), 9, ' ',
                                           'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(saida_total_imp_sem_ap_credito), 10,
                                           ' ', 'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(saida_total_isento_nao_trib), 10, ' ',
                                           'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(saida_total_base_reduzida), 10, ' ',
                                           'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(saida_total_diferida), 9, ' ', 'E',
                                           'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(saida_total_suspensa), 9, ' ', 'E',
                                           'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(saida_total_subs_tributaria), 10, ' ',
                                           'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(saida_total_outras), 9, ' ', 'E', 'N',
                                           'S')
                    linha += '|'
                    listagem.imprimeLinha(linha)
                else:
                    linha = '|'
                    linha += formataString('[%s] Sub-total' % x, 22, ' ', 'D', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(saida_subtotal_vr_contabil), 10, ' ',
                                           'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(saida_subtotal_base_calculo), 10, ' ',
                                           'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(saida_subtotal_imp_creditado), 9, ' ',
                                           'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(saida_subtotal_imp_sem_ap_credito), 10,
                                           ' ', 'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(saida_subtotal_isento_nao_trib), 10,
                                           ' ', 'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(saida_subtotal_base_reduzida), 10, ' ',
                                           'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(saida_subtotal_diferida), 9, ' ', 'E',
                                           'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(saida_subtotal_suspensa), 9, ' ', 'E',
                                           'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(saida_subtotal_subs_tributaria), 10,
                                           ' ', 'E', 'N', 'S')
                    linha += '   '
                    linha += formataString(getNumeroEditado(saida_subtotal_outras), 9, ' ', 'E',
                                           'N', 'S')
                    linha += '|'
                    listagem.imprimeLinha(linha)

                saida_subtotal_vr_contabil = 0
                saida_subtotal_base_calculo = 0
                saida_subtotal_imp_creditado = 0
                saida_subtotal_imp_sem_ap_credito = 0
                saida_subtotal_isento_nao_trib = 0
                saida_subtotal_base_reduzida = 0
                saida_subtotal_diferida = 0
                saida_subtotal_suspensa = 0
                saida_subtotal_subs_tributaria = 0
                saida_subtotal_outras = 0

                continue

            if x in (44, 52, 60):
                listagem.imprimeLinha('|' + '-' * 66 + self._get_tipo_compra_venda(
                    cr, uid, x, context) + '-' * 66 + '|')

            dapi_movimento_dados = filter(lambda i: i.get('dapi') == x, movimento_dados)

            vr_contabil = sum(map(lambda i: i.get('vr_contabil') or 0, dapi_movimento_dados))
            saida_subtotal_vr_contabil += vr_contabil
            saida_total_vr_contabil += vr_contabil

            vr_base_calculo = sum(map(lambda i: i.get('vr_base_calculo') or 0,
                                  dapi_movimento_dados))
            saida_subtotal_base_calculo += vr_base_calculo
            saida_total_base_calculo += vr_base_calculo

            vr_imposto_creditado = sum(map(lambda i: i.get('vr_encargo') or 0,
                                       dapi_movimento_dados))
            saida_subtotal_imp_creditado += vr_imposto_creditado
            saida_total_imp_creditado += vr_imposto_creditado

            vr_imposto_sem_ap_credito = sum(map(lambda i: i.get('vr_imposto_sem_ap_credito') or 0,
                                                dapi_movimento_dados))
            saida_subtotal_imp_sem_ap_credito += vr_imposto_sem_ap_credito
            saida_total_imp_sem_ap_credito += vr_imposto_sem_ap_credito

            vr_isento_nao_tributado = sum(map(lambda i: i.get('vr_isento_nao_tributado') or 0,
                                              dapi_movimento_dados))
            saida_subtotal_isento_nao_trib += vr_isento_nao_tributado
            saida_total_isento_nao_trib += vr_isento_nao_tributado

            vr_base_reduzida = sum(map(lambda i: i.get('vr_base_reduzida') or 0,
                                       dapi_movimento_dados))
            saida_subtotal_base_reduzida += vr_base_reduzida
            saida_total_base_reduzida += vr_base_reduzida

            vr_diferido = sum(map(lambda i: i.get('vr_diferido') or 0, dapi_movimento_dados))
            saida_subtotal_diferida += vr_diferido
            saida_total_diferida += vr_diferido

            vr_suspenso = sum(map(lambda i: i.get('vr_suspenso') or 0, dapi_movimento_dados))
            saida_subtotal_suspensa += vr_suspenso
            saida_total_suspensa += vr_suspenso

            vr_icms_substituicao = sum(map(lambda i: i.get('vr_icms_substituicao') or 0,
                                           dapi_movimento_dados))
            saida_subtotal_subs_tributaria += vr_icms_substituicao
            saida_total_subs_tributaria += vr_icms_substituicao

            vr_outros = sum(map(lambda i: i.get('vr_outros') or 0, dapi_movimento_dados))
            saida_subtotal_fcp += sum(map(lambda i: i.get('vr_fcp') or 0, dapi_movimento_dados))
            saida_subtotal_outras += vr_outros
            saida_total_outras += vr_outros

            cfop_movimento = dict_cfop_movimento.get(x)

            linha = '|'
            linha += formataString('[%s] %s' % (x, cfop_movimento), 22, ' ', 'D', 'N', 'S')
            linha += '   '
            linha += formataString(getNumeroEditado(vr_contabil), 10, ' ', 'E', 'N', 'S')
            linha += '   '
            linha += formataString(getNumeroEditado(vr_base_calculo), 10, ' ', 'E', 'N', 'S')
            linha += '   '
            linha += formataString(getNumeroEditado(vr_imposto_creditado), 9, ' ', 'E', 'N', 'S')
            linha += '   '
            linha += formataString(getNumeroEditado(vr_imposto_sem_ap_credito), 10, ' ', 'E', 'N',
                                   'S')
            linha += '   '
            linha += formataString(getNumeroEditado(vr_isento_nao_tributado), 10, ' ', 'E', 'N',
                                   'S')
            linha += '   '
            linha += formataString(getNumeroEditado(vr_base_reduzida), 10, ' ', 'E', 'N', 'S')
            linha += '   '
            linha += formataString(getNumeroEditado(vr_diferido), 9, ' ', 'E', 'N', 'S')
            linha += '   '
            linha += formataString(getNumeroEditado(vr_suspenso), 9, ' ', 'E', 'N', 'S')
            linha += '   '
            linha += formataString(getNumeroEditado(vr_icms_substituicao), 10, ' ', 'E', 'N', 'S')
            linha += '   '
            linha += formataString(getNumeroEditado(vr_outros), 9, ' ', 'E', 'N', 'S')
            linha += '|'
            listagem.imprimeLinha(linha)

        tamanhos = (50, 23)
        # OUTROS CREDITOS / DEBITOS

        listagem.imprimeLinha('| VI  -  ' + '-' * 55 + '  OUTROS CREDITOS / DEBITOS  ' + '-' * 56 +
                              '|')
        linha = '|'
        linha += formataString('Outros Creditos', 73, ' ', 'C', 'N', 'S')
        linha += '|'
        linha += formataString('Outros Debitos', 74, ' ', 'C', 'N', 'S')
        linha += '|'
        listagem.imprimeLinha(linha)

        # [66]
        descricao = _('[66] Credito recebido em transferencia')
        dados = self.get_linha_dapi(cr, uid, 66, movimento_dados, descricao, tamanhos, context)
        vr_credito_recebido_trans = dados.get('valor')
        linha = dados.get('linha')

        # [73]
        descricao = _('[73] Creditos transferencidos')
        dados = self.get_linha_dapi(cr, uid, 73, movimento_dados, descricao, tamanhos, context)
        vr_credito_trans = dados.get('valor')
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [67]
        descricao = _('[67] Credito presumido')
        dados = self.get_linha_dapi(cr, uid, 67, movimento_dados, descricao, tamanhos, context)
        vr_credito_presumido = dados.get('valor')
        linha = dados.get('linha')

        # [74]
        descricao = '[74] Outros'
        dados = self.get_linha_dapi(cr, uid, 74, movimento_dados, descricao, tamanhos, context)
        vr_outros = dados.get('valor')
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [68]
        descricao = _('[68] Credito extemporaneo')
        dados = self.get_linha_dapi(cr, uid, 68, movimento_dados, descricao, tamanhos, context)
        vr_credito_ex = dados.get('valor')
        linha = dados.get('linha')

        # [74.1]
        descricao = _('[74.1] Debito Difal origem (EC 87/2015)')
        dados = self.get_linha_dapi(cr, uid, 74, movimento_dados, descricao, tamanhos, context)
        vr_debito_difal_origem = dados.get('valor')
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [69]
        descricao = _('[69] Diferenca de aliquota')
        dados = self.get_linha_dapi(cr, uid, 69, movimento_dados, descricao, tamanhos, context)
        vr_diferenca_aliquota = dados.get('valor')
        linha = dados.get('linha')

        # [75]
        descricao = '[75] Total'
        total_outro_debito = vr_credito_trans + vr_outros + vr_debito_difal_origem
        context['vr_total'] = total_outro_debito
        dados = self.get_linha_dapi(cr, uid, 75, movimento_dados, descricao, tamanhos, context)
        del context['vr_total']
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [70]
        descricao = _('[70] Restituicao ST - Creditamento')
        context['unico'] = True
        dados = self.get_linha_dapi(cr, uid, 70, movimento_dados, descricao, tamanhos, context)
        vr_restituicao_st = dados.get('valor')
        listagem.imprimeLinha(dados.get('linha'))

        # [71]
        descricao = _('[71] Outros')
        dados = self.get_linha_dapi(cr, uid, 71, movimento_dados, descricao, tamanhos, context)
        vr_outros_credito = dados.get('valor')
        listagem.imprimeLinha(dados.get('linha'))

        # [71.1]
        descricao = _('[71.1] Credito Difal origem (EC 87/2015)')
        dados = self.get_linha_dapi(cr, uid, 71, movimento_dados, descricao, tamanhos, context)
        vr_credito_difal_origem = dados.get('valor')
        listagem.imprimeLinha(dados.get('linha'))

        # [72]
        descricao = '[72] Total'
        total_outro_credito = vr_credito_recebido_trans + vr_credito_presumido + vr_credito_ex + \
            vr_diferenca_aliquota + vr_restituicao_st + vr_outros_credito + vr_credito_difal_origem
        context['vr_total'] = total_outro_credito
        dados = self.get_linha_dapi(cr, uid, 72, movimento_dados, descricao, tamanhos, context)
        del context['vr_total']
        del context['unico']
        listagem.imprimeLinha(dados.get('linha'))

        # ICMS SUBSTITUTO TRIBUTARIO

        listagem.imprimeLinha('| VII  -  ' + '-' * 54 + '  ICMS - SUBSTITUTO TRIBUTARIO  ' +
                              '-' * 53 + '|')
        listagem.imprimeLinha('|' + formataString(_('Por Saidas'), 148, ' ', 'C', 'N', 'S') + '|')
        linha = '|'
        linha += formataString(_('Operacoes Internas'), 73, ' ', 'C', 'N', 'S')
        linha += '|'
        linha += formataString(_('Operacoes Interestaduais'), 37, ' ', 'C', 'N', 'S')
        linha += '|'
        linha += formataString('Por Entradas', 36, ' ', 'C', 'N', 'S')
        linha += '|'
        listagem.imprimeLinha(linha)

        tamanhos = (50, 23)
        # [76]
        descricao = _('[76] Base de calculo subst. tributaria')
        dados = self.get_linha_dapi(cr, uid, 76, movimento_dados, descricao, tamanhos, context)
        linha = dados.get('linha')

        # [83]
        descricao = '[83]'
        dados = self.get_linha_dapi(cr, uid, 83, movimento_dados, descricao, (19, 17), context)
        linha += dados.get('linha')

        # [85]
        descricao = '[85]'
        dados = self.get_linha_dapi(cr, uid, 85, movimento_dados, descricao, (18, 17), context)
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [77]
        descricao = _('[77] Valor retido')
        dados = self.get_linha_dapi(cr, uid, 77, movimento_dados, descricao, tamanhos, context)
        linha = dados.get('linha')

        # [84]
        descricao = '[84]'
        dados = self.get_linha_dapi(cr, uid, 84, movimento_dados, descricao, (19, 17), context)
        linha += dados.get('linha')

        # [86]
        descricao = '[86]'
        dados = self.get_linha_dapi(cr, uid, 86, movimento_dados, descricao, (18, 17), context)
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [77.1]
        descricao = _('[77.1] Outros Debitos de ST')
        context['unico_vii'] = True
        dados = self.get_linha_dapi(cr, uid, 77, movimento_dados, descricao, tamanhos, context)
        listagem.imprimeLinha(dados.get('linha'))

        # [78]
        descricao = _('[78] Saldo credor-ST do per. Anterior')
        dados = self.get_linha_dapi(cr, uid, 78, movimento_dados, descricao, tamanhos, context)
        listagem.imprimeLinha(dados.get('linha'))

        # [79]
        descricao = _('[79] Restituicao - Ressarc. e Abatim.')
        dados = self.get_linha_dapi(cr, uid, 79, movimento_dados, descricao, tamanhos, context)
        listagem.imprimeLinha(dados.get('linha'))

        # [80]
        descricao = _('[80] Devolucao / Outros Creditos')
        dados = self.get_linha_dapi(cr, uid, 80, movimento_dados, descricao, tamanhos, context)
        listagem.imprimeLinha(dados.get('linha'))

        # [81]
        descricao = _('[81] Saldo credor-ST p/ o per. Seguinte')
        dados = self.get_linha_dapi(cr, uid, 81, movimento_dados, descricao, tamanhos, context)
        listagem.imprimeLinha(dados.get('linha'))

        # [82]
        descricao = _('[82] ICMS subst. tributaria a recolher')
        dados = self.get_linha_dapi(cr, uid, 82, movimento_dados, descricao, tamanhos, context)
        listagem.imprimeLinha(dados.get('linha'))

        # [82.1]
        descricao = _('[82.1] Estorno devido ao FEM')
        dados = self.get_linha_dapi(cr, uid, 82, movimento_dados, descricao, tamanhos, context)
        listagem.imprimeLinha(dados.get('linha'))

        # [82.2]
        descricao = _('[82.2] Fundo de Errad. da Miseria a recolher')
        dados = self.get_linha_dapi(cr, uid, 82, movimento_dados, descricao, tamanhos, context)
        listagem.imprimeLinha(dados.get('linha'))
        del context['unico_vii']

        # Apuracao do ICMS no periodo
        listagem.imprimeLinha('| VIII  -  ' + '-' * 44 + '  APURACAO DO ICMS NO PERIODO ' +
                              '-' * 64 + '|')

        linha = '|'
        linha += formataString(_('Creditos'), 73, ' ', 'C', 'N', 'S')
        linha += '|'
        linha += formataString(_('Debitos'), 74, ' ', 'C', 'N', 'S')
        linha += '|'
        listagem.imprimeLinha(linha)

        # [87]
        descricao = _('[87] Saldo credor do periodo anterior')
        dados = self.get_linha_dapi(cr, uid, 87, movimento_dados, descricao, tamanhos, context)
        vr_saldo_credor_periodo_anterior = dados.get('valor')
        linha = dados.get('linha')

        # [93]
        descricao = _('[93] Por Saidas')
        dados = self.get_linha_dapi(cr, uid, 93, movimento_dados, descricao, tamanhos, context)
        vr_por_saidas = dados.get('valor')
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [88]
        descricao = _('[88] Por entradas')
        dados = self.get_linha_dapi(cr, uid, 88, movimento_dados, descricao, tamanhos, context)
        vr_por_entradas = dados.get('valor')
        linha = dados.get('linha')

        # [94]
        descricao = _('[94] Outros debitos')
        dados = self.get_linha_dapi(cr, uid, 94, movimento_dados, descricao, tamanhos, context)
        vr_outros_debitos = dados.get('valor')
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [89]
        descricao = _('[89] Outros creditos')
        dados = self.get_linha_dapi(cr, uid, 89, movimento_dados, descricao, tamanhos, context)
        vr_outros_creditos = dados.get('valor')
        linha = dados.get('linha')

        # [95]
        descricao = _('[95] Estorno de creditos')
        dados = self.get_linha_dapi(cr, uid, 95, movimento_dados, descricao, tamanhos, context)
        vr_estorno_creditos = dados.get('valor')
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [90]
        descricao = _('[90] Estorno de debitos')
        dados = self.get_linha_dapi(cr, uid, 90, movimento_dados, descricao, tamanhos, context)
        vr_estorno_debitos = dados.get('valor')
        linha = dados.get('linha')

        # [96]
        descricao = _('[96] Total')
        context['vr_total'] = vr_por_saidas + vr_outros_debitos + vr_estorno_creditos
        dados = self.get_linha_dapi(cr, uid, 96, movimento_dados, descricao, tamanhos, context)
        del context['vr_total']
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [90.1]
        descricao = _('[90.1] Estorno FEM')
        context['vr_total'] = saida_subtotal_fcp
        dados = self.get_linha_dapi(cr, uid, 90, movimento_dados, descricao, tamanhos, context)
        del context['vr_total']
        linha = dados.get('linha')

        # [97]
        descricao = _('[97] Saldo devedor apurado')
        dados = self.get_linha_dapi(cr, uid, 97, movimento_dados, descricao, tamanhos, context)
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [91]
        descricao = _('[91] Total')
        context['vr_total'] = vr_saldo_credor_periodo_anterior + vr_por_entradas + \
            vr_outros_creditos + vr_estorno_debitos + saida_subtotal_fcp
        dados = self.get_linha_dapi(cr, uid, 91, movimento_dados, descricao, tamanhos, context)
        del context['vr_total']
        linha = dados.get('linha')

        # [98]
        descricao = _('[98] Deducoes')
        dados = self.get_linha_dapi(cr, uid, 98, movimento_dados, descricao, tamanhos, context)
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [92]
        descricao = _('[92] Saldo credor para periodo seguinte')
        dados = self.get_linha_dapi(cr, uid, 92, movimento_dados, descricao, tamanhos, context)
        linha = dados.get('linha')

        # [98.1]
        descricao = _('[98.1] Fundo de Errad. da Miseria a recolher')
        dados = self.get_linha_dapi(cr, uid, 98, movimento_dados, descricao, tamanhos, context)
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # Obrigacoes do Periodo
        listagem.imprimeLinha('| IX  -  ' + '-' * 58 + '  OBRIGACOES DO PERIODO ' +
                              '-' * 58 + '|')

        linha = '|'
        linha += formataString(_('Obrigacoes a Recolher'), 73, ' ', 'C', 'N', 'S')
        linha += '|'
        linha += formataString(_('ICMS Recolhido no Momento das Entradas/Saidas'), 74, ' ', 'C',
                               'N', 'S')
        linha += '|'
        listagem.imprimeLinha(linha)

        # [99]
        descricao = _('[99] ICMS a recolher no periodo')
        dados = self.get_linha_dapi(cr, uid, 99, movimento_dados, descricao, tamanhos, context)
        vr_icms_recolher_periodo = dados.get('valor')
        linha = dados.get('linha')

        # [106]
        descricao = _('[106] Importacao')
        dados = self.get_linha_dapi(cr, uid, 106, movimento_dados, descricao, tamanhos, context)
        vr_importacao = dados.get('valor')
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [100]
        descricao = _('[100] Diferenca de aliquota')
        dados = self.get_linha_dapi(cr, uid, 100, movimento_dados, descricao, tamanhos, context)
        vr_diferenca_aliquota = dados.get('valor')
        linha = dados.get('linha')

        # [107]
        descricao = _('[107] Debito extemporaneo')
        dados = self.get_linha_dapi(cr, uid, 107, movimento_dados, descricao, tamanhos, context)
        vr_debito_extemporaneo = dados.get('valor')
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [101]
        descricao = _('[101] Substituicao Tributaria - Por Entradas')
        dados = self.get_linha_dapi(cr, uid, 101, movimento_dados, descricao, tamanhos, context)
        vr_subs_tributaria_entrada = dados.get('valor')
        linha = dados.get('linha')

        # [108]
        descricao = _('[108] Substituicao tributaria')
        dados = self.get_linha_dapi(cr, uid, 108, movimento_dados, descricao, tamanhos, context)
        vr_subs_tributaria = dados.get('valor')
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [102]
        descricao = _('[102] Substituicao tributaria - Por Saidas')
        dados = self.get_linha_dapi(cr, uid, 102, movimento_dados, descricao, tamanhos, context)
        vr_subs_tributaria_saida = dados.get('valor')
        linha = dados.get('linha')

        # [109]
        descricao = _('[109] Outros')
        dados = self.get_linha_dapi(cr, uid, 109, movimento_dados, descricao, tamanhos, context)
        vr_outros = dados.get('valor')
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [103]
        descricao = _('[103] Servico de transporte de responsabilidade do remetente')
        dados = self.get_linha_dapi(cr, uid, 103, movimento_dados, descricao, tamanhos, context)
        vr_servico_transporte = dados.get('valor')
        linha = dados.get('linha')

        # [110]
        descricao = _('[110] Total de ICMS antecipado')
        dados = self.get_linha_dapi(cr, uid, 110, movimento_dados, descricao, tamanhos, context)
        vr_icms_antecipado = dados.get('valor')
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [104]
        descricao = _('[104] Outros')
        dados = self.get_linha_dapi(cr, uid, 104, movimento_dados, descricao, tamanhos, context)
        vr_outros = dados.get('valor')
        linha = dados.get('linha')

        # [110.1]
        descricao = _('[110.1] Total do FEM Antecipado / Extemporaneo')
        dados = self.get_linha_dapi(cr, uid, 110, movimento_dados, descricao, tamanhos, context)
        vr_fem_antecipado = dados.get('valor')
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [104.1]
        context['unico'] = True
        descricao = _('[104.1] Recolhimento Efetivo')
        dados = self.get_linha_dapi(cr, uid, 104, movimento_dados, descricao, tamanhos, context)
        vr_recolhimento_efetivo = dados.get('valor')
        linha = dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [105]
        descricao = _('[105] Total do ICMS')
        context['vr_total'] = vr_icms_recolher_periodo + vr_diferenca_aliquota + \
            vr_subs_tributaria_entrada + vr_subs_tributaria_saida + vr_servico_transporte + \
            vr_outros + vr_recolhimento_efetivo
        dados = self.get_linha_dapi(cr, uid, 105, movimento_dados, descricao, tamanhos, context)
        del context['vr_total']
        linha = dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [105.1]
        descricao = _('[105.1] Total do FEM Subst. Tributario')
        dados = self.get_linha_dapi(cr, uid, 105, movimento_dados, descricao, tamanhos, context)
        vr_total_fem_subs_tributario = dados.get('valor')
        linha = dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [105.2]
        descricao = _('[105.2] Total FEM Op. Propria')
        dados = self.get_linha_dapi(cr, uid, 105, movimento_dados, descricao, tamanhos, context)
        vr_total_fem_op_propria = dados.get('valor')
        linha = dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))
        del context['unico']

        # Informacoes Complementares
        # Informacoes Economicas
        listagem.imprimeLinha('| X  -  ' + '-' * 18 + '  INFORMACOES COMPLEMENTARES ' +
                              '-' * 19 + '| XI  -  ' + '-' * 21 + ' INFORMACOES ECONOMICAS ' +
                              '-' * 21 + '|')

        # [111]
        descricao = _('[111] Exportacao indireta pela Comercial Exportadora / Trading Company')
        dados = self.get_linha_dapi(cr, uid, 111, movimento_dados, descricao, tamanhos, context)
        vr_exportacao_indireta = dados.get('valor')
        linha = dados.get('linha')

        # [115]
        descricao = _('[115] Numero de empregados no ultimo dia do periodo')
        dados = self.get_linha_dapi(cr, uid, 115, movimento_dados, descricao, tamanhos, context)
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [112]
        descricao = _('[112] Saida para SUFRAMA')
        dados = self.get_linha_dapi(cr, uid, 112, movimento_dados, descricao, tamanhos, context)
        vr_saida_suframa = dados.get('valor')
        linha = dados.get('linha')

        # [116]
        descricao = _('[116] Valor da folha de pagamento')
        dados = self.get_linha_dapi(cr, uid, 116, movimento_dados, descricao, tamanhos, context)
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [113]
        descricao = _('[113] Exportacao direta pelo produtor remetente')
        dados = self.get_linha_dapi(cr, uid, 113, movimento_dados, descricao, tamanhos, context)
        vr_exportacao_direta = dados.get('valor')
        linha = dados.get('linha')

        # [117]
        descricao = _('[117] Valor devido Cofins')
        dados = self.get_linha_dapi(cr, uid, 117, movimento_dados, descricao, tamanhos, context)
        vr_cofins = dados.get('valor')
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        # [114]
        descricao = _('[114] Remessa com fim especifico de exportacao pelo produtor / remetente')
        dados = self.get_linha_dapi(cr, uid, 114, movimento_dados, descricao, tamanhos, context)
        vr_remessa_exportacao = dados.get('valor')
        linha = dados.get('linha')

        # [118]
        descricao = _('[118] Energia eletrica consumida no periodo (em Kwh)')
        dados = self.get_linha_dapi(cr, uid, 118, movimento_dados, descricao, tamanhos, context)
        linha += dados.get('linha')
        listagem.imprimeLinha(linha.replace('||', '| '))

        listagem.imprimeLinha('|' + '-' * 148 + '|')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

    def get_linha_dapi(self, cr, uid, codigo, dados, descricao, tamanhos, context=None):
        context = context and context.copy() or {}

        if context.get('vr_total'):
            vr_dapi = context.get('vr_total')
        else:
            vr_dapi = sum(map(lambda i: i.get('vr_contabil') or 0,
                              filter(lambda i: i.get('dapi') == codigo, dados)))

        linha = '|'
        linha += formataString('%s' % descricao, tamanhos[0], ' ', 'D', 'N', 'S')
        linha += formataString(getNumeroEditado(vr_dapi), tamanhos[1], ' ', 'E', 'N', 'S')
        linha += '|'
        if context.get('unico_vii'):
            linha += ' ' * 37 + '|' + ' ' * 36 + '|'
        elif context.get('unico'):
            linha += ' ' * 74 + '|'

        return {'valor': vr_dapi, 'linha': linha}

    def _get_tipo_compra_venda(self, cr, uid, cod_dapi, context=None):
        context = context and context.copy() or {}
        res = ''
        if cod_dapi in (16, 44):
            res = '     ESTADO     '
        elif cod_dapi in (26, 52):
            res = ' OUTROS ESTADOS '
        elif cod_dapi in (36, 60):
            res = '    EXTERIOR    '
        return res


report_custom('report.gerar_dapi')
