# -*- encoding: utf-8 -*-

from openerp.report.interface import report_int
from openerp.report.render import render
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
import StringIO
from openerp import pooler
import time
from SigUtils.formatastring import formataString
from dateutil.parser import parse
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):

    def create(self, cr, uid, ids, datas, context=None):

        def get_linha_total(quantidade_documento, total_produto,
                            total_desconto, total_liquido, tipo='D'):
            if tipo == 'G':
                descricao = 'GERAL'
            else:
                descricao = 'DO DIA'
            descricao = 'TOTAL %s: %s NOTA(S)................' % (descricao, quantidade_documento)
            linha = '|'
            linha += formataString(descricao, 43, ' ', 'D', 'S', 'S')
            linha += ' '
            linha += formataString(' ', 47, ' ', 'D', 'S', 'S')
            linha += ' '
            linha += formataString(getNumeroEditado(total_produto, 2), 18, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString(getNumeroEditado(total_desconto, 2), 17, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString(getNumeroEditado(total_liquido, 2), 19, ' ', 'E', 'S', 'S')
            linha += '|'
            return linha

        def get_resumo_por_operacao(listagem, dict_dados):
            listagem.imprimeLinha('|' + '-' * 148 + '|')
            listagem.imprimeLinha('| R E S U M O  P O R  O P E R A C A O' + ' ' * 112 + '|')
            listagem.imprimeLinha('|' + '-' * 148 + '|')
            linha = '|'
            linha += formataString(_('DESCRICAO'), 43, ' ', 'D', 'S', 'S')
            linha += ' '
            linha += formataString('QUANTIDADE', 10, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString('VALOR', 18, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString('DESCONTO', 17, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString('VALOR TOTAL', 19, ' ', 'E', 'S', 'S')
            linha += ''
            linha += formataString(' ', 37, ' ', 'E', 'S', 'S')
            linha += '|'
            listagem.imprimeLinha(linha)
            linha = '|'
            linha += formataString('Vendas cupom', 43, ' ', 'D', 'S', 'S')
            linha += ' '
            linha += formataString(dict_dados.get('qtd_cupom'), 10, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString(getNumeroEditado(dict_dados.get('produto_cupom'), 2), 18, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString(getNumeroEditado(dict_dados.get('desconto_cupom'), 2), 17, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString(getNumeroEditado(dict_dados.get('total_cupom'), 2), 19, ' ', 'E', 'S', 'S')
            linha += ''
            linha += formataString(' ', 37, ' ', 'E', 'S', 'S')
            linha += '|'
            listagem.imprimeLinha(linha)
            linha = '|'
            linha += formataString('Vendas NF', 43, ' ', 'D', 'S', 'S')
            linha += ' '
            linha += formataString(dict_dados.get('qtd_nf'), 10, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString(getNumeroEditado(dict_dados.get('produto_nf'), 2), 18, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString(getNumeroEditado(dict_dados.get('desconto_nf'), 2), 17, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString(getNumeroEditado(dict_dados.get('total_nf'), 2), 19, ' ', 'E', 'S', 'S')
            linha += ''
            linha += formataString(' ', 37, ' ', 'E', 'S', 'S')
            linha += '|'
            listagem.imprimeLinha(linha)
            listagem.imprimeLinha('|' + '-' * 148 + '|')
            return True

        def get_resumo_financeiro_tipo_documento(listagem, list_dados):
            listagem.imprimeLinha('|' + '-' * 148 + '|')
            listagem.imprimeLinha('| R E S U M O  F I N A N C E I R O  P O R  T I P O  D E  D O C U M E N T O' + ' ' * 75 + '|')
            listagem.imprimeLinha('|' + '-' * 148 + '|')
            linha = '|'
            linha += formataString('DESCRICAO', 43, ' ', 'D', 'S', 'S')
            linha += ' '
            linha += formataString('VALOR BRUTO', 18, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString('DESCONTO', 18, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString('VALOR TOTAL', 18, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString(' ', 47, ' ', 'E', 'S', 'S')
            linha += '|'
            listagem.imprimeLinha(linha)

            list_tipo_pagamento = list(set(map(lambda i: i.get('tipo_pagamento'), list_dados)))
            list_tipo_pagamento.sort()
            total_produto = 0
            total_desconto = 0
            total = 0

            def _imprimi_total_condicao():
                listagem.imprimeLinha('|' + ' ' * 148 + '|')
                linha = '|'
                linha += formataString('TOTAL CONDICAO:', 43, ' ', 'D', 'S', 'S')
                linha += ' '
                linha += formataString(getNumeroEditado(total_tipo_pagamento_produto, 2), 18,
                                       ' ', 'E', 'S', 'S')
                linha += ' '
                linha += formataString(getNumeroEditado(total_tipo_pagamento_desconto, 2), 18,
                                       ' ', 'E', 'S', 'S')
                linha += ' '
                linha += formataString(getNumeroEditado(total_tipo_pagamento, 2), 18, ' ', 'E',
                                       'S', 'S')
                linha += ' '
                linha += formataString(' ', 47, ' ', 'E', 'S', 'S')
                linha += '|'
                listagem.imprimeLinha(linha)
                listagem.imprimeLinha('|' + ' ' * 148 + '|')
                listagem.imprimeLinha('|' + '-' * 148 + '|')

            for tipo in list_tipo_pagamento:

                if list_tipo_pagamento.index(tipo) != 0:
                    _imprimi_total_condicao()

                total_tipo_pagamento_produto = 0
                total_tipo_pagamento_desconto = 0
                total_tipo_pagamento = 0
                if tipo == 'V':
                    desc = 'A VISTA            '
                elif tipo == 'C':
                    desc = 'A PRAZO            '
                elif tipo == 'P':
                    desc = 'CONTRA APRESENTACAO'
                else:
                    desc = 'SEM CONDICOES      '
                dados_tipo_pagamento = filter(lambda i: i.get('tipo_pagamento') == tipo, list_dados)
                if not dados_tipo_pagamento:
                    continue
                listagem.imprimeLinha('|' + ' ' * 148 + '|')
                listagem.imprimeLinha('|%s' % desc + ' ' * 129 + '|')
                listagem.imprimeLinha('|' + ' ' * 148 + '|')
                for dado in dados_tipo_pagamento:
                    if not dado.get('titulo_tipo_documento'):
                        if tipo == 'V':
                            dado['titulo_tipo_documento'] = 'Dinheiro'
                        else:
                            dado['titulo_tipo_documento'] = '**Sem descricao**'
                list_tipo_documento = list(set(map(lambda td: td.get('titulo_tipo_documento'),
                                                   dados_tipo_pagamento)))
                for td in list_tipo_documento:
                    dado_tipo_documento = filter(lambda i: i.get('titulo_tipo_documento') == td,
                                                 dados_tipo_pagamento)
                    if not dados_tipo_pagamento:
                        continue
                    tipo_documento_vr_produto = sum(map(lambda vp: vp.get('vr_produto'),
                                                        dado_tipo_documento))
                    tipo_documento_vr_desconto = sum(map(lambda vp: vp.get('vr_desconto'),
                                                         dado_tipo_documento))
                    tipo_documento_vr_total = sum(map(lambda vp: vp.get('vr_total'),
                                                      dado_tipo_documento))

                    linha = '|'
                    linha += formataString(td, 43, ' ', 'D', 'S', 'S')
                    linha += ' '
                    linha += formataString(getNumeroEditado(tipo_documento_vr_produto, 2), 18, ' ',
                                           'E', 'S', 'S')
                    linha += ' '
                    linha += formataString(getNumeroEditado(tipo_documento_vr_desconto, 2), 18, ' ',
                                           'E', 'S', 'S')
                    linha += ' '
                    linha += formataString(getNumeroEditado(tipo_documento_vr_total, 2), 18, ' ',
                                           'E', 'S', 'S')
                    linha += ' '
                    linha += formataString(' ', 47, ' ', 'E', 'S', 'S')
                    linha += '|'
                    listagem.imprimeLinha(linha)
                    total_produto += tipo_documento_vr_produto
                    total_desconto += tipo_documento_vr_desconto
                    total += tipo_documento_vr_total
                    total_tipo_pagamento_produto += tipo_documento_vr_produto
                    total_tipo_pagamento_desconto += tipo_documento_vr_desconto
                    total_tipo_pagamento += tipo_documento_vr_total

                if list_tipo_pagamento.index(tipo) == len(list_tipo_pagamento) - 1:
                    _imprimi_total_condicao()

            listagem.imprimeLinha('|' + ' ' * 148 + '|')
            linha = '|'
            linha += formataString('TOTAL:', 43, ' ', 'D', 'S', 'S')
            linha += ' '
            linha += formataString(getNumeroEditado(total_produto, 2), 18, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString(getNumeroEditado(total_desconto, 2), 18, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString(getNumeroEditado(total, 2), 18, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString(' ', 47, ' ', 'E', 'S', 'S')
            linha += '|'
            listagem.imprimeLinha(linha)
            listagem.imprimeLinha('|' + ' ' * 148 + '|')
            listagem.imprimeLinha('|' + '-' * 148 + '|')
            return True

        def get_resumo_operadora_cartao(listagem, list_dados):
            listagem.imprimeLinha('|' + '-' * 148 + '|')
            listagem.imprimeLinha(
                '| R E S U M O  P O R  O P E R A D O R A  D E  C A R T A O' + ' ' * 92 + '|')
            listagem.imprimeLinha('|' + '-' * 148 + '|')
            linha = '|'
            linha += formataString('OPERADORA', 43, ' ', 'D', 'S', 'S')
            linha += ' '
            linha += formataString('PARCELAS', 8, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString('VALOR TOTAL', 18, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString(' ', 76, ' ', 'E', 'S', 'S')
            linha += '|'
            listagem.imprimeLinha(linha)
            listagem.imprimeLinha('|' + ' ' * 148 + '|')

            qtd_parcela_geral_operadora = 0
            valor_total_geral_operadora = 0
            list_operadora = list(set(map(lambda i: i.get('titulo_operadora'), list_dados)))
            for operadora in list_operadora:
                titulo_ids = list()
                if not operadora:
                    continue
                dados = filter(lambda i: i.get('titulo_operadora') == operadora, list_dados)
                operadora_dados = list()
                for dado in dados:
                    if dado.get('titulo_id') in titulo_ids:
                        continue
                    titulo_ids.append(dado.get('titulo_id'))
                    operadora_dados.append(dado)
                qtd_parcela_operadora = len(operadora_dados)
                valor_total_operadora = sum(map(lambda i: i.get('titulo_valor') or 0.0,
                                            operadora_dados))
                qtd_parcela_geral_operadora += qtd_parcela_operadora
                valor_total_geral_operadora += valor_total_operadora
                linha = '|'
                linha += formataString(operadora, 43, ' ', 'D', 'S', 'S')
                linha += ' '
                linha += formataString(getNumeroEditado(qtd_parcela_operadora, 2), 8, ' ', 'E', 'S', 'S')
                linha += ' '
                linha += formataString(getNumeroEditado(valor_total_operadora, 2), 18, ' ', 'E', 'S', 'S')
                linha += ' '
                linha += formataString(' ', 76, ' ', 'E', 'S', 'S')
                linha += '|'
                listagem.imprimeLinha(linha)
            listagem.imprimeLinha('|' + ' ' * 148 + '|')
            linha = '|'
            linha += formataString('TOTAL:', 43, ' ', 'D', 'S', 'S')
            linha += ' '
            linha += formataString(getNumeroEditado(qtd_parcela_geral_operadora, 2), 8, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString(getNumeroEditado(valor_total_geral_operadora, 2), 18, ' ', 'E', 'S', 'S')
            linha += ' '
            linha += formataString(' ', 76, ' ', 'E', 'S', 'S')
            linha += '|'
            listagem.imprimeLinha(linha)
            return True

        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('documentos_emitidos'))
        listagem.informaTamLinha(160)

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'wizard.documento.emitido')
        nome_empresa = pooler.get_pool(cr.dbname).get('res.company').browse(
            cr, uid, company_id).name
        obj_adm_util = pooler.get_pool(cr.dbname).get('adm.utils')
        data = parse(time.strftime("%d/%m/%Y %H:%M:%S"))
        data = obj_adm_util.admutl_datetime_to_timezone(cr, uid, data, "%d/%m/%Y %H:%M:%S")
        title = formataString(' ', 50, ' ', 'D', 'S', 'S')
        title += formataString(_('RELACAO DE DOCUMENTOS EMITIDOS'), 54, ' ', 'C', 'S', 'S')
        title += formataString(data, 46, ' ', 'E', 'S', 'S')

        docs = formataString(' ', 53, ' ', 'D', 'S', 'S')
        docs += formataString(nome_empresa, 53, ' ', 'C', 'S', 'S')
        docs += formataString(_('Pagina: {{ Page }} '), 53, ' ', 'E', 'S', 'S')

        usuario = pooler.get_pool(cr.dbname).get('res.users').browse(
            cr, uid, uid, context).pessoa_id.nome or ''
        data_inicial = parse(datas.get('data_inicial')).strftime('%d/%m/%Y')
        data_final = parse(datas.get('data_final')).strftime('%d/%m/%Y')
        dados = datas.get('dados')
        dados_resumo_tipo_documento = datas.get('dados_resumo_tipo_documento')
        pessoa_nome = datas.get('pessoa_nome')
        tipo_documento = datas.get('tipo_documento')
        listar_venda = datas.get('listar_venda')
        qtd_documento = 0
        qtd_documento_geral = 0
        total_produto_dia = 0
        total_produto_geral = 0
        total_desconto_dia = 0
        total_desconto_geral = 0
        total_dia = 0
        total_geral = 0
        qtd_total_cupom = 0
        valor_produto_total_cupom = 0
        valor_desconto_total_cupom = 0
        valor_total_cupom = 0
        qtd_total_nf = 0
        valor_produto_total_nf = 0
        valor_desconto_total_nf = 0
        valor_total_nf = 0
        count = 0
        docs1 = formataString(_('USUARIO: ') + usuario, 50, ' ', 'D', 'S', 'S')
        docs1 += formataString(' ', 50, ' ', 'C', 'S', 'S')
        docs1 += formataString(_('PERIODO: %s A %s') % (data_inicial, data_final), 50, ' ', 'E', 'S', 'S')
        docs2 = center_title(_('CLIENTE: %s') % pessoa_nome, '', '')
        docs3 = center_title(_('TIPO DOCUMENTO: %s') % tipo_documento, '', '')
        docs4 = center_title(_('LISTAR APENAS VENDAS: %s') % listar_venda, '', '')

        listagem.informaCab(docs)
        listagem.informaCab('')
        listagem.informaCab(title)
        listagem.informaCab('')
        listagem.informaCab(docs1)
        listagem.informaCab(docs2)
        listagem.informaCab(docs3)
        listagem.informaCab(docs4)
        listagem.informaCab('')
        listagem.informaCab(_('|----------------------------------------------------------------------------------------------------------------------------------------------------|'))
        listagem.informaCab(_('| CLIENTE/FORNECEDOR                        | DOCUMENTO   | NUMERO          | SERIE         |       VR.PRODUTO |     VR.DESCONTO |          VR.TOTAL |'))
        listagem.informaCab(_('|           | Tipo de Documento      | Numero        | Parcela | Vencimento |       Valor |                                                          |'))
        listagem.informaCab(_('|----------------------------------------------------------------------------------------------------------------------------------------------------|'))
        listagem.rodapePadrao()
        list_data_emissao = []
        dict_pessoa_data_doc = {}
        dict_titulo_tipo_documento = dict()
        dados = sorted(dados, key=lambda v: v['data_emissao'])
        for i in dados:
            if i == dados[-1] and i.get('state') == 'V':
                pass
            else:
                if i == dados[-1] and i.get('state') == 'C':
                    continue
                if i.get('state') == 'C' or (i.get('state') == 'V' and dados[dados.index(i) + 1].get(
                        'state') == 'C'):
                    continue
            count += 1
            pessoa_id = i.get('pessoa_id')
            data_emissao = parse(i.get('data_emissao')).strftime('%d/%m/%Y')
            numero_documento = i.get('numero_documento')
            pessoa_data_doc = '%s-%s-%s' % (pessoa_id, data_emissao, numero_documento)
            # dict_titulo_tipo_documento = dict()
            titulo_operadora = i.get('titulo_operadora')
            nro_autorizacao = i.get('titulo_nro_autorizacao') or ''
            titulo_estado = i.get('titulo_state')
            titulo_tipo_documento = ''
            data_vencimento = i.get('titulo_data_vencimento') or ' '
            if data_vencimento:
                data_vencimento = parse(data_vencimento).strftime('%d/%m/%Y')
            if all([i.get('titulo_tipo_documento'), i.get('titulo_documento'), data_vencimento,
                    i.get('titulo_valor')]):
                titulo_tipo_documento = '%s-%s-%s-%s' % (
                    i.get('titulo_tipo_documento') or ' ', i.get('titulo_documento') or ' ',
                    data_vencimento, i.get('titulo_valor') or 0.0)
                if titulo_tipo_documento not in dict_titulo_tipo_documento:
                    dict_titulo_tipo_documento[titulo_tipo_documento] = True
            if data_emissao not in list_data_emissao:
                if dados.index(i) != 0:
                    listagem.imprimeLinha('|' + ' ' * 148 + '|')
                    linha = get_linha_total(qtd_documento, total_produto_dia, total_desconto_dia,
                                            total_dia)
                    listagem.imprimeLinha(linha)
                    qtd_documento = 0
                    total_produto_dia = 0
                    total_desconto_dia = 0
                    total_dia = 0
                list_data_emissao.append(data_emissao)
                listagem.imprimeLinha('')
                listagem.imprimeLinha(_(' DATA DE EMISSAO: %s' % data_emissao))
            if not dict_pessoa_data_doc.get(pessoa_data_doc):
                listagem.imprimeLinha('|' + '-' * 148 + '|')
                qtd_documento_geral += 1
                qtd_documento += 1
                dict_pessoa_data_doc[pessoa_data_doc] = True
                linha = _('|')
                linha += formataString(i.get('nome_pessoa') or ' ', 43, ' ', 'D', 'S', 'S')
                linha += _('|')
                linha += formataString(i.get('doc') or ' ', 13, ' ', 'D', 'S', 'S')
                linha += _('|')
                linha += formataString(i.get('numero_documento') or ' ', 17, ' ', 'D', 'S', 'S')
                linha += _('|')
                linha += formataString(i.get('serie') or ' ', 15, ' ', 'D', 'S', 'S')
                linha += _('|')
                linha += formataString(getNumeroEditado(i.get('vr_produto') or 0.0, 2), 18, ' ', 'E', 'S', 'S')
                linha += _('|')
                linha += formataString(getNumeroEditado(i.get('vr_desconto') or 0.0, 2), 17, ' ', 'E', 'S', 'S')
                linha += _('|')
                linha += formataString(getNumeroEditado(i.get('vr_total') or 0.0, 2), 19, ' ', 'E', 'S', 'S')
                linha += _('|')
                listagem.imprimeLinha(linha)
                total_produto_dia += i.get('vr_produto') or 0.0
                total_produto_geral += i.get('vr_produto') or 0.0
                total_desconto_dia += i.get('vr_desconto') or 0.0
                total_desconto_geral += i.get('vr_desconto') or 0.0
                total_dia += i.get('vr_total') or 0.0
                total_geral += i.get('vr_total') or 0.0
                if i.get('doc') == 'CUP':
                    qtd_total_cupom += 1
                    valor_produto_total_cupom += i.get('vr_produto') or 0.0
                    valor_desconto_total_cupom += i.get('vr_desconto') or 0.0
                    valor_total_cupom += i.get('vr_total') or 0.0
                else:
                    qtd_total_nf += 1
                    valor_produto_total_nf += i.get('vr_produto') or 0.0
                    valor_desconto_total_nf += i.get('vr_desconto') or 0.0
                    valor_total_nf += i.get('vr_total') or 0.0
            if dict_pessoa_data_doc.get(pessoa_data_doc) and dict_titulo_tipo_documento.get(
                    titulo_tipo_documento):
                dict_titulo_tipo_documento[titulo_tipo_documento] = False
                linha = _('|')
                linha += formataString(' ', 11, ' ', 'D', 'S', 'S')
                linha += _('|')
                linha += formataString(i.get('titulo_tipo_documento') or ' ', 24, ' ', 'D', 'S', 'S')
                linha += _('|')
                linha += formataString(i.get('titulo_documento') or ' ', 15, ' ', 'D', 'S', 'S')
                linha += _('|')
                linha += formataString(i.get('titulo_parcela') or ' ', 9, ' ', 'D', 'S', 'S')
                linha += _('|')
                linha += formataString(data_vencimento, 12, ' ', 'D', 'S', 'S')
                linha += _('|')
                linha += formataString(getNumeroEditado(i.get('titulo_valor') or 0.0, 2), 13, ' ', 'E', 'S', 'S')
                linha += _('|')
                if titulo_operadora:
                    linha += formataString('Operadora: %s - Nr.Aut.: %s. %s' % (
                        titulo_operadora, nro_autorizacao, titulo_estado), 58, ' ', 'D', 'S', 'S')
                    linha += _('|')
                else:
                    linha += formataString(' ', 58, ' ', 'E', 'S', 'S')
                    linha += _('|')
                listagem.imprimeLinha(linha)
            if count == len(dados):
                listagem.imprimeLinha('|' + ' ' * 148 + '|')
                linha = get_linha_total(qtd_documento, total_produto_dia, total_desconto_dia,
                                        total_dia)
                listagem.imprimeLinha(linha)
        listagem.imprimeLinha('|' + ' ' * 148 + '|')
        linha = get_linha_total(qtd_documento_geral, total_produto_geral, total_desconto_geral,
                                total_geral, 'G')
        listagem.imprimeLinha(linha)
        listagem.imprimeLinha('|' + '-' * 148 + '|')
        listagem.imprimeLinha(' ' * 150)
        listagem.imprimeLinha(' ' * 150)
        listagem.cabecalhos = []

        # RESUMO POR OPERACAO
        dict_dados_por_operacao = {
            'qtd_cupom': qtd_total_cupom,
            'produto_cupom': valor_produto_total_cupom,
            'desconto_cupom': valor_desconto_total_cupom,
            'total_cupom': valor_total_cupom,
            'qtd_nf': qtd_total_nf,
            'produto_nf': valor_produto_total_nf,
            'desconto_nf': valor_desconto_total_nf,
            'total_nf': valor_total_nf
        }
        get_resumo_por_operacao(listagem, dict_dados_por_operacao)

        listagem.imprimeLinha(' ' * 150)
        listagem.imprimeLinha(' ' * 150)

        # RESUMO FINANCEIRO POR TIPO DE DOCUMENTO
        get_resumo_financeiro_tipo_documento(listagem, dados_resumo_tipo_documento)

        listagem.imprimeLinha(' ' * 150)
        listagem.imprimeLinha(' ' * 150)

        # RESUMO POR OPERADORA DE CARTAO
        get_resumo_operadora_cartao(listagem, dados)

        listagem.imprimeLinha(_('*----------------------------------------------------------------------------------------------------------------------------------------------------*'))

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.documento_emitido')
