# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(e, c, d, t=160):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        context = context and context.copy() or {}
        title = center_title('', _('Listagem DeSTDA'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('listagem_destda'))
        listagem.informaTamLinha(160)

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'financeiro.titulo', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))

        dict_mes = {
            '01': 'JANEIRO',
            '02': 'FEVEREIRO',
            '03': 'MARCO',
            '04': 'ABRIL',
            '05': 'MAIO',
            '06': 'JUNHO',
            '07': 'JULHO',
            '08': 'AGOSTO',
            '09': 'SETEMBRO',
            '10': 'OUTUBRO',
            '11': 'NOVEMBRO',
            '12': 'DEZEMBRO'
        }

        linha_mes_ano = formataString(_('Mes') + ': %s' % dict_mes.get(datas.get('mes')), 50, ' ',
                                      'D', 'N', 'S')
        linha_mes_ano += formataString('Ano: %s' % datas.get('ano'), 100, ' ', 'D', 'N', 'S')

        linha_icms = formataString('ICMS de ST: %s' % getNumeroEditado(datas.get('icms_st')),
                                   50, ' ', 'D', 'N', 'S')
        linha_icms += formataString('ICMS ativo fixo: %s' % getNumeroEditado(
            datas.get('icms_ativo_fixo')), 50, ' ', 'D', 'N', 'S')
        linha_icms += formataString('ICMS uso e consumo: %s' % getNumeroEditado(
            datas.get('icms_uso_consumo')), 50, ' ', 'D', 'N', 'S')

        listagem.informaCab(title)
        listagem.informaCab('')
        listagem.informaCab(docs)
        listagem.informaCab('')
        listagem.informaCab(linha_mes_ano)
        listagem.informaCab(linha_icms)
        listagem.informaCab('')
        listagem.informaCab('*-----------------------------*')
        listagem.informaCab('| ESTADO |              VALOR |')
        listagem.informaCab('*-----------------------------*')
        listagem.informaCab('')
        listagem.rodapePadrao()

        for x in pooler.get_pool(cr.dbname).get('wizard.gerar.destda.difal').browse(
                cr, uid, datas.get('difal_ids'), context):
            linha = '|'
            linha += formataString(x.wizdif_estado, 8, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(x.wizdif_valor), 20, ' ', 'E', 'N', 'S')
            linha += '|'
            listagem.imprimeLinha(linha)
        listagem.imprimeLinha('*-----------------------------*')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

report_custom('report.listagem_destda')
