# -*- coding: utf-8 -*-

from openerp.report.interface import report_int
from openerp.report.render import render
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
import StringIO
from openerp import pooler
import time
from SigUtils.formatastring import formataString
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        title = center_title('', _('ITENS & TRIBUTACOES'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato()  # Formato A4 - retrato (padrao)
        listagem.informaNome(pdf_string, _('Listagem de Itens e Tributacoes'))
        listagem.informaTamLinha(160)
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)
        listagem.defineFonte(tam=6.3)

        data_inicial = datas.get('data_inicial')
        data_final = datas.get('data_final')
        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'wizard.listagem.item.tributacao')
        nome_empresa = pooler.get_pool(cr.dbname).get('res.company').browse(
            cr, uid, company_id).name
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab(_('Periodo: %s a %s') % (
            time.strftime("%d/%m/%Y", time.strptime(data_inicial, "%Y-%m-%d")),
            time.strftime("%d/%m/%Y", time.strptime(data_final, "%Y-%m-%d"))))
        listagem.informaCab('')
        listagem.informaCab('+' + '-' * 148 + '+')
        listagem.informaCab(
            _('|      DOCUMENTO        |                  PESSOA                 |      DATA     |'
              '    TIPO MOVIMENTO    |   TIPO  |            NATUREZA             |'))
        listagem.informaCab('|' + '-' * 148 + '|')
        listagem.informaCab(
            _('| COD. PROD. |    GRADE    |           PRODUTO          |QUANTIDADE|CFOP|TOTAL '
              'ITEM|ENCARGO|CST|BASE CALCULO|ALIQUOTA|VR ENCARGO|VR BASE ST|   VR ST |'))
        listagem.informaCab('|' + '-' * 148 + '|')
        listagem.rodapePadrao()
        list_documento = []
        vr_total_nf = vr_total_coo = 0
        list_produto_codigo = []
        item_somado = [] # como o item aparece para cada imposto, calcula apenas uma vez o seu valor
        for i in datas.get('dados'):
            count = 0
            documento_id = i.get('documento_id')
            if i.get('emi_id') not in item_somado:
                item_somado.append(i.get('emi_id'))
                list_produto_codigo = []
                vr_total = i.get('item_vr_total') or 0
                if documento_id[:2] == 'NF':
                    vr_total_nf += vr_total
                else:
                    vr_total_coo += vr_total

            if documento_id not in list_documento:
                if i != datas.get('dados')[0]:
                    listagem.imprimeLinha('*' + '-' * 148 + '*')

                natureza_name = i.get('natureza_nome') or ''
                tipo_movimento = dict(C=_('Compra/Venda'), D=_('Devolucao'), T=_('Transferencia'),
                                      E=_('Remessa'), R=_('Retorno'), U=_('Outras')).get(
                    i.get('cfop_movimento_tipo'))
                dt = i.get('documento_data') and time.strftime(
                    "%d/%m/%Y", time.strptime(i.get('documento_data'), "%Y-%m-%d"))
                linha = ['|',formataString(str(i.get('documento_numero') or '').zfill(5) + '-' +
                                            str(i.get('documento_comp') or ''), 23, ' ', 'D', 'S',
                                            'S'),
                         '|', formataString(i.get('pessoa_nome') or ' ', 41, ' ', 'D', 'S', 'S'),
                         '|', formataString(dt or ' ', 15, ' ', 'D', 'S', 'S'),
                         '|', formataString(tipo_movimento, 22, ' ', 'E', 'S', 'S'),
                         '|']
                tipo_documento = \
                    dict(E=_('Entrada'), S=_('Saida'), V=_('Venda')).get(i.get('documento_tipo'))
                linha.extend([formataString(tipo_documento or '', 9, ' ', 'D', 'S', 'S'),
                              '|',
                              formataString(natureza_name, 33, ' ', 'D', 'S', 'S'),
                              '|'])
                listagem.imprimeLinha(''.join(linha))
                count = 1
                list_documento.append(documento_id)
            if documento_id == list_documento[-1]:
                codigo_cfop = i.get('cfop_codigo') or ''
                if i.get('encargo_sigla'):
                    encargo = i.get('encargo_sigla') or ''
                else:
                    encargo = ''
                if i.get('cst_codigo'):
                    cst = i.get('cst_codigo') or ''
                else:
                    cst = ''
                produto_codigo = i.get('produto_codigo') or ''
                if count in (0, 1) and produto_codigo not in list_produto_codigo:
                    linha = ['|', formataString(produto_codigo, 12, ' ', 'E', 'S', 'S'),

                             '|', formataString(i.get('grade_descricao') or '', 13, ' ', 'D', 'S',
                                                'S'),
                             '|', formataString(i.get('produto_nome') or '', 28, ' ', 'D', 'S',
                                                'S'),
                             '|', formataString(getNumeroEditado(i.get('quantidade') or 0, 3),
                                          10, ' ', 'E', 'S', 'S'),
                             '|', formataString(codigo_cfop, 4, ' ', 'D', 'S', 'S'),
                             '|', formataString(getNumeroEditado(i.get('item_vr_total') or 0, 2),
                                                10, ' ', 'E', 'S', 'S'),
                             '|']
                else:
                    linha = ['|%s|' % ''.ljust(82)]

                linha.extend([formataString(encargo, 7, ' ', 'D', 'S', 'S'),
                              '|', formataString(cst, 3, ' ', 'D', 'S', 'S'),
                              '|', formataString(getNumeroEditado(i.get('vr_base_calculo') or 0, 2),
                                                 12, ' ', 'E', 'S', 'S'),
                              '|', formataString(getNumeroEditado(i.get('aliquota') or 0, 2), 8,
                                                 ' ', 'E', 'S', 'S'),
                              '|', formataString(getNumeroEditado(i.get('vr_encargo') or 0, 2), 10,
                                                 ' ', 'E', 'S', 'S'),
                              '|', formataString(getNumeroEditado(i.get('vr_base_icms_st') or 0, 2),
                                                 10, ' ', 'E', 'S', 'S'),
                              '|', formataString(getNumeroEditado(i.get('vr_icms_st') or 0, 2),
                                                 9, ' ', 'E', 'S', 'S'),
                              '|'])
                listagem.imprimeLinha(''.join(linha))
                list_produto_codigo.append(produto_codigo)
            else:
                list_produto_codigo = []
        listagem.imprimeLinha('*' + '-' * 148 + '*')

        linha = '|' + ' ' * 127 + '|'
        linha += formataString(getNumeroEditado(
            sum(map(lambda t: t.get('vr_base_icms_st') or 0, datas.get('dados')))), 10, ' ', 'E',
            'S', 'S')
        linha += '|'
        linha += formataString(getNumeroEditado(
            sum(map(lambda t: t.get('vr_icms_st') or 0, datas.get('dados')))), 9, ' ', 'E',
            'S', 'S')
        linha += '|'
        listagem.imprimeLinha(linha)


        listagem.imprimeLinha(
            _('|T O T A L   N O T A S ---->') + formataString(
                getNumeroEditado(vr_total_nf, 2), 45, ' ', 'E', 'S', 'S') + '|' + ' ' * 75 + '|')
        listagem.imprimeLinha(
            _('|T O T A L   C U P O N S -->') + formataString(
                getNumeroEditado(vr_total_coo, 2), 45, ' ', 'E', 'S', 'S') + '|' + ' ' * 75 + '|')
        listagem.imprimeLinha('+' + '-' * 148 + '+')
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()

        return (self.obj.pdf, 'pdf')

report_custom('report.listagem_item_tributacao')

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
