# -*- encoding: utf-8 -*-

from datetime import date
from openerp.report.interface import report_int
from openerp.report.render import render
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
import StringIO
from openerp import pooler
import time
from datetime import datetime
from SigUtils.formatastring import formataString
from openerp.osv import osv, fields
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        title = center_title('', _('VENDAS POR FORMA DE PAGAMENTO'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Vendas forma pgto'))
        listagem.informaTamLinha(160)

        data_inicial = datas.get('data_inicial')
        data_final = datas.get('data_final')
        tipo = datas.get('tipo')
        forma_pagamento_id = datas.get('forma_pagamento_id')
        forma_pagamento_name = datas.get('forma_pagamento_name')
        detalhe_forma_pagamento = datas.get('detalhe_forma_pagamento')
        forma_tipo = dict(pooler.get_pool(cr.dbname).get(
            'adm.forma.pgto')._columns.get('admfpg_tipo').selection)

        def get_forma_tipo_descricao(tipo):
            if not detalhe_forma_pagamento:
                return tipo
            return forma_tipo.get(tipo)

        ecf_instalado = pooler.get_pool(cr.dbname).get('adm.utils').admutl_check_modulo_instalado(
            cr, uid, 'ecf', context)

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'wizard.listagem.vendas.por.periodo', context=context)
        nome_empresa = pooler.get_pool(cr.dbname).get('res.company').browse(
            cr, uid, company_id).name
        data = time.strftime("%d/%m/%Y")
        docs = center_title('%s' % data, '%s' % nome_empresa, 'Pagina: {{ Page }} ')
        data_ini = time.strftime('%d/%m/%Y', time.strptime(data_inicial, '%Y-%m-%d'))
        data_fim = time.strftime('%d/%m/%Y', time.strptime(data_final, '%Y-%m-%d'))
        tipo_impressao = 'Analitico' if tipo == 'A' else 'Sintetico'
        docs1 = center_title('Periodo: %s a %s' % (data_ini, data_fim), 'Tipo: %s' % tipo_impressao,
                             '')
        docs2 = center_title('Forma de pagamento: %s' % forma_pagamento_name, '', '')

        listagem.informaCab(title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab(docs)
        listagem.informaCab('')
        listagem.informaCab(docs1)
        if tipo == 'A':
            listagem.informaCab(docs2)
        listagem.informaCab('  ')

        if tipo == 'A':
            listagem.informaCab(
                _('|---------------------------------------------------------------------------------------------------------------------------------------------------|'))
            listagem.informaCab(
                _('|   FORMA DE PAGAMENTO                                                                                                                              |'))
            listagem.informaCab(
                _('|---------------------------------------------------------------------------------------------------------------------------------------------------|'))
            listagem.informaCab(
                _('|          DOCUMENTO          |                            CLIENTE                           |          DATA          |            VALOR            |'))
            listagem.informaCab(
                _('|---------------------------------------------------------------------------------------------------------------------------------------------------|'))
            listagem.informaCab('')
            listagem.rodapePadrao()
            valor_total = 0.0
            list_forma_pagamento = []
            valor_condicao = 0.0

            sql = """
                    SELECT
                        fnc.numero_nf AS documento,
                        (SELECT nome FROM adm_pessoa WHERE id = fnc.destinatario_id) AS pessoa,
                        fnc.data_emissao AS data,
                        {forma_tipo} AS forma_pagamento,
                        Sum(fcp.valor) AS valor
                    FROM fiscal_nf_capa fnc
                    INNER JOIN fiscal_cfop_natureza fcn ON fcn.id = fnc.natureza_id
                    INNER JOIN fiscal_cfop fc ON fc.id = fcn.cfop_id
                    INNER JOIN fiscal_condicao_pagamento fcp ON fnc.id = fcp.capa_id
                    INNER JOIN adm_forma_pgto afp ON fcp.forma_pagto_id = afp.id
                    WHERE
                        fnc.company_id = {company_id}
                        AND fnc.data_emissao at time zone 'UTC' >= '{data_inicial} 00:00:00' 
                        AND fnc.data_emissao at time zone 'UTC' <= '{data_final} 23:59:59'
                        AND fnc.tipo = 'S'
                        AND fnc.state = '3'
                        AND fc.movimento_tipo = 'C'
            """.format(company_id=company_id, data_inicial=data_inicial, data_final=data_final,
                       forma_tipo='afp.admfpg_tipo' if detalhe_forma_pagamento else 'afp.name')
            if forma_pagamento_id:
                sql += """
                        AND afp.id = %s
                """ % forma_pagamento_id
            sql += """
                    GROUP BY fnc.numero_nf, fnc.destinatario_id, fnc.data_emissao, {forma_tipo}
            """.format(forma_tipo='afp.admfpg_tipo' if detalhe_forma_pagamento else 'afp.name')
            if ecf_instalado:
                sql += """
                    UNION
                    SELECT
                        ecc.coo documento,
                        (SELECT nome FROM adm_pessoa WHERE id = ecc.cliente_id) AS pessoa,
                        ecc.date_cupom AS data,
                        {forma_tipo} AS forma_pagamento,
                        (CASE
                            WHEN ecf.troco > 0 THEN Sum(ecf.valor - ecf.troco)
                            ELSE Sum(ecf.valor)
                         END) AS valor
                    FROM ecf_cupons_capa ecc
                    INNER JOIN ecf_cupons_finalizacao ecf ON ecc.id = ecf.cupom_id
                    INNER JOIN adm_condicao_forma acf ON ecf.finalizadora_id = acf.id
                    INNER JOIN adm_forma_pgto afp ON acf.forma_pagamento_id = afp.id
                    WHERE
                        ecc.company_id = {company_id}
                        AND ecc.date_cupom >= '{data_inicial}'
                        AND ecc.date_cupom <= '{data_final}'
                        AND tipo_cupom = 'V'
                        AND state = 'V'
                """.format(company_id=company_id, data_inicial=data_inicial, data_final=data_final,
                           forma_tipo='afp.admfpg_tipo' if detalhe_forma_pagamento else 'afp.name')
                if forma_pagamento_id:
                    sql += """
                        AND afp.id = %s
                    """ % forma_pagamento_id
                sql += """
                    GROUP BY ecc.coo, pessoa, ecc.date_cupom, {forma_tipo}, ecf.troco
                    UNION
                    SELECT
                        ecc.coo documento,
                        (SELECT nome FROM adm_pessoa WHERE id = ecc.cliente_id) AS pessoa,
                        ecc.date_cupom AS data,
                        {forma_tipo} AS forma_pagamento,
                        (CASE
                            WHEN ecf.troco > 0 THEN -ecf.valor + ecf.troco
                            ELSE -ecf.valor
                         END) AS valor
                    FROM ecf_cupons_capa ecc
                    INNER JOIN ecf_cupons_finalizacao ecf ON ecc.id = ecf.cupom_id
                    INNER JOIN adm_condicao_forma acf ON ecf.finalizadora_id = acf.id
                    INNER JOIN adm_forma_pgto afp ON acf.forma_pagamento_id = afp.id
                    WHERE
                        ecc.company_id = {company_id}
                        AND ecc.date_cupom >= '{data_inicial}'
                        AND ecc.date_cupom <= '{data_final}'
                        AND tipo_cupom = 'C'
                        AND state = 'V'
                """.format(company_id=company_id, data_inicial=data_inicial, data_final=data_final,
                           forma_tipo='afp.admfpg_tipo' if detalhe_forma_pagamento else 'afp.name')
                if forma_pagamento_id:
                    sql += """
                        AND afp.id = %s
                    """ % forma_pagamento_id
            sql += """
                    ORDER BY forma_pagamento, data
            """
            cr.execute(sql)
            dados = cr.dictfetchall()

            for x in dados:
                forma_pagamento = get_forma_tipo_descricao(x.get('forma_pagamento') or '')
                if forma_pagamento not in list_forma_pagamento:
                    if dados.index(x) != 0:
                        linha = _('|')
                        linha += formataString('', 118, ' ', 'E', 'S', 'S')
                        linha += formataString('SUBTOTAL', 8, ' ', 'D', 'S', 'S')
                        linha += formataString(getNumeroEditado(valor_condicao or 0.0, 2), 21, ' ',
                                               'E', 'S', 'S')
                        linha += _('|')
                        listagem.imprimeLinha(linha)
                        listagem.imprimeLinha('|---------------------------------------------------------------------------------------------------------------------------------------------------|')

                    valor_condicao = 0.0
                    list_forma_pagamento.append(forma_pagamento)
                    linha = _('|')
                    linha += formataString(forma_pagamento, 147, ' ', 'D', 'S', 'S')
                    linha += _('|')
                    listagem.imprimeLinha(linha)
                linha = _('|')
                linha += formataString(x.get('documento') or '', 29, ' ', 'D', 'S', 'S')
                linha += _('|')
                linha += formataString(x.get('pessoa') or '', 62, ' ', 'D', 'S', 'S')
                linha += _('|')
                data = x['data'][:10]
                data = datetime.strptime(data, '%Y-%m-%d').strftime('%d/%m/%Y')
                linha += formataString(data or '', 24, ' ', 'D', 'S', 'S')
                linha += _('|')
                valor = x.get('valor') or 0.0
                linha += formataString(getNumeroEditado(valor, 2), 29, ' ', 'E', 'S', 'S')
                linha += _('|')
                listagem.imprimeLinha(linha)
                valor_condicao += valor
                valor_total += valor
                if x == dados[-1]:
                    linha = _('|')
                    linha += formataString('', 118, ' ', 'E', 'S', 'S')
                    linha += formataString('SUBTOTAL', 8, ' ', 'D', 'S', 'S')
                    linha += formataString(getNumeroEditado(valor_condicao or 0.0, 2), 21, ' ',
                                           'E', 'S', 'S')
                    linha += _('|')
                    listagem.imprimeLinha(linha)
                    listagem.imprimeLinha('|---------------------------------------------------------------------------------------------------------------------------------------------------|')

            linha = _('|')
            linha += formataString('', 118, ' ', 'E', 'S', 'S')
            linha += formataString('TOTAL', 8, ' ', 'D', 'S', 'S')
            linha += formataString(getNumeroEditado(valor_total or 0.0, 2), 21, ' ', 'E', 'S', 'S')
            linha += _('|')
            listagem.imprimeLinha(
                _('|                                                                                                                                                   |'))
            listagem.imprimeLinha(linha)
            listagem.imprimeLinha(
                _('|---------------------------------------------------------------------------------------------------------------------------------------------------|'))
        else:
            listagem.informaCab(
                _('|---------------------------------------------------------------------------------------------------------------------------------------------------|'))
            listagem.informaCab(
                _('|            DATA            |                           FORMA DE PAGAMENTO                            |                   VALOR                    |'))
            listagem.informaCab(
                _('|---------------------------------------------------------------------------------------------------------------------------------------------------|'))
            listagem.informaCab('')
            listagem.rodapePadrao()

            valor_total = 0.0
            valor_condicao = 0.0
            sql = """
                SELECT
                    left(fnc.data_emissao::varchar, 10) AS data,
                    {forma_tipo} AS forma_pagamento,
                    sum(fcp.valor) AS valor
                FROM fiscal_nf_capa fnc
                INNER JOIN fiscal_cfop_natureza fcn ON fcn.id = fnc.natureza_id
                INNER JOIN fiscal_cfop fc ON fc.id = fcn.cfop_id
                INNER JOIN fiscal_condicao_pagamento fcp ON fnc.id = fcp.capa_id
                INNER JOIN adm_forma_pgto afp ON fcp.forma_pagto_id = afp.id
                WHERE
                    fnc.company_id = {company_id}
                    AND date(fnc.data_emissao) >= '{data_inicial}'
                    AND date(fnc.data_emissao) <= '{data_final} 23:59:59'
                    AND fnc.tipo = 'S'
                    AND fnc.state = '3'
                    AND fc.movimento_tipo = 'C'
                GROUP BY data, {forma_tipo}
            """.format(company_id=company_id, data_inicial=data_inicial, data_final=data_final,
                       forma_tipo='afp.admfpg_tipo' if detalhe_forma_pagamento else 'afp.name')
            if ecf_instalado:
                sql += """
                UNION
                SELECT data::varchar,
                       forma_pagamento,
                       Sum(valor)
                FROM   (SELECT ecc.date_cupom AS data,
                               {forma_tipo}       AS forma_pagamento,
                               Sum(( CASE
                                       WHEN ecf.troco > 0 THEN ecf.valor - ecf.troco
                                       ELSE ecf.valor
                                     END ))   AS valor
                        FROM   ecf_cupons_capa ecc
                               INNER JOIN ecf_cupons_finalizacao ecf
                                       ON ecc.id = ecf.cupom_id
                               INNER JOIN adm_condicao_forma acf
                                       ON ecf.finalizadora_id = acf.id
                               INNER JOIN adm_forma_pgto afp
                                       ON acf.forma_pagamento_id = afp.id
                        WHERE  ecc.company_id = {company_id}
                               AND ecc.date_cupom >= '{data_inicial}'
                               AND ecc.date_cupom <= '{data_final}'
                               AND tipo_cupom = 'V'
                               AND state = 'V'
                        GROUP  BY ecc.date_cupom,
                                  forma_pagamento
                        UNION ALL
                        SELECT ecc.date_cupom AS data,
                               {forma_tipo}       AS forma_pagamento,
                               -Sum(( CASE
                                        WHEN ecf.troco > 0 THEN ecf.valor - ecf.troco
                                        ELSE ecf.valor
                                      END ))  AS valor
                        FROM   ecf_cupons_capa ecc
                               INNER JOIN ecf_cupons_finalizacao ecf
                                       ON ecc.id = ecf.cupom_id
                               INNER JOIN adm_condicao_forma acf
                                       ON ecf.finalizadora_id = acf.id
                               INNER JOIN adm_forma_pgto afp
                                       ON acf.forma_pagamento_id = afp.id
                        WHERE  ecc.company_id = {company_id}
                               AND ecc.date_cupom >= '{data_inicial}'
                               AND ecc.date_cupom <= '{data_final}'
                               AND tipo_cupom = 'C'
                               AND state = 'V'
                        GROUP  BY ecc.date_cupom,
                                  forma_pagamento) AS tmp
                GROUP  BY data,
                          forma_pagamento
                """.format(company_id=company_id, data_inicial=data_inicial, data_final=data_final,
                           forma_tipo='afp.admfpg_tipo' if detalhe_forma_pagamento else 'afp.name')
            sql += """
                ORDER BY forma_pagamento, data
                """
            cr.execute(sql)
            dados = cr.dictfetchall()
            list_forma_pagamento = []
            for dado in dados:
                str_forma_data = get_forma_tipo_descricao(dado.get('forma_pagamento')) + '!' + \
                                 dado.get('data')
                if str_forma_data in list_forma_pagamento:
                    continue
                list_forma_pagamento.append(str_forma_data)
            dados1 = []
            for i in list_forma_pagamento:
                forma_pagamento_dados = (filter(lambda x: get_forma_tipo_descricao(
                    x.get('forma_pagamento')) + '!' + x.get('data') == i, dados))
                dados1.append({'forma_pagamento': i.split('!')[0], 'data': i.split('!')[1],
                               'valor': sum(map(lambda x: x.get('valor'), forma_pagamento_dados))})

            list_forma_pagamento = []
            for i in dados1:
                forma_pagamento = i.get('forma_pagamento') or ''
                if forma_pagamento not in list_forma_pagamento:
                    if dados1.index(i) != 0:
                        linha = _('|')
                        linha += formataString('', 103, ' ', 'E', 'S', 'S')
                        linha += formataString('SUBTOTAL', 23, ' ', 'D', 'S', 'S')
                        linha += formataString(getNumeroEditado(valor_condicao or 0.0, 2), 21, ' ',
                                               'E', 'S', 'S')
                        linha += _('|')
                        listagem.imprimeLinha(linha)
                        listagem.imprimeLinha('|---------------------------------------------------------------------------------------------------------------------------------------------------|')
                    valor_condicao = 0.0
                    list_forma_pagamento.append(forma_pagamento)
                linha = _('|')
                data = i['data'][:10]
                data = datetime.strptime(data, '%Y-%m-%d').strftime('%d/%m/%Y')
                linha += formataString(data or '', 28, ' ', 'D', 'S', 'S')
                linha += _('|')
                linha += formataString(i.get('forma_pagamento') or '', 73, ' ', 'D', 'S', 'S')
                linha += _('|')
                linha += formataString(getNumeroEditado(i.get('valor') or 0.0, 2), 44, ' ', 'E', 'S', 'S')
                linha += _('|')
                listagem.imprimeLinha(linha)
                valor_condicao += i.get('valor') or 0.0
                valor_total += i.get('valor') or 0.0
                if i == dados1[-1]:
                    linha = _('|')
                    linha += formataString('', 103, ' ', 'E', 'S', 'S')
                    linha += formataString('SUBTOTAL', 23, ' ', 'D', 'S', 'S')
                    linha += formataString(getNumeroEditado(valor_condicao or 0.0, 2), 21, ' ',
                                           'E', 'S', 'S')
                    linha += _('|')
                    listagem.imprimeLinha(linha)
                    listagem.imprimeLinha('|---------------------------------------------------------------------------------------------------------------------------------------------------|')

            linha = _('|')
            linha += formataString('', 103, ' ', 'E', 'S', 'S')
            linha += formataString('TOTAL', 23, ' ', 'D', 'S', 'S')
            linha += formataString(getNumeroEditado(valor_total or 0.0, 2), 21, ' ', 'E', 'S', 'S')
            linha += _('|')
            listagem.imprimeLinha('|                                                                                                                                                   |')
            listagem.imprimeLinha(linha)
            listagem.imprimeLinha('|---------------------------------------------------------------------------------------------------------------------------------------------------|')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_vendas_por_periodo')
