# -*- encoding: utf-8 -*-
import time
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
import StringIO
from datetime import date
from openerp import pooler
from openerp.report.interface import report_int
from openerp.report.render import render
from openerp.tools.translate import _
from datetime import datetime
import math
import pytz
class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf

def float_time_convert(float_val):
    factor = float_val < 0 and -1 or 1
    val = abs(float_val)
    return (factor * int(math.floor(val)), int(round((val % 1) * 60)))

def subtrair_data_hora(data_final,data_inicial):
    hora_minutos = ' '
    if data_final and data_inicial:
        diff = datetime.strptime(data_final, "%Y-%m-%d %H:%M:%S") - \
               datetime.strptime(data_inicial, "%Y-%m-%d %H:%M:%S")
        total_diff = round(diff.days * 24 + \
                           (float(diff.seconds) / 3600),2)
        horas,minutos = float_time_convert(total_diff)
        hora_minutos = '%.2d' % horas + ':'+ '%.2d' % minutos
    return hora_minutos

class report_custom(report_int):

    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        pdf_string = StringIO.StringIO()

        listagem = Impressora()
        listagem.defineFormato(orientacao='1')
        listagem.informaNome(pdf_string, _('Listagem de Notas de Transferencia'))
        listagem.defineMargem(1, 1, 1, 1)
        listagem.informaTamLinha(115)
        data_ini = time.strftime("%d/%m/%Y", time.strptime(datas.get('data_inicial'), "%Y-%m-%d"))
        data_fim = time.strftime("%d/%m/%Y", time.strptime(datas.get('data_final'), "%Y-%m-%d"))
        listagem.informaCab(
            _('Listagem                                              Notas de Transferencia                                Periodo: ') + data_ini + _(' a ') + data_fim + _('   Pagina: {{ Page }} '))
        listagem.informaCab(_('Data: ') + time.strftime("%d/%m/%Y"))
        listagem.informaCab('--')
        listagem.informaCab(
            _('Emitente                                Numero         Serie     Data/Hora Emissao       Data/Hora Recebimento    Diferenca Tempo   Usuario Recebimento      Total NF      Status  '))
        listagem.informaCab('--')
        listagem.informaCab('')
        listagem.informaRodape('--')
        listagem.informaRodape(
            '                                                                                                              Sig Informatica Ltda')
        # listando o periodo para a pesquisa
        obj_fiscal_nf_capa = pooler.get_pool(cr.dbname).get('fiscal.nf.capa')
        browse_dados_nf = obj_fiscal_nf_capa.browse(cr,uid,datas['nf_capa_ids'])
        for lista in browse_dados_nf:
            #Emitente
            linha = formataString(lista.destinatario_id.name if lista.destinatario_id else '', 40 , ' ', 'D', 'N', 'S')
            # Numero NF
            linha += formataString(lista.numero_nf, 15, ' ', 'D', 'S', 'S')
            # serie NF
            linha += formataString(lista.serie_nf, 10, ' ', 'D', 'S', 'S')
            #data emissão
            data_emissao = time.strftime("%d/%m/%Y", time.strptime(lista.data_emissao,
                                                                   "%Y-%m-%d %H:%M:%S"))
            linha += formataString(data_emissao, 10, ' ', 'D', 'N', 'S')
            hora_emissao =' 00:00:00' if not lista.data_emissao else lista.data_emissao[12:]
            if isinstance(hora_emissao, float):
                horas,minutos = float_time_convert(hora_emissao)
                hora_emissao = ' ' + '%.2d' % horas + ':'+ '%.2d' % minutos +':00'
            #hora emissao
            linha += formataString(hora_emissao, 15, ' ', 'D', 'N', 'S')
            data_em = lista.data_emissao

            data_hora_emissao = data_em + hora_emissao
            rec_data_hora = lista.fisnfc_recebimento_data_hora

            recebimento_data_hora = ' '
            diferenca = ' '
            if lista.fisnfc_recebimento_data_hora:
                dt = datetime.strptime(rec_data_hora, "%Y-%m-%d %H:%M:%S")
                dt = dt.replace(tzinfo=pytz.utc)
                data_hora_tz = datetime.astimezone(dt, pytz.timezone("Brazil/East"))
                data_hora_tz = data_hora_tz.strftime("%Y-%m-%d %H:%M:%S")
                diferenca = subtrair_data_hora(data_hora_tz,data_hora_emissao)
                recebimento_data_hora = time.strftime("%d/%m/%Y %H:%M:%S", time.strptime(data_hora_tz,
                                                                                         "%Y-%m-%d %H:%M:%S"))

            #data hora recebimento
            linha += formataString(recebimento_data_hora, 25, ' ', 'D', 'N', 'S')
            #diferenca de tempo de recebimento
            linha += formataString(diferenca, 17, ' ', 'D', 'S', 'S')
            #usuario recebimento
            nome_usuario = ' ' if not lista.fisnfc_recebimento_usuario_id else\
                lista.fisnfc_recebimento_usuario_id.pessoa_id.name
            linha += formataString(nome_usuario, 17, ' ', 'D', 'S', 'S')
            linha += formataString(getNumeroEditado(lista.vr_total_nf, 2), 17, ' ', 'E', 'S', 'S') + '     '
            linha += formataString(dict(obj_fiscal_nf_capa._columns.get('state').selection).get(lista.state),
                                   12, ' ', 'D', 'S', 'S')
            listagem.imprimeLinha(linha)
            listagem.imprimeLinha('')
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_transferencia')







