#!/usr/bin/python
# -*- encoding: utf-8 -*-

import time
from openerp import pooler
import StringIO
from openerp.osv import osv
from openerp.report.render import render
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from SigUtils.impressao import Impressora
from SigUtils.formatastring import formataString
from openerp.tools.translate import _

READ_LOAD = '_classic_write'


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):

    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        db_name = pooler.get_pool(cr.dbname)

        title = center_title('', _('Listagem produtos p/ tributacao'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Listagem produtos p/ tributacao'))
        listagem.informaTamLinha(160)

        args_pg_view = datas.get('args_to_pgview_produto_por_tributacao') or []
        company_id = datas.get('company_id')

        obj_produto_por_tributacao_pgview = db_name.get('estoque.produto.por.tributacao.pgview')
        pgview_ids = obj_produto_por_tributacao_pgview.search(cr, uid, args_pg_view, context=context)
        if pgview_ids:
            nome_empresa = db_name.get('res.company').browse(cr, uid, company_id).name
            pgview_fields_to_read = [
                'pgv_estppt_produto_codigo', 'pgv_estppt_produto_name', 'pgv_estppt_ncm_codigo',
                'pgv_estppt_tributacao_name', 'pgv_estppt_encargo_name', 'pgv_estppt_cst_cod_name',
                'pgv_estppt_produto_id'
            ]
            pgview_dados = obj_produto_por_tributacao_pgview.read(
                cr, uid, pgview_ids, pgview_fields_to_read, context=context, load=READ_LOAD
            )

            data = time.strftime("%d/%m/%Y")
            docs = center_title(data, nome_empresa, 'Pagina: {{ Page }} ')

            listagem.informaCab(''+title)
            listagem.informaCab('')
            listagem.informaCab('')
            listagem.informaCab(''+docs)
            listagem.informaCab('  ')
            listagem.informaCab(_('*------------------------------------------------------------------------------------------------------------------------------------------------------------*'))
            listagem.informaCab(_('|   Codigo   |     Descricao     |     Tributacao     |                          Cst                          |  Encargo |        Ncm         |Preco de Venda|'))
            listagem.informaCab(_('*------------------------------------------------------------------------------------------------------------------------------------------------------------*'))
            listagem.informaCab('  ')
            listagem.rodapePadrao()

            produto_ids = filter(
                None, map(lambda p: p.get('pgv_estppt_produto_id'), pgview_dados)
            )
            produto_ids = list(set(produto_ids))

            dict_preco_venda = db_name.get('estoque.preco.venda').get_preco_venda(cr, uid, produto_ids)

            for i in pgview_dados:

                produto_id = i.get('pgv_estppt_produto_id')
                produto_codigo = i.get('pgv_estppt_produto_codigo') or ''
                produto_name = i.get('pgv_estppt_produto_name') or ''
                ncm_codigo = i.get('pgv_estppt_ncm_codigo') or ''
                tributacao_name = i.get('pgv_estppt_tributacao_name') or ''
                encargo_name = i.get('pgv_estppt_encargo_name') or ''
                cst_cod_name = i.get('pgv_estppt_cst_cod_name') or ''
                dados_preco_venda = dict_preco_venda.get(produto_id) or {}
                preco_venda = dados_preco_venda.get('preco_venda')

                linha = '|'
                linha += formataString(produto_codigo, 12, ' ', 'D', 'N', 'S') + '|'
                linha += formataString(produto_name, 19, ' ', 'D', 'N', 'S') + '|'
                linha += formataString(tributacao_name, 20, ' ', 'D', 'N', 'S') + '|'
                linha += formataString(cst_cod_name, 55, ' ', 'D', 'N', 'S') + '|'
                linha += formataString(encargo_name, 10, ' ', 'D', 'N', 'S') + '|'
                linha += formataString(ncm_codigo, 20, ' ', 'D', 'N', 'S') + '|'
                linha += formataString(getNumeroEditado(preco_venda, 2), 14, ' ', 'E', 'N', 'S') + '|'
                listagem.imprimeLinha(linha)

            listagem.imprimeLinha('')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return self.obj.pdf, 'pdf'

report_custom('report.relatorio_estoque_por_tributacoes')

