# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2015 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv
from openerp.tools.translate import _
from openerp.report import report_sxw
from datetime import datetime
from pytz import timezone


# noinspection PyPep8Naming
class report_fiscal_nf_capa_rps(report_sxw.rml_parse):
    """
    Impressao do Recibo Provisorio de Servicos - RPS
    addons/fiscal/report/rps.rml

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    def __init__(self, cr, uid, name, context):
        super(report_fiscal_nf_capa_rps, self).__init__(cr, uid, name, context=context)

        tz = context.get('tz') or 'Brazil/East'
        agora = datetime.now(timezone('UTC')).astimezone(timezone(tz))
        dados = {'agora': agora}
        self.localcontext.update(dados)
        self.context = context

report_sxw.report_sxw('report.fiscal.nf.capa.rps', 'fiscal.nf.capa', 'addons/fiscal/report/rps.rml',
                      header=False, parser=report_fiscal_nf_capa_rps)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
