# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _
from dateutil.parser import parse


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(e, c, d, t=140):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        size_numero_nf = 15
        size_tipo_nf = 7
        size_cupom = 7
        size_loja_caixa = 10
        size_caixas = 30
        size_produto = 30
        size_valor_nf = 20
        size_data = 10

        context = context and context.copy() or {}
        title = center_title('', _('Inconsistencias SPED'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('inconsistencia_sped'))
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)
        listagem.defineFonte(tam=7)
        # listagem.informaTamLinha(160)

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'wizard.verifica.sped', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
        docs1 = 'Periodo: %s a %s' % (datas.get('data_inicial'), datas.get('data_final'))

        listagem.informaCab(title)
        listagem.informaCab('')
        listagem.informaCab(docs)
        listagem.informaCab(docs1)
        listagem.informaCab('')
        listagem.rodapePadrao()

        if datas.get('cst_pis_diferente_cst_cofins'):
            listagem.imprimeLinha('MOVIMENTO COM CST DE PIS DIFERENTE DO COFINS')
            listagem.imprimeLinha('')
            linha = formataString('NUMERO NF', size_numero_nf, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString('TIPO NF', size_tipo_nf, ' ', 'D', 'N', 'S')
            linha += '|'
            if 'cupom_importado_sem_cst' in datas:
                linha += formataString('CUPOM', size_cupom, ' ', 'E', 'N', 'S')
                linha += '|'
                linha += formataString('LOJA-CAIXA', size_loja_caixa, ' ', 'D', 'N', 'S')
                linha += '|'
            linha += formataString('PRODUTO', size_produto, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString('GRADE', size_produto, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
            listagem.imprimeLinha('--')
        for x in datas.get('cst_pis_diferente_cst_cofins'):
            linha = formataString(x.get('numero_nf') or '', size_numero_nf, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('tipo_nf') or '', size_tipo_nf, ' ', 'D', 'N', 'S')
            linha += '|'
            if 'cupom_importado_sem_cst' in datas:
                linha += formataString(x.get('numero_cupom') or '', size_cupom, ' ', 'E', 'N', 'S')
                linha += '|'
                linha += formataString(x.get('loja_caixa') or '', size_loja_caixa, ' ', 'D', 'N',
                                       'S')
                linha += '|'
            linha += formataString(x.get('produto'), size_produto, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('grade'), size_produto, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
        if datas.get('cst_pis_diferente_cst_cofins'):
            listagem.imprimeLinha(_('Acesse: Fiscal / Lancamentos / NFs. Localize a nota e corrija '
                                    'a tributacao e CST dos itens.'))
            for e in range(0, 4):
                listagem.imprimeLinha('')

        if datas.get('tributacao_diferente_cst'):
            listagem.imprimeLinha('TRIBUTACAO DIVERGENTE DO CST')
            listagem.imprimeLinha('')
            linha = formataString('NUMERO NF', size_numero_nf, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString('TIPO NF', size_tipo_nf, ' ', 'D', 'N', 'S')
            linha += '|'
            if 'cupom_importado_sem_cst' in datas:
                linha += formataString('CUPOM', size_cupom, ' ', 'E', 'N', 'S')
                linha += '|'
                linha += formataString('LOJA-CAIXA', size_loja_caixa, ' ', 'D', 'N', 'S')
                linha += '|'
            linha += formataString('PRODUTO', size_produto, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString('GRADE', size_produto, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
            listagem.imprimeLinha('--')
        for x in datas.get('tributacao_diferente_cst'):
            linha = formataString(x.get('numero_nf') or '', size_numero_nf, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('tipo_nf') or '', size_tipo_nf, ' ', 'D', 'N', 'S')
            linha += '|'
            if 'cupom_importado_sem_cst' in datas:
                linha += formataString(x.get('numero_cupom') or '', size_cupom, ' ', 'E', 'N', 'S')
                linha += '|'
                linha += formataString(x.get('loja_caixa') or '', size_loja_caixa, ' ', 'D', 'N',
                                       'S')
                linha += '|'
            linha += formataString(x.get('produto'), size_produto, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('grade'), size_produto, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
        if datas.get('tributacao_diferente_cst'):
            for e in range(0, 4):
                listagem.imprimeLinha('')

        if datas.get('cst_entrada_movimento_saida'):
            listagem.imprimeLinha('CST DE ENTRADA PARA MOVIMENTO DE SAIDA')
            listagem.imprimeLinha('')
            linha = formataString('NUMERO NF', size_numero_nf, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString('TIPO NF', size_tipo_nf, ' ', 'D', 'N', 'S')
            linha += '|'
            if 'cupom_importado_sem_cst' in datas:
                linha += formataString('CUPOM', size_cupom, ' ', 'E', 'N', 'S')
                linha += '|'
                linha += formataString('LOJA-CAIXA', size_loja_caixa, ' ', 'D', 'N', 'S')
                linha += '|'
            linha += formataString('PRODUTO', size_produto, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString('GRADE', size_produto, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
            listagem.imprimeLinha('--')
        for x in datas.get('cst_entrada_movimento_saida'):
            linha = formataString(x.get('numero_nf') or '', size_numero_nf, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('tipo_nf') or '', size_tipo_nf, ' ', 'D', 'N', 'S')
            linha += '|'
            if 'cupom_importado_sem_cst' in datas:
                linha += formataString(x.get('numero_cupom') or '', size_cupom, ' ', 'E', 'N', 'S')
                linha += '|'
                linha += formataString(x.get('loja_caixa') or '', size_loja_caixa, ' ', 'D', 'N',
                                       'S')
                linha += '|'
            linha += formataString(x.get('produto'), size_produto, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('grade'), size_produto, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
        if datas.get('cst_entrada_movimento_saida'):
            listagem.imprimeLinha(_('Acesse: Fiscal / Lancamentos / NFs. Localize a nota e corrija '
                                    'a tributacao e CST dos itens.'))
            for e in range(0, 4):
                listagem.imprimeLinha('')

        if datas.get('cst_saida_movimento_entrada'):
            listagem.imprimeLinha('CST DE SAIDA PARA MOVIMENTO DE ENTRADA')
            listagem.imprimeLinha('')
            linha = formataString('NUMERO NF', size_numero_nf, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString('TIPO NF', size_tipo_nf, ' ', 'D', 'N', 'S')
            linha += '|'
            if 'cupom_importado_sem_cst' in datas:
                linha += formataString('CUPOM', size_cupom, ' ', 'E', 'N', 'S')
                linha += '|'
                linha += formataString('LOJA-CAIXA', size_loja_caixa, ' ', 'D', 'N', 'S')
                linha += '|'
            linha += formataString('PRODUTO', size_produto, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString('GRADE', size_produto, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
            listagem.imprimeLinha('--')
        for x in datas.get('cst_saida_movimento_entrada'):
            linha = formataString(x.get('numero_nf') or '', size_numero_nf, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('tipo_nf') or '', size_tipo_nf, ' ', 'D', 'N', 'S')
            linha += '|'
            if 'cupom_importado_sem_cst' in datas:
                linha += formataString(x.get('numero_cupom') or '', size_cupom, ' ', 'E', 'N', 'S')
                linha += '|'
                linha += formataString(x.get('loja_caixa') or '', size_loja_caixa, ' ', 'D', 'N',
                                       'S')
                linha += '|'
            linha += formataString(x.get('produto') or '', size_produto, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('grade') or '', size_produto, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
        if datas.get('cst_saida_movimento_entrada'):
            listagem.imprimeLinha(_('Acesse: Fiscal / Lancamentos / NFs. Localize a nota e corrija '
                                    'a tributacao e CST dos itens.'))
            for e in range(0, 4):
                listagem.imprimeLinha('')

        if datas.get('diferenca_base_calculo_total_nf'):
            listagem.imprimeLinha('DIFERENCA ENTRE A SOMA DAS BASES DE CALCULO E O TOTAL DA NF')
            listagem.imprimeLinha('')
            linha = formataString('NUMERO NF', size_numero_nf, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString('TIPO NF', size_tipo_nf, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString('VALOR NF', size_valor_nf, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString('VALOR BASE', size_valor_nf, ' ', 'E', 'N', 'S')
            listagem.imprimeLinha(linha)
            listagem.imprimeLinha('--')
        for x in datas.get('diferenca_base_calculo_total_nf'):
            linha = formataString(x.get('numero_nf'), size_numero_nf, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('tipo_nf'), size_tipo_nf, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(x.get('valor_nf')), size_valor_nf, ' ', 'E',
                                   'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(x.get('valor_tributacao')), size_valor_nf, ' ',
                                   'E', 'N', 'S')
            listagem.imprimeLinha(linha)
        if datas.get('diferenca_base_calculo_total_nf'):
            for e in range(0, 4):
                listagem.imprimeLinha('')

        if datas.get('cupom_importado_sem_cst'):
            listagem.imprimeLinha('CUPOM IMPORTADO SEM CST')
            listagem.imprimeLinha('')
            linha = formataString('CUPOM', size_cupom, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString('LOJA-CAIXA', size_loja_caixa, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString('PRODUTO', size_produto, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString('GRADE', size_produto, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
            listagem.imprimeLinha('--')
        for x in datas.get('cupom_importado_sem_cst'):
            linha = formataString(x.get('numero_cupom'), size_cupom, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('loja_caixa'), size_loja_caixa, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('produto'), size_produto, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('grade'), size_produto, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
        if datas.get('cupom_importado_sem_cst'):
            for e in range(0, 4):
                listagem.imprimeLinha('')

        if datas.get('diferenca_base_calculo_reducaoz_estoque'):
            listagem.imprimeLinha('DIFERENCA ENTRE A SOMA DAS BASES DE CALCULO DA REDUCAO Z E '
                                  'CUPONS MOVIMENTADOS')
            listagem.imprimeLinha('')
            linha = formataString('DATA', size_data, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString('LOJA-CAIXA', size_loja_caixa, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString('DIFERENCA', size_valor_nf, ' ', 'E', 'N', 'S')
            listagem.imprimeLinha(linha)
            listagem.imprimeLinha('--')
        for x in datas.get('diferenca_base_calculo_reducaoz_estoque'):
            linha = formataString(parse(x.get('data')).strftime('%d/%m/%Y'), size_data, ' ', 'D',
                                  'N', 'S')
            linha += '|'
            linha += formataString('%s-%s' % (x.get('loja'), x.get('caixa')), size_loja_caixa, ' ',
                                   'D', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(x.get('valor')), size_valor_nf, ' ', 'E', 'N',
                                   'S')
            listagem.imprimeLinha(linha)
        if datas.get('diferenca_base_calculo_reducaoz_estoque'):
            listagem.imprimeLinha('OBS.: Se o valor for positivo, a base de calculo da reducao Z e '
                                  'maior que o movimento.')
            listagem.imprimeLinha(
                _('Acesse: Fiscal / Lancamentos / Mapa de ECF. Confira os valores com a reducao Z. '
                  'Caso esteja correto, verifique o valor importado de'))
            listagem.imprimeLinha(
                _('cupons em: Vendas / Cupons / Resumo de importacao. Se houver cupons faltantes ou'
                  ' divergentes que estão impactando no total de vendas,'))
            listagem.imprimeLinha(_('comunique ao suporte tecnico.'))
            for e in range(0, 4):
                listagem.imprimeLinha('')

        if datas.get('reducao_z_faltante'):
            listagem.imprimeLinha('REDUCAO Z FALTANTE')
            listagem.imprimeLinha('')
            linha = formataString('DATA', size_data, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString('CAIXAS', size_caixas, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
            listagem.imprimeLinha('--')
        for x in datas.get('reducao_z_faltante'):
            linha = formataString(parse(x).strftime('%d/%m/%Y'), size_data, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(datas.get('reducao_z_faltante').get(x), size_caixas, ' ', 'D',
                                   'N', 'S')
            listagem.imprimeLinha(linha)
        if datas.get('reducao_z_faltante'):
            listagem.imprimeLinha('OBS.: Pode possuir reducao Z e nao possuir cupons lancados.')
            listagem.imprimeLinha(_('Acesse: Fiscal / Lancamentos / Mapa de ECF. Lance manualmente '
                                    'a reducao Z. Favor comunicar ao suporte tecnico.'))
        if datas.get('reducao_z_faltante'):
            for e in range(0, 4):
                listagem.imprimeLinha('')

        if datas.get('cst_nao_tributado_com_valor'):
            listagem.imprimeLinha('MOVIMENTO DE CST NAO TRIBUTADO GERA VALOR DE PIS/COFINS')
            listagem.imprimeLinha('')
            linha = formataString('NUMERO NF', size_numero_nf, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString('TIPO NF', size_tipo_nf, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString('PRODUTO', size_produto, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString('GRADE', size_produto, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
            listagem.imprimeLinha('--')
        for x in datas.get('cst_nao_tributado_com_valor'):
            linha = formataString(x.get('numero_nf') or '', size_numero_nf, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('tipo_nf') or '', size_tipo_nf, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('produto'), size_produto, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('grade'), size_produto, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
        if datas.get('cst_nao_tributado_com_valor'):
            for e in range(0, 4):
                listagem.imprimeLinha('')

        if datas.get('cfop_nao_tributado_com_valor'):
            listagem.imprimeLinha('CFOP NAO TRIBUTADO GERA VALOR DE PIS/COFINS')
            listagem.imprimeLinha('')
            linha = formataString('NUMERO NF', size_numero_nf, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString('TIPO NF', size_tipo_nf, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString('PRODUTO', size_produto, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString('GRADE', size_produto, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
            listagem.imprimeLinha('--')
        for x in datas.get('cfop_nao_tributado_com_valor'):
            linha = formataString(x.get('numero_nf') or '', size_numero_nf, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('tipo_nf') or '', size_tipo_nf, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('produto'), size_produto, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('grade'), size_produto, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
        if datas.get('cfop_nao_tributado_com_valor'):
            for e in range(0, 4):
                listagem.imprimeLinha('')

        if datas.get('cfop_bonificado_cst_diferente'):
            listagem.imprimeLinha('CFOP DE BONIFICACAO COM CST DIFERENTE DE 49 OU 98')
            listagem.imprimeLinha('')
            linha = formataString('NUMERO NF', size_numero_nf, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString('TIPO NF', size_tipo_nf, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString('PRODUTO', size_produto, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString('GRADE', size_produto, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
            listagem.imprimeLinha('--')
        for x in datas.get('cfop_bonificado_cst_diferente'):
            linha = formataString(x.get('numero_nf') or '', size_numero_nf, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('tipo_nf') or '', size_tipo_nf, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('produto'), size_produto, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('grade'), size_produto, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
        if datas.get('cfop_bonificado_cst_diferente'):
            for e in range(0, 4):
                listagem.imprimeLinha('')

        if datas.get('produto_com_grade_distinta'):
            listagem.imprimeLinha('PRODUTO MOVIMENTADO COM GRADE DE OUTRO')
            listagem.imprimeLinha('')
            linha = formataString('NUMERO NF', size_numero_nf, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString('TIPO NF', size_tipo_nf, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString('PRODUTO', size_produto, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString('SEQUENCIA', size_produto, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
            listagem.imprimeLinha('--')
        for x in datas.get('produto_com_grade_distinta'):
            linha = formataString(x.get('numero_nf') or '', size_numero_nf, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('tipo_nf') or '', size_tipo_nf, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('produto'), size_produto, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(x.get('sequencia'), size_produto, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
        if datas.get('produto_com_grade_distinta'):
            for e in range(0, 4):
                listagem.imprimeLinha('')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

report_custom('report.verifica_inconsistencia_sped')
