#!/usr/bin/python
# -*- encoding: utf-8 -*-
from datetime import datetime
import threading
import time
import logging
import socket
import json
from pynfe.nfce.manual_600.NFCe import NFCe as nfc_e
from pynfe.nfe.manual_600.nf_e400 import NFe as nf_e
from openerp.tools.translate import _


logging.basicConfig(filename='/tmp/sigerp_nfe.log',
                    encoding='utf-8',
                    level=logging.INFO,
                    format='%(asctime)s %(message)s')
qted_integra = 0
encerrar = False

_logger = logging.getLogger("SigERP_NFe")
_logger.info('==> Entrando no sigerp_nfe')

dict_status = {
    1: 'Inicializando',
    2: 'Processando',
    3: 'Processado',
    201: 'Nao consegui conversar com a SEFAZ, verifique se exite conexao com a internet!',
    202: 'Nao consegui conversar com a SEFAZ, tente mais tarde!',
    203: 'Certificado digital com validade vencida.'
}
def _tInic():
    _inicio = time.time()
    return _inicio


def _tFim(inicio, msg):
    _fim = time.time()
    _dif = '%f' % (_fim - inicio)
    _logger.info('%s -> Tempo: %s' % (msg, str(_dif)))
    return

tcp = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
HOST = ''              # Endereco IP do Servidor
PORT = 6600            # Porta que o Servidor esta
data_hora_instancia = datetime.now()

try:
    orig = (HOST, PORT)
    tcp.bind(orig)
except:
    print('Ja tem uma instancia em execucao!')
    exit()
tcp.listen(1)
seq = 0

dict_objetos = {}

def _controle(obj, con):
    res = {}
    for key in obj:
        if key == 'qtd_pendentes':
            res['qtd_pendentes'] = len(dict_objetos)
        if key == 'qtd_bases_pendentes':
            res['qtd_bases_pendentes'] = _controle_qtd_bases_pendentes()
        if key == 'qtd_funcoes_pendentes':
            res['qtd_funcoes_pendentes'] = _controle_qtd_funcoes_pendentes()
        if key == 'teste':
            res['teste'] = 'OK'
        if key == 'instanciado':
            res['instancado'] = data_hora_instancia.isoformat()
    ret = {'status': True, 'mensagem': '', 'resposta': res}
    con.send(json.dumps(ret))
    return

def _comunicar(controle):
    dict_objetos[vars()['TC_%s' % controle]]['comunicar_inicio'] = time.time()
    dict_objetos[vars()['TC_%s' % controle]]['status'] = 2

    objeto = dict_objetos[vars()['TC_%s' % controle]].get('objeto')
    funcao = dict_objetos[vars()['TC_%s' % controle]].get('funcao')
    certify = dict_objetos[vars()['TC_%s' % controle]].get('certify')
    key = dict_objetos[vars()['TC_%s' % controle]].get('key')
    environment = dict_objetos[vars()['TC_%s' % controle]].get('environment')
    state = dict_objetos[vars()['TC_%s' % controle]].get('state')
    contingency = dict_objetos[vars()['TC_%s' % controle]].get('contingency')
    # xml_nfe = dict_objetos[vars()['TC_%s' % controle]].get('xml')
    dict_objetos[vars()['TC_%s' % controle]]['comunicar_fim'] = time.time()
    try:
        if objeto == 'nfe':
            nfe = nf_e(certify=certify,
                      key=key,
                      environment=environment,
                      state=state,
                      contingency=contingency,
                          )
        else:
            nfe = nfc_e(certify=certify,
                       key=key,
                       environment=environment,
                       state=state,
                       contingency=contingency,
                       )
        if funcao == 'processar_lote':
            pass
        elif funcao == 'consultar_nota':
            pass
        elif funcao == 'consultar_nfce':
            pass
        elif funcao == 'consultar_recibo':
            pass
        elif funcao == 'cancelar_nfce':
            pass
        elif funcao == 'cancelar_nfce_substituicao':
            pass
        elif funcao == 'inutilizar_faixa_numeracao':
            ano = dict_objetos[vars()['TC_%s' % controle]].get('ano')
            cnpj = dict_objetos[vars()['TC_%s' % controle]].get('cnpj')
            serie = dict_objetos[vars()['TC_%s' % controle]].get('serie')
            ini = dict_objetos[vars()['TC_%s' % controle]].get('ini')
            fim = dict_objetos[vars()['TC_%s' % controle]].get('fim')
            justificativa = dict_objetos[vars()['TC_%s' % controle]].get('justificativa')
            arquivo = None
            if objeto == 'nfe':
                processo, arquivo = nfe.inutilizar_faixa_numeracao(ano, cnpj, serie, ini, fim, justificativa)
            else:
                processo = nfe.inutilizar_faixa_numeracao(ano, cnpj, serie, ini, fim, justificativa)
                
        nfe.process.nova_versao = True
        processo, arquivos = nfe.processar_notas([xml_nfe])
        dict_objetos[vars()['TC_%s' % controle]]['ret_processo'] = processo
        dict_objetos[vars()['TC_%s' % controle]]['ret_arquivos'] = arquivos
    except socket.gaierror:
        dict_objetos[vars()['TC_%s' % controle]]['status'] = 201
        return
    except IOError:
        dict_objetos[vars()['TC_%s' % controle]]['status'] = 202
        return
    except Exception as erro:
        try:
            if unicode(erro).find('certificate expired') >= 1:
                dict_objetos[vars()['TC_%s' % controle]]['status'] = 203
        except:
            if str(erro).find('certificate expired') >= 1:
                dict_objetos[vars()['TC_%s' % controle]]['status'] = 203

        raise osv.except_osv(_('Atencao!'),
                         self.pool.get('adm.utils').admutl_remover_acentuacao(
                             cr, user, unicode(erro)))
        return

    dict_objetos[vars()['TC_%s' % controle]]['status'] = 3
    return

while True:
    con, cliente = tcp.accept()
    """
    Obj Json no seguinte formato
    {
        'objeto': nfe ou nfce
        'funcao': funcao a ser executada *
        'controle': numero do controle ou None na primeira vez
        'certify': certificado
        'key': chave para o certificado
        'environment': ambiente 
        'state' estado da federacao,
        'contingency': contingencia,
        'lote': lote,
        'chave': chave da nfe,
    }
    Funções:
    - processar_lote
    - consultar_nota
    - consultar_nfce
    - consultar_recibo
    - cancelar_nfce
    - cancelar_nfce_substituicao
    - inutilizar_nfce
    - inutilizar_faixa_numeracao
    - 
    """
    obj = con.recv(4096)
    try:
        obj = json.loads(obj)
    except:
        ret = {'status': False, 'mensagem': 'Nao entendi o comando'}
        con.send(json.dumps(ret))
        con.close()
        continue
    if obj.get('controle'):
        if dict_objetos[vars()['TC_%s' % t]].get('status') < 200:
            ret = {'status': True,
                   'status_codigo': status_codigo,
                   'status_mensagem': dict_status.get(status_codigo)
                   }
            con.send(json.dumps(ret))
        else:
            ret = {'status': False,
                   'status_codigo': status_codigo,
                   'status_mensagem': dict_status.get(status_codigo)
                   }
            con.send(json.dumps(ret))
    else:
        t = time.time()
        _args = (t)
        vars()['TC_%s' % t] = threading.Thread(target=_comunicar, args=_args)
        vars()['TC_%s' % t].start()
        status_codigo = 1
        dict_objetos[vars()['TC_%s' % t]] = {'obj_inicio': t, 'status': 1, 'args': obj}
        ret = {'status': True,
               'status_codigo': status_codigo,
               'status_mensagem': dict_status.get(status_codigo)
               }
        con.send(json.dumps(ret))
    con.close()

