# -*- coding: utf-8 -*-

from openerp.tests.common import TransactionCase
from sigaddons.config_teste import set_config


class TestFiscalSugestaoPrecoItem(TransactionCase):
    """
    Classe responsavel por testes unitarios no metodos da classe fiscal_sugestao_preco_item
    """

    @classmethod
    def setUpClass(cls):
        set_config()

    def setUp(self):
        super(TestFiscalSugestaoPrecoItem, self).setUp()
        self.obj_fiscal_sugestao_preco = self.registry('fiscal.sugestao.preco')
        self.obj_fiscal_sugestao_preco_item = self.registry('fiscal.sugestao.preco.item')
        self.sugestao_preco_id = self.cria_sugestao_preco()

    def cria_sugestao_preco(self):
        local_id = False
        local_ids = self.registry('estoque.local').search(self.cr, self.uid, [], limit=1)
        if local_ids:
            local_id = local_ids[0]
        vals = {'fissup_opcoes': 'T', 'fissup_local_id': local_id, 'fissup_listar_saldo_zero': True,
                'fissup_codigo': 'I', 'fissup_custo': 'R'}
        return self.obj_fiscal_sugestao_preco.create(self.cr, self.uid, vals)

    def test_fisspi_get_total_sugestao(self):
        res = self.obj_fiscal_sugestao_preco_item._fisspi_get_total_sugestao(
            self.cr, self.uid, self.obj_fiscal_sugestao_preco.browse(self.cr, self.uid,
                                                                     self.sugestao_preco_id))
        self.assertEqual(type(res), list)
