#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.tests.common import TransactionCase
from sigaddons.config_teste import set_config
import json

# noinspection PyUnresolvedReferences
class TestSpedFiscal(TransactionCase):
    """
    Classe responsavel por testes unitario do sped fiscal
    :author: Thiago Abreu Rodrigues <thiago.rodrigues[at]siginformatica.com.br>
    """
    @classmethod
    def setUpClass(cls):
        set_config()

    def setUp(self):
        super(TestSpedFiscal, self).setUp()
        self.sped = self.registry('fiscal.sped')
        vals = dict(sped_data_inicial='2016-05-01', sped_data_final='2016-05-31',
                    company_id=1, tipo_arquivo='0', nome_arquivo='sped_test.txt',
                    file='sped_test.txt')
        self.ids = self.sped.create(self.cr, self.uid, vals, {})

    def test_gerar_sped(self):
        self.assertTrue(self.sped.gerar_sped(self.cr, self.uid, [self.ids], {}))

    def test_arquivo_gerado(self):
        self.sped.gerar_sped(self.cr, self.uid, [self.ids], {})
        binario = self.sped.read(self.cr, self.uid, self.ids, ['dados'], context={}).get('dados')
        arquivo = binario.decode('base64')
        self.assertTrue('|0000|' in arquivo)

    def test_get_versao_layout(self):
        self.assertEqual(self.sped.get_versao_layout(2016), '010')

    def test_get_cod_sit(self):
        self.assertEqual(self.sped.get_cod_sit('3'), '00')
        self.assertEqual(self.sped.get_cod_sit('C'), '02')
        self.assertEqual(self.sped.get_cod_sit('I'), '05')