#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.tests.common import TransactionCase
from sigaddons.config_teste import set_config
from random import randint
from datetime import date


# noinspection PyUnresolvedReferences
class TestWizardEstoqueGerarContagem(TransactionCase):
    """
    Classe de testes unitarios da heranca de estoque.inventario.contagem
    """

    @classmethod
    def setUpClass(cls):
        set_config()

    def setUp(self):
        super(TestWizardEstoqueGerarContagem, self).setUp()
        self.invcont = self.registry('estoque.gerar.contagem.osv')
        descricao = 'teste' + str(randint(1, 1000))
        vals_inventario = dict(name=descricao, descricao=descricao,
                               local=self.get_local_id('LOJA')[0],
                               mes=str(date.today().month).zfill(2), ano=str(date.today().year),
                               company_id=1)
        self.invcont_id = self.invcont.create(self.cr, self.uid, vals_inventario, context={})

    def test_gerar_contagem(self):
        self.assertTrue(
            self.invcont.gerar_inventario(self.cr, self.uid, [self.invcont_id], context={}))

    def get_local_id(self, nome_local):
        return self.registry('estoque.local').search(self.cr, self.uid, [('name', '=', nome_local)])