#!/usr/bin/python
# -*- coding: utf-8 -*-

__version__ = '1.0'
__author__ = 'thiago.rodrigues'
__email_author__ = 'thiago.rodrigues[at]siginformatica.com.br'

from openerp.tests.common import TransactionCase
from sigaddons.config_teste import set_config
from random import randint


class TestWizardInutilizarNfe(TransactionCase):
    @classmethod
    def setUpClass(cls):
        set_config()

    def setUp(self):
        super(TestWizardInutilizarNfe, self).setUp()
        self.inutiliza = self.registry('wizard.inutilizar.faixa.nfe')
        self.modelo_padrao = self.registry('adm.utils').admutl_get_parametros(
            self.cr, self.uid, 'fiscal', ['modelo_nf_series_id']).get('modelo_nf_series_id')
        self.brw_modelo = self.registry('fiscal.modelo.nf.series').browse(self.cr, self.uid,
                                                                          self.modelo_padrao)
        self.ambiente_homologacao = self.brw_modelo.ambiente == 2
        self.nf = randint(1, 999999)
        vals = dict(name='FALHA DE CONEXAO COM A SEFAZ', serie=700, faixa_inicial=self.nf,
                    faixa_final=self.nf)
        self.inutiliza_id = self.inutiliza.create(self.cr, self.uid, vals)

    def test_inutilizar(self):
        if self.ambiente_homologacao:
            res = self.inutiliza.inutilizar(self.cr, self.uid, [self.inutiliza_id])
            self.assertTrue(res)