# -*- coding: utf-8 -*-

from openerp.tests.common import TransactionCase
from sigaddons.config_teste import set_config


class TestWizardSubstituiNaturezaReceitaPisCofins(TransactionCase):
    """
    Classe responsavel por testes unitarios dos metodos da classe
    wizard_substitui_natureza_receita_pis_cofins
    :author: Tiago Henrique Prates dos Santos <tiago.santos[at]siginformatica.com.br>
    """

    @classmethod
    def setUpClass(cls):
        set_config()

    def setUp(self):
        super(TestWizardSubstituiNaturezaReceitaPisCofins, self).setUp()
        self.wizard_substitui_natureza = self.registry(
            'wizard.substitui.natureza.receita.pis.cofins')
        self.wizard_substitui_natureza_id = self.cria_wizard_substitui_natureza()

    def cria_wizard_substitui_natureza(self):
        sql = """
            SELECT
                emc.data        AS data,
                emi.produto_id  AS produto_id
            FROM
                estoque_movimento_capa emc
            INNER JOIN estoque_movimento_itens emi
                ON emc.id = emi.capa_id
            INNER JOIN fiscal_nf_item_tributacao fnit
                ON emi.id = fnit.movimento_itens_id
            INNER JOIN estoque_produto ep
                ON ep.id = emi.produto_id
            LIMIT 1
        """
        self.cr.execute(sql)
        dados = self.cr.dictfetchone()
        vals = {'wizspc_data_inicial': dados.get('data'), 'wizspc_data_final': dados.get('data'),
                'wizspc_produto_id': dados.get('produto_id')}
        return self.wizard_substitui_natureza.create(self.cr, self.uid, vals)

    def test_wizspc_button_substitui_natureza_receita_movimento(self):
        res = self.wizard_substitui_natureza.wizspc_button_substitui_natureza_receita_movimento(
            self.cr, self.uid, [self.wizard_substitui_natureza_id])
        self.assertEqual(type(res), dict)
