# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2010 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import fields, osv

class cliente_debitos_capa_wizard(osv.TransientModel):

    def _get_itens(self, cr, uid, vals, context = None):
        ids = []
        active_model = vals.get('active_model')
        if active_model:
            obj_fiscal_nf_capa = self.pool.get('fiscal.nf.capa')
            obj_do_modelo_ativo = self.pool.get(active_model)
            active_id = vals.get('active_id')
            if active_model == 'fiscal.nf.capa':
                pessoa_id = obj_do_modelo_ativo.browse(cr, uid, active_id).destinatario_id.id or False
            else:
                pessoa_id = obj_do_modelo_ativo.browse(cr, uid, active_id).pessoa_id.id or False
            if pessoa_id:
                ids = obj_fiscal_nf_capa.search(cr, uid, [('destinatario_id','=',pessoa_id),
                                                          ('tipo','=','S'),
                                                          ('state','not in',('C','3'))], context=context)
                if ids:
                    browse_nf_capa = self.pool.get('fiscal.nf.capa').browse(cr, uid, ids)
                    ids = []
                    for x in browse_nf_capa:
                        if (x.state == '1' and x.fisnfc_pedido_ids) or x.state != '1':
                            for i in x.nf_condicao_ids:
                                if i.condicao_forma_id.adm_condicao_id.tipo == 'C':
                                    ids.append(x.id)
                                    break

        return ids

    _name = "cliente.debitos.capa.wizard"
    _inherit = "cliente.debitos.capa.wizard"
    _columns = {
        'nf_ids': fields.one2many('fiscal.nf.capa', 'destinatario_id', 'NFs')
    }

    _defaults = {
        'nf_ids': _get_itens
    }
