# -*- coding: utf-8 -*-

# To change this template, choose Tools | Templates
# and open the template in the editor.


from openerp.osv import fields
from openerp.osv import osv


class fiscal_export_nfe_osv(osv.TransientModel):
    def _get_chave_nfe(self, cr, uid, context=None):
        context = context and context.copy() or {}
        id = context.get('active_id')
        dados_nf_capa = self.pool.get('fiscal.nf.capa').read(cr, uid, id, ['nfe_chave_acesso', 'numero_nf', 'serie_nf',
                                                                           'modelo_nf_series_id'], context=context)
        extensao = '-procEventoNFe.xml' if context.get('tipo') == 'Cancelamento' else '-procNFe.xml'
        if isinstance(dados_nf_capa, list):
            dados_nf_capa = dados_nf_capa[0]
        if not context.get('gerar_danfe'):
            chave = dados_nf_capa.get('nfe_chave_acesso')
            if chave:
                chave = chave + extensao
            else:
                numero_nf = 0
                serie_nf = '0'
                if dados_nf_capa['modelo_nf_series_id']:
                    obj_fiscal_modelo_nf_series = self.pool.get('fiscal.modelo.nf.series')
                    browse_modelo_nf_series = obj_fiscal_modelo_nf_series.browse(cr, uid,
                                                                                 dados_nf_capa['modelo_nf_series_id'][
                                                                                     0], context=context)
                    serie_nf = browse_modelo_nf_series.serie_nf
                    numero_nf = browse_modelo_nf_series.numero_nf
                chave = '%041d%s.xml' % (numero_nf, serie_nf.rjust(3, '0'))
        else:
            chave = dados_nf_capa.get('nfe_chave_acesso')
            if chave:
                chave = chave + '.pdf'
            else:
                chave = '%041d%s.pdf' % (dados_nf_capa['numero_nf'], dados_nf_capa['serie_nf'].rjust(3, '0'))
        return chave

    _name = "fiscal.export.nfe.osv"
    _description = "Exportacao de Nota Fiscal Eletronica e Geracao de DANFE"
    _columns = {
        'xml_export': fields.binary('Exportar Xml', readonly=True),
        'file': fields.char('Arquivo', size=64, readonly=True),
    }
    _defaults = {
        'file': _get_chave_nfe,
    }


