# -*- encoding: utf-8 -*-
from openerp.osv import osv, fields
from SigUtils.formatastring import formataString
from openerp.report.interface import report_int
from SigUtils.impressao import Impressora
import StringIO
from openerp.report.render import render
from datetime import date
from SigUtils.numero import getNumeroEditado
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_margem_contribuicao(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        pdf_file = StringIO.StringIO()
        listagem = Impressora()

        listagem.defineFormato()
        listagem.informaNome(pdf_file, 'Margem de Contribuicao')
        listagem.informaTamLinha(120)
        listagem.defineMargem(1, 1, 1, 1)
        listagem.rodapePadrao()

        data_hoje = date.today()
        data_hoje = '%s/%s/%s' % (str(data_hoje)[8:], str(data_hoje)[5:7], str(data_hoje)[:4])

        empresa = datas['company_id']

        obj_emp = pooler.get_pool(cr.dbname).get("res.company")
        obj_estoque_preco_venda = pooler.get_pool(cr.dbname).get('estoque.preco.venda')
        obj_estoque_preco_custo = pooler.get_pool(cr.dbname).get('estoque.preco.custo')
        obj_fiscal_tributacao_encargos = pooler.get_pool(cr.dbname).get('fiscal.tributacao.encargos')
        obj_fiscal_tributacao = pooler.get_pool(cr.dbname).get('fiscal.tributacao')
        obj_estoque_produto_grade = pooler.get_pool(cr.dbname).get('estoque.produto.grade')
        obj_estoque_local_locacao = pooler.get_pool(cr.dbname).get('estoque.local.locacao')
        obj_estoque_produto_embalagem = pooler.get_pool(cr.dbname).get('estoque.produto.embalagem')
        obj_estoque_embalagem = pooler.get_pool(cr.dbname).get('estoque.embalagem')

        if isinstance(empresa, list):
            empresa = empresa[0]
        res = obj_emp.read(cr, uid, empresa, ['name'], context=context)
        nome_empresa = formataString(res['name'], 25, ' ', 'D', 'N', 'S')
        obj_prod = pooler.get_pool(cr.dbname).get('estoque.produto')
        folha = 'Folha: {{ Page , 5}}'

        arg_search = []

        if datas['fabricante_id']:
            arg_search.append(('fabricante_id', '=', datas['fabricante_id'][0]))

        if datas['categoria_id']:
            arg_search.append(('categoria_id', '=', datas['categoria_id'][0]))

        if datas['ncm_id']:
            arg_search.append(('ncm_id', '=', datas['ncm_id'][0]))

        if datas['comprador_id']:
            arg_search.append(('comprador_id', '=', datas['comprador_id'][0]))

        #        if datas['fornecedor_id']:
        #            arg_search.append(('fornecedor_id.id', '=', datas['fornecedor_id'][0]))
        #
        #        if datas['tributacao_id']:
        #            arg_search.append(('tributacao_id.id', '=', datas['tributacao_id'][0]))

        arg_search.append(('tipo', '=', 'P'))

        parametro = pooler.get_pool(cr.dbname).get('estoque.parametro').read(cr, uid, empresa,
                                                                             ['custo_fixo', 'comissoes'], context=context)
        custo_fixo = parametro.get('custo_fixo')

        comissoes = parametro.get('comissoes')

        listagem.informaCab(
            _('|-------------------------------------------------------------------------------------------------------------------------------------------------|'))
        listagem.informaCab(
            _('|Contr.Estoque                                               Margem de Contribuicao                                                         Est430|'))
        listagem.informaCab(
            _('|                                                                                                                                                 |'))
        listagem.informaCab('|' + str(
            data_hoje) + '                                                  ' + nome_empresa + '                                              ' + folha + '  |')
        if datas['local_id']:
            listagem.informaCab(
                _('|                                                                                                                                                 |'))
            local = pooler.get_pool(cr.dbname).get('estoque.local').read(cr, uid, datas['local_id'][0],
                                                                         ['numero', 'name'], context=context)
            listagem.informaCab(
                _('|') + formataString(_('Local ..: ') + str(local['numero']) + ' ' + str(local['name']), 140, ' ', 'D', 'S',
                                    'S') + _('|'))
            limiteLinhas = 118
        else:
            limiteLinhas = 119
        listagem.informaCab(
            _('|-------------------------------------------------------------------------------------------------------------------------------------------------|'))
        listagem.informaCab(
            _('|Codigo do Item | Descricao                                                      |UNI |Embalagem | Ultimo Custo | Preco venda | % Lucro | % Contr |'))
        listagem.informaCab(
            _('|---------------|----------------------------------------------------------------|----|----------|--------------|-------------|---------|---------|'))
        listagem.informaCab(
            _('|               |                                                                |    |          |              |             |         |         |'))

        rs_prod = obj_prod.search(cr, uid, arg_search, context=context)

        dados = obj_prod.browse(cr, uid, rs_prod)

        produto_ids = map(lambda i: i.id, dados)
        produto_ids = list(set(produto_ids))
        preco_venda = obj_estoque_preco_venda.get_preco_venda(cr, uid, produto_ids, epc_company_id=empresa)
        custos = obj_estoque_preco_custo.get_custos_do_dia(cr, uid, produto_ids, empresa)

        contador = 1

        media_lucros = 0

        if datas['fornecedor_id']:
            obj_forn = pooler.get_pool(cr.dbname).get('estoque.fornecedor')
            fornecedores = obj_forn.search(cr, uid, [('fornecedor_id', '=', datas['fornecedor_id'][0])],
                                           context=context)
            estoque_fornecedor = obj_forn.browse(cr, uid, fornecedores)

        if datas['tributacao_id']:
            obj_trib = pooler.get_pool(cr.dbname).get('fiscal.tributacao.encargos')
            tributacoes = obj_trib.search(cr, uid, [('tributacao_id', '=', datas['tributacao_id'][0])], context=context)
            fiscal_tributacao = obj_trib.browse(cr, uid, tributacoes)

        for dado in dados:

            filtro_produto_fornecedor = False
            filtro_produto_tributacao = False

            if datas['fornecedor_id']:
                for produto_fornecedor in estoque_fornecedor:
                    if dado['id'] == produto_fornecedor.produto_id.id:
                        filtro_produto_fornecedor = True
                        break
            else:
                filtro_produto_fornecedor = True

            if datas['tributacao_id']:
                for produto_tributacao in fiscal_tributacao:
                    if dado['id'] == produto_tributacao.produto_id.id:
                        filtro_produto_tributacao = True
                        break
            else:
                filtro_produto_tributacao = True

            if filtro_produto_fornecedor and filtro_produto_tributacao:

                dados_preco_venda = preco_venda.get(dado.id) or {}
                preco_venda_rel = dados_preco_venda.get('preco_venda')

                if custos.get(dado.id):
                    ultimo_custo = custos.get(dado.id).get('estprc_ultimo_custo')
                    custo_corrigido = custos.get(dado.id).get('estprc_custo_corrigido')
                else:
                    ultimo_custo = 0.0
                    custo_corrigido = 0.0

                comissao_produto = comissoes * preco_venda_rel / 100
                custo_fixo_produto = custo_fixo * preco_venda_rel / 100

                imposto_produto = 0

                tributacao_encargos = obj_fiscal_tributacao_encargos.search(cr, uid, [('produto_id', '=', dado['id'])], context=context)

                for tributacao in tributacao_encargos:
                    tributacao_id = obj_fiscal_tributacao_encargos.read(cr, uid, tributacao, ['tributacao_id'], context=context)[
                        'tributacao_id']
                    tributo = obj_fiscal_tributacao.read(cr, uid, tributacao_id[0], ['base', 'aliquota'], context=context)

                    imposto = tributo.get('base') * tributo.get('aliquota') / 100

                    imposto_produto += imposto * preco_venda_rel / 100

                if preco_venda_rel:
                    lucro = ((
                                 preco_venda_rel - custo_corrigido - comissao_produto - imposto_produto - custo_fixo_produto) * 100) / preco_venda_rel
                    teste1 = preco_venda_rel - custo_corrigido
                    teste2 = teste1 - comissao_produto
                    teste3 = teste2 - imposto_produto
                    teste4 = teste3 - custo_fixo_produto
                    teste5 = teste4 * 100
                    teste6 = teste5 / preco_venda_rel
                    contr = ((
                                 preco_venda_rel - custo_corrigido - comissao_produto - imposto_produto) * 100) / preco_venda_rel
                else:
                    lucro = 0
                    contr = 0

                media_lucros += lucro
                sigla_embalagem = ""
                quantidade_embalagem = ""

                if datas['local_id']:
                    grade_id = obj_estoque_produto_grade.search(cr, uid, [('produto_id', '=', dado.id)], context=context)
                    if grade_id:
                        locacao_id = obj_estoque_local_locacao.search(cr, uid, [('local_id', '=', datas['local_id'][0]),
                                                                                ('grade_id', '=', grade_id[0])], context=context)
                        if locacao_id:
                            estllc_produto_embalagem_id = \
                                obj_estoque_local_locacao.read(cr, uid, locacao_id[0], ['estllc_produto_embalagem_id'], context=context)[
                                    'estllc_produto_embalagem_id']
                            if estllc_produto_embalagem_id:
                                embalagem_id = \
                                    obj_estoque_produto_embalagem.read(cr, uid, estllc_produto_embalagem_id[0],
                                                                       ['embalagem_id'], context=context)['embalagem_id']
                                embalagem = obj_estoque_embalagem.read(cr, uid, embalagem_id[0],
                                                                       ['sigla', 'quantidade_na_embalagem'], context=context)
                                sigla_embalagem = embalagem.get('sigla')
                                quantidade_embalagem = embalagem.get('quantidade_na_embalagem')

                linha = '|'

                linha += formataString(dado['codigo'], 15, ' ', 'D', 'S', 'S')
                linha += '|'
                linha += formataString(dado['name'], 64, ' ', 'D', 'S', 'S')
                linha += '|'
                linha += formataString(sigla_embalagem, 4, ' ', 'C', 'S', 'S')
                linha += '|'
                linha += formataString(quantidade_embalagem, 10, ' ', 'C', 'S', 'S')
                linha += '|'
                linha += formataString(getNumeroEditado(ultimo_custo), 14, ' ', 'E', 'S', 'S')
                linha += '|'
                linha += formataString(getNumeroEditado(preco_venda_rel), 13, ' ', 'E', 'S', 'S')
                linha += '|'
                linha += formataString(getNumeroEditado(lucro), 9, ' ', 'E', 'S', 'S')
                linha += '|'
                linha += formataString(getNumeroEditado(contr), 9, ' ', 'E', 'S', 'S')
                linha += '|'

                listagem.imprimeLinha(linha)

                resto = contador % limiteLinhas

                if not resto:
                    listagem.imprimeLinha('{{ Page }}')

                contador += 1

        media_lucros = media_lucros / contador

        listagem.imprimeLinha(
            _('|-------------------------------------------------------------------------------------------------------------------------------------------------|'))
        linha = _('|')
        linha += formataString('', 10, ' ', 'D', 'S', 'S')
        linha += formataString(_('Margem de Lucratividade Media  .......'), 121, ' ', 'D', 'S', 'S')
        linha += formataString(getNumeroEditado(media_lucros), 14, ' ', 'D', 'S', 'S')
        linha += _('|')

        listagem.imprimeLinha(linha)
        listagem.imprimeLinha(
            _('|-------------------------------------------------------------------------------------------------------------------------------------------------|'))

        listagem.finalizaImpressao()

        self.obj = external_pdf(pdf_file.getvalue())
        self.obj.render()
        pdf_file.close()
        return (self.obj.pdf, 'pdf')


report_margem_contribuicao('report.margem.contribuicao')


class margem_contribuicao(osv.TransientModel):
    _name = 'margem.contribuicao'
    _description = 'Margem de Contribuicao'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa'),
        'categoria_id': fields.many2one('estoque.categoria', 'Categoria', select=True, ondelete="restrict"),
        'local_id': fields.many2one('estoque.local', 'Local', select=True, ondelete="restrict"),
        'fabricante_id': fields.many2one("adm.pessoa", 'Fabricante', select=True, ondelete="restrict"),
        'comprador_id': fields.many2one("compras.comprador", 'Comprador', ondelete="cascade", select=True),
        'fornecedor_id': fields.many2one('financeiro.fornecedor', 'Fornecedor', select=True, ondelete="set null"),
        'ncm_id': fields.many2one('fiscal.ncm', 'NCM', select=True, ondelete="restrict"),
        'tributacao_id': fields.many2one("fiscal.tributacao", 'Tributacao', select=True, ondelete="restrict")
    }

    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(cr, uid, uid).company_id.id,
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = self.read(cr, uid, ids[0], [], context=context)

        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)

        datas = {
            'company_id': vals['company_id'],
            'categoria_id': vals['categoria_id'],
            'fabricante_id': vals['fabricante_id'],
            'fornecedor_id': vals['fornecedor_id'],
            'ncm_id': vals['ncm_id'],
            'local_id': vals['local_id'],
            'comprador_id': vals['comprador_id'],
            'tributacao_id': vals['tributacao_id']
        }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'margem.contribuicao',
            'datas': datas,
        }
