# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2017 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2017, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import fields, osv
from openerp.tools.translate import _

class wizard_nfe_operacao_nao_realizada(osv.TransientModel):
    _name = 'wizard.nfe.operacao.nao.realizada'  # wizonr
    _description = 'Motivo da operacao nao realizada'

    _columns = {
        'wizonr_nfe_consumo_id': fields.integer('ID da nota fiscal', invisible=True),
        'name': fields.char('Motivo', size=255,
                            help="Descricao do motivo de nao realizacao da operacao de uma nota "
                                 "fiscal eletronica (Manifestacao destinatario)."),
    }

    def wizonr_button_confirmar(self, cr, user, ids, context=None):
        context = context and context.copy() or dict()
        motivo_dados = self.read(cr, user, ids[0], ['name', 'wizonr_nfe_consumo_id'], context)
        if len(motivo_dados.get('name')) < 15:
            raise osv.except_osv(_('Atencao!'),
                                 _('O motivo da nao realizacao da operacao deve ter no minimo 15 '
                                   'caracteres.'))

        motivo = self.remove_accents(motivo_dados.get('name').encode('utf-8'))
        nfe_id = [motivo_dados.get('wizonr_nfe_consumo_id')]
        processo, __ = self.pool.get('fiscal.nfe.consumo').confirma_evento(
            cr, user, nfe_id, '210240', context, motivo)
        if processo.resposta.cStat.valor == u'128':  # Lote de evento processado
            if processo.resposta.infEvento.cStat.valor in (u'573', u'135'):
                self.pool.get('fiscal.nfe.consumo').write(
                    cr, user, nfe_id, dict(state='OR'), context)
            else:
                raise osv.except_osv(_('Erro!'), '%s - %s' % (
                    processo.resposta.infEvento.cStat.valor,
                    processo.resposta.infEvento.xMotivo.valor))
        else:
            raise osv.except_osv(_('Erro!'), '%s - %s' % (processo.resposta.cStat.valor,
                                                          processo.resposta.xMotivo.valor))

        return True

    @staticmethod
    def remove_accents(text):
        from unicodedata import normalize, category
        unicode_string = unicode(text, 'utf-8') if type(text) == str else text
        text = unicode(filter(lambda c: category(c) != 'Mn', normalize('NFKD', unicode_string)))

        return ''.join([ord(x) < 128 and ord(x) != 92 and x or '' for x in text])


# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
