# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class fiscal_produto_tribut_osv(osv.TransientModel):
    _name = 'fiscal.produto.tribut.osv'
    _columns = {
        'produto_osv_id': fields.many2one('estoque.produto.osv', 'Produto osv'),
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="cascade", select=True), # id do produto
        'uf_id': fields.many2one("adm.uf", 'UF ', ondelete="cascade", select=True), # id da uf
        'cidade_id': fields.many2one("adm.cidade", 'Cidade ', ondelete="cascade", select=True,
                                     domain="[('uf_id', '=', uf_id)]"), # id da cidade
        'encargo_id': fields.many2one("fiscal.encargo", 'Encargo ', ondelete="cascade", select=True), # Id do encargo
        'cst_id': fields.many2one("fiscal.cst", 'Cst ', ondelete="cascade", select=True,
                                  domain="[('encargo_id', '=', encargo_id)]"), # id do cst
        'tributacao_id': fields.many2one("fiscal.tributacao", 'Tributacao ', ondelete="cascade", select=True,
                                         domain="[('cst_id', '=', cst_id)]"), # Id da tributacao
        'mva': fields.float('MVA', digits=(5, 2)),
        'valor_pauta': fields.float('Valor Pauta', digits=(10, 2)),
        'modbcst': fields.selection([('0', 'Preco tabelado'),
                                     ('1', 'Lista negativa'),
                                     ('2', 'Lista positiva'),
                                     ('3', 'Lista neutra'),
                                     ('4', 'Margem valor agregado'),
                                     ('5', 'Pauta'),
                                     ('6', 'Valor da operacao')
                                    ], 'Modal.determ. BC do ICMS ST',
                                    help="Modalidade de determinacao da Base de Calculo do ICMS de Substituicao Tributaria",
                                    size=1),
        'codigo_cst': fields.char('Cst', size=10),
        'aliquota': fields.float('Aliquota', digits=(10, 2)),
        'base': fields.float('Base', digits=(10, 2)),
    }
