# -*- coding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from datetime import date
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
from openerp import pooler
from dateutil.parser import parse
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_registro_entrada(report_int):
    def getNumeroEditado(self, number, decimals=2, dec_point=',', thousands_sep='.'):
        try:
            number = round(float(number), decimals)
        except ValueError:
            return number
        neg = number < 0
        integer, fractional = str(abs(number)).split('.')
        m = len(integer) % 3
        if m:
            parts = [integer[:m]]
        else:
            parts = []

        parts.extend([integer[m + t:m + t + 3] for t in xrange(0, len(integer[m:]), 3)])

        if decimals:
            return '%s%s%s%s' % (
                neg and '-' or '',
                thousands_sep.join(parts),
                dec_point,
                fractional.ljust(decimals, '0')[:decimals]
            )
        else:
            return '%s%s' % (neg and '-' or '', thousands_sep.join(parts))

    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        pdf_file = StringIO.StringIO()
        # DADOS DO CONTEXTO
        empresa = datas['company_id']
        tipo_impressao = datas['tipo_impressao']
        data_ini = '%s/%s/%s' % (datas['data_ini'][8:], datas['data_ini'][5:7], datas['data_ini'][:4])
        data_fim = '%s/%s/%s' % (datas['data_fim'][8:], datas['data_fim'][5:7], datas['data_fim'][:4])

        folha = datas['folha']
        #****************************************************************************************************************************************
        # NOME DA EMPRESA LOGADA
        obj_emp = pooler.get_pool(cr.dbname).get("res.company")
        if isinstance(empresa, list):
            empresa = empresa[0]
        browse_emp = obj_emp.browse(cr, uid, empresa, context=context)
        res = obj_emp.read(cr, uid, empresa, ['name'], context=context)
        pessoa_id = browse_emp.rescon_pessoa_id.id
        nome_empresa = formataString(res['name'], 25, ' ', 'D', 'N', 'S')
        folha = formataString(datas['folha'], 5, ' ', 'D', 'N', 'S')

        #CNPJ DA EMPRESA LOGADA
        obj_dados_empresa = pooler.get_pool(cr.dbname).get('adm.pessoa')
        empresa_cnpj = browse_emp.rescon_pessoa_id.cpf_cnpj
        n_cnpj = formataString(empresa_cnpj, 18, ' ', 'D', 'N', 'S')
        # INSCRICAO ESTADUAL DA EMPRESA LOGADA CONFORME PARAMETRO SEARCH
        insc_est = browse_emp.rescon_pessoa_id.admpes_jur_ie or ' '
        insc_est = formataString(insc_est, 15, ' ', 'D', 'N', 'S')
        industria_comercio = browse_emp.rescon_pessoa_id.admpes_jur_tipo_atividade
        sql = """
            select
                nf.id as nota_id,
                nf.vr_base_icms_substituicao as base_substituicao,
                nf.vr_icms_substituicao as substituicao,
                to_char(nf.data_saida_entrada,'DD/MM/YYYY') as data_entrada,
                modelo_nf.fismnf_tipo as especie,
                nf.serie_nf as serie,
                '' as subserie,
                nf.numero_nf as numero,
                to_char(nf.data_emissao,'DD/MM/YYYY') as data_documento,
                pessoa.codigo as codigo_emitente,
                endereco_uf.sigla as uf,
                sum(mov_itens.vr_total_item_rateado) as valor_contabil_rateado,
                sum(mov_itens.vr_total_item) as valor_contabil,
                sum(mov_itens.vr_desconto_rateado) as valor_desconto,
                sum(mov_itens.vr_frete_rateado) as valor_frete,
                sum(mov_itens.vr_seguro_rateado) as vr_seguro,
                sum(mov_itens.vr_despesas_rateado) as vr_despesas_acessorias,
                '' as contabil,
                cfop.codigo as fiscal,
                encargo.sigla as icms,
                case
                    when cst.tipo = 'T' then 1
                    when cst.tipo = 'I' then 2
                    when cst.tipo = 'U' then 3
                    else 4
                end as cod,
                case
		        when encargo.sigla = 'IPI' then sum(nf_itens_tribut.vr_encargo)
                end as vr_ipi_item,
                case
                   when cst.codigo in ('10','30','70') then nf_itens_tribut.vr_icms_substituicao
                end as vr_icms_substitucao_rateado,
                cst.codigo as codigo_cst,
                sum(nf_itens_tribut.vr_base_calculo) as base_calculo,
                nf_itens_tribut.aliquota as aliquota,
                sum(nf_itens_tribut.vr_encargo) as imposto_creditado,
                sum(nf_itens_tribut.vr_reducao_base) as vr_reducao_base,
                nf.state as state,
                nf.vr_frete as vr_frete,
                /* tras o frete como false pois existe outro sql para buscar apenas frete por fora */
                0 as tipo_frete,
                nf.tributacao_id as tributacao_frete,
                nf.vr_base_icms_frete as vr_base_icms_frete,
                nf.vr_icms_frete as vr_icms_frete,
                nf.vr_aliquota_frete as vr_aliquota_frete
            from
                adm_pessoa pessoa,
                fiscal_nf_item_tributacao nf_itens_tribut,
                fiscal_tributacao tribut,
                fiscal_modelo_nf modelo_nf,
                fiscal_cst cst,
                fiscal_encargo encargo,
                fiscal_cfop cfop,
                adm_pessoa_endereco endereco,
                adm_uf endereco_uf,
                fiscal_nf_capa nf left join estoque_movimento_itens mov_itens on nf.id = mov_itens.nf_id
            where
                nf.state in ('3','C','I')
                and nf.destinatario_id = pessoa.id
                and mov_itens.id = nf_itens_tribut.movimento_itens_id
                and modelo_nf.id = nf.modelo_nf_id
                and tribut.id = nf_itens_tribut.tributacao_id
                and cst.id = nf_itens_tribut.cst_id
                and encargo.id = nf_itens_tribut.encargo_id
                and cfop.id = mov_itens.cfop_id
                and modelo_nf.id = nf.modelo_nf_id
                and endereco.id = nf.destinatario_endereco_id
                and endereco_uf.id = endereco.uf_id
                and nf.tipo = 'E'
                and (nf.tipo_frete is Null or nf.tipo_frete = 'D')
                and nf.data_saida_entrada >= ('%s')
                and nf.data_saida_entrada <= ('%s')
                and encargo.sigla in ('ICMS','IPI')
            group by
                nf.id,
                nf.vr_base_icms_substituicao,
                nf.vr_icms_substituicao,
                cfop.codigo,
                tribut.id,
                nf.data_saida_entrada,
                modelo_nf.fismnf_tipo,
                nf.serie_nf,
                nf.numero_nf,
                nf.data_emissao,
                pessoa.codigo,
                nf.state,
                endereco_uf.sigla,
                encargo.sigla,
                cst.tipo,
                nf_itens_tribut.aliquota,
                nf.vr_frete,
                nf.tipo_frete,
                nf.tributacao_id,
                nf.vr_base_icms_frete,
                nf.vr_icms_frete,
                nf.vr_aliquota_frete,
                cst.codigo,
                nf_itens_tribut.vr_encargo,
                nf_itens_tribut.vr_icms_substituicao
            order by
                nf.data_saida_entrada,
                modelo_nf.fismnf_tipo,
                nf.numero_nf,
                nf.serie_nf
            """ % (datas['data_ini'], datas['data_fim'])
        ### ______ SQL que busca o frete de fora _______
        sql_frete_por_fora = """
            select
                to_char(nf.data_emissao, 'DD/MM/YYYY') as data_entrada,
                'COF' as especie_frete,
                nf.serie_frete as serie_frete,
                nf.serie_nf as serie,
                nf.numero_conhecimento as numero_frete,
                nf.numero_nf as numero,
                to_char(nf.data_emissao_frete, 'DD/MM/YYYY') as data_documento_frete,
                to_char(nf.data_emissao, 'DD/MM/YYYY') as data_documento,
                pessoa.codigo as codigo_emitente,
                uf.sigla as uf,
                nf.vr_frete as valor_contabil,
                '' as contabil,
                cfop.codigo as fiscal,
                encargo.sigla as icms,
                /*('T','Tributado'), ('U', 'Substituicao'), ('I', 'Isento'), ('O', 'Outros'),
                ('D', 'Diferido'), ('S', 'Servico'), ('TU', 'Tributado com substituicao')*/
                case
                    when cst.tipo = 'T' then 1
                    when cst.tipo = 'I' then 2
                    when cst.tipo = 'U' then 3
                    else 4
                end as cod,
                nf.vr_base_icms_frete as base_calculo,
                nf.vr_aliquota_frete as aliquota,
                nf.vr_icms_frete as imposto_creditado,
                '' as frete_observacao,
                nf.state as state,
                True as tipo_frete,
                nf.vr_ipi_frete as vr_ipi_frete
            from
                fiscal_nf_capa nf,
                adm_pessoa pessoa,
                --adm_transportador transportadora,
                adm_pessoa_endereco endereco,
                adm_uf uf,
                fiscal_cfop_natureza natureza,
                fiscal_cfop cfop,
                fiscal_cfop_natureza_encargos natureza_encargo,
                fiscal_encargo encargo,
                fiscal_cst cst,
                fiscal_tributacao tributacao
            where
                nf.data_saida_entrada >= ('%s') and
                nf.data_saida_entrada <= ('%s') and
                nf.destinatario_id = pessoa.id and

                /* SOMENTE NOTA DE ENTRADA */
                nf.tipo= 'E' and
                /* SOMENTE FRETE DE FORA */
                nf.tipo is not Null and
                /* SOMENTE FRETE QUE TENHA TRIBUTACAO LANCADA*/
                nf.tributacao_id is not Null and
                /* TRANSPORTADORA - EMITENTE */
                --transportadora.id = nf.transportador_id and
                --transportadora.pessoa_id = pessoa.id and
                /* UF DO ENDERECO FISCAL DA TRANSPORTADORA */
                --pessoa.id = endereco.pessoa_id and
                --endereco.uf_id = uf.id and
                nf.transportador_id = endereco.pessoa_id and
                nf.transportador_id = uf.id and
                /* NATUREZA SEJA DO TIPO ENTRADA */
                natureza.tipo = 'E' and
                /* CFOP DA NOTA */
                nf.natureza_id = natureza.id and
                natureza.cfop_id = cfop.id and
                /* ICMS - ENCARGO */
                natureza_encargo.natureza_id = natureza.id and
                natureza_encargo.encargo_id = encargo.id and
                encargo.sigla in ('ICMS', 'IPI') and
                /* CODIGO DE VALORES FISCAIS */
                nf.tributacao_id = tributacao.id and
                tributacao.cst_id = cst.id
            group by
                nf.data_emissao,
                especie,
                nf.serie_frete,
                nf.serie_nf,
                nf.numero_conhecimento,
                nf.numero_nf,
                nf.data_emissao_frete,
                nf.data_emissao,
                pessoa.codigo,
                uf.sigla,
                nf.vr_frete,
                contabil,
                cfop.codigo,
                encargo.sigla,
                cod,
                nf.vr_base_icms_frete,
                nf.vr_aliquota_frete,
                nf.vr_icms_frete,
                frete_observacao,
                nf.state,
                tipo_frete,
                vr_ipi_frete
        """ % (datas['data_ini'], datas['data_fim'])
        obj_fiscal_nf_capa = pooler.get_pool(cr.dbname).get('fiscal.nf.capa')
        obj_fiscal_guia = pooler.get_pool(cr.dbname).get('fiscal.guia')
        list_data = []
        list_emitente = []
        list_nota = []
        if industria_comercio in ('A','C'):
            print "____________________________________________ COMERCIO ____________________________________________"
            #****************************************************************************************************************************************
            #CABEÇARIO RELATORIO
            listagem = Impressora()

            if datas['tipo_impressao'] == 'R':
                listagem.defineFormato(orientacao='0')
                listagem.informaNome(pdf_file, 'Registro de entrada')
                listagem.informaTamLinha(120)
                listagem.defineMargem(1, 1, 1, 1)

            if datas['tipo_impressao'] == 'P':
                listagem.defineFormato(orientacao='1')
                listagem.informaNome(pdf_file, 'Registro de entrada')
                listagem.informaTamLinha(81)
                listagem.defineMargem(2, 1, 1, 1)

            folha = int(folha)
            listagem.informaCab(
                _('|-------------------------------------------------------------------------------------------------------|-----------------------------------------|'))
            listagem.informaCab(
                _('|                                        REGISTRO DE ENTRADA                                            |    ( * ) Codigo de Valores Fiscais      |'))
            listagem.informaCab(
                _('|FIRMA:') + nome_empresa + _('                                                             MODELO P1  |-----------------------------------------|'))
            listagem.informaCab(
                _('|                                                                                                       |1-Operacao com Credito do Imposto        |'))
            listagem.informaCab(
                _('|INSCR.ESTADUAL:' + insc_est + '    CNPJ(MF):' + n_cnpj + '                                          |2-Operacao sem Credito do Imposto-Isenta |'))
            listagem.informaCab(
                _('|                                                                                                       |  ou nao-tributadas                      |'))
            listagem.informaCab(
                _('|                                                                                                       |3-Operacao com Substituicao Tributaria   |'))
            listagem.informaCab(_('|FOLHA:') + str(folha) + _('                PERIODO DE: ') + str(data_ini) + ' A ' + str(
                data_fim) + _('                                             |4-Operacao sem Credito do Imposto -Outras|'))
            listagem.informaCab(
            _('|-------------------------------------------------------------------------------------------------------|-----------------------------------------|'))
            listagem.informaCab(
                _('|          |         DOCUMENTOS FISCAIS                 |          |  CODIFICACAO  |         VALORES FISCAIS                    |                 |'))
            listagem.informaCab(
                _('| DATA DE  |--------------------------------------------|  VALOR   |---------------|--------------------------------------------|                 |'))
            listagem.informaCab(
                _('|          |    |SERIE|      |DATA DO   |CODIGO  |  UF  |          |        |      |ICMS|COD.| BASE DE CALCULO  |     |IMPOSTO  |  OBSERVACOES    |'))
            listagem.informaCab(
                _('| ENTRADA  |ESPE|SUB- |NUMERO|          |        |      | CONTABIL |CONTABIL|FISCAL|    |    |       OU         |ALIQ.|         |                 |'))
            listagem.informaCab(
                _('|          |CIE |SERIE|      |DOCUMENTO |EMITENTE|ORIGEM|          |        |      |    | (*)| VALOR DA OPERACAO|     |CREDITADO|                 |'))
            listagem.informaCab(
                _('|----------|----|-----|------|----------|--------|------|----------|--------|------|----|----|------------------|-----|---------|-----------------|'))
            listagem.informaCab(
                _('|          |    |     |      |          |        |      |          |        |      |    |    |                  |     |         |                 |'))
            #****************************************************************************************************************************************

            cr.execute(sql)
            dados_nota = cr.dictfetchall()
            cr.execute(sql_frete_por_fora)
            dados_frete_fora = cr.dictfetchall()

            cr.execute("""
                SELECT   state                                                     ,
                         id                                       AS nota_id       ,
                         TO_CHAR(data_saida_entrada,'DD/MM/YYYY') AS data_entrada  ,
                         serie_nf                                 AS serie         ,
                         numero_nf                                AS numero        ,
                         CASE
                                  WHEN state = 'C'
                                  THEN 'Cancelada'
                                  WHEN state = 'I'
                                  THEN 'Inutilizada'
                         END AS frete_observacao
                FROM     fiscal_nf_capa
                WHERE    data_saida_entrada >= ('%s')
                AND      data_saida_entrada <= ('%s')
                AND      state IN ('C',
                                   'I')
                AND      tipo = 'E'
                ORDER BY data_saida_entrada
            """ % (datas['data_ini'], datas['data_fim']))
            dados_nf_canceladas = cr.dictfetchall()

            for x in dados_nf_canceladas:
                dados_nota.append(x)

            if dados_frete_fora:
                for x in dados_frete_fora:
                    if x.get('icms') == 'IPI' and not x.get('vr_ipi_frete'):
                        pass
                    else:
                        dados_nota.extend([x])
            total_contab = 0
            total_vr_calc = 0
            icms1 = 0
            icms2 = 0
            icms3 = 0
            icms4 = 0
            ipi1 = 0
            ipi2 = 0
            ipi3 = 0
            ipi4 = 0
            imp_icms1 = 0
            imp_icms2 = 0
            imp_icms3 = 0
            imp_icms4 = 0
            imp_ipi1 = 0
            imp_ipi2 = 0
            imp_ipi3 = 0
            imp_ipi4 = 0
            resumo_estado = {}
            list_numero_nota = []
            list_dados = []
            list_codigo_emitente = []
            list_data_entrada = []
            obj_fiscal_parametro = pooler.get_pool(cr.dbname).get('fiscal.parametro')

            #            dados_nota = sorted(dados_nota, key=lambda k: k['data_entrada'])
            ## _______________________ TERMINAR CORREÇÃO APOS AS FERIAS ______________________________
            # as chaves acessas no for devem estar presentes na consulta do sql,
            # tanto para a nota quanto para o frete
            list_indices_removidos = []

            for i in dados_nota:
                x = dados_nota
                for c in x:
                    if dados_nota.index(i) != x.index(c):
                        if i.get('numero') == c.get('numero') and i.get('data_entrada') == c.get('data_entrada') and \
                                        i.get('codigo_emitente') == c.get('codigo_emitente') and i.get('icms') == c.get(
                                'icms') and \
                                        i.get('cod') == c.get('cod') and i.get('cod') == 3:
                            valor_contabil_i = i.get('valor_contabil') or i.get('valor_contabil_rateado') or 0.0
                            valor_contabil_c = c.get('valor_contabil') or c.get('valor_contabil_rateado') or 0.0
                            i['valor_contabil'] = valor_contabil_c + valor_contabil_i
                            i['valor_contabil_rateado'] = i.get('valor_contabil')
                            base_calculo_i = i.get('base_calculo') or 0.0
                            base_calculo_c = c.get('base_calculo') or 0.0
                            i['base_calculo'] = base_calculo_c + base_calculo_i
                            vr_reducao_base_i = i.get('vr_reducao_base') or 0.0
                            vr_reducao_base_c = c.get('vr_reducao_base') or 0.0
                            i['vr_reducao_base'] = vr_reducao_base_c + vr_reducao_base_i
                            list_indices_removidos.append(x.index(c))
                            x.pop(x.index(c))
            key_hash = {}
            for i in dados_nota:
                data_entrada = str(i['data_entrada'])
                fornecedor = str(i.get('codigo_emitente', '')).ljust(9, '0')
                serie = str(i['serie']).ljust(9, '0')
                numero = str(i['numero']).ljust(9, '0')

                h = hash('%s%s%s%s' % (data_entrada, fornecedor, serie, numero))

                if key_hash.get(h):
                    key_hash[h].append(i)
                else:
                    key_hash[h] = [i]
                ## _______________________ TERMINAR CORREÇÃO APOS AS FERIAS ______________________________
            for k in key_hash:
                for dados in key_hash[k]:
                #                for dados in dados_nota_ordenado:
                    uf = dados.get('uf', '')
                    cod = dados.get('cod', '')
                    icms = dados.get('icms', '')
                    serie = dados.get('serie')
                    state = dados.get('state')
                    numero = dados.get('numero')
                    fiscal = dados.get('fiscal', '')
                    especie = dados.get('especie')
                    nota_id = dados.get('nota_id')
                    subserie = dados.get('subserie')
                    vr_frete = dados.get('vr_frete') or 0
                    aliquota = dados.get('aliquota')
                    contabil = dados.get('contabil', '')
                    tipo_frete = dados.get('tipo_frete')
                    codigo_cst = dados.get('codigo_cst')
                    serie_frete = dados.get('serie_frete')
                    data_entrada = dados.get('data_entrada')
                    numero_frete = dados.get('numero_frete')
                    base_calculo = dados.get('base_calculo') or 0
                    vr_ipi_frete = dados.get('vr_ipi_frete')
                    substituicao = dados.get('substituicao')
                    vr_icms_frete = dados.get('vr_icms_frete')
                    especie_frete = dados.get('especie_frete')
                    data_documento = dados.get('data_documento', '')
                    valor_contabil = dados.get('valor_contabil') or 0
                    codigo_emitente = dados.get('codigo_emitente', '')
                    vr_reducao_base = dados.get('vr_reducao_base') or 0
                    tributacao_frete = dados.get('tributacao_frete')
                    frete_observacao = dados.get('frete_observacao')
                    imposto_creditado = dados.get('imposto_creditado')
                    vr_aliquota_frete = dados.get('vr_aliquota_frete') or 0
                    base_substituicao = dados.get('base_substituicao') or 0
                    vr_base_icms_frete = dados.get('vr_base_icms_frete')
                    data_documento_frete = dados.get('data_documento_frete')
                    valor_contabil_rateado = dados.get('valor_contabil_rateado') or 0

                    vr_desconto = dados.get('valor_desconto') or 0
                    vr_despesas_acessorias = dados.get('vr_despesas_acessorias') or 0
                    vr_seguro = dados.get('vr_seguro') or 0
                    vr_frete_total_item = dados.get('valor_frete') or 0

                    contabil_valor = True
                    if state == 'C':
                        base_calculo = 0.0
                        aliquota = 0.0
                        valor_contabil = 0.0
                        imposto_creditado = 0.0
                        #                linha='|'
                        #                linha+=formataString(dados['data_entrada'], 10, ' ', 'D', 'S', 'S')
                    vr_frete = vr_frete
                    linha = _('|')
                    if tipo_frete:
                        especie = especie_frete
                        fiscal = '1353' if datas.get('uf_sigla') == dados.get('uf') else '2353'
                        if data_documento_frete:
                            data_documento = data_documento_frete
                        if numero_frete:
                            numero = numero_frete
                        if serie_frete:
                            serie = serie_frete
                    elif especie == 'T':
                        especie = 'CTR'
                    else:
                        especie = 'NF'
                    if icms == 'IPI':
                        valor_contabil = dados.get('vr_ipi_item') or 0.0
                        valor_contabil_rateado = dados.get('vr_ipi_item') or 0.0
                        base_calculo = dados.get('vr_ipi_item') or 0.0
                        cod = 4
                        imposto_creditado = 0
                    if vr_reducao_base:
                        valor_contabil -= vr_reducao_base
                    else:
                        valor_contabil = valor_contabil_rateado or valor_contabil or 0.0
                        if not tipo_frete:
                            vr_frete_total_item = 0
                        valor_contabil += dados.get('vr_icms_substitucao_rateado') or 0.0
                    valor_contabil = valor_contabil + vr_despesas_acessorias + vr_seguro + vr_frete_total_item
                    if valor_contabil != valor_contabil_rateado:
                        valor_contabil -= vr_desconto
                    valor_contabil_editado = report_registro_entrada.getNumeroEditado(self, valor_contabil)
                    numero_nota = numero
                    numero_nota = str(numero_nota)
                    digitos_numero_nota = 0
                    if len(numero_nota) > 6:
                        digitos_numero_nota = len(numero_nota) - 6
                    if not numero in list_numero_nota:
                        linha += formataString(data_entrada, 10, ' ', 'D', 'S', 'S')
                        linha += _('|')
                        linha += formataString(especie, 4, ' ', 'C', 'S', 'S')#conct ['subserie_nf']
                        linha += _('|')
                        linha += formataString(str(serie), 5, ' ', 'E', 'S', 'S')
                        linha += _('|')
                        linha += formataString(numero_nota[digitos_numero_nota:], 6, ' ', 'E', 'S', 'S')
                        linha += _('|')
                        linha += formataString(data_documento, 10, ' ', 'D', 'S', 'S')
                        linha += _('|')
                        linha += formataString(codigo_emitente, 8, ' ', 'E', 'S', 'S')
                        linha += _('|')
                        linha += formataString(uf, 6, ' ', 'C', 'S', 'S')
                        linha += _('|')
                        linha += formataString(valor_contabil_editado, 10, ' ', 'E', 'S', 'S')
                        linha += _('|')
                    elif numero in list_numero_nota and not codigo_emitente in list_codigo_emitente:
                        linha += formataString(data_entrada, 10, ' ', 'D', 'S', 'S')
                        linha += _('|')
                        linha += formataString(especie, 4, ' ', 'C', 'S', 'S')#conct ['subserie_nf']
                        linha += _('|')
                        linha += formataString(str(serie), 5, ' ', 'E', 'S', 'S')
                        linha += _('|')
                        linha += formataString(numero_nota[digitos_numero_nota:], 6, ' ', 'E', 'S', 'S')
                        linha += _('|')
                        linha += formataString(data_documento, 10, ' ', 'D', 'S', 'S')
                        linha += _('|')
                        linha += formataString(codigo_emitente, 8, ' ', 'E', 'S', 'S')
                        linha += _('|')
                        linha += formataString(uf, 6, ' ', 'C', 'S', 'S')
                        linha += _('|')
                        linha += formataString(valor_contabil_editado, 10, ' ', 'E', 'S', 'S')
                        linha += _('|')
                    elif numero in list_numero_nota and codigo_emitente in list_codigo_emitente and not data_entrada in list_data_entrada:
                        linha += formataString(data_entrada, 10, ' ', 'D', 'S', 'S')
                        linha += _('|')
                        linha += formataString(especie, 4, ' ', 'C', 'S', 'S')#conct ['subserie_nf']
                        linha += _('|')
                        linha += formataString(str(serie), 5, ' ', 'E', 'S', 'S')
                        linha += _('|')
                        linha += formataString(numero_nota[digitos_numero_nota:], 6, ' ', 'E', 'S', 'S')
                        linha += _('|')
                        linha += formataString(data_documento, 10, ' ', 'D', 'S', 'S')
                        linha += _('|')
                        linha += formataString(codigo_emitente, 8, ' ', 'E', 'S', 'S')
                        linha += _('|')
                        linha += formataString(uf, 6, ' ', 'C', 'S', 'S')
                        linha += _('|')
                        linha += formataString(valor_contabil_editado, 10, ' ', 'E', 'S', 'S')
                        linha += _('|')
                    elif numero in list_numero_nota and codigo_emitente in list_codigo_emitente and data_entrada in list_data_entrada:
                        var = False
                        for x in list_dados:
                            if x.get('numero') == numero and x.get('codigo_emitente') == codigo_emitente and x.get(
                                    'data_entrada') == data_entrada:
                                linha += formataString('', 10, ' ', 'D', 'S', 'S')
                                linha += _('|')
                                linha += formataString('', 4, ' ', 'C', 'S', 'S')#conct ['subserie_nf']
                                linha += _('|')
                                linha += formataString('', 5, ' ', 'E', 'S', 'S')
                                linha += _('|')
                                linha += formataString('', 6, ' ', 'E', 'S', 'S')
                                linha += _('|')
                                linha += formataString('', 10, ' ', 'D', 'S', 'S')
                                linha += _('|')
                                linha += formataString('', 8, ' ', 'C', 'S', 'S')
                                linha += _('|')
                                linha += formataString('', 6, ' ', 'C', 'S', 'S')
                                linha += _('|')
                                linha += formataString(valor_contabil_editado, 10, ' ', 'E', 'S', 'S')
                                linha += _('|')
                                var = True
                                contabil_valor = False
                                break
                        if not var:
                            linha += formataString(data_entrada, 10, ' ', 'D', 'S', 'S')
                            linha += _('|')
                            linha += formataString(especie, 4, ' ', 'C', 'S', 'S')#conct ['subserie_nf']
                            linha += _('|')
                            linha += formataString(str(serie), 5, ' ', 'E', 'S', 'S')
                            linha += _('|')
                            linha += formataString(numero_nota[digitos_numero_nota:], 6, ' ', 'E', 'S', 'S')
                            linha += _('|')
                            linha += formataString(data_documento, 10, ' ', 'D', 'S', 'S')
                            linha += _('|')
                            linha += formataString(codigo_emitente, 8, ' ', 'E', 'S', 'S')
                            linha += _('|')
                            linha += formataString(uf, 6, ' ', 'C', 'S', 'S')
                            linha += _('|')
                            linha += formataString(valor_contabil_editado, 10, ' ', 'E', 'S', 'S')
                            linha += _('|')

                    else:
                        linha += formataString('', 10, ' ', 'D', 'S', 'S')
                        linha += _('|')
                        linha += formataString('', 4, ' ', 'C', 'S', 'S')#conct ['subserie_nf']
                        linha += _('|')
                        linha += formataString('', 5, ' ', 'E', 'S', 'S')
                        linha += _('|')
                        linha += formataString('', 6, ' ', 'E', 'S', 'S')
                        linha += _('|')
                        linha += formataString('', 10, ' ', 'D', 'S', 'S')
                        linha += _('|')
                        linha += formataString('', 8, ' ', 'C', 'S', 'S')
                        linha += _('|')
                        linha += formataString('', 6, ' ', 'C', 'S', 'S')
                        linha += _('|')
                        linha += formataString('', 10, ' ', 'C', 'S', 'S')
                        linha += _('|')
                        contabil_valor = False
                    linha += formataString(contabil, 8, ' ', 'D', 'S', 'S')
                    linha += _('|')
                    linha += formataString(fiscal, 6, ' ', 'E', 'S', 'S')
                    linha += _('|')
                    linha += formataString(icms, 4, ' ', 'D', 'S', 'S')
                    linha += _('|')
                    linha += formataString(cod, 4, ' ', 'C', 'S', 'S')
                    linha += _('|')
                    linha += formataString(
                        report_registro_entrada.getNumeroEditado(self, (base_calculo or vr_reducao_base)), 18, ' ', 'E',
                        'S', 'S')
                    linha += _('|')
                    linha += formataString(report_registro_entrada.getNumeroEditado(self, (aliquota or 0)), 5, ' ', 'E',
                                           'S', 'S')
                    linha += _('|')
                    linha += formataString(report_registro_entrada.getNumeroEditado(self, (imposto_creditado or 0)), 9,
                                           ' ', 'E', 'S', 'S')
                    total_contab += valor_contabil
                    total_vr_calc += valor_contabil
                    valor_imposto = imposto_creditado
                    linha += _('|')
                    base_sub = ''
                    sub = ''
                    if cod == 3 and codigo_cst in ('10', '30', '60', '70'):
                        if substituicao > 0:
                            sub = 'ICMS ST ' + str(substituicao)
                        if base_substituicao > 0:
                            base_sub = 'BC ST ' + str(base_substituicao)

                    if base_sub:
                        linha += formataString(base_sub, 17, ' ', 'D', 'S', 'S')
                        linha += _('|')
                        listagem.imprimeLinha(linha)
                        linha = _('|          |    |     |      |          |        |      |          |        |      |    |    |                  |     |         |')
                    linha += formataString(sub if state != 'C' else _(' *** CANCELADO ***'), 17, ' ', 'D', 'S', 'S')
                    linha += _('|')
                    if not uf in resumo_estado:
                        resumo_estado[uf] = {'valor_contab': 0, 'base_c_icms': 0, 'valor_icms': 0, 'base_c_ipi': 0,
                                             'valor_ipi': 0, 'isento_tribut': 0, 'vlr_outros': 0, 'vlr_substi': 0}
                    resumo_estado[uf]['valor_contab'] += valor_contabil
                    if icms == 'IPI' and cod == 1:
                        resumo_estado[uf]['base_c_ipi'] += base_calculo or 0
                        resumo_estado[uf]['valor_ipi'] += (base_calculo or 0) * aliquota / 100

                    if icms == 'ICMS' and cod == 1:
                        resumo_estado[uf]['base_c_icms'] += base_calculo or 0
                        resumo_estado[uf]['valor_icms'] += (base_calculo or 0) * aliquota / 100

                    if cod == 2:
                        resumo_estado[uf]['isento_tribut'] += base_calculo or 0

                    if cod == 4:
                        resumo_estado[uf]['vlr_outros'] += base_calculo or 0

                    if cod == 3:
                        resumo_estado[uf]['vlr_substi'] += base_calculo or 0

                    listagem.imprimeLinha(linha)

                    if tipo_frete == 'D' and tributacao_frete and contabil_valor:
                        linha = _('|')
                        linha += formataString('', 10, ' ', 'D', 'S', 'S')
                        linha += _('|')
                        linha += formataString('', 4, ' ', 'C', 'S', 'S')
                        linha += _('|')
                        linha += formataString('', 5, ' ', 'E', 'S', 'S')
                        linha += _('|')
                        linha += formataString('', 6, ' ', 'E', 'S', 'S')
                        linha += _('|')
                        linha += formataString('', 10, ' ', 'D', 'S', 'S')
                        linha += _('|')
                        linha += formataString('', 8, ' ', 'E', 'S', 'S')
                        linha += _('|')
                        linha += formataString('', 6, ' ', 'C', 'S', 'S')
                        linha += _('|')
                        linha += formataString(report_registro_entrada.getNumeroEditado(self, vr_frete) or 0.0, 10, ' ',
                                               'E', 'S', 'S')
                        linha += _('|')
                        linha += formataString(contabil, 8, ' ', 'D', 'S', 'S')
                        linha += _('|')
                        linha += formataString(fiscal, 6, ' ', 'E', 'S', 'S')
                        linha += _('|')
                        linha += formataString(icms, 4, ' ', 'D', 'S', 'S')
                        linha += _('|')
                        if vr_icms_frete:
                            cod = 1
                        else:
                            cod = 2
                        linha += formataString(cod, 4, ' ', 'C', 'S', 'S')
                        linha += _('|')
                        linha += formataString(
                            report_registro_entrada.getNumeroEditado(self, vr_base_icms_frete or 0.0), 18, ' ', 'E',
                            'S', 'S')
                        linha += _('|')
                        linha += formataString(
                            report_registro_entrada.getNumeroEditado(self, (vr_aliquota_frete or 0.0)), 5, ' ', 'E',
                            'S', 'S')
                        linha += _('|')
                        linha += formataString(report_registro_entrada.getNumeroEditado(self, (vr_icms_frete or 0.0)),
                                               9, ' ', 'E', 'S', 'S')
                        linha += _('|')
                        linha += formataString(sub if state != 'C' else _(' Cancelado'), 17, ' ', 'D', 'S', 'S')
                        linha += _('|')
                        total_contab += vr_frete or 0.0
                        listagem.imprimeLinha(linha)
                    nf_id = nota_id
                    guia_ids = obj_fiscal_nf_capa.browse(cr, uid, nf_id).guia_ids
                    if guia_ids and (not data_documento in list_data \
                                         or not codigo_emitente in list_emitente \
                                         or not numero_nota in list_nota):
                        list_nota.append(numero_nota)
                        list_data.append(data_documento)
                        list_emitente.append(codigo_emitente)
                        for x in guia_ids:
                            base = x.base or 0.0
                            valor = x.valor or 0.0
                            linha = _('|          |    |     |      |          |        |      |          |        |      |    |    |                  |     |         |')
                            linha += formataString(
                                _('GNRE BC: %s') % report_registro_entrada.getNumeroEditado(self, (base)), 17, ' ', 'D',
                                'S', 'S')
                            linha += _('|')
                            listagem.imprimeLinha(linha)
                            linha = _('|          |    |     |      |          |        |      |          |        |      |    |    |                  |     |         |')
                            linha += formataString(
                                _('Gnre Icms: %s') % report_registro_entrada.getNumeroEditado(self, (valor)), 17, ' ', 'D',
                                'S', 'S')
                            linha += _('|')
                            listagem.imprimeLinha(linha)
                    reducao_base_isento = 0.0
                    reducao_base_outros = 0.0
                    cod_base_reduzida = None
                    if vr_reducao_base:
                        cod_base_reduzida = cod
                        fiscal_parametro_id = obj_fiscal_parametro.search(cr, uid, [('company_id', '=', empresa)],
                                                                          context=context)
                        if fiscal_parametro_id:
                            fispar_base_reduzida = obj_fiscal_parametro.browse(cr, uid, fiscal_parametro_id[
                                0]).fispar_base_reduzida
                            if fispar_base_reduzida == 'I':
                                cod_base_reduzida = 2
                                reducao_base_isento = vr_reducao_base
                            else:
                                cod_base_reduzida = 4
                                reducao_base_outros = vr_reducao_base
                        linha = _('|          |    |     |      |          |        |      |')
                        linha += formataString(report_registro_entrada.getNumeroEditado(self, vr_reducao_base), 10, ' ',
                                               'E', 'S', 'S')
                        linha += _('|')
                        linha += formataString(contabil, 8, ' ', 'D', 'S', 'S')
                        linha += _('|')
                        linha += formataString(fiscal, 6, ' ', 'E', 'S', 'S')
                        linha += _('|')
                        linha += formataString(icms, 4, ' ', 'D', 'S', 'S')
                        linha += _('|')
                        linha += formataString(cod_base_reduzida, 4, ' ', 'C', 'S', 'S')
                        linha += _('|')
                        linha += formataString(report_registro_entrada.getNumeroEditado(self, vr_reducao_base), 18, ' ',
                                               'E', 'S', 'S')
                        linha += _('|')
                        linha += formataString(report_registro_entrada.getNumeroEditado(self, 0), 5, ' ', 'E', 'S', 'S')
                        linha += _('|')
                        linha += formataString(report_registro_entrada.getNumeroEditado(self, 0), 9, ' ', 'E', 'S', 'S')
                        total_contab += vr_reducao_base
                        valor_imposto = imposto_creditado
                        linha += _('|')
                        base_sub = ''
                        linha += formataString(base_sub, 17, ' ', 'D', 'S', 'S')
                        linha += _('|')
                        listagem.imprimeLinha(linha)
                    if icms == 'ICMS':
                        if cod_base_reduzida and cod_base_reduzida == 2:
                            icms2 += reducao_base_isento
                            resumo_estado[uf]['isento_tribut'] += reducao_base_isento
                        if cod_base_reduzida and cod_base_reduzida == 4:
                            icms4 += reducao_base_outros
                            resumo_estado[uf]['vlr_outros'] += reducao_base_outros
                        if cod == 1:
                            icms1 += base_calculo + (vr_frete or 0.0)
                            imp_icms1 += valor_imposto + (vr_icms_frete or 0.0)
                        elif cod == 2:
                            icms2 += base_calculo
                            imp_icms2 += valor_imposto
                        elif cod == 3:
                            icms3 += base_calculo
                            imp_icms3 += valor_imposto
                        elif cod == 4:
                            icms4 += base_calculo
                            imp_icms4 += valor_imposto

                    if icms == 'IPI':
                        if cod_base_reduzida and cod_base_reduzida == 2:
                            ipi2 += reducao_base_isento
                            resumo_estado[uf]['isento_tribut'] += reducao_base_isento
                        if cod_base_reduzida and cod_base_reduzida == 4:
                            ipi4 += reducao_base_outros
                            resumo_estado[uf]['vlr_outros'] += reducao_base_outros
                        if cod == 1:
                            ipi1 += valor_contabil
                            imp_ipi1 += valor_imposto
                        if cod == 2:
                            ipi2 += valor_contabil
                            imp_ipi2 += valor_imposto
                        if cod == 3:
                            ipi3 += valor_contabil
                            imp_ipi3 += valor_imposto
                        if cod == 4:
                            ipi4 += valor_contabil
                            imp_ipi4 += valor_imposto
                    list_numero_nota.append(numero)
                    list_dados.append(
                        {'numero': numero, 'codigo_emitente': codigo_emitente, 'data_entrada': data_entrada})
                    list_codigo_emitente.append(codigo_emitente)
                    list_data_entrada.append(data_entrada)

            total_cont = total_vr_calc
            #            total_vr_cal = total_vr_calc
            total_contab_editado = report_registro_entrada.getNumeroEditado(self, total_contab)
            listagem.imprimeLinha(
                _('---------------------------------------------------------------------------------------------------------------------------------------------------'))
            listagem.imprimeLinha(
                _('|TOTAL                                                    %9s                                                                               |') % (
                    total_contab_editado))
            if icms1:
                icms1_editado = report_registro_entrada.getNumeroEditado(self, icms1)
                imp_icms1_editado = report_registro_entrada.getNumeroEditado(self, imp_icms1)
                listagem.imprimeLinha(
                    _('|                                                                                   ICMS  1            %9s       %9s                  |') % (
                        icms1_editado, imp_icms1_editado))
            if icms2:
                icms2_editado = report_registro_entrada.getNumeroEditado(self, icms2)
                imp_icms2_editado = report_registro_entrada.getNumeroEditado(self, imp_icms2)
                listagem.imprimeLinha(
                    _('|                                                                                   ICMS  2            %9s       %9s                  |') % (
                        icms2_editado, imp_icms2_editado))
            if icms3:
                icms3_editado = report_registro_entrada.getNumeroEditado(self, icms3)
                imp_icms3_editado = report_registro_entrada.getNumeroEditado(self, imp_icms3)
                listagem.imprimeLinha(
                    _('|                                                                                   ICMS  3            %9s       %9s                  |') % (
                        icms3_editado, imp_icms3_editado))
            if icms4:
                icms4_editado = report_registro_entrada.getNumeroEditado(self, icms4)
                imp_icms4_editado = report_registro_entrada.getNumeroEditado(self, imp_icms4)
                listagem.imprimeLinha(
                    _('|                                                                                   ICMS  4            %9s       %9s                  |') % (
                        icms4_editado, imp_icms4_editado))
            if ipi1:
                ipi1_editado = report_registro_entrada.getNumeroEditado(self, ipi1)
                imp_ipi1_editado = report_registro_entrada.getNumeroEditado(self, imp_ipi1)
                listagem.imprimeLinha(
                    _('|                                                                                    IPI  1            %9s       %9s                  |') % (
                        ipi1_editado, imp_ipi1_editado))
            if ipi2:
                ipi2_editado = report_registro_entrada.getNumeroEditado(self, ipi2)
                imp_ipi2_editado = report_registro_entrada.getNumeroEditado(self, imp_ipi2)
                listagem.imprimeLinha(
                    _('|                                                                                    IPI  2            %9s       %9s                  |') % (
                        ipi2_editado, imp_ipi2_editado))
            if ipi3:
                ipi3_editado = report_registro_entrada.getNumeroEditado(self, ipi3)
                imp_ipi3_editado = report_registro_entrada.getNumeroEditado(self, imp_ipi3)
                listagem.imprimeLinha(
                    _('|                                                                                    IPI  3            %9s       %9s                  |') % (
                        ipi3_editado, imp_ipi3_editado))
            if ipi4:
                ipi4_editado = report_registro_entrada.getNumeroEditado(self, ipi4)
                imp_ipi4_editado = report_registro_entrada.getNumeroEditado(self, imp_ipi4)
                listagem.imprimeLinha(
                    _('|                                                                                    IPI  4            %9s       %9s                  |') % (
                        ipi4_editado, imp_ipi4_editado))
                #LINHA FINAL DO 1 RELATORIO
            listagem.imprimeLinha(
                _('---------------------------------------------------------------------------------------------------------------------------------------------------'))
            #QUEBRA  PAGIA
            listagem.cabecalhos = []
            folha = int(folha) + 1
            listagem.informaCab(
                _('|-------------------------------------------------------------------------------------------------------------------------------------------------|'))
            listagem.informaCab(
                _('|                                                          REGISTRO DE ENTRADAS                                                                   |'))
            listagem.informaCab(_('|FOLHA:') + str(
                folha) + _('                                                                                                                                          |'))
            listagem.informaCab(
                _('|                                                          RESUMO POR ESTADO                                                                      |'))
            listagem.informaCab(
                _('|-------------------------------------------------------------------------------------------------------------------------------------------------|'))
            listagem.informaCab(
                _('| ESTADO              | VALORES     |   BASE DE    |   VALOR   |   BASE DE  |   VALOR   |   ISENTOS   |   OUTROS      |       SUBSTITUICAO        |'))
            listagem.informaCab(
                _('|                     | CONTABEIS   |   C. ICMS    |   ICMS    |   C.IPI    |   I P I   |   TRIBUTAD  |               |                           |'))
            listagem.informaCab(
                _('|-------------------------------------------------------------------------------------------------------------------------------------------------|'))
            listagem.imprimeLinha('{{ Page }}')
            t2 = t3 = t4 = t5 = t6 = t7 = t8 = 0
            for est in resumo_estado:
                linha = _('|')
                linha += formataString(est, 21, ' ', 'D', 'S', 'S')
                linha += _('|')
                linha += formataString(
                    report_registro_entrada.getNumeroEditado(self, resumo_estado[est]['valor_contab']), 13, ' ', 'E',
                    'S', 'S')
                linha += _('|')
                linha += formataString(
                    report_registro_entrada.getNumeroEditado(self, resumo_estado[est]['base_c_icms']), 14, ' ', 'E',
                    'S', 'S')
                linha += _('|')
                linha += formataString(report_registro_entrada.getNumeroEditado(self, resumo_estado[est]['valor_icms']),
                                       11, ' ', 'E', 'S', 'S')
                linha += _('|')
                linha += formataString(report_registro_entrada.getNumeroEditado(self, resumo_estado[est]['base_c_ipi']),
                                       12, ' ', 'E', 'S', 'S')
                linha += _('|')
                linha += formataString(report_registro_entrada.getNumeroEditado(self, resumo_estado[est]['valor_ipi']),
                                       11, ' ', 'E', 'S', 'S')
                linha += _('|')
                linha += formataString(
                    report_registro_entrada.getNumeroEditado(self, resumo_estado[est]['isento_tribut']), 13, ' ', 'E',
                    'S', 'S')
                linha += _('|')
                linha += formataString(report_registro_entrada.getNumeroEditado(self, resumo_estado[est]['vlr_outros']),
                                       15, ' ', 'E', 'S', 'S')
                linha += _('|')
                linha += formataString(report_registro_entrada.getNumeroEditado(self, resumo_estado[est]['vlr_substi']),
                                       27, ' ', 'E', 'S', 'S')
                linha += _('|')
                t2 += resumo_estado[est]['base_c_icms']
                t3 += resumo_estado[est]['valor_icms']
                t4 += resumo_estado[est]['base_c_ipi']
                t5 += resumo_estado[est]['valor_ipi']
                t6 += resumo_estado[est]['isento_tribut']
                t7 += resumo_estado[est]['vlr_outros']
                t8 += resumo_estado[est]['vlr_substi']
                listagem.imprimeLinha(linha)
            listagem.imprimeLinha(
                _('|-------------------------------------------------------------------------------------------------------------------------------------------------|'))
            listagem.imprimeLinha(_('|TOTAIS%18s') % ' ' + '%11s' % report_registro_entrada.getNumeroEditado(self,
                                                                                                          total_cont) + ' ' + '%14s' % report_registro_entrada.getNumeroEditado(
                self, t2) + ' ' +
                                  '%11s' % report_registro_entrada.getNumeroEditado(self,
                                                                                    t3) + ' ' + '%12s' % report_registro_entrada.getNumeroEditado(
                self, t4) + ' ' + ''
                                  '%11s' % report_registro_entrada.getNumeroEditado(self,
                                                                                    t5) + ' ' + '%14s' % report_registro_entrada.getNumeroEditado(
                self, t6) + ' ' +
                                  '%14s' % report_registro_entrada.getNumeroEditado(self,
                                                                                    t7) + ' ' + '%27s' % report_registro_entrada.getNumeroEditado(
                self, t8) + _('|'))
            listagem.imprimeLinha(
                _('|-------------------------------------------------------------------------------------------------------------------------------------------------|'))
            #RESUMO DO RELATORIO
            listagem.finalizaImpressao()

        else:
            print "____________________________________________ INDUSTRIA ____________________________________________"
            #CABEÇARIO RELATORIO INDUSTRIA
            listagem = Impressora()
            if datas['tipo_impressao'] == 'R':
                listagem.defineFormato(orientacao='0')
                listagem.informaNome(pdf_file, 'Registro de entrada')
                listagem.informaTamLinha(120)
                listagem.defineMargem(1, 1, 1, 1)
            if datas['tipo_impressao'] == 'P':
                listagem.defineFormato(orientacao='1')
                listagem.informaNome(pdf_file, 'Registro de entrada')
                listagem.informaTamLinha(81)
                listagem.defineMargem(2, 1, 1, 1)

            listagem.informaCab(
                _('|-------------------------------------------------------------------------------------------------------|-----------------------------------------|'))
            listagem.informaCab(
                _('|                                        REGISTRO DE ENTRADA                                            |    ( * ) Codigo de Valores Fiscais      |'))
            listagem.informaCab(
                _('|FIRMA:') + nome_empresa + _('                                                             MODELO P1/A|-----------------------------------------|'))
            listagem.informaCab(
                _('|                                                                                                       |1-Operacao com Credito do Imposto        |'))
            listagem.informaCab(
                _('|INSCR.ESTADUAL:' + insc_est + '    CNPJ(MF):' + n_cnpj + '                                          |2-Operacao sem Credito do Imposto-Isenta |'))
            listagem.informaCab(
                _('|                                                                                                       |  ou nao-tributadas                      |'))
            listagem.informaCab(
                _('|                                                                                                       |3-Operacao com Substituicao Tributaria   |'))
            listagem.informaCab(_('|FOLHA:') + str(folha) + _('                PERIODO DE: ') + str(data_ini) + ' A ' + str(
                data_fim) + _('                                             |4-Operacao sem Credito do Imposto -Outras|'))
            listagem.informaCab(
                _('|-------------------------------------------------------------------------------------------------------|-----------------------------------------|'))
            listagem.informaCab(
                _('|          |         DOCUMENTOS FISCAIS                 |         |    CODIFICACAO |         VALORES FISCAIS                    |                 |'))
            listagem.informaCab(
                _('| DATA DE  |--------------------------------------------| VALOR   |----------------|--------------------------------------------|                 |'))
            listagem.informaCab(
                _('|          |    |SERIE|      |DATA DO   |CODIGO  |  UF  |         |         |      |ICMS|COD.| BASE DE CALCULO  |     |IMPOSTO  |  OBSERVACOES    |'))
            listagem.informaCab(
                _('| ENTRADA  |ESPE|SUB- |NUMERO|          |        |      | CONTABIL| CONTABIL|FISCAL|    |    |       OU         |ALIQ.|         |                 |'))
            listagem.informaCab(
                _('|          |CIE |SERIE|      |DOCUMENTO |EMITENTE|ORIGEM|         |         |      |    | (*)| VALOR DA OPERACAO|     |CREDITADO|                 |'))
            listagem.informaCab(
                _('|----------|----|-----|------|----------|--------|------|---------|---------|------|----|----|------------------|-----|---------|-----------------|'))
            listagem.informaCab(
                _('|          |    |     |      |          |        |      |         |         |      |    |    |                  |     |         |                 |'))

            cr.execute(sql)
            dados_nota = cr.dictfetchall()
            cr.execute(sql_frete_por_fora)
            dados_frete_fora = cr.dictfetchall()
            if dados_frete_fora:
                dados_nota.extend(dados_frete_fora)
            total_contab = total_vr_calc = 0
            for dados in dados_nota:
                uf = dados.get('uf')
                cod = dados.get('cod')
                icms = dados.get('icms')
                serie = dados.get('serie')
                state = dados.get('state')
                numero = dados.get('numero')
                fiscal = dados.get('fiscal')
                especie = dados.get('especie')
                nota_id = dados.get('nota_id')
                subserie = dados.get('subserie')
                vr_frete = dados.get('vr_frete') or 0
                aliquota = dados.get('aliquota')
                contabil = dados.get('contabil')
                tipo_frete = dados.get('tipo_frete')
                codigo_cst = dados.get('codigo_cst')
                serie_frete = dados.get('serie_frete')
                data_entrada = dados.get('data_entrada')
                numero_frete = dados.get('numero_frete')
                base_calculo = dados.get('base_calculo') or 0
                vr_ipi_frete = dados.get('vr_ipi_frete')
                substituicao = dados.get('substituicao')
                vr_icms_frete = dados.get('vr_icms_frete')
                especie_frete = dados.get('especie_frete')
                data_documento = dados.get('data_documento')
                valor_contabil = dados.get('valor_contabil') or 0
                codigo_emitente = dados.get('codigo_emitente')
                vr_reducao_base = dados.get('vr_reducao_base') or 0
                tributacao_frete = dados.get('tributacao_frete')
                frete_observacao = dados.get('frete_observacao')
                imposto_creditado = dados.get('imposto_creditado')
                vr_aliquota_frete = dados.get('vr_aliquota_frete') or 0
                base_substituicao = dados.get('base_substituicao') or 0
                vr_base_icms_frete = dados.get('vr_base_icms_frete')
                data_documento_frete = dados.get('data_documento_frete')
                valor_contabil_rateado = dados.get('valor_contabil_rateado') or 0

                if state == 'C':
                    base_calculo = 0.0
                    aliquota = 0.0
                    valor_contabil = 0.0
                    imposto_creditado = 0.0
                linha = _('|')
                linha += formataString(data_entrada, 10, ' ', 'D', 'S', 'S')
                linha += _('|')
                if tipo_frete:
                    especie = especie_frete
                    fiscal = fiscal[0] + '353'
                elif especie == 'T':
                    especie = 'CTR'
                else:
                    especie = 'NF'
                numero_nota = numero
                numero_nota = str(numero_nota)
                digitos_numero_nota = 0
                if len(numero_nota) > 6:
                    digitos_numero_nota = len(numero_nota) - 6
                valor_contabil = valor_contabil_rateado or valor_contabil or 0.0

                linha += formataString(especie, 4, ' ', 'C', 'S', 'S')#conct ['subserie_nf']
                linha += _('|')
                linha += formataString(str(serie), 5, ' ', 'E', 'S', 'S')
                linha += _('|')
                linha += formataString(numero_nota[digitos_numero_nota:], 6, ' ', 'E', 'S', 'S')
                linha += _('|')
                linha += formataString(data_documento, 10, ' ', 'D', 'S', 'S')
                linha += _('|')
                linha += formataString(codigo_emitente, 8, ' ', 'C', 'S', 'S')
                linha += _('|')
                linha += formataString(uf, 6, ' ', 'C', 'S', 'S')
                linha += _('|')
                linha += '%9.2f' % (valor_contabil or 0)
                linha += _('|')
                linha += formataString(contabil, 9, ' ', 'D', 'S', 'S')
                linha += _('|')
                linha += formataString(fiscal, 6, ' ', 'E', 'S', 'S')
                linha += _('|')
                linha += formataString(icms, 4, ' ', 'D', 'S', 'S')
                linha += _('|')
                linha += formataString(cod, 4, ' ', 'C', 'S', 'S')
                linha += _('|')
                linha += '%18.2f' % (base_calculo or 0)
                linha += _('|')
                linha += '%5.2f' % (aliquota or 0)
                linha += _('|')
                linha += '%9.2f' % (imposto_creditado or 0)
                total_contab += (valor_contabil or 0)
                total_vr_calc += (base_calculo or 0)
                linha += _('|')
                linha += formataString('' if state != 'C' else _(' Cancelado'), 17, ' ', 'D', 'S', 'S')
                linha += _('|')
                listagem.imprimeLinha(linha)
                nf_id = nota_id
                guia_ids = obj_fiscal_nf_capa.browse(cr, uid, nf_id).guia_ids
                if guia_ids and (not data_documento in list_data \
                                     or not codigo_emitente in list_emitente \
                                     or not numero_nota in list_nota):
                    list_nota.append(numero_nota)
                    list_data.append(data_documento)
                    list_emitente.append(codigo_emitente)
                    for x in guia_ids:
                        base = x.base or 0.0
                        valor = x.valor or 0.0
                        linha = _('|          |    |     |      |          |        |      |          |        |      |    |    |                  |     |         |')
                        linha += formataString(_('GNRE BC: %s') % report_registro_entrada.getNumeroEditado(self, (base)),
                                               17, ' ', 'D', 'S', 'S')
                        linha += _('|')
                        listagem.imprimeLinha(linha)
                        linha = _('|          |    |     |      |          |        |      |          |        |      |    |    |                  |     |         |')
                        linha += formataString(
                            _('Gnre Icms: %s') % report_registro_entrada.getNumeroEditado(self, (valor)), 17, ' ', 'D',
                            'S', 'S')
                        linha += _('|')
                        listagem.imprimeLinha(linha)
            total_cont = total_contab
            total_vr_cal = total_vr_calc
            listagem.imprimeLinha(
                _('---------------------------------------------------------------------------------------------------------------------------------------------------'))
            listagem.imprimeLinha(
                _('|TOTAL                                                   %9.2f                                     %9.2f                                  |') % (
                    total_cont, total_vr_cal))
            #LINHA FINAL DO 1 RELATORIO
            listagem.imprimeLinha(
                _('---------------------------------------------------------------------------------------------------------------------------------------------------'))
            #RESUMO DO RELATORIO
            listagem.cabecalhos = []
            folha = int(folha) + 1
            listagem.informaCab(
                _('|-------------------------------------------------------------------------------------------------------------------------------------------------|'))
            listagem.informaCab(
                _('|                                                          REGISTRO DE ENTRADAS                                               MODELO:P1           |'))
            listagem.informaCab(_('|FOLHA:') + str(
                folha) + _('                                                                                                                                    |'))
            listagem.informaCab(
                _('|                                                          RESUMO POR ESTADO                                                                      |'))
            listagem.informaCab(
                _('|-------------------------------------------------------------------------------------------------------------------------------------------------|'))
            listagem.informaCab(
                _('| ESTADO              | VALORES     |   BASE DE    |   VALOR   |   BASE DE  |   VALOR   |   ISENTOS   |   OUTROS      |       SUBSTITUICAO        |'))
            listagem.informaCab(
                _('|                     | CONTABEIS   |   C. ICMS    |   ICMS    |   C.IPI    |   I P I   |   TRIBUTAD  |               |                           |'))
            listagem.informaCab(
                _('|-------------------------------------------------------------------------------------------------------------------------------------------------|'))
            listagem.informaCab(
                _('|                                                                                                                                                 |'))
            listagem.informaCab(
                _('|-------------------------------------------------------------------------------------------------------------------------------------------------|'))
            listagem.informaCab(
                _('| TOTAIS              |             |              |           |            |           |             |               |                           |'))
            listagem.informaCab(
                _('|-------------------------------------------------------------------------------------------------------------------------------------------------|'))
            listagem.imprimeLinha('{{ Page }}')
            listagem.imprimeLinha(' ')
            listagem.finalizaImpressao()
            #ATUALIZA N DA FOLHA
        parametro_id = pooler.get_pool(cr.dbname).get('registro.entrada.osv').parametro_id(cr, uid, ids, context)
        if parametro_id:
            data_inicial = parse(datas.get('data_ini'), dayfirst=True).strftime('%Y-%m-%d')
            pooler.get_pool(cr.dbname).get('adm.paginas').admpag_set_pagina(cr, uid, data_inicial=data_inicial,
                                                                         pag_final=folha, tipo='registro_entrada',
                                                                         context=context)

        self.obj = external_pdf(pdf_file.getvalue())
        self.obj.render()
        pdf_file.close()
        return (self.obj.pdf, 'pdf')


report_registro_entrada('report.registro.entrada')


class registro_entrada_osv(osv.TransientModel):
    def parametro_id(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_parametro = self.pool.get('adm.paginas')
        parametro_id = obj_parametro.search(cr, uid, [], context=context)
        if parametro_id:
            return parametro_id[0]
        else:
            return []

    def parametro_pagina(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = {}
        parametro_id = self.parametro_id(cr, uid, ids, context)
        company_id = self.pool.get('res.users').browse(cr, uid, uid, context=context).company_id.id
        pessoa_id = self.pool.get('res.company').browse(cr, uid, company_id).rescon_pessoa_id.id
        obj_pagina = self.pool.get('adm.paginas')
        id_pagina = obj_pagina.search(cr, uid, [('company_id', '=', company_id), ('tipo', '=', 'registro_entrada')],
                                      context=context)
        if id_pagina:
            id_dados = obj_pagina.read(cr, uid, parametro_id, ['inicial'], context=context)
            grava = id_dados['inicial']
        else:
            vals = {'data': date.today(),
                    'inicial': '1',
                    'tipo': 'registro_entrada'
            }
            grava = obj_pagina.create(cr, uid, vals, context=context)
        return grava


    def data_inicial(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        parametro_id = self.parametro_id(cr, uid, ids, context)
        company_id = self.pool.get('res.users').browse(cr, uid, uid, context=context).company_id.id
        # pessoa_id = self.pool.get('res.company').browse(cr, uid, company_id).rescon_pessoa_id.id
        # obj_data = self.pool.get('adm.paginas')
        # obj_parametro = self.pool.get('adm.parametro')
        obj_pagina = self.pool.get('adm.paginas')
        id_pagina = obj_pagina.search(cr, uid, [('company_id', '=', company_id), ('tipo', '=', 'registro_entrada')],
                                      context=context)
        if id_pagina:
            id_data = obj_pagina.read(cr, uid, parametro_id, ['data'], context=context)
            data = id_data['data']

            return data

    _name = 'registro.entrada.osv'
    _description = 'Registro de Entradas'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa'),
        'tipo_impressao': fields.selection([('R', 'Retrato'), ('P', 'Paisagem')], 'Tipo Impressao',
                                           help='Por padrao Retrato A4'),
        'data_ini': fields.date('Data Inicio', help='Data inicial geracao relatorio'),
        'data_fim': fields.date('Data Fim', help='Data final geracao relatorio'),
        'folha': fields.integer('Folha', help='Informe a folha inicial')
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(cr, uid, uid).company_id.id,
        'tipo_impressao': lambda *a: 'R',
        'folha': parametro_pagina,
        'data_ini': data_inicial,
    }

    def onchange_data_inicial(self, cr, uid, ids, data_inicial, context=None):
        context = context and context.copy() or {}
        pagina = self.pool.get('adm.paginas').admpag_get_pagina(cr, uid, data=data_inicial, tipo='registro_entrada',
                                                             context=context)
        return {'value': {'folha': pagina}}

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = self.read(cr, uid, ids[0], [], context=context)
        if vals['data_ini'] > vals['data_fim']:
            raise osv.except_osv(_('Atencao'), _('A Data inicial nao poder ser maior que a Data final.'))
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
        nome_empresa = self.pool.get("res.company").read(cr, uid, company_id, ['name'], context=context)

        obj_pessoa = self.pool.get('adm.pessoa')
        # obj_endereco = self.pool.get('adm.uf')
        info_end_pessoa = obj_pessoa.admpes_endereco_fiscal(cr, uid, vals['company_id'][0],
                                                            context).get(vals['company_id'][0])
        uf_sigla = info_end_pessoa.get('uf_sigla') or ''
        datas = {
            'company_id': vals['company_id'],
            'nome_empresa': nome_empresa['name'],
            'tipo_impressao': vals['tipo_impressao'],
            'data_ini': vals['data_ini'],
            'data_fim': vals['data_fim'],
            'folha': vals['folha'],
            'uf_sigla': uf_sigla
        }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'registro.entrada',
            'datas': datas,
        }






