#!/usr/bin/python
# -*- coding: utf-8 -*-
import psycopg2
import thread
import time
from traceback import format_exc as trace
from openerp.tools.config import config


class SqlSpedFiscal(object):
    def __init__(self, cr, data_inicio, data_final, company_id):
        """
        Este construtor incia threads de consultas que sao muito demoradas
        para que no momento em a class fiscal.sped, necessitar destes registros
        eles ja estejam prontos.
        Ao iniciar uma thread lembrar de colocar um uma verificacao no metodo
        da class fiscal.sped que necessite destes dados observando se a thread do registro
        que ele necessita ainda esta sendo executada
        """

        self.cr_open = cr
        self.data_inicio = data_inicio
        self.data_fim = data_final
        self.company_id = company_id
        self.C400 = {'executando': True, 'dados': [], 'erro': False}
        self.C405 = {'executando': True, 'dados': [], 'erro': False}
        self.C420 = {'executando': True, 'dados': [], 'erro': False}
        self.C425 = {'executando': True, 'dados': [], 'erro': False}
        self.C490 = {'executando': True, 'dados': [], 'erro': False}
        self.erro = False
        try:
            thread.start_new_thread(self.sql_regC400, ())
            time.sleep(1)
            thread.start_new_thread(self.sql_regC405, ())
            time.sleep(1)
            thread.start_new_thread(self.sql_regC420, ())
            time.sleep(1)
            thread.start_new_thread(self.sql_regC425, ())
            time.sleep(1)
            thread.start_new_thread(self.sql_regC490, ())
        except:
            self.erro = trace()

    def new_cursor(self):
        password = config.options.get('db_password') or ''
        conn = psycopg2.connect(dsn=self.cr_open._cnx.dsn, password=password)
        return conn.cursor()

    def sql_consulta_movimento_notas(self, cr, filtros, perfil_sped):
        query_perfil_c = ''
        if perfil_sped == 'C':
            query_perfil_c = "AND modelo.fismnf_codigo NOT IN ('06', '29', '28' )"
        dt_ini = filtros.get('sped_data_inicial')
        dt_fin = filtros.get('sped_data_final')
        company_id = filtros.get('company_id')
        sql_terceiros = """
            UNION
            SELECT nf.id
            FROM   fiscal_nf_capa nf
                   LEFT JOIN fiscal_modelo_nf modelo
                            ON modelo.id = nf.modelo_nf_id
                   INNER JOIN fiscal_cfop_natureza natureza
                      ON natureza.id = nf.natureza_id
                   INNER JOIN fiscal_cfop cfop
                      ON cfop.id = natureza.cfop_id
            WHERE  nf.tipo = 'E'
                   AND nf.data_saida_entrada AT TIME ZONE 'UTC' BETWEEN '%s' AND '%s'
                   AND nf.company_id = %s
                   AND nf.nf_propria = False
                   AND nf.state = '3'
                   AND cfop.produto_servico_tipo <> 'S'
                   AND modelo.fismnf_codigo < '90'
                   {query_perfil_c}
            GROUP  BY nf.id,
                      modelo.fismnf_tipo_nfe
            HAVING nf.state != 'C'
                    OR ( nf.state = 'C'
                         AND ( modelo.fismnf_tipo_nfe = false
                                OR ( modelo.fismnf_tipo_nfe = true
                                     AND nf.nfe_chave_acesso != '' ) ) )
            """ % (dt_ini, dt_fin, company_id)
        sql_saida = """
            UNION
            SELECT nf.id
            FROM   fiscal_nf_capa nf
                   LEFT JOIN fiscal_modelo_nf_series modelo_nf_serie
                          ON modelo_nf_serie.id = nf.modelo_nf_series_id
                       LEFT JOIN fiscal_modelo_nf modelo
                            ON modelo.id = modelo_nf_serie.modelo_nf_id
            WHERE  nf.tipo = 'S'
                   AND nf.data_emissao AT TIME ZONE 'UTC' >= '%s'
                   AND nf.data_emissao AT TIME ZONE 'UTC' <= '%s'
                   AND nf.company_id = %s
                   AND nf.nf_propria = true
                   AND nf.state IN ( '3', 'C')
                   AND modelo.fismnf_codigo < '90'
                   AND nf.fisnfc_tipo_servico IS FALSE
                   AND CASE
                            WHEN modelo.fismnf_tipo_nfe AND nf.state = 'C'
                                THEN nf.nfe_protocolo_cancelamento IS NOT NULL
                            ELSE TRUE
                        END
                   {query_perfil_c}
            GROUP  BY nf.id,
                      modelo_nf_serie.flag_modelo_nfe
            HAVING nf.state != 'C'
                    OR ( nf.state = 'C'
                         AND ( modelo_nf_serie.flag_modelo_nfe = false
                                OR ( modelo_nf_serie.flag_modelo_nfe = true
                                     AND nf.nfe_chave_acesso != '' ) ) )
            """ % (dt_ini, dt_fin, company_id)

        sql_servico_eletronica = """
            UNION
            SELECT nf.id
            FROM   fiscal_nf_capa nf
                   LEFT JOIN fiscal_modelo_nf modelo
                            ON modelo.id = nf.modelo_nf_id
                   INNER JOIN fiscal_cfop_natureza natureza
                      ON natureza.id = nf.natureza_id
                   INNER JOIN fiscal_cfop cfop
                      ON cfop.id = natureza.cfop_id
            WHERE  nf.tipo = 'E'
                   AND nf.data_saida_entrada AT TIME ZONE 'UTC' BETWEEN '%s' AND '%s'
                   AND nf.company_id = %s
                   AND nf.nf_propria = False
                   AND nf.state = '3'
                   AND cfop.produto_servico_tipo = 'S'
                   AND modelo.fismnf_codigo = '55'
            GROUP  BY nf.id,
                      modelo.fismnf_tipo_nfe
        """ % (dt_ini, dt_fin, company_id)

        sql = """
                SELECT nf.id
                FROM   fiscal_nf_capa nf
                       LEFT JOIN fiscal_modelo_nf_series modelo_nf_serie
                              ON modelo_nf_serie.id = nf.modelo_nf_series_id
                       LEFT JOIN fiscal_modelo_nf modelo
                            ON modelo.id = modelo_nf_serie.modelo_nf_id
                WHERE  nf.tipo = 'E'
                       AND nf.data_emissao AT TIME ZONE 'UTC' >= '%s'
                       AND nf.data_emissao AT TIME ZONE 'UTC' <= '%s'
                       AND nf.company_id = %s
                       AND nf.nf_propria = true
                       AND nf.state IN ( '3', 'C')
                       AND modelo.fismnf_codigo < '90'
                       {query_perfil_c}
                GROUP  BY nf.id,
                          modelo_nf_serie.flag_modelo_nfe
                HAVING nf.state != 'C'
                        OR ( nf.state = 'C'
                             AND nf.numero_nf > 0
                             AND ( modelo_nf_serie.flag_modelo_nfe = false
                                    OR ( modelo_nf_serie.flag_modelo_nfe = true
                                         AND nf.nfe_chave_acesso != '' ) ) )
                %s
                %s
                %s
            """ % (dt_ini, dt_fin, company_id, sql_saida, sql_terceiros, sql_servico_eletronica)
        cr.execute(sql.format(query_perfil_c=query_perfil_c))
        movimento_notas = filter(None, map(lambda x: x[0], cr.fetchall()))
        return movimento_notas

    def sql_consulta_mov_cartao(self, cr, dt_ini, dt_fin, ecf_instalado, company_id):
        sql_nf = """
                --NF--
                SELECT reg,
                               pessoa_id,
                               pessoa_tipo,
                               operadora,
                               Sum(valor_credito) AS vl_credito,
                               Sum(valor_debito)  AS vl_debito,
                               cpf_cnpj           AS cpf_cnpj,
                               ie
                        FROM   (SELECT '1600'                      AS reg,
                                       afp.admfpg_cartao_pessoa_id AS pessoa_id,
                                       ap.pessoa_tipo              AS pessoa_tipo,
                                       ap.nome                     AS operadora,
                                       Sum(fcp.valor)              AS valor_credito,
                                       0                           AS valor_debito,
                                       afp.tipo_cartao             AS tipo_cartao,
                                       ap.cpf_cnpj                 AS cpf_cnpj,
                                       ap.admpes_jur_ie            AS ie
                                FROM   fiscal_condicao_pagamento fcp
                                       INNER JOIN fiscal_nf_capa fnc
                                               ON fnc.id = fcp.capa_id
                                       INNER JOIN adm_forma_pgto afp
                                               ON afp.id = fcp.forma_pagto_id
                                                  AND afp.cartao_credito_debito = true
                                       INNER JOIN adm_pessoa ap
                                               ON ap.id = afp.admfpg_cartao_pessoa_id
                                WHERE  fnc.data_emissao AT TIME ZONE 'UTC' BETWEEN
                                       '{dt_ini}' AND '{dt_fin}'
                                       AND fnc.state = '3'
                                       AND afp.tipo_cartao = 'C'
                                       AND fnc.company_id = {company_id}
                                GROUP  BY pessoa_id,
                                          operadora,
                                          tipo_cartao,
                                          ap.pessoa_tipo,
                                          ap.cpf_cnpj,
                                          ap.admpes_jur_ie
                                UNION ALL
                                SELECT '1600'                      AS reg,
                                       afp.admfpg_cartao_pessoa_id AS pessoa_id,
                                       ap.pessoa_tipo              AS pessoa_tipo,
                                       ap.nome                     AS operadora,
                                       0                           AS valor_credito,
                                       Sum(fcp.valor)              AS valor_debito,
                                       afp.tipo_cartao             AS tipo_cartao,
                                       ap.cpf_cnpj                 AS cpf_cnpj,
                                       ap.admpes_jur_ie            AS ie
                                FROM   fiscal_condicao_pagamento fcp
                                       INNER JOIN fiscal_nf_capa fnc
                                               ON fnc.id = fcp.capa_id
                                       INNER JOIN adm_forma_pgto afp
                                               ON afp.id = fcp.forma_pagto_id
                                                  AND afp.cartao_credito_debito = true
                                       INNER JOIN adm_pessoa ap
                                               ON ap.id = afp.admfpg_cartao_pessoa_id
                                WHERE  fnc.data_emissao AT TIME ZONE 'UTC' BETWEEN
                                       '{dt_ini}' AND '{dt_fin}'
                                       AND fnc.state = '3'
                                       AND afp.tipo_cartao = 'D'
                                       AND fnc.company_id = {company_id}
                                GROUP  BY pessoa_id,
                                          operadora,
                                          tipo_cartao,
                                          ap.pessoa_tipo,
                                          ap.cpf_cnpj,
                                          ap.admpes_jur_ie) AS TMP
                        GROUP  BY reg,
                                  pessoa_id,
                                  operadora,
                                  pessoa_tipo,
                                  cpf_cnpj,
                                  ie

                """.format(dt_ini=dt_ini, dt_fin=dt_fin, company_id=company_id)

        if not ecf_instalado:
            sql_cupom = ''
        else:
            sql_cupom = """
                        --CUPOM--
                        UNION ALL
                        SELECT reg,
                               pessoa_id,
                               pessoa_tipo,
                               operadora,
                               Sum(valor_credito) AS vl_credito,
                               Sum(valor_debito)  AS vl_debito,
                               cpf_cnpj           AS cpf_cnpj,
                               ie
                        FROM   (SELECT '1600'                      AS reg,
                                       afp.admfpg_cartao_pessoa_id AS pessoa_id,
                                       ap.pessoa_tipo              AS pessoa_tipo,
                                       ap.nome                     AS operadora,
                                       Sum(ecf.valor)              AS valor_credito,
                                       0                           AS valor_debito,
                                       afp.tipo_cartao             AS tipo_cartao,
                                       ap.cpf_cnpj                 AS cpf_cnpj,
                                       ap.admpes_jur_ie            AS ie
                                FROM   ecf_cupons_finalizacao ecf
                                       INNER JOIN ecf_cupons_capa ecc
                                               ON ecc.id = ecf.cupom_id
                                       INNER JOIN adm_condicao_forma acf
                                               ON acf.id = ecf.finalizadora_id
                                       INNER JOIN adm_forma_pgto afp
                                               ON afp.id = acf.forma_pagamento_id
                                                  AND afp.cartao_credito_debito = true
                                       INNER JOIN adm_pessoa ap
                                               ON ap.id = afp.admfpg_cartao_pessoa_id
                                WHERE  ecc.date_cupom BETWEEN
                                       '{dt_ini}' AND '{dt_fin}'
                                       AND ecc.state = 'V'
                                       AND ecc.tipo_cupom = 'V'
                                       AND ecf.tipo_finalizadora = 'C'
                                       AND afp.tipo_cartao = 'C'
                                       AND ecc.company_id = {company_id}
                                GROUP  BY pessoa_id,
                                          operadora,
                                          tipo_cartao,
                                          ecf.tipo_finalizadora,
                                          ap.pessoa_tipo,
                                          ap.cpf_cnpj,
                                          ap.admpes_jur_ie
                                UNION ALL
                                SELECT '1600'                      AS reg,
                                       afp.admfpg_cartao_pessoa_id AS pessoa_id,
                                       ap.pessoa_tipo              AS pessoa_tipo,
                                       ap.nome                     AS operadora,
                                       0                           AS valor_credito,
                                       Sum(ecf.valor)              AS valor_debito,
                                       afp.tipo_cartao             AS tipo_cartao,
                                       ap.cpf_cnpj                 AS cpf_cnpj,
                                       ap.admpes_jur_ie            AS ie
                                FROM   ecf_cupons_finalizacao ecf
                                       INNER JOIN ecf_cupons_capa ecc
                                               ON ecc.id = ecf.cupom_id
                                       INNER JOIN adm_condicao_forma acf
                                               ON acf.id = ecf.finalizadora_id
                                       INNER JOIN adm_forma_pgto afp
                                               ON afp.id = acf.forma_pagamento_id
                                                  AND afp.cartao_credito_debito = true
                                       INNER JOIN adm_pessoa ap
                                               ON ap.id = afp.admfpg_cartao_pessoa_id
                                WHERE  ecc.date_cupom BETWEEN
                                       '{dt_ini}' AND '{dt_fin}'
                                       AND ecc.state = 'V'
                                       AND ecc.tipo_cupom = 'V'
                                       AND ecf.tipo_finalizadora = 'C'
                                       AND afp.tipo_cartao = 'D'
                                       AND ecc.company_id = {company_id}
                                GROUP  BY pessoa_id,
                                          operadora,
                                          tipo_cartao,
                                          ecf.tipo_finalizadora,
                                          ap.pessoa_tipo,
                                          ap.cpf_cnpj,
                                          ap.admpes_jur_ie) AS TMP
                        GROUP  BY reg,
                                  pessoa_id,
                                  operadora,
                                  pessoa_tipo,
                                  cpf_cnpj,
                                  ie

            """.format(dt_ini=dt_ini, dt_fin=dt_fin, company_id=company_id)

        sql = """
            SELECT reg,
                   MOV_CARTAO.pessoa_id,
                   pessoa_tipo,
                   operadora,
                   (SELECT codigo_bc
                    FROM   adm_pais
                    WHERE  id = ape.pais_id
                    LIMIT  1)                  AS cod_pais,
                   cpf_cnpj                    AS cpf_cnpj,
                   Sum(vl_credito)             AS vl_credito,
                   Sum(vl_debito)              AS vl_debito,
                   ie,
                   (SELECT codigo_ibge
                    FROM   adm_cidade
                    WHERE  id = ape.cidade_id
                    LIMIT  1)                  AS cod_mun,
                   (SELECT admpes_jur_suframa
                    FROM   adm_pessoa
                    WHERE  id = MOV_CARTAO.pessoa_id
                    LIMIT  1)                  AS suframa,
                   (SELECT descricao
                    FROM   adm_logradouro
                    WHERE  id = ape.logradouro_id
                    LIMIT  1)                  AS endr,
                   ape.numero                  AS num,
                   ape.complemento             AS compl,
                   (SELECT name
                    FROM   adm_bairro
                    WHERE  id = ape.bairro_id) AS bairro
            FROM   ({sql_nf}
                    {sql_cupom}) AS MOV_CARTAO
                   LEFT JOIN adm_pessoa_endereco ape
                          ON ape.pessoa_id = MOV_CARTAO.pessoa_id
            GROUP  BY reg,
                      MOV_CARTAO.pessoa_id,
                      operadora,
                      pessoa_tipo,
                      ape.pais_id,
                      cpf_cnpj,
                      ie,
                      cod_mun,
                      endr,
                      num,
                      compl,
                      bairro
        """.format(sql_nf=sql_nf, sql_cupom=sql_cupom)
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

    def get_id_mov_cupom_anterior(self, cr, coo, ecf_id, data):
        sql = """
                SELECT id
                FROM   ecf_cupons_capa
                WHERE  coo = %s - 1
                       AND ecf_id = '%s'
                       AND date_cupom = '%s'
        """ % (coo, ecf_id, data)
        cr.execute(sql)
        dado = cr.dictfetchall()
        return dado

    def sql_consulta_movimento_cupons(self, cr, filtros):
        dt_ini = filtros.get('sped_data_inicial')
        dt_fin = filtros.get('sped_data_final')
        company_id = filtros.get('company_id')
        sql = """
                SELECT id
                FROM   ecf_cupons_capa
                WHERE  date_cupom >= '%s'
                       AND date_cupom <= '%s'
                       AND company_id = %s
                       AND state = 'V'
                       AND tipo_cupom = 'V'
              """ % (dt_ini, dt_fin, company_id)
        cr.execute(sql)
        movimento_cupons = filter(None, map(lambda x: x[0], cr.fetchall()))
        sql_cupons_cancelados = """
                SELECT id,
                       ecf_id,
                       coo,
                       tipo_cupom,
                       date_cupom
                FROM   ecf_cupons_capa
                WHERE  date_cupom >= '%s'
                       AND date_cupom <= '%s'
                       AND company_id = %s
                       AND state = 'V'
                       AND tipo_cupom = 'C'
        """ % (dt_ini, dt_fin, company_id)
        cr.execute(sql_cupons_cancelados)
        movimento_cupons_cancelados = cr.dictfetchall()
        for cupons_cancelados in movimento_cupons_cancelados:
            coo = cupons_cancelados['coo']
            ecf_id = cupons_cancelados['ecf_id']
            data = cupons_cancelados['date_cupom']
            cupom_cancelado_id = self.get_id_mov_cupom_anterior(cr, coo, ecf_id, data)
            if cupom_cancelado_id:
                if cupom_cancelado_id[0].get('id') in movimento_cupons:
                    movimento_cupons.remove(cupom_cancelado_id[0].get('id'))
        return movimento_cupons

    def sql_consulta_mov_modelo_2d(self, cr, filtro):
        data_ini = filtro.get('data_ini')
        data_fin = filtro.get('data_fin')
        sql = """
                SELECT nf_capa.id,
                       nf_capa.modelo_nf_id
                FROM   fiscal_nf_capa nf_capa
                       INNER JOIN fiscal_modelo_nf modelo_nf
                               ON modelo_nf.id = nf_capa.modelo_nf_id
                WHERE  modelo_nf.fismnf_codigo = '02'
                       AND nf_capa.data_emissao AT TIME ZONE 'UTC' >= '%s'
                       AND nf_capa.data_emissao AT TIME ZONE 'UTC' <= '%s'
                       AND nf_capa.tipo = 'S'
                       AND nf_capa.state IN ('3', 'C')
        """ % (data_ini, data_fin)
        cr.execute(sql)
        dados = filter(None, map(lambda x: x[0], cr.fetchall()))
        return dados

    def get_nf_id_c500(self, cr, filtro):
        return map(lambda i: i.get('nf_capa_id'), self.sql_C500(cr, filtro.get('periodo')))

    # Sql do bloco 0
    def sql_reg0150(self, cr, filtro):
        c500_nf_ids = list()
        if filtro.get('movimento_notas'):
            c500_nf_ids = self.get_nf_id_c500(cr, filtro)
        nf_capa_ids = str(list(set(filtro.get('movimento_notas') + c500_nf_ids)))
        company_id = filtro.get('company_id')
        if not company_id:
            company_id = -1
        sql_0150 = """
                   SELECT DISTINCT Cast(pessoa.codigo AS TEXT)
                            || (SELECT Cast(id AS TEXT)
                                FROM   adm_pessoa_endereco
                                WHERE  id = nf_capa.destinatario_endereco_id)            AS
                            cod_part,
                            pessoa.nome                                                  AS
                            nome,
                            (SELECT codigo_bc
                             FROM   adm_pais
                             WHERE  id = (SELECT pais_id
                                          FROM   adm_pessoa_endereco
                                          WHERE  id = nf_capa.destinatario_endereco_id)) AS
                            cod_pais,
                            (SELECT cpf_cnpj
                             FROM   adm_pessoa
                             WHERE  id = nf_capa.destinatario_id
                                    AND pessoa_tipo = 'J')                               AS
                            CNPJ,
                            (SELECT cpf_cnpj
                             FROM   adm_pessoa
                             WHERE  id = nf_capa.destinatario_id
                                    AND pessoa_tipo = 'F')                               AS
                            CPF,
                            CASE 
                                WHEN pessoa.admpes_fis_produtor_rural 
                                AND pessoa.admpes_inscricao_produtor IS NOT NULL 
                                    THEN pessoa.admpes_inscricao_produtor
                                ELSE pessoa.admpes_jur_ie
                            END                                                         AS ie,
                            (SELECT codigo_ibge
                             FROM   adm_cidade
                             WHERE  id = (SELECT cidade_id
                                          FROM   adm_pessoa_endereco
                                          WHERE  id = nf_capa.destinatario_endereco_id)) AS
                            cod_mun,
                            pessoa.admpes_jur_suframa                                           AS
                            suframa,
                            (SELECT descricao
                             FROM   adm_logradouro
                             WHERE  id = (SELECT logradouro_id
                                          FROM   adm_pessoa_endereco
                                          WHERE  id = nf_capa.destinatario_endereco_id)) AS
                            logradouro,
                            (SELECT numero
                             FROM   adm_pessoa_endereco
                             WHERE  id = nf_capa.destinatario_endereco_id)               AS
                            num,
                            (SELECT name
                             FROM   adm_bairro
                             WHERE  id = (SELECT bairro_id
                                          FROM   adm_pessoa_endereco
                                          WHERE  id = nf_capa.destinatario_endereco_id)) AS
                            bairro,
                            pessoa.id AS pessoa_id
                   FROM     fiscal_nf_capa nf_capa
                            LEFT JOIN adm_pessoa pessoa
                                  ON pessoa.id = nf_capa.destinatario_id
                            LEFT JOIN fiscal_modelo_nf modelo
                                  ON modelo.id = nf_capa.modelo_nf_id
                   WHERE    nf_capa.company_id = %s
                   AND nf_capa.id IN %s
                   AND nf_capa.state NOT IN ('I', 'C', 'D')
                   AND modelo.fismnf_codigo NOT IN ('02', '65')
                               """ % (company_id, nf_capa_ids.replace('[', '(').replace(']', ')'))
        cr.execute(sql_0150)
        dados = cr.dictfetchall()
        return dados

    def sql_reg0150_opera_cart(self, cr, dt_ini, dt_fin, opcao, company_id):
        sql_cartao = """
                INNER JOIN ecf_cupons_capa cupom
                    ON cupom.id = cond_pgto.cupom_id
                WHERE  cond_pgto.tipo_finalizadora = 'C'
                    AND data_cupom >= '%s'
                    AND data_cupom <= '%s'
                    AND cupom.company_id = %s
                ORDER BY cond_pgto.pessoa_id

                    """ % (dt_ini, dt_fin, company_id)
        sql_nf = """
                INNER JOIN fiscal_nf_capa nf_capa
                    ON nf_capa.id = cond_pgto.nf_id
                WHERE  cond_pgto.tipo_finalizadora = 'C'
                        AND data_nf >= '%s'
                        AND data_nf <= '%s'
                        AND nf_capa.company_id = %s
                ORDER BY cond_pgto.pessoa_id
                    """ % (dt_ini, dt_fin, company_id)

        if opcao == 'C':
            query = sql_cartao
        else:
            query = sql_nf
        sql = """
                SELECT DISTINCT cond_pgto.pessoa_id                             AS cod_part,
                                pessoa.pessoa_tipo,
                                pessoa.nome                                     AS nome,
                                (SELECT codigo_bc
                                 FROM   adm_pais
                                 WHERE  id = pessoa_endereco.pais_id)           AS cod_pais,
                                pessoa.cpf_cnpj                                 AS cnpj,
                                pessoa.cpf_cnpj                                 AS cpf,
                                pessoa.admpes_jur_ie                                   AS ie,
                                (SELECT codigo_ibge
                                 FROM   adm_cidade
                                 WHERE  id = pessoa_endereco.cidade_id)         AS cod_mun,
                                pessoa.admpes_jur_suframa                              AS suframa,
                                (SELECT descricao
                                 FROM   adm_logradouro
                                 WHERE  id IN( pessoa_endereco.logradouro_id )) AS endr,
                                pessoa_endereco.numero                          AS num,
                                pessoa_endereco.complemento                     AS compl,
                                (SELECT name
                                 FROM   adm_bairro
                                 WHERE  id = pessoa_endereco.bairro_id)         AS bairro
                FROM   fiscal_condicao_pagamento_pgview cond_pgto
                       INNER JOIN adm_pessoa pessoa
                               ON pessoa.id = cond_pgto.pessoa_id
                       LEFT JOIN adm_pessoa_endereco pessoa_endereco
                              ON pessoa_endereco.pessoa_id = cond_pgto.pessoa_id
                       %s
                """ % query
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

    def sql_reg0190(self, cr, filtro, ecf=False):
        inventario_id = filtro.get('inventario_id')
        if inventario_id:
            query_invent = """
                    UNION DISTINCT
                    SELECT DISTINCT produto.estpro_unidade_inventario                    AS unid,
                                    (SELECT name
                                     FROM   estoque_embalagem_unidade
                                     WHERE  unidade = produto.estpro_unidade_inventario) AS descr
                    FROM   estoque_inventario_oficial inv_oficial
                           INNER JOIN estoque_produto produto
                                   ON produto.id = inv_oficial.produto_id
                    WHERE  inv_oficial.capa_id = %s
                    GROUP BY    UNID,
                                DESCR
            """ % inventario_id
        else:
            query_invent = ''
        nf_capa_ids = str(filtro.get('movimento_notas'))
        if filtro.get('movimento_cupons'):
            cupom_capa_ids = str(filtro.get('movimento_cupons'))
        else:
            cupom_capa_ids = False
        if cupom_capa_ids:
            sql_cupom = 'OR cupom_id IN %s' % str(cupom_capa_ids).replace('[', '(').replace(']',
                                                                                            ')')
            sql_cupom_unidade = 'cupom_id IN %s' % str(cupom_capa_ids).replace('[', '(').replace(
                ']', ')')
        else:
            sql_cupom = ''
            sql_cupom_unidade = ''

        sql_0190_unidade_cupom = """
                    UNION DISTINCT
                    SELECT DISTINCT produto.estpro_unidade_inventario                    AS unid,
                                    (SELECT name
                                     FROM   estoque_embalagem_unidade
                                     WHERE  unidade = produto.estpro_unidade_inventario) AS descr
                    FROM   estoque_movimento_itens
                    INNER JOIN estoque_produto produto
                        ON produto.id = estoque_movimento_itens.produto_id
                    LEFT JOIN fiscal_nf_capa AS nf
                        ON nf.id = estoque_movimento_itens.nf_id
                    LEFT JOIN fiscal_modelo_nf AS modelo
                        ON modelo.id = nf.modelo_nf_id
                    WHERE  %(cupom)s
                           AND produto_embalagem_id IS NOT NULL
                           %(ecf)s
        
            """ % dict(cupom=sql_cupom_unidade,
                       ecf=ecf and 'AND item_cancelado IS NOT TRUE' or '--')

        sql_0190 = """
                    SELECT DISTINCT epe.estpre_unidade_produto                           AS unid,
                                    (SELECT name
                                     FROM   estoque_embalagem_unidade
                                     WHERE  unidade = epe.estpre_unidade_produto)        AS descr
                    FROM   estoque_movimento_itens
                    INNER JOIN estoque_produto_embalagem epe
                        ON epe.id = estoque_movimento_itens.produto_embalagem_id
                    LEFT JOIN fiscal_nf_capa AS nf
                        ON nf.id = estoque_movimento_itens.nf_id
                    LEFT JOIN fiscal_modelo_nf AS modelo
                        ON modelo.id = nf.modelo_nf_id
                    WHERE  ((nf_id IN %(capa_ids)s 
                             AND modelo.fismnf_codigo NOT IN ('65')) %(cupom)s)
                               AND produto_embalagem_id IS NOT NULL
                               %(ecf)s
                    %(query_unidade_cupom)s
                    %(inventario)s
                    """ % dict(capa_ids=(str(nf_capa_ids).replace('[', '(').replace(']', ')')),
                               cupom=sql_cupom, inventario=query_invent,
                               ecf=ecf and 'AND item_cancelado IS NOT TRUE' or '--',
                               query_unidade_cupom=cupom_capa_ids and sql_0190_unidade_cupom or '')
        cr.execute(sql_0190)
        dados = cr.dictfetchall()
        return dados

    def sql_reg0200(self, cr, filtro, perfil_sped):
        nf_capa_ids = str(filtro.get('movimento_notas'))
        inventario_capa_id = filtro.get('inventario_id')
        if inventario_capa_id:
            coluna_unidade = 'produto.estpro_unidade_inventario'
            sql_0200_inv = """
            SELECT DISTINCT produto.id                   AS produto_id,
                            grade.id                     AS grade_id,
            CASE WHEN       produto.grade_usar = true THEN
                            produto.codigo || ' ' || grade.grade || ' ' || %s
            ELSE            produto.codigo || ' ' || %s END           AS cod_item,
                            grade.name                   AS descr_item,
                            tipo_item                    AS tipo_item,
                            ncm.codigo                   AS cod_ncm,
                            (SELECT min(id) 
                             FROM automacao_codigo_barra 
                             WHERE active = TRUE 
                                   AND produto_id = produto.id AND grade_id = grade.id)
                                                         AS cod_barra_id,
            CASE WHEN       cest_produto.fiscest_codigo IS NOT NULL THEN
                            cest_produto.fiscest_codigo
                 WHEN       cest_ncm.fiscest_codigo IS NOT NULL THEN
                            cest_ncm.fiscest_codigo
                 ELSE       '' END                       AS cest,
                            codigo_ex_ncm                AS ex_ipi,
                            CASE
                                WHEN produto.tipo = 'S'
                                    THEN '00'
                                WHEN produto.tipo = 'P' AND produto.ncm_id IS NOT NULL
                                    THEN left(ncm.codigo, 2)
                                ELSE ''
                            END                          AS cod_gen,
                            estpro_unidade_inventario    AS unid_inv,
            (SELECT         codigo
               FROM         fiscal_tabela_servico
              WHERE         id = codigo_tab_servicos_id) AS cod_lst
            FROM            estoque_produto              AS produto
            INNER JOIN      estoque_inventario_oficial   AS itens_inv
                    ON      itens_inv.produto_id = produto.id
            INNER JOIN      estoque_produto_grade        AS grade
                    ON      grade.id = itens_inv.grade_id
            LEFT  JOIN      fiscal_ncm                   AS ncm
                    ON      ncm.id = produto.ncm_id
            LEFT  JOIN      fiscal_cest                  AS cest_ncm
                    ON      cest_ncm.id  = ncm.fisnc_cest_id
            LEFT  JOIN      fiscal_cest                  AS cest_produto
                    ON      cest_produto.id = produto.estpro_cest_id
            WHERE           itens_inv.capa_id = %s
            GROUP   BY      produto.id, grade.id, ncm.codigo, cest_produto.fiscest_codigo,
                            cest_ncm.fiscest_codigo
            """ % (coluna_unidade, coluna_unidade, inventario_capa_id)
        else:
            sql_0200_inv = ''
        if filtro.get('movimento_cupons'):
            cupom_capa_ids = str(filtro.get('movimento_cupons'))
        else:
            cupom_capa_ids = False
        if cupom_capa_ids:
            sql_cupom = 'OR (itens.cupom_id IN %s AND itens.item_cancelado = false ' \
                        '    AND itens.nf_id IS NULL)' % str(cupom_capa_ids).replace('[', '(').\
                replace(']', ')')
        else:
            sql_cupom = ''
        coluna_unidade = 'produto_embalagem.estpre_unidade_produto'
        sql_0200 = """
        SELECT DISTINCT produto.id                    AS produto_id,
                        grade.id                      AS grade_id,
        CASE WHEN       produto.grade_usar = TRUE THEN
                        produto.codigo || ' ' || grade.grade || ' ' || %s
        ELSE            produto.codigo || ' ' || %s
        END                                           AS cod_item,
                        grade.name                    AS descr_item,
                        tipo_item                     AS tipo_item,
                        ncm.codigo                    AS cod_ncm,
                        (SELECT min(id) 
                         FROM automacao_codigo_barra 
                         WHERE active = TRUE 
                               AND produto_id = produto.id AND grade_id = grade.id)
                                                      AS cod_barra_id,
        CASE WHEN       cest_produto.fiscest_codigo IS NOT NULL THEN
                                  cest_produto.fiscest_codigo
                             WHEN cest_ncm.fiscest_codigo IS NOT NULL THEN
                                  cest_ncm.fiscest_codigo
                             ELSE '' END              AS cest,
                        codigo_ex_ncm                 AS ex_ipi,
                        CASE
                            WHEN produto.tipo = 'S'
                                THEN '00'
                            WHEN produto.tipo = 'P' AND produto.ncm_id IS NOT NULL
                                THEN left(ncm.codigo, 2)
                            ELSE ''
                        END                           AS cod_gen,
                        %s 
                                                      AS unid_inv,
        (SELECT         codigo
           FROM         fiscal_tabela_servico
          WHERE         id = codigo_tab_servicos_id)  AS cod_lst
        FROM            estoque_produto               AS produto
        INNER JOIN      estoque_movimento_itens       AS itens
                ON      itens.produto_id = produto.id
        INNER JOIN      estoque_produto_grade         AS grade
                ON      grade.id = itens.grade_id
        INNER JOIN      estoque_produto_embalagem     AS produto_embalagem
                ON      itens.produto_embalagem_id = produto_embalagem.id
        LEFT  JOIN      fiscal_cfop                   AS cfop
                ON      cfop.id = itens.cfop_id
        LEFT  JOIN      fiscal_ncm                    AS ncm
                ON      ncm.id = produto.ncm_id
        LEFT  JOIN      fiscal_cest                   AS cest_ncm
                ON      cest_ncm.id  = ncm.fisnc_cest_id
        LEFT  JOIN      fiscal_cest                   AS cest_produto
                ON      cest_produto.id = produto.estpro_cest_id
        LEFT  JOIN      fiscal_nf_capa                AS nf
                ON      nf.id = itens.nf_id
        LEFT  JOIN      fiscal_modelo_nf              AS modelo
                ON      modelo.id = nf.modelo_nf_id
        WHERE           itens.nf_id IN %s
          AND           cfop.produto_servico_tipo IN ('P', 'L', 'S')
          AND           cfop.codigo NOT IN ('5929', '6929')
          AND           modelo.fismnf_codigo NOT IN ('29', '65')
           %s
        GROUP BY produto.id, grade.id, itens.produto_embalagem_id, produto_embalagem.id, ncm.codigo,
                 cest_produto.fiscest_codigo, cest_ncm.fiscest_codigo
        HAVING produto.tipo = 'P'
        """ % (coluna_unidade, coluna_unidade, coluna_unidade,
               (str(nf_capa_ids).replace('[', '(').replace(']', ')')), sql_cupom)
        if perfil_sped == 'C':
            if inventario_capa_id:
                sql_0200 = sql_0200_inv
            else:
                return []
        if inventario_capa_id:
            sql_0200 += ' UNION ALL ' + sql_0200_inv
        cr.execute(sql_0200.format(dt_ini=self.data_inicio, dt_fim=self.data_fim))
        dados = cr.dictfetchall()
        return dados

    def sql_reg0205(self, cr, produto_id, sped_data_inicial, sped_data_final):
        """
        Este registro tem por objetivo informar alterações ocorridas na descrição do produto,
        desde que não o descaracterize ou haja modificação que o identifique como sendo novo
        produto, caso não tenha ocorrido movimentação no período da alteração do item, deverá ser
        informada no primeiro período em que houver movimentação do item. Deverá ser ainda informado
        quando ocorrer alteração na codificação do produto. Não podem ser informados dois ou mais
        registros com sobreposição de períodos.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param produto_id: id da tabela estoque_produto, identificador do produto.
        :type produto_id: int
        :param sped_data_inicial: data inicial do periodo de apuracao do SPED.
        :type sped_data_inicial: str
        :param sped_data_final: data final do periodo de apuracao do SPED.
        :type sped_data_final: str
        :return: conjunto de dados da tabela estoque_produto_descricao_anterior
        :rtype: list
        """
        sql_0205 = """
            SELECT
                esteda_descricao_anterior AS descr_ant_item,
                esteda_data_inicio        AS dt_ini,
                esteda_data_fim           AS dt_fim
            FROM
                estoque_produto_descricao_anterior
            WHERE
                esteda_produto_id = %s
                AND esteda_data_fim > '%s'
                AND esteda_data_fim < '%s'
            ORDER BY esteda_data_fim DESC 
            LIMIT 1
        """ % (produto_id, sped_data_inicial, sped_data_final)
        cr.execute(sql_0205)
        dados = cr.dictfetchall()
        return dados[0] if dados else {}

    def sql_reg0400(self, cr, filtro):
        """
        Este registro tem por objetivo codificar os textos das diferentes naturezas da 
        operacao/prestacao discriminadas nos documentos fiscais. Esta codificacao e suas descricoes 
        sao livremente criadas e mantidas pelo contribuinte.
        Este registro nao se refere a CFOP. Algumas empresas utilizam outra classificacao alem das 
        apresentadas nos CFOP. Esta codificacao permite informar estes agrupamentos proprios.
        Nao podem ser informados dois ou mais registros com o mesmo conteudo no campo COD_NAT.
        """
        nf_capa_ids = filtro.get('movimento_notas')
        mov_modelo_01_ids = filtro.get('mov_modelo_01_ids')
        if mov_modelo_01_ids:
            query_mod_01 = "OR (id IN %s AND COALESCE(finalidade_emissao, '') != '2' AND " \
                           "state = '3')" % str(
                mov_modelo_01_ids).replace('[', '(').replace(']', ')')
        else:
            query_mod_01 = ''
        sql_0400 = """
                    SELECT id   AS cod_nat,
                           NAME AS descr_nat
                    FROM   fiscal_cfop_natureza
                    WHERE  id IN (SELECT natureza_id
                                  FROM   fiscal_nf_capa
                                  WHERE  id IN %s
                                  AND nf_propria = false
                                  AND modelo_nf_id IN
                                      (SELECT id
                                       FROM fiscal_modelo_nf
                                       WHERE fismnf_codigo IN ('01', '1B', '04', '55'))
                                  %s)
                           AND cfop_id NOT IN (SELECT id
                                               FROM   fiscal_cfop
                                               WHERE  produto_servico_tipo IN ('E', 'M'))
                    """ % (str(nf_capa_ids).replace('[', '(').replace(']', ')'), query_mod_01)
        cr.execute(sql_0400)
        dados = cr.dictfetchall()
        return dados

    def sql_reg0450(self, cr, filtro):
        """
        REGISTRO 0450: TABELA DOCUMENTO FISCAL DE INFORMACAO COMPLEMENTAR DO DOCUMENTO FISCAL
        Este registro tem por objetivo codificar todas as informacoes complementares dos documentos 
        fiscais exigidas pela legislacao fiscal. Estas informacoes constam no campo “Dados 
        Adicionais” dos documentos fiscais.
        Esta codificacao e suas descricoes sao livremente criadas e mantidas pelo contribuinte e 
        nao podem ser informados dois ou mais registros com o mesmo conteudo no campo COD_INF.
        Deverao constar todas as informacoes complementares de interesse do fisco existentes nos 
        documentos fiscais.
        Exemplo: nos casos de documentos fiscais de entradas de devolucao, informar o documento 
        fiscal referenciado.
        """
        nf_capa_ids = str(filtro.get('movimento_notas'))
        sql_0450 = """
                    SELECT right(id::varchar, 6)       AS cod_inf,
                           fisnfc_infcomp_contribuinte AS txt
                    FROM   fiscal_nf_capa
                    WHERE  fisnfc_infcomp_contribuinte IS NOT NULL
                           AND id IN %s
                           AND state NOT IN ('C', 'D', 'I')
                           AND fisnfc_consumidor IS NOT TRUE
                    """ % (str(nf_capa_ids).replace('[', '(').replace(']', ')'))
        cr.execute(sql_0450)
        dados = cr.dictfetchall()
        return dados

    @staticmethod
    def sql_reg0460(cr, filtro):
        """
        REGISTRO 0460: TABELA DE OBSERVACOES DO LANCAMENTO FISCAL
        Este registro eh utilizado para informar anotacoes de escrituracao determinadas pela 
        legislacao pertinente aos lancamentos fiscais, tais como: ajustes efetuados por diferimento 
        parcial de imposto, antecipacoes, diferencial de aliquota e outros.
        Esta codificacao e suas descricoes sao de atribuicao do contribuinte e nao podem ser 
        informados dois ou mais registros com o mesmo conteudo no campo COD_OBS.
        """
        nf_capa_ids = str(filtro.get('movimento_notas'))
        sql_0460 = """
                    SELECT right(id::varchar, 6)    AS cod_obs,
                           fisnfc_infcomp_fisco     AS txt
                    FROM   fiscal_nf_capa
                    WHERE  fisnfc_infcomp_fisco IS NOT NULL
                           AND fisnfc_infcomp_fisco <> ''
                           AND id IN %s
                           AND state = '3'
                    """ % (str(nf_capa_ids).replace('[', '(').replace(']', ')'))
        cr.execute(sql_0460)
        dados = cr.dictfetchall()
        return dados

    # Sql do bloco C
    def sql_regC100(self, cr, filtro):
        nf_capa_ids = str(filtro.get('movimento_notas'))
        tipo_empresa = filtro.get('tipo_empresa')
        if tipo_empresa == 'I':
            query = """
                    sum(
                        CASE
                            WHEN nf_capa.nf_propria IS FALSE
                                AND destinatario.admpes_jur_regime_tributario = 'S'
                                AND pessoa_empresa.admpes_jur_regime_tributario = 'R'
                                AND cst.tipo = 'T'
                                AND tributacao.vr_encargo > 0
                            THEN 0.00
                            ELSE
                                (SELECT vr_base_calculo
                                FROM fiscal_nf_item_tributacao trib
                                INNER JOIN fiscal_cst cst ON tributacao.cst_id = cst.id
                                WHERE trib.encargo_id =
                                   (SELECT id
                                    FROM fiscal_encargo
                                    WHERE sigla='ICMS')
                                 AND trib.id = tributacao.id
                                 AND cst.codigo NOT in('10', '30', '40', '41', '51', '60', '70', 
                                                       '90'))
                        END) AS VL_BC_ICMS,
                    sum(
                        CASE
                            WHEN nf_capa.nf_propria IS FALSE
                                AND destinatario.admpes_jur_regime_tributario = 'S'
                                AND pessoa_empresa.admpes_jur_regime_tributario = 'R'
                                AND cst.tipo = 'T'
                                AND tributacao.vr_encargo > 0
                            THEN 0.00
                            ELSE
                                (SELECT vr_encargo
                                FROM fiscal_nf_item_tributacao trib
                                INNER JOIN fiscal_cst cst ON trib.cst_id = cst.id
                                WHERE trib.encargo_id =
                                   (SELECT id
                                    FROM fiscal_encargo
                                    WHERE sigla='ICMS')
                                 AND trib.id = tributacao.id
                                 AND cst.codigo NOT in('10', '30', '40', '41', '51', '60', '70', 
                                                       '90'))
                        END) AS VL_ICMS,

                    """
        else:
            query = """
                    sum(
                        CASE
                            WHEN nf_capa.nf_propria IS FALSE
                                AND destinatario.admpes_jur_regime_tributario = 'S'
                                AND pessoa_empresa.admpes_jur_regime_tributario = 'R'
                                AND cst.tipo = 'T'
                                AND tributacao.vr_encargo > 0
                            THEN 0.00
                            ELSE
                                (SELECT vr_base_calculo
                                FROM fiscal_nf_item_tributacao trib
                                INNER JOIN fiscal_cst cst ON tributacao.cst_id = cst.id
                                WHERE trib.encargo_id =
                                   (SELECT id
                                    FROM fiscal_encargo
                                    WHERE sigla='ICMS')
                                 AND cst.codigo NOT IN ('10', '30', '40', '41', '51', '60', '70', 
                                                        '90')
                                 AND trib.id = tributacao.id)
                        END) AS VL_BC_ICMS,
                    sum(
                        CASE
                            WHEN nf_capa.nf_propria IS FALSE
                                AND destinatario.admpes_jur_regime_tributario = 'S'
                                AND pessoa_empresa.admpes_jur_regime_tributario = 'R'
                                AND cst.tipo = 'T'
                                AND tributacao.vr_encargo > 0
                            THEN 0.00
                            ELSE
                                (SELECT vr_encargo
                                FROM fiscal_nf_item_tributacao trib
                                INNER JOIN fiscal_cst cst ON tributacao.cst_id = cst.id
                                                       WHERE trib.encargo_id =
                                                           (SELECT id
                                                            FROM fiscal_encargo
                                                            WHERE sigla='ICMS')
                                AND cst.codigo NOT in('10', '30', '40', '41', '51', '60', '70', 
                                                      '90')
                                                         AND trib.id = tributacao.id)
                        END) AS VL_ICMS,
                """
        sql_C100 = """
                    SELECT DISTINCT nf_capa.id AS id ,
                                    (Select codigo from fiscal_cfop
                                      where id = (Select cfop_id from fiscal_cfop_natureza
                                      where id = nf_capa.natureza_id)) AS cfop,
                                    CASE
                                        WHEN nf_capa.tipo = 'S' THEN '1'
                                        WHEN nf_capa.tipo = 'E' THEN '0'
                                    END AS IND_OPER,
                                    CASE
                                        WHEN nf_capa.state = '3' AND (
                                            SELECT codigo
                                            FROM fiscal_cfop
                                            WHERE
                                                id IN (SELECT cfop_id
                                                       FROM fiscal_cfop_natureza
                                                       WHERE
                                                           id = nf_capa.natureza_id))
                                            IN ('5929', '6929')
                                                THEN '08'
                                        WHEN nf_capa.state = '3' AND fcn.fisnat_complemento_arroz 
                                            IS TRUE THEN '08'
                                        WHEN nf_capa.state = '3' AND nf_capa.nfe_processo_emissao 
                                            IN ('0', '3') THEN '00'
                                        WHEN nf_capa.state = 'C' THEN '02'
                                        WHEN nf_capa.state = '3' AND nf_capa.nfe_processo_emissao 
                                            IN ('1', '2') THEN '08'
                                    END AS COD_SIT,
                                    CASE
                                        WHEN nf_capa.nf_propria = TRUE THEN '0'
                                        WHEN nf_capa.nf_propria = FALSE THEN '1'
                                    END AS IND_EMIT,
                                    serie_nf AS SER,
                                    numero_nf AS NUM_DOC,
                                    nfe_chave_acesso AS CHV_NFE,
                                    nf_capa.tipo,
                      CASE 
                          WHEN fmn.fismnf_codigo = '65' THEN ''
                          ELSE
                              (SELECT CAST (codigo AS text) ||
                                 (SELECT CAST(id AS text)
                                  FROM adm_pessoa_endereco
                                  WHERE id = nf_capa.destinatario_endereco_id)
                               FROM adm_pessoa
                               WHERE id = nf_capa.destinatario_id)
                      END AS COD_PART,

                      (SELECT cpf_cnpj
                       FROM adm_pessoa
                       WHERE id = nf_capa.destinatario_id) AS CNPJ_CPF_PART,

                      (SELECT fismnf_codigo
                       FROM fiscal_modelo_nf
                       WHERE id = nf_capa.modelo_nf_id) AS COD_MOD,
                                    data_emissao AT TIME ZONE 'UTC' AS DT_DOC,
                                    CASE 
                                        WHEN nf_capa.tipo = 'S' 
                                            AND data_emissao != data_saida_entrada 
                                            THEN data_emissao AT TIME ZONE 'UTC'
                                        ELSE
                                            data_saida_entrada AT TIME ZONE 'UTC' 
                                    END AS DT_E_S,
                                    vr_total_nf AS VL_DOC,
                                    COALESCE(vr_total_produtos, 0.0) +
                                        COALESCE(vr_total_servicos, 0.0) +
                                        COALESCE(fisnfc_valor_fcp_st, 0.0) +
                                        CASE 
                                            WHEN NOT nf_capa.nf_propria THEN
                                                (SELECT sum(COALESCE(vr_desconto, 0))
                                                 FROM estoque_movimento_itens
                                                 WHERE nf_id = nf_capa.id)
                                            ELSE 0
                                        END
                                        AS VL_MERC ,
                                    vr_desconto AS VL_DESC,
                                    fisnfc_valor_icms_desonerado AS VL_ABAT_NT,
                                    frete AS IND_FRT,
                                    CASE
                                        WHEN nf_capa.tipo_frete = 'F'
                                            THEN 0
                                        ELSE vr_frete
                                    END AS VL_FRT,
                                    vr_seguro AS VL_SEG,
                                    nf_propria ,
                                    vr_despesas_acessorias +
                                     sum(CASE
                                            WHEN nf_capa.nf_propria IS FALSE
                                                AND destinatario.admpes_jur_regime_tributario = 'S'
                                                AND pessoa_empresa.admpes_jur_regime_tributario = 'R'
                                                AND cst.tipo = 'T'
                                                AND tributacao.vr_encargo > 0
                                                AND encargo.sigla = 'ICMS'
                                            THEN COALESCE(tributacao.vr_base_calculo, 0.0)
                                            ELSE 0.0
                                         END) AS VL_OUT_DA,
                                    %s --query referente a dados de vl_icms vl_bc_icms
                                    sum(
                                          CASE 
                                              WHEN fmn.fismnf_codigo = '65' THEN 0.00
                                              ELSE 
                                                  (SELECT vr_base_icms_substituicao
                                                   FROM fiscal_nf_item_tributacao
                                                   WHERE tipo_substituicao = TRUE
                                                     AND encargo_id =
                                                       (SELECT id
                                                        FROM fiscal_encargo
                                                        WHERE sigla='ICMS')
                                                     AND id = tributacao.id) 
                                          END) AS VL_BC_ICMS_ST,
                                    sum(
                                          CASE 
                                              WHEN fmn.fismnf_codigo = '65' THEN 0.00
                                              ELSE
                                                  (SELECT vr_icms_substituicao
                                                   FROM fiscal_nf_item_tributacao
                                                   WHERE tipo_substituicao = TRUE
                                                     AND encargo_id =
                                                       (SELECT id
                                                        FROM fiscal_encargo
                                                        WHERE sigla='ICMS')
                                                     AND id = tributacao.id) 
                                          END) AS VL_ICMS_ST,
                                    sum(
                                          CASE 
                                              WHEN fmn.fismnf_codigo = '65' THEN 0.00
                                              ELSE
                                                  (SELECT vr_encargo
                                                   FROM fiscal_nf_item_tributacao
                                                   WHERE encargo_id =
                                                       (SELECT id
                                                        FROM fiscal_encargo
                                                        WHERE sigla='IPI')
                                                     AND id = tributacao.id)
                                          END) AS VL_IPI ,
                                    sum(
                                          CASE 
                                              WHEN fmn.fismnf_codigo = '65' THEN 0.00
                                              ELSE
                                                  (SELECT vr_encargo
                                                   FROM fiscal_nf_item_tributacao
                                                   WHERE encargo_id =
                                                       (SELECT id
                                                        FROM fiscal_encargo
                                                        WHERE sigla='PIS')
                                                     AND id = tributacao.id)
                                          END) AS VL_PIS ,
                                    sum(
                                          CASE 
                                              WHEN fmn.fismnf_codigo = '65' THEN 0.00
                                              ELSE
                                                  (SELECT vr_encargo
                                                   FROM fiscal_nf_item_tributacao
                                                   WHERE encargo_id =
                                                       (SELECT id
                                                        FROM fiscal_encargo
                                                        WHERE sigla='COFINS')
                                                     AND id = tributacao.id)
                                          END) AS VL_COFINS ,
                                    sum(
                                          CASE 
                                              WHEN fmn.fismnf_codigo = '65' THEN 0.00
                                              ELSE  
                                                  (SELECT vr_encargo
                                                   FROM fiscal_nf_item_tributacao
                                                   WHERE tipo_substituicao = TRUE
                                                     AND encargo_id =
                                                       (SELECT id
                                                        FROM fiscal_encargo
                                                        WHERE sigla='PIS')
                                                     AND id = tributacao.id)
                                          END) AS VL_PIS_ST,
                                    sum(
                                          CASE 
                                              WHEN fmn.fismnf_codigo = '65' THEN 0.00
                                              ELSE
                                                  (SELECT vr_encargo
                                                   FROM fiscal_nf_item_tributacao
                                                   WHERE tipo_substituicao = TRUE
                                                     AND encargo_id =
                                                       (SELECT id
                                                        FROM fiscal_encargo
                                                        WHERE sigla='COFINS')
                                                     AND id = tributacao.id)
                                          END) AS VL_COFINS_ST,
                                    --Verificando condicoes de pagamentos

                                    CASE
                                        WHEN
                                               (SELECT tipo
                                                FROM adm_condicao
                                                WHERE id =
                                                    (SELECT adm_condicao_id
                                                     FROM adm_condicao_forma
                                                     WHERE id IN
                                                         (SELECT condicao_forma_id
                                                          FROM fiscal_condicao_pagamento
                                                          WHERE capa_id = nf_capa.id)LIMIT 1)) IN ('C',
                                                                                                   'P') THEN '1'
                                        WHEN
                                               (SELECT tipo
                                                FROM adm_condicao
                                                WHERE id =
                                                    (SELECT adm_condicao_id
                                                     FROM adm_condicao_forma
                                                     WHERE id IN
                                                         (SELECT condicao_forma_id
                                                          FROM fiscal_condicao_pagamento
                                                          WHERE capa_id = nf_capa.id)LIMIT 1)) IN ('V') THEN '0'
                                        WHEN nf_capa.nf_propria = FALSE
                                             AND COALESCE(nf_capa.prazo, '0') = '0' THEN '0'
                                        WHEN nf_capa.nf_propria = FALSE
                                             AND nf_capa.prazo <> '0' THEN '1'
                                        ELSE '2'
                                    END AS IND_PGTO,
                                    fisnfc_infcomp_contribuinte AS txt,
                                    nf_capa.finalidade_emissao AS finalidade_emissao
                    FROM fiscal_nf_capa nf_capa
                    LEFT JOIN fiscal_nf_item_tributacao tributacao
                           ON tributacao.fisnit_capa_id = nf_capa.id
                    LEFT JOIN fiscal_encargo encargo
                           ON encargo.id = tributacao.encargo_id
                    LEFT JOIN fiscal_cst cst
                           ON cst.id = tributacao.cst_id
                    LEFT JOIN adm_pessoa destinatario
                           ON nf_capa.destinatario_id = destinatario.id
                    LEFT JOIN res_company empresa
                           ON empresa.id = nf_capa.company_id
                    LEFT JOIN adm_pessoa pessoa_empresa
                           ON empresa.rescon_pessoa_id = pessoa_empresa.id
                    LEFT JOIN fiscal_modelo_nf fmn
                           ON fmn.id = nf_capa.modelo_nf_id
                    LEFT JOIN fiscal_cfop_natureza fcn
                           ON fcn.id = nf_capa.natureza_id 
                    WHERE nf_capa.id IN %s
                      AND fmn.fismnf_codigo IN ('01', '1B', '04', '55', '65')
                    GROUP BY nf_capa.id,
                             nf_capa.tipo,
                             nf_capa.state,
                             nf_capa.serie_nf,
                             nf_capa.numero_nf,
                             nf_capa.destinatario_id,
                             nf_capa.data_emissao,
                             nf_capa.data_saida_entrada,
                             nf_capa.vr_total_produtos,
                             nf_capa.vr_total_servicos,
                             nf_capa.vr_desconto,
                             fmn.fismnf_codigo,
                             fcn.id
                     """ % (query, str(nf_capa_ids).replace('[', '(').replace(']', ')'))
        cr.execute(sql_C100)
        dados = cr.dictfetchall()

        return dados

    def sql_reg_C100_descontos(self, cr, filtro):
        nf_ids = filtro
        sql_descontos_C100 = """
                                SELECT nf_id AS nf_id,
                                       SUM(COALESCE(vr_desconto, 0)) +
                                       SUM(COALESCE(vr_desconto_rateado, 0)) AS desc_item
                                FROM estoque_movimento_itens
                                WHERE nf_id IN ({nf_ids})
                                GROUP BY nf_id
                             """.format(nf_ids=', '.join(map(lambda n: str(n), nf_ids)))
        cr.execute(sql_descontos_C100)
        dados = cr.dictfetchall()
        dados_c100_descontos = {}
        map(lambda c: dados_c100_descontos.update({c.get('nf_id'): c.get('desc_item') or 0}), dados)
        return dados_c100_descontos

    def sql_regC140(self, cr, filtro):
        nf_ids = filtro
        sql_C140 = """
                    --C140 - FATURAMENTO E TITULOS
                    SELECT nf_capa.id AS nf_id,
                           fatura.id AS fatura_id,
                           CASE
                               WHEN nf_capa.nf_propria = TRUE THEN '0'
                               WHEN nf_capa.nf_propria = FALSE THEN '1'
                           END AS ind_emit,
                           fatura.documento AS num_tit,

                      (SELECT count(1)
                       FROM financeiro_titulo
                       WHERE fatura_id = fatura.id) AS qtd_parc,
                           sum(financeiro.vr_original) AS vl_tit,
                           CASE
                               WHEN
                                      (SELECT sigla
                                       FROM documento_documento_tipo
                                       WHERE id = financeiro.doc_tipo_id) = 'DP' THEN '00'
                               WHEN
                                      (SELECT sigla
                                       FROM documento_documento_tipo
                                       WHERE id = financeiro.doc_tipo_id) = 'CHQ' THEN '01'
                               WHEN
                                      (SELECT sigla
                                       FROM documento_documento_tipo
                                       WHERE id = financeiro.doc_tipo_id) = 'PRO' THEN '02'
                               WHEN
                                      (SELECT sigla
                                       FROM documento_documento_tipo
                                       WHERE id = financeiro.doc_tipo_id) = 'REC' THEN '03'
                               ELSE '99'
                           END AS ind_tit,
                           CASE
                               WHEN
                                      (SELECT sigla
                                       FROM documento_documento_tipo
                                       WHERE id = financeiro.doc_tipo_id) NOT IN ('DP',
                                                                                  'CHQ',
                                                                                  'PRO',
                                                                                  'REC') THEN
                                      (SELECT descricao
                                       FROM documento_documento_tipo
                                       WHERE id = financeiro.doc_tipo_id)
                           END AS desc_tit
                    FROM financeiro_fatura fatura
                    LEFT JOIN fiscal_nf_capa AS nf_capa ON nf_capa.id = fatura.nf_id
                    LEFT JOIN financeiro_titulo AS financeiro ON financeiro.fatura_id = fatura.id
                    WHERE nf_capa.id IN ({nf_ids})
                    AND
                              CASE
                                        WHEN nf_capa.tipo = 'S' THEN financeiro.tipo_titulo = 'R'
                                        ELSE financeiro.tipo_titulo = 'R'
                              END
                    GROUP BY nf_capa.id,
                             fatura.id,
                             fatura.documento,
                             nf_capa.nf_propria,
                             financeiro.doc_tipo_id
                            """.format(nf_ids=', '.join(map(lambda n: str(n), nf_ids)))
        cr.execute(sql_C140)
        dados = cr.dictfetchall()
        dados_c140 = {}
        map(lambda c: dados_c140.update({c.get('nf_id'): c}), dados)
        return dados_c140

    def sql_regC101(self, cr, nf_ids):
        sql = """
                SELECT fisnit.fisnit_capa_id                        AS nf_id,
                       uf.sigla                                     AS uf,
                       Sum(COALESCE(fisnit_vr_difal_uf_origem, 0))  AS vl_icms_uf_rem,
                       Sum(COALESCE(fisnit_vr_difal_uf_destino, 0)) AS vl_icms_uf_dest
                FROM   fiscal_nf_item_tributacao fisnit
                       INNER JOIN fiscal_encargo fe
                               ON fisnit.encargo_id = fe.id
                       INNER JOIN fiscal_nf_capa fisnfc
                               ON fisnit.fisnit_capa_id = fisnfc.id
                       INNER JOIN adm_pessoa_endereco admpesend
                               ON admpesend.id = fisnfc.destinatario_endereco_id
                       INNER JOIN adm_uf uf
                               ON uf.id = admpesend.uf_id
                WHERE  fisnit_capa_id IN ({nf_ids})
                       AND fe.sigla = 'ICMS'
                GROUP  BY fisnit.fisnit_capa_id, uf.sigla
        """.format(nf_ids=', '.join(map(lambda n: str(n), nf_ids)))
        cr.execute(sql)
        dados = cr.dictfetchall()
        dados_c101 = {}
        map(lambda c: dados_c101.update({c.get('nf_id'): c}), dados)
        return dados_c101

    def sql_regC113(self, cr, nf_ids):
        sql_C113 = """
            SELECT 
                DISTINCT nf_capa.id                                     AS id,
                CASE
                    WHEN nf_capa.tipo = 'S' THEN '1'
                    WHEN nf_capa.tipo = 'E' THEN '0'
                END                                                     AS IND_OPER,
                CASE
                    WHEN nf_capa.nf_propria = TRUE THEN '0'
                    WHEN nf_capa.nf_propria = FALSE THEN '1'
                END                                                     AS IND_EMIT,
                serie_nf                                                AS SER,
                numero_nf                                               AS NUM_DOC,
                nfe_chave_acesso                                        AS CHV_DOCe,
                (SELECT CAST (codigo AS text) ||
                    (SELECT CAST(id AS text)
                    FROM adm_pessoa_endereco
                    WHERE id = nf_capa.destinatario_endereco_id)
                    FROM adm_pessoa
                    WHERE id = nf_capa.destinatario_id)                 AS COD_PART,
                (SELECT fismnf_codigo
                FROM fiscal_modelo_nf
                WHERE id = nf_capa.modelo_nf_id)                        AS COD_MOD,
                data_emissao AT TIME ZONE 'UTC'                         AS DT_DOC
            FROM fiscal_nf_capa nf_capa
            LEFT JOIN fiscal_nf_item_tributacao tributacao
                   ON tributacao.fisnit_capa_id = nf_capa.id
            LEFT JOIN fiscal_encargo encargo
                   ON encargo.id = tributacao.encargo_id
            LEFT JOIN fiscal_cst cst
                   ON cst.id = tributacao.cst_id
            LEFT JOIN adm_pessoa destinatario
                   ON nf_capa.destinatario_id = destinatario.id
            LEFT JOIN res_company empresa
                   ON empresa.id = nf_capa.company_id
            LEFT JOIN adm_pessoa pessoa_empresa
                   ON empresa.rescon_pessoa_id = pessoa_empresa.id
            WHERE nf_capa.id IN (SELECT nf_ref_id AS id 
                                 FROM fiscal_nf_referencia 
                                 WHERE id IN ({nf_ids}))
                AND nf_capa.data_emissao <= (SELECT data_emissao 
                                             FROM fiscal_nf_capa 
                                             WHERE id = nf_capa.id)
                AND nf_capa.fisnfc_tipo_servico = FALSE
                AND nf_capa.modelo_nf_id IN
                    (SELECT id
                     FROM fiscal_modelo_nf
                     WHERE fismnf_codigo IN ('01', '1B', '04', '55'))
            GROUP BY nf_capa.id,
                     nf_capa.tipo,
                     nf_capa.numero_nf,
                     nf_capa.data_emissao
        """.format(nf_ids=', '.join(map(lambda n: str(n), nf_ids)))
        cr.execute(sql_C113)
        dados = cr.dictfetchall()
        dados_c113 = {}
        for dado in dados:
            nf_id = dado.get('id')
            if nf_id in dados_c113:
                dados_c113[nf_id].append(dado)
            else:
                dados_c113[nf_id] = [dado]
        return dados_c113

    def sql_regC141(self, cr, filtro):
        fatura_ids = filtro
        sql_C141 = """
                    SELECT fatura_id AS fatura_id,
                           parcela AS num_parc,
                           data_vencimento AS dt_vcto,
                           vr_original AS vl_parc
                    FROM financeiro_titulo
                    WHERE fatura_id IN ({fatura_ids})
                    """.format(fatura_ids=', '.join(map(lambda f: str(f), fatura_ids)))
        cr.execute(sql_C141)
        dados = cr.dictfetchall()
        dados_c141 = {}
        for dado in dados:
            fatura_id = dado.get('fatura_id')
            if fatura_id in dados_c141:
                dados_c141[fatura_id].append(dado)
            else:
                dados_c141[fatura_id] = [dado]
        return dados_c141

    def sql_regC170(self, cr, filtro):
        nf_ids = filtro
        sql_C170 = """
            SELECT DISTINCT Row_number()
                OVER (ORDER BY movimento_item.id) AS num_item,
                movimento_item.nf_id AS nf_id,
                CASE WHEN produto.grade_usar = true
                     THEN produto.codigo || ' ' || grade.grade || ' ' || {coluna_unidade}
                     ELSE produto.codigo || ' ' || {coluna_unidade}
                END AS cod_item,
                (SELECT name
                 FROM   estoque_produto_grade
                 WHERE  id = movimento_item.grade_id) AS DESCR_COMPL,
                quantidade AS QTD,
                movimento_item.sequencia AS sequencia,
                epe.estpre_unidade_produto AS unid,
                (SELECT codigo
                 FROM   fiscal_cfop
                 WHERE  id = cfop_id) AS cfop,
                (SELECT  natureza_id
                 FROM fiscal_nf_capa
                 WHERE id = movimento_item.nf_id) AS COD_NAT,
                vr_total_item_rateado
                    + vr_desconto_rateado
                    - vr_despesas_rateado
                    - CASE 
                        WHEN (
                            SELECT tipo_frete FROM fiscal_nf_capa 
                            WHERE id = movimento_item.nf_id
                            ) = 'F' THEN 0 
                        ELSE vr_frete_rateado 
                        END
                    + vr_desconto +
                    (SELECT sum(COALESCE(fisnit_vr_fcp_st, 0.0))
                    FROM   fiscal_nf_item_tributacao
                    WHERE  movimento_itens_id = movimento_item.id) + 
                    CASE WHEN (SELECT admpes_jur_tipo_atividade 
                               FROM adm_pessoa WHERE id IN (
                                   SELECT rescon_pessoa_id 
                                   FROM res_company 
                                   WHERE id IN (
                                       SELECT company_id 
                                       FROM fiscal_nf_capa 
                                       WHERE id = movimento_item.nf_id))) != 'I' THEN
                            COALESCE(
                                (SELECT SUM(vr_encargo)
                                 FROM   fiscal_nf_item_tributacao fnit
                                 LEFT JOIN fiscal_cst             fc
                                        ON fc.id = fnit.cst_id
                                 WHERE  fnit.encargo_id = (
                                        SELECT id
                                        FROM   fiscal_encargo
                                        WHERE  sigla = 'IPI')
                                   AND  movimento_itens_id = movimento_item.id
                                ), 0)                         
                        ELSE 0.0
                    END AS VL_ITEM,
                (SELECT 
                    sum(COALESCE(fisnit_vr_icms_desonerado, 0)) 
                 FROM fiscal_nf_item_tributacao 
                 WHERE movimento_itens_id = movimento_item.id) AS vl_abat_nt,
                COALESCE(vr_desconto, 0) + COALESCE(vr_desconto_rateado, 0) AS vl_desc,
                (SELECT codigo
                 FROM   fiscal_ncm
                 WHERE  id = (SELECT ncm_id
                              FROM   estoque_produto
                              WHERE  id = movimento_item.produto_id)) AS cod_ncm,
                (SELECT codigo_ex_ncm
                 FROM   estoque_produto
                 WHERE  id = movimento_item.produto_id) AS ex_ipi,
                --Informacoes ICMS
                (SELECT codigo
                 FROM   fiscal_cst
                 WHERE  id = (SELECT cst_id
                              FROM   fiscal_nf_item_tributacao
                              WHERE  encargo_id = (SELECT id
                                                   FROM   fiscal_encargo
                                                   WHERE  sigla = 'ICMS')
                                AND movimento_itens_id = movimento_item.id))AS CST_ICMS,
                Sum((SELECT
                        CASE
                            WHEN nf_capa.nf_propria IS FALSE
                                AND destinatario.admpes_jur_regime_tributario = 'S'
                                AND pessoa_empresa.admpes_jur_regime_tributario = 'R'
                                AND cst.tipo = 'T'
                                AND trib.vr_encargo > 0
                            THEN 0.00
                            ELSE
                                vr_base_calculo
                        END
                     FROM   fiscal_nf_item_tributacao trib
                     INNER JOIN fiscal_cst cst ON trib.cst_id = cst.id
                     LEFT JOIN fiscal_nf_capa nf_capa
                         ON nf_capa.id = movimento_item.nf_id
                     LEFT JOIN adm_pessoa destinatario
                         ON nf_capa.destinatario_id = destinatario.id
                     LEFT JOIN res_company empresa
                         ON empresa.id = nf_capa.company_id
                     LEFT JOIN adm_pessoa pessoa_empresa
                         ON empresa.rescon_pessoa_id = pessoa_empresa.id
                     WHERE  trib.encargo_id = (SELECT id
                                               FROM   fiscal_encargo
                                               WHERE  sigla = 'ICMS')
                            AND movimento_itens_id = movimento_item.id
                            AND cst.codigo NOT in('10', '30', '40', '41', '51', '60', '70', '90')))
                                                                           AS VL_BC_ICMS,
                Sum((SELECT
                     CASE
                         WHEN nf_capa.nf_propria IS FALSE
                             AND destinatario.admpes_jur_regime_tributario = 'S'
                             AND pessoa_empresa.admpes_jur_regime_tributario = 'R'
                             AND cst.tipo = 'T'
                             AND trib.vr_encargo > 0
                         THEN 0.00
                         ELSE
                             vr_encargo
                     END
                     FROM   fiscal_nf_item_tributacao trib
                     INNER JOIN fiscal_cst cst ON trib.cst_id = cst.id
                     LEFT JOIN fiscal_nf_capa nf_capa
                         ON nf_capa.id = movimento_item.nf_id
                     LEFT JOIN adm_pessoa destinatario
                         ON nf_capa.destinatario_id = destinatario.id
                     LEFT JOIN res_company empresa
                         ON empresa.id = nf_capa.company_id
                     LEFT JOIN adm_pessoa pessoa_empresa
                         ON empresa.rescon_pessoa_id = pessoa_empresa.id
                     WHERE  trib.encargo_id = (SELECT id
                                               FROM   fiscal_encargo
                                               WHERE  sigla = 'ICMS')
                            AND movimento_itens_id = movimento_item.id
                            AND cst.codigo NOT in('10', '30', '40', '41', '51', '60', '70', '90')))
                                                                           AS VL_ICMS,
                Sum((SELECT vr_base_icms_substituicao
                     FROM   fiscal_nf_item_tributacao
                     WHERE  tipo_substituicao = true
                           AND encargo_id = (SELECT id
                                             FROM   fiscal_encargo
                                             WHERE  sigla = 'ICMS')
                            AND movimento_itens_id = movimento_item.id)) AS VL_BC_ICMS_ST,
                Sum((SELECT vr_icms_substituicao
                     FROM   fiscal_nf_item_tributacao
                     WHERE  tipo_substituicao = true
                            AND encargo_id = (SELECT id
                                              FROM   fiscal_encargo
                                              WHERE  sigla = 'ICMS')
                            AND movimento_itens_id = movimento_item.id)) AS VL_ICMS_ST,
                (SELECT aliquota
                 FROM   fiscal_nf_item_tributacao
                 WHERE  encargo_id = (SELECT id
                                      FROM   fiscal_encargo
                                      WHERE  sigla = 'ICMS')
                        AND movimento_itens_id = movimento_item.id) AS ALIQ_ICMS,
                (SELECT aliquota
                 FROM   fiscal_nf_item_tributacao
                 WHERE  tipo_substituicao = true
                        AND encargo_id = (SELECT id
                                          FROM   fiscal_encargo
                                          WHERE  sigla = 'ICMS')
                        AND movimento_itens_id = movimento_item.id) AS ALIQ_ST,
                --BUSCA INFORMACOES PIS
                (SELECT codigo
                 FROM   fiscal_cst
                 WHERE  id = (SELECT cst_id
                              FROM   fiscal_nf_item_tributacao
                              WHERE  encargo_id = (SELECT id
                                                   FROM   fiscal_encargo
                                                   WHERE  sigla = 'PIS')
                                     AND movimento_itens_id = movimento_item.id)) AS CST_PIS,
                Sum((SELECT vr_base_calculo
                     FROM   fiscal_nf_item_tributacao
                     WHERE  encargo_id = (SELECT id
                                          FROM   fiscal_encargo
                                          WHERE  sigla = 'PIS')
                            AND movimento_itens_id = movimento_item.id)) AS VL_BC_PIS,
                Sum((SELECT aliquota
                     FROM   fiscal_nf_item_tributacao
                     WHERE  encargo_id = (SELECT id
                                          FROM   fiscal_encargo
                                          WHERE  sigla = 'PIS')
                            AND movimento_itens_id = movimento_item.id)) AS ALIQ_PIS,
                Sum((SELECT vr_encargo
                     FROM   fiscal_nf_item_tributacao
                     WHERE  encargo_id = (SELECT id
                                          FROM   fiscal_encargo
                                          WHERE  sigla = 'PIS')
                            AND movimento_itens_id = movimento_item.id)) AS VL_PIS,
                --BUSCA INFORMACOES IPI
                (SELECT codigo
                 FROM   fiscal_cst
                 WHERE  id = (SELECT cst_id
                              FROM   fiscal_nf_item_tributacao
                              WHERE  encargo_id = (SELECT id
                                                   FROM   fiscal_encargo
                                                   WHERE  sigla = 'IPI')
                                     AND movimento_itens_id = movimento_item.id))AS CST_IPI,
                Sum((SELECT vr_base_calculo
                     FROM   fiscal_nf_item_tributacao fnit
                     LEFT JOIN fiscal_cst fc
                         ON fc.id = fnit.cst_id
                     WHERE  fnit.encargo_id = (SELECT id
                                               FROM   fiscal_encargo
                                               WHERE  sigla = 'IPI')
                            AND fnit.movimento_itens_id = movimento_item.id
                            AND fc.tipo = 'T')) AS VL_BC_IPI,
                (SELECT aliquota
                 FROM   fiscal_nf_item_tributacao fnit
                 LEFT JOIN fiscal_cst fc
                         ON fc.id = fnit.cst_id
                 WHERE  fnit.encargo_id = (SELECT id
                                           FROM   fiscal_encargo
                                           WHERE  sigla = 'IPI')
                        AND fnit.movimento_itens_id = movimento_item.id
                        AND fc.tipo = 'T') AS ALIQ_IPI,
                Sum((SELECT vr_encargo
                     FROM   fiscal_nf_item_tributacao fnit
                     LEFT JOIN fiscal_cst fc
                         ON fc.id = fnit.cst_id
                     WHERE  fnit.encargo_id = (SELECT id
                                               FROM   fiscal_encargo
                                               WHERE  sigla = 'IPI')
                            AND fnit.movimento_itens_id = movimento_item.id
                            AND fc.tipo = 'T')) AS VL_IPI,
                --BUSCA INFORMACOES COFINS
                (SELECT codigo
                 FROM   fiscal_cst
                 WHERE  id = (SELECT cst_id
                              FROM   fiscal_nf_item_tributacao
                              WHERE  encargo_id = (SELECT id
                                                   FROM   fiscal_encargo
                                                   WHERE  sigla = 'COFINS')
                                     AND movimento_itens_id = movimento_item.id)) AS CST_COFINS,
                Sum((SELECT vr_base_calculo
                     FROM   fiscal_nf_item_tributacao
                     WHERE  encargo_id = (SELECT id
                                          FROM   fiscal_encargo
                                          WHERE  sigla = 'COFINS')
                            AND movimento_itens_id = movimento_item.id)) AS VL_BC_COFINS,
                (SELECT aliquota
                 FROM   fiscal_nf_item_tributacao
                 WHERE  encargo_id = (SELECT id
                                      FROM   fiscal_encargo
                                      WHERE  sigla = 'COFINS')
                        AND movimento_itens_id = movimento_item.id) AS ALIQ_COFINS,
                Sum((SELECT vr_encargo
                     FROM   fiscal_nf_item_tributacao
                     WHERE  encargo_id = (SELECT id
                                          FROM   fiscal_encargo
                                          WHERE  sigla = 'COFINS')
                            AND movimento_itens_id = movimento_item.id)) AS VL_COFINS
            FROM   estoque_movimento_itens movimento_item
            INNER JOIN estoque_produto       AS produto ON produto.id = movimento_item.produto_id
            INNER JOIN estoque_produto_grade AS grade   ON grade.id = movimento_item.grade_id
            INNER JOIN estoque_produto_embalagem AS epe ON epe.id = movimento_item.produto_embalagem_id
            WHERE  movimento_item.nf_id IN ({nf_ids})
            GROUP  BY movimento_item.nf_id,
                      movimento_item.id,
                      movimento_item.produto_id,
                      movimento_item.sequencia,
                      produto.grade_usar,
                      produto.codigo,
                      grade.grade,
                      epe.estpre_unidade_produto
        """.format(coluna_unidade='epe.estpre_unidade_produto',
                   nf_ids=', '.join(map(lambda n: str(n), nf_ids)))
        cr.execute(sql_C170)
        dados = cr.dictfetchall()
        dados_c170 = {}
        for dado in dados:
            nf_id = dado.get('nf_id')
            if nf_id in dados_c170:
                dados_c170[nf_id].append(dado)
            else:
                dados_c170[nf_id] = [dado]
        return dados_c170

    def sql_regC172(self, cr, filtro):
        nf_ids = filtro
        sql_C172 = """
                    SELECT sum(
                                 (SELECT vr_base_calculo
                                  FROM fiscal_nf_item_tributacao
                                  WHERE encargo_id =
                                      (SELECT id
                                       FROM fiscal_encargo
                                       WHERE sigla='ISS')
                                    AND id = tributacao.id)) AS VL_BC_ISSQN,

                      (SELECT aliquota
                       FROM fiscal_nf_item_tributacao
                       WHERE encargo_id =
                           (SELECT id
                            FROM fiscal_encargo
                            WHERE sigla='ISS')
                         AND id = tributacao.id) AS ALIQ_ISSQN,
                           sum(
                                 (SELECT vr_encargo
                                  FROM fiscal_nf_item_tributacao
                                  WHERE encargo_id =
                                      (SELECT id
                                       FROM fiscal_encargo
                                       WHERE sigla='ISS')
                                    AND id = tributacao.id)) AS VL_ISSQN,
                       movimento_item.nf_id AS nf_id 
                    FROM estoque_movimento_itens movimento_item
                    LEFT JOIN fiscal_nf_item_tributacao tributacao ON tributacao.movimento_itens_id = movimento_item.id
                    WHERE movimento_item.nf_id IN ({nf_ids})
                    GROUP BY movimento_item.nf_id, tributacao.id
                    """.format(nf_ids=', '.join(map(lambda n: str(n), nf_ids)))
        cr.execute(sql_C172)
        dados = cr.dictfetchall()
        dados_c172 = {}
        for dado in dados:
            nf_id = dado.get('nf_id')
            if nf_id in dados_c172:
                dados_c172[nf_id].append(dado)
            else:
                dados_c172[nf_id] = [dado]
        return dados_c172

    def sql_regC181(self, cr, filtro):
        nf_ids = filtro.get('nf_ids')
        # Movimentos de substituicao (ST) de notas de entrada de devolucao
        sql_C181 = """
            SELECT
                nf_capa.id AS nf_id,
                'MG500' AS COD_MOT_REST_COMPL,
                sum(emi.quantidade) AS QUANT_CONV,
                epe.estpre_unidade_produto AS UNID,
                (SELECT fismnf_codigo
                FROM fiscal_modelo_nf
                WHERE id = nf_capa_saida.modelo_nf_id) AS COD_MOD_SAIDA,
                nf_capa_saida.serie_nf AS SERIE_SAIDA,
                nf_capa_saida.numero_nf AS NUM_DOC_SAIDA,
                nf_capa_saida.nfe_chave_acesso AS CHV_DFE_SAIDA,
                nf_capa_saida.data_emissao::date AS DT_DOC_SAIDA,
                sum((SELECT min(sequencia) 
                    FROM estoque_movimento_itens 
                    WHERE nf_id = nf_capa_saida.id 
                        AND grade.id = emi_saida.grade_id)) AS NUM_ITEM_SAIDA,
                0 AS VL_UNIT_CONV_SAIDA,
                0 AS VL_UNIT_ICMS_OP_ESTOQUE_CONV_SAIDA,
                0 AS VL_UNIT_ICMS_ST_ESTOQUE_CONV_SAIDA,
                0 AS VL_UNIT_FCP_ICMS_ST_ESTOQUE_CONV_SAIDA,
                0 AS VL_UNIT_ICMS_NA_OPERACAO_CONV_SAIDA,
                0 AS VL_UNIT_ICMS_OP_CONV_SAIDA,
                0 AS VL_UNIT_ICMS_ST_CONV_REST,
                0 AS VL_UNIT_FCP_ST_CONV_REST,
                0 AS VL_UNIT_ICMS_ST_CONV_COMPL,
                0 AS VL_UNIT_FCP_ST_CONV_COMPL
            FROM fiscal_nf_capa nf_capa
            INNER JOIN estoque_movimento_itens emi
                ON nf_capa.id = emi.nf_id
            INNER JOIN fiscal_cfop_natureza natureza
                ON natureza.id = nf_capa.natureza_id
            INNER JOIN fiscal_cfop cfop
                ON natureza.cfop_id = cfop.id
            INNER JOIN fiscal_nf_item_tributacao tributacao
                ON nf_capa.id = tributacao.fisnit_capa_id
            INNER JOIN fiscal_encargo encargo
                ON encargo.id = tributacao.encargo_id
            INNER JOIN fiscal_cst cst
                ON cst.id = tributacao.cst_id
            INNER JOIN estoque_produto_embalagem AS epe ON epe.id = emi.produto_embalagem_id
		    INNER JOIN estoque_produto_grade AS grade ON grade.id = emi.grade_id
		    INNER JOIN fiscal_nf_referencia AS fnr ON fnr.id = nf_capa.id
            INNER JOIN fiscal_nf_capa AS nf_capa_saida ON nf_capa_saida.id = fnr.nf_ref_id 
                                                          AND nf_capa_saida.state = '3'
            INNER JOIN estoque_movimento_itens AS emi_saida ON emi_saida.nf_id = nf_capa_saida.id 
            WHERE
                nf_capa.id IN ({nf_ids})
                AND nf_capa.tipo = 'E'
                AND cfop.movimento_tipo = 'D'
                AND encargo.sigla = 'ICMS'
                AND cst.tipo IN ('U', 'TU')
                AND emi.id = tributacao.movimento_itens_id
                AND emi.grade_id = emi_saida.grade_id
            GROUP BY
                nf_capa.id, COD_MOD_SAIDA, SERIE_SAIDA, NUM_DOC_SAIDA, DT_DOC_SAIDA, 
                UNID, CHV_DFE_SAIDA 
        """.format(nf_ids=nf_ids and ', '.join(map(lambda nf: str(nf), nf_ids)) or '-1')
        cr.execute(sql_C181)
        dados = cr.dictfetchall()
        dic_dados = {}
        for dado in dados:
            if dado.get('nf_id') in dic_dados:
                dic_dados[dado.get('nf_id')].append(dado)
            else:
                dic_dados[dado.get('nf_id')] = [dado]
        return dic_dados

    def sql_regC186(self, cr, filtro):
        # Movimentos de substituicao (ST) de notas de saida de devolucao
        nf_ids = filtro.get('nf_ids')
        sql_C186 = """
            SELECT
                nf_capa.id AS nf_id,
                emi.sequencia AS NUM_ITEM,
                CASE WHEN produto.grade_usar = true
                     THEN produto.codigo || ' ' || grade.grade || ' ' || {coluna_unidade}
                     ELSE produto.codigo || ' ' || {coluna_unidade}
                END AS COD_ITEM,
                cst.codigo AS CST_ICMS,
                (SELECT codigo
                 FROM   fiscal_cfop
                 WHERE  id = emi.cfop_id) AS CFOP,
                'MG400' AS COD_MOT_REST_COMPL,
                sum(emi.quantidade) AS QUANT_CONV,
                epe.estpre_unidade_produto AS UNID,
                (SELECT fismnf_codigo
                FROM fiscal_modelo_nf
                WHERE id = nf_capa_entrada.modelo_nf_id) AS COD_MOD_ENTRADA,
                nf_capa_entrada.serie_nf AS SERIE_ENTRADA,
                nf_capa_entrada.numero_nf AS NUM_DOC_ENTRADA,
                nf_capa_entrada.nfe_chave_acesso AS CHV_DFE_ENTRADA,
                nf_capa_entrada.data_saida_entrada::date AS DT_DOC_ENTRADA,
                sum((SELECT min(sequencia) 
                    FROM estoque_movimento_itens 
                    WHERE nf_id = nf_capa_entrada.id 
                        AND grade.id = emi_entrada.grade_id)) AS NUM_ITEM_ENTRADA,
                0 AS VL_UNIT_CONV_ENTRADA,
                0 AS VL_UNIT_ICMS_OP_CONV_ENTRADA,
                0 AS VL_UNIT_BC_ICMS_ST_CONV_ENTRADA,
                0 AS VL_UNIT_ICMS_ST_CONV_ENTRADA,
                0 AS VL_UNIT_FCP_ST_CONV_ENTRADA
            FROM fiscal_nf_capa nf_capa
            INNER JOIN estoque_movimento_itens emi
                ON nf_capa.id = emi.nf_id
            INNER JOIN fiscal_cfop_natureza natureza
                ON natureza.id = nf_capa.natureza_id
            INNER JOIN fiscal_cfop cfop
                ON natureza.cfop_id = cfop.id
            INNER JOIN fiscal_nf_item_tributacao tributacao
                ON nf_capa.id = tributacao.fisnit_capa_id
            INNER JOIN fiscal_encargo encargo
                ON encargo.id = tributacao.encargo_id
            INNER JOIN fiscal_cst cst
                ON cst.id = tributacao.cst_id
            INNER JOIN estoque_produto_embalagem epe
		        ON epe.id = emi.produto_embalagem_id
		    INNER JOIN estoque_produto AS produto ON produto.id = emi.produto_id
		    INNER JOIN estoque_produto_grade AS grade ON grade.produto_id = produto.id 
		    LEFT JOIN fiscal_nf_referencia AS fnr ON fnr.id = nf_capa.id  
            LEFT JOIN fiscal_nf_capa AS nf_capa_entrada ON nf_capa_entrada.id = fnr.nf_ref_id
                                                       AND nf_capa_entrada.state = '3'
            LEFT JOIN estoque_movimento_itens AS emi_entrada ON emi_entrada.nf_id = nf_capa_entrada.id
            WHERE
                nf_capa.id IN ({nf_ids})
                AND nf_capa.tipo = 'S'
                AND cfop.movimento_tipo = 'D'
                AND encargo.sigla = 'ICMS'
                AND cst.tipo IN ('U', 'TU')
                AND emi.id = tributacao.movimento_itens_id
            GROUP BY
                nf_capa.id, COD_MOD_ENTRADA, SERIE_ENTRADA, NUM_DOC_ENTRADA, DT_DOC_ENTRADA, 
                NUM_ITEM, CHV_DFE_ENTRADA, COD_ITEM, CST_ICMS, CFOP, UNID 
        """.format(coluna_unidade='epe.estpre_unidade_produto',
                   nf_ids=nf_ids and ', '.join(map(lambda nf: str(nf), nf_ids)) or '-1')
        cr.execute(sql_C186)
        dados = cr.dictfetchall()
        dic_dados = {}
        for dado in dados:
            if dado.get('nf_id') in dic_dados:
                dic_dados[dado.get('nf_id')].append(dado)
            else:
                dic_dados[dado.get('nf_id')] = [dado]
        return dic_dados

    def sql_regC190(self, cr, filtro):
        nf_ids = filtro
        sql_C190 = """--C190
                        SELECT nf_capa.tipo,
                               nf_item_tributacao.cst_id         AS cst_id,
                               right(nf_item_tributacao.fisnit_capa_id::varchar, 6) AS cod_obs,

                          (SELECT codigo
                           FROM fiscal_cst
                           WHERE id = nf_item_tributacao.cst_id) AS cst_icms,

                          (SELECT codigo
                           FROM fiscal_cfop
                           WHERE id = mov_item.cfop_id) AS cfop ,

                           nf_item_tributacao.aliquota AS aliq_icms,
                           nf_capa.vr_total_produtos AS vl_opr_total,
                           nf_capa.vr_ipi AS vr_ipi,
                           sum(coalesce(mov_item.vr_total_item_rateado, 0.0)) + 
                               sum(coalesce(nf_item_tributacao.vr_icms_substituicao, 0.0)) +
                               sum(COALESCE(nf_item_tributacao.fisnit_vr_fcp_st, 0.0)) AS vl_opr,
                           sum(
                               CASE
                                    WHEN nf_capa.nf_propria IS FALSE
                                        AND destinatario.admpes_jur_regime_tributario = 'S'
                                        AND pessoa_empresa.admpes_jur_regime_tributario = 'R'
                                        AND cst.tipo = 'T'
                                        AND nf_item_tributacao.vr_encargo > 0
                                    THEN 0.00
                                    ELSE
                                        nf_item_tributacao.vr_base_calculo
                               END) AS vl_bc_icms,
                           sum(
                               CASE
                                    WHEN nf_capa.nf_propria IS FALSE
                                        AND destinatario.admpes_jur_regime_tributario = 'S'
                                        AND pessoa_empresa.admpes_jur_regime_tributario = 'R'
                                        AND cst.tipo = 'T'
                                        AND nf_item_tributacao.vr_encargo > 0
                                    THEN 0.00
                                    ELSE
                                        nf_item_tributacao.vr_encargo
                               END) AS vl_icms,
                           sum(COALESCE(nf_item_tributacao.vr_reducao_base, 0)) AS vl_red_bc,
                           sum(nf_item_tributacao.vr_icms_substituicao)AS vl_icms_st,
                           sum(nf_item_tributacao.vr_base_icms_substituicao) AS vl_bc_icms_st,
                           CASE
                               WHEN nf_capa.fisnfc_infcomp_fisco <> '' THEN nf_capa.id
                           END AS cod_obs,
                           nf_capa.id AS nf_id
                        FROM fiscal_nf_capa nf_capa
                        LEFT JOIN fiscal_nf_item_tributacao nf_item_tributacao ON nf_item_tributacao.fisnit_capa_id = nf_capa.id
                        LEFT JOIN estoque_movimento_itens mov_item ON mov_item.id = nf_item_tributacao.movimento_itens_id
                        LEFT JOIN fiscal_cst cst
                            ON cst.id = nf_item_tributacao.cst_id
                        LEFT JOIN adm_pessoa destinatario
                            ON nf_capa.destinatario_id = destinatario.id
                        LEFT JOIN res_company empresa
                            ON empresa.id = nf_capa.company_id
                        LEFT JOIN adm_pessoa pessoa_empresa
                            ON empresa.rescon_pessoa_id = pessoa_empresa.id
                        WHERE nf_capa.id IN ({nf_ids})
                          AND nf_item_tributacao.encargo_id IN
                            (SELECT id
                             FROM fiscal_encargo
                             WHERE sigla = 'ICMS')
                        GROUP BY nf_item_tributacao.cst_id,
                                 aliq_icms,
                                 nf_capa.id,
                                 nf_item_tributacao.encargo_id,
                                 mov_item.cfop_id,
                                 nf_item_tributacao.fisnit_capa_id,
                                 nf_capa.vr_total_produtos,
                                 nf_capa.vr_ipi,
                                 nf_capa.fisnfc_infcomp_contribuinte""".format(
            nf_ids=', '.join(map(lambda n: str(n), nf_ids)))
        cr.execute(sql_C190)
        dados = cr.dictfetchall()
        dados_c190 = {}
        for dado in dados:
            nf_id = dado.get('nf_id')
            if nf_id in dados_c190:
                dados_c190[nf_id].append(dado)
            else:
                dados_c190[nf_id] = [dado]
        return dados_c190

    def sql_get_ipi(self, cr, nf_id, cfop_codigo, aliquota_icms, cst_id):
        sql = """
                SELECT Sum(it.vr_encargo)                   AS vr_ipi
                FROM   fiscal_nf_item_tributacao it
                       INNER JOIN estoque_movimento_itens emi
                               ON emi.id = it.movimento_itens_id
                       INNER JOIN fiscal_encargo fe
                               ON fe.id = it.encargo_id
                       INNER JOIN fiscal_cfop cfop
                               ON cfop.id = emi.cfop_id
                WHERE  it.fisnit_capa_id = {nf_id}
                       AND fe.sigla = 'IPI'
                       AND cfop.codigo = '{cfop_codigo}'
                       AND it.movimento_itens_id IN (
                           SELECT movimento_itens_id
                           FROM fiscal_nf_item_tributacao
                           WHERE
                               fisnit_capa_id = {nf_id}
                               AND cst_id = {cst_id}
                               AND encargo_id IN (
                                   SELECT id FROM fiscal_encargo WHERE sigla = 'ICMS')
                               AND aliquota = {aliquota_icms}
                       )
                GROUP  BY cfop.codigo
        """.format(nf_id=nf_id, cfop_codigo=cfop_codigo, aliquota_icms=aliquota_icms, cst_id=cst_id)
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

    def sql_regC300(self, cr, filtro):
        mv_ids = filtro
        mv_2d_ids = str(mv_ids).replace('[', '(').replace(']', ')')
        sql = """
                SELECT modelo.fismnf_codigo                                       AS cod_mod,
                       nf_capa.serie_nf                                    AS ser,
                       nf_capa.subserie                                    AS sub,
                       Min(nf_capa.numero_nf)                              AS num_doc_ini,
                       Max(nf_capa.numero_nf)                              AS num_doc_fin,
                       nf_capa.data_emissao AT TIME ZONE 'UTC'             AS dt_doc,
                       Sum(CASE WHEN state = 'C' THEN 0 ELSE nf_capa.vr_total_nf END)
                                                                           AS vl_doc,
                       (SELECT Sum(vr_encargo)
                        FROM   fiscal_nf_item_tributacao
                        WHERE  fisnit_capa_id IN %s
                               AND encargo_id = (SELECT id
                                                 FROM   fiscal_encargo
                                                 WHERE  sigla = 'PIS'))    AS vl_pis,
                       (SELECT Sum(vr_encargo)
                        FROM   fiscal_nf_item_tributacao
                        WHERE  fisnit_capa_id IN( 83, 84, 85 )
                               AND encargo_id = (SELECT id
                                                 FROM   fiscal_encargo
                                                 WHERE  sigla = 'COFINS')) AS vl_cofins
                FROM   fiscal_nf_capa nf_capa
                       INNER JOIN fiscal_modelo_nf modelo
                               ON modelo.id = nf_capa.modelo_nf_id
                WHERE  modelo.fismnf_codigo = '02'
                       AND nf_capa.company_id = '%s'
                       AND nf_capa.id IN %s
                GROUP  BY modelo.fismnf_codigo,
                          nf_capa.serie_nf,
                          nf_capa.subserie,
                          nf_capa.data_emissao
        """ % (mv_2d_ids, self.company_id, mv_2d_ids)
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

    def sql_regC310(self, cr, filtro):
        sql = """
            SELECT
                nf.numero_nf AS num_doc_canc
            FROM fiscal_nf_capa nf
            LEFT JOIN fiscal_modelo_nf_series mod1
                ON mod1.id = nf.modelo_nf_series_id
            LEFT JOIN fiscal_modelo_nf mod2
                ON mod2.id = mod1.modelo_nf_id
            WHERE
                nf.company_id = %s
                AND nf.state = 'C'
                AND mod2.fismnf_codigo = '02'
                AND nf.data_emissao AT TIME ZONE 'UTC' BETWEEN '%s 00:00:00' AND '%s'
                AND nf.numero_nf BETWEEN %s AND %s
            ORDER BY nf.numero_nf
        """ % (filtro.get('company_id'), filtro.get('data_ini'), filtro.get('data_fim'),
               filtro.get('num_nf_ini'), filtro.get('num_nf_fin'))
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

    def sql_regC320(self, cr, filtro):
        mv_2d = str(filtro.get('mov_2d_ids')).replace('[', '(').replace(']', ')')
        data_emissao = filtro.get('data_emissao')
        sql = """
                SELECT cst.codigo                           AS cst_icms,
                       (SELECT codigo
                        FROM   fiscal_cfop
                        WHERE  id IN ( mov_itens.cfop_id )) AS cfop,
                       item_trib.aliquota                   AS aliq_icms,
                       Sum(mov_itens.vr_total_item)         AS vl_opr,
                       Sum(item_trib.vr_base_calculo)       AS vl_bc_icms,
                       Sum(item_trib.vr_encargo)            AS vl_icms,
                       Sum(item_trib.vr_reducao_base)       AS vl_red_bc
                FROM   fiscal_nf_item_tributacao item_trib
                       INNER JOIN fiscal_cst cst
                               ON cst.id = item_trib.cst_id
                       INNER JOIN fiscal_encargo encargo
                               ON encargo.id = item_trib.encargo_id
                       INNER JOIN fiscal_nf_capa nf_capa
                               ON item_trib.fisnit_capa_id = nf_capa.id
                       INNER JOIN estoque_movimento_itens mov_itens
                               ON item_trib.movimento_itens_id = mov_itens.id
                WHERE  encargo.sigla = 'ICMS'
                       AND fisnit_capa_id IN %s
                       AND nf_capa.data_emissao AT TIME ZONE 'UTC' = '%s'
                GROUP  BY cst.codigo,
                          mov_itens.cfop_id,
                          item_trib.aliquota
        """ % (mv_2d, data_emissao)
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

    def sql_regC321(self, cr, filtro):
        mov_2d_ids = str(filtro.get('mov_2d_ids')).replace('[', '(').replace(']', ')')
        data_emissao = filtro.get('data_emissao')
        cst = filtro.get('cst')
        sql = """
                SELECT CASE
                         WHEN produto.grade_usar = true 
                            THEN produto.codigo || ' ' || grade.grade || ' ' || 
                            epe.estpre_unidade_produto
                         ELSE produto.codigo || ' ' || epe.estpre_unidade_produto
                       END                          AS cod_item,
                       Sum(mov_itens.quantidade)    AS qtd,
                       epe.estpre_unidade_produto   AS unid,
                       Sum(mov_itens.vr_total_item) AS vl_item,
                       Sum(mov_itens.vr_desconto)   AS vl_desc,
                       Sum(vr_base_calculo)         AS vl_bc_icms,
                       Sum(vr_encargo)              AS vl_icms
                FROM   estoque_movimento_itens mov_itens
                       INNER JOIN estoque_produto produto
                               ON produto.id = mov_itens.produto_id
                       INNER JOIN fiscal_nf_capa nf_capa
                               ON nf_capa.id = mov_itens.nf_id
                       INNER JOIN fiscal_nf_item_tributacao item_trib
                               ON item_trib.movimento_itens_id = mov_itens.id
                       INNER JOIN estoque_produto_grade grade
                               ON grade.id = mov_itens.grade_id
                       LEFT JOIN estoque_produto_embalagem epe
                               ON epe.id = mov_itens.produto_embalagem_id
                WHERE  mov_itens.nf_id IN %s
                       AND nf_capa.data_emissao AT TIME ZONE 'UTC' = '%s'
                       AND item_trib.encargo_id = (SELECT id
                                                   FROM   fiscal_encargo
                                                   WHERE  sigla = 'ICMS')
                       AND item_trib.cst_id IN(SELECT id
                               FROM   fiscal_cst
                               WHERE  codigo = '%s')
                GROUP  BY mov_itens.produto_id,
                          produto.id,
                          grade.id,
                          epe.id
        """ % (mov_2d_ids, data_emissao, cst)
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

    def sql_regC400(self):
        cr = False
        try:
            # print '-----------------------INI REG C400'
            # print time.strftime('%Y-%m-%d %H:%M:%S')
            sql_C400 = """
                        SELECT CAST('C400' AS text) AS reg,
                        CAST('2D' AS text) AS cod_mod,
                        modelo AS ecf_mod,
                        nro_serie AS ecf_fab,
                            caixa AS ecf_cx,
                        id
                        FROM ecf_ecf
                        WHERE id IN (SELECT ecf_id
                                        FROM ecf_cupons_capa
                                        WHERE date_cupom >= '%s'
                                        AND date_cupom <= '%s'
                                        AND company_id = %s
                                        GROUP BY ecf_id)
                       """ % (self.data_inicio, self.data_fim, self.company_id)
            cr = self.new_cursor()
            cr.execute(sql_C400)
            dados = self.dictfetchall(cr)
            self.C400 = {'executando': False, 'dados': dados}
            # print time.strftime('%Y-%m-%d %H:%M:%S')
            # print '-----------------------FIM REG C400'
        except:
            msg_erro = trace()
            self.C400 = {'executando': False, 'dados': [], 'erro': msg_erro}
        if cr:
            cr.connection.close()

    def sql_regC405(self):
        cr = False
        try:
            # print '-----------------------INI REG C405'
            # print time.strftime('%Y-%m-%d %H:%M:%S')
            sql = """
            SELECT  id,
                    ecf                  AS chave,
                    CAST('C405' AS text) AS reg,
                    data AS dt_doc,
                    cro,
                    numero_z AS crz,
                    coo AS num_coo_fin,
                    gt_final AS gt_fin,
                    gt_final - gt_inicial AS vl_brt,
                    acrescimos,
                    descontos,
                    cancelamentos
            FROM ecf_mapa_resumo_capa
            WHERE data >= '{data_inicio}'
            AND data <= '{data_fim}'
            AND ecf IN (SELECT id FROM ecf_ecf WHERE company_id = {company_id})
            order by ecf
            """.format(data_inicio=self.data_inicio, data_fim=self.data_fim,
                       company_id=self.company_id)
            cr = self.new_cursor()
            cr.execute(sql)
            dados = self.dictfetchall(cr)
            self.C405 = {'executando': False, 'dados': dados}
            # print time.strftime('%Y-%m-%d %H:%M:%S')
            # print '-----------------------FIM REG C405'
        except:
            msg_erro = trace()
            self.C405 = {'executando': False, 'dados': [], 'erro': msg_erro}
        if cr:
            cr.connection.close()

    def sql_regC420(self):
        cr = False
        try:
            # print '-----------------------INI REG C420'
            # print time.strftime('%Y-%m-%d %H:%M:%S')
            sql = """
                    SELECT emri.capa_id          AS chave,
                           Cast('C420' AS TEXT)  AS reg,
                           ''                    AS cod_tot_par,
                           emri.base_valor            AS vlr_acum_tot,
                           emri.tipo,
                           emri.aliquota,
                           emri.imposto,
                           emri.capa_id,
                           emrc.data as data,
                           emrc.ecf as ecf
                    FROM   ecf_mapa_resumo_itens emri
                    INNER JOIN ecf_mapa_resumo_capa emrc
                      ON emrc.id = emri.capa_id
                    WHERE  emrc.data BETWEEN '{data_inicio}' AND '{data_fim}'
                    AND base_valor > 0
                    AND emrc.ecf IN (SELECT id FROM ecf_ecf WHERE company_id = {company_id})
            """.format(data_inicio=self.data_inicio, data_fim=self.data_fim,
                       company_id=self.company_id)
            cr = self.new_cursor()
            cr.execute(sql)
            dados = self.dictfetchall(cr)
            self.C420 = {'executando': False, 'dados': dados}
            # print time.strftime('%Y-%m-%d %H:%M:%S')
            # print '-----------------------FIM REG C420'
        except:
            msg_erro = trace()
            self.C420 = {'executando': False, 'dados': [], 'erro': msg_erro}
        if cr:
            cr.connection.close()

    def sql_regC425(self):
        cr = False
        try:
            # print '-----------------------INI REG C425'
            # print time.strftime('%Y-%m-%d %H:%M:%S')
            sql = """
                SELECT   chave,
                         reg,
                         cod_item,
                         Sum(qtd) AS qtd,
                         unid,
                         Sum(vl_item) AS vl_item,
                         vl_pis,
                         vl_cofins
                FROM     (
                                    SELECT     cupons_capa.ecf_id::text
                                                          || item_tributacao.aliquota::text
                                                          || cst.tipo::text
                                                          || cupons_capa.date_cupom::text AS chave,
                                               cast ('C425' AS text)                      AS reg,
                                               case
                                                  WHEN produto.grade_usar = true 
                                                      THEN produto.codigo || ' ' || grade.grade 
                                                      || ' ' || 
                                                      produto_embalagem.estpre_unidade_produto
                                                  ELSE produto.codigo || ' ' || 
                                                  produto_embalagem.estpre_unidade_produto
                                               END                                  AS cod_item,
                                               sum(mov_itens.quantidade)            AS qtd,
                                               produto_embalagem.estpre_unidade_produto AS unid,
                                               sum(mov_itens.vr_total_item_rateado) AS vl_item,
                                               cast ('' AS text)                    AS vl_pis,
                                               cast ('' AS text)                    AS vl_cofins
                                    FROM       estoque_movimento_itens mov_itens
                                    INNER JOIN estoque_produto_embalagem produto_embalagem
                                    ON         mov_itens.produto_embalagem_id = produto_embalagem.id
                                    INNER JOIN estoque_embalagem embalagem
                                    ON         produto_embalagem.embalagem_id = embalagem.id
                                    INNER JOIN fiscal_nf_item_tributacao item_tributacao
                                    ON         item_tributacao.movimento_itens_id = mov_itens.id
                                    INNER JOIN estoque_produto produto
                                    ON         mov_itens.produto_id = produto.id
                                    INNER JOIN estoque_produto_grade grade
                                    ON         mov_itens.grade_id = grade.id
                                    INNER JOIN ecf_cupons_capa cupons_capa
                                    ON         mov_itens.cupom_id = cupons_capa.id
                                    INNER JOIN fiscal_cst cst
                                    ON         cst.id = item_tributacao.cst_id
                                    WHERE      cupons_capa.date_cupom BETWEEN '{data_inicio}' AND '{data_fim}'
                                    AND        cupons_capa.state = 'V'
                                    AND        cupons_capa.tipo_cupom = 'V'
                                    AND        mov_itens.item_cancelado = false
                                    AND        item_tributacao.encargo_id =
                                               (
                                                      SELECT id
                                                      FROM   fiscal_encargo
                                                      WHERE  sigla ilike'ICMS')
                                    AND        mov_itens.nf_id IS NULL
                                    AND        cupons_capa.company_id = {company_id}
                                    GROUP BY   mov_itens.produto_id,
                                               produto.id,
                                               grade.id,
                                               produto_embalagem.id,
                                               cupons_capa.tipo_cupom,
                                               mov_itens.item_cancelado,
                                               cst.tipo,
                                               item_tributacao.aliquota,
                                               cupons_capa.ecf_id,
                                               cupons_capa.date_cupom
                                    UNION ALL
                                    --Cancelamento
                                    SELECT     cupons_capa.ecf_id::text
                                                          || item_tributacao.aliquota::text
                                                          || cst.tipo::text
                                                          || cupons_capa.date_cupom::text AS chave,
                                               cast ('C425' AS text)                      AS reg,
                                               CASE
                                                  WHEN produto.grade_usar = true 
                                                    THEN produto.codigo || ' ' || 
                                                    grade.grade || ' ' || 
                                                    produto_embalagem.estpre_unidade_produto
                                                  ELSE produto.codigo || ' ' || 
                                                  produto_embalagem.estpre_unidade_produto
                                               END                                   AS cod_item,
                                               sum(-mov_itens.quantidade)            AS qtd,
                                               produto_embalagem.estpre_unidade_produto AS unid,
                                               sum(-mov_itens.vr_total_item_rateado) AS vl_item,
                                               cast ('' AS text)                     AS vl_pis,
                                               cast ('' AS text)                     AS vl_cofins
                                    FROM       estoque_movimento_itens mov_itens
                                    INNER JOIN estoque_produto_embalagem produto_embalagem
                                    ON         mov_itens.produto_embalagem_id = produto_embalagem.id
                                    INNER JOIN estoque_embalagem embalagem
                                    ON         produto_embalagem.embalagem_id = embalagem.id
                                    INNER JOIN fiscal_nf_item_tributacao item_tributacao
                                    ON         item_tributacao.movimento_itens_id = mov_itens.id
                                    INNER JOIN estoque_produto produto
                                    ON         mov_itens.produto_id = produto.id
                                    INNER JOIN estoque_produto_grade grade
                                    ON         mov_itens.grade_id = grade.id
                                    INNER JOIN ecf_cupons_capa cupons_capa
                                    ON         mov_itens.cupom_id = cupons_capa.id
                                    INNER JOIN fiscal_cst cst
                                    ON         cst.id = item_tributacao.cst_id
                                    WHERE      cupons_capa.date_cupom BETWEEN '{data_inicio}' AND '{data_fim}'
                                    AND        cupons_capa.state = 'V'
                                    AND        cupons_capa.tipo_cupom = 'C'
                                    AND        mov_itens.item_cancelado = true
                                    AND        item_tributacao.encargo_id =
                                               (
                                                      SELECT id
                                                      FROM   fiscal_encargo
                                                      WHERE  sigla ilike'ICMS')
                                    AND        mov_itens.nf_id IS NULL
                                    AND        cupons_capa.company_id = {company_id}
                                    GROUP BY   mov_itens.produto_id,
                                               produto.id,
                                               grade.id,
                                               produto_embalagem.id,
                                               cupons_capa.tipo_cupom,
                                               mov_itens.item_cancelado,
                                               cst.tipo,
                                               item_tributacao.aliquota,
                                               cupons_capa.ecf_id,
                                               cupons_capa.date_cupom) AS tmp
                GROUP BY chave,
                         reg,
                         cod_item,
                         unid,
                         vl_pis,
                         vl_cofins
            """.format(data_inicio=self.data_inicio, data_fim=self.data_fim,
                       company_id=self.company_id)
            cr = self.new_cursor()
            cr.execute(sql)
            self.C425 = {'executando': False, 'dados': self.dictfetchall(cr)}
            # print time.strftime('%Y-%m-%d %H:%M:%S')
            # print '-----------------------FIM REG C425'
        except:
            msg_erro = trace()
            self.C425 = {'executando': False, 'dados': [], 'erro': msg_erro}
        if cr:
            cr.connection.close()

    def sql_regC490(self):
        cr = False
        try:
            # print '-----------------------INI REG C490'
            # print time.strftime('%Y-%m-%d %H:%M:%S')
            sql = """
                    SELECT   ecf_id::text
                                      ||date_cupom::text AS chave,
                             reg,
                             cst_icms,
                             cfop,
                             aliq_icms,
                             sum(vl_opr)     AS vl_opr,
                             sum(vl_bc_icms) AS vl_bc_icms,
                             sum(vl_icms)    AS vl_icms,
                             cod_obs,
                             ecf_id,
                             date_cupom
                    FROM     (
                                        SELECT     cast('C490' AS text) AS reg,
                                                   cst.codigo           AS cst_icms,
                                                   (
                                                          SELECT codigo
                                                          FROM   fiscal_cfop cfop
                                                          WHERE  cfop.id = movimento_itens.cfop_id) AS cfop,
                                                   item_tributacao.aliquota                         AS aliq_icms,
                                                   sum(movimento_itens.vr_total_item_rateado)       AS vl_opr,
                                                   CASE
                                                              WHEN cst.codigo NOT IN ( '30',
                                                                                      '40',
                                                                                      '41',
                                                                                      '50',
                                                                                      '60' ) THEN sum( vr_base_calculo)
                                                              ELSE 0.00
                                                   END AS vl_bc_icms,
                                                   CASE
                                                              WHEN cst.codigo NOT IN ( '30',
                                                                                      '40',
                                                                                      '41',
                                                                                      '50',
                                                                                      '60' ) THEN trunc(sum( vr_encargo), 2)
                                                              ELSE 0.00
                                                   END AS vl_icms,
                                                   ''  AS cod_obs,
                                                   cupons_capa.ecf_id,
                                                   cupons_capa.date_cupom
                                        FROM       fiscal_nf_item_tributacao item_tributacao
                                        INNER JOIN fiscal_cst cst
                                        ON         item_tributacao.cst_id = cst.id
                                        INNER JOIN estoque_movimento_itens movimento_itens
                                        ON         movimento_itens.id = item_tributacao.movimento_itens_id
                                        INNER JOIN estoque_movimento_capa movimento_capa
                                        ON         movimento_capa.id = movimento_itens.capa_id
                                        INNER JOIN ecf_cupons_capa cupons_capa
                                        ON         cupons_capa.id = movimento_itens.cupom_id
                                        AND        movimento_itens.nf_id IS NULL
                                        WHERE      cupons_capa.date_cupom BETWEEN '{data_inicio}' AND '{data_fim}'
                                        AND        cupons_capa.tipo_cupom = 'V'
                                        AND        movimento_itens.item_cancelado = false
                                        AND        item_tributacao.encargo_id =
                                                   (
                                                          SELECT id
                                                          FROM   fiscal_encargo
                                                          WHERE  sigla ilike'ICMS')
                                        AND cupons_capa.company_id = {company_id}
                                        GROUP BY   cst.codigo,
                                                   movimento_itens.cfop_id,
                                                   item_tributacao.aliquota,
                                                   cupons_capa.ecf_id,
                                                   cupons_capa.date_cupom
                                        UNION ALL
                                        SELECT     cast('C490' AS text) AS reg,
                                                   cst.codigo           AS cst_icms,
                                                   (
                                                          SELECT codigo
                                                          FROM   fiscal_cfop cfop
                                                          WHERE  cfop.id = movimento_itens.cfop_id) AS cfop,
                                                   item_tributacao.aliquota                         AS aliq_icms,
                                                   sum(-movimento_itens.vr_total_item_rateado)      AS vl_opr,
                                                   CASE
                                                              WHEN cst.codigo NOT IN ( '30',
                                                                                      '40',
                                                                                      '41',
                                                                                      '50',
                                                                                      '60' ) THEN sum( -vr_base_calculo)
                                                              ELSE 0.00
                                                   END AS vl_bc_icms,
                                                   CASE
                                                              WHEN cst.codigo NOT IN ( '30',
                                                                                      '40',
                                                                                      '41',
                                                                                      '50',
                                                                                      '60' ) THEN sum( -vr_encargo)
                                                              ELSE 0.00
                                                   END AS vl_icms,
                                                   ''  AS cod_obs,
                                                   cupons_capa.ecf_id,
                                                   cupons_capa.date_cupom
                                        FROM       fiscal_nf_item_tributacao item_tributacao
                                        INNER JOIN fiscal_cst cst
                                        ON         item_tributacao.cst_id = cst.id
                                        INNER JOIN estoque_movimento_itens movimento_itens
                                        ON         movimento_itens.id = item_tributacao.movimento_itens_id
                                        INNER JOIN estoque_movimento_capa movimento_capa
                                        ON         movimento_capa.id = movimento_itens.capa_id
                                        INNER JOIN ecf_cupons_capa cupons_capa
                                        ON         cupons_capa.id = movimento_itens.cupom_id
                                        AND        movimento_itens.nf_id IS NULL
                                        WHERE      cupons_capa.date_cupom BETWEEN '{data_inicio}' AND '{data_fim}'
                                        AND        cupons_capa.tipo_cupom = 'C'
                                        AND        movimento_itens.item_cancelado = true
                                        AND        item_tributacao.encargo_id =
                                                   (
                                                          SELECT id
                                                          FROM   fiscal_encargo
                                                          WHERE  sigla ilike'ICMS')
                                        AND cupons_capa.company_id = {company_id}
                                        GROUP BY   cst.codigo,
                                                   movimento_itens.cfop_id,
                                                   item_tributacao.aliquota,
                                                   cupons_capa.ecf_id,
                                                   cupons_capa.date_cupom ) AS tmp
                    GROUP BY reg,
                             cst_icms,
                             cfop,
                             aliq_icms,
                             cod_obs,
                             ecf_id,
                             date_cupom
            """.format(data_inicio=self.data_inicio, data_fim=self.data_fim,
                       company_id=self.company_id)
            cr = self.new_cursor()
            cr.execute(sql)
            self.C490 = {'executando': False, 'dados': self.dictfetchall(cr)}
            # print time.strftime('%Y-%m-%d %H:%M:%S')
            # print '-----------------------FIM REG C490'
        except:
            msg_erro = trace()
            self.C490 = {'executando': False, 'dados': [], 'erro': msg_erro}
        if cr:
            cr.connection.close()

    def sql_C500(self, cr, filtro):
        if not filtro or not isinstance(filtro, dict):
            return list()
        dt_ini = filtro.get('dt_ini')
        dt_fin = filtro.get('dt_fin')

        sql_C500 = """
        SELECT     'C500'       AS reg,
                   nf_capa.tipo AS ind_oper,
                   nf_propria   AS ind_emit,
                   Cast(pessoa.codigo AS TEXT)
                              || Cast(pessoa_endereco.id AS TEXT) AS cod_part,
                   pessoa.pessoa_tipo                             AS pessoa_tipo, 
                   pessoa.admpes_jur_ie                           AS inscricao_est, 
                   cidade.codigo_ibge                             AS codigo_ibge,
                   nf_modelo.fismnf_codigo                        AS cod_mod,
                   nf_capa.state                                  AS cod_sit,
                   nf_capa.serie_nf                               AS ser,
                   nf_capa.subserie                               AS sub,
                   ''                                             AS cod_cons,
                   nf_capa.numero_nf                              AS num_doc,
                   nf_capa.data_emissao                           AS dt_doc,
                   nf_capa.data_saida_entrada AT TIME ZONE 'UTC'  AS dt_e_s,
                   nf_capa.vr_total_nf                            AS vl_doc,
                   nf_capa.vr_desconto                            AS vl_desc,
                   Sum(movimento_itens.vr_total_item)             AS vl_forn,
                   0.00                                           AS vl_terc,
                   nf_capa.vr_despesas_acessorias                 AS vl_da,
                   nf_capa.vr_base_icms                           AS vl_bc_icms,
                   nf_capa.vr_icms                                AS vl_icms,
                   nf_capa.vr_base_icms_substituicao              AS vl_icms_st,
                   ''                                             AS cod_inf,
                   CASE
                       WHEN nf_modelo.fismnf_codigo != '66'
                           THEN nf_capa.fisnfc_energia_tipo_ligacao
                       ELSE ''
                   END                                            AS tp_ligacao,
                   nf_capa.nfe_chave_acesso                       AS chave_acesso,
                   nf_capa.fisnfc_nfe_indicador_presenca          AS indic_presenca,
                   ''                                             AS cod_grupo_tensao,
                   nf_capa.id                                     AS nf_capa_id
        FROM       fiscal_nf_capa            AS nf_capa
        INNER JOIN adm_pessoa                AS pessoa          ON pessoa.id = nf_capa.destinatario_id
        INNER JOIN adm_pessoa_endereco       AS pessoa_endereco ON pessoa_endereco.id = nf_capa.destinatario_endereco_id
        INNER JOIN adm_cidade                AS cidade          ON cidade.id = pessoa_endereco.cidade_id
        INNER JOIN fiscal_modelo_nf          AS nf_modelo       ON nf_modelo.id = nf_capa.modelo_nf_id
        INNER JOIN estoque_movimento_itens   AS movimento_itens ON movimento_itens.nf_id = nf_capa.id
        INNER JOIN fiscal_nf_item_tributacao AS item_tributacao ON item_tributacao.movimento_itens_id = movimento_itens.id
        INNER JOIN fiscal_cst                AS cst             ON cst.id = item_tributacao.cst_id
        INNER JOIN fiscal_encargo            AS encargo         ON encargo.id = item_tributacao.encargo_id
        LEFT JOIN  fiscal_codigo_consumo     AS fcc             ON fcc.fiscco_modelo_id = nf_capa.modelo_nf_id 
                                                                   AND fcc.id = nf_capa.fisnfc_cod_consumo_id        
        WHERE      nf_modelo.fismnf_codigo IN ( '66',
                                               '29',
                                               '28' )
        AND        encargo.sigla ilike 'ICMS'
        AND        nf_capa.data_saida_entrada AT TIME ZONE 'UTC' BETWEEN '%s' AND '%s'
        AND        nf_capa.state = '3'
        AND        nf_capa.company_id = '%s'
        GROUP BY   nf_capa.tipo,
                   nf_propria,
                   nf_modelo.fismnf_codigo ,
                   nf_capa.state ,
                   nf_capa.serie_nf ,
                   nf_capa.subserie ,
                   fcc.fiscco_codigo,
                   nf_capa.numero_nf ,
                   nf_capa.data_emissao ,
                   nf_capa.data_saida_entrada ,
                   nf_capa.vr_total_nf ,
                   nf_capa.vr_desconto ,
                   nf_capa.vr_despesas_acessorias ,
                   nf_capa.vr_base_icms ,
                   nf_capa.vr_icms ,
                   nf_capa.vr_base_icms_substituicao ,
                   nf_capa.fisnfc_energia_tipo_ligacao ,
                   nf_capa.fisnfc_energia_grupo_tensao ,
                   nf_capa.id,
                   nf_capa.nfe_chave_acesso,
                   nf_capa.fisnfc_nfe_indicador_presenca,
                   pessoa.codigo,
                   pessoa_endereco.id,
                   pessoa.pessoa_tipo, 
                   pessoa.admpes_jur_ie,
                   cidade.codigo_ibge
                    """ % (dt_ini, dt_fin, self.company_id)
        cr.execute(sql_C500)
        dados = cr.dictfetchall()
        return dados

    def sql_totaliza_pis_cofins(self, cr, filtro):
        nf_id = filtro
        sql = """
                SELECT mov_itens.nf_id,
                       Sum(item_tributacao.vr_encargo) as vr_encargo,
                       encargo.sigla as sigla
                FROM   estoque_movimento_itens mov_itens
                       INNER JOIN fiscal_nf_item_tributacao item_tributacao
                               ON item_tributacao.movimento_itens_id = mov_itens.id
                       INNER JOIN fiscal_encargo encargo
                               ON encargo.id = item_tributacao.encargo_id
                WHERE  encargo.sigla IN('PIS', 'COFINS')
                AND mov_itens.nf_id = %s
                GROUP  BY mov_itens.nf_id,
                          encargo.sigla
                ORDER  BY mov_itens.nf_id
                 """ % nf_id
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

    def sql_C590(self, cr, filtro):
        nf_id = filtro
        sql_C590 = """
                SELECT 'C590'                                          AS reg,
                       cst.codigo                                      AS cst_icms,
                       cfop.codigo                                     AS cfop,
                       itens_tributacao.aliquota                       AS aliq_icms,
                       Sum(mov_itens.vr_total_item_rateado)            AS vl_opr,
                       Sum(itens_tributacao.vr_base_calculo)           AS vl_bc_icms,
                       Sum(itens_tributacao.vr_encargo)                AS vl_icms,
                       Sum(itens_tributacao.vr_base_icms_substituicao) AS vl_bc_icms_st,
                       Sum(itens_tributacao.vr_reducao_base)           AS vl_red_bc,
                       nf_capa.fisnfc_infcomp_fisco                    AS cod_obs
                FROM   fiscal_nf_item_tributacao itens_tributacao
                       INNER JOIN estoque_movimento_itens mov_itens
                               ON mov_itens.id = itens_tributacao.movimento_itens_id
                       INNER JOIN fiscal_nf_capa nf_capa
                               ON nf_capa.id = mov_itens.nf_id
                       INNER JOIN fiscal_cst cst
                               ON cst.id = itens_tributacao.cst_id
                       INNER JOIN fiscal_encargo encargo
                               ON encargo.id = itens_tributacao.encargo_id
                       INNER JOIN fiscal_cfop cfop
                               ON cfop.id = mov_itens.cfop_id
                WHERE  encargo.sigla = 'ICMS'
                       AND nf_capa.id = %s
                GROUP  BY cst.codigo,
                          cfop.codigo,
                          itens_tributacao.aliquota,
                          cod_obs
                """ % nf_id
        cr.execute(sql_C590)
        dados = cr.dictfetchall()
        return dados

    def sql_D100(self, cr, filtro):
        nf_capa_ids = str(filtro.get('movimento_notas'))
        sql = """
        SELECT  DISTINCT nf_capa.id,
                CASE 
                    WHEN nf_capa.fisnfc_infcomp_contribuinte IS NOT NULL 
                        THEN right(nf_capa.id::varchar, 6) 
                    ELSE '' 
                END                                                     AS COD_INF,
                CAST('D100' AS text)                                    AS REG,
                CASE
                  WHEN nf_capa.tipo = 'E' THEN '0'
                  WHEN nf_capa.tipo = 'S' THEN '1'
                END                                                     AS IND_OPER,
                CASE
                  WHEN nf_capa.nf_propria = TRUE THEN '0'
                  ELSE '1'
                END                                                     AS IND_EMIT,
                (SELECT CAST (codigo AS TEXT) || (SELECT CAST(id AS TEXT)
                 FROM   adm_pessoa_endereco
                 WHERE  id = nf_capa.destinatario_endereco_id)
                 FROM   adm_pessoa WHERE id = nf_capa.destinatario_id)  AS COD_PART,
                modelo_nf.fismnf_codigo                                 AS COD_MOD,
                CASE
                  WHEN nf_capa.state = '3' THEN '00'
                  WHEN nf_capa.state = 'C' THEN '02'
                  WHEN nf_capa.state = 'I' THEN '05'
                END                                                     AS COD_SIT,
                nf_capa.serie_nf                                        AS SER,
                nf_capa.subserie                                        AS SUB,
                nf_capa.numero_nf                                       AS NUM_DOC,
                nf_capa.nfe_chave_cte                                   AS CHV_CTE,
                nf_capa.nfe_chave_cte                                   AS CHV_CTE,
                nf_capa.data_emissao AT TIME ZONE 'UTC'                 AS DT_DOC,
                nf_capa.data_saida_entrada AT TIME ZONE 'UTC'           AS DT_A_P ,
                ''                                                      AS CHV_CTE_REF,
                CASE
                    WHEN nf_capa.vr_frete > 0 THEN nf_capa.vr_frete
                    ELSE nf_capa.vr_total_nf
                END                                                     AS VL_DOC,
                nf_capa.vr_desconto                                     AS VL_DESC,
                nf_capa.frete                                           AS IND_FRT,
                nf_capa.vr_total_nf                                     AS VL_SERV,
                nf_capa.vr_icms                                         AS VL_ICMS,
                (SELECT item_tributacao.vr_base_calculo
                 FROM fiscal_nf_item_tributacao item_tributacao
                 INNER JOIN fiscal_cst                                  AS cst
                         ON cst.id = item_tributacao.cst_id
                 WHERE item_tributacao.encargo_id = (
                       SELECT id
                       FROM fiscal_encargo
                       WHERE sigla = 'ICMS')
                   AND nf_capa.id = item_tributacao.fisnit_capa_id
                   AND cst.codigo NOT in('10', '30', '40', '60', '70', '90')
                 GROUP BY item_tributacao.fisnit_capa_id, 
                          vr_base_calculo )                             AS VL_BC_ICMS,
                (SELECT item_tributacao.vr_encargo
                 FROM fiscal_nf_item_tributacao                         AS item_tributacao
                 INNER JOIN fiscal_cst cst
                         ON cst.id = item_tributacao.cst_id
                 WHERE item_tributacao.encargo_id = (
                       SELECT id
                       FROM fiscal_encargo
                       WHERE sigla = 'ICMS')
                         AND nf_capa.id = item_tributacao.fisnit_capa_id
                         AND cst.codigo NOT IN('10', '30', '40', '60', '70', '90')
                       GROUP BY item_tributacao.fisnit_capa_id,
                                vr_encargo)                             AS VL_ICMS,
                0.00                                                    AS VL_NT,
                nf_capa.fisnfc_infcomp_contribuinte                     AS TXT,
                ''                                                      AS COD_CTA,
                admcid_origem.codigo_ibge                               AS COD_MUN_ORIG,
                admcid_destino.codigo_ibge                              AS COD_MUN_DEST
            FROM fiscal_nf_capa                                         AS nf_capa
            INNER JOIN fiscal_modelo_nf                                 AS modelo_nf
                    ON modelo_nf.id = nf_capa.modelo_nf_id
            INNER JOIN res_company                                      AS rescom
                    ON rescom.id = nf_capa.company_id
            LEFT  JOIN adm_cidade                                       AS admcid_origem
                    ON nf_capa.fisnfc_origem_cidade_id = admcid_origem.id 
            LEFT  JOIN adm_cidade                                       AS admcid_destino
                    ON nf_capa.fisnfc_destino_cidade_id = admcid_destino.id
            WHERE nf_capa.id IN %s
              AND modelo_nf.fismnf_codigo IN ('07', '08', '8B', '09', '10', '11', '26', '27', '57', '67')
              AND nf_capa.state IN ('3', 'C', 'I')
            ORDER BY nf_capa.id ASC
        """ % (str(nf_capa_ids).replace('[', '(').replace(']', ')'))
        cr.execute(sql)
        dados = cr.dictfetchall()

        return dados

    def sql_D190(self, cr, filtro):
        nf_id = filtro
        sql_D190 = """

                    SELECT
                    'D190'                                            AS reg,
                    nf_item_tributacao.fisnit_capa_id                 AS cod_obs,
                   (SELECT codigo
                    FROM   fiscal_cst
                    WHERE  id = nf_item_tributacao.cst_id)           AS cst_icms,
                   (SELECT codigo
                        FROM   fiscal_cfop
                        WHERE id = (SELECT cfop_id
                                    FROM fiscal_cfop_natureza
                                    WHERE nf_capa.natureza_id = id)) AS cfop,

                   nf_item_tributacao.aliquota                       AS aliq_icms,
                   nf_capa.vr_total_nf                               AS vl_opr_total,
                   Sum(mov_item.vr_total_item_rateado)
                   + Sum(nf_item_tributacao.vr_icms_substituicao)    AS vl_opr,
                   Sum(nf_item_tributacao.vr_base_calculo)           AS vl_bc_icms,
                   Sum(nf_item_tributacao.vr_encargo)                AS vl_icms,
                   Sum(nf_item_tributacao.vr_reducao_base)           AS vl_red_bc,
                   CASE
                     WHEN nf_capa.fisnfc_infcomp_contribuinte <> '' THEN nf_capa.id
                   END                                               AS cod_obs
            FROM   fiscal_nf_capa nf_capa
                   LEFT JOIN fiscal_nf_item_tributacao nf_item_tributacao
                          ON nf_item_tributacao.fisnit_capa_id = nf_capa.id
                   LEFT JOIN estoque_movimento_itens mov_item
                          ON mov_item.id = nf_item_tributacao.movimento_itens_id
            WHERE  nf_capa.id = %d
                   AND nf_item_tributacao.encargo_id IN (SELECT id
                                                         FROM   fiscal_encargo
                                                         WHERE  sigla = 'ICMS')
            GROUP  BY nf_item_tributacao.cst_id,
                      nf_item_tributacao.aliquota,
                      nf_capa.id,
                      nf_item_tributacao.encargo_id,
                      mov_item.cfop_id,
                      nf_item_tributacao.fisnit_capa_id,
                      nf_capa.fisnfc_infcomp_contribuinte
                    """ % nf_id
        cr.execute(sql_D190)
        dados = cr.dictfetchall()
        return dados

    def sql_D500(self, cr, filtro):
        dt_ini = filtro.get('dt_ini')
        dt_fim = filtro.get('dt_fim')
        sql = """
            SELECT    nf_capa.id          AS nf_id,
                      'D500'              AS reg,
                       nf_capa.tipo       AS IND_OPER,
                       nf_capa.nf_propria AS IND_EMIT,
                       Cast(pessoa.codigo AS TEXT)
                                  ||
                       (
                              SELECT Cast(id AS TEXT)
                              FROM   adm_pessoa_endereco
                              WHERE  id = nf_capa.destinatario_endereco_id) AS cod_part,
                       modelo.fismnf_codigo                                 AS cod_mod,
                       nf_capa.state                                        AS COD_SIT,
                       nf_capa.serie_nf                                     AS serie,
                       nf_capa.subserie                                     AS sub,
                       nf_capa.numero_nf                                    AS num_doc,
                       nf_capa.data_emissao AT TIME ZONE 'UTC'              AS dt_doc,
                       nf_capa.data_saida_entrada AT TIME ZONE 'UTC'        AS dt_a_p,
                       nf_capa.vr_total_nf                                  AS vl_doc,
                       nf_capa.vr_desconto                                  AS vl_desc,
                       nf_capa.vr_total_nf                                  AS vl_serv,
                       nf_capa.vr_despesas_acessorias                       AS vl_da,
                       nf_capa.vr_base_icms                                 AS vl_bc_icms,
                       nf_capa.vr_icms                                      AS vl_icms,
                       (
                              SELECT Sum(vr_encargo)
                              FROM   fiscal_nf_item_tributacao
                              WHERE  encargo_id =
                                     (
                                            SELECT id
                                            FROM   fiscal_encargo
                                            WHERE  sigla = 'PIS')
                              AND    fisnit_capa_id = nf_capa.id) AS vl_pis,
                       (
                              SELECT Sum(vr_encargo)
                              FROM   fiscal_nf_item_tributacao
                              WHERE  encargo_id =
                                     (
                                            SELECT id
                                            FROM   fiscal_encargo
                                            WHERE  sigla = 'COFINS')
                              AND    fisnit_capa_id = nf_capa.id) AS vl_cofins,
                              nf_capa.fisnfc_infcomp_contribuinte AS txt
            FROM       fiscal_nf_capa nf_capa
            INNER JOIN fiscal_modelo_nf modelo
            ON         modelo.id = nf_capa.modelo_nf_id
            INNER JOIN adm_pessoa pessoa
            ON         pessoa.id = nf_capa.destinatario_id
            WHERE      nf_capa.company_id = %s
            AND        modelo.fismnf_codigo IN ('21', '22')
            AND
                       CASE
                                  WHEN nf_capa.tipo = 'E'
                                  THEN nf_capa.data_saida_entrada AT TIME ZONE 'UTC'
                                      BETWEEN '%s' AND '%s'
                                  ELSE nf_capa.data_emissao = '%s' AND nf_capa.data_emissao = '%s'
                       END
            AND NOT (nf_capa.tipo = 'E'
                     AND nf_capa.nf_propria IS NOT TRUE
                     AND nf_capa.state = 'C')
        """ % (self.company_id, dt_ini, dt_fim, dt_ini, dt_fim)
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

    def sql_D590(self, cr, nf_id):
        sql = """
                SELECT 'D590'                         AS reg,
                       produto.origem_mercadoria ||
                       cst.codigo                     AS cst_icms,
                       cst.codigo                     AS cst,
                       cfop.codigo                    AS cfop,
                       fisnit.aliquota                AS aliq_icms,
                       Sum(emi.vr_total_item_rateado) AS vl_opr,
                       Sum(fisnit.vr_base_calculo)    AS vl_bc_icms,
                       Sum(fisnit.vr_encargo)         AS vl_icms,
                       Sum(fisnit.vr_reducao_base)    AS vl_red_bc
                FROM   fiscal_nf_item_tributacao fisnit
                       INNER JOIN fiscal_cst cst
                               ON cst.id = fisnit.cst_id
                       INNER JOIN estoque_movimento_itens emi
                               ON emi.id = fisnit.movimento_itens_id
                       INNER JOIN fiscal_cfop cfop
                               ON cfop.id = emi.cfop_id
                       INNER JOIN fiscal_encargo encargo
                               ON encargo.id = fisnit.encargo_id
                       INNER JOIN estoque_produto produto
                               ON produto.id = emi.produto_id
                WHERE  fisnit.fisnit_capa_id = %d
                       AND encargo.sigla = 'ICMS'
                GROUP  BY cst.codigo,
                          cfop.codigo,
                          fisnit.aliquota,
                          produto.origem_mercadoria
        """ % nf_id
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

    def sql_regE200(self, cr, filtro):
        sql = """
            SELECT
                uf.sigla                                 AS uf,
                left(nf.data_saida_entrada::varchar, 10) AS dt_ini
            FROM fiscal_nf_capa nf
            LEFT JOIN estoque_movimento_itens emi
                ON nf.id = emi.nf_id
            LEFT JOIN adm_pessoa ap
                ON nf.destinatario_id = ap.id
            LEFT JOIN adm_pessoa_endereco ape
                ON ap.id = ape.pessoa_id
            LEFT JOIN adm_uf uf
                ON uf.id = ape.uf_id
            WHERE
                nf.id IN ({nf_ids})
                AND ((nf.vr_base_icms_substituicao > 0 AND nf.vr_icms_substituicao > 0 
                      AND 'I' = '{tipo_atividade}') OR emi.estmvi_sped_fiscal_e200_manual)
            GROUP BY uf.sigla, dt_ini
            ORDER BY dt_ini, uf.sigla
        """.format(tipo_atividade=filtro.get('tipo_atividade'),
                   nf_ids=', '.join(map(lambda i: str(i), filtro.get('nf_ids'))))
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

    def sql_regE210(self, cr, filtro):
        sql = """
            SELECT
                '1' AS ind_mov_st,
                sum(CASE
                        WHEN nf.tipo = 'E' AND NOT emi.estmvi_sped_fiscal_e200_manual THEN
                            COALESCE(fnit.vr_icms_substituicao, 0)
                        ELSE 0
                    END) AS vl_out_cred_st,
                sum(CASE
                        WHEN nf.tipo = 'S' AND NOT emi.estmvi_sped_fiscal_e200_manual THEN
                            COALESCE(fnit.vr_icms_substituicao, 0)
                        ELSE 0
                    END) AS vl_retencao_st
            FROM fiscal_nf_capa nf
            LEFT JOIN estoque_movimento_itens emi
                ON nf.id = emi.nf_id
            LEFT JOIN fiscal_nf_item_tributacao fnit
                ON emi.id = fnit.movimento_itens_id
            LEFT JOIN adm_pessoa_endereco ape
                ON nf.destinatario_endereco_id = ape.id
            LEFT JOIN adm_uf uf
                ON uf.id = ape.uf_id
            WHERE
                nf.id IN ({nf_ids})
                AND ((nf.vr_base_icms_substituicao > 0 AND nf.vr_icms_substituicao > 0) 
                     OR emi.estmvi_sped_fiscal_e200_manual)
                AND uf.sigla = '{estado}'
            LIMIT 1
        """.format(nf_ids=', '.join(map(lambda i: str(i), filtro.get('nf_ids'))),
                   estado=filtro.get('uf'))
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

    def sql_regE250(self, cr, filtro):
        sql = """
            SELECT
                '001'                                       AS cod_or,
                date_part('month', nf.data_saida_entrada)::VARCHAR || date_part(
                    'year', nf.data_saida_entrada)::VARCHAR AS mes_ref,
                fcn.fisnat_codigo_receita_uf_substituido AS cod_rec 
            FROM fiscal_nf_capa nf
            LEFT JOIN estoque_movimento_itens emi
                ON nf.id = emi.nf_id
            LEFT JOIN adm_pessoa ap
                ON nf.destinatario_id = ap.id
            LEFT JOIN adm_pessoa_endereco ape
                ON ap.id = ape.pessoa_id
            LEFT JOIN adm_uf uf
                ON uf.id = ape.uf_id
            LEFT JOIN fiscal_cfop_natureza fcn
                ON fcn.id = nf.natureza_id
            WHERE
                nf.id IN ({nf_ids})
                AND ((nf.vr_base_icms_substituicao > 0 AND nf.vr_icms_substituicao > 0) 
                     OR emi.estmvi_sped_fiscal_e200_manual)
                AND uf.sigla = '{uf}'
            GROUP BY cod_or, mes_ref, uf.sigla, cod_rec
        """.format(nf_ids=', '.join(map(lambda i: str(i), filtro.get('nf_ids'))),
                   uf=filtro.get('uf'))
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

    def sql_regE510(self, cr, nf_ids):
        sql = """
            SELECT
                cfop.codigo AS cfop,
                cst.codigo AS cst,
                sum((SELECT vr_total_item_rateado 
                     FROM estoque_movimento_itens 
                     WHERE id = movimento_itens_id LIMIT 1)) AS vl_cont_ipi,
                sum(fnit.vr_base_calculo) AS vl_bc_ipi,
                sum(fnit.vr_encargo) AS vl_ipi
            FROM
                fiscal_nf_item_tributacao fnit
            LEFT JOIN
                fiscal_cfop cfop ON cfop.id = fnit.fisnit_cfop_id
            LEFT JOIN
                fiscal_cst cst ON cst.id = cst_id
            WHERE
                fnit.encargo_id IN (SELECT id FROM fiscal_encargo WHERE sigla = 'IPI')
                AND fisnit_capa_id IN ({nf_ids})
            GROUP BY cfop, cst
        """.format(nf_ids=', '.join(map(lambda i: str(i), nf_ids)))
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

    def sql_regE520(self, cr, nf_ids):
        sql = """
            SELECT
                sum(CASE
                        WHEN tipo = 'E'
                            THEN COALESCE(vr_ipi, 0)
                        ELSE 0
                    END
                    ) AS vl_cred_ipi
            FROM
                fiscal_nf_capa
            WHERE
                id IN ({nf_ids}) 
        """.format(nf_ids=', '.join(map(lambda i: str(i), nf_ids)))
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

    def sql_regH005(self, cr, custo, inventario_capa_id):
        if custo == 'U':
            _field_custo = """
                Sum(round(eio.saldo * eio.estiof_ultimo_custo, 2)) AS vl_inv
            """
        else:
            _field_custo = """
                Sum(round(eio.saldo * eio.estiof_custo_medio_contabil, 2)) AS vl_inv
            """
        sql = """
                SELECT eic.esticp_data_livro_inventario     AS dt_inv,
                       %s
                FROM   estoque_inventario_oficial eio
                INNER JOIN estoque_inventario_capa eic
                    ON eic.id = eio.capa_id
                WHERE  eio.capa_id = %s
                GROUP BY eic.esticp_data_livro_inventario
        """ % (_field_custo, inventario_capa_id)
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

    def sql_regH010(self, cr, custo, inventario_capa_id):
        if custo == 'U':
            _field_custo = 'inv_oficial.estiof_ultimo_custo        AS vl_unit'
            _field_vl_item = 'Sum(inv_oficial.saldo * inv_oficial.estiof_ultimo_custo) AS vl_item'
        else:
            _field_custo = 'inv_oficial.estiof_custo_medio_contabil AS vl_unit'
            _field_vl_item = 'Sum(inv_oficial.saldo * inv_oficial.estiof_custo_medio_contabil) ' \
                             'AS vl_item'

        sql = """
                SELECT DISTINCT produto.id                              AS produto_id,
                                grade.id                                AS grade_id,
                                CASE
                                  WHEN produto.grade_usar = true 
                                    THEN produto.codigo || ' ' || grade.grade || ' ' || 
                                    produto.estpro_unidade_inventario 
                                  ELSE produto.codigo || ' ' || produto.estpro_unidade_inventario
                                END AS cod_item,
                                produto.estpro_unidade_inventario       AS unid,
                                Sum(inv_oficial.saldo)                  AS qtd,
                                %s,
                                %s
                FROM   estoque_inventario_oficial inv_oficial
                       INNER JOIN estoque_produto produto
                               ON inv_oficial.produto_id = produto.id
                       INNER JOIN estoque_produto_grade grade
                               ON grade.id = inv_oficial.grade_id
                WHERE inv_oficial.capa_id = %s
                GROUP BY cod_item, unid, produto.id, grade.id, vl_unit
        """ % (_field_custo, _field_vl_item, inventario_capa_id)
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

    @staticmethod
    def sql_K200(cr, filtro):
        data_ini = filtro.get('data_ini')
        data_fim = filtro.get('data_fim')
        sql = """
                 SELECT 'K200'     AS reg,
                       produto.id AS produto_id,
                       grade.id   AS grade_id,
                       CASE
                         WHEN produto.grade_usar = TRUE 
                            THEN produto.codigo || ' ' || grade.grade || ' ' || 
                            epe.estpre_unidade_produto
                         ELSE produto.codigo || ' ' || epe.estpre_unidade_produto
                       END        AS cod_item
                FROM   estoque_produto produto
                       inner join estoque_produto_grade grade
                               ON grade.produto_id = produto.id
                       inner join estoque_movimento_itens estmvi
                               ON ( estmvi.produto_id = produto.id
                                    AND estmvi.grade_id = grade.id )
                       inner join estoque_movimento_capa estmvc
                               ON estmvc.id = estmvi.capa_id
                       LEFT JOIN fiscal_nf_capa nf
                               ON nf.id = estmvi.nf_id 
                       LEFT JOIN fiscal_modelo_nf AS modelo
                               ON modelo.id = nf.modelo_nf_id
                       LEFT JOIN estoque_produto_embalagem epe
                               ON estmvi.produto_embalagem_id = epe.id         
                WHERE  produto.tipo_item in ('00', '01', '02', '03', '04', '05', '06', '10')
                       AND data BETWEEN '%s' AND '%s'
                       AND estmvi.nf_id IN (%s)
                       AND modelo.fismnf_codigo NOT IN ('29', '65')
                       %s 
                GROUP  BY reg,
                          produto.id,
                          grade.id,
                          epe.id,
                          cod_item
        """ % (data_ini, data_fim,
               filtro.get('movimento_notas') and ','.join(map(lambda n: str(n), filtro.get(
                   'movimento_notas'))) or '-1',
               filtro.get('movimento_cupons') and 'AND estmvi.cupom_id IN (%s)' % ','.join(map(
                   lambda n: str(n), filtro.get('movimento_cupons'))) or '')
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

    @staticmethod
    def sql_K230(cr, filtro):
        dt_ini = filtro.get('data_ini')
        dt_fim = filtro.get('data_fim')
        sql = """
                 SELECT 'K230'                        AS reg,
                       ordem_producao.id             AS ordem_producao_id,
                       ordem_producao.pcpopr_inicio  AS DT_INI_OP,
                       ordem_producao.pcpopr_termino AS DT_FIN_OP,
                       ordem_producao.pcpopr_numero  AS COD_DOC_OP,
                       CASE
                         WHEN produto.grade_usar = TRUE 
                            THEN produto.codigo || ' ' || grade.grade || ' ' || 
                            epe.estpre_unidade_produto
                         ELSE produto.codigo || ' ' || epe.estpre_unidade_produto
                       END                           AS COD_ITEM,
                       ordem_producao.pcpopr_quantidade_produzida AS QTD_ENC
                FROM   pcp_ordem_producao ordem_producao
                       inner join pcp_ficha_tecnica_capa ficha_tecnica
                               ON ficha_tecnica.id = ordem_producao.pcpopr_ficha_tecnica_capa_id
                       inner join estoque_produto produto
                               ON produto.id = ficha_tecnica.pcpftc_produto_id
                       inner join estoque_produto_grade grade
                               ON grade.id = ficha_tecnica.pcpftc_grade_id
                       left join estoque_produto_embalagem epe
                               ON epe.id = ficha_tecnica.pcpftc_produto_peso_embalagem_id        
                WHERE  state IN( 'F', 'N' )
                       AND ordem_producao.pcpopr_inicio BETWEEN
                           '%s' AND '%s'
                       AND ordem_producao.pcpopr_termino BETWEEN
                           '%s' AND '%s'
        """ % (dt_ini, dt_fim, dt_ini, dt_fim)
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

    @staticmethod
    def sql_K235(cr, filtro):
        ordem_producao_id = filtro.get('ordem_producao_id')
        sql = """
                 SELECT 'K235'                            AS REG,
                       almox_capa.data_hora_recebimento  AS DT_SAIDA,
                       CASE
                         WHEN produto.grade_usar = true 
                            THEN produto.codigo || ' ' || grade.grade || 
                            (CASE 
                                WHEN almox_item.produto_embalagem_id IS NOT NULL 
                                    THEN ' ' || epe.estpre_unidade_produto 
                                ELSE '' 
                            END)
                         ELSE produto.codigo ||
                            (CASE 
                                WHEN almox_item.produto_embalagem_id IS NOT NULL 
                                    THEN ' ' || epe.estpre_unidade_produto 
                                ELSE '' 
                            END)
                       END                               AS COD_ITEM,
                       almox_item.quantidade_requisitada AS QTD
                FROM   almoxarifado_requisicao_capa almox_capa
                       INNER JOIN estoquealmoxarifado_requisicao_item almox_item
                               ON almox_item.requisicao_id = almox_capa.id
                       INNER JOIN estoque_produto produto
                               ON produto.id = almox_item.produto_id
                       INNER JOIN estoque_produto_grade grade
                               ON grade.id = almox_item.grade_id
                       LEFT JOIN estoque_produto_embalagem epe
                               ON epe.id = almox_item.produto_embalagem_id        
                WHERE  almox_capa.almrqc_ordem_producao_id = %d
        """ % ordem_producao_id
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

    @staticmethod
    def sql_apuracoes(cr, apuracao_id, table):
        sql = """
                SELECT SUM(valor) AS valor
                FROM %s
                WHERE apuracao_id = %s
                """ % (table, apuracao_id)
        if table == 'fiscal_apuracao_imposto_outros_creditos':
            sql += """
                     AND fisapuoc_nf_id IS NULL
            """
        cr.execute(sql)
        dados = cr.dictfetchall()
        if dados:
            return dados[0].get('valor') or 0
        else:
            return 0

    @staticmethod
    def sql_reg1200(cr, apuracao):
        """
        REGISTRO 1200: CONTROLE DE CREDITOS FISCAIS - ICMS.
        Este registro demonstra a conta corrente dos creditos fiscais de ICMS, controlados 
        extra-apuracao. Cada UF determinara a obrigatoriedade de apresentacao deste registro.
        
        :param cr: o cursor do banco de dados
        :param apuracao: o ID da apuracao (fiscal_apuracao_imposto)
        :type cr: object
        :type apuracao: long
        :return: dados da consulta com o codigo do ajuste e valor
        :rtype: list
        """
        sql = """
SELECT   apuracao_id
     ,   fisapuoc_codigo_ajuste AS codigo_ajuste
     ,   SUM(valor)             AS valor 
FROM     fiscal_apuracao_imposto_outros_creditos 
WHERE    apuracao_id = %(apuracao)s AND fisapuoc_nf_id IS NULL
GROUP BY apuracao_id, fisapuoc_codigo_ajuste
HAVING   SUM(valor) > 0""" % locals()
        cr.execute(sql)

        return cr.dictfetchall()

    @staticmethod
    def sql_reg1210(cr, apuracao, codigo_ajuste):
        """
        REGISTRO 1210: UTILIZAÇÃO DE CRÉDITOS FISCAIS – ICMS.
        Este registro deve ser apresentado para detalhar a utilização de créditos fiscais de 
        ICMS no período. O somatório dos valores do campo 04 deste registro deve corresponder 
        ao informado no campo 06 do registro 1200
        
        :param cr: o cursor do banco de dados
        :param apuracao: o ID da apuracao (fiscal_apuracao_imposto)
        :param codigo_ajuste: codigo do ajuste fiscal
        :type cr: object
        :type apuracao: long
        :type codigo_ajuste: str
        :return: dados da consulta
        :rtype: list
        """
        sql = """
SELECT fisapuoc_tipo_utilizacao       AS tipo_util
     , valor                          AS vl_cred_util
     , fisapuoc_numero_doc            AS nr_doc
     , fisapuoc_chave_doc_eletronico  AS chv_doc_e
FROM   fiscal_apuracao_imposto_outros_creditos 
WHERE  apuracao_id = %(apuracao)s
  AND  fisapuoc_codigo_ajuste = '%(codigo_ajuste)s'
  AND  valor > 0""" % locals()
        cr.execute(sql)

        return cr.dictfetchall()

    def sql_reg1601(self, cr, dt_ini, dt_fin, ecf_instalado, company_id):
        sql_nf = """
                --NF--
                SELECT
                               pessoa_id,
                               pessoa_tipo,
                               operadora,
                               Sum(valor)         AS valor,
                               cpf_cnpj           AS cpf_cnpj,
                               ie
                        FROM   (SELECT 
                                       afp.admfpg_cartao_pessoa_id AS pessoa_id,
                                       ap.pessoa_tipo              AS pessoa_tipo,
                                       ap.nome                     AS operadora,
                                       Sum(fcp.valor)              AS valor,
                                       afp.tipo_cartao             AS tipo_cartao,
                                       ap.cpf_cnpj                 AS cpf_cnpj,
                                       ap.admpes_jur_ie            AS ie
                                FROM   fiscal_condicao_pagamento fcp
                                       INNER JOIN fiscal_nf_capa fnc
                                               ON fnc.id = fcp.capa_id
                                       INNER JOIN adm_forma_pgto afp
                                               ON afp.id = fcp.forma_pagto_id
                                                  AND afp.cartao_credito_debito = true
                                       INNER JOIN adm_pessoa ap
                                               ON ap.id = afp.admfpg_cartao_pessoa_id
                                WHERE  fnc.data_emissao AT TIME ZONE 'UTC' BETWEEN
                                       '{dt_ini}' AND '{dt_fin}'
                                       AND fnc.state = '3'
                                       AND afp.admfpg_tipo IN ('03', '04', '10', '11', '12', '13', 
                                                               '17', '18', '19')
                                       AND fnc.company_id = {company_id}
                                GROUP  BY pessoa_id,
                                          operadora,
                                          tipo_cartao,
                                          ap.pessoa_tipo,
                                          ap.cpf_cnpj,
                                          ap.admpes_jur_ie
                                ) AS TMP
                        GROUP  BY 
                                  pessoa_id,
                                  operadora,
                                  pessoa_tipo,
                                  cpf_cnpj,
                                  ie
                UNION ALL
                SELECT
                               pessoa_id,
                               pessoa_tipo,
                               operadora,
                               Sum(valor)         AS valor,
                               cpf_cnpj           AS cpf_cnpj,
                               ie
                        FROM   (SELECT 
                                       ap.id                       AS pessoa_id,
                                       ap.pessoa_tipo              AS pessoa_tipo,
                                       ap.nome                     AS operadora,
                                       Sum(fcp.valor)              AS valor,
                                       ap.cpf_cnpj                 AS cpf_cnpj,
                                       ap.admpes_jur_ie            AS ie
                                FROM   fiscal_condicao_pagamento fcp
                                       INNER JOIN fiscal_nf_capa fnc
                                               ON fnc.id = fcp.capa_id
                                       INNER JOIN adm_forma_pgto afp
                                               ON afp.id = fcp.forma_pagto_id
                                       INNER JOIN financeiro_tesouraria_contas ftc
                                               ON ftc.id = afp.admfpg_conta_tesouraria_id
                                       INNER JOIN adm_banco banco
                                               ON banco.id = ftc.banco_id
                                       INNER JOIN adm_pessoa ap
                                                ON ap.id = banco.admbco_pessoa_id
                                WHERE  fnc.data_emissao AT TIME ZONE 'UTC' BETWEEN
                                       '{dt_ini}' AND '{dt_fin}'
                                       AND fnc.state = '3'
                                       AND afp.admfpg_tipo IN ('03', '04', '10', '11', '12', '13', 
                                                               '17', '18', '19')
                                       AND fnc.company_id = {company_id}
                                GROUP  BY pessoa_id,
                                          operadora,
                                          ap.pessoa_tipo,
                                          ap.cpf_cnpj,
                                          ap.admpes_jur_ie
                                ) AS TMP
                        GROUP  BY 
                                  pessoa_id,
                                  operadora,
                                  pessoa_tipo,
                                  cpf_cnpj,
                                  ie

                """.format(dt_ini=dt_ini, dt_fin=dt_fin, company_id=company_id)

        if not ecf_instalado:
            sql_cupom = ''
        else:
            sql_cupom = """
                        --CUPOM--
                        UNION ALL
                        SELECT 
                               pessoa_id,
                               pessoa_tipo,
                               operadora,
                               Sum(valor) AS valor,
                               cpf_cnpj           AS cpf_cnpj,
                               ie
                        FROM   (SELECT 
                                       afp.admfpg_cartao_pessoa_id AS pessoa_id,
                                       ap.pessoa_tipo              AS pessoa_tipo,
                                       ap.nome                     AS operadora,
                                       Sum(ecf.valor)              AS valor,
                                       afp.tipo_cartao             AS tipo_cartao,
                                       ap.cpf_cnpj                 AS cpf_cnpj,
                                       ap.admpes_jur_ie            AS ie
                                FROM   ecf_cupons_finalizacao ecf
                                       INNER JOIN ecf_cupons_capa ecc
                                               ON ecc.id = ecf.cupom_id
                                       INNER JOIN adm_condicao_forma acf
                                               ON acf.id = ecf.finalizadora_id
                                       INNER JOIN adm_forma_pgto afp
                                               ON afp.id = acf.forma_pagamento_id
                                                  AND afp.cartao_credito_debito = true
                                       INNER JOIN adm_pessoa ap
                                               ON ap.id = afp.admfpg_cartao_pessoa_id
                                WHERE  ecc.date_cupom BETWEEN
                                       '{dt_ini}' AND '{dt_fin}'
                                       AND ecc.state = 'V'
                                       AND ecc.tipo_cupom = 'V'
                                       AND ecf.tipo_finalizadora = 'C'
                                       AND afp.tipo_cartao IN ('C', 'D')
                                       AND ecc.company_id = {company_id}
                                GROUP  BY pessoa_id,
                                          operadora,
                                          tipo_cartao,
                                          ecf.tipo_finalizadora,
                                          ap.pessoa_tipo,
                                          ap.cpf_cnpj,
                                          ap.admpes_jur_ie
                                ) AS TMP
                        GROUP  BY 
                                  pessoa_id,
                                  operadora,
                                  pessoa_tipo,
                                  cpf_cnpj,
                                  ie

            """.format(dt_ini=dt_ini, dt_fin=dt_fin, company_id=company_id)

        sql = """
            SELECT 
                   MOV_ELETRONICO.pessoa_id,
                   pessoa_tipo,
                   operadora,
                   (SELECT codigo_bc
                    FROM   adm_pais
                    WHERE  id = ape.pais_id
                    LIMIT  1)                  AS cod_pais,
                   cpf_cnpj                    AS cpf_cnpj,
                   Sum(valor)                  AS valor,
                   ie,
                   (SELECT codigo_ibge
                    FROM   adm_cidade
                    WHERE  id = ape.cidade_id
                    LIMIT  1)                  AS cod_mun,
                   (SELECT admpes_jur_suframa
                    FROM   adm_pessoa
                    WHERE  id = MOV_ELETRONICO.pessoa_id
                    LIMIT  1)                  AS suframa,
                   (SELECT descricao
                    FROM   adm_logradouro
                    WHERE  id = ape.logradouro_id
                    LIMIT  1)                  AS endr,
                   ape.numero                  AS num,
                   ape.complemento             AS compl,
                   (SELECT name
                    FROM   adm_bairro
                    WHERE  id = ape.bairro_id) AS bairro
            FROM   ({sql_nf}
                    {sql_cupom}) AS MOV_ELETRONICO
                   LEFT JOIN adm_pessoa_endereco ape
                          ON ape.pessoa_id = MOV_ELETRONICO.pessoa_id
            GROUP  BY 
                      MOV_ELETRONICO.pessoa_id,
                      operadora,
                      pessoa_tipo,
                      ape.pais_id,
                      cpf_cnpj,
                      ie,
                      cod_mun,
                      endr,
                      num,
                      compl,
                      bairro
        """.format(sql_nf=sql_nf, sql_cupom=sql_cupom)
        cr.execute(sql)
        dados = cr.dictfetchall()
        return dados

    @staticmethod
    def dictfetchall(cr):
        """Retorna todas as linhas de um cursor como um dicionario"""
        desc = cr.description
        return [dict(zip([col[0] for col in desc], row)) for row in cr.fetchall()]

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

