# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from datetime import date, timedelta, datetime
from openerp.tools.translate import _
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
from openerp import netsvc
from openerp import pooler
import time


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_apuracao_ipi(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        pdf_file = StringIO.StringIO()
        db_name = pooler.get_pool(cr.dbname)
        company_id = db_name.get('res.users').browse(cr, uid, uid, context=context).company_id.id
        cnpj = ''
        if company_id:
            empresa_name = db_name.get("res.company").read(cr, uid, company_id, ['name'], context=context)
            if isinstance(empresa_name, list):
                empresa_name = empresa_name[0]
            if isinstance(empresa_name, dict):
                empresa_name = empresa_name.get('name', '')
            pessoa_id = db_name.get('adm.pessoa').search(cr, uid, [('name', '=', empresa_name)], context=context)
            if pessoa_id:
                n_cnpj = db_name.get('adm.pessoa').read(cr, uid, pessoa_id, ['cpf_cnpj'], context=context)
                if isinstance(n_cnpj, list):
                    n_cnpj = n_cnpj[0]
                n_cnpj = n_cnpj.get('cpf_cnpj')
                cnpj = formataString(n_cnpj, 90, ' ', 'D', 'N', 'S')
            obj_pessoa_dados = db_name.get('adm.pessoa.documento.dados')
            pessoa_dados_id = obj_pessoa_dados.search(cr, uid, [('pessoa_id', '=', company_id)], context=context)
            ie = ''
            if pessoa_dados_id:
                ie = obj_pessoa_dados.read(cr, uid, pessoa_dados_id[0], ['numero'], context=context)
                if isinstance(ie, list):
                    ie = ie[0]
                if isinstance(ie, dict):
                    ie = str(ie.get('numero') or '')
            nome_empresa = formataString(empresa_name, 17, ' ', 'D', 'N', 'S')
            ie = formataString(ie, 15, ' ', 'D', 'N', 'S')
            periodo = formataString(
                time.strftime("%d-%m-%Y", time.strptime(datas['periodo_inicial'], "%Y-%m-%d")) + ' A ' + time.strftime(
                    "%d-%m-%Y", time.strptime(datas['periodo_final'], "%Y-%m-%d")), 99, ' ', 'D', 'N', 'S')

            listagem = Impressora()
            listagem.defineFormato(orientacao='0')
            listagem.informaNome(pdf_file, 'Registro de IPI')
            listagem.informaTamLinha(120)
            listagem.defineMargem(1, 1, 1, 1)
            listagem.setPage(datas['folha'] - 1)

            self.relat_cabecalho(cr, uid, listagem, nome_empresa, cnpj, ie, periodo)
            entrada = self.relat_entrada(cr, uid, ids, datas, listagem, context)
            saida = self.relat_saida(cr, uid, ids, datas, listagem, context)

            credito = self.relat_credito(cr, uid, ids, datas, listagem, entrada, context={})
            debito = self.relat_debito(cr, uid, ids, datas, listagem, saida, context={})

            valor_trasport = self.relat_apuracao_saldo(cr, uid, ids, listagem, credito, debito, context)

            listagem.finalizaImpressao()

            parametro_id = db_name.get('wizard.apuracao.ipi').parametro_id(cr, uid, ids, context)
            if parametro_id:
                db_name.get('adm.paginas').write(cr, uid, parametro_id,
                                                 {'inicial': datas['folha'], 'tipo': 'wizard_apuracao_ipi'})
            db_name.get('fiscal.apuracao.imposto').write(cr, uid, datas['apuracao_ipi_id'],
                                                         {'saldo_credor': valor_trasport}, context)

            # Cria o registro do proximo mes/ano
            ano = datas['periodo_final'][:4]
            mes = int(datas['periodo_final'][5:7])
            tipo = datas['tipo']
            apuracao = '%s-%s-01' % (ano, mes)

            if not db_name.get('fiscal.apuracao.imposto').search(
                cr, uid, [('mes', '=', mes), ('ano', '=', ano), ('tipo', '=', tipo)], context=context):
                db_name.get('fiscal.apuracao.imposto').create(
                    cr, uid, dict(tipo=tipo, ano=ano, mes=mes, data_apuracao=apuracao,
                                  saldo_credor=0.0), context=context)

            self.obj = external_pdf(pdf_file.getvalue())
            self.obj.render()
            pdf_file.close()
            return (self.obj.pdf, 'pdf')


    def relat_cabecalho(self, cr, uid, listagem, nome_empresa, cnpj, ie, periodo):
        listagem.informaCab(
            _('*--------------------------------------------------------------------------------------------------------------------------------------------------*'))
        listagem.informaCab(
            _('|                                             REGISTRO DE APURACAO DO IPI - MODELO 8                                                               |'))
        listagem.informaCab(
            _('|FIRMA: ') + nome_empresa + _('                                                                                                                          |'))
        listagem.informaCab(
            _('|                                                                                                                                                  |'))
        listagem.informaCab(_('|INSCR.ESTADUAL: ') + ie + _('               CNPJ(MF): ') + cnpj + _('|'))
        listagem.informaCab(_('|FOLHA: {{ Page }}                 MES OU PERIODO/ANO: ') + periodo + _('|'))

    def relat_entrada(self, cr, uid, ids, datas, listagem, context=None):
        context = context and context.copy() or {}
        listagem.imprimeLinha(
            _('|-------------------------------------------------------------------------------------------------------- ENTRADAS --------------------------------|'))
        listagem.imprimeLinha(
            _('|                   |                                      |              |                                                                        |'))
        listagem.imprimeLinha(
            _('|     CODIFICACAO   |                                      |              |                         IPI - VALORES FISCAIS                          |'))
        listagem.imprimeLinha(
            _('|-------------------|                                      |   VALORES    |------------------------------------------------------------------------|'))
        listagem.imprimeLinha(
            _('|                   |              NATUREZA                |              |   OPERACOES COM CREDITO DO IMPOSTO  | OPERACOES SEM CREDITO DO IMPOSTO |'))
        listagem.imprimeLinha(
            _('| CONTABIL | FISCAL |                                      |  CONTABEIS   |------------------------------------------------------------------------|'))
        listagem.imprimeLinha(
            _('|          |        |                                      |              | BASE DE CALCULO | IMPOSTO CREDITADO |ISENTOS N/ TRIBUTADOS|   OUTRAS   |'))
        listagem.imprimeLinha(
            _('|--------------------------------------------------------------------------------------------------------------------------------------------------|'))

        sql = """
              select cf.codigo, cf.descricao,
                   Sum(it.vr_total_item) as vr_contab,
                   Sum(it_tr.vr_base_calculo) as vr_base,
                   Sum(case when it_cst.codigo in ( '10','70') then it_tr.vr_encargo Else 0 end) as ImpCred,
                   Sum(case when it_cst.codigo in ( '40','41','30','02') then it_tr.vr_encargo Else 0 end )as ImpIsen,
                   Sum(case when it_cst.codigo not in ( '10','70','40','41','30','02') then it_tr.vr_encargo Else 0 end) as ImpOut
              from fiscal_nf_capa nf,
                   estoque_movimento_itens it ,
                   fiscal_nf_item_tributacao it_tr,
                   fiscal_cst it_cst,
                   fiscal_encargo enc,
                   fiscal_cfop cf
              where 1=1
                   and it.nf_id = nf.id
                   and it.id = it_tr.movimento_itens_id
                   and it_tr.cst_id = it_cst.id
                   and it_cst.encargo_id = enc.id
                   and enc.sigla = 'IPI'
                   and it.cfop_id = cf.id
                   and nf.tipo= 'E'
                   and nf.modelo_nf_id not in (select id from fiscal_modelo_nf where
			       fismnf_codigo not in ('1B','1A','2D','2E','8B', 'NF') and  CAST ( fismnf_codigo AS numeric)  >= 90)
                   and nf.data_saida_entrada >= '%s'
                   and nf.data_saida_entrada < '%s'
              group by cf.codigo, cf.descricao
              order by cf.codigo
            """ % (datas['periodo_inicial'], datas['periodo_final'])

        cr.execute(sql)
        datas['movimento'] = cr.dictfetchall()

        cfop_1 = []
        cfop_2 = []
        cfop_3 = []

        for i in datas['movimento']:
            if i['codigo'][0] == '1':
                cfop_1.append(i)
            elif i['codigo'][0] == '2':
                cfop_2.append(i)
            elif i['codigo'][0] == '3':
                cfop_3.append(i)

        total = []

        total_cfop = self.listagem_cfop(listagem, cfop_1, '1', "E")
        total.append(self.listagem_cfop_agrupamento(listagem, total_cfop, '1', "E"))
        if cfop_1:
            listagem.imprimeLinha(
                _('|--------------------------------------------------------------------------------------------------------------------------------------------------|'))

        listagem.imprimeLinha(
            _('|                                                                                                                                                  |'))
        listagem.imprimeLinha(
            _('|--------------------------------------------------------------------------------------------------------------------------------------------------|'))
        total_cfop = self.listagem_cfop(listagem, cfop_2, '2', "E")
        total.append(self.listagem_cfop_agrupamento(listagem, total_cfop, '2', "E"))
        if cfop_2:
            listagem.imprimeLinha(
                _('|--------------------------------------------------------------------------------------------------------------------------------------------------|'))
        if cfop_3:
            listagem.imprimeLinha(
                _('|                                                                                                                                                  |'))
            listagem.imprimeLinha(
                _('|--------------------------------------------------------------------------------------------------------------------------------------------------|'))
        total_cfop = self.listagem_cfop(listagem, cfop_3, '3', "E")
        total.append(self.listagem_cfop_agrupamento(listagem, total_cfop, '3', "E"))

        self.listagem_valor_total(listagem, total, 'E')

        debitos = self.demonstrativo_credito_debito(datas['movimento'], "E")
        return debitos

    def relat_saida(self, cr, uid, ids, datas, listagem, periodo, context=None):
        context = context and context.copy() or {}
        listagem.imprimeLinha('{{ Page }}')
        listagem.imprimeLinha(
            _('|-------------------------------------------------------------------------------------------------------- SAIDAS ----------------------------------|'))
        listagem.imprimeLinha(
            _('|                   |                                      |              |                                                                        |'))
        listagem.imprimeLinha(
            _('|     CODIFICACAO   |                                      |              |                         IPI - VALORES FISCAIS                          |'))
        listagem.imprimeLinha(
            _('|-------------------|                                      |   VALORES    |------------------------------------------------------------------------|'))
        listagem.imprimeLinha(
            _('|                   |              NATUREZA                |              |   OPERACOES COM CREDITO DO IMPOSTO  | OPERACOES SEM CREDITO DO IMPOSTO |'))
        listagem.imprimeLinha(
            _('| CONTABIL | FISCAL |                                      |  CONATABEIS  |------------------------------------------------------------------------|'))
        listagem.imprimeLinha(
            _('|          |        |                                      |              | BASE DE CALCULO | IMPOSTO DEBITADO  |ISENTOS N/ TRIBUTADOS|   OUTRAS   |'))
        listagem.imprimeLinha(
            _('|--------------------------------------------------------------------------------------------------------------------------------------------------|'))

        sql = """
              select cf.codigo, cf.descricao,
                   Sum(it.vr_total_item) as vr_contab,
                   Sum(it_tr.vr_base_calculo) as vr_base,
                   Sum(case when it_cst.codigo in ( '10','70') then it_tr.vr_encargo Else 0 end) as ImpCred,
                   Sum(case when it_cst.codigo in ( '40','41','30','02') then it_tr.vr_encargo Else 0 end )as ImpIsen,
                   Sum(case when it_cst.codigo not in ( '10','70','40','41','30','02') then it_tr.vr_encargo Else 0 end) as ImpOut
              from fiscal_nf_capa nf,
                   estoque_movimento_itens it ,
                   fiscal_nf_item_tributacao it_tr,
                   fiscal_cst it_cst,
                   fiscal_encargo enc,
                   fiscal_cfop cf
              where 1=1
                   and it.nf_id = nf.id
                   and it.id = it_tr.movimento_itens_id
                   and it_tr.cst_id = it_cst.id
                   and it_cst.encargo_id = enc.id
                   and enc.sigla = 'IPI'
                   and it.cfop_id = cf.id
                   and nf.tipo= 'S'
                   and nf.modelo_nf_id not in (select id from fiscal_modelo_nf where
			       fismnf_codigo not in ('1B','1A','2D','2E','8B', 'NF') and  CAST ( fismnf_codigo AS numeric)  >= 90)
                   and nf.data_saida_entrada >= '%s'
                   and nf.data_saida_entrada < '%s'
              group by cf.codigo, cf.descricao
              order by cf.codigo
            """ % (datas['periodo_inicial'], datas['periodo_final'])

        cr.execute(sql)
        datas['movimento'] = cr.dictfetchall()

        cfop_5 = []
        cfop_6 = []
        cfop_7 = []

        for i in datas['movimento']:
            if i['codigo'][0] == '5':
                cfop_5.append(i)
            elif i['codigo'][0] == '6':
                cfop_6.append(i)
            elif i['codigo'][0] == '7':
                cfop_7.append(i)

        total = []

        total_cfop = self.listagem_cfop(listagem, cfop_5, '5', "S")
        total.append(self.listagem_cfop_agrupamento(listagem, total_cfop, '5', "S"))
        if cfop_5:
            listagem.imprimeLinha(
                _('|--------------------------------------------------------------------------------------------------------------------------------------------------|'))
        if cfop_6:
            listagem.imprimeLinha(
                _('|                                                                                                                                                  |'))
            listagem.imprimeLinha(
                _('|--------------------------------------------------------------------------------------------------------------------------------------------------|'))
        total_cfop = self.listagem_cfop(listagem, cfop_6, '6', "S")
        total.append(self.listagem_cfop_agrupamento(listagem, total_cfop, '6', "S"))
        listagem.imprimeLinha(
            _('|--------------------------------------------------------------------------------------------------------------------------------------------------|'))
        if cfop_7:
            listagem.imprimeLinha(
                _('|                                                                                                                                                  |'))
            listagem.imprimeLinha(
                _('|--------------------------------------------------------------------------------------------------------------------------------------------------|'))
        total_cfop = self.listagem_cfop(listagem, cfop_6, '7', "S")
        total.append(self.listagem_cfop_agrupamento(listagem, total_cfop, '7', "S"))
        creditos = self.demonstrativo_credito_debito(datas['movimento'], "S")

        self.listagem_valor_total(listagem, total, 'S')

        return creditos

    def listagem_cfop(self, listagem, cfops, codigo_cfop, relat):

        total_contab = 0
        total_base = 0
        total_impcred_deb = 0
        total_impsen = 0
        total_outras = 0

        for i in cfops:
            word = ''
            tamanho_linha = 38
            if i.get('descricao', False):
                word = i['descricao'].split(' ')
            cont = 0
            frase = ""
            campo = 0
            len_word = len(word)
            one = True
            for j in word:
                cont += 1
                size_i = len(j)
                if size_i + campo < tamanho_linha:
                    frase = frase + j + ' '
                    campo = len(frase)
                elif size_i + campo > tamanho_linha:
                    frase = formataString('' + frase, tamanho_linha, ' ', 'D', 'N', 'S')
                    if not one:
                        listagem.imprimeLinha(
                            _('|          |        |' + frase + '|              |                 |                   |                     |            |'))
                    elif one:
                        codigo = formataString(i['codigo'], 8, ' ', 'C', 'N', 'S')
                        listagem.imprimeLinha(
                            _('|          |' + codigo + _('|') + frase + '|              |                 |                   |                     |            |'))
                        one = False
                    frase = ''
                    frase = frase + j + ' '
                    campo = len(frase)
                if cont == len_word:
                    frase = formataString('' + frase, tamanho_linha, ' ', 'D', 'N', 'S')
                    vr_contab = formataString('%1.2f' % i['vr_contab'], 14, ' ', 'E', 'N', 'S')
                    vr_base = formataString('%1.2f' % i['vr_base'], 17, ' ', 'E', 'N', 'S')
                    impcred = formataString('%1.2f' % i['impcred'], 19, ' ', 'E', 'N', 'S')
                    impisen = formataString('%1.2f' % i['impisen'], 21, ' ', 'E', 'N', 'S')
                    impout = formataString('%1.2f' % i['impout'], 12, ' ', 'E', 'N', 'S')
                    if one:
                        codigo = formataString(i['codigo'], 8, ' ', 'C', 'N', 'S')
                        listagem.imprimeLinha(
                            _('|          |') + codigo + _('|') + frase + _('|') + vr_contab + _('|') + vr_base + _('|') + impcred + _('|') + impisen + _('|') + impout + _('|'))
                    else:
                        listagem.imprimeLinha(
                            _('|          |        |') + frase + _('|') + vr_contab + _('|') + vr_base + _('|') + impcred + _('|') + impisen + _('|') + impout + _('|'))
            listagem.imprimeLinha(
                _('|--------------------------------------------------------------------------------------------------------------------------------------------------|'))
            total_contab += i['vr_contab']
            total_base += i['vr_base']
            total_impcred_deb += i['impcred']
            total_impsen += i['impisen']
            total_outras += i['impout']

        cfops = [{'total_contab': total_contab, 'total_base': total_base, 'total_imp_cred_deb': total_impcred_deb,
                  'total_impsen': total_impsen, 'total_outras': total_outras}]

        for i in cfops:
            i['total_contab'] = formataString('%1.2f' % i['total_contab'], 14, ' ', 'E', 'N', 'S')
            i['total_base'] = formataString('%1.2f' % i['total_base'], 17, ' ', 'E', 'N', 'S')
            i['total_imp_cred_deb'] = formataString('%1.2f' % i['total_imp_cred_deb'], 19, ' ', 'E', 'N', 'S')
            i['total_impsen'] = formataString('%1.2f' % i['total_impsen'], 21, ' ', 'E', 'N', 'S')
            i['total_outras'] = formataString('%1.2f' % i['total_outras'], 12, ' ', 'E', 'N', 'S')

        return cfops

    def listagem_cfop_agrupamento(self, listagem, total, codigo_cfop, tipo_relat):

        if codigo_cfop == '1' or codigo_cfop == '5':
            if tipo_relat == "E":
                descricao = _("TOTAL DE ENTRADAS DO ESTADO")
                codigo = "1000"
            else:
                descricao = _("TOTAL DE SAIDAS DO ESTADO")
                codigo = "5000"

        elif codigo_cfop == '2' or codigo_cfop == '6':
            if tipo_relat == "E":
                descricao = _("TOTAL DE ENTRADAS FORA DO ESTADO")
                codigo = "2000"
            else:
                descricao = _("TOTAL DE SAIDAS FORA DO ESTADO")
                codigo = "6000"

        elif codigo_cfop == '3' or codigo_cfop == '7':
            if tipo_relat == "E":
                descricao = _("TOTAL DE ENTRADAS DO EXTERIOR")
                codigo = "3000"
            else:
                descricao = _("TOTAL DE SAIDAS PARA EXTERIOR")
                codigo = "7000"

        descricao = formataString(descricao, 38, ' ', 'D', 'N', 'S')
        codigo = formataString(codigo, 8, ' ', 'C', 'N', 'S')

        total_contab = 0
        total_base = 0
        total_imp_cred_deb = 0
        total_impsen = 0
        total_outra = 0

        contab = 0
        base = 0
        imp_cred_deb = 0
        impsen = 0
        outra = 0

        for j in total:
            contab = float(j['total_contab'])
            base = float(j['total_base'])
            imp_cred_deb = float(j['total_imp_cred_deb'])
            impsen = float(j['total_impsen'])
            outra = float(j['total_outras'])

            if contab > 0 or base > 0 or imp_cred_deb > 0 or impsen > 0 or outra > 0:
                listagem.imprimeLinha(
                    '|          |' + codigo + _('|') + descricao + _('|') + j['total_contab'] + _('|') + j['total_base'] + _('|') +
                    j['total_imp_cred_deb'] + _('|') + j['total_impsen'] + _('|') + j['total_outras'] + _('|'))

            total_contab += contab
            total_base += base
            total_imp_cred_deb += imp_cred_deb
            total_impsen += impsen
            total_outra += outra

        return {'total_contab': total_contab, 'total_base': total_base, 'total_imp_cred_deb': total_imp_cred_deb,
                'total_impsen': total_impsen, 'total_outra': total_outra}

    def listagem_valor_total(self, listagem, total, tipo):

        descricao = _("TOTAL GERAL DAS ")
        if tipo == "E":
            descricao = descricao + _("ENTRADAS")
        else:
            descricao = descricao + _("SAIDAS")
        contab = 0.0
        base = 0.0
        imp_cred_deb = 0.0
        imp_isen = 0.0
        outras = 0.0
        #        listagem.imprimeLinha('|--------------------------------------------------------------------------------------------------------------------------------------------------|')
        for i in total:
            contab += i['total_contab']
            base += i['total_base']
            imp_cred_deb += i['total_imp_cred_deb']
            imp_isen += i['total_impsen']
            outras += i['total_outra']

        contab = formataString('%1.2f' % contab, 14, ' ', 'E', 'N', 'S')
        base = formataString('%1.2f' % base, 17, ' ', 'E', 'N', 'S')
        imp_cred_deb = formataString('%1.2f' % imp_cred_deb, 19, ' ', 'E', 'N', 'S')
        imp_isen = formataString('%1.2f' % imp_isen, 21, ' ', 'E', 'N', 'S')
        outras = formataString('%1.2f' % outras, 12, ' ', 'E', 'N', 'S')
        descricao = formataString(descricao, 38, ' ', 'D', 'N', 'S')

        listagem.imprimeLinha(
            _('|          |        |') + descricao + _('|') + contab + _('|') + base + _('|') + imp_cred_deb + _('|') + imp_isen + _('|') + outras + _('|'))
        listagem.imprimeLinha(
            _('*--------------------------------------------------------------------------------------------------------------------------------------------------*'))
        listagem.imprimeLinha(
            _('                                                                                         ** Sig Informatica Ltda **                                 '))

    def relat_credito(self, cr, uid, ids, datas, listagem, entrada, context=None):
        context = context and context.copy() or {}
        vr_total = 0
        outros_creditos = 0
        listagem.imprimeLinha('{{ Page }}')
        listagem.imprimeLinha(
            _('|--------------------------------------------------------------------------------------------------------------------------------------------------|'))
        listagem.imprimeLinha(
            _('|                                  DEMONSTRATIVO DE CREDITOS                                                 |               VALORES               |'))
        listagem.imprimeLinha(
            _('|--------------------------------------------------------------------------------------------------------------------------------------------------|'))
        listagem.imprimeLinha(
            _('|                                                                                                            |                                     |'))
        listagem.imprimeLinha(
            _('| 001 - POR ENTRADAS DO MERCADO NACIONAL                                                                     |') +
            entrada['nacional'] + _('|'))
        listagem.imprimeLinha(
            _('| 002 - POR ENTRADAS DO MERCADO EXTERNO                                                                      |') +
            entrada['externo'] + _('|'))
        listagem.imprimeLinha(
            _('| 003 - POR SAIDAS PARA O MERCADO EXTERNO                                                                    |') +
            entrada['mercado_externo'] + _('|'))
        if datas['estorno_debitos_ids']:
            vr_total += self.listar_descricao_valor(cr, uid, listagem, datas['estorno_debitos_ids'],
                                                    'fiscal.apuracao.imposto.estorno.debitos', context=context)
        listagem.imprimeLinha(
            _('| 004 - ESTORNO DE DEBITOS                                                                                   |') + formataString(
                getNumeroEditado(vr_total, 2, '.'), 37, '', 'C') + _('|'))
        listagem.imprimeLinha(
            _('|                                                                                                            |                                     |'))
        if datas['outros_creditos_ids']:
            outros_creditos = self.listar_descricao_valor(cr, uid, listagem, datas['outros_creditos_ids'],
                                                          'fiscal.apuracao.imposto.outros.creditos', context=context)
            vr_total += outros_creditos
        listagem.imprimeLinha(
            _('| 005 - OUTROS CREDITOS                                                                                      |') + formataString(
                getNumeroEditado(outros_creditos, 2, '.'), 37, '', 'C') + _('|'))
        listagem.imprimeLinha(
            _('|                                                                                                            |                                     |'))

        sub_total = vr_total + float(entrada['nacional']) + float(entrada['externo']) + float(
            entrada['mercado_externo'])
        sub_total = formataString(str('%1.2f' % sub_total), 37, ' ', 'C', 'N', 'S')
        listagem.imprimeLinha(
            _('| 006 - SUBTOTAL                                                                                             |') + sub_total + _('|'))

        saldo_credor = datas['saldo_credor_anterior']
        saldo_credor = formataString(str('%1.2f' % saldo_credor), 37, ' ', 'C', 'N', 'S')
        listagem.imprimeLinha(
            _('| 007 - SALDO CREDOR NO PERIODO ANTERIOR                                                                     |') + saldo_credor + _('|'))

        total = float(sub_total) + float(saldo_credor)
        total = formataString(str('%1.2f' % total), 37, ' ', 'C', 'N', 'S')
        listagem.imprimeLinha(
            _('| 008 - TOTAL                                                                                                |') + total + _('|'))
        if datas.get('observacao'):
            listagem.imprimeLinha(
                _('|--------------------------------------------------------------------------------------------------------------------------------------------------|'))
            listagem.imprimeLinha(
                _('|--[ OBSERVACOES ]---------------------------------------------------------------------------------------------------------------------------------|'))
            tamanho_linha = 146
            word = datas['observacao'].split(' ')
            frase = ""
            cont = 0
            len_word = len(word)
            campo = 0
            for j in word:
                cont += 1
                size_i = len(j)
                if size_i + campo < tamanho_linha:
                    frase = frase + j + ' '
                    campo = len(frase)
                elif size_i + campo > tamanho_linha:
                    frase = formataString('' + frase, tamanho_linha, ' ', 'D', 'N', 'S')
                    listagem.imprimeLinha('|' + frase + _('|'))
                    frase = ''
                    frase = frase + j + ' '
                    campo = len(frase)
                if cont == len_word:
                    frase = formataString('' + frase, tamanho_linha, ' ', 'D', 'N', 'S')
                    listagem.imprimeLinha('|' + frase + _('|'))
        else:
            listagem.imprimeLinha(
                _('|                                                                                                                                                  |'))
        return float(total)

    def relat_debito(self, cr, uid, ids, datas, listagem, saidas, context=None):
        context = context and context.copy() or {}
        vr_total = 0
        outros_debitos = 0
        listagem.imprimeLinha(
            _('|--------------------------------------------------------------------------------------------------------------------------------------------------|'))
        listagem.imprimeLinha(
            _('|                                  DEMONSTRATIVO DE DEBITOS                                                  |               VALORES               |'))
        listagem.imprimeLinha(
            _('|--------------------------------------------------------------------------------------------------------------------------------------------------|'))
        listagem.imprimeLinha(
            _('|                                                                                                            |                                     |'))
        listagem.imprimeLinha(
            _('| 009 - POR SAIDAS PARA O MERCADO NACIONAL                                                                   |') +
            saidas['nacional'] + _('|'))
        if datas['estorno_creditos_ids']:
            vr_total += self.listar_descricao_valor(cr, uid, listagem, datas['estorno_creditos_ids'],
                                                    'fiscal.apuracao.imposto.estorno.creditos', context=context)
        listagem.imprimeLinha(
            _('| 010 - ESTORNO DE CREDITOS                                                                                  |') + formataString(
                getNumeroEditado(vr_total, 2, '.'), 37, '', 'C') + _('|'))
        listagem.imprimeLinha(
            _('|                                                                                                            |                                     |'))

        listagem.imprimeLinha(
            _('| 011 - RESSARCIMENTO DE CREDITOS                                                                            |') + formataString(
                getNumeroEditado(datas.get('ressarcimento_creditos', 0.0), 2, '.'), 37, '', 'C') + _('|'))
        if datas['outros_debitos_ids']:
            outros_debitos = self.listar_descricao_valor(cr, uid, listagem, datas['outros_debitos_ids'],
                                                         'fiscal.apuracao.imposto.outros.debitos', context=context)
            vr_total += outros_debitos
        listagem.imprimeLinha(
            _('| 012 - OUTROS DEBITOS                                                                                       |') + formataString(
                getNumeroEditado(outros_debitos, 2, '.'), 37, '', 'C') + _('|'))
        listagem.imprimeLinha(
            _('|                                                                                                            |                                     |'))

        total = vr_total + float(saidas['nacional'])
        total = formataString(str('%1.2f' % total), 37, ' ', 'C', 'N', 'S')
        listagem.imprimeLinha(
            _('| 013 - TOTAL                                                                                                |') + total + _('|'))
        listagem.imprimeLinha(
            _('|--------------------------------------------------------------------------------------------------------------------------------------------------|'))

        return float(total)

    def relat_apuracao_saldo(self, cr, uid, ids, listagem, credito, debito, context=None):
        context = context and context.copy() or {}
        credor = credito - debito
        devedor = debito - credito

        if devedor < 0:
            devedor = 0

        if credor < 0:
            credor = 0



        #        debito = formataString(str('%1.2f'%debito),37,' ','C','N','S')
        #        credito = formataString(str('%1.2f'%credito),37,' ','C','N','S')

        listagem.imprimeLinha(
            _('|------------------------------------[ APURACAO DO SALDO ]-----------------------------------------------------------------------------------------|'))
        listagem.imprimeLinha(
            _('| 014 - DEBITO TOTAL(=ITEM 13)                                                                               |%9.2f|') % debito)
        listagem.imprimeLinha(
            _('| 015 - CREDITO TOTAL(=ITEM 008)                                                                             |%9.2f|') % credito)
        listagem.imprimeLinha(
            _('| 016 - SALDO DEVEDOR(ITEM 014 - ITEM 015)                                                                   |%9.2f|') % devedor)
        listagem.imprimeLinha(
            _('| 017 - SALDO CREDOR (ITEM 015 - ITEM 014)                                                                   |%9.2f|') % credor)
        listagem.imprimeLinha(
            _('|--------------------------------------------------------------------------------------------------------------------------------------------------|'))

        listagem.imprimeLinha(
            _('|--------------------------------------------------------------------------------------------------------------------------------------------------|'))
        listagem.imprimeLinha(
            _('|                                            DISTRIBUICAO DO SALDO DEVEDOR PELOS PRAZOS DE RECOLHIMENTO                                            |'))
        listagem.imprimeLinha(
            _('|--------------------------------------------------------------------------------------------------------------------------------------------------|'))
        listagem.imprimeLinha(
            _('| DATA VENCIMENTO |     VALOR     ||  DATA VENCIMENTO  |      VALOR       ||  DATA VENCIMENTO |     VALOR      || DATA VENCIMENTO |      VALOR     |'))
        listagem.imprimeLinha(
            _('|-----------------+---------------++-------------------+------------------++------------------+----------------++-----------------+----------------|'))
        listagem.imprimeLinha(
            _('|                 |               ||                   |                  ||                  |                ||                 |                |'))
        listagem.imprimeLinha(
            _('|                 |               ||                   |                  ||                  |                ||                 |                |'))
        listagem.imprimeLinha(
            _('|                 |               ||                   |                  ||                  |                ||                 |                |'))
        listagem.imprimeLinha(
            _('*--------------------------------------------------------------------------------------------------------------------------------------------------*'))
        listagem.imprimeLinha(
            _('                                                                                         ** Sig Informatica Ltda **                                 '))
        return credor

    def listar_descricao_valor(self, cr, uid, listagem, datas, tabela, context=None):
        context = context and context.copy() or {}
        db_name = pooler.get_pool(cr.dbname)
        obj_wizard_ipi_abas = db_name.get(tabela)
        # RECEBER DATAS CONTENDO UMA LISTA COM OS IDS
        wizard_ipi_abas_dados = obj_wizard_ipi_abas.read(cr, uid, datas, context=context)
        valor_total = 0
        if wizard_ipi_abas_dados:
            for i in wizard_ipi_abas_dados:
                valor_total += i['valor']
                descricao = formataString('       ' + i['descricao'], 108, ' ', 'D', 'N', 'S')
                valor = formataString(str('%1.2f' % i['valor']), 37, ' ', 'C', 'N', 'S')
                listagem.imprimeLinha('|' + descricao + _('|') + valor + _('|'))
        return float(valor_total)

    def demonstrativo_credito_debito(self, datas, relat):
        linha = 37
        saldo_nacional = 0
        saldo_externo = 0
        movimento_externo = 0
        if relat == "E":
            cfop = '1'
            cfop2 = '2'
        else:
            cfop = '5'
            cfop2 = '6'

        for i in datas:
            codigo = i['codigo'][0]
            if codigo == cfop or codigo == cfop2:
                saldo_nacional += i['impcred']
            elif codigo == '3':
                saldo_externo += i['impcred']
            elif codigo == '7':
                movimento_externo += i['impcred']

        saldo_nacional = formataString(str('%1.2f' % saldo_nacional), linha, ' ', 'C', 'N', 'S')
        saldo_externo = formataString(str('%1.2f' % saldo_externo), linha, ' ', 'C', 'N', 'S')
        movimento_externo = formataString(str('%1.2f' % movimento_externo), linha, ' ', 'C', 'N', 'S')

        if relat == "E":
            return {'nacional': saldo_nacional, 'externo': saldo_externo, 'mercado_externo': movimento_externo}
        else:
            return {'nacional': saldo_nacional, 'externo': saldo_externo}


report_apuracao_ipi('report.relatorio.apuracao.ipi')


class wizard_apuracao_ipi_capa(osv.TransientModel):
    def parametro_id(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        company_id = self.pool.get('res.users').browse(cr, uid, uid, context=context).company_id.id
        obj_parametro = self.pool.get('adm.paginas')
        parametro_id = obj_parametro.search(cr, uid, [], context=context)
        if parametro_id:
            return parametro_id[0]
        else:
            return []

    def folha_parametro(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = {}
        parametro_id = self.parametro_id(cr, uid, ids, context=context)
        company_id = self.pool.get('res.users').browse(cr, uid, uid, context=context).company_id.id
        pessoa_id = self.pool.get('res.company').browse(cr, uid, company_id, context=context).rescon_pessoa_id.id
        obj_pagina = self.pool.get('adm.paginas')
        id_pagina = obj_pagina.search(cr, uid, [('company_id', '=', company_id), ('tipo', '=', 'report_apuracao_ipi')], context=context)
        if id_pagina:
            id_dados = obj_pagina.read(cr, uid, parametro_id, ['inicial'], context=context)
            grava = id_dados['inicial']
        else:
            vals = {'data': date.today(),
                    'inicial': '1',
                    'tipo': 'report_apuracao_ipi'
            }
            grava = obj_pagina.create(cr, uid, vals, context=None)
        return grava

    def fiscal_periodo(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        parametro_id = self.parametro_id(cr, uid, ids, context=context)
        company_id = self.pool.get('res.users').browse(cr, uid, uid, context=context).company_id.id
        pessoa_id = self.pool.get('res.company').browse(cr, uid, company_id, context=context).rescon_pessoa_id.id
        obj_pagina = self.pool.get('adm.paginas')
        id_pagina = obj_pagina.search(cr, uid, [('company_id', '=', company_id), ('tipo', '=', 'report_apuracao_ipi')], context=context)
        if id_pagina:
            id_data = obj_pagina.read(cr, uid, parametro_id, ['data'], context=context)
            data = id_data['data']

            return data

    def fiscal_saldo_credor(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        parametro_id = self.parametro_id(cr, uid, ids, context=context)
        if parametro_id:
            periodo_inicial = self.pool.get('fiscal.parametro').read(cr, uid, parametro_id,
                                                                     ['saldo_credor_anterior_ipi'], context=context)
            if periodo_inicial:
                periodo_inicial = periodo_inicial['saldo_credor_anterior_ipi']
                return periodo_inicial
        else:
            return []

    _name = 'wizard.apuracao.ipi'
    _columns = {
        'tipo': fields.char('tipo', size=1),
        'apuracao_ipi_id': fields.many2one('fiscal.apuracao.imposto', 'Apuracao IPI',
                                           domain="[('tipo','=','I'), "
                                                  "('company_id', '=', company_id)]"),
        'folha': fields.integer('Folha'),
        'saldo_credor_anterior': fields.float('Saldo Credor do Periodo passado', digits=(16, 2)),
        'company_id': fields.many2one('res.company', 'Empresa', ondelete='cascade'),
    }
    _defaults = {
        'folha': folha_parametro,
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                                                        s._name,
                                                                                        context=c)
    }

    def onchange_saldo_credor_anterior(self, cr, uid, ids, apuracao_ipi_id, context=None):
        context = context and context.copy() or {}
        res = {}
        res['saldo_credor_anterior'] = 0
        id_apuracao_ante = False
        if apuracao_ipi_id:
            data_apuracao = self.pool.get('fiscal.apuracao.imposto').read(cr, uid, apuracao_ipi_id, ['data_apuracao'], context=context)
            if data_apuracao:
                id_apuracao_ante = self.pool.get('fiscal.apuracao.imposto').search(cr, uid, [('tipo', '=', 'I'), (
                    'data_apuracao', '<', data_apuracao['data_apuracao'])], context=context, order='data_apuracao desc', limit=1)

        if id_apuracao_ante:
            saldo_anterior = self.pool.get('fiscal.apuracao.imposto').read(cr, uid, id_apuracao_ante, ['saldo_credor'], context=context)
            if saldo_anterior:
                if type(saldo_anterior) is list:
                    saldo_anterior = saldo_anterior[0]
                res['saldo_credor_anterior'] = saldo_anterior['saldo_credor']
        return {'value': res}

    def button_print(self, cr, uid, ids, context=None):
        from dateutil.relativedelta import relativedelta
        context = context and context.copy() or {}
        apuracao_ipi_id = self.read(cr, uid, ids[0], context=context)
        datas = {}
        ipi_id = apuracao_ipi_id.get('apuracao_ipi_id')
        if isinstance(ipi_id, tuple):
            ipi_id = ipi_id[0]
        datas.update(self.pool.get('fiscal.apuracao.imposto').read(cr, uid, ipi_id, context=context))
        datas['folha'] = apuracao_ipi_id['folha']
        datas['saldo_credor_anterior'] = apuracao_ipi_id['saldo_credor_anterior']
        datas['apuracao_ipi_id'] = ipi_id

        if not datas['ano']:
            raise osv.except_osv(_('Atencao'), _('Informe o ano para apuracao!'))
        elif not datas['mes']:
            raise osv.except_osv(_('Atencao'), _('Informe o mes para apuracao!'))
        elif not datas['folha']:
            raise osv.except_osv(_('Atencao'), _('Informe a folha!'))
        else:

            datas['periodo_inicial'] = str(datas['ano']) + "-" + str(datas['mes']) + "-01"
            ddata = ( datetime.strptime(datas['periodo_inicial'], "%Y-%m-%d") + relativedelta(months=+1))
            datas['periodo_final'] = ddata.strftime("%Y-%m-%d")
            datas.pop('name')
            datas.pop('id')
            return {
                'type': 'ir.actions.report.xml',
                'report_name': 'relatorio.apuracao.ipi',
                'datas': datas,
            }
