# -*- coding: utf-8 -*-


from openerp.osv import fields
from openerp.osv import osv
import time

class wizard_conferir_transferencia(osv.TransientModel):
    '''
        Conferir NF de Tranferencia
        '''

    _name = "wizard.conferir.transferencia"
    _description = "Conferencia de NF"
    _columns = {
        'numero_nf': fields.integer('Numero nf', required=True),
        'serie_nf': fields.char('Serie nf', required=True, size=3),
        'nf_capa_ids': fields.many2many('fiscal.nf.capa', 'fiscal_capa_conferencia',
                                        'conferencia_id', 'nf_id', 'Nota Fiscal'),

    }

    def button_limpar(self, cr, uid, ids, context=None):
        """
                Limpar dados
                :param cr:
                :param uid:
                :param ids:
                :param context:
                :return:Boolean
              """
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'numero_nf': 0, 'serie_nf': '', 'nf_capa_ids': [[6, False, []]]}, context=context)

        return True


    def onchange_pesquisar(self, cr, uid, ids, numero_nf, serie_nf, nf_capa_ids, context=None):

        '''
                Pesquisa NFs de tranferencia pelo numero e serie da NF
                :param cr:
                :param uid:
                :param ids:
                :param numero_nf:
                :param serie_nf:
                :param nf_capa_ids:
                :param context:
                return : Dict
                '''

        context = context and context.copy() or {}
        warning = {}
        vals = {'numero_nf': 0, 'serie_nf': ''}
        if numero_nf and serie_nf:
            obj_fiscal_nf_capa = self.pool.get('fiscal.nf.capa')
            obj_fiscal_cfop = self.pool.get('fiscal.cfop')
            obj_fiscal_cfop_natureza = self.pool.get('fiscal.cfop.natureza')
            cfop_transferencia_ids = obj_fiscal_cfop.search(cr, uid, [('movimento_tipo', '=', 'T')], context=context)
            natureza_ids = obj_fiscal_cfop_natureza.search(cr, uid,
                                                           [('cfop_id', 'in',
                                                             cfop_transferencia_ids)])
            nf_ids = obj_fiscal_nf_capa.search(cr, uid, [('numero_nf', '=', numero_nf),
                                                         ('tipo', '=', 'E'),
                                                         ('natureza_id', 'in', natureza_ids),
                                                         ('serie_nf', '=', serie_nf),
                                                         ('fisnfc_recebimento_conferido', '!=', True)
                                                        ], context=context)
            if nf_ids:
                nf_ids += nf_capa_ids[0][2]
                nf_ids = list(set(nf_ids)) # removendo duplicidade

                vals = {'numero_nf': 0, 'serie_nf': '', 'nf_capa_ids': [[6, False, nf_ids]]}
                if not ids:
                    self.create(cr, uid, vals, context)
                else:
                    self.write(cr, uid, ids, vals, context)
            else:
                warning = {'title': 'Atencao', 'message': 'Nenhuma nota encontrada.'}
        return {'value': vals, 'warning': warning}


class fiscal_nf_capa(osv.Model):
    _inherit = 'fiscal.nf.capa'

    def button_conferir_transferencia(self, cr, uid, ids, context=None):

        '''Marcar como conferida  a NF  de tranferencia'''

        context = context and context.copy() or {}
        if ids:
            self.write(cr, uid, ids, {'fisnfc_recebimento_conferido': True,
                                      'fisnfc_recebimento_data_hora':time.strftime('%Y-%m-%d %H:%M:%S'),
                                      'fisnfc_recebimento_usuario_id':uid}, context=context)
        return True
