# -*- coding: utf-8 -*-
##############################################################################
# #
# Copyright (c) 2014 All Rights Reserved. Sig Solucoes em Informatica        #
# www.siginformatica.com.br siginformatica.com.br         #
#                                                                            #
##############################################################################

from openerp.osv import osv, fields


class wizard_dados_cadastrais_sped(osv.TransientModel):
    perfil_sped = [('A', 'Perfil A'), ('B', 'Perfil B'), ('C', 'Perfil C')]
    incidencia_tributaria = [('1', 'Nao Cumulativo'), ('2', 'Cumulativo')]
    tipo_contribuicao = [('1', 'Apuracao da Contribuicao Exclusivamente a Aliquota Basica'),
                         ('2', ' Apuracao da Contribuicao a Aliquotas Especificas')]

    apropriacao_creditos = [('1', 'Metodo de Apropriacao Direta'),
                            ('2', ' Metodo de Rateio Proporcional (Receita Bruta)')]

    pessoa_tipo = [('F', 'Fisica'), ('J', 'Juridica')]
    admpes_jur_tipo_atividade = [
        ('A', 'Atacadista'),
        ('I', 'Industria ou equiparado'),
        ('C', 'Comercio'),
        ('T', 'Transportadora'),
        ('S', 'Prestador de Servico'),
        ('P', 'Posto de combustivel'),
        ('M', 'Imobiliaria'),
        ('F', 'Financeira')]
    help_admpes_jur_tipo_atividade = 'Atividade preponderante exercida pela pessoa juridica'

    _name = 'wizard.dados.cadastrais.sped'
    _columns = {
        #Sped Fiscal
        'perfil_arquivo_sped': fields.selection(perfil_sped, 'Perfil de arquivo SPED'),
        'dia_vencimento_obrigacao_icms': fields.integer('Dia do vencimento do ICMS'),
        'contribuinte_substituto': fields.boolean('Contribuinte Substituto'),
        'codigo_receita': fields.char('Codigo da Receita', size=6),
        'fispar_codigo_difal_origem': fields.char('Codigo do difal de origem', size=6),
        'fispar_codigo_difal_destino': fields.char('Codigo do difal de destino', size=6),

        #Sped Contribuicoes
        'fispar_regime_incidencia_tributaria': fields.selection(incidencia_tributaria,
                                                                'Incidencia Tributaria'),
        'fispar_tipo_contribuicao_apuracao': fields.selection(tipo_contribuicao,
                                                              'Tipo de contribuicao/apuracao'),
        'fispar_metodo_apropriacao_creditos': fields.selection(apropriacao_creditos,
                                                               'Metodo de Apropriacao de Creditos'),
        'fispar_criterio_adotado': fields.selection([('1', 'Regime caixa'),
                                                     ('2', 'Competencia'),
                                                     ('9', 'Competencia detalhado')],
                                                    'Criterio adotado'),
        'fispar_cod_rec_pis': fields.char('Codigo receita PIS', size=6),
        'fispar_cod_rec_cofins': fields.char('Codigo receita COFINS', size=6),

        #Dados do Contador
        'con_altera_pessoa_id': fields.many2one('adm.pessoa', "Alterar contador", select=True,
                                                ondelete='cascade'),
        'con_pessoa_id': fields.many2one("adm.pessoa", 'Contador', select=True,
                                         ondelete="cascade"),
        'con_pessoa_tipo': fields.selection(pessoa_tipo, 'Tipo Pessoa', required=True, size=1),
        'con_cpf_cnpj': fields.char('CPF/CNPJ', size=19, select=True),
        'con_name': fields.char('Nome'),
        'con_documentos_ids': fields.one2many('adm.pessoa.documento.dados', 'pessoa_id',
                                              'Documentos'),
        'con_endereco_ids': fields.one2many('adm.pessoa.endereco', 'pessoa_id', 'Enderecos'),
        'con_telefones_ids': fields.one2many('adm.pessoa.telefone', 'pessoa_id', 'Telefones'),
        'con_email_ids': fields.one2many('adm.pessoa.email', 'pessoa_id', 'Emails'),

        #Dados da Empresa
        'emp_pessoa_id': fields.many2one("adm.pessoa", 'Pesquisar',
                                         select=True, ondelete="cascade"),
        'emp_pessoa_tipo': fields.selection(pessoa_tipo, 'Tipo Pessoa', required=True, size=1),
        'emp_cpf_cnpj': fields.char('CPF/CNPJ', size=19, select=True),
        'emp_name': fields.char('Nome'),
        'emp_documentos_ids': fields.one2many('adm.pessoa.documento.dados', 'pessoa_id',
                                              'Documentos'),
        'emp_endereco_ids': fields.one2many('adm.pessoa.endereco', 'pessoa_id', 'Enderecos'),
        'emp_telefones_ids': fields.one2many('adm.pessoa.telefone', 'pessoa_id', 'Telefones'),
        'emp_email_ids': fields.one2many('adm.pessoa.email', 'pessoa_id', 'Emails'),
        'emp_admpes_jur_tipo_atividade': fields.selection(admpes_jur_tipo_atividade,
                                                          'Natureza da atividade',
                                                          help=help_admpes_jur_tipo_atividade,
                                                          size=1),
        'emp_admpes_jur_ie': fields.char('Inscricao Estadual', size=14),
    }

    def default_get(self, cr, uid, fields_list, context=None):
        context = context and context.copy() or {}
        fields_list.append('emp_pessoa_nome')
        obj_fiscal_parametro = self.pool.get('fiscal.parametro')
        fis_par_ids = obj_fiscal_parametro.search(cr, uid, [], context=context)
        obj_adm_parametro = self.pool.get('adm.parametro')
        adm_par_ids = obj_adm_parametro.search(cr, uid, [], context=context)
        obj_adm_pessoa = self.pool.get('adm.pessoa')
        brw_fispar = obj_fiscal_parametro.browse(cr, uid, fis_par_ids[0])

        def _dadosSpedFiscal():
            res['perfil_arquivo_sped'] = brw_fispar.perfil_arquivo_sped
            res['dia_vencimento_obrigacao_icms'] = brw_fispar.dia_vencimento_obrigacao_icms
            res['contribuinte_substituto'] = brw_fispar.contribuinte_substituto
            res['codigo_receita'] = brw_fispar.codigo_receita
            res['fispar_codigo_difal_origem'] = brw_fispar.fispar_codigo_difal_origem
            res['fispar_codigo_difal_destino'] = brw_fispar.fispar_codigo_difal_destino

        def _dadosSpedContribuicoes(cr, uid, res):
            res['fispar_regime_incidencia_tributaria'] = obj_fiscal_parametro.browse(cr, uid,
                                                                                     fis_par_ids[0],
                                                                                     context=context) \
                .fispar_regime_incidencia_tributaria
            res['fispar_tipo_contribuicao_apuracao'] = obj_fiscal_parametro.browse(cr, uid,
                                                                                   fis_par_ids[0],
                                                                                   context=context) \
                .fispar_tipo_contribuicao_apuracao
            res['fispar_metodo_apropriacao_creditos'] = obj_fiscal_parametro.browse(cr, uid,
                                                                                    fis_par_ids[0],
                                                                                    context=context) \
                .fispar_metodo_apropriacao_creditos
            res['fispar_criterio_adotado'] = obj_fiscal_parametro.browse(cr, uid, fis_par_ids[0],
                                                                         context=context) \
                .fispar_criterio_adotado
            res['fispar_cod_rec_pis'] = obj_fiscal_parametro.browse(cr, uid, fis_par_ids[0],
                                                                    context=context) \
                .fispar_cod_rec_pis
            res['fispar_cod_rec_cofins'] = obj_fiscal_parametro.browse(cr, uid, fis_par_ids[0],
                                                                       context=context) \
                .fispar_cod_rec_cofins

        def _dadosContador(cr, uid, res):
            contador = obj_adm_parametro.read(cr, uid, adm_par_ids, ['contador_id'],
                                              context=context)
            contador_id = contador[0].get('contador_id')[0]
            if contador_id:
                dados_contador = obj_adm_pessoa.read(cr, uid, contador_id, [], context=context)
            else:
                dados_contador = {}
            res['con_pessoa_id'] = contador_id
            res['con_pessoa_tipo'] = dados_contador.get('pessoa_tipo')
            res['con_cpf_cnpj'] = dados_contador.get('cpf_cnpj')
            res['con_name'] = dados_contador.get('name')
            res['con_documentos_ids'] = dados_contador.get('documentos_ids')
            res['con_telefones_ids'] = dados_contador.get('telefones_ids')
            res['con_endereco_ids'] = dados_contador.get('endereco_ids')
            res['con_email_ids'] = dados_contador.get('email_ids')

        def _dadosEmpresa(cr, uid, res):
            company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, [],
                                                                        context=context)
            res_company = self.pool.get('res.company')
            emp_pes_id = False
            emp_pes_dados = res_company.read(
                cr, uid, company_id, ['rescon_pessoa_id'], context=context)
            if emp_pes_dados:
                emp_pes_id = emp_pes_dados.get('rescon_pessoa_id')
                if emp_pes_id:
                    emp_pes_id = emp_pes_id[0]
            if emp_pes_id:
                campos_pessoa = ['pessoa_tipo', 'cpf_cnpj', 'name', 'documentos_ids',
                                 'telefones_ids', 'endereco_ids', 'email_ids',
                                 'admpes_jur_tipo_atividade', 'admpes_jur_ie']
                dados_empresa = obj_adm_pessoa.read(cr, uid, emp_pes_id, campos_pessoa,
                                                    context=context)
            else:
                dados_empresa = {}
            res['emp_pessoa_id'] = emp_pes_id
            res['emp_pessoa_tipo'] = dados_empresa.get('pessoa_tipo')
            res['emp_cpf_cnpj'] = dados_empresa.get('cpf_cnpj')
            res['emp_name'] = dados_empresa.get('name')
            res['emp_documentos_ids'] = dados_empresa.get('documentos_ids')
            res['emp_telefones_ids'] = dados_empresa.get('telefones_ids')
            res['emp_endereco_ids'] = dados_empresa.get('endereco_ids')
            res['emp_email_ids'] = dados_empresa.get('email_ids')
            res['emp_admpes_jur_tipo_atividade'] = dados_empresa.get('admpes_jur_tipo_atividade')
            res['emp_admpes_jur_ie'] = dados_empresa.get('admpes_jur_ie')

        res = super(wizard_dados_cadastrais_sped, self).default_get(cr, uid, fields_list,
                                                                    context=context)
        if fis_par_ids:
            _dadosSpedFiscal()
            _dadosSpedContribuicoes(cr, uid, res)
        if adm_par_ids:
            _dadosContador(cr, uid, res)
        _dadosEmpresa(cr, uid, res)
        return res

    def create(self, cr, uid, vals, context=None):
        """
        Este metodo insere os valores con_con_pessoa_id,
        con_cpf_cnpj, emp_pessoa_tipo, emp_cpf_cnpj na
        wizard_dados_cadastrais_sped e chama o metodo
        que faz a atualizadacao dos dados passado pelo vals

        Este metodo foi feito desta forma para que o os campos
        one2many nao fossem atualizados com o id da wizard criada
        """
        context = context and context.copy() or {}
        con_pessoa_tipo = vals.get('con_pessoa_tipo')
        con_cpf_cnpj = vals.get('con_cpf_cnpj')
        emp_pessoa_tipo = vals.get('emp_pessoa_tipo')
        emp_cpf_cnpj = vals.get('emp_cpf_cnpj')
        sql = """
                INSERT INTO wizard_dados_cadastrais_sped
                            (con_pessoa_tipo,
                             con_cpf_cnpj,
                             emp_pessoa_tipo,
                             emp_cpf_cnpj)
                VALUES      ('%s',
                             '%s',
                             '%s',
                             '%s' )
                """ % (con_pessoa_tipo,
                       con_cpf_cnpj,
                       emp_pessoa_tipo,
                       emp_cpf_cnpj)

        cr.execute(sql)
        cr.commit()
        sql = """SELECT id
                 FROM wizard_dados_cadastrais_sped
                 ORDER BY id DESC LIMIT 1
                 """
        cr.execute(sql)
        res = cr.dictfetchall()[0].get('id')
        self.updateDados(cr, uid, vals, context)
        return res

    def button_atualizar(self, cr, uid, ids, context):
        return {
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'wizard.dados.cadastrais.sped',
            'type': 'ir.actions.act_window',
            'target': 'inline',
            'context': context
        }

    def updateDados(self, cr, uid, vals, context=None):
        """
        Este metodo percorre os valores de vals separando os dados
        do contador, da empresa e do parametro do fiscal
        e atualiza os valores nos respectivos lugares de origem
        """
        context = context and context.copy() or {}
        obj_adm_pessoa = self.pool.get('adm.pessoa')
        obj_fiscal_parametro = self.pool.get('fiscal.parametro')
        obj_adm_parametro = self.pool.get('adm.parametro')
        admpar_ids = obj_adm_parametro.search(cr, uid, [], context=context)
        fispar_ids = obj_fiscal_parametro.search(cr, uid, [], context=context)
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, [], context=context)
        if company_id:
            if not isinstance(company_id, list):
                company_id = [company_id]
        dados_contador = {}
        dados_fiscais = {}
        dados_empresa = {}
        if not vals.get('con_altera_pessoa_id'):
            contador_id = vals.get('con_pessoa_id')
        else:
            contador_id = vals.get('con_altera_pessoa_id')
            vals.update({'con_pessoa_id': contador_id})
            obj_adm_parametro.write(cr, uid, admpar_ids, {'contador_id': contador_id}, context)
        empresa_id = vals.get('emp_pessoa_id')
        for dado in vals:
            if dado[0:4] == 'con_':
                if dado == 'con_pessoa_id':
                    dados_contador.update({'id': vals.get(dado)})
                else:
                    dados_contador.update({dado[4:]: vals.get(dado)})
            elif dado[0:4] == 'emp_':
                if dado == 'emp_pessoa_id':
                    dados_empresa.update({'id': vals.get(dado)})
                else:
                    dados_empresa.update({dado[4:]: vals.get(dado)})
            else:
                dados_fiscais.update({dado: vals.get(dado)})
        dados_contador.pop('altera_pessoa_id')
        obj_adm_pessoa.write(cr, uid, contador_id, dados_contador, context)
        obj_fiscal_parametro.write(cr, uid, fispar_ids, dados_fiscais,
                                   context)
        obj_adm_pessoa.write(cr, uid, [empresa_id], dados_empresa, context)
        return True

    def onchange_cep(self, cr, uid, ids, cep, bairro_id, logradouro_id):
        obj_endereco = self.pool.get('adm.pessoa.endereco')
        res = obj_endereco.onchange_cep(cr, uid, ids, cep, bairro_id, logradouro_id)
        return res

    def onchange_pessoa(self, cr, uid, ids, pessoa_id, context):
        """
        Recebe os dados da pessoa informada no campo con_altera_pessoa_id
        e carrega as informacoes da pessoa na aba Dados do Contador
        """
        if not pessoa_id:
            return {}
        else:
            tipo_pessoa = context.get('pessoa') + '_'
            obj_adm_pessoa = self.pool.get('adm.pessoa')
            dados_pessoa = obj_adm_pessoa.browse(cr, uid, pessoa_id)
            if isinstance(dados_pessoa, list):
                dados_pessoa = dados_pessoa[0]
            res = self.pool.get('adm.pessoa').admpes_prepara_onchange_pessoa(cr, uid, dados_pessoa)
            brw_documento_ids = obj_adm_pessoa.browse(cr, uid, pessoa_id).documentos_ids
            documento_ids = []
            for documento in brw_documento_ids:
                documento_ids.append(documento.id)
            dados = {'value': {}}
            for valor in res.values():
                for chave in valor:
                    dados.get('value').update({tipo_pessoa + chave: valor.get(chave)})
            dados.get('value').update({tipo_pessoa + 'documentos_ids': documento_ids})
            res = dados
            return res
