# -*- coding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _


class wizard_faturar_pedidos(osv.TransientModel):
    _name = 'wizard.faturar.pedidos'

    def fields_view_get(self, cr, uid, view_id=None, view_type=False, context=None, toolbar=False,
                        submenu=False):
        res = super(wizard_faturar_pedidos, self).fields_view_get(
            cr, uid, view_id=view_id, view_type=view_type, context=context, toolbar=toolbar,
            submenu=submenu)
        context = context and context.copy() or {}
        if context.get('active_ids'):
            if view_type == 'form':
                obj_estoque_pedidos_capa = self.pool.get('estoquepedidos.pedido.capa')
                browse_pedidos = obj_estoque_pedidos_capa.browse(cr, uid, context.get('active_ids'))
                for x in browse_pedidos:
                    if not x.tipo == 'V':
                        res['arch'] = '''
                                   <form string="Atencao" version="7.0">
                                    <header>
                                       <group colspan="4">
                                        <label string="O faturamento de pedido de compra deve
                                                  ser feito a partir da Nota Fiscal de Terceiros."/>

                                        </group>
                                        <newline/>
                                        <button special="cancel" string="_Sair"/>
                                    </header>
                                     </form>'''
                        break

        return res

    def button_ok(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        pedido_ids = context.get('active_ids')
        context['faturar_diversos_pedidos'] = True
        context['super_write_fiscal_nf_capa'] = True
        obj_estoque_pedidos_capa = self.pool.get('estoquepedidos.pedido.capa')
        browse_pedidos = obj_estoque_pedidos_capa.browse(cr, uid, pedido_ids)
        destinatario_ids = []
        for x in browse_pedidos:
            context['tipo_pedido'] = x.tipo
            if x.pessoa_id.id not in destinatario_ids and len(destinatario_ids) == 0:
                destinatario_ids.append(x.pessoa_id.id)
            elif x.pessoa_id.id not in destinatario_ids and len(destinatario_ids) > 0:
                raise osv.except_osv(_('Atencao!'),
                                     _('Permitido faturar pedidos somente para o mesmo '
                                       'destinatario.'))
            if x.state not in ('V', 'D'):
                raise osv.except_osv(_('Atencao!'),
                                     _('Permitido faturar somente pedidos validados ou separados.'))

        destinario_id = destinatario_ids[0]
        nf_id = obj_estoque_pedidos_capa.button_faturar_pedido(
            cr, uid, pedido_ids, context=context, destinatario_id=destinario_id, pedido_ids=pedido_ids)

        if not nf_id:
            raise osv.except_osv(_('Atencao'), _('NF nao gerada'))
        elif context.get('compra_nf_view_terceiro'):
            nf_view = 'view_fiscal_nf_capa_terceiro_form'
        else:
            nf_view = 'view_fiscal_nf_capa_form'
        obj_model_data = self.pool.get('ir.model.data')
        reference = obj_model_data.get_object_reference(cr, uid, 'fiscal', nf_view)
        view_id = reference and reference[1] or False
        context.update({'active_id': nf_id})
        context.update({'super_write_fiscal_nf_capa': True})
        obj_fiscal_capa = self.pool.get('fiscal.nf.capa')
        obj_fiscal_capa.write(cr, uid, nf_id, {}, context=context)
        return {
            'name': 'Nota fiscal gerada',
            'view_type': 'form',
            'view_mode': 'form',
            'view_id': view_id,
            'res_model': 'fiscal.nf.capa',
            'res_id': nf_id,
            'type': 'ir.actions.act_window',
            'context': context,
        }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
