# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
import base64
from openerp.tools.translate import _


class wizard_importa_tabela_ibpt(osv.TransientModel):
    _name = 'wizard.importa.tabela.ibpt'
    _columns = {
        'arquivo': fields.binary('Arquivo', required=True),
        'flag': fields.boolean('Flag'),
    }
    _defaults = {
        'flag': False,
    }

    def button_importar_tabela_ibpt(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_fiscal_ncm = self.pool.get('fiscal.ncm')

        ibpt_dados = self.read(cr, uid, ids[0], ['arquivo'], context=context)
        dados_arquivo = base64.b64decode(ibpt_dados.get('arquivo'))
        f = open('/tmp/tabela-ibpt.csv', 'w')
        f.write(dados_arquivo)
        f.close()

        fi = open('/tmp/tabela-ibpt.csv')
        lines = fi.readlines()
        flag = False
        total_lines = len(lines) - 1
        for line in lines[1:total_lines]:
            line = line.split(';')
            try:
                codigo_ncm = line[0]
                tabela = int(line[2])
                aliqnac = float(line[4] or 0)
                aliqimp = float(line[5] or 0)
                aliqest = float(line[6] or 0)
                aliqmun = float(line[7] or 0)
                chave = line[10] or ''
            except:
                raise osv.except_osv(_('Atencao'), _('O arquivo possui Layout incompativel'))
            if tabela == 0:
                ncm_ids = obj_fiscal_ncm.search(cr, uid, [('codigo', '=', codigo_ncm)], context=context)
                if ncm_ids:
                    obj_fiscal_ncm.write(cr, uid, ncm_ids[0], {'fisnc_aliq_ibpt_fed_nac': aliqnac,
                                                               'fisnc_aliq_ibpt_fed_imp': aliqimp,
                                                               'fisnc_aliq_ibpt_est': aliqest,
                                                               'fisnc_aliq_ibpt_mun': aliqmun,
                                                               'fisnc_ibpt_chave': chave }, context)
                else:
                    obj_fiscal_ncm.create(cr, uid, {'codigo': codigo_ncm,
                                                    'fisnc_aliq_ibpt_fed_nac': aliqnac,
                                                    'fisnc_aliq_ibpt_fed_imp': aliqimp,
                                                    'fisnc_aliq_ibpt_est': aliqest,
                                                    'fisnc_aliq_ibpt_mun': aliqmun,
                                                    'fisnc_ibpt_chave': chave,
                                                    'descricao': codigo_ncm },
                                          context)
                flag = True
        if flag:
            self.write(cr, uid, ids[0], {'flag': True}, context)
        else:
            raise osv.except_osv(_('Atencao'), _('Nenhum NCM foi criado ou atualizado'))
        return True
