# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def _getMes(self, cr, uid, mes):
        if mes == 1:
            mes = _('Janeiro')
        elif mes == 2:
            mes = _('Fevereiro')
        elif mes == 3:
            mes = _('Marco')
        elif mes == 4:
            mes = _('Abril')
        elif mes == 5:
            mes = _('Maio')
        elif mes == 6:
            mes = _('Junho')
        elif mes == 7:
            mes = _('Julho')
        elif mes == 8:
            mes = _('Agosto')
        elif mes == 9:
            mes = _('Setembro')
        elif mes == 10:
            mes = _('Outubro')
        elif mes == 11:
            mes = _('Novembro')
        elif mes == 12:
            mes = _('Dezembro')
        return mes

    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        title = center_title('', _('Listagem de Guias'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Listagem de Guias'))
        listagem.informaTamLinha(160)

        obj_fiscal_guia = pooler.get_pool(cr.dbname).get('fiscal.guia')

        ano = datas.get('ano')
        mes = datas.get('mes')

        fiscal_guia_ids = obj_fiscal_guia.search(cr, uid, [('ano', '=', ano), ('mes', '=', mes)], 0, None,
                                                 'data_pagamento ASC', context=context)
        if fiscal_guia_ids:
            browse_fiscal_guia = obj_fiscal_guia.browse(cr, uid, fiscal_guia_ids)

            company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                                            'wizard.listagem.gnre.osv', context=context)
            res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id, ['name'], context=context)
            nome_empresa = res_company_dados.get('name')
            data = time.strftime("%d/%m/%Y")
            docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
            mes = self._getMes(cr, uid, int(mes))

            listagem.informaCab('' + title)
            listagem.informaCab('')
            listagem.informaCab('')
            listagem.informaCab('' + docs)
            listagem.informaCab('' + _('MES: %s') % mes + '  ' + _('ANO: %s') % ano)
            listagem.informaCab('  ')
            listagem.informaCab(
                _('*----------------------------------------------------------------------------------------------------------------------------------------------------*'))
            listagem.informaCab(
                _('|        FORNECEDOR         | DOCUMENTO | SERIE |  DATA PAGAMENTO  | DATA ENTRADA | BASE  |    VALOR     | BANCO | AGENCIA | AUTENTICACAO | CONVENIO |'))
            listagem.informaCab(
                _('*----------------------------------------------------------------------------------------------------------------------------------------------------*'))
            listagem.imprimeLinha('')
            listagem.rodapePadrao()

            for x in browse_fiscal_guia:
                if x.nf_id:
                    fornecedor = x.nf_id.destinatario_id or ''
                    if fornecedor:
                        fornecedor = fornecedor.name or ''
                    documento = x.nf_id.numero_nf or ''
                    serie = x.nf_id.serie_nf
                    data_pagamento = (x.data_pagamento or '')[:10]
                    if data_pagamento:
                        data_pagamento = time.strftime('%d/%m/%Y', time.strptime(data_pagamento, '%Y-%m-%d'))
                    data_entrada = (x.nf_id.data_saida_entrada or '')[:10]
                    if data_entrada:
                        data_entrada = time.strftime('%d/%m/%Y', time.strptime(data_entrada, '%Y-%m-%d'))
                    base = x.base or 0.0
                    valor = x.valor or 0.0
                    agencia = x.agencia_id or ''
                    banco = ''
                    if agencia:
                        banco = agencia.admbag_banco_id.admbco_codigo_bc
                        agencia = agencia.admbag_codigo_agencia
                    autenticacao = x.autenticacao or 0.0
                    convenio = x.convenio or ''
                    linha = formataString(fornecedor, 27, ' ', 'D', 'N', 'S') + '|'
                    linha += ' '
                    linha += formataString(documento, 10, ' ', 'D', 'N', 'S') + '|'
                    linha += ' '
                    linha += formataString(serie, 6, ' ', 'D', 'N', 'S') + '|'
                    linha += ' '
                    linha += formataString(data_pagamento, 17, ' ', 'D', 'N', 'S') + '|'
                    linha += ' '
                    linha += formataString(data_entrada, 13, ' ', 'D', 'N', 'S') + '|'
                    linha += ' '
                    linha += formataString(getNumeroEditado(base, 2), 6, ' ', 'D', 'N', 'S') + '|'
                    linha += ' '
                    linha += formataString(getNumeroEditado(valor, 2), 13, ' ', 'E', 'N', 'S') + '|'
                    linha += ' '
                    linha += formataString(banco, 6, ' ', 'E', 'N', 'S') + '|'
                    linha += ' '
                    linha += formataString(agencia, 8, ' ', 'E', 'N', 'S') + '|'
                    linha += ' '
                    linha += formataString(autenticacao, 13, ' ', 'E', 'N', 'S') + '|'
                    linha += ' '
                    linha += formataString(convenio, 9, ' ', 'E', 'N', 'S') + '|'
                    linha += ' '
                    listagem.imprimeLinha('|' + linha)
                    #                if not i==lista[-1]:
                    #                    listagem.imprimeLinha('{{ Page }}')
                    #                    listagem.cabecalhos=[]
            listagem.imprimeLinha(
                _('*----------------------------------------------------------------------------------------------------------------------------------------------------*'))
            listagem.imprimeLinha(
                _('                                                                                                                   ** Sig Informatica LTDA **       '))

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_gnre')


class wizard_listagem_gnre_osv(osv.TransientModel):
    _name = 'wizard.listagem.gnre.osv'
    _columns = {
        'ano': fields.char('Ano', size=4, required=True),
        'mes': fields.selection([('1', 'Janeiro'),
                                 ('2', 'Fevereiro'),
                                 ('3', 'Marco'),
                                 ('4', 'Abril'),
                                 ('5', 'Maio'),
                                 ('6', 'Junho'),
                                 ('7', 'Julho'),
                                 ('8', 'Agosto'),
                                 ('9', 'Setembro'),
                                 ('10', 'Outubro'),
                                 ('11', 'Novembro'),
                                 ('12', 'Dezembro')], 'Mes', required=True, size=2),
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        listagem_gnre_dados = self.read(cr, uid, ids, [], context=context)
        for x in listagem_gnre_dados:
            datas = {
                'ano': x.get('ano'),
                'mes': x.get('mes')
            }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'listagem_gnre',
            'datas': datas,
        }
