# -*- coding: utf-8 -*-


from openerp.osv import fields
from openerp.osv import osv
import time
from openerp.tools.translate import _
class wizard_listagem_transferencia(osv.TransientModel):
    '''
        Listagem NF de Tranferencia
        '''

    _name = "wizard.listagem.transferencia"
    _description = "Listagem de NF"
    _columns = {
        'data_inicial': fields.date('Data Inicial'),
        'data_final': fields.date('Data Final'),
        'nf_capa_ids': fields.many2many('fiscal.nf.capa', 'fiscal_listagem_conferencia',
                                        'listagem_id', 'nf_id', 'Nota Fiscal'),
        'emitente_id': fields.many2one("adm.pessoa", 'Emitente'),
    }

    def button_limpar(self, cr, uid, ids, context=None):
        """
                Limpar dados
                :param cr:
                :param uid:
                :param ids:
                :param context:
                :return:Boolean
              """
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'emitente_id':False,
                                  'data_inicial': False,
                                  'data_final': False,
                                  'nf_capa_ids': [[6, False, []]]}, context=context)

        return True

    def button_pesquisar(self, cr, uid, ids, context=None):

        '''
                Pesquisa NFs de tranferencia pelo numero e serie da NF
                :param cr:
                :param uid:
                :param ids:
                :param numero_nf:
                :param serie_nf:
                :param nf_capa_ids:
                :param context:
                return : Dict
                '''

        context = context and context.copy() or {}
        if isinstance(ids,list):
            ids = ids[0]
        dados = self.read(cr,uid,ids,[], context=context)

        data_inicial = dados['data_inicial']
        data_final = dados['data_final']
        emitente_id = dados['emitente_id']

        obj_fiscal_nf_capa = self.pool.get('fiscal.nf.capa')
        obj_fiscal_cfop = self.pool.get('fiscal.cfop')
        obj_fiscal_cfop_natureza = self.pool.get('fiscal.cfop.natureza')
        cfop_transferencia_ids = obj_fiscal_cfop.search(cr, uid, [('movimento_tipo', '=', 'T')], context=context)
        natureza_ids = obj_fiscal_cfop_natureza.search(cr, uid,
                                                       [('cfop_id', 'in',
                                                         cfop_transferencia_ids)], context=context)
        args = [('data_emissao', '>=', data_inicial),
                ('data_emissao', '<=', data_final),
                ('tipo', '=', 'E'),
                ('natureza_id', 'in', natureza_ids),
        ]
        if emitente_id:
            args.append(('destinatario_id', '=', emitente_id[0]))
        nf_ids = obj_fiscal_nf_capa.search(cr, uid,args, context=context)
        if nf_ids:

            vals = {'data_inicial':data_inicial,'data_final':data_final,'nf_capa_ids': [[6, False, nf_ids]]}
            if not ids:
                self.create(cr, uid, vals, context)
            else:
                self.write(cr, uid, ids, vals, context)
        else:
            raise osv.except_osv(_('Atencao'), _( 'Nenhuma nota encotrada'))
        return True


    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if ids:
            datas = self.read(cr, uid, ids[0], context=context)
            if not datas['nf_capa_ids']:
                raise osv.except_osv(_('Atencao'), _( 'Nenhuma nota encotrada'))
            return {
                'type': 'ir.actions.report.xml',
                'report_name': 'listagem_transferencia',
                'datas': datas,
                }
