# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _


class wizard_listagem_vendas_por_periodo(osv.TransientModel):
    _name = 'wizard.listagem.vendas.por.periodo'
    _description = u'Listagem de vendas por periodo'
    _columns = {
        'data_inicial': fields.date('Data inicial', required=True),
        'data_final': fields.date('Data final', required=True),
        'tipo': fields.selection([('S', 'Sintetico'), ('A', 'Analitico')], 'Sintetico/Analitico', size=1,
                                 required=True),
        'forma_pagamento_id': fields.many2one('adm.forma.pgto', 'Forma de pagamento'),
        'detalhe_forma_pagamento': fields.boolean('Detalhar forma de pagamento',
                                                  help='Se marcado, o relatorio e impresso de '
                                                       'acordo com o tipo da forma da pagamento'),
    }
    _defaults = {
        'tipo': 'S',
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = self.browse(cr, uid, ids)
        for x in vals:
            if x.data_final < x.data_inicial:
                raise osv.except_osv(_('Atencao'), _('A data final deve ser igual ou maior que a '
                                                     'data inicial'))
            datas = {
                'data_inicial': x.data_inicial,
                'data_final': x.data_final,
                'tipo': x.tipo,
                'forma_pagamento_id': x.forma_pagamento_id.id or False,
                'forma_pagamento_name': x.forma_pagamento_id.name or '',
                'detalhe_forma_pagamento': x.detalhe_forma_pagamento or False
            }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'listagem_vendas_por_periodo',
            'datas': datas,
        }

    def onchange_tipo(self, cr, uid, id, tipo, context=None):
        context = context and context.copy() or {}
        res = {}
        if tipo == 'S' or not tipo:
            res['forma_pagamento_id'] = False
        return {'value': res}
