# -*- coding: utf-8 -*-

from openerp.osv import osv
import base64


class estoque_produto(osv.Model):
    _inherit = 'estoque.produto'

    def estpro_button_alertafiscal(self, cr, uid, ids, context=None):
        """
        Metodo do botao 'Alerta Fiscal'. Executa a chamada do metodo 'alfutl_consulta_webservice'
        que fara a consulta no webservice e a chamada dos que fara a atualizacao da tributacao.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: Verdadeiro, caso os produtos tenham sido atualizados. Senao, falso.
        :rtype: bool
        """
        context = context and context.copy() or {}
        produto_id = ids[0] if isinstance(ids, (list, tuple)) else ids
        produto_codigo = self.read(cr, uid, produto_id, ['codigo'], context=context).get('codigo')
        if produto_codigo.isdigit():
            produto_codigo = produto_codigo.strip('0')
        try:
            str_xml_dados = self.pool.get('alertafiscal.utils').alfutl_consulta_webservice(
                cr, uid, codigo_interno=produto_codigo, context=context)
        except:
            codigo_barras = self.pool.get('automacao.codigo.barra').autcba_get_codigo_barra(
                cr, uid, produto_id=produto_id, context=context)
            if not codigo_barras:
                return False
            str_xml_dados = self.pool.get('alertafiscal.utils').alfutl_consulta_webservice(
                cr, uid, ean=codigo_barras, context=context)
        if not str_xml_dados:
            return False
        xml_dados = base64.b64encode(str_xml_dados)
        obj_importa_xml = self.pool.get('wizard.importa.xml.retorno.alertafiscal')
        obj_importa_xml.create(cr, uid, {'retalf_xml_file': xml_dados}, context)
        context.update({'alertafiscal_produto_id': produto_id})
        list_arquivo_dados = obj_importa_xml.retalf_converte_xml_dados(cr, uid, xml_dados, context)
        estoque_fiscal_id = obj_importa_xml.retalf_importa_retorno_revisao(
            cr, uid, list_arquivo_dados, context)

        reference = self.pool.get('ir.model.data').get_object_reference(
            cr, uid, 'estoque_fiscal', 'view_estoque_fiscal_itens_form')
        view_id = reference and reference[1] or False
        return {'name': 'Integracao fiscal', 'view_type': 'form',
                'res_id': self.pool.get('estoque.fiscal.capa').browse(
                    cr, uid, estoque_fiscal_id, context).estfca_item_ids[0].id, 'view_mode': 'form',
                'res_model': 'estoque.fiscal.itens', 'view_id': [view_id], 'target': 'new',
                'type': 'ir.actions.act_window'}
