# -*- coding: utf-8 -*-


from openerp.osv import osv
import base64


class fiscal_ncm(osv.Model):
    _inherit = 'fiscal.ncm'

    def fisnc_button_alertafiscal(self, cr, uid, ids, context=None):
        """
        Metodo do botao 'Alerta Fiscal'. Executa a chamada do metodo 'alfutl_consulta_webservice'
        que fara a consulta no webservice e a chamada dos que fara a atualizacao da tributacao.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: Verdadeiro, caso os produtos tenham sido atualizados. Senao, falso.
        :rtype: bool
        """
        context = context and context.copy() or {}
        ncm_id = ids[0] if isinstance(ids, (list, tuple)) else ids
        str_xml_dados = self.pool.get('alertafiscal.utils').alfutl_consulta_webservice(
            cr, uid, ncm=self.browse(cr, uid, ncm_id, context).codigo.replace('.', ''), context=context)
        if not str_xml_dados:
            return False
        xml_dados = base64.b64encode(str_xml_dados)
        context.update({'alertafiscal_ncm_id': ncm_id})
        arquivo_dados = self.pool.get('wizard.importa.xml.retorno.alertafiscal').\
            retalf_converte_xml_dados(cr, uid, xml_dados, context)
        arquivo_dados = filter(lambda i: i.get('Saida') if isinstance(i, dict) else False,
                               arquivo_dados)
        list_item = []
        map(
            lambda i: list_item.append(
                (0, 0, {'name': i.get('Detalhamento').get('Ncm') + '-' + i.get(
                    'Detalhamento').get('NomeCategoriaProduto') or 'Sem descricao',
                        'tributacao': 'ICMS: %s, PIS: %s, COFINS: %s' % (
                            i.get('Saida').get('IcmsSaidaRevenda'),
                            i.get('Federal').get('PisSaida'),
                            i.get('Federal').get('CofinsSaida'))})),
            arquivo_dados)
        vals = {'arquivo_dados': arquivo_dados, 'item_ids': list_item, 'ncm_id': ncm_id}
        ncm_categoria_id = self.pool.get('wizard.alertafiscal.ncm.categoria').create(
            cr, uid, vals, context)
        reference = self.pool.get('ir.model.data').get_object_reference(
            cr, uid, 'fiscal_alertafiscal', 'view_wizard_alertafiscal_ncm_categoria_form')
        view_id = reference and reference[1] or False
        return {'name': 'Selecao de NCM por Categoria', 'view_type': 'form',
                'res_id': ncm_categoria_id, 'view_mode': 'form',
                'res_model': 'wizard.alertafiscal.ncm.categoria', 'view_id': [view_id],
                'target': 'new', 'type': 'ir.actions.act_window', 'context': context}
