# -*- coding: utf-8 -*-

from openerp.osv import osv, fields


class wizard_alertafiscal_ncm_categoria(osv.TransientModel):
    _name = 'wizard.alertafiscal.ncm.categoria'
    _columns = {
        'name': fields.char('Descricao', size=10),
        'ncm_id': fields.many2one('fiscal.ncm', 'NCM', ondelete='cascade'),
        'arquivo_dados': fields.text('Dados do arquivo'),
        'item_ids': fields.one2many('wizard.alertafiscal.ncm.categoria.item', 'capa_id', 'Itens'),
    }


class wizard_alertafiscal_ncm_categoria_item(osv.TransientModel):
    _name = 'wizard.alertafiscal.ncm.categoria.item'
    _columns = {
        'name': fields.text('Descricao', size=10),
        'tributacao': fields.char('Tributacao', size=100),
        'capa_id': fields.many2one('wizard.alertafiscal.ncm.categoria', 'Capa', ondelete='cascade'),
    }

    def button_selecao_ncm_categoria(self, cr, uid, ids, context=None):
        """
        Metodo do botao 'Selecionar'. Definie o NCM de acordo com a categoria e tributacao
        disponivel.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: sequencia de id da tabela desse objeto.
        :type ids: list
        :param context: dados contextuais.
        :type context: dict
        :return:
        """
        context = context and context.copy() or {}
        brw_ncm_categoria_item = self.browse(cr, uid, ids[0] if isinstance(ids, list) else ids,
                                             context)
        arquivo_dados = filter(
            lambda i: i.get('Detalhamento').get('NomeCategoriaProduto') ==
            brw_ncm_categoria_item.name.split('-')[1],
            eval(brw_ncm_categoria_item.capa_id.arquivo_dados))
        context.update({'alertafiscal_ncm_id': brw_ncm_categoria_item.capa_id.ncm_id.id})
        estoque_fiscal_id = self.pool.get('wizard.importa.xml.retorno.alertafiscal').\
            retalf_importa_retorno_revisao(cr, uid, arquivo_dados, context)

        reference = self.pool.get('ir.model.data').get_object_reference(
            cr, uid, 'estoque_fiscal', 'view_estoque_fiscal_capa_form')
        view_id = reference and reference[1] or False
        return {'name': 'Integracao fiscal', 'view_type': 'form', 'res_id': estoque_fiscal_id,
                'view_mode': 'form', 'res_model': 'estoque.fiscal.capa', 'view_id': [view_id],
                'target': 'current', 'type': 'ir.actions.act_window'}
