# -*- coding: utf-8 -*-

from openerp.osv import osv
import base64


class estoque_produto(osv.Model):

    _inherit = 'estoque.produto'

    def estpro_button_imendes(self, cr, uid, ids, context=None):
        """
        Metodo do botao 'IMendes'. Realiza a chamada dos metodos para consulta dos dados
        tributarios junto a IMendes.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: Dados de acao para chamada da tela com os dados tributarios
        :rtype: dict
        """
        context = context and context.copy() or {}
        obj_fiscal_imendes_utils = self.pool.get('fiscal.imendes.utils')
        produto_id = ids[0] if isinstance(ids, (list, tuple)) else ids
        dados_retorno = obj_fiscal_imendes_utils.imeutl_consulta_produto(cr, uid, produto_id,
                                                                         context)
        if not dados_retorno:
            return {}
        estoque_fiscal_id = obj_fiscal_imendes_utils.imeutl_importa_retorno_revisao(
            cr, uid, dados_retorno, context)

        reference = self.pool.get('ir.model.data').get_object_reference(
            cr, uid, 'estoque_fiscal', 'view_estoque_fiscal_itens_form')
        view_id = reference and reference[1] or False
        return {'name': 'Integracao fiscal', 'view_type': 'form',
                'res_id': self.pool.get('estoque.fiscal.capa').browse(
                    cr, uid, estoque_fiscal_id, context).estfca_item_ids[0].id, 'view_mode': 'form',
                'res_model': 'estoque.fiscal.itens', 'view_id': [view_id], 'target': 'new',
                'type': 'ir.actions.act_window'}
