# -*- coding: utf-8 -*-
from datetime import datetime
from dateutil.relativedelta import relativedelta
from openerp.osv import osv, fields
from .utils import meep_utils
import time
import logging
logger = logging.getLogger('meep.nfce')
import openerp.sql_db as sql_db


class meep_nfce(osv.Model):

    _inherit = 'meep.nfce'

    def meep_cron_get_invoices(self, cr, uid, args, context=None):
        logger.info('---> Meep/Mobi - Buscando notas (meep_cron_get_invoices)')
        context = context and context.copy() or {}
        _hInicio = time.time()
        if not args:
            args = -1
        try:
            int(args)
        except:
            args = -1
        if args > 0:
            args = -1
        _ontem = datetime.now() + relativedelta(days=args)
        dt_inicio = _ontem.strftime('%Y-%m-%d 00:00:00')
        dt_fim = datetime.now().now().strftime('%Y-%m-%d 23:59:59')
        pag = 0
        cr_novo = sql_db.db_connect(cr.dbname).cursor()
        while True:
            pag += 1
            logger.info('---> Meep/Mobi - Buscando Pagina: %s' % pag)
            res = self.pool.get('meep.utils').meep_get_invoice_orders(cr_novo, uid, dt_inicio, dt_fim, pag=pag, qtd=50)
            if res.get('status') == True:
                _dados = res.get('dados')
                for linha in _dados.get('ApiThirdGetOrdersResponseItems'):
                    args = [('meep_nfce_chave', '=', linha.get('Sefaz').get('NFCeAccessKey'))]
                    nfce_dados = self.pool.get('meep.nfce').search(cr_novo, uid, args, context=context, limit=1)
                    if nfce_dados:
                        continue
                    if linha.get('Sefaz').get('StatusCode') is None:
                        continue
                    vals = {
                        'meep_nfce_chave': linha.get('Sefaz').get('NFCeAccessKey'),
                        'meep_nfce_equipamento': linha.get('POS').get('Code'),
                        'meep_nfce_protocolo': linha.get('Sefaz').get('ProtocolNumber'),
                        'meep_nfce_numero': linha.get('Sefaz').get('Number'),
                        'meep_nfce_serie': linha.get('Sefaz').get('Serie'),
                        'meep_nfce_emissao': linha.get('Sefaz').get('EmitAt').replace('T', ' ')[:19],
                        'meep_nfce_status': linha.get('Sefaz').get('StatusCode'),
                        'meep_nfce_canc': linha.get('Sefaz').get('CancelAt'),
                    }
                    self.pool.get('meep.nfce').create(cr_novo, uid, vals, context=context)
                    cr_novo.commit()
                if not _dados.get('NextPage'):
                    break
            else:
                cr_novo.close()
                return False
        _hFim = time.time()
        logger.info('---> Meep/Mobi - Fim de busca: %s' % (_hFim - _hInicio))
        cr_novo.close()
        return True

    def meep_importar_uma_nfce(self, cr_novo, uid, nfce_id, context=None):
        _nfce_dados = self.pool.get('meep.nfce').read(cr_novo, uid, nfce_id, [], context=context)
        res = self.pool.get('meep.utils').meep_baixar_xml(cr_novo, uid, _nfce_dados.get('meep_nfce_chave'))
        if res.get('status') == True:
            _xml = res.get('dados')
            args = [('nfe_chave_acesso', '=', _nfce_dados.get('meep_nfce_chave'))]
            nfCapa_ids = self.pool.get('fiscal.nf.capa').search(cr_novo, uid, args, context=context, limit=1)
            if nfCapa_ids:
                self.pool.get('meep.nfce').unlink(cr_novo, uid, _nfce_dados.get('id'), context=context)
                cr_novo.commit()
                return True
            try:
                sql_begin = """BEGIN; SAVEPOINT meep_cron_importar_notas;"""
                cr_novo.execute(sql_begin)  # erp
                _args = [('name', '=', _nfce_dados.get('meep_nfce_equipamento'))]
                equi_ids = self.pool.get('meep.equipamentos').search(cr_novo, uid, _args, context=context)
                if not equi_ids:
                    _mens = 'Equipamento "%s" nao cadastrado!' % _nfce_dados.get('meep_nfce_equipamento')
                    self.pool.get('meep.nfce').write(cr_novo, uid, nfce_id,
                                                     {'meep_nfce_situacao': _mens}, context=context)
                    cr_novo.commit()
                    return True

                dados_equip = self.pool.get('meep.equipamentos').read(cr_novo, uid, equi_ids[0], [],
                                                            context=context)
                _local_id = dados_equip['meep_local_id']
                if isinstance(_local_id, (list, tuple)):
                    _local_id = _local_id[0]
                res = self.pool.get('fiscal.nf.capa').fisnfc_importar_xml_proprio(cr_novo, uid, _xml,
                                                                              cancelada=_nfce_dados.get('meep_nfce_canc'),
                                                                              local_id=_local_id,
                                                                              context=None)
            except Exception as e:
                sql_rollback = """ROLLBACK TO SAVEPOINT meep_cron_importar_notas;"""
                cr_novo.execute(sql_rollback)
                self.pool.get('meep.nfce').write(cr_novo, uid, _nfce_dados.get('id'),
                                                 {'meep_nfce_situacao': e}, context=context)
                cr_novo.commit()
                return True
            if not res.get('status'):
                sql_rollback = """ROLLBACK TO SAVEPOINT meep_cron_importar_notas;"""
                cr_novo.execute(sql_rollback)
                self.pool.get('meep.nfce').write(cr_novo, uid, _nfce_dados.get('id'),
                                                 {'meep_nfce_situacao': res.get('mensagem')}, context=context)
                cr_novo.commit()
                return True
            self.pool.get('meep.nfce').unlink(cr_novo, uid, _nfce_dados.get('id'), context=context)
            cr_novo.commit()
        return True

    def meep_cron_importar_notas(self, cr_orig, uid, args, context=None):
        logger.info('---> Meep/Mobi - Importando notas do MEEP p/o SigERP')
        context = context and context.copy() or {}
        if not (args and isinstance(args, int)):
            _qtdNfce = 0
        else:
            _qtdNfce = int(args)
        _hInicio = time.time()
        cr_novo = sql_db.db_connect(cr_orig.dbname).cursor()
        # Importar as notas que ainda não foram tratadas
        if _qtdNfce:
            nfce_ids = self.pool.get('meep.nfce').search(cr_novo, uid, [('meep_nfce_situacao', '=', None)],
                                                         context=context, limit=_qtdNfce)
        else:
            nfce_ids = self.pool.get('meep.nfce').search(cr_novo, uid, [('meep_nfce_situacao', '=', None)],
                                                         context=context)
        if not nfce_ids:
            # Importar as notas que já foram tratadas a mais de 1 hora
            _agora = datetime.now()
            _agora_menos_uma_hora = (_agora - relativedelta(hours=1)).strftime('%Y-%m-%d %H:%M:%S')
            if _qtdNfce:
                nfce_ids = self.pool.get('meep.nfce').search(cr_novo, uid, [('meep_nfce_situacao', '!=', None),
                                                                            ('write_date', '<', _agora_menos_uma_hora)],
                                                             context=context, limit=_qtdNfce)
            else:
                nfce_ids = self.pool.get('meep.nfce').search(cr_novo, uid, [('meep_nfce_situacao', '!=', None),
                                                                            ('write_date', '<', _agora_menos_uma_hora)],
                                                             context=context)

        for nfce_id in nfce_ids:
            self.meep_importar_uma_nfce(cr_novo, uid, nfce_id, context=context)
        _hFim = time.time()
        logger.info('---> Meep/Mobi - Fim de Importacao: %s' % (_hFim - _hInicio))
        cr_novo.close()
        return True

    def meep_nfce_button_importar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.meep_importar_uma_nfce(cr, uid, ids[0], context=context)
        return True