# -*- coding: utf-8 -*-

from openerp.osv import osv
import json
from ..meep import Meep
import time
import logging
from openerp.tools.translate import _



class meep_utils(osv.Model):

    _name = 'meep.utils'
    _logger = logging.getLogger(_name)

    def meep_get_token(self, cr, uid):
        _url = 'token/v1/Generate'
        _con = Meep(cr, uid)
        body = {
            'grant_type': 'password',
            'username': _con.usuario.encode('utf-8'),
            'password': _con.senha.encode('utf-8'),
        }
        res = _con.meep_comunicar('post', _url, data=body)
        if res.status_code > 399:
            if isinstance(res.content, str):
                _err = res.content
            else:
                _err = json.loads(res.content).get('error') or json.loads(res.content).get('message')
            _mens = '%s-%s' % (res.status_code, _err.decode('utf-8'))
            return {'status': False, 'mensagem': _mens}
        _dados = json.loads(res.content)
        return {'status': True, 'dados': _dados.get('access_token')}

    def meep_get_sales(self, cr, uid, dt_inicio, dt_fim, pag=0, qtd=50):
        _url = 'third/sales/v1/Get'
        _con = Meep(cr, uid)
        if _con.habilitar_log:
            self._logger.info(_('----Metodo meep_get_sales'))
            _tinicio = time.time()

        body = {
            'StoreId': _con.story_id,
            'Start': dt_inicio,
            'End': dt_fim,
            'Page': pag,
            'Count': qtd
        }
        res = _con.meep_comunicar('get', _url, params=body)
        if _con.habilitar_log:
            self._logger.info(_('----Metodo meep_get_sales'))
        if res.status_code > 399:
            if isinstance(res.content, str):
                _err = res.content
            else:
                _err = json.loads(res.content).get('error') or json.loads(res.content).get('message')
            _mens = '%s-%s' % (res.status_code, _err.decode('utf-8'))
            self._logger.info(_('Nao consegui pegar as vendas! Erro: %s') % _mens)
            return {'status': False, 'mensagem': _mens}
        _dados = json.loads(res.content)
        return {'status': True, 'dados': _dados}

    def meep_get_invoice_orders(self, cr, uid, dt_inicio, dt_fim, pag=0, qtd=50):
        _url = 'third/sales/v1/GetInvoiceOrders'
        _con = Meep(cr, uid)
        body = {
            'OwnerId': _con.story_id,
            'Start': dt_inicio,
            'End': dt_fim,
            'Page': pag,
            'Count': qtd
        }
        res = _con.meep_comunicar('get', _url, params=body)
        if res.status_code > 399:
            if isinstance(res.content, str):
                _err = res.content
            else:
                _err = json.loads(res.content).get('error') or json.loads(res.content).get('message')
            _mens = '%s-%s' % (res.status_code, _err.decode('utf-8'))
            self._logger.info(_('Nao consegui pegar as invoce_orders! Erro: %s') % _mens)
            return {'status': False, 'mensagem': _mens}
        _dados = json.loads(res.content)
        return {'status': True, 'dados': _dados}

    def meep_get_orders_progress(self, cr, uid):
        _url = 'third/sales/v1/GetOrdersInProgress'
        _con = Meep(cr, uid)
        body = {
        }
        res = _con.meep_comunicar('get', _url, params=body)
        if res.status_code > 399:
            if isinstance(res.content, str):
                _err = res.content
            else:
                _err = json.loads(res.content).get('error') or json.loads(res.content).get('message')
            _mens = '%s-%s' % (res.status_code, _err.decode('utf-8'))
            self._logger.info(_('Nao consegui pegar as invoce_orders! Erro: %s') % _mens)
            return {'status': False, 'mensagem': _mens}
        _dados = json.loads(res.content)
        return {'status': True, 'dados': _dados}

    def meep_get_simple_sale(self, cr, uid, dt_inicio, dt_fim):
        _url = 'third/sales/v1/GetSimpleSales'
        _con = Meep(cr, uid)
        body = {
            'StoreId': _con.story_id,
            'Start': dt_inicio,
            'End': dt_fim,
        }
        res = _con.meep_comunicar('get', _url, params=body)
        if res.status_code > 399:
            if isinstance(res.content, str):
                _err = res.content
            else:
                _err = json.loads(res.content).get('error') or json.loads(res.content).get('message')
            _mens = '%s-%s' % (res.status_code, _err.decode('utf-8'))
            self._logger.info(_('Nao consegui pegar as simple sale! Erro: %s') % _mens)
            return {'status': False, 'mensagem': _mens}
        _dados = json.loads(res.content)
        return {'status': True, 'dados': _dados}

    def meep_baixar_xml(self, cr, uid, chaveNfce):
        _url = 'third/sales/v1/getxml/%s' % chaveNfce
        _con = Meep(cr, uid)
        body = {
        }
        res = _con.meep_comunicar('get', _url, params=body)
        if res.status_code > 399:
            if isinstance(res.content, str):
                _err = res.content
            else:
                _err = json.loads(res.content).get('error') or json.loads(res.content).get('message')
            _mens = '%s-%s' % (res.status_code, _err.decode('utf-8'))
            self._logger.info(_('Nao consegui pegar as simple sale! Erro: %s') % _mens)
            return {'status': False, 'mensagem': _mens}
        _dados = res.content
        return {'status': True, 'dados': _dados}
