# -*- encoding: utf-8 -*-
import re
import time
from urllib import urlencode
import requests
from openerp import pooler
from SigUtils.geralogs import geraLogs
from openerp.tools import config


class Meep(object):
    def __init__(self, cr, uid):
        self.API_ROOT_URL = 'https://meep-management.azure-api.net'
        self.SDK_VERSION = 'SIG.1.01'
        self.cr = cr
        self.uid = uid
        self.habilitar_log = False
        _poolget = pooler.get_pool(cr.dbname).get
        fispar_ids = _poolget('fiscal.parametro').search(cr, uid, [])
        if fispar_ids:
            fispar_ids = fispar_ids[0]
            fields = ['fispar_meep_primary_key', 'fispar_meep_story_id', 'fispar_meep_usuario', 'fispar_meep_senha',
                      'fispar_meep_access_token', 'fispar_meep_habilitar_log']
            dados = _poolget('fiscal.parametro').read(cr, uid, fispar_ids, fields)
            self.primary_key = dados.get('fispar_meep_primary_key')
            self.story_id = dados.get('fispar_meep_story_id')
            self.usuario = dados.get('fispar_meep_usuario')
            self.senha = dados.get('fispar_meep_senha')
            self.access_token = dados.get('fispar_meep_access_token')
            self.habilitar_log = dados.get('fispar_meep_habilitar_log')

    def _get_arq_log(self):
        _arq_log = 'meep_' + self.cr.dbname
        return _arq_log

    def _gerar_logs(self, mens):
        _diretorio = config.get('logfile')
        if _diretorio:
            _lista = _diretorio.split('/')
            _lista.pop(len(_lista) -1)
            _diretorio = '/'.join(_lista)
        else:
            _diretorio = '/var/log/openerp'
        _arq_log = self._get_arq_log()
        try:
            geraLogs(_arq_log, mens, 'S', _diretorio)
        except:
            try:
                geraLogs(_arq_log, mens.encode('ASCII', 'ignore'), 'S', _diretorio)
            except:
                geraLogs(_arq_log, 'Nao consegui registrar o log', 'S', _diretorio)
        return True


    # REQUEST METHODS
    def make_path(self, path, params={}):
        # Making Path and add a leading / if not exist
        if not (re.search("^http", path)):
            if not (re.search("^\/", path)):
                path = "/" + path
            path = self.API_ROOT_URL + path
        if params:
            path = path + "?" + urlencode(params)
        return path


    def meep_comunicar(self, metodo, uri, data='', json={}, params={}, headers={}):
        def comunicar():
            if self.habilitar_log:
                self._gerar_logs('Meep.%s-> URI:%s -> DADOS:%s -> JSON: %s -> HEADER:%s -> PARAMS:%s' % (metodo,
                                                                                                         uri, str(data),
                                                                                                         str(json),
                                                                                             novoHeaders, str(params)))
                _tinicio = time.time()
            response = requests.request(metodo, uri, data=data, json=json, params=params, headers=novoHeaders)
            if self.habilitar_log:
                _dif = time.time() - _tinicio
                self._gerar_logs('Meep.resposta--> Tempo:%s %s-%s ' % (_dif, response.status_code, response.content))
            return response

        novoHeaders = {
            'cache-control': 'no-cache',
            'Ocp-Apim-Subscription-Key': self.primary_key,
        }
        if not 'token' in uri:
            novoHeaders['authorization'] = 'Bearer %s' % self.access_token
        novoHeaders.update(headers)
        uri = self.make_path(uri)
        metodo = metodo.upper()
        response = comunicar()
        if response.status_code == 429:
            time.sleep(3)
        return response

