# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from SigUtils.datas import calcDiferenca
from SigUtils.datas import calcUltimoDiaDoMes
from SigUtils.datas import months_between
from SigUtils.monthdelta import monthdelta
from SigUtils import datas
from datetime import date
from datetime import timedelta
from openerp.osv import fields
from openerp.osv import osv
from openerp.tools.translate import _


class fluxocaixa_previsao(osv.Model):
    _name = 'fluxocaixa.previsao'
    _inherit = 'fluxocaixa.previsao'

    def _gerar_titulos(self, cr, uid, ids, operacao, context):
        context = context and context.copy() or {}
        vals = self.read(cr, uid, ids,
                         ['valor', 'company_id', 'insidencia', 'periodo_i', 'sabado', 'domingo', 'periodo_f',
                          'pessoa_id', 'tipo', 'dia', 'antecipa_feriado', 'tipo_dia', 'mes'], context=context)


        # CRIANDO OU ALTERANDO A PREVISAO
        if operacao == 'write':
            vals = vals[0]
            ids = ids[0]
            ids_prv = self.pool.get('financeiro.titulo').search(cr, uid, [('previsao_id', '=', ids)], context=context)
            self.pool.get('financeiro.titulo').unlink(cr, uid, ids_prv, context=context)
        context['valor_tit'] = vals['valor']
        # VERIFICA SE È FERIADO PARA A DATA PASSADA
        def is_feriado(data):
            res = 0
            args = [('admcfe_dia', '=', data.day), ('admcfe_mes', '=', data.month)]
            feriado_ids = self.pool.get('adm.calendario.feriados').search(cr, uid, args, context=context)
            vals_feriado = self.pool.get('adm.calendario.feriados').browse(cr, uid, feriado_ids)
            p_pais = self.browse(cr, uid, ids).pessoa_id.pais
            p_cidade = self.browse(cr, uid, ids).pessoa_id.cidade
            p_uf = self.browse(cr, uid, ids).pessoa_id.uf
            for x in vals_feriado:
                if x.admcfe_tipo == 'F':
                    if x.admcfe_pais_id.name == p_pais:
                        res += 1
                if x.admcfe_tipo == 'E':
                    if (x.admcfe_pais_id.name == p_pais) and (x.admcfe_uf_id.sigla == p_uf):
                        res += 1
                if x.admcfe_tipo == 'M':
                    if (x.admcfe_pais_id.name == p_pais) and (x.admcfe_uf_id.sigla == p_uf) and (x.admcfe_uf_cidade.name == p_cidade):
                        res += 1
            return True if res > 0 else False

        # PEGA OS PARAMETROS DA EMPRESA
        doc_tipo_id = self.pool.get('documento.documento.tipo').search(cr, uid, [('sigla', '=', 'PRV')], context=context)[0]
        par_id = self.pool.get('financeiro.parametros').search(cr, uid, [], context=context)
        parametros = self.pool.get('financeiro.parametros').read(cr, uid, par_id, ['moeda_id', 'local_cobranca_id'], context=context)
        local_cobranca_id = parametros[0]['local_cobranca_id'][0]
        adm_moeda_id = parametros[0]['moeda_id'][0]
        # VALIDAcoES DOS CAMPOS
        parcela = 1
        if (vals['insidencia'] in ['D', 'S']):
            # CONVERTE A DATA INICIAL PARA: <type 'datetime.date'>
            y1, m1, d1 = (int(x) for x in vals['periodo_i'].split('-'))
            periodo_i = date(y1, m1, d1)
            # CALCULA A DIFERENCA DE DIAS E INCREMENTA O PERIODO INICIAL E EFETUA OS
            sab_dom = [0, 1, 2, 3, 4] # DIAS DA SEMANA SEG, TER, QUA, QUI, SEX
            # SE SAB/DOM = TRUE ADICION A LISTA E GERA OS MOVIMENTO P ESSES DIAS
            if 'sabado' in vals:
                if vals['sabado']:
                    sab_dom.append(5)
            if 'domingo' in vals:
                if vals['domingo']:
                    sab_dom.append(6)
                    # ----------------------------------------------------------------------
                    # LANcAMENTO COM INCIDeNCIA DIaRIA
            # ----------------------------------------------------------------------
        context['fintit_titulo_sem_custificacao'] = True
        if (vals['insidencia'] == 'D'):
            for i in range(calcDiferenca(vals['periodo_i'], vals['periodo_f']) + 1):
                # VERIFICA NaO SE e SABADO OU DOMINGO
                if (periodo_i + timedelta(days=i)).weekday() in sab_dom:
                    vals_tit = {
                        'previsao_id': ids,
                        'company_id': vals['company_id'][0],
                        'pessoa_id': vals['pessoa_id'][0],
                        'documento': ids,
                        'tipo_titulo': vals['tipo'],
                        'data_emissao': vals['periodo_i'],
                        'doc_tipo_id': doc_tipo_id,
                        'local_cobranca_id': local_cobranca_id,
                        'adm_moeda_id': adm_moeda_id,
                        'data_prorrogacao': str(periodo_i + timedelta(days=i)),
                        'data_vencimento': str(periodo_i + timedelta(days=i)),
                        'vr_original': vals['valor'],
                        'parcela': parcela
                    }
                    self.pool.get('financeiro.titulo').create(cr, uid, vals_tit, context=context)
                    parcela += 1
                    # ----------------------------------------------------------------------
                    # LANcAMENTO COM INCIDeNCIA SEMANAL
            # ----------------------------------------------------------------------
        if (vals['insidencia'] == 'S'):
            for i in range(calcDiferenca(vals['periodo_i'], vals['periodo_f']) + 1):
                # VERIFICA SE È O DIA DA SEMANA SELECIONADO E CRIA OS TITULOS
                if (periodo_i + timedelta(days=i)).weekday() == vals['dia']:
                    periodo = (periodo_i + timedelta(days=i))
                    # VERIFICA SE ANTECIPA FERIADO
                    if vals['antecipa_feriado'] and is_feriado(periodo):
                        if (periodo - timedelta(days=1)) < periodo_i:
                            continue
                        else:
                            periodo = (periodo - timedelta(days=1))
                            # VALORES QUE SERaO LANcADOS NO TITULO
                    vals_tit = {
                        'previsao_id': ids,
                        'company_id': vals['company_id'][0],
                        'pessoa_id': vals['pessoa_id'][0],
                        'documento': ids,
                        'tipo_titulo': vals['tipo'],
                        'data_emissao': vals['periodo_i'],
                        'doc_tipo_id': doc_tipo_id,
                        'local_cobranca_id': local_cobranca_id,
                        'adm_moeda_id': adm_moeda_id,
                        'data_prorrogacao': periodo,
                        'data_vencimento': periodo,
                        'vr_original': vals['valor'],
                        'parcela': parcela
                    }
                    self.pool.get('financeiro.titulo').create(cr, uid, vals_tit, context=context)
                    parcela += 1
        # ----------------------------------------------------------------------
        # LANcAMENTO COM INCIDeNCIA QUINZENAL/MENSAL
        # ----------------------------------------------------------------------
        if vals['insidencia'] in ['Q', 'M', 'T']:

            y1, m1, d1 = (int(x) for x in vals['periodo_i'].split('-'))
            data_ini = date(y1, m1, d1)
            y1, m1, d1 = (int(x) for x in vals['periodo_f'].split('-'))
            data_fim = date(y1, m1, d1)
            dia = vals['dia']
            periodos = []

            for i in range(0, months_between(data_fim, data_ini)):
                if vals['insidencia'] == 'Q':
                    quinz_1 = date(data_ini.year, data_ini.month, dia) + monthdelta(i)
                    periodos.append(quinz_1)
                    quinz_2 = quinz_1 + timedelta(days=15)
                    if quinz_2 > date(quinz_1.year, quinz_1.month, calcUltimoDiaDoMes(quinz_1)):
                        quinz_2 = date(quinz_1.year, quinz_1.month, calcUltimoDiaDoMes(quinz_1))
                    periodos.append(quinz_2)
                elif vals['insidencia'] == 'M':
                    periodos.append(date(data_ini.year, data_ini.month, dia) + monthdelta(i))
                elif vals['insidencia'] == 'T' and (i % 3 + 1) == int(vals['mes']):
                    periodos.append(date(data_ini.year, data_ini.month, dia) + monthdelta(i))

            parcela = 1
            feriados_ids = self.pool.get('adm.calendario.feriados').search(cr, uid, [], context=context)
            data_feriados = []
            for fe_id in feriados_ids:
                data_feriado = self.pool.get('adm.calendario.feriados').browse(cr, uid, fe_id).admcfe_data
                data_feriados.append(data_feriado)
            for i in periodos:
                vDia = i
                inicio_periodo = date(vDia.year, vDia.month, 1) - timedelta(days=1) # ultimo dia do mes anterior, pois nao estava considerando o dia 1
                if vals['tipo_dia'] == 'U':
                    vDia = datas.calcVencimento(inicio_periodo, dia, 'DU', feriados=data_feriados)
                    vDia = vDia[:4] + '-' + vDia[4:6] + '-' + vDia[6:8]
                elif vals['tipo_dia'] == 'D':
                    vDia = inicio_periodo + timedelta(days=dia)
                    if (vals['antecipa_feriado'] == True) and str(vDia) in data_feriados:
                        vDia = inicio_periodo + timedelta(days=dia-1)
                if (str(vDia) < str(data_ini)) or (str(vDia) > str(data_fim)):
                    continue
                vals_tit = {
                    'previsao_id': ids,
                    'company_id': vals['company_id'][0],
                    'pessoa_id': vals['pessoa_id'][0],
                    'documento': ids,
                    'tipo_titulo': vals['tipo'],
                    'data_emissao': vals['periodo_i'],
                    'doc_tipo_id': doc_tipo_id,
                    'local_cobranca_id': local_cobranca_id,
                    'adm_moeda_id': adm_moeda_id,
                    'data_prorrogacao': str(vDia),
                    'data_vencimento': str(vDia),
                    'vr_original': vals['valor'],
                    'parcela': parcela
                }
                # Previsao nao deve gerar custificacao
                context.update({'fintit_titulo_sem_custificacao': True, 'fintit_manter_prv': True})
                self.pool.get('financeiro.titulo').create(cr, uid, vals_tit, context=context)
                parcela += 1
        # ----------------------------------------------------------------------
        # LANcAMENTO COM INCIDeNCIA UNICA
        # ----------------------------------------------------------------------
        if (vals['insidencia'] == 'U'):
            vals_tit = {
                'previsao_id': ids,
                'company_id': vals['company_id'][0],
                'pessoa_id': vals['pessoa_id'][0],
                'documento': ids,
                'tipo_titulo': vals['tipo'],
                'data_emissao': vals['periodo_i'],
                'doc_tipo_id': doc_tipo_id,
                'local_cobranca_id': local_cobranca_id,
                'adm_moeda_id': adm_moeda_id,
                'data_prorrogacao': vals['periodo_i'],
                'data_vencimento': vals['periodo_i'],
                'vr_original': vals['valor'],
                'parcela': parcela
            }
            self.pool.get('financeiro.titulo').create(cr, uid, vals_tit, context=context)
        return parcela

    def onchange_insidencia(self, cr, uid, ids, insidencia):
        values = {}
        if insidencia in ['D', 'S']:
            values['dia'] = 0
            values['tipo_dia'] = ''
            values['antecipa_feriado'] = False
        if insidencia in ('Q', 'M', 'T'):
            values['sabado'] = False
            values['domingo'] = False
        if insidencia == 'U':
            values['dia'] = 0
            values['tipo_dia'] = ''
            values['antecipa_feriado'] = False
            values['sabado'] = False
            values['domingo'] = False
            values['periodo_f'] = False
        return {'value': values}

    def unlink(self, cr, uid, ids, context=None):
        # VERIFICA SE e LANcAMENTO MANUAL E ORIGEM = U
        context = context and context.copy() or {}
        if (context.get('lancamento_manual', False)):
            origem = self.read(cr, uid, ids, ['origem'], context=context)[0]['origem']
            if origem == 'S':
                raise osv.except_osv(_('Atencao'), _('Nao e permitido alterar um registro cujo a Origem seja Sistema!'))
        return super(fluxocaixa_previsao, self).unlink(cr, uid, ids, context=context)

    def create(self, cr, uid, vals, context=None):
        """
        Funcao que permite lancar as previsoes do que tem a receber, aquilo que
        ainda nao e oficial. A previsao lancada, refletira em financeiro titulo.
        """
        context = context and context.copy() or {}
        self.validar(vals, context)
        if not (context.get('lancamento_manual', False)) or (vals.get('origem') != 'S'):
            # SUPER
            res = super(fluxocaixa_previsao, self).create(cr, uid, vals, context=context)
            # GERA OS TITULOS P PREVISAO LANcADA
            if not self._gerar_titulos(cr, uid, ids=res, operacao='create', context=context):
                raise osv.except_osv(_('Atencao'), _('Nao foi possivel gerar nenhum lancamento\n\nVerifique as Datas'))
        # if not context.get('lancamento_manual', False):
        #     res = super(fluxocaixa_previsao, self).create(cr, uid, vals, context=context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        res = super(fluxocaixa_previsao, self).write(cr, uid, ids, vals, context=context)
        vals = \
            self.read(cr, uid, ids, ['origem', 'insidencia', 'dia', 'valor', 'periodo_i', 'periodo_f', 'dia_semana'], context=context)[0]
        self.validar(vals, context)
        if (not context.get('lancamento_manual', False)) or (vals['origem'] != 'S'):
            if not self._gerar_titulos(cr, uid, ids=ids, operacao='write', context=context):
                raise osv.except_osv(_('Atencao'), _('Nao foi possivel gerar nenhum lancamento\n\nVerifique as Datas'))
        return res

    """
    Author: joao.almeida
    Desc: Os métodos create e write fazem a mesma validação antes de salvar.
    Estou extraindo a validação para um único método.
    """
    def validar(self, vals, context):
        # VERIFICA SE e LANcAMENTO MANUAL E ORIGEM = U
        if (context.get('lancamento_manual', False)) and vals.get('origem') == 'S':
            raise osv.except_osv(_('Atencao'), _('Nao e permitido alterar um registro cujo a Origem seja Sistema!'))
        else:
            # VALOR MENOR/IGUAL A ZERO
            if vals.get('valor') <= 0:
                raise osv.except_osv(_('Atencao'), _('Valor nao poder ser menor ou igual a zero!'))
                # VALIDAcoES DOS CAMPOS
            if vals.get('insidencia') != 'U':
                # VERIFICA DATA DE VALIDADE INICIAL e MAIOR QUE DATA VALIDADE FINAL
                if vals.get('periodo_i') > vals.get('periodo_f'):
                    raise osv.except_osv(_('Atencao'), _(
                        'A Data de Validade Inicial da Previsao nao pode ser maior que a Data de Validade Final!'))
                    # SE DIA MENSAL MAIOR QUE DIAS VALIDADE INICIAL
            if vals.get('insidencia') in ('M', 'T') and vals.get('dia') > calcUltimoDiaDoMes(vals.get('periodo_i')):
                raise osv.except_osv(_('Atencao'), _('Para Insidencia Mensal informe um Dia entre 1 - 31'))
                # SE DIA MENSAL/QUINZENAL MENOR OU IGUAL A ZERO
            if vals.get('insidencia') in ('Q', 'M', 'T') and vals.get('dia') <= 0:
                raise osv.except_osv(_('Atencao'), _('O Dia nao pode ser menor ou igual a zero (0)'))
                # SE QUINZENAL DIA MAIOR QUE 15
            if vals.get('insidencia') == 'Q' and vals.get('dia') > 15:
                raise osv.except_osv(_('Atencao'), _('Para Insidencia Quinzenal informe um Dia entre 1 - 15'))


