#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv


class financeiro_titulo(osv.Model):
    _name = 'financeiro.titulo'
    _inherit = 'financeiro.titulo'

    def fintit_button_pesquisar_previsao(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_doc_tipo = self.pool.get('documento.documento.tipo')
        doc_tip_previsao_id = obj_doc_tipo.search(cr, uid, [('sigla', '=', 'PRV')], context=context)
        pessoa_id = context.get('pessoa_id', False)
        tipo_titulo = context.get('tipo_titulo', False)
        args_tit_prev_ids = [('pessoa_id', '=', pessoa_id),
                             ('tipo_titulo', '=', tipo_titulo),
                             ('doc_tipo_id', 'in', doc_tip_previsao_id)]
        obj_model_data = self.pool.get('ir.model.data')
        referencia = obj_model_data.get_object_reference(cr, uid, 'fluxocaixa',
                                                         'view_fintit_pesquisa_previsao_tree')
        view_id = referencia and referencia[1] or False
        return {
            'view_type': 'form',
            'view_mode': 'tree',
            'res_model': 'financeiro.titulo',
            'view_id': view_id,
            'type': 'ir.actions.act_window',
            'target': 'new',
            'context': context,
            'domain': args_tit_prev_ids
        }

    def fintit_button_excluir_previsao(self, cr, uid, ids, context=None):
        """
        O método realiza a exclusão de previsões (financeiro_titulo)
        :param cr: cursor no banco de dados
        :param uid: id da tabela res_users, identificador do usuário
        :param ids: lista de id da tabela financeiro_titulo
        :param context: dicionário com valores contextuais
        :return: chamada do método que exibe a lista atualizada de previsões, ou seja, sem a que
        foi excluída
        """
        context = context and context.copy() or {}
        super(financeiro_titulo, self).unlink(cr, uid, ids, context)
        return self.fintit_button_pesquisar_previsao(cr, uid, context.get('active_ids'), context)
