# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class estoque_movimento_itens(osv.Model):

    _name = 'estoque.movimento.itens'
    _inherit = 'estoque.movimento.itens'

    def write(self, cr, user, ids, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('produto_id',False) and not context.get('atualizacao_inventario'):
            garantias = self.pool.get('estoque.produto').read(cr,user, vals.get('produto_id',False),['garantia_loja','garantia_fornec'], context=context)
            if garantias:
                vals.update(garantias[0])

        return super(estoque_movimento_itens,self).write(cr, user, ids, vals, context=context)

    def create(self, cr, user, vals, context=None):
        context = context and context.copy() or {}
        if context.get('atualizacao_inventario'):
            return super(estoque_movimento_itens, self).create(cr, user, vals, context=context)

        garantias = self.pool.get('estoque.produto').read(cr, user, vals.get('produto_id', False),
                                              ['garantia_loja', 'garantia_fornec'], context=context)
        if garantias:
            if isinstance(garantias, list):
                garantias = garantias[0]

            vals.update(garantias)

        return super(estoque_movimento_itens, self).create(cr, user, vals, context=context)
