# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import _gesbas_aces_get_dados


class gesbas_acessos(osv.Model):
    """
    Classe para controle de volume de acessos ao sigerp
    """
    _name = 'gesbas.acessos'
    _columns = {
        'gesbas_aces_pessoa_id': fields.many2one("adm.pessoa", 'Cliente', select=1, ondelete='cascade'),
        'name': fields.function(_gesbas_aces_get_dados, method=True,  multi="dados",string='Cliente', type='text',
                                store=False),
        'gesbas_aces_base': fields.char('Base', size=30),
        'gesbas_aces_servidor': fields.function(_gesbas_aces_get_dados, method=True, multi="dados", string='Servidor',
                                                type='text', store=False),
        'gesbas_aces_data_hora': fields.datetime('Data', select=1),
        'gesbas_aces_quantidade': fields.integer('Quantidade'),
    }
    _order = 'gesbas_aces_data_hora desc,gesbas_aces_pessoa_id'
