# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import _gesbas_aces_get_dados


class gesbas_servidores(osv.Model):
    """
    Classe para controle de estatisticas de uso de servidores sigerp
    """
    _name = 'gesbas.servidores'
    _columns = {
        'name': fields.char('Servidor', size=20, select=1),
        'gesbas_serv_data_hora': fields.datetime('Data', select=1),
        'gesbas_serv_cpu_cores': fields.integer('Cpus cores'),
        'gesbas_serv_cpu_1_min': fields.float('Cpu uso 1 min', digits=(3, 1)),
        'gesbas_serv_cpu_5_min': fields.float('Cpu uso 5 min', digits=(3, 1)),
        'gesbas_serv_cpu_15_min': fields.float('Cpu uso 15 min', digits=(3, 1)),
        'gesbas_serv_avg_1_min': fields.float('Avg uso 1 min', digits=(3, 1)),
        'gesbas_serv_avg_5_min': fields.float('Avg uso 5 min', digits=(3, 1)),
        'gesbas_serv_avg_15_min': fields.float('Avg uso 15 min', digits=(3, 1)),
        'gesbas_serv_dsk_uso': fields.float('Disco uso', digits=(12, 0)),
        'gesbas_serv_dsk_per': fields.float('Disco perc.uso', digits=(3, 1)),
        'gesbas_serv_dsk_read_count': fields.float('Disco read qtd.', digits=(12, 0)),
        'gesbas_serv_dsk_read_bytes': fields.float('Disco read bytes', digits=(12, 0)),
        'gesbas_serv_dsk_write_count': fields.float('Disco write qtd.', digits=(12, 0)),
        'gesbas_serv_dsk_write_bytes': fields.float('Disco write bytes', digits=(12, 0))
    }
    _order = 'name,gesbas_serv_data_hora desc'
