# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _

class importacoes_despesas(osv.Model):
    _inherit = 'importacoes.despesas'

    def impdsp_onchange_despesa_valor_tipo(self, cr, uid, ids, impdsp_onchange_despesa_valor_tipo, context=None):
        vals = {'warning': '', 'value': {}}
        if impdsp_onchange_despesa_valor_tipo == 'F':
            vals['value']['impdsp_percentual'] = 0.00
        return vals

    def impdsp_onchange_despesa_tipo(self, cr, uid, ids, impdsp_despesa_tipo, context=None):
        vals = {'warning': '', 'value': {}}
        if impdsp_despesa_tipo == 'I':
            vals['value']['impdsp_despesa_valor_tipo'] = 'V'
            vals['value']['impdsp_moeda_tipo'] = 'R'
            vals['value']['impdsp_percentual'] = 0.00
        if impdsp_despesa_tipo == 'T':
            vals['value']['impdsp_despesa_valor_tipo'] = 'F'
            vals['value']['impdsp_moeda_tipo'] = 'R'
        return vals

    def impdsp_validar(self, origem, aplicacao):
        if origem == 'O' and aplicacao == 'I':
            raise osv.except_osv(_('Atencao:'),
                                 _('Uma despesa com origem "Fornecedor" nao pode ser aplicada a capa"!'))
        if origem == 'V' and aplicacao == 'P':
            raise osv.except_osv(_('Atencao:'),
                                 _('Uma despesa com origem "Frete volume" nao pode ser aplicada ao item"!'))
        if origem == 'F' and aplicacao == 'P':
            raise osv.except_osv(_('Atencao:'),
                                 _('Uma despesa com origem "Frete" nao pode ser aplicada ao item"!'))
        return True

    def write(self, cr, uid, ids, vals, context=None):
        res = super(importacoes_despesas, self).write(cr, uid, ids, vals, context=context)
        for brw in self.browse(cr, uid, ids, context=context):
            self.impdsp_validar(brw.impdsp_origem, brw.impdsp_aplicacao)
        return res

    def create(self, cr, uid, vals, context=None):
        self.impdsp_validar(vals.get('impdsp_origem'), vals.get('brw.impdsp_aplicacao'))
        res = super(importacoes_despesas, self).create(cr, uid, vals, context=context)
        return res

