#!/usr/bin/python
# -*- coding: utf-8 -*-
idPrograma = 'atuope.py'
idVersao = 'Versao 1.01 de 09/03/2012'
idObs = 'Copyrigth by Sig Informatica Ltda'
"""
Programa para atualizar todos os registros de uma tabela para que os
campos functions possam ser calculados

Estrutura do sigerp.cfg
hostname,username,password,database,dbhostname,dbuser,dbpasswd
localhost,admin,admin,teste,localhost,luiz,admin

"""

import xmlrpclib, socket
import csv
from SigUtils import datas


try:
    arq_configuracao = '../objetos/sigerp.cfg'
    arquivo = csv.DictReader(open(arq_configuracao))
    for a in arquivo:
        hostname = a['hostname']
        username = a['username']
        pwd = a['password']
        db = a['database']
        porta = a['porta']
except:
    print 'Digite dados para coneccao no SigERP!'
    hostname = raw_input('Hostname: ')
    username = raw_input('Usuário: ')
    pwd = raw_input('Senha: ')
    db = raw_input('Banco: ')
    porta = raw_input('porta: ')

sock_common = xmlrpclib.ServerProxy ( 'http://'+hostname+':'+ str(porta) +'/xmlrpc/common' )
socket.setdefaulttimeout(3)
uid = sock_common.login( db, username, pwd )
sock = xmlrpclib.ServerProxy( 'http://'+hostname+':'+ str(porta) +'/xmlrpc/object' )
try:
    ids = sock.execute(db, uid, pwd, 'res.company', 'search', [])
except Exception as err:
    print 'Nao consegui conectar!'
    print str(err)
    exit()

def tesouraria_atualizar():
    for conta_id in sock.execute(db, uid, pwd, 'financeiro.tesouraria.contas', 'search', []):
        print conta_id
        sock.execute(db, uid, pwd, 'financeiro.tesouraria.saldos', 'fintsa_recalcular_saldos', conta_id, '2012-01-01')

while True:
    tabela = raw_input('Tabela para atualizar: ').replace('_', '.')
    if tabela == '':
        print '---------------------------------------'
        print ''
        print 'Fim'
        print ''
        exit()
    if tabela == 'ts' or tabela=='financeiro.tesouraria.saldos':
        tesouraria_atualizar()
    try:
        ids = sock.execute(db, uid, pwd, tabela, 'search', [])
        dados = {}
        context = {'salvar_forcado':True}
        if tabela == 'estoque_local_locacao':
            for id in ids:
               _local_id = sock.execute(db, uid, pwd, tabela, 'read', id, ['local_id'])['local_id']
               dados['local_id'] = _local_id
               sock.execute(db, uid, pwd, tabela, 'write', id, dados, context)
        else:
            if tabela == 'estoque_produto':
               dados['date_write'] = datas.hoje_I
            sock.execute(db, uid, pwd, tabela, 'write', ids, dados, context)
        print 'Atualizado!'
        print '---------------------------------------'
        print ''
        print ''
    except Exception as err:
        print('Nao consegui acessar a tabela!')
        print str(err)
        print '---------------------------------------'
        print ''
        print ''

