#!/usr/bin/python
# -*- coding: utf-8 -*-
idPrograma='ctb2ope.py'
idVersao='Versao 1.01 de 20/07/2011'
idObs='Copyrigth by Sig Informatica Ltda'
"""
Programa para exportacao de dados do Sig Cobol(Contabilidade) para o SigERP
Este programa deve estar na pasta objetos, juntamente com o arquivo de configuracao sigerp.cfg
Este programa e chamado direto do programa cobol

Estrutura do sigerp.cfg
hostname,username,password,database,dbhostname,dbuser,dbpasswd
localhost,admin,admin,teste,localhost,luiz,admin
"""

import sys, os
import xmlrpclib, socket
import csv
from SigUtils import datas, geralogs, calcDigito, numero, formatastring
import psycopg2
import psycopg2.extras
import psutil
i=0
lista=[]
diretorio = './'
encerrar = 'N'
try:
   for proc in psutil.process_iter():
      for x in proc.cmdline:
         if 'ctb2ope.py' in x:
            if proc.cmdline[1] == '../objetos/ctb2ope.py':
               i+=1
               arquivo = proc.cmdline[2]
               if i > 1:
                  for a in lista:
                     if a == arquivo:
                        encerrar = 'S'
               lista.append(arquivo)
except:
   pass
if encerrar == 'S':
   exit()
def gravarLog(texto):
    geralogs.geraLogs('ctb2ope.log', texto, 'S', '../arquivos/logs/')

try:
    arq_configuracao='../objetos/sigerp.cfg'
    arquivo=csv.DictReader(open(arq_configuracao))
    for a in arquivo:
        hostname = a['hostname']
        username = a['username']
        pwd = a['password']
        porta = a['porta']
        db = a['database']
        dbhostname = a['dbhostname']
        dbuser = a['dbuser']
        dbpasswd = a['dbpasswd'] 
except:
    gravarLog('Erro identificando parametros - sigerp.cfg')

sock_common = xmlrpclib.ServerProxy ( 'http://'+hostname+':'+porta+'/xmlrpc/common' )
socket.setdefaulttimeout(3)
uid = sock_common.login( db, username, pwd )
sock = xmlrpclib.ServerProxy( 'http://'+hostname+':'+porta+'/xmlrpc/object' )

_stringConeccao = ("dbname='" +db
                        +"' user='"+dbuser
                        +"' host='"+dbhostname
                        +"' password='"+dbpasswd
                        +"' connect_timeout='%d" % 3 + "'")
conn = psycopg2.connect(_stringConeccao)
cr=conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
cr_log=conn.cursor(cursor_factory=psycopg2.extras.DictCursor)


def inserirSQL(cr, tabela, dados):
    dados['create_uid'] = uid
    dados['create_date'] = datas.hoje_I
    _qtdCampos = len(dados)
    _txt1 = '('
    _txt3 = "("
    for x in dados.keys():
        _txt1 += x + ', '
        _txt3 += "'" + str(dados[x]) + "', "
    _txt1 = _txt1[:-2] + ')'
    _txt3 = _txt3[:-2] + ")"
    _txt2 = "'%s'," * _qtdCampos
    _txt2 = "(" + _txt2[:-1] + ")"
    _sql = "insert into " + tabela + " " + _txt1 + " values " + _txt2 + " returning id"
    _sql = _sql % eval(_txt3)
    try:
        cr.execute(_sql)
        cr.connection.commit()
    except Exception as e:
        cr.connection.rollback()
        gravarLog('Erro insert: tabela ' + tabela + '  sql:' + _sql +'   Erro:' + str(e))
        return False
    return cr.fetchone()[0]

def deletarSQL(cr, tabela, where):
    _sql = 'delete from ' + tabela + ' where ' + where
    try:
        cr.execute(_sql)
        cr.connection.commit()
    except Exception as e:
        cr.connection.rollback()
        gravarLog('Erro delete: tabela ' + tabela + '  sql:' + _sql+ '   Erro:' + str(e))
        return False
    return True

def alterarSQL(cr, tabela, id, dados):
    dados['write_uid'] = uid
    dados['write_date'] = datas.hoje_I
    _qtdCampos = len(dados)
    _txt = ''
    for x in dados.keys():
        _txt += x + " = '" + str(dados[x]) + "',"
    if _txt[-1:] == ',':
        _txt = _txt[:-1]
    if isinstance(id, list):
        ids = id
        _sql = "update " + tabela + " set " + _txt + " where id in ("
        i = 0
        for id in ids:
            if i > 0:
                _sql += ', '
            _sql += str(id)
            i += 1
        _sql += ")"
    else:
        _sql = "update " + tabela + " set " + _txt + " where id = " + str(id)
    try:
        cr.execute(_sql)
        cr.connection.commit()
    except Exception as e:
        cr.connection.rollback()
        gravarLog('Erro update - sql:' + _sql + '   Erro:' + str(e))
        return False
    return True

def lerLegado(cr, empresa_legado, chave_legado, tabela):
    if empresa_legado == '000':
        _sql = "select chave_sigerp from legado_controle where chave_legado = '%s' and tabela_legado = '%s'" % (
            chave_legado, tabela)
    else:
        _sql = "select chave_sigerp from legado_controle where empresa = %s and chave_legado = '%s' and tabela_legado = '%s'" % (
            empresa_legado, chave_legado, tabela)
    cr.execute(_sql)
    try:
        _regLegado = cr.fetchall()
    except Exception as e:
        gravarLog('Erro lerLegado - sql:' + _sql+ '   Erro: ' + str(e))
        return []
    result = []
    if _regLegado:
        for x in _regLegado:
            result.append(x['chave_sigerp'])
    return result

def lerSQL(cr, tabela, where=[], campos=[], order=''):
    """
    parametros:
      cr -> cursor
      tabela -> nome da tabela
      where -> clausula where pronta exemplo: ["codigo = 'teste'","name = 'luiz'"]
      campos -> campos a serem lidos, exemplo: ['codigo, nome']
      order -> ordem para ler exemplo 'codigo desc,name'
    """
    _sql = "select "
    if campos:
        for a in campos:
            _sql += a + ','
        _sql = _sql[:-1] + ' '
    else:
        _sql += '* '
    _sql += 'from ' + tabela + ' '
    if where:
        _sql += 'where '
        for a in where:
            _sql += a + " and "
        if _sql[-5:] == ' and ':
            _sql = _sql[:-5]
    if order:
        _sql = _sql + ' order by ' + order
    cr.execute(_sql)
    try:
        _registros = cr.fetchall()
    except Exception as e:
        _registros = False
    return _registros

class contarRegistros(object):
    def __init__(self, registros):
        self.regLido = 0
        self.regTotal = len(registros)
        self.regPasso = int(self.regTotal / 100)
        if self.regPasso > 100:
            self.regPasso = 100
        if self.regPasso == 0:
            self.regPasso = 1
    def contar(self,operacao='x'):   
        self.regLido += 1
        _inteiro, _resto = divmod(self.regLido, self.regPasso)
        if _resto == 0:
            if operacao == 'x':
               print(str(self.regTotal) + '/' + str(self.regLido))
            return True
        return False

def retira_acentos( string ):
    if str( type( string ) ) == "<type 'str'>":
        nova_string = ''
        for x in string:
            if ord( x ) <= 127 and x != "'" and ord(x) != 92:
                nova_string = nova_string + x
        return nova_string
    return string

def gerarCtb01(empresa_legado, operacao, dados):
    try:
        listaDados = dados.replace('#',' ').split(',')
        _chave = listaDados[0]
        _contaReduzida = listaDados[1]
        _nomeConta = listaDados[2].replace("'", " ").strip()
        _nomeConta = retira_acentos(_nomeConta)
        _digito = listaDados[3]
        _saldo = listaDados[4][:13]+'.'+listaDados[4][13:]
        _apuracao = listaDados[5]
        _sintetAnalit = listaDados[6]
        if _chave[6:] != '00000':
           _sintetAnalit = 'A'
        else:
           _sintetAnalit = 'S'
        _classificaAnaliticas = listaDados[7]
        _naturezaConta = listaDados[8]
        _mes_encerrado = int(listaDados[9][:2])
        _ano_encerrado = int(listaDados[9][2:])
        _mes_saldo = _mes_encerrado +1
        _ano_saldo = _ano_encerrado
        if _mes_saldo > 12:
            _mes_saldo = 1
            _ano_saldo +=1
        _mes_saldo = formatastring.formataString(_mes_saldo, 2, '0', 'E')
        _ano_saldo = formatastring.formataString(_ano_saldo, 4, '0', 'E')
        _data_saldo = _ano_saldo + '/' + _mes_saldo +'/' + '01'

        company_id_conta = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'contabil.conta', company_id_c)
        _grau = 5
        if _chave[6:] == '00000':
           _chave = _chave[:6]
           _grau = 4
        if _chave[4:] == '00':
           _chave = _chave[:4]
           _grau = 3
        if _chave[2:] == '00':
           _chave = _chave[:2]
           _grau = 2
        if _chave[1:] == '0':
           _chave = _chave[:1]
           _grau = 1
        if _naturezaConta == '1':
           _naturezaConta = 'A'
        else:
           if _naturezaConta == '2':
              _naturezaConta = 'P'
           else:
              if _naturezaConta == '3':
                 _naturezaConta = 'L'
              else:
                 if _naturezaConta == '4':
                    _naturezaConta = 'R'
                 else:
                    if _naturezaConta == '5':
                       _naturezaConta = 'C'
                    else:
                       _naturezaConta = 'O'
        valsConta = {
                'company_id' : company_id_conta,
                'conta' : _chave,
                'digito_conta' : _digito,
                'conta_reduzida' : _contaReduzida,
                'digito_reduzida' : calcDigito.modulo10(_contaReduzida),
                'name' : _nomeConta,
                'grau' : _grau,
                'conta_tipo' : _sintetAnalit,
                'natureza' : _naturezaConta,
                'tipo_saldo' : 'M',
                'ocultar_analiticas' : False,
                    }
        _parent = ''
        if _grau  == 2:
            _parent = _chave[:1]
        if _grau == 3:
            _parent = _chave[:2]
        if _grau == 4:
            _parent = _chave[:4]
        if _grau == 5:
            _parent = _chave[:6]
        if _parent:
            _parent_id = lerSQL(cr, 'contabil_conta', ["conta = '%s'" % _parent, 'company_id = %s' % company_id_conta], ['id'])
            if _parent_id:
                valsConta['parent_id'] = _parent_id[0]['id']
        company_id_saldos = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'contabil.saldos', company_id_c)
        idConta = lerSQL(cr, 'contabil_conta', ['company_id = %s' % company_id_conta, "conta = '%s'" % _chave])
        if idConta:
            idConta = idConta[0]['id']
        if _sintetAnalit == 'A':
            idSaldo = lerSQL(cr, 'contabil_saldos', ['company_id = %s' % company_id_saldos, 'contabil_conta_id = %s' % idConta, "data_saldo = '%s'" % _data_saldo])
            if idSaldo:
                idSaldo = idSaldo[0]['id']
            valsSaldo = {
               'company_id': company_id_saldos,
               'contabil_conta_id': idConta,
               'data_saldo': _data_saldo,
               'ctbsal_saldo_inicial': _saldo,
               'ctbsal_saldo_final': _saldo
            }
        if operacao == 'w' or 'r': #Gravar e Regravar
            if idConta:
               alterarSQL(cr, 'contabil_conta', idConta, valsConta)
            else:
               idConta = inserirSQL(cr, 'contabil_conta', valsConta)
               valsSaldo['contabil_conta_id']  = idConta
            if _sintetAnalit == 'A':
                if idSaldo:
                   alterarSQL(cr, 'contabil_saldos', idSaldo, valsSaldo)
                else:
                   idSaldo = inserirSQL(cr, 'contabil_saldos', valsSaldo)
            return True
        if operacao == 'd': #Deletar
          if not idConta:
             gravarLog('Ctb01: Nao encontrei conta para excluir - conta:'+ _chave)
             return False
          try:
             result = deletarSQL(cr, 'contabil_conta', 'id = %s' % idConta)
          except Exception as e:
             gravarLog('Ctb01: Nao consegui excluir a conta:'+ _chave + '  Erro:' + str(e))
             return False
          return True
        return False
    except Exception as e:
         gravarLog('Ctb01:Qtd Elementos:'+str(len(listaDados))+ '  Lista:'+ str(listaDados)) 
         gravarLog('Erro: '+str(e))

def gerarCtb02(empresa_legado, operacao, dados):
    try:
        listaDados = dados.replace('#',' ').split(',')
        _origem = listaDados[0]
        _data = listaDados[1]
        _hora = listaDados[2]
        _seq_mov = listaDados[3]
        _data_lancamento = listaDados[4]
        _conta = listaDados[5]
        _documento = listaDados[6]
        _contra_partida = listaDados[7].strip()
        _valor = listaDados[8][:13]+'.'+listaDados[8][13:]
        _normal_encerramento = listaDados[9]
        _historico = listaDados[10].strip()
        _chave = _origem + _data +_hora + _seq_mov
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'contabil.conta', company_id_c)
        _conta_id = lerSQL(cr, 'contabil_conta', ['company_id = %s' % company_id, "conta = '%s'" % _conta])
        if _conta_id:
            _conta_id = _conta_id[0]['id']
        else:
            gravarLog('Ctb02: Conta nao cadastrada! Conta::'+ _conta)
            return False
        if _contra_partida:
            _contra_partida_id = lerSQL(cr, 'contabil_conta', ['company_id = %s' % company_id, "conta = '%s'" % _contra_partida])
            if _contra_partida_id:
                _contra_partida_id = _contra_partida_id[0]['id']

        if _valor[:1] == '-':
            _db = 'C'
        else:
            _db = 'D'
        _valor = _valor[1:]

        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'contabil.documentos', company_id_c)
        _data_movimento = str(datas.sigDatas(_data_lancamento).getDataNoFormato('I', 'S', '/'))
        if _data_movimento == '0000/00/00':
             gravarLog('Ctb02: Data invalida:'+ _data_lancamento)
             return False
        valsDocumento = {
            'company_id': company_id,
            'data_movimento': _data_movimento,
            'tipo_lancamento': _normal_encerramento,
            'documento': _documento,
        }
        _documento_id = lerSQL(cr, 'contabil_documentos',
                        ['company_id = %s' % company_id, "data_movimento ='%s'" % _data_movimento, 'documento = %s' % _documento])
        if _documento_id:
            _documento_id = _documento_id[0]['id']
            alterarSQL(cr, 'contabil_documentos', _documento_id, valsDocumento)
        else:
            _documento_id = inserirSQL(cr, 'contabil_documentos', valsDocumento)
        vals = {
                'contabil_conta_id' : _conta_id,
                'historico' : _historico,
                'valor_lancamento' : _valor,
                'debito_credito': _db,
                'documento_id': _documento_id,
                    }
        if _contra_partida_id:
            vals['contra_partida_id'] = _contra_partida_id
        legado_id = lerLegado(cr, empresa_legado, _chave, 'ctb02')
        if legado_id:
            legado_id = legado_id[0]
            if operacao == 'w':
                operacao = 'r'
        if operacao == 'w': #Gravar
            idLancamento = inserirSQL(cr, 'contabil_lancamentos', vals)
            return True
        if operacao == 'r': #Regravar
          if legado_id:
              try:
                 alterarSQL(cr, 'contabil_lancamentos', legado_id, vals)
              except Exception as e:
                 gravarLog('Ctb02: Nao consegui alterar o lanccamento:'+ _chave + '  Erro:' + str(e))
                 return False
              return True
          else:
              idConta = inserirSQL(cr, 'contabil_lancamentos', vals)
              return True
        if operacao == 'd': #Deletar
          if not legado_id:
             gravarLog('Ctb02: Nao encontrei legado controle para excluir '+ _chave)
             return False
          try:
             result = deletarSQL(cr, 'contabil_lancamentos', 'id = %s' % legado_id)
          except Exception as e:
             gravarLog('Ctb02: Nao consegui excluir o lancamento:'+ _chave + '  Erro:' + str(e))
             return False
          return True
    except Exception as e:
         gravarLog('Ctb02:Qtd Elementos:'+str(len(listaDados))+ '  Lista:'+ str(listaDados))
         gravarLog('Erro: '+str(e))

arquivo = ''
try:
    arquivo = sys.argv[1]
except:
    gravarLog('Arquivo a integrar nao informado!')
    exit()
if arquivo == 'todos':
    novaLista = []
    try:
        lista = os.listdir(diretorio + 'int')
        for linha in lista:
            if linha[-1:] == '\n':
                linha = linha[:-1]
            if linha[:3] != 'est':
                continue
            novaLista.append(linha[6:] + linha[:6])
        novaLista.sort()
        lista = []
        for linha in novaLista:
            lista.append(linha[-6:] + linha[:-6])
    except Exception as e:
        gravarLog('Diretorio inexistente!')
        exit()
else:
    try:
        lista = os.listdir(diretorio + 'int')
        lista.sort()
    except Exception as e:
        gravarLog('Diretorio inexistente!')
        exit()
try:
    for arq in lista:
        if arquivo != 'todos':
            if arq[:5] != arquivo:
                continue
        empresa = arq[24:27]
        _operacao = arq[28:].lower()
        try:
            args = [('empresa_legado', '=', empresa), ('tipo', '=', 'S')]
            company_id_s = sock.execute(db, uid, pwd, 'legado.empresa', 'ler', args)[0]['company_id'][0]
            args = [('empresa_legado', '=', empresa), ('tipo', '=', 'C')]
            company_id_c = sock.execute(db, uid, pwd, 'legado.empresa', 'ler', args)[0]['company_id'][0]
        except:
            gravarLog('Empresa nao cadastrada!' + str(empresa) + '-' + str(args))
            continue
        args = [('company_id', '=', company_id_c)]
        try:
            file = open(diretorio + 'int/' + arq, 'r')
            _arquivoLido = arq[:5]
            registros = file.readlines()
        except:
            continue
        _horaArquivo = int(arq[15:23])
        contador = contarRegistros(registros)
        if _operacao == 'x': # Opderacao = 'x' eh qdo eh gerado o arquivo inteiro
            operacao = 'w'
        else:
            operacao = _operacao
        if _operacao == 'x': # Remover arquivo porque já foi lido e contem varios registros
            os.system('rm -rf ' + diretorio + 'int/' + arq)
        for registro in registros:
            registro = unicode(registro, 'utf-8', errors='ignore')
            res = False
            try:
                if _arquivoLido == 'ctb01':   # Plano de contas
                    res = gerarCtb01(empresa, operacao, registro)
                if _arquivoLido == 'ctb02':   # Movimento
                    res = gerarCtb02(empresa, operacao, registro)
            except Exception as e:
                gravarLog('Erro Tentando Atualizar.   Erro:' +str(e))
                res = False
            if res and _operacao != 'x': # Registro importado de arquivo com um registro, remover arquivo
                os.system('rm -rf ' + diretorio + 'int/' + arq)
                cr_log.connection.commit()
            if not res and _operacao == 'x': # Erro na importacao de registro de arquivo com varios registros, gerar registro individual para importacao futura
                _horaArquivo += 1
                arqNovo = diretorio + 'int/' + arq[:15] + numero.getNumToStr(_horaArquivo, 8, 0, 'N') + arq[23:28] + 'W'
                fileNovo = open(arqNovo, 'w')
                fileNovo.write(registro)
                fileNovo.close()
            if not res:
                cr.close()
                cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
except Exception as e:
    gravarLog('Carregando arquivos.   Erro:' + str(e))


