#!/usr/bin/python
# -*- coding: utf-8 -*-

idPrograma = 'est2ope.py'
idVersao = 'Versao 1.01 de 20/07/2011'
idObs = 'Copyrigth by Sig Informatica Ltda'
"""
Programa para exportacao de dados do Sig Cobol(estoque) para o SigERP
Este programa deve estar na pasta objetos, juntamente com o arquivo de configuracao sigerp.cfg
Este programa e chamado direto do programa cobol

Estrutura do sigerp.cfg
hostname,username,password,database,dbhostname,dbuser,dbpasswd
localhost,admin,admin,teste,localhost,luiz,admin
"""
geral = {}
import sys
import os
import xmlrpclib, socket
import csv
from SigUtils import datas, geralogs, numero, formatastring
import psycopg2
import psycopg2.extras
import psutil
import re
import time

diretorio = './'
lista = []
encerrar = 'N'
try:
    for proc in psutil.process_iter():
        _achei = False
        for x in proc.cmdline:
            if 'est2ope.py' in x:
                _achei = True
                continue
            if _achei:
                _achei = False
                if x in lista:
                    encerrar = 'S'
                    break
                lista.append(x)
except:
    pass
if encerrar == 'S':
    exit()

def retira_acentos( string ):
    if str(type(string)) == "<type 'str'>":
        nova_string = ''
        for _x in string:
            if ord(_x) <= 127 and ord(_x) != 92:
                nova_string = nova_string + _x
        return nova_string
    return string


def gravarLog(texto, linha=''):
    _arq = _dados = ''
    try:
        _arq = arq
    except:
        pass
    try:
        _dados = registro
    except:
        pass
    if not linha:
        linha = _dados
    try:
        _sql = ("select * from legado_logs where lelg_arquivo = '%s' and lelg_data = '%s' and lelg_hora = '%s'" %
                (str(_arq), str(datas.getDataDeHoje('I','-')), str(datas.getDataDeHoje('H')[:5])))
        cr_log.execute(_sql)
        _registros = cr_log.fetchall()
        if _registros:
            _log_id = _registros[0]['id']
            _sql = "update legado_logs set  lelg_empresa_legado = '%s', lelg_arquivo = '%s', lelg_erro = '%s', lelg_conteudo = '%s', lelg_data = '%s', "
            _sql += "lelg_hora = '%s', lelg_arquivo_legado = '%s',active = %s"
            _sql = _sql % (str(_arq[-5:-2]), str(_arq),str(texto).replace("'",""), str(linha).replace("'",""), str(datas.getDataDeHoje('I','-')), str(datas.getDataDeHoje('H')[:5]), str(_arq[:5]), True)
            _sql += ' where id = ' + str(_log_id)
            cr_log.execute(_sql)
        else:
            _sql = 'insert into legado_logs (lelg_empresa_legado, lelg_arquivo, lelg_erro, lelg_conteudo, lelg_data, lelg_hora, lelg_arquivo_legado, active)'
            _sql += " values ('%s','%s','%s','%s','%s','%s','%s','%s') "
            _sql = _sql % (str(_arq[-5:-2]), str(_arq),str(texto).replace("'", ""), str(linha).replace("'",""), str(datas.getDataDeHoje('I','-')), str(datas.getDataDeHoje('H')[:5]), str(_arq[:5]), True)
            cr_log.execute(_sql)
        cr_log.connection.commit()
    except Exception as e:
        cr_log.connection.rollback()
        geralogs.geraLogs('est2ope.log', 'Nao consegui gerar o legado_log.   sql:' + str(_sql) +'   Erro:' + str(e), 'S', '../arquivos/logs/')
        if _arq:
            geralogs.geraLogs('est2ope.log', _arq +  texto, 'S', '../arquivos/logs/')
        else:
            geralogs.geraLogs('est2ope.log',  texto, 'S', '../arquivos/logs/')

try:
    arq_configuracao = diretorio + '../objetos/sigerp.cfg'
    arquivo = csv.DictReader(open(arq_configuracao))
    for a in arquivo:
        hostname = a['hostname']
        username = a['username']
        pwd = a['password']
        porta = a['porta']
        db = a['database']
        dbhostname = a['dbhostname']
        dbuser = a['dbuser']
        dbpasswd = a['dbpasswd']
except:
    gravarLog('Erro identificando parametros - sigerp.cfg')

sock_common = xmlrpclib.ServerProxy('http://' + hostname + ':' + str(porta) + '/xmlrpc/common')
socket.setdefaulttimeout(3)
uid = sock_common.login(db, username, pwd)
sock = xmlrpclib.ServerProxy('http://' + hostname + ':' + str(porta) + '/xmlrpc/object')

_stringConeccao = ("dbname='" + db
                   + "' user='" + dbuser
                   + "' host='" + dbhostname
                   + "' password='" + dbpasswd
                   + "' connect_timeout='%d" % 3 + "'")
conn = psycopg2.connect(_stringConeccao)
cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
cr_log=conn.cursor(cursor_factory=psycopg2.extras.DictCursor)

def inserirSQL(cr, tabela, dados):
    dados['create_uid'] = uid
    dados['create_date'] = datas.hoje_I
    _qtdCampos = len(dados)
    _txt1 = '('
    _txt3 = "("
    for x in dados.keys():
        _txt1 += x + ', '
        _txt3 += "'" + str(dados[x]) + "', "
    _txt1 = _txt1[:-2] + ')'
    _txt3 = _txt3[:-2] + ")"
    _txt2 = "'%s'," * _qtdCampos
    _txt2 = "(" + _txt2[:-1] + ")"
    _sql = "insert into " + tabela + " " + _txt1 + " values " + _txt2 + " returning id"
    _sql = _sql % eval(_txt3)
    try:
        cr.execute(_sql)
        cr.connection.commit()
    except Exception as e:
        cr.connection.rollback()
        gravarLog('Erro insert: tabela ' + tabela + '  sql:' + _sql +'   Erro:' + str(e))
        return False
    return cr.fetchone()[0]


def deletarSQL(cr, tabela, where):
    _sql = 'delete from ' + tabela + ' where ' + where
    try:
        cr.execute(_sql)
        cr.connection.commit()
    except Exception as e:
        cr.connection.rollback()
        gravarLog('Erro delete: tabela ' + tabela + '  sql:' + _sql+ '   Erro:' + str(e))
        return False
    return True


def alterarSQL(cr, tabela, id, dados):
    dados['write_uid'] = uid
    dados['write_date'] = datas.hoje_I
    _qtdCampos = len(dados)
    _txt = ''
    for x in dados.keys():
        _txt += x + " = '" + str(dados[x]) + "',"
    if _txt[-1:] == ',':
        _txt = _txt[:-1]
    if isinstance(id, list):
        ids = id
        _sql = "update " + tabela + " set " + _txt + " where id in ("
        i = 0
        for id in ids:
            if i > 0:
                _sql += ', '
            _sql += str(id)
            i += 1
        _sql += ")"
    else:
        _sql = "update " + tabela + " set " + _txt + " where id = " + str(id)
    try:
        cr.execute(_sql)
        cr.connection.commit()
    except Exception as e:
        cr.connection.rollback()
        gravarLog('Erro update - sql:' + _sql + '   Erro:' + str(e))
        return False
    return True


def lerLegado(cr, empresa_legado, chave_legado, tabela):
    if empresa_legado == '000':
        _sql = "select chave_sigerp from legado_controle where chave_legado = '%s' and tabela_legado = '%s'" % (
            chave_legado, tabela)
    else:
        _sql = "select chave_sigerp from legado_controle where empresa = %s and chave_legado = '%s' and tabela_legado = '%s'" % (
            empresa_legado, chave_legado, tabela)
    cr.execute(_sql)
    try:
        _regLegado = cr.fetchall()
    except Exception as e:
        gravarLog('Erro lerLegado - sql:' + _sql+ '   Erro: ' + str(e))
        return []
    result = []
    if _regLegado:
        for x in _regLegado:
            result.append(x['chave_sigerp'])
    return result


def lerSQL(cr, tabela, where=[], campos=[], order=''):
    """
    parametros:
      cr -> cursor
      tabela -> nome da tabela
      where -> clausula where pronta exemplo: ["codigo = 'teste'","name = 'luiz'"]
      campos -> campos a serem lidos, exemplo: ['codigo, nome']
      order -> ordem para ler exemplo 'codigo desc,name'
    """
    _sql = "select "
    if campos:
        for a in campos:
            _sql += a + ','
        _sql = _sql[:-1] + ' '
    else:
        _sql += '* '
    _sql += 'from ' + tabela + ' '
    if where:
        _sql += 'where '
        for a in where:
            _sql += a + " and "
        if _sql[-5:] == ' and ':
            _sql = _sql[:-5]
    if order:
        _sql = _sql + ' order by ' + order
    cr.execute(_sql)
    try:
        _registros = cr.fetchall()
    except Exception as e:
        _registros = False
    return _registros


class contarRegistros(object):
    def __init__(self, registros):
        self.regLido = 0
        self.regTotal = len(registros)
        self.regPasso = int(self.regTotal / 100)
        if self.regPasso > 100:
            self.regPasso = 100
        if self.regPasso == 0:
            self.regPasso = 1

    def contar(self, operacao='x'):
        self.regLido += 1
        _inteiro, _resto = divmod(self.regLido, self.regPasso)
        if _resto == 0:
            if operacao == 'x':
                print(str(self.regTotal) + '/' + str(self.regLido) + '\r')
            return True
        return False


def gerarEst01(empresa_legado, operacao, dados, _codNumerico):#Cadastro
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        if _codNumerico:
            _chave = formatastring.formataString(listaDados[0].lstrip('0').rstrip(), 6, '0', 'E')
        else:
            _chave = listaDados[0].strip()
        _digito = listaDados[1]
        _unidade = listaDados[2].strip()
        _chaveGrupos = listaDados[3]
        _margemIdeal = listaDados[4]
        _margemMin = listaDados[5]
        _margemBruta = listaDados[6]
        _mva = listaDados[7][:3] + '.' + listaDados[7][3:]
        _cstNoEstado = listaDados[8].replace(' ', '0')
        _cstForaEstado = listaDados[9].replace(' ', '0')
        _cstProdutorRural = listaDados[10].replace(' ', '0')
        _cstUltimaEntrada = listaDados[11].replace(' ', '0')
        _codTributConsFinal = listaDados[12]
        _codTributContribuinte = listaDados[13]
        _codTributProdutor = listaDados[14]
        _codTributEntrada = listaDados[15]
        _codTributSubst = listaDados[16]
        _codTributEntradaSub = listaDados[17]
        _aliqIpi = listaDados[18][:3] + '.' + listaDados[18][3:]
        _classifFiscal = listaDados[19].strip()
        _classifNcm = re.sub('[^0-9]', '', listaDados[20].strip())
        if len(_classifNcm) > 8:
            _classifNcm = _classifNcm[:8]
        _ncm_id = lerSQL(cr, 'fiscal_ncm', ["codigo = '%s'" % _classifNcm])
        if not _ncm_id:
            _ncm_id = inserirSQL(cr, 'fiscal_ncm', {'codigo': _classifNcm, 'descricao': _classifNcm})
        else:
            _ncm_id = _ncm_id[0]['id']
        _pis = listaDados[21]
        if _pis == 'Y':
            _pis = True
        else:
            _pis = False
        _pisCstEntrada = listaDados[22]
        _pisCstSaida = listaDados[23]
        _pisNatRec = listaDados[24]
        _cofins = listaDados[25]
        if _cofins == 'Y':
            _cofins = True
        else:
            _cofins = False
        _cofinsCstEntrada = listaDados[26]
        _cofinsCstSaida = listaDados[27]
        _cofinsNatRec = listaDados[28]
        _fornecedorPrincipal = listaDados[29]
        _representante = listaDados[30]
        _tempoReposicao = listaDados[31]
        _temGrade = listaDados[32]
        if _temGrade == 'S':
            _temGrade = True
        else:
            _temGrade = False
        _comprador = listaDados[33]
        _temSerie = listaDados[34]
        _politicaPreco = listaDados[35]
        _contaCustos = listaDados[36]
        _servicoAgregado = listaDados[37]
        _kitMercadorias = listaDados[38]
        if _kitMercadorias == 'Y':
            _kitMercadorias = True
        else:
            _kitMercadorias = False
        _kitTipoPreco = listaDados[39]
        if _kitTipoPreco == 'K':
            _kitTipoPreco = 'K'
        else:
            _kitTipoPreco = 'S'
        _kitMontagem = listaDados[40]
        if _kitMontagem == 'Y':
            _kitMontagem = True
        else:
            _kitMontagem = False
        _codigoExIpi = listaDados[41].strip()
        _codigoEnqIpi = listaDados[42].strip()
        _codGenero = listaDados[43]
        _codTabServicos = listaDados[44]
        if _codTabServicos == '0000':
            _codTabServicos = ''
        _codTabServicos_id = lerSQL(cr, 'fiscal_tabela_servico', ["codigo = '%s'" % _codTabServicos])
        _ultimaPauta = listaDados[45]
        _producao = listaDados[46]
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.produto', company_id_c)
        # achar tributacao/Encargo
        idsTributacaoConsFinal = lerLegado(cr, '000', _codTributConsFinal, 'est14')
        if not idsTributacaoConsFinal:
            gravarLog('est01-Tributacao nao cadastrada!(legado) ->' + _codTributConsFinal)
            return False
        _regTributacao = lerSQL(cr, 'fiscal_tributacao', ["id = '%s'" % idsTributacaoConsFinal[0]])
        if not _regTributacao:
            gravarLog('est01-Tributacao nao cadastrada! ->' + _codTributConsFinal)
            return False
        _regEncargo = lerSQL(cr, 'fiscal_encargo', ["id = '%s'" % _regTributacao[0]['encargo_id']])
        if not _regEncargo:
            gravarLog('est01-Encargo nao cadastrado! ->' + _regTributacao[0]['name'])
            return False
        if _codTributProdutor != '000':
            idsTributacaoProdutor = lerLegado(cr, '000', _codTributProdutor, 'est14')
            if not idsTributacaoProdutor:
                gravarLog('est01-Tributacao nao cadastrada!(legado) ->' + _codTributProdutor)
                return False
            _regTributacao = lerSQL(cr, 'fiscal_tributacao', ["id = '%s'" % idsTributacaoProdutor[0]])
            if not _regTributacao:
                gravarLog('est01-Tributacao nao cadastrada! ->' + _codTributProdutor)
                return False
            _regEncargo = lerSQL(cr, 'fiscal_encargo', ["id = '%s'" % _regTributacao[0]['encargo_id']])
            if not _regEncargo:
                gravarLog('est01-Encargo nao cadastrado! ->' + _regTributacao[0]['name'])
                return False
        if _codTributContribuinte != '000':
            idsTributacaoContribuinte = lerLegado(cr, '000', _codTributContribuinte, 'est14')
            if not idsTributacaoContribuinte:
                gravarLog('est01-Tributacao nao cadastrada!(legado) ->' + _codTributContribuinte)
                return False
            _regTributacao = lerSQL(cr, 'fiscal_tributacao', ["id = '%s'" % idsTributacaoContribuinte[0]])
            if not _regTributacao:
                gravarLog('est01-Tributacao nao cadastrada! ->' + _codTributContribuinte)
                return False
            _regEncargo = lerSQL(cr, 'fiscal_encargo', ["id = '%s'" % _regTributacao[0]['encargo_id']])
            if not _regEncargo:
                gravarLog('est01-Encargo nao cadastrado! ->' + _regTributacao[0]['name'])
                return False
        if _codTributEntrada != '000':
            idsTributacaoEntrada = lerLegado(cr, '000', _codTributEntrada, 'est14')
            if not idsTributacaoEntrada:
                gravarLog('est01-Tributacao nao cadastrada!(legado) ->' + _codTributEntrada)
                return False
            _regTributacao = lerSQL(cr, 'fiscal_tributacao', ["id = '%s'" % idsTributacaoEntrada[0]])
            if not _regTributacao:
                gravarLog('est01-Tributacao nao cadastrada! ->' + _codTributEntrada)
                return False
            _regEncargo = lerSQL(cr, 'fiscal_encargo', ["id = '%s'" % _regTributacao[0]['encargo_id']])
            if not _regEncargo:
                gravarLog('est01-Encargo nao cadastrado! ->' + _regTributacao[0]['name'])
                return False

        # achar categoria
        idsCategoria = lerLegado(cr, '000', _chaveGrupos, 'est04')
        if not idsCategoria:
            gravarLog('est01-Categoria nao cadastrada! ->' + _chaveGrupos + ' Item:' + str(_chave))
            return False
        if _regEncargo[0]['sigla'] == 'ICMS':
            _produtoServico = 'P'
        else:
            _produtoServico = 'S'
            #achar fabricante
        fabricante_ids = lerLegado(cr, 1, _fornecedorPrincipal, 'cpg01')
        if fabricante_ids:
            _fabricante_id = fabricante_ids[0]
        else:
            _fabricante_id = False
            #achar comprador
        comprador_ids = lerLegado(cr, empresa_legado, _comprador, 'est16')
        if comprador_ids:
            _comprador_id = comprador_ids[0]
        else:
            _comprador_id = False
        valsProduto = {
            'tipo': _produtoServico,
            'name': 'Item ' + str(_chave),
            'company_id': company_id,
            'margem_ideal': _margemIdeal[:2] + '.' + _margemIdeal[2:],
            'margem_minima': _margemMin[:2] + '.' + _margemMin[2:],
            'margem_bruta': _margemBruta[:4] + '.' + _margemBruta[4:],
            'tempo_reposicao': _tempoReposicao,
            'codigo': _chave,
            'active': True,
            'grade_usar': _temGrade,
            'digito': _digito,
            'kit_de_produtos': _kitMercadorias,
            'codigo_ex_ncm': _codigoExIpi,
            'codigo_enq_ipi': _codigoEnqIpi,
            'codigo_genero': _codGenero,
            'tipo_item': '00',
            'origem_mercadoria': '0',
            'estpro_pis_nat_rec' : _pisNatRec,
            'estpro_cofins_nat_rec' : _cofinsNatRec
        }
        if _ncm_id:
            valsProduto['ncm_id'] = _ncm_id
        if _codTabServicos_id:
            valsProduto['codigo_tab_servicos_id'] = _codTabServicos
        if _comprador_id:
            valsProduto['comprador_id'] = _comprador_id
        if _fabricante_id:
            valsProduto['fabricante_id'] = _fabricante_id
        if idsCategoria:
            valsProduto['categoria_id'] = idsCategoria[0]
        if _kitMercadorias == 'Y':
            valsProduto['preco_kit'] = _kitTipoPreco
            valsProduto['tipo_kit'] = 'I'
        _regProduto = lerSQL(cr, 'estoque_produto', ['company_id = %s' % company_id, "codigo = '%s'" % _chave])
        if operacao == 'w': #Gravar
            if _regProduto:
                idProduto = _regProduto[0]['id']
                if idProduto:
                    return True
            try:
                idProduto = inserirSQL(cr, 'estoque_produto', valsProduto)
            except  Exception as e:
                gravarLog('Erro: ' + str(e))
                return False
            if _codNumerico:
                try:
                    _numero = int(_chave)
                    __code = 'estoque.produto'
                    __name = 'Codigo de Produto/Servico'
                    id = lerSQL(cr, 'ir_sequence', ["code = '%s' and name = '%s'" % (__code, __name)])
                    if not id:
                        inserirSQL(cr, 'ir_sequence', {'code': __code, 'name': __name})
                    _dados_sequence = lerSQL(cr, 'ir_sequence',
                        ["code = '%s' and name = '%s'" % (__code, __name)],['number_next', 'id'])
                    if not id:
                        inserirSQL(cr, 'ir_sequence',
                            {'code': __code, 'name': __name, 'number_next': 1, 'implementation': 'no_gap',
                             'company_id': empresa_legado, 'padding': 6, 'active': True, 'number_increment': 1})
                        _dados_sequence = lerSQL(cr, 'ir_sequence', ["code = '%s' and name = '%s'" % (__code, __name)],
                            ['number_next', 'id'])
                    _ultimo = _dados_sequence[0]['number_next']
                    _id = _dados_sequence[0]['id']
                    if _numero > _ultimo:
                        alterarSQL(cr, 'ir_sequence', _id, {'number_next': _numero + 1})
                except  Exception as e:
                    gravarLog('Erro na gravacao do sequence:' + str(e))

            if not _temGrade:
                vals = {
                    'produto_id': idProduto,
                    'grade': 'UN',
                    'descricao': 'UNICA',
                    'active': True,
                }
                inserirSQL(cr, 'estoque_produto_grade', vals)
            _pessoa_id = lerSQL(cr, 'res_company', ["id = '%s'" % company_id], ['rescon_pessoa_id'])
            if _pessoa_id:
                _pessoa_id = _pessoa_id[0]['rescon_pessoa_id']
            _regPessoa = lerSQL(cr, 'adm_pessoa', ["id = '%s'" % _pessoa_id],
                ['admpes_jur_tipo_atividade', 'admpes_jur_regime_tributario'])
            _tipoAtividade = _regPessoa[0]['admpes_jur_tipo_atividade']
            if _produtoServico == 'P':
                encargosLista = ['ICMS', 'PIS', 'COFINS']
            else:
                encargosLista = ['ICMS', 'ISS', 'PIS', 'COFINS']
            if _tipoAtividade == 'I':
                encargosLista.append('IPI')
            for _encargo in encargosLista:
                res = lerSQL(cr, 'fiscal_encargo', ["sigla = '%s'" % _encargo], ['id'])
                if res:
                    idFiscalEncargo = res[0]['id']
                else:
                    vals = {'name': _encargo, 'sigla': _encargo}
                    if _encargo in ['COFINS', 'PIS', 'IPI']:
                        vals['tipo_encargo'] = 'F'
                    if _encargo == 'ICMS':
                        vals['tipo_encargo'] = 'E'
                    if _encargo == 'ISS':
                        vals['tipo_encargo'] = 'M'
                    idFiscalEncargo = inserirSQL(cr, 'fiscal_encargo', vals)
                if _encargo == 'ICMS':
                    _cst = _cstNoEstado[1:]
                    _tipo = 'T'
                if _encargo == 'PIS':
                    _cst = _pisCstSaida
                    _tipo = 'T'
                if _encargo == 'COFINS':
                    _cst = _cofinsCstSaida
                    _tipo = 'T'
                if _encargo == 'ISS':
                    _cst = '00'
                    _tipo = 'T'
                if _encargo == 'IPI':
                    if float(_aliqIpi) == 0:
                        _cst = '53'
                        _tipo = 'O'
                    else:
                        _cst = '50'
                        _tipo = 'T'
                res = lerSQL(cr, 'fiscal_cst', ["codigo = '%s'" % _cst, "encargo_id = '%s'" % idFiscalEncargo])
                if res:
                    idCST = res[0]['id']
                else:
                    vals = {'codigo': _cst, 'name': _cst, 'tipo': _tipo, 'encargo_id': idFiscalEncargo}
                    idCST = inserirSQL(cr, 'fiscal_cst', vals)
                _idTributacao = False
                if _encargo == 'ICMS' or _encargo == 'ISS':
                    args = [('id', 'in', idsTributacaoConsFinal)]
                    if len(idsTributacaoConsFinal) > 1:
                        regTributacao = lerSQL(cr, 'fiscal_tributacao',
                            ["id in %s" % str(tuple(idsTributacaoConsFinal))])
                    else:
                        regTributacao = lerSQL(cr, 'fiscal_tributacao', ["id = '%s'" % idsTributacaoConsFinal[0]])
                if _encargo == 'PIS' or _encargo == 'COFINS':
                    regTributacao = lerSQL(cr, 'fiscal_tributacao', ["encargo_id = '%s' and cst_id = %s" % (idFiscalEncargo, idCST)])
                    if not regTributacao:
                        vals = {
                            'active' : True,
                            'aliquota' :0,
                            'base' : 100,
                            'cst_id' : idCST,
                            'encargo_id' : idFiscalEncargo,
                            'name' : 'Tributacao CST ' + str(_cst),
                        }
                        _idTributacao = inserirSQL(cr, 'fiscal_tributacao', vals)
                if _encargo == 'IPI':
                    regTributacao = lerSQL(cr, 'fiscal_tributacao',
                        ["encargo_id = '%s'" % idFiscalEncargo, "cst_id = '%s'" % idCST])
                for a in regTributacao:
                    if a['encargo_id'] == idFiscalEncargo and a['cst_id'] == idCST:
                        _idTributacao = a['id']
                if _idTributacao:
                    vals = {
                        'produto_id': idProduto,
                        'encargo_id': idFiscalEncargo,
                        'cst_id': idCST,
                        'tributacao_id': _idTributacao,
                        'tipo_tributacao': 'T',
                    }
                    if _encargo == 'ICMS':
                        vals['mva'] = _mva
                        if float(_mva) != 0 and _tipo == 'T':
                            vals['modbcst'] = '4'
                    else:
                        vals['mva'] = 0
                    id = inserirSQL(cr, 'fiscal_tributacao_encargos', vals)
                if _encargo == 'PIS' and _pisCstEntrada != _pisCstSaida:
                    _cst = _pisCstEntrada
                    res = lerSQL(cr, 'fiscal_cst', ["codigo = '%s'" % _cst, "encargo_id = '%s'" % idFiscalEncargo])
                    if res:
                        idCST = res[0]['id']
                    else:
                        vals = {'codigo': _cst, 'name': _cst, 'tipo': _tipo, 'encargo_id': idFiscalEncargo}
                        idCST = inserirSQL(cr, 'fiscal_cst', vals)
                    regTributacao = lerSQL(cr, 'fiscal_tributacao', ["encargo_id = '%s' and cst_id = %s" % (idFiscalEncargo, idCST)])
                    if not regTributacao:
                        vals = {
                            'active' : True,
                            'aliquota' :0,
                            'base' : 100,
                            'cst_id' : idCST,
                            'encargo_id' : idFiscalEncargo,
                            'name' : 'Tributacao CST ' + str(_cst),
                            }
                        _idTributacao = inserirSQL(cr, 'fiscal_tributacao', vals)
                    else:
                        for a in regTributacao:
                            _idTributacao = a['id']
                    vals = {
                        'produto_id': idProduto,
                        'encargo_id': idFiscalEncargo,
                        'cst_id': idCST,
                        'tributacao_id': _idTributacao,
                        'tipo_tributacao': 'E',
                        }
                    id = inserirSQL(cr, 'fiscal_tributacao_encargos', vals)
                if _encargo == 'COFINS' and _cofinsCstEntrada != _cofinsCstSaida:
                    _cst = _cofinsCstEntrada
                    res = lerSQL(cr, 'fiscal_cst', ["codigo = '%s'" % _cst, "encargo_id = '%s'" % idFiscalEncargo])
                    if res:
                        idCST = res[0]['id']
                    else:
                        vals = {'codigo': _cst, 'name': _cst, 'tipo': _tipo, 'encargo_id': idFiscalEncargo}
                        idCST = inserirSQL(cr, 'fiscal_cst', vals)
                    regTributacao = lerSQL(cr, 'fiscal_tributacao', ["encargo_id = '%s' and cst_id = %s" % (idFiscalEncargo, idCST)])
                    if not regTributacao:
                        vals = {
                            'active' : True,
                            'aliquota' :0,
                            'base' : 100,
                            'cst_id' : idCST,
                            'encargo_id' : idFiscalEncargo,
                            'name' : 'Tributacao CST ' + str(_cst),
                            }
                        _idTributacao = inserirSQL(cr, 'fiscal_tributacao', vals)
                    else:
                        for a in regTributacao:
                            _idTributacao = a['id']
                    vals = {
                        'produto_id': idProduto,
                        'encargo_id': idFiscalEncargo,
                        'cst_id': idCST,
                        'tributacao_id': _idTributacao,
                        'tipo_tributacao': 'E',
                        }
                    id = inserirSQL(cr, 'fiscal_tributacao_encargos', vals)
                if _codTributContribuinte != '000' and _encargo == 'ICMS' and _codTributContribuinte != _codTributConsFinal:
                    args = [('id', 'in', idsTributacaoContribuinte)]
                    if len(idsTributacaoContribuinte) > 1:
                        regTributacao = lerSQL(cr, 'fiscal_tributacao',
                            ["id in %s" % str(tuple(idsTributacaoContribuinte))])
                    else:
                        regTributacao = lerSQL(cr, 'fiscal_tributacao', ["id = '%s'" % idsTributacaoContribuinte[0]])
                    for a in regTributacao:
                        if a['encargo_id'] == idFiscalEncargo and a['cst_id'] == idCST:
                            _idTributacao = a['id']
                    if _idTributacao:
                        vals = {
                            'produto_id': idProduto,
                            'encargo_id': idFiscalEncargo,
                            'cst_id': idCST,
                            'tributacao_id': _idTributacao,
                            'tipo_tributacao': 'C',
                        }
                        if _encargo == 'ICMS':
                            vals['mva'] = _mva
                            if float(_mva) != 0 and _tipo == 'T':
                                vals['modbcst'] = '4'
                        else:
                            vals['mva'] = 0
                        id = inserirSQL(cr, 'fiscal_tributacao_encargos', vals)
                if _codTributProdutor != '000' and _encargo == 'ICMS' and _codTributProdutor != _codTributConsFinal:
                    args = [('id', 'in', idsTributacaoProdutor)]
                    if len(idsTributacaoProdutor) > 1:
                        regTributacao = lerSQL(cr, 'fiscal_tributacao',
                            ["id in %s" % str(tuple(idsTributacaoProdutor))])
                    else:
                        regTributacao = lerSQL(cr, 'fiscal_tributacao', ["id = '%s'" % idsTributacaoProdutor[0]])
                    for a in regTributacao:
                        if a['encargo_id'] == idFiscalEncargo and a['cst_id'] == idCST:
                            _idTributacao = a['id']
                    if _idTributacao:
                        vals = {
                            'produto_id': idProduto,
                            'encargo_id': idFiscalEncargo,
                            'cst_id': idCST,
                            'tributacao_id': _idTributacao,
                            'tipo_tributacao': 'P',
                        }
                        if _encargo == 'ICMS':
                            vals['mva'] = _mva
                            if float(_mva) != 0 and _tipo == 'T':
                                vals['modbcst'] = '4'
                        else:
                            vals['mva'] = 0
                        id = inserirSQL(cr, 'fiscal_tributacao_encargos', vals)
                if _codTributEntrada != '000' and  _encargo == 'ICMS' and _codTributEntrada != _codTributConsFinal:
                    args = [('id', 'in', idsTributacaoEntrada)]
                    if len(idsTributacaoEntrada) > 1:
                        regTributacao = lerSQL(cr, 'fiscal_tributacao', ["id in %s" % str(tuple(idsTributacaoEntrada))])
                    else:
                        regTributacao = lerSQL(cr, 'fiscal_tributacao', ["id = '%s'" % idsTributacaoEntrada[0]])
                    res = lerSQL(cr, 'fiscal_cst',
                        ["codigo = '%s'" % _cstUltimaEntrada[1:], "encargo_id = '%s'" % idFiscalEncargo])
                    if res:
                        idCST = res[0]['id']
                    else:
                        vals = {'codigo': _cstUltimaEntrada[1:], 'name': _cstUltimaEntrada[1:], 'tipo': _tipo,
                                'encargo_id': idFiscalEncargo}
                        idCST = inserirSQL(cr, 'fiscal_cst', vals)
                    for a in regTributacao:
                        if a['encargo_id'] == idFiscalEncargo and a['cst_id'] == idCST:
                            _idTributacao = a['id']
                    if _idTributacao:
                        vals = {
                            'produto_id': idProduto,
                            'encargo_id': idFiscalEncargo,
                            'cst_id': idCST,
                            'tributacao_id': _idTributacao,
                            'tipo_tributacao': 'E',
                        }
                        if _encargo == 'ICMS':
                            vals['mva'] = _mva
                            if float(_mva) != 0 and _tipo == 'T':
                                vals['modbcst'] = '4'
                        else:
                            vals['mva'] = 0
                        id = inserirSQL(cr, 'fiscal_tributacao_encargos', vals)

            return True
        if operacao == 'r': #Regravar
            if not _regProduto:
                idProduto = inserirSQL(cr, 'estoque_produto', valsProduto)
            else:
                idProduto = _regProduto[0]['id']
            valsProduto.pop('name')
            alterarSQL(cr, 'estoque_produto', idProduto, valsProduto)
            _pessoa_id = lerSQL(cr, 'res_company', ["id = '%s'" % company_id], ['rescon_pessoa_id'])
            if _pessoa_id:
                _pessoa_id = _pessoa_id[0]['rescon_pessoa_id']
            _regPessoa = lerSQL(cr, 'adm_pessoa', ["id = '%s'" % _pessoa_id],
                ['admpes_jur_tipo_atividade', 'admpes_jur_regime_tributario'])
            _tipoAtividade = _regPessoa[0]['admpes_jur_tipo_atividade']
            if _produtoServico == 'P':
                encargosLista = ['ICMS', 'PIS', 'COFINS']
            else:
                encargosLista = ['ICMS', 'ISS', 'PIS', 'COFINS']
            if _tipoAtividade == 'I':
                encargosLista.append('IPI')
            deletarSQL(cr, 'fiscal_tributacao_encargos', "produto_id = %s" % idProduto)
            for _encargo in encargosLista:
                res = lerSQL(cr, 'fiscal_encargo', ["sigla = '%s'" % _encargo], ['id'])
                if res:
                    idFiscalEncargo = res[0]['id']
                else:
                    vals = {'name': _encargo, 'sigla': _encargo}
                    if _encargo in ['COFINS', 'PIS', 'IPI']:
                        vals['tipo_encargo'] = 'F'
                    if _encargo == 'ICMS':
                        vals['tipo_encargo'] = 'E'
                    if _encargo == 'ISS':
                        vals['tipo_encargo'] = 'M'
                    idFiscalEncargo = inserirSQL(cr, 'fiscal_encargo', vals)
                if _encargo == 'ICMS':
                    _cst = _cstNoEstado[1:]
                    _tipo = 'T'
                if _encargo == 'ISS':
                    _cst = '00'
                    _tipo = 'T'
                if _encargo == 'PIS':
                    if _pis:
                        _cst = '01'
                        _tipo = 'T'
                    else:
                        _cst = '05'
                        _tipo = 'U'
                if _encargo == 'COFINS':
                    if _cofins:
                        _cst = '01'
                        _tipo = 'T'
                    else:
                        _cst = '05'
                        _tipo = 'U'
                if _encargo == 'IPI':
                    if float(_aliqIpi) == 0:
                        _cst = '53'
                        _tipo = 'O'
                    else:
                        _cst = '50'
                        _tipo = 'T'
                res = lerSQL(cr, 'fiscal_cst', ["codigo = '%s'" % _cst, "encargo_id = '%s'" % idFiscalEncargo])
                if res:
                    idCST = res[0]['id']
                else:
                    vals = {'codigo': _cst, 'name': _cst, 'tipo': _tipo, 'encargo_id': idFiscalEncargo}
                    idCST = inserirSQL(cr, 'fiscal_cst', vals)
                _idTributacao = False
                if _encargo == 'ICMS' or _encargo == 'ISS':
                    if len(idsTributacaoConsFinal) == 1:
                        args = [('id = ' + str(idsTributacaoConsFinal[0]))]
                    else:
                        args = [('id in ' + str(tuple(idsTributacaoConsFinal)))]
                    if len(idsTributacaoConsFinal) > 1:
                        regTributacao = lerSQL(cr, 'fiscal_tributacao',
                            ["id in %s" % str(tuple(idsTributacaoConsFinal))])
                    else:
                        regTributacao = lerSQL(cr, 'fiscal_tributacao', ["id = '%s'" % idsTributacaoConsFinal[0]])
                if _encargo == 'PIS' or _encargo == 'COFINS':
                    regTributacao = lerSQL(cr, 'fiscal_tributacao', ["encargo_id = '%s'" % idFiscalEncargo])
                if _encargo == 'IPI':
                    regTributacao = lerSQL(cr, 'fiscal_tributacao',
                        ["encargo_id = '%s'" % idFiscalEncargo, "cst_id = '%s'" % idCST])
                for a in regTributacao:
                    if a['encargo_id'] == idFiscalEncargo and a['cst_id'] == idCST:
                        _idTributacao = a['id']
                if _idTributacao:
                    # reg = lerSQL(cr, "fiscal_tributacao_encargos", args)
                    # if reg:
                    #     return True
                    vals = {
                        'produto_id': idProduto,
                        'encargo_id': idFiscalEncargo,
                        'cst_id': idCST,
                        'tributacao_id': _idTributacao,
                    }
                    if _encargo == 'ICMS':
                        vals['mva'] = _mva
                        if float(_mva) != 0 and _tipo == 'T':
                            vals['modbcst'] = '4'
                    else:
                        vals['mva'] = 0
                    id = inserirSQL(cr, 'fiscal_tributacao_encargos', vals)
            return True

    except Exception as e:
        gravarLog('Est01:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Erro: ' + str(e))
        return False


def gerarEst03(empresa_legado, operacao, dados, _codNumerico):#Movimento
    def lerDestinatario(codigo, tabela):
        legado = lerLegado(cr, 1, codigo, tabela)
        if not legado:
            return False
        return legado[0]

    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        if _codNumerico:
            _item = formatastring.formataString(listaDados[0].lstrip('0').rstrip(), 6, '0', 'E')
        else:
            _item = listaDados[0].strip()
        _grade = listaDados[1].strip()
        if _grade == '':
            _grade = 'UN'
        _local = listaDados[2]
        _entrada_saida = listaDados[3]
        _tipoMov = listaDados[4]
        _tipo_mov = _tipoMov
        if _tipoMov == 'T':
            _tipo_mov = 'N'
        if _tipoMov in ['E', 'O']:
            _tipo_mov = 'A'
        _tipo_programa = listaDados[5]
        _cli_for = listaDados[6]
        _serie = listaDados[7].strip()
        _documento = listaDados[8]
        _sequencia = listaDados[9]
        _data_movimento = listaDados[10]
        _data_documento = listaDados[11]
        _quantidade = listaDados[12]
        _departamento = listaDados[13]
        _vendedor = listaDados[14]
        _vendedor_externo = listaDados[15]
        _serie_conhec = listaDados[16]
        _conhec_frete = listaDados[17]
        _fornec_frete = listaDados[18]
        _valor_frete = listaDados[19].replace(' ', '0')
        _sit_tributaria = listaDados[20]
        _cst = listaDados[21]
        _cod_tributacao = listaDados[22]
        _cod_tributacao_entrada = listaDados[23]
        _cfop = listaDados[24].replace(' ', '0')
        _aliquota_icms = listaDados[25].replace(' ', '0')
        _base_icms = listaDados[26].replace(' ', '0')
        _valor_icms = listaDados[27].replace(' ', '0')
        _valor_ipi = listaDados[28].replace(' ', '0')
        _valor_icms_sub_nf = listaDados[29].replace(' ', '0')
        _valor_icms_sub_gu = listaDados[30].replace(' ', '0')
        _mva = listaDados[31].replace(' ', '0')
        _aliquota_ipi = listaDados[32].replace(' ', '0')
        _valor_pis = listaDados[33].replace(' ', '0')
        _valor_cofins = listaDados[34].replace(' ', '0')
        _valor_outros_extra = listaDados[35].replace(' ', '0')
        _valor_outros = listaDados[36].replace(' ', '0')
        _valor = listaDados[37].replace(' ', '0')
        _preco_medio = listaDados[38].replace(' ', '0')
        _custo_corr = listaDados[39].replace(' ', '0')
        _ultimo_custo = listaDados[40].replace(' ', '0')
        _preco_reposicao = listaDados[41].replace(' ', '0')
        _p_venda_deflac = listaDados[42].replace(' ', '0')
        _preco_na_nf = listaDados[43].replace(' ', '0')
        if float(_base_icms) == 0:
            _base_icms = _preco_na_nf
        _pedido = listaDados[44]
        _usuario = listaDados[45].strip()
        _desconto = listaDados[46].replace(' ', '0')
        _loja = listaDados[47]
        _caixa = listaDados[48]
        _base_ipi = listaDados[49].replace(' ', '0')
        _c_s_nf = listaDados[50].upper()
        _chaveGrade = _item + '-' + _grade
        _chaveEst03C = _entrada_saida + '-' + _tipo_mov + '-' + _tipo_programa + '-' + _cli_for + '-' + _serie + '-' + _documento + '-' + _data_documento
        _chaveEst03I = _chaveEst03C + '-' + _item + '-' + _grade + '-' + _sequencia
        # achar grade
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.produto', company_id_c)
        _regProduto = lerSQL(cr, 'estoque_produto', ['company_id = %s' % company_id, "codigo = '%s'" % _item])
        if _regProduto:
            _produto_id = _regProduto[0]['id']
        else:
            gravarLog('Est03:Item nao cadastrado:' + str(_item)+ '   Erro: ' + str(e))
            return False
        _where = ["produto_id = %s" % _produto_id, "grade = '%s'" % _grade]
        _regGrade = lerSQL(cr, 'estoque_produto_grade', _where)
        if not _regGrade:
            gravarLog('Est03:Grade nao cadastrada:' + str(_chaveGrade))
            return False
        _grade_id = _regGrade[0]['id']
        #achar local_id
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.local', company_id_c)
        _regLocal = lerSQL(cr, 'estoque_local', ["numero='%s' and company_id = %s" % (_local, company_id)])
        if not _regLocal:
            gravarLog('Est03:Local nao cadastrado:' + str(_local))
            return False
        _local_id = _regLocal[0]['id']
        _regPessoa = lerSQL(cr, 'adm_pessoa', ["nome='%s'" % _usuario])
        if _regPessoa:
            _pessoa_id = _regPessoa[0]['id']
        else:
            vals = {'nome': _usuario, 'pessoa_tipo': 'F', 'active': True}
            regCodigo = lerSQL(cr, 'ir_sequence', ["code = 'pessoa.codigo'"])
            vals['codigo'] = regCodigo[0]['number_next']
            codigo = int(regCodigo[0]['number_next']) + 1
            partner_id = inserirSQL(cr, 'res_partner', {'name':_usuario, 'notification_email_send':'comment'})
            vals['partner_id'] = partner_id
            alterarSQL(cr, 'ir_sequence', regCodigo[0]['id'], {'number_next': codigo})
            _pessoa_id = inserirSQL(cr, 'adm_pessoa', vals)
        if _c_s_nf == 'S':
            company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'rh.funcionario', company_id_s)
        else:
            company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'rh.funcionario', company_id_c)
        _regFuncionario = lerSQL(cr, 'rh_funcionario', ["company_id='%s'" % company_id, "pessoa='%s'" % _pessoa_id])
        if _regFuncionario:
            _funcionario_id = _regFuncionario[0]['id']
        else:
            vals = {'company_id': company_id, 'pessoa': _pessoa_id}
            _funcionario_id = inserirSQL(cr, 'rh_funcionario', vals)
        _destinatario_id = False
        _endereco_nf_id = False
        if _cli_for != '00000':
            if _entrada_saida == 'E':
                if _tipoMov == 'D':
                    _tabela = 'cre01'
                else:
                    _tabela = 'cpg01'
            else:
                if _tipoMov == 'D':
                    _tabela = 'cpg01'
                else:
                    _tabela = 'cre01'
            _destinatario_id = lerDestinatario(_cli_for, _tabela)
            if _destinatario_id:
                _regEndereco = lerSQL(cr, 'adm_pessoa', ["id = %s" % _destinatario_id])
                if _regEndereco:
                    _endereco_nf_id = _regEndereco[0]['endereco_nf_id']
        pis_id = cofins_id = icms_id = False
        res = lerSQL(cr, 'fiscal_encargo', ["sigla = 'ICMS'"])
        if res:
            icms_id = res[0]['id']
        res = lerSQL(cr, 'fiscal_encargo', ["sigla = 'PIS'"])
        if res:
            pis_id = res[0]['id']
        res = lerSQL(cr, 'fiscal_encargo', ["sigla = 'COFINS'"])
        if res:
            cofins_id = res[0]['id']
        if _entrada_saida == 'E':
            if _tipo_mov == 'N':
                _name = 'Compras'
            if _tipo_mov == 'R':
                _name = 'Ressuprimento Entrando'
            if _tipo_mov in ('D', 'E'):
                _name = 'Devolucao Entrando'
            if _tipo_mov == 'A':
                _name = 'Inventário Entrada'
            if _tipo_mov == 'T':
                _name = 'Transferencia Entrando'
            if _tipo_mov == 'O':
                _name = 'Outras entradas'
        if _entrada_saida == 'S':
            if _tipo_mov == 'N':
                _name = 'Vendas'
            if _tipo_mov == 'R':
                _name = 'Ressuprimento Saindo'
            if _tipo_mov in ('D', 'E'):
                _name = 'Devolucao Saindo'
            if _tipo_mov == 'A':
                _name = 'Inventário Saida'
            if _tipo_mov == 'T':
                _name = 'Transferencia Saindo'
            if _tipo_mov == 'O':
                _name = 'Outras saidas'
        _estoque_operacao_dados = lerSQL(cr, 'estoque_natureza_operacao', ["name = '%s'" % _name, "active = True"])
        if not _estoque_operacao_dados:
            vals = {
                'active': True,
                'estnto_atualizar_saldo': True,
                'estnto_gerar_estatistica': True,
                'estnto_gerar_financeiro': True,
                'estnto_tipo_operacao': _entrada_saida,
                'name': _name
            }
            _estoque_operacao_id = inserirSQL(cr, 'estoque_natureza_operacao', vals)
        else:
            _estoque_operacao_id = _estoque_operacao_dados[0]['id']

        if operacao == 'w': #Gravar
            # Verificar se já foi importado(Capa)
            _fiscal_nf_capa_id = False
            _requisicao_id = False
            if _cfop != '0000':
                _regCfop = lerSQL(cr, 'fiscal_cfop', ["codigo = '%s'" % _cfop])
                if not _regCfop:
                    gravarLog('Est03-CFOP nao cadastrado!' + _cfop)
                    return False
                _regNatureza = lerSQL(cr, 'fiscal_cfop_natureza',
                    ["cfop_id = '%s'" % _regCfop[0]['id'], "fisnat_operacao_id = %s" % _estoque_operacao_id])
                if _regNatureza:
                    _natureza_id = _regNatureza[0]['id']
                else:
                    valsNatureza = {
                        'cfop_id': _regCfop[0]['id'],
                        'name': 'A definir',
                        'active': True,
                        'tipo': _entrada_saida,
                        'fisnat_operacao_id': _estoque_operacao_id,
                    }
                    _natureza_id = inserirSQL(cr, 'fiscal_cfop_natureza', valsNatureza)
                _movimento_tipo = _regCfop[0]['movimento_tipo']
                valsNatEncargos = {}
                if _movimento_tipo != 'T':
                    valsNatEncargos = {
                        'natureza_id': _natureza_id,
                    }
                    if pis_id:
                        valsNatEncargos['encargo_id'] = pis_id
                        end_id = lerSQL(cr, 'fiscal_cfop_natureza_encargos',
                            ['encargo_id = %s' % pis_id, 'natureza_id = %s' % _natureza_id])
                        if not end_id:
                            inserirSQL(cr, 'fiscal_cfop_natureza_encargos', valsNatEncargos)
                    if cofins_id:
                        valsNatEncargos['encargo_id'] = cofins_id
                        end_id = lerSQL(cr, 'fiscal_cfop_natureza_encargos',
                            ['encargo_id = %s' % cofins_id, 'natureza_id = %s' % _natureza_id])
                        if not end_id:
                            inserirSQL(cr, 'fiscal_cfop_natureza_encargos', valsNatEncargos)
                    if icms_id:
                        valsNatEncargos['encargo_id'] = icms_id
                        end_id = lerSQL(cr, 'fiscal_cfop_natureza_encargos',
                            ['encargo_id = %s' % icms_id, 'natureza_id = %s' % _natureza_id])
                        if not end_id:
                            inserirSQL(cr, 'fiscal_cfop_natureza_encargos', valsNatEncargos)
                if _c_s_nf == 'S':
                    company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'fiscal.nf.capa',
                        company_id_s)
                else:
                    company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'fiscal.nf.capa',
                        company_id_c)
                if _tipo_mov in ('N', 'D', 'T') and _tipo_programa != 'M': # Nota fiscal, nao cupom
                    valsFiscal = {
                        'company_id': company_id,
                        'data_emissao': datas.sigDatas(_data_documento).getDataNoFormato('N', 'S', '/'),
                        'data_saida_entrada': datas.sigDatas(_data_movimento).getDataNoFormato('N', 'S', '/'),
                        'numero_nf': _documento,
                        'serie_nf': _serie,
                        'natureza_id': _natureza_id,
                        'state': '3',
                        'tipo': _entrada_saida,
                        'finalidade_emissao': '1',
                    }
                    if _destinatario_id:
                        valsFiscal['destinatario_id'] = _destinatario_id
                    else:
                        gravarLog('Est03-Destinatário nao cadastrado!' + _cli_for)
                        return False
                    if _endereco_nf_id:
                        valsFiscal['destinatario_endereco_id'] = _endereco_nf_id
                    reg_NF = lerSQL(cr, 'fiscal_nf_capa', ['company_id = %s' % company_id,
                                                            'destinatario_id = %s' % _destinatario_id,
                                                            'numero_nf = %s' % _documento,
                                                            "serie_nf = '%s'" % _serie])
                    if reg_NF:
                        _fiscal_nf_capa_id = reg_NF[0]['id']
                    else:
                        _fiscal_nf_capa_id = inserirSQL(cr, 'fiscal_nf_capa', valsFiscal)
            if _tipo_mov == 'R': #Requisicao
                if _c_s_nf == 'S':
                    company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa',
                        'estoqueressuprimento.requisicao.capa', company_id_s)
                else:
                    company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa',
                        'estoqueressuprimento.requisicao.capa', company_id_c)
                regRequisicao = lerSQL(cr, 'estoqueressuprimento_requisicao_capa',
                    ["company_id = %s" % company_id, "numero = '%s'" % _documento])
                if regRequisicao:
                    _requisicao_id = regRequisicao[0]['id']
                else:
                    valsRequisicao = {
                        'company_id': company_id,
                        'numero': _documento,
                        'data': datas.sigDatas(_data_documento).getDataNoFormato('N', 'S', '/'),
                        'state': 'O',
                        'tipo': 'QR',
                    }
                    if _entrada_saida == 'E':
                        valsRequisicao['local_entrada_id'] = _local_id
                    else:
                        valsRequisicao['local_saida_id'] = _local_id
                    _requisicao_id = inserirSQL(cr, 'estoqueressuprimento_requisicao_capa', valsRequisicao)
            if _c_s_nf == 'S':
                company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa',
                    'estoque.movimento.capa', company_id_s)
            else:
                company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa',
                    'estoque.movimento.capa', company_id_c)
            vals = {
                'company_id': company_id,
                'data': datas.sigDatas(_data_movimento).getDataNoFormato('N', 'S', '/'),
                'estmvc_operacao_id': _estoque_operacao_id,
                'funcionario_id': _funcionario_id,
            }
            args = []
            if _fiscal_nf_capa_id:
                vals['nf_capa_id'] = _fiscal_nf_capa_id
                args = ["nf_capa_id = %s" % _fiscal_nf_capa_id]
            if _requisicao_id:
                vals['requisicaoressuprimento_id'] = _requisicao_id
                args = ["requisicaoressuprimento_id = %s" % _requisicao_id]
            if args:
                _regMovimCapa = lerSQL(cr, 'estoque_movimento_capa', args)
                if _regMovimCapa:
                    _movim_capa_id = _regMovimCapa[0]['id']
                else:
                    _movim_capa_id = inserirSQL(cr, 'estoque_movimento_capa', vals)
            else:
                _movim_capa_id = inserirSQL(cr, 'estoque_movimento_capa', vals)
            _embalagens = lerSQL(cr, 'estoque_produto_embalagem',
                ["produto_id='%s'" % _produto_id, 'active = True'])
            if not _embalagens:
                gravarLog('Est03-Nao ha embalagens cadastrada para o produto!' + _item)
                return False
            lista = '('
            for x in _embalagens:
                lista += str(x['embalagem_id']) + ','
            lista = lista[:-1] + ')'
            res = lerSQL(cr, 'estoque_embalagem', ["id in %s" % lista], order='quantidade_na_embalagem')
            _embProd_id = False
            _produto_embalagem_id = _embalagens[0]['id']
            if isinstance(res, list):
                _embProd_id = res[0]['id']
                _where = ["produto_id=%s" % _produto_id, 'active = True', 'embalagem_id = %s' % _embProd_id]
                _embalagens = lerSQL(cr, 'estoque_produto_embalagem', _where)
                if _embalagens:
                    _produto_embalagem_id = _embalagens[0]['id']
            _cfops = lerSQL(cr, 'fiscal_cfop', ["codigo='%s'" % _cfop])
            if _cfops:
                _cfop_id = _cfops[0]['id']
            else:
                _cfop_id = False
            vals = {
                'capa_id': _movim_capa_id,
                'produto_id': _produto_id,
                'grade_id': _grade_id,
                'local_id': _local_id,
                'quantidade': _quantidade,
                'sequencia': _sequencia,
                'vr_unitario': (float(_preco_na_nf) - float(_valor_icms_sub_nf)) / float(_quantidade),
                'vr_total_item': float(_preco_na_nf) - float(_valor_icms_sub_nf),
                'vr_desconto': _desconto,
                'estmvi_saidas_custo_corrigido_total' : _custo_corr,
                'estmvi_saidas_custo_medio_contabil_total' : _preco_medio,
                'estmvi_saidas_custo_reposicao_total' : _preco_reposicao,
                'estmvi_saidas_ultimo_custo_total' : _ultimo_custo,
            }
            if _produto_embalagem_id:
                vals['produto_embalagem_id'] = _produto_embalagem_id
            if _cfop_id:
                vals['cfop_id'] = _cfop_id
            if _fiscal_nf_capa_id:
                vals['nf_id'] = _fiscal_nf_capa_id
            _movim_item_id = inserirSQL(cr, 'estoque_movimento_itens', vals)
            vals = {
                'empresa': empresa_legado,
                'tabela_legado': 'est03I',
                'chave_legado': _chaveEst03I,
                'chave_sigerp': _movim_item_id,
            }
            inserirSQL(cr, "legado_controle", vals)
            legado = lerLegado(cr, '000', _cod_tributacao, 'est14')
            if legado:
                _tributacao_id = legado[0]
                args = ["codigo = '%s'" % _cst[1:], "encargo_id = '%s'" % icms_id]
                _reg_cst = lerSQL(cr, 'fiscal_cst', args)
                if _reg_cst:
                    _cst_id = _reg_cst[0]['id']
                else:
                    _cst_id = False
                vals = {
                    'aliquota': _aliquota_icms,
                    'movimento_itens_id': _movim_item_id,
                    'percentual_mva': _mva,
                    'tributacao_id': _tributacao_id,
                    'vr_base_calculo': _base_icms,
                    'vr_encargo': _valor_icms,
                }
                if _cst_id:
                    vals['cst_id'] = _cst_id
                if icms_id:
                    vals['encargo_id'] = icms_id
                _fiscal_item_id = inserirSQL(cr, 'fiscal_nf_item_tributacao', vals)
                if pis_id:
                    _dadosEncargos = lerSQL(cr, 'fiscal_tributacao_encargos', ["encargo_id=%s" % pis_id,
                                                                                'produto_id=%s' % _produto_id,
                                                                                "tipo_tributacao='T'"])
                    if _dadosEncargos:
                        _dadosTributacao = lerSQL(cr, 'fiscal_tributacao',
                            ['id=%s' % _dadosEncargos[0]['tributacao_id']])
                        if _dadosTributacao:
                            _dadosCst = lerSQL(cr, 'fiscal_cst', ['id=%s' % _dadosTributacao[0]['cst_id']])
                            if _dadosCst:
                                vals = {
                                    'aliquota': _dadosTributacao[0]['aliquota'],
                                    'cst_id': _dadosTributacao[0]['cst_id'],
                                    'encargo_id': pis_id,
                                    'movimento_itens_id': _movim_item_id,
                                    'tributacao_id': _dadosEncargos[0]['tributacao_id'],
                                    'vr_base_calculo': float(_preco_na_nf),
                                    'vr_encargo': 0,
                                }
                                if _dadosCst[0]['tipo'] == 'T':
                                    vals['vr_base_calculo'] = float(_preco_na_nf) - float(_valor_icms_sub_nf)
                                    vals['vr_encargo'] = (float(_preco_na_nf) - float(_valor_icms_sub_nf)) * float(
                                        _dadosTributacao[0]['aliquota']) / 100
                                _fiscal_item_id = inserirSQL(cr, 'fiscal_nf_item_tributacao', vals)
                if cofins_id:
                    _dadosEncargos = lerSQL(cr, 'fiscal_tributacao_encargos', ["encargo_id=%s" % cofins_id,
                                                                                'produto_id=%s' % _produto_id,
                                                                                "tipo_tributacao='T'"])
                    if _dadosEncargos:
                        _dadosTributacao = lerSQL(cr, 'fiscal_tributacao',
                            ['id=%s' % _dadosEncargos[0]['tributacao_id']])
                        if _dadosTributacao:
                            _dadosCst = lerSQL(cr, 'fiscal_cst', ['id=%s' % _dadosTributacao[0]['cst_id']])
                            if _dadosCst:
                                vals = {
                                    'aliquota': _dadosTributacao[0]['aliquota'],
                                    'cst_id': _dadosTributacao[0]['cst_id'],
                                    'encargo_id': cofins_id,
                                    'movimento_itens_id': _movim_item_id,
                                    'tributacao_id': _dadosEncargos[0]['tributacao_id'],
                                    'vr_base_calculo': float(_preco_na_nf),
                                    'vr_encargo': 0,
                                }
                                if _dadosCst[0]['tipo'] == 'T':
                                    vals['vr_base_calculo'] = float(_preco_na_nf) - float(_valor_icms_sub_nf)
                                    vals['vr_encargo'] = (float(_preco_na_nf) - float(_valor_icms_sub_nf)) * float(
                                        _dadosTributacao[0]['aliquota']) / 100
                                _fiscal_item_id = inserirSQL(cr, 'fiscal_nf_item_tributacao', vals)
            if _fiscal_nf_capa_id:
                sock.execute(db, uid, pwd, 'fiscal.nf.capa', 'write', _fiscal_nf_capa_id, {'date_write': datas.hoje_I}, {'salvar_forcado':True})
            return True

        if operacao == 'd': # deletar
            try:
                _regLegado = lerSQL(cr, 'legado_controle',
                    ["empresa='%s'" % empresa_legado, "tabela_legado='est03I'", "chave_legado='%s'" % _chaveEst03I])
                if not _regLegado:
                    return False
                _movim_item_id = _regLegado[0]['chave_sigerp']
                deletarSQL(cr, 'estoque_movimento_itens', "id='%s'" % _movim_item_id)
                deletarSQL(cr, 'legado_controle', "id='%s'" % _regLegado[0]['id'])
            except Exception as e:
                gravarLog('Est03: Erro na exclusao ' + str(e))
                return False
    except Exception as e:
        gravarLog('Est03:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Erro: ' + str(e))
        return False


def gerarEst04(empresa_legado, operacao, dados):#categorias
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        _chave = listaDados[0]
        _chave1 = _chave[:3]
        _chave2 = _chave[3:6]
        _chave3 = _chave[6:9]
        _chave4 = _chave[9:]
        _nome = retira_acentos(listaDados[1].strip())
        _tipo = listaDados[2]
        _contaCustos = listaDados[3]
        _contaCtb = listaDados[4]
        legado = lerLegado(cr, '000', _chave, 'est04')
        _chavePai = False
        if _chave2 != '000':
            if _chave3 == '000':
                _chavePai = _chave1 + '000000000'
            else:
                if _chave4 == '000':
                    _chavePai = _chave1 + _chave2 + '000000'
                else:
                    _chavePai = _chave1 + _chave2 + _chave3 + '000'
        if operacao == 'w': #Gravaro
            if legado:
                return True
            vals = {
                'name': _nome,
            }
            if _chavePai:
                legado = lerLegado(cr, '000', _chavePai, 'est04')
                vals['parent_id'] = legado[0]
            idGrupo = sock.execute(db, uid, pwd, 'estoque.categoria', 'create', vals)
            vals = {
                'empresa': '000',
                'tabela_legado': 'est04',
                'chave_legado': _chave,
                'chave_sigerp': idGrupo,
            }
            idLegado = inserirSQL(cr, 'legado_controle', vals)
            if not idLegado:
                return False
            return True

        if operacao == 'r': # Regravar
            if not legado:
                gravarLog('Est04: Nao achei categoria para alterar!' + str(_chave))
                return False
            idCategoria = legado[0]
            vals = {
                'name': _nome,
            }
            idGrupo = alterarSQL(cr, 'estoque_categoria', idCategoria, vals)
            return True

        if operacao == 'd': # deletar
            idCategoria = legado[0]
            try:
                deletarSQL(cr, 'estoque_categoria', "id = '%s'" % idCategoria)
                deletarSQL(cr, 'legado_controle', "chave_sigerp = '%s' and tabela_legado='est04'" % idGrupo)
            except:
                return False
            return True
        return False
    except Exception as e:
        gravarLog('Est04:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados)+ '   Erro: ' + str(e))
        return False


def gerarEst05(empresa_legado, operacao, dados, _codNumerico):# grade
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        if _codNumerico:
            _item = formatastring.formataString(listaDados[0].lstrip('0').rstrip(), 6, '0', 'E')
        else:
            _item = listaDados[0].strip()
        _grade = listaDados[1].strip()
        if _grade == '':
            _grade = 'UN'
        _chave = _item + '-' + _grade
        _nome = retira_acentos(listaDados[2].strip())
        _nomeResumido = retira_acentos(listaDados[3].strip())
        if len(_nomeResumido) > 25:
            _nomeResumido = _nomeResumido[:25]
        _minimo = listaDados[4]
        _maximo = listaDados[5]
        _balanca = listaDados[6]
        if _balanca == 'S':
            _balanca = True
        else:
            _balanca = False
        _pesoUnidade = listaDados[7]
        _validade = listaDados[8].replace(' ', '0')
        _tecla = listaDados[9].replace(' ', '0')
        _setor = listaDados[10]
        _listaPesquisa = listaDados[11]
        _qtdEntrada = listaDados[12]
        _dataEntrada = listaDados[13]
        _qtdSaida = listaDados[14]
        _dataSaida = listaDados[15]
        _periodoDia = listaDados[16]
        if _periodoDia == 'S':
            _periodoDia = True
        else:
            _periodoDia = False
        _periodoSemana = listaDados[17]
        if _periodoSemana == 'S':
            _periodoSemana = True
        else:
            _periodoSemana = False
        _periodoQuinzena = listaDados[18]
        if _periodoQuinzena == 'S':
            _periodoQuinzena = True
        else:
            _periodoQuinzena = False
        _periodoMes = listaDados[19]
        if _periodoMes == 'S':
            _periodoMes = True
        else:
            _periodoMes = False
        _itemAtivo = listaDados[20]
        if _itemAtivo == 'N':
            _itemAtivo = False
        else:
            _itemAtivo = True
        _dataInclusao = datas.sigDatas(listaDados[21]).getDataNoFormato('N', 'S', '/')
        if _codNumerico:
            _codigoParaBaixa = formatastring.formataString(listaDados[22].lstrip('0').rstrip(), 6, '0', 'E')
        else:
            _codigoParaBaixa = listaDados[22].strip()
        _gradeParaBaixa = listaDados[23].strip()
        #Verificar se modulo concorrencia está instalado
        idsModulo = lerSQL(cr, 'ir_module_module', ["name = 'concorrencia'"])
        _concorrenciaInstalado = False
        if idsModulo:
            _concorrenciaInstalado = idsModulo[0]['state']
            if _concorrenciaInstalado == 'installed':
                _concorrenciaInstalado = True
                #Verificar se modulo balanca está instalado
        idsModulo = lerSQL(cr, 'ir_module_module', ["name = 'balanca'"])
        _balancaInstalado = False
        if idsModulo:
            _balancaInstalado = idsModulo[0]['state']
            if _balancaInstalado == 'installed':
                _balancaInstalado = True
                # achar item para atualizar o nome do produto
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.produto', company_id_c)
        _regProduto = lerSQL(cr, 'estoque_produto', ['company_id = %s' % company_id, "codigo = '%s'" % _item])
        if not _regProduto:
            gravarLog('est05-Item nao cadastrado! ->' + _item)
            return False
        _produto_id = _regProduto[0]['id']
        _codigo = _regProduto[0]['codigo']
        valsProduto = {'name': _nome}
        if _concorrenciaInstalado:
            valsProduto['pesquisa_diaria'] = _periodoDia
            valsProduto['pesquisa_semanal'] = _periodoSemana
            valsProduto['pesquisa_quinzenal'] = _periodoQuinzena
            valsProduto['pesquisa_mensal'] = _periodoMes
            if _periodoDia or _periodoSemana or _periodoQuinzena or _periodoMes:
                valsProduto['acompanhar_precos_concorrentes'] = True
            else:
                valsProduto['acompanhar_precos_concorrentes'] = False
        if _balancaInstalado:
            valsProduto['produto_de_balanca'] = _balanca
            if not _balanca:
                valsProduto['peso_unidade'] = 'N'
            else:
                valsProduto['peso_unidade'] = _pesoUnidade
            valsProduto['validade'] = _validade
            valsProduto['tecla'] = _tecla
            # achar setor
            legado = lerLegado(cr, empresa_legado, _setor, 'est21')
            if not legado:
                _setor = False
            else:
                _setor = legado[0]
                valsProduto['setor_id'] = _setor
        result = lerSQL(cr, 'estoque_produto', ["name = '%s'" % _nome])
        if result:
            valsProduto['name'] = _nome + '-' + str(_codigo)
        if _grade == 'UN' and not _itemAtivo:
            valsProduto['active'] = False
        result = alterarSQL(cr, 'estoque_produto', _produto_id, valsProduto)
        if not result:
            gravarLog('Est05:Nao consegui alterar o produto:' + str(_chave))
            return False
        valsGrade = {
            'produto_id': _produto_id,
            'grade': _grade,
            'active': _itemAtivo,
            'descricao': _nome,
            'minimo': _minimo,
            'maximo': _maximo,
        }
        #Verificar se modulo ecf está instalado
        idsModulo = lerSQL(cr, 'ir_module_module', ["name = 'ecf'"])
        _ecfInstalado = False
        if idsModulo:
            _ecfInstalado = idsModulo[0]['state']
            if _ecfInstalado == 'installed':
                _ecfInstalado = True
        valsGrade['descricao_resumida'] = _nomeResumido
        _idGrade = False
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.produto', company_id_c)
        _idsGrade = lerSQL(cr, 'estoque_produto_grade', ["produto_id = '%s'" % _produto_id, "grade = '%s'" % _grade])
        if _idsGrade:
            _idGrade = _idsGrade[0]['id']
        if operacao == 'w': #Gravar
            if _idGrade:
                result = alterarSQL(cr, 'estoque_produto_grade', _idGrade, valsGrade)
            else:
                _idGrade = inserirSQL(cr, 'estoque_produto_grade', valsGrade)
            return True

        if operacao == 'r': # Regravar
            if not _idGrade:
                _idGrade = inserirSQL(cr, 'estoque_produto_grade', valsGrade)
            valsGrade.pop('produto_id')
            valsGrade.pop('grade')
            result = alterarSQL(cr, 'estoque_produto_grade', _idGrade, valsGrade)
            return True

        if operacao == 'd': # deletar
            try:
                if _idGrade:
                    result = deletarSQL(cr, 'estoque_produto_grade', "id = %s" % _idGrade)
            except:
                gravarLog('Est05:Nao consegui exluir grade:' + str(_chave))
                result = False
            return True
    except Exception as e:
        gravarLog('Est05:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Erro: ' + str(e))
        return False


def gerarEst06(empresa_legado, operacao, dados):#Parametros pis/cofins
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        _pis = listaDados[0]
        _cofins = listaDados[1]
        encargoLista = ['PIS', 'COFINS']
        for encargo in encargoLista:
            res = lerSQL(cr, 'fiscal_encargo', ["sigla = '%s'" % encargo])
            if res:
                idFiscalEncargo = res[0]['id']
            else:
                idFiscalEncargo = False
            cstLista = ['01', '05']
            for a in cstLista:
                args = ["codigo = '%s'" % a, "encargo_id = '%s'" % idFiscalEncargo]
                try:
                    cst_id = lerSQL(cr, 'fiscal_cst', args)[0]['id']
                except:
                    vals = {
                        'codigo': a,
                        'name': 'Alterar',
                        'encargo_id': idFiscalEncargo,
                        'active': True,
                    }
                    if a == '01':
                        vals['tipo'] = 'T'
                    else:
                        vals['tipo'] = 'U'
                    cst_id = inserirSQL(cr, 'fiscal_cst', vals)
                valsTributacao = {
                    'name': encargo,
                    'encargo_id': idFiscalEncargo,
                    'cst_id': cst_id,
                    'base': 100,
                    'active': True,
                }
                if encargo == 'PIS':
                    valsTributacao['aliquota'] = _pis[:1] + '.' + _pis[1:]
                else:
                    valsTributacao['aliquota'] = _cofins[:1] + '.' + _cofins[1:]
                if a == '07':
                    valsTributacao['aliquota'] = 0
                    valsTributacao['base'] = 100
                if operacao == 'w': #Gravar
                    inserirSQL(cr, 'fiscal_tributacao', valsTributacao)
        return True

    except Exception as e:
        gravarLog('Est06:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Erro: ' + str(e))
        return False


def gerarEst10(empresa_legado, operacao, dados, _codNumerico, operacao_original): #Saldo/Lo
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        if _codNumerico:
            _item = formatastring.formataString(listaDados[0].lstrip('0').rstrip(), 6, '0', 'E')
        else:
            _item = listaDados[0].strip()
        _grade = listaDados[1].strip()
        if _grade == '':
            _grade = 'UN'
        _chave = _item + '-' + _grade
        _local = listaDados[2]
        if _local == '00':
            return True
        _unidade = listaDados[3].strip().upper()
        _qtdEmbalagem = listaDados[4][:5] + '.' + listaDados[4][5:]
        _lastro = listaDados[5]
        _capacPalete = listaDados[6]
        _locacao = listaDados[7].strip()
        _saldoC = listaDados[8][:10] + '.' + listaDados[8][10:]
        _requisitadoC = listaDados[9][:10] + '.' + listaDados[9][10:]
        _saldoS = listaDados[10][:10] + '.' + listaDados[10][10:]
        _requisitadoS = listaDados[11][:10] + '.' + listaDados[11][10:]
        # achar grade
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.produto', company_id_c)
        _regProduto = lerSQL(cr, 'estoque_produto', ['company_id = %s' % company_id, "codigo = '%s'" % _item])
        if not _regProduto:
            gravarLog('est10-Item nao cadastrado! ->' + _item)
            return False
        _produto_id = _regProduto[0]['id']
        regsGrade = lerSQL(cr, 'estoque_produto_grade', ["produto_id = %s" % _produto_id, "grade = '%s'" % _grade])
        if not regsGrade:
            gravarLog('est10-item sem grade(legado)! ->' + _chave)
            return False
        _grade_id = regsGrade[0]['id']
        #achar local_id
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.local', company_id_c)
        regsLocal = lerSQL(cr, 'estoque_local', ["numero = '%s' and company_id = %s" % (_local, company_id)])
        if not regsLocal:
            gravarLog('est10-Local nao cadastrado! ->' + _local)
            return False
        _local_id = regsLocal[0]['id']
        # achar repositor_id
        _chaveRepositor = _local + '-' + _locacao
        legado = lerLegado(cr, empresa_legado, _chaveRepositor, 'est22L')
        _repositor_id = False
        if legado:
            _pessoa_id = legado[0]
            _dados_funcionario = lerSQL(cr, 'rh_funcionario', ["pessoa = %s" % _pessoa_id])
            if _dados_funcionario:
                _repositor_id = _dados_funcionario[0]['id']
        if operacao == 'd': #Deletar
            return True

        #achar a unidade, se nao tiver criar
        regsUnidade = lerSQL(cr, 'estoque_embalagem_unidade', ["unidade = '%s'" % _unidade])
        if not regsUnidade:
            valsUnidade = {
                'unidade': _unidade,
                'name': _unidade + '-1',
                'fracao': 'I',
            }
            sock.execute(db, uid, pwd, 'estoque.embalagem.unidade', 'create', valsUnidade)
            regsUnidade = lerSQL(cr, 'estoque_embalagem_unidade', ["unidade = '%s'" % _unidade])
            if not regsUnidade:
                gravarLog('est10-Unidade nao cadastrada! ->' + _unidade)
                return False
        _unidade_id = regsUnidade[0]['id']
        _unidade_name = regsUnidade[0]['name']

        #achar a embalagem, se nao tiver criar
        if float(_qtdEmbalagem) == 1:
            _sigla = _unidade.upper()
        else:
            _qtd = str(int(float(_qtdEmbalagem)))
            if len(_qtd) == 1:
                _sigla = _unidade.upper() + '0' + _qtd
            else:
                _sigla = _unidade.upper() + _qtd
        regsUnidade = lerSQL(cr, 'estoque_embalagem', ["sigla = '%s'" % _sigla])
        if regsUnidade:
            _embalagem_id = regsUnidade[0]['id']
        else:
            valsEmbalagem = {
                'name': _unidade_name,
                'sigla': _sigla,
                'unidade_id': _unidade_id,
                'quantidade_na_embalagem': _qtdEmbalagem,
            }
            if _qtdEmbalagem > 1:
                valsEmbalagem['name'] = _unidade_name + ' com ' + str(int(float(_qtdEmbalagem)))
            _embalagem_id = inserirSQL(cr, 'estoque_embalagem', valsEmbalagem)
        where = ["produto_id = '%s'" % _produto_id, "embalagem_id = '%s'" % _embalagem_id]
        regsProdEmb = lerSQL(cr, 'estoque_produto_embalagem', where)
        if not regsProdEmb:
            valsProdEmb = {
                'produto_id': _produto_id,
                'embalagem_id': _embalagem_id,
                'active': True,
            }
            _prodEmb_id = inserirSQL(cr, 'estoque_produto_embalagem', valsProdEmb)
        else:
            _prodEmb_id = regsProdEmb[0]['id']

        #achar o produto no local, se nao existir, criar locacao
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.local.locacao',
            company_id_c)
        _local_locacao_dados = lerSQL(cr, 'estoque_local_locacao',
            ['company_id = %s' % company_id, 'local_id = %s' % _local_id, 'produto_id = %s' % _produto_id,
             'grade_id = %s' % _grade_id], ['id'])
        valsLocacao = {
            'company_id': company_id,
            'locacao': _locacao,
            'local_id': _local_id,
            'produto_id': _produto_id,
            'grade_id': _grade_id,
            'active': True,
        }
        if _repositor_id:
             valsLocacao['repositor_id'] = _repositor_id
        if _prodEmb_id:
             valsLocacao['estllc_produto_embalagem_id'] = _prodEmb_id
        if not _local_locacao_dados:
            _idLocacao = inserirSQL(cr, 'estoque_local_locacao', valsLocacao)
        else:
            alterarSQL(cr, 'estoque_local_locacao', _local_locacao_dados[0]['id'], valsLocacao)

        #Verificar se existe o saldo NO dia, se nao existir criar
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.produto.saldo',
            company_id_c)
        valsSaldo = {
            'data_movimento': datas.hoje_I,
            'saldo': float(_saldoC) + float(_saldoS) + float(_requisitadoC) + float(_requisitadoS),
            'local_id': _local_id,
            'company_id': company_id,
            'produto_id': _produto_id,
            'grade_id': _grade_id,
        }
        where = ["company_id='%s'" % company_id, "local_id='%s'" % _local_id, "produto_id='%s'" % _produto_id,
                 "grade_id='%s'" % _grade_id, "data_movimento='%s'" % datas.hoje_I, ]
        _dadosSaldo = lerSQL(cr, 'estoque_produto_saldo', where)
        if not _dadosSaldo:
            _idSaldo = inserirSQL(cr, 'estoque_produto_saldo', valsSaldo)
        else:
            alterarSQL(cr, 'estoque_produto_saldo', _dadosSaldo[0]['id'], {'saldo': float(_saldoC) + float(_saldoS),
                                                                           })
        # Atualizar produto para calcular os campos functions
        sock.execute(db, uid, pwd, 'estoque.produto', 'write', _produto_id, {'date_write': datas.hoje_I})
        return True
    except Exception as e:
        gravarLog('Est10:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Erro: ' + str(e))
        return False


def gerarEst11(empresa_legado, operacao, dados): # Vendedor
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        _chave = listaDados[0]
        _nome = listaDados[1].strip()
        _departamento = listaDados[2]
        company = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'vendas.vendedor', company_id_c)
        legadoPessoa = lerLegado(cr, company, _chave, 'est11P')
        legadoVendedor = lerLegado(cr, company, _chave, 'est11')
        if operacao == 'w': #Gravar
            if legadoVendedor:
                return True
            if legadoPessoa:
                return True
            valsPessoa = {'nome': _nome, 'pessoa_tipo': 'F', 'active': True}
            try:
                regCodigo = lerSQL(cr, 'ir_sequence', ["code = 'pessoa.codigo'"])
                valsPessoa['codigo'] = regCodigo[0]['number_next']
                codigo = int(regCodigo[0]['number_next']) + 1
                alterarSQL(cr, 'ir_sequence', regCodigo[0]['id'], {'number_next': codigo})
                partner_id = inserirSQL(cr, 'res_partner', {'name':_nome, 'notification_email_send': 'comment'})
                valsPessoa['partner_id'] = partner_id
                pessoa_id = inserirSQL(cr, 'adm_pessoa', valsPessoa)
                vals = {
                    'empresa': company,
                    'tabela_legado': 'est11P',
                    'chave_legado': _chave,
                    'chave_sigerp': pessoa_id,
                }
                inserirSQL(cr, 'legado_controle', vals)
            except:
                gravarLog('Est11-Nao consegui criar o vendedor no cadastro de pessoas!' + str(valsPessoa))
                return False
            valsVendedor = {
                'pessoa_id': pessoa_id,
                'company_id': company,
                'active': True,
                'tipo': 'I',
            }
            try:
                idVendedor = inserirSQL(cr, 'vendas_vendedor', valsVendedor)
                vals = {
                    'empresa': company,
                    'tabela_legado': 'est11',
                    'chave_legado': _chave,
                    'chave_sigerp': idVendedor,
                }
                inserirSQL(cr, 'legado_controle', vals)
            except:
                gravarLog('Est11-Nao consegui criar o vendedor!' + str(valsVendedor))
                return False
            return True
        if operacao == 'r': # Regravar
            if not legadoPessoa:
                gravarLog('Est11-Nao consegui encontrar vendedor no cadastro de pessoas!' + str(_chave))
                return False
            pessoa_id = legadoPessoa[0]
            valsPessoa = {'nome': _nome}
            try:
                alterarSQL(cr, 'adm_pessoa', pessoa_id, valsPessoa)
                _pessoa_dados = lerSQL(cr, 'adm_pessoa', ["id='%s'" % pessoa_id])
                if not _pessoa_dados:
                    gravarLog('Est11:Pessoa nao cadastrada:' + str(pessoa_id))
                    return False
                partner_id = _pessoa_dados[0]['partner_id']
                alterarSQL(cr, 'res_partner', partner_id, {'name': _nome})
            except:
                gravarLog('Est11-Nao consegui alterar o vendedor!' + str(valsPessoa))
                return False
            return True

        if operacao == 'd': # deletar
            if legadoVendedor:
                idVendedor = legadoVendedor[0]
                try:
                    deletarSQL(cr, 'vendas_vendedor', "id = '%s'" % idVendedor)
                    deletarSQL(cr, 'legado_controle', "chave_legado = '%s' and tabela_legado='est11'" % _chave)
                except:
                    return False
            if legadoPessoa:
                idPessoa = legadoPessoa[0]
                try:
                    deletarSQL(cr, 'adm_pessoa', "id = '%s'" % idPessoa)
                    deletarSQL(cr, 'legado_controle',
                        "chave_sigerp = '%s' and tabela_legado='est11P'" % _chave)
                except Exception as e:
                    gravarLog('Erro: ' + str(e))
                    return False
            return True
    except Exception as e:
        gravarLog('Est11:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) +  '   Erro: ' + str(e))
        return False


def gerarEst13(empresa_legado, operacao, dados, _codNumerico): # Requisicao
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        _locacao = listaDados[0]
        _requisicao = listaDados[1].strip()
        if _codNumerico:
            _item = formatastring.formataString(listaDados[2].lstrip('0').rstrip(), 6, '0', 'E')
        else:
            _item = listaDados[2].strip()
        _grade = listaDados[3].strip()
        _local_entrada = listaDados[4]
        _local_saida = listaDados[5]
        _quantidade = listaDados[6][:9] + '.' + listaDados[6][9:]
        _data = datas.sigDatas(listaDados[7]).getDataNoFormato('N', 'S', '/')
        _qtdConfirmada = listaDados[8][:9] + '.' + listaDados[8][9:]
        _empresaSaida = listaDados[9]
        _jaSeparado = listaDados[10]
        _jaExportadoCd = listaDados[11]
        _chave = _requisicao
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.local', company_id_c)
        _regLocal = lerSQL(cr, 'estoque_local', ["numero='%s' and company_id = %s" % (_local_entrada, company_id)])
        if not _regLocal:
            gravarLog('Est03:Local entrada invalido:' + str(_local_entrada))
            return False
        _local_entrada_id = _regLocal[0]['id']
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.local', company_id_c)
        _regLocal = lerSQL(cr, 'estoque_local', ["numero='%s' and company_id = %s" % (_local_saida, company_id)])
        if not _regLocal:
            gravarLog('Est03:Local entrada invalido:' + str(_local_saida))
            return False
        _local_saida_id = _regLocal[0]['id']
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoqueressuprimento.requisicao.capa', company_id_c)
        if _empresaSaida != '000':
            _empresaSaida = False
        else:
            args = [('empresa_legado', '=', _empresaSaida)]
            try:
                _empresaSaida = sock.execute(db, uid, pwd, 'legado.empresa', 'ler', args)[0]['company_id'][0]
            except:
                gravarLog('Empresa nao cadastrada!' + str(empresa))
        vals = {
            'company_id': company_id,
            'numero': _requisicao,
            'data': _data,
            'local_entrada_id': _local_entrada_id,
            'local_saida_id': _local_saida_id,
            'state': 'O',
            'tipo': 'QR',
        }
        if _empresaSaida:
            vals['company_id'] = _empresaSaida
        legadoRequisicao = lerLegado(cr, empresa_legado, _chave, 'est13')
        _regRequisicao = lerSQL(cr, 'estoqueressuprimento_requisicao_capa', ["resrca_empresa_entrada_id = %s" % company_id, "numero = '%s'" % _requisicao])

        if _regRequisicao:
            _requisicao_id = _regRequisicao[0]['id']
        if operacao == 'w': #Gravar
            if legadoRequisicao:
                return True
            if _regRequisicao:
                alterarSQL(cr, 'estoqueressuprimento_requisicao_capa', _requisicao_id, vals)
            else:
                try:
                    _requisicao_id = inserirSQL(cr, 'estoqueressuprimento_requisicao_capa', vals)
                    vals = {
                        'empresa': empresa_legado,
                        'tabela_legado': 'est13',
                        'chave_legado': _chave,
                        'chave_sigerp': _requisicao_id,
                    }
                    inserirSQL(cr, 'legado_controle', vals)
                except:
                    gravarLog('Est13-Nao consegui criar a requisicao!' + str(vals))
                    return False
            return True
        if operacao == 'r': # Regravar
            if not legadoRequisicao:
                gravarLog('Est13-Nao consegui encontrar requisicao!' + str(_chave))
                return False
            try:
                alterarSQL(cr, 'estoqueressuprimento_requisicao_capa', _requisicao_id, vals)
            except:
                gravarLog('Est13-Nao consegui alterar a requisicao!' + str(vals))
                return False
            return True

        if operacao == 'd': # deletar
            if legadoRequisicao:
                try:
                    deletarSQL(cr, 'estoqueressuprimento_requisicao_capa', "id = '%s'" % _requisicao_id)
                    deletarSQL(cr, 'legado_controle', "chave_legado = '%s' and tabela_legado='est13'" % _chave)
                except:
                    return False
            return True
    except Exception as e:
        gravarLog('Est13:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Erro: ' + str(e))


def gerarEst14(empresa_legado, operacao, dados): #Tributacao
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        _chave = listaDados[0]
        _nome = listaDados[1].strip()
        _aliquota = listaDados[2]
        _base = listaDados[3]
        if int(_base) == 0:
            _base = '100000000'
        _dispositivo1 = listaDados[4].strip()
        _dispositivo2 = listaDados[5].strip()
        _dispositivo3 = listaDados[6].strip()
        _tipo = listaDados[7]
        if listaDados[8] == '2':
            _imposto = 'ISS'
        else:
            _imposto = 'ICMS'
        _tributa_icms_sobre_ipi = listaDados[9]
        _base_reduzida_desc = listaDados[10]
        _base_subst_integral = listaDados[11]
        _regCompany = lerSQL(cr, 'res_company', ["id = '%s'" % company_id_c])
        if _regCompany:
            _pessoa_id = _regCompany[0]['rescon_pessoa_id']
        else:
            gravarLog('Est14:Empresa nao cadastrada:' + str(company_id_c))
            return False
        _regPessoa = lerSQL(cr, 'adm_pessoa', ["id = '%s'" % _pessoa_id])
        if not _regPessoa:
            gravarLog('Est14:Nao tem pessoa associada no cadastro de empresa:' + str(company_id_c))
            return False
        _tipoAtividade = _regPessoa[0]['admpes_jur_tipo_atividade']
        _regimeTributario = _regPessoa[0]['admpes_jur_regime_tributario']
        legado = lerLegado(cr, '000', _chave, 'est14')
        res = lerSQL(cr, 'fiscal_encargo', ["sigla = '%s'" % _imposto])
        if res:
            idFiscalEncargo = res[0]['id']
        else:
            idFiscalEncargo = False
        cstLista = []
        if _imposto == "ISS":
            cstLista = ['41']
        else:
            if _tipo == 'I':
                cstLista = ['30', '40']
            if _tipo == 'D':
                cstLista = ['51']
            if _tipo == 'O':
                cstLista = ['41', '90']
            if _tipo == 'U':
                cstLista = ['10', '30', '60', '70']
            if _tipo == 'T':
                if _tipoAtividade == 'C' and 'S': #Comercio e servico
                    cstLista = ['00']
                else:
                    cstLista = ['00', '10']
        for a in cstLista:
            args = ["codigo ='%s'" % a, "encargo_id = %s" % idFiscalEncargo]
            try:
                cst_id = lerSQL(cr, 'fiscal_cst', args)
                if cst_id:
                    cst_id = cst_id[0]['id']
                else:
                    cst_id = False
            except:
                cst_id = False
            if not cst_id:
                vals = {
                    'codigo': a,
                    'name': 'Alterar',
                    'tipo': _tipo,
                    'encargo_id': idFiscalEncargo,
                    'active': True,
                }
                cst_id = inserirSQL(cr, 'fiscal_cst', vals)
            valsTributacao = {
                'name': _nome,
                'encargo_id': idFiscalEncargo,
                'cst_id': cst_id,
                'base': _base[:3] + '.' + _base[3:],
                'aliquota': _aliquota[:2] + '.' + _aliquota[2:],
                'active': True,
                'dispositivo_fiscal': _dispositivo1.strip() + ' ' + _dispositivo2.strip() + ' ' + _dispositivo3.strip(),
            }
            if operacao == 'w': #Gravar
                idTributacao = inserirSQL(cr, 'fiscal_tributacao', valsTributacao)
                vals = {
                    'empresa': '000',
                    'tabela_legado': 'est14',
                    'chave_legado': _chave,
                    'chave_sigerp': idTributacao,
                }
                inserirSQL(cr, 'legado_controle', vals)
                continue
            if operacao == 'r': # Regravar
                idTributacao = legado[0]
                res = alterarSQL(cr, 'fiscal_tributacao', idTributacao, valsTributacao)
                continue

            if operacao == 'd': # deletar
                idTributacao = legado[0]
                try:
                    deletarSQL(cr, 'fiscal_tributacao', "id = %s" % idTributacao)
                    deletarSQL(cr, 'legado_controle', ["chave_legado = '%s'" % _chave, "tabela_legado = 'est14'"])
                except Exception as e:
                    gravarLog('Erro: ' + str(e))
                    return False
                continue
            gravarLog('Est14:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Est14: nao ha nada a fazer!')
            return False
        return True
    except Exception as e:
        gravarLog('Est14:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Erro: ' + str(e))
        return False


def gerarEst15(empresa_legado, operacao, dados): #Local
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        _chave = listaDados[0]
        _nome = listaDados[1].strip()
        if listaDados[2] == 'N':
            _exclue = False
        else:
            _exclue = True
        if listaDados[3] == 'N':
            _saldoNegativo = False
        else:
            _saldoNegativo = True
        _contaCustos = listaDados[4]
        company = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'adm.empresa.centrocusto', company_id_c)
        legado = lerLegado(cr, empresa_legado, _chave, 'est15')
        args = ["company_id ='%s'" % company]
        regsCentroCusto = lerSQL(cr, 'adm_empresa_centrocusto', args)
        if not regsCentroCusto:
            gravarLog('Est15-Centro de custo nao cadastado!')
            return False
        _idCentroCusto = regsCentroCusto[0]['id']

        company = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.local', company_id_c)
        valsLocais = {
            'company_id': company,
            'name': _nome,
            'excluir_consultas': _exclue,
            'aceita_saldo_negativo': _saldoNegativo,
            'numero': _chave,
            'centrocusto_id': _idCentroCusto,
            'active': True,
        }
        if operacao == 'w': #Gravar
            idLocal = inserirSQL(cr, 'estoque_local', valsLocais)
            vals = {
                'empresa': empresa_legado,
                'tabela_legado': 'est15',
                'chave_legado': _chave,
                'chave_sigerp': idLocal,
            }
            inserirSQL(cr, 'legado_controle', vals)
            return True

        if operacao == 'r': # Regravar
            if not legado:
                gravarLog('Est15: Nao achei local para alterar:' + _chave)
                return False
            idLocal = legado[0]
            alterarSQL(cr, 'estoque_local', idLocal, valsLocais)
            return True

        if operacao == 'd': # deletar
            if not legado:
                gravarLog('Est15: Nao achei local para Excluir:' + _chave)
                return False
            idLocal = legado[0]
            try:
                deletarSQL(cr, 'estoque_local', "id = %s" % idLocal)
                deletarSQL(cr, 'legado_controle',
                    "empresa_legado = '%s' and chave_legado = '%s' and tabela_legado = 'est15'" % (
                        empresa_legado, _chave))
            except Exception as e:
                gravarLog('Erro: ' + str(e))
                return False
    except Exception as e:
        gravarLog('Est15:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '  Erro: ' + str(e))
        return False


def gerarEst16(empresa_legado, operacao, dados): #Comprador
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        _chave = listaDados[0]
        _nome = listaDados[1].strip()
        legadoPessoa = lerLegado(cr, empresa_legado, _chave, 'est16P')
        legadoVendedor = lerLegado(cr, empresa_legado, _chave, 'est16')
        company = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'compras.comprador', company_id_c)
        if operacao == 'w': #Gravar
            if legadoVendedor:
                return True
            if legadoPessoa:
                return True
            valsPessoa = {'nome': _nome, 'pessoa_tipo': 'F', 'active': True}
            try:
                regCodigo = lerSQL(cr, 'ir_sequence', ["code = 'pessoa.codigo'"])
                valsPessoa['codigo'] = regCodigo[0]['number_next']
                codigo = int(regCodigo[0]['number_next']) + 1
                alterarSQL(cr, 'ir_sequence', regCodigo[0]['id'], {'number_next': codigo})
                partner_id = inserirSQL(cr, 'res_partner', {'name':_nome, 'notification_email_send':'comment'})
                valsPessoa['partner_id'] = partner_id
                pessoa_id = inserirSQL(cr, 'adm_pessoa', valsPessoa)
                vals = {
                    'empresa': empresa_legado,
                    'tabela_legado': 'est16P',
                    'chave_legado': _chave,
                    'chave_sigerp': pessoa_id,
                }
                inserirSQL(cr, 'legado_controle', vals)
            except:
                gravarLog('Est16-Nao consegui criar o comprador no cadastro de pessoas!' + str(valsPessoa))
                return False
            valsComprador = {
                'pessoa_id': pessoa_id,
                'company_id': company,
            }
            try:
                idComprador = inserirSQL(cr, 'compras_comprador', valsComprador)
                vals = {
                    'empresa': empresa_legado,
                    'tabela_legado': 'est16',
                    'chave_legado': _chave,
                    'chave_sigerp': idComprador,
                }
                inserirSQL(cr, 'legado_controle', vals)
            except:
                gravarLog('Est16-Nao consegui criar o comprador!' + str(valsComprador))
                return False
            return True
        if operacao == 'r': #regravar
            if not legadoPessoa:
                gravarLog('Est16-Nao consegui encontrar comprador no cadastro de pessoas!' + str(_chave))
                return False
            pessoa_id = legadoPessoa[0]
            valsPessoa = {'name': _nome}
            try:
                alterarSQL(cr, 'adm_pessoa', pessoa_id, valsPessoa)
                partner_id = lerSQL(cr, 'adm_pessoa', ['id = %s' % pessoa_id])[0]['partner_id']
                alterarSQL(cr, 'res_partner', partner_id, {'name':_nome})
            except:
                gravarLog('Est16-Nao consegui alterar o comprador!' + str(valsPessoa))
                return False
            return True
        if operacao == 'd': # deletar
            if legadoVendedor:
                idVendedor = legadoVendedor[0]
                try:
                    deletarSQL(cr, 'compras_comprador', "id = '%s'" % idVendedor)
                    deletarSQL(cr, 'legado_controle', "chave_legado = '%s' and tabela_legado='est16'" % _chave)
                except:
                    return False
            if legadoPessoa:
                idPessoa = legadoPessoa[0]
                try:
                    deletarSQL(cr, 'adm_pessoa', "id = '%s'" % idPessoa)
                    deletarSQL(cr, 'legado_controle',
                        "chave_sigerp = '%s' and tabela_legado='est16P'" % _chave)
                except Exception as e:
                    gravarLog('Erro: ' + str(e))
                    return False
            return True
    except Exception as e:
        gravarLog('Est16:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Erro: ' + str(e))
        return False


def gerarEst17(empresa_legado, operacao, dados, codNumerico):# codigo de barras
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        if _codNumerico:
            _item = formatastring.formataString(listaDados[0].lstrip('0').rstrip(), 6, '0', 'E')
        else:
            _item = listaDados[0].strip()
        _grade = listaDados[1].strip()
        if _grade == '':
            _grade = 'UN'
        _codBarra = listaDados[2]
        _chave = _codBarra
        _chaveGrade = _item + '-' + _grade
        _qtdEmbalagem = listaDados[3][:5]
        _unidade = listaDados[4].strip().upper()
        _emite_etiqueta = listaDados[5]
        if _emite_etiqueta in ('S', 'Y'):
            _emite_etiqueta = True
        else:
            _emite_etiqueta = False
        _modelo_etiqueta = listaDados[6]
        _ultimaData = datas.sigDatas(listaDados[7]).getDataNoFormato('N', 'S', '/')
        _pesoEmbalagem = listaDados[8][:1] + '.' + listaDados[8][1:]
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.produto', company_id_c)
        _regProduto = lerSQL(cr, 'estoque_produto', ['company_id = %s' % company_id, "codigo = '%s'" % _item])
        if not _regProduto:
            gravarLog('est17-Item nao cadastrado! ->' + _item)
            return False
        _produto_id = _regProduto[0]['id']
        _gradeDados = lerSQL(cr, 'estoque_produto_grade', ['produto_id = %s' % _produto_id, "grade = '%s'" % _grade])
        if not _gradeDados:
            gravarLog('est17-Grade nao cadastrada! ->' + _chaveGrade)
            return False
        _grade_id = _gradeDados[0]['id']
        _regUnidade = lerSQL(cr, 'estoque_embalagem_unidade', ["unidade = '%s'" % _unidade])
        if not _regUnidade:
            valsUnidade = {
                'unidade': _unidade,
                'name': _unidade + '-1',
                'fracao': 'I',
            }
            sock.execute(db, uid, pwd, 'estoque.embalagem.unidade', 'create', valsUnidade)
            _regsUnidade = lerSQL(cr, 'estoque_embalagem_unidade', ["unidade = '%s'" % _unidade])
            if not _regsUnidade:
                gravarLog('est10-Unidade nao cadastrada! ->' + _unidade)
                return False
        _unidade_id = _regUnidade[0]['id']
        if float(_qtdEmbalagem) == 1:
            _sigla = _unidade
        else:
            _qtd = str(int(float(_qtdEmbalagem)))
            if len(_qtd) == 1:
                _sigla = _unidade.upper() + '0' + _qtd
            else:
                _sigla = _unidade.upper() + _qtd
        _regEmbalagem = lerSQL(cr, 'estoque_embalagem', ["sigla = '%s' " % _sigla])
        if not _regEmbalagem:
            valsEmbalagem = {
                'name': _regUnidade[0]['name'],
                'sigla': _sigla,
                'unidade_id': _unidade_id,
                'quantidade_na_embalagem': _qtdEmbalagem,
            }
            if _qtdEmbalagem > 1:
               valsEmbalagem['name'] = _regUnidade[0]['name'] + ' com ' + str(int(_qtdEmbalagem))
            _embalagem_id = inserirSQL(cr, 'estoque_embalagem', valsEmbalagem)
        else:
            _embalagem_id = _regEmbalagem[0]['id']
        _regEmbProduto = lerSQL(cr, 'estoque_produto_embalagem',
            ["produto_id = %s and embalagem_id = %s" % (_produto_id, _embalagem_id)])
        if not _regEmbProduto:
            valsProdEmb = {
                'produto_id': _produto_id,
                'embalagem_id': _embalagem_id,
                'active': True,
            }
            _embProduto_id = inserirSQL(cr, 'estoque_produto_embalagem', valsProdEmb)
        else:
            _embProduto_id = _regEmbProduto[0]['id']
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'automacao.codigo.barra',
            company_id_c)
        valsBarra = {
            'company_id': company_id,
            'produto_id': _produto_id,
            'grade_id': _grade_id,
            'produto_embalagem_id': _embProduto_id,
            'emite_etiqueta': _emite_etiqueta,
            'codigo_barra': _codBarra,
            'peso_embalagem': _pesoEmbalagem,
            'active': True,
        }
        if _ultimaData != '00/00/0000':
            valsBarra['ultima_data_movimentacao'] = _ultimaData
        _idBarra = lerSQL(cr, 'automacao_codigo_barra',
            ['company_id = %s' % company_id, "codigo_barra = '%s'" % _codBarra], ['id'])
        if _idBarra:
            _idBarra = _idBarra[0]['id']
        if operacao == 'w': #Gravar
            if _idBarra:
                return True
            try:
                _idBarra = inserirSQL(cr, 'automacao_codigo_barra', valsBarra)
            except Exception as e:
                gravarLog('Est17:Nao consegui inserir codigo de barra: ' + str(valsBarra) + '   Erro: ' + str(e))
                return False
            return True

        if operacao == 'r': # Regravar
            if not _idBarra:
                _idBarra = inserirSQL(cr, 'automacao_codigo_barra', valsBarra)
            try:
                alterarSQL(cr, 'automacao_codigo_barra', _idBarra, valsBarra)
            except Exception as e:
                gravarLog('Est17:Nao consegui alterar codigo de barra: ' + str(valsBarra) + '   Erro: ' + str(e))
                return False
            return True

        if operacao == 'd': # deletar
            try:
                deletarSQL(cr, 'automacao_codigo_barra', "id = %s" % _idBarra)
            except:
                return False
            return True
    except Exception as e:
        gravarLog('Est17:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Erro: ' + str(e))
        return False


def gerarEst18(empresa_legado, operacao, dados, codNumerico):# codigo de barras
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        if _codNumerico:
            _item = formatastring.formataString(listaDados[0].lstrip('0').rstrip(), 6, '0', 'E')
        else:
            _item = listaDados[0].strip()
        _grade = listaDados[1].strip()
        if _grade == '':
            _grade = 'UN'
        _chave = _item + '-' + _grade
        _descricao = listaDados[2].strip()
        a = ''
        for x in _descricao:
            if ord(x) < 130:
                a += x
        _descricao = a
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.produto', company_id_c)
        _regProduto = lerSQL(cr, 'estoque_produto', ['company_id = %s' % company_id, "codigo = '%s'" % _item])
        if not _regProduto:
            gravarLog('est18-Item nao cadastrado! ->' + _item)
            return False
        _produto_id = _regProduto[0]['id']
        _gradeDados = lerSQL(cr, 'estoque_produto_grade', ['produto_id = %s' % _produto_id, "grade = '%s'" % _grade])
        if not _gradeDados:
            gravarLog('est18-Grade nao cadastrada! ->' + _chave)
            return False
        _grade_id = _gradeDados[0]['id']
        valsGrade = {
            'descricao_complementar': _descricao,
        }

        if operacao == 'w' or 'r': # Gravar e Regravar
            try:
                alterarSQL(cr, 'estoque_produto_grade', _grade_id, valsGrade)
            except Exception as e:
                gravarLog('Est18:Nao consegui alterar a descricao complementar: ' + str(valsGrade) + '   Erro: ' + str(e))
            return True

        if operacao == 'd': # deletar
            try:
                alterarSQL(cr, 'estoque_produto_grade', _grade_id, {'descricao_complementar': ''})
            except Exception as e:
                gravarLog('Est18:Nao consegui excluir a descricao complementar: ' + str(valsGrade) + '   Erro: ' + str(e))
            return True
    except Exception as e:
        gravarLog('Est18:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Erro: ' + str(e))


def gerarEst19(empresa_legado, operacao, dados): #Unidade
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        _chave = listaDados[0].strip().upper()
        _nome = listaDados[1].strip()
        if listaDados[2] == 'I':
            _aceitarFracao = False
        else:
            _aceitarFracao = True
        valsUnidade = {
            'unidade': _chave,
            'name': _nome,
            'fracao': _aceitarFracao,
        }
        _regUnidade = lerSQL(cr, 'estoque_embalagem_unidade', ["unidade = '%s'" % _chave])
        if operacao == 'r' and not _regUnidade:
            operacao = 'w'
        if operacao == 'w': #Gravar
            if _regUnidade:
                return True
            idUnidade = sock.execute(db, uid, pwd, 'estoque.embalagem.unidade', 'create', valsUnidade)
            return True
        if not _regUnidade:
            gravarLog('Est19:Unidade nao cadastrada:' + str(_chave))
            return False
        idUnidade = _regUnidade[0]['id']
        if operacao == 'r': # Regravar
            sock.execute(db, uid, pwd, 'estoque.embalagem.unidade', 'write', idUnidade, valsUnidade)
            return True

        if operacao == 'd': # deletar
            try:
                sock.execute(db, uid, pwd, 'estoque.embalagem.unidade', 'unlink', [idUnidade])
            except:
                gravarLog('Erro: ' + str(e))
                return False
            return True
    except Exception as e:
        gravarLog('Est19:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Erro: ' + str(e))
        return False


def gerarEst21(empresa_legado, operacao, dados): # Setor
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        _chave = listaDados[0]
        _nome = listaDados[1].strip()
        args = [('chave_legado', '=', _chave), ('empresa', '=', empresa_legado), ('tabela_legado', '=', 'est21')]
        legado = sock.execute(db, uid, pwd, 'legado.controle', 'ler', args)
        valsSetor = {
            'name': _nome,
        }
        if operacao == 'w': #Gravar
            idUnidade = sock.execute(db, uid, pwd, 'balanca.setor', 'create', valsSetor)
            vals = {

                'empresa': empresa_legado,
                'tabela_legado': 'est21',
                'chave_legado': _chave,
                'chave_sigerp': idUnidade,
            }
            sock.execute(db, uid, pwd, 'legado.controle', 'create', vals)
            return True

        if operacao == 'r': # Regravar
            idsetor = legado[0]['chave_sigerp']
            sock.execute(db, uid, pwd, 'balanca.setor', 'write', idsetor, valsSetor)
            return True

        if operacao == 'd': # deletar
            idsetor = legado[0]['chave_sigerp']
            try:
                sock.execute(db, uid, pwd, 'balanca.setor', 'unlink', [idsetor])
                sock.execute(db, uid, pwd, 'legado.controle', 'unlink', legado[0]['id'])
            except Exception as e:
                gravarLog('Erro: ' + str(e))
                return False
            return True
    except Exception as e:
        gravarLog('Est21:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Erro: ' + str(e))


def gerarEst22(empresa_legado, operacao, dados): #Funcionario
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        _local = listaDados[0]
        _codRepositor = listaDados[1]
        _nome = listaDados[2].strip()
        _chave = _local + '-' + _nome.strip()
        args = [('chave_legado', '=', _chave), ('empresa', '=', empresa_legado), ('tabela_legado', '=', 'est22')]
        legado = sock.execute(db, uid, pwd, 'legado.controle', 'ler', args)
        company = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'rh.funcionario', company_id_c)
        if operacao == 'w': #Gravar
            if legado: # repositor já existe
                # Verificar se o controle por locacao ja existe e se nao existir criar.
                args = [('chave_legado', '=', _local + '-' + _codRepositor.strip()), ('empresa', '=', empresa_legado),
                        ('tabela_legado', '=', 'est22L')]
                legado = sock.execute(db, uid, pwd, 'legado.controle', 'ler', args)
                idPessoa = lerLegado(cr, empresa_legado, _chave, 'est22P')
                if isinstance(idPessoa, list):
                    idPessoa = idPessoa[0]
                if not legado:
                    vals = {
                        'empresa': empresa_legado,
                        'tabela_legado': 'est22L',
                        'chave_legado': _local + '-' + _codRepositor.strip(),
                        'chave_sigerp': idPessoa,
                    }
                    sock.execute(db, uid, pwd, 'legado.controle', 'create', vals)
                return True
            valsPessoa = {'nome': _nome, 'pessoa_tipo': 'F'}
            try:
                regCodigo = lerSQL(cr, 'ir_sequence', ["code = 'pessoa.codigo'"])
                valsPessoa['codigo'] = regCodigo[0]['number_next']
                codigo = int(regCodigo[0]['number_next']) + 1
                alterarSQL(cr, 'ir_sequence', regCodigo[0]['id'], {'number_next': codigo})
                partner_id = inserirSQL(cr, 'res_partner', {'name':_nome, 'notification_email_send':'comment'})
                valsPessoa['partner_id'] = partner_id
                idPessoa = inserirSQL(cr, 'adm_pessoa', valsPessoa)
                vals = {
                    'empresa': empresa_legado,
                    'tabela_legado': 'est22P',
                    'chave_legado': _chave,
                    'chave_sigerp': idPessoa,
                }
                sock.execute(db, uid, pwd, 'legado.controle', 'create', vals)
            except:
                gravarLog('Est22-Nao consegui criar o funcionario no cadastro de pessoas!' + str(valsPessoa))
                return False
            args = [('company_id', '=', company), ('pessoa', '=', idPessoa)]
            funcionario_ids = sock.execute(db, uid, pwd, 'rh.funcionario', 'search', args)
            if funcionario_ids:
                idFuncionario = funcionario_ids[0]
            else:
                valsFuncionario = {
                    'company_id': company,
                    'pessoa': idPessoa,
                }
                idFuncionario = inserirSQL(cr, 'rh_funcionario', valsFuncionario)
            vals = {
                'empresa': empresa_legado,
                'tabela_legado': 'est22',
                'chave_legado': _chave,
                'chave_sigerp': idFuncionario,
            }
            sock.execute(db, uid, pwd, 'legado.controle', 'create', vals)
            return True

        if operacao == 'r': #Regravar
            if not legado: # repositor nao existe
                gravarLog('Est22:Nao achei funcionario para alterar' + _chave)
                return False
            args = [('chave_legado', '=', _chave), ('empresa', '=', empresa_legado), ('tabela_legado', '=', 'est22P')]
            legadoPessoa = sock.execute(db, uid, pwd, 'legado.controle', 'ler', args)
            idPessoa = legadoPessoa[0]['chave_sigerp']
            idPessoa = sock.execute(db, uid, pwd, 'adm.pessoa', 'write', idPessoa, {'nome': _nome})
            partner_id = lerSQL(cr, 'adm_pessoa', ['id = %s' % idPessoa])[0]['id']
            sock.execute(db, uid, pwd, 'res.partner', 'write', partner_id, {'name': _nome})
            company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'rh.funcionario', company_id_c)
            args = [('empresa', '=', company_id), ('pessoa', '=', idPessoa)]
            regsFuncionario = sock.execute(db, uid, pwd, 'rh.funcionario', 'search', args)
            if regsFuncionario:
                idFuncionario = regsFuncionario[0]
            else:
                valsFuncionario = {
                    'empresa': company_id,
                    'pessoa': idPessoa,
                }
                idFuncionario = sock.execute(db, uid, pwd, 'rh.funcionario', 'create', valsFuncionario)
            vals = {
                'empresa': empresa_legado,
                'tabela_legado': 'est22',
                'chave_legado': _chave,
                'chave_sigerp': idFuncionario,
            }
            sock.execute(db, uid, pwd, 'legado.controle', 'create', vals)
            return True

        if operacao == 'd': # deletar
            idfuncionario = legado[0]['chave_sigerp']
            try:
                sock.execute(db, uid, pwd, 'rh.funcionario', 'unlink', [idfuncionario])
                sock.execute(db, uid, pwd, 'legado.controle', 'unlink', legado[0]['id'])
            except:
                return False
            return True
    except Exception as e:
        gravarLog('Est22:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Erro: ' + str(e))
        return False


def gerarEst24(empresa_legado, operacao, dados):# ECFs
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        _chave = listaDados[0]
        _sequencia = listaDados[1]
        _local = listaDados[2]
        _cSNF = listaDados[3]
        _departamento = listaDados[4]
        _nroSerie = listaDados[5].strip()
        _cro = listaDados[6]
        _situacao = listaDados[7]
        if _situacao == 'I':
            _situacao = False
        else:
            _situacao = True
        _fabricante = listaDados[8].strip()
        _modelo = listaDados[9].strip()
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.local', company_id_c)
        regsLocal = lerSQL(cr, 'estoque_local', ["numero = '%s' company_id = %s" % (_local, company_id)])
        if not regsLocal:
            gravarLog('Est24-Local nao cadastrado: %s' % _local)
            return False
        company = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'ecf.ecf', company_id_c)
        _local_id = regsLocal[0]['id']

        _regPessoa = lerSQL(cr, 'adm_pessoa', ["nome = '%s'" % _fabricante])
        if _regPessoa:
            _pessoa_id = _regPessoa[0]['id']
        else:
            vals = {'nome': _fabricante, 'pessoa_tipo': 'J', 'active': True}
            regCodigo = lerSQL(cr, 'ir_sequence', ["code = 'pessoa.codigo'"])
            vals['codigo'] = regCodigo[0]['number_next']
            codigo = int(regCodigo[0]['number_next']) + 1
            alterarSQL(cr, 'ir_sequence', regCodigo[0]['id'], {'number_next': codigo})
            partner_id = inserirSQL(cr,'res_partner', {'name':_fabricante, 'notification_email_send':'comment'})
            vals['partner_id'] = partner_id
            _pessoa_id = inserirSQL(cr, 'adm_pessoa', vals)

        _regEcf = lerSQL(cr, 'ecf_ecf', ["caixa = %s" % _chave])
        valsEcf = {
            'company_id': company,
            'local_id': _local_id,
            'fabricante_id': _pessoa_id,
            'nro_serie': _nroSerie,
            'ativo': _situacao,
            'modelo': _modelo,
            'loja': 1,
            'caixa': _chave,
        }
        if operacao == 'w' or 'r': #Gravar e regravar
            if _regEcf:
                alterarSQL(cr, 'ecf_ecf', _regEcf[0]['id'], valsEcf)
            else:
                _ecfId = inserirSQL(cr, 'ecf_ecf', valsEcf)
                if not _ecfId:
                    return False
            return  True

        if operacao == 'd': # deletar
            try:
                deletarSQL(cr, 'ecf_ecf', "id = %s" % _regEcf[0]['id'])
            except Exception as e:
                gravarLog('Erro: ' + str(e))
                return False
            return True
    except Exception as e:
        gravarLog('Est24:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Erro: ' + str(e))
        return False


def gerarEst33(empresa_legado, operacao, dados, _codNumerico):# politica especial
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        if _codNumerico:
            _item = formatastring.formataString(listaDados[0].lstrip('0').rstrip(), 6, '0', 'E')
        else:
            _item = listaDados[0].strip()
        _grade = listaDados[1].strip()
        if _grade == '':
            _grade = 'UN'
        _chave = _item + '-' + _grade
        _inicio = datas.sigDatas(listaDados[2]).getDataNoFormato('N', 'S', '/')
        _fim = datas.sigDatas(listaDados[3]).getDataNoFormato('N', 'S', '/')
        if _inicio == '00/00/0000' or _fim == '00/00/0000':
            gravarLog('est33-Data invalida! ->' + _inicio + '  -  ' + _fim)
            return False
        _valor = listaDados[4][:9] + '.' + listaDados[4][9:]
        _usuario = listaDados[5].strip()
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.produto', company_id_c)
        _regProduto = lerSQL(cr, 'estoque_produto', ['company_id = %s' % company_id, "codigo = '%s'" % _item])
        if not _regProduto:
            gravarLog('est33-Item nao cadastrado! ->' + _item)
            return False
        _produto_id = _regProduto[0]['id']
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'automacao_precos_promocao',
            company_id_c)
        valsPreco = {
            'produto_id': _produto_id,
            'company_id': company_id,
            'data_inicio': _inicio,
            'data_termino': _fim,
            'preco_venda': _valor
        }
        regPreco = lerSQL(cr, 'automacao_precos_promocao',
            ["produto_id = %s" % _produto_id, "company_id = %s" % company_id])
        if operacao == 'w' or 'r': #Gravar e regravar
            if regPreco:
                alterarSQL(cr, 'automacao_precos_promocao', regPreco[0]['id'], valsPreco)
            else:
                _idPreco = inserirSQL(cr, 'automacao_precos_promocao', valsPreco)
            return True

        if operacao == 'd': # deletar
            try:
                deletarSQL(cr, 'automacao_precos_promocao', "id = %s" % regPreco[0]['id'])
                return True
            except:
                return False

    except Exception as e:
        gravarLog('Est33:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Erro: ' + str(e))
        return False


def gerarEst38(empresa_legado, operacao, dados):# Pedido de fornecedor(Capa)
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        _pedido = listaDados[0]
        _chave = _pedido
        _fornecedor = listaDados[1]
        _representante = listaDados[2]
        _data_pedido = listaDados[3]
        _data_entrega = listaDados[4]
        _transportador = listaDados[5]
        _vencimento1 = datas.sigDatas(listaDados[6]).getDataNoFormato('N', 'S', '/')
        _vencimento2 = datas.sigDatas(listaDados[7]).getDataNoFormato('N', 'S', '/')
        _vencimento3 = datas.sigDatas(listaDados[8]).getDataNoFormato('N', 'S', '/')
        _vencimento4 = datas.sigDatas(listaDados[9]).getDataNoFormato('N', 'S', '/')
        _vencimento5 = datas.sigDatas(listaDados[10]).getDataNoFormato('N', 'S', '/')
        _vencimento6 = datas.sigDatas(listaDados[11]).getDataNoFormato('N', 'S', '/')
        _obs1 = listaDados[12].strip()
        _obs2 = listaDados[13].strip()
        _obs3 = listaDados[14].strip()
        _obs4 = listaDados[15].strip()
        _data_faturamento = datas.sigDatas(listaDados[16]).getDataNoFormato('N', 'S', '/')
        _obs5 = listaDados[17].strip()
        _obs6 = listaDados[18].strip()
        _fim = datas.sigDatas(listaDados[3]).getDataNoFormato('N', 'S', '/')
        _condicao_pgto_id = lerSQL(cr, 'adm_condicao', [])[0]['id']
        _observacao = (_obs1 + ' ' + _obs2 + ' ' + _obs3 + ' ' + _obs4 + ' ' + _obs5 + ' ' + _obs6).strip()
        _observacao = retira_acentos(_observacao)
        _fornecedor_id = lerLegado(cr, 1, _fornecedor, 'cpg01')[0]
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoquepedidos.pedido.capa',
            company_id_c)
        valsPedido = {
            'company_id': company_id,
            'numero_pedido': _pedido,
            'data_emissao': _data_pedido,
            'condicao_pgto_id': _condicao_pgto_id,
            'observacao': _observacao,
            'tipo': 'C',
            'pessoa_id': _fornecedor_id,
            'state': 'V'
        }
        if _data_entrega != '00000000':
            valsPedido['data_entrega'] = _data_entrega

        if _transportador != '00000':
            legado = lerLegado(cr, 1, _transportador, 'cpg01')
            if legado:
                _pessoa_id = legado[0]
                _regTransportador = lerSQL(cr, 'adm_transportador', ["pessoa_id = %s " % _pessoa_id])
                if _regTransportador:
                    _transportador_id = _regTransportador[0]['id']
                    valsPedido['transportador_id'] = _transportador_id
                else:
                    _transportador_id = inserirSQL(cr, 'adm_transportador', {'pessoa_id': _pessoa_id})
                valsPedido['transportador_id'] = _transportador_id

        _regPedido = lerSQL(cr, 'estoquepedidos_pedido_capa', ["numero_pedido = '%s'" % _pedido])

        if operacao == 'w' or 'r': #Gravar e regravar
            if _regPedido:
                alterarSQL(cr, 'estoquepedidos_pedido_capa', _regPedido[0]['id'], valsPedido)
            else:
                _idPedido = inserirSQL(cr, 'estoquepedidos_pedido_capa', valsPedido)
                listVencimento = [_vencimento1, _vencimento2, _vencimento3, _vencimento4, _vencimento5, _vencimento6]
                for venc in listVencimento:
                    if venc != '00/00/0000':
                        valsParcela = {
                            'data_vencimento': venc,
                            'pedido_id': _idPedido,
                            'vr_parcela': 0.01
                        }
                        _idParcela = inserirSQL(cr, 'estoquepedidos_pedido_parcela', valsParcela)
            return True

        if operacao == 'd': # deletar
            try:
                deletarSQL(cr, 'estoquepedidos_pedido_capa', "id = %s" % _regPedido[0]['id'])
            except:
                return False
            return True

    except Exception as e:
        gravarLog('Est38:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Erro:' + str(e))
        return False


def gerarEst39(empresa_legado, operacao, dados, _codNumerico):# Pedido de fornecedor(Itens)
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        _pedido = listaDados[0]
        _sequencia = listaDados[1]
        if _codNumerico:
            _item = formatastring.formataString(listaDados[2].lstrip('0').rstrip(), 6, '0', 'E')
        else:
            _item = listaDados[2].strip()
        _grade = listaDados[3].strip()
        if _grade == '':
            _grade = 'UN'
        _quantidade = listaDados[4]
        _valor = listaDados[5]
        _qtd_entregue = listaDados[6]
        _ipi = listaDados[7]
        _local = listaDados[8]
        _bonificacao = listaDados[9].strip()
        _saldo_na_hora = listaDados[10].strip()
        _regPedido = lerSQL(cr, 'estoquepedidos_pedido_capa', ["numero_pedido = '%s'" % _pedido])
        if not _regPedido:
            gravarLog('est39-Pedido nao cadastrado! ->' + _pedido)
            return False
        _pedido_id = _regPedido[0]['id']
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.produto', company_id_c)
        _regProduto = lerSQL(cr, 'estoque_produto', ['company_id = %s' % company_id, "codigo = '%s'" % _item])
        if not _regProduto:
            gravarLog('est39-Item nao cadastrado! ->' + _item)
            return False
        _produto_id = _regProduto[0]['id']
        _chave = _item + '-' + _grade
        _gradeDados = lerSQL(cr, 'estoque_produto_grade', ['produto_id = %s' % _produto_id, "grade = '%s'" % _grade])
        if not _gradeDados:
            gravarLog('est39-item sem grade(legado)! ->' + _chave)
            return False
        _grade_id = _gradeDados[0]['id']
        #achar local_id
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.local', company_id_c)
        regsLocal = lerSQL(cr, 'estoque_local', ["numero = '%s' and company_id = %s" % (_local, company_id)])
        if not regsLocal:
            gravarLog('est10-Local nao cadastrado! ->' + _local)
            return False
        _local_id = regsLocal[0]['id']
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoquepedidos.pedido.capa',
            company_id_c)
        valsPedido = {
            'grade_id': _grade_id,
            'local_id': _local_id,
            'pedido_id': _pedido_id,
            'produto_id': _produto_id,
            'qtde_pedida': _quantidade,
            'valor_total': _valor,
            'vr_unitario': float(_valor) / float(_quantidade),
        }
        if _qtd_entregue != '000000000.000':
            valsPedido['qtde_atendida'] = _qtd_entregue
        _regPedidoItem = lerSQL(cr, 'estoquepedidos_pedido_item',
            ["pedido_id = '%s'" % _pedido_id, "produto_id = '%s'" % _produto_id, "grade_id = '%s'" % _grade_id])
        if _regPedidoItem:
            _pedido_item_id = _regPedidoItem[0]['id']

        if operacao == 'w' or 'r': #Gravar e regravar
            if _regPedidoItem:
                alterarSQL(cr, 'estoquepedidos_pedido_item', _pedido_item_id, valsPedido)
            else:
                _idPedido = inserirSQL(cr, 'estoquepedidos_pedido_item', valsPedido)
            valor = 0
            regItens = lerSQL(cr, 'estoquepedidos_pedido_item', ["pedido_id = %s" % _pedido_id])
            for reg in regItens:
                valor += reg['valor_total']
            alterarSQL(cr, 'estoquepedidos_pedido_capa', _pedido_id, {'valor_total': valor})
            regParcelas = lerSQL(cr, 'estoquepedidos_pedido_parcela', ["pedido_id = %s" % _pedido_id])
            if regParcelas:
                _ids = []
                for reg in regParcelas:
                    _ids.append(reg['id'])
                qtde = len(regParcelas)
                if qtde > 0:
                    _valorParcela = valor / qtde
                    alterarSQL(cr, 'estoquepedidos_pedido_parcela', _ids, {'vr_parcela': _valorParcela})
            return True

        if operacao == 'd': # deletar
            try:
                deletarSQL(cr, 'estoquepedidos_pedido_capa', "id = %s" % _pedido_item_id)
            except:
                return False
            return True

    except Exception as e:
        gravarLog('Est39:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Erro: ' + str(e))
        return False


def gerarEst53(empresa_legado, operacao, dados, _codNumerico):# Inventario
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        _ano = listaDados[0]
        _mes = listaDados[1]
        _local = listaDados[2]
        if _codNumerico:
            _item = formatastring.formataString(listaDados[3].lstrip('0').rstrip(), 6, '0', 'E')
        else:
            _item = listaDados[3].strip()
        _grade = listaDados[4].strip()
        if _grade == '':
            _grade = 'UN'
        _chave = _item + '-' + _grade
        _unidade = listaDados[5]
        _qtdEmbalagem = listaDados[6][:5] + '.' + listaDados[6][5:]
        _contado = listaDados[7][:10] + '.' + listaDados[7][10:]
        _saldoCadastroCNF = listaDados[8][:10] + '.' + listaDados[8][10:]
        _saldoCadastroSNF = listaDados[9][:10] + '.' + listaDados[9][10:]
        _custoMedio = listaDados[10][:11] + '.' + listaDados[10][11:]
        _precoCusto = listaDados[11][:11] + '.' + listaDados[11][11:]
        _jaAtualizou = listaDados[12]
        if _jaAtualizou in ('Y', 'S'):
            _jaAtualizou = True
        else:
            _jaAtualizou = False
        _quemContou = listaDados[13].strip()
        _emAndamento = listaDados[14][:10] + '.' + listaDados[14][10:]
        _codTributacao = listaDados[15]
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.produto', company_id_c)
        _regProduto = lerSQL(cr, 'estoque_produto', ['company_id = %s' % company_id, "codigo = '%s'" % _item])
        if not _regProduto:
            gravarLog('est53-Item nao cadastrado! ->' + _item)
            return False
        _produto_id = _regProduto[0]['id']
        _gradeDados = lerSQL(cr, 'estoque_produto_grade', ['produto_id = %s' % _produto_id, "grade = '%s'" % _grade])
        if not _gradeDados:
            gravarLog('est53-Grade nao cadastrado! ->' + _chave)
            return False
        _grade_id = _gradeDados[0]['id']
        valsCapa = {
            'company_id': company_id,
            'ano': _ano,
            'mes': _mes,
            'create_date': datas.hoje_I,
            'create_uid': uid,
        }
        if _jaAtualizou:
            valsCapa['state'] = 'A'
        else:
            valsCapa['state'] = 'G'
        _state = valsCapa['state']
        legadoInvCapa = lerLegado(cr, empresa_legado, _ano + _mes, 'est53C')
        if legadoInvCapa:
            legadoInvItem = lerLegado(cr, empresa_legado, str(legadoInvCapa[0]['id']) + _chave + _local, 'est53I')
        else:
            legadoInvItem = []
        if operacao == 'w': #Gravar
            if not legadoInvCapa:
                idCapa = inserirSQL(cr, 'estoque_inventario_capa', valsCapa)
                vals = {
                    'empresa': empresa_legado,
                    'tabela_legado': 'est53C',
                    'chave_legado': _ano + _mes,
                    'chave_sigerp': idCapa,
                }
                inserirSQL(cr, 'legado_controle', vals)
            else:
                idCapa = legadoInvCapa[0]
            if legadoInvItem:
                return True
            valsItem = {
                'inventario_id': idCapa,
                'produto_id': _produto_id,
                'grade_id': _grade_id,
                'estict_custo_medio_contabil': _custoMedio,
                'estict_ultimo_custo': _precoCusto,
                'state': _state,
                'saldo_cadastro': float(_saldoCadastroCNF) + float(_saldoCadastroSNF),
                'saldo_contado': _contado,
                'requisitado': _emAndamento,
            }
            valsItem['produto_contado'] = False
            if _state == 'A':
                valsItem['produto_contado'] = True
            if float(_contado) > 0:
                valsItem['produto_contado'] = True
            idItens = inserirSQL(cr, 'estoque_inventario_contagem', valsItem)
            vals = {
                'empresa': empresa_legado,
                'tabela_legado': 'est53I',
                'chave_legado': str(legadoInvCapa[0]['id']) + _chave + _local,
                'chave_sigerp': idItens,
            }
            inserirSQL(cr, 'legado_controle', vals)
            return True
        if operacao == 'r': # alterar
            if not legadoInvCapa:
                gravarLog('Est53:Nao achei inventario para alterar:' + _ano + _mes)
                return False
            if not legadoInvItem:
                gravarLog('Est53:Nao achei inventario para alterar:' + _ano + '/' + _mes + ' ' + _chave + ' ' + _local)
                return False
            alterarSQL(cr, 'estoque_inventario_capa', idCapa, {'state': _state})
            valsItem = {
                'inventario_id': idCapa,
                'produto_id': _produto_id,
                'grade_id': _grade_id,
                'estict_custo_medio_contabil': _custoMedio,
                'estict_ultimo_custo': _precoCusto,
                'state': _state,
                'saldo_cadastro': float(_saldoCadastroCNF) + float(_saldoCadastroSNF),
                'saldo_contado': _contado,
                'requisitado': _emAndamento,
            }
            valsItem['produto_contado'] = False
            if _state == 'A':
                valsItem['produto_contado'] = True
            if float(_contado) > 0:
                valsItem['produto_contado'] = True
            alterarSQL(cr, 'estoque_inventario_contagem', idCapa, valsItem)
            return True
        if operacao == 'd': # deletar
            if not legadoInvItem:
                gravarLog('Est53:Nao achei inventario para excluir:' + _ano + '/' + _mes + ' ' + _chave + ' ' + _local)
                return False
            try:
                deletarSQL(cr, 'estoque_inventario_contagem', "id = %s" % legadoInvItem[0])
                deletarSQL(cr, 'legado_controle',
                    "empresa = '%s' and chave_legado = '%s' and tabela_legado = 'est53I'" % (
                        empresa_legado, str(legadoInvCapa[0]['id']) + _chave + _local))
            except:
                return False
    except Exception as e:
        gravarLog('Est53:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Erro: ' + str(e))


def gerarEst55(empresa_legado, operacao, dados, _codNumerico, operacao_original):#Precos
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        if _codNumerico:
            _chave = formatastring.formataString(listaDados[0].lstrip('0').rstrip(), 6, '0', 'E')
        else:
            _chave = listaDados[0].strip()
        _pVenda1 = listaDados[1][:11] + '.' + listaDados[1][11:]
        _pVenda2 = listaDados[2][:11] + '.' + listaDados[2][11:]
        _tabelaCorrecao = listaDados[3].strip().upper()
        _indexaPVenda = listaDados[4]
        if _indexaPVenda == 'Y':
            _indexaPVenda = True
        else:
            _indexaPVenda = False
        _nomeIndexador = listaDados[5].strip().upper()
        _pCusto = listaDados[6][:10] + '.' + listaDados[6][10:]
        _pMedio = listaDados[7][:11] + '.' + listaDados[7][11:]
        _pReposicao = listaDados[8][:11] + '.' + listaDados[8][11:]
        _custoCorr = listaDados[9][:9] + '.' + listaDados[9][9:]
        _ultimoFornec = listaDados[10]
        _penulPCusto = listaDados[11][:10] + '.' + listaDados[11][10:]
        _penulPMedio = listaDados[12][:11] + '.' + listaDados[12][11:]
        _penulCustoCorr = listaDados[13][:9] + '.' + listaDados[13][9:]
        _penulPReposicao = listaDados[14][:11] + '.' + listaDados[14][11:]
        _penulFornec = listaDados[15]
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.produto', company_id_c)
        _regProduto = lerSQL(cr, 'estoque_produto', ['company_id = %s' % company_id, "codigo = '%s'" % _chave])
        if not _regProduto:
            gravarLog('est55-Item nao cadastrado! ->' + _chave)
            return False
        _produto_id = _regProduto[0]['id']
        company_custo = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.preco.custo',
            company_id_c)
        regCusto = lerSQL(cr, 'estoque_preco_custo',
            ["produto_id = %s and company_id = %s and create_date = '%s'" % (_produto_id, company_custo, datas.hoje_I)])
        company_venda = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.preco.venda',
            company_id_c)
        regVenda = lerSQL(cr, 'estoque_preco_venda',
            ["produto_id = %s and company_id = %s and write_date = '%s'" % (_produto_id, company_venda, datas.hoje_I)])
        valsPreco = {
            'produto_id': _produto_id,
            'company_id': company_custo,
            'estprc_custo_corrigido': _custoCorr,
            'estprc_custo_medio_contabil': _pMedio,
            'estprc_ultimo_custo': _pCusto,
            'estprc_custo_reposicao': _pReposicao,
            'active': True,
        }
        try:
            if regCusto:
                alterarSQL(cr, 'estoque_preco_custo', regCusto[0]['id'], valsPreco)
            else:
                inserirSQL(cr, 'estoque_preco_custo', valsPreco)
            valsPreco = {
                'produto_id': _produto_id,
                'company_id': company_venda,
                'write_date': datas.hoje_I,
                'preco_venda': _pVenda1,
            }
            if regVenda:
                alterarSQL(cr, 'estoque_preco_venda', regVenda[0]['id'], valsPreco)
            else:
                inserirSQL(cr, 'estoque_preco_venda', valsPreco)
            #Atualizar produto para calcular os campos functions
            sock.execute(db, uid, pwd, 'estoque.produto', 'write', _produto_id, {'date_write': datas.hoje_I})
        except Exception as e:
            gravarLog('Est55:Erro atualizando precos ' + str(_chave) + '   Erro: ' + str(e))
            return False
        return True
    except Exception as e:
        gravarLog('Est55:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Erro: ' + str(e))
        return False

def gerarEst59(empresa_legado, operacao, dados, _codNumerico):# Codigos de produtos parqa os fornecedores
    try:
        listaDados = dados.replace('#', ' ').split('*|*')
        if _codNumerico:
            _item = formatastring.formataString(listaDados[0].lstrip('0').rstrip(), 6, '0', 'E')
        else:
            _item = listaDados[0].strip()
        _grade = listaDados[1].strip()
        if _grade == '':
            _grade = 'UN'
        _fornecedor = listaDados[2].strip()
        _codFornecedor = listaDados[3].strip()
        _chave = _item + '-' + _grade
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'estoque.produto', company_id_c)
        _regProduto = lerSQL(cr, 'estoque_produto', ['company_id = %s' % company_id, "codigo = '%s'" % _item])
        if not _regProduto:
            gravarLog('est59-Item nao cadastrado! ->' + _item)
            return False
        _produto_id = _regProduto[0]['id']
        _fabricante_id = _regProduto[0]['fabricante_id']
        _where = ["produto_id = %s" % _produto_id, "grade = '%s'" % _grade]
        _regGrade = lerSQL(cr, 'estoque_produto_grade', _where)
        if not _regGrade:
            gravarLog('Est59:Grade nao cadastrada:' + str(_chave))
            return False
        _grade_id = _regGrade[0]['id']
        _pessoa_ids = lerLegado(cr, 1, _fornecedor, 'cpg01')
        if _pessoa_ids:
            _pessoa_id = _pessoa_ids[0]
        else:
            gravarLog('Est59:Pessoa nao cadastrada:' + str(_fornecedor))
            return False
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'financeiro.fornecedor', company_id_c)
        _regFornecedor = lerSQL(cr, 'financeiro_fornecedor', ['company_id = %s' % company_id, "pessoa_id = '%s'" % _pessoa_id])
        if _regFornecedor:
            _fornecedor_id = _regFornecedor[0]['id']
        else:
            gravarLog('Est59:Fornecedor nao cadastrada:' + str(_fornecedor))
            return False
        vals = {
            'codigo_fornecedor' : _codFornecedor,
            'fornecedor_id' : _fornecedor_id,
            'grade_id' : _grade_id,
            'produto_id': _produto_id,
        }
        regCodFornecedor = lerSQL(cr, 'estoque_produto_codigo_fornecedor', ["produto_id = %s" % _produto_id, "grade_id = %s" % _grade_id, "codigo_fornecedor = '%s'" % _codFornecedor])
        if operacao == 'w' or 'r': #Gravar e regravar
            if regCodFornecedor:
                alterarSQL(cr, 'estoque_produto_codigo_fornecedor', regCodFornecedor[0]['id'], vals)
            else:
                _idPreco = inserirSQL(cr, 'estoque_produto_codigo_fornecedor', vals)
                if not _idPreco:
                    return False
            if _fabricante_id:
                alterarSQL(cr, 'estoque_produto_grade', _grade_id, {'codigo_no_fabricante': _codFornecedor} )
            return True

        if operacao == 'd': # deletar
            try:
                deletarSQL(cr, 'estoque_produto_codigo_fornecedor', "id = %s" % regCodFornecedor[0]['id'])
                return True
            except Exception as e:
                gravarLog('Est59:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Erro: ' + str(e))
                return False

    except Exception as e:
        gravarLog('Est59:Qtd Elementos:' + str(len(listaDados)) + '  Lista:' + str(listaDados) + '   Erro: ' + str(e))
        return False



arquivo = ''
try:
    arquivo = sys.argv[1]
except:
    gravarLog('Arquivo a integrar nao informado!')
    exit()
if arquivo in ('est05', 'est55'):
    time.sleep(3) #esperar um pouco porque o cadastrado de itens(est01) e um pouco Mais lento

if arquivo == 'todos':
    novaLista = []
    try:
        lista = os.listdir(diretorio + 'int')
        for linha in lista:
            if linha[-1:] == '\n':
                linha = linha[:-1]
            if linha[:3] != 'est':
                continue
            novaLista.append(linha[6:] + linha[:6])
        novaLista.sort()
        lista = []
        for linha in novaLista:
            lista.append(linha[-6:] + linha[:-6])
    except Exception as e:
        gravarLog('Diretorio inexistente!')
        exit()
else:
    try:
        lista = os.listdir(diretorio + 'int')
        lista.sort()
    except Exception as e:
        gravarLog('Diretorio inexistente!')
        exit()

try:
    for arq in lista:
        if arquivo != 'todos':
            if arq[:5] != arquivo:
                continue
        empresa = arq[24:27]
        _operacao = arq[28:].lower()
        try:
            args = [('empresa_legado', '=', empresa), ('tipo', '=', 'S')]
            company_id_s = sock.execute(db, uid, pwd, 'legado.empresa', 'ler', args)[0]['company_id'][0]
            args = [('empresa_legado', '=', empresa), ('tipo', '=', 'C')]
            company_id_c = sock.execute(db, uid, pwd, 'legado.empresa', 'ler', args)[0]['company_id'][0]
        except:
            gravarLog('Empresa nao cadastrada!' + str(empresa) + '-' + str(args))
            continue
        args = [('company_id', '=', company_id_c)]
        registro = sock.execute(db, uid, pwd, 'estoque.parametro', 'ler', args)
        if not registro:
            gravarLog('Parametro do estoque nao cadastrado!')
            sys.exit()
        _codNumerico = registro[0]['codigo_numerico']
        try:
            file = open(diretorio + 'int/' + arq, 'r')
            _arquivoLido = arq[:5]
            registros = file.readlines()
        except:
            continue
        _horaArquivo = int(arq[15:23])
        contador = contarRegistros(registros)
        if _operacao == 'x': # Opderacao = 'x' eh qdo eh gerado o arquivo inteiro
            operacao = 'w'
        else:
            operacao = _operacao
        if _operacao == 'x': # Remover arquivo porque já foi lido e contem varios registros
            os.system('rm -rf ' + diretorio + 'int/' + arq)
        for registro in registros:
            registro = unicode(registro, 'utf-8', errors='ignore')
            res = False
            try:
                if _arquivoLido == 'est01':   # Cadastro
                    res = gerarEst01(empresa, operacao, registro, _codNumerico)
                if _arquivoLido == 'est03':   # Movimento
                    res = gerarEst03(empresa, operacao, registro, _codNumerico)
                if _arquivoLido == 'est04':   # Categoria
                    res = gerarEst04(empresa, operacao, registro)
                if _arquivoLido == 'est05':   # Grade
                    res = gerarEst05(empresa, operacao, registro, _codNumerico)
                if _arquivoLido == 'est06':   # Parametro
                    res = gerarEst06(empresa, operacao, registro)
                if _arquivoLido == 'est10':   # Saldo
                    res = gerarEst10(empresa, operacao, registro, _codNumerico, _operacao)
                if _arquivoLido == 'est11':   # Vendedor
                    res = gerarEst11(empresa, operacao, registro)
                if _arquivoLido == 'est13':   # Requisicao
                    res = gerarEst13(empresa, operacao, registro, _codNumerico)
                if _arquivoLido == 'est14':   # Tributacao
                    res = gerarEst14(empresa, operacao, registro)
                if _arquivoLido == 'est15':   # Local
                    res = gerarEst15(empresa, operacao, registro)
                if _arquivoLido == 'est16':   # Comprador
                    res = gerarEst16(empresa, operacao, registro)
                if _arquivoLido == 'est17':   # Codigo de barras
                    res = gerarEst17(empresa, operacao, registro, _codNumerico)
                if _arquivoLido == 'est18':   # Descricao complementar
                    res = gerarEst18(empresa, operacao, registro, _codNumerico)
                if _arquivoLido == 'est19':   # Unidade
                    res = gerarEst19(empresa, operacao, registro)
                if _arquivoLido == 'est21':   # Setor
                    res = gerarEst21(empresa, operacao, registro)
                if _arquivoLido == 'est22':   # Funcionario
                    res = gerarEst22(empresa, operacao, registro)
                if _arquivoLido == 'est24':   # Fcfs
                    res = gerarEst24(empresa, operacao, registro)
                if _arquivoLido == 'est33':   # Politica Especial
                    res = gerarEst33(empresa, operacao, registro, _codNumerico)
                if _arquivoLido == 'est38':   # Pedido de Fornecedor(Capa)
                    res = gerarEst38(empresa, operacao, registro)
                if _arquivoLido == 'est39':   # Pedido de Fornecedor(Itens)
                    res = gerarEst39(empresa, operacao, registro, _codNumerico)
                if _arquivoLido == 'est53':   # Inventario
                    res = gerarEst53(empresa, operacao, registro, _codNumerico)
                if _arquivoLido == 'est55':   # Precos de venda
                    res = gerarEst55(empresa, operacao, registro, _codNumerico, _operacao)
                if _arquivoLido == 'est59':   # Cadastro de codigo de itens por fornecedor
                    res = gerarEst59(empresa, operacao, registro, _codNumerico)
            except Exception as e:
                gravarLog('Erro Tentando Atualizar.   Erro:' +str(e))
                res = False
            if res and _operacao != 'x': # Registro importado de arquivo com um registro, remover arquivo
                os.system('rm -rf ' + diretorio + 'int/' + arq)
                deletarSQL(cr_log, 'legado_logs',  "lelg_arquivo = '%s'" % arq)
                cr_log.connection.commit()
            if not res and _operacao == 'x': # Erro na importacao de registro de arquivo com varios registros, gerar registro individual para importacao futura
                _horaArquivo += 1
                arqNovo = diretorio + 'int/' + arq[:15] + numero.getNumToStr(_horaArquivo, 8, 0, 'N') + arq[23:28] + 'W'
                fileNovo = open(arqNovo, 'w')
                fileNovo.write(registro)
                fileNovo.close()
            if not res:
                cr.close()
                cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)


except Exception as e:
    gravarLog('Carregando arquivos.   Erro:' + str(e))

