#!/usr/bin/python
# -*- coding: utf-8 -*-
idPrograma = 'fis2ope.py'
idVersao = 'Versao 1.01 de 20/07/2011'
idObs = 'Copyrigth by Sig Informatica Ltda'
"""
Programa para exportacao de dados do Sig Cobol(fiscal) para o SigERP
Este programa deve estar na pasta objetos, juntamente com o arquivo de configuracao sigerp.cfg
Este programa e chamado direto do programa cobol

Estrutura do sigerp.cfg
hostname,username,password,database,dbhostname,dbuser,dbpasswd
localhost,admin,admin,teste,localhost,luiz,admin
"""

import sys
import os
import xmlrpclib, socket
import csv
from SigUtils import datas, geralogs, numero
import psycopg2
import psycopg2.extras
import psutil
diretorio = './'
j = 0
lista = []
encerrar = 'N'
try:
    for proc in psutil.process_iter():
        for cmd in proc.cmdline:
            if 'fis2ope.py' in cmd:
                if proc.cmdline[1] == '../objetos/fis2ope.py':
                    j += 1
                    arquivo = proc.cmdline[2]
                    if j > 1:
                        for arq in lista:
                            if arq == arquivo:
                                encerrar = 'S'
                    lista.append(arquivo)
except:
    pass
if encerrar == 'S':
    exit()
def retira_acentos( string ):
    if str( type( string ) ) == "<type 'str'>":
        nova_string = ''
        for car in string:
            if ord( car ) <= 127 and ord(car) != 92:
                nova_string = nova_string + car
        return nova_string
    return string

def gravarLog(texto, linha=''):
    _arq = _dados = ''
    try:
        _arq = arq
    except:
        pass
    try:
        _dados = registro
    except:
        pass
    if not linha:
        linha = _dados
    try:
        _sql = ("select * from legado_logs where lelg_arquivo = '%s' and lelg_data = '%s' and lelg_hora = '%s'" %
                (str(_arq), str(datas.getDataDeHoje('I','-')), str(datas.getDataDeHoje('H')[:5])))
        cr_log.execute(_sql)
        _registros = cr_log.fetchall()
        if _registros:
            _log_id = _registros[0]['id']
            _sql = "update legado_logs set  lelg_empresa_legado = _'%s', lelg_arquivo = '%s', lelg_erro = '%s', lelg_conteudo = '%s', lelg_data = '%s', "
            _sql += "lelg_hora = '%s', lelg_arquivo_legado = '%s',active = %s"
            _sql = _sql % (str(_arq[-5:-2]), str(_arq),str(texto).replace("'",""), str(linha).replace("'",""), str(datas.getDataDeHoje('I','-')), str(datas.getDataDeHoje('H')[:5]), str(_arq[:5]), True)
            _sql += ' where id = ' + str(_log_id)
            cr_log.execute(_sql)
        else:
            _sql = 'insert into legado_logs (lelg_empresa_legado, lelg_arquivo, lelg_erro, lelg_conteudo, lelg_data, lelg_hora, lelg_arquivo_legado, active)'
            _sql += " values ('%s','%s','%s','%s','%s','%s','%s','%s') "
            _sql = _sql % (str(_arq[-5:-2]), str(_arq),str(texto).replace("'", ""), str(linha).replace("'",""), str(datas.getDataDeHoje('I','-')), str(datas.getDataDeHoje('H')[:5]), str(_arq[:5]), True)
            cr_log.execute(_sql)
        cr_log.connection.commit()
    except Exception as e:
        cr_log.connection.rollback()
        geralogs.geraLogs('fis2ope.log', 'Nao consegui gerar o legado_log.   sql:' + str(_sql) +'   Erro:' + str(e), 'S', '../arquivos/logs/')
        if _arq:
            geralogs.geraLogs('fis2ope.log', _arq +  texto, 'S', '../arquivos/logs/')
        else:
            geralogs.geraLogs('fis2ope.log',  texto, 'S', '../arquivos/logs/')


try:
    arq_configuracao = diretorio + '../objetos/sigerp.cfg'
    arquivo = csv.DictReader(open(arq_configuracao))
    for arq in arquivo:
        hostname = arq['hostname']
        username = arq['username']
        pwd = arq['password']
        porta = arq['porta']
        db = arq['database']
        dbhostname = arq['dbhostname']
        dbuser = arq['dbuser']
        dbpasswd = arq['dbpasswd']
except:
    gravarLog('Erro identificando parametros - sigerp.cfg')

# para especificar a porta use -p=8888
sock_common = xmlrpclib.ServerProxy ( 'http://'+hostname+':' + str(porta) + '/xmlrpc/common' )
socket.setdefaulttimeout(3)
uid = sock_common.login( db, username, pwd )
sock = xmlrpclib.ServerProxy( 'http://'+hostname+':'+ str(porta) + '/xmlrpc/object' )

_stringConeccao = ("dbname='" +db
                        +"' user='"+dbuser
                        +"' host='"+dbhostname
                        +"' password='"+dbpasswd
                        +"' connect_timeout='%d" % 3 + "'")
conn = psycopg2.connect(_stringConeccao)
cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
cr_log = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)

def inserirSQL(cursor, tabela, dados):
    _cr = cursor
    dados['create_uid'] = uid
    dados['create_date'] = datas.hoje_I
    _qtdCampos = len(dados)
    _txt1 = '('
    _txt3 = "("
    for x in dados.keys():
        _txt1 += x + ', '
        _txt3 += "'" + str(dados[x]) + "', "
    _txt1 = _txt1[:-2]+')'
    _txt3 = _txt3[:-2]+")"
    _txt2 = "'%s',"*_qtdCampos
    _txt2 = "("+_txt2[:-1]+")"
    _sql = "insert into "+tabela+" "+_txt1+" values "+_txt2+" returning id"
    _sql = _sql % eval(_txt3)
    try:
        _cr.execute(_sql)
        _cr.connection.commit()
    except Exception as e:
        _cr.connection.rollback()
        gravarLog('Erro insert: tabela '+tabela+ '  sql:'+ _sql + '   Erro: '+str(e))
        return False
    return _cr.fetchone()[0]

def deletarSQL(cursor, tabela, where):
    _sql = 'delete from '+tabela+' where '+where
    try:
        cursor.execute(_sql)
        cursor.connection.commit()
    except Exception as e:
        cursor.connection.rollback()
        gravarLog('Erro delete: tabela '+tabela+ '  sql:'+ _sql + '   Erro: '+str(e))
        return False
    return True

def alterarSQL(cursor, tabela, id, dados):
    dados['write_uid'] = uid
    dados['write_date'] = datas.hoje_I
    _qtdCampos = len(dados)
    _txt = ''
    for x in dados.keys():
        _txt += x + " = '" + str(dados[x]) + "',"
    if _txt[-1:] == ',':
        _txt = _txt[:-1]
    if isinstance(id, list):
        ids = id
        _sql = "update "+tabela+" set "+_txt+" where id in ("
        i = 0
        for id in ids:
            if i > 0:
                _sql += ', '
            _sql += str(id)
            i += 1
        _sql += ")"
    else:
        _sql = "update "+tabela+" set "+_txt+" where id = "+str(id)
    try:
        cursor.execute(_sql)
        cursor.connection.commit()
    except Exception as e:
        cursor.connection.rollback()
        gravarLog('Erro update - sql:'+ _sql + '   Erro: '+str(e))
        return False
    return True

def lerLegado(cursor, empresa_legado, chave_legado, tabela):
    _sql ="select chave_sigerp from legado_controle where empresa = '%s' and chave_legado = '%s' and tabela_legado = '%s'" % (empresa_legado, chave_legado, tabela)
    cursor.execute(_sql)
    try:
        _regLegado = cursor.fetchall()
    except Exception as e:
        gravarLog('Erro lerLegado - sql:'+ _sql + '   Erro: '+str(e))
        return []
    result = []
    if _regLegado:
        for x in _regLegado:
            result.append(x['chave_sigerp'])
    return result

def lerSQL(cursor, tabela, where=None, campos=None):
    """
    parametros:
      cr -> cursor
      tabela -> nome da tabela
      where -> clausula where pronta exemplo: ["codigo = 'teste'","name = 'luiz'"]
      campos -> campos a serem lidos, exemplo: ['codigo, nome']
    """
    if not where:
        where = []
    if not campos:
        campos = []
    _sql = "select "
    if campos:
        for a in campos:
            _sql += a + ','
        _sql = _sql[:-1]+ ' '
    else:
        _sql += '* '
    _sql += 'from '+ tabela + ' '
    if where:
        _sql += 'where '
        for a in where:
            _sql += a +" and "
        if _sql[-5:] == ' and ':
            _sql = _sql[:-5]
    try:
        cursor.execute(_sql)
        _registros = cursor.fetchall()
    except:
        _registros = False
    return _registros

class contarRegistros(object):
    def __init__(self, registros):
        self.regLido = 0
        self.regTotal = len(registros)
        self.regPasso = int(self.regTotal / 100)
        if self.regPasso > 100:
            self.regPasso = 100
        if self.regPasso == 0:
            self.regPasso = 1
    def contar(self, oper='x'):
        self.regLido += 1
        _inteiro, _resto = divmod(self.regLido, self.regPasso)
        if _resto == 0:
            if oper == 'x':
                print(str(self.regTotal) + '/' + str(self.regLido) + '\r')
            return True
        return False

def gerarFis01(empresa_legado, operacao, dados):#Cadastro
    try:
        listaDados = dados.replace('#',' ').split(',')
        _fornecedor = listaDados[0]
        _serie = listaDados[1].strip()
        _nota_fiscal = listaDados[2]
        _data_entrada = datas.sigDatas(listaDados[3]).getDataNoFormato('N', 'S', '/')
        _codigo_fiscal = listaDados[4]
        _especie = listaDados[5].strip()
        _modelo_nf = listaDados[6].strip()
        _estado = listaDados[7].strip()
        _data_documento = datas.sigDatas(listaDados[8]).getDataNoFormato('N', 'S', '/')
        _valor_contabil = listaDados[9]
        _base_icms = listaDados[10]
        _valor_icms = listaDados[11].replace(' ', '0')
        _base_ipi = listaDados[12].replace(' ', '0')
        _valor_ipi = listaDados[13].replace(' ', '0')
        _base_substituicao = listaDados[14].replace(' ', '0')
        _icms_substituicao = listaDados[15].replace(' ', '0')
        _desconto = listaDados[16].replace(' ', '0')
        _ind_frete = listaDados[17]
        _vl_frete_na_nf = listaDados[18].replace(' ', '0')
        _seguro = listaDados[19].replace(' ', '0')
        _desp_acessoria = listaDados[20].replace(' ', '0')
        _avista_aprazo = listaDados[21]
        _c_s_nf = listaDados[22]
        _usar_cliente = listaDados[23]
        _nf_propria_empresa = listaDados[24]
        _chave_nfe = listaDados[25]
        _nf_origem = listaDados[26]
        _nf_origem_serie = listaDados[27]
        _obs = listaDados[28]
        _obs = retira_acentos(_obs)
        _codigo_consumo = listaDados[29]
        _tipo_ligacao = listaDados[30]
        _grupo_tensao = listaDados[31]
        _status_nfe = listaDados[32]
        _protocolo_nfe = listaDados[33]
        _protocolo_canc_nfe = listaDados[34]
        _lote_nfe = listaDados[35]
        _finalidade_nfe = listaDados[36]
        _motivo_nfe = listaDados[37]
        _natureza = listaDados[38]
        _nfe_cstat = listaDados[39]
        _situacao_nf = listaDados[40]
        _xml = listaDados[41].strip()
        if _c_s_nf  == 'S':
            company = company_id_s
        else:
            company = company_id_c
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'fiscal_nf_capa', company)
        _reg_cfop = lerSQL(cr, 'fiscal_cfop', ["codigo = '%s'" % _codigo_fiscal])
        if not _reg_cfop:
            gravarLog('fis01-CFOP nao cadastrado! ->' + _codigo_fiscal)
            return False
        _cfop_id = _reg_cfop[0]['id']
        _cfop_tipo = _reg_cfop[0]['movimento_tipo']
        if _cfop_tipo == 'D':
            legado = lerLegado(cr, 1, _fornecedor, 'cre01')
        else:
            legado = lerLegado(cr, 1, _fornecedor, 'cpg01')
        if not legado:
            gravarLog('fis01-Fornecedor/Cliente nao cadastrado!(legado) ->'+ _fornecedor)
            return False

        _fornecedor_id = legado[0]
        _regEndereco = lerSQL(cr, 'adm_pessoa_endereco', ['pessoa_id = %s' % _fornecedor_id])
        _endereco_id = False
        if _regEndereco:
            _endereco_id = _regEndereco[0]['id']

        _reg_modelo_nf = lerSQL(cr, 'fiscal_modelo_nf', ["fismnf_codigo = '%s'" % _modelo_nf])
        if not _reg_modelo_nf:
            gravarLog('fis01-Modelo de NF nao cadastrado! ->' + _modelo_nf)
            return False
        _modelo_nf_id = _reg_modelo_nf[0]['id']
        _reg_modelo_nf_serie = lerSQL(cr, 'fiscal_modelo_nf_series', ['modelo_nf_id = %s' % _modelo_nf_id])
        if _reg_modelo_nf_serie:
            _modelo_nf_serie_id = _reg_modelo_nf_serie[0]['id']
        else:
            _reg_fiscal = lerSQL(cr, 'fiscal_parametro', ['company_id = %s' % company])
            if _reg_fiscal:
                _param_id = _reg_fiscal[0]['id']
            else:
                gravarLog('fis01-Parametro do fiscal nao cadastrado para a empresa:' + company)
                return False
            _modelo_nf_serie_id = inserirSQL(cr, 'fiscal_modelo_nf_series', {'modelo_nf_id' : _modelo_nf_id,
                                                                        'ambiente' : '1',
                                                                        'parametro_id' : _param_id,
                                                                        'state' : 'A',
                                                                        'numero_nf' : 0,
                                                                        'serie_nf' : _serie
            })

        _estoque_operacao_dados = lerSQL(cr, 'estoque_natureza_operacao', ["name = 'Compras'", "active = True" ])
        if not _estoque_operacao_dados:
            vals = {
                'active' : True,
                'estnto_atualizar_saldo' : True,
                'estnto_gerar_estatistica' : True,
                'estnto_gerar_financeiro' : True,
                'estnto_tipo_operacao' : 'E',
                'name' : 'Compras'
            }
            _estoque_operacao_id = inserirSQL(cr, 'estoque_natureza_operacao', vals)
        else:
            _estoque_operacao_id = _estoque_operacao_dados[0]['id']
        _reg_natureza = lerSQL(cr, 'fiscal_cfop_natureza', ['cfop_id = %s' % _cfop_id])
        if not _reg_natureza:
            valsNatureza = {
                    'active' : True,
                    'cfop_id' : _cfop_id,
                    'name' : 'Compras',
                    'tipo' : 'E',
                    'fisnat_operacao_id' : _estoque_operacao_id
                    }
            _natureza_id = inserirSQL(cr, 'fiscal_cfop_natureza', valsNatureza)
        else:
            _natureza_id = _reg_natureza[0]['id']
        valsNF = {
                'company_id' : company_id,
                'data_emissao' : _data_documento,
                'data_emissao_frete' : _data_documento,
                'data_saida_entrada' : _data_entrada,
                'destinatario_id' : _fornecedor_id,
                'especie' : _especie,
                'finalidade_emissao' : '1',
                'frete' : '0',
                'fisnfc_infcomp_fisco' : _obs,
                'modelo_nf_series_id' : _modelo_nf_serie_id,
                'modelo_nf_id' : _modelo_nf_id,
                'natureza_id' : _natureza_id,
                'nf_propria' : False,
                'nfe_chave_acesso' : _chave_nfe,
                'nfe_forma_impressao_danfe' : '1',
                'nfe_lote' : _lote_nfe,
                'nfe_processo_emissao' : '0',
                'nfe_protocolo' : _protocolo_nfe,
                'nfe_protocolo_cancelamento' : _protocolo_canc_nfe,
                'numero_nf': _nota_fiscal,
                'state' : '3',
                'serie_nf' : _serie,
                'tipo' : 'E',
                'vr_base_icms_substituicao' : _base_substituicao,
                'vr_desconto' : _desconto,
                'vr_despesas_acessorias' : _desp_acessoria,
                'vr_frete' : _vl_frete_na_nf,
                'vr_icms' : _valor_icms,
                'vr_icms_substituicao' : _icms_substituicao,
                'vr_ipi' : _valor_ipi,
                'vr_seguro' : _seguro,
                #'vr_total_nf' : _valor_contabil,
        }
        if _xml:
            valsNF['nfe_xml_gerado'] = _xml
            valsNF['nfe_xml_proc'] = _xml
        if _endereco_id:
            valsNF['destinatario_endereco_id'] = _endereco_id
        if _modelo_nf == '55':
            valsNF['modelo_55'] = True
        if _nf_propria_empresa == 'S':
            valsNF['nf_propria'] = True
            if _chave_nfe:
                if _serie[:1] == '9':
                    valsNF['nfe_forma_emissao'] = '2'
                else:
                    valsNF['nfe_forma_emissao'] = '1'
        reg_NF = lerSQL(cr, 'fiscal_nf_capa', ['company_id = %s' % company_id,
                                           'destinatario_id = %s' % _fornecedor_id,
                                           'numero_nf = %s' % _nota_fiscal,
                                           "serie_nf = '%s'" % _serie])
        if reg_NF:
            _nf_id = reg_NF[0]['id']

        if operacao == 'w' or 'r': #Gravar ou regravar
            try:
                if reg_NF:
                    alterarSQL(cr, 'fiscal_nf_capa', _nf_id, valsNF)
                else:
                    _nf_id = inserirSQL(cr, 'fiscal_nf_capa', valsNF)
                regCapa = lerSQL(cr, 'estoque_movimento_capa', ['nf_capa_id = %s' % _nf_id])
                if regCapa:
                    capa_id = regCapa[0]['id']
                    regItens = lerSQL(cr, 'estoque_movimento_itens', ['capa_id = %s' % capa_id])
                    if regItens:
                        ids_itens = []
                        for reg in regItens:
                            ids_itens.append(reg['id'])
                        alterarSQL(cr, 'estoque_movimento_itens', ids_itens, {'nf_id': _nf_id})
            except Exception as e:
                gravarLog('Erro: '+str(e))
                return False
            sock.execute(db, uid, pwd, 'fiscal.nf.capa', 'write', _nf_id, {'date_write': datas.hoje_I}, {'salvar_forcado':True})
            return True
        if operacao == 'd':
            try:
                deletarSQL(cr, 'fiscal_nf_capa', "company_id = %s and destinatario_id = %s and numero_nf = %s and serie_nf = '%s'"
                        % (company_id, _fornecedor_id, _nota_fiscal, _serie))
            except Exception as e:
                gravarLog('Erro: '+str(e))
                return False
            return True
        gravarLog('Erro: Operacao indefinida:'+str(operacao))
        return False
    except Exception as e:
        gravarLog('Fis01:Qtd Elementos:'+str(len(listaDados))+ '  Lista:'+ str(listaDados) + '   Erro: '+str(e))
        return False

def gerarFis02(empresa_legado, operacao, dados):#
    try:
        listaDados = dados.replace('#',' ').split(',')
        _cliente = listaDados[0]
        _serie = listaDados[1].strip()
        _nota_fiscal = listaDados[2]
        _data_documento = datas.sigDatas(listaDados[3]).getDataNoFormato('N', 'S', '/')
        _codigo_fiscal = listaDados[4]
        _especie = listaDados[5].strip()
        _modelo_nf = listaDados[6].strip()
        _estado = listaDados[7].strip()
        _valor_bruto = listaDados[8]
        _valor_contabil = listaDados[9]
        _base_icms = listaDados[10]
        _valor_icms = listaDados[11].replace(' ', '0')
        _aliq_icms = listaDados[12].replace(' ', '0')
        _base_ipi = listaDados[13].replace(' ', '0')
        _valor_ipi = listaDados[14].replace(' ', '0')
        _wvalor_isentos = listaDados[15].replace(' ', '0')
        _wvalor_outros = listaDados[16].replace(' ', '0')
        _wvalor_substituicao = listaDados[17].replace(' ', '0')
        _wvalor_mob = listaDados[18].replace(' ', '0')
        _wvalor_iss = listaDados[19].replace(' ', '0')
        _wvalor_terceiros = listaDados[20].replace(' ', '0')
        _wvalor_diferido = listaDados[21].replace(' ', '0')
        _base_reduzinda_nao_tributado = listaDados[22].replace(' ', '0')
        _base_substituicao = listaDados[23].replace(' ', '0')
        _icms_substituicao = listaDados[24].replace(' ', '0')
        _departamento = listaDados[25].replace(' ', '0')
        _vendedor = listaDados[26].replace(' ', '0')
        _vendedor_externo = listaDados[27].replace(' ', '0')
        _obs = listaDados[28]
        _obs = retira_acentos(_obs)
        _c_s_nf = listaDados[29]
        _nf_origem = listaDados[30].replace(' ', '0')
        _nf_origem_serie = listaDados[31].replace(' ', '0')
        _dav = listaDados[32].replace(' ', '0')
        _nfe_status = listaDados[33]
        _chave_nfe = listaDados[34]
        _data_saida = datas.sigDatas(listaDados[35]).getDataNoFormato('N', 'S', '/')
        _hora_saida = listaDados[36]
        _finalidade_nfe = listaDados[37]
        _lote_nfe = listaDados[38]
        _status_nfe = listaDados[39]
        _motivo_nfe = listaDados[40]
        _protocolo_nfe = listaDados[41]
        _protocolo_canc_nfe = listaDados[42]
        _situacao_nf = listaDados[43]
        _xml = listaDados[44].strip()

        if _modelo_nf == '2D': # Cupom fiscal nao importar aqui
            return True
        if _c_s_nf  == 'S':
            company = company_id_s
        else:
            company = company_id_c
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'fiscal_nf_capa', company)

        _reg_cfop = lerSQL(cr, 'fiscal_cfop', ["codigo = '%s'" % _codigo_fiscal])
        if not _reg_cfop:
            gravarLog('fis02-CFOP nao cadastrado! ->' + _codigo_fiscal)
            return False
        _cfop_id = _reg_cfop[0]['id']
        _cfop_tipo = _reg_cfop[0]['movimento_tipo']
        if _cfop_tipo == 'D':
            legado = lerLegado(cr, 1, _cliente, 'cpg01')
        else:
            legado = lerLegado(cr, 1, _cliente, 'cre01')
        if not legado:
            gravarLog('fis02-Fornecedor/Cliente nao cadastrado!(legado) ->'+ _cliente)
            return False

        _cliente_id = legado[0]
        _regEndereco = lerSQL(cr, 'adm_pessoa_endereco', ['pessoa_id = %s' % _cliente_id])
        _endereco_id = False
        if _regEndereco:
            _endereco_id = _regEndereco[0]['id']

        _reg_modelo_nf = lerSQL(cr, 'fiscal_modelo_nf', ["fismnf_codigo = '%s'" % _modelo_nf])
        if not _reg_modelo_nf:
            gravarLog('fis02-Modelo de NF nao cadastrado! ->' + _modelo_nf)
            return False
        _modelo_nf_id = _reg_modelo_nf[0]['id']
        _reg_modelo_nf_serie = lerSQL(cr, 'fiscal_modelo_nf_series', ['modelo_nf_id = %s' % _modelo_nf_id])
        if _reg_modelo_nf_serie:
            _modelo_nf_serie_id = _reg_modelo_nf_serie[0]['id']
        else:
            _reg_fiscal = lerSQL(cr, 'fiscal_parametro', ['company_id = %s' % company])
            if _reg_fiscal:
                _param_id = _reg_fiscal[0]['id']
            else:
                gravarLog('fis02-Parametro do fiscal nao cadastrado para a empresa:' + company)
                return False
            _modelo_nf_serie_id = inserirSQL(cr, 'fiscal_modelo_nf_series', {'modelo_nf_id' : _modelo_nf_id,
                                                                         'ambiente' : '1',
                                                                         'parametro_id' : _param_id,
                                                                         'state' : 'A',
                                                                         'numero_nf' : 0,
                                                                         'serie_nf' : _serie
            })

        _reg_natureza = lerSQL(cr, 'fiscal_cfop_natureza', ['cfop_id = %s' % _cfop_id])
        if not _reg_natureza:
            valsNatureza = {
                'active' : True,
                'cfop_id' : _cfop_id,
                'estoque_saldo' : True,
                'financeiro' : True,
                'name' : 'Vendas',
                'tipo' : 'S'
            }
            _natureza_id = inserirSQL(cr, 'fiscal_cfop_natureza', valsNatureza)
        else:
            _natureza_id = _reg_natureza[0]['id']

        valsNF = {
            'company_id' : company_id,
            'data_emissao' : _data_documento,
            'data_emissao_frete' : _data_documento,
            'data_saida_entrada' : _data_documento,
            'destinatario_id' : _cliente_id,
            'especie' : _especie,
            'finalidade_emissao' : '1',
            'frete' : '0',
            'fisnfc_infcomp_fisco' : _obs,
            'modelo_nf_series_id' : _modelo_nf_serie_id,
            'modelo_nf_id' : _modelo_nf_id,
            'natureza_id' : _natureza_id,
            'nf_propria' : False,
            'nfe_chave_acesso' : _chave_nfe,
            'nfe_forma_impressao_danfe' : '1',
            'nfe_lote' : _lote_nfe,
            'nfe_processo_emissao' : '0',
            'nfe_protocolo' : _protocolo_nfe,
            'nfe_protocolo_cancelamento' : _protocolo_canc_nfe,
            'numero_nf': _nota_fiscal,
            'state' : '3',
            'serie_nf' : _serie,
            'tipo' : 'S',
            'vr_base_icms_substituicao' : _base_substituicao,
            'vr_icms' : _valor_icms,
            'vr_icms_substituicao' : _icms_substituicao,
            'vr_ipi' : _valor_ipi,
            #'vr_total_nf' : _valor_contabil,
        }
        if _xml:
            valsNF['nfe_xml_gerado'] = _xml
            valsNF['nfe_xml_proc'] = _xml
        if _endereco_id:
            valsNF['destinatario_endereco_id'] = _endereco_id
        if _modelo_nf == '55':
            valsNF['modelo_55'] = True
        valsNF['nf_propria'] = True
        if _chave_nfe:
            if _serie[:1] == '9':
                valsNF['nfe_forma_emissao'] = '2'
            else:
                valsNF['nfe_forma_emissao'] = '1'
        reg_NF = lerSQL(cr, 'fiscal_nf_capa', ['company_id = %s' % company_id,
                                           'destinatario_id = %s' % _cliente_id,
                                           'numero_nf = %s' % _nota_fiscal,
                                           "serie_nf = '%s'" % _serie])
        if reg_NF:
            _nf_id = reg_NF[0]['id']

        if operacao == 'w' or 'r': #Gravar ou regravar
            try:
                if reg_NF:
                    alterarSQL(cr, 'fiscal_nf_capa', _nf_id, valsNF)
                else:
                    _nf_id = inserirSQL(cr, 'fiscal_nf_capa', valsNF)
                regCapa = lerSQL(cr, 'estoque_movimento_capa', ['nf_capa_id = %s' % _nf_id])
                if regCapa:
                    capa_id = regCapa[0]['id']
                    regItens = lerSQL(cr, 'estoque_movimento_itens', ['capa_id = %s' % capa_id])
                    if regItens:
                        ids_itens = []
                        for reg in regItens:
                            ids_itens.append(reg['id'])
                        alterarSQL(cr, 'estoque_movimento_itens', ids_itens, {'nf_id': _nf_id})
            except Exception as e:
                gravarLog('Erro: '+str(e))
                return False
            sock.execute(db, uid, pwd, 'fiscal.nf.capa', 'write', _nf_id, {'date_write': datas.hoje_I}, {'salvar_forcado':True})
            return True
        if operacao == 'd':
            try:
                deletarSQL(cr, 'fiscal_nf_capa', "company_id = %s and destinatario_id = %s and numero_nf = %s and serie_nf = '%s'"
                             % (company_id, _cliente_id, _nota_fiscal, _serie ))
            except Exception as e:
                gravarLog('Erro: '+str(e))
                return False
            return True
        return False
    except Exception as e:
        gravarLog('fis02:Qtd Elementos:'+str(len(listaDados))+ '  Lista:'+ str(listaDados) + '   Erro: '+str(e))
        return False

def gerarFis05(empresa_legado, operacao, dados):#
    try:
        listaDados = dados.replace('#',' ').split(',')
        _data = datas.sigDatas(listaDados[0]).getDataNoFormato('N', 'S', '/')
        _ecf = listaDados[1].strip()
        _numero_z = listaDados[2]
        _cup_ini = listaDados[3]
        _cup_fin = listaDados[4]
        _gt_ini = listaDados[5].replace(' ', '0')
        _gt_fin = listaDados[6].replace(' ', '0')
        _wvalor_substituicao = listaDados[7].replace(' ', '0')
        _wvalor_isentos = listaDados[8].replace(' ', '0')
        _wvalor_outros = listaDados[9].replace(' ', '0')
        _wvalor_cancelamentos = listaDados[10].replace(' ', '0')
        _wvalor_descontos = listaDados[11].replace(' ', '0')

        _dic_imposto = {}
        for x in range(10):
            _wimposto = listaDados[12+(x*5)]
            _waliquota = listaDados[13+(x*5)].replace(' ', '0')
            _wbase_imposto = listaDados[14+(x*5)].replace(' ', '0')
            _wvalor_imposto = listaDados[15+(x*5)].replace(' ', '0')
            _wbase_reduzida = listaDados[16+(x*5)].replace(' ', '0')
            _dic_imposto[x] = {'tipo':_wimposto,
                               'aliq':_waliquota,
                               'base':_wbase_imposto,
                               'valor':_wvalor_imposto,
                               'reduz':_wbase_reduzida
                               }
        _wvalor_diferido = listaDados[62].replace(' ', '0')
        _cro = listaDados[63]
        _wvalor_acrescimos = listaDados[64].replace(' ', '0')
        _coo = listaDados[65]

        company = company_id_c
        company_id = sock.execute(db, uid, pwd, 'adm.empresa.objeto', 'getEmpresa', 'ecf_ecf', company)

        _args = ['company_id = %s' % company_id, 'caixa = %s' % _ecf]
        _ecf_dados = lerSQL(cr, 'ecf_ecf', _args)
        if not _ecf_dados:
            gravarLog('fis05-ECF nao cadastrado! ->' + _ecf)
            return False
        _ecf_id = _ecf_dados[0]['id']

        vals = {'data': _data,
                'ecf' : _ecf_id,
                'numero_z':_numero_z,
                'cupom_inicial':_cup_ini,
                'cupom_final':_cup_fin,
                'gt_inicial':_gt_ini,
                'gt_final':_gt_fin,
                'cancelamentos': _wvalor_cancelamentos,
                'descontos':_wvalor_descontos,
                'acrescimos':_wvalor_acrescimos,
                'coo': _coo,
                'cro':_cro,
                }
        _mapa_dados = lerSQL(cr, 'ecf_mapa_resumo_capa', ["data = '%s'" % _data, 'ecf = %s' % _ecf_id])
        if operacao == 'w' or 'r': #Gravar ou regravar
            try:
                if _mapa_dados:
                    _mapa_id =  _mapa_dados[0]['id']
                    alterarSQL(cr, 'ecf_mapa_resumo_capa', _mapa_id, vals)
                else:
                    _mapa_id = inserirSQL(cr, 'ecf_mapa_resumo_capa', vals)
                _args = 'capa_id = %s' % _mapa_id
                deletarSQL(cr, 'ecf_mapa_resumo_itens', _args)
                if float(_wvalor_substituicao):
                    vals = {'capa_id': _mapa_id,
                            'base_valor':_wvalor_substituicao,
                            'imposto': 'C',
                            'tipo':'F',
                            }
                    inserirSQL(cr, 'ecf_mapa_resumo_itens', vals)
                if float(_wvalor_isentos):
                    vals = {'capa_id': _mapa_id,
                            'base_valor':_wvalor_isentos,
                            'imposto': 'C',
                            'tipo':'I',
                            }
                    inserirSQL(cr, 'ecf_mapa_resumo_itens', vals)
                if float(_wvalor_outros):
                    vals = {'capa_id': _mapa_id,
                            'base_valor':_wvalor_outros,
                            'imposto': 'C',
                            'tipo':'O',
                            }
                    inserirSQL(cr, 'ecf_mapa_resumo_itens', vals)
                if float(_wvalor_diferido):
                    vals = {'capa_id': _mapa_id,
                            'base_valor':_wvalor_diferido,
                            'imposto': 'C',
                            'tipo':'D',
                            }
                    inserirSQL(cr, 'ecf_mapa_resumo_itens', vals)
                for _item in _dic_imposto:
                    if float(_dic_imposto[_item]['valor']):
                        vals = {'capa_id': _mapa_id,
                                'aliquota': _dic_imposto[_item]['aliq'],
                                'base_reduzida':_dic_imposto[_item]['reduz'],
                                'base_valor':_dic_imposto[_item]['base'],
                                'imposto': _dic_imposto[_item]['tipo'],
                                'imposto_valor':_dic_imposto[_item]['valor'],
                                'tipo':'T',
                                }
                        inserirSQL(cr, 'ecf_mapa_resumo_itens', vals)

            except Exception as e:
                gravarLog('Erro: '+str(e))
                return False
            return True
        if operacao == 'd':
            try:
                if not _mapa_dados:
                    return True
                deletarSQL(cr, 'ecf_mapa_resumo_capa', "data = '%s' and ecf = %s" % (_data, _ecf_id))
            except Exception as e:
                gravarLog('Erro: '+str(e))
                return False
            return True
        return False
    except Exception as e:
        gravarLog('fis05:Qtd Elementos:'+str(len(listaDados))+ '  Lista:'+ str(listaDados) + '   Erro: '+str(e))
        return False

try:
    arquivo = sys.argv[1]
except:
    gravarLog('Arquivo a integrar nao informado!')
    exit()

if arquivo == 'todos':
    novaLista = []
    try:
        lista = os.listdir(diretorio+'int')
        for linha in lista:
            if linha[-1:] == '\n':
                linha = linha[:-1]
            if linha[:3] != 'est':
                continue
            novaLista.append(linha[6:]+linha[:6])
        novaLista.sort()
        lista = []
        for linha in novaLista:
            lista.append(linha[-6:]+linha[:-6])
    except:
        gravarLog('Diretorio inexistente!')
        exit()
else:
    try:
        lista = os.listdir(diretorio+'int')
        lista.sort()
    except:
        gravarLog('Diretorio inexistente!')
        exit()
try:
    for arq in lista:
        if arquivo != 'todos':
            if arq[:5] != arquivo:
                continue
        empresa = arq[24:27]
        _operacao = arq[28:].lower()
        try:
            args = [('empresa_legado', '=', empresa), ('tipo', '=', 'S')]
            company_id_s =  sock.execute(db, uid, pwd, 'legado.empresa', 'ler', args)[0]['company_id'][0]
            args = [('empresa_legado', '=', empresa), ('tipo', '=', 'C')]
            company_id_c =  sock.execute(db, uid, pwd, 'legado.empresa', 'ler', args)[0]['company_id'][0]
        except:
            gravarLog('Empresa nao cadastrada!' + str(empresa) + '-' + str(args))
            continue
        try:
            _file = open(diretorio + 'int/' + arq, 'r')
            _arquivoLido = arq[:5]
            registros = _file.readlines()
        except:
            continue
        _horaArquivo = int(arq[15:23])
        contador = contarRegistros(registros)
        if _operacao == 'x': # Opderacao = 'x' eh qdo eh gerado o arquivo inteiro
            operacao = 'w'
        else:
            operacao = _operacao
        if _operacao == 'x': # Remover arquivo porque já foi lido e contem varios registros
            os.system('rm -rf ' + diretorio+'int/'+arq)
        for registro in registros:
            registro = unicode(registro, 'utf-8', errors='ignore')
            res = False
            try:
                if _arquivoLido == 'fis01':   # Nota fiscal de entrada
                    res = gerarFis01(empresa, operacao, registro)
                if _arquivoLido == 'fis02':   # Nota fiscal de saida
                    res = gerarFis02(empresa, operacao, registro)
                if _arquivoLido == 'fis05':   # Mapa de ECF
                    res = gerarFis05(empresa, operacao, registro)
            except Exception as err:
                gravarLog('Erro Tentando Atualizar.   Erro:' +str(err))
                res = False
            if res and _operacao != 'x': # Registro importado de arquivo com um registro, remover arquivo
                os.system('rm -rf ' + diretorio+'int/'+arq)
                deletarSQL(cr_log, 'legado_logs',  "lelg_arquivo = '%s'" % arq)
                cr_log.connection.commit()
            if not res and _operacao == 'x': # Erro na importacao de registro de arquivo com varios registros, gerar registro individual para importacao futura
                _horaArquivo += 1
                arqNovo = diretorio+'int/'+arq[:15]+numero.getNumToStr(_horaArquivo, 8, 0, 'N')+arq[23:28]+'W'
                fileNovo = open(arqNovo, 'w')
                fileNovo.write(registro)
                fileNovo.close()
except Exception as err:
    gravarLog('Carregando arquivos.    Erro:' + str(err))

