# -*- coding: utf-8 -*-
import xmlrpclib, socket
import csv

def cupom_capa(linha):
    data = linha[2:10]
    try:
        loja = int(linha[10:14])
    except:
        loja = False
    try:
        caixa = int(linha[14:17])
    except:
        caixa = False
    try:
        nro_cupom = int(linha[17:23])
    except:
        nro_cupom = False
    try:
        operador = int(linha[23:33])
    except:
        operador = False
    cliente = linha[33:48]
    hora_inicio = linha[48:52]
    ano = data[:4]
    mes = data[4:6]
    dia = data[6:8]
    data_inicio = ano + '-' + mes + '-' + dia + ' ' + hora_inicio[:2] + ':' + hora_inicio[2:4] + ':00.000000'
    hora_fim = linha[52:56]
    ano = data[:4]
    mes = data[4:6]
    dia = data[6:8]
    data_fim = ano + '-' + mes + '-' + dia + ' ' + hora_fim[:2] + ':' + hora_fim[2:4] + ':00.000000'
    tipo = linha[56:57]
    alteracao = linha[57:58]
    if alteracao is not 'A' or alteracao is not 'D':
        alteracao = False
    try:
        valor_desc_acres = float(linha[58:70])
    except:
        valor_desc_acres = False
    try:
        total_cupom = float(linha[70:80] + '.' + linha[80:82])
    except:
        total_cupom = False
    cliente_conta_vale = linha[82:87]
    conta_contra_vale = linha[87:102]
    conta_transferencia_contra_vale = linha[102:117]
    valor_contra_vale = linha[117:129]
    try:
        codigo_vendedor = int(linha[129:135])
    except:
        codigo_vendedor = False
    ids = sock.execute(db, uid, pwd, 'supervisor.cad.operadores', 'search', [('supope_codigo','=',operador)])
    if ids:
        operador = ids
    else:
        operador = sock.execute(db, uid, pwd, 'supervisor.cad.operadores', 'create', {'supope_codigo': operador, 'name': operador})
    if operador and isinstance(operador, list):
        operador = operador[0]
    vals = {
        'supcap_data_cupom': data,
        'supcap_loja': loja,
        'supcap_caixa': caixa,
        'supcap_nro_cupom': nro_cupom,
        'supcap_operador_id': operador,
        'supcap_cliente': cliente,
        'supcap_data_inicio': data_inicio,
        'supcap_data_fim': data_fim,
        'supcap_tipo': tipo,
        'supcap_alteracao': alteracao,
        'supcap_valor_desc_acres': valor_desc_acres,
        'supcap_total_cupom': total_cupom,
        'supcap_cod_vendedor': codigo_vendedor,
    }

    capa_id = sock.execute(db, uid, pwd, 'supervisor.mov.capa', 'create', vals)
    return capa_id

def cupom_itens(linha, capa_id):
    sequencia = linha[23:26]
    item = linha[26:40]
    ids = sock.execute(db, uid, pwd, 'supervisor.cad.itens', 'search', [('supite_codigo_item','=',item)])
    if ids:
        if isinstance(ids, list):
            ids = ids[0]
        nome_item = sock.execute(db, uid, pwd, 'supervisor.cad.itens', 'read', ids, ['name'])['name']
    else:
        nome_item = False
    departamento = linha[40:42]
    quantidade = float(linha[42:50] + '.' + linha[50:53])
    preco_total = float(linha[53:63] + '.' + linha[63:65])
    desconto = float(linha[65:75] + '.' + linha[75:77])
    acrescimo = float(linha[77:87] + '.' + linha[87:89])
    venda_cancelamento = linha[89:90]
    tributacao_ecf = linha[90:93]
    tributacao_ecf = tributacao_ecf.strip()
    tributacao_tipo = False
    ids = sock.execute(db, uid, pwd, 'supervisor.cad.tributacao', 'search', [('suptri_codigo_trib_ecf','=',tributacao_ecf)])
    if ids:
        if isinstance(ids, list):
            ids = ids[0]
        tipo_tributacao = sock.execute(db, uid, pwd, 'supervisor.cad.tributacao', 'read', ids, ['suptri_tipo_tributacao'])['suptri_tipo_tributacao']
        if tipo_tributacao == 'T':
            tributacao_tipo = 'T'
        elif tipo_tributacao == 'F':
            tributacao_tipo = 'F'
        elif tipo_tributacao == 'I':
            tributacao_tipo = 'I'
        elif tipo_tributacao == 'O':
            tributacao_tipo = False
        else:
            tributacao_tipo = 'N'


    tributacao_retag = linha[93:95]
    aliquota = float(linha[95:97] + '.' + linha[97:99])
    base = float(linha[99:102] + '.' + linha[102:104])

    vals = {
        'supcor_capa_id': capa_id,
        'supcor_sequencia': sequencia,
        'supcor_item': item,
        'supcor_nome_item': nome_item,
        'supcor_quantidade': quantidade,
        'supcor_preco_total': preco_total,
        'supcor_desconto_item': desconto,
        'supcor_acrescimo_item': acrescimo,
        'supcor_venda_cancelamento': venda_cancelamento,
        'supcor_tributacao_ecf': tributacao_ecf,
        'supcor_tributacao_retag': tributacao_retag,
        'supcor_aliquota': aliquota,
        'supcor_base': base,
        'supcor_tipo_tributacao': tributacao_tipo,
    }

    sock.execute(db, uid, pwd, 'supervisor.mov.corpos', 'create', vals)

def cupom_fechamento(linha, capa_id):
    sequencia = linha[23:26]
    finalizadora = linha[26:29]
    tipo = linha[29:30]
    valor = float(linha[30:40] + '.' + linha[40:42])
    troco = float(linha[42:52] + '.' + linha[52:54])
    nro_banco = linha[54:57]
    agencia = linha[57:62]
    nro_cheque = linha[62:72]
    conta = linha[72:79]
    juros = float(linha[79:89] + '.' + linha[89:91])
    cnpj = linha[91:106]
    vista_prazo = linha[106:107]
    valor_taxa_adm = linha[107:119]
    cliente_adm = linha[119:124]
    descontos = float(linha[124:134] + '.' + linha[134:136])
    acrescimos = float(linha[136:146] + '.' + linha[146:148])

    vals = {
        'supfec_capa_id': capa_id,
        'supfec_sequencia': sequencia,
        'supfec_finalizadora': finalizadora,
        'supfec_valor': valor,
        'supfec_troco': troco,
        'supfec_nro_banco': nro_banco,
        'supfec_agencia': agencia,
        'supfec_nro_cheque': nro_cheque,
        'supfec_conta': conta,
        'supfec_juros': juros,
        'supfec_cnpj': cnpj,
        'supfec_desconto_proporcional': descontos,
        'supfec_acrescimo_proporcional': acrescimos,
    }

    fechamento_id = sock.execute(db, uid, pwd, 'supervisor.mov.fechamentos', 'create', vals)
    return fechamento_id

def cupom_vencimentos(linha, fechamento_id):
    sequencia_vencimento = linha[26:28]
    valor_parcela = float(linha[28:38] + '.' + linha[38:40])
    vencimento = linha[40:48]

    vals = {
        'supfve_fechamentos_id': fechamento_id,
        'supfve_sequencia_vencimento': sequencia_vencimento,
        'supfve_valor_parcela': valor_parcela,
        'supfve_vencimento': vencimento,
    }

    sock.execute(db, uid, pwd, 'supervisor.mov.vencimentos', 'create', vals)

def cupom_xz_1(linha, capa_id):
    data = linha[2:10]
    crz = linha[24:34]
    try:
        cupom_inicial = int(linha[34:40])
    except:
        cupom_inicial = False
    try:
        cupom_final = int(linha[40:46])
    except:
        cupom_final = False
    try:
        gt_inicial = float(linha[46:62] + '.' + linha[62:64])
    except:
        gt_inicial = False
    try:
        gt_final = float(linha[64:80] + '.' + linha[80:82])
    except:
        gt_final = False
    try:
        cancelamentos = float(linha[82:92] + '.' + linha[92:94])
    except:
        cancelamentos = False
    try:
        descontos = float(linha[94:104] + '.' + linha[104:106])
    except:
        descontos = False
    try:
        acrescimos = float(linha[106:116] + '.' + linha[116:118])
    except:
        acrescimos = False
    try:
        cro = int(linha[118:122])
    except:
        cro = False

    vals = {
        'supcxz_capa_id': capa_id,
        'supcxz_data_movimento': data,
        'supcxz_cro': cro,
        'supcxz_cupom_inicial': cupom_inicial,
        'supcxz_cupom_final': cupom_final,
        'supcxz_gt_atual': gt_final,
        'supcxz_gt_anterior': gt_inicial,
        'supcxz_cancelamentos': cancelamentos,
        'supcxz_descontos': descontos,
        'supcxz_acrescimos': acrescimos,
    }

    sock.execute(db, uid, pwd, 'supervisor.mov.corpo.xz', 'create', vals)

def cupom_xz_2(linha, capa_id):
    tributacao_na_ecf = linha[26:29]
    try:
        valor = float(linha[31:40] + '.' + linha[40:43])
    except:
        valor = False

    vals = {
        'suptxz_capa_id': capa_id,
        'suptxz_codigo_trib_ecf': tributacao_na_ecf,
        'suptxz_valor': valor,
    }

    sock.execute(db, uid, pwd, 'supervisor.mov.totalizadores.xz', 'create', vals)

def cupom_xz_3(linha, capa_id, sequencia_fechamento):
    try:
        finalizadora = int(linha[24:27])
    except:
        finalizadora = False
    tipo_finalizadora = linha[27:28]
    vista_prazo = linha[28:29]
    try:
        valor_finalizadora = float(linha[29:39] + '.' + linha[39:41])
    except:
        valor_finalizadora = False
    conta_caixa_creditar = linha[41:56]
    conta_caixa_debitar = linha[56:71]
    conta_taxa_adm = linha[71:86]
    valor_taxa_adm = linha[86:98]
    cliente_adm = linha[98:103]
    valor_bruto = linha[103:115]
    try:
        descontos = float(linha[115:125] + '.' + linha[125:127])
    except:
        descontos = False
    conta_descontos = linha[127:142]
    try:
        acrescimos = float(linha[142:152] + '.' + linha[152:154])
    except:
        acrescimos = False
    conta_acrescimos = linha[154:169]
    try:
        troco = float(linha[169:179] + '.' + linha[179:181])
    except:
        troco = False
    conta_troco = linha[181:196]

    vals = {
        'supfec_capa_id': capa_id,
        'supfec_sequencia': sequencia_fechamento,
        'supfec_finalizadora': finalizadora,
        'supfec_tipo_finalizadora': tipo_finalizadora,
        'supfec_valor': valor_finalizadora,
        'supfec_troco': troco,
        'supfec_desconto_proporcional': descontos,
        'supfec_acrescimo_proporcional': acrescimos,
    }

    fechamento_id = sock.execute(db, uid, pwd, 'supervisor.mov.fechamentos', 'create', vals)
    return fechamento_id

def cupom_xz_4(linha, fechamento_id):
    try:
        sequencia_vencimento = int(linha[24:26])
    except:
        sequencia_vencimento = False
    try:
        valor_parcela = float(linha[26:36] + '.' + linha[36:38])
    except:
        valor_parcela = False
    vencimento = linha[38:46]
    ano = vencimento[:4]
    mes = vencimento[4:6]
    dia = vencimento[6:8]
    data = ano + '-' + mes + '-' + dia

    vals = {
        'supfve_fechamentos_id': fechamento_id,
        'supfve_sequencia_vencimento': sequencia_vencimento,
        'supfve_valor_parcela': valor_parcela,
        'supfve_vencimento': data,
    }

    sock.execute(db, uid, pwd, 'supervisor.mov.vencimentos', 'create', vals)

try:
    arq_configuracao = '../objetos/sigerp.cfg'
    arquivo = csv.DictReader(open(arq_configuracao))
    for a in arquivo:
        hostname = a['hostname']
        username = a['username']
        pwd = a['password']
        db = a['database']
        porta = a['porta']
except:
    print 'Digite dados para coneccao no SigERP!'
    hostname = raw_input('Hostname: ')
    username = raw_input('Usuário: ')
    pwd = raw_input('Senha: ')
    db = raw_input('Banco: ')
    porta = raw_input('porta: ')

sock_common = xmlrpclib.ServerProxy ( 'http://'+hostname+':'+ str(porta) +'/xmlrpc/common' )
socket.setdefaulttimeout(3)
uid = sock_common.login( db, username, pwd )
sock = xmlrpclib.ServerProxy( 'http://'+hostname+':'+ str(porta) +'/xmlrpc/object' )
try:
    ids = sock.execute(db, uid, pwd, 'res.company', 'search', [])
except Exception as err:
    print 'Nao consegui conectar!'
    print str(err)
    exit()

try:
    caminho_arquivo = raw_input('Digite o caminho completo do arquivo: ')
    arquivo = open(caminho_arquivo,'r')
    conteudo_arquivo = arquivo.readlines()
    sequencia_fechamento = 1
    for i in conteudo_arquivo:
        if i[:2] == 'CC':
            capa_id = cupom_capa(i)
            sequencia_fechamento = 1
        elif i[:2] == 'CI':
            cupom_itens(i, capa_id)
            sequencia_fechamento = 1
        elif i[:2] == 'CF':
            fechamento_id = cupom_fechamento(i, capa_id)
            sequencia_fechamento = 1
        elif i[:2] == 'CV':
            cupom_vencimentos(i, fechamento_id)
            sequencia_fechamento = 1
        elif i[:2] == 'CZ':
            tipo = i[23:24]
            if tipo == '1':
                cupom_xz_1(i, capa_id)
                sequencia_fechamento = 1
            elif tipo == '2':
                cupom_xz_2(i, capa_id)
                sequencia_fechamento = 1
            elif tipo == '3':
                fechamento_id = cupom_xz_3(i, capa_id, sequencia_fechamento)
                sequencia_fechamento += 1
            elif tipo == '4':
                cupom_xz_4(i, fechamento_id)
                sequencia_fechamento = 1

    arquivo.close()
    print 'Importacao finalizada com sucesso'
except:
    print 'Erro durante importacao'
