#!/usr/bin/python
# -*- coding: utf-8 -*-
idPrograma='integra.py'
idVersao='Versao 1.01 de 13/05/2013'
idObs='Copyrigth by Sig Informatica Ltda'
"""
Programa para exportacao de dados do Sig Cobol(Contabilidade) para o SigERP
Este programa deve estar na pasta objetos, juntamente com o arquivo de configuracao sigerp.cfg
Este programa e chamado direto do programa cobol

Estrutura do sigerp.cfg
hostname,username,password,database,dbhostname,dbuser,dbpasswd
localhost,admin,admin,teste,localhost,luiz,admin
"""
diretorio = './'
i = 0
import sys, os, re
import xmlrpclib, socket
import csv
from SigUtils import datas, geralogs, numero
import psycopg2
import psycopg2.extras
import psutil

j = 0
lista = []
encerrar = 'N'
try:
    for proc in psutil.process_iter():
        for cmd in proc.cmdline:
            if 'integra.py' in cmd:
                if proc.cmdline[1] == '../objetos/integra.py':
                    j += 1
                    arquivo = proc.cmdline[2]
                    if j > 1:
                       encerrar = 'S'
                    lista.append(arquivo)
except:
    pass
if encerrar == 'S':
    exit()

def gravarLog(texto):
    geralogs.geraLogs('integra.log',  texto, 'S', '../arquivos/logs/')

try:
    arq_configuracao='../objetos/sigerp.cfg'
    arquivo=csv.DictReader(open(arq_configuracao))
    for a in arquivo:
        hostname = a['hostname']
        username = a['username']
        pwd = a['password']
        porta = a['porta']
        db = a['database']
        dbhostname = a['dbhostname']
        dbuser = a['dbuser']
        dbpasswd = a['dbpasswd']
except:
    gravarLog('Erro identificando parametros - sigerp.cfg')

sock_common = xmlrpclib.ServerProxy ( 'http://'+hostname+':'+porta+'/xmlrpc/common' )
socket.setdefaulttimeout(3)
uid = sock_common.login( db, username, pwd )
sock = xmlrpclib.ServerProxy( 'http://'+hostname+':'+porta+'/xmlrpc/object' )

_stringConeccao = ("dbname='" +db
                        +"' user='"+dbuser
                        +"' host='"+dbhostname
                        +"' password='"+dbpasswd
                        +"' connect_timeout='%d" % 3 + "'")
conn = psycopg2.connect(_stringConeccao)
cr=conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
cr_log=conn.cursor(cursor_factory=psycopg2.extras.DictCursor)

def inserirSQL(cr, tabela, dados):
    _cr = cr
    if uid:
        dados['create_uid'] = uid
    elif 'create_uid' in dados:
        del dados['create_uid']
    dados['create_date'] = datas.hoje_I
    _qtdCampos=len(dados)
    _txt1='('
    _txt3="("
    for x in dados.keys():
        _txt1 +=x +', '
        _txt3 +="'"+str(dados[x]).replace('\n', '') + "', "
    _txt1 = _txt1[:-2]+')'
    _txt3 = _txt3[:-2]+")"
    _txt2 = "'%s',"*_qtdCampos
    _txt2 = "("+_txt2[:-1]+")"
    _sql = "insert into "+tabela+" "+_txt1+" values "+_txt2+" returning id"
    _sql = _sql % eval(_txt3)
    try:
       cr.execute(_sql)
    except Exception as e:
         cr.connection.rollback()
         gravarLog('Erro insert: tabela '+tabela+ '  sql:'+ _sql + '   Erro: '+str(e))
    return cr.fetchone()[0]
try:
    lista=os.listdir(diretorio+'int')
    lista.sort()
except Exception as e:
    gravarLog('Diretorio inexistente!' + str(e))
    exit()
try:
    for arq in lista:
      empresa = arq[24:27]
      _operacao = arq[28:].upper()
      try:
         file=open('int/'+arq, 'r')
         _arquivoLido = arq[:5]
         registros=file.readlines()
      except:
         continue
      _dataArquivo = arq[6:14]
      _horaArquivo = arq[15:19]
      if _operacao == 'X': # Opderacao = 'x' eh qdo eh gerado o arquivo inteiro
         _operacao='W'
      os.system('rm -rf ' + diretorio+'int/'+arq)
      for registro in registros:
          registro = unicode(registro, 'utf-8', errors='ignore')
          res = False
          vals = {
              'lelg_empresa_legado': empresa,
              'lelg_conteudo': registro,
              'lelg_data': _dataArquivo,
              'lelg_hora': _horaArquivo[0:2] + ':' + _horaArquivo[2:],
              'lelg_arquivo_legado': _arquivoLido,
              'lelg_operacao': _operacao,
              'lelg_erro_registro': False,
          }
          inserirSQL(cr, 'legado_logs', vals)
          cr_log.connection.commit()
except Exception as e:
   gravarLog('Erro Carregando arquivos.    Erro: '+str(e))

