#!/usr/bin/python
# -*- coding: utf-8 -*-
idPrograma = 'sis2ope.py'
idVersao = 'Versao 1.01 de 20/07/2011'
idObs = 'Copyrigth by Sig Informatica Ltda'
"""
Programa para exportacao de dados do Sig Cobol(estoque) para o SigERP
Este programa deve estar na pasta objetos, juntamente com o arquivo de configuracao sigerp.cfg
Este programa e chamado direto do programa cobol

Estrutura do sigerp.cfg
hostname,username,password,database,dbhostname,dbuser,dbpasswd
localhost,admin,admin,teste,localhost,luiz,admin

"""

import sys, os
import xmlrpclib, socket
import csv
from SigUtils import datas, geralogs, numero
import psycopg2
import psycopg2.extras
diretorio = './'

def gravarLog(texto, linha=''):
    _arq = _dados = ''
    try:
        _arq = arq
    except:
        pass
    try:
        _dados = registro
    except:
        pass
    if not linha:
        linha = _dados
    try:
        _sql = ("select * from legado_logs where lelg_arquivo = '%s' and lelg_data = '%s' and lelg_hora = '%s'" %
                (str(_arq), str(datas.getDataDeHoje('I','-')), str(datas.getDataDeHoje('H')[:5])))
        cr_log.execute(_sql)
        _registros = cr_log.fetchall()
        if _registros:
            _log_id = _registros[0]['id']
            _sql = "update legado_logs set  lelg_empresa_legado = _'%s', lelg_arquivo = '%s', lelg_erro = '%s', lelg_conteudo = '%s', lelg_data = '%s', "
            _sql += "lelg_hora = '%s', lelg_arquivo_legado = '%s',active = %s"
            _sql = _sql % (str(_arq[-5:-2]), str(_arq),str(texto).replace("'",""), str(linha).replace("'",""), str(datas.getDataDeHoje('I','-')), str(datas.getDataDeHoje('H')[:5]), str(_arq[:5]), True)
            _sql += ' where id = ' + str(_log_id)
            cr_log.execute(_sql)
        else:
            _sql = 'insert into legado_logs (lelg_empresa_legado, lelg_arquivo, lelg_erro, lelg_conteudo, lelg_data, lelg_hora, lelg_arquivo_legado, active)'
            _sql += " values ('%s','%s','%s','%s','%s','%s','%s','%s') "
            _sql = _sql % (str(_arq[-5:-2]), str(_arq),str(texto).replace("'", ""), str(linha).replace("'",""), str(datas.getDataDeHoje('I','-')), str(datas.getDataDeHoje('H')[:5]), str(_arq[:5]), True)
            cr_log.execute(_sql)
        cr_log.connection.commit()
    except Exception as e:
        cr_log.connection.rollback()
        geralogs.geraLogs('sis2ope.log', 'Nao consegui gerar o legado_log.   sql:' + str(_sql) +'   Erro:' + str(e), 'S', '../arquivos/logs/')
        if _arq:
            geralogs.geraLogs('sis2ope.log', _arq +  texto, 'S', '../arquivos/logs/')
        else:
            geralogs.geraLogs('sis2ope.log',  texto, 'S', '../arquivos/logs/')

try:
    arq_configuracao = '../objetos/sigerp.cfg'
    arquivo = csv.DictReader(open(arq_configuracao))
    for a in arquivo:
        hostname = a['hostname']
        username = a['username']
        pwd = a['password']
        porta = a['porta']
        db = a['database']
        dbhostname = a['dbhostname']
        dbuser = a['dbuser']
        dbpasswd = a['dbpasswd']
except:
    gravarLog('Erro identificando parametros - sigerp.cfg')

sock_common = xmlrpclib.ServerProxy ( 'http://'+hostname+':'+porta+'/xmlrpc/common' )
socket.setdefaulttimeout(3)
uid = sock_common.login( db, username, pwd )
sock = xmlrpclib.ServerProxy( 'http://'+hostname+':'+porta+'/xmlrpc/object' )

_stringConeccao = ("dbname='" +db
                        +"' user='"+dbuser
                        +"' host='"+dbhostname
                        +"' password='"+dbpasswd
                        +"' connect_timeout='%d" % 3 + "'")
conn = psycopg2.connect(_stringConeccao)
cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
cr_log=conn.cursor(cursor_factory=psycopg2.extras.DictCursor)

class contarRegistros(object):
    def __init__(self, _registros):
        self.regLido = 0
        self.regTotal = len(_registros)
        self.regPasso = int(self.regTotal / 100)
        if self.regPasso > 100:
            self.regPasso = 100
        if self.regPasso == 0:
            self.regPasso = 1
    def contar(self, _oper = 'x'):
        self.regLido += 1
        _inteiro, _resto = divmod(self.regLido, self.regPasso)
        if _resto == 0:
#            if _oper == 'x':
#                print(str(self.regTotal) + '/' + str(self.regLido))
            return True
        return False

def inserirSQL(cursor, tabela, dados):
    _cursor = cursor
    _qtdCampos = len(dados)
    _txt1 = '('
    _txt3 = "("
    for x in dados.keys():
        _txt1 += x + ', '
        _txt3 += "'" + str(dados[x]) + "', "
    _txt1 = _txt1[:-2]+')'
    _txt3 = _txt3[:-2]+")"
    _txt2 = "'%s',"*_qtdCampos
    _txt2 = "(" + _txt2[:-1] + ")"
    _sql = "insert into " + tabela + " " + _txt1 + " values " + _txt2 + " returning id"
    _sql = _sql % eval(_txt3)
    try:
       cursor.execute(_sql)
    except Exception as e:
        cr.connection.rollback()
        gravarLog('Erro insert: tabela '+tabela+ '  sql:'+ _sql+ '  Erro:' + str(e))
    return cursor.fetchone()[0]

def deletarSQL(cursor, tabela, where):
    _cursor = cursor
    _sql = 'delete from '+tabela+' where '+where
    try:
        cursor.execute(_sql)
    except Exception as err:
        gravarLog('Erro delete: tabela ' + tabela + '  sql:'+ _sql + '   Erro:' + str(err))
        return False
    return True

def alterarSQL(cursor, tabela, _id, dados): # _id pode ser um _id ou uma lista para clausula where
    _cursor = cursor
    dados['write_uid'] = str(uid)
    dados['write_date'] = datas.hoje_I
    _qtdCampos = len(dados)
    _txt = ''
    for x in dados.keys():
        if str(dados[x])[:1] == '!':
            _txt += x + " = " + str(dados[x])[1:] + ","
        else:
            _txt += x + " = '" + str(dados[x]) + "',"
    if _txt[-1:] == ',':
        _txt = _txt[:-1]
    if str(type(_id)) == "<type 'list'>":
        _sql = "update " + tabela + " set " + _txt + " where "
        for a in _id:# lista para where
            _sql += a +" and "
        if _sql[-5:] == ' and ':
            _sql = _sql[:-5]
    else:
        _sql = "update "+tabela+" set "+_txt+" where id = "+str(_id)
    try:
        cursor.execute(_sql)
    except Exception as e:
        gravarLog('Erro update - sql:'+ _sql + '   Erro:' + str(e))
        return False
    return True

def lerLegado(cr, empresa_legado, chave_legado, tabela):
    _sql = "select chave_sigerp from legado_controle where empresa = '%s' and chave_legado = '%s' and tabela_legado = '%s'" % (empresa_legado, chave_legado, tabela)
    cr.execute(_sql)
    _regLegado = cr.fetchall()
    result = []
    if _regLegado:
        for x in _regLegado:
            result.append(x['chave_sigerp'])
    return result

def lerSQL(cr, tabela, where=[], campos = [], order = []):
    """
    parametros:
      cr -> cursor
      tabela -> nome da tabela
      where -> clausula where pronta exemplo: ["codigo = 'teste'","name = 'luiz'"]
      campos -> campos a serem lidos, exemplo: ['codigo, nome']
      order -> ordem a ser retornada, exemplo: ['campo, desc']
    """
    _sql = "select "
    if campos:
        for a in campos:
            _sql += a + ','
        _sql = _sql[:-1]+ ' '
    else:
        _sql += '* '
    _sql += 'from '+ tabela + ' '
    if where:
        _sql += 'where '
        for a in where:
            _sql += a +" and "
        if _sql[-5:] == ' and ':
            _sql = _sql[:-5]
    if order:
        _sql += " order by " + order[0]
        if len(order) == 2:
            _sql += ' ' + order[1]
    cr.execute(_sql)
    _registros = cr.fetchall()
    #if not _registros:
    #    print _sql
    return _registros

def gerarSis09(empresa_legado,company_id, operacao, dados):
    try:
        listaDados = dados.replace('#',' ').split('*|*')
        _nroBanco = listaDados[0]
        _nome = listaDados[1].strip()
        _chave = _nroBanco
        _regBanco = lerSQL(cr, 'adm_banco', ["admbco_codigo_bc = %s" % _chave])
        if not _regBanco:
            partner_id = inserirSQL(cr, 'res_partner', {'name': _nome,'notification_email_send':'comment'})
            vals = {'nome':_nome,'pessoa_tipo':'J', 'active' : True, 'admpes_jur_tipo_empresa' : 'B', 'admpes_jur_tipo_atividade' : 'F', 'partner_id':partner_id}
            regCodigo = lerSQL(cr, 'ir_sequence', ["code = 'pessoa.codigo'"])
            vals['codigo'] = regCodigo[0]['number_next']
            codigo = int(regCodigo[0]['number_next']) + 1
            alterarSQL(cr, 'ir_sequence', str(regCodigo[0]['id']), {'number_next':codigo})
            _pessoa_id = inserirSQL(cr, 'adm_pessoa', vals)
        else:
            _pessoa_id = _regBanco[0]['admbco_pessoa_id']
        valsBanco = {
                'admbco_pessoa_id' : _pessoa_id,
                'admbco_codigo_bc' : _nroBanco,
        }
        if operacao == 'w': #Gravar e alterar
            if _regBanco:
                return True
            if _nroBanco == '000':
                return True
            idBanco = inserirSQL(cr, 'adm_banco', valsBanco)
            valsLocal = {
                 'pessoa_id' : _pessoa_id,
                 'tipo' : 'B',
                 'descricao' : _nome,
                 'active' : True,
                 }
            idLocal = inserirSQL(cr, 'financeiro_local_cobranca', valsLocal)
            return True
    except Exception as e:
        gravarLog('Sis09:Qtd Elementos:'+str(len(listaDados))+ '  Lista:'+ str(listaDados) + '   Erro:' + str(e), dados)
        return False

def gerarSis26(empresa_legado,company_id, operacao, dados, ultimo_cfop):
    try:
        listaDados = dados.replace('#',' ').split('*|*')
        _cfop = listaDados[0]
        if _cfop[:1] == '0':
            return False, False
        _natureza = listaDados[1].strip()
        _descricao = listaDados[2].strip()
        _entrada_saida = listaDados[3]
        _analitica_sintetica = listaDados[4]
        _tipo_movimento = listaDados[5]
        if _tipo_movimento == 'A':
            _tipo_movimento = 'C'
        else:
            if _tipo_movimento == 'B':
                _tipo_movimento = 'T'
            else:
                if _tipo_movimento == 'C':
                    _tipo_movimento = 'D'
                else:
                    _tipo_movimento = 'U'
        _tipo_transacao = listaDados[6]
        if _tipo_transacao in ('C', 'I', 'M', 'S', 'O'):
            pass
        else:
            _tipo_transacao = 'C'
        # ver se tem
        _sql = ("select id from fiscal_cfop where codigo = '%s'" % _cfop)
        cr.execute(_sql)
        _regCfop = cr.fetchone()
        if _regCfop:
            return True, _regCfop[0]
        _ultimo_sintetico = False
        vals = {
                'descricao': _descricao,
                'tipo' : _entrada_saida,
                'analitico_sintetico' : _analitica_sintetica,
                'movimento_tipo' : _tipo_movimento,
                'transacao_tipo' : _tipo_transacao,
                'codigo' : _cfop,
                'produto_servico_tipo': 'P',
                }
        if operacao == 'w': #Gravar
            if _analitica_sintetica == 'A':
                vals['parent_id'] = ultimo_cfop
            _cfop_id = inserirSQL(cr, 'fiscal_cfop', vals)
            _ultimo_sintetico = _cfop_id
        return True, _ultimo_sintetico

    except Exception as e:
        gravarLog('Sis26:Qtd Elementos:'+str(len(listaDados))+ '  Lista:'+ str(listaDados) + '   Erro:' + str(e), dados)
        return False
try:
    arquivo = sys.argv[1]
except:
    gravarLog('Arquivo a integrar nao informado!')
    exit()
lista=[]
if arquivo == 'todos':
    novaLista = []
    try:
        lista=os.listdir(diretorio+'int')
        for linha in lista:
            if linha[-1:] == '\n':
                linha = linha[:-1]
            if linha[:3] != 'sis':
                continue
            novaLista.append(linha[6:]+linha[:6])
        novaLista.sort()
        lista = []
        for linha in novaLista:
            lista.append(linha[-6:]+linha[:-6])
    except Exception as e:
        gravarLog('Diretorio inexistente!')
        exit()
else:
    try:
        lista=os.listdir(diretorio+'int')
        lista.sort()
    except Exception as e:
        gravarLog('Diretorio inexistente!')
        exit()

try:
    for arq in lista:
        if arquivo != 'todos':
            if arq[:5]!=arquivo:
                continue
        empresa = arq[24:27]
        _operacao = arq[28:].lower()
        try:
            args = [('empresa_legado', '=', empresa), ('tipo', '=', 'C')]
            company_id_c =  sock.execute(db, uid, pwd, 'legado.empresa', 'ler', args)[0]['company_id'][0]
            args = [('empresa_legado', '=', empresa), ('tipo', '=', 'S')]
            company_id_s =  sock.execute(db, uid, pwd, 'legado.empresa', 'ler', args)[0]['company_id'][0]
        except:
            gravarLog('Empresa nao cadastrada!' + str(empresa) + '-' + str(args))
            continue
        _arquivo = open('int/' + arq, 'r')
        _arquivoLido = arq[:5]
        registros = _arquivo.readlines()
        _horaArquivo = int(arq[15:23])
        contador = contarRegistros(registros)
        if _operacao == 'x': # Opderacao = 'x' eh qdo eh gerado o arquivo inteiro
            operacao = 'w'
        else:
            operacao = _operacao
        _ultimo_cfop = False
        if _operacao == 'x': # Remover arquivo porque já foi lido e contem varios registros
            os.system('rm -rf ' + diretorio+'int/'+arq)
        for registro in registros:
            registro = unicode(registro, 'utf-8', errors='ignore')
            res = False
            if _arquivoLido == 'sis09':   # Bancos
                res = gerarSis09(empresa, company_id_c, operacao, registro)
            if _arquivoLido == 'sis26':   # CFOPs
                res, cfop = gerarSis26(empresa, company_id_c, operacao, registro, _ultimo_cfop)
                _ultimo_cfop = cfop
            if contador.contar(_operacao):
                cr.connection.commit()
            if res and _operacao != 'x': # Registro importado de arquivo com um registro, remover arquivo
                os.system('rm -rf ' + diretorio+'int/'+arq)
                deletarSQL(cr_log, 'legado_logs',  "lelg_arquivo = '%s'" % arq)
                cr_log.connection.commit()
            if not res and _operacao == 'x': # Erro na importacao de registro de arquivo com varios registros, gerar registro individual para importacao futura
                _horaArquivo += 1
                arqNovo = diretorio+'int/'+arq[:15]+numero.getNumToStr(_horaArquivo,8,0,'N')+arq[23:28]+'W'
                fileNovo=open(arqNovo, 'w')
                fileNovo.write(registro)
                fileNovo.close()
        cr.connection.commit()
except Exception as e:
    gravarLog('Erro Carregando arquivos   Erro:' + str(e))

