#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _
# noinspection PyUnresolvedReferences
from openerp.addons.kit.model.funcoes import get_preco_total_venda_itens_kit

LOAD = '_classic_write'


class kit_util(osv.Model):

    _name = 'kit.util'
    _auto = False

    def kitutl_inserir_produtos(self, cr, uid, kit_movimento_ids, add_to_kitmov_vals=None,
                                context=None):
        context = context and context.copy() or {}
        if not isinstance(add_to_kitmov_vals, dict):
            add_to_kitmov_vals = {}

        obj_kit_mov = self.pool.get('kit.movimento')
        obj_kit_produto = self.pool.get('kit.produto')
        obj_local_locacao = self.pool.get('estoque.local.locacao')
        obj_estoque_local = self.pool.get('estoque.local')
        obj_estoque_produto = self.pool.get('estoque.produto')

        # LOCAL DE VENDA PADRAO
        parametro_dados = self.pool.get('estoque.parametro').estpar_get_fields(
            cr, uid, fields_to_read=['local_venda_padrao_id']
        )
        if isinstance(parametro_dados, list):
            parametro_dados = parametro_dados[0]
        local_padrao_id = parametro_dados['local_venda_padrao_id']
        if not local_padrao_id:
            raise osv.except_osv(_('Atencao'), _('"local para saidas" não cadastrado nos '
                                                 'parametros do estoque'))

        kit_mov_ids = obj_kit_mov.search(cr, uid, [('id', 'in', kit_movimento_ids),
                                                   ('kitmov_lancado', '=', False)], context=context)

        if not kit_mov_ids:
            raise osv.except_osv('Atencao', 'Os Itens que compoem o kit ja foram lancados!')

        # KIT DE PRODUTOS LANCADOS NA NF
        kit_mov_dados = obj_kit_mov.read(cr, uid, kit_mov_ids, ['kitmov_produto_id',
                                              'kitmov_quantidade'], context=context, load=LOAD)
        produto_kit_ids = list(set(filter(None, map(lambda i: i.get('kitmov_produto_id'),
                                                              kit_mov_dados))))
        produto_kit_names = self.pool.get('estoque.produto').name_get(cr, uid, produto_kit_ids,
                                                                      context)
        if produto_kit_names:
            dict_kit_name = dict(produto_kit_names)
        else:
            dict_kit_name = {}

        list_vals = []
        for kit in kit_mov_dados:
            kit_mov_id = kit['id']
            kit_mov_quantidade = kit.get('kitmov_quantidade')
            # KIT ESCOLHIDO NO MOVIMENTO
            kit_produto_id = kit.get('kitmov_produto_id')
            if not kit_produto_id:
                continue

            dados_produto = obj_estoque_produto.read(cr, uid, kit_produto_id, ['name', 'preco_kit'],
                                                     context=context )
            produto_name = dados_produto.get('name')
            local_name = obj_estoque_local.browse(cr, uid, local_padrao_id).name
            locacao_ids = obj_local_locacao.search(
                cr, uid, [('produto_id', '=', kit_produto_id),
                          ('local_id', '=', local_padrao_id)], context=context)
            if not locacao_ids:
                raise osv.except_osv(_('Atencao'),
                                     _('Nao ha cadastro de locacao para o produto %s - Local: '
                                       '%s.' % (produto_name, local_name)))
            kit_embalagem_id = obj_local_locacao.browse(
                cr, uid, locacao_ids[0]).estllc_produto_embalagem_id
            if not kit_embalagem_id:
                raise osv.except_osv(_('Atencao'),
                                     _('Nao ha cadastro de embalagem para o produto %s - Local: '
                                       '%s.' % (produto_name, local_name)))
            fracionado = kit_embalagem_id.embalagem_id.unidade_id.fracao or False

            kit_name = dict_kit_name.get(kit_produto_id) or '** Nome do Kit nao encontrado **'
            if not fracionado and kit_mov_quantidade != int(kit_mov_quantidade):
                raise osv.except_osv(_('Atencao'),
                                     _('A embalagem definida para o produto kit: %s, no local: '
                                       '%s, nao permite fracionamento' % (kit_name,
                                                                          local_name)))


            # PESQUISA OS ITENS QUE COMPOEM O KIT
            kit_produto_ids = obj_kit_produto.search(cr, uid,
                                  [('kitpro_produto_id', '=', kit_produto_id)], context=context)

            if not kit_produto_ids:
                raise osv.except_osv(_('Atencao!'),
                                     _('O kit %s nao possui nenhum item cadastrado!') %
                                       kit_name)

            fields_to_read = ['kitpro_item_produto_id', 'kitpro_grade_id', 'kitpro_quantidade',
                              'kitpro_produto_id', 'kitpro_preco_venda',
                              'kitpro_produto_embalagem_id']
            kit_produto_dados = obj_kit_produto.read(cr, uid, kit_produto_ids, fields_to_read,
                                                     context=context, load=LOAD)

            itens_kit = []
            kit_produto_ids = map(lambda x: x.get('kitpro_item_produto_id'), kit_produto_dados)
            kit_grade_ids = map(lambda x: x.get('kitpro_grade_id'), kit_produto_dados)
            qtd_emb = self.pool.get('estoque.utils').get_grade_qtd_embalagem(cr, kit_grade_ids,
                                                                             context=context)
            obj_preco_venda = self.pool.get('estoque.preco.venda')
            preco_kits_itens = obj_preco_venda.get_preco_venda(cr, uid, kit_produto_ids,
                                                               context=context)
            args_local_local = [('produto_id', 'in', kit_produto_ids),
                                ('grade_id', 'in', kit_grade_ids),
                                ('local_id', '=', local_padrao_id)]
            locacao_ids = obj_local_locacao.search(cr, uid, args_local_local, context=context)
            if not locacao_ids:
                raise osv.except_osv('Atencao', 'Sem locacao na grade do produto!')

            # PRODUTO, GRADE E QUANTIDADE INSERIDAS NO KIT
            msg = []
            msg_preco = []
            kits = {}
            for i in kit_produto_dados:
                if not kits.get(i.get('kitpro_produto_id')):
                    kits[i.get('kitpro_produto_id')] = [i.get('id')]
                else:
                    kits[i.get('kitpro_produto_id')].append(i.get('id'))


            preco_total_itens = {}
            for kit_id in kits:
                preco_total_itens = get_preco_total_venda_itens_kit(self, cr, uid, kits.get(kit_id),
                                                         context=context)

            for item in kit_produto_dados:
                kitpro_quantidade = item.get('kitpro_quantidade')
                grade_id = item['kitpro_grade_id']
                quantidade = kitpro_quantidade * kit_mov_quantidade
                preco_venda = preco_total_itens.get(item.get('id'))
                produto_do_kit_id = item.get('kitpro_item_produto_id')
                if not preco_venda:
                    dados = self.pool.get('estoque.produto').read(cr, uid, produto_do_kit_id,
                                                    ['name', 'codigo'], context=context)
                    msg_preco.append('%s - %s' % (dados.get('codigo'), dados.get('name')))
                    continue
                produto_embalagem_id = item.get('kitpro_produto_embalagem_id')
                chave_emb = '%s-%s' % (grade_id, produto_embalagem_id)
                if not qtd_emb.get(chave_emb):
                    dados = self.pool.get('estoque.produto').read(cr, uid, produto_do_kit_id,
                                                    ['name', 'codigo'], context=context)
                    msg.append('%s - %s' % (dados.get('codigo'), dados.get('name')))
                    continue

                if msg:
                    continue

                embalagem_quantidade = qtd_emb.get(chave_emb).get('qtd')
                vr_unitario = preco_kits_itens.get(produto_do_kit_id).get('preco_venda') * \
                              embalagem_quantidade

                total = vr_unitario * quantidade
                desconto = total - (preco_venda * kit_mov_quantidade)
                if desconto < 0:
                    raise osv.except_osv(_('Atencao!'),
                                         _('A soma dos precos dos itens devem ser maior que o preco'
                                           ' do kit'))

                embalagem_aceita_fracao = qtd_emb.get(chave_emb).get('fracao')
                if quantidade - int(quantidade) and not embalagem_aceita_fracao:
                    produto = self.pool.get('estoque.produto').read(cr, uid, produto_do_kit_id,
                                                                    ['id'], context=context)
                    raise osv.except_osv(_('Atencao!'),
                                         _('A embalagem do produto %s nao aceita quantidade '
                                           'fracionada') % produto[1])

                vals = {
                    'local_id': local_padrao_id or None,
                    'produto_id': produto_do_kit_id or None,
                    'grade_id': grade_id or None,
                    'produto_embalagem_id': produto_embalagem_id or None,
                    'quantidade': quantidade or 0,
                    'qtd_emb': embalagem_quantidade, # usado apenas para nota fiscal
                    'desconto': desconto,
                    'valor_unitario': vr_unitario or 0,
                    'valor_preco_venda': vr_unitario or 0,
                    'kit_mov_id': kit_mov_id or None,
                    'estmvi_kit_produto_id': kit_produto_id or False,
                    'kitpro_quantidade': quantidade,
                    'kitpro_grade_id': (grade_id, False),
                    'kitpro_item_produto_id': (produto_do_kit_id, False),
                }
                if vals:
                    vals.update(add_to_kitmov_vals)

                itens_kit.append([0,0, vals])

            if msg:
                raise osv.except_osv(_('Atencao!'),
                                     _('Os itens do kit %s nao possuem embalagem informada no kit: \n%s') %
                                     (kit_name, '\n'.join(msg)))
            if msg_preco:
                raise osv.except_osv(_('Atencao!'),
                                     _('Os itens nao possuem preco total no kit:\n %s') %
                                        '\n'.join(msg_preco))

            list_vals.extend(itens_kit)

        return list_vals
