# -*- coding: utf-8 -*-

from openerp.osv import osv


class automacao_atualizar_precos_osv(osv.TransientModel):

    _inherit = "automacao.atualizar.precos.osv"

    def get_query_produto_dados(self, cr, uid, sql, context=None):
        """
        O metodo ajusta a query para a busca dos dados dos produtos. Essa sobreescricao eh baseada
        nas necessidades do modulo 'kit'.
        
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param sql: codigo SQL para busca dos produtos.
        :type sql: str
        :param context: dados contextuais.
        :type context: dict
        :return: codigo SQL
        :rtype: str
        """
        context = context and context.copy() or {}
        super(automacao_atualizar_precos_osv, self).get_query_produto_dados(cr, uid, sql, context)
        sql = sql.replace(
            'epv.create_date > ap.data_atualizacao OR ap.data_atualizacao IS NULL',
            """CASE WHEN ep.preco_kit != 'S' OR ep.preco_kit IS NULL
			        THEN epv.create_date > ap.data_atualizacao OR  ap.data_atualizacao IS NULL
			        ELSE ep.preco_kit = 'S'
		            END""")
        sql = sql.replace(
            'AND epv.create_date IS NOT NULL',
            "AND CASE WHEN ep.preco_kit != 'S' THEN epv.create_date IS NOT NULL ELSE TRUE END")

        return sql

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
