# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import estpro_verifica_cadastro_kit


class estoque_produto(osv.Model):

    _name = 'estoque.produto'
    _inherit = 'estoque.produto'
    _columns = {
        'kit_de_produtos': fields.boolean('Kit produtos', select=1, help="Indica que e um kit de mercadorias"),
        'preco_kit': fields.selection([('K', 'Preco no kit'), ('S', 'Soma dos Itens')], 'Preco kit', size=1),
        # Indica se o kit necessita de montagem previa
        'produto_kit_ids': fields.one2many('kit.produto', 'kitpro_produto_id', 'Produtos'),
        'tipo_kit': fields.selection([('I', 'Item')], 'Tipo do Kit', size=1),
        'estpro_cadastro_kit': fields.function(estpro_verifica_cadastro_kit, method=True,
                                               string='Cadastro de kit', type='boolean',
                                               store=False),
        # Kits aos quais o item esta contido.
        'estpro_contem_kit_ids': fields.one2many('kit.produto', 'kitpro_item_produto_id',
                                                 'Produtos'),
    }
    _defaults = {
        'kit_de_produtos': False,
        'tipo_kit': 'I'
    }
