# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
from ....fiscal.control.utils import log_debug

READ_LOAD = '_classic_write'


class fiscal_nf_capa(osv.Model):
    """
    Heranca da classe ´fiscal_nf_capa´.
    """

    _inherit = 'fiscal.nf.capa'

    def fisnfc_kit_inserir_itens(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]

        kits_lancados = []
        context.update({'kit_itens':True})

        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name,
                                                                    context=context)
        obj_kit_util = self.pool.get('kit.util')
        obj_kit_mov = self.pool.get('kit.movimento')
        obj_pessoa = self.pool.get('adm.pessoa')
        obj_fiscal_cfop_natureza = self.pool.get('fiscal.cfop.natureza')
        obj_fiscal_cfop = self.pool.get('fiscal.cfop')
        obj_fiscal_encargo = self.pool.get('fiscal.encargo')
        obj_fiscal_cfop_natureza_encargos = self.pool.get('fiscal.cfop.natureza.encargos')
        obj_adm_pessoa_endereco = self.pool.get('adm.pessoa.endereco')
        obj_estoque_produto = self.pool.get('estoque.produto')
        obj_estoque_movimento_itens = self.pool.get('estoque.movimento.itens')

        rescon_pessoa_id = self.pool.get('res.company').read(
            cr, uid, company_id, ['rescon_pessoa_id'], context, READ_LOAD).get(
            'rescon_pessoa_id')
        tipo_atividade = obj_pessoa.read(cr, uid, rescon_pessoa_id,
                                         ['admpes_jur_tipo_atividade'], context).get(
            'admpes_jur_tipo_atividade')

        # BUSCA OS ITEMS DO TIPO KIT QUE ESTAO LANCADOS NA NOTA FISCAL
        campos_nf = ['fisnfc_kit_item_ids', 'natureza_id', 'destinatario_id', 'company_id', 'tipo',
                     'destinatario_endereco_id', 'vr_desconto', 'vr_frete', 'vr_seguro',
                     'vr_seguro', 'vr_despesas_acessorias', 'fisnfc_vr_despesas_extras',
                     'vr_icms_frete', 'estoque_movimento_itens_ids', 'tipo_frete']
        nf_dados = self.read(cr, uid, ids, campos_nf, context=context, load=READ_LOAD)
        for nf in nf_dados:
            nf_id = nf['id']
            nf_kit_mov_ids = nf.get('fisnfc_kit_item_ids')

            if not nf_kit_mov_ids:
                raise osv.except_osv('Atencao', 'Nenhum Kit escolhido!')

            list_vals = obj_kit_util.kitutl_inserir_produtos(cr, uid,
                                                             kit_movimento_ids=nf_kit_mov_ids,
                                                             context=context)
            list_itens = []
            for vals in list_vals:
                local_id = vals[2].get('local_id')
                produto_id = vals[2].get('produto_id')
                grade_id = vals[2].get('grade_id')
                produto_embalagem_id = vals[2].get('produto_embalagem_id')
                quantidade = vals[2].get('quantidade')
                qtd_emb = vals[2].get('qtd_emb')
                valor_unitario = vals[2].get('valor_unitario') / qtd_emb
                valor_preco_venda = vals[2].get('valor_preco_venda') / qtd_emb
                desconto = vals[2].get('desconto')
                kit_mov_id = vals[2].get('kit_mov_id')
                estmvi_kit_produto_id = vals[2].get('estmvi_kit_produto_id')
                vals_mov_item = {
                    'local_id': local_id,
                    'produto_id': produto_id,
                    'grade_id': grade_id,
                    'produto_embalagem_id': produto_embalagem_id,
                    'quantidade': quantidade,
                    'vr_unitario': valor_unitario,
                    'vr_total_item': valor_unitario * quantidade - desconto,
                    'vr_preco_venda': valor_preco_venda,
                    'vr_desconto': desconto,
                    'estmvi_kit_mov_id': kit_mov_id,
                    'estmvi_kit_produto_id':estmvi_kit_produto_id
                }
                # --------------Tributacoes----------------
                campos = ['tipo', 'produto_grade_ids', 'grade_usar', 'origem_mercadoria']
                dados_produto = obj_estoque_produto.read(cr, uid, produto_id, campos, context)

                campos = ['cfop_id', 'natureza_encargos_ids', 'tipo', 'fisnat_icms_desonerado']
                dados_natureza = obj_fiscal_cfop_natureza.read(
                    cr, uid, nf.get('natureza_id'), campos, context, READ_LOAD)

                campos = ['movimento_tipo', 'codigo', 'sigla']
                dados_cfop_nat = obj_fiscal_cfop.read(
                    cr, uid, dados_natureza.get('cfop_id'), campos, context)

                campos = ['encargo_id', 'sobrepor_tributacao_id', 'fiscne_sobrepoe_so_tributados']
                dados_nat_encargo = obj_fiscal_cfop_natureza_encargos.read(
                    cr, uid, dados_natureza.get('natureza_encargos_ids'), campos, context,
                    READ_LOAD)
                encargo_ids = map(lambda x: x.get('encargo_id'), dados_nat_encargo)
                dict_encargos_nat = {}
                map(lambda x: dict_encargos_nat.update({x.get('id'): x}),
                    obj_fiscal_encargo.read(cr, uid, encargo_ids, ['sigla'], context))

                campos = ['cpf_cnpj', 'endereco_ids', 'admpes_jur_tipo_atividade']
                dados_destinatario = obj_pessoa.read(cr, uid, nf.get('destinatario_id'), campos,
                                                     context)

                dados_endereco = nf.get('destinatario_endereco_id') and obj_adm_pessoa_endereco.\
                    read(cr, uid, nf.get('destinatario_endereco_id'), ['uf_id'], context,
                         '_classic_write')
                uf_id = dados_endereco and dados_endereco.get('uf_id')

                tipo_tributacao = nf.get('destinatario_id') and obj_pessoa.\
                    admpes_get_tipo_consumidor(cr, uid, nf.get('destinatario_id'), context) or 'T'
                tipo_tributacao = 'T' if tipo_tributacao == 'F' else tipo_tributacao
                tipo_tributacao = 'E' if nf.get('tipo') != 'S' else tipo_tributacao

                tributacoes_ids = obj_estoque_movimento_itens.calcular_tributo_itens(
                    cr, uid, dados_produto, dados_natureza, dados_nat_encargo, dados_cfop_nat,
                    encargo_ids, dados_destinatario, tipo_tributacao, valor_unitario * quantidade,
                    uf_id=uf_id, context=context)
                cfop_id = obj_estoque_movimento_itens.estmvi_get_cfop_id(
                    cr, uid, produto_id, dados_produto.get('tipo'), nf.get('tipo'), dados_cfop_nat,
                    dados_nat_encargo, dict_encargos_nat, encargo_ids, dados_destinatario,
                    tipo_atividade, context)
                vals_mov_item.update({'cfop_id': cfop_id, 'tributacoes_ids': tributacoes_ids})
                # -------------------------------
                list_itens.append((0,0,vals_mov_item))
                if kit_mov_id:
                    kits_lancados.append(kit_mov_id)

            if not nf.get('estoque_movimento_itens_ids'):
                nf['estoque_movimento_itens_ids'] = list_itens
            else:
                nf['estoque_movimento_itens_ids'].extend(list_itens)
            nf['estoque_movimento_itens_ids'] = [
                (4, i, False) if not isinstance(i, (tuple, list)) else i
                for i in nf['estoque_movimento_itens_ids']]

            list_itens = self.calcula_rateio(
                        cr, uid, nf.get('vr_desconto', 0), nf.get('vr_frete', 0),
                        nf.get('vr_seguro', 0), nf.get('vr_despesas_acessorias', 0),
                        nf.get('fisnfc_vr_despesas_extras', 0), nf.get('vr_icms_frete', 0),
                        nf.get('natureza_id'),
                        [],
                        nf.get('estoque_movimento_itens_ids'), nf.get('tipo_frete'),
                        context=context)
            self.write(cr, uid, nf_id, {'estoque_movimento_itens_ids': list_itens}, context=context)

        if kits_lancados:
            context_kit_item = context.copy()
            context_kit_item['preenchendo_itens'] = True
            obj_kit_mov.write(cr, uid, list(set(kits_lancados)), {'kitmov_lancado': True},
                              context=context_kit_item)

        return True

    def ajusta_kits(self, cr, uid, vals, context=None):
        '''Corrige o campo 'fisnfc_kit_item_ids' ao fazer uma copia da nota'''
        context = context and context.copy() or {}
        super(fiscal_nf_capa, self).ajusta_kits(cr, uid, vals, context)
        if not vals.get('fisnfc_kit_item_ids'):
            return

        vals['fisnfc_kit_item_ids'] = []
        for i in vals.pop('fisnfc_kit_item_ids'):
            vals['fisnfc_kit_item_ids'] = [(4, i)]

    @log_debug
    def fisnfc_verificar_nota_fiscal(self, cr, user, nf, context=None):
        """
        Realiza a verificacao de uma nota fiscal.

        :param cr: o cursor do banco de dados
        :param user: ID do usuario utilizado para a verificacao de perfil
        :param nf: ID da nota fiscal
        :param context: um dicionario padrao para valores contextuais
        :type cr: object
        :type user: int
        :type nf: long
        :type context: dict
        :return: verdadeiro se a nota fiscal foi validada.
        :rtype: bool
        """
        context = context and context.copy() or {}

        # Verifica se existem produtos/itens do Kit que nao constam dos itens da nota fiscal
        if filter(lambda f: not f.kitmov_lancado, self.browse(
                cr, user, nf, context).fisnfc_kit_item_ids):
            raise osv.except_osv(_('Atencao!'),
                                 _('Existem produtos do Kit que ainda nao foram inseridos. Para '
                                   'inserir clique no botao "Inserir itens do KIT".'))

        return super(fiscal_nf_capa, self).fisnfc_verificar_nota_fiscal(cr, user, nf, context)

    def nfe_infnfe_det_infadprod(self, cr, user, item, context=None):
        """
        Acrescenta os numeros de serie aas informacoes adicionais do item.
        
        :param cr: cursor do banco de dados
        :param user: o ID do usuario utilizado para a verificacao de perfil
        :param item: o ID do item da nota fiscal
        :param context: um dicionario padrao para valores contextuais
        :type cr: object
        :type user: int
        :type item: long
        :type context: dict
        :return: lista com as informacoes adicionais do item.
        :rtype: list
        
        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """
        # //NFe.infNFe.det.infAdProd - Informacoes adicionais do produto
        result = super(fiscal_nf_capa, self).nfe_infnfe_det_infadprod(cr, user, item, context)
        brw_item = self.pool.get('estoque.movimento.itens').browse(cr, user, item, context)
        if brw_item.estmvi_kit_produto_id:
            result.append('Kit: %s' % brw_item.estmvi_kit_produto_id.name)

        return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
