#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields

READ_LOAD = '_classic_write'


class estoquepedidos_pedido_capa(osv.Model):

    _inherit = 'estoquepedidos.pedido.capa'
    _name = 'estoquepedidos.pedido.capa'
    _columns = {
        'pedido_kit_item_ids': fields.one2many('kit.movimento', 'kitmov_pedido_id', 'Kit por Itens')
    }

    def button_pedido_kit_inserir_itens(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]

        kits_lancados = []

        obj_kit_util = self.pool.get('kit.util')
        obj_kit_mov = self.pool.get('kit.movimento')

        obj_ped_item = self.pool.get('estoquepedidos.pedido.item')
        # BUSCA OS ITEMS DO TIPO KIT QUE ESTAO LANCADOS NO PEDIDO
        pedido_dados = self.read(cr, uid, ids, ['pedido_kit_item_ids'], context=context,
                                 load=READ_LOAD)
        for i in pedido_dados:
            pedido_id = i['id']
            pedido_kit_mov_ids = i.get('pedido_kit_item_ids')

            if not pedido_kit_mov_ids:
                raise osv.except_osv('Atencao', 'Nenhum Kit escolhido!')

            list_vals = obj_kit_util.kitutl_inserir_produtos(cr, uid,
                                                             kit_movimento_ids=pedido_kit_mov_ids,
                                                             context=context)
            list_itens = []
            for vals in list_vals:
                local_id = vals[2].get('local_id')
                produto_id = vals[2].get('produto_id')
                grade_id = vals[2].get('grade_id')
                produto_embalagem_id = vals[2].get('produto_embalagem_id')
                quantidade = vals[2].get('quantidade')
                valor_unitario = vals[2].get('valor_unitario')
                valor_preco_venda = vals[2].get('valor_preco_venda')
                desconto = vals[2].get('desconto')
                kit_mov_id = vals[2].get('kit_mov_id')
                pedite_kit_produto_id = vals[2].get('estmvi_kit_produto_id')
                vals_mov_item = {
                    'local_id': local_id,
                    'produto_id': produto_id,
                    'grade_id': grade_id,
                    'produto_embalagem_id': produto_embalagem_id,
                    'qtde_pedida': quantidade,
                    'vr_unitario': valor_unitario,
                    'pei_preco_venda': valor_preco_venda,
                    'vr_desconto': desconto,
                    'pedite_kit_mov_id': kit_mov_id,
                    'pedite_kit_produto_id': pedite_kit_produto_id
                }
                list_itens.append((0,0,vals_mov_item))
                if kit_mov_id:
                    kits_lancados.append(kit_mov_id)

            self.write(cr, uid, pedido_id, {'pedido_item_ids': list_itens}, context=context)

        if kits_lancados:
            context_kit_item = context.copy()
            context_kit_item['preenchendo_itens'] = True
            obj_kit_mov.write(cr, uid, kits_lancados, {'kitmov_lancado': True}, context=context_kit_item)

        # Atualiza os metodos funcionais
        self.write(cr, uid, ids, {}, context=context)
        return True




