# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class kit_movimento(osv.Model):

    _name = 'kit.movimento'
    _rec_name = 'kitmov_produto_id'
    _columns = {
        'kitmov_produto_id': fields.many2one(
            'estoque.produto', 'Produto', ondelete='cascade', required=True,
            domain="[('kit_de_produtos', '=', True), ('tipo_kit', '=', 'I')]"),
        'kitmov_orcamento_id': fields.many2one('orcamentos.orcamento.capa', 'Orcamento', ondelete='set null'),
        'kitmov_nf_id': fields.many2one('fiscal.nf.capa', 'Fiscal', ondelete='cascade'),
        'kitmov_quantidade': fields.float('Quantidade', digits=(9, 3), required=True),
        'kitmov_lancado': fields.boolean('Itens Lancados'),
        'kitmov_pedido_id': fields.many2one('estoquepedidos.pedido.capa', 'Pedido', ondelete='set null'),
    }
    _defaults = {
        'kitmov_quantidade': 1,
        'kitmov_lancado': False,
    }


