# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import get_kit_id_do_produto, get_kit_id_do_item_kit, get_kit_id_do_preco_venda, \
                    get_preco_venda_itens_kit, get_kit_id_do_embalagem

class kit_produto(osv.Model):
    """
    Tabela de kit de produtos(composicao)
    """

    _name = 'kit.produto'
    _rec_name = 'kitpro_produto_id'
    _columns = {
        'id': fields.integer('ID'),
        'kitpro_produto_id': fields.many2one('estoque.produto', 'Kit', select=True,
                                             oldname='produto_kit_id'),
        'kitpro_item_produto_id': fields.many2one('estoque.produto', 'Produto do Kit', select=True,
                                                  required=True, ondelete='cascade',
                                                  oldname='produto_id'),
        'kitpro_grade_id': fields.many2one('estoque.produto.grade', 'Grade', required=True,
                                           ondelete='cascade', oldname='grade_id',
                                           domain="[('produto_id', '=', kitpro_item_produto_id)]"),
        'kitpro_produto_embalagem_id': fields.many2one('estoque.produto.embalagem', 'Embalagem',
                                                       required=True, ondelete='cascade',
                                                       select=True,
                                                       domain="[('produto_id', '=', kitpro_item_produto_id)]"),
        'kitpro_quantidade': fields.float('Quantidade', digits=(9, 3), required=True,
                                          oldname='quantidade'),
        'kitpro_preco_venda': fields.function(get_preco_venda_itens_kit, method=True,
                                              string="Preco (Total)",
                                      store={'estoque.produto': (get_kit_id_do_produto,
                                                                 ['preco_kit'], 10),
                                             'estoque.preco.venda': (get_kit_id_do_preco_venda, [],
                                                                     10),
                                             'kit.produto': (get_kit_id_do_item_kit,
                                                         ['kitpro_item_produto_id',
                                                          'kitpro_grade_id',
                                                          'kitpro_quantidade',
                                                          'kitpro_produto_embalagem_id'], 10),
                                             'estoque.embalagem': (get_kit_id_do_embalagem,
                                                      ['quantidade_na_embalagem'], 10)}, type="float"),
    }
    _defaults = {
        'kitpro_quantidade': 1,
    }

