# -*- coding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class ExternalPDF(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class ReportCustom(report_int):

    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}

        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        title = center_title('', _('Relacao de Kits'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato()
        listagem.informaNome(pdf_string, _('Relacao de Kits'))
        listagem.informaTamLinha(160)
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)

        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, datas.get('company_id'), ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
        docs1 = ''
        if datas.get('produto'):
            docs1 = 'Kit: ' + datas.get('produto')
        docs2 = ''
        if datas.get('tipo_preco'):
            docs2 = 'Tipo preco: ' + datas.get('tipo_preco')
        docs3 = ''
        if datas.get('situacao'):
            docs3 = 'Situacao: ' + datas.get('situacao')

        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab(docs)
        if docs1:
            listagem.informaCab(docs1)
        if docs2:
            listagem.informaCab(docs2)
        if docs3:
            listagem.informaCab(docs3)
        listagem.informaCab('')
        listagem.informaCab('--')
        listagem.informaCab(formataString('KIT', 100, ' ', 'D', 'N', 'S') + formataString(
            'SALDO', 50, ' ', 'E', 'N', 'S'))
        listagem.informaCab('     ' + formataString('ITEM', 60, ' ', 'D', 'N', 'S') +
                            formataString('SALDO', 20, ' ', 'E', 'N', 'S') +
                            formataString('EM KITS', 20, ' ', 'E', 'N', 'S') +
                            formataString('QTD NO KIT', 20, ' ', 'E', 'N', 'S'))
        listagem.informaCab('--')
        listagem.rodapePadrao()
        kit_codigo = ''
        saldos = datas.get('saldos')
        for dado in datas.get('kit_dados'):
            if kit_codigo != dado.get('kit_codigo'):
                saldo = saldos.get(str(dado.get('kit_grade_id'))) or {}
                listagem.imprimeLinha('')
                descricao = dado.get('kit_descricao') if dado.get('kit_descricao') != 'UNICA' else \
                    dado.get('kit_name')
                linha = formataString(dado.get('kit_codigo') + ' - ' + descricao, 100, ' ', 'D',
                                      'N', 'S')
                linha += formataString(getNumeroEditado(saldo.get('saldo') or 0, 5), 50, ' ', 'E',
                                       'N', 'S')
                listagem.imprimeLinha(linha)
            kit_codigo = dado.get('kit_codigo')
            if not dado.get('item_grade_id'):
                continue
            saldo = saldos.get(str(dado.get('item_grade_id'))) or {}
            saldo = float(saldo.get('saldo') or 0)
            qtd_no_kit = float(dado.get('qtd_no_kit'))
            # listagem.imprimeLinha('')
            descricao = dado.get('item_descricao') if dado.get('item_descricao') != 'UNICA' else \
                dado.get('item_name')
            linha = '     '
            linha += formataString(dado.get('item_codigo') + ' - ' + dado.get('item_grade') + ' - '
                                   + descricao, 60, ' ', 'D', 'N', 'S')
            linha += formataString(getNumeroEditado(saldo, 5), 20, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(saldo / qtd_no_kit, 5), 20, ' ', 'E',
                                   'N', 'S')
            linha += formataString(getNumeroEditado(qtd_no_kit, 3), 20, ' ', 'E', 'N', 'S')
            listagem.imprimeLinha(linha)

        listagem.finalizaImpressao()
        self.obj = ExternalPDF(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return self.obj.pdf, 'pdf'


ReportCustom('report.listagem_relacao_kits')
