#!/usr/bin/python
# -*- coding: utf-8 -*-

__version__ = '1.0'
__author__ = 'thiago.rodrigues'
__email_author__ = 'thiago.rodrigues[at]siginformatica.com.br'

from openerp.tests.common import TransactionCase
from sigaddons.config_teste import set_config
from random import randint


class TestEstoqueProduto(TransactionCase):
    @classmethod
    def setUpClass(cls):
        set_config()

    def setUp(self):
        super(TestEstoqueProduto, self).setUp()
        self.estpro = self.registry('estoque.produto')
        self.estprogra = self.registry('estoque.produto.grade')
        self.kitpro = self.registry('kit.produto')
        self.company_id = 1
        self.produto1 = self.estpro.create(self.cr, self.uid, vals=self.get_vals_produto())
        self.grade_1 = self.estprogra.create(self.cr, self.uid,
                                             vals=self.get_vals_grade(self.produto1))
        self.produto2 = self.estpro.create(self.cr, self.uid, vals=self.get_vals_produto())
        self.grade_2 = self.estprogra.create(self.cr, self.uid,
                                             vals=self.get_vals_grade(self.produto2))
        vals_produto_kit = self.get_vals_produto(grade_unica=True, kit_de_produtos=True,
                                                 preco_kit='K')
        self.produto_kit_id = self.estpro.create(self.cr, self.uid, vals=vals_produto_kit)
        self.kit1 = self.kitpro.create(
            self.cr, self.uid, vals=dict(kitpro_produto_id=self.produto_kit_id,
                                         kitpro_item_produto_id=self.produto1,
                                         kitpro_grade_id=self.grade_1,
                                         kitpro_quantidade=6.0, supkit_preco_venda=10.0))
        self.kit2 = self.kitpro.create(
            self.cr, self.uid, vals=dict(kitpro_produto_id=self.produto_kit_id,
                                         kitpro_item_produto_id=self.produto2,
                                         kitpro_grade_id=self.grade_2,
                                         kitpro_quantidade=1.0, supkit_preco_venda=10.0))


    def get_vals_produto(self, grade_unica=True, kit_de_produtos=False, preco_kit='k'):
        nome_prod = 'teste' + str(randint(1, 1000))
        vals = dict(company_id=self.company_id, name=nome_prod, origem_mercadoria='0',
                    tipo_item='00', grade_usar=grade_unica, kit_de_produtos=kit_de_produtos)
        if kit_de_produtos:
            vals['preco_kit'] = preco_kit
        return vals

    def get_vals_kit(self, preco_kit='K'):
        vals = self.get_vals_produto()
        vals['kit_de_produtos'] = True
        vals['preco_kit'] = preco_kit
        return vals

    def get_vals_grade(self, produto_id, grade='UN'):
        nome_grade = 'teste' + str(randint(1, 1000))
        return dict(descricao=nome_grade, grade=grade, produto_id=produto_id)