# -*- encoding: utf-8 -*-

from openerp.osv import osv
import datetime
import time
from SigUtils import datas


class logs_logs(osv.Model):
    _name = 'logs.logs'
    _inherit = 'logs.logs'

    def read(self, cr, uid, ids, fields=None, context=None, load='_classic_read'):
        context = context and context.copy() or {}
        if not isinstance(ids, (tuple, list)):
            ids = [ids]
        logs_dados = super(logs_logs, self).read(cr, uid, ids, context=context, load=load)
        novo_dados = []
        _conv_tz = self.pool.get('adm.utils').admutl_converte_tz
        for item in logs_dados:
            _d = item['logs_data']
            _h = item['logs_horario']
            _dh = _d + ' ' + _h
            t = datetime.datetime.fromtimestamp(
                time.mktime(time.strptime(_dh, "%Y-%m-%d %H:%M:%S")))
            _datetime = _conv_tz(cr, uid, t, tz_origem='UTC')
            item['logs_data'] = _datetime.strftime('%Y-%m-%d')
            item['logs_horario'] = _datetime.strftime('%H:%M:%S')
            novo_dados.append(item)
        return novo_dados

    def logs_deletar_logs(self, cr, uid, prazo=None):
        """
        Funcao chamada pelo cron para excuir logs antigos
        @param cr:
        @param uid:
        @param prazo: prazo para excluir em dias
        @return:
        """
        try:
            prazo = int(prazo)
        except:
            prazo = 90
        _hoje = datas. getDataDeHoje('I')
        _data_fim = datas.calcVencimento(_hoje, (prazo * -1))
        _sql = "delete from logs_logs where logs_data < '%s'" % (_data_fim[:4]+'-'+_data_fim[4:6]+'-'+_data_fim[6:])
        cr.execute(_sql)
        return True

    def logs_detalhar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not isinstance(ids, (tuple, list)):
            ids = [ids]
        logs_dados = super(logs_logs, self).read(cr, uid, ids, context=context)
        for item in logs_dados:
            vals_det = {}
            _obj = self.pool.get(item['logs_tabela'])
            dado_atual = _obj.read(cr, uid, item['logs_id_do_registro'], [], context=context,
                                   load='_classic_write')
            if isinstance(dado_atual, (list, tuple)):
                dado_atual = dado_atual[0]
            vals_det['logdet_id'] = item.get('id')
            _ant = {}
            if item.get('logs_dados_anteriores'):
                _ant = eval(item.get('logs_dados_anteriores'))
            _nov = {}
            if item.get('logs_dados_novos'):
                _nov = eval(item.get('logs_dados_novos'))
            ids_to_del = self.pool.get('logs.detalhe.osv').search(cr, uid, [('logdet_id', '=', item.get('id'))],
                                                                  context=context)
            if ids_to_del:
                self.pool.get('logs.detalhe.osv').unlink(cr, uid, ids_to_del)
            for x in dado_atual:
                _selection = False
                try:
                    _desc = _obj._columns.get(x).string
                    if _obj._columns.get(x)._type == 'selection':
                        _selection = True
                except:
                    _desc = x
                _dado_ant = _ant.get(x) or ''
                _dado_nov = _nov.get(x) or ''
                _dado_atual = dado_atual.get(x) or ''
                if _selection and _obj._columns.get(x)._type == 'selection':
                    for i in _obj._columns.get(x).selection:
                        if _dado_ant == i[0]:
                            _dado_ant = i[1]
                        if _dado_nov == i[0]:
                            _dado_nov = i[1]
                        if _dado_atual == i[0]:
                            _dado_atual = i[1]
                vals_det['logdet_detalhe'] = _desc
                vals_det['logdet_atual'] = _dado_atual
                vals_det['logdet_anterior'] = _dado_ant
                vals_det['logdet_novo'] = _dado_nov
                self.pool.get('logs.detalhe.osv').create(cr, uid, vals_det, context)
        _id = context.get('log_id') or False
        value = {
            'view_type': 'form',
            'view_mode': 'tree',
            'res_model': 'logs.detalhe.osv',
            'type': 'ir.actions.act_window',
            'target': 'new',
            'context': context
        }
        if _id:
            value['domain'] = "[('logdet_id', '=', %s)]" % _id
        return value