# -*- coding: utf-8 -*-
# #############################################################################
#
# Author: Guewen Baconnier
# Copyright 2012 Camptocamp SA
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv.orm import BaseModel
import time

original_create = getattr(BaseModel, 'create')
original_write = getattr(BaseModel, 'write')
original_unlink = getattr(BaseModel, 'unlink')


def registrar_log(self, cr, uid, operacao, ids, _vals, context):
    def logs_get_verifica_2many(coluna):
        """
        Verficar se o campo é one2many ou many2many
        @param coluna: nome da coluna para veriricar
        @return: bool, True ou Fase
        """
        if self._columns.get(coluna):
            if self._columns.get(coluna)._type in ('many2many', 'one2many'):
                return True
            else:
                return False
        if not self._inherits:
            return False
        _tabelas = self._inherits.keys()
        for _tabela in _tabelas:
            if self.pool.get(_tabela)._columns.get(coluna):
                if self.pool.get(_tabela)._columns.get(coluna)._type in ('many2many', 'one2many'):
                    return True
                else:
                    return False
        return False

    def _identificar_coluna(_dados_ant, _dados_novos):
        _selection = False
        try:
            _desc = self._columns.get(idx).string
            if self._columns.get(idx)._type == 'selection' and \
                    isinstance(self._columns.get(idx).selecion, list):
                _selection = True
        except:
            _desc = idx
        if _selection:
            for i in self._columns.get(idx).selection:
                if _dados_ant.get(idx) == i[0]:
                    _dados_ant[idx] = i[1]
                if _dados_novos.get(idx) == i[0]:
                    _dados_novos[idx] = i[1]
        for x in _dados_ant:
            if _dados_ant[x] and isinstance(_dados_ant[x], (str, unicode)):
                _dados_ant[x] = _dados_ant[x].replace("'", " ")
        for x in _dados_novos:
            if _dados_novos[x] and isinstance(_dados_novos[x], (str, unicode)):
                _dados_novos[x] = _dados_novos[x].replace("'", " ")
        return _desc, _dados_ant, _dados_novos

    if self._name in ('ir.values', 'ir.ui.view', 'ir.model.data', 'ir.actions.act_window',
                          'ir.actions.act_window.view', 'ir.actions.report.xml', 'ir.ui.menu',
                          'ir.module.module', 'ir.model.access', 'ir.actions.todo', 'ir.rule',
                          'res.groups', 'ir.actions.client', 'ir.propert', 'note.stage',
                          'ir.module.category') or self._transient or not ids:
        return True
    if hasattr(self, '_gerar_logs_logs') and self._gerar_logs_logs == 'N':
        return True  # Nao gera log
    _dados = {}
    vals = {}
    for x in _vals:
        vals[x] = _vals[x]
    if 'company_id' in vals:
        _dados['logs_company_id'] = int(vals['company_id'])
    else:
        company_dados = self.pool.get('res.users').read(cr, uid, uid, ['company_id'], context,
                                                        load='_classic_write')
        if isinstance(company_dados, list):
            company_dados = company_dados[0]
        company_id = int(company_dados.get('company_id'))
        _dados['logs_company_id'] = company_id
    _dados['logs_data'] = time.strftime('%Y-%m-%d')
    _dados['logs_horario'] = time.strftime('%H:%M:%S')
    if context:
        _dados['logs_context'] = str(context).replace("'", '"')
    _dados['logs_user_id'] = uid
    _dados['logs_tabela'] = self._name
    _dados['logs_operacao'] = operacao
    if not isinstance(ids, (tuple, list)):
        ids = [ids]

    dict_dados = {}
    campos = []
    if 'name' in self._columns.keys():
        campos = ['name']
    elif '_rec_name' in dir(self) and self._rec_name != 'name':
        campos = [self._rec_name]

    if campos:
        map(lambda x: dict_dados.update({x.get('id'): x}),
            self.read(cr, uid, ids, campos, context=context))

    for id in ids:
        _dados['logs_id_do_registro'] = str(id)
        _sql = "insert into logs_logs "
        _campos = []
        _values = []
        for i, j in _dados.items():
            _campos.append(i)
            _values.append('%r' % j)

        _campos.append('logs_reference')
        _values.extend(['%r' % '%s,%s' % (self._name, str(id))])
        if 'name' in self._columns.keys():
            _campos.append('logs_nome_elemento')
            name = dict_dados.get(id)
            name = name[0] if isinstance(name, (list, tuple)) else name
            name = name.get('name') or ''
            if isinstance(name, (tuple,list)):
                name = str(name)
            _values.append(('%r' % name.replace("'", '')).replace("u'", "'").replace('u"', '"'))
        elif '_rec_name' in dir(self) and self._rec_name != 'name':
            rec_name = dict_dados.get(id)
            if rec_name:
                _campos.append('logs_nome_elemento')
                if isinstance(rec_name, list):
                    rec_name = rec_name[0]
                rec_name = rec_name.get(self._rec_name) or ''
                if isinstance(rec_name, unicode):
                    rec_name = rec_name
                elif isinstance(rec_name, tuple):
                    rec_name = '%s - %s' % rec_name
                else:
                    rec_name = '%s' % rec_name

                _values.append(('%r' % rec_name.replace("'", '')).replace("u'", "'").replace('u"', '"'))

        _sql += '(%s) \nvalues (%s) \nreturning id' % (','.join(_campos), ','.join(_values))
        try:
            cr.execute(_sql)
        except Exception as e:
            continue
        _logs_id = cr.fetchone()[0]
        _dados_ant = _dados_novos = {}
        if operacao != 'I':
            _sql = "select * from %s where id = %d" % (self._table, id)
            cr.execute(_sql)
            _dados_read = cr.dictfetchone() or {}
            if operacao == 'E':
                _dados_ant = _dados_read
            else:  # So interessa os dados antigos do que foi alterado
                x = {}
                for key in vals:
                    x[key] = _dados_read.get(key)
                _dados_ant = x
        if vals:
            _dados_novos = vals
        _sql = 'insert into logs_detalhe (logdet_id,logdet_detalhe,'
        while _dados_ant:
            for idx in _dados_ant:
                if logs_get_verifica_2many(idx):
                    continue
                _sql1 = _sql
                _sql1 += 'logdet_anterior,'
                _desc, _dados_ant, _dados_novos = _identificar_coluna(_dados_ant, _dados_novos)
                if idx in _dados_novos.keys():
                    _sql1 += 'logdet_novo,'
                _sql1 = _sql1[:-1] + ") values (" + str(
                    _logs_id) + ",'" + idx + "','%s','" % _dados_ant.get(idx)
                if idx in _dados_novos.keys():
                    try:
                        _xdados = str(_dados_novos.get(idx)).decode('utf-8').encode('ASCII',
                                                                                    'ignore')
                    except:
                        _xdados = _dados_novos.get(idx)
                    _sql1 = _sql1 + "%s')" % _xdados.replace("'", '"')
                    _dados_novos.pop(idx)
                else:
                    _sql1 = _sql1[:-2] + ')'
                cr.execute(_sql1)
            _dados_ant = {}
        while _dados_novos:
            for idx in _dados_novos:
                if logs_get_verifica_2many(idx):
                    continue
                _desc, _dados_ant, _dados_novos = _identificar_coluna(_dados_ant, _dados_novos)
                _sql1 = _sql
                _sql1 += 'logdet_novo,'
                try:
                    _xdados = str(_dados_novos.get(idx)).decode('utf-8').encode('ASCII', 'ignore')
                except:
                    _xdados = _dados_novos.get(idx)
                _sql1 = _sql1[:-1] + ") values (%s, '%s', '%s')" % (_logs_id, idx, _xdados.replace("'", '"'))
                cr.execute(_sql1)
            _dados_novos = {}
    return True


def write(self, cr, uid, ids, vals, context=None):
    context = context and context.copy() or {}
    if check_installed_logs(self, cr, uid, context):
        registrar_log(self, cr, uid, 'A', ids, vals, context)
    res = original_write(self, cr, uid, ids, vals, context=context)
    return res


BaseModel.write = write


def create(self, cr, uid, vals, context=None):
    context = context and context.copy() or {}
    record_id = original_create(self, cr, uid, vals, context=context)
    # Tratamento para que a criacao de novas bases nao seja impedido
    if record_id and check_installed_logs(self, cr, uid, context):
        registrar_log(self, cr, uid, 'I', record_id, vals, context)
    return record_id


BaseModel.create = create


def unlink(self, cr, uid, ids, context=None):
    context = context and context.copy() or {}
    if check_installed_logs(self, cr, uid, context):
        registrar_log(self, cr, uid, 'E', ids, {}, context)
    res = original_unlink(self, cr, uid, ids, context=context)
    return res


BaseModel.unlink = unlink


def check_installed_logs(self, cr, uid, context=None):
    context = context and context.copy() or {}
    logs_installed = self.pool.get('ir.module.module').search(
        cr, uid, [('name', '=', 'logs'), ('state', 'in', ('installed', 'to_upgrade'))],
        context=context)
    return logs_installed
