# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields

def _logs_get(self, cr, uid, context=None):
    context = context and context.copy() or {}
    obj = self.pool.get('ir.model')
    ids = obj.search(cr, uid, [], context=context)
    res = obj.read(cr, uid, ids, ['model', 'name'], context=context)
    return [(r['model'], r['name']) for r in res]

class logs_logs(osv.Model):
    _name = 'logs.logs'
    _log_access = False
    _gerar_logs_logs = 'N'

    _columns = {
        'id': fields.integer('Id', readonly=1),
        'logs_tabela': fields.char('Classe', size=64, required=1, select=1),
        'logs_id_do_registro': fields.integer('id', select=1),
        'logs_data': fields.date('Data', select=1),
        'logs_horario': fields.char('Horario', size=8),
        'logs_context': fields.text('Contexto'),
        'logs_operacao': fields.selection([('I', 'Inclusao'), ('E', 'Exclusao'),
                                           ('A', 'Alteracao')], 'Operacao', size=1),
        'logs_user_id': fields.many2one('res.users', 'Usuario', select=1),
        'logs_company_id': fields.many2one('res.company', 'Empresa', select=1),
        'logs_detalhe_ids': fields.one2many('logs.detalhe', 'logdet_id', 'Detalhes'),
        'logs_reference': fields.reference('Registro', _logs_get, size=128),
        'logs_nome_elemento': fields.text('Nome elemento'),
    }
    _order = 'id desc'

