# -*- encoding: utf-8 -*-

# Funcoes da classe wizard_logs_capa


def check_field_is_relation(self, cr, uid, ids, field_name, arg, context=None):
    """
    Metodo de campo funcional. Identifica se o campo selecionado e ou nao do tipo relacional.
    :param cr: cursor no banco de dados.
    :type cr: object
    :param uid: id da tabela res_users, identificador do usuario.
    :param ids: lista de id da tabela desse objeto.
    :type ids: list
    :param field_name: descricao do campo funcional.
    :type field_name: str
    :param arg: lista de argumentos de pesquisa.
    :type arg: list
    :param context: dicionario com valores contextuais.
    :type context: dict
    :return: dicionario com o id do campo e seu respectivo valor.
    """
    context = context and context.copy() or {}
    res = {}
    for log in self.browse(cr, uid, ids, context):
        res[log.id] = False
        if not log.logs_table_field_id:
            continue
        if log.logs_table_field_id.wlogtf_field[-3:] == '_id':
            res[log.id] = True
    return res


def get_logs_ids(self, cr, uid, ids, field_name, arg, context=None):
    """
    Metodo de campo funcional. Encontra registros na tabela logs_logs que satisfacam aos filtros da
    wizard_logs_capa.
    :param cr: cursor no banco de dados.
    :type cr: object
    :param uid: id da tabela res_users, identificador do usuario.
    :param ids: lista de id da tabela desse objeto.
    :type ids: list
    :param field_name: descricao do campo funcional.
    :type field_name: str
    :param arg: lista de argumentos de pesquisa.
    :type arg: list
    :param context: dicionario com valores contextuais.
    :type context: dict
    :return: dicionario com o id do registro e seu respectivo valor.
    """
    context = context and context.copy() or {}
    res = {}
    for log in self.browse(cr, uid, ids, context):
        campos = list()
        map(lambda i: campos.append(str(i.wlogfv_table_field)), log.logs_field_value_ids)
        valores = list()
        map(lambda i: valores.append(str(i.wlogfv_value)), log.logs_field_value_ids)
        models = list()
        map(lambda i: models.append(str(i.wlogfv_model)), log.logs_field_value_ids)
        if not models and log.tabela_id.model:
            models.append(str(log.tabela_id.model))
        sql = """
            SELECT
                ll.id
            FROM
                logs_logs ll
            INNER JOIN
                logs_detalhe ld ON ll.id = ld.logdet_id
            WHERE
                1 = 1
        """
        res[log.id] = []
        if len(campos) == 1:
            campos = str(tuple(campos)).replace(',', '')
        elif len(campos) > 1:
            campos = str(tuple(campos))
        if campos:
            sql += """
                AND logdet_detalhe IN %s""" % campos
        if len(valores) == 1:
            valores = str(tuple(valores)).replace(',', '')
        elif len(valores) > 1:
            valores = str(tuple(valores))
        if valores:
            sql += """
                AND (logdet_anterior IN %s
                     OR logdet_novo IN %s)""" % (valores, valores)
        if len(models) == 1:
            models = str(tuple(models)).replace(',', '')
        elif len(models) > 1:
            models = str(tuple(models))
        if models:
            sql += """
                AND logs_tabela IN %s""" % models
        if log.data_i:
            sql += """
                AND logs_data >= '%s'""" % log.data_i
        if log.data_f:
            sql += """
                AND logs_data <= '%s'""" % log.data_f
        if log.operacao:
            sql += """
                AND logs_operacao = '%s'""" % log.operacao
        if log.usuario_id:
            sql += """
                AND logs_user_id = %s""" % log.usuario_id.id
        if log.empresa_id:
            sql += """
                AND logs_company_id = %s""" % log.empresa_id.id
        cr.execute(sql)
        log_ids = map(lambda i: i.get('id'), cr.dictfetchall())
        res[log.id] = log_ids
    return res
