# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
import time
from SigUtils.formatastring import formataString
from openerp.tools.translate import _
from funcoes import check_field_is_relation
from funcoes import get_logs_ids


class wizard_logs_capa(osv.TransientModel):

    def _get_reference_field(self, cr, uid, context=None):
        context = context and context.copy() or {}
        if not context.get('model'):
            return list()
        obj = self.pool.get('ir.model')
        ids = obj.search(cr, uid, [('model', '=', context.get('model'))], context=context)
        res = obj.read(cr, uid, ids, ['model', 'name'], context=context)
        return [(r['model'], r['name']) for r in res]

    _name = 'wizard.logs.capa'
    _columns = {
        'id': fields.integer('id', readonly=True),
        'data_i': fields.date('Data inicial'),
        'data_f': fields.date('Data Final'),
        'empresa_id': fields.many2one('res.company', 'Empresa'),
        'usuario_id': fields.many2one('res.users', 'Usuario'),
        'tabela_id': fields.many2one('ir.model', 'Tabela'),
        'operacao': fields.selection([('I', 'Inclusao'), ('E', 'Exclusao'), ('A', 'Alteracao')],
                                     'Operacao'),
        'logs_field_value_ids': fields.one2many('wizard.logs.field.value', 'wlogfv_capa_id',
                                                'Campos e valores'),
        'logs_table_field_id': fields.many2one('wizard.logs.table.field', 'Campo'),
        'valor': fields.text('Valor'),
        'logs_field_reference': fields.reference('Valor', _get_reference_field, size=128),
        'relacional': fields.function(check_field_is_relation, string='Relacional', method=True,
                                      type='boolean'),
        'item_ids': fields.function(get_logs_ids, string='Logs', method=True, type='one2many',
                                    relation='logs.logs'),
    }

    _defaults = {
        'data_i': time.strftime("%Y-%m-%d"),
        'data_f': time.strftime("%Y-%m-%d"),
        'relacional': lambda *a: False,
    }

    def _get_empresa(self, cr, data_i, data_f, usuario, tabela, operacao):
        _sql = """
            select
                distinct(logs_company_id)
            from
                logs_logs
            where
                1 = 1
        """
        if data_i:
            _sql += """
                AND logs_data >= '%s'""" % data_i
        if data_f:
            _sql += """
                AND logs_data <= '%s'""" % data_f
        if usuario:
            _sql += ' and logs_user_id = %s' % usuario
        if tabela:
            _sql1 = 'select name from ir_model where id = %s' % tabela
            cr.execute(_sql1)
            _nome_tabela = cr.fetchone()
            _sql += " and logs_tabela = '%s'" % _nome_tabela
        if operacao:
            _sql += " and logs_operacao = '%s'" % operacao
        cr.execute(_sql)
        _ids = tuple([str(x[0]) for x in cr.fetchall()])
        res = [('id', 'in', _ids)]
        return res

    def _get_usuario(self, cr, data_i, data_f, empresa, tabela, operacao):
        _sql = """
            select
                distinct(logs_user_id)
            from
                logs_logs
            where
                1 = 1
        """
        if data_i:
            _sql += """
                AND logs_data >= '%s'""" % data_i
        if data_f:
            _sql += """
                AND logs_data <= '%s'""" % data_f
        if empresa:
            _sql += ' and logs_company_id = %s' % empresa
        if tabela:
            _sql1 = 'select name from ir_model where id = %s' % tabela
            cr.execute(_sql1)
            _nome_tabela = cr.fetchone()
            _sql += " and logs_tabela = '%s'" % _nome_tabela
        if operacao:
            _sql += " and logs_operacao = '%s'" % operacao
        cr.execute(_sql)
        _ids = tuple([str(x[0]) for x in cr.fetchall()])
        res = [('id', 'in', _ids)]
        return res

    def _get_tabela(self, cr, data_i, data_f, empresa, usuario, operacao):
        _sql = """
            select
                distinct(logs_tabela)
            from
                logs_logs
            where
                1 = 1
        """
        if data_i:
            _sql += """
                AND logs_data >= '%s'""" % data_i
        if data_f:
            _sql += """
                AND logs_data <= '%s'""" % data_f
        if empresa:
            _sql += ' and logs_company_id = %s' % empresa
        if usuario:
            _sql += ' and logs_user_id = %s' % usuario
        if operacao:
            _sql += " and logs_operacao = '%s'" % operacao
        cr.execute(_sql)
        _nomes = tuple([str(x[0]) for x in cr.fetchall()])
        _ids = list()
        if _nomes:
            if len(_nomes) == 1:
                _nomes = _nomes[0]
                _where = "= '%s'" % _nomes
            else:
                _where = 'in %s' % str(_nomes)
            _sql = 'select id from ir_model where name %s' % _where
            cr.execute(_sql)
            _ids = tuple([str(x[0]) for x in cr.fetchall()])
        res = [('id', 'in', _ids)]
        return res

    def onchange_data(self, cr, uid, ids, data_i, data_f, empresa, usuario, tabela, operacao,
                      context=None):
        context = context and context.copy() or {}
        vals = {'value': {}, 'domain': {}}
        res = self._get_empresa(cr, data_i, data_f, usuario, tabela, operacao)
        if res:
            vals['domain']['empresa_id'] = res
        res = self._get_usuario(cr, data_i, data_f, empresa, tabela, operacao)
        if res:
            vals['domain']['usuario_id'] = res
        res = self._get_tabela(cr, data_i, data_f, empresa, usuario, operacao)
        if res:
            vals['domain']['tabela_id'] = res
        return vals

    def onchange_empresa(self, cr, uid, ids, data_i, data_f, empresa, usuario, tabela, operacao,
                         context=None):
        context = context and context.copy() or {}
        vals = {'value': {}, 'domain': {}}
        res = self._get_usuario(cr, data_i, data_f, empresa, tabela, operacao)
        if res:
            vals['domain']['usuario_id'] = res
        res = self._get_tabela(cr, data_i, data_f, empresa, usuario, operacao)
        if res:
            vals['domain']['tabela_id'] = res
        return vals


    def onchange_usuario(self, cr, uid, ids, data_i, data_f, empresa, usuario, tabela, operacao,
                         context=None):
        context = context and context.copy() or {}
        vals = {'value': {}, 'domain': {}}
        if not empresa:
            res = self._get_empresa(cr, data_i, data_f, usuario, tabela, operacao)
            if res:
                vals['domain']['empresa_id'] = res
        res = self._get_tabela(cr, data_i, data_f, empresa, usuario, operacao)
        if res:
            vals['domain']['tabela_id'] = res
        return vals

    def onchange_tabela(self, cr, uid, ids, data_i, data_f, empresa, usuario, tabela, operacao,
                        context=None):
        context = context and context.copy() or {}
        vals = {'value': {'logs_table_field_id': False, 'valor': ''}, 'domain': {}}
        if not empresa:
            res = self._get_empresa(cr, data_i, data_f, usuario, tabela, operacao)
            if res:
                vals['domain']['empresa_id'] = res
        if not usuario:
            res = self._get_usuario(cr, data_i, data_f, empresa, tabela, operacao)
            if res:
                vals['domain']['usuario_id'] = res
        if not tabela:
            return vals
        model = self.pool.get('ir.model').browse(cr, uid, tabela, context).model
        self.get_table_field(cr, uid, model, context)
        return vals

    def button_pesquisar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}

        return True

    def get_table_field(self, cr, uid, model, context=None):
        """
        O metodo exclui e insere dados na tabela wizard_logs_table_field a cada alteracao do campo
        'tabela_id'.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid:int
        :param model: descricao do atributo '_name' da classe.
        :type model: str
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: Verdadeiro
        :rtype: bool
        """
        context = context and context.copy() or {}
        cr.execute("""DELETE FROM wizard_logs_table_field""")
        if not model:
            return False
        columns = self.pool.get(model)._columns
        sql = """
            INSERT INTO wizard_logs_table_field (create_uid, wlogtf_field, wlogft_model) VALUES
        """
        for column in columns:
            if columns.get(column)._type in ('one2many', 'many2many'):
                continue
            sql += "(%s, '%s', '%s')" % (uid, column, columns.get(column)._obj or '')
            if column != columns.keys()[-1]:
                sql += ','
        if sql[-1] == ',':
            sql = sql[:-1]
        cr.execute(sql)
        cr.commit()
        return True

    def set_field_value(self, cr, uid, ids, context=None):
        """
        O metodo cria os registros na tabela wizard_logs_field_value, de acordo com o campo e valor
        selecionados.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid:int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: Verdadeiro
        :rtype: bool
        """
        context = context and context.copy() or {}
        for x in self.browse(cr, uid, ids, context):
            if x.logs_table_field_id and not x.valor and not x.relacional:
                raise osv.except_osv(_('Atencao'), _('Informe o "Valor".'))
            campo = x.logs_table_field_id.wlogtf_field
            valor = x.valor
            if x.relacional:
                valor = x.logs_field_reference.id
            self.write(cr, uid, x.id, {'logs_field_value_ids': [
                (0, 0, {'wlogfv_table_field': campo,
                        'wlogfv_value': valor,
                        'wlogfv_model': x.tabela_id.model})]}, context)
        return True

    def recarrega_tela(self, cr, uid, ids, context=None):
        """
        O metodo recarrega a tela atual para que campos funcionais estore=False sejam recalculados.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid:int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: Acao para a chamada da mesta tela.
        :rtype: dict
        """
        context = context and context.copy() or {}
        obj_model_data = self.pool.get('ir.model.data')
        reference = obj_model_data.get_object_reference(cr, uid, 'logs', 'view_logs_detalhe_form')
        view_id = reference and reference[1] or False
        model = self.browse(cr, uid, ids[0], context).logs_table_field_id.wlogft_model
        context.update({'model': model})
        return {
            'res_id': ids[0],
            'name': 'Pesquisa de logs',
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'wizard.logs.capa',
            'view_id': [view_id],
            'context': context,
            'target': 'inline',
            'type': 'ir.actions.act_window',
        }

    def onchange_table_field_id(self, cr, uid, ids, table_field_id, context=None):
        context = context and context.copy() or {}
        res = {'value': {'relacional': False, 'logs_field_reference': False}}
        if not table_field_id:
            return res
        field = self.pool.get('wizard.logs.table.field').browse(
            cr, uid, table_field_id, context).wlogtf_field
        if field[-3:] == '_id':
            res['value']['relacional'] = True
        return res


class wizard_logs_table_field(osv.TransientModel):
    # prefixo: wlogtf_

    _name = 'wizard.logs.table.field'
    _rec_name = 'wlogtf_field'
    _columns = {
        'wlogtf_field': fields.char('Campo', size=128),
        'wlogft_model': fields.char('Model', size=128),
    }


class wizard_logs_field_value(osv.TransientModel):
    # prefixo: wlogfv_

    _name = 'wizard.logs.field.value'
    _columns = {
        'wlogfv_capa_id': fields.many2one('wizard.logs.capa', 'Capa'),
        'wlogfv_model': fields.char('Modelo', size=128),
        'wlogfv_table_field': fields.char('Campo', size=128),
        'wlogfv_value': fields.text('Valor'),
    }
