# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class madeireira_medida(osv.Model):
    # prefixo: madmed_
    _inherit = 'madeireira.medida'

    def name_search(self, cr, uid, name='', args=[], operator='ilike', context=None, limit=100):
        context = context and context.copy() or {}
        ids = []
        try:
            name = float(name)
        except:
            pass
        if isinstance(name, float):
            ids = self.search(cr, uid, ['|', ('id', '=', name),
                                        '|', ('madmed_comprimento', '=', name),
                                        '|', ('madmed_largura', '=', name),
                                        ('madmed_espessura', '=', name)] + args, limit=limit,
                              context=context)
            #if not ids:
            #    ids = self.search(cr, uid, [] + args, limit=limit, context=context)
        if not name and not ids:
            ids = self.search(cr, uid, [] + args, limit=limit, context=context)
        return self.name_get(cr, uid, ids)

    def name_get(self, cr, uid, ids, context=None):
        res = []
        context = context and context.copy() or {}
        if not len(ids):
            return []
        dados = self.read(cr, uid, ids,
                          ['madmed_comprimento', 'madmed_largura', 'madmed_espessura'],
                          context=context)
        for x in dados:
            descricao = '%s - ' % x.get('id')
            comprimento = x.get('madmed_comprimento')
            if comprimento:
                descricao += '%s m' % comprimento
            largura = x.get('madmed_largura')
            if largura:
                if descricao:
                    descricao += ' x %s cm' % largura
                else:
                    descricao += '%s cm' % largura
            espessura = x.get('madmed_espessura')
            if espessura:
                if descricao:
                    descricao += ' x %s cm' % espessura
                else:
                    descricao += '%s cm' % espessura
            res.append((x.get('id'), descricao))
        return res
