# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2014 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _

class madeireira_produto_variacao(osv.Model):
    _name = 'madeireira.produto.variacao'
    _inherit = 'madeireira.produto.variacao'


    def madpro_onchange_produto_id(self, cr, uid, ids, produto_id, context=None):
        """
            Ao editar o campo produto o tipo de variacao do produto sera infomado.
            """
        context = context and context.copy() or {}
        vals = {'value': {}}
        if produto_id:
            obj_estoque_produto = self.pool.get('estoque.produto')
            brw_estoque_produto = obj_estoque_produto.browse(cr, uid, produto_id)
            tipo_variacao = brw_estoque_produto.estpro_variacao
            vals['value'] = {'estpro_variacao': tipo_variacao}
        return vals

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if not vals['madpro_variacao'] > 0:
            raise osv.except_osv(_('Atencao'),
                                 _('A variacao deve ser maior que zero!'))
        return super(madeireira_produto_variacao, self).create(cr, uid, vals, context=context)

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, list):
            id = ids[0]
        if 'madpro_variacao' in vals:
            madpro_variacao = vals['madpro_variacao']
        else:
            madpro_variacao = self.browse(cr,uid,id).madpro_variacao
        if not madpro_variacao > 0:
            raise osv.except_osv(_('Atencao'),
                                 _('A variacao deve ser maior que zero!'))
        return super(madeireira_produto_variacao, self).write(cr, uid, ids, vals, context=context)