# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv

LOAD = '_classic_write'


class estsug_compra_capa(osv.Model):
    # prefixo: esgccp_
    _inherit = 'estsug.compra.capa'

    def _esgccp_get_quantidade_pedido_estatistica(self, separar_company):
        sql = """
                , (select sum(CASE
                                  WHEN pedite_volume > 0 THEN pedite_volume
                                  ELSE qtde_pedida
                              END)
                        from estoquepedidos_pedido_item epi
                        left join estoquepedidos_pedido_capa epc on epc.id = epi.pedido_id
                        where epi.grade_id = epg.id and epc.tipo = 'C'
                              and epc.state = 'V' AND {separar_company}) as pedidos
        """.format(separar_company=separar_company)
        return sql

    def _esgccp_get_quantidade_pedido_minimo_maximo(self, query_empresa_nao_fiscal):
        sql = """
            (select sum(CASE
                            WHEN pedite_volume > 0 THEN pedite_volume
                            ELSE qtde_pedida
                        END)
             from estoquepedidos_pedido_item i
             left join estoquepedidos_pedido_capa c on c.id = i.pedido_id
             where i.grade_id = epg.id and c.tipo = 'C' and c.state = 'V' and c.%s
            ) as pedidos,
        """ % query_empresa_nao_fiscal
        return sql

    def _esgccp_get_sql_saidas_minimo_maximo(self, data_inicial, data_final, cond_operacao,
                                             local, empresa):
        sql = """
                (
                select sum(CASE WHEN estmvi_volume > 0 THEN
                               estmvi_volume
                           ELSE
                               quantidade
                           END)
                from estoque_movimento_capa c
                inner join estoque_movimento_itens i on i.capa_id = c.id
                inner join fiscal_nf_capa f on f.id = c.nf_capa_id
                where
                    c.state = 'F'
                    and i.produto_id = epg.produto_id
                    and i.grade_id = epg.id
                    and c.data between '{data_inicial}' AND '{data_final}'
                    {cond_operacao}
                    {_local}
                    {_empresa}) as saidas,
        """.format(data_inicial=data_inicial,
                   data_final=data_final,
                   cond_operacao=cond_operacao,
                   _local=local,
                   _empresa=empresa)
        return sql
