# -*- coding: utf-8 -*-

from openerp.osv import osv, fields


class estoque_movimento_itens(osv.Model):
    """
    PREFIXO: ESTMVI
    complemento do movimento do estoque

    """
    from funcoes import estmvi_get_volume, estmvi_get_sigla_embalagem

    _inherit = 'estoque.movimento.itens'
    _columns = {

        'estmvi_comprimento': fields.float('Comprimento(m)', digits=(15, 2),
                                           help="Comprimento da peca em metros"),
        'estmvi_largura': fields.float('Largura(cm)', digits=(15, 2),
                                       help="Largura da peca em centimetros"),
        'estmvi_espessura': fields.float('Espessura(cm)', digits=(15, 2),
                                         help="Espessura da peca em centimetros"),
        'estmvi_volume': fields.function(estmvi_get_volume, method=True, string='Volume',
                                         digits=(15, 4), store=True),
        'estmvi_sigla_embalagem': fields.function(estmvi_get_sigla_embalagem, method=True,
                                                  string="Sigla embalagem", type="char")
    }
