# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoquepedidos_pedido_item(osv.Model):

    """
    PREFIXO PARA OS CAMPOS: pedite_
    """

    from funcoes import pedite_get_volume, pedite_get_sigla_embalagem

    _inherit = 'estoquepedidos.pedido.item'
    _columns = {
        'pedite_comprimento': fields.float('Comprimento(m)', digits=(5, 2),
                                           help="Comprimento da peca em metros"),
        'pedite_largura': fields.float('Largura(cm)', digits=(5, 2),
                                       help="Largura da peca em centimetros"),
        'pedite_espessura': fields.float('Espessura(cm)', digits=(5, 2),
                                         help="Espessura da peca em centimetros"),
        'pedite_volume': fields.function(pedite_get_volume, method=True, string="Volume",
                                         digits=(5, 4), store=True),
        'pedite_sigla_embalagem': fields.function(pedite_get_sigla_embalagem, method=True,
                                                  string="Sigla embalagem", type="char"),
        'pedite_medida_id': fields.many2one('madeireira.medida', 'Medida'),
    }
