# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2016 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2016, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv


class fiscal_nf_capa(osv.Model):
    """
    Heranca da classe ´fiscal_nf_capa´.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _inherit = 'fiscal.nf.capa'

    def get_total_nf_itens(self, cr, user, nf, context=None):
        """
        Calcula o valor total de cada item da nota fiscal em funcao do volume

        :param cr: cursor do banco de dados
        :param user: ID do usuario utilizado para a verificacao de perfil
        :param nf: ID da nota fiscal
        :param context: um dicionario padrao para valores contextuais
        :type cr: object
        :type user: int
        :type nf: long
        :type context: dict
        :return: o valor total do item: produto entre valor unitario e a quantidade.
        :rtype: float

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}
        item_ids = self.get_nf_item_ids(cr, user, nf_id=nf, context=context)
        item_dados = self.pool.get('estoque.movimento.itens').read(
            cr, user, item_ids, ['vr_unitario', 'quantidade', 'estmvi_volume'], context=context)

        return sum(map(
            lambda m: m.get('vr_unitario') * (m.get('estmvi_volume') or m.get('quantidade')),
            item_dados))

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
