# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv

class orcamentos_orcamento_itens(osv.Model):

    _inherit = 'orcamentos.orcamento.itens'

    def init(self, cr):
        cr.execute("""delete
                      from ir_act_report_xml
                      where model = 'orcamentos.orcamento.capa' and
                      report_rml != 'addons/madeireira/report/rel_impressao_orcamento.rml'
                      """)

    def orcori_onchange_volume(self, cr, uid, ids, produto_id, quantidade, valor_unitario_bruto,
                               desconto_total, comprimento, largura, espessura, pessoa_id,
                               context=None):

        context = context and context.copy() or {}
        obj_madeireira_utils = self.pool.get('madeireira.utils')
        volume = obj_madeireira_utils.madutl_calcula_volume(
            quantidade, comprimento, largura, espessura, self, 'orcori_volume')

        quantidade = volume or quantidade

        if produto_id:
            valida_variacao = obj_madeireira_utils.madpro_valida_variacao(
                cr, uid, produto_id, comprimento, espessura, context)

            if valida_variacao.get('warning'):
                valida = valida_variacao['value']
                value = {
                    'orcori_comprimento': valida['comprimento'],
                    'orcori_espessura': valida['espessura']
                }
                valida_variacao['value'] = value
                return valida_variacao
            else:
                vr_variacao = valida_variacao.get('vr_variacao')
                if valor_unitario_bruto:
                    valor_unitario_bruto = obj_madeireira_utils.madutl_get_valor_com_fator(
                        cr, uid, produto_id, vr_variacao, pessoa_id, context)

        total_item = (valor_unitario_bruto * quantidade) - desconto_total
        res = {
            'valor_total': total_item, 'orcori_volume': volume,
            'valor_unitario_bruto': valor_unitario_bruto
        }

        return {'value': res}

    def orcori_onchange_medida(self, cr, uid, ids, orcori_medida_id, context=None):
        context = context and context.copy() or {}
        res = {
            'value': {
                'orcori_comprimento': 0,
                'orcori_largura': 0,
                'orcori_espessura': 0
            }
        }

        if orcori_medida_id:
            brw_madeireira_medida = self.pool.get('madeireira.medida').browse(
                cr, uid, orcori_medida_id, context)
            comprimento = brw_madeireira_medida.madmed_comprimento
            largura = brw_madeireira_medida.madmed_largura
            espessura = brw_madeireira_medida.madmed_espessura
            vals = {
                'orcori_comprimento': comprimento,
                'orcori_largura': largura,
                'orcori_espessura': espessura,
                'orcori_madmed_largura': largura,
                'orcori_madmed_espessura': espessura,
                'orcori_madmed_comprimento': comprimento
            }
            res['value'] = vals

        return res
