# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class orcamentos_orcamento_itens(osv.Model):
    """
    Tabela que contem os items dos orcamentos
    PREFIXO PARA CRIAÇÃO DE CAMPOS: orcori_
    """
    from funcoes import orcori_get_volume, orcori_get_sigla_embalagem

    _inherit = 'orcamentos.orcamento.itens'
    _columns = {
        'orcori_comprimento': fields.float('Comprimento(m)', digits=(5, 2),
                                           help="Comprimento da peca em metros"),
        'orcori_largura': fields.float('Largura(cm)', digits=(5, 2),
                                       help="Largura da peca em centimetros"),
        'orcori_espessura': fields.float('Espessura(cm)', digits=(5, 2),
                                         help="Espessura da peca em centimetros"),
        'orcori_volume': fields.function(orcori_get_volume, method=True, string="Volume",
                                         digits=(5, 4), store=True),
        'orcori_sigla_embalagem': fields.function(orcori_get_sigla_embalagem, method=True,
                                                  string="Sigla embalagem", type="char"),
        'orcori_medida_id': fields.many2one('madeireira.medida', 'Medida'),
        'orcori_madmed_largura': fields.related('orcori_medida_id', 'madmed_largura', type='float',
                                                store=False, relation='madeireira.medida',
                                                string='Medida largura'),
        'orcori_madmed_espessura': fields.related('orcori_medida_id', 'madmed_espessura',
                                                  type='float', store=False,
                                                  relation='madeireira.medida',
                                                  string='Medida espessura'),
        'orcori_madmed_comprimento': fields.related('orcori_medida_id', 'madmed_comprimento',
                                                    type='float', store=False,
                                                    relation='madeireira.medida',
                                                    string='Medida comprimento'),
    }
