# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class madeireira_medida(osv.Model):
    # prefixo: madmed_
    _name = 'madeireira.medida'
    _columns = {
        'id': fields.integer('Id'),
        'madmed_largura': fields.float('Largura', digits=(5, 2), help='Cadastrar a largura em centimetro (cm)'),
        'madmed_espessura': fields.float('Espessura', digits=(5, 2),
                                         help='Cadastrar a espessura em centimetro (cm)'),
        'madmed_comprimento': fields.float('Comprimento', digits=(5, 2),
                                           help='Cadastrar o comprimento em metro (m)')
    }
    _sql_constraints = [
        ('madmed_largura_uniq', 'unique (madmed_largura, madmed_espessura, madmed_comprimento)',
         'Essa medida ja existe!'.decode('utf-8')),
    ]
