# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class madeireira_produto_variacao(osv.Model):


    _name = 'madeireira.produto.variacao'
    _inherits = {
        'estoque.produto': 'madpro_produto_id',
        }
    _columns = {
        'id': fields.integer(),
        'madpro_produto_id': fields.many2one('estoque.produto', 'Produto', ondelete="restrict",
                                             required=True,
                                             domain="[('estpro_variacao','!=','S')]"),
        'madpro_variacao': fields.float('Variacao', digits=(15,2)),
        'madpro_fator': fields.float('Fator', digits=(11,8), required=True,
                                     help="Fator a ser aplicado ao preco do produto"),
    }

    _sql_constraints = [('codigo_uniq', 'unique (madpro_produto_id,madpro_variacao)',
                         'O produto e variacao precisam ser unicos!')]
