# -*- encoding: utf-8 -*-

import time
from openerp.report import report_sxw
from SigUtils.numero import getNumeroEditado
from pytz import timezone
from datetime import datetime


class rel_estoquepedidos_separacao(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context):
        super(rel_estoquepedidos_separacao, self).__init__(cr, uid, name, context=context)
        tz = context.get('tz') or 'Brazil/East'
        agora = datetime.now(timezone('UTC')).astimezone(timezone(tz))
        agora = str(agora)[11:19]
        obj_adm_util = self.pool.get('adm.utils')

        def remover_acentuacao(string):
            if not string:
                return ' '
            string = self.pool.get('adm.utils').admutl_remover_acentuacao(cr, uid, string)
            return string

        self.localcontext.update({
            'time': time,
            'sum': sum,
            'getNumeroEditado': obj_adm_util.admutl_get_valor_formatado,
            'int': int,
            'agora': agora,
            'removeAcentuacao': remover_acentuacao,
        })
        self.context = context


report_sxw.report_sxw('report.madeireira_estoquepedidos_separacao', 'estoquepedidos.pedido.capa',
                      'addons/madeireira/report/rel_impressao_estoquepedidos_separacao.rml',
                      parser=rel_estoquepedidos_separacao)
