#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.tests.common import TransactionCase
from sigaddons.config_teste import set_config


class TestMadeireiraUtils(TransactionCase):
    """
    Classe responsavel por testes unitarios dos metodos da classe madeireira_utils
    :author: Tiago Henrique Prates dos Santos <tiago.santos[at]siginformatica.com.br>
    """

    @classmethod
    def setUpClass(cls):
        set_config()

    def setUp(self):
        super(TestMadeireiraUtils, self).setUp()
        self.madeireira_utils = self.registry('madeireira.utils')
        self.quantidade = 10
        self.comprimento = 2.0
        self.largura = 20.0
        self.espessura = 5.0
        self.objeto = self.registry('estoquepedidos.pedido.item')
        self.campo = 'pedite_volume'

    def test_madutl_calcula_volume(self):
        res = self.madeireira_utils.madutl_calcula_volume(
            self.quantidade, self.comprimento, self.largura, self.espessura, self.objeto,
            self.campo)
        self.assertEqual(res, 0.2)
