# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv


class manutencao_corretiva(osv.Model):
    _name = 'manutencao.corretiva'
    _inherit = 'manutencao.corretiva'

    def button_confirmar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': 'C'}, context)
        return True

    def button_resolver(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': 'R'}, context)
        return True

    def button_cancelar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': 'A'}, context)
        return True

    def button_definir_atividades(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': 'D'}, context)
        return True

    def button_gerar_os(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        _company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'oservico.os', context=context)
        _pessoa_id = self.pool.get('res.company').browse(cr, uid, _company_id).rescon_pessoa_id.id
        brw_manutencao_corretiva = self.browse(cr, uid, ids, context=context)[0]
        vals = {
            'company_id': _company_id,
            'osvos_pessoa_id': _pessoa_id,
            'osvos_defeito_relatado': brw_manutencao_corretiva.mancor_descricao_problema,
            'osvos_observacoes': brw_manutencao_corretiva.mancor_observacao,
            'osvos_equip_serie': brw_manutencao_corretiva.mancor_equipamento_id.manmaq_serie,
            'osvos_equipamento_id': brw_manutencao_corretiva.mancor_equipamento_id.id,
            'osvos_data_previsao': brw_manutencao_corretiva.mancor_data_previsao,
        }
        _lista_servico = []
        for x in brw_manutencao_corretiva.mancor_corretiva_atividade_ids:
            _preco = self.pool.get('estoque.preco.venda').get_preco_venda(cr, uid, x.mancoa_servico_id.id)
            dados_preco_venda = _preco.get(x.mancoa_servico_id.id) or {}
            valor_preco_venda = dados_preco_venda.get('preco_venda')
            _servico = {
                'osvsrv_servico_id': x.mancoa_servico_id.id,
                'osvsrv_quantidade': 1,
                'osvsrv_preco_unitario': valor_preco_venda,
                'osvsrv_duracao_prevista': x.mancoa_duracao,
                'osvsrv_observacao': x.mancoa_observacao,
            }
            if x.mancoa_mecanico_id:
                _servico['osvsrv_mecanico_id'] = x.mancoa_mecanico_id.id
            _lista_servico.append((0, 0, _servico))
        if _lista_servico:
            vals['osvos_servicos_ids'] = _lista_servico
        res = self.pool.get('oservico.os').create(cr, uid, vals, context=context)
        self.write(cr, uid, ids, {'mancor_os_id': res, 'state': 'O'}, context=context)
        return res
