# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class manutencao_equipamento(osv.Model):
    """
    Cadastro de Máquinas para manutenção
    """
    _name = 'manutencao.equipamento'
    _inherit = 'manutencao.equipamento'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        res = super(manutencao_equipamento, self).create(cr, uid, vals, context=context)
        if vals.get('manmaq_localizacao_id'):
            vals_his = {
                'manloh_data': time.strftime('%Y-%m-%d'),
                'manloh_equipamento_id': res,
                'manloh_localizacao_id': vals.get('manmaq_localizacao_id'),
            }
            self.pool.get('manutencao.localizacao.historico').create(cr, uid, vals_his,
                                                                     context=context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        res = super(manutencao_equipamento, self).write(cr, uid, ids, vals, context=context)
        if vals.get('manmaq_localizacao_id'):
            for id in ids:
                vals_his = {
                    'manloh_data': time.strftime('%Y-%m-%d'),
                    'manloh_equipamento_id': id,
                    'manloh_localizacao_id': vals.get('manmaq_localizacao_id'),
                }
                self.pool.get('manutencao.localizacao.historico').create(cr, uid, vals_his,
                                                                     context=context)
        return res
