# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from SigUtils import datas


class manutencao_execucao(osv.Model):
    _name = 'manutencao.execucao'
    _inherit = 'manutencao.execucao'

    def manexe_incluir_proxima_previsao(self, cr, uid, ids, context=None):
        def _criar_por_data():
            _unidade = brw_manutencao_execucao.manexe_atividade_id.manatv_frequencia_unidade
            _fator = 1
            if _unidade == 'S':
                _fator = 7
            if _unidade == 'Q':
                _fator = 15
            if _unidade == 'M':
                _fator = 30
            if _unidade == 'A':
                _fator = 365
            _prazo = _fator * _frequencia
            _previsao = datas.calcVencimento(_data, _prazo)
            _vals = {
                'manexe_equipamento_id': _equipamento_id,
                'manexe_atividade_id': _atividade_id,
                'manexe_data_prevista': _previsao,
                'state': 'P',
            }
            self.create(cr, uid, _vals, context=context.update({'sem_previsao': True}))
            return True

        def _criar_por_medicao():
            #TODO
            return True

        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
        for brw_manutencao_execucao in self.browse(cr, uid, ids, context=context):
            _state = brw_manutencao_execucao.state
            if _state == 'P': #Já é previsao, não necessita gerar outra
                continue
            _equipamento_id = brw_manutencao_execucao.manexe_equipamento_id.id
            _atividade_id = brw_manutencao_execucao.manexe_atividade_id.id
            _id = brw_manutencao_execucao.id
            _prev_id = self.search(cr, uid, [('manexe_equipamento_id', '=', _equipamento_id),
                                             ('manexe_atividade_id', '=', _atividade_id),
                                             ('state', '=', 'P'),
                                             ('id', '!=', _id)], context=context)
            if _prev_id:
                continue # Não fazer nada, já existe outra previsao
            _data = brw_manutencao_execucao.manexe_data_realizada
            _frequencia = brw_manutencao_execucao.manexe_atividade_id.manatv_frequencia
            if brw_manutencao_execucao.manexe_equipamento_id.manmaq_tipo_manutencao == 'D':
                _criar_por_data()
                continue
            _criar_por_medicao()
        return True

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        res = super(manutencao_execucao, self).write(cr, uid, ids, vals, context=context)
        self.manexe_incluir_proxima_previsao(cr, uid, ids, context)
        return res

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if context.get('cadastro_execucao'):
            vals['state'] = 'R'
        res = super(manutencao_execucao, self).create(cr, uid, vals, context=context)
        if not context.get('sem_previsao'):
            self.manexe_incluir_proxima_previsao(cr, uid, res, context)
        return res