# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class manutencao_atividade(osv.Model):
    """
    Cadastro de atividades do plano de manutenção
    """
    #from funcoes import _manatv_get_equipamento

    _name = 'manutencao.atividade'
    _inherits = {
        'manutencao.parte': 'manatv_parte_id',
    }
    _columns = {
        'manatv_servico_id': fields.many2one('estoque.produto', 'Servico', required=True,
                                             select=True, domain="[('tipo', '=', 'S')]"),
        'manatv_prioridade': fields.selection([('A', 'Alta'), ('M', 'Media'), ('B', 'Baixa')],
                                              'Prioridade', size=1, required=True),
        'manatv_frequencia': fields.integer('Frequencia', required=True,
                                            help="Frequencia em que a atividade deve ser executada"),
        'manatv_frequencia_unidade': fields.selection([('H', 'Hora'), ('K', 'Kilometro'),
                                                       ('D', 'Dia'), ('S', 'Semana'),
                                                       ('Q', 'Quinzena'), ('M', 'Mes'),
                                                       ('A', 'Ano')], 'Unidade', size=1,
                                                      required=True),
        'manatv_limite': fields.integer('Limite', help="Limite alternativo"),
        'manatv_limite_unidade': fields.selection([('D', 'Dia'), ('S', 'Semana'), ('Q', 'Quinzena'),
                                                   ('M', 'Mes'), ('A', 'Ano')], 'Unidade', size=1),
        'manatv_duracao': fields.float('Duracao', float=(2,2), required=True,
                                       help="Tempo necessario para execucao da atividade"),
        'manatv_parte_id': fields.many2one("manutencao.parte", 'Parte', ondelete="restrict",
                                           required=True, select=True),
        'manatv_observacao': fields.text('Observacao'),
        'manatv_execucao_ids': fields.one2many('manutencao.execucao', 'manexe_atividade_id',
                                               'Execucao'),
        'manatv_servicos_ids': fields.one2many('oservico.servicos', 'osvsrv_atividade_id',
                                               'Servicos'),
        # 'manatv_equipamento_ids': fields.function(_manatv_get_equipamento, method=True,
        #                                         string='Equipamentos', type='one2many', store=False),
    }
    _defaults = {
        'manatv_prioridade': lambda *a: 'B',
    }

