# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class manutencao_corretiva(osv.Model):
    """
    Tabela de solicitação de manutenção corretiva
    """
    _name = 'manutencao.corretiva'
    _columns = {
        'id': fields.integer('Id', readonly=True),
        'name': fields.char('Descricao', size=64, required=True),
        'mancor_equipamento_id': fields.many2one("manutencao.equipamento", 'Equipamento',
                                                 ondelete="cascade", required=True, select=True),
        'mancor_falha_id': fields.many2one("manutencao.falha", 'Falha', ondelete="restrict",
                                           required=True, select=True),
        'mancor_descricao_problema': fields.text('Descricao do problema', required=True),
        'create_date': fields.datetime('Data', readonly=True),
        'mancor_funcionario_id': fields.many2one("rh.funcionario", 'Funcionario',
                                                 ondelete="restrict", required=True, select=True),
        'mancor_os_id': fields.many2one('oservico.os', 'Ordem de servico', ondelete="restrict",
                                        select=True),
        'state': fields.selection([('E', 'Esboco'), ('C', 'Confirmado'),
                                   ('D', 'Definindo atividades'), ('O', 'O.S.Gerada'),
                                   ('R', 'Realizado'), ('A', 'Cancelado')], 'Status',
            required=True, size=1),
        'mancor_prioridade': fields.selection([('B', 'Baixa'), ('M', 'Media'), ('A', 'Alta')],
                                              'Prioridade', size=1, required=True),
        'mancor_data_previsao': fields.date('Previsao de atendimento', select=True),
        'mancor_observacao': fields.text('Informacoes complementares'),
        'mancor_corretiva_atividade_ids': fields.one2many('manutencao.corretiva.atividade',
                                                          'mancoa_corretiva_id', 'Atividades'),
    }
    _defaults = {
        'state': lambda *a: 'E',
        'mancor_prioridade': lambda *a: 'M',
    }
    _order = 'create_date desc'
