# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class manutencao_equipamento(osv.Model):
    """
    Cadastro de Máquinas para manutenção
    """


    _name = 'manutencao.equipamento'
    _columns = {
        'name': fields.char('Descricao', size=45, required=True),
        'manmaq_tipo_manutencao': fields.selection([('M', 'Medicao'), ('D', 'Data')],
                                                   'Tipo de manutencao', required=True, size=1),
        'manmaq_codigo': fields.char('Codigo', size=10, required=True),
        'manmaq_prioridade': fields.selection([('A', 'Alta'), ('M', 'Media'), ('B', 'Baixa')],
                                              'Prioridade', size=1, required=True),
        'manmaq_modelo': fields.char('Modelo', size=30),
        'manmaq_serie': fields.char('Serie', size=30),
        'manmaq_centro_custo_id': fields.many2one("adm.empresa.centrocusto", 'Centro custo',
                                                  ondelete="restrict", select=True),
        'manmaq_equipamento_pai_id': fields.many2one("manutencao.equipamento", 'Equipamento pai',
                                                     ondelete="cascade", select=True),
        'manmaq_localizacao_id': fields.many2one("manutencao.localizacao", 'localizacao',
                                                 ondelete="restrict", select=True,
                                                 help="Informe a localizacao onde se encontra o equipamento"),
        'manmaq_observacao': fields.text('Informacoes complementares'),
        'manmaq_capacidade_potencia': fields.char('Capacidade/potencia', size=45),
        'manmaq_fornecedor_id': fields.many2one("financeiro.fornecedor", 'Fornecedor',
                                                ondelete="cascade", select=True),
        'manmaq_data_aquisicao': fields.date('Data de aquisicao'),
        'manmaq_valor_compra': fields.float('Valor da compra'),
        'manmaq_plano_id': fields.many2one("manutencao.plano", 'Plano de manutencao',
                                           ondelete="restrict", select=True),
        'manmaq_equipamento_ids': fields.one2many('manutencao.equipamento',
                                                  'manmaq_equipamento_pai_id', 'Equipamentos'),
        'manmaq_medicao_ids': fields.one2many('manutencao.medicao', 'manhor_equipamento_id',
                                              'medicao'),
        'manmaq_execucao_ids': fields.one2many('manutencao.execucao', 'manexe_equipamento_id',
                                               'Execucao'),
        'manmaq_oservico_os_ids': fields.one2many('oservico.os', 'osvos_equipamento_id', 'Os'),

        'manmaq_localizacao_historico_ids': fields.one2many('manutencao.localizacao.historico',
                                                            'manloh_equipamento_id', 'Historico'),
        'manmaq_corretiva_ids': fields.one2many('manutencao.corretiva', 'mancor_equipamento_id',
                                                'Corretiva'),

        'manmaq_categoria_ids': fields.many2many('oservico.categoria',
                                                    'manutencao_equipamento_m2m_os_categoria',
                                                    'mancre_equipamento_id','mancre_os_categoria_id',
                                                    'Categorias')

    }
    _defaults = {
        'manmaq_prioridade': lambda *a: 'B',
    }

