# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class manutencao_execucao(osv.Model):
    """
    Tabela que contem os planos executados ou a serem executados
    """
    from funcoes import _manexe_status_os
    _name = 'manutencao.execucao'
    _columns = {
        'manexe_equipamento_id': fields.many2one("manutencao.equipamento", 'Equipamento',
                                                 ondelete="restrict", required=True, select=True),
        'manexe_atividade_id': fields.many2one("manutencao.atividade", 'Atividade',
                                                     ondelete="restrict", required=True,
                                                     select=True),
        'manexe_data_prevista': fields.date('Data prevista'),
        'manexe_data_realizada': fields.date('Data realizada'),
        'manexe_os_id': fields.many2one('oservico.os', 'Os', select=True, ondelete="cascade"),
        'manexe_status_os': fields.function(_manexe_status_os, method=True, string='Descricao',
                                                type='char', store=False),
        'state': fields.selection([('P', 'Previsao'), ('R', 'Realizado')], 'Estado', required=True)
    }
    _order = 'manexe_data_realizada desc,manexe_equipamento_id,manexe_atividade_id'
    _defaults = {
        'state': lambda *a: 'R',
    }

