# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class manutencao_localizacao(osv.Model):
    """
    Cadastro de localizacao dos equipamentos
    """
    from funcoes import _get_nome_completo, name_get
    _name = 'manutencao.localizacao'
    _columns = {
        'name': fields.char('Descricao', size=45, required=True,
                            help='Localizacao do equipamento, sala, andar, predio, galpao, etc'),
        'parent_id': fields.many2one("manutencao.localizacao", 'Localizacao pai',
                                           ondelete="restrict", select=True),
        'manloc_localizacao_ids': fields.one2many('manutencao.localizacao', 'parent_id',
                                                 'Localizacao'),
        'manloc_equipamento_ids': fields.one2many('manutencao.equipamento', 'manmaq_localizacao_id',
                                                 'Equipamento'),
        'manloc_localizacao_historico_ids': fields.one2many('manutencao.localizacao.historico',
                                                           'manloh_localizacao_id', 'Historico'),
        'manloc_nome_completo': fields.function(_get_nome_completo, method=True, string='Descricao',
                                                type='char', store=False, select=True),
    }

