# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class manutencao_parte(osv.Model):
    """
    Cadastro de partes dos equipamentos no plano de manutenção
    """
    from funcoes import _get_nome_completo, name_get
    _name = 'manutencao.parte'
    _inherits = {
        'manutencao.plano': 'manpar_plano_id',
    }
    _columns = {
        'name': fields.char('Descricao', size=64, required=True),
        'manpar_plano_id': fields.many2one('manutencao.plano', 'Plano', required=True,
                                           ondelete="cascade", select=True),
        'parent_id': fields.many2one('manutencao.parte', 'Parte pai', ondelete="cascade",
                                     select=True),
        'manpar_atividade_ids': fields.one2many('manutencao.atividade', 'manatv_parte_id',
                                                'Atividade'),
        'manpar_nome_completo': fields.function(_get_nome_completo, method=True,
                                                string='Descricao completa',
                                                type='char', store=True, select=True),
        }
    _order = 'manpar_nome_completo'
