# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel França
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class manutencao_plano(osv.Model):
    """
    Cadastro de planos de manutenção
    """
    _name = 'manutencao.plano'
    _columns = {
        'name': fields.char('Descricao', size=64, required=True),
        'manpla_regime': fields.selection([('L', 'Leitura'), ('D', 'Data')], 'Regime', size=1),  #Somente para o primeiro nível
        'manpla_unidade_id': fields.many2one("estoque.embalagem.unidade", 'Unidade',
                                             ondelete="restrict", select=True), # Usado somente quando regime for
        'state': fields.selection([('E', 'Esboco'), ('A', 'Ativo'), ('S', 'Suspenso')], 'status',
                                  required=True, size=1),
        'manpla_observacao': fields.text('Informacoes complementares'),
        'manpla_parte_ids': fields.one2many('manutencao.parte', 'manpar_plano_id', 'Partes'),
        'manpla_equipamento_ids': fields.one2many('manutencao.equipamento', 'manmaq_plano_id',
                                                  'Equipamento'),

    }

    _defaults = {
        'state': lambda *a: 'E',
    }