# -*- coding: utf-8 -*-

from openerp.osv import fields, osv
import time
from SigUtils import datas


class wizard_gerar_os_preventiva(osv.TransientModel):
    _name = 'wizard.gerar.os.preventiva'

    def _get_data_final(self, cr, uid, context=None):
        context = context and context.copy() or {}
        _data = time.strftime('%Y-%m-%d')
        _ultimo = str(datas.calcUltimoDiaDoMes(_data))
        _data = str(_data)[:8] + _ultimo
        return _data

    _columns = {
        'data_inicial': fields.date('Data inicial', required=True),
        'data_final': fields.date('Data final', required=True),
        'equipamento_ids': fields.many2many("manutencao.equipamento",
                                            "wizard_gerar_os_m2m_equipamentos",
                                            'equipamento_id', 'wizard_id', 'Equipamentos'),
        'state': fields.selection([('E', 'Esboco'), ('P', 'Pesquisado'), ('G', 'Gerado')], 'State',
                                  size=1, required=True),
        'itens': fields.one2many("wizard.gerar.os.preventiva.itens", 'capa_id', 'Itens'),
    }
    _defaults = {
        'data_inicial': lambda *a: time.strftime('%Y-%m-%d'),
        'data_final': _get_data_final,
        'state': lambda *a: 'E',
    }

    def pesquisar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': 'P'}, context=context)
        return True


class wizard_gerar_os_preventiva_itens(osv.TransientModel):
    _name = "wizard.gerar.os.preventiva.itens"
    _inherits = {
        'manutencao.atividade': 'atividade_id',
    }
    _columns = {
        'capa_id': fields.many2one("wizard.gerar.os.preventiva", 'Capa', required=True),
        'atividade_id': fields.many2one("manutencao.atividade", 'Atividade', required=True,
                                        ondelete="cascade"),
    }
