# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################
#

from openerp.osv import osv
from SigUtils.formatastring import formataString

import logging
_logger = logging.getLogger(__name__)
from openerp.tools.translate import _
from SigUtils.numero import getNumeroEditado

class mkp_anuncios(osv.Model):
    _name = 'mkp.anuncios'
    _inherit = 'mkp.anuncios'

    def mkpanu_open_url(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        dados_anuncios = self.read(cr, uid, ids, ['mkpanu_anuncio_endereco'], context=context)[0]
        url = dados_anuncios.get('mkpanu_anuncio_endereco')
        return {
            'type': 'ir.actions.act_url',
            'url': url,
            'target': 'new'
        }

    def mkpanu_get_url_manutencao(self, cr, uid, ids, codigo_anuncio, codigo_mkp, context=None):
        """
        Metodo para pegar a url de manutencao de cada marketplace. Será sobrescrito
        :param cr:
        :param uid:
        :param ids:
        :param codigo_anuncio:
        :param codigo_mkp:
        :param context:
        :return:
        """
        _url = ''
        return _url

    def mkpanu_open_url_manutencao(self, cr, uid, ids, context=None):
        """
        Metodo para abrir a pagina do anuncio no marketplace para manutenção
        :param cr:
        :param uid:
        :param ids: Embora seja ids é sempre uma lista de 1 id
        :param context:
        :return:
        """
        context = context and context.copy() or {}
        if ids:
            dados_anuncios = self.read(cr, uid, ids[0], ['mkpanu_conta_id','mkpanu_codigo_anuncio'], context=context)
            conta_id = dados_anuncios.get('mkpanu_conta_id')[0]
            codigo_anuncio = dados_anuncios.get('mkpanu_codigo_anuncio')
            codigo_mkp = self.pool.get('mkp.marketplaces').mkpmkp_get_codigo(cr, uid, conta_id, context=None)
            _url = self.mkpanu_get_url_manutencao(cr, uid, ids, codigo_anuncio, codigo_mkp, context=context)
            if _url:
                return {
                    'type': 'ir.actions.act_url',
                    'url': _url,
                    'target': 'new'
                }
        return True

    def mkpanu_atualizar_preco_mkp(self, cr, uid, obj_id, cod_mkp, context=None):
        """
        metodo criado para ser sobrescrito pelos métodos particulares de cada marketplace
        :param cr:
        :param uid:
        :param _id:
        :param context:
        :return: dicionnário contendo codigo do marketplace
        """
        context = context and context.copy() or {}
        res = {'status': True, 'mensagem': ''}
        return res

    def mkpanu_atualizar_anuncio_mkp(self, cr, uid, obj_id, cod_mkp, context=None):
        """
        metodo criado para ser sobrescrito pelos métodos particulares de cada marketplace
        :param cr:
        :param uid:
        :param _id:
        :param context:
        :return: dicionnário contendo codigo do marketplace
        """
        context = context and context.copy() or {}
        res = {'status': True, 'mensagem': ''}
        return res

    def mkpanu_atualizar_saldo(self, cr, uid, id, conta_id, mkp_code, context=None):
        """
        metodo criado para ser sobrescrito pelos métodos particulares de cada marketplace
        :param cr:
        :param uid:
        :param _id:
        :param context:
        :return: dicionnário contendo codigo do marketplace
        """
        res = {'status': True, 'mensagem': ''}
        return res

    def mkpanu_enviar_dados_fiscais(self, cr, uid, brw_anuncio, context=None):
        context = context and context.copy() or {}
        return True

    def mkpanu_btn_enviar_dados_fiscais(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        # Para o botão, ids é sempre id
        if not ids:
            return True
        brw_anuncio = self.pool.get('mkp.anuncios').browse(cr, uid, ids[0], context=context)
        res = self.mkpanu_enviar_dados_fiscais(cr, uid, brw_anuncio, context=context)
        return res

    def mkpanu_btn_ativar(self, cr, uid, ids, context=None):
        # Para o botão, ids é sempre id
        if not ids:
            return True
        self.write(cr, uid, ids, {'mkpanu_estado': 'A', 'mkpanu_necessita_atualizar': False}, context=context)
        for _id in ids:
            dados_anuncio = self.read(cr, uid, _id, ['mkpanu_marketplace_integrador'], context=context)
            _code_mkp = dados_anuncio.get('mkpanu_marketplace_integrador')
            res = self.mkpanu_atualizar_anuncio_mkp(cr, uid, _id, _code_mkp, context=context)
            if res.get('status') == False:
                raise osv.except_osv(_('Atencao:'), res.get('mensagem'))
        return True

    def mkpanu_btn_exportar_um_anuncio(self, cr, uid, ids, context=None):
        _obj_acoes = self.pool.get('mkp.acoes')
        for an in self.browse(cr, uid, ids, context=context):
            vals = {
                'mkpaco_conta_id': an.mkpanu_conta_id.id,
                'mkpaco_objeto': 'A',
                'mkpaco_acao':'A',
                'mkpaco_id': an.id
            }
            _obj_acoes.create(cr, uid, vals, context=context)
        return True

    def mkpanu_montar_variacoes(self, cr, uid, brw_anuncio, incluir_preco=True, context=None):
        """
        Método para montar lista de dicionarios com variacoes para publidar no Marketplace
        @param cr:
        @param uid:
        @param brw_anuncio: browser do anuncio
        @param incluir_preco = True ou False, se é para incluir o preco no var
        @param context:
        @return:lista de dicionario de variacoes Ex.:
        [{'price': 1.00, 'available_quantity': 2, 'attribute_combinations':
             [{"name": 'AZ', "value_name": 'azul'}],'seller_custom_field' : '0000-az'}]
        """
        vals_var = []
        obj_prod_imagem = self.pool.get('estoque_img.produto')
        _local = brw_anuncio.mkpanu_conta_id.mkpcta_local_id.id
        obj_grade = self.pool.get('estoque.produto.grade')
        _valor = brw_anuncio.mkpanu_valor_promocao or brw_anuncio.mkpanu_valor or brw_anuncio.mkpanu_valor_sugerido
        for _brw_grade in brw_anuncio.mkpanu_produto_id.produto_grade_ids:
            # vals_grade = {}
            _company_id = brw_anuncio.mkpanu_conta_id.company_id.id
            context.update({'company_id': _company_id})
            _x = obj_grade.estpgr_get_saldo(cr, uid, [_brw_grade.id], 'D', _local, context=context)
            if _x.get(_brw_grade.id) < 1:
                _x[_brw_grade.id] = 0
            val_bar = []
            for brw_cod_barra in brw_anuncio.mkpanu_produto_id.automacao_ids:
                if not brw_cod_barra.active:
                    continue
                if _brw_grade.id == brw_cod_barra.grade_id.id:
                    if brw_cod_barra.autcba_tipo_barra == '13':
                         _barra = brw_cod_barra.codigo_barra[1:]
                         val_bar.append({'id': 'EAN', 'value_name': _barra})
            val_bar.append({'id': 'SELLER_SKU', 'value_name': '%s-%s' % (_brw_grade.produto_id.codigo.strip(), _brw_grade.grade)})
            _picture_grades = []
            for brw_imagens in _brw_grade.estpgr_imagem_ids:
                _imagem_mkp = obj_prod_imagem.estimg_imagem_mkp(cr, uid, brw_imagens.id,
                                                                brw_anuncio.mkpanu_marketplace_id.mkpmkp_codigo,
                                                                context=context)
                if _imagem_mkp:
                    _picture_grades.append(_imagem_mkp)
            for brw_imagens in brw_anuncio.mkpanu_produto_id.estpro_imagem_ids:
                if not brw_imagens.estimg_grade_id.id:
                    _imagem_mkp = obj_prod_imagem.estimg_imagem_mkp(cr, uid, brw_imagens.id,
                                                                    brw_anuncio.mkpanu_marketplace_id.mkpmkp_codigo,
                                                                    context=context)
                    if _imagem_mkp:
                        _picture_grades.append(_imagem_mkp)
            vals_grade = {
                'attribute_combinations': [{"name": brw_anuncio.mkpanu_produto_id.estpro_grade_descricao or 'Grade',
                    "value_name": _brw_grade.descricao,
                }],
                'seller_custom_field' : '%s-%s' % (brw_anuncio.mkpanu_produto_id.codigo.strip(), _brw_grade.grade),
            }
            if incluir_preco:
                vals_grade['price'] = _valor
            if not brw_anuncio.mkpanu_mercadofull:
                vals_grade['available_quantity'] = int(_x.get(_brw_grade.id) / brw_anuncio.mkpanu_quantidade)
            if _picture_grades:
                vals_grade['picture_ids'] = _picture_grades
            if val_bar:
                vals_grade['attributes'] = val_bar
            _id_no_mkp = False
            for brw_var in brw_anuncio.mkpanu_variacoes_ids:
                if brw_var.mkpanuv_grade_id.grade == _brw_grade.grade:
                    _id_no_mkp = brw_var.mkpanuv_id_no_mkp
                    break
            if _id_no_mkp:
                vals_grade['id'] = _id_no_mkp
            if vals_grade:
                vals_var.append(vals_grade)
        return vals_var

    def create(self, cr, uid, vals, context=None):
        if vals.get('mkpanu_anuncio_endereco'):
            if not ('http://' in vals.get('mkpanu_anuncio_endereco') or 'https://' in vals.get('mkpanu_anuncio_endereco')):
                vals['mkpanu_anuncio_endereco'] = 'http://' + vals.get('mkpanu_anuncio_endereco')
        res = super(mkp_anuncios, self).create(cr, uid, vals, context=context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, int):
            ids = [ids]
        if vals.get('mkpanu_anuncio_endereco'):
            if not ('http://' in vals.get('mkpanu_anuncio_endereco') or 'https://' in vals.get('mkpanu_anuncio_endereco')):
                vals['mkpanu_anuncio_endereco'] = 'http://' + vals.get('mkpanu_anuncio_endereco')
        idx = vals.keys()
        if 'mkpanu_valor_promocao' in idx:
            idx.pop(idx.index('mkpanu_valor_promocao'))
        if 'mkpanu_valor' in idx:
            idx.pop(idx.index('mkpanu_valor'))
        if 'mkpanu_fator_ajuste' in idx:
            idx.pop(idx.index('mkpanu_fator_ajuste'))
        if 'mkpanu_fator_ajuste' in idx:
            idx.pop(idx.index('mkpanu_fator_ajuste'))
        if 'mkpanu_necessita_atualizar' in idx:
            idx.pop(idx.index('mkpanu_necessita_atualizar'))
        if 'mkpanu_saldo' in idx:
            idx.pop(idx.index('mkpanu_saldo'))
        if len(idx) > 0:
            if not 'mkpanu_necessita_atualizar' in vals:
                vals['mkpanu_necessita_atualizar'] = True
        res = super(mkp_anuncios, self).write(cr, uid, ids, vals, context=context)
        for _dados_anuncio in self.read(cr, uid, ids, ['mkpanu_conta_id', 'mkpanu_mercadofull'], context=context):
            _objeto = False
            if ('mkpanu_valor_promocao' in vals.keys() or
                'mkpanu_valor' in vals.keys() or
                'mkpanu_fator_ajuste' in vals.keys()):
                _objeto = 'P'
            if not _dados_anuncio.get('mkpanu_mercadofull'):
                if 'mkpanu_saldo' in vals.keys():
                    if _objeto:
                        _objeto = 'A'
                    else:
                        _objeto = 'S'
            if len(idx) > 0:
                _objeto = 'A'
            if _objeto:
                vals_acoes = {
                    'mkpaco_conta_id': _dados_anuncio.get('mkpanu_conta_id')[0],
                    'mkpaco_objeto': _objeto,
                    'mkpaco_acao': 'A',
                    'mkpaco_id': _dados_anuncio.get('id')
                }
                if not (_objeto == 'A' and 'mkpanu_necessita_atualizar' in vals and vals['mkpanu_necessita_atualizar'] == False):
                    res = self.pool.get('mkp.acoes').create(cr, uid, vals_acoes, context=context)
        return res


    def name_search(self, cr, uid, name='', args=None, operator='ilike', context=None, limit=100):
        context = context and context.copy() or {}
        ids = []

        ids = self.search(cr, uid, [('mkpanu_codigo_anuncio', '=', name)], context=context)
        if ids:
            return self.name_get(cr, uid, ids, context)
        _codigo = None
        try:
            _codigo = int(name)
        except:
            pass
        ids = []
        if _codigo:
            dados_par_estoque = self.pool.get('adm.utils').admutl_get_parametros(cr, uid,
                                                                                 'estoque',
                                                                                 ['codigo_numerico',
                                                                                  'estpar_tamanho_codigo'],
                                                                                 context=context)
            if dados_par_estoque['codigo_numerico']:
                cod_interno = formataString(name.lstrip().lstrip('0').rstrip(),
                                            dados_par_estoque['estpar_tamanho_codigo'], '0',
                                            'E')
            args_codigo = [('codigo', '=', str(cod_interno))]
            ids = self.search(cr, uid, args_codigo, limit=limit, context=context)
        args.append(['name', operator, name])
        ids += self.search(cr, uid, args, limit=80 if limit else None, context=context)
        res = self.name_get(cr, uid, ids, context)
        return res

    def name_get(self, cr, uid, ids, context=None):
        if not len(ids):
            return {}
        context = context and context.copy() or {}
        reads = self.read(cr, uid, ids, ['mkpanu_codigo_anuncio', 'mkpanu_title', 'mkpanu_anuncio_tipo_id', 'mkpanu_valor',
                                         'mkpanu_frete'], context=context)
        res = []
        for record in reads:

            valor = getNumeroEditado(record['mkpanu_valor'])
            name = '%s-%s-%s-%s-%s' % (record['mkpanu_codigo_anuncio'], record['mkpanu_title'],
                                       record['mkpanu_anuncio_tipo_id'][1], record['mkpanu_frete'], valor)
            res.append((record['id'], name))
        return res

    def mkpanu_onchange_marketplace(self, cr, uid, ids, mkp_id, context=None):
        context = context and context.copy() or {}
        res = {}
        if mkp_id:
            obj_conta = self.pool.get('mkp.contas')
            conta_ids = obj_conta.search(cr, uid, [('mkpcta_marketplace_id', '=', mkp_id)], context=context)
            if len(conta_ids) == 1:
                res.update({'mkpanu_conta_id': conta_ids[0]})
            else:
                res.update({'mkpanu_conta_id': False})
            obj_anuncio_tipo = self.pool.get('mkp.anuncios.tipo')
            tipo_ids = obj_anuncio_tipo.search(cr, uid, [('mkpant_marketplace_id', '=', mkp_id)], context=context)
            if len(tipo_ids) == 1:
                res.update({'mkpanu_anuncio_tipo_id': tipo_ids[0]})
            else:
                res.update({'mkpanu_anuncio_tipo_id': False})
            obj_marketplace = self.pool.get('mkp.marketplaces')
            mkp_integrador = obj_marketplace.read(cr, uid, mkp_id, ['mkpmkp_codigo'], context=context)['mkpmkp_codigo']
            res.update({'mkpanu_marketplace_integrador': mkp_integrador})
        return {'value': res}

    def mkpanu_get_p_sugestao(self, cr, uid, brw_anuncio, context=None):
        """
        Calcular o preco de venda de um anuncio
        :param cr:
        :param uid:
        :param brw_anuncio:
        :param context:
        :return:
        """
        _per_acres = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', 'estpar_preco_perc_acrescimo', context=context).get(
            'estpar_preco_perc_acrescimo')
        _p_original = brw_anuncio.preco_venda * 100 / (100 + _per_acres)
        _p_venda = ((_p_original * brw_anuncio.mkpanu_quantidade) + brw_anuncio.mkpanu_valor_frete
                   + brw_anuncio.mkpanu_anuncio_tipo_id.mkpant_custo_fixo) \
                        * 100 / (100 - (brw_anuncio.mkpanu_anuncio_tipo_id.mkpant_custo_var + brw_anuncio.mkpanu_marketplace_id.mkpmkp_perc_aumento_pv))
        _p_venda = _p_venda * brw_anuncio.mkpanu_fator_ajuste
        return _p_venda

# Problemas conhecidos
#--------------------------------------------------
# Prob#1 - Situacao -> Pendente
# Item premium sem estoque(está pausado) não é reativado
# https://api.mercadolibre.com/items/MarketplaceB730949663 == Data-> {"status": "active", "available_quantity": 3}
# {"message":"Validation error","error":"validation_error","status":400,"cause":
#      [{"code":"item.status.invalid","message":"Is not possible to activate an item without stock."}]}
# Solução: É so inserir o estoque que o item é reativado
#--------------------------------------------------
#

