# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv



class mkp_anuncios_relacionamento(osv.Model):


    _inherit = 'mkp.anuncios.relacionamento'

    def mkpanur_criar_relacionamento(self, cr, uid, mkpanur_codigo_anuncio, _anuncio_relacionado, context=None):
        """
        Método para criar relacionamento entre codigos de anuncios (catalogo)
        :param cr:
        :param uid:
        :param mkpanur_codigo_anuncio: Codigo do anuncio original no marketplace (char)
        :param dados_notificacao: Codigos dos anuncios relacionados no marketplace (lista)
        :param context:
        :return: boolean
        """
        context = context and context.copy() or {}
        mkpanur_ids = self.search(cr, uid, [('mkpanur_codigo_anuncio', '=', mkpanur_codigo_anuncio)], context=context)
        if mkpanur_ids:
            self.unlink(cr, uid, mkpanur_ids, context=context)
        for _rel in _anuncio_relacionado:
            vals = {
                'mkpanur_codigo_anuncio': mkpanur_codigo_anuncio,
                'mkpanur_relacionado': _rel
            }
            self.create(cr, uid, vals, context=context)
        return True

