# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
import logging
from openerp.tools.translate import _


class mkp_categorias(osv.Model):
    _inherit = 'mkp.categorias'
    _logger = logging.getLogger(_inherit)

    def __init__(self, pool, cr):
        super(mkp_categorias, self).__init__(pool, cr)
        self._mkp_categ_default_company = []

    def mkpcat_get_company_default(self, cr, uid, mkp_id, context=None):
        _company_id = False
        sql = "select distinct company_id from mkp_categorias where mkpcat_marketplace_id = %s" % mkp_id
        cr.execute(sql)
        for dados in cr.dictfetchall():
            _company_id = dados.get('company_id')
            break
        return _company_id

#todo: Implementar unlink excluindo mo mkp se o mkp permitir(no caso prestashop), verificando se não tem produtos cadastrados para elas inclusive para as filhas
    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        obj_marketplace = self.pool.get('mkp.marketplaces')
        dados_mmkp = obj_marketplace.read(cr, uid, vals.get('mkpcat_marketplace_id'), ['mkpmkp_codigo'], context=context)
        if dados_mmkp and dados_mmkp.get('mkpmkp_codigo') in self._mkp_categ_default_company:
            _company_id = self.mkpcat_get_company_default(cr, uid, vals.get('mkpcat_marketplace_id'), context=context)
            context['sig_force_company'] = _company_id
        if not (vals and vals.get('name')):
            raise osv.except_osv(_('Atencao'), _('Uma categoria precisa ter um descricao! codigo: %s' % vals.get('mkpcat_codigo')))
        res = super(mkp_categorias, self).create(cr, uid, vals, context=context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if context.get('mkp_code'):
            if not isinstance(ids, (list, tuple)):
                ids = [ids]
            if vals.get('mkpcat_marketplace_id'):
                _mkp_id = vals.get('mkpcat_marketplace_id')
            else:
                _mkp_id = \
                self.read(cr, uid, ids, ['mkpcat_marketplace_id'], context=context)[0].get('mkpcat_marketplace_id')[0]
            dados_mmkp = self.pool.get('mkp.marketplaces').read(cr, uid, _mkp_id, ['mkpmkp_codigo'], context=context)
            if dados_mmkp and dados_mmkp.get('mkpmkp_codigo') in self._mkp_categ_default_company:
                _company_id = self.mkpcat_get_company_default(cr, uid, _mkp_id, context=context)
                context['sig_force_company'] = _company_id
        res = super(mkp_categorias, self).write(cr, uid, ids, vals, context=context)
        return res

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        for arg in args:
            if arg[0] == 'mkpcat_marketplace_id':
                _mkp_id = arg[2]
                dados_mmkp = self.pool.get('mkp.marketplaces').read(cr, uid, _mkp_id, ['mkpmkp_codigo'],
                                                                    context=context)
                if dados_mmkp and dados_mmkp.get('mkpmkp_codigo') in self._mkp_categ_default_company:
                    _company_id = self.mkpcat_get_company_default(cr, uid, _mkp_id, context=context)
                    context['sig_force_company'] = _company_id
                    break
        res = super(mkp_categorias, self).search(cr, uid, args, offset=offset, limit=limit, order=order,
                                                 context=context, count=count)
        return res

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not len(ids):
            return []
        dict = self.mkpcat_get_descricao_completa(cr, uid, ids, context=context)
        _keys = dict.keys()
        res = []
        for x in _keys:
            res.append((x, dict.get(x)))
        return res

    def mkpcat_get_descricao_completa(self, cr, uid, ids, context=None):
        """
        Função para montar o nome completo das categorias na estrutura de arvores (nomepai/filho/...)
        @cr:
        @uid:
        @ids: lista de ids das categorias
        @context:
        @return: dicionario que contem dicionario o nome completo das categorias
        """
        context = context and context.copy() or {}
        if not len(ids):
            return []
        res = {}
        for brw_categoria in self.browse(cr, uid, ids, context=context):
            _descricao_completa = ''
            _name = brw_categoria.name
            _brw_parent = brw_categoria.parent_id
            while _name:
                if _descricao_completa:
                    _descricao_completa = '%s > %s' % (_name, _descricao_completa)
                else:
                    _descricao_completa = _name
                _name = False
                if _brw_parent:
                    _name = _brw_parent.name
                    _brw_parent = _brw_parent.parent_id
            if not context.get('categoria_sem_codigo'):
                _descricao_completa = "%s-%s" % (brw_categoria.mkpcat_codigo, _descricao_completa)
            res[brw_categoria.id] = _descricao_completa
        return res

    def name_search(self, cr, uid, name='', args=[], operator='ilike', context=None, limit=100):
        """
        Busca tambem as categorias filhas
        """
        context = context and context.copy() or {}
        ids = []
        name = unicode(name)
        ids = self.search(cr, uid, [('mkpcat_codigo', '=', name)] + args, limit=limit, context=context)
        if ids:
            return self.name_get(cr, uid, ids)
        ids = self.search(cr, uid, [('name', operator, name)] + args, limit=limit, context=context)
        categoria_filhas = self.search(cr, uid, [('parent_id', 'child_of', ids)], context=context)
        if categoria_filhas:
            ids.extend(categoria_filhas)

        return self.name_get(cr, uid, ids)

    def mkpcat_pesquisar_categorias_no_mkp(self, cr, uid, mkp_ids, context=None):
        """
        Método a ser sobrescrito pelos metodos de cada parketplace
        :param uid:
        :param mkp_ids:
        :param context:
        :return:
        """
        res = False
        return res

    def mkpcat_buscar_atributos_no_mkp(self, cr, uid, ids, mkp_integrador, mkp_categ_code, context=None):
        """
        Método a ser sobrescrito pelos metodos de cada parketplace
        :param uid:
        :param mkp_ids:
        :param context:
        :return:
        """
        res = False
        return res

    def mkpcat_set_atributos_estoque(self, cr, uid, ids, context=None):
        for brw_categoria in self.browse(cr, uid, ids, [], context=context):
            for brw_atributo in brw_categoria.mkpcat_atributos_ids:
                _label = brw_atributo.label

    def mkpcat_pesquisar_categorias(self, cr, uid, ids, context=None):
        self._logger.info('Pesquisando categorias no Marketplace')
        mkp_ids = []
        if ids:
            for dados_cat in self.read(cr, uid, ids, ['mkpcat_marketplace_id'], context=context):
                mkp_ids.append(dados_cat.get('mkpcat_marketplace_id')[0])
        else:
            obj_mkp = self.pool.get('mkp.marketplaces')
            for mkp_id in obj_mkp.search(cr, uid, [], context=context):
                if self.pool.get('mkp.marketplaces').mkpmkp_verificar_se_comunica(cr, uid, mkp_id, context=context):
                    mkp_ids.append(mkp_id)
        res = self.mkpcat_pesquisar_categorias_no_mkp(cr, uid, mkp_ids, context=context)
        self._logger.info('Fim de pesquisa de categorias no Marketplace')
        return True

    def mkpcat_buscar_atributos(self, cr, uid, ids, context=None):
        self._logger.info('Buscando atributos no Marketplace')
        if not ids:
            return True
        dados_categ = self.read(cr, uid, ids[0], [], context=context)
        mkp_categ_code = dados_categ.get('mkpcat_codigo')
        if mkp_categ_code:
            mkp_integrador = dados_categ.get('mkpcat_mkp_codigo')
            res = self.mkpcat_buscar_atributos_no_mkp(cr, uid, ids, mkp_integrador,  mkp_categ_code, context=context)
            if not res:
                raise osv.except_osv(_('Atencao'), _('Este marketplace nao pesquisa atributos pela categoria'))
        self._logger.info('Fim de pesquisa de busca de atributos no Marketplace')
        return True

    def mkpcat_buscar_atributos_estoque(self, cr, uid, ids, context=None):
        if not ids:
            return True
        obj_mkp = self.pool.get('mkp.marketplaces')
        obj_mkp_categ_atributos = self.pool.get('mkp.categorias.atributos')
        obj_mkp_atributos = self.pool.get('mkp.atributos')
        brw_categ = self.browse(cr, uid, ids[0], context=context)
        if brw_categ.mkpcat_categoria_estoque_id:
            mkp_id = brw_categ.mkpcat_marketplace_id.id
            for brw_atributos in brw_categ.mkpcat_categoria_estoque_id.estcat_atributos_ids:
                _attr_id = brw_atributos.estatc_atributo_id.id
                _name = brw_atributos.estatc_atributo_id.name
                _sequence = 1
                args = [('mkpcatatr_estoque_atributo_id', '=', _attr_id)]
                _categ_attrib_ids = obj_mkp_categ_atributos.search(cr, uid, args, context=context)
                vals = {
                    'mkpcatatr_categoria_id': ids[0],
                    'mkpcatatr_estoque_atributo_id': _attr_id,
                    'mkpcatatr_label': _name,
                }
                if _categ_attrib_ids:
                    obj_mkp_categ_atributos.write(cr, uid, _categ_attrib_ids, vals, context=context)
                else:
                    obj_mkp_categ_atributos.create(cr, uid, vals, context=context)
                args = [('mkpatr_atributos_id', '=', _attr_id), ('mkpatr_marketplace_id', '=', mkp_id)]
                _mkp_atributos_ids = obj_mkp_atributos.search(cr, uid, args, context=context)
                if not _mkp_atributos_ids:
                    vals = {
                        'mkpatr_marketplace_id': mkp_id,
                        'mkpatr_atributos_id': _attr_id,
                        'name': _name
                    }
                    obj_mkp_atributos.create(cr, uid, vals, context=context)
        return True

    def mkpcat_cron_pesquisar_categorias(self, cr, uid, context=None):
        """
        Método chamado pelo cron para pesquisar categorias nos marketplaces
        @param cr:
        @param uid:
        @param context:
        @return: Sempre True
        """
        context = context and context.copy() or {}
        self.mkpcat_pesquisar_categorias(cr, uid, [], context=context)
        return True

    def mkpcat_onchange_mkpid(self, cr, uid, ids, mkp_id, context=None):
        context = context and context.copy() or {}
        obj_mkp = self.pool.get('mkp.marketplaces')
        dados_mkp = obj_mkp.read(cr, uid, mkp_id, [], context=context)
        mkp_integrador = dados_mkp.get('mkpmkp_codigo')
        return {'value': {'mkpcat_mkp_codigo': mkp_integrador}}
