# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
import logging

class mkp_marketplaces(osv.Model):
    _inherit = 'mkp.marketplaces'
    _logger = logging.getLogger(_inherit)

    def mkpmkp_btn_exportar_todos_saldos(self, cr, uid, ids, context=None):
        _obj_acoes = self.pool.get('mkp.acoes')
        for brw_mkps in self.browse(cr, uid, ids, context=context):
            for brw_anuncios in brw_mkps.mkpmkp_anuncios_ids:
                vals = {
                    'mkpaco_conta_id': brw_anuncios.mkpanu_conta_id.id,
                    'mkpaco_objeto': 'S',
                    'mkpaco_acao': 'A',
                    'mkpaco_id': brw_anuncios.id
                }
                res = _obj_acoes.create(cr, uid, vals, context=context)
        return True

    def mkpmkp_btn_exportar_todos_precos(self, cr, uid, ids, context=None):
        _obj_acoes = self.pool.get('mkp.acoes')
        for brw_mkps in self.browse(cr, uid, ids, context=context):
            for brw_anuncios in brw_mkps.mkpmkp_anuncios_ids:
                vals = {
                    'mkpaco_conta_id': brw_anuncios.mkpanu_conta_id.id,
                    'mkpaco_objeto': 'P',
                    'mkpaco_acao': 'A',
                    'mkpaco_id': brw_anuncios.id
                }
                res = _obj_acoes.create(cr, uid, vals, context=context)
        return True

    def mkpmkp_btn_exportar_todos_anuncios(self, cr, uid, ids, context=None):
        _obj_acoes = self.pool.get('mkp.acoes')
        for brw_mkps in self.browse(cr, uid, ids, context=context):
            for brw_anuncios in brw_mkps.mkpmkp_anuncios_ids:
                vals = {
                    'mkpaco_conta_id': brw_anuncios.mkpanu_conta_id.id,
                    'mkpaco_objeto': 'A',
                    'mkpaco_acao': 'A',
                    'mkpaco_id': brw_anuncios.id
                }
                res = _obj_acoes.create(cr, uid, vals, context=context)
        return True

    def mkpmkp_buscar_atributos_no_mkp(self, cr, uid, id,  mkp_integrador, context=None):
        """
        Método a ser sobrescrito pelos metodos de cada parketplace
        :param uid:
        :param mkp_ids:
        :param context:
        :return:
        """
        res = False
        return res


    def mkpmkp_buscar_atributos(self, cr, uid, ids, context=None):
        self._logger.info('Buscando atributos no Marketplace')
        if not ids:
            return True
        dados_mkp = self.read(cr, uid, ids[0], ['mkpmkp_codigo'], context=context)
        if isinstance(dados_mkp, list):
            dados_mkp = [0]
        mkp_integrador = dados_mkp.get('mkpmkp_codigo')
        res = self.mkpmkp_buscar_atributos_no_mkp(cr, uid, ids[0], mkp_integrador, context=context)
        self._logger.info('Fim de pesquisa de busca de atributos no Marketplace')
        return True

    def mkpmkp_get_id(self, cr, uid, codigo_mkp, context=None):
        """
        Retorna o id do Marketplace
        :param cr:
        :param uid:
        :param codigo_mkp: codigo do Marketplace
        :param context:
        :return: id do marketplace ou False
        """
        context = context and context.copy() or {}
        id = False
        ids = self.search(cr, uid,[('mkpmkp_codigo', '=', codigo_mkp)], context=context)
        if ids:
            id = ids[0]
        return id

    def mkpmkp_get_codigo(self, cr, uid, conta_id, context=None):
        """
        Retorna o codigo do Marketplace
        :param cr:
        :param uid:
        :param codigo_mkp: codigo do Marketplace
        :param context:
        :return: id do marketplace ou False
        """
        context = context and context.copy() or {}
        brw_conta = self.pool.get('mkp.contas').browse(cr, uid, conta_id, context=context)
        return brw_conta.mkpcta_marketplace_id.mkpmkp_codigo

    def mkpmkp_get_endereco_api(self, cr, uid, codigo_mkp, context=None):
        """
        retorna o endereço da api do Marketplace
        :param cr:
        :param uid:
        :param codigo_mkp: Codigo do Marketplace
        :param context:
        :return: string, com endereço da api or False
        """
        context = context and context.copy() or {}
        id = self.mkpmkp_get_id(cr, uid, codigo_mkp, context=context)
        res = False
        if id:
            dados = self.read(cr, uid, id, ['mkpmkp_api'], context=context)
            res = dados.get('mkpmkp_api')
        return res

    def mkpmkp_verificar_se_comunica(self, cr, uid, mkp_id, context=None):
        sql = "select mkpmkp_parar_comunicacao from mkp_marketplaces where id = %s" % mkp_id
        self.cr.execute(sql)
        dados = self.cr.dictfetchall()
        if dados.get('mkpmkp_parar_comunicacao'):
            return False
        return True
