# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
import logging


class mkp_mensagens(osv.Model):

    _inherit = 'mkp.mensagens'
    _logger = logging.getLogger(_inherit)

    def _needaction_domain_get(self, cr, uid, context=None):
        """
        Mostra a quantidade de mensagens não lidas

        :param cr: a linha atual do cursor do banco de dados,
        :param uid: o ID do usuario utilizado para a verificacao de perfil,
        :param context: um dicionario padrao para valores contextuais,
        :return: dominio utilizado para contar mensagens não lidas.

        :see: openerp/addons/base/ir/ir.needaction (class ir_needaction_mixin)
        :copyright: OpenERP SA.
        """
        context = context and context.copy() or {}
        return [('mkpmen_dono', '=', 'C'), ('mkpmen_data_leitura', '=', False)]


    def _mkpmen_atualizar_mensagem_mkp(self, cr, uid, brw_mensagem, context=None):
        """
        Método para ser sobrescrito pelos métodos de cada marketplace
        :param cr:
        :param uid:
        :param id:
        :param context:
        :return:
        """
        context = context and context.copy() or {}
        res = {'status': True, 'mensagem': ''}
        return res


    def mkpmen_atualizar_mensagem_mkp(self, cr, uid, id, context=None):
        """
        Envia mensagem para o marketplace correspondente
        @param cr:
        @param uid:
        @param id: id da mensagem a ser enviada
        @param context:
        @return: dicionario contendo id do anuncio e response ex.:{status: True/False, 'mensagem': 'Mensagem'}
                 response. quando response.raise_for_status() for None, tá tudo certo. Para pegar o erro use response.status_code
        """
        context = context and context.copy() or {}
        brw_mensagem = self.browse(cr, uid, id, context=context)
        res = self._mkpmen_atualizar_mensagem_mkp(cr, uid, brw_mensagem, context=context)
        return res
