# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class mkp_perguntas(osv.Model):
    _inherit = 'mkp.perguntas'

    def mkpper_set_resposta_mkp(self, cr, uid, pergunta_ml_id, resposta, conta_id, codigo_mkp, context=None):
        """
        Método a ser sobrescrito para cada marketplace.
        @param cr:
        @param uid:
        @param pedido: Número do pedido no M.L.
        @param context:
        @return: Sempre True
        """
        self._logger.info('Enviando respostas de perguntas')
        context = context and context.copy() or {}
        return True

    def mkpper_btn_responder(self, cr, uid, ids, context=None):
        res = False
        for brw_perguntas in self.browse(cr, uid, ids, context=context):
            pergunta_ml_id = brw_perguntas.mkpper_codigo_mkp
            resposta = brw_perguntas.mkpper_resposta
            conta_id = brw_perguntas.mkpper_conta_id.id
            # codigo_mkp = brw_perguntas.mkpper_conta_id.mkpcta_marketplace_id.mkpmkp_codigo
            res = self.pool.get('mkp.merliv').mkpMerLiv_set_resposta(cr, uid, pergunta_ml_id, resposta, conta_id, context)
            self.write(cr, uid, brw_perguntas.id, {'state': 'R'}, context=context)
        return res

    def _needaction_domain_get(self, cr, uid, context=None):
        """
        Mostra a quantidade de perguntas pendentes de respostas

        :param cr: a linha atual do cursor do banco de dados,
        :param uid: o ID do usuario utilizado para a verificacao de perfil,
        :param context: um dicionario padrao para valores contextuais,
        :return: dominio utilizado para contar perguntas pendentes.

        :see: openerp/addons/base/ir/ir.needaction (class ir_needaction_mixin)
        :copyright: OpenERP SA.
        """
        context = context and context.copy() or {}
        return [('state', '=', 'N')]


    def search(self, cr, user, args, offset=0, limit=None, order=None, context=None, count=False):
        res = []
        if not 'mkpper_conta_id' in str(args):
            _company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, user, 'mkp.perguntas', context=context)
            conta_ids = self.pool.get('mkp.contas').search(cr, user, [('company_id', '=', _company_id)],
                                                           context=context)
            if conta_ids:
                args.append(('mkpper_conta_id', 'in', tuple(conta_ids)))
        if 'mkpper_conta_id' in str(args):
            res = super(mkp_perguntas, self).search(cr, user, args, offset=offset, limit=limit, order=order,
                                                context=context, count=count)
        return res
