begin transaction;

insert into mkp_modelos
   (id, create_uid, create_date, write_date, write_uid, name, mkpmod_tipo, mkpmod_cabecalho, mkpmod_rodape)
   select id, create_uid, create_date, write_date, write_uid, name, mlmod_tipo, mlmod_cabecalho_html, mlmod_rodape_html from ml_modelos;
SELECT setval('mkp_modelos_id_seq', (SELECT MAX(id) FROM mkp_modelos));

insert into mkp_marketplaces (name, mkpmkp_codigo, mkpmkp_api, mkpmkp_pessoa_id, mkpmkp_modelo_id)
       values ('Mercado Livre', 'MerLiv', 'https://api.mercadolibre.com', 12, (select id from ml_modelos where mlmod_tipo = 'T' limit 1));

insert into mkp_contas (mkpcta_marketplace_id, name, mkpcta_saldo_percentual, mkpcta_local_id, mkpcta_host_erp, mkpcta_banco_erp, mkpcta_ml_app_id, mkpcta_ml_secret_key, mkpcta_ml_user_id, mkpcta_ml_token, mkpcta_ml_refresh_token, mkpcta_ml_code, mkpcta_ml_redirect_url, mkpcta_operacao_frete_id)
       values ((select id from mkp_marketplaces where mkpmkp_codigo = 'MerLiv'), 'M.L.Solear', 100, 3, 'https://mlapi.siginformatica.com.br', 'mlapi', (select estpar_ml_app_id from estoque_parametro where company_id=3), (select estpar_ml_secret_key from estoque_parametro where company_id=3),
                (select estpar_ml_user_id from estoque_parametro where company_id=3), (select estpar_ml_token from estoque_parametro where company_id=3), (select estpar_ml_refresh_token from estoque_parametro where company_id=3),
                (select estpar_ml_code from estoque_parametro where company_id=3), (select estpar_ml_redirect_url from estoque_parametro where company_id=3), (select estpar_ml_operacao_frete_id from estoque_parametro where company_id=3));

insert into mkp_anuncios_tipo
   (id, mkpant_marketplace_id, create_uid, create_date, write_date, write_uid, name, mkpant_codigo, mkpant_tipo_custo_fixo, mkpant_custo_fixo, mkpant_custo_var)
   select id, (select id from mkp_marketplaces where mkpmkp_codigo = 'MerLiv'), create_uid, create_date, write_date, write_uid, name, mlant_codigo, mlant_tipo_custo_fixo, mlant_custo_fixo, mlant_custo_var from ml_anuncios_tipo;
SELECT setval('mkp_anuncios_tipo_id_seq', (SELECT MAX(id) FROM mkp_anuncios_tipo));

insert into mkp_categorias
   (id, mkpcat_marketplace_id, create_uid, create_date, write_date, write_uid, name, mkpcat_codigo, mkpcat_descricao_completa, parent_id, active)
   select id, (select id from mkp_marketplaces where mkpmkp_codigo = 'MerLiv'), create_uid, create_date, write_date, write_uid, name, mlcat_codigo, mlcat_descricao_completa, parent_id, active from ml_categorias;
SELECT setval('mkp_categorias_id_seq', (SELECT MAX(id) FROM mkp_categorias));

insert into mkp_modelos_secao
   (id, create_uid, create_date, write_date, write_uid, name, sequence, mkpmsc_modelo_id, mkpmsc_cab_secao_html, mkpmsc_cab_secao_texto, mkpmsc_corpo_html, mkpmsc_corpo_texto)
   select id, create_uid, create_date, write_date, write_uid, name, sequence, mlmsc_modelo_id, mlmsc_cab_secao_html, mlmsc_cab_secao_html , mlmsc_texto_padrao, mlmsc_texto_padrao from ml_modelos_secao;
SELECT setval('mkp_modelos_secao_id_seq', (SELECT MAX(id) FROM mkp_modelos_secao));

insert into mkpml_anuncios
   (id, mkpanu_marketplace_id, mkpanu_conta_id, create_uid, create_date, write_date, write_uid, mkpanu_codigo_anuncio, mkpanu_anuncio_endereco, mkpanu_title, mkpanu_produto_id, mkpanu_quantidade, mkpanu_estado, mkpanu_valor, mkpanu_valor_promocao, mkpmlanu_anuncio_tipo_id, mkpmlanu_frete, mkpanu_valor_frete, mkpmlanu_retirar_em_maos, mkpmlanu_saldo, mkpanu_qtd_vendido, mkpmlanu_lucro_pvenda, mkpmlanu_lucro_pcusto, mkpanu_necessita_atualizar)
   select id, (select id from mkp_marketplaces where mkpmkp_codigo = 'MerLiv'), (select id from mkp_contas limit 1), create_uid, create_date, write_date, write_uid, mlanu_codigo_anuncio, mlanu_anuncio_endereco, mlanu_title, mlanu_produto_id, mlanu_quantidade, mlanu_estado, mlanu_valor, mlanu_valor_promocao, mlanu_anuncio_tipo_id, mlanu_frete, mlanu_valor_frete, mlanu_retirar_em_maos, mlanu_saldo, mlanu_qtd_vendido, mlanu_lucro_pvenda, mlanu_lucro_pcusto, mlanu_necessita_atualizar_ml from ml_anuncios;
SELECT setval('mkp_anuncios_id_seq', (SELECT MAX(id) FROM mkpml_anuncios));

insert into mkp_acoes
   (id, create_uid, create_date, write_date, write_uid, mkpaco_conta_id, mkpaco_objeto, mkpaco_acao, mkpaco_id, state, mkpaco_mensagem, mkpaco_prioridade)
   select id, create_uid, create_date, write_date, write_uid, (select id from mkp_contas limit 1), mlaco_objeto, mlaco_acao, mlaco_id, state, mlaco_mensagem, mlaco_prioridade from ml_acoes;
SELECT setval('mkp_acoes_id_seq', (SELECT MAX(id) FROM mkp_acoes));

insert into mkp_produto_marketplaces
   (mkpromkp_produto_id,mkpromkp_marketplace_id, mkpromkp_categoria_id)
   select distinct(mlanu_produto_id), (select id from mkp_marketplaces where mkpmkp_codigo = 'MerLiv'), estpro_categoria_ml_id from ml_anuncios
                left join estoque_produto ep on ep.id = mlanu_produto_id;

insert into mkp_produto_marketplaces_secao
   (id, create_uid, create_date, write_date, write_uid, sequence, mkppromkpsc_produto_mkp_id, mkppromkpsc_secao_id, mkppromkpsc_secao_texto,  mkppromkpsc_sobrepoe_acrescenta)
   select mas.id, mas.create_uid, mas.create_date, mas.write_date, mas.write_uid, mas.sequence, (select id from mkp_produto_marketplaces where mkpromkp_produto_id=mlanu_produto_id and mkpromkp_marketplace_id=(select id from mkp_marketplaces where mkpmkp_codigo = 'MerLiv')), mlans_secao_id, mlans_secao_texto, mlans_sobrepoe_acrescenta from ml_anuncios_secao mas
                 left join ml_anuncios ma on ma.id = mlans_anuncio_id;
SELECT setval('mkp_produto_marketplaces_secao_id_seq', (SELECT MAX(id) FROM mkp_produto_marketplaces_secao));

insert into mkp_anuncios_var
   (id, create_uid, create_date, write_date, write_uid, mkpmlanuv_anuncio_id, mkpmlanuv_grade_id, mkpmlanuv_id_no_mkp, mkpmlanuv_valor, sequence)
   select id, create_uid, create_date, write_date, write_uid, mlanuv_anuncio_id, mlanuv_grade_id, mlanuv_id_no_ml, mlanuv_valor, sequence from ml_anuncios_variacoes;
SELECT setval('mkp_anuncios_var_id_seq', (SELECT MAX(id) FROM mkp_anuncios_var));

insert into mkp_mensagens
   (id, create_uid, create_date, write_date, write_uid, mkpmen_conta_id ,mkpmen_codigo_mkp, mkpmen_data, mkpmen_data_recebimento, mkpmen_data_leitura, mkpmen_pedido_mkp, mkpmen_pedido_id, mkpmen_dono, name)
   select id, create_uid, create_date, write_date, write_uid, (select id from mkp_contas limit 1), mlmen_codigo_ml_id, mlmen_data, mlmen_data_recebimento, mlmen_data_leitura, mlmen_pedido_ml_id, mlmen_pedido_id, mlmen_dono, name from ml_mensagens;
SELECT setval('mkp_mensagens_id_seq', (SELECT MAX(id) FROM mkp_mensagens));

insert into mkp_notificacoes
   (id, create_uid, create_date, write_date, write_uid, mkpnot_conta_id, mkpnot_application, mkpnot_resource, mkpnot_loja, mkpnot_topic, mkpnot_attempts, state)
   select id, create_uid, create_date, write_date, write_uid, (select id from mkp_contas limit 1), mlnot_application, mlnot_resource, mlnot_ml_user, mlnot_topic, mlnot_attempts, state from ml_notificacoes;
SELECT setval('mkp_notificacoes_id_seq', (SELECT MAX(id) FROM mkp_notificacoes));

insert into mkp_perguntas
   (id, create_uid, create_date, write_date, write_uid, mkpper_conta_id, mkpper_codigo_mkp, mkpper_anuncio_id, mkpper_produto_id, name, mkpper_resposta, mkpper_data, mkpper_apelido, mkpper_cidade, state)
   select id, create_uid, create_date, write_date, write_uid, (select id from mkp_contas limit 1), mlper_codigo_ml_id, mlper_anuncio_id, mlper_produto_id, name, mlper_resposta, mlper_data, ml_apelido, mlper_cidade, state from ml_perguntas;
SELECT setval('mkp_perguntas_id_seq', (SELECT MAX(id) FROM mkp_perguntas));

insert into  mkp_produto_marketplace_imagens
   (mkprmkimg_produto_mkp_id, mkprmkimg_imagem_produto_id, sequence, mkprmkimg_codigo_no_mkp, mkprmkimg_endereco_mkp)
   select mpm.id, eip.id, eip.sequence, estimg_codigo_ml, estimg_endereco_ml
    from mkp_produto_marketplaces mpm, estoque_img_produto eip
    where estimg_produto_id = mkpromkp_produto_id;

insert into mkpml_pagamentos
       (id, create_uid, create_date, write_date, write_uid, mkpmlpag_marketplace_id, mkpmlpag_conta_id, mkpmlpag_payment_code, mkpmlpag_ml_order,mkpmlpag_valor_itens,mkpmlpag_frete_recebido,mkpmlpag_frete_custo, mkpmlpag_tarifa_ml, mkpmlpag_total_liquido, mkpmlpag_pedido_id)
       select id, create_uid, create_date, write_date, write_uid,
                (select id from mkp_marketplaces where mkpmkp_codigo = 'MerLiv'),
                (select id from mkp_contas limit 1), mlpag_payment_code, mlpag_ml_order,mlpag_valor_itens,mlpag_frete_recebido,mlpag_frete_custo, mlpag_tarifa_ml, mlpag_total_liquido, mlpag_pedido_id from ml_pagamentos;
SELECT setval('mkpml_pagamentos_id_seq', (SELECT MAX(id) FROM mkpml_pagamentos));

update estoquepedidos_pedido_parcela set pedprc_id_pagamento_mkp = pedprc_id_pagamento_ml,  pedprc_payment_mkp_type = pedprc_payment_ml_type;
update estoquepedidos_pedido_capa set pedcap_mkp_status = pedcap_ml_status, pedcap_mkp_tipo_anuncio = pedcap_ml_tipo_anuncio, pedcap_mkp_frete_free = pedcap_ml_frete_free,  pedcap_mkp_shipping = pedcap_ml_shipping, pedcap_mkp_item_titulo_id = pedcap_item_titulo_id, pedcap_mkp_frete_rec_titulo_id = pedcap_frete_rec_titulo_id, pedcap_mkp_frete_pag_titulo_id = pedcap_frete_pag_titulo_id, pedcap_mkp_tarifa_titulo_id = pedcap_tarifa_titulo_id;
update estoquepedidos_pedido_capa set pedcap_conta_id = 1 where pedcap_mkp_shipping is not null;
update fiscal_nf_capa set fisnfc_mkp_nro_pedido = fisnfc_ml_nro_pedido;
update financeiro_titulo set fintit_mkp_nro_pedido = fintit_ml_nro_pedido;
update ir_module_module set state = 'uninstalled' where name like 'ml%';
delete from ir_act_window where id in (select res_id from ir_model_data where module like 'ml%' and (model like 'ml%' or model like 'ir%'));
delete from ir_act_server where id in (select res_id from ir_model_data where module like 'ml%' and model = 'ir.actions.server');
delete from ir_cron where id in (select res_id from ir_model_data where module like 'ml%' and model = 'ir.cron');
delete from ir_model_constraint where model in (select id from ir_model where model like 'ml%');
delete from ir_model_constraint where model in (select id from ir_model where model like 'wizard.faturamento.pedido%');
delete from ir_model where model like 'ml%';
delete from ir_model where model like 'wizard.faturamento.pedido%';
delete from ir_ui_menu  where id in (select res_id from ir_model_data where module like 'ml%' and model = 'ir.ui.menu');
delete from ir_model_data where module like 'ml%' and (model like 'ml%' or model like 'ir%');
delete from ir_ui_view where model like 'ml%';
delete from ir_ui_view where model = 'wizard.faturamento.pedido.capa';
delete from ir_filters where model_id like 'ml%';
delete from ir_model_access where name = 'wizard.faturamento.pedido.capa';
delete from ir_model_data where model like 'ml%';
delete from ir_ui_view_sc where name like '%ML%';
delete from res_groups where id in (select res_id from ir_model_data where module like 'ml%' and model = 'res.groups');
delete from ir_model_data where module like 'ml%' and model = 'res.groups';
delete from adm_monitor_alertas_grupos where id in (select res_id from ir_model_data where module like 'ml%' and model = 'adm.monitor.alertas.grupos');
delete from ir_model_data where module like 'ml%' and model = 'adm.monitor.alertas.grupos';
delete from adm_monitor_alertas where id in (select res_id from ir_model_data where module like 'ml%' and model = 'adm.monitor.alertas');
delete from ir_model_data where module like 'ml%' and model = 'adm.monitor.alertas';
delete from websig_sql_sentencas where id in (select res_id from ir_model_data where module like 'ml%' and model = 'websig.sql.sentencas');
delete from ir_model_data where module like 'ml%' and model = 'websig.sql.sentencas';
delete from res_users where id in (select res_id from ir_model_data where module like 'ml%' and model = 'res.users');
delete from ir_model_data where module like 'ml%' and model = 'res.users';
delete from ir_model_data where name like 'ml_user_remoto%';
delete from ir_model_constraint where model in (select id from ir_model where model like 'wizard.acompanhamento.vendas%');
delete from ir_model where model like 'wizard.acompanhamento.vendas%';
delete from ir_ui_view where model like 'wizard.acompanhamento%';
delete from ir_model_data where name like 'ml_%';
delete from ir_ui_view where name like 'ml%';
delete from ir_ui_view where name in ('pedido.capa.venda.ml.tree', 'wizard.baixa.titulo.ml.form', 'estoquepedidos.pedido.capa.ml.inherit.form');
delete from ir_ui_view where arch like '%fisnfc_ml_nro_pedido%';
delete from ir_ui_view where arch like '%estsug_estado_para_ml%';
delete from ir_ui_view where arch like '%estfor_anuncio%';
delete from ir_ui_view where arch like '%estpar_ml_%';
delete from ir_ui_view where arch like '%estpro_garantia%' or arch like '%estpro_link_video%' or arch like '%estpro_descricao_reduzida%';
delete from ir_ui_view where arch like '%mlmen_%';
delete from ir_ui_view where arch like '%estimg_codigo_ml%';

delete from ir_model_data where id in (select imd.id from ir_model_data imd left join ir_act_window iaw on iaw.id = imd.res_id where model = 'ir.actions.act_window' and iaw.id is null);
delete from ir_ui_view_sc where id in (select sc.id from ir_ui_view_sc sc left join ir_ui_view iuv on iuv.id = sc.res_id where sc.resource='ir.ui.view' and iuv.id is null);
delete from ir_ui_view_sc where id in (select sc.id from ir_ui_view_sc sc left join ir_ui_menu ium on ium.id = sc.res_id  where sc.resource='ir.ui.menu' and ium.id is null);
delete from ir_values where id in (select iv.id from ir_values iv left join ir_ui_menu ium on ium.id = iv.res_id where iv.model = 'ir.ui.menu' and ium.id is null);
delete from ir_values where id in (select iv.id from ir_values iv left join ir_act_window iaw on iaw.id = cast(split_part(iv.value, ',', 2) as int) where iv.value like 'ir.actions.act_window,%' and iaw.id is null);

alter table estoque_produto drop column estpro_categoria_ml_id;
alter table estoque_parametro drop column estpar_ml_email_pedido_entregue;
alter table estoque_parametro drop column estpar_ml_email_pedido_enviado;
alter table estoque_parametro drop column estpar_ml_email_rastreamento;
alter table estoque_parametro drop column estpar_ml_email_pedido_novo;
alter table estoquepedidos_pedido_item drop column pedite_anuncio_id;
alter table estoque_produto drop column estpro_modelo_anuncio_id;
alter table estoque_fornecedor drop column estfor_anuncio;
alter table estoque_parametro drop column estpar_ml_condicao_gratis;
alter table estoque_parametro drop column estpar_ml_condicao_premium;
alter table estoque_parametro drop column estpar_ml_condicao_classico;
alter table estoque_parametro drop column estpar_ml_secret_key;
alter table estoque_parametro drop column estpar_ml_redirect_url;
alter table estoque_parametro drop column estpar_ml_refresh_token;
alter table estoque_parametro drop column estpar_ml_banco_erp_moved0;
alter table estoque_parametro drop column estpar_ml_user_id;
alter table estoque_parametro drop column estpar_ml_app_id;
alter table estoque_parametro drop column estpar_ml_porta_erp;
alter table estoque_parametro drop column estpar_ml_saldo_percentual;
alter table estoque_parametro drop column estpar_ml_token;
alter table estoque_parametro drop column estpar_ml_code;
alter table estoque_parametro drop column estpar_ml_local_id;
alter table estoque_parametro drop column estpar_ml_pessoa_id;
alter table estoque_parametro drop column estpar_ml_operacao_frete_id;
alter table estoque_parametro drop column estpar_ml_email_conta;
alter table estoque_parametro drop column estpar_ml_email_senha;
alter table estoque_parametro drop column estpar_ml_habilita_log;
alter table estoque_parametro drop column estpar_ml_banco_erp_moved1;
alter table estoque_parametro drop column estpar_ml_banco_erp_moved2;
alter table estoque_parametro drop column estpar_ml_host_erp;
alter table estoque_parametro drop column estpar_ml_banco_erp;
alter table estoque_parametro drop column estpar_ml_rastreio_nas_mensagens;
alter table estoque_produto drop column estpro_garantia;
alter table estoque_produto drop column estpro_link_video;
alter table estoque_produto drop column estpro_descricao_reduzida;
alter table estoque_img_produto drop column estimg_codigo_ml;
alter table estoque_img_produto drop column estimg_endereco_ml;
alter table estoquepedidos_pedido_parcela drop column pedprc_id_pagamento_ml;
alter table estoquepedidos_pedido_parcela drop column pedprc_payment_ml_type;
alter table estoquepedidos_pedido_capa drop column pedcap_item_titulo_id;
alter table estoquepedidos_pedido_capa drop column pedcap_frete_rec_titulo_id;
alter table estoquepedidos_pedido_capa drop column pedcap_frete_pag_titulo_id;
alter table estoquepedidos_pedido_capa drop column pedcap_tarifa_titulo_id;
alter table financeiro_parametros drop column finpar_ml_forma_pgto_id;
alter table financeiro_titulo drop column fintit_mkp_nro_pedido;
alter table wizard_baixa_titulo drop column wbt_ml_nro_pedido;
alter table wizard_baixa_titulo_detalhe drop column wbtd_ml_nro_pedido;
alter table fiscal_nf_capa drop column fisnfc_ml_nro_pedido;
delete from ir_model_fields where name in ('estimg_codigo_ml', 'estpro_categoria_ml_id', 'estpar_ml_email_pedido_entregue', 'estpar_ml_email_pedido_enviado', 'estpar_ml_email_rastreamento',
  'estpar_ml_email_pedido_novo', 'estpar_ml_email_pedido_novo', 'pedite_anuncio_id', 'estpro_modelo_anuncio_id', 'estpro_modelo_anuncio_id', 'estfor_anuncio', 'estpar_ml_condicao_gratis',
  'estpar_ml_condicao_premium', 'estpar_ml_condicao_classico', 'estpar_ml_secret_key', 'estpar_ml_redirect_url', 'estpar_ml_refresh_token', 'estpar_ml_user_id', 'estpar_ml_app_id');
delete from ir_model_fields where name in ('estpar_ml_porta_erp','estpar_ml_saldo_percentual', 'estpar_ml_token', 'estpar_ml_code', 'estpar_ml_local_id', 'estpar_ml_pessoa_id',
   'estpar_ml_operacao_frete_id', 'estpar_ml_email_conta', 'estpar_ml_email_senha', 'estpar_ml_habilita_log', 'estpar_ml_host_erp', 'estpar_ml_banco_erp', 'estpar_ml_rastreio_nas_mensagens',
   'estpro_garantia', 'estpro_link_video', 'estpro_descricao_reduzida', 'estimg_codigo_ml', 'estimg_endereco_ml', 'pedprc_id_pagamento_ml', 'pedprc_payment_ml_type', 'pedcap_item_titulo_id');
delete from ir_model where name in ('pedcap_frete_rec_titulo_id', 'pedcap_frete_pag_titulo_id', 'finpar_ml_forma_pgto_id','fintit_mkp_nro_pedido', 'wbt_ml_nro_pedido', 'wbtd_ml_nro_pedido',
   'fisnfc_ml_nro_pedido');

drop table ml_promocoes;
drop table ml_busca_anuncios_anuncios_wiz;
drop table ml_concorrentes_pesquisas;
drop table ml_concorrentes_anuncios;
drop table ml_anuncios_promocoes;
drop table ml_concorrentes_vendas;
drop table ml_concorrentes_vendas_semana;
drop table ml_produtos_secao;
drop table wizard_faturamento_pedido_conferencia;
drop table wizard_faturamento_pedido_detalhe;
drop table wizard_faturamento_pedido_mensagens;
drop table wizard_faturamento_pedido_perguntas;
drop table ml_perguntas;
drop table ml_mensagens;
drop table wizard_acompanhamento_vendas_anuncios;
drop table wizard_acompanhamento_vendas_itens;
drop table wizard_acompanhamento_vendas_capa;
drop table ml_categorias;
drop table ml_emails;
drop table ml_anuncios_secao_relacionamento;
drop table ml_anuncios_secao;
drop table ml_anuncios_variacoes;
drop table ml_pesquisas;
drop table ml_anuncios;
drop table ml_pagamentos;
drop table ml_usuarios_visitas;
drop table wizard_faturamento_pedido_capa;
drop table ml_anuncios_tipo;
drop table ml_modelos_secao;
drop table ml_modelos;
drop table ml_acoes;
drop table ml_busca_anuncios_produtos_wiz;
drop table ml_concorrentes_vendas_dia;
drop table ml_notificacoes;

alter table estoquepedidos_pedido_capa drop column pedcap_ml_shipping;
alter table estoquepedidos_pedido_capa drop column pedcap_ml_status;
alter table estoquepedidos_pedido_capa drop column pedcap_ml_tipo_anuncio;
alter table estoquepedidos_pedido_capa drop column pedcap_ml_frete_free;


-------
begin transaction;
--- Mercado Livre
delete from mkpml_anuncios where mkpanu_codigo_anuncio is null;
drop table if exists mkp_anuncios_variacoes;
insert into mkp_anuncios
   (mkpanu_title, mkpanu_valor_frete, mkpanu_estado, mkpanu_produto_id, mkpanu_necessita_atualizar, mkpanu_qtd_vendido, mkpanu_valor_promocao, mkpanu_marketplace_id, mkpanu_anuncio_endereco,
   mkpanu_quantidade, mkpanu_codigo_anuncio, mkpanu_conta_id,mkpanu_valor,mkpanu_lucro_pvenda, mkpanu_lucro_pcusto,mkpanu_retirar_em_maos,mkpanu_frete,mkpanu_anuncio_tipo_id,mkpanu_mercado_envios,
   mkpanu_saldo,create_uid,create_date,write_uid,write_date)
   select mkpanu_title, mkpanu_valor_frete,mkpanu_estado,mkpanu_produto_id,mkpanu_necessita_atualizar,mkpanu_qtd_vendido, mkpanu_valor_promocao, mkpanu_marketplace_id, mkpanu_anuncio_endereco,
   mkpanu_quantidade,mkpanu_codigo_anuncio,mkpanu_conta_id, mkpanu_valor, mkpmlanu_lucro_pvenda, mkpmlanu_lucro_pcusto, mkpmlanu_retirar_em_maos,mkpmlanu_frete,mkpmlanu_anuncio_tipo_id,mkpmlanu_mercado_envios,
   mkpmlanu_saldo,create_uid,create_date,write_uid,write_date from mkpml_anuncios;

insert into mkp_anuncios_secao
   (create_uid,write_date,write_uid,create_date,mkpans_secao_id,mkpans_anuncio_id,mkpans_sobrepoe_acrescenta,sequence,mkpans_secao_texto,mkpans_modelo_id)
   select create_uid,write_date,write_uid,create_date,mkpmlans_secao_id,
   (select id from mkp_anuncios
      where mkpanu_marketplace_id = (select id from mkp_marketplaces where mkpmkp_codigo = 'MerLiv') and
            mkpanu_codigo_anuncio = (select mkpanu_codigo_anuncio from mkpml_anuncios where id = mkpmlans_anuncio_id)),
   mkpmlans_sobrepoe_acrescenta,sequence,mkpmlans_secao_texto,mkpmlans_modelo_id from mkpml_anuncios_secao;

insert into mkp_anuncios_var
   (create_uid,write_date,write_uid,create_date,mkpanuv_grade_id, mkpanuv_valor, sequence, mkpanuv_anuncio_id, mkpanuv_id_no_mkp, mkpanuv_saldo)
   select create_uid,write_date,write_uid,create_date,mkpmlanuv_grade_id, mkpmlanuv_valor, sequence,
   (select id from mkp_anuncios
      where mkpanu_marketplace_id = (select id from mkp_marketplaces where mkpmkp_codigo = 'MerLiv') and
            mkpanu_codigo_anuncio = (select mkpanu_codigo_anuncio from mkpml_anuncios where id = mkpmlanuv_anuncio_id)),
   mkpmlanuv_id_no_mkp, mkpmlanuv_saldo
         from  mkpml_anuncios_var;

--- Prestashop
delete from mkpps_anuncios where mkpanu_codigo_anuncio is null;
insert into mkp_anuncios_tipo
   (mkpant_marketplace_id, name, mkpant_codigo) values ((select id from mkp_marketplaces where mkpmkp_codigo = 'PrtShp'), 'Unico', 'un');

insert into mkp_anuncios
   (mkpanu_title, mkpanu_valor_frete, mkpanu_estado, mkpanu_produto_id, mkpanu_necessita_atualizar, mkpanu_qtd_vendido, mkpanu_valor_promocao, mkpanu_marketplace_id, mkpanu_anuncio_endereco,
   mkpanu_quantidade, mkpanu_codigo_anuncio, mkpanu_conta_id,mkpanu_valor,mkpanu_lucro_pvenda, mkpanu_lucro_pcusto,mkpanu_anuncio_tipo_id,
   mkpanu_saldo,create_uid,create_date,write_uid,write_date)
   select mkpanu_title, mkpanu_valor_frete,mkpanu_estado,mkpanu_produto_id,mkpanu_necessita_atualizar,mkpanu_qtd_vendido, mkpanu_valor_promocao, mkpanu_marketplace_id, mkpanu_anuncio_endereco,
   mkpanu_quantidade,mkpanu_codigo_anuncio,mkpanu_conta_id, mkpanu_valor, mkppsanu_lucro_pvenda, mkppsanu_lucro_pcusto,
   (select id from mkp_anuncios_tipo where mkpant_marketplace_id = (select id from mkp_marketplaces where mkpmkp_codigo = 'PrtShp') and mkpant_codigo = 'un'),
   mkppsanu_saldo,create_uid,create_date,write_uid,write_date from mkpps_anuncios;

insert into mkp_anuncios_secao
   (create_uid,write_date,write_uid,create_date,mkpans_secao_id,mkpans_anuncio_id,mkpans_sobrepoe_acrescenta,sequence,mkpans_secao_texto)
   select create_uid,write_date,write_uid,create_date,mkppsans_secao_id,
   (select id from mkp_anuncios
      where mkpanu_marketplace_id = (select id from mkp_marketplaces where mkpmkp_codigo = 'PrtShp') and
            mkpanu_codigo_anuncio = (select mkpanu_codigo_anuncio from mkpps_anuncios where id = mkppsans_anuncio_id)),
   mkppsans_sobrepoe_acrescenta,sequence,mkppsans_secao_texto from mkpps_anuncios_secao;   

insert into mkp_anuncios_var
   (create_uid,write_date,write_uid,create_date,mkpanuv_grade_id, mkpanuv_valor, sequence, mkpanuv_anuncio_id, mkpanuv_id_no_mkp, mkpanuv_saldo)
   select create_uid,write_date,write_uid,create_date,mkppsanuv_grade_id, mkppsanuv_valor, sequence,
   (select id from mkp_anuncios
      where mkpanu_marketplace_id = (select id from mkp_marketplaces where mkpmkp_codigo = 'PrtShp') and
            mkpanu_codigo_anuncio = (select mkpanu_codigo_anuncio from mkpps_anuncios where id = mkppsanuv_anuncio_id)),
   mkppsanuv_id_no_mkp, mkppsanuv_saldo
         from  mkpps_anuncios_var;

--- SkyHub
delete from mkpsh_anuncios where mkpanu_codigo_anuncio is null;
insert into mkp_anuncios_tipo
   (mkpant_marketplace_id, name, mkpant_codigo) values ((select id from mkp_marketplaces where mkpmkp_codigo = 'SkyHub'), 'Unico', 'un');

insert into mkp_anuncios
   (mkpanu_title, mkpanu_valor_frete, mkpanu_estado, mkpanu_produto_id, mkpanu_necessita_atualizar, mkpanu_qtd_vendido, mkpanu_valor_promocao, mkpanu_marketplace_id, mkpanu_anuncio_endereco,
   mkpanu_quantidade, mkpanu_codigo_anuncio, mkpanu_conta_id,mkpanu_valor,mkpanu_lucro_pvenda, mkpanu_lucro_pcusto,mkpanu_anuncio_tipo_id,
   mkpanu_saldo,create_uid,create_date,write_uid,write_date)
   select mkpanu_title, mkpanu_valor_frete,mkpanu_estado,mkpanu_produto_id,mkpanu_necessita_atualizar,mkpanu_qtd_vendido, mkpanu_valor_promocao, mkpanu_marketplace_id, mkpanu_anuncio_endereco,
   mkpanu_quantidade,mkpanu_codigo_anuncio,mkpanu_conta_id, mkpanu_valor, mkpshanu_lucro_pvenda, mkpshanu_lucro_pcusto,
   (select id from mkp_anuncios_tipo where mkpant_marketplace_id = (select id from mkp_marketplaces where mkpmkp_codigo = 'SkyHub') and mkpant_codigo = 'un'),
   mkpshanu_saldo,create_uid,create_date,write_uid,write_date from mkpsh_anuncios;

insert into mkp_anuncios_secao
   (create_uid,write_date,write_uid,create_date,mkpans_secao_id,mkpans_anuncio_id,mkpans_sobrepoe_acrescenta,sequence,mkpans_secao_texto)
   select create_uid,write_date,write_uid,create_date,mkpshans_secao_id,
   (select id from mkp_anuncios
      where mkpanu_marketplace_id = (select id from mkp_marketplaces where mkpmkp_codigo = 'SkyHub') and
            mkpanu_codigo_anuncio = (select mkpanu_codigo_anuncio from mkpsh_anuncios where id = mkpshans_anuncio_id)),
   mkpshans_sobrepoe_acrescenta,sequence,mkpshans_secao_texto from mkpsh_anuncios_secao;   

insert into mkp_anuncios_var
   (create_uid,write_date,write_uid,create_date,mkpanuv_grade_id, mkpanuv_valor, sequence, mkpanuv_anuncio_id, mkpanuv_id_no_mkp, mkpanuv_saldo)
   select create_uid,write_date,write_uid,create_date,mkpshanuv_grade_id, mkpshanuv_valor, sequence,
   (select id from mkp_anuncios
      where mkpanu_marketplace_id = (select id from mkp_marketplaces where mkpmkp_codigo = 'SkyHub') and
            mkpanu_codigo_anuncio = (select mkpanu_codigo_anuncio from mkpsh_anuncios where id = mkpshanuv_anuncio_id)),
   mkpshanuv_id_no_mkp, mkpshanuv_saldo
         from  mkpsh_anuncios_var;


--- Tray
delete from mkptr_anuncios where mkpanu_codigo_anuncio is null;
insert into mkp_anuncios_tipo
   (mkpant_marketplace_id, name, mkpant_codigo) values ((select id from mkp_marketplaces where mkpmkp_codigo = 'Tray'), 'Unico', 'un');

insert into mkp_anuncios
   (mkpanu_title, mkpanu_valor_frete, mkpanu_estado, mkpanu_produto_id, mkpanu_necessita_atualizar, mkpanu_qtd_vendido, mkpanu_valor_promocao, mkpanu_marketplace_id, mkpanu_anuncio_endereco,
   mkpanu_quantidade, mkpanu_codigo_anuncio, mkpanu_conta_id,mkpanu_valor,mkpanu_lucro_pvenda, mkpanu_lucro_pcusto,mkpanu_anuncio_tipo_id,
   mkpanu_saldo,create_uid,create_date,write_uid,write_date)
   select mkpanu_title, mkpanu_valor_frete,mkpanu_estado,mkpanu_produto_id,mkpanu_necessita_atualizar,mkpanu_qtd_vendido, mkpanu_valor_promocao, mkpanu_marketplace_id, mkpanu_anuncio_endereco,
   mkpanu_quantidade,mkpanu_codigo_anuncio,mkpanu_conta_id, mkpanu_valor, mkptranu_lucro_pvenda, mkptranu_lucro_pcusto,
   (select id from mkp_anuncios_tipo where mkpant_marketplace_id = (select id from mkp_marketplaces where mkpmkp_codigo = 'Tray') and mkpant_codigo = 'un'),
   mkptranu_saldo,create_uid,create_date,write_uid,write_date from mkptr_anuncios;

insert into mkp_anuncios_secao
   (create_uid,write_date,write_uid,create_date,mkpans_secao_id,mkpans_anuncio_id,mkpans_sobrepoe_acrescenta,sequence,mkpans_secao_texto)
   select create_uid,write_date,write_uid,create_date,mkptrans_secao_id,
   (select id from mkp_anuncios
      where mkpanu_marketplace_id = (select id from mkp_marketplaces where mkpmkp_codigo = 'Tray') and
            mkpanu_codigo_anuncio = (select mkpanu_codigo_anuncio from mkptr_anuncios where id = mkptrans_anuncio_id)),
   mkptrans_sobrepoe_acrescenta,sequence,mkptrans_secao_texto from mkptr_anuncios_secao;   

insert into mkp_anuncios_var
   (create_uid,write_date,write_uid,create_date,mkpanuv_grade_id, mkpanuv_valor, sequence, mkpanuv_anuncio_id, mkpanuv_id_no_mkp, mkpanuv_saldo)
   select create_uid,write_date,write_uid,create_date,mkptranuv_grade_id, mkptranuv_valor, sequence,
   (select id from mkp_anuncios
      where mkpanu_marketplace_id = (select id from mkp_marketplaces where mkpmkp_codigo = 'Tray') and
            mkpanu_codigo_anuncio = (select mkpanu_codigo_anuncio from mkptr_anuncios where id = mkptranuv_anuncio_id)),
   mkptranuv_id_no_mkp, mkptranuv_saldo
         from  mkptr_anuncios_var;
