# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from datetime import datetime


class automacao_precos(osv.Model):
    """
    Tabela de automacao
    Utilizado pelos programas de venda, principalmente para autoservico

    # prefixo: autpre_

    """
    _inherit = 'automacao.precos'

    def write(self, cr, uid, ids, vals, context=None):
        _spg = self.pool.get
        context = context and context.copy() or {}
        if vals.get('preco_venda'):
            _per_acrescimo = _spg('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', 'estpar_preco_perc_acrescimo', context=context).get(
            'estpar_preco_perc_acrescimo')
            if _per_acrescimo:
                vals['preco_venda'] = vals.get('preco_venda') * (100 + _per_acrescimo) / 100
        res = super(automacao_precos, self).write(cr, uid, ids, vals, context)
        if 'preco_venda' in vals:
            if not isinstance(ids, (list, tuple)):
                ids = [ids]
            for dados_precos in self.read(cr, uid, ids, ['autpre_produto_id'], context=context):
                _prod_id = dados_precos.get('autpre_produto_id')[0]
                _spg('mkp.utils').mkputl_atualizar_preco_anuncios(cr, uid, [_prod_id], context=context)
        return res

    def create(self, cr, uid, vals, context=None):
        _spg = self.pool.get
        context = context and context.copy() or {}
        if vals.get('preco_venda'):
            _per_acrescimo = _spg('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', 'estpar_preco_perc_acrescimo', context=context).get(
            'estpar_preco_perc_acrescimo')
            if _per_acrescimo:
                vals['preco_venda'] = vals.get('preco_venda') * (100 + _per_acrescimo) / 100
        res = super(automacao_precos, self).create(cr, uid, vals, context)
        for dados_precos in self.read(cr, uid, [res], ['autpre_produto_id'], context=context):
            _prod_id = dados_precos.get('autpre_produto_id')[0]
            _spg('mkp.utils').mkputl_atualizar_preco_anuncios(cr, uid, [_prod_id], context=context)
        return res
