# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_produto_saldo(osv.Model):

    _inherit = 'estoque.produto.saldo'

    def create(self, cr, uid, vals, context=None):
        _spg = self.pool.get
        res = super(estoque_produto_saldo, self).create(cr, uid, vals, context=context)
        _produto_id = vals.get('produto_id') or False
        _local_id = vals.get('local_id') or False
        if _produto_id:
            _spg('mkp.utils').mkputl_atualizar_saldo_anuncios(cr, uid, [_produto_id], context=context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        _spg = self.pool.get
        res = super(estoque_produto_saldo, self).write(cr, uid, ids, vals, context=context)
        if ids:
            if not isinstance(ids, (list, tuple)):
                ids = [ids]
            _prod_ids = [x.get('produto_id') for x in self.read(cr, uid, ids, ['produto_id'], load='_classic_write',
                                                                context=context)]
            _spg('mkp.utils').mkputl_atualizar_saldo_anuncios(cr, uid, _prod_ids, context=context)
        return res

    def unlink(self, cr, uid, ids, context=None):
        _spg = self.pool.get
        res = super(estoque_produto_saldo, self).unlink(cr, uid, ids, context=context)
        _obj_anuncio = self.pool.get('mkp.anuncios')
        if ids:
            if not isinstance(ids, (list, tuple)):
                ids = [ids]
            _prod_ids = [x.get('produto_id') for x in self.read(cr, uid, ids, ['produto_id'], load='_classic_write',
                                                                context=context)]
            _spg('mkp.utils').mkputl_atualizar_saldo_anuncios(cr, uid, _prod_ids, context=context)
        return res

