# -*- encoding: utf-8 -*-
# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
from SigUtils import datas
from datetime import datetime
from openerp.tools import config
import logging

class estoquepedidos_pedido_capa(osv.Model):
    _inherit = 'estoquepedidos.pedido.capa'
    _logger = logging.getLogger(_inherit)

    def pedcap_ver_se_pode_faturar(self, cr, uid, id, context=None):
        """
        Metodo para verificar se todos pedidos estão pagos, deve ser sobrescrito por metodo de cada marketplace.
        Se retornar um False, não deixar faturar
        :param cr:
        :param uid:
        :param brw_pedido:  browse do pedido
        :return: True-Tudo ok / False-Nao faturar
        """
        res = True
        return res

    def pedcap_buscar_pedido_no_mkp(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        sql = 'select pedcap_integrador, pedcap_nro_pedido_externo, pedcap_conta_id, pedcap_mkp_carrinho_compras from estoquepedidos_pedido_capa where id in (%s)' % ','.join([str(i) for i in ids])
        cr.execute(sql)
        dados_pedido = cr.dictfetchall()
        _dados = {}
        if dados_pedido:
            pedcap_integrador = dados_pedido[0].get('pedcap_integrador')
            pedcap_order = dados_pedido[0].get('pedcap_nro_pedido_externo')
            _conta_id = dados_pedido[0].get('pedcap_conta_id')
            _carrinho = dados_pedido[0].get('pedcap_mkp_carrinho_compras')
            _dados = {'integrador': pedcap_integrador,
                          'order': pedcap_order,
                          'conta_id': _conta_id,
                          'carrinho': _carrinho,
                      }
        return {'status': True,
                'dados': _dados,
                'mensagem': '',
                }

    def pedcap_button_buscar_no_mkp(self, cr, uid, ids, context=None):
        res = self.pedcap_buscar_pedido_no_mkp(cr, uid, ids, context=None)
        if res.get('status') == False:
            raise osv.except_osv(_('Atencao!'), _('Nao consegui importar o pedido. %s') % res.get('mensagem'))
        return res

    def pedcap_cron_buscar_pedidos_no_mkp(self, cr, uid, context=None):
        context = context and context.copy() or {}
        self._logger.info('Cron pedcap_cron_buscar_pedidos_no_mkp-Inicio')
        sql = """
            SELECT id from estoquepedidos_pedido_capa where state = 'R' and tipo = 'V'
        """
        cr.execute(sql)
        for dados_pedido in cr.dictfetchall():
            _pedidos_ids = [dados_pedido.get('id')]
            res = self.pedcap_buscar_pedido_no_mkp(cr, uid, _pedidos_ids, context=None)
        self._logger.info('Cron pedcap_cron_buscar_pedidos_no_mkp-Fim')
        return True

    def button_validar(self, cr, uid, ids, context=None):
        for _id in ids:
            res_ok = self.pedcap_ver_se_pode_faturar(cr, uid, _id, context=context)
            if not res_ok:
                raise osv.except_osv(_('Atencao'), _('Pedido nao pode ser validado!'))
        res = super(estoquepedidos_pedido_capa, self).button_validar(cr, uid, ids, context=context)
        return res

    def _pedcap_get_modelo_nf(self, cr, uid, id, context=None):
        """
        Metodo para ser sobrescrito por outros módulos. para informar o modelo da nf
        Se não houver, por default retorna False, porque não tendo especifico, o método gerar nf vai pegar no parametro
        :param cr:
        :param uid:
        :param id: id do pedido
        :param context:
        :return: modelo nf id or False
        """
        res = super(estoquepedidos_pedido_capa, self)._pedcap_get_modelo_nf(cr, uid, id, context=context)
        if id:
            brw_pedido = self.pool.get('estoquepedidos.pedido.capa').browse(cr, uid, id, context=context)
            if brw_pedido.pedcap_conta_id and brw_pedido.pedcap_conta_id.mkpcta_modelo_nf_series:
                res = brw_pedido.pedcap_conta_id.mkpcta_modelo_nf_series.id
        return res

    def button_faturar_pedido(self, cr, uid, ids, context=None, destinatario_id=False, pedido_ids=[]):
        res = super(estoquepedidos_pedido_capa, self).button_faturar_pedido(cr, uid, ids, context=context,
                                                                            destinatario_id=destinatario_id,
                                                                            pedido_ids=pedido_ids)
        for _id in ids:
            sql = 'select pedcap_nro_pedido_externo, pedcap_conta_id from estoquepedidos_pedido_capa where id = %s' % _id
            cr.execute(sql)
            dados_pedido = cr.fetchone()
            if dados_pedido:
                _pedido_mkp = dados_pedido[0]
                _conta_id = dados_pedido[1]
                sql = 'select distinct nf_id from fiscal_nf_pedidos where pedido_id = %s' % _id
                cr.execute(sql)
                _nf_ids = filter(None, map(lambda x:x[0], cr.fetchall()))
                if _nf_ids:
                    vals = {
                        'fisnfc_mkp_nro_pedido': _pedido_mkp,
                        'fisnfc_mkp_conta_id': _conta_id,
                    }
                    if not _conta_id:
                        vals['fisnfc_nfe_indintermed'] = '0'
                    else:
                        sql = 'select mkpcta_mkp_cnpj_mkp, mkpcta_mkp_id_conta from mkp_contas where id = %s' % _conta_id
                        cr.execute(sql)
                        dados_conta = cr.dictfetchall()
                        if dados_conta[0].get('mkpcta_mkp_cnpj_mkp'):
                            vals['fisnfc_nfe_indintermed'] = '1'
                            vals['fisnfc_nfe_intermediador_cnpj'] = dados_conta[0].get('mkpcta_mkp_cnpj_mkp')
                            vals['fisnfc_nfe_intermediador_identificador'] = dados_conta[0].get('mkpcta_mkp_id_conta')
                        else:
                            vals['fisnfc_nfe_indintermed'] = '0'
                    self.pool.get('fiscal.nf.capa').write(cr, uid, _nf_ids, vals, context=context)
        return res


    def pedcap_btn_mkp_enviar_email(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return True

    def copy(self, cr, uid, id, default=None, context=None):
        context = context and context.copy() or {}
        if not default:
            default = {}
        default.update({'pedcap_mensagens_ids': []})
        res = super(estoquepedidos_pedido_capa, self).copy(cr, uid, id, default, context)
        return res

    def pedcap_cancelar_pedido_no_mkp(self, cr, uid, brw_pedido, context=None):
        """
        Metodo para cancelar pedio no mkp, deve ser sobrescrito por cada marketplace
        :param cr:
        :param uid:
        :param brw_pedido:
        :param context:
        :return:
        """
        context = context and context.copy() or {}
        return True

    def button_cancelar_mkp(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        for brw_pedido in self.browse(cr, uid, ids, context=context):
            if not (brw_pedido.pedcap_conta_id or brw_pedido.pedcap_nro_pedido_externo):
                raise osv.except_osv(_('Atencao'), _('Este pedido nao e de um marketplace!'))
            if not brw_pedido.pedcap_integrador:
                raise osv.except_osv(_('Atencao'), _('Nao consegui identificar o marketplace!'))
            self.pedcap_cancelar_pedido_no_mkp(cr, uid, brw_pedido, context=context)
        return True

    def _pedcap_get_tempo_entrega_item(self, cr, uid, brw_pedido, context=None):
        _diff = 0
        _hoje = self.pool.get('adm.utils').admutl_datetime_to_timezone(cr, uid, datetime.now(),
                                                                           formato='%Y-%m-%d')
        if brw_pedido.state == 'F' and brw_pedido.data_entrega:
            _diff = datas.calcDiferenca(brw_pedido.data_emissao, brw_pedido.data_entrega)
        else:
            _diff = datas.calcDiferenca(brw_pedido.data_emissao, _hoje)
        mkp_logo = {
            'Mercado Livre': 'marketplace/static/src/img/ml_logo.png',
            'Amazon': 'marketplace/static/src/img/amazon_logo.png',
            'Magazine Luiza': 'marketplace/static/src/img/magalu_logo.png',
            # 'Magalu': 'marketplace/static/src/img/magalu_logo.png',
            'Loja Tray': 'marketplace/static/src/img/tray_logo.png',
            'Americanas': 'marketplace/static/src/img/americanas_logo.png',
            'Shoptime': 'marketplace/static/src/img/shoptime_logo.png',
            'Submarino': 'marketplace/static/src/img/submarino_logo.png',
            'Carrefour': 'marketplace/static/src/img/carrefour_logo.png',
            'Olist': 'marketplace/static/src/img/olist_logo.png',
            'Shopee': 'marketplace/static/src/img/shopee_logo.png',
            'Loja Prestashop': 'marketplace/static/src/img/prestashop_logo.png',
            'Via Varejo': 'marketplace/static/src/img/viavarejo_logo.png',
            'Madeira Madeira': 'marketplace/static/src/img/madeira_logo.png',
            'company_id_%s' % brw_pedido.company_id.id: 'marketplace/static/src/img/company_%s_logo.png' % brw_pedido.company_id.id
        }
        mkp_banner = {
            'Mercado Livre': 'marketplace/static/src/img/ml_banner.png',
            'Amazon': 'marketplace/static/src/img/amazon_banner.png',
            'Magazine Luiza': 'marketplace/static/src/img/magalu_banner.png',
            # 'Magalu': 'marketplace/static/src/img/magalu_banner.png',
            'Loja Tray': 'marketplace/static/src/img/tray_banner.png',
            'Americanas': 'marketplace/static/src/img/americanas_banner.png',
            'Shoptime': 'marketplace/static/src/img/shoptime_banner.png',
            'Submarino': 'marketplace/static/src/img/submarino_banner.png',
            'Carrefour': 'marketplace/static/src/img/carrefour_banner.png',
            'Olist': 'marketplace/static/src/img/olist_banner.png',
            'Shopee': 'marketplace/static/src/img/shopee_banner.png',
            'Loja Prestashop': 'marketplace/static/src/img/prestashop_banner.png',
            'Via Varejo': 'marketplace/static/src/img/viavarejo_banner.png',
            'Madeira Madeira': 'marketplace/static/src/img/madeira_banner.png',
            'company_id_%s' % brw_pedido.company_id.id: 'marketplace/static/src/img/company_%s_banner.png' % brw_pedido.company_id.id,
        }
        _banner = _logo = ''
        _mkp = brw_pedido.pedcap_marketplace
        if _mkp == 'Mercado Livre':
            if brw_pedido.pedcap_full:
                if brw_pedido.pedcap_eshop:
                    mkp_logo['Mercado Livre'] = 'marketplace/static/src/img/mshop_full_logo.png'
                    mkp_banner['Mercado Livre'] = 'marketplace/static/src/img/mshop_full_banner.png'
                else:
                    mkp_logo['Mercado Livre'] = 'marketplace/static/src/img/ml_full_logo.png'
                    mkp_banner['Mercado Livre'] = 'marketplace/static/src/img/ml_full_banner.png'
            else:
                if brw_pedido.pedcap_eshop:
                    mkp_logo['Mercado Livre'] = 'marketplace/static/src/img/mshop_logo.png'
                    mkp_banner['Mercado Livre'] = 'marketplace/static/src/img/mshop_banner.png'
                else:
                    mkp_logo['Mercado Livre'] = 'marketplace/static/src/img/ml_logo.png'
                    mkp_banner['Mercado Livre'] = 'marketplace/static/src/img/ml_banner.png'
        if not _mkp:
            _mkp = 'company_id_%s' % brw_pedido.company_id.id
        try:
            if mkp_banner.get(_mkp):
                arq = '%s/%s' % (config.get('addons_path'), mkp_banner.get(_mkp))
                file_img = open(arq, 'r')
                _banner = file_img.read()
                file_img.close()
        except Exception as e:
            print(e)
            pass
        if _mkp:
            _logo = mkp_logo.get(_mkp)

        vals = {
            'pedcap_tempo_entrega': _diff,
            'pedcap_mkp_logo_mkp': _logo,
            'pedcap_mkp_banner_mkp': _banner,
        }
        return vals

    def pedcap_ver_se_atualiza_saldo_anuncios(self, cr, uid, pedido_ids, context=None):
        """
        Verificar se eh para atualizar saldo dos anuncios dos itens do pedido
        """
        context = context and context.copy() or {}
        _spg = self.pool.get
        produto_ids = []
        if not isinstance(pedido_ids, (list,tuple)):
            pedido_ids = [pedido_ids]
        _esboco_reserva = _spg('adm.utils').admutl_get_parametros(cr, uid, 'estoque', ['estpar_esboco_na_reserva'],
                                                                  context=context)['estpar_esboco_na_reserva']
        for brw_pedido in self.browse(cr, uid, pedido_ids, context=context):
            if brw_pedido.tipo == 'C':
                continue
            if brw_pedido.state not in ('R', 'V', 'C'):
                continue
            for brw_itens in brw_pedido.pedido_item_ids:
                produto_ids.append(brw_itens.produto_id.id)
        context['company_id'] = brw_pedido.company_id.id
        if produto_ids:
            context['company_id'] = brw_pedido.company_id.id
            _spg('mkp.utils').mkputl_atualizar_saldo_anuncios(cr, uid, produto_ids, context=context)
        return True

    def write(self, cr, uid, ids, vals, context=None):
        _spg = self.pool.get
        res = super(estoquepedidos_pedido_capa, self).write(cr, uid, ids, vals, context=context)
        if vals.get('state'):
            self.pedcap_ver_se_atualiza_saldo_anuncios(cr, uid, ids, context=context)
        return res

    def create(self, cr, uid, vals, context=None):
        _spg = self.pool.get
        res = super(estoquepedidos_pedido_capa, self).create(cr, uid, vals, context=context)
        self.pedcap_ver_se_atualiza_saldo_anuncios(cr, uid, [res], context=context)
        return res

