# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

import time
from openerp.osv import osv, fields


class estoquepedidos_pedido_capa(osv.Model):
    _inherit = 'estoquepedidos.pedido.capa'
    from funcoes import _pedcap_get_tempo_entrega, _pedcap_get_marketplace

    _columns = {
        # todo: mudar status para selecion
        #         _dict_status_ml = {'paid': 'Pago', 'confirmed': 'Confirmado', 'payment_in': 'Em pagamento',
        #                            'cancelled': 'Cancelada', 'payment_required': 'Aguardando pagamento'}
        'pedcap_conta_id': fields.many2one('mkp.contas', 'Conta Marketplace', select=True),
        'pedcap_integrador': fields.related('pedcap_conta_id', 'mkpcta_integrador', type="char",
                                            string='Integrador', store=True, size=6, select=True),
        'pedcap_marketplace': fields.function(_pedcap_get_marketplace, method=True, string='Marketplace', type='char',
                                              size=20, store=True),
        'pedcap_mkp_status': fields.char('Status Marketplace', size=40, help='Status do pedido no Marketplace'),
        # TODO: MUDAR O TIPO DE ANUNCIO PARA M2O COM A CLASSE ANUNCIO TIPO
        'pedcap_mkp_tipo_anuncio': fields.char('Anuncio Marketplace', size=30, help='Tipo de anuncio no Marketplace'),
        'pedcap_mkp_frete_free': fields.float('Frete free', digits=(5,2), help='Custo do frete gratis'),
        'pedcap_mkp_shipping': fields.char('Shipping id do Marketplace', size=20),
        'pedcap_tempo_entrega': fields.function(_pedcap_get_tempo_entrega, method=True, string='Tempo entrega',
                                                type='integer', store=False, multi="dados"),
        'pedcap_valor_tarifa': fields.float('Valor da tarifa', digits=(7,2)),
        'pedcap_mkp_item_titulo_id': fields.many2one('financeiro.titulo', 'Titulo da venda', select=True),
        'pedcap_mkp_frete_rec_titulo_id': fields.many2one('financeiro.titulo', 'Titulo do frete a receber', select=True),
        'pedcap_mkp_frete_pag_titulo_id': fields.many2one('financeiro.titulo', 'Titulo do frete a pagar', select=True),
        'pedcap_mkp_tarifa_titulo_id': fields.many2one('financeiro.titulo', 'Titulo da tarifa Marketplace', select=True),
        'pedcap_mkp_mensagens_ids': fields.one2many('mkp.mensagens', 'mkpmen_pedido_id', 'Mensagens'),
        'pedcap_mkp_carrinho_compras': fields.char('Carrinho compras', size=30, select=1),
        'pedcap_mkp_logo_mkp': fields.function(_pedcap_get_tempo_entrega, method=True, string='Logo Mkp',
                                                type='char', size=60, store=False, multi="dados"),
        'pedcap_mkp_banner_mkp': fields.function(_pedcap_get_tempo_entrega, method=True, string='Banner Mkp',
                                               type='binary', store=False, multi="dados"),
        'pedcap_full': fields.boolean('Fullfiltment'),
        'pedcap_eshop': fields.boolean('eShop', help='Indentifica pedido do eShop do mkp!'),
        'pedcap_faturar_em': fields.date('Faturar em', help='Data em que o pedido pode ser faturado')
    }
    _defaults = {
        'pedcap_eshop': False,
        'pedcap_faturar_em': lambda *a: time.strftime('%Y-%m-%d'),
    }
