# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
import logging

_versao = '20G-001'
_logger = logging.getLogger('fiscal_nf_capa')


class fiscal_nf_capa(osv.Model):
    _inherit = 'fiscal.nf.capa'

    def fisnfc_faturar_nf_erp(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        parametro = self._parametros(cr, uid)

        def __criar_financeiro_frete_mkp():
            if not nf_dado.get('vr_frete'):
                _logger.info('=====> Lancando frete -> Pedido sem frete!')
                return True
            cta_frete = ''
            cta_frete += 'mkpcta_operacao_frete_id, '
            _pessoa_id = False
            if cta_frete:
                cta_frete = cta_frete[:-2]
                _sql = """SELECT pedcap_conta_id, mkpcta_integrador, mkpmkp_pessoa_id, %s
                          FROM   estoquepedidos_pedido_capa epc
                          LEFT JOIN mkp_contas on mkp_contas.id = pedcap_conta_id
                          LEFT JOIN mkp_marketplaces mm on mm.id =  mkpcta_marketplace_id
                          WHERE  epc.id in %s""" % (cta_frete, str(ped_ids).replace('[', '(').replace(']', ')'))
                cr.execute(_sql)
                cta_frete = False
                for dados in cr.dictfetchall():
                    cta_frete = dados.get('mkpcta_operacao_frete_id')
                    _pessoa_id = dados.get('mkpmkp_pessoa_id')
            if not (_pessoa_id or cta_frete):
                _logger.info('=====> Lancando frete -> mkp sem pessoa(%s) ou conta de frete(%s)!' % (_pessoa_id or '', cta_frete or ''))
                return True
            fat_id = self.pool.get('financeiro.fatura').create(
                cr, uid, {'company_id': nf_dado.get('company_id'),
                          'pessoa_id': _pessoa_id,
                          'data_emissao': nf_dado.get('data_emissao'), 'tipo_fatura': 'P',
                          'documento': str(nf_dado.get('numero_nf')).zfill(9),
                          'nf_id': nf_dado.get('id')}, context=context)
            context['fisnfc_tratar_exclusao'] = True
            context['fintit_titulo_sem_custificacao'] = True
            self.pool.get('financeiro').financ_titulo_entrada(
                cr, uid, fult_tit_pessoa_id=_pessoa_id,
                fult_tit_emissao=nf_dado.get('data_emissao')[0:10],
                fult_tit_vencimento=nf_dado.get('data_emissao')[0:10],
                fult_tit_documento=nf_dado.get('numero_nf'),
                fult_tit_parcela=99,
                fult_tit_valor=nf_dado.get('vr_frete'),
                fult_tit_tipo_lancamento='A',
                fult_tit_tipo_titulo='P',
                fult_tit_obs='Valor referente a Frete',
                fult_tit_fatura_id=fat_id, fult_tit_tipo_sacado='F',
                fult_tit_operacao_id=cta_frete, context=context)
            # Cria o movimento gerencial para o Frete deve ser feito fora do titulo
            if cta_frete:
                _sql = """SELECT finope_centro_custo_id,
                                 finope_evento_id
                          FROM financeiro_operacoes
                          WHERE id = %s""" % cta_frete
                cr.execute(_sql)
                dados_operacao = cr.dictfetchone()
                if dados_operacao:
                    vals_g_movimento = {'evento_id': dados_operacao.get('finope_evento_id'),
                                        'centro_custo_id': parametro.financeiro.finpar_centro_custo_venda_id,
                                        'valor': nf_dado.get('vr_frete'),
                                        'fingmo_historico': 'Valor referente a frete',
                                        'fingmo_data': nf_dado.get('data_emissao')[0:10],
                                        'fingmo_nf_id': nf_dado.get('id')}
                    self.pool.get('gerencial.movimento').create(cr, uid, vals_g_movimento, context)
            _logger.info('=====> Lancando frete -> Lancado Ok!')
            return True

        def __criar_financeiro_taxa_administracao_mkp():
            # Gerar Tarifa do Marketplace conforme o que está nas parcelas do pedido
            _sql = """SELECT pedcdc_mkp_tarifa, mkpmkp_pessoa_id
                      FROM   estoquepedidos_pedido_condicao
                      LEFT JOIN estoquepedidos_pedido_capa epc on epc.id = capa_id
                      LEFT JOIN mkp_contas on mkp_contas.id = pedcap_conta_id
                      LEFT JOIN mkp_marketplaces mm on mm.id = mkpcta_marketplace_id
                      WHERE  capa_id in %s""" % str(ped_ids).replace('[', '(').replace(']', ')')
            cr.execute(_sql)
            dados = cr.dictfetchall()
            if not dados:
                _logger.info('=====> Lancando Tx.adm -> Pedido Sem parcelas!')
                return True
            _pessoa_id = map(lambda m:m.get('mkpmkp_pessoa_id'), dados)[0]
            tem_tarifa = sum(map(lambda m: m.get('pedcdc_mkp_tarifa') or 0, dados)) > 0
            if not tem_tarifa:
                _logger.info('=====> Lancando Tx.adm -> Pedido sem tarifa!')
                return True
            fat_ids = self.pool.get('financeiro.fatura').search(
                cr, uid, [('nf_id', '=', nf_dado.get('id')), ('tipo_fatura', '=', 'P')],
                context=context)

            # Se ja houver uma fatura do tipo 'P' usa a mesma, caso contrario cria uma nova
            if fat_ids:
                fat_id = fat_ids[0]
            else:
                vals_fatura = {'company_id': nf_dado.get('company_id'),
                               'pessoa_id': _pessoa_id,
                               'data_emissao': nf_dado.get('data_emissao'), 'tipo_fatura': 'P',
                               'documento': str(nf_dado.get('numero_nf')).zfill(9),
                               'nf_id': nf_dado.get('id')}
                fat_id = self.pool.get('financeiro.fatura').create(cr, uid, vals_fatura, context)
            for _dado in dados:
                if _dado.get('pedcdc_mkp_tarifa') > 0:
                    context['fisnfc_tratar_exclusao'] = True
                    context['fintit_titulo_sem_custificacao'] = True
                    self.pool.get('financeiro').financ_titulo_entrada(
                        cr, uid,
                        fult_tit_pessoa_id= _pessoa_id,
                        fult_tit_emissao=nf_dado.get('data_emissao')[0:10],
                        fult_tit_vencimento=nf_dado.get('data_emissao')[0:10],
                        fult_tit_documento=nf_dado.get('numero_nf'),
                        fult_tit_parcela=98,
                        fult_tit_valor=_dado.get('pedcdc_mkp_tarifa'),
                        fult_tit_tipo_lancamento='A',
                        fult_tit_tipo_titulo='P',
                        fult_tit_obs='Valor referente a Taxa Marketplace',
                        fult_tit_fatura_id=fat_id,
                        fult_tit_tipo_sacado='F',
                        fult_tit_operacao_id=False,
                        context=context)
                    # Cria o movimento gerencial para taxa referente a condicao de pagamento do
                    # pedido, deve ser feito fora do titulo
                    if parametro.financeiro.usar_centro_custos_e_eventos:
                        vals_g_movimento = {
                            'evento_id': parametro.financeiro.finpar_evento_venda_taxa_adm_id,
                            'centro_custo_id': parametro.financeiro.finpar_centro_custo_venda_id,
                            'valor': _dado.get('pedcdc_mkp_tarifa'),
                            'fingmo_historico': 'Valor referente a tarifa Marketplace',
                            'fingmo_data': nf_dado.get('data_emissao')[0:10],
                            'fingmo_nf_id': nf_dado.get('id')}
                        self.pool.get('gerencial.movimento').create(cr, uid, vals_g_movimento,
                                                                    context)
            _logger.info('=====> Lancando Tx.adm -> Lancado Ok!')
            return True

        res = super(fiscal_nf_capa, self).fisnfc_faturar_nf_erp(cr, uid, ids, context=context)

        if res.get('state') != '3':  # Se a nota fiscal nao for faturada
            return res
        _sql = """SELECT id
                       , fisnfc_mkp_nro_pedido
                       , vr_frete
                       , company_id
                       , destinatario_id
                       , data_emissao
                       , numero_nf
                  FROM   fiscal_nf_capa
                  WHERE  id in (%s)""" % tuple(x for x in ids)
        cr.execute(_sql)
        nf_dados = cr.dictfetchall()
        fisnfc_forma_pgto_id = self.pool.get('adm.forma.pgto').search(
            cr, uid, [('sigla', '=', 'DN')], context=context)[0]
        for nf_dado in nf_dados:
            if nf_dado.get('fisnfc_mkp_nro_pedido'):
                _ped_id = nf_dado.get('fisnfc_mkp_nro_pedido')
                ped_ids = self.pool.get('estoquepedidos.pedido.capa').search(
                    cr, uid, [('pedcap_nro_pedido_externo', '=', _ped_id), ('tipo', '=', 'V')], context=context)
                _logger.info('MKP Versao %s Faturando NF:%s Pedido:%s' % (_versao, nf_dado.get('numero_nf'), _ped_id))
                __criar_financeiro_frete_mkp()
                __criar_financeiro_taxa_administracao_mkp()
                _sql = """
                  SELECT ft.id
                  FROM   financeiro_titulo ft
                  LEFT JOIN financeiro_fatura        AS ff
                         ON ff.id = ft.fatura_id
                  LEFT JOIN documento_documento_tipo AS ddp
                         ON ddp.id = ft.doc_tipo_id
                  WHERE  ddp.sigla != 'PRV' and ff.nf_id = %s""" % nf_dado.get('id')
                cr.execute(_sql)
                titulo_ids = filter(None, map(lambda x: x[0], cr.fetchall()))
                self.pool.get('financeiro.titulo').write(cr, uid, titulo_ids, {
                    'fintit_mkp_nro_pedido': nf_dado.get('fisnfc_mkp_nro_pedido')}, context=context)
                fields = ['id', 'parcela', 'state', 'vr_original']
                vals_pedido = {}
                for dados_titulo in self.pool.get('financeiro.titulo').read(
                        cr, uid, titulo_ids, fields, context=context):
                    if dados_titulo.get('parcela') == 98:
                        vals_pedido['pedcap_mkp_tarifa_titulo_id'] = dados_titulo.get('id')
                    elif dados_titulo.get('parcela') == 97:
                        vals_pedido['pedcap_mkp_frete_rec_titulo_id'] = dados_titulo.get('id')
                    elif dados_titulo.get('parcela') == 99:
                        vals_pedido['pedcap_mkp_frete_pag_titulo_id'] = dados_titulo.get('id')
                    else:
                        if dados_titulo.get('vr_original') == nf_dado.get('vr_frete'):
                            self.pool.get('financeiro.titulo').write(
                                cr, uid, dados_titulo.get('id'), {'parcela': 97}, context=context)
                            vals_pedido['pedcap_mkp_frete_rec_titulo_id'] = dados_titulo.get('id')
                        vals_pedido['pedcap_mkp_item_titulo_id'] = dados_titulo.get('id')

                    # Baixa todos os titulos em aberto
                    if dados_titulo.get('state') == 'A':
                        self.fisnfc_baixar_titulo(
                            cr, uid, dados_titulo.get('id'), fisnfc_forma_pgto_id, False,
                            context=context)
                _sql = """
                select pedprc_id_pagamento_mkp from estoquepedidos_pedido_parcela where pedido_id = %s 
                """ % ped_ids[0]
                cr.execute(_sql)
                doc_frete = False
                doc_venda = False
                for x in cr.fetchall():
                    if not doc_venda:
                        doc_venda = x[0]
                    else:
                        doc_frete = x[0]
                _sql = """
                      SELECT ft.id, ft.parcela, ftb.tesouraria_movimento_id
                      FROM   financeiro_titulo ft
                      left join financeiro_titulo_baixa as ftb
                             on ftb.titulo_id = ft.id
                      WHERE  fintit_mkp_nro_pedido = '%s'""" % _ped_id
                cr.execute(_sql)
                dados_tit = cr.dictfetchall()
                _sql = "update financeiro_tesouraria_movimento set fintem_documento = '%s' where id = %s"
                for tit in dados_tit:
                    _tes_id = tit.get('tesouraria_movimento_id')
                    if _tes_id:
                        if tit.get('parcela') == 99: # Titulo de Frete a pagar
                            if doc_frete:
                                cr.execute(_sql % (doc_frete, _tes_id))
                        else:
                            if doc_venda:
                                cr.execute(_sql % (doc_venda, _tes_id))

                if vals_pedido:
                    self.pool.get('estoquepedidos.pedido.capa').write(
                        cr, uid, ped_ids, vals_pedido, context=context)

        return res

    def write(self, cr, uid, ids, vals, context=None):
        res = super(fiscal_nf_capa, self).write(cr, uid, ids, vals, context=context)
        """
        Verificar se eh para atualizar saldo dos anuncios dos itens da nf
        """
        _spg = self.pool.get
        if not 'state' in vals:
            return res
        if not isinstance(ids, (list,tuple)):
            ids = [ids]
        produto_ids = []
        for brw_nota in self.browse(cr, uid, ids, context=context):
            if not brw_nota.state in ('2', 'C', 'D'):
                continue
            for brw_itens in brw_nota.estoque_movimento_itens_ids:
                produto_ids.append(brw_itens.produto_id.id)
        context['company_id'] = brw_nota.company_id.id
        _spg('mkp.utils').mkputl_atualizar_saldo_anuncios(cr, uid, produto_ids, context=context)
        return res


    def fisnfc_btn_faturar_no_mkp(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = self.pool.get('mkp.utils').mkputl_faturar_no_mkp(cr, uid, ids, context=context)
        if res.get('status'):
            return True
        raise osv.except_osv(_('Atencao'), res.get('mensagem'))

    def button_faturar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = super(fiscal_nf_capa, self).button_faturar(cr, uid, ids, context=context)
        if res.get('state') != '3':  # Se a nota fiscal nao for faturada
            return res
        self.pool.get('mkp.utils').mkputl_faturar_no_mkp(cr, uid, ids, context=context)
        return res

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
