# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from datetime import datetime
from openerp.tools.translate import _


class rastreio_eventos(osv.Model):
    _inherit = 'rastreio.eventos'


    def create(self, cr, uid, vals, context=None):
        _situacao = vals.get('raseve_situacao')
        _observacao = vals.get('raseve_observacao')
        _obj_encomenda = self.pool.get('rastreio.encomendas')
        brw_encomenda = _obj_encomenda.browse(cr, uid, vals.get('raseve_encomenda_id'), context=context)
        if (brw_encomenda and
           brw_encomenda.rasenc_pedido_id and
           brw_encomenda.rasenc_pedido_id.pedcap_conta_id and
           brw_encomenda.rasenc_pedido_id.pedcap_conta_id.mkpcta_marketplace_id and
           brw_encomenda.rasenc_pedido_id.pedcap_conta_id.mkpcta_marketplace_id.mkpmkp_rastreio_nas_mensagens):
           if not brw_encomenda.rasenc_pedido_id.pedcap_full:
               if _situacao and _situacao != 'Registrado':
                    _ped_mkp_id = brw_encomenda.rasenc_pedido_id.pedcap_nro_pedido_externo
                    _obj_mensagens = self.pool.get('mkp.mensagens')
                    _obj_acoes = self.pool.get('mkp.acoes')
                    if brw_encomenda.rasenc_pedido_id.tipo == 'V' and _ped_mkp_id:  # Pedido de venda
                        _data1 = datetime.strptime(vals.get('raseve_data_hora')[:-6], '%Y-%m-%d %H:%M:%S')
                        _datan = self.pool.get('adm.utils').admutl_datetime_to_timezone(cr, uid, _data1)
                        _datai = self.pool.get('adm.utils').admutl_datetime_to_timezone(cr, uid, _data1,
                                                                                        formato='%Y-%m-%d %H:%M:%S')
                        vals_mens = {
                            'mkpmen_conta_id': brw_encomenda.rasenc_pedido_id.pedcap_conta_id.id,
                            'mkpmen_data': _datai,
                            'mkpmen_pedido_mkp': _ped_mkp_id,
                            'mkpmen_pedido_id': brw_encomenda.rasenc_pedido_id.id,
                            'mkpmen_dono': 'L',
                            'name': 'Ola,\nacompanhe sua entrega:\n%s-%s' % (_datan, _observacao),
                        }
                        if 'postado' in _situacao and brw_encomenda.rasenc_pedido_id.pedcap_encomenda_id:
                            vals_mens['name'] = 'Ola,\nacompanhe sua entrega:\n%s-%s\nCodigo para rastreio:%s' % \
                                                (_datan, _situacao, str(brw_encomenda.rasenc_pedido_id.pedcap_encomenda_id.name))
                        args = [('mkpmen_pedido_mkp', '=', _ped_mkp_id), ('name', '=', vals_mens.get('name'))]
                        mens_ids = _obj_mensagens.search(cr, uid, args, context=context)
                        if not mens_ids:
                            mens_id = _obj_mensagens.create(cr, uid, vals_mens, context=context)
                            vals_aco = {
                                'mkpaco_conta_id': brw_encomenda.rasenc_pedido_id.pedcap_conta_id.id,
                                'mkpaco_objeto': 'M',
                                'mkpaco_acao': 'A',
                                'mkpaco_id': mens_id
                            }
                            _obj_acoes.create(cr, uid, vals_aco, context=context)
        res_create = super(rastreio_eventos, self).create(cr, uid, vals, context=context)
        if not res_create:
            return res_create
        _situacao = vals.get('raseve_situacao')
        if not _situacao:
            return res_create
        _encomenda_id = vals.get('raseve_encomenda_id')
        dados_encomenda = self.pool.get('rastreio.encomendas').read(cr, uid, _encomenda_id, ['rasenc_pedido_id', 'name'],
                                                                   load='_classic_write', context=context)
        _ped_id = dados_encomenda.get('rasenc_pedido_id')
        if not _ped_id:
            return res_create
        dados_pedido = self.pool.get('estoquepedidos.pedido.capa').read(cr, uid, _ped_id,
                                                                           ['pedcap_conta_id'],
                                                                           load='_classic_write', context=context)
        if isinstance(dados_pedido, list):
            dados_pedido = dados_pedido[0]
        _conta_id = dados_pedido.get('pedcap_conta_id')
        if not _conta_id:
            return res_create
        dados_conta = self.pool.get('mkp.contas').read(cr, uid, _conta_id, ['mkpcta_integrador'], context=context)
        mkp_integrador = dados_conta.get('mkpcta_integrador')
        if 'postado' in _situacao:
            data = vals.get('raseve_data_hora')
            codigo_rastreio = dados_encomenda.get('name')
            self.pool.get('mkp.utils').mkputl_postar_no_mkp(cr, uid, mkp_integrador, _conta_id, _ped_id, codigo_rastreio, data, context=context)
            return res_create
        return res_create
