# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _
from dateutil.parser import parse


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=200):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        title = center_title('', _('Avaliacao de Vendas'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='1')
        listagem.informaNome(pdf_string, _('Avaliacao de Vendas'))
        listagem.defineFonte(tam=7)
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)

        obj_tributacao_simples_nacional = pooler.get_pool(cr.dbname).get(
            'fiscal.tributacao.simples.nacional')
        categoria_produto_dict = datas.get('categoria_produto_dict')
        produto_dados = datas.get('produto_dados')
        comissao_mkp_dados = datas.get('comissao_mkp_dados')
        comissao_mkp_por_produto = datas.get('comissao_mkp_por_produto')
        tributacao_simples_nacional = datas.get('tributacao_simples_nacional')
        data_produto_dict = datas.get('data_produto_dict')

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'wizard.mkp.avaliacao.venda', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))

        tam_produto = 28
        tam_grade = 5
        tam_data = 10
        tam_categoria = 28
        tam_nf = 10
        tam_vr_vendido = 12
        tam_frete = 10
        tam_custo = 12
        tam_impostos = 10
        tam_custo_fixo = 10
        tam_com_mkp = 10
        tam_lucro = 12
        tam_luc_pv = 10
        tam_luc_pc = 10

        listagem.informaCab(title)
        listagem.informaCab('')
        listagem.informaCab(docs)
        listagem.informaCab('')

        filtros = []
        periodo = 'Periodo: {data_ini} a {data_fim}'
        ini = ''
        fim = ''
        for filtro in datas.keys():
            descricao = ''
            if filtro == 'agrupar':
                agrupamento = datas.get(filtro)
                descricao = 'Agrupar por: '
                descricao += (agrupamento == 'P' and 'Produto') or \
                             (agrupamento == 'C' and 'Categoria') or (agrupamento == 'D' and 'Data')
            if filtro == 'custo':
                custo = datas.get(filtro)
                descricao = 'Custo: '
                descricao += (custo == 'M' and 'Medio') or (custo == 'C' and 'Corrigido') or \
                             (custo == 'U' and 'Ultimo')
            if filtro == 'data_ini':
                ini =  datas.get(filtro)
            if filtro == 'data_fim':
                fim =  datas.get(filtro)
            if filtro == 'produto':
                descricao = 'Produto: ' + datas.get(filtro)
            if filtro == 'nf':
                descricao = 'NF: ' + datas.get(filtro)
            if filtro == 'categoria':
                descricao = 'Categoria: ' + datas.get(filtro)
            descricao and filtros.append(descricao)
        if ini or fim:
            filtros.append(periodo.format(data_ini=ini, data_fim=fim))
        filtros.sort()
        while filtros:
            if len(filtros) >= 3:
                listagem.informaCab(center_title(filtros[0], filtros[1], filtros[2], 190))
                filtros = filtros[3:]
            elif len(filtros) >= 2:
                listagem.informaCab(center_title(filtros[0], filtros[1], ''))
                filtros = filtros[2:]
            else:
                listagem.informaCab(center_title(filtros[0], '', ''))
                filtros = filtros[1:]
        listagem.informaCab('--')
        cab = formataString('PRODUTO', tam_produto, ' ', 'D', 'N', 'S') + ' '
        cab += formataString('GRADE', tam_grade, ' ', 'D', 'N', 'S') + ' '
        cab += formataString('DATA', tam_data, ' ', 'D', 'N', 'S') + ' '
        cab += formataString('CATEGORIA', tam_categoria, ' ', 'D', 'N', 'S') + ' '
        cab += formataString('NF', tam_nf, ' ', 'E', 'N', 'S') + ' '
        cab += formataString('VR. VENDIDO', tam_vr_vendido, ' ', 'E', 'N', 'S') + ' '
        cab += formataString('FRETE', tam_frete, ' ', 'E', 'N', 'S') + ' '
        cab += formataString('CUSTO', tam_custo, ' ', 'E', 'N', 'S') + ' '
        cab += formataString('IMPOSTOS', tam_impostos, ' ', 'E', 'N', 'S') + ' '
        cab += formataString('C. FIXO', tam_custo_fixo, ' ', 'E', 'N', 'S') + ' '
        cab += formataString('COM. MKP', tam_com_mkp, ' ', 'E', 'N', 'S') + ' '
        cab += formataString('LUCRO', tam_lucro, ' ', 'E', 'N', 'S') + ' '
        cab += formataString('% LUC.PV', tam_luc_pv, ' ', 'E', 'N', 'S') + ' '
        cab += formataString('% LUC.PC', tam_luc_pc, ' ', 'E', 'N', 'S')
        listagem.informaCab(cab)
        listagem.informaCab('--')
        listagem.informaCab('')
        listagem.rodapePadrao()

        vr_vendido_total = 0.0
        vr_frete_total = 0.0
        vr_custo_total = 0.0
        vr_custo_fixo_total = 0.0
        vr_com_mkp_total = 0.0
        vr_imposto_total = 0.0
        vr_lucro_total = 0.0

        nf_produto_list = []

        for dado in datas.get('dados'):
            vr_vendido = dado.get('vr_vendido') or 0
            vr_vendido_total += vr_vendido
            vr_frete = dado.get('vr_frete') or 0
            vr_frete_total += vr_frete
            vr_custo = dado.get('vr_custo') or 0
            vr_custo_total += vr_custo
            vr_custo_fixo = vr_vendido * (datas.get('custo_fixo') / 100.0)
            vr_custo_fixo_total += vr_custo_fixo
            vr_com_mkp = dado.get('com_mkp') or 0.0
            vr_imposto = not datas.get('simples_nacional') and (
                    dado.get('vr_imposto') or 0.0) or 0.0

            categoria_produto_ids = categoria_produto_dict and categoria_produto_dict.get(str(
                dado.get('categoria_id'))) or []
            if categoria_produto_ids:
                categoria_dados = filter(lambda c: c.get('produto_id') in categoria_produto_ids,
                                         produto_dados)
                if datas.get('simples_nacional'):
                    tributacao = obj_tributacao_simples_nacional.fistsn_calcula_aliquota_imposto(
                        cr, uid, categoria_produto_ids, context)
                    vr_imposto = sum(map(
                        lambda i: (tributacao.get(i.get('produto_id')) / 100.0) * i.get(
                            'vr_vendido'), categoria_dados))
                list_vr_com_mkp = []
                comissao_mkp_categoria = comissao_mkp_por_produto.values()
                map(lambda i: list_vr_com_mkp.append(sum(map(lambda p: p.get(str(i)) or 0.0,
                                                             comissao_mkp_categoria))),
                    categoria_produto_ids)
                vr_com_mkp = sum(list_vr_com_mkp)
            data_produto_ids = data_produto_dict and data_produto_dict.get(dado.get('data')) or []
            if data_produto_ids:
                data_dados = filter(lambda c: c.get('data') == dado.get('data')
                                              and c.get('produto_id') in data_produto_ids,
                                    produto_dados)
                if datas.get('simples_nacional'):
                    tributacao = obj_tributacao_simples_nacional.fistsn_calcula_aliquota_imposto(
                        cr, uid, data_produto_ids, context)
                    vr_imposto = sum(map(
                        lambda i: (tributacao.get(i.get('produto_id')) / 100.0) * i.get(
                            'vr_vendido'), data_dados))
                data_nf_ids = list(set(map(lambda n: n.get('nf_id'), data_dados)))
                vr_com_mkp = sum(map(lambda i: comissao_mkp_dados.get(str(i)) or 0, data_nf_ids))

            elif dado.get('produto_id'):
                if datas.get('simples_nacional'):
                    vr_imposto = (tributacao_simples_nacional.get(
                        str(dado.get('produto_id'))) / 100.0) * vr_vendido
                if datas.get('agrupar') == 'P':
                    vr_com_mkp = sum(map(lambda p: p.get(str(dado.get('produto_id'))) or 0.0,
                                         comissao_mkp_por_produto.values()))
                else:
                    nf_produto = str(dado.get('nf_id')) + '/' + str(dado.get('produto_id'))
                    vr_com_mkp = nf_produto not in nf_produto_list and comissao_mkp_por_produto.get(
                        str(dado.get('nf_id'))).get(str(dado.get('produto_id'))) or 0.0
                    nf_produto_list.append(nf_produto)

            vr_imposto_total += vr_imposto
            vr_com_mkp_total += vr_com_mkp

            vr_lucro = vr_vendido - vr_frete - vr_custo - vr_imposto - vr_custo_fixo - vr_com_mkp
            vr_lucro_total += vr_lucro
            vr_lucro_pv = vr_vendido and round((vr_lucro * 100.0) / vr_vendido, 2) or 0.0
            vr_lucro_pc = vr_custo and round((vr_lucro * 100.0) / vr_custo, 2) or 0.0

            linha = formataString(dado.get('produto') or '', tam_produto, ' ', 'D', 'N', 'S') + ' '
            linha += formataString(dado.get('grade') or '', tam_grade, ' ', 'D', 'N', 'S') + ' '
            linha += formataString(dado.get('data') and parse(dado.get('data')).strftime(
                '%d-%m-%Y') or '', tam_data, ' ', 'D', 'N', 'S') + ' '
            linha += formataString(dado.get('categoria') or '', tam_categoria, ' ', 'D', 'N',
                                   'S') + ' '
            linha += formataString(dado.get('nf') or '', tam_nf, ' ', 'E', 'N', 'S') + ' '
            linha += formataString(getNumeroEditado(vr_vendido), tam_vr_vendido,
                                   ' ', 'E', 'N', 'S') + ' '
            linha += formataString(getNumeroEditado(vr_frete), tam_frete, ' ', 'E', 'N', 'S') + ' '
            linha += formataString(getNumeroEditado(vr_custo), tam_custo, ' ', 'E', 'N', 'S') + ' '
            linha += formataString(getNumeroEditado(vr_imposto), tam_impostos,
                                   ' ', 'E', 'N', 'S') + ' '
            linha += formataString(getNumeroEditado(vr_custo_fixo), tam_custo_fixo, ' ', 'E', 'N',
                                   'S') + ' '
            linha += formataString(getNumeroEditado(vr_com_mkp), tam_com_mkp, ' ', 'E', 'N',
                                   'S') + ' '
            linha += formataString(getNumeroEditado(vr_lucro), tam_lucro, ' ', 'E', 'N', 'S') + ' '
            linha += formataString(getNumeroEditado(vr_lucro_pv), tam_luc_pv, ' ', 'E', 'N',
                                   'S') + ' '
            linha += formataString(getNumeroEditado(vr_lucro_pc), tam_luc_pc, ' ', 'E', 'N', 'S')
            listagem.imprimeLinha(linha)

        listagem.imprimeLinha('--')
        linha = formataString('TOTAL', 86, ' ', 'D', 'N', 'S')
        linha += formataString(getNumeroEditado(vr_vendido_total), tam_vr_vendido, ' ', 'E', 'N',
                               'S') + ' '
        linha += formataString(getNumeroEditado(vr_frete_total), tam_frete, ' ', 'E', 'N',
                               'S') + ' '
        linha += formataString(getNumeroEditado(vr_custo_total), tam_custo, ' ', 'E', 'N',
                               'S') + ' '
        linha += formataString(getNumeroEditado(vr_imposto_total), tam_impostos, ' ', 'E', 'N',
                               'S') + ' '
        linha += formataString(getNumeroEditado(vr_custo_fixo_total), tam_custo_fixo, ' ', 'E', 'N',
                               'S') + ' '
        linha += formataString(getNumeroEditado(vr_com_mkp_total), tam_com_mkp, ' ', 'E', 'N',
                               'S') + ' '
        linha += formataString(getNumeroEditado(vr_lucro_total), tam_lucro, ' ', 'E', 'N',
                               'S') + ' '
        linha += formataString(getNumeroEditado((vr_lucro_total * 100.0) / vr_vendido_total),
                               tam_luc_pv, ' ', 'E', 'N', 'S') + ' '
        linha += formataString(getNumeroEditado((vr_lucro_total * 100.0) / vr_custo_total),
                               tam_luc_pc, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.mkp_avaliacao_venda')
