#!/usr/bin/python
# -*- encoding: utf-8 -*-
from datetime import datetime
import threading
import time
import logging
import socket
import json
from SigUtils.sigerp import db_sig
# from integrar_mkp_magalu import magalu_mkp_objeto
# from integrar_mkp_classes import mkp_objeto


logging.basicConfig(filename='/tmp/mkp_integrar.log', encoding='utf-8', level=logging.INFO, format='%(asctime)s %(message)s')
qted_integra = 0
encerrar = False

_logger = logging.getLogger("MKP_integrar")
_logger.info('==> Entrando no Integrar_MKP')

def _tInic():
    _inicio = time.time()
    return _inicio


def _tFim(inicio, msg):
    _fim = time.time()
    _dif = '%f' % (_fim - inicio)
    _logger.info('%s -> Tempo: %s' % (msg, str(_dif)))
    return

tcp = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
HOST = ''              # Endereco IP do Servidor
PORT = 1111            # Porta que o Servidor esta
data_hora_instancia = datetime.now()

try:
    orig = (HOST, PORT)
    tcp.bind(orig)
except:
    print 'Ja tem uma instancia em execucao!'
    exit()
tcp.listen(1)
seq = 0

dict_objetos = {}
dict_bases = {
    'mlapi': {
        'db_host': 'alvorada',
        'db_host': '192.168.144.14',
        'db_password': 'SIG_0p3n3rp',
        'db_port': False,
        'db_user': 'ml'
    }
}

def _controle_qtd_bases_pendentes():
    _bases = {}
    for key in dict_objetos:
        _base, _funcao, _erp_id = key.split('|')
        if _bases.get(_base):
            _bases[_base]['qtd'] = _bases.get(_base) + 1
            if dict_objetos.get(key).data_recebimento < _bases.get(_base).get('mais_antigo'):
                _bases[_base]['mais_antigo'] = dict_objetos.get(key).data_recebimento.isoformat()
        else:
            _bases[_base] = {'qtd': 1, 'mais_antigo': dict_objetos.get(key).data_recebimento.isoformat()}
    return _bases

def _controle_qtd_funcoes_pendentes():
    _funcoes = {}
    for key in dict_objetos:
        _base, _funcao, _erp_id = key.split('|')
        if _funcoes.get(_funcao):
            _funcoes[_funcao]['qtd'] = _funcoes.get(_funcao) + 1
            if dict_objetos.get(key).data_recebimento < _funcoes.get(_funcao).get('mais_antigo'):
                _funcoes[_funcao]['mais_antigo'] = dict_objetos.get(key).data_recebimento.isoformat()
        else:
            _funcoes[_funcao] = {'qtd': 1, 'mais_antigo': dict_objetos.get(key).data_recebimento.isoformat()}
    return _funcoes

def _controle(obj, con):
    res = {}
    for key in obj:
        if key == 'qtd_pendentes':
            res['qtd_pendentes'] = len(dict_objetos)
        if key == 'qtd_bases_pendentes':
            res['qtd_bases_pendentes'] = _controle_qtd_bases_pendentes()
        if key == 'qtd_funcoes_pendentes':
            res['qtd_funcoes_pendentes'] = _controle_qtd_funcoes_pendentes()
        if key == 'teste':
            res['teste'] = 'OK'
        if key == 'instanciado':
            res['instancado'] = data_hora_instancia.isoformat()
    ret = {'status': True, 'mensagem': '', 'resposta': res}
    con.send(json.dumps(ret))
    return

def _comando(cmd, con):
    if cmd.get('cmd_name') == 'base':
        dict_bases[cmd.get('cmd_name').get('base')]
        return
    # x = mkp_objeto()
    # for key in obj.keys():
    #     exec ("x.%s = obj.get('%s')" % (key, key))
    # x.status_objeto = '2R'
    # x.data_recebimento = datetime.now()
    # x.integra_id = '%s|%s|%s' % (x.base, x.funcao, x.erp_id)
    # dict_objetos.update({
    #     x.integra_id: x,
    # })
    # ret = {'status': True, 'mensagem': '', 'recebido': x.data_recebimento.isoformat()}
    # con.send(json.dumps(ret))
    # return
    # # if obj.get('mkp') == 'Magalu':
    # #     integrador = magalu_mkp_objeto()
    # # for key in obj.keys():
    # #     if obj.get(key):
    # #         exec("integrador.%s = obj.get('%s')" % (key, key))
    # # if obj.get('funcao') == 'get_anuncio':
    # #     res = integrador.get_anuncio(integrador.dados.get('codigo_anuncio'), integrador.dados.get('variacoes'))
    # # con.send(json.dumps({'status': True, 'mensagem': '', 'dados': integrador.dados}))
    # # print obj, cliente, seq

def _Mkp_notificacao(db, notificacao):
    pass

def _Notificacoes():
    for x in range(1, 100):
        globals()['TN_%s' % x] = False
    while True:
        for _base in dict_bases.keys():
            if not dict_bases.get(_base).get('db'):
                kargs = {
                    'host': dict_bases.get(_base).get('db_host'),
                    'port': dict_bases.get(_base).get('db_port'),
                    'pwd': dict_bases.get(_base).get('db_password'),
                    'user': dict_bases.get(_base).get('db_user'),
                }
                dict_bases[_base]['db'] = db_sig(_base, **kargs)
            _db = dict_bases.get(_base).get('db')
            args = [('state', '=', 'R'), ('mkpnot_attempts', '<>', '9')]
            for _notificacao in _db.dbsSelect('mkp_notificacoes', [], args):
                _continuar = True
                while _continuar:
                    for x in range(1, 100):
                        if vars()['TN_%s' % x] and vars()['TN_%s' % x].isAlive():
                            if x == 100:
                                break
                            else:
                                continue
                        vars()['TN_%s' % x] = threading.Thread(target=_Mkp_notificacao, args=(_db, _notificacao))
                        _continuar = False
                        break


TC_notificacoes = threading.Thread(target=_Notificacoes, args=())
TC_notificacoes.start()
# TC_acoes = threading.Thread(target=_acoes, args=())
# TC_acoes.start()

while True:
    con, cliente = tcp.accept()
    seq += 1
    obj = con.recv(4096)
    try:
        obj = json.loads(obj)
    except:
        ret = {'status': False, 'mensagem': 'Nao entendi o comando'}
        con.send(json.dumps(ret))
        con.close()
        continue
    if obj.get('comando'):
        _comando(obj.get('comando'), con)
    elif obj.get('controle'):
        _controle(obj.get('controle'), con)
    else:
        ret = {'status': False, 'mensagem': 'Mensagem nao reconhecida!'}
        con.send(json.dumps(ret))
    con.close()

"""
Exemplo de comandos
{'comando': {
    'cmd_name': 'base', 
    'base': {
        'mlapi': {
            'db_host': 'alvorada',
            'db_password': 'SIG_0p3n3rp',
            'db_port': False,
            'db_user': 'ml'
        }
    }
}
"""
