# -*- encoding: utf-8 -*-
# #############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
# #############################################################################

from openerp.osv import osv, fields
import logging
from ...adm.control.utils import _links_get


class mkp_acoes(osv.Model):
    """
    Tabela de acoes a serem executads no mercado Livre

    prefixo: mkpaco_
    """

    _name = 'mkp.acoes' #antigo ml.acoes
    _logger = logging.getLogger(_name)
    _gerar_logs_logs = 'N'
    _inherit = ['ir.needaction_mixin']
    _columns = {
        'mkpaco_conta_id': fields.many2one('mkp.contas', 'Conta', required=True, select=True),
        'write_date': fields.datetime('Data', readonly=True, select=True),
        'mkpaco_objeto': fields.selection([('A', 'Anuncio'),('C', 'Categoria'), ('G', 'Gtim'), ('I', 'Imagem'),
                                          ('P', 'Preco'), ('S', 'Saldo'), ('R', 'Relacionamento'), ('M', 'Mensagem')],
                                         'Acao sobre', size=1, required=True),
        'mkpaco_acao': fields.selection([('E', 'Excluir'), ('A', 'Atualizar')], 'Acao', size=1, required=True),
        'mkpaco_id': fields.integer('Id do objeto', required=True),
        'state': fields.selection([('AE', 'A executar'), ('EX', 'Executado'), ('ER', 'Com Erro'), ('EU', 'Em execucao')],
                                  'Estado', size=2, select=True),
        'mkpaco_mensagem': fields.text('Mensagem de erro'),
        'mkpaco_prioridade': fields.integer('Prioridade', select=1),
    }
    _defaults = {
        'state': 'AE',
        'mkpaco_prioridade': 1,
    }
    _order = 'state,mkpaco_prioridade,write_date'
