# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields



class mkp_anuncios(osv.Model): # antigo ml_anuncos
    """
    Tabela de anuncios proprios do mercado Livre
ze
    prefixo: mlanu_
    """
    from funcoes import _mkpanu_get_dados, _mkpanu_get_lucro
    from funcoes import _mkpanu_get_anuncios_custos_alterados
    # from funcoes import _mkpanu_get_anuncio_saldo, _mkpanu_get_anuncios_dos_saldos_alterados
    from funcoes import _mkpanu_get_anuncios_alterados
        # _mkpanu_get_anuncios_dos_itens_alterados

    _rec_name = 'mkpanu_title'
    _roteavel = True
    _inherits = {'estoque.produto': 'mkpanu_produto_id'}

    _name = 'mkp.anuncios' # antigo mkp.anuncios
    _columns = {
        'id': fields.integer('ID', readonly=True),
        'mkpanu_marketplace_id': fields.many2one('mkp.marketplaces', 'Marketplace', required=True, select=True),
        'mkpanu_marketplace_integrador': fields.related('mkpanu_marketplace_id', 'mkpmkp_codigo', type="char",
                                                    string='Integrador', store=False, size=6),
        'mkpanu_conta_id': fields.many2one('mkp.contas', 'Conta', required=True, select=True),
        'mkpanu_codigo_anuncio': fields.char('Codigo do anuncio', size=24, select=1),
        'mkpanu_anuncio_endereco': fields.char('Anuncio', size=128),
        'mkpanu_title': fields.char('Titulo', size=60, required=True),
        'mkpanu_catalogo': fields.function(_mkpanu_get_dados, method=True, string='Catalogo', type="boolean",
                                           store=False, multi="dado"),
        'mkpanu_descricao_texto': fields.function(_mkpanu_get_dados, method=True, string='Descricao',
                                                type="text", store=False, multi="dados"),
        'mkpanu_descricao_html': fields.function(_mkpanu_get_dados, method=True, string='Descricao',
                                                type="text", store=False, multi="dados"),
        'mkpanu_produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="cascade", select=True,
                                            required=True),
        'mkpanu_modelo_id': fields.related('mkpanu_marketplace_id', 'mkpmkp_modelo_id', relation='mkp.modelos',
                                             type='many2one', store=False, string='Modelo'),
        'mkpanu_modelo_tipo': fields.function(_mkpanu_get_dados, method=True, string='Modelo de anuncio',
                                                type='char', store=False, multi="dados"),
        'mkpanu_quantidade': fields.integer('Quantidade',
                                           help='Quantidade de itens, utilizado para kits ou conjuntos de produtos'),
        'mkpanu_estado': fields.selection(
            [('A', 'Ativo'), ('P', 'Pausado'), ('F', 'Finalizado'), ('C', 'Com problemas'), ('G', 'Aguardando')],
            'Estado', size=1),
        'mkpanu_estado_mkp': fields.char('Estado no MKP', size=20),
        'mkpanu_valor': fields.float('Valor', digits=(7, 2)),
        'mkpanu_valor_promocao': fields.float('Valor promocional', digits=(7, 2)),
        'mkpanu_valor_sugerido': fields.function(_mkpanu_get_dados, method=True, string="P.Sugerido",
                                                 type="float", digits=(7, 2), store=False, multi="dados"),
        'mkpanu_valor_sugerido2': fields.function(_mkpanu_get_dados, method=True, string="P.Sugerido 2",
                                                 type="float", digits=(7, 2), store=False, multi="dados"),
        'mkpanu_qtd_maxima': fields.integer('Qtd.Maxima', help="Quantidade maxima permitida por pedido."),
        'mkpanu_qtd_vendido': fields.integer('Qtd.Vendido'),
        'mkpanu_valor_frete': fields.float('Valor do frete', digit=(5, 2)),
        'mkpanu_fator_ajuste': fields.float('Fator de ajuste', digits=(1, 4), help='Fator de ajuste do preço calculado, acima de 1 aumenta o preco, abaixo de 1 reduz o preco.'),
        'mkpanu_necessita_atualizar': fields.boolean('Necessita atualizar no Marketplace'),
        'mkpanu_saldo': fields.integer('Saldo'),
        'mkpanu_anuncio_tipo_id': fields.many2one("mkp.anuncios.tipo", 'Tipo de anuncio', required=True, select=True),
        'mkpanu_mercado_envios': fields.boolean('Mercado envios'),
        'mkpanu_mercadofull': fields.boolean('FulFillment', select=True, help='Centro de Distribuicao do Marketplace'),
        'mkpanu_frete': fields.selection([('CC', 'Por conta do comprador'), ('GB', 'Frete gratis Brasil'),
                                            ('CV', 'Frete p/conta do vendedor')], 'Frete', size=2),
        'mkpanu_retirar_em_maos': fields.boolean('Oferecer retirada em maos'),
        'mkpanu_lucro_pvenda': fields.function(_mkpanu_get_lucro, method=True, string='%Luc.PV.',
                                                 help='Percentual de lucro sobre o preco de venda',
                                                 type="float", digits=(5, 2), multi="lucro",
                                                 store=False,
                                                ),
        'mkpanu_lucro_pcusto': fields.function(_mkpanu_get_lucro, method=True, string='%Luc.PC.',
                                                 help='Percentual de lucro sobre o preco de custo(medio)',
                                                 type="float", digits=(5, 2), multi="lucro",
                                                 store=False,
                                               ),
        'mkpanu_variacoes_ids': fields.one2many('mkp.anuncios.var', 'mkpanuv_anuncio_id', 'Grades'),
        'mkpanu_pergunta_ids': fields.one2many('mkp.perguntas', 'mkpper_anuncio_id', 'Perguntas'),
        'mkpanu_secao_ids': fields.one2many('mkp.anuncios.secao', 'mkpans_anuncio_id', 'Secoes'),
        'mkpanu_logo_integrador': fields.function(_mkpanu_get_dados, method=True, string='Logo Integrador',
                                               type='char', size=60, store=False, multi="dados"),
        'mkpanu_banner_integrador': fields.function(_mkpanu_get_dados, method=True, string='Banner Integrador',
                                               type='binary', store=False, multi="dados"),
        'mkpanu_banner.full': fields.function(_mkpanu_get_dados, method=True, string='Full',
                                               type='char', size=60, store=False, multi="dados"),
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'mkpanu_notas': fields.text('Anotacoes'),
        'mkpanu_frete_id': fields.many2one('mkp.fretes', 'Tabela de Frete', select=True),
        # id da empresa\n
    }
    _order = 'mkpanu_produto_id,mkpanu_anuncio_tipo_id,mkpanu_valor_promocao,mkpanu_valor'
    _defaults = {
        'mkpanu_estado': 'A',
        'mkpanu_quantidade': 1,
        'mkpanu_fator_ajuste': 1,
        'mkpanu_valor_promocao': 0,
        'mkpanu_qtd_maxima': 0,
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }
