# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class mkp_anuncios_secao(osv.Model): # antigo mkp_anuncios_secao
    """
    Tabela de secoes dos anuncios do marketplace

    prefixo: mkpans
    """

    _name = 'mkp.anuncios.secao' # antigo mkp.anuncios.secao
    _inherits = {'mkp.anuncios': 'mkpans_anuncio_id'}

    _columns = {
        'sequence': fields.integer('Sequencia'),
        'mkpans_anuncio_id': fields.many2one('mkp.anuncios', 'Anuncio', required=True, ondelete='cascade',select=True),
        'mkpans_modelo_id': fields.related('mkpans_anuncio_id', 'mkpanu_modelo_id', relation="mkp.modelos", type='many2one',
                                           store=True, string='Categoria'),
        'mkpans_secao_id': fields.many2one('mkp.modelos.secao', 'secoes', required=True, ondelete="restrict", select=True,
                                           domain=[('mkpmsc_modelo_id','=', 'mkpans_modelo_id')]),
        'mkpans_secao_texto': fields.text('Texto da secao'),
        'mkpans_sobrepoe_acrescenta': fields.selection([('S','Sobrepor'), ('A', 'Acrescentar')], 'Comportamento', size=1,
                                                      help='Informe se esta seção ira sobrepor a do produto ou se vai acrescentar!',
                                                      required=True),
    }
    _defaults = {
        'mkpans_sobrepoe_acrescenta': 'A',
        'sequence': 10,
    }
    _order='mkpans_anuncio_id,sequence,mkpans_secao_id'

