# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class mkp_anuncios_tipo(osv.Model): # Antiga mkp.anuncios_tipo
    """
    Tabela de tipos deanuncios dos marketplaces

    prefixo: mkpant_
    """

    _name = 'mkp.anuncios.tipo'
    _columns = {
        'id': fields.integer('Codigo', readonly=1),
        'mkpant_marketplace_id': fields.many2one('mkp.marketplaces', 'Marketplace', required=True, select=True),
        'name': fields.char('Anuncio', size=30, required=True, select=True),
        'mkpant_codigo': fields.char('Codigo no placeholder', size=15, required=True),
        'mkpant_custo_var': fields.float("Custo variavel", digits=(4, 2)),
        'mkpant_custo_var2': fields.float("Custo variavel 2", digits=(4, 2),
                                          help='Custo para eshop, caso o marketplace tenha'),
        'mkpant_custo_fixo': fields.float("Custo fixo", digits=(4, 2)),
        'mkpant_tipo_custo_fixo': fields.selection([('U', 'Por unidade'), ('P', 'Por pedido')], 'Tipo de custo fixo',
                                                   size=1),
        'mkpant_condicao_pgto': fields.many2one('adm.condicao.forma', 'Condicao de pagamento',
                                                       help='condicao de pagamento para  este tipo de anuncio!'),
    }
    _order = 'mkpant_marketplace_id,name'
