# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class mkp_anuncios_var(osv.Model): # antigo mkp_anuncios_var
    """
    Tabela de variacoes de anuncios dos marketplaces
    prefixo: mkpanuv_
    """
    _name = 'mkp.anuncios.var'
    _inherits = {'mkp.anuncios': 'mkpanuv_anuncio_id'}

    _columns = {
        'mkpanuv_anuncio_id': fields.many2one('mkp.anuncios', 'Anuncio', required=True, select=True, ondelete='cascade'),
        'mkpanuv_grade_id': fields.many2one('estoque.produto.grade', 'Grade', required=True, select=True,
                                            ondelete='cascade'),
        'mkpanuv_id_no_mkp': fields.char('Id no MarketPlace', char=40, required=True, select=True),
        'mkpanuv_valor': fields.float('Valor', digits=(7, 2)),
        'sequence': fields.integer('Sequencia')
    }
    _defaults = {
        'sequence': 10,
    }
    _sql_constraints = [
        ('name_uniq', 'unique(mkpanuv_anuncio_id,mkpanuv_grade_id)', 'Variacao de anuncio ja existe!'),
    ]
    _order = 'mkpanuv_anuncio_id,sequence,mkpanuv_grade_id'

