# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class mkp_categorias_atributos(osv.Model): # antigo ml_categorias
    """
    Tabela de atributos das categorias dos marketplaces

    prefixo: mkpcatatr__
    """
    _gerar_logs_logs = 'N'

    _name = 'mkp.categorias.atributos'
    _columns = {
        'mkpcatatr_categoria_id': fields.many2one('mkp.categorias', 'Categorias', required=True, ondelete='cascade',
                                                  select=True),
        'mkpcatatr_estoque_atributo_id': fields.many2one('estoque.atributos', 'Atributo estoque', ondelete='set null', select=True),
        'mkpcatatr_id_mkp': fields.char('Id no mkp', size=10),
        'mkpcatatr_tipo': fields.selection([('P', 'Principal'), ('S', 'Secundaria')], 'Tipo de atributo', size=1,
                                           required=True),
        'mkpcatatr_label': fields.char('Label', size=30, required=True),
        'mkpcatatr_tipo_dados': fields.char('Tipo de dados', size=20, required=False),
        'mkpcatatr_tags_ids': fields.one2many('mkp.categorias.atributos.tags', 'mkpcatatrt_atributo_id', 'Tags'),
        'mkpcatatr_unidades_ids': fields.one2many('mkp.categorias.atributos.unidades', 'mkpcatatru_atributo_id', 'Unidades'),
    }
    _defaults = {
        'mkpcatatr_tipo': 'P',
    }

