# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class mkp_categorias(osv.Model): # antigo ml_categorias
    """
    Tabela de categorias dos marketplaces

    prefixo: mkpcat_
    """
    _gerar_logs_logs = 'N'
    from funcoes import mkpcat_get_dados

    _name = 'mkp.categorias'
    _roteavel = True
    _columns = {
        'mkpcat_marketplace_id': fields.many2one('mkp.marketplaces', 'Marketplace', required=True, select=True),
        'name': fields.char('Descricao', size=128, required=True, select=True),
        'mkpcat_descricao_completa': fields.function(mkpcat_get_dados, method=True, type="char", multi='dados',
                                                    string='Descricao completa', store=True),
        'parent_id': fields.many2one("mkp.categorias", 'Categoria Pai', ondelete="restrict", select=True),
        'mkpcat_codigo': fields.char('Codigo', size=16, select=True),
        'mkpcat_filhos_ids': fields.one2many('mkp.categorias', 'parent_id', 'Filhas'),
        'mkpcat_produtos_ids': fields.one2many('mkp.produto.marketplaces', 'mkpromkp_categoria_id', 'Produtos'),
        'active': fields.boolean('Ativo'),
        'mkpcat_mkp_codigo': fields.function(mkpcat_get_dados, method=True, string='Codigo do Mkp',
                                                type='char', store=False, multi="dados"),
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'mkpcat_atributos_ids': fields.one2many('mkp.categorias.atributos', 'mkpcatatr_categoria_id', 'Atributos'),
        'mkpcat_categoria_estoque_id': fields.many2one('estoque.categoria', 'Categoria estoque', ondelete="cascade", select=True),
    }
    _defaults = {
        'active': True,
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }
    _order = 'mkpcat_marketplace_id,mkpcat_descricao_completa'
    _sql_constraints = [
            ('codigo_uniq', 'unique(mkpcat_marketplace_id, mkpcat_codigo, company_id)', 'Codigo de categoria ja cadastrado!'),
    ]
