# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.tools import config
from openerp.tools.translate import _

# Funcoes da classe mkp_marketplace
def _mkpmkp_get_categ_usadas(self, cr, uid, ids, field_name, args, context=None):
    res = {}
    context = context and context.copy() or {}
    if not len(ids):
        return res
    for _brw_mkp in self.browse(cr, uid, ids, context=context):
        _categs = []
        for brw_produto_mkp in _brw_mkp.mkpmkp_produto_mkp_ids:
            if brw_produto_mkp.mkpromkp_categoria_id and not brw_produto_mkp.mkpromkp_categoria_id.id in _categs:
                _categs.append(brw_produto_mkp.mkpromkp_categoria_id.id)
        res[_brw_mkp.id] = {'mkpmkp_categorias_usadas_ids': _categs}
    return res

# Funcoes da classe mkp_categorias
def mkpcat_get_dados(self, cr, uid, ids, field_name, args, context=None):
    res = {}
    context = context and context.copy() or {}
    if not len(ids):
        return res
    context['categoria_sem_codigo'] = True
    _descricoes = self.mkpcat_get_descricao_completa(cr, uid, ids, context=context)
    for _brw_categoria in self.browse(cr, uid, ids, context=context):
        _dict = {}
        _dict['mkpcat_descricao_completa'] = _descricoes.get(_brw_categoria.id)
        _dict['mkpcat_mkp_codigo'] = _brw_categoria.mkpcat_marketplace_id.mkpmkp_codigo
        res[_brw_categoria.id] = _dict
    return res

# funcoes da classe anuncios

# def _mkpanu_get_dados(self, cr, uid, ids, name, args, context=None):
#     context = context and context.copy() or {}
#     if not len(ids):
#         return []
#     res = {}
#     for brw_anuncio in self.browse(cr, uid, ids, context=context):
#         _tipo = brw_anuncio.mkpanu_modelo_id.mkpmod_tipo
#         _codigo_mkp = brw_anuncio.mkpanu_marketplace_id.mkpmkp_codigo
#         vals = {'mkpanu_modelo_tipo': _tipo, 'mkpanu_marketplace_integrador': _codigo_mkp}
#         obj_mkp_produto_marketplaces = self.pool.get('mkp.produto.marketplaces')
#         args = [('mkpromkp_produto_id', '=', brw_anuncio.mkpanu_produto_id.id),
#                 ('mkpromkp_marketplace_id', '=', brw_anuncio.mkpanu_marketplace_id.id)]
#         mkp_produto_marketplaces_ids = obj_mkp_produto_marketplaces.search(cr, uid, args, context=context)
#         if mkp_produto_marketplaces_ids:
#             vals['mkpanu_descricao_texto'] = vals['mkpanu_descricao_html'] = self.pool.get('mkp.utils').mkputl_preview(cr, uid,
#                                                                                    mkp_produto_marketplaces_ids[0],
#                                                                                     brw_anuncio.id, context=None)
#
#         res[brw_anuncio.id] = vals
#     return res


def _mkpanu_get_anuncios_custos_alterados(self, cr, uid, ids, context=None):
    '''
    Funcao que retorna o uma lista de ids da classe mkp.anuncios onde o custo de um
    produto foi alterado
    :param ids: ids da classe estoque.preco.custo
    :return: lista com ids da classe 'mkp.anuncios'
    '''
    context = context and context.copy() or {}
    dados_preco_custo = self.read(cr, uid, ids, ['produto_id'], load='_classic_write', context=context)
    produto_ids = map(lambda x: x.get('produto_id'), dados_preco_custo)
    anuncio_ids = self.pool.get('mkp.anuncios').search(cr, uid,  [('mkpanu_produto_id','in', produto_ids)], context=context)
    return anuncio_ids


# Funcoes da classe ml_perguntas
def _mkpper_get_dados(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    for brw_ml_perguntas in self.browse(cr, uid, ids, context=context):
        _cliente = brw_ml_perguntas.mkpper_apelido
        _produto = brw_ml_perguntas.mkpper_produto_id.id
        if not _produto:
            continue
        lista_cli_pro_ids = self.search(cr, uid, [('mkpper_produto_id', '=', _produto), ('mkpper_apelido', '=', _cliente)],
                                        context=context)
        lista_cli_pro_ids.remove(brw_ml_perguntas.id)
        if _cliente:
            lista_cliente_ids = self.search(cr, uid, [('mkpper_apelido', '=', _cliente)], context=context)
            lista_cliente_ids.remove(brw_ml_perguntas.id)
        else:
            lista_cliente_ids = []
        lista_produto_ids = self.search(cr, uid, [('mkpper_produto_id', '=', _produto)], context=context)
        lista_produto_ids.remove(brw_ml_perguntas.id)
        foto = self.pool.get('estoque.produto').read(cr, uid, _produto, ['estpro_foto'], context=context)['estpro_foto']
        cliente_id = self.pool.get('adm.pessoa').search(cr, uid, [('admpes_id_externo', '=', 'fantasia_apelido')])
        if cliente_id and isinstance(cliente_id, (tuple, list)):
            cliente_id = cliente_id[0]
        if brw_ml_perguntas.mkpper_anuncio_id:
            _saldo = self.pool.get('mkp.anuncios').read(cr, uid, brw_ml_perguntas.mkpper_anuncio_id.id, ['mkpanu_saldo'])[
                'mkpanu_saldo']
        else:
            _saldo = 0
        res[brw_ml_perguntas.id] = {
            'mkpper_outras_perguntas_cli_pro_ids': lista_cli_pro_ids,
            'mkpper_outras_perguntas_cliente_ids': lista_cliente_ids,
            'mkpper_outras_perguntas_produto_ids': lista_produto_ids,
            'mkpper_produto_foto': foto,
            'mkpper_cliente_id': cliente_id,
            'mkpper_saldo': _saldo,
        }
    return res

# funcoes da classe produto_marketplace
def _mkpromkp_get_dados(self, cr, uid, ids, name, args, context=None):
    context = context and context.copy() or {}
    if not len(ids):
        return []
    res = {}
    for _prod_mkp in self.browse(cr, uid, ids, context=context):
        vals = {'mkpromkp_modelo_tipo': _prod_mkp.mkpromkp_modelo_id.mkpmod_tipo}
        _preview = self.pool.get('mkp.utils').mkputl_preview(cr, uid, _prod_mkp.id, context=None)
        vals['mkpromkp_anuncio_preview_html'] = _preview
        vals['mkpromkp_anuncio_preview_text'] = _preview
        res[_prod_mkp.id] = vals
    return res


# Funcoes da classe mkp_produto_marketplaces_secao
def _mkppromkpsc_get_dados(self, cr, uid, ids, name, args, context=None):
    context = context and context.copy() or {}
    if not len(ids):
        return []
    res = {}
    for brw_secao in self.browse(cr, uid, ids, context=context):
        _tipo = brw_secao.mkppromkpsc_secao_id.mkpmsc_modelo_id.mkpmod_tipo
        vals = {'mkpromkpsc_modelo_tipo': _tipo}
        res[brw_secao.id] = vals
    return res

def _mkpanu_get_anuncios_alterados(self, cr, uid, ids, context=None):
    '''
    Funcao que retorna o uma lista de ids da classe mkp.anuncios onde os valores dos anuncios
    :param ids: ids da classe ml.pesquisas
    :return: lista com ids da classe 'mkp.anuncios'
    '''
    lista_ids = []
    for dados_anuncio in self.read(cr, uid, ids, ['mkpanu_necessita_atualizar'], context=context):
        if dados_anuncio.get('mkpanu_necessita_atualizar'):
           lista_ids.append(dados_anuncio.get('id'))
    return lista_ids

def _mkpanu_get_lucro(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    if not len(ids):
        return []
    res = {}
    for brw_anuncios in self.browse(cr, uid, ids, context=context):
        _company_id = brw_anuncios.company_id.id
        _produto_id = brw_anuncios.mkpanu_produto_id.id
        _qtd = brw_anuncios.mkpanu_quantidade
        _lucro_pv = _lucro_pc = 0
        _kit = self.pool.get('mkp.utils')._mkputl_get_kit_itens(cr, uid, _produto_id, context=context)
        _custos = 0
        if not _kit:
            _kit = [{'produto': _produto_id, 'qtd': 1}]
            _itens_do_kit = [_produto_id]
        else:
            _itens_do_kit = [x.get('produto') for x in _kit]
        _custos_prod = self.pool.get('estoque.preco.custo').get_custos_do_dia(cr, uid, _itens_do_kit,
                                                                         epc_company_id=_company_id,
                                                                         context=context)
        for key in _custos_prod.keys():
            for _item in _kit:
                if _item.get('produto') == key:
                    _custos += _custos_prod.get(key).get('estprc_custo_medio_contabil') * _item.get('qtd')
                    break
        _p_sugestao = self.mkpanu_get_p_sugestao(cr, uid, brw_anuncios, context=context)
        _pv = brw_anuncios.mkpanu_valor_promocao or brw_anuncios.mkpanu_valor or _p_sugestao or 0

        _vl_frete = brw_anuncios.mkpanu_valor_frete if brw_anuncios.mkpanu_frete in ('GB', 'CV') else 0
        _custo_var_ml = brw_anuncios.mkpanu_anuncio_tipo_id.mkpant_custo_var or 0
        _custo_fixo_ml = brw_anuncios.mkpanu_anuncio_tipo_id.mkpant_custo_fixo or 0
        _tipo_custo_fixo_ml = brw_anuncios.mkpanu_anuncio_tipo_id.mkpant_tipo_custo_fixo or ''
        if _tipo_custo_fixo_ml != 'U':
            _custo_fixo_ml = 0
        _pc = (_custos * brw_anuncios.mkpanu_quantidade) or 0
        if _pv:
            try:
                _lucro_pv = (_pv - (_pv * _custo_var_ml / 100) - _pc - _vl_frete - _custo_fixo_ml) * 100 / _pv
            except:
                _lucro_pv = 0
        if _pc:
            try:
                _lucro_pc = (_pv - (_pv * _custo_var_ml / 100) - _pc - _vl_frete - _custo_fixo_ml) * 100 / _pc
            except:
                _lucro_pc = 0
        res[brw_anuncios.id] = {
            'mkpanu_lucro_pvenda': _lucro_pv,
            'mkpanu_lucro_pcusto': _lucro_pc,
        }
    return res

def _mkpanu_get_dados(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    if not len(ids):
        return []
    res = {}
    for brw_anuncios in self.browse(cr, uid, ids, context=context):
        _per_acres = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', 'estpar_preco_perc_acrescimo', company_id=brw_anuncios.mkpanu_conta_id.company_id.id, context=context).get(
            'estpar_preco_perc_acrescimo')
        _p_original = brw_anuncios.preco_venda * 100 / (100 + _per_acres)
        _p_venda = ((_p_original * brw_anuncios.mkpanu_quantidade) + brw_anuncios.mkpanu_valor_frete
                   + brw_anuncios.mkpanu_anuncio_tipo_id.mkpant_custo_fixo) \
                        * 100 / (100 - (brw_anuncios.mkpanu_anuncio_tipo_id.mkpant_custo_var + brw_anuncios.mkpanu_marketplace_id.mkpmkp_perc_aumento_pv))
        _p_venda2 = ((_p_original * brw_anuncios.mkpanu_quantidade) + brw_anuncios.mkpanu_valor_frete
                   + brw_anuncios.mkpanu_anuncio_tipo_id.mkpant_custo_fixo) \
                        * 100 / (100 - (brw_anuncios.mkpanu_anuncio_tipo_id.mkpant_custo_var2 + brw_anuncios.mkpanu_marketplace_id.mkpmkp_perc_aumento_pv))
        _p_venda = _p_venda * brw_anuncios.mkpanu_fator_ajuste
        _p_venda2 = _p_venda2 * brw_anuncios.mkpanu_fator_ajuste
        if brw_anuncios.mkpanu_conta_id.mkpcta_fator_ajuste_pv:
            _p_venda = _p_venda * brw_anuncios.mkpanu_conta_id.mkpcta_fator_ajuste_pv
        if brw_anuncios.mkpanu_conta_id.mkpcta_fator_ajuste_pv:
            _p_venda2 = _p_venda2 * brw_anuncios.mkpanu_conta_id.mkpcta_fator_ajuste_pv
        args = [('mkpromkp_produto_id', '=', brw_anuncios.mkpanu_produto_id.id),
                ('mkpromkp_marketplace_id', '=', brw_anuncios.mkpanu_marketplace_id.id),
                ('company_id', '=', brw_anuncios.mkpanu_conta_id.company_id.id)]
        context['sig_force_company'] = True
        prod_mkp_ids = self.pool.get('mkp.produto.marketplaces').search(cr, uid, args, context=context)
        context.pop('sig_force_company')
        _preview = ''
        if prod_mkp_ids:
            _preview = self.pool.get('mkp.utils').mkputl_preview(cr, uid, prod_mkp_ids[0], brw_anuncios.id, context=context)
        integrador_logo = {
            'MerLiv': 'marketplace/static/src/img/ml_logo.png',
            'SkyHub': 'marketplace/static/src/img/skyhub_logo.png',
            'Tray': 'marketplace/static/src/img/tray_logo.png',
            'PrtShp': 'marketplace/static/src/img/prestashop_logo.png',
            'Olist': 'marketplace/static/src/img/olist_logo.png',
            'Shopee': 'marketplace/static/src/img/shopee_logo.png',
            'MadMad': 'marketplace/static/src/img/madeira_logo.png',
            'Magalu': 'marketplace/static/src/img/magalu_logo.png',
        }
        integrador_banner = {
            'MerLiv': 'marketplace/static/src/img/ml_banner.png',
            'SkyHub': 'marketplace/static/src/img/skyhub_banner.png',
            'Tray': 'marketplace/static/src/img/tray_banner.png',
            'PrtShp': 'marketplace/static/src/img/prestashop_banner.png',
            'Olist': 'marketplace/static/src/img/olist_banner.png',
            'Shopee': 'marketplace/static/src/img/shopee_banner.png',
            'MadMad': 'marketplace/static/src/img/madeira_banner.png',
            'Magalu': 'marketplace/static/src/img/magalu_banner.png',
        }
        _banner = _logo = ''
        _integrador = brw_anuncios.mkpanu_marketplace_integrador
        if _integrador == 'MerLiv':
            if brw_anuncios.mkpanu_mercadofull:
                if brw_anuncios.mkpanu_mercado_livre and brw_anuncios.mkpanu_mercado_shop:
                    integrador_logo['MerLiv'] = 'marketplace/static/src/img/ml_full_mshop_logo.png'
                    integrador_banner['MerLiv'] = 'marketplace/static/src/img/ml_full_mshop_banner.png'
                elif brw_anuncios.mkpanu_mercado_shop:
                    integrador_logo['MerLiv'] = 'marketplace/static/src/img/mshop_full_logo.png'
                    integrador_banner['MerLiv'] = 'marketplace/static/src/img/mshop_full_banner.png'
                else:
                    integrador_logo['MerLiv'] = 'marketplace/static/src/img/ml_full_logo.png'
                    integrador_banner['MerLiv'] = 'marketplace/static/src/img/ml_full_banner.png'
            else:
                if brw_anuncios.mkpanu_mercado_livre and brw_anuncios.mkpanu_mercado_shop:
                    integrador_logo['MerLiv'] = 'marketplace/static/src/img/ml_mshop_logo.png'
                    integrador_banner['MerLiv'] = 'marketplace/static/src/img/ml_mshop_banner.png'
                elif brw_anuncios.mkpanu_mercado_shop:
                    integrador_logo['MerLiv'] = 'marketplace/static/src/img/mshop_logo.png'
                    integrador_banner['MerLiv'] = 'marketplace/static/src/img/mshop_banner.png'
                else:
                    integrador_logo['MerLiv'] = 'marketplace/static/src/img/ml_logo.png'
                    integrador_banner['MerLiv'] = 'marketplace/static/src/img/ml_banner.png'
        try:
            if integrador_banner.get(_integrador):
                arq = '%s/%s' % (config.get('addons_path'), integrador_banner.get(_integrador))
                file_img = open(arq, 'r')
                _banner = file_img.read()
                file_img.close()
        except Exception as e:
            print(e)
            pass
        if _integrador:
            _logo = integrador_logo.get(_integrador)
        _args = [('mkpanur_codigo_anuncio', '=', brw_anuncios.mkpanu_codigo_anuncio)]
        _rel_ids = self.pool.get('mkp.anuncios.relacionamento').search(cr, uid, _args, context=context)
        if _rel_ids:
            _catalogo = True
        else:
            _catalogo = False
        res[brw_anuncios.id] = {
            'mkpanu_valor_sugerido': round(_p_venda, 2),
            'mkpanu_valor_sugerido2': round(_p_venda2, 2),
            'mkpanu_descricao_texto': _preview,
            'mkpanu_descricao_html': _preview,
            'mkpanu_modelo_tipo': brw_anuncios.mkpanu_marketplace_id.mkpmkp_modelo_id.mkpmod_tipo,
            'mkpanu_logo_integrador': _logo,
            'mkpanu_banner_integrador': _banner,
            'mkpanu_catalogo': _catalogo,
        }
    return res

def _mkpanuv_get_variacao_saldo(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    if not len(ids):
        return []
    obj_estoque_produto_grade = self.pool.get('estoque.produto.grade')
    res = {}
    for brw_anuncios_variacoes in self.browse(cr, uid, ids, context=context):
        try:  # try utilizado, porque da exceção ao excluir uma variacao
            _perc_saldo = brw_anuncios_variacoes.mkpanuv_anuncio_id.mkpanu_conta_id.mkpcta_saldo_percentual
        except:
            return res
        _grade_id = brw_anuncios_variacoes.mkpanuv_grade_id.id
        _local_id = brw_anuncios_variacoes.mkpanuv_anuncio_id.mkpanu_marketplace_id.id
        context['company_id'] = brw_anuncios_variacoes.mkpanuv_anuncio_id.company_id.id
        _saldo = int(obj_estoque_produto_grade.estpgr_get_saldo(cr, uid, [_grade_id], pesquisar="D",
                                                      local=_local_id, context=context)[_grade_id])
        if _perc_saldo > 0 or _perc_saldo < 100:
            _saldo = int(_saldo * _perc_saldo / 100)
        res[brw_anuncios_variacoes.id] = _saldo
    return res

def _mkpanu_get_variacoes_dos_anuncios_alterados(self, cr, uid, ids, context=None):
    '''
    Funcao que retorna o uma lista de ids da classe mkp_anuncios_var onde o anuncio foi alterado
    :param ids: ids da mkp.anuncios
    :return: lista com ids da classe 'mkp_anuncios_var'
    '''
    context = context and context.copy() or {}
    obj_mkp_anuncios_var = self.pool.get('mkp.anuncios.var')
    anuncio_ids = obj_mkp_anuncios_var.search(cr, uid,  [('mkpanuv_anuncio_id','in',ids)], context=context)
    return anuncio_ids

def _mkpanuv_get_variacoes_dos_saldos_alterados(self, cr, uid, ids, context=None):
    '''
    Funcao que retorna o uma lista de ids da classe mkp_anuncios_var onde o saldo de uma
    grade foi alterado
    :param ids: ids da classe estoque.produto.saldo
    :return: lista com ids da classe 'mkp_anuncios_var'
    '''
    context = context and context.copy() or {}
    obj_mkp_anuncios_var = self.pool.get('mkp.anuncios.var')
    grade_ids = []
    for dados_saldos in self.read(cr, uid, ids, ['grade_id', 'local_id'], load='_classic_write', context=context):
        grade_ids.append(dados_saldos.get('grade_id'))
    anuncio_ids = obj_mkp_anuncios_var.search(cr, uid,  [('mkpanuv_grade_id','in',grade_ids)], context=context)
    return anuncio_ids

