# -*- encoding: utf-8 -*-
# #############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
# #############################################################################

from openerp.osv import osv, fields
import logging



class mkp_marketplaces_adicional(osv.Model):
    """
    Tabela de marketplaces adicionais (Qdo usa hub de integração)

    prefixo: mkpmkpadc__
    """

    _name = 'mkp.marketplaces.adicional'
    _logger = logging.getLogger(_name)
    _columns = {
        'mkpmkpadc_marketplace_id': fields.many2one('mkp.marketplaces', 'Marketplace', required=True, select=True,
                                                    ondelete='cascade'),
        'mkpmkpadc_apelido': fields.char('Apelido', size=20, required=True,select=True),
        'mkpmkpadc_adicional_fixo': fields.float('Valor fixo', digits=(8,2), help='Valor fixo cobrado pelo marketplace adicional'),
        'mkpmkpadc_adicional_percentual': fields.float('Percentual', digits=(8, 2),
                                                 help='Percentual cobrado pelo marketplace adicional'),
        'mkpmkpadc_condicao_pgto_id': fields.many2one('adm.condicao.forma', 'Condicao de pagamento',
                                                      help='condicao de pagamento para o Mkp Adicional'),

    }