# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class mkp_marketplaces(osv.Model):
    """
    Tabela de Marketplaces

    prefixo: mkpmkp_
    """
    from funcoes import _mkpmkp_get_categ_usadas
    _name = 'mkp.marketplaces'
    _columns = {
        'name': fields.char('Descricao', size=30, select=True, required=True),
        'mkpmkp_codigo': fields.char('Codigo', size=6, select=True, required=True),
        'mkpmkp_api': fields.char('Endereco da api', size=128),
        'mkpmkp_pessoa_id': fields.many2one('adm.pessoa', 'Pessoa MarketPlace', required=False,
                                               help='Identifique a pessoa que e o MarketPlace.'),
        'mkpmkp_modelo_id': fields.many2one('mkp.modelos', 'Modelo de anuncio', required=False),
        'mkpmkp_rastreio_nas_mensagens': fields.boolean('Habilita o rastreamento nas mensagens do pedido'),
        'mkpmkp_conta_ids': fields.one2many('mkp.contas', 'mkpcta_marketplace_id', 'Contas'),
        'mkpmkp_mark_adicional_ids': fields.one2many('mkp.marketplaces.adicional', 'mkpmkpadc_marketplace_id', 'Mkps Adicionais'),
        'mkpmkp_produto_mkp_ids': fields.one2many('mkp.produto.marketplaces', 'mkpromkp_marketplace_id', 'Produtos'),
        'mkpmkp_habilita_log': fields.boolean('Habilita log de comunicacao com Marketplace'),
        'mkpmkp_parar_comunicacao': fields.boolean('Parar comunicacao', help="Se marcado nao envia nada para este MKP!"),
        'mkpmkp_atributos_ids': fields.one2many('mkp.atributos', 'mkpatr_marketplace_id', 'Atributos'),
        'mkpmkp_anuncios_ids': fields.one2many('mkp.anuncios', 'mkpanu_marketplace_id', 'Anuncios'),
        'mkpmkp_perc_aumento_pv': fields.float('Percentual aumento', digits=(2,2), help='Percentual de aumento no Preco de venda'),
        'mkpmkp_categorias_usadas_ids': fields.function(_mkpmkp_get_categ_usadas, method=True, type='one2many',
                                                              multi="dados", relation='mkp.categorias',
                                                              string='Categorias utilizadas'),

    }

    _sql_constraints = [
        ('mkpmkp_codigo_uniq', 'unique(mkpmkp_codigo)', 'Codigo de marketplace ja existe!'),
    ]
    default = {
        'mkpmkp_habilita_log' : False,
    }