# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class mkp_mensagens(osv.Model):
    """
    Mensagens dos pedidos

    prefixo: mkpmen_
    """

    _inherit = ['ir.needaction_mixin']
    _gerar_logs_logs = 'N'
    _name = 'mkp.mensagens'
    _columns = {
        'mkpmen_conta_id': fields.many2one('mkp.contas', 'Conta', required=True, select=True),
        'mkpmen_codigo_mkp': fields.char('Codigo no Marketplace', size=40, select=True),
        'mkpmen_data': fields.datetime('Data da mensagem'),
        'mkpmen_data_recebimento': fields.datetime('Data do recebimento'),
        'mkpmen_data_leitura': fields.datetime('Data da leitura', select=True),
        'mkpmen_pedido_mkp': fields.char('Pedido ML', size=20, select=True),
        'mkpmen_pedido_id': fields.many2one('estoquepedidos.pedido.capa', 'Pedido', select=True),
        'mkpmen_dono': fields.selection([('L', 'Loja'), ('C', 'Cliente')], 'Autor', select=True),
        'name': fields.text('Mensagem'),
    }
    _order = 'mkpmen_data desc'
    _sql_constraints=[
            ('codigo_uniq', 'unique(mkpmen_conta_id,mkpmen_codigo_mkp)', 'Codigo de mensagem ja cadastrado!'),
    ]
