# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class mkp_modelos_secao(osv.Model):
    """
    Tabela de secao dos modelos de anuncios proprios do mercado Livre

    prefixo: mkpmsc_
    """

    _name = 'mkp.modelos.secao'
    _inherits = {'mkp.modelos':'mkpmsc_modelo_id'}
    _columns = {
        'name': fields.char('Descricao da secao', required=True),
        'sequence': fields.integer('Sequencia'),
        'mkpmsc_modelo_id': fields.many2one('mkp.modelos', 'Modelo', select=True, ondelete='restrict', required=True),
        'mkpmsc_cab_secao': fields.text('Cabecalho da secao'),
        'mkpmsc_corpo': fields.text('Texto padrao'),
        'mkpmsc_descricao_produto': fields.boolean('Descricao produto', help="Identifica que a secao e descricao do produto"),
    }
    _order = 'mkpmsc_modelo_id,sequence'
    _defaults = {
        'sequence': 10,
    }

