# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import logging


class mkp_notificacoes(osv.Model): # antigo mkp_notificacoes
    """
    Classe para receber as notificacoes do mercado livre
    prefixo mkpnot_
    """
    _name = "mkp.notificacoes" # antigo mkp.notificacoes
    _logger = logging.getLogger(_name)
    _inherit = ['ir.needaction_mixin']
    _gerar_logs_logs = 'N'
    _columns = {
        'id': fields.integer('id', readonly=True),
        'mkpnot_conta_id': fields.many2one('mkp.contas', 'Conta', required=True, select=True),
        'create_date': fields.datetime('Data da inclusao', readonly=True, select=True),
        'write_date': fields.datetime('Ultima inclusao', readonly=True, select=True),
        'mkpnot_resource': fields.char('Recurso', size=128),
        'mkpnot_topic': fields.char('Topic', size=20),
        'mkpnot_attempts': fields.char('Attempts', size=5),
        'state': fields.selection([('R', 'Recebido'), ('P', 'Processado'), ('E', 'Com problema')],
                                  'Status', select=True),
        'mkpnot_mensagem': fields.text('Mensagem'),
        'mkpnot_loja': fields.char('User id', size=24),
    }
    _defaults = {
        'state': 'R',
    }
    _order = 'id desc'

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

