# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

# todo:
# 1) Implementar pesquisa de valor do frete https://api.mercadolibre.com/items/:item_id/shipping_options?zip_code=13565905

from openerp.osv import osv, fields


class mkp_perguntas(osv.Model):
    """
    Tabela de perguntas feita nos anuncios

    prefixo: mkpper_
    """

    from funcoes import _mkpper_get_dados

    _name = 'mkp.perguntas'
    _inherit = ['ir.needaction_mixin']
    _gerar_logs_logs = 'N'
    _columns = {
        'mkpper_codigo_mkp': fields.char('Codigo no Marketplace', size=20, required=True, select=True),
        'mkpper_conta_id': fields.many2one('mkp.contas', 'Conta', required=True, select=True),
        'mkpper_produto_id': fields.many2one('estoque.produto', 'Produto', ondelete='cascade', select=True),
        'name': fields.text('Pergunta'),
        'mkpper_resposta': fields.text('Resposta'),
        'mkpper_data': fields.datetime('Data'),
        'mkpper_cidade': fields.char('Cidade/Estado', size=30),
        'mkpper_cliente_id': fields.function(_mkpper_get_dados, method=True, type='many2one', store=False,
                                            multi="dados", relation='adm.pessoa', string='Cliente'),
        'mkpper_produto_foto': fields.function(_mkpper_get_dados, method=True, type='binary',
                                                      multi="dados", string='Foto'),
        'state': fields.selection([('R', 'Respondida'), ('N', 'Nao respondida'), ('E', 'Anuncio encerrado'),
                                    ('S', 'Sob revisao')], 'Situacao'),
        'mkpper_outras_perguntas_cliente_ids': fields.function(_mkpper_get_dados, method=True, type='one2many',
                                                      multi="dados", relation='mkp.perguntas',
                                                              string='Outras perguntas do cliente'),
        'mkpper_outras_perguntas_produto_ids': fields.function(_mkpper_get_dados, method=True, type='one2many',
                                                      multi="dados", relation='mkp.perguntas',
                                                              string='Outras perguntas no produto'),
        'mkpper_outras_perguntas_cli_pro_ids': fields.function(_mkpper_get_dados, method=True, type='one2many',
                                                              multi="dados", relation='mkp.perguntas',
                                                              string='Outras perguntas'),
        'mkpper_saldo': fields.function(_mkpper_get_dados, method=True, type='float', multi="dados", string='Saldo'),
        'mkpper_apelido': fields.char('Id do usuario no ML', size=14, select=True),
        'mkpper_anuncio_id': fields.many2one('mkp.anuncios', 'Anuncio', select=True),
    }
    _order = 'mkpper_codigo_mkp desc'
