# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################


from openerp.osv import osv, fields


class mkp_produto_marketplaces(osv.Model):
    """
    Tabela de marketplaces de um produto

    prefixo: mkpromkp_
    """

    from funcoes import _mkpromkp_get_dados

    _name = 'mkp.produto.marketplaces'
    _columns = {
        'mkpromkp_produto_id': fields.many2one('estoque.produto', 'Produto', ondelete='cascade', select=True),
        'mkpromkp_marketplace_id': fields.many2one('mkp.marketplaces', 'Marketplace', required=True, select=True),
        'mkpromkp_modelo_id': fields.related('mkpromkp_marketplace_id', 'mkpmkp_modelo_id', relation='mkp.modelos',
                                             type='many2one', store=False, string='Modelo'),
        'mkpromkp_categoria_id': fields.many2one('mkp.categorias', 'Categoria', select=True,
                                                 domain="[('mkpcat_marketplace_id', '=', mkpromkp_marketplace_id)]"),
        'mkpromkp_modelo_tipo': fields.function(_mkpromkp_get_dados, method=True, string='Modelo de anuncio',
                                                type='char', size=1, store=False, multi="dados"),
        'mkpromkp_marketplace_integrador': fields.related('mkpromkp_marketplace_id', 'mkpmkp_codigo', type="char",
                                                    string='Integrador', store=True, size=6),
        'name': fields.related('mkpromkp_marketplace_id', 'name', type="char",
                                                    string='Marketplace', store=False),
        'mkpromkp_secoes_ids': fields.one2many('mkp.produto.marketplaces.secao', 'mkppromkpsc_produto_mkp_id', 'Secoes'),
        'mkpromkp_anuncio_preview_html': fields.function(_mkpromkp_get_dados, method=True,
                                                  string='Preview anuncio',
                                                  type='text', store=False, multi='dados'),
        'mkpromkp_anuncio_preview_text': fields.function(_mkpromkp_get_dados, method=True,
                                                  string='Preview anuncio',
                                                  type='text', store=False, multi='dados'),
        'mkpromkp_imagens_ids': fields.one2many('mkp.produto.marketplace.imagens', 'mkprmkimg_produto_mkp_id', 'Imagens'),
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        # id da empresa\n
    }

    _sql_constraints = [
        ('mkp_uniq', 'unique(company_id,mkpromkp_produto_id,mkpromkp_marketplace_id)', 'O Marketplace nao pode se repetir por produto!'),
    ]

    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }