# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################


from openerp.osv import osv, fields


class mkp_produto_marketplace_imagens(osv.Model):
    """
    Tabela de imagens dos produtos nos marketplaces

    prefixo: mkprmkimg_
    """

    _name = 'mkp.produto.marketplace.imagens'
    _inherits = {'mkp.produto.marketplaces': 'mkprmkimg_produto_mkp_id', 'estoque_img.produto': 'mkprmkimg_imagem_produto_id'}
    _columns = {
        'mkprmkimg_produto_mkp_id': fields.many2one('mkp.produto.marketplaces', 'Marketplace', required=True, ondelete='cascade',
                                            select=True),
        'mkprmkimg_imagem_produto_id': fields.many2one('estoque_img.produto', 'Imagem', required=True, ondelete='cascade',
                                            select=True),
        'sequence': fields.integer('Sequencia'),
        'mkprmkimg_codigo_no_mkp': fields.char("Codigo no Marketplace", size=128, select=True),
        'mkprmkimg_endereco_mkp': fields.char('Endereco no Marketplace', size=264),
        'mkprmkimg_foto':fields.related('mkprmkimg_imagem_produto_id', 'estimg_foto', type="binary",
                                                    string='Imagem', store=False),
        'mkprmkimg_mkp_codigo': fields.related('mkprmkimg_produto_mkp_id', 'mkpromkp_marketplace_integrador', type="char",
                                         size=6, string='Imagenm', store=False),
        'mkprmkimg_dimensoes': fields.related('mkprmkimg_imagem_produto_id','estimg_dimensoes', type='char', size=10, string='Dimensoes', store=False),
        'mkprmkimg_formato': fields.related('mkprmkimg_imagem_produto_id', 'estimg_formato', type='char', size=10, string='Formato', store=False),
        'mkprmkimg_tamanho': fields.related('mkprmkimg_imagem_produto_id', 'estimg_tamanho', type='char', size=10, string='Tamanho', store=False),
    }
    _defaults = {
        'sequence': 10,
    }
    _sql_constraints = {
        ('codigo_uniq', 'unique(mkprmkimg_produto_mkp_id,mkprmkimg_imagem_produto_id)', 'Imagem precisa ser unica no marketplace!'),
    }

    _order = 'mkprmkimg_produto_mkp_id,sequence'