# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class mkp_produto_marketplaces_secao(osv.Model): # antigo ml_produtos_secao
    """
    Tabela de modelos de anuncios dos market places

    prefixo: mkppromkpsc_
    """
    from funcoes import _mkppromkpsc_get_dados

    _name = 'mkp.produto.marketplaces.secao'
    _inherits = {'mkp.produto.marketplaces': 'mkppromkpsc_produto_mkp_id'}

    _columns = {
        'sequence': fields.integer('Sequencia'),
        'mkppromkpsc_produto_mkp_id': fields.many2one('mkp.produto.marketplaces', 'Marketplace', required=True, ondelete='cascade',
                                            select=True),

        'mkppromkpsc_secao_id': fields.many2one('mkp.modelos.secao', 'secoes', required=True, ondelete="restrict",
                                          select=True),
        'mkpromkpsc_modelo_tipo': fields.function(_mkppromkpsc_get_dados, method=True, string='Modelo de anuncio',
                                                type='selection', store=False, multi="dados",
                                              selection=[('T', 'Texto'), ('H', 'Html')]),
        'mkppromkpsc_secao_texto': fields.text('Texto da secao'),
        'mkppromkpsc_sobrepoe_acrescenta': fields.selection([('S','Sobrepor'), ('A', 'Acrescentar')], 'Comportamento', size=1,
                                                      help='Informe se esta seção ira sobrepor a do modelo ou se vai acrescentar!',
                                                      required=True),
    }
    _defaults = {
        'mkppromkpsc_sobrepoe_acrescenta': 'A',
        'mkpromkpsc_modelo_tipo': 'T',
        'sequence': 10,
    }
    _order = 'mkppromkpsc_produto_mkp_id,sequence,mkppromkpsc_secao_id'

