#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from datetime import datetime, timedelta
from SigUtils import datas


class wizard_mkp_acompanhamento_vendas_capa(osv.TransientModel):
    _name = 'wizard.mkp.acompanhamento.vendas.capa'
    _columns = {
        'wizavc_produto_id': fields.many2one('estoque.produto', 'Produto'),
        'wizavc_categoria_id': fields.many2one('estoque.categoria', 'Categoria'),
        'wizavc_so_com_saldo': fields.boolean('So com saldo'),
        'wizavc_prazo_vendas': fields.integer('Prazo para vendas em dias'),
        'wizavc_itens_ids': fields.one2many('wizard.mkp.acompanhamento.vendas.itens', 'wizavi_capa_id', 'Itens'),
    }
    _defaults = {
        'wizavc_prazo_vendas': 30,
        'wizavc_so_com_saldo': True,
    }

    def __wizavc_montar_vals(self, cr, uid, brw_capa, produto_id, context=None):
        obj_produto = self.pool.get('estoque.produto')
        _dt_inicio = datetime.now() - timedelta(days=brw_capa.wizavc_prazo_vendas+1)
        _dt_inicio = self.pool.get('adm.utils').admutl_datetime_to_timezone(cr, uid, _dt_inicio,
                                                                            formato='%Y-%m-%d')
        _local_id = 1 # Todo: buscar o local do marketplace
        _saldo = int(obj_produto.estpro_get_saldo(cr, uid, [produto_id], 'D',_local_id, context=context)[produto_id])
        if brw_capa.wizavc_so_com_saldo and _saldo == 0:
            return False
        sql = """select sum(i.quantidade) from estoque_movimento_capa c
                      inner join estoque_movimento_itens i on i.capa_id = c.id
                      left join estoque_natureza_operacao n on n.id = c.estmvc_operacao_id
                      where c.data > '%s' and
                            i.produto_id = %s and
                            n.estnto_tipo_operacao = 'S' and
                            n.estnto_gerar_estatistica is True
                      """ % (_dt_inicio, produto_id)
        cr.execute(sql)
        quantidade = cr.fetchone()[0]
        if not quantidade:
            quantidade = 0
        sql = """select max(data) from estoque_movimento_capa c
                      inner join estoque_movimento_itens i on i.capa_id = c.id
                      left join estoque_natureza_operacao n on n.id = c.estmvc_operacao_id
                      where i.produto_id = %s and
                            n.estnto_tipo_operacao = 'S' and
                            n.estnto_gerar_estatistica is True
                      """ %  produto_id
        cr.execute(sql)
        _ultima_venda = cr.fetchone()[0]
        if _ultima_venda:
            _dias = datas.calcDiferenca(_ultima_venda, datas.getDataDeHoje('I'))
        else:
            _dias = 9999
        # identificar anuncios do produto
        _sql = "select * from mkp_anuncios where mkpanu_produto_id = %s and mkpanu_estado = 'A'" % produto_id
        cr.execute(_sql)
        _anuncios = cr.dictfetchall()
        lista_anuncios = []
        for _anuncio in _anuncios:
            _sql = "select sum(mlpes_qtd_venda_dia) from mkp_pesquisas where mlpes_anuncios_id = %s and mlpes_data > '%s'" % (_anuncio.get('id'), _dt_inicio)
            cr.execute(_sql)
            _vendas = cr.fetchone()[0]
            sql = """select max(mlpes_data) from ml_pesquisas
                          where mlpes_anuncios_id = '%s' AND
                                mlpes_data > '%s' and
                                mlpes_qtd_venda_dia > 0
                          """ %  (_anuncio.get('id'), _dt_inicio)
            cr.execute(sql)
            _ultima_venda = cr.fetchone()[0]
            if _ultima_venda:
                _dias_p = datas.calcDiferenca(_ultima_venda, datas.getDataDeHoje('I'))
            else:
                _dias_p = 9999
            vals_anuncios = {
                'wizava_anuncio_codigo': _anuncio.get('mlanu_codigo_anuncio'),
                'wizava_mkp_anuncio_tipo_id': _anuncio.get('mlanu_anuncio_tipo_id'),
                'wizava_frete':_anuncio.get('mlanu_frete'),
                'wizava_valor': _anuncio.get('mlanu_valor'),
                'wizava_vendas': _vendas,
                'wizava_dias_sem_venda': _dias_p
            }
            lista_anuncios.append((0, 0, vals_anuncios))
        _vals = {
            'wizavi_capa_id': brw_capa.id,
            'wizavi_produto_id': produto_id,
            'wizavi_saldo': _saldo,
            'wizavi_vendas_proprias': int(quantidade),
            'wizavi_vendas_proprias_tempo': _dias,
            'wizavi_anuncio_ids': lista_anuncios,
        }
        return _vals

    def wizavc_btn_pesquisar(self, cr, uid, ids, context=None):
        obj_produto = self.pool.get('estoque.produto')
        obj_itens = self.pool.get('wizard.mkp.acompanhamento.vendas.itens')
        for brw_capa in self.browse(cr, uid, ids, context=context):
            _itens_ids = obj_itens.search(cr, uid, [('wizavi_capa_id', '=', brw_capa.id)], context=context)
            obj_itens.unlink(cr, uid, _itens_ids, context=context)
            args = []
            if brw_capa.wizavc_produto_id:
                args.append(('id', '=', brw_capa.wizavc_produto_id.id))
            if brw_capa.wizavc_categoria_id:
                args.append(('categoria_id', 'child_of', brw_capa.wizavc_categoria_id.id))
            for produto_id in obj_produto.search(cr, uid, args, context=context):
                vals = self.__wizavc_montar_vals(cr, uid, brw_capa, produto_id, context=context )
                if not vals:
                    continue
                _item_id = obj_itens.create(cr, uid, vals, context=context)


        return True

class wizard_mkp_acompanhamento_vendas_itens(osv.TransientModel):
    _name = 'wizard.mkp.acompanhamento.vendas.itens'
    _columns = {
        'wizavi_capa_id': fields.many2one('wizard.mkp.acompanhamento.vendas.capa', 'Capa', required=True, ondelete='cascade'),
        'wizavi_produto_id': fields.many2one('estoque.produto', 'Produto'),
        'wizavi_saldo': fields.integer('Saldo'),
        'wizavi_vendas_proprias': fields.integer('Vendas'),
        'wizavi_vendas_proprias_tempo': fields.integer('Tempo sem venda'),
        'wizavi_anuncio_ids': fields.one2many('wizard.mkp.acompanhamento.vendas.anuncios', 'wizava_item_id', 'Anuncios'),
    }

class wizard_mkp_acompanhamento_vendas_anuncios(osv.TransientModel):
    _name = 'wizard.mkp.acompanhamento.vendas.anuncios'
    _columns = {
        'wizava_item_id': fields.many2one('wizard.mkp.acompanhamento.vendas.itens', 'Item', required=True, ondelete='cascade'),
        'wizava_anuncio_codigo': fields.char('Codigo do anuncio', size=14),
        'wizava_mkp_anuncio_tipo_id': fields.many2one("mkp.anuncios.tipo", 'Tipo de anuncio'),
        'wizava_frete': fields.selection([('CC', 'Por conta do comprador'), ('GB', 'Frete gratis Brasil'),
                                         ('CV', 'Frete p/conta do vendedor')], 'Frete', size=2),
        'wizava_valor': fields.float('Valor', digits=(7, 2)),
        'wizava_vendas': fields.integer('Vendas'),
        'wizava_dias_sem_venda': fields.integer('Dias sem venda'),

    }

