#!/usr/bin/python
# -*- coding: utf-8 -*-

import time
from openerp.osv import osv, fields
from openerp.tools.translate import _
from SigUtils import numero
from SigUtils import datas
from openerp.tools import config


ordem_do_processo = ('wizfpc_sit_ped',
                     'wizfpc_sit_nf',
                     'wizfpc_sit_danfe_impresso',
                     'wizfpc_sit_etiqueta_endereco')


class wizard_mkp_faturamento_pedido_capa(osv.Model):
    _name = 'wizard.mkp.faturamento.pedido.capa'
    _gerar_logs_logs = 'N'
    _inherit = ['ir.needaction_mixin']

    def _needaction_domain_get(self, cr, uid, context=None):
        """
        Mostra a quantidade de pedidos disponiveis para faturar.

        :param cr: a linha atual do cursor do banco de dados,
        :param uid: o ID do usuario utilizado para a verificacao de perfil,
        :param context: um dicionario padrao para valores contextuais,
        :return: dominio utilizado para contar os pedidos a faturar

        :see: openerp/addons/base/ir/ir.needaction (class ir_needaction_mixin)
        :copyright: OpenERP SA.
        """
        context = context and context.copy() or {}
        return [('state', '!=', '5')]

    def _wizfpc_get_banner(self, cr, uid, ids, name, arg, context=None):
        res = {}
        context = context and context.copy() or {}
        if not ids:
            return res

        for x in self.browse(cr, uid, ids):
            mkp_banner = {
                'Mercado Livre': 'marketplace/static/src/img/ml_banner.png',
                'Amazon': 'marketplace/static/src/img/amazon_banner.png',
                'Magazine Luiza': 'marketplace/static/src/img/magalu_banner.png',
                'Loja Tray': 'marketplace/static/src/img/tray_banner.png',
                'Americanas': 'marketplace/static/src/img/americanas_banner.png',
                'Shoptime': 'marketplace/static/src/img/shoptime_banner.png',
                'Submarino': 'marketplace/static/src/img/submarino_banner.png',
                'Carrefour': 'marketplace/static/src/img/carrefour_banner.png',
                'Olist': 'marketplace/static/src/img/olist_banner.png',
                'Shopee': 'marketplace/static/src/img/shopee_banner.png',
                'Via Varejo': 'marketplace/static/src/img/viavarejo_banner.png',
                'Loja Prestashop': 'marketplace/static/src/img/prestashop_banner.png',
                'Madeira Madeira': 'marketplace/static/src/img/madeira_banner.png',
            }
            if mkp_banner.get(x.wizfpc_marketplace):
                try:
                    arq = '%s/%s' % (config.get('addons_path'), mkp_banner.get(x.wizfpc_marketplace))
                    file_img = open(arq, 'r')
                    _banner = file_img.read()
                    file_img.close()
                except:
                    _banner = ''
            else:
                _banner = ''
            vals = {
                'wizfpc_banner_mkp': _banner,
            }
            res[x.id] = vals
        return res

    def _wizfpc_get_data_hoje(self, cr, uid, ids, name, arg, context=None):
        res = {}
        context = context and context.copy() or {}
        if not ids:
            return res
        for i in ids:
            res[i] = time.strftime('%Y-%m-%d')
        return res

    _columns = {
        'id': fields.integer('id', readonly=1),
        'wizfpc_cliente_id': fields.many2one('adm.pessoa', 'Cliente'),
        'wizfpc_pj_pf': fields.char('PJ PF', size=2),
        'wizfpc_endereco_id': fields.many2one("adm.pessoa.endereco", 'Endereco ',
                                              ondelete="restrict",
                                              domain="[('pessoa_id', '=', wizfpc_cliente_id)]"),
        'wizfpc_encomenda_id': fields.many2one('rastreio.encomendas', 'Encomenda'),
        'wizfpc_shippiment': fields.char('Encomenda', size=15),
        'wizfpc_nro_pedido_externo': fields.char('Nro externo do pedido', size=40, select=1),
        'wizfpc_carrinho_compras': fields.char('Carrinho compras', size=30, select=1),
        'wizfpc_coletas': fields.boolean('Coletas'),
        'state': fields.selection(string='Status',
                                  selection=[('1', 'Esboco'),
                                             ('2', 'Verificado'),
                                             ('3', 'Pedido Faturado'),
                                             ('4', 'Faturado'),
                                             ('5', 'Concluido')
                                             ], size=1, select=1),
        'wizfpc_sit_ped': fields.boolean('Pedido faturado'),
        'wizfpc_sit_nf': fields.boolean('NF faturada'),
        'wizfpc_sit_danfe_impresso': fields.boolean('Danfe Impresso'),
        'wizfpc_sit_etiqueta_endereco': fields.boolean('Etiqueta Endereco impressa'),
        'wizfpc_detalhe_ids': fields.one2many('wizard.mkp.faturamento.pedido.detalhe', 'wizfpd_capa_id',
                                              'Produtos', ondelete="cascade"),
        'wizfpc_conferencia_ids': fields.one2many('wizard.mkp.faturamento.pedido.conferencia',
                                                  'wizfco_capa_id', 'Conferencia',
                                                  ondelete="cascade"),
        'wizfpc_perguntas_ids': fields.one2many('wizard.mkp.faturamento.pedido.perguntas',
                                                'wizfpe_capa_id', 'Perguntas',
                                                ondelete="cascade"),
        'wizfpc_mensagens_ids': fields.one2many('wizard.mkp.faturamento.pedido.mensagens',
                                                'wizfme_capa_id', 'Mensagens',
                                                ondelete="cascade"),
        'wizfpc_codigo_etiqueta': fields.char('Etiqueta correios', char=20),
        'wizfpc_chave_nfe': fields.char('Chave NFE', size=44),
        'wizfpc_nf_id': fields.many2one('fiscal.nf.capa', 'NF'),
        'wizfpc_conta_id': fields.many2one('mkp.contas', 'Conta'),
        'wizfpc_modelo_90': fields.boolean('Modelo 90+'),
        'wizfpc_mkp_integrador': fields.char('Codigo Mkp', size=6),
        'wizfpc_logo_mkp': fields.char('Logo Mkp', size=60),
        'wizfpc_marketplace': fields.char('Marketplace', size=20),
        'wizfpc_banner_mkp': fields.function(_wizfpc_get_banner, method=True, string='Banner Mkp',
                                               type='binary', store=False, multi="dados"),
        'wizfpc_mensagem': fields.text('Mensagem'),
        'wizfpc_faturar_em': fields.date('Faturar em'),
        'wizfpc_hoje': fields.function(_wizfpc_get_data_hoje, method=True,
                                      string='Hoje', type='date', store=False),
    }
    _order = 'wizfpc_mkp_integrador,wizfpc_faturar_em,id'
    _defaults = {
        'state': '1',
    }

    def wizfpc_cron_excluir_fat_concluido(self, cr, uid, prazo=None, context=None):
        """
        Método chamado pelo cron para excluir faturamentos já concluidos
        @return: Sempre True
        """
        try:
            prazo = int(prazo)
        except:
            prazo = 15
        _hoje = datas.getDataDeHoje('I')
        _data_fim = datas.calcVencimento(_hoje, prazo * -1)
        _sql = "delete from wizard_mkp_faturamento_pedido_capa where wizfpc_faturar_em < '%s' and state = '5'" % \
               _data_fim[:4] + '-' + _data_fim[4:6] + '-' + _data_fim[6:]
        cr.execute(_sql)
        return True

    def search(self, cr, user, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        load = '_classic_write'
        if not 'wizfpc_conta_id' in str(args):
            _company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, user, 'mkp.contas', context=context)
            conta_ids = self.pool.get('mkp.contas').search(cr, user, [('company_id', '=', _company_id)],
                                                           context=context)
            if conta_ids:
                args.append(('wizfpc_conta_id', 'in', tuple(conta_ids)))
        res = super(wizard_mkp_faturamento_pedido_capa, self).search(cr, user, args, offset=offset, limit=limit,
                                                                     order=order, context=context, count=count)
        if not context.get('wizard_tela_faturamento') or count:
            return res
        context.pop('wizard_tela_faturamento')
        _spg = self.pool.get
        # pedidos de venda em Esboco e Validados
        args_pedido = [('tipo', '=', 'V'), ('state', '=', 'V'), ('pedcap_full', '!=', True)]
        pedido_ids = _spg('estoquepedidos.pedido.capa').search(cr, user, args_pedido, order='id', context=context)
        if not pedido_ids:
            return res

        dados = _spg('estoquepedidos.pedido.capa').read(cr, user, pedido_ids, ['pessoa_id', 'pedido_item_ids', 'pedcap_endereco_id',
                                                       'pedcap_encomenda_id', 'pedcap_nro_pedido_externo',
                                                       'pedcap_mkp_mensagens_ids', 'pedcap_pj_pf', 'pedcap_mkp_shipping',
                                                       'pedcap_conta_id', 'pedcap_integrador', 'pedcap_mkp_logo_mkp',
                                                       'pedcap_mkp_banner_mkp', 'pedcap_marketplace',
                                                       'pedcap_mkp_carrinho_compras', 'pedcap_faturar_em'],
                                context=context, load=load)
        ped_externo = {}
        itens_ids = []
        mensagens = {}
        _idx = 0
        for i in dados:
            _conta_id = i.get('pedcap_conta_id')
            _ped_id = i.get('id')
            ped_externo[_ped_id] = i.get('pedcap_nro_pedido_externo')
            itens_ids.extend(i.get('pedido_item_ids'))
            for mid in i.get('pedcap_mkp_mensagens_ids'):
                if mensagens.get(_ped_id):
                    mensagens[_ped_id].append((0, 0, {'wizfme_mensagem_id': mid}))
                else:
                    mensagens[_ped_id] = [(0, 0, {'wizfme_mensagem_id': mid})]
            # se não tiver encomenda, tentar pegar
            _encomenda_id = i.get('pedcap_encomenda_id')
            _nro_externo = i.get('pedcap_nro_pedido_externo')
            _shipping_id = i.get('pedcap_mkp_shipping')
            try:
                if (not _encomenda_id) and _nro_externo:
                    if not _shipping_id:
                        dados_order = _spg('mkp.utils').mkpcutl_get_order(cr, user, _nro_externo, context=context)
                        _shipping_id = dados_order.get('shipping') and dados_order.get('shipping').get('id')
                    _encomenda = _spg('mkp.utils').mkputl_get_tracking_number(cr, user, _shipping_id, _conta_id)
                    if _encomenda:
                        _pessoa_id = i.get('pessoa_id')
                        _encomenda_id = _spg('mkp.utils').mkpcutl_incluir_codigo_postagem(cr, user, i.get('id'), _pessoa_id,
                                                                                _encomenda,  context=context)
                        dados[_idx]['pedcap_encomenda_id'] = _encomenda_id
            except:
                pass
            _idx += 1
        detalhe = {}
        produto_ids = []
        grade_ids = []
        local_ids = []
        _chave_perguntas = []
        for i in _spg('estoquepedidos.pedido.item').read(cr, user, itens_ids,
                                                                  ['produto_id', 'grade_id', 'qtde_pedida', 'pedido_id',
                                                                   'pedite_anuncio_id', 'local_id'],
                                                                  context=context):
            pedido_id = i.get('pedido_id') and i.get('pedido_id')[0]
            anuncio_id = i.get('pedite_anuncio_id') and i.get('pedite_anuncio_id')[0]
            if pedido_id and anuncio_id:
                _chave_perguntas.append({'pedido_id': pedido_id, 'anuncio_id': anuncio_id})
            codigo = i.get('produto_id')[1].split(' -')[0]
            qtde_pedida = i.get('qtde_pedida')
            vals_itens = {'wizfpd_codigo': codigo,
                          'wizfpd_grade': i.get('grade_id') and i.get('grade_id')[1].split(' -')[0] or '',
                          'wizfpd_descricao': i.get('grade_id') and i.get('grade_id')[1].split('- ')[1] or '',
                          'wizfpd_qtd': qtde_pedida,
                          'wizfpd_pedido_id': pedido_id,
                          'produto_id': i.get('produto_id')[0],
                          'grade_id': i.get('grade_id') and i.get('grade_id')[0],
                          'local_id': i.get('local_id')[0],
                          'wizfpd_pedido_mkp_id': ped_externo[pedido_id],
                          'wizfpd_embalagem_id': i.get('produto_embalagem_id') and i.get('produto_embalagem_id')[0]}
            produto_ids.append(i.get('produto_id')[0])
            grade_ids.append(i.get('grade_id') and i.get('grade_id')[0])
            local_ids.append(i.get('local_id')[0])
            if not detalhe.get(pedido_id):
                detalhe[pedido_id] = [[0, 0, vals_itens]]
            else:
                detalhe[pedido_id].append([0, 0, vals_itens])
        perguntas = {}
        for i in _chave_perguntas:
            _pedido_id = i.get('pedido_id')
            _anuncio_id = i.get('anuncio_id')
            _apelido = False
            for x in _spg('estoquepedidos.pedido.capa').browse(cr, user, [_pedido_id], context=context):
                _apelido = x.pessoa_id.fantasia_apelido
            if _apelido:
                _perguntas_ids = _spg('mkp.perguntas').search(cr, user,
                                                      [('mkp_apelido', '=', _apelido),
                                                       ('mkpper_anuncio_id', '=', _anuncio_id)], context=context)
                for per in _perguntas_ids:
                    if perguntas.get(_pedido_id):
                        perguntas[_pedido_id].append((0,0, {'wizfpe_pergunta_id': per}))
                    else:
                        perguntas[_pedido_id] = [(0,0, {'wizfpe_pergunta_id': per})]

        dict_locacao = {}
        args_loc = [('produto_id', 'in', produto_ids),
                    ('grade_id', 'in', grade_ids),
                    ('local_id', 'in', local_ids)]
        locacao_ids = _spg('estoque.local.locacao').search(cr, user, args_loc, context=context)
        campos = ['produto_id', 'grade_id', 'local_id', 'locacao']
        for i in _spg('estoque.local.locacao').read(cr, user, locacao_ids, campos, context=context, load=load):
            chave = '%s-%s-%s' % (i.get('produto_id'), i.get('grade_id'), i.get('local_id'))
            dict_locacao[chave] = i.get('locacao')

        _ids_excluidos = []
        for i in dados:
            if not detalhe.get(i.get('id')):
                continue # Pedido sem itens
            for j in detalhe.get(i.get('id')):
                chave = '%s-%s-%s' % (j[2].pop('produto_id'),
                                      j[2].pop('grade_id'),
                                      j[2].pop('local_id'))
                if dict_locacao.get(chave):
                    j[2]['wizfpd_locacao'] = dict_locacao.get(chave)
            _conta_id = i.get('pedcap_conta_id')
            if _conta_id:
                dados_conta = _spg('mkp.contas').read(cr, user, _conta_id, ['mkpcta_ml_coletas'], context=context)
                _coleta = dados_conta.get('mkpcta_ml_coletas')
            else:
                _coleta = ''
            vals = {'wizfpc_cliente_id': i.get('pessoa_id'),
                    'wizfpc_pj_pf': i.get('pedcap_pj_pf'),
                    'wizfpc_faturar_em': i.get('pedcap_faturar_em'),
                    'wizfpc_endereco_id': i.get('pedcap_endereco_id'),
                    'wizfpc_encomenda_id': i.get('pedcap_encomenda_id'),
                    'wizfpc_shippiment': i.get('pedcap_mkp_shipping'),
                    'wizfpc_nro_pedido_externo': i.get('pedcap_nro_pedido_externo'),
                    'wizfpc_carrinho_compras': i.get('pedcap_mkp_carrinho_compras'),
                    'wizfpc_coletas': _coleta,
                    'wizfpc_conta_id': _conta_id,
                    'wizfpc_mkp_integrador': i.get('pedcap_integrador'),
                    'wizfpc_logo_mkp': i.get('pedcap_mkp_logo_mkp'),
                    'wizfpc_banner_mkp': i.get('pedcap_mkp_banner_mkp'),
                    'wizfpc_detalhe_ids': detalhe.get(i.get('id')),
                    'wizfpc_perguntas_ids': perguntas.get(i.get('id')),
                    'wizfpc_mensagens_ids': mensagens.get(i.get('id')),
                    'wizfpc_marketplace': i.get('pedcap_marketplace'),
                    }
            # testar pelo carrinho de compras
            if i.get('pedcap_mkp_carrinho_compras'):
                wargs = [('wizfpc_carrinho_compras', '=', i.get('pedcap_mkp_carrinho_compras')),
                         ('wizfpc_marketplace', '=', i.get('pedcap_marketplace'))]
                wids = self.search(cr, user, wargs, context=context)
            else:
                wargs = [('wizfpc_nro_pedido_externo', '=', i.get('pedcap_nro_pedido_externo')),
                         ('wizfpc_marketplace', '=', i.get('pedcap_marketplace'))]
                wids = self.search(cr, user, wargs, context=context)
            # if not wids:
            #     if i.get('pedcap_marketplace') == 'Mercado Livre': # testar pelo shippment
            #         wargs = [('wizfpc_cliente_id', '=', i.get('pessoa_id')),
            #                  ('wizfpc_shippiment', '=', i.get('pedcap_mkp_shipping'))]
            #         wids = self.search(cr, user, wargs, context=context)
            #     if not wids:
            #         # Se nao encontrou o pedido com encomenda, procurar sem encomenda para nao ficar duplicado
            #         wargs = [('wizfpc_cliente_id', '=', i.get('pessoa_id')),
            #                  ('state', '!=', '5'),
            #                  ('wizfpc_encomenda_id', '=', None)]
            #         wids = self.search(cr, user, wargs, context=context)
            if not wids:
                capa_id = self.create(cr, user, vals, context=context)
                res.append(capa_id)
                _ids_excluidos.append(capa_id)
            else:
                # Excluir apenas 1 vez, porque pedidos de carrinho de compra que tem mais de uma ordem só ficava uma ordem sem este controle
                if not wids[0] in _ids_excluidos:
                    sql = 'delete from wizard_mkp_faturamento_pedido_detalhe where wizfpd_capa_id = %s' % wids[0]
                    cr.execute(sql)
                    sql = 'delete from wizard_mkp_faturamento_pedido_perguntas where wizfpe_capa_id = %s' % wids[0]
                    cr.execute(sql)
                    sql = 'delete from wizard_mkp_faturamento_pedido_mensagens where wizfme_capa_id = %s' % wids[0]
                    cr.execute(sql)
                    _ids_excluidos.append(wids[0])
                self.write(cr, user, wids, vals, context=context)
        return res

    def wizfpd_button_esboco(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': '1'}, context=context)
        return True

    def wizfpd_button_validar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        campos = ['wizfpc_conferencia_ids']
        detalhe_ids = []
        map(lambda x: detalhe_ids.extend(x.get('wizfpc_conferencia_ids')),
            self.read(cr, uid, ids, campos, context=context))
        obj_conf = self.pool.get('wizard.mkp.faturamento.pedido.conferencia')
        campos = ['wizfco_codigo_barra', 'wizfco_qtd', 'wizfco_qtd_pedida']
        if not detalhe_ids:
            raise osv.except_osv(_('Atencao!'),
                                 _('E necessario fazer a conferencia dos itens antes de validar:'))
        _dqtds = {}
        for i in obj_conf.read(cr, uid, detalhe_ids, campos, context=context):
            if _dqtds.get(i.get('wizfco_codigo_barra')):
                _dqtds[i.get('wizfco_codigo_barra')]['pedida'] = _dqtds.get(i.get('wizfco_codigo_barra')).get('pedida') + i.get('wizfco_qtd_pedida')
                _dqtds[i.get('wizfco_codigo_barra')]['conferida'] = _dqtds.get(i.get('wizfco_codigo_barra')).get('conferida') + i.get('wizfco_qtd')
            else:
                _dqtds[i.get('wizfco_codigo_barra')] = {'pedida': i.get('wizfco_qtd_pedida'), 'conferida': i.get('wizfco_qtd')}
        msg = []
        for i in _dqtds:
            if _dqtds.get(i).get('pedida') != _dqtds.get(i).get('conferida'):
                msg.append(i)
        if msg:
            raise osv.except_osv(_('Atencao!'),
                                 _('Quantidade atendida diferente da pedida nos itens:\n%s')
                                 % ',\n'.join(msg))

        self.write(cr, uid, ids, {'state': '2'}, context=context)
        return True

    def wizfpd_button_faturar(self, cr, uid, ids, context=None):
        def _get_nf_id(pedido):
            sql = 'select distinct nf_id from fiscal_nf_pedidos where pedido_id = %s' % pedido
            cr.execute(sql)
            _nf_ids = filter(None, map(lambda x: x[0], cr.fetchall()))
            if _nf_ids:
                return _nf_ids
            return False

        def _wizfdp_get_passo(passo):
            def _get_wizfpc_sit_ped():
                # Faturar pedido
                for ped_id in pedido_ids:
                    dados_pedido = obj_pedido_capa.read(cr, uid, ped_id, ['state', 'pessoa_id'], context)
                    destinatario_id = dados_pedido[0].get('pessoa_id')[0]
                    if dados_pedido[0].get('state') != 'V':
                        return {}

                if len(pedido_ids) > 1:
                    context['faturar_diversos_pedidos'] = True
                    obj_pedido_capa.button_faturar_pedido(cr, uid, pedido_ids, context=context,
                                                          destinatario_id=destinatario_id,
                                                          pedido_ids=pedido_ids)
                else:
                    obj_pedido_capa.button_faturar_pedido(cr, uid, pedido_ids, context=context)
                self.write(cr, uid, brw.id, {'wizfpc_sit_ped': True, 'state': '3'}, context=context)
                cr.commit()
                return {}

            def _get_wizfpc_sit_nf():
                nf_ids = obj_nf_capa.search(cr, uid, [('fisnfc_pedido_ids', '=', pedido_ids[0])])
                if not nf_ids:
                    return {}

                res = obj_nf_capa.read(cr, uid, nf_ids[0], ['state'], context=context)
                if not res:
                    return res
                if res.get('state') == '1': #Esboco -> Validar nf
                    obj_nf_capa.button_verificar_nf(cr, uid, nf_ids[0], context)
                    cr.commit()
                    res = obj_nf_capa.read(cr, uid, nf_ids[0], ['state'], context=context)
                if res.get('state') == 'EP': # Lote em processamento -> processar lote
                    obj_nf_capa.fisnfc_button_processar_lote(cr, uid, nf_ids, context=context)
                    cr.commit()
                    res =  obj_nf_capa.read(cr, uid, nf_ids[0],['state'], context=context)
                if res.get('state') in ('2', '2E'):
                    obj_nf_capa.fisnfc_funcao_button_faturar(cr, uid, nf_ids, context)
                    cr.commit()
                    res = obj_nf_capa.read(cr, uid, nf_ids[0], ['state'], context=context)
                if res.get('state') == '3':
                    self.write(cr, uid, brw.id, {'wizfpc_sit_nf': True, 'state': '4', 'wizfpc_nf_id': nf_ids[0]}, context)
                    cr.commit()
                    self.pool.get('mkp.utils').mkputl_faturar_no_mkp(cr, uid, [nf_ids[0]], context=context)
                return {}

            def _get_wizfpc_sit_danfe_impresso():
                context_nf = context.copy()
                context_nf['gerar_danfe'] = True
                # imprime a nf
                nf_ids = obj_nf_capa.search(cr, uid, [('fisnfc_pedido_ids', '=', pedido_ids[0]), ('state', '=', '3')]) # Só notas faturadas
                if not nf_ids:
                    return {}
                dados_nf = obj_nf_capa.read(cr, uid, nf_ids[0], ['fisnfc_modelo_serie'], context=context)
                modelo = int(dados_nf.get('fisnfc_modelo_serie')[:2])
                vals = {'wizfpc_sit_danfe_impresso': True,  'wizfpc_nf_id': nf_ids[0]}
                if modelo < 90:
                    obj_nf_capa.exportar_xml_danfe(cr, uid, nf_ids, context=context_nf, show_wizard=False)
                else:
                    vals['wizfpc_modelo_90'] = True
                self.write(cr, uid, brw.id, vals, context=context)
                cr.commit()
                return {}

            def _get_wizfpc_sit_etiqueta_endereco():
                # https: // api.mercadolibre.com / shipment_labels?shipment_ids = {shipping_id} & response_type = zpl2 & access_token = {access_token}

                return {}

            res = {}
            if passo == 'wizfpc_sit_ped':
                res = _get_wizfpc_sit_ped()
            elif passo == 'wizfpc_sit_nf':
                res = _get_wizfpc_sit_nf()
            elif passo == 'wizfpc_sit_danfe_impresso':
                res = _get_wizfpc_sit_danfe_impresso()
            elif passo == 'wizfpc_sit_etiqueta_endereco':
                res = _get_wizfpc_sit_etiqueta_endereco()

            return res
            #

        context = context and context.copy() or {}
        obj_pedido_capa = self.pool.get('estoquepedidos.pedido.capa')
        obj_nf_capa = self.pool.get('fiscal.nf.capa')
        for brw in self.browse(cr, uid, ids, context=context):
            pedido_ids = []
            for brw_det in brw.wizfpc_detalhe_ids:
                _ped_id = brw_det.wizfpd_pedido_id.id
                if not _ped_id in pedido_ids:
                    pedido_ids.append(_ped_id)
            for item in ordem_do_processo:
                _wizfdp_get_passo(item)

        return True

    def wizfpc_verificar_se_fatura_no_mkp(self, cr, uid, ids, context=None):
        return True

    def wizfpc_imprimir_etiqueta(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        _spg = self.pool.get
        det_ids = []
        _conta_id = False
        _mkp_integrador = ''
        _modelo_90 = False
        vals = {'wizfpc_mensagem': ''}
        for x in self.read(cr, uid, ids, ['wizfpc_detalhe_ids', 'wizfpc_encomenda_id','wizfpc_conta_id',
                                          'wizfpc_mkp_integrador','wizfpc_modelo_90'], context):
            if x.get('wizfpc_conta_id'):
                _conta_id = x.get('wizfpc_conta_id')[0]
                _mkp_integrador = x.get('wizfpc_mkp_integrador')
            det_ids.extend(x.get('wizfpc_detalhe_ids'))
            if x.get('wizfpc_modelo_90'):
                _modelo_90 = True
            pedido_ids = map(lambda x: x.get('wizfpd_pedido_id'),
                         _spg('wizard.mkp.faturamento.pedido.detalhe').read(cr, uid,
                                                                            det_ids,
                                                                            ['wizfpd_pedido_id'],
                                                                            context,
                                                                            '_classic_write'))
            if _modelo_90:
                _nf_prt = _spg('adm.utils').admutl_get_parametros(cr, uid, 'fiscal', ['impressora_danfe']).get('impressora_danfe')
                context['mkp_modelo_90'] = _nf_prt
            else:
                self.wizfpc_verificar_se_fatura_no_mkp(cr, uid, ids, context=context)
            res = _spg('mkp.utils').mkputl_get_etiqueta_no_mkp(cr, uid, _mkp_integrador, _conta_id, pedido_ids,
                                                               context=context)
            if res.get('status'):
                vals.update({'wizfpc_sit_etiqueta_endereco': True})
                if res.get('dados') and res.get('dados').get('encomenda_id'):
                    vals.update({'wizfpc_encomenda_id': res.get('dados').get('encomenda_id')})
            else:
                vals['wizfpc_mensagem'] = res.get('mensagem')
            if x.get('wizfpc_mkp_integrador') in ('Olist', 'SupCam'):  # Atualiza a encomenda no wizard
                dados_ped = _spg('estoquepedidos.pedido.capa').read(cr, uid, pedido_ids[0],
                                                                    ['pedcap_encomenda_id'],
                                                                    context, '_classic_write')
                if dados_ped and isinstance(dados_ped, list):
                    dados_ped = dados_ped[0]
                vals.update({'wizfpc_encomenda_id': dados_ped.get('pedcap_encomenda_id')})
            self.write(cr, uid, ids, vals)
        return True

    # imprime a nf
    def wizfpc_button_danfe_impresso(self, cr, uid, ids, context=None):
        context_nf = context.copy()
        context_nf['gerar_danfe'] = True
        _spg = self.pool.get
        _conta_id = False
        _mkp_integrador = ''
        vals = {'wizfpc_mensagem': ''}
        for brw in self.browse(cr, uid, ids, context=context):
            pedido_ids = []
            if brw.wizfpc_conta_id:
                _conta_id = brw.wizfpc_conta_id.id
                _mkp_integrador = brw.wizfpc_mkp_integrador
            for brw_det in brw.wizfpc_detalhe_ids:
                _ped_id = brw_det.wizfpd_pedido_id.id
                if not _ped_id in pedido_ids:
                    pedido_ids.append(_ped_id)
            nf_ids = _spg('fiscal.nf.capa').search(cr, uid, [('fisnfc_pedido_ids', '=', pedido_ids[0]),
                                                             ('state', '=', '3')])  # Só notas faturadas
            if not nf_ids:
                return {}
            dados_nf = _spg('fiscal.nf.capa').read(cr, uid, nf_ids[0], ['fisnfc_modelo_serie'], context=context)
            modelo = int(dados_nf.get('fisnfc_modelo_serie')[:2])
            if modelo < 90:
                _spg('fiscal.nf.capa').exportar_xml_danfe(cr, uid, nf_ids, context=context_nf, show_wizard=False)
            else:
                context['danfe'] = True
                _nf_prt = _spg('adm.utils').admutl_get_parametros(cr, uid, 'fiscal', ['impressora_danfe']).get('impressora_danfe')
                context['mkp_modelo_90'] = _nf_prt
                res = _spg('mkp.utils').mkputl_get_etiqueta_no_mkp(cr, uid, _mkp_integrador, _conta_id, pedido_ids, context=context)
                if not res.get('status'):
                    vals['wizfpc_mensagem'] = res.get('mensagem')
                if brw.wizfpc_mkp_integrador == 'Shopee':  # Atualiza a encomenda no wizard
                    dados_ped = _spg('estoquepedidos.pedido.capa').read(cr, uid, pedido_ids[0],
                                                                       ['pedcap_encomenda_id'],
                                                                       context, '_classic_write')
                    if dados_ped and isinstance(dados_ped, list):
                        dados_ped = dados_ped[0]
                    vals.update({'wizfpc_encomenda_id': dados_ped.get('pedcap_encomenda_id')})
                self.write(cr, uid, brw.id, vals, context=context)
        return True

    def wizfpc_button_concluir(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        for brw_wizard in self.browse(cr, uid, ids, context=context):
            if brw_wizard.state != '4':
                raise osv.except_osv(_('Atencao!'),
                                     _('Nao esta faturado!'))
            if brw_wizard.wizfpc_conta_id.mkpcta_ml_coletas:
                if brw_wizard.wizfpc_codigo_etiqueta != brw_wizard.wizfpc_shippiment:
                    raise osv.except_osv(_('Atencao!'), _('Etiqueta de postagem divergente!'))
            else:
                if not brw_wizard.wizfpc_codigo_etiqueta:
                    raise osv.except_osv(_('Atencao!'), _('Etiqueta de postagem divergente!'))
                if not brw_wizard.wizfpc_encomenda_id:
                    raise osv.except_osv(_('Atencao!'), _('Etiqueta de postagem divergente!'))
                if brw_wizard.wizfpc_codigo_etiqueta.upper() != brw_wizard.wizfpc_encomenda_id.name.upper():
                    raise osv.except_osv(_('Atencao!'), _('Etiqueta de postagem divergente!'))


            if (brw_wizard.wizfpc_chave_nfe and
                    brw_wizard.wizfpc_chave_nfe != brw_wizard.wizfpc_nf_id.nfe_chave_acesso):
                raise osv.except_osv(_('Atencao!'),
                                     _('Chave de nf divergente!'))
        self.write(cr, uid, ids, {'state': '5'}, context=context)
        return True

    def wizfpc_sit_etiqueta_endereco(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.wizfpc_imprimir_etiqueta(cr, uid, ids, context)
        return True

    def wizfpd_button_etiqueta(self, cr, uid, ids, context=None):
        context = context and context.copy()
        self.wizfpc_imprimir_etiqueta(cr, uid, ids, context)
        return True


class wizard_mkp_faturamento_pedido_detalhe(osv.Model):
    _name = 'wizard.mkp.faturamento.pedido.detalhe'
    _gerar_logs_logs = 'N'
    _columns = {
        'wizfpd_capa_id': fields.many2one('wizard.mkp.faturamento.pedido.capa', 'Capa', ondelete='cascade'),
        'wizfpd_codigo': fields.char('Codigo', size=20),
        'wizfpd_grade': fields.char('Grade', size=2),
        'wizfpd_descricao': fields.char('Descricao', size=80),
        'wizfpd_qtd': fields.integer('Quantidade'),
        'wizfpd_locacao': fields.char('Locacao', size=15),
        'wizfpd_pedido_id': fields.many2one('estoquepedidos.pedido.capa', 'Pedido'),
        'wizfpd_embalagem_id': fields.many2one("estoque.produto.embalagem", 'Embalagem', ondelete="set null"),
        'wizfpd_pedido_mkp_id': fields.char('Pedido Marketplace', size=30),
    }
    _order = 'wizfpd_locacao'

    def wizfpd_visualizar_pedido(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        pedido_id = self.read(cr, uid, ids, ['wizfpd_pedido_id'], context=context,
                              load='_classic_write')[0].get('wizfpd_pedido_id')

        obj_model_data = self.pool.get('ir.model.data')
        reference = obj_model_data.get_object_reference(cr, uid, 'estoquepedidos',
                                                        'view_estoquepedidos_pedido_capa_form')
        view_id = reference and reference[1] or False
        return {
            # 'name': _('Itens da Requisicao: %s') % str(numero),
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'estoquepedidos.pedido.capa',
            'type': 'ir.actions.act_window',
            'view_id': view_id,
            'res_id': pedido_id,
            'target': 'new',
            'context': context,
        }

    def wizfpd_open_url(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        nro = self.browse(cr, uid, ids, context=context)[0].wizfpd_pedido_id.pedcap_nro_pedido_externo
        if not nro:
            return True
        url = 'https://www.mercadolivre.com.br/vendas/%s/detalhe' % nro
        # url = 'https://myaccount.mercadolivre.com.br/sales/vop?&orderId=%s' % nro
        return {
            'type': 'ir.actions.act_url',
            'url': url,
            'target': 'new'
        }


class wizard_mkp_faturamento_pedido_conferencia(osv.Model):
    _name = 'wizard.mkp.faturamento.pedido.conferencia'
    _columns = {
        'wizfco_capa_id': fields.many2one('wizard.mkp.faturamento.pedido.capa', 'Capa'),
        # 'wizfco_detalhe_id': fields.many2one('wizard.mkp.faturamento.pedido.detalhe', 'Detalhe'),
        'wizfco_codigo_barra': fields.char('Codigo de barra', size=20),
        'wizfco_produto': fields.char('Produto', size=64),
        'wizfco_codigo': fields.char('Codigo', size=20),
        'wizfco_grade': fields.char('Grade', size=2),
        'wizfco_qtd': fields.integer('Quantidade'),
        'wizfco_qtd_pedida': fields.integer('Quantidade pedida'),
    }

    def wizfco_onchange_codbarra(self, cr, uid, ids, codigo_barra, context=None):
        context = context and context.copy() or {}
        context.update({'active_test': False})
        obj_codigo_barra = self.pool.get('automacao.codigo.barra')
        codbarra_ids = obj_codigo_barra.search(cr, uid, [('codigo_barra', '=', codigo_barra)], context=context)
        if not codbarra_ids:
            raise osv.except_osv(_('Atencao'), _('Codigo de barras nao cadastrado!'))
        brw_cod_barra = obj_codigo_barra.browse(cr, uid, codbarra_ids[0], context=context)
        prod = '%s-%s %s' % (
            brw_cod_barra.produto_id.codigo,
            brw_cod_barra.grade_id.grade,
            brw_cod_barra.grade_id.name
        )
        cod = brw_cod_barra.produto_id.codigo
        grade = brw_cod_barra.grade_id.grade
        return {'value': {'wizfco_produto': prod, 'wizfco_codigo': cod, 'wizfco_grade': grade}}

    def wizfco_get_qtd_pedida(self, cr, uid, ids, codigo, grade, context=None):
        res = {}
        for i in self.browse(cr, uid, ids, context=context):
            vals = {}
            for d in i.wizfco_capa_id.wizfpc_detalhe_ids:
                if d.wizfpd_codigo == codigo and d.wizfpd_grade == grade:
                    if vals.get('wizfco_qtd_pedida'):
                        vals = {'wizfco_qtd_pedida': vals.get('wizfco_qtd_pedida') + d.wizfpd_qtd}
                    else:
                        vals = {'wizfco_qtd_pedida': d.wizfpd_qtd}
                    self.write(cr, uid, i.id, vals, context=context)
        return

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        cod = numero.getNumToStr(vals['wizfco_codigo_barra'], 14, 0, 'N')  # formatar para 14 bytes
        if cod == -1:
            raise osv.except_osv(_('Atencao'), _('Codigo de barras invalido.'))

        vals['wizfco_codigo_barra'] = cod
        codigo = vals.get('wizfco_codigo')
        grade = vals.get('wizfco_grade')
        id = super(wizard_mkp_faturamento_pedido_conferencia, self).create(cr, uid, vals, context=context)
        self.wizfco_get_qtd_pedida(cr, uid, [id], codigo, grade, context=context)
        return id

        if isinstance(ids, (int, long)):
            ids = [ids]
        for dados in self.read(cr, uid, ids, [], context=context):
            if dados.get('wizfco_codigo'):
                codigo = dados.get('wizfco_codigo')
            if dados.get('wizfco_grade'):
                grade = dados.get('wizfco_grade')
            if vals.get('wizfco_codigo_barra'):
                cod = numero.getNumToStr(vals['wizfco_codigo_barra'], 14, 0, 'N')  # formatar para 14 bytes
                if cod == -1:
                    raise osv.except_osv(_('Atencao'), _('Codigo de barras invalido.'))
                vals['wizfco_codigo_barra'] = cod
                if vals.get('wizfco_codigo'):
                    codigo = vals.get('wizfco_codigo')
                if vals.get('wizfco_grade'):
                    grade = vals.get('wizfco_grade')
        res = super(wizard_faturamento_pedido_conferencia, self).write(cr, uid, ids, vals, context=context)
        if vals.get('wizfco_codigo_barra'):
            vals['wizfco_qtd_pedida'] = self.wizfco_get_qtd_pedida(cr, uid, ids, codigo, grade, context=context)
        return res


class wizard_mkp_faturamento_pedido_perguntas(osv.Model):
    _name = 'wizard.mkp.faturamento.pedido.perguntas'
    _gerar_logs_logs = 'N'

    def _wizfpe_get_dados(self, cr, uid, ids, field_name, args, context=None):
        context = context and context.copy() or {}
        res = {}
        pergunta_ids = []
        for i in self.read(cr, uid, ids, ['wizfpe_pergunta_id']):
            pergunta_ids.append(i.get('wizfpe_pergunta_id')[0])
            for brw_mkp_perguntas in self.pool.get('mkp.perguntas').browse(cr, uid, pergunta_ids, context=context):
                _pergunta = brw_mkp_perguntas.name
                _resposta = brw_mkp_perguntas.mkpper_resposta
                _data = brw_mkp_perguntas.mkpper_data
                res[i.get('id')] = {
                    'wizfpe_data': _data,
                    'wizfpe_pergunta': _pergunta,
                    'wizfpe_resposta': _resposta,
                }
        return res

    _columns = {
        'wizfpe_capa_id': fields.many2one('wizard.mkp.faturamento.pedido.capa', 'Capa', ondelete='cascade'),
        'wizfpe_pergunta_id': fields.many2one('mkp.perguntas', 'Pergunta', ondelete='cascade'),
        'wizfpe_data': fields.function(_wizfpe_get_dados, method=True, type='datetime', store=False,
                                       multi="dados", string='Data'),
        'wizfpe_pergunta': fields.function(_wizfpe_get_dados, method=True, type='text', store=False,
                                           multi="dados", string='Pergunta'),
        'wizfpe_resposta': fields.function(_wizfpe_get_dados, method=True, type='text', store=False,
                                           multi="dados", string='Resposta'),
    }


class wizard_mkp_faturamento_pedido_mensagens(osv.Model):
    _name = 'wizard.mkp.faturamento.pedido.mensagens'
    _gerar_logs_logs = 'N'

    def _wizfme_get_dados(self, cr, uid, ids, field_name, args, context=None):
        context = context and context.copy() or {}
        res = {}
        mensagem_ids = []
        for i in self.read(cr, uid, ids, ['wizfme_mensagem_id']):
            mensagem_ids.append(i.get('wizfme_mensagem_id')[0])
            for brw_mkp_mensagens in self.pool.get('mkp.mensagens').browse(cr, uid, mensagem_ids, context=context):
                _mensagem = brw_mkp_mensagens.name
                res[i.get('id')] = {
                    'wizfme_mensagem': _mensagem,
                }
        return res

    _columns = {
        'wizfme_capa_id': fields.many2one('wizard.mkp.faturamento.pedido.capa', 'Capa', ondelete='cascade'),
        'wizfme_mensagem_id': fields.many2one('mkp.mensagens', 'Mensagem', ondelete='cascade'),
        'wizfme_mensagem': fields.function(_wizfme_get_dados, method=True, type='text', store=False,
                                           multi="dados", string='Mensagem'),

    }
