#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv
import json
import logging
from SigUtils.cep import Correios
from openerp.tools import config


class mkp_utils(osv.Model):
    _inherit = 'mkp.utils'

    def _mkputl_get_prodkit_contem_item(self, cr, uid, produto_ids, context=None):
        """
        Metodo para retornar produtos que estão contindos no kit do produto kit
        :param cr:
        :param uid:
        :param produto_ids: ids dos produtos
        :param context:
        :return: lista de ids de produtos que estão contidos em kit dos produtos fornecidos
        """
        _spg = self.pool.get
        lista = super(mkp_utils, self)._mkputl_get_prodkit_contem_item(cr, uid, produto_ids, context=context)
        modulo_kit_instalado = _spg('adm.utils').admutl_check_modulo_instalado(cr, uid, 'kit', context)
        if modulo_kit_instalado:
            produto_ids = map(lambda x:"%s" % x, produto_ids)
            sql = "select kitpro_produto_id from kit_produto where kitpro_item_produto_id in (%s)" % ",".join(produto_ids)
            cr.execute(sql)
            lista = []
            for dados_kit in cr.dictfetchall():
                lista.append(dados_kit.get('kitpro_produto_id'))
        return lista

    def _mkputl_get_kit_itens(self, cr, uid, produto_id, context=None):
        """
        Método a ser sobrescrito par buscar os itens que compoem o kit
        :param self:
        :param cr:
        :param uid:
        :param produto_id:
        :param context:
        :return:
        """
        obj_kit_produto = self.pool.get('kit.produto')
        kit_ids = obj_kit_produto.search(cr, uid, [('kitpro_produto_id', '=', produto_id)], context=context)
        lista = []
        for dados_kits in obj_kit_produto.read(cr, uid, kit_ids, [], context=context):
            _dict = {'produto': dados_kits.get('kitpro_item_produto_id')[0], 'qtd': dados_kits.get('kitpro_quantidade')}
            lista.append(_dict)
        return lista

    def _mkputl_monta_dic_item_pedido(self, cr, uid, prod_id, grade_id, local_id, emb_id, qtd, valor, anuncio_id, context=None):
        context = context and context.copy() or {}
        obj_estoque_produto = self.pool.get('estoque.produto')
        obj_local_locacao = self.pool.get('estoque.local.locacao')
        brw_produtos = obj_estoque_produto.browse(cr, uid, prod_id, context=context)
        if brw_produtos.kit_de_produtos:
            _dict_prods = {}
            i = 0
            lista = []
            res = []
            for brw_item in brw_produtos.produto_kit_ids:
                i += 1
                _dic_item = {'prod_id': brw_item.kitpro_item_produto_id.id}
                _dic_item['grade_id'] = brw_item.kitpro_grade_id.id
                _dic_item['nova_qtd'] = brw_item.kitpro_quantidade * qtd
                _dic_item['novo_valor'] = brw_item.kitpro_preco_venda * qtd
                _args = [('grade_id', '=', brw_item.kitpro_grade_id.id), ('local_id', '=', local_id)]
                _emb_ids = obj_local_locacao.search(cr, uid, _args, context=context)
                _emb_id = \
                    obj_local_locacao.read(cr, uid, _emb_ids[0],
                                           ['estllc_produto_embalagem_id'], context=context)[
                        'estllc_produto_embalagem_id'][0]
                _dic_item['emb_id'] = _emb_id
                _dict_prods[i] = _dic_item
                lista.append([i,_dic_item['novo_valor']])
            lista = self.pool.get('adm.utils').efetuar_rateio((valor * qtd), elementos=lista)
            for x in lista:
                _dict_prods.get(x[0])['novo_valor'] = x[1]
            for x in _dict_prods:
                _item = super(mkp_utils, self)._mkputl_monta_dic_item_pedido(cr, uid,
                                                                              _dict_prods.get(x).get('prod_id'),
                                                                              _dict_prods.get(x).get('grade_id'),
                                                                              local_id,
                                                                              _dict_prods.get(x).get('emb_id'),
                                                                              _dict_prods.get(x).get('nova_qtd'),
                                                                              _dict_prods.get(x).get('novo_valor') / _dict_prods.get(x).get('nova_qtd'),
                                                                              anuncio_id,
                                                                              context=context)
                res.append(_item[0])
        else:
            res = super(mkp_utils, self)._mkputl_monta_dic_item_pedido(cr, uid, prod_id, grade_id, local_id, emb_id, qtd,
                                                                     valor, anuncio_id, context=context)
        return res

