# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################
from openerp.osv import osv
import json
import logging
from ..mm import MadMad
from openerp.osv.fields import float_round
from SigUtils import datas


MM_STATUS = [
    '0-A processar',
    '1-Aguardando aprovacao',
    '2-Divergencias',
    '3-Reprovado',
    '4-Aguardando confirmacao',
    '5-Publicado'
]

# Classe de alto nivel para comunicação com o Madeira Madeira
class mkp_MadMad(osv.Model):
    _name = 'mkp.madmad'
    _auto = False
    _tem_erro = False
    _mensagem_erro = ''
    _logger = logging.getLogger(_name)

    def mkpMadMad_get_anuncio_status(self, cr, uid, brw_anuncio, context=None):
        def _get_producao():
            _url = 'v1/produto/%s' % _sku
            response = mm_con.mad_comunicar('get', _url, {})
            if response.status_code < 400:
                dados_anuncio['status_mkp'] = MM_STATUS[5]
            return response

        def _get_aguardando():
            _url = 'v1/produto/aguardando/%s' % _sku
            response = mm_con.mad_comunicar('get', _url, {})
            if response.status_code < 400:
                dados_anuncio['status_mkp'] = MM_STATUS[1]
            return response

        def _get_aprocessar():
            _url = 'v1/produto/aprocessar/%s' % _sku
            response = mm_con.mad_comunicar('get', _url, {})
            if response.status_code < 400:
                dados_anuncio['status_mkp'] = MM_STATUS[0]
            return response

        context = context and context.copy() or {}
        _spg = self.pool.get
        mm_con = MadMad(cr, uid, brw_anuncio.mkpanu_conta_id.id)
        dados_anuncio = {}
        for brw_grade in brw_anuncio.mkpanu_produto_id.produto_grade_ids:
            if brw_anuncio.mkpanu_produto_id.grade_usar:
                _sku = '%s%s' % (brw_anuncio.mkpanu_produto_id.codigo, brw_grade.grade)
            else:
                _sku = '%sUN' % brw_anuncio.mkpanu_produto_id.codigo
            retorno = _get_producao()
            if retorno.status_code < 400:
                vals_acoes = {
                    'mkpaco_conta_id': brw_anuncio.mkpanu_conta_id.id,
                    'mkpaco_objeto': 'P',
                    'mkpaco_acao': 'A',
                    'mkpaco_id': brw_anuncio.id,
                }
                _spg('mkp.acoes').create(cr, uid, vals_acoes, context=context)
                vals_acoes = {
                    'mkpaco_conta_id': brw_anuncio.mkpanu_conta_id.id,
                    'mkpaco_objeto': 'S',
                    'mkpaco_acao': 'A',
                    'mkpaco_id': brw_anuncio.id,
                }
                _spg('mkp.acoes').create(cr, uid, vals_acoes, context=context)
                _loja = brw_anuncio.mkpanu_conta_id.mkpcta_mm_loja
                vals_anuncio = {
                    'mkpanu_anuncio_endereco':'https://painelmarketplace.madeiramadeira.com.br/painel/v2/produtos-view.html#-%s|%s' % (_sku, _loja),
                    'mkpanu_necessita_atualizar': False,
                }
                ret_anuncio = json.loads(retorno.content)
                if ret_anuncio and ret_anuncio.get('data') and ret_anuncio.get('data').get('url'):
                    vals_anuncio['mkpanu_anuncio_endereco'] = 'https://madeiramadeira.com.br%s' % ret_anuncio.get('data').get('url')
                _spg('mkp.anuncios').write(cr, uid, brw_anuncio.id, vals_anuncio, context=context)
                return {'status': True, 'mensagem': '', 'dados_anuncio': dados_anuncio}
            retorno = _get_aguardando()
            if retorno.status_code < 400:
                return {'status': True, 'mensagem': '', 'dados_anuncio': dados_anuncio}
            retorno = _get_aprocessar()
            if retorno.status_code < 400:
                return {'status': True, 'mensagem': '', 'dados_anuncio': dados_anuncio}
            if retorno.status_code == 404:
                _url = 'v1/produto/aguardando/%s' % _sku
                response = mm_con.mad_comunicar('get', _url, {})
                _json = json.loads(response.content)
                _causa = ' '
                for x in _json.get('errors'):
                    if isinstance(x, unicode):
                        _causa = '%s %s\n' % (_causa, x)
                    else:
                        _causa = '%s%s-%s\n' % (_causa, x.get('id'), x.get('title'))
                _mens = _causa
                return {'status': False, 'mensagem': _mens}


    def mkpMadMad_set_anuncio(self, cr, uid, brw_anuncio, context=None):
        def _atualizar_variacoes():
            variacoes_atuais = {}
            for brw_var in brw_anuncio.mkpanu_variacoes_ids:
                variacoes_atuais[brw_var.mkpanuv_grade_id.id] = brw_var.mkpanuv_id_no_mkp
            if variacoes_atuais.get(brw_grade.id):  # Já tem
                return
            vals_var = {
                'mkpanuv_anuncio_id': brw_anuncio.id,
                'mkpanuv_grade_id': brw_grade.id,
                'mkpanuv_id_no_mkp': vals.get('sku'),
            }
            _spg('mkp.anuncios.var').create(cr, uid, vals_var, context=context)
            return

        context = context and context.copy() or {}
        _spg = self.pool.get
        mm_con = MadMad(cr, uid, brw_anuncio.mkpanu_conta_id.id)
        args = [
            ('mkpromkp_produto_id', '=', brw_anuncio.mkpanu_produto_id.id),
            ('mkpromkp_marketplace_id', '=', brw_anuncio.mkpanu_marketplace_id.id),
            ('company_id', '=', brw_anuncio.company_id.id)
        ]
        context['sig_force_company'] = True
        mkpromkp_ids = _spg('mkp.produto.marketplaces').search(cr, uid, args, context=context)
        context.pop('sig_force_company')
        if not mkpromkp_ids:
            return {'status': False, 'mensagem': 'Marketplace nao cadastrado!'}

        brw_mkpromkp = _spg('mkp.produto.marketplaces').browse(cr, uid, mkpromkp_ids[0], context=context)

        _atributos = []
        _marca = ''
        for brw_atributo in brw_mkpromkp.mkpromkp_produto_id.estpro_atributo_ids:
            _valor_att = brw_atributo.estatp_atributo_valor
            if brw_atributo.estatp_tem_unidade:
                _valor_att = '%s%s' % (brw_atributo.estatp_atributo_valor, brw_atributo.estatp_atributo_unidade_id.name)
            if not _valor_att:
                return {'status': False,
                        'mensagem': 'Item %s com atributos sem valor!' % brw_atributo.estatp_produto_id.codigo}

            _dic = {'nome': brw_atributo.estatp_atributo_id.name, 'valor': _valor_att}
            if brw_atributo.estatp_atributo_id.name.lower() == 'marca':
                _marca = _valor_att
            _atributos.append(_dic)
        if brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_responsavel:
            _g = "do vendedor" if brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_responsavel == 'L' else "de fábrica"
            _tp = {'D': 'dias', 'M': 'meses', 'A': 'anos'}
            _gar = '%s Prazo:%s %s' % (_g,
                                       brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_prazo,
                                       _tp.get(brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_prazo_tipo))
        else:
            _gar = brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia
        _atributos.append({'nome': 'Garantia', 'valor': _gar})
        _local = brw_anuncio.mkpanu_conta_id.mkpcta_local_id.id

        for brw_grade in brw_anuncio.mkpanu_produto_id.produto_grade_ids:
            vals = {}
            _imagens = []
            _cat_code = int(brw_mkpromkp.mkpromkp_categoria_id.mkpcat_codigo.split('-')[1])
            for brw_imagens in brw_mkpromkp.mkpromkp_imagens_ids:
                if brw_imagens.mkprmkimg_imagem_produto_id.estimg_grade_id.id:
                    if brw_imagens.mkprmkimg_imagem_produto_id.estimg_grade_id.id != brw_grade.id:
                            continue
                _imagens.append(brw_imagens.mkprmkimg_endereco_mkp)
            if not _imagens:
                return {'status': False,
                        'mensagem': 'Item %s-%s sem fotos!' % (brw_grade.produto_id.codigo, brw_grade.grade)}
            _valor = brw_anuncio.mkpanu_valor_promocao or brw_anuncio.mkpanu_valor or brw_anuncio.mkpanu_valor_sugerido
            _ean = False
            for brw_cod_barra in brw_anuncio.mkpanu_produto_id.automacao_ids:
                if not brw_cod_barra.active:
                    continue
                if brw_cod_barra.grade_id.id != brw_grade.id:
                    continue
                if brw_cod_barra.autcba_tipo_barra == '13':
                     _ean = brw_cod_barra.codigo_barra[1:]

            vals['id_categoria'] = _cat_code
            if brw_anuncio.mkpanu_produto_id.grade_usar:
                vals['nome'] = '%s - %s' % (brw_anuncio.mkpanu_title, brw_grade.descricao)
                i = 0
                for __att in _atributos:
                    if __att.get('nome') == brw_anuncio.mkpanu_produto_id.estpro_grade_descricao:
                        _atributos.pop(i)
                        break
                    i += 1
                _dic = {'nome': brw_anuncio.mkpanu_produto_id.estpro_grade_descricao, 'valor': brw_grade.descricao}
                _atributos.append(_dic)
            else:
                vals['nome'] = brw_anuncio.mkpanu_title
            vals['descricao'] = brw_anuncio.mkpanu_descricao_html
            vals['ean'] = _ean
            if brw_anuncio.mkpanu_produto_id.grade_usar:
                vals['sku'] = '%s%s' % (brw_anuncio.mkpanu_produto_id.codigo, brw_grade.grade)
            else:
                vals['sku'] = '%sUN' % brw_anuncio.mkpanu_produto_id.codigo
            vals['marca'] = _marca or 'OEM'
            vals['preco_por'] = 30.0 if _valor < 30 else _valor
            vals['preco_de'] = float_round((vals['preco_por'] / 0.9), 2)
            if brw_anuncio.mkpanu_produto_id.grade_usar:
                context['company_id'] = brw_anuncio.company_id.id
                _x = _spg('estoque.produto.grade').estpgr_get_saldo(cr, uid, [brw_grade.id], 'D', _local, context=context)
                _saldo = int(_x.get(brw_grade.id) / brw_anuncio.mkpanu_quantidade) if _x.get(brw_grade.id) > 0 else 0
            else:
                _saldo = brw_anuncio.mkpanu_saldo
            vals['estoque'] = _saldo if _saldo < 501 else 500
            _peso = 0.3
            _altura = 7
            _largura = 10
            _comprimento = 10
            for brw_embalagem in brw_anuncio.mkpanu_produto_id.produto_embalagem_ids:  # pegar APENAS A PRIMEIRA
                _peso = brw_embalagem.peso_bruto
                _altura = brw_embalagem.altura
                _largura = brw_embalagem.largura
                _comprimento = brw_embalagem.profundidade
                break
            vals['altura'] = _altura
            vals['largura'] = _largura
            vals['profundidade'] = _comprimento
            vals['peso'] = _peso
            vals['imagens'] = _imagens
            vals['atributos'] = _atributos
            if brw_anuncio.mkpanu_produto_id.estpro_mkp_link_video:
                vals['video'] = brw_anuncio.mkpanu_produto_id.estpro_mkp_link_video
            _url = 'v1/produto'
            if brw_anuncio.mkpanu_codigo_anuncio:
                response = mm_con.mad_comunicar('put', _url, [vals])
                if response.status_code == 422:  # Nao tem nada pra alterar
                    return {'status': True, 'mensagem': ''}
            else:
                response = mm_con.mad_comunicar('post', _url, [vals])
            if response.status_code > 399:
                _json = json.loads(response.content)
                _causa = ' '
                for x in _json.get('errors'):
                    """Item nao sobreu alteracao"""
                    if response.status_code == 422 and x.get('detail'):
                        return {'status': False, 'mensagem': x.get('detail')}
                    if isinstance(x, unicode):
                        _causa = '%s %s\n' % (_causa, x)
                    else:
                        _causa = '%s%s\n' % (_causa, x.get('detail'))
                _mens = _causa
                return {'status': False, 'mensagem': _mens}
            vals_anuncio = {}
            if brw_anuncio.mkpanu_produto_id.grade_usar:
                vals_anuncio['mkpanu_codigo_anuncio'] = brw_anuncio.mkpanu_produto_id.codigo
            else:
                vals_anuncio['mkpanu_codigo_anuncio'] = vals.get('sku')
            vals_anuncio['mkpanu_estado_mkp'] = MM_STATUS[0]
            vals_anuncio['mkpanu_estado'] = 'G'
            _loja = brw_anuncio.mkpanu_conta_id.mkpcta_mm_loja
            _codigo = brw_anuncio.mkpanu_produto_id.codigo
            if brw_anuncio.mkpanu_produto_id.grade_usar:
                _sku = '%s%s' % (_codigo, brw_anuncio.mkpanu_produto_id.produto_grade_ids[0].grade)
            else:
                _sku = '%sUN' % _codigo
            vals_anuncio['mkpanu_anuncio_endereco'] = \
                'https://painelmarketplace.madeiramadeira.com.br/painel/v2/produtos-view.html#-%s|%s' % (_sku, _loja)
            _spg('mkp.anuncios').write(cr, uid, brw_anuncio.id, vals_anuncio, context=context)
            _atualizar_variacoes()
        return {'status': True, 'mensagem': ''}

    def mkpMadMad_atualizar_saldo(self, cr, uid, anuncio_id, context=None):
        """
        Inclui ou altera saldo do anuncio no site do Madeira Madeira
        @param cr:
        @param uid:
        @param anuncio_id: ids do anuncio alterado
        @param context:
        @return: dicionario contendo id do anuncio e response ex.:{status: True/False, 'mensagem': 'Mensagem'}
                 response. quando response.raise_for_status() for None, tá tudo certo. Para pegar o erro use response.status_code
        """
        context = context and context.copy() or {}
        _spg = self.pool.get
        brw_anuncio = _spg('mkp.anuncios').browse(cr, uid, anuncio_id, context=context)
        context['company_id'] = brw_anuncio.company_id.id
        mm_con = MadMad(cr, uid, brw_anuncio.mkpanu_conta_id.id)
        _local = brw_anuncio.mkpanu_conta_id.mkpcta_local_id.id
        # Verificar situacao do anuncio no Madeira Madeira
        if not brw_anuncio.mkpanu_codigo_anuncio:
            res = {'status': True, 'mensagem': ''}
            return res
        vals = []
        for _brw_grade in brw_anuncio.mkpanu_produto_id.produto_grade_ids:
            context['company_id'] = brw_anuncio.company_id.id
            _x = _spg('estoque.produto.grade').estpgr_get_saldo(cr, uid, [_brw_grade.id], 'D', _local, context=context)
            _saldo = int(_x.get(_brw_grade.id) / brw_anuncio.mkpanu_quantidade) if _x.get(_brw_grade.id) > 0 else 0
            _saldo = _saldo if _saldo < 501 else 500
            if brw_anuncio.mkpanu_produto_id.grade_usar:
                _sku = '%s%s' % (brw_anuncio.mkpanu_produto_id.codigo, _brw_grade.grade)
            else:
                _sku = '%sUN' % brw_anuncio.mkpanu_produto_id.codigo
            vals.append({'sku': _sku, 'estoque': _saldo})
        _url = 'v1/produto/estoque'
        response = mm_con.mad_comunicar('put', _url, vals)
        if response.status_code > 399:
            _json = json.loads(response.content)
            _causa = ' '
            for x in _json.get('errors'):
                """Item ainda nao esta ativo no mkp"""
                if response.status_code == 422 and x.get('status') == 404:
                    return {'status': True, 'mensagem': ''}
                """Estoque igual ao enviado recentemente"""
                if response.status_code == 422 and x.get('status') == 422:
                    return {'status': True, 'mensagem': ''}
                if isinstance(x, unicode):
                    _causa = '%s %s\n' % (_causa, x)
                else:
                    _causa = '%s%s-%s\n' % (_causa, x.get('id'), x.get('title'))
            _mens = _causa
            return {'status': False, 'mensagem': _mens}
        res = {'status': True, 'mensagem': ''}
        return res

    def mkpMadMad_atualizar_preco(self, cr, uid, anuncio_id, context=None):
        """
        Altera preco do anuncio no site do Madeira Madeira
        @param cr:
        @param uid:
        @param anuncio_id: ids do anuncio alterado
        @param context:
        @return: dicionario contendo id do anuncio e response ex.:{status: True/False, 'mensagem': 'Mensagem'}
                 response. quando response.raise_for_status() for None, tá tudo certo. Para pegar o erro use response.status_code
        """
        context = context and context.copy() or {}
        _spg = self.pool.get
        brw_anuncio = _spg('mkp.anuncios').browse(cr, uid, anuncio_id, context=context)
        mm_con = MadMad(cr, uid, brw_anuncio.mkpanu_conta_id.id)
        _local = brw_anuncio.mkpanu_conta_id.mkpcta_local_id.id
        # Verificar situacao do anuncio no Madeira Madeira
        if not brw_anuncio.mkpanu_codigo_anuncio:
            res = {'status': True, 'mensagem': ''}
            return res
        vals = []
        for _brw_grade in brw_anuncio.mkpanu_produto_id.produto_grade_ids:
            if brw_anuncio.mkpanu_produto_id.grade_usar:
                _sku = '%s%s' % (brw_anuncio.mkpanu_produto_id.codigo, _brw_grade.grade)
            else:
                _sku = '%sUN' % brw_anuncio.mkpanu_produto_id.codigo
            _valor = brw_anuncio.mkpanu_valor_promocao or brw_anuncio.mkpanu_valor or brw_anuncio.mkpanu_valor_sugerido
            _preco_por = 30.0 if _valor < 30 else _valor
            _preco_de = float_round((_preco_por / 0.9), 2)
            vals.append({
                'sku': _sku,
                'preco_de': _preco_de,
                'preco_por': _preco_por
            })
        _url = 'v1/produto/preco'
        response = mm_con.mad_comunicar('put', _url, vals)
        if response.status_code > 399:
            _json = json.loads(response.content)
            _causa = ' '
            for x in _json.get('errors'):
                """Item ainda nao esta ativo no mkp"""
                if response.status_code == 422 and x.get('status') == 404:
                    return {'status': True, 'mensagem': ''}
                if isinstance(x, unicode):
                    _causa = '%s %s\n' % (_causa, x)
                else:
                    _causa = '%s%s-%s\n' % (_causa, x.get('id'), x.get('title'))
            _mens = _causa
            return {'status': False, 'mensagem': _mens}
        res = {'status': True, 'mensagem': ''}
        return res

    def mkpMadMad_get_orders(self, cr, uid, pedido, conta_id, context=None):
        """
        Método destinado a buscar um pedido no Madeira Madeira
        @param cr:
        @param uid:
        @param pedido: Número do pedido no Madeira Madeira
        @param context:
        @return: Sempre True
        """
        context = context and context.copy() or {}
        mm_con = MadMad(cr, uid, conta_id)
        _url = 'v1/pedido/id/%s' % pedido
        response = mm_con.mad_comunicar('get', _url)
        if response.status_code > 399:
            if response.status_code == 404:
                return {'status': False, 'mensagem': 'Pagina nao encontrada!'}
            _json = json.loads(response.content)
            _causa = ' '
            for x in _json.get('errors'):
                """Item nao sobreu alteracao"""
                if response.status_code == 422 and x.get('detail'):
                    return {'status': False, 'mensagem': x.get('detail')}
                if isinstance(x, unicode):
                    _causa = '%s %s\n' % (_causa, x)
                else:
                    _causa = '%s%s\n' % (_causa, x.get('detail'))
            _mens = _causa
            return {'status': False, 'mensagem': _mens}
        dados = json.loads(response.text)
        return {'status': True, 'mensagem': '', 'pedido': dados}

    def mkpMadMad_set_order_recebida(self, cr, uid, conta_id, order, context=None):
        """
        Informa pedido recebido ao Madeira Madeira
        @param cr:
        @param uid:
        @param order: Numero da ordem
        @param context:
        @return: dicionario contendo id do anuncio e response ex.:{status: True/False, 'mensagem': 'Mensagem'}
                 response. quando response.raise_for_status() for None, tá tudo certo. Para pegar o erro use response.status_code
        """
        context = context and context.copy() or {}
        mm_con = MadMad(cr, uid, conta_id)
        _spg = self.pool.get
        _url = 'v1/pedido/received'
        vals = [{
            'id_pedido': int(order)
        }]
        response = mm_con.mad_comunicar('put', _url, vals)
        if response.status_code > 399:
            _json = json.loads(response.content)
            _causa = ' '
            for x in _json.get('errors'):
                """Item ainda nao esta ativo no mkp"""
                if response.status_code == 422 and x.get('status') == 404:
                    return {'status': True, 'mensagem': ''}
                if isinstance(x, unicode):
                    _causa = '%s %s\n' % (_causa, x)
                else:
                    _causa = '%s%s-%s\n' % (_causa, x.get('id'), x.get('title'))
            _mens = _causa
            return {'status': False, 'mensagem': _mens}
        res = {'status': True, 'mensagem': ''}
        return res

    def mkpMadMad_set_order_faturado(self, cr, uid, _order, _conta_id, context=None):
        context = context and context.copy() or {}
        _spg = self.pool.get
        ped_id = _spg('estoquepedidos.pedido.capa').search(cr, uid, [('pedcap_nro_pedido_externo', '=', _order)],
                                                           context=context)
        brw_ped = _spg('estoquepedidos.pedido.capa').browse(cr, uid, ped_id[0], context=context)
        _itens = []
        for brw_nf in brw_ped.pedcap_nf_ids:
            _chave = brw_nf.nfe_chave_acesso
            _data_emissao = brw_nf.data_emissao[:10]
            for brw_itens in brw_ped.pedido_item_ids:
                _item = {
                    'sku': '%s%s' % (brw_itens.produto_id.codigo, brw_itens.grade_id.grade),
                    'quantidade': int(brw_itens.qtde_pedida),
                    'chave_acesso': _chave,
                    'data_emissao': datas.getDataNoFormato(_data_emissao),
                    'valor': brw_itens.valor_total,
                }
                _itens.append(_item)
            recurso = 'v1/pedido/invoiced'
            vals = [{
                'id_pedido': int(_order),
                'faturamento': _itens,
            }]
            mkp_con = MadMad(cr, uid, _conta_id)
            response = mkp_con.mad_comunicar('put', recurso, vals)
            """ Pedido ja esta faturado """
            if response.status_code == 422:
                return {'status': True, 'mensagem': ''}
            if response.status_code > 399:
                return {'status': False, 'mensagem': json.loads(response.content)}
        return {'status': True, 'mensagem': ''}

    def mkpMadMad_set_order_enviado(self, cr, uid, _order, _conta_id, data, rastreio, context=None):
        context = context and context.copy() or {}
        _spg = self.pool.get
        ped_id = _spg('estoquepedidos.pedido.capa').search(cr, uid, [('pedcap_nro_pedido_externo', '=', _order)],
                                                           context=context)
        brw_ped = _spg('estoquepedidos.pedido.capa').browse(cr, uid, ped_id[0], context=context)
        _itens = []
        _data = data[:10]
        for brw_itens in brw_ped.pedido_item_ids:
            _item = {
                'sku': '%s%s' % (brw_itens.produto_id.codigo, brw_itens.grade_id.grade),
                'quantidade': int(brw_itens.qtde_pedida),
                'data_transportadora': datas.getDataNoFormato(_data),
                'codigo_rastreio': rastreio,
                'nome_transportadora': 'CORREIOS',
                'url_rastreio': 'https://www2.correios.com.br/sistemas/rastreamento/',
            }
            _itens.append(_item)
        recurso = 'v1/pedido/shipped'
        vals = [{
            'id_pedido': int(_order),
            'envio': _itens,
        }]
        mkp_con = MadMad(cr, uid, _conta_id)
        response = mkp_con.mad_comunicar('put', recurso, vals)
        if response.status_code > 399:
            return {'status': False, 'mensagem': json.loads(response.content)}
        return {'status': True, 'mensagem': ''}


    def mkpMadMad_set_order_entregue(self, cr, uid, _order, _conta_id, data, context=None):
        context = context and context.copy() or {}
        _spg = self.pool.get
        ped_id = _spg('estoquepedidos.pedido.capa').search(cr, uid, [('pedcap_nro_pedido_externo', '=', _order)],
                                                           context=context)
        brw_ped = _spg('estoquepedidos.pedido.capa').browse(cr, uid, ped_id[0], context=context)
        _itens = []
        for brw_itens in brw_ped.pedido_item_ids:
            _item = {
                'sku': '%s%s' % (brw_itens.produto_id.codigo, brw_itens.grade_id.grade),
                'quantidade': int(brw_itens.qtde_pedida),
                'data_entrega': datas.getDataNoFormato(data),
            }
            _itens.append(_item)
        recurso = 'v1/pedido/delivered'
        vals = [{
            'id_pedido': int(_order),
            'entrega': _itens,
        }]
        mkp_con = MadMad(cr, uid, _conta_id)
        response = mkp_con.mad_comunicar('put', recurso, vals)
        if response.status_code > 399:
            return {'status': False, 'mensagem': json.loads(response.content)}
        return {'status': True, 'mensagem': ''}

    def mkpMadMad_get_categorias(self, cr, uid, context=None):
        self._logger.info('Buscando categorias no Madeira Madeira!')
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
        _url = '/v1/categoria/limit=100000&offset=0'
        mkp_con = MadMad(cr, uid, company_id=company_id)
        xml_str = mkp_con.get(_url)
        if xml_str.status_code > 399:
            self._logger.info('Nao consegui conectar no Madeira Madeira')
            return False
        return xml_str
