# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from ...adm.control.utils import capitalize_all
from datetime import datetime, timedelta
import subprocess
from openerp.tools.translate import _

MAD_STATUS_ORDER = {
    '1': 'Novo',
    '2': 'Recebido',
    '3': 'Aprovado',
    '4': 'Cancelado',
    '5': 'Cancelado',
    '6': 'Faturado',
    '7': 'Enviado',
    '8': 'Entregue',
}

class mkp_utils(osv.Model):
    _inherit = 'mkp.utils'

    def mkputl_atualizar_anuncio_madmad(self, cr, uid, id, context=None):
        """
        Inclui ou altera anuncio no site da madmad
        @param cr:
        @param uid:
        @param id: id do anuncio a ser alterado
        @param context:
        @return: dicionario contendo id do anuncio e response ex.:{status: True/False, 'mensagem': 'Mensagem'}
                 response. quando response.raise_for_status() for None, tá tudo certo. Para pegar o erro use response.status_code
        """

        context = context and context.copy() or {}
        _spg = self.pool.get
        brw_anuncio = _spg('mkp.anuncios').browse(cr, uid, id, context=context)
        if not brw_anuncio:  # anuncio nao existe mais. Retornar True para que a ação seja encerrada
            return {'status': True, 'mensagem': ''}
        try:
            _codigo = brw_anuncio.mkpanu_codigo_anuncio
        except:  # Erro porque o id não existe
            return {'status': True, 'mensagem': ''}
        vals_anuncio = {'mkpanu_necessita_atualizar': False}
        res = _spg('mkp.madmad').mkpMadMad_set_anuncio(cr, uid, brw_anuncio, context=context)
        return res


    def mkputl_importar_um_pedido_madmad(self, cr, uid, ped, conta_id, context=None):
        context = context and context.copy() or {}
        _venda = ped
        _madmad_venda_id = _venda.get('id_pedido')
        self._logger.info('Importando pedido MadMad: %s' % _venda.get('id_pedido'))
        _spg = self.pool.get
        brw_conta = _spg('mkp.contas').browse(cr, uid, conta_id, context=context)
        context['sig_force_company'] = brw_conta.company_id.id
        _local_id = brw_conta.mkpcta_local_id.id
        _hoje = _spg('adm.utils').admutl_datetime_to_timezone(cr, uid, datetime.now(), formato='%Y_%m_%d_%H_%M_%s')
        cr.execute(''' BEGIN; SAVEPOINT importar_pedido_madmad_%s; ''' % _hoje)
        _comentario = ''
        _status_madmad_name = MAD_STATUS_ORDER.get(_venda.get('status'))
        _data_venda = _venda.get('data_criacao')[:10]
        _lista_itens = []
        _qtd_venda = 0
        _vr_acrescimo = 0
        _preco_total = 0
        for _item in _venda.get('skus'):
            _pedido_item = {}
            _sku_code = _item.get('skuseller')[:-2]
            _sku_grade = _item.get('skuseller')[-2:]
            _produto_ids = _spg('estoque.produto').search(cr, uid, [('codigo', '=', _sku_code)], context=context)
            if not _produto_ids:
                continue
            _produto_id = _produto_ids[0]
            _sku_anuncio = _sku_code if _sku_grade != 'UN' else _item.get('skuseller')
            _args = [('mkpanu_codigo_anuncio', '=', _sku_anuncio)]
            _anuncio_ids = _spg('mkp.anuncios').search(cr, uid, _args, context=context)
            if not _anuncio_ids:  # se não achar o anuncio direto pelo codigo, buscar pelo produto e conta
                _args = [('mkpanu_produto_id', '=', _produto_id), ('mkpanu_conta_id', '=', conta_id)]
                _anuncio_ids = _spg('mkp.anuncios').search(cr, uid, _args, context=context)
                if not _anuncio_ids:
                    continue
            _frete_receita = 0
            _brw_anuncio = _spg('mkp.anuncios').browse(cr, uid, _anuncio_ids[0], context=context)
            _grade_ids = _spg('estoque.produto.grade').search(cr, uid, [('produto_id', '=', _produto_id),
                                                                        ('grade', '=', _sku_grade)], context=context)
            _qtd_anuncio = _brw_anuncio.mkpanu_quantidade or 1
            if _qtd_anuncio == 0:
                _qtd_anuncio = 1
            _qtd_venda = int((_item.get('quantidade') or 1) * _qtd_anuncio)
            _valor_total_item = (float(_item.get('valor_unitario')) / _qtd_anuncio) * _qtd_venda
            _l_vl = _valor_total_item / _qtd_venda
            _args = [('grade_id', '=', _grade_ids[0]), ('local_id', '=', _local_id)]
            _emb_ids = _spg('estoque.local.locacao').search(cr, uid, _args, context=context)
            _emb_id = \
                _spg('estoque.local.locacao').read(cr, uid, _emb_ids[0], ['estllc_produto_embalagem_id'],
                                       context=context)['estllc_produto_embalagem_id'][0]
            _pedido_item = _spg('mkp.utils')._mkputl_monta_dic_item_pedido(cr, uid, _produto_id,
                                                                                    _grade_ids[0], _local_id, _emb_id,
                                                                                    _qtd_venda, _l_vl, _anuncio_ids[0])
            for x in _pedido_item:
                _lista_itens.append(x)
            _preco_total += _valor_total_item
        _preco_total += float(_venda.get('frete'))
        _cliente_madmad_email = False
        _cliente_madmad_fone_1 = _cliente_madmad_fone_2 = _cliente_madmad_ddd_1 = _cliente_madmad_ddd_2 = False
        _fone = _venda.get('comprador').get('telefone')
        _ddd = ''
        _fone = _fone.strip().replace('-', '').replace('.', '').replace('/', '').replace(' ', '')
        ddd = _fone[:2]
        _nro_f = _fone[2:]
        _cliente_madmad_ddd_1 = ddd
        _cliente_madmad_fone_1 = _nro_f
        _cliente_nome = _venda.get('comprador').get('nome')
        _cliente_nome = capitalize_all(_cliente_nome)
        _cliente_cpf = _venda.get('comprador').get('documento')
        _cliente_cep = _cliente_rua = _cliente_rua_nro = _cliente_rua_complemento = ''
        _cliente_cep = _venda.get('comprador').get('cep') or ''
        _cliente_rua = _venda.get('comprador').get('logradouro')
        _cliente_rua_nro = _venda.get('comprador').get('numero')
        _cliente_rua_complemento = _venda.get('comprador').get('complemento')
        _cliente_bairro = _venda.get('comprador').get('bairro')
        _pedido_ids = _spg('estoquepedidos.pedido.capa').search(cr, uid,
                                                                [('pedcap_nro_pedido_externo', '=', _madmad_venda_id),
                                                                 ('tipo', '=', 'V')], context=context)
        _pedido_id = False
        _status_pedido_erp = 'R'
        _pessoa_ids = False
        if _cliente_cpf:
            _pessoa_ids = _spg('adm.pessoa').search(cr, uid, [('cpf_cnpj', '=', _cliente_cpf)], context=context)
        _pais_id = False
        if _pessoa_ids:
            _pessoa_id = _spg('mkp.utils').mkputl_orders_alterar_pessoa(cr, uid, _pessoa_ids[0], _cliente_nome,
                                                                       _cliente_cpf, '', '', _cliente_cep, _cliente_rua,
                                                                   _cliente_rua_nro, _cliente_rua_complemento,
                                                                   _cliente_madmad_ddd_1, _cliente_madmad_fone_1,
                                                                   _cliente_madmad_ddd_2, _cliente_madmad_fone_2,
                                                                   'Comum', _cliente_madmad_email, context=context)
        else:
            # TODO FAZER TRATAMENTO PARA ALTERAR OS DADOS DO CLIENTE POIS PODE TER TIDO ALTERAÇÃO NO Marketplace
            _pessoa_id = self.mkputl_orders_incluir_pessoa(cr, uid, _cliente_nome, _cliente_cpf, '',
                                                           '', '', _cliente_cep, _cliente_rua,
                                                           _cliente_rua_nro, _cliente_rua_complemento,
                                                           _cliente_madmad_ddd_1,
                                                           _cliente_madmad_fone_1, _cliente_madmad_ddd_2,
                                                           _cliente_madmad_fone_2,
                                                           'Comum', _cliente_madmad_email, context=context)
        if _pedido_ids:  # O nro pedido do Marketplace é unico, portanto se tiver pedido so tem 1
            _pedido_id = _pedido_ids[0]
            _dados_pedido = _spg('estoquepedidos.pedido.capa').read(cr, uid, [_pedido_id], ['state'], context=context)
            _status_pedido_erp = _dados_pedido[0].get('state')
            if _status_pedido_erp == 'V':  # Se o pedido estiver validado, voltar para esboco
                _spg('estoquepedidos.pedido.capa').button_rascunho(cr, uid, [_pedido_id], context=context)
                _status_pedido_erp = 'R'
            if _status_madmad_name == 'Cancelado':
                if _status_pedido_erp == 'R':
                    _spg('estoquepedidos.pedido.capa').button_cancelar(cr, uid, [_pedido_id], context=context)
                return True
            if _status_pedido_erp not in ('R', 'C'):  # O pedido não está mais em esboço ou cancelado, não deve ser alterado
                vals = {'pedcap_mkp_status': _status_madmad_name}
                _spg('estoquepedidos.pedido.capa').write(cr, uid, [_pedido_id], vals, context=context)
                return _pedido_id

        _tipo_anuncio = _brw_anuncio.mkpanu_anuncio_tipo_id.name
        _vencimento = _data_venda
        _forma = []
        _condicao_forma_id = _brw_anuncio.mkpanu_anuncio_tipo_id.mkpant_condicao_pgto.id
        _taxa_tr_percentual = _brw_anuncio.mkpanu_anuncio_tipo_id.mkpant_custo_var
        _forma1 = {
            'forma_pagto_id': _brw_anuncio.mkpanu_anuncio_tipo_id.mkpant_condicao_pgto.forma_pagamento_id.id,
            'condicao_forma_id': _condicao_forma_id,
            'pedido_parcela_ids': [(0, 0, {'vr_parcela': _preco_total, 'data_vencimento': _vencimento})],
            'valor': _preco_total,
            'pedcdc_mkp_tarifa': (_taxa_tr_percentual * _preco_total / 100),
            'pedcdc_mkp_tarifa': float(_venda.get('comissao')),
        }
        _forma.append((0, 0, _forma1))

        dados_pessoa = _spg('adm.pessoa').read(cr, uid, _pessoa_id, ['endereco_nf_id'], context=context)
        if dados_pessoa and dados_pessoa.get('endereco_nf_id'):
            _end_id = dados_pessoa.get('endereco_nf_id')[0]
        else:
            _end_id = ''
        vals = {
            'observacao': _comentario,
            'data_emissao': _data_venda,
            'tipo': 'V',
            'pessoa_id': _pessoa_id,
            'pedcap_endereco_id': _end_id,
            'pedcap_mkp_status': _status_madmad_name,
            'pedcap_nro_pedido_externo': _madmad_venda_id,
            'pedcap_endereco_eletronico': 'https://painelmarketplace.madeiramadeira.com.br/painel/v2/pedidos.html/-#%s' % _madmad_venda_id,
            'pedcap_mkp_tipo_anuncio': _tipo_anuncio,
            'vr_frete': _venda.get('frete'),
            'vr_desconto': 0.00,
            'vr_seguro': 0.00,
            'vr_despesas_acessorias': _vr_acrescimo,
            'pedcap_conta_id': conta_id,
        }

        if not _pedido_id:
            if _anuncio_ids:
                vals['pedido_item_ids'] = _lista_itens
            if _forma:
                vals['pedido_condicao_ids'] = _forma
            _pedido_id = _spg('estoquepedidos.pedido.capa').create(cr, uid, vals, context=context)
            vals = {}
            if _status_madmad_name == 'Cancelado':
                vals['state'] = 'C'
            _spg('estoquepedidos.pedido.capa').write(cr, uid, [_pedido_id], vals, context=context)
            vals_anuncio = {
                'mkpanu_necessita_atualizar': False,
                'mkpanu_qtd_vendido': int(_brw_anuncio.mkpanu_qtd_vendido) + 1
            }
            _spg('mkp.anuncios').write(cr, uid, _anuncio_ids[0], vals_anuncio, context=context)
            cr.execute(''' COMMIT; ''')  # Comito, porque se houver algum problema na validação, não perco o pedido
            cr.execute(''' BEGIN; SAVEPOINT importar_pedido_ml_%s; ''' % _hoje)
        else:
            if _status_madmad_name == 'Cancelado' and _status_pedido_erp != 'C':
                return False  # Marcar com problema
            elif _status_madmad_name in ('Enviado', 'Entregue', 'Faturado') \
                    and _status_pedido_erp == 'R':
                _spg('estoquepedidos.pedido.capa').button_validar(cr, uid, [_pedido_id], context=context)
                _spg('estoquepedidos.pedido.capa').button_faturar_pedido(cr, uid, [_pedido_id], context=context)
            elif _status_madmad_name != 'Cancelado':
                _condicao_ids = self.pool.get('estoquepedidos.pedido.condicao').search(cr, uid,
                                                                                       [('capa_id', '=', _pedido_id)],
                                                                                       context=context)
                if _condicao_ids and _forma:
                    self.pool.get('estoquepedidos.pedido.condicao').unlink(cr, uid, _condicao_ids, context=context)
                vals['pedido_condicao_ids'] = _forma
                vals['state'] = 'R'
                context['salvar_forcado'] = True
                _spg('estoquepedidos.pedido.capa').write(cr, uid, [_pedido_id], vals, context=context)
                cr.execute(''' COMMIT; ''')  # Comito, porque se houver algum problema na validação, não perco o pedido
                cr.execute(''' BEGIN; SAVEPOINT importar_pedido_ml_%s; ''' % _hoje)
        if _status_madmad_name == 'Aprovado':
            try:
                _spg('estoquepedidos.pedido.capa').button_validar(cr, uid, [_pedido_id], context=context)
            except:
                pass
        _spg('mkp.madmad').mkpMadMad_set_order_recebida(cr, uid, conta_id, _madmad_venda_id, context=context)
        cr.execute(''' COMMIT; ''')
        return _pedido_id

    def mkputl_faturar_no_mkp_selecionado(self, cr, uid, mkp_integrador, conta_id, ped_externo, chave, nf_ids,
                                          context=None):
        """
        Metodo sobrescrito ppelo marketplace especifico
        :param cr:
        :param uid:
        :param mkp_integrador:
        :param conta_id:
        :param ped_externo:
        :param chave:
        :param context:
        :return:
        """
        context = context and context.copy() or {}
        if mkp_integrador == 'MadMad':
            res = self.pool.get('mkp.madmad').mkpMadMad_set_order_faturado(cr, uid, ped_externo, conta_id,
                                                                           context=context)
        else:
            res = super(mkp_utils, self).mkputl_faturar_no_mkp_selecionado(cr, uid, mkp_integrador, conta_id,
                                                                           ped_externo, chave, nf_ids, context=context)
        return res


    def mkputl_postar_no_mkp(self, cr, uid, mkp_integrador, _conta_id, _ped_id, codigo_rastreio, data, context=None):
        """
        Metodo utilizado para informar aos marketplaces que o pedido foi postado.
        Deve ser sobrescrito em cada marketplace
        :param cr:
        :param uid:
        :param mkp_integrador:
        :param _conta_id:
        :param _ped_id:
        :param data:
        :param context:
        :return:
        """
        _spg = self.pool.get
        if mkp_integrador != 'MadMad':
            return super(mkp_utils, self).mkputl_postar_no_mkp(cr, uid, mkp_integrador, _conta_id, _ped_id,
                                                               codigo_rastreio, data, context=context)
        dados_ped = self.pool.get('estoquepedidos.pedido.capa').read(cr, uid, _ped_id,
                                                                  ['pedcap_nro_pedido_externo'], context)
        _order = dados_ped[0].get('pedcap_nro_pedido_externo')
        res = _spg('mkp.madmad').mkpMadMad_set_order_enviado(cr, uid, _order, _conta_id, data, codigo_rastreio,
                                                             context=context)
        return True


    def mkputl_entregar_no_mkp(self, cr, uid, brw_encomenda, context=None):
        """
        Metodo utilizado para informar aos marketplaces que o pedido foi entregue ao cliente
        Deve ser sobrescrito em cada marketplace
        :param cr:
        :param uid:
        :param brw_encomenda:
        :param context:
        :return:
        """
        if brw_encomenda.rasenc_pedido_id.pedcap_conta_id.mkpcta_integrador != 'MadMad':
            return super(mkp_utils, self).mkputl_entregar_no_mkp(cr, uid, brw_encomenda, context=context)
        _conta_id = brw_encomenda.rasenc_pedido_id.pedcap_conta_id.id
        _ped_ext_id = brw_encomenda.rasenc_pedido_id.pedcap_nro_pedido_externo
        _data = brw_encomenda.rasenc_evento_ids[0].raseve_data_hora[:10]
        if not _ped_ext_id:
            return True

        self.pool.get('mkp.madmad').mkpMadMad_set_order_entregue(cr, uid, _ped_ext_id, _conta_id, _data,
                                                                 context=None)
        return True
