# -*- encoding: utf-8 -*-

import json
import xmlrpclib, socket
from logging import getLogger
import requests
import time
import hmac
import hashlib
from openerp import pooler
from openerp.tools.translate import _
import openerp.addons.web.http as http
from ..marketplace.control.utils import configuracao
from SigUtils.geralogs import geraLogs
from SigUtils.sigerp import db_sig


_logger = getLogger("MadeiraMadeira")
_senha = 'mkp_remoto_77813'


def _remover_acentuacao(text, cod='utf-8'):
    """
    Funcao Wrapper para remover acentuacao
    :param text:texto onde sera feita a remocao da acentuacao
    :param cod:Tipo de codificacao
    return:string
    """

    from unicodedata import normalize, category
    try:
        unicode_string = str(text)
    except UnicodeEncodeError:
        return normalize('NFKD', text).encode('ASCII', 'ignore')
    return unicode(filter(lambda c: category(c) != 'Mn',
                          normalize('NFKD', unicode_string.decode(cod))))


class MadMad(object):
    def logged_client(f):
        """Decorator for User Credentials checking."""

        def inner(self, *args, **kargs):
            if ((self.client_id is None) or (self.client_secret is None)):
                raise Exception(_("Nao posso acessar o MadMad, parametros do MadMad nao informados!"))
            return f(self, *args, **kargs)

        return inner

    def __init__(self, cr=False, uid=False, conta_id=False):
        self.API_ROOT_URL_TESTE = 'https://marketplace-sandbox.madeiramadeira.com.br'  # Sandbox
        self.API_ROOT_URL = 'https://marketplace.madeiramadeira.com.br'  # Producao
        self.cr = cr
        self.uid = uid
        self.shop_id = ''
        self.partner_id = ''
        self.partner_key = ''
        self.redirect_url = ''
        self.code = ''
        self.habilitar_log = False
        self.conta_id = ''
        self.comunicar = True
        if cr:
            _poolget = pooler.get_pool(cr.dbname).get
            mkp_ids = _poolget('mkp.marketplaces').search(cr, uid, [('mkpmkp_codigo', '=', 'MadMad')])
            if mkp_ids:
                mkp_ids = mkp_ids[0]
                dados_marketplace = _poolget('mkp.marketplaces').read(cr, uid, mkp_ids, [])
                if dados_marketplace.get('mkpmkp_parar_comunicacao'):
                    self.comunicar = False
                if not conta_id:
                    conta_id = _poolget('mkp.contas').search(cr, uid, [('mkpcta_marketplace_id', '=', mkp_ids)])
                    if conta_id:
                        conta_id = conta_id[0]
                if conta_id:
                    self.conta_id = conta_id
                    dados_conta = _poolget('mkp.contas').read(cr, uid, conta_id, [])
                    if dados_conta.get('mkpcta_parar_comunicacao'):
                        self.comunicar = False
                    self.habilitar_log = dados_marketplace.get('mkpmkp_habilita_log')
                    self.access_token = dados_conta.get('mkpcta_mm_token')
                    self.shop_id = dados_conta.get('mkpcta_mm_loja')
                    if not dados_conta.get('mkpcta_producao'):
                        self.API_ROOT_URL = self.API_ROOT_URL_TESTE

    def _get_arq_log(self):
        _arq_log = 'mkp_madmad_' + self.cr.dbname
        return _arq_log

    def madmad_comunicar(self, path, body):
        _spg = pooler.get_pool

        def comunicar():
            i = 0
            while True:
                i += 1
                try:
                    if self.habilitar_log:
                        _logger.info('MadMad.get-> %s -> %s' % (path, body))
                    try:
                        geraLogs(self._get_arq_log(),
                                 'PATH:%s BODY:%s HEADER:%s' % (path, str(body), str(headers)), 'S',
                                 '/var/log/openerp/')
                    except:
                        geraLogs(self._get_arq_log(), '%s-> Nao consegui registrar o log' % path, 'S',
                                 '/var/log/openerp/')
                    response = requests.post(url, json=body, headers=headers)
                    try:
                        try:
                            geraLogs(self._get_arq_log(),
                                     'Status:%s Resposta: %s' % (response.status_code, str(response.text)),
                                     'S', '/var/log/openerp/')
                        except:
                            geraLogs(self._get_arq_log(),
                                     'Status:%s Resposta: %s' % (
                                     response.status_code, response.text.encode('ASCII', 'ignore')),
                                     'S', '/var/log/openerp/')
                    except:
                        geraLogs(self._get_arq_log(), 'Nao consegui registrar a resposta', 'S', '/var/log/openerp/')

                    if response.status_code == 200:
                        if self.habilitar_log:
                            x = _spg(self.cr.dbname).get('adm.utils').admutl_remover_acentuacao(self.cr, self.uid,
                                                                                                response.content)
                            _logger.info('MadMad.resposta--> %s ' % x)
                    else:
                        x = _spg(self.cr.dbname).get('adm.utils').admutl_remover_acentuacao(self.cr, self.uid,
                                                                                            response.reason)
                        _logger.error('MadMad.get--> Uri:%s Params:%s Resposta:%s-%s ' % (url, body,
                                                                                          response.status_code, x))
                    break
                except Exception as e:
                    print('' \
                          '' \
                          '' \
                          'erro no while ->', e)
            return response

        if not self.comunicar:
            return {'error': 999, 'mensagem': 'Comunicacao parada'}

        timest = int(time.time())
        default_parameter = {}
        if body:
            body.update(default_parameter)
        else:
            body = {}
            body.update(default_parameter)
        url = self.API_ROOT_URL + path
        headers = {
            "Content-Type": "application/json",
            'TOKENMM': self.access_token,
        }
        resp = comunicar()
        if resp.status_code == 200:
            ret = json.loads(resp.content)
        else:
            ret = {'error': resp.status_code, 'mensagem': resp.reason}
        return ret


# madmad_con = MadMad()


class sc(http.Controller):
    _cp_path = '/mkp_madmad'

    @http.httprequest
    def notifications(self, req, s_action=None, **kw):
        _logger.info('--------------------- notificacoes: %s / %s ' % (str(req.httprequest.data), str(kw)))
        _id_seller = False
        try:
            dados_post = json.loads(req.httprequest.data)
            _id_seller = dados_post.get('id_seller')
        except:
            dados_post = False

        """
        Funções:
        pedNovo, pedCancelado, pedAprovado, prodAprovado
        """
        _funcao = kw.get('funcao', False)
        if _id_seller:
            cfg_madmad = configuracao('marketplace_madeiramadeira', str(_id_seller))
            cfg_madmad.lerConfiguracao()
            _url = req.httprequest.base_url
            _authorization = req.httprequest.environ.get('HTTP_AUTHORIZATION')
            _base = str(cfg_madmad.base)
            cfg = configuracao('marketplace', _base)
            cfg.lerConfiguracao()
            _db_user = cfg.db_user
            _db_password = cfg.db_password
            _db_host = cfg.db_host
            _db_port = cfg.db_port
            arg_db = {}
            if _db_host:
                arg_db.update({'host': _db_host})
            else:
                arg_db.update({'host': 'localhost'})
            if _db_port:
                arg_db.update({'port': _db_port or '5431'})
            if _db_user:
                arg_db.update({'user': _db_user})
            if _db_password:
                arg_db.update({'pwd': _db_password})
            _db = db_sig(_base, **arg_db)
            _fields = ['id']
            _where = [('login', '=', 'mkp_remoto')]
            dados_users = _db.dbsSelect('res_users', _fields, _where)
            _uid = False
            if dados_users:
                _uid = dados_users[0].get('id')
                if _uid:
                    if _funcao == 'prodAprovado':
                        _topic = 'items'
                        _resource = '/items/%s' % dados_post.get('sku')
                    elif _funcao in ('pedNovo', 'pedCancelado', 'pedAprovado'):
                        _topic = 'orders'
                        _resource = '/%s/%s' % (_topic, dados_post.get('order'))
                    else:
                        _db.conexao.close()
                        return 'Nao'
                    _db.uid = _uid
                    _where = [('mkpnot_resource', '=', _resource),
                            ('mkpnot_loja', '=', _id_seller)
                            ]
                    dados_not = _db.dbsSelect('mkp_notificacoes', ['id'], _where)
                    _not_id = False
                    if dados_not:
                        _not_id = dados_not[0].get('id')
                    ## Gravar as notificacoes
                    if _not_id:
                        vals = {
                            'mkpnot_attempts': 1,
                            'state': 'R',
                        }
                        where = [('id', '=', _not_id)]
                        x = _db.dbsUpdate('mkp_notificacoes', vals, where)
                        if x:
                            _db.conexao.commit()
                        else:
                            _db.conexao.roolback()
                    else:
                        vals = {
                            'mkpnot_conta_id': cfg_madmad.conta_id,
                            'mkpnot_resource': _resource,
                            'mkpnot_loja': _id_seller,
                            'mkpnot_topic': _topic,
                            'mkpnot_attempts': 1,
                            'state': 'R',
                        }
                        x = _db.dbsInsert('mkp_notificacoes', vals)
                        if not x:
                            _db.conexao.roolback()
                        else:
                            _db.conexao.commit()
                    _db.conexao.close()
                    return 'OK'  # nunca retorne booleano, vai dar erro de https
            _db.conexao.close()
        _logger.info('Nao consegui pegar o seller_id da aplicacao no Mkp MadeiraMadeira.')
        return 'Nao' # nunca retorne booleano, vai dar erro de https
