# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
import json
import logging
from openerp import SUPERUSER_ID
from openerp.tools.translate import _
import hashlib


class mkp_categorias(osv.Model):
    _inherit = 'mkp.categorias'
    _logger = logging.getLogger(_inherit)

    def mkpcat_pesquisar_categorias_no_mkp(self, cr, uid, mkp_ids, context=None):
        def _mkpcat_atualizar_categoria():
            vals = {}
            vals['mkpcat_marketplace_id'] = mkp_id
            vals['mkpcat_atualizado'] = True
            vals['active'] = True
            _nivel = 0
            if categ.get('nivel_3'):
                _nivel = 3
            elif categ.get('nivel_2'):
                _nivel = 2
            else:
                _nivel = 1
            # tratar nivel 1
            if _nivel == 1:
                vals['mkpcat_codigo'] = '0-%s' % categ.get('id_categoria')
            else:
                vals['mkpcat_codigo'] = '1-%s' % categ.get('id_nivel_1')
            vals['name'] = categ.get('nivel_1')
            _args = [
                ('mkpcat_codigo', '=', vals['mkpcat_codigo']),
                ('mkpcat_marketplace_id', '=', mkp_id)
            ]
            _nivel_1_id = self.search(cr, uid, _args, context=context)
            if _nivel_1_id:
                _nivel_1_id = _nivel_1_id[0]
                self.write(cr, uid, _nivel_1_id, vals, context=context)
            else:
                _nivel_1_id = self.create(cr, uid, vals, context=context)
            if _nivel == 1:
                cr.commit()
                return True
            # tratar nivel 2
            if _nivel == 2:
                vals['mkpcat_codigo'] = '0-%s' % categ.get('id_categoria')
            else:
                vals['mkpcat_codigo'] = '2-%s' % categ.get('id_nivel_2')
            vals['name'] = categ.get('nivel_2')
            _args = [
                ('mkpcat_codigo', '=', vals['mkpcat_codigo']),
                ('mkpcat_marketplace_id', '=', mkp_id)
            ]
            _nivel_2_id = self.search(cr, uid, _args, context=context)
            if _nivel_2_id:
                _nivel_2_id = _nivel_2_id[0]
                self.write(cr, uid, _nivel_2_id, vals, context=context)
            else:
                vals['parent_id'] = _nivel_1_id
                _nivel_2_id = self.create(cr, uid, vals, context=context)
            if _nivel == 2:
                cr.commit()
                return True
            # tratar nivel 3
            vals['mkpcat_codigo'] = '0-%s' % categ.get('id_categoria')
            vals['name'] = categ.get('nivel_3')
            _args = [
                ('mkpcat_codigo', '=', vals['mkpcat_codigo']),
                ('mkpcat_marketplace_id', '=', mkp_id)
            ]
            _nivel_3_id = self.search(cr, uid, _args, context=context)
            if _nivel_3_id:
                _nivel_3_id = _nivel_3_id[0]
                self.write(cr, uid, _nivel_3_id, vals, context=context)
            else:
                vals['parent_id'] = _nivel_2_id
                _nivel_3_id = self.create(cr, uid, vals, context=context)
            cr.commit()
            return True

        context = context and context.copy() or {}
        super(mkp_categorias, self).mkpcat_pesquisar_categorias_no_mkp(cr, uid, mkp_ids, context=None)
        context['active_test'] = False
        mkp_id = self.pool.get('mkp.marketplaces').mkpmkp_get_id(cr, uid, 'MadMad', context=None)
        if not mkp_id in mkp_ids:
            return True
        xml_str = self.pool.get('mkp.madmad').mkpMadMad_get_categorias(cr, uid, context=context)
        m = hashlib.md5()
        m.update(xml_str.content)
        _md5 = m.hexdigest()
        try:
            dados_md5 = self.pool.get('ir.config_parameter').get_param(cr, uid, 'mkp_mm_categorias_md5')
        except:
            dados_md5 = False
        if dados_md5:
            _md5_old = dados_md5
            if _md5_old == _md5:  # Não houve alteracao nas  categorias
                return True
        _categoria_ids = self.search(cr, uid, [('mkpcat_marketplace_id', '=', mkp_id)], context=context)
        self.write(cr, uid, _categoria_ids, {'mkpcat_atualizado': False}, context=context)
        _l_categ = json.loads(xml_str.content).get('data')
        for categ in _l_categ:
            _mkpcat_atualizar_categoria()

        self.pool.get('ir.config_parameter').set_param(cr, SUPERUSER_ID, 'mkp_mm_categorias_md5', _md5, context={})
        # Inativar as que foram retidas do Madeira Madeira
        _categoria_ids = self.search(cr, uid, [('mkpcat_marketplace_id', '=', mkp_id),
                                               ('mkpcat_atualizado', '=', False)], context=context)
        self.write(cr, uid, _categoria_ids, {'active': False}, context=context)
        return True

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        obj_marketplace = self.pool.get('mkp.marketplaces')
        dados_mmkp = obj_marketplace.read(cr, uid, vals.get('mkpcat_marketplace_id'), ['mkpmkp_codigo'])
        if dados_mmkp and dados_mmkp.get('mkpmkp_codigo') == 'MadMad':
            if not (vals and vals.get('mkpcat_codigo', False)):
                raise osv.except_osv(_('Atencao'), _('Faltou o codigo da categoria(id)!'))
        res = super(mkp_categorias, self).create(cr, uid, vals, context=context)
        return res




