# -*- encoding: utf-8 -*-
import re
from urllib import urlencode
import json
import requests
from openerp import pooler
from openerp.tools.translate import _
from SigUtils.geralogs import geraLogs
from openerp.tools import config


class MadMad(object):
    def logged_client(f):
        """Decorator for User Credentials checking."""
        def inner(self, *args, **kargs):
            if (self.access_token is None):
                raise Exception(_("Nao posso acessar o Marketplace. parametros do MadeiraMadeira nao informados!"))
            return f(self, *args, **kargs)
        return inner

    def __init__(self, cr=False, uid=False, conta_id=False, company_id=False):
        self.API_ROOT_URL_TESTE = 'https://marketplace-sandbox.madeiramadeira.com.br'  # Sandbox
        self.API_ROOT_URL = 'https://marketplace.madeiramadeira.com.br'
        self.cr = cr
        self.uid = uid
        self.shop_id = ''
        self.access_token = ''
        self.redirect_url = ''
        self.seller = ''
        self.habilitar_log = False
        self.conta_id = ''
        self.comunicar = True
        if cr:
            _poolget = pooler.get_pool(cr.dbname).get
            mkp_ids = _poolget('mkp.marketplaces').search(cr, uid, [('mkpmkp_codigo', '=', 'MadMad')])
            if mkp_ids:
                mkp_ids = mkp_ids[0]
                dados_marketplace = _poolget('mkp.marketplaces').read(cr, uid, mkp_ids, [])
                if dados_marketplace.get('mkpmkp_parar_comunicacao'):
                    self.comunicar = False
                if not conta_id:
                    conta_id = _poolget('mkp.contas').search(cr, uid, [('mkpcta_marketplace_id', '=', mkp_ids)])
                    if conta_id:
                        conta_id = conta_id[0]
                if conta_id:
                    self.conta_id = conta_id
                    dados_conta = _poolget('mkp.contas').read(cr, uid, conta_id, [])
                    if dados_conta.get('mkpcta_parar_comunicacao'):
                        self.comunicar = False
                    self.access_token = dados_conta.get('mkpcta_mm_token')
                    self.shop_id = dados_conta.get('mkpcta_mm_loja')
                    self.habilitar_log = dados_marketplace.get('mkpmkp_habilita_log')
                    if not dados_conta.get('mkpcta_producao'):
                        self.API_ROOT_URL = self.API_ROOT_URL_TESTE

    def _get_arq_log(self):
        _arq_log = 'mkp_madmad_' + self.cr.dbname
        return _arq_log

    def _gerar_logs(self, mens):
        _diretorio = config.get('logfile')
        if _diretorio:
            _lista = _diretorio.split('/')
            _lista.pop(len(_lista) -1)
            _diretorio = '/'.join(_lista)
        else:
            _diretorio = '/var/log/openerp'
        _arq_log = self._get_arq_log()
        try:
            geraLogs(_arq_log, mens, 'S', _diretorio)
        except:
            try:
                geraLogs(_arq_log, mens.encode('ASCII', 'ignore'), 'S', _diretorio)
            except:
                geraLogs(_arq_log, 'Nao consegui registrar o log', 'S', _diretorio)
        return True


    # REQUEST METHODS
    def make_path(self, path, params={}):
        # Making Path and add a leading / if not exist
        if not (re.search("^http", path)):
            if not (re.search("^\/", path)):
                path = "/" + path
            path = self.API_ROOT_URL + path
        if params:
            path = path + "?" + urlencode(params)
        return path

    @logged_client
    def mad_comunicar(self, metodo, path, body=None):
        def comunicar():
            if self.habilitar_log:
                self._gerar_logs('PATH:%s BODY:%s HEADER:%s' % (path, str(body), str(headers)))
            response = requests.request(metodo, uri, data=body, headers=headers)
            if self.habilitar_log:
                self._gerar_logs('Status:%s Resposta: %s' % (response.status_code, response.text))
            return response

        if not self.comunicar:
            class resp(object):
                status_code = 999
                content = '{"error":"Comunicacao parada"}'
            return resp

        headers = {
            'Content-type': 'application/json',
            'TOKENMM': self.access_token,
        }
        metodo = metodo.upper()
        uri = self.make_path(path)
        if body:
            body = json.dumps(body)

        response = comunicar()
        if response.status_code == 401:
            _res = eval(response.content)
        return response
