# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from ...adm.control.utils import capitalize_all
from datetime import datetime
import subprocess
from openerp.tools.translate import _
import os


class mkp_utils(osv.Model):
    _inherit = 'mkp.utils'

    def mkputl_atualizar_anuncio_magalu(self, cr, uid, id, context=None):
        """
        Inclui ou altera anuncio no site da magalu
        @param cr:
        @param uid:
        @param id: id do anuncio a ser alterado
        @param context:
        @return: dicionario contendo id do anuncio e response ex.:{status: True/False, 'mensagem': 'Mensagem'}
                 response. quando response.raise_for_status() for None, tá tudo certo. Para pegar o erro use response.status_code
        """

        context = context and context.copy() or {}
        _spg = self.pool.get
        brw_anuncio = _spg('mkp.anuncios').browse(cr, uid, id, context=context)
        if not brw_anuncio:  # anuncio nao existe mais. Retornar True para que a ação seja encerrada
            return {'status': True, 'mensagem': ''}
        try:
            _codigo = brw_anuncio.mkpanu_codigo_anuncio
        except:  # Erro porque o id não existe
            return {'status': True, 'mensagem': ''}
        res = _spg('mkp.magalu').mkpMagalu_set_anuncio(cr, uid, brw_anuncio, context=context)
        return res

    def mkputl_atualizar_preco_magalu(self, cr, uid, id, context=None):
        """
        altera precos no Magalu
        @param cr:
        @param uid:
        @param id: id do anuncio a ser alterado
        @param context:
        @return: dicionario contendo id do anuncio e response ex.:{status: True/False, 'mensagem': 'Mensagem'}
                 response. quando response.raise_for_status() for None, tá tudo certo. Para pegar o erro use response.status_code
        """
        context = context and context.copy() or {}
        _spg = self.pool.get
        brw_anuncio = _spg('mkp.anuncios').browse(cr, uid, id, context=context)
        if not brw_anuncio:  # anuncio nao existe mais. Retornar True para que a ação seja encerrada
            return {'status': True, 'mensagem': ''}
        try:
            _codigo = brw_anuncio.mkpanu_codigo_anuncio
        except: # Erro porque o id não existe
            return {'status': True, 'mensagem': ''}
        res = _spg('mkp.magalu').mkpMagalu_set_preco(cr, uid, brw_anuncio, context=context)
        if res and res.get('status') == False:
            raise osv.except_osv(_('Atencao!'),
                                 _('Nao consegui atualizar o preco!\n%s' % res.get('mensagem')))
        return res

    def mkputl_importar_um_pedido_magalu(self, cr, uid, ped, conta_id, context=None):
        context = context and context.copy() or {}
        _venda = ped
        _magalu_venda_id = _venda.get('IdOrder')
        self._logger.info('Importando pedido magalu: %s' % _venda.get('IdOrder'))
        _spg = self.pool.get
        brw_conta = _spg('mkp.contas').browse(cr, uid, conta_id, context=context)
        context['sig_force_company'] = brw_conta.company_id.id
        _local_id = brw_conta.mkpcta_local_id.id
        _hoje = _spg('adm.utils').admutl_datetime_to_timezone(cr, uid, datetime.now(), formato='%Y_%m_%d_%H_%M_%s')
        cr.execute(''' BEGIN; SAVEPOINT importar_pedido_magalu_%s; ''' % _hoje)
        _comentario = ''
        _status_magalu_name = _venda.get('OrderStatus')
        _data_venda = _venda.get('PurchasedDate')[:10]
        _lista_itens = []
        _qtd_venda = 0
        _vr_acrescimo = float(_venda.get('TotalTax').replace(',', '.'))
        _vr_desconto = 0
        _preco_total = 0
        _vr_frete = float(_venda.get('TotalFreight').replace(',', '.'))
        for _item in _venda.get('Products'):
            _pedido_item = {}
            _sku = _item.get('IdSku')
            _sku_codigo, _sku_grade = _sku.split('-')
            _produto_ids = _spg('estoque.produto').search(cr, uid, [('codigo', '=', _sku_codigo)], context=context)
            if not _produto_ids:
                continue
            _produto_id = _produto_ids[0]
            _args = [('mkpanu_produto_id', '=', _produto_id), ('mkpanu_conta_id', '=', conta_id)]
            _anuncio_ids = _spg('mkp.anuncios').search(cr, uid, _args, context=context)
            if not _anuncio_ids:
                continue
            _brw_anuncio = _spg('mkp.anuncios').browse(cr, uid, _anuncio_ids[0], context=context)
            _produto_id = _brw_anuncio.mkpanu_produto_id.id
            _grade_ids = _spg('estoque.produto.grade').search(cr, uid, [('produto_id', '=', _produto_id),
                                                                        ('grade', '=', _sku_grade)], context=context)
            _qtd_anuncio = _brw_anuncio.mkpanu_quantidade or 1
            if _qtd_anuncio == 0:
                _qtd_anuncio = 1
            _qtd_venda = int((_item.get('Quantity') or 1) * _qtd_anuncio)
            _desconto_item = float(_item.get('Discount'))
            _vr_desconto += _desconto_item
            _valor_total_item = (float(_item.get('Price').replace(',', '.')) / _qtd_anuncio) * _qtd_venda
            _l_vl = _valor_total_item / _qtd_venda
            _args = [('grade_id', '=', _grade_ids[0]), ('local_id', '=', _local_id)]
            _emb_ids = _spg('estoque.local.locacao').search(cr, uid, _args, context=context)
            _emb_id = \
                _spg('estoque.local.locacao').read(cr, uid, _emb_ids[0], ['estllc_produto_embalagem_id'],
                                       context=context)['estllc_produto_embalagem_id'][0]
            _pedido_item = _spg('mkp.utils')._mkputl_monta_dic_item_pedido(cr, uid, _produto_id,
                                                                                    _grade_ids[0], _local_id, _emb_id,
                                                                                    _qtd_venda, _l_vl, _brw_anuncio.id)
            for x in _pedido_item:
                _lista_itens.append(x)
            _preco_total += _valor_total_item - _desconto_item
        _preco_total += _vr_frete + _vr_acrescimo
        _cliente_magalu_email = False
        _cliente_magalu_fone_1 = _cliente_magalu_fone_2 = _cliente_magalu_ddd_1 =  _cliente_magalu_ddd_2 = False
        _fone = _venda.get('TelephoneMainNumber')
        _ddd = ''
        _fone = _fone.strip().replace('-', '').replace('.','').replace('/','').replace(' ','')
        ddd = _fone[2:4]
        _nro_f = _fone[4:]
        _cliente_magalu_ddd_1 = ddd
        _cliente_magalu_fone_1 = _nro_f
        if _venda.get('CustomerPfName'):
            _cliente_nome = _venda.get('CustomerPfName')
            _cliente_cpf = _venda.get('CustomerPfCpf')
        else:
            _cliente_nome = _venda.get('CustomerPjCorporatename')
            _cliente_cpf = _venda.get('CustomerPjCnpj')
        _cliente_nome = capitalize_all(_cliente_nome)
        _cliente_apelido = ''
        _cliente_cep = _cliente_rua = _cliente_rua_nro = _cliente_rua_complemento = ''
        _cliente_cep = _venda.get('DeliveryAddressZipcode') or ''
        _cliente_rua = _venda.get('DeliveryAddressStreet') or ''
        _cliente_rua_nro = _venda.get('DeliveryAddressNumber') or ''
        _cliente_rua_complemento = _venda.get('DeliveryAddressAdditionalInfo') or ''
        _cliente_bairro = _venda.get('DeliveryAddressNeighborhood') or ''
        _pedido_ids = _spg('estoquepedidos.pedido.capa').search(cr, uid, [('pedcap_nro_pedido_externo', '=', _magalu_venda_id), ('tipo', '=', 'V')], context=context)
        _pedido_id = False
        _status_pedido_erp = 'R'
        _pessoa_ids = False
        if _cliente_cpf:
            _pessoa_ids = _spg('adm.pessoa').search(cr, uid, [('cpf_cnpj', '=', _cliente_cpf)], context=context)
        _pais_id = False
        if _pessoa_ids:
            _pessoa_id = _spg('mkp.utils').mkputl_orders_alterar_pessoa(cr, uid, _pessoa_ids[0], _cliente_nome, _cliente_cpf,
                                                                   '', '', _cliente_cep, _cliente_rua,
                                                                   _cliente_rua_nro, _cliente_rua_complemento,
                                                                   _cliente_magalu_ddd_1, _cliente_magalu_fone_1,
                                                                   _cliente_magalu_ddd_2, _cliente_magalu_fone_2, 'Comum',
                                                                   _cliente_magalu_email, context=context)
        else:
            # TODO FAZER TRATAMENTO PARA ALTERAR OS DADOS DO CLIENTE POIS PODE TER TIDO ALTERAÇÃO NO Marketplace
            _pessoa_id = self.mkputl_orders_incluir_pessoa(cr, uid, _cliente_nome, _cliente_cpf, '',
                                                           _cliente_apelido, '', _cliente_cep, _cliente_rua,
                                                           _cliente_rua_nro, _cliente_rua_complemento, _cliente_magalu_ddd_1,
                                                           _cliente_magalu_fone_1, _cliente_magalu_ddd_2, _cliente_magalu_fone_2,
                                                           'Comum', _cliente_magalu_email, context=context)
        if _pedido_ids:  # O nro pedido do Marketplace é unico, portanto se tiver pedido so tem 1
            _pedido_id = _pedido_ids[0]
            _dados_pedido = _spg('estoquepedidos.pedido.capa').read(cr, uid, [_pedido_id], ['state'], context=context)
            _status_pedido_erp = _dados_pedido[0].get('state')
            if _status_magalu_name == 'CANCELED':
                if _status_pedido_erp == 'R':
                    _spg('estoquepedidos.pedido.capa').button_cancelar(cr, uid, [_pedido_id], context=context)
                return True
            if _status_pedido_erp == 'V':
                if _status_magalu_name == 'APPROVED':
                    _spg('mkp.magalu').mkpMagalu_set_orders_status(cr, uid, _magalu_venda_id, conta_id, 'PROCESSING', context=context)
                    vals = {'pedcap_mkp_status': _status_magalu_name}
                    _spg('estoquepedidos.pedido.capa').write(cr, uid, [_pedido_id], vals, context=context)
                    return _pedido_id
                if _status_magalu_name == 'PROCESSING':
                    return _pedido_id
            if _status_pedido_erp == 'F' and _status_magalu_name in ('INVOICED', 'SHIPPED', 'DELIVERED'):
                return _pedido_id

        _condicao_forma_id = False
        _tipo_anuncio = _brw_anuncio.mkpanu_anuncio_tipo_id.name
        _vencimento = _data_venda
        _forma = []
        _condicao_forma_id = _brw_anuncio.mkpanu_anuncio_tipo_id.mkpant_condicao_pgto.id
        _taxa_tr_percentual = _brw_anuncio.mkpanu_anuncio_tipo_id.mkpant_custo_var
        _forma_pagto_id = _brw_anuncio.mkpanu_anuncio_tipo_id.mkpant_condicao_pgto.forma_pagamento_id.id
        _forma_mkp = _venda.get('Payments')[0].get('Name') or ''
        _forma1 = {
            'forma_pagto_id': _forma_pagto_id,
            'condicao_forma_id': _condicao_forma_id,
            'pedido_parcela_ids': [(0, 0, {'vr_parcela': _preco_total,
                                           'data_vencimento': _vencimento,
                                           'pedprc_payment_mkp_type': _forma_mkp})],
            'valor': _preco_total,
            'pedcdc_mkp_tarifa': (_taxa_tr_percentual * _preco_total / 100),
        }
        _forma.append((0, 0, _forma1))

        dados_pessoa = _spg('adm.pessoa').read(cr, uid, _pessoa_id, ['endereco_nf_id'], context=context)
        if dados_pessoa and dados_pessoa.get('endereco_nf_id'):
            _end_id = dados_pessoa.get('endereco_nf_id')[0]
        else:
            _end_id = ''
        vals = {
            'observacao': _comentario,
            'data_emissao': _data_venda,
            'tipo': 'V',
            'pessoa_id': _pessoa_id,
            'pedcap_endereco_id': _end_id,
            'pedcap_mkp_status': _status_magalu_name,
            'pedcap_nro_pedido_externo': _magalu_venda_id,
            'pedcap_endereco_eletronico': brw_conta.mkpcta_marketplace_id.mkpmkp_api + '/portal/sale/%s' % _magalu_venda_id,
            'pedcap_mkp_tipo_anuncio': _tipo_anuncio,
            'vr_frete': _vr_frete,
            'vr_desconto': _vr_desconto,
            'vr_seguro': 0.00,
            'vr_despesas_acessorias': _vr_acrescimo,
            'pedcap_conta_id': conta_id,
        }

        if not _pedido_id:
            vals['pedido_item_ids'] = _lista_itens
            if _forma:
                vals['pedido_condicao_ids'] = _forma
            _pedido_id = _spg('estoquepedidos.pedido.capa').create(cr, uid, vals, context=context)
            vals = {}
            if _status_magalu_name == 'CANCELLED':
                vals['state'] = 'C'
            _spg('estoquepedidos.pedido.capa').write(cr, uid, [_pedido_id], vals, context=context)
            vals_anuncio = {'mkpanu_necessita_atualizar': False, 'mkpanu_qtd_vendido': int(_brw_anuncio.mkpanu_qtd_vendido) + 1}
            _spg('mkp.anuncios').write(cr, uid, _brw_anuncio.id, vals_anuncio, context=context)
            cr.execute(''' COMMIT; ''')  # Comito, porque se houver algum problema na validação, não perco o pedido
            cr.execute(''' BEGIN; SAVEPOINT importar_pedido_ml_%s; ''' % _hoje)
        else:
            if _status_magalu_name == 'CANCELLED' and _status_pedido_erp != 'C':
                return False  # Marcar com problema
            elif _status_magalu_name in ('INVOICED', 'SHIPPED', 'DELIVERED') \
                    and _status_pedido_erp == 'R':
                _spg('estoquepedidos.pedido.capa').button_validar(cr, uid, [_pedido_id], context=context)
                _spg('estoquepedidos.pedido.capa').button_faturar_pedido(cr, uid, [_pedido_id], context=context)
            elif _status_magalu_name != 'CANCELLED':
                _condicao_ids = self.pool.get('estoquepedidos.pedido.condicao').search(cr, uid, [('capa_id', '=', _pedido_id)], context=context)
                if _condicao_ids and _forma:
                    self.pool.get('estoquepedidos.pedido.condicao').unlink(cr, uid, _condicao_ids, context=context)
                vals['pedido_condicao_ids'] = _forma
                context['salvar_forcado'] = True
                _spg('estoquepedidos.pedido.capa').write(cr, uid, [_pedido_id], vals, context=context)
                cr.execute(''' COMMIT; ''')  # Comito, porque se houver algum problema na validação, não perco o pedido
                cr.execute(''' BEGIN; SAVEPOINT importar_pedido_ml_%s; ''' % _hoje)
        if _status_magalu_name == 'APPROVED':
            try:
                _spg('estoquepedidos.pedido.capa').button_validar(cr, uid, [_pedido_id], context=context)
                _spg('mkp.magalu').mkpMagalu_set_orders_status(cr, uid, _magalu_venda_id, conta_id, 'PROCESSING', context=context)
            except Exception as e:
                pass
        _encomenda = False
        if _venda.get('ShippedTrackingProtocol'):
            _encomenda = _venda.get('ShippedTrackingProtocol')
            try:
                _servico_id = brw_conta.mkpcta_rastreamento_servico_id.id
            except:
                _servico_id = False
            if _encomenda:
                sql = "select id from rastreio_encomendas where name = '%s'" % _encomenda
                cr.execute(sql)
                _encomenda_id = cr.fetchone()
                if _encomenda_id:
                    _encomenda_id = _encomenda_id[0]
                else:
                    vals_encomenda = dict(
                        name=_encomenda,
                        rasenc_pedido_id=_pedido_id,
                        rasenc_pessoa_id=_pessoa_id,
                        rasenc_compra_venda='V',
                    )
                    if _servico_id:
                        vals_encomenda['rasenc_servicos_ids'] = [(4, _servico_id,)]
                    _encomenda_id = _spg('rastreio.encomendas').create(cr, uid, vals_encomenda, context=context)
        if _encomenda:
            vals_ped = {'pedcap_encomenda_id': _encomenda_id}
            res = _spg('estoquepedidos.pedido.capa').write(cr, uid, [_pedido_id], vals_ped, context=context)
        cr.execute(''' COMMIT; ''')
        return _pedido_id

    def mkputl_get_etiqueta_no_mkp(self, cr, uid, mkp_integrador, conta_id, pedido_ids, context=None):
        """
        Metodo para buscar etiqueta no marketplace, deve ser sobrescrito por cada marketplace
        :param cr:
        :param uid:
        :param mkp_integrador:
        :param conta_id:
        :param pedido_ids:
        :param context:
        :return: {status: True/False, 'mensagem': '', 'dados': ''}
        """
        context = context and context.copy() or {}
        if mkp_integrador != 'Magalu':
            res = super(mkp_utils, self).mkputl_get_etiqueta_no_mkp(cr, uid, mkp_integrador, conta_id, pedido_ids,
                                                                    context=context)
            return res
        _spg = self.pool.get
        _rastreio_id_ped = False
        for i in self.pool.get('estoquepedidos.pedido.capa').read(cr, uid, pedido_ids,
                                                                  ['pedcap_nro_pedido_externo',
                                                                   'pedcap_conta_id',
                                                                   'pessoa_id'], context):
            _conta_id = i.get('pedcap_conta_id')[0]
            _order = i.get('pedcap_nro_pedido_externo')

            # etiqueta, controle, track_no = self.pool.get('mkp.magalu').mkpMagalu_get_etiqueta(cr, uid, _order, _conta_id, context)
            ret = self.pool.get('mkp.magalu').mkpMagalu_get_etiqueta(cr, uid, _order, _conta_id, context)
            if not ret.get('status'):
                return {'status': False, 'mensagem':  _('Nenhuma etiqueta encontrada!'), 'dados': ''}
            etiqueta = ret.get('etiqueta')
            track_no = ret.get('track_no')
            if not context.get('danfe'):
                printer = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque',
                                                                           ['estpar_impressora_termica', 'estpar_impressora_termica_servidor'],
                                                                           context=context)
                if printer:
                    servidor = printer.get('estpar_impressora_termica_servidor')
                    printer = printer.get('estpar_impressora_termica')
                else:
                    return {'status': False, 'mensagem': _('Cadastrar impressora no parametro do "Estoque" na aba '
                                           '"Automacao"'), 'dados': ''}
                try:
                    if servidor:
                        subprocess.call(["lp", '-o raw', "-n1", '-h%s' % servidor, '-d%s' % printer, etiqueta])
                    else:
                        subprocess.call(["lp", '-o raw', "-n1", '-d%s' % printer, etiqueta])
                except Exception as e:
                    os.remove(etiqueta)
                    return {'status': False, 'mensagem': _('Erro ao imprimir etiqueta de postagem %s') % e, 'dados': ''}
            # _prt_nf = context.get('mkp_modelo_90', False)
            # if _prt_nf:
            #     _prt_nf = '-d%s' % _prt_nf
            #     parametro_dados = _spg('adm.utils').admutl_get_parametros(cr, uid, 'fiscal', 'fispar_tamanho_danfe', context=context)
            #     formato = '-omedia=' + parametro_dados.get('fispar_tamanho_danfe') or '-omedia=A4'
            #     fit = '-ofit-to-page'
            #     subprocess.call(["lp", '-n1', formato, fit, _prt_nf, controle])
            if track_no:
                vals = {
                    'name': track_no,
                    'rasenc_pedido_id': i.get('id'),
                    'rasenc_pessoa_id': i.get('pessoa_id')[0],
                    'rasenc_compra_venda': 'V',
                }
                try:
                    _dados_conta = _spg('mkp.contas').read(cr, uid, _conta_id, ['mkpcta_rastreamento_servico_id'],
                                                           context=context)
                    _servico_id = _dados_conta.get('mkpcta_rastreamento_servico_id')[0]
                except:
                    _servico_id = False
                if _servico_id:
                    vals['rasenc_servicos_ids'] = [(4, _servico_id,)]
                _encomenda_id = self.pool.get('rastreio.encomendas').create(cr, uid, vals, context=context)
                vals = {'pedcap_encomenda_id': _encomenda_id}
                _spg('estoquepedidos.pedido.capa').write(cr, uid, [i.get('id')], vals, context=context)
            os.remove(etiqueta)

        return {'status': True, 'mensagem': '', 'dados': {'track_no': track_no, 'encomenda_id': _encomenda_id}}


    def mkputl_cron_pesquisar_pedidos_pendentes_magalu(self, cr, uid, context=None):
        """
        Método chamado pelo cron para pesquisar pedidos pendentes(perdidos)nos marketplaces
        @param cr:
        @param uid:
        @param context:
        @return: Sempre True
        """
        context = context and context.copy() or {}
        obj_contas = self.pool.get('mkp.contas')
        for company_id in self.pool.get('res.company').search(cr, uid, [], context=context):
            context['sig_force_company'] = True
            args = [('mkpcta_integrador', '=', 'Magalu'), ('company_id', '=', company_id)]
            conta_ids = obj_contas.search(cr, uid, args, context=context)
            for brw_conta in obj_contas.browse(cr, uid, conta_ids, context=context):
                if brw_conta.mkpcta_parar_comunicacao or \
                   brw_conta.mkpcta_marketplace_id.mkpmkp_parar_comunicacao:
                    continue
                _conta_id = brw_conta.id
                self.pool.get('mkp.magalu').mkpMagalu_pesquisar_orders(cr, uid, _conta_id, context=context)
        return True

    def mkputl_cron_pesquisar_pedidos_magalu(self, cr, uid, context=None):
        """
        Método chamado pelo cron para pesquisar pedidos nos marketplaces
        @param cr:
        @param uid:
        @param context:
        @return: Sempre True
        """
        context = context and context.copy() or {}
        obj_contas = self.pool.get('mkp.contas')
        for company_id in self.pool.get('res.company').search(cr, uid, [], context=context):
            context['sig_force_company'] = True
            args = [('mkpcta_integrador', '=', 'Magalu'), ('company_id', '=', company_id)]
            conta_ids = obj_contas.search(cr, uid, args, context=context)
            for brw_conta in obj_contas.browse(cr, uid, conta_ids, context=context):
                if brw_conta.mkpcta_parar_comunicacao or \
                   brw_conta.mkpcta_marketplace_id.mkpmkp_parar_comunicacao:
                    continue
                _conta_id = brw_conta.id
                self.pool.get('mkp.magalu').mkpMagalu_pesquisar_orders_queues(cr, uid, _conta_id, context=context)
        return True

    def mkputl_faturar_no_mkp_selecionado(self, cr, uid, mkp_integrador, conta_id, ped_externo, chave, nf_ids, context=None):
        """
        Metodo sobrescrito ppelo marketplace especifico
        :param cr:
        :param uid:
        :param mkp_integrador:
        :param conta_id:
        :param ped_externo:
        :param chave:
        :param context:
        :return:
        """
        context = context and context.copy() or {}
        if mkp_integrador == 'Magalu':
            for brw_nf in self.pool.get('fiscal.nf.capa').browse(cr, uid, nf_ids, context=context):
                res = self.pool.get('mkp.magalu').mkpMagalu_set_order_faturado(cr, uid, ped_externo, conta_id,
                                                                               brw_nf, context=context)
                for brw_itens in brw_nf.estoque_movimento_itens_ids:
                    for brw_anuncio in  brw_itens.produto_id.estpro_anuncios_ids:
                        if brw_anuncio.mkpanu_conta_id.id == conta_id:
                            _qtd = brw_anuncio.mkpanu_qtd_vendido + brw_itens.quantidade
                            vals = {'mkpanu_qtd_vendido': _qtd}
                            self.pool.get('mkp.anuncios').write(cr, uid, brw_anuncio.id, vals, context=context)
                            break
        else:
            res = super(mkp_utils, self).mkputl_faturar_no_mkp_selecionado(cr, uid, mkp_integrador, conta_id, ped_externo,
                                                                          chave, nf_ids, context=context)
        return res

