# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class estoquepedidos_pedido_capa(osv.Model):
    _inherit = 'estoquepedidos.pedido.capa'

    def pedcap_buscar_pedido_no_mkp(self, cr, uid, ids, context=None):
        _spg = self.pool.get
        res = super(estoquepedidos_pedido_capa, self).pedcap_buscar_pedido_no_mkp(cr, uid, ids, context=None)
        if res.get('dados') and res.get('dados').get('integrador') == u'Magalu':
            _conta_id = res.get('dados').get('conta_id')
            _order = str(res.get('dados').get('order'))
            dados = _spg('mkp.magalu').mkpMagalu_get_orders(cr, uid, _order, _conta_id)
            if not dados.get('status'):
                res['mensagem'] = dados.get('mensagem')
                return res
            _pedido = dados.get('pedido')
            _ped_id = _spg('mkp.utils').mkputl_importar_um_pedido_magalu(cr, uid, _pedido, _conta_id, context=context)
            if not _ped_id:
                res['status'] = False
                res['mensagem'] = ''
        return res

    def pedcap_ver_se_pode_faturar(self, cr, uid, id, context=None):
        """
        Metodo para verificar se todos pedidos estão pagos, deve ser sobrescrito por metodo de cada marketplace.
        Se retornar um False, não deixar faturar
        :param cr:
        :param uid:
        :param brw_pedido:  browse do pedido
        :return: True-Tudo ok / False-Nao faturar
        """
        context = context and context.copy() or {}
        res = super(estoquepedidos_pedido_capa, self).pedcap_ver_se_pode_faturar(cr, uid, id, context=None)
        if not res:
            return res
        sql = 'select pedcap_integrador, pedcap_mkp_status from estoquepedidos_pedido_capa where id = %s' % id
        cr.execute(sql)
        dados_pedido = cr.dictfetchall()
        if dados_pedido:
            pedcap_integrador = dados_pedido[0].get('pedcap_integrador')
            pedcap_mkp_status = dados_pedido[0].get('pedcap_mkp_status')
        if pedcap_integrador == 'Magalu':
            if not pedcap_mkp_status in ('APPROVED', 'PROCESSING', 'INVOICED'):
                res = False
        return res
