# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
import json
import logging
from openerp import SUPERUSER_ID
from openerp.tools.translate import _
import hashlib


class mkp_categorias(osv.Model):
    _inherit = 'mkp.categorias'
    _logger = logging.getLogger(_inherit)

    def mkpcat_pesquisar_categorias_no_mkp(self, cr, uid, mkp_ids, context=None):
        context = context and context.copy() or {}
        super(mkp_categorias, self).mkpcat_pesquisar_categorias_no_mkp(cr, uid, mkp_ids, context=None)
        context['active_test'] = False
        mkp_id = self.pool.get('mkp.marketplaces').mkpmkp_get_id(cr, uid, 'Magalu', context=None)
        if not mkp_id in mkp_ids:
            return True
        res = self.pool.get('mkp.magalu').mkpMagalu_get_categorias(cr, uid, context=context)
        if not res.get('status'):
            return res
        _l_categ = res.get('categorias')
        for categ in _l_categ:
            vals = {
                'mkpcat_codigo': categ.get('Id'),
                'name': categ.get('Name'),
            }
            _parent_id = categ.get('ParentId')
            _args = [
                ('mkpcat_codigo', '=', _parent_id),
                ('mkpcat_marketplace_id', '=', mkp_id)
            ]
            _pai_id = self.search(cr, uid, _args, context=context)
            if not _pai_id:
                continue
            vals['parent_id'] = _pai_id[0]
            _args = [
                ('mkpcat_codigo', '=', categ.get('Id')),
                ('mkpcat_marketplace_id', '=', mkp_id)
            ]
            _cat_id = self.search(cr, uid, _args, context=context)
            if _cat_id:
                self.write(cr, uid, _cat_id, vals, context=context)
            else:
                _cat_id = self.create(cr, uid, vals, context=context)
            cr.commit()
        return True


    def mkpcat_btn_mag_categoria_atualizar(self, cr, uid, categ_ids, context=None):
        context = context and context.copy() or {}
        for brw_categoria in self.browse(cr, uid, categ_ids, context=context):
            _conta_id = False
            id = brw_categoria.id
            for brw_conta in brw_categoria.mkpcat_marketplace_id.mkpmkp_conta_ids:
                if brw_conta.mkpcta_integrador == 'Magalu':
                    _conta_id = brw_conta.id
            if brw_categoria.mkpcat_codigo:
                raise osv.except_osv(_('Atencao'), _('Nao posso alterar categorias no Magalu'))
            _codigo = brw_categoria.mkpcat_codigo or 'Mag-%s' % brw_categoria.id
            _categoria = brw_categoria.name
            _categoria_pai = brw_categoria.parent_id.mkpcat_codigo or ''
            res = self._mkpcat_mag_categoria_enviar(cr, uid, _conta_id, _codigo, _categoria, categoria_pai=_categoria_pai,
                                                    context=context)
            if res.get('status'):
                self.write(cr, uid, id, {'mkpcat_codigo': _codigo}, context=context)
        return True

    def _mkpcat_mag_categoria_enviar(self, cr, uid, conta_id, codigo, categoria, categoria_pai=None, context=None):
        context = context and context.copy() or {}
        obj_mkp_Magalu = self.pool.get('mkp.magalu')
        res = obj_mkp_Magalu.mkpMagalu_set_categories(cr, uid, conta_id, codigo, categoria, categoria_pai=categoria_pai,
                                                      context=context)
        if not res.get('status'):
            raise osv.except_osv(_('Atencao!'),
                                 _('Nao consegui atualizar a categoria!\n%s' % res.get('mensagem')))
        return res


