# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
import logging
_logger = logging.getLogger(__name__)


class mkp_notificacoes(osv.Model):
    _inherit = "mkp.notificacoes"

    def _mkpnot_get_orders_magalu(self, cr, uid, dados_notificacao, context=None):
        _spg = self.pool.get
        _order = dados_notificacao.get('mkpnot_resource').split('/')[2]
        _conta_id = dados_notificacao.get('mkpnot_conta_id')
        _dados_conta = _spg('mkp.contas').read(cr, uid, _conta_id, [], context=context)
        dados = _spg('mkp.magalu').mkpMagalu_get_orders(cr, uid, str(_order), _conta_id, context=context)
        if not dados.get('status'):
            return False
        _pedido = dados.get('pedido')
        _ped_id = _spg('mkp.utils').mkputl_importar_um_pedido_magalu(cr, uid, _pedido, _conta_id, context=context)
        if not _ped_id:
            self._logger.info('Pedido nao importado!')
            return False
        return True

    def _mkpnot_get_itens_magalu(self, cr, uid, dados_notificacao, context=None):
        _anuncio = dados_notificacao.get('mkpnot_resource').split('/')[2]
        _spg = self.pool.get
        _args = [('mkpanu_conta_id', '=', dados_notificacao.get('mkpnot_conta_id')),
                 ('mkpanu_codigo_anuncio', '=', _anuncio)]
        _anuncio_ids = _spg('mkp.anuncios').search(cr, uid, _args, context=context)
        if _anuncio_ids:
            brw_anuncio = _spg('mkp.anuncios').browse(cr, uid, _anuncio_ids, context=context)
            if brw_anuncio:
                brw_anuncio = brw_anuncio[0]
                dados_anuncioMagalu = _spg('mkp.magalu').mkpMagalu_get_anuncio(cr, uid, brw_anuncio,
                                                                                      context=context)
                _status_mkp = dados_anuncioMagalu.get('anuncio').get('Active')
                if _status_mkp:
                    _estado = 'A'
                else:
                    _estado = 'P'
                vals = {
                    'mkpanu_necessita_atualizar': False,
                    # 'mkpanu_qtd_vendido': dados_anuncioMagalu.get('sales'),
                    'mkpanu_estado_mkp': dados_anuncioMagalu.get('anuncio').get('Active'),
                    'mkpanu_estado': _estado,
                }
                _spg('mkp.anuncios').write(cr, uid, brw_anuncio.id, vals, context=context)
                return True
            self._logger.info('Anuncio nao localizado!')
            return False

    def _mkpnot_processar_notificacao(self, cr, uid, codigo_mkp, notificacao_tipo, dados_notificacao, context=None):
        """
        Metodo qeue sobrescreve o original para tratamento especializado
        :param cr:
        :param uid:
        :param codigo_mkp: Codigo do Marketplace
        :param dados_notificacao: Dados resultado do read de um registro do marketplace, com todos os atributos
        :param context:
        :return:
        """
        context = context and context.copy() or {}
        res = super(mkp_notificacoes, self)._mkpnot_processar_notificacao(cr, uid, codigo_mkp, notificacao_tipo,
                                                                          dados_notificacao, context=context)
        if codigo_mkp == 'Magalu':
            if notificacao_tipo == 'items':
                res = self._mkpnot_get_itens_magalu(cr, uid, dados_notificacao, context=context)
            elif notificacao_tipo == 'orders':
                res = self._mkpnot_get_orders_magalu(cr, uid, dados_notificacao, context=context)
        return res
