# -*- encoding: utf-8 -*-
import re
import time
from urllib import urlencode
import requests
from openerp import pooler
from openerp.tools.translate import _
import base64
from SigUtils.geralogs import geraLogs
from openerp.tools import config

class Magalu(object):
    def logged_client(f):
        """Decorator for User Credentials checking."""
        def inner(self, *args, **kargs):
            if ((self.client_id is None) or (self.client_secret is None)):
                raise Exception, _("Nao posso acessar o Magalu. parametros do Magalu nao informados!")
            return f(self, *args, **kargs)
        return inner

    def __init__(self, cr=False, uid=False, conta_id=False, company_id=False):
        # self.API_ROOT_URL = 'https://api.integracommerce.com.br'
        self.API_ROOT_URL = 'https://in.integracommerce.com.br'
        self.SDK_VERSION = 'SIG.1.01'
        self.cr = cr
        self.uid = uid
        self.client_id = ''
        self.client_secret = ''
        self.access_token = ''
        self.id_token = ''
        self.refresh_token = ''
        self.code = ''
        self.redirect_url = ''
        self.seller = ''
        self.habilitar_log = False
        self.conta_id = ''
        self.email = ''
        self.seller = ''
        self.comunicar = True
        if cr:
            _poolget = pooler.get_pool(cr.dbname).get
            mkp_ids = _poolget('mkp.marketplaces').search(cr, uid, [('mkpmkp_codigo', '=', 'Magalu')])
            if mkp_ids:
                mkp_ids = mkp_ids[0]
                dados_marketplace = _poolget('mkp.marketplaces').read(cr, uid, mkp_ids, [])
                if dados_marketplace.get('mkpmkp_parar_comunicacao'):
                    self.comunicar = False
                if not conta_id:
                    conta_id = _poolget('mkp.contas').search(cr, uid, [('mkpcta_marketplace_id', '=', mkp_ids)])
                    if conta_id:
                        conta_id = conta_id[0]
                if conta_id:
                    self.conta_id = conta_id
                    dados_conta = _poolget('mkp.contas').read(cr, uid, conta_id, [])
                    if dados_conta.get('mkpcta_parar_comunicacao'):
                        self.comunicar = False
                    self.client_id = dados_conta.get('mkpcta_mag_user_email')
                    self.client_secret = dados_conta.get('mkpcta_mag_secret_key')
                    self.habilitar_log = dados_marketplace.get('mkpmkp_habilita_log')

    def _get_arq_log(self):
        _arq_log = 'mkp_magalu_' + self.cr.dbname
        return _arq_log

    def _gerar_logs(self, mens):
        _diretorio = config.get('logfile')
        if _diretorio:
            _lista = _diretorio.split('/')
            _lista.pop(len(_lista) -1)
            _diretorio = '/'.join(_lista)
        else:
            _diretorio = '/var/log/openerp'
        _arq_log = self._get_arq_log()
        try:
            geraLogs(_arq_log, mens, 'S', _diretorio)
        except:
            try:
                geraLogs(_arq_log, mens.encode('ASCII', 'ignore'), 'S', _diretorio)
            except:
                geraLogs(_arq_log, 'Nao consegui registrar o log', 'S', _diretorio)
        return True


    # REQUEST METHODS
    def make_path(self, path, params={}):
        # Making Path and add a leading / if not exist
        if not (re.search("^http", path)):
            if not (re.search("^\/", path)):
                path = "/" + path
            path = self.API_ROOT_URL + path
        if params:
            path = path + "?" + urlencode(params)
        return path

    @logged_client
    def magalu_comunicar(self, metodo, uri, dados=None, params={}):
        def comunicar():
            if self.habilitar_log:
                self._gerar_logs('Magalu.%s-> URI:%s -> DADOS:%s -> HEADER:%s -> PARAMS:%s' % (metodo, uri, str(dados), headers, str(params)))
            response = requests.request(metodo, uri, json=dados, params=params, headers=headers)
            if self.habilitar_log:
                self._gerar_logs('Magalu.resposta--> %s-%s ' % (response.status_code, response.content))
            return response

        if not self.comunicar:
            class resp(object):
                status_code = 999
                content = '{"Message":"Comunicacao parada"}'
            return resp

        _basic = '%s:%s' % (self.client_id.strip(), self.client_secret.strip())
        _basic = base64.b64encode(_basic)
        headers = {
            'cache-control': 'no-cache',
            'authorization': 'Basic %s' % _basic,
        }
        uri = self.make_path(uri)
        metodo = metodo.upper()
        response = comunicar()
        if response.status_code == 429:
            time.sleep(3)
        return response

