# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################
import urllib2
from openerp.osv import osv
from openerp.tools.translate import _
import json
import logging
from datetime import datetime
import thread
import zipfile
from ..meli import Meli
import base64
import time
import re
import os


ML_STATUS = {
    'A': 'active',
    'P': 'paused',
    'F': 'closed',
}

# Classe de alto nivel para comunicação com o Mercado Livre
class mkp_MerLiv(osv.Model):
    _name = 'mkp.merliv'
    _auto = False
    _tem_erro = False
    _mensagem_erro = ''
    _logger = logging.getLogger(_name)

    def mkpMerLiv_get_attrs_anuncio(self, cr, uid, brw_produto, context=None):
       vals = []
       # for brw_atributo in brw_produto.estpro_atributo_ids:
           # if brw_atributo.estatp_atributo_valor:
       return vals

    def mkpMerLiv_get_anuncio(self, cr, uid, conta_id, codigo_anuncio, context=None):
        context = context and context.copy() or {}
        ml_con = Meli(cr, uid, conta_id)
        params = {}
        if codigo_anuncio:
            _url = 'items/' + str(codigo_anuncio)
            response = ml_con.get(_url, params)
            if response.status_code > 399:
                return {'status': False, 'mensagem': json.loads(response.content).get('message')}
            dados_anuncio_MerLiv = json.loads(response.content)
            return dados_anuncio_MerLiv
        return False

    def mkpMerLiv_set_anuncio(self, cr, uid, brw_anuncio, context=None):
        def _mlaunu_atualizar_variacoes():
            var_ml = {}
            var_erp = {}
            for v in dados_anuncio_MerLiv.get('variations'):
                if v.get('seller_custom_field'):
                    var_ml[v.get('seller_custom_field').split('-')[1]] = v.get('id')
            for v in brw_anuncio.mkpanu_variacoes_ids:
                if var_ml.get(v.mkpanuv_grade_id.grade):
                    if unicode(var_ml.get(v.mkpanuv_grade_id.grade)) != v.mkpanuv_id_no_mkp:
                        self.pool.get('mkp.anuncios.var').write(cr, uid, v.id,
                                                                 {'mkpanuv_id_no_mkp': var_ml.get(v.mkpanuv_grade_id.grade)},
                                                                 context=context)
                    var_ml.pop(v.mkpanuv_grade_id.grade)
                else:
                    var_erp[v.mkpanuv_grade_id.grade] = v.id
            if var_ml: #Tem variacao no ML e nao tem no ERP, incluir
                for key_grade in var_ml:
                    grade_id = False
                    args = [('produto_id', '=', brw_anuncio.mkpanu_produto_id.id),('grade', '=', key_grade)]
                    grade_ids = self.pool.get('estoque.produto.grade').search(cr, uid, args, context=context)
                    if grade_ids:
                        vals = {
                            'mkpanuv_anuncio_id': brw_anuncio.id,
                            'mkpanuv_grade_id': grade_ids[0],
                            'mkpanuv_id_no_mkp': var_ml.get(key_grade),
                        }
                        self.pool.get('mkp.anuncios.var').create(cr, uid, vals, context=context)
            if var_erp:  # Tem no erp e não tem no M.L.
                for key in var_erp:
                    res = self.pool.get('mkp.anuncios.var').unlink(cr, uid, var_erp.get(key), context=context)
            return

        context = context and context.copy() or {}
        obj_mkpromkp = self.pool.get('mkp.produto.marketplaces')
        ml_con = Meli(cr, uid, brw_anuncio.mkpanu_conta_id.id)
        params = {}
        _url = 'items/' + str(brw_anuncio.mkpanu_codigo_anuncio)
        dados_anuncio_MerLiv = False
        _full = False
        if brw_anuncio.mkpanu_codigo_anuncio:
            _anuncio = brw_anuncio.mkpanu_codigo_anuncio
            _conta_id = brw_anuncio.mkpanu_conta_id.id
            dados_anuncio_MerLiv = self.mkpMerLiv_get_anuncio(cr, uid, _conta_id, _anuncio, context=context)
            if dados_anuncio_MerLiv:
                if (dados_anuncio_MerLiv.get('shipping') and
                    dados_anuncio_MerLiv.get('shipping').get('logistic_type') == 'fulfillment'):
                        _full = True
                if dados_anuncio_MerLiv.get('variations') or brw_anuncio.mkpanu_produto_id.grade_usar:
                    _mlaunu_atualizar_variacoes()
                brw_anuncio = self.pool.get('mkp.anuncios').browse(cr, uid, brw_anuncio.id,  context=context)  # Atualizar browser porque houve alteracao de dados
            if dados_anuncio_MerLiv.get('status') == 'closed':
                return {'status': False, 'mensagem': 'O anuncio está encerrado, nao pode ser reaberto!'}
        vals = {}
        _picture_produts = []
        _img_idx = 0
        _ajustar_imagens = False
        if brw_anuncio.mkpanu_codigo_anuncio:
            if not dados_anuncio_MerLiv or (len(brw_anuncio.mkpanu_produto_id.estpro_imagem_ids) != len(dados_anuncio_MerLiv.get('pictures'))):
                _ajustar_imagens = True
        else:
            _ajustar_imagens = True
        args = [('mkpromkp_produto_id', '=', brw_anuncio.mkpanu_produto_id.id), ('mkpromkp_marketplace_id', '=', brw_anuncio.mkpanu_marketplace_id.id)]
        mkpromkp_ids = obj_mkpromkp.search(cr, uid, args, context=context)
        _atributos = {}
        if mkpromkp_ids:
            brw_mkpromkp = obj_mkpromkp.browse(cr, uid, mkpromkp_ids[0], context=context)  # Embora se mkpromkp_ids, será sempre lista de 1
            for brw_imagens in brw_mkpromkp.mkpromkp_imagens_ids:
                if _ajustar_imagens or dados_anuncio_MerLiv and brw_imagens.mkprmkimg_codigo_no_mkp != dados_anuncio_MerLiv.get('pictures')[_img_idx].get('id'):
                    _ajustar_imagens = True
                    _imagem_ml = self.pool.get('mkp.merliv').estimg_imagem_cadastrar_ml(cr, uid, brw_imagens.mkprmkimg_imagem_produto_id.id, context=context)
                    if _imagem_ml:
                        _picture_produts.append({'id': _imagem_ml})
                else:
                    _picture_produts.append({'id': brw_imagens.mkprmkimg_codigo_no_mkp})
                _img_idx += 1

        vals_var = []
        if brw_anuncio.mkpanu_produto_id.grade_usar or (dados_anuncio_MerLiv and dados_anuncio_MerLiv.get('variations')):
            """ anuncio em campanha, nao pode alterar preco"""
            _incluir_preco = True
            if brw_anuncio.mkpanu_codigo_anuncio:
                if dados_anuncio_MerLiv.get('deal_ids'):
                    _incluir_preco = False
            vals_var = self.pool.get('mkp.anuncios').mkpanu_montar_variacoes(cr, uid, brw_anuncio,
                                                                             incluir_preco=_incluir_preco, context=context)
            vals.update({'variations': vals_var,
                         'seller_custom_field': '',
                         'attributes': [{'id': 'GTIN', 'value_name': ''},
                                        {'id': 'SELLER_SKU', 'value_name': ''}]
                         })
        else:
            _valor = brw_anuncio.mkpanu_valor_promocao or brw_anuncio.mkpanu_valor or brw_anuncio.mkpanu_valor_sugerido
            val_attr = self.mkpMerLiv_get_attrs_anuncio(cr, uid, brw_anuncio.mkpanu_produto_id, context=context)
            for brw_cod_barra in brw_anuncio.mkpanu_produto_id.automacao_ids:
                if not brw_cod_barra.active:
                    continue
                if brw_cod_barra.autcba_tipo_barra == '13':
                     _barra = brw_cod_barra.codigo_barra[1:]
                     val_attr.append({'id': 'GTIN', 'value_name': _barra})
            val_attr.append({'id': 'SELLER_SKU', 'value_name': '%s-UN' % brw_anuncio.mkpanu_produto_id.codigo.strip()})
            if brw_anuncio.mkpanu_valor_promocao > 1:
                _valor = brw_anuncio.mkpanu_valor_promocao
            vals.update({
                'price': _valor,
                'seller_custom_field': '%s-UN' % brw_anuncio.mkpanu_produto_id.codigo.strip(),
            })
            """ anuncio em campanha, nao pode alterar preco"""
            if brw_anuncio.mkpanu_codigo_anuncio:
                if dados_anuncio_MerLiv.get('deal_ids'):
                    vals.pop('price')
            if not (dados_anuncio_MerLiv and
                dados_anuncio_MerLiv.get('shipping').get('logistic_type') == 'fulfillment'):
                vals.update({'available_quantity': brw_anuncio.mkpanu_saldo})
            if val_attr:
                vals['attributes'] = val_attr
        if _picture_produts and _ajustar_imagens:
            vals['pictures'] = _picture_produts

        if brw_anuncio.mkpanu_produto_id.estpro_mkp_link_video:
            vals['video_id'] = brw_anuncio.mkpanu_produto_id.estpro_mkp_link_video
        vals['accepts_mercadopago'] = True
        vals_shipping = {}
        if brw_anuncio.mkpanu_retirar_em_maos:
            vals_shipping['local_pick_up'] = True
        else:
            vals_shipping['local_pick_up'] = False
        if brw_anuncio.mkpanu_frete == 'CV':
            vals_shipping['mode'] = 'custom'
            vals_shipping['methods'] = []
            vals_shipping['costs'] = []
            for brw_linha in brw_anuncio.mkpanu_frete_id.mkpfrt_linhas_ids:
                vals_shipping['costs'].append({'description': brw_linha.name, 'cost': brw_linha.mkpfrl_valor})
        else:
            vals_shipping['mode'] = 'me2'
            if brw_anuncio.mkpanu_frete == 'CC':
                vals_shipping['free_shipping'] = False
            else:
                vals_shipping['free_shipping'] = True
                if brw_anuncio.mkpanu_frete == 'GB':
                    vals_shipping['free_methods'] = [{"id": 100009, "rule": {"free_mode": "country", "value": None}}]
        vals['shipping'] = vals_shipping
        vals['title'] = brw_anuncio.mkpanu_title
        if brw_anuncio.mkpanu_mercadofull or (dados_anuncio_MerLiv and dados_anuncio_MerLiv.get('shipping').get('logistic_type') == 'fulfillment'):
            vals.pop('shipping')
            if vals.get('available_quantity'):
                vals.pop('available_quantity')
            if vals.get('variations'):
                i = 0
                for var in vals.get('variations'):
                    if var.has_key('available_quantity'):
                        vals['variations'][i].pop('available_quantity')
                    i += 1
        vals_anuncio = {}
        if brw_anuncio.mkpanu_conta_id.mkpcta_ml_mshop_separado:
            _channels = []
            if brw_anuncio.mkpanu_mercado_livre:
                _channels.append('marketplace')
            if brw_anuncio.mkpanu_mercado_shop:
                _channels.append('mshops')
            vals['channels'] = _channels
        if not brw_anuncio.mkpanu_codigo_anuncio:  # Anuncio novo
            _prod = brw_anuncio.mkpanu_produto_id.id
            _mkp_id = brw_anuncio.mkpanu_marketplace_id.id
            args = [('mkpromkp_produto_id', '=', _prod), ('mkpromkp_marketplace_id', '=', _mkp_id)]
            obj_mkpromkp = self.pool.get('mkp.produto.marketplaces')
            _mkpromkp_ids = obj_mkpromkp.search(cr, uid, args, context=context)
            _cat_code = ''
            if _mkpromkp_ids:
                brw_mkpromkp = obj_mkpromkp.browse(cr, uid, _mkpromkp_ids[0], context=context)
                _cat_code = brw_mkpromkp.mkpromkp_categoria_id.mkpcat_codigo
            vals['category_id'] = _cat_code
            vals['currency_id'] = 'BRL'
            vals['buying_mode'] = "buy_it_now"
            vals['condition'] = 'new'
            vals['listing_type_id'] = brw_anuncio.mkpanu_anuncio_tipo_id.mkpant_codigo
            # vals['non_mercado_pago_payment_methods'] = []
            if brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_responsavel and \
               brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_prazo and \
               brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_prazo_tipo:
                _g = "Garantia do vendedor" if brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_responsavel == 'L' else "Garantia de fábrica"
                _tp = {'D': 'dias', 'M': 'meses','A': 'anos'}
                _pt = _tp.get(brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_prazo_tipo)
                _p = "%s %s" % (brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_prazo, _pt)
                _max = str(brw_anuncio.mkpanu_conta_id.mkpcta_qtd_maxima or brw_anuncio.mkpanu_qtd_maxima or '')
                vals['sale_terms'] = [
                     {"id": "WARRANTY_TYPE", "value_name": _g},
                     {"id": "WARRANTY_TIME", "value_name": _p},
                ]
            elif brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia:
                vals['warranty'] = brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia
            else:
                vals['warranty'] = None
            _url = 'items/'
            response = ml_con.post(_url, vals, params)
            if response.status_code > 399:
                _json = json.loads(response.content)
                _causa = ''
                for x in _json.get('cause'):
                    if isinstance(x, unicode):
                        _causa += x + '\n'
                    else:
                        _causa += x.get('message') + '\n'
                _mens = _json.get('message') + '\n' + _causa
                return {'status': False, 'mensagem': _mens}
            res = json.loads(response.content)
            vals_anuncio['mkpanu_codigo_anuncio'] = res.get('id')
            vals_anuncio['mkpanu_anuncio_endereco'] = res.get('permalink')
            _urlf = _url + str(res.get('id'))
            _urld = 'items/%s/description' % str(res.get('id'))
        else: # Anuncios já existentes
            # if dados_anuncio_MerLiv.get('sold_quantity') == 0: # sem venda
            #     vals['title'] = brw_anuncio.mkpanu_title
            # vals['non_mercado_pago_payment_methods'] = []
            if brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_responsavel and \
               brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_prazo and \
               brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_prazo_tipo:
                _g = "Garantia do vendedor" if brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_responsavel == 'L' else "Garantia de fábrica"
                _tp = {'D': 'dias', 'M': 'meses', 'A': 'anos'}
                _pt = _tp.get(brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_prazo_tipo)
                _p = "%s %s" % (brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_prazo, _pt)
                _max = str(brw_anuncio.mkpanu_conta_id.mkpcta_qtd_maxima or brw_anuncio.mkpanu_qtd_maxima or '')
                vals['sale_terms'] = [
                     {"id": "WARRANTY_TYPE", "value_name": _g},
                     {"id": "WARRANTY_TIME", "value_name": _p},
                ]
            elif brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia:
                vals['warranty'] = brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia
            else:
                vals['warranty'] = None
            if _full:
                if dados_anuncio_MerLiv.get('available_quantity') > 0:
                    vals['status'] = ML_STATUS.get(brw_anuncio.mkpanu_estado)
            elif brw_anuncio.mkpanu_saldo > 0:
                vals['status'] = ML_STATUS.get(brw_anuncio.mkpanu_estado)
            _url = 'items/'
            _urlf = _url + str(brw_anuncio.mkpanu_codigo_anuncio)
            response = ml_con.put(_urlf, vals, params)
            if response.status_code > 399:
                _content = json.loads(response.content)
                _mens = _content.get('message') + '\nCausa:'
                for _causa in _content.get('cause'):
                    _mens += _causa.get('message') + '\n'
                return {'status': False, 'mensagem': _mens}
            _urld = 'items/%s/description' % str(brw_anuncio.mkpanu_codigo_anuncio)
        if dados_anuncio_MerLiv:
            vals_anuncio['mkpanu_qtd_vendido'] = dados_anuncio_MerLiv.get('sold_quantity')
        if _full:
            vals_anuncio['mkpanu_saldo'] = dados_anuncio_MerLiv.get('available_quantity')
        self.pool.get('mkp.anuncios').write(cr, uid, brw_anuncio.id, vals_anuncio, context=context)
        if vals_var:
            _vals_var = json.loads(response.content).get('variations')
            self.pool.get('mkp.anuncios.var').mkpmlanuv_atualizar_variacoes(cr, uid, _vals_var,
                                                                              brw_anuncio, context=context)
        if brw_anuncio.mkpanu_marketplace_id.mkpmkp_modelo_id.mkpmod_tipo == 'H':
            valsd = {'text': brw_anuncio.mkpanu_descricao_texto}
        else:
            valsd = {'plain_text': brw_anuncio.mkpanu_descricao_texto}
        response = ml_con.put(_urld, valsd, params)
        if response.status_code > 399:
            return {'status': False, 'mensagem': json.loads(response.content).get('message')}
        if dados_anuncio_MerLiv and brw_anuncio.mkpanu_anuncio_tipo_id.mkpant_codigo != dados_anuncio_MerLiv.get('listing_type_id'):
            _urlg = '%s/listing_type' % _urlf
            valsg = {'id': brw_anuncio.mkpanu_anuncio_tipo_id.mkpant_codigo}
            response = ml_con.post(_urlg, valsg, params)
            if response.status_code > 399:
                return {'status': False, 'mensagem': json.loads(response.content).get('message')}
        return {'status': True, 'mensagem': ''}

    def mkpMerLiv_set_saldo(self, cr, uid, anuncio_id, context=None):
        """
        Inclui ou altera saldo do anuncio no site do Mercado livre
        @param cr:
        @param uid:
        @param anuncio_id: ids do anuncio alterado
        @param context:
        @return: dicionario contendo id do anuncio e response ex.:{status: True/False, 'mensagem': 'Mensagem'}
                 response. quando response.raise_for_status() for None, tá tudo certo. Para pegar o erro use response.status_code
        """
        context = context and context.copy() or {}
        _spg = self.pool.get
        brw_anuncio = _spg('mkp.anuncios').browse(cr, uid, anuncio_id, context=context)
        ml_con = Meli(cr, uid, brw_anuncio.mkpanu_conta_id.id)
        params = {}
        if brw_anuncio.mkpanu_mercadofull:
            res = {'status': True, 'mensagem': ''}
            return res
        vals = {}
        _local = brw_anuncio.mkpanu_conta_id.mkpcta_local_id.id
        # Verificar situacao do anuncio no M.L.
        if not brw_anuncio.mkpanu_codigo_anuncio:
            res = {'status': True, 'mensagem': ''}
            return res
        _url = 'items/' + str(brw_anuncio.mkpanu_codigo_anuncio)
        response = ml_con.get(_url, params)
        if response.status_code > 399:
            return {'status': False, 'mensagem': json.loads(response.content).get('message')}
        dados_anuncio_ml = json.loads(response.content)
        if dados_anuncio_ml.get('status') == 'paused':
            if brw_anuncio.mkpanu_saldo < 1:  # O anuncio já está pausado e o saldo é zero, Não há nada a fazer
               return {'status': True, 'mensagem': ''}
            else:
                vals['status'] = 'active'
        if dados_anuncio_ml.get('variations') or brw_anuncio.mkpanu_produto_id.grade_usar:
            vals_var = []
            _saldo_zero = False
            _company_id = brw_anuncio.mkpanu_conta_id.company_id.id
            context.update({'company_id': _company_id})
            for _brw_grade in brw_anuncio.mkpanu_produto_id.produto_grade_ids:
                context['company_id'] = brw_anuncio.company_id.id
                _x = _spg('estoque.produto.grade').estpgr_get_saldo(cr, uid, [_brw_grade.id], 'D', _local, context=context)
                # if _x.get(_brw_grade.id) == 0:
                #     _saldo_zero = True
                #     continue
                vals_grade = {
                    'available_quantity': int(_x.get(_brw_grade.id) / brw_anuncio.mkpanu_quantidade) if _x.get(_brw_grade.id) > 0 else 0,
                }
                _valor = brw_anuncio.mkpanu_valor_promocao or brw_anuncio.mkpanu_valor or brw_anuncio.mkpanu_valor_sugerido
                # vals_grade['price'] = _valor
                for _brw_var in brw_anuncio.mkpanu_variacoes_ids:
                    if _brw_var.mkpanuv_grade_id.id == _brw_grade.id:
                        vals_grade['id'] = _brw_var.mkpanuv_id_no_mkp
                        break
                if vals_grade.get('id'): # Não considerar grades que não estão no M.L.
                    vals_var.append(vals_grade)
            if vals_var:
                vals = {'variations': vals_var}
        else:
            _saldo = brw_anuncio.mkpanu_saldo
            vals.update({
                'available_quantity': _saldo,
            })
        _url = 'items/'
        _urlf = _url +str(brw_anuncio.mkpanu_codigo_anuncio)
        response = ml_con.put(_urlf, vals, params)
        if response.status_code > 399:
            vals_acoes = {
                'mkpaco_conta_id': brw_anuncio.mkpanu_conta_id.id,
                'mkpaco_objeto': 'A',
                'mkpaco_acao': 'A',
                'mkpaco_id': brw_anuncio.id,
            }
            _spg('mkp.acoes').create(cr, uid, vals_acoes, context=context)
            return {'status': False, 'mensagem': json.loads(response.content).get('message')}
        res = {'status': True, 'mensagem': ''}
        return res

    def mkpMerLiv_set_preco(self, cr, uid, anuncio_id, context=None):
        """
        Altera preco do anuncio no site do Mercado livre
        @param cr:
        @param uid:
        @param anuncio_id: ids do anuncio alterado
        @param context:
        @return: dicionario contendo id do anuncio e response ex.:{status: True/False, 'mensagem': 'Mensagem'}
                 response. quando response.raise_for_status() for None, tá tudo certo. Para pegar o erro use response.status_code
        """
        def _montar_corpo(valor, mshops=None):
            _vals = {}
            # if brw_anuncio.mkpanu_produto_id.grade_usar or brw_anuncio.mkpanu_variacoes_ids:
            if brw_anuncio.mkpanu_produto_id.grade_usar and not mshops:
                vals_var = []
                for _brw_grade in brw_anuncio.mkpanu_produto_id.produto_grade_ids:
                    context['company_id'] = brw_anuncio.company_id.id
                    _x = _spg('estoque.produto.grade').estpgr_get_saldo(cr, uid, [_brw_grade.id], 'D', _local,
                                                                        context=context)
                    vals_grade = {'price': valor}
                    for _brw_var in brw_anuncio.mkpanu_variacoes_ids:
                        if _brw_var.mkpanuv_grade_id.id == _brw_grade.id:
                            vals_grade['id'] = _brw_var.mkpanuv_id_no_mkp
                            break
                    if vals_grade.get('id'):  # Não considerar grades que não estão no M.L.
                        vals_var.append(vals_grade)
                if vals_var:
                    _vals = {'variations': vals_var}
            else:
                if mshops:
                    _vals.update({
                        'amount': valor,
                        'currency_id': 'BRL'
                    })
                else:
                    _vals.update({'price': valor})
            if mshops:
                _url = 'items/%s/prices/types/standard/channels/mshops'
                _urlf = _url % str(brw_anuncio.mkpanu_codigo_anuncio)
                response = ml_con.post(_urlf, _vals, params)
            else:
                _url = 'items/%s'
                _urlf = _url % str(brw_anuncio.mkpanu_codigo_anuncio)
                response = ml_con.put(_urlf, _vals, params)
            return response

        def _registrar_erro():
            if 'deal_ids' in response.text:
                return {'status': False, 'mensagem': _('Item em promocao, nao posso alterar o preco!')}
            vals_acoes = {
                'mkpaco_conta_id': brw_anuncio.mkpanu_conta_id.id,
                'mkpaco_objeto': 'A',
                'mkpaco_acao': 'A',
                'mkpaco_id': brw_anuncio.id,
            }
            _spg('mkp.acoes').create(cr, uid, vals_acoes, context=context)
            _mens = '%s-%s-%s' % (json.loads(response.content).get('message', ''),
                                  json.loads(response.content).get('error', ''),
                                  json.loads(response.content).get('cause', ''))
            return {'status': False, 'mensagem': _mens}

        context = context and context.copy() or {}
        _spg = self.pool.get
        brw_anuncio = _spg('mkp.anuncios').browse(cr, uid, anuncio_id, context=context)
        ml_con = Meli(cr, uid, brw_anuncio.mkpanu_conta_id.id)
        params = {}
        _local = brw_anuncio.mkpanu_conta_id.mkpcta_local_id.id
        # Verificar situacao do anuncio no M.L.
        if not brw_anuncio.mkpanu_codigo_anuncio:
            res = {'status': True, 'mensagem': ''}
            return res
        _valor = brw_anuncio.mkpanu_valor_promocao or brw_anuncio.mkpanu_valor or brw_anuncio.mkpanu_valor_sugerido
        _valor2 = brw_anuncio.mkpanu_valor_sugerido2
        if brw_anuncio.mkpanu_conta_id.mkpcta_ml_mshop_separado:
            if brw_anuncio.mkpanu_mercado_livre:
                response = _montar_corpo(_valor)
                if response.status_code > 399:
                    res = _registrar_erro()
                    return res
            if brw_anuncio.mkpanu_mercado_shop:
                response = _montar_corpo(_valor2, mshops=True)
                if response.status_code > 399:
                    res = _registrar_erro()
                    return res
        else:
            response = _montar_corpo(_valor)
            if response.status_code > 399:
                res = _registrar_erro()
                return res

        res = {'status': True, 'mensagem': ''}
        return res

    def mkpMerLiv_atualizar_mensagem(self, cr, uid, brw_mensagem, context=None):
        context = context and context.copy() or {}
        ml_con = Meli(cr, uid, brw_mensagem.mkpmen_conta_id.id)
        params = {'mark_as_read': 'false'}
        _ml_meu_user_id = brw_mensagem.mkpmen_conta_id.mkpcta_ml_user_id
        _ml_cli_user_id = brw_mensagem.mkpmen_pedido_id.pessoa_id.admpes_id_externo
        if not _ml_cli_user_id:  # Não é cliente do M.L. não precisa fazer nada
            return {'status': True, 'mensagem': ''}
        _pack_id = brw_mensagem.mkpmen_pedido_id.pedcap_mkp_carrinho_compras
        _order_id = brw_mensagem.mkpmen_pedido_id.pedcap_nro_pedido_externo
        if not _pack_id:
            _pack_id = _order_id
        _mens = brw_mensagem.name
        _url = 'messages/packs/%s/sellers/%s' % (_pack_id, _ml_meu_user_id)
        vals = {
            'from': {'user_id': _ml_meu_user_id},
            'to': {'user_id': _ml_cli_user_id},
            'text': _mens
        }
        response = ml_con.post(_url, vals, params)
        if response.status_code > 399:
            return {'status': False, 'mensagem': json.loads(response.content).get('message')}
        res = {'status': True, 'mensagem': ''}
        message_id = json.loads(response.content).get('id')
        res['message_id'] = message_id
        return res

    def mkpMerLiv_get_shipment(self, cr, uid, _ship_id, _conta_id, context=None):
        ml_con = Meli(cr, uid, _conta_id)
        # Pegar custo do frete
        _url = '/shipments/%s/costs' % _ship_id
        params = {}
        headers = {}
        headers = {'X-Costos-New': 'true'}
        response = ml_con.get(_url, params, headers=headers)
        if response.status_code > 399:
            return False
        dados_costs = json.loads(response.content)
        # Pegar etiqueta de postagem
        _url = '/shipments/%s' % _ship_id
        headers = {'x-format-new': 'true'}
        response = ml_con.get(_url, params, headers=headers)
        if response.status_code > 399:
            return False
        dados = json.loads(response.content)
        dados_costs['tracking_number'] = dados.get('tracking_number')
        return dados_costs

    def mkpMerLiv_get_billing(self, cr, uid, _order, _conta_id, context=None):
        ml_con = Meli(cr, uid, _conta_id)
        _url = '/orders/%s/billing_info' % _order
        params = {}
        headers = {}
        response = ml_con.get(_url, params, headers=headers)
        if response.status_code > 399:
            return False
        try:
            dados_bill = json.loads(response.content)
        except:
            dados_bill = {'billing_info': {'additional_info':{}}}
        return dados_bill

    def mkpMerLiv_get_etiqueta(self, cr, uid, _ship_ids, conta_id, context=None):
        if not _ship_ids:
            return ''

        if not isinstance(_ship_ids, list):
            _ship_ids = [_ship_ids]
        'https://api.mercadolibre.com/shipment_labels?shipment_ids=27651568876&response_type=zpl2&access_token=APP_USR-5212872253144318-072009-4c11a5aceb86ccd7b9a083f297e596ee-77813143'
        _url = 'shipment_labels?shipment_ids=%s&response_type=zpl2' % ','.join(
                                                                  map(lambda x: '%s' % x,_ship_ids))
        ml_con = Meli(cr, uid, conta_id)
        params = {}
        headers = {}
        try:
            response = ml_con.get(_url, params, headers=headers)
        except Exception as e:
            raise osv.except_osv(_('Atencao!'),
                                 _('Erro de comunicacao com o Mercado Livre:\n\n%s') % e)

        data = datetime.now()
        path_zip = '/tmp/etiqueta-%s.zip' % data
        f = open(path_zip, 'w')
        f.write(response.content)
        f.close()
        path = '/tmp/etiqueta-%s' % data
        try:
            fantasy_zip = zipfile.ZipFile(path_zip)
            fantasy_zip.extractall(path)
            fantasy_zip.close()
        except Exception as e:
            try:
                f = open(path_zip, 'r')
                _etiq = json.loads(f.read())
                f.close()
                if _etiq.get('error') == 'labels_generation_locked':
                    raise Exception('labels_generation_locked')
                elif _etiq.get('error') == 'not_found':
                    raise Exception(_('A etiqueta ainda nao foi liberada pelo M.L.-not_found!'))
                else:
                    raise Exception('Erro na leitura da etiqueta\n%s' % _etiq.get('message'))
            except Exception as e:
                if e.message == 'labels_generation_locked':
                    raise osv.except_osv(_('Atencao!'),
                         _('A etiqueta ainda nao foi liberada pelo M.L.!'))
                raise osv.except_osv(_('Atencao!'),
                                 _('Nao consegui extrair a etiqueta:\n\n%s') % e)
        os.remove(path_zip)
        f_in = open('%s/Etiqueta de envio.txt' % path, 'r')
        fi = f_in.readlines()
        f_in.close()
        out_path = '/tmp/etiqueta-%s.txt' % str(data).replace(' ', '_')
        f = open(out_path, 'w')
        f.writelines(fi)
        f.close()
        f_in = open('%s/Controle.pdf' % path, 'r')
        fi = f_in.readlines()
        f_in.close()
        os.remove('%s/Etiqueta de envio.txt' % path)
        os.remove('%s/Controle.pdf' % path)
        os.remove
        os.rmdir(path)
        outC_path = '/tmp/Controle-%s.pdf' % str(data).replace(' ', '_').replace(':', '_')
        f = open(outC_path, 'w')
        f.writelines(fi)
        f.close()
        return out_path, outC_path

    def mkpMerLiv_get_custo_frete(self, cr, uid, anuncio, conta_id, context=None):
        """
        Método destinado a buscar o custo do frete de um anuncio
        @param cr:
        @param uid:
        @param anuncio: codigo do anuncio no mercado livre MLB????????????
        @param context:
        @return: Sempre True
        """
        context = context and context.copy() or {}
        ml_con = Meli(cr, uid, conta_id)
        params = {'seller': ml_con.seller}
        _url = 'items/%s/shipping_options/free' % anuncio
        xml_str = ml_con.get(_url, {})
        if xml_str.status_code > 399:
            return 0.00
        dados = json.loads(xml_str.text)
        idx = dados.get('coverage').keys()
        return dados.get('coverage').get(idx[0]).get('list_cost')

    def mkpMerLiv_get_invoice_id(self, cr, uid, _ship_id, conta_id, context=None):
        """
        get invoice de uma order
        :param cr:
        :param uid:
        :param _ship_id: Codigo da encomenda
        :param context:
        :return: numero da invoice
        """
        ml_con = Meli(cr, uid, conta_id)
        _url = '/users/%s/invoices/shipments/%s' % (ml_con.seller,_ship_id)
        params = {}
        headers = {}
        response = ml_con.get(_url, params, headers=headers)
        dados = json.loads(response.content)
        _invoice = False
        if dados.get('id'):
            _invoice = dados.get('id')
        return _invoice

    def mkpMerLiv_get_shipment_orders(self, cr, uid, _ship_id, conta_id, context=None):
        """
        get ordens de uma etiqueta
        :param cr:
        :param uid:
        :param _ship_id: Codigo da encomenda
        :param context:
        :return: lista com numero das ordens(pedidos)
        """
        ml_con = Meli(cr, uid, conta_id)
        _url = '/shipments/%s/items' % _ship_id
        params = {}
        headers = {}
        response = ml_con.get(_url, params, headers=headers)
        dados = json.loads(response.content)
        _orders = []
        for x in dados:
            _orders.append(x.get('order_id'))
        return _orders


    def mkpMerLiv_get_order(self, cr, uid, pedido, conta_id, context=None):
        """
        Método destinado a buscar um pedido no M.L.
        @param cr:
        @param uid:
        @param pedido: Número do pedido no M.L.
        @param context:
        @return: Sempre True
        """
        context = context and context.copy() or {}
        ml_con = Meli(cr, uid, conta_id)
        headers = {'x-format-new': 'true'}
        params = {'seller': ml_con.seller}
        _url = 'orders/%s' % pedido
        xml_str = ml_con.get(_url, params, headers=headers)
        dados = json.loads(xml_str.text)
        if dados.get('error'):
            return {'status': False, 'mensagem': dados.get('error')}
        if dados.get('shipping') and dados.get('shipping').get('id'):
            _ship_id = dados.get('shipping').get('id')
            # Comentado porque não estava trazendo o cpf/cnpj - confirmar futuramente a necessidade deste codigo
            # if 'not_delivered' in dados.get('tags'):
            #     _url = 'shipments/%s' % _ship_id
            #     xml_str = ml_con.get(_url, params, headers=headers)
            #     dados_ship = json.loads(xml_str.text)
            #     dados['mercadofull'] = False
            #     if dados_ship.get('destination'):
            #         if dados_ship.get('destination').get('shipping_address'):
            #             _address = dados_ship.get('destination').get('shipping_address')
            #             if not dados.get('shipping').get('receiver_address'):
            #                 dados['shipping']['receiver_address'] = {}
            #             dados['shipping']['receiver_address']['street_name'] = _address.get('street_name')
            #             dados['shipping']['receiver_address']['street_number'] =_address.get('street_number')
            #             dados['shipping']['receiver_address']['zip_code'] =_address.get('zip_code')
            #             dados['shipping']['receiver_address']['comment'] = _address.get('comment')
            #             if _address.get('neighborhood') and _address.get('neighborhood').get('name'):
            #                 dados['shipping']['receiver_address']['bairro'] = _address.get('neighborhood').get('name')
            #     return dados
            # else:
            _url = 'shipments/%s' % _ship_id
            xml_str = ml_con.get(_url, params, headers=headers)
            dados_ship = json.loads(xml_str.text)
            _logistica = dados_ship.get('logistic').get('type')
            if dados_ship.get('lead_time'):
                if dados_ship.get('lead_time').get('buffering') and \
                   dados_ship.get('lead_time').get('buffering').get('date'):
                    _data_faturamento = dados_ship.get('lead_time').get('buffering').get('date')[:10]
                    dados['faturar_em'] = _data_faturamento
                elif dados_ship.get('lead_time').get('estimated_handling_limit') and \
                     dados_ship.get('lead_time').get('estimated_handling_limit').get('date'):
                        _data_faturamento = dados_ship.get('lead_time').get('estimated_handling_limit').get('date')[:10]
                        dados['faturar_em'] = _data_faturamento
                if dados_ship.get('lead_time').get('estimated_delivery_limit') and \
                   dados_ship.get('lead_time').get('estimated_delivery_limit').get('date'):
                    _data_entrega = dados_ship.get('lead_time').get('estimated_delivery_limit').get('date')[:10]
                    dados['data_entrega'] = _data_entrega
            _url = 'shipments/%s/billing_info' % _ship_id
            xml_str = ml_con.get(_url, params, headers=headers)
            dados_bil = json.loads(xml_str.text)
            if _logistica == 'fulfillment':
                dados['mercadofull'] = True
            else:
                dados['mercadofull'] = False
            if dados_bil.get('status') == 400 and dados.get('status') not in ('paid', 'cancelled'): #Pedido aguardando pagamento
                return {'status': False, 'mensagem': _('Pedido aguardando pagamento')}
            if dados_bil.get('status') == 400 and dados.get('status') == 'paid': #Pedido pago, sem Mercado envios
                return dados
            # if dados_bil.get('carrier').get('document').get('value'):
            #     dados['mercadofull'] = True
            # else:
            #     dados['mercadofull'] = False
            if dados_bil and dados_bil.get('receiver'):
                cliente = dados_bil.get('receiver')
                if cliente.get('name'):
                    dados['buyer']['first_name'] = cliente.get( 'name')
                    dados['buyer']['last_name'] = ''
                if cliente.get('document'):
                    if cliente.get('document').get('value'):
                        if not dados.get('buyer'):
                            dados['buyer'] = {}
                        if not dados.get('buyer').get('billing_info'):
                            dados['buyer']['billing_info'] = {}
                        dados['buyer']['billing_info']['doc_number'] = cliente.get('document').get('value')
                if cliente.get('additional_documents'):
                    for _doc in cliente.get('additional_documents'):
                        if _doc.get('type') == 'STATE_REGISTRATION':
                            dados['buyer']['billing_info']['IE'] = _doc.get('value')
                if cliente.get('billing_address'):
                    if cliente.get('billing_address').get('street_name'):
                        if not dados.get('shipping').get('receiver_address'):
                            dados['shipping']['receiver_address'] = {}
                        dados['shipping']['receiver_address']['street_name'] = cliente.get('billing_address').get('street_name')
                        dados['shipping']['receiver_address']['street_number'] = cliente.get('billing_address').get('street_number')
                        dados['shipping']['receiver_address']['zip_code'] = cliente.get('billing_address').get('zip_code')
                        dados['shipping']['receiver_address']['comment'] = cliente.get('billing_address').get('comment')
                    if cliente.get('billing_address').get('neighborhood') and cliente.get('billing_address').get('neighborhood').get('name'):
                        dados['shipping']['receiver_address']['bairro'] = cliente.get('billing_address').get('neighborhood').get('name')
            _url = 'shipments/%s/payments' % _ship_id
            xml_str = ml_con.get(_url, params, headers=headers)
            for dados_pay in json.loads(xml_str.text):
                dados['shipping']['payment_id'] = dados_pay.get('payment_id')
        return dados

    def mkpMerLiv_get_invoice(self, cr, uid, recurso, conta_id, context=None):
        """
        Método destinado a pegar as nfs no M.L.
        :param cr:
        :param uid:
        :param recurso:
        :param conta_id:
        :param context:
        :return:
        """

        context = context and context.copy() or {}
        ml_con = Meli(cr, uid, conta_id)
        params = {}
        _url = recurso
        xml_str = ml_con.get(_url, params)
        if xml_str.status_code > 404:
            self._logger.info('Invoice nao encontrada no M.L.')
            return False
        if xml_str.status_code > 399:
            self._logger.info('Nao consegui conectar no M.L.')
            return False
        dados_nota = json.loads(xml_str.text)
        end_xml = dados_nota.get('attributes').get('xml_location')
        xml_str = ml_con.get(end_xml, params)
        if xml_str.status_code < 400:
            dados_nota['xml'] = xml_str.text
        return dados_nota

    def mkpMerLiv_get_dados_fiscais(self, cr, uid, sku, conta_id, context=None):
        """
        Método destinado a buscar os recebimentos no mercado pago
        @param cr:
        @param uid:
        @param payment: Codigo do pagamento no mercado pago
        @param context:
        @return: Json com resultado da pesquisa de pagamentos no mercado livre
        """
        context = context and context.copy() or {}
        ml_con = Meli(cr, uid, conta_id)
        params = {}
        _url = 'items/fiscal_information/%s' % sku
        xml_str = ml_con.get(_url, params)
        if xml_str.status_code == 404: # Dados fiscais nao cadastrados
            return False
        elif xml_str.status_code > 399:
            self._logger.info('Nao consegui conectar no M.L.')
            return False
        dados_fiscais = json.loads(xml_str.text)
        res = {
                'ncm': dados_fiscais.get('tax_information').get('ncm'),
                'csosn': dados_fiscais.get('tax_information').get('csosn'),
                'cest': dados_fiscais.get('tax_information').get('cest'),
                'ean': dados_fiscais.get('tax_information').get('ean'),
                'cost': dados_fiscais.get('cost'),
            }
        return res

    def mkpMerLiv_set_dados_fiscais(self, cr, uid, sku, conta_id, dados_fiscais, context=None):
        context = context and context.copy() or {}
        ml_con = Meli(cr, uid, conta_id)
        params = {}
        if sku:
            _url = 'items/fiscal_information/%s' % sku
            xml_str = ml_con.put(_url, dados_fiscais, params)
        else:
            _url = 'items/fiscal_information'
            xml_str = ml_con.post(_url, dados_fiscais, params)
        if xml_str.status_code == 404: # Dados fiscais nao cadastrados
            return False
        elif xml_str.status_code > 399:
            self._logger.info('Nao consegui conectar no M.L.')
            return False
        return True

    def mkpMerLiv_set_order_faturado(self, cr, uid, _order, _conta_id, chave, nf_ids, context=None):
        context = context and context.copy() or {}
        obj_ped = self.pool.get('estoquepedidos.pedido.capa')
        ped_id = obj_ped.search(cr, uid, [('pedcap_nro_pedido_externo', '=', _order)], context=context)
        dados_ped = obj_ped.read(cr, uid, ped_id, ['pedcap_mkp_shipping'], context=context)
        if isinstance(dados_ped, list):
            dados_ped = dados_ped[0]
        if dados_ped and dados_ped.get('pedcap_mkp_shipping'):
            _ship = dados_ped.get('pedcap_mkp_shipping')
            recurso = 'shipments/%s/invoice_data' % _ship
            data = self.pool.get('fiscal.nf.capa').exportar_xml_danfe(cr, uid, nf_ids, context={'gerar_so_xml': True})
            mkp_con = Meli(cr, uid, _conta_id)
            headers = {'Content-Type': 'application/xml'}
            params = {'siteId': 'MLB'}
            response = mkp_con.post(recurso, data, params=params, headers=headers)
            if response.status_code > 399:
                return {'status': False, 'mensagem': json.loads(response.content)}
        return {'status': True, 'mensagem': ''}


    def mkpMerLiv_get_payments(self, cr, uid, payment, conta_id, context=None):
        """
        Método destinado a buscar os recebimentos no mercado pago
        @param cr:
        @param uid:
        @param payment: Codigo do pagamento no mercado pago
        @param context:
        @return: Json com resultado da pesquisa de pagamentos no mercado livre
        """
        context = context and context.copy() or {}
        ml_con = Meli(cr, uid, conta_id)
        params = {}
        _url = 'collections/%s' % payment
        xml_str = ml_con.get(_url, params)
        if xml_str.status_code > 399:
            return {'status': False, 'mensagem': _('Nao consegui encontrar o pagamento!')}
        dados_collections = json.loads(xml_str.text)
        if dados_collections.get('status_detail') in ('by_payer', 'pending_capture', 'pending_waiting_payment', 'pending_waiting_transfer'):
            return {'status': True, 'mensagem': '', 'dados': {}}
        res = {
                'pedido': dados_collections.get('order_id'),
                'Venda': dados_collections.get('transaction_amount'),
                'Tarifa_ml': dados_collections.get('marketplace_fee'),
                'Tarifa_mp': dados_collections.get('mercadopago_fee'),
                'Frete': dados_collections.get('shipping_cost'),
            }
        return {'status': True, 'mensagem': '', 'dados': res}

    def mkpMerLiv_get_pergunta(self, cr, uid, pergunta, conta_id, context=None):
        """
        Método destinado a buscar um pedido no M.L.
        @param cr:
        @param uid:
        @param pedido: Número do pedido no M.L.
        @param context:
        @return: Sempre True
        """
        context = context and context.copy() or {}
        ml_con = Meli(cr, uid, conta_id)
        params = {}
        _url = 'questions/%s' % pergunta
        xml_str = ml_con.get(_url, params)
        dados = json.loads(xml_str.text)
        return dados

    def mkpMerLiv_get_mensagem(self, cr, uid, mensagem, conta_id, context=None):
        """
        Método destinado a buscar uma mensagem de pedido no M.L.
        @param cr:
        @param cr:
        @param uid:
        @param pedido: Número da mensagem no M.L.
        @param context:
        @return: Sempre True
        """
        context = context and context.copy() or {}
        ml_con = Meli(cr, uid, conta_id)
        params = {'tag': 'post_sale'}
        headers = {}
        _url = 'messages/%s' % mensagem
        xml_str = ml_con.get(_url, params, headers=headers)
        dados = json.loads(xml_str.text)
        return dados

    def mkpMerLiv_get_usuario(self, cr, uid, ml_user_id, conta_id, context=None):
        """
        Método destinado a buscar um usuario no M.L.
        @param cr:
        @param uid:
        @param ml_user_id: Número do usuario no M.L.
        @param context:
        @return: Sempre True
        """
        context = context and context.copy() or {}
        ml_con = Meli(cr, uid, conta_id)
        params = {}
        _url = 'users/%s' % ml_user_id
        xml_str = ml_con.get(_url, params)
        dados = json.loads(xml_str.text)
        return dados

    def MkpMerLiv_pesquisar_anuncio(self, cr, uid, conta_id, context=None):
        context = context and context.copy() or {}
        ml_con = Meli(cr, uid, conta_id)
        params = {'seller': ml_con.seller}
        _url = 'orders/search/recent'
        self._logger.info('Pesquisando pedidos')
        _offset = 0
        _laco = 1
        res = []
        _cnpj_full = ''
        brw_conta = self.pool.get('mkp.contas').browse(cr, uid, conta_id, context=context)
        if brw_conta and \
           brw_conta.mkpcta_fulfillment_empresa_id and \
           brw_conta.mkpcta_fulfillment_empresa_id.rescon_pessoa_id and \
           brw_conta.mkpcta_fulfillment_empresa_id.rescon_pessoa_id.cpf_cnpj:
            _cnpj_full = brw_conta.mkpcta_fulfillment_empresa_id.rescon_pessoa_id.cpf_cnpj
            _cnpj_full = re.sub('[^0-9]', '', _cnpj_full)
        while True:
            try:
                params['offset'] = _offset
                xml_str = ml_con.get(_url, params)
                dados = json.loads(xml_str.text)
                _total_pedidos = dados.get('paging').get('total')
                _qtd_lacos = (_total_pedidos / 50) + 1
                if _total_pedidos in (50, 100, 150, 200, 250, 300):
                    _qtd_lacos -= 1
            except:
                self._logger.info('Nao consegui obter a pesquisa de pedidos!')
                return {}
            if dados.get('status', False):
                self._logger.info(
                    'Erro ML: %s-%s' % (dados.get('status', 'NI'), dados.get('message', 'Erro nao identificado!')))
                return True

            for _venda in dados.get('results'):
                _ship_id = _venda.get('shipping').get('id')
                _venda['mercadofull'] = False
                if _ship_id:
                    _urlb = 'shipments/%s/billing_info' % _ship_id
                    xml_str = ml_con.get(_urlb, params, headers={'x-format-new': 'true'})
                    dados_bil = json.loads(xml_str.text)
                    if dados_bil.get('senders') and \
                       dados_bil.get('senders')[0].get('document') and \
                       dados_bil.get('senders')[0].get('document').get('value') and \
                       dados_bil.get('senders')[0].get('document').get('value') == _cnpj_full:
                            _venda['mercadofull'] = True
                else:
                    pass
                res.append(_venda)
            _offset += 50
            _laco += 1
            if _laco > _qtd_lacos:
                break
        return res

    def mkpMerLiv_set_resposta(self, cr, uid, pergunta_ml_id, resposta, conta_id, context=None):
        """
        Método destinado a responder uma pergunta no M.L.
        @param cr:
        @param uid:
        @param pedido: Número do pedido no M.L.
        @param context:
        @return: Sempre True
        """
        ml_con = Meli(cr, uid, conta_id)
        params = {}
        vals = { 'question_id': pergunta_ml_id, 'text': resposta}
        _url = 'answers'
        response = ml_con.post(_url, vals, params)
        # res = json.loads(response.content)
        if response.status_code > 399:
            return False
        else:
            return True

    def mkpMerLiv_get_categorias_atributos(self, cr, uid, mkp_categoria_code, context=None):
        self._logger.info('Buscando atributos da categorias no M.L.!')
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
        _url = 'https://api.mercadolibre.com/categories/%s/technical_specs/input#options' % mkp_categoria_code
        mkp_con = Meli(cr, uid, company_id=company_id)
        xml_str = mkp_con.get(_url)
        if xml_str.status_code > 399:
            self._logger.info('Nao consegui conectar no M.L.')
            return False
        return xml_str

    def mkpMerLiv_get_categorias(self, cr, uid, context=None):
        self._logger.info('Buscando categorias no M.L.!')
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
        _url = '/sites/MLB/categories/all'
        mkp_con = Meli(cr, uid, company_id=company_id)
        xml_str = mkp_con.get(_url)
        if xml_str.status_code > 399:
            self._logger.info('Nao consegui conectar no M.L.')
            return False
        return xml_str

    def mkpMerLiv_autenticar(self, cr, uid, conta_id):
        meli = Meli(cr, uid, conta_id)
        _url = meli.auth_url()
        return _url

    def estimg_imagem_cadastrar_ml(self, cr, uid, imagem_id, force = False, context={}):
        """
        Função para cadastrar imagens no ML se não existir ou para retornar o id da imagem
        @param cr:
        @param uid:
        @param imagem_id: integer. id da imagen do produto ou da grade no sigerp
        @param context:
        @return: char Codigo da imagem no ML
        """
        def _set_imagem(_imagem, _img_id):
            _arq = '/tmp/ml_%s.jpg' % time.time()
            f=open(_arq, 'wb')
            f.write(base64.b64decode(_imagem))
            f.close()
            params = {}
            response = ml_con.upload('pictures', {'file': open(_arq, 'rb')}, params)
            if response.status_code > 399:
                return False
            res = json.loads(response.content)
            _img_ml_id = res.get('id')
            _img_size = res.get('max_size')
            _img_url = ''
            for x in res.get('variations'):
                if x.get('size') == _img_size:
                    _img_url = x.get('url')
                    break
            context['ml_atualizado'] = True
            obj_img.write(cr, uid, _img_id, {'mkprmkimg_codigo_no_mkp':_img_ml_id, 'mkprmkimg_endereco_mkp': _img_url},
                                  context=context)
            return _img_ml_id

        def _get_imagem_no_ml(id_imagem_no_ml):
            response = ml_con.get('pictures/%s' % id_imagem_no_ml)
            if response.status_code > 399: #Not found
                return False
            else:
                return True

        def _get_imagem():
            args = [('mkprmkimg_imagem_produto_id', '=',imagem_id)]
            mkp_produto_marketplace_imagens_ids = self.pool.get('mkp.produto.marketplace.imagens').search(cr, uid, args, context=context)
            res = False
            for dados_imagem in obj_img.read(cr, uid, mkp_produto_marketplace_imagens_ids, ['mkprmkimg_codigo_no_mkp', 'mkprmkimg_foto', 'mkprmkimg_mkp_codigo'], context=context):
                if dados_imagem.get('mkprmkimg_mkp_codigo') == 'MerLiv':
                    if not force:
                        id_imagem_no_ml = dados_imagem.get('mkprmkimg_codigo_no_mkp') or False
                        if id_imagem_no_ml and _get_imagem_no_ml(id_imagem_no_ml):
                            return id_imagem_no_ml
                    res = _set_imagem(dados_imagem.get('mkprmkimg_foto'), dados_imagem.get('id'))
            return res

        context = context and context.copy() or {}
        ml_con = Meli(cr, uid)
        obj_img = self.pool.get('mkp.produto.marketplace.imagens')
        imagem_no_ml = _get_imagem()
        return imagem_no_ml


class mkpMerLiv_pesquisar_anuncio(object):
    def __init__(self, cr, uid, conta_id, dt_inicio, dt_hoje):
        self.iniciou = False
        self.terminou = False
        self.anuncios = []
        self.anuncios_com_problemas = []
        self.dict_resposta = {}
        self.ml_con = Meli(cr, uid, conta_id)
        self.dt_inicio = dt_inicio
        self.dt_hoje = dt_hoje
        self._codigos = ''
        return

    def pesquisar_no_ml(self):
        str_codigos = self._codigos
        _url = '/items?ids=%s' % str_codigos
        xml_str = self.ml_con.get(_url)
        if xml_str.status_code > 399:
            anuncios = str_codigos.split(',')
            for a in anuncios:
                self.anuncios_com_problemas.append(a)
            return True

        res_url = {}
        for res in json.loads(xml_str.text):
            res = res.get('body')
            res_url = {}
            res_url['descricao_anuncio'] = res.get('title', 'Nao consegui identificar')
            _state = res.get('status')
            res_url['qtd_vendido'] = res.get('sold_quantity', 0)
            res_url['preco'] = res.get('price', 0)
            _mp = res.get('accepts_mercadopago', False)
            c_s_juros = res.get('listing_type_id')
            _parcela = 'parcelas '
            res_url['anuncio_tipo'] = res.get('listing_type_id')
            if c_s_juros == 'gold_pro':
                _parcela += 'Sem Juros '
            else:
                _parcela += 'Com Juros '
            if _mp:
                _parcela += ' Com MercadoPago'
            res_url['parcelas'] = _parcela
            res_url['estoque'] = res.get('available_quantity', 0)
            res_url['frete_gratis'] = False
            if res.get('shipping', False):
                res_url['frete_gratis'] = res.get('shipping').get('free_shipping', False)
            res_url['local_vendedor'] = ''
            if res.get('seller_address', False):
                if res.get('seller_address').get('city', False) and res.get('seller_address').get('state', False):
                    res_url['local_vendedor'] = '%s (%s)' % (
                        res.get('seller_address').get('city').get('name', ''),
                        res.get('seller_address').get('state').get('name', ''))
            if _state == 'active':
                res_url['state'] = 'A'
            elif _state == 'paused':
                res_url['state'] = 'P'
            elif _state == 'closed':
                res_url['state'] = 'F'
            else:
                res_url['state'] = 'C'
            res_url['mercado_envio'] = False
            res_url['titulo'] = res.get('title')
            try:
                if res.get('shipping').get('mode') == 'me2':
                    res_url['mercado_envio'] = True
            except:
                pass
            _id_anuncio = res.get('id', '').strip()
            try:
                res_url['foto'] = urllib2.urlopen(res.get('thumbnail')).read().encode('base64')
            except:
                # self._logger.info('Nao consegui tratar a foto do anuncio %s' % _id_anuncio)
                pass
            self.dict_resposta[_id_anuncio] = res_url
        # Pesquisar visitas
        # _anuncios = str([str(x) for x in self.dict_resposta.keys()]).replace("'", '').replace(' ', '')[1:-1]
        _url = '/items/visits?ids=%s&date_from=%sT00:00:00.000-03:00&date_to=%sT23:59:59.999-03:00#options' % (
            str_codigos, self.dt_inicio, self.dt_hoje)
        xml_str = self.ml_con.get(_url)
        if xml_str.status_code < 400:
            for res in json.loads(xml_str.text):
                _codigo_anuncio = res.get('item_id')
                res_vis = {'qtd_visitas': res.get('total_visits', 0)}
                if res_url.get(_codigo_anuncio):
                    res_url[_codigo_anuncio].update(res_vis)
        return True

    def registrar(self, anun):
        if not isinstance(anun, (tuple,list)):
            self.anuncios.append(anun)
        else:
            for a in anun:
                self.anuncios.append(a)
        return True

    def iniciar(self):
        self.iniciou = True
        while True:
            qtd_anuncios = len(self.anuncios)
            qtd_anuncios_com_problema = len(self.anuncios_com_problemas)
            if qtd_anuncios == 0 and qtd_anuncios_com_problema == 0:
                break
            if qtd_anuncios == 0:
               for a in self.anuncios_com_problemas:
                   self.anuncios.append(a)
               qtd_anuncios = len(self.anuncios)
            if qtd_anuncios > 20:
                qtd_anuncios = 20
            codigos = ''
            for i in range(qtd_anuncios):
                codigos += self.anuncios.pop(0) + ','
            codigos = codigos[:-1]
            self._codigos = codigos
            thread.start_new_thread(self.pesquisar_no_ml, ())
            # self._pesquisar_ml(codigos)
        return True

    def retornar(self):
        if self.terminou == True:
            return False
        res = {}
        for key in self.dict_resposta.keys():
            res[key] = self.dict_resposta.get(key)
            self.dict_resposta.__delitem__(key)
            if not (self.dict_resposta or self.anuncios):
                self.terminou = True
                break
        return res


