# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from SigUtils.cep import Correios
from openerp.tools import config
from ...adm.control.utils import capitalize_all
from datetime import datetime, timedelta
from merliv import mkpMerLiv_pesquisar_anuncio
import time
import subprocess
from openerp.tools.translate import _


ML_STATUS = {
    'A': 'active',
    'P': 'paused',
    'F': 'closed'
}


class mkp_utils(osv.Model):
    _inherit = 'mkp.utils'

    def mkputl_atualizar_anuncio_merliv(self, cr, uid, id, context=None):
        """
        Inclui ou altera anuncio no site do Mercado livre
        @param cr:
        @param uid:
        @param id: id do anuncio a ser alterado
        @param context:
        @return: dicionario contendo id do anuncio e response ex.:{status: True/False, 'mensagem': 'Mensagem'}
                 response. quando response.raise_for_status() for None, tá tudo certo. Para pegar o erro use response.status_code
        """

        context = context and context.copy() or {}
        obj_MerLiv = self.pool.get('mkp.merliv')
        obj_anuncios = self.pool.get('mkp.anuncios')
        brw_anuncio = obj_anuncios.browse(cr, uid, id, context=context)
        if not brw_anuncio:  # anuncio nao existe mais. Retornar True para que a ação seja encerrada
            return {'status': True, 'mensagem': ''}
        try:
            _codigo = brw_anuncio.mkpanu_codigo_anuncio
        except:  # Erro porque o id não existe
            return {'status': True, 'mensagem': ''}
        res = obj_MerLiv.mkpMerLiv_set_anuncio(cr, uid, brw_anuncio, context=context)
        if 'pausado ou finalizado' in res.get('mensagem'):  # Pausado ou finalizado marcar como atualizado
            res['status'] = True
        else:
            if not res.get('status'):
                return res
        vals_anuncio = {'mkpanu_necessita_atualizar': False}
        obj_anuncios.write(cr, uid, brw_anuncio.id, vals_anuncio, context=context)
        return res

    def mkputl_faturar_no_mkp_selecionado(self, cr, uid, mkp_integrador, conta_id, ped_externo, chave, nf_ids, context=None):
        """
        Metodo sobrescrito ppelo marketplace especifico
        :param cr:
        :param uid:
        :param mkp_integrador:
        :param conta_id:
        :param ped_externo:
        :param chave:
        :param context:
        :return:
        """
        context = context and context.copy() or {}
        if mkp_integrador == 'MerLiv':
            if chave[:10] == '0000000000': # serie 90+
                res = True
            else:
                res = self.pool.get('mkp.merliv').mkpMerLiv_set_order_faturado(cr, uid, ped_externo, conta_id,
                                                                         chave, nf_ids, context=context)
                # if not res.get('status'):
                #     mensagem = 'Nao consegui faturar no marketplace! \n %s' % res.get('mensagem')
                #     raise osv.except_osv(_('Atencao'), _(mensagem))
        else:
            res = super(mkp_utils, self).mkputl_faturar_no_mkp_selecionado(cr, uid, mkp_integrador, conta_id, ped_externo,
                                                                          chave, nf_ids, context=context)
        return res


    def mkputl_cron_pesquisar_pedidos_merliv(self, cr, uid, context=None):
        """
        Método chamado pelo cron para pesquisar pedidos nos marketplaces
        @param cr:
        @param uid:
        @param context:
        @return: Sempre True
        """
        context = context and context.copy() or {}
        obj_contas = self.pool.get('mkp.contas')
        for company_id in self.pool.get('res.company').search(cr, uid, [], context=context):
            context['sig_force_company'] = True
            args = [('mkpcta_integrador', '=', 'MerLiv'), ('company_id', '=', company_id)]
            conta_ids = obj_contas.search(cr, uid, args, context=context)
            for brw_conta in obj_contas.browse(cr, uid, conta_ids, context=context):
                if brw_conta.mkpcta_parar_comunicacao or \
                   brw_conta.mkpcta_marketplace_id.mkpmkp_parar_comunicacao:
                    continue
                _conta_id = brw_conta.id
                self._mkputl_pesquisar_pedido_mkp_merliv(cr, uid, _conta_id, context=context)
        return True

    def _mkputl_anuncio_preview(self, cr, uid, brw_mkp_produto, anuncio_id, preview_dict, context=None):
        """
        Metodo especifico do Mercado livre para tratamento da seção dos anuncios que são separados em cada marketplace
        :param cr:
        :param uid:
        :param brw_mkp_produto:
        :param anuncio_id:
        :param preview_dict:
        :param context:
        :return: dicionario: preview_dict
        """
        if brw_mkp_produto.mkpromkp_marketplace_integrador != 'MerLiv':
            return preview_dict
        obj_anuncio = self.pool.get('mkp.anuncios')
        brw_anuncio = obj_anuncio.browse(cr, uid, anuncio_id, context=context)
        for brw_secao in brw_anuncio.mkpanu_secao_ids:
            idx = brw_secao.mkpans_secao_id.id
            secao = preview_dict.get('secoes').get(idx)
            if brw_secao.mkpans_secao_texto:
                if brw_secao.mkpans_sobrepoe_acrescenta == 'S':
                    secao['corpo'] = brw_secao.mkpans_secao_texto
                else:
                    if secao['corpo']:
                        secao['corpo'] = secao['corpo'] + brw_secao.mkpans_secao_texto
                    else:
                        secao['corpo'] = brw_secao.mkpans_secao_texto
                preview_dict['secoes'][idx] = secao
        return preview_dict

    def correios_comunicar(self, cr, uid, cep):
        _cep_correios = False
        i = 0
        while i < 3:
            try:
                _cep_correios = Correios(config.options.get('http_proxy')).consulta(str(cep), primeiro=False)
                if isinstance(_cep_correios, list):
                    _cep_correios = _cep_correios[0]
                    break
            except:
                pass
            i += 1
            time.sleep(1)
        return _cep_correios

    def mkputl_get_tracking_number(self, cr, uid, _ship_id, conta_id):
        dados = self.pool.get('mkp.merliv').mkpMerLiv_get_shipment(cr, uid, _ship_id, conta_id)
        track_number = dados.get('tracking_number')
        return track_number

    def mkputl_get_valor_frete(self, cr, uid, _ship_id, conta_id, context=None):
        dados = self.pool.get('mkp.merliv').mkpMerLiv_get_shipment(cr, uid, _ship_id, conta_id, context=context)
        _frete_loja = frete_custo = 0
        for sender in dados.get('senders'):
            _frete_loja += sender.get('cost')
        _frete_cliente = dados.get('receiver').get('cost')
        return _frete_loja, _frete_cliente

    def _mkputl_get_anuncio_catalogo(self, cr, uid, codigo, company_id, context=None):
        def _get_ids():
            _anun_ids = []
            _anuncio_ids = self.pool.get('mkp.anuncios').search(cr, uid, [('mkpanu_codigo_anuncio', '=', _cod)],
                                                                context=context)
            if _anuncio_ids:
                for _anuncio_brw in self.pool.get('mkp.anuncios').browse(cr, uid, _anuncio_ids, context=context):
                    if _anuncio_brw.company_id.id == company_id:
                        _anun_ids = [_anuncio_brw.id]
                        break
            return _anun_ids

        _args = ['|', ('mkpanur_codigo_anuncio', '=', codigo), ('mkpanur_relacionado', '=', codigo)]
        rel_ids = self.pool.get('mkp.anuncios.relacionamento').search(cr, uid, _args, context=context)
        for rel_brw in self.pool.get('mkp.anuncios.relacionamento').browse(cr, uid, rel_ids, context=context):
            _cod = rel_brw.mkpanur_codigo_anuncio
            if _cod != codigo:
                _anuncio_ids = _get_ids()
                if _anuncio_ids:
                    return _anuncio_ids
            _cod = rel_brw.mkpanur_relacionado
            if _cod != codigo:
                _anuncio_ids = _get_ids()
                if _anuncio_ids:
                    return _anuncio_ids
        return []

    def mkputl_importar_um_pedido(self, cr, uid, _venda, conta_id, context=None):
        self._logger.info('Importando o pedido M.L.: %s' % _venda.get('id'))
        obj_pedido = self.pool.get('estoquepedidos.pedido.capa')
        obj_local_locacao = self.pool.get('estoque.local.locacao')
        obj_pessoa = self.pool.get('adm.pessoa')
        obj_variacoes = self.pool.get('mkp.anuncios.var')
        obj_marketplaces = self.pool.get('mkp.marketplaces')
        obj_contas = self.pool.get('mkp.contas')
        obj_mkputils = self.pool.get('mkp.utils')
        dados_conta = obj_contas.read(cr, uid, conta_id, ['mkpcta_local_id',
                                                          'mkpcta_marketplace_id',
                                                          'mkpcta_fulfillment_empresa_id',
                                                          'mkpcta_fulfillment_local_id',
                                                          'company_id',
                                                          'mkpcta_ml_user_id'], context=context)
        dados_marketplace = obj_marketplaces.read(cr, uid, dados_conta.get('mkpcta_marketplace_id')[0],
                                                  ['mkpmkp_ml_frete_cliente'],context=context)
        _local_id = dados_conta.get('mkpcta_local_id')[0]

        _condicao_frete_cliente_id = dados_marketplace.get('mkpmkp_ml_frete_cliente')[0]
        _hoje = self.pool.get('adm.utils').admutl_datetime_to_timezone(cr, uid, datetime.now(),
                                                                       formato='%Y_%m_%d_%H_%M_%s')
        cr.execute(''' BEGIN; SAVEPOINT importar_pedido_ml_%s; ''' % _hoje)
        _ml_venda_id = _venda.get('id')
        _faturar_em = _venda.get('faturar_em', False)
        _data_entrega = _venda.get('data_entrega', False)
        _comentario = _venda.get('comments') or ''
        _status = _venda.get('status')
        _data_venda = _venda.get('date_created')
        _pack_id = _venda.get('pack_id', False)
        _lista_itens = []
        _anuncio_tipo_id = False
        _qtd_venda = 0
        _formas = []
        _vr_desconto = 0.00
        if _venda.get('coupon'):
            _vr_desconto = _venda.get('coupon').get('amount')
        for _item in _venda.get('order_items'):
            _pedido_item = {}
            context.update({'sig_force_company': True})
            _args = [('mkpanu_codigo_anuncio', '=', _item.get('item').get('id'))]
            _anuncio_ids = self.pool.get('mkp.anuncios').search(cr, uid, _args, context=context)
            if not _anuncio_ids:
                _anuncio_ids = self._mkputl_get_anuncio_catalogo(cr, uid, _item.get('item').get('id'),
                                                                 dados_conta.get('company_id')[0], context=None)
            _shipping_id = False
            _frete_cliente = _frete_loja = 0
            _conta_id = False
            _full = False
            _mshop = True if 'mshops' in _venda.get('tags') else False
            if _anuncio_ids:
                _campos = ['mkpanu_produto_id', 'mkpanu_valor_frete', 'mkpanu_frete', 'mkpanu_valor_frete',
                           'mkpanu_anuncio_tipo_id', 'mkpanu_quantidade', 'mkpanu_conta_id', 'mkpanu_mercadofull']
                _dados_anuncio = self.pool.get('mkp.anuncios').read(cr, uid, _anuncio_ids[0], _campos, context=context)
                if _venda.get('mercadofull'):
                    _full = True
                    if dados_conta.get('mkpcta_fulfillment_empresa_id'):
                        context['sig_force_company'] = dados_conta.get('mkpcta_fulfillment_empresa_id')[0]
                    if dados_conta.get('mkpcta_fulfillment_local_id'):
                        _local_id = dados_conta.get('mkpcta_fulfillment_local_id')[0]
                else:
                    context['sig_force_company'] = dados_conta.get('company_id')[0]
                _produto_id = _dados_anuncio['mkpanu_produto_id'][0]
                _anuncio_tipo_id = _dados_anuncio['mkpanu_anuncio_tipo_id'][0]
                _conta_id = _dados_anuncio['mkpanu_conta_id'][0]
                if _venda.get('shipping') and _venda.get('shipping').get('id'):
                    _shipping_id = _venda.get('shipping').get('id')
                    _frete_loja, _frete_cliente = self.mkputl_get_valor_frete(cr, uid, _shipping_id, _conta_id, context=context)
                _grade_ids = self.pool.get('estoque.produto.grade').search(cr, uid, [
                    ('produto_id', '=', _produto_id)], context=context)
                if len(_grade_ids) > 1:
                    try:
                        _grade = _item.get('item').get('seller_custom_field')[-2:]
                        _grade_lida_ids = self.pool.get('estoque.produto.grade').search(cr, uid, [
                            ('produto_id', '=', _produto_id), ('grade', '=', _grade)], context=context)
                        if _grade_lida_ids:
                            _grade_ids = _grade_lida_ids
                        else:
                            _variation = _item.get('item').get('variation_id')
                            _var_id = obj_variacoes.search(cr, uid, [('mkpanuv_id_no_mkp', '=', _variation)], context=context)
                            if _var_id:
                                _dados_variacao = obj_variacoes.read(cr, uid, _var_id[0], ['mkpanuv_grade_id'], context=context, load='_classic_write')
                                if _dados_variacao:
                                    _grade_ids = [_dados_variacao.get('mkpanuv_grade_id')]
                    except:
                        pass
                _qtd_anuncio = _dados_anuncio.get('mkpanu_quantidade', 1)
                if _qtd_anuncio == 0:
                    _qtd_anuncio = 1
                _qtd_venda =_item.get('quantity') * _qtd_anuncio
                _qtd_unidades =_item.get('quantity')
                _valor_total_item = (float(_item.get('full_unit_price')) / _qtd_anuncio) * _qtd_venda
                __vlt = (float(_item.get('unit_price')) / _qtd_anuncio) * _qtd_venda
                if _valor_total_item < __vlt:
                    _valor_total_item = __vlt
                _vr_desconto += _valor_total_item - __vlt
                _vr_forma = _valor_total_item
                if _vr_desconto and _vr_forma > _vr_desconto:
                    _vr_forma -= _vr_desconto
                _formas.append((_anuncio_tipo_id, _vr_forma, _qtd_unidades, _valor_total_item))
                if _frete_loja:
                    _valor_total_item -= _frete_loja
                _l_vl = _valor_total_item / _qtd_venda
                _args = [('grade_id', '=', _grade_ids[0]), ('local_id', '=', _local_id)]
                _emb_ids = obj_local_locacao.search(cr, uid, _args, context=context)
                if not _emb_ids:
                    return False
                _emb_id = \
                    obj_local_locacao.read(cr, uid, _emb_ids[0],
                                           ['estllc_produto_embalagem_id'], context=context)[
                        'estllc_produto_embalagem_id'][0]
                _pedido_item = self.pool.get('mkp.utils')._mkputl_monta_dic_item_pedido(cr, uid, _produto_id,
                                                                                        _grade_ids[0], _local_id, _emb_id,
                                                                                        _qtd_venda, _l_vl, _anuncio_ids[0])
            for x in _pedido_item:
                _lista_itens.append(x)
        _preco_total = _venda.get('total_amount')
        if _frete_cliente:
            _preco_total += _frete_cliente
        _cliente_ml_apelido = _venda.get('buyer').get('nickname')
        _dados_bill = self.pool.get('mkp.merliv').mkpMerLiv_get_billing(cr, uid, _ml_venda_id, conta_id,
                                                                        context=context)
        if not _dados_bill:
            return False
        _cliente_cpf = _dados_bill.get('billing_info').get('doc_number') or ''
        _cliente_cpf = _cliente_cpf.replace('.', '').replace('-', '').replace('/', '')
        _cliente_cep = _cliente_rua = _cliente_rua_nro = _cliente_rua_complemento = _cliente_bairro = ''
        _cliente_nome_1 = _cliente_nome_2 = ''
        if _dados_bill.get('billing_info').get('additional_info'):
            for x in _dados_bill.get('billing_info').get('additional_info'):
                if x.get('type') == u'ZIP_CODE':
                    _cliente_cep = x.get('value', '')
                elif x.get('type') == u'STREET_NAME':
                    _cliente_rua = x.get('value', '')
                elif x.get('type') == u'STREET_NUMBER':
                    _cliente_rua_nro = x.get('value', '')
                elif x.get('type') == u'COMMENT':
                    _cliente_rua_complemento = x.get('value', '')
                elif x.get('type') == u'NEIGHBORHOOD':
                    _cliente_bairro = x.get('value', '')
                elif x.get('type') == u'FIRST_NAME' or x.get('type') == u'BUSINESS_NAME':
                    _cliente_nome_1 = x.get('value', '')
                elif x.get('type') == u'LAST_NAME':
                   _cliente_nome_2 = x.get('value', '')
        else:
            if _venda.get('shipping').get('receiver_address'):
                _cliente_cep = _venda.get('shipping').get('receiver_address').get('zip_code')
                _cliente_rua = _venda.get('shipping').get('receiver_address').get('street_name')
                _cliente_rua_nro = _venda.get('shipping').get('receiver_address').get('street_number')
                _cliente_rua_complemento  = _venda.get('shipping').get('receiver_address').get('comment')
                _cliente_bairro = _venda.get('shipping').get('receiver_address').get('bairro')
        _cliente_nome = capitalize_all('%s %s' % (_cliente_nome_1, _cliente_nome_2))
        if not (_cliente_nome_1 or _cliente_nome_2):
            _cliente_nome = _venda.get('buyer').get('first_name', '') + ' ' +_venda.get('buyer').get('last_name', '')
        _cliente_ie = False
        _dados_adicionais = _dados_bill.get('billing_info').get('additional_info')
        for _da in _dados_adicionais:
            if _da.get('type') and _da.get('type') == u'STATE_REGISTRATION':
                _cliente_ie = _da.get('value')
                break
        _cliente_ml_email = _venda.get('buyer').get('email', '')
        _cliente_ml_fone_1 = _cliente_ml_fone_2 = False
        _cliente_ml_id = _venda.get('buyer').get('id')
        _cliente_ml_ddd_1 = _cliente_ml_fone_1 = _cliente_ml_ddd_2 = _cliente_ml_fone_2 = ''
        if _venda.get('buyer').get('phone'):
            _cliente_ml_ddd_1 = _venda.get('buyer').get('phone').get('area_code')
            _cliente_ml_fone_1 = _venda.get('buyer').get('phone').get('number')
            if _cliente_ml_fone_1:
                _cliente_ml_fone_1 = filter(lambda f: f in '0123456789', _cliente_ml_fone_1)
                if len(_cliente_ml_fone_1) > 9:
                    if _cliente_ml_fone_1[0] == '0':
                        _cliente_ml_ddd_1 = _cliente_ml_fone_1[:3]
                        _cliente_ml_fone_1 = _cliente_ml_fone_1[3:]
                    else:
                        _cliente_ml_ddd_1 = _cliente_ml_fone_1[:2]
                        _cliente_ml_fone_1 = _cliente_ml_fone_1[2:]
        if _venda.get('buyer').get('alternative_phone'):
            _cliente_ml_ddd_2 = _venda.get('buyer').get('alternative_phone').get('area_code')
            _cliente_ml_fone_2 = _venda.get('buyer').get('alternative_phone').get('number')
            _cliente_ml_fone_2 = filter(lambda f: f in '0123456789', _cliente_ml_fone_2)
            if len(_cliente_ml_fone_2) > 9:
                if _cliente_ml_fone_2[0] == '0':
                    _cliente_ml_ddd_2 = _cliente_ml_fone_2[:3]
                    _cliente_ml_fone_2 = _cliente_ml_fone_2[3:]
                else:
                    _cliente_ml_ddd_2 = _cliente_ml_fone_2[:2]
                    _cliente_ml_fone_2 = _cliente_ml_fone_2[2:]
        # if not _cliente_rua:
        #     return False
        if not _cliente_bairro and _cliente_cep:
            x = self.correios_comunicar(cr, uid, _cliente_cep)
            if x:
                if isinstance(x, dict) and x.get('bairro'):
                    _cliente_bairro = x.get('bairro') or ''
        if not _cliente_bairro:
            _cliente_bairro = 'bairro'
        if _frete_cliente:
            _comentario += ' \nFrete por conta do cliente: %s' % _frete_cliente
        if _frete_loja:
            _comentario += ' \nFrete gratis - Valor: %s' % _frete_loja

        if _cliente_rua_complemento and len(_cliente_rua_complemento) > 20:
            _cliente_rua_complemento = _cliente_rua_complemento[0:20]
        _pedido_ids = obj_pedido.search(cr, uid, [('pedcap_nro_pedido_externo', '=', _ml_venda_id), ('tipo', '=', 'V')], context=context)
        _pedido_id = False
        _status_pedido_erp = False
        _pessoa_ids = False
        if _cliente_cpf:
            _pessoa_ids = obj_pessoa.search(cr, uid, [('cpf_cnpj', '=', _cliente_cpf)], context=context)
        else:
            _pessoa_ids = obj_pessoa.search(cr, uid, [('admpes_id_externo', '=', _cliente_ml_id)], context=context)
            if not _pessoa_ids:
                _pessoa_ids = obj_pessoa.search(cr, uid, [('fantasia_apelido', '=', _cliente_ml_apelido)], context=context)

        _pais_id = False

        if _cliente_ml_email and 'mercadolivre.com' in _cliente_ml_email:
            _tipo_email = 'Mercado Livre'
        else:
            _tipo_email = 'Comum'
        if _pessoa_ids:
            _pessoa_id = obj_mkputils.mkputl_orders_alterar_pessoa(cr, uid, _pessoa_ids[0], _cliente_nome, _cliente_cpf,
                                                                   _cliente_ml_id, '', _cliente_cep, _cliente_rua,
                                                                   _cliente_rua_nro, _cliente_rua_complemento,
                                                                   _cliente_ml_ddd_1, _cliente_ml_fone_1,
                                                                   _cliente_ml_ddd_2, _cliente_ml_fone_2, _tipo_email,
                                                                   _cliente_ml_email, context=context)
        else:
            # TODO FAZER TRATAMENTO PARA ALTERAR OS DADOS DO CLIENTE POIS PODE TER TIDO ALTERAÇÃO NO M.L.
            _pessoa_id = self.mkputl_orders_incluir_pessoa(cr, uid, _cliente_nome, _cliente_cpf, _cliente_ml_id,
                                                           _cliente_ml_apelido, _cliente_ie, _cliente_cep, _cliente_rua,
                                                           _cliente_rua_nro, _cliente_rua_complemento, _cliente_ml_ddd_1,
                                                           _cliente_ml_fone_1, _cliente_ml_ddd_2, _cliente_ml_fone_2,
                                                           _tipo_email, _cliente_ml_email, context=context)

        if _pedido_ids:  # O nro pedido do ML é unico, portanto se tiver pedido so tem 1
            _pedido_id = _pedido_ids[0]
            _dados_pedido = obj_pedido.read(cr, uid, [_pedido_id], ['state'], context=context)
            _status_pedido_erp = _dados_pedido[0].get('state')
            if _status_pedido_erp == 'V':  # Se o pedido estiver validado, voltar para esboco
                obj_pedido.button_rascunho(cr, uid, [_pedido_id], context=context)
                _status_pedido_erp = 'R'
            if _status_pedido_erp not in (
            'R', 'C'):  # O pedido não está mais em esboço ou cancelado, não deve ser alterado
                return _pedido_id
        obj_condicao_forma = self.pool.get('adm.condicao.forma')
        _forma = []
        _tipo_anuncio = ''
        for x in _formas:
            _condicao_forma_id = False
            _taxa_ml = _taxa_ml_fixo = 0
            _anuncio_tipo_id = x[0]
            _valor_parcela = x[1]
            _qtd_unidades = x[2]
            _vtm = x[3]
            _campos = ['mkpant_custo_var', 'mkpant_custo_fixo', 'mkpant_tipo_custo_fixo', 'mkpant_codigo', 'mkpant_condicao_pgto', 'name']
            _dados_read = self.pool.get('mkp.anuncios.tipo').read(cr, uid, _anuncio_tipo_id, _campos, context=context)
            _taxa_ml = _dados_read.get('mkpant_custo_var')
            _taxa_ml_fixo = _dados_read.get('mkpant_custo_fixo')
            _taxa_ml_tipo_fixo = _dados_read.get('mkpant_tipo_custo_fixo')
            if _taxa_ml_tipo_fixo == 'U':
                _taxa_ml_fixo = _taxa_ml_fixo * _qtd_unidades
            _condicao_forma_id = _dados_read.get('mkpant_condicao_pgto')
            _tipo_anuncio = _dados_read.get('name')
            if _condicao_forma_id:
                _condicao_forma_id = _condicao_forma_id[0]
                _vencimento = _data_venda[:10]
                _frete_na_parcela = _frete_cliente
                _forma_pgto_id = \
                    obj_condicao_forma.read(cr, uid, _condicao_forma_id, [], context=context)['forma_pagamento_id'][0]
                _forma1 = {
                    'forma_pagto_id': _forma_pgto_id,
                    'condicao_forma_id': _condicao_forma_id,
                    'pedido_parcela_ids': [(0, 0, {'vr_parcela': _valor_parcela, 'data_vencimento': _vencimento})],
                    'valor': _valor_parcela,
                    'pedcdc_mkp_tarifa': (_taxa_ml * _vtm / 100) + _taxa_ml_fixo,
                }
                _forma.append((0,0, _forma1))
        if _frete_cliente:
            _forma1 = {
                'forma_pagto_id': obj_condicao_forma.read(cr, uid, _condicao_frete_cliente_id, [], context=context)['forma_pagamento_id'][0],
                'condicao_forma_id': _condicao_frete_cliente_id,
                'pedido_parcela_ids': [(0, 0, {'vr_parcela': _frete_cliente, 'data_vencimento': _vencimento})],
                'valor': _frete_cliente,
            }
            _forma.append((0, 0, _forma1))

        dados_pessoa = self.pool.get('adm.pessoa').read(cr, uid, _pessoa_id, ['endereco_nf_id'], context=context)
        if dados_pessoa and dados_pessoa.get('endereco_nf_id'):
            _end_id = dados_pessoa.get('endereco_nf_id')[0]
        else:
            _end_id = ''
        _dict_status_ml = {'paid': 'Pago', 'confirmed': 'Confirmado', 'payment_in': 'Em pagamento',
                           'cancelled': 'Cancelada', 'payment_required': 'Aguardando pagamento'}
        vals = {
            'observacao': _comentario,
            'data_emissao': _data_venda,
            'tipo': 'V',
            'pessoa_id': _pessoa_id,
            'pedcap_endereco_id': _end_id,
            'pedcap_mkp_status': _dict_status_ml.get(_status),
            'pedcap_nro_pedido_externo': _ml_venda_id,
            'pedcap_endereco_eletronico': 'https://www.mercadolivre.com.br/vendas/%s/detalhe' % _ml_venda_id,
            # 'pedcap_endereco_eletronico': 'https://myaccount.mercadolivre.com.br/sales/vop?&orderId=%s' % _ml_venda_id,
            'pedcap_mkp_tipo_anuncio': _tipo_anuncio,
            'vr_frete': 0.00,
            'vr_desconto': _vr_desconto,
            'vr_seguro': 0.00,
            'vr_despesas_acessorias': 0.00,
            'pedcap_conta_id': _conta_id,
        }
        if _shipping_id:
            vals['pedcap_mkp_shipping'] = _shipping_id
            _orders = self.pool.get('mkp.merliv').mkpMerLiv_get_shipment_orders(cr, uid, _shipping_id, _conta_id, context=None)
            if _orders:
                # Criar notificaçoes para todas as ordens relacionadas com a encomenda que ainda nao existam
                for x in _orders:
                    if x == unicode(_ml_venda_id):
                        continue
                    sql = "select id from mkp_notificacoes where mkpnot_resource = '/orders/%s'" % x
                    cr.execute(sql)
                    _nots = cr.dictfetchone()
                    if not _nots:
                        vals_not = {
                            'mkpnot_conta_id': _conta_id,
                            'mkpnot_resource': "/orders/%s" % x,
                            'mkpnot_topic': 'orders_v2',
                            'state': 'R',
                            'mkpnot_attempts': 1,
                            # 'mlnot_application': brw   .get('estpar_ml_app_id') or False,
                            # 'mlnot_ml_user': estoque_parametro_dados.get('estpar_ml_user_id') or False,
                        }
                        self.pool.get('mkp.notificacoes').create(cr, uid, vals_not, context=context)
            _invoice = self.pool.get('mkp.merliv').mkpMerLiv_get_invoice_id(cr, uid, _shipping_id, _conta_id,
                                                                            context=context)
            if _invoice:
                _seller = dados_conta.get('mkpcta_ml_user_id')
                sql = "select id from mkp_notificacoes where mkpnot_resource = '/users/%s/invoices/%s'" % (_seller, _invoice)
                cr.execute(sql)
                _nots = cr.dictfetchone()
                if not _nots:
                    vals_not = {
                        'mkpnot_conta_id': _conta_id,
                        'mkpnot_resource': '/users/%s/invoices/%s' % (_seller,_invoice),
                        'mkpnot_topic': 'invoices',
                        'state': 'R',
                        'mkpnot_attempts': 1,
                        'mkpnot_loja': _seller,
                        # 'mlnot_application': brw   .get('estpar_ml_app_id') or False,
                    }
                    self.pool.get('mkp.notificacoes').create(cr, uid, vals_not, context=context)
        vals['vr_frete'] = _frete_cliente + _frete_loja
        vals['pedcap_full'] = _full
        vals['pedcap_eshop'] = _mshop
        if _faturar_em:
            vals['pedcap_faturar_em'] = _faturar_em
        if _data_entrega:
            vals['data_entrega'] = _data_entrega
        if _pack_id:
            vals['pedcap_mkp_carrinho_compras'] = _pack_id
        if not _pedido_id:
            if _anuncio_ids:
                vals['pedido_item_ids'] = _lista_itens
            if _forma:
                vals['pedido_condicao_ids'] = _forma
            _pedido_id = obj_pedido.create(cr, uid, vals, context=context)
            obj_pedido.write(cr, uid, _pedido_id, {}, context=context)
            cr.execute(''' COMMIT; ''')  # Comito, porque se houver algum problema na validação, não perco o pedido
            _hoje = self.pool.get('adm.utils').admutl_datetime_to_timezone(cr, uid, datetime.now(),
                                                                           formato='%Y_%m_%d_%H_%M_%s')
            cr.execute(''' BEGIN; SAVEPOINT importarimportar_pedido_ml_%s; ''' % _hoje)
        else:
            if _status == 'confirmed' and _status_pedido_erp == 'C':
                return False # Marcar com problema
            elif _status != 'cancelled':
                _condicao_ids = self.pool.get('estoquepedidos.pedido.condicao').search(cr, uid, [('capa_id', '=', _pedido_id)], context=context)
                if _condicao_ids and _forma:
                    self.pool.get('estoquepedidos.pedido.condicao').unlink(cr, uid, _condicao_ids, context=context)
                vals['pedido_condicao_ids'] = _forma
                vals['state'] = 'R'
                context['salvar_forcado'] = True
                obj_pedido.write(cr, uid, _pedido_id, vals, context=context)
                context.pop('salvar_forcado')
                cr.execute(''' COMMIT; ''')  # Comito, porque se houver algum problema na validação, não perco o pedido
                _hoje = self.pool.get('adm.utils').admutl_datetime_to_timezone(cr, uid, datetime.now(),
                                                                               formato='%Y_%m_%d_%H_%M_%s')
                cr.execute(''' BEGIN; SAVEPOINT importar_pedido_ml_%s; ''' % _hoje)
        if _status == 'paid':
            try:
                res = obj_pedido.button_validar(cr, uid, [_pedido_id], context=context)
            except:
                pass
        if _status == 'cancelled' and _status_pedido_erp not in ('C', 'F'):
            obj_pedido.button_cancelar(cr, uid, [_pedido_id], context=context)
        else:
            if _status_pedido_erp == 'F':
                cr.execute(''' COMMIT; ''')
                return False # Marcar com problema, pedido faturado no ERP e cancelado mo MKP
        if _full and _status != 'cancelled':
            vals = {'state': 'R'}
            context['salvar_forcado'] = True
            obj_pedido.write(cr, uid, _pedido_id, vals, context=context)
        cr.execute(''' COMMIT; ''')
        # self.pedcap_ver_se_atualiza_saldo_anuncios(cr, uid, [_pedido_id], context=context)
        return _pedido_id

    def _mkputl_get_pesquisa_no_mkp(self, cr, uid, brw_anuncios):
        """
        método a ser sobrescrito pelos métodos de cada marketplace
        @param brw_anuncio: broser de um anuncio  a sere pesquisado
          ex.:{576: u'MLB887521819', 565: u'MLB872477007', 542: u'MLB851019359'}
        @return: dicionario que contem dicionario com o resultado da pesquisa
          Ex.: {u'MLB851019359': {'estoque': 63, 'mercado_envio': True, 'parcelas': 'parcelas Com Juros  Com MercadoPago',
                                  'local_vendedor': u'Sete Lagoas (Minas Gerais)', 'qtd_vendido': 231, 'anuncio_tipo': u'gold_special',
                                  'foto': 'xx', 'state': 'A', 'frete_gratis': False, 'preco': 14.49,
                                  'titulo': u'Afinador Digital Crom\xe1tico Clip Viol\xe3o Viola Guitarra Cavaco',
                                  'descricao_anuncio': u'Afinador Digital Crom\xe1tico Clip Viol\xe3o Viola Guitarra Cavaco',
                                  'qtd_visitas': 3654}}

        """
        result = super(mkp_utils, self)._mkputl_get_pesquisa_no_mkp(cr, uid, brw_anuncios)
        _str_codigos = []
        _hoje = self.pool.get('adm.utils').admutl_datetime_to_timezone(cr, uid, datetime.now(),
                                                                       formato='%Y-%m-%d')
        _dt_inicio = datetime.now() - timedelta(days=360)
        _dt_inicio = self.pool.get('adm.utils').admutl_datetime_to_timezone(cr, uid, _dt_inicio,
                                                                            formato='%Y-%m-%d')
        for brw_anuncio in brw_anuncios:
            if brw_anuncio.mkpanu_marketplace_id.mkpmkp_codigo == 'MerLiv':
                pesquisas = mkpMerLiv_pesquisar_anuncio(cr, uid, brw_anuncio.mkpanu_conta_id.id, _dt_inicio, _hoje)
                _str_codigos.append(brw_anuncio.mkpanu_codigo_anuncio)
        if _str_codigos: # Códigos de anuncios do M.L.
            pesquisas.registrar(_str_codigos)
            pesquisas.iniciar()
            while not pesquisas.terminou:
                res = pesquisas.retornar()
                if res:
                    for anun_id in res.keys():
                        _pes = res.get(anun_id)
                        result[anun_id] = _pes
        return result

    def mkputl_get_pesquisa_ml(self, cr, uid, dict_anuncios):
        """
        Função para buscar as pesquisas no site do Mercado Livre
        @param dict_anuncios: dicionario com id no erp e id no ml de anuncios a serem pesquisado
          ex.:{576: u'MLB887521819', 565: u'MLB872477007', 542: u'MLB851019359'}
        @return: dicionario que contem dicionario com o resultado da pesquisa
          Ex.: {u'MLB851019359': {'estoque': 63, 'mercado_envio': True, 'parcelas': 'parcelas Com Juros  Com MercadoPago',
                                  'local_vendedor': u'Sete Lagoas (Minas Gerais)', 'qtd_vendido': 231, 'anuncio_tipo': u'gold_special',
                                  'foto': 'xx', 'state': 'A', 'frete_gratis': False, 'preco': 14.49,
                                  'titulo': u'Afinador Digital Crom\xe1tico Clip Viol\xe3o Viola Guitarra Cavaco',
                                  'descricao_anuncio': u'Afinador Digital Crom\xe1tico Clip Viol\xe3o Viola Guitarra Cavaco',
                                  'qtd_visitas': 3654}}
        """
        res = {}
        if not dict_anuncios:
            return res
        brw_anuncios = self.pool.get('mkp.anuncios').browse(cr, uid, dict_anuncios.keys())
        res = self._mkputl_get_pesquisa_no_mkp(cr, uid, brw_anuncios)
        return res


    # Métodos já conferidos
    def _mkputl_pesquisar_pedido_mkp_merliv(self, cr, uid, conta_id, context=None):
        """
        Metodo chamado pelo cron para pesquisr pedidos no M.L.
        :param cr:
        :param uid:
        :param conta_id: id da conta no marketplace
        :param codigo_mkp: codigo de identificação do marketplace
        :param context:
        :return:
        """
        context = context and context.copy() or {}
        obj_est_ped_capa = self.pool.get('estoquepedidos.pedido.capa')
        for ped in self.pool.get('mkp.merliv').MkpMerLiv_pesquisar_anuncio(cr, uid, conta_id, context=context):
            _ped_externo = ped.get('id')
            _ped_ids = obj_est_ped_capa.search(cr, uid, [('pedcap_nro_pedido_externo', '=', _ped_externo), ('tipo', '=', 'V')], context=context)
            if not _ped_ids:  # Só importar qdo nao tiver o pedido na base do erpFmkpa
                self.mkputl_importar_um_pedido(cr, uid, ped, conta_id, context=context)
        self._logger.info('Fim de pesquisa de pedidos do M.L.')
        return True

    def mkputl_get_etiqueta_no_mkp(self, cr, uid, mkp_integrador, conta_id, pedido_ids, context=None):
        """
        Metodo para buscar etiqueta no marketplace, deve ser sobrescrito por cada marketplace
        :param cr:
        :param uid:
        :param mkp_integrador:
        :param conta_id:
        :param pedido_ids:
        :param context:
        :return: {status: True/False, 'mensagem': '', 'dados': ''}
        """
        context = context and context.copy() or {}
        if mkp_integrador != 'MerLiv':
            res = super(mkp_utils, self).mkputl_get_etiqueta_no_mkp(cr, uid, mkp_integrador, conta_id, pedido_ids, context=context)
            return res
        _ship_ids = []
        _rastreio_id_ped = False
        for i in self.pool.get('estoquepedidos.pedido.capa').read(cr, uid, pedido_ids,
                                                                  ['pedcap_mkp_shipping','pedcap_encomenda_id',
                                                                   'pedcap_conta_id'], context):
            _conta_id = i.get('pedcap_conta_id')[0]
            i.get('pedcap_mkp_shipping') and _ship_ids.append(i.get('pedcap_mkp_shipping'))
            if i.get('pedcap_encomenda_id'):
                _rastreio_id_ped = i.get('pedcap_encomenda_id')[0]

        arquivo, controle = self.pool.get('mkp.merliv').mkpMerLiv_get_etiqueta(cr, uid, _ship_ids, _conta_id, context)
        if not arquivo:
            return {'status': False, 'mensagem': _('Nenhuma etiqueta encontrada!'), 'dados': ''}

        printer = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque',
                                                                   ['estpar_impressora_termica', 'estpar_impressora_termica_servidor'],
                                                                   context=context)
        if printer:
            servidor = printer.get('estpar_impressora_termica_servidor')
            printer = printer.get('estpar_impressora_termica')
        else:
            return {'status': False, 'mensagem': _('Cadastrar impressora no parametro do "Estoque" na aba '
                                   '"Automacao"'), 'dados': ''}
        try:
            if servidor:
                subprocess.call(["lp", '-o raw', "-n1", '-h%s' % servidor, '-d%s' % printer, arquivo])
            else:
                subprocess.call(["lp", '-o raw', "-n1", '-d%s' % printer, arquivo])
        except Exception as e:
            return {'status': False, 'mensagem': _('Erro ao imprimir etiqueta de postagem %s') % e, 'dados': ''}
        _prt_nf = context.get('mkp_modelo_90', False)
        if _prt_nf:
            self._logger.info('lp -n1 -P3 -d%s %s' % (_prt_nf, controle))
            subprocess.call(["lp", "-n1", '-P3', '-d%s' % _prt_nf, controle])
        return {'status': True, 'mensagem': '', 'dados': ''}

