# -*- encoding: utf-8 -*-

import openerp.addons.web.http as http
import json
from .meli import Meli
from ..marketplace.control.utils import configuracao
import xmlrpclib, socket
from logging import getLogger
from SigUtils.sigerp import db_sig
from openerp.osv.fields import datetime as field_datetime
import sys

_logger = getLogger("Mercado Livre")

_senha = 'mkp_remoto_77813'


mlcon = Meli()


class sc(http.Controller):
    _cp_path = '/mkp_ml'


    @http.httprequest
    def teste(self, req, s_action=None, **kw):
        _logger.info('=============================== teste %s' % req)
        # return 'testado IP:%s' % req.httprequest.headers.environ.get('REMOTE_ADDR')
        # sys.exit(1)
        return 'Ok'

    @http.httprequest
    def authorize(self, req, s_action=None, **kw):
        _logger.info('=============================== Autorize %s' % req.params)
        _app_id = req.params.get('application_id')
        _tg_code = req.params.get('code')
        _user_id = _tg_code[_tg_code.find('-',3)+1:]
        _logger.info('Mercado Livre - Autorizando: %s' % _user_id)
        cfg = configuracao('marketplace_ml', _user_id)
        cfg.lerConfiguracao()
        # _server = str(cfg.server).replace('https', 'http')
        _server = str(cfg.server)
        _base = str(cfg.base)
        mlcon.redirect_url = cfg.redirect
        mlcon.seller = _user_id
        mlcon.client_id = _app_id
        mlcon.client_secret = cfg.secreto
        template = "<html><header>Retorno do ML</header><body>Nao consegui autorizar!<br>%s</body></html>" % str(req.params)
        if req.params.get('code'):
            if _server:
                sock_common = xmlrpclib.ServerProxy('%s/xmlrpc/common' % _server)
                socket.setdefaulttimeout(3)
                uid = sock_common.login(_base, 'mkp_remoto', _senha)
                sock = xmlrpclib.ServerProxy('%s/xmlrpc/object' % _server)
                for _conta_id in sock.execute(_base, uid, _senha, 'mkp.contas', 'search',
                                [('mkpcta_ml_user_id', '=', mlcon.seller)], 0, False, '', {'sig_force_company': True}):
                    dados_marketplace = sock.execute(_base, uid, _senha, 'mkp.contas', 'read', _conta_id, [])
                    mlcon.client_secret = dados_marketplace.get('mkpcta_ml_secret_key')
                    mlcon.code = req.params.get('code')
                    mlcon.authorize()
                    vals = {'mkpcta_ml_token': mlcon.access_token,
                            'mkpcta_ml_refresh_token': mlcon.refresh_token,
                            'mkpcta_ml_code': mlcon.code}
                    sock.execute(_base, uid, _senha, 'mkp.contas', 'write', _conta_id, vals)
                    # Será necessario definir como vai atualizar a base de dados, uma vez que neste ponto não existe um cursor
                    # verificar se vai ser arquivo de configuracao, parametros passados no link do autorize ou outra situacao
                    template = "<html><header>Retorno do ML</header><body>Token: %s<br>Code:%s<br>Refresh:%s</body></html>" % (mlcon.access_token, mlcon.code,mlcon.refresh_token)
            else:
                _logger.info('Não encontrei servidor no arquivo de ml.config para a aplicacao: %s') % str(_app_id)
        return template

    @http.httprequest
    def notifications(self, req, s_action=None, **kw):
        _logger.info('--------------------- notificacoes: %s ' % str(req.httprequest.data))
        dados_post = json.loads(req.httprequest.data)
        _app_id = unicode(dados_post.get('application_id'))
        _user_id = unicode(dados_post.get('user_id'))
        if _user_id:
            cfg_ml = configuracao('marketplace_ml', _user_id)
            cfg_ml.lerConfiguracao()
            mlcon.redirect_url = cfg_ml.redirect
            mlcon.client_id = _app_id
            mlcon.seller = _user_id
            mlcon.client_secret = cfg_ml.secreto
            mlcon.conta_id = cfg_ml.conta_id
            _base = cfg_ml.base
            cfg = configuracao('marketplace', _base)
            cfg.lerConfiguracao()
            _db_user = cfg.db_user
            _db_password = cfg.db_password
            _db_host = cfg.db_host
            _db_port = cfg.db_port
            arg_db = {}
            if _db_host:
                arg_db.update({'host': _db_host})
            else:
                arg_db.update({'host': 'localhost'})
            if _db_port:
                arg_db.update({'port': _db_port or '5431'})
            if _db_user:
                arg_db.update({'user': _db_user})
            if _db_password:
                arg_db.update({'pwd': _db_password})
            _db = db_sig(_base, **arg_db)
            _fields = ['id']
            _where = [('login', '=', 'mkp_remoto')]
            dados_users = _db.dbsSelect('res_users', _fields, _where)
            _uid = False
            if dados_users:
                _uid = dados_users[0].get('id')
                if _uid:
                    _db.uid = _uid
                    _where = [('mkpnot_resource', '=', dados_post.get('resource')),
                            ('mkpnot_loja', '=', _user_id)
                            ]
                    dados_not = _db.dbsSelect('mkp_notificacoes', ['id'], _where)
                    _not_id = False
                    if dados_not:
                        _not_id = dados_not[0].get('id')
                    ## Gravar as notificacoes
                    if _not_id:
                        vals = {
                            'mkpnot_attempts': '1',
                            'state': 'R',
                        }
                        where = [('id', '=', _not_id)]
                        x = _db.dbsUpdate('mkp_notificacoes', vals, where)
                        if x:
                            _db.conexao.commit()
                        else:
                            _db.conexao.roolback()
                    else:
                        vals = {
                            'mkpnot_conta_id': mlcon.conta_id,
                            'mkpnot_application': unicode(dados_post.get('application_id')) or False,
                            'mkpnot_resource': dados_post.get('resource') or False,
                            'mkpnot_loja': dados_post.get('user_id') or False,
                            'mkpnot_topic': dados_post.get('topic') or False,
                            'mkpnot_attempts': '1',
                            'state': 'R'
                        }
                        x = _db.dbsInsert('mkp_notificacoes', vals)
                        if not x:
                            _db.conexao.roolback()
                        else:
                            _db.conexao.commit()
                    _db.conexao.close()
                    return 'OK'  # nunca retorne booleano, vai dar erro de https
            _db.conexao.close()
        _logger.info('Nao consegui pegar o id da aplicacao no Mkp M.L.')
        return  'Nao'# nunca retorne booleano, vai dar erro de https


"""
1 - Acessa https://auth.mercadolibre.com.ar/authorization?response_type=code&client_id="& ClientId & "&redirect_uri="
2 - Esta URL vai retornar para a url do parâmetro redirect_uri com um parâmetro chamado CODE
3 - Fazer um post para /oauth/token?grant_type=authorization_code&client_id={client_id}&client_secret={client_secret}&code={code}&redirect_uri={redirect_uri}" com o CODE recebido
4 - este post vai retornar um json com access_token e refresh_token. Estes dois dados devem ser salvos no banco de dados

    """