# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################
#
from openerp.osv import osv


class mkp_anuncios(osv.Model):
    _name = 'mkp.anuncios'
    _inherit = 'mkp.anuncios'

    def mkpanu_enviar_dados_fiscais(self, cr, uid, brw_anuncio, context=None):
        def _mlanu_get_dados_fiscais():
            _company_id = _spg('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
            _custos_prod = _spg('estoque.preco.custo').get_custos_do_dia(cr, uid,
                                                                                  [brw_anuncio.mkpanu_produto_id.id],
                                                                                  epc_company_id=_company_id,
                                                                                  context=context)
            _custos = 0.0
            for key in _custos_prod.keys():
                _custos += _custos_prod.get(key).get('estprc_custo_medio_contabil') / 2
                break
            _ean = ''
            # for x in brw_anuncio.mkpanu_produto_id.automacao_ids:
            for x in brw_grade.codigo_barra_ids:
                _ean = x.codigo_barra
            dados_fiscais = {
                'sku': '%s-%s' % (brw_anuncio.mkpanu_produto_id.codigo, brw_grade.grade),
                'title': brw_anuncio.mkpanu_title,
                'type': 'single',
                'cost': _custos,
                'tax_information': {
                    'ncm': brw_anuncio.mkpanu_produto_id.ncm_id.codigo.replace('.',''),
                    'origin_type': 'reseller',
                    'origin_detail': brw_anuncio.mkpanu_produto_id.origem_mercadoria,
                    'tax_rule_id': '',
                    'cest': brw_anuncio.mkpanu_produto_id.estpro_cest_id.fiscest_codigo,
                    'ean': _ean,
                },
            }
            company = _spg('res.users')._get_company(cr, uid)
            brw_company = _spg('res.company').browse(cr, uid, company, context=context)
            if brw_company.rescon_pessoa_id.admpes_jur_regime_tributario == 'S':  # simples Nacional
                for brw_trib in brw_anuncio.mkpanu_produto_id.tributacao_ids:
                    if brw_trib.tipo_tributacao != 'T':
                        continue
                    if brw_trib.encargo_id.sigla != 'ICMS':
                        continue
                    _csosn = brw_trib.cst_id.fiscst_csosn_nao_contribuinte_id.codigo
                    dados_fiscais['tax_information']['csosn'] = _csosn
                    break
            return dados_fiscais

        context = context and context.copy() or {}
        _spg = self.pool.get
        res = super(mkp_anuncios, self).mkpanu_enviar_dados_fiscais(cr, uid, brw_anuncio, context=context)
        if brw_anuncio.mkpanu_marketplace_integrador == 'MerLiv':
            _conta_id = brw_anuncio.mkpanu_conta_id.id
            for brw_grade in brw_anuncio.mkpanu_produto_id.produto_grade_ids:
                _sku = '%s-%s' % (brw_anuncio.mkpanu_produto_id.codigo, brw_grade.grade)
                dados_fiscais = _spg('mkp.merliv').mkpMerLiv_get_dados_fiscais(cr, uid, _sku, _conta_id, context=context)
                if not dados_fiscais:
                    dados_fiscais = _mlanu_get_dados_fiscais()
                    res = _spg('mkp.merliv').mkpMerLiv_set_dados_fiscais(cr, uid, False, _conta_id, dados_fiscais)
                else:
                    dados_fiscais = _mlanu_get_dados_fiscais()
                    dados_fiscais.pop('sku')
                    res = _spg('mkp.merliv').mkpMerLiv_set_dados_fiscais(cr, uid, _sku, _conta_id, dados_fiscais)
        return res

    def mkpanu_get_url_manutencao(self, cr, uid, ids, codigo_anuncio, codigo_mkp, context=None):
        context = context and context.copy() or {}
        _url = super(mkp_anuncios, self).mkpanu_get_url_manutencao(cr, uid, ids, codigo_anuncio, codigo_mkp, context=context)
        if codigo_mkp == 'MerLiv':
            _url = 'https://www.mercadolivre.com.br/publicaciones/%s/modificar' % codigo_anuncio
        return _url

    def mkpanu_atualizar_anuncio_mkp(self, cr, uid, obj_id, code_mkp, context=None):
        context = context and context.copy() or {}
        res = super(mkp_anuncios, self).mkpanu_atualizar_anuncio_mkp(cr, uid, obj_id, code_mkp, context=context)
        if code_mkp == 'MerLiv':
            res = self.pool.get('mkp.utils').mkputl_atualizar_anuncio_merliv(cr, uid, obj_id, context=context)
        return res

    def mkpanu_atualizar_preco_mkp(self, cr, uid, obj_id, code_mkp, context=None):
        context = context and context.copy() or {}
        res = super(mkp_anuncios, self).mkpanu_atualizar_preco_mkp(cr, uid, obj_id, code_mkp, context=context)
        if code_mkp == 'MerLiv':
            res = self.pool.get('mkp.merliv').mkpMerLiv_set_preco(cr, uid, obj_id, context=context)
        return res

    def mkpanu_atualizar_saldo(self, cr, uid, id, conta_id, mkp_code, context=None):
        context = context and context.copy() or {}
        res = super(mkp_anuncios, self).mkpanu_atualizar_saldo(cr, uid, id, conta_id, mkp_code, context=context)
        if mkp_code == 'MerLiv':
            res = self.pool.get('mkp.merliv').mkpMerLiv_set_saldo(cr, uid, id, context=context)
        return res

    # Não tem mais funcao para carregar
    # def _mkpanu_carregar_um_anuncio(self, cr, uid, browse_anuncio, context=None):
    #     super(mkp_anuncios, self)._mkpanu_carregar_um_anuncio(cr, uid, browse_anuncio, context=None)
    #     if browse_anuncio.mkpanu_marketplace_id.mkpmkp_codigo == 'MerLiv':
    #         _preview = self._mkpanu_get_anuncio_preview(cr, uid, [browse_anuncio.id], context=context)
    #         self.write(cr, uid, browse_anuncio.id, vals, context=context)
    #     return True
