# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
import json
import logging
from openerp import SUPERUSER_ID
from openerp.tools.translate import _
from SigUtils.sigerp import db_sig


class mkp_categorias(osv.Model):
    _inherit = 'mkp.categorias'
    _logger = logging.getLogger(_inherit)
    def __init__(self, pool, cr):
        super(mkp_categorias, self).__init__(pool, cr)
        self._mkp_categ_default_company.append('MerLiv')

    # comentado para verificar se realmente precisa, porque tem no marketplace
    def mkpcat_buscar_atributos_no_mkp(self, cr, uid, ids, mkp_integrador, mkp_categ_code, context=None):
        context = context and context.copy() or {}
        _spg = self.pool.get
        res = super(mkp_categorias, self).mkpcat_buscar_atributos_no_mkp(cr, uid,  ids, mkp_integrador, mkp_categ_code, context=context)
        if mkp_integrador != 'MerLiv':
            return res
        xml_str = self.pool.get('mkp.merliv').mkpMerLiv_get_categorias_atributos(cr, uid, mkp_categ_code, context=context)
        _atributos = json.loads(xml_str.content)
        vals = {}
        if _atributos:
            _attrs_ids = _spg('mkp.categorias.atributos').search(cr, uid, [('mkpcatatr_categoria_id', '=', ids[0])], context=context)
            if _attrs_ids:
                _spg('mkp.categorias.atributos').unlink(cr, uid, _attrs_ids, context=context)
        for _atributo in _atributos.get('groups'):
            for _componente in _atributo.get('components'):
                for _attrib in _componente.get('attributes'):
                    if _atributo.get('id') == 'MAIN':
                        vals['mkpcatatr_tipo'] = 'P'
                    else:
                        vals['mkpcatatr_tipo'] = 'S'
                    vals['mkpcatatr_categoria_id'] = ids[0]
                    vals['mkpcatatr_label'] = _attrib.get('name')
                    vals['mkpcatatr_tipo_dados'] = _attrib.get('value_type')
                    _attr_id = _spg('mkp.categorias.atributos').create(cr, uid, vals, context=context)
                    for _tag in _attrib.get('tags'):
                        _spg('mkp.categorias.atributos.tags').create(cr, uid, {'mkpcatatrt_atributo_id': _attr_id, 'name': _tag}, context=context)
                    default_unit_id = _componente.get('default_unit_id', False)
                    _units = _attrib.get('units', False)
                    if _units:
                        for _unit in _attrib.get('units', False):
                            vals_units = {
                                'mkpcatatru_atributo_id': _attr_id,
                                'mkpcatatru_id_mkp': _unit.get('id'),
                                'name': _unit.get('name')
                            }
                            if default_unit_id:
                                vals_units['mkpcatatru_default'] = True
                            _spg('mkp.categorias.atributos.unidades').create(cr, uid, vals_units, context=context)
        return True


    def mkpcat_pesquisar_categorias_no_mkp(self, cr, uid, mkp_ids, context=None):
        def _mkpcat_atualizar_categoria():
            vals = {}
            vals['mkpcat_marketplace_id'] = mkp_id
            vals['mkpcat_codigo'] = _categoria.get('id')
            vals['name'] = _categoria.get('name').encode('utf-8', 'ignore').replace("'", '')
            vals['name'] = self.pool.get('adm.utils').admutl_remover_acentuacao(cr, uid, vals['name'])
            if _categoria.get('settings'):
                if _categoria.get('settings').get('item_conditions'):
                    if 'used' in _categoria.get('settings').get('item_conditions'):
                        vals['mkpcat_aceita_produtos_usados'] = True
                    if 'new' in _categoria.get('settings').get('item_conditions'):
                        vals['mkpcat_aceita_produtos_novos'] = True
                    if _categoria.get('settings').get('listing_allowed'):
                        vals['mkpcat_permite_venda'] = True
                    if 'me2' in str(_categoria.get('settings').get('shipping_modes')):
                        vals['mkpcat_mercado_envios'] = True
                if _categoria.get('path_from_root') and len(_categoria.get('path_from_root')) > 1:
                    _pai_codigo = _categoria.get('path_from_root')[-2:-1][0].get('id')
                    _pai_ids = _db_sig.dbsSelect('mkp_categorias', ['id'], [('mkpcat_codigo', '=', _pai_codigo)])
                    if _pai_ids:
                        vals['parent_id'] = _pai_ids[0].get('id')
                    else:
                        _categorias_pendentes.append(_categoria)
            _categ_ids = _db_sig.dbsSelect('mkp_categorias', ['id'], [('mkpcat_codigo', '=', _categoria.get('id'))])
            vals['mkpcat_atualizado'] = True
            vals['active'] = True
            if _categ_ids:
                _db_sig.dbsUpdate('mkp_categorias', vals, [('mkpcat_codigo', '=', str(_categoria.get('id')))])
            else:
                vals['company_id'] = _company
                _db_sig.dbsInsert('mkp_categorias', vals)
            _db_sig.conexao.commit()
            return True

        super(mkp_categorias, self).mkpcat_pesquisar_categorias_no_mkp(cr, uid, mkp_ids, context=None)
        _db_sig = db_sig(self.pool.db_name)
        _company = context.get('sig_force_company') or self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid)
        _categorias_pendentes = []
        _atualizado = []
        _imp = False  # Se True, vai executar os prints
        MerLiv_id = self.pool.get('mkp.marketplaces').mkpmkp_get_id(cr, uid, 'MerLiv', context=None)
        if not MerLiv_id in mkp_ids:
            return True
        if _imp:
            print('Buscando categorias no Merliv.....')
        xml_str = self.pool.get('mkp.merliv').mkpMerLiv_get_categorias(cr, uid, context=context)
        _md5 = xml_str.headers.get('X-Content-MD5')
        if _imp:
            print('Terminado a busca!')
        try:
            dados_md5 = self.pool.get('ir.config_parameter').get_param(cr, uid, 'mkp_categorias_md5')
            dados_md5 = dados_md5.split(':')
        except:
            dados_md5 = False
        if dados_md5:
            _md5_old = dados_md5[0]
            if _md5_old == _md5: # Não houve alteracao nas  categorias
                return True
        self.pool.get('ir.config_parameter').set_param(cr,SUPERUSER_ID, 'mkp_categorias_md5', _md5, context={})
        mkp_id = self.pool.get('mkp.marketplaces').mkpmkp_get_id(cr, uid, 'MerLiv', context=context)
        _categoria_ids = self.search(cr, uid, [('mkpcat_marketplace_id', '=', mkp_id)], context=context)
        if _imp:
            print('Marcando como nao atualizado %s registros' % len(_categoria_ids))
        _db_sig.dbsUpdate('mkp_categorias', {'mkpcat_atualizado': False}, [('id', 'in', tuple(_categoria_ids))])
        _d_categ = json.loads(xml_str.content)
        if _imp:
            print('for de %s' % len(_d_categ.keys()))
        i = 0
        for idx in _d_categ.keys():
            i += 1
            if _imp:
                print('Sequencia For: %s de %s' % (i, len(_d_categ.keys())))
            _categoria = _d_categ.get(idx)
            _mkpcat_atualizar_categoria()
            _atualizado.append(_categoria.get('id'))
            if i % 10 == 0:
                cr.commit()
        if _imp:
            print("fim do for")
        # Reprocessar as categorias pendentes
        if _imp:
            print('while de %s' % len(_categorias_pendentes))
        i = 0
        while _categorias_pendentes:
            i += 1
            if _imp:
                print('Sequencia While: %s de %s' % (i, len(_categorias_pendentes)))
            _novas_pendencias = _categorias_pendentes
            _categorias_pendentes = []
            a = 0
            for _categoria in _novas_pendencias:
                a +=1
                if _imp:
                    print('Sequencia While: %s de %s Pendencias %s de %s' % (i, len(_categorias_pendentes), a, len(_novas_pendencias)))
                _mkpcat_atualizar_categoria()
        # Inativar as que foram retiradas do M.L.
        if _imp:
            print('Fim do while')
        _db_sig.dbsUpdate('mkp_categorias', {'active': False}, [('mkpcat_marketplace_id', '=', mkp_id),
                                                                ('mkpcat_atualizado', '=', False)])
        _db_sig.conexao.close()
        return True

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        obj_marketplace = self.pool.get('mkp.marketplaces')
        dados_mmkp = obj_marketplace.read(cr, uid, vals.get('mkpcat_marketplace_id'), ['mkpmkp_codigo'], context=context)
        if dados_mmkp and dados_mmkp.get('mkpmkp_codigo') == 'MerLiv':
            if not (vals and vals.get('mkpcat_codigo', False)):
                raise osv.except_osv(_('Atencao'), _('Faltou o codigo da categoria!'))
        res = super(mkp_categorias, self).create(cr, uid, vals, context=context)
        return res



