# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from pynfe.nfe.manual_600.consrecinfe import ProcNFe
from pynfe.nfce.manual_600.retenvcancnfce import ProcEventoNFe
from openerp.osv import osv
from datetime import datetime
import logging


class mkp_notificacoes(osv.Model):
    _inherit = "mkp.notificacoes"
    _logger = logging.getLogger(_inherit)

    def _mkpnot_get_itens_ml(self, cr, uid, dados_notificacao, context=None):
        context = context and context.copy() or {}
        _anuncio_orig = dados_notificacao.get('mkpnot_resource').split('/')[2]
        _obj_anuncio = self.pool.get('mkp.anuncios')
        context.update({'sig_force_company': True})
        dados_anuncioMerLiv = self.pool.get('mkp.merliv').mkpMerLiv_get_anuncio(
                                            cr, uid, dados_notificacao.get('mkpnot_conta_id'), _anuncio_orig, context=None)
        _anuncio_ids = _obj_anuncio.search(cr, uid, [('mkpanu_codigo_anuncio', '=', _anuncio_orig)], context=context)
        _anuncio_relacionado = []
        if dados_anuncioMerLiv.get('item_relations'):
            for i in dados_anuncioMerLiv.get('item_relations'):
                _anuncio_relacionado.append(i.get('id'))
        if not _anuncio_ids and _anuncio_relacionado:
            for a in _anuncio_relacionado:
                _anuncio_ids = _obj_anuncio.search(cr, uid, [('mkpanu_codigo_anuncio', '=', a)], context=context)
                if not _anuncio_ids:
                    continue
                _anuncio_relacionado.append(_anuncio_orig)
                break
        if _anuncio_ids:
            dados_anuncio = _obj_anuncio.read(cr, uid, _anuncio_ids, ['id', 'mkpanu_estado', 'mkpanu_valor_promocao',
                                                                      'mkpanu_valor', 'mkpanu_frete',
                                                                      'mkpanu_codigo_anuncio', 'mkpanu_conta_id'],
                                              context=context)
            if dados_anuncio:
                dados_anuncio = dados_anuncio[0]
                vals = {
                    'mkpanu_necessita_atualizar': False,
                    'mkpanu_qtd_vendido': dados_anuncioMerLiv.get('sold_quantity')
                }
                # custo do frete
                if dados_anuncio.get('mkpanu_frete') != 'CC':
                    vals['mkpanu_valor_frete'] = \
                        self.pool.get('mkp.merliv').mkpMerLiv_get_custo_frete(cr, uid,
                                                                              dados_anuncio.get('mkpanu_codigo_anuncio'),
                                                                              dados_anuncio.get('mkpanu_conta_id')[0]
                                                                              )
                if dados_anuncioMerLiv.get('shipping').get('logistic_type') == 'fulfillment':
                    vals['mkpanu_mercadofull'] = True
                    vals['mkpanu_saldo'] = dados_anuncioMerLiv.get('available_quantity')
                else:
                    vals['mkpanu_mercadofull'] = False
                vals['mkpanu_estado_mkp'] = dados_anuncioMerLiv.get('status')
                if dados_anuncioMerLiv.get('status') in ('under_review', 'closed'):
                    vals['mkpanu_estado'] = 'C'
                elif dados_anuncioMerLiv.get('status') == 'paused':
                    if dados_anuncioMerLiv.get('sub_status') != 'out_of_stock':
                        vals['mkpanu_estado'] = 'P'
                elif dados_anuncioMerLiv.get('status') in ('active',):
                    vals['mkpanu_estado'] = 'A'
                canais = dados_anuncioMerLiv.get('channels')
                if 'marketplace' in canais:
                    vals['mkpanu_mercado_livre'] = True
                else:
                    vals['mkpanu_mercado_livre'] = False
                if 'mshops' in canais:
                    vals['mkpanu_mercado_shop'] = True
                else:
                    vals['mkpanu_mercado_shop'] = False
                if dados_anuncioMerLiv.get('shipping').get('logistic_type') == 'fulfillment':
                    vals['mkpanu_saldo'] = dados_anuncioMerLiv.get('available_quantity')
                _obj_anuncio.write(cr, uid, dados_anuncio.get('id'), vals, context=context)
                self.pool.get('mkp.anuncios.relacionamento').mkpanur_criar_relacionamento(cr, uid, _anuncio_orig,
                                                                                  _anuncio_relacionado, context=context)
                return True
        self._logger.info('Anuncio nao localizado!')
        return False

    def _mkpnot_get_messages_ml(self, cr, uid, dados_notificacao, context=None):
        _spg = self.pool.get
        vals = {}
        _mensagem = dados_notificacao.get('mkpnot_resource')
        dic_mensagem = _spg('mkp.merliv').mkpMerLiv_get_mensagem(cr, uid, _mensagem,
                                                                 dados_notificacao.get('mkpnot_conta_id'))
        if dic_mensagem.get('status') == 404:  # mensagem excluida
            return True
        conta_id = dados_notificacao.get('mkpnot_conta_id')
        companys = []
        dados_conta = _spg('mkp.contas').read(cr, uid, conta_id, ['mkpcta_fulfillment_empresa_id', 'company_id',
                                                                  'mkpcta_ml_user_id'],
                                              context=context, load='_classic_write')
        if dados_conta.get('company_id') and dados_conta.get('company_id') not in companys:
            companys.append(dados_conta.get('company_id'))
        if dados_conta.get('mkpcta_fulfillment_empresa_id') and \
                dados_conta.get('mkpcta_fulfillment_empresa_id') not in companys:
            companys.append(dados_conta.get('mkpcta_fulfillment_empresa_id'))
        if dic_mensagem.get('messages'):
            for _mensagem in dic_mensagem.get('messages'):
                try:
                    _order_ml = None
                    for _resource in _mensagem.get('message_resources'):
                        if _resource.get('name') == 'packs':
                            _order_ml = _resource.get('id')
                            break
                    if not _order_ml:
                        continue
                    args = ['|', ('pedcap_nro_pedido_externo', '=', _order_ml),
                            ('pedcap_mkp_carrinho_compras', '=', _order_ml),
                            ('tipo', '=', 'V')]
                    if companys:
                        args.append(('company_id', 'in', companys))
                        context['sig_force_company'] = True
                    _pedido_ids = _spg('estoquepedidos.pedido.capa').search(cr, uid, args, context=context)
                    context.pop('sig_force_company')
                    if _pedido_ids:
                        vals['mkpmen_conta_id'] = dados_notificacao.get('mkpnot_conta_id')
                        vals['mkpmen_codigo_mkp'] = _mensagem.get('id')
                        vals['mkpmen_data'] = _mensagem.get('message_date').get('available')
                        vals['mkpmen_data_recebimento'] = _mensagem.get('message_date').get('received')
                        vals['mkpmen_data_leitura'] = _mensagem.get('message_date').get('read')
                        vals['mkpmen_pedido_mkp'] = _order_ml
                        vals['mkpmen_pedido_id'] = _pedido_ids[0]
                        vals['name'] = _mensagem.get('text')
                    else:
                        self._logger.info('Pedido nao localizado na nossa base! Pedido: %s' % _order_ml)
                        return False
                    _mensagem_ids = _spg('mkp.mensagens').search(cr, uid,
                                                                 [('mkpmen_codigo_mkp', '=', _mensagem.get('id'))],
                                                                 context=context)
                    _from = _mensagem.get('from').get('user_id')
                    if _from == dados_conta.get('mkpcta_ml_user_id'):
                        vals['mkpmen_dono'] = 'L'
                    else:
                        vals['mkpmen_dono'] = 'C'
                    if _mensagem_ids:
                        _spg('mkp.mensagens').write(cr, uid, _mensagem_ids, vals, context=context)
                    else:
                        _spg('mkp.mensagens').create(cr, uid, vals, context=context)
                except Exception as e:
                    self._logger.info('Erro no try!')
                    return False
        else:
            try:
                _order_ml = dic_mensagem.get('resource_id')
                if not _order_ml:
                    return False
                args = ['|', ('pedcap_nro_pedido_externo', '=', _order_ml),
                        ('pedcap_mkp_carrinho_compras', '=', _order_ml),
                        ('tipo', '=', 'V')]
                if companys:
                    args.append(('company_id', 'in', companys))
                    context['sig_force_company'] = True
                _pedido_ids = _spg('estoquepedidos.pedido.capa').search(cr, uid, args, context=context)
                context.pop('sig_force_company')
                if _pedido_ids:
                    vals['mkpmen_conta_id'] = dados_notificacao.get('mkpnot_conta_id')
                    vals['mkpmen_codigo_mkp'] = _mensagem
                    vals['mkpmen_data'] = dic_mensagem.get('date')
                    vals['mkpmen_data_recebimento'] = dic_mensagem.get('date_received')
                    vals['mkpmen_data_leitura'] = dic_mensagem.get('date_read')
                    vals['mkpmen_pedido_mkp'] = _order_ml
                    vals['mkpmen_pedido_id'] = _pedido_ids[0]
                    vals['name'] = dic_mensagem.get('text')
                else:
                    self._logger.info('Pedido nao localizado na nossa base! Pedido: %s' % _order_ml)
                    return False
                _mensagem_ids = _spg('mkp.mensagens').search(cr, uid, [('mkpmen_codigo_mkp', '=', _mensagem)],
                                                      context=context)
                _from = dic_mensagem.get('from').get('user_id')
                if _from == dados_conta.get('mkpcta_ml_user_id'):
                    vals['mkpmen_dono'] = 'L'
                else:
                    vals['mkpmen_dono'] = 'C'
                if _mensagem_ids:
                    _spg('mkp.mensagens').write(cr, uid, _mensagem_ids, vals, context=context)
                else:
                    _spg('mkp.mensagens').create(cr, uid, vals, context=context)
            except Exception as e:
                self._logger.info('Erro no try!')
                return False
        return True

    def _mkpnot_get_questions_ml(self, cr, uid, dados_notificacao, context=None):
        dict_status = {
            'ANSWERED': 'R',
            'UNANSWERED': 'N',
            'CLOSED_UNANSWERED': 'E',
            'UNDER_REVIEW': 'S',
        }
        vals = {}
        _obj_perguntas = self.pool.get('mkp.perguntas')
        _pergunta = dados_notificacao.get('mkpnot_resource').split('/')[2]
        dic_pergunta = self.pool.get('mkp.merliv').mkpMerLiv_get_pergunta(cr, uid, _pergunta, dados_notificacao.get('mkpnot_conta_id'))
        if dic_pergunta.get('status') == 404:  # Pergunta excluida
            return True
        _cod_anuncio_ml = dic_pergunta.get('item_id', False)
        if _cod_anuncio_ml:
            _obj_anuncio = self.pool.get('mkp.anuncios')
            _anuncio_ids = _obj_anuncio.search(cr, uid, [('mkpanu_codigo_anuncio', '=', _cod_anuncio_ml)],
                                               context=context)
            if _anuncio_ids:
                vals['mkpper_anuncio_id'] = _anuncio_ids[0]
                _dados_anuncio = _obj_anuncio.read(cr, uid, _anuncio_ids[0], ['mkpanu_produto_id'], context=context)
                _produto_id = _dados_anuncio.get('mkpanu_produto_id', False)
                if _produto_id:
                    vals['mkpper_produto_id'] = _produto_id[0]
            else: # Se não tem anuncio, não gravar a pergunta
                return True
        else:
            self._logger.info('Anuncio nao encontrado na pergunta!')
            return False
        vals['mkpper_codigo_mkp'] = dic_pergunta.get('id')
        _pergunta_ids = _obj_perguntas.search(cr, uid, [('mkpper_codigo_mkp', '=', vals.get('mkpper_codigo_mkp'))],
                                              context=context)
        vals['name'] = dic_pergunta.get('text')
        _resposta = dic_pergunta.get('answer')
        if _resposta:
            _resposta = _resposta.get('text', False)
            if _resposta:
                vals['mkpper_resposta'] = _resposta
        vals['mkpper_data'] = dic_pergunta.get('date_created')
        vals['mkpper_cidade'] = ''
        vals['state'] = dict_status.get(dic_pergunta.get('status'), 'N')
        conta_id = dados_notificacao.get('mkpnot_conta_id')
        vals['mkpper_conta_id'] = conta_id
        _from = dic_pergunta.get('from', False)
        if _from:
            _user = _from.get('id')
            dic_user = self.pool.get('mkp.merliv').mkpMerLiv_get_usuario(cr, uid, _user, conta_id)
            vals['ml_apelido'] = dic_user.get('nickname', '')
            if dic_user.get('address') and \
               dic_user.get('address').get('city') and \
               dic_user.get('address').get('state'):
                vals['mkpper_cidade'] = "%s/%s" % (dic_user.get('address').get('city').strip(),
                                                   dic_user.get('address').get('state').strip().strip('BR-'))
        if _pergunta_ids:
            _obj_perguntas.write(cr, uid, _pergunta_ids, vals, context=context)
        else:
            _obj_perguntas.create(cr, uid, vals, context=context)
        return True

    def _mkpnot_get_orders_ml(self, cr, uid, dados_notificacao, context=None):
        _order = dados_notificacao.get('mkpnot_resource').split('/')[2]
        _conta_id = dados_notificacao.get('mkpnot_conta_id')
        _dados_conta = self.pool.get('mkp.contas').read(cr, uid, _conta_id, [], context=context)
        _obj_pedido_capa = self.pool.get('estoquepedidos.pedido.capa')
        dados = self.pool.get('mkp.merliv').mkpMerLiv_get_order(cr, uid, _order, _conta_id, context=context)
        if dados.get('status') == False:
            return dados
        try:  # Se não conseguir importar o pedido, ignore e continue o processo das notificacoes
            _ped_id = self.pool.get('mkp.utils').mkputl_importar_um_pedido(cr, uid, dados, _conta_id, context=context)
            if not _ped_id:
                self._logger.info('Erro na importacao do pedido!')
                return False
        except Exception as e:
            self._logger.info('Erro no try! Erro: %s' % e)
            return False
        if dados.get('mercadofull'): # Para full, nao importar encomendas
            return True
        sql = 'select pedcap_encomenda_id, pessoa_id from estoquepedidos_pedido_capa where id = %d' % _ped_id
        cr.execute(sql)
        dados_pedido = cr.fetchone()
        if not (dados_pedido and dados_pedido[0]):  # nao tem o codigo de rastreio
            if dados.get('shipping') and dados.get('shipping').get('id'):
                _ship_id = dados.get('shipping') and dados.get('shipping').get('id')
                _encomenda = self.pool.get('mkp.utils').mkputl_get_tracking_number(cr, uid, _ship_id, _conta_id)
                try:
                    _servico_id = _dados_conta.get('mkpcta_rastreamento_servico_id')[0]
                except:
                    _servico_id = False
                if _encomenda and len(_encomenda) == 13 and _encomenda.endswith('BR'):
                    sql = "select id from rastreio_encomendas where name = '%s'" % _encomenda
                    cr.execute(sql)
                    _encomenda_id = cr.fetchone()
                    if _encomenda_id:
                        _encomenda_id = _encomenda_id[0]
                    else:
                        vals = dict(
                            name=_encomenda,
                            rasenc_pedido_id=_ped_id,
                            rasenc_pessoa_id=dados_pedido[1],
                            rasenc_compra_venda='V',
                        )
                        if _servico_id:
                            vals['rasenc_servicos_ids']=[(4, _servico_id,)]
                        _encomenda_id = self.pool.get('rastreio.encomendas').create(cr, uid, vals, context=context)
                    _obj_pedido_capa.write(cr, uid, [_ped_id], {'pedcap_encomenda_id': _encomenda_id},
                                           context=context)
        return True

    def _mkpnot_get_shipments_ml(self, cr, uid, dados_notificacao, context=None):
        _spg = self.pool.get
        _shipment = dados_notificacao.get('mkpnot_resource').split('/')[2]
        _conta_id = dados_notificacao.get('mkpnot_conta_id')
        _dados_ship = _spg('mkp.merliv').mkpMerLiv_get_shipment(cr, uid, _shipment, _conta_id, context=context)
        _track_number = _dados_ship.get('tracking_number')
        if not _track_number or len(_track_number) != 13 or _track_number[-2:] != 'BR':
            return True
        _pedido_ids = _spg('estoquepedidos.pedido.capa').search(cr, uid, [('pedcap_mkp_shipping', '=', _shipment)],
                                                  context=context)
        if not _pedido_ids:
            return False
        _ped_id = _pedido_ids[0]
        fields = ['pedcap_encomenda_id', 'pessoa_id']
        dados_pedido =  _spg('estoquepedidos.pedido.capa').read(cr, uid, _ped_id, fields, context=context)
        if isinstance(dados_pedido, list):
            dados_pedido = dados_pedido[0]
        if dados_pedido.get('pedcap_encomenda_id') and dados_pedido.get('pedcap_encomenda_id')[1] == _track_number:
            return True
        sql = "select id from rastreio_servicos where rassvr_codigo='CorBra'"
        cr.execute(sql)
        _servico_id = cr.fetchone()[0]
        sql = "select id from rastreio_encomendas where name = '%s'" % _track_number
        cr.execute(sql)
        _encomenda_id = cr.fetchone()
        if _encomenda_id:
            _encomenda_id = _encomenda_id[0]
        else:
            vals = dict(
                name = _track_number,
                rasenc_pedido_id = _ped_id,
                rasenc_pessoa_id = dados_pedido.get('pessoa_id')[0],
                rasenc_compra_venda = 'V',
                rasenc_servicos_ids = [(4, _servico_id, )]
            )
            _encomenda_id = _spg('rastreio.encomendas').create(cr, uid, vals, context=context)
        _spg('estoquepedidos.pedido.capa').write(cr, uid, [_ped_id], {'pedcap_encomenda_id':_encomenda_id}, context=context)
        return True

    def _mkpnot_get_invoice_ml(self, cr, uid, dados_notificacao, context=None):
        def _get_modelo_nf_serie_90():
            _modelo_ids = self.pool.get('fiscal.modelo.nf').search(cr, uid,
                                                                   [('fismnf_codigo', '>', '89')], context=context)
            if not _modelo_ids:
                return False
            _mod_nf_ser = self.pool.get('fiscal_modelo_nf_series').search(cr, uid,
                                                                          [('modelo_nf_id', 'in', _modelo_ids)],
                                                                          context=context, limit=1)
            if _mod_nf_ser:
                return _mod_nf_ser[0]
            else:
                return False
        context = context and context.copy() or {}
        _spg = self.pool.get
        _recurso = dados_notificacao.get('mkpnot_resource')
        _conta_id = dados_notificacao.get('mkpnot_conta_id')
        dados_conta = _spg('mkp.contas').read(cr, uid, _conta_id, [], context=context)
        dados = _spg('mkp.merliv').mkpMerLiv_get_invoice(cr, uid, _recurso, _conta_id, context=context)
        if not dados:
            return {'status': False, 'mensagem': 'Nao consegui pegar os dados da nota no MKP!'}
        _nfs_referenciadas_ids = []
        if dados.get('attributes').get('reference_invoices'):
            for iv in dados.get('attributes').get('reference_invoices'):
                _nf_ids = self.pool.get('fiscal.nf.capa').search(cr, uid,
                                                         [('nfe_chave_acesso', '=', iv.get('invoice_key'))],
                                                                 context=context)
                if _nf_ids:
                    _nfs_referenciadas_ids.extend(_nf_ids)
                    continue
                return {'status': False, 'mensagem': 'NF nao encontrada chave: %s invoice: %s' %
                                                     (iv.get('invoice_key'), iv.get('id'))}
        _transaction_type = dados.get('fiscal_data').get('transaction_type')
        _fulfillment = dados.get('shipment').get('logistic_type') == 'fulfillment'
        _nro_nf = dados.get('invoice_number')
        _cnpj_emitente = dados.get('issuer').get('identifications').get('cnpj')
        _uf_emitente = dados.get('issuer').get('address').get('state')
        _uf_destinatario = dados.get('recipient').get('address').get('state')
        _status_nf = dados.get('status')
        if _status_nf not in ('authorized', 'canceled', 'disabled', 'forbidden'):
            return {'status': False, 'mensagem': 'Nf %s nao esta autorizada: Status: %s invoice: %s!' %
                                                 (_nro_nf, _status_nf,dados.get('id'))}
        if _status_nf == 'canceled':
            nfe_canc = ProcEventoNFe()
            nfe_canc.xml = str(dados.get('xml'))
        else:
            nfe = ProcNFe()
            nfe.xml = dados.get('xml').encode('utf-8')
        _pessoa_ids = _spg('adm.pessoa').search(cr, uid, [('cpf_cnpj', '=', _cnpj_emitente)], context=context)
        if not _pessoa_ids:
            return {'status': False, 'mensagem': 'Cnpj nao cadastrado! cnpj: %s' % _cnpj_emitente}
        _pessoa_id = _pessoa_ids[0]
        company_ids = _spg('res.company').search(cr, uid, [('rescon_pessoa_id', '=', _pessoa_id)], context=context)
        if not company_ids:
            return {'status': False, 'mensagem': 'Empresa nao cadastrada para a pessoa_id: %s' % _pessoa_id}
        company_id = company_ids[0]
        context['sig_force_company'] = company_id
        # vals_remoto = {'company_id': company_id}
        user_ids = _spg('res.users').search(cr, uid, [('login', '=', 'mkp_user_nf')], context=context)
        if not user_ids:
            return {'status': False, 'mensagem': 'Usuario nao cadastrado para o login: mkp_user_nf'}

        uid = user_ids[0]
        # _spg('res.users').write(cr, uid, uid, vals_remoto, context=context_force)
        _user_dados = _spg('res.users').read(cr, uid, uid, ['pessoa_id'], context=context)
        if not _user_dados:
            return {'status': False, 'mensagem': 'O Usuario %s nao tem uma pessoa_id!' % uid}
        _user_pessoa_id = _user_dados.get('pessoa_id')[0]
        _args = [('company_id', '=', company_id), ('pessoa', '=', _user_pessoa_id)]
        _func_ids = _spg('rh.funcionario').search(cr, uid, _args, context=context)
        if not _func_ids:
            _func_id = _spg('rh.funcionario').create(cr, uid, {'company_id': company_id, 'pessoa': _user_pessoa_id},
                                                   context=context)
        else:
            _func_id = _func_ids[0]
        _modelo_ids = _spg('fiscal.modelo.nf').search(cr, uid, [('fismnf_codigo', '=', '55')], context=context)
        if not _modelo_ids:
            return {'status': False, 'mensagem': 'Modelo de nf nao cadastrado: 55'}
        _modelo_id = _modelo_ids[0]
        _serie = dados.get('invoice_series').zfill(3)
        if _status_nf == 'disabled':
            res = _spg('mkp.utils').mkputl_inutilizar_nf(cr, uid, company_id, _nro_nf, _serie, context=context)
            return res
        _campos = ['id', 'condicao_pgto_transferencia_id','company_id','fispar_natureza_uf_dentro_venda_id',
                   'fispar_natureza_uf_fora_venda_id', 'fispar_natureza_uf_dentro_devolucao_id',
                   'fispar_natureza_uf_fora_devolucao_id', 'fispar_natureza_transferencia_saida_id']
        _dados_parametros = _spg('adm.utils').admutl_get_parametros(cr, uid, 'fiscal.parametro', _campos, context=context)
        _param_id = _dados_parametros.get('id')
        _param_company_id = _dados_parametros.get('company_id')
        args = [('modelo_nf_id', '=', _modelo_id),('serie_nf', '=', _serie), ('parametro_id', '=', _param_id)]
        _modelo_nf_series_ids = _spg('fiscal.modelo.nf.series').search(cr, uid, args, context=context)
        if not _modelo_nf_series_ids:
            return {'status': False, 'mensagem': 'Serie %s nao cadastrada para a empresa_id: %s' % (_serie, _param_company_id)}
        _modelo_nf_series_id = _modelo_nf_series_ids[0]
        _natureza = dados.get('fiscal_data').get('transaction_type_description')
        if _transaction_type in ('sale_return', 'devolution'):  # Devolução
            if _uf_emitente == _uf_destinatario:
                _nat_id = _dados_parametros.get('fispar_natureza_uf_dentro_devolucao_id')
            else:
                _nat_id = _dados_parametros.get('fispar_natureza_uf_fora_devolucao_id')
            brw_natureza = _spg('fiscal.cfop.natureza').browse(cr, uid, _nat_id, context=context)
            tipo_nat = brw_natureza.cfop_id.movimento_tipo
        elif _transaction_type == 'removal':  # Transferencia (retirada do full)
            _nat_id = _dados_parametros.get('fispar_natureza_transferencia_saida_id')
            brw_natureza = _spg('fiscal.cfop.natureza').browse(cr, uid, _nat_id, context=context)
            tipo_nat = brw_natureza.cfop_id.movimento_tipo
        else:
            # _tipo_operacao
            _cfop = dados.get('items')[0].get('fiscal_data').get('attributes').get('cfop')
            _cfop_ids = _spg('fiscal.cfop').search(cr, uid, [('codigo', '=', _cfop)], context=context)

            _nat_ids = _spg('fiscal.cfop.natureza').search(cr, uid, ['|', ('fisnat_natureza_fiscal', '=', _natureza),
                                                                          ('name', '=', _natureza),
                                                                          ('cfop_id','=', _cfop_ids[0])], context=context)
            if not _nat_ids:
                return {'status': False, 'mensagem': 'Natureza nao cadastrada: %s e cfop: %s' % (_natureza, _cfop)}
            _nat_id = _nat_ids[0]
            brw_natureza = _spg('fiscal.cfop.natureza').browse(cr, uid, _nat_id, context=context)
            tipo_nat = brw_natureza.cfop_id.movimento_tipo
            if tipo_nat == 'C': # Venda, precisa saber se é dentro ou fora do estado
                if _uf_emitente == _uf_destinatario:
                    _nat_id = _dados_parametros.get('fispar_natureza_uf_dentro_venda_id')
                else:
                    _nat_id = _dados_parametros.get('fispar_natureza_uf_fora_venda_id')
                brw_natureza = _spg('fiscal.cfop.natureza').browse(cr, uid, _nat_id, context=context)
        _est_operacao_id = brw_natureza.fisnat_operacao_id.id
        _data_nf = dados.get('issued_date')[:10].replace('/','-')
        _cnpj_destinatario = dados.get('recipient').get('identifications').get('cnpj') or dados.get('recipient').get('identifications').get('cpf')
        _cliente_nome = dados.get('recipient').get('name')
        _destinatario_ids = _spg('adm.pessoa').search(cr, uid, [('cpf_cnpj', '=', _cnpj_destinatario)], context=context)
        _ddd = _fone = ''
        if dados.get('recipient').get('phone'):
            _ddd = dados.get('recipient').get('phone').get('area_code') or ''
            _fone = dados.get('recipient').get('phone').get('number') or ''
        _rua = dados.get('recipient').get('address').get('street_name')
        _rua_nro = dados.get('recipient').get('address').get('street_number')
        _rua_complemento = dados.get('recipient').get('address').get('complement')
        _bairro = dados.get('recipient').get('address').get('neighborhood')
        _cidade = dados.get('recipient').get('address').get('city')
        _cep = dados.get('recipient').get('address').get('zip_code')
        _estado = dados.get('recipient').get('address').get('state')
        _pais = dados.get('recipient').get('address').get('country')
        _ie = dados.get('recipient').get('identifications').get('ie') or ''
        outros_dados = {
            'pais': _pais,
            'estado': _estado,
            'cidade': _cidade,
            'bairro': _bairro,
        }
        if _destinatario_ids:
            _destinatario_id = _spg('mkp.utils').mkputl_orders_alterar_pessoa(cr, uid, _destinatario_ids[0], _cliente_nome, _cnpj_destinatario,
                                                                   False, '', _cep, _rua,
                                                                   _rua_nro, _rua_complemento,
                                                                   _ddd, _fone,
                                                                   False, False, False,
                                                                   False,  context=context, **outros_dados)
        else:
            # TODO FAZER TRATAMENTO PARA ALTERAR OS DADOS DO CLIENTE POIS PODE TER TIDO ALTERAÇÃO NO M.L.
            _destinatario_id = _spg('mkp.utils').mkputl_orders_incluir_pessoa(cr, uid, _cliente_nome, _cnpj_destinatario, False,
                                                           False, _ie, _cep, _rua,
                                                           _rua_nro, _rua_complemento, _ddd,
                                                           _fone, False, False,
                                                           False, False, context=context,**outros_dados)

        if not _destinatario_id:
            return {'status': False, 'mensagem': 'Destinatario nao cadastrado: %s' % _cnpj_destinatario}
        dados_pessoa = _spg('adm.pessoa').read(cr, uid, _destinatario_id, ['endereco_nf_id'], context=context)
        if dados_pessoa and dados_pessoa.get('endereco_nf_id'):
            _end_id = dados_pessoa.get('endereco_nf_id')[0]
        else:
            _end_id = ''

        vr_frete = dados.get('shipment').get('buyer_cost') or 0.0
        _vr_nota = float(dados.get('amount'))
        _pedidos_ids = []
        _condicoes = []
        _order = False
        if tipo_nat != 'C':  # Não é nota de venda, não tem pedido
            _condicao_forma_id = _dados_parametros.get('condicao_pgto_transferencia_id')
            if not _condicao_forma_id:
                return {'status': False, 'mensagem': 'Condicao/forma de pagamento na cadastrado no parametro'}
            dados_condicao_forma = _spg('adm.condicao.forma').read(cr, uid, _condicao_forma_id, [], context=context)
            _condicoes = [{
                'condicao_forma_id': dados_condicao_forma.get('id'),
                'forma_pagto_id': dados_condicao_forma.get('forma_pagamento_id')[0],
                'valor':_vr_nota,
                'parcelas': [{
                    'valor': _vr_nota,
                    'vencimento': _data_nf
                }]
            }]
        else:  # Nota de venda
            for item in dados.get('items'):
                _order = item.get('external_order_id')
                _ped_ids = _spg('estoquepedidos.pedido.capa').search(cr, uid,
                                                 [('pedcap_nro_pedido_externo', '=', _order), ('tipo', '=', 'V')],
                                                 context=context)
                if not _ped_ids:
                    args = [('mkpnot_conta_id', '=', _conta_id), ('mkpnot_resource', '=', '/orders/%s' % _order)]
                    not_ids = _spg('mkp.notificacoes').search(cr, uid, args, context=context)
                    if not_ids:
                        vals = {
                            'state': 'R',
                        }
                        _spg('mkp.notificacoes').write(cr, uid, not_ids, vals, context=context)
                    else:
                        vals_not = {
                        'mkpnot_conta_id': _conta_id,
                        'mkpnot_application': dados_notificacao.get('mkpnot_application'),
                        'mkpnot_resource': '/orders/%s' % _order,
                        'mkpnot_loja': dados_notificacao.get('mkpnot_loja'),
                        'mkpnot_topic': 'orders_v2',
                        'mkpnot_attempts': '1',
                        }
                        res = _spg('mkp.notificacoes').create(cr, uid, vals_not, context=context)
                    return {'status': False, 'mensagem': 'Aguardando a importacao do pedido: %s' % _order}
                else:
                    _pedidos_ids.append(_ped_ids[0])
                    brw_pedido = _spg('estoquepedidos.pedido.capa').browse(cr, uid, _ped_ids[0], context=context)
                    _condicoes = []
                    for brw_cond in brw_pedido.pedido_condicao_ids:
                        _condicao_forma_id = brw_cond.condicao_forma_id.id
                        dados_condicao_forma = _spg('adm.condicao.forma').read(cr, uid, _condicao_forma_id, [], context=context)
                        _condicoes.append({
                            'condicao_forma_id':  dados_condicao_forma.get('id'),
                            'forma_pagto_id': dados_condicao_forma.get('forma_pagamento_id')[0],
                            'valor': brw_cond.valor,
                            'parcelas': [{
                                'valor': brw_cond.valor,
                                'vencimento': _data_nf
                             }],
                        })
        _vr_desconto = 0.0
        mens_fiscais = ''
        mens_contribuinte = ''
        if dados.get('fiscal_data').get('messages'):
            for mens in dados.get('fiscal_data').get('messages'):
                if mens.get('type') == 'FISCAL':
                    mens_fiscais += ' ' + mens.get('content')
                else:
                    mens_contribuinte += ' ' + mens.get('content')
        mens_contribuinte += '\nInvoice M.L.: %s' % dados.get('id')
        context['fatura_pedido'] = True
        context['fiscal'] = True
        context['proprio'] = True
        context['fisnfc_nao_faturar_sefaz'] = True
        context['fisnfc_importacao_nfce_do_supervisor'] = True
        _status_code = dados.get('attributes').get('status_code')
        if _status_code == 100:
            _state = '3'
        elif _status_code in (101, 135):
            _state = 'C'
        elif _status_code == 102:
            _state = 'I'
        elif _status_code in (110, 302):
            _state = 'D'
        else:
            _state = '1'
        if _pedidos_ids:
            if vr_frete == 0:
                _ped_dados = _spg('estoquepedidos.pedido.capa').read(cr, uid, _pedidos_ids[0],['vr_frete'], context=context)
                if _ped_dados:
                    _ped_frete = _ped_dados[0].get('vr_frete')
                    if _ped_frete and _ped_frete != vr_frete:
                        vr_frete = _ped_frete
                        _vr_desconto += vr_frete
            # else:
            #     _vr_desconto += vr_frete

        args =[('numero_nf', '=', _nro_nf),
               ('serie_nf', '=', _serie),
               ('modelo_nf_id', '=', _modelo_id),
               # ('tipo','=', 'S'),
               ('company_id', '=', company_id),
               ('state', 'in', ('3', 'C', 'I', 'P', 'D'))]
        nf_ids = _spg('fiscal.nf.capa').search(cr, uid, args, context=context)
        if nf_ids:
            nf_id = nf_ids[0]
        else:
            vals = {'tipo': brw_natureza.tipo,
                    'fisnfc_tipo_servico': False,
                    'company_id': company_id,
                    'numero_nf': _nro_nf,
                    'serie_nf': _serie,
                    'nf_propria': True,
                    'natureza_id': _nat_id,
                    'modelo_nf_series_id': _modelo_nf_series_id,
                    'modelo_nf_id': _modelo_id,
                    'destinatario_id': _destinatario_id,
                    'destinatario_endereco_id': _end_id,
                    'data_emissao': dados.get('issued_date')[:19].replace('T', ' ').replace('/','-'),
                    'hora_emissao': dados.get('issued_date')[:19].replace('T', ' ').replace('/','-'),
                    'data_saida_entrada': dados.get('issued_date')[:19].replace('T', ' ').replace('/','-'),
                    'modelo_55': True,
                    'fisnfc_consumidor': False,
                    'gerar_xml': True,
                    'nfe_forma_impressao_danfe': '1',
                    'nfe_processo_emissao': '0',
                    'fisnfc_nfe_indicador_presenca': '1' if tipo_nat == 'T' else '2',
                    'nfe_versao_processo_emissao': dados.get('xml_version'),
                    'nfe_forma_emissao': '1' if dados.get('emission_type') == 'normal' else '2',
                    'finalidade_emissao': '1',
                    'nfe_protocolo': dados.get('attributes').get('protocol'),
                    'nfe_status': '%s - %s' % (_status_code, dados.get('attributes').get('status_description') ),
                    'nfe_chave_acesso': dados.get('attributes').get('invoice_key'),
                    'nfe_lote':dados.get('attributes').get('receipt'),
                    'vr_desconto': _vr_desconto,
                    'vr_icms_substituicao': 0.0,
                    'vr_base_icms_substituicao': 0.0,
                    'vr_seguro': 0.0,
                    'vr_despesas_acessorias': 0.0,
                    'vr_frete': vr_frete,
                    'vr_total_nf': _vr_nota,
                    'frete': '0' if vr_frete else '9',
                    'fisnfc_infcomp_contribuinte': mens_contribuinte,
                    'fisnfc_infcomp_fisco': mens_fiscais,
                    'state': _state,
                    }
            if _state != 'C':
                vals.update({
                'nfe_xml_gerado': nfe.NFe.xml,
                'nfe_xml_auto': _state == '3' and nfe.protNFe.xml,
                })
            if _order:
                vals['fisnfc_mkp_nro_pedido'] = _order
                vals['fisnfc_mkp_conta_id'] = brw_pedido.pedcap_conta_id.id
                vals['fisnfc_mkp_invoice'] = dados.get('id')
            if vr_frete > 0:
                vals['tipo_frete'] = 'D'
            if _state == 'C':
                vals['estoque_movimento_itens_ids'] = []
            if _pedidos_ids:
                vals.update({'fisnfc_pedido_ids': [(6, 0, _pedidos_ids)]})
            if _nfs_referenciadas_ids:
                _list = []
                for i in _nfs_referenciadas_ids:
                    _list.append([6, False, [i]])
                vals.update({'fisnfc_nf_referencia_ids': _list})
            _hoje = _spg('adm.utils').admutl_datetime_to_timezone(cr, uid, datetime.now(),
                                                                           formato='%Y_%m_%d_%H_%M_%s')
            cr.execute(''' BEGIN; SAVEPOINT importar_notas_ml_%s; ''' % _hoje)
            sql_rollback = """ROLLBACK TO SAVEPOINT importar_notas_ml_%s; """ % _hoje
            sql_release = """RELEASE SAVEPOINT importar_notas_ml_%s; """ % _hoje
            context['nf_capa_manutencao'] = True
            try:
                nf_id = _spg('fiscal.nf.capa').create(cr, uid, vals, context=context)
            except Exception as e:
                cr.execute(sql_rollback)
                return {'status': False, 'Mensagem': e}
            context.pop('nf_capa_manutencao')
            if not nf_id:
                cr.execute(sql_rollback)
                return {'status': False, 'Mensagem': 'Nao consegui criar a nota fiscal'}

            #### Criar capa do movimento do estoque
            vals_mov_capa = {'company_id': company_id,
                    'nf_capa_id': nf_id,
                    'funcionario_id': _func_id,
                    'estmvc_operacao_id': _est_operacao_id,
                    'data': _data_nf,
                    'state': 'F' if _state == '3' else 'C',
            }
            mov_capa_id = _spg('estoque.movimento.capa').create(cr, uid, vals_mov_capa, context=context)

            ####   Criar itens do movimento do estoque e fiscal item tributacao
            nf_item_ids = list()
            itens_ids = list()
            itens = dados.get('items')
            _total_itens = _vr_nota - vr_frete
            lista = []
            lista_frete = []
            i = 0
            for item in itens:
                i += 1
                lista.append([i, float(item.get('total_amount'))])
                lista_frete.append([i, float(item.get('total_amount'))])
            valores_rateados_itens = _spg('adm.utils').efetuar_rateio(_vr_nota, lista)
            valores_rateados_frete = _spg('adm.utils').efetuar_rateio(vr_frete, lista_frete)
            i = -1
            for item in itens:
                i += 1
                _order = item.get('external_order_id')
                _anuncio = item.get('external_product_id')
                _anuncio_ids = _spg('mkp.anuncios').search(cr, uid, [('mkpanu_codigo_anuncio', '=', _anuncio)],
                                                           context=context)
                if _anuncio_ids:
                    _dados_anuncio = _spg('mkp.anuncios').read(cr, uid, _anuncio_ids[0],
                                                               ['mkpanu_produto_id', 'mkpanu_conta_id'],
                                                               context=context)
                    _prod_id = _dados_anuncio.get('mkpanu_produto_id')[0]
                else:
                    try:
                        _codigo = item.get('attributes').get('sku').split('-')[0]
                        _prod_id = _spg('estoque.produto').search(cr, uid, [
                                    ('codigo', '=', _codigo)], context=context)[0]
                    except:
                        return {'status': False,
                                'mensagem': 'Nao consegui identificar o produto para a venda!'}
                _grade_ids = _spg('estoque.produto.grade').search(cr, uid, [
                    ('produto_id', '=', _prod_id)], context=context)
                if len(_grade_ids) > 1:
                    try:
                        _grade = item.get('attributes').get('sku')[-2:]
                        _grade_lida_ids = _spg('estoque.produto.grade').search(cr, uid, [
                            ('produto_id', '=', _prod_id), ('grade', '=', _grade)], context=context)
                        if _grade_lida_ids:
                            _grade_ids = _grade_lida_ids
                        else:
                            _ean = item.get('attributes').get('ean')
                            barra_ids = _spg('automacao.codigo.barra').search(cr, uid, [('codigo_barra', '=', _ean)],
                                                                              context=context)
                            if not barra_ids:
                                return {'status': False,
                                        'mensagem': 'Codigo de barras %s do Anuncio %s nao cadastrado!' % (_ean, _anuncio)}
                            dados_barra = _spg('automacao.codigo.barra').read(cr, uid, barra_ids[0], ['grade_id'],
                                                                              context=context)
                            _grade_ids = [dados_barra.get('grade_id')[0]]
                    except:
                        return {'status': False,
                                'mensagem': 'Nao consegui identificar a grade para a venda do anuncio: %s' % _anuncio}

                _grade_id = _grade_ids[0]
                _local_id = dados_conta.get('mkpcta_local_id')[0]
                if _transaction_type == 'sale' and \
                   _fulfillment and \
                   company_id == dados_conta.get('mkpcta_fulfillment_empresa_id')[0]:
                    _local_id = dados_conta.get('mkpcta_fulfillment_local_id')[0]
                args = [('company_id', '=', company_id), ('grade_id', '=', _grade_id), ('local_id', '=', _local_id)]
                _local_locacao_ids = _spg('estoque.local.locacao').search(cr, uid, args, context=context)
                if not _local_locacao_ids:
                    return {'status': False, 'mensagem': 'Local locacao, nao cadastrado para o anuncio: %s' % _anuncio}
                dados_local_locacao = _spg('estoque.local.locacao').read(cr, uid, _local_locacao_ids[0],
                                                                         ['estllc_produto_embalagem_id'],
                                                                         context=context)
                _vr_total = float(item.get('total_amount'))
                _cfop = item.get('fiscal_data').get('attributes').get('cfop')
                _cfop_ids = _spg('fiscal.cfop').search(cr, uid, [('codigo', '=', _cfop)], context=context)
                vals_custos = _spg('estoque.preco.custo').get_custos_do_dia(cr, uid, _prod_id, company_id,
                                                                        _data_nf, context)
                custos = vals_custos.get(_prod_id) or {}
                _quantidade = item.get('quantity')
                _custo_corrigido = (custos.get('estprc_custo_corrigido') or 0) * _quantidade
                _ultimo_custo = (custos.get('estprc_ultimo_custo') or 0) * _quantidade
                _custo_reposicao = (custos.get('estprc_custo_reposicao') or 0) * _quantidade
                _custo_medio_contabil = (custos.get('estprc_custo_medio_contabil') or 0) * _quantidade
                _vr_desconto_item = 0
                if i == 0:
                    _vr_desconto_item = _vr_desconto
                vals = {
                    'local_id': _local_id,
                    'nf_id': nf_id,
                    'sequencia': itens.index(item) + 1,
                    'cfop_id': _cfop_ids[0],
                    'capa_id': mov_capa_id,
                    'natureza_id': _nat_id,
                    'produto_id': _prod_id,
                    'quantidade': _quantidade,
                    'produto_embalagem_id': dados_local_locacao.get('estllc_produto_embalagem_id')[0],
                    'grade_id': _grade_id,
                    'vr_desconto': 0.0,
                    'vr_desconto_rateado': _vr_desconto_item,
                    'vr_despesas_rateado': 0.0,
                    'estmvi_vr_despesas_extras_rateado': 0.0,
                    'vr_preco_venda': _vr_total,
                    'vr_unitario': _vr_total / item.get('quantity'),
                    'vr_total_item': _vr_total,
                    'vr_total_item_rateado': valores_rateados_itens[i][1],
                    'vr_frete_rateado':  valores_rateados_frete[i][1],
                    'estmvi_saidas_custo_corrigido_total': _custo_corrigido,
                    'estmvi_saidas_custo_medio_contabil_total': _custo_medio_contabil,
                    'estmvi_saidas_ultimo_custo_total': _ultimo_custo,
                    'estmvi_saidas_custo_reposicao_total': _custo_reposicao,
                }
                context['atualizacao_inventario'] = True # contexto utilizdo para apenas criar sem fazer outros tratamentos
                _item_id = _spg('estoque.movimento.itens').create(cr, uid, vals, context=context)
                context.pop('atualizacao_inventario')
                itens_ids.append(_item_id)
                _cst_icms = _csosn = _icms_tribut = False
                _csosn_ids = []
                nat_rec_pis_cofins = ''
                for _encargo in item.get('fiscal_data').get('rules'):
                    _name = _encargo.get('name', False)
                    if _name == 'ICMS_SIMPLES':
                        _csosn = _encargo.get('attributes').get('csosn', False)
                        _csosn_ids = _spg('fiscal.csosn').search(cr, uid, [('codigo', '=', _csosn)], context=context)
                        _enc_ids = _spg('fiscal.encargo').search(cr, uid, [('sigla', '=', 'ICMS')], context=context)
                    elif _name == 'ICMS':
                        _icms_tribut = True
                    elif _name == 'PIS':
                        nat_rec_pis_cofins = _spg('estoque.produto').read(cr, uid, _prod_id, ['estpro_pis_nat_rec'],
                                                                          context).get('estpro_pis_nat_rec') or ''
                    elif _name == 'COFINS':
                        nat_rec_pis_cofins = _spg('estoque.produto').read(cr, uid, _prod_id, ['estpro_cofins_nat_rec'],
                                                                          context).get('estpro_cofins_nat_rec') or ''
                    else:
                        continue
                if not (_csosn_ids or _icms_tribut):
                    return {'status': False,
                            'mensagem': 'Nao encontrei o csosn: %s' % _csosn}
                for _encargo in item.get('fiscal_data').get('rules'):
                    _name = _encargo.get('name', False)
                    _vbc = _encargo.get('attributes').get('vbc', False)
                    _cst = _encargo.get('attributes').get('cst', False)
                    _nat_rec_pis_cofins = ''
                    if _name == 'ICMS_SIMPLES':
                        _aencargo = 0
                        _vencargo = 0
                        args = [('fiscst_csosn_nao_contribuinte_id', '=', _csosn_ids[0])]
                        _cst_ids = _spg('fiscal.cst').search(cr, uid, args, context=context)
                        if not _cst_ids:
                            return {'status': False,
                                'mensagem': 'Nao encontrei cst para o csosn: %s' % _csosn}
                        _cst = _spg('fiscal.cst').read(cr, uid, _cst_ids[0], ['codigo']).get('codigo')
                        if not _cst:
                            return {'status': False,
                                    'mensagem': 'Nao encontrei cst para o csosn: %s' % _csosn}
                        _enc_ids = _spg('fiscal.encargo').search(cr, uid, [('sigla', '=', 'ICMS')], context=context)
                        if not _enc_ids:
                            return {'status': False,
                                    'mensagem': 'Nao encontrei o encargo: %s' % 'ICMS'}
                    elif _name == 'PIS':
                        _vencargo = _encargo.get('attributes').get('vpis', False)
                        _aencargo = _encargo.get('attributes').get('ppis', False)
                        _enc_ids = _spg('fiscal.encargo').search(cr, uid, [('sigla', '=', 'PIS')], context=context)
                        if not _enc_ids:
                            return {'status': False,
                                    'mensagem': 'Nao encontrei o encargo: %s' % 'PIS'}
                    elif _name == 'COFINS':
                        _vencargo = _encargo.get('attributes').get('vcofins', False)
                        _aencargo = _encargo.get('attributes').get('pcofins', False)
                        _enc_ids = _spg('fiscal.encargo').search(cr, uid, [('sigla', '=', 'COFINS')], context=context)
                        if not _enc_ids:
                            return {'status': False,
                                    'mensagem': 'Nao encontrei o encargo: %s' % 'COFINS'}
                    elif _name == 'ICMS':
                        _vencargo = _encargo.get('attributes').get('vicms', False)
                        _aencargo = _encargo.get('attributes').get('picms', False)
                        _enc_ids = _spg('fiscal.encargo').search(cr, uid, [('sigla', '=', 'ICMS')], context=context)
                        if not _enc_ids:
                            return {'status': False,
                                    'mensagem': 'Nao encontrei o encargo: %s' % 'ICMS'}
                    else:
                        continue
                    args = [('codigo', '=', _cst),('encargo_id', '=', _enc_ids[0])]
                    _cst_ids = _spg('fiscal.cst').search(cr, uid, args, context=context)
                    args =[
                        ('encargo_id', '=', _enc_ids[0]),
                        ('produto_id', '=', _prod_id),
                        ('tipo_tributacao', '=', 'T'),
                        # ('cst_id','=',_cst_ids[0])
                    ]
                    _tribut_encargos_ids = _spg('fiscal.tributacao.encargos').search(cr, uid, args, context=context)
                    if not _tribut_encargos_ids:
                        return {'status': False,
                                'mensagem': 'Nao encontrei o tributacao encargos para o produto_id: %s, encargo_id %s, cst_id: %s' % (_prod_id, _enc_ids[0], _cst_ids[0])}
                    _tribut_id = _spg('fiscal.tributacao.encargos').read(cr, uid, _tribut_encargos_ids[0], ['tributacao_id'], context=context)['tributacao_id'][0]
                    if _csosn_ids:
                        if isinstance(_csosn_ids, (list, tuple)):
                            _csosn_id = _csosn_ids[0]
                    else:
                        _csosn_id = None
                    vals = {
                        'movimento_itens_id': _item_id,
                        'encargo_id': _enc_ids[0],
                        'fisnit_capa_id': nf_id,
                        'aliquota': _aencargo,
                        'vr_encargo': _vencargo,
                        'vr_base_calculo': valores_rateados_itens[i][1],
                        'vr_reducao_base': 0.0,
                        'fisnit_nat_rec_pis_cofins': nat_rec_pis_cofins,
                        'fisnit_csosn_id': _csosn_id,
                        'cst_id': _cst_ids[0],
                        'tributacao_id': _tribut_id,
                        'fisnit_vr_difal_uf_origem': _encargo.get('attributes').get('vicmsufremet') or 0.00,
                        'fisnit_vr_difal_uf_destino': _encargo.get('attributes').get('vicmsufdest') or 0.00,
                        'fisnit_vr_fcp': _encargo.get('attributes').get('fvcpufdest') or 0.00,
                    }
                    _nf_item_id = _spg('fiscal.nf.item.tributacao').create(cr, uid, vals, context=context)
                    nf_item_ids.append(_nf_item_id)
            context['super_write_estoque_movimento_itens'] = True
            context['fisnit_super_write'] = True
            _spg('estoque.movimento.itens').write(cr, uid, itens_ids, {}, context=context)
            self.pool.get('fiscal.nf.item.tributacao').write(cr, uid, nf_item_ids, {}, context=context)
            context.pop('super_write_estoque_movimento_itens')
            context.pop('fisnit_super_write')

            ### Inserir condicoes de pagamento
            for _condicao in _condicoes:
                parcelas = _condicao.pop('parcelas')
                _condicao['capa_id'] = nf_id
                cond_pgto_id = _spg('fiscal.condicao.pagamento').create(cr, uid, _condicao, context=context)
                for _parcela in parcelas:
                    _parcela['nf_condicao_id'] = cond_pgto_id
                    _spg('fiscal.nf.parcelas').create(cr, uid, _parcela, context=context)
            res = _spg('fiscal.nf.capa').write(cr, uid, [nf_id], {}, context=context)
            try:
                res = _spg('fiscal.nf.capa').fisnfc_funcao_button_faturar(cr, uid, [nf_id], context)
            except Exception as e:
                cr.execute(sql_rollback)
                return {'status': False, 'Mensagem': e}
            if not res:
                cr.execute(sql_rollback)
                return {'status': False, 'Mensagem': 'Nao consegui faturar a nota fiscal'}
            if _pedidos_ids:
                context['pedcap_write_state'] = True
                vals = {
                    'state': 'F',
                    'pedcap_data_faturamento': _data_nf,
                }
                _spg('estoquepedidos.pedido.capa').write(cr, uid, _pedidos_ids, vals, context=context)
        # inbound -> entrada no cd
        # sale -> venda
        # symbolic_inbound_return -> devolução simbolica para acobertar uma venda
        if _transaction_type == 'sale' and \
           _fulfillment and \
           company_id ==  dados_conta.get('mkpcta_fulfillment_empresa_id')[0]:
            args = [('nf_id', '=', nf_id)]
            reqResupCap_id = self.pool.get('estoqueressuprimento.requisicao.capa').search(cr, uid, args, context=context)
            if not reqResupCap_id:
                #  criar requisicao ressuprimento p/transferir para o local do full
                valsReqCapa = {
                    'company_id': dados_conta.get('mkpcta_fulfillment_empresa_id')[0],
                    'data': _data_nf,
                    'local_entrada_id': dados_conta.get('mkpcta_fulfillment_local_id')[0],
                    'local_saida_id': dados_conta.get('mkpcta_local_id')[0],
                    'nf_id': nf_id,
                    'state': 'R',
                    'tipo': 'QR',
                }
                reqResupCap_id = self.pool.get('estoqueressuprimento.requisicao.capa').create(cr, uid, valsReqCapa, context=context)
                brwnf = self.pool.get('fiscal.nf.capa').browse(cr, uid, nf_id, context=context)
                for record in brwnf.estoque_movimento_itens_ids:
                    valsReqItens = {
                        'embalagem_id': record.produto_embalagem_id.id,
                        'grade_id': record.grade_id.id,
                        'produto_id': record.produto_id.id,
                        'quantidade_confirmada': record.quantidade,
                        'quantidade_requisitada': record.quantidade,
                        'requisicao_id': reqResupCap_id,
                    }
                    context['super_estoqueressuprimento_requisicao_itens'] = True
                    self.pool.get('estoqueressuprimento.requisicao.itens').create(cr, uid, valsReqItens, context=context)
                    context['super_estoqueressuprimento_requisicao_itens'] = False
                self.pool.get('estoqueressuprimento.requisicao.capa').button_gerar_nota_ressuprimento(cr, uid, [reqResupCap_id], context=context)
        elif brw_natureza.cfop_id.movimento_tipo in ('E', 'R', 'U'):
            """ 
            Para operações(movimento_tipo do cfop) de Remessa, retorno e outros
            tem que fazer segunda nota para o local do fullfillment
            """
            if dados_conta.get('mkpcta_fulfillment_empresa_id') and \
                dados_conta.get('mkpcta_fulfillment_empresa_id')[0] == dados_conta.get('company_id')[0]:
                _brw_nf_original = _spg('fiscal.nf.capa').browse(cr, uid, nf_id, context=context)
                if _cfop[:1] in ('1', '5'):
                    _cfop90 = '1' + _cfop[1:] if _cfop[0] == '5' else '5' + _cfop[1:]
                else:
                    _cfop90 = '2' + _cfop[1:] if _cfop[0] == '6' else '6' + _cfop[1:]
                _cfop90_ids = _spg('fiscal.cfop').search(cr, uid,[('codigo', '=', _cfop90)], context=context)
                _nat90_ids = self.pool.get('fiscal.cfop.natureza').search(cr, uid,
                                                                        [('cfop_id', '=', _cfop90_ids[0])],
                                                                        context=context, limit=1)
                if not _nat90_ids:
                    return {'status': False, 'mensagem': 'Natureza nao cadastrada: %s e cfop: %s' % (
                        _natureza, _cfop90)}
                if dados_conta.get('mkpcta_full_modelo_90_nf_series'):
                    _modelo_nf_serie_90 = dados_conta.get('mkpcta_full_modelo_90_nf_series')[0]
                else:
                    _modelo_nf_serie_90 = _get_modelo_nf_serie_90()
                if not _modelo_nf_serie_90:
                    return {'status': False, 'Mensagem': 'Modelo 90 nao encontrado!'}
                brw90_modelo_nf_series = self.pool.get('fiscal.modelo.nf.series').browse(cr, uid, _modelo_nf_serie_90, context=context)
                args = [('numero_nf', '=', _nro_nf),
                        ('serie_nf', '=', _serie),
                        ('modelo_nf_series_id', '=', _modelo_nf_serie_90),
                        ('modelo_nf_id', '=', brw90_modelo_nf_series.modelo_nf_id.id),
                        ('company_id', '=', company_id),
                        ('destinatario_id', '=', _destinatario_id),
                        ('nf_propria', '=',  True),
                        ('natureza_id', '=', _nat90_ids[0])]
                record_ids = self.pool.get('fiscal.nf.capa').search(cr, uid, args, context=context)
                if record_ids:
                    return {'status': True, 'Mensagem': ''}
                # nota fiscal de saida para o deposito, gerar nf de entrada para o local do full
                _nat90_ids = _spg('fiscal.cfop.natureza').search(cr, uid, [('cfop_id', '=', _cfop90_ids[0])],
                                                                 context=context)
                if not _nat90_ids:
                    return {'status': False, 'mensagem': 'Natureza nao cadastrada: %s e cfop: %s' % (_natureza, _cfop90)}
                _default = {
                    'modelo_55': False,
                    'modelo_nf_series_id': _modelo_nf_serie_90,
                    'modelo_nf_id': brw90_modelo_nf_series.modelo_nf_id.id,
                    'natureza_id': _nat90_ids[0],
                    'tipo': 'E' if _cfop90[0] < '4' else 'S',
                    'nf_propria': True,
                    'fisnfc_modelo': _modelo_nf_serie_90,
                    'fisnfc_nf_referencia_ids': [(6, 0, [nf_id])],
                }
                _local90 = dados_conta.get('mkpcta_fulfillment_local_id')[0]
                _nf90 = _spg('fiscal.nf.capa').copy(cr, uid, nf_id, default=_default, context=context)
                brw90 = _spg('fiscal.nf.capa').browse(cr, uid, _nf90, context=context)
                _spg('fiscal.nf.capa').write(cr, uid, _nf90, {'numero_nf': _nro_nf})
                mov_capa90_id = brw90.estoque_movimento_capa_ids[0].id
                _est_90operacao_id = brw90.natureza_id.fisnat_operacao_id.id
                _spg('estoque.movimento.capa').write(cr, uid, mov_capa90_id,
                                                     {'estmvc_operacao_id': _est_90operacao_id}, context=context)
                context['super_write_estoque_movimento_itens'] = True
                for brw_itens in brw90.estoque_movimento_itens_ids:
                    _spg('estoque.movimento.itens').write(cr, uid, brw_itens.id, {'local_id': _local90,
                                                                                  'cfop_id': _cfop90_ids[0],
                                                                                  'capa_id': mov_capa90_id,
                                                                                  'nf_id': brw90.id,
                                                                                  'natureza_id': _nat90_ids[0]},
                                                          context=context)
                    _trib_ids = map(lambda i: i.id, brw_itens.tributacoes_ids)
                    _spg('fiscal.nf.item.tributacao').unlink(cr, uid, _trib_ids)
                context.pop('super_write_estoque_movimento_itens')
                res = _spg('fiscal.nf.capa').fisnfc_validar_nota_fiscal(cr, uid, brw90.id, context=context)
                res = _spg('fiscal.nf.capa').fisnfc_funcao_button_faturar(cr, uid, [brw90.id], context=context)
        return {'status': True, 'Mensagem': ''}

    def _mkpnot_processar_notificacao(self, cr, uid, codigo_mkp, notificacao_tipo, dados_notificacao, context=None):
        """
        Metodo qeue sobrescreve o original para tratamento especializado
        :param cr:
        :param uid:
        :param codigo_mkp: Codigo do Marketplace
        :param dados_notificacao: Dados resultado do read de um registro do marketplace, com todos os atributos
        :param context:
        :return:
        """
        context = context and context.copy() or {}
        res = super(mkp_notificacoes, self)._mkpnot_processar_notificacao(cr, uid, codigo_mkp, notificacao_tipo,
                                                                          dados_notificacao, context=context)
        if codigo_mkp == 'MerLiv':
            if notificacao_tipo == 'items':
                res = self._mkpnot_get_itens_ml(cr, uid, dados_notificacao, context=context)
            elif notificacao_tipo == 'messages':
                res = self._mkpnot_get_messages_ml(cr, uid, dados_notificacao, context=context)
            elif notificacao_tipo == 'questions':
                res = self._mkpnot_get_questions_ml(cr, uid, dados_notificacao, context=context)
            elif notificacao_tipo == 'orders_v2':
                res = self._mkpnot_get_orders_ml(cr, uid, dados_notificacao, context=context)
            elif notificacao_tipo == 'payments':
                _payment = dados_notificacao.get('mkpnot_resource').split('/')[2]
                _conta_id = dados_notificacao.get('mkpnot_conta_id')
                res = self.pool.get('mkpml.pagamentos').mkpmlpag_get_payments(cr, uid, _payment, _conta_id, context=context)
            elif notificacao_tipo == 'shipments':
                res = self._mkpnot_get_shipments_ml(cr, uid, dados_notificacao, context=context)
            elif notificacao_tipo == 'invoices':
                res = self._mkpnot_get_invoice_ml(cr, uid, dados_notificacao, context=context)
            # elif notificacao_tipo == 'payments':
            #     res = True
            elif notificacao_tipo == 'claims':
                res = True
        return res

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
