# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from ...adm.control.utils import capitalize_all
from datetime import datetime
import subprocess
from openerp.tools.translate import _
import os


class mkp_utils(osv.Model):
    _inherit = 'mkp.utils'

    def mkputl_atualizar_anuncio_olist(self, cr, uid, id, context=None):
        """
        Inclui ou altera anuncio no site do Olist
        @param cr:
        @param uid:
        @param id: id do anuncio a ser alterado
        @param context:
        @return: dicionario contendo id do anuncio e response ex.:{status: True/False, 'mensagem': 'Mensagem'}
                 response. quando response.raise_for_status() for None, tá tudo certo. Para pegar o erro use response.status_code
        """

        context = context and context.copy() or {}
        _spg = self.pool.get
        brw_anuncio = _spg('mkp.anuncios').browse(cr, uid, id, context=context)
        if not brw_anuncio:  # anuncio nao existe mais. Retornar True para que a ação seja encerrada
            return {'status': True, 'mensagem': ''}
        try:
            _codigo = brw_anuncio.mkpanu_codigo_anuncio
        except:  # Erro porque o id não existe
            return {'status': True, 'mensagem': ''}
        res = _spg('mkp.olist').mkpOlist_set_anuncio(cr, uid, brw_anuncio, context=context)
        return res

    def mkputl_importar_um_pedido_olist(self, cr, uid, pedido, conta_id, context=None):
        context = context and context.copy() or {}
        _venda = pedido
        _olist_order_code = _venda.get('code')
        _volumes = len(_venda.get('volumes'))
        self._logger.info(_('Importando pedido Olist: %s') % _olist_order_code)
        _spg = self.pool.get
        brw_conta = _spg('mkp.contas').browse(cr, uid, conta_id, context=context)
        context['sig_force_company'] = brw_conta.company_id.id
        _local_id = brw_conta.mkpcta_local_id.id
        _hoje = _spg('adm.utils').admutl_datetime_to_timezone(cr, uid, datetime.now(), formato='%Y_%m_%d_%H_%M_%s')
        cr.execute(''' BEGIN; SAVEPOINT importar_pedido_olist_%s; ''' % _hoje)
        _comentario = ''
        _status_olist_name = _venda.get('status')
        _data_venda = _venda.get('created_at')[:19].replace('T', ' ')
        _lista_itens = []
        _qtd_venda = 0
        _vr_acrescimo = 0
        _preco_total = 0
        _qtd_unidades = 0
        for _item in _venda.get('seller_order_items'):
            _pedido_item = {}
            _sku = _item.get('product_sku')
            _produto_grade = _item.get('seller_product_code').replace('_', '-')
            if '-' in _produto_grade:
                _sku_code, _sku_grade = _produto_grade.split('-')
            else:
                _sku_code = _produto_grade[:-2]
                _sku_grade = _produto_grade[-2:]
            _args = [('mkpanu_codigo_anuncio', '=', _sku)]
            _anuncio_ids = _spg('mkp.anuncios').search(cr, uid, _args, context=context)
            if not _anuncio_ids:
                _produto_ids = _spg('estoque.produto').search(cr, uid, [('codigo', '=', _sku_code)], context=context)
                _produto_id = _produto_ids[0]
                _args = [('mkpanu_produto_id', '=', _produto_id), ('mkpanu_conta_id', '=', conta_id)]
                _anuncio_ids = _spg('mkp.anuncios').search(cr, uid, _args, context=context)
                if not _anuncio_ids:
                    continue
            _brw_anuncio = _spg('mkp.anuncios').browse(cr, uid, _anuncio_ids[0], context=context)
            _produto_id = _brw_anuncio.mkpanu_produto_id.id
            _grade_ids = _spg('estoque.produto.grade').search(cr, uid, [('produto_id', '=', _produto_id),
                                                                        ('grade', '=', _sku_grade)], context=context)
            _qtd_anuncio = _brw_anuncio.mkpanu_quantidade
            if _qtd_anuncio == 0:
                _qtd_anuncio = 1
            _qtd_venda = 1
            _qtd_unidades += _qtd_venda
            _qtd_venda = _qtd_venda * _qtd_anuncio
            _valor_total_item = (float(_item.get('price')) / _qtd_anuncio) * _qtd_venda
            _l_vl = _valor_total_item / _qtd_venda
            _args = [('grade_id', '=', _grade_ids[0]), ('local_id', '=', _local_id)]
            _emb_ids = _spg('estoque.local.locacao').search(cr, uid, _args, context=context)
            _emb_id = \
                _spg('estoque.local.locacao').read(cr, uid, _emb_ids[0], ['estllc_produto_embalagem_id'],
                                       context=context)['estllc_produto_embalagem_id'][0]
            _pedido_item = _spg('mkp.utils')._mkputl_monta_dic_item_pedido(cr, uid, _produto_id,
                                                                                    _grade_ids[0], _local_id, _emb_id,
                                                                                    _qtd_venda, _l_vl, _anuncio_ids[0])
            for x in _pedido_item:
                _lista_itens.append(x)
            _preco_total += _valor_total_item
        _frete = float(_venda.get('total_freight'))
        _preco_total += _frete
        _order_cliente = _venda.get('customer')
        _fone_cel = _fone_home = ''
        for _order_phone in _order_cliente.get('phones'):
            if _order_phone.get('phone_type') == u'mobile':
                _fone_cel = _order_phone.get('phone')
            else:
                _fone_home = _order_phone.get('phone')
        _fone_cel = _fone_cel.strip().replace('-', '').replace('.', '').replace('/', '').replace(' ', '').replace('(', '').replace(')', '')
        _fone_home = _fone_home.strip().replace('-', '').replace('.', '').replace('/', '').replace(' ', '').replace('(', '').replace(')', '')
        _cliente_olist_ddd_1 = _fone_cel[:2]
        _cliente_olist_fone_1 = _fone_cel[2:]
        _cliente_olist_ddd_2 = _fone_home[:2]
        _cliente_olist_fone_2 = _fone_home[2:]
        _cliente_olist_email = _order_cliente.get('email')
        _cliente_nome = _order_cliente.get('name')
        _cliente_nome = capitalize_all(_cliente_nome)
        _cliente_cpf = _order_cliente.get('document_number')
        if _cliente_cpf == '1231231123':
            _cliente_cpf = '01231231190'
        _cliente_apelido = ''
        _cliente_cep = _cliente_rua = _cliente_rua_nro = _cliente_rua_complemento = ''
        _cliente_cep = _order_cliente.get('address').get('zip_code') or ''
        _cliente_rua = _order_cliente.get('address').get('address') or ''
        _cliente_rua_nro = _order_cliente.get('address').get('number') or ''
        _cliente_rua_complemento = _order_cliente.get('address').get('complement') or ''
        _cliente_bairro = _order_cliente.get('address').get('district') or ''
        _pedido_ids = _spg('estoquepedidos.pedido.capa').search(
            cr, uid, [('pedcap_nro_pedido_externo', '=', _olist_order_code), ('tipo', '=', 'V')], context=context)
        _pedido_id = False
        _status_pedido_erp = 'R'
        _pessoa_ids = False
        if _cliente_cpf:
            _pessoa_ids = _spg('adm.pessoa').search(cr, uid, [('cpf_cnpj', '=', _cliente_cpf)], context=context)
        _pais_id = False
        if _pessoa_ids:
            _pessoa_id = _spg('mkp.utils').mkputl_orders_alterar_pessoa(cr, uid, _pessoa_ids[0], _cliente_nome, _cliente_cpf,
                                                                   '', '', _cliente_cep, _cliente_rua,
                                                                   _cliente_rua_nro, _cliente_rua_complemento,
                                                                   _cliente_olist_ddd_1, _cliente_olist_fone_1,
                                                                   _cliente_olist_ddd_2, _cliente_olist_fone_2, 'Comum',
                                                                   _cliente_olist_email, context=context)
        else:
            # TODO FAZER TRATAMENTO PARA ALTERAR OS DADOS DO CLIENTE POIS PODE TER TIDO ALTERAÇÃO NO Marketplace
            _pessoa_id = self.mkputl_orders_incluir_pessoa(cr, uid, _cliente_nome, _cliente_cpf, '',
                                                           _cliente_apelido, '', _cliente_cep, _cliente_rua,
                                                           _cliente_rua_nro, _cliente_rua_complemento, _cliente_olist_ddd_1,
                                                           _cliente_olist_fone_1, _cliente_olist_ddd_2, _cliente_olist_fone_2,
                                                           'Comum', _cliente_olist_email, context=context)
        if _pedido_ids:  # O nro pedido do Marketplace é unico, portanto se tiver pedido so tem 1
            _pedido_id = _pedido_ids[0]
            _dados_pedido = _spg('estoquepedidos.pedido.capa').read(cr, uid, [_pedido_id], ['state'], context=context)
            _status_pedido_erp = _dados_pedido[0].get('state')
            if _status_pedido_erp == 'V':  # Se o pedido estiver validado, voltar para esboco
                _spg('estoquepedidos.pedido.capa').button_rascunho(cr, uid, [_pedido_id], context=context)
                _status_pedido_erp = 'R'
            # if _status_olist_name == 'CANCELLED':
            #     if _status_pedido_erp == 'R':
            #         _spg('estoquepedidos.pedido.capa').button_cancelar(cr, uid, [_pedido_id], context=context)
            #     return True
            if _status_pedido_erp not in ('R', 'C'):  # O pedido não está mais em esboço ou cancelado, não deve ser alterado
                vals = {'pedcap_mkp_status': _status_olist_name}
                _spg('estoquepedidos.pedido.capa').write(cr, uid, [_pedido_id], vals, context=context)
                return _pedido_id

        _tipo_anuncio = ''
        _vencimento = _data_venda
        _forma = []
        _condicao_forma_id = _brw_anuncio.mkpanu_anuncio_tipo_id.mkpant_condicao_pgto.id
        _forma_id = _brw_anuncio.mkpanu_anuncio_tipo_id.mkpant_condicao_pgto.forma_pagamento_id.id
        _taxa_mkp_percentual = _brw_anuncio.mkpanu_anuncio_tipo_id.mkpant_custo_var
        _taxa_mkp_fixo = _brw_anuncio.mkpanu_anuncio_tipo_id.mkpant_custo_fixo
        _taxa_mkp_tipo_fixo = _brw_anuncio.mkpanu_anuncio_tipo_id.mkpant_tipo_custo_fixo
        if _taxa_mkp_tipo_fixo == 'U':
            _taxa_mkp_fixo = _taxa_mkp_fixo * _qtd_unidades

        _forma1 = {
            'forma_pagto_id': _forma_id,
            'condicao_forma_id': _condicao_forma_id,
            'pedido_parcela_ids': [(0, 0, {'vr_parcela': _preco_total, 'data_vencimento': _vencimento, })],
            'valor': _preco_total,
            'pedcdc_mkp_tarifa': (_taxa_mkp_percentual * _preco_total / 100) + _taxa_mkp_fixo,
        }
        _forma.append((0, 0, _forma1))

        dados_pessoa = _spg('adm.pessoa').read(cr, uid, _pessoa_id, ['endereco_nf_id'], context=context)
        if dados_pessoa and dados_pessoa.get('endereco_nf_id'):
            _end_id = dados_pessoa.get('endereco_nf_id')[0]
        else:
            _end_id = ''
        vals = {
            'observacao': _comentario,
            'data_emissao': _data_venda,
            'tipo': 'V',
            'pessoa_id': _pessoa_id,
            'pedcap_endereco_id': _end_id,
            'pedcap_mkp_status': _status_olist_name,
            'pedcap_nro_pedido_externo': _olist_order_code,
            'pedcap_endereco_eletronico': 'https://app.olist.com/volumes/orders/%s/' % _olist_order_code,
            'pedcap_mkp_tipo_anuncio': _tipo_anuncio,
            'vr_frete': _frete,
            'vr_desconto': 0.00,
            'vr_seguro': 0.00,
            'vr_despesas_acessorias': _vr_acrescimo,
            'pedcap_conta_id': conta_id,
        }

        if not _pedido_id:
            if _anuncio_ids:
                vals['pedido_item_ids'] = _lista_itens
            if _forma:
                vals['pedido_condicao_ids'] = _forma
            _pedido_id = _spg('estoquepedidos.pedido.capa').create(cr, uid, vals, context=context)
            vals = {}
            if _status_olist_name == 'CANCELLED':
                vals['state'] = 'C'
            _spg('estoquepedidos.pedido.capa').write(cr, uid, [_pedido_id], vals, context=context)
            cr.execute(''' COMMIT; ''')  # Comito, porque se houver algum problema na validação, não perco o pedido
            cr.execute(''' BEGIN; SAVEPOINT importar_pedido_ml_%s; ''' % _hoje)
        else:
            # if _status_olist_name == 'CANCELLED' and _status_pedido_erp != 'C':
            #     return False  # Marcar com problema
            # elif _status_olist_name in ('SHIPPED', 'TO_CONFIRME_RECEIVE', 'TO_RETURN', 'COMPLETED') \
            #         and _status_pedido_erp == 'R':
            #     _spg('estoquepedidos.pedido.capa').button_validar(cr, uid, [_pedido_id], context=context)
            #     _spg('estoquepedidos.pedido.capa').button_faturar_pedido(cr, uid, [_pedido_id], context=context)
            # elif _status_olist_name != 'CANCELLED':
            #     _condicao_ids = self.pool.get('estoquepedidos.pedido.condicao').search(cr, uid, [('capa_id', '=', _pedido_id)], context=context)
            #     if _condicao_ids and _forma:
            #         self.pool.get('estoquepedidos.pedido.condicao').unlink(cr, uid, _condicao_ids, context=context)
            #     vals['pedido_condicao_ids'] = _forma
            #     vals['state'] = 'R'
                context['salvar_forcado'] = True
                _spg('estoquepedidos.pedido.capa').write(cr, uid, [_pedido_id], vals, context=context)
                cr.execute(''' COMMIT; ''')  # Comito, porque se houver algum problema na validação, não perco o pedido
                cr.execute(''' BEGIN; SAVEPOINT importar_pedido_ml_%s; ''' % _hoje)
        if _status_olist_name == 'approved':
            try:
                _spg('estoquepedidos.pedido.capa').button_validar(cr, uid, [_pedido_id], context=context)
            except:
                pass
        _encomenda = False
        if _venda.get('shipments'):
            for ship in _venda.get('shipments'):
                for track in ship.get('tracks'):
                    _encomenda = track.get('code')
                    try:
                        _servico_id = brw_conta.mkpcta_rastreamento_servico_id.id
                    except:
                        _servico_id = False
                    if _encomenda:
                        sql = "select id from rastreio_encomendas where name = '%s'" % _encomenda
                        cr.execute(sql)
                        _encomenda_id = cr.fetchone()
                        if _encomenda_id:
                            _encomenda_id = _encomenda_id[0]
                        else:
                            vals_encomenda = dict(
                                name=_encomenda,
                                rasenc_pedido_id=_pedido_id,
                                rasenc_pessoa_id=_pessoa_id,
                                rasenc_compra_venda='V',
                            )
                            if _servico_id:
                                vals_encomenda['rasenc_servicos_ids'] = [(4, _servico_id,)]
                            _encomenda_id = _spg('rastreio.encomendas').create(cr, uid, vals_encomenda, context=context)
        if _encomenda:
            vals_ped = {'pedcap_encomenda_id': _encomenda_id}
            res = _spg('estoquepedidos.pedido.capa').write(cr, uid, [_pedido_id], vals_ped, context=context)
        cr.execute(''' COMMIT; ''')
        return _pedido_id

    def mkputl_faturar_no_mkp_selecionado(self, cr, uid, mkp_integrador, conta_id, ped_externo, chave, nf_ids, context=None):
        """
        Metodo sobrescrito ppelo marketplace especifico
        :param cr:
        :param uid:
        :param mkp_integrador:
        :param conta_id:
        :param ped_externo:
        :param chave:
        :param context:
        :return:
        """
        context = context and context.copy() or {}
        if mkp_integrador == 'Olist':
            for brw_nf in self.pool.get('fiscal.nf.capa').browse(cr, uid, nf_ids, context=context):
                _link = brw_nf.fisnfc_link_xml
                _lista = _link.split('/')
                _lista[6] = 'd'
                _link = '/'.join(_lista)
                res = self.pool.get('mkp.olist').mkpOlist_set_order_faturado(cr, uid, ped_externo, conta_id,
                                                                               _link, context=context)
                for brw_itens in brw_nf.estoque_movimento_itens_ids:
                    for brw_anuncio in  brw_itens.produto_id.estpro_anuncios_ids:
                        if brw_anuncio.mkpanu_conta_id.id == conta_id:
                            _qtd = brw_anuncio.mkpanu_qtd_vendido + brw_itens.quantidade
                            vals = {'mkpanu_qtd_vendido': _qtd}
                            self.pool.get('mkp.anuncios').write(cr, uid, brw_anuncio.id, vals, context=context)
                            break
        else:
            res = super(mkp_utils, self).mkputl_faturar_no_mkp_selecionado(cr, uid, mkp_integrador, conta_id, ped_externo,
                                                                          chave, nf_ids, context=context)
        return res

    def mkputl_get_etiqueta_no_mkp(self, cr, uid, mkp_integrador, conta_id, pedido_ids, context=None):
        """
        Metodo para buscar etiqueta no marketplace, deve ser sobrescrito por cada marketplace
        :param cr:
        :param uid:
        :param mkp_integrador:
        :param conta_id:
        :param pedido_ids:
        :param context:
        :return: {status: True/False, 'mensagem': '', 'dados': ''}
        """
        context = context and context.copy() or {}
        if mkp_integrador != 'Olist':
            res = super(mkp_utils, self).mkputl_get_etiqueta_no_mkp(cr, uid, mkp_integrador, conta_id, pedido_ids, context=context)
            return res
        for i in self.pool.get('estoquepedidos.pedido.capa').read(cr, uid, pedido_ids,
                                                                  ['pedcap_nro_pedido_externo', 'numero_pedido',
                                                                   'pedcap_nf_ids', 'pedcap_encomenda_id',
                                                                   'pessoa_id'], context):
            _ped = i.get('pedcap_nro_pedido_externo')
            _encomenda_id = i.get('pedcap_encomenda_id')
            if isinstance(_encomenda_id, tuple):
                _encomenda_id = _encomenda_id[0]
            if not _ped:
                return {'status': False, 'mensagem': _('Nao encontrei numero externo do pedido'), 'dados': ''}
            _pkg = self.pool.get('mkp.olist').mkpOlist_verificar_pacotes(cr, uid, conta_id, _ped, context=context)
            if _pkg.get('status') == False:
                return {'status': False, 'mensagem': _pkg.get('mensagem'), 'dados': ''}
            if not _pkg:
                return {'status': False, 'mensagem': _('Nao consegui pegar a etiqueta'), 'dados': ''}
            if not _pkg.get('shipments'):
                return {'status': False, 'mensagem': _('Nao consegui pegar a etiqueta'), 'dados': ''}
            res = self.pool.get('mkp.olist').mkpOlist_get_etiqueta_mkp(cr, uid, conta_id, _pkg, context=context)
            if not res.get('status'):
                if res.get('mensagem'):
                    return {'status': False, 'mensagem': res.get('mensagem'), 'dados': ''}
                else:
                    return {'status': False, 'mensagem': _('Nao consegui pegar a Etiqueta'), 'dados': ''}
            printer = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque',
                                                                       ['estpar_impressora_termica', 'estpar_impressora_termica_servidor'],
                                                                       context=context)
            if printer:
                servidor = printer.get('estpar_impressora_termica_servidor')
                printer = printer.get('estpar_impressora_termica')
            else:
                return {'status': False, 'mensagem': _('Cadastrar impressora no parametro do "Estoque" na aba '
                                       '"Automacao"'), 'dados': ''}
            _track = _pkg.get('shipments')[0].get('tracking_code')
            arq = res.get('arquivo')
            try:
                if servidor:
                    subprocess.call(["lp", '-o raw', "-n1", '-h%s' % servidor, '-d%s' % printer, arq])
                else:
                    subprocess.call(["lp", '-o raw', "-n1", '-d%s' % printer, arq])
            except Exception as e:
                return {'status': False, 'mensagem': _('Erro ao imprimir etiqueta de postagem %s') % e,
                        'dados': ''}
            os.remove(arq)
            if _encomenda_id:
                vals = {'name': _track}
                self.pool.get('rastreio.encomendas').write(cr, uid, _encomenda_id, vals, context=context)
            else:
                vals = {
                    'name': _track,
                    'rasenc_pedido_id': i.get('id'),
                    'rasenc_pessoa_id': i.get('pessoa_id')[0],
                    'rasenc_compra_venda': 'V',
                }
                _encomenda_id = self.pool.get('rastreio.encomendas').create(cr, uid, vals, context=context)
                vals = {'pedcap_encomenda_id': _encomenda_id}
                self.pool.get('estoquepedidos.pedido.capa').write(cr, uid, [i.get('id')], vals, context=context)
        return {'status': True, 'mensagem': '', 'dados': {'track_no': _track, 'encomenda_id': _encomenda_id}}

    def _mkputl_pesquisar_pedido_mkp_olist(self, cr, uid, conta_id, context=None):
        """
        Metodo a ser sobrescrito para cada market place
        :param cr:
        :param uid:
        :param conta_id: id da conta no marketplace
        :param codigo_mkp: codigo de identificação do marketplace
        :param context:
        :return:
        """
        context = context and context.copy() or {}
        self._logger.info('Inicio de pesquisa de pedidos Olist')
        self.pool.get('mkp.olist').mkpOlist_pesquisar_orders(cr, uid, conta_id, context=context)
        self._logger.info('Fim de pesquisa de pedidos Olist')
        return True


    def mkputl_cron_pesquisar_pedidos_olist(self, cr, uid, context=None):
        """
        Método chamado pelo cron para pesquisar pedidos nos marketplaces
        @param cr:
        @param uid:
        @param context:
        @return: Sempre True
        """
        context = context and context.copy() or {}
        obj_contas = self.pool.get('mkp.contas')
        for company_id in self.pool.get('res.company').search(cr, uid, [], context=context):
            context['sig_force_company'] = True
            args = [('mkpcta_integrador', '=', 'Olist'), ('company_id', '=', company_id)]
            conta_ids = obj_contas.search(cr, uid, args, context=context)
            for brw_conta in obj_contas.browse(cr, uid, conta_ids, context=context):
                if brw_conta.mkpcta_parar_comunicacao or \
                   brw_conta.mkpcta_marketplace_id.mkpmkp_parar_comunicacao:
                    continue
                _conta_id = brw_conta.id
                self._mkputl_pesquisar_pedido_mkp_olist(cr, uid, _conta_id, context=context)
        return True

