# -*- encoding: utf-8 -*-

import openerp.addons.web.http as http
import json
from olist import Olist
from ..marketplace.control.utils import configuracao
import xmlrpclib, socket
from logging import getLogger
from SigUtils.sigerp import db_sig


_logger = getLogger("Olist")

_senha = 'mkp_remoto_77813'


olcon = Olist()


class sc(http.Controller):
    _cp_path = '/mkp_ol'

    @http.httprequest
    def teste(self, req, s_action=None, **kw):
        _logger.info('=============================== teste %s' % req)
        return 'testado IP:%s' % req.httprequest.headers.environ.get('REMOTE_ADDR')


    @http.httprequest
    def redirect(self, req, s_action=None, **kw):
        _logger.info('=== mkp_olist/redirect === %s' % str(req.params))
        _code = req.params.get('code')
        _state = req.params.get('state')  # Secret key
        _logger.info('Olist - Autorizando: %s' % _state)
        cfg_olist = configuracao('marketplace_olist', _state)
        cfg_olist.lerConfiguracao()
        _base = str(cfg_olist.base)
        olcon.redirect_url = cfg_olist.redirect
        olcon.client_secret = cfg_olist.secreto
        olcon.shop_id = cfg_olist.shop_id
        _conta_id = cfg_olist.conta_id
        _logger.info('=== mk_ol/authorize === %s' % str(req.params))
        if req.params.get('code'):
            cfg = configuracao('marketplace', _base)
            cfg.lerConfiguracao()
            _db_user = cfg.db_user
            _db_password = cfg.db_password
            _db_host = cfg.db_host
            _db_port = cfg.db_port
            arg_db = {}
            if _db_host:
                arg_db.update({'host': _db_host})
            else:
                arg_db.update({'host': 'localhost'})
            if _db_port:
                arg_db.update({'port': _db_port or '5431'})
            if _db_user:
                arg_db.update({'user': _db_user})
            if _db_password:
                arg_db.update({'pwd': _db_password})
            _db = db_sig(_base, **arg_db)
            _fields = ['id']
            _where = [('login', '=', 'mkp_remoto')]
            dados_users = _db.dbsSelect('res_users', _fields, _where)
            _uid = False
            if dados_users:
                _uid = dados_users[0].get('id')
                if _uid:
                    olcon.client_secret = _state
                    olcon.code = req.params.get('code')
                    olcon.authorize()
                    vals = {
                        'mkpcta_ol_token': olcon.access_token,
                        'mkpcta_ol_id_token': olcon.id_token,
                        'mkpcta_ol_refresh_token': olcon.refresh_token,
                    }
                    if olcon.seller:
                        vals['mkpcta_ol_seller_id'] = olcon.seller
                    where = [('id', '=', _conta_id)]
                    x = _db.dbsUpdate('mkp_contas', vals, where)
                    if not x:
                        _db.conexao.roolback()
                    else:
                        _db.conexao.commit()
                    _logger.info('Token: %s' % str(olcon.access_token))
            _db.conexao.close()
        return 'Ok'

    @http.httprequest
    def notifications(self, req, s_action=None, **kw):
        _logger.info('--------------------- notificacoes: %s ' % str(req.httprequest.data))
        dados_post = json.loads(req.httprequest.data)
        _seller_id = unicode(dados_post.get('seller_id'))
        if _seller_id:
            cfg = configuracao('marketplace_olist', _seller_id)
            cfg.lerConfiguracao()
            olcon.redirect_url = cfg.redirect
            olcon.shop_id = cfg.shop_id
            olcon.client_secret = cfg.secreto
            olcon.conta_id = cfg.conta_id
            _base = str(cfg.base)
            cfg = configuracao('marketplace', _base)
            cfg.lerConfiguracao()
            _db_user = cfg.db_user
            _db_password = cfg.db_password
            _db_host = cfg.db_host
            _db_port = cfg.db_port
            arg_db = {}
            if _db_host:
                arg_db.update({'host': _db_host})
            else:
                arg_db.update({'host': 'localhost'})
            if _db_port:
                arg_db.update({'port': _db_port or '5431'})
            if _db_user:
                arg_db.update({'user': _db_user})
            if _db_password:
                arg_db.update({'pwd': _db_password})
            _db = db_sig(_base, **arg_db)
            _fields = ['id']
            _where = [('login', '=', 'mkp_remoto')]
            dados_users = _db.dbsSelect('res_users', _fields, _where)
            _uid = False
            if dados_users:
                _uid = dados_users[0].get('id')
                if _uid:
                    _db.uid = _uid
                    _where = [
                        ('mkpnot_resource', '=', dados_post.get('resource')),
                        ('mkpnot_loja', '=', olcon.shop_id)
                    ]
                    dados_not = _db.dbsSelect('mkp_notificacoes', ['id'], _where)
                    _not_id = False
                    if dados_not:
                        _not_id = dados_not[0].get('id')
                    _topic = dados_post.get('topic') or ''
                    if _topic == u'products':
                        _topic = 'items'
                    if _topic == u'fulfillment':
                        _topic = 'shipments'
                    ## Gravar as notificacoes
                    if _not_id:
                        vals = {
                            'mkpnot_attempts': '1',
                            'state': 'R',
                        }
                        where = [('id', '=', _not_id)]
                        x = _db.dbsUpdate('mkp_notificacoes', vals, where)
                        if x:
                            _db.conexao.commit()
                        else:
                            _db.conexao.roolback()
                    else:
                        vals = {
                            'mkpnot_conta_id': olcon.conta_id,
                            'mkpnot_resource': dados_post.get('resource') or '',
                            'mkpnot_loja': olcon.shop_id or '',
                            'mkpnot_topic': _topic,
                            'mkpnot_attempts': 1,
                            'state': 'R',
                        }
                        x = _db.dbsInsert('mkp_notificacoes', vals)
                        if not x:
                            _db.conexao.roolback()
                        else:
                            _db.conexao.commit()
                    _db.conexao.close()
                    return 'OK'  # nunca retorne booleano, vai dar erro de https
            _db.conexao.close()
        _logger.info('Nao consegui pegar a loja no Mkp Olist')
        return 'Nao'  # nunca retorne booleano, vai dar erro de https


"""
1 - Acessa https://auth.mercadolibre.com.ar/authorization?response_type=code&client_id="& ClientId & "&redirect_uri="
2 - Esta URL vai retornar para a url do parâmetro redirect_uri com um parâmetro chamado CODE
3 - Fazer um post para /oauth/token?grant_type=authorization_code&client_id={client_id}&client_secret={client_secret}&code={code}&redirect_uri={redirect_uri}" com o CODE recebido
4 - este post vai retornar um json com access_token e refresh_token. Estes dois dados devem ser salvos no banco de dados

    """