# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class estoquepedidos_pedido_capa(osv.Model):
    _inherit = 'estoquepedidos.pedido.capa'

    def pedcap_buscar_pedido_no_mkp(self, cr, uid, ids, context=None):
        _spg = self.pool.get
        res = super(estoquepedidos_pedido_capa, self).pedcap_buscar_pedido_no_mkp(cr, uid, ids, context=None)
        if res.get('dados') and res.get('dados').get('integrador') == u'Olist':
            _conta_id = res.get('dados').get('conta_id')
            _order = str(res.get('dados').get('order'))
            dados = _spg('mkp.olist').mkpOlist_get_orders(cr, uid, str(_order), _conta_id)
            if not dados.get('status'):
                res['mensagem'] = dados.get('mensagem')
                return res
            _pedido = dados.get('orders')
            _ped_id = _spg('mkp.utils').mkputl_importar_um_pedido_olist(cr, uid, _pedido, _conta_id, context=context)
            if not _ped_id:
                res['status'] = False
                res['mensagem'] = ''
        return res

    # def pedcap_cancelar_pedido_no_mkp(self, cr, uid, brw_pedido, context=None):
    #     """
    #     Metodo para cancelar pedio no mkp, deve ser sobrescrito por cada marketplace
    #     :param cr:
    #     :param uid:
    #     :param brw_pedido:
    #     :param context:
    #     :return:
    #     """
    #     context = context and context.copy() or {}
    #     if brw_pedido.pedcap_integrador == 'SkyHub':
    #         res = self.pool.get('mkp.skyhub').mkpSkyHub_cancelar_pedido(cr, uid,
    #                                                                     brw_pedido.pedcap_conta_id.id,
    #                                                                     brw_pedido.pedcap_nro_pedido_externo,
    #                                                                     context=context)
    #         res = True
    #     else:
    #         res = super(estoquepedidos_pedido_capa, self).pedcap_cancelar_pedido_no_mkp(cr, uid,
    #                                                                                     brw_pedido,
    #                                                                                     context=context)
    #     return res

    def pedcap_ver_se_pode_faturar(self, cr, uid, id, context=None):
        """
        Metodo para verificar se todos pedidos estão pagos, deve ser sobrescrito por metodo de cada marketplace.
        Se retornar um False, não deixar faturar
        :param cr:
        :param uid:
        :param brw_pedido:  browse do pedido
        :return: True-Tudo ok / False-Nao faturar
        """
        context = context and context.copy() or {}
        res = super(estoquepedidos_pedido_capa, self).pedcap_ver_se_pode_faturar(cr, uid, id, context=None)
        if not res:
            return res
        sql = 'select pedcap_integrador, pedcap_mkp_status from estoquepedidos_pedido_capa where id = %s' % id
        cr.execute(sql)
        dados_pedido = cr.dictfetchall()
        if dados_pedido:
            pedcap_integrador = dados_pedido[0].get('pedcap_integrador')
            pedcap_mkp_status = dados_pedido[0].get('pedcap_mkp_status')
        if pedcap_integrador == 'Olist':
            if pedcap_mkp_status not in ('approved', 'invoiced'):
                res = False
        return res
