# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
import logging
import datetime
from SigUtils.sigerp import db_sig
_logger = logging.getLogger(__name__)

class mkp_notificacoes(osv.Model):
    _inherit = "mkp.notificacoes"

    def _mkpnot_get_shipments_olist(self, cr, uid, dados_notificacao, context=None):
        def __registrar_encomenda(encomenda, servico, ped_id, pessoa_id):
            if not (encomenda and servico):
                return {'status': False, 'mensagem': 'Sem codido da ecomenta e/ou do servico'}
            _args = [('name', '=', servico)]
            if servico == 'Correios':
                _args = [('rassvr_codigo', '=', 'CorBra')]
            elif servico == 'JadLog':
                _args = [('rassvr_codigo', '=', 'jadlog')]
            else:
                _args = [('rassvr_codigo', '=', servico)]
            _servico_ids = _spg('rastreio.servicos').search(cr, uid, _args, context=context)
            if not _servico_ids:
                return {'status': False, 'mensagem': 'Servico %s nao encontrado!' % _args[0][2]}
            _servico_id = _servico_ids[0]
            _fields = ['id']
            _args = [('name', '=', encomenda)]
            _dados_encomenda = _db_sig.dbsSelect('rastreio_encomendas', _fields, _args)
            if _dados_encomenda:
                return {'status': True, 'mensagem': '', 'Encomenda': _dados_encomenda[0].get('id')}
            vals_encomenda = {
                'name': encomenda,
                'rasenc_pedido_id': ped_id,
                'rasenc_pessoa_id': pessoa_id,
                'rasenc_compra_venda': 'V',
            }
            _encomenda_id = _db_sig.dbsInsert('rastreio_encomendas', vals_encomenda)
            if _servico_id:
                vals_serv = {
                    'encomenda_id' : _encomenda_id,
                    'servico_id': _servico_id
                }
                _db_sig.dbsInsert('rastreio_encomendas_m2m_servicos', vals_serv, many2many=True)
            return {'status': True, 'mensagem': '', 'encomenda': _encomenda_id}

        def __tratar_pacotes():
            _pdf = dados_pkg.get('shipping_label_url')
            _zpl = dados_pkg.get('zpl_label_url')
            _ship_id = dados_pkg.get('shipment_id')
            _status = dados_pkg.get('status')
            _vals_pack = {
                'mkppko_pedido_id': _ped_id,
                'mkppko_id_pacote': _id_pkg,
                'mkppko_id_shipment': _ship_id or '',
                'mkppko_status': _status,
                'mkppko_pdf': _pdf or '',
                'mkppko_zpl': _zpl or '',
            }
            _fields = ['id']
            _args = [('mkppko_pedido_id', '=', _ped_id), ('mkppko_id_pacote',  '=', _id_pkg)]
            _dados_pacote = _db_sig.dbsSelect('mkp_pacotes_olist', _fields, _args)
            if _dados_pacote:
                _dados_pacote= _dados_pacote[0]
                _pac_id = _dados_pacote.get('id')
                _where = [('id', '=', _pac_id)]
                _db_sig.dbsUpdate('mkp_pacotes_olist', _vals_pack, _where)
            else:
                _pac_id = _db_sig.dbsInsert('mkp_pacotes_olist', _vals_pack)
            _db_sig.conexao.commit()
            return _pac_id


        def __tratar_postagens(postagens):
            for _pack in postagens.get('packages'):
                _cod_rastreio = _pack.get('tracking_code')
                _fields = ['id']
                _args = [('name', '=', _cod_rastreio)]
                _dados_encomenda = _db_sig.dbsSelect('rastreio_encomendas', _fields, _args)
                if not _dados_encomenda:
                    return {'status': False, 'mensagem': 'Encomenda %s nao encontrada!' % _cod_rastreio}
                _data_hora = _pack.get('created_at').replace('T', ' ')[:19]
                _data_hora = datetime.datetime.strptime(_data_hora, '%Y-%m-%d %H:%M:%S')
                _data_hora = self.pool.get('adm.utils').admutl_datetime_to_timezone(cr, uid, _data_hora,
                                                                       formato='%Y-%m-%d %H:%M:%s')[:19]
                _enc_id = _dados_encomenda[0].get('id')
                _track_status = _pack.get('tracking_status')
                _fields = ['id']
                _args = [('raseve_encomenda_id', '=', _enc_id), ('raseve_data_hora', '=', _data_hora)]
                _dados_evento = _db_sig.dbsSelect('rastreio_eventos', _fields, _args)
                if _dados_evento:
                    return {'status': True, 'mensagem': ''}  # Evento já estava registrado
                vals = {
                    'raseve_encomenda_id': _enc_id,
                    'raseve_data_hora': _data_hora,
                    'raseve_evento': _track_status,
                    'raseve_observacao': _track_status,
                }
                _db_sig.dbsInsert('rastreio_eventos', vals)
                _db_sig.conexao.commit()
            return {'status': True, 'mensagem': ''}

        _spg = self.pool.get
        _objeto = dados_notificacao.get('mkpnot_resource').split('/')[1]
        _code = dados_notificacao.get('mkpnot_resource').split('/')[2]
        _conta_id = dados_notificacao.get('mkpnot_conta_id')
        _db_sig = db_sig(self.pool.db_name)
        if _objeto == 'packages':
            res = _spg('mkp.olist').mkpOlist_get_packages(cr, uid, _code, _conta_id)
            if not res.get('status'):
                _db_sig.conexao.close()
                return res
            dados_pkg = res.get('packages')
            _order = dados_pkg.get('seller_order_code')
            _track_code = dados_pkg.get('tracking_code')
            _servico = dados_pkg.get('carrier_name')
            _id_pkg = dados_pkg.get('id')
            _seller_id = dados_pkg.get('seller_id')

            _fields = ['id', 'pessoa_id']
            _args = [('pedcap_nro_pedido_externo', '=', _order)]
            _dados_pedido = _db_sig.dbsSelect('estoquepedidos_pedido_capa', _fields, _args)
            if not _dados_pedido:
                _db_sig.conexao.close()
                return {'status': False, 'mensagem': 'Pedido %s nao encontrado!' % _order}
            _dados_pedido = _dados_pedido[0]
            _ped_id = _dados_pedido.get('id')
            _pessoa_id = _dados_pedido.get('pessoa_id')
            _pac_id = __tratar_pacotes()
            if not _track_code:
                res = _spg('mkp.olist').mkpOlist_set_shipments(cr, uid, _conta_id, _seller_id, _id_pkg, context=None)
                if not res.get('status'):
                    _db_sig.conexao.close()
                    return res
                dados_pkg = res.get('packages')
            else:
                res = __registrar_encomenda(_track_code, _servico, _ped_id, _pessoa_id)
            _db_sig.conexao.close()
            return res
        elif _objeto == 'shipments':
            res = _spg('mkp.olist').mkpOlist_get_shippment(cr, uid, _code, _conta_id)
            if not res.get('status'):
                _db_sig.conexao.close()
                return res
            res = __tratar_postagens(res.get('packages'))
            _db_sig.conexao.close()
            return res
        else:
            _db_sig.conexao.close()
            return {'status': False, 'mensagem': 'Objeto %s nao identificado!' % _objeto}
        if not _track_code:
            _db_sig.conexao.close()
            return {'status': False, 'mensagem': 'A etiqueta ainda nao esta preparada!'}
        _pessoa_id = _dados_pedido.get('pessoa_id')
        _encomenda_id = __registrar_encomenda(_track_code, _servico, _ped_id, _pessoa_id)
        _db_sig.conexao.close()

    def _mkpnot_get_orders_olist(self, cr, uid, dados_notificacao, context=None):
        _spg = self.pool.get
        _order = dados_notificacao.get('mkpnot_resource').split('/')[2]
        _conta_id = dados_notificacao.get('mkpnot_conta_id')
        _dados_conta = _spg('mkp.contas').read(cr, uid, _conta_id, [], context=context)
        dados = _spg('mkp.olist').mkpOlist_get_orders(cr, uid, str(_order), _conta_id)
        if not dados.get('status'):
            return False
        _pedido = dados.get('orders')
        _ped_id = _spg('mkp.utils').mkputl_importar_um_pedido_olist(cr, uid, _pedido, _conta_id, context=context)
        if not _ped_id:
            self._logger.info('Pedido nao importado!')
            return False
        return True

    def _mkpnot_get_itens_olist(self, cr, uid, dados_notificacao, context=None):
        _anuncio = dados_notificacao.get('mkpnot_resource').split('/')[2]
        _spg = self.pool.get
        _anuncio_ids = _spg('mkp.anuncios').search(cr, uid, [('mkpanu_codigo_anuncio', '=', _anuncio)], context=context)
        if not _anuncio_ids:
            _anuncio_var_ids = _spg('mkp.anuncios.var').search(cr, uid, [('mkpanuv_id_no_mkp', '=', _anuncio)], context=context)
            if _anuncio_var_ids:
                _anuncio_ids = [_spg('mkp.anuncios.var').read(cr, uid, _anuncio_var_ids[0], ['mkpanuv_anuncio_id'], context=context).get('mkpanuv_anuncio_id')[0]]
        if _anuncio_ids:
            dados_anuncio = _spg('mkp.anuncios').read(cr, uid, _anuncio_ids, [
                                                                                'id',
                                                                                'mkpanu_codigo_anuncio',
                                                                                'mkpanu_conta_id'
                                                                             ],
                                                                             context=context)
            if dados_anuncio:
                dados_anuncio = dados_anuncio[0]
                dados_anuncioOlist = _spg('mkp.olist').mkpOlist_get_anuncio(cr, uid,
                                                                                dados_anuncio.get('mkpanu_conta_id')[0],
                                                                                dados_anuncio.get('mkpanu_codigo_anuncio'),
                                                                                context=context)
                _status_mkp = dados_anuncioOlist.get('status')
                if _status_mkp == 'rejected':
                    _estado = 'C'
                elif _status_mkp == 'approved':
                    _estado = 'A'
                else:
                    _estado = 'G'
                vals = {
                    'mkpanu_necessita_atualizar': False,
                    'mkpanu_estado_mkp': _status_mkp,
                    'mkpanu_estado': _estado,
                    # 'mkpanu_qtd_vendido': dados_anuncioOlist.get('sales')
                }
                _spg('mkp.anuncios').write(cr, uid, dados_anuncio.get('id'), vals, context=context)
                return True
            self._logger.info('Anuncio nao localizado!')
            return False

    def _mkpnot_processar_notificacao(self, cr, uid, codigo_mkp, notificacao_tipo, dados_notificacao, context=None):
        """
        Metodo qeue sobrescreve o original para tratamento especializado
        :param cr:
        :param uid:
        :param codigo_mkp: Codigo do Marketplace
        :param dados_notificacao: Dados resultado do read de um registro do marketplace, com todos os atributos
        :param context:
        :return:
        """
        context = context and context.copy() or {}
        res = super(mkp_notificacoes, self)._mkpnot_processar_notificacao(cr, uid, codigo_mkp, notificacao_tipo,
                                                                          dados_notificacao, context=context)
        if codigo_mkp == 'Olist':
            if notificacao_tipo == 'items':
                res = self._mkpnot_get_itens_olist(cr, uid, dados_notificacao, context=context)
            elif notificacao_tipo == 'orders':
                res = self._mkpnot_get_orders_olist(cr, uid, dados_notificacao, context=context)
            elif notificacao_tipo == 'shipments':
                res = self._mkpnot_get_shipments_olist(cr, uid, dados_notificacao, context=context)
            # elif notificacao_tipo == 'invoices':
            #     res = self._mkpnot_get_invoice_olist(cr, uid, dados_notificacao, context=context)
            # # elif notificacao_tipo == 'payments':
            # #     res = True
            # elif notificacao_tipo == 'claims':
            #     res = True
        return res
