# -*- encoding: utf-8 -*-
import re
from urllib import urlencode
from openerp.tools import config
import requests
from openerp import pooler
import logging
from openerp.tools.translate import _
from SigUtils.geralogs import geraLogs

_logger = logging.getLogger('Olist')



class Olist(object):
    def logged_client(f):
        """Decorator for User Credentials checking."""
        def inner(self, *args, **kargs):
            if ((self.client_id is None) or (self.client_secret is None)):
                raise Exception, _("Nao posso acessar o Olist. parametros do Olist nao informados!")
            return f(self, *args, **kargs)
        return inner

    def __init__(self, cr=False, uid=False, conta_id=False, company_id=False):
        self.API_ROOT_URL = 'https://partners-api.olist.com/v1'
        # self.API_ROOT_URL = 'https://api-sandbox.olist.com/v1'
        self.SDK_VERSION = 'SIG.1.01'
        self.AUTH_URL = 'https://id.olist.com'
        # self.AUTH_URL = 'https://id-sandbox.olist.com'
        self.OAUTH_URL = 'openid/authorize'
        self.cr = cr
        self.uid = uid
        self.client_id = ''
        self.client_secret = ''
        self.access_token = ''
        self.id_token = ''
        self.refresh_token = ''
        self.code = ''
        self.redirect_url = ''
        self.seller = ''
        self.habilitar_log = False
        self.conta_id = ''
        self.email = ''
        self.seller = ''
        self.comunicar = True
        if cr:
            _poolget = pooler.get_pool(cr.dbname).get
            mkp_ids = _poolget('mkp.marketplaces').search(cr, uid, [('mkpmkp_codigo', '=', 'Olist')])
            if mkp_ids:
                mkp_ids = mkp_ids[0]
                dados_marketplace = _poolget('mkp.marketplaces').read(cr, uid, mkp_ids, [])
                if dados_marketplace.get('mkpmkp_parar_comunicacao'):
                    self.comunicar = False
                if not conta_id:
                    conta_id = _poolget('mkp.contas').search(cr, uid, [('mkpcta_marketplace_id', '=', mkp_ids)])
                    if conta_id:
                        conta_id = conta_id[0]
                if conta_id:
                    self.conta_id = conta_id
                    dados_conta = _poolget('mkp.contas').read(cr, uid, conta_id, [])
                    if dados_conta.get('mkpcta_parar_comunicacao'):
                        self.comunicar = False
                    self.client_id = dados_conta.get('mkpcta_ol_client_id')
                    self.client_secret = dados_conta.get('mkpcta_ol_secret_key')
                    self.id_token = dados_conta.get('mkpcta_ol_id_token')
                    self.access_token = dados_conta.get('mkpcta_ol_token')
                    self.refresh_token = dados_conta.get('mkpcta_ol_refresh_token')
                    self.redirect_url = dados_conta.get('mkpcta_ol_redirect_url')
                    self.code = dados_conta.get('mkpcta_ol_code')
                    self.email = dados_conta.get('mkpcta_ol_user_email')
                    self.habilitar_log = dados_marketplace.get('mkpmkp_habilita_log')

    def _get_arq_log(self):
        _arq_log = 'mkp_Olist_' + self.cr.dbname
        return _arq_log
    
    def _gerar_logs(self, mens):
        _diretorio = config.get('logfile')
        if _diretorio:
            _lista = _diretorio.split('/')
            _lista.pop(len(_lista) -1)
            _diretorio = '/'.join(_lista)
        else:
            _diretorio = '/var/log/openerp'
        _arq_log = self._get_arq_log()
        try:
            geraLogs(_arq_log, mens, 'S', _diretorio)
        except:
            try:
                geraLogs(_arq_log, mens.encode('ASCII', 'ignore'), 'S', _diretorio)
            except:
                geraLogs(_arq_log, 'Nao consegui registrar o log', 'S', _diretorio)
        return True

    #AUTH METHODS
    def auth_url(self):
        params = {
            'client_id': str(self.client_id),
            'response_type': 'code',
            'scope': str('openid %s profile' % self.email),
            'redirect_uri': str(self.redirect_url),
            'state': str(self.client_secret),
        }
        url = self.AUTH_URL + '/' + self.OAUTH_URL + '?' + urlencode(params)
        return url


    def authorize(self):
        params = {
            'code': str(self.code),
            'client_id': self.shop_id,
            'client_secret': self.client_secret,
            'redirect_uri': self.redirect_url,
            'grant_type': 'authorization_code',
        }
        headers = {
            'Content-Type': 'application/x-www-form-urlencoded'
        }
        uri = self.AUTH_URL + '/openid/token'
        if self.habilitar_log:
            self._gerar_logs('Olist.Authorize-> %s -> %s' % (uri, params))
        response = requests.post(uri, data=urlencode(params), headers=headers)
        if self.habilitar_log:
            if response.status_code == 200:
                mens = response.content
            else:
                mens = response
            self._gerar_logs('Olist.resposta--> %s ' % mens)
            
        if response.status_code == requests.codes.ok:
            response_info = response.json()
            self.id_token = response_info['id_token']
            self.access_token = response_info['access_token']
            self.refresh_token = response_info['refresh_token']
            return self.access_token
        else:
            # response code isn't a 200; raise an exception
            response.raise_for_status()

    def get_refresh_token(self):
        obj_utils = pooler.get_pool(self.cr.dbname).get('adm.utils')
        if self.refresh_token:
            params = {
                'client_id': self.client_id,
                'client_secret': self.client_secret,
                'refresh_token': self.refresh_token,
                'grant_type': 'refresh_token',
            }
            headers = {
                'Content-Type': 'application/x-www-form-urlencoded'
            }
            uri = self.AUTH_URL + '/openid/token'

            if self.habilitar_log:
                self._gerar_logs('Olist.Authorize-> %s -> %s' % (uri, params))
            response = requests.post(uri, data=urlencode(params), headers=headers)
            if self.habilitar_log:
                if response.status_code == 200:
                    msg = response.content
                else:
                    msg = response
                    try:
                        msg = '%s - %s' % (response, response.content)
                    except:
                        pass
                self._gerar_logs('Olist.resposta--> %s ' % msg)

            if response.status_code == requests.codes.ok:
                response_info = response.json()
                self.access_token = response_info['access_token']
                self.id_token = response_info['id_token']
                self.refresh_token = response_info['refresh_token']
                if self.cr:
                    vals = {
                        'mkpcta_ol_token': self.access_token,
                        'mkpcta_ol_id_token': self.id_token,
                        'mkpcta_ol_refresh_token': self.refresh_token
                    }
                    pooler.get_pool(self.cr.dbname).get('mkp.contas').write(self.cr, self.uid, self.conta_id, vals)
                return self.access_token, self.refresh_token
            else:
                # response code isn't a 200; raise an exception
                return False, False
        else:
            self._gerar_logs('Olist.resposta--> refresh token nao cadastrado!')
            return (False, False)

    # REQUEST METHODS
    def make_path(self, path, params={}):
        # Making Path and add a leading / if not exist
        if not (re.search("^http", path)):
            if not (re.search("^\/", path)):
                path = "/" + path
            path = self.API_ROOT_URL + path
        if params:
            path = path + "?" + urlencode(params)
        return path

    @logged_client
    def olist_comunicar(self, metodo, uri, dados=None, params=None):
        def comunicar():
            if self.habilitar_log:
                self._gerar_logs('%s-> URL:%s Body: %s Header: %s' % (metodo.upper(), str(uri),
                                                                                              str(dados),
                                                                                              str(headers)))

            if dados:
                response = requests.request(metodo, uri, json=dados, headers=headers)
            else:
                response = requests.request(metodo, uri, headers=headers, params=params)
            if self.habilitar_log:
                self._gerar_logs('Olist.resposta--> %s ' % response.content)
            return response

        if not params:
            params = {}
        if not self.comunicar:
            class resp(object):
                status_code = 999
                content = '{"message":"Comunicacao parada"}'
            return resp

        headers = {
            'Accept': 'application/json',
            'Authorization': 'JWT %s' % str(self.id_token),
            'Content-Type': 'application/json'
        }
        uri = self.make_path(uri)
        response = comunicar()
        if (response.status_code == 403 or
            (response.status_code == 200 and 'JWT has expired' in response.content)):
            _access_token, refresh_token = self.get_refresh_token()
            if _access_token:
                headers.update(
                    {
                        'Authorization': 'JWT %s' % str(self.id_token),
                    }
                )
                response = comunicar()
        return response

