# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################
from openerp.osv import osv
from openerp.tools.translate import _
import logging
from ..ptsp import Ptsp
import base64
import time

# Classe de alto nivel para comunicação com o Prestashop
class mkp_PrtShp(osv.Model):
    _name = 'mkp.prtshp'
    _auto = False
    _tem_erro = False
    _mensagem_erro = ''
    _logger = logging.getLogger(_name)

    def mkpPrtShp_imagem_cadastrar(self, cr, uid, conta_id, brw_mkp_produto_mkp, codigo, force = False, context={}):

        context = context and context.copy() or {}
        ps_con = Ptsp(cr, uid, conta_id)
        recurso = 'images/products/%s' % codigo
        _st = True
        _msg = None
        res = {}
        _grades = {}
        _todas = []
        for brw_image in brw_mkp_produto_mkp.mkpromkp_imagens_ids:
            if not brw_image.mkprmkimg_codigo_no_mkp:
                _arq = '/tmp/ps_%s.jpg' % time.time()
                dados_PrtShp = ps_con.set(recurso, files=[('image', _arq, base64.b64decode(brw_image.mkprmkimg_foto))])
                if dados_PrtShp and dados_PrtShp.get('status'):
                    _cod =  dados_PrtShp.get('resposta').get('prestashop').get('image').get('id')
                    if not res.get('default_image'):
                        res['default_image'] = _cod
                    if brw_image.estimg_grade_id:
                        if not _grades.get(brw_image.estimg_grade_id.grade):
                            _grades[brw_image.estimg_grade_id.grade] = []
                        _grades[brw_image.estimg_grade_id.grade].append({'id':_cod})
                    else:
                        _todas.append({'id': brw_image.mkprmkimg_codigo_no_mkp})
                    dados = {'mkprmkimg_codigo_no_mkp':_cod, 'mkprmkimg_endereco_mkp': ''}
                    self.pool.get('mkp.produto.marketplace.imagens').write(cr, uid, brw_image.id, dados, context=context)
                    cr.commit() # comitar porque já atualizaou o Prestashop
            else:
                if not res.get('default_image'):
                    res['default_image'] = brw_image.mkprmkimg_codigo_no_mkp
                if brw_image.estimg_grade_id:
                    if not _grades.get(brw_image.estimg_grade_id.grade):
                        _grades[brw_image.estimg_grade_id.grade] = []
                    _grades[brw_image.estimg_grade_id.grade].append({'id':brw_image.mkprmkimg_codigo_no_mkp})
                else:
                    _todas.append({'id':brw_image.mkprmkimg_codigo_no_mkp})
        if _todas:
            for _grade in _grades:
                for x in _todas:
                    _grades[_grade].append(x)
        res['grades'] = _grades
        return {'status': _st, 'message': _msg, 'imgs': res}


    def mkpPrtShp_get_languages(self, cr, uid, conta_id, codigo_language, context=None):
        context = context and context.copy() or {}
        ps_con = Ptsp(cr, uid, conta_id)
        recurso = 'languages'
        recurso_id = codigo_language or ''
        dados_PrtShp = ps_con.get(recurso, recurso_id)
        return dados_PrtShp

    def _mkpPrtShp_get_lang_ids(self, cr, uid, conta_id, context=None):
        res_lang = self.mkpPrtShp_get_languages(cr, uid, conta_id, '', context=None)
        lang_ids = []
        if res_lang and res_lang.get('status'):
            langs = res_lang.get('resposta').get('languages').get('language')
            if isinstance(langs, (list, tuple)):
                for lang in langs:
                    lang_ids.append(lang.get('attrs').get('id'))
            else:
                lang_ids.append(res_lang.get('resposta').get('languages').get('language').get('attrs').get('id'))
        return lang_ids

    def _mkpPrtShp_get_uma_ordem(self, cr, uid, conta_id, pedido, context=None):
        context = context and context.copy() or {}
        ps_con = Ptsp(cr, uid, conta_id)
        res = {}
        recurso = 'orders'
        dados_PrtShp = ps_con.get(recurso, pedido)
        return dados_PrtShp

    def _mkpPrtShp_get_pedido(self, cr, uid, conta_id, pedido, context=None):
        context = context and context.copy() or {}
        ps_con = Ptsp(cr, uid, conta_id)
        res = {}
        dados_PrtShp = self._mkpPrtShp_get_uma_ordem(cr, uid, conta_id, pedido, context=context)
        if dados_PrtShp and dados_PrtShp.get('status'):
            res = dados_PrtShp.get('resposta').get('order')
            recurso = 'customers'
            dados_PrtShp = ps_con.get(recurso, res.get('id_customer'))
            if dados_PrtShp and dados_PrtShp.get('status'):
                res['customer'] = dados_PrtShp.get('resposta').get('customer')
            recurso = 'addresses'
            dados_PrtShp = ps_con.get(recurso, res.get('id_address_delivery'))
            if dados_PrtShp and dados_PrtShp.get('status'):
                res['addresses'] = dados_PrtShp.get('resposta').get('address')
        return res



    def _mkpPrtShp_get_saldo_ids(self, cr, uid, conta_id, product_id, context=None):
        context = context and context.copy() or {}
        res = []
        ps_con = Ptsp(cr, uid, conta_id)
        recurso = 'products'
        dados_PrtShp = ps_con.get(recurso, product_id)
        if dados_PrtShp and dados_PrtShp.get('status'):
            stocks = dados_PrtShp.get('resposta').get('product').get('associations').get('stock_availables')
            if isinstance(stocks, (list, tuple)):
                for x in stocks.get('id'):
                    res.append((x.get('id'), x.get('id_product_attribute')))
            else:
                res.append((stocks.get('id'), stocks.get('id_product_attribute')))
        return res

    def mkpPrtShp_get_stock(self, cr, uid, conta_id, codigo, context=None):
        context = context and context.copy() or {}
        ps_con = Ptsp(cr, uid, conta_id)
        recurso = 'stock_availables'
        recurso_id = codigo or ''
        dados_PrtShp = ps_con.get(recurso, recurso_id)
        return dados_PrtShp

    def mkpPrtShp_get_categories(self, cr, uid, conta_id, codigo_categoria, context=None):
        context = context and context.copy() or {}
        ps_con = Ptsp(cr, uid, conta_id)
        recurso = 'categories'
        recurso_id = codigo_categoria or ''
        dados_PrtShp = ps_con.get(recurso, recurso_id)
        return dados_PrtShp

    def mkpPrtShp_set_categories(self, cr, uid, conta_id, codigo, categoria, categoria_pai, context=None):
        context = context and context.copy() or {}
        if not categoria:
            return {'status': False, 'mensagem': 'Faltou a descricao da categoria'}
        ps_con = Ptsp(cr, uid, conta_id)
        lang_ids = self._mkpPrtShp_get_lang_ids(cr, uid, conta_id, context=context)
        name = []
        link_rewrite = []
        for lang_id in lang_ids:
            name.append({'attrs':{'id': str(lang_id)}, 'value': categoria})
            link_rewrite.append({'attrs': {'id': str(lang_id)}, 'value': '1'})
        data = {
            'category':
                    {
                        'active': '1',
                        'name': {'language': name},
                        'link_rewrite': {'language': link_rewrite},
                        'id_shop_default': '1',
                    }
        }
        if categoria_pai:
            data['category']['id_parent'] = categoria_pai
            data['category']['is_root_category'] = '0'
        else:
            data['category']['is_root_category'] = '1'
            data['category']['id_parent'] = '1' # Sempre que que ter pai
        if  codigo:
            data['category']['id'] = codigo
        recurso = 'categories'
        dados_PrtShp = ps_con.set(recurso, data, codigo)
        return dados_PrtShp


    def mkpPrtShp_get_anuncios(self, cr, uid, conta_id, codigo_produto, context=None):
        context = context and context.copy() or {}
        ps_con = Ptsp(cr, uid, conta_id)
        recurso = 'products'
        recurso_id = codigo_produto or ''
        dados_PrtShp = ps_con.get(recurso, recurso_id)
        # Remover attributos que não podem ser alterados
        dados_PrtShp.get('resposta').get('product').pop('manufacturer_name')
        dados_PrtShp.get('resposta').get('product').pop('quantity')
        dados_PrtShp.get('resposta').get('product').pop('position_in_category')
        return dados_PrtShp

    def mkpPrtShp_get_set_product_options(self, cr, uid, conta_id, dados, context=None):
        """
        Metodo para pesquisar e/ou cadastrar os nomes das grades e seus atributos(cores, tamanhos, etc)
        :param cr:
        :param uid:
        :param conta_id:
        :param dados: dicionario ex: {'descricao': 'Cor', 'id':'5', attrs':[{'id': 10, 'descricao':'Branco'},{'id':11, 'descricao':'Preto'}
        :param context:
        :return: o mesmo campo dados, porem populado com os ids. Qdo houver erro, não vai retornar id
        """
        context = context and context.copy() or {}
        ps_con = Ptsp(cr, uid, conta_id)
        recurso = 'product_options'
        lang_ids = self._mkpPrtShp_get_lang_ids(cr, uid, conta_id, context=context)
        # Pesquisar a descrição das grades, ex.: cor, Tamanho, etc...
        x = ps_con.search(recurso, {'filter[name]': '[%s]' % dados.get('descricao')})
        _grade_description_id = False
        if x and x.get('status'):
            _grade_description_id = x.get('resposta')
            if isinstance(_grade_description_id, list) and len(_grade_description_id) > 0:
                _grade_description_id = _grade_description_id[0]
        if not _grade_description_id: # Cadastrar a descrição das grades ex.: 'Cor', 'Tamanho', etc
            data_gr_descr = {'product_option': {}}
            name = []
            for lang_id in lang_ids:
                name.append({'attrs': {'id': str(lang_id)}, 'value': dados.get('descricao')})
            data_gr_descr['product_option']['is_color_group'] = 0
            data_gr_descr['product_option']['group_type'] = 'select'
            data_gr_descr['product_option']['name'] = {'language': name}
            data_gr_descr['product_option']['public_name'] = {'language': name}
            dados_grade_description = ps_con.set(recurso, data_gr_descr)
            if dados_grade_description and dados_grade_description.get('status'):
                _grade_description_id = dados_grade_description.get('resposta').get('prestashop').get('product_option').get(
                    'id')
            else:
                dados['id'] = None
                return dados
        dados['id'] = _grade_description_id
        # Pesquisar todas as grades de uma descricao, ex: 'Branco', 'Preto', etc
        recurso = 'product_option_values'
        x = ps_con.search(recurso, {'filter[id_attribute_group]': '[%s]' % _grade_description_id})
        if x and x.get('status'):
            for _grade_id in x.get('resposta'):
                dados_PrtShp = ps_con.get(recurso, _grade_id)
                _name = dados_PrtShp.get('resposta').get('product_option_value').get('name')
                _nome_id = dados_PrtShp.get('resposta').get('product_option_value').get('id')
                if isinstance(_name, (list, tuple)):
                    _nome = _name[0].get('language').get('value')
                else:
                    _nome = _name.get('language').get('value')
                for _attrs in  dados.get('attrs'):
                    if _attrs.get('descricao') == _nome:
                        _attrs['id'] = _nome_id
                        break
            # cadastrar os atributos que ainda não tem
            for _attrs in dados.get('attrs'):
                if _attrs.get('id'):
                    continue
                name = []
                for lang_id in lang_ids:
                    name.append({'attrs': {'id': str(lang_id)}, 'value': _attrs.get('descricao')})
                vals= {recurso: {'name':{'language': name},'id_attribute_group': _grade_description_id}}
                dados_PrtShp = ps_con.set(recurso, vals, '')
                if dados_PrtShp and dados_PrtShp.get('status'):
                    _attrs ['id'] = dados_PrtShp.get('resposta').get('prestashop').get('product_option_value').get('id')
        return dados

    def mkpPrtShp_set_anuncios(self, cr, uid, brw_anuncio, context=None):
        context = context and context.copy() or {}
        obj_mkpromkp = self.pool.get('mkp.produto.marketplaces')
        obj_categoria = self.pool.get('mkp.categorias')
        obj_variacoes = self.pool.get('mkp.anuncios.var')
        mkp_id = brw_anuncio.mkpanu_marketplace_id.id
        args = [('mkpromkp_produto_id', '=', brw_anuncio.mkpanu_produto_id.id), ('mkpromkp_marketplace_id', '=', mkp_id)]
        mkp_produto_mkp_ids = obj_mkpromkp.search(cr, uid, args, context=context)
        if not mkp_produto_mkp_ids:
            return {'status': True} # Não tem nanuncio para atualizar
        brw_mkp_produto_mkp = obj_mkpromkp.browse(cr, uid, mkp_produto_mkp_ids, context=context)[0]
        if not brw_mkp_produto_mkp.mkpromkp_categoria_id:
            return {'status': False, 'mensagem': _('Nao tem categoria cadastrada no produto para o Marketplace')}
        if brw_mkp_produto_mkp.mkpromkp_categoria_id.mkpcat_codigo:
            ps_categ_id = brw_mkp_produto_mkp.mkpromkp_categoria_id.mkpcat_codigo
        else:
            categ_ids = [brw_mkp_produto_mkp.mkpromkp_categoria_id.id]
            ps_categ_id = obj_categoria.mkpcat_ps_categoria_atualizar(cr, uid, categ_ids, context=None)
        conta_id = brw_anuncio.mkpanu_conta_id.id
        ps_con = Ptsp(cr, uid, conta_id)
        lang_ids = self._mkpPrtShp_get_lang_ids(cr, uid, conta_id, context=context)
        _Pname = brw_anuncio.mkpanu_title
        _Pprice = brw_anuncio.mkpanu_valor_promocao or brw_anuncio.mkpanu_valor or brw_anuncio.mkpanu_valor_sugerido
        _Pcateg = ps_categ_id
        _usar_grade = brw_mkp_produto_mkp.mkpromkp_produto_id.grade_usar
        _grade_description_id = None
        if _usar_grade: # Cadastrar a descrição da grade e as grades
            if not  brw_mkp_produto_mkp.mkpromkp_produto_id.estpro_grade_descricao:
                return {'status': False, 'mensagem': _('Produto %s sem "Descricao da grade" !') % brw_mkp_produto_mkp.mkpromkp_produto_id.codigo}
            _grade_description_name = brw_mkp_produto_mkp.mkpromkp_produto_id.estpro_grade_descricao.strip().capitalize()
            _attrs = []
            for brw_grade in brw_mkp_produto_mkp.mkpromkp_produto_id.produto_grade_ids:
                _attrs.append({'descricao': brw_grade.descricao, 'grade': brw_grade.grade})
            dados_product_option = {'descricao': _grade_description_name, 'attrs': _attrs}
            dados_product_option = self.mkpPrtShp_get_set_product_options(cr, uid, conta_id, dados_product_option, context=None)
            if not dados_product_option.get('id'):
                return {'status': False, 'mensagem': _('Nao consegui cadastrar a descricao da grade no Markeplace!')}

        name = []
        link_rewrite = []
        description = []
        description_short = []
        for lang_id in lang_ids:
            name.append({'attrs':{'id': str(lang_id)}, 'value': _Pname})
            link_rewrite.append({'attrs': {'id': str(lang_id)}, 'value': '1'})
            description.append({'attrs': {'id': str(lang_id)}, 'value':  brw_anuncio.mkpanu_descricao_texto})
            description_short.append({'attrs': {'id': str(lang_id)}, 'value':  _Pname})
        data_prod = {'product':{}}
        codigo = brw_anuncio.mkpanu_codigo_anuncio
        if codigo:
            res = self.mkpPrtShp_get_anuncios(cr, uid, conta_id, codigo, context=context)
            if res and res.get('status'):
                data_prod = res.get('resposta')
        else:
            data_prod['product']['associations'] = {}
            data_prod['product']['associations']['categories'] = {}
        data_prod['product']['active'] = '1'
        data_prod['product']['name'] = {'language': name}
        data_prod['product']['link_rewrite'] = {'language': link_rewrite}
        data_prod['product']['available_for_order'] = '1'
        data_prod['product']['price'] = _Pprice
        data_prod['product']['condition'] = 'new'
        data_prod['product']['description'] = {'language': description}
        data_prod['product']['description_short'] = {'language': description_short}
        data_prod['product']['meta_description'] = {'language': name}
        data_prod['product']['show_price'] = 1
        data_prod['product']['id_category_default'] = _Pcateg

        # Identificar as grades do produto e as variações do anuncio já cadastrados
        _grades = {}
        for brw_grade in brw_anuncio.mkpanu_produto_id.produto_grade_ids:
            _grades[brw_grade.grade] = {}
            _grades[brw_grade.grade]['id'] = brw_grade.id
            _grades[brw_grade.grade]['sku'] = '%s-%s' % (brw_grade.produto_id.codigo, brw_grade.grade)
            for brw_cod_barras in brw_grade.codigo_barra_ids:
                if brw_cod_barras.active and brw_cod_barras.autcba_tipo_barra == '13':
                    _grades[brw_grade.grade]['ean'] = brw_cod_barras.codigo_barra[1:]
            _grades[brw_grade.grade]['saldo'] =  int(brw_grade.saldo / brw_anuncio.mkpanu_quantidade)
            args_var = [('mkpanuv_anuncio_id', '=', brw_anuncio.id), ('mkpanuv_grade_id', '=', brw_grade.id)]
            var_ids = obj_variacoes.search(cr, uid, args_var, context=context)
            if var_ids:
                _grades[brw_grade.grade]['variacao_id'] = var_ids[0] # Sempre é apenas 1 registro
                dados_var = obj_variacoes.read(cr, uid, var_ids[0], [], context=context)
                _grades[brw_grade.grade]['cod_comb'] = dados_var.get('mkpanuv_id_no_mkp')

        # Cadastrar o produto para depois cadastrar grades, saldos e imagens
        recurso = 'products'
        dados_PrtShp = ps_con.set(recurso, data_prod, codigo)
        if codigo:
            data_prod['product']['id'] = codigo
        if dados_PrtShp and not dados_PrtShp.get('status'):
            return dados_PrtShp
        if not codigo:
            codigo = dados_PrtShp.get('resposta').get('prestashop').get('product').get('id')
        vals_anuncio = {'mkpanu_codigo_anuncio': codigo, 'mkpanu_anuncio_endereco': ''}
        self.pool.get('mkp.anuncios').write(cr, uid, brw_anuncio.id, vals_anuncio, context=context)
        cr.commit() # Comitar, porque já foi inserido no prestashop

        data_comb = dados_PrtShp.get('resposta').get('prestashop').get('product').get('associations').get('combinations') #Todo: Confirmar retorno qdo tiver combination
        data_categories = []
        brw_x = brw_mkp_produto_mkp.mkpromkp_categoria_id
        while True:
            if brw_x.mkpcat_codigo:
                data_categories.append({'id': brw_x.mkpcat_codigo})
            if brw_x.parent_id:
                brw_x = brw_x.parent_id
            else:
                break

        # Cadastrar as imagens para o produto
        dados_imagem = self.mkpPrtShp_imagem_cadastrar(cr, uid, conta_id, brw_mkp_produto_mkp, codigo, force = False, context={})
        res = self.mkpPrtShp_get_anuncios(cr, uid, conta_id, codigo, context=context)
        if res and res.get('status'):
            data_prod = res.get('resposta')
        if dados_imagem and dados_imagem.get('status'):
            if dados_imagem.get('imgs').get('default_image'):
                data_prod['product']['id_default_image'] = dados_imagem.get('imgs').get('default_image')

        data_prod['product']['associations']['categories'] = {}
        data_prod['product']['associations']['categories']['category'] = data_categories
        dados_PrtShp = ps_con.set(recurso, data_prod, codigo)
        _maior_saldo = 0
        _mensagens_ret = []
        for gr_key in _grades:
            data_comb = {'combination': {}}
            if _usar_grade:
                # Associar as grades, imagens, saldo e cadastrar demais dados da grade no prestashop
                data_comb['combination']['minimal_quantity'] = '1'
                if int(_grades.get(gr_key).get('saldo')) > _maior_saldo:
                    data_comb['combination']['default_on'] = '0'
                    _maior_saldo = int(_grades.get(gr_key).get('saldo'))
                data_comb['combination']['id_product'] = codigo
                data_comb['combination']['reference'] = _grades.get(gr_key).get('sku')
                if _grades.get(gr_key).get('ean'):
                    data_comb['combination']['ean13'] = _grades.get(gr_key).get('ean')
                recurso = 'combinations'
                data_comb['combination']['associations'] = {}
                data_comb['combination']['associations']['product_option_values'] = {}
                for gr in dados_product_option.get('attrs'):
                    if gr.get('grade') == gr_key:
                        data_comb['combination']['associations']['product_option_values']['product_option_value'] = {'id': gr.get('id')}
                        break
                data_comb['combination']['associations']['images'] = {}
                data_comb['combination']['associations']['images']['image'] = dados_imagem.get('imgs').get('grades').get(gr_key)
                cod_comb = _grades.get(gr_key).get('cod_comb', None)
                var_id = _grades.get(gr_key).get('variacao_id', None)
                if cod_comb:
                    data_comb['combination']['id'] = cod_comb
                dados_PrtShp = ps_con.set(recurso, data_comb, cod_comb)
                if not cod_comb:
                    if dados_PrtShp and dados_PrtShp.get('status'):
                        cod_comb = dados_PrtShp.get('resposta').get('prestashop').get('combination').get('id')
                    else:
                        _sts = dados_PrtShp.get('message')
                        if not _sts in _mensagens_ret:
                            _mensagens_ret.append(_sts)
                        continue
                        # return {'status': False, 'mensagem': _('Nao consegui cadastrar a grade no MKP!')}
                _grades[gr_key]['variacao_id'] = var_id
                if not var_id:
                    vals = {'mkpanuv_anuncio_id': brw_anuncio.id,
                           'mkpanuv_grade_id': _grades.get(gr_key).get('id'),
                           'mkpanuv_id_no_mkp': cod_comb,
                           }
                    obj_variacoes.create(cr, uid, vals, context=context)
                    cr.commit() # Persistir, porque ja cadastrou a grade mo Prestashop
                dados_PrtShp = self.mkpPrtShp_get_anuncios(cr, uid, conta_id, codigo, context=context) # Pegar produto novamente porque acrescentou nova grade
                dados_saldo = dados_PrtShp.get('resposta').get('product').get('associations').get(
                    'stock_availables')  # Atualizar dados saldo de novo, porque incluir uma grade(combinação)
                if isinstance(dados_saldo.get('stock_available'), dict):
                    dados_saldo = {'stock_available': [dados_saldo.get('stock_available')]}
                for estoque in dados_saldo.get('stock_available'):
                    if estoque.get('id_product_attribute') != cod_comb:
                        continue
                    _stock_id = estoque.get('id')
                    res = self.mkpPrtShp_get_stock(cr, uid, conta_id, _stock_id, context=context)
                    if res and res.get('status'):
                        data_stock_available = res.get('resposta')
                        data_stock_available['stock_available']['quantity'] = int(_grades.get(gr_key).get('saldo'))
                        res = ps_con.set('stock_availables', data_stock_available, _stock_id)
                    else:
                        return res
            else:
                res = self.mkpPrtShp_get_anuncios(cr, uid, conta_id, codigo, context=context)
                if res and res.get('status'):
                    data_prod = res.get('resposta')
                # Cadastrar demais dados para o produto que não usa grade
                data_prod['product']['reference'] = _grades.get(gr_key).get('sku')
                data_prod['product']['price'] = _Pprice
                if _grades.get(gr_key).get('ean'):
                    data_prod['product']['ean13'] = _grades.get(gr_key).get('ean')
                dados_saldo = dados_PrtShp.get('resposta').get('prestashop').get('product').get('associations').get(
                    'stock_availables')
                _stock_id = dados_saldo.get('stock_available').get('id')
                res = self.mkpPrtShp_get_stock(cr, uid, conta_id, _stock_id, context=context)
                if res and res.get('status'):
                    data_stock_available = res.get('resposta')
                    data_stock_available['stock_available']['quantity'] = int(_grades.get(gr_key).get('saldo'))
                    res = ps_con.set('stock_availables', data_stock_available, _stock_id)
                else:
                    return res
                recurso = 'products'
                if codigo:
                    data_prod['product']['id'] = codigo
                dados_PrtShp = ps_con.set(recurso, data_prod, codigo)
        if _mensagens_ret:
            return {'status': False, 'mensagem': _('Nao consegui cadastrar uma ou mais grade no MKP! Mens:%s' % str(_mensagens_ret))}

        return dados_PrtShp
        #imagens tratar


    def mkpPrtShp_atualizar_saldo(self, cr, uid, anuncio_id, context=None):
        """
        Altera saldo dos anuncio no site do Prestashop
        @param cr:
        @param uid:
        @param anuncio_id: ids do anuncio a ser alterado
        @param context:
        @return: dicionario contendo id do anuncio e response ex.:{status: True/False, 'mensagem': 'Mensagem'}
                 response. quando response.raise_for_status() for None, tá tudo certo. Para pegar o erro use response.status_code
        """
        context = context and context.copy() or {}
        obj_anuncio = self.pool.get('mkp.anuncios')
        obj_grade = self.pool.get('estoque.produto.grade')
        brw_anuncio = obj_anuncio.browse(cr, uid, anuncio_id, context=context)
        conta_id = brw_anuncio.mkpanu_conta_id.id
        ps_con = Ptsp(cr, uid, conta_id)
        _local = brw_anuncio.mkpanu_conta_id.mkpcta_local_id.id
        # Verificar situacao do anuncio no M.L.
        if not brw_anuncio.mkpanu_codigo_anuncio:
            res = {'status': True, 'mensagem': ''}
            return res
        dados_PrtShp = self.mkpPrtShp_get_anuncios(cr, uid, conta_id, brw_anuncio.mkpanu_codigo_anuncio, context=context)
        if brw_anuncio.mkpanu_produto_id.grade_usar:
            dados_saldo = dados_PrtShp.get('resposta').get('product').get('associations').get('stock_availables').get('stock_available')
        else:
            dados_saldo = [dados_PrtShp.get('resposta').get('product').get('associations').get('stock_availables').get('stock_available')]
        for x in dados_saldo:
            if brw_anuncio.mkpanu_produto_id.grade_usar:
                if x.get('id_product_attribute') == '0':
                    continue
                for a in brw_anuncio.mkpanu_variacoes_ids:
                    if a.mkpanuv_id_no_mkp == x.get('id_product_attribute'):
                        _stock_id = x.get('id')
                        context['company_id'] = brw_anuncio.company_id.id
                        _x = obj_grade.estpgr_get_saldo(cr, uid, [a.mkpanuv_grade_id.id], 'D', _local, context=context)
                        res = self.mkpPrtShp_get_stock(cr, uid, conta_id, _stock_id, context=context)
                        if res and res.get('status'):
                            data_stock_available = res.get('resposta')
                            data_stock_available['stock_available']['quantity'] = int(_x.get(a.mkpanuv_grade_id.id) / brw_anuncio.mkpanu_quantidade) if _x.get(a.mkpanuv_grade_id.id) > 0 else 0,
                            res = ps_con.set('stock_availables', data_stock_available, _stock_id)
                            break
            else:
                _stock_id = x.get('id')
                res = self.mkpPrtShp_get_stock(cr, uid, conta_id, _stock_id, context=context)
                if res and res.get('status'):
                    data_stock_available = res.get('resposta')
                    data_stock_available['stock_available']['quantity'] = int(brw_anuncio.mkpanu_saldo)
                    res = ps_con.set('stock_availables', data_stock_available, _stock_id)
        res = {'status': True, 'mensagem': ''}
        return res

    def mkpPrtShp_pesquisar_orders(self, cr, uid, conta_id, context=None):
        context = context and context.copy() or {}
        ps_con = Ptsp(cr, uid, conta_id)
        peds = []
        dados_conta = self.pool.get('mkp.contas').read(cr, uid, conta_id, [])
        _ultimo_pedido = dados_conta.get('mkpcta_ps_ultima_order', 0)
        _ultimo_pedido += 1
        options = {'filter[id]':[_ultimo_pedido,_ultimo_pedido + 50]}
        dados_PrtShp = ps_con.get('orders', None, options=options)
        if dados_PrtShp and dados_PrtShp.get('status'):
            if dados_PrtShp.get('resposta').get('orders'):
                if not isinstance(dados_PrtShp.get('resposta').get('orders').get('order'), (list, tuple)): # Qdo tem um pedido s[o, não vem lista
                    dados_PrtShp['resposta']['orders']['order'] = [dados_PrtShp.get('resposta').get('orders').get('order')]
                for order in dados_PrtShp.get('resposta').get('orders').get('order'):
                    peds.append(order.get('attrs').get('id'))
        return peds

    def mkpPrtShp_pesquisar_orders_status(self, cr, uid, context=None):
        context = context and context.copy() or {}
        obj_conta = self.pool.get('mkp.contas')
        obj_order_status = self.pool.get('mkpps.order.status')
        conta_ids = obj_conta.search(cr, uid, [], context=context)
        for brw_conta in obj_conta.browse(cr, uid, conta_ids, context=context):
            if brw_conta.mkpcta_integrador != 'PrtShp':
                continue
            ps_con = Ptsp(cr, uid, brw_conta.id)
            dados_PrtShp = ps_con.get('order_states', None)
            if dados_PrtShp and dados_PrtShp.get('status'):
                if not isinstance(dados_PrtShp.get('resposta').get('order_states').get('order_state'), (list, tuple)): # Qdo tem um status só, não vem lista
                    dados_PrtShp['resposta']['order_states']['order_state'] = [dados_PrtShp.get('resposta').get('order_states').get('order_state')]
            for order_state in dados_PrtShp.get('resposta').get('order_states').get('order_state'):
                _state = order_state.get('attrs').get('id')
                dados_order_state = ps_con.get('order_states', _state)
                if dados_order_state and dados_order_state.get('status'):
                    _name = dados_order_state.get('resposta').get('order_state').get('name')
                    if isinstance(_name, (list, tuple)):
                        _nome = _name[0].get('language').get('value')
                    else:
                        _nome = _name.get('language').get('value')
                    status_ps_id = dados_order_state.get('resposta').get('order_state').get('id')
                    vals = {
                        "mkppsos_conta_id": brw_conta.id,
                        "mkppsos_codigo_ps": status_ps_id,
                        "name": _nome,
                        "mkppsos_modulo": dados_order_state.get('resposta').get('order_state').get('module_name'),
                    }
                    args = [('mkppsos_codigo_ps', '=', status_ps_id), ('mkppsos_conta_id', '=', brw_conta.id)]
                    os_ids = obj_order_status.search(cr, uid, args, context=context)
                    if os_ids:
                        obj_order_status.write(cr, uid, os_ids, vals, context=context)
                    else:
                        obj_order_status.create(cr, uid, vals, context=context)
        return True

    def mkpPrtShp_set_histories(self, cr, uid, conta_id, anuncio_ps, status_order, context=None):
        context = context and context.copy() or {}
        if not (anuncio_ps and status_order):
            return {'status': False, 'mensagem': 'Faltou o anuncio ou o status'}
        ps_con = Ptsp(cr, uid, conta_id)
        data = {
            'order_history':
                    {
                        'id_order_state': status_order,
                        'id_order': anuncio_ps,
                    }
        }
        recurso = 'order_histories'
        dados_PrtShp = ps_con.set(recurso, data)
        return dados_PrtShp

    def mkpPrtShp_set_tracknumber(self, cr, uid, conta_id, order, track_number,  context=None):
        context = context and context.copy() or {}
        if not (track_number and order):
            return {'status': False, 'mensagem': 'Faltou o codigo de rastreio ou a ordem'}
        ps_con = Ptsp(cr, uid, conta_id)
        recurso = 'order_carriers'
        _oc = ps_con.get(recurso, order)
        data = _oc.get('resposta')
        if _oc and _oc.get('status'):
            data['order_carrier']['tracking_number'] = track_number
            dados_PrtShp = ps_con.set(recurso, data, order)
        else:
            dados_PrtShp = {'status':False, 'message': _('Nao consegui pegar o order_carriers')}
        return dados_PrtShp

