# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from SigUtils.cep import Correios
from datetime import datetime
from ...adm.control.utils import capitalize_all
import re
import logging


ML_STATUS = {
    'A': 'active',
    'P': 'paused',
    'F': 'closed'
}


class mkp_utils(osv.Model):
    _inherit = 'mkp.utils'
    _logger = logging.getLogger(_inherit)

    def mkputl_cron_pesquisar_pedidos_prtshp(self, cr, uid, context=None):
        """
        Método chamado pelo cron para pesquisar pedidos nos marketplaces
        @param cr:
        @param uid:
        @param context:
        @return: Sempre True
        """
        context = context and context.copy() or {}
        obj_contas = self.pool.get('mkp.contas')
        for company_id in self.pool.get('res.company').search(cr, uid, [], context=context):
            context['sig_force_company'] = True
            args = [('mkpcta_integrador', '=', 'PrtShp'), ('company_id', '=', company_id)]
            conta_ids = obj_contas.search(cr, uid, args, context=context)
            for brw_conta in obj_contas.browse(cr, uid, conta_ids, context=context):
                if brw_conta.mkpcta_parar_comunicacao or \
                   brw_conta.mkpcta_marketplace_id.mkpmkp_parar_comunicacao:
                    continue
                _conta_id = brw_conta.id
                _mkp_codigo = brw_conta.mkpcta_marketplace_id.mkpmkp_codigo
                self._mkputl_pesquisar_pedido_mkp_prtshp(cr, uid, _conta_id, _mkp_codigo, context=context)
        return True

    def mkputl_importar_um_pedido_ps(self, cr, uid, ped, conta_id, context=None):
        self._logger.info('Importando o pedido: %s' % ped)
        _venda = self.pool.get('mkp.prtshp')._mkpPrtShp_get_pedido(cr, uid, conta_id, ped, context=context)
        obj_pedido = self.pool.get('estoquepedidos.pedido.capa')
        obj_local_locacao = self.pool.get('estoque.local.locacao')
        obj_pessoa = self.pool.get('adm.pessoa')
        obj_acoes = self.pool.get('mkp.acoes')
        obj_variacoes = self.pool.get('mkp.anuncios.var')
        obj_contas = self.pool.get('mkp.contas')
        obj_ps_forma_pagto = self.pool.get('mkpps.formas.pagto')
        obj_order_status = self.pool.get('mkpps.order.status')
        obj_mkputils = self.pool.get('mkp.utils')
        dados_conta = obj_contas.read(cr, uid, conta_id, ['mkpcta_local_id', 'mkpcta_marketplace_id','company_id'], context=context)
        context['sig_force_company'] = dados_conta.get('company_id')[0]
        _local_id = dados_conta.get('mkpcta_local_id')[0]

        _hoje = self.pool.get('adm.utils').admutl_datetime_to_timezone(cr, uid, datetime.now(),
                                                                       formato='%Y_%m_%d_%H_%M_%s')
        cr.execute(''' BEGIN; SAVEPOINT importar_pedido_ps_%s; ''' % _hoje)
        _ps_venda_id = _venda.get('id')
        _comentario = ''
        _status_ps_id = _venda.get('current_state') # todo:
        args = [('mkppsos_codigo_ps', '=', _status_ps_id), ('mkppsos_conta_id', '=', conta_id)]
        _sts_ids = obj_order_status.search(cr, uid, args, context=context)
        dados_status_order = obj_order_status.read(cr, uid, _sts_ids[0], [], context=context)
        _status_ps_name = dados_status_order.get('name')
        _status_ps_erp = dados_status_order.get('mkppsos_status_pedido')
        _data_venda = _venda.get('date_add')
        _lista_itens = []
        _qtd_venda = 0
        if not isinstance(_venda.get('associations').get('order_rows').get('order_row'), (list, tuple)): # Para apenas 1 item no pedido, não vem lista
            _venda['associations']['order_rows']['order_row'] = [_venda.get('associations').get('order_rows').get('order_row')]
        for _item in _venda.get('associations').get('order_rows').get('order_row'):
            _pedido_item = {}
            _args = [('mkpanu_codigo_anuncio', '=', _item.get('product_id'))]
            _anuncio_ids = self.pool.get('mkp.anuncios').search(cr, uid, _args,
                                                               context=context)
            _frete_receita = 0
            if _anuncio_ids:
                _campos = ['mkpanu_produto_id', 'mkpanu_valor_frete', 'mkpanu_frete', 'mkpanu_valor_frete',
                           'mkpanu_anuncio_tipo_id', 'mkpanu_quantidade', 'mkpanu_conta_id']
                _dados_anuncio = self.pool.get('mkp.anuncios').read(cr, uid, _anuncio_ids[0], _campos, context=context)
                _produto_id = _dados_anuncio['mkpanu_produto_id'][0]
                _grade_ids = self.pool.get('estoque.produto.grade').search(cr, uid, [
                    ('produto_id', '=', _produto_id)], context=context)
                if len(_grade_ids) > 1:
                    try:
                        _grade = _item.get('item').get('seller_custom_field')[-2:]
                        _grade_lida_ids = self.pool.get('estoque.produto.grade').search(cr, uid, [
                            ('produto_id', '=', _produto_id), ('grade', '=', _grade)], context=context)
                        if _grade_lida_ids:
                            _grade_ids = _grade_lida_ids
                        else:
                            _variation = _item.get('item').get('variation_id')
                            _var_id = obj_variacoes.search(cr, uid, [('mkpanuv_id_no_mkp', '=', _variation)], context=context)
                            if _var_id:
                                _dados_variacao = obj_variacoes.read(cr, uid, _var_id[0], ['mkpanuv_grade_id'], context=context, load='_classic_write')
                                if _dados_variacao:
                                    _grade_ids = [_dados_variacao.get('mkpanuv_grade_id')]
                    except:
                        pass
                _qtd_anuncio = _dados_anuncio.get('mkpanu_quantidade', 1)
                if _qtd_anuncio == 0:
                    _qtd_anuncio = 1
                _qtd_venda =int(_item.get('product_quantity') * _qtd_anuncio)
                _qtd_unidades =_item.get('product_quantity')
                _valor_total_item = (float(_item.get('product_price')) / _qtd_anuncio) * _qtd_venda
                _l_vl = _valor_total_item / _qtd_venda
                _args = [('grade_id', '=', _grade_ids[0]), ('local_id', '=', _local_id)]
                _emb_ids = obj_local_locacao.search(cr, uid, _args, context=context)
                _emb_id = \
                    obj_local_locacao.read(cr, uid, _emb_ids[0],
                                           ['estllc_produto_embalagem_id'], context=context)[
                        'estllc_produto_embalagem_id'][0]
                _pedido_item = self.pool.get('mkp.utils')._mkputl_monta_dic_item_pedido(cr, uid, _produto_id,
                                                                                        _grade_ids[0], _local_id, _emb_id,
                                                                                        _qtd_venda, _l_vl, _anuncio_ids[0])
            for x in _pedido_item:
                _lista_itens.append(x)
        _preco_total = float(_venda.get('total_paid'))
        _cliente_ps_email = _venda.get('customer').get('email')
        _cliente_ps_fone_1 = _cliente_ps_fone_2 = _cliente_ps_ddd_1 = _cliente_ps_ddd_2 =  False
        _cliente_ps_id = _venda.get('id_customer')
        if _venda.get('addresses').get('phone'):
            _cliente_ps_fone_1 = _venda.get('addresses').get('phone').strip().replace('-', '').replace('.','').replace('/','')
            if len(_cliente_ps_fone_1) > 8:
                _cliente_ps_ddd_1 = _cliente_ps_fone_1[:-8]
                _cliente_ps_fone_1 = _cliente_ps_fone_1[-8:]

        if _venda.get('addresses').get('phone_mobile'):
            _cliente_ps_fone_2 = _venda.get('addresses').get('phone_mobile').strip().replace('-', '').replace('.','').replace('/','')
            if len(_cliente_ps_fone_2) > 9:
                _cliente_ps_ddd_2 = _cliente_ps_fone_2[:-9]
                _cliente_ps_fone_2 = _cliente_ps_fone_2[-9:]
        _cliente_nome_1 = _venda.get('customer').get('firstname')
        _cliente_nome_2 = _venda.get('customer').get('lastname')
        _cliente_nome = capitalize_all('%s %s' % (_cliente_nome_1, _cliente_nome_2))
        _cliente_cpf = re.sub('[^0-9]', '', _venda.get('customer').get('cpf_cnpj') or '')
        _cliente_cep = _cliente_rua = _cliente_rua_nro = _cliente_rua_complemento = ''
        _cliente_cep = _venda.get('addresses').get('postcode') or ''
        _cliente_rua = _venda.get('addresses').get('address1') or ''
        _cliente_rua_nro = _venda.get('addresses').get('numend') or ''
        _cliente_rua_complemento = _venda.get('addresses').get('compl') or ''
        _cliente_bairro = _venda.get('addresses').get('address2') or ''
        _pedido_ids = obj_pedido.search(cr, uid, [('pedcap_nro_pedido_externo', '=', _ps_venda_id), ('tipo', '=', 'V')], context=context)
        _pedido_id = False
        _status_pedido_erp = False
        _pessoa_ids = False
        if _cliente_cpf:
            _pessoa_ids = obj_pessoa.search(cr, uid, [('cpf_cnpj', '=', _cliente_cpf)], context=context)
        if not _pessoa_ids:
            _pessoa_ids = obj_pessoa.search(cr, uid, [('admpes_id_externo', '=', _cliente_ps_id)], context=context)

        _pais_id = False
        if _pessoa_ids:
            _pessoa_id = obj_mkputils.mkputl_orders_alterar_pessoa(cr, uid, _pessoa_ids[0], _cliente_nome, _cliente_cpf,
                                                                   _cliente_ps_id, '', _cliente_cep, _cliente_rua,
                                                                   _cliente_rua_nro, _cliente_rua_complemento,
                                                                   _cliente_ps_ddd_1, _cliente_ps_fone_1,
                                                                   _cliente_ps_ddd_2, _cliente_ps_fone_2, 'Comum',
                                                                   _cliente_ps_email, context=context)
        else:
            # TODO FAZER TRATAMENTO PARA ALTERAR OS DADOS DO CLIENTE POIS PODE TER TIDO ALTERAÇÃO NO M.L.
            _pessoa_id = self.mkputl_orders_incluir_pessoa(cr, uid, _cliente_nome, _cliente_cpf, _cliente_ps_id,
                                                           '', '', _cliente_cep, _cliente_rua,
                                                           _cliente_rua_nro, _cliente_rua_complemento, _cliente_ps_ddd_1,
                                                           _cliente_ps_fone_1, _cliente_ps_ddd_2, _cliente_ps_fone_2,
                                                           'Comum', _cliente_ps_email, context=context)


        if _pedido_ids:  # O nro pedido do ML é unico, portanto se tiver pedido so tem 1
            _pedido_id = _pedido_ids[0]
            _dados_pedido = obj_pedido.read(cr, uid, [_pedido_id], ['state'], context=context)
            _status_pedido_erp = _dados_pedido[0].get('state')
            if _status_pedido_erp == 'V': # Se o pedido estiver validado, voltar para esboco
                obj_pedido.button_rascunho(cr, uid, [_pedido_id], context=context)
                _status_pedido_erp = 'R'
            if _status_pedido_erp not in ('R', 'C'):  # O pedido não está mais em esboço ou cancelado, não deve ser alterado
                return _pedido_id
        _condicao_forma_id = False
        _payment = _venda.get('payment')
        args = [('mkppsfpg_conta_id', '=', conta_id), ('name', '=', _payment)]
        ps_forma_ids = obj_ps_forma_pagto.search(cr, uid, args, context=context)
        if not ps_forma_ids:
            ps_forma_id = obj_ps_forma_pagto.create(cr, uid, {'mkppsfpg_conta_id': conta_id, 'name': _payment}, context=context)
        else:
            ps_forma_id = ps_forma_ids[0]
        _tipo_anuncio = ''
        _taxa_ps = 0
        brw_ps_forma = obj_ps_forma_pagto.browse(cr, uid, ps_forma_id, context=context)

        _vencimento = _data_venda[:10]
        _forma = []
        if brw_ps_forma and brw_ps_forma.mkppsfpg_forma_pgto_id:
            _taxa_ps = brw_ps_forma.mkppsfpg_forma_pgto_id.taxa
            _forma1 = {
                'forma_pagto_id': brw_ps_forma.mkppsfpg_forma_pgto_id.forma_pagamento_id.id,
                'condicao_forma_id': brw_ps_forma.mkppsfpg_forma_pgto_id.id,
                'pedido_parcela_ids': [(0, 0, {'vr_parcela': _preco_total, 'data_vencimento': _vencimento,})],
                'valor': _preco_total,
                'pedcdc_mkp_tarifa': (_taxa_ps * _preco_total / 100),
            }
            _forma.append((0,0, _forma1))

        dados_pessoa = self.pool.get('adm.pessoa').read(cr, uid, _pessoa_id, ['endereco_nf_id'], context=context)
        if dados_pessoa and dados_pessoa.get('endereco_nf_id'):
            _end_id = dados_pessoa.get('endereco_nf_id')[0]
        else:
            _end_id = ''
        vals = {
            'observacao': _comentario,
            'data_emissao': _data_venda,
            'tipo': 'V',
            'pessoa_id': _pessoa_id,
            'pedcap_endereco_id': _end_id,
            'pedcap_mkp_status': _status_ps_name,
            'pedcap_nro_pedido_externo': _ps_venda_id,
            'pedcap_endereco_eletronico': brw_ps_forma.mkppsfpg_conta_id.mkpcta_ps_site + '/administracao/index.php?controller=AdminOrders&id_order=%s&vieworder' % _ps_venda_id,
            'pedcap_mkp_tipo_anuncio': _tipo_anuncio,
            'vr_frete': _venda.get('total_shipping_tax_incl'),
            'vr_desconto': 0.00,
            'vr_seguro': 0.00,
            'vr_despesas_acessorias': 0.00,
            'pedcap_conta_id': conta_id,
        }
        if not _pedido_id:
            if _anuncio_ids:
                vals['pedido_item_ids'] = _lista_itens
            if _forma:
                vals['pedido_condicao_ids'] = _forma
            _pedido_id = obj_pedido.create(cr, uid, vals, context=context)
            obj_pedido.write(cr, uid, _pedido_id, {}, context=context)
            cr.execute(''' COMMIT; ''')  # Comito, porque se houver algum problema na validação, não perco o pedido
            cr.execute(''' BEGIN; SAVEPOINT importar_pedido_ps_%s; ''' % _hoje)
        else:
            if _status_ps_erp != 'C' and _status_pedido_erp == 'C':
                return False # Marcar com problema
            elif _status_ps_erp != 'C':
                _condicao_ids = self.pool.get('estoquepedidos.pedido.condicao').search(cr, uid, [('capa_id', '=', _pedido_id)], context=context)
                if _condicao_ids and _forma:
                    self.pool.get('estoquepedidos.pedido.condicao').unlink(cr, uid, _condicao_ids, context=context)
                vals['pedido_condicao_ids'] = _forma
                vals['state'] = 'R'
                context['salvar_forcado'] = True
                res = obj_pedido.write(cr, uid, _pedido_id, vals, context=context)
                cr.execute(''' COMMIT; ''')  # Comito, porque se houver algum problema na validação, não perco o pedido
                cr.execute(''' BEGIN; SAVEPOINT importar_pedido_ps_%s; ''' % _hoje)
        if _status_ps_erp == 'V':
            try:
                obj_pedido.button_validar(cr, uid, [_pedido_id], context=context)
            except:
                pass
        if _status_ps_erp == 'C' and _status_pedido_erp not in  ('C', 'F'):
            obj_pedido.button_cancelar(cr, uid, [_pedido_id], context=context)
        else:
            if _status_pedido_erp == 'F':
                cr.execute(''' COMMIT; ''')
                return False # Marcar com problema, pedido faturado no ERP e cancelado mo MKP
        obj_contas.write(cr, uid, conta_id, {'mkpcta_ps_ultima_order': _ps_venda_id}, context=context)
        cr.execute(''' COMMIT; ''')
        # self.pedcap_ver_se_atualiza_saldo_anuncios(cr, uid, [_pedido_id], context=context)
        return _pedido_id

    # Métodos já conferidos
    def _mkputl_pesquisar_pedido_mkp_prtshp(self, cr, uid, conta_id, codigo_mkp, context=None):
        """
        Metodo a ser sobrescrito para cada market place
        :param cr:
        :param uid:
        :param conta_id: id da conta no marketplace
        :param codigo_mkp: codigo de identificação do marketplace
        :param context:
        :return:
        """
        context = context and context.copy() or {}
        self._logger.info('Inicio de pesquisa de pedidos PrestaShop')
        obj_cron = self.pool.get('ir.cron')
        for ped in self.pool.get('mkp.prtshp').mkpPrtShp_pesquisar_orders(cr, uid, conta_id, context=context):
            vals = {
                'mkpnot_conta_id': conta_id,
                'mkpnot_resource': ped,
                'mkpnot_topic': 'orders',
            }
            self.pool.get('mkp.notificacoes').create(cr, uid, vals, context=context)
            args_cron = [
                ('model', '=', 'mkp.notificacoes'),
                ('function', '=', 'mkpnot_cron_executar_notificacoes'),
                ('active', '=', False)
            ]
            cron_ids = obj_cron.search(cr, uid, args_cron, context=context)
            if cron_ids:
                for dados_cron in obj_cron.read(cr, uid, cron_ids, [], context=context):
                    if dados_cron.get('numbercall') == 0:
                        _cron_id = dados_cron.get('id')
                        try:
                            obj_cron.write(cr, uid, [_cron_id], {'numbercall': 1, 'active': True}, context=context)
                        except Exception as e:  # se o cron estiver executando, vai dar erro, desconsiderar, atualiza da proxima vez
                            self._logger.info(
                                '--------------------- notificacoes: Nao consegui iniciar o cron erro: %s' % e)
        self._logger.info('Fim de pesquisa de pedidos PrestaShop')
        return True

    def mkputl_entregar_no_mkp(self, cr, uid, brw_encomenda, context=None):
        """
        Metodo utilizado para informar aos marketplaces que o pedido foi entregue ao cliente
        Deve ser sobrescrito em cada marketplace
        :param cr:
        :param uid:
        :param brw_encomenda:
        :param context:
        :return:
        """
        if brw_encomenda.rasenc_pedido_id.pedcap_conta_id.mkpcta_integrador != 'PrtShp':
            return super(mkp_utils, self).mkputl_entregar_no_mkp(cr, uid, brw_encomenda, context=context)
        _conta_id = brw_encomenda.rasenc_pedido_id.pedcap_conta_id.id
        _ped_ext_id = brw_encomenda.rasenc_pedido_id.pedcap_nro_pedido_externo
        if not _ped_ext_id:
            return True

        if (brw_encomenda.rasenc_pedido_id.pedcap_conta_id.mkpcta_ps_status_entregue and
            brw_encomenda.rasenc_pedido_id.pedcap_conta_id.mkpcta_ps_status_entregue.mkppsos_codigo_ps):
                self.pool.get('mkp.prtshp').mkpPrtShp_set_histories(cr, uid, _conta_id, _ped_ext_id,
                                                            brw_encomenda.rasenc_pedido_id.pedcap_conta_id.mkpcta_ps_status_entregue.mkppsos_codigo_ps,
                                                            context=context)

        return True

    def mkputl_faturar_no_mkp_selecionado(self, cr, uid, mkp_integrador, conta_id, ped_externo, chave, nf_ids, context=None):
        """
        Metodo sobrescrito ppelo marketplace especifico
        :param cr:
        :param uid:
        :param mkp_integrador:
        :param conta_id:
        :param ped_externo:
        :param chave:
        :param context:
        :return:
        """
        context = context and context.copy() or {}
        if mkp_integrador == 'PrtShp':
            for brw_nf in self.pool.get('fiscal.nf.capa').browse(cr, uid, nf_ids, context=context):
                for brw_itens in brw_nf.estoque_movimento_itens_ids:
                    for brw_anuncio in  brw_itens.produto_id.estpro_anuncios_ids:
                        if brw_anuncio.mkpanu_conta_id.id == conta_id:
                            _qtd = brw_anuncio.mkpanu_qtd_vendido + brw_itens.quantidade
                            vals = {'mkpanu_qtd_vendido': _qtd}
                            self.pool.get('mkp.anuncios').write(cr, uid, brw_anuncio.id, vals, context=context)
                            break
        else:
            res = super(mkp_utils, self).mkputl_faturar_no_mkp_selecionado(cr, uid, mkp_integrador, conta_id, ped_externo,
                                                                          chave, nf_ids, context=context)
        return res
