# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################
#
from openerp.osv import osv
from openerp.tools.translate import _
from SigUtils.numero import getNumeroEditado

class mkp_anuncios(osv.Model):
    _name = 'mkp.anuncios'
    _inherit = 'mkp.anuncios'

    def _auto_init(self, cr, context=None):
        try:
            import prestapyt
        except:
            raise osv.except_osv(_('Atencao!'),
                                 _('O modulo prestapyt nao esta instalado!\n'
                                   'Instale-o com "pip install prestapyt"'))
        super(mkp_anuncios, self)._auto_init(cr, context)


    def mkpanu_get_url_manutencao(self, cr, uid, ids, codigo_anuncio, codigo_mkp, context=None):
        context = context and context.copy() or {}
        _url = super(mkp_anuncios, self).mkpanu_get_url_manutencao(cr, uid, ids, codigo_anuncio, codigo_mkp, context=context)
        if codigo_mkp == 'PrtShp':
            for brw_anuncio in self.browse(cr, uid, ids, context=context):
                _site = brw_anuncio.mkpanu_conta_id.mkpcta_ps_site
                _anuncio = brw_anuncio.mkpanu_codigo_anuncio
                _token = brw_anuncio.mkpanu_conta_id.mkpcta_ps_chave_id
                _url = _site + '/administracao/index.php?controller=AdminProducts&id_product=%s&updateproduct&token=%s' % (_anuncio, _token)
        return _url

    def mkpanu_atualizar_preco_mkp(self, cr, uid, obj_id, code_mkp, context=None):
        context = context and context.copy() or {}
        res = super(mkp_anuncios, self).mkpanu_atualizar_preco_mkp(cr, uid, obj_id, code_mkp, context=context)
        if not res.get('status'):
            _res = res
        else:
            _res = False
        if code_mkp == 'PrtShp':
            res = self.pool.get('mkp.anuncios').mkppsanu_atualizar_anuncio(cr, uid, obj_id, context=context)
        if _res:
            return _res
        return res

    def mkpanu_atualizar_anuncio_mkp(self, cr, uid, obj_id, code_mkp, context=None):
        context = context and context.copy() or {}
        res = super(mkp_anuncios, self).mkpanu_atualizar_anuncio_mkp(cr, uid, obj_id, code_mkp, context=context)
        if res.get('status'):
            _res = res
        else:
            _res = False
        if code_mkp == 'PrtShp':
            res = self.pool.get('mkp.anuncios').mkppsanu_atualizar_anuncio(cr, uid, obj_id, context=context)
        if _res:
            return _res
        return res

    def mkpanu_atualizar_saldo(self, cr, uid, id, conta_id, mkp_code, context=None):
        context = context and context.copy() or {}
        res = super(mkp_anuncios, self).mkpanu_atualizar_saldo(cr, uid, id, conta_id, mkp_code, context=context)
        if mkp_code == 'PrtShp':
            res = self.pool.get('mkp.prtshp').mkpPrtShp_atualizar_saldo(cr, uid, id, context=context)
        return res

    # Não tem mais funcao para carregar
    # def _mkpanu_carregar_um_anuncio(self, cr, uid, browse_anuncio, context=None):
    #     super(mkp_anuncios, self)._mkpanu_carregar_um_anuncio(cr, uid, browse_anuncio, context=None)
    #     if browse_anuncio.mkpanu_marketplace_id.mkpmkp_codigo == 'PrtShp':
    #         _preview = self._mkpanu_get_anuncio_preview(cr, uid, [browse_anuncio.id], context=context)
    #         self.write(cr, uid, browse_anuncio.id, vals, context=context)
    #     return True


    def mkppsanu_atualizar_anuncio(self, cr, uid, id, context=None):
        """
        Inclui ou altera anuncio no site do Prestashop
        @param cr:
        @param uid:
        @param id: id do anuncio a ser alterado
        @param context:
        @return: dicionario contendo id do anuncio e response ex.:{status: True/False, 'mensagem': 'Mensagem'}
                 response. quando response.raise_for_status() for None, tá tudo certo. Para pegar o erro use response.status_code
        """
        context = context and context.copy() or {}
        obj_PrtShp = self.pool.get('mkp.prtshp')
        brw_anuncio = self.browse(cr, uid, id, context=context)
        if not brw_anuncio: # anuncio nao existe mais. Retornar True para que a ação seja encerrada
            return {'status': True, 'mensagem': ''}
        res = obj_PrtShp.mkpPrtShp_set_anuncios(cr, uid, brw_anuncio, context=context)
        if res and res.get('status'):
            vals_anuncio = {'mkpanu_necessita_atualizar': False}
            self.write(cr, uid, brw_anuncio.id, vals_anuncio, context=context)
            return {'status': True, 'mensagem': ''}
        elif res:
            return res
        return {'status': False, 'mensagem': 'Nao consegui atualizar anuncio!'}

    def name_get(self, cr, uid, ids, context=None):
        if not len(ids):
            return {}
        context = context and context.copy() or {}
        reads = self.read(cr, uid, ids, ['mkpanu_codigo_anuncio', 'mkpanu_title', 'mkpanu_valor'], context=context)
        res = []
        for record in reads:
            valor = getNumeroEditado(record['mkpanu_valor'])
            name = '%s-%s-%s' % (record['mkpanu_codigo_anuncio'], record['mkpanu_title'], valor)
            res.append((record['id'], name))
        return res
