# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class mkp_categorias(osv.Model):
    _inherit = 'mkp.categorias'

    def _mkpcat_ps_categoria_enviar(self, cr, uid, id, _conta_id, _codigo, _categoria, _pai, context=None):
        obj_mkp_PrtShp = self.pool.get('mkp.prtshp')
        res = obj_mkp_PrtShp.mkpPrtShp_set_categories(cr, uid, _conta_id, _codigo, _categoria, _pai, context=context)
        if res and res.get('status') == False:
            raise osv.except_osv(_('Atencao!'),
                                 _('Nao consegui atualizar a categoria!\n%s' % res.get('message')))
        if not _codigo:
            _codigo = res.get('resposta').get('prestashop').get('category').get('id')
            self.pool.get('mkp.categorias').write(cr, uid, id, {'mkpcat_codigo': _codigo}, context=context)
        return _codigo

    def mkpcat_ps_categoria_atualizar(self, cr, uid, categ_ids, context=None):
        for brw_categoria in self.browse(cr, uid, categ_ids, context=context):
            _conta_id = False
            id = brw_categoria.id
            for brw_conta in brw_categoria.mkpcat_marketplace_id.mkpmkp_conta_ids:
                if brw_conta.mkpcta_integrador == 'PrtShp':
                    _conta_id = brw_conta.id
            _codigo =  brw_categoria.mkpcat_codigo or False
            _categoria = brw_categoria.name
            _pai = brw_categoria.parent_id.mkpcat_codigo or False
            brw_categ_temp = brw_categoria
            ancestrais = []
            while True: # verificar parent para cadastramento no prestashop do parent e dos ancestrais
                if not brw_categ_temp.parent_id:
                    break
                brw_categ_temp = brw_categ_temp.parent_id
                if brw_categ_temp.mkpcat_codigo: # Se o pai já tem codigo os no prestashop, os ancestrais tambem tem
                    break
                _Pcodigo = brw_categ_temp.mkpcat_codigo or False
                _Pcategoria = brw_categ_temp.name
                _Ppai = brw_categ_temp.parent_id.mkpcat_codigo or False
                _Pid = brw_categ_temp.id
                ancestrais.append({'codigo':_Pcodigo, 'categ':_Pcategoria, 'pai': _Ppai, 'id':_Pid})
            while ancestrais:
                _Pcodigo = ancestrais[len(ancestrais)-1].get('codigo')
                _Pcategoria = ancestrais[len(ancestrais)-1].get('categ')
                _Ppai = ancestrais[len(ancestrais)-1].get('pai')
                _Pid = ancestrais[len(ancestrais)-1].get('id')
                ancestrais.pop(len(ancestrais)-1)
                _pai = self._mkpcat_ps_categoria_enviar(cr, uid, _Pid, _conta_id, _Pcodigo, _Pcategoria, _Ppai, context=context)
                if ancestrais:
                    ancestrais[len(ancestrais)-1]['pai'] = _pai
            res = self._mkpcat_ps_categoria_enviar(cr, uid, id, _conta_id, _codigo, _categoria, _pai, context=context)
        return res
