# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp import osv
from openerp.tools.translate import _


# Métodos da classe anuncio
def _mkppsanu_get_anuncios_alterados(self, cr, uid, ids, context=None):
    '''
    Funcao que retorna o uma lista de ids da classe mkp.anuncios onde os valores dos anuncios
    :param ids: ids da classe ml.pesquisas
    :return: lista com ids da classe 'mkp.anuncios'
    '''
    return ids

def _mkppsanu_get_anuncios_dos_saldos_alterados(self, cr, uid, ids, context=None):
    '''
    Funcao que retorna o uma lista de ids da classe mkp.anuncios onde o saldo de um
    produto foi alterado
    :param ids: ids da classe estoque.produto.saldo
    :return: lista com ids da classe 'mkp.anuncios'
    '''
    context = context and context.copy() or {}
    produto_ids = []
    for dados_saldos in self.read(cr, uid, ids, ['produto_id', 'local_id'], load='_classic_write', context=context):
        produto_ids.append(dados_saldos.get('produto_id'))
    anuncio_ids = self.search(cr, uid,  [('mkpanu_produto_id','in',produto_ids)], context=context)
    return anuncio_ids



def _mkppsanu_get_anuncio_saldo(self, cr, uid, ids, field_name, args, context=None):
    """
    Metodo para calcular o saldo do item, vai ser chamado da classe de anuncio de cada marketplace
    :param self:
    :param cr:
    :param uid:
    :param ids:
    :param field_name:
    :param args:
    :param context:
    :return:
    """
    context = context and context.copy() or {}
    if not len(ids):
        return []
    obj_estoque_produto = self.pool.get('estoque.produto')
    res = {}
    _company_id = False
    if context.get('uid'):
        _company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, context.get('uid'), self._name, context=context)
        if not 'company_id' in context:
            context['company_id'] = _company_id
    for brw_anuncios in self.browse(cr, uid, ids, context=context):
        _produto_id = brw_anuncios.mkpanu_produto_id.id
        _local_id = brw_anuncios.mkpanu_conta_id.mkpcta_local_id.id
        _perc_saldo = brw_anuncios.mkpanu_conta_id.mkpcta_saldo_percentual
        _saldo = int(obj_estoque_produto.estpro_get_saldo(cr, uid, [_produto_id], pesquisar="D",
                                                      local=_local_id, context=context)[_produto_id])
        if _perc_saldo > 0 or _perc_saldo < 100:
            _saldo = int(_saldo * _perc_saldo / 100)
        _saldo = _saldo / (brw_anuncios.mkpanu_quantidade or 1)
        if _saldo < 0:
            _saldo = 0
        res[brw_anuncios.id] = _saldo
    return res

def _mkppsanu_get_dados(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    if not len(ids):
        return []
    res = {}
    for brw_anuncios in self.browse(cr, uid, ids, context=context):
        _p_venda = (brw_anuncios.preco_venda * brw_anuncios.mkpanu_quantidade) \
                        * 100 / (100 - brw_anuncios.mkpanu_conta_id.mkpcta_ps_comisao_mkp)
        res[brw_anuncios.id] = {
            'mkppsanu_valor_sugerido': round(_p_venda, 2),
        }
    return res

def _mkppsanu_get_lucro(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    _company_id = None
    if context.get('uid'):
        _company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, context.get('uid'), self._name, context=context)
    if not len(ids):
        return []
    res = {}
    for brw_anuncios in self.browse(cr, uid, ids, context=context):
        _produto_id = brw_anuncios.mkpanu_produto_id.id
        _qtd = brw_anuncios.mkpanu_quantidade
        _lucro_pv = _lucro_pc = 0
        _custos = self.pool.get('estoque.preco.custo').get_custos_do_dia(cr, uid, [_produto_id],
                                                                         epc_company_id=_company_id,
                                                                         context=context).get(_produto_id)
        _pv = brw_anuncios.mkpanu_valor_promocao or brw_anuncios.mkpanu_valor or brw_anuncios.mkppsanu_valor_sugerido or 0
        _custo_var_ps = 5 #todo Cadastrar a comissao de cobranca da forma de pagamento mp=5%
        _pc = (_custos.get('estprc_custo_medio_contabil') * brw_anuncios.mkpanu_quantidade) or 0
        if _pv:
            try:
                _lucro_pv = (_pv - (_pv * _custo_var_ps / 100) - _pc) * 100 / _pv
            except:
                _lucro_pv = 0
        if _pc:
            try:
                _lucro_pc = (_pv - (_pv * _custo_var_ps / 100) - _pc) * 100 / _pc
            except:
                _lucro_pc = 0
        res[brw_anuncios.id] = {
            'mkppsanu_lucro_pvenda': _lucro_pv,
            'mkppsanu_lucro_pcusto': _lucro_pc,
        }
    return res

# Funcoes da classe mkpps_anuncios_variacoes
def _mkppsanuv_get_variacoes_dos_saldos_alterados(self, cr, uid, ids, context=None):
    '''
    Funcao que retorna o uma lista de ids da classe mkp.anuncios.var onde o saldo de uma
    grade foi alterado
    :param ids: ids da classe estoque.produto.saldo
    :return: lista com ids da classe 'mkp.anuncios.var'
    '''
    context = context and context.copy() or {}
    obj_mkpps_anuncios_variacoes = self.pool.get('mkp.anuncios.var')
    grade_ids = []
    for dados_saldos in self.read(cr, uid, ids, ['grade_id', 'local_id'], load='_classic_write', context=context):
        grade_ids.append(dados_saldos.get('grade_id'))
    anuncio_ids = obj_mkpps_anuncios_variacoes.search(cr, uid,  [('mkppsanuv_grade_id','in',grade_ids)], context=context)
    return anuncio_ids


def _mkppsanuv_get_variacao_saldo(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    if not len(ids):
        return []
    obj_estoque_produto_grade = self.pool.get('estoque.produto.grade')
    res = {}
    for brw_anuncios_variacoes in self.browse(cr, uid, ids, context=context):
        _perc_saldo = brw_anuncios_variacoes.mkppsanuv_anuncio_id.mkpanu_conta_id.mkpcta_saldo_percentual
        _grade_id = brw_anuncios_variacoes.mkppsanuv_grade_id.id
        _local_id = brw_anuncios_variacoes.mkppsanuv_anuncio_id.mkpanu_marketplace_id.id
        context['company_id'] = brw_anuncios_variacoes.mkppsanuv_anuncio_id.company_id.id
        _saldo = int(obj_estoque_produto_grade.estpgr_get_saldo(cr, uid, [_grade_id], pesquisar="D",
                                                      local=_local_id, context=context)[_grade_id])
        if _perc_saldo > 0 or _perc_saldo < 100:
            _saldo = int(_saldo * _perc_saldo / 100)
        res[brw_anuncios_variacoes.id] = _saldo
    return res

# Métodos da classe anuncios_prestashop_secoes
def mkppsans_get_modelo_id(self, cr, uid, context=None):
    res = None
    context = context and context.copy() or {}
    obj_mkp = self.pool.get('mkp.marketplaces')
    mkp_ids = obj_mkp.search(cr, uid, [('mkpmkp_codigo', '=', 'PrtShp')], context=context)
    for dados_mkp in obj_mkp.read(cr, uid, mkp_ids, ['mkpmkp_modelo_id'], context=context, load='_classic_write'):
        res = dados_mkp.get('mkpmkp_modelo_id')
    if not res:
        raise osv.except_osv(_('Atencao!'),
                             _('Modelo de anuncio não definido no Marketplace PrestaShop!'))
    return res

