# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from ...adm.control.utils import capitalize_all
from datetime import datetime
import subprocess
from openerp.tools.translate import _
from SigUtils import datas
import os

class mkp_utils(osv.Model):
    _inherit = 'mkp.utils'

    def mkputl_atualizar_anuncio_shopee(self, cr, uid, id, context=None):
        """
        Inclui ou altera anuncio no site da shopee
        @param cr:
        @param uid:
        @param id: id do anuncio a ser alterado
        @param context:
        @return: dicionario contendo id do anuncio e response ex.:{status: True/False, 'mensagem': 'Mensagem'}
                 response. quando response.raise_for_status() for None, tá tudo certo. Para pegar o erro use response.status_code
        """

        context = context and context.copy() or {}
        _spg = self.pool.get
        brw_anuncio = _spg('mkp.anuncios').browse(cr, uid, id, context=context)
        _codigo = False
        if not brw_anuncio:  # anuncio nao existe mais. Retornar True para que a ação seja encerrada
            return {'status': True, 'mensagem': ''}
        try:
            _codigo = brw_anuncio.mkpanu_codigo_anuncio
        except:  # Erro porque o id não existe
            return {'status': True, 'mensagem': ''}
        res = _spg('mkp.shopee').mkpShopee_set_anuncio(cr, uid, brw_anuncio, context=context)
        return res
    
    def mkputl_logistico_ativar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        _spg = self.pool.get
        res = super(mkp_utils, self).mkputl_logistico_ativar(cr, uid, ids, context=context)
        for brw_logisticos in _spg('mkp.logisticos').browse(cr, uid, ids, context=context):
            if brw_logisticos.mkplog_marketplace_id.mkpmkp_codigo != 'Shopee':
                continue
            _conta_id = brw_logisticos.mkplog_conta_id.id
            _channel_id = brw_logisticos.mkplog_codigo
            _habilitar = False if brw_logisticos.mkplog_ativo else True
            res = _spg('mkp.shopee').mkpShopee_logistico_setar(cr, uid, _conta_id, _channel_id,
                                                               _habilitar, context=context)
            if res.get('status'):
                _spg('mkp.logisticos').write(cr, uid, brw_logisticos.id, {'mkplog_ativo': _habilitar}, context=context)
        if not res.get('status'):
            raise osv.except_osv(_('Atencao'), res.get('mensagem'))
        return res


    def mkputl_importar_um_pedido_shopee(self, cr, uid, ped, conta_id, context=None):
        context = context and context.copy() or {}
        _venda = ped
        _shopee_venda_id = _venda.get('order_sn')
        self._logger.info(_('Importando pedido Shopee: %s') % _venda.get('order_sn'))
        _spg = self.pool.get
        brw_conta = _spg('mkp.contas').browse(cr, uid, conta_id, context=context)
        context['sig_force_company'] = brw_conta.company_id.id
        _local_id = brw_conta.mkpcta_local_id.id
        _hoje = _spg('adm.utils').admutl_datetime_to_timezone(cr, uid, datetime.now(), formato='%Y_%m_%d_%H_%M_%s')
        cr.execute(''' BEGIN; SAVEPOINT importar_pedido_shopee_%s; ''' % _hoje)
        _comentario = ''
        _status_shopee_name = _venda.get('order_status')
        _data_venda = str(datetime.fromtimestamp(_venda.get('create_time')))
        _data_entrega = datas.calcVencimento(_data_venda, int(_venda.get('days_to_ship') or 0))
        _lista_itens = []
        _qtd_venda = 0
        _vr_acrescimo = 0.0
        _preco_total = 0.0
        _vr_desconto = 0.0
        _tipo_anuncio = ''
        for _item in _venda.get('item_list'):
            _pedido_item = {}
            _sku = _item.get('item_sku')
            if '-' in _sku:
                _sku_code, _sku_grade = _sku.split('-')
            else:
                if _item.get('model_sku'):
                    _sku_code, _sku_grade = _item.get('model_sku').split('-')
                else:
                    _sku_code = _sku
                    _sku_grade = 'UN'
            _produto_ids = _spg('estoque.produto').search(cr, uid, [('codigo', '=', _sku_code)], context=context)
            if not _produto_ids:
                continue
            _produto_id = _produto_ids[0]
            _args = [('mkpanu_codigo_anuncio', '=', _item.get('item_id'))]
            _anuncio_ids = _spg('mkp.anuncios').search(cr, uid, _args, context=context)
            if not _anuncio_ids: # se não achar o anuncio direto pelo codigo, buscar pelo produto e conta
                _args = [('mkpanu_produto_id', '=', _produto_id), ('mkpanu_conta_id', '=', conta_id)]
                _anuncio_ids = _spg('mkp.anuncios').search(cr, uid, _args, context=context)
                if not _anuncio_ids:
                    continue
            _frete_receita = 0
            _campos = ['mkpanu_valor_frete', 'mkpanu_frete', 'mkpanu_anuncio_tipo_id', 'mkpanu_quantidade',
                       'mkpanu_valor_promocao', 'mkpanu_valor', 'mkpanu_valor_sugerido']
            _dados_anuncio = _spg('mkp.anuncios').read(cr, uid, _anuncio_ids[0], _campos, context=context)
            _grade_ids = _spg('estoque.produto.grade').search(cr, uid, [('produto_id', '=', _produto_id),
                                                                        ('grade', '=', _sku_grade)], context=context)
            _qtd_anuncio = _dados_anuncio.get('mkpanu_quantidade', 1)
            if _qtd_anuncio == 0:
                _qtd_anuncio = 1
            _qtd_venda = int((_item.get('model_quantity_purchased') or 1) * _qtd_anuncio)
            if _item.get('model_original_price'):
                _valor_total_item = (float(_item.get('model_original_price')) / _qtd_anuncio) * _qtd_venda
            else:
                _valor = _dados_anuncio.get('mkpanu_valor_promocao') or \
                         _dados_anuncio.get('mkpanu_valor') or \
                         _dados_anuncio.get('mkpanu_valor_sugerido')
                _valor_total_item = (float(_valor) / _qtd_anuncio) * _qtd_venda
            if _item.get('model_discounted_price'):
                _valor_total_liquido = (float(_item.get('model_discounted_price')) / _qtd_anuncio) * _qtd_venda
            else:
                _valor_total_liquido = _valor_total_item
            # _vr_desconto += (_valor_total_item - _valor_total_liquido)
            _l_vl = _valor_total_item / _qtd_venda
            _args = [('grade_id', '=', _grade_ids[0]), ('local_id', '=', _local_id)]
            _emb_ids = _spg('estoque.local.locacao').search(cr, uid, _args, context=context)
            _emb_id = \
                _spg('estoque.local.locacao').read(cr, uid, _emb_ids[0], ['estllc_produto_embalagem_id'],
                                       context=context)['estllc_produto_embalagem_id'][0]
            _pedido_item = _spg('mkp.utils')._mkputl_monta_dic_item_pedido(cr, uid, _produto_id,
                                                                                    _grade_ids[0], _local_id, _emb_id,
                                                                                    _qtd_venda, _l_vl, _anuncio_ids[0])
            for x in _pedido_item:
                _lista_itens.append(x)
            _preco_total += _valor_total_item
            _anuncio_tipo_id = _dados_anuncio.get('mkpanu_anuncio_tipo_id')[0]
            _campos = ['mkpant_custo_var', 'mkpant_custo_fixo', 'mkpant_tipo_custo_fixo', 'mkpant_codigo', 'mkpant_condicao_pgto', 'name']
            _dados_read = self.pool.get('mkp.anuncios.tipo').read(cr, uid, _anuncio_tipo_id, _campos, context=context)
            _comissao = _dados_read.get('mkpant_custo_var')
            _tipo_anuncio = _dados_read.get('name')
        _total_da_nota = float(_venda.get('total_amount') or 1)
        # _frete = _venda.get('estimated_shipping_fee', 0.00)
        # Ajustando total da nota
        _frete = _vr_desconto = 0
        if _preco_total != _total_da_nota:
            if _total_da_nota > _preco_total:
                _frete = _total_da_nota - _preco_total
                _preco_total += _frete
            else:
                _vr_desconto = _preco_total - _total_da_nota
        _cliente_shopee_email = False
        _cliente_shopee_fone_1 = _cliente_shopee_fone_2 = _cliente_shopee_ddd_1 =  _cliente_shopee_ddd_2 = False
        _fone = _venda.get('recipient_address').get('phone')
        _ddd = ''
        _fone = _fone.strip().replace('-', '').replace('.','').replace('/','').replace(' ','')
        ddd = _fone[2:4]
        _nro_f = _fone[4:]
        _cliente_shopee_ddd_1 = ddd
        _cliente_shopee_fone_1 = _nro_f
        _cliente_nome = _venda.get('recipient_address').get('name')
        _cliente_nome = capitalize_all(_cliente_nome)
        if _venda.get('buyer_cpf_id') != u'******':
            _cliente_cpf = _venda.get('buyer_cpf_id')
        else:
            _cliente_cpf = ''
        _cliente_apelido = _venda.get('buyer_username')
        _cliente_cep = _cliente_rua = _cliente_rua_nro = _cliente_rua_complemento = ''
        _cliente_cep = _venda.get('recipient_address').get('zipcode') or ''
        _full_address = _venda.get('recipient_address').get('full_address')
        _full_address = _full_address.replace(_venda.get('recipient_address').get('zipcode'), '')
        _full_address = _full_address.replace('%s,' % _venda.get('recipient_address').get('state'), '')
        _full_address = _full_address.replace('%s,' % _venda.get('recipient_address').get('city'), '')
        _full_address = _full_address.strip()
        if _full_address[-1:] == ',':
            _full_address = _full_address[:-1]
        if ',' in _full_address:
            _cliente_rua = _full_address.split(',')[0]
            _cliente_rua_nro = _full_address.split(',')[1]
        else:
            i = -1
            _tam = len(_full_address) * -1
            while True:
                if _full_address[i:].isdigit():
                    i += -1
                    if i < _tam:
                        break
                    continue
                break
            i += +1
            _cliente_rua = _full_address[:i]
            _cliente_rua_nro = _full_address[i:]
        _cliente_rua_complemento = ''
        _cliente_bairro = ''
        _pedido_ids = _spg('estoquepedidos.pedido.capa').search(cr, uid, [('pedcap_nro_pedido_externo', '=', _shopee_venda_id), ('tipo', '=', 'V')], context=context)
        _pedido_id = False
        _status_pedido_erp = 'R'
        _pessoa_ids = False
        if _cliente_cpf:
            _pessoa_ids = _spg('adm.pessoa').search(cr, uid, [('cpf_cnpj', '=', _cliente_cpf)], context=context)
        else:
            _pessoa_ids = _spg('adm.pessoa').search(cr, uid, [('fantasia_apelido', '=', _cliente_apelido)], context=context)
        _pais_id = False
        if _pessoa_ids:
            _pessoa_id = self.mkputl_orders_alterar_pessoa(cr, uid, _pessoa_ids[0], _cliente_nome, _cliente_cpf,
                                                                   '', '', _cliente_cep, _cliente_rua,
                                                                   _cliente_rua_nro, _cliente_rua_complemento,
                                                                   _cliente_shopee_ddd_1, _cliente_shopee_fone_1,
                                                                   _cliente_shopee_ddd_2, _cliente_shopee_fone_2, 'Comum',
                                                                   _cliente_shopee_email, context=context)
        else:
            # TODO FAZER TRATAMENTO PARA ALTERAR OS DADOS DO CLIENTE POIS PODE TER TIDO ALTERAÇÃO NO Marketplace
            _pessoa_id = self.mkputl_orders_incluir_pessoa(cr, uid, _cliente_nome, _cliente_cpf, '',
                                                           _cliente_apelido, '', _cliente_cep, _cliente_rua,
                                                           _cliente_rua_nro, _cliente_rua_complemento, _cliente_shopee_ddd_1,
                                                           _cliente_shopee_fone_1, _cliente_shopee_ddd_2, _cliente_shopee_fone_2,
                                                           'Comum', _cliente_shopee_email, context=context)
        if _pedido_ids:  # O nro pedido do Marketplace é unico, portanto se tiver pedido so tem 1
            _pedido_id = _pedido_ids[0]
            _dados_pedido = _spg('estoquepedidos.pedido.capa').read(cr, uid, [_pedido_id], ['state'], context=context)
            _status_pedido_erp = _dados_pedido[0].get('state')
            if _status_pedido_erp == 'V':  # Se o pedido estiver validado, voltar para esboco
                _spg('estoquepedidos.pedido.capa').button_rascunho(cr, uid, [_pedido_id], context=context)
                _status_pedido_erp = 'R'
            if _status_shopee_name == 'CANCELLED':
                if _status_pedido_erp == 'R':
                    _spg('estoquepedidos.pedido.capa').button_cancelar(cr, uid, [_pedido_id], context=context)
                return True
            if _status_pedido_erp not in ('R', 'C'):  # O pedido não está mais em esboço ou cancelado, não deve ser alterado
                vals = {'pedcap_mkp_status': _status_shopee_name}
                _spg('estoquepedidos.pedido.capa').write(cr, uid, [_pedido_id], vals, context=context)
                return _pedido_id

        _condicao_forma_id = False
        _vencimento = _data_venda
        _forma = []
        _condicao_forma_id = brw_conta.mkpcta_marketplace_id.mkpmkp_shopee_condicao_pgto_id.id
        brw_condicao = brw_conta.mkpcta_marketplace_id.mkpmkp_shopee_condicao_pgto_id
        _forma1 = {
            'forma_pagto_id': brw_condicao.forma_pagamento_id.id,
            'condicao_forma_id': brw_condicao.id,
            'pedido_parcela_ids': [(0, 0, {'vr_parcela': _total_da_nota, 'data_vencimento': _vencimento, })],
            'valor': _total_da_nota,
            'pedcdc_mkp_tarifa': (_comissao * _preco_total / 100),
        }
        _forma.append((0, 0, _forma1))

        dados_pessoa = _spg('adm.pessoa').read(cr, uid, _pessoa_id, ['endereco_nf_id'], context=context)
        if dados_pessoa and dados_pessoa.get('endereco_nf_id'):
            _end_id = dados_pessoa.get('endereco_nf_id')[0]
        else:
            _end_id = ''
        vals = {
            'observacao': _comentario,
            'data_emissao': _data_venda,
            'data_entrega': _data_entrega,
            'tipo': 'V',
            'pessoa_id': _pessoa_id,
            'pedcap_endereco_id': _end_id,
            'pedcap_mkp_status': _status_shopee_name,
            'pedcap_nro_pedido_externo': _shopee_venda_id,
            'pedcap_endereco_eletronico': brw_conta.mkpcta_marketplace_id.mkpmkp_api + '/portal/sale/%s' % _shopee_venda_id,
            'pedcap_mkp_tipo_anuncio': _tipo_anuncio,
            'vr_frete': _frete,
            'vr_desconto': _vr_desconto,
            'vr_seguro': 0.00,
            'vr_despesas_acessorias': _vr_acrescimo,
            'pedcap_conta_id': conta_id,
        }

        if not _pedido_id:
            if _anuncio_ids:
                vals['pedido_item_ids'] = _lista_itens
            if _forma:
                vals['pedido_condicao_ids'] = _forma
            _pedido_id = _spg('estoquepedidos.pedido.capa').create(cr, uid, vals, context=context)
            vals = {}
            if _status_shopee_name == 'CANCELLED':
                vals['state'] = 'C'
            _spg('estoquepedidos.pedido.capa').write(cr, uid, [_pedido_id], vals, context=context)
            cr.execute(''' COMMIT; ''')  # Comito, porque se houver algum problema na validação, não perco o pedido
            cr.execute(''' BEGIN; SAVEPOINT importar_pedido_ml_%s; ''' % _hoje)
        else:
            if _status_shopee_name == 'CANCELLED' and _status_pedido_erp != 'C':
                return False  # Marcar com problema
            elif _status_shopee_name in ('SHIPPED', 'TO_CONFIRME_RECEIVE', 'TO_RETURN', 'COMPLETED') \
                    and _status_pedido_erp == 'R':
                _spg('estoquepedidos.pedido.capa').button_validar(cr, uid, [_pedido_id], context=context)
                _spg('estoquepedidos.pedido.capa').button_faturar_pedido(cr, uid, [_pedido_id], context=context)
            elif _status_shopee_name != 'CANCELLED':
                _condicao_ids = self.pool.get('estoquepedidos.pedido.condicao').search(cr, uid, [('capa_id', '=', _pedido_id)], context=context)
                if _condicao_ids and _forma:
                    self.pool.get('estoquepedidos.pedido.condicao').unlink(cr, uid, _condicao_ids, context=context)
                vals['pedido_condicao_ids'] = _forma
                vals['state'] = 'R'
                context['salvar_forcado'] = True
                _spg('estoquepedidos.pedido.capa').write(cr, uid, [_pedido_id], vals, context=context)
                cr.execute(''' COMMIT; ''')  # Comito, porque se houver algum problema na validação, não perco o pedido
                cr.execute(''' BEGIN; SAVEPOINT importar_pedido_ml_%s; ''' % _hoje)
        if _status_shopee_name == 'READY_TO_SHIP':
            try:
                _spg('estoquepedidos.pedido.capa').button_validar(cr, uid, [_pedido_id], context=context)
            except:
                pass
        _encomenda = False
        if _venda.get('package_list'):
            for ship in _venda.get('package_list'):
                if ship.get('package_number'):
                    _encomenda = ship.get('package_number')
                    try:
                        _servico_id = brw_conta.mkpcta_rastreamento_servico_id.id
                    except:
                        _servico_id = False
                    if _encomenda:
                        sql = "select id from rastreio_encomendas where name = '%s'" % _encomenda
                        cr.execute(sql)
                        _encomenda_id = cr.fetchone()
                        if _encomenda_id:
                            _encomenda_id = _encomenda_id[0]
                        else:
                            vals_encomenda = dict(
                                name=_encomenda,
                                rasenc_pedido_id=_pedido_id,
                                rasenc_pessoa_id=_pessoa_id,
                                rasenc_compra_venda='V',
                            )
                            if _servico_id:
                                vals_encomenda['rasenc_servicos_ids'] = [(4, _servico_id,)]
                            _encomenda_id = _spg('rastreio.encomendas').create(cr, uid, vals_encomenda, context=context)
        if _encomenda:
            vals_ped = {'pedcap_encomenda_id': _encomenda_id}
            res = _spg('estoquepedidos.pedido.capa').write(cr, uid, [_pedido_id], vals_ped, context=context)
        cr.execute(''' COMMIT; ''')
        return _pedido_id

    def mkputl_faturar_no_mkp_selecionado(self, cr, uid, mkp_integrador, conta_id, ped_externo, chave, nf_ids,
                                          context=None):
        """
        Metodo sobrescrito ppelo marketplace especifico
        :param cr:
        :param uid:
        :param mkp_integrador:
        :param conta_id:
        :param ped_externo:
        :param chave:
        :param context:
        :return:
        """
        context = context and context.copy() or {}
        if mkp_integrador == 'Shopee':
            res = self.pool.get('mkp.shopee').mkpShopee_set_order_faturado(cr, uid, ped_externo, conta_id,
                                                                           context=context)
        else:
            res = super(mkp_utils, self).mkputl_faturar_no_mkp_selecionado(cr, uid, mkp_integrador, conta_id,
                                                                           ped_externo, chave, nf_ids, context=context)
        return res


    def mkputl_get_etiqueta_no_mkp(self, cr, uid, mkp_integrador, conta_id, pedido_ids, context=None):
        """
        Metodo para buscar etiqueta no marketplace, deve ser sobrescrito por cada marketplace
        :param cr:
        :param uid:
        :param mkp_integrador:
        :param conta_id:
        :param pedido_ids:
        :param context:
        :return: {status: True/False, 'mensagem': '', 'dados': ''}
        """
        context = context and context.copy() or {}
        if mkp_integrador != 'Shopee':
            res = super(mkp_utils, self).mkputl_get_etiqueta_no_mkp(cr, uid, mkp_integrador, conta_id, pedido_ids,
                                                                    context=context)
            return res
        _spg = self.pool.get
        _rastreio_id_ped = False
        for i in self.pool.get('estoquepedidos.pedido.capa').read(cr, uid, pedido_ids,
                                                                  ['pedcap_nro_pedido_externo',
                                                                   'pedcap_conta_id',
                                                                   'pessoa_id'], context):
            _conta_id = i.get('pedcap_conta_id')[0]
            _order = i.get('pedcap_nro_pedido_externo')

            # etiqueta, controle, track_no = self.pool.get('mkp.shopee').mkpShopee_get_etiqueta(cr, uid, _order, _conta_id, context)
            ret = self.pool.get('mkp.shopee').mkpShopee_get_etiqueta(cr, uid, _order, _conta_id, context)
            if not ret.get('status'):
                _msg = ret.get('mensagem') or _('Nenhuma etiqueta encontrada!')
                return {'status': False, 'mensagem': _msg, 'dados': ''}
            etiqueta = ret.get('etiqueta')
            controle = ret.get('controle')
            track_no = ret.get('trackno')
            if not etiqueta:
                os.remove(etiqueta)
                os.remove(controle)
            if not context.get('danfe'):
                printer = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque',
                                                                           ['estpar_impressora_termica', 'estpar_impressora_termica_servidor'],
                                                                           context=context)
                if printer:
                    servidor = printer.get('estpar_impressora_termica_servidor')
                    printer = printer.get('estpar_impressora_termica')
                else:
                    os.remove(etiqueta)
                    os.remove(controle)
                    return {'status': False, 'mensagem': _('Cadastrar impressora no parametro do "Estoque" na aba '
                                           '"Automacao"'), 'dados': ''}
                try:
                    if servidor:
                        subprocess.call(["lp", '-o raw', "-n1", '-h%s' % servidor, '-d%s' % printer, etiqueta])
                    else:
                        subprocess.call(["lp", '-o raw', "-n1", '-d%s' % printer, etiqueta])
                except Exception as e:
                    os.remove(etiqueta)
                    os.remove(controle)
                    return {'status': False, 'mensagem': _('Erro ao imprimir etiqueta de postagem %s') % e, 'dados': ''}
            _prt_nf = context.get('mkp_modelo_90', False)
            if _prt_nf:
                _prt_nf = '-d%s' % _prt_nf
                parametro_dados = _spg('adm.utils').admutl_get_parametros(cr, uid, 'fiscal', 'fispar_tamanho_danfe', context=context)
                formato = '-omedia=' + parametro_dados.get('fispar_tamanho_danfe') or '-omedia=A4'
                fit = '-ofit-to-page'
                subprocess.call(["lp", '-n1', formato, fit, _prt_nf, controle])
            if track_no:
                vals = {
                    'name': track_no,
                    'rasenc_pedido_id': i.get('id'),
                    'rasenc_pessoa_id': i.get('pessoa_id')[0],
                    'rasenc_compra_venda': 'V',
                }
                try:
                    _dados_conta = _spg('mkp.contas').read(cr, uid, _conta_id, ['mkpcta_rastreamento_servico_id'],
                                                           context=context)
                    _servico_id = _dados_conta.get('mkpcta_rastreamento_servico_id')[0]
                except:
                    _servico_id = False
                if _servico_id:
                    vals['rasenc_servicos_ids'] = [(4, _servico_id,)]
                _encomenda_id = self.pool.get('rastreio.encomendas').create(cr, uid, vals, context=context)
                vals = {'pedcap_encomenda_id': _encomenda_id}
                _spg('estoquepedidos.pedido.capa').write(cr, uid, [i.get('id')], vals, context=context)
            os.remove(etiqueta)
            if controle:
                os.remove(controle)
        return {'status': True, 'mensagem': '', 'dados': {'track_no': track_no, 'encomenda_id': _encomenda_id}}

    def _mkputl_pesquisar_pedido_mkp_shopee(self, cr, uid, conta_id, context=None):
        """
        Metodo chamado pelo cron para pesquisr pedidos no Shopee
        :param cr:
        :param uid:
        :param conta_id: id da conta no marketplace
        :param codigo_mkp: codigo de identificação do marketplace
        :param context:
        :return:
        """
        context = context and context.copy() or {}
        self._logger.info(_('Inicio de pesquisa de pedidos Shopee'))
        ped = self.pool.get('mkp.shopee').mkpShopee_pesquisar_orders(cr, uid, conta_id, context=context)
        self._logger.info(_('Fim de pesquisa de pedidos Shopee'))
        return True

    def mkputl_cron_pesquisar_pedidos_shopee(self, cr, uid, context=None):
        """
        Método chamado pelo cron para pesquisar pedidos nos marketplaces
        @param cr:
        @param uid:
        @param context:
        @return: Sempre True
        """
        context = context and context.copy() or {}
        obj_contas = self.pool.get('mkp.contas')
        for company_id in self.pool.get('res.company').search(cr, uid, [], context=context):
            context['sig_force_company'] = True
            args = [('mkpcta_integrador', '=', 'Shopee'), ('company_id', '=', company_id)]
            conta_ids = obj_contas.search(cr, uid, args, context=context)
            for brw_conta in obj_contas.browse(cr, uid, conta_ids, context=context):
                if brw_conta.mkpcta_parar_comunicacao or \
                   brw_conta.mkpcta_marketplace_id.mkpmkp_parar_comunicacao:
                    continue
                _conta_id = brw_conta.id
                self._mkputl_pesquisar_pedido_mkp_shopee(cr, uid, _conta_id, context=context)
        return True

