# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
import logging
from openerp.tools.translate import _


class mkp_categorias(osv.Model):
    _inherit = 'mkp.categorias'
    _logger = logging.getLogger(_inherit)

    def __init__(self, pool, cr):
        super(mkp_categorias, self).__init__(pool, cr)
        self._mkp_categ_default_company.append('Shopee')

    def mkpcat_buscar_atributos_no_mkp(self, cr, uid, ids, mkp_integrador, mkp_categ_code, context=None):
        context = context and context.copy() or {}
        _spg = self.pool.get
        res = super(mkp_categorias, self).mkpcat_buscar_atributos_no_mkp(cr, uid,  ids, mkp_integrador, mkp_categ_code, context=context)
        if mkp_integrador != 'Shopee':
            return res
        resp = self.pool.get('mkp.shopee').mkpShopee_get_categorias_atributos(cr, uid, mkp_categ_code, context=context)
        if not resp.get('status'):
            raise osv.except_osv(_('Atencao'),
                                 _('Erro ao buscar as atributos das categorias.\nErro informado:\n%s') % resp.get('mensagem'))
        _atributos = resp.get('atributos').get('attribute_list') or []
        vals = {}
        for _atributo in _atributos:
            if _atributo.get('is_mandatory'):
                vals['mkpcatatr_tipo'] = 'P'
            else:
                vals['mkpcatatr_tipo'] = 'S'
            vals['mkpcatatr_categoria_id'] = ids[0]
            vals['mkpcatatr_id_mkp'] = _atributo.get('attribute_id')
            vals['mkpcatatr_label'] = _atributo.get('display_attribute_name')
            vals['mkpcatatr_tipo_dados'] = _atributo.get('input_type')
            args = [('mkpcatatr_categoria_id', '=', ids[0]), ('mkpcatatr_id_mkp', '=', _atributo.get('attribute_id'))]
            _attr_ids = _spg('mkp.categorias.atributos').search(cr, uid, args, context=context)
            if _attr_ids:
                _attr_id = _spg('mkp.categorias.atributos').write(cr, uid, _attr_ids, vals, context=context)
            else:
                _attr_id = _spg('mkp.categorias.atributos').create(cr, uid, vals, context=context)
        return True
