# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
from ....marketplace.control.utils import configuracao
from openerp.tools import config


class mkp_contas(osv.Model):
    _inherit = 'mkp.contas'

    def mkpcta_shopee_btn_get_code(self, cr, uid, ids, context=None):
        _spg = self.pool.get
        if ids:
            dados_conta = self.read(cr, uid, ids[0], [], context=context)
            conta_id = dados_conta.get('id')
            _url = _spg('mkp.shopee').mkpShopee_autenticar(cr, uid, conta_id)
            c = configuracao('marketplace_shopee', str(dados_conta.get('mkpcta_shopee_shop_id')))
            c.partner_key = dados_conta.get('mkpcta_shopee_partner_key')
            c.partner_id = dados_conta.get('mkpcta_shopee_partner_id')
            c.server = dados_conta.get('mkpcta_host_erp')
            c.base = dados_conta.get('mkpcta_banco_erp')
            c.redirect = dados_conta.get('mkpcta_shopee_redirect_url')
            c.conta_id = dados_conta.get('id')
            c.shop_id = str(dados_conta.get('mkpcta_shopee_shop_id'))
            c.gravarConfiguracao()

            c = configuracao('marketplace', dados_conta.get('mkpcta_banco_erp'))
            c.db_user = config.options.get('db_user')
            c.db_password = config.options.get('db_password') or None
            c.db_host = config.options.get('db_host') or ''
            c.db_port = config.options.get('db_port') or '5432'
            c.gravarConfiguracao()
        return {
            "type": "ir.actions.act_url",
            "url": _url,
            "target": "new",
        }

    def mkpcta_shopee_btn_get_categories(self, cr, uid, ids, context=None):
        _spg = self.pool.get
        def __setCategorias(categorias):
            for categoria in categorias.get('category_list'):
                code = str(categoria.get('category_id'))
                name = categoria.get('original_category_name')
                parent_id = categoria.get('parent_category_id')
                args = [('mkpcat_marketplace_id', '=', mkp_id),
                        ('mkpcat_codigo', '=', code)]
                context['active_test'] = False
                categ_ids = _spg('mkp.categorias').search(cr, uid, args, context=context)
                categ_pai_ids = False
                if parent_id:
                    args = [('mkpcat_marketplace_id', '=', mkp_id),
                            ('mkpcat_codigo', '=', parent_id)]
                    categ_pai_ids = _spg('mkp.categorias').search(cr, uid, args, context=context)
                vals = {
                    'mkpcat_marketplace_id': mkp_id,
                    'mkpcat_codigo': code,
                    'name': name
                }
                if categ_pai_ids:
                    vals['parent_id'] = categ_pai_ids[0]
                if categ_ids:
                    vals.update({'active': True})
                    _spg('mkp.categorias').write(cr, uid, categ_ids, vals, context=context)
                else:
                    _spg('mkp.categorias').create(cr, uid, vals, context=context)
            return True

        if ids:
            dados_conta = self.read(cr, uid, ids[0], [], context=context)
            conta_id = dados_conta.get('id')
            resp = _spg('mkp.shopee').mkpShopee_get_categorias(cr, uid, conta_id)
            if resp.get('status'):
                mkp_id = _spg('mkp.contas').read(cr, uid, ids[0], ['mkpcta_marketplace_id'], context=context).get(
                    'mkpcta_marketplace_id')[0]
                args = [('mkpcat_marketplace_id', '=', mkp_id)]
                categ_ids = _spg('mkp.categorias').search(cr, uid, args, context=context)
                _spg('mkp.categorias').write(cr, uid, categ_ids, {'active': False}, context=context)
                __setCategorias(resp.get('categorias'))
            else:
                raise osv.except_osv(_('Atencao'), _('Erro ao buscar as categorias.\nErro informado:\n%s') % resp.get('mensagem'))
        return True

    def mkpcta_shopee_btn_get_logistics(self, cr, uid, ids, context=None):
        _spg = self.pool.get
        def __setLogisticos(logisticos):
            mkp_id = _spg('mkp.contas').read(cr, uid, ids[0], ['mkpcta_marketplace_id'], context=context).get('mkpcta_marketplace_id')[0]
            for logistico in logisticos:
                code = str(logistico.get('logistics_channel_id'))
                name = logistico.get('logistics_channel_name')
                peso = logistico.get('weight_limit').get('item_max_weight')
                largura = logistico.get('item_max_dimension').get('width')
                comprimento = logistico.get('item_max_dimension').get('length')
                altura = logistico.get('item_max_dimension').get('height')
                _ativo = logistico.get('enabled')
                vals = {
                    'mkplog_marketplace_id': mkp_id,
                    'mkplog_conta_id': ids[0],
                    'mkplog_codigo': code,
                    'name': name,
                    'mkplog_peso': peso,
                    'mkplog_altura': altura,
                    'mkplog_comprimento': comprimento,
                    'mkplog_largura': largura,
                    'mkplog_ativo': _ativo,
                }
                args = [('mkplog_marketplace_id', '=', mkp_id),
                        ('mkplog_codigo', '=', code)]
                log_ids = _spg('mkp.logisticos').search(cr, uid, args, context=context)
                if log_ids:
                    _spg('mkp.logisticos').write(cr, uid, log_ids, vals, context=context)
                else:
                    _spg('mkp.logisticos').create(cr, uid, vals, context=context)
            return True
        if ids:
            dados_conta = self.read(cr, uid, ids[0], [], context=context)
            conta_id = dados_conta.get('id')
            resp = _spg('mkp.shopee').mkpShopee_get_logistics(cr, uid, conta_id)
            if resp.get('status'):
                __setLogisticos(resp.get('logisticos').get('logistics_channel_list'))
            else:
                raise osv.except_osv(_('Atencao'), _('Erro ao buscar dados logisticos.\nErro informado:\n%s') % resp.get('mensagem'))
        return True

