# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
import logging
_logger = logging.getLogger(__name__)


class mkp_notificacoes(osv.Model):
    _inherit = "mkp.notificacoes"

    def _mkpnot_get_orders_shopee(self, cr, uid, dados_notificacao, context=None):
        _spg = self.pool.get
        _order = dados_notificacao.get('mkpnot_resource').split('/')[2]
        _conta_id = dados_notificacao.get('mkpnot_conta_id')
        _dados_conta = _spg('mkp.contas').read(cr, uid, _conta_id, [], context=context)
        dados = _spg('mkp.shopee').mkpShopee_get_orders(cr, uid, [str(_order)], _conta_id)
        if not dados.get('status'):
            return False
        _pedido = dados.get('orders')[0]
        _ped_id = _spg('mkp.utils').mkputl_importar_um_pedido_shopee(cr, uid, _pedido, _conta_id, context=context)
        if not _ped_id:
            self._logger.info('Pedido nao importado!')
            return False
        return True

    def _mkpnot_get_itens_shopee(self, cr, uid, dados_notificacao, context=None):
        _anuncio = dados_notificacao.get('mkpnot_resource').split('/')[2]
        _spg = self.pool.get
        _anuncio_ids = _spg('mkp.anuncios').search(cr, uid, [('mkpanu_codigo_anuncio', '=', _anuncio)], context=context)
        if _anuncio_ids:
            dados_anuncio = _spg('mkp.anuncios').read(cr, uid, _anuncio_ids, [
                                                                                'id',
                                                                                'mkpanu_codigo_anuncio',
                                                                                'mkpanu_conta_id'
                                                                             ],
                                                                             context=context)
            if dados_anuncio:
                dados_anuncio = dados_anuncio[0]
                dados_anuncioShopee = _spg('mkp.shopee').mkpShopee_get_anuncio(cr, uid,
                                                                                dados_anuncio.get('mkpanu_conta_id')[0],
                                                                                dados_anuncio.get('mkpanu_codigo_anuncio'),
                                                                                context=context)
                vals = {
                    'mkpanu_necessita_atualizar': False,
                    'mkpanu_qtd_vendido': dados_anuncioShopee.get('sale')
                }
                vals['mkpanu_estado_mkp'] = dados_anuncioShopee.get('status')
                _spg('mkp.anuncios').write(cr, uid, dados_anuncio.get('id'), vals, context=context)
                return True
            self._logger.info('Anuncio nao localizado!')
            return False

    def _mkpnot_processar_notificacao(self, cr, uid, codigo_mkp, notificacao_tipo, dados_notificacao, context=None):
        """
        Metodo qeue sobrescreve o original para tratamento especializado
        :param cr:
        :param uid:
        :param codigo_mkp: Codigo do Marketplace
        :param dados_notificacao: Dados resultado do read de um registro do marketplace, com todos os atributos
        :param context:
        :return:
        """
        context = context and context.copy() or {}
        res = super(mkp_notificacoes, self)._mkpnot_processar_notificacao(cr, uid, codigo_mkp, notificacao_tipo,
                                                                          dados_notificacao, context=context)
        if codigo_mkp == 'Shopee':
            if notificacao_tipo == 'items':
                res = self._mkpnot_get_itens_shopee(cr, uid, dados_notificacao, context=context)
            # elif notificacao_tipo == 'messages':
            #     res = self._mkpnot_get_messages_shopee(cr, uid, dados_notificacao, context=context)
            # elif notificacao_tipo == 'questions':
            #     res = self._mkpnot_get_questions_shopee(cr, uid, dados_notificacao, context=context)
            elif notificacao_tipo == 'orders':
                res = self._mkpnot_get_orders_shopee(cr, uid, dados_notificacao, context=context)
            # elif notificacao_tipo == 'payments':
            #     _payment = dados_notificacao.get('mkpnot_resource').split('/')[2]
            #     _conta_id = dados_notificacao.get('mkpnot_conta_id')
            #     res = self.pool.get('mkpml.pagamentos').mkpmlpag_get_payments(cr, uid, _payment, _conta_id, context=context)
            # elif notificacao_tipo == 'shipments':
            #     res = self._mkpnot_get_shipments_shopee(cr, uid, dados_notificacao, context=context)
            # elif notificacao_tipo == 'invoices':
            #     res = self._mkpnot_get_invoice_shopee(cr, uid, dados_notificacao, context=context)
            # # elif notificacao_tipo == 'payments':
            # #     res = True
            # elif notificacao_tipo == 'claims':
            #     res = True
        return res
