from .controller import Shopee
from datetime import datetime


def _Shopee_atualizar_anuncio_mkp(db, id):
        pass

def _Shopee_atualizar_preco_mkp(db, id):
    _fields = [
        'mkpaco_conta_id',
        'mkpaco_objeto',
        'mkpaco_acao',
        'mkpaco_prioridade',
        'mkpaco_id',
    ]
    _where = [('id', '=', id)]
    _acoesDados = db.dbsSelect('mkp_acoes', _fields, _where)[0]
    shopee_con = Shopee(db, db.uid, _acoesDados.get('mkpaco_conta_id'))
    params = {
        'access_token': shopee_con.access_token
    }
    vals = {}
    _fields = ['mkpcta_local_id']
    _where = [('id', '=', _acoesDados.get('mkpaco_conta_id'))]
    _contasDados = db.dbsSelect('mkp_contas', _fields, _where)[0]
    _local = _contasDados.get('mkpcta_local_id')
    # Verificar situacao do anuncio no M.L.
    _fields = [
        'mkpanu_codigo_anuncio',
        'mkpanu_valor_promocao',
        'mkpanu_valor',
        'mkpanu_valor_sugerido',
        'mkpanu_produto_id',
    ]
    _where = [('id', '=', _acoesDados.get('mkpaco_id'))]
    _anunciosDados = db.dbsSelect('mkp_anuncios', _fields, _where)[0]
    if not _anunciosDados.get('mkpanu_codigo_anuncio'):
        res = {'status': True, 'mensagem': ''}
        return res
    _valor = _anunciosDados.get('mkpanu_valor_promocao') or \
             _anunciosDados.get('mkpanu_valor') or \
             _anunciosDados.get('mkpanu_valor_sugerido')

    _fields = ['grade_usar']
    _where = [('id', '=', _anunciosDados.get('mkpanu_produto_id'))]
    _produtosDados = db.dbsSelect('estoque_produto', _fields, _where)[0]
    # if _produtosDados.get('grade_usar') or brw_anuncio.mkpanu_variacoes_ids:
    #     vals_var = []
    #     for _brw_grade in brw_anuncio.mkpanu_produto_id.produto_grade_ids:
    #         context['company_id'] = brw_anuncio.company_id.id
    #         _x = obj_grade.estpgr_get_saldo(cr, uid, [_brw_grade.id], 'D', _local, context=context)
    #         vals_grade = {'price': _valor}
    #         for _brw_var in brw_anuncio.mkpanu_variacoes_ids:
    #             if _brw_var.mkpanuv_grade_id.id == _brw_grade.id:
    #                 vals_grade['id'] = _brw_var.mkpanuv_id_no_mkp
    #                 break
    #         if vals_grade.get('id'): # Não considerar grades que não estão no M.L.
    #             vals_var.append(vals_grade)
    #     if vals_var:
    #         vals = {'variations': vals_var}
    # else:
    #     vals.update({
    #         'price': _valor,
    #     })
    # _url = 'items/'
    # _urlf = _url + [str(brw_anuncio.mkpanu_codigo_anuncio)
    # response = shopee_con.put(_urlf, vals, params)
    # if response.status_code > 399:
    #     _mens = '%s-%s-%s' % (json.loads(response.content).get('message', ''),
    #                           json.loads(response.content).get('error', ''),
    #                           json.loads(response.content).get('cause', ''))
    #     return {'status': False, 'mensagem': _mens}
    res = {'status': True, 'mensagem': ''}
    return res


def _Shopee_atualizar_saldo_mkp(db, id):
        pass

def _Shopee_atualizar_mensagem_mkp(db, id):
        pass

def Shopee_executar_uma_acao(db, id):
    _fields = ['mkpaco_conta_id', 'mkpaco_objeto', 'mkpaco_acao', 'mkpaco_prioridade']
    _where = [('id', '=', id)]
    dados_acoes = db.dbsSelect('mkp_acoes', _fields, _where)[0]
    _mkpaco_objeto = dados_acoes.get('mkpaco_objeto')
    _mkpaco_acao = dados_acoes.get('mkpaco_acao')
    _mkpaco_prioridade = dados_acoes.get('mkpaco_prioridade')
    resultado = {'status': False, 'mensagem': 'Nao executado'}
    if _mkpaco_objeto == 'A': # Anuncios
        if _mkpaco_acao == 'A':
            resultado = _Shopee_atualizar_anuncio_mkp(db, id)
    elif _mkpaco_objeto == 'P':  # Precos
        if _mkpaco_acao == 'A':
            resultado = _Shopee_atualizar_preco_mkp(db, id)
    elif _mkpaco_objeto == 'M':  # Mensagens
        if _mkpaco_acao == 'A':
            resultado = _Shopee_atualizar_mensagem_mkp(db, id)
    elif _mkpaco_objeto == 'S': # Saldos
        if _mkpaco_acao == 'A':
            res = _Shopee_atualizar_saldo_mkp(db, id)
            if res:
                resultado = {'status': True, 'mensagem': ''}
    if not resultado.get('status'):
        _mens = resultado.get('mensagem')
        if resultado.get('cause') and isinstance(resultado.get('cause'), list):
            for _men_cause in resultado.get('cause'):
                _mens += ' / ' + _men_cause.get('message') or _men_cause.get('code')
        _prioridade = (_mkpaco_prioridade + 1) if _mkpaco_prioridade < 9 else 0
        _vals = {'state': 'ER', 'mkpaco_mensagem': _mens, 'mkpaco_prioridade': _prioridade}
        if db.uid:
            _vals.update({'write_uid': db.uid, 'write_date': datetime.utcnow().strftime('%Y-%m-%d %H:%M:%S')})
        res = db.dbsUpdate('mkp_acoes', _vals, _where)
    else:
        if _mkpaco_objeto == 'M':
            res = db.dbsDelete('mkp_acoes', _where)
        else:
            _vals = {'state': 'EX', 'mkpaco_mensagem': ''}
            if db.uid:
                _vals.update({'write_uid': db.uid, 'write_date': datetime.utcnow().strftime('%Y-%m-%d %H:%M:%S')})
            res = db.dbsUpdate('mkp_acoes', _vals, _where)
    return True

