# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################
from openerp.osv import osv
import json
import logging
from datetime import datetime
from ..skyhub import SkyHub
import pytz
from openerp.tools.translate import _
from unicodedata import normalize


# Classe de alto nivel para comunicação com o SkyHub
class mkp_SkyHub(osv.Model):
    _name = 'mkp.skyhub'
    _auto = False
    _tem_erro = False
    _mensagem_erro = ''
    _logger = logging.getLogger(_name)

    def mkpSkyHub_get_produto(self, cr, uid, conta_id, sku_produto, context=None):
        context = context and context.copy() or {}
        sh_con = SkyHub(cr, uid, conta_id)
        params = {}
        if sku_produto:
            _url = 'products/' +str(sku_produto)
            response = sh_con.get(_url, params)
            if response.status_code > 399:
                return {'status': False, 'mensagem': json.loads(response.content).get('message')}
            dados_produto_SkyHub = json.loads(response.content)
            return dados_produto_SkyHub
        return False

    def mkpSkyHub_set_atributos(self, cr, uid, conta_id, vals, context=None):
        context = context and context.copy() or {}
        sh_con = SkyHub(cr, uid, conta_id)
        params = {}
        _url = 'attributes'
        if vals.get('name'):
            mkp_integrador = vals.pop('name')
            response = sh_con.put(_url, mkp_integrador , vals)
        else:
            vals['name'] = vals.get('label')
            response = sh_con.post(_url, vals, params)
        if response.status_code > 399:
            return {'status': False, 'mensagem': json.loads(response.content).get('message')}
        return {'status': True, 'mensagem': '', 'atribute_code': vals.get('name')}

    def mkpSkyHub_get_atributos(self, cr, uid, conta_id, context=None):
        context = context and context.copy() or {}
        sh_con = SkyHub(cr, uid, conta_id)
        params = {}
        _url = 'attributes'
        response = sh_con.get(_url, params)
        if response.status_code > 399:
            return {'status': False, 'mensagem': json.loads(response.content).get('message')}
        dados_produto_SkyHub = json.loads(response.content)
        return dados_produto_SkyHub

    def mkpSkyHub_get_categorias(self, cr, uid, conta_id, sku_produto, context=None):
        context = context and context.copy() or {}
        sh_con = SkyHub(cr, uid, conta_id)
        params = {}
        if sku_produto:
            _url = 'products/' +str(sku_produto)
            response = sh_con.get(_url, params)
            if response.status_code > 399:
                return {'status': False, 'mensagem': json.loads(response.content).get('mensagem')}
            dados_produto_SkyHub = json.loads(response.content)
            return dados_produto_SkyHub
        return False

    def mkpSkyHub_set_categories(self, cr, uid, id, conta_id, codigo, categoria, context=None):
        context = context and context.copy() or {}
        res = {'status': True, 'mensagem': ''}
        if not categoria:
            return {'status': False, 'mensagem': 'Faltou a descricao da categoria'}
        sh_con = SkyHub(cr, uid, conta_id)
        recurso = 'categories'
        data = {
            'category':
                {
                    'code': codigo or id,
                    'name': categoria,
                }
        }
        if not codigo:
            response = sh_con.post(recurso, data, {})
        else:
            response = sh_con.put(recurso, id, data)
        if response.status_code > 399:
            return {'status': False, 'mensagem': json.loads(response.content).get('error')}
        return res

    def mkpSkyHub_set_anuncios(self, cr, uid, brw_anuncio, context=None):
        context = context and context.copy() or {}
        obj_mkpromkp = self.pool.get('mkp.produto.marketplaces')
        obj_grade = self.pool.get('estoque.produto.grade')
        obj_anuncios_var = self.pool.get('mkp.anuncios.var')
        sh_con = SkyHub(cr, uid, brw_anuncio.mkpanu_conta_id.id)
        params = {}
        vals = {}
        _picture_produts = []
        _pictures_grades = {}
        _img_comum = []

        args = [('mkpromkp_produto_id', '=', brw_anuncio.mkpanu_produto_id.id), ('mkpromkp_marketplace_id', '=', brw_anuncio.mkpanu_marketplace_id.id)]
        mkpromkp_ids = obj_mkpromkp.search(cr, uid, args, context=context)
        if not mkpromkp_ids:
            return {'status': False, 'mensagem': 'Produto nao cadastrado no marketplace'}

        brw_mkpromkp = obj_mkpromkp.browse(cr, uid, mkpromkp_ids[0], context=context) # Embora se mkpromkp_ids, será sempre lista de 1
        for brw_imagens in brw_mkpromkp.mkpromkp_imagens_ids:
            _picture_produts.append(brw_imagens.mkprmkimg_endereco_mkp)
            if brw_anuncio.mkpanu_produto_id.grade_usar:
                _gr = brw_imagens.mkprmkimg_imagem_produto_id.estimg_grade_id.grade
                if not _gr: # imagem é é do produto e não da grade
                    _img_comum.append(brw_imagens.mkprmkimg_endereco_mkp)
                    continue
                _img_gr = _pictures_grades.get(_gr, [])
                if not brw_imagens.mkprmkimg_endereco_mkp: # Para SkyHub tem que ter endereço da imagem
                    continue
                _img_gr.append(brw_imagens.mkprmkimg_endereco_mkp)
                _pictures_grades[_gr]= _img_gr
        if brw_anuncio.mkpanu_produto_id.grade_usar and not _pictures_grades:
            return {'status': False,
                    'mensagem': 'O produto %s nao tem fotos das grades' % brw_anuncio.mkpanu_produto_id.codigo}
        for _img_idx in _pictures_grades.keys():
            _pictures_grades[_img_idx] = _pictures_grades.get(_img_idx) + _img_comum
        vals['name'] = brw_anuncio.mkpanu_title
        vals['description'] = brw_mkpromkp.mkpromkp_anuncio_preview_html.replace('<br>', '')
        if brw_anuncio.mkpanu_estado == 'A':
            vals['status'] = 'enabled'
        else:
            vals['status'] = 'disabled'
        _valor = brw_anuncio.mkpanu_valor_promocao or brw_anuncio.mkpanu_valor or brw_anuncio.mkpanu_valor_sugerido
        _peso = 0.3
        _altura = 7
        _largura = 10
        _comprimento = 10
        for brw_embalagem in brw_anuncio.mkpanu_produto_id.produto_embalagem_ids: # pegar APENAS A PRIMEIRA
            _peso = brw_embalagem.peso_bruto
            _altura = brw_embalagem.altura
            _largura = brw_embalagem.largura
            _comprimento = brw_embalagem.profundidade
            break
        vals['price'] = _valor
        vals['promotional_price'] = brw_anuncio.mkpanu_valor_promocao or _valor
        vals['cost'] = 0.0
        vals['weight'] = _peso
        vals['height'] = _altura
        vals['width'] = _largura
        vals['length'] = _comprimento
        vals['brand'] = 'Marca'
        vals['nbm'] = brw_anuncio.mkpanu_produto_id.ncm_id.codigo.replace('.','')
        vals['categories'] = [{'code': brw_mkpromkp.mkpromkp_categoria_id.mkpcat_codigo,
                               'name': brw_mkpromkp.mkpromkp_categoria_id.mkpcat_descricao_completa}]
        vals['images'] = _picture_produts
        vals['specifications'] = []
        if 'crossdocking' in brw_anuncio.mkpanu_title:
            vals['specifications'].append({'key': 'CrossDocking', 'value': 7})
        for brw_atributos in brw_anuncio.mkpanu_produto_id.estpro_atributo_ids:
            _at_vl = brw_atributos.estatp_atributo_valor
            if brw_atributos.estatp_tem_unidade:
                if not brw_atributos.estatp_atributo_unidade_id.name:
                    return {
                        'status': False,
                        'mensagem': _('Atributo "%s" sem unidade cadastrada!') % brw_atributos.estatp_atributo_id.name
                    }
                _at_vl = '%s %s' % (brw_atributos.estatp_atributo_valor, brw_atributos.estatp_atributo_unidade_id.name)
            if not _at_vl:
                continue
            # Retirando acentuacao do atributo
            # try:
            #     _at_vl = normalize('NFKD', _at_vl.decode('utf-8')).encode('ASCII', 'ignore')
            # except:
            #     _at_vl = normalize('NFKD', _at_vl).encode('ASCII', 'ignore')
            _at_vl = normalize('NFKD', _at_vl).encode('ASCII', 'ignore')

            vals['specifications'].append({'key': str(brw_atributos.estatp_atributo_id.name), 'value': str(_at_vl)})
            if brw_atributos.estatp_atributo_id.name == 'Marca':
                vals['brand'] = str(brw_atributos.estatp_atributo_valor)
        # Segundo a documentação, a garantia é apenas em meses
        # if brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_responsavel and \
        #         brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_prazo and \
        #         brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_prazo_tipo:
        #     _g = "Garantia"
        #     _tp = {'D': 'dias', 'M': 'meses', 'A': 'anos'}
        #     _pt = _tp.get(brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_prazo_tipo)
        #     _p = "%s %s" % (brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_prazo, _pt)
        #     _max = str(brw_anuncio.mkpanu_conta_id.mkpcta_qtd_maxima or brw_anuncio.mkpanu_qtd_maxima or '')
        #     vals['specifications'].append({'key': 'Garantia', 'value': _p})
        if brw_anuncio.mkpanu_produto_id.grade_usar:
            if not brw_anuncio.mkpanu_produto_id.estpro_grade_descricao:
                return {
                    'status': False,
                    'mensagem': _('Item "%s" sem descricao de grade cadastrada!') % brw_anuncio.mkpanu_produto_id.codigo
                }
            vals['sku'] = brw_anuncio.mkpanu_produto_id.codigo
            _sku = vals.get('sku')
            grades = []
            _local = brw_anuncio.mkpanu_conta_id.mkpcta_local_id.id
            for _brw_grade in brw_anuncio.mkpanu_produto_id.produto_grade_ids:
                context['company_id'] = brw_anuncio.company_id.id
                _x = obj_grade.estpgr_get_saldo(cr, uid, [_brw_grade.id], 'D', _local, context=context)
                vals_grade = {}
                vals_grade['sku'] = '%s-%s' % (brw_anuncio.mkpanu_produto_id.codigo, _brw_grade.grade)
                vals_grade['qty'] = int(_x.get(_brw_grade.id) / brw_anuncio.mkpanu_quantidade)
                for brw_cod_barra in brw_anuncio.mkpanu_produto_id.automacao_ids:
                    if _brw_grade.id == brw_cod_barra.grade_id.id:
                        if brw_cod_barra.autcba_tipo_barra == '13':
                            _barra = brw_cod_barra.codigo_barra[1:]
                            vals_grade['ean'] = _barra
                            break
                vals_grade['images'] = _pictures_grades.get(_brw_grade.grade) or []
                vals_grade['specifications'] = [{'key': brw_anuncio.mkpanu_produto_id.estpro_grade_descricao.lower(),
                                                 'value': _brw_grade.descricao},
                                                # {'key': 'price', 'value': _valor},
                                                # {'key': 'promotional_price', 'value': _valor},
                                                ]
                # if  brw_anuncio.mkpanu_produto_id.estpro_grade_descricao == 'CT':
                #     vals_grade['specifications'] = [{'key': 'cor','value': 'Preto'},{'key': 'tamanho','value': '38'} ]
                #     vals_grade['sku'] = '%s-PR38' % brw_anuncio.mkpanu_produto_id.codigo
                #     vals_grade['qty'] =  10
                #     v1={}
                #     v1['specifications'] = [{'key': 'cor','value': 'Preto'},{'key': 'tamanho','value': '40'}]
                #     v1['sku'] = '%s-PR40' % brw_anuncio.mkpanu_produto_id.codigo
                #     v1['qty'] =  17
                #     grades.append(v1)
                #     v2={}
                #     v2['specifications'] = [{'key': 'cor','value': 'Marron'},{'key': 'tamanho','value': '38'}]
                #     v2['sku'] = '%s-MA38' % brw_anuncio.mkpanu_produto_id.codigo
                #     v2['qty'] =  21
                #     grades.append(v2)

                grades.append(vals_grade)
                vals_var = {
                    'mkpanuv_anuncio_id': brw_anuncio.id,
                    'mkpanuv_grade_id': _brw_grade.id,
                    'mkpanuv_id_no_mkp': vals_grade.get('sku'),
                    'mkpanuv_valor': _valor,
                }
                args = [('mkpanuv_anuncio_id', '=', brw_anuncio.id),('mkpanuv_grade_id', '=', _brw_grade.id)]
                var_ids = obj_anuncios_var.search(cr, uid, args, context=context)
                if var_ids:
                    obj_anuncios_var.write(cr, uid, var_ids, vals_var, context=context)
                else:
                    obj_anuncios_var.create(cr, uid, vals_var, context=context)
            vals['variations'] = grades
            _var_attr = []
            for grade in grades:
                for x in grade.get('specifications'):
                    if not x.get('key') in _var_attr:
                        _var_attr.append(x.get('key'))
            vals['variation_attributes'] = [brw_anuncio.mkpanu_produto_id.estpro_grade_descricao.lower()]
        else:
            vals['sku'] = '%s-UN' % brw_anuncio.mkpanu_produto_id.codigo
            _sku = vals.get('sku')
            vals['qty'] = brw_anuncio.mkpanu_saldo
            for brw_cod_barra in brw_anuncio.mkpanu_produto_id.automacao_ids:
                if brw_cod_barra.autcba_tipo_barra == '13':
                     _barra = brw_cod_barra.codigo_barra[1:]
                     vals['ean'] = _barra
                     break
        res = {'status': True, 'mensagem': ''}
        vals = {'product': vals}
        _url = 'products/'
        if not brw_anuncio.mkpanu_codigo_anuncio:
            response = sh_con.post(_url, vals, params)
        else:
            response = sh_con.put(_url, _sku, vals)
        if response.status_code > 399:
            return {'status': False, 'mensagem': json.loads(response.content).get('error')}
        return res

    def mkpSkyHub_atualizar_saldo(self, cr, uid, anuncio_id, context=None):
        """
        Inclui ou altera saldo dos anuncio no site do Prestashop
        @param cr:
        @param uid:
        @param anuncio_id: ids do produto a ser alterado
        @param context:
        @return: dicionario contendo id do anuncio e response ex.:{status: True/False, 'mensagem': 'Mensagem'}
                 response. quando response.raise_for_status() for None, tá tudo certo. Para pegar o erro use response.status_code
        """

        context = context and context.copy() or {}
        res = {'status': True, 'mensagem': ''}
        obj_anuncio = self.pool.get('mkp.anuncios')
        obj_grade = self.pool.get('estoque.produto.grade')
        brw_anuncio = obj_anuncio.browse(cr, uid, anuncio_id, context=context)
        sh_con = SkyHub(cr, uid, brw_anuncio.mkpanu_conta_id.id)
        _local = brw_anuncio.mkpanu_conta_id.mkpcta_local_id.id
        # Verificar situacao do anuncio no Marketplace
        if not brw_anuncio.mkpanu_codigo_anuncio:
            res = {'status': True, 'mensagem': ''}
            return res
        _product = {}
        if brw_anuncio.mkpanu_produto_id.grade_usar:
            _sku = brw_anuncio.mkpanu_produto_id.codigo
            grades = []
            for brw_grade in brw_anuncio.mkpanu_produto_id.produto_grade_ids:
                vals_grade = {}
                context['company_id'] = brw_anuncio.company_id.id
                _x = obj_grade.estpgr_get_saldo(cr, uid, [brw_grade.id], 'D', _local, context=context)
                vals_grade['qty'] = int(_x.get(brw_grade.id) / brw_anuncio.mkpanu_quantidade) if _x.get(brw_grade.id) > 0 else 0,
                vals_grade['sku'] = '%s-%s' % (brw_anuncio.mkpanu_produto_id.codigo, brw_grade.grade)
                grades.append(vals_grade)
                continue
            _product['variations'] = grades
        else:
            _sku = '%s-UN' % brw_anuncio.mkpanu_produto_id.codigo
            _product['qty'] = brw_anuncio.mkpanu_saldo
        vals = {'product': _product}
        _url = 'products'
        response = sh_con.put(_url, _sku, vals)
        if response.status_code > 399:
            return {'status': False, 'mensagem': json.loads(response.content).get('message')}
        return res

    def mkpSkyHub_pesquisar_orders(self, cr, uid, conta_id, context=None):
        context = context and context.copy() or {}
        sh_con = SkyHub(cr, uid, conta_id)
        response = sh_con.get('queues/orders', {})
        if response.status_code > 399:
            return {'status': False, 'mensagem': json.loads(response.content).get('message')}
        if not response.content:
            return False
        _ped = json.loads(response.content)
        obj_utils = self.pool.get('mkp.utils')
        dados_ped = obj_utils.mkputl_importar_um_pedido_skyhub(cr, uid, _ped, conta_id, context=None)
        if dados_ped:
            args = [('mkpnot_conta_id', '=', conta_id), ('mkpnot_resource', '=', 'orders/%s' % _ped.get('code'))]
            not_ids = self.pool.get('mkp.notificacoes').search(cr, uid, args, context=context)
            if not_ids:
                vals = {
                    'state': 'R',
                }
                self.pool.get('mkp.notificacoes').write(cr, uid, not_ids, vals, context=context)
            else:
                vals = {
                'mkpnot_conta_id': conta_id,
                'mkpnot_resource': 'orders/%s' % _ped.get('code'),
                'mkpnot_topic': 'orders',
                'mkpnot_attempts': 1,
                'state': 'P',
                }
                res = self.pool.get('mkp.notificacoes').create(cr, uid, vals, context=context)
            response = sh_con.delete('queues/orders', _ped.get('code'))
        return dados_ped

    def mkpSkyHub_get_order(self, cr, uid, _order, _conta_id, context=None):
        context = context and context.copy() or {}
        sh_con = SkyHub(cr, uid, _conta_id)
        response = sh_con.get(_order, {})
        if response.status_code > 399:
            return {'status': False, 'mensagem': json.loads(response.content).get('message')}
        if not response.content:
            return False
        _ped = json.loads(response.content)
        return _ped

    def mkpSkyHub_set_order_faturado(self, cr, uid, _order, _conta_id, chave, data, context=None):
        context = context and context.copy() or {}
        sh_con = SkyHub(cr, uid, _conta_id)
        recurso = 'orders/%s/invoice' % _order
        _dt  = datetime.now()
        _dt = _dt.replace(tzinfo=pytz.utc)
        data_hora_tz = datetime.astimezone(_dt, pytz.timezone("America/Sao_Paulo"))
        _dt = datetime.strftime(data_hora_tz, u'%Y-%m-%dT%H:%M:%S') + str(data_hora_tz)[-6:]
        data = {
                  "invoice": {
                    "volume_qty": 1,
                    "key": chave,
                    "issue_date": _dt,
                  },
                  "status": "order_invoiced"
        }
        response = sh_con.post(recurso, data, {})
        if response.status_code == 422:
            data.pop('status')
            response = sh_con.post(recurso, data, {})
        if response.status_code > 399:
            return {'status': False, 'mensagem': json.loads(response.content)}
        # if not response.content:
        #     return {'status': False, 'mensagem': ''}
        return {'status': True, 'mensagem': ''}

    def mkpSkyHub_full_enviar_xml(self, cr, uid, _conta_id, xml, cnpj_cd, context=None):
        context = context and context.copy() or {}
        sh_con = SkyHub(cr, uid, _conta_id)
        recurso = 'fulfillment/b2w/delivery'
        data = {
              "invoice": {
                  "payload": xml,
              },
              "recipient_document": cnpj_cd
        }
        response = sh_con.post(recurso, data, {})
        if response.status_code > 399:
            return {'status': False, 'mensagem': json.loads(response.content)}
        if not response.content:
            return {'status': False, 'mensagem': ''}
        return {'status': True, 'mensagem': ''}

    def mkpSkyHub_cancelar_pedido(self, cr, uid, conta_id, pedido_externo, context=None):
        context = context and context.copy() or {}
        sh_con = SkyHub(cr, uid, conta_id)
        _dados = {'status': 'order_canceled'}
        recurso = 'orders/%s/cancel' % pedido_externo
        response = sh_con.post(recurso, _dados, {})
        if response.status_code > 399:
            return {'status': False, 'mensagem': json.loads(response.content).get('message')}
        if not response.content:
            return False
        return True

    def mkpSkyHub_entregar_pedido(self, cr, uid, conta_id, pedido_externo, context=None):
        context = context and context.copy() or {}
        sh_con = SkyHub(cr, uid, conta_id)
        _dados = {'status': 'complete'}
        recurso = 'orders/%s/delivery' % pedido_externo
        response = sh_con.post(recurso, _dados, {})
        if response.status_code > 399:
            return {'status': False, 'mensagem': json.loads(response.content).get('message')}
        if not response.content:
            return False
        return True

    def mkpSkyHub_postar_pedido(self, cr, uid, conta_id, pedido_externo, etiqueta, context=None):
        context = context and context.copy() or {}
        sh_con = SkyHub(cr, uid, conta_id)
        _dt  = datetime.now()
        _dt = _dt.replace(tzinfo=pytz.utc)
        data_hora_tz = datetime.astimezone(_dt, pytz.timezone("America/Sao_Paulo"))
        _dt = datetime.strftime(data_hora_tz, u'%Y-%m-%dT%H:%M:%S') + str(data_hora_tz)[-6:]
        _dados = {"status":"order_shipped",
                  "shipment":{"code": pedido_externo,
                              # "items":[{"sku":"1001","qty":1}],
                              "delivered_carrier_date": _dt,
                              "track":{"code": etiqueta,
                                       "carrier":"Correios",
                                       # "method":"SEDEX",
                                       "url":"www.correios.com.br"
                                       }
                              }
                  }
        recurso = 'orders/%s/shipments' % pedido_externo
        response = sh_con.post(recurso, _dados, {})
        if response.status_code > 399:
            return {'status': False, 'mensagem': json.loads(response.content).get('message')}
        if not response.content:
            return False
        return True

    def mkpSkyHub_get_set_plp(self, cr, uid, conta_id, pedido_externo, context=None):
        context = context and context.copy() or {}
        sh_con = SkyHub(cr, uid, conta_id)
        i = 0
        while True:
            _dados = {'order_remote_codes': [pedido_externo]}
            recurso = 'shipments/b2w'
            response = sh_con.post(recurso, _dados, {})
            if response.status_code > 399:
                if i > 0:
                    break
                recurso = 'shipments/b2w/to_group'
                response = sh_con.get(recurso, {'offset': 1})
                i = 1
            else:
                break
        if response.status_code > 399:
            try:
                _mens = ''
                if json.loads(response.content):
                    _mens = json.loads(response.content)
                    if json.loads(response.content).get('error'):
                        _mens = json.loads(response.content).get('error')
                return {'status': False, 'mensagem': _mens}
            except:
                return {'status': False, 'mensagem': response.content}
        if not response.content:
            return False
        res = json.loads((response.content))
        _men = res.get('message', False)
        lista = _men.split(' ')
        return lista[1]

    def mkpSkyHub_get_etiqueta_mkp(self, cr, uid, conta_id, plp, context=None):
        context = context and context.copy() or {}
        sh_con = SkyHub(cr, uid, conta_id)
        recurso = 'shipments/b2w/view'
        params = {'plp_id': plp}
        response = sh_con.get(recurso, params)
        if response.status_code > 399:
            return {'status': False, 'mensagem': json.loads(response.content).get('message')}
        if not response.content:
            return False
        dados = json.loads(response.content)
        return dados

    def mkpSkyHub_get_nf_ret_simbol_mkp(self, cr, uid, conta_id, cnpj,  chave_nfe, context=None):
        context = context and context.copy() or {}
        sh_con = SkyHub(cr, uid, conta_id)
        recurso = 'fulfillment/b2w/delivery/nfe'
        params = {'cd_vat_number': cnpj, 'order_access_key': chave_nfe}
        response = sh_con.get(recurso, params)
        if response.status_code == 404:  # "Nota nao encontrada"
            return {}
        if response.status_code > 399:
            return {'status': False, 'mensagem': json.loads(response.content).get('message')}
        if not response.content:
            return False
        dados = json.loads(response.content)
        return dados