# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################
from openerp.osv import osv
from openerp.tools.translate import _
import logging
from ..controller import Supercampo
from SigUtils import datas
from openerp.osv.fields import float_round

import datetime
import requests
import zipfile
import json
import time
import base64
import os


# Classe de alto nivel para comunicação com o Mercado Livre
class mkp_Supercampo(osv.Model):
    _name = 'mkp.supercampo'
    _auto = False
    _tem_erro = False
    _mensagem_erro = ''
    _logger = logging.getLogger(_name)

    def mkpSupercampo_get_set_depositos(self, cr, uid, conta_id, context=None):
        def _set_deposito():
            brw_conta = self.pool.get('mkp.contas').browse(cr, uid, conta_id, context=context)
            _pessoa_id = brw_conta.company_id.rescon_pessoa_id.id
            _end = self.pool.get('adm.pessoa').admpes_endereco_fiscal(cr, uid, [_pessoa_id], context=context)
            body = {
                'name': 'EMP %s' % brw_conta.company_id.id,
                'packingTime': 1,
                'zipcode': _end.get(_pessoa_id).get('cep').replace('.', ''),
                'state': _end.get(_pessoa_id).get('uf_sigla'),
                'city': _end.get(_pessoa_id).get('cidade'),
                'quarter': _end.get(_pessoa_id).get('bairro') or '',
                'street': _end.get(_pessoa_id).get('logradouro'),
                'number': _end.get(_pessoa_id).get('numero') or '',
                'complement': _end.get(_pessoa_id).get('complemento') or '',
            }
            resp = con_supercampo.supercampo_comunicar('post', path, body=body)
            if resp.get('error'):
                ret = {'status': False, 'mensagem': resp.get('message'), 'depositos': []}
                return ret
            con_supercampo.deposito_id = resp.get('response').get('id')
            vals = {
                'mkpcta_supercampo_deposito_id': con_supercampo.deposito_id,
            }
            self.pool.get('mkp.contas').write(cr, uid, conta_id, vals, context=context)
            return {'status': True, 'mensagem': '', 'depositos': [con_supercampo.deposito_id]}
        con_supercampo = Supercampo(cr, uid, conta_id)
        path = '/warehouses/'
        body = {
        }
        resp = con_supercampo.supercampo_comunicar('get', path, body=body)
        if resp.get('error') == 404 and resp.get('message') and 'NOT_FOUND' in resp.get('message'):
            resp = _set_deposito()
            return resp
        if resp.get('error'):
            ret = {'status': False, 'mensagem': resp.get('message'), 'depositos': []}
            return ret
        for _deposito in resp.get('response'):
            con_supercampo.deposito_id = _deposito.get('id')
            vals = {
                'mkpcta_supercampo_deposito_id': con_supercampo.deposito_id,
            }
            self.pool.get('mkp.contas').write(cr, uid, conta_id, vals, context=context)

        ret = {'status': True, 'mensagem': '', 'depositos': resp.get('response')}
        return ret

    def mkpSupercampo_autenticar(self, cr, uid, conta_id, context=None):
        con_supercampo = Supercampo(cr, uid, conta_id)
        res = con_supercampo.authorize()
        if con_supercampo.deposito_id < 1:
            resp = self.mkpSupercampo_get_set_depositos(cr, uid, conta_id, context=context)
        return res

    def mkpSupercampo_get_categorias(self, cr, uid, conta_id):
        self._logger.info('Buscando categorias na Supercampo!')
        con_supercampo = Supercampo(cr, uid, conta_id)
        path = '/listParents/'
        body = {
        }
        resp = con_supercampo.supercampo_comunicar('get', path, body=body)
        if resp.get('error'):
            ret = {'status': False, 'mensagem': resp.get('message'), 'categorias': []}
            return ret
        _categorias_pai = resp.get('response').get('categories')
        _categorias = []
        for _categ in _categorias_pai:
            _d = _categ.copy()
            _categ_id = _categ.get('id')
            path = '/listCategoryTree/%s' % _categ_id
            body = {
            }
            try:
                resp = con_supercampo.supercampo_comunicar('get', path, body=body)
            except:
                _d['filhas'] = []
                _categorias.append(_d)
                continue
            if resp.get('error'):
                if 'NOT_FOUND' in resp.get('message'):  # sem subcategorias
                    continue
                ret = {'status': False, 'mensagem': resp.get('message'), 'categorias': []}
                return ret
            _d['filhas'] = resp.get('response').get('categories')
            _categorias.append(_d)

        ret = {'status': True, 'mensagem': '', 'categorias': _categorias}
        return ret

    def mkpSupercampo_get_orders(self, cr, uid, order, conta_id, context=None):
        self._logger.info(_('Buscando orders na Supercampo!'))
        con_supercampo = Supercampo(cr, uid, conta_id)
        path = '/partnerOrders/%s' % order
        body = {
        }
        resp = con_supercampo.supercampo_comunicar('get', path, body)
        if resp.get('errors'):
            if resp.get('message'):
                ret = {'status': False, 'mensagem': resp.get('message'), 'orders': []}
            else:
                ret = {'status': False, 'mensagem': resp.get('errors'), 'orders': []}
        else:
            ret = {'status': True, 'mensagem': '', 'orders': resp.get('response')}
        return ret

    # Todo: Ok
    def mkpSupercampo_get_atributos(self, cr, uid, conta_id, context=None):
        self._logger.info(_('Buscando atributos do Supercampo!'))
        path = '/attributeGroups'
        con_supercampo = Supercampo(cr, uid, conta_id)
        body = {
        }
        resp_gr = con_supercampo.supercampo_comunicar('get', path, body)
        if resp_gr.get('error'):
            ret = {'status': False, 'mensagem': resp_gr.get('message'), 'atributos': []}
            return ret
        atributos = []
        for grupo in resp_gr.get('response').get('attributeGroups'):
            path = '/attributes/group/%s' % grupo.get('id')
            resp = con_supercampo.supercampo_comunicar('get', path, body)
            if resp.get('error'):
                ret = {'status': False, 'mensagem': resp.get('message'), 'atributos': []}
                return ret
            for atributo in resp.get('response').get('attributes'):
                atributos.append(atributo)
        ret = {'status': True, 'mensagem': '', 'atributos': atributos}
        return ret

    # Todo: Verificar

    def mkpSupercampo_get_set_stocks(self, cr, uid, brw_anuncio, context=None):
        def _set_stock():
            brw_conta = brw_anuncio.mkpanu_conta_id
            _pessoa_id = brw_conta.company_id.rescon_pessoa_id.id
            _end = self.pool.get('adm.pessoa').admpes_endereco_fiscal(cr, uid, [_pessoa_id], context=context)

            _sku = self._mkpSupercampo_get_sku_produto(cr, uid, brw_anuncio, context=context)
            body = {
                'productId': int(_id_product),
                'warehouseId': brw_conta.mkpcta_supercampo_deposito_id,
                'quantity': 0,
                'price': 10000,
                'virtualQuantity': 0,
                'leadTime': 1,
                'byRequest': False,
                'partCode': _sku,
            }
            path = '/stocks'
            resp = con_supercampo.supercampo_comunicar('post', path, body=body)
            if resp.get('error'):
                ret = {'status': False, 'mensagem': resp.get('message'), 'depositos': []}
                return ret
            return {'status': True, 'mensagem': '', 'stock': resp.get('response').get('id')}

        con_supercampo = Supercampo(cr, uid, brw_anuncio.mkpanu_conta_id.id)
        ids_stocks = {
            'produto': None,
            'grades': {},
        }
        _skus = self._mkpSupercampo_get_sku_produto(cr, uid, brw_anuncio, context=context)
        if '-' in brw_anuncio.mkpanu_codigo_anuncio:
            _id_product, _id_stock = brw_anuncio.mkpanu_codigo_anuncio.split('-')
        else:
            _id_product = brw_anuncio.mkpanu_codigo_anuncio
            path = '/stocks/find/%s' % _id_product
            body = {
            }
            _sku = _skus.get('sku_produto')
            resp = con_supercampo.supercampo_comunicar('get', path, body=body)
            if resp.get('response') and resp.get('response').get('error') == 'Produto sem estoque.':
                resp = _set_stock()
                if resp.get('error'):
                    if resp.get('message'):
                        ret = {'status': False, 'mensagem': resp.get('message'), 'stock': None}
                    else:
                        ret = {'status': False, 'mensagem': resp.get('error'), 'stock': None}
                    return ret
                _id_stock = resp.get('stock')
            else:
                _id_stock = resp.get('response').get('stock')[0].get('id')
        ids_stocks['produto'] = _id_stock
        for brw_var in brw_anuncio.mkpanu_variacoes_ids:
            if '-' in brw_var.mkpanuv_id_no_mkp:
                _id_product, _id_stock = brw_var.mkpanuv_id_no_mkp.split('-')
            else:
                _id_product = brw_var.mkpanuv_id_no_mkp
                for _grade in _skus.get('sku_grades').keys():
                    if brw_var.mkpanuv_grade_id.grade != _grade:
                        continue
                    _sku = _skus.get('sku_grades').get(_grade)
                    path = '/stocks/find/%s' % _id_product
                    resp = con_supercampo.supercampo_comunicar('get', path, body=body)
                    if resp.get('response') and resp.get('response').get('error') == 'Produto sem estoque.':
                        resp = _set_stock()
                        if resp.get('error'):
                            if resp.get('message'):
                                ret = {'status': False, 'mensagem': resp.get('message'), 'stock': None}
                            else:
                                ret = {'status': False, 'mensagem': resp.get('error'), 'stock': None}
                            return ret
                        _id_stock = resp.get('stock')
                    else:
                        _id_stock = resp.get('response').get('stock')[0].get('id')
                    break
            ids_stocks['grades'][brw_var.mkpanuv_grade_id.grade] = _id_stock
        ret = {'status': True, 'mensagem': '', 'stock': ids_stocks}
        return ret

    def mkpSupercampo_atualizar_saldo_preco(self, cr, uid, anuncio_id, context=None):
        """
        Inclui ou altera saldo e o preco do anuncio no site do Supercampo
        @param cr:
        @param uid:
        @param anuncio_id: ids do anuncio alterado
        @param context:
        @return: dicionario contendo id do anuncio e response ex.:{status: True/False, 'mensagem': 'Mensagem'}
                 response. quando response.raise_for_status() for None, tá tudo certo. Para pegar o erro use response.status_code
        """
        context = context and context.copy() or {}
        _spg = self.pool.get
        brw_anuncio = _spg('mkp.anuncios').browse(cr, uid, anuncio_id, context=context)
        context['company_id'] = brw_anuncio.company_id.id
        con_supercampo = Supercampo(cr, uid, brw_anuncio.mkpanu_conta_id.id)
        _conta_id = brw_anuncio.mkpanu_conta_id.id
        _local = brw_anuncio.mkpanu_conta_id.mkpcta_local_id.id
        _valor = brw_anuncio.mkpanu_valor_promocao or brw_anuncio.mkpanu_valor or brw_anuncio.mkpanu_valor_sugerido
        if not brw_anuncio.mkpanu_codigo_anuncio:
            return {'status': False, 'mensagem': _('Produto nao cadastrado no mkp!'), 'item': []}
        resp = self.mkpSupercampo_get_set_stocks(cr, uid, brw_anuncio, context=context)
        if resp.get('error'):
            ret = {'status': False, 'mensagem': resp.get('message'), 'stock': {}}

        _stocks = resp.get('stock')
        if not brw_anuncio.mkpanu_produto_id.grade_usar:  # produtos sem grade
            _id_stock = _stocks.get('produto')
            body = {
                'price': float(_valor),
                'quantity': int(brw_anuncio.mkpanu_saldo),
                'virtualQuantity': 0,
                'leadTime': 1,
                'byRequest': False,
            }
            if brw_anuncio.mkpanu_estado == 'P':
                body['quantity'] = 0
            path = '/stocks/%s'
            _path = path % int(_id_stock)
            resp = con_supercampo.supercampo_comunicar('put', _path, body)
            if resp.get('error'):
                ret = {'status': False, 'mensagem': resp.get('message'), 'stock': []}
            else:
                ret = {'status': True, 'mensagem': '', 'stock': brw_anuncio.mkpanu_codigo_anuncio}
                if not '-' in brw_anuncio.mkpanu_codigo_anuncio:
                    vals = {'mkpanu_codigo_anuncio': '%s-%s' % (brw_anuncio.mkpanu_codigo_anuncio, _id_stock)}
                    self.pool.get('mkp.anuncios').write(cr, uid, brw_anuncio.id, vals, context=context)
            return ret
        body = {
            'price': float(_valor),
            'quantity': int(brw_anuncio.mkpanu_saldo),
            'virtualQuantity': 0,
            'leadTime': 1,
            'byRequest': False,
        }
        for brw_variacoes in brw_anuncio.mkpanu_variacoes_ids:
            _id_stock = _stocks.get('grades').get(brw_variacoes.mkpanuv_grade_id.grade)
            _grade_id = brw_variacoes.mkpanuv_grade_id.id
            context['company_id'] = brw_anuncio.company_id.id
            _x = _spg('estoque.produto.grade').estpgr_get_saldo(cr, uid, [_grade_id], 'D', _local, context=context)
            if _x.get(_grade_id) == 0:
                _saldo_zero = True
            body['quantity'] = int(_x.get(_grade_id) / brw_anuncio.mkpanu_quantidade) if _x.get(_grade_id) > 0 else 0
            path = '/stocks/%s'
            _path = path % int(_id_stock)
            resp = con_supercampo.supercampo_comunicar('put', _path, body)
            if resp.get('error'):
                ret = {'status': False, 'mensagem': resp.get('message'), 'item': []}
            else:
                ret = {'status': True, 'mensagem': ''}
            if not '-' in brw_variacoes.mkpanuv_id_no_mkp:
                vals = {'mkpanuv_id_no_mkp': '%s-%s' % (brw_variacoes.mkpanuv_id_no_mkp, _id_stock)}
                self.pool.get('mkp.anuncios.var').write(cr, uid, brw_variacoes.id, vals, context=context)
            if not brw_anuncio.mkpanu_variacoes_ids:
                ret = {'status': False, 'mensagem': _('Item com grade, mas sem variacoes cadastradas!'), 'item': []}
        return ret

    # # Todo: Verificar
    # def mkpSupercampo_verificar_variacoes(self, cr, uid, brw_anuncio, variacoes, context=None):
    #     _spg = self.pool.get
    #     context = context and context.copy() or {}
    #     for variacao in variacoes:
    #         _codigo, _grade = variacao.get('variation_sku').split('-')
    #         _args = [('produto_id', '=', brw_anuncio.mkpanu_produto_id.id),
    #                  ('grade', '=', _grade)]
    #         _grade_ids = _spg('estoque.produto.grade').search(cr, uid, _args, context=context)
    #         if not _grade_ids:
    #             continue
    #         _var_mkp_id = variacao.get('variation_id')
    #         _args = [('mkpanuv_anuncio_id', '=', brw_anuncio.id),
    #                  ('mkpanuv_grade_id', '=', _grade_ids[0])]
    #         var_ids = _spg('mkp.anuncios.var').search(cr, uid, _args, context=context)
    #         if var_ids:
    #             _spg('mkp.anuncios.var').write(cr, uid, var_ids[0], {'mkpanuv_id_no_mkp': _var_mkp_id}, context=context)
    #         else:
    #             vals = {
    #                 'mkpanuv_anuncio_id': brw_anuncio.id,
    #                 'mkpanuv_grade_id': _grade_ids[0],
    #                 'mkpanuv_id_no_mkp': _var_mkp_id
    #             }
    #             _spg('mkp.anuncios.var').create(cr, uid, vals, context=context)
    #     return True

    # # todo: verificar os metodos de variaçoes no supercampo
    # def mkpSupercampo_set_variacoes(self, cr, uid, brw_anuncio, anuncio_code, context=None):
    #     _spg = self.pool.get
    #     context = context and context.copy() or {}
    #     con_supercampo = Supercampo(cr, uid, brw_anuncio.mkpanu_conta_id.id)
    #     variacoes_atualizar = {}
    #     variacoes_existentes = {}
    #     vals_criar_option = []
    #     vals_criar_model = []
    #     vals_alterar = []
    #     vals_alterar_com_novo = []
    #     for brw_variacoes in brw_anuncio.mkpanu_variacoes_ids:
    #         variacoes_existentes.update({
    #             brw_variacoes.mkpanuv_grade_id.id: {
    #                 'id_no_mkp': brw_variacoes.mkpanuv_id_no_mkp,
    #                 'id_no_erp': brw_variacoes.id,
    #             }
    #         })
    #     _local = brw_anuncio.mkpanu_conta_id.mkpcta_local_id.id
    #     i = 0
    #     for _brw_grade in brw_anuncio.mkpanu_produto_id.produto_grade_ids:
    #         _sku = '%s-%s' % (brw_anuncio.mkpanu_produto_id.codigo, _brw_grade.grade)
    #         _grade_ids = [_brw_grade.id]
    #         context['company_id'] = brw_anuncio.company_id.id
    #         _x = _spg('estoque.produto.grade').estpgr_get_saldo(cr, uid, _grade_ids, 'D', _local)
    #         _saldo = int(_x.get(_brw_grade.id) / brw_anuncio.mkpanu_quantidade)
    #         var = {
    #             'image': {'image_id': ''},
    #             'normal_stock': _saldo,
    #             'original_price': brw_anuncio.mkpanu_valor_promocao or brw_anuncio.mkpanu_valor or brw_anuncio.mkpanu_valor_sugerido,
    #             'model_sku': _sku,
    #             'option': _brw_grade.descricao,
    #             'tem_reg_variacao': False,
    #             'grade_id': _brw_grade.id,
    #         }
    #         if _brw_grade.id in variacoes_existentes.keys():
    #             var['tem_reg_variacao'] = True
    #             var['id_no_mkp'] = variacoes_existentes.get(_brw_grade.id).get('id_no_mkp')
    #             var['var_id_no_erp'] = variacoes_existentes.get(_brw_grade.id).get('id_no_erp')
    #         variacoes_atualizar[_brw_grade.descricao] = var
    #         vals_alterar_com_novo.append({'option': var.get('option')})
    #         if var.get('id_no_mkp'):
    #             vals_alterar.append({'option': var.get('option')})
    #             i += 1
    #         else:
    #             vals_criar_option.append({'option': var.get('option')})
    #             vals_criar_model.append({
    #                 'tier_index': [i],
    #                 'normal_stock': var.get('normal_stock'),
    #                 'original_price': var.get('original_price'),
    #                 'model_sku': var.get('model_sku'),
    #             })
    #             i += 1
    #
    #     if vals_alterar and vals_criar_option:
    #         vals_alterar = vals_alterar_com_novo
    #         vals_criar_option = []
    #
    #     if vals_alterar:
    #
    #         """Alterar variacoes ja cadastradas"""
    #         path = '/api/v2/product/update_tier_variation'
    #         body = {
    #             'item_id': int(anuncio_code),
    #             'tier_variation': [{
    #                 'name': brw_anuncio.mkpanu_produto_id.estpro_grade_descricao,
    #                 'option_list': vals_alterar,
    #             }],
    #         }
    #         resp = con_supercampo.supercampo_comunicar('post', path, body)
    #         if resp.get('error'):
    #             # ret = {'status': False, 'mensagem': resp.get('message'), 'variacoes': []}
    #             return resp
    #
    #         if vals_criar_model:
    #             """Criar modelo(nova grade)"""
    #             path = '/api/v2/product/add_model'
    #             body = {
    #                 'item_id': int(anuncio_code),
    #                 'model_list': vals_criar_model,
    #             }
    #             resp = con_supercampo.supercampo_comunicar('post', path, body)
    #             if resp.get('error'):
    #                 # ret = {'status': False, 'mensagem': resp.get('message'), 'variacoes': []}
    #                 return resp
    #             resp_var = resp.get('response').get('model')
    #             i = 0
    #             for x in vals_alterar:
    #                 _grade = x.get('option')
    #                 for y in resp_var:
    #                     if y.get('tier_index')[0] != i:
    #                         continue
    #                     variacoes_atualizar[_grade]['id_no_mkp'] = y.get('model_id')
    #                     break
    #                 i += 1
    #
    #     if vals_criar_option:
    #         """Criar variacoes novas"""
    #         path = '/api/v2/product/init_tier_variation'
    #         body = {
    #             'item_id': int(anuncio_code),
    #             'tier_variation': [{
    #                 'name': brw_anuncio.mkpanu_produto_id.estpro_grade_descricao,
    #                 'option_list': vals_criar_option,
    #             }],
    #             'model': vals_criar_model,
    #         }
    #         resp = con_supercampo.supercampo_comunicar('post', path, body)
    #         if resp.get('error'):
    #             # ret = {'status': False, 'mensagem': resp.get('message'), 'variacoes': []}
    #             return resp
    #         resp_var = resp.get('response').get('model')
    #         i = 0
    #         for x in vals_criar_option:
    #             _grade = x.get('option')
    #             variacoes_atualizar[_grade]['id_no_mkp'] = resp_var[i].get('model_id')
    #             i += 1
    #
    #     """Criar e atualizar registros de variacoes"""
    #     for _grade in variacoes_atualizar.keys():
    #         var = variacoes_atualizar.get(_grade)
    #         vals_vars = {
    #             'mkpanuv_anuncio_id': brw_anuncio.id,
    #             'mkpanuv_grade_id': var.get('grade_id'),
    #             'mkpanuv_id_no_mkp': var.get('id_no_mkp'),
    #         }
    #         if var.get('tem_reg_variacao'):
    #             _spg('mkp.anuncios.var').write(cr, uid, var.get('var_id_no_erp'), vals_vars, context=context)
    #         else:
    #             _spg('mkp.anuncios.var').create(cr, uid, vals_vars, context=context)
    #     """Excluir variacoes existentes no mkp"""
    #     for idx in variacoes_existentes.keys():
    #         x = variacoes_existentes.get(idx)
    #         _achei = False
    #         for idx in variacoes_atualizar.keys():
    #             y = variacoes_atualizar.get(idx)
    #             if x.get('id_no_erp') == y.get('var_id_no_erp'):
    #                 _achei = True
    #                 break
    #         if not _achei:
    #             _spg('mkp.anuncios.var').unlink(cr, uid, x.get('id_no_erp'), context=context)
    #
    #     # for var_alt in variacoes_alterar:
    #     #     path = '/api/v1/items/update_variation_stock'
    #     #     k = var_alt.keys()[0]
    #     #     body = {
    #     #         'item_id': int(anuncio_code),
    #     #         'variation_id': int(k),
    #     #         'stock': var_alt.get(k),
    #     #         'price': brw_anuncio.mkpanu_valor_promocao or brw_anuncio.mkpanu_valor or brw_anuncio.mkpanu_valor_sugerido,
    #     #     }
    #     #     resp = con_supercampo.supercampo_comunicar(path, body)
    #     #     # tratar retorno
    #     #     if resp.get('error'):
    #     #         ret = {'status': False, 'mensagem': resp.get('message'), 'variacoes': []}
    #     #         return ret
    #     # ret = {'status': True, 'mensagem': '', 'variacoes': resp.get('variations')}
    #     return resp

    # # Todo: Ok
    # def mkpSupercampo_set_imagem(self, cr, uid, conta_id, imagem, context=None):
    #     _spg = self.pool.get
    #     context = context and context.copy() or {}
    #     _arq = '/tmp/supercampo_%s.jpg' % time.time()
    #     f = open(_arq, 'wb')
    #     f.write(base64.b64decode(imagem))
    #     f.close()
    #     con_supercampo = Supercampo(cr, uid, conta_id)
    #     path = '/api/v2/media_space/upload_image'
    #     files = {
    #         'image': open(_arq, 'rb'),
    #         'Content-Disposition': 'form-data; name="image"; filename="%s"' % _arq,
    #         'Content-Type': 'image/jpeg',
    #     }
    #     resp = con_supercampo.supercampo_comunicar('upload', path, files)
    #     os.remove(_arq)
    #     if resp.get('error'):
    #         ret = {'status': False, 'mensagem': resp.get('message'), 'images': []}
    #     else:
    #         ret = {'status': True, 'mensagem': '', 'images': resp.get('response')}
    #     return ret

    def mkpSupercampo_set_get_brand(self, cr, uid, conta_id, categoria, marca, context=None):
        _spg = self.pool.get
        context = context and context.copy() or {}
        con_supercampo = Supercampo(cr, uid, conta_id)
        path = '/manufacturer'
        params = {
            'name': marca
        }
        resp = con_supercampo.supercampo_comunicar('get', path, params=params)
        if resp.get('error'):
            if resp.get('message'):
                ret = {'status': False, 'mensagem': resp.get('message'), 'brands': {}}
            else:
                ret = {'status': False, 'mensagem': resp.get('errors'), 'brands': {}}
            return ret
        for lista in resp.get('response').get('manufacturers'):
            if lista.get('name').lower() == marca.lower():
                _dMarca = lista.get('id')
                ret = {'status': True, 'mensagem': '', 'brands': _dMarca}
                return ret
        body = {
            'name': marca,
            'fullName': marca,
            'description': marca,
        }
        resp = con_supercampo.supercampo_comunicar('post', path, data=body)
        if resp.get('error'):
            ret = {'status': False,
                   'mensagem': resp.get('message'),
                   'marcas': {}}
            return ret
        _dMarca = resp.get('response').get('id')
        ret = {'status': True, 'mensagem': '', 'brands': _dMarca}
        return ret

    def _mkpSupercampo_verificar_cadastrar_imagem(self, cr, uid, brw_anuncio, context=None):
        def _excluir_imagens(codigo):
            _path = path % codigo
            params = {
            }
            resp = con_supercampo.supercampo_comunicar('delete', _path, params=params)
            return True

        def _adicionar_imagens(imagem):
            controle[0] += 1
            _arq = '/tmp/SupCam_%s.jpg' % controle[0]
            f = open(_arq, 'wb')
            f.write(base64.b64decode(imagem))
            f.close()
            files.append(
                ('images', ('file', open(_arq, 'rb'), 'application/octet-stream'))
            )
            nome_files.append(_arq)
            return True

        con_supercampo = Supercampo(cr, uid, brw_anuncio.mkpanu_conta_id.id)
        _spg = self.pool.get
        args = [
            ('mkpromkp_produto_id', '=', brw_anuncio.mkpanu_produto_id.id),
            ('mkpromkp_marketplace_id', '=', brw_anuncio.mkpanu_marketplace_id.id),
            ('company_id', '=', brw_anuncio.company_id.id)
        ]
        context['sig_force_company'] = True
        mkpromkp_ids = _spg('mkp.produto.marketplaces').search(cr, uid, args, context=context)
        context.pop('sig_force_company')
        brw_mkpromkp = _spg('mkp.produto.marketplaces').browse(cr, uid, mkpromkp_ids[0], context=context) # Embora se mkpromkp_ids, será sempre lista de 1
        path = '/products/images/%s'
        if brw_anuncio.mkpanu_produto_id.grade_usar:
            for brw_var in brw_anuncio.mkpanu_variacoes_ids:
                _id_product = brw_var.mkpanuv_id_no_mkp
                if '-' in _id_product:
                    _id_product = _id_product.split('-')[0]
                _excluir_imagens(_id_product)
                files = []
                nome_files = []
                controle = [time.time()]
                for brw_grade in brw_anuncio.mkpanu_produto_id.produto_grade_ids:
                    if brw_grade.id != brw_var.mkpanuv_grade_id.id:
                        continue
                    for brw_imagens in brw_mkpromkp.mkpromkp_imagens_ids:
                        if not brw_imagens.mkprmkimg_imagem_produto_id.estimg_grade_id:
                            _adicionar_imagens(brw_imagens.mkprmkimg_foto)
                            continue
                        if brw_imagens.mkprmkimg_imagem_produto_id.estimg_grade_id.id == brw_grade.id:
                            _adicionar_imagens(brw_imagens.mkprmkimg_foto)
                _path = path % _id_product
                resp = con_supercampo.supercampo_comunicar('post', _path, params={}, files=files)
                for _arq in nome_files:
                    os.remove(_arq)
        else:
            _id_product = brw_anuncio.mkpanu_codigo_anuncio
            if '-' in _id_product:
                _id_product = _id_product.split('-')[0]
            _excluir_imagens(_id_product)
            files = []
            nome_files = []
            controle = [time.time()]
            for brw_imagens in brw_mkpromkp.mkpromkp_imagens_ids:
                _adicionar_imagens(brw_imagens.mkprmkimg_foto)
            _path = path % _id_product
            for file in files:
                resp = con_supercampo.supercampo_comunicar('post', _path, params={}, files=[file])
            for _arq in nome_files:
                os.remove(_arq)
        return True

    def _mkpSupercampo_get_sku_produto(self, cr, uid, brw_anuncio, context=None):
        """
        Formata o sku de um produto
        :param cr:
        :param uid:
        :param brw_anuncio:
        :param context:
        :return: {sku_produto: ___, sku_grades :{'GR':_sku_grade, 'GR': _sku_grade}}
        """
        if not brw_anuncio.mkpanu_produto_id.grade_usar:
            _sku = '%s-UN' % brw_anuncio.mkpanu_produto_id.codigo
            return {'sku_produto': _sku, 'sku_grades': {}}
        grades = {}
        for brw_grade in brw_anuncio.mkpanu_produto_id.produto_grade_ids:
            _sku = brw_anuncio.mkpanu_produto_id.codigo
            _sku_grade = '%s-%s' % (brw_anuncio.mkpanu_produto_id.codigo, brw_grade.grade)
            grades.update({brw_grade.grade: _sku_grade})
        return {'sku_produto': _sku, 'sku_grades': grades}

    def mkpSupercampo_set_anuncio(self, cr, uid, brw_anuncio, context=None):
        if brw_anuncio.mkpanu_codigo_anuncio:
            _funcao = _('Alterar')
            _obj = _('Anuncio')
            _cod = brw_anuncio.mkpanu_codigo_anuncio
        else:
            _funcao = _('Criar')
            _obj = _('Item')
            _cod = brw_anuncio.mkpanu_produto_id.codigo
        self._logger.info(_('%s anuncio na Supercampo! %s: %s') % (_funcao, _obj, _cod))
        _spg = self.pool.get
        context = context and context.copy() or {}
        con_supercampo = Supercampo(cr, uid, brw_anuncio.mkpanu_conta_id.id)
        mkp_id = brw_anuncio.mkpanu_marketplace_id.id
        args = [('mkpromkp_produto_id', '=', brw_anuncio.mkpanu_produto_id.id),
                ('mkpromkp_marketplace_id', '=', mkp_id),
                ('company_id', '=', brw_anuncio.company_id.id)
                ]
        context['sig_force_company'] = True
        mkp_produto_mkp_ids = _spg('mkp.produto.marketplaces').search(cr, uid, args, context=context)
        context.pop('sig_force_company')
        if not mkp_produto_mkp_ids:
            return {'status': True}  # Não tem anuncio para atualizar
        brw_mkpromkp = _spg('mkp.produto.marketplaces').browse(cr, uid, mkp_produto_mkp_ids, context=context)[0]
        if not brw_mkpromkp.mkpromkp_categoria_id:
            return {'status': False, 'mensagem': _('Nao tem categoria cadastrada no produto para o Marketplace')}
        _categ_id = brw_mkpromkp.mkpromkp_categoria_id.mkpcat_codigo
        _name = brw_anuncio.mkpanu_title
        _descricao = brw_anuncio.mkpanu_descricao_texto
        _marca = ''
        for brw_atributo in brw_mkpromkp.mkpromkp_produto_id.estpro_atributo_ids:
            _valor_att = brw_atributo.estatp_atributo_valor
            if brw_atributo.estatp_atributo_id.name.lower() == 'marca':
                _marca = _valor_att
                break
        if not _marca:
            return {'status': False, 'mensagem': _('Nao tem marca cadastrada nos atributos')}
        ret_brand = self.mkpSupercampo_set_get_brand(cr, uid, brw_anuncio.mkpanu_conta_id.id, int(_categ_id), _marca,
                                                     context=context)
        if not ret_brand.get('status'):
            return ret_brand

        _ean = False
        _dados_sku = self._mkpSupercampo_get_sku_produto(cr, uid, brw_anuncio, context=context)
        _sku_produto = _dados_sku.get('sku_produto')
        for brw_grade in brw_anuncio.mkpanu_produto_id.produto_grade_ids:
            _sku_grade = _dados_sku.get('sku_grades').get(brw_grade.grade) or _dados_sku.get('sku_produto')
            vals = {}
            _cat_code = int(brw_mkpromkp.mkpromkp_categoria_id.mkpcat_codigo)
            _valor = brw_anuncio.mkpanu_valor_promocao or brw_anuncio.mkpanu_valor or brw_anuncio.mkpanu_valor_sugerido
            _ean = False
            for brw_cod_barra in brw_anuncio.mkpanu_produto_id.automacao_ids:
                if not brw_cod_barra.active:
                    continue
                if brw_cod_barra.grade_id.id != brw_grade.id:
                    continue
                if brw_cod_barra.autcba_tipo_barra == '13':
                    _ean = brw_cod_barra.codigo_barra[1:]
                    break

            if brw_anuncio.mkpanu_produto_id.grade_usar:
                vals['name'] = '%s - %s' % (brw_anuncio.mkpanu_title, brw_grade.descricao)
            else:
                vals['name'] = brw_anuncio.mkpanu_title
            vals['description'] = brw_anuncio.mkpanu_descricao_html
            vals['manufacturer'] = ret_brand.get('brands')
            vals['mfrPartCode'] = brw_grade.codigo_no_fabricante or _sku_grade
            vals['composition'] = 'KIT' if brw_anuncio.mkpanu_produto_id.kit_de_produtos else 'UNITARY'
            vals['type'] = 'PRODUCT'
            vals['barCode'] = _ean
            if brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_responsavel:
                _g = "do vendedor" if brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_responsavel == 'L' else "de fábrica"
                _tp = {'D': 'dias', 'M': 'meses', 'A': 'anos'}
                _gar = '%s Prazo:%s %s' % (_g,
                                           brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_prazo,
                                           _tp.get(brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia_prazo_tipo))
            else:
                _gar = brw_anuncio.mkpanu_produto_id.estpro_mkp_garantia
            vals['mfrWarranty'] = _gar
            vals['mainCategory'] = _categ_id
            # vals['secondaryCategory'] = 10000
            _peso_bruto = 0.3
            _peso_liquido = 0.3
            _altura = 7
            _largura = 10
            _comprimento = 10
            for brw_embalagem in brw_anuncio.mkpanu_produto_id.produto_embalagem_ids:  # pegar APENAS A PRIMEIRA
                _peso_bruto = brw_embalagem.peso_bruto
                _peso_liquido = brw_embalagem.peso_liquido
                _altura = brw_embalagem.altura
                _largura = brw_embalagem.largura
                _comprimento = brw_embalagem.profundidade
                break
            vals['width'] = _largura
            vals['height'] = _altura
            vals['depth'] = _comprimento
            vals['grossWeight'] = _peso_bruto
            vals['netWeight'] = _peso_liquido
            id_product = None
            if brw_anuncio.mkpanu_produto_id.grade_usar:
                for brw_var in brw_anuncio.mkpanu_variacoes_ids:
                    if brw_var.mkpanuv_grade_id == brw_grade.id:
                        id_product = brw_var.mkpanuv_anuncio_id
                        break
            else:
                id_product = brw_anuncio.mkpanu_codigo_anuncio
                if id_product and '-' in id_product:
                    id_product = id_product.split('-')[0]
            if not id_product:
                path = '/products/find'
                params = {
                    'brand': _marca,
                    'composition': 'KIT' if brw_anuncio.mkpanu_produto_id.kit_de_produtos else 'UNITARY',
                    'partCode': brw_grade.codigo_no_fabricante or _sku_grade,
                }
                resp = con_supercampo.supercampo_comunicar('get', path, params=params)
                if not resp.get('error'):
                    id_product = resp.get('response').get('id')

            path = '/products'
            if id_product:
                _metodo = 'put'
                vals['id'] = id_product
            else:
                _metodo = 'post'
            resp = con_supercampo.supercampo_comunicar(_metodo, path, body=vals)
            if resp.get('error'):
                if resp.get('message'):
                    ret = {'status': False, 'mensagem': resp.get('message'), 'produto': {}}
                else:
                    ret = {'status': False, 'mensagem': resp.get('errors'), 'produto': {}}
                return ret
            id_product = resp.get('response').get('id')
            self.pool.get('mkp.anuncios').write(cr, uid, brw_anuncio.id, {'mkpanu_codigo_anuncio': id_product}, context=context)
            if brw_anuncio.mkpanu_produto_id.grade_usar:
                args = [
                    ('mkpanuv_anuncio_id', '=', brw_anuncio.id),
                    ('mkpanuv_grade_id', '=', brw_grade.id)
                ]
                var_ids = self.pool.get('mkp.anuncios.var').search(cr, uid, args, context=context)
                vals = {
                    'mkpanuv_id_no_mkp': id_product,
                    'mkpanuv_anuncio_id': brw_anuncio.id,
                    'mkpanuv_grade_id': brw_grade.id
                }
                if var_ids:
                    self.pool.get('mkp.anuncios.var').write(cr, uid, var_ids, vals, context=context)
                else:
                    self.pool.get('mkp.anuncios.var').create(cr, uid, vals, context=context)
        brw_anuncio = self.pool.get('mkp.anuncios').browse(cr, uid, brw_anuncio.id, context=context)
        self.mkpSupercampo_atualizar_saldo_preco(cr, uid, brw_anuncio.id, context=context)
        self._mkpSupercampo_verificar_cadastrar_imagem(cr, uid, brw_anuncio, context=context)
        return {'status': True, 'mensagem': ''}


    # # Todo: Verificar
    # def mkpSupercampo_get_anuncio(self, cr, uid, conta_id, item_code, context=None):
    #     self._logger.info(_('Buscando anuncios na Supercampo!'))
    #     con_supercampo = Supercampo(cr, uid, conta_id)
    #     path = '/api/v2/product/get_item_base_info'
    #     body = {
    #         'item_id_list': [int(item_code)],
    #         'need_tax_info': False,
    #         'need_complaint_policy': False,
    #     }
    #     resp = con_supercampo.supercampo_comunicar('get', path, body)
    #     if resp.get('error'):
    #         ret = {'status': False, 'mensagem': resp.get('message'), 'item': []}
    #     path = '/api/v2/product/get_item_extra_info'
    #     body = {
    #         'item_id_list': [int(item_code)],
    #     }
    #     resp_extra = con_supercampo.supercampo_comunicar('get', path, body)
    #     if resp_extra.get('error'):
    #         ret = {'status': False, 'mensagem': resp_extra.get('message'), 'item': []}
    #     _item = resp.get('response').get('item_list')[0]
    #     if resp_extra.get('response') and resp_extra.get('response').get('item_list'):
    #         _item.update(resp_extra.get('response').get('item_list')[0])
    #     else:
    #         _item.update({'sale': 0})
    #     ret = {'status': True, 'mensagem': '', 'item': _item}
    #     return ret
    #
    # # Todo: Verificar
    # def mkpSupercampo_get_etiqueta(self, cr, uid, order, conta_id, context):
    #     self._logger.info(_('Buscando etiqueta na Supercampo!'))
    #     con_supercampo = Supercampo(cr, uid, conta_id)
    #     """Iniciando a logistica"""
    #     path = '/api/v2/logistics/get_shipping_parameter'
    #     body = {
    #         'order_sn': order,
    #     }
    #     resp_par = con_supercampo.supercampo_comunicar('get', path, body)
    #     if resp_par.get('error'):
    #         ret = {'status': False, 'mensagem': resp_par.get('message'), 'etiqueta': []}
    #         return ret
    #
    #     path = '/api/v2/logistics/ship_order'
    #     body = {
    #         'order_sn': order,
    #         "dropoff": {
    #             "tracking_number": "",
    #             "branch_id": 0,
    #             "sender_real_name": ""
    #         }
    #     }
    #     resp = con_supercampo.supercampo_comunicar('post', path, body)
    #     if resp.get('error'):
    #         ret = {'status': False, 'mensagem': resp.get('message'), 'etiqueta': []}
    #         return ret
    #
    #     path = '/api/v2/logistics/get_tracking_number'
    #     body = {
    #         'order_sn': order,
    #         'response_optional_fields': 'plp_number,first_mile_tracking_number,last_mile_tracking_number',
    #     }
    #     resp = con_supercampo.supercampo_comunicar('get', path, body)
    #     if resp.get('error'):
    #         ret = {'status': False, 'mensagem': resp.get('message'), 'etiqueta': []}
    #         return ret
    #     _tracking_no = resp.get('response').get('tracking_number')
    #
    #     path = '/api/v2/logistics/get_shipping_document_parameter'
    #     body = {
    #         'order_list': [order],
    #     }
    #     resp = con_supercampo.supercampo_comunicar('post', path, body)
    #     if resp.get('error'):
    #         ret = {'status': False, 'mensagem': resp.get('message'), 'etiqueta': []}
    #         return ret
    #
    #     path = '/api/v2/logistics/create_shipping_document'
    #     body = {
    #         'order_list': [{
    #             'order_sn': order,
    #             # 'package_number': ''
    #         }],
    #     }
    #     resp = con_supercampo.supercampo_comunicar('post', path, body)
    #     if resp.get('error'):
    #         ret = {'status': False, 'mensagem': resp.get('message'), 'etiqueta': []}
    #         return ret
    #
    #     path = '/api/v2/logistics/get_shipping_document_result'
    #     body = {
    #         'order_list': [{
    #             'order_sn': order,
    #             # 'package_number': ''
    #         }],
    #     }
    #     resp = con_supercampo.supercampo_comunicar('post', path, body)
    #     if resp.get('error'):
    #         ret = {'status': False, 'mensagem': resp.get('message'), 'etiqueta': []}
    #         return ret
    #     _ship_document = resp.get('response').get('order_list')[0].get('shipping_document_type')
    #
    #     path = '/api/v2/logistics/download_shipping_document'
    #     body = {
    #         'shipping_document_type': _ship_document,
    #         'order_list': [{
    #             'order_sn': order,
    #             # 'package_number': ''
    #         }],
    #     }
    #     resp = con_supercampo.supercampo_comunicar('post', path, body)
    #     if resp.get('error'):
    #         ret = {'status': False, 'mensagem': resp.get('message'), 'etiqueta': []}
    #         return ret
    #     arq = resp.get('response').get('airway_bills')
    #     # i = 0
    #     # while True:
    #     #     i += 1
    #     #     path = '/api/v1/logistics/init'
    #     #     body = {
    #     #         "ordersn": order,
    #     #         'dropoff': {},
    #     #     }
    #     #     resp = con_supercampo.supercampo_comunicar(path, body)
    #     #     if resp.get('error'):
    #     #         ret = {'status': False, 'mensagem': resp.get('message'), 'etiqueta': []}
    #     #         return ret
    #     #     if resp.get('tracking_number'):
    #     #         _tracking_no = resp.get('tracking_number')
    #     #     else:
    #     #         if i < 10:
    #     #             self._logger.info(_('Tentando novamente!'))
    #     #             time.sleep(1)
    #     #             continue
    #     #     path = '/api/v1/logistics/airway_bill/get_mass'
    #     #     body = {
    #     #         'ordersn_list': [order],
    #     #     }
    #     #     resp = con_supercampo.supercampo_comunicar(path, body)
    #     #     if resp.get('result').get('errors'):
    #     #         ret = {'status': False, 'mensagem': _('Nao consegui pegar etiqueta de postagem'), 'etiqueta': []}
    #     #         return ret
    #     #     else:
    #     #         break
    #     # arq = resp.get('result').get('airway_bills')
    #     if isinstance(arq, list):
    #         arq = arq[0]
    #     _url = arq.get('airway_bill')
    #     dados = requests.get(_url)
    #     data = datetime.datetime.now()
    #     path_zip = '/tmp/etiqueta-supercampo-%s.zip' % data
    #     f = open(path_zip, 'w')
    #     f.write(dados.content)
    #     f.close()
    #     path = '/tmp/etiqueta-%s' % data
    #     try:
    #         fantasy_zip = zipfile.ZipFile(path_zip)
    #         fantasy_zip.extractall(path)
    #         fantasy_zip.close()
    #     except Exception as e:
    #         try:
    #             f = open(path_zip, 'r')
    #             _etiq = json.loads(f.read())
    #             f.close()
    #             if _etiq.get('error') == 'labels_generation_locked':
    #                 ret = {'status': False, 'mensagem': _('labels_generation_locked'), 'etiqueta': []}
    #                 return ret
    #             elif _etiq.get('error') == 'not_found':
    #                 ret = {'status': False, 'mensagem': _('A etiqueta ainda nao foi liberada pelo Supercampo.-not_found!'), 'etiqueta': []}
    #                 return ret
    #             else:
    #                 ret = {'status': False, 'mensagem': _('Erro na leitura da etiqueta\n%s') % _etiq.get('message'), 'etiqueta': []}
    #                 return ret
    #         except Exception as e:
    #             if e.message == 'labels_generation_locked':
    #                 ret = {'status': False, 'mensagem': _('A etiqueta ainda nao foi liberada pelo Supercampo.!'), 'etiqueta': []}
    #                 return ret
    #             ret = {'status': False, 'mensagem': (_('Nao consegui extrair a etiqueta:\n\n%s') % e), 'etiqueta': []}
    #             return ret
    #     f_in = open('%s/shipping_label.txt' % path, 'r')
    #     fi = f_in.readlines()
    #     f_in.close()
    #     out_path = '/tmp/etiqueta-%s.txt' % str(data).replace(' ', '_')
    #     f = open(out_path, 'w')
    #     f.writelines(fi)
    #     f.close()
    #     f_in = open('%s/content_declaration_file.pdf' % path, 'r')
    #     fi = f_in.readlines()
    #     f_in.close()
    #     outC_path = '/tmp/Controle-%s.pdf' % str(data).replace(' ', '_').replace(':', '_')
    #     f = open(outC_path, 'w')
    #     f.writelines(fi)
    #     f.close()
    #     ret = {'status': True, 'mensagem': '', 'etiqueta': [out_path, outC_path, _tracking_no]}
    #     return ret
    #
    def mkpSupercampo_pesquisar_orders(self, cr, uid, conta_id, context=None):
        context = context and context.copy() or {}
        _spg = self.pool.get
        con_supercampo = Supercampo(cr, uid, conta_id)
        path = '/partnerOrders'
        _offset = 0
        _prazo = -1
        if context.get('prazo'):
            _prazo = context.get('prazo')
        _dataIni = datas.getDataDeHoje()
        _dataIni = datas.calcVencimento(_dataIni, _prazo)
        _dataIni = datas.getDataNoFormato(_dataIni, 'I', '-')
        params = {
            'limit': 25,
            'offset': 0,
            'DateIniUpdate': '%sT00:00:00Z' % _dataIni
        }
        while True:
            params.update({'offset': _offset})
            resp = con_supercampo.supercampo_comunicar('get', path, params=params)
            _offset += 25
            _achei = False
            for order in resp.get('response'):
                _achei = True
                _order_id = order.get('id')
                _resourse = '/orders/%s' % _order_id
                args = [
                    ('mkpnot_conta_id', '=', conta_id),
                    ('mkpnot_resource', '=', _resourse)
                ]
                not_ids = _spg('mkp.notificacoes').search(cr, uid, args, context=context)
                if not_ids:
                    vals = {'state': 'R'}
                    res = _spg('mkp.notificacoes').write(cr, uid, not_ids[0], vals, context=context)
                else:
                    vals = {
                        'mkpnot_conta_id': conta_id,
                        'mkpnot_resource': _resourse,
                        'mkpnot_topic': 'orders',
                        'mkpnot_attempts': 1,
                        'mkpnot_loja': con_supercampo.shop_id,
                        'state': 'R',
                    }
                    res = _spg('mkp.notificacoes').create(cr, uid, vals, context=context)
            if not _achei:
                break
        return True

    def mkpSupercampo_set_order_faturado(self, cr, uid, _order, _conta_id, brw_nf, context=None):
        context = context and context.copy() or {}
        con_supercampo = Supercampo(cr, uid, _conta_id)
        recurso = '/partnerOrders/%s' % _order
        try:
            _pedido = brw_nf.fisnfc_pedido_ids[0].numero_pedido
        except:
            _pedido = ''
        _data_nf = brw_nf.data_emissao[:10]
        data = {
            "status": 'READY',
            'supplierOrderId': _pedido,
            'supplierInvoiceNumber': brw_nf.numero_nf,
            'supplierInvoiceSerie': brw_nf.serie_nf,
            'supplierInvoiceKey': brw_nf.nfe_chave_acesso,
            'supplierInvoiceDate': _data_nf,

        }
        resp = con_supercampo.supercampo_comunicar('put', recurso, data=data)
        if resp.get('error'):
            return {
                'status': False,
                'mensagem': resp.get('message')
            }
        if resp.get('status') != 'READY':
            return {
                'status': False,
                'mensagem': _('status nao modificado')
            }

        ret = {'status': True, 'mensagem': '', 'order': resp.get('response')}
        return ret

    def mkpSupercampo_postar_pedido(self, cr, uid, conta_id, order, etiqueta, context=None):
        context = context and context.copy() or {}
        con_supercampo = Supercampo(cr, uid, conta_id)
        recurso = '/partnerOrders/%s' % order
        data = {
            "status": 'SHIPPED',
            'trackingCode': etiqueta,
            'urlTrackingCode': 'www.correios.com.br',
            'ownCarrier': 'Correios',
        }
        resp = con_supercampo.supercampo_comunicar('put', recurso, body=data)
        if resp.get('error'):
            return {
                'status': False,
                'mensagem': resp.get('message')
            }
        ret = {'status': True, 'mensagem': '', 'order': resp.get('response')}
        return ret
