# -*- encoding: utf-8 -*-

import json
from logging import getLogger
import requests
from openerp import pooler
from openerp.tools.translate import _
import openerp.addons.web.http as http
from ..marketplace.control.utils import configuracao
from SigUtils.geralogs import geraLogs
from SigUtils.sigerp import db_sig
from openerp.tools import config

_logger = getLogger("Supercampo")
_senha = 'mkp_remoto_77813'


def _remover_acentuacao(text, cod='utf-8'):
    """
    Funcao Wrapper para remover acentuacao
    :param text:texto onde sera feita a remocao da acentuacao
    :param cod:Tipo de codificacao
    return:string
    """

    from unicodedata import normalize, category
    try:
        unicode_string = str(text)
    except UnicodeEncodeError:
        return normalize('NFKD', text).encode('ASCII', 'ignore')
    return unicode(filter(lambda c: category(c) != 'Mn',
                          normalize('NFKD', unicode_string.decode(cod))))


class Supercampo(object):
    def logged_client(f):
        """Decorator for User Credentials checking."""

        def inner(self, *args, **kargs):
            if ((self.client_id is None) or (self.client_secret is None)):
                raise Exception(_("Nao posso acessar o Supercampo, parametros do Supercampo nao informados!"))
            return f(self, *args, **kargs)

        return inner

    def __init__(self, cr=False, uid=False, conta_id=False, producao=True):
        self.API_ROOT_URL_TESTE = 'https://ws.sandbox.autorei.net'  # Sandbox
        self.API_ROOT_URL = 'https://partner.supercampomobile.com'  # Producao
        self.SDK_VERSION = 'SIG.1.01'
        self.AUTH_URL = '/oauth/token'
        self.cr = cr
        self.uid = uid
        self.shop_id = ''
        self.partner_id = ''
        self.partner_key = ''
        self.redirect_url = ''
        self.access_token = ''
        self.refresh_token = ''
        self.code = ''
        self.habilitar_log = False
        self.conta_id = ''
        if cr:
            _poolget = pooler.get_pool(cr.dbname).get
            mkp_ids = _poolget('mkp.marketplaces').search(cr, uid, [('mkpmkp_codigo', '=', 'SupCam')])
            if mkp_ids:
                mkp_ids = mkp_ids[0]
                dados_marketplace = _poolget('mkp.marketplaces').read(cr, uid, mkp_ids, [])
                if not conta_id:
                    conta_id = _poolget('mkp.contas').search(cr, uid, [('mkpcta_marketplace_id', '=', mkp_ids)])
                    if conta_id:
                        conta_id = conta_id[0]
                if conta_id:
                    self.conta_id = conta_id
                    dados_conta = _poolget('mkp.contas').read(cr, uid, conta_id, [])
                    self.deposito_id = dados_conta.get('mkpcta_supercampo_deposito_id')
                    self.conta = str(dados_conta.get('mkpcta_supercampo_conta'))
                    self.senha = str(dados_conta.get('mkpcta_supercampo_senha'))
                    self.redirect_url = dados_conta.get('mkpcta_supercampo_redirect_url')
                    self.code = dados_conta.get('mkpcta_supercampo_code')
                    self.habilitar_log = dados_marketplace.get('mkpmkp_habilita_log')
                    self.access_token = dados_conta.get('mkpcta_supercampo_token')
                    self.refresh_token = dados_conta.get('mkpcta_supercampo_refresh_token')
                    if not dados_conta.get('mkpcta_producao'):
                        self.API_ROOT_URL = self.API_ROOT_URL_TESTE
        else:
            if not producao:
                self.API_ROOT_URL = self.API_ROOT_URL_TESTE

    def _get_arq_log(self):
        _arq_log = 'mkp_supercampo_' + self.cr.dbname
        return _arq_log

    def _gerar_logs(self, mens):
        _diretorio = config.get('logfile')
        if _diretorio:
            _lista = _diretorio.split('/')
            _lista.pop(len(_lista) - 1)
            _diretorio = '/'.join(_lista)
        else:
            _diretorio = '/var/log/openerp'
        _arq_log = self._get_arq_log()
        try:
            geraLogs(_arq_log, mens, 'S', _diretorio)
        except:
            try:
                geraLogs(_arq_log, mens.encode('ASCII', 'ignore'), 'S', _diretorio)
            except:
                geraLogs(_arq_log, 'Nao consegui registrar o log', 'S', _diretorio)
        return True


    # AUTH METHODS
    def auth_url(self):
        url = self.API_ROOT_URL + self.AUTH_URL
        return url

    def supercampo_comunicar(self, metodo, path, body=None, data=None, params=None, headers=None, files=None):
        _spg = pooler.get_pool
        _metodo = metodo.upper()

        def comunicar():
            _body = body
            if self.habilitar_log:
                _mens = 'Supercampo.%s -> PATH:%s-> HEADERS:%s' % (_metodo, url, _headers)
                if _params:
                    _mens += ' -> PARAMS: %s' % _params
                if data:
                    _mens += ' -> DATA:%s' % data
                if _body:
                    _mens += ' -> BODY:%s' % _body
                if files:
                    _mens += ' -> FILES:%s' % files
                self._gerar_logs(_mens)
            if _metodo == 'POST' and 'manufacturer' in url:
                response = requests.request(_metodo, url, files=[('','')], data=data, headers=_headers)
            elif body:
                response = requests.request(_metodo, url, json=_body, params=_params, headers=_headers)
            else:
                if files:
                    response = requests.request(_metodo, url, data=data, params=_params, headers=_headers, files=files)
                else:
                    response = requests.request(_metodo, url, data=data, params=_params, headers=_headers, files=[('','')])
            if self.habilitar_log:
                self._gerar_logs('Status:%s Resposta: %s' % (response.status_code, response.text))
            return response

        ret = {'error': True, 'message': 'Erro nao identificado', 'response': ''}
        while True:
            url = self.API_ROOT_URL + path
            _params = {
            }
            _headers = {
                # 'Content-Type': 'application/json',
                'Authorization': 'Bearer %s' % self.access_token,
            }
            if path == self.AUTH_URL:
                _headers.pop('Authorization')
            # elif path == '/manufacturer':
            #     _headers.pop('Content-Type')
            # elif '/partnerOrders' in path:
            #     _headers.pop('Content-Type')
            # elif '/products/images' in path:
            #     _headers.pop('Content-Type')
            if params:
                _params.update(params)
            if headers:
                _headers.update(headers)
            resp = comunicar()
            if resp.status_code == 200:
                ret = {'error': False, 'message': '', 'response': json.loads(resp.content)}
                break
            if resp.status_code == 202:
                if resp.content:
                    ret = {'error': False, 'message': '', 'response': json.loads(resp.content)}
                else:
                    ret = {'error': False, 'message': '', 'response': ''}
                break

                # ret = json.loads(resp.content)
            elif resp.status_code == 401 and \
                 json.loads(resp.content).get('error') == 'invalid_token':
                 # json.loads(resp.content).get('error') == 'invalid_token' and \
                 # u'Invalid access token:' in json.loads(resp.content).get('error_description'):
                    resp = self.authorize()
                    if not resp:
                        ret = {'error': 'token_invalido', 'message': 'Refresh Token invalido!'}
                        break
                    continue
            elif resp.status_code > 299:
                ret = {'error': resp.status_code, 'message': resp.text}
                break
        return ret

    def authorize(self):
        con_supercampo = Supercampo(self.cr, self.uid, self.conta_id)
        path = con_supercampo.AUTH_URL
        body = {
            'scope': 'trust',
            'grant_type': 'password',
            'username': self.conta,
            'password': self.senha,
        }
        headers = {
            'Content-Type': 'application/x-www-form-urlencoded',
            'Authorization': 'Basic YXBpLXdzOnBhc3N3b3JkLW1hc3Rlcg==',
        }
        res = con_supercampo.supercampo_comunicar('post', path, data=body, headers=headers)
        if not res.get('error'):
            self.access_token = res.get('response').get('access_token')
            self.refresh_token = res.get('response').get('refresh_token')
            vals = {
                'mkpcta_supercampo_token': self.access_token,
                'mkpcta_supercampo_refresh_token': self.refresh_token
            }
            _poolget = pooler.get_pool(self.cr.dbname).get
            _poolget('mkp.contas').write(self.cr, self.uid, self.conta_id, vals)
            self.cr.commit()
        return True

class sc(http.Controller):
    _cp_path = '/mkp_supercampo'

    def teste(self, req, s_action=None, **kw):
        _logger.info('=============================== teste %s' % req)
        # return 'testado IP:%s' % req.httprequest.headers.environ.get('REMOTE_ADDR')
        # sys.exit(1)
        return 'Ok'

    @http.httprequest
    def notifications(self, req, s_action=None, **kw):
        _logger.info('--------------------- notificacoes: %s ' % str(req.httprequest.data))
        dados_post = json.loads(req.httprequest.data)
        if dados_post.get('code') in (0, 1):  # Somente teste de conexao
            _logger.info('Notificacao processada!-1')
            return 'Ok'
        _code = dados_post.get('code')
        _shop_id = dados_post.get('shop_id')
        if _shop_id:
            cfg_supercampo = configuracao('marketplace_supercampo', str(_shop_id))
            cfg_supercampo.lerConfiguracao()
            _url = req.httprequest.base_url
            _authorization = req.httprequest.environ.get('HTTP_AUTHORIZATION')
            _partner_key = cfg_supercampo.partner_key
            # res = self.verify_push_msg(_url, req.httprequest.data, _partner_key, _authorization)
            _base = str(cfg_supercampo.base)
            cfg = configuracao('marketplace', _base)
            cfg.lerConfiguracao()
            _db_user = cfg.db_user
            _db_password = cfg.db_password
            _db_host = cfg.db_host
            _db_port = cfg.db_port
            arg_db = {}
            if _db_host:
                arg_db.update({'host': _db_host})
            else:
                arg_db.update({'host': 'localhost'})
            if _db_port:
                arg_db.update({'port': _db_port or '5431'})
            if _db_user:
                arg_db.update({'user': _db_user})
            if _db_password:
                arg_db.update({'pwd': _db_password})
            _db = db_sig(_base, **arg_db)
            _fields = ['id']
            _where = [('login', '=', 'mkp_remoto')]
            dados_users = _db.dbsSelect('res_users', _fields, _where)
            _uid = False
            if dados_users:
                _uid = dados_users[0].get('id')
                if _uid:
                    if _code == 3:
                        _topic = 'orders'
                        _resource = '/%s/%s' % (_topic, dados_post.get('data').get('ordersn'))
                    else:
                        _db.conexao.close()
                        return 'Ok'
                    _db.uid = _uid
                    _where = [
                        ('mkpnot_resource', '=', _resource),
                        ('mkpnot_loja', '=', _shop_id)
                    ]
                    dados_not = _db.dbsSelect('mkp_notificacoes', ['id'], _where)
                    _not_id = False
                    if dados_not:
                        _not_id = dados_not[0].get('id')
                    ## Gravar as notificacoes
                    if _not_id:
                        vals = {
                            'mkpnot_attempts': 1,
                            'state': 'R',
                        }
                        where = [('id', '=', _not_id)]
                        x = _db.dbsUpdate('mkp_notificacoes', vals, where)
                        if x:
                            _db.conexao.commit()
                        else:
                            _db.conexao.roolback()
                    else:
                        vals = {
                            'mkpnot_conta_id': cfg_supercampo.conta_id,
                            'mkpnot_resource': _resource,
                            'mkpnot_loja': _shop_id,
                            'mkpnot_topic': _topic,
                            'mkpnot_attempts': 1,
                            'state': 'R',
                        }
                        x = _db.dbsInsert('mkp_notificacoes', vals)
                        if not x:
                            _db.conexao.roolback()
                        else:
                            _db.conexao.commit()
                    _logger.info('Notificacao processada!-2')
                    _db.conexao.close()
                    return 'OK'  # nunca retorne booleano, vai dar erro de https
            _db.conexao.close()
        _logger.info('Nao consegui pegar o shop_id no Mkp Supercampo!')
        return 'Ok'  # nunca retorne booleano, vai dar erro de https
