# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from SigUtils import datas
from datetime import datetime
import logging
_logger = logging.getLogger(__name__)


class mkp_notificacoes(osv.Model):
    _inherit = "mkp.notificacoes"

    def _mkpnot_get_orders_supcam(self, cr, uid, dados_notificacao, context=None):
        _order = dados_notificacao.get('mkpnot_resource').split('/')[2]
        _conta_id = dados_notificacao.get('mkpnot_conta_id')
        _dados_conta = self.pool.get('mkp.contas').read(cr, uid, _conta_id, [], context=context)
        _obj_pedido_capa = self.pool.get('estoquepedidos.pedido.capa')
        resp = self.pool.get('mkp.supercampo').mkpSupercampo_get_orders(cr, uid, _order, _conta_id, context=context)
        if resp.get('status'):
            dados = resp.get('orders')
            try:  # Se não conseguir importar o pedido, ignore e continue o processo das notificacoes
                _ped_id = self.pool.get('mkp.utils').mkputl_importar_um_pedido_supercampo(cr, uid, dados, _conta_id,
                                                                                          context=context)
                if not _ped_id:
                    self._logger.info('Pedido nao importado!')
                    return False
            except Exception as e:
                self._logger.info('Erro no try! Erro: %s' % e)
                return False
        else:
            self._logger.info('Pedido nao importado!')
            return False
        return True


    def _mkpnot_processar_notificacao(self, cr, uid, codigo_mkp, notificacao_tipo, dados_notificacao, context=None):
        """
        Metodo qeue sobrescreve o original para tratamento especializado
        :param cr:
        :param uid:
        :param codigo_mkp: Codigo do Marketplace
        :param dados_notificacao: Dados resultado do read de um registro do marketplace, com todos os atributos
        :param context:
        :return:
        """
        context = context and context.copy() or {}
        res = super(mkp_notificacoes, self)._mkpnot_processar_notificacao(cr, uid, codigo_mkp, notificacao_tipo,
                                                                          dados_notificacao, context=context)
        if codigo_mkp == 'SupCam':
            # if notificacao_tipo == 'items':
            #     res = self._mkpnot_get_itens_supcam(cr, uid, dados_notificacao, context=context)
            # elif notificacao_tipo == 'messages':
            #     res = self._mkpnot_get_messages_supcam(cr, uid, dados_notificacao, context=context)
            # elif notificacao_tipo == 'questions':
            #     res = self._mkpnot_get_questions_supcam(cr, uid, dados_notificacao, context=context)
            if notificacao_tipo == 'orders':
                res = self._mkpnot_get_orders_supcam(cr, uid, dados_notificacao, context=context)
            # elif notificacao_tipo == 'collections':
            #     _payment = dados_notificacao.get('mkpnot_resource').split('/')[2]
            #     _conta_id = dados_notificacao.get('mkpnot_conta_id')
            #     res = self.pool.get('mkpml.pagamentos').mkpmlpag_get_payments(cr, uid, _payment, _conta_id, context=context)
            # elif notificacao_tipo == 'shipments':
            #     res = self._mkpnot_get_supcamipments_supcam(cr, uid, dados_notificacao, context=context)
            # elif notificacao_tipo == 'payments':
            #     res = True
            # elif notificacao_tipo == 'claims':
            #     res = True
        return res


