# -*- encoding: utf-8 -*-

import openerp.addons.web.http as http
from ..marketplace.control.utils import configuracao
import xmlrpclib, socket
from logging import getLogger
from tray import Tray
from SigUtils.sigerp import db_sig


template_ok = """
<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8">
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>
    <form name="autorizar" action="" method="post">
        <p>Autorizar o aplicativo SigERP</p>
        <br>
        <a href="%s/auth.php?response_type=code&consumer_key=%s&callback=%s"> Clique aqui para autorizar! </a> 
    </form>
</body>
</html>
"""
template_autorizado = """
<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8">
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<title>Retorno de Autorização do SigERP</title>
</head>
<body>
<BR> 
<br>AUTORIZADO!<BR>
<BR>
Access_token: %s<br>
Refresh_token: %s<br>
Code: %s
</body>
</html>
"""
#        <a href="%s/auth.php?response_type=code&consumer_key=%s&callback=%s"> Clique aqui para autorizar! </a>

_logger = getLogger("Tray")

_senha = 'mkp_remoto_77813'

tray_conn = Tray()


class sc(http.Controller):
    _cp_path = '/mkp_tray'


    @http.httprequest
    def authorize(self, req, s_action=None, **kw):
        _logger.info('=== mkp_tray/authorize === %s' % str(req.params))
        template = "<html><header>Retorno da Tray</header><body>Nao consegui autorizar!<br>%s</body></html>" % str(req.params)
        tray_conn.adm_user = req.params.get('adm_user')
        tray_conn.store = req.params.get('store')
        if not tray_conn.store:
            _logger.info('=== mkp_tray/authorize === Nao consegui autorizar, sem loja definida(store)!')
            return template
        url = req.params.get('url')
        tray_conn.API_ROOT_URL = url + '/web_api'
        cfg = configuracao('marketplace_tray', tray_conn.store)
        cfg.lerConfiguracao()
        _server = str(cfg.server)
        _base = str(cfg.base)
        if not cfg.autorizado:
            _logger.info('=== mkp_tray/authorize === Nao consegui autorizar, sem parametro "autorizado" configurado!')
            return template
        tray_conn.redirect_url = str(cfg.autorizado)
        if _server:
            sock_common = xmlrpclib.ServerProxy('%s/xmlrpc/common' % _server)
            socket.setdefaulttimeout(15)
            uid = sock_common.login(_base, 'mkp_remoto', _senha)
            sock = xmlrpclib.ServerProxy('%s/xmlrpc/object' % _server)
            for _conta_id in sock.execute(_base, uid, _senha, 'mkp.contas', 'search',
                                    [('mkpcta_tr_id_loja', '=', tray_conn.store)]):
                dados_conta = sock.execute(_base, uid, _senha, 'mkp.contas', 'read', _conta_id, [])
                _mkp_id = dados_conta.get('mkpcta_marketplace_id')[0]
                dados_mkp = sock.execute(_base, uid, _senha, 'mkp.marketplaces', 'read', _mkp_id, [])
                tray_conn.consumer_key = dados_mkp.get('mkpmkp_tr_consumer_key')
                template = template_ok % (url, tray_conn.consumer_key, tray_conn.redirect_url)
                return template
        else:
            _logger.info('=== mkp_tray/authorize === Nao consegui autorizar, sem servidor definido!')



    @http.httprequest
    def autorizado(self, req, s_action=None, **kw):
        _logger.info('=== mkp_tray/authorizado === %s' % str(req.params))
        _loja = req.params.get('store')
        cfg = configuracao('marketplace_tray', _loja)
        cfg.lerConfiguracao()
        _server = str(cfg.server)
        _base = str(cfg.base)

        if _server:
            sock_common = xmlrpclib.ServerProxy('%s/xmlrpc/common' % _server)
            socket.setdefaulttimeout(15)
            uid = sock_common.login(_base, 'mkp_remoto', _senha)
            sock = xmlrpclib.ServerProxy('%s/xmlrpc/object' % _server)
            for _conta_id in sock.execute(_base, uid, _senha, 'mkp.contas', 'search',
                                    [('mkpcta_tr_id_loja', '=', _loja)]):
                dados_conta = sock.execute(_base, uid, _senha, 'mkp.contas', 'read', _conta_id, [])
                _mkp_id = dados_conta.get('mkpcta_marketplace_id')[0]
                dados_mkp = sock.execute(_base, uid, _senha, 'mkp.marketplaces', 'read', _mkp_id, [])
                tray_conn.API_ROOT_URL = dados_mkp.get('mkpmkp_api').strip()
                tray_conn.consumer_key = dados_mkp.get('mkpmkp_tr_consumer_key')
                tray_conn.code = str(req.params.get('code'))
                tray_conn.consumer_secret =  dados_mkp.get('mkpmkp_tr_consumer_secret')
                res = tray_conn.get_token()
                if res:
                    vals = {
                        'mkpcta_tr_code': req.params.get('code'),
                        'mkpcta_tr_access_token': tray_conn.access_token,
                        'mkpcta_tr_refresh_token': tray_conn.refresh_token
                    }
                else:
                    _logger.info('=== mkp_tray/authorizado === Nao consegui pegar o token')
                    return 'ok'
                sock.execute(_base, uid, _senha, 'mkp.contas', 'write', [_conta_id], vals)
                template = template_autorizado % (str(tray_conn.access_token), str(tray_conn.refresh_token), str(req.params.get('code')))
                return template
        return 'ok'

    @http.httprequest
    def notifications(self, req, s_action=None, **kw):
        _logger.info('--------------------- Tray notificacoes: %s action:%s kw: %s ' % (str(req.httprequest.data), s_action, kw))
        _seller_id = kw.get('seller_id', False)
        _scope = kw.get('scope_name')
        if _scope == 'order':
            _scope = 'orders'
        _act = kw.get('act')
        _scope_id = kw.get('scope_id')
        if _seller_id:
            cfg = configuracao('marketplace_tray', _seller_id)
            cfg.lerConfiguracao()
            # tray_conn.client_id = _seller_id
            # tray_conn.client_secret = cfg.secreto
            # tray_conn.conta_id = cfg.conta_id
            _server = str(cfg.server)
            if not _server:
                _logger.info('Seller_id %s nao cadastrado!' % str(_seller_id))
                return 'Nao'  # nunca retorne booleano, vai dar erro de https
            _base = str(cfg.base)
            _conta_id = str(cfg.conta_id)
            cfg = configuracao('marketplace', _base)
            cfg.lerConfiguracao()
            _db_user = cfg.db_user
            _db_password = cfg.db_password
            _db_host = cfg.db_host
            _db_port = cfg.db_port
            arg_db = {}
            if _db_host:
                arg_db.update({'host': _db_host})
            else:
                arg_db.update({'host': 'localhost'})
            if _db_port:
                arg_db.update({'port': _db_port or '5431'})
            if _db_user:
                arg_db.update({'user': _db_user})
            if _db_password:
                arg_db.update({'pwd': _db_password})
            _db = db_sig(_base, **arg_db)
            _fields = ['id']
            _where = [('login', '=', 'mkp_remoto')]
            dados_users = _db.dbsSelect('res_users', _fields, _where)
            _uid = False
            if dados_users:
                _uid = dados_users[0].get('id')
                if _uid:
                    _db.uid = _uid
                    _where = [('mkpnot_resource', '=', '/%s/%s' % (_scope, _scope_id)),
                            ('mkpnot_application', '=', _seller_id),
                            ]
                    dados_not = _db.dbsSelect('mkp_notificacoes', ['id'], _where)
                    _not_id = False
                    if dados_not:
                        _not_id = dados_not[0].get('id')
                    ## Gravar as notificacoes
                    if _not_id:
                        vals = {
                            'state': 'R',
                        }
                        where = [('id', '=', _not_id)]
                        x = _db.dbsUpdate('mkp_notificacoes', vals, where)
                        if x:
                            _db.conexao.commit()
                        else:
                            _db.conexao.roolback()
                    else:
                        vals = {
                            'mkpnot_conta_id': _conta_id,
                            'mkpnot_application': _seller_id,
                            'mkpnot_resource': '/%s/%s' % (_scope, _scope_id) or False,
                            'mkpnot_topic': _scope or False,
                            'mkpnot_attempts': '1',
                        }
                        x = _db.dbsInsert('mkp_notificacoes', vals)
                        if not x:
                            _db.conexao.roolback()
                        else:
                            _db.conexao.commit()
                    _db.conexao.close()
                    return 'OK'  # nunca retorne booleano, vai dar erro de https
            _db.conexao.close()
        _logger.info('Nao consegui pegar o seller_id do Mkp Mkp Tray/n')
        return 'Nao'  # nunca retorne booleano, vai dar erro de https

# metodo temporario, apagar depois de homologar
    @http.httprequest
    def teste_get_categorias(self, req, s_action=None, **kw):
        tray_conn.store = req.params.get('store')
        if not tray_conn.store:
            return 'Loja nao informada!'
        cfg = configuracao('marketplace_tray', tray_conn.store)
        cfg.lerConfiguracao()
        _server = str(cfg.server)
        _base = str(cfg.base)
        if not _server:
            return 'Nao encontrei a loja: %s' % tray_conn.store
        sock_common = xmlrpclib.ServerProxy('%s/xmlrpc/common' % _server)
        socket.setdefaulttimeout(15)
        uid = sock_common.login(_base, 'mkp_remoto', _senha)
        sock = xmlrpclib.ServerProxy('%s/xmlrpc/object' % _server)
        mkpTray = sock.execute(_base, uid, _senha, 'mkp.tray', 'mkpTray_get_categorias')
        return mkpTray


# metodo temporario, apagar após homologar
    @http.httprequest
    def teste_renovar_token(self, req, s_action=None, **kw):
        _logger.info('=============================== renovar_token %s' % req)
        tray_conn.store = req.params.get('store')
        if not tray_conn.store:
            return 'Loja nao informada!'
        cfg = configuracao('marketplace_tray', tray_conn.store)
        cfg.lerConfiguracao()
        _server = str(cfg.server)
        _base = str(cfg.base)
        if not _server:
            return 'Nao encontrei a loja: %s' % tray_conn.store
        sock_common = xmlrpclib.ServerProxy('%s/xmlrpc/common' % _server)
        socket.setdefaulttimeout(15)
        uid = sock_common.login(_base, 'mkp_remoto', _senha)
        sock = xmlrpclib.ServerProxy('%s/xmlrpc/object' % _server)
        for _conta_id in sock.execute(_base, uid, _senha, 'mkp.contas', 'search',
                                [('mkpcta_tr_id_loja', '=', tray_conn.store)]):
            dados_conta = sock.execute(_base, uid, _senha, 'mkp.contas', 'read', _conta_id, [])
            _mkp_id = dados_conta.get('mkpcta_marketplace_id')[0]
            dados_mkp = sock.execute(_base, uid, _senha, 'mkp.marketplaces', 'read', _mkp_id, [])
            tray_conn.API_ROOT_URL = dados_mkp.get('mkpmkp_api').strip()
            tray_conn.refresh_token = str(dados_conta.get('mkpcta_tr_refresh_token'))
        res = tray_conn.renovar_token()
        if res:
            return 'token renovado'
        else:
            return 'nao consegui renovar o token'


    @http.httprequest
    def teste(self, req, s_action=None, **kw):
        _logger.info('=============================== teste %s' % req)
        return 'testado para Tray'

    @http.httprequest
    def teste_set_categoria(self, req, s_action=None, **kw):
        _logger.info('=============================== set_categoria %s' % req)
        tray_conn.store = req.params.get('store')
        if not tray_conn.store:
            return 'Loja nao informada!'
        categoria = req.params.get('categoria')
        if not tray_conn.store:
            return 'Categoria nao informada!'
        cfg = configuracao('marketplace_tray', tray_conn.store)
        cfg.lerConfiguracao()
        _server = str(cfg.server)
        _base = str(cfg.base)
        if not _server:
            return 'Nao encontrei a loja: %s' % tray_conn.store
        sock_common = xmlrpclib.ServerProxy('%s/xmlrpc/common' % _server)
        socket.setdefaulttimeout(15)
        uid = sock_common.login(_base, 'mkp_remoto', _senha)
        sock = xmlrpclib.ServerProxy('%s/xmlrpc/object' % _server)
        for _conta_id in sock.execute(_base, uid, _senha, 'mkp.contas', 'search',
                                [('mkpcta_tr_id_loja', '=', tray_conn.store)]):
            dados_conta = sock.execute(_base, uid, _senha, 'mkp.contas', 'read', _conta_id, [])
            _mkp_id = dados_conta.get('mkpcta_marketplace_id')[0]
            dados_mkp = sock.execute(_base, uid, _senha, 'mkp.marketplaces', 'read', _mkp_id, [])
            tray_conn.API_ROOT_URL = dados_mkp.get('mkpmkp_api').strip()
            tray_conn.access_token = str(dados_conta.get('mkpcta_tr_access_token'))
        res = sock.execute(_base, uid, _senha, 'mkp.tray', 'mkpTray_set_categories', _conta_id, '13791', categoria, context={})
        #conta_id, codigo, categoria, categoria_pai, context=None)
        if res:
            return 'Categoria cadastrada'
        else:
            return 'nao consegui cadastrar a categoria'

