# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class mkp_categorias(osv.Model):
    _inherit = 'mkp.categorias'

    def _mkpcat_tr_categoria_enviar(self, cr, uid, id, _conta_id, _codigo, _categoria, _pai, meta_keywords=None,
                                    meta_descricao=None, property=None, context=None):
        obj_mkp_Tray = self.pool.get('mkp.tray')
        res = obj_mkp_Tray.mkpTray_set_categories(cr, uid, _conta_id, _codigo, _categoria, _pai, meta_keywords=meta_keywords, meta_descricao=meta_descricao, property=property, context=context)
        if res and res.get('status') == False:
            raise osv.except_osv(_('Atencao!'),
                                 _('Nao consegui atualizar a categoria!\n%s' % res.get('mensagem')))
        if not _codigo:
            _codigo = res.get('id')
            self.pool.get('mkp.categorias').write(cr, uid, id, {'mkpcat_codigo': _codigo}, context=context)
        return _codigo

    def mkpcat_tr_categoria_atualizar(self, cr, uid, categ_ids, context=None):
        for brw_categoria in self.browse(cr, uid, categ_ids, context=context):
            _conta_id = False
            id = brw_categoria.id
            for brw_conta in brw_categoria.mkpcat_marketplace_id.mkpmkp_conta_ids:
                if brw_conta.mkpcta_integrador == 'Tray':
                    _conta_id = brw_conta.id
            _codigo =  brw_categoria.mkpcat_codigo or False
            _categoria = brw_categoria.name
            _property = []
            for brw_property in brw_categoria.mkpcat_atributos_ids:
                for x in brw_property.mkpcatatr_estoque_atributo_id.estatr_mkp_atributos_ids:
                    if x.mkpatr_marketplace_id.id == brw_categoria.mkpcat_marketplace_id.id:
                        _property.append(x.name)
            if brw_categoria.mkpcat_categoria_estoque_id:
                _meta_keywords = brw_categoria.mkpcat_categoria_estoque_id.estcat_seo_tags
            else:
                _meta_keywords = False
            if brw_categoria.mkpcat_categoria_estoque_id:
                _meta_descricao = brw_categoria.mkpcat_categoria_estoque_id.estcat_seo_descricao
            else:
                _meta_descricao = False
            _pai = brw_categoria.parent_id.mkpcat_codigo or False
            brw_categ_temp = brw_categoria
            ancestrais = []
            while True: # verificar parent para cadastramento na Tray do parent e dos ancestrais
                if not brw_categ_temp.parent_id:
                    break
                brw_categ_temp = brw_categ_temp.parent_id
                if brw_categ_temp.mkpcat_codigo: # Se o pai já tem codigo os na Tray, os ancestrais tambem tem
                    break
                _Pcodigo = brw_categ_temp.mkpcat_codigo or False
                _Pcategoria = brw_categ_temp.name
                _Ppai = brw_categ_temp.parent_id.mkpcat_codigo or False
                _Pid = brw_categ_temp.id
                _Pproperty = []
                for brw_property in brw_categ_temp.mkpcat_atributos_ids:
                    for x in brw_property.mkpcatatr_estoque_atributo_id.estatr_mkp_atributos_ids:
                        if x.mkpatr_marketplace_id.id == brw_categ_temp.mkpcat_marketplace_id.id:
                            _property.append(x.name)
                if brw_categ_temp.mkpcat_categoria_estoque_id:
                    _Pmeta_keywords = brw_categ_temp.mkpcat_categoria_estoque_id.estcat_seo_tags
                else:
                    _Pmeta_keywords = False
                if brw_categ_temp.mkpcat_categoria_estoque_id:
                    _Pmeta_descricao = brw_categ_temp.mkpcat_categoria_estoque_id.estcat_seo_descricao
                else:
                    _Pmeta_descricao = False
                ancestrais.append({'codigo':_Pcodigo, 'categ':_Pcategoria, 'pai': _Ppai, 'id':_Pid,
                                   'meta_descricao': _Pmeta_descricao, 'meta_keywords':_Pmeta_keywords})
            while ancestrais:
                _Pcodigo = ancestrais[len(ancestrais)-1].get('codigo')
                _Pcategoria = ancestrais[len(ancestrais)-1].get('categ')
                _Ppai = ancestrais[len(ancestrais)-1].get('pai')
                _Pid = ancestrais[len(ancestrais)-1].get('id')
                _Pmeta_descricao = ancestrais[len(ancestrais)-1].get('meta_descricao')
                _Pmeta_keywords = ancestrais[len(ancestrais)-1].get('meta_keywords')
                ancestrais.pop(len(ancestrais)-1)
                _pai = self._mkpcat_tr_categoria_enviar(cr, uid, _Pid, _conta_id, _Pcodigo, _Pcategoria, _Ppai,
                                                        meta_keywords=_Pmeta_keywords, meta_descricao=_Pmeta_descricao,
                                                        property=_Pproperty, context=context)
                if ancestrais:
                    ancestrais[len(ancestrais)-1]['pai'] = _pai
            res = self._mkpcat_tr_categoria_enviar(cr, uid, id, _conta_id, _codigo, _categoria, _pai,
                                                   meta_keywords=_meta_keywords, meta_descricao=_meta_descricao,
                                                   property=_property, context=context)
        return res
