# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from SigUtils import datas
from datetime import datetime
import logging
_logger = logging.getLogger(__name__)


class mkp_notificacoes(osv.Model):
    _inherit = "mkp.notificacoes"

    def _mkpnot_get_orders_tr(self, cr, uid, dados_notificacao, context=None):
        _order = dados_notificacao.get('mkpnot_resource').split('/')[2]
        _conta_id = dados_notificacao.get('mkpnot_conta_id')
        _dados_conta = self.pool.get('mkp.contas').read(cr, uid, _conta_id, [], context=context)
        _obj_pedido_capa = self.pool.get('estoquepedidos.pedido.capa')
        dados = self.pool.get('mkp.tray').mkpTray_get_order(cr, uid, _order, _conta_id, context=context)
        if not dados:
            return False
        try:  # Se não conseguir importar o pedido, ignore e continue o processo das notificacoes
            res = self.pool.get('mkp.utils').mkputl_importar_um_pedido_tray(cr, uid, dados, _conta_id, context=context)
            if res.get('status:'):
                _ped_id = res.get('pedido')
            else:
                self._logger.info('Pedido nao importado!')
                return res
        except Exception as e:
            try:
                self._logger.info('Erro no Try! Erro: %s' % e.value)
            except:
                self._logger.info('Erro no Try!')
            return False
        return True


    def _mkpnot_processar_notificacao(self, cr, uid, codigo_mkp, notificacao_tipo, dados_notificacao, context=None):
        """
        Metodo qeue sobrescreve o original para tratamento especializado
        :param cr:
        :param uid:
        :param codigo_mkp: Codigo do Marketplace
        :param dados_notificacao: Dados resultado do read de um registro do marketplace, com todos os atributos
        :param context:
        :return:
        """
        context = context and context.copy() or {}
        res = super(mkp_notificacoes, self)._mkpnot_processar_notificacao(cr, uid, codigo_mkp, notificacao_tipo,
                                                                          dados_notificacao, context=context)
        if codigo_mkp == 'Tray':
            # if notificacao_tipo == 'items':
            #     res =  self._mkpnot_get_itens_tr(cr, uid, dados_notificacao, context=context)
            # elif notificacao_tipo == 'messages':
            #     res = self._mkpnot_get_messages_tr(cr, uid, dados_notificacao, context=context)
            # elif notificacao_tipo == 'questions':
            #     res = self._mkpnot_get_questions_tr(cr, uid, dados_notificacao, context=context)
            if notificacao_tipo == 'orders':
                res = self._mkpnot_get_orders_tr(cr, uid, dados_notificacao, context=context)
            # elif notificacao_tipo == 'collections':
            #     _payment = dados_notificacao.get('mkpnot_resource').split('/')[2]
            #     _conta_id = dados_notificacao.get('mkpnot_conta_id')
            #     res = self.pool.get('mkpml.pagamentos').mkpmlpag_get_payments(cr, uid, _payment, _conta_id, context=context)
            # elif notificacao_tipo == 'shipments':
            #     res = self._mkpnot_get_tripments_tr(cr, uid, dados_notificacao, context=context)
            # elif notificacao_tipo == 'payments':
            #     res = True
            # elif notificacao_tipo == 'claims':
            #     res = True
        return res


