# -*- encoding: utf-8 -*-
import re
from urllib import urlencode
import json
import requests
from openerp import pooler
import logging
from openerp.tools.translate import _
from openerp.tools import config
from SigUtils.geralogs import geraLogs

_logger = logging.getLogger('Tray')
"""
Consumer Key: fb2ce1dd4f762e5290e3b6cc8cb3e20da063195b9ff7b16d5965babca03dc85e
Consumer Secret: 8cefed12b742a48754093711135d514e82f53d6897ce3f63c512c3c2ea6448e8

Documentação das APIs:https://traydevelopers.zendesk.com/hc/pt-br/categories/360000706274-Aplicativos
"""
# consumer_key = 'fb2ce1dd4f762e5290e3b6cc8cb3e20da063195b9ff7b16d5965babca03dc85e'
# consumer_secret = '8cefed12b742a48754093711135d514e82f53d6897ce3f63c512c3c2ea6448e8'

class Tray(object):
    def logged_client(f):
        """Decorator for User Credentials checking."""
        def inner(self, *args, **kargs):
            if ((self.user_email is None) or (self.app_key is None)):
                raise Exception(_("Nao posso acessar o Tray. parametros do Tray nao informados!"))
            return f(self, *args, **kargs)
        return inner

    def __init__(self, cr=False, uid=False, conta_id=False, company_id=False):
        self.API_ROOT_URL = 'root_url'
        self.AUTH_URL = 'auth.php'
        self.cr = cr
        self.uid = uid
        self.user_email = ''
        self.app_key = ''
        self.account_manager_key = ''
        self.habilitar_log = False
        self.conta_id = conta_id
        self.store = ''
        self.adm_user = ''
        self.code = ''
        self.comunicar = True
        if cr:
            _poolget = pooler.get_pool(cr.dbname).get
            mkp_ids = _poolget('mkp.marketplaces').search(cr, uid, [('mkpmkp_codigo', '=', 'Tray')])
            if mkp_ids:
                mkp_ids = mkp_ids[0]
                dados_marketplace = _poolget('mkp.marketplaces').read(cr, uid, mkp_ids, [])
                if dados_marketplace.get('mkpmkp_parar_comunicacao'):
                    self.comunicar = False
                self.consumer_key = dados_marketplace.get('mkpmkp_tr_consumer_key')
                self.consumer_secret = dados_marketplace.get('mkpmkp_tr_consumer_secret')
                if not conta_id:
                    conta_id = _poolget('mkp.contas').search(cr, uid, [('mkpcta_marketplace_id', '=', mkp_ids)])
                    if conta_id:
                        conta_id = conta_id[0]
                if conta_id:
                    self.conta_id = conta_id
                    dados_conta = _poolget('mkp.contas').read(cr, uid, conta_id, [])
                    if dados_conta.get('mkpcta_parar_comunicacao'):
                        self.comunicar = False
                    # self.user_email = dados_conta.get('mkpcta_sh_user_email')
                    # self.app_key = dados_conta.get('mkpcta_sh_api_key')
                    # self.account_manager_key = dados_conta.get('mkpcta_tr_account_manager_key')
                    self.habilitar_log = dados_marketplace.get('mkpmkp_habilita_log')
                    self.redirect_url = dados_conta.get('mkpcta_tr_redirect_url')
                    self.store = dados_conta.get('mkpcta_tr_id_loja')
                    self.API_ROOT_URL = dados_marketplace.get('mkpmkp_api').strip()
                    self.code = dados_conta.get('mkpcta_tr_code')
                    self.access_token = dados_conta.get('mkpcta_tr_access_token')
                    self.refresh_token = dados_conta.get('mkpcta_tr_refresh_token')

    def _get_arq_log(self):
        _arq_log = 'mkp_tray_' + self.cr.dbname
        return _arq_log

    def _gerar_logs(self, mens):
        _diretorio = config.get('logfile')
        if _diretorio:
            _lista = _diretorio.split('/')
            _lista.pop(len(_lista) -1)
            _diretorio = '/'.join(_lista)
        else:
            _diretorio = '/var/log/openerp'
        _arq_log = self._get_arq_log()
        try:
            geraLogs(_arq_log, mens, 'S', _diretorio)
        except:
            try:
                geraLogs(_arq_log, mens.encode('ASCII', 'ignore'), 'S', _diretorio)
            except:
                geraLogs(_arq_log, 'Nao consegui registrar o log', 'S', _diretorio)
        return True


    def _comunicar_com_Tray(self, metodo, uri, params, body):
        if not self.comunicar:
            class resp(object):
                status_code = 999
                content = '{"message":"Comunicacao parada"}'
            return resp
        headers = self._monta_header()
        headers['Content-Length'] = str(len(body))
        while True:
            params['access_token'] = self.access_token
            if self.habilitar_log:
                self._gerar_logs('%s-> URL:%s Params: %s Body: %s Header: %s' % (metodo.upper(), str(uri),
                                                                                          str(params), str(body),
                                                                                          str(headers)))
            if metodo == 'get':
                response = requests.get(uri, params=urlencode(params), headers=headers)
            elif metodo == 'post':
                response = requests.post(uri, data=body, params=urlencode(params), headers=headers)
            elif metodo == 'put':
                response = requests.put(uri, data=body, params=urlencode(params), headers=headers)
            elif metodo == 'delete':
                response = requests.delete(uri, headers=headers)
            if self.habilitar_log:
                self._gerar_logs('Status:%s Resposta: %s' % (response.status_code, response.text))
            if response.status_code == 401:
                if response.content:
                    _res = eval(response.content)
                    if _res.get('error_code') in (1000, 1099):  # Token invalido ou expirado
                        res = self.renovar_token()
                        if not res:
                            break
            else:
                break
        return response

    def get_token(self):
        params = {
            'consumer_key': self.consumer_key,
            'consumer_secret': self.consumer_secret,
            'code': self.code,
        }
        url = self.API_ROOT_URL + '/auth'
        response = requests.post(url, json=params)
        if self.habilitar_log:
            if response.status_code == 201:
                self._gerar_logs('Tray.resposta--> %s ' % response.content)
            else:
                self._gerar_logs('Tray.get_token mensagem:--> %s ' % response)
        if response.status_code == requests.codes.ok:
            response_info = response.json()
            if 'access_token' in response_info:
                self.access_token = response_info['access_token']
                self.refresh_token = response_info['refresh_token']
            else:
                self.refresh_token = ''  # offline_access not set up
                self.access_token = ''
            return True
        return False

    def renovar_token(self):
        if self.habilitar_log:
            self._gerar_logs('Tray.renovar_token')
        params = {
            'refresh_token': self.refresh_token
        }
        url = self.API_ROOT_URL + '/auth'
        response = requests.get(url, params=urlencode(params))
        if self.habilitar_log:
            if response.status_code == 200:
                self._gerar_logs('Tray.resposta--> %s ' % response.content)
            else:
                self._gerar_logs('Tray.renovar_token. Mensagem:--> %s ' % response.text)

        if response.status_code == requests.codes.ok:
            response_info = response.json()
            if 'access_token' in response_info:
                self.access_token = response_info['access_token']
                self.refresh_token = response_info['refresh_token']
                vals = {
                    'mkpcta_tr_access_token': self.access_token,
                    'mkpcta_tr_refresh_token': self.refresh_token
                }
                pooler.get_pool(self.cr.dbname).get('mkp.contas').write(self.cr, self.uid, [self.conta_id], vals)
                return True
        return False

    def authorize(self):
        params = {
            'response_type': 'code',
            'consumer_key': self.consumer_key,
            'adm_user': self.adm_user
        }
        uri = self.make_path(self.AUTH_URL)
        uri = uri.replace('/web_api', '')
        if self.habilitar_log:
            self._gerar_logs('Tray.Authorize-> %s -> %s' % (uri, params))
        response = requests.get(uri, params=urlencode(params))
        if self.habilitar_log:
            if response.status_code == 200:
                self._gerar_logs('Tray.resposta--> %s ' % response.content)
            else:
                self._gerar_logs('Tray.authorize Mensagem:--> %s ' % response)

        if response.status_code == requests.codes.ok:
            return response.content
        else:
            response.raise_for_status()

    # REQUEST METHODS
    @logged_client
    def get(self, path, params={}):
        uri = self.make_path(path)
        response = self._comunicar_com_Tray('get', uri, params, {})
        return response

    @logged_client
    def post(self, path, body={}, params={}):
        uri = self.make_path(path)
        if body:
            body = json.dumps(body)
        response = self._comunicar_com_Tray('post', uri, params, body)
        return response

    @logged_client
    def put(self, path,  body=None, params={}):
        uri = self.make_path(path)
        _body = json.dumps(body)
        response = self._comunicar_com_Tray('put', uri, params, _body)
        return response

    def delete(self, path, mkp_integrador):
        uri = self.make_path(path) + '/' + str(mkp_integrador)
        response = self._comunicar_com_Tray('delete', uri, {}, {})
        return response

    def make_path(self, path, params={}):
        # Making Path and add a leading / if not exist
        if not (re.search("^http", path)):
            if not (re.search("^\/", path)):
                path = "/" + path
            path = self.API_ROOT_URL + path
        if params:
            path = path + "?" + urlencode(params)
        return path

    def _monta_header(self):
        headers = {
            'Content-Type':'application/json',
        }
        return headers
