# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2019 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2019, Creative Commons
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""
from openerp.osv import osv, fields


class adm_pessoa(osv.Model):
    """
    Classe Pessoa
    """

    def admpes_get_tipo_proprietario(self, cr, user, context=None):
        context = context and context.copy() or {}
        return [('0', 'TAC agregado'), ('1', 'TAC independente'), ('2', 'Outros')]

    def admpes_get_endereco_uf(self, cr, user, ids, name, args, context=None):
        context = context and context.copy() or {}
        result = {}.fromkeys(ids, '')
        for r in self.browse(cr, user, ids, context):
            if r.endereco_nf_id:
                endereco = r.endereco_nf_id.uf_id and r.endereco_nf_id.cidade_id and r.endereco_nf_id
            else:
                enderecos = [e for e in r.endereco_ids if e.uf_id and e.cidade_id]
                endereco = enderecos and enderecos[0]
            result[r.id] = endereco

        return result

    _inherit = 'adm.pessoa'  # admpes
    _columns = {
        'admpes_rntrc': fields.char(
            'RNTRC', size=8, help='Registro obrigatorio do proprietario, coproprietario ou '
                                  'arrendatario do veiculo junto a ANTT para exercer a atividade '
                                  'de transportador rodoviario de cargas por conta de terceiros e '
                                  'mediante remuneracao.'),
        'admpes_tipo_proprietario': fields.selection(
            admpes_get_tipo_proprietario, 'Tipo proprietario', size=1,
            help=''),
        'admpes_endereco': fields.function(
            admpes_get_endereco_uf, type='char', size=2, string='Endereco'),
    }

    def search(self, cr, user, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        context['modal_rodoviario'] = True
        result = super(adm_pessoa, self).search(cr, user, args, offset, limit, order, context, count)
        return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
