# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2019 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2019, Creative Commons
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""
# noinspection PyProtectedMember
from openerp.tools.translate import _
from openerp.osv import fields
from openerp.osv import osv


# noinspection PyAbstractClass,PyPep8Naming
class fiscal_evento(osv.Model):
    """
    Classe evento de documentos eletronicos (MDF-e)
    """
    # noinspection PyMethodMayBeStatic,PyUnusedLocal
    def fiseve_get_evento(self, cr, user, context=None):
        context = context and context.copy() or {}
        result = super(fiscal_evento, self).fiseve_get_evento(cr, user, context)
        result.extend([
            ('58110112', _('Encerramento do Manifesto')),
            ('58110114', _('Inclusao de condutor')),
            ('58110115', _('Inclusao de DF-e (carregamento posterior)')),
            ('58999104', _('Consultar nao encerrados')),
        ])

        return result

    _name = 'fiscal.evento'  # Prefix: mdfeev
    _inherit = 'fiscal.evento'
    _columns = {
        'fiseve_tipo': fields.selection(fiseve_get_evento, 'Evento'),
        'mdfe_rodo_id': fields.many2one(
            'mdfe.modal.rodoviario', 'MDF-e Rodoviario', ondelete='restrict', select=True,
            help='Manifesto de Documento Eletronico (Modal Rodoviario)'),
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
