# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2019 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2019, Creative Commons
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""
from openerp.osv import osv, fields


class fiscal_modelo_nf(osv.Model):  # Prefix: fismnf
    """
    Modelos de notas fiscais
    """
    def fismnf_get_modelo_nf_tipo(self, cr, user, context=None):
        """
        Retorna os tipos de modelo de uma nota fiscal
        """
        context = context and context.copy() or {}
        result = super(fiscal_modelo_nf, self).fismnf_get_modelo_nf_tipo(cr, user, context)
        result = result and result[:] or []
        result.append(('M', 'Manifesto de Documento Fiscal'))

        return result

    _inherit = 'fiscal.modelo.nf'
    _columns = {
        'fismnf_tipo': fields.selection(
            fismnf_get_modelo_nf_tipo, 'Tipo de documento', size=1, oldname='tipo')
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:


