# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################
from openerp.osv import osv, fields
from openerp.tools.translate import _


class fiscal_parametro(osv.Model):
    """
    Parametros do MDF-e.
    """
    def _fispar_mdfe_get_ambiente(self, cr, user, context=None):
        context = context and context.copy() or {}
        return [('1', 'Producao'), ('2', 'Homologacao')]

    def _fispar_mdfe_get_versao_xml(self, cr, user, context=None):
        context = context and context.copy() or {}
        return [('3.00', '3.00')]

    def _fispar_mdfe_get_tipo_emitente(self, cr, user, context=None):
        context = context and context.copy() or {}
        return [('1', 'Prestador de servico de transporte'),
                ('2', 'Transportador de carga propria'),
                ('3', 'Prestador de servico de transporte que emitira CT-e Globalizado')]

    def _fispar_mdfe_get_tipo_transportador(self, cr, user, context=None):
        context = context and context.copy() or {}
        return [('1', 'ETC - Empresas de Transporte Rodoviario de Carga'),
                ('2', 'TAC - Transportador Autonomo de Cargas'),
                ('3', 'CTC - Cooperativa de Transporte Rodoviario de Cargas')]

    _inherit = 'fiscal.parametro'
    _columns = {
        'fispar_mdfe_modelo_serie_id': fields.many2one(
            'fiscal.modelo.nf.series', 'Modelo padrao de MDF-e', required=True, ondelete='restrict',
            help='Modelo padrao para o Manifesto Eletronico de Documentos Fiscais.'),
        'fispar_mdfe_ambiente': fields.selection(
            _fispar_mdfe_get_ambiente, 'Ambiente', size=1),
        'fispar_mdfe_versao_xml': fields.selection(
            _fispar_mdfe_get_versao_xml, 'Versao XML', size=5),
        'fispar_mdfe_tipo_emitente': fields.selection(
            _fispar_mdfe_get_tipo_emitente, 'Tipo de emitente', required=True,
            help='Deve ser preenchido com 2 para emitentes de NF-e e pelas transportadoras quando '
                 'estiverem fazendo transporte de carga propria. Deve ser preenchido com 3 para '
                 'transportador de carga que emitira a posteriori CT-e Globalizado relacionando '
                 'as NF-e.'),
        'fispar_mdfe_tipo_transportador': fields.selection(
            _fispar_mdfe_get_tipo_transportador, 'Tipo do transportador', required=False, size=1,
            help='Tipo do transportador de carga rodoviaria'),
    }
    _defaults = {
        'fispar_mdfe_tipo_emitente': '2',  # Nao prestador de servico de transporte
        'fispar_mdfe_ambiente': '2',
        'fispar_mdfe_versao_xml': '3.00'
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
