# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2019 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2019, Creative Commons
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""
from funcoes_modal_rodoviario import _mmodr_total_fornecimento
from openerp.osv import fields
from openerp.osv import osv


class mdfe_lacre(osv.Model):
    """
    Classe Lacres do MDF-e
    """
    class ParamToObject(object):
        """
        Converte valores de dicionarios em objetos
        """
        def __init__(self, **entries):
            self.__dict__.update(entries)

    def parametro(self, cr, uid, company=False, context=None):
        context = context and context.copy() or {}
        company = self.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, self._name, None, context, company)
        parametros = dict([(mod, self.ParamToObject(
            **self.pool.get('adm.utils').admutl_get_parametros(
                cr, uid, mod, [], company))) for mod in [
                               'financeiro', 'fiscal', 'estoque', 'adm', 'rh']])

        return self.ParamToObject(**parametros)

    _name = 'mdfe.lacre'  # Prefix: mdfel
    _columns = {
        'mdfel_numero': fields.char(
            'Lacre', size=20, help='Numero do lacre do MDF-e.'),
        'mdfel_modal_rodoviario_id': fields.many2one('mdfe.modal.rodoviario', 'Lacre')
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
