# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2019 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2019, Creative Commons
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""
from openerp.osv import osv, fields


# noinspection PyPep8Naming,PyAbstractClass
class mdfe_municipio_descarregamento(osv.Model):
    """
    Classe Municipio Descarregamento
    """
    _name = 'mdfe.municipio.descarregamento'  # mdfemd
    _columns = {
        'mdfemd_uf_id': fields.many2one('adm.uf', string='UF', ondelete='restrict'),
        'mdfemd_municipio_id': fields.many2one(
            'adm.cidade', string='Municipio', ondelete='restrict',
            help='Municipio utilizado no descarregamento'),
        'mdfemd_cte_referencia_ids': fields.many2many(
            'fiscal.nf.capa', 'mdfemd_cte_referencia_m2m_fiscal_nf_capa', 'mdfemd_cte_id',
            'fisnfc_id', 'CT-e'),
        'mdfemd_nfe_referencia_ids': fields.many2many(
            'fiscal.nf.capa', 'mdfemd_nfe_referencia_m2m_fiscal_nf_capa', 'mdfemd_nfe_id',
            'fisnfc_id', 'NF-e'),
        'mdfemd_nf_referencia_ids': fields.many2many(
            'fiscal.nf.capa', 'mdfemd_nf_referencia_m2m_fiscal_nf_capa',  'mdfemd_nf_id',
            'fisnfc_id', 'NF'),
        'mdfemd_rodo_id': fields.many2one('mdfe.modal.rodoviario', 'Modalidade Rodoviario')
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
