# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2019 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2019, Creative Commons
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""
from funcoes_modal_rodoviario import _mmodr_total_fornecimento
from openerp.osv import fields
from openerp.osv import osv


class mdfe_rel_rodo_uf_data(osv.Model):
    """
    Classe MDF-e - Modalidade Rodoviario
    """

    def mdfru_get_sequence(self, cr, uid, context):
        if not context.get('ufs'):
            return 1

        seq = 1
        for uf in context.get('ufs'):
            if seq < uf[2].get('sequence'):
                seq = uf[2].get('sequence')

        return seq + 1

    def mdfru_get_name(self, cr, uid, ids, name, arg, context=None):
        context = context and context.copy() or {}
        res = {}
        for i in self.browse(cr, uid, ids):
            res[i.id] = i.mdfru_uf_id.name

        return res

    _name = 'mdfe.rel.rodo.uf'  # Prefix: mmodr
    _columns = {
        'sequence': fields.integer('Sequencia'),
        'mdfru_rodo_id': fields.many2one('mdfe.modal.rodoviario', 'Modal Rodoviario',
                                         ondelete='cascade', required=True),
        'mdfru_uf_id': fields.many2one('adm.uf', 'Sigla', ondelete='cascade', required=True),
        'name': fields.function(mdfru_get_name, method=True, string='Nome',
                                                       type='text', store=False)

    }
    _defaults = {
        'sequence': mdfru_get_sequence,
    }

    _order = 'sequence'

    def mdfru_onchange_uf(self, cr, user, ids, uf_id, context=None):
        if not uf_id:
            return {'value': {'name': ''}}

        uf = self.pool.get('adm.uf').read(cr, user, uf_id, ['name'], context)
        return {'value': {'name': uf.get('name') or ''}}

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
