# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2019 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2019, Creative Commons
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""
from openerp.osv import fields
from openerp.osv import osv

class mdfe_vale_pedagio(osv.Model):
    """
    Classe Vale Pedagio
    """
    class ParamToObject(object):
        """
        Converte valores de dicionarios em objetos
        """
        def __init__(self, **entries):
            self.__dict__.update(entries)

    def parametro(self, cr, uid, company=False, context=None):
        context = context and context.copy() or {}
        company = self.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, self._name, None, context, company)
        parametros = dict([(mod, self.ParamToObject(
            **self.pool.get('adm.utils').admutl_get_parametros(
                cr, uid, mod, [], company))) for mod in [
            'financeiro', 'fiscal', 'estoque', 'adm', 'rh']])

        return self.ParamToObject(**parametros)

    _name = 'mdfe.vale.pedagio'  # Prefix: mdfevp
    _columns = {
        'mdfevp_empresa_fornecedora_id': fields.many2one(
            'adm.pessoa', 'Fornecedor', ondelete='restrict', domain='[("pessoa_tipo", "=", "J")]',
            help='Empresa que fornece ao responsavel pelo pagamento do Vale-Pedagio os '
                 'dispositivos do Vale-Pedagio.'),
        'mdfevp_responsavel_pagamento_id': fields.many2one(
            'adm.pessoa', 'Responsavel', ondelete='restrict',
            help='Responsavel pelo pagamento do Vale-Pedagio.'),
        'mdfevp_numero_comprovante_compra': fields.char(
            'Comprovante', size=20, help='Numero de ordem do comprovante de compra do Vale-Pedagio '
                                         'fornecido para cada veiculo ou combinacao veicular, por '
                                         'viagem.'),
        'mdfevp_valor': fields.float('Valor do Vale-Pedagio', digits=(6, 2)),
        'mmodr_id': fields.many2one('mdfe.modal.rodoviario', 'Modalidade Rodoviario')
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
