# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2019 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2019, Creative Commons
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""
from openerp.osv import fields
from datetime import datetime
from openerp.osv import osv


class mdfe_cancelamento_osv(osv.TransientModel):
    _name = "mdfe.cancelamento.osv"
    _description = "Cancelamento de MDF-e"

    _columns = {
        'modal': fields.selection([('rodo', 'Modal Rodoviario')]),
        'mdfe_id': fields.integer('ID do Manifesto'),
        'motivo': fields.char('Motivo do cancelamento', size=255),
    }

    def button_cancelar_mdfe_rodo(self, cr, user, ids, context=None):
        context = context and context.copy() or {}
        cancelamento_dados = self.read(
            cr, user, ids[0], ['mdfe_id', 'motivo'], context, '_classic_write')
        mdfe_id = cancelamento_dados.get('mdfe_id')
        mdfe_dados = self.pool.get('mdfe.modal.rodoviario').read(
            cr, user, mdfe_id, ['mdfe_chave_acesso', 'mdfe_protocolo_autorizacao'], context)
        chave = mdfe_dados.get('mdfe_chave_acesso')
        protocolo = mdfe_dados.get('mdfe_protocolo_autorizacao')
        process = self.pool.get('mdfe.modal.rodoviario').mmodr_cancelar_mdfe(
            cr, user, chave, protocolo, cancelamento_dados.get('motivo'), context)
        dhregevento = process.resposta.infEvento.dhRegEvento.valor
        dhregevento = dhregevento and self.pool.get('adm.utils').admutl_converte_tz(
            cr, user, datetime.strptime(dhregevento.__str__()[:19], '%Y-%m-%d %H:%M:%S'),
            'America/Sao_Paulo', 'UTC')
        self.pool.get('fiscal.evento').create(cr, user, {
            'fiseve_xml_env': process.envio.xml,
            'fiseve_xml_ret': process.resposta.xml,
            'fiseve_tipo': '00110111',  # Cancelamento de MDF-e
            'fiseve_data': dhregevento or datetime.now().strftime('%Y-%m-%d %H:%M:%S'),
            'fiseve_status': process.resposta.infEvento.cStat.valor,
            'fiseve_motivo': process.resposta.infEvento.xMotivo.valor,
            'fiseve_lote': False,
            'fiseve_protocolo': process.resposta.infEvento.nProt.valor,
            'mdfe_rodo_id': mdfe_id,
        })
        if process.resposta.infEvento.cStat.valor == u'135':
            self.pool.get('mdfe.modal.rodoviario').write(cr, user, mdfe_id, {
                'mdfe_protocolo_cancelamento': process.resposta.infEvento.nProt.valor,
                'mdfe_xml_cancelamento': process.resposta.infEvento.xml,
                'mdfe_status_sefaz': '%s-%s' % (process.resposta.infEvento.cStat.valor,
                                                process.resposta.infEvento.xMotivo.valor),
                'state': 'C'
            }, context)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
