# -*- encoding: utf-8 -*-
##########################################################################r####
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

READ_LOAD = '_classic_write'

from openerp.osv import osv
from datetime import date, timedelta, datetime
from openerp.tools.translate import _
from openerp.report import report_sxw
import subprocess
import base64
from dateutil.parser import parse


class orcamentos_orcamento_capa(osv.Model):
    _name = 'orcamentos.orcamento.capa'
    _inherit = 'orcamentos.orcamento.capa'

    def init(self, cr):
        modulo_madeireira_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, 1, 'madeireira', context=None)
        if modulo_madeireira_instalado:
            cr.execute("""delete
                          from ir_act_report_xml
                          where model = 'orcamentos.orcamento.capa' and
                          report_rml != 'addons/madeireira/report/rel_impressao_orcamento.rml'
                          """)
        else:
            cr.execute("""select id
                          from ir_act_report_xml
                          where model = 'orcamentos.orcamento.capa' and
                          report_rml = 'addons/orcamentos/report/rel_impressao.rml'
                          """)
            report_id = cr.dictfetchone()
            if not report_id:
                cr.execute("""insert
                              into ir_act_report_xml
                              (name, type, model, report_name, auto, header, report_type, report_file, report_rml, multi,
                               attachment_use)
                              values ('Impressao de Orcamentos', 'ir.actions.report.xml', 'orcamentos.orcamento.capa',
                                      'orcamentos.orcamento.capa', False, False, 'pdf',
                                      'addons/orcamentos/report/rel_impressao.rml',
                                      'addons/orcamentos/report/rel_impressao.rml',
                                      False, False)
                              """)

    def default_get(self, cr, uid, fields, context=None):
        def _orccap_default_get_software(res, context):
            if context.get('orcamento_tipo_software'):
                res['orcamento_tipo_software'] = context.get('orcamento_tipo_software')
            return res

        context = context and context.copy() or {}
        res = super(orcamentos_orcamento_capa, self).default_get(cr, uid, fields, context)
        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'software', context):
            res = _orccap_default_get_software(res, context)
        if context.get('contexto_orcamentos'):
            estoque_parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(
                cr, uid, 'estoque', 'estpar_orcamento_mensagem_padrao', context=context)
            estoque_parametro_dados.get('estpar_orcamento_mensagem_padrao') and res.update(
                {'observacao': estoque_parametro_dados.get('estpar_orcamento_mensagem_padrao')})
        return res

    def _auto_init(self, cr, context=None):
        #Metodo implementado apos a versap 2J3 em 17/10/12 qdo da troca dos status
        context = context and context.copy() or {}
        super(orcamentos_orcamento_capa, self)._auto_init(cr, context)
        cr.execute("update orcamentos_orcamento_capa set state = '1E' where state='inicial'")
        cr.execute("update orcamentos_orcamento_capa set state = '2V' where state='validado'")
        cr.execute("update orcamentos_orcamento_capa set state = '3A' where state='aprovado'")
        cr.execute("update orcamentos_orcamento_capa set state = '4G' where state='gerado'")
        cr.execute("update orcamentos_orcamento_capa set state = '5C' where state='cancelado'")

    def sequence_criar(self, cr, uid, context=None):
        context = context and context.copy() or {}
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
        __code = 'orcamento.capa.documento'
        __name = 'Sequencia do Orcamento'
        vals = {
            'name': __name,
            'code': __code,
            'padding': 6,
            'prefix': 'ORC-%(year)s-',
            'company_id': company_id,
            'implementation': 'no_gap',
        }
        # Gerar sequence para orcamento para a empresa
        consulta = self.pool.get('ir.sequence.type').search(cr, uid, [('code', '=', __code)],
                                                            context=context)
        if not consulta:
            self.pool.get('ir.sequence.type').create(cr, uid, {'name': __name, 'code': __code},
                                                     context)
        self.pool.get('ir.sequence').create(cr, uid, vals, context)
        return True

    def _needaction_domain_get(self, cr, uid, context=None):
        """
            Mostra a quantidade de Orcamentos ainda nao conccluidos'

            @param cr: {cursor} a linha atual do cursor do banco de dados,
            @param uid: {int} o ID do usuário utilizado para a verificacao de perfil,
            @param context: {dict} um dicionário padrao para valores contextuais,
            @return: {list} dominio utilizado para contar as Ordens de Servico com
            ´status´  igual a 'aberta'.

            @see: openerp/addons/base/ir/ir.needaction (class ir_needaction_mixin)
            @copyright: OpenERP SA.
            """
        context = context and context.copy() or {}
        return [('state', 'in', ['1E', '2V', '3A'])]

    def button_abrir_pedido(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, list):
            ids = ids[0]
        browse_orcamento = self.browse(cr, uid, ids)
        pedido_id = browse_orcamento.pedido_id.id
        if not pedido_id:
            raise osv.except_osv(_('Atencao'), _('Pedido nao gerado!'))
        else:
            reference = self.pool.get('ir.model.data').get_object_reference(cr, uid, 'estoquepedidos',
                                                                            'view_estoquepedidos_pedido_capa_form')
            view_id = reference and reference[1] or False
            return {
                'name': _('Pedido Gerado'),
                'view_type': 'form',
                'view_mode': 'form',
                'view_id': [view_id],
                'res_model': 'estoquepedidos.pedido.capa',
                'res_id': pedido_id,
                'type': 'ir.actions.act_window',
            }

    def button_esboco(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = super(orcamentos_orcamento_capa, self).write(cr, uid, ids, {'state': '1E'}, context)
        self.message_post(cr, uid, ids, _('Alteracao de Status'), _('Esboco'))
        return res

    def button_enviar_orcamento_email(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        _html_body_template = "<html><head><title>Orcamento</title></head><body><p>" \
                              "Segue anexo o orcamento.</p></body></html>"
        orcamento_dados = self.browse(cr, uid, ids[0])
        if orcamento_dados.company_id.servidor_smtp_id:
            param_ids = [orcamento_dados.company_id.servidor_smtp_id.id]
        else:
            param_ids = self.pool.get('ir.mail_server').search(cr, uid, args=[], order='sequence asc',
                                                               limit=1, context=context)
        if not param_ids:
            raise osv.except_osv(_('Atencao'), _('Configure os parametros de email'))
        emails = orcamento_dados.pessoa_id.email
        if not emails:
            raise osv.except_osv(_('Atencao'), _('Cliente nao tem email cadastrado'))
        filename = (orcamento_dados.documento or 'orcamento')

        context.update({'active_id': ids[0] if isinstance(ids, list) else ids})
        anexo = base64.encodestring(self.gerar_pdf_orcamento(
            cr, uid, ids, context=context)[0])
        del context['active_id']

        ret = self.pool.get('adm.utils').admutl_send_email(
            cr, uid,
            email=orcamento_dados.pessoa_id.email,
            assunto=_("Orcamento - %s") % filename,
            corpo=_html_body_template,
            destinatarios=', '.join(map(lambda e: e.name,
                                        filter(lambda a: a.name != orcamento_dados.pessoa_id.email,
                                               orcamento_dados.pessoa_id.email_ids))),
            anexo=anexo,
            nome_anexo=filename + '.pdf',
            mail_server_id = param_ids[0],
            context=context,
            )
        if ret:
            msg = _('E-mail para: %s. Enviado com sucesso!') % orcamento_dados.pessoa_id.email
            self.log(cr, uid, ids[0], msg)
        return True

    def orccap_valida_condicoes_pagamento(self, cr, uid, ids, context=None):
        """
        Ao validar o orçamento:
        1) se não tiver nenhuma forma de pagamento, trazer as padrões, se tiver não trazer
        2) se tiver alguma forma de pagamento com valor superior ao total do orçamento, não validar
        3) se a soma das formas(somente as que tem valor menor do que o orçamento)
           NÃO for maior ou igual ao total do orçamento não validar

        Ao aprovar o orçamento
        1) Se a soma das formas selecionadas não for igual ao total do orçamento, não aprovar
        """
        context = context and context.copy() or {}
        res = True
        obj_orcamento_utils = self.pool.get('orcamento.utils')
        calcular_condicao = False
        dados_orcamento = self.read(cr, uid, ids[0], ['orcamento_itens_ids',
                                                       'orcamento_condicao_ids'], context)

        itens = map(lambda x: [4, x, {}], dados_orcamento.get('orcamento_itens_ids') or [])
        values = {'orcamento_itens_ids': itens}
        total_orcamento = self._orccap_calcula_total_orcamento(cr, uid, ids, values, context
                                                               ).get('valor_liquido') or 0.00
        orcamento_condicoes = dados_orcamento.get('orcamento_condicao_ids')
        if orcamento_condicoes:
            dict_condicoes = {}
            for i in self.pool.get('orcamentos.orcamento.condicao').read(cr, uid,
                                                           orcamento_condicoes, ['valor'], context):
                dict_condicoes[i.get('id')] = i.get('valor')
            dict_condicoes = obj_orcamento_utils.orcult_valida_condicoes_iguais_ao_total(
                dict_condicoes, total_orcamento)
            if dict_condicoes:
                res = obj_orcamento_utils.orcult_valida_soma_condicoes_menores_ao_total(
                    dict_condicoes, total_orcamento)
                if not res:
                    return res
                res = obj_orcamento_utils.orcult_valida_condicao_maior_total(dict_condicoes,
                                                                             total_orcamento)
                if not res:
                    return res
        else:
            calcular_condicao = True
        if calcular_condicao:
            condicoes_ok = self.button_calcular_condicoes(cr, uid, ids, context)
            if not condicoes_ok:
                res = False
        return res

    def button_validado(self, cr, uid, ids, context=None):
        """
        Efetua a validacao do orcamento.

        :param cr: a linha atual do cursor do banco de dados
        :param uid: ID do usuario utilizado para a verificacao de perfil
        :param ids: lista dos IDs
        :param context: um dicionario padrao para valores contextuais
        :type cr: cursor
        :type uid: int
        :type ids: list[long]
        :type context: dict
        :raise: mensagem se erro se nao foi possivel validar o orcamento.
        :return: verdadeiro se a validacao foi efetuada.
        :rtype: bool
        """

        context = context and context.copy() or {}

        if isinstance(ids, (int, long)):
            ids = [ids]

        # ___________________________ Objects ________________________________
        obj_orcamento_utils = self.pool.get('orcamento.utils')
        obj_orcamentos_orcamento_itens = self.pool.get('orcamentos.orcamento.itens')
        obj_estoque_parametro = self.pool.get('estoque.parametro')
        obj_estoque_preco_venda = self.pool.get('estoque.preco.venda')

        # Name dos orcamento_ids
        orcamento_names_dict = obj_orcamento_utils.orcutl_get_orcamento_names(cr, uid, ids, context)

        erro_orcamento = ''
        erro_condicao_pgto = ''
        orcamento_sem_itens = ''
        itens_custo_maior_precovenda = ''
        itens_quantidade_valor_zero = ''

        # Caso nao exista condicoes de pagamento informadas no orcamento o metodo ´button_calcular´
        # condicoes sera executado. O metodo orccap_valida_condicoes_pagamento ira fazer as
        # validacoes.
        if not self.orccap_valida_condicoes_pagamento(cr, uid, ids, context):
            raise osv.except_osv(_('Atencao'), _('Orcamento nao possui condicoes de pagamento '
                                                 'ou os valores sao invalidos'))

        orcamento_dados = self.read(cr, uid, ids, ['orcamento_itens_ids', 'pessoa_id'], context=context)
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
        estoque_parametro_id = obj_estoque_parametro.search(
            cr, uid, [('company_id', '=', company_id)], context=context)
        estpar_pvenda_menor_pcusto = False
        pessoa_id = False
        hoje = ''

        # Verifica Kit
        modulo_kit_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(
            cr, uid, 'kit', context)

        if modulo_kit_instalado:
            if isinstance(ids,list):
                orcamento_id = ids[0]
            else:
                orcamento_id = ids

            kit_item_ids = self.browse(cr, uid, orcamento_id).orccap_kit_item_ids

            for k in kit_item_ids:
                if not k.kitmov_lancado:
                    raise osv.except_osv(_('Atencao'),
                                         _('Existem produtos do Kit que ainda nao foram '
                                           'inseridos. Para inserir clique no botao '
                                           '"Inserir Kit de Item" .'))

        if estoque_parametro_id:
            estoque_parametro_dados = obj_estoque_parametro.browse(cr, uid, estoque_parametro_id[0])
            estpar_pvenda_menor_pcusto = estoque_parametro_dados.estpar_pvenda_menor_pcusto
            prazo_validade = estoque_parametro_dados.prazo_de_validade
            alterar_prazo_validade = estoque_parametro_dados.alterar_prazo_validade

            if not alterar_prazo_validade and prazo_validade:
                hoje = date.today()
                validade = timedelta(days=prazo_validade)
                hoje += validade

        for i in orcamento_dados:
            id = i['id']
            itens = i.get('orcamento_itens_ids')
            pessoa_id = i.get('pessoa_id')

            if not itens:
                orcamento_name = (orcamento_names_dict.get(id) or '').encode(
                    'utf-8') or _('** Nro Orcamento nao encontrado **')
                orcamento_sem_itens += '%s, ' % orcamento_name
            else:
                if not estpar_pvenda_menor_pcusto and estoque_parametro_id:
                    browse_orcamento_itens = obj_orcamentos_orcamento_itens.browse(
                        cr, uid, i.get('orcamento_itens_ids'))

                    for item in browse_orcamento_itens:
                        produto_name = item.produto_id.name

                        if not item.quantidade > 0:
                            itens_quantidade_valor_zero += '\n %s, \n' % _(produto_name)
                        else:
                            preco_venda = item.valor_total / item.quantidade or 0.0
                            produto_id = item.produto_id.id
                            custo_maior_precovenda = obj_estoque_preco_venda.estpve_verificar_custo_maior_pvenda(
                                cr, uid, preco_venda, produto_id,
                                [], context)

                            if custo_maior_precovenda:
                                itens_custo_maior_precovenda += '\n %s, \n' % produto_name

        if itens_quantidade_valor_zero:
            raise osv.except_osv(_('Atencao'),
                                 _('O(s) produto(s) a seguir esta(ao) com a quantidade invalida: '
                                   '%s') % itens_quantidade_valor_zero)
        if orcamento_sem_itens:
            raise osv.except_osv(_('Erro Validacao Orcamento'),
                                 _('Nenhum item encontrado nos orcamentos: %s') %
                                 orcamento_sem_itens)
        if itens_custo_maior_precovenda:
            raise osv.except_osv(_('Atencao'),
                                 _('Os produtos a seguir possuem preco de venda menor que o de '
                                   'custo: %s' % itens_custo_maior_precovenda))

        # Liberacao de desconto
        desconto_liberado = obj_orcamento_utils.orcutl_liberacao_desconto(cr, uid, ids, context)
        if not desconto_liberado:
            erro_orcamento += obj_orcamento_utils.orcutl_get_erro()

        for i in ids:
            condicoes_pgto_validas = obj_orcamento_utils.orcult_validar_condicoes_pgto(
                cr, uid, i, context)

            if not condicoes_pgto_validas:
                erro_condicao_pgto += obj_orcamento_utils.orcutl_get_erro()

        if not erro_condicao_pgto:
            erro_orcamento += erro_condicao_pgto
            orcamento_a_vista = obj_orcamento_utils.orcamento_a_vista(cr, uid, ids)

            if not orcamento_a_vista and pessoa_id:
                # Liberacao de restricao
                venda_liberada = obj_orcamento_utils.orcutl_restricao_venda(cr, uid, ids, context)

                if not venda_liberada:
                    erro_orcamento += obj_orcamento_utils.orcutl_get_erro()

        if erro_orcamento:
            raise osv.except_osv(_('Erro Validacao Orcamento'), erro_orcamento)

        vals = {'state': '2V'}

        if hoje:
            vals.update({'validade': hoje})

        res = super(orcamentos_orcamento_capa, self).write(cr, uid, ids, vals, context)

        for i in ids:
            self.message_post(cr, uid, i, _('Alteracao de Status'), _('Validado'))

        return res

    def button_aprovado(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        erro_orcamento = ''

        obj_orcamento_utils = self.pool.get('orcamento.utils')
        desconto_liberado = obj_orcamento_utils.orcutl_liberacao_desconto(cr, uid, ids, context)
        if not desconto_liberado:
            erro_orcamento = obj_orcamento_utils.orcutl_get_erro()

        for i in ids:
            cliente_id = self.browse(cr, uid, i).pessoa_id
            if not cliente_id:
                raise osv.except_osv(_('Atencao'), 'Informe o cliente para que o orcamento seja '
                                                   'aprovado.')
            condicoes_pgto_validas = obj_orcamento_utils.orcult_validar_condicoes_pgto(cr, uid, i, state='3A',
                                                                                       context=context)
            if not condicoes_pgto_validas:
                erro_orcamento += obj_orcamento_utils.orcutl_get_erro()

        if not erro_orcamento:
            orcamento_a_vista = obj_orcamento_utils.orcamento_a_vista(cr, uid, ids)
            if not orcamento_a_vista:
                venda_liberada = obj_orcamento_utils.orcutl_restricao_venda(cr, uid, ids, context)
                if not venda_liberada:
                    erro_orcamento += obj_orcamento_utils.orcutl_get_erro()
                    raise osv.except_osv(_('Erro Aprovacao Orcamento'), erro_orcamento)
        else:
            raise osv.except_osv(_('Erro Aprovacao Orcamento'), erro_orcamento)

        res = super(orcamentos_orcamento_capa, self).write(cr, uid, ids, {'state': '3A'}, context)

        for i in ids:
            self.message_post(cr, uid, i, _('Alteracao de Status'), _('Aprovado'))
        return res

    def button_cancelado(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.message_post(cr, uid, ids, _('Alteracao de Status'), _('Cancelado'))
        oservico_vendas_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(
            cr, uid, 'oservico_vendas', context={})
        if oservico_vendas_instalado:
            os_ids = self.pool.get('oservico.os').search(cr, uid,
                                                         [('osvos_orcamento_id', 'in', ids)], context=context)
            if os_ids:
                self.pool.get('oservico.os').write(cr, uid, os_ids, {'osvos_orcamento_id': False}, context)
        if context.get('orccap_cancelamento'):
            obj_model_data = self.pool.get('ir.model.data')
            reference = obj_model_data.get_object_reference(
                cr, uid, 'orcamentos', 'view_orcamentos_motivo_cancelamento_form')
            view_id = reference and reference[1] or False
            return {'res_id': ids[0],
                    'name': 'Motivo cancelamento',
                    'view_type': 'form',
                    'view_mode': 'form',
                    'res_model': 'orcamentos.orcamento.capa',
                    'view_id': [view_id],
                    'target': 'new',
                    'type': 'ir.actions.act_window',
                    }
        res = super(orcamentos_orcamento_capa, self).write(cr, uid, ids, {'state': '5C'}, context)
        return res

    def orccap_button_registra_cancelamento(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        # Grava status de cancelamento
        self.write(cr, uid, ids, {'state': '5C'}, context)
        return True

    def gerar_pdf_orcamento(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        documento = self.pool.get('orcamentos.orcamento.capa').read(cr, uid, ids[0], ['documento'], context=context)
        if isinstance(documento, list):
            documento = documento[0]
        hoje = datetime.now()
        documento = 'report.orcamento.' + documento.get('documento') + '.' + str(hoje)
        obj_ir_act_report_xml = self.pool.get('ir.actions.report.xml')
        report_id = obj_ir_act_report_xml.search(cr, uid, [('report_name', '=', 'orcamentos.orcamento.capa')],
                                                 context=context)
        report_xml = obj_ir_act_report_xml.browse(cr, uid, report_id[0])
        report_xml._data.get(report_id[0])['name'] = 'Impressao de Orcamentos'
        report_pdf = report_sxw.report_sxw(documento, 'orcamentos.orcamento.capa',
                                           'orcamentos/report/rel_impressao.rml',
                                           parser=rel_impressao_orcamento).create_single_pdf(
            cr, uid, ids, {'report_type': 'pdf'}, report_xml, context)
        return report_pdf

    def imprimir_orcamento(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        report_pdf = self.gerar_pdf_orcamento(cr, uid, ids, context=context)
        if report_pdf:
            estoque_parametros = self.pool.get('adm.utils').admutl_get_parametros(
                cr, uid, 'estoque', ['estpar_impressora_orcamento', 'estpar_vias_orcamento'],
                context=context)
            estpar_impressora_orcamento = estoque_parametros.get('estpar_impressora_orcamento')
            quantidade_vias = "-n" + str(estoque_parametros.get('estpar_vias_orcamento') or 1)
            if estpar_impressora_orcamento:
                p = open('/tmp/orcamento.pdf', 'wb')
                p.write(report_pdf[0])
                p.close()
                impressora = "-d" + estpar_impressora_orcamento
                subprocess.call(["lp", quantidade_vias, impressora, "/tmp/orcamento.pdf"])

    def button_gerado(self, cr, uid, ids, context=None):
        def _orccap_button_gerado_kit(cr, uid, ids, context):
            obj_adm_utils = self.pool.get('adm.utils')
            modulo_kit_categoria_instalado = obj_adm_utils.admutl_check_modulo_instalado(
                cr, uid, modulo='kit_categoria', context=context
            )
            fields_to_read = ['pedido_id', 'orccap_kit_item_ids']

            if modulo_kit_categoria_instalado:
                fields_to_read.append('orccap_kit_categoria_ids')
                obj_kit_categoria_mov = self.pool.get('kit.categoria.movimento')
            else:
                obj_kit_categoria_mov = None

            orcamento_dados = self.read(cr, uid, ids, fields_to_read, context=context, load=READ_LOAD)
            obj_kit_mov = self.pool.get('kit.movimento')

            for i in orcamento_dados:
                orcamento_pedido_id = i.get('pedido_id')
                orcamento_kit_item_ids = i.get('orccap_kit_item_ids')
                orcamento_kit_categoria_ids = i.get('orccap_kit_categoria_ids')
                if orcamento_kit_item_ids:
                    obj_kit_mov.write(cr, uid, orcamento_kit_item_ids, {'kitmov_pedido_id': orcamento_pedido_id}, context=context)
                if orcamento_kit_categoria_ids and obj_kit_categoria_mov:
                    obj_kit_categoria_mov.write(
                        cr, uid, orcamento_kit_categoria_ids, {'kitcatmov_pedido_id': orcamento_pedido_id}, context=context
                    )
            return True

        def _orccap_button_gerado_software(self, cr, uid, ids):
            campos = ['company_id', 'pessoa_id', 'orcamento_itens_ids', 'orcamento_condicao_ids',
                      'valor_liquido', 'valor_desconto_total', 'orcamento_tipo_software',
                      'dia_vencimento']

            dados_software = self.read(cr, uid, ids[0], campos, context=context)

            # VERIFICAR PARAMETROS
            o_par = self.pool.get('financeiro.parametros')
            args = [('company_id', '=', dados_software.get('company_id')[0])]
            par_id = o_par.search(cr, uid, args, context=context)

            if not par_id:
                company_name = dados_software.get('company_id')[1]
                msg = _('Favor cadastrar parametros financeiros para a empresa %s') % company_name
                raise osv.except_osv(_('Atencao!'), msg)

            if dados_software.get('orcamento_tipo_software'):
                obj_orcamento_itens = self.pool.get('orcamentos.orcamento.itens')
                obj_software_contratos_produtos = self.pool.get('software.contratos.produtos')
                obj_contratos_contrato = self.pool.get('contratos.contrato')
                obj_contratos_prazos = self.pool.get('contratos.prazos')
                campos = ['produto_id', 'sms']
                orcamento_item_ids = dados_software.get('orcamento_itens_ids', [])
                produto_id = obj_orcamento_itens.read(cr, uid, orcamento_item_ids, campos, context=context)
                cttprz_valor = 0.0

                for x in produto_id:
                    cttprz_valor += x['sms']

                vals_contrato = {'company_id': dados_software.get('company_id')[0], 'tipo': 'R',
                                 'pessoa_id': dados_software.get('pessoa_id')[0],
                                 'orcamento_id': dados_software.get('id'),
                                 'dia': dados_software.get('dia_vencimento')}
                contrato_id = obj_contratos_contrato.create(cr, uid, vals_contrato)

                if contrato_id:
                    dados = {'cttprz_contrato_id': contrato_id, 'cttprz_data_inicio': date.today(),
                             'cttprz_data_termino': date.today() + timedelta(days=365),
                             'cttprz_valor': cttprz_valor}
                    obj_contratos_prazos.create(cr, uid, dados, context)

                for x in produto_id:
                    dados = {'produto_id': x['produto_id'][0], 'contrato_id': contrato_id}
                    obj_software_contratos_produtos.create(cr, uid, dados, context)

                res = super(orcamentos_orcamento_capa, self).write(
                    cr, uid, ids, {'state': 'gerado'}, context)

                self.log(cr, uid, ids[0], _('Gerado Contrato'))
                return res
            else:
                return False

        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
        context.update({'orcamento_gera_pedido':True})

        if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'software', context):
            if _orccap_button_gerado_software(self, cr, uid, ids):
                return True

        kit_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'kit',
                                                                                 context)
        if kit_instalado:
            _orccap_button_gerado_kit(cr, uid, ids, context)

        if context.get('orc_soft', False):
            res = super(orcamentos_orcamento_capa, self).write(cr, uid, ids, {'state': '4G'}, context=context)

            self.message_post(cr, uid, ids, _('Alteracao de Status'), _('Gerado Contrato'))
            return res

        campos = ['company_id', 'pessoa_id', 'orcamento_itens_ids', 'orcamento_condicao_ids',
                  'valor_liquido', 'valor_desconto_total', 'valor_acrescimo_total', 'vendedor_id',
                  'vendedor_externo_id', 'condicao_pagto_id', 'observacao', 'orccap_data_entrega',
                  'orccap_vr_despesas_acessorias', 'orccap_vr_frete', 'orccap_endereco_id']
        vals = self.read(cr, uid, ids, campos, context=context)[0]

        #########################################################
        # Verificar se existe cliente cadastrado no Orcamento ###
        if not vals.get('pessoa_id'):
            raise osv.except_osv(_('Atencao'), _('Informe um cliente para o orcamento!'))

        args = [('capa_id', 'in', ids), ('aprovado', '=', True)]
        condicao_ids = self.pool.get('orcamentos.orcamento.condicao').search(cr, uid, args, context=context)
        campos = ['condicao_id', 'valor']
        condicao_forma = self.pool.get('orcamentos.orcamento.condicao').read(
            cr, uid, condicao_ids, campos, context=context)
        valor_condicao = 0.0
        condicao_forma_ids = []

        for condicoes in condicao_forma:
            valor_condicao += condicoes.get('valor')
            condicao_id = condicoes.get('condicao_id')

            if isinstance(condicao_id, (list, tuple)):
                condicao_id = condicao_id[0]
            condicao_forma_ids.append(condicao_id)

        ###################################################
        # a Condicao no Pedido esta relacionada com adm.condicao
        # depois que for alterado o pedido, excluir a linha que buscam adm.condicao.
        ########################################################
        orcamento_condicao_ids = []

        for condicao in condicao_forma_ids:
            condicao_forma_id = self.pool.get('adm.condicao.forma').read(cr, uid, condicao, ['adm_condicao_id'], context=context)[
                'adm_condicao_id']
            orcamento_condicao_ids.append((condicao_forma_id))
            #        vals['condicao_pagto_id'] = condicao_forma_id

        vals['orcamento_condicao_ids'] = orcamento_condicao_ids
        endereco_id = vals.get('orccap_endereco_id')
        if isinstance(endereco_id, (list, tuple)):
            endereco_id = endereco_id[0]

        ########################################################
        #TODO : Verificar a criacao das parcelas. e gravacaod
        if not vals['orcamento_itens_ids']:
            raise osv.except_osv(_('Atencao'), _('Nao ha Itens Para Gerar o Pedido'))
        obj_ped_itens = self.pool.get('estoquepedidos.pedido.item')
        obj_orc_itens = self.pool.get('orcamentos.orcamento.itens')
        obj_ped_cond = self.pool.get('estoquepedidos.pedido.condicao')
        orc_itens_ids = obj_orc_itens.search(cr, uid, [('orcamento_id', '=', ids)], context=context)

        if not orc_itens_ids:
            raise osv.except_osv(_('Atencao'), _('E necessario marcar algum item para gerar o pedido'))

        obj_ped_capa = self.pool.get('estoquepedidos.pedido.capa')
        pedido_vals = {
            'company_id': vals['company_id'][0],
            'orcamento_id': vals['id'],
            'pessoa_id': vals['pessoa_id'][0],
            'data_emissao': date.today(),
            'tipo': 'V',
            'vr_desconto': vals['valor_desconto_total'],
            'vr_despesas_acessorias': vals['orccap_vr_despesas_acessorias'],
            'vr_frete': vals.get('orccap_vr_frete') or 0.0,
            'vr_acrescimo': vals['valor_acrescimo_total'],
            'vr_seguro': 0.0,
            'observacao': vals['observacao'],
            'data_entrega': vals['orccap_data_entrega'],
            'pedcap_endereco_id': endereco_id
        }

        if vals.get('vendedor_id', False):
            pedido_vals['vendedor_id'] = vals['vendedor_id'][0]

        if vals.get('vendedor_externo_id', False):
            pedido_vals['vendedor_externo_id'] = vals['vendedor_externo_id'][0]

        context['orccap_nao_altera_valor'] = True
        context['permiti_gravar'] = 1
        pedido_id = obj_ped_capa.create(cr, uid, pedido_vals, context)

        if pedido_id:
            super(orcamentos_orcamento_capa, self).write(cr, uid, ids, {'pedido_id': pedido_id}, context)

        # ITENS DO ORÇAMENTO
        item_ids = vals.get('orcamento_itens_ids')

        if not item_ids:
            raise osv.except_osv(_('Atencao'), _('Nenhum item inserido no orcamento!'))
        browse_orcamento_item = self.pool.get('orcamentos.orcamento.itens').browse(cr, uid, item_ids)
        context['permiti_gravar'] = 1

        for i in browse_orcamento_item:
            local_id = i.local_id.id
            produto_id = i.produto_id.id
            grade_id = i.grade_id.id
            produto_embalagem_id = i.produto_embalagem_id.id
            if i.produto_id.tipo == 'P':
                if not produto_embalagem_id:
                    raise osv.except_osv(_('Atencao'), _('Embalagem nao cadastrada para o produto do orcamento!'))
                if not grade_id:
                    raise osv.except_osv(_('Atencao'), _('Grade nao cadastrada para o produto do orcamento!'))

            vals_pedido_item = {
                'pedido_id': pedido_id,
                'local_id': local_id,
                'produto_id': produto_id,
                'grade_id': grade_id,
                'produto_embalagem_id': produto_embalagem_id,
                'qtde_pedida': i.quantidade,
                'vr_unitario': i.valor_unitario_bruto,
                'vr_desconto': i.desconto_total,
                'pei_preco_venda': i.orcori_preco_venda,
                'observacao': i.orcori_observacao or '',
                'pedite_despesas': i.orcori_despesas,
            }

            if vals.get('vendedor_id'):
                vals_pedido_item['vendedor_id'] = vals.get('vendedor_id')[0]

            if vals.get('vendedor_externo_id'):
                vals_pedido_item['vendedor_externo_id'] = vals.get('vendedor_externo_id')[0]

            if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'madeireira', context):
                vals_pedido_item['pedite_comprimento'] = i.orcori_comprimento
                vals_pedido_item['pedite_largura'] = i.orcori_largura
                vals_pedido_item['pedite_espessura'] = i.orcori_espessura

            context['orcamento_item_id'] = i.id
            if kit_instalado:
                orcori_kit_produto_id = i.orcori_kit_produto_id
                if orcori_kit_produto_id:
                    vals_pedido_item['pedite_kit_produto_id'] = orcori_kit_produto_id.id
            obj_ped_itens.create(cr, uid, vals_pedido_item, context=context)
            # CONDIÇÕES DO ORÇAMENTO

        for forma in condicao_forma:
            condicao_forma_dados = self.pool.get('adm.condicao.forma').read(cr, uid, forma['condicao_id'][0],
                                                                            ['forma_pagamento_id'], context=context)
            if isinstance(condicao_forma_dados, list):
                condicao_forma_dados = condicao_forma_dados[0]
            forma_pagamento_id = condicao_forma_dados.get('forma_pagamento_id')
            if isinstance(forma_pagamento_id, tuple):
                forma_pagamento_id = forma_pagamento_id[0]
            pedido_condicao = obj_ped_cond.create(cr, uid, {
                'capa_id': pedido_id,
                'forma_pagto_id': forma_pagamento_id,
                'condicao_forma_id': forma['condicao_id'][0],
                'valor': forma['valor']
            }, context)

        context['gerando_pedido'] = True
        obj_ped_capa.button_parcelas(cr, uid, pedido_id, context)
        # forcei a atualizacao do pedido para que o valor total do pedido seja recalculado
        obj_ped_capa.write(cr, uid, pedido_id, {}, context)

        res = super(orcamentos_orcamento_capa, self).write(cr, uid, ids, {'state': '4G'}, context)

        obj_liberar_restricoes = self.pool.get('venlre.liberar.restricoes')
        liberar_restricoes_ids = obj_liberar_restricoes.search(cr, uid, [('venlre_orcamento_id', 'in', ids)])
        if liberar_restricoes_ids and pedido_id:
            obj_liberar_restricoes.write(
                cr, uid, liberar_restricoes_ids, {'venlre_pedido_id': pedido_id}, context
            )

        obj_ped_capa.write(cr, uid, pedido_id, {'data_emissao': date.today(), 'valor_total': valor_condicao}, context)
        self.message_post(cr, uid, ids, _('Alteracao de Status'), _('Gerado'))
        autorizacao_capa_id = self.pool.get('vendas.liberar.desconto').search(cr, uid,
                                                                              [('venauv_orcamento_id', '=', ids[0])],
                                                                              context=context)
        if autorizacao_capa_id:
            vals_autorizacao = {
                'venauv_pedido_id': pedido_id,
            }
            self.pool.get('vendas.liberar.desconto').write(cr, uid, autorizacao_capa_id, vals_autorizacao, context)

        if res:
            return self.button_abrir_pedido(cr, uid, ids, context)
        else:
            return res

    def button_calcular_condicoes(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = True

        # ATUALIZA O REGISTRO DA CAPA

        res = True

        # ATUALIZA O REGISTRO DA CAPA
        self.orccap_button_salvar(cr, uid, ids)

        if isinstance(ids, (int, long)):
            orcamento_ids = [ids]
        else:
            orcamento_ids = ids

        # OBJETOS
        obj_orcamento_condicao = self.pool.get('orcamentos.orcamento.condicao')
        orc_condicoes_ids = obj_orcamento_condicao.search(cr, uid, [('capa_id', 'in', orcamento_ids)], context=context)
        if orc_condicoes_ids:
            obj_orcamento_condicao.unlink(cr, uid, orc_condicoes_ids)
            orc_condicoes_ids = []

        # SE O ORCAMENTO NÃO POSSUIR CONDIÇÕES CADASTRAS, IRÁ BUSCA AS CONDIÇÕES DO PARAMETRO DO ESTOQUE
        if not orc_condicoes_ids:
            res = False

            # OBJETO
            obj_estoque_parametro = self.pool.get('estoque.parametro')
            obj_parametro_condicoes = self.pool.get('estoque.param.condicoes')
            obj_adm_condicao_forma = self.pool.get('adm.condicao.forma')

            company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'orcamentos.orcamento.capa',
                                                                        context=context)
            parametro_ids = obj_estoque_parametro.search(cr, uid, [('company_id', '=', company_id)], context=context)
            if not parametro_ids:
                osv.except_osv(_('Atencao'), _('Nenhum parametro do estoque encontra-se cadastrado para a Empresa'))
            else:
                parametro_id = parametro_ids[0]
                parametro_condicao_ids = obj_parametro_condicoes.search(cr, uid, [('parametro_id', '=', parametro_id)],
                                                                        context=context)
                if not parametro_condicao_ids:
                    raise osv.except_osv(
                        _('Atencao'),
                        _('Nenhuma condicao de pagamento encontra-se cadastrada no parametro do estoque para a Empresa')
                    )
                else:
                    # BUSCA A CONDIÇAO E A FORMA DE PAGAMENTO DAS CONDIÇÕES DO PARAMETRO
                    parametro_condicao_dados = obj_parametro_condicoes.read(
                        cr, uid, parametro_condicao_ids, ['condicao_id', 'forma_pagto_id'], context=context
                    )

                    condicao_ids = filter(
                        None,
                        map(lambda i: i.get('condicao_id') and i['condicao_id'][0] or False, parametro_condicao_dados)
                    )

                    condicao_acres_desc = {}
                    if condicao_ids:
                        # PARA CADA CONDIÇÃO, BUSCA O ACRESCIMO E DESCONTO CADASTRADO NELA
                        # TODO: ACRESCIMO E DESCONTO AINDA NÃO ESTAO IMPLEMENTADOS, MAS O TRATAMENTO JA EXISTE NO CODIGO
                        condicao_dados = obj_adm_condicao_forma.read(
                            cr, uid, condicao_ids, ['acrescimo', 'desconto'], context=context
                        )
                        for i in condicao_dados:
                            id = i['id']
                            acrescimo = i.get('acrescimo') or 0
                            desconto = i.get('desconto') or 0

                            condicao_acres_desc[id] = (acrescimo, desconto)

                    orcamento_dados = self.read(cr, uid, orcamento_ids, ['valor_liquido'], context=context)
                    for orc in orcamento_dados:
                        orc_id = orc['id']
                        orc_valor_liquido = orc.get('valor_liquido') or 0

                        # CRIA AS CONDIÇÕES DE ACORDO COM O PARAMETRO DO ESTOQUE.
                        for i in parametro_condicao_dados:
                            condicao_id = i.get('condicao_id') and i['condicao_id'][0] or False
                            forma_pgto_id = i.get('forma_pagto_id') and i['forma_pagto_id'][0] or False

                            condicao_acres, condidcao_desc = condicao_acres_desc.get(condicao_id) or (0, 0)

                            valor_acrescimo = orc_valor_liquido * condicao_acres / 100
                            valor_desconto = orc_valor_liquido * condidcao_desc / 100

                            valor_total = orc_valor_liquido + valor_acrescimo - valor_desconto

                            values = {
                                'capa_id': orc_id,
                                'forma_pagto_id': forma_pgto_id,
                                'condicao_id': condicao_id,
                                'valor': valor_total
                            }

                            obj_orcamento_condicao.create(cr, uid, values, context)
                            res = True
        return res

    def orccap_button_salvar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = super(orcamentos_orcamento_capa, self).write(cr, uid, ids, {}, context)
        return res

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if context.get('__copy_data_seen'):
            if vals.get('pedido_id'):
                del vals['pedido_id']
        vals['documento'] = self.pool.get('adm.utils').get_sequence(cr, uid, self._name, 'orcamento.capa.documento')
        ## verificacao feita em caso de duplicacao do registro
        if vals.get('valor_desconto_total') and vals.get('orcamento_itens_ids'):
            itens = vals['orcamento_itens_ids'][0][2]
            itens = [itens]
            val_total = sum(map(lambda i: (i.get('valor_unitario_bruto') or i.get('orcori_preco_venda') or 0) * (
                i.get('quantidade') or 0) - (i.get('desconto_total') or 0), itens))
            if vals['valor_desconto_total'] > val_total:
                raise osv.except_osv(_('Atencao'), _('Valor do desconto superior ao valor total!'))

        orcamento_capa_id = super(orcamentos_orcamento_capa, self).create(cr, uid, vals, context)

        self.pool.get('adm.transacao.capa').admtrc_criar_transacao(cr, uid, 'orca', orcamento_capa_id, context=None)
        if orcamento_capa_id:
            orcamento_capa_dados = self.read(cr, uid, orcamento_capa_id, ['orcamento_itens_ids'],
                                             context=context)
            self.pool.get('orcamentos.orcamento.itens').orcori_check_preco_venda(
                cr, uid, orcamento_capa_dados.get('orcamento_itens_ids'), context)
        return orcamento_capa_id

    def unlink(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        raise osv.except_osv(_('Atencao'), _('Nao e permitido excluir um orcamento, apenas cancelar.'))

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}

        if ids and isinstance(ids, (int, long)):
            ids = [ids]

        dados_orcamento_capa = self.read(cr, uid, ids, ['state', 'valor_desconto_total'], context=context)

        if dados_orcamento_capa and isinstance(dados_orcamento_capa, list):
            dados_orcamento_capa = dados_orcamento_capa[0]

        if dados_orcamento_capa and isinstance(dados_orcamento_capa,dict):
            state = dados_orcamento_capa.get('state')
        else:
            state = ''

        # Tratamento apenas para kanban
        if context.get('contexto_orcamentos', False) and vals.get('state', False):
            if ((state == '1E' and vals.get('state') not in ('2V', '5C')) or
                    (state == '4G') or (state == '5C') or
                    (state == '2V' and vals.get('state') not in ('1E', '5C', '3A')) or
                    (state == '3A' and vals.get('state') not in ('1E', '4G', '5C'))):

                raise osv.except_osv(_('Atencao'),
                                     _('Esta mudanca nao e permitida!'))
            else:
                context.pop('contexto_orcamentos')
                if vals.get('state') == '1E':
                    self.button_esboco(cr, uid, ids)
                if vals.get('state') == '2V':
                    self.button_validado(cr, uid, ids)
                if vals.get('state') == '3A':
                    self.button_aprovado(cr, uid, ids)
                if vals.get('state') == '4G':
                    self.button_gerado(cr, uid, ids)
                if vals.get('state') == '5C':
                    self.button_cancelado(cr, uid, ids)
                return True

        if state == '4G':
            if not 'state' in vals:
                raise osv.except_osv(_('Atencao'),
                                     _('Ja foi Gerado um Pedido p/ este Orcamento. Nao pode alterar!'))
        elif state == '5C':
            if not 'state' in vals:
                raise osv.except_osv(_('Atencao'), _('Orcamento cancelado. Nao pode alterar.'))
        elif state != '1E':
            if 'orcamento_itens_ids' in vals:
                raise osv.except_osv(_('Atencao'), _('So pode alterar itens no estado de Esboco'))

        if vals.get('valor_desconto_total'):
            context['orccap_valor_com_desconto'] = True
        else:
            context['orccap_nao_alterar_total'] = True

        if 'valor_liquido' in vals and vals.get('valor_liquido') < 0:
            raise osv.except_osv(_('Atencao'), _('Valor do desconto superior ao valor total!'))

        result = super(orcamentos_orcamento_capa, self).write(cr, uid, ids, vals, context)

        if result and ids:
            orcamento_capa_dados = self.read(cr, uid, ids, ['orcamento_itens_ids'], context=context)
            for orcamento in orcamento_capa_dados:
                self.pool.get('orcamentos.orcamento.itens').orcori_check_preco_venda(
                    cr, uid, orcamento.get('orcamento_itens_ids'), context)

        return result

    def orccap_onchange_vr_despesas_acessorias(self, cr, uid, ids, itens, despesas, context=None):
        context = context and context.copy() or {}
        res = {'value': {}}
        if not itens:
            res['orccap_vr_despesas_acessorias'] = 0
            res['warning'] = {'title':   _('Atencao!'),
                              'message': _('Nenhum item selecionado para rateio das despesas!')}
            return res

        res['value'] = self.pool.get('orcamentos.orcamento.itens').orcori_ratear_despesa_itens(cr,
                                                                      uid, itens, despesas, context)
        return res

    def _orccap_calcula_total_orcamento(self, cr, uid, ids, values, context=None):
        """
        Calcula o total do orcamento em funcao do valor total dos itens e do valor total do
        desconto.

        :param cr: a linha atual do cursor do banco de dados
        :param uid: ID do usuario utilizado para a verificacao de perfil
        :param ids: lista dos IDs
        :param values: dicionario com o nome dos campos e seus respectivos valores
        :param context: um dicionario padrao para valores contextuais
        :type cr: cursor
        :type uid: int
        :type ids: long|list[long]
        :type values: dict
        :type context: dict
        :return: dicionario com o valor liquido (total do orcamento).
        :rtype: dict

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}
        valor_desconto_total, valor_despesas_acessorias = 0, 0
        valor_frete = 0
        campos = ['valor_desconto_total', 'orcamento_itens_ids', 'orccap_vr_despesas_acessorias',
                  'orccap_vr_frete']
        dados_orcamento = self.read(cr, uid, ids, campos, context=context)

        if dados_orcamento and isinstance(dados_orcamento, list):
            dados_orcamento = dados_orcamento[0]

        if dados_orcamento and isinstance(dados_orcamento, dict):
            valor_desconto_total += values.get('valor_desconto_total',
                                               dados_orcamento.get('valor_desconto_total', 0))
            valor_frete = values.get('orccap_vr_frete', dados_orcamento.get('orccap_vr_frete') or 0)

        valor_itens_total = total_despesas = 0
        itens = filter(lambda x: x[0] in (0,1,4), values.get('orcamento_itens_ids') or [])
        for i in self.resolve_2many_commands(cr, uid, 'orcamento_itens_ids', itens,
                                        ['valor_total', 'orcori_despesas'], context=context):
            valor_itens_total += i.get('valor_total') or 0.0
            total_despesas += i.get('orcori_despesas')

        if valor_itens_total <= 0:
            valor_desconto_total = 0
        valor_liquido = round(valor_itens_total, 2) + total_despesas - valor_desconto_total + \
                        valor_frete
        result = {'valor_liquido': valor_liquido,
                  'orccap_vr_despesas_acessorias': total_despesas}
        return result

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        if not args:
            args = []
        context = context and context.copy() or {}
        if context.get('state_filter', False):
            st = []
            state = []
            cont = 0
            try:
                while cont != len(args):
                    if args[cont][0] == 'state':
                        st.append(args[cont][2])
                        args.pop(cont)
                        if cont > 0:
                            if args[cont - 1] == '|':
                                args.pop(cont - 1)
                                cont -= 1
                    else:
                        cont += 1
                if st:
                    # MONTA O ARGUMENTO ['state','in','valores']
                    state.append("state")
                    state.append("in")
                    state.append(st)
                    # CONVERTE state PARA UMA TUPLA > ('state','in','valores') < E ACRESCENTA EM args
                    args.append(tuple(state))
            except IndexError:
                raise osv.except_osv(_('Atencao'),
                                     _('Ocorreu um erro ao tentar acessar um indice na lista, indice inexistente'))
        res = super(orcamentos_orcamento_capa, self).search(cr, uid, args, offset, limit, order, context, count)
        return res

    def onchange_orcamento_itens(self, cr, uid, ids, orcamento_item_ids, context=None):
        """
        Atualiza o total do orcamento em funcao do valor total dos itens

        @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}

        if ids and isinstance(ids, (int, long)):
            ids = [ids]

        values = {'orcamento_itens_ids': orcamento_item_ids}
        return {'value': self._orccap_calcula_total_orcamento(cr, uid, ids, values, context)}

    def total_orcamento_itens(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        total_itens = 0
        if ids:
            if isinstance(ids, (int, long)):
                ids = [ids]
            obj_orcamento_itens = self.pool.get('orcamentos.orcamento.itens')
            orcamento_item_ids = obj_orcamento_itens.search(cr, uid, [('orcamento_id', 'in', ids)], context=context)
            if orcamento_item_ids:
                orcamento_item_dados = obj_orcamento_itens.read(cr, uid, orcamento_item_ids, ['valor_total'], context=context) or [{}]
                total_itens = sum(map(lambda i: i.get('valor_total') or 0, orcamento_item_dados))
        return total_itens

    def onchange_percentual_desconto_capa(self, cr, uid, ids, percentual_desconto, context=None):
        context = context and context.copy() or {}
        res = {}
        if percentual_desconto < 0:
            return {'value': {'percentual_desconto': 0},
                    'warning': {'title': _('Atencao'), 'message': _('Desconto invalido')}}
        total_itens = self.total_orcamento_itens(cr, uid, ids, context=context)
        valor_desconto_total = total_itens * percentual_desconto / 100
        res.update({'valor_desconto_total': valor_desconto_total})
        return {'value': res}

    def onchange_desconto_total_capa(self, cr, uid, ids, valor_desconto_total, itens, context=None):
        """
        Atualiza o total do orcamento em funcao do desconto.
        """

        context = context and context.copy() or {}
        if valor_desconto_total < 0:
            return {'value': {'valor_desconto_total': 0},
                    'warning': {'title': _('Atencao'), 'message': _('Desconto invalido')}}

        if ids and isinstance(ids, (int, long)):
            ids = [ids]

        values = {'valor_desconto_total': valor_desconto_total,
                  'orcamento_itens_ids': itens}
        result = {'value': self._orccap_calcula_total_orcamento(cr, uid, ids, values, context)}

        return result

    def orccap_onchange_valor_frete(self, cr, uid, ids, valor_frete, itens, context=None):
        """
        Atualiza o total do orcamento em funcao do frete.
        """

        context = context and context.copy() or {}
        if valor_frete < 0:
            return {'value': {'orccap_vr_frete': 0},
                    'warning': {'title': _('Atencao'), 'message': _('Valor de frete invalido')}}

        if ids and isinstance(ids, (int, long)):
            ids = [ids]
        dict_total_orcamento = self._orccap_calcula_total_orcamento(cr, uid, ids,
                                                            {'orcamento_itens_ids': itens}, context)
        dict_total_orcamento['valor_liquido'] += valor_frete
        result = {'value': dict_total_orcamento}

        return result

    def onchange_cliente_orcamento(self, cr, uid, ids, pessoa_id, context=None):
        """
        Metodo para buscar o vendedor cadastrado para o cliente, se houver.
        """
        context = context and context.copy() or {}
        res = {'observacao_pessoa': None, 'orccap_endereco_id': False}
        obj_financeiro_cliente = self.pool.get('financeiro.cliente')
        obj_adm_empresa_objeto = self.pool.get('adm.empresa.objeto')
        warning = {}
        if pessoa_id:
            cliente_id = obj_financeiro_cliente.search(cr, uid, [('pessoa_id', '=', pessoa_id)], context=context)
            if cliente_id:
                cliente_dados = obj_financeiro_cliente.read(cr, uid, cliente_id,
                                                            ['vendedor_id', 'vendedor_externo_id'], context=context)
                for i in cliente_dados:
                    if i.get('vendedor_id'):
                        vendedor_id = i.get('vendedor_id')
                        if isinstance(vendedor_id, tuple):
                            vendedor_id = vendedor_id[0]
                        res['vendedor_id'] = vendedor_id
                    if i.get('vendedor_externo_id'):
                        vendedor_externo_id = i.get('vendedor_externo_id')
                        if isinstance(vendedor_externo_id, tuple):
                            vendedor_externo_id = vendedor_externo_id[0]
                        res['vendedor_externo_id'] = vendedor_externo_id
            dados_pessoa = self.pool.get('adm.pessoa').read(
                cr, uid, pessoa_id, ['nome', 'endereco_nf_id', 'endereco_ids'], context=context)
            obj_financeiro = self.pool.get('financeiro')
            observacao_cliente = obj_financeiro.\
                    finutl_observacao_cliente(cr, uid, pessoa_id, context=context)
            res['observacao_pessoa'] = observacao_cliente.get(pessoa_id)
            if isinstance(dados_pessoa, list):
                dados_pessoa = dados_pessoa[0]
            company_id = obj_adm_empresa_objeto.getEmpresa(cr, uid, self._name, context=context)
            is_cliente = obj_financeiro_cliente.verificar_incluir_cliente(
                cr, uid, pessoa_id, company_id, 'incluir', context=context)
            if is_cliente:
                pessoa_com_restricao = self.pool.get('financeiro').\
                    finutl_verificar_restricao_cliente(cr, uid, finutl_pessoa_id=pessoa_id,
                                                       context=context)
                if pessoa_com_restricao:
                    warning['title'] = _('Atencao')
                    warning['message'] = _('Cliente possui restricoes de venda.')
            else:
                warning['title'] = _('Atencao')
                warning['message'] = _('%s nao e um cliente.' % dados_pessoa.get('nome'))
                res['pessoa_id'] = False

            if dados_pessoa:
                id_end = False
                endereco_id = dados_pessoa.get('endereco_nf_id')
                if isinstance(endereco_id, (list, tuple)):
                    id_end = endereco_id[0]
                else:
                    endereco_ids = dados_pessoa.get('endereco_ids')
                    if endereco_ids:
                        id_end = endereco_ids[0]
                res['orccap_endereco_id'] = id_end
        return {'value': res, 'warning': warning}

    def fields_view_get(self, cr, uid, view_id=None, view_type='form', context=None, toolbar=False,
                        submenu=False):
        context = context and context.copy() or {}
        res = super(orcamentos_orcamento_capa, self).fields_view_get(cr, uid, view_id, view_type,
                                                                     context, toolbar, submenu)
        obj_ir_translation = self.pool.get('ir.translation')
        translation_id = obj_ir_translation.search(
            cr, uid, [('src', '=', 'Impressao de Orcamentos'), ('module', '=', 'madeireira')], context=context)
        if translation_id:
            obj_ir_translation.write(cr, uid, translation_id[0],
                                     {'value': 'Impressao de Orcamentos',
                                      'source': 'Impressao de Orcamentos'}, context=context)
        return res

    def orccap_button_imprimir(self, cr, uid, ids, context=None):
        """
        O metodo imprime o orcamento.
        :param cr: cursor no banco de dados.
        :type cr: cursor
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista com o id da tabela desse objeto.
        :type ids: list
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: dicionario com acao para chamada da classe do relatorio.
        :rtype: dict
        """

        dados_parametro = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', ['estpar_orcamento_formato_impressao',
                                 'estpar_orcamento_retrato_paisagem'])
        formato = dados_parametro.get('estpar_orcamento_formato_impressao')
        modo = dados_parametro.get('estpar_orcamento_retrato_paisagem')
        path = '/orcamentos/report/rel_impressao.rml'
        self.pool.get('estoque.parametro').estpar_converte_formato_impressao(cr, uid, formato, path,
                                                                             'o', modo)

        if isinstance(ids, (list, tuple)):
            ids = ids[0]
        return {
                'type': 'ir.actions.report.xml',
                'report_name': 'orcamentos.orcamento.capa',
                'name': self.browse(cr, uid, ids, context).documento,
        }


class rel_impressao_orcamento(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context=None):
        from openerp import pooler
        context = context and context.copy() or {}
        super(rel_impressao_orcamento, self).__init__(cr, uid, name, context)

        obj_adm_utils = pooler.get_pool(cr.dbname).get('adm.utils')
        obj_orcamentos_orcamento_capa = pooler.get_pool(cr.dbname).get('orcamentos.orcamento.capa')
        parametros = ['estpar_descricao_grade']
        estoque_parametros = obj_adm_utils.admutl_get_parametros(cr, uid, 'estoque', parametros,
                                                                 context=context)

        def orcamento_descricao_item(brw_produto, brw_grade):
            descricao = brw_grade.descricao
            if estoque_parametros.get('estpar_descricao_grade') == 'P':
                descricao = '%s %s' % (brw_produto.name, brw_grade.descricao)
            return descricao

        self.localcontext.update({
            'getNumeroEditado': self.pool.get('adm.utils').admutl_get_valor_formatado,
            'int': int,
            'orcamento_descricao_item': orcamento_descricao_item,
            'data_emissao': obj_adm_utils.admutl_datetime_to_timezone(
                cr, uid, parse(obj_orcamentos_orcamento_capa.read(
                    cr, uid, context.get('active_id'), ['create_date'],
                    context).get('create_date')), '%d/%m/%Y %H:%M:%S')
        })
        self.context = context
