# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from SigUtils.numero import getNumeroEditado
from openerp.tools.translate import _


class orcamentos_orcamento_condicao(osv.Model):
    _name = 'orcamentos.orcamento.condicao'
    _inherit = 'orcamentos.orcamento.condicao'

    def button_aprovar_condicao(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        orc_capa_id = self.pool.get('orcamentos.orcamento.capa').search(cr, uid, [('orcamento_condicao_ids', '=', ids)], context=context)
        fields_to_read = ['state', 'orcamento_condicao_ids', 'valor_liquido']
        orc_capa_dados = self.pool.get('orcamentos.orcamento.capa').read(cr, uid, orc_capa_id,
                                                                         fields_to_read, context=context)
        if orc_capa_dados and isinstance(orc_capa_dados, list):
            orc_capa_dados = orc_capa_dados[0]
        orc_cond_ids = 0
        if orc_capa_dados and isinstance(orc_capa_dados, dict):
            orc_cond_ids = orc_capa_dados['orcamento_condicao_ids']
            orc_capa_state = orc_capa_dados['state']
            if orc_capa_state in ('3A', '4G', '5C'):
                raise osv.except_osv(_('Atencao'), _(
                    'Nao e permitido aprovar outra condicao de pagamento no estado que o orcamento se encontra'))
        soma_valor_cond_ativa = 0
        for cond_id in orc_cond_ids:
            dados_cond = self.pool.get('orcamentos.orcamento.condicao').browse(cr, uid, cond_id, context=context)
            if dados_cond.aprovado:
                soma_valor_cond_ativa += dados_cond.valor
        cond_atual_id = self.pool.get('orcamentos.orcamento.condicao').browse(cr, uid, ids, context=context)[0]
        valor = cond_atual_id.valor or 0.0
        if not valor or valor < 0:
            raise osv.except_osv(_('Atencao'), _('Informe um valor para a condicao de pagamento'))
        if round(soma_valor_cond_ativa + valor, 2) <= round(orc_capa_dados['valor_liquido'], 2):
            res = self.write(cr, uid, ids, {'aprovado': True}, context)
            return res
        raise osv.except_osv(_('Atencao'),
                             _('O valor da soma das formas de pagamento deve ser igual ao valor total do orcamento!'))

    def button_cancelar_condicao(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        orc_capa_id = self.pool.get('orcamentos.orcamento.capa').search(cr, uid, [('orcamento_condicao_ids', '=', ids)], context=context)
        orc_capa_dados = self.pool.get('orcamentos.orcamento.capa').read(cr, uid, orc_capa_id,
                                                                         ['state'], context=context)
        if orc_capa_dados and isinstance(orc_capa_dados, list):
            orc_capa_dados = orc_capa_dados[0]
        if orc_capa_dados and isinstance(orc_capa_dados, dict):
            orc_capa_state = orc_capa_dados['state']
            if orc_capa_state in ('3A', '4G', '5C'):
                raise osv.except_osv(_('Atencao'), _(
                    'Nao e permitido cancelar uma condicao de pagamento no estado que o orcamento se encontra'))
        res = self.write(cr, uid, ids, {'aprovado': False}, context)
        return res

    def onchange_forma_pagamento(self, cr, uid, ids, forma_pagto_id, context=None):
        context = context and context.copy() or {}
        res = {'condicao_id': None}
        if forma_pagto_id:
            ids_adm_condicao_forma = self.pool.get('adm.condicao.forma').search(cr, uid, [
                ('forma_pagamento_id', '=', forma_pagto_id)], context=context)
            if len(ids_adm_condicao_forma) == 1:
                condicao_id = ids_adm_condicao_forma
                if isinstance(condicao_id, list):
                    condicao_id = condicao_id[0]
                res['condicao_id'] = condicao_id
        return {'value': res}

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if context.get('__copy_data_seen'):
            if vals.get('aprovado'):
                vals['aprovado'] = False
        res = super(orcamentos_orcamento_condicao, self).create(cr, uid, vals, context)
        return res

