# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
# noinspection PyProtectedMember
from openerp.tools.translate import _


# noinspection PyAbstractClass,PyPep8Naming
class orcamentos_padrao_capa(osv.Model):
    _name = 'orcamentos.padrao.capa'
    _inherit = 'orcamentos.padrao.capa'

    def button_gera_orcamento(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_orc = self.pool.get('orcamentos.orcamento.capa')
        obj_orc_padrao = self.pool.get('orcamentos.padrao.capa')
        obj_orc_padrao_itens = self.pool.get('orcamentos.padrao.itens')
        obj_orc_itens = self.pool.get('orcamentos.orcamento.itens')
        orcamentos_padrao_capa_dados = obj_orc_padrao.read(cr, uid, ids, ['company_id'],
                                                           context=context)
        # Verifica se alguma empresa foi escolhida
        company_id = False
        for x in orcamentos_padrao_capa_dados:
            company_id = x.get('company_id')
            if isinstance(company_id, tuple):
                company_id = company_id[0]
            break
            # Verificando as empresas escolhidas sao identicas
        for orcamento_padrao in orcamentos_padrao_capa_dados:
            empresa_id = orcamento_padrao.get('company_id')
            if isinstance(empresa_id, tuple):
                empresa_id = empresa_id[0]
            if empresa_id != company_id:
                raise osv.except_osv(
                    _('Atencao'), _('Escolha a mesma empresa para gerar orcamento.'))
            # Gerando o orcamento a partir do padrao
        orc_id = False
        if company_id:
            orc_id = obj_orc.create(cr, uid, {'company_id': company_id}, context)

        # Gravando os itens para o orcamento gerado lendo do orcamento padrao
        id_padrao_itens = obj_orc_padrao_itens.search(cr, uid, [('orcamento_id', 'in', ids)],
                                                      context=context)
        padrao_itens = obj_orc_padrao_itens.read(cr, uid, id_padrao_itens, [], context=context)
        # Verifica se existe item
        if padrao_itens:
            for itens in padrao_itens:
                if itens.get('produto_embalagem_id'):
                    produto_embalagem_id = itens.get('produto_embalagem_id')
                    if isinstance(produto_embalagem_id, tuple):
                        produto_embalagem_id = produto_embalagem_id[0]
                else:
                    produto_embalagem_id = False
                if itens.get('grade_id'):
                    grade_id = itens.get('grade_id')
                    if isinstance(grade_id, tuple):
                        grade_id = grade_id[0]
                else:
                    grade_id = False
                if itens.get('local_id'):
                    local_id = itens.get('local_id')
                    if isinstance(local_id, tuple):
                        local_id = local_id[0]
                else:
                    local_id = False
                if itens.get('produto_id'):
                    produto_id = itens.get('produto_id')
                    if isinstance(produto_id, tuple):
                        produto_id = produto_id[0]
                else:
                    produto_id = False

                # calculo valor unitario
                preco_venda = self.pool.get('estoque.preco.venda').get_preco_venda(
                    cr, uid, produto_id, epc_grade_ids=grade_id or [], epc_company_id=company_id)
                dados_preco_venda = preco_venda.get(produto_id) or {}
                vl_produto_unit = dados_preco_venda.get(grade_id) or dados_preco_venda.get(
                    'preco_venda')

                # calcular valor total
                estoque_produto_embalagem_dados = self.pool.get('estoque.produto.embalagem').\
                    read(cr, uid, [produto_embalagem_id], ['embalagem_id'], context=context)
                emb_id = False
                for x in estoque_produto_embalagem_dados:
                    emb_id = x.get('embalagem_id')
                    if isinstance(emb_id, tuple):
                        emb_id = emb_id[0]
                estoque_embalagem_dados = self.pool.get('estoque.embalagem'). \
                    read(cr, uid, [emb_id], ['quantidade_na_embalagem'], context=context)
                qt_emb = False
                for x in estoque_embalagem_dados:
                    qt_emb = x.get('quantidade_na_embalagem')

                    # calcular valor Unitario * embalagem
                vl_unit = qt_emb * vl_produto_unit

                # calcular valor Total dos produtos
                vl_total = vl_unit * itens.get('quantidade')

                # Resultado operacao
                vals = {
                    'orcamento_id': orc_id,
                    'quantidade': itens.get('quantidade'),
                    'produto_embalagem_id': produto_embalagem_id,
                    'grade_id': grade_id,
                    'local_id': local_id,
                    'produto_id': produto_id,
                    'valor_unitario_bruto': vl_unit,
                    'valor_total': vl_total,
                    'orcori_preco_venda': vl_produto_unit
                }
                # Gravando os itens
                obj_orc_itens.create(cr, uid, vals, context)
        if not orc_id:
            raise osv.except_osv(_('Atencao'),
                                 _('Erro ao gerar orcamento. Dados do orcamento padrao pode estar '
                                   'incompleto.'))
        obj_model_data = self.pool.get('ir.model.data')
        reference = obj_model_data.get_object_reference(
            cr, uid, 'orcamentos', 'view_orcamentos_orcamento_capa_form')
        view_id = reference and reference[1] or False
        return {
            'res_id': orc_id,
            'name': _('Orcamento'),
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'orcamentos.orcamento.capa',
            'view_id': view_id,
            'type': 'ir.actions.act_window',
        }
