# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler
from openerp.tools.translate import _


class orcamentos_padrao_itens(osv.Model):
    _name = 'orcamentos.padrao.itens'
    _inherit = 'orcamentos.padrao.itens'

    def default_get(self, cr, uid, fields, context=None):
        context = context and context.copy() or {}
        obj_estoque_parametro = self.pool.get('estoque.parametro')
        res = super(orcamentos_padrao_itens, self).default_get(cr, uid, fields, context=context)
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
        local_venda_padrao_id = None
        estoque_parametro_ids = obj_estoque_parametro.search(cr, uid, [('company_id', '=', company_id)], context=context)
        if estoque_parametro_ids:
            estoque_parametro_dados = obj_estoque_parametro.read(cr, uid, estoque_parametro_ids,
                                                                 ['local_venda_padrao_id'], context=context)
            for x in estoque_parametro_dados:
                local_venda_padrao_id = x.get('local_venda_padrao_id')
                if isinstance(local_venda_padrao_id, tuple):
                    local_venda_padrao_id = local_venda_padrao_id[0]
        if local_venda_padrao_id:
            res['local_id'] = local_venda_padrao_id
        return res

    def get_local_embalagem(self, cr, uid, company_id, local_id, produto_id, grade_id, context=None):
        context = context and context.copy() or {}
        produto_embalagem_id = False
        obj_local_locacao = self.pool.get('estoque.local.locacao')
        local_locacao_ids = obj_local_locacao.search(cr, uid, [('company_id', '=', company_id),
                                                               ('local_id', '=', local_id),
                                                               ('produto_id', '=', produto_id),
                                                               ('grade_id', '=', grade_id)], context=context)
        if local_locacao_ids:
            local_locacao_id = local_locacao_ids[0]
            local_locacao_dados = obj_local_locacao.read(cr, uid, local_locacao_id, ['estllc_produto_embalagem_id'],
                                                         context=context)
            if isinstance(local_locacao_dados, list) and local_locacao_dados:
                local_locacao_dados = local_locacao_dados[0]
            if isinstance(local_locacao_dados, dict):
                produto_embalagem_id = local_locacao_dados.get('estllc_produto_embalagem_id') and \
                                       local_locacao_dados['estllc_produto_embalagem_id'][0]
                if produto_embalagem_id:
                    return produto_embalagem_id
        produto_embalagem_ids = self.pool.get('estoque.produto.embalagem').search(cr, uid,
                                                                                  [('produto_id', '=', produto_id)],
                                                                                  context=context)
        if produto_embalagem_ids and len(produto_embalagem_ids) == 1:
            produto_embalagem_id = produto_embalagem_ids[0]
        return produto_embalagem_id

    def onchange_produto(self, cr, uid, ids, produto_id, local_id, company_id, context=None):
        # OBSERVAÇÃO - HEYYY VOCCCCE
        # **********************************************************************
        # Esta funcao tem heranca no modulo software, quando alterar essa funcao
        # verificar se nao dá problema na chamada pelo mod. software
        context = context and context.copy() or {}
        warning = {}
        value = {}
        if produto_id:
            # verificando o preco de venda do produto
            preco_venda = self.pool.get('estoque.preco.venda').get_preco_venda(
                cr, uid, produto_id, epc_company_id=company_id)
            dados_preco_venda = preco_venda.get(produto_id) or {}
            preco_venda = dados_preco_venda.get('preco_venda')
            if not preco_venda:
                warning = {
                    'title': _('Atencao'),
                    'message': _('Nao ha Preco de Venda cadastrado para o produto')
                }
            grade_id = self.pool.get('estoque.produto.grade').search(cr, uid, [('produto_id', '=', produto_id)],
                                                                     context=context)
            if len(grade_id) == 1:
                value['grade_id'] = grade_id[0]
                produto_embalagem_id = self.get_local_embalagem(cr, uid, company_id, local_id, produto_id, grade_id[0])
                if produto_embalagem_id:
                    value['produto_embalagem_id'] = produto_embalagem_id
            else:
                value['grade_id'] = None

        return {'value': value, 'warning': warning}


