#!/usr/bin/python
# -*- coding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _
from decimal import Decimal, ROUND_UP


class orcamento_utils(osv.Model):
    _name = 'orcamento.utils'
    _auto = False
    _tem_erro = False
    _mensagem_erro = ''

    def orcutl_get_erro(self):
        return self._mensagem_erro

    def orcutl_get_orcamento_names(self, cr, uid, orcamento_ids, context=None):
        # NAME DOS ORCAMENTO_IDS
        context = context and context.copy() or {}
        res_name_get = self.pool.get('orcamentos.orcamento.capa').name_get(cr, uid, orcamento_ids, context) or [
            ('', '')]
        return dict(res_name_get)

    def orcutl_get_orcamento_valor_bruto_itens(self, cr, uid, orcamento_id, context=None):
        context = context and context.copy() or {}
        browse_orcamento = self.pool.get('orcamentos.orcamento.capa').browse(cr, uid, orcamento_id, context)
        RECORD_ORC_ITENS = browse_orcamento.orcamento_itens_ids
        total_itens = sum(map(lambda i: i.valor_total + i.desconto_total, RECORD_ORC_ITENS) or []) or 0
        orc_desconto = browse_orcamento.valor_desconto_total or 0

        total_orcamento = total_itens + orc_desconto
        return total_orcamento

    def orcamento_a_vista(self, cr, uid, orcamento_id):
        if isinstance(orcamento_id, list):
            orcamento_id = orcamento_id[0]
        res = False
        browse_orcamento = self.pool.get('orcamentos.orcamento.capa').browse(cr, uid, orcamento_id)
        record_orcamento_condicoes = browse_orcamento.orcamento_condicao_ids
        if record_orcamento_condicoes:
            # Filtra a condicao aprovada, se houver
            record_condicao_aprovada = filter(lambda c: c.aprovado, record_orcamento_condicoes)
            if record_condicao_aprovada:
                # Verifica se a condicao aprovada eh a vista
                record_condicoes_a_vista = filter(
                    lambda c: c.condicao_id and c.condicao_id.adm_condicao_id.tipo == 'V'
                    or c.forma_pagto_id.cartao_credito_debito, record_condicao_aprovada
                )
                if record_condicoes_a_vista:
                    res = True
            else:
                # Filtra se as condicoes sao do tipo 'V'(à vista) ou que a forma de
                # pagamento seja cartao, que tbm e considerada à vista.
                record_condicoes_a_vista = filter(
                    lambda c: c.condicao_id and c.condicao_id.adm_condicao_id.tipo == 'V'
                    or c.forma_pagto_id.cartao_credito_debito, record_orcamento_condicoes
                )
                if len(record_condicoes_a_vista) == len(record_orcamento_condicoes):
                    res = True

        return res

    def orcutl_possui_liberacao_desconto(self, cr, uid, orcamento_id, context=None):
        context = context and context.copy() or {}
        desconto_liberado_ids = self.pool.get('vendas.liberar.desconto').search(
            cr, uid, [('venauv_orcamento_id', '=', orcamento_id)], context=None
        )
        if desconto_liberado_ids:
            return desconto_liberado_ids
        else:
            return False

    def orcutl_validar_desconto_itens(self, cr, uid, orcamento_ids, context=None):
        """
        Funcao Valida:
            * Se o desconto dado aos itens e maior que o permitido.
        Retorna:
            * True - Descontos dentro do permitido. Orcamento OK
            * False - Descontos acima do limite.
        """

        context = context and context.copy() or {}
        self._mensagem_erro = u''
        self._tem_erro = False

        if isinstance(orcamento_ids, (int, long)):
            orcamento_ids = [orcamento_ids]

        # OBJETOS
        obj_adm_utils = self.pool.get('adm.utils')
        obj_orcamento = self.pool.get('orcamentos.orcamento.capa')
        obj_estoque_produto = self.pool.get('estoque.produto')

        # NAME DOS ORCAMENTO_IDS
        orcamento_names_dict = self.orcutl_get_orcamento_names(cr, uid, orcamento_ids, context)

        # CONTROLE
        erro_orcamento_item_desconto = u''

        browse_orcamento = obj_orcamento.browse(cr, uid, orcamento_ids, context)

        for o in browse_orcamento:

            # CONTROLE ITEM
            erro_item_desconto = u''

            # DADOS DO ORÇAMENTO
            ORC_ID = o.id

            orcamento_name = (orcamento_names_dict.get(ORC_ID) or '').encode(
                'utf-8') or _('** Orcamento nao encontrado **')
            RECORD_ORCAMENTO_ITENS = o.orcamento_itens_ids
            total_desconto_itens = sum(map(lambda i: i.desconto_total or 0, RECORD_ORCAMENTO_ITENS))
            ORC_DESCONTO = (o.valor_desconto_total or 0) - total_desconto_itens
            if not RECORD_ORCAMENTO_ITENS:
                continue
            else:
                rateio_capa_itens = {}
                if ORC_DESCONTO > 0:
                    # SE HOUVER DESCONTO NA CAPA DO ORCAMENTO, RATEA-LO PARA O ITENS.
                    elementos = map(lambda i: [i.id, i.valor_total], RECORD_ORCAMENTO_ITENS)
                    elementos_rateados = map(tuple, obj_adm_utils.efetuar_rateio(ORC_DESCONTO, elementos))
                    rateio_capa_itens = dict(elementos_rateados)

                # ITENS DO ORÇAMENTO
                for i in RECORD_ORCAMENTO_ITENS:
                    IORC_ITEM_ID = i.produto_id.id
                    percentual_desconto_item = obj_estoque_produto.estpro_get_desconto_maximo(cr, uid, IORC_ITEM_ID, context).get(IORC_ITEM_ID)
                    if percentual_desconto_item:
                        IORC_ID = i.id
                        IORC_VALOR_LIQUIDO = i.valor_total or 0
                        IORC_DESCONTO = i.desconto_total or 0

                        valor_bruto = IORC_VALOR_LIQUIDO + IORC_DESCONTO
                        capa_desconto_rateado = rateio_capa_itens.get(IORC_ID) or 0
                        # DESCONTO TOTAL DADO NO ITEM (CAPA + DETALHE)
                        desconto_total_item = float(Decimal(str(
                            IORC_DESCONTO + capa_desconto_rateado)).quantize(
                            Decimal('.01'), rounding=ROUND_UP))

                        desconto_maximo_permitido = float(Decimal(str(
                            valor_bruto * percentual_desconto_item / 100)).quantize(
                            Decimal('.01'), rounding=ROUND_UP))
                        if desconto_total_item:
                            if desconto_total_item > desconto_maximo_permitido:
                                item_name_get = obj_estoque_produto.name_get(cr, uid, [IORC_ITEM_ID], context) or [
                                    ('', '')]
                                dict_item_name = dict(item_name_get)
                                produto_name = (dict_item_name.get(IORC_ITEM_ID) or '').encode('utf-8') \
                                    or _('** Produto nao encontrado **')
                                erro_item_desconto += '%s, ' % produto_name.decode('utf-8')

            if erro_item_desconto:
                erro_orcamento_item_desconto += '%s - Itens: %s' % (orcamento_name, erro_item_desconto)

        if erro_orcamento_item_desconto:
            self._tem_erro = True
            self._mensagem_erro += _('* [DESCONTO ACIMA DO LIMITE]: %s ') % erro_orcamento_item_desconto

        if self._tem_erro:
            return False
        else:
            return True

    def orcult_validar_condicoes_pgto(self, cr, uid, orcamento_id, state='', context=None):
        context = context and context.copy() or {}
        self._tem_erro = False
        self._mensagem_erro = u''

        APROVADO = '3A'

        if isinstance(orcamento_id, list):
            orcamento_id = orcamento_id[0]

        # OBJETOS
        obj_orcamento = self.pool.get('orcamentos.orcamento.capa')

        # NAME DOS ORCAMENTO_IDS
        dict_orcamento_names = self.orcutl_get_orcamento_names(cr, uid, orcamento_id, context=context)

        campos = ['orcamento_condicao_ids', 'valor_liquido']
        dados_orcamento = obj_orcamento.read(cr, uid, orcamento_id, campos, context=context)
        if isinstance(dados_orcamento, list):
            dados_orcamento = dados_orcamento[0]
        if isinstance(dados_orcamento, dict):
            orc_id = dados_orcamento['id']
            orc_valor_total = dados_orcamento.get('valor_liquido') or 0
            orcamento_name = (dict_orcamento_names.get(orc_id) or '').encode(
                'utf-8') or _('** Orcamento nao encontrado **')

            orc_condicao_ids = dados_orcamento.get('orcamento_condicao_ids')
            if not orc_condicao_ids:
                self._tem_erro = True
                self._mensagem_erro += _('* Condicoes de pagamento nao informadas no orcamento: %s') % orcamento_name
            else:
                obj_orcamento_condicao_pgto = self.pool.get('orcamentos.orcamento.condicao')
                if len(orc_condicao_ids) == 1:
                    obj_orcamento_condicao_pgto.write(cr, uid, orc_condicao_ids, {'aprovado': True}, context)
                else:
                    condicoes_aprovadas_ids = obj_orcamento_condicao_pgto.search(
                        cr, uid, [('aprovado', '=', True), ('id', 'in', orc_condicao_ids)], context=context
                    )

                    if not condicoes_aprovadas_ids and state == APROVADO:
                        self._tem_erro = True
                        self._mensagem_erro += _('* Nenhuma condicao de pagamento aprovada no orcamento: %s') % orcamento_name
                    else:
                        condicao_dados = obj_orcamento_condicao_pgto.read(cr, uid, condicoes_aprovadas_ids, ['valor'],
                                                                          context=context)
                        total_condicoes = sum(map(lambda i: i.get('valor') or 0, condicao_dados))
                        if round(total_condicoes, 2) != round(orc_valor_total, 2):
                            self._tem_erro = True
                            self._mensagem_erro = _('* Condicao aprovada possui valor diferente do valor total do orcamento: %s') % orcamento_name
        if self._tem_erro:
            return False
        else:
            return True

    @staticmethod
    def orcult_valida_condicoes_iguais_ao_total(dict_codicoes, valor_orcamento):
        """
        Parametro: dict_condicoes - dicionario contendo os ids das condicoes e seus respectivos
                                    valores
        valor_orcamento - valor liquido do orcamento
        Funcao: Este metodo deve retirar do dicinario dict_condicoes
                os valores que possuam valor igual ao total do orcamento
                Isto serve para que estes valores nao sejam validados novamente
                em outras verificacoes, uma vez que eles ja estao Ok
        retorno: dict
        """
        if not isinstance(dict_codicoes, dict):
            dict_codicoes = {}
        for condicao in dict_codicoes.keys():
            if round(dict_codicoes[condicao], 2) == round(valor_orcamento, 2):
                dict_codicoes.pop(condicao)
        return dict_codicoes

    @staticmethod
    def orcult_valida_soma_condicoes_menores_ao_total(dict_condicoes, valor_orcamento):
        """
        Parametro: dict_condicoes - dicionario contendo os ids das condicoes e seus respectivos
                                    valores
                   valor_orcamento - valor liquido do orcamento
        Funcao: Este metodo verifica se a soma das condicoes de pagamento que tem
                valor menor ou igual ao total do orcamento sao maior ou igual
                ao total do orcamento
        Retorno: boolean
        """
        res = True
        if not isinstance(dict_condicoes, dict):
            dict_condicoes = {}
        total_condicoes = sum(dict_condicoes.values())
        if round(total_condicoes, 2) < round(valor_orcamento, 2):
            res = False
        return res

    @staticmethod
    def orcult_valida_condicao_maior_total(dict_condicoes, valor_orcamento):
        """
        Parametro: dict_condicoes - dicionario contendo os ids das condicoes e seus respectivos
                                    valores
                   valor_orcamento - valor liquido do orcamento
        Funcao: Este metodo verifica se existe alguma condicao com valor
                maior que o total do orcamento
        Retorno: boolean
        """
        res = True
        list_valores_maiores = map(lambda i: i > valor_orcamento, dict_condicoes.values())
        if any(list_valores_maiores):
            res = False
        return res

    def orcutl_restricao_venda(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self._tem_erro = False
        self._mensagem_erro = u''

        TIPO_DOCUMENTO = 'ORC'
        if isinstance(ids, (int, long)):
            ids = [ids]

        obj_venda_utils = self.pool.get('vendas.utils')

        fields_to_read = ['pessoa_id', 'state']
        orcamento_dados = self.pool.get('orcamentos.orcamento.capa').read(cr, uid, ids, fields_to_read, context=context)
        for i in orcamento_dados:

            id = i['id']
            pessoa_id = i.get('pessoa_id') and i['pessoa_id'][0] or False
            state = i.get('state')

            venda_liberada = obj_venda_utils.venutl_documento_restricao_venda(
                cr, uid, documento_id=id, pessoa_id=pessoa_id, documento_state=state,
                documento_tipo=TIPO_DOCUMENTO, context=context)

            if not venda_liberada:
                erro_venda = obj_venda_utils.venutl_get_erro()
                self._tem_erro = True
                self._mensagem_erro += erro_venda

        if self._tem_erro:
            return False
        else:
            return True

    def orcutl_liberacao_desconto(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            orcamento_ids = [ids]
        else:
            orcamento_ids = ids

        obj_liberar_desconto = self.pool.get('vendas.liberar.desconto')

        # NAME DOS ORCAMENTO_IDS
        orcamento_names_dict = self.orcutl_get_orcamento_names(cr, uid, ids, context)

        fields_to_read = [
            'orcamento_condicao_ids', 'orcamento_itens_ids', 'valor_liquido', 'valor_desconto_total',
            'valor_acrescimo_total'
        ]
        orcamento_dados = self.pool.get('orcamentos.orcamento.capa').read(cr, uid, orcamento_ids, fields_to_read, context=context)

        # CONTROLES
        orcamento_erros = u''
        info_orc_liberacao_desconto_criada = u''
        erro_orc_liberacao_desconto_nao_autorizada = u''

        for i in orcamento_dados:
            orc_id = i['id']
            orc_valor_liquido = i.get('valor_liquido') or 0

            orcamento_name = (orcamento_names_dict.get(orc_id) or '').encode(
                'utf-8') or _('** Orcamento nao encontrado **')

            # VALIDAÇÃO DE DESCONTOS DADOS NOS ITENS E NA CAPA.
            desconto_liberado = self.orcutl_validar_desconto_itens(
                cr, uid, orcamento_ids=orc_id, context=context
            )

            # *** Liberacao de Desconto ***
            liberacao_desconto_orc_ids = self.orcutl_possui_liberacao_desconto(cr, uid, orc_id, context)

            if desconto_liberado:
                # SE NÃO HOUVER NENHUM PROBLEMA REFERENTE A DESCONTO E EXISTIR ALGUM REGISTRO DE LIBERACAO DE
                # DESCONTO, O MESMO SERÁ EXCLUIDO, POIS NÃO SERÁ MAIS NECESSARIO POR NÃO HAVER MAIS DESCONTO.
                if liberacao_desconto_orc_ids:
                    obj_liberar_desconto.unlink(cr, uid, liberacao_desconto_orc_ids, context)
                else:
                    continue
            else:
                if not liberacao_desconto_orc_ids:

                    orcamento_erros += self.orcutl_get_erro()

                    # CASO O DESCONTO EXCEDA O LIMITE NOS ITENS, O SISTEMA IRÁ CRIAR AUTOMATICAMENTE UMA LIBERAÇÃO
                    # DE DESCONTO NÃO AUTORIZADA, PARA QUE UM SUPERVISOR AUTORIZE.
                    vals_liberar_desconto = {
                        'venauv_orcamento_id': orc_id,
                        'venauv_autorizado': False,
                    }
                    obj_liberar_desconto.create(cr, uid, vals_liberar_desconto, context)
                    # NÃO RETIRAR O COMMIT, POIS HOUVE ERRO E SERÁ FEITO UM RAISE. POREM, É PRECISO
                    # CRIAR A LIBERAÇÃO DE DESCONTO.
                    cr.commit()
                    info_orc_liberacao_desconto_criada += u'%s, ' % orcamento_name

                else:
                    args_liberacao_autorizada = [
                        ('venauv_autorizado', '=', True),
                        ('venauv_valor_liquido', '=', round(orc_valor_liquido, 2)),
                        ('id', 'in', liberacao_desconto_orc_ids)
                    ]
                    desconto_liberado_valor_liquido_ids = obj_liberar_desconto.search(
                        cr, uid, args_liberacao_autorizada, context=None
                    )
                    if desconto_liberado_valor_liquido_ids:
                        continue
                    else:
                        orcamento_erros += self.orcutl_get_erro()

                        erro_orc_liberacao_desconto_nao_autorizada += u'%s, ' % orcamento_name
                        values = {
                            'venauv_autorizado': False
                        }
                        obj_liberar_desconto.write(cr, uid, liberacao_desconto_orc_ids, values, context)
                        cr.commit()
                        # Validacao das condicoes de pagamento - Se existe e alguma esta aprovada

        if info_orc_liberacao_desconto_criada:
            orcamento_erros += _('** [CRIADA] - Liberacao de Desconto criada para os orcamentos: %s') % info_orc_liberacao_desconto_criada

        if erro_orc_liberacao_desconto_nao_autorizada:
            orcamento_erros += _('* [DESCONTO NAO AUTORIZADO] Orcamentos: %s') % erro_orc_liberacao_desconto_nao_autorizada

        if orcamento_erros:
            self._tem_erro = True
            self._mensagem_erro = orcamento_erros
            return False
        else:
            return True
