# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2010 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import fields, osv


class cliente_debitos_capa_wizard(osv.TransientModel):
    def _get_itens(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        ids = []
        active_model = vals.get('active_model')
        if active_model:
            obj_do_modelo_ativo = self.pool.get(active_model)
            active_id = vals.get('active_id')
            if active_model == 'fiscal.nf.capa':
                pessoa_id = obj_do_modelo_ativo.browse(cr, uid, active_id).destinatario_id.id or False
            else:
                pessoa_id = obj_do_modelo_ativo.browse(cr, uid, active_id).pessoa_id.id or False
            if pessoa_id:
                obj_orcamentos_orcamento_capa = self.pool.get('orcamentos.orcamento.capa')
                ids = obj_orcamentos_orcamento_capa.search(cr, uid, [('pessoa_id', '=', pessoa_id),
                                                                     ('state', '=', '3A')], context=None)
                if ids:
                    browse_orcamento_capa = obj_orcamentos_orcamento_capa.browse(cr, uid, ids)
                    ids = []
                    for x in browse_orcamento_capa:
                        for i in x.orcamento_condicao_ids:
                            if i.condicao_id.adm_condicao_id.tipo == 'C':
                                ids.append(x.id)
                                break

        return ids

    _name = "cliente.debitos.capa.wizard"
    _inherit = "cliente.debitos.capa.wizard"
    _columns = {
        'orcamento_ids': fields.one2many('orcamentos.orcamento.capa', 'pessoa_id', 'Orcamentos')
    }

    _defaults = {
        'orcamento_ids': _get_itens
    }
