# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler
from openerp.tools.translate import _


class estoque_parametro(osv.Model):
    _name = 'estoque.parametro'
    _inherit = 'estoque.parametro'
    _columns = {
        'prazo_de_validade': fields.integer('Prazo de Validade'),  # Prazo de Validade
        'alterar_prazo_validade': fields.boolean('Alterar Prazo Validade'),  # Altera prazo de validade
        'condicoes_ids': fields.one2many('estoque.param.condicoes', 'parametro_id', 'Condicoes'),
        'estpar_impressora_orcamento': fields.char('Impressora para Orcamento', size=128, help='Nome da impressora para orcamento caso nao queira fazer selecao na hora de imprimir'),
        'estpar_orcamento_matricial': fields.boolean('Orcamento na matricial'),
        'estpar_nao_imprimir_valor_item': fields.boolean('Nao imprimir valor dos itens',
                                                         help="Se marcado, na impressao do "
                                                              "orcamento os valores unitarios e "
                                                              "totais de cada item nao serao "
                                                              "impressos, somente o total do "
                                                              "orcamento"),
        'estpar_orcamento_formato_impressao': fields.selection([('1', 'A4'), ('2', 'Meia pagina')],
                                                               string='Formato impressao', size=1),
        'estpar_orcamento_retrato_paisagem': fields.selection([('P', 'Paisagem'), ('R', 'Retrato')],
                                                              'Modo impressao', size=1),
        'estpar_vias_orcamento': fields.integer('Quant. vias para impressao'),
        'estpar_orcamento_mensagem_padrao': fields.text('Mensagem padrao'),
    }
    _defaults = {
        'alterar_prazo_validade': lambda * a: True,
        'estpar_orcamento_matricial': lambda * a: False,
        'estpar_vias_orcamento': 1,
    }

