# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

import time
from openerp.tools.translate import _
from decimal import Decimal, ROUND_HALF_UP


#Funcoes da classe orcamentos.orcamento.capa
def _orcap_get_altera_prazo_validade_padrao(self, cr, uid, context=None):
    context = context and context.copy() or {}
    company_id = self.pool.get('res.users').browse(cr, uid, uid).company_id.id
    obj_estoque_parametro = self.pool.get('estoque.parametro')
    parametro_id = obj_estoque_parametro.search(cr, uid, [('company_id', '=', company_id)], context=context)
    if parametro_id and isinstance(parametro_id, list):
        parametro_id = parametro_id[0]
    alterar_prazo_validade = obj_estoque_parametro.read(cr, uid, parametro_id, ['alterar_prazo_validade'], context=context)
    if alterar_prazo_validade and isinstance(alterar_prazo_validade, dict):
        alterar_prazo_validade = alterar_prazo_validade.get('alterar_prazo_validade')
    return alterar_prazo_validade


def _orcap_get_altera_prazo_validade(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    browse_item_orcamento = self.browse(cr, uid, ids)
    for i in browse_item_orcamento:
        company_id = self.pool.get('res.users').browse(cr, uid, uid).company_id.id
        obj_estoque_parametro = self.pool.get('estoque.parametro')
        parametro_id = obj_estoque_parametro.search(cr, uid, [('company_id', '=', company_id)], context=context)
        if parametro_id and isinstance(parametro_id, list):
            parametro_id = parametro_id[0]
        alterar_prazo_validade = obj_estoque_parametro.read(cr, uid, parametro_id, ['alterar_prazo_validade'], context=context)
        if alterar_prazo_validade and isinstance(alterar_prazo_validade, dict):
            alterar_prazo_validade = alterar_prazo_validade.get('alterar_prazo_validade')
        res[i.id] = alterar_prazo_validade
    return res


def _orccap_get_valor_liquido(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    if isinstance(ids, (int, long)):
        ids = [ids]
    res = {}.fromkeys(ids, 0)
    browse_orcamento = self.browse(cr, uid, ids)
    for i in browse_orcamento:
        id = i.id
        item_ids = i.orcamento_itens_ids
        total_itens = sum(map(lambda j: j.valor_total, item_ids))
        desconto = i.valor_desconto_total or 0
        despesas_acessorias = i.orccap_vr_despesas_acessorias or 0
        vr_frete = i.orccap_vr_frete or 0
        if context.get('orccap_nao_alterar_total'):
            desconto = 0
        elif context.get('orccap_valor_com_desconto'):
            desconto = (total_itens * i.percentual_desconto / 100)
            if not desconto:
                desconto = i.valor_desconto_total or 0
        orccap_valor_ipi = i.orccap_valor_ipi
        total_orcamento = total_itens - desconto + orccap_valor_ipi + despesas_acessorias + vr_frete
        res[id] = total_orcamento
    return res


def _orccap_prioridade(self, cr, uid, ids, name, arg, context):
    import datetime
    import time

    res = {}
    vals = self.read(cr, uid, ids, ['previsao_aprovacao', 'state'], context=context)
    dtHoje = datetime.date.today()
    for reg in vals:
        res[reg['id']] = 0
        if reg['state'] == '2V' and reg['previsao_aprovacao']:
            dtAprova = datetime.date(*time.strptime(reg['previsao_aprovacao'], "%Y-%m-%d")[0:3])
            DiasAprovacao = (dtAprova - dtHoje).days
            res[reg['id']] = ((DiasAprovacao < 0 and 99999 ) or
                              (DiasAprovacao == 0 and 1 ) or
                              (DiasAprovacao > 0 and DiasAprovacao <= 5 and 5) or
                              (DiasAprovacao > 5 and DiasAprovacao <= 15 and 10) or
                              50)
    return res


def _orccap_get_observacao_cliente(self, cr, uid, ids, name, arg, context):
    if isinstance(ids, (int, long)):
        ids = [ids]
    res = {}.fromkeys(ids, '')
    obj_financeiro_cliente = self.pool.get('financeiro.cliente')
    obj_financeiro_clientes_mensagem = self.pool.get('financeiro.clientes.mensagem')
    browse_orcamento = self.browse(cr, uid, ids)
    for i in browse_orcamento:
        id = i.id
        record_pessoa = i.pessoa_id
        if record_pessoa:
            pessoa_obs = record_pessoa.observacoes or ''
            pessoa_id = record_pessoa.id
            cliente_id = obj_financeiro_cliente.search(cr, uid, [('pessoa_id', '=', pessoa_id)], context=None)
            if cliente_id:
                cliente_mensagem_id = obj_financeiro_clientes_mensagem.search(cr, uid,
                                                                              [('cliente_id', 'in', cliente_id)],
                                                                              context=None)
                if cliente_mensagem_id:
                    clientes_mensagem_dados = obj_financeiro_clientes_mensagem.browse(cr, uid, cliente_mensagem_id)
                    for j in clientes_mensagem_dados:
                        if j.modo_exibicao in ('V', 'A'):
                            mensagem_id = j.mensagens_id
                            if mensagem_id:
                                pessoa_obs += '\n' + mensagem_id.name
        else:
            pessoa_obs = ''
        res[id] = pessoa_obs
    return res


def _orccap_get_valor_ipi_total(self, cr, uid, ids, name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    obj_orcamentos_orcamento_itens = self.pool.get('orcamentos.orcamento.itens')
    if not isinstance(ids, list):
        ids = [ids]
    for id in ids:
        browse_orcamento_item = self.browse(cr, uid, id).orcamento_itens_ids
        valor_total_ipi = 0.0
        for x in browse_orcamento_item:
            valor_total = obj_orcamentos_orcamento_itens._orcori_get_total_itens(cr, uid, [x.id], None, None, context)
            valor_total = valor_total.get(x.id)
            browse_tributacao = x.produto_id.tributacao_ids
            for i in browse_tributacao:
                if i.encargo_id.sigla == 'IPI' and i.tipo_tributacao != 'E':
                    ipi_aliquota = i.tributacao_id.aliquota
                    valor_total_ipi_item = valor_total * ipi_aliquota / 100
                    valor_total_ipi += valor_total_ipi_item
                    break
        res[id] = round(valor_total_ipi, 2)
    return res


def _orccap_check_nao_imprimir_valor_item(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    obj_adm_utils = self.pool.get('adm.utils')
    dado_estoque_parametro = obj_adm_utils.admutl_get_parametros(
        cr, uid, 'estoque', ['estpar_nao_imprimir_valor_item'], context=context)
    nao_imprimir_valor_item = dado_estoque_parametro.get('estpar_nao_imprimir_valor_item')
    brw_contratos_contrato = self.browse(cr, uid, ids, context=context)
    for contrato in brw_contratos_contrato:
        res[contrato.id] = nao_imprimir_valor_item
    return res


#Funcoes da classe orcamentos.orcamento.itens
def _orcori_get_total_itens(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    total_item = 0
    browse_item_orcamento = self.browse(cr, uid, ids)
    madeireira_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'madeireira', context=context)
    for i in browse_item_orcamento:
        sigla = ''
        if i.produto_embalagem_id:
            embalagem_id = i.produto_embalagem_id.embalagem_id
            if embalagem_id:
                sigla = embalagem_id.sigla or ''

        id = i.id
        valor_unitario = i.valor_unitario_bruto # valor unitario ja possui a quantidade de embalagem
        quantidade = i.quantidade
        desconto = i.desconto_total or 0
        total_item = valor_unitario * quantidade - desconto
        if madeireira_instalado:
            if not any([i.orcori_comprimento, i.orcori_espessura, i.orcori_largura]):
                quantidade = i.quantidade
            comprimento = i.orcori_comprimento or 1
            largura = i.orcori_largura
            espessura = i.orcori_espessura
            quantidade = self.pool.get('madeireira.utils').madutl_calcula_volume(
                quantidade, comprimento, largura, espessura, self, 'orcori_volume')
            total_item = float(Decimal(str(valor_unitario * quantidade - desconto)).quantize(
                Decimal('.01'), rounding=ROUND_HALF_UP))
        res[id] = total_item
    return res


def _orcori_get_foto(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    browse_item_orcamento = self.browse(cr, uid, ids)
    for i in browse_item_orcamento:
        foto = i.produto_id.estpro_foto
        if foto:
            res[i.id] = foto
        else:
            res[i.id] = False
    return res


def _orcori_get_local_venda_padrao(self, cr, uid, ids):
    res = False
    emp_id = self.pool.get('res.users').browse(cr, uid, uid).company_id.id
    obj_par = self.pool.get('estoque.parametro')
    par_id = obj_par.search(cr, uid, [('company_id', '=', emp_id)], context=None)
    if par_id:
        res = obj_par.browse(cr, uid, par_id[0]).local_venda_padrao_id.id
    return res


def _orcori_get_saldo_produto(self, cr, uid, ids, fields_name, args, context=None):
    """
    Busca o saldo e a quantidade reservada dos produtos
    @param cr: cursor do banco de dados
    @param uid: id do usuario
    @param ids: lista de id da tabela estoqueorcamentos_orcamento_item
    @param fields_name: nome do atributo
    @param args: argumentos
    @param context: dicionario com valores contextuais
    """
    context = context and context.copy() or {}
    res = {}
    obj_estoque_produto_saldo = self.pool.get('estoque.produto.saldo')
    brw_orcamento_item = self.browse(cr, uid, ids, context)
    for x in brw_orcamento_item:
        grade_id = x.grade_id.id
        local_id = x.local_id.id
        data = time.strftime('%Y-%m-%d')
        saldo = obj_estoque_produto_saldo.get_saldo_do_dia(cr, uid, grade_id, data, local_id, context=context)
        vals = {'orcori_saldo': 0, 'orcori_reservada': 0}
        res[x.id] = vals
        saldo = saldo.get(grade_id)
        if saldo:
            vals['orcori_saldo'] = saldo.get('saldo') or 0
            vals['orcori_reservada'] = saldo.get('qtd_reservada')
            res[x.id] = vals
    return res


def _orcori_get_prod_similares(self, cr, uid, ids, fields_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    for id in ids:
        brw_produto = self.browse(cr, uid, id).produto_id
        if brw_produto:
            simi_ids = []
            for simi in brw_produto.produto_similaridade_ids:
                simi_ids.append(simi.id)
            res[id] = simi_ids
        else:
            res[id] = ''
    return res


def _orcori_get_par_similaridade(self, cr, uid, ids, fields_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    for id in ids:
        par = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque.parametro','usar_similaridade')
        if par:
            res[id] = par.get('usar_similaridade')
        else:
            res[id] = False
    return res


def _orcori_get_state(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    brw_orcamento_item = self.browse(cr, uid, ids, context)
    for item in brw_orcamento_item:
        estado = item.orcamento_id.state
        if estado == '1E':
            estado = _('Esboco')
        elif estado == '2V':
            estado = 'Validado'
        elif estado == '3A':
            estado = 'Aprovado'
        elif estado == '4G':
            estado = 'Gerado pedido'
        else:
            estado = 'Cancelado'
        res[item.id] = estado
    return res


def orcori_get_permissao_vr_unitario(self, cr, uid, ids, field_name, args, context=None):
    """
    Metodo do campo function 'orcori_altera_vr_unitario'. Verifica se o usuario (uid) possui
    permissao para alterar o preco de venda para os orcamentos recebidos (ids).
    :param cr: cursor no banco de dados.
    :type cr: object
    :param uid: id da tabela res_users, identificador do usuario.
    :type uid: int
    :param ids: lista de id da tabela desse objeto.
    :type ids: list
    :param field_name: descricao do campo funcional.
    :type field_name: str
    :param args: dados de pesquisa.
    :type args: list
    :param context: dados com valores contextuais.
    :type context: dict
    :return: dados da descricao do campo com seu respectivo valor.
    :rtype: dict
    """
    context = context and context.copy() or {}
    permissao_altera_preco = self.pool.get('ir.model.access').check_groups(
        cr, uid, 'estoque.group_estoque_alterar_preco')
    res = dict().fromkeys(ids, permissao_altera_preco)
    return res


def _orccap_get_premite_alterar(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = self.pool.get('estoque.parametro').estpar_get_permite_alterar_condicoes_pgto(cr, uid, ids, context)
    return res


def get_par_similaridade(self, cr, uid, ids):
    par = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque.parametro','usar_similaridade')
    return par.get('usar_similaridade')

def default_get_orcori_par_similaridade(self, cr, uid, ids, context=None):
    context = context and context.copy() or {}
    return get_par_similaridade(self, cr, uid, ids)


def _orccap_get_vendedor_obrigatorio(self, cr, user, ids, name=None, arg=None, context=None):
    """
    Manipulacao de campos. Valores de campos pre-definidos como tipo funcao.
    Retorna verdadeiro/falso em funcao do parametro informado no campo ´estpar_vendedor_obrigatorio´

    :param cr: a linha atual do cursor do banco de dados,
    :param user: ID do usuario utilizado para a verificacao de perfil,
    :param ids: lista dos IDs,
    :param context: um dicionario padrao para valores contextuais,
    :type cr: cursor
    :type user: int
    :type ids: list
    :type context: dict
    :return: valores ajustados dos campos.
    :rtype: bool

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """
    context = context and context.copy() or dict()
    if isinstance(ids, list):
        result = dict().fromkeys(ids, self.pool.get('adm.utils').admutl_get_parametros(
            cr, user, 'estoque', [], context).get('estpar_vendedor_obrigatorio'))
    else:
        result = self.pool.get('adm.utils').admutl_get_parametros(
            cr, user, 'estoque', [], context).get('estpar_vendedor_obrigatorio')

    return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

