# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class orcamentos_orcamento_condicao(osv.Model):
    """
    Condicoes de pagamento do orcamento
    """
    _name = 'orcamentos.orcamento.condicao'
    _columns = {
        'capa_id': fields.many2one("orcamentos.orcamento.capa", 'Capa', ondelete="cascade", required=True, select=True),
        # Id da capa
        'forma_pagto_id': fields.many2one('adm.forma.pgto', 'Forma de Pagamento', ondelete="restrict", required=True),
        'condicao_id': fields.many2one('adm.condicao.forma', 'Condicao', ondelete="restrict", required=True),
        'valor': fields.float('Valor', digits=(15, 2), required=True),
        'aprovado': fields.boolean('Aprovado'),
    }
    _defaults = {
        'aprovado': lambda *a: False,
    }
