# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class orcamentos_padrao_capa(osv.Model):
    """
    Cadastro de orcamentos padroes

    prefixo: orcpca_
    """
    _name = 'orcamentos.padrao.capa'
    _roteavel = True
    _columns = {
        'id': fields.integer('Nro', readonly=True), # Id
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True), # Id da empresa
        'name': fields.char('Descricao', size=50, required=True), # Descricao do orcamento padrao
        'padrao_itens_ids': fields.one2many('orcamentos.padrao.itens', 'orcamento_id', 'Itens', required=True),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }
