# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler


class orcamentos_padrao_itens(osv.Model):
    """
    Tabela de itens do orcamento padrao
    """
    _name = 'orcamentos.padrao.itens'
    _columns = {
        'orcamento_id': fields.many2one("orcamentos.padrao.capa", 'Orcamento', ondelete="cascade", required=True,
                                        select=True), # id do orcamento padrao
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="restrict", required=True, select=True),
        'grade_id': fields.many2one("estoque.produto.grade", 'Grade', ondelete="restrict", select=True,
                                    domain="[('produto_id', '=', produto_id)]"), # id de identificacao da grade/produto
        'local_id': fields.many2one("estoque.local", 'Local', ondelete="restrict", required=True, select=True),
        'produto_embalagem_id': fields.many2one("estoque.produto.embalagem", 'Embalagem', ondelete="restrict",
                                                required=True, select=True, domain="[('produto_id', '=', produto_id)]"),
        'quantidade': fields.float('Quantidade', digits=(13, 5), required=True), # Quantidade de itens
    }

