# -*- encoding: utf-8 -*-

import time

from openerp.osv import osv, fields
from openerp import pooler
from openerp.report import report_sxw
from openerp.tools.translate import _
import subprocess
from SigUtils.formatastring import formataString
from SigUtils.numero import getNumeroEditado
from datetime import datetime
import re
from dateutil.parser import parse


class rel_impressao(report_sxw.rml_parse):

    # COMANDOS IMPRESSORA MATRICIAL
    reseta_configuracao_impressora = chr(27)+chr(120)+chr(48)
    condensado = chr(15)
    modo_negrito_on = chr(27)+chr(71)
    modo_negrito_off = chr(27)+chr(72)

    def __init__(self, cr, uid, name, context=None):
        context = context and context.copy() or {}
        super(rel_impressao, self).__init__(cr, uid, name, context)

        obj_adm_utils = pooler.get_pool(cr.dbname).get('adm.utils')
        obj_orcamentos_orcamento_capa = pooler.get_pool(cr.dbname).get('orcamentos.orcamento.capa')
        parametros = ['estpar_impressora_orcamento', 'estpar_orcamento_matricial',
                      'estpar_descricao_grade', 'estpar_vias_orcamento']
        estoque_parametros = obj_adm_utils.admutl_get_parametros(cr, uid, 'estoque', parametros,
                                                                 context=context)

        def orcamento_descricao_item(brw_produto, brw_grade):
            descricao = brw_grade.descricao
            if estoque_parametros.get('estpar_descricao_grade') == 'P':
                descricao = '%s %s' % (brw_produto.name, brw_grade.descricao)
            return descricao

        self.localcontext.update({
            'time': time,
            'telefones_empresa': self.buscar_telefones_empresa(cr, uid, context=context),
            'sum': sum,
            'getNumeroEditado': self.pool.get('adm.utils').admutl_get_valor_formatado,
            'int': int,
            'orcamento_descricao_item': orcamento_descricao_item,
            'data_emissao': obj_adm_utils.admutl_datetime_to_timezone(
                cr, uid, parse(obj_orcamentos_orcamento_capa.read(
                    cr, uid, context.get('active_id'), ['create_date'],
                    context).get('create_date')), '%d/%m/%Y %H:%M:%S')
        })
        orcamento_ids = context.get('active_ids')
        if orcamento_ids:
            impressora_orcamento = estoque_parametros.get('estpar_impressora_orcamento')
            orcamento_matricial = estoque_parametros.get('estpar_orcamento_matricial')
            quantidade_vias = "-n" + str(estoque_parametros.get('estpar_vias_orcamento') or 1)
            if impressora_orcamento and orcamento_matricial:
                browse_orcamento = obj_orcamentos_orcamento_capa.browse(cr, uid, orcamento_ids[0])
                self.imprimir_orcamento_impressora_matricial(cr, uid, orcamento_ids[0], context=context)
                impressora = "-d" + impressora_orcamento
                subprocess.call(["lp", quantidade_vias, impressora,
                                 "/tmp/%s.txt" % browse_orcamento.documento])
            else:
                pooler.get_pool(cr.dbname).get('orcamentos.orcamento.capa').imprimir_orcamento(cr, uid, orcamento_ids, context=context)
        self.context = context

    def buscar_telefones_empresa(self, cr,uid, context=None):
        '''
                Retorna todos os numeros de telefone da empresa
                '''

        context = context and context.copy() or {}
        orcamento_id = context.get('active_id')
        obj_orcamentos_orcamento_capa = pooler.get_pool(cr.dbname).get('orcamentos.orcamento.capa')
        brw_orcamentos_orcamento_capa = obj_orcamentos_orcamento_capa.browse(cr,uid,orcamento_id,context=context)
        brw_telefone_ids = brw_orcamentos_orcamento_capa.company_id.rescon_pessoa_id.telefones_ids
        telefones = ''
        ddd = ''
        for t in brw_telefone_ids:
            if t.ddd:
                ddd = re.sub('[^0-9]', '', t.ddd)
            numero = re.sub('[^0-9]', '', t.numero)
            if ddd:
                ddd = '(' + str(ddd) + ')'
            if len(t.numero) == 8:
                numero = "%s-%s" % (t.numero[:4], t.numero[4:])
            telefones += ddd + numero +',' if len(brw_telefone_ids) > 1 else ddd + numero
        return telefones

    def imprimir_orcamento_impressora_matricial(self, cr, uid, ids, context=None):
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        madeireira_instalado = self.pool.get('adm.utils'). \
            admutl_check_modulo_instalado(cr, uid, 'madeireira', context)
        obj_orcamentos_orcamento_capa = pooler.get_pool(cr.dbname).get('orcamentos.orcamento.capa')
        obj_adm_utils = pooler.get_pool(cr.dbname).get('adm.utils')
        if ids:
            count = 0
            browse_orcamento = obj_orcamentos_orcamento_capa.browse(cr, uid, ids)
            nao_imprimir_valor_item = browse_orcamento.orccap_nao_imprimir_valor_item
            orcamento_txt = open('/tmp/%s.txt' % browse_orcamento.documento, 'wb')
            orcamento_txt.write(self.reseta_configuracao_impressora)
            orcamento_txt.write(self.condensado)
            orcamento_txt.write('                                                              ORCAMENTO                                                             ' + '\r\n')
            count += 1
            data_emissao = ''
            if browse_orcamento.create_date:
                data_emissao = datetime.strptime(browse_orcamento.create_date, '%Y-%m-%d %H:%M:%S')
                data_emissao = self.pool.get('adm.utils').admutl_converte_tz(cr, uid, data_emissao,
                                                                   tz_origem='UTC', context=context)
                data_emissao = datetime.strftime(data_emissao, '%d/%m/%Y %H:%M:%S')

            validade = browse_orcamento.validade or ''
            status = browse_orcamento.state
            if status == '2V':
                status = 'VALIDADO'
            elif status == '1E':
                status = 'ESBOCO'
            elif status == '3A':
                status = 'APROVADO'
            elif status == '4G':
                status = 'GERADO PEDIDO'
            else:
                status = 'CANCELADO'

            if validade:
                validade = time.strftime('%d/%m/%Y', time.strptime(validade, '%Y-%m-%d'))
            descricao = '               NAO E DOCUMENTO FISCAL! NAO E VALIDO COMO RECIBO E COMO GARANTIA DE MERCADORIA. NAO COMPROVA PAGAMENTO!              '
            docs = center_title('', descricao, 'Pagina: {{ Page }} ')
            orcamento_txt.write(self.modo_negrito_on)
            orcamento_txt.write(descricao + '\r\n')
            orcamento_txt.write(self.modo_negrito_off)
            count += 1

            pessoa = 'CLIENTE'
            orcamento_txt.write('NUMERO: %s\r\n' % browse_orcamento.documento)
            count += 1
            orcamento_txt.write('%s\r\n' % obj_adm_utils.admutl_remover_acentuacao(cr, uid, browse_orcamento.company_id.name.encode('utf-8')) or '')
            count += 1
            endereco = obj_adm_utils.admutl_remover_acentuacao(cr, uid, (('ENDERECO: %s - %s, %s - %s - %s' % (
                browse_orcamento.company_id.rescon_pessoa_id.endereco, browse_orcamento.company_id.rescon_pessoa_id.bairro,
                browse_orcamento.company_id.rescon_pessoa_id.cidade, browse_orcamento.company_id.rescon_pessoa_id.uf,
                browse_orcamento.company_id.rescon_pessoa_id.cep)).encode('utf-8')))
            endereco = endereco.encode('utf-8')
            orcamento_txt.write(endereco + '\r\n')
            count += 1
            orcamento_txt.write('CNPJ: %s\r\n' % browse_orcamento.company_id.rescon_pessoa_id.cpf_cnpj or '')
            count += 1
            telefone = self.buscar_telefones_empresa(cr,uid,context=context)
            orcamento_txt.write('TELEFONE: %s\r\n' % telefone)
            count += 1
            orcamento_txt.write(
                '------------------------------------------------------------------------------------------------------------------------------------' + '\r\n')
            count += 1
            pessoa_nome = ''
            pessoa_id = browse_orcamento.pessoa_id
            if pessoa_id:
                pessoa_nome = pessoa_id.name.encode('utf-8') or ''
            orcamento_txt.write('%s: %s - CPF/CNPJ: %s\r\n' % (pessoa, obj_adm_utils.admutl_remover_acentuacao(
                cr, uid, pessoa_nome), (pessoa_id and pessoa_id.cpf_cnpj or '')))
            count += 1
            aos_cuidados = browse_orcamento.aos_cuidados or ''
            orcamento_txt.write('A/C: %s\r\n' % obj_adm_utils.admutl_remover_acentuacao(
                cr, uid, aos_cuidados))
            count += 1
            endereco = obj_adm_utils.admutl_remover_acentuacao(cr, uid,
                (('ENDERECO: %s - %s. %s - %s - %s\r\n') % (
                    browse_orcamento.pessoa_id.endereco or '',
                    browse_orcamento.pessoa_id.bairro or '',
                    browse_orcamento.pessoa_id.cidade or '', browse_orcamento.pessoa_id.uf or '',
                    browse_orcamento.pessoa_id.cep or '')).encode('utf-8'))
            endereco = endereco.encode('utf-8')
            orcamento_txt.write(endereco)
            count += 1
            telefone = browse_orcamento.pessoa_id.telefone or ''
            orcamento_txt.write('TELEFONE: %s\r\n' % telefone)
            count += 1
            orcamento_txt.write(
                '------------------------------------------------------------------------------------------------------------------------------------' + '\r\n')
            count += 1
            orcamento_txt.write(
                'EMISSAO: %s' % data_emissao + '                          ' + 'VALIDADE: %s' % validade + '                         ' + 'STATUS: %s\r\n' % status)
            count += 1
            orcamento_txt.write(
                '------------------------------------------------------------------------------------------------------------------------------------' + '\r\n')
            count += 1
            if madeireira_instalado:
                orcamento_txt.write(
                    'DESCRICAO DO ITEM                  EMB.     QUANT.    COMPR.       LARG.       ESPE.      VR BRUTO        DESCONTO          VR TOTAL' + '\r\n')
            else:
                orcamento_txt.write(
                    'DESCRICAO DO ITEM                           EMBALAGEM           QUANTIDADE          VALOR BRUTO        DESCONTO          VALOR TOTAL' + '\r\n')
            count += 1
            total = 0
            total_desconto = 0
            itens_orcamento = browse_orcamento.orcamento_itens_ids or []
            for x in itens_orcamento:
                item = (x.grade_id.name if x.grade_id.name else x.produto_id.name).encode('utf-8')
                descricao_produto = obj_adm_utils.admutl_remover_acentuacao(cr, uid, item) or ''
                descricao_produto = obj_adm_utils.admutl_remove_caracter(descricao_produto)
                descricao_produto = '%s-%s' % (x.produto_id.codigo,
                                               descricao_produto.decode('utf-8'))
                if not madeireira_instalado:
                    if len(descricao_produto) > 43:
                        linha = formataString(descricao_produto[:43], 132, ' ', 'D', 'N', 'S')
                        orcamento_txt.write(linha + '\r\n')
                        count += 1
                        descricao_produto = descricao_produto[43:]
                    linha = formataString(descricao_produto[:43], 43, ' ', 'D', 'N', 'S') + ''
                    linha += ' '
                    linha += formataString(x.produto_embalagem_id.embalagem_id.sigla or '', 10, ' ', 'D', 'N', 'S') + ''
                    linha += ' '
                    linha += formataString(getNumeroEditado(x.quantidade or 0, 2), 14, ' ', 'E', 'N', 'S') + ''
                    linha += ' '

                else:
                    espaco = 0
                    tamanho_descricao = len(descricao_produto.decode('utf-8'))
                    if tamanho_descricao < 35:
                        espaco = 35 - tamanho_descricao
                    elif len(descricao_produto) > 35:
                        linha = formataString(descricao_produto[:35], 132, ' ', 'D', 'N', 'S')
                        orcamento_txt.write(linha + '\r\n')
                        count += 1
                        descricao_produto = descricao_produto[35:]
                    linha = formataString(descricao_produto[:35] + ' ' * espaco, 35, ' ', 'D', 'N',
                                          'S') + ''
                    linha += ' '
                    linha += formataString(x.produto_embalagem_id.embalagem_id.sigla or '', 5, ' ', 'D', 'N', 'S') + ''
                    linha += ' '
                    linha += formataString(getNumeroEditado(x.quantidade or 0, 2), 6, ' ', 'E', 'N', 'S') + ''
                    linha += ' '
                    linha += formataString(getNumeroEditado(x.orcori_comprimento or 0, 2), 12, ' ', 'E', 'N', 'S') + ''
                    linha += ' '
                    linha += formataString(getNumeroEditado(x.orcori_largura or 0, 2), 12, ' ', 'E', 'N', 'S') + ''
                    linha += ' '
                    linha += formataString(getNumeroEditado(x.orcori_espessura or 0, 2),9, ' ', 'E', 'N', 'S') + ''
                    linha += ' '

                if nao_imprimir_valor_item:
                    if madeireira_instalado:
                        linha += formataString('', 14, ' ', 'E', 'N', 'S') + ''
                        linha += ' '
                    else:
                        linha += formataString('', 20, ' ', 'E', 'N', 'S') + ''
                        linha += ' '

                else:
                    if madeireira_instalado:
                        linha += formataString(getNumeroEditado(x.valor_unitario_bruto or 0, 2), 14, ' ', 'E', 'N', 'S') + ''
                    else:
                        linha += formataString(getNumeroEditado(x.valor_unitario_bruto or 0, 2), 20, ' ', 'E', 'N', 'S') + ''
                    linha += ' '
                linha += formataString(getNumeroEditado(x.desconto_total or 0, 2), 15, ' ', 'E', 'N', 'S') + ''
                linha += ' '
                if nao_imprimir_valor_item:
                    linha += formataString('', 20, ' ', 'E', 'N', 'S') + ''
                    linha += ' '
                else:
                    if madeireira_instalado:
                        linha += formataString(getNumeroEditado(x.valor_total or 0, 2), 12, ' ', 'E', 'N', 'S') + ''
                    else:
                        linha += formataString(getNumeroEditado(x.valor_total or 0, 2), 20, ' ', 'E', 'N', 'S') + ''
                    linha += ' '
                orcamento_txt.write(linha + '\r\n')
                count = self.calcula_quebra_de_linha(count, orcamento_txt, browse_orcamento)
                total += x.valor_total or 0
                total_desconto += x.desconto_total or 0

                if x.orcori_observacao:
                    orcamento_txt.write(formataString(x.orcori_observacao, 70, ' ', 'D', 'N', 'S') +
                                        '\r\n')
                    count = self.calcula_quebra_de_linha(count, orcamento_txt, browse_orcamento)

            tam_mad = 0
            linha = formataString('DESCONTO', madeireira_instalado and 93 or 88, ' ', 'D', 'N', 'S') + ''
            linha += ''
            total_desconto += browse_orcamento.valor_desconto_total or 0
            if madeireira_instalado:
                linha += formataString(getNumeroEditado(total_desconto or 0, 2), 22, ' ', 'E', 'N', 'S') + ''
                tam_mad = 97
            else:
                linha += formataString(getNumeroEditado(total_desconto or 0, 2), 18, ' ', 'E', 'N', 'S') + ''
            linha += ''
            orcamento_txt.write(linha + '\r\n')
            if browse_orcamento.orccap_vr_frete:
                total += browse_orcamento.orccap_vr_frete
                linha = formataString('Frete', tam_mad or 88, ' ', 'D', 'N', 'S') + ''
                linha += formataString(getNumeroEditado(browse_orcamento.orccap_vr_frete or 0, 2), 18, ' ', 'E', 'N', 'S') + ''
                linha += ''
                orcamento_txt.write(linha + '\r\n')
            if browse_orcamento.orccap_vr_despesas_acessorias:
                total += browse_orcamento.orccap_vr_despesas_acessorias
                linha = formataString('Despesas', tam_mad or 88, ' ', 'D', 'N', 'S') + ''
                linha += formataString(
                    getNumeroEditado(browse_orcamento.orccap_vr_despesas_acessorias or 0, 2), 18,
                    ' ', 'E', 'N', 'S') + ''
                linha += ''
                orcamento_txt.write(linha + '\r\n')
            if browse_orcamento.orccap_valor_ipi:
                linha = formataString('IPI', tam_mad or 88, ' ', 'D', 'N', 'S') + ''
                linha += formataString(
                    getNumeroEditado(browse_orcamento.orccap_valor_ipi or 0, 2), 18,
                    ' ', 'E', 'N', 'S') + ''
                linha += ''
                orcamento_txt.write(linha + '\r\n')

            count = self.calcula_quebra_de_linha(count, orcamento_txt, browse_orcamento)
            linha = formataString('TOTAL', 114, ' ', 'D', 'N', 'S') + ''
            linha += ''
            total -= browse_orcamento.valor_desconto_total or 0
            if madeireira_instalado:
                linha += formataString(getNumeroEditado(total or 0, 2), 14, ' ', 'E', 'N', 'S') + ''
            else:
                linha += formataString(getNumeroEditado(total or 0, 2), 18, ' ', 'E', 'N', 'S') + ''
            linha += ''
            orcamento_txt.write(linha + '\r\n')
            count = self.calcula_quebra_de_linha(count, orcamento_txt, browse_orcamento)
            orcamento_txt.write(
                '------------------------------------------------------------------------------------------------------------------------------------' + '\r\n')
            count = self.calcula_quebra_de_linha(count, orcamento_txt, browse_orcamento)

            # Espacamento especial para evitar a sensacao de cabecalho repetido.
            if count in (26, 27):
                var = count
                for cc in range(var, 29):
                    orcamento_txt.write('\r\n')
                    count = self.calcula_quebra_de_linha(count, orcamento_txt, browse_orcamento)

            orcamento_txt.write(
                'FORMA                       CONDICAO PRAZO                           VALOR LIQUIDO            VALOR PARCELA' + '\r\n')
            count = self.calcula_quebra_de_linha(count, orcamento_txt, browse_orcamento)
            condicao_orcamento = browse_orcamento.orcamento_condicao_ids
            for p in condicao_orcamento:
                linha = formataString(p.forma_pagto_id.name, 27, ' ', 'D', 'N', 'S') + ''
                linha += ' '
                linha += formataString(p.condicao_id.adm_condicao_id.name, 33, ' ', 'D', 'N',
                                       'S') + ''
                linha += ' '
                linha += formataString(getNumeroEditado(p.valor or 0, 2), 20, ' ', 'E', 'N',
                                       'S') + ''
                linha += ' '
                valor_parcela = p.valor / p.condicao_id.adm_condicao_id.qtde_parcelas or 1
                linha += formataString(getNumeroEditado(valor_parcela or 0, 2), 24, ' ', 'E', 'N',
                                       'S') + ''
                linha += ' '
                orcamento_txt.write(linha + '\r\n')
                count = self.calcula_quebra_de_linha(count, orcamento_txt, browse_orcamento)
            orcamento_txt.write(
                '------------------------------------------------------------------------------------------------------------------------------------' + '\r\n')
            count = self.calcula_quebra_de_linha(count, orcamento_txt, browse_orcamento)
            observacao = browse_orcamento.observacao or ''
            observacao = observacao.encode('utf-8')
            orcamento_txt.write('OBSERVACAO: %s\r\n' % observacao[:120])
            count = self.calcula_quebra_de_linha(count, orcamento_txt, browse_orcamento)
            orcamento_txt.write(
                '                                                              ASSINATURA VENDEDOR:___________________________________ \r\n')
            if count < 34:
                count += 1
            else:
                count = self.calcula_quebra_de_linha(count, orcamento_txt, browse_orcamento)
            if browse_orcamento.vendedor_id:
                orcamento_txt.write('                                                              '
                                    '                       %s \r\n' %
                                    obj_adm_utils.admutl_remover_acentuacao(
                                        cr, uid, browse_orcamento.vendedor_id.nome[:32]))
                if count < 34:
                    count += 1
                else:
                    count = self.calcula_quebra_de_linha(count, orcamento_txt, browse_orcamento)
            orcamento_txt.write(
                '------------------------------------------------------------------------------------------------------------------------------------' + '\r\n')
            if count < 34:
                count += 1
            else:
                count = self.calcula_quebra_de_linha(count, orcamento_txt, browse_orcamento)
            orcamento_txt.write(
                '                                                                                        ** Sig Informatica LTDA **                  ')
            if count < 34:
                count += 1
            else:
                count = self.calcula_quebra_de_linha(count, orcamento_txt, browse_orcamento)
            if count < 34:
                var = 33 - count
                for c in range(0, var):
                    orcamento_txt.write('\r\n')
            orcamento_txt.write(self.reseta_configuracao_impressora)
            orcamento_txt.close()

        return True

    def calcula_quebra_de_linha(self, count, txt, browse_orcamento=None):
        count += 1
        if count == 29:
            count = 0
            for c in range(0, 4):
                txt.write('\r\n')
            txt.write(self.reseta_configuracao_impressora+self.condensado)
            txt.write(
                '                                                              ORCAMENTO                                                             ' + '\r\n')
            count += 1
            descricao = '               NAO E DOCUMENTO FISCAL! NAO E VALIDO COMO RECIBO E COMO GARANTIA DE MERCADORIA. NAO COMPROVA PAGAMENTO!              '
            txt.write(self.modo_negrito_on)
            txt.write(descricao + '\r\n')
            txt.write(self.modo_negrito_off)
            count += 1
            txt.write('NUMERO: %s\r\n' % browse_orcamento.documento)
            count += 1
            txt.write('%s\r\n' % browse_orcamento.company_id.name.encode('utf-8') or '')
            count += 1
            endereco = 'ENDERECO: %s - %s, %s - %s - %s' % (
                browse_orcamento.company_id.rescon_pessoa_id.endereco, browse_orcamento.company_id.rescon_pessoa_id.bairro,
                browse_orcamento.company_id.rescon_pessoa_id.cidade, browse_orcamento.company_id.rescon_pessoa_id.uf,
                browse_orcamento.company_id.rescon_pessoa_id.cep)
            endereco = endereco.encode('utf-8')
            txt.write(endereco + '\r\n')
            count += 1
            txt.write('CNPJ: %s\r\n' % browse_orcamento.company_id.rescon_pessoa_id.cpf_cnpj or '')
            count += 1
            telefone = browse_orcamento.pessoa_id.telefone or ''
            txt.write('TELEFONE: %s\r\n' % telefone)
            count += 1
            txt.write(
                '------------------------------------------------------------------------------------------------------------------------------------' + '\r\n')
            count += 1
        return count


report_sxw.report_sxw('report.orcamentos.orcamento.capa', 'orcamentos.orcamento.capa',
                      'orcamentos/report/rel_impressao.rml', parser=rel_impressao, header=False)
