# -*- coding: utf-8 -*-



from openerp.osv import fields, osv
from openerp.tools.translate import _


class wizard_alterar_preco_venda(osv.TransientModel):
    _name = 'wizard.alterar.preco.venda'
    _description = 'Alterar preco de venda'

    _columns = {
        'login': fields.char('Login', size=30, required=True),
        'senha': fields.char('Senha', size=30, required=True),
        'produto_id': fields.many2one('estoque.produto', 'Produto'),
        'preco_venda': fields.float('Preco', digits=(9, 2)),
        'altera': fields.boolean('pode alterar Preco de venda'),
        'texto': fields.text('log'),
        'altera_login': fields.boolean('precisa alterar login e senha'),
    }
    _defaults = {'altera': lambda *a: False,
                 'altera_login': lambda *a: True,
    }

    def default_get(self, cr, uid, fields_list, context=None):
        context = context and context.copy() or {}
        res = osv.osv_memory.default_get(self, cr, uid, fields_list, context=context)
        item_id = context.get('active_id', False)
        if item_id:
            produto_dados = self.pool.get('orcamentos.orcamento.itens').read(cr, uid, item_id,
                                                                             ['produto_id', 'valor_unitario_bruto'], context=context)
            if isinstance(produto_dados, list) and produto_dados:
                produto_dados = produto_dados[0]
            if isinstance(produto_dados, dict):
                res['produto_id'] = produto_dados.get('produto_id') and produto_dados['produto_id'][0] or False
                res['preco_venda'] = produto_dados.get('valor_unitario_bruto') or 0
        return res

    def onchange_dados(self, cr, uid, ids, login, senha):
        val = {'value': {'altera': False, 'altera_login': True}}
        val['texto'] = False
        obj = self.pool.get('ir.model.access')
        #        res = obj.check_groups(cr, uid, 'estoque.group_estoque_alterar_preco')
        #        if res == True:
        #            val['value']['altera']=True
        #            val['value']['altera_login']=False
        if login and senha:
            usuario = self.pool.get('res.users').search(cr, uid, [('login', '=', login), ('password', '=', senha)],
                                                        context=None)
            if usuario:
                usuario = usuario[0]
                res = obj.check_groups(cr, usuario, 'estoque.group_estoque_alterar_preco')
                if res == True:
                    val = {'value': {'altera': True}}
                else:
                    val = {'value': {'texto': _('Usuario sem permissao')}}
            else:
                val = {'value': {'texto': _('Usuario nao cadastrado')}}
        return val

    def altera_preco_venda(self, cr, uid, ids, context=None):
        """
            Contexto criado pois o metodo 'write' usa um metodo onchange que recalcula o preco de venda
        """

        context = context and context.copy() or {}
        context['orcamento_preco_venda'] = True
        preco_venda = self.read(cr, uid, ids, ['preco_venda'], context=context)
        if preco_venda:
            preco_venda = preco_venda[0]['preco_venda']
            item_id = context.get('active_id', False)
            if item_id:
                self.pool.get('orcamentos.orcamento.itens').write(cr, uid, item_id, {'orcori_preco_venda': preco_venda},
                                                                  context=context)
        return {'type': 'ir.actions.act_window_close'}
