# -*- encoding: utf-8 -*-

from openerp.osv import fields, osv
from datetime import datetime, date, timedelta
import time


AVAILABLE_STATE = [
    ('ES','Esboco'),
    ('EA', 'Em Avaliacao'),
    ('AV', 'Avaliado'),
    ('PE', 'Contactando Cliente/Fornecedor'),
    ('AP', 'Aprovado'),#ate este status ele pode cancelar...
    ('RE', 'Reprovado'),
    ('EE', 'Em Execucao'),
    ('EX', 'Executado'),
    ('CR', 'Cliente Contactado.Aguardando Retirada'),
    ('AF','Faturada para Cliente'),
    ('FA','Faturada para Cliente/Fornecedor'),
    ('CA', 'Cancelado'),
    #deixar status abaixo, por causa dos tratamentos do crm
    ('draft', 'Draft'),
    ('open', 'Open'),
    ('cancel', 'Cancel'),
    ('done', 'Close'),
    ('pending', 'Pending'),
]

AVAILABLE_STATE_S=[
    ('ES', 'Esboco'),
    ('EA', 'Avaliacao'),#ate este status pode cancelar
    ('AV', 'Avaliado'),
    ('AP', 'Aprovado'),
    ('RE', 'Reprovado'),
    ('EE', 'Em Execucao'),
    ('CL','Concluido'),
    ('CA', 'Cancelado'),
    ('FA','Faturado')
]

class rma_servico(osv.Model):

    _name = "rma.servico"
    _inherit = "rma.servico"

    def onchange_servico(self, cr, uid, ids, servico_id, context=None):
        context = context and context.copy() or {}
        tempo = 0
        if servico_id:
            servico_tempo = self.pool.get('estoque.produto').read(cr, uid, servico_id, ['tempo_previsto'], context=context)
            if isinstance(servico_tempo, list):
                servico_tempo = servico_tempo[0]
            if isinstance(servico_tempo, dict):
                if servico_tempo.get('tempo_previsto'):
                    tempo = servico_tempo['tempo_previsto']
        return {'value':{'quantidade': tempo}}

    def historiar(self,cr,uid,ordens,name,context={}):
        for ordem in self.pool.get('ordem.servico').browse(cr,uid,ordens):
            data = {
                'name': name,
                'canal_id': ordem.canal_id.id,
                'user_id': uid,
                'date': time.strftime('%Y-%m-%d %H:%M:%S'),
                'ordem_id': ordem.id,
                'section_id': ordem.section_id.id
            }
            obj_hist = self.pool.get('ordem.servico.historico')
            data['description'] = name
            data['email'] = ordem.user_id.login or \
                        (ordem.user_id and ordem.user_id.pessoa_id.name and
                         ordem.user_id.pessoa_id.email) or False
            obj_hist.create(cr, uid, data, context)
        return True

    def button_esboco(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        read=self.read(cr,uid,ids[0],['ordem_id','state','servico_id'], context=context)
        servico='Servico: '+read['servico_id'][1].encode('utf-8')+'. Status: '
        ordem=read['ordem_id'][0]
        self.write(cr, uid, ids, {'state': 'ES'}, context=context)
        self.log(cr, uid, ids[0], servico+'Servico em Esboco.')
        self.historiar(cr, uid, [ordem],servico+'Servico em Esboco.')
        return True

    def button_em_avaliacao(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        read=self.read(cr,uid,ids[0],['ordem_id','state','servico_id'], context=context)
        servico='Servico: '+read['servico_id'][1].encode('utf-8')+'. Status: '
        ordem=read['ordem_id'][0]
        for x in AVAILABLE_STATE_S:
            if x[0]==read['state']:
                st1=x[1]
            if x[0]=='EA':
                st2=x[1]
        self.write(cr, uid, ids, {'state': 'EA'}, context=context)
        self.log(cr, uid, ids[0],servico+st2)
        self.historiar(cr, uid, [ordem],servico+st1+' >> '+st2)
        return True

    def button_avaliado(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        read=self.read(cr,uid,ids[0],['ordem_id','state','servico_id'], context=context)
        servico='Servico: '+read['servico_id'][1].encode('utf-8')+'. Status: '
        ordem=read['ordem_id'][0]
        for x in AVAILABLE_STATE_S:
            if x[0]==read['state']:
                st1=x[1]
            if x[0]=='AV':
                st2=x[1]
        self.write(cr, uid, ids, {'state': 'AV'}, context=context)
        self.log(cr, uid, ids[0],servico+st2)
        self.historiar(cr, uid, [ordem],servico+st1+' >> '+st2)
        return True

    def button_aprovado(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        read=self.read(cr,uid,ids[0],['ordem_id','state','servico_id'], context=context)
        servico='Servico: '+read['servico_id'][1].encode('utf-8')+'. Status: '
        ordem=read['ordem_id'][0]
        for x in AVAILABLE_STATE_S:
            if x[0]==read['state']:
                st1=x[1]
            if x[0]=='AP':
                st2=x[1]
        self.write(cr, uid, ids, {'state': 'AP'}, context=context)
        self.log(cr, uid, ids[0],servico+st2)
        self.historiar(cr, uid, [ordem],servico+st1+' >> '+st2)
        return True

    def button_reprovado(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        read=self.read(cr,uid,ids[0],['ordem_id','state','servico_id'], context=context)
        servico='Servico: '+read['servico_id'][1].encode('utf-8')+'. Status: '
        ordem=read['ordem_id'][0]
        for x in AVAILABLE_STATE_S:
            if x[0]==read['state']:
                st1=x[1]
            if x[0]=='RE':
                st2=x[1]
        self.write(cr, uid, ids, {'state': 'RE'}, context=context)
        self.log(cr, uid, ids[0],servico+st2)
        self.historiar(cr, uid, [ordem],servico+st1+' >> '+st2)
        return True

    def button_executando(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        read=self.read(cr,uid,ids[0],['ordem_id','state','servico_id'], context=context)
        servico='Servico: '+read['servico_id'][1].encode('utf-8')+'. Status: '
        ordem=read['ordem_id'][0]
        for x in AVAILABLE_STATE_S:
            if x[0]==read['state']:
                st1=x[1]
            if x[0]=='EE':
                st2=x[1]
        self.write(cr, uid, ids, {'state': 'EE'}, context=context)
        self.log(cr, uid, ids[0],servico+st2)
        self.historiar(cr, uid, [ordem],servico+st1+' >> '+st2)
        return True

    def button_concluido(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        read=self.read(cr,uid,ids[0],['ordem_id','state','servico_id'], context=context)
        servico='Servico: '+read['servico_id'][1].encode('utf-8')+'. Status: '
        ordem=read['ordem_id'][0]
        for x in AVAILABLE_STATE_S:
            if x[0]==read['state']:
                st1=x[1]
            if x[0]=='CL':
                st2=x[1]
        self.write(cr, uid, ids, {'state': 'CL'}, context=context)
        self.log(cr, uid, ids[0],servico+st2)
        self.historiar(cr, uid, [ordem],servico+st1+' >> '+st2)
        return True

    def button_cancelar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        read=self.read(cr,uid,ids[0],['ordem_id','state','servico_id'], context=context)
        servico='Servico: '+read['servico_id'][1].encode('utf-8')+'. Status: '
        ordem=read['ordem_id'][0]
        for x in AVAILABLE_STATE_S:
            if x[0]==read['state']:
                st1=x[1]
            if x[0]=='CA':
                st2=x[1]
        self.write(cr, uid, ids, {'state': 'CA'}, context=context)
        self.log(cr, uid, ids[0],servico+st2)
        self.historiar(cr, uid, [ordem],servico+st1+' >> '+st2)
        return True
    def button_faturada(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        read=self.read(cr,uid,ids[0],['ordem_id','state','servico_id'], context=context)
        servico='Servico: '+read['servico_id'][1].encode('utf-8')+'. Status: '
        ordem=read['ordem_id'][0]
        for x in AVAILABLE_STATE_S:
            if x[0]==read['state']:
                st1=x[1]
            if x[0]=='CA':
                st2=x[1]
        self.write(cr, uid, ids, {'state': 'FA'}, context=context)
        self.log(cr, uid, ids[0],servico+st2)
        self.historiar(cr, uid, [ordem],servico+st1+' >> '+st2)
        return True
