# -*- encoding: utf-8 -*-
from openerp.osv import fields, osv
from openerp.tools.translate import _
from datetime import date
import time
import sys


class rma_nf(osv.Model):
    _name = 'rma.nf'
    _inherit = 'rma.nf'

    def inserir_servico(self, cr, uid, company_id, nf_id, context=None):
        #        try:
        context = context and context.copy() or {}
        vr_total = 0
        obj_estoque = self.pool.get('estoque.produto')
        obj_rma_servico = self.pool.get('rma.servico')
        obj_estoque_preco = self.pool.get('estoque.preco.venda')
        obj_mov_itens = self.pool.get('estoque.movimento.itens')
        obj_servicos_pgtos = self.pool.get('financeiro.fornecedores.servico.pagamento')

        rma_servico = obj_rma_servico.search(cr, uid, [('ordem_id', 'in', context.get('os_id'))], context=context)
        if rma_servico:
            rma_servico_ids = obj_rma_servico.read(cr, uid, rma_servico, ['servico_id'], context=context)
            if rma_servico_ids:
                list_servico_ids = []
                for i in rma_servico_ids:
                    list_servico_ids.append(i['servico_id'][0])
                fornec_servico = obj_servicos_pgtos.search(cr, uid, [('fornecedor_id', '=', context.get('fabricante')),
                                                                     ('servico_id', 'in', list_servico_ids)],
                                                           context=context)
                if fornec_servico and list_servico_ids:
                    fornec_servico = obj_servicos_pgtos.read(cr, uid, fornec_servico, ['servico_id'], context=context)
                    if fornec_servico:
                        if context.get('tipo_pessoa') == "Cliente":
                            for i in fornec_servico:
                                list_servico_ids.remove(i['servico_id'][0])
                        elif context.get('tipo_pessoa') == "Fornecedor":
                            list_servico_ids = []
                            for i in fornec_servico:
                                list_servico_ids.append(i['servico_id'][0])
                elif not fornec_servico and context.get('tipo_pessoa') == "Fornecedor":
                    list_servico_ids = []
                if list_servico_ids:
                    servico = obj_estoque.read(cr, uid, list_servico_ids, ['preco_venda_ids'], context=context)
                    # list: [{'preco_venda_ids': [9], 'codigo': u'45', 'id': 29}]
                    if servico:
                        for i in servico:
                            preco = obj_estoque_preco.search(cr, uid, [('company_id', '=', company_id),
                                                                       ('id', 'in', i['preco_venda_ids'])],
                                                             context=context)
                            if preco:
                                preco = obj_estoque_preco.read(cr, uid, preco[0], ['preco_venda'],
                                                               context=context)['preco_venda']
                                obj_mov_itens.create(cr, uid, {
                                    'nf_id': nf_id,
                                    'produto_id': i['id'],
                                    'quantidade': 1,
                                    'vr_unitario': preco,
                                    'vr_total_item': preco,
                                    'verifica_usa_grade': False
                                }, context)
                                vr_total += preco
                            else:
                                raise osv.except_osv(_('Atencao'),
                                                     _('O Servico:  ' + str(obj_estoque.browse(cr, uid, i[
                                                         'id']).name) + 'nao possui preco cadastrado'))
                        return vr_total
        cr.rollback()
        return 0

    #        except:
    #            raise osv.except_osv(_('Atencao'),_('Erro no Modulo Ordem_Servico: Arquivo nf_rma.py, Funcao - inserir_servico: '+str(sys.exc_info())))

    def inserir_produto(self, cr, uid, company_id, nf_id, context=None):
        #        try:
        context = context and context.copy() or {}
        vr_total = 0
        obj_rma_produto = self.pool.get('rma.produto')
        obj_serie = self.pool.get('estoqueserie.produto')
        obj_embalagem = self.pool.get('estoque.embalagem')
        obj_mov_itens = self.pool.get('estoque.movimento.itens')
        obj_troca_itens = self.pool.get('estoqueressuprimento.troca.itens')
        obj_requisicao = self.pool.get('estoqueressuprimento.requisicao.capa')

        rma_produto = obj_rma_produto.search(cr, uid, [('ordem_id', 'in', context.get('os_id'))], context=context)
        if rma_produto:
            rma_produto_ids = obj_rma_produto.read(cr, uid, rma_produto, ['produto_id', 'numero_serie'],
                                                   context=context)
            if rma_produto_ids:
                list_rma_produto_ids = []
                list_produtos_rma = []
                for i in rma_produto_ids:
                    list_rma_produto_ids.append({'produto_id': i['produto_id'][0], 'nro_serie': i.get('numero_serie')})
                    list_produtos_rma.append(i['produto_id'][0])
                    # list: [{'produto_id':16, 'nro_serie':u'1111111111'}]
                if list_rma_produto_ids:
                    numero_os = obj_requisicao.fields_get(cr, uid, ['numero_os'])
                    if numero_os:
                        requisicao_ids = obj_requisicao.search(cr, uid, [('tipo', '=', 'TR'),
                                                                         ('state', '=', 'O'),
                                                                         ('numero_os', 'in', context.get('os_id'))],
                                                               context=context)
                    else:
                        requisicao_ids = obj_requisicao.search(cr, uid, [('tipo', '=', 'TR'),
                                                                         ('state', '=', 'O'), ], context=context)

                    if requisicao_ids:
                        if context.get('tipo_pessoa') == "Cliente":
                            troca_itens_ids = obj_troca_itens.search(cr, uid, [('troca_id', 'in', requisicao_ids),
                                                                               ('produto_novo_id', 'in',
                                                                                list_produtos_rma)],
                                                                     context=context)
                            if troca_itens_ids:
                                troca_itens = obj_troca_itens.read(cr, uid, troca_itens_ids,
                                                                   ['produto_novo_id', 'nro_serie'],
                                                                   context=context)
                                if troca_itens:
                                    for i in troca_itens:
                                        if i.get('nro_serie', False):
                                            for j in list_rma_produto_ids:
                                                if j.get('produto_id') == i['produto_novo_id'][0]:
                                                    j['nro_serie'] = i.get('nro_serie')
                                                    break
                        elif context.get('tipo_pessoa') == "Fornecedor":
                            troca_itens_ids = obj_troca_itens.search(cr, uid, [('troca_id', 'in', requisicao_ids),
                                                                               ('produto_antigo_id', 'in',
                                                                                list_produtos_rma)],
                                                                     context=context)
                            if troca_itens_ids:
                                troca_itens = obj_troca_itens.read(cr, uid, troca_itens_ids,
                                                                   ['produto_antigo_id', 'nro_serie'],
                                                                   context=context)
                                if troca_itens:
                                    fornec_prod = []
                                    fornec_serie = []
                                    for i in troca_itens:
                                        fornec_prod.append(i['produto_antigo_id'][0])
                                        fornec_serie.append(i['nro_serie'])
                                    args = [('produto_id', 'in', fornec_prod), ('ordem_id', 'in', context.get('os_id'))]
                                    if fornec_serie:
                                        args.append(('numero_serie', 'in', fornec_serie))
                                    fornec_produtos = obj_rma_produto.search(cr, uid, args, context=context)
                                    if fornec_produtos:
                                        fornec_produtos = obj_rma_produto.read(cr, uid, fornec_produtos,
                                                                               ['produto_id', 'numero_serie'],
                                                                               context=context)
                                        if fornec_produtos:
                                            list_rma_produto_ids = []
                                            for i in fornec_produtos:
                                                list_rma_produto_ids.append({'produto_id': i['produto_id'][0],
                                                                             'nro_serie': i.get('numero_serie')})
                        if list_rma_produto_ids:
                            vals = {}
                            for i in list_rma_produto_ids:
                                vals['nf_id'] = nf_id
                                vals['produto_id'] = i.get('produto_id')
                                vals['grade_id'] = None
                                vals['local_id'] = None
                                vals['produto_embalagem_id'] = 1
                                vals['quantidade'] = 1
                                vals['vr_unitario'] = 0
                                grade = self.pool.get('estoque.produto.grade').search(cr, uid, [
                                    ('produto_id', '=', i.get('produto_id'))], context=context)
                                if grade:
                                    vals['grade_id'] = grade[0]
                                    local = self.pool.get('estoque.local.locacao').search(cr, uid, [
                                        ('produto_id', '=', i.get('produto_id')),
                                        ('grade_id', '=', grade[0])], context=context)
                                    if local:
                                        local = \
                                            self.pool.get('estoque.local.locacao').read(cr, uid, local[0], ['local_id'],
                                                                                        context=context)['local_id']
                                        if local:
                                            vals['local_id'] = local[0]
                                preco_venda = self.pool.get('estoque.preco.venda').get_preco_venda(
                                    cr, uid, i.get('produto_id') or 0, epc_company_id=company_id)
                                obj_estoque = self.pool.get('estoque.produto')
                                dados_preco_venda = preco_venda.get(i.get('produto_id') or 0) or {}
                                preco = dados_preco_venda.get('preco_venda')
                                if preco == 0.00:
                                    raise osv.except_osv(_('Atencao'),
                                                         _('O Produto: ' + str(
                                                             obj_estoque.browse(cr, uid, i['produto_id']).name,
                                                                                context=context) + ' nao possui preco cadastrado'))
                                else:
                                    vals['vr_unitario'] = preco
                                    nf_mov_id = obj_mov_itens.create(cr, uid, vals, context)
                                    cr.commit()
                                    if nf_mov_id:
                                        if i.get('nro_serie'):
                                            context['active_id'] = int(nf_mov_id)
                                            obj_serie.create(cr, uid, {'nro_serie': i['nro_serie']}, context=context)
                                    vr_total += preco * obj_embalagem.read(cr, uid, 1, ['quantidade_na_embalagem'],
                                                                           context=context)['quantidade_na_embalagem']
                            return vr_total
        cr.rollback()
        return 0

    #        except:
    #            raise osv.except_osv(_('Atencao'),_('Erro no Modulo Ordem_Servico: Arquivo nf_rma.py, Funcao - inserir_produto: '+str(sys.exc_info())))

    def gerar_nf_capa(self, cr, uid, ids, context=None):
        #        try:
        context = context and context.copy() or {}
        company_id = self.pool.get('res.users').browse(cr, uid, uid, context).company_id.id
        if company_id:
            obj_parametro = self.pool.get('fiscal.parametro')
            parametro_id = obj_parametro.search(cr, uid, [], context=context)
            if not parametro_id:
                raise osv.except_osv(_('Atencao'), _('Nao existe nenhum parametro fiscal cadastrado para a empresa!'))
            else:
                cond_pgt_ids = self.pool.get('adm.condicao').search(cr, uid, [])
                if not cond_pgt_ids:
                    raise osv.except_osv(_('Atencao'), _('Nao existe nenhuma condicao de pagamento cadastrada!'))
                else:
                    cond_pgt = self.pool.get('adm.condicao').read(cr, uid, cond_pgt_ids[0], ['id'], context=context)
                    if cond_pgt.get('id', False):
                        cond_pgt = cond_pgt['id']
                        modelo_serie = obj_parametro.read(cr, uid, parametro_id[0], ['modelo_nf_series_id'],
                                                          context=context)
                        if not modelo_serie.get('modelo_nf_series_id', False):
                            raise osv.except_osv(_('Atencao'),
                                                 _('Nao existe nenhum modelo de serie para a Nota Fiscal cadastrado!'))
                        else:
                            modelo_serie = modelo_serie['modelo_nf_series_id'][0]
                            destinatario_id = self.read(cr, uid, ids, ['pessoa_id'], context=context)
                            if not destinatario_id.get('pessoa_id', False):
                                raise osv.except_osv(_('Atencao'),
                                                     _('O destinatario nao encontra-se cadastrado no sistema!'))
                            else:
                                destinatario_id = destinatario_id['pessoa_id'][0]
                                id_endereco = self.pool.get('adm.pessoa.endereco').search(cr, uid, [
                                    ('pessoa_id', '=', destinatario_id)], context=context)
                                if not id_endereco:
                                    raise osv.except_osv(_('Atencao'), _(
                                        'Nao existe endereco cadastrado para o %s' % context.get('tipo_pessoa',
                                                                                                 'destinatario')))
                                elif modelo_serie:
                                    nf_id = self.pool.get('fiscal.nf.capa').create(cr, uid, {
                                        'tipo': 'S',
                                        'company_id': company_id,
                                        'destinatario_id': destinatario_id,
                                        'destinatario_endereco_id': id_endereco[0],
                                        'modelo_nf_series_id': modelo_serie,
                                        'condicao_pgto_id': cond_pgt
                                    }, context)
                                    if nf_id:
                                        return {'nf_id': int(nf_id), 'company_id': company_id}

        cr.rollback()
        return False

    #        except:
    #            raise osv.except_osv(_('Atencao'),_('Erro no Modulo Ordem_Servico: Arquivo nf_rma.py, Funcao - gerar_nf_capa: '+str(sys.exc_info())))

    def processar_servico(self, cr, uid, ids, context=None):
        #        try:
        context = context and context.copy() or {}
        nf_capa = self.gerar_nf_capa(cr, uid, ids, context)
        if isinstance(nf_capa, dict):
            nf_id = nf_capa.get('nf_id', [])
            company_id = nf_capa.get('company_id', [])
            if nf_id:
                vr_total = 0
                obj_estoque = self.pool.get('estoque.produto')
                obj_serie = self.pool.get('estoqueserie.produto')
                obj_embalagem = self.pool.get('estoque.embalagem')
                obj_mov_itens = self.pool.get('estoque.movimento.itens')
                obj_estoque_preco = self.pool.get('estoque.preco.venda')

                if context.get('tipo_pessoa') == 'Cliente':
                    destinatario_id = self.read(cr, uid, ids, ['pessoa_id'], context=context)
                    if not destinatario_id.get('pessoa_id', False):
                        raise osv.except_osv(_('Atencao'), _('O destinatario nao encontra-se cadastrado no sistema!'))
                    else:
                        destinatario_id = destinatario_id['pessoa_id'][0]
                        if not self.pool.get('financeiro.cliente').search(cr, uid,
                                                                          [('pessoa_id', '=', destinatario_id)],
                                                                          context=context):
                            raise osv.except_osv(_('Atencao'),
                                                 _('O destinatario nao encontra-se cadastrado como um cliente!'))
                        else:
                            ######################### CRIAÇÃO DOS SERVIÇOS PARA O CLIENTE ########################
                            vr_total = self.inserir_servico(cr, uid, company_id, nf_id, context)
                            ########################## CRIAÇÃO DOS EQUIPAMENTOS ADICIONAIS PARA O CLIENTE ####################
                            obj_rma_produto_add = self.pool.get('rma.equipamento_adicionado')
                            rma_produto_add = obj_rma_produto_add.search(cr, uid,
                                                                         [('ordem_id', 'in', context.get('os_id'))],
                                                                         context=context)
                            if rma_produto_add:
                                rma_produto_add_ids = obj_rma_produto_add.read(cr, uid, rma_produto_add,
                                                                               ['local_id', 'quantidade',
                                                                                'produto_id', 'ordem_id',
                                                                                'numero_serie', 'grade_id'],
                                                                               context=context)
                                if rma_produto_add_ids:
                                    for i in rma_produto_add_ids:
                                        produto_preco_ids = \
                                            obj_estoque.read(cr, uid, i['produto_id'][0], ['preco_venda_ids'],
                                                             context=context)['preco_venda_ids']
                                        preco = obj_estoque_preco.search(cr, uid, [('company_id', '=', company_id),
                                                                                   ('id', 'in', produto_preco_ids),
                                                                                   ('produto_id', '=',
                                                                                    i['produto_id'][0])],
                                                                         context=context)
                                        if not preco:
                                            raise osv.except_osv(_('Atencao'),
                                                                 _('O Produto: ' + str(obj_estoque.browse(cr, uid,
                                                                                                          i[
                                                                                                              'id']).name) + ' nao possui preco cadastrado'))
                                        else:
                                            preco = obj_estoque_preco.read(cr, uid, preco[0], ['preco_venda'],
                                                                           context=context)['preco_venda']
                                            if i['numero_serie']:
                                                quantidade = 1
                                            else:
                                                quantidade = i['quantidade']
                                            nf_mov_id = obj_mov_itens.create(cr, uid, {'nf_id': nf_id,
                                                                                       'produto_id': i['produto_id'][0],
                                                                                       'grade_id': i['grade_id'][0],
                                                                                       'local_id': i['local_id'][0],
                                                                                       'produto_embalagem_id': 1,
                                                                                       'quantidade': quantidade,
                                                                                       'vr_unitario': preco,
                                                                                       }, context=context)
                                            cr.commit()
                                            if nf_mov_id:
                                                if i['numero_serie']:
                                                    context['active_id'] = int(nf_mov_id)
                                                    obj_serie.create(cr, uid, {'nro_serie': i['numero_serie']},
                                                                     context=context)
                                            embalagem_id = obj_embalagem.search(cr, uid, [], context=context)
                                            if not embalagem_id:
                                                embalagem = 1
                                            else:
                                                embalagem = obj_embalagem.read(cr, uid, embalagem[0],
                                                                               ['quantidade_na_embalagem'],
                                                                               context=context)
                                                if not embalagem.get('quantidade_na_embalagem', False):
                                                    embalagem = embalagem['quantidade_na_embalagem']
                                                else:
                                                    embalagem = 1
                                            vr_total += quantidade * preco * embalagem
                            ########################## CRIAÇÃO DOS EQUIPAMENTOS PARA O CLIENTE ####################
                            vr_total += self.inserir_produto(cr, uid, company_id, nf_id, context)

                elif context.get('tipo_pessoa') == 'Fornecedor':
                    ####################### CRICAÇÃO DOS SERVIÇOS PAGOS PELO FORNECEDOR #######################
                    vr_total += self.inserir_servico(cr, uid, company_id, nf_id, context)

                    ###################### CRIAÇÃO DOS EQUIPAMENTOS PARA O FORNECEDOR #######################
                    vr_total += self.inserir_produto(cr, uid, company_id, nf_id, context)

            self.pool.get('fiscal.nf.capa').write(cr, uid, nf_id, {'vr_total_nf': vr_total}, context)
            self.write(cr, uid, ids,
                       {'state': '2', 'nf_id': nf_id, 'data_geracao_nf': date.today().strftime('%d-%m-%Y')},
                       context)
            #        except Exception as e:
            #            raise osv.except_osv(_('Atencao'),_('Erro no Modulo Ordem_Servico: Arquivo nf_rma.py, Funcao - processar_servico: '+str(e)))

    def gerar_nf_ordens(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        pessoa_id = self.read(cr, uid, ids[0], ['pessoa_id'], context=context)['pessoa_id'][0]
        fabricante = self.pool.get('financeiro.fornecedor').search(cr, uid, [('pessoa_id', '=', pessoa_id)],
                                                                   context=context)
        if fabricante:
            context['fabricante'] = fabricante[0]
        nf_capa = self.gerar_nf_capa(cr, uid, ids[0], context=context)
        if nf_capa:
            nf_id = nf_capa.get('nf_id')
            company_id = nf_capa.get('company_id')
            rma_ordens = self.read(cr, uid, ids[0], ['rma_ordens_ids'], context=context)
            if rma_ordens:
                rma_ordens = rma_ordens['rma_ordens_ids']
                #                rma_nf_ids = self.pool.get('rma.nf.ordens').search(cr, uid, [('id','in',rma_ordens['rma_ordens_ids']),
                #                                                                             ('rma_nf_ids','=',rma_ordens['id'])], context=context)
                ordens = self.pool.get('rma.nf.ordens').read(cr, uid, rma_ordens, ['protocolo'], context=context)
                vr_total = 0
                os_ids = []
                #                context['tipo_pessoa'] = "Fornecedor"
                for i in ordens:
                    context['os_id'] = [i['protocolo'][0]]
                    os_ids.append(i['protocolo'][0])
                    vr = self.inserir_produto(cr, uid, company_id, nf_id, context)
                    if vr:
                        vr_total += vr
                    vr = self.inserir_servico(cr, uid, company_id, nf_id, context)
                    if vr:
                        vr_total += vr
                if ordens:
                    state = ""
                    if context.get('tipo_pessoa') == "Cliente":
                        state = 'AF'
                    elif context.get('tipo_pessoa') == "Fornecedor":
                        state = 'FA'
                    if state:
                        self.pool.get('fiscal.nf.capa').write(cr, uid, nf_id, {'vr_total_nf': vr_total}, context)
                        self.write(cr, uid, ids,
                                   {'state': '2', 'data_geracao_nf': time.strftime('%Y-%m-%d'), 'nf_id': nf_id},
                                   context)
                        self.pool.get('rma.nf.ordens').write(cr, uid, rma_ordens, {'processar': True}, context)
                        self.pool.get('ordem.servico').write(cr, uid, os_ids, {'state': state}, context)
                        return True
        cr.rollback()
        return False
