# -*- encoding: utf-8 -*-

from openerp.osv import fields, osv
from datetime import datetime, date, timedelta
import time


AVAILABLE_STATE = [
    ('ES','Esboco'),
    ('EA', 'Em Avaliacao'),
    ('AV', 'Avaliado'),
    ('PE', 'Contactando Cliente/Fornecedor'),
    ('AP', 'Aprovado'),#ate este status ele pode cancelar...
    ('RE', 'Reprovado'),
    ('EE', 'Em Execucao'),
    ('EX', 'Executado'),
    ('CR', 'Cliente Contactado.Aguardando Retirada'),
    ('AF','Faturada para Cliente'),
    ('FA','Faturada para Cliente/Fornecedor'),
    ('CA', 'Cancelado'),
    #deixar status abaixo, por causa dos tratamentos do crm
    ('draft', 'Draft'),
    ('open', 'Open'),
    ('cancel', 'Cancel'),
    ('done', 'Close'),
    ('pending', 'Pending'),
]

AVAILABLE_STATE_S=[
    ('ES', 'Esboco'),
    ('EA', 'Avaliacao'),#ate este status pode cancelar
    ('AV', 'Avaliado'),
    ('AP', 'Aprovado'),
    ('RE', 'Reprovado'),
    ('EE', 'Em Execucao'),
    ('CL','Concluido'),
    ('CA', 'Cancelado'),
    ('FA','Faturado')
]

class ordem_servico(osv.Model):

    _name = "ordem.servico"
    _inherit = "ordem.servico"
    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not len(ids):
            return []
        reads = self.browse(cr, uid, ids, context=context)
        res = []
        for record in reads:
            _id=record.id
            res.append((record['id'], _id))
        return res

    def button_gerar_troca(self,cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return True

    def onchange_data_atendimento(self, cr, uid, ids, date, categ_id, context=None):
        context = context and context.copy() or {}
        res = super(ordem_servico,self).onchange_data_atendimento( cr, uid, ids, date, categ_id, context=context)
        if categ_id:
            garantia = self.pool.get('crm_br.case.categ').read(cr, uid, categ_id, ['name'], context=context)
            if isinstance(garantia, list):
                garantia = garantia[0]
            if isinstance(garantia, dict):
                garantia = garantia.get('name', '').encode('UTF-8')
                if garantia == "Visita Tecnica":
                    res['value']['flag'] = 'VT'
                elif garantia == "Garantia Fornecedor":
                    res['value']['flag'] = 'GF'
                elif garantia == "Garantia Loja":
                    res['value']['flag'] = 'GL'
                elif garantia == "Conserto":
                    res['value']['flag'] = 'CO'
        return res

    def onchange_data(self, cr, uid, ids, nf_id, context=None):
        context = context and context.copy() or {}
        if nf_id:
            data = self.pool.get('fiscal.nf.capa').read(cr, uid, nf_id, ['data_saida_entrada'], context=context)['data_saida_entrada']
            return {'value':{'data_emi_nf':data}}

    def historiar(self,cr,uid,ordens,name,context={}):
        for ordem in self.browse(cr,uid,ordens):
            data = {
                'name': name,
                'canal_id': ordem.canal_id.id,
                'user_id': uid,
                'date': time.strftime('%Y-%m-%d %H:%M:%S'),
                'ordem_id': ordem.id,
                'section_id': ordem.section_id.id
            }
            obj_hist = self.pool.get('ordem.servico.historico')
            data['description'] = name
            data['email'] = ordem.user_id.login or \
                        (ordem.user_id and ordem.user_id.pessoa_id.name and
                         ordem.user_id.pessoa_id.email) or False
            obj_hist.create(cr, uid, data, context)
        return True
    def button_esboco(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': 'ES'}, context)
        self.log(cr, uid, ids[0], 'Ordem de Servico em Esboco.')
        return True

    def button_em_avaliacao(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': 'EA'}, context)
        self.log(cr, uid, ids[0], 'Ordem de Servico em Avaliacao.')
        self.pool.get("ordem.servico").historiar(cr, uid, ids,'Alteracao do Status da OS de: Esboco >> Em Avaliacao')
        self.historiar(cr, uid, ids,'Alteracao do Status da OS de: Esboco >> Em Avaliacao')
        return True

    def button_avaliado(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': 'AV'}, context)
        self.log(cr, uid, ids[0], 'Ordem de Servido Avaliada.')
        self.historiar(cr, uid, ids,'Alteracao do Status da OS de: Em Avaliacao >> Avaliado')
        return True

    def button_contactando(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': 'PE'}, context)
        self.log(cr, uid, ids[0], 'Contactando Cliente/Fornecedor.')
        self.historiar(cr, uid, ids,'Alteracao do Status da OS de: Avaliado >> Contactando')
        return True

    def button_aprovado(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': 'AP'}, context)
        self.log(cr, uid, ids[0], 'Ordem de Servico Aprovada.')
        self.historiar(cr, uid, ids,'Alteracao do Status da OS de: Contactando >> Aprovado')
        return True

    def button_reprovado(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': 'RE'}, context)
        self.log(cr, uid, ids[0], 'Ordem de Servico Reprovada.')
        self.historiar(cr, uid, ids,'Alteracao do Status da OS de: Contactando >> Reprovado')
        return True

    def button_executando(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': 'EE'}, context)
        self.log(cr, uid, ids[0], 'Ordem de Servico em Execucao.')
        self.historiar(cr, uid, ids,'Alteracao do Status da OS de: Aprovado >> Executando')
        return True

    def button_executado(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        numero_os = self.pool.get('estoqueressuprimento.requisicao.capa').fields_get(cr,uid,['numero_os'])

        if numero_os:
            troca_aberta = self.pool.get('estoqueressuprimento.requisicao.capa').search(cr, uid, [('numero_os','=',ids),
                                                                                              ('state','!=','O')],
                                                                                        context=context)
            if troca_aberta:
                raise osv.except_osv('SigERP', 'Exitem Trocas nao concluidas para a OS')

        self.write(cr, uid, ids, {'state': 'EX'}, context)
        self.log(cr, uid, ids[0], 'Ordem de Servico Executada.')
        self.historiar(cr, uid, ids,'Alteracao do Status da OS de: Executando >> Executado')
        return True

    def button_aguardando_retirada(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': 'CR'}, context)
        self.log(cr, uid, ids[0], 'Cliente contactado.Aguardando Retirada.')
        self.historiar(cr, uid, ids,'Alteracao do Status da OS de: Executado >> Aguardando Retirada')
        return True

    def button_imprimir(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        pessoa_id = 0
        os_dados = self.read(cr, uid, ids, ['pessoa_id'], context=context)
        if isinstance(os_dados, list):
            os_dados = os_dados[0]
        if isinstance(os_dados, dict):
            if os_dados.get('pessoa_id'):
                try:
                    pessoa_id = os_dados['pessoa_id'][0]
                except:
                    pass
        empresa_id = self.pool.get('res.users').browse(cr, uid, uid).company_id.id
        if pessoa_id and empresa_id:
            datas = {'company_id': empresa_id, 'pessoa_id': pessoa_id}
            return {'type': 'ir.actions.report.xml','report_name': 'carta.aviso','datas': datas}
        return False

    def button_cancelar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': 'CA'}, context)
        self.log(cr, uid, ids[0], 'Ordem de Servico cancelada.')
        self.historiar(cr, uid, ids,'Alteracao do Status da OS de: Cancelada')
        return True

    def button_a_faturar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        context['fabricante'] = self.browse(cr,uid,ids[0]).fabricante_id.id
        context['tipo_pessoa'] = "Cliente"
        nf_rma_id = self.pool.get('rma.nf').create(cr, uid, {
                                                         'pessoa_id':self.browse(cr,uid,ids[0]).pessoa_id.id,
                                                         'tipo': 'C'
                                                         }, context)
        if nf_rma_id:
            self.pool.get('rma.nf.ordens').create(cr, uid, {
                                                            'protocolo':ids[0],
                                                            'rma_nf_id':nf_rma_id
                                                         }, context)
        cr.commit()
        id = int(nf_rma_id)
        context['os_id'] = ids
        res = self.pool.get('rma.nf').processar_servico(cr, uid, id, context)
        self.write(cr, uid, ids, {'state': 'AF'}, context)
        self.log(cr, uid, ids[0], 'Ordem de Servico Faturada.')
        self.historiar(cr, uid, ids,'Alteracao do Status da OS de: Faturada para Cliente')
        return res

    def button_faturada(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        fab_id = self.browse(cr,uid,ids[0]).fabricante_id
        if fab_id:
            fabricante_pessoa = fab_id.pessoa_id.id
            fabricante = self.browse(cr,uid,ids[0]).fabricante_id.id
            nf_rma_id = self.pool.get('rma.nf').create(cr, uid, {
                                                             'pessoa_id':fabricante_pessoa,
                                                             'tipo': 'F'
                                                             }, context)
            if nf_rma_id:
                self.pool.get('rma.nf.ordens').create(cr, uid, {
                                                                'protocolo':ids[0],
                                                                'rma_nf_id':nf_rma_id
                                                             }, context)
            cr.commit()
            id = int(nf_rma_id)

            context['os_id'] = ids
            context['tipo_pessoa'] = "Fornecedor"
            context['fabricante'] = fabricante
            res = self.pool.get('rma.nf').processar_servico(cr, uid, id, context)
        self.write(cr, uid, ids, {'state': 'FA'}, context)
        self.log(cr, uid, ids[0], 'Ordem de Servico faturarada para Fornecedor.')
        self.historiar(cr, uid, ids,'Alteracao do Status da OS de: Faturada para Cliente >> Faturada para Fornecedor')
        return res

    def button_imprimir_os(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        datas = {'capa':{}, 'equipamento_recebido_ids':[], 'equipamento_adicionado_ids':[], 'servico_ids':[]}
        os_dados = self.read(cr, uid, ids, ['pessoa_id', 'user_id', 'date', 'name', 'id', 'section_id', 'rma_produto_ids',
                                            'rma_equipamento_adicionado_ids', 'rma_servico_ids', 'nf_id', 'data_emi_nf'], context=context)

        if isinstance(os_dados, list):
            os_dados = os_dados[0]
        if isinstance(os_dados, dict):
            try:
                atendente_nome = os_dados['user_id'][1]
            except:
                atendente_nome = ''
            try:
                cliente_nome = os_dados['pessoa_id'][1]
            except:
                cliente_nome = ''
            try:
                sessao = os_dados['section_id'][1]
            except:
                sessao = ''
            datas['capa']={'atendente': atendente_nome, 'cliente': cliente_nome, 'sessao': sessao,
                           'data_atendimento': os_dados.get('date',''), 'protocolo': os_dados.get('id',0)}
            datas['equipamento_recebido_ids'] = tuple(os_dados.get('rma_produto_ids',[]))
            datas['equipamento_adicionado_ids'] = tuple(os_dados.get('rma_equipamento_adicionado_ids',[]))
            datas['servico_ids'] = tuple(os_dados.get('rma_servico_ids',[]))
            datas['empresa_id'] = self.pool.get('res.users').browse(cr, uid, uid).company_id.id
            datas['empresa_nome'] = self.pool.get('res.users').browse(cr, uid, uid).company_id.name

            if os_dados.get('nf_id'):
                try:
                    nf_id = os_dados['nf_id'][0]
                except:
                    nf_id = []
                if nf_id:
                    numero = self.pool.get('fiscal.nf.capa').browse(cr, uid, nf_id).numero_nf
                    datas['capa'].update(numero_nf = numero)
                    if os_dados.get('data_emi_nf'):
                        emissao = os_dados['data_emi_nf']
                        datas['capa'].update(nf_emissao = emissao)
            return {'type': 'ir.actions.report.xml','report_name': 'os.impressao','datas': datas}
        return False


    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        if not args:
            args = []
        context = context and context.copy() or {}
        res = super(ordem_servico, self).search(cr, uid, args, offset, limit, order, context, count)
        if context.get('nf_servico_fabricante', False):
            result=[]
            obj_rma=self.pool.get('rma.servico')
            obj_for_ser=self.pool.get('financeiro.fornecedores.servico.pagamento')
            for x in res:
                servicos=self.read(cr,uid,x,['rma_servico_ids'], context=context)['rma_servico_ids']
                if servicos:
                    prods=[]
                    p_f=[]
                    for p in servicos:
                        prods.append(obj_rma.read(cr,uid,p,['servico_id'], context=context)['servico_id'][0])
                    c_serv=obj_for_ser.search(cr,uid,[('servico_id','in',prods)], context=context)
                    for n in c_serv:
                        p_f.append(obj_for_ser.browse(cr,uid,n).servico_id.id, context=context)
                    prod_s_f=list(set(p_f))
                    if c_serv:
                        for y in self.pool.get('rma.servico').browse(cr,uid,servicos, context=context):
                            if y.state=='CL' and (y.servico_id.id in prod_s_f):
                                result.append(x)
            return result
        else:
            return res
