# -*- encoding: utf-8 -*-

from openerp.osv import fields, osv
from datetime import datetime, date, timedelta
import time


AVAILABLE_STATE = [
    ('ES','Esboco'),
    ('EA', 'Em Avaliacao'),
    ('AV', 'Avaliado'),
    ('PE', 'Contactando Cliente/Fornecedor'),
    ('AP', 'Aprovado'),#ate este status ele pode cancelar...
    ('RE', 'Reprovado'),
    ('EE', 'Em Execucao'),
    ('EX', 'Executado'),
    ('CR', 'Cliente Contactado.Aguardando Retirada'),
    ('AF','Faturada para Cliente'),
    ('FA','Faturada para Cliente/Fornecedor'),
    ('CA', 'Cancelado'),
    #deixar status abaixo, por causa dos tratamentos do crm
    ('draft', 'Draft'),
    ('open', 'Open'),
    ('cancel', 'Cancel'),
    ('done', 'Close'),
    ('pending', 'Pending'),
]

AVAILABLE_STATE_S=[
    ('ES', 'Esboco'),
    ('EA', 'Avaliacao'),#ate este status pode cancelar
    ('AV', 'Avaliado'),
    ('AP', 'Aprovado'),
    ('RE', 'Reprovado'),
    ('EE', 'Em Execucao'),
    ('CL','Concluido'),
    ('CA', 'Cancelado'),
    ('FA','Faturado')
]

class ordem_servico(osv.Model):

    _name = "ordem.servico"
    _inherit="crm_br.case"
    def _periodo_tempo(self, cr, uid, ids, field, args, context=None):
        res = {}
        context = context and context.copy() or {}
        if not len(ids):
            return {}
        if ids:
            for x in ids:
                inf=self.read(cr,uid,x,['date'], context=context)['date']
                dt_obj = datetime.strptime(inf, "%Y-%m-%d %H:%M:%S")
                hoje= datetime.today()
                if dt_obj:
                    d = hoje - dt_obj
                    res[x]=d.days
            return res

    def _total_servico(self, cr, uid, ids, field_name, arg, context=None):
        res={}
        total = 0

        context = context and context.copy() or {}
        if not len(ids):
            return {}
        if ids:
            obj_servico = self.pool.get('rma.servico')
            id_servico = obj_servico.search(cr,uid,[('ordem_id','=',ids)], context=context)
            for x in id_servico:
                rma_servico = obj_servico.read(cr,uid,x,['servico_id'], context=context)['servico_id'][0]
                preco_venda = self.pool.get('estoque.preco.venda').get_preco_venda(cr, uid, rma_servico)
                dados_preco_venda = preco_venda.get(rma_servico) or {}
                vlr_serv = dados_preco_venda.get('preco_venda')
                total += vlr_serv
            res[ids[0]] = total
            return res

    def _total_equipamento(self, cr, uid, ids, field_name, arg, context=None):
        res={}
        total = 0
        context = context and context.copy() or {}
        if not len(ids):
            return {}
        if ids:
            obj_produto = self.pool.get('rma.produto')
            id_produto = obj_produto.search(cr,uid,[('ordem_id','=',ids)], context=context)
            for x in id_produto:
                rma_produto = obj_produto.read(cr,uid,x,['produto_id'], context=context)['produto_id'][0]
                preco_venda = self.pool.get('estoque.preco.venda').get_preco_venda(cr, uid, rma_produto)
                dados_preco_venda = preco_venda.get(rma_produto) or {}
                vlr_produt = dados_preco_venda.get('preco_venda')
                total += vlr_produt
            res[ids[0]] = total
            return res


    _columns={
         'rma_servico_ids': fields.one2many('rma.servico', 'ordem_id','RMA Servico'),
         'nf_id': fields.many2one("fiscal.nf.capa",'Nro. da Nota Fiscal', domain="[('tipo','=','S')]", ondelete="restrict"),
         'rma_produto_ids':fields.one2many('rma.produto','ordem_id','Equipamento'),
         'data_emi_nf':fields.date('Data Emissao da NF'),
         'numero_nota_fabricante':fields.integer('Numero da Nota',size=20),
         'state': fields.selection(AVAILABLE_STATE, 'Status', size=16, readonly=True),
         'flag':fields.char('flag', size=2),
         'fabricante_id' : fields.many2one("financeiro.fornecedor", 'Fabricante', ondelete="cascade", select=True), # id do fabricante do produto
         'rma_parametro_ids':fields.one2many('ordem_servico.parametro','parametro_id','Paramento'),
         'rma_tempo_abertura': fields.function(_periodo_tempo, method=True, string='Tempo', type='integer',  store=True),
         'rma_equipamento_adicionado_ids': fields.one2many('rma.equipamento_adicionado', 'ordem_id','RMA Equipamento Adicionado'),
         'total_servico': fields.function(_total_servico, method=True, string='Valor Total Servicos', type='float'),
         'total_equipamento': fields.function(_total_equipamento, method=True, string='Valor Total Equipamento', type='float'),
         'ordem_history_line': fields.one2many('ordem.servico.historico', 'ordem_id', 'Communication', readonly=1),
         'ordem_log_ids': fields.one2many('ordem.servico.log', 'ordem_id', 'Logs History', readonly=1),
    }
    _defaults={
        'state':lambda * a:'ES'
    }
