# -*- encoding: utf-8 -*-

from openerp.osv import fields, osv
from datetime import datetime, date, timedelta
import time


AVAILABLE_STATE = [
    ('ES','Esboco'),
    ('EA', 'Em Avaliacao'),
    ('AV', 'Avaliado'),
    ('PE', 'Contactando Cliente/Fornecedor'),
    ('AP', 'Aprovado'),#ate este status ele pode cancelar...
    ('RE', 'Reprovado'),
    ('EE', 'Em Execucao'),
    ('EX', 'Executado'),
    ('CR', 'Cliente Contactado.Aguardando Retirada'),
    ('AF','Faturada para Cliente'),
    ('FA','Faturada para Cliente/Fornecedor'),
    ('CA', 'Cancelado'),
    #deixar status abaixo, por causa dos tratamentos do crm
    ('draft', 'Draft'),
    ('open', 'Open'),
    ('cancel', 'Cancel'),
    ('done', 'Close'),
    ('pending', 'Pending'),
]

AVAILABLE_STATE_S=[
    ('ES', 'Esboco'),
    ('EA', 'Avaliacao'),#ate este status pode cancelar
    ('AV', 'Avaliado'),
    ('AP', 'Aprovado'),
    ('RE', 'Reprovado'),
    ('EE', 'Em Execucao'),
    ('CL','Concluido'),
    ('CA', 'Cancelado'),
    ('FA','Faturado')
]
class ordem_servico_historico(osv.Model):
    _name = "ordem.servico.historico"
    _order = "id desc"
    _inherits = {'ordem.servico.log':"log_id"}

    def _note_get(self, cursor, user, ids, name, arg, context=None):
        context = context and context.copy() or {}
        res = {}
        for hist in self.browse(cursor, user, ids, context or {}):
            res[hist.id] = (hist.email or '/') + ' (' + str(hist.date) + ')\n'
            res[hist.id] += (hist.description or '')
        return res
    _columns = {
        'description': fields.text('Descricao'),
        'note': fields.function(_note_get, method=True, string="Anotacao", type="text"),
        'email': fields.char('Email', size=84),
        'log_id': fields.many2one('ordem.servico.log', 'Log'),
    }
