# -*- encoding: utf-8 -*-

from openerp.osv import fields, osv
from datetime import datetime, date, timedelta
import time


AVAILABLE_STATE = [
    ('ES','Esboco'),
    ('EA', 'Em Avaliacao'),
    ('AV', 'Avaliado'),
    ('PE', 'Contactando Cliente/Fornecedor'),
    ('AP', 'Aprovado'),#ate este status ele pode cancelar...
    ('RE', 'Reprovado'),
    ('EE', 'Em Execucao'),
    ('EX', 'Executado'),
    ('CR', 'Cliente Contactado.Aguardando Retirada'),
    ('AF','Faturada para Cliente'),
    ('FA','Faturada para Cliente/Fornecedor'),
    ('CA', 'Cancelado'),
    #deixar status abaixo, por causa dos tratamentos do crm
    ('draft', 'Draft'),
    ('open', 'Open'),
    ('cancel', 'Cancel'),
    ('done', 'Close'),
    ('pending', 'Pending'),
]

AVAILABLE_STATE_S=[
    ('ES', 'Esboco'),
    ('EA', 'Avaliacao'),#ate este status pode cancelar
    ('AV', 'Avaliado'),
    ('AP', 'Aprovado'),
    ('RE', 'Reprovado'),
    ('EE', 'Em Execucao'),
    ('CL','Concluido'),
    ('CA', 'Cancelado'),
    ('FA','Faturado')
]
class ordem_servico_log(osv.Model):

    from funcoes import _calcula_atendimento

    _name = "ordem.servico.log"
    _description = "Case Communication History"
    _order = "date desc"

    _columns = {
        'name': fields.char('Acao', size=64),
        'som': fields.many2one('crm_br.som', 'State of Mind'),
        'date': fields.datetime('Data'),
        'canal_id': fields.many2one('crm_br.canal', 'Canal'),
        'section_id': fields.many2one('crm_br.case.section', 'Secao'),
        'user_id': fields.many2one('res.users', 'Usuario Responsavel', readonly=True),
        'ordem_id': fields.many2one('ordem.servico', 'Ordem', required=True, ondelete='cascade'),
        'tempo_atend': fields.function(_calcula_atendimento, type='float', method=True, string='Tempo Atendimento', store=True),
    }
    _defaults = {
        'date': lambda * a: time.strftime('%Y-%m-%d %H:%M:%S'),
    }
