# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
# from SigUtils.numero import getNumeroEditado
from datetime import timedelta, datetime
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
# from openerp import netsvc
from openerp import pooler
import time


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_carta_aviso(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        pdf_file = StringIO.StringIO()

        empresa = datas['company_id']
        pessoa_id = datas['pessoa_id']

        # *******************************************************************************
        obj_emp = pooler.get_pool(cr.dbname).get("res.company")
        res = obj_emp.read(cr, uid, empresa, ['name'], context=context)
        nome_empresa = formataString(res['name'], 20, ' ', 'D', 'S', 'S')

        obj_ordem_servico = pooler.get_pool(cr.dbname).get('ordem.servico')
        obj_data = pooler.get_pool(cr.dbname).get('ordem_servico.parametro')
        id_data = obj_data.search(cr, uid, [('company_id', '=', empresa)], context=context)
        data_prazo = obj_data.read(cr, uid, id_data, ['prazo_ret'], context=context)[0]['prazo_ret']

        ids_os = obj_ordem_servico.search(cr, uid, [('pessoa_id', '=', pessoa_id)], context=context)
        #  ---------------------
        serv_dado = obj_ordem_servico.read(cr, uid, ids_os, ['date'], context=context)
        pessoa_nome = obj_ordem_servico.read(cr, uid, ids_os, ['pessoa_id'], context=context)[0]['pessoa_id'][-1]

        data_max = datetime.strptime('2001-01-01', '%Y-%m-%d')
        for i in serv_dado:
            data_exec = datetime.strptime(i['date'], '%Y-%m-%d %H:%M:%S')
            if data_exec > data_max:
                data_max = data_exec
        data_max = data_exec + timedelta(days=data_prazo)
        max_data = data_max.strftime('%d/%m/%Y')

        nome_cliente = formataString(pessoa_nome, 20, ' ', 'D', 'S', 'S')

        #    ----------------------
        os_str = " "
        for s in ids_os:
            os_str = os_str + str(s)
            if s != ids_os[len(ids_os) - 1]:
                os_str = os_str + ", "
            else:
                os_str = os_str + " "
            # *******************************************************************************

        listagem = Impressora()
        listagem.defineFormato(orientacao='1')
        listagem.informaNome(pdf_file, 'Carta Aviso O.S.')
        listagem.informaTamLinha(80)
        listagem.defineMargem(1, 1, 1, 1)
        cab = ''              '                                                                                                                           Pagina:{{ Page }}'
        listagem.informaCab(cab)
        listagem.informaCab(' ')
        data = time.strftime('%d-%m-%Y')
        listagem.informaCab(
            'Data: ' + data + '                               CARTA DE AVISO ORDEM SERVICO                             ')
        listagem.informaCab(' ')
        listagem.informaCab('PREZADO(A) SR.(A), ')
        listagem.informaCab(' ')
        listagem.informaCab(u'' + nome_cliente + u'')
        listagem.informaCab(' ')
        listagem.informaCab(u'A ' + nome_empresa + u'')
        listagem.informaCab(' ')
        listagem.informaCab(' Vem por meio desta informar que a(s) O.S.' + os_str + 'abaixo encontra-se finalizada(s).')
        listagem.informaCab(' ')
        listagem.informaCab(
            '-------------------------------------------------------------------------------------------------------------------------------------')
        listagem.informaCab(
            'NroOS      SERVICO                                       DESCRICAO SERVICO                                               DATA EXECUCAO')
        listagem.informaCab(
            '--------- --------------------------------------------- --------------------------------------------------------------- -------------')

        # ***********************************RMA.SERVIÇO********************************************
        obj_serv = pooler.get_pool(cr.dbname).get('rma.servico')
        ids_serv = obj_serv.search(cr, uid, [('ordem_id', 'in', ids_os)], context=context)
        serv_dados = obj_serv.read(cr, uid, ids_serv, ['ordem_id', 'servico_id', 'descricao', 'data_exec'],
                                   context=context)
        for dados in serv_dados:
            if dados.get('ordem_id', False):
                linha = formataString(dados['ordem_id'][0], 10, ' ', 'D', 'S', 'S')
                if dados.get('servico_id', False):
                    linha += formataString(dados['servico_id'][-1], 46, ' ', 'D', 'N', 'S')
                    if dados.get('descricao', False):
                        linha += formataString(dados['descricao'], 64, ' ', 'D', 'S', 'S')
                        if dados.get('data_exec', False):
                            linha += formataString(dados['data_exec'], 10, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)

        listagem.imprimeLinha(' ')
        listagem.imprimeLinha(
            '-------------------------------------------------------------------------------------------------------------------------------------')
        listagem.imprimeLinha('PRODUTO                                               NroSERIE')
        listagem.imprimeLinha(
            '----------------------------------------------------- -------------------------------------------------------------------------------')

        # ***********************************RMA.PRODUTO*******************************************
        obj_produto = pooler.get_pool(cr.dbname).get('rma.produto')
        ids_produto = obj_produto.search(cr, uid, [('ordem_id', 'in', ids_os)], context=context)
        prod_dados = obj_produto.read(cr, uid, ids_produto, ['numero_serie', 'produto_id'], context=context)
        for dados_produto in prod_dados:
            if dados_produto.get('produto_id', False):
                ln = formataString(dados_produto['produto_id'][-1], 54, ' ', 'D', 'S', 'S')
                if dados_produto.get('numero_serie', False):
                    ln += formataString(dados_produto['numero_serie'], 30, ' ', 'D', 'S', 'S')
            listagem.imprimeLinha(ln)

        listagem.imprimeLinha(
            '-------------------------------------------------------------------------------------------------------------------------------------')

        listagem.imprimeLinha('Os equipamentos devem ser retirados ate a data ' + max_data + '')
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_file.getvalue())
        self.obj.render()
        pdf_file.close()
        return (self.obj.pdf, 'pdf')


report_carta_aviso('report.carta.aviso')


class carta_aviso_osv(osv.TransientModel):
    _name = 'carta.aviso.osv'
    _description = 'Carta Aviso OS'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa'),
        'pessoa_id': fields.many2one('adm.pessoa', 'Cliente'),

    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(cr, uid, uid).company_id.id,

    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = self.read(cr, uid, ids[0], [], context=context)
        nome_empresa = self.pool.get("res.company").read(cr, uid, vals['company_id'], ['name'], context=context)
        datas = {
            'company_id': vals['company_id'],
            'nome_empresa': nome_empresa['name'],
            'pessoa_id': vals['pessoa_id'],

        }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'carta.aviso',
            'datas': datas,
        }


carta_aviso_osv()


class adm_pessoa(osv.Model):
    _name = "adm.pessoa"
    _inherit = "adm.pessoa"

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        res = []
        if context.get('carta_avisa', False):
            obj_ordem_servico = pooler.get_pool(cr.dbname).get('ordem.servico')
            #######     COMENTEI O CODIGO ABAIXO PORQUE AS VARIAVEIS NÃO ESTAO SENDO USADAS, GERANDO PROCESSAMENTO DESNECESSARIO.
            #            obj_data=pooler.get_pool(cr.dbname).get('ordem_servico.parametro')
            #            id_data= obj_data.search(cr,uid,[('company_id','=',context['empresa'])])
            #            data_prazo= obj_data.read(cr,uid,id_data,['prazo_envio'])[0]['prazo_envio']
            #            serv_dado = obj_ordem_servico.read(cr,uid,id_data,['date'])
            #            envio= (datetime.now() - timedelta(days=data_prazo)).strftime('%Y-%m-%d %H:%M:%S')
            #            obj_pess=self.pool.get('crm_br.case')
            #            res=obj_pess.search(cr,uid,[('state','=','CR')])
            res = obj_ordem_servico.search(cr, uid, [('state', '=', 'CR')], context=context)

        else:
            res = super(adm_pessoa, self).search(cr, uid, args, offset, limit, order, context, count)
        return res


adm_pessoa()
