# -*- encoding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
from dateutil.parser import parse
from datetime import date, datetime
from openerp import pooler, osv


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf

class report_os_impressao(report_int):

    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        pdf_file=StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_file,'Ordem de Servico')
        listagem.informaTamLinha(120)
        listagem.defineMargem(1,1,1,1)
        # PARAMETRO PARA LARGURA DA IMPRESSÃO
        self._len_pagina = 148
        # PARAMETRO PARA ACESSAR AS TABELAS
        self.valor_total = 0
        self.db_name = pooler.get_pool(cr.dbname)
        
        if isinstance(datas, dict):
            try:
                sessao = datas['capa']['sessao']
            except:
                sessao = ''
            try:
                protocolo = datas['capa']['protocolo']
            except:
                protocolo = ''
            try:
                cliente = datas['capa']['cliente']
            except:
                cliente = ''
            try:
                data_atendimento = datas['capa']['data_atendimento']
            except:
                data_atendimento = ''
            try:
                atendente = datas['capa']['atendente']
            except:
                atendente = ''
            try:
                empresa_nome = datas['empresa_nome']
            except:
                empresa_nome = ''
            if data_atendimento:
                try:
                    data_atendimento = parse(data_atendimento)# retorna objeto - datetime.datetime
                except:
                    raise osv.except_osv(('Atencao'),('A data de atendimento nao e uma data valida!'))
                if isinstance(data_atendimento, datetime):
                    data_atendimento = str(data_atendimento.date())
                    data_atendimento = datetime.strptime(data_atendimento, "%Y-%m-%d").__format__("%d-%m-%Y")
                else:
                    data_atendimento = ''
            try:
                nf_numero = datas['capa']['numero_nf']
            except:
                nf_numero = ''
            try:
                nf_emissao = datas['capa']['nf_emissao']
            except:
                nf_emissao = ''
            if nf_emissao:
                try:
                    nf_emissao = parse(nf_emissao)# retorna objeto - datetime.datetime
                except:
                    raise osv.except_osv(('Atencao'),('A data de emissao da nota fiscal nao e uma data valida!'))
                if isinstance(nf_emissao, datetime):
                    nf_emissao = str(nf_emissao.date())
                    nf_emissao = datetime.strptime(nf_emissao, "%Y-%m-%d").__format__("%d-%m-%Y")
                else:
                    nf_emissao = ''
            self.print_cabecalho(listagem, sessao, empresa_nome, protocolo, cliente, data_atendimento, atendente, nf_numero, nf_emissao)
            if datas.get('equipamento_recebido_ids'):
                self.print_equipamentos_recebidos(cr, uid, ids, listagem, datas['equipamento_recebido_ids'], datas.get('empresa_id',0), context=context)
            if datas.get('equipamento_adicionado_ids'):
                self.print_equipamentos_adicionados(cr, uid, ids, listagem, datas['equipamento_adicionado_ids'], datas.get('empresa_id',0), context=context)
            if datas.get('servico_ids'):
                self.print_servicos_realizados(cr, uid, ids, listagem, datas['servico_ids'], datas.get('empresa_id',0), context=context)
            self.listagem_valor_total(listagem)
            
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_file.getvalue())
        self.obj.render()
        pdf_file.close()
        return (self.obj.pdf, 'pdf')
    
    def print_cabecalho(self, listagem, sessao, empresa_nome, protocolo, cliente, data_atendimento, atendente, nf_numero='', nf_emissao=''):
        if not isinstance(protocolo, str):
            protocolo = str(protocolo)
        sessao = formataString(sessao.upper(),self._len_pagina,' ','C','N','S')
        empresa_nome = formataString('Empresa: '+empresa_nome,self._len_pagina,' ','D','N','S')
        protocolo = formataString('Protocolo: '+protocolo, self._len_pagina,' ','D','N','S')
        cliente = formataString('Cliente: '+cliente, self._len_pagina,' ','D','N','S')
        data_atendimento = formataString('Data Atendimento: '+data_atendimento, self._len_pagina,' ','D','N','S')
        atendente = formataString('Atendente: '+atendente, self._len_pagina,' ','D','N','S')
        data_impressao = datetime.strptime(str(date.today()), "%Y-%m-%d").__format__("%d-%m-%Y")
        data_impressao = formataString('Data Impressao: '+str(data_impressao), self._len_pagina,' ','D','N','S')

        listagem.informaCab(' '+(self._len_pagina*' ')+' ')
        listagem.informaCab(' '+sessao+' ')
        listagem.informaCab(' '+(self._len_pagina*' ')+' ')
        listagem.informaCab(' '+empresa_nome+' ')
        listagem.informaCab(' '+protocolo+' ')
        listagem.informaCab(' '+cliente+' ')
        listagem.rodapePadrao()
        if nf_numero:
            if not isinstance(nf_numero, str):
                nf_numero = str(nf_numero)
            if nf_emissao:
                nf_emissao = "Data Emissao NF: %s"%nf_emissao
            nf_numero = formataString('NF nro: '+nf_numero+(5*' ')+nf_emissao,self._len_pagina,' ','D','N','S')
            listagem.informaCab(' '+nf_numero+' ')
        listagem.informaCab(' '+data_atendimento+' ')
        listagem.informaCab(' '+atendente+' ')
        listagem.informaCab(' '+data_impressao+' ')
        listagem.informaCab(' '+(self._len_pagina*' ')+' ')
        listagem.informaCab((self._len_pagina*'-'))
        listagem.informaCab(' '+(self._len_pagina*' ')+' ')

    def print_equipamentos_recebidos(self, cr, uid, ids, listagem, equipamento_recebido_ids, empresa_id, context=None):
        """
        BUSCA OS EQUIPAMENTOS RECEBIDOS NA TABELA RMA.PRODUTO E CHAMA A FUNÇÃO LISTAGEM_ITENS PARA EXIBIR-LOS
        """
        context = context and context.copy() or {}
        titulo = formataString(' EQUIPAMENTOS RECEBIDOS ', self._len_pagina,'_','D','N','S')
        listagem.imprimeLinha(' '+titulo+' ')
        equipamentos_recebidos = self.db_name.get('rma.produto').read(cr, uid, equipamento_recebido_ids, context=context)
        self.listagem_itens(cr, uid, ids, listagem, equipamentos_recebidos, empresa_id, 'R', context=context)
        
    def print_equipamentos_adicionados(self, cr, uid, ids, listagem, equipamento_adicionado_ids, empresa_id, context=None):
        """
        BUSCA OS EQUIPAMENTOS ADICIONADOS NA TABELA RMA.EQUIPAMENTO.ADICIONADO E CHAMA A FUNÇÃO LISTAGEM_ITENS PARA EXIBI-LOS
        """
        context = context and context.copy() or {}
        titulo = formataString(' EQUIPAMENTOS ADICIONADOS ', self._len_pagina,'_','D','N','S')
        listagem.imprimeLinha(' '+titulo+' ')
        equipamentos_adicionados = self.db_name.get('rma.equipamento_adicionado').read(cr, uid, equipamento_adicionado_ids, context=context)
        self.listagem_itens(cr, uid, ids, listagem, equipamentos_adicionados, empresa_id, 'A', context=context)

    def print_servicos_realizados(self, cr, uid, ids, listagem, servico_ids, empresa_id, context=None):
        """
        BUSCA OS SERVIÇOS NA TABELA RMA.SERVICO E CHAMA A FUNÇÃO LISTAGEM_ITENS PARA EXIBI-LOS
        """
        context = context and context.copy() or {}
        titulo = formataString(' SERVICOS REALIZADOS ', self._len_pagina,'_','D','N','S')
        listagem.imprimeLinha(' '+titulo+' ')
        servicos = self.db_name.get('rma.servico').read(cr, uid, servico_ids, context=context)
        self.listagem_itens(cr, uid, ids, listagem, servicos, empresa_id, 'S', item="SERVICOS", context=context)

    def listagem_itens(self, cr, uid, ids, listagem, itens, empresa_id, tipo_item, item="PRODUTOS", context=None):
        """
        FUNÇÃO QUE LISTA OS PRODUTOS, COM SUA DESCRIÇÃO, SERIE E VALOR CADASTRADO PARA A EMPRESA PASSADA

        tipo_item = S - Servico; A - Equipamento Adicionado; R - Equipamento Recebido
        """
        # PARAMETROS DE LIMITAÇÃO PARA LISTAGEM DOS ITENS
        context = context and context.copy() or {}
        inicio = 24
        espaco_item = 55
        espaco_serie = 18
        espaco_valor = 15
        espaco_obs = 32
        obj_produto_preco = self.db_name.get('estoque.preco.venda')
        
        cabecalho_item = formataString(item, espaco_item,' ','C','N','S')
        if not tipo_item == 'S':
            str_numero_serie = "NUMERO DE SERIE"
        else:
            str_numero_serie = ''
        cabecalho_serie = formataString(str_numero_serie, espaco_serie,' ','C','N','S')
        if not tipo_item == 'R':
            str_valor = "VALOR"
        else:
            str_valor = ''
        cabecalho_valor = formataString(str_valor, espaco_valor,' ','E','N','S')
        if tipo_item == 'A':
            str_obs = ''
        else:
            str_obs = "OBSERVACAO"
        cabecalho_obs = formataString(str_obs, espaco_obs,' ','C','N','S')
        listagem.imprimeLinha(' '+(inicio*' ')+' '+cabecalho_item+' '+cabecalho_serie+' '+cabecalho_valor+' '+cabecalho_obs+' ')
        listagem.imprimeLinha('--')
    
        if tipo_item == 'S':
            coluna_item = 'servico_id'
        else:
            coluna_item = 'produto_id'
        
        for i in itens:
            quantidade = 1
            if not coluna_item == 'servico_id':
                # APENAS O EQUIAPEMENTO ADICIONADO POSSUI QUANTIDADE.
                # NA TABELA DE RMA.SERVIÇO O TEMPO DO SERVIÇO ESTA EM UMA COLUNA COM NOME QUANTIDADE, ENTÃO NO CASO DE SERVIÇO NÃO PODE SER VERIFICADO.
                quantidade = i.get('quantidade',1)
            produto_preco = ''
            try:
                produto_id = i[coluna_item][0]
            except:
                produto_id = []
            try:
                produto_nome = i[coluna_item][1]
            except:
                produto_nome = ''
            if produto_id and not tipo_item == 'R':
                produto_preco_id = obj_produto_preco.search(cr, uid, [('produto_id','=',produto_id),('company_id','=',empresa_id)], context=context)
                if produto_preco_id:
                    produto_preco_venda = obj_produto_preco.read(cr, uid, produto_preco_id[0], ['preco_venda'], context=context)
                    if isinstance(produto_preco_venda, list):
                        produto_preco_venda = produto_preco_venda[0]
                    if isinstance(produto_preco_venda, dict):
                        if produto_preco_venda.get('preco_venda',False):
                            produto_preco = produto_preco_venda['preco_venda'] * quantidade
            if produto_preco:
                self.valor_total += produto_preco
            produto_nome = formataString(produto_nome, espaco_item,' ','D','N','S')
            numero_serie = formataString(str(i.get('numero_serie') or ''), espaco_serie,' ','D','N','S')
            str_produto_preco = formataString(str(produto_preco), espaco_valor,' ','E','N','S')
            if i.get('descricao') and tipo_item != 'A':
                tamanho_linha = espaco_obs
                word = i['descricao'].split(' ')
                obs = ""
                cont = 0
                len_word = len(word)
                campo = 0
                for j in word:
                    cont += 1
                    size_i = len(j)
                    if size_i+campo < tamanho_linha:
                        obs = obs + j +' '
                        campo = len(obs)
                    elif size_i+campo > tamanho_linha:
                        obs = formataString(''+obs,tamanho_linha,' ','D','N','S')
                        listagem.imprimeLinha(' '+(inicio*' ')+' '+produto_nome+' '+numero_serie+' '+str_produto_preco+'  '+obs)
                        produto_nome = (espaco_item * ' ')
                        numero_serie = (espaco_serie * ' ')
                        str_produto_preco = (espaco_valor * ' ')
                        obs = ''
                        obs = obs + j +' '
                        campo = len(obs)
                    if cont == len_word:
                        obs = formataString(''+obs,tamanho_linha,' ','D','N','S')
                        listagem.imprimeLinha(' '+(inicio*' ')+' '+(espaco_item*' ')+' '+(espaco_serie*' ')+' '+(espaco_valor*' ')+'  '+obs+' ')
            else:
                listagem.imprimeLinha(' '+(inicio*' ')+' '+produto_nome+' '+numero_serie+' '+str_produto_preco+' ')
        listagem.imprimeLinha(' '+(self._len_pagina*' ')+' ')
        listagem.imprimeLinha(' '+(self._len_pagina*' ')+' ')
        return True

    def listagem_valor_total(self, listagem):
        label_valor_total = formataString(' VALOR TOTAL', 91,' ','D','N','S')
        str_valor_total = formataString(str(self.valor_total), 24,' ','E','N','S')
        listagem.imprimeLinha(' '+label_valor_total+str_valor_total+' ')
        listagem.imprimeLinha('--')

report_os_impressao('report.os.impressao')








