# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler
import time
from openerp.tools.translate import _


class oservico_apontamento(osv.Model):
    _name = 'oservico.apontamento'
    _inherit = 'oservico.apontamento'

    def osvapo_onchange_servico(self, cr, uid, ids, servico_id):
        res = {}
        brw_oservico_servico = self.pool.get('oservico.servicos').browse(cr, uid, servico_id)
        if brw_oservico_servico and brw_oservico_servico.osvsrv_mecanico_id:
            res['osvapo_mecanico_id'] = brw_oservico_servico.osvsrv_mecanico_id.id
        return {'value': res}

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if 'osvapo_fim' in vals:
            apt_data_inicio = self.browse(cr,uid, ids)[0].osvapo_inicio
            if apt_data_inicio > vals.get('osvapo_fim'):
                raise osv.except_osv(_('Atencao'), _('A data de termino deve ser maior que a data de inicio!'))
        if context.get('Apontamento', False):
            if context['Apontamento'] == 'Abrir':
                vals['state'] = 'A'
            if context['Apontamento'] == 'Fechar':
                vals['state'] = 'F'
            if context['Apontamento'] == 'Cancelar':
                vals['state'] = 'C'
                vals['osvapo_cancelado_uid'] = uid
                vals['osvapo_cancelado_data'] = time.strftime('%Y-%m-%d %H:%M:%S')
        result = super(oservico_apontamento, self).write(cr, uid, ids, vals, context)
        return result

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if context.get('Apontamento', False):
            if context['Apontamento'] == 'Abrir':
                vals['state'] = 'A'
                _args = [
                    ('osvapo_os_id', '=', vals.get('osvapo_os_id', False)),
                    ('osvapo_servico_id', '=', vals.get('osvapo_servico_id', False)),
                    ('osvapo_mecanico_id', '=', vals.get('osvapo_mecanico_id', False)),
                    ('state', '=', 'A')
                ]
                _apontamento_ids = self.search(cr, uid, _args, context=context)
                if _apontamento_ids:
                    raise osv.except_osv(_('Atencao'), _('Este servico ja esta apontado nesta O.S. para este tecnico!'))
            if context['Apontamento'] == 'Fechar':
                vals['state'] = 'F'
            if context['Apontamento'] == 'Cancelar':
                vals['state'] = 'C'
                vals['osvapo_cancelado_uid'] = uid
                vals['osvapo_cancelado_data'] = time.strftime('%Y-%m-%d %H:%M:%S')
        result = super(oservico_apontamento, self).create(cr, uid, vals, context)
        return result
    def onchange_osvapo_fim(self, cr, uid, id, osvapo_fim):
        res = {}
        if not osvapo_fim:
            return res
        apt_data_inicio = self.browse(cr,uid, id)[0].osvapo_inicio
        apt_data_fim = osvapo_fim
        if apt_data_inicio > apt_data_fim:
            res['warning'] = {'title': ('Atencao'), 'message': ('A data de termino deve ser maior que a data de inicio!')}
        return res

