# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
import time
from openerp.tools.translate import _
from datetime import date, datetime
from SigUtils import datas


class oservico_os(osv.Model):
    _name = 'oservico.os'
    _inherit = 'oservico.os'

    def sequence_criar(self, cr, uid, context=None):
        context = context and context.copy() or {}
        company_id = 1
        __code = 'oservico.nro_os'
        __name = 'Numero da Ordem de servico'
        vals = {
            'name': __name,
            'code': __code,
            'prefix': '%(year)s-',
            'padding': 6,
            'company_id': company_id,
            'implementation': 'no_gap',
        }
        consulta = self.pool.get('ir.sequence.type').search(cr, uid, [('code', '=', __code)],
                                                            context=context)
        if not consulta:
            self.pool.get('ir.sequence.type').create(cr, uid, {'name': __name, 'code': __code},
                                                     context)
        self.pool.get('ir.sequence').create(cr, uid, vals, context)
        return True

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if context.get('form_os', False) and not context.get('osvos_alteracao_sistema'):
            for brw_os in self.browse(cr, uid, ids, context=context):
                if brw_os.state in ('C', 'F'):
                    raise osv.except_osv(_('Atencao'), _('Nao posso alterar O.S. cancelada ou Fechada.'))
        result = super(oservico_os, self).write(cr, uid, ids, vals, context)
        return result

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        vals['osvos_numero'] = self.pool.get('adm.utils').get_sequence(cr, uid, self._name, 'oservico.nro_os')
        result = super(oservico_os, self).create(cr, uid, vals, context)
        return result

    def copy(self, cr, uid, id, default={}, context=None):
        context = context and context.copy() or {}
        context.update({'oservico_copy': True})
        data_hoje = time.strftime('%Y-%m-%d %H:%M:%S')
        if isinstance(default, dict):
            default.update({'osvos_pecas_ids': False, 'osvos_data_abertura': data_hoje,
                            'state': 'E'})
        return super(oservico_os, self).copy(cr, uid, id, default, context)

    def on_change_data_entrega(self, cr, uid, ids, osvos_data_entrega ,osvos_data_abertura):
        if osvos_data_entrega < osvos_data_abertura[0:10]:
            res = {'osvos_data_entrega': ''}
            return {'value': res}
        return True

    def osvos_button_esboco(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        for brw_os in self.browse(cr, uid, ids, context=context):
            for req_capa in brw_os.osvos_requisicao_ids:
                if req_capa.state == 'N' and not req_capa.osvrqc_devolucao and (
                        not req_capa.osvrqc_requisicao_devolucao_id or req_capa.osvrqc_requisicao_devolucao_id.state != 'N'):
                    raise osv.except_osv(_('Atencao'),
                                         _('Esta O.S. ja tem requisicao entregue. Nao posso retornar para Esboco!'))
        res = self.write(cr, uid, ids, {'state': 'E'}, context)
        self.message_post(cr, uid, ids[0], _('Alteracao de Status'), _('O.S. em Esboco'))
        return res

    def osvos_butao_atualizar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return True

    def osvos_button_abrir(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = self.write(cr, uid, ids, {'state': 'A'}, context)
        self.message_post(cr, uid, ids[0], _('Alteracao de Status'), _('O.S. Aberta'))
        return res

    def osvos_button_fechar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        for brw_os in self.browse(cr, uid, ids, context=context):
            for brw_servico in brw_os.osvos_servicos_ids:
                if not brw_servico.osvsrv_apontamento_ids:
                    raise osv.except_osv(_('Atencao'),
                                         _('Para fechar uma O.S., todos os servicos tem que '
                                           'estar com os apontamentos concluidos!'))
                for brw_apontamento in brw_servico.osvsrv_apontamento_ids:
                    if brw_apontamento.state == 'A':
                        raise osv.except_osv(_('Atencao'),
                                             _('Para fechar uma O.S., todos os servicos tem que '
                                               'estar com os apontamentos concluidos!'))
            for brw_requisicao in brw_os.osvos_requisicao_ids:
                if brw_requisicao.state not in ('C', 'N'):
                    raise osv.except_osv(_('Atencao'),
                                         _('Para fechar uma O.S., todas as requisicoes tem que ter sido entregue ou estar cancelada.'))

        res = self.write(cr, uid, ids, {'state': 'F',
                                        'osvos_data_fechamento': time.strftime('%Y-%m-%d %H:%M:%S'),
                                        'osvos_fechamento_user_id': uid}, context)
        self.message_post(cr, uid, ids[0], _('Alteracao de Status'), _('O.S. Fechada'))
        return res

    def osvos_button_cancelar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        for brw_os in self.browse(cr, uid, ids, context=context):
            for servico in brw_os.osvos_servicos_ids:
                if not servico.osvsrv_concluido:
                    raise osv.except_osv(_('Atencao:'),
                                         _('Não é permitido o cancelamento da OS.\nExistem serviços não concluídos para a mesma!'))
            for brw_requisicao in brw_os.osvos_requisicao_ids:
                if brw_requisicao.state == 'N': # requisicao entregue
                    if not brw_requisicao.osvrqc_requisicao_devolucao_id:
                        raise osv.except_osv(_('Atencao'),
                                             _('Nao posso cancelar O.S. com requisicoes entregues, e necessario fazer devolucao antes!'))
                if brw_requisicao.state == 'E': # Requisicoes em Esboco, cancelar
                    self.pool.get('oservico.requisicao.capa').osvrqc_button_cancelar(cr, uid, [brw_requisicao.id],
                                                                                     context)
        res = self.write(cr, uid, ids, {'state': 'C'}, context)
        self.message_post(cr, uid, ids[0], _('Alteracao de Status'), _('O.S. Cancelada'))
        return res

    def osvos_onchange_pessoa(self, cr, uid, ids, pessoa_id, context=None):
        context = context and context.copy() or {}
        res = {}
        if pessoa_id:
            obj_adm_pessoa_telefone = self.pool.get('adm.pessoa.telefone')
            telefone_id = obj_adm_pessoa_telefone.search(cr, uid, [('pessoa_id', '=', pessoa_id)],
                                                         context=context)
            if not telefone_id:
                return res
            elif len(telefone_id) > 1:
                telefone_id = telefone_id[0]
            res['osvos_telefone'] = telefone_id
        return {'value': res}

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = []
        for brw_os in self.browse(cr, uid, ids, context=context):
            id = brw_os.id
            codigo = brw_os.osvos_pessoa_id.name
            name = brw_os.osvos_numero
            if not context.get('retorno_sem_codigo'):
                result = "%s%s%s" % (name, ' - ', codigo)
            else:
                result = name
            res.append((id, result))
        return res

    def default_get(self, cr, uid, fields, context):
        res = super(oservico_os, self).default_get(cr, uid, fields, context)
        res['osvos_veiculo_instalado'] = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'oservico_veiculo', context)
        return res

    def osvos_button_parcelas(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = []
        context['criar'] = "parcelas"
        obj_condicao_pag = self.pool.get('oservico.os.condicao')
        os_condicao_ids = obj_condicao_pag.search(cr, uid, [('osvocd_capa_id', 'in', ids)], context=context)
        obj_parcelas = self.pool.get('oservico.os.parcela')
        # BUSCA O ID_PARCELA EM FUNÇÃO
        if os_condicao_ids:
            os_condicao_id = obj_parcelas.search(cr, uid, [('osvocp_condicao_id', 'in', os_condicao_ids)],
                                                 context=context)
            # DELETAR AS PARCELAS EXISTENTES
            if os_condicao_id:
                obj_parcelas.unlink(cr, uid, os_condicao_id, context)
                # BUSCAR VALOR TOTAL DO os
            valor_total = self.pool.get('oservico.os').read(cr, uid, ids, ['osvos_valor_total'], context=context)[0]['osvos_valor_total']
            dados_condicao = obj_condicao_pag.read(cr, uid, os_condicao_ids,
                                                   ['osvocd_condicao_forma_id', 'osvocd_valor', 'id'], context=context)
            obj_condicao_forma = self.pool.get('adm.condicao.forma')
            valor_total_parcelas = sum(map(lambda x: x['osvocd_valor'], dados_condicao)) or 0
            if round(valor_total, 2) != round(valor_total_parcelas, 2):
                raise osv.except_osv(_('Atencao'), _(
                    'O valor total das condicoes de pagamento dever ser igual ao valor total da nota.'))
            for x in dados_condicao:
            # DIVIDIR PELAS PARCELAS
                if x['osvocd_condicao_forma_id']:
                    condicao_id = obj_condicao_forma.browse(cr, uid,
                                                            x['osvocd_condicao_forma_id'][0], context=context).adm_condicao_id.id
                    parcelas_condicao = self.pool.get('adm.condicao').read(cr, uid, condicao_id,
                                                                           ['qtde_parcelas', 'dias_primeira_parcela',
                                                                            'tipo_prazo', 'dias_incremento'], context=context)
                    if parcelas_condicao.get('qtde_parcelas', False) > 0:
                        valor_cada_parcela = round(x['osvocd_valor'] / parcelas_condicao['qtde_parcelas'], 2)
                        # CRIAR PARCELAS COM NOVOS VALORES
                        i = 1
                        vct = date.today()
                        while i <= parcelas_condicao['qtde_parcelas']:
                            if i == parcelas_condicao['qtde_parcelas']:# SE FOR A ULTIMA PARCELA
                                valor_cada_parcela = x['osvocd_valor'] - (valor_cada_parcela * (
                                    i - 1))# NO CASO DA ULTIMA PARCELA, É SUBTRAIDO DO VALOR TOTAL AS PARCELAS JA FEITAS.
                            if i == 1:# SE FOR A PRIMERIA PARCELA, vct RECEBE O DIA ATUAL
                                vct = datas.sigDatas(vct).getCalculaPrazo(parcelas_condicao['dias_primeira_parcela'],
                                                                          parcelas_condicao['tipo_prazo'], 'N')
                            else:
                                vct = datas.sigDatas(vct).getCalculaPrazo(parcelas_condicao['dias_incremento'],
                                                                          parcelas_condicao['tipo_prazo'], 'N')
                            vct = datetime.strptime(vct, "%Y%m%d") # CONVERTENDO DE STR P/ DATETIME
                            vct = datetime.date(
                                vct) # CONVERTENDO DE DATETIME P/ DATE, SE PASSAR DATETIME PARA A FUNÇÃO sigDatas NÃO CALCULA A DATA CORRETA
                            vals = {
                                'osvocp_condicao_id': x['id'],
                                'osvocp_vr_parcela': valor_cada_parcela,
                                'osvocp_data_vencimento': vct,
                            }
                            i += 1
                            # GRAVAR PARCELAS
                            res.append(obj_parcelas.create(cr, uid, vals, context=context))
        return res

    def osvos_button_imprimir_recibo(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return {'type': 'ir.actions.report.xml',
                'report_name': 'oservico.os.recibo',
                }

    def osvos_button_print_os(self, cr, uid, ids, context=None):
        """
        O metodo realiza a impressao de uma ordem de servico.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela dessa classe.
        :type ids: list
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: action para chamada do relatorio.
        :rtype: dict
        """
        context = context and context.copy() or {}
        os_id = ids[0] if isinstance(ids, list) else ids
        return {'type': 'ir.actions.report.xml',
                'report_name': 'oservico.os',
                'name': self.browse(cr, uid, os_id, context).osvos_numero
                }

    def osvos_onchange_setor_id(self, cr, uid, ids, setor_id, context=None):
        context = context and context.copy() or {}
        return {'value': {'osvos_centro_custo_id': False}}

    def osvos_imprimir_dados_requisicoes_oservico(self, cr, uid, ids, context=None):
        """
        Metodo de acao do botao. Monta os dados para chamada da classe de um relatorio para
        impressao em PDf dos dados das requisicoes.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dados contextuais.
        :type context: dict
        :return: conjunto de dados que formam acao para gerar a impressao.
        :rtype: dict
        """
        context = context and context.copy() or {}
        oservico_os_dados = self.read(cr, uid, ids[0] if isinstance(ids, (list, tuple)) else ids,
                                      ['osvos_numero', 'osvos_requisicao_ids'], context)
        requisicao_ids = oservico_os_dados.get('osvos_requisicao_ids')
        if not requisicao_ids:
            raise osv.except_osv(_('Atencao'), _('A ordem de servico nao possui requisicoes.'))
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'oservico_listagem_dados_requisicoes',
            'name': 'Dados requisicoes OS %s' % oservico_os_dados.get('osvos_numero'),
            'datas': {'requisicao_ids': requisicao_ids}
        }
