# -*- coding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _


class oservico_centro_custo(osv.Model):

    _inherit = 'oservico.centro.custo'

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = list()
        for centro_custo in self.browse(cr, uid, ids, context):
            res.append((centro_custo.id, '%s - %s' % (centro_custo.id, centro_custo.name)))
        return res

    def name_search(self, cr, uid, name='', args=None, operator='ilike', context=None, limit=100):
        if not args:
            args = []
        context = context and context.copy() or {}
        if name.isdigit():
            args.append(('id', operator, name))
        if name.isalpha():
            args.append(('name', operator, name))
        ids = self.search(cr, uid, args, limit=limit, context=context)
        return self.name_get(cr, uid, ids, context)

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy()
        if context.get('oservico'):
            raise osv.except_osv(_('Atencao'), _("O cadastro deve ser feito pelo menu 'Centro de "
                                                 "custos'"))
        res = super(oservico_centro_custo, self).create(cr, uid, vals, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy()
        if context.get('oservico'):
            raise osv.except_osv(_('Atencao'), _("A edicao deve ser feita pelo menu 'Centro de "
                                                 "custos'"))
        res = super(oservico_centro_custo, self).write(cr, uid, ids, vals, context)
        return res
