# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class oservico_os_condicao(osv.Model):
    _name = 'oservico.os.condicao'
    _inherit = 'oservico.os.condicao'

    def osvocd_onchange_forma_pgto(self, cr, uid, ids, osvocd_forma_pagto_id, context=None):
        context = context and context.copy() or {}
        res = {}
        if osvocd_forma_pagto_id:
            obj_adm_condicao_forma = self.pool.get('adm.condicao.forma')
            adm_condicao_forma_ids = obj_adm_condicao_forma.search(cr, uid,
                                                                   [('forma_pagamento_id', '=', osvocd_forma_pagto_id)],
                                                                   context=context)
            if len(adm_condicao_forma_ids) == 1:
                res.update({'osvocd_condicao_forma_id': adm_condicao_forma_ids[0]})
        return {'value': res}

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
        res = []
        os_condicao_dados = self.browse(cr, uid, ids)
        for i in os_condicao_dados:
            id = i.id
            condicao_forma = i.osvocd_condicao_forma_id.adm_condicao_id.name
            forma_pagamento = i.osvocd_forma_pagto_id.name
            name = '%s - %s' % (forma_pagamento, condicao_forma)
            res.append((id, name))
        return res

    def default_get(self, cr, uid, fields_list, context=None):
        context = context and context.copy() or {}
        lista_cond_ids=[]
        valor_tot_conds = 0
        if context and context.get('osvos_condicao_ids'):
            for cond in context.get('osvos_condicao_ids'):
                if cond[1]:
                    lista_cond_ids.append(cond[1])
                else:
                    valor_tot_conds += cond[2].get('osvocd_valor')
            bwr_conds = self.browse(cr, uid, lista_cond_ids)
            for cond in bwr_conds:
                valor_tot_conds += cond.osvocd_valor
        res = super(oservico_os_condicao, self).default_get(cr, uid, fields_list, context)
        if context.get('osvos_valor_total'):
            res['osvocd_valor'] = context.get('osvos_valor_total') - valor_tot_conds
        return res
