# -*- coding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _


class oservico_setor(osv.Model):

    _inherit = 'oservico.setor'

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = list()
        for setor in self.browse(cr, uid, ids, context):
            res.append((setor.id, '%s - %s' % (setor.id, setor.name)))
        return res

    def name_search(self, cr, uid, name='', args=None, operator='ilike', context=None, limit=100):
        if not args:
            args = []
        context = context and context.copy() or {}
        if name.isdigit():
            args.append(('id', '=', int(name)))
        if name.isalpha():
            args.append(('name', operator, name))
        ids = self.search(cr, uid, args, limit=limit, context=context)
        return self.name_get(cr, uid, ids, context)

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        self.osset_verifica_origem_cadastro(cr, uid, context)
        return super(oservico_setor, self).create(cr, uid, vals, context)

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        self.osset_verifica_origem_cadastro(cr, uid, context)
        return super(oservico_setor, self).write(cr, uid, ids, vals, context)

    def osset_verifica_origem_cadastro(self, cr, uid, context=None):
        context = context and context.copy() or {}
        res = True
        if context.get('oservico'):
            raise osv.except_osv(_('Atencao'), _('Inclua/Edite um setor pelo menu '
                                                 '"Cadastros/Setor".'))
        return res
