# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler
from openerp.tools.translate import _
import time


class oservico_requisicao_capa(osv.Model):
    _name = 'oservico.requisicao.capa'
    _inherit = 'oservico.requisicao.capa'

    def sequence_criar(self, cr, uid, context=None):
        context = context and context.copy() or {}
        company_id = 1
        __code = 'oservico.nro_requisicao'
        __name = 'Numero da Requisicao de pecas(OS)'
        vals = {
            'name': __name,
            'code': __code,
            'prefix': '%(year)s-',
            'padding': 6,
            'company_id': company_id,
            'implementation': 'no_gap',
        }
        consulta = self.pool.get('ir.sequence').search(cr, uid, [('code', '=', __code), ('company_id', '=', company_id)], context=context)
        if not consulta:
            self.pool.get('ir.sequence').create(cr, uid, vals, context)
        #todo: verificar se e possivel isolar a transacao para apenas comitar no ir.sequence
        cr.commit()
        return True

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('osvrqc_os_id', False):
            brw_os = self.pool.get('oservico.os').browse(cr, uid, vals['osvrqc_os_id'], context=context)
            if brw_os.state in ('C', 'F'):
                raise osv.except_osv(_('Atencao'), _('Nao posso Criar Requisicao de O.S Cancelada ou Fechada.'))
        vals['osvrqc_numero'] = self.pool.get('adm.utils').get_sequence(cr, uid, self._name, 'oservico.nro_requisicao')
        result = super(oservico_requisicao_capa, self).create(cr, uid, vals, context)
        return result

    def osvrqc_button_entregar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        try:
            if isinstance(ids, list):
                id = ids[0]
                id = int(id)
        except:
            return False
        for brw_requisicao in self.browse(cr, uid, ids):
            if brw_requisicao.osvrqc_os_id.state != 'A':
                raise osv.except_osv(_('Atencao'), _('Nao posso Entregar itens se a O.S nao estiver Aberta!'))
        res = self.write(cr, uid, ids, {'state': 'N'}, context)
        self.message_post(cr, uid, ids[0], _('Alteracao de Status'), _('Requisicao(O.S.) Entregue'))
        produto_saldo_insuficiente = self._osvrqc_trata_saldo_produto(cr, uid, ids, context)
        if produto_saldo_insuficiente:
            raise osv.except_osv(_('Atencao'),
                                 _('Os produtos a seguir possuem quantidade requisitada maior que '
                                   'o saldo disponivel: %s' % produto_saldo_insuficiente))
        return res

    def _osvrqc_trata_saldo_produto(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_estoque_produto_saldo = self.pool.get('estoque.produto.saldo')
        res = []
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name,
                                                                    context=context)
        requisicao_capa_dados = self.read(
            cr, uid, ids, ['osvrqc_requisicao_itens_ids', 'osvrqc_local_id', 'osvrqc_devolucao'],
            context=context, load='_classic_write')
        if isinstance(requisicao_capa_dados, (list, tuple)):
            requisicao_capa_dados = requisicao_capa_dados[0]
        requisicao_item_ids = requisicao_capa_dados.get('osvrqc_requisicao_itens_ids')
        local_id = requisicao_capa_dados.get('osvrqc_local_id')
        devolucao = requisicao_capa_dados.get('osvrqc_devolucao')
        aceita_saldo_negativo = self.pool.get('estoque.local').browse(
            cr, uid, local_id, context).aceita_saldo_negativo or False
        requisicao_item_dados = self.pool.get('oservico.requisicao.itens').read(
            cr, uid, requisicao_item_ids, ['osvrqi_produto_id', 'osvrqi_grade_id',
                                           'osvrqi_quantidade'], context=context,
            load='_classic_read')
        data_hoje = time.strftime('%Y-%m-%d')
        grade_qtd_entrada = {}
        grade_qtd_saida = {}
        for item in requisicao_item_dados:
            permite_produto = True
            grade_id = item.get('osvrqi_grade_id')[0]
            name_produto = item.get('osvrqi_produto_id')[1]
            quantidade = item.get('osvrqi_quantidade')
            if devolucao:
                if grade_id in grade_qtd_entrada:
                    grade_qtd_entrada[grade_id] += quantidade
                else:
                    grade_qtd_entrada[grade_id] = quantidade
            else:
                grade_ids = list(set(map(lambda i: i.get('osvrqi_grade_id')[0],
                                         requisicao_item_dados)))
                saldo_produtos = obj_estoque_produto_saldo.get_saldo_do_dia(cr, uid, grade_ids,
                                                                            data_hoje, local_id,
                                                                            context=context)
                saldo_disponivel = saldo_produtos.get(grade_id).get('disponivel')
                if saldo_disponivel < 0 and not aceita_saldo_negativo:
                    res.append(name_produto)
                    permite_produto = False

                if permite_produto:
                    if grade_id in grade_qtd_saida:
                        grade_qtd_saida[grade_id] += quantidade
                    else:
                        grade_qtd_saida[grade_id] = quantidade

        if grade_qtd_entrada:
            obj_estoque_produto_saldo.atualizar_saldo_do_dia(cr, uid, eps_company_id=company_id,
                grade_qtd=grade_qtd_entrada, eps_data=data_hoje, eps_entrada_saida='E',
                eps_local_id=local_id, context=context)

        if grade_qtd_saida:
            obj_estoque_produto_saldo.atualizar_saldo_do_dia(cr, uid, eps_company_id=company_id,
                grade_qtd=grade_qtd_saida, eps_data=data_hoje, eps_entrada_saida='S',
                eps_local_id=local_id, context=context)

        return '\n'.join(res)

    def osvrqc_button_cancelar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = self.write(cr, uid, ids, {'state': 'C', 'osvrqc_cancelado_user_id': uid}, context)
        self.message_post(cr, uid, ids[0], 'Alteracao de Status', 'Requisicao(O.S.) Cancelada')
        requisicao_capa_dados = self.read(cr, uid, ids, [], context=context)
        for req in requisicao_capa_dados:
            if req['osvrqc_requisicao_devolucao_id']:
                self.write(cr, uid, req['osvrqc_requisicao_devolucao_id'][0], {'osvrqc_requisicao_devolucao_id': False},
                           context=context.update({'req_force': True}))
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if vals and len(vals) == 1 and vals.get('osvrqc_os_id',
                                                False):# se estiver vindo apenas o numero da os, permitir gravar
            context['req_force'] = True
        for brw_requisicao in self.browse(cr, uid, ids, context=context):
            if brw_requisicao.state in ('N', 'C') and not context.get('req_force', False):
                raise osv.except_osv(_('Atencao'), _('Nao posso alterar Requisicao cancelada ou Entregue!'))
            if brw_requisicao.osvrqc_os_id.state in ('C', 'F'):
                raise osv.except_osv(_('Atencao'), _('Nao posso alterar Requisicao de O.S Cancelada ou Fechada.'))
        result = super(oservico_requisicao_capa, self).write(cr, uid, ids, vals, context)
        return result

    def unlink(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        for brw_requisicao in self.browse(cr, uid, ids, context=context):
            if brw_requisicao.state in ('N', 'C'):
                raise osv.except_osv(_('Atencao'), _('Nao posso alterar Requisicao cancelada ou Entregue.'))
            if brw_requisicao.osvrqc_os_id.state in ('C', 'F'):
                raise osv.except_osv(_('Atencao'), _('Nao posso alterar Requisicao de O.S Cancelada ou Fechada.'))
        result = super(oservico_requisicao_capa, self).unlink(cr, uid, ids, context)
        return result

    def osvrqc_button_atualizar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return True

    def default_get(self, cr, uid, fields_list, context=None):
        context = context and context.copy() or {}
        res = super(oservico_requisicao_capa, self).default_get(cr, uid, fields_list, context)
        parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, 'estoque', ['estpar_local_oservico_id'])
        local_id = parametro_dados.get('estpar_local_oservico_id')
        if local_id:
            res['osvrqc_local_id'] = local_id
        return res
