# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class oservico_servicos(osv.Model):
    _name = 'oservico.servicos'
    _inherit = 'oservico.servicos'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('osvsrv_concluido'):
            if context.get('oservico_copy'):
                del vals['osvsrv_concluido']
            elif not context.get('importacao_planilha'):
                raise osv.except_osv(_('Atencao'),
                                     _('Concluir servico somente apos apontamento(s) fechado(s).'))
        if vals.get('osvsrv_os_id', False):
            brw_os = self.pool.get('oservico.os').browse(cr, uid, vals['osvsrv_os_id'],
                                                         context=context)
            if brw_os.state in ('C', 'F') and not context.get('importacao_planilha'):
                raise osv.except_osv(_('Atencao'), _('Nao posso Criar Servicos em O.S. Cancelada '
                                                     'ou Fechada.'))
        result = super(oservico_servicos, self).create(cr, uid, vals, context)
        return result

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        for brw_servicos in self.browse(cr, uid, ids, context=context):
            if context.get('importacao_planilha'):
                continue
            if brw_servicos.osvsrv_os_id.state in ('C', 'F'):
                raise osv.except_osv(_('Atencao'), _('Nao posso alterar Servicos em O.S. Cancelada '
                                                     'ou Fechada.'))
            brw_apontamento_ids = brw_servicos.osvsrv_apontamento_ids
            if not brw_apontamento_ids and vals.get('osvsrv_concluido'):
                raise osv.except_osv(_('Atencao'),
                                     _('Concluir servico somente apos apontamento(s) fechado(s).'))
            apontamentos = len(brw_apontamento_ids)
            apontamentos_fechados = len(filter(lambda i: i.state == 'F', brw_apontamento_ids))
            if apontamentos != apontamentos_fechados:
                raise osv.except_osv(_('Atencao'),
                                     _('Concluir servico somente apos apontamento(s) fechado(s).'))
        result = super(oservico_servicos, self).write(cr, uid, ids, vals, context)
        return result

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        order = 'osvsrv_data_inicio desc'
        res = super(oservico_servicos, self).search(cr, uid, args, offset, limit, order, context,
                                                  count)
        return res

    def unlink(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        for brw_servicos in self.browse(cr, uid, ids, context=context):
            if brw_servicos.osvsrv_os_id.state in ('C', 'F'):
                raise osv.except_osv(_('Atencao'), _('Nao posso alterar Servicos em O.S. Cancelada ou Fechada.'))
        result = super(oservico_servicos, self).unlink(cr, uid, ids, context)
        return result

    def osvsrv_onchange_servico(self, cr, uid, ids, osvsrv_servico_id, pessoa_id=None, context=None):
        context = context and context.copy() or {}
        res = {'osvsrv_preco_unitario': 0, 'osvsrv_duracao_prevista': 0}
        if osvsrv_servico_id:
            cliente_id = None
            if pessoa_id:
                cliente_id = self.pool.get('financeiro.cliente').search(cr, uid, [('pessoa_id', '=', pessoa_id)],
                                                                        context=context)
            preco = self.pool.get('estoque.preco.venda').get_preco_venda(cr, uid, osvsrv_servico_id,
                                                                         epc_cliente_id=cliente_id)
            if preco:
                dados_preco_venda = preco.get(osvsrv_servico_id) or {}
                preco = dados_preco_venda.get('preco_venda')
                res['osvsrv_preco_unitario'] = preco
            brw_estoque_produto = self.pool.get('estoque.produto').browse(cr, uid, osvsrv_servico_id)
            if brw_estoque_produto.tempo_previsto:
                res['osvsrv_duracao_prevista'] = brw_estoque_produto.tempo_previsto
        return {'value': res}

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = []
        for brw in self.browse(cr, uid, ids, context=context):
            res.append((brw.id, brw.name))
        return res
