# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_parametro(osv.Model):
    """
    Tabela de parametros de produtos
    """
    _inherit = 'estoque.parametro'

    _columns = {
        'estpar_local_oservico_id': fields.many2one('estoque.local', 'Local requisicao OS',
                                                    ondelete='restrict',
                                                    help='Local para requisicao da ordem de '
                                                         'servico'),
        'estpar_oservico_considerar_tempo_minimo': fields.boolean(
            'Considerar tempo minimo', help='Se marcado, considera o tempo minimo a ser faturado '
                                            'para servico/OS'),
        'estpar_oservico_minimo_faturado': fields.selection(
            [('S', 'Servico'), ('O', 'Ordem servico')], 'Minimo faturado por', size=1,
            help='Tempo minimo faturado por OS/Servico'),
        'estpar_oservico_tempo_minimo_os': fields.float('Tempo minimo', digits=(2, 4),
                                                        help='Tempo minimo estabalecido para '
                                                             'servico/OS')
    }

    _defaults = {
        'estpar_oservico_considerar_tempo_minimo': lambda *a: False,
        'estpar_oservico_minimo_faturado': lambda *a: 'O',
        'estpar_oservico_tempo_minimo_os': lambda *a: 1.0,
    }
