# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class oservico_apontamento(osv.Model):
    from funcoes import _osvapo_get_tempo, _osvapo_get_tempo_previsto, _osvapo_get_state_os

    _name = 'oservico.apontamento'
    _description = 'Apontamento dos tecnicos nos servicos'
    _rec_name = 'osvapo_servico_id'
    _columns = {
        'osvapo_os_id': fields.many2one('oservico.os', 'OS', required=True, select=True,
                                        ondelete='cascade'),
        'osvapo_servico_id': fields.many2one('oservico.servicos', 'Servico', required=True, select=True,
                                             domain="[('osvsrv_os_id','=',osvapo_os_id), ('osvsrv_concluido','=',False)]"),
        'osvapo_mecanico_id': fields.many2one('oservico.mecanico', 'Tecnico', select=True, required=True),
        'osvapo_inicio': fields.datetime('Inicio', required=True),
        'osvapo_fim': fields.datetime('Termino'),
        'osvapo_cancelado': fields.boolean('Cancelado'),
        'osvapo_cancelado_data': fields.datetime('Data do Cancelamento'),
        'osvapo_cancelado_uid': fields.many2one('res.users', 'Usuario que cancelou'),
        'state': fields.selection([('A', 'Aberto'), ('F', 'Fechado'), ('C', 'Cancelado')], 'Estado'),
        'osvapo_tempo': fields.function(_osvapo_get_tempo, type='float', string='Tempo Atendimento', store=False),
        'osvapo_tempo_previsto': fields.function(_osvapo_get_tempo_previsto, type='float', string='Tempo previsto de atendimento', store=False),
        'osvapo_state_os': fields.function(_osvapo_get_state_os, type='char', size=15, string="Estado O.S.",
                                           store=False)
    }

    _defaults = {
        'osvapo_inicio': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S'),
    }
