from datetime import datetime
import time


#Funcoes da classe oservico.servicos
def _osvsrv_get_nome(self, cursor, user, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for brw_servico in self.browse(cursor, user, ids):
        if brw_servico.osvsrv_servico_id:
            res[brw_servico.id] = brw_servico.osvsrv_servico_id.codigo + ' - ' + brw_servico.osvsrv_servico_id.name
        else:
            res[brw_servico.id] = ''
    return res


def _osvsrv_verifica_veiculo_instalado(self, cr, uid, ids, field, args, context=None):
    context = context and context.copy() or {}
    _veiculo = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'oservico_veiculo', context)
    res = {}.fromkeys(ids, _veiculo)
    return res


#Funcoes da classe oservico.apontamento
def _osvapo_get_tempo(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for brw_apontamento in self.browse(cr, uid, ids, context=context):
        if brw_apontamento.osvapo_inicio and brw_apontamento.osvapo_fim:
            i = datetime.fromtimestamp(time.mktime(time.strptime(brw_apontamento.osvapo_inicio, "%Y-%m-%d %H:%M:%S")))
            f = datetime.fromtimestamp(time.mktime(time.strptime(brw_apontamento.osvapo_fim, "%Y-%m-%d %H:%M:%S")))
            tempo = f - i
            res[brw_apontamento.id] = tempo.days * 24 + (float(tempo.seconds) / 3600)
        else:
            res[brw_apontamento.id] = 0.0
    return res


def _osvapo_get_tempo_previsto(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for brw_apontamento in self.browse(cr, uid, ids, context=context):
        servicos = self.pool.get('oservico.servicos').browse(cr, uid, brw_apontamento.osvapo_servico_id.id)
        res[brw_apontamento.id] = servicos.osvsrv_duracao_prevista
    return res


def _osvapo_get_state_os(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    os_state = {
        'E': 'Esboco',
        'A': 'Aberta',
        'C': 'Cancelada',
        'F': 'Fechada',
    }
    res = {}
    for brw_apontamento in self.browse(cr, uid, ids, context=context):
        state = ''
        if brw_apontamento.osvapo_os_id:
            state = brw_apontamento.osvapo_os_id.state
            state = os_state.get(state)
            if not state:
                state = ''
        res[brw_apontamento.id] = state
    return res


#Funcoes da classe oservico.os
def _osvos_get_adm_mensagem_padrao(self, cr, uid, ids, field_name, args, context=None):
    """
    Metodo de campo function. Busca e insere no atributo 'osvos_mensagem_padrao' a mensagem padrao
    cadastrada nos parametros do adm
    """
    context = context and context.copy() or {}
    res = {}
    adm_util_parametro = self.pool.get('adm.utils').admutl_get_parametros(
        cr, uid, 'adm', 'admpar_oservico_mensagem_padrao')
    mensagem_padrao = adm_util_parametro.get('admpar_oservico_mensagem_padrao') or ''
    brw_oservico_os = self.browse(cr, uid, ids, context=context)
    for x in brw_oservico_os:
        res[x.id] = mensagem_padrao
    return res


#Funcoes da classe oservico.os
def _osvos_get_total(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for brw_os in self.browse(cr, uid, ids, context=context):
        total = 0.0 - brw_os.osvos_desconto_servico - brw_os.osvos_desconto_pecas
        if brw_os.osvos_servicos_ids:
            for brw_servico in brw_os.osvos_servicos_ids:
                total += brw_servico.osvsrv_quantidade * brw_servico.osvsrv_preco_unitario
        if brw_os.osvos_pecas_ids:
            for brw_pecas in brw_os.osvos_pecas_ids:
                if brw_pecas.devolucao:
                    total -= brw_pecas.quantidade * brw_pecas.preco_unitario
                else:
                    total += brw_pecas.quantidade * brw_pecas.preco_unitario
        res[brw_os.id] = total
    return res


def _osvos_get_total_servicos(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for brw_os in self.browse(cr, uid, ids, context=context):
        total = 0.0 - brw_os.osvos_desconto_servico
        if brw_os.osvos_servicos_ids:
            for brw_servico in brw_os.osvos_servicos_ids:
                total += brw_servico.osvsrv_quantidade * brw_servico.osvsrv_preco_unitario
        res[brw_os.id] = total
    return res


def _osvos_get_total_pecas(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for brw_os in self.browse(cr, uid, ids, context=context):
        total = 0.0 - brw_os.osvos_desconto_pecas
        if brw_os.osvos_pecas_ids:
            for brw_pecas in brw_os.osvos_pecas_ids:
                if brw_pecas.devolucao:
                    total -= brw_pecas.quantidade * brw_pecas.preco_unitario
                else:
                    total += brw_pecas.quantidade * brw_pecas.preco_unitario
        res[brw_os.id] = total
    return res


#Funcoes da classe oservico.requisicao.itens
def _osvrqi_get_os(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    for brw_requisicao_itens in self.browse(cr, uid, ids, context=context):
        id = brw_requisicao_itens.id
        os_id = brw_requisicao_itens.osvrqi_capa_id.id
        res[id] = os_id
    return res


#Funcoes da classe oservico.categoria
def _osvcat_nome_completo(self, cr, uid, ids, prop, unknow_none, context=None):
    """
    Metodo para retornar a estrutura da arvore das categorias
    """
    context = context and context.copy() or {}
    res = self.name_get(cr, uid, ids, context=context)
    return dict(res)


def _osvcat_tem_filho(self, cr, uid, ids, name_fields, args, context=None):
    context = context and context.copy() or {}
    res = {}
    for x in ids:
        record = self.search(cr, uid, [('parent_id', 'child_of', ids)], context=context)
        if record != ids:
            res[x] = True
    return res


def _osvcat_uniq_categoria(self, cr, uid, ids, context=None):
    context = context and context.copy() or {}
    vals = self.read(cr, uid, ids, ['name', 'parent_id'], context=context)
    sql = "select * from oservico_categoria where name ilike '%s'" % vals[0]['name']
    if vals[0]['parent_id']:
        sql += "and parent_id = '%s'" % vals[0]['parent_id'][0]
    cr.execute(sql)
    res = cr.fetchall()
    #res = cr.fetchall()
    if len(res) >= 2:
        return False
    return True
