#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from funcoes import _osvcat_nome_completo, _osvcat_tem_filho
from funcoes import _osvcat_uniq_categoria


class oservico_categoria(osv.Model):
    """
    Categoria de equipamentos da ordem de serviços.
    """
    _name = 'oservico.categoria'
    _columns = {
        #________________________________________CHAR______________________________________________
        'name': fields.char('Nome Categoria', size=60),

        #________________________________________one2Many__________________________________________
        'parent_id': fields.many2one("oservico.categoria", 'Categoria Pai', ondelete="cascade",
                                     select=True),
        'child_ids': fields.one2many('oservico.categoria', 'parent_id', 'Categorias filhas'),
        'osvcat_oservico_ids': fields.one2many('oservico.os', 'osvos_categoria_id',
                                                'Ordem Servico'),

        #________________________________________Function__________________________________________
        'osvcat_nome_completo': fields.function(_osvcat_nome_completo, method=True, type="char",
                                                string='Descricao completa'),
        'osvcat_verifica_filho': fields.function(_osvcat_tem_filho, method=True,
                                                 string='Contem filho', type='boolean'),
    }

    _sql_constraints = [
        ('name_uniq', 'unique (name, parent_id)', 'Esta categoria ja existe '
                                                                'para a categoria pai ')
    ]

    _constraints = [(_osvcat_uniq_categoria, 'Esta categoria ja existe '
                                             'para a categoria pai', ['Nome categoria'])]
