# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class oservico_requisicao_capa(osv.Model):
    """
    Requisicao de pecas para a Ordem de Servico
    """
    _name = 'oservico.requisicao.capa'
    _inherit = ['mail.thread', 'ir.needaction_mixin']
    _description = 'Capa da Requisicao de pecas (OS)'
    _rec_name = 'osvrqc_numero'
    _columns = {
        'company_id': fields.many2one('res.company', 'Empresa', required=True, readonly=True, select=True),
        'osvrqc_os_id': fields.many2one('oservico.os', 'Os', required=True, select=True),
        'osvrqc_numero': fields.char('Numero', size=11, select=True, readonly=True), # Numero da requisicao
        'osvrqc_data': fields.date('Data', required=True, readonly=True, select=True), # Data da requisicao
        'osvrqc_requisitante_id': fields.many2one('res.users', 'Requisitante', required=True, select=True),
        'osvrqc_mecanico_id': fields.many2one('oservico.mecanico', 'Tecnico/Mecanico', select=True),
        'osvrqc_cancelado_user_id': fields.many2one('res.users', 'Cancelado por'), # Usuário que cancelou a requisicao.
        'osvrqc_devolucao': fields.boolean('Devolucao', help='Indica que a requisicao e uma devolucao de pecas'),
        'osvrqc_requisicao_devolucao_id': fields.many2one('oservico.requisicao.capa', 'Requisicao relacionada',
                                                          select=True),
        'osvrqc_requisicao_itens_ids': fields.one2many('oservico.requisicao.itens', 'osvrqi_capa_id',
                                                       'Itens da requisicao'),
        'state': fields.selection([('E', 'Esboco'), ('N', 'Entregue'), ('C', 'Cancelada')], 'Estado', required=True,
                                  size=1), # Estado da requisicao \
        'osvrqc_observacao': fields.text('Informacoes complementares'),
        'osvrqc_local_id': fields.many2one('estoque.local', 'Local', required=True),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        'osvrqc_devolucao': lambda *a: False,
        'osvrqc_data': lambda *a: time.strftime('%Y-%m-%d'),
        'state': 'E',
    }
    _sql_constraints = [
        ('osvrqc_numero_uniq', 'unique (company_id,osvrqc_numero)', 'O Numero da requisicao precisa ser unico!'),
    ]

    _order = 'osvrqc_numero desc'

