# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class oservico_requisicao_itens(osv.Model):
    from funcoes import _osvrqi_get_os

    _name = 'oservico.requisicao.itens'
    _description = 'Itens da requisicao de pecas (OS)'
    _rec_name = 'osvrqi_produto_id'
    _columns = {
        'osvrqi_capa_id': fields.many2one('oservico.requisicao.capa', 'Requisicao', required=True, select=True, ondelete="cascade" ),
        'osvrqi_produto_id': fields.many2one('estoque.produto', 'Produto', required=True, domain="[('tipo','=','P')]",
                                             select=True),
        'osvrqi_grade_id': fields.many2one('estoque.produto.grade', 'Grade', required=True,
                                           domain="[('produto_id','=',osvrqi_produto_id)]", select=True),
        'osvrqi_quantidade': fields.float('Quantidade', digits=(8, 3), required=True),
        'osvrqi_preco_unitario': fields.float('Preco unitario', digits=(12, 2), required=True),
        'osvrqi_os_id': fields.function(_osvrqi_get_os, type='integer', method=True, string='OS', store=False),
    }
    _defaults = {
        'osvrqi_quantidade': lambda *a: 1,
    }

