# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import _osvsrv_get_nome

class oservico_servicos(osv.Model):
    _name = 'oservico.servicos'
    _description = 'Servicos na OS'
    _columns = {
        'name': fields.function(_osvsrv_get_nome, method=True, string='Servico', type='text', store=False),
        'osvsrv_os_id': fields.many2one('oservico.os', 'OS', required=True, select=True,
                                        ondelete='cascade'),
        'osvsrv_servico_id': fields.many2one('estoque.produto', 'Servico', required=True, domain="[('tipo','=','S')]",
                                             select=True),
        'osvsrv_quantidade': fields.float('Quantidade', digits=(8, 3), required=True),
        'osvsrv_duracao_prevista': fields.float('Previsao', float=(2,2)),
        'osvsrv_mecanico_id': fields.many2one('oservico.mecanico', 'Tecnico', select=True),
        'osvsrv_preco_unitario': fields.float('Preco unitario', digits=(12, 2)),
        'osvsrv_apontamento_ids': fields.one2many('oservico.apontamento', 'osvapo_servico_id', 'Apontamentos'),
        'osvsrv_observacao': fields.text('Observacao'),
        'osvsrv_concluido': fields.boolean('Concluido'),
        'osvsrv_data_inicio': fields.datetime('Data inicio')
    }
    _defaults = {
        'osvsrv_quantidade': lambda *a: 1,
    }

