# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.sql import drop_view_if_exists


class oservico_requisicao_pgview(osv.Model):
    _name = "oservico.requisicao.pgview"
    _auto = False
    _columns = {
        'capa_id': fields.many2one('oservico.requisicao.capa', 'Requisicao'),
        'produto_id': fields.many2one('estoque.produto', 'Produto'),
        'grade_id': fields.many2one('estoque.produto.grade', 'Grade'),
        'quantidade': fields.float('Quantidade', digits=(8, 3)),
        'preco_unitario': fields.float('Preco unitario', digits=(12, 2)),
        'os_id': fields.many2one('oservico.os', 'O.S.'),
        'devolucao': fields.boolean('Devolucao'),
        'state': fields.selection([('E', 'Esboco'), ('N', 'Entregue'), ('C', 'Cancelada')], 'Estado', size=1),
    }

    def init(self, cr):
        drop_view_if_exists(cr, "oservico_requisicao_pgview")
        cr.execute("""create or replace view oservico_requisicao_pgview  as(
            select
               I.id,
               I.osvrqi_capa_id as capa_id,
               I.osvrqi_produto_id as produto_id,
               I.osvrqi_grade_id as grade_id,
               I.osvrqi_quantidade as quantidade,
               I.osvrqi_preco_unitario as preco_unitario,
               C.osvrqc_os_id as os_id,
               C.osvrqc_devolucao as devolucao,
               C.state as state
            from oservico_requisicao_itens I
            left join oservico_requisicao_capa C on C.id = I.osvrqi_capa_id
            where C.state <> 'C'
            )
            """)

