# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=228):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        title = center_title('', _('Listagem de OS'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='1')
        listagem.informaNome(pdf_string, _('Listagem de OS'))
        listagem.informaTamLinha(160)

        obj_oservico_os = pooler.get_pool(cr.dbname).get('oservico.os')

        data_emissao_inicial = datas.get('data_emissao_inicial')
        data_emissao_final = datas.get('data_emissao_final')
        data_fechamento_inicial = datas.get('data_fechamento_inicial')
        data_fechamento_final = datas.get('data_fechamento_final')
        data_entrega = datas.get('data_entrega')
        cliente_id = datas.get('cliente_id')
        state = datas.get('state')
        args = []
        if isinstance(cliente_id, (list, tuple)):
            cliente_id = cliente_id[0]

        veiculo_id = datas.get('veiculo_id')
        if isinstance(veiculo_id, (list, tuple)):
            veiculo_id = veiculo_id[0]

        if veiculo_id:
            args.append(('osvos_veiculo_id', '=', veiculo_id))
        if state:
            args.append(('state', '=', state))
        if cliente_id:
            args.append(('osvos_pessoa_id', '=', cliente_id))
        if data_entrega:
            args.append(('osvos_data_entrega', '=', data_entrega))
        if data_emissao_inicial:
            args.append(('osvos_data_abertura', '>=', data_emissao_inicial))
        if data_emissao_final:
            args.append(('osvos_data_abertura', '<=', data_emissao_final))
        if data_fechamento_inicial:
            args.append(('osvos_data_fechamento', '>=', data_fechamento_inicial))
        if data_fechamento_final:
            args.append(('osvos_data_fechamento', '<=', data_fechamento_final))
        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                                'inventario.listagem.diferenca.osv', context=context)
        args.append(('company_id', '=', company_id))

        oservico_os_ids = obj_oservico_os.search(cr, uid, args, context=context)
        if oservico_os_ids:
            oservico_os_dados = obj_oservico_os.read(cr, uid, oservico_os_ids,
                                                     ['osvos_numero', 'osvos_pessoa_id', 'osvos_vendedor_id',
                                                      'osvos_vendedor_externo_id', 'osvos_data_abertura',
                                                      'osvos_valor_total', 'osvos_data_entrega', 'osvos_execucao',
                                                      'state', 'osvos_garantia'], context=context)

            res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id, ['name'], context=context)
            nome_empresa = res_company_dados.get('name')
            docs = center_title(' ', nome_empresa, _('Pagina: {{ Page }} '))

            listagem.informaCab('' + title)
            listagem.informaCab('')
            listagem.informaCab('')
            listagem.informaCab('' + docs)
            listagem.informaCab('  ')
            listagem.informaCab(
                '*------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.informaCab(
                _('|  NUMERO   |                       CLIENTE                       |             VENDEDOR              |          VENDEDOR EXTERNO         | DATA EMISSAO | DATA ENTREGA |    VALOR TOTAL   | EXECUCAO | ESTADO | GARANTIA |'))
            listagem.informaCab(
                '*------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.rodapePadrao()
            for x in oservico_os_dados:
                pessoa_id = x.get('osvos_pessoa_id')
                if isinstance(pessoa_id, tuple):
                    pessoa_id = pessoa_id[1]
                vendedor_id = x.get('osvos_vendedor_id')
                if isinstance(vendedor_id, tuple):
                    vendedor_id = vendedor_id[1]
                vendedor_externo_id = x.get('osvos_vendedor_externo_id')
                if isinstance(vendedor_externo_id, tuple):
                    vendedor_externo_id = vendedor_externo_id[1]
                data_abertura = False
                if x.get('osvos_data_abertura'):
                    data_abertura = x.get('osvos_data_abertura')[:10]
                data_entrega = False
                if x.get('osvos_data_entrega'):
                    data_entrega = x.get('osvos_data_entrega')[:10]
                execucao = False
                if x.get('osvos_execucao') == 'I':
                    execucao = _('Interna')
                elif x.get('osvos_execucao') == 'E':
                    execucao = _('Externa')
                estado = False
                if x.get('state') == 'E':
                    estado = _('Esboco')
                elif x.get('state') == 'A':
                    estado = _('Aberta')
                elif x.get('state') == 'C':
                    estado = _('Cancelada')
                elif x.get('state') == 'F':
                    estado = _('Fechada')
                linha = formataString(x.get('osvos_numero') or '', 11, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(pessoa_id or '', 52, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(vendedor_id or '', 34, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(vendedor_externo_id or '', 34, ' ', 'D', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(data_abertura or '', 13, ' ', 'C', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(data_entrega or '', 13, ' ', 'C', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(x.get('osvos_valor_total') or '', 17, ' ', 'E', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(execucao or '', 9, ' ', 'C', 'N', 'S') + '|'
                linha += ' '
                linha += formataString(estado or '', 7, ' ', 'C', 'N', 'S') + '|'
                linha += ' '
                garantia = ''
                if isinstance(x.get('osvos_garantia'), bool):
                    if x.get('osvos_garantia'):
                        garantia = 'Sim'
                    else:
                        garantia = 'Não'
                linha += formataString(garantia or '', 9, ' ', 'E', 'N', 'S') + '|'
                linha += ' '
                listagem.imprimeLinha('|' + linha)

            listagem.imprimeLinha(
                '*------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')
            listagem.imprimeLinha(
                '                                                                                                                                                                                         ** Sig Informatica LTDA **       ')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.oservico_listagem_os')


class listagem_os_osv(osv.TransientModel):
    _name = 'listagem.os.osv'
    _columns = {
        'data_emissao_inicial': fields.date('Data Emissao Inicial'),
        'data_emissao_final': fields.date('Data Emissao Final'),
        'data_fechamento_inicial': fields.date('Data Fechamento Inicial'),
        'data_fechamento_final': fields.date('Data Fechamento Final'),
        'data_entrega': fields.date('Data Entrega'),
        'cliente_id': fields.many2one("adm.pessoa", 'Cliente', ondelete="restrict"),
        'state': fields.selection([('E', 'Esboco'), ('A', 'Aberta'), ('C', 'Cancelada'), ('F', 'Fechada')], 'Estado',
                                  size=1), # Estado da OS E=Esboco, A=Aberta, C=Cancelada, F=Fechada
    }
    _defaults = {
        'data_emissao_inicial': lambda *a: time.strftime('%Y-%m-%d'),
        'data_emissao_final': lambda *a: time.strftime('%Y-%m-%d'),
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        listagem_os_dados = self.read(cr, uid, ids, [], context=context)
        if isinstance(listagem_os_dados, (list, tuple)):
            listagem_os_dados = listagem_os_dados[0]
        datas = {
            'data_emissao_inicial': listagem_os_dados.get('data_emissao_inicial'),
            'data_emissao_final': listagem_os_dados.get('data_emissao_final'),
            'data_fechamento_inicial': listagem_os_dados.get('data_fechamento_inicial'),
            'data_fechamento_final': listagem_os_dados.get('data_fechamento_final'),
            'data_entrega': listagem_os_dados.get('data_entrega'),
            'cliente_id': listagem_os_dados.get('cliente_id'),
            'veiculo_id': listagem_os_dados.get('veiculo_id'),
            'state': listagem_os_dados.get('state'),
        }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'oservico_listagem_os',
            'datas': datas,
        }
