# -*- encoding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.numero import getNumeroEditado
from SigUtils.impressao import Impressora
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
from openerp import pooler
from openerp.tools.translate import _
from dateutil.parser import parse


class ExternalPDF(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class ReportCustom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(e, c, d, t=160):
            title_c = (t - len(c)) / 2
            title = e
            for i in range(title_c - len(e)):
                title += ' '
            title += c
            for i in range(title_c - len(d)):
                title += ' '
            title += d
            return title

        context = context and context.copy() or {}
        brw_listagem_requisicao = pooler.get_pool(cr.dbname).get(
            'wizard.oservico.listagem.requisicao').browse(
            cr, uid, ids[0] if isinstance(ids, (list, tuple)) else ids, context)
        brw_oservico_requisicao_capa = pooler.get_pool(cr.dbname).get(
            'oservico.requisicao.capa').browse(cr, uid, datas.get('requisicao_ids'), context)
        dict_estado = {'E': _('Esboco'), 'N': _('Entregue'), 'C': _('Cancelada')}

        title = center_title('', _('Listagem de Requisicoes'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Listagem de Requisicoes'))
        listagem.informaTamLinha(160)
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'oservico.os', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name') or ''
        docs = center_title(' ', nome_empresa, _('Pagina: {{ Page }} '))

        docs1 = ''
        if brw_listagem_requisicao.data_inicio:
            docs1 += formataString(
                'Data inicial: ' + parse(brw_listagem_requisicao.data_inicio).strftime('%d-%m-%Y'),
                35, ' ', 'D', 'N', 'S')
        if brw_listagem_requisicao.data_fim:
            docs1 += formataString('Data final: ' + parse(
                brw_listagem_requisicao.data_fim).strftime('%d-%m-%Y'), 35, ' ', 'D', 'N', 'S')

        docs2 = ''
        if brw_listagem_requisicao.os_id:
            docs2 += formataString('OS: ' + brw_listagem_requisicao.os_id.osvos_numero, 35, ' ',
                                   'D', 'N', 'S')
        if brw_listagem_requisicao.requisitante_id:
            docs2 += formataString(
                'Requisitante: ' + brw_listagem_requisicao.requisitante_id.name or '', 35, ' ', 'D',
                'N', 'S')

        docs3 = ''
        if brw_listagem_requisicao.mecanico_id:
            docs3 += formataString(
                'Tecnico/Mecanico: ' + brw_listagem_requisicao.mecanico_id.name or '', 35, ' ', 'D',
                'N', 'S')
        if brw_listagem_requisicao.produto_id:
            docs3 += formataString(
                'Produto: ' + str(brw_listagem_requisicao.produto_id.codigo) + ' - ' +
                brw_listagem_requisicao.produto_id.name, 35, ' ', 'D', 'N', 'S')

        docs4 = ''
        if brw_listagem_requisicao.state:
            docs4 += 'Estado: ' + dict_estado.get(brw_listagem_requisicao.state)

        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab(' ')
        if docs1:
            listagem.informaCab(docs1)
        if docs2:
            listagem.informaCab(docs2)
        if docs3:
            listagem.informaCab(docs3)
        if docs4:
            listagem.informaCab(docs4)
        listagem.informaCab('--')
        listagem.informaCab('|OS         |REQUISICAO |DATA      |REQUISITANTE                  '
                            '|ESTADO   |PRODUTO                |GRADE                  '
                            '|QUANTIDADE|P.UNITARIO|     TOTAL|')
        listagem.informaCab('--')
        listagem.rodapePadrao()
        total_geral = 0.0
        for requisicao in brw_oservico_requisicao_capa:
            requisicao_itens_ids = requisicao.osvrqc_requisicao_itens_ids
            if datas.get('produto_id'):
                requisicao_itens_ids = filter(
                    lambda it: it.osvrqi_produto_id.id == datas.get('produto_id'),
                    requisicao_itens_ids)
            data = requisicao.osvrqc_data or ''
            if data:
                data = parse(data).strftime('%d-%m-%Y')
            for item in requisicao_itens_ids:
                linha = formataString(requisicao.osvrqc_os_id.osvos_numero or '', 11, ' ', 'D', 'N',
                                      'S') + '|'
                linha += formataString(requisicao.osvrqc_numero or '', 11, ' ', 'D', 'N', 'S') + '|'
                linha += formataString(data, 10, ' ', 'D', 'N', 'S') + '|'
                linha += formataString(requisicao.osvrqc_requisitante_id.name or '', 30, ' ', 'D',
                                       'N', 'S') + '|'
                linha += formataString(dict_estado.get(requisicao.state) or '', 9, ' ', 'D', 'N',
                                       'S') + '|'
                linha += formataString(item.osvrqi_produto_id.codigo + ' - ' +
                                       item.osvrqi_produto_id.name, 23, ' ', 'D', 'N', 'S') + '|'
                linha += formataString((item.osvrqi_grade_id.grade or '') + ' - ' +
                                       (item.osvrqi_grade_id.name or ''), 23, ' ', 'D', 'N', 'S') \
                    + '|'
                linha += formataString(getNumeroEditado(item.osvrqi_quantidade or 0), 10, ' ', 'E',
                                       'N', 'S') + '|'
                linha += formataString(getNumeroEditado(item.osvrqi_preco_unitario or 0), 10, ' ',
                                       'E', 'N', 'S') + '|'
                total = (item.osvrqi_quantidade or 0) * (item.osvrqi_preco_unitario or 0)
                total_geral += total
                linha += formataString(getNumeroEditado(total), 10, ' ', 'E', 'N', 'S') + '|'
                listagem.imprimeLinha('|' + linha)
            listagem.imprimeLinha(' ')

        listagem.imprimeLinha('--')
        linha = 'TOTAL' + ' ' * 141
        linha += formataString(getNumeroEditado(total_geral), 11, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)
        listagem.imprimeLinha(' ' * 185 + '** Sig Informatica LTDA **       ')

        listagem.finalizaImpressao()
        self.obj = ExternalPDF(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return self.obj.pdf, 'pdf'


ReportCustom('report.oservico_listagem_requisicao')
