# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.numero import getNumeroEditado
from SigUtils.impressao import Impressora
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _
from dateutil.parser import parse


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=150):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        brw_oservico_requisicao_capa = pooler.get_pool(cr.dbname).get(
            'oservico.requisicao.capa').browse(cr, uid, datas.get('requisicao_ids'), context)
        os_numero = brw_oservico_requisicao_capa[0].osvrqc_os_id.osvos_numero
        title = center_title('', _('Dados das Requisicoes da OS ' + os_numero), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Dados requisicoes OS'))
        listagem.informaTamLinha(160)
        listagem.defineFonte(tam=6.5)
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'oservico.os', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name') or ''
        docs = center_title(' ', nome_empresa, _('Pagina: {{ Page }} '))

        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab(' ')
        listagem.informaCab('--')
        listagem.informaCab('|NUMERO     |DATA      |REQUISITANTE                  |ESTADO   '
                            '|PRODUTO                |GRADE                  |QUANTIDADE|P.UNITARIO'
                            '|     TOTAL|')
        listagem.informaCab('--')
        listagem.rodapePadrao()
        for requisicao in brw_oservico_requisicao_capa:
            if requisicao.state == 'E':
                estado = _('Esboco')
            elif requisicao.state == 'N':
                estado = _('Entregue')
            else:
                estado = _('Cancelada')
            data = requisicao.osvrqc_data or ''
            if data:
                data = parse(data).strftime('%d-%m-%Y')
            for item in requisicao.osvrqc_requisicao_itens_ids:
                linha = formataString(requisicao.osvrqc_numero or '', 11, ' ', 'D', 'N', 'S') + '|'
                linha += formataString(data, 10, ' ', 'D', 'N', 'S') + '|'
                linha += formataString(requisicao.osvrqc_requisitante_id.name or '', 30, ' ', 'D',
                                       'N', 'S') + '|'
                linha += formataString(estado or '', 9, ' ', 'D', 'N', 'S') + '|'
                linha += formataString(item.osvrqi_produto_id.codigo + ' - ' +
                                       item.osvrqi_produto_id.name, 23, ' ', 'D', 'N', 'S') + '|'
                linha += formataString((item.osvrqi_grade_id.grade or '') + ' - ' +
                                       (item.osvrqi_grade_id.name or ''), 23, ' ', 'D', 'N', 'S') \
                    + '|'
                linha += formataString(getNumeroEditado(item.osvrqi_quantidade or 0), 10, ' ', 'E',
                                       'N', 'S') + '|'
                linha += formataString(getNumeroEditado(item.osvrqi_preco_unitario or 0), 10, ' ',
                                       'E', 'N', 'S') + '|'
                linha += formataString(
                    getNumeroEditado((item.osvrqi_quantidade or 0) *
                                     (item.osvrqi_preco_unitario or 0)), 10, ' ', 'E', 'N',
                    'S') + '|'
                listagem.imprimeLinha('|' + linha)
            listagem.imprimeLinha(' ')

        listagem.imprimeLinha('--')
        listagem.imprimeLinha(' ' * 185 + '** Sig Informatica LTDA **       ')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.oservico_listagem_dados_requisicoes')
