# -*- encoding: utf-8 -*-

from openerp.tests.common import TransactionCase
from sigaddons.config_teste import set_config


class TestOServicoOS(TransactionCase):
    """
    Classe de testes unitarios da class oservico.os
    """

    @classmethod
    def setUpClass(cls):
        set_config()

    def setUp(self):
        super(TestOServicoOS, self).setUp()
        self.oservico = self.registry('oservico.os')
        self.oservico_id = self.cria_oservico()

    def test_osvos_button_print_os(self):
        numero_os = self.oservico.browse(self.cr, self.uid, self.oservico_id).osvos_numero
        vals = {'type': 'ir.actions.report.xml',
                'report_name': 'oservico.os',
                'name': numero_os}
        res = self.oservico.osvos_button_print_os(self.cr, self.uid, [self.oservico_id])
        self.assertDictEqual(vals, res)

    def cria_oservico(self):
        vals = {
            'osvos_pessoa_id': self.registry('adm.pessoa').search(self.cr, self.uid, [],
                                                                  limit=1)[0],
            'osvos_defeito_relatado': 'TESTE',
        }
        return self.oservico.create(self.cr, self.uid, vals)
