# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class oservico_requisicao_devolucao_osv(osv.TransientModel):
    _name = 'oservico.requisicao.devolucao.osv'
    _columns = {
        'requisicao_original_id': fields.many2one('oservico.requisicao.capa', 'Requisicao de origem', required=True,
                                                  domain="[('state','=','N'), ('osvrqc_devolucao', '=', False)]"),
        #somente as entregues e nao devolvidas
        'data_requisicao_original': fields.datetime('Data requisicao original'),
        'requisitante_original_id': fields.many2one('res.users', 'Nome requisitante da requisicao original'),
    }

    def onchange_requisicao(self, cr, uid, ids, requisicao_id, context=None):
        context = context and context.copy() or {}
        res = {}
        obj_requisicao_capa = self.pool.get('oservico.requisicao.capa')
        if requisicao_id:
            _requisitante_id = obj_requisicao_capa.browse(cr, uid, requisicao_id).osvrqc_requisitante_id.id
            if _requisitante_id:
                res['requisitante_original_id'] = _requisitante_id
            res['data_requisicao_original'] = obj_requisicao_capa.browse(cr, uid, requisicao_id).osvrqc_data
        return {'value': res}

    def button_requisicao_devolucao(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not isinstance(ids, list):
            ids = [ids]
        res = {}
        obj_oservico_requisicao_capa = self.pool.get('oservico.requisicao.capa')
        obj_oservico_requisicao_item = self.pool.get('oservico.requisicao.itens')
        wizard_dados = self.read(cr, uid, ids, ['requisicao_original_id'], context=context)
        for x in wizard_dados:
            requisicao_original_id = x.get('requisicao_original_id')
        if isinstance(requisicao_original_id, tuple):
            requisicao_original_id = requisicao_original_id[0]
        if not isinstance(requisicao_original_id, list):
            requisicao_original_id = [requisicao_original_id]
        requisicao_devolucao_dados = obj_oservico_requisicao_capa.browse(cr, uid, requisicao_original_id, context=context)
        #Gravar capa da requisicao de devolucao
        for x in requisicao_devolucao_dados:
            vals = {
                'company_id': x.company_id.id,
                'osvrqc_os_id': x.osvrqc_os_id.id,
                'osvrqc_data': x.osvrqc_data,
                'osvrqc_requisitante_id': x.osvrqc_requisitante_id.id,
                'osvrqc_mecanico_id': x.osvrqc_mecanico_id.id,
                'osvrqc_devolucao': True,
                'osvrqc_requisicao_devolucao_id': requisicao_original_id[0],
                'state': 'E',
                'osvrqc_observacao': x.osvrqc_observacao
            }
            _requisicao_dev_id = obj_oservico_requisicao_capa.create(cr, uid, vals, context)
            if x.osvrqc_requisicao_itens_ids:
                for item in x.osvrqc_requisicao_itens_ids:
                    #gravar itens da requisicao de devolucao
                    vals = {
                        'osvrqi_capa_id': _requisicao_dev_id,
                        'osvrqi_produto_id': item.osvrqi_produto_id.id,
                        'osvrqi_grade_id': item.osvrqi_grade_id.id,
                        'osvrqi_quantidade': item.osvrqi_quantidade,
                        'osvrqi_preco_unitario': item.osvrqi_preco_unitario,
                    }
                    obj_oservico_requisicao_item.create(cr, uid, vals, context)
                # Marcar a devolucao original indicando que foi devolvida
            context.update({'req_force': True})
            obj_oservico_requisicao_capa.write(cr, uid, requisicao_original_id,
                                               {'osvrqc_requisicao_devolucao_id': _requisicao_dev_id},
                                               context=context)
        return {'type': 'ir.actions.act_window_close'}

