# -*- coding: utf-8 -*-

from openerp.osv import fields, osv
from openerp.tools.translate import _


class wizard_alterar_preco_venda_oservico(osv.TransientModel):
    _name = 'wizard.alterar.preco.venda.oservico'
    _description = 'Alterar preco de venda'

    _columns = {
        'login': fields.char('Login', size=30, required=True),
        'senha': fields.char('Senha', size=30, required=True),
        'produto_id': fields.many2one('estoque.produto', 'Produto'),
        'preco_venda': fields.float('Preco', digits=(9, 2)),
        'altera': fields.boolean('pode alterar Preco de venda'),
        'texto': fields.text('log'),
        'altera_login': fields.boolean('precisa alterar login e senha'),
    }
    _defaults = {
        'altera': lambda *a: False,
        'altera_login': lambda *a: True,
    }

    def default_get(self, cr, uid, fields_list, context=None):
        context = context and context.copy() or {}
        res = osv.osv_memory.default_get(self, cr, uid, fields_list, context=context)
        item_id = context.get('active_id', False)
        if item_id:
            produto = self.pool.get('oservico.requisicao.itens').read(cr, uid, item_id,
                                                                      ['osvrqi_produto_id', 'osvrqi_preco_unitario'], context=context)
            if produto and produto.get('osvrqi_produto_id', False):
                res['produto_id'] = produto['osvrqi_produto_id'][0]
                res['preco_venda'] = produto['osvrqi_preco_unitario']
        obj = self.pool.get('ir.model.access')
        usuario_pertence_grupo = obj.check_groups(cr, uid, 'os.group_estoque_alterar_preco')
        if usuario_pertence_grupo:
            res['altera'] = True
            res['altera_login'] = False

        return res

    def onchange_dados(self, cr, uid, ids, login, senha, context=None):
        context = context and context.copy() or {}
        val = {'value': {'altera': False, 'altera_login': True}}
        val['texto'] = False
        obj = self.pool.get('ir.model.access')
        res = obj.check_groups(cr, uid, 'estoque.group_estoque_alterar_preco')
        if res == True:
            val['value']['altera'] = True
            val['value']['altera_login'] = False
        if login and senha:
            usuario = self.pool.get('res.users').search(cr, uid, [('login', '=', login), ('password', '=', senha)],
                                                        context=context)
            if usuario:
                usuario = usuario[0]
                res = obj.check_groups(cr, usuario, 'estoque.group_estoque_alterar_preco')
                if res == True:
                    val = {'value': {'altera': True}}
                else:
                    val = {'value': {'texto': _('Usuario sem permissao')}}
            else:
                val = {'value': {'texto': _('Usuario nao cadastrado')}}
        return val

    def altera_preco_venda(self, cr, uid, ids, context=None):
        """
            Contexto criado pois o metodo 'write' usa um metodo onchange que recalcula o preco de venda
        """

        context = context and context.copy() or {}
        context['oservico_preco_venda'] = True
        preco_venda = self.read(cr, uid, ids, ['preco_venda'], context=context)
        if preco_venda:
            preco_venda = preco_venda[0]['preco_venda']
            item_id = context.get('active_id', False)
            if item_id:
                self.pool.get('oservico.requisicao.itens').write(cr, uid, item_id,
                                                                 {'osvrqi_preco_unitario': preco_venda}, context)
        return {'type': 'ir.actions.act_window_close'}
