# -*- coding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _


class wizard_oservico_listagem_requisicao(osv.TransientModel):
    _name = 'wizard.oservico.listagem.requisicao'
    _columns = {
        'data_inicio': fields.date('Data inicial'),
        'data_fim': fields.date('Data final'),
        'os_id': fields.many2one('oservico.os', 'OS'),
        'requisitante_id': fields.many2one('res.users', 'Requisitante'),
        'mecanico_id': fields.many2one('oservico.mecanico', 'Tecnico/Mecanico'),
        'produto_id': fields.many2one('estoque.produto', 'Produto'),
        'state': fields.selection([('E', 'Esboco'), ('N', 'Entregue'), ('C', 'Cancelada')],
                                  'Estado', size=1),
    }

    def button_imprimi_listagem_requisicao(self, cr, uid, ids, context=None):
        """
        O metodo organiza os dados e processa acao de chamada para a classe de relatorio.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: id da tabela desse objeto.
        :type ids: list
        :param context: dados contextuais.
        :type context: dict
        :return: dados da acao para a classe do relatorio.
        :rtype: dict
        """
        context = context and context.copy() or {}
        brw_listagem_requisicao = self.browse(
            cr, uid, ids[0] if isinstance(ids, (list, tuple)) else ids, context)
        data_inicio = brw_listagem_requisicao.data_inicio
        data_fim = brw_listagem_requisicao.data_fim
        if data_inicio > data_fim:
            raise osv.except_osv(_('Atencao'), _('Data inicial maior que a data final.'))
        obj_oservico_requisicao_capa = self.pool.get('oservico.requisicao.capa')
        obj_oservico_requisicao_itens = self.pool.get('oservico.requisicao.itens')
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'oservico.requisicao.capa', context=context)
        args = [('company_id', '=', company_id)]
        if data_inicio:
            args.append(('osvrqc_data', '>=', data_inicio))
        if data_fim:
            args.append(('osvrqc_data', '<=', data_fim))
        if brw_listagem_requisicao.os_id:
            args.append(('osvrqc_os_id', '=', brw_listagem_requisicao.os_id.id))
        if brw_listagem_requisicao.requisitante_id:
            args.append(('osvrqc_requisitante_id', '=', brw_listagem_requisicao.requisitante_id.id))
        if brw_listagem_requisicao.mecanico_id:
            args.append(('osvrqc_mecanico_id', '=', brw_listagem_requisicao.mecanico_id.id))
        if brw_listagem_requisicao.state:
            args.append(('state', '=', brw_listagem_requisicao.state))
        requisicao_capa_ids = obj_oservico_requisicao_capa.search(cr, uid, args, context=context)
        datas = {'requisicao_ids': requisicao_capa_ids,
                 'produto_id': brw_listagem_requisicao.produto_id.id}
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'oservico_listagem_requisicao',
            'name': 'Listagem de Requisicoes',
            'datas': datas
        }
