# -*- coding: utf-8 -*-

# Funcoes da classe oservico_os


def osvos_get_dados_veiculo(self, cr, uid, ids, field_name, arg, context=None):
    """
    Metodo de atributos funcionais. Baseado nos dados da placa ('osvos_placa') sera buscado o
    identificador do veiculo (veiculos_veiculo). Se encontrado, acessa os dados da descricao, marca,
    modelo e ano de fabricacao.
    :param cr: cursor no banco de dados.
    :type cr: object
    :param uid: id da tabela res_users, identificador do usuario.
    :type uid: int
    :param ids: lista de registros da tabela dessa classe.
    :type ids: list
    :param field_name: conjunto da descricao dos atributos.
    :type field_name: list
    :param arg: conjunto de argumentos para pesquisa.
    :type arg: list
    :param context: conjunto de dados contextuais.
    :type context: dict
    :return: conjunto de dados com a descricao de cada atributo e seu respectivo valor.
    :rtype: dict[dict]
    """
    context = context and context.copy() or {}
    obj_veiculos_veiculo = self.pool.get('veiculos.veiculo')
    res = {}
    for os in self.browse(cr, uid, ids, context):
        res[os.id] = {}
        if not os.osvos_placa:
            continue
        args_veiculo = [('placa', '=', os.osvos_placa.upper())]
        if os.osvos_pessoa_id.id:
            args_veiculo.append(('veivei_pessoa_id', '=', os.osvos_pessoa_id.id))
        veiculo_id = obj_veiculos_veiculo.search(cr, uid, args_veiculo, limit=1, context=context)
        if not veiculo_id:
            continue
        brw_veiculo = obj_veiculos_veiculo.browse(cr, uid, veiculo_id[0], context)
        res[os.id] = {'osvos_veiculo_name': brw_veiculo.name or '',
                      'osvos_veiculo_marca_id': brw_veiculo.marca_id.id or False,
                      'osvos_veiculo_modelo_id': brw_veiculo.modelo_id.id or False,
                      'osvos_veiculo_ano_fabricacao': brw_veiculo.ano_fabricacao or ''}
    return res
