# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv


class oservico_os(osv.Model):

    _inherit = 'oservico.os'

    def osvos_onchange_placa(self, cr, uid, ids, pessoa_id, placa, context=None):
        """
        O metodo encontra o cliente (pessoa_id) que possui o veiculo com a placa informada. Metodo
        chamado na saida do campo 'osvos_placa'.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param pessoa_id: id da tabela adm_pessoa.
        :type pessoa_id: int
        :param placa: sequencia de caracteres da placa de um veiculo.
        :type placa: str
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return:
        """
        context = context and context.copy() or {}
        res = {'value': {'osvos_veiculo_name': '',
                         'osvos_veiculo_marca_id': False,
                         'osvos_veiculo_modelo_id': False,
                         'osvos_veiculo_ano_fabricacao': ''}
               }
        if not placa:
            return res
        args_veiculo = [('placa', 'ilike', placa)]
        if pessoa_id:
            args_veiculo.append(('veivei_pessoa_id', '=', pessoa_id))
        obj_veiculos_veiculo = self.pool.get('veiculos.veiculo')
        veiculo_ids = obj_veiculos_veiculo.search(cr, uid, args_veiculo, context=context)
        if not veiculo_ids:
            return res
        brw_veiculo = obj_veiculos_veiculo.browse(cr, uid, veiculo_ids[0], context)
        res['value'] = {'osvos_veiculo_name': brw_veiculo.name or '',
                        'osvos_veiculo_marca_id': brw_veiculo.marca_id.id or False,
                        'osvos_veiculo_modelo_id': brw_veiculo.modelo_id.id or False,
                        'osvos_veiculo_ano_fabricacao': brw_veiculo.ano_fabricacao or ''}
        if not pessoa_id and brw_veiculo.veivei_pessoa_id:
            res['value'].update({'osvos_pessoa_id': brw_veiculo.veivei_pessoa_id.id or False})
        return res
