# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import osvos_get_dados_veiculo


class oservico_os(osv.Model):

    _name = 'oservico.os'
    _inherit = 'oservico.os'
    _columns = {
        'osvos_equip_motor': fields.char('Motor', size=20),
        'osvos_equip_bicos': fields.char('Bicos', size=20),
        'osvos_km': fields.integer('Km'),
        'osvos_veiculo_id': fields.many2one('veiculos.veiculo', 'Veiculo', select=True,
                                            domain="[('veivei_pessoa_id','=',osvos_pessoa_id)]"),
        'osvos_placa': fields.char('Placa', size=7),
        'osvos_oficina_id': fields.many2one('oservico.oficinas', 'Oficina', select=True),
        'osvos_veiculo_name': fields.function(osvos_get_dados_veiculo, mthod=True,
                                              string='Veiculo', type='char', size=50,
                                              multi='veiculo'),
        'osvos_veiculo_marca_id': fields.function(osvos_get_dados_veiculo, mthod=True,
                                                  string='Marca', type='many2one',
                                                  relation='veiculos.marca', multi='veiculo'),
        'osvos_veiculo_modelo_id': fields.function(osvos_get_dados_veiculo, mthod=True,
                                                   string='Modelo', type='many2one',
                                                   relation='veiculos.modelo', multi='veiculo'),
        'osvos_veiculo_ano_fabricacao': fields.function(osvos_get_dados_veiculo, mthod=True,
                                                        string='Ano fabricacao', type='char',
                                                        size=4, multi='veiculo'),
    }
