# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
from datetime import date
from SigUtils import datas
import socket
from SigUtils.formatastring import formataString
from dateutil.parser import parse


class oservico_os(osv.Model):
    _name = 'oservico.os'
    _inherit = 'oservico.os'

    def copy(self, cr, uid, id, default={}, context=None):
        context = context and context.copy() or {}
        context.update({'oservico_copy': True})
        default.update({'osvos_orcamento_id': False})
        return super(oservico_os, self).copy(cr, uid, id, default, context)

    def osvos_button_abrir(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_adm_condicoes = self.pool.get('adm.condicao')
        obj_oservico_os_condicao = self.pool.get('oservico.os.condicao')
        obj_oservico_os_parcela = self.pool.get('oservico.os.parcela')
        for brw_os in self.browse(cr, uid, ids, context=context):
            if brw_os.osvos_orcamento_id and brw_os.osvos_orcamento_id.state not in ('3A', '4G'):
                raise osv.except_osv(_('Atencao'),
                                     _('Nao posso abrir O.S. sem ter o orcamento aprovado!'))
            if brw_os.osvos_orcamento_id:
                for condicao in brw_os.osvos_orcamento_id.orcamento_condicao_ids:
                    if condicao.aprovado:
                        vals = {
                            'osvocd_capa_id': brw_os.id,
                            'osvocd_valor': condicao.valor,
                            'osvocd_condicao_forma_id': condicao.condicao_id.id,
                            'osvocd_forma_pagto_id': condicao.forma_pagto_id.id,
                        }
                        obj_oservico_os_condicao.create(cr, uid, vals, context=context)
                        orcamento_condicoes = obj_adm_condicoes.read(cr, uid,
                                                                     condicao.forma_pagto_id.id,
                                                                     ['qtde_parcelas',
                                                                      'dias_primeira_parcela',
                                                                      'dias_incremento',
                                                                      'tipo_prazo'], context=context)
                        vct = date.today()
                        valor_condicao = condicao.valor
                        quantidade_parcelas = orcamento_condicoes['qtde_parcelas']
                        valor_parcela = round(valor_condicao / quantidade_parcelas, 2)
                        soma_parcelas = 0
                        ids_os_condicao = self.pool.get('oservico.os.condicao').search(cr, uid, [
                            ('osvocd_capa_id', '=', brw_os.id)], context=context)
                        for i in range(1, quantidade_parcelas + 1):
                            if i == quantidade_parcelas:
                                valor_parcela = valor_condicao - soma_parcelas
                            if i == 1:# A PRIMEIRA PARCELA DEVE TER A DATA DE VENCIMENTO ACRESCENTADA COM A QUANTIDADE DE DIAS DA PRIMEIRA PARCELA E DEPOIS OS DIAS SERAO INCREMENTADOS
                                dias_parcela = orcamento_condicoes['dias_primeira_parcela']
                            else:
                                dias_parcela = orcamento_condicoes['dias_incremento']
                            vct = datas.sigDatas(vct).getCalculaPrazo(dias_parcela,
                                                                      orcamento_condicoes[
                                                                          'tipo_prazo'],
                                                                      'N')
                            vct = vct[0:4] + '-' + vct[4:6] + '-' + vct[6:8]
                            soma_parcelas += valor_parcela
                            obj_oservico_os_parcela.create(cr, uid, {
                                'osvocp_condicao_id': ids_os_condicao[0],
                                'osvocp_vr_parcela': valor_parcela,
                                'osvocp_data_vencimento': vct,
                            }, context)
                            # GERAR PEDIDO A VISTA
                        if not orcamento_condicoes:
                            vct = datas.sigDatas(date.today()).getCalculaPrazo(0, 'DD', 'N')
                            vct = vct[0:4] + '-' + vct[4:6] + '-' + vct[6:8]
                            obj_oservico_os_parcela.create(cr, uid, {
                                'osvocp_condicao_id': ids_os_condicao[0],
                                'osvocp_vr_parcela': valor_parcela,
                                'osvocp_data_vencimento': vct,
                            }, context)
        super(oservico_os, self).osvos_button_abrir(cr, uid, ids, context=context)

    def osvos_button_gerar_orcamento(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_estoque_produto_embalagem = self.pool.get('estoque.produto.embalagem')
        for brw_os in self.browse(cr, uid, ids, context=context):
            if brw_os.osvos_orcamento_id:
                raise osv.except_osv(_('Atencao'),
                                     _('Nao posso Gerar outro orcamento para esta O.S.!'))
            vals = {
                'observacao': 'O.S. Nro: %s' % brw_os.osvos_numero,
                'pessoa_id': brw_os.osvos_pessoa_id.id,
                'state': '1E',
            }
            if brw_os.osvos_vendedor_id:
                vals['vendedor_id'] = brw_os.osvos_vendedor_id.id
            if brw_os.osvos_vendedor_externo_id:
                vals['vendedor_externo_id'] = brw_os.osvos_vendedor_externo_id.id
            _orcamento_id = self.pool.get('orcamentos.orcamento.capa').create(cr, uid, vals,
                                                                              context)
            self.write(cr, uid, [brw_os.id], {'osvos_orcamento_id': _orcamento_id}, context)
            estoque_parametro = self.pool.get('adm.utils').admutl_get_parametros(
                cr, uid, 'estoque', ['local_venda_padrao_id', 'estpar_embalagem_servico_id'])
            local_id = estoque_parametro.get('local_venda_padrao_id')
            embalagem_id = estoque_parametro.get('estpar_embalagem_servico_id')
            if not local_id:
                raise osv.except_osv(_('Atencao'), _('Cadastre o local para saidas nos parametros '
                                                     'do estoque'))
            if not embalagem_id:
                raise osv.except_osv(_('Atencao'), _('Nao existe embalagem para servico cadastrada '
                                                     'no parametro do estoque'))
            local_numero = self.pool.get('estoque.local').browse(cr, uid, local_id).numero
            for item in brw_os.osvos_pecas_ids:
                requisicao_local_id = item.capa_id.osvrqc_local_id.id
                if item.devolucao or item.capa_id.osvrqc_requisicao_devolucao_id:
                    continue
                emb_id = False
                for locacao in item.grade_id.local_locacao_ids:
                    if locacao.local_id.id != requisicao_local_id:
                        continue
                    emb_id = locacao.estllc_produto_embalagem_id.id
                if not emb_id:
                    raise osv.except_osv(_('Atencao'),
                                         _('O item %s nao tem embalagem cadastrada no local %s!') %
                                         (item.produto_id.codigo, local_numero))
                vals = {
                    'local_id': requisicao_local_id,
                    'orcamento_id': _orcamento_id,
                    'produto_id': item.produto_id.id,
                    'grade_id': item.grade_id.id,
                    'quantidade': item.quantidade,
                    'valor_unitario_bruto': item.preco_unitario,
                    'orcori_preco_venda': item.preco_unitario,
                    'produto_embalagem_id': emb_id
                }
                self.pool.get('orcamentos.orcamento.itens').create(cr, uid, vals, context)
            for servico in brw_os.osvos_servicos_ids:
                produto_embalagem_id = obj_estoque_produto_embalagem.search(
                    cr, uid, [('produto_id', '=', servico.osvsrv_servico_id.id),
                              ('embalagem_id', '=', embalagem_id)], context=context)
                if not produto_embalagem_id:
                    vals_produto_embalagem = {'produto_id': servico.osvsrv_servico_id.id,
                                              'embalagem_id': embalagem_id}
                    produto_embalagem_id = obj_estoque_produto_embalagem.create(
                        cr, uid, vals_produto_embalagem, context)
                else:
                    produto_embalagem_id = produto_embalagem_id[0]
                vals = {
                    'orcamento_id': _orcamento_id,
                    'local_id': local_id,
                    'produto_id': servico.osvsrv_servico_id.id,
                    'grade_id': servico.osvsrv_servico_id.produto_grade_ids[0].id,
                    'produto_embalagem_id': produto_embalagem_id,
                    'quantidade': servico.osvsrv_quantidade,
                    'valor_unitario_bruto': servico.osvsrv_preco_unitario,
                    'orcori_preco_venda': servico.osvsrv_preco_unitario,
                }
                self.pool.get('orcamentos.orcamento.itens').create(cr, uid, vals, context)
        return True

    def _osvos_gerar_pedido(self, cr, uid, ordem_servico, context=None):
        context = context and context.copy() or {}
        company_id = ordem_servico.company_id
        faturamento_sob_demanda = ordem_servico.osvos_faturamento_sob_demanda
        obj_estoquepedidos_pedido_capa = self.pool.get('estoquepedidos.pedido.capa')
        obj_estoquepedidos_pedido_item = self.pool.get('estoquepedidos.pedido.item')
        obj_estoquepedidos_pedido_condicao = self.pool.get('estoquepedidos.pedido.condicao')
        obj_estoquepedidos_pedido_parcela = self.pool.get('estoquepedidos.pedido.parcela')
        obj_estoque_produto_embalagem = self.pool.get('estoque.produto.embalagem')

        pessoa_id = ordem_servico.osvos_pessoa_id.id
        vals = {
            'tipo': 'V',
            'pessoa_id': pessoa_id
        }
        res = obj_estoquepedidos_pedido_capa.create(cr, uid, vals, context)

        obj_estoque_parametro = self.pool.get('estoque.parametro')
        parametro_id = obj_estoque_parametro.search(cr, uid, [('company_id', '=', company_id)], context=context)
        if parametro_id and isinstance(parametro_id, list):
            parametro_id = parametro_id[0]
        dados_estoque_parametro = obj_estoque_parametro.read(cr, uid, parametro_id,
                                                             ['estpar_embalagem_servico_id'], context=context)
        estpar_embalagem_servico_id = dados_estoque_parametro['estpar_embalagem_servico_id']
        if not estpar_embalagem_servico_id:
            raise osv.except_osv(_('Atencao'),
                                 _(
                                     'Nao existe embalagem para servico cadastrada no parametro do estoque'))
        elif isinstance(estpar_embalagem_servico_id, tuple):
            estpar_embalagem_servico_id = estpar_embalagem_servico_id[0]
        servico_ids = map(lambda i: i.id, ordem_servico.osvos_servicos_ids)
        tempo_total_os = self._osvos_get_tempo_total_os(cr, uid, servico_ids, context=context)
        total_apontamento = tempo_total_os.get('total_tempo_apontamento')
        total_previsto = tempo_total_os.get('total_tempo_previsto')
        for servico in ordem_servico.osvos_servicos_ids:
            produto_embalagem_id = obj_estoque_produto_embalagem.search(
                cr, uid, [('produto_id', '=', servico.osvsrv_servico_id.id),
                          ('embalagem_id', '=', estpar_embalagem_servico_id)], context=context)
            if not produto_embalagem_id:
                vals_produto_embalagem = {'produto_id': servico.osvsrv_servico_id.id,
                                          'embalagem_id': estpar_embalagem_servico_id}
                produto_embalagem_id = obj_estoque_produto_embalagem.create(
                    cr, uid, vals_produto_embalagem, context)
            else:
                produto_embalagem_id = produto_embalagem_id[0]
            quantidade_pedida = self._osvos_calcular_quantidade_pedida(
                cr, uid, faturamento_sob_demanda, servico.osvsrv_os_id.id, servico.id,
                total_apontamento, total_previsto, context=context)
            vals_item = {
                'pedido_id': res,
                'produto_id': servico.osvsrv_servico_id.id,
                'qtde_pedida': quantidade_pedida,
                'vr_unitario': servico.osvsrv_preco_unitario,
                'grade_id': servico.osvsrv_servico_id.produto_grade_ids[0].id,
                'produto_embalagem_id': produto_embalagem_id
            }
            obj_estoquepedidos_pedido_item.create(cr, uid, vals_item, context)

        for produto in ordem_servico.osvos_pecas_ids:
            local_id = produto.capa_id.osvrqc_local_id.id
            if not produto.devolucao and produto.state is not 'C':
                produto_embalagem_id = obj_estoque_produto_embalagem.search(cr, uid, [
                    ('produto_id', '=', produto.produto_id.id)], context=context)
                if produto_embalagem_id:
                    produto_embalagem_id = produto_embalagem_id[0]
                context.update({'tipo': 'V'})
                vals_produto = {
                    'pedido_id': res,
                    'produto_id': produto.produto_id.id,
                    'qtde_pedida': produto.quantidade,
                    'vr_unitario': produto.preco_unitario,
                    'grade_id': produto.grade_id.id,
                    'produto_embalagem_id': produto_embalagem_id,
                    'local_id': local_id,
                }
                obj_estoquepedidos_pedido_item.create(cr, uid, vals_produto, context)

        for condicao in ordem_servico.osvos_condicao_ids:
            vals_condicao = {'capa_id': res,
                             'valor': condicao.osvocd_valor or 0,
                             'condicao_forma_id': condicao.osvocd_condicao_forma_id.id,
                             'forma_pagto_id': condicao.osvocd_forma_pagto_id.id,
                             }
            pedido_condicao_id = obj_estoquepedidos_pedido_condicao.create(cr, uid, vals_condicao,
                                                                           context)
            for parcela in condicao.osvocd_os_parcela_ids:
                context.update({'criar': True})
                vals_parcela = {'vr_parcela': parcela.osvocp_vr_parcela or 0,
                                'pedido_condicao_id': pedido_condicao_id,
                                'data_vencimento': parcela.osvocp_data_vencimento,
                                'pedido_id': res}
                obj_estoquepedidos_pedido_parcela.create(cr, uid, vals_parcela, context)

        return res

    def osvos_button_fechar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = super(oservico_os, self).osvos_button_fechar(cr, uid, ids, context=context)
        numero_pedido = False
        for brw_os in self.browse(cr, uid, ids, context=context):
            numero_pedido = self._osvos_gerar_pedido(cr, uid, brw_os, context)
        context['osvos_alteracao_sistema'] = True
        self.write(cr, uid, ids, {'osvos_pedido_id': numero_pedido}, context)
        return res


    def _osvos_calcular_quantidade_pedida(self, cr, uid, faturamento_sob_demanda, ordem_servico_id,
                                          servico_id, total_geral_apontamento,
                                          total_geral_previsto, context=None):
        """
        O metodo calcula a quantidade pedida para cada item que sera incluido no pedido. Essa
        quantidade ira variar de acordo com os parametros.
        @param cr: cursor no banco de dados
        @param uid: id da tabela res_users, identificador do usuario
        @param faturamento_sob_demanda: se True, sera considerado os apontamentos dos servicos,
        se False, sera considerado o tempo previsto
        @param ordem_servico_id: id da tabela oservico_os, identificador da ordem de servico
        @param servico_id: id da tabela oservico_servicos, identificador do servico
        @param total_geral_apontamento: quantidade total dos apontamentos fechados dos servicos
        @param total_geral_previsto: quantidade total dos tempos previstos para os servicos
        @return: float representando a quantidade
        """
        context = context and context.copy() or {}
        obj_adm_util = self.pool.get('adm.utils')
        fields_to_read = ['estpar_oservico_considerar_tempo_minimo',
                          'estpar_oservico_minimo_faturado', 'estpar_oservico_tempo_minimo_os']
        estoque_parametro_dados = obj_adm_util.admutl_get_parametros(cr, uid, 'estoque',
                                                                     fields_to_read)
        considerar_tempo_minimo = estoque_parametro_dados.get(
            'estpar_oservico_considerar_tempo_minimo')
        minimo_faturado = estoque_parametro_dados.get('estpar_oservico_minimo_faturado')
        tempo_minimo = estoque_parametro_dados.get('estpar_oservico_tempo_minimo_os') or 0
        brw_oservico_servico = self.pool.get('oservico.servicos').browse(cr, uid, servico_id)
        quantidade_servico = brw_oservico_servico.osvsrv_quantidade
        name_servico = brw_oservico_servico.osvsrv_servico_id.name or ''
        if faturamento_sob_demanda:
            obj_oservico_apontamento = self.pool.get('oservico.apontamento')
            apontamento_ids = obj_oservico_apontamento.search(
                cr, uid, [('osvapo_os_id', '=', ordem_servico_id),
                          ('osvapo_servico_id', '=', servico_id),
                          ('state', '=', 'F')], context=context)
            brw_oservico_apontamento = obj_oservico_apontamento.browse(cr, uid, apontamento_ids)
            total_tempo_gasto = 0
            for x in brw_oservico_apontamento:
                inicio = x.osvapo_inicio
                fim = x.osvapo_fim
                tempo_gasto = parse(fim) - parse(inicio)
                # Tempo gasto em horas
                total_tempo_gasto += tempo_gasto.total_seconds() / 3600
            if considerar_tempo_minimo:
                if minimo_faturado == 'S' and total_tempo_gasto < tempo_minimo:
                    total_tempo_gasto = tempo_minimo
                elif minimo_faturado == 'O' and total_geral_apontamento < tempo_minimo:
                    diferenca = tempo_minimo - total_geral_apontamento
                    total_tempo_gasto += ((total_tempo_gasto / total_geral_apontamento) * diferenca)
            quantidade = total_tempo_gasto * quantidade_servico
            if not quantidade:
                raise osv.except_osv(_('Atencao'),
                                     _('Para o servico "%s" , a "Quantidade" ou o tempo total '
                                       'apontado estao zerados' % name_servico))
        else:
            quantidade_previsao = brw_oservico_servico.osvsrv_duracao_prevista or 0
            if considerar_tempo_minimo:
                if minimo_faturado == 'S' and quantidade_previsao < tempo_minimo:
                    quantidade_previsao = tempo_minimo
                elif minimo_faturado == 'O' and total_geral_previsto < tempo_minimo:
                    diferenca = tempo_minimo - total_geral_previsto
                    quantidade_previsao += ((quantidade_previsao / total_geral_previsto) *
                                            diferenca)
            quantidade = quantidade_servico * quantidade_previsao
            if not quantidade:
                raise osv.except_osv(_('Atencao'),
                                     _('Para o servico "%s", a "Previsao" esta '
                                       'zerada' % name_servico))
        return quantidade

    def _osvos_get_tempo_total_os(self, cr, uid, servico_ids, context=None):
        """
        O metodo calcula a quantidade total para tempo previsto e tempo de apontamento para
        os servicos de uma ordem de servico
        @param cr: cursor no banco de dados
        @param uid: id da tabela res_users, identificador do usuario
        @param servico_ids: lista de ids da tabela oservico_servicos, identificadores dos servicos
        da ordem de servico
        @return: dicionario com as chaves e valores de tempo total de apontamento e previsao
        """
        context = context and context.copy() or {}
        res = {'total_tempo_apontamento': 0.0, 'total_tempo_previsto': 0.0}
        if not servico_ids:
            return res
        obj_oservico_apontamento = self.pool.get('oservico.apontamento')
        brw_oservico_servico = self.pool.get('oservico.servicos').browse(cr, uid, servico_ids)
        for x in brw_oservico_servico:
            quantidade_servico = x.osvsrv_quantidade
            apontamento_ids = obj_oservico_apontamento.search(
                cr, uid, [('osvapo_os_id', '=', x.osvsrv_os_id.id),
                          ('osvapo_servico_id', '=', x.id),
                          ('state', '=', 'F')], context=context)
            brw_oservico_apontamento = obj_oservico_apontamento.browse(cr, uid, apontamento_ids)
            total_tempo_gasto = 0
            for y in brw_oservico_apontamento:
                inicio = y.osvapo_inicio
                fim = y.osvapo_fim
                tempo_gasto = parse(fim) - parse(inicio)
                # Tempo gasto em horas
                total_tempo_gasto += tempo_gasto.total_seconds() / 3600
            quantidade_apontamento = total_tempo_gasto * quantidade_servico
            res['total_tempo_apontamento'] += quantidade_apontamento

            quantidade_previsao = x.osvsrv_duracao_prevista or 0
            quantidade_previsto = quantidade_servico * quantidade_previsao
            res['total_tempo_previsto'] += quantidade_previsto
        return res
