# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler


class patrimonio_grupos(osv.Model):
    """
    Tabela de Grupos de Bens
    """
    _name = 'patrimonio.grupos'
    _inherit = 'patrimonio.grupos'

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not len(ids):
            return []
        reads = self.read(cr, uid, ids, ['sigla', 'name'], context=context)
        res = []
        for record in reads:
            name = record['sigla'] + '-' + record['name']
            res.append((record['id'], name))
        return res

    def name_search(self, cr, uid, name='', args=[], operator='ilike', context=None, limit=100):
        context = context and context.copy() or {}
        ids = self.search(cr, uid, [('sigla', operator, name.upper())] + args, limit=limit, context=context)
        if not ids:
            ids = self.search(cr, uid, [('name', operator, name)] + args, limit=limit, context=context)
        return self.name_get(cr, uid, ids)

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if 'sigla' in vals:
            if vals['sigla']:
                vals['sigla'] = vals['sigla'].upper()
        result = super(patrimonio_grupos, self).create(cr, uid, vals, context)
        return result

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if 'sigla' in vals:
            if vals['sigla']:
                vals['sigla'] = vals['sigla'].upper()
        result = super(patrimonio_grupos, self).write(cr, uid, ids, vals, context)
        return result

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        context['sig_search_sem_filhos'] = True
        result = super(patrimonio_grupos, self).search(cr, uid, args, offset, limit, order, context, count)
        return result
