# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class patrimonio_movimento(osv.Model):
    """
    Tabela de movimentacao. Resultado da correcao/Depressiacao.
    """
    _name = 'patrimonio.movimento'
    _inherit = 'patrimonio.movimento'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if 'mes' in vals:
            if vals['mes'].isdigit() and int(vals['mes']) > 0 and int(vals['mes']) < 13:
                vals['mes'] = '%002d' % int(vals['mes'])
            else:
                raise osv.except_osv(_('Atencao'), _('Mes invalido!'))
        result = super(patrimonio_movimento, self).create(cr, uid, vals, context)
        return result

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if 'mes' in vals:
            if vals['mes'].isdigit() and int(vals['mes']) > 0 and int(vals['mes']) < 13:
                vals['mes'] = '%002d' % int(vals['mes'])
            else:
                raise osv.except_osv(_('Atencao'), _('Mes invalido!'))
        result = super(patrimonio_movimento, self).write(cr, uid, ids, vals, context)
        return result

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        context['sig_search_sem_filhos'] = True
        result = super(patrimonio_movimento, self).search(cr, uid, args, offset, limit, order, context, count)
        return result