# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler
from openerp.tools.translate import _


class patrimonio_tipo_custos_complementares(osv.Model):
    """
    Tabela de Tipos de Custos complementares na aquisicao de bens
    """
    _name = 'patrimonio.tipo.custos.complementares'
    _inherit = 'patrimonio.tipo.custos.complementares'

    def name_search(self, cr, user, name='', args=None, operator='ilike', context=None, limit=100):
        context = context and context.copy() or {}
        if not args:
            args = []
        context = context and context.copy() or {}
        ids = self.search(cr, user, [('sigla', '=', name.upper())] + args, limit=limit,
                          context=context)
        if not ids:
            ids = self.search(cr, user, [('name', operator, name)] + args,
                              limit=limit, context=context)
        return self.name_get(cr, user, ids, context)

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if 'sigla' in vals:
            if vals['sigla']:
                vals['sigla'] = vals['sigla'].upper()
        result = super(patrimonio_tipo_custos_complementares, self).create(cr, uid, vals, context)
        return result

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if 'sigla' in vals:
            if vals['sigla']:
                vals['sigla'] = vals['sigla'].upper()
        result = super(patrimonio_tipo_custos_complementares, self).write(cr, uid, ids, vals, context)
        return result

