# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class adm_parametro(osv.Model):
    _name = 'adm.parametro'
    _inherit = 'adm.parametro'
    _columns = {
        'admpar_pat_indexador_id': fields.many2one("adm.moeda", 'Indexador', ondelete="restrict", required=True,
                                                   select=True, oldname="patrimonio_indexador_id"), # Id do Indexador/Moeda a ser utilizado!
        'admpar_pat_qtd_parcelas': fields.integer('Qtd de parcelas',
                                                  help='Quantidade de parcelas para apropriacao do credito do ICMS',
                                                  required=True, oldname="patrimonio_qtd_parcelas"), # Numero de parcelas para apropriacao
        'admpar_pat_ano': fields.char('Ultimo ano calculado', size=4, oldname="patrimonio_ano"), # Ultimo ano do calculo da depreciacao/Ciap
        'admpar_pat_mes': fields.char('Ultimo _mes calculado', size=2, oldname="patrimonio_mes"), # Ultimo mes do calculo da depreciacao/Ciap
        'admpar_pat_gerar_ciap': fields.boolean('Gerar Ciap', oldname="patrimonio_gerar_ciap",
                                                help='Marque esta opcao se deseja gerar o controle do Ciap'),
        #Parametros para tonar requerido os campos necessários para a geracao do ciap
    }
    _default = {
        'admpar_pat_gerar_ciap': lambda *a: 1,
    }
    _sql_constraints = [
        ('ciap_parametro_unique', 'unique (company_id)', 'Nao pode haver mais de um parametro por empresa!'),
    ]


