# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler
import time
from openerp.tools.translate import _


class patrimonio_bens_historico_local(osv.Model):
    """
    Tabela de historico das localizacoes dos bens
    """
    _name = 'patrimonio.bens.historico.local'
    _rec_name = 'bem_id'
    _columns = {
        'bem_id': fields.many2one("patrimonio.bens", 'Bem', ondelete="cascade", required=True, select=True),
        'localizacao_id': fields.many2one("patrimonio.localizacao", 'Localizacao', ondelete="restrict", select=True),
        'data_inicial': fields.date('Data Inicial', select=True, required=True),
        'data_final': fields.date('Data Final'), # Data de Saida do bem da localizacao
    }
    _order = 'data_inicial desc'
    _defaults = {
        'data_inicial': lambda *a: time.strftime('%Y-%m-%d'),
    }



