# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler
from openerp.tools.translate import _


class patrimonio_custos_complementares(osv.Model):
    """
    Tabela de Custos complementares da aquisicao de bens
    """
    _name = 'patrimonio.custos.complementares'
    _columns = {
        'bem_id': fields.many2one("patrimonio.bens", 'Bem', ondelete="cascade", required=True, select=True),
        'tipo_id': fields.many2one("patrimonio.tipo.custos.complementares", 'Custo complementar', ondelete="restrict",
                                   required=True), # Bem a quem pertence o custo complementar
        'valor': fields.float('Custo', digits=(12, 2), required=True), # Valor do Custo complementar
        'icms': fields.float('ICMS', digits=(12, 2), help="Valor do ICMS relativo ao custo complementar"),
    }
