# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler


class patrimonio_manutencoes(osv.Model):
    """
    Tabela de manutencao dos bens

    prefixo: patman_
    """
    _name = 'patrimonio.manutencoes'
    _roteavel = True
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'bens_id': fields.many2one("patrimonio.bens", 'Bem', ondelete="restrict", required=True, select=True),
        'data_saida': fields.date('Data da saida'), # Data de saida do bem para manutencao\n
        'destinatario_id': fields.many2one("adm.pessoa", 'Destinatario', ondelete="restrict", select=True),
        'numero_nf': fields.integer('Numero da nf'), # Numero da nf de saida para manutencao\n
        'prazo_entrega': fields.date('Prazo de entrega'), # Data a ser devolvido
        'valor_orcado': fields.float('Valor orcado', digits=(12, 2)), # Valor orcado
        'observacao_saida': fields.text('Observacao na saida'), # Observacoes
        'data_entrada': fields.date('Data de entrada'), # Data da nota fiscal de devolucao
        'numero_nf_entrada': fields.char('Numero da nf entrada', size=45), # Numero da nf de devolucao
        'emitente_id': fields.many2one("adm.pessoa", 'Emitente', ondelete="restrict", select=True),
        'data_garantia': fields.date('Data da garantia'), # Data final da garantia\n
        'valor_pago': fields.float('Valor pago', digits=(12, 2)), # Valor pago
        'observacao_entrada': fields.text('Observacao na entrada'), # Observacoes da entrada(devolucao)
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }

