# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler


class patrimonio_movimento(osv.Model):
    """
    Tabela de movimentacao. Resultado da correcao/Depressiacao.
    """
    _name = 'patrimonio.movimento'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'bem_id': fields.many2one("patrimonio.bens", 'Bem', ondelete="restrict", required=True, select=True),
        'ano': fields.char('Ano', size=4, required=True, select=True), # Ano do movimento
        'mes': fields.char('Mes', size=2, required=True), # Mes do movimento
        'depreciacao_inicial': fields.float('Depreciacao inicial', digits=(12, 2)),
        'depreciacao_final': fields.float('Depreciacao final', digits=(12, 2)),
        'depreciacao_mes': fields.float('Depreciacao mes', digits=(12, 2)), # Valor da depreciacao do mes
        'index_depre_inicial': fields.float('Index depre inicial', digits=(12, 4)), # depreciacao inicial em indexador
        'index_depre_final': fields.float('Index depre final', digits=(12, 4)), # Depreciacao final em indexador
        'index_depre_mes': fields.float('Index depre mes', digits=(12, 4)), # Depreciacao do mes em indexador
    }

    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }
    _order = 'company_id, bem_id, ano, mes'

