# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields
from datetime import datetime


class patrimonio_uso(osv.Model):
    """
    Registro de uso do bem.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    @since: 25.04.2013
    """

    _name = 'patrimonio.uso'                                                        # patuso
    _rec_name = 'patuso_bens_id'

    _columns = {
        # ___________________________ Many2One _______________________________
        'patuso_bens_id': fields.many2one('patrimonio.bens', 'Bem', required=True, select=True),
        'patuso_funcionario_id': fields.many2one('rh.funcionario', 'Funcionario', select=True),

        # ___________________________ Datetime _______________________________
        'patuso_data_inicio': fields.datetime('Inicio do uso', required=False),
        'patuso_data_final': fields.datetime('Fim do uso', required=False),
        'patuso_observacao': fields.text('Observacao')
    }

    _defaults = {
        'patuso_data_inicio': datetime.now().strftime("%Y-%m-%d %H:%M:%S"),
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
