# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler
from openerp.tools.translate import _


class patrimonio_tipo_custos_complementares(osv.Model):
    """
    Tabela de Tipos de Custos complementares na aquisicao de bens
    """
    _name = 'patrimonio.tipo.custos.complementares'
    _columns = {
        'name': fields.char('Descricao', size=40, required=True), # Descricao do tipo de custo de aquisicao
        'sigla': fields.char('Sigla', size=3, required=True, select=True),
        'active': fields.boolean('Ativo'),
    }

    _defaults = {
        'active': lambda *a: 1,
    }
    _sql_constraints = [
        ('sigla_tipo_custo_complementar', 'unique (sigla)', 'A sigla precisa ser unica!'),
    ]


