# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields

MES = [('01', 'Janeiro'), ('02', 'Fevereiro'), ('03', 'Marco'), ('04', 'Abril'),
       ('05', 'Maio'), ('06', 'Junho'), ('07', 'Julho'), ('08', 'Agosto'),
       ('09', 'Setembro'), ('10', 'Outubro'), ('11', 'Novembro'),
       ('12', 'Dezembro')]


class wizard_depreciacao_bem(osv.TransientModel):
    """
    Calcular a Depreciacao.

    @change: 13.05.2013 - pierre.barbosa
    """
    _name = 'wizard.depreciacao.bem'                                                # wizdep

    from funcoes import wizdep_proximo_ano, wizdep_proximo_mes

    _columns = {
        # ___________________________ Many2One _______________________________
        'company_id': fields.many2one("res.company", 'Empresa',
                                      ondelete="restrict", required=True,
                                      select=True),

        # ___________________________ Char ___________________________________
        'ano': fields.char('Ano', size=4, required=True, select=True),              # Ano do movimento

        # ___________________________ Selection ______________________________
        'mes': fields.selection(MES, 'Mes', size=2, required=True),                 # Mes do movimento
    }

    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(cr, uid, uid).company_id.id,
        'ano': wizdep_proximo_ano,
        'mes': wizdep_proximo_mes,
    }

