# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv
from openerp.tools.translate import _
# __________________________ wizard.depreciacao.bem __________________________
def wizdep_proximo_ano(self, cr, uid, ids, context=None):
    """

    @param cr: {cursor} a linha atual do cursor do banco de dados,
    @param uid: {int} o ID do usuario utilizado para a verificacao de perfil,
    @param ids: {list} lista dos IDs,
    @param context: {dict} um dicionario padrao para valores contextuais,
    @return:

    @change: 13.05.2013 - pierre.barbosa
    """

    from datetime import datetime

    context = context and context.copy() or {}

    if isinstance(ids, (int, long)):
        ids = [ids]

    # ___________________________ Objects ________________________________
    obj_adm_parametro = self.pool.get('adm.parametro')

    parametro_ids = obj_adm_parametro.search(cr, uid, [], context=context)

    if not parametro_ids:
        msg = _('Parametro da Administracao nao cadastrado.')
        raise osv.except_osv(_('Atencao'), msg)

    campos = ['admpar_pat_ano', 'admpar_pat_mes']
    dados_patrimonio = obj_adm_parametro.read(cr, uid, parametro_ids, campos,
                                              context=context)

    mes = datetime.now().month
    ano = datetime.now().year

    if dados_patrimonio and isinstance(dados_patrimonio, list):
        dados_patrimonio = dados_patrimonio[0]

    if dados_patrimonio and isinstance(dados_patrimonio, dict):
        ano = int(dados_patrimonio.get('admpar_pat_ano')) or ano
        mes = int(dados_patrimonio.get('admpar_pat_mes')) or mes

        if mes > 12:
            ano += 1

    return '{0:>4d}'.format(
        ano)                                                    # String, 4 posicoes, alinhada a direita


def wizdep_proximo_mes(self, cr, uid, ids, context=None):
    """

    @param cr: {cursor} a linha atual do cursor do banco de dados,
    @param uid: {int} o ID do usuario utilizado para a verificacao de perfil,
    @param ids: {list} lista dos IDs,
    @param context: {dict} um dicionario padrao para valores contextuais,
    @return:

    @change: 13.05.2013 - pierre.barbosa
    """

    from datetime import datetime

    context = context and context.copy() or {}

    if isinstance(ids, (int, long)):
        ids = [ids]

    # ___________________________ Objects ________________________________
    obj_adm_parametro = self.pool.get('adm.parametro')

    parametro_ids = obj_adm_parametro.search(cr, uid, [], context=context)

    if not parametro_ids:
        msg = _('Parametro da Administracao nao cadastrado.')
        raise osv.except_osv(_('Atencao'), msg)

    campos = ['admpar_pat_ano', 'admpar_pat_mes']
    dados_patrimonio = obj_adm_parametro.read(cr, uid, parametro_ids, campos,
                                              context=context)

    mes = datetime.now().month

    if dados_patrimonio and isinstance(dados_patrimonio, list):
        dados_patrimonio = dados_patrimonio[0]

    if dados_patrimonio and isinstance(dados_patrimonio, dict):
        mes = int(dados_patrimonio.get('admpar_pat_mes')) or mes

        if mes > 12:
            mes = 1

    return '{0:02d}'.format(
        mes)                                                    # String, 2 poscisoes com zero a esquerda

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
