# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields

# -*- encoding: utf-8 -*-

from openerp.report.interface import report_int
from openerp.report.render import render
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
import StringIO
from openerp import pooler
import time
from SigUtils.formatastring import formataString
from openerp.osv import osv, fields
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        title = center_title('', _('BENS'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Listagem de Bens'))
        listagem.informaTamLinha(160)
        usuario_bem = datas.get('uso') or ''
        localizacao_id = datas.get('localizacao_id') or ''
        bem = datas.get('bem') or ''
        args = []
        if usuario_bem:
            patuso_funcionario_ids = pooler.get_pool(cr.dbname).get('rh.funcionario').search(cr, uid,
                                                                                             [('name', 'ilike',
                                                                                               usuario_bem)],
                                                                                             context=context)
            patuso_uso_ids = pooler.get_pool(cr.dbname).get('patrimonio.uso').search(cr, uid, [
                ('patuso_funcionario_id', 'in', patuso_funcionario_ids), ('patuso_data_final', '=', None)],
                                                                                     context=context)
            args.append(('patuso_uso_ids', 'in', patuso_uso_ids))
        if localizacao_id:
            args.append(('localizacao_id', '=', localizacao_id))
        if bem:
            args.append(('name', 'ilike', bem))
        bens_ids = pooler.get_pool(cr.dbname).get('patrimonio.bens').search(cr, uid, args, context=context)

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                                                     'wizard.listagem.item.tributacao',
                                                                                     context=context)
        nome_empresa = pooler.get_pool(cr.dbname).get('res.company').browse(cr, uid, company_id).name
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))

        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab('  ')
        listagem.informaCab(
            '|-----------------------------------------------------------------------------------------------------------------------------------------------------------|')
        listagem.informaCab(
            _(
                '|                                                                         FILTROS:                                                                          |'))
        if bem:
            linha = formataString(bem or '', 149, ' ', 'D', 'S', 'S')
            listagem.informaCab(
                _('| BEM: ' + linha + '|'))
        if localizacao_id:
            localizacao = pooler.get_pool(cr.dbname).get('patrimonio.localizacao').browse(cr, uid, localizacao_id).name
            if localizacao and isinstance(localizacao, list):
                localizacao = localizacao[0]
            linha = formataString(localizacao or '', 141, ' ', 'D', 'S', 'S')
            listagem.informaCab(
                _('| LOCALIZACAO: ' + linha + '|'))
        if usuario_bem:
            linha = formataString(usuario_bem or '', 149, ' ', 'D', 'S', 'S')
            listagem.informaCab(
                _('| USO: ' + linha + '|'))
        if not bem and not localizacao_id and not usuario_bem:
            linha = formataString('', 141, ' ', 'D', 'S', 'S')
            listagem.informaCab(
                _('| NENHUM FILTRO' + linha + '|'))
        listagem.informaCab(
            '|-----------------------------------------------------------------------------------------------------------------------------------------------------------|')
        listagem.informaCab(
            _(
                '|   CODIGO   |           DESCRICAO          |        GRUPO        |        NUMERO DE SERIE       |         LOCALIZACAO          |            USO            |'))
        listagem.informaCab(
            '|-----------------------------------------------------------------------------------------------------------------------------------------------------------|')
        listagem.informaCab(
            '|                                                                                                                                                           |')
        listagem.rodapePadrao()

        if bens_ids:
            bws_bens = pooler.get_pool(cr.dbname).get('patrimonio.bens').browse(cr, uid, bens_ids)
            for i in bws_bens:
                linha = '|'
                linha += formataString(i.codigo_bem or 0, 12, ' ', 'C', 'S', 'S')
                linha += '|'
                linha += formataString(i.name or '-', 30, ' ', 'D', 'S', 'S')
                linha += '|'
                linha += formataString(i.grupos_id.name or '-', 21, ' ', 'C', 'S', 'S')
                linha += '|'
                linha += formataString(i.numero_serie or 0, 30, ' ', 'E', 'S', 'S')
                linha += '|'
                linha += formataString(i.localizacao_id.name or '-', 30, ' ', 'C', 'S', 'S')
                linha += '|'
                nome_uso = ''
                for patuso in i.patuso_uso_ids:
                    if not patuso.patuso_data_final:
                        nome_uso = patuso.patuso_funcionario_id.name
                linha += formataString(nome_uso, 27, ' ', 'D', 'S', 'S')
                linha += '|'
                listagem.imprimeLinha(linha)
        linha = '|-----------------------------------------------------------------------------------------------------------------------------------------------------------|'
        listagem.imprimeLinha(linha)
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_bens')


class wizard_bens(osv.TransientModel):
    _name = 'wizard.bens'
    _description = 'Bens'

    _columns = {
        'bem': fields.char('Bem', size=30),

        'localizacao_id': fields.many2one("patrimonio.localizacao", 'Localizacao',  # Codigo de identificacao do Bem
                                          ondelete="restrict", select=True),
        'uso': fields.char('Uso', size=30),

    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vals = self.browse(cr, uid, ids, context=context)
        for x in vals:
            datas = {
                'bem': x.bem,
                'localizacao_id': x.localizacao_id.id,
                'uso': x.uso, }

        return {'type': 'ir.actions.report.xml',
                'report_name': 'listagem_bens',
                'datas': datas}
