# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class adm_parametro(osv.Model):
    """

    @change: 30.04.2013 - pierre.barbosa
    """

    _name = 'adm.parametro'
    _inherit = 'adm.parametro'

    _columns = {
        'admpar_pat_ano': fields.char('Ultimo ano calculado', size=4, oldname="patrimonio_ano"),              # Ultimo ano do calculo da depreciacao/Ciap
        'admpar_pat_mes': fields.char('Ultimo mes calculado', size=2, oldname="patrimonio_mes"),              # Ultimo mes do calculo da depreciacao/Ciap
        'admpar_pat_gerar_ciap': fields.boolean('Gerar Ciap', oldname="patrimonio_gerar_ciap",                      # Parametros para tonar requerido os campos necessarios para a geracao do ciap
                                                help='Marque esta opcao se deseja gerar o controle do Ciap'),
    }

    _default = {
        'admpar_pat_gerar_ciap': lambda * args: 1
    }

    _sql_constraints = [
        ('ciap_parametro_unique',
         'unique (company_id)',
         'Nao pode haver mais de um parametro por empresa.'),
    ]

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
