# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""
from openerp.tools.translate import _
from openerp import osv

# __________________________ patrimonio.bens _________________________________
def patfis_get_gerarCiap(self, cr, uid, ids, name, arg, context=None):
    """
    Numero de parcelas do CIAP.

    @param cr: {cursor} a linha atual do cursor do banco de dados,
    @param uid: {int} o ID do usuário utilizado para a verificacao de perfil,
    @param ids: {list} lista dos IDs,
    @param name:
    @param arg:
    @param context: {dict} um dicionário padrao para valores contextuais,
    @return: {int} o numero de parcelas ou mensagem de erro.
    """

    context = context and context.copy() or {}

    if isinstance(ids, (int, long)):
        ids = [ids]

    # __________________________ Objects _____________________________________
    obj_parametro = self.pool.get('adm.parametro')

    parametro_ids = obj_parametro.search(cr, uid, [], context=context)

    res = {}
    if parametro_ids:
        campos = ['admpar_pat_gerar_ciap']
        parametro_dados = obj_parametro.read(cr, uid, parametro_ids, campos, context=context)

        if parametro_dados and isinstance(parametro_dados, list):
            parametro_dados = parametro_dados[0]

        if parametro_dados and isinstance(parametro_dados, dict):
            gerar_ciap = parametro_dados.get('admpar_pat_gerar_ciap')

            for _id in ids:
                res[_id] = gerar_ciap

        return res
    else:
        msg = _('Parametro nao cadastrado. Parametro da Administracao - Aba Contabil')
        raise osv.except_osv(_('Atencao'), msg)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
