# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class patrimonio_bens(osv.Model):
    """

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    @since: 26.04.2013
    """

    _name = 'patrimonio.bens'
    _inherit = 'patrimonio.bens'

    from funcoes import patfis_get_gerarCiap

    _columns = {
        # ___________________________ Many2One _______________________________
        'patbem_nota_fiscal_id': fields.many2one(
            'fiscal.nf.capa', 'Nota Fiscal', domain="[('tipo', '=', 'E'), ('state', '=', '3')]"),
        'patbem_item_id': fields.many2one('estoque.movimento.itens', 'Item',
                                          domain="[('nf_id', '=', patbem_nota_fiscal_id)]"),

        # ___________________________ One2Many _______________________________
        'ciap_ids': fields.one2many('patrimoniofiscal.ciap', 'bem_id', 'Ciap'),

        # ___________________________ Functions ______________________________
        'gerar_ciap': fields.function(patfis_get_gerarCiap, method=True, string='Gerar Ciap',
                                      type='boolean', store=False)
    }

    _defaults = {
        'gerar_ciap': lambda s, cr, uid, c: s.patfis_get_gerarCiap(cr, uid, [], 'gerar_ciap', None)
    }


# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
