# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""


# __________________________ CIAP (patrimoniofiscal) ________________________
def patfis_get_upf(self, cr, uid, ids, name, arg, context=None):
    """

    @param cr: {cursor} a linha atual do cursor do banco de dados,
    @param uid: {int} o ID do usuário utilizado para a verificacao de perfil,
    @param ids: {list} lista dos IDs,
    @param name:
    @param arg:
    @param context: {dict} um dicionário padrao para valores contextuais,
    @return:

    @change: 29.04.2013 - pierre.barbosa
    """

    context = context and context.copy() or {}

    if isinstance(ids, (int, long)):
        ids = [ids]

    # ___________________________ Objects ________________________________
    obj_moeda = self.pool.get('adm.moeda.valor')

    result = {}

    for item in self.browse(cr, uid, ids):
        ano = item.ano
        mes = '%02d' % int(item.mes)
        if int(mes) < 1 or int(mes) > 12:
            result[item.id] = 0.00
        else:
            resMoeda = obj_moeda.achar_valor_moeda(cr, uid, 'UPF', ano, mes,
                                                   operador='<=',
                                                   vlDefault=1.00, context=context)
            if not resMoeda['status']:
                result[item.id] = 0.00
            else:
                result[item.id] = resMoeda['valor']
    return result


# __________________________ CIAP/Controle (patrimoniofiscal) _______________
def _patfis_get_saldo(self, cr, uid, ids, name, arg, context=None):
    """

    @param cr: {cursor} a linha atual do cursor do banco de dados,
    @param uid: {int} o ID do usuário utilizado para a verificacao de perfil,
    @param ids: {list} lista dos IDs,
    @param name:
    @param arg:
    @param context: {dict} um dicionário padrao para valores contextuais,
    @return:

    @change: 29.04.2013 - pierre.barbosa
    """

    context = context and context.copy() or {}

    if isinstance(ids, (int, long)):
        ids = [ids]

    # ___________________________ Objects ________________________________
    obj_patrimoniofiscal_ciap = self.pool.get('patrimoniofiscal.ciap')
    obj_patrimonio_bens = self.pool.get('patrimonio.bens')

    result = {}

    for item in self.browse(cr, uid, ids):
        _ano = item.ano
        _mes = '%02d' % int(item.mes)
        _empresa_id = item.company_id.id

        if int(item.mes) < 1 or int(item.mes) > 12:
            result[item.id] = 0.00
        else:
            args = [('company_id', '=', _empresa_id), ('ano', '=', _ano),
                    ('mes', '=', _mes)]
            context.update({'sig_force_company': True})
            ciap_ids = obj_patrimoniofiscal_ciap.search(cr, uid, args, context=context)
            del context['sig_force_company']
            _valor = 0.00

            for ciap_id in ciap_ids:
                ciap_dados = obj_patrimoniofiscal_ciap.read(cr, uid, ciap_id, context=context)

                if ciap_dados and isinstance(ciap_dados, list):
                    ciap_dados = ciap_dados[0]

                if ciap_dados and isinstance(ciap_dados, dict):
                    bem_id = ciap_dados.get('bem_id')
                    bem_dados = obj_patrimonio_bens.read(cr, uid, bem_id[0], context=context)

                    if bem_dados and isinstance(bem_dados, list):
                        bem_dados = bem_dados[0]

                    if bem_dados and isinstance(bem_dados, dict):
                        _data_baixa = _ano + '-' + _mes + '-01'
                        if bem_dados.get('data_baixa') and bem_dados.get('data_baixa') < _data_baixa:
                            continue

                    _valor = _valor + ciap_dados.get('valor_apropriacao') or 0

            result[item.id] = _valor

    return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
