# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv
from openerp.tools.translate import _

# __________________________ SPED (patrimoniofiscal) ________________________
def patfis_get_ano(self, cr, uid, ids, context=None):
    """
    Metodo patfis_get_ano

    @param cr: {cursor} a linha atual do cursor do banco de dados,
    @param uid: {int} o ID do usuário utilizado para a verificacao de perfil,
    @param ids: {list} lista dos IDs,
    @param context: {dict} um dicionário padrao para valores contextuais,
    @return:

    @change: 29.04.2013 - pierre.barbosa
    """

    from datetime import datetime

    context = context and context.copy() or {}

    if isinstance(ids, (int, long)):
        ids = [ids]

    # __________________________ Objects _____________________________________
    obj_parametro = self.pool.get('adm.parametro')

    parametro_ids = obj_parametro.search(cr, uid, [], context=context)
    hoje = datetime.now()

    if parametro_ids:
        campos = ['admpar_pat_ano', 'admpar_pat_gerar_ciap']
        dados_parametro = obj_parametro.read(cr, uid, parametro_ids, campos, context=context)

        if dados_parametro and isinstance(dados_parametro, list):
            dados_parametro = dados_parametro[0]

        if dados_parametro and isinstance(dados_parametro, dict):
            ano = int(dados_parametro.get('admpar_pat_ano')) or hoje.year           # Padrao = ano corrente

            if not dados_parametro.get('admpar_pat_gerar_ciap'):
                msg = _('''No parametro da Administracao nao esta marcado para gerar CIAP!
                Reveja os dados cadastrais dos Bens apos marcar esta opcao.''')
                raise osv.except_osv(_('Atencao'), msg)
            return str(ano)

    raise osv.except_osv(_('Atencao'), _('Parametro da Administracao nao cadastrado.'))


def patfis_get_mes(self, cr, uid, ids, context=None):
    """
    Metodo patfis_get_mes

    @param cr: {cursor} a linha atual do cursor do banco de dados,
    @param uid: {int} o ID do usuário utilizado para a verificacao de perfil,
    @param ids: {list} lista dos IDs,
    @param context: {dict} um dicionário padrao para valores contextuais,
    @return:

    @change: 29.04.2013 - pierre.barbosa
    """

    context = context and context.copy() or {}

    if isinstance(ids, (int, long)):
        ids = [ids]

    # __________________________ Objects _____________________________________
    obj_parametro = self.pool.get('adm.parametro')

    parametro_ids = obj_parametro.search(cr, uid, [], context=context)

    if parametro_ids:
        campos = ['admpar_pat_mes']
        parametro_dados = obj_parametro.read(cr, uid, parametro_ids, campos, context=context)

        if parametro_dados and isinstance(parametro_dados, list):
            parametro_dados = parametro_dados[0]

        if parametro_dados and isinstance(parametro_dados, dict):
            mes = int(parametro_dados.get('admpar_pat_mes')) or 1                   # Padrao = janeiro

            return str('%02d' % mes)

    raise osv.except_osv(_('Atencao'), _('Parametro da Administracao nao cadastrado.'))

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
