# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

import base64
from openerp.osv import osv
from dateutil.parser import parse
from dateutil.relativedelta import relativedelta
from pythonsped.efd import bloco_0


class patrimoniofiscal_sped(osv.TransientModel):
    """
    Gerar arquivo para o SPED

    @change: 02.05.2013 - pierre.barbosa
    """

    _name = 'patrimoniofiscal.sped'
    _inherit = 'patrimoniofiscal.sped'

    def patfis_button_gerar(self, cr, uid, ids, context=None):
        """
        Metodo patfis_button_gerar

        @param cr: {cursor} a linha atual do cursor do banco de dados,
        @param uid: {int} o ID do usuário utilizado para a verificacao de perfil,
        @param ids: {list} lista dos IDs,
        @param context: {dict} um dicionário padrao para valores contextuais,
        @return:

        @change: 28.03.2017 - tiago.santos
        """

        context = context and context.copy() or {}

        if isinstance(ids, (int, long)):
            ids = [ids]

        sped_dados = self.browse(cr, uid, ids[0], context=context)
        ano = sped_dados.ano
        mes = sped_dados.mes

        data_inicio = ano + '-' + mes + '-01'
        data_fim = ((parse(data_inicio) + relativedelta(months=1)) - relativedelta(days=1)).\
            strftime('%Y-%m-%d')

        args_periodo_mes_e_ano = [('mes', '>=', int(mes)), ('mes', '<=', int(mes)),
                                  ('ano', '>=', int(ano)), ('ano', '<=', int(ano))]

        reg_0001 = bloco_0.registro_0001()
        context['patfis_cod_part'] = True
        self.pool.get('fiscal.sped').blocoG(
            cr, uid, data_inicio, data_fim, sped_dados.company_id.id, args_periodo_mes_e_ano,
            int(mes), int(ano), reg_0001, context)
        dados = reg_0001.processos
        dados.sort()
        str_dados = ''.join(dados)
        str_dados += '|G990|%s|' % (len(filter(lambda i: i[1] == 'G', dados)) + 1)
        vals = {
            'dados': base64.encodestring(str_dados.encode('utf-8', 'strict'))
        }

        self.write(cr, uid, ids, vals, context)

        return {}

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
