# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields

MES = [('01', 'Janeiro'), ('02', 'Fevereiro'), ('03', 'Marco'), ('04', 'Abril'),
       ('05', 'Maio'), ('06', 'Junho'), ('07', 'Julho'), ('08', 'Agosto'),
       ('09', 'Setembro'), ('10', 'Outubro'), ('11', 'Novembro'),
       ('12', 'Dezembro')]


class patrimoniofiscal_sped(osv.TransientModel):
    """
    Gerar arquivo para o SPED
    """

    _name = 'patrimoniofiscal.sped'

    from funcoes import patfis_get_ano, patfis_get_mes

    _columns = {
        # ___________________________ Many2One _______________________________
        'company_id': fields.many2one("res.company", 'Empresa',                     # ID da empresa
                                      ondelete="restrict", required=True,
                                      select = True),

        # ___________________________ Char ___________________________________
        'ano': fields.char('Ano', size=4, required=True, select=True),              # Ano do movimento
        'file': fields.char('Arquivo', size=20, readonly=True),

        # ___________________________ Binary _________________________________
        'dados': fields.binary('Arquivo', readonly=True),

        # ___________________________ Selection ______________________________
        'mes': fields.selection(MES, 'Mês', size=2, required=True),                 # Mes do movimento
    }

    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('res.users').browse(cr, uid, uid).company_id.id,
        'ano': patfis_get_ano,
        'mes': patfis_get_mes,
        'file': lambda * args: 'sped_ciap.txt'
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
