# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv


class pcp_ficha_tecnica_embalagem(osv.Model):
    """
    Embalagens da ficha tecnica.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'pcp.ficha.tecnica.embalagem'  # Prefixo: pcpfte_
    _inherit = 'pcp.ficha.tecnica.embalagem'

    def pcpfte_get_cuto(self, cr, uid, produto_id, quantidade):
        estoque_parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(
            cr, uid, tabela='estoque', campos='estpar_custo_para_precovenda')
        custo_para_preco_venda = estoque_parametro_dados.get('estpar_custo_para_precovenda')
        custo = self.pool.get('estoque.preco.custo').get_custos_do_dia(cr, uid, produto_id)
        if custo.get(produto_id) and isinstance(custo, dict):
            if custo_para_preco_venda == 'U':
                custo = custo.get(produto_id).get('estprc_ultimo_custo') or 0
            elif custo_para_preco_venda == 'M':
                custo = custo.get(produto_id).get('estprc_custo_medio_contabil') or 0
            elif custo_para_preco_venda == 'C':
                custo = custo.get(produto_id).get('estprc_custo_corrigido') or 0
            elif custo_para_preco_venda == 'R':
                custo = custo.get(produto_id).get('estprc_custo_reposicao') or 0
            else:
                custo = 0
        else:
            custo = 0
        custo_total = custo*quantidade
        return custo_total

    def pcpfte_onchange_produto_id(self, cr, uid, ids, produto_id, quantidade=0, context=None):
        """
        Verifica se o produto tem apenas uma grade. Se sim, atribui a grade unica ao produto.

        @param cr: {cursor} a linha atual do cursor do banco de dados,
        @param uid: {int} ID do usuario utilizado para a verificacao de perfil,
        @param ids: {list} lista com os IDs,
        @param produto_id: {char} Tipo da acao a ser executada,
        @return: {dict} valor da grade do produto se for unica.

        @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}
        if ids and isinstance(ids, (int, long)):
            ids = [ids]

        # ___________________________ Objects ________________________________
        obj_estoque_produto_grade = self.pool.get('estoque.produto.grade')
        args = [('produto_id', '=', produto_id)]
        grade_ids = obj_estoque_produto_grade.search(cr, uid, args, context=context)

        result = {'value':{}}
        custos = self.pcpfte_get_cuto(cr, uid, produto_id, quantidade)
        result['value']['pcpfte_custo_total'] = custos
        if len(grade_ids) == 1:  # Apenas uma grade
            result['value']['pcpfte_grade_id'] = grade_ids
        else:
            result['value']['pcpfte_grade_id'] = ''

        return result

    def pcpfte_onchange_qtd(self, cr, uid, ids, produto_id, quantidade):
        res={}
        custos = self.pcpfte_get_cuto(cr, uid, produto_id, quantidade=0)
        res['value'] = {'pcpfte_custo_total': custos}
        return res

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
