# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class pcp_ficha_tecnica_itens(osv.Model):
    _name = 'pcp.ficha.tecnica.itens'
    _inherit = 'pcp.ficha.tecnica.itens'

    def onchange_materia_prima_item(self, cr, uid, ids, pcpfti_produto_id, context=None):
        context = context and context.copy() or {}
        obj_estoque_produto_grade = self.pool.get('estoque.produto.grade')
        grade_ids = obj_estoque_produto_grade.search(cr, uid, [('produto_id', '=', pcpfti_produto_id)], context=context)
        vals = {'pcpfti_grade_id': False}
        if len(grade_ids) == 1:
            vals['pcpfti_grade_id'] = grade_ids[0]
            return {'value': vals}

        return {'value': vals}

    def pcpfti_onchange_grade_id(self, cr, uid, ids, pcpfti_grade_id, context=None):
        context = context and context.copy() or {}
        vals = {'pcpfti_produto_embalagem_id': False}
        if not pcpfti_grade_id:
            return {'value': vals}

        obj_locacao = self.pool.get('estoque.local.locacao')
        locacao_ids = obj_locacao.search(cr, uid, [('grade_id', '=', pcpfti_grade_id)], context=context)
        if not locacao_ids:
            return {'value': vals}

        dados_locacao = obj_locacao.read(cr, uid, locacao_ids, ['estllc_produto_embalagem_id'], context)
        if len(dados_locacao) == 1:
            vals['pcpfti_produto_embalagem_id'] = dados_locacao[0].get('estllc_produto_embalagem_id')
            return {'value': vals}

        return {'value': vals}

    def write(self, cr, uid, ids, vals, context=None):
        # Recurso encontrado para solucao desse problema. O problema foi incluído devido a
        # implementacao da atividade 100525, que deve ser revista.
        if vals.get('pcpfti_capa_id') and context.get('no_store_function'):
            return False
        res = super(pcp_ficha_tecnica_itens, self).write(cr, uid, ids, vals, context)
        return res
