#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class pcp_conversao_capa(osv.Model):
    _name = 'pcp.conversao.capa'
    _inherit = 'pcp.conversao.capa'

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = []

        for x in self.browse(cr, uid, ids):
            res.append((x.id, x.pcpcvc_produto_id.name))

        return res

    def pcpcvc_onchange_produto_id(self, cr, uid, ids, produto_id, context=None):
        """
        O metodo insere um valor para a grade (atributo 'pcpcvc_grade_id'), caso ela seja unica
        para o produto_id informado.
        :param cr: cursor no banco de dados.
        :param uid: id da tabela res_users, identificador do usuario.
        :param ids: lista de id da tabela desse objeto.
        :param produto_id: id da tabela estoque_produto.
        :param context: dicionario com valores contextuais.
        :return: dicionario, sendo a chave a descricao do atributo e o valor da chave o valor do
        do atributo.
        """
        context = context and context.copy() or {}
        res = {'value': {'pcpcvc_grade_id': False}}
        if not produto_id:
            return res
        obj_estoque_produto_grade = self.pool.get('estoque.produto.grade')
        produto_grade_id = obj_estoque_produto_grade.estpgr_get_produto_id_grade_unica(
            cr, uid, produto_id, context)
        res['value']['pcpcvc_grade_id'] = produto_grade_id
        return res
