# -*- coding: utf-8 -*-

from openerp.osv import osv


class wizard_listagem_movimento_analitico_osv(osv.TransientModel):
    _inherit = 'wizard.listagem.movimento.analitico.osv'

    def get_origem_movimento_analitico(self, cr, uid, context=None):
        """
        O metodo identifica a origem do item movimentado no estoque.
        Se nota ou cupom fiscal, eh identificado pelo tipo de movimento do CFOP.
        Se pcp, eh identificado pelo id da tabela pcp_ordem_producao (estmvc_ordem_producao_id) na
        capa do movimento.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param context: dados com valores contextuais.
        :type context: dict
        :return: query para busca dos dados no movimento
        :rtype: str
        """
        context = context and context.copy() or {}
        sql = super(wizard_listagem_movimento_analitico_osv, self).get_origem_movimento_analitico(
            cr, uid, context)
        sql = sql.replace("ELSE fc.movimento_tipo",
                          "WHEN emc.estmvc_ordem_producao_id IS NOT NULL THEN 'P' "
                          "ELSE fc.movimento_tipo")
        return sql
