# -*- encoding: utf-8 -*-


from openerp.osv import osv
from openerp.tools.translate import _


class estoque_movimento_itens(osv.Model):
    """
    Tabela com itens movimentados
    """
    _name = 'estoque.movimento.itens'
    _inherit = 'estoque.movimento.itens'


    def estmvi_onchange_quantidade_pcp(self, cr, uid, ids, quantidade, produto_embalagem_id,
                                       context=None):

        context = context and context.copy() or {}
        res = {}
        fracao_unidade = False
        if produto_embalagem_id:
            embalagem_id = self.pool.get('estoque.produto.embalagem').browse(cr, uid,
                                                                             produto_embalagem_id).embalagem_id
            if embalagem_id:
                unidade_id = embalagem_id.unidade_id
                if unidade_id:
                    fracao_unidade = unidade_id.fracao or False

        if quantidade:
            dif = quantidade - int(quantidade)
            if not fracao_unidade and (dif <= -0.001 or 0.001 <= dif) :
                mensagem = _('A embalagem nao aceita fracionamento. \n')
                res['value'] = {'quantidade': 0.0}
                res['warning'] = {'title': _('Atencao'), 'message': mensagem}

        return res


    def create(self, cr, uid, vals, context=None):

        context = context and context.copy() or {}
        if context.get('ctx_pcp_perda_producao'):
            if vals.get('quantidade') == 0:
                raise osv.except_osv(_('Atencao'),
                                     _('A quantidade de perda nao pode ser igual a zero.'))

        res = super(estoque_movimento_itens, self).create(cr, uid, vals, context)

        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if context.get('ctx_pcp_perda_producao'):
            if 'quantidade' in vals and vals['quantidade'] == 0:
                raise osv.except_osv(_('Atencao'),
                                     _('A quantidade de perda nao pode ser igual a zero.'))

        res = super(estoque_movimento_itens, self).write(cr, uid, ids, vals, context)

        return res
