# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv
from openerp.tools.translate import _


class estoquealmoxarifado_requisicao_devolucao_osv(osv.TransientModel):
    """
    Requisicao de devolucao. (heranca)

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'estoquealmoxarifado.requisicao.devolucao.osv'
    _inherit = 'estoquealmoxarifado.requisicao.devolucao.osv'

    def wizard_criar_requisicao_devolucao(self, cr, uid, ids, context):
        """
        Cria a requisicao de devolucao baseada na requisicao original. (heranca)
        Atribuicao do numero da requisicao de origem.

        @param cr: {cursor} a linha atual do cursor do banco de dados,
        @param uid: {int} o ID do usuario utilizado para a verificacao de perfil,
        @param ids: {list} lista dos IDs,
        @param context: {dict} um dicionário padrao para valores contextuais,
        @return: {ind} ID da requisicao de devolucao.

        @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}

        if ids and isinstance(ids, (int, long)):
            ids = [ids]

        # ___________________________ Objects ________________________________
        obj_estoquealmoxarifado_requisicao_capa = self.pool.get('almoxarifado.requisicao.capa')

        requisicao_devolucao_id = super(
            estoquealmoxarifado_requisicao_devolucao_osv, self).wizard_criar_requisicao_devolucao(
            cr, uid, ids, context)

        # Requisicao original
        brw_requisicao_origem = self.browse(cr, uid, ids[0], context)
        ordem_producao_id = brw_requisicao_origem.requisicao_original_id.almrqc_ordem_producao_id.id

        #Verifica se a ordem de producao da requisicao ja foi fechada
        ordem_producao_state = brw_requisicao_origem.requisicao_original_id.\
            almrqc_ordem_producao_id.state
        if ordem_producao_state == 'F':
            pcpopr_numero = brw_requisicao_origem.requisicao_original_id.\
                almrqc_ordem_producao_id.pcpopr_numero
            msg = 'Enquanto esta tela estava aberta a ordem de producao (%s) referente a esta ' \
                  'requisicao foi fechada' % pcpopr_numero
            raise osv.except_osv(_('Atencao'), _(msg))
        # Cria a requisicao de devolucao
        values = {'almrqc_ordem_producao_id': ordem_producao_id}
        obj_estoquealmoxarifado_requisicao_capa.write(cr, uid, requisicao_devolucao_id, values, context)

        return requisicao_devolucao_id

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
