# -*- coding: utf-8 -*-

from openerp.osv import osv


class fiscal_sugestao_preco_item(osv.Model):
    """
    Classe reponsavel pela regra de negocio do itens da sugestao de precos
    """

    _inherit = 'fiscal.sugestao.preco.item'

    def fisspi_get_preco_custo_ficha_tecnica(self, cr, uid, grade_ids, context=None):
        """
        O metodo define os custos para os produtos (grade_ids) recebidos baseando-se nos custos
        totais da ficha tecnica de cada um
        :param cr: cursor no banco de dados.
        :type cr: int
        :param uid: id da tabela res_users, identificador do usuario na transacao.
        :type uid: int
        :param grade_ids: lista de id da tabela estoque_produto_grade, identificadores dos produtos.
        :type grade_ids: list
        :param context: dados contextuais.
        :type context: dict
        :return: dados da identificacao das grades com seus respectivos custos.
        :rtype: dict
        """
        context = context and context.copy() or {}
        dados = {}
        obj_pcp_ficha_tecnica_capa = self.pool.get('pcp.ficha.tecnica.capa')
        ficha_ids = obj_pcp_ficha_tecnica_capa.search(
            cr, uid, [('pcpftc_grade_id', 'in', grade_ids)], context=context)
        campos = ['pcpftc_grade_id', 'pcpftc_custo_total', 'pcpftc_valor_embalagem',
                  'pcpftc_quantidade_peso']
        for ficha in obj_pcp_ficha_tecnica_capa.read(cr, uid, ficha_ids, campos, context,
                                                     '_classic_write'):
            custo = (ficha.get('pcpftc_custo_total') or 0.0) + (ficha.get('pcpftc_valor_embalagem')
                                                                or 0.0)
            custo /= (ficha.get('pcpftc_quantidade_peso') or 1.0)
            dados.update({ficha.get('pcpftc_grade_id'): custo})
        return dados
