#!/usr/bin/python
# -*- coding: utf-8 -*-

from openerp.osv import osv
from datetime import datetime


class fiscal_nf_capa(osv.Model):
    _name = 'fiscal.nf.capa'
    _inherit = 'fiscal.nf.capa'

    def fisnfc_funcao_button_faturar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        super(fiscal_nf_capa, self).fisnfc_funcao_button_faturar(cr, uid, ids, context)
        if not ids:
            return True
        obj_itens = self.pool.get('estoque.movimento.itens')
        for nf_id in ids:
            # apenas notas faturdas
            if self.search(cr, uid, [('id','=', nf_id), ('state', '!=', '3')], context=context):
                continue

            item_ids = obj_itens.search(cr, uid, [('nf_id', '=', nf_id)], context=context)
            dados_itens = obj_itens.read(cr, uid, item_ids, ['produto_id', 'grade_id', 'local_id',
                                                     'produto_embalagem_id', 'quantidade'], context=context,
                                         load='_classic_write')
            produto_ids = map(lambda x: x.get('produto_id'), dados_itens)
            baixa_produto_ids = self.pool.get('estoque.produto').search(cr, uid, [('id', 'in', produto_ids),
                                              ('estpro_baixar_insumos', '=', True)], context=context)
            if not baixa_produto_ids:
                continue

            obj_ficha = self.pool.get('pcp.ficha.tecnica.capa')
            ficha_ids = obj_ficha.search(cr, uid, [('pcpftc_produto_id', 'in', baixa_produto_ids)],
                                         context=context)
            dict_fichas = {}
            map(lambda x: dict_fichas.update({x.pcpftc_produto_id.id: x}),
                obj_ficha.browse(cr, uid, ficha_ids, context))
            local_id = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque',
                                                ['local_venda_padrao_id'], context=context).get('local_venda_padrao_id')
            fin_par =self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'financeiro',
                                            ['finpar_centro_custo_venda_id', 'finpar_evento_venda_id'], context=context)
            dict_itens_red = {}
            dict_vals_mov_itens = {}
            for item in dados_itens:
                brw_ficha = dict_fichas.get(item.get('produto_id'))
                if not brw_ficha:
                    continue

                fator = item.get('quantidade') / brw_ficha.pcpftc_quantidade_peso
                for insumo in brw_ficha.pcpftc_ficha_tecnica_itens_ids:
                    qtd_baixa = fator * insumo.pcpfti_quantidade
                    chave = '%s-%s-%s-%s' % (insumo.pcpfti_produto_id.id,
                                             insumo.pcpfti_grade_id.id,
                                             insumo.pcpfti_produto_embalagem_id.id,
                                             local_id)
                    if not dict_itens_red.get(chave):
                        dict_itens_red[chave] = {'produto_id': insumo.pcpfti_produto_id.id,
                                                 'grade_id': insumo.pcpfti_grade_id.id,
                                                 'local_id': local_id,
                                                 'produto_embalagem_id': insumo.pcpfti_produto_embalagem_id.id,
                                                 'evento_id': fin_par.get('finpar_evento_venda_id'),
                                                 'quantidade_requisitada': qtd_baixa}
                    else:
                        dict_itens_red[chave]['quantidade_requisitada'] += qtd_baixa

                chave = '%s-%s-%s-%s' % (item.get('produto_id'),
                                         item.get('grade_id'),
                                         item.get('produto_embalagem_id'),
                                         item.get('local_id'),)
                if not dict_vals_mov_itens.get(chave):
                    if item.get('id'):
                        del(item['id'])
                    dict_vals_mov_itens[chave] = [0,0, item.copy()]
                else:
                    dict_vals_mov_itens[chave][2]['quantidade'] += item.get('quantidade')

            if not dict_itens_red:
                continue

            obj_rh = self.pool.get('rh.funcionario')
            funcionario_id = obj_rh.search(cr, uid, [('pessoa', '=', uid)], context=context)
            if not funcionario_id:
                funcionario_id = obj_rh.create(cr, uid, {'pessoa': uid}, context=context)

            if isinstance(funcionario_id, list):
                funcionario_id = funcionario_id[0]

            nf_dados = self.read(cr, uid, nf_id, ['numero_nf', 'serie_nf'], context)
            vals_capa = {'local_id': local_id,
                         'centrocusto_id': fin_par.get('finpar_centro_custo_venda_id'),
                         'state': 'E',
                         'funcionario_id': funcionario_id,
                         'observacao': 'Referente a Nota: %s Serie: %s' % (nf_dados.get('numero_nf'),
                                                                           nf_dados.get('serie_nf'))}

            req_id = self.pool.get('almoxarifado.requisicao.capa').create(cr, uid, vals_capa, context)
            for i in dict_itens_red.values():
                i['requisicao_id'] = req_id
                self.pool.get('estoquealmoxarifado.requisicao.item').create(cr, uid, i, context)

            context_aux = context.copy()
            context_aux['active_id'] = req_id
            obj_wiz = self.pool.get('wizard.almoxarifado.entrega')
            wiz_id = obj_wiz.create(cr, uid, {'recebeu_id': funcionario_id}, context_aux)
            obj_wiz.button_wizard_entregar(cr, uid, [wiz_id], context_aux)
            obj_mov_capa = self.pool.get('estoque.movimento.capa')
            vals_mov_capa = {'funcionario_id': funcionario_id,
                             'movimento_itens_ids': dict_vals_mov_itens.values(),
                             'state': 'E',
                             'data': datetime.now().date()}
            context_aux = context.copy()
            context_aux['entrada_producao'] = True
            mov_capa_id = obj_mov_capa.create(cr, uid, vals_mov_capa, context=context_aux)
            obj_mov_capa.estmvc_button_efetivado(cr, uid, mov_capa_id, context=context)

        return True
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
