# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields
from funcoes import _get_pcpfte_get_custo


class pcp_ficha_tecnica_embalagem_data(osv.Model):
    """
    Embalagens da ficha tecnica.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    from funcoes import _pcpfte_fields_function

    _name = 'pcp.ficha.tecnica.embalagem'  # Prefixo: pcpfte_

    _columns = {
        # ___________________________ Many2One _______________________________
        'pcpfte_capa_id': fields.many2one('pcp.ficha.tecnica.capa', 'Ficha tecnica'),
        'pcpfte_produto_id': fields.many2one('estoque.produto', 'Descricao', ondelete='restrict',
                                             required=True),
        'pcpfte_grade_id': fields.many2one('estoque.produto.grade', 'Grade', ondelete='restrict',
                                           required=True,
                                           domain="[('produto_id', '=', pcpfte_produto_id)]"),

        # ___________________________ Float __________________________________
        'pcpfte_quantidade': fields.float('Quantidade', digits=(12, 3), required=True,
                                          help='Quantidade de embalagem necessaria para o '
                                               'rendimento informado na receita'),

        # ___________________________ Function _______________________________
        'name': fields.function(_pcpfte_fields_function, method=True, size=60, string='Embalagem'),
        'pcpfte_custo_total': fields.function(_get_pcpfte_get_custo, method=True, string='Custo',
                                              type="float", digits=(15, 3), store=False),
        # ___________________________ Boolean  -------------------------------
        'pcpfte_considerar_padrao': fields.boolean('Padrao',
                                                   help='Se marcada, considera a embalagem a ser '
                                                        'usada na receita como padrao'),
    }

    _defaults = {
        'pcpfte_considerar_padrao': lambda *a: True,
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
