# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class pcp_ficha_tecnica_etapas(osv.Model):
    """
    Cadastro de etapas da producao
    """
    _name = 'pcp.ficha.tecnica.etapas'
    _columns = {
        'name': fields.char('Descricao', size=45, required=True), # Descricao da fase
        'pcpfte_tempo': fields.float('Tempo', digits=(2, 2), help="Tempo necessario para execucao nesta etapa"),
        'pcpfte_observacao': fields.text('Informacoes complementares'), # Informacoes complementares
        'pcpfte_capa_id': fields.many2one("pcp.ficha.tecnica.capa", 'Ficha tecnica', ondelete="cascade", required=True,
                                          select=True),
        'pcpfte_etapas_pai_id': fields.many2one("pcp.ficha.tecnica.etapas", 'Etapa anterior', ondelete="restrict",
                                                select=True),
        'pcpfte_ficha_tecnica_itens_ids': fields.one2many('pcp.ficha.tecnica.itens', 'pcpfti_etapas_id',
                                                          'Itens da ficha tecnica:previo'),
    }
