# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class pcp_ficha_tecnica_itens(osv.Model):
    from funcoes import _get_pcpfti_custo_total

    _name = 'pcp.ficha.tecnica.itens'

    _columns = {
        'pcpfti_capa_id': fields.many2one("pcp.ficha.tecnica.capa", 'Ficha Tecnica', ondelete="cascade", required=True,
                                          select=True), # id da capa da ficha tecnica
        'pcpfti_etapas_id': fields.many2one("pcp.ficha.tecnica.etapas", 'Etapa', ondelete="restrict", select=True),
        'pcpfti_produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="restrict", required=True,
                                             select=True),
        'pcpfti_grade_id': fields.many2one("estoque.produto.grade", 'Grade', ondelete="restrict",
                                           domain="[('produto_id', '=', pcpfti_produto_id)]", required=True,
                                           select=True),
        'pcpfti_produto_embalagem_id': fields.many2one("estoque.produto.embalagem", 'Embalagem', ondelete="restrict",
                                                       domain="[('produto_id','=',pcpfti_produto_id)]", required=True,
                                                       select=True),
        'pcpfti_quantidade': fields.float('Quantidade', digits=(12, 3), required=True,
                                          help="Quantidade necessaria para a producao"),
        'pcpfti_custo_total': fields.function(_get_pcpfti_custo_total, method=True, string='Custo', type="float",
                                              digits=(15, 3), store=False),
    }

