# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields
from funcoes import _pcpope_get_custo_total


class pcp_ordem_producao_embalagem(osv.Model):
    """
    Embalagens utilizadas pela ordem de producao.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    from funcoes import pcpope_validar_quantidade

    _name = 'pcp.ordem.producao.embalagem'  # Prefixo: pcpope_

    _columns = {
        # ___________________________ Many2One _______________________________
        'pcpope_ordem_producao_id': fields.many2one('pcp.ordem.producao', 'Ordem de producao'),

        'pcpope_produto_id': fields.many2one('estoque.produto', 'Descricao',
                                             required=True),
        'pcpope_grade_id': fields.many2one('estoque.produto.grade', 'Grade', ondelete='restrict',
                                           required=True),
        # ___________________________ Float __________________________________
        'pcpope_quantidade': fields.float('Quantidade', required=True, digits=(12, 3)),

        # ___________________________ Function _______________________________
        'pcpope_custo_total': fields.function(_pcpope_get_custo_total, method=True, string='Custo',
                                              type="float", digits=(15, 3), store=False),
    }

    _constraints = [(pcpope_validar_quantidade,
                     'A quantidade de embalagens deve ser especificada.', ['Quantidade'])]

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
