# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class pcp_conversao_itens(osv.Model):
    # prefixo: pcpcvi_
    _name = 'pcp.conversao.itens'
    _rec_name = 'pcpcvi_produto_id'
    _columns = {
        'pcpcvi_capa_id': fields.many2one('pcp.conversao.capa', 'Capa', select=True,
                                          ondelete='restrict'),
        'pcpcvi_produto_id': fields.many2one('estoque.produto', 'Materia prima/insumo(origem)', select=True,
                                             ondelete='restrict'),
        'pcpcvi_grade_id': fields.many2one('estoque.produto.grade', 'Grade', select=True,
                                           ondelete='restrict',
                                           domain="[('produto_id', '=', pcpcvi_produto_id)]"),
        'pcpcvi_fator_conversao': fields.float('Fator de conversao', digits=(5, 3), required=True),
    }
    _constraints = [(lambda s, c, u, i: s.browse(c, u, i)[0].pcpcvi_fator_conversao > 0,
                    _('o valor informado deve ser maior que zero.'),
                     [_('Fator de conversao')])]
