# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _
from funcoes import _get_name_produto, _get_categoria_produto, _pljprd_get_unidade_peso


class pcp_planejamento_producao(osv.Model):

    # prefixo: pljprd_

    _name = 'pcp.planejamento.producao'

    _columns = {
        'name': fields.function(_get_name_produto, method=True, string='Descricao', type='char',
                                store=False),
        'pljprd_ficha_tecnica_id': fields.many2one('pcp.ficha.tecnica.capa', 'Ficha tecnica',
                                                   required=True),
        'pljprd_ordem_producao_id': fields.many2one('pcp.ordem.producao', 'Ordem de producao'),
        'pljprd_data': fields.date('Data', required=True),
        'pljprd_quantidade': fields.float('Quantidade', digits=(12, 3), required=True),
        'pljprd_excluir_do_planejamento_automatico': fields.boolean(
            'Excluir do planejamento de producao automatico'),
        'pljprd_categoria': fields.function(_get_categoria_produto, method=True,
                                            string='Categoria', type='char', store=True),
        # Usado na wizard wiz_pcp_planejamento_producao_automatico
        'pljprd_qtd_unidade': fields.function(_pljprd_get_unidade_peso, method=True,
                                              string='Unidade', type='float', digits=(12, 3),
                                              store=False, multi='unidade_peso'),
        'pljprd_qtd_peso': fields.function(_pljprd_get_unidade_peso, method=True,
                                           string='Peso(kg)', type='float', digits=(12, 3),
                                           store=False, multi='unidade_peso'),
    }

    _defaults = {
        'pljprd_excluir_do_planejamento_automatico': lambda* a: False,
    }

    _order = 'pljprd_data ASC'
