# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _

class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf

class report_custom(report_int):
    def create(self, cr, uid, ids, data, context=None):
        def center_title(e, c, d, t=159):
            title_c = (t - len(c)) / 2
            title = e
            for i in range(title_c - len(e)):
                title += ' '
            title += c
            for i in range(title_c - len(d)):
                title += ' '
            if (t - len(c))%2 > 0:
                d = ' '+ d
            title += d
            return title

        context = context and context.copy() or {}
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Balanco de producao'))
        listagem.informaTamLinha(160)

        obj_estoque_preco_venda = pooler.get_pool(cr.dbname).get('estoque.preco.venda')

        data_inicial = data.get('data_inicial') or ''
        data_final = data.get('data_final') or ''
        categoria_ids = data.get('categoria_ids')
        produto_ids = data.get('produto_ids')
        origem_ids = data.get('pcpwizbap_origem_ids')

        where_clauses = []
        if data_inicial:
            where_clauses.append("data >= '%s'" % data_inicial)
        if data_final:
            where_clauses.append("data <= '%s'" % data_final)

        if produto_ids:
            if len(produto_ids) == 1:
                where_clauses.append("produto_id = %d" % produto_ids[0])
            else:
                where_clauses.append("produto_id in %s" % str(tuple(produto_ids)))

        if categoria_ids:
            if len(categoria_ids) == 1:
                where_clauses.append("categoria_id = %d" % categoria_ids[0])
            else:
                where_clauses.append("categoria_id in %s" % str(tuple(categoria_ids)))

        if origem_ids:
            query_origem = "AND emo.id IN {origem_ids}".\
                format(origem_ids=str(origem_ids).replace('[', '(').replace(']', ')'))
        else:
            query_origem = ""
        str_where = ("where %s" % " and ".join(where_clauses)) if where_clauses else ""
        str_order = "produto" if data.get('ordem') == "P" else "categoria, produto"

        sql = """
select
     categoria_id
    ,categoria
    ,produto_id
    ,produto
    ,produto_codigo
    ,unidade
    ,sum(producao) as producao
    ,sum(perda) as perda
    ,sum(venda) as venda
from (
    select
         ec.id as categoria_id
        ,ec.name as categoria
        ,ep.id as produto_id
        ,ep.name as produto
        ,ep.codigo as produto_codigo
        ,eeu.unidade
        ,emi.quantidade as producao
        ,0.0 as perda
        ,0.0 as venda
        ,emc.data
    from pcp_ordem_producao pop
    inner join estoque_movimento_capa emc on emc.estmvc_ordem_producao_id = pop.id
    inner join estoque_movimento_itens emi on emi.capa_id = emc.id
    left join fiscal_nf_capa fnc ON fnc.id = emi.nf_id
    inner join estoque_produto ep on ep.id = emi.produto_id
    inner join estoque_categoria ec on ec.id = ep.categoria_id
    inner join estoque_produto_embalagem epe on epe.id = emi.produto_embalagem_id
    inner join estoque_embalagem ee on ee.id = epe.embalagem_id
    inner join estoque_embalagem_unidade eeu on eeu.id = ee.unidade_id
    where pop.state = 'F'
          and case 
                  when emi.nf_id is not null then fnc.state = '3' 
                  else true
              end

    union all

    select
         ec.id as categoria_id
        ,ec.name as categoria
        ,ep.id as produto_id
        ,ep.name as produto
        ,ep.codigo as produto_codigo
        ,eeu.unidade
        ,emi.quantidade as producao
        ,0.0 as perda
        ,0.0 as venda
        ,emc.data
    from pcp_ordem_producao pop
    inner join pcp_ficha_tecnica_capa ftc on ftc.id = pop.pcpopr_ficha_tecnica_capa_id
    inner join estoque_produto ep on ep.id = ftc.pcpftc_produto_id
    inner join estoque_movimento_itens emi on emi.produto_id = ep.id
    left join fiscal_nf_capa fnc ON fnc.id = emi.nf_id
    inner join estoque_movimento_capa emc on emc.id = emi.capa_id and emc.nf_capa_id = pop.pcpopr_nf_entrada_id
    inner join estoque_categoria ec on ec.id = ep.categoria_id
    inner join estoque_produto_embalagem epe on epe.id = emi.produto_embalagem_id
    inner join estoque_embalagem ee on ee.id = epe.embalagem_id
    inner join estoque_embalagem_unidade eeu on eeu.id = ee.unidade_id
    where pop.state = 'N'
          and case 
                  when emi.nf_id is not null then fnc.state = '3' 
                  else true
              end

    union all

    select
         ec.id as categoria_id
        ,ec.name as categoria
        ,ep.id as produto_id
        ,ep.name as produto
        ,ep.codigo as produto_codigo
        ,eeu.unidade
        ,0.0 as producao
        ,emi.quantidade as perda
        ,0.0 as venda
        ,emc.data
    from estoque_movimento_capa emc
    inner join estoque_movimento_itens emi on emi.capa_id = emc.id
    left join fiscal_nf_capa fnc ON fnc.id = emi.nf_id
    inner join estoque_produto ep on ep.id = emi.produto_id
    inner join estoque_categoria ec on ec.id = ep.categoria_id
    inner join estoque_produto_embalagem epe on epe.id = emi.produto_embalagem_id
    inner join estoque_embalagem ee on ee.id = epe.embalagem_id
    inner join estoque_embalagem_unidade eeu on eeu.id = ee.unidade_id
    inner join estoque_natureza_operacao eno on eno.id = emc.estmvc_operacao_id
    inner join estoque_movimento_origem emo on emo.id = eno.estnto_movimento_origem_id
    where emc.state = 'F'
          and emo.estmog_codigo = 'E'
          and case 
                  when emi.nf_id is not null then fnc.state = '3' 
                  else true
              end
          {query_origem}
    union all

    select
         ec.id as categoria_id
        ,ec.name as categoria
        ,ep.id as produto_id
        ,ep.name as produto
        ,ep.codigo as produto_codigo
        ,eeu.unidade
        ,0.0 as producao
        ,0.0 as perda
        ,emi.quantidade as venda
        ,emc.data
    from estoque_movimento_capa emc
    inner join estoque_movimento_itens emi on emi.capa_id = emc.id
    inner join fiscal_nf_capa fnc ON fnc.id = emi.nf_id
    inner join estoque_produto ep on ep.id = emi.produto_id
    inner join estoque_categoria ec on ec.id = ep.categoria_id
    inner join estoque_produto_embalagem epe on epe.id = emi.produto_embalagem_id
    inner join estoque_embalagem ee on ee.id = epe.embalagem_id
    inner join estoque_embalagem_unidade eeu on eeu.id = ee.unidade_id
    inner join estoque_natureza_operacao eno on eno.id = emc.estmvc_operacao_id
    inner join estoque_movimento_origem emo on emo.id = eno.estnto_movimento_origem_id
    where fnc.state = '3'
          {query_origem}
    and estnto_tipo_operacao = 'S' and estnto_atualizar_saldo
    and exists (select 1 from pcp_ficha_tecnica_capa where pcpftc_produto_id = ep.id)
) balanco_producao
{str_where}
group by
     categoria_id
    ,categoria
    ,produto_id
    ,produto
    ,produto_codigo
    ,unidade
order by {str_order}
""".format(str_where=str_where, str_order=str_order, query_origem=query_origem)
        cr.execute(sql)
        dados = cr.dictfetchall()

        produto_ids = list(set(map(lambda i: i.get('produto_id'), dados)))
        dict_preco_venda = obj_estoque_preco_venda.get_preco_venda(
            cr, uid, epc_produto_ids=produto_ids, context=context)
        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'pcp.wizard.relatorio.balanco.producao', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        title = center_title('|', _('%s') % nome_empresa, '|')
        data = time.strftime("%d/%m/%Y")
        title1 = center_title('|', _('Balanco de Producao'), data+'|')
        periodo = 'Periodo:      %s   a   %s' % (data_inicial, data_final)
        docs = center_title('|', periodo, _('       Pagina: {{ Page }} '), 167)+ '|'

        listagem.informaCab('*-------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(title)
        listagem.informaCab('|                                                                                                                                                             |')
        listagem.informaCab(title1)
        listagem.informaCab('|                                                                                                                                                             |')
        listagem.informaCab(docs)
        listagem.informaCab(  '|                                                                                                                                                             |')
        listagem.informaCab(  '*-------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(_('|        PRODUTOS                                     |  UN  |     PRECO     |      PRODUCAO      |      VENDAS      |      PERDAS      |      RESULTADO      |'))
        listagem.informaCab(  '*-------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(  '|                                                     |      |               |                    |                  |                  |                     |')
        listagem.rodapePadrao()
        list_categoria = []
        total_categoria_producao = 0
        total_categoria_venda = 0
        total_categoria_perda = 0
        total_categoria_resultado = 0
        total_geral_producao = 0
        total_geral_venda = 0
        total_geral_perda = 0
        total_geral_resultado = 0
        flag_total = False
        for x in dados:
            codigo = x.get('produto_codigo')
            produto_id = x.get('produto_id')
            dados_preco_venda = dict_preco_venda.get(produto_id) or {}
            preco_venda = dados_preco_venda.get('preco_venda')
            producao = x.get('producao') or 0
            venda = x.get('venda') or 0
            perda = x.get('perda') or 0
            resultado = producao - venda - perda
            categoria = x.get('categoria')
            if categoria not in list_categoria:
                list_categoria.append(categoria)
                if dados.index(x) != 0:
                    flag_total=True
                    linha = formataString('TOTAL', 53, ' ', 'D', 'N', 'S')+'|      |               |'
                    linha += ' '
                    linha += formataString(getNumeroEditado(total_categoria_producao, 3), 19, ' ', 'E', 'N', 'S')+'|'
                    linha += ' '
                    linha += formataString(getNumeroEditado(total_categoria_venda, 3), 17, ' ', 'E', 'N', 'S')+'|'
                    linha += ' '
                    linha += formataString(getNumeroEditado(total_categoria_perda, 3), 17, ' ', 'E', 'N', 'S')+'|'
                    linha += ' '
                    linha += formataString(getNumeroEditado(total_categoria_resultado, 3), 20, ' ', 'E', 'N', 'S')+'|'
                    linha += ' '
                    listagem.imprimeLinha('|'+linha)
                    total_categoria_producao = 0
                    total_categoria_venda = 0
                    total_categoria_perda = 0
                    total_categoria_resultado = 0
                if flag_total:
                    flag_total=False
                    listagem.imprimeLinha('*-------------------------------------------------------------------------------------------------------------------------------------------------------------*')
                categoria = formataString(categoria, 53, ' ', 'D', 'N', 'S')+'|      |               |                    |                  |                  |                     |'
                linha = categoria
                listagem.imprimeLinha('|'+linha)

            linha = formataString(codigo, 7, ' ', 'D', 'N', 'S')+''
            linha += ' '
            linha += formataString(x.get('produto'), 45, ' ', 'D', 'N', 'S')+'|'
            linha += ' '
            linha += formataString(x.get('unidade'), 5, ' ', 'D', 'N', 'S')+'|'
            linha += ' '
            linha += formataString(getNumeroEditado(preco_venda, 3), 14, ' ', 'E', 'N', 'S')+'|'
            linha += ' '
            linha += formataString(getNumeroEditado(producao, 3), 19, ' ', 'E', 'N', 'S')+'|'
            linha += ' '
            linha += formataString(getNumeroEditado(venda, 3), 17, ' ', 'E', 'N', 'S')+'|'
            linha += ' '
            linha += formataString(getNumeroEditado(perda, 3), 17, ' ', 'E', 'N', 'S')+'|'
            linha += ' '
            linha += formataString(getNumeroEditado(resultado, 3), 20, ' ', 'E', 'N', 'S')+'|'
            linha += ' '
            listagem.imprimeLinha('|'+linha)
            total_categoria_producao += producao
            total_categoria_venda += venda
            total_categoria_perda += perda
            total_categoria_resultado += resultado

            if dados[-1] == x:
                linha = formataString('TOTAL', 53, ' ', 'D', 'N', 'S')+'|      |               |'
                linha += ' '
                linha += formataString(getNumeroEditado(total_categoria_producao, 3), 19, ' ', 'E', 'N', 'S')+'|'
                linha += ' '
                linha += formataString(getNumeroEditado(total_categoria_venda, 3), 17, ' ', 'E', 'N', 'S')+'|'
                linha += ' '
                linha += formataString(getNumeroEditado(total_categoria_perda, 3), 17, ' ', 'E', 'N', 'S')+'|'
                linha += ' '
                linha += formataString(getNumeroEditado(total_categoria_resultado, 3), 20, ' ', 'E', 'N', 'S')+'|'
                linha += ' '
                listagem.imprimeLinha('|'+linha)
                listagem.imprimeLinha('*-------------------------------------------------------------------------------------------------------------------------------------------------------------*')
                total_categoria_producao = 0
                total_categoria_venda = 0
                total_categoria_perda = 0
                total_categoria_resultado = 0

            total_geral_producao += producao
            total_geral_venda += venda
            total_geral_perda += perda
            total_geral_resultado += resultado
        linha = formataString('TOTAL GERAL', 77, ' ', 'D', 'N', 'S')+''
        linha += ' '
        linha += formataString(getNumeroEditado(total_geral_producao, 3), 19, ' ', 'E', 'N', 'S')+'|'
        linha += ' '
        linha += formataString(getNumeroEditado(total_geral_venda, 3), 17, ' ', 'E', 'N', 'S')+'|'
        linha += ' '
        linha += formataString(getNumeroEditado(total_geral_perda, 3), 17, ' ', 'E', 'N', 'S')+'|'
        linha += ' '
        linha += formataString(getNumeroEditado(total_geral_resultado, 3), 20, ' ', 'E', 'N', 'S')+'|'
        linha += ' '
        listagem.imprimeLinha('|'+linha)
        listagem.imprimeLinha('*-------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

report_custom('report.balanco_producao')


class pcp_wizard_relatorio_balanco_producao(osv.TransientModel):

    _name = 'pcp.wizard.relatorio.balanco.producao'
    _columns = {
        'data_inicial': fields.date('Data inicial'),
        'data_final': fields.date('Data final'),
        'categoria_ids': fields.many2many('estoque.categoria', 'estoque_categoria_balanco_producao',
                                          'balanco_producao_id', 'categoria_id', 'Categoria'),
        'produto_ids': fields.many2many('estoque.produto', 'estoque_produto_balanco_producao',
                                        'balanco_producao_id', 'produto_id', 'Produto'),
        'ordem': fields.selection([('C', 'Categoria'), ('P', 'Produto')], 'Ordenar por', size=1,
                                  required=True),
        'pcpwizbap_origem_ids': fields.many2many('estoque.movimento.origem',
                                                'estoque_origem_balanco_produto',
                                                'balanco_produto_id', 'origem_id', 'Origem')
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        balanco_producao_dados = self.read(
            cr, uid, ids[0] if isinstance(ids, list) else ids, [], context=context)
        datas = {
            'data_inicial': balanco_producao_dados.get('data_inicial'),
            'data_final': balanco_producao_dados.get('data_final'),
            'categoria_ids': balanco_producao_dados.get('categoria_ids'),
            'produto_ids': balanco_producao_dados.get('produto_ids'),
            'ordem': balanco_producao_dados.get('ordem'),
            'pcpwizbap_origem_ids': balanco_producao_dados.get('pcpwizbap_origem_ids')
        }
        return {'type': 'ir.actions.report.xml',
                'report_name': 'balanco_producao',
                'datas': datas,
                }
