# -*- encoding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.numero import getNumeroEditado
from SigUtils.impressao import Impressora
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _
from dateutil.parser import parse


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):

        cons_report_length = 159

        def center_title(e, c, d, t=cons_report_length):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            if (t - len(c)) % 2 > 0:
                titulo += ' '
            titulo += d
            return titulo

        context = context and context.copy() or {}
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.informaTamLinha(cons_report_length)
        listagem.informaNome(pdf_string, _('Ficha tecnica'))
        listagem.defineMargem(0.5, 0.5, 1, 1)

        ficha_tecnica_dados = datas.get('lista_itens')

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid, context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id,
                                                                               ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        titulo = center_title(data, _('RELATORIO FICHA TECNICA'), '[pagina x]', cons_report_length).replace('[pagina x]', _('Pagina: {{ Page , 2 }}'))
        listagem.informaCab(titulo)
        listagem.informaCab(formataString(_('Empresa: ') + nome_empresa, cons_report_length, ' ', 'D', 'N', 'S'))
        listagem.informaCab(  '                                                                                                                                                               ')
        listagem.informaCab(  '*-------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(_('|                            PRODUTO                            | GRADE | CUSTO UNITARIO |  MARGEM ATUAL  |   PRECO ATUAL  | MARGEM SUGERIDA | PRECO SUGERIDO |'))
        listagem.informaCab(  '*-------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(  '|                                                               |       |                |                |                |                 |                |')
        listagem.informaRodape('*-------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        for item in ficha_tecnica_dados:
            linha = '|'
            linha += formataString(item.get('produto'), 63, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(item.get('grade'), 7, ' ', 'C', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(item.get('custo_unitario'), 3), 15, ' ', 'E', 'N', 'S') + ' '
            linha += '|'
            linha += formataString(getNumeroEditado(item.get('margem_atual'), 2), 15, ' ', 'E', 'N', 'S') + ' '
            linha += '|'
            linha += formataString(getNumeroEditado(item.get('preco_atual'), 2), 15, ' ', 'E', 'N', 'S') + ' '
            linha += '|'
            linha += formataString(getNumeroEditado(item.get('margem_sugerida'), 2), 16, ' ', 'E', 'N', 'S') + ' '
            linha += '|'
            linha += formataString(getNumeroEditado(item.get('preco_sugerido'), 2), 15, ' ', 'E', 'N', 'S') + ' '
            linha += '|'
            listagem.imprimeLinha(linha)
        listagem.imprimeLinha(  '*-------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.imprimeLinha(_('                                                                   ** Sig Informatica LTDA **                                                                  '))
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

report_custom('report.listagem_ficha_tecnica')
