# -*- encoding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.numero import getNumeroEditado
from SigUtils.impressao import Impressora
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        def center_title(e, c, d, t=160):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        title = center_title('', _('Material Faltante'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('material_faltante'))
        listagem.informaTamLinha(160)

        listar_material_id = datas.get('id')
        wiz_pcp_listar_material_dados = pooler.get_pool(cr.dbname).get('wiz.pcp.listar.material').\
            read(cr, uid, listar_material_id, [], context)
        if isinstance(wiz_pcp_listar_material_dados, list):
            wiz_pcp_listar_material_dados = wiz_pcp_listar_material_dados[0]
        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid, context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id,
                                                                               ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
        data_inicial = wiz_pcp_listar_material_dados.get('wizplm_data_inicial')
        data_inicial = time.strftime('%d/%m/%Y', time.strptime(data_inicial, '%Y-%m-%d'))
        data_final = wiz_pcp_listar_material_dados.get('wizplm_data_final') or ''
        if data_final:
            data_final = time.strftime('%d/%m/%Y', time.strptime(data_final, '%Y-%m-%d'))
        docs1 = center_title('Periodo: %s a %s' % (data_inicial, data_final), '', '')
        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab('' + docs1)
        listagem.informaCab('')
        listagem.informaCab('*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(_('|PRODUTO                                      |GRADE                        |EMBALAGEM              |QTD. EXISTENTE            |QTD.FALTANTE         |'))
        listagem.informaCab('*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab('')
        listagem.rodapePadrao()
        wiz_pcp_listar_material_item_dados = pooler.get_pool(cr.dbname).\
            get('wiz.pcp.listar.material.item').read(cr, uid, wiz_pcp_listar_material_dados.
                                                     get('wizplm_item_ids'), [], context=context)
        for item in wiz_pcp_listar_material_item_dados:
            produto_embalagem = item.get('wizlmi_produto_embalagem_id') or ''
            if produto_embalagem and isinstance(produto_embalagem, tuple):
                produto_embalagem = produto_embalagem[1]
            linha = formataString(item.get('wizlmi_produto_id')[1] or '', 45, ' ', 'D', 'N', 'S') + '|'
            linha += ''
            linha += formataString(item.get('wizlmi_grade_id')[1] or '', 29, ' ', 'D', 'N', 'S') + '|'
            linha += ''
            linha += formataString(produto_embalagem, 23, ' ', 'D', 'N', 'S') + '|'
            linha += ''
            linha += formataString(getNumeroEditado(item.get('wizlmi_qtd_existente') or 0.0, 2), 26, ' ', 'E', 'N', 'S') + '|'
            linha += ''
            linha += formataString(getNumeroEditado(item.get('wizlmi_qtd_faltante') or 0.0, 2), 21, ' ', 'E', 'N', 'S') + '|'
            linha += ''
            listagem.imprimeLinha('|' + linha)
        listagem.imprimeLinha('*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.imprimeLinha(_('                                                                                                ** Sig Informatica LTDA **                          '))
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_material_faltante')
