# -*- encoding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.numero import getNumeroEditado
from SigUtils.impressao import Impressora
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _
from dateutil.parser import parse


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        def center_title(e, c, d, t=92):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'pcp.wizard.relatorio.balanco.producao', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        title1 = center_title('|', _('%s') % nome_empresa+'  ', '|',113)
        data = time.strftime("%d/%m/%Y")
        title2 = center_title('|', _('LISTAGEM ORDENS DE PRODUCAO  '), data +' |', 113)
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('ordem_de_producao'))
        listagem.informaTamLinha(100)
        listagem.defineMargem(1,1,1,1)

        obj_pcp_ordem_producao = pooler.get_pool(cr.dbname).get('pcp.ordem.producao')
        obj_pcp_ficha_tecnica_capa = pooler.get_pool(cr.dbname).get('pcp.ficha.tecnica.capa')

        situacao = datas.get('situacao')
        dia = datas.get('dia')
        categoria_id = datas.get('categoria_id')
        args = []
        if categoria_id:
            produto_ids = pooler.get_pool(cr.dbname).get('estoque.produto').search(
                cr, uid, [('categoria_id', '=', categoria_id)], context=context)
            if produto_ids:
                ficha_tecnica_ids = obj_pcp_ficha_tecnica_capa.search(
                    cr, uid, [('pcpftc_produto_id', 'in', produto_ids)], context=context)
                if ficha_tecnica_ids:
                    args.append(('pcpopr_ficha_tecnica_capa_id', 'in', ficha_tecnica_ids))
                else:
                    args.append(('pcpopr_ficha_tecnica_capa_id', '=', False))
        if situacao:
            args.append(('state', '=', situacao))
        else:
            args.append(('state', 'not in', ('E', 'N')))
        ordem_producao_ids = obj_pcp_ordem_producao.search(cr, uid, args, context=context)
        brw_ordem_producao = obj_pcp_ordem_producao.browse(cr, uid, ordem_producao_ids, context)
        brw_ordem_producao = filter(lambda i: parse(i.pcpopr_inicio).date().weekday() == int(dia),
                                    brw_ordem_producao)
        categoria_ids = list(
            set(map(lambda i: i.pcpopr_ficha_tecnica_capa_id.pcpftc_produto_id.categoria_id.id,
                    brw_ordem_producao)))
        categoria_ids = filter(lambda i: i > 0, categoria_ids)
        estoque_categoria_dados = pooler.get_pool(cr.dbname).get('estoque.categoria').browse(
            cr, uid, categoria_ids)
        dia_semana = self._get_nome_dia_semana(cr, uid, dia, context).upper()
        dia_semana = formataString(dia_semana,13,' ', 'D', 'N', 'S')
        listagem.informaCab(  '--')
        listagem.informaCab(title1)
        listagem.informaCab(  '|                                                                                                               |')
        listagem.informaCab(  '|                                                                                                               |')
        listagem.informaCab(title2)
        listagem.informaCab(  '|                                                                                                               |')
        listagem.informaCab(_('| %s   Data: ____ / ____ / ____                                                                      |' % dia_semana))
        listagem.informaCab(  '--')
        listagem.informaCab(_('|          PRODUTO                                                                         | Quantidade Pedida  |'))
        listagem.informaCab(  '*---------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(  '|                                                                                          |                    |')
        listagem.rodapePadrao()
        def get_name_categoria(bwr_cat):  # pega o nome das categorias pais + o proprio nome, se tiver
            nome = ''
            if bwr_cat.parent_id:
                 nome = str(get_name_categoria(bwr_cat.parent_id)) + '/'
            nome += bwr_cat.name
            return nome
        for x in estoque_categoria_dados:
            total_categoria = 0.0
            categoria_id = x.id
            categoria_name = get_name_categoria(x)
            brw_ordem_producao_categoria = filter(
                lambda i: i.pcpopr_ficha_tecnica_capa_id.pcpftc_produto_id.categoria_id.id ==
                categoria_id, brw_ordem_producao)
            for y in brw_ordem_producao_categoria:
                produto = y.pcpopr_ficha_tecnica_capa_id.pcpftc_produto_id.name
                if brw_ordem_producao_categoria.index(y) == 0:
                    if len(categoria_name.upper()) < 60:
                        linha = 'Categoria:                    ' + formataString(categoria_name.upper(), 60, ' ', 'D', 'N', 'S') + '|                    |'
                    elif len(categoria_name.upper()) < 120:
                        categoria = categoria_name.upper()[0:60]
                        linha = 'Categoria:                    ' + formataString(categoria, 60, ' ', 'D', 'N', 'S') + '|                    |'
                        listagem.imprimeLinha('|' + linha)
                        categoria = categoria_name.upper()[60:]
                        linha = '                              ' + formataString(categoria, 60, ' ', 'D', 'N', 'S') + '|                    |'
                    elif len(categoria_name.upper()) < 180:
                        categoria = categoria_name.upper()[0:60]
                        linha = 'Categoria:                    ' +formataString(categoria, 60, ' ', 'D', 'N', 'S') + '|                    |'
                        listagem.imprimeLinha('|' + linha)
                        categoria = categoria_name.upper()[60:120]
                        linha = '                              ' + formataString(categoria, 60, ' ', 'D', 'N', 'S') + '|                    |'
                        listagem.imprimeLinha('|' + linha)
                        categoria = categoria_name.upper()[120:]
                        linha = '                              ' + formataString(categoria, 60, ' ', 'D', 'N', 'S') + '|                    |'
                    listagem.imprimeLinha('|' + linha)
                linha = formataString(produto, 90, ' ', 'D', 'N', 'S') + '|'
                linha += ''
                total_categoria += y.pcpopr_quantidade_a_produzir
                linha += formataString(getNumeroEditado(y.pcpopr_quantidade_a_produzir or 0, 3), 20, ' ', 'E', 'N', 'S') + '|'
                linha += ''
                listagem.imprimeLinha('|' + linha)
            linha = '|                                                                           Total Categoria|'
            linha += formataString(getNumeroEditado(total_categoria or 0, 3), 20, ' ', 'E', 'N', 'S') + '|'
            listagem.imprimeLinha(linha)
            listagem.imprimeLinha(  '*---------------------------------------------------------------------------------------------------------------*')
        listagem.imprimeLinha(_('                                                                         ** Sig Informatica LTDA **                  '))
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

    def _get_nome_dia_semana(self, cr, uid, dia_semana, context=None):
        context = context and context.copy() or {}
        dia = ''
        if not dia_semana:
            return dia
        if dia_semana == '0':
            dia = 'Segunda-feira'
        elif dia_semana == '1':
            dia = 'Terca-feira  '
        elif dia_semana == '2':
            dia = 'Quarta-feira '
        elif dia_semana == '3':
            dia = 'Quinta-feira '
        elif dia_semana == '4':
            dia = 'Sexta-feira  '
        elif dia_semana == '5':
            dia = 'Sabado       '
        elif dia_semana == '6':
            dia = 'Domingo      '
        return dia


report_custom('report.listagem_ordem_producao')
