# -*- encoding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.numero import getNumeroEditado
from SigUtils.impressao import Impressora
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        def center_title(e, c, d, t=160):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        title = center_title('', _('Planejamento de Producao'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('planejamento_de_producao'))
        listagem.informaTamLinha(160)

        listagem_planejamento_producao_id = datas.get('id')
        wiz_listagem_planejamento_producao_dados = pooler.get_pool(cr.dbname).get(
            'wiz.listagem.planejamento.producao').read(cr, uid, listagem_planejamento_producao_id,
                                                       [], context=context)
        if isinstance(wiz_listagem_planejamento_producao_dados, list):
            wiz_listagem_planejamento_producao_dados = wiz_listagem_planejamento_producao_dados[0]
        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'pcp.planejamento.producao', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id,
                                                                               ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
        data_inicial = wiz_listagem_planejamento_producao_dados.get('wizlpp_data_inicio') or ''
        if data_inicial:
            data_inicial = time.strftime('%d/%m/%Y', time.strptime(data_inicial, '%Y-%m-%d'))
        data_final = wiz_listagem_planejamento_producao_dados.get('wizlpp_data_fim') or ''
        if data_final:
            data_final = time.strftime('%d/%m/%Y', time.strptime(data_final, '%Y-%m-%d'))
        dia_selecionado = ''
        if wiz_listagem_planejamento_producao_dados.get('wizlpp_segunda'):
            dia_selecionado += 'Segunda'
        if wiz_listagem_planejamento_producao_dados.get('wizlpp_terca'):
            if dia_selecionado:
                dia_selecionado += ', Terca'
            else:
                dia_selecionado += 'Terca'
        if wiz_listagem_planejamento_producao_dados.get('wizlpp_quarta'):
            if dia_selecionado:
                dia_selecionado += ', Quarta'
            else:
                dia_selecionado += 'Quarta'
        if wiz_listagem_planejamento_producao_dados.get('wizlpp_quinta'):
            if dia_selecionado:
                dia_selecionado += ', Quinta'
            else:
                dia_selecionado += 'Quinta'
        if wiz_listagem_planejamento_producao_dados.get('wizlpp_sexta'):
            if dia_selecionado:
                dia_selecionado += ', Sexta'
            else:
                dia_selecionado += 'Sexta'
        if wiz_listagem_planejamento_producao_dados.get('wizlpp_sabado'):
            if dia_selecionado:
                dia_selecionado += ', Sabado'
            else:
                dia_selecionado += 'Sabado'
        if wiz_listagem_planejamento_producao_dados.get('wizlpp_domingo'):
            if dia_selecionado:
                dia_selecionado += ', Domingo'
            else:
                dia_selecionado += 'Domingo'
        docs1 = center_title('Periodo: %s a %s' % (data_inicial, data_final), '', '')
        ficha_tecnica = ''
        if wiz_listagem_planejamento_producao_dados.get('wizlpp_ficha_tecnica_id'):
            ficha_tecnica = wiz_listagem_planejamento_producao_dados.get(
                'wizlpp_ficha_tecnica_id')[1]
        docs2 = center_title('Ficha tecnica: %s' % ficha_tecnica, '', '')
        docs3 = center_title('Dias selecionados: %s' % dia_selecionado, '', '')
        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab('' + docs1)
        listagem.informaCab('' + docs2)
        listagem.informaCab('' + docs3)
        listagem.informaCab('')
        listagem.informaCab('*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(_('|DIA                       |DATA                           |FICHA TECNICA                                                       |          QUANTIDADE|'))
        listagem.informaCab('*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab('')
        listagem.rodapePadrao()
        wiz_listagem_planejamento_producao_item_dados = pooler.get_pool(cr.dbname).\
            get('wiz.listagem.planejamento.producao.item').read(
                cr, uid, wiz_listagem_planejamento_producao_dados.
                get('wizlpp_planejamento_producao_item_ids'), [], context=context)
        for item in wiz_listagem_planejamento_producao_item_dados:
            data = item.get('wizlpi_data') or ''
            if data:
                data = time.strftime('%d/%m/%Y', time.strptime(data, '%Y-%m-%d'))
            linha = formataString(self._get_nome_dia_semana(cr, uid, item.get('wizlpi_dia_semana'), context=context), 26, ' ', 'D', 'N', 'S') + '|'
            linha += ''
            linha += formataString(data, 31, ' ', 'D', 'N', 'S') + '|'
            linha += ''
            linha += formataString(item.get('wizlpi_ficha_tecnica_id')[1] or '', 68, ' ', 'D', 'N', 'S') + '|'
            linha += ''
            linha += formataString(item.get('wizlpi_quantidade'), 20, ' ', 'E', 'N', 'S') + '|'
            linha += ''
            listagem.imprimeLinha('|' + linha)
        listagem.imprimeLinha('*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.imprimeLinha(_('                                                                                                ** Sig Informatica LTDA **                          '))
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

    def _get_nome_dia_semana(self, cr, uid, dia_semana, context=None):
        context = context and context.copy() or {}
        dia = ''
        if not dia_semana:
            return dia
        if dia_semana == 1:
            dia = 'Segunda-feira'
        elif dia_semana == 2:
            dia = 'Terca-feira'
        elif dia_semana == 3:
            dia = 'Quarta-feira'
        elif dia_semana == 4:
            dia = 'Quinta-feira'
        elif dia_semana == 5:
            dia = 'Sexta-feira'
        elif dia_semana == 6:
            dia = 'Sabado'
        else:
            dia = 'Domingo'
        return dia


report_custom('report.listagem_planejamento_producao')
