# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from datetime import datetime
from pytz import timezone
from openerp.report import report_sxw


class pcp_relatorio_ordem_producao_consulta(report_sxw.rml_parse):
    """
    Cria o modelo de relatorio de consulta de ordem de producao.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    def __init__(self, cr, uid, name, context):
        super(pcp_relatorio_ordem_producao_consulta, self).__init__(cr, uid, name, context)

        # Data de hoje
        hoje = datetime.now(timezone('UTC')).astimezone(timezone(context.get('tz', 'Brazil/East')))

        # Nome da empresa
        empresa_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, context=context)
        empresa = self.pool.get('res.company').read(cr, uid, empresa_id, ['name'], context=context)
        empresa = empresa[0].get('name') if isinstance(empresa, list) else empresa.get('name')

        self.localcontext.update({'hoje': hoje, 'empresa': empresa})
        self.context = context

report_sxw.report_sxw('report.ordem_producao_consulta', 'wizard.ordem.producao.consulta',
                      'addons/pcp/report/ordem_producao_consulta.rml',
                      parser=pcp_relatorio_ordem_producao_consulta, header=False)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
