# -*- encoding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(e, c, d, t=160):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        context = context and context.copy() or {}
        title = center_title('', _('Planejamento de Producao'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('planejamento_de_producao'))
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)
        listagem.defineFonte(tam=6.3)
        desc_dia_semana = datas.get('desc_dia_semana')
        dados = datas.get('dados')
        #listagem.informaCab('______________________________________________________________________________________________________________________________________________________')
        listagem.informaCab('------------------------------------------------------------------------------------------------------------------------------------------------------')
        listagem.informaCab(_('|                                   ORDEM DE PRODUCAO                                  |         Data: _______/_______/_______       | Pagina: {{ Page }}     |'))
        #listagem.informaCab('______________________________________________________________________________________________________________________________________________________')
        listagem.informaCab('------------------------------------------------------------------------------------------------------------------------------------------------------')
        listagem.informaCab('|                                                                       '+ desc_dia_semana.rjust(13, ' ') +'                                                                |')
        #listagem.informaCab('______________________________________________________________________________________________________________________________________________________')
        listagem.informaCab('------------------------------------------------------------------------------------------------------------------------------------------------------')
        listagem.informaCab(_('|                         PRODUTO                        |      Pedido     |   Producao Realizada   | Faltas 18h |  Sobras  |  Controle de Qualidade |'))
        #listagem.informaCab('______________________________________________________________________________________________________________________________________________________')
        listagem.informaCab('------------------------------------------------------------------------------------------------------------------------------------------------------')
        listagem.informaCab('')
        listagem.rodapePadrao()
        dados = sorted(dados, key=lambda i: i.get('categoria_pai_id') and i.get('categoria_id'))
        list_categoria_pai = []
        list_categoria = []
        for x in dados:
            categoria_pai_id = x.get('categoria_pai_id') or False
            categoria_pai = x.get('categoria_pai_name') or ''
            categoria_id = x.get('categoria_id') or False
            categoria = x.get('categoria_name') or ''
            produto = x.get('produto_name') or ''
            if categoria_pai and not categoria_pai_id in list_categoria_pai:
                list_categoria_pai.append(categoria_pai_id)
                listagem.imprimeLinha(_('|                                                                     '+ categoria_pai.ljust(30, ' ') +'                                                 |'))
                #listagem.imprimeLinha('______________________________________________________________________________________________________________________________________________________')
                listagem.imprimeLinha('------------------------------------------------------------------------------------------------------------------------------------------------------')
            if categoria and not categoria_id in list_categoria:
                list_categoria.append(categoria_id)
                linha = formataString(categoria, 56, ' ', 'C', 'N', 'S') + '|'
                linha += ''
                linha += formataString('', 17, ' ', 'D', 'N', 'S') + '|'
                linha += ''
                linha += formataString('', 24, ' ', 'D', 'N', 'S') + '|'
                linha += ''
                linha += formataString('', 12, ' ', 'D', 'N', 'S') + '|'
                linha += ''
                linha += formataString('', 10, ' ', 'D', 'N', 'S') + '|'
                linha += ''
                linha += formataString('', 24, ' ', 'D', 'N', 'S') + '|'
                linha += ''
                listagem.imprimeLinha('|' + linha)
                #listagem.imprimeLinha('______________________________________________________________________________________________________________________________________________________')
                listagem.imprimeLinha('------------------------------------------------------------------------------------------------------------------------------------------------------')
            linha = formataString(produto, 56, ' ', 'D', 'N', 'S') + '|'
            linha += ''
            linha += formataString('', 17, ' ', 'D', 'N', 'S') + '|'
            linha += ''
            linha += formataString('', 24, ' ', 'D', 'N', 'S') + '|'
            linha += ''
            linha += formataString('', 12, ' ', 'D', 'N', 'S') + '|'
            linha += ''
            linha += formataString('', 10, ' ', 'D', 'N', 'S') + '|'
            linha += ''
            linha += formataString('', 24, ' ', 'D', 'N', 'S') + '|'
            linha += ''
            listagem.imprimeLinha('|' + linha)
            #listagem.imprimeLinha('______________________________________________________________________________________________________________________________________________________')
            listagem.imprimeLinha('------------------------------------------------------------------------------------------------------------------------------------------------------')
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

report_custom('report.planilha_producao')
