#!/usr/bin/python
# -*- encoding: utf-8 -*-

from datetime import datetime
from pytz import timezone
from openerp.report import report_sxw
from openerp.tools import drop_view_if_exists





class rel_comparativo(report_sxw.rml_parse):
    def __init__(self, cr, uid,name, context=None):
        context = context and context.copy() or {}
        super(rel_comparativo, self).__init__(cr, uid, name, context=context)
        # Data de hoje
        tz = context.get('tz') or 'Brazil/East'
        hoje = datetime.now(timezone('UTC')).astimezone(timezone(tz))

        # Nome da empresa
        empresa_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, context=context)
        empresa = self.pool.get('res.company').read(cr, uid, empresa_id, ['name'], context=context)
        empresa = empresa[0].get('name') if isinstance(empresa, list) else empresa.get('name')






        # Categoria
        report_id = context.get('active_id', False)
        campos = ['ficha_tecnica_ids', 'categoria_ids', 'data_inicial', 'data_final']
        dados_relatorio = self.pool.get('pcp.wizard.relatorio.comparativo').read(
            cr, uid, report_id, campos, context=context)

        obj_view_pcp_relatorio_comparativo = self.pool.get('view.pcp.relatorio.comparativo')

        args = []  # Sem argumento. Todas as fichas tecnicas de todas as categorias

        # Filtro categorias
        if dados_relatorio.get('categoria_ids'):
            args.append(('pcprcp_categoria_id', '=', dados_relatorio.get('categoria_ids')[0]))

        # Filtro de ficha tecnica
        ficha_tecnica_ids = dados_relatorio.get('ficha_tecnica_ids', [])
        if ficha_tecnica_ids:
            args.append(('pcprcp_ficha_tecnica_id', 'in', ficha_tecnica_ids))

        rel_ids = obj_view_pcp_relatorio_comparativo.search(
                cr, uid, args, context=context)

        itens_relatorio = obj_view_pcp_relatorio_comparativo.browse(
            cr, uid, rel_ids)

        quantidade_produzida_total = 0
        valor_total = 0
        quantidade_perda_total = 0
        percente_perda_total = 0
        valor_perda_total = 0
        for i in itens_relatorio:
            quantidade_produzida_total += i.pcprcp_quantidade_produzida
            valor_total += i.pcprcp_valor * i.pcprcp_quantidade_produzida
            quantidade_perda_total += i.pcprcp_quantidade_perda
            valor_perda_total += i.pcprcp_valor * i.pcprcp_quantidade_perda

        if quantidade_produzida_total != 0:
            percente_perda_total = quantidade_perda_total * 100 / quantidade_produzida_total

        if dados_relatorio and isinstance(dados_relatorio, list):
            dados_relatorio = dados_relatorio[0]

        if dados_relatorio and isinstance(dados_relatorio, dict):
            categoria = dados_relatorio.get('categoria_ids') or ('', 'Todas')
            ficha_tecnica_ids = dados_relatorio.get('ficha_tecnica_ids', [])
            data_inicial = dados_relatorio.get('data_inicial')
            data_final = dados_relatorio.get('data_final')
            self.localcontext.update({'categoria': categoria,
                                      'ficha_tecnica': ficha_tecnica_ids,
                                      'data_inicial': data_inicial,
                                      'data_final': data_final,
                                      'quantidade_produzida_total': quantidade_produzida_total,
                                      'valor_total': valor_total,
                                      'quantidade_perda_total': quantidade_perda_total,
                                      'percente_perda_total': percente_perda_total,
                                      'valor_perda_total': valor_perda_total})

        self.localcontext.update({'hoje': hoje, 'empresa': empresa})
        self.context = context

report_sxw.report_sxw('report.rel_comparativo', 'view.pcp.relatorio.comparativo',
                      'addons/pcp/report/rel_comparativo.rml',
                      parser=rel_comparativo, header=False)

