# -*- encoding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(e, c, d, t=160):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        context = context and context.copy() or {}
        title = center_title('', _('Venda Diaria'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Venda diaria'))
        listagem.informaTamLinha(160)

        consulta_venda_diaria_id = datas.get('id')
        consulta_venda_diaria_dados = pooler.get_pool(cr.dbname).\
            get('wizard.consulta.venda.diaria').read(cr, uid, consulta_venda_diaria_id, [], context=context)
        venda_diaria_item_ids = consulta_venda_diaria_dados.get('wizcvd_item_ids')
        consulta_venda_diaria_item_dados = []
        if venda_diaria_item_ids:
            consulta_venda_diaria_item_dados = pooler.get_pool(cr.dbname).\
                get('wizard.consulta.venda.diaria.item').read(cr, uid, venda_diaria_item_ids, [], context=context)
        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid, context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id,
                                                                               ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
        ficha_tecnica_id = consulta_venda_diaria_dados.get('wizcvd_ficha_tecnica_id')
        ficha_tecnica = ''
        if isinstance(ficha_tecnica_id, (list, tuple)):
            ficha_tecnica = ficha_tecnica_id[1]
        local_id = consulta_venda_diaria_dados.get('wizcvd_local_id')
        local = ''
        if isinstance(local_id, (list, tuple)):
            local = local_id[1]
        docs1 = center_title('Ficha tecnica: ' + ficha_tecnica, 'Local: ' + local, '')
        data_inicial = consulta_venda_diaria_dados.get('wizcvd_data_inicial')
        if not data_inicial:
            data_inicial = ''
        else:
            data_inicial = time.strftime('%d/%m/%Y', time.strptime(data_inicial, '%Y-%m-%d'))
        data_final = consulta_venda_diaria_dados.get('wizcvd_data_final')
        if not data_final:
            data_final = ''
        else:
            data_final = time.strftime('%d/%m/%Y', time.strptime(data_final, '%Y-%m-%d'))
        docs2 = center_title('Data inicial: ' + data_inicial, 'Data final: ' + data_final, '')
        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab('' + docs1)
        listagem.informaCab('' + docs2)
        listagem.informaCab('')
        listagem.informaCab('*----------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(_('|                   PRODUTO                      |          EMBALAGEM           |  QUANTIDADE  |     PRECO CUSTO     |    PRECO VENDA     | VALOR AGREGADO |'))
        listagem.informaCab('*----------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab('')
        listagem.rodapePadrao()
        for item in consulta_venda_diaria_item_dados:
            linha = formataString(item.get('wizcvi_produto_id')[1], 48, ' ', 'D', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(item.get('wizcvi_produto_embalagem_id')[1], 29, ' ', 'D', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(item.get('wizcvi_quantidade'), 3), 13, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(item.get('wizcvi_preco_custo'), 2), 20, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(item.get('wizcvi_preco_venda'), 5), 19, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(item.get('wizcvi_valor_agregado'), 2), 15, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            listagem.imprimeLinha('|' + linha)
        listagem.imprimeLinha('*----------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.imprimeLinha(_('                                                                                                      ** Sig Informatica LTDA **                          '))
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.venda_diaria')
