# -*- coding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _


class wizard_duplicar_ficha(osv.TransientModel):
    # prefixo: wizduf_

    _name = 'wizard.duplicar.ficha'

    def wizduf_get_produto(self, cr, uid, context=None):
        context = context and context.copy() or {}
        return context.get('pcpftc_produto_id') or ''

    _columns = {
        'wizduf_produto_id': fields.many2one('estoque.produto', 'Produto', required=True,
                                             domain="[('tipo_item','in',['03','04','05','06'])]"),
        'wizduf_grade_id': fields.many2one('estoque.produto.grade', 'Grade', required=True,
                                           domain="[('produto_id', '=', wizduf_produto_id)]"),
        'wizduf_produto_peso_embalagem_id': fields.many2one(
            'estoque.produto.embalagem', 'Embalagem (peso)', required=True, select=True,
            domain="[('produto_id', '=', wizduf_produto_id)]"),
        'wizduf_produto_unidade_embalagem_id': fields.many2one('estoque.produto.embalagem',
                                                               'Embalagem (opcional)',
                                                               domain="[('produto_id', '=', pcpftc_produto_id)]"
                                                               ),
    }

    _defaults = {
        'wizduf_produto_id': wizduf_get_produto,
    }

    def wizduf_onchange_produto_id(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return {'value': {'wizduf_grade_id': '',
                          'wizduf_produto_unidade_embalagem_id': ''}
                }

    def wizduf_button_duplicar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_pcp_capa = self.pool.get('pcp.ficha.tecnica.capa')
        brw_capa = obj_pcp_capa.browse(cr, uid, context.get('active_id'), context)
        brw_wiz = self.browse(cr, uid, ids[0], context)
        # if self.browse(cr, uid, ids[0], context).wizduf_grade_id.id == \
        #     brw_capa.pcpftc_grade_id.id:
        #     raise osv.except_osv(_('Atencao!'),
        #                          _('Ja existe ficha tecnica para este produto e grade!'))
        default = {'pcpftc_produto_id': brw_wiz.wizduf_produto_id.id,
                   'pcpftc_grade_id': brw_wiz.wizduf_grade_id.id,
                   'pcpftc_produto_peso_embalagem_id': brw_wiz.wizduf_produto_peso_embalagem_id.id}
        if brw_wiz.wizduf_produto_unidade_embalagem_id.id:
            default['pcpftc_produto_unidade_embalagem_id'] = brw_wiz.wizduf_produto_unidade_embalagem_id.id

        # context['__copy_translations_seen'] = {'pcp.ficha.tecnica.capa': [brw_capa.id]}
        res = obj_pcp_capa.copy(cr, uid, brw_capa.id, default, context)
        obj_model_data = self.pool.get('ir.model.data')
        result = obj_model_data.get_object_reference(cr, uid, 'pcp', 'view_pcp_ficha_tecnica_form')
        view_id = result and result[1] or False
        return {
            # 'name': 'Copiar Ficha Tecnica',
            'res_id': res,
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'pcp.ficha.tecnica.capa',
            'view_id': view_id,
            'target': 'current',
            'type': 'ir.actions.act_window',
        }
