# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _
from dateutil.parser import parse
from datetime import date


class wiz_listagem_planejamento_producao(osv.TransientModel):
    # prefixo: wizlpp_

    _name = 'wiz.listagem.planejamento.producao'

    _columns = {
        'wizlpp_ficha_tecnica_id': fields.many2one('pcp.ficha.tecnica.capa', 'Ficha tecnica'),
        'wizlpp_segunda': fields.boolean('Segunda-feira'),
        'wizlpp_terca': fields.boolean('Terca-feira'),
        'wizlpp_quarta': fields.boolean('Quarta-feira'),
        'wizlpp_quinta': fields.boolean('Quinta-feira'),
        'wizlpp_sexta': fields.boolean('Sexta-feira'),
        'wizlpp_sabado': fields.boolean('Sabado'),
        'wizlpp_domingo': fields.boolean('Domingo'),
        'wizlpp_data_inicio': fields.date('Data inicial'),
        'wizlpp_data_fim': fields.date('Data final'),
        'wizlpp_planejamento_producao_item_ids': fields.one2many(
            'wiz.listagem.planejamento.producao.item', 'wizlpi_capa_id', 'Itens')
    }

    def wizlpp_button_pesquisar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        cr.execute('DELETE FROM wiz_listagem_planejamento_producao_item')
        obj_wiz_listagem_planejamento_producao_item = self.pool.get(
            'wiz.listagem.planejamento.producao.item')
        obj_pcp_planejamento_producao = self.pool.get('pcp.planejamento.producao')
        brw_wiz_listagem_planejamento_producao = self.browse(cr, uid, ids, context)
        for x in brw_wiz_listagem_planejamento_producao:
            args_planejamento = []
            ficha_tecnica_id = x.wizlpp_ficha_tecnica_id.id
            if ficha_tecnica_id:
                args_planejamento.append(('pljprd_ficha_tecnica_id', '=', ficha_tecnica_id))
            if x.wizlpp_data_inicio:
                args_planejamento.append(('pljprd_data', '>=', x.wizlpp_data_inicio))
            if x.wizlpp_data_fim:
                args_planejamento.append(('pljprd_data', '<=', x.wizlpp_data_fim))
            planejamento_producao_ids = obj_pcp_planejamento_producao.search(cr, uid,
                                                                             args_planejamento, context=context)
            brw_planejamento_producao = obj_pcp_planejamento_producao.browse(
                cr, uid, planejamento_producao_ids, context)
            list_dia_semana = []
            if x.wizlpp_segunda:
                list_dia_semana.append(1)
            if x.wizlpp_terca:
                list_dia_semana.append(2)
            if x.wizlpp_quarta:
                list_dia_semana.append(3)
            if x.wizlpp_quinta:
                list_dia_semana.append(4)
            if x.wizlpp_sexta:
                list_dia_semana.append(5)
            if x.wizlpp_sabado:
                list_dia_semana.append(6)
            if x.wizlpp_domingo:
                list_dia_semana.append(7)
            for y in brw_planejamento_producao:
                dia_semana = parse(y.pljprd_data, yearfirst=True).date()
                dia_semana = date.weekday(dia_semana) + 1
                if list_dia_semana and not dia_semana in list_dia_semana:
                    continue
                vals = {
                    'wizlpi_capa_id': x.id,
                    'wizlpi_ficha_tecnica_id': y.pljprd_ficha_tecnica_id.id,
                    'wizlpi_quantidade': y.pljprd_quantidade,
                    'wizlpi_data': y.pljprd_data,
                    'wizlpi_dia_semana': dia_semana

                }
                obj_wiz_listagem_planejamento_producao_item.create(cr, uid, vals, context)
        return True

    def wizlpp_button_imprimir(self, cr, uid, ids, context=None):
        """
        Metodo responsavel por chamar a classe do relatorio que ira imprimir um arquivo pdf com
        as informacoes dos planejamentos de producao
        @return: Dicionario com acao para a classe do relatorio, os dados referentes e o nome.
        """
        context = context and context.copy() or {}
        datas = {
            'id': ids[0],
        }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'listagem_planejamento_producao',
            'datas': datas,
        }


class wiz_listagem_planejamento_producao_item(osv.TransientModel):
    # prefixo: wizlpi_

    _name = 'wiz.listagem.planejamento.producao.item'

    _columns = {
        'wizlpi_capa_id': fields.many2one('wiz.listagem.planejamento.producao', 'Capa'),
        'wizlpi_ficha_tecnica_id': fields.many2one('pcp.ficha.tecnica.capa',
                                                   'Ficha tecnica'),
        'wizlpi_quantidade': fields.integer('Quantidade'),
        'wizlpi_data': fields.date('Data'),
        'wizlpi_dia_semana': fields.selection([(1, _('Segunda-feira')), (2, _('Terca-feira')),
                                               (3, _('Quarta-feira')), (4, _('Quinta-feira')),
                                               (5, _('Sexta-feira')), (6, _('Sabado')),
                                               (7, _('Domingo'))], 'Dia', size=1),
    }

    _order = 'wizlpi_dia_semana, wizlpi_data'
