# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv
from openerp.tools.translate import _


class pcp_wizard_relatorio_planejamento_producao(osv.TransientModel):
    """
    Formulario com os parametros para impressao do relatorio de planejamento de producao.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'pcp.wizard.relatorio.planejamento.producao'  # Prefixo: pcpwpp_
    _inherit = 'pcp.wizard.relatorio.planejamento.producao'

    def pcpwpp_button_imprimir_relatorio(self, cr, uid, ids, context=None):
        """
        Realiza a impressao do relatorio de planejamento de producao.

        @param cr: {cursor} a linha atual do cursor do banco de dados,
        @param uid: {int} ID do usuario utilizado para a verificacao de perfil,
        @param ids: {list} lista dos IDs,
        @param context: {dict} um dicionario padrao para valores contextuais,
        @return: {dict} mensagem de aviso se nao houver ficha tecnica.

        @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        result = {'warning': {'title': _('Aviso'),
                              'message': _('Nenhuma ficha tecnica para imprimir.')}}
        data = {}  # Dados utilizados para impressao do relatorio
        context = context and context.copy() or {}

        if ids and isinstance(ids, (int, long)):
            ids = [ids]

        # ___________________________ Objects ________________________________
        obj_view_pcp_relatorio_sugestao_producao = self.pool.get('view.pcp.relatorio.sugestao.producao')

        campos = ['pcpwpp_ficha_tecnica_ids', 'pcpwpp_categoria_id']
        dados_relatorio = self.read(cr, uid, ids, campos, context=context, load='_classic_write')

        if dados_relatorio and isinstance(dados_relatorio, list):
            dados_relatorio = dados_relatorio[0]

        if dados_relatorio and isinstance(dados_relatorio, dict):
            # Se nao for informada nenhuma ficha tecnica, todas as fichas tecnicas deverao ser
            # consideradas, o mesmo para categoria
            args = []  # Sem argumento. Todas as fichas tecnicas de todas as categorias

            # Filtro de ficha tecnica
            ficha_tecnica_ids = dados_relatorio.get('pcpwpp_ficha_tecnica_ids', [])
            if ficha_tecnica_ids:
                args.append(('pcprpp_ficha_tecnica_id', 'in', ficha_tecnica_ids))

            # Lista dos ID's
            data['ids'] = obj_view_pcp_relatorio_sugestao_producao.search(
                cr, uid, args, context=context)

            if data['ids']:
                # Impressao do relatorio
                result = {'type': 'ir.actions.report.xml', 'report_name': 'sugestao_producao',
                          'datas': data}
            else:
                raise osv.except_osv(_('Atencao!'), _('Nenhuma ficha tecnica para imprimir.'))

        return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
