# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _


class wiz_pcp_relatorio_planilha_producao(osv.TransientModel):
    # prefixo: wizprp_

    _name = 'wiz.pcp.relatorio.planilha.producao'

    _columns = {
        'wizprp_dia_semana': fields.selection([(1, 'Domingo'), (2, 'Segunda-feira'),
                                               (3, 'Terca-feira'), (4, 'Quarta-feira'),
                                               (5, 'Quinta-feira'), (6, 'Sexta-feira'),
                                               (7, 'Sabado')], 'Dia da semana da ficha tecnica',
                                              size=1, required=True),
        'wizprp_categoria_id': fields.many2one('estoque.categoria', 'Categoria'),
    }

    def wizprp_button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        datas = {}
        brw_relatorio_planilha_producao = self.browse(cr, uid, ids, context)
        for x in brw_relatorio_planilha_producao:
            dia_semana = x.wizprp_dia_semana
            if dia_semana == 1:
                dia_semana = 'pcpftc_domingo'
                desc_dia_semana = 'DOMINGO'
            elif dia_semana == 2:
                dia_semana = 'pcpftc_segunda'
                desc_dia_semana = 'SEGUNDA-FEIRA'
            elif dia_semana == 3:
                dia_semana = 'pcpftc_terca'
                desc_dia_semana = 'TERCA-FEIRA'
            elif dia_semana == 4:
                dia_semana = 'pcpftc_quarta'
                desc_dia_semana = 'QUARTA-FEIRA'
            elif dia_semana == 5:
                dia_semana = 'pcpftc_quinta'
                desc_dia_semana = 'QUINTA-FEIRA'
            elif dia_semana == 6:
                dia_semana = 'pcpftc_sexta'
                desc_dia_semana = 'SEXTA-FEIRA'
            elif dia_semana == 7:
                dia_semana = 'pcpftc_sabado'
                desc_dia_semana = 'SABADO'
            categoria_id = False
            if x.wizprp_categoria_id:
                categoria_id = x.wizprp_categoria_id.id
            datas.update({'dia_semana': dia_semana, 'categoria_id': categoria_id,
                          'desc_dia_semana': desc_dia_semana})
            sql = """
                SELECT
                    ft.pcpftc_produto_id AS produto_id,
                    (SELECT name FROM estoque_produto WHERE id = ft.pcpftc_produto_id)
                    AS produto_name,
                    ep.categoria_id AS categoria_id,
                    (SELECT name FROM estoque_categoria WHERE id = ep.categoria_id)
                    AS categoria_name,
                    (SELECT parent_id FROM estoque_categoria WHERE id = ep.categoria_id)
                    AS categoria_pai_id,
                    (SELECT name FROM estoque_categoria WHERE id in
                        (SELECT parent_id FROM estoque_categoria WHERE id = ep.categoria_id))
                    AS categoria_pai_name
                FROM pcp_ficha_tecnica_capa ft
                INNER JOIN estoque_produto ep ON ft.pcpftc_produto_id = ep.id
                WHERE ft.%s = True
            """ % dia_semana
            if categoria_id:
                sql += """
                      AND ep.categoria_id = %s
                """ % categoria_id
            cr.execute(sql)
            dados = cr.dictfetchall()
            datas.update({'dados': dados})
        if not datas.get('dados'):
            raise osv.except_osv(_('Atencao'), _('Com os filtros selecionados nao ha dados a '
                                                 'serem impressos'))
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'planilha_producao',
            'datas': datas,
        }
