# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class pcp_simulacao_precos_encargos(osv.TransientModel):
    _name = 'pcp.wizard.simulacao.precos.encargos'

    def _get_valor(self, cr, uid, ids, name, arg, context=None):
        context = context and context.copy() or {}

        if ids and isinstance(ids, (int, long)):
            ids = [ids]

        result = {}

        campos = ['base', 'aliquota', 'preco_venda']
        dados_simulacao = self.read(cr, uid, ids, campos, context=context)

        if dados_simulacao and not isinstance(dados_simulacao, list):
            dados_simulacao = [dados_simulacao]

        for encargo in dados_simulacao:
            base = encargo.get('base', 0.0)
            aliquota = encargo.get('aliquota', 0.0)
            preco_venda = encargo.get('preco_venda', 0.0)
            result[encargo['id']] = base * aliquota * preco_venda / 10000

        return result

    _columns = {
        'capa_id': fields.many2one('pcp.ficha.tecnica.capa', 'Ficha'),
        'encargo_capa_id': fields.many2one('pcp.wizard.simulacao.precos', 'Encargos'),
        'aliquota': fields.float('Aliquota', digits=(15, 2)),
        'base': fields.float('Base', digits=(15, 2)),
        'encargo': fields.char('Encargo', size=10),
        'preco_venda': fields.float('Preco Venda', digits=(15, 2)),
        'valor': fields.function(_get_valor, method=True, string='Valor', type='float',
                                 digits=(15, 2), store=False),
    }
