# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _
import time
from SigUtils.datas import sigDatas
from SigUtils.formatastring import formataString
import math

class procedimentos_atividade(osv.Model):

    _name = 'procedimentos.atividade'
    _inherit = 'procedimentos.atividade'

    def name_get(self, cr, uid, ids, context=None):
        res = []
        context = context and context.copy() or {}
        if not len(ids):
            return []
        reads = self.read(cr, uid, ids, ['codigo', 'name'], context=context)
        for record in reads:
            res.append((record['id'], str(record['codigo']) + ' - ' + record['name']))
        return res

    def sequence_criar(self, cr, uid, context=None):
        context = context and context.copy() or {}
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
        sigla = context.get('sigla')+'-'
        code = context.get('code')
        name = context.get('name')
        vals = {
            'name' : name,
            'code' : code,
            'padding' : 3,
            'company_id' : company_id,
            'prefix' : sigla,
            'implementation' : 'no_gap',
            }
        consulta = self.pool.get('ir.sequence.type').search(cr, uid, [('code', '=', code)],
                                                            context=context)
        if not consulta:
            self.pool.get('ir.sequence.type').create(cr, uid, {'name': name, 'code': code}, context)
            self.pool.get('ir.sequence').create(cr, uid, vals, context)
        return True

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('frequencia') in ('B', 'T', 'U', 'R', 'A') and not 1 <= vals.get('dia') <= 31:
            raise osv.except_osv(_('Atencao'), _('Informe para o campo "Dia" um valor entre 1 e '
                                                 '31'))
        if vals.get('frequencia') in ('B', 'T', 'U', 'R', 'A') \
                and not 1 <= vals.get('prcatv_mes') <= 12:
            raise osv.except_osv(_('Atencao'), _('Informe para o campo "Mes" um valor entre 1 e '
                                                 '12'))
        obj_adm_empresa_centrocusto = self.pool.get('adm.empresa.centrocusto')
        responsavel_id = vals.get('responsavel_id')
        if isinstance(responsavel_id, (list, tuple)):
            responsavel_id = responsavel_id[0]
        sigla = obj_adm_empresa_centrocusto.browse(cr, uid, responsavel_id).sigla
        if sigla:
            sigla = sigla.upper()
            name = 'Procedimento Atividade'
            code = 'procedimento_atividade.'+str(sigla)
            context['sigla'] = sigla
            context['name'] = name
            context['code'] = code
            self.sequence_criar(cr, uid, context)
            vals['codigo'] = self.pool.get('adm.utils').get_sequence(cr, uid, self._name, code)
        res = super(procedimentos_atividade, self).create(cr, uid, vals, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if 'prcatv_mes' in vals:
            if not 1 <= vals.get('prcatv_mes') <= 12:
                raise osv.except_osv(_('Atencao'), _('Informe para o campo "Mes" um valor entre '
                                                     '1 e 12'))
        if 'dia' in vals:
            if not 1 <= vals.get('dia') <= 31:
                raise osv.except_osv(_('Atencao'), _('Informe para o campo "Dia" um valor entre '
                                                     '1 e 31'))
        if vals.get('frequencia') in ('B', 'T', 'U', 'R', 'A') and 'dia' in vals:
            if not 1 <= vals.get('dia') <= 31:
                raise osv.except_osv(_('Atencao'), _('Informe para o campo "Dia" um valor entre '
                                                     '1 e 31'))
        if vals.get('frequencia') in ('B', 'T', 'U', 'R', 'A') and 'prcatv_mes' in vals:
            if not 1 <= vals.get('prcatv_mes') <= 12:
                raise osv.except_osv(_('Atencao'), _('Informe para o campo "Mes" um valor entre '
                                                     '1 e 12'))
        obj_adm_empresa_centrocusto = self.pool.get('adm.empresa.centrocusto')
        responsavel_id = vals.get('responsavel_id')
        if isinstance(responsavel_id, (list, tuple)):
            responsavel_id = responsavel_id[0]
        sigla = obj_adm_empresa_centrocusto.browse(cr, uid, responsavel_id).sigla
        if sigla:
            sigla = sigla.upper()
            name = 'Procedimento Atividade'
            code = 'procedimento_atividade.'+str(sigla)
            context['sigla'] = sigla
            context['name'] = name
            context['code'] = code
            self.sequence_criar(cr, uid, context)
            vals['codigo'] = self.pool.get('adm.utils').get_sequence(cr, uid, self._name, code)
        res = super(procedimentos_atividade, self).write(cr, uid, ids, vals, context)
        return res

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        if context.get('passo_procedimento_atividade'):
            limit = None
            new_args = []
            for x in args:
                if 'id' and 'in' in x:
                    continue
                else:
                    new_args.append(x)
            if new_args:
                args = new_args

        res = super(procedimentos_atividade, self).search(cr, uid, args, offset, limit, order,
                                                          context, count)
        return res

    def prcatv_onchange_frequencia_mes(self, cr, uid, ids, frequencia, mes, context=None):
        context = context and context.copy() or {}
        res = {}
        if not frequencia or not mes or frequencia in ('D', 'S', 'Q', 'M', 'E'):
            return res
        var = False
        if frequencia == 'B':
            if 1 <= mes <= 2:
                var = True
            numero_valido = '1 ou 2'
        elif frequencia == 'T':
            if 1 <= mes <= 3:
                var = True
            numero_valido = '1 a 3'
        elif frequencia == 'U':
            if 1 <= mes <= 4:
                var = True
            numero_valido = '1 a 4'
        elif frequencia == 'R':
            if 1 <= mes <= 6:
                var = True
            numero_valido = '1 a 6'
        elif frequencia == 'A':
            if 1 <= mes <= 12:
                var = True
            numero_valido = '1 a 12'
        if not var:
            res['value'] = {'prcatv_mes': False}
            res['warning'] = {'title': _('Atencao'),
                              'message': _('O numero de mes e frequencia informados nao sao '
                                           'correspondentes. Numeros validos para essa '
                                           'frequencia: %s' % numero_valido)}
        return res

    def prcatv_procedimento_atividade_para_alerta(self, cr, uid, context=None):
        context = context and context.copy() or {}
        obj_adm_util = self.pool.get('adm.utils')
        obj_procedimento_atividade = self.pool.get('procedimentos.atividade')
        obj_tarefa = self.pool.get('tarefas.tarefas')
        tarefas_instalado = obj_adm_util.admutl_check_modulo_instalado(cr, uid, 'tarefas', context)
        list_informacao = []
        args = [('frequencia', 'in', ('B', 'T', 'U', 'R', 'A')), ('dia', '>=', 1),
                ('dia', '<=', 31), ('prcatv_mes', '>=', 1), ('prcatv_mes', '<=', 12)]
        procedimento_atividade_ids = obj_procedimento_atividade.search(cr, uid, args, context=context)
        campos = ['codigo', 'responsavel_id', 'frequencia', 'prcatv_mes', 'dia',
                  'prcatv_funcionario_ids']
        procedimento_atividade_dados = obj_procedimento_atividade.read(
            cr, uid, procedimento_atividade_ids, campos, context=context)
        dados_frequencia = {'D': 'Diaria', 'S': 'Semanal', 'Q': 'Quinzenal', 'M': 'Mensal',
                            'B': 'Bimestral', 'T': 'Trimestral', 'U': 'Quadrimestral',
                            'R': 'Semestral', 'A': 'Anual', 'E': 'Esporadico'}
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, context=context)
        company_pessoa_id = self.pool.get('res.company').browse(cr, uid, company_id).\
            rescon_pessoa_id.id
        de_uid = False
        company_user_ids = self.pool.get('res.users').search(cr, uid, [('pessoa_id', '=',company_pessoa_id)],
                                                             context=context)
        if company_user_ids:
            de_uid = company_user_ids[0]
        ano_atual = time.strftime('%Y')
        for atividade in procedimento_atividade_dados:
            codigo = atividade.get('codigo')
            departamento = atividade.get('responsavel_id')
            if isinstance(departamento, tuple):
                departamento = departamento[1]
            frequencia = dados_frequencia.get(atividade.get('frequencia'))
            mes = atividade.get('prcatv_mes')
            dia = atividade.get('dia')
            desc = '%s  %s  %s  %s/%s' % (codigo, departamento, frequencia, dia, mes)
            if not tarefas_instalado:
                continue
            # Tratamento para inclusão no modulo tarefas
            funcionario_ids = atividade.get('prcatv_funcionario_ids')
            centro_custo_id = atividade.get('responsavel_id')
            if isinstance(centro_custo_id, (list, tuple)):
                centro_custo_id = centro_custo_id[0]
            user_ids = self._prcatv_get_usuario_from_funcionario(cr, uid, funcionario_ids,
                                                                 centro_custo_id, context)
            list_informacao.append([desc, user_ids])
            for user_id in user_ids:
                data_agenda = '%s-%s-%s' % (ano_atual, mes, dia)
                vals = {'name': codigo, 'descricao': codigo, 'de_uid': de_uid, 'para_uid': user_id,
                        'data_agenda': data_agenda}
                args = [('name', '=', codigo), ('de_uid', '=', de_uid), ('para_uid', '=', user_id),
                        ('data_agenda', '=', data_agenda)]
                tarefa_ids = obj_tarefa.search(cr, uid, args, context=context)
                if not tarefa_ids:
                    obj_tarefa.create(cr, uid, vals, context)
        return list_informacao

    def _prcatv_get_usuario_from_funcionario(self, cr, uid, funcionario_ids, centro_custo_id,
                                             context=None):
        context = context and context.copy() or {}
        obj_rh_funcionario = self.pool.get('rh.funcionario')
        obj_res_user = self.pool.get('res.users')
        res = []
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'res.users', context=context)
        if not funcionario_ids or not centro_custo_id:
            return res
        if centro_custo_id and not funcionario_ids:
            funcionario_ids = obj_rh_funcionario.search(cr, uid,
                                                        [('centro_custo', '=', centro_custo_id),
                                                         ('company_id', '=', company_id)], context=context)
        if funcionario_ids:
            rh_funcionario_dados = obj_rh_funcionario.read(cr, uid, funcionario_ids, ['pessoa'], context=context,
                                                           load='_classic_write')
            pessoa_ids = map(lambda i: i.get('pessoa'), rh_funcionario_dados)
            res = obj_res_user.search(cr, uid, [('pessoa_id', 'in', pessoa_ids),
                                                ('company_id', '=', company_id)], context=context)
        return res

    def prcatv_gerar_processos(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        _obj_processos_capa = self.pool.get('procedimentos.proc.capa')
        self._data_calculada = False
        def _tem_processo():
            """
            Funcao para verificar se já existe processo para a situação apresentada
            Existindo processo ou Não sendo para existir processo, a função retorna True
            para que um novo processo não seja criado
            @return: Boolean
                True Já tem processo ou não é para ser gerado ou
                False para gerar um processo
            """
            def _prcatv_calc_bi_tri_qua_sem(qtd):
                """
                Funcao para calcular a data para Bimetre, Trimestre, Quadrimestre e Semestre
                :param qtd: Bimestre=2, Trimestre=3 ...
                :return: data calculada
                """
                _dia = int(_atividade_dados.dia)
                _mes = ((int(math.ceil(_hoje.mes / float(qtd)) - 1) * qtd) + int(_atividade_dados.prcatv_mes))
                if _mes < _hoje.mes:
                    _mes += qtd
                _ano = _hoje.ano
                if _mes > 12:
                    _ano += 1
                    _mes = 12 - _mes
                _data = ('%s-%s-%s') % (formataString(str(01), 2, '0', 'E'),
                                        formataString(str(_mes), 2, '0', 'E'),
                                        formataString(str(_ano), 4, '0', 'E'),
                )
                _ultimo = sigDatas(_data).getUltimoDiaDoMes()
                if _dia > _ultimo:
                    _dia = _ultimo
                _data = (formataString(str(_ano), 4, '0', 'E') +
                         formataString(str(_mes), 2, '0', 'E') +
                         formataString(str(_dia), 2, '0', 'E')
                )
                _args.append(('prcprc_data', '=', _data))
                return _data

            _hoje = sigDatas(time.strftime('%Y-%m-%d'))
            _args = [('prcprc_atividade_id', '=', _atividade_dados.id)]
            if _atividade_dados.frequencia in ('D', 'E'):
                _args.append(('prcprc_data', '=', _hoje.getDataNoFormato('I','S')))
                self._data_calculada = _hoje.getDataNoFormato('I','S')
            if _atividade_dados.frequencia == 'S':
                if _hoje.nroDiaDaSemana != _atividade_dados.dia: # dia da semana diferente, não gerar
                    return True
                _args.append(('prcprc_data', '=', _hoje.getDataNoFormato('I','S')))
                self._data_calculada = _hoje.getDataNoFormato('I','S')
            if _atividade_dados.frequencia == 'Q':
                _ultimo = _hoje.getUltimoDiaDaQuinzena()
                _dia = int(_atividade_dados.dia)
                if _dia > _ultimo:
                    _dia = _ultimo
                if _hoje.nroDiaDaQuinzena != _dia: # dia da quinzena diferente, não gerar
                    return True
                if _hoje.dia > 15:
                    _dia += 15
                _data = _hoje.getDataNoFormato('I','S')[:-2] + formataString(str(_dia), 2, '0', 'E')
                _args.append(('prcprc_data', '=', _data))
                self._data_calculada = _data
            if _atividade_dados.frequencia == 'M':
                _ultimo = _hoje.getUltimoDiaDoMes()
                _dia = int(_atividade_dados.dia)
                if _dia > _ultimo:
                    _dia = _ultimo
                if _hoje.dia != _dia: # dia do mes diferente, não gerar
                    return True
                _data = _hoje.getDataNoFormato('I','S')[:-2] + formataString(str(_dia), 2, '0', 'E')
                _args.append(('prcprc_data', '=', _data))
                self._data_calculada = _data
            if _atividade_dados.frequencia == 'A':
                _dia = int(_atividade_dados.dia)
                _mes = int(_atividade_dados.prcatv_mes)
                _ano = _hoje.ano
                if _mes < _hoje.mes:
                    _ano += 1
                if _mes == _hoje.mes:
                    if _dia < _hoje.dia:
                        _ano += 1
                _data = ('%s-%s-%s') % (formataString(str(01), 2, '0', 'E'),
                                        formataString(str(_mes), 2, '0', 'E'),
                                        formataString(str(_ano), 4, '0', 'E'),
                )
                _ultimo = sigDatas(_data).getUltimoDiaDoMes()
                if _dia > _ultimo:
                    _dia = _ultimo
                _data = (formataString(str(_ano), 4, '0', 'E') +
                         formataString(str(_mes), 2, '0', 'E') +
                         formataString(str(_dia), 2, '0', 'E')
                )
                _args.append(('prcprc_data', '=', _data))
                self._data_calculada = _data
            if _atividade_dados.frequencia == 'B':
                self._data_calculada = _prcatv_calc_bi_tri_qua_sem(2)
            if _atividade_dados.frequencia == 'T':
                self._data_calculada = _prcatv_calc_bi_tri_qua_sem(3)
            if _atividade_dados.frequencia == 'U':
                self._data_calculada = _prcatv_calc_bi_tri_qua_sem(4)
            if _atividade_dados.frequencia == 'R':
                self._data_calculada = _prcatv_calc_bi_tri_qua_sem(6)
            if _obj_processos_capa.search(cr, uid, _args, context=context):
                return True
            return False

        def _gerar_processo():
            vals = {}
            vals['prcprc_atividade_id'] = _atividade_dados.id
            vals['prcprc_data'] = self._data_calculada
            vals['state'] = 'P'
            passos = []
            _seq = 0
            for _passo in _atividade_dados.passo_ids:
                _dict_passo = {}
                _dict_passo['prcprp_passo_id'] = _passo.id
                _seq += 1
                _dict_passo['prcprp_sequencia'] = _seq
                _dict_passo['state'] = '1'
                passos.append([0, 0, _dict_passo])
            vals['prcprc_passo_ids'] = passos
            _obj_processos_capa.create(cr, uid, vals, context)
            return True
        if ids:
            atividades_ids = ids
        else:
            atividades_ids = self.search(cr, uid, [('prcatv_gerar_processo', '=', True), ('frequencia', '!=', 'E')], context=context)
        if not atividades_ids:
            return True
        for _atividade_dados in self.browse(cr, uid, atividades_ids, context=context):
            if not _tem_processo():
                _gerar_processo()
        return True

    def prcatv_button_gerar_processo(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return self.prcatv_gerar_processos(cr, uid, ids, context)

    def prcatv_button_print(self, cr, uid, ids, context=None):
        """
        Metodo do botao 'Imprimir'. Retorna acao para chamada da classe de impressao do formulario
        :param cr: cursor no banco de dados
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario
        :type uid: int
        :param ids: conjunto de id da tabela desse objeto
        :type ids: list
        :param context: dados contextuais
        :type context: dict
        :return: dados de acao para chamada da classe de impressao
        :rtype: dict
        """
        context = context and context.copy() or {}
        report_name = ''
        if len(ids) == 1:
            brw_procedimentos_atividade = self.browse(cr, uid, ids[0], context)
            report_name = brw_procedimentos_atividade.codigo + ' ' + \
                brw_procedimentos_atividade.name
            report_name = report_name.replace(' ', '_').replace('-', '_')
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'procedimentos_atividade',
            'name': report_name or 'procedimentos_atividades',
            'context': context
        }
