# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
# www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv


class procedimentos_proc_capa(osv.Model):
    # prefixo: prcprc

    _name = 'procedimentos.proc.capa'
    _inherit = 'procedimentos.proc.capa'

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        res = False
        if context.get('view_processos_executar', False):
            _dados_users = self.pool.get('res.users').browse(cr, uid, uid, context=context)
            _funcionario_id = False
            if _dados_users:
                _pessoa_id = _dados_users.pessoa_id.id
                _funcionario_ids = self.pool.get('rh.funcionario').search(cr, uid, [
                    ('pessoa', '=', _pessoa_id)], context=context)
                if _funcionario_ids:
                    _funcionario_id = _funcionario_ids[0]

            if _funcionario_id:
                args.append('|')
                args.append(('prcatv_funcionario_ids', '=', False))
                args.append(('prcatv_funcionario_ids', '=', _funcionario_id))
            else:
                args.append(('prcatv_funcionario_ids', '=', False))
        res = super(procedimentos_proc_capa, self).search(cr, uid, args, offset=offset,
                                                          limit=limit, order=order,
                                                          context=context, count=count)
        return res

    def prcprc_get_state(self, cr, uid, ids, context=None):
        """
        Função para identificar o Estado do processo, baseado nos passos
        @param cr:
        @param uid:
        @param ids: ids dos processos
        @return: boolean
        """
        # Estado da capa:
        # [('P', 'Pendente'), ('E', 'Em processo'), ('C', 'Concluido')]
        # Estado dos passos:
        # [('1', 'Aguardando'), ('2', 'Em atividade'), ('3', 'Parado'), ('4', 'Concluido')]
        context = context and context.copy() or {}
        for dados_capa in self.browse(cr, uid, ids, context=context):
            _state = 'P'
            for _dados_passos in dados_capa.prcprc_passo_ids:
                if _state == 'P':
                    if _dados_passos.state in ('2', '3'):
                        _state = 'E'
                        break
                    if _dados_passos.state == '4':
                        _state = 'C'
                        continue
                if _state == 'E':
                    if _dados_passos.state in ('1', '2', '3'):
                        break
                    else:
                        _state = 'C'
                if _state == 'C':
                    if _dados_passos.state in ('1', '2', '3'):
                        _state = 'E'
                        break
            self.write(cr, uid, dados_capa.id, {'state': _state}, context)
        return True

    def prcprc_button_executar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not ids:
            return True
        _brw_processo = self.browse(cr, uid, ids[0], context=context)
        _passo_id = None
        for _passo in _brw_processo.prcprc_passo_ids:
            if _passo.state in ('2', '3'):
                _passo_id = _passo.id
                break
            if _passo.state == '4':
                continue
            if not _passo_id:
                _passo_id = _passo.id
                continue
            if _passo.id < _passo_id:
                _passo_id = _passo.id
        if not _passo_id:
            return True
        value = {
            'res_id': _passo_id,
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'procedimentos.proc.passo',
            'type': 'ir.actions.act_window',
            'target': 'inline',
            'context': context
        }
        return value

    def sequence_criar(self, cr, uid, context=None):
        context = context and context.copy() or {}
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
        __code = 'procedimentos.proc.capa'
        __name = 'Numero do processo'
        vals = {
            'name': __name,
            'code': __code,
            'padding': 6,
            'prefix': '%(year)s-',
            'company_id': company_id,
            'implementation': 'no_gap',
        }
        consulta = self.pool.get('ir.sequence.type').search(cr, uid, [('code', '=', __code)],
                                                            context=context)
        if not consulta:
            self.pool.get('ir.sequence.type').create(cr, uid, {'name': __name, 'code': __code}, context)
            self.pool.get('ir.sequence').create(cr, uid, vals, context)
        cr.commit()
        return True

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        vals['prcprc_processo'] = self.pool.get('adm.utils').get_sequence(cr, uid, self._name,
                                                                    'procedimentos.proc.capa')
        processo_id = super(procedimentos_proc_capa, self).create(cr, uid, vals, context)
        return processo_id


