# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from datetime import datetime

#Funcoes da classe procedimentos_passo
def _get_codigo_pop(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res={}
    for id in ids:
        res[id]=self.browse(cr, uid, id).atividade_passo_id.codigo
    return res

# Funcoes da classe atividades
def _prcatv_get_tempo(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    _spg = self.pool.get
    for _atividade_dados in self.read(cr, uid, ids, ['prcatv_tipo_tempo'], context=context, load='_classic_write'):
        _tempo_pevisto = 0
        _tempo_gasto = 0
        _passos_ids = _spg('procedimentos.passo').search(cr, uid, [('atividade_id', '=', _atividade_dados.get('id'))],
                                                         context=context)
        for _passo_dados in _spg('procedimentos.passo').read(cr, uid, _passos_ids, ['prcpas_tempo_previsto'],
                                                             context=context, load='_classic_write'):
            _res_atv = {}
            _tempo_pevisto += _passo_dados.get('prcpas_tempo_previsto')
            _tempo_exec_ids = _spg('procedimentos.proc.tempo').search(
                cr,
                uid,
                [('prcprt_passo_id', '=', _passo_dados.get('id'))],
                context=context
            )
            _fields = [
                'prcprt_inicio',
                'prcprt_fim'
            ]
            for _tempo_exec_dados in _spg('procedimentos.proc.tempo').read(cr, uid, _passos_ids, _fields,
                                                                 context=context, load='_classic_write'):
                if not _tempo_exec_dados.get('prcprt_fim'):
                    continue
                _inicio = datetime.strptime(_tempo_exec_dados.get('prcprt_inicio'), '%d/%m/%Y %H:%M:%S')
                _fim = datetime.strptime(_tempo_exec_dados.get('prcprt_fim'), '%d/%m/%Y %H:%M:%S')
                _dif = _fim - _inicio
                _dias = _dif.days
                _horas, _resto = divmod(_dif.seconds, 3600)
                _minutos, segundos = divmod(_resto, 60)
                if _atividade_dados.get('prcatv_tipo_tempo') == 'M':
                    _tempo_gasto += (_dias * 24 * 60) + (_horas * 24) + _minutos
                elif _atividade_dados.get('prcatv_tipo_tempo') == 'H':
                    _tempo_gasto += (_dias * 24) + (_horas * 24)
                elif _atividade_dados.get('prcatv_tipo_tempo') == 'D':
                    _tempo_gasto += _dias
                else:
                    continue
        res[_atividade_dados.get('id')] = {
            'prcatv_tempo_previsto': _tempo_pevisto,
        }
    return res


def _prcprc_get_tempo(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    _spg = self.pool.get
    for _exec_dados in self.read(cr, uid, ids, ['prcprc_atividade_id'], context=context, load='_classic_write'):
        _tempo_pevisto = 0
        _tempo_gasto = 0
        _atividade_dados = _spg('procedimentos.atividade').read(cr, uid, _exec_dados.get('prcprc_atividade_id'),
                                                                ['prcatv_tipo_tempo'],
                                                                     context=context, load='_classic_write')
        _passos_ids = _spg('procedimentos.passo').search(cr, uid,
                                                         [('atividade_id', '=', _atividade_dados.get('id'))],
                                                         context=context)
        for _passo_dados in _spg('procedimentos.passo').read(cr, uid, _passos_ids, ['prcpas_tempo_previsto'],
                                                             context=context, load='_classic_write'):
            _res_atv = {}
            _tempo_pevisto += _passo_dados.get('prcpas_tempo_previsto')
            _tempo_exec_ids = _spg('procedimentos.proc.tempo').search(
                cr,
                uid,
                [('prcprt_passo_id', '=', _passo_dados.get('id'))],
                context=context
            )
            _fields = [
                'prcprt_inicio',
                'prcprt_fim'
            ]
            for _tempo_exec_dados in _spg('procedimentos.proc.tempo').read(cr, uid, _passos_ids, _fields,
                                                                 context=context, load='_classic_write'):
                if not _tempo_exec_dados.get('prcprt_fim'):
                    continue
                _inicio = datetime.strptime(_tempo_exec_dados.get('prcprt_inicio'), '%d/%m/%Y %H:%M:%S')
                _fim = datetime.strptime(_tempo_exec_dados.get('prcprt_fim'), '%d/%m/%Y %H:%M:%S')
                _dif = _fim - _inicio
                _dias = _dif.days
                _horas, _resto = divmod(_dif.seconds, 3600)
                _minutos, segundos = divmod(_resto, 60)
                if _atividade_dados.get('prcatv_tipo_tempo') == 'M':
                    _tempo_gasto += (_dias * 24 * 60) + (_horas * 24) + _minutos
                elif _atividade_dados.get('prcatv_tipo_tempo') == 'H':
                    _tempo_gasto += (_dias * 24) + (_horas * 24)
                elif _atividade_dados.get('prcatv_tipo_tempo') == 'D':
                    _tempo_gasto += _dias
                else:
                    continue
        res[_exec_dados.get('id')] = {
            'prcprc_tipo_tempo': _atividade_dados.get('prcatv_tipo_tempo'),
            'prcprc_tempo_previsto': _tempo_pevisto,
            'prcprc_tempo_gasto': _tempo_gasto,
        }
    return res


def _prcprp_get_tempo(self, cr, uid, ids, name, arg, context=None):
    context = context and context.copy() or {}
    res = {}
    _spg = self.pool.get
    for _exec_dados in self.read(cr, uid, ids, ['prcprp_passo_id'], context=context, load='_classic_write'):
        _tempo_pevisto = 0
        _tempo_gasto = 0
        _passo_dados = _spg('procedimentos.passo').read(cr, uid, _exec_dados.get('prcprp_passo_id'),
                                                             ['prcpas_tempo_previsto', 'atividade_id'],
                                                             context=context, load='_classic_write')
        _res_atv = {}
        _atividade_dados = _spg('procedimentos.atividade').read(cr, uid, _passo_dados.get('atividade_id'), [],
                                                                context=context)
        _tempo_pevisto += _passo_dados.get('prcpas_tempo_previsto')
        res[_exec_dados.get('id')] = {
            'prcprp_tipo_tempo': _atividade_dados.get('prcatv_tipo_tempo'),
            'prcprp_tempo_previsto': _tempo_pevisto,
            'prcprp_tempo_gasto': 0,
        }
        _tempo_exec_ids = _spg('procedimentos.proc.tempo').search(
            cr,
            uid,
            [('prcprt_passo_id', '=', _passo_dados.get('id'))],
            context=context
        )
        _fields = [
            'prcprt_inicio',
            'prcprt_fim'
        ]
        _tempo_exec_dados = _spg('procedimentos.proc.tempo').read(cr, uid, _exec_dados.get('prcprp_passo_id'), _fields,
                                                             context=context, load='_classic_write')
        if not (_tempo_exec_dados and _tempo_exec_dados.get('prcprt_fim')):
            continue
        _inicio = datetime.strptime(_tempo_exec_dados.get('prcprt_inicio'), '%d/%m/%Y %H:%M:%S')
        _fim = datetime.strptime(_tempo_exec_dados.get('prcprt_fim'), '%d/%m/%Y %H:%M:%S')
        _dif = _fim - _inicio
        _dias = _dif.days
        _horas, _resto = divmod(_dif.seconds, 3600)
        _minutos, segundos = divmod(_resto, 60)
        if _atividade_dados.get('prcatv_tipo_tempo') == 'M':
            _tempo_gasto += (_dias * 24 * 60) + (_horas * 24) + _minutos
        elif _atividade_dados.get('prcatv_tipo_tempo') == 'H':
            _tempo_gasto += (_dias * 24) + (_horas * 24)
        elif _atividade_dados.get('prcatv_tipo_tempo') == 'D':
            _tempo_gasto += _dias
        else:
            continue
        res[_atividade_dados.get('id')] = {
            'prcprp_tipo_tempo': _atividade_dados.get('prcatv_tipo_tempo'),
            'prcprp_tempo_previsto': _tempo_pevisto,
            'prcprp_tempo_gasto': _tempo_gasto,
        }
    return res
