# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler
import time

class procedimentos_passo(osv.Model):
    """
        Tabela de passos a serem desenvolvidos no POP
    """

    from funcoes import _get_codigo_pop

    _name='procedimentos.passo'
    _columns = {
        'atividade_id' : fields.many2one('procedimentos.atividade', 'Procedimento', ondelete="restrict"), # Id da atividade a que este passo pertence
        'name' : fields.char('Nome', size=60, required=True), # Nome do passo
        'descricao' : fields.text('Descricao'), # Descricao detalha do passos
        'sequence' : fields.integer('Sequencia'), # Sequencia do passo no pop
        'atividade_passo_id' : fields.many2one('procedimentos.atividade', 'Procedimento', ondelete="restrict", help='Caso este passo seja uma atividade, selecione-a aqui!'), # atividade que equivale a este passo
        'codigo_pop_passo' : fields.function(_get_codigo_pop, method=True, string='POP', type='char', store=False),
        'prcpas_tempo_previsto': fields.integer('Tempo previsto'),
    }
    _order = "sequence,id"

