# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
# www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class procedimentos_proc_capa(osv.Model):
    """
        Tabela de processos gerados dos POPs.
    """
    # prefixo: prcprc
    from funcoes import _prcprc_get_tempo
    _name = 'procedimentos.proc.capa'
    _name_rec = 'prcprc_atividade_id'
    _inherits = {
        'procedimentos.atividade': 'prcprc_atividade_id'
    }
    _columns = {
        'prcprc_processo': fields.char('Numero do processo', size=15, required=False, select=True, readonly=True),
        'prcprc_atividade_id': fields.many2one('procedimentos.atividade', 'POP',
                                               ondelete="restrict", required=True),
        'prcprc_data': fields.date('Data', required=True),
        'prcprc_observacao': fields.text('Informacoes complementares'),
        'prcprc_passo_ids': fields.one2many('procedimentos.proc.passo', 'prcprp_capa_id',
                                            'Passos'),
        'state': fields.selection([('P', 'Pendente'), ('E', 'Em processo'), ('C', 'Concluido')],
                                  'Estado', size=1, required=True),
        'create_uid': fields.many2one('res.users', 'Criado por', readonly=True),
        'prcprc_tipo_tempo': fields.function(_prcprc_get_tempo, method=True, string="Periodo tempo p/execucao",
                                             type="selection", multi="dados",
                                             selection=[('M', 'Minutos'), ('H', 'Horas'), ('D', 'Dias')], store=False),
        'prcprc_tempo_previsto': fields.function(_prcprc_get_tempo, method=True, string='Tempo previsto', multi="dados",
                                                 type='integer', store=False),
        'prcprc_tempo_gasto': fields.function(_prcprc_get_tempo, method=True, string='Tempo gasto', multi="dados",
                                              type='integer', store=False),
    }
    _default = {
        'state': 'P',
    }
    _order = 'id desc'
    _sql_constraints = [
        ('processo_uniq', 'unique (prcprc_processo)', 'O numero do processo precisa ser unico!'),
    ]

