# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
# www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class procedimentos_proc_passo(osv.Model):
    """
        Tabela de passos dos processos gerados dos POPs.
    """
    # prefixo: prcprp_
    from funcoes import _prcprp_get_tempo
    _name = 'procedimentos.proc.passo'
    _inherits = {
        'procedimentos.proc.capa': 'prcprp_capa_id',
        'procedimentos.passo': 'prcprp_passo_id',
    }
    _columns = {
        'prcprp_capa_id': fields.many2one('procedimentos.proc.capa', 'Processo',
                                          ondelete="cascade", required=True),
        'prcprp_passo_id': fields.many2one('procedimentos.passo', 'Passo', ondelete="restrict",
                                           required=True),
        'prcprp_sequencia': fields.integer('Sequencia', required=True),
        'state': fields.selection(
            [('1', 'Aguardando'), ('2', 'Em atividade'), ('3', 'Parado'), ('4', 'Concluido')],
            'Estado', size=1, required=True),
        'prcprp_user_id': fields.many2one('res.users', 'Usuario'),
        'prcprp_observacao': fields.text('Informacoes complementares'),
        'prcprp_tempo_ids': fields.one2many('procedimentos.proc.tempo', 'prcprt_passo_id',
                                            'Tempos'),
        'prcprp_tipo_tempo': fields.function(_prcprp_get_tempo, method=True, string="Periodo tempo p/execucao",
                                             type="selection", multi="dados",
                                             selection=[('M', 'Minutos'), ('H', 'Horas'), ('D', 'Dias')], store=False),
        'prcprp_tempo_previsto': fields.function(_prcprp_get_tempo, method=True, string='Tempo previsto', multi="dados",
                                                 type='integer', store=False),
        'prcprp_tempo_gasto': fields.function(_prcprp_get_tempo, method=True, string='Tempo gasto', multi="dados",
                                              type='integer', store=False),

    }
    _defaults = {
        'state': '1',
    }
    _order = 'prcprp_capa_id desc,prcprp_sequencia'

