# -*- coding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.numero import getNumeroEditado
from SigUtils.impressao import Impressora
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _
from dateutil.parser import parse


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):

    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}

        def get_frequencia(frq):
            if frq == 'D':
                frequencia = 'Diaria'
            elif frq == 'S':
                frequencia = 'Semanal'
            elif frq == 'Q':
                frequencia = 'Quinzenal'
            elif frq == 'M':
                frequencia = 'Mensal'
            elif frq == 'B':
                frequencia = 'Bimestral'
            elif frq == 'T':
                frequencia = 'Trimestral'
            elif frq == 'U':
                frequencia = 'Quadrimestral'
            elif frq == 'R':
                frequencia = 'Semestral'
            elif frq == 'A':
                frequencia = 'Anual'
            else:
                frequencia = 'Esporadico'
            return frequencia

        def center_title(e, c, d, t=125):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('procedimentos_atividade'))
        # listagem.informaTamLinha(160)
        listagem.defineFonte(tam=7.5)
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)

        brw_procedimentos_atividade = pooler.get_pool(cr.dbname).get(
            'procedimentos.atividade').browse(cr, uid, ids, context)
        contador = 1
        for atividade in brw_procedimentos_atividade:
            data_criacao = atividade.data_criacao and parse(atividade.data_criacao).strftime(
                '%d/%m/%Y') or ''
            data_revisao = atividade.data_revisao and parse(atividade.data_revisao).strftime(
                '%d/%m/%Y') or ''
            docs = center_title('Departamento: ' + atividade.responsavel_id.codigo + ' - ' +
                                atividade.responsavel_id.name, '', 'Data criacao: ' + data_criacao)
            docs1 = center_title('Revisao: ' + (atividade.revisao or ''), '',
                                 'Data revisao: ' + data_revisao)
            docs2 = center_title('Frequencia: ' + get_frequencia(atividade.frequencia),
                                 'Dia: ' + str(atividade.dia or 0),
                                 'Mes: ' + str(atividade.prcatv_mes or 0))

            listagem.cabecalhos = []
            listagem.informaCab((atividade.codigo + ' - ' + atividade.name).upper())
            listagem.informaCab('')
            listagem.informaCab(docs)
            listagem.informaCab(docs1)
            listagem.informaCab(docs2)
            listagem.informaCab('--')
            listagem.informaCab('')
            listagem.rodapePadrao()
            contador > 1 and listagem.imprimeLinha('{{ Page }}')
            if atividade.passo_ids:
                listagem.imprimeLinha('Passos:')
                listagem.imprimeLinha('')
            for passo in atividade.passo_ids:
                linha = formataString('{{ bold }}'+passo.name, 60, ' ', 'D', 'N', 'S')
                linha += formataString('Seq.: ' + str(passo.sequence), 10, ' ', 'D', 'N', 'S')
                linha += formataString('Processo: ' + (passo.codigo_pop_passo or ''), 20, ' ', 'D',
                                       'N', 'S')
                listagem.imprimeLinha(linha)
                if not passo.descricao:
                    listagem.imprimeLinha('')
                    continue
                listagem.imprimeLinha('Descricao:')
                descricao = passo.descricao.split('\n')
                for desc in descricao:
                    while desc:
                        desc = desc.replace('\t', '   ')
                        listagem.imprimeLinha(formataString(desc[:125], 125, ' ', 'D', 'N', 'S'))
                        desc = desc[125:]
                listagem.imprimeLinha('')
            listagem.imprimeLinha('')

            linha = formataString('Recurso:', 70, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
            recurso_ids = atividade.recurso_ids
            for recurso in recurso_ids:
                linha = formataString(recurso.recurso_id.name, 60, ' ', 'D', 'N', 'S')
                linha += formataString(getNumeroEditado(recurso.quantidade, 3), 10, ' ', 'E', 'N',
                                       'S')
                listagem.imprimeLinha(linha)
            listagem.imprimeLinha('')

            list_acoes_corretivas = atividade.acoes_corretivas and atividade.acoes_corretivas.split(
                '\n') or []
            linha = formataString('Acoes Corretivas:', 63, ' ', 'D', 'N', 'S')
            listagem.imprimeLinha(linha)
            for acao in list_acoes_corretivas:
                acoes_corretivas = acao.replace('\t', '   ') or ''
                while acoes_corretivas:
                    linha = formataString(acoes_corretivas[:125], 125, ' ', 'D', 'N', 'S')
                    listagem.imprimeLinha(linha)
                    acoes_corretivas = acoes_corretivas[125:]
            listagem.imprimeLinha('')

            listagem.imprimeLinha('Funcionarios:')
            for funcionario in atividade.prcatv_funcionario_ids:
                listagem.imprimeLinha(formataString(funcionario.matricula, 4, '0', 'E') + ' - ' +
                                      funcionario.nome)
            contador += 1
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.procedimentos_atividade')
