# -*- encoding: utf-8 -*-
from openerp.osv import osv, fields


class segmento_produto_software(osv.Model):
    _name = 'segmento.produto.software'
    _columns = {
        'produto_id': fields.many2one('estoque.produto', 'Produto', select=True,
                                      ondelete="cascade"),
        'seguimento_id': fields.many2one('adm.pessoa.categoria.nome', 'Segmento',
                                         ondelete="restrict", required=True, select=True),
        # Id da categoria do cliente
        'pontos_de_venda': fields.integer('Pontos de venda', required=True),
        # Quantidade de pontos de vendas(limite máximo
        'preco': fields.float('Preco', digits=(10, 2)), # Valor do produto
        'quantidade_horas': fields.float('Quantidade de Horas', digits=(4, 2)),
    }
    _default = {
        'preco': None,
        'quantidade_horas': None
    }

    def fields_view_get(self, cr, user, view_id=None, view_type='tree', context=None, toolbar=False,
                        submenu=False):
        context = context and context.copy() or {}
        res = super(segmento_produto_software, self).fields_view_get(cr, user, view_id, view_type,
                                                                     context, toolbar, submenu)
        software_obj = self.pool.get('segmento.produto.software')
        return res

