# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from mx import DateTime
from mx.DateTime import now
import time
from openerp.tools.translate import _
import sys
from openerp.osv import fields, osv
from openerp.tools.translate import _
from datetime import datetime, timedelta


class project_br(osv.Model):
    _name = "project_br.project_br"
    _inherit = "project_br.project_br"

    def onchange_parent_id(self, cr, uid, ids, parent_id):

        pessoa_id = False
        if parent_id:
            pessoa_id = self.browse(cr, uid, parent_id).pessoa_id.id
            if pessoa_id:
                self.onchange_pessoa_id(cr, uid, ids, pessoa_id)
        return {'value': {'pessoa_id': pessoa_id}}

    def onchange_pessoa_id(self, cr, uid, ids, part, context=None):
        context = context and context.copy() or {}
        vals = {}
        if ids:
            if not part:
                return {'value': {'endereco_id': False, 'pricelist_id': False}}
            ids_project = self.search(cr, uid, [('parent_id', 'child_of', ids)], context=context)
            ids_task = self.pool.get('project_br.task').search(cr, uid, [
                ('project_br_id', 'in', (ids_project))], context=context)
            #         ---------------------------- Update nas Tarefas filhas Nome do Cliente --------------
            if ids_task:
                self.pool.get('project_br.task').write(cr, uid, ids_task, {'pessoa_id': part},
                                                       context)
            ids_project.remove(ids[0])
            self.write(cr, uid, ids_project, {'pessoa_id': part}, context)
        modulo_document_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr,
                                                                                             uid,
                                                                                             'document',
                                                                                             context=context)
        if modulo_document_instalado:
            if part:
                brw_adm_pessoa = self.pool.get('adm.pessoa').browse(cr, uid, part, context=context)
                file_ids = self.pool.get('ir.attachment').search(cr, uid, [
                    ('partner_id', '=', brw_adm_pessoa.partner_id.id)], context=context)
                vals['file_ids'] = file_ids
        return {'value': vals}

    def unlink(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        ret = True
        ids_project = self.search(cr, uid, ['|', ('parent_id', 'child_of', ids), ('id', 'in', ids)], context=context)
        prj_stats = self.read(cr, uid, ids_project, ['state'], context=context)
        for st in prj_stats:
            if st['state'] in ('done', 'pending' ):
                ret = False
                break
        if ret:
            ids_task = self.pool.get('project_br.task').search(cr, uid, [
                ('project_br_id', 'in', (ids_project))], context=context)
            tsk_stats = self.pool.get('project_br.task').read(cr, uid, ids_task, ['state'], context=context)
            for st in tsk_stats:
                if st['state'] in ('done', 'pending', 'open' ):
                    ret = False
                    break
        if ret:
            self.pool.get('project_br.task').unlink(cr, uid, ids_task, context=context)
            super(project_br, self).unlink(cr, uid, ids_project, context=context)
        else:
            raise osv.except_osv(_('SigErp !'), _('Nao e possivel excluir projetos iniciados.'))
        return ret

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not len(ids):
            return []
        reads = self.read(cr, uid, ids, ['name', 'id', 'parent_id'], context=context)
        res = []
        for record in reads:
            name = record['name']
            if record['parent_id']:
                name = record['parent_id'][1] + ' / ' + name
            else:
                name = str(record['id']) + ' - ' + name

            res.append((record['id'], name))
        return res

    def name_search(self, cr, uid, name='', args=[], operator='ilike', context=None, limit=100):
        context = context and context.copy() or {}
        ids = []
        try:
            name = int(name)
        except:
            pass
        if isinstance(name, int):
            ids = self.search(cr, uid, [('id', '=', str(name))] + args, limit=limit,
                              context=context)
        if not ids:
            ids = self.search(cr, uid, [('name', operator, name)] + args, limit=limit,
                              context=context)
        return self.name_get(cr, uid, ids)

    def read(self, cr, uid, ids, fields=None, context=None, load='_classic_read'):

        '''Para concatenar o id e o nome do projeto'''

        context = context and context.copy() or {}
        res = super(project_br, self).read(cr, uid, ids, fields=fields, context=context, load=load)
        if context.get('estrutura_projetos', False):
            for a in res:
                if 'pessoa_id' in a:
                    if 'id' in a and 'name' in a:
                        a['name'] = '%05.0f - %s' % (a['id'], a['name'])
        return res

    # toggle activity of project_brs, their sub project_brs and their tasks
    def set_template(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = self.setActive(cr, uid, ids, value=False, context=context)
        return res

    def set_done(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        project_ids = ids
        for p in project_ids:
            _ids = self.read(cr, uid, [p], ['child_id', 'tasks'], context=context)
            child_ids = _ids[0]['child_id']
            task_ids = _ids[0]['tasks']
            if task_ids:
                obj_works = self.pool.get('project_br.task.work')
                user_id = obj_works._get_user(cr, uid, context)
                for x in task_ids:
                    obj_works.create(cr, uid, {'task_id': x,
                                               'name': 'Projeto concluido.',
                                               'user_id': user_id}, context=context)
                self.pool.get('project_br.task').write(cr, uid, task_ids, {'state': 'done',
                                                                           'date_close': time.strftime(
                                                                               '%Y-%m-%d')},
                                                       context=context)
            project_ids += child_ids
        self.write(cr, uid, project_ids,
                   {'state': 'done', 'data_conclusao': time.strftime('%Y-%m-%d')}, context=context)
        return True

    def set_cancel(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': 'cancelled'}, context=context)
        return True

    def set_pending(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': 'pending'}, context=context)
        return True

    def set_open(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': 'open', 'data_conclusao': False}, context=context)
        return True

    def reset_project_br(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = self.setActive(cr, uid, ids, value=True, context=context)
        return res

    def copy(self, cr, uid, id, default={}, context=None):
        context = context and context.copy() or {}
        default = default or {}
        context['active_test'] = False
        default['state'] = 'open'
        res = super(project_br, self).copy(cr, uid, id, default, context)
        ids = self.search(cr, uid, [('parent_id', 'child_of', [res])], context=context)
        if default.get('pessoa_id') and default.get('manager'):
            cr.execute('update project_br_project_br set pessoa_id= ' + str(
                default['pessoa_id']) + ', manager=' + str(
                default['manager']) + ' where id in (' + ','.join(map(str, ids)) + ')')
            cr.execute('update project_br_task set active=True, pessoa_id=' + str(
                default['pessoa_id']) + ' where project_br_id in (' + ','.join(map(str, ids)) + ')')
        return res

    def duplicate_template(self, cr, uid, ids, company_id, gerente_id, name, context):
        default = {'parent_id': False, 'pessoa_id': company_id, 'manager': gerente_id, 'name': name}
        lista_ids_project = []
        for id in ids:
            _id = self.copy(cr, uid, id, default=default)
            lista_ids_project.append(_id)
        browse_project = self.browse(cr, uid, lista_ids_project)
        for projectc in browse_project:
            lista_tasks = projectc.tasks
            pessoa_id = projectc.pessoa_id.id
            for task in lista_tasks:
                self.pool.get('project_br.task').write(cr, uid, task.id, {'pessoa_id':pessoa_id}, context)

        cr.commit()
        return {'type': 'ir.actions.act_window_close'}

    # set active value for a project_br, its sub project_brs and its tasks
    def setActive(self, cr, uid, ids, value=True, context=None):
        context = context and context.copy() or {}
        for proj in self.browse(cr, uid, ids, context):
            self.write(cr, uid, [proj.id],
                       {'state': value and 'open' or 'template', 'data_conclusao': False}, context)
            cr.execute('select id from project_br_task where project_br_id=%s', (proj.id,))
            tasks_id = [x[0] for x in cr.fetchall()]
            if tasks_id:
                self.pool.get('project_br.task').write(cr, uid, tasks_id, {'active': value},
                                                       context)
            cr.execute('select id from project_br_project_br where parent_id=%s', (proj.id,))
            project_br_ids = [x[0] for x in cr.fetchall()]
            for child in project_br_ids:
                self.setActive(cr, uid, [child], value, context)
        return True

    # funcao chamada pelo cron 'ir_cron_notificar_pendencia'
    def prjprh_notificar_pendencia(self, cr, uid, id, context=None):
        context = context and context.copy() or {}
        obj_adm_pessoa = self.pool.get('adm.pessoa')
        data_inicio = str(datetime.now())
        data_fim = str(datetime.now() + timedelta(days=10))[:10] + ' 23:59:59'
        sql1 = '''SELECT project_br_id
                  FROM project_br_task
                  WHERE data_inicio_previsto >= '%s'
                    and data_inicio_previsto <= '%s'
               ''' % (data_inicio, data_fim)
        cr.execute(sql1)
        task_dados = cr.dictfetchall()
        projetos_ids = map(lambda x: x.get('project_br_id'), task_dados)
        projetos_ids = str(set(projetos_ids)).replace('set([','(').replace('])',')')
        dados_projeto = []
        if task_dados:
            sql2 = '''SELECT id, name, pessoa_id, company_id, manager
                      FROM project_br_project_br
                      WHERE id IN %s
                   ''' % (projetos_ids)
            cr.execute(sql2)
            dados_projeto = cr.dictfetchall()

        for p in dados_projeto:
            pessoa_com_restricao = self.pool.get('financeiro').finutl_verificar_restricao_cliente(cr, uid,
                                                    finutl_pessoa_id=p.get('pessoa_id'), context=context)
            if pessoa_com_restricao:
                nome = obj_adm_pessoa.read(cr, uid, p.get('pessoa_id'), ['nome'], context=context)
                if nome and isinstance(nome, list):
                    nome=nome[0]
                nome_cliente = nome.get('nome') or ''
                nome_projeto = p.get('name')
                ids_para_email = []
                brw_gerente = obj_adm_pessoa.browse(cr, uid, p.get('manager'), context=context)
                bwr_company = self.pool.get('res.company').browse(cr, uid, p.get('company_id'))
                rel_ids = self.pool.get('adm.pessoa.relacionamento').search(cr, uid, [('pessoa_id','=',bwr_company.rescon_pessoa_id.id),
                                                                            ('admprel_setor_ids','=','Sup. de serviços')], context=context)
                rel_dados = self.pool.get('adm.pessoa.relacionamento').read(cr, uid, rel_ids, ['dependente_id'], context=context)
                contatos_ids = map(lambda x: x.get('dependente_id')[0], rel_dados)
                for cont_id in contatos_ids:
                    ids_para_email.append(cont_id)
                ids_para_email.append(brw_gerente.id)
                emails = self.pool.get('adm.pessoa')._admpes_get_email(cr, uid, ids_para_email,'', [])
                list_email = []
                for id in emails:
                    list_email.append(emails.get(id))
                mail_mail = self.pool.get('mail.mail')
                subject = 'Pendencias no projeto: %s' % (nome_projeto)
                project_email = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'adm', 'admpar_prj_email_projeto').get('admpar_prj_email_projeto')
                body_html = u"""<p><b>Atenção!</b><br/>
                                   <b>Segue abaixo o projeto e o cliente que possui restrição.(Titulos em atraso/Bloqueio por mensagem/Limite de credito)</b><br/>
                                   <b>Projeto: </b> %s<br/>
                                   <b>Nome do cliente: </b> %s</p>""" %(nome_projeto, nome_cliente)
                for email in list_email:
                    dict_mail = {'email_from': project_email, 'email_to': email, 'subject': subject,
                                         'body_html': body_html}
                    mail_id = mail_mail.create(cr, uid, dict_mail, context)
                    mail_mail.send(cr, uid, [mail_id])

    def prjprj_limpa_programacao_tarefas(self, cr, uid, id, context=None):
        context = context and context.copy() or {}
        obj_project_br_task = self.pool.get('project_br.task')
        projetos_ids = []
        if id:
            if isinstance(id, list):
                id = id[0]
            projetos_filhos = self.search(cr, uid, [('parent_id', 'child_of', id)], context=context)
            if projetos_filhos:
                projetos_ids.extend(projetos_filhos)
                if id not in projetos_ids:
                    projetos_ids.extend(id)
                tarefas_ids = obj_project_br_task.search(cr, uid,
                                                         [('state', 'in', ('draft', 'pending')),
                                                          ('project_br_id', 'in', projetos_ids)], context=context)
                if tarefas_ids:
                    obj_project_br_task.write(cr, uid, tarefas_ids, {'data_inicio_previsto': None}, context)
        return True
    def importar_atividades_modelo_projeto(self, cr, uid, id, context=None):
        # id_modelo = self.pool.get('fiscal.exibe.questao.osv').create(cr, uid, {'': msg, 'opcao_confirma': True},
        #                                                            context=context)
        context = context and context.copy() or {}
        return {
                'name': _('Importacao de atividades'),
                'view_type': 'form',
                'view_mode': 'form',
                # 'res_id': id_modelo,
                'res_model': 'importacao.atividades.osv',
                'view_id': False,
                'context': context,
                'target': 'new',
                'type': 'ir.actions.act_window',
            }
    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('manager'):
            try:
                user_ids = self.pool.get('res.users').search(cr, uid,
                                                             [('pessoa_id', '=', vals['manager'])], context=context)
                vals['pessoa_uid'] = user_ids[0]
            except:
                pass
        return super(project_br, self).create(cr, uid, vals, context=context)

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('manager'):
            try:
                user_ids = self.pool.get('res.users').search(cr, uid,
                                                             [('pessoa_id', '=', vals['manager'])], context=context)
                vals['pessoa_uid'] = user_ids[0]
            except:
                vals['pessoa_uid'] = 0
        return super(project_br, self).write(cr, uid, ids, vals, context)

