# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class project_br_calendario(osv.Model):

    _name = 'project_br.calendario'
    _inherit = 'project_br.calendario'

    def search(self, cr, user, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        if context.get('menu', False):
            self.insert_data(cr)
            context['menu'] = False

        return osv.osv.search(self, cr, user, args, offset=offset, limit=limit, order=order,
                              context=context, count=count)

    def insert_data(self, cr):
        cr.execute("""
            truncate project_br_calendario
            """)
        cr.execute("""
                insert into project_br_calendario
                           (id, create_uid, create_date, data_inicio_previsto,cliente_id, consultor_id,
                            planned_hours, data_fim_previsto) (

                select id, create_uid, create_date, data_inicio_previsto, cliente_id, consultor_id ,
                       planned_hours,
                       data_inicio_previsto + to_char((planned_hours*60*60),'9999990.99')::interval as data_fim_previsto

                from
                    (select min (id) as id,
                                min(create_uid) as create_uid,
                                min(create_date ) as create_date ,
                        date_trunc('minute',pt.data_inicio_previsto) as data_inicio_previsto ,
                        pt.pessoa_id as cliente_id,
                        pt.user_id as consultor_id,
                        sum(pt.planned_hours) as planned_hours
                       from project_br_task pt
                      where pt.data_inicio_previsto >= CURRENT_DATE - 15
                       group by date_trunc('minute',pt.data_inicio_previsto),
                        pt.pessoa_id ,
                        pt.user_id ) a)
            """)
