# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from mx import DateTime
from mx.DateTime import now
import time
from openerp.tools.translate import _
import sys
from openerp.osv import fields, osv
from openerp.tools.translate import _

class project_br_work(osv.Model):
    _name = "project_br.task.work"
    _inherit = "project_br.task.work"

    def _get_user(self, cr, uid, context): #Para ler o uid e o pessoa_id do usuario logado
        obj_res_users = self.pool.get('res.users')
        user_id = obj_res_users.search(cr, uid, [('id', '=', uid)], context=context)
        pessoa_id = False
        if user_id:
            pessoa_id = obj_res_users.browse(cr, uid, user_id[0]).pessoa_id.id
        return pessoa_id

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('hours') and not vals.get('hours'):
            vals['hours'] = 0.00
        if 'task_id' in vals:
            cr.execute('update project_br_task set remaining_hours=remaining_hours - %s where id=%s', (vals.get('hours', 0.0), vals['task_id']))
        return super(project_br_work, self).create(cr, uid, vals, context=context)

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if 'hours' in vals and (not vals['hours']):
            vals['hours'] = 0.00
        if 'hours' in vals:
            for work in self.browse(cr, uid, ids, context):
                cr.execute('update project_br_task set remaining_hours=remaining_hours - %s + (%s) where id=%s', (vals.get('hours', 0.0), work.hours, work.task_id.id))
        return super(project_br_work, self).write(cr, uid, ids, vals, context)

    def unlink(self, cr, uid, ids, *args, **kwargs):
        for work in self.browse(cr, uid, ids):
            cr.execute('update project_br_task set remaining_hours=remaining_hours + %s where id=%s', (work.hours, work.task_id.id))
        return super(project_br_work, self).unlink(cr, uid, ids, *args, **kwargs)


