# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

import time

#Funcoes da classe config_compute_remaining
def _get_remaining(self, cr, uid, ctx):
    if 'active_id' in ctx:
        return self.pool.get('project_br.task').browse(cr, uid, ctx['active_id']).remaining_hours
    return False

#Funcoes da classe project_br
def _complete_name(self, cr, uid, ids, name, args, context):
    res = {}
    for m in self.browse(cr, uid, ids, context=context):
        res[m.id] = (m.parent_id and (m.parent_id.name + '/') or '') + m.name
    return res

def _get_user(self, cr, uid, context):#Para ler o uid e o pessoa_id do usuario logado
    id = 0
    if context.get('myproject'):
        ids = self.pool.get('res.users').search(cr, uid, [('id', '=', uid)], context=context)
        id = self.pool.get('res.users').read(cr, uid, ids, ['pessoa_id'], context=context)[0]['pessoa_id'][0]
    return id

def _progress_rate(self, cr, uid, ids, names, arg, context=None):
    context = context and context.copy() or {}
    if isinstance(ids, (int, long)):
        ids = [ids]
    res = {}.fromkeys(ids, {}.fromkeys(['planned_hours', 'effective_hours', 'total_hours', 'progress_rate'], 0.0))
    progress = {}
    if not ids:
        return res
    ids2 = self.search(cr, uid, [('parent_id', 'child_of', ids)], context=context)
    if ids2:
        str_ids = str(map(str, ids2)).replace('[', '(').replace(']', ')')
        sql = """
                select
                    project_br_id,
                    sum(planned_hours),
                    sum(total_hours),
                    sum(effective_hours)
                from
                    project_br_task
                where
                    state != 'cancelled' and
                    project_br_id in %s
                group by
                    project_br_id
            """%str_ids
        cr.execute(sql)
        progress = dict(map(lambda x: (x[0], (x[1], x[2], x[3])), cr.fetchall()))

    for project_br in self.browse(cr, uid, ids, context=context):
        s = [0.0, 0.0, 0.0]
        tocompute = [project_br]
        while tocompute:
            p = tocompute.pop()
            tocompute += p.child_id
            for i in range(3):
                if progress.get(p.id, (0.0, 0.0, 0.0))[i]:
                    s[i] += progress.get(p.id, (0.0, 0.0, 0.0))[i]
        progress_rate = s[0]
        if progress_rate:
            progress_rate = s[2] and (100.0 * s[2] / s[0]) or 0.0
        res[project_br.id] = {
            'planned_hours': s[0],
            'effective_hours': s[2],
            'total_hours': (s[0] - s[1]) * -1 if (s[0] - s[1]) > -0.01 and (s[0]-s[1]) < 0 else (s[0]-s[1]),
            'progress_rate': progress_rate
        }
    return res


def _prjprj_get_datas(self, cr, uid, ids, fied_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    brw_project_br = self.browse(cr, uid, ids, context)
    for project in brw_project_br:
        res[project.id] = {'prjprj_data_atendimento_ultimo': False,
                           'prjprj_data_atendimento_proximo': False}
        brw_task_ultimo = filter(lambda i: i.date_start < time.strftime('%Y-%m-%d %H:%M:S'),
                                 project.tasks)
        if brw_task_ultimo:
            brw_task_ultimo = sorted(brw_task_ultimo, key=lambda i: i.date_start, reverse=True)
            res[project.id]['prjprj_data_atendimento_ultimo'] = brw_task_ultimo[0].date_start
        brw_task_proximo = filter(
            lambda i: i.data_inicio_previsto > time.strftime('%Y-%m-%d %H:%M:S'),
            project.tasks)
        if brw_task_proximo:
            brw_task_proximo = sorted(brw_task_proximo, key=lambda i: i.data_inicio_previsto)
            res[project.id][
                'prjprj_data_atendimento_proximo'] = brw_task_proximo[0].data_inicio_previsto
    return res


def _prjprj_get_hora(self, cr, uid, ids, names, arg, context=None):
    context = context and context.copy() or {}
    if isinstance(ids, (int, long)):
        ids = [ids]
    float_to_time = self.pool.get('adm.utils').admutl_float_to_time
    res = {}.fromkeys(ids, {}.fromkeys(['planned_hours', 'effective_hours'], 0.0))
    progress = {}
    if not ids:
        return res
    ids2 = self.search(cr, uid, [('parent_id', 'child_of', ids)], context=context)
    if ids2:
        str_ids = str(map(str, ids2)).replace('[', '(').replace(']', ')')
        sql = """
                SELECT project_br_id,
                       Sum(planned_hours),
                       Sum(effective_hours)
                FROM   project_br_task
                WHERE  state != 'cancelled'
                       AND project_br_id IN %s
                GROUP  BY project_br_id
                            """ % str_ids
        cr.execute(sql)
        progress = dict(map(lambda x: (x[0], (x[1], x[2])), cr.fetchall()))

    for project_br in self.browse(cr, uid, ids, context=context):
        s = [0.0, 0.0, 0.0]
        tocompute = [project_br]
        while tocompute:
            p = tocompute.pop()
            tocompute += p.child_id
            for i in range(2):
                if progress.get(p.id, (0.0, 0.0, 0.0))[i]:
                    s[i] += progress.get(p.id, (0.0, 0.0, 0.0))[i]
        res[project_br.id] = {
            'prjprj_hora_planejada_formatada': float_to_time(s[0]),
            'prjprj_hora_efetiva_formatada': float_to_time(s[1]),
        }
    return res


def _verifica_recursao(self, cr, uid, ids):
    """
    Metodo para Impedir o cadastramento de projetos recursivas
    """
    level = 100
    while len(ids):
        cr.execute("select distinct parent_id from project_br_project_br where id in (" + ','.join(map(str, ids)) + ')')
        ids = filter(None, map(lambda x:x[0], cr.fetchall()))
        if not level:
            return False
        level -= 1
    return True

#Funcoes da classe task
def _get_user(self, cr, uid, context): #Para ler o uid e o pessoa_id do usuario logado
    id = 0
    if context.get('mytask'):
        ids = self.pool.get('res.users').search(cr, uid, [('id', '=', uid)], context=context)
        id = self.pool.get('res.users').read(cr, uid, ids, ['pessoa_id'], context=context)[0]['pessoa_id'][0]
    return id

def _history_get(self, cr, uid, ids, name, args, context=None):
    context = context and context.copy() or {}
    result = {}
    for task in self.browse(cr, uid, ids, context=context):
        result[task.id] = self._str_get(task, border='===')
        t2 = task.parent_id
        level = 0
        while t2:
            level -= 1
            result[task.id] = self._str_get(t2, level) + result[task.id]
            t2 = t2.parent_id
        t3 = map(lambda x: (x, 1), task.child_ids)
        while t3:
            t2 = t3.pop(0)
            result[task.id] = result[task.id] + self._str_get(t2[0], t2[1])
            t3 += map(lambda x: (x, t2[1] + 1), t2[0].child_ids)
    return result


# Compute: effective_hours, total_hours, progress
def _hours_get(self, cr, uid, ids, field_names, args, context):
    task_set = ','.join(map(str, ids))
    cr.execute(("""
                    SELECT task_id,
                           Coalesce(Sum(hours), 0)
                    FROM   project_br_task_work
                    WHERE  task_id IN (%s)
                    GROUP  BY task_id """) % (task_set,))
    hours = dict(cr.fetchall())
    res = {}
    for task in self.browse(cr, uid, ids, context=context):
        res[task.id] = {}
        res[task.id]['effective_hours'] = hours.get(task.id, 0.0)
        total_hora = hours.get(task.id, 0.0)
        res[task.id]['total_hours'] = total_hora
        if total_hora:
            if task.planned_hours and hours.get(task.id, 0.0):
                res[task.id]['progress'] = round(min(100.0 * hours.get(task.id, 0.0) / task.planned_hours,
                                                 100), 2)
            elif not hours.get(task.id, 0.0):
                res[task.id]['progress'] = 0
            else:
                res[task.id]['progress'] = 100
        else:
            res[task.id]['progress'] = 0.0
        if task.state == 'done':
            res[task.id]['progress'] = 100.0
        res[task.id]['delay_hours'] = 0.0
        if total_hora > task.planned_hours:
            res[task.id]['delay_hours'] = total_hora - task.planned_hours
    return res

def _default_project_br(self, cr, uid, context=None):
    context = context and context.copy() or {}
    if context.get('project_br_id'):
        return context['project_br_id']
    return False

def _prjcal_get_tasks_cliente(self, cr, uid, ids, field_names, args, context=None):
    context = context and context.copy() or {}
    res = {}
    for id in ids:
        browse_task = self.browse(cr, uid, id)
        pessoa_id = browse_task.cliente_id.id
        consultor_id = browse_task.consultor_id.id
        data_inicio_previsto = browse_task.data_inicio_previsto
        data_fim_previsto = browse_task.data_fim_previsto
        sql = """
            select
                id
            from
                (select
                    min (id) as id,
                    min(create_uid) as create_uid,
                    min(create_date ) as create_date ,
                    date_trunc('hour',pt.data_inicio_previsto) as data_inicio_previsto ,
                    pt.pessoa_id as cliente_id,
                    pt.user_id as consultor_id,
                    sum(pt.planned_hours) as planned_hours
                from
                    project_br_task pt
                where
                    pt.data_inicio_previsto BETWEEN '%s' AND '%s' AND
                    pt.user_id = %s AND
                    pt.pessoa_id = %s
                group by
                    date_trunc('hour',pt.data_inicio_previsto),
                    pt.pessoa_id ,
                    pt.user_id
                ) a
        """ %(data_inicio_previsto, data_fim_previsto, consultor_id, pessoa_id)
        cr.execute(sql)
        task_ids = cr.fetchall()
        if task_ids:
            task_ids = map(lambda i: i[0], task_ids)
            res[id] = task_ids
    return res

def _prjcal_get_tasks_cliente(self, cr, uid, ids, field_names, args, context=None):
    context = context and context.copy() or {}
    res = {}
    for id in ids:
        browse_task = self.browse(cr, uid, id)
        pessoa_id = browse_task.cliente_id.id
        consultor_id = browse_task.consultor_id.id
        data_inicio_previsto = browse_task.data_inicio_previsto
        if consultor_id:
            sql = """
                select
                    id
                from
                    (select
                        id as id,
                        create_uid as create_uid,
                        create_date as create_date ,
                        date_trunc('hour',pt.data_inicio_previsto) as data_inicio_previsto ,
                        pt.pessoa_id as cliente_id,
                        pt.user_id as consultor_id,
                        sum(pt.planned_hours) as planned_hours
                    from
                        project_br_task pt
                    where
                        pt.data_inicio_previsto = '%s' AND
                        pt.user_id = %s AND
                        pt.pessoa_id = %s
                    group by
                        id,
                        date_trunc('hour',pt.data_inicio_previsto),
                        pt.pessoa_id ,
                        pt.user_id
                    ) a
            """ %(data_inicio_previsto, consultor_id, pessoa_id)
            cr.execute(sql)
            task_ids = cr.fetchall()
            if task_ids:
                task_ids = map(lambda i: i[0], task_ids)
                res[id] = task_ids
        else:
            res[id] = []
    return res
