# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from mx import DateTime
from mx.DateTime import now
import time
from openerp.tools.translate import _
import sys
from openerp.osv import fields, osv
from openerp.tools.translate import _

class project_br_work(osv.Model):

    from funcoes import _get_user

    _name = "project_br.task.work"
    _description = "Task Work"

    _columns = {
        'name': fields.char('Work summary', size=512),
        'date': fields.datetime('Date'),
        'task_id': fields.many2one('project_br.task', 'Task', ondelete='cascade', required=True),
        'hours': fields.float('Time Spent'),
        'user_id': fields.many2one('adm.pessoa', 'Done by', required=True, domain="[('pessoa_tipo','=','F')]"),
    }
    _defaults = {
        'user_id':_get_user,
        'date': lambda * a: time.strftime('%Y-%m-%d %H:%M:%S')
    }
    _order = "date desc"

