# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        title = center_title('', 45*' '+'Projetos a Faturar', '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='1')
        listagem.informaNome(pdf_string, 'Projetos a faturar')
        listagem.informaTamLinha(150)

        obj_project_br = pooler.get_pool(cr.dbname).get('project_br.project_br')
        obj_project_br_task = pooler.get_pool(cr.dbname).get('project_br.task')

        args = []
        pessoa_id = datas.get('pessoa_id')
        if pessoa_id and isinstance(pessoa_id, (list, tuple)):
            pessoa_id = pessoa_id[0]
        if pessoa_id:
            args.append(('pessoa_id', '=', pessoa_id),)
        projetos_concluidos = datas.get('projetos_concluidos')
        periodo_inicial = datas.get('periodo_inicial')
        if periodo_inicial and projetos_concluidos:
            args.append(('date_start', '>=', periodo_inicial),)
        periodo_final = datas.get('periodo_final')
        if periodo_final and projetos_concluidos:
            args.append(('date_start', '<=', periodo_final),)
        if projetos_concluidos:
            args.append(('state', '=', 'done'),)
        else:
            args_task = []
            periodo_inicial_task = periodo_final_task = False
            if periodo_inicial:
                periodo_inicial_task = periodo_inicial + ' 00:00:00'
                args_task.append(('date_close', '>=', periodo_inicial_task))
            if periodo_final:
                periodo_final_task = periodo_final + ' 23:59:59'
                args_task.append(('date_close', '<=', periodo_final_task))
            if pessoa_id:
                args_task.append(('pessoa_id', '=', pessoa_id))
            args_task.append(('prjtsk_a_faturar', '=', True))
            args_task.append(('state', '=', 'done'))
            task_ids = obj_project_br_task.search(cr, uid, args_task, context=context)
            args.append(('tasks', 'in', task_ids))
            args.append(('state', '!=', 'cancelled'),)
        args.append(('prjprj_faturar', '=', True),)

        project_br_ids = obj_project_br.search(cr, uid, args, context=context)

        if project_br_ids:
            browse_project_br = obj_project_br.browse(cr, uid, project_br_ids, context=context)

            company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid, context=context)
            res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
                cr, uid, company_id, ['name'], context=context)
            nome_empresa = res_company_dados.get('name')
            data = time.strftime("%d/%m/%Y")
            docs = center_title(data, 39*' ' + nome_empresa, 94*' '+'Pagina: {{ Page }} ')

            listagem.informaCab(''+title)
            listagem.informaCab('')
            listagem.informaCab('')
            listagem.informaCab(''+docs)
            listagem.informaCab('  ')
            listagem.informaCab('--')
            listagem.informaCab('ID' + 6 * ' ' +
                                'Projeto' + 47 * ' ' +
                                'Gerente do Projeto' + 13 * ' ' +
                                'Cliente' + 30 * ' ' +
                                'Tempo Planejado' + 4 * ' ' +
                                'Tempo Total' + 4 * ' ' +
                                'Estado' + 4 * ' ' +
                                'Data Inicio' + 4 * ' ' +
                                'Data Conclusao' + 4 * ' ' +
                                'Valor Total')
            listagem.informaCab('--')
            listagem.informaCab('  ')
            listagem.rodapePadrao()

            total_tempo_planejado = 0
            total_tempo_gasto = 0
            total_valor = 0
            float_to_time = pooler.get_pool(cr.dbname).get('adm.utils').admutl_float_to_time
            for x in browse_project_br:
                data_inicio = x.date_start or ''
                if data_inicio:
                    data_inicio = time.strftime('%d/%m/%Y', time.strptime(data_inicio, '%Y-%m-%d'))
                data_conclusao = x.data_conclusao or ''
                if data_conclusao:
                    data_conclusao = time.strftime('%d/%m/%Y', time.strptime(data_conclusao,
                                                                             '%Y-%m-%d'))
                tempo_gasto_tarefas = 0
                total_horas_planejadas = 0
                tempo_gasto_calculo_valor = 0
                brw_tasks = x.tasks
                if not projetos_concluidos:
                    if periodo_inicial_task and periodo_final_task:
                        brw_tasks = filter(
                            lambda i: periodo_inicial_task <= i.date_close <= periodo_final_task,
                            brw_tasks)
                    elif periodo_inicial_task and not periodo_final_task:
                        brw_tasks = filter(
                            lambda i: i.date_close >= periodo_inicial_task ,
                            brw_tasks)
                    elif  not periodo_inicial_task and periodo_final_task:
                        brw_tasks = filter(
                            lambda i: i.date_close <= periodo_final_task ,
                            brw_tasks)

                for i in brw_tasks:
                    if i.prjtsk_a_faturar and i.state == 'done':
                        tempo_gasto = i.effective_hours or 0
                        if 0 < tempo_gasto < 1 and i.prjtsk_considerar_tempo_minimo:
                            tempo_gasto = 1.0
                        tempo_gasto_calculo_valor += tempo_gasto
                        tempo_gasto_tarefas += i.effective_hours or 0
                        total_horas_planejadas += i.planned_hours or 0

                valor_hora = x.prjprj_valor_hora or 0
                valor_total = tempo_gasto_calculo_valor * valor_hora

                estado = x.state or ''
                if estado == 'template':
                    estado = 'Modelo'
                elif estado == 'open':
                    estado = 'Aberto'
                elif estado == 'pending':
                    estado = 'Pendente'
                elif estado == 'cancelled':
                    estado = 'Cancelado'
                elif estado == 'done':
                    estado = 'Concluido'

                linha = formataString(x.id or '', 7, ' ', 'D', 'N', 'S')
                linha += ' '
                linha += formataString(x.name or '', 53, ' ', 'D', 'N', 'S')
                linha += ' '
                linha += formataString(x.manager.name or '', 30, ' ', 'D', 'N', 'S')
                linha += ' '
                linha += formataString(x.pessoa_id.name or '', 43, ' ', 'D', 'N', 'S')
                linha += ' '
                linha += formataString(float_to_time(total_horas_planejadas), 15, ' ', 'D', 'N', 'S')
                linha += ' '
                linha += formataString(float_to_time(tempo_gasto_tarefas), 9, ' ', 'D', 'N', 'S')
                linha += ' '
                linha += formataString(estado, 11, ' ', 'D', 'N', 'S')
                linha += ' '
                linha += formataString(data_inicio, 15, ' ', 'D', 'N', 'S')
                linha += ' '
                linha += formataString(data_conclusao, 10, ' ', 'D', 'N', 'S')
                linha += ' '
                linha += formataString(getNumeroEditado(valor_total, 2), 16, ' ', 'E', 'N', 'S')
                linha += ' '
                listagem.imprimeLinha(' ')
                listagem.imprimeLinha(linha)
                total_tempo_planejado += total_horas_planejadas or 0
                total_tempo_gasto += tempo_gasto_tarefas or 0
                total_valor += valor_total
            listagem.imprimeLinha(' ')
            listagem.imprimeLinha(' ')
            linha = formataString('Total', 122, ' ', 'D', 'N', 'S')+''
            linha += ''
            linha += formataString(float_to_time(total_tempo_planejado), 19, ' ', 'E', 'N', 'S')+''
            linha += ''
            linha += formataString(float_to_time(total_tempo_gasto), 16, ' ', 'E', 'N', 'S')+''
            linha += ''
            linha += formataString(getNumeroEditado(total_valor, 2), 61, ' ', 'E', 'N', 'S')+''
            linha += ' '
            listagem.imprimeLinha(''+linha)
            listagem.imprimeLinha(' ')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

report_custom('report.listagem_projetos_a_faturar')
