# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################



from openerp import pooler
from datetime import time, timedelta
from time import strftime, strptime
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from SigUtils.datas import getDataDeHoje
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
from dateutil import parser
from openerp.tools.translate import _

fmt = "%d-%m-%Y %H:%M:%S"


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def achaDataFinal(diasUteis):
            from SigUtils import datas

            horasAgora = datas.getDataDeHoje('H').split(':')
            minutosAgora = (int(horasAgora[0]) * 60) + (int(horasAgora[1]))
            tempoRestanteHoje = 1080 - minutosAgora
            if tempoRestanteHoje < 0:
                tempoRestanteHoje = 0
            if tempoRestanteHoje != 0:
                tempoRestanteHoje = tempoRestanteHoje / 60 # tempo em horas
            tempoRestanteHoras = (diasUteis * 8) - tempoRestanteHoje
            dataHoje = datas.getDataDeHoje()
            dataFinal = datas.calcVencimentos(dataHoje, [1])[0]
            while True:
                a = datas.sigDatas(dataFinal)
                if not (a.dia3DaSemana in ('Sab', 'Dom')):
                    if tempoRestanteHoras < 8:
                        tempoRestanteHoras = 0
                    else:
                        tempoRestanteHoras -= 8
                dataFinal = datas.calcVencimento(dataFinal, 1)
                if tempoRestanteHoras == 0:
                    break
            return datas.sigDatas(dataFinal).getDataNoFormato('N', 'S')

        #-------------------------------------------------------------------------------
        context = context and context.copy() or {}
        # Formato de impressao dos dados: hora
        hora = 'h'
        # Transforma float em time (HH:MM:SS)
        float_to_time = pooler.get_pool(cr.dbname).get('adm.utils').admutl_float_to_time

        pdf_file = StringIO.StringIO()
        ids_tarefas = ids
        obj_tar = pooler.get_pool(cr.dbname).get('project_br.task')
        cab = 62 * '' + 'Tarefas por Projeto'
        visita_prevista = 0
        data_final = '          '
        if ids_tarefas:
            browse_tarefas = obj_tar.browse(cr, uid, ids_tarefas)
            projeto_ids = [x.project_br_id.id for x in browse_tarefas]
            projeto_ids = list(set(projeto_ids))
            if len(projeto_ids) == 1:
                projeto_name = browse_tarefas[0].project_br_id.name or ''
                codigo = browse_tarefas[0].project_br_id.id
                nome_projeto = str(codigo) + ' - ' + projeto_name
                visita_prevista = browse_tarefas[0].project_br_id.prjprj_quantidade_deslocamento
                date_end = browse_tarefas[0].project_br_id.date_end
                if date_end:
                    data_final = strftime('%d/%m/%Y', (strptime(date_end, '%Y-%m-%d')))
                cab = 70 * ' ' + 'Tarefas do Projeto  ' + nome_projeto
            else:
                cab = 85 * ' ' + 'Tarefas por Projeto'

        listagem = Impressora()
        listagem.defineFormato(orientacao='1')
        listagem.informaNome(pdf_file, 'Relatorio de Tarefas')
        listagem.informaTamLinha(160)
        listagem.defineFonte(tam=7.5)
        listagem.informaCab(cab)
        listagem.informaCab(' ')
        data = getDataDeHoje()
        listagem.informaCab('Emissao: ' + data + 200 * ' ' + 'Pag.' + '{{ Page }}')
        listagem.informaCab(' ')
        listagem.informaCab('--')
        cab = formataString('Tarefa ', 8, ' ', 'E', 'S', 'S')
        cab += formataString('Fat.', 6, ' ', 'E', 'S', 'S')
        cab += formataString('Sequ. ', 6, ' ', 'E', 'S', 'S')
        cab += formataString(' ', 1, ' ', 'E', 'S', 'S')
        cab += formataString('Sumario  ', 38, ' ', 'D', 'S', 'S')
        cab += formataString('Projeto', 37, ' ', 'D', 'S', 'S')
        cab += formataString('Data Inicio', 17, ' ', 'D', 'S', 'S')
        cab += formataString('Planejado ', 10, ' ', 'E', 'S', 'S')
        cab += formataString('Gasto', 8, ' ', 'E', 'S', 'S')
        cab += formataString(' A deduzir', 12, ' ', 'E', 'S', 'S')
        cab += formataString('Restante  ', 9, ' ', 'E', 'S', 'S')
        cab += formataString(' ', 1, ' ', 'E', 'S', 'S')
        cab += formataString('Atribuido ', 18, ' ', 'D', 'S', 'S')
        cab += formataString(' ', 1, ' ', 'E', 'S', 'S')
        cab += formataString('Estado', 14, ' ', 'D', 'S', 'S')
        listagem.informaCab(cab)
        listagem.informaCab('--')
        listagem.informaCab(' ')
        listagem.rodapePadrao()
        tot_plan = 0
        tot_gast = 0
        tot_ded = 0
        tot_gast_faturar = 0
        tot_dif = 0
        visita_planejada = []
        atendentes = {}
        for tar in obj_tar.browse(cr, uid, ids_tarefas):
            linha = ' '
            linha += formataString(tar.id, 7, ' ', 'E', 'N', 'S')
            linha += ' '
            if tar.prjtsk_a_faturar:
                tarefa_a_faturar = 'F '
                tot_gast_faturar += tar.effective_hours - tar.prjtsk_horas_a_deduzir
            else:
                tarefa_a_faturar = 'N '
            linha += formataString(tarefa_a_faturar, 6, ' ', 'E', 'N', 'S')

            linha += formataString(tar.sequence, 5, ' ', 'E', 'N', 'S')
            linha += ' '
            sumario1 = _(tar.name)
            linha += formataString(sumario1[:36], 37, ' ', 'D', 'N', 'S')
            sumario1 = sumario1[36:]
            linha += ' '

            linha += formataString(tar.project_br_id.name[:35], 36, ' ', 'D', 'N', 'S')
            linha += ' '
            if tar.date_start or tar.data_inicio_previsto:
                _dt = parser.parse(tar.date_start or tar.data_inicio_previsto)
                data_inicio = pooler.get_pool(cr.dbname).get(
                    'adm.utils').admutl_datetime_to_timezone(cr, uid, _dt)
            else:
                data_inicio = ' '
            linha += formataString(data_inicio[:-3], 16, ' ', 'D', 'N', 'S')
            linha += ' '

            linha += formataString(float_to_time(tar.planned_hours), 10, ' ', 'E',
                                   'N', 'S')
            linha += ' '
            linha += formataString(float_to_time(tar.effective_hours), 8, ' ', 'E',
                                   'N', 'S')
            linha += ' '
            linha += formataString(float_to_time(tar.prjtsk_horas_a_deduzir), 10, ' ', 'E',
                                   'N', 'S')
            linha += ' '
            linha += formataString(float_to_time(tar.remaining_hours), 8, ' ', 'E', 'N', 'S')
            linha += ' '
            tot_plan += tar.planned_hours
            tot_gast += tar.effective_hours
            tot_ded  += tar.prjtsk_horas_a_deduzir
            tot_dif += tar.remaining_hours
            if tar.prjtsk_deslocamento and len(data_inicio) >= 2:
                visita_planejada.append(int(data_inicio[:2]))
            if not tar.user_id.name:
                atri = ' '
            else:
                atri = tar.user_id.name
            if atendentes.get(atri):
                atendentes[atri]['tot_plan'] = atendentes[atri]['tot_plan'] + tar.planned_hours
                atendentes[atri]['tot_gast'] = atendentes[atri]['tot_gast'] + tar.effective_hours
                atendentes[atri]['tot_ded'] = atendentes[atri]['tot_ded'] + tar.prjtsk_horas_a_deduzir
                atendentes[atri]['tot_dif'] = atendentes[atri]['tot_dif'] + tar.delay_hours
            else:
                atendentes[atri] = {'tot_plan': tar.planned_hours, 'tot_gast': tar.effective_hours,
                                    'tot_dif': tar.delay_hours,'tot_ded':tar.prjtsk_horas_a_deduzir}
            lista = atri.split(' ')
            atendente = ''
            i = 0
            for x in lista:
                if x.lower() in ('de', 'do', 'da'):
                    continue
                if i < 2:
                    atendente += x + ' '
                i += 1
            linha += formataString(atendente, 18, ' ', 'D', 'N', 'S')
            linha += formataString(' ', 1, ' ', 'D', 'N', 'S')
            estado = ''
            if tar.state == 'draft':
                estado = 'Esboco'
            if tar.state == 'open':
                estado = 'Em progresso'
            if tar.state == 'pending':
                estado = 'Pendente'
            if tar.state == 'cancelled':
                estado = 'Cancelada'
            if tar.state == 'done':
                estado = 'Concluida'
            linha += formataString(estado, 14, ' ', 'D', 'N', 'S')
            linha += ' '
            listagem.imprimeLinha(linha)

            while sumario1:
                linha = ' ' * 21
                linha += formataString(sumario1[:36], 37, ' ', 'D', 'N', 'S')
                sumario1 = sumario1[36:]
                listagem.imprimeLinha(linha)


        listagem.imprimeLinha('--')
        linha = formataString('T o t a l', 113, ' ', 'D', 'N', 'S')
        linha += formataString(float_to_time(tot_plan), 10, ' ', 'E', 'N', 'S')
        linha += ' '
        linha += formataString(float_to_time(tot_gast), 8, ' ', 'E', 'N', 'S')
        linha += ' '
        linha += formataString(float_to_time(tot_ded), 10, ' ', 'E', 'N', 'S')
        linha += ' '
        linha += formataString(float_to_time(tot_dif), 8, ' ', 'E',  'N', 'S')
        linha += ' '
        listagem.imprimeLinha(linha)
        listagem.imprimeLinha('--')
        linha = 'Tempo planejado - Horas: '
        linha += formataString(float_to_time(tot_plan), 4, ' ', 'E', 'N', 'S')
        linha += '                      Termino Previsto: ' + data_final
        linha += '             Total gasto a faturar: '
        linha += formataString(float_to_time(tot_gast_faturar), 6, ' ', 'E', 'N', 'S')

        listagem.imprimeLinha(linha)
        linha = '                                               '
        linha += '   Visitas Previstas:'
        linha += formataString(visita_prevista, 4, ' ', 'E', 'N', 'S')
        linha += '                       Visitas Planejadas:'
        dias = len(list(set(visita_planejada))) if visita_planejada else 0
        linha += formataString(dias, 4, ' ', 'E', 'N', 'S')

        listagem.imprimeLinha(linha)
        listagem.imprimeLinha('--')
        linha = formataString(' ', 50, ' ', 'D', 'N', 'S')
        linha += formataString('C o n s u l t o r e s', 21, ' ', 'D', 'N', 'S')
        linha += formataString('H.Plan. ', 13, ' ', 'E', 'S', 'S')
        linha += formataString('H.Real. ', 10, ' ', 'E', 'S', 'S')
        linha += formataString('Difer.  ', 9, ' ', 'E', 'S', 'S')
        listagem.imprimeLinha(linha)
        for atend in atendentes:
            linha = formataString(' ', 50, ' ', 'D', 'N', 'S')
            lista = atend.split(' ')
            nome = ''
            i = 0
            for x in lista:
                if x.lower() in ('de', 'do', 'da'):
                    continue
                if i < 2:
                    nome += x + ' '
                i += 1
            linha += formataString(nome, 21, ' ', 'D', 'N', 'S')
            linha += formataString(float_to_time(atendentes[atend]['tot_plan']), 10, ' ',
                                   'E', 'N', 'S')
            linha += ' '
            linha += formataString(float_to_time(atendentes[atend]['tot_gast']), 9, ' ',
                                   'E', 'N', 'S')
            linha += ' '
            linha += formataString(float_to_time(atendentes[atend]['tot_dif']), 9, ' ',
                                   'E', 'N', 'S')
            qtd_ida_volta = 0

            for work in tar.work_ids:
                if work.rat_id.ratrat_deslocamento_ida:
                    qtd_ida_volta += 1
                if work.rat_id.ratrat_deslocamento_volta:
                    qtd_ida_volta += 1
            linha += ' '

            listagem.imprimeLinha(linha)
        listagem.imprimeLinha('--')
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_file.getvalue())
        self.obj.render()
        pdf_file.close()

        return self.obj.pdf, 'pdf'


report_custom('report.project_br.task')


# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

