# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2010 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################
from openerp.osv import fields, osv
from openerp.tools.translate import _
from openerp import tools
from openerp import pooler
import time
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from datetime import date
from datetime import timedelta
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO

class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'
    def _render(self):
        return self.pdf

class acompanhamento_projetos(osv.TransientModel):

    _name = "acompanhamento.projetos"
    _description = "acompanhamento.projetos"
    _columns = {
        'project_br_id': fields.many2one('project_br.project_br', 'Projeto'),
        'planned_hours': fields.float('Horas planejadas'),
        'effective_hours': fields.float('Horas gastas'),
        'delay_hours':fields.float('Horas excedidas'),
        'progress_rate': fields.float('Progresso'),
        'state': fields.selection([('template', 'Modelo'), ('open', 'Em Execucao'), ('pending', 'Pendente'), ('cancelled', 'Cancelado'), ('done', 'Concluido')], 'State'),
        'work_id':fields.many2one('acompanhamento.task.work','Acompanhamento task work'),
    }

acompanhamento_projetos()

class acompanhamento_task_work(osv.TransientModel):

    _name = "acompanhamento.task.work"
    _description = "acompanhamento.task.work"

    _columns = {
       'data': fields.date('Data', required=True),
       'projeto': fields.many2one('project_br.project_br', 'Projeto'),
       'acompanhamento_projeto_ids':fields.one2many('acompanhamento.projetos', 'work_id', 'Acompanhamento')
    }
    
    def pesquisar_acompanhamento(self,cr,uid,ids,context=None):
        context = context and context.copy() or {}
        wizard_acomp_task_dados = self.read(cr, uid, ids, ['data', 'projeto', 'acompanhamento_projeto_ids'], context=context)
        if isinstance(wizard_acomp_task_dados, list) and wizard_acomp_task_dados:
            wizard_acomp_task_dados = wizard_acomp_task_dados[0]
        if isinstance(wizard_acomp_task_dados, dict):
            wizard_id = wizard_acomp_task_dados['id']
            wizard_data = wizard_acomp_task_dados.get('data')
            wizard_projeto_id = wizard_acomp_task_dados.get('projeto') and wizard_acomp_task_dados['projeto'][0] or False
            wizard_acomp_project_ids = wizard_acomp_task_dados.get('acompanhamento_projeto_ids')

            obj_wizard_acomp_project=self.pool.get('acompanhamento.projetos')
            if wizard_acomp_project_ids:
                obj_wizard_acomp_project.unlink(cr, uid, wizard_acomp_project_ids, context)

            obj_project_br = self.pool.get('project_br.project_br')
            args = [('date_start', '<=', wizard_data)]
            if wizard_projeto_id:
                all_project_br_ids = obj_project_br.search(cr, uid, [('parent_id', 'child_of', wizard_projeto_id)], context=context)
                args.append(('id', 'in', all_project_br_ids))
            project_ids = obj_project_br.search(cr, uid, args, context=context)
            if not project_ids:
                raise osv.except_osv(('SigERP'), ('Nenhum projeto encontrado!'))
            else:

                project_dados = obj_project_br.read(cr, uid, project_ids, ['planned_hours', 'effective_hours', 'total_hours', 'progress_rate', 'state'], context=context)
                for i in project_dados:
                    project_id = i['id']
                    horas_planejadas = i.get('planned_hours') or 0
                    total_horas = i.get('total_hours') or 0
                    progress_rate = i.get('progress_rate') or 0
                    project_state = i.get('state')

                    delay_hours = total_horas - horas_planejadas
                    if delay_hours < 0:
                        delay_hours = 0

                    vals_project = {
                        'project_br_id': project_id,
                        'planned_hours': horas_planejadas,
                        'effective_hours': total_horas,
                        'delay_hours': delay_hours,
                        'progress_rate': progress_rate,
                        'work_id': wizard_id,
                        'state': project_state
                    }
                    obj_wizard_acomp_project.create(cr, uid, vals_project, context)
        return True
    
    def imprimir_acompanhamento(self,cr,uid,ids,context=None):
        context = context and context.copy() or {}
        obj_task=self.pool.get('acompanhamento.task.work')
        data={}
        dado= obj_task.read(cr,uid,ids[0],[], context=context)
        data['data'] = dado
        data['ids'] = ids
        return { 'type': 'ir.actions.report.xml',
                'report_name': 'acompanhamento.projetos',
                'datas':data
              }
        
    def limpar_acompanhamento(self,cr,uid,ids,context=None):
        context = context and context.copy() or {}
        obj_proj=self.pool.get('acompanhamento.projetos')
        self.write(cr, uid, ids, {'data':False,'projeto':False,'acompanhamento_projeto_ids':[]}, context)
        id_s = obj_proj.search(cr, uid, [], context=context)
        obj_proj.unlink(cr,uid,id_s)
        return True

acompanhamento_task_work()

class report_acompanhamento_projetos(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        context = context and context.copy() or {}
        obj_pro=pooler.get_pool(cr.dbname).get('acompanhamento.projetos')
        ids_pro= datas['data']['acompanhamento_projeto_ids']
        pdf_file=StringIO.StringIO()
        listagem=Impressora()
        listagem.informaNome(pdf_file,'Acompanhamento de Projetos')
        listagem.informaTamLinha(100)
        cab='                              Acompanhamento de Projetos                                       Pag.'+'{{ Page }}'
        listagem.informaCab(cab)
        listagem.informaCab(' ')
        data=str(datas['data']['data'])
        projeto_id = datas['data']['projeto'][0]
        proj= str(datas['data']['projeto'])
        if proj != 'False':
            nom_pro = pooler.get_pool(cr.dbname).get('project_br.project_br').read(cr,uid,projeto_id,['name'], context=context)['name']
            pro=' Projeto: '+nom_pro
        else:
            pro=' '
        da=time.strftime("%d/%m/%Y",time.strptime(data,"%Y-%m-%d"))
        listagem.informaCab('Selecao: Data - '+da+pro)
        listagem.informaCab(' ')
        listagem.informaCab('--')
        cab=formataString('Projeto', 35, ' ', 'D', 'S', 'S')
        cab+=formataString('Progresso  ',12, ' ', 'D', 'S', 'S')
        cab+=formataString('Hs. Planejadas', 16, ' ', 'D', 'S', 'S')
        cab+=formataString('Hs. Gastas', 14, ' ', 'D', 'S', 'S')
        cab+=formataString('Hs. Excedidas', 14, ' ', 'D', 'S', 'S')
        listagem.informaCab(cab)
        listagem.informaCab('--')
        listagem.rodapePadrao()
        for pro in obj_pro.browse(cr, uid, ids_pro):
            linha=formataString(pro.project_br_id.name, 34, ' ', 'D', 'N', 'S')
            linha+=' '
            linha+=formataString(getNumeroEditado(pro.progress_rate)+' %',11,' ','D','N','S')
            linha+=' '
            linha+=formataString(getNumeroEditado(pro.planned_hours,dec_point=':'), 15, ' ', 'D', 'N', 'S')
            linha+=' '
            linha+=formataString(getNumeroEditado(pro.effective_hours,dec_point=':'),13,' ','D','N','S')
            linha+=' '
            linha+=formataString(getNumeroEditado(pro.delay_hours,dec_point=':'),10,' ','d','N','S')
            linha+=' '
            listagem.imprimeLinha(linha)
        listagem.imprimeLinha('--')
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_file.getvalue())
        self.obj.render()
        pdf_file.close()
        return (self.obj.pdf, 'pdf')

report_acompanhamento_projetos('report.acompanhamento.projetos')
