# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.tools import email_send as email
from openerp import pooler
from openerp.osv import osv
from openerp.tools.translate import _
from openerp.osv import fields

def email_send(cr, uid, ids, destino, descricao, context=None):
    context = context and context.copy() or {}
    for task in pooler.get_pool(cr.dbname).get('project_br.task').browse(cr, uid, ids):
        subject = "Task '%s' closed" % task.name
        if task.user_id and task.user_id.id and task.user_id.email_ids:
            from_adr = task.user_id.email_ids[0].name

        else:
            raise osv.except_osv(_('Error'), _("Couldn't send mail because your email address is not configured!"))
        if destino:
            body = descricao
            ir_mail_server = pooler.get_pool(cr.dbname).get('ir.mail_server')
            msg = ir_mail_server.build_email(email_from=from_adr, # take config default
                    email_to=[destino],
                    subject=subject,
                    body = body)
            return ir_mail_server.send_email(cr, uid, msg, context=context)
        else:
            raise osv.except_osv(_('Error'), _("Couldn't send mail because the contact for this task (%s) has no email address!") % contact.name)

class wizard_close(osv.TransientModel):
    def _get_pessoa(self, cr, uid , context):
        task = pooler.get_pool(cr.dbname).get('project_br.task').browse(cr, uid, context['active_id'])
        pessoa_id = task.pessoa_id.id
        return pessoa_id

    _name = 'project_br.task.close'
    _description = 'Project task close'
    _columns = {
        'pessoa_id' : fields.many2one("adm.pessoa", 'Pessoa'),
        'email': fields.many2one('adm.pessoa.email', 'Emails', domain="[('pessoa_id', '=', pessoa_id)]"),
        'file': fields.text('Descricao'),
                }
    _defaults = {
        'pessoa_id': _get_pessoa,

    }

    def check_complete(self, cr, uid, data, context):
        if context['email'] == False and context['descricao']:
            raise osv.except_osv(_('Atencao'), _("Email vazio!"))
        if context['descricao'] == False and context['email']:
            raise osv.except_osv(_('Atencao'), _("Descricao vazia!"))
        if context:
            if isinstance(context, dict):
                ids = context['active_ids']
                task = pooler.get_pool(cr.dbname).get('project_br.task').browse(cr, uid, ids)[0]
                if task.project_br_id and task.project_br_id.warn_customer:
                    if context['email']:
                        self._data_send(cr, uid, data, context)
                return self._do_close(cr, uid, data, context)


    def _data_send(self, cr, uid, data, context):
        adm_pessoa_email_dados = pooler.get_pool(cr.dbname).get('adm.pessoa.email').read(cr, uid, context['email'], ['name'], context=context)
        email_send(cr, uid, context['active_ids'], adm_pessoa_email_dados['name'], context['descricao'])
        return {}

    def _do_close(self, cr, uid, data, context):
        task_obj = pooler.get_pool(cr.dbname).get('project_br.task')
        task_obj.do_close(cr, uid, context['active_id'], context)
        return {}

#    states = {
#        'init': {
#            'actions': [],
#            'result': {'type':'choice', 'next_state':_check_complete}
#        },
#        'mail_ask': {
#            'actions': [_get_data],
#            'result': {'type':'form', 'state':[('end', 'Cancel'), ('close', 'Quiet close'), ('mail_send', 'Send Message')]},
#        },
#        'mail_send': {
#            'actions': [_data_send],
#            'result': {'type':'state', 'state':'close'},
#        },
#    }
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
