# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields

class duplicacao_model_project_osv(osv.TransientModel):
    _name = 'duplicacao.model.project.osv'
    _description = 'Duplicacao Modelos de Projetos'
    _columns = {
        'wizduplic_cliente_id': fields.many2one('adm.pessoa', 'Cliente', domain="[('pessoa_tipo','=','J')]", required=True),
        'wizduplic_gerente_id': fields.many2one('adm.pessoa', 'Gerente do Projeto', domain="[('pessoa_tipo','=','F')]", required=True),
        'wizduplic_name': fields.char("Projeto", size=128, required=True),
    }

    def salvar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        duplicao_dados = self.read(cr, uid, ids, ['wizduplic_cliente_id', 'wizduplic_gerente_id', 'wizduplic_name'], context=context)
        if isinstance(duplicao_dados, list) and duplicao_dados:
            duplicao_dados = duplicao_dados[0]
        if isinstance(duplicao_dados, dict):
            company_id = duplicao_dados.get('wizduplic_cliente_id') and duplicao_dados['wizduplic_cliente_id'][0] or False
            gerente_id = duplicao_dados.get('wizduplic_gerente_id') and duplicao_dados['wizduplic_gerente_id'][0] or False
            project_name = duplicao_dados.get('wizduplic_name') or ''

            active_id = context.get('active_id')
            self.pool.get('project_br.project_br').duplicate_template(cr, uid, [active_id], company_id, gerente_id, project_name, context)
            return {'type': 'ir.actions.act_window_close'}
        return False