# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from openerp.osv import osv, fields

class project_br_duplicate_project(osv.TransientModel):
    _name = 'project_br.duplicate.project'
    _description = 'Duplicar Projeto'

    _columns = {
        'name': fields.char('Nome do Projeto', size=64, required=True),
        'pessoa_id': fields.many2one('adm.pessoa', 'Cliente', required=True),
    }
    
    def duplicate(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        projeto_id = context.get('active_id', False)
        pessoa_id = self.browse(cr, uid, ids[0]).pessoa_id.id
        name = self.browse(cr, uid, ids[0]).name
        obj_project = self.pool.get('project_br.project_br')
        obj_project.copy(cr, uid, projeto_id, {'name': name}, {'cliente_do_projeto': pessoa_id})
        return {'type': 'ir.actions.act_window_close'}
    
project_br_duplicate_project()
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: