# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _


class importacao_atividades_osv(osv.TransientModel):
    _name = 'importacao.atividades.osv'
    _description = 'Importacao de atividades de modelos de projetos'
    _columns = {
        'wizimport_modelo_projeto_id': fields.many2one('project_br.project_br', 'Modelos de projeto', domain="[('state','=','template')]", required=True)
    }
    def adicionar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not context.get('wizimport_modelo_projeto_id') or not context.get('self_id'):
            return
        if isinstance(context.get('wizimport_modelo_projeto_id'), list):
            context['wizimport_modelo_projeto_id'] = context.get('wizimport_modelo_projeto_id')[0]
        default = {}
        default['project_br_id'] = context.get('self_id')
        tasks_ids = self.pool.get('project_br.project_br').browse(cr, uid, context.get('wizimport_modelo_projeto_id')).tasks
        if not tasks_ids:
            raise osv.except_osv(_('Atencao'), _('O projeto nao possui atividades.'))
        lista_tasks_ids=[]
        for task in tasks_ids:
            _ids = self.pool.get('project_br.task').copy(cr, uid, task.id, default, context)
            lista_tasks_ids.append(_ids)
        pessoa_id = self.pool.get('project_br.project_br').browse(cr, uid, context.get('self_id')).pessoa_id.id
        self.pool.get('project_br.task').write(cr, uid, lista_tasks_ids, {'pessoa_id':pessoa_id}, context)