# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from openerp.tools import email_send as email
from openerp import pooler
from openerp.tools.translate import _
from openerp.osv import osv
from openerp.osv import fields

#ask_form = """<?xml version="1.0" ?>
#<form string="Delegate this task to a user">
#    <separator string="Delegated Task" colspan="4"/>
#    <field name="user_id" colspan="4"/>
#    <field name="planned_hours" colspan="4" widget="float_time"/>
#    <field name="name" colspan="4"/>
#    <field name="new_task_description"/>
#    <separator string="Validation Task" colspan="4"/>
#    <field name="planned_hours_me" colspan="4" widget="float_time"/>
#    <field name="prefix" colspan="4"/>
#    <field name="state" colspan="4"/>
#</form>"""

#ask_fields = {
#    'name': {'string': 'Delegated Title', 'type': 'char', 'required': True, 'size':64, 'help':"New title of the task delegated to the user."},
#    'prefix': {'string': 'Your Task Title', 'type': 'char', 'required': True, 'size':64, 'help':"New title of your own task to validate the work done."},
#    'user_id': {'string':'Assign To', 'type':'many2one', 'relation': 'adm.pessoa', 'required':True, 'help':"User you want to delegate this task to."},
#    'new_task_description': {'string':'New Task Description', 'type':'text', 'help':"Reinclude the description of the task in the task of the user."},
#    'planned_hours': {'string':'Planned Hours', 'type':'float', 'widget':'float_time', 'help':"Estimated time to close this task by the delegated user."},
#    'planned_hours_me': {'string':'Hours to Validate', 'type':'float', 'widget':'float_time', 'help':"Estimated time for you to validate the work done by the user to whom you delegate this task."},
#    'state': {'string':'Validation State', 'type':'selection', 'selection': [('pending','Pending'),('done','Done')], 'help':"New state of your own task. Pending will be reopened automatically when the delegated task is closed.", 'required':True},
#}

class wizard_delegate(osv.TransientModel):

    _name = 'project_br.task.delegate'
    _description = 'Project task delegate'

    def _get_name(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        task = self.pool.get('project_br.task.delegate').ask_auto_complete(cr, uid, ids, context)
        return task['name']
    def _get_prefix(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        task = self.pool.get('project_br.task.delegate').ask_auto_complete(cr, uid, ids, context)
        return task['prefix']
    def _get_user_id(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        task = self.pool.get('project_br.task.delegate').ask_auto_complete(cr, uid, ids, context)
        return task['user_id']
    def _get_new_task_description(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        task = self.pool.get('project_br.task.delegate').ask_auto_complete(cr, uid, ids, context)
        return task['new_task_description']
    def _get_planned_hours(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        task = self.pool.get('project_br.task.delegate').ask_auto_complete(cr, uid, ids, context)
        return task['planned_hours']
    def _get_planned_hours_me(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        task = self.pool.get('project_br.task.delegate').ask_auto_complete(cr, uid, ids, context)
        return task['planned_hours_me']
    def _get_state(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        task = self.pool.get('project_br.task.delegate').ask_auto_complete(cr, uid, ids, context)
        return task['state']

    _columns = {
        'name': fields.char('Titulo delegado', required=1, size=64, help="Novo titulo da tarefa delegada ao usuario." ),
        'prefix': fields.char('Seu titulo de Tarefas', required=1, size=64, help="Novo titulo de sua propria tarefa de validar o trabalho realizado."),
        'user_id': fields.many2one('adm.pessoa', 'Atribuir a', required=1, help="Usuario que deseja delegar essa tarefa a."),
        'new_task_description': fields.text('Nova descricao de tarefa', help="Reincluir a descricao da tarefa na tarefa do usuario"),
        'planned_hours': fields.float('Horas planejadas', help="Tempo estimado para fechar esta tarefa pelo usuario delegado."),
        'planned_hours_me': fields.float('Horas para validar', help="Tempo estimado para validar o trabalho feito pelo usuario para quem voce delegar essa tarefa."),
        'state': fields.selection([('pending', 'Pendente'), ('done', 'Concluido')], 'Estado validacao', required=1, help="Novo estado de sua propria tarefa. Pendente sera reaberto automaticamente quando a tarefa delegada estiver fechada."),
        }
    _defaults = {
        'name': _get_name,
        'prefix': _get_prefix,
        'user_id': _get_user_id,
        'new_task_description': _get_new_task_description,
        'planned_hours': _get_planned_hours,
        'planned_hours_me': _get_planned_hours_me,
        'state': _get_state,
        }

    def do_assign(self, cr, uid, ids, context):
        task_delegate = self.read(cr, uid, ids, context=context)
        if task_delegate and isinstance(task_delegate, list):
            task_delegate = task_delegate[0]

        task_obj = pooler.get_pool(cr.dbname).get('project_br.task')
#        task = task_obj.browse(cr, uid, data['id'], context)
        newname = task_delegate['prefix'] or ''
        task_obj.copy(cr, uid, context['active_id'], {
            'name': task_delegate['name'],
            'user_id': task_delegate['user_id'][0],
            'planned_hours': task_delegate['planned_hours'],
            'remaining_hours': task_delegate['planned_hours'],
            'parent_id': context['active_id'],
            'state': 'open',
            'description': task_delegate['new_task_description'] or '',
            'child_ids': [],
            'work_ids': []
        })
        task_obj.write(cr, uid, [context['active_id']], {
            'remaining_hours': task_delegate['planned_hours'],
            'name': newname
        }, context)
        if task_delegate['state']=='pending':
            task_obj.do_pending(cr, uid, [context['active_id']], context)
        else:
            task_obj.do_close(cr, uid, [context['active_id']], context)
        return {}

    def ask_auto_complete(self, cr, uid, data, context):
        task_obj = pooler.get_pool(cr.dbname).get('project_br.task')
        task = task_obj.browse(cr, uid, data['active_id'], context)
        if task.name.startswith(_('CHECK: ')):
            newname = task.name.strip(_('CHECK: '))
        else:
            newname = task.name or ''
        return {
            'name': newname,
            'user_id': False,
            'planned_hours': task.remaining_hours,
            'planned_hours_me': 1.0,
            'prefix': _('CHECK: ')+ newname,
            'new_task_description': task.description,
            'state': 'pending'
        }

#    states = {
#        'init': {
#            'actions': [_ask_auto_complete],
#            'result': {'type':'form', 'arch':ask_form, 'fields':ask_fields, 'state':[
#                ('end', 'Cancel'),
#                ('valid', 'Validate')
#            ]},
#        },
#        'valid': {
#            'actions': [_do_assign],
#            'result': {'type':'state', 'state':'end'},
#        }
#    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
