# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class project_br(osv.Model):

    _inherit = 'project_br.project_br'

    def prjprj_check_is_client(self, cr, uid, pessoa_id, context=None):
        """
        O metodo identifica se a pessoa informada e ou não um cliente.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param pessoa_id: id da tabela adm_pessoa.
        :type pessoa_id: int
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: Verdadeiro, caso 'pessoa_id' seja um cliente. Falso, caso 'pessoa_id' nao tenha
        sido informado ou se nao e um cliente.
        :rtype: bool
        """
        context = context and context.copy() or {}
        if not pessoa_id:
            return False
        cliente_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'financeiro.cliente', context=context)
        is_cliente = self.pool.get('financeiro.cliente').verificar_incluir_cliente(
            cr, uid, pessoa_id, cliente_company_id, 'verificar', context)
        if is_cliente:
            return True
        nome_pessoa = self.pool.get('adm.pessoa').browse(cr, uid, pessoa_id).nome
        raise osv.except_osv(_('Atencao'), _('%s nao e um cliente.' % nome_pessoa))

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        self.prjprj_check_is_client(cr, uid, vals.get('pessoa_id'), context)
        res = super(project_br, self).create(cr, uid, vals, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('pessoa_id'):
            self.prjprj_check_is_client(cr, uid, vals.get('pessoa_id'), context)
        res = super(project_br, self).write(cr, uid, ids, vals, context)
        return res
