# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoquepedidos_pedido_capa(osv.Model):
    _inherit = 'estoquepedidos.pedido.capa'

    def create(self, cr, uid, vals, context=None):
        res = super(estoquepedidos_pedido_capa, self).create(cr, uid, vals, context=context)
        if vals.get('pedcap_encomenda_id'):
            self.pool.get('rastreio.encomendas').write(cr, uid, vals.get('pedcap_encomenda_id'),
                                                       {'rasenc_pedido_id': res}, context=context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        if vals.has_key('pedcap_encomenda_id'): # Se tem, houve alteração
            _encomenda_nova_id = vals.get('pedcap_encomenda_id') or False
            if _encomenda_nova_id:
                for dados_pedido in self.read(cr, uid, ids, ['pedcap_encomenda_id'], context=context, load='_classic_write'):
                    _encomenda_anterior_id = dados_pedido.get('pedcap_encomenda_id')
                    if _encomenda_anterior_id and _encomenda_anterior_id != _encomenda_nova_id:
                        self.pool.get('rastreio.encomendas').unlink(cr, uid, _encomenda_anterior_id)
            if _encomenda_nova_id:
                for _id in ids:
                    self.pool.get('rastreio.encomendas').write(cr, uid, [_encomenda_nova_id],
                                                           {'rasenc_pedido_id': _id}, context=context)
        res = super(estoquepedidos_pedido_capa, self).write(cr, uid, ids, vals, context=context)
        return res

    def button_faturar_pedido(self, cr, uid, ids, context=None, destinatario_id=False, pedido_ids=[]):
        res = super(estoquepedidos_pedido_capa, self).button_faturar_pedido(cr, uid, ids, context=context,
                                                                            destinatario_id=destinatario_id,
                                                                            pedido_ids=pedido_ids)
        for _id in ids:
            sql = 'select pedcap_encomenda_id from estoquepedidos_pedido_capa where id = %s' % _id
            cr.execute(sql)
            dados_pedido = cr.fetchone()
            if dados_pedido:
                _encomenda_id = dados_pedido[0]
                sql = 'select distinct nf_id from fiscal_nf_pedidos where pedido_id = %s' % _id
                cr.execute(sql)
                _nf_ids = filter(None, map(lambda x:x[0], cr.fetchall()))
                if _nf_ids:
                    self.pool.get('fiscal.nf.capa').write(cr, uid, _nf_ids, {'fisnfc_encomenda_id': _encomenda_id},
                                                          context=context)
        return res



