# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class fiscal_nf_capa(osv.Model):
    _inherit = 'fiscal.nf.capa'

    def create(self, cr, uid, vals, context=None):
        res = super(fiscal_nf_capa, self).create(cr, uid, vals, context=context)
        if vals.get('fisnfc_encomenda_id'):
            context['super_write_fiscal_nf_capa'] = True
            self.pool.get('rastreio.encomendas').write(cr, uid, vals.get('fisnfc_encomenda_id'),
                                                       {'rasenc_nf_id': res}, context=context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        if vals.has_key('fisnfc_encomenda_id'): # Se tem, houve alteração
            _encomenda_nova_id = vals.get('fisnfc_encomenda_id') or False
            if _encomenda_nova_id and not context.get('faturar_diversos_pedidos'):
                for dados_pedido in self.read(cr, uid, ids, ['fisnfc_encomenda_id'], context=context, load='_classic_write'):
                    _encomenda_anterior_id = dados_pedido.get('fisnfc_encomenda_id')
                    if _encomenda_anterior_id:
                        self.pool.get('rastreio.encomendas').unlink(cr, uid, _encomenda_anterior_id)
            if _encomenda_nova_id:
                for _id in ids:
                    self.pool.get('rastreio.encomendas').write(cr, uid, _encomenda_nova_id,
                                                           {'rasenc_nf_id': _id}, context=context)
        res = super(fiscal_nf_capa, self).write(cr, uid, ids, vals, context=context)
        return res





