# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class rastreio_encomendas(osv.Model):
    """
        Tabela de encomendas.
    """
    # prefixo: rasenc_

    from funcoes import rasenc_get_dados_evento, raseve_get_encomendas, rasenc_get_dias

    _name = 'rastreio.encomendas'
    _columns = {
        'rasenc_pedido_id': fields.many2one('estoquepedidos.pedido.capa', 'Pedido', ondelete='cascade', select=True),
        'rasenc_nf_id': fields.many2one('fiscal.nf.capa', 'Nota', ondelete='cascade', select=True),
        'rasenc_pessoa_id': fields.many2one('adm.pessoa', 'Pessoa', ondelete='cascade'),
        'rasenc_destino': fields.char('Destino', size=33),
        'rasenc_compra_venda': fields.selection([('C', 'Compra'), ('V', 'Venda')], 'Compra/Venda'),
        'name': fields.char('Codigo rastreio', size=20, required=True, select=True),
        'rasenc_entregue': fields.boolean('Entregue'),
        'rasenc_evento_ids': fields.one2many('rastreio.eventos', 'raseve_encomenda_id', 'Eventos'),
        'rasenc_observacoes': fields.text('Observacoes'),
        'rasenc_pendente_visualizar': fields.boolean('Pendente visualizar'),
        'rasenc_atencao': fields.boolean('Encomenda marcada com atencao'),
        'rasenc_servicos_ids': fields.many2many('rastreio.servicos', 'rastreio_encomendas_m2m_servicos', 'encomenda_id',
            'servico_id', 'Servicos', required=True),
        # '':
        'rasenc_data_inicio': fields.function(rasenc_get_dados_evento, method=True, string='Dt.Inicio', type="date",
                                                      store={
                                                          'rastreio.eventos': (raseve_get_encomendas, [], 10)
                                                      }, multi=True),
        'rasenc_data_ultimo_evento': fields.function(rasenc_get_dados_evento, method=True, string='Dt.Ult.Mov.', type="date",
                                                      store={
                                                          'rastreio.eventos': (raseve_get_encomendas, [], 10)
                                                      }, multi=True),
        'rasenc_dias_desde_o_inicio': fields.function(rasenc_get_dias, method=True, string='Inicio Mov.', type="integer",
                                                      store=False, multi=True),
        'rasenc_dias_desde_o_ultimo': fields.function(rasenc_get_dias, method=True, string='Ultima Mov.', type="integer",
                                                      store=False, multi=True),
        'rasenc_ultimo_evento': fields.function(rasenc_get_dados_evento, method=True, string='Ultimo Evento.',
                                                      type="text",
                                                      store={
                                                          'rastreio.eventos': (raseve_get_encomendas, [], 10)
                                                      }, multi=True),

    }
    _defaults = {
        'rasenc_entregue': False,
        'rasenc_pendente_visualizar': True,
    }
