# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################
from SigUtils import datas


# funcoes da classe rastreio_encomendas
def rasenc_get_dias(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    data_hoje = datas.getDataDeHoje(formato="I")
    for brw_encomenda in self.browse(cr, uid, ids, context=context):
        diasI = datas.calcDiferenca(brw_encomenda.rasenc_data_inicio, data_hoje)
        diasU = datas.calcDiferenca(brw_encomenda.rasenc_data_ultimo_evento, data_hoje)
        vals = {
            'rasenc_dias_desde_o_inicio': diasI,
            'rasenc_dias_desde_o_ultimo': diasU,
        }
        res[brw_encomenda.id] = vals
    return res

def rasenc_get_dados_evento(self, cr, uid, ids, field_name, args, context=None):
    res = {}
    for _id in ids:
        data_inicial = False
        _sql = """
                select raseve_data_hora, rasenc_entregue, raseve_evento, raseve_observacao, raseve_situacao
                    from rastreio_eventos re
                    left join rastreio_encomendas  rc on rc.id = raseve_encomenda_id
                    where raseve_encomenda_id = %d 
                    order by raseve_data_hora""" % _id
        cr.execute(_sql)
        _data_ultimo_evento = 0
        _ultimo_evento = ''
        for dados in cr.dictfetchall():
            _data_evento = dados.get('raseve_data_hora')[:10]
            if not data_inicial:
                data_inicial = _data_evento
            _data_ultimo_evento = _data_evento
            _ultimo_evento = dados.get('raseve_observacao') if dados.get('raseve_observacao') else dados.get('raseve_situacao')
        vals = {
            'rasenc_data_inicio': data_inicial,
            'rasenc_data_ultimo_evento': _data_ultimo_evento,
            'rasenc_ultimo_evento': _ultimo_evento,
        }
        res[_id] = vals
    return res


# funcoes da classe rastreio_eventos
def raseve_get_encomendas(self, cr, uid, ids, context=None):
    list = []
    for evento in self.browse(cr, uid, ids, context=context):
        list.append(evento.raseve_encomenda_id.id)
    return list

