# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class rastreio_correios_parametro(osv.Model):
    _name = 'rastreio.correios.parametro'
    _rec_name = 'company_id'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'rascor_usuario': fields.char('Usuario Correios', size=20),  # codigo de usuario dos correios
        'rascor_senha': fields.char('Senha Correios', size=20),  # senha do usuario dos correios
        'rascor_cartao_postagem': fields.char('Cartao Postagem Correios', size=20),  # senha do usuario dos correios
        'rascor_codigo_acesso': fields.char('Codigo acesso Correios', size=50),
        'rascor_token': fields.text('Token Correios'),
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }
    _sql_constraints = [
        ('company_uniq', 'unique (company_id)', 'O parametro deve ser unico por empresa!')
    ]
