# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from SigUtils import datas


class wiz_rastreios(osv.TransientModel):

    def _get_cidades(self, cr, uid, context=None):
        context = context and context.copy() or {}
        if not context.get('compra_venda'):
            return [('', '')]
        _sql = "select distinct raseve_cidade from rastreio_eventos re left join rastreio_encomendas rd on rd.id = re.raseve_encomenda_id where rasenc_compra_venda = '%s'" % context.get('compra_venda')
        cr.execute(_sql)
        vals = [(x[0], x[0]) for x in cr.fetchall()]
        return vals

    def _get_situacao(self, cr, uid, context=None):
        context = context and context.copy() or {}
        if not context.get('compra_venda'):
            return [('', '')]
        _sql = "select distinct raseve_situacao from rastreio_eventos re left join rastreio_encomendas rd on rd.id = re.raseve_encomenda_id where rasenc_compra_venda = '%s'" % context.get('compra_venda')
        cr.execute(_sql)
        vals = [(x[0], x[0]) for x in cr.fetchall()]
        return vals

    _name = 'wiz.rastreio'
    _columns = {
        'wzras_sem_ver': fields.boolean('Nao visualizados'),
        'wzras_pendente': fields.boolean('Pendente entrega'),
        'wzras_atencao': fields.boolean('Encomenda marcada com atencao'),
        'wzras_data_inicio': fields.date('Data inicial'),
        'wzras_data_final': fields.date('Data final'),
        'wzras_cidade': fields.selection(_get_cidades, 'Cidade'),
        'wzras_situacao': fields.selection(_get_situacao, 'Situacao'),
        'wzras_texto': fields.text('Texto a pesquisar'),
        'wzras_encomenda': fields.char('Codigo para rastreio', size=20),
        'wzras_encomendas_ids': fields.one2many('wiz.rastreio.encomendas', 'wzrasen_capa_id', 'Encomendas'),
    }

    _defaults = {
        'wzras_sem_ver': True,
    }


    def wzras_marcar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        for brw_wizard in self.browse(cr, uid, ids, context=context):
            encomenda_ids = []
            for brw_encomenda in brw_wizard.wzras_encomendas_ids:
                encomenda_ids.append(brw_encomenda.wzrasen_encomenda_id.id)
            self.pool.get('rastreio.encomendas').write(cr, uid, encomenda_ids, {'rasenc_pendente_visualizar': False})
        return True

    def wzras_pesquisar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        sql = u'delete from wiz_rastreio_encomendas where wzrasen_capa_id in (%s)' % tuple(x for x in ids)
        cr.execute(sql)
        lista = []
        data_hoje = datas.getDataDeHoje(formato="I")

        for brw_wizard in self.browse(cr, uid, ids, context=context):
            sql = unicode("""
                select distinct raseve_encomenda_id, rasenc_data_inicio, rasenc_data_ultimo_evento
                    from rastreio_eventos rt
                    left join rastreio_encomendas rc on rc.id = rt.raseve_encomenda_id
            """)
            _where_and = u' where'
            if brw_wizard.wzras_encomenda:
                sql += _where_and + u" rc.name = '%s'" % brw_wizard.wzras_encomenda.upper()
            else:
                if brw_wizard.wzras_sem_ver:
                    sql += _where_and + u" rasenc_pendente_visualizar = True"
                    _where_and = u' and'
                if brw_wizard.wzras_atencao:
                    sql += _where_and + u" rasenc_atencao = True"
                    _where_and = u' and'
                if brw_wizard.wzras_pendente:
                    sql += _where_and + u" rasenc_entregue = False"
                    _where_and = u' and'
                if brw_wizard.wzras_data_inicio:
                    sql += _where_and + u" raseve_data_hora > '%s'" % (brw_wizard.wzras_data_inicio + u' 00:00:00')
                    _where_and = u' and'
                if brw_wizard.wzras_data_final:
                    sql += _where_and + u" raseve_data_hora < '%s'" % (brw_wizard.wzras_data_final + u' 23:59:59')
                    _where_and = u' and'
                if brw_wizard.wzras_cidade:
                    sql += _where_and + u" raseve_cidade = '%s'" % brw_wizard.wzras_cidade
                    _where_and = u' and'
                if brw_wizard.wzras_situacao:
                    sql += _where_and + u" raseve_situacao = '%s'" % brw_wizard.wzras_situacao
                    _where_and = u' and'
                if brw_wizard.wzras_texto:
                    sql += _where_and + u" raseve_observacao ilike '%" + brw_wizard.wzras_texto +"%'"
                    _where_and = u' and'
                if context.get('compra_venda'):
                    sql += _where_and + u" rasenc_compra_venda = '%s'" % context.get('compra_venda')
                    _where_and = u' and'
            cr.execute(sql)
            for dados in cr.fetchall():
                vals = {
                    'wzrasen_capa_id': brw_wizard.id,
                    'wzrasen_encomenda_id' : dados[0],
                    'wzrasen_dias_inicio' : datas.calcDiferenca(dados[1], data_hoje),
                    'wzrasen_dias_ultimo': datas.calcDiferenca(dados[2], data_hoje),
                }
                lista.append((0, 0, vals))
        self.write(cr, uid, ids, {'wzras_encomendas_ids': lista}, context=context)
        return True


    def wzras_button_rastrear(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.pool.get('rastreio.encomendas').rasenc_cron_rastrear(cr, uid, context=context)
        self.wzras_pesquisar(cr, uid, ids, context=context)
        return True


class wiz_rastreio_encomendas(osv.TransientModel):
    _name = 'wiz.rastreio.encomendas'
    _inherits = {
        'wiz.rastreio': 'wzrasen_capa_id',
        'rastreio.encomendas': 'wzrasen_encomenda_id'
    }
    _columns = {
        'wzrasen_capa_id': fields.many2one('wiz.rastreio', 'Capa', required=True, ondelete='cascade'),
        'wzrasen_encomenda_id': fields.many2one('rastreio.encomendas', 'Encomenda', required=True, ondelete='cascade'),
        'wzrasen_dias_inicio': fields.integer('Dias Inicio'),
        'wzrasen_dias_ultimo': fields.integer('Dias Ultimo'),
    }

    def wzrasen_marcar_um(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        for brw_wizard in self.browse(cr, uid, ids, context=context):
            encomenda_id = brw_wizard.wzrasen_encomenda_id.id
            self.pool.get('rastreio.encomendas').write(cr, uid, encomenda_id, {'rasenc_pendente_visualizar': False})
        return True
