# -*- encoding: utf-8 -*-
from openerp.osv import fields, osv
import time
from datetime import date


class rat_atividade(osv.Model):

    _name = 'rat.atividade'
    _inherit = 'rat.atividade'

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        rat_id = vals.get('rat_id') or 0
        rat_tempo = vals.get('tempo') or 0
        rat_descricao = vals.get('descricao') or ''
        rat_concluido = vals.get('concluido') or False
        rat_atividade_id = vals.get('atividade_id') or False
        user_treinamento_m2m = vals.get('user_treinamento_m2m_pessoa') or []

        taskw_name = 'Rat: %s - %s' % (rat_id, rat_descricao)
        taskw_user_id = False

        if rat_id:
            browse_rat = self.pool.get('rat.rat').browse(cr, uid, rat_id)
            taskw_user_id = browse_rat.user_id.pessoa_id.id

        if rat_concluido:
            taskw_realizacao = 100
        else:
            taskw_realizacao = 0

        vals_task_work = {
            'name': taskw_name,
            'date': time.strftime('%Y-%m-%d %H:%M:%S'),
            'hours': rat_tempo,
            'rat_id': rat_id,
            'task_id': rat_atividade_id,
            'user_id': taskw_user_id,
            'realizacao': taskw_realizacao,
        }

        task_work_id = self.pool.get('project_br.task.work').create(cr, uid, vals_task_work, context)

        vals['work_id'] = task_work_id

        if user_treinamento_m2m:
            for i in user_treinamento_m2m:
                usuario_ids = i[2]
                if usuario_ids:
                    vals['ratatv_relacionamento_id'] = usuario_ids[0]

        res = super(rat_atividade, self).create(cr, uid, vals, context)
        if rat_concluido:
            vals_task = {'state': 'done'}
            self.pool.get('project_br.task').do_close(cr, uid, [rat_atividade_id], context)
        else:
            self.pool.get('project_br.task').write(cr, uid, rat_atividade_id, {}, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('user_treinamento_m2m_pessoa'):
            user_treinamento_m2m = vals['user_treinamento_m2m_pessoa']
            for i in user_treinamento_m2m:
                usuario_ids = i[2]
                if usuario_ids:
                    vals['ratatv_relacionamento_id'] = usuario_ids[0]

        res = super(rat_atividade, self).write(cr, uid, ids, vals, context=context)
        dados_atividade = self.read(cr, uid, ids, ['work_id', 'concluido'], context=context,
                                    load='_classic_write')
        atividade_concluida = dados_atividade[0].get('concluido') if isinstance(
            dados_atividade, list) else dados_atividade.get('concluido')
        ids_task = []
        for id_task in dados_atividade:
            ids_task.append(id_task.get('work_id'))
        task_id = [self.read(cr, uid, ids, ['atividade_id'], context=context)[0]['atividade_id'][0]]
        vals_task_work = {}
        vals_task = {}
        if 'descricao' in vals:
            vals_task_work['name'] = vals['descricao']
        if 'tempo' in vals:
            vals_task_work['hours'] = vals['tempo']
        if vals.get('atividade_id'):
            vals_task_work['task_id'] = vals.get('atividade_id')
        if 'concluido' in vals or atividade_concluida:
            if vals.get('concluido') or atividade_concluida:
                vals_task_work['realizacao'] = 100
                vals_task = {'state':'done'}
                self.pool.get('project_br.task').do_close(cr, uid, task_id, context)
            else:
                vals_task_work['realizacao'] = 0
                vals_task = {'state':'open'}
        self.pool.get('project_br.task.work').write(cr, uid, ids_task, vals_task_work, context=context)
        self.pool.get('project_br.task').write(cr, uid, task_id, vals_task, context=context)

        return res

    def unlink(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        dados_rat_atividade = self.read(cr, uid, ids, ['work_id'], context=context, load='_classic_write')
        ids_task = map(lambda i: i.get('work_id'), dados_rat_atividade)
        res = super(rat_atividade, self).unlink(cr, uid, ids,context=context)
        self.pool.get('project_br.task.work').unlink(cr, uid, ids_task, context=context)
        return res
