# -*- encoding: utf-8 -*-

from openerp.osv import fields, osv
import time
from datetime import date,datetime
from openerp.tools.translate import _
from openerp.osv.fields import float_round


class rat_rat(osv.Model):

    _name = "rat.rat"
    _inherit = "rat.rat"

    def set_cancelar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': 'cancelled'}, context)
        self.log(cr, uid, ids[0], 'RAT Cancelado')
        return True

    def set_finalizar(self, cr, uid, ids, context=None):

        """
        Realiza a alteracao do estado do rat para 'Finalizado' ('done'), caso o rat possua
        atividades com usuario cadastrado.
        """

        context = context and context.copy() or {}
        vals = dict()
        vals['state'] = 'done'

        obj_rat_setores = self.pool.get('rat.setores')
        setor_ids = obj_rat_setores.search(cr, uid, [])
        if setor_ids:
            vals['ratrat_proximo_setor_id'] = min(map(lambda i: i.get('sequence'),
                                                      obj_rat_setores.read(cr, uid, setor_ids,
                                                                           ['sequence'])))

        obj_rat_atividade = self.pool.get('rat.atividade')
        id = ids
        if isinstance(ids,list):
            id = ids[0]
        dados_rat = self.read(cr, uid, id, ['data_fim', 'data_inicio', 'ratrat_tempo_atendimento'], context=context)
        vals['data_fim'] = dados_rat['data_fim']

        if not vals['data_fim']:
            vals['data_fim'] = str(date.today()) + ' ' + time.strftime('%H:%M:%S')

        cr.execute("SELECT rat_id, COALESCE(SUM(tempo),0)"
                   " FROM rat_atividade WHERE rat_id IN %s GROUP BY rat_id", (tuple(ids),))
        tempo = dict(cr.fetchall())
        soma_atividade = round(tempo.get(id, 0.0), 2)
        diff = soma_atividade - dados_rat['ratrat_tempo_atendimento']
        if diff > 0.17:#Se a diferenca for maior que 10minutos, neste caso esta como float
            context.update({'ultrapassa_minutos_permitidos':True})

        if float_round(dados_rat.get('ratrat_tempo_atendimento'), 5) != float_round(
                soma_atividade, 5):
            context.update({'horas_divergentes': dados_rat['ratrat_tempo_atendimento']})
        rat_atividade_ids = obj_rat_atividade.search(cr, uid, [("rat_id", "in", ids)], context=context)
        if not rat_atividade_ids:
            raise osv.except_osv(_('Atencao'), _('Rat sem tarefa cadastrada'))
        dados_rat_atividade = obj_rat_atividade.read(cr, uid, rat_atividade_ids,
                                                     ["atividade_id", "user_treinamento_m2m_pessoa"], context=context)
        for atividade in dados_rat_atividade:
            if not atividade['user_treinamento_m2m_pessoa']:
                raise osv.except_osv(_('Atencao'), _('Tarefa: %s sem usuario cadastrado'
                                                     % atividade['atividade_id'][1]))
        brw_rat_atividade = obj_rat_atividade.browse(cr, uid, rat_atividade_ids, context=context)
        atividade_concluida = map(lambda i: i.concluido, brw_rat_atividade)
        if not all(atividade_concluida):
            context.update({'atividades_nao_concluidas': '* Existem atividades que nao foram '
                                                         'concluidas, confirma o fechamento do '
                                                         'RAT?'})
        if (context.get('atividades_nao_concluidas') or context.get('horas_divergentes'))\
                and not context.get('confirma'):
            obj_model_data = self.pool.get('ir.model.data')
            reference = obj_model_data.get_object_reference(cr, uid, 'rat',
                                                            'wizard_confirmar_finalizacao_rat_view')
            view_id = reference and reference[1] or False
            return {'name': '',
                    'view_type': 'form',
                    'view_mode': 'form',
                    'res_model': 'rat.rat',
                    'view_id': [view_id],
                    'context': context,
                    'target': 'new',
                    'type': 'ir.actions.act_window',
                    }
        self.write(cr, uid, ids, vals, context)
        self.log(cr, uid, ids[0], 'RAT Finalizado')
        return True

    def ratrat_reabrir_rat(self, cr, uid, ids, context=None):

        """
              Reabre o RAT ja concluído
            :param cr:
            :param uid:
            :param ids:
            :param context:
            :return: True
            """
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'state': 'draft'}, context)
        self.log(cr, uid, ids[0], 'RAT reaberto.')
        return True

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if context.get('active_id'):
            res = context.get('active_id')
        else:
            res = super(rat_rat, self).create(cr, uid, vals, context)
        return res

    def write(self, cr, user, ids, vals, context=None):
        context = context and context.copy() or {}
        val = self.read(cr, user, ids[0], context=context)
        if not vals.get('ratrat_deslocamento_volta_tempo') and val['state'] != 'draft':
            if vals:
                if 'state' not in vals and not 'tramitacao' in context:
                    raise osv.except_osv('SigERP', 'O RAT so pode ser alterado quando estiver em Esboco.')
        if 'state' in vals:
            if not val['data_fim'] and vals['state'] == 'done':
                val['data_fim'] = str(date.today()) + ' ' + time.strftime('%H:%M:%S')
#               raise osv.except_osv('SigERP', 'O horário final nao foi informado.')
        res = super(rat_rat, self).write(cr, user, ids, vals, context=context)
        return res

    def fields_view_get(self, cr, user, view_id=None, view_type='form', context=None, toolbar=False, submenu=False):
        res = super(rat_rat, self).fields_view_get(cr, user, view_id, view_type, context, toolbar, submenu)
        context = context and context.copy() or {}
        atividades_nao_concluidas = context['atividades_nao_concluidas']\
            if context.get('atividades_nao_concluidas') else ' '
        if context.get('horas_divergentes') and not context.get('ultrapassa_minutos_permitidos'):
            res['arch'] = '''
                     <form string="Confirmar finalizacao" version="7.0">
                    <header>
                    <button name="set_finalizar" string="Confirma" type="object"
                    context="{'confirma': True}" icon="gtk-apply"/>
                    <button special="cancel" string="Cancelar" icon="gtk-cancel"/>
                    </header>
                    <newline/>
                    <label string="* Atencao: Total de horas divergentes !
                     %s "
                  />

                    </form>
                    ''' % atividades_nao_concluidas + '  '
        elif context.get('ultrapassa_minutos_permitidos'):
            res['arch'] = '''
                     <form string="Confirmar finalizacao" version="7.0">
                    <header>
                    <button special="cancel" string="Cancelar" icon="gtk-cancel"/>
                    </header>
                    <newline/>
                    <label string="* Atencao: Total de horas divergentes ultrapassam 10 minutos de
                     diferenca nao sera permitido finalizar."

                  />

                    </form>
                    '''

        return res

    def retorna_report(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        datas = {}
        datas = {
            'ids': ids,
            'model': 'rat.rat',
            'form': {}
        }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'rat.rat',
            'datas': datas,
        }

    def check_report(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return self.retorna_report(cr, uid, ids, context)

    def ratrat_onchange_consultor(self, cr, uid, ids, user_id, context=None):
        context = context and context.copy() or {}
        res = {}
        if not user_id:
            return res
        pessoa_id = self.pool.get('res.users').browse(cr, uid, user_id, context).pessoa_id.id
        if not pessoa_id:
            return res
        res['value'] = {'ratrat_pessoa_responsavel_id': pessoa_id}
        return res

    def onchange_cliente_rat(self, cr, uid, ids, cliente_id, context=None):
        context = context and context.copy() or {}
        res = {}
        if cliente_id:
            res['value'] = {'ratrat_resp_id': False}
        return res

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}

        if context.get("tramitacao"):
            setor_usuario_ids = self.pool.get("rat.setor.usuarios").get_setor_usuario_ids(cr, uid, context)
            args.append(('ratrat_proximo_setor_id', 'in', setor_usuario_ids))

        res = super(rat_rat, self).search(cr, uid, args, offset, limit, order, context, count)

        return res

    def set_avancar_setor(self, cr, uid, ids, context=None):
        """
        O metodo disponibiliza o rat para os usuarios que pertencem ao proximo setor da sequencia.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: Verdadeiro, caso o rat seja atualizado para o proximo setor. Senao, Falso.
        :rtype: bool
        """
        context = context and context.copy() or {}

        res = False

        if not context.get('confirma_avanco_setor'):
            reference = self.pool.get('ir.model.data').get_object_reference(
                cr, uid, 'rat', 'wizard_confirma_avanco_setor_form')
            view_id = reference and reference[1] or False
            return {'name': '',
                    'view_type': 'form',
                    'view_mode': 'form',
                    'res_model': 'wizard.confirma.avanco.setor',
                    'view_id': [view_id],
                    'context': context,
                    'target': 'new',
                    'type': 'ir.actions.act_window',
                    }

        proximo_setor_id = self.read(cr, uid, ids, ['ratrat_proximo_setor_id'])

        if isinstance(proximo_setor_id, list):
            proximo_setor_id = proximo_setor_id[0].get('ratrat_proximo_setor_id')
        else:
            proximo_setor_id = proximo_setor_id.get('ratrat_proximo_setor_id')

        setor_atual = proximo_setor_id[0] if proximo_setor_id else False
        obj_rat_setores = self.pool.get('rat.setores')

        setor_ids = obj_rat_setores.search(cr, uid, [], context=context, order='sequence')

        if setor_atual and setor_ids and len(setor_ids) > 1:
            vals = {}

            for setor in setor_ids:
                index = setor_ids.index(setor)

                if setor_ids[index] == setor_ids[-1]:
                    vals = {'ratrat_proximo_setor_id': None}

                elif setor == setor_atual:
                    vals = {'ratrat_proximo_setor_id': setor_ids[index + 1]}
                    break

            res = self.write(cr, uid, ids, vals, context)

        return res

    def set_destramitar(self, cr, user, ids, context=None):
        """
        Retorno da tramitacao. O setor volta a ser o primeiro na ordem de tramitacao
        :param cr: a linha atual do cursor do banco de dados
        :param user: o ID do usuario utilizado para a verificacao de perfil
        :param ids: IDs dos itens de expedicao
        :param context: um dicionario padrao para valores contextuais
        :type cr: object
        :type user: int
        :type ids: list
        :type context: dict
        :return: verdadeiro se a destramitacao foi efetuada
        :rtype: bool
        
        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """
        context = context and context.copy() or dict()

        # Recupera as tramitacoes do RAT
        obj_rat_setor_historicos = self.pool.get('rat.setor.historicos')
        tramitacao_ids = obj_rat_setor_historicos.search(
            cr, user, [('ratseh_rat_id', 'in', ids)], context=context)

        # Recupera os setores para remover as tramitacoes conservando o setor cuja tramitacao eh a
        # de menor sequencia (primeiro setor)
        tramitacao_dados = tramitacao_ids and obj_rat_setor_historicos.read(
            cr, user, tramitacao_ids, ['ratseh_setor_id'], context, '_classic_write')
        obj_rat_setores = self.pool.get('rat.setores')
        setor_ids = tramitacao_dados and obj_rat_setores.search(
            cr, user, [('id', 'in', map(lambda m: m.get('ratseh_setor_id'), tramitacao_dados))],
            order='sequence', context=context)
        primeiro_setor_id = setor_ids and setor_ids[0]
        tramitacao_primeiro_setor_ids = \
            primeiro_setor_id and obj_rat_setor_historicos.search(
                cr, user, [('ratseh_rat_id', 'in', ids),
                           ('ratseh_setor_id', '=', primeiro_setor_id)], context=context)
        tramitacao_demais_setores_ids = obj_rat_setor_historicos.search(
                cr, user, [('ratseh_rat_id', 'in', ids),
                           ('ratseh_setor_id', '!=', primeiro_setor_id)], context=context)
        obj_rat_setor_historicos.unlink(
            cr, user, tramitacao_demais_setores_ids, context)

        # Ao conservar o primeiro setor da tramitacao, altera sua observacao
        obj_rat_setor_historicos.write(
            cr, user, tramitacao_primeiro_setor_ids and tramitacao_primeiro_setor_ids[0],
            dict(ratseh_observacoes=_('Destramitacao.')))
        if tramitacao_primeiro_setor_ids:
            sequence = obj_rat_setor_historicos.browse(cr, user, tramitacao_primeiro_setor_ids[0],
                                                       context).ratseh_setor_id.sequence
            setor_ids = obj_rat_setores.search(cr, user, [('sequence', '>', sequence)], limit=1,
                                               order='sequence')
            if setor_ids:
                self.write(cr, user, ids, {'ratrat_proximo_setor_id': setor_ids[0]}, context)

        return True

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

