#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv


class rat_setor_usuarios(osv.Model):
    _name = "rat.setor.usuarios"
    _inherit = "rat.setor.usuarios"

    def get_setor_usuario_ids(self, cr, user_id, context=None):
        """
        Metodo que retorna os ids dos setores em que o usuario passado pelo parametro "user_id",
        esta cadastrado.

        :param cr: linha atual do cursor do banco de dados
        :param user_id: id do usuario
        :param context: dicionario padrao para valores contextuais
        :type cr: object
        :type user_id: int
        :type context: dict
        :return: lista de ids de setores
        :rtype: list
        """

        context = context and context.copy() or {}

        setor_user_ids = self.search(cr, user_id, [('ratsus_user_id', '=', user_id)])

        setor_ids = self.read(cr, user_id, setor_user_ids, ['ratsus_setor_id'],
                              context=context, load="_classic_write")

        setor_ids = map(lambda i: i.get('ratsus_setor_id'), setor_ids)

        return setor_ids
