# -*- encoding: utf-8 -*-
from openerp.osv import fields, osv


class rat_atividade(osv.Model):
    # prefixo: ratatv_

    _name = 'rat.atividade'
    _rec_name = 'descricao'
    _inherits = {
        'rat.rat': 'rat_id',
    }
    _columns = {
        'rat_id': fields.many2one('rat.rat', 'atividade rat', ondelete="cascade", required=True,
                                  select=True),
        'atividade_id': fields.many2one('project_br.task', 'Atividade', ondelete='cascade',
                                        required=True),
        'tempo': fields.float('Tempo', required=True, digits=(10, 5)),
        'descricao': fields.char('Observacao', size=448),
        'concluido': fields.boolean('Concluido'),
        # 'user_treinamento': fields.many2many('adm.pessoa', 'usuario_treinamento_rel',
        #                                      'rat', 'relacionamento', "Usuario Treinamento",
        #                                      ),
        'user_treinamento_m2m_pessoa': fields.many2many('adm.pessoa', 'rat_usuario_treinamento_rel',
                                             'rat', 'relacionamento', "Usuario Treinamento",
                                             ),
        'ratatv_relacionamento_id': fields.many2one('adm.pessoa', 'Usuario',
                                        context="{'contatos_de': cliente_id}", ondelete="restrict"),
        'work_id': fields.many2one('project_br.task.work',
                                   'Nro da Atividade na Atividade do Projeto', required=True),
        'ratatv_atividades_tecnicas': fields.text('Informacoes Tecnicas',
                                                help="Anotacoes tecnicas decorrentes da atividade"),
    }
