# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from datetime import datetime


#Funcoes da classe rat_atividade
def _calcula_tempo_atendimento(self, cr, uid, ids, name, arg, context=None):

    '''Calcula o tempo total do atendimento do RAT Eletronico '''
    context = context and context.copy() or {}
    res = {}

    for rat in self.browse(cr, uid, ids, context=context):
        if rat.data_fim:
            total_atendimento_data = datetime.strptime(rat.data_fim, "%Y-%m-%d %H:%M:%S") - \
                                     datetime.strptime(rat.data_inicio, "%Y-%m-%d %H:%M:%S")

            total_atendimento_data = round(total_atendimento_data.days * 24 + \
                                       (float(total_atendimento_data.seconds) / 3600), 5)

            res[rat.id] = total_atendimento_data
    return res


# Funcoes da classe rat_rat
def _ratrat_get_pessoa_responsavel_atividade(self, cr, uid, ids, field_name, args, context=None):

    """
    Busca o id da pessoa (adm_pessoa) responsavel pelo atendimento da atividade
    """

    context = context and context.copy() or {}
    res = {}
    brw_rat_rat = self.browse(cr, uid, ids, context)
    for rat in brw_rat_rat:
        pessoa_id = rat.user_id.pessoa_id.id
        if pessoa_id:
            res[rat.id] = pessoa_id
        else:
            res[rat.id] = False
    return res


# Funcoes da classe rat_setores
def get_sequence(self, cr, uid, context=None):
    context = context and context.copy() or {}

    setor_ids = self.search(cr, uid, [], context=context)
    sequences = self.read(cr, uid, setor_ids, ['sequence'], context=context)
    if not sequences:
        return 1

    return max(map(lambda i: i.get('sequence'), sequences)) + 1
