# -*- encoding: utf-8 -*-
from openerp.osv import fields, osv
import time
from datetime import date


class rat_rat(osv.Model):
    _name = "rat.rat"
    _rec_name = 'id'

    from funcoes import _calcula_tempo_atendimento
    from funcoes import _ratrat_get_pessoa_responsavel_atividade

    _columns = {
        'id': fields.integer('Nro Rat'),
        'create_date': fields.datetime('Data'),
        'create_uid': fields.many2one("res.users", 'Usuario', ondelete="restrict", select=True),
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", readonly=True), # Id da empresa
        'data_inicio': fields.datetime('Data de Inicio', required=True),
        'data_fim': fields.datetime('Data de Termino'),
        'cliente_id': fields.many2one("adm.pessoa", 'Cliente', ondelete="restrict", required=True, select=True), # Id da pessoa para que está sendo feito o orcamento
        'user_id': fields.many2one('res.users', 'Consultor', ondelete="restrict", required=True),
        'descricao': fields.text('Observacao'),
        'state': fields.selection([('draft', 'Esboco'), ('cancelled', 'Cancelado'), ('done', 'Finalizado')], 'Status', readonly=True, required=True),
        'ratrat_resp_id': fields.many2one('adm.pessoa', 'Usuario',  context="{'contatos_de': cliente_id}", ondelete="restrict", required=True),
        'atividade_rat_ids': fields.one2many('rat.atividade', 'rat_id', 'Atividades'),
        'ratrat_deslocamento_ida': fields.boolean('Ida'),
        'ratrat_deslocamento_volta': fields.boolean('Volta'),
        'ratrat_deslocamento_ida_tempo': fields.float('Tempo Deslocamento ida', digits=(5,2)),
        'ratrat_deslocamento_volta_tempo': fields.float('Tempo Deslocamento volta', digits=(5,2)),
        'rat_work_ids': fields.one2many('project_br.task.work', 'rat_id', 'Works'),
        'ratrat_tempo_atendimento': fields.function(_calcula_tempo_atendimento, type='float',
                                                    method=True, string='Total tempo atendimento',
                                                    store=True, digits=(10, 5)),
        'ratrat_pessoa_responsavel_id': fields.function(_ratrat_get_pessoa_responsavel_atividade,
                                                        method=True, string='Atribuido para',
                                                        type='many2one', relation='adm.pessoa',
                                                        store=False),
        #  pessoa_id responsavel pela realizacao da atividade

        "ratrat_setor_historico_ids": fields.one2many("rat.setor.historicos", "ratseh_rat_id",
                                                      "Historicos"),
        "ratrat_proximo_setor_id": fields.many2one("rat.setores", "Proximo setor", ondelete="restrict")
    }
    _order = 'id desc'
    _defaults = {
                 'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
                 'data_inicio': lambda * a: time.strftime('%Y-%m-%d %H:%M:%S'),
                 'state': lambda * a: 'draft',
                 'user_id' : lambda obj, cr, uid, context: uid}

