# -*- encoding: utf-8 -*-

import time
from openerp.report import report_sxw
from openerp.tools.translate import _


class rel_rat(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(rel_rat, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({'time': time,
                                  'fltime': self.floattotime,
                                  'calc_tempo': self.calcular_tempo,
                                  'str_convert': self.string_convert,
                                  'formatar_nome_projeto': self.formatar_nome_projeto,
                                  'remover_acentuacao': self.pool.get('adm.utils').admutl_remover_acentuacao})
        self.context = context

    def string_convert(self, strg):
        if strg == 'Duracao':
            strg = _('Duracao')
        elif strg == 'Observacao':
            strg = _('Observacao')
        elif strg == 'Descricao':
            strg = _('Descricao')
        elif strg == 'Endereco':
            strg = _('Endereco')
        return strg

    def floattotime(self, data):
        horas = int(data)
        minutos = abs(int((data - horas) * 60 * 100) / 100.0)
        return '%.2d:%.2d' % (horas, round(minutos, 1))

    def calcular_tempo(self, data, tipo_ret=0):

        sum_duracao = 0.00
        sum_prev = 0.00

        for atividade in data:
            sum_duracao += atividade.tempo
            sum_prev += atividade.atividade_id.planned_hours
        sum_dif = sum_prev - sum_duracao
        if tipo_ret == 0:
            res = self.floattotime(sum_duracao)
        elif tipo_ret == 1:
            res = self.floattotime(sum_prev)
        else:
            res = self.floattotime(sum_dif)

        return res

    def formatar_nome_projeto(self, projeto_id=None, descricao=None):
        """
        Deve passar como parâmetro somente projeto_id ou somente descricao.

        @param projeto_id: Id do projeto.
        @param descricao: Qualquer string que deseja remover acentuação.

        @return: Se informar projeto_id, retorna o nome do projeto para aquele id.
                 Se informar descricao, formata o nome informado, removendo acentuação.
        """
        obj_adm_utils = self.pool.get('adm.utils')
        if not descricao:
            descricao = ''
        if projeto_id and not descricao:
            descricao = projeto_id.complete_name
        res = obj_adm_utils.admutl_remover_acentuacao(None, None, text=descricao)
        return res


report_sxw.report_sxw('report.rat.rat', 'rat.rat', 'addons/rat/report/rel_rat.rml', parser=rel_rat,
                      header=False)
