# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class recebimento_divergencia_itens(osv.Model):
    """
    Relacionamento entre Recebimento e Notas Fiscais divergentes.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'recebimento.divergencia.itens'  # recdit
    _inherit = 'recebimento.divergencia.itens'  # recebimento/model/divergencia_itens_data

    _columns = {
        # ___________________________ Many2One _______________________________
        'divergencia_nf_id': fields.many2one('recebimento.divergencia.nf', 'Divergencias')

    }


class recebimento_divergencia_nf(osv.Model):
    """
    Relacionamento entre Notas Fiscais divergentes e Recebimento.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'recebimento.divergencia.nf'  # recdnf
    _inherit = 'recebimento.divergencia.nf'  # recebimento/model/divergencia_nf_data

    _columns = {
        # ___________________________ One2Many _______________________________
        'divergencia_item_ids': fields.one2many('recebimento.divergencia.itens',
                                                'divergencia_nf_id',
                                                'Item de divergencia')
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

