# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class estoque_parametro(osv.Model):
    """
    Parametro de verificacao da data de validade (Produto x Picking) para
    realizar reposicao.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'estoque.parametro'  # estpar
    _inherit = 'estoque.parametro'  # estoque/model/parametro_data

    from funcoes import estpar_field_selection_state_nf

    _columns = {
        # ___________________________ Boolean ________________________________
        # Verdadeiro para verificar a data de validade do produto durante o recebimento
        'estpar_verifica_data_validade': fields.boolean('Validade'),

        # ___________________________ Selection ______________________________
        'estpar_status_nf': fields.selection(estpar_field_selection_state_nf,
                                             'Status da nota fiscal', size=1)
    }

    _defaults = {
        'estpar_verifica_data_validade': lambda *args: True,  # Por padrao, sempre verifica a data
        'estpar_status_nf': lambda *args: '2'  # Notas fiscais validadas por padrao
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
