# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class recebimento_os_historico(osv.Model):
    """
    Registro do hitorico das Ordens de Servico.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'recebimento.os.historico'  # rechis
    _inherit = 'recebimento.os.historico'  # recebimento/inherit/os_historico

    def osvhis_registra_acao(self, cr, uid, ids, acao, context=None):
        """
        Registro do historico.

        @param cr: {cursor} a linha atual do cursor do banco de dados,
        @param uid: {int} ID do usuario utilizado para a verificacao de perfil,
        @param ids: {list} lista dos IDs,
        @param acao: {char} nome da acao,
        @param context: {dict} um dicionario padrao para valores contextuais,
        @return: {boolean} verdadeiro se os registros foram criados corretamen-
        te.

        @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}
        if not isinstance(ids, list):
            ids = [ids]

        os_lista = []  # Lista dos ID das Ordens de Servico

        for _id in ids:
            # Cria novo registro de historico
            dados = {'recebimento_id': _id,
                     'acao': acao.capitalize()}
            if self.create(cr, uid, dados, context):  # Registra dados da nova acao
                os_lista.append(_id)

        return all(os_lista)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
