# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class recebimento_os_historico(osv.Model):
    """
    Historico das ordens de servico de recebimento

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'recebimento.os.historico'  # osvhis
    _inherit = 'os.historico'  # recebimento/os/model/os_historico_data

    _columns = {
        # ___________________________ Many2One _______________________________
        # ID da ordem de servico de recebimento
        'recebimento_id': fields.many2one('recebimento.os', 'Ordem de servico')

    }


class recebimento_os(osv.Model):
    """
    Ordem de servico de recebimento

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'recebimento.os'  # recosv
    _inherit = 'recebimento.os'  # recebimento/inherit/os_data

    _columns = {
        # ___________________________ One2Many _______________________________
        'historico_ids': fields.one2many('recebimento.os.historico',  # Registro historico
                                         'recebimento_id', 'Item do historico')
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
