# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class recebimento_divergencia_itens(osv.Model):
    """
    Itens de divergencia.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'recebimento.divergencia.itens'  # recdit
    _inherits = {'estoque.produto.grade': 'grade_id'}

    from funcoes import recdit_fields_function, recdit_field_selection_divergencia

    _columns = {
        # ___________________________ Many2One _______________________________
        'produto_id': fields.many2one('estoque.produto', 'Produto', select=True),  # Produto
        'grade_id': fields.many2one('estoque.produto.grade', 'Grade', required=True, select=True,
                                    ondelete='restrict'),

        # ___________________________ Float___________________________________
        'qtde_pedida': fields.float('Quantidade pedida', digits=(8, 3)),
        'qtde_nf': fields.float('Quantidade na nota fiscal', digits=(8, 3)),
        'valor_item_pedido': fields.float('Total do pedido', digits=(8, 2)),
        'valor_item_nf': fields.float('Total na nota fiscal', digits=(8, 2)),

        # ___________________________ Selection_______________________________
        'tipo_divergencia': fields.selection(recdit_field_selection_divergencia,
                                             'Tipo de divergencia', size=1),

        # ___________________________ Function _______________________________
        'codigo': fields.function(recdit_fields_function, method=True, type='char', size=6,
                                  string='Codigo')
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
