# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields
import time


class recebimento_divergencia_nf(osv.Model):
    """
    Notas Fiscais com divergencia em relacao ao Pedido.

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'recebimento.divergencia.nf'  # recdnf
    _rec_name = 'numero'

    from funcoes import recdnf_field_selection_state, recdnf_fields_function

    _columns = {
        # ___________________________ Datetime _______________________________
        'data_divergencia': fields.datetime('Data da divergencia',
                                            required=True),
        'data_acao': fields.datetime('Data da acao'),  # Divergencia aceita/recusada

        # ___________________________ Many2One _______________________________
        'user_id': fields.many2one('res.users', 'Responsavel', required=True),
        'nf_id': fields.many2one('fiscal.nf.capa', 'Nota fiscal', required=True,
                                 ondelete='restrict'),
        'usuario_autorizador_id': fields.many2one('res.users', 'Usuario autorizador'),

        # ___________________________ Text ___________________________________
        'observacao': fields.text('Observacao'),

        # ___________________________ Function _______________________________
        # ID da nota fiscal com divergencia
        'numero': fields.function(recdnf_fields_function, type='integer', method=True,
                                  string='Nr.'),

        # ___________________________ Selection ______________________________
        'state': fields.selection(recdnf_field_selection_state, 'Status', size=2, required=True)
    }

    _order = 'state, data_divergencia desc'

    _defaults = {
        'data_divergencia': lambda *args: time.strftime('%Y-%m-%d %H:%M:%S'),
        'user_id': lambda self, cr, uid, context: uid,
        'state': lambda *args: 'DV'  # Divergente por padrao
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
