# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""


# _______________________ os _________________________________________________
def osvosv_fields_function(self, cr, uid, ids, name, arg, context=None):
    """
    Manipulacao de campos. Valores de campos pre-definidos.

    :param cr: a linha atual do cursor do banco de dados,
    :param uid: ID do usuario utilizado para a verificacao de perfil,
    :param ids: lista dos IDs,
    :param name: lista com o nome dos campos,
    :param arg: dicionario com os argumentos e valores,
    :param context: um dicionario padrao para valores contextuais,
    :type cr: object
    :type uid: int
    :type ids: long|list[long]
    :type name: list
    :type context: dict
    :return: valores ajustados dos campos.
    :rtype: dict

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    from datetime import datetime

    context = context and context.copy() or {}

    if ids and isinstance(ids, (int, long)):
        ids = [ids]

    result = {}

    for os in self.browse(cr, uid, ids):
        try:
            if name == 'tipo':
                valor = os.tipo_id.codigo
            elif name == 'name':
                if not os.descricao:
                    valor = 'Ordem de servico nr %s' % os.numero
                else:
                    valor = os.numero
            elif name == 'numero':
                if os.data_criacao:
                    valor = '%s-%06d' % (os.data_criacao[:4], os.id)
                else:
                    valor = '%s-%06d' % (datetime.now().year, os.id)
            else:
                valor = None
        except Exception as e:
            valor = None

        result[os.id] = valor

    return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
