# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields

STATUS_OS = [('esboco', 'Esboco'), ('criada', 'Criada'), ('aberta', 'Aberta'),
             ('cancelada', 'Cancelada'), ('fechada', 'Fechada')]


# noinspection PyPep8Naming
class os(osv.Model):
    """
    Ordens de Servico.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'os'  # osvosv

    from funcoes import osvosv_fields_function

    _columns = {
        # ___________________________ Many2Many ______________________________
        'responsavel_ids': fields.many2many('res.users', 'os_m2m_users', 'os_id', 'user_id',
                                            'Responsavel',
                                            help='Responsavel pela execucao da ordem de servico.'),

        # ___________________________ Many2One _______________________________
        'parent_id': fields.many2one("os", 'Ordem de servico pai', ondelete="restrict",
                                     select=True),
        'tipo_id': fields.many2one('os.tipo', 'Tipo da OS'),  # Tipo da ordem de servico
        'conferente_id': fields.many2one('res.users', 'Nome do conferente',
                                         help='Responsavel pela conferencia da ordem de servico.'),

        # ___________________________ Char ___________________________________
        'descricao': fields.char('Descricao', size=60),

        # ___________________________ Datetime _______________________________
        'data_criacao': fields.datetime('Data de criacao', readonly=True),
        'data_abertura': fields.datetime('Data de abertura', readonly=True),
        'data_fechamento': fields.datetime('Data de fechamento', readonly=True),
        'data_cancelamento': fields.datetime('Data de cancelamento',  readonly=True),

        # ___________________________ Selection ______________________________
        'state': fields.selection(STATUS_OS, 'Status'),

        # ___________________________ Function _______________________________
        'tipo': fields.function(osvosv_fields_function, method=True, type='char', size=3,
                                store=True, string='Tipo',
                                help='Tipo da ordem de servico.'),
        'name': fields.function(osvosv_fields_function, method=True, type='char', size=80,
                                store=True, string='Nome'),
        'numero': fields.function(osvosv_fields_function, method=True, type='char', size=12,
                                  store=True, string='Nr'),

        # ___________________________ Boolean ________________________________
        'active': fields.boolean('Ativo')
    }

    # Valores padrao
    _defaults = {
        'state': lambda *args: 'esboco',
        'active': lambda *args: True
    }

    _order = 'state, id desc'

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
