# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields
import time


# noinspection PyPep8Naming
class os_historico(osv.Model):
    """
    Registro do historico (log) das acoes de ordem de servico.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _name = 'os.historico'  # osvhis

    _columns = {
        # ___________________________ Many2One _______________________________
        'usuario_id': fields.many2one('res.users', 'Responsavel pela acao'),

        # ___________________________ Datetime _______________________________
        'data_historico': fields.datetime('Data'),

        # ___________________________ Char ___________________________________
        'acao': fields.char('Acao', size=255),

        # ___________________________ Boolean ________________________________
        'active': fields.boolean('Ativo')
    }

    _defaults = {
        'active': lambda *args: True,
        'data_historico': lambda *args: time.strftime('%Y-%m-%d %H:%M:%S'),
        'usuario_id': lambda self, cr, uid, context: uid
    }

    _order = 'data_historico desc'

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
