# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv
from openerp.tools.translate import _
from openerp.report import report_sxw
from datetime import datetime
from pytz import timezone


class report_recebimento(report_sxw.rml_parse):
    """
    Relatorio de conferencia - Recebimento "cego"
    addons/recebimento/report/recebimento.rml

    @author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    def __init__(self, cr, uid, name, context):
        super(report_recebimento, self).__init__(cr, uid, name, context=context)

        tz = context.get('tz') or 'Brazil/East'
        agora = datetime.now(timezone('UTC')).astimezone(timezone(tz))
        dados = {'datetime': datetime, 'agora': agora, 'lista_nf': self.lista_nf,
                 'divergencia': context.get('divergencia', '')}

        self.localcontext.update(dados)

        self.context = context

        # ___________________________ Objects ________________________________
        obj_os_historico = self.pool.get('recebimento.os.historico')
        obj_recebimento_itens = self.pool.get('recebimento.itens')

        acao = 'imprimir ordem de servico'

        if context.get('divergencia'):
            acao += ' (divergencias)'

        os_id = context.get('active_id', False)

        if os_id:
            obj_os_historico.osvhis_registra_acao(cr, uid, os_id, acao, context)

        # Verifica se existe item de recebimento
        args = [('recebimento_id', '=', context.get('active_id'))]

        if not obj_recebimento_itens.search(cr, uid, args, context=context):
            msg = _('Relatorio de ordem de servico de recebimento nao pode ser impresso. Nao ha '
                    'itens de recebimento.')

            raise osv.except_osv(_('Atencao!'), msg)

    def lista_nf(self, nf_ids):
        """
        Monta a lista dos numenos daf Notas Fiscais para apresentar no relatorio

        @param nf_ids: {list} lista dos nDs daf Notas Fiscais
        @return: {string} Numero das Notas Fiscais separadas por ','.
        """

        lista = 'NOTAS FISCAIS: ' if len(nf_ids) > 1 else 'NOTA FISCAL: '
        for nf in nf_ids:
            lista += str(nf.numero_nf) + ', '

        return lista[:len(lista) - 2]

report_sxw.report_sxw('report.recebimento.os',  'recebimento.os',
                      'addons/recebimento/report/recebimento.rml', parser=report_recebimento)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
