# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class receb_correios_capas(osv.Model):
    """
        Tabela de recebimentos.
    """
    # prefixo: rcorcap_

    _name = 'receb.correios.capas'
    _columns = {
        'id': fields.integer('Id', readonly=True),
        'create_date': fields.datetime('Data do recebimento', readonly=True, select=True),
        'create_uid': fields.many2one('res.users', 'Usuario', readonly=True, select=True),
        'rcorcap_observacoes': fields.text('Informacoes adicionais'),
        'rcorcap_pacote_ids': fields.one2many('receb.correios.pacotes', 'rcorpac_capa_id', 'Pacotes'),
        'state': fields.selection([('P', 'Pendente'),('C', 'Concluido')], 'Situacao', size=1)
    }
    _order = 'id desc'
    _defaults = {
        'state': 'P',
    }
