# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class receb_correios_pacotes(osv.Model):
    """
        Tabela de pacotes do recebimentos.
    """
    # prefixo: rcorpac_

    _name = 'receb.correios.pacotes'
    _columns = {
        'rcorpac_capa_id': fields.many2one('receb.correios.capas', 'Capa', required=True, ondelete='cascade', select=True),
        'rcorpac_etiqueta': fields.char('Etiqueta', size=15, select=True),
        'rcorpac_observacoes': fields.text('Informacoes complementares'),
        'rcorpac_nf_id': fields.many2one('fiscal.nf.capa', 'Nota', ondelete='cascade', select=True),
        'rcorcpac_pedido_id': fields.many2one('estoquepedidos.pedido.capa', 'Pedido', ondelete='restrict', select=True),
        'rcorcpac_itens_ids': fields.one2many('receb.correios.itens', 'rcorite_pacote_id', 'Itens'),
    }
    _order = 'rcorpac_capa_id desc,id'
