# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _


class reclamacoes_reclamacao(osv.Model):

    _inherit = 'reclamacoes.reclamacao'

    def rclrcl_onchange_pessoa(self, cr, uid, ids, pessoa_id, context):
        vals = {'value':'', 'message': ''}
        value = {}
        if context.get('rcl_tipo_reclamacao') == 'compras':
            value['rclrcl_compra_venda_pedido_invertida'] = 'V'
            value['rclrcl_compra_venda'] = 'E'
        else:
            value['rclrcl_compra_venda_pedido_invertida'] = 'C'
            value['rclrcl_compra_venda'] = 'S'
        vals['value'] = value

        return vals

    def rclrcl_onchange_nf_origem(self, cr, uid, ids, nf_id, context):
        vals = {'value':'', 'message': ''}
        value = {}
        if nf_id:
            dados_nf = self.pool.get('fiscal.nf.capa').read(cr, uid, nf_id, ['fisnfc_pedido_ids', 'estoque_movimento_itens_ids'], context=context)
            pedidos_ids = dados_nf.get('fisnfc_pedido_ids')
            movimento_ids = dados_nf.get('estoque_movimento_itens_ids')
            estoque_movimento_itens_dados = self.pool.get('estoque.movimento.itens').read(
                cr, uid, movimento_ids, ['produto_id'], context, '_classic_write')
            _pedido_id = False
            if pedidos_ids:
                _pedido_id = pedidos_ids[0]
            value['rclrcl_pedido_origem_id'] = _pedido_id
            value['rclrcl_nf_produto_ids'] = list(set(map(lambda i: i.get('produto_id'), estoque_movimento_itens_dados)))
        vals['value'] = value
        return vals

    def rclrcl_open_url(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        brw_reclamacao = self.browse(cr, uid, ids, context=context)[0]
        url = brw_reclamacao.rclrcl_reclamacao_externa
        return {
            'type': 'ir.actions.act_url',
            'url': url,
            'target': 'new'
        }


    def rclrcl_button_pendente(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = self.write(cr, uid, ids, {'state': 'P'})
        self.message_post(cr, uid, ids, _('Alteracao de Status'), _('Pendente'))
        return res

    def rclrcl_button_cancelar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = self.write(cr, uid, ids, {'state': 'C'})
        self.message_post(cr, uid, ids, _('Alteracao de Status'), _('Cancelado'))
        return res

    def rclrcl_button_finalizar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = self.write(cr, uid, ids, {'state': 'F'})
        self.message_post(cr, uid, ids, _('Alteracao de Status'), _('Finalizado'))
        return res

