# -*- coding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
import StringIO
from openerp import pooler
from openerp.report.interface import report_int
from openerp.report.render import render
from openerp.tools.translate import _
from ..utils.relatorio import RelPagina
from dateutil.parser import parse
import base64


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        if datas.get('pdf'):
            return self.create_pdf(cr, uid, ids, datas.get('pdf'), context)


    def create_pdf(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=140):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        # PDF ja veio pronto, é só imprimir
        if datas.get('estrutura').get('pdf'):
            _pdf = base64.b64decode(datas.get('dados'))
            self.obj = external_pdf(_pdf)
            self.obj.render()
            return (self.obj.pdf, 'pdf')

        context = context and context.copy() or {}
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        estrutura = datas.get('estrutura')
        pagina = RelPagina()
        pagina.set_vals(estrutura)
        if pagina.relpag_num:
            listagem.setPage(pagina.relpag_num - 1)
        orientacao = pagina.relpag_orientacao == 'P' and '1' or pagina.relpag_orientacao == 'R'\
                     and '0' or '1'
        listagem.defineFormato(orientacao=orientacao)
        listagem.informaNome(pdf_string, pagina.relpag_nome_rel)
        # listagem.informaTamLinha(tam=pagina.relpag_tam_linha)
        listagem.tamanhoLinha = pagina.relpag_tam_linha
        tam = pagina.relpag_fonte_tamanho
        if pagina.relpag_orientacao == 'R':
            tam = pagina.relpag_fonte_tamanho * 0.65

        listagem.defineFonte(tam=tam)

        listagem.defineMargem(pagina.relpag_margem_esquerda,
                              pagina.relpag_margem_direita,
                              pagina.relpag_margem_superior,
                              pagina.relpag_margem_inferior)

        dados = datas.get('dados')
        if pagina.relpag_cabecalhos:
            listagem.informaCab('*%s*' % ''.ljust(pagina.relpag_tam_linha - 2, '-'))
        for cab in pagina.relpag_cabecalhos:
            dados_cab = dados.get(cab.relcab_name)
            linha = cab.relcab_separa_coluna or ''
            for col in cab.relcab_colunas:
                if col.relcol_nao_separa_coluna:
                    linha = linha[:len(linha) - 1] + ' '
                try:
                    text = dados_cab.get(col.relcol_name)
                    text = text.replace('|pag|', _('Pagina: ') + '{{ Page }}')
                except:
                    pass
                linha += formataString(text, col.relcol_dados_tam, ' ',
                                       col.relcol_dados_alinhamento or 'D', 'N', 'S') + \
                         cab.relcab_separa_coluna

            listagem.informaCab(linha)
            if cab.relcab_divide_linha:
                listagem.informaCab('*%s*' % ''.ljust(pagina.relpag_tam_linha-2, '-'))

        listagem.informaRodape('--')
        listagem.informaRodape(_('Sig Informatica Ltda   ').rjust(pagina.relpag_tam_linha))
        cont_linha = 0
        linha_anterior = ''
        for linha in dados.get('linhas'):
            for i in pagina.relpag_linhas:
                if i.rellin_name not in linha:
                    continue

                if linha_anterior != i.rellin_name:
                    linha_anterior = i.rellin_name
                    if i.rellin_divide_linha_anterior:
                        listagem.imprimeLinha('*%s*' % ''.ljust(pagina.relpag_tam_linha-2, '-'))

                if i.rellin_nova_pagina and cont_linha > 0:
                    listagem.imprimeLinha('{{ Page }}')
                cont_linha += 1

                dados_linha = linha.get(i.rellin_name)
                linha = i.rellin_separa_coluna
                for col in i.rellin_colunas:
                    if col.relcol_nao_separa_coluna:
                        linha = linha[:len(linha) - 1] + ' '
                    text = dados_linha.get(col.relcol_name) or ''
                    linha += formataString(text, col.relcol_dados_tam, ' ',
                                           col.relcol_dados_alinhamento or 'D', 'N', 'S') + \
                             i.rellin_separa_coluna

                listagem.imprimeLinha(linha)
                if i.rellin_divide_linha:
                    listagem.imprimeLinha('*%s*' % ''.ljust(pagina.relpag_tam_linha-2, '-'))

        listagem.imprimeLinha('*%s*' % ''.ljust(pagina.relpag_tam_linha-2, '-'))
        listagem.finalizaImpressao()

        # Alguns relatorios tem um controle de paginacao. Tratar aqui.
        if pagina.relpag_num:
            if estrutura.get('relpag_nome_rel') == u'Registro de inventário':
                pooler.get_pool(cr.dbname).get('rel.registro.inventario.osv').atualiza_paginacao(
                    cr, uid, pagina.relpag_num, listagem.getPage(),
                    parse(dados.get('cab4').get('data_estoque')[-10:]).strftime('%Y-%m-%d'),
                    context)

        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

report_custom('report.relatorios')
