# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""
class RelBase(object):
    def set_vals(self, vals):
        '''
        As as chaves do dicionario virarao atributos com seus respectivos valores
        :param vals: dict
        :return:
        '''
        for x, y in vals.items():
            # nao deixa adicionar um atributo que ja nao esteja declarado na classe
            if x not in self.__dict__:
                raise Exception('Atributo "%s" invalido para a classe "%s"' %
                                (x, self.__class__.__name__))
            if type(y) != type(eval('self.%s' % x)):
                if (type(eval('self.%s' % x)) == float and type(y) == int):
                    self.__setattr__(x, y)
                    continue

                if type(y) not in [str, unicode] or type(eval('self.%s' % x)) not in [str, unicode]:
                    raise Exception('Tipo do atributo "%s" deve ser: "%s"' %
                                    (x, type(eval('self.%s' % x))))

            self.__setattr__(x, y)


class RelColuna(RelBase):
    def __init__(self, name):
        self.relcol_name = name                  # Nome da coluna, string, required
        self.relcol_fonte_nome = ''              # Fonte, string
        self.relcol_fonte_tamanho = 0            # integer
        self.relcol_cor = ''                     # string
        self.relcol_negrito = False              # boolean
        self.relcol_italico = False              # boolean
        self.relcol_quebra = False               # boolean
        self.relcol_subtotal = False             # boolean 'Para sub-totalizar, tem relcol_quebra tem que estar marcado''
        self.relcol_total = False                # boolean
        self.relcol_dados_tipo = ''              # S=String, V=Valor/numero, D=Data
        self.relcol_dados_tam = 0                # integer
        self.relcol_dados_tam_decimal = 0        # integer
        self.relcol_dados_alinhamento  = ''      # E=Esquerda, C=Centralizado, D=Direita
        self.relcol_nao_separa_coluna = False    # boolean, True para a coluna nao usar o caracter
        # de separacao da linha


class RelCabecalho(RelBase):
    def __init__(self, name):
        self.relcab_name = name                  # Nome do cabeçalho, string, required
        self.relcab_fonte_nome = ''              # Fonte, string
        self.relcab_fonte_tamanho = 0            # integer
        self.relcab_cor = ''                     # string
        self.relcab_divide_linha = False         # boolean, desenha um traco na proxima linha
        self.relcab_negrito = False              # boolean
        self.relcab_italico = False              # boolean
        self.relcab_colunas = []                 # lista contendo objetos da classe rel_coluna
        self.relcab_separa_coluna = ''           # string separa colunas com o caracter passado

    def set_vals(self, vals):
        super(RelCabecalho, self).set_vals(vals)
        if 'relcab_colunas' not in vals:
            return

        aux = []
        for i in self.relcab_colunas:
            col = RelColuna(i.get('relcol_name'))
            col.set_vals(i)
            aux.append(col)

        self.relcab_colunas = aux


class RelLinha(RelBase):
    def __init__(self, name):
        self.rellin_name = name                  # Nome da linha, string, required
        self.rellin_fonte_nome = ''              # Fonte, string
        self.rellin_fonte_tamanho = 0            # integer
        self.rellin_cor = ''                     # string
        self.rellin_divide_linha = False         # boolean, desenha um traco na proxima linha
        self.rellin_divide_linha_anterior = False # boolean, desenha um traco linha anterior apenas
                                                  # uma vez quando o tipo de linha mudar
        self.rellin_negrito = False              # boolean
        self.rellin_italico = False              # boolean
        self.rellin_colunas = []                 # lista contendo objetos da classe rel_coluna
        self.rellin_separa_coluna = ''           # string separa colunas com o caracter passado
        self.rellin_nova_pagina = False          # boolean, True para se iniciar uma nova pagina

    def set_vals(self, vals):
        super(RelLinha, self).set_vals(vals)
        if 'rellin_colunas' not in vals:
            return

        aux = []
        for i in self.rellin_colunas:
            col = RelColuna(i.get('relcol_name'))
            col.set_vals(i)
            aux.append(col)

        self.rellin_colunas = aux

class RelRodape(RelBase):
    def __init__(self, name):
        self.relrdp_name = name                  # Nome do rodape, string, required
        self.relrdp_fonte_nome = ''              # Fonte, string
        self.relrdp_fonte_tamanho = 0            # integer
        self.relrdp_cor = ''                     # string
        self.relrdp_negrito = False              # boolean
        self.relrdp_italico = False              # boolean
        self.relrdp_colunas = []                 # lista contendo objetos da classe rel_coluna

    def set_vals(self, vals):
        super(RelRodape, self).set_vals(vals)
        if 'relrdp_colunas' not in vals:
            return

        aux = []
        for i in self.relrdp_colunas:
            col = RelColuna(i.get('relcol_name'))
            col.set_vals(i)
            aux.append(col)

        self.relrdp_colunas = aux

class RelPagina(RelBase):
    def __init__(self):
        self.relpag_nome_rel = 'Sem nome'        # string, Nome do relatorio
        self.relpag_orientacao = ''              # R=Retrato, P=Paisagem
        self.relpag_tam_linha = 100              # int, default 100, Tamanho da linha
        self.relpag_margem_esquerda = 1.0        # float default 1
        self.relpag_margem_direita = 1.0         # float default 1
        self.relpag_margem_superior = 1.0        # float default 1
        self.relpag_margem_inferior = 1.0        # float default 1
        self.relpag_fonte_nome = 'Verdana'       # Fonte, string, default 'Courier'
        self.relpag_fonte_tamanho = 15.0         # Float, default 15
        self.relpag_cor = 'black'                # string, default 'black'
        self.relpag_num = 0                      # int, numero da pagina inicial, para relatorios
        # que possuem o proprio controle de numeracao (ex.: livro registro de inventario)
        self.relpag_cabecalhos = []              # lista contend objetos da classe rel_cabecalho
        self.relpag_linhas = []                  # lista contendo objetos da classe rel_linha
        self.relpag_rodapes = []                 # lista contendo objetos da classe rel_rodape

    def set_vals(self, vals):
        super(RelPagina, self).set_vals(vals)
        if 'relpag_cabecalhos' in vals:
            aux = []
            for i in self.relpag_cabecalhos:
                col = RelCabecalho(i.get('relcab_name'))
                col.set_vals(i)
                aux.append(col)

            self.relpag_cabecalhos = aux

        if 'relpag_linhas' in vals:
            aux = []
            for i in self.relpag_linhas:
                col = RelLinha(i.get('rellin_name'))
                col.set_vals(i)
                aux.append(col)

            self.relpag_linhas = aux

        if 'relpag_rodapes' in vals:
            aux = []
            for i in self.relpag_rodapes:
                col = RelRodape(i.get('relrdp_name'))
                col.set_vals(i)
                aux.append(col)

            self.relpag_rodapes = aux
