# -*- coding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _
from openerp.tools.config import config
from ..utils.relatorio import RelPagina
import xlwt
from datetime import datetime
import os
import base64
from SigUtils.formatastring import formataString
import subprocess
import openerp.netsvc as netsvc


class wizard_relatorios_impressao(osv.TransientModel):

    def _get_parametros(self, cr, uid, context=None):
        context = context and context.copy() or {}
        nome_relatorio = context.get('active_model')
        if not nome_relatorio:
            return {}

        chave = '%04d-%s' % (uid, nome_relatorio)
        parametros = self.pool.get('ir.config_parameter').get_param(cr, uid, chave)
        if not parametros:
            return {}

        return eval(parametros)

    def _get_default_wizrei_gerar(self, cr, uid, context=None):
        context = context and context.copy() or {}
        paramtros = self._get_parametros(cr, uid, context)
        return paramtros.get('wizrei_gerar') or 'T'

    def _get_default_wizrei_linha_por_pagina(self, cr, uid, context=None):
        context = context and context.copy() or {}
        paramtros = self._get_parametros(cr, uid, context)
        return paramtros.get('wizrei_linha_por_pagina') and \
               int(paramtros.get('wizrei_linha_por_pagina'))  or 48

    def _get_default_wizrei_impressora(self, cr, uid, context=None):
        context = context and context.copy() or {}
        paramtros = self._get_parametros(cr, uid, context)
        return paramtros.get('wizrei_impressora') or ''

    def _get_default_wizrei_tipo_impressao(self, cr, uid, context=None):
        context = context and context.copy() or {}
        paramtros = self._get_parametros(cr, uid, context)
        return paramtros.get('wizrei_tipo_impressao') or 'P'

    def _get_default_wizrei_tipo_arquivo(self, cr, uid, context=None):
        context = context and context.copy() or {}
        paramtros = self._get_parametros(cr, uid, context)
        return paramtros.get('wizrei_tipo_arquivo') or 'E'

    def _get_default_wizrei_orientacao(self, cr, uid, context=None):
        context = context and context.copy() or {}
        paramtros = self._get_parametros(cr, uid, context)
        return paramtros.get('wizrei_orientacao') or 'R'

    def _get_default_wizrei_nome_relatorio(self, cr, uid, context=None):
        context = context and context.copy() or {}
        paramtros = self._get_parametros(cr, uid, context)
        return paramtros.get('wizrei_nome_relatorio') or ''

    # prefixo: wizrei_

    NOME_RELATORIO = [('1','Todos')]
    PRINTER_CHOICES = [('', '')]
    _name = 'wizard.relatorios.impressao'
    _columns = {
        'wizrei_gerar': fields.selection([('T','Tela'),
                                          ('I','Impressora'),
                                          ('D','Download'),
                                          ('A','Arquivo')], 'Gerar', size=1, required=True),
        'wizrei_linha_por_pagina': fields.integer('Linhas por Pagina'),
        # o selection deste campo sera populado na funcao fields_view_get para estar atualizado
        'wizrei_impressora': fields.selection(PRINTER_CHOICES, 'Impressoras', size=2),
        'wizrei_tipo_impressao': fields.selection([('P','Pdf'),
                                                   ('T','Texto Puro')], 'Tipo impressao', size=1),
        'wizrei_arquivo_nome': fields.char('Nome', size=30),
        'wizrei_arquivo': fields.binary('Nome do arquivo'),
        'wizrei_tipo_arquivo': fields.selection([('E','Excell'),
                                                 ('C','Csv'),
                                                 ('T', 'Txt')], 'Tipo de arquivo', size=1),
        'wizrei_orientacao': fields.selection([('R','Retrato'),
                                               ('P','Paisagem')], 'Orientacao', size=1),
        'wizrei_nome_relatorio': fields.selection(NOME_RELATORIO, 'Relatorio', size=1),
    }

    _defaults = {
         'wizrei_gerar': _get_default_wizrei_gerar,
         'wizrei_linha_por_pagina': _get_default_wizrei_linha_por_pagina,
         'wizrei_impressora': _get_default_wizrei_impressora,
         'wizrei_tipo_impressao': _get_default_wizrei_tipo_impressao,
         'wizrei_tipo_arquivo': _get_default_wizrei_tipo_arquivo,
         'wizrei_orientacao': _get_default_wizrei_orientacao,
         'wizrei_nome_relatorio': _get_default_wizrei_nome_relatorio,
    }

    def get_tela_relatorios(self, cr, uid, context=None):
        "Retorna a tela padrao de relatorios"
        context = context and context.copy() or {}
        reference = self.pool.get('ir.model.data').get_object_reference(cr, uid, 'relatorios',
                                                            'view_wizard_relatorios_impressao_form')
        view_id = reference and reference[1] or False
        return {'name': _('Relatorios'),
                'view_type': 'form',
                'view_mode': 'form',
                'res_model': 'wizard.relatorios.impressao',
                'view_id': [view_id],
                'context': context,
                'target': 'new',
                'type': 'ir.actions.act_window'}

    def get_nome_relatorio(self, choice):
        label = dict(self.NOME_RELATORIO).get(choice) or ''
        return label

    def get_printer_label(self, choice):
        if os.name == 'posix':
            from cups import Connection

        try:
            conn = Connection()
            printers = conn.getPrinters()
        except:
            printers = {}

        printer_names = printers.keys()
        # SE O INDICE COMECA COM ZERO, NAO ACEITA SER SELECIONADO.
        printer_len = map(str, range(1, printer_names.__len__() + 1))
        printers = zip(printer_len, printer_names)

        label = dict(printers).get(choice) or ''
        return label

    def fields_view_get(self, cr, user, view_id=None, view_type=False, context=None, toolbar=False,
                        submenu=False):
        context = context and context.copy() or {}
        # --------------- Pega o nome do relatorio corrente ----------------------------------------
        res = super(wizard_relatorios_impressao, self).fields_view_get(
            cr, user, view_id=view_id, view_type=view_type, context=context, toolbar=toolbar,
            submenu=submenu)
        nome = context.get('active_model') or "Sem nome"
        if len(self.NOME_RELATORIO) > 1:
            self.NOME_RELATORIO = self.NOME_RELATORIO[:-1]

        self.NOME_RELATORIO.append(('2', nome))
        self._columns['wizrei_nome_relatorio'].selection = self.NOME_RELATORIO
        res['fields']['wizrei_nome_relatorio']['selection'] = self.NOME_RELATORIO

        # -------------- Pega as impressoras que estao ligadas na rede-----------------------------
        if os.name == 'posix':
            from cups import Connection

        try:
            conn = Connection()
            printers = conn.getPrinters()
        except:
            printers = {}

        if not printers:
            printers = {'Impressora nao localizada': ''}

        printer_names = printers.keys()
        # SE O INDICE COMECA COM ZERO, NAO ACEITA SER SELECIONADO.
        printer_len = map(str, range(1, printer_names.__len__() + 1))
        self.PRINTER_CHOICES = zip(printer_len, printer_names)
        self._columns['wizrei_impressora'].selection = self.PRINTER_CHOICES
        res['fields']['wizrei_impressora']['selection'] = self.PRINTER_CHOICES
        return res

    def wizrei_button_salvar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        brw = self.browse(cr, uid, ids[0], context)
        if not brw.wizrei_nome_relatorio:
            raise osv.except_osv(_('Atencao!'),
                                 _('Escolha o relatorio!'))

        chave = '%04d-%s' % (uid, self.get_nome_relatorio(brw.wizrei_nome_relatorio))
        vals = {'wizrei_gerar': brw.wizrei_gerar,
                'wizrei_linha_por_pagina': brw.wizrei_linha_por_pagina,
                'wizrei_impressora': brw.wizrei_impressora,
                'wizrei_tipo_impressao': brw.wizrei_tipo_impressao,
                'wizrei_tipo_arquivo': brw.wizrei_tipo_arquivo,
                'wizrei_orientacao': brw.wizrei_orientacao,
                'wizrei_nome_relatorio': brw.wizrei_nome_relatorio}
        self.pool.get('ir.config_parameter').set_param(cr, uid, chave, str(vals))
        reference = self.pool.get('ir.model.data').get_object_reference(cr, uid, 'relatorios',
                                                            'view_wizard_relatorios_impressao_form')
        view_id = reference and reference[1] or False
        # retorna o proprio formulario apos salvar as configuracoes
        return {'name': _('Relatorios'),
                'view_type': 'form',
                'view_mode': 'form',
                'res_id': ids[0],
                'res_model': 'wizard.relatorios.impressao',
                'view_id': [view_id],
                'context': context,
                'target': 'new',
                'type': 'ir.actions.act_window'}

    def wizrei_gerar_rel_tela(self, cr, uid, pagina, dados, qtd_por_paginas, context=None):
        context = context and context.copy() or {}
        alinhamento = {'D': 'LEFT',
                       'C': 'MIDDLE',
                       'E': 'RIGHT',
                       '': 'LEFT',  # padrao
                       }
        cabecalho = u'\n<hr/>'
        pag_size = pagina.relpag_fonte_tamanho
        pag_style = pagina.relpag_fonte_nome
        pag_cor = pagina.relpag_cor
        pag = 1
        for i in pagina.relpag_cabecalhos:
            cab_size = i.relcab_fonte_tamanho or pag_size
            cab_style = i.relcab_fonte_nome or pag_style
            cab_cor = i.relcab_cor or pag_cor
            dados_cab = dados.get(i.relcab_name)
            if not dados_cab:
                continue

            corpo = u'\n<table width="100%"><tr>'
            tam_cols = sum(map(lambda x: x.relcol_dados_tam or 1, i.relcab_colunas))
            for col in i.relcab_colunas:
                col_size = col.relcol_fonte_tamanho or cab_size
                col_style = col.relcol_fonte_nome or cab_style
                col_cor = col.relcol_cor or cab_cor
                width = ((col.relcol_dados_tam or 1)/float(tam_cols) * 100)
                text = dados_cab.get(col.relcol_name)
                if col.relcol_negrito:
                    text = u'<b>%s<b>' % text

                if col.relcol_italico:
                    text = u'<i>%s<i>' % text

                corpo += u'\n<td ALIGN={alinhamento} width="{width}%" style="padding-left: ' \
                         u'3px;padding-bottom:0px; font-size: {f_size}px;">' \
                         u'<font color="{cor}" face="{f_style}">{text}</font></td>'.format(
                    width=width,
                    f_size=col_size,
                    f_style=col_style,
                    alinhamento=alinhamento.get(col.relcol_dados_alinhamento),
                    cor=col_cor,
                    text=text)

            corpo += u'\n</tr>\n</table>'
            cabecalho += u'\n%s' % corpo

        cabecalho += u'\n<hr/>'
        rodape = u'\n<hr/> \n<div align="Right">Sig Informatica Ltda.&nbsp;&nbsp;</div> <br/><br/>'
        list_paginas = []
        cont = 1
        itens = u''
        imprime_divisoria = u''
        linha_anterior = ''
        grupo_itens = []
        for linha in dados.get('linhas'):
            mudou_linha = False
            if linha.keys()[0] != linha_anterior:
                mudou_linha = True
                if linha_anterior:
                    grupo_itens.append(u'\n<table width="100%">{itens}\n</table>{div}'.format(itens=itens,
                                                                                      div=imprime_divisoria))
                    imprime_divisoria = u''
                    itens = u''

                linha_anterior = linha.keys()[0]

            corpo = u'\n<tr>'
            for i in pagina.relpag_linhas:
                lin_size = i.rellin_fonte_tamanho or pag_size
                lin_style = i.rellin_fonte_nome or pag_style
                lin_cor = i.rellin_cor or pag_cor
                dados_linha = linha.get(i.rellin_name)
                if not dados_linha:
                    continue

                if mudou_linha and i.rellin_divide_linha_anterior:
                    corpo += u'\n<hr/>'

                mudou_linha = False
                tam_cols = sum(map(lambda x: x.relcol_dados_tam or 1, i.rellin_colunas))
                for col in i.rellin_colunas:
                    col_size = col.relcol_fonte_tamanho or lin_size
                    col_style = col.relcol_fonte_nome or lin_style
                    col_cor = col.relcol_cor or lin_cor
                    width = (col.relcol_dados_tam or 1)/float(tam_cols) * 100
                    text = dados_linha.get(col.relcol_name) or ''
                    if col.relcol_negrito:
                        text = u'<b>%s<b>' % text

                    if col.relcol_italico:
                        text = u'<i>%s<i>' % text

                    corpo += u'\n<td ALIGN={alinhamento} width="{width}%" style="padding-left: ' \
                             u'3px;padding-bottom:0px; font-size: {f_size}px;">' \
                             u'<font color="{cor}" face="{f_style}">{text}</font></td>'.format(
                        width=width,
                        f_size=col_size,
                        f_style=col_style,
                        alinhamento=alinhamento.get(col.relcol_dados_alinhamento),
                        cor=col_cor,
                        text=text)

                if i.rellin_divide_linha:
                    imprime_divisoria += u'\n<hr/>'

            corpo += u'\n</tr>'
            itens += corpo
            if cont < qtd_por_paginas:
                cont += 1
                continue

            grupo_itens.append(u'\n<table width="100%">{itens}\n</table>{div}'.format(itens=itens,
                                                                                      div=imprime_divisoria))
            imprime_divisoria = u''
            conteudo = u'{cabecalho}{grupo_itens}'.format(
                    cabecalho=cabecalho.replace('|pag|', 'Pagina: %s' % pag) , grupo_itens=''.join(grupo_itens)) + rodape
            if list_paginas:
                conteudo = u'<br/><br/>' + conteudo

            grupo_itens = []
            itens = u''
            pag += 1
            cont = 1
            list_paginas.append(conteudo)

        # ultimo conteudo que nao entrou na lista por ter qtd menor que permitido por pagina
        if itens:
            grupo_itens.append(u'\n<table width="100%">{itens}\n</table>'.format(itens=itens,
                                                                                      div=imprime_divisoria))
            imprime_divisoria = u''
            conteudo = u'{cabecalho}{grupo_itens}'.format(
                cabecalho=cabecalho.replace('|pag|', 'Pagina: %s' % pag), grupo_itens='\n'.join(grupo_itens)) + rodape
            if list_paginas:
                conteudo = u'<br/><br/>' + conteudo

            list_paginas.append(conteudo)

        html = u"""<meta charset="UTF-8"> 
                   <html>
                       <head>
                           <title>Relatorio</title>
                       </head>
                       <body>
                           {conteudo}
                       </body>
                   </html>""".format(conteudo=''.join(list_paginas))
        path = '/relatorio_%s.html' % datetime.now().strftime('%d-%m-%Y_%H:%M:%S')
        root = config.options['static_http_document_root']
        prefix = config.options['static_http_url_prefix']
        http_enable = config.options['static_http_enable']
        msg = []
        not root and msg .append('static_http_document_root')
        not prefix and msg .append('static_http_url_prefix')
        not http_enable and msg .append('static_http_enable')
        if msg:
            raise osv.except_osv(_('Atencao!'),
                                 _('Configure os parametros:\n\n%s\n\n'
                                   'E reinicie o servico do openerp') % '\n'.join(msg))

        a = open(root + path, 'w')
        a.write(html.encode('utf-8'))
        a.close()
        # Todo: mudar a url para ficar dinamica, ou seja, buscar o caminho do servidor e passá-lo
        return {
            'type': 'ir.actions.act_url',
            'url': 'http://%s%s' % (context.get('HTTP_HOST'), prefix + path),
            'target': 'new',
        }

    def wizrei_button_gerar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}

        estrutura = context.get('estrutura') and context.pop('estrutura') or {}
        if not estrutura:
            raise osv.except_osv(_('Atencao!'),
                                 _('A Estrutura do relatorio nao foi informada!'))
        try:
            pagina = RelPagina()
            pagina.set_vals(estrutura)
        except Exception as e:
            raise osv.except_osv(_('Atencao!'),
                                 _('Estrutura invalida: %s' % e))

        dados = context.get('dados') and context.pop('dados') or {}
        if not dados:
            raise osv.except_osv(_('Atencao!'),
                                 _('Sem dados para este relatorio!'))

        brw_filtros = self.browse(cr, uid, ids[0], context)
        estrutura['relpag_orientacao'] = brw_filtros.wizrei_orientacao or 'R'
        res = True
        if brw_filtros.wizrei_gerar == 'T':
            res = self.wizrei_gerar_rel_tela(cr, uid, pagina, dados,
                                             brw_filtros.wizrei_linha_por_pagina, context)

        elif brw_filtros.wizrei_gerar == 'I':
            if brw_filtros.wizrei_tipo_impressao == 'P':
                documento = 'relatorio_pdf_%s.pdf' % datetime.now().strftime('%d-%m-%Y_%H:%M:%S')
                diretorio = "/tmp/" + documento
                obj_realtorios = netsvc.LocalService('report.' + 'relatorios')
                report_dados, report_formato = obj_realtorios.create(
                    cr, uid, ids, {'pdf': {'estrutura': estrutura, 'dados': dados}}, context)
                report_file = open(diretorio, 'w')
                report_file.write(report_dados)
                report_file.close()
            else:
                documento = 'relatorio_txt_%s.txt' % datetime.now().strftime('%d-%m-%Y_%H:%M:%S')
                diretorio = "/tmp/" + documento
                context.update({'wizrei_impressao_texto': True})
                arquivo_txt_dados = self.wizrei_gerar_rel_txt(cr, uid, pagina, dados, context)
                del context['wizrei_impressao_texto']
                arquivo_txt_dados = base64.decodestring(arquivo_txt_dados)
                report_file = open(diretorio, 'w')
                report_file.write(arquivo_txt_dados)
                report_file.close()

            impressora = "-d" + self.get_printer_label(brw_filtros.wizrei_impressora)
            subprocess.call(["lp", '-n1', impressora, diretorio])

        elif brw_filtros.wizrei_gerar == 'D':
            res = {'type': 'ir.actions.report.xml',
                   'report_name': 'relatorios',
                   'datas': {'pdf': {'estrutura': estrutura,
                                     'dados':dados}}}

        elif brw_filtros.wizrei_gerar == 'A':
            if brw_filtros.wizrei_tipo_arquivo == 'E':
                arquivo = self._gerar_planilha(cr, uid, estrutura, dados, context)
                nome = '%s.xls' % (estrutura.get('relpag_nome_rel') or 'Arquivo sem nome')
            elif brw_filtros.wizrei_tipo_arquivo == 'C':
                arquivo = self.wizrei_gerar_rel_csv(cr, uid, pagina, dados, context)
                nome = '%s.csv' % (estrutura.get('relpag_nome_rel') or 'Arquivo sem nome')
            else:
                arquivo = self.wizrei_gerar_rel_txt(cr, uid, pagina, dados, context)
                nome = '%s.txt' % (estrutura.get('relpag_nome_rel') or 'Arquivo sem nome')

            self.write(cr, uid, ids, {'wizrei_arquivo': arquivo,
                                      'wizrei_arquivo_nome': nome}, context)
            reference = self.pool.get('ir.model.data').get_object_reference(
                cr, uid, 'relatorios', 'view_wizard_relatorios_impressao_form')
            view_id = reference and reference[1] or False
            return {'name': _('Relatorios'),
                    'view_type': 'form',
                    'view_mode': 'form',
                    'res_model': 'wizard.relatorios.impressao',
                    'view_id': [view_id],
                    'res_id': ids[0],
                    'context': context,
                    'target': 'new',
                    'type': 'ir.actions.act_window'}

        return res

    def wizrei_gerar_rel_csv(self, cr, uid, pagina, dados, context=None):
        """
        Metodo responsavel por tratar os dados do relatorio para uma estrutura de formato CSV.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param pagina: instancia da classe RelPagina, responsavel pela estrutura de layout do
        relatorio.
        :type pagina: object
        :param dados: conteudo do relatorio.
        :type dados: dict
        :param context: dados contextuais.
        :type context: dict
        :return: dados do relatario construido no formato CSV.
        :rtype: str
        """
        context = context and context.copy() or {}
        path = '/tmp/relatorio_csv_%s.csv' % datetime.now().strftime('%d-%m-%Y_%H:%M:%S')
        a = open(path, 'w')
        obj_adm_utils = self.pool.get('adm.utils')
        for i in pagina.relpag_cabecalhos:
            dados_cab = dados.get(i.relcab_name)
            corpo = ''
            for col in i.relcab_colunas:
                if dados_cab.get(col.relcol_name) == '|pag|':
                    continue
                corpo += obj_adm_utils.admutl_remover_acentuacao(cr, uid, (dados_cab.get(
                    col.relcol_name) or '')) + ';'

            corpo += '\r\n'
            a.write(corpo)

        for linha in dados.get('linhas'):
            corpo = ''
            for i in pagina.relpag_linhas:
                dados_linha = linha.get(i.rellin_name)
                if not dados_linha:
                    continue

                for col in i.rellin_colunas:
                    corpo += obj_adm_utils.admutl_remover_acentuacao(cr, uid, (dados_linha.get(
                        col.relcol_name) or '')) + ';'

            corpo += '\r\n'
            a.write(corpo)

        a.close()
        dados_csv = open(path, 'r')
        dados_csv = dados_csv.read()
        dados_csv = base64.encodestring(dados_csv.encode('utf-8', 'strict'))
        return dados_csv

    def wizrei_gerar_rel_txt(self, cr, uid, pagina, dados, context=None):
        """
        Metodo responsavel por tratar os dados do relatorio para uma estrutura de formato TXT.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param pagina: instancia da classe RelPagina, responsavel pela estrutura de layout do
        relatorio.
        :type pagina: object
        :param dados: conteudo do relatorio.
        :type dados: dict
        :param context: dados contextuais.
        :type context: dict
        :return: dados do relatario construido no formato TXT.
        :rtype: str
        """
        context = context and context.copy() or {}
        path = '/tmp/relatorio_txt_%s.txt' % datetime.now().strftime('%d-%m-%Y_%H:%M:%S')
        a = open(path, 'w')
        if context.get('wizrei_impressao_texto'):
            a.write(chr(15) + chr(27) + chr(77))
        obj_adm_utils = self.pool.get('adm.utils')
        for i in pagina.relpag_cabecalhos:
            dados_cab = dados.get(i.relcab_name)
            corpo = ''
            tam_cols = sum(map(lambda x: x.relcol_dados_tam or 1, i.relcab_colunas))
            for col in i.relcab_colunas:
                if dados_cab.get(col.relcol_name) == '|pag|':
                    continue
                # width = ((col.relcol_dados_tam or 1)/float(tam_cols) * 100)
                width = col.relcol_dados_tam or 1
                text = obj_adm_utils.admutl_remover_acentuacao(cr, uid, (dados_cab.get(
                    col.relcol_name) or ''))

                corpo += formataString(text, int(width), ' ', col.relcol_dados_alinhamento, 'N',
                                       'S') + ' '

            corpo += '\r\n'
            a.write(corpo)

        rodape = u'Sig Informatica Ltda'
        for linha in dados.get('linhas'):
            corpo = ''
            for i in pagina.relpag_linhas:
                dados_linha = linha.get(i.rellin_name)
                if not dados_linha:
                    continue
                tam_cols = sum(map(lambda x: x.relcol_dados_tam or 1, i.rellin_colunas))

                if i.rellin_divide_linha_anterior:
                    a.write('-' * tam_cols + '\r\n')

                for col in i.rellin_colunas:
                    # width = (col.relcol_dados_tam or 1)/float(tam_cols) * 100
                    width = col.relcol_dados_tam or 1
                    text = obj_adm_utils.admutl_remover_acentuacao(cr, uid, (dados_linha.get(
                        col.relcol_name) or ''))

                    corpo += formataString(text, int(width), ' ', col.relcol_dados_alinhamento,
                                           'N', 'S') + ' '

                if i.rellin_divide_linha:
                    a.write('\r\n' + '-' * tam_cols + '\r\n')

            corpo += '\r\n'
            a.write(corpo)

        a.close()
        dados_txt = open(path, 'r')
        dados_txt = dados_txt.read()
        dados_txt = base64.encodestring(dados_txt.encode('utf-8', 'strict'))

        return dados_txt

    def _gerar_planilha(self, cr, uid, estrutura, dados, context=None):
        context = context and context.copy() or {}
        #### Criacao de Planilha Excel #####
        wb = xlwt.Workbook(encoding='utf8')
        ws = wb.add_sheet(_('Relatorio'))
        ######## Definicao dos Estilos ######
        font0 = xlwt.Font()
        font0.name = 'Times New Roman'
        font0.height = 480
        font0.colour_index = 0
        font0.bold = True
        font0.shadow = True
        font1 = xlwt.Font()
        font1.name = 'Times New Roman'
        font1.height = 200
        font1.bold = False
        font1.shadow = False
        font2 = xlwt.Font()
        font2.name = 'Times New Roman'
        font2.height = 200
        font2.bold = True
        font2.shadow = False
        font3 = xlwt.Font()
        font3.name = 'Times New Roman'
        font3.height = 200
        font3.bold = True
        font3.shadow = False

        # Bloqueia toda a aba da planilha
        # ws.protect = True  # defaults to False
        # Define a senha de bloqueio
        # ws.password = "1357"
        pattern = xlwt.Pattern() # Create the Pattern
        pattern.pattern = xlwt.Pattern.SOLID_PATTERN
        pattern.pattern_fore_colour = 0x18 # cor de fundo da celula

        borders = xlwt.Borders() # Create Borders
        borders.left = xlwt.Borders.THIN # May be: NO_LINE, THIN, MEDIUM, DASHED, DOTTED, THICK, DOUBLE, HAIR, MEDIUM_DASHED, THIN_DASH_DOTTED, MEDIUM_DASH_DOTTED, THIN_DASH_DOT_DOTTED, MEDIUM_DASH_DOT_DOTTED, SLANTED_MEDIUM_DASH_DOTTED, or 0x00 through 0x0D.
        borders.right = xlwt.Borders.THIN
        borders.top = xlwt.Borders.THIN
        borders.bottom = xlwt.Borders.THIN

        # Cria um estilo para desbloquear uma celula
        styleDesbloqueado1 = xlwt.easyxf("protection: cell_locked false;")  # igual a style4 mas desbloqueado
        styleDesbloqueado1.font = font3
        styleDesbloqueado1.num_format_str = '_(#,##0.00_);(#,##0.00)'
        styleDesbloqueado2 = xlwt.easyxf("protection: cell_locked false;")  # igual a style7 mas desbloqueado
        styleDesbloqueado2.font = font1
        styleDesbloqueado2.alignment.horz = xlwt.Alignment.HORZ_RIGHT
        styleDesbloqueado3 = xlwt.easyxf("protection: cell_locked false;")  # igual a style3 mas desbloqueado
        styleDesbloqueado3.font = font3
        styleDesbloqueado4 = xlwt.easyxf("protection: cell_locked false;")  # igual a style6 mas desbloqueado
        styleDesbloqueado4.font = font3
        styleDesbloqueado4.num_format_str = '_(#,##0_);(#,##0)'
        styleDesbloqueado5 = xlwt.easyxf("protection: cell_locked false;")  # igual a style9 mas desbloqueado
        styleDesbloqueado5.font = font3
        styleDesbloqueado5.num_format_str = '_("%" #,##0_);(#,##0)'
        styleDesbloqueado6 = xlwt.easyxf("protection: cell_locked false;")  # igual a style8 mas desbloqueado
        styleDesbloqueado6.font = font3
        styleDesbloqueado6.num_format_str = 'DD/MM/YYYY'
        styleDesbloqueado1.pattern = pattern
        styleDesbloqueado2.pattern = pattern
        styleDesbloqueado3.pattern = pattern
        styleDesbloqueado4.pattern = pattern
        styleDesbloqueado5.pattern = pattern
        styleDesbloqueado6.pattern = pattern
        styleDesbloqueado1.borders = borders
        styleDesbloqueado2.borders = borders
        styleDesbloqueado3.borders = borders
        styleDesbloqueado4.borders = borders
        styleDesbloqueado5.borders = borders
        styleDesbloqueado6.borders = borders
        # Cria um estilo para bloquear uma celula
        read_only = xlwt.easyxf("")  # "cell_locked true" is default

        style0 = xlwt.XFStyle()
        style0.font = font0
        style0.alignment.horz = xlwt.Alignment.HORZ_CENTER
        style0.alignment.vert = xlwt.Alignment.VERT_CENTER
        style1 = xlwt.XFStyle()
        style1.font = font1
        style1.borders = borders
        style2 = xlwt.XFStyle()
        style2.font = font2
        style3 = xlwt.XFStyle()
        style3.font = font3
        #style3.num_format_str = '_("$"* #,##0.00_);_("$"* (#,##0.00))'
        style3.num_format_str = '_("$"* #,##0.00_);_("$"* (#,##0.00))'
        style4 = xlwt.XFStyle()
        style4.font = font3
        style4.num_format_str = '_(#,##0.00_);(#,##0.00)'
        style5 = xlwt.XFStyle()
        style5.font = font3
        style5.alignment.horz = xlwt.Alignment.HORZ_RIGHT
        style6 = xlwt.XFStyle()
        style6.font = font3
        style6.num_format_str = '_(#,##0_);(#,##0)'
        style7 = xlwt.XFStyle()
        style7.font = font1
        style7.alignment.horz = xlwt.Alignment.HORZ_RIGHT
        style7.borders = borders
        style8 = xlwt.XFStyle()
        style8.font = font3
        style8.num_format_str = 'DD/MM/YYYY'
        style9 = xlwt.XFStyle()
        style9.font = font3
        style9.num_format_str = '_("%" #,##0_);(#,##0)'
        #####################
        ##### CAbecalho #####

        pagina = RelPagina()
        pagina.set_vals(estrutura)
        row = 0
        for cab in pagina.relpag_cabecalhos:
            n_col = 0
            dados_cab = dados.get(cab.relcab_name)
            if not dados_cab:
                continue
            pattern_old = False
            if cab.relcab_cor:
                pattern_old = style1.pattern
                style1.pattern = pattern

            for col in cab.relcab_colunas:
                text = dados_cab.get(col.relcol_name)
                text = text.replace('|pag|', '')
                ws.write(row, n_col, text, style1)
                n_col += 1

            if pattern_old:
                style1.pattern = pattern_old

            row += 1

        ws.set_panes_frozen(True)
        ws.set_horz_split_pos(row)
        n_col = 2
        for linha in dados.get('linhas'):
            for i in pagina.relpag_linhas:
                n_col = 0
                dados_linha = linha.get(i.rellin_name)
                if not dados_linha:
                    continue
                for col in i.rellin_colunas:
                    text = dados_linha.get(col.relcol_name)
                    ws.col(n_col).width = col.relcol_dados_tam * 300
                    ws.write(row, n_col, text, style1)
                    n_col += 1

                row += 1

        ws.write_merge(row, row, 0, n_col and n_col-1 or 1, _('Sig Informatica Ltda           '),
                       style7)
        filename = 'relatorio'
        wb.save('/tmp/%s.xls' % filename)
        xml = open('/tmp/%s.xls' % filename, 'rb').read().encode('base64')
        return xml


        listagem.informaRodape(''.ljust(pagina.relpag_tam_linha, '-'))
        listagem.informaRodape(_('Sig Informatica Ltda   ').rjust(pagina.relpag_tam_linha))
        ws.row(0).height = 500
        ws.col(1).width = 17000
        ws.write_merge(0, 0, 0, 9, 'Cliente', style0)
        ws.write(1, 0, 'Nome :', style1)
        ws.write(2, 0, 'Endereco :', style1)
        ws.write(3, 0, 'E-mail :', style1)
        ws.write_merge(1, 1, 1, 9, '%s' % razaoSocialCliente, style1)
        ws.write_merge(2, 2, 1, 9, '%s' % enderecoCliente, style1)
        ws.write_merge(3, 3, 1, 9, '%s' % emailCliente, style1)
        ws.row(5).height = 500
        ws.write_merge(5, 5, 0, 9, 'Fornecedor', style0)
        ws.write(6, 0, 'Nome :', style1)
        ws.write(7, 0, 'Endereco :', style1)
        ws.write(8, 0, 'E-mail :', style1)
        ws.write_merge(6, 6, 1, 9, '%s' % nomeFantasiaFornecedor, style1)
        ws.write_merge(7, 7, 1, 9, '%s' % enderecoFornecedor, style1)
        ws.write_merge(8, 8, 1, 9, '%s' % emailFornecedor, style1)
        ws.row(10).height = 500
        ws.write_merge(10, 10, 0, 9, 'Itens', style0)
        ws.write_merge(11, 11, 0, 1, 'Produto', style2)
        ws.write(11, 2, 'Grade', style2)
        ws.write(11, 3, 'Quantidade', style2)
        ws.col(4).width = 5000
        ws.write(11, 4, 'Embalagem', style2)
        ws.write(11, 5, 'Validade(Dias)', style2)
        ws.write(11, 6, 'ICMS(%)', style2)
        ws.write(11, 7, 'IPI(%)', style2)
        ws.write(11, 8, 'Preco Un.', style2)
        ws.write(11, 9, 'Preco Total', style2)
        ws.write(11, 10, 'Controle', style2)
        lin = 11
        #Itens da cotacao
        estpar_dados = self.pool.get('estoque.parametro').estpar_get_fields(
            cr, uid, fields_to_read=['estpar_tamanho_codigo'], context=context
        )
        if isinstance(estpar_dados, list):
            estpar_dados = estpar_dados[0]
        tamanho_codigo_produto = estpar_dados['estpar_tamanho_codigo']
        for i in obj_cotacao.cotacoes_itens_ids:
            lin += 1
            cotacao_item_id = i.id
            produto_codigo = str(i.requisicao_itens_id.produto_id.codigo).rjust(tamanho_codigo_produto, '0')
            produto_name = '%s' % (i.requisicao_itens_id.produto_id.name,)
            produto_grade_sigla = i.requisicao_itens_id.grade_id.grade
            produto_qtd = i.requisicao_itens_id.quantidade
            embalagem = i.requisicao_itens_id.comrit_produto_embalagem_id.embalagem_id.name
            ws.write(lin, 0, produto_codigo)
            ws.write(lin, 1, produto_name)
            ws.write(lin, 2, produto_grade_sigla)
            ws.write(lin, 3, produto_qtd, styleDesbloqueado1)
            ws.write(lin, 4, embalagem)
            ws.write(lin, 5, '', styleDesbloqueado4)
            ws.write(lin, 6, '', styleDesbloqueado4)
            ws.write(lin, 7, '', styleDesbloqueado5)
            ws.write(lin, 8, '', styleDesbloqueado3)
            ws.write(lin, 9,
                     xlwt.Formula("(D%d*I%d)+(D%d*I%d*H%d/100)" % (lin + 1, lin + 1,
                                                                   lin + 1, lin + 1,
                                                                   lin + 1)), style3)
            ws.write(lin, 10, cotacao_item_id)
        lin += 2
        ws.write_merge(lin, lin, 0, 6, _('Total dos itens do Pedido '), style2)
        ws.write(lin, 8,
                 xlwt.Formula("sum(J13:J%d)" % (lin)), style3)
        lin += 2
        ws.write_merge(lin, lin + 5, 0, 1, u'', style0)
        ws.row(lin).height = 500
        ws.write_merge(lin, lin, 2, 8, _('Resumo'), style0)
        ws.write_merge(lin + 1, lin + 1, 2, 3, _('Nro Cotacao :'), style7)
        ws.write(lin + 1, 4, "%06.0f" % cotacao_id)
        ws.write_merge(lin + 1, lin + 1, 6, 7, _('Tipo Frete ( CIF / FOB )'), style7)
        ws.write_merge(lin + 2, lin + 2, 2, 3, _('Validade Proposta '), style7)
        ws.write_merge(lin + 2, lin + 2, 6, 7, _('Valor do  Frete'), style7)
        ws.write_merge(lin + 3, lin + 3, 2, 3, _('Prazo para Entrega (Dias)'), style7)
        ws.write_merge(lin + 3, lin + 3, 6, 7, _('Despesas Acessorias'), style7)
        ws.write_merge(lin + 4, lin + 4, 6, 7, _('Outras Despesas'), style7)
        ws.write_merge(lin + 5, lin + 5, 2, 3, _('Total do Pedido'), style2)
        ws.write(lin + 2, 4, '', styleDesbloqueado6)
        ws.write(lin + 3, 4, '', styleDesbloqueado4)
        ws.write(lin + 1, 8, '', styleDesbloqueado3)
        ws.write(lin + 2, 8, '', styleDesbloqueado3)
        ws.write(lin + 3, 8, '', styleDesbloqueado3)
        ws.write(lin + 4, 8, '', styleDesbloqueado3)
        ws.write(lin + 5, 4,
                 xlwt.Formula(
                     'IF(I%d ="CIF";I%d;0)+I%d+I%d+I%d' % (lin + 2, lin + 3, lin + 4, lin + 5, lin - 1))
            , style3)
        ws.write_merge(lin + 6, lin + 7, 0, 8, _('©2015 SIG Solucoes em gestao.'), style5)
        filename = obj_cotacao.numero
        if not os.path.exists('/tmp/enviar'):
            os.makedirs('/tmp/enviar')
        wb.save('/tmp/enviar/%s.xls' % filename)
        xml = open('/tmp/enviar/%s.xls' % filename, 'rb').read().encode('base64')

        return xml
