# -*- encoding: utf-8 -*-
#############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
#############################################################################

from openerp.osv import osv, fields
import os
import ast
from openerp import tools
import codecs

class report_export(osv.TransientModel):
    def button_export(self, cr, uid, ids, context=None):
        def rm_space(txt):
            """ FUNcaO P/ REMOVER ESPAcOS """
            res = ''
            for char in txt:
                if char == ' ': char = '_'
                res += char
            return res.lower()

        context = context and context.copy() or {}
        vals = self.read(cr, uid, ids, ['report_ids','modulo_id'])
        report_ids = vals[0]['report_ids']
        modulo_id = vals[0]['modulo_id']
        modulo_name = self.pool.get('ir.module.module').browse(cr, uid,modulo_id).name

        modulo_path = os.path.join(tools.config['addons_path'], modulo_name)
        modulo_report_path = os.path.join(modulo_path, 'report')
        # Se nao existir a pasta 'report' criar
        if not os.path.exists(modulo_report_path):
            os.mkdir(modulo_report_path)

        dict_f = open(os.path.join(modulo_path, '__openerp__.py'), 'r')
        dict_s = dict_f.read()
        dict_f.close()
        dict = ast.literal_eval(dict_s) # CONVERTE STRING P/ DICIONARIO
        update_xml = []

        for id in report_ids:
            report = self.pool.get('base_report_creator.report').browse(cr, uid,id)
            model_name = ''
            report_name = rm_space(report.name)
            ref_id = 'report_export_' + report_name + '_' + str(report.id)
            for model_id in report.model_ids:
                model_name += "'"+ model_id['name'] +"',"
            #
            # CRIAcaO DO(S) ARQUIVO(OS) DEMO
            #
            xml_filename = '%s_export.xml' % report_name
            demo_file = codecs.open(os.path.join(modulo_report_path, xml_filename), 'w', 'utf-8')
            demo_file.write('<?xml version="1.0" encoding="utf-8"?>\n')
            demo_file.write('<openerp>\n')
            demo_file.write('    <data>\n')

            # CRIAR O MODEL
            view_type2 = ''
            view_type3 = ''
            if report.view_type2:
                view_type2 = report.view_type2
            if report.view_type3:
                view_type3 = report.view_type3
#            <menuitem name="Ocorrencia" id="menu_adm_ocorrencia" action="action_adm_ocorrencia" parent="adm.menu_cad_principal" sequence="50"/>

            demo_file.write('    # --- RELATORIO / %s ---\n' % report_name)
            demo_file.write('        <record id="'+ref_id+'" model="base_report_creator.report">\n')
            demo_file.write('            <field model="ir.model" search="[(' + "'model', 'in' ,(" + model_name + '))]" name="model_ids"/>\n')
            demo_file.write('            <field eval="&quot;'+report.name+'&quot;" name="name"/>\n')
            demo_file.write('            <field eval="&quot;'+report.view_graph_type+'&quot;" name="view_graph_type"/>\n')
            demo_file.write('            <field eval="&quot;'+view_type3+'&quot;" name="view_type3"/>\n')
            demo_file.write('            <field eval="&quot;'+view_type2+'&quot;" name="view_type2"/>\n')
            demo_file.write('            <field eval="&quot;'+report.view_type1+'&quot;" name="view_type1"/>\n')
            demo_file.write('            <field eval="&quot;'+report.type+'&quot;" name="type"/>\n')
            demo_file.write('            <field eval="&quot;'+report.view_graph_orientation+'&quot;" name="view_graph_orientation"/>\n')
            demo_file.write('            <field eval="&quot;'+report.sql_query+'&quot;" name="sql_query"/>\n')
            demo_file.write('            <field eval="&quot;1&quot;" name="active"/>\n')
            demo_file.write('        </record>\n')
            # CRIAR O CAMPOS
            field_ids = report.field_ids
            if field_ids:
                demo_file.write('    # --- CAMPOS ---\n')
                for id_field in field_ids:
                    fields = self.pool.get('base_report_creator.report.fields').read(cr, uid, id_field['id'], ['field_id','sequence'])
                    model_fields = self.pool.get('ir.model.fields').read(cr, uid, fields['field_id'][0], ['name','model'])
                    demo_file.write('        <record id="base_report_creator_movimento_fields_'+str(id_field['id'])+'" model="base_report_creator.report.fields">\n')
                    demo_file.write('            <field name="report_id" ref="'+ref_id+'"/>\n')
                    demo_file.write('            <field model="ir.model.fields" name="field_id" search="[('+"'name','=','"+model_fields['name']+ "'),('model','=','" + model_fields['model'] + "'"')]"/>\n')
                    demo_file.write('            <field eval="'+str(fields['sequence'])+'" name="sequence"/>\n')
                    demo_file.write('        </record>\n')
            # CRIAR O FILTROS
            filter_ids = report.filter_ids
            if report.filter_ids:
                demo_file.write('    # --- FILTROS ---\n')
                for id_filter in filter_ids:
                    fields = self.pool.get('base_report_creator.report.filter').read(cr, uid, id_filter['id'], ['expression','name','condition'])
                    demo_file.write('        <record id="base_report_creator_movimento_filter_'+str(id_filter['id'])+'" model="base_report_creator.report.filter">\n')
                    demo_file.write('            <field name="report_id" ref="'+ref_id+'"/>\n')
                    demo_file.write('            <field eval="&quot;'+fields['name']+'&quot;" name="name"/>\n')
                    demo_file.write('            <field eval="&quot;'+fields['expression']+'&quot;" name="expression"/>\n')
                    demo_file.write('            <field eval="&quot;'+fields['condition']+'&quot;" name="condition"/>\n')
                    demo_file.write('        </record>\n')
            #
            # CRIACAO DAS ACTIONS
            #
            action_ids = self.pool.get('ir.actions.act_window').search(cr, uid, [('context', '=', "{'report_id':"+str(id)+'}')])
            if not action_ids:
                print 'ids', report_ids
                print 'nao existem actions para este relatorio'
            else:
                view = report.view_type1
                if report.view_type2:
                    view+=','+report.view_type2
                if report.view_type3:
                    view+=','+report.view_type3
                for action_id in action_ids:
                    demo_file.write('    # --- ACTION(S) ---\n')

                    action_name = 'action_'+report_name+'_'+str(action_id)
                    demo_file.write('        <record id="'+action_name+'" model="ir.actions.act_window">\n')
                    demo_file.write('            <field eval="&quot;'+report.name+'&quot;" name="name"/>\n')
                    demo_file.write('            <field eval="&quot;form&quot;" name="view_type"/>\n')
                    demo_file.write('            <field eval="&quot;'+view+'&quot;" name="view_mode"/>\n')
                    demo_file.write('            <field eval="&quot;{'+"'"+'report_id'+"'"+':%d}&quot;%'+ref_id+'" name="context"/>\n')
                    demo_file.write('            <field eval="&quot;base_report_creator_report.result&quot;" name="res_model"/>\n')
                    demo_file.write('        </record>\n')
                    searc_ = [('value', '=', 'ir.actions.act_window,'+str(action_id))]
                    values_ids = self.pool.get('ir.values').search(cr, uid, searc_)
                    if not values_ids:
                        searc_ = [('value', '=', 'ir.actions.act_window, '+str(action_id))]
                        values_ids = self.pool.get('ir.values').search(cr, uid, searc_)
                    print '**********', values_ids
                    for values_id in values_ids:
                        res_id = self.pool.get('ir.values').read(cr, uid, values_id,['res_id'])['res_id']
                        menu = self.pool.get('ir.ui.menu').read(cr, uid, res_id,['parent_id', 'name'])
                        parent_id = str( menu['parent_id'][1])
                        menu_name = 'mnu_report_'+report_name+'_'+str(values_id)
                        demo_file.write('        # --- MENU ---| '+menu_name+' |\n')
                        demo_file.write('        <record id="'+menu_name+'" model="ir.ui.menu">\n')
                        demo_file.write('            <field eval="&quot;'+menu['name']+'&quot;" name="name"/>\n')
                        demo_file.write('            <field eval="&quot;'+parent_id+'&quot;" name="parent_id"/>\n')
                        demo_file.write('            <field model="ir.ui.menu" search="[(' + "'name', '=' ,'"+parent_id+"'"+')]" name="parent_id"/>\n')
                        demo_file.write('            <field eval="'+"'"+'ir.actions.act_window,%d'+"'"+'%'+action_name+'" name="action"/>\n')
                        demo_file.write('            <field eval="&quot;STOCK_SELECT_COLOR&quot;" name="icon"/>\n')
                        demo_file.write('        </record>\n')

                        values_name = 'values_report_'+report_name+'_'+str(values_id)
                        demo_file.write('        # --- IR.VALUES ---| '+menu_name+' |\n')
                        demo_file.write('        <record id="'+values_name+'" model="ir.values">\n')
                        demo_file.write('            <field eval="&quot;Menuitem&quot;" name="name"/>\n')
                        demo_file.write('            <field eval="&quot;action&quot;" name="key"/>\n')
                        demo_file.write('            <field eval="&quot;tree_but_open&quot;" name="key2"/>\n')
                        demo_file.write('            <field eval="&quot;ir.ui.menu&quot;" name="model"/>\n')
                        demo_file.write('            <field eval="'+"'"+'ir.actions.act_window,%d'+"'"+'%'+action_name+'" name="value"/>\n')
                        demo_file.write('            <field eval="'+menu_name+'" name="res_id"/>\n')
                        demo_file.write('            <field eval="True" name="object"/>\n')
                        demo_file.write('        </record>\n')
            demo_file.write('    </data>\n')
            demo_file.write('</openerp>\n')
            demo_file.close()
            flag = False
            # VERIFICA SE O DEMO Ja EXISTE NO TERP
            st = xml_filename
            for i in dict['update_xml']:
                if i == st:
                    flag = True
            if not flag:
                update_xml += ['report/%s' % xml_filename]
        dict['update_xml'] += update_xml

        #
        # CRIAcaO DO ARQUIVO __openerp__.py
        #

        # VERIFICA SE O MODULO base_report_creator Ja EXISTE NO TERP
        flag = False
        for i in dict['depends']:
            if i == 'base_report_creator':
                flag = True
        if not flag:
            dict['depends'] += ['base_report_creator']
        # CRIA UM ARQUIVO DE BACKUP DO TERP
        if not os.path.exists(os.path.join(modulo_path, '__openerp__.bak')):
            terp_bak = open(os.path.join(modulo_path, '__openerp__.bak'), 'w')
            terp_bak.write(dict_s)
            terp_bak.close()
        #

        terp_file = open(os.path.join(modulo_path, '__openerp__.py'),'w')
        terp_file.write('{\n')
        if dict.get('name'):
            terp_file.write('    '+"'name'"+':'+ "'" +dict['name']+"',\n")
        if dict.get('version'):
            terp_file.write('    '+"'version'"+':'+ "'" +dict['version']+"',\n")
        if dict.get('category'):
            terp_file.write('    '+"'category'"+':'+ "'" +dict['category']+"',\n")
        if dict.get('author'):
            terp_file.write('    '+"'author'"+':'+ "'" +dict['author']+"',\n")
        if dict.get('website'):
            terp_file.write('    '+"'website'"+':'+ "'" +dict['website']+"',\n")
        if dict.get('description'):
            terp_file.write('    '+"'description'"+':'+ '"""' +dict['description']+'""",\n')
        for i in dict:
            if i == 'depends':
                terp_file.write('    '+"'"+i+"'"+': [\n')
                for vals in dict[i]:
                    terp_file.write('        '+"'"+vals+"',\n")
                terp_file.write('    ],\n')
            if i == 'init_xml':
                terp_file.write('    '+"'"+i+"'"+': [\n')
                for vals in dict[i]:
                    terp_file.write('        '+"'"+vals+"',\n")
                terp_file.write('    ],\n')
            if i == 'update_xml':
                terp_file.write('    '+"'"+i+"'"+': [\n')
                for vals in dict[i]:
                    terp_file.write('        '+"'"+vals+"',\n")
                terp_file.write('    ],\n')
            if i == 'data':
                terp_file.write('    '+"'"+i+"'"+': [\n')
                for vals in dict[i]:
                    terp_file.write('        '+"'"+vals+"',\n")
                terp_file.write('    ],\n')
            if i == 'demo':
                terp_file.write('    '+"'"+i+"'"+': [\n')
                for vals in dict[i]:
                    terp_file.write('        '+"'"+vals+"',\n")
                terp_file.write('    ],\n')
        #
        if dict.get('certificate'):
            terp_file.write('    '+"'certificate'"+':'+ "'" +dict['certificate']+"',\n")
        if dict.get('active'):
            if dict['active']:
                dict['active'] = True
            else:
                dict['active'] = 'False'
            terp_file.write('    '+"'active'"+':'+ "'" +dict['active']+"',\n")
        if dict.get('installable'):
            if dict['installable']:
                installable = True
            else:
                installable = 'False'
            terp_file.write('    '+"'installable'"+':'+ "'" +installable+"',\n")
        terp_file.write('}')
        terp_file.close()
        return {'type': 'ir.actions.act_window_close'}


    _name = 'report.export'
    _columns = {
        'report_ids': fields.many2many('base_report_creator.report','report_export_reports', 'report_id', 'name','Relatorios', required=True),
        'modulo_id': fields.many2one('ir.module.module', 'Modulo', required=True)
    }
    _defaults = {
        'modulo_id': lambda *a: 167
    }
report_export()
