# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from openerp.osv import fields,osv
from openerp import tools


class report_project_br_user_carga(osv.Model):
    _name = "report_project_br.user.carga"
    _inherit = "report_project_br.user.carga"
    
    def init(self, cr):
        tools.sql.drop_view_if_exists(cr, "report_project_br_user_carga")
        cr.execute("""
              create view report_project_br_user_carga as (
               select t.user_id as id, t.user_id, u.nome,
                  (select sum(planned_hours) from project_br_task where user_id=t.user_id and date_part('month',date_start) = 1 and date_start >  now()) as jan,
                  (select sum(planned_hours) from project_br_task where user_id=t.user_id and date_part('month',date_start) = 2 and date_start >  now()) as fev,
                  (select sum(planned_hours) from project_br_task where user_id=t.user_id and date_part('month',date_start) = 3 and date_start >  now()) as mar,
                  (select sum(planned_hours) from project_br_task where user_id=t.user_id and date_part('month',date_start) = 4 and date_start >  now()) as abr,
                  (select sum(planned_hours) from project_br_task where user_id=t.user_id and date_part('month',date_start) = 5 and date_start >  now()) as mai,
                  (select sum(planned_hours) from project_br_task where user_id=t.user_id and date_part('month',date_start) = 6 and date_start >  now()) as jun,
                  (select sum(planned_hours) from project_br_task where user_id=t.user_id and date_part('month',date_start) = 7 and date_start >  now()) as jul,
                  (select sum(planned_hours) from project_br_task where user_id=t.user_id and date_part('month',date_start) = 8 and date_start >  now()) as ago,
                  (select sum(planned_hours) from project_br_task where user_id=t.user_id and date_part('month',date_start) = 9 and date_start >  now()) as set,
                  (select sum(planned_hours) from project_br_task where user_id=t.user_id and date_part('month',date_start) = 10 and date_start >  now()) as out,
                  (select sum(planned_hours) from project_br_task where user_id=t.user_id and date_part('month',date_start) = 11 and date_start >  now()) as nov,
                  (select sum(planned_hours) from project_br_task where user_id=t.user_id and date_part('month',date_start) = 12 and date_start >  now()) as dez
                  from project_br_task t, adm_pessoa u
                  where t.date_start > now() and u.id=t.user_id 
                  group by t.user_id, u.nome
                )""")
