# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import fields,osv
import mx.DateTime


class  report_closed_task_br(osv.Model):
    _name = "report.closed.task_br"
    _inherit = "report.closed.task_br"

    def init(self, cr):
        cr.execute('''
            create or replace view report_closed_task_br as (
                select
                   tsk.id as id, tsk.sequence as sequence, tsk.name as name,
                   tsk.project_br_id as project_id, tsk.user_id as user_id,
                   tsk.date_deadline as date_deadline, tsk.planned_hours as planned_hours,
                   tsk.delay_hours as delay_hours, tsk.progress as progress,
                   tsk.priority as priority, tsk.state as state,
                   tsk.remaining_hours as remaining_hours, tsk.date_close as date_close
                from
                    project_br_task tsk
                where
                    (tsk.date_close <= CURRENT_DATE AND tsk.date_close > (CURRENT_DATE-15))
            )
        ''')
