# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import fields,osv
import mx.DateTime

class  report_task_br_user_pipeline_open (osv.Model):

    _name = "report.task_br.user.pipeline.open"
    _inherit = "report.task_br.user.pipeline.open"

    def init(self, cr):
        cr.execute('''
            create or replace view report_task_br_user_pipeline_open as (
                select
                    min(t.id) as id,
                    u.id as user_id,
                    u.company_id as company_id,
                    count(t.*) as task_nbr,
                    sum(t.planned_hours) as task_hrs,
                    sum(t.planned_hours * (100 - t.progress) / 100) as task_progress,
                    case when t.state is null then 'no' else t.state end as task_state
                from
                    res_users u
                left join 
                    project_br_task t on (u.id = t.user_id)
                where
                    u.active
                group by
                    u.id, u.company_id, t.state
            )
        ''')

    def read(self, cr, uid, ids, fields=None, context=None, load='_classic_read'):
        res = []
        for id in ids:
            if id:
                res.append(id)
        return super(report_task_br_user_pipeline_open, self).read(cr, uid, res, fields=fields, context=context, load=load)
