# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import fields,osv
import mx.DateTime


class  report_closed_task_br(osv.Model):
    _name = "report.closed.task_br"
    _description = "Closed Task Report"
    _auto = False
    _columns = {
        'sequence': fields.integer('Sequence', readonly=True),
        'name': fields.char('Task summary', size=128, readonly=True),
        'project_id': fields.many2one('project_br.project_br', 'Project', readonly=True),
        'user_id': fields.many2one('res.users', 'Assigned to', readonly=True),
        'date_deadline': fields.datetime('Deadline', readonly=True),
        'planned_hours': fields.float('Planned Hours', readonly=True),
        'delay_hours': fields.float('Delay Hours', readonly=True),
        'progress': fields.float('Progress (%)', readonly=True),
        'priority' : fields.selection([('4','Very Low'), ('3','Low'), ('2','Medium'), ('1','Urgent'), ('0','Very urgent')], 'Importance', readonly=True),
        'state': fields.selection([('draft', 'Draft'),('open', 'In Progress'),('pending', 'Pending'), ('cancelled', 'Cancelled'), ('done', 'Done')], 'Status', readonly=True),
        'remaining_hours': fields.float('Remaining Hours', readonly=True),
        'date_close' : fields.datetime('Date Closed', readonly=True)
    }
