# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class reuniao_atas(osv.Model):
    """
    Tabela de Atas das reunioes
    Prefixo: reuata_
    """
    _name = 'reuniao.atas'
    _rec_name = 'reuata_reuniao_id'
    _columns = {
        'reuata_reuniao_id': fields.many2one("reuniao.reunioes", 'Reuniao', ondelete="cascade",
                                             required=True,
                                             select=True),  # id da reuniao
        'reuata_sequencia': fields.integer('Sequencia', required=True),
        # Sequencia do assunto contido na ata
        'reuata_pauta_id': fields.many2one("reuniao.pautas", 'Pauta', ondelete="no action",
                                           select=True,
                                           domain="[('reupau_reunioes_id', '=', reuata_reuniao_id)]"),
        'reuata_texto': fields.text('Texto', required=True),
        'reuata_marcadores_ids': fields.many2many('reuniao.marcadores',
                                                  'reuniao_marcadores_atas_rel', 'reuniao_id',
                                                  'ata_id', 'Marcadores'),
    }
    _order = 'reuata_reuniao_id,reuata_sequencia'
