# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
import time


class reuniao_reunioes(osv.Model):
    """
    Tabela de Reunioes
    Prefixo: reureu_
    """
    _name = 'reuniao.reunioes'
    _columns = {
        'name': fields.char('Descricao', size=45, required=True),
        'reureu_data': fields.date('Data', required=True),  # Data da reuniao
        'reureu_horario': fields.float('Horario', digits=(3, 2)),  # Horário de inicio da reuniao
        'reureu_tipo_id': fields.many2one("reuniao.tipos", 'Tipo', ondelete="restrict",
                                          select=True),  # Tipos de reuniao
        'reureu_duracao': fields.float('Duracao', digits=(3, 2)),  # Tempo de duracao
        'reureu_pautas_ids': fields.one2many('reuniao.pautas', 'reupau_reunioes_id', 'Pautas'),
        'reureu_participantes_ids': fields.one2many('reuniao.participantes', 'reupar_reuniao_id',
                                                    'Participantes'),
        'reureu_atas_ids': fields.one2many('reuniao.atas', 'reuata_reuniao_id', 'Atas'),
    }

