# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class rh_funcionario(osv.Model):
    """
    Classe funcionario
    Prefixo: rhfunc
    """
    _name = 'rh.funcionario'
    _inherits = {
        'adm.pessoa': 'pessoa',
    }

    from funcoes import _rhfunc_check_matricula

    _roteavel = True
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'pessoa': fields.many2one("adm.pessoa", 'Funcionario', ondelete="cascade", required=True, select=True,
                                  domain="[('pessoa_tipo', '=', 'F')]"),
        'centro_custo': fields.many2one("adm.empresa.centrocusto", 'Centro de custo', ondelete="restrict", select=True,
                                        domain="[('company_id', '=', company_id)]"),
        'matricula': fields.integer('Matricula', select=True),
        'cargo': fields.many2one("rh.cargo", 'Cargo', ondelete="restrict", select=True),
        'active': fields.boolean('Ativo'),
        'rh_dt_admissao': fields.date('Data de admissao'),
        'rhfunc_habilidade_ids': fields.many2many('rh.habilidade',
                                                  'rh_funcionario_habilidade',
                                                  'funcionario_id', 'habibilidade_id',
                                                  'Habilidades'),
        'rhfunc_pis': fields.char('PIS', size=15, select=True)
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        'active': lambda *a: True,
        'pessoa_tipo': lambda *a: 'F',

    }
    _constraints = [(_rhfunc_check_matricula, _('A matricula nao pode ser repetida!'), ['matricula'])]



