# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler
import time

class rhcurriculo_cursos_tipos(osv.Model):
    """
    tabela de Tipos de cursos
    """
    _name = 'rhcurriculo.cursos.tipos'
    _columns = {
        'name' : fields.char('Descricao', size=45, required=True), # Descricao do curso
        'apelido' : fields.char('Apelido', size=5, required=True, select = True), # Apelido do curso
        'cursos_ids' : fields.one2many('rhcurriculo.cursos', 'cursos_tipos_id','Cursos'),
    }
    _sql_constraints = [
        ('apelido_uniq', 'unique (apelido)', 'O apelido precisa ser unico!'),
    ]
rhcurriculo_cursos_tipos()

class rhcurriculo_cursos(osv.Model):
    """
    Cursos realizados
    """
    def _get_cidade(self, cr, uid, ids, name, arg, context=None):
        context = context and context.copy() or {}
        res={}
        for empresa in self.browse(cr, uid, ids):
            if empresa.cidade_id:
                res[empresa.id] = empresa.cidade_id.name
            else:
                res[empresa.id] = False
        return res
    def _get_estado(self, cr, uid, ids, name, arg, context=None):
        context = context and context.copy() or {}
        res={}
        for empresa in self.browse(cr, uid, ids):
            if empresa.uf_id:
                res[empresa.id] = empresa.uf_id.name
            else:
                res[empresa.id] = False
        return res
    _name = 'rhcurriculo.cursos'
    _columns = {
        'sequence' : fields.integer('Sequencia'),
        'cursos_tipos_id' : fields.many2one("rhcurriculo.cursos.tipos", 'Tipos de cursos', ondelete="restrict", required=True, select = True), # Id do tipo de curso\n
        'curriculo_id' : fields.many2one("rhcurriculo.curriculo", 'Curriculo', ondelete="cascade", required=True, select = True), # Id do curriculo
        'instituicao': fields.char('Instituicao', size=60), # Nome da instituicao onde fez o curso
        'name' : fields.char('Descricao', size=60), # descricao do curso
        'mes_conclusao': fields.char('Mes de conclusao', size=2), # Mes de admissao nesta empresa
        'ano_conclusao': fields.char('Ano de conclusao', size=4), # Ano de admissao nesta empresa
        'cidade_str' : fields.char('Cidade', size=45),
        'uf_id' : fields.many2one("adm.uf", 'Uf', ondelete="restrict", select = True), # Id do estado(UF)
        'cidade_id' : fields.many2one("adm.cidade", 'Cidade', ondelete="restrict",  domain="[('uf_id', '=', uf_id)]", select = True), # Id da cidade
        'cidade' : fields.function(_get_cidade, method=True, type="char", string='Cidade'),
        'uf' : fields.function(_get_estado, method=True, type="char", string='Estado'),
    }
rhcurriculo_cursos()

