# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler
import time

class rhcurriculo_empresas(osv.Model):
    """
    Tabela de empresas trabalhadas
    
    """
    def _get_cidade(self, cr, uid, ids, name, arg, context=None):
        context = context and context.copy() or {}
        res={}
        for empresa in self.browse(cr, uid, ids):
            if empresa.cidade_id:
                res[empresa.id] = empresa.cidade_id.name
            else:
                res[empresa.id] = False
        return res
    def _get_estado(self, cr, uid, ids, name, arg, context=None):
        context = context and context.copy() or {}
        res={}
        for empresa in self.browse(cr, uid, ids):
            if empresa.uf_id:
                res[empresa.id] = empresa.uf_id.name
            else:
                res[empresa.id] = False
        return res
    _name = 'rhcurriculo.empresas'
    _rec_name = 'empresa'
    _columns = {
        'sequence' : fields.integer('Sequencia'),
        'empresa' : fields.char('Empresa', size=45), # empresa onde trabalhou
        'segmento' : fields.char('Segmento', size=45), # empresa onde trabalhou
        'mes_entrada' : fields.char('Mes de admissao', size=2), # Mes de admissao nesta empresa
        'ano_entrada' : fields.char('Ano de admissao', size=4), # Ano de admissao nesta empresa
        'mes_saida' : fields.char('Mes da rescisao', size=2), # Mes de rescisao nesta empresa
        'ano_saida' : fields.char('Ano ds rescisao', size=4), # Ano de rescisao nesta empresa
        'cargo' : fields.char('Cargo', size=30), # Cargo ocupado
        'atribuicoes' : fields.text('Atribuicoes'), # Atribuicoes e Realizacoes na empresa
        'curriculo_id' : fields.many2one("rhcurriculo.curriculo", 'Curriculo', ondelete="restrict", select = True), # Id do curriculo
        'uf_id' : fields.many2one("adm.uf", 'Estado', ondelete="restrict", select = True), # Estado(UF) da empresa\n
        'cidade_id' : fields.many2one("adm.cidade", 'Cidade', ondelete="restrict",  domain="[('uf_id', '=', uf_id)]", select = True), # Cidade
        'cidade' : fields.function(_get_cidade, method=True, type="char", string='Cidade'),
        'uf' : fields.function(_get_estado, method=True, type="char", string='Estado'),
        'modalidade' : fields.selection([('', ''),('C', 'CONSULTOR'),
                                        ('E', 'EMPREGADO'),('P', 'EMPRESARIO'),('A', 'AUTONOMO')],
                                        'Modalidade', size=1)
    }
    _order = 'sequence, ano_entrada, mes_entrada'
rhcurriculo_empresas()

