# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler
import time

class rhcurriculo_entrevista(osv.Model):
    """
    Cadastro das entrevistas realizadas com os candidatos
    """
    def _get_name(self, cr, uid, ids, name, arg, context=None):
        context = context and context.copy() or {}
        res={}
        for entrevista in self.browse(cr, uid, ids):
            if entrevista.curriculo_id:
                res[entrevista.id] = entrevista.curriculo_id.pessoa_id.name
            else:
                res[entrevista.id] = False
        return res


    _name = 'rhcurriculo.entrevista'
    _columns = {
        'name' : fields.function(_get_name, method=True, type="char", string='Nome'),    
        'curriculo_id' : fields.many2one("rhcurriculo.curriculo", 'Curriculo', ondelete="cascade", required=True, select = True), # id do curriculo do candidato
        'experiencia_profissional' : fields.text('Experiencia profissional'), # Experiencia profissional
        'lazer' : fields.text('Lazer e outras atividades'), # Lazer e outras atividades\n
        'religiao' : fields.char('Religiao', size=45), # religiao professada
        'familia' : fields.text('Familia'), # Dados familiares
        'familia_relacionamento' : fields.text('Relacionamento familiar'), # Relacionamento familiar
        'saude' : fields.text('Saude'), # Saude do candidato
        'fuma' : fields.selection([('S','Sim'), ('N', 'Nao')], 'Fuma', size=1), # informa se o entrevistado e fumante\nS=Sim\nN=Nao
        'fuma_complemento' : fields.char('Fuma complemento', size=45), # Informacao complementar sobre fumante
        'bebe' : fields.selection([('S','Sim'), ('N', 'Nao')], 'Bebe', size=1), # Informa se o entrevistado faz uso de bebida alcoolica
        'bebe_complemento' : fields.char('Bebe complemento', size=45), # Informacao complementar sobre o habito da bebida
        'qualidade' : fields.char('Qualidade', size=60),
        'ponto_a_desenvolver' : fields.char('Ponto a desenvolver', size=60),
        'situacoes_dificeis' : fields.text('Situacoes dificeis'),
        'motivacao' : fields.text('Motivacao'), # Motivacao para o cargo
        'observacao' : fields.text('Observacoes'), # Observacoes do entrevistador
        'entrevistador_id' : fields.many2one("adm.pessoa", 'Entrevistador', ondelete="no action", required=True, select = True, domain="[('pessoa_tipo','=','F')]"), # id da pessoa que entrevistou
        'data_entrevista' : fields.date('Data da entrevista'), # Data da entrevista
        'selecao_ids' : fields.one2many('rhcurriculo.selecao', 'entrevista_id','Selecao'),
    }
rhcurriculo_entrevista()

class rhcurriculo_curriculo(osv.Model):
    _name = 'rhcurriculo.curriculo'
    _inherit = 'rhcurriculo.curriculo'
    _columns = {
        'entrevista_ids' : fields.one2many('rhcurriculo.entrevista', 'curriculo_id','Entrevista'),
        }
rhcurriculo_curriculo()
