# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler
import time

class rhcurriculo_selecao(osv.Model):
    """
    Tabela de candidatos indicados aos cargos
    Contem tambem a ordem de probabilidade de contratacao
    alem da indicacao de contratacao, bem como de nao contratacao
    com a destricao do motivo para a nao contratacao
    """
    def _get_name(self, cr, uid, ids, name, arg, context=None):
        context = context and context.copy() or {}
        res={}
        for selecao in self.browse(cr, uid, ids):
            if selecao.entrevista_id:
                nome=selecao.entrevista_id.curriculo_id.pessoa_id.name
                contratante=selecao.vagas_id.contratante_id.name
                res[selecao.id] = nome + ' / '+contratante
            else:
                res[selecao.id] = False
        return res
    _name = 'rhcurriculo.selecao'
    _columns = {
        'name' : fields.function(_get_name, method=True, type="char", string='Descricao'),    
        'entrevista_id' : fields.many2one("rhcurriculo.entrevista", 'Entrevista', ondelete="no action", required=True, select = True), #Id da entrevista,
        'vagas_id' : fields.many2one("rhcurriculo.vagas", 'Perfil de contratacao', ondelete="no action", required=True, select = True), # id da vaga (Perfil de contratacao)
        'state' : fields.selection([('I','Indicado'), ('N', 'Nao indicado'), ('A', 'Stand by')], 'Situacao', size=1), # Parecer do candidato para a vaga\nI=Candidato Indicado\nN=Candidato nao indicado\nA=Avaliando o candidato\n
        'state_descricao' : fields.char('Motivo', size=60), # Descricao do estado
        'state_n' : fields.selection([(' ','Nao se aplica'), ('P', 'Nao tem perfil'), ('D', 'Desqualificado pelo teste')], 'Nao indicado.(Motivo)', size=1), # Campo utilizado quando o estado e 'N'-> Nao indicado\n' '-> nao se aplica\nP -> Nao tem o perfil\nD -> Desqualificado no teste
        'sequence' : fields.integer('Ordem de contratacao'), # Indica a ordem de probabilidade de contratacao
        'contratado' : fields.integer('Contratado'), # Indica se o candidato foi contratado ou nao foi contratado
        'contratado_nao' : fields.char('Nao contratado(Motivo)', size=60), # Motivo pelo qual o candidado nao foi contratado
    }
rhcurriculo_selecao()

