from django.shortcuts import render_to_response
from django.template import RequestContext
from django.http import HttpResponseRedirect
from django.contrib.auth import authenticate, login
from django.contrib.auth.models import User
from django import forms
from django.core import validators

class LoginManipulator(forms.Manipulator):
  def __init__(self, request):
    self.fields = (
      forms.TextField(field_name="username", length=35, maxlength=30, is_required=True, validator_list=[validators.isNotEmpty]),
      forms.PasswordField(field_name='password', length=35, maxlength=30, is_required=True, validator_list=[self.isValidLogin])
    )
    self.request = request

  def isValidLogin(self, new_data, all_data):
    self.username = self.request.POST['username']
    self.password = self.request.POST['password']
    self.user = authenticate(username=self.username, password=self.password)

    if self.user is not None:
      if self.user.is_active:
        login(self.request, self.user)
      else:
        raise validators.ValidationError, "The account is locked."
    else:
      raise validators.ValidationError, "User does not exist."

def run(request):
  errors = {}
  new_data = {}
  message = ''

  manipulator = LoginManipulator(request)

  if request.GET:
    new_data = request.GET.copy()
    message = new_data['message']
  if request.POST:
    new_data = request.POST.copy()

    errors = manipulator.get_validation_errors(new_data)
    manipulator.do_html2python(new_data)

    if not errors:
      return HttpResponseRedirect('/')

  form = forms.FormWrapper(manipulator, new_data, errors)
  return render_to_response('login.html', {'form':form, 'message':message})
