# -*- coding: utf-8 -*-
from django.core import serializers
from django.http import HttpResponse
from django.http import HttpResponseRedirect
from django.shortcuts import render_to_response
from django.contrib.auth import authenticate, login
from django.core.urlresolvers import reverse
from login.models import LoginForm
from login.models import LoggedForm
import xmlrpclib, socket
import base64
from django.forms.util import ErrorList
from datetime import datetime
from django.utils import simplejson
import re
import time
from django.forms import forms, fields

dbname = 'erp'
username = 'rhexterno'
pwd = 'rhexterno'
sock_common = xmlrpclib.ServerProxy ('http://localhost:8069/xmlrpc/common')
socket.setdefaulttimeout(3)
uid = sock_common.login(dbname, username, pwd)
sock = xmlrpclib.ServerProxy('http://localhost:8069/xmlrpc/object')
def cad_endereco(cep, pessoa_id, numero, complemento):
    # LOG GERAL
    id_loggeral = sock.execute(dbname, uid, pwd, 'cep.loggeral', 'search', [('cep_log','=',cep)])
    if id_loggeral:
        res = True
        vals_loggeral = sock.execute(dbname, uid, pwd, 'cep.loggeral', 'read', id_loggeral,[])[0]
        # TIPO LOG
        tipo_id = sock.execute(dbname, uid, pwd, 'cep.tipolog', 'search', [('chave_pat','=',vals_loggeral['chvpat_log'])])
        vals_tipo = sock.execute(dbname, uid, pwd, 'cep.tipolog', 'read', tipo_id,[])[0]
        # BAIRRO
        search = [
                    ('chvloc_bai', '=', vals_loggeral['chvloc_log']),
                    ('chave_bai', '=', vals_loggeral['chvbai_log1'])
                ]
        id_bairro = sock.execute(dbname, uid, pwd, 'cep.bairros', 'search', search)
        vals_bairro = sock.execute(dbname, uid, pwd, 'cep.bairros', 'read', id_bairro, [])[0]
        # CIDADE
        id_cidade = sock.execute(dbname, uid, pwd, 'cep.localidades', 'search', [('chave_loc','=',vals_loggeral['chvloc_log'])])
        vals_cidade = sock.execute(dbname, uid, pwd, 'cep.localidades', 'read', id_cidade, [])[0]
        fields = {
                    'logradouro': vals_loggeral['nome_log'],
                    'bairro': vals_bairro['extenso_bai'],
                    'cidade': vals_cidade['nome_loc'],
                    'uf': vals_loggeral['uf_log'],
                    'tipo_log': vals_tipo['nome_pat'],
        }
        # ENDEREÇO TIPO
        endereco_tipo_id = sock.execute(dbname, uid, pwd, 'adm.endereco.tipo', 'search', [('name','=','Normal')])[0]
        # PAIS
        pais_id = sock.execute(dbname, uid, pwd, 'adm.pais', 'search', [('name','=','BRASIL')])[0]
        # ESTADO
        uf_id = sock.execute(dbname, uid, pwd, 'adm.uf', 'search', [('sigla','=',fields['uf'])])[0]
        # CIDADE
        args_search = [('pais_id','=',pais_id),('uf_id','=',uf_id)]
        args_create = {'name': fields['cidade'], 'uf_id': uf_id}
        cidade_id = sock.execute(dbname, uid, pwd, 'adm.cidade', 'search', args_search)
        if not cidade_id:
            cidade_id = sock.execute(dbname, uid, pwd, 'adm.cidade', 'create', args_create)
        else:
            cidade_id = cidade_id[0]

        # LOGRADOURO
        args_search = [('name','=',fields['logradouro']),('titulo','=',fields['tipo_log'])]
        args_create = {'name': fields['logradouro'], 'titulo': fields['tipo_log']}
        logradouro_id = sock.execute(dbname, uid, pwd, 'adm.logradouro', 'search', args_search)
        if not logradouro_id:
            logradouro_id = sock.execute(dbname, uid, pwd, 'adm.logradouro', 'create', args_create)
        else:
            logradouro_id = logradouro_id[0]
        # BAIRRO
        bairro_id = sock.execute(dbname, uid, pwd, 'adm.bairro', 'search', [('name', '=', fields['bairro'])])
        if not bairro_id:
            bairro_id = sock.execute(dbname, uid, pwd, 'adm.bairro', 'create', {'name': fields['bairro']})
        else:
            bairro_id = bairro_id[0]
        # ENDEREÇO
        args_search = [
            ('pessoa_id','=',pessoa_id)
        ]
        args_create = {
            'pessoa_id': pessoa_id, 'endereco_tipo_id': endereco_tipo_id, 'pais_id': pais_id,
            'uf_id': uf_id, 'cidade_id': cidade_id, 'bairro_id': bairro_id,
            'logradouro_id': logradouro_id, 'cep': cep, 'numero': numero, 'complemento': complemento
        }
        endereco_id = sock.execute(dbname, uid, pwd, 'adm.pessoa.endereco', 'search', args_search)
        if not endereco_id:
            endereco_id = sock.execute(dbname, uid, pwd, 'adm.pessoa.endereco', 'create', args_create)
        else:
            sock.execute(dbname, uid, pwd, 'adm.pessoa.endereco', 'write', endereco_id, args_create)
    else:
        res = False
    return res
def get_contatos(request, cep):
    # LOG GERAL
    id_loggeral = sock.execute(dbname, uid, pwd, 'cep.loggeral', 'search', [('cep_log','=',cep)])
    if id_loggeral:
        vals_loggeral = sock.execute(dbname, uid, pwd, 'cep.loggeral', 'read', id_loggeral,[])[0]
        # BAIRRO
        search = [
                    ('chvloc_bai', '=', vals_loggeral['chvloc_log']),
                    ('chave_bai', '=', vals_loggeral['chvbai_log1'])
                ]
        id_bairro = sock.execute(dbname, uid, pwd, 'cep.bairros', 'search', search)
        vals_bairro = sock.execute(dbname, uid, pwd, 'cep.bairros', 'read', id_bairro, [])[0]
        # CIDADE
        id_cidade = sock.execute(dbname, uid, pwd, 'cep.localidades', 'search', [('chave_loc','=',vals_loggeral['chvloc_log'])])
        vals_cidade = sock.execute(dbname, uid, pwd, 'cep.localidades', 'read', id_cidade, [])[0]
        fields = {
            'fields': {
                    'logradouro': vals_loggeral['nome_log'],
                    'bairro': vals_bairro['extenso_bai'],
                    'cidade': vals_cidade['nome_loc'],
                    'uf': vals_loggeral['uf_log'],
                    'cep': '1'
            }
        }
    else:
        fields = {
            'fields': {
                    'cep': '0'
            }
        }
    mimetype = 'application/javascript'
    data = simplejson.dumps(fields)
    if request.is_ajax():
        if request.method == 'GET':
            message = "This is an XHR GET request"
            
        elif request.method == 'POST':
            message = "This is an XHR POST request"
            # Here we can access the POST data
            #data = serializers.serialize('json', test_dict)
            #print data
            return HttpResponse(data,mimetype)
    else:
        message = "No XHR"
    return HttpResponse(data,mimetype)

def login(request):
    def errorHandle(error):
        form = LoginForm()
        return render_to_response('login.html', {
                'error' : error,
                'form' : form,
        })
    if request.method == 'POST':
            form = LoginForm(request.POST)
            if form.is_valid():
                # VERIFICAR USUARIO REGISTRADO
                if 'SubmitEntrar' in request.POST:
                    args_search = [('cpf_cnpj', '=', request.POST['cpf'])]
                    id_pessoa = sock.execute(dbname, uid, pwd, 'adm.pessoa', 'search', args_search)
                    if id_pessoa:
                        args_search = [('pessoa_id','=',id_pessoa)]
                        id_acesso = sock.execute(dbname, uid, pwd, 'rhcurriculo.acesso', 'search', args_search)
                        if id_acesso:
                            password = sock.execute(dbname, uid, pwd, 'rhcurriculo.acesso', 'read', id_acesso, ['senha'])[0]['senha']
                            if request.POST['senha'] == password:
                                request.session['tipo_login'] = 'user_cadastrado'
                                request.session['user_cpf'] = request.POST['cpf']
                                request.session['user_senha'] = request.POST['senha']
                                request.session['user_id'] = id_pessoa
                                return HttpResponseRedirect('../logged/')
                            else:
                                error = {'Form': 'Senha incorreta'}
                                return errorHandle(error)
                        else:
                            error = {'Form': 'Nao possui acesso! Efetua o cadastro.'}
                            return errorHandle(error)
                    else:
                        error = {'Form': 'Usuario nao cadastrado! Efetua o cadastro.'}
                        return errorHandle(error)
                # EFETUAR NOVO CADASTRO
                if 'SubmitNovo' in request.POST:
                    request.session['tipo_login'] = 'user_novo'
                    request.session['user_cpf'] = request.POST['cpf']
                    request.session['user_senha'] = request.POST['senha']
                    args_search = [('cpf_cnpj', '=', request.POST['cpf'])]
                    id_pessoa = sock.execute(dbname, uid, pwd, 'adm.pessoa', 'search', args_search)
                    if id_pessoa:
                        request.session['user_id'] = id_pessoa
                        args_search = [('pessoa_id','=',id_pessoa)]
                        id_acesso = sock.execute(dbname, uid, pwd, 'rhcurriculo.acesso', 'search', args_search)
                        if id_acesso:
                            error = {'FormNovo': 'Usuario ja cadastrado!'}
                            return errorHandle(error)
                        else:
                            return HttpResponseRedirect('../logged/')
                    else:
                        if request.POST['senha_confirm']:
                            if request.POST['senha'] == request.POST['senha_confirm']:
                                return HttpResponseRedirect('../logged/')
                            else:
                                error = {'FormNovo': 'A senha de confirmacao nao confere!'}
                                return errorHandle(error)
                        else:
                            error = {'FormNovo': 'Repita a senha!'}
                            return errorHandle(error)

            else:
                if 'SubmitEntrar' in request.POST:
                    error = {'Form': 'Prencha todos os campos'}
                if 'SubmitNovo' in request.POST:
                    print '*', request.POST
                    error = {'FormNovo': 'Prencha todos os campos'}
                return errorHandle(error)
        else:
            form = LoginForm() # An unbound form
            return render_to_response('login.html', {'form': form})


#
#        form = LoginForm(request.POST) # A form bound to the POST data
#        if form.is_valid(): # All validation rules pass
#                        args_search = [('cpf_cnpj', '=', request.POST['cpf'])]
#                        id_pessoa = sock.execute(dbname, uid, pwd, 'adm.pessoa', 'search', args_search)
#
#                        if id_pessoa:
#                            print 'Usuário cadastrado', id_pessoa
#                            args_search = [('pessoa_id','=',id_pessoa)]
#                            id_acesso = sock.execute(dbname, uid, pwd, 'rhcurriculo.acesso', 'search', args_search)
#                            if id_acesso:
#                                password = sock.execute(dbname, uid, pwd, 'rhcurriculo.acesso', 'read', id_acesso, ['senha'])[0]['senha']
#                                print 'Possui acesso', id_acesso, password
#                                if request.POST['senha'] == password:
##                                    login_url = '%s?next=%s' % (reverse('site_rh.login.views.login'), reverse('site_rh.login.views.logged'))
##                                    print '****', login_url
#                                    return HttpResponseRedirect('../logged/upd/' + str(id_pessoa[0]) +'/'+request.POST['cpf']+'/')
#                                    #return HttpResponseRedirect(reverse('site_rh.login.views.logged', args=[ 12,12 ]))
#                                    #return HttpResponseRedirect(reverse('site_rh.login.views.logged/12', kwargs={'user_cpf':123}))
#                                    #return HttpResponseRedirect(reverse('arch-summary', args=[1945]))
#                                    #return HttpResponseRedirect('12')
#                                else:
#                                    error = u'Senha incorreta'
#                                    return errorHandle(error)
#                            else:
#                                return HttpResponseRedirect('../logged/new/' + request.POST['senha'] +'/'+request.POST['cpf']+'/')
#                                error = u'Nao possui acesso'
#                                return errorHandle(error)
#                        else:
#                            request.session['senha'] = request.POST['senha']
#                            return HttpResponseRedirect('../logged/new/'+request.POST['senha']+'/'+request.POST['cpf']+'/')
#                            error = u'Usuário nao cadastrado'
#                            return errorHandle(error)
#        else:
#            error = u'Prencha todos os campos'
#            return errorHandle(error)
#    else:
#        form = LoginForm() # An unbound form
#        return render_to_response('login.html', {
#            'form': form,
#        })

def logged(request):
    print request
    flag = request.session.get('tipo_login')
    cpf = request.session.get('user_cpf')
    senha = request.session.get('user_senha')
    id =  request.session.get('user_id')
    def errorHandle(error):
            form = LoggedForm(request.POST)
            return render_to_response('cadastro_rh.html', {
                            'error' : error,
                            'form' : form,
            })
    if request.method=='POST':
        form = LoggedForm(request.POST)
        vals = form.data
        print vals
        if form.is_valid():
            pass
            # PESSOA
            args_search = [('cpf_cnpj', '=', cpf)]
            args_create = {'pessoa_tipo': 'F','name': vals['nome'],'cpf_cnpj': cpf}
            id_pessoa = sock.execute(dbname, uid, pwd, 'adm.pessoa', 'search', args_search)
            if not id_pessoa:
                id_pessoa = sock.execute(dbname, uid, pwd, 'adm.pessoa', 'create', args_create)
            else:
                sock.execute(dbname, uid, pwd, 'adm.pessoa', 'write', id_pessoa, args_create)
                id_pessoa = id_pessoa[0]
            # PESSOA FISICA
            args_search = [('pessoa_id', '=', id_pessoa)]
            args_create = {'pessoa_id': id_pessoa,'data_nascimento': vals['nascimento'],'sexo': vals['sexo'],'estado_civil': vals['estado_civil']}
            id_pessoa_f = sock.execute(dbname, uid, pwd, 'adm.pessoa.fisica', 'search', args_search)
            if not id_pessoa_f:
                id_pessoa_f = sock.execute(dbname, uid, pwd, 'adm.pessoa.fisica', 'create', args_create)
            else:
                sock.execute(dbname, uid, pwd, 'adm.pessoa.fisica', 'write', id_pessoa_f, args_create)
                id_pessoa_f = id_pessoa_f[0]
            # EMAIL
            email_tipo_id = sock.execute(dbname, uid, pwd, 'adm.email.tipo', 'search', [('name','=','Comum')])
            email_id = sock.execute(dbname, uid, pwd, 'adm.pessoa.email', 'search', [('name','=',vals['email'])])
            args_create = {'name': vals['email'], 'email_tipo_id': email_tipo_id[0], 'pessoa_id': id_pessoa}
            if not email_id:
                email_id = sock.execute(dbname, uid, pwd, 'adm.pessoa.email', 'create', args_create)
            else:
                sock.execute(dbname, uid, pwd, 'adm.pessoa.email', 'write', email_id[0], args_create)
                email_id = email_id[0]
            #ENDEREÇO
            cad_endereco(vals['cep'], id_pessoa, vals['numero'], vals['complemento'])
            # TELEFONES
            id_fone_cel_t = sock.execute(dbname, uid, pwd, 'adm.telefone.tipo', 'search', [('name','=','Celular')])[0]
            id_fone_com_t = sock.execute(dbname, uid, pwd, 'adm.telefone.tipo', 'search', [('name','=','Comercial')])[0]
            id_fone_res_t = sock.execute(dbname, uid, pwd, 'adm.telefone.tipo', 'search', [('name','=','Residencial')])[0]
            #> CELULAR
            if vals['fone_cel']:
                args_search = [('pessoa_id','=',id_pessoa),('telefone_tipo_id','=', id_fone_cel_t)]
                args_create = {'telefone_tipo_id': id_fone_cel_t, 'pessoa_id': id_pessoa, 'ddd': vals['ddd_cel'], 'numero': vals['fone_cel']}
                id_fone_cel = sock.execute(dbname, uid, pwd, 'adm.pessoa.telefone', 'search', args_search)
                if not id_fone_cel:
                    sock.execute(dbname, uid, pwd, 'adm.pessoa.telefone', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'adm.pessoa.telefone', 'write', id_fone_cel, args_create)
            #> RESIDENCIAL
            if vals['fone_res']:
                args_search = [('pessoa_id','=',id_pessoa),('telefone_tipo_id','=', id_fone_res_t)]
                args_create = {'telefone_tipo_id': id_fone_res_t, 'pessoa_id': id_pessoa, 'ddd': vals['ddd_res'], 'numero': vals['fone_res']}
                id_fone_res = sock.execute(dbname, uid, pwd, 'adm.pessoa.telefone', 'search', args_search)
                if not id_fone_res:
                    sock.execute(dbname, uid, pwd, 'adm.pessoa.telefone', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'adm.pessoa.telefone', 'write', id_fone_res, args_create)
            #> COMERCIAL
            if vals['fone_com']:
                args_search = [('pessoa_id','=',id_pessoa),('telefone_tipo_id','=', id_fone_com_t)]
                args_create = {'telefone_tipo_id': id_fone_com_t, 'pessoa_id': id_pessoa, 'ddd': vals['ddd_com'], 'numero': vals['fone_com']}
                id_fone_com = sock.execute(dbname, uid, pwd, 'adm.pessoa.telefone', 'search', args_search)
                if not id_fone_com:
                    sock.execute(dbname, uid, pwd, 'adm.pessoa.telefone', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'adm.pessoa.telefone', 'write', id_fone_com, args_create)
            # ACESSO
            args_search = [('pessoa_id','=',id_pessoa)]
            id_acesso = sock.execute(dbname, uid, pwd, 'rhcurriculo.acesso', 'search', args_search)
            if not id_acesso:
                args_create = {'pessoa_id': id_pessoa, 'senha': senha}
                id_acesso = sock.execute(dbname, uid, pwd, 'rhcurriculo.acesso', 'create', args_create)
            else:
                id_acesso = id_acesso[0]
            # CURRICULO
            if not 'filhos' in vals:
                filhos = False
            else: filhos = vals['filhos']
            if not 'deficiencia' in vals:
                deficiencia = False
            else: deficiencia = vals['deficiencia']
            if not 'experiencia' in vals:
                experiencia = False
            else:
                experiencia = vals['experiencia']
            args_search = [('pessoa_id','=',id_pessoa),('acesso_id','=',id_acesso)]
            args_create = {
                'filhos': filhos,
                'deficiencia': deficiencia,
                'deficiencia_descricao': vals['deficiencia_descricao'],
                'outra_cidade':vals['outra_cidade'],
                'pretencao': vals['pretencao'],
                'disponibilidade':vals['disponibilidade'],
                'trabalhando': vals['trabalhando'],
                'escolaridade': vals['escolaridade'],
                'complemento': vals['objetivos'],
                'pessoa_id': id_pessoa,
                'acesso_id': id_acesso,
                'experiencia': experiencia,
                'name': vals['nome']
            }
            curriculo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.curriculo', 'search', args_search)
            if not curriculo_id:
                curriculo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.curriculo', 'create', args_create)
            else:
                sock.execute(dbname, uid, pwd, 'rhcurriculo.curriculo', 'write', curriculo_id, args_create)
                curriculo_id = curriculo_id[0]
            # EXPERIENCIAS
            # -> VENDAS
            [vendas_ope, vendas_sup, vendas_ger, vendas_dir] = [False, False, False, False]
            for key in vals:
                if key == 'vendas_ope':
                    vendas_ope = True
                if key == 'vendas_sup':
                    vendas_sup = True
                if key == 'vendas_ger':
                    vendas_ger = True
                if key == 'vendas_dir':
                    vendas_dir = True
            if 'vendas_ope' or 'vendas_sup' or 'vendas_ger' or 'vendas_dir' in vals:
                vendas_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias.tipos', 'search', [('name','=','VENDAS')])[0]
                args_search = [('experiencias_tipos_id','=',vendas_tipo_id),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'experiencias_tipos_id': vendas_tipo_id, 'curriculo_id': curriculo_id,
                    'operacional': vendas_ope, 'supervisao': vendas_sup,
                    'gerencia': vendas_ger, 'diretoria': vendas_dir
                }
                vendas_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'search', args_search)
                if not vendas_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'write', vendas_id, args_create)
            # -> OFFICE BOY
            [boy_ope, boy_sup, boy_ger, boy_dir] = [False, False, False, False]
            for key in vals:
                if key == 'boy_ope':
                    boy_ope = True
                if key == 'boy_sup':
                    boy_sup = True
                if key == 'boy_ger':
                    boy_ger = True
                if key == 'boy_dir':
                    boy_dir = True
            if 'boy_ope' or 'boy_sup' or 'boy_ger' or 'boy_dir' in vals:
                boy_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias.tipos', 'search', [('name','=','OFFICE BOY (MOTOQUEIRO)')])[0]
                args_search = [('experiencias_tipos_id','=',boy_tipo_id),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'experiencias_tipos_id': boy_tipo_id, 'curriculo_id': curriculo_id,
                    'operacional': boy_ope, 'supervisao': boy_sup,
                    'gerencia': boy_ger, 'diretoria': boy_dir
                }
                boy_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'search', args_search)
                if not boy_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'write', boy_id, args_create)
            # -> ADMINISTRATIVO
            [admin_ope, admin_sup, admin_ger, admin_dir] = [False, False, False, False]
            for key in vals:
                if key == 'admin_ope':
                    admin_ope = True
                if key == 'admin_sup':
                    admin_sup = True
                if key == 'admin_ger':
                    admin_ger = True
                if key == 'admin_dir':
                    admin_dir = True
            if 'admin_ope' or 'admin_sup' or 'admin_ger' or 'admin_dir' in vals:
                admin_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias.tipos', 'search', [('name','=','ADMINISTRATIVO')])[0]
                args_search = [('experiencias_tipos_id','=',admin_tipo_id),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'experiencias_tipos_id': admin_tipo_id, 'curriculo_id': curriculo_id,
                    'operacional': admin_ope, 'supervisao': admin_sup,
                    'gerencia': admin_ger, 'diretoria': admin_dir
                }
                admin_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'search', args_search)
                if not admin_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'write', admin_id, args_create)
            # -> FINANCEIRO
            [finan_ope, finan_sup, finan_ger, finan_dir] = [False, False, False, False]
            for key in vals:
                if key == 'finan_ope':
                    finan_ope = True
                if key == 'finan_sup':
                    finan_sup = True
                if key == 'finan_ger':
                    finan_ger = True
                if key == 'finan_dir':
                    finan_dir = True
            if 'finan_ope' or 'finan_sup' or 'finan_ger' or 'finan_dir' in vals:
                finan_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias.tipos', 'search', [('name','=','FINANCEIRO')])[0]
                args_search = [('experiencias_tipos_id','=',finan_tipo_id),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'experiencias_tipos_id': finan_tipo_id, 'curriculo_id': curriculo_id,
                    'operacional': finan_ope, 'supervisao': finan_sup,
                    'gerencia': finan_ger, 'diretoria': finan_dir
                }
                finan_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'search', args_search)
                if not finan_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'write', finan_id, args_create)
            # -> COMPRAS
            [comp_ope, comp_sup, comp_ger, comp_dir] = [False, False, False, False]
            for key in vals:
                if key == 'comp_ope':
                    comp_ope = True
                if key == 'comp_sup':
                    comp_sup = True
                if key == 'comp_ger':
                    comp_ger = True
                if key == 'comp_dir':
                    comp_dir = True
            if 'comp_ope' or 'comp_sup' or 'comp_ger' or 'comp_dir' in vals:
                comp_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias.tipos', 'search', [('name','=','COMPRAS')])[0]
                args_search = [('experiencias_tipos_id','=',comp_tipo_id),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'experiencias_tipos_id': comp_tipo_id, 'curriculo_id': curriculo_id,
                    'operacional': comp_ope, 'supervisao': comp_sup,
                    'gerencia': comp_ger, 'diretoria': comp_dir
                }
                comp_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'search', args_search)
                if not comp_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'write', comp_id, args_create)
            # -> ESTOQUE
            [est_ope, est_sup, est_ger, est_dir] = [False, False, False, False]
            for key in vals:
                if key == 'est_ope':
                    est_ope = True
                if key == 'est_sup':
                    est_sup = True
                if key == 'est_ger':
                    est_ger = True
                if key == 'est_dir':
                    est_dir = True
            if 'est_ope' or 'est_sup' or 'est_ger' or 'est_dir' in vals:
                est_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias.tipos', 'search', [('name','=','ESTOQUE')])[0]
                args_search = [('experiencias_tipos_id','=',est_tipo_id),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'experiencias_tipos_id': est_tipo_id, 'curriculo_id': curriculo_id,
                    'operacional': est_ope, 'supervisao': est_sup,
                    'gerencia': est_ger, 'diretoria': est_dir
                }
                est_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'search', args_search)
                if not est_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'write', est_id, args_create)
            # -> FISCAL
            [fisc_ope, fisc_sup, fisc_ger, fisc_dir] = [False, False, False, False]
            for key in vals:
                if key == 'fisc_ope':
                    fisc_ope = True
                if key == 'fisc_sup':
                    fisc_sup = True
                if key == 'fisc_ger':
                    fisc_ger = True
                if key == 'fisc_dir':
                    fisc_dir = True
            if 'fisc_ope' or 'fisc_sup' or 'fisc_ger' or 'fisc_dir' in vals:
                fisc_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias.tipos', 'search', [('name','=','FISCAL')])[0]
                args_search = [('experiencias_tipos_id','=',fisc_tipo_id),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'experiencias_tipos_id': fisc_tipo_id, 'curriculo_id': curriculo_id,
                    'operacional': fisc_ope, 'supervisao': fisc_sup,
                    'gerencia': fisc_ger, 'diretoria': fisc_dir
                }
                fisc_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'search', args_search)
                if not fisc_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'write', fisc_id, args_create)
            # -> AMBIENTAL
            [amb_ope, amb_sup, amb_ger, amb_dir] = [False, False, False, False]
            for key in vals:
                if key == 'amb_ope':
                    amb_ope = True
                if key == 'amb_sup':
                    amb_sup = True
                if key == 'amb_ger':
                    amb_ger = True
                if key == 'amb_dir':
                    amb_dir = True
            if 'amb_ope' or 'amb_sup' or 'amb_ger' or 'amb_dir' in vals:
                amb_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias.tipos', 'search', [('name','=','AMBIENTAL')])[0]
                args_search = [('experiencias_tipos_id','=',amb_tipo_id),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'experiencias_tipos_id': amb_tipo_id, 'curriculo_id': curriculo_id,
                    'operacional': amb_ope, 'supervisao': amb_sup,
                    'gerencia': amb_ger, 'diretoria': amb_dir
                }
                amb_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'search', args_search)
                if not amb_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'write', amb_id, args_create)
            # -> ATENDIMENTO
            [atend_ope, atend_sup, atend_ger, atend_dir] = [False, False, False, False]
            for key in vals:
                if key == 'atend_ope':
                    atend_ope = True
                if key == 'atend_sup':
                    atend_sup = True
                if key == 'atend_ger':
                    atend_ger = True
                if key == 'atend_dir':
                    atend_dir = True
            if 'atend_ope' or 'atend_sup' or 'atend_ger' or 'atend_dir' in vals:
                atend_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias.tipos', 'search', [('name','=','ATENDIMENTO/CLIENTE')])[0]
                args_search = [('experiencias_tipos_id','=',atend_tipo_id),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'experiencias_tipos_id': atend_tipo_id, 'curriculo_id': curriculo_id,
                    'operacional': atend_ope, 'supervisao': atend_sup,
                    'gerencia': atend_ger, 'diretoria': atend_dir
                }
                atend_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'search', args_search)
                if not atend_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'write', atend_id, args_create)
            # -> COMUNICAÇAO
            [com_ope, com_sup, com_ger, com_dir] = [False, False, False, False]
            for key in vals:
                if key == 'com_ope':
                    com_ope = True
                if key == 'com_sup':
                    com_sup = True
                if key == 'com_ger':
                    com_ger = True
                if key == 'com_dir':
                    com_dir = True
            if 'com_ope' or 'com_sup' or 'com_ger' or 'com_dir' in vals:
                com_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias.tipos', 'search', [('name','=','COMUNICACAO')])[0]
                args_search = [('experiencias_tipos_id','=',com_tipo_id),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'experiencias_tipos_id': com_tipo_id, 'curriculo_id': curriculo_id,
                    'operacional': com_ope, 'supervisao': com_sup,
                    'gerencia': com_ger, 'diretoria': com_dir
                }
                com_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'search', args_search)
                if not com_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'write', com_id, args_create)
            # -> SUPORTE
            [sup_ope, sup_sup, sup_ger, sup_dir] = [False, False, False, False]
            for key in vals:
                if key == 'sup_ope':
                    sup_ope = True
                if key == 'sup_sup':
                    sup_sup = True
                if key == 'sup_ger':
                    sup_ger = True
                if key == 'sup_dir':
                    sup_dir = True
            if 'sup_ope' or 'sup_sup' or 'sup_ger' or 'sup_dir' in vals:
                sup_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias.tipos', 'search', [('name','=','SUPORTE TECNICO')])[0]
                args_search = [('experiencias_tipos_id','=',sup_tipo_id),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'experiencias_tipos_id': sup_tipo_id, 'curriculo_id': curriculo_id,
                    'operacional': sup_ope, 'supervisao': sup_sup,
                    'gerencia': sup_ger, 'diretoria': sup_dir
                }
                sup_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'search', args_search)
                if not sup_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'write', sup_id, args_create)
            # -> QUALIDADE
            [qual_ope, qual_sup, qual_ger, qual_dir] = [False, False, False, False]
            for key in vals:
                if key == 'qual_ope':
                    qual_ope = True
                if key == 'qual_sup':
                    qual_sup = True
                if key == 'qual_ger':
                    qual_ger = True
                if key == 'qual_dir':
                    qual_dir = True
            if 'qual_ope' or 'qual_sup' or 'qual_ger' or 'qual_dir' in vals:
                qual_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias.tipos', 'search', [('name','=','QUALIDADE')])[0]
                args_search = [('experiencias_tipos_id','=',qual_tipo_id),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'experiencias_tipos_id': qual_tipo_id, 'curriculo_id': curriculo_id,
                    'operacional': qual_ope, 'supervisao': qual_sup,
                    'gerencia': qual_ger, 'diretoria': qual_dir
                }
                qual_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'search', args_search)
                if not qual_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'write', qual_id, args_create)
            # -> CAIXA
            [caixa_ope, caixa_sup, caixa_ger, caixa_dir] = [False, False, False, False]
            for key in vals:
                if key == 'caixa_ope':
                    caixa_ope = True
                if key == 'caixa_sup':
                    caixa_sup = True
                if key == 'caixa_ger':
                    caixa_ger = True
                if key == 'caixa_dir':
                    caixa_dir = True
            if 'caixa_ope' or 'caixa_sup' or 'caixa_ger' or 'caixa_dir' in vals:
                caixa_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias.tipos', 'search', [('name','=','CAIXA')])[0]
                args_search = [('experiencias_tipos_id','=',caixa_tipo_id),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'experiencias_tipos_id': caixa_tipo_id, 'curriculo_id': curriculo_id,
                    'operacional': caixa_ope, 'supervisao': caixa_sup,
                    'gerencia': caixa_ger, 'diretoria': caixa_dir
                }
                caixa_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'search', args_search)
                if not caixa_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'write', caixa_id, args_create)
            # -> NUTRICAO
            [nut_ope, nut_sup, nut_ger, nut_dir] = [False, False, False, False]
            for key in vals:
                if key == 'nut_ope':
                    nut_ope = True
                if key == 'nut_sup':
                    nut_sup = True
                if key == 'nut_ger':
                    nut_ger = True
                if key == 'nut_dir':
                    nut_dir = True
            if 'nut_ope' or 'nut_sup' or 'nut_ger' or 'nut_dir' in vals:
                nut_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias.tipos', 'search', [('name','=','NUTRICAO')])[0]
                args_search = [('experiencias_tipos_id','=',nut_tipo_id),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'experiencias_tipos_id': nut_tipo_id, 'curriculo_id': curriculo_id,
                    'operacional': nut_ope, 'supervisao': nut_sup,
                    'gerencia': nut_ger, 'diretoria': nut_dir
                }
                nut_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'search', args_search)
                if not nut_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'write', nut_id, args_create)
            # -> ADVOCACIA
            [adv_ope, adv_sup, adv_ger, adv_dir] = [False, False, False, False]
            for key in vals:
                if key == 'adv_ope':
                    adv_ope = True
                if key == 'adv_sup':
                    adv_sup = True
                if key == 'adv_ger':
                    adv_ger = True
                if key == 'adv_dir':
                    adv_dir = True
            if 'adv_ope' or 'adv_sup' or 'adv_ger' or 'adv_dir' in vals:
                adv_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias.tipos', 'search', [('name','=','ADVOCACIA')])[0]
                args_search = [('experiencias_tipos_id','=',adv_tipo_id),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'experiencias_tipos_id': adv_tipo_id, 'curriculo_id': curriculo_id,
                    'operacional': adv_ope, 'supervisao': adv_sup,
                    'gerencia': adv_ger, 'diretoria': adv_dir
                }
                adv_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'search', args_search)
                if not adv_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'write', adv_id, args_create)
            # -> SECRETARIADO
            [sec_ope, sec_sup, sec_ger, sec_dir] = [False, False, False, False]
            for key in vals:
                if key == 'sec_ope':
                    sec_ope = True
                if key == 'sec_sup':
                    sec_sup = True
                if key == 'sec_ger':
                    sec_ger = True
                if key == 'sec_dir':
                    sec_dir = True
            if 'sec_ope' or 'sec_sup' or 'sec_ger' or 'sec_dir' in vals:
                sec_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias.tipos', 'search', [('name','=','SECRETARIADO')])[0]
                args_search = [('experiencias_tipos_id','=',sec_tipo_id),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'experiencias_tipos_id': sec_tipo_id, 'curriculo_id': curriculo_id,
                    'operacional': sec_ope, 'supervisao': sec_sup,
                    'gerencia': sec_ger, 'diretoria': sec_dir
                }
                sec_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'search', args_search)
                if not sec_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'write', sec_id, args_create)
            # -> GERAIS
            [serv_ope, serv_sup, serv_ger, serv_dir] = [False, False, False, False]
            for key in vals:
                if key == 'serv_ope':
                    serv_ope = True
                if key == 'serv_sup':
                    serv_sup = True
                if key == 'serv_ger':
                    serv_ger = True
                if key == 'serv_dir':
                    serv_dir = True
            if 'serv_ope' or 'serv_sup' or 'serv_ger' or 'serv_dir' in vals:
                serv_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias.tipos', 'search', [('name','=','SERVICOS GERAIS')])[0]
                args_search = [('experiencias_tipos_id','=',serv_tipo_id),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'experiencias_tipos_id': serv_tipo_id, 'curriculo_id': curriculo_id,
                    'operacional': serv_ope, 'supervisao': serv_sup,
                    'gerencia': serv_ger, 'diretoria': serv_dir
                }
                serv_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'search', args_search)
                if not serv_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'write', serv_id, args_create)
            # -> TECNOLOGIA
            [tec_ope, tec_sup, tec_ger, tec_dir] = [False, False, False, False]
            for key in vals:
                if key == 'tec_ope':
                    tec_ope = True
                if key == 'tec_sup':
                    tec_sup = True
                if key == 'tec_ger':
                    tec_ger = True
                if key == 'tec_dir':
                    tec_dir = True
            if 'tec_ope' or 'tec_sup' or 'tec_ger' or 'tec_dir' in vals:
                tec_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias.tipos', 'search', [('name','=','IMPLANTACAO DE TECNOLOGIA')])[0]
                args_search = [('experiencias_tipos_id','=',tec_tipo_id),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'experiencias_tipos_id': tec_tipo_id, 'curriculo_id': curriculo_id,
                    'operacional': tec_ope, 'supervisao': tec_sup,
                    'gerencia': tec_ger, 'diretoria': tec_dir
                }
                tec_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'search', args_search)
                if not tec_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'write', tec_id, args_create)
            # -> OUVIDORIA
            [ouv_ope, ouv_sup, ouv_ger, ouv_dir] = [False, False, False, False]
            for key in vals:
                if key == 'ouv_ope':
                    ouv_ope = True
                if key == 'ouv_sup':
                    ouv_sup = True
                if key == 'ouv_ger':
                    ouv_ger = True
                if key == 'ouv_dir':
                    ouv_dir = True
            if 'ouv_ope' or 'ouv_sup' or 'ouv_ger' or 'ouv_dir' in vals:
                ouv_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias.tipos', 'search', [('name','=','OUVIDORIA')])[0]
                args_search = [('experiencias_tipos_id','=',ouv_tipo_id),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'experiencias_tipos_id': ouv_tipo_id, 'curriculo_id': curriculo_id,
                    'operacional': ouv_ope, 'supervisao': ouv_sup,
                    'gerencia': ouv_ger, 'diretoria': ouv_dir
                }
                ouv_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'search', args_search)
                if not ouv_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'write', ouv_id, args_create)
            # -> OUVIDORIA
            [plan_ope, plan_sup, plan_ger, plan_dir] = [False, False, False, False]
            for key in vals:
                if key == 'plan_ope':
                    plan_ope = True
                if key == 'plan_sup':
                    plan_sup = True
                if key == 'plan_ger':
                    plan_ger = True
                if key == 'plan_dir':
                    plan_dir = True
            if 'plan_ope' or 'plan_sup' or 'plan_ger' or 'plan_dir' in vals:
                plan_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias.tipos', 'search', [('name','=','PLANEJAMENTO ESTRATEGICO')])[0]
                args_search = [('experiencias_tipos_id','=',plan_tipo_id),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'experiencias_tipos_id': plan_tipo_id, 'curriculo_id': curriculo_id,
                    'operacional': plan_ope, 'supervisao': plan_sup,
                    'gerencia': plan_ger, 'diretoria': plan_dir
                }
                plan_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'search', args_search)
                if not plan_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'write', plan_id, args_create)
            # EMPRESA 01
            if vals['empresa_01']:
                args_search = [('sequence','=',1),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'sequence': 1, 'empresa': vals['empresa_01'], 'segmento': vals['segmento_01'],
                    'mes_entrada': vals['mes_entrada_01'], 'ano_entrada': vals['ano_entrada_01'],
                    'mes_saida': vals['mes_saida_01'], 'ano_saida': vals['ano_saida_01'],
                    'cargo': vals['cargo_01'], 'atribuicoes': vals['atribuicoes_01'],
                    'curriculo_id': curriculo_id, 'modalidade' : vals['modalidade_01']
                }
                empresa_01_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.empresas', 'search', args_search)
                if not empresa_01_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.empresas', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.empresas', 'write', empresa_01_id, args_create)
            # EMPRESA 02
            if vals['empresa_02']:
                args_search = [('sequence','=',2),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'sequence': 2, 'empresa': vals['empresa_02'], 'segmento': vals['segmento_02'],
                    'mes_entrada': vals['mes_entrada_02'], 'ano_entrada': vals['ano_entrada_02'],
                    'mes_saida': vals['mes_saida_02'], 'ano_saida': vals['ano_saida_02'],
                    'cargo': vals['cargo_02'], 'atribuicoes': vals['atribuicoes_02'],
                    'curriculo_id': curriculo_id, 'modalidade' : vals['modalidade_02']
                }
                empresa_02_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.empresas', 'search', args_search)
                if not empresa_02_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.empresas', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.empresas', 'write', empresa_02_id, args_create)
            # EMPRESA 03
            if vals['empresa_03']:
                args_search = [('sequence','=',3),('curriculo_id','=', curriculo_id)]
                args_create = {
                    'sequence': 3, 'empresa': vals['empresa_03'], 'segmento': vals['segmento_03'],
                    'mes_entrada': vals['mes_entrada_03'], 'ano_entrada': vals['ano_entrada_03'],
                    'mes_saida': vals['mes_saida_03'], 'ano_saida': vals['ano_saida_03'],
                    'cargo': vals['cargo_03'], 'atribuicoes': vals['atribuicoes_03'],
                    'curriculo_id': curriculo_id, 'modalidade' : vals['modalidade_03']
                }
                empresa_03_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.empresas', 'search', args_search)
                if not empresa_03_id:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.empresas', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.empresas', 'write', empresa_03_id, args_create)
            # IDIOMAS INGLES
            args_search = [('name','=', 'Ingles')]
            idiomas_tipos_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.idiomas.tipos', 'search', args_search)[0]
            args_search = [('idiomas_tipos_id','=', idiomas_tipos_id), ('curriculo_id','=',curriculo_id)]
            idiomas_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.idiomas', 'search', args_search)
            args_create = {'idiomas_tipos_id': idiomas_tipos_id, 'curriculo_id': curriculo_id, 'fluencia': vals['idioma_ingles']}
            if not idiomas_id:
                idiomas_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.idiomas', 'create', args_create)
            else:
                sock.execute(dbname, uid, pwd, 'rhcurriculo.idiomas', 'write', idiomas_id, args_create)
            # IDIOMAS ESPANHOL
            args_search = [('name','=', 'Espanhol')]
            idiomas_tipos_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.idiomas.tipos', 'search', args_search)[0]
            args_search = [('idiomas_tipos_id','=', idiomas_tipos_id), ('curriculo_id','=',curriculo_id)]
            idiomas_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.idiomas', 'search', args_search)
            args_create = {'idiomas_tipos_id': idiomas_tipos_id, 'curriculo_id': curriculo_id, 'fluencia': vals['idioma_espanhol']}
            if not idiomas_id:
                idiomas_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.idiomas', 'create', args_create)
            else:
                sock.execute(dbname, uid, pwd, 'rhcurriculo.idiomas', 'write', idiomas_id, args_create)
            # IDIOMAS FRANCES
            args_search = [('name','=', 'Frances')]
            idiomas_tipos_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.idiomas.tipos', 'search', args_search)[0]
            args_search = [('idiomas_tipos_id','=', idiomas_tipos_id), ('curriculo_id','=',curriculo_id)]
            idiomas_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.idiomas', 'search', args_search)
            args_create = {'idiomas_tipos_id': idiomas_tipos_id, 'curriculo_id': curriculo_id, 'fluencia': vals['idioma_frances']}
            if not idiomas_id:
                idiomas_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.idiomas', 'create', args_create)
            else:
                sock.execute(dbname, uid, pwd, 'rhcurriculo.idiomas', 'write', idiomas_id, args_create)
            # IDIOMAS ALEMAO
            args_search = [('name','=', 'Alemao')]
            idiomas_tipos_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.idiomas.tipos', 'search', args_search)[0]
            args_search = [('idiomas_tipos_id','=', idiomas_tipos_id), ('curriculo_id','=',curriculo_id)]
            idiomas_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.idiomas', 'search', args_search)
            args_create = {'idiomas_tipos_id': idiomas_tipos_id, 'curriculo_id': curriculo_id, 'fluencia': vals['idioma_alemao']}
            if not idiomas_id:
                idiomas_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.idiomas', 'create', args_create)
            else:
                sock.execute(dbname, uid, pwd, 'rhcurriculo.idiomas', 'write', idiomas_id, args_create)
            # IDIOMAS ITALIANO
            args_search = [('name','=', 'Italiano')]
            idiomas_tipos_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.idiomas.tipos', 'search', args_search)[0]
            args_search = [('idiomas_tipos_id','=', idiomas_tipos_id), ('curriculo_id','=',curriculo_id)]
            idiomas_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.idiomas', 'search', args_search)
            args_create = {'idiomas_tipos_id': idiomas_tipos_id, 'curriculo_id': curriculo_id, 'fluencia': vals['idioma_italiano']}
            if not idiomas_id:
                idiomas_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.idiomas', 'create', args_create)
            else:
                sock.execute(dbname, uid, pwd, 'rhcurriculo.idiomas', 'write', idiomas_id, args_create)
            # TECNOLOGIA OFFICE (WORD/EXCEL)
            args_search = [('name','=', 'OFFICE (WORD/EXCEL)')]
            tecnologia_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia.tipo', 'search', args_search)[0]
            args_search = [('tecnologia_tipo_id','=', tecnologia_tipo_id), ('curriculo_id','=',curriculo_id)]
            tecnologia_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia', 'search', args_search)
            args_create = {'tecnologia_tipo_id': tecnologia_tipo_id, 'curriculo_id': curriculo_id, 'dominio': vals['curso_office']}
            if not tecnologia_id:
                tecnologia_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia', 'create', args_create)
            else:
                sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia', 'write', tecnologia_id, args_create)
            # TECNOLOGIA AUTO-CAD
            args_search = [('name','=', 'AUTO-CAD')]
            tecnologia_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia.tipo', 'search', args_search)[0]
            args_search = [('tecnologia_tipo_id','=', tecnologia_tipo_id), ('curriculo_id','=',curriculo_id)]
            tecnologia_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia', 'search', args_search)
            args_create = {'tecnologia_tipo_id': tecnologia_tipo_id, 'curriculo_id': curriculo_id, 'dominio': vals['curso_cad']}
            if not tecnologia_id:
                tecnologia_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia', 'create', args_create)
            else:
                sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia', 'write', tecnologia_id, args_create)
            # TECNOLOGIA DESIGN (PHOTOSHOP/COREL-DRAW)
            args_search = [('name','=', 'DESIGN (PHOTOSHOP/COREL-DRAW)')]
            tecnologia_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia.tipo', 'search', args_search)[0]
            args_search = [('tecnologia_tipo_id','=', tecnologia_tipo_id), ('curriculo_id','=',curriculo_id)]
            tecnologia_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia', 'search', args_search)
            args_create = {'tecnologia_tipo_id': tecnologia_tipo_id, 'curriculo_id': curriculo_id, 'dominio': vals['curso_design']}
            if not tecnologia_id:
                tecnologia_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia', 'create', args_create)
            else:
                sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia', 'write', tecnologia_id, args_create)
            # TECNOLOGIA MANUTENÇÃO DE MICROS
            args_search = [('name','=', 'MANUTENCAO DE MICROS')]
            tecnologia_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia.tipo', 'search', args_search)[0]
            args_search = [('tecnologia_tipo_id','=', tecnologia_tipo_id), ('curriculo_id','=',curriculo_id)]
            tecnologia_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia', 'search', args_search)
            args_create = {'tecnologia_tipo_id': tecnologia_tipo_id, 'curriculo_id': curriculo_id, 'dominio': vals['curso_micros']}
            if not tecnologia_id:
                tecnologia_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia', 'create', args_create)
            else:
                sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia', 'write', tecnologia_id, args_create)
            # TECNOLOGIA REDES
            args_search = [('name','=', 'REDES')]
            tecnologia_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia.tipo', 'search', args_search)[0]
            args_search = [('tecnologia_tipo_id','=', tecnologia_tipo_id), ('curriculo_id','=',curriculo_id)]
            tecnologia_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia', 'search', args_search)
            args_create = {'tecnologia_tipo_id': tecnologia_tipo_id, 'curriculo_id': curriculo_id, 'dominio': vals['curso_redes']}
            if not tecnologia_id:
                tecnologia_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia', 'create', args_create)
            else:
                sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia', 'write', tecnologia_id, args_create)
            # TECNOLOGIA PROGRAMAÇÃO (PYTHON/...)
            args_search = [('name','=', 'PROGRAMACAO (PYTHON/...)')]
            tecnologia_tipo_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia.tipo', 'search', args_search)[0]
            args_search = [('tecnologia_tipo_id','=', tecnologia_tipo_id), ('curriculo_id','=',curriculo_id)]
            tecnologia_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia', 'search', args_search)
            args_create = {'tecnologia_tipo_id': tecnologia_tipo_id, 'curriculo_id': curriculo_id, 'dominio': vals['curso_programacao']}
            if not tecnologia_id:
                tecnologia_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia', 'create', args_create)
            else:
                sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia', 'write', tecnologia_id, args_create)
            # CURSO 01
            if not vals['tipo_curso_01'] == 'False':
                args_search = [('sequence','=', 1), ('curriculo_id','=',curriculo_id)]
                args_create =  {'cursos_tipos_id': vals['tipo_curso_01'], 'instituicao': vals['instituicao_01'],
                        'cidade_str': vals['cidade_01'], 'name': vals['descricao_01'],
                        'mes_conclusao': vals['mes_conclusao_01'], 'ano_conclusao': vals['ano_conclusao_01'],
                        'curriculo_id': curriculo_id, 'sequence': 1}
                curso_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.cursos', 'search', args_search)
                if not curso_id:
                    curso_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.cursos', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.cursos', 'write', curso_id, args_create)
            # CURSO 02
            if not vals['tipo_curso_02'] == 'False':
                args_search = [('sequence','=', 2), ('curriculo_id','=',curriculo_id)]
                args_create =  {'cursos_tipos_id': vals['tipo_curso_02'], 'instituicao': vals['instituicao_02'],
                        'cidade_str': vals['cidade_02'], 'name': vals['descricao_02'],
                        'mes_conclusao': vals['mes_conclusao_02'], 'ano_conclusao': vals['ano_conclusao_02'],
                        'curriculo_id': curriculo_id, 'sequence': 2}
                curso_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.cursos', 'search', args_search)
                if not curso_id:
                    curso_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.cursos', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.cursos', 'write', curso_id, args_create)
            # CURSO 03
            if not vals['tipo_curso_03'] == 'False':
                args_search = [('sequence','=', 3), ('curriculo_id','=',curriculo_id)]
                args_create =  {'cursos_tipos_id': vals['tipo_curso_03'], 'instituicao': vals['instituicao_03'],
                        'cidade_str': vals['cidade_03'], 'name': vals['descricao_03'],
                        'mes_conclusao': vals['mes_conclusao_03'], 'ano_conclusao': vals['ano_conclusao_03'],
                        'curriculo_id': curriculo_id, 'sequence': 3}
                curso_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.cursos', 'search', args_search)
                if not curso_id:
                    curso_id = sock.execute(dbname, uid, pwd, 'rhcurriculo.cursos', 'create', args_create)
                else:
                    sock.execute(dbname, uid, pwd, 'rhcurriculo.cursos', 'write', curso_id, args_create)



            return render_to_response('update.html', {
                    'dados': {'email': 'christian'},
            })




        else:
            return errorHandle(form.errors)
    else:
        tipo_login = request.session.get('tipo_login')
        if tipo_login == 'user_novo':
            form = LoggedForm()
            return render_to_response('cadastro_rh.html', {'form': form })
        if tipo_login ==  'user_cadastrado':
            id_pessoa = id
            # DADOS PESSOA
            fields = ['name', 'email' ,'endereco_ids', 'telefones_ids', 'pessoa_fisica_ids']
            vals_pessoa = sock.execute(dbname, uid, pwd, 'adm.pessoa', 'read', id_pessoa, fields)[0]
            # DADOS PESSOA FISICA
            fields = ['data_nascimento', 'estado_civil', 'sexo']
            vals_pessoa_f = sock.execute(dbname, uid, pwd, 'adm.pessoa.fisica', 'read', vals_pessoa['pessoa_fisica_ids'], fields)[0]
            # DADOS ENDERECO
            fields = ['cep', 'complemento', 'numero', 'cidade_id', 'bairro_id', 'logradouro_id', 'uf_id']
            vals_endereco = sock.execute(dbname, uid, pwd, 'adm.pessoa.endereco', 'read', vals_pessoa['endereco_ids'], fields)
            
            if vals_endereco:
                cep = re.sub('[^0-9]', '',vals_endereco[0]['cep']),
                cidade = vals_endereco[0]['cidade_id'][1],
                uf = vals_endereco[0]['uf_id'][1],
                endereco = vals_endereco[0]['logradouro_id'][1],
                bairro = vals_endereco[0]['bairro_id'][1],
                numero = vals_endereco[0]['numero'],
                complemento = vals_endereco[0]['complemento'],
                if isinstance(cep, tuple): cep = cep[0]
                if isinstance(cidade, tuple): cidade = cidade[0]
                if isinstance(uf, tuple): uf = uf[0]
                if isinstance(endereco, tuple): endereco = endereco[0]
                if isinstance(bairro, tuple): bairro = bairro[0]
                if isinstance(numero, tuple): numero = numero[0]
                if isinstance(complemento, tuple): complemento = complemento[0]
            else:
                [cep, cidade, uf, endereco, bairro, numero, complemento] = ['','','','','','','']
            # DADOS TELEFONE
            fields = ['ddd', 'numero', 'telefone_tipo_id']
            [ddd_com, fone_com, ddd_res, fone_res, ddd_cel, fone_cel] = ['','','','','','',]
            for id in vals_pessoa['telefones_ids']:
                vals_telefone = sock.execute(dbname, uid, pwd, 'adm.pessoa.telefone', 'read', id, fields)[0]
                if vals_telefone['telefone_tipo_id'][1] == 'Comercial':
                    ddd_com = vals_telefone['ddd']
                    fone_com = vals_telefone['numero']
                if vals_telefone['telefone_tipo_id'][1] == 'Residencial':
                    ddd_res = vals_telefone['ddd']
                    fone_res = vals_telefone['numero']
                if vals_telefone['telefone_tipo_id'][1] == 'Celular':
                    ddd_cel = vals_telefone['ddd']
                    fone_cel = vals_telefone['numero']
            # DADOS CURRICULO
            id_curriculo = sock.execute(dbname, uid, pwd, 'rhcurriculo.curriculo', 'search', [('pessoa_id','=',id_pessoa)])
            vals_curriculo = sock.execute(dbname, uid, pwd, 'rhcurriculo.curriculo', 'read', id_curriculo, [])[0]
            # EXPERIENCIAS
            fields = []
            [vendas_ope, vendas_sup, vendas_ger, vendas_dir] = [False,False,False,False]
            [boy_ope, boy_sup, boy_ger, boy_dir] = [False,False,False,False]
            [admin_ope, admin_sup, admin_ger, admin_dir] = [False,False,False,False]
            [finan_ope, finan_sup, finan_ger, finan_dir] = [False,False,False,False]
            [comp_ope, comp_sup, comp_ger, comp_dir] = [False,False,False,False]
            [est_ope, est_sup, est_ger, est_dir] = [False,False,False,False]
            [fisc_ope, fisc_sup, fisc_ger, fisc_dir] = [False,False,False,False]
            #AMBIENTAL
            [amb_ope, amb_sup, amb_ger, amb_dir] = [False,False,False,False]
            #ATENDIMENTO
            [atend_ope, atend_sup, atend_ger, atend_dir] = [False,False,False,False]
            #COMUNICACAO
            [com_ope, com_sup, com_ger, com_dir] = [False,False,False,False]
            #SUPORTE
            [sup_ope, sup_sup, sup_ger, sup_dir] = [False,False,False,False]
            #QUALIDADE
            [qual_ope, qual_sup, qual_ger, qual_dir] = [False,False,False,False]
            #CAIXA
            [caixa_ope, caixa_sup, caixa_ger, caixa_dir] = [False,False,False,False]
            #NUTRICAO
            [nut_ope, nut_sup, nut_ger, nut_dir] = [False,False,False,False]
            #ADVOCACIA
            [adv_ope, adv_sup, adv_ger, adv_dir] = [False,False,False,False]
            #SECRETARIADO
            [sec_ope, sec_sup, sec_ger, sec_dir] = [False,False,False,False]
            #SERVIÇOS GERAIS
            [serv_ope, serv_sup, serv_ger, serv_dir] = [False,False,False,False]
            #SERVIÇOS TECNOLOGIA
            [tec_ope, tec_sup, tec_ger,tec_dir] = [False,False,False,False]
            #OUVIDORIA
            [ouv_ope, ouv_sup, ouv_ger, ouv_dir] = [False,False,False,False]
            #PLANEJAMENTO
            [plan_ope, plan_sup, plan_ger, plan_dir] = [False,False,False,False]

            for id in vals_curriculo['experiencias_ids']:
                vals_experiencia = sock.execute(dbname, uid, pwd, 'rhcurriculo.experiencias', 'read', id, fields)
                if vals_experiencia['experiencias_tipos_id'][1] == 'VENDAS':
                    vendas_ope = vals_experiencia['operacional']
                    vendas_sup = vals_experiencia['supervisao']
                    vendas_ger = vals_experiencia['gerencia']
                    vendas_dir = vals_experiencia['diretoria']
                if vals_experiencia['experiencias_tipos_id'][1] == 'OFFICE BOY (MOTOQUEIRO)':
                    boy_ope = vals_experiencia['operacional']
                    boy_sup = vals_experiencia['supervisao']
                    boy_ger = vals_experiencia['gerencia']
                    boy_dir = vals_experiencia['diretoria']
                if vals_experiencia['experiencias_tipos_id'][1] == 'ADMINISTRATIVO':
                    admin_ope = vals_experiencia['operacional']
                    admin_sup = vals_experiencia['supervisao']
                    admin_ger = vals_experiencia['gerencia']
                    admin_dir = vals_experiencia['diretoria']
                if vals_experiencia['experiencias_tipos_id'][1] == 'FINANCEIRO':
                    finan_ope = vals_experiencia['operacional']
                    finan_sup = vals_experiencia['supervisao']
                    finan_ger = vals_experiencia['gerencia']
                    finan_dir = vals_experiencia['diretoria']
                if vals_experiencia['experiencias_tipos_id'][1] == 'COMPRAS':
                    comp_ope = vals_experiencia['operacional']
                    comp_sup = vals_experiencia['supervisao']
                    comp_ger = vals_experiencia['gerencia']
                    comp_dir = vals_experiencia['diretoria']
                if vals_experiencia['experiencias_tipos_id'][1] == 'ESTOQUE':
                    est_ope = vals_experiencia['operacional']
                    est_sup = vals_experiencia['supervisao']
                    est_ger = vals_experiencia['gerencia']
                    est_dir = vals_experiencia['diretoria']
                if vals_experiencia['experiencias_tipos_id'][1] == 'FISCAL':
                    fisc_ope = vals_experiencia['operacional']
                    fisc_sup = vals_experiencia['supervisao']
                    fisc_ger = vals_experiencia['gerencia']
                    fisc_dir = vals_experiencia['diretoria']
                if vals_experiencia['experiencias_tipos_id'][1] == 'AMBIENTAL':
                    amb_ope = vals_experiencia['operacional']
                    amb_sup = vals_experiencia['supervisao']
                    amb_ger = vals_experiencia['gerencia']
                    amb_dir = vals_experiencia['diretoria']
                if vals_experiencia['experiencias_tipos_id'][1] == 'ATENDIMENTO/CLIENTE':
                    atend_ope = vals_experiencia['operacional']
                    atend_sup = vals_experiencia['supervisao']
                    atend_ger = vals_experiencia['gerencia']
                    atend_dir = vals_experiencia['diretoria']
                if vals_experiencia['experiencias_tipos_id'][1] == 'COMUNICACAO':
                    com_ope = vals_experiencia['operacional']
                    com_sup = vals_experiencia['supervisao']
                    com_ger = vals_experiencia['gerencia']
                    com_dir = vals_experiencia['diretoria']
                if vals_experiencia['experiencias_tipos_id'][1] == 'SUPORTE TECNICO':
                    sup_ope = vals_experiencia['operacional']
                    sup_sup = vals_experiencia['supervisao']
                    sup_ger = vals_experiencia['gerencia']
                    sup_dir = vals_experiencia['diretoria']
                if vals_experiencia['experiencias_tipos_id'][1] == 'QUALIDADE':
                    qual_ope = vals_experiencia['operacional']
                    qual_sup = vals_experiencia['supervisao']
                    qual_ger = vals_experiencia['gerencia']
                    qual_dir = vals_experiencia['diretoria']
                if vals_experiencia['experiencias_tipos_id'][1] == 'CAIXA':
                    caixa_ope = vals_experiencia['operacional']
                    caixa_sup = vals_experiencia['supervisao']
                    caixa_ger = vals_experiencia['gerencia']
                    caixa_dir = vals_experiencia['diretoria']
                if vals_experiencia['experiencias_tipos_id'][1] == 'NUTRICAO':
                    nut_ope = vals_experiencia['operacional']
                    nut_sup = vals_experiencia['supervisao']
                    nut_ger = vals_experiencia['gerencia']
                    nut_dir = vals_experiencia['diretoria']
                if vals_experiencia['experiencias_tipos_id'][1] == 'ADVOCACIA':
                    adv_ope = vals_experiencia['operacional']
                    adv_sup = vals_experiencia['supervisao']
                    adv_ger = vals_experiencia['gerencia']
                    adv_dir = vals_experiencia['diretoria']
                if vals_experiencia['experiencias_tipos_id'][1] == 'SECRETARIADO':
                    sec_ope = vals_experiencia['operacional']
                    sec_sup = vals_experiencia['supervisao']
                    sec_ger = vals_experiencia['gerencia']
                    sec_dir = vals_experiencia['diretoria']
                if vals_experiencia['experiencias_tipos_id'][1] == 'SERVICOS GERAIS':
                    serv_ope = vals_experiencia['operacional']
                    serv_sup = vals_experiencia['supervisao']
                    serv_ger = vals_experiencia['gerencia']
                    serv_dir = vals_experiencia['diretoria']
                if vals_experiencia['experiencias_tipos_id'][1] == 'IMPLANTACAO DE TECNOLOGIA':
                    tec_ope = vals_experiencia['operacional']
                    tec_sup = vals_experiencia['supervisao']
                    tec_ger = vals_experiencia['gerencia']
                    tec_dir = vals_experiencia['diretoria']
                if vals_experiencia['experiencias_tipos_id'][1] == 'OUVIDORIA':
                    ouv_ope = vals_experiencia['operacional']
                    ouv_sup = vals_experiencia['supervisao']
                    ouv_ger = vals_experiencia['gerencia']
                    ouv_dir = vals_experiencia['diretoria']
                if vals_experiencia['experiencias_tipos_id'][1] == 'PLANEJAMENTO ESTRATEGICO':
                    plan_ope = vals_experiencia['operacional']
                    plan_sup = vals_experiencia['supervisao']
                    plan_ger = vals_experiencia['gerencia']
                    plan_dir = vals_experiencia['diretoria']
            # EMPRESA
            [empresa_01, segmento_01, modalidade_01, cargo_01, mes_entrada_01, ano_entrada_01, mes_saida_01, ano_saida_01, atribuicoes_01] = ['','','','','','','','','',]
            [empresa_02, segmento_02, modalidade_02, cargo_02, mes_entrada_02, ano_entrada_02, mes_saida_02, ano_saida_02, atribuicoes_02] = ['','','','','','','','','',]
            [empresa_03, segmento_03, modalidade_03, cargo_03, mes_entrada_03, ano_entrada_03, mes_saida_03, ano_saida_03, atribuicoes_03] = ['','','','','','','','','',]
            for id in vals_curriculo['empresas_ids']:

                vals_empresa = sock.execute(dbname, uid, pwd, 'rhcurriculo.empresas', 'read', id, [])
                if vals_empresa['sequence'] == 1:
                    empresa_01 = vals_empresa['empresa']
                    segmento_01 = vals_empresa['segmento']
                    modalidade_01 = vals_empresa['modalidade']
                    cargo_01 = vals_empresa['cargo']
                    mes_entrada_01 = vals_empresa['mes_entrada']
                    ano_entrada_01 = vals_empresa['ano_entrada']
                    mes_saida_01 = vals_empresa['mes_saida']
                    ano_saida_01 = vals_empresa['ano_saida']
                    atribuicoes_01 = vals_empresa['atribuicoes']
                if vals_empresa['sequence'] == 2:
                    empresa_02 = vals_empresa['empresa']
                    segmento_02 = vals_empresa['segmento']
                    modalidade_02 = vals_empresa['modalidade']
                    cargo_02 = vals_empresa['cargo']
                    mes_entrada_02 = vals_empresa['mes_entrada']
                    ano_entrada_02 = vals_empresa['ano_entrada']
                    mes_saida_02 = vals_empresa['mes_saida']
                    ano_saida_02 = vals_empresa['ano_saida']
                    atribuicoes_02 = vals_empresa['atribuicoes']
                if vals_empresa['sequence'] == 3:
                    empresa_03 = vals_empresa['empresa']
                    segmento_03 = vals_empresa['segmento']
                    modalidade_03 = vals_empresa['modalidade']
                    cargo_03 = vals_empresa['cargo']
                    mes_entrada_03 = vals_empresa['mes_entrada']
                    ano_entrada_03 = vals_empresa['ano_entrada']
                    mes_saida_03 = vals_empresa['mes_saida']
                    ano_saida_03 = vals_empresa['ano_saida']
                    atribuicoes_03 = vals_empresa['atribuicoes']
            # IDIOMAS
            [idioma_ingles, idioma_espanhol, idioma_frances, idioma_alemao, idioma_italiano] = ['00','00','00','00','00']
            for id in vals_curriculo['idiomas_ids']:
                vals_idiomas = sock.execute(dbname, uid, pwd, 'rhcurriculo.idiomas', 'read', id, [])
                if vals_idiomas['idiomas_tipos_id'][1] == 'Ingles':
                    idioma_ingles = vals_idiomas['fluencia']
                if vals_idiomas['idiomas_tipos_id'][1] == 'Espanhol':
                    idioma_espanhol = vals_idiomas['fluencia']
                if vals_idiomas['idiomas_tipos_id'][1] == 'Frances':
                    idioma_frances = vals_idiomas['fluencia']
                if vals_idiomas['idiomas_tipos_id'][1] == 'Alemao':
                    idioma_alemao = vals_idiomas['fluencia']
                if vals_idiomas['idiomas_tipos_id'][1] == 'Italiano':
                    idioma_italiano = vals_idiomas['fluencia']
            # CURSOS
            [curso_office, curso_cad, curso_design, curso_micros, curso_redes, curso_programacao] = ['N','N','N','N','N','N']

            for id in vals_curriculo['tecnologia_ids']:
                vals_tecnologia = sock.execute(dbname, uid, pwd, 'rhcurriculo.tecnologia', 'read', id, [])
                if vals_tecnologia['tecnologia_tipo_id'][1] == 'OFFICE (WORD/EXCEL)':
                    curso_office = vals_tecnologia['dominio']
                if vals_tecnologia['tecnologia_tipo_id'][1] == 'AUTO-CAD':
                    curso_cad = vals_tecnologia['dominio']
                if vals_tecnologia['tecnologia_tipo_id'][1] == 'DESIGN (PHOTOSHOP/COREL-DRAW)':
                    curso_design = vals_tecnologia['dominio']
                if vals_tecnologia['tecnologia_tipo_id'][1] == 'MANUTENCAO DE MICROS':
                    curso_micros = vals_tecnologia['dominio']
                if vals_tecnologia['tecnologia_tipo_id'][1] == 'REDES':
                    curso_redes = vals_tecnologia['dominio']
                if vals_tecnologia['tecnologia_tipo_id'][1] == 'PROGRAMACAO (PYTHON/...)':
                    curso_programacao = vals_tecnologia['dominio']
            # GRADUAÇÂO
            [tipo_curso_01, instituicao_01, cidade_01, descricao_01, mes_conclusao_01, ano_conclusao_01] = [False, '','','','','']
            [tipo_curso_02, instituicao_02, cidade_02, descricao_02, mes_conclusao_02, ano_conclusao_02] = [False, '','','','','']
            [tipo_curso_03, instituicao_03, cidade_03, descricao_03, mes_conclusao_03, ano_conclusao_03] = [False, '','','','','']
            for id in vals_curriculo['cursos_ids']:
                vals_cursos = sock.execute(dbname, uid, pwd, 'rhcurriculo.cursos', 'read', id, [])
                if vals_cursos['sequence'] == 1:
                    tipo_curso_01 = vals_cursos['cursos_tipos_id'][0]
                    instituicao_01 = vals_cursos['instituicao']
                    cidade_01 = vals_cursos['cidade_str']
                    descricao_01 = vals_cursos['name']
                    mes_conclusao_01 = vals_cursos['mes_conclusao']
                    ano_conclusao_01 = vals_cursos['ano_conclusao']
                if vals_cursos['sequence'] == 2:
                    tipo_curso_02 = vals_cursos['cursos_tipos_id'][0]
                    instituicao_02 = vals_cursos['instituicao']
                    cidade_02 = vals_cursos['cidade_str']
                    descricao_02 = vals_cursos['name']
                    mes_conclusao_02 = vals_cursos['mes_conclusao']
                    ano_conclusao_02 = vals_cursos['ano_conclusao']
                if vals_cursos['sequence'] == 3:
                    tipo_curso_03 = vals_cursos['cursos_tipos_id'][0]
                    instituicao_03 = vals_cursos['instituicao']
                    cidade_03 = vals_cursos['cidade_str']
                    descricao_03 = vals_cursos['name']
                    mes_conclusao_03 = vals_cursos['mes_conclusao']
                    ano_conclusao_03 = vals_cursos['ano_conclusao']


            data = {
                    'nome': vals_pessoa['name'],
                    'email': vals_pessoa['email'],
                    'email_confirm': vals_pessoa['email'],

                    'cep': cep,
                    'cidade': cidade,
                    'uf': uf,
                    'endereco': endereco,
                    'bairro': bairro,
                    'numero': numero,
                    'complemento': complemento,
                    'ddd_com': ddd_com,
                    'ddd_res': ddd_res,
                    'ddd_cel': ddd_cel,
                    'fone_com': fone_com,
                    'fone_res': fone_res,
                    'fone_cel': fone_cel,
                    'estado_civil': vals_pessoa_f['estado_civil'],
                    'sexo': vals_pessoa_f['sexo'],
                    'nascimento': time.strftime("%d/%m/%Y",time.strptime(vals_pessoa_f['data_nascimento'],"%Y-%m-%d")),
                    'filhos': vals_curriculo['filhos'],
                    'deficiencia': vals_curriculo['deficiencia'],
                    'deficiencia_descricao': vals_curriculo['deficiencia_descricao'],
                    'experiencia': vals_curriculo['experiencia'],
                    'disponibilidade': vals_curriculo['disponibilidade'],
                    'trabalhando': vals_curriculo['trabalhando'],
                    'vendas_ope': vendas_ope, 'vendas_sup': vendas_sup, 'vendas_ger': vendas_ger, 'vendas_dir': vendas_dir,
                    'boy_ope': boy_ope, 'boy_sup': boy_sup, 'boy_ger': boy_ger, 'boy_dir': boy_dir,
                    'admin_ope': admin_ope, 'admin_sup': admin_sup, 'admin_ger': admin_ger, 'admin_dir': admin_dir,
                    'finan_ope': finan_ope, 'finan_sup': finan_sup, 'finan_ger': finan_ger, 'finan_dir': finan_dir,
                    'comp_ope': comp_ope, 'comp_sup': comp_sup, 'comp_ger': comp_ger, 'comp_dir': comp_dir,
                    'est_ope': est_ope, 'est_sup': est_sup, 'est_ger': est_ger, 'est_dir': est_dir,
                    'fisc_ope':fisc_ope, 'fisc_sup':fisc_sup, 'fisc_ger':fisc_ger, 'fisc_dir':fisc_dir,
                    #AMBIENTAL
                    'amb_ope':amb_ope, 'amb_sup':amb_sup, 'amb_ger':amb_ger, 'amb_dir':amb_dir,
                    #ATENDIMENTO
                    'atend_ope':atend_ope, 'atend_sup':atend_sup, 'atend_ger':atend_ger, 'atend_dir':atend_dir,
                    #COMUNICACAO
                    'com_ope':com_ope, 'com_sup':com_sup, 'com_ger':com_ger, 'com_dir':com_dir,
                    #SUPORTE
                    'sup_ope':sup_ope, 'sup_sup':sup_sup, 'sup_ger':sup_ger, 'sup_dir':sup_dir,
                    #QUALIDADE
                    'qual_ope':qual_ope, 'qual_sup':qual_sup, 'qual_ger':qual_ger, 'qual_dir':qual_dir,
                    #CAIXA
                    'caixa_ope':caixa_ope, 'caixa_sup':caixa_sup, 'caixa_ger':caixa_ger, 'caixa_dir':caixa_dir,
                    #NUTRICAO
                    'nut_ope':nut_ope, 'nut_sup':nut_sup, 'nut_ger':nut_ger, 'nut_dir':nut_dir,
                    ''#ADVOCACIA
                    'adv_ope':adv_ope, 'adv_sup':adv_sup, 'adv_ger':adv_ger, 'adv_dir':adv_dir,
                    ''#SECRETARIADO
                    'sec_ope':sec_ope, 'sec_sup':sec_sup, 'sec_ger':sec_ger, 'sec_dir':sec_dir,
                    ''#SERVIÇOS GERAIS
                    'serv_ope':serv_ope, 'serv_sup':serv_sup, 'serv_ger':serv_ger,'serv_dir':serv_dir,
                    ''#SERVIÇOS TECNOLOGIA
                    'tec_ope':tec_ope, 'tec_sup':tec_sup, 'tec_ger':tec_ger, 'tec_dir':tec_dir,
                    #OUVIDORIA
                    'ouv_ope':ouv_ope, 'ouv_sup':ouv_sup, 'ouv_ger':ouv_ger, 'ouv_dir':ouv_dir,
                    #PLANEJAMENTO
                    'plan_ope':plan_ope, 'plan_sup':plan_sup, 'plan_ger':plan_ger, 'plan_dir':plan_dir,
                    'objetivos':vals_curriculo['complemento'],
                    'pretencao':vals_curriculo['pretencao'],
                    'outra_cidade':vals_curriculo['outra_cidade'],
                    'escolaridade':vals_curriculo['escolaridade'],
                    #EMPRESA 01
                    'empresa_01': empresa_01,
                    'segmento_01': segmento_01,
                    'modalidade_01': modalidade_01,
                    'cargo_01': cargo_01,
                    'mes_entrada_01': mes_entrada_01,
                    'ano_entrada_01': ano_entrada_01,
                    'mes_saida_01': mes_saida_01,
                    'ano_saida_01': ano_saida_01,
                    'atribuicoes_01': atribuicoes_01,
                    #EMPRESA 02
                    'empresa_02': empresa_02,
                    'segmento_02': segmento_02,
                    'modalidade_02': modalidade_02,
                    'cargo_02': cargo_02,
                    'mes_entrada_02': mes_entrada_02,
                    'ano_entrada_02': ano_entrada_02,
                    'mes_saida_02': mes_saida_02,
                    'ano_saida_02': ano_saida_02,
                    'atribuicoes_02': atribuicoes_02,
                    #EMPRESA 03
                    'empresa_03': empresa_03,
                    'segmento_03': segmento_03,
                    'modalidade_03': modalidade_03,
                    'cargo_03': cargo_03,
                    'mes_entrada_03': mes_entrada_03,
                    'ano_entrada_03': ano_entrada_03,
                    'mes_saida_03': mes_saida_03,
                    'ano_saida_03': ano_saida_03,
                    'atribuicoes_03': atribuicoes_03,
                    #IDIOMAS
                    'idioma_ingles': idioma_ingles,
                    'idioma_espanhol': idioma_espanhol,
                    'idioma_frances': idioma_frances,
                    'idioma_alemao': idioma_alemao,
                    'idioma_italiano': idioma_italiano,
                    #TECNOLOGIAS
                    'curso_office': curso_office,
                    'curso_cad': curso_cad,
                    'curso_design': curso_design,
                    'curso_micros': curso_micros,
                    'curso_redes': curso_redes,
                    'curso_programacao': curso_programacao,
                    #GRADUACAO 01
                    'tipo_curso_01': tipo_curso_01,
                    'instituicao_01': instituicao_01,
                    'cidade_01': cidade_01,
                    'descricao_01': descricao_01,
                    'mes_conclusao_01': mes_conclusao_01,
                    'ano_conclusao_01': ano_conclusao_01,
                    #GRADUACAO 02
                    'tipo_curso_02': tipo_curso_02,
                    'instituicao_02': instituicao_02,
                    'cidade_02': cidade_02,
                    'descricao_02': descricao_02,
                    'mes_conclusao_02': mes_conclusao_02,
                    'ano_conclusao_02': ano_conclusao_02,
                    #GRADUACAO 01
                    'tipo_curso_03': tipo_curso_03,
                    'instituicao_03': instituicao_03,
                    'cidade_03': cidade_03,
                    'descricao_03': descricao_03,
                    'mes_conclusao_03': mes_conclusao_03,
                    'ano_conclusao_03': ano_conclusao_03,

            }

            form = LoggedForm(data)

            return render_to_response('cadastro_rh.html', {'form': form })
    return render_to_response('cadastro_rh.html', {'form': form })