# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler
import time

class rhcurriculo_vagas(osv.Model):
    """
    Tabela de vagas ofertadas pelos contratantes
    Perfil de contratacao
    
    """
    _name = 'rhcurriculo.vagas'
    _rec_name = 'contratante_id'
    _columns = {
        'contratante_id' : fields.many2one("adm.pessoa", 'Contratante', ondelete="cascade", required=True, select = True, domain="[('pessoa_tipo','=','J')]"), # Id da empresa que faz a contratacao
        'date_contratacao' : fields.date('Date contratacao'), # Data da contratacao
        'cargo' : fields.char('Cargo', size=45), # Cargo contratado
        'prazo_contratacao' : fields.selection([('1','10 dias'),('2','15 dias'),('3','30 dias'),('4','Mais de 30 dias')], 'Prazo contratacao', size=1), # Prazo para contratacao\n1=10 dias\n2=15 dias\n3=30 dias\n4=Mais de 30 dias
        'numero_vagas' : fields.integer('Numero vagas'), # Quantidade de vagas
        'responsavel_id' : fields.many2one("adm.pessoa", 'Responsavel', ondelete="no action", required=True, select = True, domain="[('pessoa_tipo','=','F')]"), # Id da pessoa responsavel
        'superior_id' : fields.many2one("adm.pessoa", 'Superior', ondelete="no action", select = True, domain="[('pessoa_tipo','=','F')]"), # Id do superior imediato\n
        'cargo_exigencias' : fields.text('Cargo exigencias'), # Exigencias do cargo
        'cargo_tarefas' : fields.text('Tarefas do Cargo'), # Relacao das tarefas a serem executadas neste cargo
        'horario' : fields.selection([('1','1'),('2','2')], 'Horario de trabalho', size=1), # Horario de trabalho\n1=\n2=
        'salario' : fields.float('Salario', digits=(14,2)), # Valor do salario a ser pago
        'modalidade' : fields.selection([('1','CLT'), ('2','Estatutario'), ('3','PJ')], 'Modalidade', size=1), # Modalidade de contratacao\n1=CLT-Carteira assinada\n2=Estatutario\n3=PJ
        'demanda_hora_extra' : fields.selection([('S','Sim'),('N','Nao'),('E','Eventualmente')], 'Demanda hora extra', size=1), # Demanda hora extra?\nS=Sim,\nN=Nao\nE=Eventualmente
        'sistema_pagamento' : fields.selection([('B','Banco de horas'),('F','Pago na folha')], 'Sistema de pagamento', size=1), # Sistema de Pagamento\nB=Banco de horas\nF=Pago na folha
        'epi' : fields.selection([('S','Sim'),('N','Nao')], 'EPI', size=1), # utiliza EPI\nS=Sim\nN=Nao
        'epi_quais' : fields.char('EPI, quais', size=60), # Caso utilize EPI, quais sao utilizados
        'vale_transporte' : fields.selection([('S','Sim'),('N','Nao')], 'Vale transporte', size=1), # Fornece vale transporte\nS=Sim\nN=Nao
        'vale_alimentacao' : fields.selection([('S','Sim'),('N','Nao')], 'Vale alimentacao', size=1), # Fornece vale alimentacao\nS=Sim,\nN=Nao
        'vale_transporte_quantidade' : fields.integer('Vale transporte quantidade'), # Quantidade de vales transporte
        'plano_saude' : fields.selection([('S','Sim'),('N','Nao')], 'Plano saude', size=1), # Fornece plano saude\n
        'plano_saude_modalidade' : fields.char('Plano saude modalidade', size=60), # Modalidade do plano de saude
        'plano_odontologico' : fields.selection([('S','Sim'),('N','Nao')], 'Plano odontologico', size=1), # Fornece Plano odontologico\nS=Sim\nN=Nao
        'bolsa_estudo' : fields.selection([('S','Sim'),('N','Nao')], 'Bolsa de estudo', size=1), # Fornece bolsa de estudo\nS=Sim\nN=Nao
        'bolsa_estudo_valor' : fields.float('Bolsa estudo valor', digits=(12,2)), # Valor da bolsa de estudos
        'outros_beneficios' : fields.text('Outros beneficios'), # Outros beneficios ofertados pelo contratante
        'sexo' : fields.selection([('M','Masculino'), ('F', 'Feminino'), ('A', 'Ambos')], 'Sexo', size=1), # sexo solicitado\nM=Masculino\nF=Feminino\nA=Ambos
        'raca' : fields.selection([('B','Branco'), ('N', 'Negro'), ('I', 'Indiferente')], 'Raca', size=1), # Raca da pessoa a ser contratada\nB=Branco\nN=Negro\nI=Indiferente
        'experiencia_minima' : fields.char('Experiencia minima', size=45), # Esperiencia minima do candidato
        'experiencia_desejada' : fields.char('Experiencia desejada', size=45), # Experiencia desejada do candidato.
        'escolaridade_minima' : fields.selection([('00','Sem Informacao'),('01', 'Nao sabe ler/escrever'),('02', 'Alfabetizado'),('03', 'Fundamental 1o grau incompleto'),('04', 'Fundamental 1o grau completo'),('05', 'Medio 2o grau incompleto'),('06', 'Medio 2o grau completo'),('07', 'Superior incompleto'),('08', 'Superior completo'),('09', 'Especializacao'),('10', 'Residencia'),('11', 'Mestrado'),('12', 'Doutorado')], 'Escolaridade minima', size=2), # Escolaridade minima aceita\nGrau de escolaridade\n01=Nao sabe ler/escrever\n02=Alfabetizado\n03=Fundamental 1o grau incompleto\n04=Fundamental 1o grau completo\n05=Medio 2o grau incompleto\n06=Medio 2o grau completo\n07=Superior incompleto\n08=Superior completo\n09=Especializacao\n10=Residencia\n11=Mestrado\n12=Doutorado\n00=Sem informacao
        'escolaridade_desejada' : fields.selection([('00','Sem Informacao'),('01', 'Nao sabe ler/escrever'),('02', 'Alfabetizado'),('03', 'Fundamental 1o grau incompleto'),('04', 'Fundamental 1o grau completo'),('05', 'Medio 2o grau incompleto'),('06', 'Medio 2o grau completo'),('07', 'Superior incompleto'),('08', 'Superior completo'),('09', 'Especializacao'),('10', 'Residencia'),('11', 'Mestrado'),('12', 'Doutorado')], 'Escolaridade desejada', size=2), # Escolaridade desejada\nGrau de escolaridade\n01=Nao sabe ler/escrever\n02=Alfabetizado\n03=Fundamental 1o grau incompleto\n04=Fundamental 1o grau completo\n05=Medio 2o grau incompleto\n06=Medio 2o grau completo\n07=Superior incompleto\n08=Superior completo\n09=Especializacao\n10=Residencia\n11=Mestrado\n12=Doutorado\n00=Sem informacao
        'estado_civil' : fields.selection([('S','Solteiro'), ('C', 'Casado'), ('I', 'Indiferente')], 'Estado civil', size=1), # Estado civil desejado para a contratacao\nS=Solteiro\nC=Casado, \nI=Indiferente
        'filhos_restricao' : fields.selection([('S','Sim'), ('N', 'Nao')], 'Restricao filhos', size=1), # Restricao quanto a filhos do candidato
        'filhos_restricao_tipo' : fields.char('Tipo de restricao filhos', size=45),
        'caracteristicas_pessoais' : fields.text('Caracteristicas pessoais'), # Caracteristicas pessoais e fisicas do candidato
        'contratacao_restricoes' : fields.text('Contratacao restricoes'), # Restricoes para contratacao
        'state' : fields.selection([('recebido','Recebido'), ('captando', 'Captando'), ('atendido', 'Atendido'), ('cancelado', 'Cancelado')], 'Situacao'), # Estado da vaga\nRecebido=Vaga recebida. estado inicial\nCaptando=Procurando candidatos para a vaga\nAtendido=Fornecidos os candidatos para a vaga\nCancelado=Vaga cancelada
    }

