# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
# www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class rhfolha_eventos(osv.Model):
    """
    Classe cadastro de eventos
    Prefixo: rheven
    """
    _name = 'rhfolha.eventos'
    _rec_name = 'rheven_name'
    _columns = {
        'rheven_codigo': fields.integer('Codigo', select=True, required=True),
        'rheven_name': fields.char('Descricao', size=45, required=True, select=True),
        'rheven_venc_desc': fields.selection([('V', 'Vencimento'), ('D', 'Desconto')], 'Vencimento/Desconto', required=True),
        'rheven_irrf': fields.boolean('Inside IRRF'),
        'rheven_inss': fields.boolean('Inside INSS'),
        'rheven_fgts': fields.boolean('Inside FGTS'),
        'rheven_processamento': fields.selection([('A', 'Automatico'), ('V', 'Valor'), ('R', 'Referencia')], 'Tipo de processamento', required=True),
        'rheven_percentual': fields.float('Percentual', digits=(4, 2)),
        'rheven_formula': fields.text('Formula'),
        'rheven_evento_id': fields.many2one('gerencial.evento', 'Evento', ondelete='restrict'),
    }
    _order = 'rheven_codigo'
    _sql_constraints = [
        ('codigo_faixa_uniq', 'unique(rheven_codigo)', 'O codigo do evento precisa ser unico!'),
    ]
    _defaults = {
        'rheven_processamento': lambda *a: 'V',
        'rheven_venc_desc': lambda *a: 'V',
    }
