# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
# www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class rhfolha_folha_capa(osv.Model):
    """
    Classe folha mensal(Capa)
    Para cada funcionario, para cada mes, haverá um registro nesta classe
    Prefixo: rhfolc
    """
    _name = 'rhfolha.folha.capa'
    _rec_name = 'rhfolc_funcionario_id'
    _columns = {
        'rhfolc_funcionario_id': fields.many2one('rh.funcionario', 'Funcionario', required=True, ondelete='restrict'),
        'write_date': fields.datetime('Ultima alteracao', readonly=True),
        'create_date': fields.datetime('Criado em', readonly=True),
        'create_uid': fields.many2one('res.users', 'Criado por', readonly=True),
        'write_uid': fields.many2one('res.users', 'Alterado por', readonly=True),
        'rhfolc_ano': fields.integer('Ano', required=True),
        'rhfolc_mes': fields.integer('Mes', required=True),
        'rhfolc_base_inss': fields.float('Base INSS', readonly=True),
        'rhfolc_base_fgts': fields.float('Base FGTS', readonly=True),
        'rhfolc_base_irrf': fields.float('Base IRRF', readonly=True),
        'rhfolc_liquido': fields.float('Liquido', readonly=True),
        'rhfolc_item_ids': fields.one2many('rhfolha.folha.itens', 'rhfoli_capa_id', 'Itens'),
    }
    _sql_constraints = [
        ('folha_uniq', 'unique(rhfolc_funcionario_id, rhfolc_ano, rhfolc_mes)', 'Ja foi calculada a folha para este mes!'),
    ]
    _order = 'rhfolc_ano desc,rhfolc_mes desc,rhfolc_funcionario_id'
