# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
# www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class rhfolha_folha_itens(osv.Model):
    """
    Classe folha(itens)
    Prefixo: rhfoli
    """
    _name = 'rhfolha.folha.itens'
    _rec_name = 'rhfoli_evento_id'
    _columns = {
        'rhfoli_capa_id': fields.many2one('rhfolha.folha.capa', 'Capa', required=True,
                                          ondelete='cascade', select=True),
        'rhfoli_evento_id': fields.many2one('rhfolha.eventos', 'Evento', required=True, select=True),
        'rhfoli_evento_codigo': fields.integer('Evento'),
        'rhfoli_referencia': fields.float('Referencia'),
        'rhfoli_vencimento': fields.float('Vencimentos', digits=(9, 2)),
        'rhfoli_desconto': fields.float('Descontos', digits=(9, 2)),
    }
    _order = 'rhfoli_capa_id,rhfoli_evento_codigo'
    _sql_constraints = [
        ('lancamento_uniq', 'unique(rhfoli_capa_id, rhfoli_evento_id)',
         'O evento nao pode ser repetido!'),
    ]



