# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
# www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from SigUtils.numero import getNumeroEditado


# Funcoes da classe rhfol_inss
def _rhinss_get_name(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    if not len(ids):
        return []
    inss_ids = self.search(cr, uid, [], context=context)
    _ant = False
    reads = self.read(cr, uid, inss_ids, ['rhinss_limite'], context=context)
    res = {}
    for record in reads:
        if _ant:
            name = 'De ' + getNumeroEditado(_ant + 0.01) + ' ate ' + getNumeroEditado(
                record.get('rhinss_limite'))
        else:
            name = 'Ate ' + getNumeroEditado(record.get('rhinss_limite'))
        _ant = record.get('rhinss_limite')
        if record.get('id') in ids:
            res[record.get('id')] = name
    return res


# Funcoes da classe rhfol_salario_familia
def _rhsfam_get_name(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    if not len(ids):
        return []
    salario_familia_ids = self.search(cr, uid, [], context=context)
    _ant = False
    reads = self.read(cr, uid, salario_familia_ids, ['rhsfam_limite'], context=context)
    res = {}
    for record in reads:
        if _ant:
            name = 'De ' + getNumeroEditado(_ant + 0.01) + ' ate ' + getNumeroEditado(
                record.get('rhsfam_limite'))
        else:
            name = 'Ate ' + getNumeroEditado(record.get('rhsfam_limite'))
        _ant = record.get('rhsfam_limite')
        if record.get('id') in ids:
            res[record.get('id')] = name
    return res


# Funcoes da classe rhfol_irrf
def _rhirrf_get_name(self, cr, uid, ids, field_name, args, context=None):
    context = context and context.copy() or {}
    if not len(ids):
        return []
    irrf_ids = self.search(cr, uid, [], context=context)
    _ant = False
    reads = self.read(cr, uid, irrf_ids, ['rhirrf_limite'], context=context)
    res = {}
    for record in reads:
        if _ant:
            name = 'De ' + getNumeroEditado(_ant + 0.01) + ' ate ' + getNumeroEditado(
                record.get('rhirrf_limite'))
        else:
            name = 'Ate ' + getNumeroEditado(record.get('rhirrf_limite'))
        _ant = record.get('rhirrf_limite')
        if record.get('id') in ids:
            res[record.get('id')] = name
    return res


# funcao da classe rhfol_lancamentos_capa
def _rhlanc_get_dados_funcionario(self, cr, uid, ids, name, arg, context=None):
    res = {}
    context = context and context.copy() or {}
    if not ids:
        return res
    _lista_func = []
    _rel_func_lanc = {}
    for x in self.browse(cr, uid, ids):
        _lista_func.append(x.rhlanc_funcionario_id.id)
        _rel_func_lanc[x.rhlanc_funcionario_id.id] = x.id
    _funcionario_ids = self.pool.get('rh.funcionario').search(cr, uid, [('id', 'in', _lista_func)], context=context)
    _dados_func = self.pool.get('rh.funcionario').read(cr, uid, _funcionario_ids,
                                                       ['rhfunc_salario', 'rh_dt_admissao',
                                                        'cargo', 'active'], context=context)
    for _dado_func in _dados_func:
        vals = {
            'rhlanc_salario': _dado_func.get('rhfunc_salario'),
            'rhlanc_dt_admissao': _dado_func.get('rh_dt_admissao'),
            'rhlanc_cargo_id': _dado_func.get('cargo'),
            'rhlanc_funcionario_ativo': _dado_func.get('active'),
        }
        res[_rel_func_lanc.get(_dado_func.get('id'))] = vals
    return res
