# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
# www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import _rhinss_get_name


class rhfolha_inss(osv.Model):
    """
    Classe cadastro de inss
    Prefixo: rhfol
    """
    _name = 'rhfolha.inss'
    _rec_name = 'rhinss_name'
    _columns = {
        'rhinss_faixa': fields.integer('Faixa', select=True),
        'rhinss_limite': fields.float('Salario ate', digits=(11, 2), required=True),
        'rhinss_aliquota': fields.float('Aliquota', required=True, digits=(4, 2)),
        'rhinss_name': fields.function(_rhinss_get_name, method=True,
                                      string='Salario de contribuicao', type='char', size=56,
                                      store=False),
    }
    _order = 'rhinss_faixa'
    _sql_constraints = [
        ('codigo_faixa_uniq', 'unique(rhinss_faixa)', 'O numero da faixa precisa ser unico!'),
    ]
