# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
# www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import _rhirrf_get_name


class rhfolha_irrf(osv.Model):
    """
    Classe cadastro de irrf
    Prefixo: rhfol
    """
    _name = 'rhfolha.irrf'
    _rec_name = 'rhirrf_name'
    _columns = {
        'rhirrf_faixa': fields.integer('Faixa', select=True),
        'rhirrf_limite': fields.float('Salario ate', digits=(11, 2), required=True),
        'rhirrf_aliquota': fields.float('Aliquota', required=True, digits=(4, 2)),
        'rhirrf_deducao': fields.float('Parcela a deduzir', digits=(11, 2), required=True),
        'rhirrf_name': fields.function(_rhirrf_get_name, method=True,
                                      string='Salario de contribuicao', type='char', size=56,
                                      store=False),
    }
    _order = 'rhirrf_faixa'
    _sql_constraints = [
        ('codigo_faixa_uniq', 'unique(rhirrf_faixa)', 'O numero da faixa precisa ser unico!'),
    ]

