# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
# www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class rhfolha_lancamentos_capa(osv.Model):
    """
    Classe lancamentos(Capa), esta classe sera usada todo mes para calcular a folha de cada mes
    Prefixo: rhlanc
    """
    _name = 'rhfolha.lancamentos.capa'
    _rec_name = 'rhlanc_funcionario_id'
    from funcoes import _rhlanc_get_dados_funcionario
    _columns = {
        'id': fields.integer('ID'),
        'rhlanc_funcionario_id': fields.many2one('rh.funcionario', 'Funcionario', required=True),
        'write_date': fields.datetime('Ultima alteracao', readonly=True),
        'rhlanc_lancamento_ids': fields.one2many('rhfolha.lancamentos.itens', 'rhlani_capa_id', 'Lancamentos'),
        'rhlanc_salario': fields.function(_rhlanc_get_dados_funcionario, method=True,
                                          string='Salario', multi="dados", type='float',
                                          store=True),
        'rhlanc_dt_admissao': fields.function(_rhlanc_get_dados_funcionario, method=True,
                                          string='Data admissao', multi="dados", type='date',
                                          store=True),
        'rhlanc_cargo_id': fields.function(_rhlanc_get_dados_funcionario, method=True,
                                          string='Cargo', multi="dados", type='many2one',
                                          relation="rh.cargo", store=True),
        'rhlanc_funcionario_ativo': fields.function(_rhlanc_get_dados_funcionario, method=True,
                                          string='Funcionario ativo', multi="dados", type='boolean',
                                          store=False),
}
    _order = 'rhlanc_funcionario_id'
    _sql_constraints = [
        ('funcionario_uniq', 'unique(rhlanc_funcionario_id)', 'O funcionario nao pode ser repetido!'),
    ]


