# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
# www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class rhfolha_lancamentos_itens(osv.Model):
    """
    Classe lancamentos(itens)
    Prefixo: rhlani
    """
    _name = 'rhfolha.lancamentos.itens'
    _rec_name = 'rhlani_evento_id'
    _columns = {
        'rhlani_capa_id': fields.many2one('rhfolha.lancamentos.capa', 'Capa', required=True,
                                          ondelete='cascade'),
        'rhlani_evento_id': fields.many2one('rhfolha.eventos', 'Evento', required=True),
        'rhlani_tipo_evento': fields.selection(
            [('R', 'Referencia'), ('V', 'Vencimento'), ('D', 'Desconto')], 'Tipo evento',
            readonly=True),
        'rhlani_referencia': fields.float('Referencia'),
        'rhlani_vencimento': fields.float('Vencimentos', digits=(9, 2)),
        'rhlani_desconto': fields.float('Descontos', digits=(9, 2)),
    }
    _order = 'rhlani_capa_id,rhlani_evento_id'
    _sql_constraints = [
        ('lancamento_uniq', 'unique(rhlani_capa_id, rhlani_evento_id)',
         'O evento nao pode ser repetido!'),
    ]


