# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
# www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import _rhsfam_get_name


class rhfolha_salario_familia(osv.Model):
    """
    Classe cadastro de salario_familia
    Prefixo: rhfol
    """
    _name = 'rhfolha.salario.familia'
    _rec_name = 'rhsfam_name'
    _columns = {
        'rhsfam_faixa': fields.integer('Faixa', select=True),
        'rhsfam_limite': fields.float('Salario ate', digits=(11, 2), required=True),
        'rhsfam_valor': fields.float('valor', required=True, digits=(11, 2)),
        'rhsfam_name': fields.function(_rhsfam_get_name, method=True,
                                      string='Remuneracao mensal', type='char', size=56,
                                      store=False),
    }
    _order = 'rhsfam_faixa'
    _sql_constraints = [
        ('codigo_faixa_uniq', 'unique(rhsfam_faixa)', 'O numero da faixa precisa ser unico!'),
    ]

