# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2010 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _
from ..comunicacao.sdk import SDK
from ..comunicacao.comandos import GetEvento
from SigUtils.pis import Pis

class wiz_rhhenry_funcionarios(osv.Model):
    # prefixo: wizrhfun

    _name = 'wiz.rhhenry.funcionarios'
    _columns = {
        'wizrhfun_relogio_id': fields.many2one('rhponto.relogios', 'Relogio', required=True, ondelete='cascade'),
        'wizrhfun_linha_ids': fields.one2many('wiz.rhhenry.funcionarios.linhas', 'wizrhfunl_capa_id', 'Linhas'),

    }
    _defaults = {
        'wizrhfun_relogio_id': lambda s, cr, uid, c: s.pool.get('rhponto.relogios').rhprel_getRelogio(cr, uid,
                                                                                                      context=c)
    }

    def wizrhfun_button_importar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = False
        brwDados = self.browse(cr, uid, ids[0], context=context)
        ip = brwDados.wizrhfun_relogio_id.rhprel_ip
        try:
            porta = int(brwDados.wizrhfun_relogio_id.rhprel_porta)
        except:
            raise osv.except_osv(_('Atencao'), _('Porta nao e um valor numerico!'))
        timeout = 1
        linha_ids = self.pool.get('wiz.rhhenry.funcionarios.linhas').search(cr,
                                                                            uid,
                                                                            [('wizrhfunl_capa_id', '=', ids[0])],
                                                                            context=context)
        if linha_ids:
            self.pool.get('wiz.rhhenry.funcionarios.linhas').unlink(cr, uid, linha_ids, context=context)
        with SDK(ip, porta, timeout=timeout) as s:
            s.get_usuarios(qtd_usuarios=1000, indice_usuario=0)
            relogio = GetEvento(s)

        for dado in relogio.data_payload:
            _pis = Pis().verificarTamanho(str(dado.get('pis')))
            if _pis:
                funcionario_ids = self.pool.get('rh.funcionario').search(cr,
                                                                         uid,
                                                                         [('rhfunc_pis', '=', _pis)],
                                                                         context=context)
            else:
                funcionario_ids = []
            if funcionario_ids:
                funcionario_id = funcionario_ids[0]
            else:
                funcionario_id = False
            vals = {
                'wizrhfunl_capa_id': ids[0],
                'wizrhfunl_funcionario_id': funcionario_id,
                'wizrhfunl_referencia': dado.get('pis'),
                'wizrhfunl_cartao': dado.get('cartoes'),
                'wizrhfunl_nome': dado.get('nome'),
            }
            self.pool.get('wiz.rhhenry.funcionarios.linhas').create(cr, uid, vals, context)
        for funcionario_id in self.pool.get('rh.funcionario').search(cr, uid, [], context=context):
            args = [('wizrhfunl_capa_id', '=', ids[0]),
                    ('wizrhfunl_funcionario_id', '=', funcionario_id)]
            if self.pool.get('wiz.rhhenry.funcionarios.linhas').search(cr, uid, args, context=context):
                continue
            vals = {
                'wizrhfunl_capa_id': ids[0],
                'wizrhfunl_funcionario_id': funcionario_id,
            }
            self.pool.get('wiz.rhhenry.funcionarios.linhas').create(cr, uid, vals, context)
        return res


class wiz_rhhenry_funcionarios_linhas(osv.Model):
    # prefixo: wizrhfunl

    _name = 'wiz.rhhenry.funcionarios.linhas'
    _columns = {
        'wizrhfunl_capa_id': fields.many2one('wiz.rhhenry.funcionarios', 'Capa', required=True, ondelete='cascade'),
        'wizrhfunl_funcionario_id': fields.many2one('rh.funcionario','Funcionario', ondelete='cascade'),
        'wizrhfunl_referencia': fields.char('PIS', size=15),
        'wizrhfunl_cartao': fields.char('Cartoes', sise=10),
        'wizrhfunl_nome': fields.char('Nome', size=50),
        'wizrhfunl_associar': fields.boolean('Associar'),
    }
    _defaults = {
        'wizrhfunl_associar': False,
    }

    def wizrhfunl_btn_func_excluir(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        brwDados = self.browse(cr, uid, ids[0], context=context)
        ip = brwDados.wizrhfunl_capa_id.wizrhfun_relogio_id.rhprel_ip
        try:
            porta = int(brwDados.wizrhfunl_capa_id.wizrhfun_relogio_id.rhprel_porta)
        except:
            raise osv.except_osv(_('Atencao'), _('Porta nao e um valor numerico!'))
        timeout = 1
        with SDK(ip, porta, timeout=timeout) as s:
            s.set_usuarios(operacao='E',
                           nome=brwDados.wizrhfunl_nome,
                           pis=brwDados.wizrhfunl_referencia,
                           cartao=brwDados.wizrhfunl_cartao)
            if not s.status:
                raise osv.except_osv(_('Atencao'), s.erro)
            relogio = GetEvento(s)
            if relogio.status == 3: # Erro
                raise osv.except_osv(_('Atencao'), relogio.erro)
            vals = {
                'wizrhfunl_referencia': None,
                'wizrhfunl_cartao': None,
                'wizrhfunl_nome': None,
            }
            self.pool.get('wiz.rhhenry.funcionarios.linhas').write(cr, uid, ids[0], vals, context)
            return True

    def wizrhfunl_btn_func_incluir(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        brwDados = self.browse(cr, uid, ids[0], context=context)
        ip = brwDados.wizrhfunl_capa_id.wizrhfun_relogio_id.rhprel_ip
        try:
            porta = int(brwDados.wizrhfunl_capa_id.wizrhfun_relogio_id.rhprel_porta)
        except:
            raise osv.except_osv(_('Atencao'), _('Porta nao e um valor numerico!'))
        timeout = 1
        with SDK(ip, porta, timeout=timeout) as s:
            s.set_usuarios(operacao='I',
                           nome=brwDados.wizrhfunl_funcionario_id.name[:20],
                           pis=brwDados.wizrhfunl_funcionario_id.rhfunc_pis,
                           cartao=brwDados.wizrhfunl_funcionario_id.pessoa.codigo)
            if not s.status:
                raise osv.except_osv(_('Atencao'), s.erro)
            relogio = GetEvento(s)
            if relogio.status == 3:  # Erro
                raise osv.except_osv(_('Atencao'), relogio.erro)
            vals = {
                'wizrhfunl_funcionario_id': brwDados.wizrhfunl_funcionario_id.id,
                'wizrhfunl_referencia': brwDados.wizrhfunl_funcionario_id.rhfunc_pis,
                'wizrhfunl_cartao': brwDados.wizrhfunl_funcionario_id.pessoa.codigo,
                'wizrhfunl_nome': brwDados.wizrhfunl_funcionario_id.name[:20],
            }
            self.pool.get('wiz.rhhenry.funcionarios.linhas').write(cr, uid, ids[0], vals, context)

        return True

