# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2010 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _
from ..comunicacao.sdk import SDK
from ..comunicacao.comandos import GetEvento
from datetime import datetime


class wiz_rhhenry_horario(osv.Model):
    # prefixo: wizrhhor

    _name = 'wiz.rhhenry.horario'
    _columns = {
        'wizrhhor_relogio_id': fields.many2one('rhponto.relogios', 'Relogio', required=True, ondelete='cascade'),
        'wizrhhor_data_hora': fields.datetime('Data/Hora relogio'),
        'wizrhhor_horario_verao': fields.boolean('Horario de verao-Usar'),
        'wizrhhor_horario_verao_inicio': fields.date('Horario de verao-Inicio'),
        'wizrhhor_horario_verao_final': fields.date('Horario de verao-Final'),

    }
    _defaults = {
        'wizrhhor_horario_verao': False,
        'wizrhhor_relogio_id': lambda s, cr, uid, c: s.pool.get('rhponto.relogios').rhprel_getRelogio(cr, uid, context=c)
    }

    def wizrhfun_button_buscar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = False
        brwDados = self.browse(cr, uid, ids[0], context=context)
        ip = brwDados.wizrhhor_relogio_id.rhprel_ip
        try:
            porta = int(brwDados.wizrhhor_relogio_id.rhprel_porta)
        except:
            raise osv.except_osv(_('Atencao'), _('Porta nao e um valor numerico!'))
        timeout = 1
        with SDK(ip, porta, timeout=timeout) as s:
            s.get_horario()
            relogio = GetEvento(s)

        data_hora = relogio.data_payload.get('data_hora')
        data_inicio = relogio.data_payload.get('data_inicio_hor_verao')
        data_fim = relogio.data_payload.get('data_fim_hor_verao')
        data_hora = data_hora[:6] + '20' + data_hora[6:]
        if data_inicio == '00/00/00':
            usar = False
            data_inicio = data_fim = None
        else:
            usar = True
            data_inicio = data_inicio[:6] + '20' + data_inicio[6:]
            data_fim = data_fim[:6] + '20' + data_fim[6:]
        self.write(cr, uid, ids, {
            'wizrhhor_data_hora': data_hora,
            'wizrhhor_horario_verao': usar,
            'wizrhhor_horario_verao_inicio': data_inicio,
            'wizrhhor_horario_verao_final': data_fim,
        }, context=context)

        return res

    def wizrhfun_button_enviar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = False
        brwDados = self.browse(cr, uid, ids[0], context=context)
        ip = brwDados.wizrhhor_relogio_id.rhprel_ip
        try:
            porta = int(brwDados.wizrhhor_relogio_id.rhprel_porta)
        except:
            raise osv.except_osv(_('Atencao'), _('Porta nao e um valor numerico!'))
        timeout = 1
        with SDK(ip, porta, timeout=timeout) as s:
            ultimo_acesso = datetime.now()
            s.set_horario(timestamp=ultimo_acesso)
            relogio = GetEvento(s)

        return res
