# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
# www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from datetime import datetime
from ..comunicacao.sdk import SDK
from ..comunicacao.comandos import GetEvento



class rhhenry_testar_comunicacao(osv.TransientModel):
    _name = 'rhhenry.testar.comunicacao'
    _columns = {
        'resposta': fields.text('Resposta'),
    }
    @staticmethod
    def getParametros():
        ip = "192.168.1.21"
        porta = 3000
        timeout = 1
        return ip, porta, timeout

    def button_processar(self, cr, uid, ids, context=None):
        ip, porta, timeout = self.getParametros()
        print('iniciando')
        iniciar = True
        with SDK(ip, porta, timeout=timeout) as s:
            resposta = ''
            resp, command = s.get_horario()
            print(resp, command)
            comanda = GetEvento(s)
            resposta = "Get->Comando:%s\nIndex:%s\nData:%s\nPayload:%s\n" % \
                             (comanda.comando, comanda.index, comanda.data, comanda.data_payload)

            ultimo_acesso = datetime.now()
            resp, command = s.set_horario(timestamp=ultimo_acesso)
            print(resp, command)
            comanda = GetEvento(s)
            resposta +='\n\n'+ "Set->Comando:%s\nIndex:%s\nData:%s\nPayload:%s\n" % \
                             (comanda.comando, comanda.index, comanda.data, comanda.data_payload)

            vals = {'resposta': resposta}
            self.write(cr, uid, ids, vals, context=context)
        return True

    def button_ler_usuario(self, cr, uid, ids, context=None):
        ip, porta, timeout = self.getParametros()
        print('iniciando')
        iniciar = True
        with SDK(ip, porta, timeout=timeout) as s:

            resp, command = s.get_usuarios(qtd_usuarios=10, indice_usuario=0)
            print(resp, command)
            comanda = GetEvento(s)
            resposta ="Usu->Comando:%s\nIndex:%s\nData:%s\nPayload:%s\n" % \
                             (comanda.comando, comanda.index, comanda.data, comanda.data_payload)

            vals = {'resposta': resposta}
            self.write(cr, uid, ids, vals, context=context)
        return True

    def button_ler_evento(self, cr, uid, ids, context=None):
        ip, porta, timeout = self.getParametros()
        print('iniciando')
        iniciar = True
        with SDK(ip, porta, timeout=timeout) as s:

            resp, command = s.get_eventos(operacao='N', qtd_eventos=500, indice_evento=6300)
            print(resp, command)
            comanda = GetEvento(s)
            resposta ="Usu->Comando:%s\nIndex:%s\nData:%s\nPayload:%s\n" % \
                             (comanda.comando, comanda.index, comanda.data, comanda.data_payload)

            vals = {'resposta': resposta}
            self.write(cr, uid, ids, vals, context=context)
        return True
