# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from openerp.osv import fields, osv

from openerp import tools


class rhponto_marcacao_dia(osv.Model):

    _name = 'rhponto.marcacao.dia'
    _inherit = 'rhponto.marcacao.dia'
    def init(self, cr):
        tools.sql.drop_view_if_exists(cr, "rhponto_marcacao_dia")
        cr.execute("""
              create view rhponto_marcacao_dia as (
                select
                    min(P.id) as id,
                    P.rhpmar_funcionario_id as rhpmad_funcionario_id,
                    P.rhpmar_data as rhpmad_data,
                    (select P1.rhpmar_horario from rhponto_marcacao P1 where P1.rhpmar_data=P.rhpmar_data and P1.rhpmar_funcionario_id=P.rhpmar_funcionario_id order by rhpmar_horario limit 1 offset 0) as rhpmad_entrada1,
                    (select P2.rhpmar_horario from rhponto_marcacao P2 where P2.rhpmar_data=P.rhpmar_data and P2.rhpmar_funcionario_id=P.rhpmar_funcionario_id order by rhpmar_horario limit 1 offset 1) as rhpmad_saida1,
                    (select P3.rhpmar_horario from rhponto_marcacao P3 where P3.rhpmar_data=P.rhpmar_data and P3.rhpmar_funcionario_id=P.rhpmar_funcionario_id order by rhpmar_horario limit 1 offset 2) as rhpmad_entrada2,
                    (select P4.rhpmar_horario from rhponto_marcacao P4 where P4.rhpmar_data=P.rhpmar_data and P4.rhpmar_funcionario_id=P.rhpmar_funcionario_id order by rhpmar_horario limit 1 offset 3) as rhpmad_saida2,
                    (select P5.rhpmar_horario from rhponto_marcacao P5 where P5.rhpmar_data=P.rhpmar_data and P5.rhpmar_funcionario_id=P.rhpmar_funcionario_id order by rhpmar_horario limit 1 offset 4) as rhpmad_entrada3,
                    (select P6.rhpmar_horario from rhponto_marcacao P6 where P6.rhpmar_data=P.rhpmar_data and P6.rhpmar_funcionario_id=P.rhpmar_funcionario_id order by rhpmar_horario limit 1 offset 5) as rhpmad_saida3,
                    (select P7.rhpmar_horario from rhponto_marcacao P7 where P7.rhpmar_data=P.rhpmar_data and P7.rhpmar_funcionario_id=P.rhpmar_funcionario_id order by rhpmar_horario limit 1 offset 6) as rhpmad_entrada4,
                    (select P8.rhpmar_horario from rhponto_marcacao P8 where P8.rhpmar_data=P.rhpmar_data and P8.rhpmar_funcionario_id=P.rhpmar_funcionario_id order by rhpmar_horario limit 1 offset 7) as rhpmad_saida4,
                    (select P9.rhpmar_horario from rhponto_marcacao P9 where P9.rhpmar_data=P.rhpmar_data and P9.rhpmar_funcionario_id=P.rhpmar_funcionario_id order by rhpmar_horario limit 1 offset 8) as rhpmad_entrada5,
                    (select P10.rhpmar_horario from rhponto_marcacao P10 where P10.rhpmar_data=P.rhpmar_data and P10.rhpmar_funcionario_id=P.rhpmar_funcionario_id order by rhpmar_horario limit 1 offset 9) as rhpmad_saida5
                from rhponto_marcacao P
                    group by rhpmad_funcionario_id, rhpmad_data)
                """)



