# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields

class rhponto_afastamento(osv.Model):
    """
    Prefixo: rhpafa_
    """

    _name = 'rhponto.afastamento'
    _rec_name = 'rhpafa_funcionario_id'
    _columns = {
        'rhpafa_codigo' : fields.integer('Codigo', select=True),
        'rhpafa_funcionario_id' : fields.many2one('rh.funcionario', 'Funcionario', ondelete='restrict', required=True, select=True),
        'rhpafa_justificativa_id' : fields.many2one('rhponto.justificativa', 'Justificativa', ondelete='restrict', required=True, select=True),
        'rhpafa_data_ini' : fields.date('Data Inicial', required=True),
        'rhpafa_data_fim' : fields.date('Data Final', required=True),
        'rhpafa_tipo' : fields.selection([('P', 'Periodo'), ('T', 'Tempo')], 'Tipo', size=1),
        'rhpafa_minutos' : fields.integer('Minutos'),
    }
    _order = 'rhpafa_funcionario_id, rhpafa_data_ini desc'
    _defaults = {
        'rhpafa_codigo' : lambda *a: 0,
    }

