# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from SigUtils.formatastring import formataString

#Funcoes da classe rhponto_banco_horas
def _get_name(self, cr, uid, ids, name, arg, context=None):
    """
    Retorna o descricao do banco_horas
    """
    context = context and context.copy() or {}
    res = {}
    if ids:
        banco_horas_datas = self.browse(cr, uid, ids)
        for banco_horas_data in banco_horas_datas:
            _func_lista =  banco_horas_data.rhpbch_funcionario_id.pessoa.name.split()
            if len(_func_lista)  > 1:
                _func_nome =  _func_lista[0] + ' ' + _func_lista[len(_func_lista) -1]
            else:
                _func_nome = _func_lista[0]
            res[banco_horas_data.id] =  _func_nome + '-' +str( banco_horas_data.rhpbch_data) + ' ' + str(banco_horas_data.rhpbch_qtd_hora)
    return res

#Funcoes da classe rhponto_marcacao
def _get_name_marcacao(self, cr, uid, ids, name, arg, context=None):
    """
    Retorna o descricao do marcacao
    """
    context = context and context.copy() or {}
    res = {}
    if ids:
        for marcacao_data in self.browse(cr, uid, ids):
            _func_lista =  marcacao_data.rhpmar_funcionario_id.pessoa.name.split()
            if len(_func_lista)  > 1:
                _func_nome =  _func_lista[0] + ' ' + _func_lista[len(_func_lista) -1]
            else:
                _func_nome = _func_lista[0]
            res[marcacao_data.id] =  _func_nome + '-' +str(marcacao_data.rhpmar_data) + ' ' + str(marcacao_data.rhpmar_horario)
    return res

#Funcoes da classe rhponto_marcacao_dia
def _get_tempo(self, cr, uid, ids, name, arg, context=None):
    """
    Retorna o tempo trabalhado
    """
    context = context and context.copy() or {}
    res = {}.fromkeys(ids, 0)
    if ids:
        marcacao_dia_datas = self.browse(cr, uid, ids)
        for marcacao_dia_data in marcacao_dia_datas:
            rhpmad_entrada1 = marcacao_dia_data['rhpmad_entrada1']
            rhpmad_entrada2 = marcacao_dia_data['rhpmad_entrada2']
            rhpmad_entrada3 = marcacao_dia_data['rhpmad_entrada3']
            rhpmad_entrada4 = marcacao_dia_data['rhpmad_entrada4']
            rhpmad_entrada5 = marcacao_dia_data['rhpmad_entrada5']
            rhpmad_saida1 = marcacao_dia_data['rhpmad_saida1']
            rhpmad_saida2 = marcacao_dia_data['rhpmad_saida2']
            rhpmad_saida3 = marcacao_dia_data['rhpmad_saida3']
            rhpmad_saida4 = marcacao_dia_data['rhpmad_saida4']
            rhpmad_saida5 = marcacao_dia_data['rhpmad_saida5']
            if ((rhpmad_entrada1 and not rhpmad_saida1) or
                (rhpmad_entrada2 and not rhpmad_saida2) or
                (rhpmad_entrada3 and not rhpmad_saida3) or
                (rhpmad_entrada4 and not rhpmad_saida4) or
                (rhpmad_entrada5 and not rhpmad_saida5)):
                res[marcacao_dia_data.id] =  9999999
                continue
            _tempo = 0
            # if rhpmad_entrada1 and rhpmad_saida1:
            #     _tempo += (int(rhpmad_saida1) * 60 + (rhpmad_saida1 - int(rhpmad_saida1))) - (int(rhpmad_entrada1) * 60 + (rhpmad_entrada1 - int(rhpmad_entrada1)))
            # if rhpmad_entrada2 and rhpmad_saida2:
            #     _tempo += (int(rhpmad_saida2) * 60 + (rhpmad_saida2 - int(rhpmad_saida2))) - (int(rhpmad_entrada2) * 60 + (rhpmad_entrada2 - int(rhpmad_entrada2)))
            # if rhpmad_entrada3 and rhpmad_saida3:
            #     _tempo += (int(rhpmad_saida3) * 60 + (rhpmad_saida3 - int(rhpmad_saida3))) - (int(rhpmad_entrada3) * 60 + (rhpmad_entrada3 - int(rhpmad_entrada3)))
            # if rhpmad_entrada4 and rhpmad_saida4:
            #     _tempo += (int(rhpmad_saida4) * 60 + (rhpmad_saida4 - int(rhpmad_saida4))) - (int(rhpmad_entrada4) * 60 + (rhpmad_entrada4 - int(rhpmad_entrada4)))
            # if rhpmad_entrada5 and rhpmad_saida5:
            #     _tempo += (int(rhpmad_saida5) * 60 + (rhpmad_saida5 - int(rhpmad_saida5))) - (int(rhpmad_entrada5) * 60 + (rhpmad_entrada5 - int(rhpmad_entrada5)))
            if rhpmad_entrada1 and rhpmad_saida1:
                _tempo += rhpmad_saida1 - rhpmad_entrada1
            if rhpmad_entrada2 and rhpmad_saida2:
                _tempo += rhpmad_saida2 - rhpmad_entrada2
            if rhpmad_entrada3 and rhpmad_saida3:
                _tempo += rhpmad_saida3 - rhpmad_entrada3
            if rhpmad_entrada4 and rhpmad_saida4:
                _tempo += rhpmad_saida4 - rhpmad_entrada4
            if rhpmad_entrada5 and rhpmad_saida5:
                _tempo += rhpmad_saida5 - rhpmad_entrada5
            res[marcacao_dia_data.id] =  _tempo
    return res

#Funcoes da classe rhponto_periodo
def _get_name_periodo(self, cr, uid, ids, name, arg, context=None):
    """
    Retorna o descricao do periodo
    """
    context = context and context.copy() or {}
    res = {}
    if ids:
        for periodo_data in self.read(cr, uid, ids, ['rhpper_hora_entrada', 'rhpper_hora_saida'], context=context):
            horas_entrada = int(periodo_data['rhpper_hora_entrada'])
            minutos_entrada = periodo_data['rhpper_hora_entrada'] - horas_entrada
            horas_saida = int(periodo_data['rhpper_hora_saida'])
            minutos_saida = periodo_data['rhpper_hora_saida'] - horas_saida
            res[periodo_data['id']] = 'De: ' + formataString(int(round(horas_entrada,0)),2,'0','E','N','S') + ':' + formataString(int(round((minutos_entrada*60),0)),2,'0','E','N','S')\
                                      + ' a ' + formataString(int(round(horas_saida,0)),2,'0','E','N','S')  + ':' + formataString(int(round((minutos_saida*60),0)),2,'0','E','N','S')
    return res
