# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields

class rhponto_marcacao(osv.Model):

    from funcoes import _get_name_marcacao
    """
    Prefixo rhpmar_"""
    _name = 'rhponto.marcacao'
    _columns = {
        'name': fields.function(_get_name_marcacao, method=True, string='Descricao', type='text',
                                store=False),
        'rhpmar_codigo': fields.integer('Codigo', select=True),
        'rhpmar_funcionario_id': fields.many2one('rh.funcionario', 'Funcionario', ondelete='restrict',
                                             required=True, select=True),
        'rhpmar_data': fields.date('Data', required=True, select=True),
        'rhpmar_horario': fields.float('Hora', required=True),
        'rhpmar_tipo': fields.selection([('A', 'Automatico'),('M', 'Manual')], 'Tipo', size=1, required=True),
    }
    _order = 'rhpmar_funcionario_id, rhpmar_data desc, rhpmar_horario'
    _defaults = {
        'rhpmar_codigo': lambda *a: 0,
        'rhpmar_tipo': 'M',
    }


