# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2010 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################


from openerp.osv import fields, osv
from SigUtils import datas
from mx import DateTime


class banco_horas_atualizar_osv(osv.TransientModel):
    _name = "banco_horas.atualizar.osv"
    _description = "Wizard para importacao de marcacoes de ponto"
    _columns = {
         'data_inicial' : fields.date('Data Inicial', required=True),
         'data_final' : fields.date('Data Final', required=True),
    }

    def atualizar(self, cr, uid, ids, context=None):
        """

        """
        context = context and context.copy() or {}
        _registros = self.browse(cr, uid, ids)
        for _registro in _registros:
            _data = _registro['data_inicial']
            _data_final = _registro['data_final']
        _data_final = datas.sigDatas(_data_final).getDataNoFormato('I', 'S', separador='-')
        _data = datas.sigDatas(_data).getDataNoFormato('I', 'S', separador='-')
        obj_banco = self.pool.get('rhponto.banco.horas')
        _banco_ids = obj_banco.search(cr, uid, ['&', ('rhpbch_data', '>=', _data), ('rhpbch_tipo', '=', 'A')], context=context)
        obj_banco.unlink(cr, uid, _banco_ids)
        obj_funcionario =  self.pool.get('rh.funcionario')
        obj_periodo =  self.pool.get('rhponto.periodo')
        obj_jornada =  self.pool.get('rhponto.jornada')
        obj_marcacao =  self.pool.get('rhponto.marcacao')
        obj_adm_calendario_feriados =  self.pool.get('adm.calendario.feriados')
        obj_afastamento =  self.pool.get('rhponto.afastamento')
        obj_justificativa =  self.pool.get('rhponto.justificativa')
        _funcionario_ids = obj_funcionario.search(cr, uid, [('active', '=', True)], context=context)
        while _data < _data_final: #Variando a data de hoje -30 ate hoje
            _feriado_ids = obj_adm_calendario_feriados.search(cr, uid, [('admcfe_data', '=', _data)], context=context)
            _Data = datas.sigDatas(_data)
            _dia_da_semana = _Data.dia3DaSemana.lower()
            for _funcionario_id in _funcionario_ids: # Calcular para cada funcionario
                _afastamento_ids = obj_afastamento.search(cr, uid, ['&', ('rhpafa_funcionario_id', '=', _funcionario_id), ('rhpafa_data_ini', '<=', _data), ('rhpafa_data_fim', '>=', _data) ], context=context)
                _afastamento_dados = obj_afastamento.read(cr, uid, _afastamento_ids, ['rhpafa_justificativa_id', 'rhpafa_tipo', 'rhpafa_minutos'], context=context)
                if _afastamento_dados:
                    _afastamento_dados = _afastamento_dados[0] #apenas um afastamento por dia
                    _justificativa_dados = obj_justificativa.read(cr, uid, _afastamento_dados['rhpafa_justificativa_id'][0], ['rhpjus_tipo'], context=context)
                    if _justificativa_dados['rhpjus_tipo'] == 'C':
                        _afastamento_dados = False
                _jornada_ids = obj_jornada.search(cr, uid, [('rhpjor_funcionario_id', '=', _funcionario_id)], context=context, order = 'rhpjor_data desc')
                _jornada_dados = obj_jornada.read(cr, uid, _jornada_ids, ['rhpjor_data',
                                                                          'rhpjor_dom',
                                                                          'rhpjor_seg',
                                                                          'rhpjor_ter',
                                                                          'rhpjor_qua',
                                                                          'rhpjor_qui',
                                                                          'rhpjor_sex',
                                                                          'rhpjor_sab'], context=context)
                if not _jornada_dados: #Se o funcionario nao tiver jornada cadastrada passar para o proximo
                    continue
                for _jornada_registro in _jornada_dados:
                   if _jornada_registro['rhpjor_data'] > _data: # a jornada nao interessa porque e superior a data a ser processada
                       continue
                   lista_horarios = [] # lista de horarios de entrada e saida do dia avaliado
                   _expediente = _jornada_registro['rh_'+_dia_da_semana]
                   if _expediente:
                       _expediente_id = _expediente[0]
                       periodo_ids = obj_periodo.search(cr, uid, [('rhpper_expediente_id', '=', _expediente_id)], context=context, order = 'rhpper_hora_entrada')
                       if periodo_ids: #Periodos de trabalho do funcionario no dia da semana
                           periodo_dados = obj_periodo.read(cr, uid, periodo_ids, ['rhpper_hora_entrada', 'rhpper_hora_saida'], context=context)
                           for periodo_registro in periodo_dados:
                               lista_horarios.append(periodo_registro['rhpper_hora_entrada'])
                               lista_horarios.append(periodo_registro['rhpper_hora_saida'])
                   args = [ '&', ('rhpmar_funcionario_id', '=', _funcionario_id), ('rhpmar_data', '=', _data)]
                   marcacao_ids = obj_marcacao.search(cr, uid, args, order = 'rhpmar_horario', context=context)
                   marcacao_dados = obj_marcacao.read(cr, uid, marcacao_ids, ['rhpmar_horario'], context=context)
                   marcacao_horas = []
                   if marcacao_dados:
                       for marcacao_registro in marcacao_dados:
                           marcacao_horas.append(marcacao_registro['rhponto_marcacao'])
                   if _feriado_ids and not marcacao_horas: # O dia e feriado e o funcionario nao trabalhou
                       break # terminar laco de jornada e continuar o de funcionario
                   if not lista_horarios and not marcacao_horas: #Nao tendo horarios a trabalhar nem horario trabalhados, nao interessa este dia
                       break # terminar laco de jornada e continuar o de funcionario
                   minutos_a_trabalhar = 0
                   minutos_trabalhados = 0
                   i = 'entrada'
                   for x in lista_horarios:
                       x = x * 3600
                       if i == 'entrada':
                           minutos_a_trabalhar -= DateTime.TimeFrom(x).minutes
                           i =  'saida'
                       else:
                           minutos_a_trabalhar += DateTime.TimeFrom(x).minutes
                           i =  'entrada'
                   i = 'entrada'
                   for x in marcacao_horas:
                       x = x * 3600
                       if i == 'entrada':
                           minutos_trabalhados -= DateTime.TimeFrom(x).minutes
                           i =  'saida'
                       else:
                           minutos_trabalhados += DateTime.TimeFrom(x).minutes
                           i =  'entrada'
                   if i == 'saida': #Marcacao está incompleta, desconsiderar. Proximo funcionario
                       break      # terminar laco de jornada e continuar o de funcionario
                   if _afastamento_dados: #tem afastamento
                       if _afastamento_dados['rhpafa_tipo'] == 'P':
                           minutos_trabalhados += minutos_a_trabalhar # afastamento por periodo acrescentar o total de minutos do dia
                       else:
                           minutos_trabalhados += _afastamento_dados['rhpafa_minutos']
                   _banco_dia = minutos_trabalhados - minutos_a_trabalhar
                   vals = {
                           'rhpbch_funcionario_id' : _funcionario_id,
                           'rhpbch_data' : _data,
                           'rhpbch_tipo' : 'A',
                           'rhpbch_qtd_hora' : _banco_dia,
                           }
                   if _banco_dia < 0:
                       _horas_positivo = _banco_dia * -1
                   else:
                       _horas_positivo = _banco_dia
                   if _horas_positivo > 10:
                       if _banco_dia > 0:
                           _saldo_horas = obj_banco.saldo_horas(cr, uid, _data, _funcionario_id)
                           _saldo_final = _saldo_horas + _banco_dia
                           if  _saldo_horas >= 0:
                               vals['rhpbch_historico'] = 'Horas Extras'
                               banco_hora_id = obj_banco.create(cr, uid, vals, context)
                           elif _saldo_final >= 0:
                               vals['rhpbch_qtd_hora'] = _banco_dia - _saldo_final
                               vals['rhpbch_historico'] = 'Compensacao de Horas'
                               _banco_dia = _saldo_final
                               banco_hora_id = obj_banco.create(cr, uid, vals, context)
                               if _banco_dia > 0:
                                   vals['rhpbch_qtd_hora'] = _banco_dia
                                   vals['rhpbch_historico'] = 'Horas Extras'
                                   banco_hora_id = obj_banco.create(cr, uid, vals, context)
                           else:
                               vals['rhpbch_historico'] = 'Compensacao de Horas'
                               banco_hora_id = obj_banco.create(cr, uid, vals, context)
                           if _saldo_final > 0:
                               _valor = int(_banco_dia * 25 / 100)
                               if _valor > 0:
                                   vals['rhpbch_historico'] = 'Acrescimo de 25%'
                                   vals['rhpbch_qtd_hora'] = _valor
                                   banco_hora_id = obj_banco.create(cr, uid, vals, context)
                       else:
                           vals['rhpbch_historico'] = 'Faltas'
                           banco_hora_id = obj_banco.create(cr, uid, vals, context)
                   break # Encerrar jornada, voltar para novo funcionario
            _data = datas.sigDatas(_data).getCalculaPrazo(1)
            _data = datas.sigDatas(_data).getDataNoFormato('I', 'S', separador='-')




        return {'type': 'ir.actions.act_window_close'}

banco_horas_atualizar_osv()
