# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class software_origem(osv.Model):
    _name = 'software.origem'
    _inherit = 'software.origem'

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not len(ids):
            return []
        reads = self.browse(cr, uid, ids, context=context)
        res = []
        for record in reads:
            res.append((record['id'], record.name))
        return res

    def name_search(self, cr, uid, name='', args=[], operator='ilike', context=None, limit=100):
        context = context and context.copy() or {}
        ids = self.search(cr, uid, [('sigla', operator, name.upper())] + args, limit=limit, context=context)
        if not ids:
            ids = self.search(cr, uid, [('name', operator, name)] + args, limit=limit, context=context)
        return self.name_get(cr, uid, ids)

    def create(self, cr, user, vals, context=None):
        context = context and context.copy() or {}
        if 'sigla' in vals:
            if vals['sigla']:
                vals['sigla'] = vals['sigla'].upper()
        res = super(software_origem, self).create(cr, user, vals, context)
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if 'sigla' in vals:
            if vals['sigla']:
                vals['sigla'] = vals['sigla'].upper()
        res = super(software_origem, self).write(cr, uid, ids, vals, context=context)
        return res

