# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp import netsvc

LOGGER = netsvc.Logger()


class orcamentos_orcamento_capa(osv.Model):
    _name = 'orcamentos.orcamento.capa'
    _inherit = 'orcamentos.orcamento.capa'

    def _get_vlr_desl(self, cr, uid, ids, field_name, arg, context):
        res = {}
        o_transport = self.pool.get('software.transporte')
        o_par = self.pool.get('software.parametros')
        for id in ids:
            vals_orc = self.read(cr, uid, id, ['km', 'transporte_id'], context)
            km, km_por_hora, horas_adicionais, valor_da_hora = vals_orc['km'], 0.00, 0.00, 0.00
            if vals_orc['transporte_id']:
                vals_transporte = o_transport.read(cr, uid, vals_orc['transporte_id'][0],
                                                   ['km_por_hora', 'horas_adicionais'])
                km_por_hora, horas_adicionais = vals_transporte['km_por_hora'], vals_transporte['horas_adicionais']
            par_id = o_par.search(cr, uid, [], context=context)
            if par_id:
                valor_da_hora = o_par.read(cr, uid, par_id[0], ['valor_da_hora'])['valor_da_hora']
            try:
                vlr = (km / km_por_hora + horas_adicionais) * valor_da_hora
            except ZeroDivisionError:
                #LOGGER.notifyChannel("Orcamento ID %d"%id, netsvc.LOG_ERROR, "ZeroDivisionError")
                vlr = 0
            res[id] = vlr
        return res

    _columns = {
        'pesquisador_id': fields.many2one("software.pesquisador", 'Pesquisador', ondelete="restrict", select=True),
        'central_oportunidade_id': fields.many2one("software.central.oportunidade", 'Central oportunidade',
                                                   ondelete="restrict", select=True),
        'origem_id': fields.many2one("software.origem", 'Origem', ondelete="restrict", select=True),
        'coligadas': fields.integer('Coligadas'), # Quantidade de empresas coligadas
        'filiais': fields.integer('Filiais'), # Quantidade de filiais
        'servidores': fields.integer('Servidores'), # quantidade de servidores
        'usuarios': fields.integer('Usuarios'), # Quantidade de usuários
        'indicacao_de_id': fields.many2one("adm.pessoa", 'Indicacao de', ondelete="restrict", select=True),
        'contato_id': fields.many2one("adm.pessoa", 'Contato id', ondelete="restrict", select=True),
        'proprietario_id': fields.many2one("adm.pessoa", 'Proprietario', ondelete="restrict", select=True),
        'seguimento_id': fields.many2one("software.seguimento", 'Seguimento', ondelete="restrict", required=False,
                                         select=True),
        'pontos_de_venda': fields.integer('Pontos de venda'), # Quantidade de pontos de venda
        'descolamento': fields.boolean('Descolamento'), # Descolamento
        'km': fields.integer('Km'), # Km
        'valor_deslocamento': fields.function(_get_vlr_desl, type='float', digits=(9, 2), method=True, store=True,
                                              string='Valor do deslocamento'),
        'transporte_id': fields.many2one("software.transporte", 'Transporte', ondelete="restrict"),
        'numero_visitas': fields.integer('Numero de visitas'),
        'dia_vencimento': fields.integer('Dia Vencimento'), # Dia Vencimento
        'orcamento_tipo_software': fields.boolean('Orcamento e de Software?')
        # Informa se o orcamento e de Software ou Normal
    }
