# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class software_parametros(osv.Model):
    """
    Tabela de parametros do modulo software
    """
    _name = 'software.parametros'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'percentual_sms': fields.float('Percentual sms', digits=(4, 1), required=True),
        'taxa_juros_sms': fields.float('Taxa de juros sms', digits=(4, 2), required=False), # Taxa de juros
        'multa_atraso': fields.float('Multa atraso', digits=(4, 2), required=False), # Multa atraso
        'local_id': fields.many2one("estoque.local", 'Local', ondelete="restrict", required=True, select=True),
        'numero_visitas': fields.integer('Numero de visitas', required=True),
        'valor_da_hora': fields.float('Valor da hora', digits=(9, 2), required=True,
                                      help="Valor da hora em deslocamento"),
    }
    _sql_constraints = [
        ('empresa_uniq', 'unique (company_id)', 'Empresa precisa ser unica!'),
    ]
    _defaults = {
        'numero_visitas': lambda *a: 9,
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }    

