# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class software_pesquisador(osv.Model):
    """
    Tabela de pesquisadores
    """
    _name = 'software.pesquisador'
    _rec_name = 'funcionario_id'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'funcionario_id': fields.many2one("rh.funcionario", 'Funcionario', ondelete="restrict", required=True,
                                          select=True), # id do funcionario
        'orcamentos_orcamento_capa_ids': fields.one2many('orcamentos.orcamento.capa', 'pesquisador_id', 'Capa'),
    }
    _sql_constraints = [
        ('pesquisador_uniq', 'unique (company_id, funcionario_id)', 'Empresa e funcionario precisam ser unicos!'),
    ]
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }    
    

