# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class software_tabela_produtos(osv.Model):
    """
    Tabela de precos
    """
    _name = 'software.tabela.produtos'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="cascade", required=True, select=True,
                                      domain="[('tipo', '=', 'P'),('company_id','=',company_id)]"),
        'seguimento_id': fields.many2one("software.seguimento", 'Seguimento', ondelete="cascade", required=True,
                                         select=True),
        'pontos_de_venda': fields.integer('PDVs', required=True, help='Quantidade maxima de PDVs'),
        'preco': fields.float('Preco', digits=(10, 2), required=True), # Valor do produto
    }

    _sql_constraints = [
        ('tabela_produto_uniq', 'unique (company_id, produto_id, seguimento_id, pontos_de_venda)',
         'Empresa, produto, seguimento e ponto de venda precisam ser unicos!'),
    ]
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }

