# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class software_tabela_servicos(osv.Model):
    """
    Tabela de quantidade de horas de cada servico
    """
    _name = 'software.tabela.servicos'
    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True),
        'servico_id': fields.many2one("estoque.produto", 'Servico', ondelete="cascade", required=True, select=True,
                                      domain="[('tipo', '=', 'S'),('company_id','=',company_id)]"), # id do servico
        'seguimento_id': fields.many2one("software.seguimento", 'Seguimento', ondelete="restrict", required=True,
                                         select=True), # id do seguimento
        'pontos_de_venda': fields.integer('Pontos de venda', required=True),
        'qtd_horas': fields.float('Qtd horas', digits=(6, 2), required=True), # Quantidade de horas
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
    }
    _sql_constraints = [
        ('tabela_servico_uniq', 'unique (company_id, servico_id, seguimento_id, pontos_de_venda)',
         'Empresa, servico, seguimento e pontos de venda precisam ser unicos!'),
    ]

