# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class software_tabela_view(osv.Model):
    def _get_name(self, cr, uid, ids, field, args, context=None):
        res = {}
        context = context and context.copy() or {}
        if not len(ids):
            return {}
        reads = self.read(cr, uid, ids, [ 'descricao','name'], context=context)
        for record in reads:
            res[record['id']] = str( record['name'])
        return res
    _name = 'software.tabela.view'
    _description = 'Tabela'
    _auto = False
    _columns = {
        'name' : fields.function(_get_name, method=True, string='Nome', type='char', size=63, store=True),
        'company_id' : fields.many2one("res.company", 'Empresa', ondelete="cascade", required=True, select=True), # id da empresa\n
        'produto_id' : fields.many2one("estoque.produto", 'Produto', ondelete="cascade", required=True, select=True),
        'seguimento_id' : fields.many2one("software.seguimento", 'Seguimento', ondelete="cascade", required=True, select=True),
        'pontos_de_venda' : fields.integer('Pontos de venda', required=True), # Quantidade de pontos de vendas(limite máximo
        'preco' : fields.float('Preco', digits=(10, 2), required=True), # Valor do produto
        'tipo': fields.char('Tipo',size=5, required=False)
        }

    def init(self, cr):
            tools.drop_view_if_exists(cr, 'software_tabela_view')
            cr.execute("""
                CREATE OR REPLACE VIEW software_tabela_view AS
                         SELECT produto.produto_id AS id, ep.name AS name, produto.seguimento_id, produto.pontos_de_venda, produto.preco, produto.company_id, produto.produto_id, 'P' AS tipo, 0 AS horas
                           FROM software_tabela_produtos produto, estoque_produto ep
                          WHERE ep.id = produto.produto_id AND ep.company_id = produto.company_id
                UNION ALL
                         SELECT servico.servico_id AS id, ep.name AS name, servico.seguimento_id, servico.pontos_de_venda, servico.qtd_horas * epv.preco_venda AS preco, servico.company_id, servico.servico_id AS produto_id, 'S' AS tipo, servico.qtd_horas AS horas
                           FROM software_tabela_servicos servico, estoque_produto ep, estoque_preco_venda epv
                          WHERE ep.id = servico.servico_id AND ep.company_id = servico.company_id AND epv.produto_id = servico.servico_id;
            """)
