#!/usr/bin/python
# -*- encoding: utf-8 -*-

from re import sub
from openerp.osv import osv
from openerp.tools.translate import _


class control_cad_clientes(osv.Model):

    _inherit = 'supervisor.cad.clientes'

    def create(self, cr, user, vals, context=None):
        context = context and context.copy() or {}
        cpf_cnpj = vals.get('supcli_cnpj_cpf') or ''
        vals['supcli_cnpj_cpf'] = (sub('[^0-9]', '', cpf_cnpj)).rjust(15, '0')

        return super(control_cad_clientes, self).create(cr, user, vals, context)

    def write(self, cr, user, ids, vals, context=None):
        context = context and context.copy() or {}
        if 'supcli_cnpj_cpf' in vals:
            cpf_cnpj = vals['supcli_cnpj_cpf'] or ''
            vals['supcli_cnpj_cpf'] = sub('[^0-9]', '', cpf_cnpj).rjust(15, '0')

        return super(control_cad_clientes, self).write(cr, user, ids, vals, context)

    def supcli_button_exportar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        reference = self.pool.get('ir.model.data').get_object_reference(cr, uid, 'supervisor',
                                               'view_wizard_exportar_cliente_caixa_especifico_form')
        view_id = reference and reference[1] or False
        return {'name': _('Exportar Cliente para um Caixa'),
                'view_type': 'form',
                'view_mode': 'form',
                'res_model': 'wizard.exportar.cliente.caixa.especifico',
                'view_id': [view_id],
                'context': context,
                'target': 'new',
                'type': 'ir.actions.act_window'}