#!/usr/bin/python
# -*- encoding: utf-8 -*-

from re import sub
from openerp.osv import osv
from openerp.tools.translate import _


class supervisor_cad_finalizadora(osv.Model):

    _inherit = 'supervisor.cad.finalizadora'

    def create(self, cr, user, vals, context=None):
        context = context and context.copy() or {}
        res = super(supervisor_cad_finalizadora, self).create(cr, user, vals, context)
        self._bloqueia_cadastro_errado(cr, user, vals, ids=[res],  context=context)
        return res

    def write(self, cr, user, ids, vals, context=None):
        context = context and context.copy() or {}
        self._bloqueia_cadastro_errado(cr, user, vals, ids=ids, context=context)
        return super(supervisor_cad_finalizadora, self).write(cr, user, ids, vals, context)

    def _bloqueia_cadastro_errado(self, cr, uid, vals, ids=[], context=None):
        context = context and context.copy() or {}
        # teste somente quando o usuario alterou, quando for o sitesma, nao testa.
        if not context.get('supfin_manutencao'):
            return True

        msg = []
        if ids:
            for finalizadora in self.read(cr, uid, ids, ['supfin_codigo'], context=context):
                if finalizadora.get('supfin_codigo') != 9999:
                    return True

        # se a finalizadora for 9999, nao permite criar ou salvar os campos que nao sejam os
        # obrigatorios na lista abaixo
        campos_obrigatorios = ['supfin_codigo', 'name', 'supfin_tipo_finalizadora',
                               'supfin_codigo_na_ecf', 'supfin_avista_aprazo']
        for campo in vals:
            if campo not in campos_obrigatorios and vals.get(campo):
                msg.append(self._columns.get(campo).string)

        if not msg:
            return True

        raise osv.except_osv(_('Atencao!'),
                             _('Os campos a seguir nao devem ser preenchidos:\n%s' %
                              ("'" + "'\n'".join(msg) + "'")))

