# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _


class supervisor_cad_operadores(osv.Model):
    """
    Tabela de Cadastro de Operadores
    Prefixo: supope

    """
    _inherit = 'supervisor.cad.operadores'

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        context.update({'active_test': False})
        res = super(supervisor_cad_operadores, self).search(cr, uid, args, offset, limit, order,
                                                            context, count)
        return res

    def create(self, cr, user, vals, context=None):
        context = context and context.copy() or {}
        self.supope_verifica_codigo(vals, context)
        self.remove_acentuacao_nome(vals)
        return super(supervisor_cad_operadores, self).create(cr, user, vals, context)

    def write(self, cr, uid, id, vals, context=None):
        context = context and context.copy() or {}
        self.supope_verifica_codigo(vals, context)
        self.remove_acentuacao_nome(vals)
        return super(supervisor_cad_operadores, self).write(cr, uid, id, vals, context)

    def supope_verifica_codigo(self, vals, context=None):
        context = context and context.copy() or {}
        if 'supope_codigo' in vals and (not vals.get('supope_codigo') or
                                                vals.get('supope_codigo') < 1):
            raise osv.except_osv(_('Atencao!'),
                                 _('Codigo do operador deve ser maior que Zero!'))

        return True

    def remove_acentuacao_nome(self, vals, context=None):
        context = context and context.copy() or {}
        if not vals or not vals.get('name'):
            return True

        obj_util = self.pool.get('supervisor.util')
        vals['name'] = obj_util.suputi_remover_acentuacao(vals.get('name'))
        return True