# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from datetime import datetime


class supervisor_cad_pdvs(osv.Model):
    """
    Tabela de Cadastro de PFVs
    Prefixo: suppdv
    """
    _name = 'supervisor.cad.pdvs'
    _inherit = 'supervisor.cad.pdvs'

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = []
        if not len(ids):
            return []
        dados = self.read(cr, uid, ids, ['suppdv_loja', 'suppdv_caixa'], context=context)
        for x in dados:
            res.append((x['id'], str(x['suppdv_loja']) + ' - ' + str(x['suppdv_caixa'])))
        return res

    def name_search(self, cr, uid, name='', args=[], operator='ilike', context=None, limit=100):
        context = context and context.copy() or {}
        try:
            name = int(name)
        except:
            pass
        if isinstance(name, int):
            ids = self.search(cr, uid, [( 'suppdv_loja', '=', name )] + args, limit=limit,
                              context=context)
            if not ids:
                ids = self.search(cr, uid, [( 'suppdv_caixa', '=', name )] + args, limit=limit,
                                  context=context)
                if not ids:
                    return ids
        else:
            ids = self.search(cr, uid, args, limit=limit, context=context)
            if not ids:
                return ids

        return self.name_get(cr, uid, ids)

    def altera_data_atualizacao(self, cr, uid, loja, caixa, context=None):
        '''
        Atualiza a hora que o caixa conectou com o supervisor, esta funcao eh chamada no PDV
        :param cr: 
        :param uid: 
        :param loja: 
        :param caixa: 
        :param context: 
        :return: 
        '''
        context = context and context.copy() or {}
        args = [('suppdv_loja', '=', loja),
                ('suppdv_caixa', '=', caixa)]
        pdv_ids = self.search(cr, uid, args, context=context)
        if not pdv_ids:
            self.create(cr, uid, {'suppdv_loja':loja,
                                  'suppdv_caixa': caixa,
                                  'suppdv_data_pdv_atualizacao': datetime.now()})
            return 'OK'

        self.write(cr, uid, pdv_ids, {'suppdv_data_pdv_atualizacao': '%s' % datetime.now()},
                   context)
        return 'OK'