#!/usr/bin/python
# -*- coding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _


class supervisor_cad_restricao_item(osv.Model):

    _inherit = 'supervisor.cad.restricao.item'

    def supres_onchange_codigo(self, cr, uid, ids, codigo_barras, context=None):
        context = context and context.copy() or {}
        if not codigo_barras:
            return {}

        if len(codigo_barras) < 14:
            codigo_barras = codigo_barras.zfill(14)

        obj_cad_itens = self.pool.get('supervisor.cad.itens')
        cad_itens_ids = obj_cad_itens.search(cr, uid, [('supite_codigo_item','=',codigo_barras)],
                                             context=context)
        if not cad_itens_ids:
            warning = {'title':  _('Atencao!'),
                       'message':_('Codigo de barras nao esta cadastrado no supervisor!')}
            return {'value': {'supres_codigo_barra':''},
                    'warning': warning}

        dados_itens = obj_cad_itens.read(cr, uid, cad_itens_ids[0], ['supite_descricao_completa',
                                                                  'name'], context=context)
        nome_item = dados_itens.get('supite_descricao_completa') or dados_itens.get('name')
        return {'value':{'supres_nome_item': nome_item,
                         'supres_codigo_barra': codigo_barras}}


