# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class supervisor_cad_tributacao(osv.Model):
    """
    Tabela de Tributacao
    Prefixo: suptri
    """
    _name = 'supervisor.cad.tributacao'
    _inherit = 'supervisor.cad.tributacao'

    def name_get(self, cr, uid, ids, context=None):
        res = []
        context = context and context.copy() or {}
        if not len(ids):
            return []
        dados = self.read(cr, uid, ids, ['suptri_codigo_trib_retag', 'suptri_name'], context=context)
        for x in dados:
            if x.get('suptri_codigo_trib_retag'):
                trib_retag = str(x.get('suptri_codigo_trib_retag'))
                res.append((x['id'], trib_retag + ' - ' + str(x.get('suptri_name'))))
            else:
                res.append((x['id'], str(x.get('suptri_name'))))
        return res

    def name_search(self, cr, uid, name='', args=[], operator='ilike', context=None, limit=100):
        context = context and context.copy() or {}
        ids = []
        pesquisa = name
        try:
            pesquisa = int(name)
        except:
            pass
        if isinstance(pesquisa, int):
            ids = self.search(cr, uid, [( 'suptri_codigo_trib_retag', '=', name )] + args, limit=limit, context=context)
        else:
            ids = self.search(cr, uid, [( 'suptri_name', '=', name )] + args, limit=limit, context=context)
        if not ids:
            ids = self.search(cr, uid, args, limit=limit, context=context)
        return self.name_get(cr, uid, ids)
