# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
import re


class supervisor_cfg_configuracao(osv.Model):

    _inherit = 'supervisor.cfg.configuracao'

    def supcfc_verifica_cnpj(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        cnpj = vals.get('supcfc_cnpj')
        if cnpj and len(cnpj) != 14:
            raise osv.except_osv(_('Atencao!'),
                                 _('CNPJ invalido! Deve conter 14 digitos'))

        cnpj = re.sub('[^0-9]', '', str(vals.get('supcfc_cnpj') or ''))
        if cnpj and (not cnpj.isdigit() or len(cnpj) != 14):
            raise osv.except_osv(_('Atencao!'),
                                 _('CNPJ invalido! Digite apenas os numeros!'))
        return True

    def create(self, cr, user, vals, context=None):
        context = context and context.copy() or {}
        self.supcfc_verifica_cnpj(cr, user, vals, context)
        if 'supcfc_nro_empresa' in vals and not vals.get('supcfc_nro_empresa'):
            raise osv.except_osv('Atencao!',
                                 'A Empresa deve ser diferente de zero!')

        self.verificar_faturamento_simples_nacional(vals, context)
        return super(supervisor_cfg_configuracao, self).create(cr, user, vals, context)

    def write(self, cr, user, ids, vals, context=None):
        context = context and context.copy() or {}
        self.supcfc_verifica_cnpj(cr, user, vals, context)
        if 'supcfc_nro_empresa' in vals and not vals.get('supcfc_nro_empresa'):
            raise osv.except_osv('Atencao!',
                                 'A Empresa deve ser diferente de zero!')

        self.verificar_faturamento_simples_nacional(vals, context)
        return super(supervisor_cfg_configuracao, self).write(cr, user, ids, vals, context)

    def verificar_faturamento_simples_nacional(self, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('supcfc_regime_tributario') == 'S' \
                and vals.get('supcfc_valor_faturamento') <= 0:
            raise osv.except_osv('Atencao!',
                                 'O valor do Faturamento Anual deve ser maior que zero para '
                                 'Simples Nacional!')

        return True

    def supcfc_abrir_importacao(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return {
            'name': _('Importacao de Certificado Digital'),
            'view_type': 'form',
            'view_mode': 'form',
            'res_model': 'supervisor.import.certificado',
            'view_id': False,
            'target': 'new',
            'type': 'ir.actions.act_window',
        }
