# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _
import time


class supervisor_mov_acao_pendente(osv.Model):
    _inherit = 'supervisor.mov.acao.pendente'

    def cria_acao_pendente(self, cr, uid, tabela, caixas=[], context=None):
        '''
        Cria acoes pendentes para os caixas passados no parametro ou para todos os caixas cadastrados no supervisor
        caso nao seja passado nenhum caixa no parametro.
        :param cr:
        :param uid:
        :param tabela: tabela que sera criada acao pendente
        :param caixas: lista com os numeros dos caixas(ecfs)
        :param context:
        :return:
        '''
        obj_pdvs = self.pool.get('supervisor.cad.pdvs')
        context = context and context.copy() or {}
        if not caixas:
            pdvs_ids = obj_pdvs.search(cr, uid, [], context=context)
            if not pdvs_ids:
                raise osv.except_osv(_('Atencao!'),
                                     _('Nenhum PDV cadastrado no supervisor!'))

        else:
            pdvs_ids = obj_pdvs.search(cr, uid, [('suppdv_caixa','in', caixas)], context=context)

        dados_pdvs = obj_pdvs.read(cr, uid, pdvs_ids, ['suppdv_loja', 'suppdv_caixa'], context=context)
        for pdv in dados_pdvs:
            args = [('supeape_loja','=',pdv.get('suppdv_loja')),
                    ('supeape_pdv','=',pdv.get('suppdv_caixa')),
                    ('supape_tabela','=',tabela),
                    ('supape_situacao','=','A')]
            if self.search(cr, uid, args, context=context):
                continue

            self.create(cr, uid, {'supeape_loja': pdv.get('suppdv_loja'),
                                  'supeape_pdv': pdv.get('suppdv_caixa'),
                                  'supape_tabela': tabela,
                                  'supape_situacao': 'A'}, context=context)

        return True


