# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time
from dateutil.parser import parse


class supervisor_mov_caixa(osv.Model):
    """
    Tabela de Caixa
    Prefixo: supcax
    """
    _inherit = 'supervisor.mov.caixa'

    def name_search(self, cr, uid, name='', args=None, operator='ilike', context=None, limit=100):
        context = context and context.copy() or {}
        ids = []
        name = str(name)
        operador_ids = self.pool.get('supervisor.cad.operadores').search(cr, uid,
                                                                         [('name', operator, name)], context=context)
        if operador_ids:
            ids = self.search(cr, uid, [('supcax_operador_id', 'in', operador_ids)] + args,
                              limit=limit, context=context)
        return self.name_get(cr, uid, ids)

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = []

        if not ids:
            return res

        obj_supervisor_util = self.pool.get('supervisor.util')
        dados = self.browse(cr, uid, ids, context)

        for x in dados:
            data_hora_abertura = ''
            data_hora_fechamento = ''

            if x.supcax_data_hora_abertura:
                data_hora_abertura = obj_supervisor_util.suputi_datetime_to_timezone(
                    cr, uid, parse(x.supcax_data_hora_abertura))

            if x.supcax_data_hora_fechamento:
                data_hora_fechamento = obj_supervisor_util.suputi_datetime_to_timezone(
                    cr, uid, parse(x.supcax_data_hora_fechamento))

            name = '%s - %s / %s' % (x.supcax_operador_id.name,
                                     data_hora_abertura, data_hora_fechamento)

            res.append((x['id'], name))

        return res

