# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
from pynfe.nfe.manual_600.nfe_400 import AutXML, Vol, DetPag
from pynfe.nfe.manual_600.consrecinfe import ProtNFe
from pynfe.nfe.manual_600.cancnfe_evento import EnvEvento, RetEnvEvento, ProcEventoNFe
from pynfe.nfe.manual_600.processador import ProcessoNFe
from pynfe.nfce.manual_600.nfce_p import Det
from pynfe.xml_sped.__init__ import UF_CODIGO
from pynfe.nfce.manual_600.webservices import ESTADO_WS
from pynfe.xml_sped.certificado import Certificado
from pynfe.nfce.manual_600.webservices_flag import WS_CONSULTA_QRCODE, WS_CONSULTA_CHAVE
from pynfe.nfce.manual_600 import qr_code
from pynfe.nfce.manual_600.consrecinfce import ProcNFCe
from pynfe.nfce.manual_600.nfce_p import NFCe
from pynfe.nfce.manual_600.NFCe import NFCe as nfc_e
from datetime import datetime
from decimal import Decimal
import re
import socket
import base64
import pytz

from openerp.addons.supervisor import print_log

HOMOLOGACAO = 2
TWOPLACES = Decimal(10) ** -2


class supervisor_mov_capa(osv.Model):

    _inherit = 'supervisor.mov.capa'

    def message_post(self, cr, uid, thread_id, body='', subject=None, type='notification',
                     subtype=None, parent_id=False, attachments=None, context=None,
                     content_subtype='html', **kwargs):
        context = context and context.copy() or {}

        return super(supervisor_mov_capa, self).message_post(
            cr, uid, thread_id, body=body, subject=subject, type=type, subtype=subtype,
            parent_id=parent_id, attachments=attachments, context=context,
            content_subtype=content_subtype, **kwargs)

    def supcap_button_cancelar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        reference = self.pool.get('ir.model.data').get_object_reference(cr, uid, 'supervisor',
                                                                        'view_wiz_supervisor_cancealr_nfce_form')
        view_id = reference and reference[1] or False
        return {'name': _('Confirmar Cancelamento'),
                'view_type': 'form',
                'view_mode': 'form',
                'res_model': 'supervisor.wizard.cancelar.nota',
                'view_id': [view_id],
                'context': context,
                'target': 'new',
                'type': 'ir.actions.act_window'}

    def supcap_verifica_status_nfce_sefaz(self, cr, uid, brw_capa, context=None):
        context = context and context.copy() or {}
        obj_conifg = self.pool.get('supervisor.cfg.configuracao')
        config_ids = obj_conifg.search(cr, uid, [('supcfc_loja', '=', brw_capa.supcap_loja)],
                                       context=context)
        if not config_ids:
            raise osv.except_osv(_('Atencao!'),
                                 _('Sem cadastro de configuracao para loja %s!') %
                                 brw_capa.supcap_loja)

        brw_config = obj_conifg.browse(cr, uid, config_ids[0], context=context)
        self.supcap_verifica_ambiente(cr, uid, brw_capa, brw_config, context)
        chave_acesso = brw_capa.supcap_chave_acesso
        ambiente = brw_config.supcfc_ambiente == 'P' and 1 or 2
        try:
            proc_nfce = nfc_e(brw_config.supcfc_certificado_conteudo,
                              brw_config.supcfc_chave_conteudo,
                              ambiente,
                              brw_config.supcfc_estado)
            result, __ = proc_nfce.consultar_nota(chave_acesso)
        except socket.gaierror:
            raise osv.except_osv(_('Atencao!'),
                                 _('Falha ao comunicar com o servidor da SEFAZ. Verifique se '
                                   'existe conexao com a Internet.'))
        except Exception as erro:
            raise osv.except_osv(_('Erro!'), erro.message) or erro
        except IOError:
            raise osv.except_osv(_('Erro!'), _('Falha ao comunicar com o servidor da SEFAZ. Tente '
                                               'novamente mais tarde.'))
        return result, __

    def cron_supcap_faturar_nfce(self, cr, uid, context=None):
        context = context and context.copy() or {}
        print_log('Supevisor - Cron Processar NFC-e ', 'I')
        partner_id = self.pool.get('res.users').read(cr, uid, uid, ['partner_id'], context,
                                                     '_classic_write').get('partner_id')
        context['tz'] = self.pool.get('res.partner').read(cr, uid, partner_id, ['tz'],
                                                          context).get('tz') or 'America/Sao_Paulo'
        obj_conifg = self.pool.get('supervisor.cfg.configuracao')
        config_ids = obj_conifg.search(cr, uid, [], context=context)
        if config_ids:
            brw_config = obj_conifg.browse(cr, uid, config_ids[0], context=context)

        limite = 50
        ids = self.search(cr, uid, [('supcap_state', '=', '4')], limit=limite,
                          order='supcap_data_cupom', context=context)
        for id in ids:
            try:
                self.supcap_faturar_nfce(cr, uid, [id], context)
                cr.execute('COMMIT')
            except Exception as e:
                print_log('Supevisor - Erro ao faturar NFC-e de ID: %s - %s' % (id, e), 'E')
                continue

            status = self.read(cr, uid, id, ['supcap_status'], context).get('supcap_status')
            # caso a sefaz estiver com problema, tenta faturar apenas na proxima iteracao do cron
            if '999' in status:
                return True
        #
        limite -= len(ids) - 5
        ids = self.search(cr, uid, [('supcap_state', '=', '5'),
                                    ('supcap_status', 'ilike', '501 - ')], context=context)
        args =  [('supcap_state', '=', '5')]
        if ids:
            args.append(('id', 'not in', ids))

        ids = self.search(cr, uid, args, limit=(limite or 1), order='supcap_data_cupom',
                          context=context)
        for brw_capa in self.browse(cr, uid, ids, context):
            # 501 = fora do prazo para cancelamento
            # 919 = Item da NFC-e Substituta difere do mesmo item da NFC-e a ser cancelada
            # 563 = Ja existe pedido de Inutilizacao com a mesma faixa de inutilizacao
            if brw_capa.supcap_status and brw_capa.supcap_status.split(' - ')[0] in ('501', '563', '919'):
                continue
            try:
                processo, __ = self.supcap_verifica_status_nfce_sefaz(cr, uid, brw_capa, context)
                if processo.resposta.cStat.valor == u'100':  # Faturada
                    protocolo = processo.resposta.protNFe.infProt.nProt.valor
                    processo.resposta.protNFe.Signature.URI = ''  # tira a assinatura do xml de autorizacao
                    xml_proc = processo.resposta.protNFe.infProt.xml
                    self.write(cr, uid, brw_capa.id, {'supcap_xml_proc': xml_proc,
                                                      'supcap_protocolo': protocolo}, context)
                    self.supcap_cancelar_nfce(cr, uid, brw_capa, protocolo, context, True)

                elif processo.resposta.cStat.valor == u'101':  # Cancelada
                    protocolo = processo.resposta.protNFe.infProt.nProt.valor
                    processo.resposta.protNFe.Signature.URI = ''  # tira a assinatura do xml de autorizacao
                    xml_proc = processo.resposta.protNFe.infProt.xml
                    xml_canc = self.supcap_gerar_xml_cancelamento(processo, brw_capa, brw_config, protocolo)
                    self.write(cr, uid, brw_capa.id, {'supcap_state': 'C',
                                                      'supcap_cliente': '',
                                                      'supcap_xml_cancelamento': xml_canc,
                                                      'supcap_tipo': 'C',
                                                      'supcap_xml_proc': xml_proc,
                                                      'supcap_protocolo': protocolo}, context)
                    self.supcap_alterar_corpos(cr, uid, brw_capa, 'C', context)

                elif processo.resposta.cStat.valor == u'102':  # Inutilizada
                    self.write(cr, uid, brw_capa.id, {'supcap_state': 'I',
                                                      'supcap_cliente': '',
                                                      'supcap_tipo': 'I'}, context)
                    self.supcap_alterar_corpos(cr, uid, brw_capa, 'I', context)

                elif processo.resposta.cStat.valor in (u'137', u'217'):
                    self.supcap_inutilizar_nfce(cr, uid, brw_capa, context)

                elif processo.resposta.cStat.valor in (u'999'):
                    # Caso tenha retornado erro da SEFAZ na consulta, tenta inutilizar e nao der
                    # tenta cancelar
                    self.supcap_inutilizar_nfce(cr, uid, brw_capa, context)

                cr.execute('COMMIT;')
            except Exception as e:
                print_log('Supevisor - Erro ao processar NFC-e de ID: %s - %s' % (brw_capa.id, e),
                          'E')
                continue

            dados = self.read(cr, uid, brw_capa.id, ['supcap_status', 'supcap_loja', 'supcap_caixa',
                                'supcap_chave_acesso', 'supcap_nro_cupom', 'supcap_state'], context)

            if dados.get('supcap_state') in ('3', 'C', 'I', 'D', '2E'):
                data = datetime.strftime(self.pool.get('supervisor.util').suputi_converte_tz(
                    cr, uid, datetime.strptime(
                        datetime.now().strftime('%Y-%m-%d %H:%M:%S'), '%Y-%m-%d %H:%M:%S'), 'UTC',
                    context=context), '%Y-%m-%d %H:%M:%S')
                obj_conifg = self.pool.get('supervisor.cfg.configuracao')
                config_ids = obj_conifg.search(cr, uid, [('supcfc_loja', '=', dados.get('supcap_loja'))],
                                               context=context)
                brw_config = obj_conifg.browse(cr, uid, config_ids[0], context=context)
                ambiente = {'H': _('Homologacao'),
                            'P': _('Producao')}.get(brw_config.supcfc_ambiente)
                self.message_post(cr, uid, ids[0], dados.get('supcap_status') or '' + ' em %s' % data,
                                  '%s %s-%s - %s [%s]' % ('NFC-e',
                                                          dados.get('supcap_nro_cupom'),
                                                          dados.get('supcap_caixa'),
                                                          dados.get('supcap_chave_acesso'), ambiente))

        return True

    def cron_supervisor_deletar_registros(self, cr, uid, context=None):
        try:
            cr.execute("""
    BEGIN;
    DELETE FROM supervisor_mov_capa
    WHERE id IN (SELECT capa.id
                 FROM supervisor_mov_capa AS capa 
                 INNER JOIN supervisor_mov_cupom_servidor AS serv ON serv.supcse_capa_id = capa.id
                 WHERE capa.supcap_data_cupom <= CURRENT_DATE - 120
                   AND serv.supcse_enviado = True);
    COMMIT;                                    
                       """)
        except Exception:
            cr.execute('ROLLBACK;')

        return True

    def supcap_gerar_xml_cancelamento(self, consulta, brw_capa, brw_config, protocolo):
        """Refaz o xml de cancelamento, quando a sefaz aceita o cancelamento mas na hora do retorno da erro"""
        ambiente = brw_config.supcfc_ambiente == 'P' and 1 or 2
        proc_nfce = nfc_e(brw_config.supcfc_certificado_conteudo,
                          brw_config.supcfc_chave_conteudo,
                          ambiente,
                          brw_config.supcfc_estado)
        chave = brw_capa.supcap_chave_acesso
        envio = EnvEvento()
        resposta = RetEnvEvento()
        processo = ProcessoNFe(2, envio, resposta)
        envio.infEvento.tpAmb.valor = ambiente
        envio.infEvento.chNFe.valor = chave
        envio.infEvento.nProt.valor = protocolo
        envio.infEvento.xJust.valor = 'Nota fiscal emitida em contingencia'
        envio.infEvento.cOrgao.valor = UF_CODIGO[brw_config.supcfc_estado]
        dt = datetime.utcnow()
        dt = dt.replace(tzinfo=pytz.utc)
        data_hora_tz = datetime.astimezone(dt, pytz.timezone("Brazil/East"))
        data_evento = datetime.strftime(data_hora_tz, u'%Y-%m-%dT%H:%M:%S') + str(data_hora_tz)[-6:]
        envio.infEvento.dhEvento.valor = data_evento
        envio.infEvento.CNPJ.valor = chave[6:20]
        proc_nfce.process.certificado.assina_xmlnfe(envio)
        envio.validar()
        # seta os dados que nao tem
        resposta.retEvento.infEvento.cStat.valor = u'135'
        resposta.retEvento.infEvento.tpAmb.valor = ambiente
        resposta.retEvento.infEvento.verAplic.valor = consulta.resposta.protNFe.infProt.verAplic.valor
        resposta.retEvento.infEvento.cOrgao.valor = consulta.resposta.retCancNFe.infCanc.cOrgao.valor
        resposta.retEvento.infEvento.xMotivo.valor = consulta.resposta.retCancNFe.infCanc.xMotivo.valor
        resposta.retEvento.infEvento.dhRegEvento.valor = str(consulta.resposta.retCancNFe.infCanc.dhRegEvento.valor).replace(' ', 'T')
        protocolo_canc = consulta.resposta.retCancNFe.infCanc.nProt.valor
        resposta.retEvento.infEvento.nProt.valor = protocolo_canc
        resposta.retEvento.infEvento.chNFe.valor = chave
        resposta.retEvento.infEvento.Id.valor = 'ID%s' % protocolo_canc
        processo_cancelamento_nfe = ProcEventoNFe()
        processo_cancelamento_nfe.envEvento = envio
        processo_cancelamento_nfe.retEnvEvento = resposta
        processo_cancelamento_nfe.validar()
        processo.processo_cancelamento_nfe = processo_cancelamento_nfe
        return processo.processo_cancelamento_nfe.xml

    def supcap_alterar_corpos(self, cr, uid, brw_capa, tipo, context=None):
        context = context and context.copy() or {}
        corpos_ids = map(lambda x: x.id, brw_capa.supcap_mov_corpos_ids)
        self.pool.get('supervisor.mov.corpos').write(cr, uid, corpos_ids, 
                                                     {'supcor_venda_cancelamento': tipo}, context)
        return True

    def supcap_cancelar_nfce(self, cr, uid, brw_capa, protocolo, context=None, substituicao=False):
        context = context and context.copy() or {}
        obj_conifg = self.pool.get('supervisor.cfg.configuracao')
        config_ids = obj_conifg.search(cr, uid, [('supcfc_loja', '=', brw_capa.supcap_loja)],
                                       context=context)
        if not config_ids:
            raise osv.except_osv(_('Atencao!'),
                                 _('Sem cadastro de configuracao para loja %s!') % brw_capa.supcap_loja)

        brw_config = obj_conifg.browse(cr, uid, config_ids[0], context=context)
        self.supcap_verifica_ambiente(cr, uid, brw_capa, brw_config, context)
        chave_acesso = brw_capa.supcap_chave_acesso
        ambiente = brw_config.supcfc_ambiente == 'P' and 1 or 2
        protocolo = brw_capa.supcap_protocolo or protocolo
        if not protocolo:
            raise osv.except_osv(_("Atencao!"), _("Nota sem protocolo!"))

        print_log('Supevisor - Cancelando NFC-e %s  serie %s' % (brw_capa.supcap_nro_cupom,
                                                                 brw_capa.supcap_caixa), 'I')
        try:
            proc_nfce = nfc_e(brw_config.supcfc_certificado_conteudo,
                              brw_config.supcfc_chave_conteudo,
                              ambiente,
                              brw_config.supcfc_estado)
            proc_nfce.process.tentativas = brw_config.supcfc_qtd_conexoes_nfce or 20
            proc_nfce.process.timeout = brw_config.supcfc_timeout_conexoes_nfce or 10
            if not substituicao:
                processo = proc_nfce.process.cancelar_nfce(chave_acesso,
                                                           protocolo,
                                                           'Nota fiscal emitida em contingencia')
            else:
                nf_ids = self.search(cr, uid, [('supcap_caixa', '=', brw_capa.supcap_caixa),
                                               ('supcap_nro_cupom', '=', brw_capa.supcap_nro_cupom + 1),
                                               ('supcap_state', '=', '3')], context=context)
                if nf_ids:
                    chave_ref = self.read(cr, uid, nf_ids[0], ['supcap_chave_acesso'], context
                                          ).get('supcap_chave_acesso')
                    if not chave_ref:
                        print_log('Sem chave de referencia para o cancelamento por substituicao', 'E')
                        return
                else:
                    print_log('Aguardando faturar a NFC-e %s Serie %s' %
                              (brw_capa.supcap_nro_cupom + 1, brw_capa.supcap_caixa), 'E')
                    return


                processo = proc_nfce.process.cancelar_nfce_substituicao(chave_acesso,
                                                                        protocolo,
                                                                        'Cancelamento de NFCe por substituicao',
                                                                        chave_ref)

        except socket.gaierror:
            print_log(_('Falha no servidor da SEFAZ. Verifique se existe conexao com a Internet.'), 'E')

        except IOError:
            print_log(_('Falha no servidor da SEFAZ. Tente novamente mais tarde.'), 'E')

        except Exception as erro:
            if str(erro).find('certificate expired') >= 1:
                erro = 'Certificado digital com validade vencida.'

            print_log(erro, 'E')

        else:
            value = {}
            if processo.resposta.cStat.valor == u'128':
                if processo.resposta.retEvento.infEvento.cStat.valor in (u'135-155-151'):
                    value['supcap_xml_cancelamento'] = processo.processo_cancelamento_nfe.xml
                    if processo.resposta.retEvento.infEvento.Id.valor:
                        value['supcap_protocolo_cancelamento'] = \
                            processo.resposta.retEvento.infEvento.Id.valor[2:]
                    value['supcap_status'] = '%s - %s' % (
                        processo.resposta.retEvento.infEvento.cStat.valor,
                        processo.resposta.retEvento.infEvento.xMotivo.valor)
                    value['supcap_state'] = 'C'
                    value['supcap_tipo'] = 'C'
                    value['supcap_cliente'] = ''
                    self.write(cr, uid, brw_capa.id, value, context)
                    self.supcap_alterar_corpos(cr, uid, brw_capa, 'C', context)
                elif processo.resposta.retEvento.infEvento.cStat.valor in (u'501', u'580') and \
                        not substituicao:
                    self.supcap_cancelar_nfce(cr, uid, brw_capa, protocolo, context, True)

                else:
                    value['supcap_status'] = '%s - %s' % (
                        processo.resposta.retEvento.infEvento.cStat.valor,
                        processo.resposta.retEvento.infEvento.xMotivo.valor)
                    self.write(cr, uid, brw_capa.id, value, context)
            else:
                if not processo.resposta.cStat.valor:
                    erro = 'Erro interno na SEFAZ. Tente novamente.'
                else:
                    erro = '%s - %s.' % (processo.resposta.cStat.valor,
                                         processo.resposta.xMotivo.valor)

                value['supcap_status'] = erro
                self.write(cr, uid, brw_capa.id, value, context)

        return True

    def supcap_inutilizar_nfce(self, cr, uid, brw_capa, context=None):
        context = context and context.copy() or {}
        obj_conifg = self.pool.get('supervisor.cfg.configuracao')
        config_ids = obj_conifg.search(cr, uid, [('supcfc_loja', '=', brw_capa.supcap_loja)],
                                       context=context)
        if not config_ids:
            raise osv.except_osv(_('Atencao!'),
                                 _('Sem cadastro de configuracao para loja %s!') %
                                 brw_capa.supcap_loja)

        brw_config = obj_conifg.browse(cr, uid, config_ids[0], context=context)
        self.supcap_verifica_ambiente(cr, uid, brw_capa, brw_config, context)
        cnpj = re.sub('[^0-9]', '', brw_config.supcfc_cnpj) or ''
        if not cnpj:
            raise osv.except_osv(_('Atencao!'), _('Nao existe CNPJ cadastro para o emitente.'))

        ambiente = brw_config.supcfc_ambiente == 'P' and 1 or 2
        ini = brw_capa.supcap_nro_cupom
        fim = brw_capa.supcap_nro_cupom
        justificativa = 'Nota fiscal emitida em contingencia'

        serie = brw_capa.supcap_caixa
        ano = datetime.now().strftime(u'%y')
        print_log('Supevisor - Inutilizando NFC-e %s  serie %s' % (brw_capa.supcap_nro_cupom,
                                                                   brw_capa.supcap_caixa), 'I')
        vals = {}
        try:
            proc_nfce = nfc_e(brw_config.supcfc_certificado_conteudo,
                              brw_config.supcfc_chave_conteudo,
                              ambiente,
                              brw_config.supcfc_estado)
            processo = proc_nfce.inutilizar_faixa_numeracao(ano, cnpj, serie, ini, fim,
                                                                justificativa)
        except socket.gaierror:
            vals['supcap_status'] = _('Falha no servidor da SEFAZ. Verifique se existe conexao com a Internet.')
            self.write(cr, uid, brw_capa.id, {'supcap_state': '4'}, context=context)
            return True

        except IOError:
            vals['supcap_status'] = _('Falha no servidor da SEFAZ. Tente novamente mais tarde.')
            self.write(cr, uid, brw_capa.id, vals, context=context)
            return True

        except Exception as err:
            vals['supcap_status'] = _('Erro de conexao com servidor. \n%s') % err
            self.write(cr, uid, brw_capa.id, vals, context)
            return True

        if processo.resposta.infInut.cStat.valor not in (u'102', u'563'):
            vals['supcap_status'] = '%s - %s.' % (processo.resposta.infInut.cStat.valor,
                                                  processo.resposta.infInut.xMotivo.valor)
            self.write(cr, uid, brw_capa.id, vals, context)
            return True

        # if processo.resposta.infInut.cStat.valor == u'563':
        #     numero_protocolo = re.sub('[^0-9]', '', processo.resposta.infInut.xMotivo.valor)
        # else:
        numero_protocolo = processo.resposta.infInut.nProt.valor

        vals = {'supcap_protocolo': numero_protocolo,
                'supcap_state': 'I',
                'supcap_tipo': 'I',
                'supcap_status': '102 - Inutilizacao de numero homologado',
                'supcap_cliente': '',
                }
        args = [('supcap_data_cupom', '=', brw_capa.supcap_data_cupom),
                ('supcap_loja', '=', brw_capa.supcap_loja),
                ('supcap_caixa', '=', brw_capa.supcap_caixa),
                ('supcap_nro_cupom', '=', brw_capa.supcap_nro_cupom),
                ('supcap_tipo', '=', 'I')]
        if self.search(cr, uid, args, context=context):
            vals.pop('supcap_state')
            vals.pop('supcap_tipo')
            vals.pop('supcap_protocolo')
            vals['supcap_status'] = '%s - %s.' % (processo.resposta.infInut.cStat.valor,
                                                  processo.resposta.infInut.xMotivo.valor)

        self.write(cr, uid, brw_capa.id, vals, context)
        self.supcap_alterar_corpos(cr, uid, brw_capa, 'I', context)
        return True

    def supcap_button_faturar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.supcap_faturar_nfce(cr, uid, ids, context)
        dados = self.read(cr, uid, ids[0], ['supcap_status', 'supcap_loja', 'supcap_caixa',
                                            'supcap_chave_acesso', 'supcap_nro_cupom'], context)
        data = datetime.strftime(self.pool.get('supervisor.util').suputi_converte_tz(
            cr, uid, datetime.strptime(
                datetime.now().strftime('%Y-%m-%d %H:%M:%S'), '%Y-%m-%d %H:%M:%S'), 'UTC',
            context=context), '%Y-%m-%d %H:%M:%S')
        obj_conifg = self.pool.get('supervisor.cfg.configuracao')
        config_ids = obj_conifg.search(cr, uid, [('supcfc_loja', '=', dados.get('supcap_loja'))],
                                       context=context)
        brw_config = obj_conifg.browse(cr, uid, config_ids[0], context=context)
        ambiente = {'H': _('Homologacao'),
                    'P': _('Producao')}.get(brw_config.supcfc_ambiente)
        self.message_post(cr, uid, ids[0], dados.get('supcap_status') or '' + ' em %s' % data,
                          '%s %s-%s - %s [%s]' % ('NFC-e',
                                                  dados.get('supcap_nro_cupom'),
                                                  dados.get('supcap_caixa'),
                                                  dados.get('supcap_chave_acesso'), ambiente))
        return True

    def supcap_button_faturada(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'supcap_state': '3'}, context)
        return True

    def supcap_verifica_ambiente(self, cr, uid, brw_capa, brw_config, context=None):
        context = context and context.copy() or {}
        if brw_capa.supcap_ambiente == brw_config.supcfc_ambiente:
            return True

        amb_nota = {'H': _('Homologacao'),
                    'P': _('Producao')}.get(brw_capa.supcap_ambiente)
        amb_conf = {'H': _('Homologacao'),
                    'P': _('Producao')}.get(brw_config.supcfc_ambiente)
        msg = _('Ambiente da nota diferente da configuracao:\n'
                'Ambiente Nota: %s\nAmbiente Configuracao: %s' % (amb_nota, amb_conf))
        self.write(cr, uid, brw_capa.id, {'supcap_state': '2E', 'supcap_status': msg},
                                                   context)
        cr.execute('COMMIT;')
        raise osv.except_osv(_('Atencao!'), msg)

    def supcap_precessar_lote(self, cr, uid, brw_capa, brw_config, context=None):
        context = context and context.copy() or {}
        vals = {}
        ambiente = brw_config.supcfc_ambiente == 'P' and 1 or 2  # 1=Producao, 2=Homologacao
        nfce = self.gerar_nfce(cr, uid, brw_config, brw_capa, ambiente, context)

        try:
            proc_nfce = nfc_e(brw_config.supcfc_certificado_conteudo,
                              brw_config.supcfc_chave_conteudo,
                              ambiente,
                              brw_config.supcfc_estado)
            proc_nfce.process.tentativas = brw_config.supcfc_qtd_conexoes_nfce or 20
            proc_nfce.process.timeout = brw_config.supcfc_timeout_conexoes_nfce or 10
            processo = proc_nfce.process.consultar_recibo(brw_capa.supcap_lote)
        except Exception as e:
            print_log('Falha no servidor da SEFAZ. Erro: %s' % e, 'E')
            return True

        if processo.resposta.cStat.valor == u'104':  # O lote foi processado
            if processo.resposta.protNFe:
                protocolo = processo.resposta.protNFe[0]  # Normalmente somente uma nota eh enviada
            else:
                protocolo = ProtNFe()
                protocolo.infProt.cStat.valor = u'999'
                protocolo.infProt.xMotivo.valor = u'Erro de comunicacao com a SEFAZ'

            processo.resposta.cStat.valor = protocolo.infProt.cStat.valor
            processo.resposta.xMotivo.valor = protocolo.infProt.xMotivo.valor
            if protocolo.infProt.cStat.valor == u'100':  # Nota fiscal esta autorizada (SEFAZ)
                # Gera o XML e assina
                certificado = Certificado()
                certificado.certificado = brw_config.supcfc_certificado_conteudo
                certificado.chave = brw_config.supcfc_chave_conteudo
                certificado.assina_xmlnfe(nfce)

                vals['supcap_xml_proc'] = nfce.xml
                vals['supcap_protocolo'] = protocolo.infProt.nProt.valor
                vals['supcap_state'] = '3'
            elif protocolo.infProt.cStat.valor in (u'110', u'205', u'301', u'302', u'303'):
                # 110 = Uso denegado
                # 205 = NF-e esta denegada na base de dados da SEFAZ
                # 301 = Uso denegado: irregularidade fiscal do emitente
                # 302 = Uso denegado: irregularidade fiscal do destinatario
                # 303 = Destinatario nao habilitado a operar na UF
                vals['supcap_state'] = 'D'
            else:
                vals['supcap_state'] = '2E'

        elif processo.resposta.cStat.valor == u'105':  # O lote continua em processamento
            return True

        else:  # O lote nao foi processado. Ocorreu algum erro
            vals['supcap_state'] = '2E'

        vals['supcap_status'] = '%s - %s' % (processo.resposta.cStat.valor,
                                             processo.resposta.xMotivo.valor)
        self.write(cr, uid, brw_capa.id, vals, context)
        return True

    def supcap_faturar_nfce(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        id = ids[0]
        brw_capa = self.browse(cr, uid, id, context)
        obj_conifg = self.pool.get('supervisor.cfg.configuracao')
        config_ids = obj_conifg.search(cr, uid, [('supcfc_loja', '=', brw_capa.supcap_loja)],
                                       context=context)
        if not config_ids:
            raise osv.except_osv(_('Atencao!'),
                                 _('Sem cadastro de configuracao para loja %s!') %
                                   brw_capa.supcap_loja)

        brw_config = obj_conifg.browse(cr, uid, config_ids[0], context=context)
        self.supcap_verifica_ambiente(cr, uid, brw_capa, brw_config, context)
        print_log('Supevisor - Faturando NFC-e %s  serie %s' % (brw_capa.supcap_nro_cupom,
                                                                brw_capa.supcap_caixa), 'I')
        if brw_capa.supcap_status and brw_capa.supcap_status.split(' - ')[0] == '105':
            self.supcap_precessar_lote(cr, uid, brw_capa, brw_config, context)
            return True

        processo, __ = self.supcap_verifica_status_nfce_sefaz(cr, uid, brw_capa, context)
        if processo.resposta.cStat.valor == u'100':  # Faturada
            # Faturada
            ambiente = brw_config.supcfc_ambiente == 'P' and 1 or 2  # 1=Producao, 2=Homologacao
            nfce = self.gerar_nfce(cr, uid, brw_config, brw_capa, ambiente, context)
            procnfce = ProcNFCe()
            certificado = Certificado()
            certificado.certificado = brw_config.supcfc_certificado_conteudo
            certificado.chave = brw_config.supcfc_chave_conteudo
            certificado.assina_xmlnfe(nfce)
            procnfce.NFe.xml = str(nfce.xml)
            procnfce.protNFe.xml = str(processo.resposta.protNFe.xml)
            vals = {'supcap_state': '3',
                    'supcap_protocolo': processo.resposta.protNFe.infProt.nProt.valor,
                    'supcap_status': '%s - %s' % (processo.resposta.cStat.valor,
                                                  processo.resposta.xMotivo.valor or ''),
                    'supcap_xml_proc': procnfce.xml}
            self.write(cr, uid, id, vals, context)
            return True

        elif processo.resposta.cStat.valor == u'101':  # Cancelada
            processo.resposta.protNFe.Signature.URI = ''  # tira a assinatura do xml de autorizacao
            xml_proc = processo.resposta.protNFe.infProt.xml
            self.write(cr, uid, id, {'supcap_xml_proc': xml_proc,
                                     'supcap_protocolo': processo.resposta.protNFe.infProt.nProt.valor,
                                     'supcap_state': 'C',
                                     'supcap_status': '%s - %s' % (processo.resposta.cStat.valor,
                                                                   processo.resposta.xMotivo.valor or '')},
                       context)
            self.supcap_alterar_corpos(cr, uid, brw_capa, 'C', context)
            return True

        elif processo.resposta.cStat.valor == u'102':  # Inutilizada
            self.write(cr, uid, id, {'supcap_state': 'I',
                                     'supcap_status': '%s - %s' % (processo.resposta.cStat.valor,
                                                                   processo.resposta.xMotivo.valor or '')}
                       , context)
            self.supcap_alterar_corpos(cr, uid, brw_capa, 'I', context)
            return True

        elif processo.resposta.cStat.valor not in (u'137', u'217', u'999'):
            self.write(cr, uid, id, {'supcap_state': '2E',
                                     'supcap_status': '%s - %s.' % (processo.resposta.cStat.valor,
                                                                    processo.resposta.xMotivo.valor)}, context)
            return True

        # nota nao esta na SEFAZ

        ambiente = brw_config.supcfc_ambiente == 'P' and 1 or 2  # 1=Producao, 2=Homologacao
        nfce = self.gerar_nfce(cr, uid, brw_config, brw_capa, ambiente, context)
        chave_acesso = nfce.chave
        lote = ''
        try:
            xml = nfce.xml
            proc_nfce = nfc_e(brw_config.supcfc_certificado_conteudo,
                              brw_config.supcfc_chave_conteudo,
                              ambiente,
                              brw_config.supcfc_estado)
            proc_nfce.process.tentativas = brw_config.supcfc_qtd_conexoes_nfce or 20
            proc_nfce.process.timeout = brw_config.supcfc_timeout_conexoes_nfce or 10
            proc_nfce.process.nova_versao = True
            processo = proc_nfce.process.processar_lote(nfce)
            lote = processo.resposta.infRec.nRec.valor
            if processo.resposta.cStat.valor == u'103':
                processo = proc_nfce.process.consultar_recibo(lote)

        except socket.gaierror:
            print_log('Falha no servidor da SEFAZ. Verifique se existe conexao com a Internet.', 'E')
            vals = {'supcap_state': '4',
                    'supcap_xml_gerado': xml}
            if lote:
                vals['supcap_lote'] = lote
            self.write(cr, uid, ids, vals, context=context)

        except IOError:
            print_log('Falha no servidor da SEFAZ. Tente novamente mais tarde.', 'E')
            vals = {'supcap_state': '4',
                    'supcap_xml_gerado': xml}
            if lote:
                vals['supcap_lote'] = lote

            self.write(cr, uid, ids, vals, context=context)

        except Exception as erro:
            if str(erro).find('certificate expired') >= 1:
                erro = _('Certificado digital com validade vencida.')
            print_log(erro, 'E')
            vals = {'supcap_state': '2E',
                    'supcap_status': """%s""" % str(erro)[:399].replace('"', '').replace("'", ''),
                    'supcap_xml_gerado': xml}
            if lote:
                vals['supcap_lote'] = lote

            self.write(cr, uid, ids, vals, context=context)

        else:
            if processo.resposta.cStat.valor == u'105':  # Lote em processamento
                vals = {'supcap_state': '4',
                        'supcap_lote': processo.envio.idLote.valor,
                        'supcap_status': '105 - Lote em Processamento',
                        'supcap_xml_gerado': xml}
                self.write(cr, uid, ids, vals, context=context)

            elif processo.resposta.cStat.valor == u'104':  # Lote processado
                protocolo = processo.resposta.protNFe
                chave_acesso = protocolo.infProt.chNFe.valor
                procnfce = ProcNFCe()
                procnfce.NFe.xml = str(nfce.xml)
                procnfce.protNFe.xml = str(protocolo.xml)
                if protocolo.infProt.cStat.valor == u'100':
                    # Nota fiscal faturada!
                    vals = {'supcap_lote': processo.envio.idLote.valor,
                            'supcap_protocolo': protocolo.infProt.nProt.valor,
                            'supcap_status': '%s - %s.' % (protocolo.infProt.cStat.valor,
                                                           protocolo.infProt.xMotivo.valor),
                            'supcap_xml_proc': procnfce.xml,
                            'supcap_state': '3',
                            'supcap_xml_gerado': xml,
                            'supcap_data_fim': datetime.now(),
                            'supcap_chave_acesso': chave_acesso}
                    self.write(cr, uid, ids, vals, context=context)

                elif protocolo.infProt.cStat.valor == u'204':  # Duplicidade de nota fiscal
                    # Consultar o lote
                    lote = re.sub('[^0-9]', '', brw_capa.supcap_lote or lote or protocolo.infProt.xMotivo.valor or '')
                    if lote:
                        processo = proc_nfce.process.consultar_recibo(lote)

                    if lote and processo.resposta and processo.resposta.protNFe:
                        protocolo = processo.resposta.protNFe[0]  # Somente uma nota foi enviada
                        vals = {'supcap_lote': processo.envio.idLote.valor,
                                'supcap_protocolo': protocolo.infProt.nProt.valor,
                                'supcap_chave_acesso': chave_acesso,
                                'supcap_status': '%s - %s.' % (protocolo.infProt.cStat.valor,
                                                               protocolo.infProt.xMotivo.valor),
                                'supcap_xml_proc': procnfce.xml,
                                'supcap_xml_gerado': xml, }
                        if protocolo.infProt.cStat.valor == u'100':
                            vals.update({'supcap_state': '3'})
                            self.write(cr, uid, ids, vals, context=context)
                        else:  # contingencia
                            vals.update({'supcap_state': '2E'})
                            self.write(cr, uid, ids, vals, context=context)
                    else:
                        status = '%s - %s.' % (protocolo.infProt.cStat.valor,
                                               protocolo.infProt.xMotivo.valor)
                        vals = {'supcap_chave_acesso': chave_acesso,
                                'supcap_status': status,
                                'supcap_xml_proc': procnfce.xml,
                                'supcap_xml_gerado': xml, }
                        if lote:
                            vals['supcap_lote'] = lote
                        if protocolo.infProt.cStat.valor == u'100':
                            if not protocolo.infProt.xMotivo.valor:
                                vals.update({'supcap_status': '%s - %s.' %
                                                              ('100', 'Autorizado o uso da NF-e.')})

                            vals.update({'supcap_state': '3'})
                            self.write(cr, uid, ids, vals, context=context)
                        else:  # contingencia
                            vals.update({'supcap_state': '2E'})
                            self.write(cr, uid, ids, vals, context=context)

                elif protocolo.infProt.cStat.valor == u'213':
                    msg = 'Cnpj cadastrado diferente do certificado digital'
                    vals = {'supcap_status': msg,
                            'supcap_state': '2E',
                            'supcap_xml_gerado': xml}
                    if lote:
                        vals['supcap_lote'] = lote

                    self.write(cr, uid, ids, vals, context=context)
                elif protocolo.infProt.cStat.valor == u'228':  # Data de emissao atrasada
                    # Consultar o lote
                    processo = proc_nfce.process.consultar_recibo(brw_capa.supcap_lote)
                    protocolo = processo.resposta.protNFe[0]  # Somente uma nota foi enviada
                    vals = {'supcap_protocolo': protocolo.infProt.nProt.valor,
                            'supcap_status': '%s - %s.' % (protocolo.infProt.cStat.valor,
                                                           protocolo.infProt.xMotivo.valor),
                            'supcap_xml_proc': procnfce.xml,
                            'supcap_xml_gerado': xml, }
                    if lote:
                        vals['supcap_lote'] = lote
                    if protocolo.infProt.cStat.valor == u'100':
                        vals['supcap_state'] = '3'
                        self.write(cr, uid, ids, vals, context=context)
                    else:  # contingencia
                        vals['supcap_state'] = '2E'
                        self.write(cr, uid, ids, vals, context=context)
                elif protocolo.infProt.cStat.valor in (u'110', u'205', u'301', u'302', u'303'):
                    # Nota fiscal denegada
                    vals = {'supcap_status': '%s - %s.' % (protocolo.infProt.cStat.valor,
                                                           protocolo.infProt.xMotivo.valor),
                            'supcap_state': 'D',
                            'supcap_xml_gerado': xml, }
                    self.write(cr, uid, ids, vals, context=context)
                else:  # Lote processado mas, houve erro
                    vals = {'supcap_status': '%s - %s.' % (protocolo.infProt.cStat.valor,
                                                           protocolo.infProt.xMotivo.valor),
                            'supcap_state': '2E',
                            'supcap_xml_gerado': xml}
                    self.write(cr, uid, ids, vals, context=context)

            elif processo.resposta.cStat.valor == u'999':  # erro interno no sefaz ou sem internet
                motivo = u'Rejeicao: %s - %s.' % (processo.resposta.cStat.valor,
                                                 processo.resposta.xMotivo.valor)
                vals = {'supcap_state': '4',
                        'supcap_status': motivo}
                if lote:
                    vals['supcap_lote'] = lote
                self.write(cr, uid, ids, vals, context=context)
            else:
                vals = {'supcap_state': '2E',
                        'supcap_xml_gerado': xml, }
                if lote:
                    vals['supcap_lote'] = lote

                if not processo.resposta.cStat.valor:
                    vals['supcap_status'] = 'Erro interno na SEFAZ. Tente novamente.'
                else:
                    vals['supcap_status'] = '%s - %s.' % (processo.resposta.cStat.valor,
                                                          processo.resposta.xMotivo.valor)

                self.write(cr, uid, ids, vals, context=context)

        return True

    def gerar_nfce(self, cr, uid, brw_config, brw_capa, ambiente, context):
        """
        Gera o XML da nota fiscal eletronica (saida)
        """
        nfe = NFCe()
        if not brw_capa.supcap_xml_gerado:
            raise osv.except_osv(_('Atencao!'),
                                 _('Nota sem xml!'))

        nfe.xml = str(brw_capa.supcap_xml_gerado)
        self._fisnfc_set_nfe_infnfe(cr, uid, brw_config, brw_capa, nfe, context)
        nfe.chave = nfe.infNFe.Id.valor[3:]
        nfe.infNFe.ide.cNF.valor = nfe.chave[35:43]
        # nfe.monta_chave()
        # nfe.infNFe.ide.cDV.valor = nfe.infNFe.Id.valor[-1]
        self.fisnfc_set_nfe_infnfesupl(brw_config, brw_capa, nfe, ambiente)
        return nfe

    def fisnfc_set_nfe_infnfesupl(self, brw_config, brw_capa, nfe, ambiente):
        """
        Atribui os valores do QR-Code e da URL de consulta por chave da NFC-e.
        """
        # //NFe.infNFeSupl - Informacoes complementares da NFC-e
        uf = brw_config.supcfc_estado
        nfe.chave or nfe.gera_nova_chave()
        versao = '4.00'
        nfe.infNFeSupl.qrCode.valor = self._qrcode_v2(brw_config, brw_capa, nfe, uf, versao, ambiente)
        nfe.infNFeSupl.urlChave.valor = ESTADO_WS[versao][uf][ambiente][WS_CONSULTA_CHAVE][
            'url']

    def _qrcode_v2(self, brw_config, brw_capa, nfce, uf, versao, ambiente):
        """
        Constroi texto do QR-Code versao 2.0 da nota fiscal de consumidor.

        :param cr: cursor do banco de dados
        :param user: ID do usuario utilizado para a verificacao de perfil
        :param nf: dados da nota fiscal (browse)
        :param nfce: objeto nota fiscal eletronica - NFe()
        :param context: um dicionario padrao para valores contextuais
        :type cr: object
        :type user: int
        :type nf: browse
        :type nfce: NFCe
        :type context: dict
        :return: texto com o QR-Code a ser impresso no DANFE NFC-e.
        :rtype: str
        """
        nfce.chave or nfce.gera_nova_chave()
        url_qrcode = ESTADO_WS[versao][uf][ambiente][WS_CONSULTA_QRCODE]['url'] or u''
        csc = brw_config.supcfc_csc or u''
        csc_id = 1 if csc else 2
        if ambiente == HOMOLOGACAO:
            csc_id = 1
        csc = [csc_id, csc]

        # DigestValue em funcao da contingencia OFFLINE
        if nfce.chave[34] in ('5', '9'):
            # Assina a NFC-e para recuperar o DigestValue
            certificado = Certificado()
            certificado.certificado = brw_config.supcfc_certificado_conteudo
            certificado.chave = brw_config.supcfc_chave_conteudo
            certificado.assina_xmlnfe(nfce)
            result = qr_code.qrcode_v2_offline(ambiente, url_qrcode, nfce.chave,
                                               nfce.Signature.DigestValue, csc,
                                               datetime.strptime(brw_capa.supcap_data_cupom, '%Y-%m-%d').day,
                                               brw_capa.supcap_total_cupom)
        else:
            result = qr_code.qrcode_v2_online(ambiente, url_qrcode, nfce.chave, csc)

        return result

    def _fisnfc_set_nfe_infnfe(self, cr, uid, brw_config, brw_capa, nfe, context):
        context = context and context.copy() or {}
        # Identificacao da nota
        self._fisnfc_set_nfe_infnfe_ide(cr, uid, brw_config, brw_capa, nfe, context)

        # Dados do emitente
        self._fisnfc_set_nfe_infnfe_emit(cr, uid, brw_capa, brw_config, nfe)

        # Dados do destinatario
        self._fisnfc_set_nfe_infnfe_dest(cr, uid, brw_capa, nfe)

        # Autorizados download XML
        self._fisnfc_set_nfe_infnfe_autxml(brw_config, nfe)

        # Dados de pagamento
        self._fisnfc_set_nfe_infnfe_pag(cr, brw_capa, nfe)

        # todo: verificar a tranportadora
        # Dados da transportadora
        self._fisnfc_set_nfe_infnfe_transp(nfe)

        # Itens da NF
        self._fisnfc_set_nfe_infnfe_prod(cr, uid, brw_config, brw_capa, nfe, context)

        # Total produtos
        self._fisnfc_set_nfe_infnfe_total_icmstot(brw_capa, nfe)

    def _fisnfc_set_nfe_infnfe_ide(self, cr, uid, brw_config, brw_capa, nfe, context):
        # //NFe.infNFe.Ide - Identificacao da NF-e
        # nfe.infNFe.ide.cUF.valor = UF_CODIGO.get(brw_config.supcfc_estado) or False
        # nfe.infNFe.ide.cNF.valor = str(brw_capa.id)[:8].zfill(8)
        nfe.infNFe.ide.natOp.valor = 'Venda para consumidor final'
        # nfe.infNFe.ide.mod.valor = 65
        # nfe.infNFe.ide.serie.valor = brw_capa.supcap_caixa
        # nfe.infNFe.ide.nNF.valor = brw_capa.supcap_nro_cupom
        nfe.infNFe.ide.procEmi.valor = 0  # 0=Emissao de NF-e com aplicativo do contribuinte;
        data = datetime.strptime(brw_capa.supcap_data_fim[:19],
                                                       '%Y-%m-%d %H:%M:%S')
        data = self.pool.get('supervisor.util').suputi_converte_tz(cr, uid, data, tz_origem='UTC',
                                                       tz_destino=context.get('tz'))
        # nfe.infNFe.ide.dhEmi.valor = data
        nfe.infNFe.ide.indPres.valor = '1' or '4'  # 4 = em operacao com entrega a domicilio
        nfe.infNFe.ide.tpNF.valor = 1  # 1 = Saida
        nfe.infNFe.ide.idDest.valor = 1  # 1 = Venda no estado
        nfe.infNFe.ide.cMunFG.valor = brw_config.supcfc_cidade_ibge
        nfe.infNFe.ide.tpImp.valor = '4'  # 4 = DANFE NFC-e
        nfe.infNFe.ide.verProc.valor = nfe.arquivo_esquema.split('.')[0]
        # nfe.infNFe.ide.tpEmis.valor = 9  # 1 = Emissao normal, 5 e 9 = contingencias
        nfe.infNFe.ide.dhCont.valor = data
        nfe.infNFe.ide.xJust.valor = 'Sem conexao com a SEFAZ'
        nfe.infNFe.ide.tpAmb.valor = brw_config.supcfc_ambiente == 'P' and 1 or 2
        nfe.infNFe.ide.indFinal.valor = u'1'  # 1 = Consumidor final
        nfe.infNFe.ide.finNFe.valor = 1  # 1 = NF-e normal

    def _fisnfc_set_nfe_infnfe_emit(self, cr, uid, brw_capa, brw_config, nfe):
        # //NFe.infNFe.emit - Dados do emitente
        msg = []
        if not brw_config.supcfc_cnpj:
            msg.append('CNPJ')
        if not brw_config.supcfc_cliente:
            msg.append('Nome')

        if msg:
            msg = 'Dados da empresa incompletos:\n%s' % ',\n'.join(msg)
            self.write(cr, uid, brw_capa.id, {'supcap_state': '2E',
                                              'supcap_status': msg}, {})
            cr.execute('COMMIT;')
            raise osv.except_osv(_('Atencao!'), msg)

        obj_sup_util = self.pool.get('supervisor.util')
        cnpj = brw_config.supcfc_cnpj or u''
        nfe.infNFe.emit.CNPJ.valor = re.sub('[^0-9]', u'', cnpj[-14:])
        nfe.infNFe.emit.xNome.valor = obj_sup_util.suputi_remover_acentuacao(
                                         (brw_config.supcfc_cliente or u'').replace(u'\u2013', '-'))
        nfe.infNFe.emit.IE.valor = re.sub('[^0-9A-Z]', u'',
                                          brw_config.supcfc_inscricao_estadual or u'')
        nfe.infNFe.emit.xFant.valor = obj_sup_util.suputi_remover_acentuacao(
                                         (brw_config.supcfc_fantasia or u''))
        if brw_config.supcfc_inscricao_municipal:
            nfe.infNFe.emit.IM.valor = brw_config.supcfc_inscricao_municipal or u''

        nfe.infNFe.emit.enderEmit.fone.valor = \
            re.sub('[^0-9]', u'', str(brw_config.supcfc_telefone) or u'')
        nfe.infNFe.emit.CRT.valor = brw_config.supcfc_regime_tributario == 'S' and 1 or 3
        self._fisnfc_set_nfe_infnfe_emit_enderemit(cr, uid, brw_config, nfe)

    def _fisnfc_set_nfe_infnfe_emit_enderemit(self, cr, uid, brw_config, nfe):
        # //NFe.infNFe.emit.enderEmit - Endereco do emitente
        obj_sup_util = self.pool.get('supervisor.util')
        endereco = obj_sup_util.suputi_remover_acentuacao(brw_config.supcfc_endereco or '')
        complemento = obj_sup_util.suputi_remover_acentuacao(brw_config.supcfc_complemento or '')
        bairro = obj_sup_util.suputi_remover_acentuacao(brw_config.supcfc_bairro or u'Bairro')
        cidade = obj_sup_util.suputi_remover_acentuacao(brw_config.supcfc_cidade or '')
        nfe.infNFe.emit.enderEmit.xLgr.valor = endereco
        nfe.infNFe.emit.enderEmit.nro.valor = u'%s' % brw_config.supcfc_numero
        nfe.infNFe.emit.enderEmit.xCpl.valor = complemento
        nfe.infNFe.emit.enderEmit.xBairro.valor = bairro
        nfe.infNFe.emit.enderEmit.xMun.valor = cidade
        nfe.infNFe.emit.enderEmit.cMun.valor = brw_config.supcfc_cidade_ibge or 0
        nfe.infNFe.emit.enderEmit.UF.valor = brw_config.supcfc_estado or u''
        nfe.infNFe.emit.enderEmit.cPais.valor = int('01058'[-4:]) or 0
        nfe.infNFe.emit.enderEmit.xPais.valor = u'Brasil'
        nfe.infNFe.emit.enderEmit.CEP.valor = re.sub('[^0-9]', u'',
                                                     brw_config.supcfc_cep or u'')

    def _fisnfc_set_nfe_infnfe_dest(self, cr, uid, brw_capa, nfe):
        # //NFe.infNFe.dest - Dados do destinatário
        brw_cliente = False
        if brw_capa.supcap_cliente:
            obj_cliente = self.pool.get('supervisor.cad.clientes')
            cliente_ids = obj_cliente.search(cr, uid,
                                    [('supcli_cnpj_cpf', '=', brw_capa.supcap_cliente)], context={})
            if cliente_ids:
                brw_cliente = obj_cliente.browse(cr, uid, cliente_ids[0], context={})


        if nfe.infNFe.ide.tpAmb.valor == 2:
            nfe.infNFe.dest.xNome.valor = u'NF-E EMITIDA EM AMBIENTE DE HOMOLOGACAO - SEM VALOR ' \
                                          u'FISCAL'
        else:
            # Se nao houver destinatario (NFC-e) assume 'CONSUMIDOR NAO IDENTIFICADO'
            nome_consumidor = brw_cliente and brw_cliente.name or 'CONSUMIDOR NAO IDENTIFICADO'
            nfe.infNFe.dest.xNome.valor = nome_consumidor

        nfe.infNFe.dest.email.valor = brw_cliente and brw_cliente.supcli_email or u''
        nfe.infNFe.dest.indIEDest.valor = u'9'  # 9 = Nao contribuinte
        self._fisnfc_set_nfe_infnfe_dest_enderdest(brw_cliente, nfe)
        cnpj_cpf = brw_cliente and brw_cliente.supcli_cnpj_cpf
        if brw_cliente and brw_cliente.supcli_tipo_pessoa == u'J':
            nfe.infNFe.dest.CNPJ.valor = re.sub('[^0-9]', u'', cnpj_cpf[-14:] or u'')

        elif cnpj_cpf:
            nfe.infNFe.dest.CPF.valor = re.sub('[^0-9]', u'', cnpj_cpf[-11:] or u'') or u''

        elif not cnpj_cpf: # limpa o cliente se o mesmo for apagado do xml
            if nfe.infNFe.dest.CNPJ.valor:
                nfe.infNFe.dest.CNPJ.valor = ''
            if nfe.infNFe.dest.CPF.valor:
                nfe.infNFe.dest.CPF.valor = ''

    def _fisnfc_set_nfe_infnfe_dest_enderdest(self, brw_cliente, nfe):
        # //NFe.infNFe.dest.enderDest - Endereco do destinatario
        if not brw_cliente or not brw_cliente.supcli_endereco \
                or not brw_cliente.supcli_endereco_numero \
                or not brw_cliente.supcli_cidade \
                or not brw_cliente.supcli_cod_municipio or not int(brw_cliente.supcli_cod_municipio) \
                or not brw_cliente.supcli_estado:
            return False

        nfe.infNFe.dest.enderDest.xLgr.valor = brw_cliente and brw_cliente.supcli_endereco or u''
        nfe.infNFe.dest.enderDest.nro.valor = brw_cliente and brw_cliente.supcli_endereco_numero or u''
        nfe.infNFe.dest.enderDest.xBairro.valor = brw_cliente and brw_cliente.supcli_bairro or u'Bairro'
        nfe.infNFe.dest.enderDest.cMun.valor = brw_cliente and brw_cliente.supcli_cod_municipio or u''
        nfe.infNFe.dest.enderDest.xMun.valor = brw_cliente and brw_cliente.supcli_cidade or u''
        nfe.infNFe.dest.enderDest.UF.valor = brw_cliente and brw_cliente.supcli_estado or u''
        nfe.infNFe.dest.enderDest.xCpl.valor = u''
        nfe.infNFe.dest.enderDest.CEP.valor = re.sub('[^0-9]', u'',
                                                     brw_cliente and brw_cliente.supcli_cep
                                                     or u'')
        telefone = brw_cliente and brw_cliente.supcli_telefone or u''
        nfe.infNFe.dest.enderDest.fone.valor = re.sub('[^0-9]', u'', telefone)
        nfe.infNFe.dest.enderDest.cPais.valor = int('01058'[-4:]) or 0
        nfe.infNFe.dest.enderDest.xPais.valor = u'Brasil'
        return True

    def _fisnfc_set_nfe_infnfe_autxml(self, brw_config, nfe):
        nfe.infNFe.autXML = []
        # //NFe.infNFe.autXML - Pessoas autorizadas para o download do XML da NF-e
        if nfe.infNFe.emit.enderEmit.UF.valor == 'BA':  # Contemplado apenas pela Bahia
            if (nfe.infNFe.dest.CPF.valor or nfe.infNFe.dest.CNPJ.valor) != u'13937073000156':
                autxml = AutXML()
                autxml.CNPJ.valor = '13937073000156'  # CNPJ da SEFAZ Bahia
                nfe.infNFe.autXML.append(autxml)

        # CNPJ da Sig para consultar notas dos clientes.
        if nfe.infNFe.ide.tpAmb.valor == 1: # apenas em producao
            autxml = AutXML()
            autxml.CNPJ.valor = '01526558000178'
            nfe.infNFe.autXML.append(autxml)

        cnpj = brw_config.supcfc_contador_cnpj or ''
        cpf = brw_config.supcfc_contador_cpf or ''
        if cnpj and cnpj != nfe.infNFe.dest.CNPJ.valor:
            autxml = AutXML()
            autxml.CNPJ.valor = cnpj
            nfe.infNFe.autXML.append(autxml)

        elif cpf and cpf != nfe.infNFe.dest.CPF.valor:
            autxml = AutXML()
            autxml.CPF.valor = cpf
            nfe.infNFe.autXML.append(autxml)

    def _fisnfc_set_nfe_infnfe_pag(self, cr, brw_capa, nfe):
        # //NFe.infNFe.pag - Dados de pagamento
        # {'01': 'Dinheiro',
        #  '02': 'Cheque',
        #  '03': 'Cartão de Crédito',
        #  '04': 'Cartão de Débito',
        #  '05': 'Crédito Loja',
        #  '10': 'Vale Alimentação',
        #  '11': 'Vale Refeição',
        #  '12': 'Vale Presente',
        #  '13': 'Vale Combustível',
        #  '99': 'Outros'}
        cr.execute("""
                    SELECT ccf.supfin_avista_aprazo     AS avista,
                           ccf.supfin_cartao_tipo       AS tipo_cartao,
                           ccf.supfin_tipo_finalizadora AS tipo_fin,
                           ccf.supfin_usa_tef           AS usa_tef,
                           scb.supban_tipo              AS tipo_ban,
                           scb.name                     AS nome_ban,
                           cmf.supfec_valor             AS valor,
                           cmf.supfec_troco             AS troco,
                           cmf.supfec_cnpj_cartao       AS cnpj_fec,
                           cmf.supfec_aut_cartao        AS aut_cartao,
                           cmf.supfec_nome_finalizadora AS nome_fin,
                           coc.supopc_cnpj              AS cnpj_op
                    FROM supervisor_mov_fechamentos            AS cmf
                    INNER JOIN supervisor_cad_finalizadora     AS ccf ON ccf.supfin_codigo = cmf.supfec_finalizadora
                    LEFT  JOIN supervisor_cad_bandeiras        AS scb ON scb.id = ccf.supfin_bandeira_cre
                    LEFT  JOIN supervisor_cad_operadora_cartao AS coc ON coc.id = ccf.supfin_operadora_id
                    WHERE cmf.supfec_capa_id = %s """ % brw_capa.id)
        dados_pag = cr.dictfetchall()
        troco = 0
        nfe.infNFe.pag.detPag = []
        for condicao in dados_pag:
            troco += (condicao.get('troco') or 0)
            detpag = DetPag()

            avista = 0
            if condicao.get('avista') == 'P':  # a prazo
                avista = 1

            hoje = str(datetime.now())
            homologacao = nfe.infNFe.ide.tpAmb.valor == 2
            detpag.indPag.valor = str(avista)  # 0=A vista ,1=A Prazo ,2=Outros
            tipo_pagamento = u'01'  # Dinheiro
            if condicao.get('tipo_fin') == 'H':
                tipo_pagamento = u'02'  # cheque
            elif condicao.get('tipo_fin') in ('C', 'T'):  # cartao e ticket
                if condicao.get('tipo_cartao') == 'C':
                    tipo_pagamento = u'03'  # credito
                    if condicao.get('tipo_ban') == 'O': # Carteira digital
                        detpag.indPag.valor = str(0)
                        if hoje >= '2021-09-01' or homologacao:
                            tipo_pagamento = u'18'
                        if (condicao.get('nome_ban') or '').upper() == 'PIX' and \
                                (hoje >= '2021-09-01' or homologacao):  # PIX
                            tipo_pagamento = u'01'

                else:
                    tipo_pagamento = u'04'  # debto

            elif condicao.get('tipo_fin') == 'O':
                tipo_pagamento = u'99'  # outros
                detpag.xPag.valor = (condicao.get('nome_fin') or '')[:60]

            detpag.tPag.valor = tipo_pagamento
            detpag.vPag.valor = '%.2f' % condicao.get('valor')
            if detpag.tPag.valor in (u'03', u'04'):  # Cartao credito/debito
                cnpj = condicao.get('cnpj_fec') or condicao.get('cnpj_op') or u''
                if cnpj:
                    cnpj = cnpj.rjust(14, '0')

                detpag.card.tpIntegra.valor = condicao.get('usa_tef') and 1 or 2  # 1=TEF, 2=POS
                detpag.card.CNPJ.valor = cnpj
                detpag.card.cAut.valor = condicao.get('aut_cartao') or u'123456'

            nfe.infNFe.pag.detPag.append(detpag)

        if troco:
            nfe.infNFe.pag.vTroco.valor = Decimal(troco).quantize(TWOPLACES)

    def _fisnfc_set_nfe_infnfe_transp(self, nfe):
        # //NFe.infNfE.transp - Dados da transportadora
        load = '_classic_write'

        # O DANFE da versao 4.0 ainda nao contempla todas as opcoes de frete
        # frete = {'0': u'0', '1': u'1', '2': u'2', '3': u'0', '4': u'1'}.get(dados_nf.get('frete'))
        # todo: quando tiver frete, tratar o frete
        nfe.infNFe.transp.modFrete.valor = u'9'
        return True

        # if dados_nf.get('transportador_id') and dados_nf.get('frete') != u'9':
        #     campos = ['name', 'pessoa_id', 'admtra_annt']
        #     dados_transp = self.pool.get('adm.transportador').read(
        #         cr, user, dados_nf.get('transportador_id'), campos, context, load)
        #     campos = ['endereco_nf_id', 'pessoa_tipo', 'cpf_cnpj', 'admpes_jur_ie',
        #               'endereco_ids']
        #     pessoa_transp = self.pool.get('adm.pessoa').read(
        #         cr, user, dados_transp.get('pessoa_id'), campos, context, load)
        #     nfe.infNFe.transp.transporta.xNome.valor = (dados_transp.get('name') or u'')[:45]
        #     if pessoa_transp.get('pessoa_tipo') == 'J':
        #         nfe.infNFe.transp.transporta.CNPJ.valor = re.sub(
        #             '[^0-9]', u'', pessoa_transp.get('cpf_cnpj') or u'')
        #         nfe.infNFe.transp.transporta.IE.valor = re.sub(
        #             '[^0-9A-Z]', u'', pessoa_transp.get('admpes_jur_ie') or '').upper()
        #     else:
        #         nfe.infNFe.transp.transporta.CPF.valor = re.sub(
        #             '[^0-9A-z]', u'', pessoa_transp.get('cpf_cnpj') or u'')
        #     if pessoa_transp:
        #         obj_endereco = self.pool.get('adm.pessoa.endereco')
        #         campos = ['logradouro_id', 'cidade_id']
        #         ender_transp = pessoa_transp.get('endereco_nf_id') and obj_endereco.read(
        #             cr, user, pessoa_transp.get('endereco_nf_id'), campos, context, load) or {}
        #         ender_transp = ender_transp or obj_endereco.read(
        #             cr, user, pessoa_transp.get('endereco_ids')[0], campos, context, load)
        #         campos = ['titulo', 'descricao']
        #         logradouro = ender_transp.get('logradouro_id') and self.pool.get(
        #             'adm.logradouro').read(
        #             cr, user, ender_transp.get('logradouro_id'), campos, context) or {}
        #         campos = ['uf_id', 'name']
        #         cidade = ender_transp.get('cidade_id') and self.pool.get('adm.cidade').read(
        #             cr, user, ender_transp.get('cidade_id'), campos, context, load) or {}
        #         uf = cidade.get('uf_id') and self.pool.get('adm.uf').read(
        #             cr, user, cidade.get('uf_id'), ['sigla'], context) or {}
        #         nfe.infNFe.transp.transporta.xEnder.valor = \
        #             logradouro and ((logradouro.get('titulo') or u'') + u' ' +
        #                             (logradouro.get('descricao') or u'')).strip() or u''
        #         nfe.infNFe.transp.transporta.xMun.valor = cidade.get('name') or u''
        #         nfe.infNFe.transp.transporta.UF.valor = uf.get('sigla') or u''
        #
        # self._fisnfc_set_nfe_infnfe_transp_vol(cr, user, dados_nf, nfe, context)

    # def _fisnfc_set_nfe_infnfe_transp_vol(self, cr, user, dados_nf, nfe, context=None):
    #     # //NFe.infNFe.transp.vol - Dados dos volumes
    #     context = context and context.copy() or {}
    #     vol = Vol()
    #     vol.qVol.valor = dados_nf.get('quantidade_volume') or 0
    #     vol.esp.valor = dados_nf.get('especie') or u''
    #     vol.marca.valor = dados_nf.get('marca') or u''
    #     vol.nVol.valor = dados_nf.get('numero_volume') or u''
    #     vol.pesoB.valor = '%.3f' % dados_nf.get('peso_bruto') or 0
    #     vol.pesoL.valor = '%.3f' % dados_nf.get('peso_liquido') or 0
    #     nfe.infNFe.transp.vol.append(vol)

    def _fisnfc_set_nfe_infnfe_prod(self, cr, uid, brw_config, brw_capa, nfe, context):
        # //NFe.infNFe.prod - Itens da nota fiscal
        nfe.infNFe.det = []
        tot_ncm_vr_tributo_fed = tot_ncm_vr_tributo_est = tot_ncm_vr_tributo_mun = 0
        ncm_chave = u''
        self.total_aproveitamento_credito = 0
        cr.execute("""
                        SELECT smc.*, 
                               supcor_codigo_retaguarda     AS codigo_interno,
                               supcor_codigo_anp            AS codigo_anp,
                               supcor_adrem                 AS adrem,
                               supcor_pglp                  AS pglp,
                               supcor_pgnn                  AS pgnn,
                               supcor_pgni                  AS pgni,
                               supcor_vpart                  AS vpart,
                               supcor_producao              AS producao,
                               supcor_unidade               AS unidade,
                               supcor_origem_mercadoria     AS origem_mercadoria,
                               supcor_aliquota_ibpt_fed     AS supcor_aliquota_ibpt_fed,
                               supcor_aliquota_ibpt_est     AS supcor_aliquota_ibpt_est,
                               supcor_aliquota_ibpt_mun     AS supcor_aliquota_ibpt_mun,
                               supcor_getin                 AS supcor_getin,
                               supcor_codigo_trib_icms      AS codigo_icms,
                               supcor_codigo_cst_icms       AS codigo_cst,
                               supcor_tipo_tributacao_icms  AS tipo_trib,
                               supcor_codigo_csosn_icms     AS csosn,
                               supcor_base_icms             AS base_icms,
                               suptnf_base                  AS percent_base_icms,
                               supcor_aliquota_icms         AS aliquota_icms,
                               supcor_codigo_beneficio_icms AS cod_beneficio,
                               supcor_motivo_beneficio_icms AS mot_beneficio,
                               supcor_aliquota_fcp_icms     AS aliquota_fcp,
                               supcor_codigo_trib_pis       AS codigo_pis,
                               supcor_aliquota_pis          AS aliquota_pis,
                               supcor_codigo_cst_pis        AS codigo_cst_pis,
                               supcor_base_pis              AS base_pis,
                               supcor_codigo_trib_cofins    AS codigo_cofins,
                               supcor_aliquota_cofins       AS aliquota_cofins,
                               supcor_codigo_cst_cofins     AS codigo_cst_cofins,
                               supcor_base_cofins           AS base_cofins,
                               supite_med_codigo_anvisa     AS med_codigo_anvisa,
                               supite_med_motivo_isencao    AS med_motivo_isencao,
                               supite_med_preco_maximo      AS med_preco_maximo,
                               supite_fator_multiplicador   AS fator_multiplicador

                        FROM supervisor_mov_corpos                AS smc
                        LEFT JOIN supervisor_cad_tributacao_nfce AS cct ON cct.suptnf_codigo = smc.supcor_codigo_trib_icms
                        LEFT JOIN supervisor_cad_itens           AS sci ON sci.supite_codigo_item = smc.supcor_item
                        WHERE smc.supcor_capa_id = {capa_id}
                          AND smc.supcor_venda_cancelamento = 'V'
                          AND sci.supite_loja = {loja}
                        ORDER BY smc.supcor_sequencia""".format(capa_id=brw_capa.id,
                                                                loja=brw_config.supcfc_loja))
        dados_itens = cr.dictfetchall()
        numero_item = 1
        for item in dados_itens:
            if item.get('supcor_item') and item.get('supcor_getin'):
                codigo_barra = item.get('supcor_item')
                # Na nota 4.0 o primeiro digito do codigo de barras nao pode ser 0 quando tiver
                # 14 digitos, o primeiro digito deve ser de 1 a 9 que indicara a quantidade na
                # embalagem
                if len(codigo_barra) == 14:
                    if codigo_barra[0] == '0':
                        codigo_barra = codigo_barra[1:]

                p_cean = codigo_barra
                if int(p_cean) < 10000000:
                    p_cean = u'SEM GTIN'

            else:
                p_cean = u'SEM GTIN'

            ncm_vr_tributo_fed = 0
            if item.get('supcor_aliquota_ibpt_fed') > 0:
                ncm_vr_tributo_fed = Decimal(item.get('supcor_quantidade')) * Decimal(item.get(
                    'supcor_preco_unitario'))
                ncm_vr_tributo_fed *= Decimal(item.get('supcor_aliquota_ibpt_fed') or 0)
                ncm_vr_tributo_fed /= Decimal(100)

            ncm_vr_tributo_est = Decimal(item.get('supcor_quantidade')) * Decimal(item.get(
                'supcor_preco_unitario'))
            ncm_vr_tributo_est *= Decimal(item.get('supcor_aliquota_ibpt_est') or 0)
            ncm_vr_tributo_est /= Decimal(100)
            ncm_vr_tributo_mun = Decimal(item.get('supcor_quantidade')) * Decimal(item.get(
                'supcor_preco_unitario'))
            ncm_vr_tributo_mun *= Decimal(item.get('supcor_aliquota_ibpt_mun') or 0)
            ncm_vr_tributo_mun /= Decimal(100)
            if not ncm_chave:
                ncm_chave = item.get('fisnc_ibpt_chave') or u''

            tot_ncm_vr_tributo_fed += Decimal(ncm_vr_tributo_fed)
            tot_ncm_vr_tributo_est += Decimal(ncm_vr_tributo_est)
            tot_ncm_vr_tributo_mun += Decimal(ncm_vr_tributo_mun)
            p_ucom = item.get('unidade')
            p_qcom = '%.3f' % item.get('supcor_quantidade')
            p_vuncom = '%f' % item.get('supcor_preco_unitario')
            p_vuncom = p_vuncom.rstrip('0')  # Desconsidera zeros aa direita
            _valor = item.get('supcor_preco_total')
            p_vprod = '%.2f' % _valor
            p_ceantrib = p_cean
            det = Det()
            det.nItem.valor = numero_item
            numero_item += 1
            det.prod.cProd.valor = item.get('codigo_interno') or u''
            det.prod.cEAN.valor = p_cean or u''

            # Se NFC-e em ambiente de homologacao, a descricao do primeiro item deve ser
            # obrigatoriamente NOTA FISCAL EMITIDA EM AMBIENTE DE HOMOLOGACAO - SEM VALOR FISCAL
            nome_item = u'NOTA FISCAL EMITIDA EM AMBIENTE DE HOMOLOGACAO - SEM VALOR FISCAL'
            if item == dados_itens[0] and nfe.infNFe.ide.tpAmb.valor == 2:  # Homologacao
                det.prod.xProd.valor = u'NOTA FISCAL EMITIDA EM AMBIENTE DE HOMOLOGACAO - SEM ' \
                                       u'VALOR FISCAL'
            else:
                nome_item = (item.get('supcor_nome_item') or u'').replace('&', '&amp;')
                det.prod.xProd.valor = nome_item

            # Tratamento para combustiveis. Verifica se o produto tem CFOP para combustiveis e
            # faz a insercao das tags
            det.prod.NCM.valor = re.sub('[^0-9]', u'', item.get('supcor_ncm') or '') or u''
            if det.prod.NCM.valor[:4] in ('3001', '3002', '3003', '3004', '3005', '3006'):
                det.prod.med.cProdANVISA.valor = item.get('med_codigo_anvisa') or ''
                det.prod.med.xMotivoIsencao.valor = item.get('med_motivo_isencao') or ''
                det.prod.med.vPMC.valor = str(Decimal(item.get('med_preco_maximo')).quantize(TWOPLACES) or 0)

            # todo: verificar nFCI
            # det.prod.nFCI.valor = produto.get('estpro_fci') or u''

            # CFOPS validos 5101; 5102; 5103; 5104; 5115; 5401; 5403; 5405; 5653; 5656; 5667 e 5933
            det.prod.CFOP.valor = item.get('supcor_codigo_cfop')
            if not item.get('tipo_trib'):
                raise osv.except_osv(_('Atencao!'),
                                     _('Tributacao de ICMS nao encontrada ou sem Tipo!'))

            det.prod.uCom.valor = p_ucom or u''
            det.prod.qCom.valor = p_qcom or 0
            det.prod.vUnCom.valor = p_vuncom or 0
            if item.get('supcor_codigo_cfop') == '5656':
                det.prod.comb.cProdANP.valor = item.get('codigo_anp') or 0
                det.prod.comb.descANP.valor = (item.get('supcor_nome_item') or u'').replace('&', '&amp;')
                det.prod.comb.UFCons.valor = brw_config.supcfc_estado
                if item.get('codigo_anp') == 210203001:
                    # apenas para codigo anp 210203001, a unidade tributavel deve ser 'kg',
                    # se nao ocorre a rejeicao '854'
                    p_ucom = 'kg'
                    det.prod.comb.pGLP.valor = Decimal(item.get('pglp') or 0)
                    det.prod.comb.pGNn.valor = Decimal(item.get('pgnn') or 0)
                    det.prod.comb.pGNi.valor = Decimal(item.get('pgni') or 0)
                    det.prod.comb.vPart.valor = Decimal(item.get('vpart') or 0)

            det.prod.vDesc.valor = '%.2f' % (item.get('supcor_desconto_item') or 0)
            # det.prod.vFrete.valor = '%.2f' % item.get('vr_frete_rateado') or 0
            # det.prod.vSeg.valor = '%.2f' % item.get('vr_seguro_rateado') or 0

            det.prod.vOutro.valor = '%.2f' % item.get('supcor_acrescimo_item') or 0
            det.prod.vProd.valor = p_vprod or 0
            det.prod.cEANTrib.valor = p_ceantrib or u''
            det.prod.uTrib.valor = p_ucom or u''
            det.prod.qTrib.valor = '%.3f' % (item.get('supcor_quantidade') *
                                             (item.get('fator_multiplicador') or 1))
            det.prod.vUnTrib.valor = '%.4f' % (det.prod.vProd.valor / det.prod.qTrib.valor)
            det.prod.indTot.valor = 1  # Valor do item entra no valor total da nota, 1-sim, 0-nao

            # //NFe.infNFe.imposto - Encargos e tributacoes
            det.imposto.vTotTrib.valor = '%.2f' % (item.get('supcor_vr_imposto_fed', 0) +
                                                   item.get('supcor_vr_imposto_est', 0) +
                                                   item.get('supcor_vr_imposto_mun', 0))

            if nfe.infNFe.emit.CRT.valor == 1:
                self.set_regime_tributario_simples_nacional(cr, uid, brw_config, det, item)
            else:
                self.set_regime_tributario_outros(cr, uid, det, item, brw_capa)

            nfe.infNFe.det.append(det)

        # Aproveitamento de ICMS para Simples Nacional
        if brw_config.supcfc_valor_faturamento > 0:
            if nfe.infNFe.emit.CRT.valor == 1:
                nfe.infNFe.infAdic.infCpl.valor += \
                    (u'\n Documento emitido por ME ou EPP optante pelo Simples Nacional. - NAO '
                     u'GERA DIREITO DE CREDITO FISCAL DE IPI. - Permite aproveitamento '
                     u'de credito ICMS no valor de R$ %.2f correspondente a aliq. %.2f%% nos '
                     u'termos ART.23 LC123/06') % (
                        self.total_aproveitamento_credito or 0,
                        self._fisnfc_get_aliquota_sn(cr, uid, brw_config))

        total_nf = Decimal(brw_capa.supcap_total_cupom)
        valor_percent_aprox_fed = tot_ncm_vr_tributo_fed / total_nf * Decimal(100)
        valor_percent_aprox_est = tot_ncm_vr_tributo_est / total_nf * Decimal(100)
        valor_percent_aprox_mun = tot_ncm_vr_tributo_mun / total_nf * Decimal(100)
        nfe.infNFe.infAdic.infCpl.valor += \
            (u' \n Trib.Aprox.: R$ %.2f (%.2f%%) federal R$ %.2f (%.2f%%) estadual R$ %.2f '
             u'(%.2f%%) municipal. Fonte IBPT %s') % (
                tot_ncm_vr_tributo_fed, valor_percent_aprox_fed, tot_ncm_vr_tributo_est,
                valor_percent_aprox_est, tot_ncm_vr_tributo_mun, valor_percent_aprox_mun,
                ncm_chave)
        # valor_cfop_por_aliquota = \
        #     self.pool.get('fiscal.nf.item.tributacao').fisnit_get_cfop_por_aliquota(
        #         dados_itens[0].get('tributacoes_ids'))

        # todo: verificar como fazer esta parte
        str_resumo = u''
        # for vcpa in valor_cfop_por_aliquota:
        #     str_resumo += '[%s - CFOP: %s ' % (vcpa.get('encargo'), vcpa.get('cfop'))
        #     if vcpa.get('vr_icms_substituicao'):
        #         str_resumo += ('Substituicao') + ': %s]' % getNumeroEditado(
        #             vcpa.get('vr_icms_substituicao'))
        #         continue
        #     if vcpa.get('vr_isento'):
        #         str_resumo += 'Isentos: %s ' % getNumeroEditado(vcpa.get('vr_isento'))
        #     if vcpa.get('aliquota'):
        #         str_resumo += 'Trib.a: %s%% ' % getNumeroEditado(vcpa.get('aliquota'), 3)
        #     if vcpa.get('vr_base_calculo'):
        #         str_resumo += 'Base: %s ' % getNumeroEditado(vcpa.get('vr_base_calculo'))
        #     if vcpa.get('vr_encargo'):
        #         str_resumo += 'Imp.: %s' % getNumeroEditado(vcpa.get('vr_encargo'))
        #     str_resumo += ']'
        if str_resumo:
            nfe.infNFe.infAdic.infCpl.valor += u'\n Resumo: ' + str_resumo

        total_icms_uf_dest = sum(map(lambda m: float(m.imposto.ICMSUFDest.vICMSUFDest.valor),
                                     nfe.infNFe.det))
        total_fcp = sum(map(lambda m: float(m.imposto.ICMS.vFCP.valor), nfe.infNFe.det))
        if total_icms_uf_dest:
            nfe.infNFe.infAdic.infCpl.valor += (
                                                   u' \n Parcela do diferencial de aliquota devido '
                                                   u'ao estado destino: R$%.2f\n Valor do fundo de '
                                                   u'combate a pobreza: R$%.2f') % (
                                                   total_icms_uf_dest, total_fcp)
        # if self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, user, 'ecf', context):
        #     for cond in dict_condicoes.values():
        #         cond_forma = dict_cond_forma.get(cond.get('condicao_forma_id'))
        #         if cond_forma.get('tipo_finalizadora') == u'C':
        #             nfe.infNFe.infAdic.infCpl.valor += \
        #                 (u'\n Autorizacao do cartao: %s') % cond.get('fiscpg_nro_autorizacao_cartao')

    def _fisnfc_set_nfe_infnfe_total_icmstot(self, brw_capa, nfe, context=None):
        # NFe.infNFe.total.ICMSTot - Total do grupo ICMS - Produtos
        context = context and context.copy() or {}
        nfe.infNFe.total.ICMSTot.vBC.valor = '%.2f' % sum(map(
            lambda m: float(m.imposto.ICMS.vBC.valor), nfe.infNFe.det))
        nfe.infNFe.total.ICMSTot.vICMS.valor = '%.2f' % (sum(map(
            lambda m: float(m.imposto.ICMS.vICMS.valor), nfe.infNFe.det)) or 0)
        nfe.infNFe.total.ICMSTot.vICMSDeson.valor = '%.2f' % sum(map(
            lambda m: float(m.imposto.ICMS.vICMSDeson.valor), nfe.infNFe.det))
        nfe.infNFe.total.ICMSTot.qBCMonoRet.valor = '%.2f' % sum(map(
            lambda m: float(m.imposto.ICMS.qBCMonoRet.valor), nfe.infNFe.det))
        nfe.infNFe.total.ICMSTot.vICMSMonoRet.valor = '%.2f' % sum(map(
            lambda m: float(m.imposto.ICMS.vICMSMonoRet.valor), nfe.infNFe.det))
        nfe.infNFe.total.ICMSTot.vFCP.valor = '%.2f' % sum(map(
            lambda m: float(m.imposto.ICMS.vFCP.valor), nfe.infNFe.det))
        nfe.infNFe.total.ICMSTot.vBCST.valor = '%.2f' % sum(map(
            lambda m: float(m.imposto.ICMS.vBCST.valor), nfe.infNFe.det))
        nfe.infNFe.total.ICMSTot.vST.valor = '%.2f' % sum(map(
            lambda m: float(m.imposto.ICMS.vICMSST.valor), nfe.infNFe.det))
        nfe.infNFe.total.ICMSTot.vFCPST.valor = '%.2f' % sum(map(
            lambda m: float(m.imposto.ICMS.vFCPST.valor), nfe.infNFe.det))
        nfe.infNFe.total.ICMSTot.vProd.valor = '%.2f' % sum(map(
            lambda m: float(m.prod.vProd.valor), nfe.infNFe.det))
        nfe.infNFe.total.ICMSTot.vFrete.valor = '%.2f' % 0
        nfe.infNFe.total.ICMSTot.vSeg.valor = '%.2f' % 0
        nfe.infNFe.total.ICMSTot.vDesc.valor = '%.2f' % sum(map(
            lambda m: float(m.prod.vDesc.valor), nfe.infNFe.det))
        nfe.infNFe.total.ICMSTot.vII.valor = '%.2f' % sum(map(
            lambda m: float(m.imposto.II.vII.valor), nfe.infNFe.det))
        nfe.infNFe.total.ICMSTot.vIPI.valor = '%.2f' % sum(map(
            lambda m: float(m.imposto.IPI.vIPI.valor), nfe.infNFe.det))
        nfe.infNFe.total.ICMSTot.vPIS.valor = '%.2f' % sum(map(
            lambda m: float(m.imposto.PIS.vPIS.valor), nfe.infNFe.det))
        nfe.infNFe.total.ICMSTot.vCOFINS.valor = '%.2f' % sum(map(
            lambda m: float(m.imposto.COFINS.vCOFINS.valor), nfe.infNFe.det))
        nfe.infNFe.total.ICMSTot.vOutro.valor = '%.2f' % sum(map(
            lambda m: float(m.prod.vOutro.valor), nfe.infNFe.det))
        nfe.infNFe.total.ICMSTot.vNF.valor = '%.2f' % brw_capa.supcap_total_cupom
        nfe.infNFe.total.ICMSTot.vTotTrib.valor = '%.2f' % sum(map(
            lambda m: float(m.imposto.vTotTrib.valor), nfe.infNFe.det))
        nfe.infNFe.total.ICMSTot.vICMSUFDest.valor = '%.2f' % sum(map(
            lambda m: float(m.imposto.ICMSUFDest.vICMSUFDest.valor), nfe.infNFe.det))
        nfe.infNFe.total.ICMSTot.vICMSUFRemet.valor = '%.2f' % sum(map(
            lambda m: float(m.imposto.ICMSUFDest.vICMSUFRemet.valor), nfe.infNFe.det))

    def set_beneficio_fiscal(self, det, item, valor_desonerado):
        # CSTs: 20, 30, 40, 41, 50, 51, 70, 90
        pass
        # vr_liquido = Decimal(item.get('supcor_preco_total') - item.get('supcor_desconto_item') +
        #                      item.get('supcor_acrescimo_item'))
        # base_icms = Decimal(vr_liquido * Decimal(item.get('base_icms')) / Decimal(Decimal(100)0)).quantize(TWOPLACES)
        # vr_icms = Decimal(base_icms * Decimal(18) / Decimal(Decimal(100)0)).quantize(
        #     TWOPLACES)
        # valor_desonerado = vr_icms
        # det.imposto.ICMS.vICMSDeson.obrigatorio = True
        # det.imposto.ICMS.motDesICMS.obrigatorio = True
        # det.imposto.ICMS.vICMSDeson.valor = '%.2f' % valor_desonerado
        # det.imposto.ICMS.motDesICMS.valor = int(item.get('mot_beneficio') or 0)

    def set_regime_tributario_outros_icms(self, cr, uid, det, item, brw_capa):
        codigo_cst = item.get('codigo_cst')
        det.imposto.ICMS.CST.valor = codigo_cst  # deve ser diferente de 50, 51
        det.imposto.ICMS.orig.valor = int(item.get('origem_mercadoria') or '0')
        vr_encargo = Decimal(item.get('supcor_vr_icms') or 0)
        vr_base_icms = Decimal(item.get('supcor_base_icms'))
        det.imposto.ICMS.pICMS.valor = '%.2f' % (item.get('aliquota_icms') or 0)
        det.imposto.ICMS.vICMS.valor = '%.2f' % vr_encargo
        brw_cliente = False
        if brw_capa.supcap_cliente:
            obj_cliente = self.pool.get('supervisor.cad.clientes')
            cliente_ids = obj_cliente.search(cr, uid,
                                             [('supcli_cnpj_cpf', '=', brw_capa.supcap_cliente)],
                                             context={})
            if cliente_ids:
                brw_cliente = obj_cliente.browse(cr, uid, cliente_ids[0], context={})

            if not brw_cliente:
                raise osv.except_osv(_('Atencao!'),
                                     _('O cliente "%s" nao esta cadastrado!') % brw_capa.supcap_cliente)
        # Em operacoes interestaduais (idDest=2) para consumidor final (indFinal=1) nao
        # contribuinte (indIEDest=9), o valor do FCP deve ser informado no campo vFCPUFDest

        det.imposto.ICMS.pFCP.valor = '%.4f' % 0
        det.imposto.ICMS.vFCP.valor = '%.2f' % 0
        if codigo_cst == '00':  # Tributado integralmente
            det.imposto.ICMS.modBC.valor = u'3'
            det.imposto.ICMS.vBC.valor = '%.2f' % vr_base_icms

        elif codigo_cst == '20':  # Com reducao de base de calculo
            det.imposto.ICMS.modBC.valor = u'3'
            det.imposto.ICMS.pRedBC.valor = '%.4f' % (Decimal(100) - Decimal(item.get('percent_base_icms')))
            det.imposto.ICMS.vBC.valor = '%.2f' % vr_base_icms
            det.imposto.ICMS.vBCFCP.valor = '%.2f' % vr_base_icms
            self.set_beneficio_fiscal(det, item, vr_encargo)

        elif codigo_cst == '30':
            aliq_fcp = Decimal(item.get('aliquota_fcp'))
            vr_fcp = 0
            if brw_cliente and brw_cliente.supcli_tipo_pessoa == u'F':
                vr_fcp = vr_base_icms * aliq_fcp / Decimal(100)

            det.imposto.ICMS.pICMS.valor = '%.2f' % 0
            det.imposto.ICMS.vICMS.valor = '%.2f' % 0
            det.imposto.ICMSUFDest.pFCPUFDest.valor = '%.4f' % 0
            det.imposto.ICMSUFDest.vFCPUFDest.valor = '%.2f' % 0
            det.imposto.ICMS.modBCST.valor = '4'
            det.imposto.ICMS.vBCST.valor = '%.2f' % vr_base_icms
            det.imposto.ICMS.pICMSST.valor = '%.2f' % (item.get('aliquota_icms') or 0)
            det.imposto.ICMS.vICMSST.valor = '%.2f' % vr_encargo
            det.imposto.ICMS.vBCFCPST.valor = '%.2f' % vr_base_icms
            det.imposto.ICMS.pFCPST.valor = '%.4f' % aliq_fcp
            det.imposto.ICMS.vFCPST.valor = '%.2f' % vr_fcp
            det.prod.CEST.valor = item.get('supcor_cest') or ''
            self.set_beneficio_fiscal(det, item, vr_encargo)

        elif codigo_cst in ('40','41','50'):  # 40=Isento, 41=Nao tributado, 50=Com suspensao
            det.imposto.ICMS.pFCP.valor = '%.4f' % 0
            det.imposto.ICMS.vFCP.valor = '%.2f' % 0
            self.set_beneficio_fiscal(det, item, vr_encargo)

        elif codigo_cst == '51': # Com difereimento
            det.imposto.ICMS.vBC.valor = '%.2f' % vr_base_icms
            det.imposto.ICMS.vBCFCP.valor = '%.2f' % vr_base_icms
            self.set_beneficio_fiscal(det, item, vr_encargo)

        elif codigo_cst == '60':  # Cobrado anteriormente com substituicao tributaria
            det.prod.CEST.valor = item.get('supcor_cest') or ''
            det.imposto.ICMS.vBCSTRet.valor = '%.2f' % vr_base_icms
            det.imposto.ICMS.pFCP.valor = '%.4f' % 0
            det.imposto.ICMS.vFCP.valor = '%.2f' % 0
            det.imposto.ICMS.vICMSSTRet.valor = '%.2f' % vr_encargo

        elif codigo_cst == '61':  # Monofásico combustiveis
            det.prod.CEST.valor = item.get('supcor_cest') or ''
            det.imposto.ICMS.vBCSTRet.valor = '%.2f' % vr_base_icms
            if det.prod.comb.cProdANP.valor == 210203001:
                det.imposto.ICMS.qBCMonoRet.valor = '%.4f' % float(det.prod.qTrib.valor)
                det.imposto.ICMS.adRemICMSRet.valor = '%.4f' % item.get('adrem') or 0
                vICMSMonoRet = item.get('adrem') * float(det.prod.qTrib.valor)
                det.imposto.ICMS.vICMSMonoRet.valor = '%.2f' % vICMSMonoRet

        elif codigo_cst == '70': # Com redução da BC e cobrança do ICMS por substituição tributária
            aliq_fcp = Decimal(item.get('aliquota_fcp'))
            vr_fcp = 0
            if brw_cliente and brw_cliente.supcli_tipo_pessoa == u'F':
                vr_fcp = vr_base_icms * aliq_fcp / Decimal(100)

            det.imposto.ICMS.modBC.valor = '3'
            det.imposto.ICMS.pRedBC.valor = '%.4f' % (Decimal(100) - Decimal(item.get('percent_base_icms')))
            det.imposto.ICMS.vBC.valor = '%.2f' % vr_base_icms
            det.imposto.ICMS.vBCFCPST.valor = '%.2f' % vr_base_icms
            det.imposto.ICMS.pFCPST.valor = '%.4f' % aliq_fcp
            det.imposto.ICMS.vFCPST.valor = '%.2f' % vr_fcp
            det.imposto.ICMS.modBCST.valor = '4'
            det.imposto.ICMS.vBCST.valor = '%.2f' % vr_base_icms
            det.imposto.ICMS.vICMSST.valor = '%.2f' % vr_encargo
            det.imposto.ICMS.vBCFCP.valor = '%.2f' % vr_base_icms
            det.prod.CEST.valor = item.get('supcor_cest') or ''
            self.set_beneficio_fiscal(det, item, vr_encargo)

        elif codigo_cst == '90':  # Outras tributacoes)
            det.imposto.ICMS.modBC.valor = '3'
            det.imposto.ICMS.vBC.valor = '%.2f' % vr_base_icms
            det.imposto.ICMS.vBCFCP.valor = '%.2f' % vr_base_icms
            det.prod.CEST.valor = item.get('supcor_cest') or ''

        # Isentos
        if item.get('tipo_trib').strip() == u'I':
            det.imposto.ICMS.vBC.valor = '%.2f' % 0

    def set_regime_tributario_outros_pis(self, det, item):
        codigo_cst = item.get('codigo_cst_pis')
        codigo_cst = '99' if codigo_cst == '05' else codigo_cst
        det.imposto.PIS.CST.valor = codigo_cst
        vr_base_pis = Decimal(item.get('supcor_base_pis') or 0)
        aliq_pis = Decimal(item.get('aliquota_pis') or 0)
        vr_pis = Decimal(item.get('supcor_vr_pis') or 0)
        if codigo_cst in ('01', '02'):
            det.imposto.PIS.vBC.valor = '%.2f' % vr_base_pis
            det.imposto.PIS.pPIS.valor = '%.4f' % aliq_pis
            det.imposto.PIS.vPIS.valor = '%.2f' % vr_pis
        elif codigo_cst == '03':
            det.imposto.PIS.qBCProd.valor = '%.4f' % item.get('supcor_quantidade')
            det.imposto.PIS.vAliqProd.valor = '%.4f' % (vr_base_pis * (aliq_pis / Decimal(100)))
            det.imposto.PIS.vPIS.valor = '%.2f' % vr_pis

        elif codigo_cst in (
        '49', '50', '51', '52', '53', '54', '55', '56', '60', '61', '62', '63',
        '64', '65', '66', '67', '70', '71', '72', '73', '74', '75', '98', '99'):
            det.imposto.PIS.vBC.valor = '%.2f' % vr_base_pis
            det.imposto.PIS.pPIS.valor = '%.4f' % aliq_pis
            det.imposto.PIS.vPIS.valor = '%.2f' % vr_pis
            det.imposto.PIS.qBCProd.valor = '%.4f' % item.get('supcor_quantidade')
            det.imposto.PIS.vAliqProd.valor = '%.4f' % (vr_base_pis * (aliq_pis / Decimal(100)))
            det.imposto.PIS.vPIS.valor = '%.2f' % vr_pis

    def set_regime_tributario_outros_cofins(self, det, item):
        codigo_cst = item.get('codigo_cst_cofins')
        codigo_cst = '99' if codigo_cst == '05' else codigo_cst
        det.imposto.COFINS.CST.valor = codigo_cst
        vr_base_cofins = Decimal(item.get('supcor_base_cofins') or 0)
        aliq_cofins = Decimal(item.get('aliquota_cofins') or 0)
        vr_cofins = Decimal(item.get('supcor_vr_cofins') or 0)
        if codigo_cst in ('01', '02'):
            det.imposto.COFINS.vBC.valor = '%.2f' % vr_base_cofins
            det.imposto.COFINS.pCOFINS.valor = '%.4f' % aliq_cofins
            det.imposto.COFINS.vCOFINS.valor = '%.2f' % vr_cofins
        elif codigo_cst == '03':
            det.imposto.COFINS.qBCProd.valor = '%.4f' % item.get('supcor_quantidade')
            det.imposto.COFINS.vAliqProd.valor = '%.4f' % \
                                                 (vr_base_cofins * (aliq_cofins / Decimal(100)))
            det.imposto.COFINS.vCOFINS.valor = '%.2f' % vr_cofins
        elif codigo_cst in ('04', '06', '07', '08', '09'):
            pass
        elif codigo_cst in (
        '49', '50', '51', '52', '53', '54', '55', '56', '60', '61', '62', '63',
        '64', '65', '66', '67', '70', '71', '72', '73', '74', '75', '98', '99'):
            det.imposto.COFINS.vBC.valor = '%.2f' % vr_base_cofins
            det.imposto.COFINS.pCOFINS.valor = '%.4f' % aliq_cofins
            det.imposto.COFINS.qBCProd.valor = '%.2f' % item.get('supcor_quantidade')
            det.imposto.COFINS.vAliqProd.valor = '%.4f' % \
                                                 (vr_base_cofins * (aliq_cofins / Decimal(100)))
            det.imposto.COFINS.vCOFINS.valor = '%.2f' % vr_cofins

    def set_regime_tributario_outros(self, cr, uid, det, item, brw_capa):
        vals  = {}
        vr_liquido = Decimal(item.get('supcor_preco_total')) - Decimal(item.get('supcor_desconto_item')) + \
                             Decimal(item.get('supcor_acrescimo_item'))
        # recalcula os valores das tributacoes caso tenha trocado o cadastro das mesmas.
        if item.get('codigo_icms') != item.get('supcor_codigo_trib_icms'):
            base_icms = Decimal(vr_liquido * Decimal(item.get('base_icms')) / Decimal(100)).quantize(TWOPLACES)
            vr_icms = Decimal(base_icms * Decimal(item.get('aliquota_icms'))  / Decimal(100)).quantize(TWOPLACES)
            vals.update({'supcor_vr_icms': vr_icms,
                         'supcor_base_icms': base_icms})

        if item.get('codigo_pis') != item.get('supcor_codigo_trib_pis'):
            base_pis = Decimal(vr_liquido * Decimal(item.get('base_pis')) / Decimal(100)).quantize(
                TWOPLACES)
            vr_pis = Decimal(base_pis * Decimal(item.get('aliquota_pis')) / Decimal(100)).quantize(
                TWOPLACES)
            vals.update({'supcor_vr_pis': vr_pis,
                         'supcor_base_pis': base_pis})

        if item.get('codigo_cofins') != item.get('supcor_codigo_trib_cofins'):
            base_cofins = Decimal(vr_liquido * Decimal(item.get('base_cofins')) / Decimal(100)).quantize(
                TWOPLACES)
            vr_cofins = Decimal(base_cofins * Decimal(item.get('aliquota_cofins'))/ Decimal(100)).quantize(
                TWOPLACES)
            vals.update({'supcor_vr_cofins': vr_cofins,
                         'supcor_base_cofins': base_cofins})

        if vals:
            self.pool.get('supervisor.mov.corpos').write(cr, uid, item.get('id'), vals, {})
            item.update(vals)

        self.set_regime_tributario_outros_icms(cr, uid, det, item, brw_capa)
        self.set_regime_tributario_outros_pis(det, item)
        self.set_regime_tributario_outros_cofins(det, item)

    def set_regime_tributario_simples_nacional_icms(self, cr, uid, brw_config, det, item):
        """
        Atribui os valores de ICMS para regime tributario Simples Nacional.
        :param det: item de movimentacao
        :param item: dados do item
        :type det: Det (objeto ´nfe.infNFe.det´)
        :type item: dict
        :return: n/a
        :rtype: n/a
        """
        csosn = item.get('csosn')
        # todo: ver como fica essa parte de teste de csosn
        # if not csosn:  # Como o CSOSN nao eh obrigatorio evita-se erro ao validar o arquivo .xsd
        #     produto_nome = self.pool.get('estoque.produto').read(
        #         cr, user, produto['id'], ['name'], context).get('name')
        #     sequencia = self.pool.get('estoque.movimento.itens').read(
        #         cr, user, item['id'], ['sequencia'], context).get('sequencia')
        #     raise osv.except_osv(('Atencao!'),
        #                          ('Nenhum CSOSN cadastrado para ICMS/%s no item %s-%s.') % (
        #                              cst.get('codigo'), sequencia, produto_nome))
        codigo_cst = item.get('codigo_cst')
        det.imposto.ICMS.orig.valor = item.get('origem_mercadoria')
        det.imposto.ICMS.CSOSN.valor = csosn
        aliquota = self._fisnfc_get_aliquota_sn(cr, uid, brw_config)
        vr_cred_icms_sn = Decimal(item.get('supcor_base_icms')) * aliquota / Decimal(100)
        if csosn == '101':
            det.imposto.ICMS.pCredSN.valor = '%.2f' % aliquota
            det.imposto.ICMS.vCredICMSSN.valor = '%.2f' % vr_cred_icms_sn
        elif csosn == '500':
            det.imposto.ICMS.vBCSTRet.valor = '%.2f' % item.get('supcor_base_icms')
        # elif csosn == '900':
        #     det.imposto.ICMS.vCredICMSSN.valor = 0

        if codigo_cst == '60':
            det.prod.CEST.valor = item.get('supcor_cest') or ''

        # Para tipo tributado soma o aproveitamento de credito
        if item.get('suptnf_tipo_tributacao') == u'T':
            # Aproveitamento de credito
            self.total_aproveitamento_credito += \
                (Decimal(item.get('supcor_base_icms')) * aliquota / Decimal(100))

    def set_regime_tributario_simples_nacional(self, cr, uid, brw_config, det, item):
        """
        Atribui valores para o regime Simples Nacional
        :param det: item de movimentacao
        :param item: dados do item
        :type det: Det (objeto ´nfe.infNFe.det´)
        :type item: dict
        :return: n/a
        :rtype: n/a
        """
        det.imposto.ICMS.regime_tributario = 1  # Simples Nacional
        self.set_regime_tributario_simples_nacional_icms(cr, uid, brw_config, det, item)
        det.imposto.PIS.CST.valor = u'99'  # Outras operacoes
        det.imposto.COFINS.CST.valor = u'99'  # Outras operacoes

    def _fisnfc_get_aliquota_sn(self, cr, uid, brw_config):
        """
        Recupera o valor da aliquota do Simples Nacional.
        """
        aliquota_sn = 0
        receita_anual = brw_config.supcfc_valor_faturamento
        obj_simples = self.pool.get('supervisor.tributacao.simples.nacional')
        simples_ids = obj_simples.search(cr, uid, [], order='suptsn_valor_faturamento', context={})
        for trib in obj_simples.read(cr, uid, simples_ids, ['suptsn_valor_faturamento',
                                                            'suptsn_aliq_icms'], context={}):
            if receita_anual <= trib.get('suptsn_valor_faturamento'):
                aliquota_sn = (trib.get('suptsn_aliq_icms') or 0)
                break

        return Decimal(aliquota_sn)

    def supcap_button_exportar_xml(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        dados = self.read(cr, uid, ids[0], ['supcap_xml_proc',
                                            'supcap_xml_gerado',
                                            'supcap_xml_cancelamento'], context)
        xml = dados.get('supcap_xml_cancelamento') or  dados.get('supcap_xml_proc') or \
              dados.get('supcap_xml_gerado')

        if not xml:
            raise osv.except_osv(_('Atencao!'), _('Nota sem xml!'))

        xml = base64.encodestring(xml.encode('utf-8', 'strict'))
        context['active_id'] = ids[0]
        id_export = self.pool.get('wizard.exporta.xml.nfce').create(cr, uid, {'xml_export': xml},
                                                                    context)
        return {'name': 'Exportacao NF-e',
                'view_type': 'form',
                'view_mode': 'form',
                'res_id': id_export,
                'res_model': 'wizard.exporta.xml.nfce',
                'view_id': False,
                'target': 'new',
                'type': 'ir.actions.act_window'}

    def supcap_buscar_protocolo(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        brw_capa = self.browse(cr, uid, ids[0], context)
        if (brw_capa.supcap_state == '3' and brw_capa.supcap_protocolo) or \
            (brw_capa.supcap_state == 'C' and brw_capa.supcap_protocolo_cancelamento):
            raise osv.except_osv(_('Atencao!'), _('Nota ja possui protocolo'))
        try:
            processo, __ = self.supcap_verifica_status_nfce_sefaz(cr, uid, brw_capa, context)
            if processo.resposta.cStat.valor == u'100':  # Faturada
                protocolo = processo.resposta.protNFe.infProt.nProt.valor
                self.write(cr, uid, brw_capa.id, {'supcap_protocolo': protocolo}, context)

            elif processo.resposta.cStat.valor == u'101':  # Cancelada
                protocolo = processo.resposta.retCancNFe.infCanc.nProt.valor
                if protocolo and 'ID' in protocolo:
                    protocolo = protocolo.replace('ID', '')

                self.write(cr, uid, brw_capa.id, {'supcap_protocolo_cancelamento': protocolo},
                           context)

            elif processo.resposta.cStat.valor == u'102':  # Inutilizada
                raise Exception(_('Atencao!'), _('Nao implementado para Nota Inutilizada'))

            elif processo.resposta.cStat.valor in (u'137', u'217'):
                raise Exception(_('Nota nao encontrada na SEFAZ'))

            elif processo.resposta.cStat.valor in (u'999'):
                raise Exception(_('Erro interno no SEFAZ: 999'))

        except Exception as e:
            raise osv.except_osv(_('Atencao!'), str(e))


        return True
