#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from funcoes import _supban_get_descricao_completa


class supervisor_cad_bandeiras(osv.Model):
    """
    Tabela de cadastro de bandeiras
    Prefixo: supban
    """

    _name = 'supervisor.cad.bandeiras'
    _rec_name = 'supban_descricao_completa'
    _gerar_logs_logs = 'N'

    _columns = {'supban_codigo': fields.integer('Codigo', required=True, select=True),

                'name': fields.char('Descricao', size=30, required=True),

                'supban_descricao_completa': fields.function(_supban_get_descricao_completa,
                                                             string="Descricao compelta",
                                                             type="char", store=True),

                'supban_tipo': fields.selection([('C', 'Credito'), ('D', 'Debito'),
                                                 ('V', 'Voucher'), ('O', 'Carteira Digital')],
                                                'Tipo de cartao'),

                'supban_cad_finalizadoras_cre_ids': fields.one2many('supervisor.cad.finalizadora',
                                                                    'supfin_bandeira_cre',
                                                                    'Mod bandeiras credito',
                                                                    select=True),

                'supban_cad_finalizadoras_deb_ids': fields.one2many('supervisor.cad.finalizadora',
                                                                    'supfin_bandeira_deb',
                                                                    'Mod bandeiras debito',
                                                                    select=True)}

    _sql_constraints = [('supban_codigo_uniq', 'unique (supban_codigo, supban_tipo)',
                         'O codigo precisa ser unico!')]

    _order = 'supban_codigo, name, supban_tipo'
