# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class supervisor_cad_cfop(osv.Model):
    """
    Tabela de Cadastros de CFOPs
    prefixo: supcfop
    """
    _name = 'supervisor.cad.cfop'
    _gerar_logs_logs = 'N'
    _columns = {
        'supcfop_codigo': fields.integer('Codigo', required=True, select=True),
        'name': fields.char('Descricao', size=255),
        'supcfop_tipo': fields.selection([('E', 'Entrada'), ('S', 'Saida')], 'Tipo'), # E=Entrada, S=Saida
        'supcfop_analitico_sintetico': fields.selection([('A', 'Analitico'), ('S', 'Sinteticp')], 'Analitico/intetico'),
        'supcfop_movimento_tipo': fields.selection([('C', 'Compra/Venda'),
                                                    ('D', 'Devolucao'),
                                                    ('T', 'Transferencia'),
                                                    ('E', 'Remessa'),
                                                    ('R', 'Retorno'),
                                                    ('U', 'Outras')], 'Movimento tipo'),
        'supcfop_transacao_tipo': fields.selection([('C', 'Comercializacao'),
                                                    ('I', 'Industrializacao'),
                                                    ('M', 'Imobilizado'),
                                                    ('S', 'Consumo'),
                                                    ('O', 'Outros')], 'Transacao tipo'),
        'produto_servico_tipo': fields.selection([('P', 'Mercadoria / Produto'),
                                                  ('F', 'Servico de transporte'),
                                                  ('M', 'Servico de comunicacao'),
                                                  ('S', 'Servico'),
                                                  ('E', 'Energia eletrica'),
                                                  ('L', 'Combustivel / Lubrificante'),
                                                  ('O', 'Outros')], 'Produto servico tipo'),
        'nfe_corpos_ids': fields.one2many('supervisor.nfe.corpos', 'supnfo_cfop_id', 'Corpos'),
    }
    _sql_constraints = [
        ('supcfop_codigo_uniq', 'unique (supcfop_codigo)', 'O supcfop_codigo precisa ser unico!'),
    ]
