# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class supervisor_cad_clientes(osv.Model):
    """
    Tabela de Cadastro de Clientes
    Prefixo: supcli
    """
    _name = 'supervisor.cad.clientes'
    _gerar_logs_logs = 'N'
    _columns = {
        'supcli_cnpj_cpf': fields.char('Cnpj cpf', size=15, required=True, select=True),
        'name': fields.char('Nome', size=40, required=True, select=True),
        'supcli_endereco': fields.char('Endereco', size=90),
        'supcli_status': fields.char('Status', size=1),
        'supcli_limite_compras': fields.float('Limite de compras', digits=(14,2)),
        'supcli_total_em_aberto': fields.float('Total em aberto', digits=(10,2)),
        'supcli_codigo_interno': fields.float('Codigo interno', digits=(14,0)),
        'supcli_insc_estadual': fields.char('Inscricao estadual', size=15),
        'supcli_bairro': fields.char('Bairro', size=20),
        'supcli_cidade': fields.char('Cidade', size=30),
        'supcli_estado': fields.char('Estado', size=2),
        'supcli_cep': fields.char('Cep', size=8),
        'supcli_telefone': fields.char('Telefone', size=14),
        'supcli_rota': fields.integer('Rota'),
        'supcli_tipo_pessoa': fields.selection([('F','Fisica'),('J','Juridica')], 'Tipo de pessoa'),
        'supcli_cod_municipio': fields.integer('Codigo do municipio'),
        'supcli_endereco_numero': fields.char('Numero', size=15),
        'supcli_complemento': fields.char('Complemento', size=20),
        'supcli_email': fields.char('Email', size=100),
        'supcli_mensagens_clientes_ids': fields.one2many('supervisor.cad.mensagens.clientes', 'supclm_cnpj_cpf', 'Clientes'),
    }
    _sql_constraints = [
        ('supcli_cnpj_cpf_uniq', 'unique (supcli_cnpj_cpf)', 'O cnpj_cpf precisa ser unico!'),
    ]

