# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _

class supervisor_cad_finalizadora_na_ecf(osv.Model):
    """
    Cadastro de nomes de finalizadoras na ecf
    Prefixo: supfec
    
    """

    _name = 'supervisor.cad.finalizadora.na.ecf'
    _gerar_logs_logs = 'N'
    _columns = {
        'supfec_codigo_na_ecf': fields.integer('Codigo na ecf', required=True),
        'name': fields.char('Descricao', size=30, select=True),
        'supfec_cad_finalizadora_ids': fields.one2many('supervisor.cad.finalizadora', 'supfin_codigo_na_ecf',
                                                       'Finalizadora'),
    }

    _sql_constraints = [
        ('cod_fin_loja_caixa_uniq', 'unique (supfec_codigo_na_ecf)',
         _('O codigo da finalizadora precisa ser unico!')),
        ]

    _order = 'supfec_codigo_na_ecf'