# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
import time


class supervisor_cad_modelos_nfe(osv.Model):
    """
    Tabela de modelos de nfe
    Prefixo: supmnf
    
    """
    _name = 'supervisor.cad.modelos.nfe'
    _gerar_logs_logs = 'N'
    _columns = {
        'supmnf_codigo': fields.char('Codigo', size=2, required=True, select=True),
        'name': fields.char('Descricao', size=100),
        'supmnf_serie': fields.integer('Serie'),
        'supmnf_numeracao': fields.integer('Numeracao'),
        'active': fields.boolean('Ativo'),
    }
    _defaults = {
        'active': lambda *a: True,
    }
    _sql_constraints = [
        ('supmnf_codigo_uniq', 'unique (supmnf_codigo)', 'O codigo precisa ser unico!'),
    ]

