# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
import time


class supervisor_cad_operadores(osv.Model):
    """
    Tabela de Cadastro de Operadores
    Prefixo: supope
    
    """
    _name = 'supervisor.cad.operadores'

    _columns = {
        'id': fields.integer('ID'),
        'supope_codigo': fields.integer('Codigo', required=True, select=True),
        'name': fields.char('Nome', size=30),
        'supope_senha': fields.char('Senha', size=15),
        'supope_operador_supervisor': fields.selection([('O','Operador'), ('S', 'Supervisor')], 'Operador/Supervisor'),
        'supope_cancela_item': fields.boolean('Cancelar item'),
        'supope_desconto_item': fields.boolean('Desconto em item'),
        'supope_libera_restricao': fields.boolean('Liberar restricao'),
        'active': fields.boolean('Ativo'),
        'supope_mov_capa_ids': fields.one2many('supervisor.mov.capa', 'supcap_operador_id', 'Capa'),
        'supope_dav_capa_ids': fields.one2many('supervisor.dav.capa', 'supdva_operador_id', 'Capa'),
        'supope_autorizacoes_ids': fields.one2many('supervisor.autorizacoes', 'supaut_autorizador_id', 'Autorizacoes'),
        'supope_mov_caixa_ids': fields.one2many('supervisor.mov.caixa', 'supcax_operador_id', 'Caixa'),
        'supope_pve_capa_ids': fields.one2many('supervisor.pve.capa', 'suppva_operador_id', 'Capa'),
        'supope_user_id': fields.many2one("res.users", 'Usuario', select=True,
                                          help="Este campo deve ser preenchido caso o usuario "
                                               "posssa cancelar notas pelo 'Supervisor'"),
    }
    _defaults = {
        'active': lambda *a: True,
    }
    _sql_constraints = [
        ('supope_codigo_uniq', 'unique (supope_codigo)', 'O codigo precisa ser unico!'),
    ]

