# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from datetime import datetime, timedelta


class supervisor_cad_pdvs(osv.Model):
    """
    Tabela de Cadastro de PFVs
    Prefixo: suppdv
    """
    def get_pdv_online(self, cr, uid, ids, name, arg, context=None):
        context = context and context.copy() or {}
        res = {}
        for i in self.read(cr, uid, ids, ['suppdv_data_pdv_atualizacao'], context):
            data = i.get('suppdv_data_pdv_atualizacao')
            if data and (datetime.strptime(data[:19], '%Y-%m-%d %H:%M:%S') +
                             timedelta(seconds=60)) > datetime.now():
                res[i.get('id')] = '/supervisor/static/src/img/online.png'
            else:
                res[i.get('id')] = '/supervisor/static/src/img/offline.png'

        return res

    _name = 'supervisor.cad.pdvs'
    _gerar_logs_logs = 'N'
    _columns = {
        'suppdv_loja': fields.integer('Loja', required=True, select=True),
        'suppdv_caixa': fields.integer('Caixa', required=True),
        'suppdv_ip_caixa': fields.char('Ip do caixa', size=20),
        'suppdv_banco': fields.char('Banco do PDV', size=20),
        'suppdv_usuario_banco': fields.char('Usuario do Banco do PDV', size=20),
        'suppdv_data_pdv_atualizacao': fields.datetime('Ultima comunicacao do PDV'),
        'state': fields.function(get_pdv_online, method=True, string="Online", store=False,
                                 type="char", size=30),
        'suppdv_lastup_clientes': fields.datetime('Ultima atualizacao de clientes'),
        'suppdv_lastup_tipo_recebimento': fields.datetime('Ultima atualizacao de tipo recebimento'),
        'suppdv_lastup_finalizadora': fields.datetime('Ultima atualizacao de finalizadora'),
        'suppdv_lastup_operadores': fields.datetime('Ultima atualizacao operadores'),
        'suppdv_lastup_mensagens_clientes': fields.datetime('Ultima atualizacao mensagens clientes'),
        'suppdv_lastup_tributacao': fields.datetime('Ultima atualizacao de tributacao'),
        'suppdv_lastup_itens': fields.datetime('Ultima atualizacao de itens'),
        'suppdv_lastup_kits': fields.datetime('Ultima atualizacao de kits'),
        'suppdv_lastup_vendedor': fields.datetime('Ultima atualizacao de vendedor'),
    }
    _sql_constraints = [
        ('suppdv_loja_caixa_uniq', 'unique (suppdv_loja,suppdv_caixa)',
         'A loja e o caixa precisam ser unicos!'),
    ]

