# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class supervisor_cad_restricao_item(osv.Model):
    """
    Tabela de Restricoes de itens
    Prefixo: supres
    """
    _name = 'supervisor.cad.restricao.item'
    _gerar_logs_logs = 'N'
    _columns = {
        'supres_codigo_barra': fields.char('Codigo de barras', size=14, required=True),
        'supres_nome_item': fields.char('Item', size=60),
        'supres_max': fields.integer('Maximo sem autorizacao'),
        'supres_solicita_sup': fields.boolean('Solicitar Supervisor',
                                              help="Solicitar o Supervisor para venda deste produto!")
    }
    _sql_constraints = [
        ('supres_supres_codigo_barra_uniq', 'unique (supres_codigo_barra)',
         _('Este item ja possui restricao!')),
    ]

