# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class supervisor_cad_tributacao(osv.Model):
    """
    Tabela de Tributacao
    Prefixo: suptri
    """
    _name = 'supervisor.cad.tributacao'
    _gerar_logs_logs = 'N'
    _columns = {
        'suptri_codigo_trib_ecf': fields.char('Codigo tribu ecf', size=3, required=True, select=True,
                                              help='Codigo de Tributacao na ECF!'),
        'suptri_name': fields.char('Descricao', size=30, required=True),
        'suptri_codigo_trib_retag': fields.char('Codigo trib retag', size=3, select=True,
                                                help='Codigo de tributacao no retaguarda'),
        'suptri_aliquota': fields.float('Aliquota', digits=(5,2)),
        'suptri_base': fields.float('Base', digits=(5,2)),
        'suptri_tipo_imposto': fields.selection([('C', 'ICMS'), ('S', 'ISS')], 'Tipo de imposto'), # Tipo do imposto C=ICMS, S=ISS
        'suptri_tipo_tributacao': fields.selection([('T', 'Tributado'), ('F', 'Substituicao'),
                                                    ('I', 'Isentos'), ('N', 'Outros')],
                                                   'Tipo de tributacao', required=True),
        # Tipo de Tributacao T=Tributado, F=Substituicao, I=Isento, N=Nao tributado
        'cad_itens_ids': fields.one2many('supervisor.cad.itens', 'supite_tributacao_id', 'Itens'),
        'suptri_loja': fields.integer('Loja', required=True, select=True),
    }
    _sql_constraints = [
        ('suptri_codigo_trib_ecf_loja_caixa_uniq',
         'unique (suptri_codigo_trib_ecf, suptri_loja)',
         'O codigo de tributacao na ecf precisa ser unico para o mesmo caixa e loja!'),
    ]

    _defaults = {
        'suptri_loja': lambda self, cr, user, context: self.pool.get('supervisor.util').get_loja(
                                                                         cr, user, context=context),
    }
