# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class supervisor_cad_tributacao_nfce(osv.Model):
    """
    Tabela de Tributacao da NFC-E
    Prefixo: suptnf
    """
    _name = 'supervisor.cad.tributacao.nfce'
    _gerar_logs_logs = 'N'
    _columns = {
        'suptnf_codigo': fields.integer("Codigo Tributacao", help="Codigo unico da tributacao",
                                        required=True),
        'suptnf_aliquota': fields.float('Aliquota', digits=(5,2)),
        'suptnf_base': fields.float('Base', digits=(5,2)),
        'suptnf_encargo': fields.selection([('I', 'ICMS'), ('S', 'ISS'),
                                            ('P', 'PIS'), ('C', 'COFINS')], 'Encargo',
                                           required=True),
        'suptnf_codigo_cst': fields.char('Codigo CST', size=2, required=True),
        'suptnf_codigo_csosn': fields.char('Codigo CSOSN', size=3),
        'suptnf_tipo_tributacao': fields.selection([('T', 'Tributado'),
                                                    ('U', 'Substituicao Tributaria'),
                                                    ('I', 'Isento'),
                                                    ('O', 'Outros'),
                                                    ('D', 'Diferido'),
                                                    ('S', 'Servico'),
                                                    ('TU', 'Tributado com substituicao')],
                                                   'Tipo de tributacao', required=True),
        'suptnf_aliquota_fcp': fields.float('Aliquota FCP', digits=(5,2)),
        'suptnf_codigo_beneficio': fields.char('Codigo de Beneficio Fiscal', size=10),
        'suptnf_motivo_beneficio': fields.selection(
                       [('1', 'Taxi'), ('3', 'Uso na agropecuaria'), ('4', 'Frotista/Locadora'),
                        ('5', 'Diplomatico/Consular'),
                        ('6', 'Utilitarios e motocicletas da Amazonia'),
                        ('7', 'SUFRAMA'), ('8', 'Venda a orgao publico'), ('9', 'Outros'),
                        ('10', 'Deficiente condutor'), ('11', 'Deficiente nao condutor'),
                        ('12', 'Orgao de fomento e desenvolvimento agropecuario')],
                       'Motivo do Beneficio Fiscal'),
    }

    _sql_constraints = [
        ('suptnf_codigo_uniq', 'unique(suptnf_codigo)', 'O codigo da tributacao deve ser unico!'),
    ]