# -*- coding: utf-8 -*-

from openerp.osv import osv, fields


class supervisor_tributacao_simples_nacional(osv.Model):

    def _soma_total_aliquota(self, cr, uid, ids, name, arg, context=None):
        context = context and context.copy() or {}
        res = {}
        for i in self.browse(cr, uid, ids, context=context):
            res[i.id] = i.suptsn_aliq_irpj + i.suptsn_aliq_csll + i.suptsn_aliq_cofins + \
                        i.suptsn_aliq_pis + i.suptsn_aliq_inss + i.suptsn_aliq_icms

        return res

    _name = 'supervisor.tributacao.simples.nacional'
    _columns = {
        'suptsn_valor_faturamento': fields.float('Receita ate', digits=(15, 2), required=True,
                                                 help='Valor limite para aplicar os percentuais desta faixa'),
        'suptsn_aliq_irpj': fields.float('IRPJ', digits=(5, 3), help='Aliquota para calculo do IRPJ'),
        'suptsn_aliq_csll': fields.float('CSLL', digits=(5, 3), help='Aliquota para calculo do CSLL'),
        'suptsn_aliq_cofins': fields.float('Cofins', digits=(5, 3), help='Aliquota para calculo do Cofins'),
        'suptsn_aliq_pis': fields.float('PIS', digits=(5, 3), help='Aliquota para calculo do PIS'),
        'suptsn_aliq_inss': fields.float('INSS', digits=(5, 3), help='Aliquota para calculo do INSS'),
        'suptsn_aliq_icms': fields.float('ICMS', digits=(5, 3), help='Aliquota para calculo do ICMS'),
        'suptsn_aliq_total': fields.function(_soma_total_aliquota, method=True, string='Valor Total Aliquota',
                                             type='float', digits=(15, 2), store=False),
    }
