# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class supervisor_cfg_configuracao(osv.Model):
    """
    Tabela de configuracao
    supcfc
    """
    _name = 'supervisor.cfg.configuracao'
    _gerar_logs_logs = 'N'
    _rec_name = 'supcfc_cliente'
    _columns = {
        'supcfc_nro_empresa': fields.integer('Numero da Empresa', required=True, select=True),
        'supcfc_loja': fields.integer('Loja', required=True, select=True),
        'supcfc_cnpj': fields.char('Cnpj', size=15, required=True),
        'supcfc_cliente': fields.char('Empresa', size=40),
        'supcfc_endereco': fields.char('Endereco', size=40),
        'supcfc_cidade': fields.char('Cidade', size=30),
        'supcfc_estado': fields.char('Estado', size=2),
        'supcfc_cep': fields.char('Cep', size=8),
        'supcfc_nro_serie': fields.char('Nro de serie', size=5),
        'supcfc_inscricao_estadual': fields.char('Inscricao Estadual', size=20),
        'supcfc_fax': fields.char('Fax', size=14),
        'supcfc_telefone': fields.char('Telefone', size=14),
        'supcfc_numero': fields.integer('Numero'),
        'supcfc_complemento': fields.char('Complemento', size=20),
        'supcfc_bairro': fields.char('Bairro', size=15, required=True),
        'supcfc_responsavel': fields.char('Responsavel', size=25, required=True),
        'supcfc_ultimo_acesso': fields.char('Ultimo acesso', size=8),
        'supcfc_inscricao_municipal': fields.char('Inscricao Municipal', size=20),
        'supcfc_cidade_ibge': fields.char('Codigo Ibge', size=7),
        'supcfc_fantasia': fields.char('Fantasia', size=40),
        'supcfc_contador_nome': fields.char('Nome do contador', size=40),
        'supcfc_contador_cpf': fields.char('CPF', size=11),
        'supcfc_contador_crc': fields.char('CRC', size=15),
        'supcfc_contador_cnpj': fields.char('CNPJ', size=14),
        'supcfc_contador_cep': fields.integer('Cep'),
        'supcfc_contador_end': fields.char('Endereco', size=40),
        'supcfc_contador_end_nro': fields.integer('Numero'),
        'supcfc_contador_end_compl': fields.char('Complemento', size=20),
        'supcfc_contador_end_bairro': fields.char('Bairro', size=30),
        'supcfc_contador_end_mun_ibge': fields.integer('Codigo Ibge'),
        'supcfc_contador_fone': fields.char('Fone', size=10),
        'supcfc_contador_fax': fields.char('Fax', size=10),
        'supcfc_contador_email': fields.char('E-mail', size=40),
        'supcfc_pis': fields.float('Pis', digits=(5,4)),
        'supcfc_cofins': fields.float('Cofins', digits=(5,4)),
        'supcfc_diretorio_importacao': fields.char('Diretorio para importacao', size=100),
        'supcfc_certificado_conteudo': fields.text('Certificado Conteudo'),
        'supcfc_chave_conteudo': fields.text('chave'),
        'supcfc_data_validade': fields.datetime('Data de Validade '),
        'supcfc_proprietario_certificado': fields.char('Proprietario Certificado', size=50),
        'supcfc_csc': fields.char('Identificacao do CSC', size=36,
            help='Codigo de Seguranca do Contribuinte - O CSC corresponde a um codigo de seguranca '
                 'alfanumerico (16 a 36 bytes) de conhecimento apenas da Secretaria da Fazenda da '
                 'Unidade Federada do emitente e do proprio contribuinte, tambem chamado de '
                 '“Token”.'),
        'supcfc_regime_tributario': fields.selection([('R', 'Lucro Real'),
                                                      ('P', 'Lucro Presumido'),
                                                      ('S', 'Simples Nacional')],'Regime Tributario', size=1),
        'supcfc_ambiente': fields.selection([('H', 'Homologacao'),
                                             ('P', 'Producao'),], 'Ambiente', required=1, size=1),
        'supcfc_valor_faturamento': fields.float('Valor do Faturamento Anual', digits=(15, 2)),
        'supcfc_qtd_conexoes_nfce': fields.integer('Numero de tentativas de conexao',
                                                   help='Numero de tentativas de conexao com a SEFAZ'),
        'supcfc_timeout_conexoes_nfce': fields.integer('Tempo de espera da conexao(segundos)',
                                                       help='Tempo de espera da conexao com a SEFAZ'),
        'supcfc_incio_contingencia': fields.datetime('Inicio da Contingencia'),
        'supcfc_fim_contingencia': fields.datetime('Fim da contingencia'),
    }
    _sql_constraints = [
        ('supcfc_loja_uniq',  'unique (supcfc_nro_empresa, supcfc_loja)',
        'A loja precisa ser unica para a mesma empresa'),
    ]

    _defaults = {
        'supcfc_nro_empresa': 0,
        'supcfc_ambiente': 'H',
        'supcfc_qtd_conexoes_nfce': 20,
        'supcfc_timeout_conexoes_nfce': 10,
    }

