# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
import time


class supervisor_cfg_parametros(osv.Model):
    """
    Tabela de parametros do supervisor
    Prefixo: supcfp
    """
    _name = 'supervisor.cfg.parametros'
    _gerar_logs_logs = 'N'
    _columns = {
        'supcfp_moeda_singular': fields.char('Moeda singular', size=20),
        'supcfp_moeda_plural': fields.char('Moeda plural', size=20),
        'supcfp_municipio': fields.char('Municipio', size=30),
        'supcfp_favorecido': fields.char('Favorecido', size=40),
        'supcfp_qtd_minima': fields.integer('Qtd minima'),
        'supcfp_qtd_maxima': fields.integer('Qtd maxima'),
        'supcfp_valor_bonus': fields.float('Valor bonus', digits=(10,2)),
        'supcfp_pz_sem_juros': fields.integer('Pz sem juros'),
        'supcfp_pz_prazo1': fields.integer('Pz prazo1'),
        'supcfp_pz_prazo2': fields.integer('Pz prazo2'),
        'supcfp_pz_prazo3': fields.integer('Pz prazo3'),
        'supcfp_pz_prazo4': fields.integer('Pz prazo4'),
        'supcfp_pz_prazo5': fields.integer('Pz prazo5'),
        'supcfp_pz_valor1': fields.float('Pz valor1', digits=(10,2)),
        'supcfp_pz_valor2': fields.float('Pz valor2', digits=(10,2)),
        'supcfp_pz_valor3': fields.float('Pz valor3', digits=(10,2)),
        'supcfp_pz_valor4': fields.float('Pz valor4', digits=(10,2)),
        'supcfp_pz_valor5': fields.float('Pz valor5', digits=(10,2)),
        'supcfp_pz_juros1': fields.float('Pz juros1', digits=(10,2)),
        'supcfp_pz_juros2': fields.float('Pz juros2', digits=(10,2)),
        'supcfp_pz_juros3': fields.float('Pz juros3', digits=(10,2)),
        'supcfp_pz_juros4': fields.float('Pz juros4', digits=(10,2)),
        'supcfp_pz_juros5': fields.float('Pz juros5', digits=(10,2)),
        'supcfp_limite_sangria': fields.float('Limite sangria', digits=(10,2)),
        'supcfp_cliente_contra_vale': fields.integer('Cliente contra vale'),
        'supcfp_conta_contra_vale': fields.char('Conta contra vale', size=15),
        'supcfp_conta_transfer_contra_vale': fields.char('Conta transfer contra vale', size=15),
        'supcfp_pre_permite_desconto': fields.boolean('Pre permite desconto'),
        'supcfp_pre_permite_acrescimo': fields.boolean('Pre permite acrescimo',
                                                       oldname='supcfp_pre_Permite_acrescimo'),
        'supcfp_limite_cheque_a_vista': fields.float('Limite cheque a vista', digits=(10,2)),
        'supcfp_restringe_desconto': fields.boolean("Restringe percentual de desconto no cupom",
                                                    help="Se estiver marcado, ao fazer uma venda no"
                                                         " PDV com desconto percentual na capa do "
                                                         "cupom, \no desconto sera calculado apenas"
                                                         " no itens que nao entraram em qualquer "
                                                         "tipo de promocao"),
        'supcfp_mensagem_doacao': fields.text('Mensagem de Doacao',
                                        help="Mensagem que ira aparecer no comprovante do cliente"),
        'supcfp_tot_doacao': fields.integer('Totalizador de Doacao'),
        'supcfp_cfop': fields.char('Codigo CFOP Producao Propria', size=4,
                                   help="Caso o campo esteja vazio o default sera 5101"),
        'supcfp_deduz_icms': fields.boolean("Deduz ICMS do PIS/COFINS",
                                                    help="Se estiver marcado, retira o valor do ICMS da base de"
                                                         " calculo do PIS/COFINS"),

        'supcfp_tolerancia_percentual': fields.float('Tolerancia de peso em %', digits=(10, 2),
                                                     help="Tolerancia de peso em percentual para o caixa de auto"
                                                          " atendimento fazer a verificacao do produto"),
        'supcfp_tolerancia_fixo': fields.float('Tolerancia de peso em gramas', digits=(10, 2),
                                                     help="Tolerancia de peso em gramas para o caixa de auto"
                                                          " atendimento fazer a verificacao do produto"),
        'supcfp_qtd_cancela': fields.integer('Qtd de tentativas erradas',
                                                     help="Quantidade de tentativas de pesar o item antes de "
                                                          "ser cancelado pelo sistema."),
    }

    _defaults = {
        'supcfp_restringe_desconto': True,
        'supcfp_qtd_cancela': 3,
    }

