# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class supervisor_dav_capa(osv.Model):
    """
    Tabela de capa do DAV
    Prefixo: supdva
    """
    _name = 'supervisor.dav.capa'
    _gerar_logs_logs = 'N'
    _columns = {
        'supdva_nro_pedido': fields.integer('Nro. DAV', readonly=True),
        'supdva_data_hora': fields.datetime('Data hora'),
        'supdva_cliente': fields.char('Cliente', size=15),
        'supdva_nome_cliente': fields.char('Nome cliente', size=60),
        'supdva_operador_id': fields.many2one("supervisor.cad.operadores", 'Operador', ondelete="restrict",
                                              select=True),
        'supdva_vendedor_id': fields.many2one("supervisor.cad.vendedor", 'Vendedor', ondelete="restrict",
                                              select=True),
        'supdva_juros': fields.float('Juros'),
        'supdva_descontos': fields.float('Descontos'),
        'supdva_data_cupom': fields.datetime('Supdav data cupom', oldname="supdav_data_cupom"),
        'supdva_restricao': fields.integer('Restricao'),
        'supdva_total_dav': fields.float('Total dav', digits=(10,2)),
        'supdva_avisos': fields.char('Avisos', size=255),
        'supdva_dav_corpo_ids': fields.one2many('supervisor.dav.corpo', 'supdvo_capa_id', 'Corpo'),
        'supdva_dav_fechamento_ids': fields.one2many('supervisor.dav.fechamento', 'supdvf_capa_id', 'Fechamento'),
        'supdva_loja': fields.integer('Loja'),
        'supdva_caixa': fields.integer('Caixa'),
        'supdva_nro_cupom': fields.integer('Cupom'),
    }

