# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class supervisor_dav_corpo(osv.Model):
    """
    Tabela de itens do DAV
    Prefixo: supdvo
    """
    _name = 'supervisor.dav.corpo'
    _gerar_logs_logs = 'N'
    _columns = {
        'supdvo_capa_id': fields.many2one("supervisor.dav.capa", 'capa', ondelete="cascade", required=True,
                                          select=True, oldname="supdva_capa_id"),
        'supdvo_sequencia': fields.integer('sequencia', required=True, oldname="supdva_sequencia"),
        'supdvo_numero_do_dav': fields.integer('numero do dav', oldname="supdva_numero_do_dav"),
        'supdvo_data_hora': fields.datetime('data hora', oldname="supdva_data_hora"),
        'supdvo_item': fields.char('item', size=14, oldname="supdva_item"),
        'supdvo_quantidade': fields.float('quantidade', digits=(10, 2), oldname="supdva_quantidade"),
        'supdvo_quantidade_conferida': fields.float('quantidade conferida', digits=(10, 2),
                                                    oldname="supdva_quantidade_conferida"),
        'supdvo_vr_total': fields.float('vr total', digits=(10, 3), oldname="supdva_vr_total"),
        'supdvo_desconto_item': fields.float('desconto item', digits=(10, 3), oldname="supdva_desconto_item"),
        'supdvo_acrescimo_item': fields.float('acrescimo item', digits=(10, 3), oldname="supdva_acrescimo_item"),
        'supdvo_venda_cancelamento': fields.char('venda cancelamento', size=1, oldname="supdva_venda_cancelamento"),
        'supdvo_descricao': fields.char('descricao', size=60, oldname="supdva_descricao"),
        'supdvo_unidade': fields.char('unidade', size=3, oldname="supdva_unidade"),
        'supdvo_vr_unit': fields.float('vr unit', digits=(10, 2), oldname="supdva_vr_unit"),
        'supdvo_totalizador_parcial': fields.char('totalizador parcial', size=7, oldname="supdva_totalizador_parcial"),
        'supdvo_vendedor_id': fields.many2one("supervisor.cad.vendedor", 'Vendedor',
                                              ondelete="restrict", select=True),
    }
    _defaults = {
        'supdvo_totalizador_parcial': lambda *a: 'NULL',
    }

