# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
import time


class supervisor_dav_fechamento(osv.Model):
    """
    Tabela de fechamento do DAV
    Prefixo: supdvf
    """
    _name = 'supervisor.dav.fechamento'
    _gerar_logs_logs = 'N'
    _columns = {
        'supdvf_capa_id': fields.many2one("supervisor.dav.capa", 'Capa', ondelete="cascade", required=True, select=True),
        'supdvf_sequencia': fields.integer('Sequencia', required=True),
        'supdvf_finalizadora': fields.integer('Finalizadora'),
        'supdvf_valor': fields.float('Valor'),
        'supdvf_cheque_banco': fields.integer('Cheque banco'),
        'supdvf_cheque_agencia': fields.integer('Cheque agencia'),
        'supdvf_cheque_numero': fields.char('Cheque numero', size=9),
        'supdvf_cheque_conta': fields.integer('Cheque conta'),
        'supdvf_cheque_juros': fields.float('Cheque juros'),
        'supdvf_cheque_cnpj': fields.char('Cheque cnpj', size=15),
        'supdvf_dav_vencimentos_ids': fields.one2many('supervisor.dav.vencimentos', 'supdvv_fechamento_id', 'Vencimentos'),
    }
    _defaults = {
        'supdvf_cheque_cnpj': lambda *a: 'NULL',
    }

