# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2015 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz:siginformatica.com.br>
                                -------

Copyleft (CC) 2015, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

import logging
from openerp.tools.translate import _

# --------------------------------- supervisor.cad.bandeiras --------------------------------- #
def _supban_get_descricao_completa(self, cr, uid, ids, name, arg, context=None):

    """
    Concatena o código + descrição da bandeira.

    :param cr: {cursor} a linha atual do cursor do banco de dados,
    :param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    :param ids: {list} lista dos IDs,
    :param name: {list} lista com o nome dos campos,
    :param arg: {dict} dicionario com os argumentos e valores,
    :param context: {dict} um dicionario padrao para valores contextuais,
    :return: {dict} valores ajustados dos campos.

    :author: Dener Luiz Rodrigues da Silva <dl.rodrigues94[at]gmail.com>
    """

    context = context and context.copy() or {}

    if ids and isinstance(ids, (int, long)):
        ids = [ids]

    res = {}

    for bandeira in self.browse(cr, uid, ids, context=context):
        res[bandeira.id] = str(bandeira.supban_codigo).rjust(5, '0') + ' - ' + bandeira.name

    return res


# ______________________________ supervisor.log.importacao _________________________________
def get_percentual_progresso(self, cr, uid, ids, field_name, args, context=None):
    """
    Metodo de campo funcao. Calcula o percentual que representa o progresso da importacao dos
    arquivos
    :param cr: cursor no banco de dados
    :param uid: id da tabela res_users, identificador do usuario
    :param ids: lista de id da tabela supervisor_log_importacao
    :param field_name: nome do campo que recebera o resultado do calculo
    :param args: lista de argumentos
    :param context: dicionario com valores contextuais
    :return: dicionario, com chave e valor representando o id da tabela supervisor_log_importacao e
    o resultado do calculo, respectivamente
    """
    context = context and context.copy() or {}
    res = {}
    brw_log_importacao = self.browse(cr, uid, ids, context)
    for log in brw_log_importacao:
        qtd_importada = log.suplog_qtd_importada or 0
        qtd_a_importar = log.suplog_qtd_a_importar or 0
        qtd_total = qtd_a_importar + qtd_importada
        progresso = 0.0
        if qtd_total:
            progresso = (float(qtd_importada) / qtd_total) * 100
        res[log.id] = progresso
    return res


# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
