# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from funcoes import get_percentual_progresso


class supervisor_log_importacao(osv.Model):
    # prefixo: suplog_

    _name = 'supervisor.log.importacao'
    _gerar_logs_logs = 'N'
    _columns = {
        'create_date': fields.datetime('Data/hora importacao', readonly=True),
        'state': fields.selection([('I', 'Importando'), ('P', 'Importado'), ('E', 'Erro')],
                                  'Estado', size=1),
        'suplog_qtd_importada': fields.integer('Quantidade importada'),
        'suplog_qtd_a_importar': fields.integer('Quantidade a importar'),
        'suplog_item_ids': fields.one2many('supervisor.log.importacao.item', 'suploi_capa_id',
                                           'Itens'),
        'suplog_percentual_progresso': fields.function(get_percentual_progresso, method=True,
                                                       string='Progresso', type='float',
                                                       digits=(5, 2), store=True),
        'suplog_importacao': fields.char('Data/hora importacao / Nome', size=40),
    }
    _defaults = {
        'state': lambda *a: 'I',
    }


class supervisor_log_importacao_item(osv.Model):
    # prefixo: suploi_

    _name = 'supervisor.log.importacao.item'
    _columns = {
        'suploi_capa_id': fields.many2one('supervisor.log.importacao', 'Capa'),
        'suploi_erro': fields.text('Erro'),
    }
