# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class supervisor_mov_caixa(osv.Model):
    """
    Tabela de Caixa
    Prefixo: supcax
    """
    _name = 'supervisor.mov.caixa'
    _gerar_logs_logs = 'N'
    _columns = {
        'supcax_loja': fields.integer('Loja', required=True),
        'supcax_caixa': fields.integer('Caixa', required=True),
        'supcax_data_hora_abertura': fields.datetime('Data hora abertura'),
        'supcax_data_hora_fechamento': fields.datetime('Data hora fechamento'),
        'supcax_fechado': fields.char('Fechado', size=1),
        'supcax_operador_id': fields.many2one("supervisor.cad.operadores", 'Operador',
                                              ondelete="no action", required=True, select=True),
        'supcax_enviado': fields.selection([('S', 'Sim'), ('N', 'Nao')], 'Enviado'),
    }
    _defaults = {
        'supcax_enviado': lambda *a: 'N',
    }

