# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
import time


class supervisor_mov_corpo_xz(osv.Model):
    """
    Tabela complementar capa para X e Z
    Prefixo: supcxz
    """
    _inherits = {
        'supervisor.mov.capa': 'supcxz_capa_id',
    }
    _name = 'supervisor.mov.corpo.xz'
    _gerar_logs_logs = 'N'
    _columns = {
        'supcxz_capa_id': fields.many2one("supervisor.mov.capa", 'Capa', ondelete="cascade", required=True, select=True),
        'supcxz_data_movimento': fields.date('Data movimento', required=True, select=True),
        'supcxz_cro': fields.integer('Cro'),
        'supcxz_cupom_inicial': fields.integer('Cupom inicial'),
        'supcxz_cupom_final': fields.integer('Cupom final'),
        'supcxz_gt_atual': fields.float('Gt atual', digits=(16,3)),
        'supcxz_gt_anterior': fields.float('Gt anterior', digits=(16,3)),
        'supcxz_cancelamentos': fields.float('Cancelamentos', digits=(16,3)),
        'supcxz_descontos': fields.float('Descontos', digits=(16,3)),
        'supcxz_acrescimos': fields.float('Acrescimos', digits=(16,3)),
        'supcxz_modelo_ecf': fields.char('Modelo ecf', size=20),
        'supcxz_parametro_desconto_iss': fields.boolean('Parametro desconto iss'),
        'supcxz_descontos_iss': fields.float('Descontos iss', digits=(16,3)),
        'supcxz_acrescimos_iss': fields.float('Acrescimos iss', digits=(16,3)),
        'supcxz_cancelamentos_iss': fields.float('Cancelamentos iss', digits=(16,3)),
        'supcxz_ccf': fields.integer('Ccf'),
        'supcxz_gnf': fields.integer('Gnf'),
    }

