# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class supervisor_mov_corpos(osv.Model):
    """
    Tabela de itens dos cupons
    Prefixo: supcor
    """
    _inherits = {
        'supervisor.mov.capa': 'supcor_capa_id',
    }
    _name = 'supervisor.mov.corpos'
    _gerar_logs_logs = 'N'
    _columns = {
        'supcor_capa_id': fields.many2one("supervisor.mov.capa", 'Capa', ondelete="cascade",
                                          required=True, select=True),
        'supcor_kit_vendido_id': fields.many2one("supervisor.mov.kits.vendidos", 'Kit',
                                                 ondelete="cascade", select=True),
        'supcor_sequencia': fields.integer('Sequencia', required=True),
        'supcor_nro_serie': fields.char('Nro serie', size=20),
        'supcor_item': fields.char('Item', size=14),
        'supcor_nome_item': fields.char('Nome item', size=60),
        'supcor_nro_serie_item': fields.char('Nro serie item', size=30),
        'supcor_quantidade': fields.float('Quantidade', digits=(10, 3)),
        'supcor_unidade': fields.char('Unidade', size=3),
        'supcor_preco_unitario': fields.float('Preco unitario', digits=(10, 3)),
        'supcor_preco_total': fields.float('Preco total', digits=(10, 3)), # preco bruto do item sem desconto
                                                                           # ou acrescimo
        'supcor_vr_imposto_fed': fields.float('Vr imposto', digits=(10, 2)),
        'supcor_vr_imposto_est': fields.float('Vr imposto', digits=(10, 2)),
        'supcor_vr_imposto_mun': fields.float('Vr imposto', digits=(10, 2)),
        'supcor_ibpt_chave': fields.char('Chave ibpt', size=10),
        'supcor_desconto_item': fields.float('Desconto item', digits=(10, 3)),
        'supcor_acrescimo_item': fields.float('Acrescimo item', digits=(10, 3)),
        'supcor_desconto_item_sem_rat': fields.float('Desconto item', digits=(10, 3)), # Sem desconto da capa rateado(apenas para sacnntech)
        'supcor_acrescimo_item_sem_rat': fields.float('Acrescimo item', digits=(10, 3)), # Sem acrescimo da capa rateado(apenas para sacnntech)
        'supcor_venda_cancelamento': fields.selection([('V', 'Venda'),
                                                       ('C', 'Cancelamento'),
                                                       ('I', 'Inutilizado')],
                                                      'Venda cancelamento'),
        'supcor_cancelado': fields.boolean('Cancelado na venda',
                                           help="Item cancelado na venda e a nota foi faturada"),
        'supcor_tributacao_ecf': fields.char('Tributacao ecf', size=3),
        'supcor_tributacao_retag': fields.integer('Tributacao retag'),
        'supcor_codigo_anp': fields.integer('Combustivel/Lubrificante'),
        'supcor_adrem': fields.float('Aliquota adRemICMSRet', digits=(7, 4)),
        'supcor_pglp':  fields.float('Percentual do GLP', digits=(7, 4),
                                     help='Percentual do GLP derivado do petróleo no '
                                          'produto GLP (cProdANP=210203001)(Valores de 0 a 100)'),
        'supcor_pgnn': fields.float('Percentual de Gás Natural Nacional', digits=(7, 4),
                                     help='Percentual de Gás Natural Nacional - GLGNn para o '
                                          'produto GLP (cProdANP=210203001)(Valores de 0 a 100)'),
        'supcor_pgni': fields.float('Percentual de Gás Natural Importado', digits=(7, 4),
                                     help='Percentual de Gás Natural Importado - GLGNi para o '
                                          'produto GLP (cProdANP=210203001)(Valores de 0 a 100)'),
        'supcor_vpart': fields.float('Valor de partida (cProdANP=210203001)', digits=(13, 2),
                                     help='Deve ser informado neste campo o valor por quilograma'
                                          ' sem ICMS'),
        'supcor_aliquota': fields.float('Aliquota', digits=(5, 2)),
        'supcor_base': fields.float('Base', digits=(10, 2)),
        'supcor_vr_fcp_st': fields.float('Base', digits=(15, 2)),
        'supcor_vr_icms': fields.float('Valor ICMS', digits=(10, 2)),
        'supcor_base_icms': fields.float('Base ICMS', digits=(10, 2)),
        'supcor_codigo_trib_icms': fields.integer('Codigo da tributacao ICMS'),
        'supcor_vr_pis': fields.float('Valor PIS', digits=(10, 2)),
        'supcor_base_pis': fields.float('Base PIS', digits=(10, 2)),
        'supcor_codigo_trib_pis': fields.integer('Codigo da tributacao PIS'),
        'supcor_vr_cofins': fields.float('Valor COFINS', digits=(10, 2)),
        'supcor_base_cofins': fields.float('Base COFINS', digits=(10, 2)),
        'supcor_codigo_trib_cofins': fields.integer('Codigo da tributacao COFINS'),
        'supcor_totalizador_parcial': fields.char('Totalizador parcial', size=7),
        'supcor_tipo_tributacao': fields.selection([('T', 'Tributado'),
                                                    ('F', 'Substituicao'),
                                                    ('I', 'Isentos'),
                                                    ('N', 'Nao tributado')], 'Tipo tributacao'),
        'supcor_indicador_arr_trunc': fields.selection([('T', 'Truncamento'),
                                                        ('A', 'Arredondamento')],
                                                       'Indicador arr trunc'),
        'supcor_indicador_ppt': fields.selection([('P', 'Propria'), ('T', 'Terceiros')],
                                                 'Indicador ppt'),
        'supcor_ncm': fields.char('Ncm', size=8),
        'supcor_cest': fields.char('Cest', size=7),
        'supcor_ccf': fields.integer('Ccf'),
        'supcor_cod_vendedor': fields.integer('Cód.vendedor'),
        'supcor_nome_vendedor': fields.char('Vendedor item', size=40),
        'supcor_codigo_cfop': fields.char('Codigo CFOP', size=4, select=True),
        'supcor_codigo_retaguarda': fields.char('Codigo retaguarda', size=20, select=True),
        'supcor_producao': fields.selection([('P', 'Propria'), ('T', 'Terceiro')], 'Producao'),
        'supcor_origem_mercadoria': fields.char("Origem da mercadoria", size=1),
        'supcor_aliquota_ibpt_fed': fields.float('Aliquota de Tributos Federais', digits=(5, 2)),
        'supcor_aliquota_ibpt_est': fields.float('Aliquota de Tributos Estaduais', digits=(5, 2)),
        'supcor_aliquota_ibpt_mun': fields.float('Aliquota de Tributos Municipais', digits=(5, 2)),
        'supcor_getin': fields.boolean("Tem GETIN"),
        'supcor_codigo_cst_icms': fields.char('Codigo CST ICMS', size=2),
        'supcor_tipo_tributacao_icms': fields.char('Tipo de tributacao ICMS', size=2),
        'supcor_codigo_csosn_icms': fields.char('Codigo CSOSN ICMS', size=3),
        'supcor_aliquota_icms': fields.float('Aliquota ICMS', digits=(5, 2)),
        'supcor_codigo_beneficio_icms': fields.char('Codigo de Beneficio Fiscal ICMS', size=10),
        'supcor_motivo_beneficio_icms': fields.char('Motivo do Beneficio Fiscal ICMS', size=2),
        'supcor_aliquota_fcp_icms': fields.float('Aliquota FCP ICMS', digits=(5,2)),
        'supcor_aliquota_pis': fields.float('Aliquota PIS', digits=(5, 2)),
        'supcor_codigo_cst_pis': fields.char('Codigo CST PIS', size=2),
        'supcor_aliquota_cofins': fields.float('Aliquota COFINS', digits=(5, 2)),
        'supcor_codigo_cst_cofins': fields.char('Codigo CST COFINS', size=2),
    }

    _order = 'supcor_sequencia'