# -*- encoding: utf-8 -*-
# #############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
import time


class supervisor_mov_fechamentos(osv.Model):
    """
    Tabela de Fechamento dos cupons
    Prefixo: supfec
    """
    _inherits = {
        'supervisor.mov.capa': 'supfec_capa_id',
    }
    _name = 'supervisor.mov.fechamentos'
    _gerar_logs_logs = 'N'
    _rec_name = 'supfec_tipo_finalizadora'

    _columns = {
        'id': fields.integer('id', readonly=True),
        'supfec_capa_id': fields.many2one("supervisor.mov.capa", 'Mov capa', ondelete="cascade",
                                          required=True, select=True, oldname='supfec_mov_capa_id'),
        'supfec_sequencia': fields.integer('Sequencia', required=True),
        'supfec_ccf': fields.integer('Ccf'),
        'supfec_gnf': fields.integer('Gnf'),
        'supfec_cdc': fields.integer('Cdc'),
        'supfec_nro_serie': fields.char('Nro serie', size=20),
        'supfec_finalizadora': fields.integer('Finalizadora'), # codigo da finalizadora
        'supfec_tipo_finalizadora': fields.selection([('D', 'Dinheiro'),
                                                      ('H', 'Cheque'),
                                                      ('C', 'Cartao'),
                                                      ('T', 'Ticket'),
                                                      ('O', 'Outros')], 'Tipo de finalizadora'),
        'supfec_valor': fields.float('Valor', digits=(10, 2)),
        'supfec_troco': fields.float('Troco', digits=(10, 2)),
        'supfec_nro_banco': fields.integer('Nro banco'),
        'supfec_agencia': fields.integer('Agencia'),
        'supfec_nro_cheque': fields.integer('Nro cheque'),
        'supfec_conta': fields.integer('Conta'),
        'supfec_juros': fields.float('Juros', digits=(8, 2)),
        'supfec_cnpj': fields.char('Cnpj', size=15),
        'supfec_desconto_proporcional': fields.float('Desconto proporcional', digits=(8, 2)),
        'supfec_acrescimo_proporcional': fields.float('Acrescimo proporcional', digits=(8, 2)),
        'supfec_cnpj_convenio': fields.char('Cnpj convenio', size=15),
        'supfec_nro_autorizacao': fields.char('Nro autorizacao', size=15),
        'supfec_nome_finalizadora': fields.char('Nome finalizadora', size=100),
        'supfec_mov_vencimentos_ids': fields.one2many('supervisor.mov.vencimentos',
                                                      'supfve_fechamentos_id', 'Vencimentos'),
        'supfec_cnpj_cartao': fields.char('Cnpj Administradora de Cartao', size=15),
        'supfec_aut_cartao': fields.char('Autorizacao de Cartao', size=20),
    }
    _order = 'supfec_capa_id,id'

