# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
import time


class supervisor_mov_totalizadores_xz(osv.Model):
    """
    Tabela de Totalizadores do X e do Z
    Prefixo: suptxz
    """
    _inherits = {
        'supervisor.mov.capa': 'suptxz_capa_id',
    }
    _name = 'supervisor.mov.totalizadores.xz'
    _gerar_logs_logs = 'N'
    _columns = {
        'suptxz_capa_id': fields.many2one("supervisor.mov.capa", 'Capa', ondelete="cascade",
                                          required=True, select=True),
        'suptxz_codigo_trib_ecf': fields.char('Codigo trib ecf', size=3, required=True),
        'suptxz_descricao_totalizador': fields.char('Descricao totalizador', size=30),
        'suptxz_valor': fields.float('Valor do imposto', digits=(9,3)),
        'suptxz_aliquota': fields.float('Aliquota', digits=(4,2)),
        'suptxz_base': fields.float('Base do imposto', digits=(5,2)),
        'suptxz_tipo_imposto': fields.selection([('C','ICMS'), ('S', 'ISS')], 'Tipo imposto'), # C=ICMS, S=ISS
        'suptxz_tipo_tributacao': fields.selection([('T', 'Tributado'),
                                                    ('F', 'Substituicao'),
                                                    ('I', 'Isento'),
                                                    ('N', 'Nao tributado')], 'Tipo tributacao'), # T=Tributado, F=Substituicao, I=Isentos, N=Nao tributados
        'suptxz_crz': fields.integer('Crz'),
        'suptxz_nro_serie': fields.char('Nro serie', size=20),
    }

