# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
import time


class supervisor_nfe_capa(osv.Model):
    """
    Tabela de capa da nfe
    Prefixo: supnfa
    """
    _name = 'supervisor.nfe.capa'
    _gerar_logs_logs = 'N'
    _columns = {
        'supnfa_serie_nf': fields.char('Serie nf', size=3),
        'supnfa_modelo_nf': fields.char('Modelo nf', size=2),
        'supnfa_destinatario_doc': fields.char('Destinatario doc', size=15),
        'supnfa_destinatario_fone': fields.char('Destinatario fone', size=15),
        'supfna_forma_pgto': fields.integer('Supfna forma pgto'),
        'supnfa_destinatario_nome': fields.char('Destinatario nome', size=60),
        'supnfa_destinatario_uf': fields.char('Destinatario uf', size=2),
        'supnfa_destinatario_municipio': fields.char('Destinatario municipio', size=255),
        'supnfa_destinatario_cmunicipio': fields.integer('Destinatario cmunicipio'),
        'supnfa_destinatario_cep': fields.char('Destinatario cep', size=8),
        'supnfa_destinatario_endereco': fields.char('Destinatario endereco', size=255),
        'supnfa_destinatario_bairro': fields.char('Destinatario bairro', size=60),
        'supnfa_destinatario_numero': fields.char('Destinatario numero', size=20),
        'supnfa_destinatario_cpl': fields.char('Destinatario cpl', size=255),
        'supnfa_transportador': fields.integer('Transportador'),
        'supnfa_data_emissao': fields.date('Data emissao'),
        'supnfa_data_saida_entrada': fields.datetime('Data saida entrada'),
        'supnfa_hora_emissao': fields.float('Hora emissao', digits=(3,2)),
        'supnfa_natureza': fields.char('Natureza', size=255),
        'supnfa_peso_liquido': fields.float('Peso liquido', digits=(10,2)),
        'supnfa_numero_nf': fields.integer('Numero nf'),
        'supnfa_tipo': fields.char('Tipo', size=16),
        'supnfa_numero_volume': fields.char('Numero volume', size=15),
        'supnfa_peso_bruto': fields.float('Peso bruto', digits=(10,2)),
        'supnfa_vr_base_icms_frete': fields.float('Vr base icms frete', digits=(10,2)),
        'supnfa_quantidade_volume': fields.integer('Quantidade volume'),
        'supnfa_nfe_lote': fields.char('Nfe lote', size=15),
        'supnfa_nfe_protocolo': fields.char('Nfe protocolo', size=15),
        'supnfa_vr_total_nf': fields.float('Vr total nf', digits=(10,0)),
        'supnfa_vr_desconto': fields.float('Vr desconto', digits=(10,0)),
        'supnfa_state': fields.integer('State'),
        'supnfa_condicao_pgto': fields.integer('Condicao pgto'),
        'supnfa_nfe_processo_emissao': fields.char('Nfe processo emissao', size=16),
        'supnfa_nfe_protocolo_cancelamento': fields.char('Nfe protocolo cancelamento', size=15),
        'supnfa_especie': fields.char('Especie', size=15),
        'supnfa_vr_despesas_acessorias': fields.float('Vr despesas acessorias', digits=(10,0)),
        'supnfa_vr_frete': fields.float('Vr frete', digits=(10,0)),
        'supnfa_nfe_chave_acesso': fields.char('Nfe chave acesso', size=44),
        'supnfa_nfe_xml_cancelamento': fields.text('Nfe xml cancelamento'),
        'supnfa_nfe_xml_gerado': fields.text('Nfe xml gerado'),
        'supnfa_nfe_status': fields.char('Nfe status', size=255),
        'supnfa_nfe_xml_proc': fields.text('Nfe xml proc'),
        'supnfa_observacao': fields.char('Observacao', size=255),
        'supnfa_vr_total_deducao': fields.float('Vr total deducao', digits=(10,2)),
        'supnfa_nfe_corpos_ids': fields.one2many('supervisor.nfe.corpos', 'supnfo_nfe_capa_id', 'Corpos'),
    }

