# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class supervisor_pve_capa(osv.Model):
    """
    Tabela de Capa da Prevenda
    Prefixo: suppva
    """
    _name = 'supervisor.pve.capa'
    _gerar_logs_logs = 'N'
    _columns = {
        'id': fields.integer('Nro Pre-venda', readonly=True),
        'suppva_data_hora': fields.datetime('Data hora'),
        'suppva_cliente': fields.char('Cliente', size=15),
        'suppva_operador_id': fields.many2one("supervisor.cad.operadores", 'Operadore', ondelete="restrict",
                                              required=True, select=True, oldname="suppva_operadore_id"),
        'suppva_loja': fields.integer('Loja'),
        'suppva_juros': fields.float('Juros', digits=(10, 2)),
        'suppva_descontos': fields.float('Descontos', digits=(10, 2)),
        'suppva_data_cupom': fields.date('Data cupom'),
        'suppva_restricao': fields.integer('Restricao'),
        'suppva_nome_cliente': fields.char('Nome cliente', size=60),
        'suppva_total_pve': fields.float('Total pve', digits=(10, 2)),
        'suppva_pve_corpo_ids': fields.one2many('supervisor.pve.corpo', 'suppvo_capa_id', 'Corpo'),
        'suppva_pve_fechamento_ids': fields.one2many('supervisor.pve.fechamento', 'suppvf_capa_id', 'Fechamento'),
        'suppva_caixa': fields.integer('Caixa'),
        'suppva_nro_cupom': fields.integer('Nro Cupom'),
    }
