# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
from openerp.osv import osv
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.informaNome(pdf_string, _('Acompanhamento de doacoes'))
        listagem.informaTamLinha(52)
        listagem.defineFormato(orientacao='0')
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)
        listagem.defineFonte(tam=14)
        data_ini = datas.get('data_ini')
        data_fim = datas.get('data_fim')
        loja = datas.get('loja')
        caixa = datas.get('caixa')
        dados = datas.get('dados')
        obj_supervisor_cfg_configuracao = pooler.get_pool(cr.dbname).get(
            'supervisor.cfg.configuracao')
        configuracao_ids = obj_supervisor_cfg_configuracao.search(cr, uid, [], context=context)
        nome_empresa = ''
        if configuracao_ids:
            nome_empresa = obj_supervisor_cfg_configuracao.browse(
                cr, uid, configuracao_ids[0], context=context).supcfc_cliente or ''
        data_hoje = time.strftime("%d/%m/%Y")
        title = center_title(_('Sistema de PDVs'), '', '', 52)
        title1 = center_title('%s', '', '', 52) % nome_empresa
        docs = center_title('', _('Acompanhamento de doacoes'), '', 52)
        docs2 = center_title(_('Data: %s') % data_hoje, '', _('Pagina: {{ Page }} '), 60)
        data_ini = time.strftime('%d/%m/%Y', time.strptime(data_ini, '%Y-%m-%d'))
        data_fim = time.strftime('%d/%m/%Y', time.strptime(data_fim, '%Y-%m-%d'))
        docs3 = center_title(_('Data Movimento: %s a %s') % (data_ini, data_fim), '', '', 52)
        docs4 = center_title(_('Loja: %s    Caixa: %s') % (loja or 'Todas', caixa or 'Todos'), '',
                             '', 52)
        listagem.informaCab('' + title)
        listagem.informaCab('' + title1)
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab('' + docs2)
        listagem.informaCab('  ')
        listagem.informaCab('' + docs3)
        listagem.informaCab('' + docs4)
        listagem.informaCab('  ')
        linha_divisoria = '*%s*' % ''.ljust(50, '-')
        listagem.informaCab(linha_divisoria)
        listagem.informaCab(_('|   DATA   | LOJA | CAIXA |   COO   |    VALOR     |'))
        listagem.informaCab(linha_divisoria)
        listagem.rodapePadrao()
        valor_total = 0
        for i in dados:
            linha = [formataString(i.get('data') or '', 10, ' ', 'E', 'N', 'S'),
                     formataString('%s ' % i.get('loja'), 6, ' ', 'E', 'N', 'S'),
                     formataString('%s ' % i.get('caixa'), 7, ' ', 'E', 'N', 'S'),
                     formataString('%s ' % i.get('coo'), 9, ' ', 'E', 'N', 'S'),
                     formataString(getNumeroEditado(i.get('valor'), 2), 13, ' ', 'E', 'N', 'S')]
            listagem.imprimeLinha('|%s |' % '|'.join(linha))
            valor_total += i.get('valor')

        listagem.imprimeLinha(linha_divisoria)
        linha = [formataString(_('TOTAL'), 35, ' ', 'D', 'N', 'S'),
                 formataString(getNumeroEditado(valor_total, 2), 13, ' ', 'E', 'N', 'S')]
        listagem.imprimeLinha('|%s |' % '|'.join(linha))
        listagem.imprimeLinha(linha_divisoria)
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_acompanhamento_doacao')