# -*- coding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _


class wizard_acompanhamento_acrescimo(osv.TransientModel):
    _name = 'wizard.acompanhamento.acrescimo'
    _columns = {
        'data_ini': fields.date('Data Inicial', required=True),
        'data_fim': fields.date('Data Final', required=True),
        'loja': fields.integer('Loja'),
        'caixa': fields.integer('Caixa'),
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        acompanhamento_acrescimo_dados = self.read(
            cr, uid, ids[0] if isinstance(ids, (list, tuple)) else ids, [], context=context)
        datas = {
            'data_ini': acompanhamento_acrescimo_dados.get('data_ini'),
            'data_fim': acompanhamento_acrescimo_dados.get('data_fim'),
            'loja': acompanhamento_acrescimo_dados.get('loja', False),
            'caixa': acompanhamento_acrescimo_dados.get('caixa', False),
        }

        caixa = datas.get('caixa')
        loja = datas.get('loja')
        data_ini = datas.get('data_ini')
        data_fim = datas.get('data_fim')
        cond_caixa = ''
        cond_loja = ''
        if caixa:
            cond_caixa = 'AND supcap_caixa = %s' % caixa

        if loja:
            cond_loja = 'AND supcap_loja = %s' % loja

        sql = """
            SELECT cap.supcap_nro_cupom              AS coo,
                   cap.supcap_loja                   AS loja,
                   cap.supcap_caixa                  AS caixa,
                   cap.supcap_tipo                   AS tipo,
                   COALESCE (cap.supcap_cliente, '') AS cliente,
                   SUM(cor.supcor_preco_total)       AS supcor_preco_total,
                   SUM(cor.supcor_acrescimo_item)    AS supcor_acrescimo_item
            FROM supervisor_mov_capa              AS cap
            INNER JOIN supervisor_mov_corpos      AS cor ON cor.supcor_capa_id = cap.id  
            WHERE supcap_data_cupom >= '{data_ini}'
              AND supcap_data_cupom <= '{data_fim}'
              AND supcap_tipo in ('V', 'C')
              AND not (cor.supcor_venda_cancelamento = 'C' AND  cap.supcap_tipo = 'V')
              AND cor.supcor_acrescimo_item > 0
              {cond_caixa}
              {cond_loja}
            GROUP BY cap.supcap_nro_cupom,
                     cap.supcap_loja,
                     cap.supcap_caixa,
                     cap.supcap_tipo,
                     cap.supcap_cliente
              """.format(data_ini=data_ini,
                         data_fim=data_fim,
                         cond_caixa=cond_caixa,
                         cond_loja=cond_loja)
        cr.execute(sql)
        dados_corpos = cr.dictfetchall()
        if not dados_corpos:
            raise osv.except_osv(_('Atencao!'),
                                 _('Nao ha registros com estes filtros!'))
        datas['dados_corpos'] = dados_corpos
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'listagem_acompanhamento_acrescimo',
            'datas': datas,
        }
