# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _


class wizard_acompanhamento_desconto(osv.TransientModel):
    _name = 'wizard.acompanhamento.desconto'
    _columns = {
        'data_ini': fields.date('Data Inicial', required=True),
        'data_fim': fields.date('Data Final', required=True),
        'loja': fields.integer('Loja'),
        'caixa': fields.integer('Caixa'),
        'somente_desconto': fields.boolean('Somente Desconto')
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        for x in self.read(cr, uid, ids, [], context=context):
            datas = {
                'data_ini': x.get('data_ini'),
                'data_fim': x.get('data_fim'),
                'loja': x.get('loja', False),
                'caixa': x.get('caixa', False),
                'somente_desconto': x.get('somente_desconto') or False,
            }

        caixa = datas.get('caixa')
        loja = datas.get('loja')
        data_ini = datas.get('data_ini')
        data_fim = datas.get('data_fim')
        cond_caixa = caixa and ('AND supcap_caixa = %s' % caixa) or ''
        cond_loja = loja and ('AND supcap_loja = %s' % loja) or ''
        cond_desconto = datas.get('somente_desconto') and \
                        'AND cor.supcor_desconto_item > 0' or ''
        sql = """
            SELECT cap.supcap_nro_cupom              AS coo,
                   cap.supcap_caixa                  AS caixa,
                   cap.supcap_tipo                   AS tipo,
                   COALESCE (cap.supcap_cliente, '') AS cliente,
                   COALESCE (sco.name , '')          AS nome_autorizador,
                   SUM(cor.supcor_preco_total)       AS supcor_preco_total,
                   SUM(CASE WHEN sa.supaut_liberou_desconto
                            THEN cor.supcor_desconto_item
                            ELSE 0
                       END)                          AS supcor_desconto_item,
                   sa.supaut_liberou_desconto        AS liberou_desconto,
                   sa.supaut_liberou_cheque_a_vista,
                   sa.supaut_liberou_limite_credito,
                   sa.supaut_liberou_restricao_mensagem,
                   sa.supaut_liberou_cancelamento_cupom AS cancelou_cupom
            FROM supervisor_autorizacoes          AS sa  
            INNER JOIN supervisor_mov_capa        AS cap ON cap.id = sa.supaut_capa_id
            INNER JOIN supervisor_mov_corpos      AS cor ON cor.supcor_capa_id = cap.id  
            INNER JOIN supervisor_cad_operadores  AS sco ON sco.id = sa.supaut_autorizador_id
            WHERE supcap_data_cupom >= '{data_ini}'
              AND supcap_data_cupom <= '{data_fim}'
              AND supcap_tipo in ('V', 'C')
              AND not (cor.supcor_venda_cancelamento = 'C' AND  cap.supcap_tipo = 'V')
              AND CASE WHEN sa.supaut_liberou_desconto AND (NOT sa.supaut_liberou_cheque_a_vista AND 
                                                            NOT supaut_liberou_limite_credito AND 
                                                            NOT sa.supaut_liberou_restricao_mensagem)
                       THEN cor.supcor_desconto_item > 0
                       ELSE TRUE 
                  END 
              {cond_caixa}
              {cond_loja}
              {cond_desconto}
            GROUP BY cap.supcap_nro_cupom,
                     cap.supcap_caixa,
                     cap.supcap_tipo,
                     cap.supcap_cliente,
                     sco.name,
                     sa.supaut_liberou_desconto,
                     sa.supaut_liberou_cheque_a_vista,
                     sa.supaut_liberou_limite_credito,
                     sa.supaut_liberou_restricao_mensagem,
                     sa.supaut_liberou_cancelamento_cupom
              """.format(data_ini=data_ini,
                         data_fim=data_fim,
                         cond_caixa=cond_caixa,
                         cond_loja=cond_loja,
                         cond_desconto=cond_desconto)
        cr.execute(sql)
        dados_corpos = cr.dictfetchall()
        if not dados_corpos:
            raise osv.except_osv(_('Atencao!'),
                                 _('Nao ha registros com estes filtros!'))
        datas['dados_corpos'] = dados_corpos
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'listagem_acompanhamento_desconto',
            'datas': datas,
        }
