# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        data_titulo = time.strftime('%d/%m/%Y')
        hora_titulo = time.strftime('%H:%M:%S')
        obj_supervisor_cfg_configuracao = pooler.get_pool(cr.dbname).get(
            'supervisor.cfg.configuracao')
        configuracao_ids = obj_supervisor_cfg_configuracao.search(cr, uid, [], context=context)
        nome_empresa = ''
        if configuracao_ids:
            nome_empresa = obj_supervisor_cfg_configuracao.browse(
                cr, uid, configuracao_ids[0], context=context).supcfc_cliente or ''
        title1 = center_title(nome_empresa, 'Acompanhamento de vendas por faixa', '|', 140)
        title2 = center_title(data_titulo +'  '+hora_titulo,'','|', 140)
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Acompanhamento de vendas por faixa'))
        listagem.informaTamLinha(160)
        listagem.defineMargem(0.5,0.5,0.5,0.5)
        listagem.defineFonte(tam=6.7)

        data_inicial = datas.get('data_inicial')
        data_final = datas.get('data_final')

        data_inicial_cabecalho = time.strftime("%d/%m/%Y", time.strptime(data_inicial, "%Y-%m-%d"))
        data_final_cabecalho = time.strftime("%d/%m/%Y", time.strptime(data_final, "%Y-%m-%d"))

        listagem.informaCab(
              '*===========================================================================================================================================*')
        listagem.informaCab('|' + title1)
        listagem.informaCab(center_title('|',' ','|', 142))
        listagem.informaCab('|' + title2)
        listagem.informaCab(center_title('|',' ','|', 142))
        listagem.informaCab(
              '*===========================================================================================================================================*')
        listagem.informaCab(
            _('|   Valor Inicial   |    Valor Final    |   Valor Vendido   |    Perc. Venda    |    No de Vendas   |    Perc.Vendas    |    Valor medio    |'))
        listagem.informaCab(
              '*-------------------------------------------------------------------------------------------------------------------------------------------*')

        sql = """
                SELECT capa.id,
                       supcap_tipo,
                       supcap_state,
                       sum (
                            COALESCE(item.supcor_preco_total, 0.0) + 
                            COALESCE(item.supcor_acrescimo_item, 0.0) - 
                            COALESCE(item.supcor_desconto_item, 0.0)
                        ) AS supcap_total_cupom,
                       supcap_data_cupom,
                       supcap_data_fim
                FROM   supervisor_mov_capa capa
                LEFT JOIN supervisor_mov_corpos item
                    ON capa.id = item.supcor_capa_id
                WHERE  supcap_tipo IN ('C', 'V', 'D')
                AND    supcap_data_cupom >= '%s'
                AND    supcap_data_cupom <= '%s'
                AND CASE 
                        WHEN capa.supcap_tipo = 'V' THEN item.supcor_venda_cancelamento = 'V' 
                        ELSE TRUE 
                    END
                GROUP BY capa.id,
                         supcap_tipo,
                         supcap_state,
                         supcap_data_cupom,
                         supcap_data_fim
        """ % (data_inicial, data_final)


        cr.execute(sql)
        dados_mov_capa = cr.dictfetchall()

        total_por_faixa = {10:0.0, 20:0.0, 30:0.0, 50:0.0, 80:0.0, 100:0.0, 150:0.0,
                           200:0.0, 300:0.0, 400:0.0, 5000:0.0, 5000.01:0.0, 10000:0.0}  # 10000 representa o total geral
        numero_vendas_por_faixa =  {10:0, 20:0, 30:0, 50:0, 80:0, 100:0, 150:0,
                                    200:0, 300:0, 400:0, 5000:0, 5000.01:0, 10000:0}
        lista_chaves = total_por_faixa.keys()
        lista_chaves.sort()
        for capa in dados_mov_capa:
            total_cupom = capa.get('supcap_total_cupom')
            for j in lista_chaves:
                if total_cupom <= j  or (j==lista_chaves[-2] and total_cupom >= lista_chaves[-2]):
                    if capa.get('supcap_tipo') == 'V' and capa.get('supcap_state') == '6':
                        total_por_faixa[j] += total_cupom
                        numero_vendas_por_faixa[j] +=1
                        total_por_faixa[10000] += total_cupom
                        numero_vendas_por_faixa[10000] +=1
                        break

                    elif capa.get('supcap_tipo') == 'C' and not capa.get('supcap_state'):
                        total_por_faixa[j] -= total_cupom
                        numero_vendas_por_faixa[j] -=1
                        total_por_faixa[10000] -= total_cupom
                        numero_vendas_por_faixa[10000] -=1
                        break
        linha = '|'
        total_geral = 0.0
        for i in range(0,len(lista_chaves)):
            chave = lista_chaves[i]
            valor = total_por_faixa.get(chave)
            percent_valor = total_por_faixa.get(10000) and round(valor*100/total_por_faixa.get(10000), 2) or 0
            n_vendas = numero_vendas_por_faixa.get(chave)
            percent_n_vendas = 0
            if numero_vendas_por_faixa.get(10000):
                percent_n_vendas = round(float(n_vendas)*100/float(numero_vendas_por_faixa.get(10000)), 2)

            valor_medio = 0
            if n_vendas > 0:
                valor_medio = round(valor/n_vendas, 2)

            if chave == 10:
                linha += formataString('0,01', 19, ' ', 'E','N','S') + '|' + formataString(getNumeroEditado(chave,2), 19, ' ', 'E','N','S') + '|'
            elif  -0.001 < chave - 5000.01 and chave - 5000.01 < 0.001:
                linha += formataString('Acima de ' + getNumeroEditado(chave, 2), 19, ' ', 'E','N','S') + '|' + formataString('', 19, ' ', 'E','N','S') + '|'
            elif chave == 10000:
                break
            else:
                linha += formataString(getNumeroEditado(lista_chaves[i-1]+0.01, 2), 19, ' ', 'E','N','S') + '|' + formataString(getNumeroEditado(chave,2), 19, ' ', 'E','N','S') + '|'
            total_geral += valor
            linha += formataString(getNumeroEditado(valor,2), 19, ' ', 'E','N','S') + '|' + formataString(getNumeroEditado(percent_valor,2)+' % ', 19, ' ', 'E','N','S') + '|'
            linha += formataString(n_vendas, 19, ' ', 'E','N','S') + '|' + formataString(getNumeroEditado(percent_n_vendas,2)+' % ', 19, ' ', 'E','N','S') + '|'
            linha += formataString(getNumeroEditado(valor_medio,2), 19, ' ', 'E','N','S') + '|'
            listagem.imprimeLinha(linha)
            linha = '|'
        listagem.imprimeLinha(
            '*-------------------------------------------------------------------------------------------------------------------------------------------*')

        linha = formataString('', 41, ' ', 'E', 'N', 'S')
        linha += formataString(getNumeroEditado(total_geral, 2), 19, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.wizard_acompanhamento_vendas')


class wizard_acompanhamento_vendas(osv.TransientModel):
    _name = 'wizard.acompanhamento.vendas'
    _columns = {
        'data_inicial': fields.date('Data Inicial', required=True),
        'data_final': fields.date('Data Final', required=True),
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        acomp_vendas = self.read(cr, uid, ids, [], context=context)
        if isinstance(acomp_vendas, (list, tuple)):
            acomp_vendas = acomp_vendas[0]
        datas = {
            'data_inicial': acomp_vendas.get('data_inicial'),
            'data_final': acomp_vendas.get('data_final'),
        }

        sql = """
                SELECT supcap_tipo,
                       supcap_total_cupom,
                       supcap_data_cupom,
                       supcap_data_fim
                FROM   supervisor_mov_capa
                WHERE  supcap_tipo IN %s
                AND    supcap_data_cupom >= '%s'
                AND    supcap_data_cupom <= '%s' """ % (('C', 'V', 'D'), datas.get('data_inicial'), datas.get('data_final'))

        cr.execute(sql)
        dados_mov_capa = cr.dictfetchall()
        if not dados_mov_capa:
            raise osv.except_osv(_('Atencao'), _('Nao ha registro neste periodo'))
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'wizard_acompanhamento_vendas',
            'datas': datas,
        }
