# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
from openerp import pooler
import time
from openerp.tools.translate import _


class groupby(dict):
    def __init__(self, seq, key=lambda x: x):
        for value in seq:
            k = key(value)

            self.setdefault(k, []).append(value)

    __iter__ = dict.iteritems


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        title = center_title('', _('Apuracao Vendas Caixa'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.informaTamLinha(160)
        listagem.defineFormato(orientacao='1')
        listagem.defineFonte(tam=8.4)
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)
        listagem.informaNome(pdf_string, _('Apuracao Vendas Caixa'))

        data_inicial = datas.get('data_inicial')
        data_final = datas.get('data_final')
        numero_loja = datas.get('numero_loja')

        sql = """SELECT movcapa.supcap_loja                   AS loja,
                        movcapa.supcap_caixa                  AS caixa,
                        movcapa.supcap_data_cupom             AS data,
                        SUM(smf.supfec_valor)                 AS total_cupom,
                        SUM(smf.supfec_troco)                 AS troco,
			            CASE WHEN scf.name ilike '%%PIX%%'
                             THEN 'T'
                             ELSE smf.supfec_tipo_finalizadora    
                        END                                   AS tipo_finalizadora,
                        movcapa.supcap_indicador_cancelamento AS cancelamento,
                        movcapa.supcap_tipo                   AS tipo_cupom,
                        movcapa.supcap_data_fim
                 FROM   supervisor_mov_capa AS movcapa
                 LEFT JOIN supervisor_mov_fechamentos  AS smf ON smf.supfec_capa_id = movcapa.id
                 LEFT JOIN supervisor_cad_finalizadora AS scf ON scf.supfin_codigo = smf.supfec_finalizadora
                 WHERE  movcapa.supcap_data_cupom >= '%s'
                        AND movcapa.supcap_data_cupom <= '%s'
        """ % (data_inicial, data_final)
        if numero_loja:
            sql += """
                        AND movcapa.supcap_loja = %s
            """ % numero_loja
        sql += """
                        AND ((movcapa.supcap_tipo IN ( 'C', 'V') AND (movcapa.supcap_state IS NULL)) 
                             OR
                             (movcapa.supcap_tipo = 'V' AND movcapa.supcap_state IN ('3', '4', '2E'))
                             OR 
                              movcapa.supcap_state = '6' -- dav vendido
                             )
                 GROUP  BY movcapa.supcap_loja,
                           movcapa.supcap_caixa,
                           movcapa.supcap_data_cupom,
                           smf.supfec_tipo_finalizadora,
                           movcapa.supcap_tipo,
                           movcapa.supcap_indicador_cancelamento,
                           movcapa.supcap_data_fim,
                           scf.name
        """

        cr.execute(sql)
        dados = cr.dictfetchall()
        sql_2 = """ SELECT supcap_loja                   AS loja,
                           supcap_caixa                  AS caixa,
                           supcap_data_cupom             AS data,
                           supcap_total_cupom            AS total_cupom,
                           supcap_indicador_cancelamento AS cancelamento,
                           supcap_tipo                   AS tipo_cupom,
                           supcap_data_fim
                    FROM   supervisor_mov_capa
                    WHERE  supcap_data_cupom >= '%s'
                           AND supcap_data_cupom <= '%s'
                           AND ((supcap_tipo IN ( 'C', 'V') AND (supcap_state IS NULL)) 
                                OR
                                (supcap_tipo = 'V' AND supcap_state IN ('3', '4', '2E'))
                                OR 
                                 supcap_state = '6' -- dav vendido
                                )
        """ % (data_inicial, data_final)
        if numero_loja:
            sql_2 += """
                           AND supcap_loja = %s
        """ % numero_loja
        cr.execute(sql_2)
        dados_2 = cr.dictfetchall()
        tamanho_linha = '*' + (158 * '-') + '*'
        if dados:
            obj_supervisor_cfg_configuracao = pooler.get_pool(cr.dbname).get(
                'supervisor.cfg.configuracao')
            configuracao_ids = obj_supervisor_cfg_configuracao.search(cr, uid, [], context=context)
            nome_empresa = ''
            if configuracao_ids:
                nome_empresa = obj_supervisor_cfg_configuracao.browse(
                    cr, uid, configuracao_ids[0], context=context).supcfc_cliente or ''
            data = time.strftime("%d/%m/%Y")
            docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
            data_ini = time.strftime('%d/%m/%Y', time.strptime(data_inicial, '%Y-%m-%d'))
            data_fim = time.strftime('%d/%m/%Y', time.strptime(data_final, '%Y-%m-%d'))
            docs1 = center_title('Periodo: %s a %s' % (data_ini, data_fim), '', '')
            docs2 = center_title('Loja: %s' % numero_loja, '', '')

            listagem.informaCab('' + title)
            listagem.informaCab('')
            listagem.informaCab(docs)
            listagem.informaCab(docs1)
            listagem.informaCab(docs2)
            listagem.informaCab('  ')
            tamanho_linha_superior = '*' + (158 * '-' + '*')
            listagem.informaCab(tamanho_linha_superior)
            listagem.informaCab(
                _('| Loja | PDV | Clientes |   %   | Dinheiro |   %   | Cheques |   %   |  Cartao  |   %   |   PIX   |   %   | Outros  |   %   |   Total   |   %   | Ticket Medio |'))
            listagem.informaCab(tamanho_linha_superior)
            listagem.rodapePadrao()
            p_dinheiro, p_cheque, p_cartao, p_tickets, p_outros, p_geral, t_medio = 0, 0, 0, 0, 0, 0, 0
            t_dinheiro, t_cheque, t_cartao, t_tickets, t_outros, t_geral, p_clientes = 0, 0, 0, 0, 0, 0, 0

            n = 0
            # Dinheiro/Venda
            filtro_finalizadora_dv = lambda i: (i['tipo_finalizadora'] == 'D' and
                                                i.get('tipo_cupom') in ['V', 'D'])
            # Dinheiro/Cancelamento
            filtro_finalizadora_dc = lambda i: (i['tipo_finalizadora'] == 'D' and
                                                i.get('tipo_cupom') == 'C')
            # Cheque/Venda
            filtro_finalizadora_hv = lambda i: (i['tipo_finalizadora'] == 'H' and
                                                i.get('tipo_cupom') in ['V', 'D'])
            # Cheque/Cancelamento
            filtro_finalizadora_hc = lambda i: (i['tipo_finalizadora'] == 'H' and
                                                i.get('tipo_cupom') == 'C')
            # Cartao/Venda
            filtro_finalizadora_cv = lambda i: (i['tipo_finalizadora'] == 'C' and
                                                i.get('tipo_cupom') in ['V', 'D'])
            # Cartao/Cancelamento
            filtro_finalizadora_cc = lambda i: (i['tipo_finalizadora'] == 'C' and
                                                i.get('tipo_cupom') == 'C')
            # Ticket/Venda
            filtro_finalizadora_tv = lambda i: (i['tipo_finalizadora'] == 'T' and
                                                i.get('tipo_cupom') in ['V', 'D'])
            # Ticket/Cancelamento
            filtro_finalizadora_tc = lambda i: (i['tipo_finalizadora'] == 'T' and
                                                i.get('tipo_cupom') == 'C')
            # Outros/Venda
            filtro_finalizadora_ov = lambda i: (i['tipo_finalizadora'] == 'O' and
                                                i.get('tipo_cupom') in ['V', 'D'])
            # Outros/Cancelamento
            filtro_finalizadora_oc = lambda i: (i['tipo_finalizadora'] == 'O' and
                                                i.get('tipo_cupom') == 'C')
            # Clientes/Venda
            filtro_cliente_venda = lambda i: (i.get('tipo_cupom') in ['V', 'D'])
            # Clientes/Cancelamento
            filtro_cliente_cancelamento = lambda i: (i.get('tipo_cupom') == 'C')

            finalizadora_cheque = filter(filtro_finalizadora_hv, dados)
            finalizadora_cheque_c = filter(filtro_finalizadora_hc, dados)
            total_cheque = sum(map(lambda x: x['total_cupom'], finalizadora_cheque)) or 0
            total_cheque_c = sum(map(lambda x: x['total_cupom'], finalizadora_cheque_c)) or 0
            total_cheque_troco = sum(map(lambda x: x['troco'], finalizadora_cheque)) or 0
            total_cheque_troco_c = sum(map(lambda x: x['troco'], finalizadora_cheque_c)) or 0
            total_cheque -= total_cheque_c

            finalizadora_cartao = filter(filtro_finalizadora_cv, dados)
            finalizadora_cartao_c = filter(filtro_finalizadora_cc, dados)
            total_cartao = sum(map(lambda x: x['total_cupom'], finalizadora_cartao)) or 0
            total_cartao_c = sum(map(lambda x: x['total_cupom'], finalizadora_cartao_c)) or 0
            total_cartao_troco = sum(map(lambda x: x['troco'], finalizadora_cartao)) or 0
            total_cartao_troco_c = sum(map(lambda x: x['troco'], finalizadora_cartao_c)) or 0
            total_cartao -= total_cartao_c

            finalizadora_ticket = filter(filtro_finalizadora_tv, dados)
            finalizadora_ticket_c = filter(filtro_finalizadora_tc, dados)
            total_tickets = sum(map(lambda x: x['total_cupom'], finalizadora_ticket)) or 0
            total_tickets_c = sum(map(lambda x: x['total_cupom'], finalizadora_ticket_c)) or 0
            total_tickets_troco = sum(map(lambda x: x['troco'], finalizadora_ticket)) or 0
            total_tickets_troco_c = sum(map(lambda x: x['troco'], finalizadora_ticket_c)) or 0
            total_tickets -= total_tickets_c

            finalizadora_outros = filter(filtro_finalizadora_ov, dados)
            finalizadora_outros_c = filter(filtro_finalizadora_oc, dados)
            total_outros = sum(map(lambda x: x['total_cupom'], finalizadora_outros)) or 0
            total_outros_c = sum(map(lambda x: x['total_cupom'], finalizadora_outros_c)) or 0
            total_outros_troco = sum(map(lambda x: x['troco'], finalizadora_outros)) or 0
            total_outros_troco_c = sum(map(lambda x: x['troco'], finalizadora_outros_c)) or 0
            total_outros -= total_outros_c

            finalizadora_dinheiro = filter(filtro_finalizadora_dv, dados)
            finalizadora_dinheiro_c = filter(filtro_finalizadora_dc, dados)
            total_dinheiro = sum(map(lambda x: x['total_cupom'], finalizadora_dinheiro)) or 0
            total_dinheiro_c = sum(map(lambda x: x['total_cupom'], finalizadora_dinheiro_c)) or 0
            total_dinheiro_troco = sum(map(lambda x: x['troco'], finalizadora_dinheiro)) or 0
            total_dinheiro_troco_c = sum(map(lambda x: x['troco'], finalizadora_dinheiro_c)) or 0
            total_dinheiro_troco += total_cheque_troco + total_cartao_troco + total_tickets_troco + \
                                    total_outros_troco    # se houver troco de cheque, cartao, ticket, ele sera retirado do dinheiro
            total_dinheiro_troco_c += total_cheque_troco_c + total_cartao_troco_c + total_tickets_troco_c + \
                                      total_outros_troco_c
            total_dinheiro -= (total_dinheiro_c + total_dinheiro_troco - total_dinheiro_troco_c)

            #total_geral = sum(map(lambda x: x['total_cupom'], dados)) or 0
            total_geral = total_dinheiro + total_cheque + total_cartao + total_tickets + \
                total_outros

            clientes = filter(filtro_cliente_venda, dados_2) or []
            clientes_c = filter(filtro_cliente_cancelamento, dados_2) or []
            total_clientes = len(clientes) - len(clientes_c)
            dados_2 = groupby(dados_2, key=lambda r: r['caixa'])
            dados_agrupados = groupby(dados, key=lambda r: r['caixa'])
            dados_chaves = dados_agrupados.keys()
            dados_chaves.sort()
            for k in dados_chaves:
                g = dados_agrupados.get(k)
                t_cheque = filter(filtro_finalizadora_hv, g)
                total_cheque_cupom = sum(map(lambda x: x['total_cupom'], t_cheque)) or 0
                t_cheque_c = filter(filtro_finalizadora_hc, g)
                total_cheque_cupom_c = sum(map(lambda x: x['total_cupom'], t_cheque_c)) or 0
                total_cheque_troco_cupom = sum(map(lambda x: x['troco'], t_cheque)) or 0
                total_cheque_cupom -= total_cheque_cupom_c
                if total_cheque_cupom and total_cheque:
                    percentual_cheque = (total_cheque_cupom * 100 / total_cheque)
                else:
                    percentual_cheque = 0
                p_cheque += percentual_cheque

                t_cartao = filter(filtro_finalizadora_cv, g)
                total_cartao_cupom = sum(map(lambda x: x['total_cupom'], t_cartao)) or 0
                t_cartao_c = filter(filtro_finalizadora_cc, g)
                total_cartao_cupom_c = sum(map(lambda x: x['total_cupom'], t_cartao_c)) or 0
                total_cartao_troco_cupom = sum(map(lambda x: x['troco'], t_cartao)) or 0
                total_cartao_cupom -= total_cartao_cupom_c
                if total_cartao_cupom and total_cartao:
                    percentual_cartao = (total_cartao_cupom * 100 / total_cartao)
                else:
                    percentual_cartao = 0
                p_cartao += percentual_cartao

                t_tickets = filter(filtro_finalizadora_tv, g)
                total_tickets_cupom = sum(map(lambda x: x['total_cupom'], t_tickets)) or 0
                t_tickets_c = filter(filtro_finalizadora_tc, g)
                total_tickets_cupom_c = sum(map(lambda x: x['total_cupom'], t_tickets_c)) or 0
                total_tickets_troco_cupom = sum(map(lambda x: x['troco'], t_tickets)) or 0
                total_tickets_cupom -= total_tickets_cupom_c
                if total_tickets_cupom and total_tickets:
                    percentual_tickets = (total_tickets_cupom * 100 / total_tickets)
                else:
                    percentual_tickets = 0
                p_tickets += percentual_tickets

                t_outros = filter(filtro_finalizadora_ov, g)
                total_outros_cupom = sum(map(lambda x: x['total_cupom'], t_outros)) or 0
                t_outros_c = filter(filtro_finalizadora_oc, g)
                total_outros_cupom_c = sum(map(lambda x: x['total_cupom'], t_outros_c)) or 0
                total_outros_troco_cupom = sum(map(lambda x: x['troco'], t_outros)) or 0
                total_outros_cupom -= total_outros_cupom_c
                if total_outros_cupom and total_outros:
                    percentual_outros = (total_outros_cupom * 100 / total_outros)
                else:
                    percentual_outros = 0
                p_outros += percentual_outros

                t_dinheiro = filter(filtro_finalizadora_dv, g)
                total_dinheiro_cupom = sum(map(lambda x: x['total_cupom'], t_dinheiro)) or 0
                t_dinheiro_c = filter(filtro_finalizadora_dc, g)
                total_dinheiro_cupom_c = sum(map(lambda x: x['total_cupom'], t_dinheiro_c)) or 0
                total_dinheiro_troco_cupom_c = sum(map(lambda x: x['troco'], t_dinheiro_c)) or 0
                total_dinheiro_troco_cupom = sum(map(lambda x: x['troco'], t_dinheiro)) or 0
                total_dinheiro_troco_cupom += total_cheque_troco_cupom + total_cartao_troco_cupom +\
                                              total_tickets_troco_cupom + total_outros_troco_cupom
                total_dinheiro_cupom -= total_dinheiro_troco_cupom
                total_dinheiro_cupom -= total_dinheiro_cupom_c - total_dinheiro_troco_cupom_c
                if total_dinheiro_cupom and total_dinheiro:
                    percentual_dinheiro = (total_dinheiro_cupom * 100 / total_dinheiro)
                else:
                    percentual_dinheiro = 0
                p_dinheiro += percentual_dinheiro

                #total_geral_cupom = sum(map(lambda x: x['total_cupom'], g)) or 0
                total_geral_cupom = total_dinheiro_cupom + total_cheque_cupom + \
                    total_cartao_cupom + total_tickets_cupom + total_outros_cupom
                if total_geral_cupom and total_geral:
                    percentual_geral = (total_geral_cupom * 100 / total_geral)
                else:
                    percentual_geral = 0
                p_geral += percentual_geral

                total_clientes_cupom = len(filter(filtro_cliente_venda, dados_2.get(k))) or 0
                total_clientes_cupom_c = len(filter(filtro_cliente_cancelamento, dados_2.get(k))) or 0
                total_clientes_cupom -= total_clientes_cupom_c
                percentual_clientes = 0
                if total_clientes_cupom and total_clientes:
                    percentual_clientes = total_clientes_cupom * 100.0 / total_clientes

                p_clientes += percentual_clientes
                linha = ['|', formataString(g[0].get('loja'), 6, ' ', 'E', 'N', 'S'), '| ',
                         formataString(g[0].get('caixa'), 4, ' ', 'E', 'N', 'S'), '| ',
                #cliente
                         formataString(total_clientes_cupom, 9, ' ', 'E', 'N', 'S'), '| ',
                         formataString(getNumeroEditado(percentual_clientes), 6, ' ', 'E', 'N', 'S'), '| ',
                #dinheiro
                         formataString(getNumeroEditado(total_dinheiro_cupom), 9, ' ', 'E', 'N', 'S'), '| ',
                         formataString(getNumeroEditado(percentual_dinheiro), 6, ' ', 'E', 'N', 'S'), '| ',
                #cheque
                         formataString(getNumeroEditado(total_cheque_cupom), 8, ' ', 'E', 'N', 'S'), '| ',
                         formataString(getNumeroEditado(percentual_cheque), 6, ' ', 'E', 'N', 'S'), '| ',
                #cartao
                         formataString(getNumeroEditado(total_cartao_cupom), 9, ' ', 'E', 'N', 'S'), '| ',
                         formataString(getNumeroEditado(percentual_cartao), 6, ' ', 'E', 'N', 'S'), '| ',
                #tickets
                         formataString(getNumeroEditado(total_tickets_cupom), 8, ' ', 'E', 'N', 'S'), '| ',
                         formataString(getNumeroEditado(percentual_tickets), 6, ' ', 'E', 'N', 'S'), '| ',

                #outros
                         formataString(getNumeroEditado(total_outros_cupom), 8, ' ', 'E', 'N', 'S'), '| ',
                         formataString(getNumeroEditado(percentual_outros), 6, ' ', 'E', 'N', 'S'), '| ',
                #total geral
                         formataString(getNumeroEditado(total_geral_cupom), 10, ' ', 'E', 'N', 'S'), '| ',
                         formataString(getNumeroEditado(percentual_geral), 6, ' ', 'E', 'N', 'S'), '| ']
                #ticket medio
                if total_clientes_cupom:
                    linha.extend([formataString(getNumeroEditado(total_geral_cupom / total_clientes_cupom), 13, ' ', 'E', 'N', 'S'), '| '])
                else:
                    linha.extend([formataString(getNumeroEditado(0), 13, ' ', 'E', 'N', 'S'), '| '])
                listagem.imprimeLinha(''.join(linha))

            linha = _('Totais :      ')
            #cliente
            linha += formataString(total_clientes, 9, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(p_clientes), 6, ' ', 'E', 'N', 'S') + '|'#pencentual cliente
            linha += ' '
            #dinheiro
            linha += formataString(getNumeroEditado(total_dinheiro), 9, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(p_dinheiro), 6, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            #cheque
            linha += formataString(getNumeroEditado(total_cheque), 8, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(p_cheque), 6, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            #cartao
            linha += formataString(getNumeroEditado(total_cartao), 9, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(p_cartao), 6, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            #tickets
            linha += formataString(getNumeroEditado(total_tickets), 8, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(p_tickets), 6, ' ', 'E', 'N', 'S') + '|'
            linha += ' '

            #outros
            linha += formataString(getNumeroEditado(total_outros), 8, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(p_outros), 6, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            #total geral
            linha += formataString(getNumeroEditado(total_geral), 10, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            linha += formataString(getNumeroEditado(p_geral), 6, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            #ticket medio
            if total_geral and total_clientes:
                linha += formataString(getNumeroEditado(total_geral / total_clientes), 13, ' ', 'E', 'N', 'S') + '|'
            else:
                linha += formataString(getNumeroEditado(0), 13, ' ', 'E', 'N', 'S') + '|'
            linha += ' '
            listagem.imprimeLinha(tamanho_linha)
            listagem.imprimeLinha('|' + linha)
            listagem.imprimeLinha(tamanho_linha)

        if datas.get('completo'):
            self._imprimir_relatorio_completo(cr, listagem, tamanho_linha, datas, context)

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

    def _imprimir_relatorio_completo(self, cr, listagem, tamanho_linha, datas, context=None):
        context = context and context.copy() or {}
        if listagem.cabecalhos:
            listagem.cabecalhos.pop(-1)
            listagem.cabecalhos.pop(-1)
        listagem.imprimeLinha('')
        listagem.imprimeLinha(_(' Cancelamentos'))
        listagem.imprimeLinha(tamanho_linha)
        listagem.imprimeLinha('| Loja |   TIPO   | CAIXA    | CANCELADAS                                                                                                                      |')
        listagem.imprimeLinha(tamanho_linha)
        canceladas = self.get_notas_canceladas(cr, datas, context)
        if canceladas:
            cont = 0
            ultimo_caixa = 0
            for i in canceladas:
                if not ultimo_caixa or ultimo_caixa != i.get('caixa'):
                    if ultimo_caixa:
                        dif = len(tamanho_linha) - len(linha)
                        if dif:
                            linha += formataString('', dif - 1, ' ', 'D', 'N', 'S') + '|'
                        listagem.imprimeLinha(linha)
                        listagem.imprimeLinha(tamanho_linha)
                        cont = 0

                    ultimo_caixa = i.get('caixa')
                    tipo = i.get('tipo') == 'C' and 'NFC-e' or 'DAV'
                    linha = '|' + formataString(datas.get('numero_loja') or '', 5, ' ', 'E', 'N', 'S')
                    linha += ' |' + formataString(tipo, 10, ' ', 'C', 'N', 'S')
                    linha += '|   ' + formataString(i.get('caixa') or '', 3, '0', 'E', 'N', 'S')
                    linha += '    |' + formataString(i.get('nota') or '', 9, ' ', 'E', 'N', 'S')
                else:
                    linha += '|' + formataString(i.get('nota') or '', 9, ' ', 'E', 'N', 'S')

                cont += 1
                if cont >= 13:
                    cont = 0
                    listagem.imprimeLinha(linha + '|')
                    linha = '|                            '

            dif = len(tamanho_linha) - len(linha)
            if dif:
                linha += formataString('', dif - 1, ' ', 'D', 'N', 'S') + '|'

            listagem.imprimeLinha(linha)
            listagem.imprimeLinha(tamanho_linha)

        else:
            listagem.imprimeLinha('|' + formataString('|' or '', 159, ' ', 'E', 'N', 'S'))
            listagem.imprimeLinha(tamanho_linha)

        listagem.imprimeLinha('')
        listagem.imprimeLinha(_(' Inutilizadas'))
        listagem.imprimeLinha(tamanho_linha)
        listagem.imprimeLinha('| Loja |   TIPO   | CAIXA    | INUTILIZADAS                                                                                                                    |')
        listagem.imprimeLinha(tamanho_linha)
        canceladas = self.get_notas_inutilizadas(cr, datas, context)
        if canceladas:
            cont = 0
            ultimo_caixa = 0
            for i in canceladas:
                if not ultimo_caixa or ultimo_caixa != i.get('caixa'):
                    if ultimo_caixa:
                        dif = len(tamanho_linha) - len(linha)
                        if dif:
                            linha += formataString('', dif - 1, ' ', 'D', 'N', 'S') + '|'
                        listagem.imprimeLinha(linha)
                        listagem.imprimeLinha(tamanho_linha)
                        cont = 0

                    ultimo_caixa = i.get('caixa')
                    tipo = 'NFC-e'
                    linha = '|' + formataString(datas.get('numero_loja') or '', 5, ' ', 'E', 'N', 'S')
                    linha += ' |' + formataString(tipo, 10, ' ', 'C', 'N', 'S')
                    linha += '|   ' + formataString(i.get('caixa') or '', 3, '0', 'E', 'N', 'S')
                    linha += '    |' + formataString(i.get('nota') or '', 9, ' ', 'E', 'N', 'S')
                else:
                    linha += '|' + formataString(i.get('nota') or '', 9, ' ', 'E', 'N', 'S')

                cont += 1
                if cont >= 13:
                    cont = 0
                    listagem.imprimeLinha(linha + '|')
                    linha = '|                            '

            dif = len(tamanho_linha) - len(linha)
            if dif:
                linha += formataString('', dif - 1, ' ', 'D', 'N', 'S') + '|'

            listagem.imprimeLinha(linha)
            listagem.imprimeLinha(tamanho_linha)

        else:
            listagem.imprimeLinha('|' + formataString('|' or '', 159, ' ', 'E', 'N', 'S'))
            listagem.imprimeLinha(tamanho_linha)

        cab1 = _('| Loja |   TIPO   | CAIXA | INICIAL |  FINAL  | NUMERO FALTANTE                                                                                                |')
        listagem.informaCab(cab1)
        listagem.informaCab(tamanho_linha)
        listagem.imprimeLinha('')
        listagem.imprimeLinha(_(' Faltantes'))
        listagem.imprimeLinha(tamanho_linha)
        listagem.imprimeLinha(cab1)
        listagem.imprimeLinha(tamanho_linha)
        for i in self.get_notas_faltantes(cr, datas, context):
            dados = i[0]
            faltantes = i[1]
            tipo = dados.get('tipo') == 'V' and 'NFC-e' or 'DAV'
            linha = '|' + formataString(datas.get('numero_loja') or '', 5, ' ', 'E', 'N', 'S')
            linha += ' |' + formataString(tipo, 10, ' ', 'C', 'N', 'S')
            linha += '|   ' + formataString(dados.get('caixa') or '', 3, '0', 'E', 'N', 'S')
            linha += ' |' + formataString(dados.get('inicio') or '', 9, ' ', 'E', 'N', 'S')
            linha += '|' + formataString(dados.get('fim') or '', 9, ' ', 'E', 'N', 'S')
            if faltantes:
                linha += '|   '
                cont = 0
                for j in faltantes:
                    cont += 1
                    linha += formataString(j or '', 9, ' ', 'E', 'N', 'S') + '|'
                    if cont >= 11:
                        cont = 0
                        listagem.imprimeLinha(linha)
                        linha = '|                                             |   '

            else:
                linha += '|' + formataString('|' or '', 113, ' ', 'E', 'N', 'S')

            dif = len(tamanho_linha) - len(linha)
            if dif:
                linha += formataString('', dif - 1, ' ', 'D', 'N', 'S') + '|'

            listagem.imprimeLinha(linha)
            listagem.imprimeLinha(tamanho_linha)

        listagem.imprimeLinha('')
        listagem.imprimeLinha(_(' Totais por Tributacao'))
        listagem.imprimeLinha(tamanho_linha)
        listagem.imprimeLinha(_(
            '| Loja | CAIXA | CST | ALIQUOTA % | VALOR CONTABIL | BASE ICMS | VALOR ICMS |                                                                                  |'))

        listagem.imprimeLinha(tamanho_linha)
        caixa_antigo = False
        total_contabil = total_base_icms = total_icms = 0
        for i in self.get_totais_por_tributacao(cr, datas, context):
            if caixa_antigo != i.get('caixa'):
                if caixa_antigo:
                    listagem.imprimeLinha(tamanho_linha)
                caixa_antigo = i.get('caixa')
                caixa = '%03d' % i.get('caixa')
                linha = '|' + formataString(datas.get('numero_loja') or '', 5, ' ', 'E', 'N', 'S')
                linha += ' |' + formataString(caixa or '', 6, ' ', 'E', 'N', 'S')
            else:
                linha = '|' + formataString('' or '', 5, ' ', 'E', 'N', 'S')
                linha += ' |' + formataString('' or '', 6, ' ', 'E', 'N', 'S')

            linha += ' |' +  formataString(i.get('cst_icms') or '', 4, ' ', 'E', 'N', 'S')
            linha += ' |' +  formataString(getNumeroEditado(i.get('aliquota') or 0, 2), 11, ' ', 'E', 'N', 'S')
            linha += ' |' +  formataString(getNumeroEditado(i.get('valor_contabil') or 0, 2), 15, ' ', 'E', 'N', 'S')
            linha += ' |' +  formataString(getNumeroEditado(i.get('valor_base') or 0, 2), 10, ' ', 'E', 'N', 'S')
            linha += ' |' +  formataString(getNumeroEditado(i.get('valor_icms') or 0, 2), 11, ' ', 'E', 'N', 'S')
            linha += ' |' +  formataString('|', 83, ' ', 'E', 'N', 'S')
            listagem.imprimeLinha(linha)
            total_contabil += i.get('valor_contabil')
            total_base_icms += i.get('valor_base')
            total_icms +=  i.get('valor_icms')

        total_contabil = getNumeroEditado(total_contabil, 2)
        total_base_icms = getNumeroEditado(total_base_icms, 2)
        total_icms = getNumeroEditado(total_icms, 2)
        listagem.imprimeLinha(tamanho_linha)
        listagem.imprimeLinha(_(
            '|                     TOTAL       | %14s |%10s |%11s |                                                                                  |')
                              % (total_contabil, total_base_icms, total_icms))
        listagem.imprimeLinha(tamanho_linha)

    def get_notas_canceladas(self, cr, filtros, context=None):
        context = context and context.copy() or {}
        cond_loja = ''
        if filtros.get('numero_loja'):
            cond_loja += 'AND supcap_loja = %s' % filtros.get('numero_loja')

        cr.execute("""
            SELECT supcap_nro_cupom AS nota,
                   supcap_caixa     AS caixa,
                   supcap_tipo      AS tipo
            FROM supervisor_mov_capa
            WHERE supcap_data_cupom >= '{data_ini}'
              AND supcap_data_cupom <= '{data_fim}' 
              AND supcap_state IN ('C', '7')
            ORDER BY supcap_caixa, supcap_tipo, supcap_nro_cupom
        """.format(data_ini=filtros.get('data_inicial'),
                   data_fim=filtros.get('data_final'),
                   cond_loja=cond_loja))

        return cr.dictfetchall()

    def get_notas_inutilizadas(self, cr, filtros, context=None):
        context = context and context.copy() or {}
        cond_loja = ''
        if filtros.get('numero_loja'):
            cond_loja += 'AND supcap_loja = %s' % filtros.get('numero_loja')

        cr.execute("""
            SELECT supcap_nro_cupom AS nota,
                   supcap_caixa     AS caixa
            FROM supervisor_mov_capa
            WHERE supcap_data_cupom >= '{data_ini}'
              AND supcap_data_cupom <= '{data_fim}' 
              AND supcap_state IN ('I')
            ORDER BY supcap_caixa, supcap_nro_cupom
        """.format(data_ini=filtros.get('data_inicial'),
                   data_fim=filtros.get('data_final'),
                   cond_loja=cond_loja))

        return cr.dictfetchall()

    def get_notas_faltantes(self, cr, filtros, context=None):
        context = context and context.copy() or {}
        cond_loja = ''
        if filtros.get('numero_loja'):
            cond_loja += 'AND supcap_loja = %s' % filtros.get('numero_loja')

        cr.execute("""
        SELECT * 
        FROM (
            ---- NFC-e ----
            SELECT MIN(supcap_nro_cupom) AS inicio,
                   MAX(supcap_nro_cupom) AS fim,
                   supcap_caixa          AS caixa,
                   'V'                   AS tipo
            FROM supervisor_mov_capa
            WHERE supcap_data_cupom >= '{data_ini}'
              AND supcap_data_cupom <= '{data_fim}' 
              AND supcap_state IN ('3', 'I', 'D', 'C')
              {cond_loja}
              GROUP BY supcap_caixa
            UNION ALL
            ---- DAV ----
            SELECT MIN(supcap_nro_cupom) AS inicio,
                   MAX(supcap_nro_cupom) AS fim,
                   supcap_caixa          AS caixa,
                   'D'                   AS tipo
            FROM supervisor_mov_capa
            WHERE supcap_data_cupom >= '{data_ini}'
              AND supcap_data_cupom <= '{data_fim}' 
              AND supcap_state IN ('6', '7')
              {cond_loja}
              GROUP BY supcap_caixa) AS tmp
        ORDER BY caixa
        """.format(data_ini=filtros.get('data_inicial'),
                   data_fim=filtros.get('data_final'),
                   cond_loja=cond_loja))

        res = []
        for i in cr.dictfetchall():
            state = i.get('tipo') == 'V' and "'3', 'I', 'D', 'C', '6', '7'" or "'6','7'"
            sequencia = map(lambda x: '%s' % x, range(i.get('inicio'), i.get('fim') + 1))
            cr.execute("""SELECT supcap_nro_cupom AS nro_nota
                          FROM supervisor_mov_capa
                          WHERE supcap_nro_cupom >= {inicio}
                            AND supcap_nro_cupom <= {fim}
                            AND supcap_caixa = {caixa}
                            AND supcap_state IN ({state})
                            AND supcap_nro_cupom NOT IN ({sequencia})
                            {cond_loja}
                          ORDER BY supcap_nro_cupom""".
                       format(state=state,
                              inicio=i.get('inicio'),
                              fim=i.get('fim'),
                              caixa=i.get('caixa'),
                              sequencia=','.join(sequencia),
                              cond_loja=cond_loja)
                       )
            dados = cr.dictfetchall()
            falantes = []
            if dados:
                falantes = map(lambda x: x.get('nro_nota'), dados)

            res.append((i, falantes))

        return res

    def get_totais_por_tributacao(self, cr, filtros, context=None):
        context = context and context.copy() or {}
        cond_loja = ''
        if filtros.get('numero_loja'):
            cond_loja += 'AND supcap_loja = %s' % filtros.get('numero_loja')

        cr.execute("""SELECT capa.supcap_caixa                AS caixa,
                             SUM(corpo.supcor_preco_total 
                               - corpo.supcor_desconto_item
                               + corpo.supcor_acrescimo_item) AS valor_contabil,
                             SUM(corpo.supcor_vr_icms)        AS valor_icms,
                             SUM(corpo.supcor_base_icms)      AS valor_base,
                             corpo.supcor_aliquota_icms       AS aliquota,
                             corpo.supcor_codigo_cst_icms     AS cst_icms
                      FROM supervisor_mov_capa         AS capa
                      INNER JOIN supervisor_mov_corpos AS corpo ON corpo.supcor_capa_id = capa.id
                      WHERE capa.supcap_data_cupom >= '{data_ini}'
                        AND capa.supcap_data_cupom <= '{data_fim}' 
                        AND capa.supcap_state = '3'
                        AND corpo.supcor_venda_cancelamento = 'V'
                        {cond_loja}
                      GROUP BY capa.supcap_caixa, corpo.supcor_aliquota_icms, corpo.supcor_codigo_cst_icms
                      ORDER BY capa.supcap_caixa, corpo.supcor_codigo_cst_icms, corpo.supcor_aliquota_icms
                      """.format(data_ini=filtros.get('data_inicial'),
                                data_fim=filtros.get('data_final'),
                                cond_loja=cond_loja))

        return map(lambda x: x, cr.dictfetchall())

report_custom('report.apuracao_venda_caixa')


class wizard_apuracao_venda_caixa(osv.TransientModel):
    _name = 'wizard.apuracao.venda.caixa'
    _description = 'Apuracao Vendas Caixa'
    _columns = {
        'data_inicial': fields.date('Data Inicial', required=True),
        'data_final': fields.date('Data Final', required=True),
        'numero_loja': fields.integer('Loja', required=True, select=True),
        'completo': fields.boolean('Relatorio Completo'),

    }

    _defaults = {
        'completo': False,
    }

    def gerar_apuracao(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, list):
            ids = ids[0]
        dados_apuracao = self.read(cr, uid, ids, [], context=context)
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'apuracao_venda_caixa',
            'datas': dados_apuracao,
        }
