# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
from pynfe.nfce.manual_600.NFCe import NFCe as nfc_e
from datetime import datetime
import socket


HOMOLOGACAO = 2


class supervisor_wizard_cancelar_nota(osv.TransientModel):

    _name = 'supervisor.wizard.cancelar.nota'

    def wizcan_criar_log(self, cr, uid, nf_id, context=None):
        context = context and context.copy() or {}
        obj_capa = self.pool.get('supervisor.mov.capa')
        dados = obj_capa.read(cr, uid, nf_id, ['supcap_status', 'supcap_loja', 'supcap_caixa',
                                                 'supcap_chave_acesso', 'supcap_nro_cupom',
                                                 'supcap_state'], context)

        if dados.get('supcap_state') in ('3', 'C', 'I', 'D', '2E'):
            data = datetime.strftime(self.pool.get('supervisor.util').suputi_converte_tz(
                cr, uid, datetime.strptime(
                    datetime.now().strftime('%Y-%m-%d %H:%M:%S'), '%Y-%m-%d %H:%M:%S'), 'UTC',
                context=context), '%Y-%m-%d %H:%M:%S')
            obj_conifg = self.pool.get('supervisor.cfg.configuracao')
            config_ids = obj_conifg.search(cr, uid,
                                           [('supcfc_loja', '=', dados.get('supcap_loja'))],
                                           context=context)
            brw_config = obj_conifg.browse(cr, uid, config_ids[0], context=context)
            ambiente = {'H': _('Homologacao'),
                        'P': _('Producao')}.get(brw_config.supcfc_ambiente)
            obj_capa.message_post(cr, uid, nf_id, dados.get('supcap_status') or '' + ' em %s' % data,
                              '%s %s-%s - %s [%s]' % ('NFC-e',
                                                      dados.get('supcap_nro_cupom'),
                                                      dados.get('supcap_caixa'),
                                                      dados.get('supcap_chave_acesso'), ambiente))
        return True

    def wizcan_get_operador(self, cr, uid, context):
        context = context and context.copy() or {}
        op_ids = self.pool.get('supervisor.cad.operadores').search(cr, uid,
                                                    [('supope_user_id', '=', uid)], context=context)
        if not op_ids:
            nome = self.pool.get('res.users').read(cr, uid, uid, ['login'], context).get('login')
            raise osv.except_osv(_("Atencao!"),
                                 _("Este usuario '%s' nao tem correlacao com o "
                                   "cadastro de operadores!") % nome)

        return op_ids[0]

    def wizcan_criar_autoriazacao(self, cr, uid, brw_capa, operador_id, context):
        context = context and context.copy() or {}
        vals = {'supaut_autorizador_id': operador_id,
                'supaut_liberou_desconto': False,
                'supaut_liberou_limite_credito': False,
                'supaut_liberou_restricao_mensagem': False,
                'supaut_liberou_cancelamento_cupom': True,
                'supaut_liberou_cheque_a_vista': False,
                'supaut_capa_id': brw_capa.id}
        if brw_capa.supcap_cliente:
            vals['supaut_cliente'] = brw_capa.supcap_cliente

        return self.pool.get('supervisor.autorizacoes').create(cr, uid, vals, context)

    def wizcan_button_cancelar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        nfce_id = context.get('active_id')
        if not nfce_id:
            raise osv.except_osv(_('Atencao!'), _('Recarrege a tela!'))

        obj_configuracao = self.pool.get('supervisor.cfg.configuracao')
        config_ids = obj_configuracao.search(cr, uid, [], context=context)
        if not config_ids:
            raise osv.except_osv(_('Atencao!'),
                                 _('Nenhum configuracao cadastrada!'))

        brw_config = obj_configuracao.browse(cr, uid, config_ids[0], context)
        obj_capa = self.pool.get('supervisor.mov.capa')
        brw_capa = obj_capa.browse(cr, uid, nfce_id, context)
        state = brw_capa.supcap_state.strip()
        if state != '3':
            if state in ('4', '5'):
                txt = _('foi emitida em CONTINGECIA!')
            elif state == 'C':
                txt = _('ja esta CANCELADA!')
            elif state == 'D':
                txt = _('esta DENEGADA!')

            msg = _("A Nota nao pode ser cancelada pois %s") % txt
            raise osv.except_osv(_('Atencao!'), msg)

        op_id = self.wizcan_get_operador(cr, uid, context)
        processo, __ = obj_capa.supcap_verifica_status_nfce_sefaz(cr, uid, brw_capa, context)
        if processo.resposta.cStat.valor == u'101':  # Cancelada
            infCanc = processo.resposta.retCancNFe.infCanc
            data = self.pool.get('supervisor.util').suputi_datetime_to_timezone(cr, uid, infCanc.dhRecbto.valor,
                                                                             '%Y-%m-%d %H:%M:%S')
            data = datetime.strptime(data, '%Y-%m-%d %H:%M:%S')
            data = self.pool.get('supervisor.util').suputi_converte_tz(cr, uid, data,
                                                                       'America/Sao_Paulo', 'UTC',
                                                                       context=context)
            prot_cancelamento = infCanc.nProt.valor
            if prot_cancelamento and 'ID' in prot_cancelamento:
                prot_cancelamento = prot_cancelamento.replace('ID', '')

            obj_capa.write(cr, uid, brw_capa.id, {'supcap_state': 'C',
                                                  'supcap_protocolo_cancelamento': prot_cancelamento,
                                                  'supcap_data_fim': data}, context)
            obj_capa.supcap_alterar_corpos(cr, uid, brw_capa, 'C', context)
            cr.execute("""UPDATE supervisor_mov_cupom_servidor 
                          SET supcse_enviado = False
                          WHERE supcse_capa_id = %s""" % nfce_id)
            self.wizcan_criar_autoriazacao(cr, uid, brw_capa, op_id, context)
            self.wizcan_criar_log(cr, uid, brw_capa.id, context)
            return True

        elif processo.resposta.cStat.valor == u'102':  # Inutilizada
            obj_capa.write(cr, uid, brw_capa.id, {'supcap_state': 'I'}, context)
            obj_capa.supcap_alterar_corpos(cr, uid, brw_capa, 'I', context)
            cr.execute("""UPDATE supervisor_mov_cupom_servidor 
                          SET supcse_enviado = False
                          WHERE supcse_capa_id = %s""" % nfce_id)
            self.wizcan_criar_log(cr, uid, brw_capa.id, context)
            return True

        # elif processo.resposta.cStat.valor in (u'137', u'217'):
        #     obj_capa.supcap_inutilizar_nfce(cr, uid, brw_capa, context)
        #     obj_capa.supcap_alterar_corpos(cr, uid, brw_capa, 'C', context)

        chave_acesso = brw_capa.supcap_chave_acesso
        ambiente = brw_capa.supcap_ambiente == 'P' and 1 or 2
        protocolo = brw_capa.supcap_protocolo and brw_capa.supcap_protocolo.replace(' ', '')
        if not protocolo:
            raise osv.except_osv(_("Atencao!"), _("Nota sem protocolo!"))

        value = {}
        try:
            proc_nfce = nfc_e(brw_config.supcfc_certificado_conteudo.replace('\\n', '\n'),
                              brw_config.supcfc_chave_conteudo.replace('\\n', '\n'),
                              ambiente,
                              brw_config.supcfc_estado)
            processo = proc_nfce.process.cancelar_nfce(chave_acesso,
                                                       protocolo,
                                                       'O cliente desistiu da compra')
        except socket.gaierror:
            raise osv.except_osv(_('Atencao!'),
                                 _('Falha no servidor da SEFAZ. \n'
                                   'Verifique se existe conexao com a Internet.'))

        except IOError:
            raise osv.except_osv(_('Atencao!'),
                                  _('Falha no servidor da SEFAZ. \nTente novamente mais tarde.'))

        except Exception as erro:
            if str(erro).find('certificate expired') >= 1:
                erro = _('Certificado digital com validade vencida.')

            raise osv.except_osv(_('Atencao!'), erro)

        else:
            if processo.resposta.cStat.valor == u'128':
                if processo.resposta.retEvento.infEvento.cStat.valor in (u'135-155-151'):
                    value['supcap_xml_cancelamento'] = processo.processo_cancelamento_nfe.xml
                    if processo.resposta.retEvento.infEvento.Id.valor:
                        value['supcap_protocolo_cancelamento'] = \
                            processo.resposta.retEvento.infEvento.Id.valor[2:]

                    data = datetime.strptime(processo.resposta.retEvento.infEvento.dhRegEvento.valor[:-6],
                                             '%Y-%m-%dT%H:%M:%S')
                    data = self.pool.get('supervisor.util').suputi_converte_tz(cr, uid, data,
                                                        'America/Sao_Paulo', 'UTC', context=context)
                    value['supcap_data_fim'] = data
                    value['supcap_status'] = '%s - %s' % (
                                                processo.resposta.retEvento.infEvento.cStat.valor,
                                                processo.resposta.retEvento.infEvento.xMotivo.valor)
                    value['supcap_state'] = 'C'
                    value['supcap_tipo'] = 'C'
                    obj_capa.write(cr, uid, nfce_id, value, context)
                    obj_capa.supcap_alterar_corpos(cr, uid, brw_capa, 'C', context)
                    cr.execute("""UPDATE supervisor_mov_cupom_servidor 
                                  SET supcse_enviado = False
                                  WHERE supcse_capa_id = %s""" % nfce_id)
                    self.wizcan_criar_autoriazacao(cr, uid, brw_capa, op_id, context)
                    self.wizcan_criar_log(cr, uid, brw_capa.id, context)
                    return True

                else:
                    msg = '%s - %s' % (processo.resposta.retEvento.infEvento.cStat.valor,
                                       processo.resposta.retEvento.infEvento.xMotivo.valor)
                    raise osv.except_osv(_('Atencao!'), msg)

            else:
                if not processo.resposta.cStat.valor:
                    erro = _('Erro interno na SEFAZ. Tente novamente.')
                else:
                    erro = '%s - %s.' % (processo.resposta.cStat.valor,
                                         processo.resposta.xMotivo.valor)

                raise osv.except_osv(_('Atencao!'), erro)

        self.wizcan_criar_log(cr, uid, brw_capa.id, context)
        return True
