#!/usr/bin/python
# -*- coding: utf-8 -*-

from openerp.tools.translate import _
from openerp.osv import osv, fields
import psycopg2


class wizard_exportar_cliente_caixa_especifico(osv.TransientModel):

    _name = 'wizard.exportar.cliente.caixa.especifico'

    _columns = {
        'wizecc_loja': fields.integer('Loja', required=True),
        'wizecc_caixa': fields.integer('Caixa', required=True),
    }

    def button_exportar_cliente(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_pdvs = self.pool.get('supervisor.cad.pdvs')
        brw_filtro = self.browse(cr, uid, ids[0], context)
        caixa = brw_filtro.wizecc_caixa
        loja = brw_filtro.wizecc_loja
        pdv_ids = obj_pdvs.search(cr, uid, [('suppdv_loja', '=', loja),
                                            ('suppdv_caixa', '=', caixa)], context=context)
        if not pdv_ids:
            raise osv.except_osv(_("Atencao!"),
                                 _("Nenhum PDV encontrado com Loja: %s Caixa: %s") % (loja, caixa))

        brw_pdv = obj_pdvs.browse(cr, uid, pdv_ids[0], context)
        host = brw_pdv.suppdv_ip_caixa
        user = brw_pdv.suppdv_usuario_banco
        db = brw_pdv.suppdv_banco
        conn = False
        if not all([host, user, db]):
            raise osv.except_osv(_('Atencao!'),
                                 _("Cadastro do PDV esta incompleto, verifique o IP, Banco ou Usuario"))
        try:
            # CONEXAO COM O BANCO DE DADOS
            conn = psycopg2.connect(database=db, user=user, password='', host=host, #SigLuiz
                                    connect_timeout=3)
            _cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
        except Exception as err:
            if conn:
                conn.close()
            msg = _("Host: %s \nUsuario: %s \nBanco: %s\n" % (host, user, db))
            raise osv.except_osv(_('Atencao'),
                                 _('Nao foi possivel conectar ao Postgres do caixa. \n%s' % msg +
                                   'Verifique as informacoes no cadastro dos PDVs'))

        _cr.execute("SET statement_timeout = '3s'")
        cliente_id = context.get('active_id')
        cr.execute("""SELECT * FROM supervisor_cad_clientes WHERE id = %s""" % cliente_id)
        dados_cliente = cr.dictfetchall()[0]
        _cr.execute("""SELECT id 
                       FROM caixa_cad_clientes
                       WHERE supcli_cnpj_cpf = '%s' """ %
                    dados_cliente.get('supcli_cnpj_cpf').rjust(15, '0'))
        del dados_cliente['id']
        del dados_cliente['create_date']
        del dados_cliente['write_date']
        del dados_cliente['create_uid']
        del dados_cliente['write_uid']
        cliente_pdv = self.pool.get('supervisor.util').suputi_fetchall_to_dictfetchall(_cr)
        if cliente_pdv:
            dados = self.get_dados_to_update(dados_cliente, context)
            sql = """UPDATE caixa_cad_clientes 
                        SET %s
                     WHERE id = %s;
                     COMMIT;
                  """ % (dados, cliente_pdv[0].get('id'))
        else:
            campos, dados = self.get_dados_to_insert(dados_cliente, context)
            sql = """INSERT INTO caixa_cad_clientes
                            (%s)
                     VALUES (%s);
                     COMMIT;
                  """ % (campos, dados)
        try:
            _cr.execute(sql.replace("u'", "'").replace("'null'", 'null'))
        except Exception as e:
            if conn:
                conn.close()
            raise osv.except_osv(_('Atencao!'),
                                 _('Erro: %s') % e)
        if conn:
            conn.close()
        return True

    def get_dados_to_update(self, dados_cliente, context):
        context = context and context.copy() or {}
        res = []
        for i, j in dados_cliente.items():
            valor = j or 'null'
            res.append('%s = %r' % (i, valor))

        return ',\n'.join(res)

    def get_dados_to_insert(self, dados_cliente, context):
        context = context and context.copy() or {}
        campos = []
        res = []
        for i, j in dados_cliente.items():
            campos.append(i)
            valor = j or 'null'
            res.append('%r' % valor)

        return ', '.join(campos), ', '.join(res)