# -*- coding: utf-8 -*-
from openerp.osv import osv, fields
from SigUtils.registro import Registro
from datetime import datetime
import os
from math import pow

from openerp.tools.translate import _

class wizard_conulta_cupons_mfd(osv.TransientModel):
    _name = 'wizard.consulta.cupom.mfd'
    _description = 'Consulta os cupons do arquivo da MFD'
    _columns = {
        'wizccm_arquivo_mfd_ids': fields.one2many('wizard.arquivo.mfd',
                                           'wizmfd_consulta_id', 'Arquivos MDF'),
        'wizccm_coo': fields.text("COO's"),
        'wizccm_fim': fields.boolean('Fim'),
        'wizccm_exrpota_tudo': fields.boolean("Importar tudo"),
    }
    _defaults = {
        'wizccm_fim': False,
    }

    def button_carregar_arquivos(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_sup_arquivo_mfd = self.pool.get('supervisor.arquivo.mfd')
        obj_wiz_arquivo_mfd = self.pool.get('wizard.arquivo.mfd')
        obj_wiz_arquivo_mfd.unlink(cr, uid, self.read(cr, uid, ids,
                                                        context=context)[0].get('wizccm_arquivo_mfd_ids'))
        arq_mfd_ids = obj_sup_arquivo_mfd.search(cr, uid, [], context=context)
        for arq_mfd in obj_sup_arquivo_mfd.read(cr, uid, arq_mfd_ids, [], context=context):
            vals = {'wizmfd_consulta_id': ids[0],
                    'wizmfd_loja': arq_mfd.get('supmfd_loja'),
                    'wizmfd_caixa': arq_mfd.get('supmfd_caixa'),
                    'wizmfd_nome_arquivo': arq_mfd.get('supmfd_nome_arquivo'),
                    'wizmfd_conteudo': arq_mfd.get('supmfd_conteudo'),
                    'wizmfd_selecionado': False,
            }
            obj_wiz_arquivo_mfd.create(cr, uid, vals, context=context)

        return True

    def button_carregar_cupons(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_wiz_arquivo_mfd = self.pool.get('wizard.arquivo.mfd')
        arq_mfd_ids = obj_wiz_arquivo_mfd.search(cr, uid, [('wizmfd_consulta_id','in',ids),
                                                           ('wizmfd_selecionado', '=', True)])

        if not arq_mfd_ids:
            raise osv.except_osv(_('Atencao!'),
                                 _('Nenhum arquivo selecionado!'))

        dados_capa = self.read(cr, uid, ids, ['wizccm_coo', 'wizccm_exrpota_tudo'],
                                             context=context)[0]
        coos_selecionados = dados_capa.get('wizccm_coo') or ''
        self.exp_tudo = dados_capa.get('wizccm_exrpota_tudo')
        if not coos_selecionados and not self.exp_tudo:
            raise osv.except_osv(_('Atencao!'),
                                 _('Nenhum COO selecionado!'))

        if coos_selecionados:
            coos_selecionados = map(lambda x: int(x), coos_selecionados.split(','))

        cwd = os.path.abspath(os.path.dirname(__file__))
        nome_arquivos =  (fname for fname in os.listdir(cwd) \
                         if os.path.isdir(os.path.join(cwd, fname)))
        for nome_arquivo in nome_arquivos:
            module_importacao_path = os.path.join(cwd, '%s/cupom_mfd' % nome_arquivo)
            registros = Registro(module_importacao_path)

        obj_mov_capa = self.pool.get('supervisor.mov.capa')
        lista_cupons = [] # lista de cupons que serao gravados
        for arq_mfd in obj_wiz_arquivo_mfd.read(cr, uid, arq_mfd_ids, [], context=context):
            loja = arq_mfd.get('wizmfd_loja')
            caixa = arq_mfd.get('wizmfd_caixa')
            list_coo = []
            if not self.exp_tudo:
                mov_capa_ids = obj_mov_capa.search(cr, uid,
                                               [('supcap_nro_cupom', 'in', coos_selecionados),
                                                ('supcap_loja', '=', loja),
                                                ('supcap_caixa', '=', caixa)], context=context)
                list_coo = map(lambda x: x.get('supcap_nro_cupom'),
                                         obj_mov_capa.read(cr, uid, mov_capa_ids, [], context=context))
                list_coo = filter(lambda x: int(x) not in list_coo, coos_selecionados) # coo's que nao estao no banco
            vals_capa = []
            self.lista_coo_cancelados = [] # guardar os COOs de venda que possuem COO de cancelamento
            vals_itens={}
            self.vals_itens_cancelados = {}
            vals_tot_nao_fiscais = {}
            vals_capa_19 = {}
            vals_itens_20 = {}
            vals_fechamento = {}
            nro_serie = '' # numero de serie da ECF
            for line in arq_mfd.get('wizmfd_conteudo').split('\n'):
                coo = 0
                if line[:3] == 'E01': # itentificacao da ECF
                    e01 = registros.registro_decompoe(registros.E01(), line)
                    nro_serie = e01.numero_fabricante
                elif line[:3] == 'E02': # Identificacao do atual contribuinte usuario da ecf
                    e02 = registros.registro_decompoe(registros.E02(), line)

                elif line[:3] == 'E14': # capa do cupom
                    e14 = registros.registro_decompoe(registros.E14(), line)
                    vals_capa = self.get_capa_cupom_14(cr, uid, e14, list_coo, context=context)

                elif line[:3] == 'E15': # itens do cupom
                    e15 = registros.registro_decompoe(registros.E15(), line)
                    coo = e15.coo
                    vals_itens = self.get_itens_cupom_15(cr, uid, e15, list_coo, context=context)

                elif line[:3] == 'E16': # demais documentos emitidos pela ecf
                    e16 = registros.registro_decompoe(registros.E16(), line)
                    vals_capa = self.get_capa_cupom_16(cr, uid, e16, list_coo, context=context)

                # por enquando estes dados nao sao gravados no supervisor
                # elif line[:3] == 'E17': # Detalhe da Reducao Z – Totalizadores Nao Fiscais;
                #     e17 = registros.registro_decompoe(registros.E17(), line)
                #     vals_tot_nao_fiscais = self.get_detalhe_z_17(cr, uid, e17, context=context)
                #
                # elif line[:3] == 'E18': # Detalhe da Reducao Z – Meios de Pagamento e Troco;
                #     e18 = registros.registro_decompoe(registros.E18(), line)
                #     vals_meios_pagamento = self.get_detalhe_z_18(cr, uid, e18, context=context)

                elif line[:3] == 'E19': # Documento Nao Fiscal
                    e19 = registros.registro_decompoe(registros.E19(), line)
                    coo = e19.coo
                    vals_capa_19 = self.get_capa_cupom_19(cr, uid, e19, list_coo, context=context)

                elif line[:3] == 'E20': # Detalhe do Documento Nao Fiscal;
                    e20 = registros.registro_decompoe(registros.E20(), line)
                    coo = e20.coo
                    vals_itens_20 = self.get_itens_cupom_20(cr, uid, e20, list_coo, context=context)

                elif line[:3] == 'E21': # Detalhe do Cupom Fiscal e do Documento Nao Fiscal – Meio de Pagamento.”
                    e21 = registros.registro_decompoe(registros.E21(), line)
                    coo = e21.coo
                    vals_fechamento = self.get_fechamento_21(cr, uid, e21, list_coo, context=context)

                if vals_capa:
                    for val in vals_capa:
                        val['supcap_loja'] = loja
                        val['supcap_caixa'] = caixa
                        val['supcap_marca_ecf'] = e01.marca_ecf
                        val['supcap_nro_proprietario'] = e02.numero_usuario
                        val['supcap_nro_serie'] = nro_serie
                        lista_cupons.append(val)

                    vals_capa = {}

                if vals_itens:
                    map(lambda x: x['supcap_mov_corpos_ids'].extend([(0, False, vals_itens)])
                                  if x.get('supcap_nro_cupom')==coo else 0, lista_cupons)
                    if self.vals_itens_cancelados:
                        map(lambda x: x['supcap_mov_corpos_ids'].extend([(0, False, self.vals_itens_cancelados)])
                                      if x.get('supcap_nro_cupom')==(coo+1) else 0, lista_cupons)

                    vals_itens = {}
                    self.vals_itens_cancelados = {}

                # por enquando estes dados nao sao gravados no supervisor
                # if vals_detalhe_z:
                #     map(lambda x: x['supcap_mov_totalizadores_xz_ids'].extend([(0, False, vals_detalhe_z)])
                #                   if x.get('supcap_crz')==vals_detalhe_z.get('suptxz_crz') else 0, lista_cupons)
                #     vals_detalhe_z = {}

                if vals_capa_19:
                    controle = False
                    for x in lista_cupons:
                        if x.get('supcap_nro_cupom')==coo:
                            vals_capa_19['supcap_nro_serie'] = nro_serie
                            x.update(vals_capa_19)
                            controle = True

                    if not controle: # cupons de sangria e suprimento
                        vals_capa_19['supcap_loja'] = loja
                        vals_capa_19['supcap_caixa'] = caixa
                        vals_capa_19['supcap_marca_ecf'] = e01.marca_ecf
                        vals_capa_19['supcap_nro_proprietario'] = e02.numero_usuario
                        vals_capa_19['supcap_nro_serie'] = nro_serie
                        lista_cupons.append(vals_capa_19)

                    vals_capa_19 = {}

                if vals_itens_20:
                    for x in lista_cupons:
                        if x.get('supcap_nro_cupom')==coo:
                            x['supcap_nro_serie'] = nro_serie
                            if vals_itens_20.get('supcap_tipo'): # sangria e suprimento
                                x['supcap_tipo'] = vals_itens_20.pop('supcap_tipo')
                            else: # item nao fiscal, sangria e suprimento nao tem itens
                                x['supcap_mov_corpos_ids'].extend([(0, False, vals_itens_20)])

                    vals_itens_20={}

                if vals_fechamento:
                    map(lambda x: x['supcap_mov_fechamentos_ids'].extend([(0,False,vals_fechamento)])
                                  if x.get('supcap_nro_cupom')==coo else 0, lista_cupons)
                    vals_fechamento = {}

        for cupom in lista_cupons:
            # elimina os cupons que nao foram selecionados
            if cupom.get('supcap_nro_cupom') not in list_coo  and not self.exp_tudo:
                continue

            if self.exp_tudo:
                sql = """ SELECT supcap_nro_cupom
                          FROM supervisor_mov_capa
                          WHERE supcap_nro_cupom = {coos}
                            AND supcap_data_cupom = '{data}'
                            AND supcap_caixa = {caixa}
                            AND supcap_loja = {loja}
                      """.format(coos=cupom.get('supcap_nro_cupom'),
                                 data=cupom.get('supcap_data_cupom'),
                                 caixa=caixa,
                                 loja=loja)
                cr.execute(sql)
                coos_do_banco = map(lambda x: x.get('supcap_nro_cupom'), cr.dictfetchall())
                # elimina os cupons que ja estao no banco de dados
                if cupom.get('supcap_nro_cupom') in coos_do_banco:
                    continue

            self.rateia_desc_acres(cr, uid, cupom, context=context)
            if not 'supcap_operador_id' in cupom:

                operador_id = self.pool.get('supervisor.cad.operadores').\
                              search(cr, uid,[('supope_operador_supervisor','=', 'S')],
                                     context=context)
                if not operador_id:
                    raise osv.except_osv(_('Atencao!'),
                                         _('Nenhum operador cadastrado como Supervisor!'))

                cupom['supcap_operador_id'] = operador_id[0]

            if cupom.get('supcap_mov_fechamentos_ids'):
                total_fechamento = sum(map(lambda x: x[2].get('supfec_valor'),
                                           cupom.get('supcap_mov_fechamentos_ids'))
                                       )
                troco = total_fechamento - cupom.get('supcap_total_cupom')
                if troco > 0.009:
                    for fin in cupom.get('supcap_mov_fechamentos_ids'):
                        if 'DINHEIRO' in fin[2].get('supfec_nome_finalizadora').upper():
                            fin[2]['supfec_troco'] = troco

            context_cupom = context.copy()
            context_cupom['importacao_cupom_via_mfd'] = True
            obj_mov_capa.create(cr, uid, cupom, context=context_cupom)

        self.write(cr, uid, ids, {'wizccm_fim': True}, context=context)
        return True

    def rateia_desc_acres(self, cr, uid, cupom, context=None):
        context = context and context.copy() or {}
        if not cupom.get('supcap_mov_corpos_ids'):
            return True

        efetuar_rateio = self.pool.get('supervisor.util').efetuar_rateio

        desconto = cupom.get('supcap_desconto_subtotal')
        acrescimo = cupom.get('supcap_acrescimo_subtotal')
        dict_item = {}
        # retira os itens cancelados
        itens_venda = filter(lambda y: y[2].get('supcor_venda_cancelamento') == 'V',
                                           cupom.get('supcap_mov_corpos_ids'))
        list_itens = map(lambda x: [x[2].get('supcor_sequencia'),
                                    x[2].get('supcor_preco_total')],
                                    itens_venda)
        if desconto:
            itens_rateados = efetuar_rateio(desconto, list_itens)
            map(lambda x: dict_item.update({x[0]:x[1]}), itens_rateados)
            map(lambda x: x[2].update({'supcor_desconto_item': x[2].get('supcor_desconto_item',0) +
                                                          dict_item.get(x[2].get('supcor_sequencia'))}),
                itens_venda)

        if acrescimo:
            itens_rateados = efetuar_rateio(acrescimo, list_itens)
            map(lambda x: dict_item.update({x[0]:x[1]}), itens_rateados)
            map(lambda x: x[2].update({'supcor_acrescimo_item': x[2].get('supcor_acrescimo_item',0) +
                                                           dict_item.get(x[2].get('supcor_sequencia'))}),
                itens_venda)

        return True




    def numero(self, valor, decimal, context=None):
        '''
        tranforma um inteiro em float com a quantidade de casas decimais passadas
        :param valor: valor passado
        :param decimal: numero de casas decimais
        :param context:
        :return: float
        '''
        context = context and context.copy() or {}
        return valor / pow(10, decimal)

    def get_capa_cupom_14(self, cr, uid, registro, list_coo, context=None):
        context = context and context.copy() or {}

        tem_cupom_de_cancelamento = False
        total_liquido = self.numero(registro.total_liquido, 2)
        if registro.indicador_cancelamento == 'N':
            tipo = 'V'
        else:
            if total_liquido > 0: # este cupom possui um cupom de cancelamento
                tipo = 'V'
                tem_cupom_de_cancelamento = True
            else: # este cupom eh nulo
                tipo = 'N'

        coo_cancelado = 0
        if tem_cupom_de_cancelamento: # testa se o cupom de cancelamento foi selecionado mas o de venda esta gravado
            coo_cancelado = registro.coo + 1

        # pega apenas os cupons que foram selecionados e nao estao gravados no banco
        if registro.coo not in list_coo and coo_cancelado not in list_coo and not self.exp_tudo:
            return {}

        data_cupom = datetime.strptime(registro.data_inicio_emissao, "%Y%m%d")
        vals = {'supcap_data_cupom': data_cupom.date(),
                'supcap_nro_cupom': registro.coo,
                'supcap_cliente': registro.cpf_cnpj_cliente[:15],
                'supcap_data_inicio': data_cupom,
                'supcap_data_fim': data_cupom,
                'supcap_tipo': tipo,
                'supcap_alteracao': registro.indicador_desconto_acrescimo,
                'supcap_valor_desc_acres': self.numero(0, 2, context=context),
                'supcap_total_cupom': total_liquido,
                'supcap_mf_adicional': True if registro.mf_adicional else False,
                'supcap_modelo_ecf': registro.modelo_ecf,
                'supcap_ccf': registro.ccf_cvc_cbp,
                'supcap_subtotal': self.numero(registro.subtotal, 2, context=context),
                'supcap_desconto_subtotal': self.numero(registro.desconto, 2, context=context),
                'supcap_indicador_desconto': registro.tipo_desconto,
                'supcap_acrescimo_subtotal': self.numero(registro.acrescimo, 2, context=context),
                'supcap_indicador_acrescimo': registro.tipo_acrescimo,
                'supcap_indicador_cancelamento': 'N' if tipo == 'V' else 'S',
                'supcap_cancelamento_acrescimo': self.numero(registro.cancelamento_acrescimo, 2, context=context),
                'supcap_nome_cliente': registro.nome_cliente[:40],
                'supcap_mov_corpos_ids': [], # este valor eh atribuido depois com os vals dos itens
                'supcap_mov_fechamentos_ids': [], # este valor eh atribuido depois com os vals dos fechamentos
                'supcap_mov_totalizadores_xz_ids': [], # este valor eh atribuido depois com os vals dos tot. Z
        }
        vals_cancelado = {}
        if tem_cupom_de_cancelamento:
            vals_cancelado = vals.copy()
            vals_cancelado['supcap_tipo'] = 'C'
            vals_cancelado['supcap_nro_cupom'] = registro.coo + 1
            vals_cancelado['supcap_indicador_cancelamento'] = 'S'
            self.lista_coo_cancelados.append(vals)

        res = [vals] if not vals_cancelado else [vals, vals_cancelado]
        return res

    def get_itens_cupom_15(self, cr, uid, registro, list_coo,context=None):
        context = context and context.copy() or {}
        if registro.coo not in list_coo and not self.exp_tudo:
            return False

        obj_sup_cad_itens = self.pool.get('supervisor.cad.itens')
        context_aux = context.copy()
        context_aux['active_test'] = False
        item_ids = obj_sup_cad_itens.search(cr, uid, [('supite_codigo_item','like',registro.codigo_item)],
                                            context=context_aux)
        if not item_ids:
            raise osv.except_osv(_('Atencao!'),
                                 _('O item %s(%s) nao esta cadastrado na tabela de itens no supervisor!') %
                                   (registro.descricao_item, registro.codigo_item))

        brw_item = obj_sup_cad_itens.browse(cr, uid, item_ids[0], context=context)
        brw_tributacao = brw_item.supite_tributacao_id
        tipo_trib = brw_tributacao.suptri_tipo_tributacao
        desconto = self.numero(registro.desconto_item, 2, context=context)
        acrescimo = self.numero(registro.acrescimo_item, 2,context=context)
        total_bruto = self.numero(registro.total_liquido_item, 2, context=context) + desconto - acrescimo
        vals = {'supcor_sequencia': registro.numero_item,
                'supcor_item': registro.codigo_item,
                'supcor_nome_item': registro.descricao_item[:60],
                'supcor_quantidade': self.numero(registro.quantidade_item, 3, context=context),
                'supcor_unidade': registro.unidade_medida,
                'supcor_preco_unitario': self.numero(registro.valor_unitario, 2, context=context),
                'supcor_preco_total': total_bruto,
                'supcor_desconto_item': desconto,
                'supcor_acrescimo_item': acrescimo,
                'supcor_venda_cancelamento': 'V' if registro.indicador_cancelamento == 'N' else 'C',
                'supcor_tributacao_ecf': registro.codigo_totalizador[:2],
                'supcor_tributacao_retag': brw_tributacao.suptri_codigo_trib_retag,
                'supcor_aliquota': self.numero(int(registro.codigo_totalizador[3:] or 0), 2, context=context),
                'supcor_base': 100 if tipo_trib == 'T' else 0,
                'supcor_totalizador_parcial': registro.codigo_totalizador,
                'supcor_tipo_tributacao': tipo_trib,
                'supcor_indicador_arr_trunc': registro.indicador_arredondamento_truncamento,
                'supcor_indicador_ppt': 'T',
                'supcor_ncm': brw_item.supite_ncm,
                'supcor_ccf': registro.ccf_cvc_cbp
        }
        if registro.coo in self.lista_coo_cancelados:
            self.vals_itens_cancelados = vals.copy()
            self.vals_itens_cancelados['supcor_venda_cancelamento'] = 'C'

        return vals

    def get_capa_cupom_16(self, cr, uid, registro, list_coo, context=None):
        context = context and context.copy() or {}
        # pega apenas os cupons que foram selecionados e nao estao gravados no banco
        if registro.coo not in list_coo and not self.exp_tudo:
            return {}

        data_cupom = datetime.strptime(registro.data_final_emissao + registro.hora_final_emissao,
                                       "%Y%m%d%H%M%S")
        TIPOS_CUPOM = {'MF': 'M',
                       'RZ': 'Z',
                       'LX': 'X',
                       'RV': 'V',
                       'CC': 'T',
                       'RG': 'G',
                       'CN': 'G', # sangia, ressuprimento, etc... nao eh possivel definir pelo arquivo
                       'NC': 'G', # comprovante nao fiscal cancelamento, nao eh possivel definir pelo arquivo
        }
        vals = {'supcap_nro_cupom': registro.coo,
                'supcap_data_cupom': data_cupom.date(),
                'supcap_data_inicio': data_cupom,
                'supcap_data_fim': data_cupom,
                'supcap_gnf': registro.gnf,
                'supcap_crz': registro.crz,
                'supcap_grg': registro.grg,
                'supcap_cdc': registro.cdc,
                'supcap_mov_totalizadores_xz_ids': [], # este valor eh atribuido depois com os vals dos tot. Z
                }

        if TIPOS_CUPOM.get(registro.tipo_documento):
            vals['supcap_tipo'] = TIPOS_CUPOM.get(registro.tipo_documento)

        if registro.tipo_documento in ['CM', 'RV', 'CC', 'CN', 'NC', 'RG', 'NF']: # valores aceitos na capa
            vals['supcap_tipo_comprovante'] = registro.tipo_documento

        if registro.tipo_documento == 'CC':
            vals['supcap_nro_cupom_vinculado'] = registro.coo - 1

        return [vals]

    def get_detalhe_z_17(self, cr, uid, registro, context=None):
        context = context and context.copy() or {}

        vals = {'suptxz_descricao_totalizador': registro.totalizador_nao_fiscal,
                'suptxz_valor': self.numero(registro.valor_acumulado, 2, context=context),
                'suptxz_crz': registro.crz,
                'suptxz_nro_serie': registro.numero_fabricante,
                }

        return vals

    def get_detalhe_z_18(self, cr, uid, registro, context=None):
        context = context and context.copy() or {}

        vals = {'suptxz_descricao_totalizador': registro.descricao_totalizador,
                'suptxz_valor': self.numero(registro.valor_acumulado, 2, context=context),
                'suptxz_crz': registro.crz,
                'suptxz_nro_serie': registro.numero_fabricante,
                }

        return vals

    def get_capa_cupom_19(self, cr, uid, registro, list_coo, context=None):
        context = context and context.copy() or {}
        # pega apenas os cupons que foram selecionados e nao estao gravados no banco
        if registro.coo not in list_coo and not self.exp_tudo:
            return {}

        data_cupom = datetime.strptime(registro.data_inicio_emissao, "%Y%m%d")
        vals = {'supcap_data_cupom': data_cupom.date(),
                'supcap_data_inicio': data_cupom,
                'supcap_data_fim': data_cupom,
                'supcap_nro_cupom': registro.coo,
                'supcap_cliente': registro.cpf_cnpj_cliente[:15],
                'supcap_alteracao': registro.indicador_desconto_acrescimo,
                'supcap_valor_desc_acres': self.numero(registro.cancelamento_acrescimo, 2, context=context),
                'supcap_total_cupom': self.numero(registro.total_liquido, 2),
                'supcap_mf_adicional': True if registro.mf_adicional else False,
                'supcap_modelo_ecf': registro.modelo_ecf,
                'supcap_subtotal': self.numero(registro.subtotal, 2, context=context),
                'supcap_desconto_subtotal': self.numero(registro.desconto, 2, context=context),
                'supcap_indicador_desconto': registro.tipo_desconto,
                'supcap_acrescimo_subtotal': self.numero(registro.acrescimo, 2, context=context),
                'supcap_indicador_acrescimo': registro.tipo_acrescimo,
                'supcap_indicador_cancelamento': registro.indicador_cancelamento,
                'supcap_cancelamento_acrescimo': self.numero(registro.cancelamento_acrescimo, 2, context=context),
                'supcap_nome_cliente': registro.nome_cliente[:40],
                'supcap_mov_corpos_ids': [], # este valor eh atribuido depois com os vals dos itens
                'supcap_mov_fechamentos_ids': [], # este valor eh atribuido depois com os vals dos fechamentos
        }
        return vals

    def get_itens_cupom_20(self, cr, uid, registro, list_coo,context=None):
        context = context and context.copy() or {}
        if registro.coo not in list_coo and not self.exp_tudo:
            return False

        desconto = self.numero(registro.desconto_item, 2, context=context)
        acrescimo = self.numero(registro.acrescimo_item, 2,context=context)
        total_bruto = self.numero(registro.total_liquido_item, 2, context=context) + desconto - acrescimo
        nome = registro.denominacao_operacao[:15]
        vals = {'supcor_sequencia': registro.numero_item,
                'supcor_nome_item': nome,
                'supcor_preco_total': total_bruto,
                'supcor_desconto_item': desconto,
                'supcor_acrescimo_item': acrescimo,
                'supcor_venda_cancelamento': 'V' if registro.indicador_cancelamento == 'N' else 'C',
                'supcor_indicador_ppt': 'T',
        }
        if 'SANGRIA' in nome.upper():
            vals['supcap_tipo'] = 'A'

        if 'SUPRIMENTO' in nome.upper():
            vals['supcap_tipo'] = 'U'

        return vals

    def get_fechamento_21(self, cr, uid, registro, list_coo, context=None):
        context = context and context.copy() or {}
        if registro.coo not in list_coo and not self.exp_tudo:
            return False

        nome = registro.descricao_totalizador
        obj_finalizadora_ecf = self.pool.get('supervisor.cad.finalizadora.na.ecf')
        finalizadora_ecf_ids = obj_finalizadora_ecf.search(cr, uid, [('name', '=', nome)],
                                                           context=context)
        dados_finalizaroda = {}
        if finalizadora_ecf_ids:
            finalizadora_ids = self.pool.get('supervisor.cad.finalizadora').\
                       search(cr, uid, [('supfin_codigo_na_ecf', '=', finalizadora_ecf_ids[0])],
                              order='supfin_codigo', context=context)
            dados_finalizaroda = self.pool.get('supervisor.cad.finalizadora').read(cr, uid,
                                 finalizadora_ids[0], ['supfin_codigo',
                                                       'supfin_tipo_finalizadora'], context=context)

        vals = {'supfec_sequencia': 1,
                'supfec_ccf': registro.ccf,
                'supfec_gnf': registro.gnf,
                'supfec_nro_serie': registro.numero_fabricante,
                'supfec_valor':  self.numero(registro.valor_pagamento, 2, context=context),
                'supfec_nome_finalizadora': registro.descricao_totalizador,
        }
        if dados_finalizaroda:
            # cadastra a primeira finalizadora que achar caso tenha mais de uma
            vals['supfec_finalizadora'] = dados_finalizaroda.get('supfin_codigo')
            vals['supfec_tipo_finalizadora'] = dados_finalizaroda.get('supfin_tipo_finalizadora')

        return vals

class wizard_arquivo_mfd(osv.TransientModel):
    """
    Tabela de arquivo mfd
    Prefixo: wizmfd
    """
    _name = 'wizard.arquivo.mfd'
    _columns = {
        'wizmfd_consulta_id': fields.many2one('wizard.consulta.cupom.mfd', 'Consulta'),
        'wizmfd_loja': fields.integer("Loja", required=True),
        'wizmfd_caixa': fields.integer("Caixa", required=True),
        'wizmfd_nome_arquivo': fields.char("Nome do arquivo", size=40, required=True),
        'wizmfd_conteudo': fields.text("Conteudo do arquivo", required=True),
        'wizmfd_selecionado': fields.boolean('Carregar'),
    }