# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _
from dateutil.parser import parse


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        data_titulo = time.strftime('%d/%m/%Y')
        hora_titulo = time.strftime('%H:%M:%S')
        obj_supervisor_cfg_configuracao = pooler.get_pool(cr.dbname).get(
            'supervisor.cfg.configuracao')
        configuracao_ids = obj_supervisor_cfg_configuracao.search(cr, uid, [], context=context)
        nome_empresa = ''
        if configuracao_ids:
            nome_empresa = obj_supervisor_cfg_configuracao.browse(
                cr, uid, configuracao_ids[0], context=context).supcfc_cliente or ''
        title1 = center_title(_('Sistema de PDVs'), nome_empresa, _('Pagina: {{ Page }} '))
        title2 = center_title(data_titulo, _('Flash de Venda'), hora_titulo)
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Flash de Venda'))
        listagem.informaTamLinha(160)

        data_inicial = datas.get('data_inicial')
        data_final = datas.get('data_final')
        loja = datas.get('loja')

        if not loja:
            nome_loja = _('Todas')
        else:
            nome_loja = loja

        data_inicial_cabecalho = time.strftime("%d/%m/%Y", time.strptime(data_inicial, "%Y-%m-%d"))
        data_final_cabecalho = time.strftime("%d/%m/%Y", time.strptime(data_final, "%Y-%m-%d"))

        listagem.informaCab('' + title1)
        listagem.informaCab('')
        listagem.informaCab('' + title2)
        listagem.informaCab('')
        listagem.informaCab(
            _('Periodo do movimento: ') + data_inicial_cabecalho + _(' a ') + data_final_cabecalho + '     ' + _('Loja: ') + str(
                nome_loja))
        listagem.informaCab(
            '*---------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(
            _('|                    Horario                     |                      Total das Vendas                     |                Total Clientes              |'))
        listagem.informaCab(
            '*---------------------------------------------------------------------------------------------------------------------------------------------------------*')

        sql = """
                SELECT supcap_tipo,
                       supcap_total_cupom,
                       supcap_data_cupom,
                       supcap_data_fim
                FROM   supervisor_mov_capa
                WHERE  supcap_data_cupom >= '%s'
                  AND  supcap_data_cupom <= '%s' 
                  AND  supcap_tipo IN %s 
                  AND  (supcap_state IS NULL OR supcap_state = '3')""" % (data_inicial, data_final,
                                                                          ('C', 'V'))

        if loja:
            sql += """ and supcap_loja = %s""" % loja

        cr.execute(sql)
        reg = cr.dictfetchall()

        cliente_por_hora = {}
        total_cupom_por_hora = {}
        for i in range(0, 24):
            cliente_por_hora[i] = 0
            total_cupom_por_hora[i] = 0

        def formata_hora(hora):
            hora_format = str(hora)
            if len(hora_format) == 1:
                hora_format = '0' + hora_format
            return hora_format

        obj_supervisor_util = pooler.get_pool(cr.dbname).get('supervisor.util')

        for i in reg:
            tipo_cupom = i.get('supcap_tipo')
            valor_cupom = i.get('supcap_total_cupom')
            data_cupom = i.get('supcap_data_cupom')
            data_fim = obj_supervisor_util.suputi_datetime_to_timezone(
                cr, uid, parse(i.get('supcap_data_fim')), formato='%Y-%m-%d %H:%M:%s')
            hora = 0
            while hora < 24:
                if data_cupom + ' %s:00:00' % formata_hora(hora) <= data_fim <= data_cupom + ' %s:59:59' % formata_hora(hora):
                    if tipo_cupom == 'V':
                        total_cupom_por_hora[hora] += valor_cupom
                        cliente_por_hora[hora] += 1
                    else:
                        total_cupom_por_hora[hora] -= valor_cupom
                        cliente_por_hora[hora] -= 1
                    break
                hora += 1

        hora = 0
        total_clientes = 0
        total_cupom = 0
        while hora < 24:
            if not cliente_por_hora[hora]:
                hora += 1
                continue
            linha = '|'
            linha += formataString('%s:00 a %s:59' % (formata_hora(hora),formata_hora(hora)), 30, ' ', 'E', 'N', 'S')
            linha += formataString('|', 19, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(total_cupom_por_hora[hora], 2), 35, ' ', 'E', 'N', 'S')
            linha += formataString('|', 25, ' ', 'E', 'N', 'S')
            linha += formataString(cliente_por_hora[hora], 25, ' ', 'E', 'N', 'S')
            linha += formataString('|', 20, ' ', 'E', 'N', 'S')
            listagem.imprimeLinha(linha)
            total_clientes += cliente_por_hora[hora]
            total_cupom += total_cupom_por_hora[hora]
            hora += 1

        listagem.imprimeLinha(
            '*---------------------------------------------------------------------------------------------------------------------------------------------------------*')

        linha = '|'
        linha += formataString('Total', 30, ' ', 'E', 'N', 'S')
        linha += formataString('|', 19, ' ', 'E', 'N', 'S')
        linha += formataString(getNumeroEditado(total_cupom, 2), 35, ' ', 'E', 'N', 'S')
        linha += formataString('|', 25, ' ', 'E', 'N', 'S')
        linha += formataString(total_clientes, 25, ' ', 'E', 'N', 'S')
        linha += formataString('|', 20, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)

        listagem.imprimeLinha(
            '*---------------------------------------------------------------------------------------------------------------------------------------------------------*')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.wizard_relatorio_flash_vendas')


class wizard_relatorio_flash_vendas(osv.TransientModel):
    _name = 'wizard.relatorio.flash.vendas'
    _columns = {
        'data_inicial': fields.date('Data Inicial', required=True),
        'data_final': fields.date('Data Final', required=True),
        'loja': fields.integer('Loja'),
    }

    def button_print(self, cr, uid, ids, context={}):
        flash_vendas_dados = self.read(cr, uid, ids, [])
        if isinstance(flash_vendas_dados, (list, tuple)):
            flash_vendas_dados = flash_vendas_dados[0]
        datas = {
            'data_inicial': flash_vendas_dados.get('data_inicial'),
            'data_final': flash_vendas_dados.get('data_final'),
            'loja': flash_vendas_dados.get('loja'),
        }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'wizard_relatorio_flash_vendas',
            'datas': datas,
        }
