#!/usr/bin/python
# -*- encoding: utf-8 -*-
from reportlab.lib.validators import isInstanceOf

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from datetime import date
from openerp.tools.translate import _
from openerp import pooler


class groupby(dict):
    def __init__(self, seq, key=lambda x: x):
        for value in seq:
            k = key(value)

            self.setdefault(k, []).append(value)

    __iter__ = dict.iteritems


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):

    def create(self, cr, uid, ids, datas, context=None):

        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        obj_supervisor_cad_pdvs = pooler.get_pool(cr.dbname).get('supervisor.cad.pdvs')
        str_caixa = str(datas.get('caixa'))
        if not datas.get('caixa'):
            str_caixa = 'Todos'
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Supervisor Tesouraria'))
        listagem.informaTamLinha(160)

        listagem.informaCab('*-------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(' CAIXA'+'                                                       ' + 'Data: %s' % time.strftime('%d/%m/%Y') + '                                        ' + 'Caixa no.: %s' % str_caixa)
        listagem.informaCab('*-------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab('')
        listagem.rodapePadrao()

        linha = ' '
        linha += formataString('Venda Bruta:', 17, ' ', 'D', 'N', 'S')
        linha += '                    '
        linha += formataString('R$' + getNumeroEditado(datas.get('venda_bruta'), 2), 12, ' ', 'E', 'N', 'S')
        linha += '                    '
        linha += formataString('Dinheiro:', 17, ' ', 'D', 'N', 'S')
        linha += '                    '
        linha += formataString('R$' + getNumeroEditado(datas.get('saldo_dinheiro'), 2), 12, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)

        linha = ' '
        linha += formataString('Venda Liquida:', 17, ' ', 'D', 'N', 'S')
        linha += '                    '
        linha += formataString('R$' + getNumeroEditado(datas.get('venda_liquida'), 2), 12, ' ', 'E', 'N', 'S')
        linha += '                    '
        linha += formataString('Cheque:', 17, ' ', 'D', 'N', 'S')
        linha += '                    '
        linha += formataString('R$' + getNumeroEditado(datas.get('saldo_cheque'), 2), 12, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)

        linha = ' '
        linha += formataString('Recebimento:', 17, ' ', 'D', 'N', 'S')
        linha += '                    '
        linha += formataString('R$' + getNumeroEditado(datas.get('recebimento'), 2), 12, ' ', 'E', 'N', 'S')
        linha += '                    '
        linha += formataString('Cartao:', 17, ' ', 'D', 'N', 'S')
        linha += '                    '
        linha += formataString('R$' + getNumeroEditado(datas.get('saldo_cartao'), 2), 12, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)

        linha = ' '
        linha += formataString('Descontos:', 17, ' ', 'D', 'N', 'S')
        linha += '                    '
        linha += formataString('R$' + getNumeroEditado(datas.get('descontos'), 2), 12, ' ', 'E', 'N', 'S')
        linha += '                    '
        linha += formataString('PIX:', 17, ' ', 'D', 'N', 'S')
        linha += '                    '
        linha += formataString('R$' + getNumeroEditado(datas.get('saldo_ticket'), 2), 12, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)

        linha = ' '
        linha += formataString('Acrescimos:', 17, ' ', 'D', 'N', 'S')
        linha += '                    '
        linha += formataString('R$' + getNumeroEditado(datas.get('acrescimos'), 2), 12, ' ', 'E', 'N', 'S')
        linha += '                    '
        linha += formataString('Outros:', 17, ' ', 'D', 'N', 'S')
        linha += '                    '
        linha += formataString('R$' + getNumeroEditado(datas.get('saldo_outros'), 2), 12, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)

        linha = ' '
        linha += formataString('Cancelamentos:', 17, ' ', 'D', 'N', 'S')
        linha += '                    '
        linha += formataString('R$' + getNumeroEditado(datas.get('cancelamentos'), 2), 12, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)

        linha = ' '
        linha += formataString('Suprimento:', 17, ' ', 'D', 'N', 'S')
        linha += '                    '
        linha += formataString('R$' + getNumeroEditado(datas.get('suprimento'), 2), 12, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)

        listagem.imprimeLinha(' ')

        linha = ' '
        linha += formataString('Sangria Total:', 17, ' ', 'D', 'N', 'S')
        linha += '                    '
        linha += formataString('R$' + getNumeroEditado(datas.get('sangria_total'), 2), 12, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)

        linha = ' '
        linha += formataString('Sangria Dinheiro:', 17, ' ', 'D', 'N', 'S')
        linha += '                    '
        linha += formataString('R$' + getNumeroEditado(datas.get('sangria_dinheiro'), 2), 12, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)

        linha = ' '
        linha += formataString('Sangria Cheque:', 17, ' ', 'D', 'N', 'S')
        linha += '                    '
        linha += formataString('R$' + getNumeroEditado(datas.get('sangria_cheque'), 2), 12, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)

        linha = ' '
        linha += formataString('Sangria Cartao:', 17, ' ', 'D', 'N', 'S')
        linha += '                    '
        linha += formataString('R$' + getNumeroEditado(datas.get('sangria_cartao'), 2), 12, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)

        linha = ' '
        linha += formataString('Sangria PIX:', 17, ' ', 'D', 'N', 'S')
        linha += '                    '
        linha += formataString('R$' + getNumeroEditado(datas.get('sangria_ticket'), 2), 12, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)

        linha = ' '
        linha += formataString('Sangria Outros:', 17, ' ', 'D', 'N', 'S')
        linha += '                    '
        linha += formataString('R$' + getNumeroEditado(datas.get('sangria_outros'), 2), 12, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)

        listagem.imprimeLinha('*-------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        linha = ' '
        linha += formataString('Total:', 17, ' ', 'D', 'N', 'S')
        linha += '                    '
        linha += formataString('R$' + getNumeroEditado(datas.get('saldo_total'), 2), 12, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)
        listagem.imprimeLinha('*-------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        linha = ' '
        linha += formataString('Saldo do Caixa:', 17, ' ', 'D', 'N', 'S')
        linha += '                    '
        linha += formataString('R$' + getNumeroEditado(datas.get('saldo_caixa'), 2), 12, ' ', 'E', 'N', 'S')
        linha += '                    '
        linha += formataString('Diferenca:', 17, ' ', 'D', 'N', 'S')
        linha += '                    '
        linha += formataString('R$' + getNumeroEditado(datas.get('saldo_diferenca'), 2), 12, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)
        listagem.imprimeLinha('*-------------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

report_custom('report.listagem_supervisor_tesouraria')


class wizard_relatorio_tesouraria(osv.TransientModel):
    _name = 'wizard.relatorio.tesouraria'
    _description = 'Relatorio de tesouraria'

    _columns = {
        'data': fields.date('Data', required=True),

        'loja': fields.integer('Loja'),
        'caixa': fields.integer('Caixa'),
        'turno_ids': fields.many2many(
            'supervisor.mov.caixa', 'm2m_rel_tesouraria_supervisor_mov_caixa',
            'rel_tesouraria_id', 'mov_caixa_id', 'Turno',
            domain="[('supcax_loja', '=', loja), ('supcax_caixa', '=', caixa),"
                   "('supcax_data_hora_abertura', '>=', data),"
                   "('supcax_data_hora_abertura', '<=', data)]"),
        'venda_bruta': fields.float('Venda bruta', digits=(15, 2)),
        'descontos': fields.float('Descontos', digits=(15, 2)),
        'acrescimos': fields.float('Acrescimos', digits=(15, 2)),
        'cancelamentos': fields.float('Cancelamentos', digits=(15, 2)),
        'venda_liquida': fields.float('Venda liquida', digits=(15, 2)),
        'recebimento': fields.float('Recebimento', digits=(15, 2)),
        'suprimento': fields.float('Suprimento', digits=(15, 2)),
        'sangria': fields.float('Sangria', digits=(15, 2)),
        'saldo_caixa': fields.float('Saldo caixa', digits=(15, 2)),
        'saldo_dinheiro': fields.float('Dinheiro', digits=(15, 2)),
        'saldo_cheque': fields.float('Cheque', digits=(15, 2)),
        'saldo_cartao': fields.float('Cartao', digits=(15, 2)),
        'saldo_outros': fields.float('Outros', digits=(15, 2)),
        'saldo_ticket': fields.float('PIX', digits=(15, 2)),
        'saldo_total': fields.float('Total', digits=(15, 2)),
        'saldo_diferenca': fields.float('Diferenca', digits=(15, 2)),
        'sangria_dinheiro': fields.float('Dinheiro', digits=(15, 2)),
        'sangria_cheque': fields.float('Cheque', digits=(15, 2)),
        'sangria_cartao': fields.float('Cartao', digits=(15, 2)),
        'sangria_outros': fields.float('Outros', digits=(15, 2)),
        'sangria_ticket': fields.float('PIX', digits=(15, 2)),
        'sangria_total': fields.float('Total', digits=(15, 2)),
    }

    _defaults = {
        'data': fields.date.today(),
    }

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        res = super(wizard_relatorio_tesouraria, self).create(cr, uid, vals, context)
        return res

    def calcular(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = True
        dados_tesouraria = self.read(cr, uid, ids, ['data', 'loja', 'caixa', 'turno_ids'], context=context,
                                     load='_classic_write')
        for x in dados_tesouraria:
            data = x.get('data')
            loja = x.get('loja')
            caixa = x.get('caixa')
            turno_ids = x.get('turno_ids')
            dados_calculo = self.get_dados_fechamento(cr, uid, data, loja, caixa, turno_ids,
                                                      context)
            for dado in dados_calculo:
                saldo_total = sum([dado.get('saldo_dinheiro') or 0.0,
                                   dado.get('saldo_cheque') or 0.0,
                                   dado.get('saldo_ticket') or 0.0,
                                   dado.get('saldo_cartao') or 0.0,
                                   dado.get('saldo_outros') or 0.0])
                dado['saldo_total'] = saldo_total
                dado['saldo_diferenca'] = dado.get('saldo_caixa')
                sangria_total = sum([dado.get('sangria_dinheiro') or 0.0,
                                     dado.get('sangria_cheque') or 0.0,
                                    dado.get('sangria_ticket') or 0.0,
                                     dado.get('sangria_cartao') or 0.0,
                                    dado.get('sangria_outros') or 0.0])
                dado['sangria_total'] = sangria_total
                self.write(cr, uid, x.get('id'), dado, context)
        return res

    def get_dados_fechamento(self, cr, uid, data, loja=False, caixa=False, turno_ids=[], context=None):
        """
        Venda Bruta Diaria = Total itens + Acrescimo Itens sem Rateio + Acrescimo capa 
                            (Cupons de venda, venda(cancelados) e nulos)
        Cancelamento ICMS = Total itens + Acrescimo Itens sem Rateio 
                            (Para itens com venda_cancelamento = 'C' independente do cupom)
                            + Acrescimo da capa (Cupons Nulos e Cancelados)
        Desconto ICMS = Soma do (Desconto dos itens com rateio (Cupons de venda) 
                                - Desconto dos itens com rateio (Cupons de venda cancelados))
        Venda Liquida = Total liquido dos cupons de venda 
                       - Total liquido dos cupons de venda cancelados
        Acrescimo ICMS = Acrescimo das Capas (Cupons de venda)
                       + Acrescimo dos itens (Cupons de venda, itens com venda_cancelamento = 'V')
                       - Acrescimo das Capas (Cupons de venda cancelados)
                       - Acrescimo dos itens (Cupons de venda cancelados) 
        """
        context = context and context.copy() or {}
        cond_loja = cond_caixa = ""
        if loja:
            cond_loja += """AND smc.supcap_loja = %s """ % loja
        if caixa:
            cond_caixa += """AND smc.supcap_caixa = %s """ % caixa

        cond_turno = []
        if turno_ids:
            for i in turno_ids:
                cr.execute("""SELECT supcax_data_hora_abertura   AS ini,
                                     supcax_data_hora_fechamento AS fim
                              FROM supervisor_mov_caixa
                              WHERE id = %s
                           """ % i)
                datas = cr.dictfetchall()
                if not datas[0].get('fim'):
                    raise osv.except_osv(_('Atencao!'),
                                         _('Turno sem data de fechamento'))
                cond_turno.append("""smc.supcap_data_inicio BETWEEN '%s' AND '%s'""" % (datas[0].get('ini'),
                                                                                     datas[0].get('fim')))
        if cond_turno:
            cond_turno = 'AND (%s)' % '\n                   OR '.join(cond_turno)
        else:
            cond_turno = ''

        sql = """
            SELECT smc.supcap_nro_cupom                             AS coo,
                   smc.supcap_caixa                                 AS caixa,
                   smc.supcap_tipo                                  AS tipo_cupom,
                   smc.supcap_state                                 AS state,
                   smc.supcap_total_cupom                           AS total_liquido_cupom,
                   CASE WHEN smc.supcap_alteracao = 'A' 
                        THEN smc.supcap_valor_desc_acres  
                        ELSE 0
                   END                                              AS acres_capa,
                   COALESCE(smcor.supcor_venda_cancelamento)        AS venda_cancelamento,
                   COALESCE(smcor.supcor_preco_total, 0)            AS total_bruto_item,
                   COALESCE(smcor.supcor_desconto_item, 0)          AS desconto_item,
                   COALESCE(smcor.supcor_acrescimo_item_sem_rat, 0) AS acrescimo_item,
                   smc.supcap_cod_tot_nao_fiscal                    AS tot_nao_fiscal 
            FROM supervisor_mov_capa             AS smc
            LEFT JOIN supervisor_mov_corpos      AS smcor ON supcor_capa_id = smc.id
            WHERE smc.supcap_data_cupom = '{data_cupom}'
              {cond_loja}
              {cond_caixa}
              {cond_turno}
              AND smc.supcap_tipo IN ('A', 'W', 'U', 'V', 'C', 'D', 'N', 'R')
        """.format(data_cupom=data,
                   cond_loja=cond_loja,
                   cond_caixa=cond_caixa,
                   cond_turno=cond_turno)
        cr.execute(sql)
        dados = cr.dictfetchall()
        sql = """SELECT CASE WHEN COALESCE(smf.supfec_valor,0) = 0
                             THEN smc.supcap_total_cupom
                             ELSE COALESCE(smf.supfec_valor,0) - COALESCE(smf.supfec_troco , 0) 
                        END                                              AS valor_fechamento,          
                        CASE WHEN scf.name ilike '%PIX%'
                             THEN 'T'
                             ELSE smf.supfec_tipo_finalizadora    
                        END                                              AS tipo_finalizadora,
                        smc.supcap_tipo                                  AS tipo_cupom,
                        smc.supcap_cod_tot_nao_fiscal                    AS tot_nao_fiscal,
                        smc.supcap_state                                 AS state 

                 FROM supervisor_mov_capa             AS smc
                 LEFT JOIN supervisor_mov_fechamentos AS smf   ON smf.supfec_capa_id = smc.id
                 LEFT JOIN supervisor_cad_finalizadora AS scf ON scf.supfin_codigo = smf.supfec_finalizadora
                 WHERE smc.supcap_data_cupom = '{data_cupom}'
                   {cond_loja}
                   {cond_caixa}
                   {cond_turno}
                   AND smc.supcap_tipo IN ('A', 'W', 'U', 'V', 'C', 'D')
              """.format(data_cupom=data,
                         cond_loja=cond_loja,
                         cond_caixa=cond_caixa,
                         cond_turno=cond_turno)
        cr.execute(sql)
        dados_fechamentos = cr.dictfetchall()
        obj_parametros = self.pool.get('supervisor.cfg.parametros')
        par_ids = obj_parametros.search(cr, uid, [], context=context)
        tot_nao_fiscal = obj_parametros.read(cr, uid, par_ids[0], ['supcfp_tot_devolucao_ficha'],
                                             context=context).get('supcfp_tot_devolucao_ficha')
        res = []
        chaves = []
        venda_bruta = 0
        venda_liquida = 0
        cancelamentos = 0
        descontos = 0
        acrescimos = 0
        sangria = 0
        suprimento = 0
        recebimento = 0
        acrescimos_capa = []
        cancel_acrescimos_capa = []
        for dado in dados:
            considera_dav = False
            if not context.get('wizrte_nao_considera_dav'):
                considera_dav =  dado.get('state') == '6'
            coo = dado.get('coo')
            if dado.get('tipo_cupom') == 'V' and (dado.get('state') in ('3', '4', '2E') or not dado.get('state'))\
                    or considera_dav:
                venda_bruta += dado.get('total_bruto_item') + dado.get('acrescimo_item')
                if dado.get('venda_cancelamento') == 'V':
                    descontos += dado.get('desconto_item')
                    acrescimos += dado.get('acrescimo_item')
                else:
                    cancelamentos += dado.get('total_bruto_item') + dado.get('acrescimo_item')

                if coo not in acrescimos_capa:
                    acrescimos_capa.append(coo)
                    venda_bruta += dado.get('acres_capa')
                    acrescimos += dado.get('acres_capa')

            elif dado.get('tipo_cupom') == 'N':
                venda_bruta += dado.get('total_bruto_item') + dado.get('acrescimo_item')
                cancelamentos += dado.get('total_bruto_item') + dado.get('acrescimo_item')
                if coo not in acrescimos_capa:
                    acrescimos_capa.append(coo)
                    venda_bruta += dado.get('acres_capa')
                    cancelamentos += dado.get('acres_capa')

            elif dado.get('tipo_cupom') == 'C' and not dado.get('state'):
                acrescimos -= dado.get('acrescimo_item')
                descontos -= dado.get('desconto_item')
                cancelamentos += dado.get('total_bruto_item') + dado.get('acrescimo_item')
                if coo not in cancel_acrescimos_capa:
                    cancel_acrescimos_capa.append(coo)
                    acrescimos -= dado.get('acres_capa')
                    cancelamentos += dado.get('acres_capa')

            chave = '%s-%s' % (coo, dado.get('caixa'))
            if chave not in chaves:
                chaves.append(chave)
                if dado.get('tipo_cupom') == 'V' and (dado.get('state') in ('3', '4', '2E') or not dado.get('state')) \
                        or considera_dav:
                    venda_liquida += dado.get('total_liquido_cupom')

                elif dado.get('tipo_cupom') == 'C' and not dado.get('state'):
                    venda_liquida -= dado.get('total_liquido_cupom')

                elif dado.get('tipo_cupom') == 'A':
                    sangria += dado.get('total_liquido_cupom')

                elif dado.get('tipo_cupom') in ('W', 'R'):
                    # subtrai o valor dos recebimentos onde o totalizador eh de devolucao
                    if tot_nao_fiscal and dado.get('tot_nao_fiscal') == tot_nao_fiscal:
                        recebimento -= dado.get('total_liquido_cupom')
                    else:
                        recebimento += dado.get('total_liquido_cupom')

                elif dado.get('tipo_cupom') == 'U':
                    suprimento += dado.get('total_liquido_cupom')

        saldo_dinheiro = 0
        saldo_cheque = 0
        saldo_outros = 0
        saldo_cartao = 0
        saldo_ticket = 0
        sangria_dinheiro = 0
        sangria_cheque = 0
        sangria_outros = 0
        sangria_cartao = 0
        sangria_ticket = 0
        for dado in dados_fechamentos:
            if dado.get('tipo_cupom') == 'C' and not dado.get('state'): # saldo cancelado
                if dado.get('tipo_finalizadora') == 'D':
                    saldo_dinheiro -= dado.get('valor_fechamento')

                elif dado.get('tipo_finalizadora') == 'H':
                    saldo_cheque -= dado.get('valor_fechamento')

                elif dado.get('tipo_finalizadora') == 'O':
                    saldo_outros -= dado.get('valor_fechamento')

                elif dado.get('tipo_finalizadora') == 'C':
                    saldo_cartao -= dado.get('valor_fechamento')

                elif dado.get('tipo_finalizadora') == 'T':
                    saldo_ticket -= dado.get('valor_fechamento')

            elif dado.get('tipo_cupom') == 'A': # saldo da sangria
                if dado.get('tipo_finalizadora') == 'D':
                    sangria_dinheiro += dado.get('valor_fechamento')

                elif dado.get('tipo_finalizadora') == 'H':
                    sangria_cheque += dado.get('valor_fechamento')

                elif dado.get('tipo_finalizadora') == 'O':
                    sangria_outros += dado.get('valor_fechamento')

                elif dado.get('tipo_finalizadora') == 'C':
                    sangria_cartao += dado.get('valor_fechamento')

                elif dado.get('tipo_finalizadora') == 'T':
                    sangria_ticket += dado.get('valor_fechamento')

            elif dado.get('tipo_cupom') != 'C': # saldo sem a sangria
                if dado.get('tipo_finalizadora') == 'D' or not dado.get('tipo_finalizadora'):
                    if tot_nao_fiscal and dado.get('tot_nao_fiscal') == tot_nao_fiscal:
                        saldo_dinheiro -= dado.get('valor_fechamento')
                    else:
                        saldo_dinheiro += dado.get('valor_fechamento')

                elif dado.get('tipo_finalizadora') == 'H':
                    saldo_cheque += dado.get('valor_fechamento')

                elif dado.get('tipo_finalizadora') == 'O':
                    saldo_outros += dado.get('valor_fechamento')

                elif dado.get('tipo_finalizadora') == 'C':
                    saldo_cartao += dado.get('valor_fechamento')

                elif dado.get('tipo_finalizadora') == 'T':
                    saldo_ticket += dado.get('valor_fechamento')

        saldo_caixa = venda_liquida + recebimento + suprimento - sangria
        res.append({'venda_bruta': venda_bruta,
                    'venda_liquida': venda_liquida,
                    'cancelamentos': cancelamentos,
                    'descontos': descontos,
                    'sangria': sangria,
                    'recebimento': recebimento,
                    'acrescimos': acrescimos,
                    'suprimento': suprimento,
                    'saldo_caixa': saldo_caixa,
                    'saldo_dinheiro': saldo_dinheiro,
                    'saldo_cheque': saldo_cheque,
                    'saldo_outros': saldo_outros,
                    'saldo_cartao': saldo_cartao,
                    'saldo_ticket': saldo_ticket,
                    'sangria_dinheiro': sangria_dinheiro,
                    'sangria_cheque': sangria_cheque,
                    'sangria_outros': sangria_outros,
                    'sangria_cartao': sangria_cartao,
                    'sangria_ticket': sangria_ticket})
        return res

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        dados_tesouraria = self.read(cr, uid, ids, [], context=context)
        if isinstance(dados_tesouraria, (list, tuple)):
            dados_tesouraria = dados_tesouraria[0]
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'listagem_supervisor_tesouraria',
            'datas': dados_tesouraria,
        }

    def onchange_turno(self, cr, uid, ids, data, loja, caixa, context=None):
        context = context and context.copy() or {}
        turno_ids = []
        if data and loja and caixa:
            data_ini = '%s 00:00:00' % data
            data_fin = '%s 23:59:59' % data
            obj_mov_caixa = self.pool.get('supervisor.mov.caixa')
            turno_ids = obj_mov_caixa.search(
                cr, uid, [('supcax_data_hora_abertura', '>=', data_ini),
                          ('supcax_data_hora_abertura', '<=', data_fin),
                          ('supcax_caixa', '=', caixa), ('supcax_loja', '=', loja)], context=context)
        res = {'value': {'turno_ids': turno_ids}}
        return res
