# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=200):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        data_titulo = time.strftime('%d/%m/%Y')
        hora_titulo = time.strftime('%H:%M:%S')
        obj_supervisor_cfg_configuracao = pooler.get_pool(cr.dbname).get(
            'supervisor.cfg.configuracao')
        configuracao_ids = obj_supervisor_cfg_configuracao.search(cr, uid, [], context=context)
        nome_empresa = ''
        if configuracao_ids:
            nome_empresa = obj_supervisor_cfg_configuracao.browse(
                cr, uid, configuracao_ids[0], context=context).supcfc_cliente or ''
        title1 = center_title(_('Sistema de PDVs'), nome_empresa, _('Pagina: {{ Page }} '))
        title2 = center_title(data_titulo, _('Resumo de vendas por Tributacao'), hora_titulo)
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='1')
        listagem.informaNome(pdf_string, _('Vendas por tributacao'))
        listagem.informaTamLinha(160)

        data = datas.get('data')
        loja = datas.get('loja')

        if not loja:
            nome_loja = _('Todas')
        else:
            nome_loja = loja

        data_cabecalho = time.strftime("%d/%m/%Y", time.strptime(data, "%Y-%m-%d"))

        listagem.rodapePadrao()

        listagem.informaCab('' + title1)
        listagem.informaCab('')
        listagem.informaCab('' + title2)
        listagem.informaCab('')
        listagem.informaCab(_('Data do movimento: ') + data_cabecalho + '     ' + _('Loja: ') + str(nome_loja))
        listagem.informaCab(
            '*--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')

        sql = """
            SELECT ca.supcap_caixa,
                   co.supcor_aliquota,
                   co.supcor_tipo_tributacao_icms,
                   SUM(CASE WHEN ca.supcap_tipo = 'V' AND co.supcor_venda_cancelamento = 'V' AND ca.supcap_state IS NULL
                            THEN co.supcor_preco_total + co.supcor_acrescimo_item - co.supcor_desconto_item
                            WHEN ca.supcap_tipo = 'V' AND co.supcor_venda_cancelamento = 'V' AND ca.supcap_state IN ('3','4', '2E')
                            THEN co.supcor_preco_total + co.supcor_acrescimo_item - co.supcor_desconto_item
                            WHEN ca.supcap_tipo = 'C' AND ca.supcap_state IS NULL 
                            THEN (co.supcor_preco_total + co.supcor_acrescimo_item - co.supcor_desconto_item) * -1
                            ELSE 0
                       END) AS supcor_preco_total
            FROM supervisor_mov_capa         AS ca
            INNER JOIN supervisor_mov_corpos AS co ON co.supcor_capa_id = ca.id 
            WHERE ca.supcap_data_cupom = '%s'
        """ % data
        if loja:
            sql += """
                and ca.supcap_loja = %s
        """ % loja
        sql += """
                and ca.supcap_tipo in ('V', 'C')
            group by
                ca.supcap_caixa, co.supcor_aliquota, co.supcor_tipo_tributacao_icms
            order by
                ca.supcap_caixa
        """

        cr.execute(sql)
        reg = cr.dictfetchall()

        obj_supervisor_cad_tributacao = pooler.get_pool(cr.dbname).get('supervisor.cad.tributacao')
        tributacao_ids = obj_supervisor_cad_tributacao.search(
            cr, uid, [('suptri_tipo_tributacao', '=', 'T')], context=context)
        tributacao_dados = obj_supervisor_cad_tributacao.read(cr, uid, tributacao_ids,
                                                              ['suptri_aliquota'], context=context)
        aliquotas = list(set(map(lambda i: i.get('suptri_aliquota'), tributacao_dados)))
        cabecalho = _('| PDVs |   Total   |     F     |     I     |     N     |')

        for j in aliquotas:
            cabecalho += '   ' + str(getNumeroEditado(j, 2)) + '%   |'

        listagem.informaCab(cabecalho)
        listagem.informaCab(
            '*--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')


        total_geral = 0
        total_valor_f = 0
        total_valor_i = 0
        total_valor_n = 0
        soma_aliquotas_geral = {}
        for x in aliquotas:
            soma_aliquotas_geral[x] = 0
        list_caixa = []
        for i in reg:
            total_item = 0
            valor_f = 0
            valor_i = 0
            valor_n = 0
            soma_aliquotas = {}
            for x in aliquotas:
                soma_aliquotas[x] = 0
            caixa = i.get('supcap_caixa')
            if caixa in list_caixa:
                continue
            list_caixa.append(caixa)
            dados_caixa = filter(lambda i: i.get('supcap_caixa') == caixa, reg)
            for x in dados_caixa:
                tipo_tributacao = (x.get('supcor_tipo_tributacao_icms') or '').strip()
                preco_total = x.get('supcor_preco_total') or 0
                acrescimo = x.get('supcor_acrescimo_item') or 0
                desconto = x.get('supcor_desconto_item') or 0
                aliquota = x.get('supcor_aliquota')
                if tipo_tributacao in ('F', 'U'):
                    valor_f += preco_total + acrescimo - desconto
                    total_item += preco_total + acrescimo - desconto
                    total_valor_f += valor_f
                elif tipo_tributacao == 'I':
                    valor_i += preco_total + acrescimo - desconto
                    total_item += preco_total + acrescimo - desconto
                    total_valor_i += valor_i
                elif tipo_tributacao == 'N':
                    valor_n += preco_total + acrescimo - desconto
                    total_item += preco_total + acrescimo - desconto
                    total_valor_n += valor_n
                elif tipo_tributacao == 'T':
                    if soma_aliquotas.get(aliquota):
                        soma_aliquotas[aliquota] += preco_total + acrescimo - desconto
                    else:
                        soma_aliquotas[aliquota] = preco_total + acrescimo - desconto
                    if soma_aliquotas_geral.get(aliquota):
                        soma_aliquotas_geral[aliquota] += soma_aliquotas.get(aliquota)
                    else:
                        soma_aliquotas_geral[aliquota] = soma_aliquotas.get(aliquota)
                    total_item += preco_total + acrescimo - desconto

            linha = '|'
            linha += formataString(caixa, 6, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(total_item), 11, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(valor_f, 2), 11, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(valor_i, 2), 11, ' ', 'E', 'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(valor_n, 2), 11, ' ', 'E', 'N', 'S')
            linha += '|'

            for x in aliquotas:
                if x > 10:
                    linha += formataString(getNumeroEditado(soma_aliquotas[x], 2), 12, ' ', 'E', 'N', 'S')
                else:
                    linha += formataString(getNumeroEditado(soma_aliquotas[x], 2), 11, ' ', 'E', 'N', 'S')
                linha += '|'

            total_geral += total_item

            listagem.imprimeLinha(linha)

        linha = '|'
        linha += formataString('', 7, ' ', 'E', 'N', 'S')
        linha += formataString(getNumeroEditado(total_geral), 11, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString(getNumeroEditado(total_valor_f, 2), 11, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString(getNumeroEditado(total_valor_i, 2), 11, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString(getNumeroEditado(total_valor_n, 2), 11, ' ', 'E', 'N', 'S')
        linha += '|'

        for x in aliquotas:
            if x > 10:
                linha += formataString(getNumeroEditado(soma_aliquotas_geral[x], 2), 12, ' ', 'E', 'N', 'S')
            else:
                linha += formataString(getNumeroEditado(soma_aliquotas_geral[x], 2), 11, ' ', 'E', 'N', 'S')
            linha += '|'

        listagem.imprimeLinha(
            '*--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')

        listagem.imprimeLinha(linha)

        listagem.imprimeLinha(
            '*--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------*')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.wizard_relatorio_vendas_tributacao')


class wizard_relatorio_vendas_tributacao(osv.TransientModel):
    _name = 'wizard.relatorio.vendas.tributacao'
    _columns = {
        'data': fields.date('Data', required=True),
        'loja': fields.integer('Loja'),
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        vendas_tributacao = self.read(cr, uid, ids, [], context=context)
        if isinstance(vendas_tributacao, (list, tuple)):
            vendas_tributacao = vendas_tributacao[0]
        datas = {
            'data': vendas_tributacao.get('data'),
            'loja': vendas_tributacao.get('loja'),
        }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'wizard_relatorio_vendas_tributacao',
            'datas': datas,
        }
