# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _


class wizard_supervisor_altera_forma_pagamento(osv.TransientModel):
    # prefixo: wizafp_
    _name = 'wizard.supervisor.altera.forma.pagamento'
    _columns = {
        'wizafp_loja': fields.integer('Loja'),
        'wizafp_caixa': fields.integer('Caixa'),
        'wizafp_nro_cupom': fields.integer('Numero cupom'),
        'wizafp_data_cupom': fields.date('Data cupom'),
        'wizafp_item_ids': fields.one2many('wizard.supervisor.altera.forma.pagamento.item',
                                           'wizafi_capa_id', 'Itens'),
    }

    def wizafp_button_pesquisar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = False
        cr.execute('DELETE FROM wizard_supervisor_altera_forma_pagamento_item WHERE create_uid = %s'
                   % uid)
        obj_altera_forma_pagamento_item = self.pool.get(
            'wizard.supervisor.altera.forma.pagamento.item')
        brw_altera_forma_pagamento = self.browse(cr, uid, ids, context)
        for x in brw_altera_forma_pagamento:
            loja = x.wizafp_loja
            caixa = x.wizafp_caixa
            nro_cupom = x.wizafp_nro_cupom
            data_cupom = x.wizafp_data_cupom
            sql = """
                SELECT
                    supcap_loja                 AS wizafi_loja,
                    supcap_caixa                AS wizafi_caixa,
                    supcap_nro_cupom            AS wizafi_nro_cupom,
                    supcap_total_cupom          AS wizafi_valor_cupom,
                    supfec_finalizadora         AS wizafi_finalizadora,
                    supfec_tipo_finalizadora    AS wizafi_tipo_finalizadora,
                    supfec_valor                AS wizafi_valor_finalizadora,
                    smf.id                      AS wizafi_fechamento
                FROM supervisor_mov_fechamentos smf
                INNER JOIN supervisor_mov_capa smc
                    ON smc.id = smf.supfec_capa_id
                WHERE
                    1 = 1
            """
            if loja:
                sql += """
                    AND supcap_loja = %s
                """ % loja
            if caixa:
                sql += """
                    AND supcap_caixa = %s
                """ % caixa
            if nro_cupom:
                sql += """
                    AND supcap_nro_cupom = %s
                """ % nro_cupom
            if data_cupom:
                sql += """
                    AND supcap_data_cupom = '%s'
                """ % data_cupom
            sql += """
                ORDER BY smc.id
            """
            if not any([loja, caixa, nro_cupom, data_cupom]):
                sql += """
                LIMIT 10000
                """
            cr.execute(sql)
            dados = cr.dictfetchall()
            for dado in dados:
                dado.update({'wizafi_capa_id': x.id})
                obj_altera_forma_pagamento_item.create(cr, uid, dado, context)
                res = True
        return res

    def wizafp_button_salvar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = super(wizard_supervisor_altera_forma_pagamento, self).write(cr, uid, ids, {}, context)
        return res


class wizard_supervisor_altera_forma_pagamento_item(osv.TransientModel):
    # prefixo: wizafi_
    _name = 'wizard.supervisor.altera.forma.pagamento.item'
    _columns = {
        'wizafi_capa_id': fields.many2one('wizard.supervisor.altera.forma.pagamento', 'Capa'),
        'wizafi_loja': fields.integer('Loja'),
        'wizafi_caixa': fields.integer('Caixa'),
        'wizafi_nro_cupom': fields.integer('Cupom'),
        'wizafi_valor_cupom': fields.float('Valor cupom', digits=(10, 3)),
        'wizafi_finalizadora': fields.integer('Finalizadora', size=100),
        'wizafi_tipo_finalizadora': fields.selection([('D', 'Dinheiro'),
                                                      ('H', 'Cheque'),
                                                      ('C', 'Cartao'),
                                                      ('T', 'Ticket'),
                                                      ('O', 'Outros')], 'Tipo finalizadora'),
        'wizafi_valor_finalizadora': fields.float('Valor finalizadora', digits=(10, 2)),
        'wizafi_fechamento': fields.integer('Fechamento'),
    }
    _order = 'wizafi_loja, wizafi_caixa, wizafi_nro_cupom'

    def wizafi_onchange_finalizadora(self, cr, uid, ids, finalizadora, context=None):
        context = context and context.copy() or {}
        res = {}
        brw_altera_forma_pagamento_item = self.browse(cr, uid, ids[0], context)
        finalizadora_inicial = brw_altera_forma_pagamento_item.wizafi_finalizadora
        tipo_finalizadora = brw_altera_forma_pagamento_item.wizafi_tipo_finalizadora
        res['value'] = {'wizafi_finalizadora': finalizadora_inicial}
        if not finalizadora:
            return res
        obj_supervisor_cad_finalizadora = self.pool.get('supervisor.cad.finalizadora')
        cad_finalizadora_ids = obj_supervisor_cad_finalizadora.search(
            cr, uid, [('supfin_codigo', '=', finalizadora)], context=context)
        if not cad_finalizadora_ids:
            return res
        cad_tipo_finalizadora = obj_supervisor_cad_finalizadora.browse(
            cr, uid, cad_finalizadora_ids[0], context).supfin_tipo_finalizadora
        if tipo_finalizadora != cad_tipo_finalizadora:
            res['warning'] = {'title': _('Atencao'), 'message': _('Esta finalizadora nao e do '
                                                                  'mesmo tipo da anterior!')}
        else:
            res['value'] = {'wizafi_finalizadora': finalizadora}
        return res

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        res = super(wizard_supervisor_altera_forma_pagamento_item, self).write(cr, uid, ids, vals,
                                                                               context)
        brw_item = self.browse(cr, uid, ids, context)
        finalizadora = vals.get('wizafi_finalizadora')
        if not finalizadora:
            return res
        obj_supervisor_mov_fechamentos = self.pool.get('supervisor.mov.fechamentos')
        obj_supervisor_cad_finalizadora = self.pool.get('supervisor.cad.finalizadora')
        cad_finalizadora_ids = obj_supervisor_cad_finalizadora.search(
            cr, uid, [('supfin_codigo', '=', finalizadora)])
        nome_finalizadora = ''
        if cad_finalizadora_ids:
            nome_finalizadora = obj_supervisor_cad_finalizadora.browse(
                cr, uid, cad_finalizadora_ids[0], context).name or ''
        for item in brw_item:
            mov_fechamentos_id = item.wizafi_fechamento
            obj_supervisor_mov_fechamentos.write(cr, uid, mov_fechamentos_id,
                                                 {'supfec_finalizadora': finalizadora,
                                                  'supfec_nome_finalizadora': nome_finalizadora},
                                                 context)
        return res
