# -*- coding: utf-8 -*-
#
# OBS: para funcionar eh preciso que tenha a pasta 'static' dentro do modulo

import openerp.addons.web.http as http
import xmlrpclib, socket
import json
import psycopg2

SEM_ERRO = '00'
ERRO_CONEXAO = '01'
USUARIO_NAO_CASTRADO = ''
ITEM_NAO_CASTRADO = '05'
SENHA_INCORRETA = ''
ERRO_EXECUTAR_SQL = ''


def dictfetchall(_cr):
    """ fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
     para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
     conversao."""

    # testa resultados armazenados
    results = _cr.fetchall()
    if results < 1:
        return results

    # substitui resultados das listas por dicionarios
    rownum = 0
    for row in results:
        dictrow = {}
        dictnum = 0
        for col in _cr.description:
            dictrow[col[0]] = row[dictnum]
            dictnum += 1

        results[rownum] = dictrow
        rownum += 1

    return results


class sc_supervisor_android(http.Controller):
    _cp_path = '/supervisor_android'

    @http.httprequest
    def teste(self, req, s_action=None, **kw):
        ip = req.httprequest.environ.get('REMOTE_ADDR')
        print(ip)
        return ip

    @http.httprequest
    def atualizar_ip_caixa(self, req, s_action=None, **kw):
        """Deve retornar uma string para nao ocorrer erro"""

        return 'OK'

    def _get_cursor(self):
        try:
            conn = psycopg2.connect(database='construmais_t', password='sig', user='openerp', host='localhost',
                                    connect_timeout=3)
            cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
            return cr, False
        except Exception as e:
            return False, json.dumps({'codigo': ERRO_CONEXAO,
                                      'mensagem': 'Erro: %s' % e,
                                      'retorno': [],
                                      })


    @http.httprequest
    def logar(self, req, s_action=None, **kw):
        cr, erro = self._get_cursor()
        if not cr:
            return erro

        login = req.params.get('username')
        senha = req.params.get('password')
        try:
            cr.execute("""
                SELECT id,
                       name                       AS nome,
                       supope_operador_supervisor AS tipo,
                       supope_codigo              AS login,
                       supope_senha               AS senha,
                       supope_cancela_item        AS cancela_item,
                       supope_desconto_item       AS desconto_item,
                       supope_libera_restricao    AS libera_restricao,
                       active                     AS acive                       
                FROM supervisor_cad_operadores
                WHERE supope_codigo = '{login}'
                       """.format(login=login))
            dados = dictfetchall(cr)
            if not dados:
                cr.close()
                return json.dumps({'codigo': USUARIO_NAO_CASTRADO,
                                   'mensagem': 'Login ou E-mail não cadatrado!',
                                   'retorno': []})

            if dados[0].get('senha') != senha:
                cr.close()
                return json.dumps({'codigo': SENHA_INCORRETA,
                                   'mensagem': 'Senha Incorreta!',
                                   'retorno': []})
            cr.close()
            return json.dumps({'retorno': dados,
                               'codigo': SEM_ERRO,
                               'mensagem': 'ok'})
        except Exception as e:
            cr.close()
            return json.dumps({'codigo': ERRO_EXECUTAR_SQL,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': []})

    @http.httprequest
    def busca_item(self, req, s_action=None, **kw):
        cr, erro = self._get_cursor()
        if not cr:
            return erro

        codigo = req.params.get('codigo').zfill(14)
        try:
            cr.execute("""
                SELECT id, 
                       name,
                       supite_codigo_item,   
                       supite_preco                      
                FROM supervisor_cad_itens
                WHERE supite_codigo_item = '{codigo}'
                       """.format(codigo=codigo))
            dados = dictfetchall(cr)
            if not dados:
                cr.close()
                return json.dumps({'codigo': ITEM_NAO_CASTRADO,
                                   'mensagem': 'Item não cadatrado!',
                                   'retorno': []})

            cr.close()
            return json.dumps({'retorno': dados,
                               'codigo': SEM_ERRO,
                               'mensagem': 'ok'})
        except Exception as e:
            cr.close()
            return json.dumps({'codigo': ERRO_EXECUTAR_SQL,
                               'mensagem': 'Erro: %s' % e,
                               'retorno': []})

