# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
from datetime import datetime


# noinspection PyPep8Naming
class supervisor_cda_capa(osv.Model):
    """
    Tabela da capa da comanda
    Prefixo: supcda
    OBS: Para realizar alteracoes verificar o impacto em outros sistemas.
    """

    from funcoes import supcda_fields_function, supcda_get_data

    _name = 'supervisor.cda.capa'
    _rec_name = 'supcda_codigo_comanda'
    _gerar_logs_logs = 'N'
    _columns = {
        # ___________________________ One2Many _______________________________
        'supcda_comanda_item_ids': fields.one2many('supervisor.cda.corpo', 'supcdo_capa_id',
                                                   'Item da comanda', ondelete='cascade'),

        # ___________________________ Integer ________________________________
        'supcda_codigo_comanda': fields.integer('Codigo', select=1),
        'supcda_operador': fields.integer('Operador'),
        'supcda_loja': fields.integer('Loja'),
        'supcda_caixa': fields.integer('Caixa'),
        'supcda_nro_cupom': fields.integer('Cupom'),
        'supcda_restricao': fields.integer('Restricao', select=1),

        # ___________________________ Datetime _______________________________
        'supcda_data_hora': fields.datetime('Data/Hora'),
        'supcda_data_cupom': fields.datetime('Data/Cupom'),

        # ___________________________ Char ___________________________________
        'supcda_cliente': fields.char('Cliente', size=15),
        'supcda_nome_cliente': fields.char('Nome', size=100),

        # ___________________________ Float __________________________________
        'supcda_juros': fields.float('Juros', digits=(10, 2)),
        'supcda_descontos': fields.float('Descontos', digits=(10, 2)),
        'supcda_total_comanda': fields.float('Total', digits=(10, 2)),

        'supcda_comanda_status': fields.function(supcda_fields_function, method=True, type='char',
                                                 size=20, string='Situacao'),
        'supcda_data': fields.function(supcda_get_data, method=True, type='date', string='Data Comanda',
                                       store=True, multi='data'),
        'supcda_data_cupom_sem_hora': fields.function(supcda_get_data, method=True, type='date', string='Data Cupom',
                                       store=True, multi='data'),
        'supcda_dia': fields.function(supcda_get_data, method=True, type='char', size=20, string='Dia',
                                       store=True, multi='data'),
    }
    _order = 'supcda_data_hora desc'

    _defaults = {
        'supcda_data_hora': datetime.now(),
        'supcda_restricao': 0,
        'supcda_total_comanda': 0.0
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
