# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class supervisor_cda_corpo(osv.Model):
    """
    Tabela do corpo da comanda
    Prefixo: supcdo
    OBS: Para realizar alteracoes verificar o impacto em outros sistemas.
    """
    _name = 'supervisor.cda.corpo'
    _gerar_logs_logs = 'N'
    _columns = {
        'supcdo_capa_id': fields.many2one('supervisor.cda.capa', 'Capa'),
        'supcdo_sequencia_id': fields.integer('Sequencia', required=True),
        'supcdo_item': fields.char('Item', size=14),
        'supcdo_quantidade': fields.float('Quantidade', digits=(10, 2)),
        'supcdo_preco_total': fields.float('Total', digits=(10, 3)),
        'supcdo_venda_cancelamento': fields.char('Venda/Cancelamento', size=1),
        'supcdo_cod_vendedor': fields.integer('Vendedor item'),
        'supcdo_nome_vendedor': fields.char('Vendedor item', size=30),
    }

    _defaults = {
        'supcdo_venda_cancelamento': 'V'
    }

    _sql_constraints = [
        ('capa_sequencia_unique', 'unique(supcdo_capa_id, supcdo_sequencia_id)',
         'A sequencia deve ser unica para a capa!')
    ]
