# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
# o numero no nome serve para ordenar a consulta no frente
BOTOES = [('1', '1-Primeiro Esquerda'),
          ('2', '2-Primeiro Direita'),
          ('3', '3-Segundo Esquerda'),
          ('4', '4-Segundo Direita'),
          ('5', '5-Terceiro Esquerda'),
          ('6', '6-Terceiro Direita')]
# noinspection PyPep8Naming
class supervisor_cda_itens_favoritos(osv.Model):
    """
    Tabela de itens favorito para comanda
    Prefixo: supifa
    """

    _name = 'supervisor.cda.itens.favoritos'
    _gerar_logs_logs = 'N'
    _columns = {
        'supifa_item_id': fields.many2one('supervisor.cad.itens', 'Item', select=True),
        'supifa_cod_item': fields.char('Codigo Item', size=14),
        'supifa_botao': fields.selection(BOTOES, 'Botao', required=True),
        'supifa_botao_descricao': fields.char('Descricao no Botao',  size=26,required=True),
    }
    _sql_constraints = [
        ('item', 'unique (supifa_item_id)', 'Este item ja foi usado!'),
        ('botao', 'unique (supifa_botao)', 'Este botao ja foi usado!'),
    ]
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
