# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2015 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz:siginformatica.com.br>
                                -------

================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

import logging
from openerp.tools.translate import _


# _______________________ supervisor.cda.capa ________________________________
def supcda_fields_function(self, cr, uid, ids, name, arg, context=None):
    """
    Manipulacao de campos. Valores de campos pre-definidos.

    :param cr: {cursor} a linha atual do cursor do banco de dados,
    :param uid: {int} ID do usuario utilizado para a verificacao de perfil,
    :param ids: {list} lista dos IDs,
    :param name: {list} lista com o nome dos campos,
    :param arg: {dict} dicionario com os argumentos e valores,
    :param context: {dict} um dicionario padrao para valores contextuais,
    :return: {dict} valores ajustados dos campos.

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """

    _logger = logging.getLogger('supervisor.cda.capa')
    context = context and context.copy() or {}
    result = {}

    for brw_supervisor_cda_capa in self.browse(cr, uid, ids, context=context):
        try:
            if name == 'supcda_comanda_status':
                value = {
                    -1: _('Cancelada'), 0: _('Aberta'), 1: _('Aguardando emissao'),
                    2: _('Faturada'), 4: _('Anulada'), 5: _('Em faturamento')
                }.get(brw_supervisor_cda_capa.supcda_restricao) or ''
            else:
                value = None
        except Exception as e:
            _logger.error('Atributo %s: %s' % (name, e))
            value = None

        result[brw_supervisor_cda_capa.id] = value

    return result

def supcda_get_data(self, cr, uid, ids, name, arg, context=None):
    '''
    Grava apenas a data da comanda para consulta com data sem hora
    '''
    context = context and context.copy() or {}
    res = {}
    for brw_comanda in self.browse(cr, uid, ids, context=context):
        campos = {'supcda_data': brw_comanda.supcda_data_hora[:10],
                  'supcda_dia': brw_comanda.supcda_data_hora[8:10],
                  'supcda_data_cupom_sem_hora': False}
        if brw_comanda.supcda_data_cupom:
            campos['supcda_data_cupom_sem_hora'] = brw_comanda.supcda_data_cupom[:10]
        res[brw_comanda.id] = campos

    return res


# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4
