#!/usr/bin/python
# -*- encoding: utf-8 -*-
from sdk import SDK
from datetime import datetime, timedelta
from comandos import ComandaLiberarNegar, GetEvento


ip = "192.168.1.24"
porta = 3000
timeout = 1

print('iniciando')
ultimo_acesso = datetime.now()
iniciar = True
with SDK(ip, porta, timeout=timeout) as s:
    while True:
        if iniciar:
            s.set_horario(timestamp=datetime.now())
            iniciar = False
        comanda = GetEvento(s)
        if comanda.status != 0:
            # Ao passar de 1 minuto, ler o horário para manter a conexao
            if ultimo_acesso < (datetime.now() - timedelta(minutes=1)):
                s.get_horario()
                ultimo_acesso = datetime.now()
                print("Timeout c/get")
            else:
                print("Timeout s/get")
            continue
        ultimo_acesso = datetime.now()
        print(comanda.retorno)
        print(comanda.data)
        print(comanda.data_payload)
        if comanda.data_payload.get('status_pedido') != '0':
            print('====>', comanda.data_payload.get('status_pedido'))
            continue
        if comanda.comando != 'REON':
            continue
        if comanda.index:
            if (int(comanda.index) % 2) == 0:
                s.send_command(ComandaLiberarNegar(comanda.index, liberaNega='N', mensagens=('Comanda nao fechada', 'Procure o caixa!')))
            else:
                s.send_command(ComandaLiberarNegar(comanda.index, liberaNega='L', mensagens=('Obrigado,', 'Volte sempre!')))
        print('----------------------------------------')

s._socket.close()

