#!/usr/bin/python
# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from SigUtils.calcDigito import modulo10

class supervisor_cad_ficha(osv.Model):


    _inherit = 'supervisor.cad.ficha'

    def read_group(self, cr, uid, domain, fields, groupby, offset=0, limit=None, context=None,
                   orderby=False):
        res = super(supervisor_cad_ficha, self).read_group(cr, uid, domain, fields,
                                                           groupby, offset, limit, context, orderby)
        for i in res:
            if 'supfch_loja_count' in i:
                i['supfch_loja'] = 'Loja: %s' % i.get('supfch_loja')
            elif 'supfch_loja' in i:
                del i['supfch_loja']

            if 'supfch_caixa_count' in i:
                i['supfch_caixa'] = 'Caixa: %s' % i.get('supfch_caixa')
            elif 'supfch_caixa' in i:
                del i['supfch_caixa']

            if 'supfch_codigo_ficha' in i:
                del i['supfch_codigo_ficha']

            if 'supfch_caixa_faturado' in i:
                del i['supfch_caixa_faturado']

            if 'supfch_cupom_coo' in i:
                del i['supfch_cupom_coo']

        return res

    def get_cb_ficha(self, codigo, loja, caixa, context=None):
        context = context and context.copy() or {}
        if not codigo:
            return ''

        cb = '99%02d%02d%08d' % (loja, caixa, codigo)
        return '%s%s' % (cb, modulo10(cb))

    def button_reimprimir_ficha(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self.write(cr, uid, ids, {'supfch_cz_state_impressao': '2'})
        return True
