#!/usr/bin/python
# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class supervisor_cad_ficha(osv.Model):
    """
    Tabela de fichas
    Prefixo: supfch

    """
    def get_descricao(self, cr, uid, ids, name, arg, context=None):
        context = context and context.copy() or {}
        res = {}
        dados = self.read(cr, uid, ids, ['supfch_item'], context=context)
        cbs = map(lambda x: x.get('supfch_item'), dados)
        args = [('supite_codigo_item','in', cbs)]
        item_ids = self.pool.get('supervisor.cad.itens').search(cr, uid, args, context=context)
        dict_itens = {}
        map(lambda x: dict_itens.update({x.get('supite_codigo_item'):
                                             x.get('supite_descricao_completa') or ''}),
            self.pool.get('supervisor.cad.itens').read(cr, uid, item_ids,
                              ['supite_descricao_completa', 'supite_codigo_item'], context=context))

        for i in dados:
            res[i.get('id')] = dict_itens.get(i.get('supfch_item')) or ''

        return res

    _name = 'supervisor.cad.ficha'
    _gerar_logs_logs = 'N'
    _columns = {
        'supfch_codigo_ficha': fields.integer('Codigo', required=True, select=True),
        'state': fields.selection([('1', 'Emitida'), ('2', 'Trocada'), ('3', 'Faturada')],
                                  'Estado', required=True, readonly=True),
        'create_date': fields.datetime('Data Emissao', required=True, readonly=True, select=True),

        'supfch_valor': fields.float('Valor', required=True,  digits=(10, 2)),
        'supfch_desconto': fields.float('Desconto', required=True,  digits=(10, 2)),
        'supfch_loja': fields.integer('Loja', required=True, select=True),
        'supfch_caixa': fields.integer('Caixa', required=True, select=True),
        'supfch_item': fields.char('Item', required=True, select=True), # Codigo de barras
        'supfch_descricao': fields.function(get_descricao, type='char', size=60, string="Descricao",
                                           store=False),
        'supfch_exportado': fields.boolean('Exportado'),
        'supfch_caixa_faturado': fields.integer('Caixa Faturado'),
        'supfch_cupom_coo': fields.integer('Cupom'),
        'supfch_cupom_data': fields.date('Data Cupom'),
        'supfch_cz_nome_cliente': fields.char('Nome cliente', size=40),
        'supfch_cz_data_hora_entrega': fields.datetime('Horario entrega:'),
        'supfch_cz_observacoes': fields.text('Observacoes'),
        'supfch_cz_state_impressao': fields.selection([('1', 'Nao imprimir'),
                                                       ('2', 'A imprimir'),
                                                       ('3' , 'Impresso')], 'Estado da impressao',
                                                      select=True),
        'supfch_cz_data_hora_impressao': fields.datetime('Data e hora da impressao'),
        'supfch_cz_sequencia_de_impressao': fields.integer('Sequencia de impressao'),
    }

    _defaults = {
        'supfch_exportado': False,
        'supfch_cz_sequencia_de_impressao': 0
    }

    _order = 'create_date desc, supfch_codigo_ficha desc'