# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
from datetime import datetime
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.informaNome(pdf_string, _('Acompanhamento de Fichas(cupom de recebimento)'))
        listagem.informaTamLinha(67)
        listagem.defineFormato(orientacao='0')
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)
        listagem.defineFonte(tam=8.4)
        data_ini = datas.get('data_ini')
        data_fim = datas.get('data_fim')
        loja = datas.get('loja')
        caixa = datas.get('caixa')
        totalizador = datas.get('totalizador')
        tot_devolucao = datas.get('tot_devolucao')
        dados = datas.get('dados')
        obj_supervisor_cfg_configuracao = pooler.get_pool(cr.dbname).get(
            'supervisor.cfg.configuracao')
        configuracao_ids = obj_supervisor_cfg_configuracao.search(cr, uid, [], context=context)
        nome_empresa = ''
        if configuracao_ids:
            nome_empresa = obj_supervisor_cfg_configuracao.browse(
                cr, uid, configuracao_ids[0], context=context).supcfc_cliente or ''
        data_hoje = time.strftime("%d/%m/%Y")
        title = center_title(_('Sistema de PDVs'), '', '', 67)
        title1 = center_title('%s', '', '', 67) % nome_empresa
        docs = center_title('', _('Acompanhamento de Fichas(cupom de recebimento)'), '', 67)
        docs2 = center_title(_('Data: %s') % data_hoje, '', _('Pagina: {{ Page }} '), 75)
        data_ini = time.strftime('%d/%m/%Y', time.strptime(data_ini, '%Y-%m-%d'))
        data_fim = time.strftime('%d/%m/%Y', time.strptime(data_fim, '%Y-%m-%d'))
        docs3 = center_title(_('Data Movimento: %s a %s') % (data_ini, data_fim), '', '', 67)
        docs4 = center_title(_('Loja: %s    Caixa: %s     Totalizador: %s') %
                             (loja or 'Todas', caixa or 'Todos', {'1': _('Ficha/Devolucao'),
                                                                  '2': _('Ficha'),
                                                                  '3': _('Devolucao')}.get(totalizador)), '',
                             '', 67)
        listagem.informaCab('' + title)
        listagem.informaCab('' + title1)
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab('' + docs2)
        listagem.informaCab('  ')
        listagem.informaCab('' + docs3)
        listagem.informaCab('' + docs4)
        listagem.informaCab('  ')
        linha_divisoria = '*%s*' % ''.ljust(67, '-')
        listagem.informaCab(linha_divisoria)
        listagem.informaCab(_('|   DATA   | LOJA | CAIXA |    COO    | FINALIZADORA |    VALOR     |'))
        listagem.informaCab(linha_divisoria)
        listagem.rodapePadrao()
        valor_total = 0
        coos = []
        totais = {}
        totais_geral = {}.fromkeys(['D','H','C','T','O','DV','TG', 'STG'], 0)
        for i in dados:
            data = datetime.strptime(i.get('data'), '%Y-%m-%d').strftime('%d/%m/%Y')
            coo = i.get('coo')
            loja = '%02d' % int(i.get('loja') or 0)
            caixa = '%02d' % int(i.get('caixa') or 0)
            valor = i.get('fin_valor') - i.get('fin_troco')
            fin_ecf = i.get('finalizadora')
            if not fin_ecf and i.get('tot') != tot_devolucao:
                continue

            finalizadora = ({'D': _('Dinheiro'),
                             'H': _('Cheque'),
                             'C': _('Cartao'),
                             'T': _('Ticket'),
                             'O': _('Outros'),
                             None: ''}.get(fin_ecf)).ljust(13)
            chave = '%s-%s' % (loja, caixa)
            if not totais.get(chave):
                totais[chave] = {}.fromkeys(['D', 'H', 'C', 'T', 'O', 'DV'], 0)

            if i.get('tot') == tot_devolucao:
                if not valor:
                    valor = i.get('valor')

                finalizadora = _("Devolucao")
                valor *= -1
                totais[chave]['DV'] += valor
                totais_geral['DV'] += valor
            else:
                totais[chave][i.get('finalizadora')] += valor
                totais_geral[i.get('finalizadora')] += valor

            totais_geral['TG'] += valor # total getal
            if valor > 0:
                totais_geral['STG'] += valor # Subtotal getal

            if coo not in coos:
                coos.append(coo)
                linha = [formataString(data or '', 10, ' ', 'E', 'N', 'S'),
                         formataString('%s ' % loja, 6, ' ', 'E', 'N', 'S'),
                         formataString('%s ' % caixa, 7, ' ', 'E', 'N', 'S'),
                         formataString('%s ' % coo, 11, ' ', 'E', 'N', 'S')]
            else:
                linha = [''.ljust(37)]

            linha.extend([formataString(' %s' % finalizadora, 14, ' ', 'D', 'N', 'S'),
                          formataString(getNumeroEditado(valor, 2), 13, ' ', 'E', 'N', 'S')])
            listagem.imprimeLinha('|%s |' % '|'.join(linha))
            valor_total += valor

        listagem.imprimeLinha(linha_divisoria)
        linha = [formataString(_('TOTAL'), 52, ' ', 'D', 'N', 'S'),
                 formataString(getNumeroEditado(valor_total, 2), 13, ' ', 'E', 'N', 'S')]
        listagem.imprimeLinha('|%s |' % '|'.join(linha))
        listagem.imprimeLinha(linha_divisoria)


        linha_divisoria = '*%s*' % ''.ljust(111, '-')
        listagem.cabecalhos = listagem.cabecalhos[:-3]
        listagem.informaCab(linha_divisoria)
        listagem.informaCab(_('|                                       TOTAIS POR FINALIZADORA                                                 |'))
        listagem.informaCab(_('|LOJA/CAIXA| DINHEIRO | DEVOLUCAO | DINHEIRO |  CARTAO  |  OUTROS  |  TICKET  |  CHEQUE  |  SUBTOTAL  |  TOTAL  |'))
        listagem.informaCab(linha_divisoria)
        listagem.rodapePadrao()
        listagem.imprimeLinha('{{ Page }}')
        for i, j in totais.items():
            loja, caixa = i.split('-')
            loja_caixa = '%s/%s' % (loja, caixa)
            total = sum(j.values())
            subtotal = total - j.get('DV')
            dinheiro_liq = j.get('D') + j.get('DV')
            linha = [formataString(getNumeroEditado(loja_caixa, 2), 10, ' ', 'E', 'N', 'S'),
                     formataString(getNumeroEditado(j.get('D'), 2), 10, ' ', 'E', 'N', 'S'),
                     formataString(getNumeroEditado(j.get('DV'), 2), 11, ' ', 'E', 'N', 'S'),
                     formataString(getNumeroEditado(dinheiro_liq, 2), 10, ' ', 'E', 'N', 'S'),
                     formataString(getNumeroEditado(j.get('C'), 2), 10, ' ', 'E', 'N', 'S'),
                     formataString(getNumeroEditado(j.get('O'), 2), 10, ' ', 'E', 'N', 'S'),
                     formataString(getNumeroEditado(j.get('T'), 2), 10, ' ', 'E', 'N', 'S'),
                     formataString(getNumeroEditado(j.get('H'), 2), 10, ' ', 'E', 'N', 'S'),
                     formataString(getNumeroEditado(subtotal, 2), 12, ' ', 'E', 'N', 'S'),
                     formataString(getNumeroEditado(total, 2), 9, ' ', 'E', 'N', 'S')]
            listagem.imprimeLinha('|%s|' % '|'.join(linha))
            listagem.imprimeLinha(linha_divisoria)


        tot_din_liq = totais_geral.get('D') + totais_geral.get('DV')
        linha_totais =[formataString('TOTAIS', 10, ' ', 'E', 'N', 'S'),
                       formataString(getNumeroEditado(totais_geral.get('D'), 2), 10, ' ', 'E', 'N', 'S'),
                       formataString(getNumeroEditado(totais_geral.get('DV'), 2), 11, ' ', 'E', 'N', 'S'),
                       formataString(getNumeroEditado(tot_din_liq, 2), 10, ' ', 'E', 'N', 'S'),
                       formataString(getNumeroEditado(totais_geral.get('C'), 2), 10, ' ', 'E', 'N', 'S'),
                       formataString(getNumeroEditado(totais_geral.get('O'), 2), 10, ' ', 'E', 'N', 'S'),
                       formataString(getNumeroEditado(totais_geral.get('T'), 2), 10, ' ', 'E', 'N', 'S'),
                       formataString(getNumeroEditado(totais_geral.get('H'), 2), 10, ' ', 'E', 'N', 'S'),
                       formataString(getNumeroEditado(totais_geral.get('STG'), 2), 12, ' ', 'E', 'N', 'S'),
                       formataString(getNumeroEditado(totais_geral.get('TG'), 2), 9, ' ', 'E', 'N', 'S')]
        listagem.imprimeLinha('|%s|' % '|'.join(linha_totais))
        listagem.imprimeLinha(linha_divisoria)

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.listagem_acompanhamento_ficha')