#!/usr/bin/python
#  -*- coding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _


class supervisor_cad_funcionarios(osv.Model):

    _inherit = 'supervisor.cad.funcionarios'

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        res = []
        obj_cad_clientes = self.pool.get('supervisor.cad.clientes')
        dados = self.read(cr, uid, ids, ['supfun_codigo','supfun_codigo_cliente'], context)
        codigos = map(lambda x: x.get('supfun_codigo_cliente'), dados)
        cliente_ids = obj_cad_clientes.search(cr, uid, [('supcli_codigo_interno', 'in', codigos)],
                                              context=context)
        dados_clientes = obj_cad_clientes.read(cr, uid, cliente_ids, ['name',
                                               'supcli_codigo_interno'], context=context)
        codigo_nome = {}
        map(lambda x: codigo_nome.update({x.get('supcli_codigo_interno'): x.get('name')}),
            dados_clientes)
        for funcionario in dados:
            codigo_cliente = funcionario.get('supfun_codigo_cliente')
            name = '%s-%s' % (int(funcionario.get('supfun_codigo')),
                                codigo_nome.get(codigo_cliente))
            res.append((funcionario.get('id'), name))

        return res

    def name_search(self, cr, user, name='', args=None, operator='ilike', context=None, limit=100):
        res = super(supervisor_cad_funcionarios, self).name_search(cr, user, name, args, operator,
                                                             context, limit)
        # se nao encontrar pelo codigo tenta encontrar pelo cpf
        if not res and name.isdigit():
            args_fun = [('supfun_cpf', 'ilike', name )]
            res = self.search(cr, user, args_fun, context=context, limit=limit)
            if res:
                res = self.name_get(cr, user, res, context=context)

        # se nao encontrar pelo codigo tenta encontrar pelo nome
        if not res and not name.isdigit():
            obj_cliente = self.pool.get('supervisor.cad.clientes')
            args_cli = [('name', 'ilike', name + '%')]
            res = obj_cliente.search(cr, user, args_cli, context=context)
            dados_clientes = obj_cliente.read(cr, user, res, ['supcli_codigo_interno'],
                                              context=context)
            codigo_clientes = map(lambda x: x.get('supcli_codigo_interno'), dados_clientes)
            if codigo_clientes:
                args.append(('supfun_codigo_cliente', 'in', codigo_clientes))
                res = self.search(cr, user, args, context=context, limit=limit)
                if res:
                    res = self.name_get(cr, user, res, context=context)

        return res

    def supfun_onchange_cod_cliente(self, cr, uid, ids, codigo_cliente, context=None):
        context = context and context.copy() or {}
        if not int(codigo_cliente):
            return {}

        cliente_ids = self.pool.get('supervisor.cad.clientes').search(cr, uid,
                                  [('supcli_codigo_interno', '=', codigo_cliente)], context=context)
        if cliente_ids:
            cpf = self.pool.get('supervisor.cad.clientes').read(cr, uid, cliente_ids[0],
                                  ['supcli_cnpj_cpf'], context=context).get('supcli_cnpj_cpf') or ''
            return {'value': {'supfun_cpf': cpf}}

        return {'value': {'supfun_codigo_cliente': False},
                'warning': {'title': _('Atencao!'),
                            'message': _('Nao existe cliente cadastrado com este codigo!')}}

    def supfun_onchange_cpf(self, cr, uid, ids, cpf, codigo_cliente, context=None):
        context = context and context.copy() or {}
        if not cpf:
            return {}

        cliente_ids = self.pool.get('supervisor.cad.clientes').search(cr, uid,
                                  [('supcli_cnpj_cpf', '=', cpf.zfill(15))], context=context)
        if not cliente_ids:
            return {'value': {'supfun_cpf': ''},
                    'warning': {'title': _('Atencao!'),
                                'message': _('Nao existe cliente cadastrado com este CPF!')}}

        codigo_interno = self.pool.get('supervisor.cad.clientes').read(cr, uid, cliente_ids[0],
                            ['supcli_codigo_interno'], context=context).get('supcli_codigo_interno')
        if int(codigo_interno) != int(codigo_cliente):
            return {'value': {'supfun_cpf': ''},
                    'warning': {'title': _('Atencao!'),
                                'message': _('Este CPF pertence a outro cliente')}}

        return {}