# -*- coding: utf-8 -*-

from openerp.osv import osv, fields


class supervisor_cad_funcionarios(osv.Model):
    # prefixo: supfun

    _name = 'supervisor.cad.funcionarios'
    _rec_name = 'supfun_codigo'
    _gerar_logs_logs = 'N'
    _columns = {
        'supfun_codigo': fields.float('Codigo do funcionario', digits=(14, 0), required=True,
                                      select=True),
        'supfun_codigo_cliente': fields.float('Codigo no cadastro de clientes', digits=(14, 0),
                                              required=True, select=True),
        'supfun_cpf': fields.char('CPF', size=15, select=True),
        'supfun_salario': fields.float('Salario', required=True),
        'supfun_percentual_limite_desconto': fields.float('Limite de desconto (percentual)',
                                                          help='Percentual que identifica o limite '
                                                               'de compras com relacao ao salario'),
        'supfun_percentual_desconto': fields.float('Percentual de desconto',
                                                   help='Percentual de desconto a ser aplicado '
                                                        'sobre as compras do funcionario'),
    }

    _sql_constraints = [
        ('codigo_func_uniq', 'unique(supfun_codigo)',
         'O codigo do funcionario ja esta registrado para outro funcionario'),
        ('codigo_cli_uniq', 'unique(supfun_codigo_cliente)',
         'O codigo de cliente ja esta registrado para outro funcionario'),
    ]