#!/usr/bin/python
# -*- coding: utf-8 -*-

from openerp.tests.common import TransactionCase
from sigaddons.config_teste import set_config
import os
import importlib
from SigUtils.registro import Registro

__author__ = 'tiago.santos'


class TestWizardSupervisorImportaArquivo(TransactionCase):
    """
    Classe responsavel por testes unitarios nos metodos da classe wizard_supervisor_importa_arquivo
    """

    @classmethod
    def setUpClass(cls):
        set_config()

    def setUp(self):
        super(TestWizardSupervisorImportaArquivo, self).setUp()
        self.obj_wizard_supervisor_importa_arquivo = self.registry(
            'wizard.supervisor.importa.arquivo')
        cwd = '/data/workspace/tiago.santos/trunk/sigaddons/supervisor/wizard/importacao'
        nome_arquivos = (fname for fname in os.listdir(cwd) if
                         os.path.isdir(os.path.join(cwd, fname)))

        self.registros = None
        for nome_arquivo in nome_arquivos:
            module_importacao_path = os.path.join(cwd, '%s/arquivos' % nome_arquivo)
            self.registros = Registro(module_importacao_path)

        self.lines = ['000000000000111000000000000123000000098085020001500',
                      '000000000000222000000000000124000000096055020001500',
                      '000000000000333000000000000125000000190085030001800',
                      '000000000000444000000000000126000000125033030001000']

    def test_importa_arquivo_funcionario(self):
        res = self.obj_wizard_supervisor_importa_arquivo._importa_arquivo_funcionario(
            self.cr, self.uid, None, self.registros, self.lines, {})
        self.assertTrue(res)
