# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.addons.supervisor import print_log
from datetime import datetime
import subprocess
import os
import time


class supervisor_cad_itens(osv.Model):

    _name = 'supervisor.producao.utils'

    def _get_realacao_locais(self, cr, uid, context=None):
        context = context and context.copy() or {}
        obj_sup_local = self.pool.get('supervisor.producao.local')
        local_ids = obj_sup_local.search(cr, uid, [('sucloc_impressora','!=', False)],
                                         context=context)
        locais = {}
        if local_ids:
            map(lambda x: locais.update({x.get('sucloc_codigo'): x.get('sucloc_impressora')}),
                obj_sup_local.read(cr, uid, local_ids, ['sucloc_impressora', 'sucloc_codigo'],
                                   context=context))
        return locais

    def imprimir_pedidos(self, cr, uid, impressoras, context=None):
        context = context and context.copy() or {}
        path = '/tmp/pedido_cozinha-%s.txt' % datetime.now()
        obj_cmd = self.pool.get('supervisor.cad.comandos.impressoras')
        imp_ids = obj_cmd.search(cr, uid, [('state', '=', '2')], context=context)
        if not imp_ids:
            raise osv.except_osv(('Atencao!'), ('Sem impressora ativa no cadastro de impresoras!'))

        parametros = self.pool.get('ir.config_parameter').get_param(cr, uid, 'local.server.sig')
        if not parametros:
            self.pool.get('ir.config_parameter').set_param(cr, uid, 'supervisor.impressora.cozinha',
                                                           'USUARIO_UBUNTU;PORTA_DA_IMPRESSORA')
            raise osv.except_osv(('Atencao!'), ('Parametros de sistema da impressora nao configurados!'))
        try:
            parametros = parametros.split(';')
        except:
            raise osv.except_osv(('Atencao!'), ('Parametros de sistema da impressora estao incorretos!'))

        nome = obj_cmd.read(cr, uid, imp_ids[0], ['supcci_marca'], context).get('supcci_marca') or ''

        for impressora, impressoes in impressoras.items():
            file = open(path, 'w')
            file.write('\n'.join(impressoes))
            file.close()
            try:
                if nome.upper() in ('ELGIN', 'EPSON'):
                    os.system("echo %s | sudo -S chmod 776 %s; cat %s > %s" %
                              (parametros[0] or 'sig',
                               parametros[1],
                               path,
                               parametros[1]))
                else:
                    subprocess.call(["lp", "-o raw", "-n1", '-d%s' % impressora, path])

                subprocess.call(["lp", "-n1", '-d%s' % impressora, path])
            except Exception as e:
                print_log('Erro ao imprimir pedido de cozinha %s' % e, tipo='E')

            time.sleep(1)

    def cron_supervisor_producao_imprimir_pedidos_cozinha(self, cr, uid, context=None):
        'Implementado por heranca no cupervisor_producao_ comanda e ficha'
        context = context and context.copy() or {}
        return True