# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class supervisor_cfg_parametros(osv.Model):
    """
    Tabela de parametros do supervisor
    Prefixo: supcfp
    """
    _inherit = 'supervisor.cfg.parametros'
    _columns = {
        'supcfp_comissao': fields.float('Percentual de comissao', digits=(2,2),
                                        help="Percentual de comissao dos funcionarios(10%)"),

        'supcfp_produtos_app': fields.boolean('Apenas Produtos App', digits=(2, 2),
                                        help="Quando marcado, apenas os produtos que tem marcado"
                                             " 'App Comanda' irao aparecer no aplicativo da comanda"),

        'supcfp_itens_operador': fields.boolean('Apenas itens do operador', digits=(2, 2),
                                              help="Quando marcado, apenas itens que o operador "
                                                   "vendeu na comanda irao aparecer no APP ao "
                                                   "clicar em 'Entregar Itens', se desmarcado, "
                                                   "o operador pode entregar itens de outro "
                                                   "operador"),
    }
    _defaults = {
        'supcfp_itens_operador': True,
    }
