# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
from datetime import datetime
from openerp.addons.supervisor import print_log
import subprocess
import time


class supervisor_cad_itens(osv.Model):

    _inherit = 'supervisor.producao.utils'

    def _get_impressora_impressao(self, cr, uid, dados_corpo, dict_itens, dict_capa, context=None):
        """Retorna um  dict com a chave sendo a impressora e o valor as impressoes"""
        context = context and context.copy() or {}
        remove_acentuacao = self.pool.get('supervisor.util').suputi_remover_acentuacao
        dict_locais = self._get_realacao_locais(cr, uid, context)
        impressoras = {}
        if not dict_locais:
            return impressoras

        obj_sup_util = self.pool.get('supervisor.util')
        obj_configuracao = self.pool.get('supervisor.cfg.configuracao')
        obj_cmd = self.pool.get('supervisor.cad.comandos.impressoras')
        imp_ids = obj_cmd.search(cr, uid, [('state', '=', '2')], context=context)
        if not imp_ids:
            raise osv.except_osv(_('Atencao!'), _('Sem impressora ativa no cadastro de impresoras!'))

        cmd = obj_cmd.read(cr, uid, imp_ids[0], [], context) or ''
        ini_negrito = '%s' % cmd.supcci_negrito_liga
        fim_negrito = '%s' % cmd.supcci_negrito_desliga
        fonte_i = cmd.supcci_fonte_liga
        fonte_f = cmd.supcci_fonte_desliga
        cfg_ids = obj_configuracao.search(cr, uid, [], context=context)
        nome_empresa = remove_acentuacao(obj_configuracao.read(cr, uid, cfg_ids[0], ['supcfc_cliente'],
                                             context=context).get('supcfc_cliente') or '')
        data_sem_fuso = datetime.now()
        data = self.pool.get('supervisor.util').suputi_converte_tz(cr, uid, data_sem_fuso,
                                                    tz_origem='UTC', tz_destino='America/Sao_Paulo')
        data = datetime.strftime(data, '%d/%m/%Y %H:%M:%S')[:19]
        ultima_capa_id = False
        cabecalho = ['%s%s%s' % (ini_negrito, (nome_empresa).center(48), fim_negrito),
                     ('DATA IMPRESSAO: %s' % data).rjust(48),
                     '',
                     '%s--------------* PEDIDO DE COZINHA *-------------%s' % (ini_negrito,
                                                                               fim_negrito),
                     '']
        rodape = ['DESENVOLVIDO POR:',
                  '%sSig Solucoes em Informatica Ltda. (31)2106-1700%s' % (ini_negrito,
                                                                           fim_negrito),
                  '%s' % (cmd.supcci_corta_papel),  # corta papel
        ]
        impressao_comanda = []
        ultima_printer = False
        for corpo in dados_corpo:
            # itens cancelados nao imprime
            if corpo.get('supcdo_venda_cancelamento') == 'C':
                vals = {'supcdo_imprimir': '1'}
                self.pool.get('supervisor.cda.corpo').write(cr, uid, corpo.get('id'), vals,
                                                            context=context)
                continue

            create_date = obj_sup_util.suputi_converte_tz(cr, uid, datetime.strptime(
                           corpo.get('create_date') or ('%s' % data_sem_fuso)[:19], '%Y-%m-%d %H:%M:%S'),
                                                          tz_origem='UTC',
                                                     context=context).strftime( '%d/%m/%Y %H:%M:%S')
            item = dict_itens.get(corpo.get('supcdo_item'))
            printer = False
            if item.get('supite_codigo_local') and dict_locais.get(item.get('supite_codigo_local')):
                printer = dict_locais.get(item.get('supite_codigo_local'))

            nome_cliente = remove_acentuacao(dict_capa.get(corpo.get('supcdo_capa_id'))[1] or '')
            comanda = dict_capa.get(corpo.get('supcdo_capa_id'))[2]
            mesa = dict_capa.get(corpo.get('supcdo_capa_id'))[3]
            seq_item = corpo.get('supcdo_sequencia_id')
            descricao = remove_acentuacao(item.get('supite_descricao_completa'))
            qtd = corpo.get('supcdo_quantidade')
            if len(descricao) > 42:
                descricao = '\n      '.join([descricao[:42], descricao[42:]])

            obs = remove_acentuacao(corpo.get('supcdo_observacao') or '')
            if len(obs) > 48:
                obs = '\n'.join([obs[:48], obs[48:]])

            seq_impressao = (corpo.get('supcdo_seq_impressao') or 0) + 1
            if ultima_capa_id != corpo.get('supcdo_capa_id'):
                if impressao_comanda:
                    impressao_comanda.extend(rodape)
                    if ultima_printer:
                        if not impressoras.get(ultima_printer):
                            impressoras[ultima_printer] = ['\n'.join(impressao_comanda)]
                        else:
                            impressoras[ultima_printer].append('\n'.join(impressao_comanda))
                    else:
                        print_log(_('Impressora nao cadastrada no local do item: %s') %
                                  item.get('supite_codigo_item'), tipo='W')


                ultima_capa_id = corpo.get('supcdo_capa_id')
                impressao_comanda = []
                impressao_comanda.extend(cabecalho)
                if seq_impressao > 1:
                    impressao_comanda.append('%s Reimpressao de pedido%s' % (fonte_i, fonte_f))

                if nome_cliente:
                    impressao_comanda.append('CLIENTE: %s' % nome_cliente)

                impressao_comanda.extend([
                             'COMANDA: %s%06d%s' % (ini_negrito, comanda, fim_negrito),
                             'MESA: %s%03d%s' % (ini_negrito,mesa, fim_negrito),
                             'DATA: %s' % create_date,
                             '',
                             '%s------------------------------------------------%s' % (ini_negrito,
                                                                                       fim_negrito),
                             ])

            impressao_comanda.extend([
                             'Seq.Item: %s%03d%s' % (ini_negrito, seq_item, fim_negrito),
                             'SEQ.IMPRESSAO: %s' % seq_impressao,
                             'ITEM: %s%s%s' % (fonte_i, descricao, fonte_f),
                             'QTD: %s%s%s%s%s' % (fonte_i, ini_negrito, qtd, fim_negrito, fonte_f),
                             '',
                             'OBS:\n%s*%s\%s' % (fonte_i, obs, fonte_f),
                             '',])
            ultima_printer = printer
            if not printer:
                continue

            vals = {'supcdo_seq_impressao': seq_impressao,
                    'supcdo_data_hora_impressao': data_sem_fuso,
                    'supcdo_imprimir': '4'}
            self.pool.get('supervisor.cda.corpo').write(cr, uid, corpo.get('id'), vals,
                                                        context=context)

        if impressao_comanda:
            impressao_comanda.extend(rodape)
            if ultima_printer:
                if not impressoras.get(ultima_printer):
                    impressoras[ultima_printer] = ['\n'.join(impressao_comanda)]
                else:
                    impressoras[ultima_printer].append('\n'.join(impressao_comanda))
            else:
                print_log(_('Impressora nao cadastrada no local do item: %s') %
                          item.get('supite_codigo_item'), tipo='W')

        return impressoras

    def cron_supervisor_producao_imprimir_pedidos_cozinha(self, cr, uid, context=None):
        context = context and context.copy() or {}
        super(supervisor_cad_itens, self).cron_supervisor_producao_imprimir_pedidos_cozinha(cr, uid,
                                                                                            context)
        return True

        # Foi retirada a impressao de pedido de cozinha da comanda via Supervisor. A impressao
        # Agora está sendo feita pelo Comanda e pelo App da Comanda. OBs o codigo ficou para caso
        # precise voltar a impressao para o supervisor.
        obj_capa = self.pool.get('supervisor.cda.capa')
        obj_corpo = self.pool.get('supervisor.cda.corpo')
        obj_item = self.pool.get('supervisor.cad.itens')
        corpo_ids = obj_corpo.search(cr, uid, [('supcdo_imprimir','=','3')], context=context,
                                     order='id')
        if not corpo_ids:
            return True

        campos = ['supcdo_seq_impressao', 'supcdo_observacao', 'supcdo_item', 'supcdo_quantidade',
                  'supcdo_nome_vendedor', 'supcdo_capa_id', 'supcdo_sequencia_id', 'create_date',
                  'supcdo_capa_id']
        dados_corpo = obj_corpo.read(cr, uid, corpo_ids, campos, context=context,
                                     load='_classic_write')
        codigos = []
        capa_ids = []
        for i in dados_corpo:
            codigos.append(i.get('supcdo_item'))
            capa_ids.append(i.get('supcdo_capa_id'))

        # ------------ pega a relacao dos itens ---------------
        item_ids = obj_item.search(cr, uid, [('supite_codigo_item', 'in', codigos)])
        campos = ['supite_codigo_item', 'supite_descricao_completa', 'supite_codigo_local']
        dados_item = obj_item.read(cr, uid, item_ids, campos, context=context)
        dict_itens = {}
        map(lambda x: dict_itens.update( {x.get('supite_codigo_item'): x}), dados_item)

        # ------------ pega a relacao das capas ---------------
        dict_capa = {}
        for i in obj_capa.read(cr, uid, capa_ids, [], context=context):
            cliente = i.get('supcda_nome_cliente') or ''
            comanda = i.get('supcda_codigo_comanda')
            mesa = i.get('supcda_mesa') or 0
            chave = '%s-%s' % (i.get('supcda_loja'), i.get('supcda_caixa'))
            dict_capa.update({i.get('id'): (chave, cliente, comanda, mesa)})

        impressoras = self._get_impressora_impressao(cr, uid, dados_corpo, dict_itens, dict_capa,
                                                     context=context)
        if not impressoras:
            print_log('Nenuma impressora cadastrada nos locais', tipo='W')
            return True

        self.imprimir_pedidos(cr, uid, impressoras, context=context)
        return True