#!/usr/bin/python
# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.addons.supervisor import print_log
from openerp.tools.translate import _
from datetime import datetime


class supervisor_cad_ficha(osv.Model):

    _inherit = 'supervisor.cad.ficha'

    def imprimir_pedidos_ficha_cozinha(self, cr, uid, context=None):
        context = context and context.copy() or {}
        ficha_ids = self.search(cr, uid, [('supfch_cz_state_impressao', '=', '2')], context=context)
        if not ficha_ids:
            return True

        obj_sup_util = self.pool.get('supervisor.util')
        obj_item = self.pool.get('supervisor.cad.itens')
        obj_configuracao = self.pool.get('supervisor.cfg.configuracao')
        obj_producao_utils = self.pool.get('supervisor.producao.utils')
        cfg_ids = obj_configuracao.search(cr, uid, [], context=context)
        nome_empresa = obj_sup_util.suputi_remover_acentuacao(obj_configuracao.read(cr, uid,
                       cfg_ids[0], ['supcfc_cliente'], context=context).get('supcfc_cliente') or '')
        ini_negrito = '%s%s' % (chr(27), chr(69))
        fim_negrito = '%s%s' % (chr(27), chr(70))
        dict_locais = obj_producao_utils._get_realacao_locais(cr, uid, context)
        if not dict_locais:
            print_log(_('Nenhum impressora encontrada no cadstro de locais do Supervisor'),
                      tipo='W')

        campos = ['supfch_descricao', 'supfch_cz_nome_cliente', 'supfch_cz_observacoes',
                  'supfch_cz_data_hora_entrega', 'supfch_item', 'supfch_cz_sequencia_de_impressao',
                  'supfch_codigo_ficha', 'supfch_loja', 'supfch_caixa', 'create_date']
        dados_ficha = self.read(cr, uid, ficha_ids, campos, context=context)
        cbs = list(set(map(lambda x: x.get('supfch_item'), dados_ficha)))
        item_ids = obj_item.search(cr, uid, [('supite_codigo_item', 'in', cbs)], context=context)
        dict_itens = {}
        map(lambda x: dict_itens.update(
                                       {x.get('supite_codigo_item'): x.get('supite_codigo_local')}),
            obj_item.read(cr, uid, item_ids, ['supite_codigo_item','supite_codigo_local'],
                          context=context))
        data = datetime.now()
        str_data = obj_sup_util.suputi_converte_tz(cr, uid, data, tz_origem='UTC',
                                               context=context).strftime('%d/%m/%Y %H:%M:%S')
        impressoras = {}
        for ficha in dados_ficha:
            cliente = obj_sup_util.suputi_remover_acentuacao(ficha.get('supfch_cz_nome_cliente') or
                                                             '')
            cod_ficha = ficha.get('supfch_codigo_ficha')
            loja = ficha.get('supfch_loja')
            caixa = ficha.get('supfch_caixa')
            data_entrega = ''
            data_emissao = obj_sup_util.suputi_converte_tz(cr, uid, datetime.strptime(
                                                    ficha.get('create_date'), '%Y-%m-%d %H:%M:%S'),
                                   tz_origem='UTC', context=context).strftime('%d/%m/%Y %H:%M:%S')
            if ficha.get('supfch_cz_data_hora_entrega'):
                data_entrega = obj_sup_util.suputi_converte_tz(cr, uid,
                                         datetime.strptime(ficha.get('supfch_cz_data_hora_entrega'),
                                         '%Y-%m-%d %H:%M:%S'),
                                    tz_origem='UTC', context=context).strftime('%d/%m/%Y %H:%M:%S')


            seq_impressao = ficha.get('supfch_cz_sequencia_de_impressao') + 1
            descricao = obj_sup_util.suputi_remover_acentuacao(ficha.get('supfch_descricao'))
            obs = obj_sup_util.suputi_remover_acentuacao(ficha.get('supfch_cz_observacoes') or '')
            impressao = ['%s%s%s' % (ini_negrito, (nome_empresa).center(48), fim_negrito),
                         ('DATA IMPRESSAO: %s' % str_data
                          ).rjust(48),
                         '',
                         '%s--------------* PEDIDO DE COZINHA *-------------%s' % (ini_negrito,
                                                                                   fim_negrito),
                         '']
            if seq_impressao > 1:
                impressao.append('\x1B\x57\x01 Reimpressao de pedido\x1B\x57\x00')

            if cliente:
                impressao.append('CLIENTE: %s%s%s' % (ini_negrito, cliente, fim_negrito))

            impressao.extend([
                          'FICHA: %s' % self.get_cb_ficha(cod_ficha, loja, caixa,
                                                          context=context),
                          '%sLOJA: %02d CAIXA: %02d%s' % (ini_negrito, loja, caixa, fim_negrito),
                          'SEQ.IMPRESSAO: %s' % seq_impressao,
                          'DATA EMISSAO: %s' % data_emissao,
                          'DATA DE ENTREGA: %s%s%s' % (ini_negrito, data_entrega, fim_negrito),
                          '',
                          '%s------------------------------------------------%s' % (ini_negrito,
                                                                                    fim_negrito),
                          'ITEM: \x1B\x57\x01%s\x1B\x57\x00' % descricao,
                          '',
                          'OBS:\n \x1B\x57\x01*%s\x1B\x57\x00' % obs,
                          '',
                          'DESENVOLVIDO POR:',
                          '%sSig Solucoes em Informatica Ltda. (31)2106-1700%s' % (ini_negrito,
                                                                                   fim_negrito),
                          '%s%s' % (chr(27), chr(109)),  # corta papel
                        ])
            cod_local = dict_itens.get(ficha.get('supfch_item'))
            if not cod_local:
                print_log(_('Item %s sem local cadastrado!') % '%s-%s' % (ficha.get('supfch_item'),
                                                                          descricao), tipo='W')
                continue

            printer = dict_locais.get(cod_local)
            if printer:
                if not impressoras.get(printer):
                    impressoras[printer] = ['\n'.join(impressao)]
                else:
                    impressoras[printer].append('\n'.join(impressao))
            else:
                print_log(_('Impressora nao cadastrada no local: %s') % cod_local, tipo='W')
                continue


            vals = {'supfch_cz_sequencia_de_impressao': seq_impressao,
                    'supfch_cz_data_hora_impressao': data,
                    'supfch_cz_state_impressao': '3'}
            self.write(cr, uid, ficha.get('id'), vals, context=context)

        obj_producao_utils.imprimir_pedidos(cr, uid, impressoras, context=context)
        return True