#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _


class supervisor_cad_promo4(osv.Model):

    _name = 'supervisor.cad.promo4'
    _inherit = 'supervisor.cad.promo4'

    def onchange_suppro4_sequencia(self, cr, uid, ids, sequencial, codigo_barras, itens, context=None):
        context = context and context.copy() or {}
        if not codigo_barras:
            return {'value':{'suppro4_descricao': '', 'suppro4_controle':''}}

        args = [('supite_codigo_item', '=', str(codigo_barras).zfill(14))]
        itens_ids = self.pool.get('supervisor.cad.itens').search(cr, uid, args, context=context)
        if not itens_ids:
            warning = {'title': _('Atencao!')}
            warning['message'] = _('Nao ha item para este codigo de barras!')
            return {'value': {'suppro4_barras': '', 'suppro4_descricao': '',
                              'suppro4_controle': ''},
                    'warning': warning}
        dados_item = self.pool.get('supervisor.cad.itens').read(cr, uid, itens_ids[0],
                                                                ['name', 'supite_preco',
                                                                 'supite_codigo_item'],
                                                                context=context)
        res = self.suppro4_verifica_precos_diferentes(cr, uid, sequencial, dados_item, itens,
                                                       context)
        if res:
            res['value'] = {'suppro4_sequencial': ''}

        return res

    def onchange_suppro4_barras(self, cr, uid, ids, sequencial, codigo_barras, itens, context=None):
        context = context and context.copy() or {}
        if not codigo_barras:
            return {'value':{'suppro4_descricao': '', 'suppro4_controle':''}}

        args = [('supite_codigo_item','=',str(codigo_barras).zfill(14))]
        itens_ids = self.pool.get('supervisor.cad.itens').search(cr, uid, args, context=context)

        if not itens_ids:
            warning = {'title': _('Atencao!')}
            warning['message'] = _('Nao ha item para este codigo de barras!')
            return {'value': {'suppro4_barras': '', 'suppro4_descricao': '', 'suppro4_controle':''},
                    'warning': warning}

        dados_item = self.pool.get('supervisor.cad.itens').read(cr, uid, itens_ids[0],
                                    ['name', 'supite_preco', 'supite_codigo_item'], context=context)
        res = self.suppro4_verifica_precos_diferentes(cr, uid, sequencial, dados_item, itens,
                                                      context)
        if res:
            return res

        descricao = dados_item.get('name') or ''
        return {'value':{'suppro4_descricao': str(descricao), 'suppro4_controle':''}}

    def suppro4_verifica_precos_diferentes(self, cr, uid, sequencial, item, promo_itens,
                                           context=None):
        # para itens com o mesmo sequencial verica se tem algum que nao tem o mesmo preco
        context = context and context.copy() or {}
        obj_itens = self.pool.get('supervisor.cad.itens')
        res = {}
        dict_itens = {item.get('supite_codigo_item'): item}
        dict_itens_agrupados = {sequencial: [item]}
        codigos = []
        promo_item_ids = []
        for i in promo_itens:
            if i[0] == 2:
                continue

            if i[2] and i[2].get('suppro4_barras'):
                codigos.append(i[2].get('suppro4_barras').rjust(14, '0'))
            else:
                promo_item_ids.append(i[1])

        dict_promo_itens = {}
        if promo_item_ids:
            for i in self.read(cr, uid, promo_item_ids, ['suppro4_barras', 'suppro4_sequencial'],
                               context):
                dict_promo_itens.update({i.get('id'): i})
                codigos.append(i.get('suppro4_barras').rjust(14, '0'))

        item_ids = obj_itens.search(cr, uid, [('supite_codigo_item', 'in', codigos)],
                                    context=context)
        if not item_ids:
            return res

        map(lambda x: dict_itens.update({x.get('supite_codigo_item'): x}),
            obj_itens.read(cr, uid, item_ids, ['supite_codigo_item', 'supite_preco', 'name'],
                           context))
        for i in promo_itens:
            if i[0] == 2:
                continue

            if not i[2]:
                i[2] = dict_promo_itens.get(i[1])
            elif not i[2].get('suppro4_barras'):
                i[2].update(dict_promo_itens.get(i[1]))

            cb = i[2].get('suppro4_barras').rjust(14, '0')
            if dict_itens_agrupados.get(i[2].get('suppro4_sequencial')):
                dict_itens_agrupados[i[2].get('suppro4_sequencial')].append(dict_itens.get(cb))
            else:
                dict_itens_agrupados[i[2].get('suppro4_sequencial')] = [dict_itens.get(cb)]

        s = False
        for seq, lista_itens in dict_itens_agrupados.items():
            if s == False or s != seq:
                s = seq

            preco = 0
            old_item = False
            for supite in lista_itens:
                if not preco:
                    preco = supite.get('supite_preco')
                    old_item = supite
                if preco != supite.get('supite_preco'):
                    item1 = '%s-%s: R$ %s' % (supite.get('supite_codigo_item'), supite.get('name'),
                                              supite.get('supite_preco'))
                    item2 = '%s-%s: R$ %s' % (old_item.get('supite_codigo_item'),
                                              old_item.get('name'), old_item.get('supite_preco'))
                    msg = _('Itens no sequencial "%s" devem ter o mesmo preco:\n%s\n%s') % \
                          (s, item1, item2)
                    return {'value': {'suppro4_barras': '', 'suppro4_descricao': '',
                                      'suppro4_controle':''},
                            'warning': {'title': _('Atencao!'),
                                        'message': msg.replace('.', '.')}}
        return res

    def onchange_suppro4_descricao(self, cr, uid, ids, descricao, controle, context=None):
        context = context and context.copy() or {}
        if controle:
            warning = {'title': _('Atencao!')}
            warning['message'] = _('A descricao nao pode ser alterada!')
            return {'warning': warning, 'value': {'suppro4_descricao': controle}}

        return {'value':{'suppro4_controle': descricao}}

    def create(self, cr, user, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('suppro4_barras'):
            vals['suppro4_barras'] = '%s' % vals.get('suppro4_barras').zfill(14)

        return super(supervisor_cad_promo4, self).create(cr, user, vals, context=context)

    def write(self, cr, user, ids, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('suppro4_barras'):
            vals['suppro4_barras'] = '%s' % vals.get('suppro4_barras').zfill(14)

        return super(supervisor_cad_promo4, self).write(cr, user, ids, vals, context=context)


