#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _


class supervisor_cad_promo5f(osv.Model):

    _name = 'supervisor.cad.promo5f'
    _inherit = 'supervisor.cad.promo5f'

    def onchange_suppro5f_barras(self, cr, uid, ids, codigo_barras, context=None):
        context = context and context.copy() or {}
        if not codigo_barras:
            return {'value':{'suppro5f_descricao': '', 'suppro5f_controle':''}}

        args = [('supite_codigo_item','=',str(codigo_barras).zfill(14))]
        itens_ids = self.pool.get('supervisor.cad.itens').search(cr, uid, args, context=context)

        if not itens_ids:
            warning = {'title': _('Atencao!')}
            warning['message'] = _('Nao ha item para este codigo de barras!')
            return {'value': {'suppro5f_barras': '', 'suppro5f_descricao': '', 'suppro5f_controle':''},
                    'warning': warning}

        dados_item = self.pool.get('supervisor.cad.itens').read(cr, uid, itens_ids[0],
                                                                ['name'], context=context)
        descricao = dados_item.get('name') or ''
        return {'value':{'suppro5f_descricao': str(descricao), 'suppro5f_controle':''}}

    def onchange_suppro5f_descricao(self, cr, uid, ids, descricao, controle, context=None):
        context = context and context.copy() or {}
        if controle:
            warning = {'title': _('Atencao!')}
            warning['message'] = _('A descricao nao pode ser alterada!')
            return {'warning': warning, 'value': {'suppro5f_descricao': controle}}

        return {'value':{'suppro5f_controle': descricao}}
    
    def create(self, cr, user, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('suppro5f_barras'):
            vals['suppro5f_barras'] = '%s' % vals.get('suppro5f_barras').zfill(14)

        return super(supervisor_cad_promo5f, self).create(cr, user, vals, context=context)

    def write(self, cr, user, ids, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('suppro5f_barras'):
            vals['suppro5f_barras'] = '%s' % vals.get('suppro5f_barras').zfill(14)

        return super(supervisor_cad_promo5f, self).write(cr, user, ids, vals, context=context)


