#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _


class supervisor_cad_promo6(osv.Model):

    _name = 'supervisor.cad.promo6'
    _inherit = 'supervisor.cad.promo6'

    def onchange_suppro6_barras(self, cr, uid, ids, codigo_barras, itens_promo_6, context=None):
        context = context and context.copy() or {}
        if not codigo_barras:
            return {'value':{'suppro6_descricao': '', 'suppro6_controle':''}}

        args = [('supite_codigo_item','=',str(codigo_barras).zfill(14))]
        obj_sup_item = self.pool.get('supervisor.cad.itens')
        itens_ids = obj_sup_item.search(cr, uid, args, context=context)

        if not itens_ids:
            warning = {'title': _('Atencao!')}
            warning['message'] = _('Nao ha item para este codigo de barras!')
            return {'value': {'suppro6_barras': '', 'suppro6_descricao': '', 'suppro6_controle':''},
                    'warning': warning}

        dados_item = obj_sup_item.read(cr, uid, itens_ids[0],
                                                           ['name','supite_preco'], context=context)

        values = self.pool.get('supervisor.cad.promo_capa').resolve_2many_commands(
            cr, uid, 'supproc_promo6_ids', itens_promo_6, ['suppro6_barras'], context=context)
        values = filter(lambda x: x.get('id') not in ids, values)
        itens_cod_barras = map(lambda x: x.get('suppro6_barras').zfill(14), values)
        if itens_cod_barras:
            args = [('supite_codigo_item','in', (itens_cod_barras))]
            itens_ids = obj_sup_item.search(cr, uid, args, context=context)
            for item in obj_sup_item.read(cr, uid, itens_ids, ['supite_preco'], context=context):
                # caso o preco do item seleciona seja diferente dos ja cadastrados avisa o usuario
                if item.get('supite_preco') != dados_item.get('supite_preco'):
                    return {'value':{'suppro6_descricao': '',
                                     'suppro6_controle':'',
                                     'suppro6_barras': ''},
                            'warning': {'title': _('Atencao!'),
                                        'message': _('Os itens desta promocao devem ter o mesmo preco!')}
                            }

        descricao = dados_item.get('name') or ''
        return {'value':{'suppro6_descricao': str(descricao), 'suppro6_controle':''}}

    def onchange_suppro6_descricao(self, cr, uid, ids, descricao, controle, context=None):
        context = context and context.copy() or {}
        if controle:
            warning = {'title': _('Atencao!')}
            warning['message'] = _('A descricao nao pode ser alterada!')
            return {'warning': warning, 'value': {'suppro6_descricao': controle}}

        return {'value':{'suppro6_controle': descricao}}

    def create(self, cr, user, vals, context=None):
        context = context and context.copy() or {}
        self.suppro6_verifica_quantidades(vals, context)
        if vals.get('suppro6_barras'):
            vals['suppro6_barras'] = '%s' % vals.get('suppro6_barras').zfill(14)

        return super(supervisor_cad_promo6, self).create(cr, user, vals, context=context)

    def write(self, cr, user, ids, vals, context=None):
        context = context and context.copy() or {}
        self.suppro6_verifica_quantidades(vals, context)
        if vals.get('suppro6_barras'):
            vals['suppro6_barras'] = '%s' % vals.get('suppro6_barras').zfill(14)

        return super(supervisor_cad_promo6, self).write(cr, user, ids, vals, context=context)


    def suppro6_verifica_quantidades(self, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('suppro6_qtd_leva') <=0:
            raise osv.except_osv(_('Atencao!'),_('"Quantidade levada" deve ser maior que Zero'))

        if vals.get('suppro6_qtd_paga') <=0:
            raise osv.except_osv(_('Atencao!'),_('"Quantidade paga" deve ser maior que Zero'))