#!/usr/bin/python
# -*- coding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _


class supervisor_cad_promo7(osv.Model):

    _name = 'supervisor.cad.promo7'
    _inherit = 'supervisor.cad.promo7'

    def onchange_suppro7_barras(self, cr, uid, ids, codigo_barras, context=None):
        context = context and context.copy() or {}
        if not codigo_barras:
            return {'value':{'suppro7_descricao': '', 'suppro7_controle':''}}

        args = [('supite_codigo_item','=',str(codigo_barras).zfill(14))]
        itens_ids = self.pool.get('supervisor.cad.itens').search(cr, uid, args, context=context)

        if not itens_ids:
            warning = {'title': _('Atencao!')}
            warning['message'] = _('Nao ha item para este codigo de barras!')
            return {'value': {'suppro7_barras': '', 'suppro7_descricao': '', 'suppro7_controle':''},
                    'warning': warning}

        dados_item = self.pool.get('supervisor.cad.itens').read(cr, uid, itens_ids[0],
                                                                ['name'], context=context)
        descricao = dados_item.get('name') or ''
        return {'value':{'suppro7_descricao': str(descricao), 'suppro7_controle':''}}

    def onchange_suppro7_descricao(self, cr, uid, ids, descricao, controle, context=None):
        context = context and context.copy() or {}
        if controle:
            warning = {'title': _('Atencao!')}
            warning['message'] = _('A descricao nao pode ser alterada!')
            return {'warning': warning, 'value': {'suppro7_descricao': controle}}

        return {'value':{'suppro7_controle': descricao}}

    def onchange_suppro7_desconto(self, cr, uid, ids, cb, tipo_desc, desconto, context=None):
        context = context and context.copy() or {}
        res = {'value': {}}
        if not cb or not desconto:
            return res

        if not tipo_desc:
            res['value']['suppro7_desconto'] = 0
            res['warning'] = {'title': _('Atencao!'),
                              'message': _('Escolha um tipo de desconto!')}

        args = [('supite_codigo_item', '=', str(cb).zfill(14))]
        itens_ids = self.pool.get('supervisor.cad.itens').search(cr, uid, args, context=context)
        dados_item = self.pool.get('supervisor.cad.itens').read(cr, uid, itens_ids[0],
                                                                ['supite_preco'], context=context)
        if tipo_desc == '$' and desconto >= dados_item.get('supite_preco'):
            res['value']['suppro7_desconto'] = 0
            res['warning'] = {'title': _('Atencao!'),
                              'message': _('Valor do desconto maior ou igual ao preco do item\n'
                                           'Preco Item: R$ %0.2f\n Desconto: R$ %0.2f') %
                                         (dados_item.get('supite_preco'), desconto)}
        elif desconto > 99:
            res['value']['suppro7_desconto'] = 0
            res['warning'] = {'title': _('Atencao!'),
                              'message': _('Percentual do desconto maior 99%')}

        return res



    def create(self, cr, user, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('suppro7_barras'):
            vals['suppro7_barras'] = '%s' % vals.get('suppro7_barras').zfill(14)

        return super(supervisor_cad_promo7, self).create(cr, user, vals, context=context)

    def write(self, cr, user, ids, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('suppro7_barras'):
            vals['suppro7_barras'] = '%s' % vals.get('suppro7_barras').zfill(14)

        return super(supervisor_cad_promo7, self).write(cr, user, ids, vals, context=context)