#!/usr/bin/python
# -*- coding: utf-8 -*-

PROMOCOES = ['supervisor.cad.promo1', 'supervisor.cad.promo2', 'supervisor.cad.promo3p',
             'supervisor.cad.promo3f', 'supervisor.cad.promo4', 'supervisor.cad.promo5p',
             'supervisor.cad.promo5f', 'supervisor.cad.promo6', 'supervisor.cad.promo7']

CONTROLE = ['1','2','3p','3f','4','5p','5f','6','7']

def verifica_cb(cr, id, codigo_barras, periodo_inicial, periodo_final, context=None):
    """
    Verifica se os codigos de barras da promocao estao em outra promocao ativada
    :param cr:
    :param uid:
    :param id: id da capa da promocao para nao ser pesquisado
    :param codigo_barras: lista com os codigos de barras da promocao
    :param context:
    :return: lista de dicionarios com id da promocao(chave) e os codigos de barras(valor) que estao nas
             outras promocoes  ou lista vazia
    """
    context = context and context.copy() or {}
    res = []
    if not codigo_barras:
        return res

    str_codigo_barras = "'" + "','".join(map(lambda x: x, codigo_barras)) + "'"
    for classe in PROMOCOES:
        controle = filter(lambda x: x in classe, CONTROLE)[0]
        cr.execute('''
        SELECT promo.suppro{controle}_barras AS codigo_barras,
               pc.supproc_id_promo        AS id_promo
        FROM {classe} AS promo
        INNER JOIN supervisor_cad_promo_capa AS pc ON pc.id = promo.suppro{controle}_capa_id
        WHERE (('{periodo_inicial}' <= pc.supproc_data_hora_inicio AND  pc.supproc_data_hora_inicio <= '{periodo_final}')
           OR  ('{periodo_inicial}' <= pc.supproc_data_hora_fim AND  pc.supproc_data_hora_fim <= '{periodo_final}')
           or  pc.supproc_data_hora_inicio <= '{periodo_inicial}' and '{periodo_final}' <= pc.supproc_data_hora_fim)
          AND pc.state = '2' --ativada
          AND promo.suppro{controle}_barras in ({codigo_barras})
          AND pc.id != {id}
        ORDER BY pc.supproc_id_promo, promo.id
           '''.format(classe=classe.replace('.', '_'),
                      periodo_inicial=periodo_inicial,
                      periodo_final=periodo_final,
                      controle=controle,
                      codigo_barras=str_codigo_barras,
                      id=id) )
        res.extend(map(lambda x: {x.get('id_promo'): x.get('codigo_barras')}, cr.dictfetchall() ))

    return res
