# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

def criar_triger(cr, tabela, context=None):
    '''
    Criar uma triger para o campo scanntec para as tabelas do supervisor cad_itens,
          mov_capa, mov_corpos, mov_corpo_xz, mov_fehcamentos
    :param cr:
    :param tabela:
    :return:
    '''
    context = context and context.copy() or {}
    condicao =  '''IF TG_OP NOT IN ('UPDATE', 'DELETE') OR OLD.scanntech = 1 THEN'''
    if tabela in ['cad_itens', 'mov_capa']:
        condicao = '''IF TG_OP NOT IN ('UPDATE', 'DELETE') OR (OLD.scanntech = 1
                         AND OLD.log_erro = NEW.log_erro) THEN'''
    _sql = '''
        CREATE OR REPLACE FUNCTION {nome}_gatilho() RETURNS trigger AS ${nome}_gatilho$
            BEGIN
                {condicao}
                    NEW.scanntech := 0;
                END IF;
                RETURN NEW;
            END;
    
        ${nome}_gatilho$ LANGUAGE plpgsql;

        DROP TRIGGER IF EXISTS {nome}_gatilho ON supervisor_{nome};
        CREATE TRIGGER {nome}_gatilho BEFORE INSERT OR UPDATE ON supervisor_{nome}
            FOR EACH ROW EXECUTE PROCEDURE {nome}_gatilho();
    '''.format(nome=tabela,
               condicao=condicao)
    cr.execute(_sql)
    return True