# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################


from openerp.osv import osv, fields
from openerp.tools import drop_view_if_exists


class supervisor_mov_corpo_xz_view(osv.Model):
    """
    View dos corpos xz no supervisor para a API Avanco utilizar
    """
    _name = "scanntech_corpo_xz_view"
    _auto = False
    _columns = {
        'capa_id': fields.many2one("supervisor.mov.capa", 'Capa', ondelete="cascade", required=True, select=True),
        'data_movimento': fields.date('Data movimento', required=True, select=True),
        'cupom_inicial': fields.integer('Cupom inicial'),
        'cupom_final': fields.integer('Cupom final'),
        'gt_atual': fields.float('Gt atual', digits=(16,3)),
        'gt_anterior': fields.float('Gt anterior', digits=(16,3)),
        'cancelamentos': fields.float('Cancelamentos', digits=(16,3)),
        'descontos': fields.float('Descontos', digits=(16,3)),
        'acrescimos': fields.float('Acrescimos', digits=(16,3)),
        'crz': fields.integer('crz'),
        'cro': fields.integer('Cro'),
        'descontos_iss': fields.float('Descontos iss', digits=(16,3)),
        'acrescimos_iss': fields.float('Acrescimos iss', digits=(16,3)),
        'cancelamentos_iss': fields.float('Cancelamentos iss', digits=(16,3)),
        'scanntech': fields.integer('Sacanntech', sequence=True),
    }

    def init(self, cr):
        drop_view_if_exists(cr, "scanntech_corpo_xz_view")
        cr.execute("""
            CREATE OR REPLACE VIEW scanntech_corpo_xz_view AS(
                SELECT smcxz.supcxz_capa_id                AS capa_id,
                       smcxz.supcxz_data_movimento         AS data_movimento,
                       smcxz.supcxz_cupom_inicial          AS cupom_inicial,
                       smcxz.supcxz_cupom_final            AS cupom_final,
                       smcxz.supcxz_gt_atual               AS gt_atual,
                       smcxz.supcxz_gt_anterior            AS gt_anterior,
                       smcxz.supcxz_cancelamentos          AS cancelamentos,
                       smcxz.supcxz_descontos              AS descontos,
                       smc.supcap_crz                      AS crz,
                       smcxz.supcxz_cro                    AS cro,
                       smcxz.supcxz_acrescimos             AS acrescimos,
                       smcxz.supcxz_descontos_iss          AS descontos_iss,
                       smcxz.supcxz_acrescimos_iss         AS acrescimos_iss,
                       smcxz.supcxz_cancelamentos_iss      AS cancelamentos_iss,
                       smcxz.scanntech
                FROM supervisor_mov_corpo_xz AS smcxz
                LEFT JOIN supervisor_mov_capa AS smc ON smc.id = smcxz.supcxz_capa_id
            );

            CREATE RULE scanntech_corpo_xz_view_upd AS
            ON UPDATE TO scanntech_corpo_xz_view DO INSTEAD UPDATE supervisor_mov_corpo_xz SET scanntech = NEW.scanntech
            WHERE supcxz_capa_id = NEW.capa_id
              and supcxz_data_movimento = NEW.data_movimento
              and supcxz_gt_atual = NEW.gt_atual;
        """)
