# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################


from openerp.osv import osv, fields
from openerp.tools import drop_view_if_exists


class supervisor_mov_fechamentos_view(osv.Model):
    """
    View dos fechamentos no supervisor para a API Avanco utilizar
    """
    _name = "scanntech_fechamentos_view"
    _auto = False
    _columns = {
        'id': fields.integer('Id', required=True),
        'capa_id': fields.many2one("supervisor.mov.capa", 'Mov capa', ondelete="cascade",
                                          required=True, select=True,),
        'tipo_finalizadora': fields.selection([('D', 'Dinheiro'),
                                                      ('H', 'Cheque'),
                                                      ('C', 'Cartao'),
                                                      ('T', 'Ticket'),
                                                      ('O', 'Outros')], 'Tipo de finalizadora'),
        'valor': fields.float('Valor', digits=(10, 2)),
        'troco': fields.float('Troco', digits=(10, 2)),
        'scanntech': fields.integer('Sacanntech', sequence=True),
    }

    def init(self, cr):
        drop_view_if_exists(cr, "scanntech_fechamentos_view")
        cr.execute("""
            CREATE OR REPLACE VIEW scanntech_fechamentos_view AS(
                SELECT id,
                       supfec_capa_id           AS capa_id,
                       supfec_tipo_finalizadora AS tipo_finalizadora,
                       supfec_valor             AS valor,
                       supfec_troco             AS troco,
                       scanntech
                FROM supervisor_mov_fechamentos
                );

            CREATE RULE scanntech_fechamentos_view_upd AS
            ON UPDATE TO scanntech_fechamentos_view DO INSTEAD UPDATE supervisor_mov_fechamentos SET scanntech = NEW.scanntech
            WHERE id = NEW.id;
        """)
