# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################


from openerp.osv import osv, fields
from openerp.tools import drop_view_if_exists


class supervisor_mov_totalizadores_xz_view(osv.Model):
    """
    View dos totalizadores xz no supervisor para a API Avanco utilizar
    """
    _name = "scanntech_totalizadores_xz_view"
    _auto = False
    _columns = {
        'id': fields.integer('Id', required=True),
        'capa_id': fields.many2one("supervisor.mov.capa", 'Mov capa', ondelete="cascade",
                                          required=True, select=True,),
        'tributacao':fields.selection([('T','Tributado'),
                                       ('F', 'Substituicao'),
                                       ('I', 'Isento'),
                                       ('N', 'Nao tributado')], 'Tipo tributacao'),
        'aliquota_original': fields.float('Aliquota Original', digits=(10, 2)),
        'aliquota_efetiva': fields.float('Aliquota efetiva', digits=(10, 2)),
        'base_calculo': fields.float('Base de calculo', digits=(10, 2)),
        'scanntech': fields.integer('Sacanntech', sequence=True),
    }

    def init(self, cr):
        drop_view_if_exists(cr, "scanntech_totalizadores_xz_view")
        cr.execute("""
            CREATE OR REPLACE VIEW scanntech_totalizadores_xz_view AS(
                SELECT id,
                       suptxz_capa_id         AS capa_id,
                       suptxz_tipo_tributacao AS tributacao,
                       suptxz_aliquota        AS aliquota_original,
                       suptxz_aliquota        AS aliquota_efetiva,
                       suptxz_base            AS base_calculo,
                       scanntech
                FROM supervisor_mov_totalizadores_xz
                );

            CREATE RULE scanntech_totalizadores_xz_view_upd AS
            ON UPDATE TO scanntech_totalizadores_xz_view DO INSTEAD UPDATE supervisor_mov_totalizadores_xz SET scanntech = NEW.scanntech
            WHERE id = NEW.id;
        """)
