# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class wizard_supervisor_exporta_para_ecf(osv.Model):
    """
    Tabela de Totalizadores do X e do Z
    Prefixo: suptxz
    """
    _name = "wizard.supervisor.exporta.para.ecf"
    _inherit = 'wizard.supervisor.exporta.para.ecf'
    _columns = {
        'promocoes': fields.boolean('Promocoes'),
    }

    def get_acao_promocao(self, cr, uid, ids, vals, args, dict_exportado, context=None):
        super(wizard_supervisor_exporta_para_ecf, self).get_acao_promocao( cr, uid, ids, vals,
                                                                           dict_exportado, args,
                                                                           context=context)
        for id in ids:
            obj_supervisor_mov_acao_pendente = self.pool.get('supervisor.mov.acao.pendente')
            brw_exporta_para_ecf = self.browse(cr, uid, id, context=context)
            if not brw_exporta_para_ecf.promocoes:
                return

            args[0][2] = 'Promocoes'
            acao_pendente_ids = obj_supervisor_mov_acao_pendente.search(cr, uid, args, context=context)
            dict_exportado['exportado'] = True
            if not acao_pendente_ids:
                vals['supape_tabela'] = 'Promocoes'
                obj_supervisor_mov_acao_pendente.create(cr, uid, vals, context=context)

    def checking_all_boxes(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        super(wizard_supervisor_exporta_para_ecf, self).checking_all_boxes(cr, uid, ids, context)
        if ids:
            self.write(cr, uid, ids, {'promocoes': True}, context)

        return True

    def exporta_verificar_promocoes_tipo4(self, cr, user, context):
        context = context and context.copy() or {}
        super(wizard_supervisor_exporta_para_ecf, self).exporta_verificar_promocoes_tipo4(cr, user,
                                                                                          context)
        obj_promo_capa = self.pool.get('supervisor.cad.promo_capa')
        promo_ids = obj_promo_capa.search(cr, user, [('state', '=', '2'),
                                                     ('supproc_tipo_promo', '=', '4')],
                                          context=context)
        if not promo_ids:
            return True

        msg = []
        for i in obj_promo_capa.browse(cr, user, promo_ids, context):
            if obj_promo_capa.verificar_valor_itens(cr, user, i.supproc_promo4_ids,
                                                    context):
                msg.append(_('%s - Promocao Id: %s') % (i.supproc_nome_promo,
                                                        i.supproc_id_promo))

        if msg:
            if context.get('exporta_sem_retornar_raise'):
                return False
            else:
                raise osv.except_osv(_('Atencao!'),
                                     _('As seguintes promocoes do tipo 4 estao com valor maior '
                                       'que a soma dos itens: \n%s') % '\n'.join(msg))

        return True