# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from os import path, listdir, remove
from fnmatch import fnmatch
from SigUtils.registro import Registro
import os
import importlib
from openerp.tools.translate import _
from datetime import datetime
from dateutil.parser import parse


class wizard_supervisor_importa_arquivo(osv.Model):

    _inherit = "wizard.supervisor.importa.arquivo"

    def atualiza_vals_promo(self, vals, promocao, cfg_empresa, context):
        'Implementado por heranca no supervisor_master_promocoes'
        pass

    def _importa_arquivo_promocao(self, cr, uid, registros, cfg_empresa, lines,
                                  context=None):
        """
        O metodo importa os dados da promocao para as tabelas 'supervisor_cad_promo_capa' e
        'supervisor_cad_promo4'.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param instancia_arquivo: obj do arquivo que sera importado.
        :type instancia_arquivo: object
        :param registros: objeto dos layouts dos arquivos de importacao.
        :type registros: object
        :param lines: dados do arquivo que sera importado.
        :type lines: list
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: Verdadeiro, caso alguma promocao seja incluida, senao, Falso.
        :rtype: bool
        """
        context = context and context.copy() or {}
        super(wizard_supervisor_importa_arquivo, self)._importa_arquivo_promocao(cr, uid, registros,
                                                                                 lines, context)
        log_importacao = self.pool.get('supervisor.log.importacao').suplog_cria_log
        res = False
        obj_supervisor_cad_promo_capa = self.pool.get('supervisor.cad.promo_capa')
        qtd_grava_log = qtd_importada = 0
        frequencia = (len(lines)/50) or 1
        obj_sup_util = self.pool.get('supervisor.util')
        nome = '%s -  Promocao' % obj_sup_util.suputi_datetime_to_timezone(cr, uid, datetime.now())
        obj_supervisor_util = self.pool.get('supervisor.util')
        converte_tz = obj_supervisor_util.suputi_converte_tz
        try:
            for line in lines:
                qtd_importada += 1
                qtd_grava_log += 1
                try:
                    promocao = registros.registro_decompoe(registros.Promocao(),
                                                           line.strip('\r\n').strip('\n'))
                except Exception as e:
                    log_importacao(cr, uid, nome, qtd_importada, len(lines),
                                   'Erro de Layout linha %s: %s' % (qtd_importada, str(e)),
                                   context=context)
                    continue

                nome_promocao = obj_supervisor_util.suputi_remover_acentuacao(
                    promocao.supproc_nome_promo or '')
                nome_promocao = obj_supervisor_util.suputi_remove_caracter(nome_promocao)
                vals = {
                    'supproc_nome_promo': nome_promocao,
                    'state': '2',
                    'supproc_data_hora_inicio': converte_tz(
                        cr, uid, parse(promocao.supproc_data_hora_inicio + ' 00:00:00'),
                        tz_destino='utc', context=context).strftime('%Y-%m-%d %H:%M:%S'),
                    'supproc_data_hora_fim': converte_tz(
                        cr, uid, parse(promocao.supproc_data_hora_fim + ' 23:59:59'), tz_destino='utc',
                        context=context).strftime('%Y-%m-%d %H:%M:%S'),
                    'supproc_tipo_promo': '4',
                    'supproc_maximo': 999,
                    'supproc_promo4_ids': [(0, 0, {'suppro4_barras': promocao.suppro4_barras,
                                                   'suppro4_quantidade': 1,
                                                   'suppro4_preco': promocao.suppro4_preco})]
                }
                if qtd_grava_log / frequencia > 0:  # frenquencia em que grava o log
                    qtd_grava_log = 0
                    log_importacao(cr, uid, nome, qtd_importada, len(lines), '', context=context)

                self.atualiza_vals_promo(vals, promocao, cfg_empresa, context)
                res = obj_supervisor_cad_promo_capa.create(cr, uid, vals, context)

        except Exception as e:
            log_importacao(cr, uid, nome, qtd_importada, len(lines),
                           'Erro linha %s: %s' % (qtd_importada, str(e)), context=context)

        log_importacao(cr, uid, nome, qtd_importada, len(lines), '', finalizado=True,
                       context=context)  # final dos registros que sobraram

        return res
