#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class supervisor_cad_promo2(osv.Model):
    """
    PACOTE COM % DE DESCONTO:
    Três unidades de qualquer um dos seguintes itens:
    7891050000101 - WHISKY PASSPORT 1000ML
    e levando uma unidade de qualquer um dos seguintes ítens:
    7622300807283 - CHOCOLATE LACTA BIS LAKA SNACKS BRANCO 126G
    Desconto total de 5%
    Prefixo: suppro2
    """
    from funcoes import get_default_suppro_quantidade, get_default_suppro_desconto

    _name = 'supervisor.cad.promo2'
    _rec_name = 'suppro2_barras'
    _gerar_logs_logs = 'N'
    _columns = {
        'suppro2_capa_id': fields.many2one('supervisor.cad.promo_capa','Capa',ondelete="cascade",
                                           required=True, select=True),
        'suppro2_barras': fields.char('Codigo de barras', size=14, required=True, select=True),
        'suppro2_quantidade': fields.float('Quantidade', digits=(10, 3), required=True),
        'suppro2_desconto': fields.float('Desconto', digits=(10, 2), required=True,),
        'suppro2_tipo_desconto': fields.selection([('$', 'Valor'),
                                                   ('%', 'Percentual')],  'Tipo de desconto', required=True,),
        'suppro2_sequencial': fields.integer('Sequencial', required=True),
        'suppro2_controle': fields.char('Controle', size=30), # controla de onde vem a alteracao do campo de descricao
        'suppro2_descricao': fields.char('Descricao', size=30),
    }

    _defaults = {
        'suppro2_quantidade': get_default_suppro_quantidade,
        'suppro2_desconto': get_default_suppro_desconto,
        'suppro2_sequencial': 1,
        'suppro2_tipo_desconto':'%',
    }