#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class supervisor_cad_promo3f(osv.Model):
    """(filho)
    PACOTE COM DESCONTO ADICIONAL:
    Levando 1 unidade de qualquer um dos ítens:
    7896036090244 - OLEO LIZA SOJA P 900ML
    Desconto de 20% em qualquer um dos ítens:
    7898339470204 - BATATA PALHA TOSTFRI 200G
    Prefixo: suppro3f
    """
    from funcoes import get_default_suppro_quantidade, get_default_suppro_desconto

    _name = 'supervisor.cad.promo3f'
    _rec_name = 'suppro3f_barras'
    _gerar_logs_logs = 'N'
    _columns = {
        'suppro3f_capa_id': fields.many2one('supervisor.cad.promo_capa','Capa',ondelete="cascade",
                                           required=True, select=True),
        'suppro3f_barras': fields.char('Codigo de barras', size=14, required=True, select=True),
        'suppro3f_quantidade': fields.float('Quantidade', digits=(10, 3), required=True),
        'suppro3f_desconto': fields.float('Desconto', digits=(10, 2), required=True,),
        'suppro3f_tipo_desconto': fields.selection([('$', 'Valor'),
                                                    ('%', 'Percentual')],  'Tipo de desconto', required=True,),
        'suppro3f_controle': fields.char('Controle', size=30), # controla de onde vem a alteracao do campo de descricao
        'suppro3f_descricao': fields.char('Descricao', size=30),
    }

    _defaults = {
        'suppro3f_quantidade': get_default_suppro_quantidade,
        'suppro3f_desconto': get_default_suppro_desconto,
    }