#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class supervisor_cad_promo3p(osv.Model):
    """(Pai)
    PACOTE COM DESCONTO ADICIONAL:
    Levando 1 unidade de qualquer um dos ítens:
    7896036090244 - OLEO LIZA SOJA P 900ML
    Desconto de 20% em qualquer um dos ítens:
    7898339470204 - BATATA PALHA TOSTFRI 200G
    Prefixo: suppro3p
    """
    from funcoes import get_default_suppro_quantidade

    _name = 'supervisor.cad.promo3p'
    _rec_name = 'suppro3p_barras'
    _gerar_logs_logs = 'N'
    _columns = {
        'suppro3p_capa_id': fields.many2one('supervisor.cad.promo_capa','Capa',ondelete="cascade",
                                           required=True, select=True),
        'suppro3p_barras': fields.char('Codigo de barras', size=14, required=True, select=True),
        'suppro3p_quantidade': fields.float('Quantidade', digits=(10, 3), required=True),
        'suppro3p_sequencial': fields.integer('Sequencial', required=True),
        'suppro3p_controle': fields.char('Controle', size=30), # controla de onde vem a alteracao do campo de descricao
        'suppro3p_descricao': fields.char('Descricao', size=30),
    }

    _defaults = {
        'suppro3p_quantidade': get_default_suppro_quantidade,
        'suppro3p_sequencial': 1,
    }
