#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class supervisor_cad_promo4(osv.Model):
    """
    PACOTE COM PREÇO FIXO:
    Levando 6 unidades de qualquer um dos itens:
    7891991006101 - CERVEJA BAVARIA PILSEN CL C/ALCOOL LT 350 ML
    Pague R$ 6.00 pelas 6 unidades, ou, R$ 1,00 por unidade
    Prefixo: suppro4
    """
    from funcoes import get_default_suppro_quantidade, get_default_suppro4_preco

    _name = 'supervisor.cad.promo4'
    _rec_name = 'suppro4_barras'
    _gerar_logs_logs = 'N'
    _columns = {
        'suppro4_capa_id': fields.many2one('supervisor.cad.promo_capa','Capa',ondelete="cascade",
                                           required=True, select=True),
        'suppro4_barras': fields.char('Codigo de barras', size=14, required=True, select=True),
        'suppro4_quantidade': fields.float('Quantidade', digits=(10, 3), required=True),
        'suppro4_preco': fields.float('Preco', digits=(10, 2), required=True,),
        'suppro4_sequencial': fields.integer('Sequencial', required=True),
        'suppro4_controle': fields.char('Controle', size=30), # controla de onde vem a alteracao do campo de descricao
        'suppro4_descricao': fields.char('Descricao', size=30),
    }

    _defaults = {
        'suppro4_quantidade': get_default_suppro_quantidade,
        'suppro4_preco': get_default_suppro4_preco,
        'suppro4_sequencial': 1,
    }

