#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class supervisor_cad_promo5f(osv.Model):
    """(filho)
    PACOTE COM % DE DESCONTO:
    Três unidades de qualquer um dos seguintes itens:
    7891050000101 - WHISKY PASSPORT 1000ML
    e levando uma unidade de qualquer um dos seguintes ítens:
    7622300807283 - CHOCOLATE LACTA BIS LAKA SNACKS BRANCO 126G
    Desconto total de 5%
    Prefixo: suppro5f
    """
    from funcoes import get_default_suppro_quantidade

    _name = 'supervisor.cad.promo5f'
    _rec_name = 'suppro5f_barras'
    _gerar_logs_logs = 'N'
    _columns = {
        'suppro5f_capa_id': fields.many2one('supervisor.cad.promo_capa','Capa',ondelete="cascade",
                                           required=True, select=True),
        'suppro5f_barras': fields.char('Codigo de barras', size=14, required=True, select=True),
        'suppro5f_quantidade': fields.float('Quantidade', digits=(10, 3), required=True),
        'suppro5f_controle': fields.char('Controle', size=30), # controla de onde vem a alteracao do campo de descricao
        'suppro5f_descricao': fields.char('Descricao', size=30),
    }

    _defaults = {
        'suppro5f_quantidade': get_default_suppro_quantidade
    }