#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class supervisor_cad_promo5p(osv.Model):
    """(pai)
    PACOTE COM PRODUTO GRÁTIS:
    Levando 2 unidades de qualquer um dos ítens:
    7896048705709 - LEITE PO BLENDY MOD AMAREL INTEG TRADNAT ENV AL 400G
    Leve grátis um dos ítens:
    7896062534088 - PB PAO DE MEL PAN 100G
    Prefixo: suppro5p
    """
    from funcoes import get_default_suppro_quantidade

    _name = 'supervisor.cad.promo5p'
    _gerar_logs_logs = 'N'
    _rec_name = 'suppro5p_barras'
    _columns = {
        'suppro5p_capa_id': fields.many2one('supervisor.cad.promo_capa','Capa',ondelete="cascade",
                                           required=True, select=True),
        'suppro5p_barras': fields.char('Codigo de barras', size=14, required=True, select=True),
        'suppro5p_quantidade': fields.float('Quantidade', digits=(10, 3), required=True),
        'suppro5p_sequencial': fields.integer('Sequencial', required=True),
        'suppro5p_controle': fields.char('Controle', size=30), # controla de onde vem a alteracao do campo de descricao
        'suppro5p_descricao': fields.char('Descricao', size=30),
    }

    _defaults = {
        'suppro5p_quantidade': get_default_suppro_quantidade,
        'suppro5p_sequencial': 1,
    }
