#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class supervisor_cad_promo6(osv.Model):
    """
    PACOTE LEVE X PAGUE X menos:
    Levando 6 unidades deste item pague 5 – L6P5
    7896048703899 – REFRIGERANTE COCA LATA
    Levando 6 unidades deste produto pague somente 5
    Tabela de cadastro de bandeiras
    Prefixo: suppro6
    """
    from funcoes import get_default_suppro_qtd_leva, get_default_suppro_qtd_paga

    _name = 'supervisor.cad.promo6'
    _rec_name = 'suppro6_barras'
    _gerar_logs_logs = 'N'
    _columns = {
        'suppro6_capa_id': fields.many2one('supervisor.cad.promo_capa','Capa',ondelete="cascade",
                                           required=True, select=True),
        'suppro6_barras': fields.char('Codigo de barras', size=14, required=True, select=True),
        'suppro6_qtd_leva': fields.float('Quantidade levada', digits=(10, 3), required=True),
        'suppro6_qtd_paga': fields.float('Quantidade paga', digits=(10, 3), required=True),
        'suppro6_sequencial': fields.integer('Sequencial', required=True),
        'suppro6_controle': fields.char('Controle', size=30), # controla de onde vem a alteracao do campo de descricao
        'suppro6_descricao': fields.char('Descricao', size=30),
    }

    _defaults = {
        'suppro6_qtd_leva': get_default_suppro_qtd_leva,
        'suppro6_qtd_paga': get_default_suppro_qtd_paga,
        'suppro6_sequencial': 1,
    }
