#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class supervisor_cad_promo7(osv.Model):
    """
    PACOTE COM DESCONTO FIXO
    Se o cliente comprar 5 unidades de qualquer um dos seguintes itens:
    7896213500092 - REMOVEDOR SALTE 500ML
    Recebe um desconto total de R$2.00
    Prefixo: suppro7
    """
    from funcoes import get_default_suppro_quantidade, get_default_suppro_desconto

    _name = 'supervisor.cad.promo7'
    _rec_name = 'suppro7_barras'
    _gerar_logs_logs = 'N'
    _columns = {
        'suppro7_capa_id': fields.many2one('supervisor.cad.promo_capa','Capa',ondelete="cascade",
                                           required=True, select=True),
        'suppro7_barras': fields.char('Codigo de barras', size=14, required=True, select=True),
        'suppro7_quantidade': fields.float('Qtd. Minima', digits=(10, 3), required=True),
        'suppro7_desconto': fields.float('Desconto', digits=(10, 2), required=True,),
        'suppro7_tipo_desconto': fields.selection([('$', 'Valor'),
                                                   ('%', 'Percentual')],  'Tipo de desconto', required=True,),
        'suppro7_sequencial': fields.integer('Sequencial', required=True),
        'suppro7_controle': fields.char('Controle', size=30), # controla de onde vem a alteracao do campo de descricao
        'suppro7_descricao': fields.char('Descricao', size=30),
    }
    _defaults = {
        'suppro7_quantidade': get_default_suppro_quantidade,
        'suppro7_desconto': get_default_suppro_desconto,
        'suppro7_sequencial': 1,
        'suppro7_tipo_desconto':'$',
    }
