#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _

SELECTION_PROMO = [('1', 'Promo 1'),
                   ('2', 'Promo 2'),
                   ('3', 'Promo 3'),
                   ('4', 'Promo 4'),
                   ('5', 'Promo 5'),
                   ('6', 'Promo 6'),
                   ('7', 'Promo 7')]

class supervisor_cad_promo_capa(osv.Model):
    _state_esboco = '1'
    _state_ativada = '2'
    _state_finalizada = '3'
    SELECTION_STATE = [(_state_esboco, _('Esboco')),
                       (_state_ativada, 'Ativada'),
                       (_state_finalizada, 'Finalizada')]

    def get_id_promo(self, cr, uid, context=None):
        context = context and context.copy() or {}
        promo_ids = self.search(cr, uid, [('supproc_scanntech','=',False)])
        if not promo_ids:
            return 1

        max_id_promo = max(map(lambda x: x.get('supproc_id_promo'),
                                          self.read(cr, uid, promo_ids, ['supproc_id_promo'],
                                                    context=context)))
        return max_id_promo + 1

    _name = 'supervisor.cad.promo_capa'
    _rec_name = 'supproc_id_promo'
    _gerar_logs_logs = 'N'
    _columns = {
        'id': fields.integer(),
        'supproc_nome_promo': fields.char('Descricao', size=50),
        'state': fields.selection(SELECTION_STATE, 'State', select=True),
        'supproc_data_hora_inicio': fields.datetime('Data/Hora inicio', required=True, select=True),
        'supproc_data_hora_fim': fields.datetime('Data/Hora fim', required=True, select=True),
        'supproc_id_promo': fields.integer('Id Promocao', required=True),
        'supproc_tipo_promo': fields.selection(SELECTION_PROMO,'Tipo Promocao', required=True),
        'supproc_maximo': fields.integer(_('Maximo')),
        'supproc_scanntech': fields.boolean('Scanntech'), # True a promocao eh Scanntech,
                                                          # False a promocao eh Sig
        'supproc_finalizadora_dinheiro': fields.boolean('Somente Dinheiro',
                                                        help='Promocao disponivel mediante ao '
                                                           'pagamento todal da compra em dinheiro'),
        'supproc_promo1_ids': fields.one2many('supervisor.cad.promo1', 'suppro1_capa_id',
                                              'Promo 1'),
        'supproc_promo2_ids': fields.one2many('supervisor.cad.promo2', 'suppro2_capa_id',
                                              'Promo 2'),
        'supproc_promo3p_ids': fields.one2many('supervisor.cad.promo3p', 'suppro3p_capa_id',
                                               'Promo 3p'),
        'supproc_promo3f_ids': fields.one2many('supervisor.cad.promo3f', 'suppro3f_capa_id',
                                               'Promo 3f'),
        'supproc_promo4_ids': fields.one2many('supervisor.cad.promo4', 'suppro4_capa_id',
                                              'Promo 4'),
        'supproc_promo5p_ids': fields.one2many('supervisor.cad.promo5p', 'suppro5p_capa_id',
                                               'Promo 5p'),
        'supproc_promo5f_ids': fields.one2many('supervisor.cad.promo5f', 'suppro5f_capa_id',
                                               'Promo 5f'),
        'supproc_promo6_ids': fields.one2many('supervisor.cad.promo6', 'suppro6_capa_id',
                                              'Promo 6'),
        'supproc_promo7_ids': fields.one2many('supervisor.cad.promo7', 'suppro7_capa_id',
                                              'Promo 7'),
    }
    _defaults = {
        'state': _state_esboco,
        'supproc_scanntech': False,
        'supproc_maximo': 1,
        'supproc_id_promo': get_id_promo,
        'supproc_finalizadora_dinheiro': False,
    }
    _sql_constraints = {
        ('scanntech_id_promo_unic', 'unique (supproc_scanntech,supproc_id_promo)',
                                    _('O Id da promocao deve ser unico')),
    }
