#!/usr/bin/python
# -*- coding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=138):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Relatorio de Promocoes Vendidas'))
        listagem.informaTamLinha(123)
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)
        listagem.defineFonte(tam=6.8)
        data_inicial = datas.get('data_inicio')
        data_final = datas.get('data_fim')
        ordenar = {'0':_('Promocao'), '1': 'Coo', '2': 'Produto(A-Z)'}.get(datas.get('ordenar'))
        tipo_promocao = {'0': 'Todas', '1': 'Scanntech', '2': _('Propria')}.\
                                                                get(datas.get('tipo_promocao'))
        promocoes_ids = datas.get('promocoes_ids')

        obj_supervisor_cfg_configuracao = pooler.get_pool(cr.dbname).get(
            'supervisor.cfg.configuracao')
        configuracao_ids = obj_supervisor_cfg_configuracao.search(cr, uid, [], context=context)
        nome_empresa = ''
        if configuracao_ids:
            nome_empresa = obj_supervisor_cfg_configuracao.browse(
                cr, uid, configuracao_ids[0], context=context).supcfc_cliente or ''
        title = center_title('', '%s', '') % nome_empresa
        docs = center_title('', _('POMOCOES VENDIDAS'),
                            _('Pagina: {{ Page }} '))
        data_inicial = time.strftime('%d/%m/%Y', time.strptime(data_inicial, '%Y-%m-%d'))
        data_final = time.strftime('%d/%m/%Y', time.strptime(data_final, '%Y-%m-%d'))
        docs2 = center_title(_(' Periodo: %s a %s') % (data_inicial, data_final),
                             _('Ordenar por: %s') % ordenar,
                             _('Tipo de promocao: %s ') % tipo_promocao)
        docs3 = center_title(_(' Promocoes: %s') % (','.join(promocoes_ids)), '', '')

        listagem.informaCab(title)
        listagem.informaCab('')
        listagem.informaCab(docs)
        listagem.informaCab(' Filtros')
        listagem.informaCab(docs2)
        listagem.informaCab(docs3)
        listagem.informaCab(
            '*----------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(
          _('| LOJA | ECF |  COO  | DATA CUPOM |ID PROMO | TIPO PROMO | CODIGO BARRAS |               DESCRICAO                | QTD PROMO | DESCONTO |'))
        listagem.informaCab(
            '*----------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.imprimeLinha(
            '|      |     |       |            |         |            |               |                                        |           |          |')
        listagem.rodapePadrao()

        deconto_total = 0
        item_desconto = {}
        coos_cancelados = map(lambda y: y.get('coo'),
                              filter(lambda x: x.get('tipo') == 'C' ,datas.get('dados')))
        for item in datas.get('dados'):
            coo = item.get('coo')
            if coo+1 in coos_cancelados or coo in coos_cancelados:
                continue

            desconto = item.get('desconto')
            tipo_promo = {'1':'Scanntech', '2': _('Propria')}.get(item.get('tipo_promo'))
            data_cupom = time.strftime('%d/%m/%Y', time.strptime(item.get('data_cupom'), '%Y-%m-%d'))
            nome_item = item.get('nome_item')
            linha = "|{loja} |{ecf} |{coo}| {data} |{promo} | {tipo_promo} |{codigo_barra} |{descricao}|{qtd_promo} |{desconto} |".format(
                loja=formataString(item.get('loja') or '', 5, ' ', 'E', 'N', 'S'),
                ecf=formataString(item.get('caixa'), 4, ' ', 'E', 'N', 'S'),
                coo=formataString(coo, 7, ' ', 'E', 'N', 'S'),
                data=formataString(data_cupom, 10, ' ', 'E', 'N', 'S'),
                promo=formataString(item.get('id_promo'), 8, ' ', 'E', 'N', 'S'),
                tipo_promo=formataString(tipo_promo, 10, ' ', 'D', 'N', 'S'),
                codigo_barra=formataString(item.get('codigo_barra'), 14, ' ', 'E', 'N', 'S'),
                descricao=formataString(nome_item, 40, ' ', 'D', 'N', 'S'),
                qtd_promo=formataString(item.get('qtd_promo'), 10, ' ', 'E', 'N', 'S'),
                desconto=formataString(getNumeroEditado(desconto), 9, ' ', 'E', 'N', 'S'),
            )
            deconto_total += desconto
            if not item_desconto.get(nome_item):
                item_desconto[nome_item] = desconto
            else:
                item_desconto[nome_item] += desconto
            listagem.imprimeLinha(linha)

        listagem.imprimeLinha(
            '*----------------------------------------------------------------------------------------------------------------------------------------*')
        linha = '|                                                                                                             Total Desconto: %s |'
        listagem.imprimeLinha(linha % formataString(getNumeroEditado(deconto_total), 10, ' ', 'E', 'N', 'S'))
        listagem.imprimeLinha(
            '*----------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.imprimeLinha(
            '| DESCRICAO                                   TOTAL DESCONTO                                                                             |')

        for item in sorted(item_desconto):
            listagem.imprimeLinha(
            '| {item}    R$ {total}                                                                                |'.
            format(item=formataString(item, 40, ' ', 'D', 'N', 'S'),
                   total=formataString(getNumeroEditado(item_desconto.get(item)), 8, ' ', 'E', 'N', 'S')))

        listagem.imprimeLinha(
            '*----------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.imprimeLinha(
          _('                                                                                                         ** Sig Informatica LTDA **       '))

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.relatorio_promocoes')


class supervisor_cad_promo_capa(osv.TransientModel):
    """
    Prefixo: suprep
    """
    _inherit = 'supervisor.relatorio.promocoes'

    def suprep_imprimir(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        brw_rel_promocoes = self.browse(cr, uid, ids, context=context)[0]
        pdvs = []
        data_inicio = brw_rel_promocoes.suprep_data_inico
        data_fim = brw_rel_promocoes.suprep_data_fim
        tipo_promo = brw_rel_promocoes.suprep_tipo_promocao
        for brw_pdv in brw_rel_promocoes.suprep_pdv_ids:
            pdvs.append({'loja': brw_pdv.suppdv_loja,
                         'caixa': brw_pdv.suppdv_caixa})

        itens = map(lambda x: x.supite_codigo_item, brw_rel_promocoes.suprep_itens_ids)
        promocoes_ids = list(set(map(lambda x: str(x.supproc_id_promo),
                                     brw_rel_promocoes.suprep_promocoes_ids)))
        ordenar = brw_rel_promocoes.suprep_ordenar


        dados = self.get_dados(cr, uid, data_inicio, data_fim, tipo_promo, pdvs, itens,
                               promocoes_ids, ordenar, context=context)
        if not dados:
            raise osv.except_osv(_("Atencao!"),
                                 _("Nenhuma promocao vendida para estes filtros!"))
        vals = {'data_inicio': data_inicio,
                'data_fim': data_fim,
                'tipo_promocao': tipo_promo,
                'dados': dados,
                'ordenar': ordenar,
                'promocoes_ids': promocoes_ids,
        }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'relatorio_promocoes',
            'datas': vals,
        }

    def get_dados(self, cr, uid, data_inicio, data_fim, tipo_promo, pdvs, itens, promocoes_ids,
                                 ordenar, context=None):
        context = context and context.copy() or {}
        if tipo_promo == '0': # os dois tipos de promocao Scanntech e Propria
            cond_tipo_promo = "AND smcor.supcor_tipo_promo in ('1', '2')"
        else:
            cond_tipo_promo = "AND smcor.supcor_tipo_promo = '%s'" % tipo_promo

        cond_pdv = ""
        for pdv in pdvs:
            if not cond_pdv:
                cond_pdv += "AND ("

            cond_pdv += "(smcap.supcap_loja = %s AND smcap.supcap_caixa = %s) OR " % \
                                                                  (pdv.get('loja'),pdv.get('caixa'))

        if cond_pdv:
            cond_pdv = cond_pdv[:-3] + ")"

        cond_itens = ""
        if itens:
            cond_itens = "AND smcor.supcor_item in %s" % ("('" + "','".join(itens) +"')")

        cond_promocoes = ""
        if promocoes_ids:
            cond_promocoes = "AND smcor.supcor_id_promo in %s" % ("('" + "','".join(promocoes_ids) +"')")

        if ordenar == '0':
            order_by = """ORDER BY smcor.supcor_id_promo,
                       smcap.supcap_loja,
                       smcap.supcap_caixa,
                       smcap.supcap_nro_cupom,
                       sci.supite_descricao_completa
                       """
        elif ordenar == '1':
            order_by = """ORDER BY smcap.supcap_loja,
                       smcap.supcap_caixa,
                       smcap.supcap_nro_cupom,
                       sci.supite_descricao_completa"""
        else:
            order_by = """ORDER BY sci.supite_descricao_completa,
                       smcap.supcap_loja,
                       smcap.supcap_caixa,
                       smcap.supcap_nro_cupom"""

        sql = """
            SELECT smcor.supcor_item                  AS codigo_barra,
                   smcor.supcor_id_promo              AS id_promo,
                   smcor.supcor_tipo_promo            AS tipo_promo,
                   smcor.supcor_quantidade_promo      AS qtd_promo,
                   smcor.supcor_desconto_item_sem_rat AS desconto,
                   sci.supite_descricao_completa      AS nome_item,
                   smcap.supcap_data_cupom            AS data_cupom,
                   smcap.supcap_loja                  AS loja,
                   smcap.supcap_caixa                 AS caixa,
                   smcap.supcap_nro_cupom             AS coo,
                   smcap.supcap_tipo                  AS tipo
            FROM supervisor_mov_corpos      AS smcor
            INNER JOIN supervisor_mov_capa  AS smcap ON smcap.id = smcor.supcor_capa_id
            LEFT  JOIN supervisor_cad_itens AS sci   ON sci.supite_codigo_item = smcor.supcor_item
            WHERE smcap.supcap_data_cupom >= '{data_inicio}'
              AND smcap.supcap_data_cupom <= '{data_fim}'
              {cond_itens}
              {cond_promocoes}
              AND smcor.supcor_id_promo IS NOT NULL
              AND smcap.supcap_tipo IN ('V', 'C')
              {cond_tipo_promo}
              {cond_pdv}
              {order_by}
        """.format(data_inicio=data_inicio,
                   data_fim=data_fim,
                   cond_tipo_promo=cond_tipo_promo,
                   cond_itens=cond_itens,
                   cond_pdv=cond_pdv,
                   cond_promocoes=cond_promocoes,
                   order_by=order_by)
        cr.execute(sql)
        return cr.dictfetchall()