#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _

TIPO_PROMOCAO = [('0','Todos'),
                 ('1','Scanntech'),
                 ('2', _('Propria'))]

TIPO_ORDENACAO = [('0',_('Promocao')),
                   ('1','Coo'),
                   ('2','Produto(A-Z)')]

class supervisor_cad_promo_capa(osv.TransientModel):
    """
    Prefixo: suprep
    """
    _name = 'supervisor.relatorio.promocoes'
    _columns = {
        'suprep_data_inico': fields.date('Periodo inicial', required=True),
        'suprep_data_fim': fields.date('Periodo final', required=True),
        'suprep_pdv_ids': fields.many2many('supervisor.cad.pdvs', 'supervisor_pdv_rel_pdvs_promo',
                                           'id', 'pdv_id', 'PDVs', required=True),
        'suprep_tipo_promocao': fields.selection(TIPO_PROMOCAO, "Tipo de promocao",  size=1,
                                                 required=True),
        'suprep_itens_ids': fields.many2many('supervisor.cad.itens', 'supervisor_rel_itens_promo',
                                           'id', 'item_id', 'Itens'),
        'suprep_promocoes_ids': fields.many2many('supervisor.cad.promo_capa', 'supervisor_rel_capa_promo',
                                           'id', 'promo_id', 'Promocoes'),

        'suprep_ordenar': fields.selection(TIPO_ORDENACAO, "Ordenar por",  size=1, required=True),
    }

    _defaults = {
        'suprep_pdv_ids': lambda s, cr, uid, c: s.pool.get('supervisor.cad.pdvs').search(cr, uid, [],
                                                                                  context=c),
        'suprep_tipo_promocao': '0',
        'suprep_ordenar': '0',
    }
