# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class wizard_supervisor_reexportar_arq(osv.TransientModel):

    _name = "wizard.supervisor.reexportar.arq"

    _columns = {
        'wizexa_data_ini': fields.date('Data inicial', required=True),
        'wizexa_data_fim': fields.date('Data final', required=True),
        'wizexa_fechamento': fields.boolean('Incluir fechamento'),
        'wizexa_log': fields.text('Log'),

    }

    def wizexa_onchange_data(self, cr, uid, ids, data_ini, data_fim, op, context=None):
        context = context and context.copy() or {}
        res = {}
        if not (data_ini and data_fim):
            return res

        if data_ini > data_fim:
            vals = {}
            warning = {'title': _('Atencao!')}
            if op == 1:
                vals['wizexa_data_ini'] = None
                warning['message'] = _('Data Inicial nao pode ser maior que a data Final!')
            else:
                vals['wizexa_data_fim'] = None
                warning['message'] = _('Data Final nao pode ser menor que a data Inicial!')

            res['value'] = vals
            res['warning'] = warning

        return res

    def wizexa_button_reexportar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        brw = self.browse(cr, uid, ids[0], context)
        sql = """UPDATE supervisor_mov_capa 
                 SET scanntech = 0 
                 WHERE supcap_data_cupom >= '{ini}'
                   AND supcap_data_cupom <= '{fim}'
              """.format(ini=brw.wizexa_data_ini, fim=brw.wizexa_data_fim)
        cr.execute(sql)
        context['supcap_exp_manual'] = {'ini': brw.wizexa_data_ini,
                                        'fim': brw.wizexa_data_fim,
                                        'fechamento': brw.wizexa_fechamento,
                                        'export_id': ids}
        self.write(cr, uid, ids, {'wizexa_log': ''}, context)
        self.pool.get('supervisor.mov.capa').funcao_supcap_exporta_notas_pif(cr, uid, context)
        return True
