#!/usr/bin/python
# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp.tools.translate import _


class supervisor_cad_sorteio(osv.Model):
    """
    Tabela de sorteios
    Prefixo: supsor

    """

    _name = 'supervisor.cad.sorteio'
    _gerar_logs_logs = 'N'
    _columns = {
        'supsor_data_inicio': fields.date('Data inicial', required=True, select=True),
        'supsor_data_fim': fields.date('Data Final', required=True, select=True),
        'supsor_valor': fields.float('Valor', required=True,  digits=(10, 2),
                                     help=_('Valor minimo de compra necessario para ganhar um '
                                            'cupom')),
        'supsor_descricao': fields.text('Descricao', required=True),
        'state': fields.selection([('1', 'Esboco'),
                                   ('2', 'Ativo')], 'Estado', select=True, size=1)
    }

    _defaults = {
        'state': '1',
    }