# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
import time
from openerp.tools.translate import _
from datetime import date
from smtplib import SMTP
from email.mime.text import MIMEText as mtext

READ_LOAD = '_classic_write'

READ_LOAD = '_classic_write'


class tarefas_tarefas(osv.Model):
    _name = "tarefas.tarefas"
    _inherit = "tarefas.tarefas"

    def tarefas_send_email(self, cr, uid, ids, context):

        if isinstance(ids, (int, long)):
            ids = [ids]

        fields_to_read = ['tar_remetente_email', 'tar_destinatario_email', 'name', 'descricao', 'avisar']

        tarefa_dados = self.read(cr, uid, ids, fields_to_read, context=context, load=READ_LOAD)
        if tarefa_dados:
            tarefa_avisar_dados = filter(lambda i: i.get('avisar') is True, tarefa_dados)
            if tarefa_avisar_dados:
                obj_mail_server = self.pool.get('ir.mail_server')

                # obj_mail = self.pool.get('mail.mail')
                for i in tarefa_avisar_dados:
                    texto = unicode(i.get('descricao') or '** Sem nenhuma descricao **')

                    remetente_email = i.get('tar_remetente_email')
                    assunto = 'Tarefa a ser atendida: %s ' % (i.get('name') or '** Assunto nao especificado **')
                    destinatario_email = i.get('tar_destinatario_email')

                    server_ids = obj_mail_server.search(cr, uid, [('smtp_user', '=', remetente_email)], context=context)
                    if not server_ids:
                        raise osv.except_osv(
                            'SigERP', 'Remetente nao cadastrado nas configuracoes do servidor de saida.'
                        )
                    else:
                        server_dados = obj_mail_server.read(
                            cr, uid, server_ids[0], ['smtp_pass', 'smtp_host', 'smtp_port'], context=context
                        )
                        if server_dados and isinstance(server_dados, list):
                            server_dados = server_dados[0]
                        if isinstance(server_dados, dict):
                            smtp_user_password = server_dados.get('smtp_pass')
                            smtp_host = server_dados.get('smtp_host')
                            smtp_port = server_dados.get('smtp_port')

                            erro_dados = ''
                            if not smtp_user_password:
                                erro_dados += 'Senha do remetente nao cadastrada, '
                            if not smtp_host:
                                erro_dados += 'Host nao informado, '
                            if not smtp_port:
                                erro_dados += 'Porta nao informada'

                            if erro_dados:
                                raise osv.except_osv(
                                    'Erro no cadastro de configuracoes do Servidor de Saida', erro_dados
                                )

                            # FORMATA A MENSAGEM PARA ENVIO
                            msg = mtext(texto, 'plain', 'UTF-8')
                            msg['Subject'] = assunto
                            msg['From'] = remetente_email
                            msg['To'] = destinatario_email

                            # CONECTA NO SERVIDOR
                            try:
                                server_smtp = SMTP(smtp_host, smtp_port)
                            except Exception as e:
                                erro_conect_server = e.message
                                raise osv.except_osv('Erro ao conectar com o servidor', erro_conect_server)

                            try:
                                # CRIPTOGRAFIA TLS
                                server_smtp.starttls()
                                # EFETUA O LOGIN DO USUARIO NO SERVIDOR
                                server_smtp.login(remetente_email, smtp_user_password)
                                # ENVIA O EMAIL
                                server_smtp.sendmail(remetente_email, destinatario_email, msg.as_string())
                            except Exception as e:
                                erro = e.message
                                raise osv.except_osv('Erro ao enviar o email', erro)
                            finally:
                                # FECHA CONEXÃO COM O SERVIDOR
                                server_smtp.close()
        return True

    def _run(self, cr, uid, ids=None, use_new_cursor=False, context=None):
        context = context and context.copy() or {}
        print 'Tarefas', time.strftime('%Y-%m-%d %H:%M:%S')
        return {}

    def read(self, cr, uid, ids, fields={}, context=None, load='_classic_read'):

        '''Quando o usuario le a tarefa que foi delegada a ele, salva-se a data de leitura e o campo "lida", e mudado para True'''

        context = context and context.copy() or {}
        if fields is None:
            fields = {}

        res = super(tarefas_tarefas, self).read(cr, uid, ids, fields=fields, context=context, load=load)

        if 'descricao' in fields and context.get('leitura'):

            if not isinstance(res, list):
                res = [res]
            records_to_write = []
            for i in res:
                id = i['id']
                # EM ALGUNS CASOS O CAMPO PARA_UID VEM COMO INTEIRO E EM OUTROS VEM COMO TUPLA
                # POR ISSO O TESTE ESTA SENDO FEITO, PORQUE OCORRE NÃO SEI.
                para_uid = i.get('para_uid') or False
                if isinstance(para_uid, tuple):
                    para_uid = para_uid[0] or False
                data_lida = i.get('data_lida')
                if para_uid == uid and not data_lida:
                    records_to_write.append(id)
            if records_to_write:
                self.write(cr, uid, records_to_write, {'lida': True, 'data_lida': time.strftime('%Y-%m-%d %H:%M:%S')},
                           context)

        return res

    def create(self, cr, uid, vals, context=None):

        '''Quando o usuario cria uma tarefa e marca avisar ele gera uma acao agendada'''

        context = context and context.copy() or {}
        tarefa_id = super(tarefas_tarefas, self).create(cr, uid, vals, context=context)
        if tarefa_id:
            self.tarefas_send_email(cr, uid, tarefa_id, context)
        if vals.get('avisar', False):
            if vals.get('data_agenda', False):
                date = vals['data_agenda']
            else:
                date = time.strftime('%Y-%m-%d 00:00:00')

            cron_obj = self.pool.get('ir.cron')
            data = {
                'name': "Lembrete Tarefa: " + vals['name'],
                'user_id': vals['para_uid'],
                'nextcall': date,
                'model': 'tarefas.tarefas',
                'function': '_lembrete',
                'interval_number': 1,
                'interval_type': 'days',
                'numbercall': 1,
                'priority': 1,
                'args': (int(str(tarefa_id)),),
            }
            cron_obj.create(cr, uid, data, context)
        return tarefa_id

    def _lembrete(self, cr, uid, ids=None, use_new_cursor=False, context=None):
        '''
            Essa funcao e executada quando chega a data e hora agendada da tarefa, gerando um
            chamado "request" para o usuario que foi delegada a tarefa e logo apos excluindo a acao do ir.cron
        '''
        context = context and context.copy() or {}
        if ids:
            tarefa_id = ids
            # request = self.pool.get('res.request')
            try:
                assunto = self.pool.get('tarefas.tarefas').read(cr, uid, tarefa_id, ['name'], context=context)['name']
                para = \
                    self.pool.get('tarefas.tarefas').read(cr, uid, tarefa_id, ['para_uid'], context=context)[
                        'para_uid'][0]
                de = self.pool.get('tarefas.tarefas').read(cr, uid, tarefa_id, ['de_uid'], context=context)['de_uid'][0]
                body = \
                    self.pool.get('tarefas.tarefas').read(cr, uid, tarefa_id, ['descricao'], context=context)[
                        'descricao'][
                        0]
                resolvido = self.pool.get('tarefas.tarefas').read(cr, uid, tarefa_id, ['resolvido'], context=context)[
                    'resolvido']
                if type(resolvido) == "<type 'list'>":
                    resolvido = resolvido[0]

                # if not resolvido:
                #     request.create(cr, uid, {
                #         'name': 'Lembrete Atividade: ' + assunto,
                #         'body': body + '\nEsta Atividade esta no prazo de vencimento ',
                #         'state': 'waiting',
                #         'act_from': de,
                #         'act_to': para,
                #     }, context)
            except:
                pass
            a = '(%d,)' % tarefa_id
            cron_obj = self.pool.get('ir.cron')
            b = cron_obj.search(cr, uid, [('args', '=', a)], context=context)
            if b:
                cron_obj.unlink(cr, uid, b)

                #         print 'exec---', time.strftime('%Y-%m-%d %H:%M:%S')
        return {}

    def write(self, cr, uid, ids, vals, context=None):

        '''Quando altera e pedir para avisar gera uma acao agendada '''
        context = context and context.copy() or {}
        if vals.get('resolvido', False):
            vals['data_resolvido'] = time.strftime('%Y-%m-%d %H:%M:%S')
            print 'tem', vals['data_resolvido']
        else:
            vals['data_resolvido'] = None
            print 'nao tem'
        if not vals.get('resolvido', False):
            avisar_old = self.read(cr, uid, ids, ['avisar'], context=context)[0]['avisar']
            avisar_new = vals.get('avisar', False)
            data_agenda_old = self.read(cr, uid, ids, ['data_agenda'], context=context)[0]['data_agenda']
            data_agenda_new = vals.get('data_agenda')
            nome = self.read(cr, uid, ids, ['name'], context=context)[0]['name']
            para = self.read(cr, uid, ids, ['para_uid'], context=context)[0]['para_uid'][0]
            cron_obj = self.pool.get('ir.cron')
            id = ids[0]
            arg = '(' + str(id) + ',)'

            if not data_agenda_old:
                data_agenda_old = time.strftime('%Y-%m-%d %H:%M:%S')

            if not data_agenda_new:
                data_agenda_new = data_agenda_old

            data_agenda_old = data_agenda_old
            data_agenda_new = data_agenda_new

            data = {
                'name': "Lembrete Atividade: " + nome,
                'user_id': para,
                'nextcall': data_agenda_new,
                'model': 'tarefas.tarefas',
                'function': '_lembrete',
                'interval_number': 1,
                'interval_type': 'days',
                'numbercall': 1,
                'priority': 1,
                'args': (int(str(id)),),
            }

            if avisar_new and not avisar_old:
                id = ids[0]
                cron_obj.create(cr, uid, data, context)
                print 'criar acao'
            if avisar_new and avisar_old and data_agenda_new != data_agenda_old:
                busca = cron_obj.search(cr, uid, [('args', '=', arg)], context=context)
                if busca:
                    cron_obj.write(cr, uid, busca, {'nextcall': data_agenda_new}, context)
                else:
                    cron_obj.create(cr, uid, data, context)
                print '#### Alterar Data'
            if not avisar_new and avisar_old:
                busca = cron_obj.search(cr, uid, [('args', '=', arg)], context=context)
                if busca:
                    cron_obj.unlink(cr, uid, busca)
                print '### Excluir Aviso'

        res = super(tarefas_tarefas, self).write(cr, uid, ids, vals, context=context)
        if vals.get('avisar'):
            self.tarefas_send_email(cr, uid, ids, context)
        return res

    # def unlink(self, cr, uid, ids, context= {}):
    #
    #     '''Verifica se o usuario logado e criador da tarefa, se nao for nao permite excluir'''
    #
    #     a = self.pool.get('tarefas.tarefas').read(cr,uid,ids,['de_uid'])
    #     if a[0]['de_uid'][0] != uid:
    #            raise osv.except_osv(_('Erro:'),
    #                     _('Voce nao tem permissao para excluir esta tarefa!'))
    #
    #     '''Verifica se existe uma acao agendada para esta tarefa, e se existir  exclui a acao'''
    #     id = ids[0]
    #     arg= '('+str(id)+',)'
    #     cron_obj = self.pool.get('ir.cron')
    #     busca = cron_obj.search(cr,uid,[('args','=',arg)])
    #     if busca:
    #         cron_obj.unlink(cr, uid,busca)
    #
    #     return super(tarefas_tarefas,self).unlink(cr, uid, ids, context)

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):

        '''Mostra as tarefas do usuario logado  e as tarefas dos usuarios que compartilharam com o usuario logado'''

        context = context and context.copy() or {}
        if context.get('todas', False):
            res = []

            com = self.pool.get('tarefas.compartilhamento').search(cr, uid, [('compartilhar_com_uid', '=', uid)],
                                                                   context=context)
            dono = self.pool.get('tarefas.compartilhamento').read(cr, uid, com, ['dono_uid'], context=context)
            ids = []
            for i in dono:
                ids.append(i['dono_uid'][0])

            ids.append(uid)
            args += ['|', ('para_uid', 'in', ids)]
            args += [('de_uid', '=', uid)]
            res = super(tarefas_tarefas, self).search(cr, uid, args, context=context)

        else:
            res = super(tarefas_tarefas, self).search(cr, uid, args, offset, limit, order, context=context, count=count)
        return res
