# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import fields, osv
from funcoes import tarefa_get_pessoa_email


class tarefas_tarefas(osv.Model):
    """
    Tarefas de cada usuario
    """
    from funcoes import tarefa_get_pessoa_email

    _name = "tarefas.tarefas"
    _columns = {

        #____________________ integer _______________________
        'sequence': fields.integer('Sequencia'),  # Sequencia para atendimento das tarefas

        #____________________ boolean _______________________
        'lida': fields.boolean('Lida'),  # Indica que a tarefa foi lida pela pessoa para quem foi delegada
        'avisar': fields.boolean('Avisar'),  # Indica que e para avisar quem vai executar
        'resolvido': fields.boolean('Resolvido', select=1),  # Indica que a tarefa ja foi resolvida

        #____________________ char _______________________
        'name': fields.char('Assunto', size=60, select=True, required=True),  # Assunto da tarefa
        'descricao': fields.text('Descricao', required=True),  # Descricao da tarefa

        #____________________ datetime _______________________
        'data_lida': fields.datetime("Data que foi lida"),  # Data para a execucao da tarefa
        # ATENÇÃO: CAMPO [data_agenda] NÃO PODE SER DATETIME, POIS GERA LENTIDAO NO DOMAIN DA AÇÃO. > LUIS PAULO
        'data_agenda': fields.date("Data Agendada", select=1),  # Data para a execucao da tarefa
        'data_resolvido': fields.datetime('Data da solucao'),  # Data em que o problema foi resolvido

        #____________________ date _______________________
        'create_date': fields.date('Data Inclusao'),  # data de criacao da tarefa

        #____________________ selection _______________________
        'prioridade': fields.selection([('B', 'Baixa'), ('M', 'Media'), ('A', 'Alta')], 'Prioridade', required=True, size=1),

        #____________________ function _______________________
        'tar_destinatario_email': fields.function(tarefa_get_pessoa_email, method=True, string="Email", store=False,
                                                  type="char", size=64, arg="destinatario_email"),
        'tar_remetente_email': fields.function(tarefa_get_pessoa_email, method=True, string="Email", store=False,
                                               type="char", size=64, arg="remetente_email"),

        #____________________ many2one _______________________
        'de_uid': fields.many2one('res.users', "De", readonly=True, ondelete="restrict", select=1),  # Dono da tarefa
        'para_uid': fields.many2one('res.users', "Para", required=True, ondelete="restrict", select=1),  # Pessoa para quem a tarefa foi delegada
        'pessoa_id': fields.many2one('adm.pessoa', 'Parceiro', ondelete="restrict", select=1),  # Indica que a tarefa e relacionada a um parceiro
    }

    _order = 'resolvido, data_agenda desc, para_uid, sequence'
    _defaults = {
        'de_uid': lambda obj, cr, uid, context: uid,
        'prioridade': lambda *a: 'B',
        'resolvido': lambda *a: False,
        'sequence': lambda *a: 10,
    }
