# -*- coding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _
from dateutil.parser import parse
import requests
import urllib2
from openerp.tools import config


class taxpertise_utils(osv.Model):
    _name = 'taxpertise.utils'

    def taxutl_consulta_webservice(self, cr, uid, dt_filtro=False, ean=False, ncm=False,
                                   context=None):
        """
        Metodo responsavel por realizar a consulta com o webservice classifisco.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param dt_filtro: ultima data de atualizacao da tributacao junto ao classifisco.
        :type dt_filtro: str
        :param ean: sequencia de caracteres referente a um codigo de barras.
        :type ean: str
        :param ncm: sequencia de caracteres referente a um NCM.
        :type ncm: str
        :param context: dados contextuais.
        :type context: dict
        :return: Xml com os dados procesados pelo webservice, caso a consulta seja realizada
        corretamente. Senao, mensagem que informara possivel problema/erro.
        """
        obj_adm_utils = self.pool.get('adm.utils')
        list_parametros = ['estpar_taxpertise_idintegracao', 'estpar_taxpertise_idcliente',
                           'estpar_taxpertise_token']
        estoque_parametro_dados = obj_adm_utils.admutl_get_parametros(
            cr, uid, 'estoque', list_parametros, context=context)
        if not all(estoque_parametro_dados.values()):
            raise osv.except_osv(_('Atencao'), _("Cadastre todos os dados da aba 'Taxpertise' nos "
                                                 "parametros do estoque."))
        if not any([dt_filtro, ean, ncm]):
            raise osv.except_osv(_('Atencao'), _('Deve ser informado uma data de atualizacao, '
                                                 'codigo de barras ou NCM.'))
        list_dados_conexao = [
            '?idIntegracao=' + estoque_parametro_dados.get('estpar_taxpertise_idintegracao'),
            '&idCliente=' + estoque_parametro_dados.get('estpar_taxpertise_idcliente'),
            '&token=' + estoque_parametro_dados.get('estpar_taxpertise_token')]

        if dt_filtro:
            dt_filtro = parse(dt_filtro).strftime('%d/%m/%Y')
            list_dados_conexao.append('&dtFiltro=' + dt_filtro)
        elif ean:
            list_dados_conexao.append('&ean=' + ean)
        else:
            list_dados_conexao.append('&ncm=' + ncm)

        url = 'http://figurafiscal.com.br/webservice/' + ''.join(list_dados_conexao)
        proxy = config.options.get('http_proxy')
        if proxy:
            proxy_handler = urllib2.ProxyHandler({'http': proxy})
            opener = urllib2.build_opener(proxy_handler)
            urllib2.install_opener(opener)
        res = urllib2.Request(url)
        try:
            res = urllib2.urlopen(res)
        except Exception as e:
            msg = ''
            if e.code == 305:
                msg += ' Verifique as configuracoes de proxy.'
            raise osv.except_osv(_('Atencao'), str(e) + msg)
        str_xml = res.read()
        return str_xml
