# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

import time
from openerp.osv import fields
from openerp.osv import osv
from openerp import pooler
from openerp import tools
from datetime import date,datetime
from openerp.tools.translate import _
class estoqueressuprimento_troca_itens(osv.Model):
    _name = 'estoqueressuprimento.troca.itens'
    _inherit = 'estoqueressuprimento.troca.itens'
        
    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        res = super(estoqueressuprimento_troca_itens, self).create(cr, uid, vals, context)
        if vals.get('troca_id') and res:
            numero_os = self.pool.get('estoqueressuprimento.requisicao.capa').read(cr, uid, vals['troca_id'],['numero_os'], context=context)
            if numero_os:
                numero_os = numero_os['numero_os'][0]
                obj_rma_produto = self.pool.get('rma.produto')
                args = [('produto_id','=',vals['produto_antigo_id']),('ordem_id','=',numero_os)]
                if vals.get('nro_serie_antigo'):
                    args.append(('numero_serie','=',vals['nro_serie_antigo']))
                rma_produto_ids = obj_rma_produto.search(cr, uid, args, context=context)
                if rma_produto_ids:
                    obj_rma_produto.write(cr, uid, rma_produto_ids[0],{'rma_produto_troca_id':int(res)}, context=context)
        return res
    
    def onchange_garantia(self,cr,uid,ids,produto_antigo_id, context=None):
        context = context and context.copy() or {}
        garantia_loja=[]
        warning={}
        hoje = date.today()#data atual
        obj_nf = self.pool.get('fiscal.nf.capa')
        obj_mov = self.pool.get('estoque.movimento.itens')
        obj_garan = self.pool.get('estoque.produto')
        if produto_antigo_id:
            id_itens = obj_mov.search(cr,uid,[('produto_id','=',produto_antigo_id)], context=context)
            id_nf = obj_mov.read(cr,uid,id_itens,['nf_id'], context=context)[0]['nf_id'][0]
            data_emissao = obj_nf.read(cr,uid,id_nf,['data_emissao'], context=context)['data_emissao']
            if garantia_loja:
                garantia_loja = obj_garan.read(cr,uid,produto_antigo_id,['garantia_loja'], context=context)['garantia_loja']
                calc= hoje - datetime.strptime(data_emissao,'%Y-%m-%d').date()
                if calc.days > garantia_loja:
                      warning['title'] = 'SiGERP'
                      warning['message'] = 'Produto fora da garantia da loja!'
        return {'value':{'produto_antigo_id':produto_antigo_id},'warning': warning}
    
    def onchange_nro_serie(self, cr, uid, ids,produto_antigo_id,nro_serie_antigo, context=None):
        context = context and context.copy() or {}
        warning={}
        dbname = pooler.get_pool(cr.dbname)
       ## BUSCA A EMPRESA E SE PRODUTO TEM CONTROLE DE NUMERO DE SERIE 
        estoque_produto = dbname.get('estoque.produto').read(cr,uid,produto_antigo_id,['controle_ns','company_id'], context=context)
        if estoque_produto.get('company_id'):            
        ## BUSCA SE O PARAMETRO PARA CONTROLAR NUMERO DE SERIE ESTA MARCADO (TRUE)
            parametro_serie = dbname.get('estoque.parametro').search(cr,uid,[], context=context)
            if parametro_serie:
                usa_numero_serie = dbname.get('estoque.parametro').read(cr,uid,parametro_serie,['usa_numero_serie'], context=context)[0]['usa_numero_serie']
                if usa_numero_serie:
                    if estoque_produto['controle_ns']:
                        series_cadastradas = dbname.get('estoqueserie.produto').search(cr,uid,[('produto_id','=',produto_antigo_id),('nro_serie','=',nro_serie_antigo)], context=context)
                        if not series_cadastradas:
                             warning['title'] = 'SiGERP'
                             warning['message'] = 'Nro Serie nao corresponde com o produto informado!'
              
                                        
        return {'value':{'produto_antigo_id':produto_antigo_id},'warning': warning}
    
