# -*- encoding: utf-8 -*-
from openerp.osv import fields, osv
from datetime import datetime


class wizard_fornecedor_capa(osv.TransientModel):
    _name = "wizard.fornecedor.capa"
    _columns = {
        'fornecedor_id' : fields.many2one('financeiro.fornecedor', "Fornecedor", select=True),
        'troca_capa_ids' : fields.one2many('wizard.fornecedor.trocas', 'troca_capa_id', 'Troca_itens')
        }

    def button_gerar_nf(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_wizard_troca = self.pool.get('wizard.fornecedor.trocas') # TABELA
        # BUSCA O ID DO FORNECEDOR
        fornecedor_id = self.read(cr, uid, ids[0], ['fornecedor_id'])
        if fornecedor_id:
            # BUSCA O ID DOS ITENS LANÇADOS
            itens_id = obj_wizard_troca.search(cr, uid, [('troca_capa_id', '=', fornecedor_id.get('id'))])
            if itens_id:
                itens_data = obj_wizard_troca.read(cr, uid, itens_id, ['produto_id'])
                if itens_data:
                    produtos_ids = []
                    for i in itens_data:
                        # MONTA UM LIST APENAS COM OS IDS, POIS O RETORNO TRAS O ID E O NOME
                        produtos_ids.append(i['produto_id'])
#################### MONTAGEM DA CAPA NOTA FISCAL
                    company_id = self.pool.get('res.users').browse(cr, uid, uid, context=context).company_id.id
                    if company_id:
                        obj_parametro = self.pool.get('fiscal.parametro') # TABELA
                        parametro_id = obj_parametro.search(cr, uid, [])
                        if parametro_id:
                            modelo_nf = obj_parametro.read(cr, uid, parametro_id[0], ['modelo_nf_series_id'])
                            pessoa_id = self.pool.get('financeiro.fornecedor').read(cr, uid, fornecedor_id['fornecedor_id'], ['pessoa_id'])
                            if pessoa_id:
                                obj_nf = self.pool.get('fiscal.nf.capa') # TABELA
                                fornecedor_endereco = obj_nf.onchange_destinatario(cr, uid, ids, 'S', pessoa_id['pessoa_id'][0], company_id)
                                # dict: {'warning': {}, 'value': {'gerar_xml': True, 'destinatario_endereco_id': 359}}
                                if fornecedor_endereco:
                                    condicao_pgto = self.pool.get('adm.condicao').read(cr, uid, 1) # FICOU DECIDIDO QUE A CONDIÇÃO A SER GERADA FICARA SENDO A PRIMEIRA CRIADA
                                    if condicao_pgto:
                                        nf_capa_id = obj_nf.create(cr, uid, {
                                                                        'tipo':'S',
                                                                        'company_id': company_id,
                                                                        'destinatario_id': pessoa_id['pessoa_id'][0],
                                                                        'destinatario_endereco_id': fornecedor_endereco['value']['destinatario_endereco_id'],
                                                                        'modelo_nf_series_id': modelo_nf['modelo_nf_series_id'][0],
                                                                        'condicao_pgto_id':1
                                                                        }, context)
####################################### MONTAGEM DOS ITENS NOTA FISCAL
                                        obj_requisicao = self.pool.get('estoqueressuprimento.requisicao.capa')
                                        # BUSCA TODAS AS TROCAS QUE PODEM SER TROCADAS
                                        requisicao_id = obj_requisicao.search(cr, uid, [('tipo', '=', 'TR'), ('state', '=', 'O')])
                                        if requisicao_id:
                                            obj_troca = self.pool.get('estoqueressuprimento.troca.itens')
                                            # BUSCA TODOS OS ITENS DAS TROCAS QUE PODEM SER TROCADOS
                                            troca_id = obj_troca.search(cr, uid, [('troca_id', 'in', requisicao_id), ('state', '=', 'E'),
                                                                                  ('produto_antigo_id', 'in', produtos_ids)])
                                            if troca_id:
                                                # LE O ID DA CAPA DE ONDE ESTÃO OS ITENS
                                                troca_id = obj_troca.read(cr, uid, troca_id, ['troca_id'])
                                                troca_list_ids = []
                                                for i in troca_id:
                                                    # GERA UMA LISTA COM OS IDS DA CAPA DA TROCA_ITENS
                                                    troca_list_ids.append(i['troca_id'][0])
                                                # REMOVE OS IDS REPITIDOS
                                                troca_list_ids = list(set(troca_list_ids))
                                                # BUSCA O ID DA TROCA DE ACORDO COM OS ITENS, É FEITO PARA QUE NÃO HAJA TROCAS SEM QUE OS PRODUTOS ESTEJAM NO STATUS PARA TROCAR
                                                numero_os = obj_requisicao.search(cr, uid, [('id', 'in', troca_list_ids)])
                                                if numero_os:
                                                    faturar_produto_ids = tuple(obj_troca.search(cr, uid, [('troca_id', 'in', numero_os), ('state', '=', 'E'),
                                                                                                 ('produto_antigo_id', 'in', produtos_ids)]))
                                                    troca_produtos_ids = list(faturar_produto_ids)
                                                    numero_os = obj_requisicao.read(cr, uid, numero_os, ['numero_os'])
                                                    numero_nf = []
                                                    nf_id = []
                                                    cont = 0
                                                    obj_ordem = self.pool.get('ordem.servico')
                                                    for i in numero_os:
                                                        numero_nf.append(obj_ordem.read(cr, uid, i['numero_os'][0], ['nf_id']))
                                                        if numero_nf[cont]['nf_id']:
                                                            nf_id.append((numero_nf[cont]['nf_id'][0], i['numero_os'][0]))
                                                        cont += 1
                                                    numero_os = []
                                                    numero_nf = []
                                                    obj_mov = self.pool.get('estoque.movimento.itens')
                                                    obj_serie = self.pool.get('estoqueserie.produto')
                                                    valor_total = 0
                                                    obs = ""
                                                    serie_produtos = []
                                                    for i in nf_id: # PARA CADA NOTA FISCAL
                                                        nf_itens_id = obj_mov.search(cr, uid, [('nf_id', '=', i[0]), ('produto_id', 'in', produtos_ids)])
                                                        if nf_itens_id:
                                                            obs = obs + "OS: " + str(i[1]) + ", "
                                                            for j in nf_itens_id: # PARA CADA ITEM DA NOTA FISCAL
                                                                res = obj_mov.copy_data(cr, uid, j, default={}, context={})
                                                                if res:
                                                                    produto_serie = res['produto_id']
                                                                    res['nf_id'] = nf_capa_id
                                                                    res['quantidade'] = 1
                                                                    res['vr_total_item'] = res['vr_unitario']
                                                                    res['vr_desconto'] = 0

                                                                    valor_total += res[ 'vr_total_item']

                                                                    if not res['sequencia']:
                                                                        res['sequencia'] = 0

                                                                    if not res['tributacoes_ids']:
                                                                        res['tributacoes_ids'] = 0

                                                                    if not res['locacao_id']:
                                                                        del res['locacao_id']

                                                                    if not res['produto_embalagem_id']:
                                                                        res['produto_embalagem_id'] = 0

                                                                    if not res['natureza_id']:
                                                                        res['natureza_id'] = 0

                                                                    if not res['grade_id']:
                                                                        res['grade_id'] = 0

                                                                    if not res['vr_preco_venda']:
                                                                        res['vr_preco_venda'] = 0

                                                                    if not res['local_id']:
                                                                        res['local_id'] = 0

                                                                    if not res['cfop_id']:
                                                                        res['cfop_id'] = 0

                                                                    if not res['movimento_serie_ids']:
                                                                        res['movimento_serie_ids'] = 0

                                                                    if not res['capa_id']:
                                                                        res['capa_id'] = 0

                                                                    if not res['verifica_usa_grade']:
                                                                        res['verifica_usa_grade'] = 0

                                                                    mov_id = obj_mov.create(cr, uid, res, context)
                                                                    obs = obs + str(produto_serie)
    ############################################################### MONTAGEM DA SERIES DA NOTA FISCAL
                                                                    if mov_id:
                                                                        if troca_produtos_ids:
                                                                            for l in troca_produtos_ids:

                                                                                serie_produtos = obj_troca.read(cr, uid, l, ['nro_serie_antigo', 'produto_antigo_id'])
                                                                                series = ""
                                                                                if serie_produtos.get('nro_serie_antigo'):
                                                                                    serie_id = obj_serie.search(cr, uid, [('movimento_itens_id', '=', j),
                                                                                                                          ('produto_id', '=', serie_produtos['produto_antigo_id'][0]),
                                                                                                                          ('nro_serie', '=', serie_produtos['nro_serie_antigo'])])
                                                                                    if serie_id:
                                                                                        res_serie = obj_serie.read(cr, uid, serie_id[0], ['nro_serie'])
                                                                                        if res_serie:
                                                                                            res_serie['movimento_itens_id'] = mov_id
                                                                                            if 'id' in res_serie:
                                                                                                del res_serie['id']
                                                                                            res_serie['status'] = 'R'
                                                                                            res_serie['produto_id'] = produto_serie
                                                                                            res_serie['grade_id'] = obj_mov.browse(cr, uid, mov_id).grade_id.id
                                                                                            res_serie['data_operacao'] = datetime.now().strftime('%d-%m-%Y'' ''%H:%M:%S')
                                                                                            context['troca_serie'] = True
                                                                                            obj_serie.create(cr, uid, res_serie, context)
                                                                                            context['troca_serie'] = False
                                                                                            series = series + str(res_serie['nro_serie'])
                                                                                            troca_produtos_ids.remove(l)
                                                                            obs = obs + "/ " + series + "; "

                                                    if nf_capa_id:
                                                        obj_nf.write(cr, uid, nf_capa_id, {'vr_total_nf':valor_total, 'observacao':obs}, context)
                                                    if faturar_produto_ids:
                                                        obj_troca.write(cr, uid, faturar_produto_ids, {'state':'NF'}, context)
                                            else:
                                                raise osv.except_osv(('Atencao'), ('Os produtos informados ja foram faturados.'))
                                        else:
                                            raise osv.except_osv(('Atencao'), ('Nenhuma troca com o status - Entregue foi encontrada para gerar uma Nota Fiscal'))
                                    else:
                                        raise osv.except_osv(('Atencao'), ('E necessario cadastrar uma condicao de Pagamento no modulo Administracao/Cadastros/Condicao.'))

        return True
wizard_fornecedor_capa()

class wizard_fornecedor_trocas(osv.TransientModel):
    _name = "wizard.fornecedor.trocas"
    _columns = {
        'troca_capa_id' : fields.many2one('wizard.fornecedor.capa', 'Troca'),
        'produto_id' : fields.many2one('estoque.produto', 'Produtos do Fornecedor'),
    }

wizard_fornecedor_trocas()

class estoque_produto(osv.Model):
    _name = "estoque.produto"
    _inherit = "estoque.produto"

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        res = []
        if context.get('view_troca_nf', False) and context.get('fornecedor_id', False):
            obj_fornecedor = self.pool.get('estoque.fornecedor') # TABELA
            fornecedor_id = obj_fornecedor.search(cr, uid, [('fornecedor_id', '=', context.get('fornecedor_id'))])
            if fornecedor_id:
                produtos_fornec_data = obj_fornecedor.read(cr, uid, fornecedor_id, ['produto_id'])
                if produtos_fornec_data:
                    produto_ids = []
                    for i in produtos_fornec_data:
                        produto_ids.append(i['produto_id'][0])
                    produtos_fornec_data = [] # PARA LIBERAR MEMORIA
                    obj_troca = self.pool.get('estoqueressuprimento.troca.itens') # TABELA
                    troca_itens_ids = obj_troca.search(cr, uid, [('produto_antigo_id', 'in', produto_ids), ('state', '=', 'E')])
                    if troca_itens_ids:
                        troca_itens_ids = list(set(troca_itens_ids))# RETORNA OS DADOS SEM REPETIÇÃO
                        if troca_itens_ids:
                            produto_ids = obj_troca.read(cr, uid, troca_itens_ids, ['produto_antigo_id'])
                            if produto_ids:
                                for i in produto_ids:
                                    res.append(i['produto_antigo_id'][0])
        else:
            res = super(estoque_produto, self).search(cr, uid, args, offset, limit, order, context, count)
        return res

