# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class trocas_documento_origem(osv.Model):
    # prefixo: trcdor_

    _inherit = 'trocas.documento.origem'

    def trcdor_seleciona_item(self, cr, uid, nf_id, context=None):
        """
        O metodo encontra na tabela estoque_movimento_itens todos os registros que se referem a
        essa nota fiscal (trcdor_nf_id). Os dados desses registro sao incluidos na tabela
        trocas_itens_entrada.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param context: dicionario com valores contextuais.
        :type context:dict
        :return: Lista dos itens para serem incluidas no atributo trcdor_itens_ids.
        :rtype: list
        """
        context = context and context.copy() or {}
        item_ids = []
        if not nf_id:
            return item_ids
        brw_fiscal_nf_capa = self.pool.get('fiscal.nf.capa').browse(cr, uid, nf_id, context)
        for movimento in brw_fiscal_nf_capa.estoque_movimento_itens_ids:
            item_ids.append((0, 0, {'trcien_movimento_item_id': movimento.id,
                                    'produto_id': movimento.produto_id.id,
                                    'grade_id': movimento.grade_id.id,
                                    'quantidade': movimento.quantidade,
                                    'trcien_quantidade_devolver': movimento.quantidade}))
        return item_ids

    def trcdor_onchange_nf_id(self, cr, uid, ids, nf_id, context=None):
        """
        O metodo insere os dados do movimento de itens no atributo 'trcdor_itens_ids' a partir da
        nota fiscal recebida (nf_id).
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param nf_id: id da nota fiscal, tabela fiscal_nf_capa
        :type nf_id: int
        :param context: dicionario com valores contextuais.
        :type context:dict
        :return:
        """
        context = context and context.copy() or {}
        res = {'value': {'trcdor_itens_ids': self.trcdor_seleciona_item(cr, uid, nf_id, context)}}
        return res
