# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _


class trocas_itens_entrada(osv.Model):
    # prefixo: trcien_

    _inherit = 'trocas.itens.entrada'

    def trcien_onchange_quantidade_devolver(self, cr, uid, ids, quantidade_movimento,
                                            quantidade_devolver, context=None):
        """
        O metodo e chamado na saida do atributo 'trcien_quantidade_devolver'. Informa ao usuario
        que o valor inserido em quantidade_devolver e invalido, caso seja maior que a
        quantidade_movimento.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto.
        :type ids: list
        :param quantidade_devolver: quantidade que se deseja devolver.
        :type quantidade_devolver: float
        :param quantidade_movimento: quantidade que foi movimentada, vendida.
        :type quantidade_movimento: float
        :param context: dicionario com valores contextuais.
        :type context:dict
        :return: dicionario com a descricao dos campos e seus respectivos valores e/ou mensagem de
        alerta ao usuario.
        """
        context = context and context.copy() or {}
        res = {}
        if not quantidade_devolver or (quantidade_devolver <= quantidade_movimento):
            return res
        res['warning'] = {'title': _('Atencao'),
                          'message': _('Quantidade a devolver deve ser menor ou igual a '
                                       'quantidade vendida')}
        res['value'] = {'trcien_quantidade_devolver': 0.0}
        return res

    def create(self, cr, uid, vals, context=None):
        """
        O metodo cria um novo registro na tabela desse objeto.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario.
        :type uid: int
        :param vals: dicionario com a descricao dos campos e seus respectivos valores.
        :type vals: dict
        :param context: dicionario com valores contextuais.
        :type context: dict
        :return: id do novo registro.
        :rtype: int
        """
        context = context and context.copy() or {}
        vals['trcien_capa_id'] = self.pool.get('trocas.documento.origem').read(
            cr, uid, vals.get('trcien_capa_origem_id'), ['trcdor_capa_id'], context,
            '_classic_write').get('trcdor_capa_id')
        res = super(trocas_itens_entrada, self).create(cr, uid, vals, context)
        return res
