# -*- encoding: utf-8 -*-

# FUNCOES DA CLASSE trocas_capa


def trccap_get_total_troca(self, cr, uid, ids, fields_name, arg, context=None):
    """
    O metodo calcula o valor total da troca. Esse valor e encontrado a partir do resultado da
    subtracao do total da entrada, do total da saida e do valor do desconto.
    :param cr: cursor no banco de dados.
    :type cr: object
    :param uid: id da tabela res_users, identificador do usuario.
    :type uid: int
    :param ids: lista de id da tabela desse objeto.
    :type ids: list
    :param fields_name: lista com a descricao dos campos funcionais.
    :type fields_name: list
    :param arg: lista dos argumentos de pesquisa.
    :type arg: list
    :param context: dicionario com valores contextuais.
    :type context: dict
    :return: dicionario com o id da tabela e o respectivo valor total da troca.
    :rtype: dict
    """
    context = context and context.copy() or {}
    res = {}
    for troca in self.browse(cr, uid, ids, context):
        itens_entrada = troca.trccap_itens_entrada_ids
        itens_saida = troca.trccap_itens_saida_ids
        total_entrada = sum(
            map(lambda i: (i.trcien_movimento_item_id.vr_unitario or 0) *
                i.trcien_quantidade_devolver, itens_entrada))
        total_saida = sum(map(lambda i: i.trcisa_valor_total, itens_saida))
        res[troca.id] = total_entrada - total_saida - troca.trccap_desconto
    return res