# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from funcoes import trccap_get_total_troca


class trocas_capa(osv.Model):
    # prefixo: trccap_

    _name = 'trocas.capa'

    _columns = {
        'trccap_pessoa_id': fields.many2one('adm.pessoa', 'Cliente', ondelete='restrict',
                                            required=True),
        'create_date': fields.datetime('Data da troca', readonly=True),
        'create_uid': fields.many2one('res.users', 'Usuario', readonly=True),
        'trccap_doc_origem_ids': fields.one2many('trocas.documento.origem', 'trcdor_capa_id',
                                                 'Origem'),
        'trccap_desconto': fields.float('Desconto na venda', digits=(11,2)),
        'trccap_total_troca': fields.function(trccap_get_total_troca, method=True,
                                              string='Total troca', type='float', digits=(15, 2)),
        'trccap_itens_entrada_ids': fields.one2many(
            'trocas.itens.entrada', 'trcien_capa_id', 'Itens entrando',
            domain=[('trcien_quantidade_devolver', '>', 0)]),
        'trccap_itens_saida_ids': fields.one2many('trocas.itens.saida', 'trcisa_capa_id',
                                                  'Itens saindo'),
        'state': fields.selection([('ES', 'Esboco'), ('VA', 'Validado'), ('EF', 'Efetivado'),
                                   ('CA', 'Cancelado')], 'Estado', size=2),
        'trccap_nf_ids': fields.many2many('fiscal.nf.capa', 'trocas_capa_m2m_nf_capa', 'troca_id',
                                          'nf_id', 'Nota fiscal'),
    }

    _defaults = {
        'state': lambda *a: 'ES',
    }

    _order = 'create_date DESC'