# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class trocas_itens_entrada(osv.Model):
    # prefixo: trcien_

    _name = 'trocas.itens.entrada'

    _inherits = {'estoque.movimento.itens': 'trcien_movimento_item_id',
                 'trocas.documento.origem': 'trcien_capa_origem_id'}

    _columns = {
        'trcien_capa_origem_id': fields.many2one('trocas.documento.origem', 'Origem',
                                                 required=True, select=True, ondelete='cascade',
                                                 oldname='trcien_capa_nf_origem_id'),
        'trcien_movimento_item_id': fields.many2one('estoque.movimento.itens', 'Item',
                                                    required=True,
                                                    domain=[('nf_id', '=', 'trcdor_nf_id')],
                                                    ondelete='restrict'),
        'trcien_quantidade_devolver': fields.float('Quantidade a devolver', required=True,
                                                   digits=(8, 3)),
        'trcien_capa_id': fields.related('trcien_capa_origem_id', 'trcdor_capa_id',
                                         type='many2one', relation='trocas.capa', store=True),
    }
