# -*- encoding: utf-8 -*-

from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _
from dateutil.parser import parse
from dateutil.relativedelta import relativedelta


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):

    def create(self, cr, uid, ids, datas, context=None):
        def center_title(e, c, d, t=150):
            title_c = (t - len(c)) / 2
            titulo = e
            for i in range(title_c - len(e)):
                titulo += ' '
            titulo += c
            for i in range(title_c - len(d)):
                titulo += ' '
            titulo += d
            return titulo

        context = context and context.copy() or {}
        title = center_title('', _('Trocas'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('impressao_trocas'))
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)
        listagem.defineFonte(tam=6.7)

        brw_trocas_capa = pooler.get_pool(cr.dbname).get('trocas.capa').browse(
            cr, uid, datas.get('troca_id'), context)
        data_troca = pooler.get_pool(cr.dbname).get('adm.utils').admutl_datetime_to_timezone(
            cr, uid, parse(brw_trocas_capa.create_date), '%d/%m/%Y %H:%M:%S')
        nota_entrada = ''
        entrada_nota_id = filter(lambda i: i.tipo == 'E', brw_trocas_capa.trccap_nf_ids)
        if entrada_nota_id:
            nota_entrada = entrada_nota_id[0].name
        nota_saida = ''
        saida_nota_id = filter(lambda i: i.tipo == 'S', brw_trocas_capa.trccap_nf_ids)
        if saida_nota_id:
            nota_saida = saida_nota_id[0].name
        state = brw_trocas_capa.state
        if state == 'ES':
            state = _('Esboco')
        elif state == 'VA':
            state = 'Validado'
        elif state == 'EF':
            state = 'Efetivado'
        else:
            state = 'Cancelado'

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'trocas.capa', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))

        docs1 = formataString('Cliente: %s' % brw_trocas_capa.trccap_pessoa_id.nome, 49, ' ', 'D',
                              'N', 'S')
        docs1 += formataString('Data da troca: %s' % data_troca, 46, ' ', 'D', 'N', 'S')
        docs1 += formataString('Usuario: %s' % brw_trocas_capa.create_uid.pessoa_id.nome, 47, ' ',
                               'D', 'N', 'S')

        docs2 = formataString('Nota Fiscal de entrada: %s' % nota_entrada, 140, ' ', 'D', 'N', 'S')
        docs3 = formataString('Nota Fiscal de saida: %s' % nota_saida, 140, ' ', 'D', 'N', 'S')

        docs4 = formataString('Desconto na venda: %s' % getNumeroEditado(
            brw_trocas_capa.trccap_desconto), 49, ' ', 'D', 'N', 'S')
        docs4 += formataString('Total troca: %s' % getNumeroEditado(
            brw_trocas_capa.trccap_total_troca), 91, ' ', 'D', 'N', 'S')

        listagem.informaCab(''+title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab(''+docs)
        listagem.informaCab('')
        listagem.informaCab(docs1)
        listagem.informaCab(docs4)
        listagem.informaCab('Status: %s' % state)
        listagem.informaCab('')
        listagem.informaCab(docs2)
        listagem.informaCab(docs3)
        listagem.informaCab('')
        listagem.rodapePadrao()

        listagem.imprimeLinha(_('Documentos e itens p/ devolucao'))
        listagem.imprimeLinha('')
        listagem.imprimeLinha('*' + ('-' * 140) + '*')
        linha = '|'
        linha += formataString('PRODUTO', 38, ' ', 'D',  'N', 'S')
        linha += '|'
        linha += formataString('GRADE', 49, ' ', 'D', 'N', 'S')
        linha += '|'
        linha += formataString('QUANTIDADE', 12, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString('VALOR TOTAL', 15, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString('QUANTIDADE A DEVOLVER', 22, ' ', 'E', 'N', 'S')
        linha += '|'
        listagem.imprimeLinha(linha)
        listagem.imprimeLinha('*' + ('-' * 140) + '*')
        for origem in brw_trocas_capa.trccap_doc_origem_ids:
            nf = ''
            if origem.trcdor_nf_id:
                nf = origem.trcdor_nf_id.name
            linha = '|'
            linha += formataString('Nota Fiscal: %s' % nf, 140, ' ', 'D', 'N', 'S')
            linha += '|'
            listagem.imprimeLinha(linha)
            if context.get('trocas_ecf'):
                cupom = ''
                if origem.trcdor_cupom_id:
                    cupom = origem.trcdor_cupom_id.coo
                linha = '|'
                linha += formataString('Cupom Fiscal: %s' % cupom, 140, ' ', 'D', 'N', 'S')
                linha += '|'
                listagem.imprimeLinha(linha)
            listagem.imprimeLinha('|' + (' ' * 140) + '|')
            for item in origem.trcdor_itens_ids:
                linha = '|'
                linha += formataString(item.produto_id.codigo, 38, ' ', 'D', 'N', 'S')
                linha += '|'
                linha += formataString('%s - %s' % (item.grade_id.grade, item.grade_id.descricao),
                                       49, ' ', 'D', 'N', 'S')
                linha += '|'
                linha += formataString(getNumeroEditado(item.quantidade, 3), 12, ' ', 'E', 'N', 'S')
                linha += '|'
                linha += formataString(getNumeroEditado(item.vr_total_item, 2), 15, ' ', 'E', 'N',
                                       'S')
                linha += '|'
                linha += formataString(getNumeroEditado(item.trcien_quantidade_devolver, 3), 22,
                                       ' ', 'E', 'N', 'S')
                linha += '|'
                listagem.imprimeLinha(linha)
            if origem != brw_trocas_capa.trccap_doc_origem_ids[-1]:
                listagem.imprimeLinha('|' + (' ' * 140) + '|')
        listagem.imprimeLinha('*' + ('-' * 140) + '*')

        listagem.imprimeLinha('')
        listagem.imprimeLinha(_('Itens p/ venda'))
        listagem.imprimeLinha('')
        listagem.imprimeLinha('*' + ('-' * 140) + '*')
        linha = '|'
        linha += formataString('LOCAL', 15, ' ', 'D',  'N', 'S')
        linha += '|'
        linha += formataString('PRODUTO', 35, ' ', 'D',  'N', 'S')
        linha += '|'
        linha += formataString('GRADE', 46, ' ', 'D', 'N', 'S')
        linha += '|'
        linha += formataString('QUANTIDADE', 25, ' ', 'E', 'N', 'S')
        linha += '|'
        linha += formataString('VALOR TOTAL', 15, ' ', 'E', 'N', 'S')
        linha += '|'
        listagem.imprimeLinha(linha)
        listagem.imprimeLinha('*' + ('-' * 140) + '*')
        for item in brw_trocas_capa.trccap_itens_saida_ids:
            linha = '|'
            linha += formataString('%s - %s' % (item.trcisa_local_id.numero,
                                                item.trcisa_local_id.name), 15, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString(item.trcisa_produto_id.codigo, 35, ' ', 'D', 'N', 'S')
            linha += '|'
            linha += formataString('%s - %s' % (item.trcisa_grade_id.grade,
                                                item.trcisa_grade_id.descricao), 46, ' ', 'D', 'N',
                                   'S')
            linha += '|'
            linha += formataString(getNumeroEditado(item.trcisa_quantidade, 3), 25, ' ', 'E',
                                   'N', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(item.trcisa_valor_total, 2), 15,
                                   ' ', 'E', 'N', 'S')
            linha += '|'
            listagem.imprimeLinha(linha)

        listagem.imprimeLinha('*' + ('-' * 140) + '*')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

report_custom('report.trocas')
