# -*- coding: utf-8 -*-
# #############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
# www.siginformatica.com.br luiz@siginformatica.com.br
#
# #############################################################################

from openerp.osv import osv
from SigUtils.ajustar_empresa import sigutils_conversar_com_a_sig
from SigUtils import sigerp
from openerp.tools.translate import _
import logging
from openerp import SUPERUSER_ID
from unicodedata import normalize
from ...web_sig.control.utils import websig_get_my_ip
from openerp.modules import get_module_resource
from openerp import tools
from datetime import datetime
import xmlrpclib, socket
from re import sub
from openerp.tools import config as openerp_config


def log_debug(func):
    from openerp.tools import config as openerp_config
    from datetime import datetime
    import logging
    import time
    no_logger = ['pendencias']

    def wrapper(*args, **kwargs):
        if args[0]._name in no_logger and openerp_config.get('log_level').upper() == 'DEBUG':
            _logger = logging.getLogger(__name__)
            _logger.setLevel(logging.DEBUG)  # Enable DEBUG mode
        elif openerp_config.get('log_level').upper() == 'DEBUG':
            _logger = args[0]._logger
        else:
            return func(*args, **kwargs)
        start_time = time.time()
        result = func(*args, **kwargs)
        if _logger.isEnabledFor(logging.DEBUG):
            end_time = time.time()
            _logger.debug('%s :: %s@%s|%s (%.3fs)' % (
                func.__doc__ and func.__doc__.replace(
                    '\n', '', 1).strip().split('\n')[0] or '', func.func_name,
                datetime.fromtimestamp(start_time).strftime('%H:%M:%S'),
                datetime.fromtimestamp(end_time).strftime('%H:%M:%S'), end_time - start_time))

        return result

    return wrapper


class valida_pendencias(osv.Model):
    _inherit = 'valida.pendencias'
    _logger = logging.getLogger(_inherit)
    _logger.level = logging._levelNames[openerp_config.get('log_level').upper()]

    def valpen_verifica_versao(self, cr, uid, par=[], context={}):
        """Usado no frente via xmlrpc, o parametro nao eh usado, mas nao retirar pois vai dar erro no frente"""
        context = context and context.copy() or {}
        return '7'

    def _auto_init(self, cr, context=None):
        context = context and context.copy() or {}
        try:
            res = super(valida_pendencias, self)._auto_init(cr, context)
            _sql = "select name, latest_version, state from ir_module_module where state <> 'uninstalled' order by name"
            cr.execute(_sql)
            _dict_modulos = {'modulos': {}}
            for _module_dados in cr.dictfetchall():
                terp_file = get_module_resource(_module_dados.get('name'), '__openerp__.py')
                ver = ''
                try:
                    f = tools.file_open(terp_file)
                    ver = eval(f.read())['version']
                except:
                    pass
                finally:
                    f.close()
                _dict_modulos['modulos'][_module_dados.get('name')] = ver
            _xmodulos = str(_dict_modulos).replace("'", '"')
            vals = {'valpen_codigo': _xmodulos}
            pendencia_ids = self.search(cr, SUPERUSER_ID, [('valpen_codigo', '=', _xmodulos)],
                                        context=context)
            if not pendencia_ids:
                self.create(cr, 1, vals, context)
        except:
            pass

        return res

    def valpen_validar_erp(self, cr, uid, ids, context=None):
        """
        Método executado por heranca no modulo 'adm'
        @param cr:
        @param uid:
        @param ids:
        @param context:
        @return: True ou False dependendo se conseguiu ou não
        """
        context = context and context.copy() or {}
        return True

    def valpen_ajustar_pendencias(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        self._logger.info(_('Ajustar pendencias! %s' % context))

        def _admpen_ajustar_versao_modulos():
            self._logger.info(_('Ajustando registro das versoes dos modulos'))
            res = False
            _company_dados = self.pool.get('res.company').browse(cr, uid, 1, context=context)
            try:
                _cnpj_cliente = _company_dados.rescon_pessoa_id.cpf_cnpj
                _nome_cliente = _company_dados.rescon_pessoa_id.nome
            except:
                _cnpj_cliente = ''
                _nome_cliente = ''
            try:
                _vals = eval(brw_pendencias.valpen_codigo)
                _vals['cnpj_cliente'] = _cnpj_cliente
                _vals['nome_cliente'] = _nome_cliente
                _vals['data'] = brw_pendencias.create_date
                servidor = self.pool.get('ir.config_parameter').get_sig_server(cr, uid).split(',')
                self._logger.info(
                    _('Conversando com a Sig(modulos): Host:%s, Porta:%s, User:%s, db:%s, context:%s') % (
                        servidor[0], servidor[2], servidor[3], servidor[1], context))
                _vals['ip_cliente'] = websig_get_my_ip()


                servidor = self.pool.get('ir.config_parameter').get_sig_server(cr, uid).split(',')
                servidor_local_id = self.pool.get('ir.config_parameter').search(cr, uid,
                                                                               [('key', '=','local.server.sig')])
                if servidor_local_id:
                    servidor_local = self.pool.get('ir.config_parameter').read(cr, uid, servidor_local_id, [])
                    servidor_local = servidor_local[0]['value']
                else:
                    servidor_local = 'iporanga'
                    self.pool.get('ir.config_parameter').create(cr, uid, {'key': 'local.server.sig',
                                                                          'value': servidor_local})
                res = sigutils_conversar_com_a_sig(servidor, 'sig.cliente.modulo.versao',
                                                   'sigclv_recebe_versao', _vals, 'S', servidor_local)
                self._logger.info(_('Fim de conversacao! Resultado: %s') % str(res))
            except Exception, e:
                self._logger.warn(_('Erro ao tentar conversar com a Sig! Erro: %s') % str(e))
                # Não conseguindo a conecção, remover o servidor da configuração para que possar ser gerado novamente,
                # talvez ele esteja errado
                server_id = self.pool.get('ir.config_parameter').search(cr, SUPERUSER_ID,
                                                                        [('key', '=', 'server_sig')], context=context)
                self.pool.get('ir.config_parameter').unlink(cr, SUPERUSER_ID, server_id)
            self._logger.info(_('Fim de registro de versoes!'))
            return res

        pendencias_ids = self.search(cr, uid, [], context=context)
        if pendencias_ids:
            for brw_pendencias in self.browse(cr, uid, pendencias_ids, context=context):
                if 'modulos' in brw_pendencias.valpen_codigo:
                    res = _admpen_ajustar_versao_modulos()
                    if res:
                        self.unlink(cr, uid, brw_pendencias.id, context=context)

        self._logger.info(_('Pendencias ajustadas'))
        return True

    @log_debug
    def valpen_verifica_rede_sig(self, cr, uid, context=None):
        """
        Verifica se o sistema esta rodando dentro da rede da sig
        :param cr:
        :param uid:
        :param context:
        :return: True ou False
        """
        context = context and context.copy() or {}
        server = self.pool.get('ir.config_parameter').get_sig_server(cr, uid,
                                                                     context=context).split(',')
        host = self.pool.get('ir.config_parameter').get_param(cr, uid, 'local.server.sig')
        try:
            dbname = server[1]
            port = server[2]
            usuario = server[3]
            senha = server[4]
        except:
            raise Exception('Erro no parametro "server_sig" do sistema, parametro incorreto')

        try:
            sock_common = xmlrpclib.ServerProxy('http://%s:%s/xmlrpc/common' % (host, port))
            socket.setdefaulttimeout(3)
            sock_common.login(dbname, usuario, senha)
            xmlrpclib.ServerProxy('http://%s:%s/xmlrpc/object' % (host, port))
        except Exception as e:
            return False

        return True

    @log_debug
    def valpen_verificar_licenca_ativa(self, cr, uid, context=None):
        '''
        Verifica se a licenca do sistema esta valida, em caso de negativa, dispara um raise erro
        :param cr:
        :param uid:
        :param context:
        :return:
        '''
        context = context and context.copy() or {}
        # Segunda-feira (Monday) e o primeiro dia, representado pelo numero 0.
        # para finais de semana, nao faz a verificacao
        if datetime.now().weekday() in [5,6]:
            return True

        licenca = self.pool.get('ir.config_parameter').get_param(cr, uid, 'licensa_sig_erp')
        if self.valpen_verifica_rede_sig(cr, uid, context):
            return True

        if not licenca:
            raise osv.except_osv(_('Atencao!'),
                                 _('Sistema sem licenca cadastrada!'))

        try:
            licenca = sigerp._crypto_sig('d', licenca)
        except Exception as e:
            self._logger.info(_('Erro ao descriptografar licenca: %s') % e)
            raise osv.except_osv(_('Atencao!'), _('Criptografia incorreta!'))

        list_licenca = licenca.split(';')
        if len(list_licenca) > 1:
            _dt = list_licenca[1]
            if _dt == '0':
                raise osv.except_osv(_('Atencao!'),
                                     _('Erro 9000 - Favor entrar em contato com o Suporte!'))

            _hoje = datetime.strftime(datetime.now(), '%Y%m%d')
            if _hoje > _dt:
                raise osv.except_osv(_('Atencao!'),
                                     _('Erro 9000 - Favor entrar em contato com o Suporte!'))

    def valpen_ativar_licenca(self, cr, uid, cripto_licenca, context=None):
        context = context and context.copy() or {}
        try:
            licenca = sigerp._crypto_sig('d', cripto_licenca)
        except Exception as e:
            self._logger.info(_('Erro ao descriptografar licenca: %s') % e)
            raise osv.except_osv(_('Atencao!'), _('Criptografia incorreta!'))

        list_licenca = licenca.split(';')
        cnpj = list_licenca[0]
        _company_dados = self.pool.get('res.company').browse(cr, uid, 1, context=context)
        try:
            cnpj_cadastro = sub('[^0-9]', '', _company_dados.rescon_pessoa_id.cpf_cnpj)
        except:
            obj_config = self.pool.get('supervisor.cfg.configuracao')
            config_ids = obj_config.search(cr, uid, [], context=context)
            dados_conf = obj_config.read(cr, uid, config_ids[0], ['supcfc_cnpj'], context)
            cnpj_cadastro = sub('[^0-9]', '', dados_conf.get('supcfc_cnpj') or '')

        if cnpj != cnpj_cadastro:
            raise osv.except_osv(_('Atencao!'),
                                 _('Cnpj da licenca diferente do cadastrado na empresa!'))

        self.pool.get('ir.config_parameter').set_param(cr, uid, 'licensa_sig_erp', cripto_licenca)
        self.valpen_verificar_licenca_ativa(cr, uid, context)
        return True
