# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from SigUtils import sigerp
from openerp.tools.translate import _


class ir_config_parameter(osv.Model):
    _name = "ir.config_parameter"
    _inherit = "ir.config_parameter"

    def get_sig_server(self, cr, uid, context=None):
        context = context and context.copy() or {}
        servidor = self.pool.get('ir.config_parameter').get_param(cr, uid, 'server_sig', False)
        if not servidor:
            self.set_sig_server(cr, uid, False, False, False, False, False)
            servidor = self.pool.get('ir.config_parameter').get_param(cr, uid, 'server_sig', False)
        if servidor:
            try:
                servidor = sigerp._get_sig_server(servidor)
            except Exception as e:
                raise osv.except_osv(_('Atencao!'),
                                     _('Erro ao descriptografar parametro do sistema: "server_sig" \n%s') % e)
        return servidor

    def set_sig_server(self, cr, uid, host, bd, porta, user, passwd, context=None):
        context = context and context.copy() or {}
        value = sigerp._set_sig_server(host, bd, porta, user, passwd)
        return self.pool.get('ir.config_parameter').set_param(cr, uid, 'server_sig', value, context)


