# -*- coding: utf-8 -*-
# Part of Odoo. See LICENSE file for full copyright and licensing details.
from openerp.osv import fields, osv


class ir_cron(osv.osv):
    """ Model describing cron jobs (also called actions or tasks).
    """

    # TODO: perhaps in the future we could consider a flag on ir.cron jobs
    # that would cause database wake-up even if the database has not been
    # loaded yet or was already unloaded (e.g. 'force_db_wakeup' or something)
    # See also openerp.cron

    _inherit = "ir.cron"

    def method_direct_trigger(self, cr, uid, ids, context=None):
        if context is None:
            context={}
        cron_obj = self.browse(cr, uid, ids, context=context)
        for cron in cron_obj:
            self._callback(cr, cron.user_id.id, cron.model, cron.function, cron.args, cron.id)
        return True
