# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler
from SigUtils import datas
from openerp.tools.translate import _


class veiculos_uso(osv.Model):
    _name = 'veiculos.uso'
    _inherit = 'veiculos.uso'

    def onchange_km(self, cr, uid, ids, veiculo_id, data_termino, km, context=None):
        context = context and context.copy() or {}
        res = {}
        mensagem = ''
        idsUso = self.pool.get('veiculos.uso').search(cr, uid, [('veiculo_id', '=', veiculo_id)], context=context,
                                                      order='data_termino desc', limit=1)
        if idsUso:
            for idUso in idsUso:
                x = self.pool.get('veiculos.uso').read(cr, uid, idUso, ['km'], context=context)
                usoKm = x['km']
                if km < usoKm:
                    mensagem = mensagem + _('Ja foi feito lancamento com KM superior a este! \n\r')
        idsDespesaTipo = self.pool.get('veiculos.despesa.tipo').search(cr, uid, [('repeticao', '!=', 'N')],
                                                                       context=context)
        if idsDespesaTipo:
            for idDespesaTipo in idsDespesaTipo:
                x = self.pool.get('veiculos.despesa.tipo').read(cr, uid, idDespesaTipo,
                                                                ['repeticao', 'tempo', 'km', 'name'], context=context)
                despesaTipoRepeticao = x['repeticao']
                despesaTipoKm = x['km']
                despesaTipoTempo = x['tempo']
                despesaTipoName = x['name']
                args = [('veiculo_id', '=', veiculo_id), ('despesa_tipo_id', '=', idDespesaTipo)]
                idsDespesa = self.pool.get('veiculos.despesas').search(cr, uid, args, context=context, order='km desc',
                                                                       limit=1)
                if idsDespesa:
                    regDespesa = self.pool.get('veiculos.despesas').read(cr, uid, idsDespesa[0], ['data', 'km'],
                                                                         context=context)
                    despesaData = regDespesa['data']
                    despesaKm = regDespesa['km']
                    if despesaTipoRepeticao in ('K', 'A'):
                        if int(km) - int(despesaKm) > int(despesaTipoKm):
                            mensagem = mensagem + _('Veja a necessidade de: ') + despesaTipoName + '\n\r'
                    else:
                        if despesaTipoRepeticao in ('T', 'A'):
                            _hoje = datas.getDataDeHoje()
                            if datas.calcDiferenca(_hoje, despesaData) > despesaTipoTempo:
                                mensagem = mensagem + _('Veja a necessidade de: ') + despesaTipoName + '\n\r'
        if mensagem:
            warning = {'title': _('Atencao')}
            warning['message'] = mensagem
            res = {'warning': warning}
        return res
