# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
from openerp import pooler

class veiculos_veiculo(osv.Model):
    _name = 'veiculos.veiculo'
    _inherit = 'veiculos.veiculo'

    def create(self, cr, user, vals, context=None):
        context = context and context.copy() or {}
        if 'placa' in vals and vals['placa']:
            vals['placa'] = vals['placa'].upper()
#        if 'codigo' in vals and vals['codigo']:
#            vals['codigo'] = vals['codigo'].upper()
        res = super(veiculos_veiculo, self).create(cr, user, vals, context)
        return res

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not len(ids):
            return []
        reads = self.read(cr, uid, ids, ['name','placa'], context=context)
        res = []
        for record in reads:
            name = record['placa'] + ' - ' +record['name']
            res.append((record['id'], name))
        return res

    def name_search(self, cr, user, name='', args=None, operator='ilike', context=None, limit=100):
        """
        Metodo para pesquisa de veiculos
        Pesquisa pelo codigo, placa ou descricao
        """
        if not args:
            args = []
        context = context and context.copy() or {}
        __name = name.upper()
        ids = self.search(cr, user, [('placa', '=', __name)], limit=limit, context=context)
        if not ids:
            ids = self.search(cr, user, [('name', operator, name)] + args, limit=limit, context=context)
        return self.name_get(cr, user, ids, context)

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        if 'placa' in vals and vals['placa']:
            vals['placa'] = vals['placa'].upper()
        res = super(veiculos_veiculo, self).write(cr, uid, ids, vals, context=context)
        return res


