# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class veiculos_despesa_tipo(osv.Model):
    """
    Tabela de Tipos de despesas
    """
    _name = 'veiculos.despesa.tipo'
    _columns = {
        'id': fields.integer('Codigo', readonly=True),
        'name': fields.char('Descricao', size=50, required=True), # Descricao do tipo de despesa do veiculo
        'repeticao': fields.selection([('T', 'Tempo'), ('K', 'Kilometragem'), ('A', 'Ambos'), ('N', 'Nenhum')],
                                      'Repetir por', size=1,
                                      help="Tipo de repeticao da despesa, identifica de que forma a despesa se repete"),
        'tempo': fields.integer('Tempo(meses)'),
        'km': fields.integer('Quantidade(Kilometros)'),
    }
    _defaults = {
        'repeticao': 'N'
    }

