# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields
import time

class veiculos_despesas(osv.Model):
    """
    Tabela de despesas dos veiculos
    """
    _name = 'veiculos.despesas'
    _columns = {
        'veiculo_id': fields.many2one("veiculos.veiculo", 'Veiculo', ondelete="restrict", required=True, select=True),
        'km': fields.integer('Km'), # Kilometragem do velocimetro
        'litros': fields.float('Litros', digits=(4, 1)), # Litragem do abastecimento\n
        'valor': fields.float('Valor', digits=(14, 2)), # Valor da despesa\n
        'observacao': fields.text('Observacao'), # Informacoes  complementares
        'data': fields.date('Data', required=True), # Data do movimento
        'despesa_tipo_id': fields.many2one('veiculos.despesa.tipo', 'Tipo de despesa', required=True),
    }
    _defaults = {
        'data': lambda *a: time.strftime('%Y-%m-%d'),
    }
    _order = 'veiculo_id, despesa_tipo_id, km desc'

