# -*- encoding: utf-8 -*-
"""
Copyright (C) 2009-2013 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2013, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import osv, fields


class veiculos_motorista(osv.Model):
    """
    Tabela de motoristas

    @since: 17.04.2013
    """

    _name = 'veiculos.motorista'
    _inherits = {'adm.pessoa': 'pessoa_id'}


    _columns = {
        # ___________________________ Many2One _______________________________
        'pessoa_id': fields.many2one("adm.pessoa", 'Pessoa', required=True,
                                     ondelete="restrict", select=True,
                                     domain="[('pessoa_tipo', '=', 'F')]"),

        # ___________________________ One2Many _______________________________
        'veiculo_ids': fields.one2many('veiculos.veiculo', 'motorista_id',
                                       'Veiculo'),

        # ___________________________ Boolean ________________________________
        'active': fields.boolean('Ativo')
    }

    _defaults = {
        'active': lambda *a: True,
    }
