# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class veiculos_multa(osv.Model):
    """
    Tabela de multas
    Prefixo veimul
    """
    _name = 'veiculos.multa'
    _rec_name = 'veimul_veiculo_id'
    _columns = {
        'veimul_veiculo_id': fields.many2one('veiculos.veiculo', 'Veiculo', required=True,
                                             ondelete='restrict'),
        'veimul_motorista_id': fields.many2one("veiculos.motorista", 'Motorista', select=True,
                                               ondelete='restrict'),
        'veimul_multa_tipo_id': fields.many2one("veiculos.multa.tipo", 'Tipo de multa', select=True,
                                                ondelete='restrict'),
        'veimul_data': fields.datetime('Data', required=True),
        'veimul_obs': fields.text('Informacoes complementares'),
    }
    _order = 'veimul_data desc, veimul_veiculo_id'



