# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields

from funcoes import venauv_get_dados
class veiculos_uso(osv.Model):
    """
    Tabela de uso dos veiculos
    """
    _name = 'veiculos.uso'
    _rec_name = 'destino'
    _columns = {
        'veiculo_id': fields.many2one('veiculos.veiculo', 'Veiculo', required=True, ondelete='restrict'),
        'data_inicio': fields.datetime('Data de inicio', required=True), # Data de inicio do uso do veiculo
        'data_termino': fields.datetime('Data de termino', required=True), # Data de termino do uso do veiculo
        'destino': fields.char('Destino', size=64), # Destino
        'km': fields.integer('Km', help='Odometro do veiculo na chegada'),
        'km_percorrido': fields.function(venauv_get_dados, type='integer', method=True, store=True,
                                         string='Km percorrido', multi='Dados'),
        'motorista_id': fields.many2one("veiculos.motorista", 'Motorista', select=True, required=True),
        'pessoa_id': fields.many2one("adm.pessoa", 'Pessoa referencia')
    }

