#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv


class liberar_desconto(osv.Model):
    _name = 'vendas.liberar.desconto'
    _inherit = 'vendas.liberar.desconto'

    def write(self, cr, uid, ids, values, context=None):
        context = context and context.copy() or {}
        if 'venauv_autorizado' in values:
            values['venauv_user_id'] = uid
        res = super(liberar_desconto, self).write(cr, uid, ids, values, context)
        return res

    def _get_restricao_dados(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
        # VERIFICA SE O MODULO FISCAL ESTA INSTALADO
        modulo_fiscal_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'fiscal', context=context)
        # VERIFICA SE O MODULO ORCAMENTO ESTA INSTALADO
        modulo_orcamento_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'orcamentos', context=context)

        fields_to_read = ['venauv_pedido_id']
        if modulo_orcamento_instalado:
            fields_to_read.append('venauv_orcamento_id')
        if modulo_fiscal_instalado:
            fields_to_read.append('venauv_nf_id')

        restricao_dados = self.read(cr, uid, ids, fields_to_read, context=context)
        return restricao_dados
