# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
import re
from openerp.tools.translate import _
from SigUtils import inscricao_estadual


class vendas_vendedor(osv.Model):
    _name = 'vendas.vendedor'
    _inherit = 'vendas.vendedor'

    def onchange_cpf_cnpj(self, cr, uid, ids, pessoa_tipo, cpf_cnpj, context=None):
        context = context and context.copy() or {}
        warning = {}
        if not cpf_cnpj:
            return {'warning': warning, 'value': {}}
        res = self.pool.get('adm.utils').admutl_cpf_cnpj_testar(pessoa_tipo, cpf_cnpj, True)
        if res:
            cpf_cnpj = res
        else:
            warning = {'title': _('Erro na validacao')}
            if pessoa_tipo == 'F':
                warning['message'] = _('CPF Invalido!  Digite Novamente!')
            else:
                warning['message'] = _('CNPJ Invalido!  Digite Novamente!')
            return {'warning': warning, 'value': {'cpf_cnpj': ''}}
        _cnpj_cpf_sem_formatar = re.sub('[^0-9]', '', cpf_cnpj)
        obj_pessoa = self.pool.get('adm.pessoa')
        pessoa_ids = obj_pessoa.search(cr, uid,
                                       [('cpf_cnpj', '=', _cnpj_cpf_sem_formatar), ('pessoa_tipo', '=', pessoa_tipo)],
                                       context=context)
        if pessoa_ids:
            vendedor_ids = self.search(cr, uid, [('pessoa_id', 'in', pessoa_ids)], context=context)
            if vendedor_ids:
                warning = {'title': _('Atencao')}
                warning['message'] = _('Vendedor ja cadastrado!')
                return {'warning': warning, 'value': {'cpf_cnpj': ''}}
            pessoa_id = pessoa_ids[0]
            browse_pessoa = obj_pessoa.browse(cr, uid, pessoa_id)
            endereco_ids = []
            for dados_endereco in browse_pessoa.endereco_ids:
                enderecos = {
                    'cep': dados_endereco.cep,
                    'active': dados_endereco.active,
                    'uf_id': dados_endereco.uf_id and dados_endereco.uf_id.id or False,
                    'numero': dados_endereco.numero,
                    'pais_id': dados_endereco.pais_id and dados_endereco.pais_id.id or False,
                    'bairro_id': dados_endereco.bairro_id and dados_endereco.bairro_id.id or False,
                    'cidade_id': dados_endereco.cidade_id and dados_endereco.cidade_id.id or False,
                    'observacao': dados_endereco.observacao,
                    'complemento': dados_endereco.complemento,
                    'logradouro_id': dados_endereco.logradouro_id and dados_endereco.logradouro_id.id or False,
                    'endereco_tipo_id': dados_endereco.endereco_tipo_id.id,
                }
                endereco_ids.append((1, dados_endereco.id, enderecos))
            email_ids = []
            for dados_emails in browse_pessoa.email_ids:
                emails = {
                    'name': dados_emails.name,
                    'observacao': dados_emails.observacao,
                    'email_tipo_id': dados_emails.email_tipo_id and dados_emails.email_tipo_id.id or False,
                }
                email_ids.append((1, dados_emails.id, emails))
            telefones_ids = []
            for dados_telefones in browse_pessoa.telefones_ids:
                telefones = {
                    "ddi": dados_telefones.ddi,
                    "ddd": dados_telefones.ddd,
                    "numero": dados_telefones.numero,
                    "observacoes": dados_telefones.observacoes,
                    "telefone_tipo_id": dados_telefones.telefone_tipo_id and
                                        dados_telefones.telefone_tipo_id.id or False,
                }
                telefones_ids.append((1, dados_telefones.id, telefones))
            documento_ids = []
            res = {
                'codigo': browse_pessoa.codigo,
                'name': browse_pessoa.name,
                "foto": browse_pessoa.foto,
                'pessoa_id': browse_pessoa.id,
                'admpes_fis_rg': browse_pessoa.admpes_fis_rg,
                'cpf_cnpj': cpf_cnpj,
                'admpes_fis_sexo': browse_pessoa.admpes_fis_sexo,
                'email_ids': email_ids,
                'endereco_ids': endereco_ids,
                'telefones_ids': telefones_ids,
                'documento_ids': documento_ids,
                'admpes_fis_estado_civil': browse_pessoa.admpes_fis_estado_civil,
                'fantasia_apelido': browse_pessoa.fantasia_apelido,
                'admpes_fis_cnh_nro': browse_pessoa.admpes_fis_cnh_nro,
                'admpes_fis_data_nascimento': browse_pessoa.admpes_fis_data_nascimento,
                'admpes_fis_cnh_validade': browse_pessoa.admpes_fis_cnh_validade,
                'admpes_fis_cnh_categoria': browse_pessoa.admpes_fis_cnh_categoria,
                'admpes_fis_rg_orgao_emissor': browse_pessoa.admpes_fis_rg_orgao_emissor,
                'admpes_fis_rg_data_emisssao': browse_pessoa.admpes_fis_rg_data_emisssao,
                'admpes_fis_cnh_orgao_emissor': browse_pessoa.admpes_fis_cnh_orgao_emissor,
                'admpes_jur_data_fundacao': browse_pessoa.admpes_jur_data_fundacao,
                'admpes_jur_tipo_empresa': browse_pessoa.admpes_jur_tipo_empresa,
                'admpes_jur_ie': browse_pessoa.admpes_jur_ie,
                'admpes_jur_regime_tributario': browse_pessoa.admpes_jur_regime_tributario,
                'admpes_jur_tipo_atividade': browse_pessoa.admpes_jur_tipo_atividade,
                'admpes_jur_cnae_id': browse_pessoa.admpes_jur_cnae_id.id,
            }
            return {'value': res}
        return {'warning': warning, 'value': {'cpf_cnpj': cpf_cnpj}}

    def venven_onchange_ie(self, cr, uid, ids, admpes_jur_ie):
        res = {}
        estado = False
        for partner in self.browse(cr, uid, ids):
            estado = partner.uf.upper()
        if admpes_jur_ie and admpes_jur_ie.isdigit() and estado:
            res = inscricao_estadual.validar(estado, admpes_jur_ie)
            if not res:
                return {'warning': {'title': _('Atencao'),
                                    'message': _('Inscricao Estadual invalida para o seguinte estado: %s') % estado}}
        return res

    def name_search(self, cr, uid, name='', args=None, operator='ilike', context=None, limit=100):
        context = context and context.copy() or {}
        if name.isdigit():
            ids = self.search(cr, uid, [('id', '=', int(name))] + args, limit=limit, context=context)
        else:
            ids = self.search(cr, uid, [('nome', operator, name)] + args, limit=limit, context=context)
        res = self.name_get(cr, uid, ids, context)
        return res

    def venven_get_vendedor_id(self, cr, uid, pessoa_id=False, context=None):
        """
        O metodo encontra o vendedor para o usuario (uid) logado ou para a pessoa (pessoa_id), caso
        essa seja informada.
        :param cr: cursor no banco de dados
        :type cr: object
        :param uid: id da tabela res_users, identificador do usuario
        :type uid: int
        :param pessoa_id: id da tabela adm_pessoa, identificador da pessoa
        :type pessoa_id: int
        :param context: dados contextuais
        :type context: dict
        :return: Caso seja encontrado, id desse objeto. Senao, Falso
        :rtype: int
        """
        context = context and context.copy() or {}
        if not pessoa_id:
            pessoa_id = self.pool.get('res.users').read(cr, uid, uid, ['pessoa_id'], context,
                                                        '_classic_write').get('pessoa_id')
        vendedor_ids = self.pool.get('vendas.vendedor').search(
            cr, uid, [('pessoa_id', '=', pessoa_id)], context=context)
        return vendedor_ids[0] if vendedor_ids else False
