#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv
from datetime import datetime
from openerp import SUPERUSER_ID


class liberar_desconto(osv.Model):

    _name = 'venlre.liberar.restricoes'
    _inherit = 'venlre.liberar.restricoes'

    def write(self, cr, uid, ids, values, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (list, tuple)):
            pass
        else:
            ids = [ids]
        if len(ids) == 1:
            _autorizado = self.read(cr, uid, ids, ['venlre_autorizado'], context=context)[0]['venlre_autorizado']
            if 'venlre_autorizado' in values:
                _autorizado = values['venlre_autorizado']
            if _autorizado:
                values['venlre_user_id'] = uid
                values['venlre_data'] = str(datetime.now())
            else:
                values['venlre_user_id'] = False
                values['venlre_data'] = 0
        res = super(liberar_desconto, self).write(cr, uid, ids, values, context=context)
        return res

    def _get_restricao_dados(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if isinstance(ids, (int, long)):
            ids = [ids]
        # VERIFICA SE O MODULO FISCAL ESTA INSTALADO
        modulo_fiscal_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'fiscal', context)
        # VERIFICA SE O MODULO ORCAMENTO ESTA INSTALADO
        modulo_orcamento_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'orcamentos', context)

        fields_to_read = ['venlre_pedido_id']
        if modulo_orcamento_instalado:
            fields_to_read.append('venlre_orcamento_id')
        if modulo_fiscal_instalado:
            fields_to_read.append('venlre_nf_id')

        restricao_dados = self.read(cr, uid, ids, fields_to_read, context=context,
                                    load='_classic_write')
        return restricao_dados

    def _get_restricao_pessoa_id(self, cr, uid, orcamento_ids, pedido_ids, nf_ids, context=None):
        """
        RETORNA UM DICIONARIO CONTENDO O DOCUMENTO COM UMA DICIONARIO COM OS IDS DOS
        DOCUMENTOS COMO CHAVE E ID DA PESSOA COMO VALOR
        EX: {'PEDIDOS: {1:105, 2:210}} ONDE 1 E 2 SAO OS IDS DOS PEDIDOS E 105 E210 IDS DAS PESSOAS
        """
        res = {}
        context = context and context.copy() or {}
        obj_venda_utils = self.pool.get('vendas.utils')
        if nf_ids:
            res['nota'] = obj_venda_utils.venutl_get_nf_pessoa_id(cr, uid, nf_ids, context)

        if pedido_ids:
            res['pedido'] = obj_venda_utils.venutl_get_pedido_pessoa_id(cr, uid, pedido_ids,
                                                                         context)

        if orcamento_ids:
            res['orcamento'] = obj_venda_utils.venutl_get_orcamento_pessoa_id(cr, uid, orcamento_ids,
                                                                            context)

        return res

    def _get_valor_documento(self, cr, uid, orcamento_ids, pedido_ids, nf_ids, context=None):
        """
        Retorna o nome do documento como chave, e um dicionario como valor, tendo o id do documento
        como chave e o valor do documento como valor do dicionario.
        """
        context = context and context.copy() or {}
        res = {}
        if nf_ids:
            dados_nf = self.pool.get('fiscal.nf.capa').read(cr, uid, nf_ids, ['vr_total_nf'],
                                                            context=context)
            res['nota'] = {}
            map(lambda x: res['nota'].update({x.get('id'): x.get('vr_total_nf')}), dados_nf)

        if pedido_ids:
            dados_pedido = self.pool.get('estoquepedidos.pedido.capa').read(
                cr, uid, pedido_ids, ['valor_total'], context=context)
            res['pedido'] = {}
            map(lambda x: res['pedido'].update({x.get('id'): x.get('valor_total')}), dados_pedido)

        if orcamento_ids:
            dados_orcamento = self.pool.get('orcamentos.orcamento.capa').read(
                cr, uid, orcamento_ids, ['valor_liquido'], context=context)
            res['orcamento'] = {}
            map(lambda x: res['orcamento'].update({x.get('id'): x.get('valor_liquido')}),
                dados_orcamento)

        return res

