# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class financeiro_cliente(osv.Model):
    _name = 'financeiro.cliente'
    _inherit = 'financeiro.cliente'

    def fincli_get_base_endereco(self, cr, uid, ids, name, arg, context=None, tipo=None):
        context = context and context.copy() or {}
        res = {}
        if not len(ids):
            return {}
        obj = self.pool.get('adm.pessoa.endereco')
        for id in ids:
            id2 = self.fincli_get_pessoa_id(cr, uid, id, context=context)
            args = [('pessoa_id', '=', id2)]
            endereco_ids = obj.search(cr, uid, args, context=context)
            if not endereco_ids:
                args = [('pessoa_id', '=', id2)]
                endereco_ids = obj.search(cr, uid, args, context=context)
                if endereco_ids:
                    endereco_ids = [endereco_ids[0]]
            if endereco_ids:
                for endereco_id in [endereco_ids[0]]:
                    endereco = obj.browse(cr, uid, endereco_id)
                    if tipo == 'endereco':
                        rua = endereco.logradouro_id.name
                        #-- INICIO - ALTERAcaO POR CHRISTIAN -------------------
                        #nro = str(endereco.numero)
                        if endereco.numero:
                            nro = endereco.numero
                        else:
                            nro = 'S/N'
                            #-- FIM ------------------------------------------------
                        compl = endereco.complemento
                        if not rua:
                            endereco = ''
                        else:
                            endereco = rua
                        if nro:
                            endereco = endereco + ', ' + nro
                        if compl:
                            endereco = endereco + '-' + compl
                        res[id] = endereco
                        continue
                    if tipo == 'cidade':
                        cidade = endereco.cidade_id.name
                        res[id] = cidade
                        continue
                    if tipo == 'bairro':
                        bairro = endereco.bairro_id.name
                        res[id] = bairro
                        continue
                    if tipo == 'estado':
                        estado = endereco.uf_id.sigla
                        res[id] = estado
                        continue
                    if tipo == 'pais':
                        pais = endereco.pais_id.name
                        res[id] = pais
                        continue
                    if tipo == 'cep':
                        cep = endereco.cep
                        res[id] = cep
                        continue
                    res[id] = ''
            else:
                res[id] = ''
        return res

    def fincli_get_pessoa_id(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        pessoa_ids = []
        if not isinstance(ids, list):
            ids = [ids]
        cliente_dados = self.read(cr, uid, ids, ['pessoa_id'], context=context)
        for x in cliente_dados:
            pessoa_id = x.get('pessoa_id')
            if isinstance(pessoa_id, tuple):
                pessoa_id = pessoa_id[0]
            pessoa_ids.append(pessoa_id)
        return pessoa_ids
