# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class financeiro_cliente(osv.Model):
    _name = 'financeiro.cliente'
    _inherit = 'financeiro.cliente'

    from funcoes import fincli_get_bairro, fincli_get_cidade, fincli_get_endereco, fincli_get_estado # _fincli_media_atraso

    _columns = {
        'vendedor_id': fields.many2one("vendas.vendedor", 'Vendedor', ondelete="restrict", select=True,
                                       domain="[('tipo','=','I')]"), # id do vendedor
        'vendedor_externo_id': fields.many2one("vendas.vendedor", 'Vendedor externo', ondelete="restrict", select=True,
                                               domain="[('tipo','=','E')]"), # id do vendedor externo
        'fincli_rota': fields.many2one('vendas.rotas', 'Rota para entregas', ondelete='set null'),
        'sequence': fields.integer('Sequencia na rota', help='Sequencia de entrega na rota'),
        'fincli_endereco': fields.function(fincli_get_endereco, method=True, type="char", size=64, string='Endereco',
                                           store=False), # Endereco da pessoa
        'fincli_bairro': fields.function(fincli_get_bairro, method=True, type="char", size=30, string='Bairro',
                                         store=False), # Bairro da pessoa
        'fincli_cidade': fields.function(fincli_get_cidade, method=True, type="char", size=30, string='Cidade',
                                         store=False), # Cidade da pessoa
        'fincli_uf': fields.function(fincli_get_estado, method=True, type="char", size=2, string='Estado', store=False),
        'fincli_atraso_previsto': fields.integer('Atraso Previsto',
                                                 help='Prazo em dias previsto para pagamento em atraso'),
        'fincli_atraso_medio': fields.float(), # este campo nao eh mais utilizado, porem a sua retirada esta causando erro



    }
    _defaults = {
        'sequence': lambda *a: 100,
    }

