# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_parametro(osv.Model):
    """
    Tabela de Categoria de produtos (Segmentacao)
    """
    _name = 'estoque.parametro'
    _inherit = 'estoque.parametro'
    _columns = {
        'estpar_desconto': fields.float('% Desconto maximo', digits=(2, 2)),
        'estpar_incluir_frete_no_custoreposicao': fields.boolean('Incluir frete no custo reposicao'),
        'estpar_incluir_ipi_no_custoreposicao': fields.boolean('Incluir Ipi no custo reposicao'),
        'estpar_pedido_separar': fields.boolean('Separar itens do pedido',
                                                help='Se marcado a empresa ira trabalhar com separacao de itens do pedido para a expedicao'),
        'estpar_impressora_pedido': fields.char('Impressora para Pedido de Venda', size=128,
                                                help='Nome da impressora para Pedido de Venda, caso nao queira fazer selecao na hora de imprimir'),
        'estpar_permite_alterar_condicoes_pgto': fields.boolean('Permitir alterar condicoes de pagamento', oldname="estpar_permite_alterar_condicoes_pgto",
                                                help='Se marcado, permite que o usuario altere as condicoes de pagamento no orcamento, pedido e nf'),
        'estpar_vendedor_obrigatorio': fields.boolean(
            'Vendedor obrigatorio', help='Se marcado, sera obrigatorio informar o vendedor interno '
                                         'no pedido, no orcamento e na nota fiscal.'),
        'estpar_vendedor_eh_usuario': fields.boolean('Usar usuario como vendedor'),
    }
    _defaults = {
        'estpar_permite_alterar_condicoes_pgto': False,
        'estpar_vendedor_obrigatorio': False,
        'estpar_vendedor_eh_usuario': lambda *a: False,
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
