# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_produto(osv.Model):
    """
    Tabela de Categoria de produtos (Segmentacao)
    """
    _name = 'estoque.produto'
    _inherit = 'estoque.produto'

    def estpro_get_desconto_maximo(self, cr, uid, produto_ids, context=None):
        context = context and context.copy() or {}
        res = {}
        if not isinstance(produto_ids, list):
            produto_ids = [produto_ids]

        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, 'estoque.parametro', context=context)
        parametro_ids = self.pool.get('estoque.parametro').search(cr, uid, [('company_id', '=', company_id)], context=context)
        parametro_dados = self.pool.get('estoque.parametro').read(cr, uid, parametro_ids, ['estpar_desconto'], context=context)
        desconto_parametro = False
        for reg in parametro_dados:
            if reg.get('estpar_desconto') > 0:
                desconto_parametro = reg.get('estpar_desconto')

        campos = ['estpro_desconto', 'categoria_id']
        dados_produto = self.read(cr, uid, produto_ids, campos, context=context,
                                  load='_classic_write')
        categ_ids = []
        for i in dados_produto:
            id = i.get('id')
            if i.get('estpro_desconto') and i.get('estpro_desconto') > 0:
                res[id] = i.get('estpro_desconto')
                continue

            if i.get('categoria_id'):
                categ_ids.append(i.get('categoria_id'))
            else:
                res[id] = desconto_parametro

        if not categ_ids:
            return res

        dict_categ = {}
        map(lambda x: dict_categ.update({x.id: x}),
            self.pool.get('estoque.categoria').browse(cr, uid, categ_ids, context=context))

        for i in dados_produto:
            id = i.get('id')
            brw_categ = dict_categ.get(i.get('categoria_id'))
            if not res.get(id) and brw_categ:
                while brw_categ:
                    if brw_categ.estcat_desconto and brw_categ.estcat_desconto > 0:
                        res[id] = brw_categ.estcat_desconto
                        break

                    brw_categ = brw_categ.parent_id
            if not res.get(id) and desconto_parametro:
                res[id] = desconto_parametro

        return res
