# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2017 All Rights Reserved. Luiz Fernando Maciel França
              www.siginformatica.com.br <luiz@siginformatica.com.br>
                                -------

Copyleft (CC) 2017, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""


# Funcoes da classe estoquepedidos_pedido_capa
def _pedcap_get_valor_ipi_total(self, cr, uid, ids, name, args, context=None):
    context = context and context.copy() or {}
    res = {}
    obj_pedido_item = self.pool.get('estoquepedidos.pedido.item')
    if not isinstance(ids, list):
        ids = [ids]

    laod = '_classic_write'
    modulo_fiscal = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid,
                                                                             'fiscal', context)
    dados_pedidos = self.read(cr, uid, ids, ['pedido_item_ids'], context)
    item_ids = []
    map(lambda x: x.get('pedido_item_ids') and item_ids.extend(x.get('pedido_item_ids')),
        dados_pedidos)
    dict_itens = {}
    produto_ids = []
    for i in obj_pedido_item.read(cr, uid, item_ids, ['produto_id'], context, laod):
        dict_itens[i.get('id')] = i
        produto_ids.append(i.get('produto_id'))

    dict_produtos = {}
    tributacao_ids = []
    for i in self.pool.get('estoque.produto').read(cr, uid, produto_ids, ['tributacao_ids'],
                                                   context):
        dict_produtos[i.get('id')] = i
        i.get('tributacao_ids') and tributacao_ids.extend(i.get('tributacao_ids'))

    dict_tributacoes = {}
    campos = ['encargo_id', 'tipo_tributacao', 'tributacao_id']
    encargo_ids = []
    trib_ids = []
    for i in self.pool.get('fiscal.tributacao.encargos').read(cr, uid, tributacao_ids, campos,
                                                              context, laod):
        dict_tributacoes[i.get('id')] = i
        i.get('encargo_id') and encargo_ids.append(i.get('encargo_id'))
        i.get('tributacao_id') and trib_ids.append(i.get('tributacao_id'))

    dict_encargos = {}
    map(lambda x: dict_encargos.update({x.get('id'): x}),
        self.pool.get('fiscal.encargo').read(cr, uid, encargo_ids, ['sigla'], context))

    dict_trib = {}
    map(lambda x: dict_trib.update({x.get('id'): x}),
        self.pool.get('fiscal.tributacao').read(cr, uid, trib_ids, ['aliquota'], context))

    totais_itens = obj_pedido_item.pedite_get_item_valor_total(cr, uid, item_ids, None, None,
                                                               context)
    for pedido in dados_pedidos:
        valor_total_ipi = 0.0
        for item_id in pedido.get('pedido_item_ids'):
            item = dict_itens.get(item_id)
            produto = dict_produtos.get(item.get('produto_id'))
            valor_total = totais_itens.get(item_id)
            if modulo_fiscal:
                for tributacao_id in produto.get('tributacao_ids'):
                    tributacao = dict_tributacoes.get(tributacao_id)
                    encargo = dict_encargos.get(tributacao.get('encargo_id'))
                    trib = dict_trib.get(tributacao.get('tributacao_id'))
                    if encargo.get('sigla') == 'IPI' and tributacao.get('tipo_tributacao') != 'E':
                        ipi_aliquota = trib.get('aliquota')
                        valor_total_ipi_item = valor_total * ipi_aliquota / 100
                        valor_total_ipi += valor_total_ipi_item
                        break

        res[pedido.get('id')] = round(valor_total_ipi, 2)

    return res

def _pedcap_get_estpar_pedido_separar(self, cr, uid, ids, field, args, context=None):
    context = context and context.copy() or {}
    res = {}
    company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name, context=context)
    obj_estoque_parametro = self.pool.get('estoque.parametro')
    estoque_parametro_id = obj_estoque_parametro.search(cr, uid, [('company_id', '=', company_id)], context=context)
    estpar_pedido_separar = False
    if estoque_parametro_id:
        estpar_pedido_separar = obj_estoque_parametro.browse(cr, uid, estoque_parametro_id[0]).estpar_pedido_separar
    for i in ids:
        res[i] = estpar_pedido_separar
    return res


def _pedcap_get_observacao_cliente(self, cr, uid, ids, name, arg, context):
    if isinstance(ids, (int, long)):
        ids = [ids]
    res = {}.fromkeys(ids, '')
    obj_financeiro_cliente = self.pool.get('financeiro.cliente')
    obj_financeiro_clientes_mensagem = self.pool.get('financeiro.clientes.mensagem')
    browse_pedido = self.browse(cr, uid, ids)
    for i in browse_pedido:
        id = i.id
        record_pessoa = i.pessoa_id
        if record_pessoa:
            pessoa_obs = record_pessoa.observacoes or ''
            pessoa_id = record_pessoa.id
            cliente_id = obj_financeiro_cliente.search(cr, uid, [('pessoa_id', '=', pessoa_id)], context=context)
            if cliente_id:
                cliente_mensagem_id = obj_financeiro_clientes_mensagem.search(cr, uid,
                                                                              [('cliente_id', 'in', cliente_id)],
                                                                              context=context)
                if cliente_mensagem_id:
                    clientes_mensagem_dados = obj_financeiro_clientes_mensagem.browse(cr, uid, cliente_mensagem_id)
                    for j in clientes_mensagem_dados:
                        if j.modo_exibicao in ('V', 'A'):
                            mensagem_id = j.mensagens_id
                            if mensagem_id:
                                pessoa_obs += '\n' + mensagem_id.name
        else:
            pessoa_obs = ''
        res[id] = pessoa_obs
    return res


def _pedcap_get_vendedor_obrigatorio(self, cr, user, ids, name=None, arg=None, context=None):
    """
    Manipulacao de campos. Valores de campos pre-definidos como tipo funcao.
    Retorna verdadeiro/falso em funcao do parametro informado no campo ´estpar_vendedor_obrigatorio´

    :param cr: a linha atual do cursor do banco de dados,
    :param user: ID do usuario utilizado para a verificacao de perfil,
    :param ids: lista dos IDs,
    :param context: um dicionario padrao para valores contextuais,
    :type cr: cursor
    :type user: int
    :type ids: list
    :type context: dict
    :return: valores ajustados dos campos.
    :rtype: bool

    :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
    """
    context = context and context.copy() or dict()
    if isinstance(ids, list):
        result = dict().fromkeys(ids, self.pool.get('adm.utils').admutl_get_parametros(
            cr, user, 'estoque', [], context).get('estpar_vendedor_obrigatorio'))
    else:
        result = self.pool.get('adm.utils').admutl_get_parametros(
            cr, user, 'estoque', [], context).get('estpar_vendedor_obrigatorio')

    return result


def pedcap_get_vendedor_usuario(self, cr, uid, ids, field_name=None, args=None, context=None):
    """
    Manipulacao de campos. Valores de campos pre-definidos como tipo funcao.
    Retorna verdadeiro/falso em funcao do parametro informado no campo 'estpar_vendedor_eh_usuario'
    e se o usuario é um vendedor (vendas.vendedor).

    :param cr: a linha atual do cursor do banco de dados,
    :param uid: ID do usuario utilizado para a verificacao de perfil,
    :param ids: lista dos IDs,
    :param context: um dicionario padrao para valores contextuais,
    :type cr: cursor
    :type uid: int
    :type ids: list
    :type context: dict
    :return: valores ajustados dos campos.
    :rtype: bool
    """
    context = context and context.copy() or dict()
    estoque_parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(
        cr, uid, 'estoque', 'estpar_vendedor_eh_usuario', context)
    res = {}
    vendedor_id = self.pool.get('vendas.vendedor').venven_get_vendedor_id(cr, uid, context=context)
    map(lambda i: res.update({i: True if estoque_parametro_dados.get('estpar_vendedor_eh_usuario')
                              and vendedor_id else False}), ids)
    return res


def pedite_get_vendedor_usuario(self, cr, uid, ids, field_name=None, args=None, context=None):
    """
    Manipulacao de campos. Valores de campos pre-definidos como tipo funcao.
    Retorna verdadeiro/falso em funcao do parametro informado no campo 'estpar_vendedor_eh_usuario'
    e se o usuario é um vendedor (vendas.vendedor).

    :param cr: a linha atual do cursor do banco de dados,
    :param uid: ID do usuario utilizado para a verificacao de perfil,
    :param ids: lista dos IDs,
    :param context: um dicionario padrao para valores contextuais,
    :type cr: cursor
    :type uid: int
    :type ids: list
    :type context: dict
    :return: valores ajustados dos campos.
    :rtype: bool
    """
    context = context and context.copy() or dict()
    estoque_parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(
        cr, uid, 'estoque', 'estpar_vendedor_eh_usuario', context)
    res = {}
    vendedor_id = self.pool.get('vendas.vendedor').venven_get_vendedor_id(cr, uid, context=context)
    map(lambda i: res.update({i: True if estoque_parametro_dados.get('estpar_vendedor_eh_usuario')
                             and vendedor_id else False}), ids)
    return res

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:


