# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoquepedidos_pedido_capa(osv.Model):
    from funcoes import _pedcap_get_valor_ipi_total, _pedcap_get_estpar_pedido_separar
    from funcoes import _pedcap_get_observacao_cliente, _pedcap_get_vendedor_obrigatorio
    from funcoes import pedcap_get_vendedor_usuario

    def pedcap_get_mostrar_botao_separar_itens(self, cr, uid, ids, field, args=[], context=None):
        context = context and context.copy() or {}
        res = {}
        obj_estoquepedidos_pedido_capa = self.pool.get('estoquepedidos.pedido.capa')
        estpar_pedido_separar = obj_estoquepedidos_pedido_capa._get_estpar_pedido_separar_padrao(cr, uid,
                                                                                                 context=context)
        for dados_pedido in self.read(cr, uid, ids, ['state'], context=context):
            state = dados_pedido.get('state')
            if (estpar_pedido_separar and state == 'D') or (not estpar_pedido_separar and state == 'V'):
                res[dados_pedido.get('id')] = True
            else:
                res[dados_pedido.get('id')] = False
        return res

    _name = 'estoquepedidos.pedido.capa'
    _inherit = 'estoquepedidos.pedido.capa'
    _columns = {
        'vendedor_id': fields.many2one('vendas.vendedor', 'Vendedor', ondelete="restrict"),
        'vendedor_externo_id': fields.many2one('vendas.vendedor', 'Vendedor externo',
                                               ondelete="restrict", select=True),
        'estpar_pedido_separar': fields.function(
            _pedcap_get_estpar_pedido_separar, method=True, string="Parametro Separar Pedido",
            type="boolean", store=False),
        'mostrar_botao_separar_itens': fields.function(
            pedcap_get_mostrar_botao_separar_itens, method=True, type='boolean',
            string="Mostrar Botao Separar Itens", store=False),
        'observacao_pessoa': fields.function(
            _pedcap_get_observacao_cliente, type="text", method=True, string="Observacao Cliente",
            store=False),
        'pedcap_valor_ipi': fields.function(
            _pedcap_get_valor_ipi_total, method=True, string='Valor do IPI', store=False),
        'pedcap_cancelamento_id': fields.many2one('venda.motivo.cancelamento',
                                                  'Motivo cancelamento'),
        'pedcap_cancelamento_complemento': fields.text('Cancelamento complemento'),
        'pedcap_vendedor_obrigatorio': fields.function(
            _pedcap_get_vendedor_obrigatorio, store=False, type='boolean',
            string='Vendedor obrigatorio'),
        'pedcap_vendedor_usuario': fields.function(pedcap_get_vendedor_usuario, type='boolean',
                                                   string='Vendedor e usuario', method=True),
        'pedcap_rota_entrega': fields.many2one('vendas.rotas', 'Rota', ondelete="set null", select=True )
    }
    _defaults = {
        'estpar_pedido_separar': lambda s, cr, uid, c: s._get_estpar_pedido_separar_padrao(cr, uid, None),
        'pedcap_vendedor_obrigatorio': _pedcap_get_vendedor_obrigatorio
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

