# -*- coding: utf-8 -*-

from openerp.osv import osv, fields


class titulos_liquidados_osv(osv.TransientModel):

    _inherit = 'titulos.liquidados.osv'

    _columns = {
        'vendedor_id': fields.many2one("vendas.vendedor", 'Vendedor', ondelete="restrict",
                                       select=True, domain="[('tipo','=','I')]"),
        'vendedor_externo_id': fields.many2one("vendas.vendedor", 'Vendedor externo',
                                               ondelete="restrict", select=True,
                                               domain="[('tipo','=','E')]"),
    }

    def button_print(self, cr, uid, ids, context=None):
        """
        O metodo reune os dados necessarios para gerar o relatorio em arquivo pdf. Seu retorno e uma
        acao (action) com a chamada do relatorio.
        :param cr: cursor no banco de dados.
        :type cr: object
        :param uid: id da tabela res_users, identidicador do usuario.
        :type uid: int
        :param ids: lista de id da tabela desse objeto
        :type ids: list
        :param context: dicionario com valores contextuais
        :type context: dict
        :return: dicionario com acao para chamada do relatorio
        :rtype: dict
        """
        context = context and context.copy() or {}
        obj_financeiro_titulo_baixa = self.pool.get('financeiro.titulo.baixa')
        obj_financeiro_titulo = self.pool.get('financeiro.titulo')
        res = super(titulos_liquidados_osv, self).button_print(cr, uid, ids, context)
        args_titulo = list()
        for titulo in self.browse(cr, uid, ids, context):
            if titulo.vendedor_id:
                res['datas']['lista_argumentos'] += '|Vendedor: %s ' % \
                                                    titulo.vendedor_id.pessoa_id.nome
                args_titulo.append(('vendedor_id', '=', titulo.vendedor_id.id))
            if titulo.vendedor_externo_id:
                res['datas']['lista_argumentos'] += '|Vendedor externo: %s ' % \
                                                    titulo.vendedor_externo_id.pessoa_id.nome
                args_titulo.append(('vendedor_externo_id', '=',
                                    titulo.vendedor_externo_id.id))
            if not args_titulo:
                continue
            titulo_ids = map(lambda i: i.titulo_id.id, obj_financeiro_titulo_baixa.browse(
                cr, uid, res.get('datas').get('titulo_baixa_ids'), context))
            args_titulo.append(('id', 'in', titulo_ids))
            titulo_ids = obj_financeiro_titulo.search(cr, uid, args_titulo, context=context)
            res['datas']['titulo_baixa_ids'] = obj_financeiro_titulo_baixa.search(
                cr, uid, [('id', 'in', res.get('datas').get('titulo_baixa_ids')),
                          ('titulo_id', 'in', titulo_ids)], context=context)

        return res
