# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp import pooler


# Funcoes da classe financeiro_cliente
def fincli_get_endereco(self, cr, uid, ids, name, arg, context=None):
    """
    Metodo utilizado para invocar o metodo _get_base_endereco informando o tipo como "endereco"
    """
    context = context and context.copy() or {}
    res = self.fincli_get_base_endereco(cr, uid, ids, name, arg, context=None, tipo='endereco')
    return res


def fincli_get_bairro(self, cr, uid, ids, name, arg, context=None):
    """
    Metodo utilizado para invocar o metodo _get_base_endereco informando o tipo como "bairro"
    """
    context = context and context.copy() or {}
    res = self.fincli_get_base_endereco(cr, uid, ids, name, arg, context=None, tipo='bairro')
    return res


def fincli_get_cidade(self, cr, uid, ids, name, arg, context=None):
    """
    Metodo utilizado para invocar o metodo _get_base_endereco informando o tipo como "cidade"
    """
    '''Qdo for do tipo fisica ou juridica, retornar a cidade do endereco do tipo 'Normal'
    Caso nao exista o endereco do tipo esperado, retornar a cidade do primeiro endereco que encontrar'''
    context = context and context.copy() or {}
    res = {}
    for id in ids:

        res[id] = ''
        obj_enderecos = pooler.get_pool(cr.dbname).get('adm.pessoa.endereco')
        enderecos = obj_enderecos.search(cr, uid, [('pessoa_id', '=', id)], context=context)
        end_cidade = obj_enderecos.read(cr, uid, enderecos, ['cidade_id'], context=context)

        if end_cidade:
            b = end_cidade[0]['cidade_id']
            if not b == False:
                res[id] = end_cidade[0]['cidade_id'][1]

    res = self.fincli_get_base_endereco(cr, uid, ids, res, arg, context=context, tipo='cidade')

    return res


def fincli_get_estado(self, cr, uid, ids, name, arg, context=None):
    """
    Metodo utilizado para invocar o metodo _get_base_endereco informando o tipo como "estado"
    """
    context = context and context.copy() or {}
    res = {}
    for id in ids:
        res[id] = ''
        obj_ufs = pooler.get_pool(cr.dbname).get('adm.pessoa.endereco')
        ufs = obj_ufs.search(cr, uid, [('pessoa_id', '=', id)], context=context)
        uf_name = obj_ufs.read(cr, uid, ufs, ['uf_id'], context=context)

        if uf_name:
            b = uf_name[0]['uf_id']
            if not b == False:
                res[id] = uf_name[0]['uf_id'][1]

    res = self.fincli_get_base_endereco(cr, uid, ids, res, arg, context=context, tipo='estado')
    return res

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

