# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields


class wizard_titulo_movimentado(osv.TransientModel):
    # prefixo: wiztmo_
    _inherit = 'wizard.titulo.movimentado'
    _columns = {
        'wiztmo_vendedor_id': fields.many2one("vendas.vendedor", 'Vendedor', ondelete="restrict",
                                              select=True, domain="[('tipo','=','I')]"),
        'wiztmo_vendedor_externo_id': fields.many2one("vendas.vendedor", 'Vendedor externo',
                                                      ondelete="restrict", select=True,
                                                      domain="[('tipo','=','E')]"),
    }

    def wiztmo_button_print(self, cr, uid, ids, context=None):
        """
        O metodo reune os dados necessarios para gerar o relatorio em arquivo pdf. Seu retorno e uma
        acao (action) com a chamada do relatorio.
        :param cr: cursor no banco de dados.
        :param uid: id da tabela res_users, identidicador do usuario.
        :param ids: lista de id da tabela desse objeto
        :param context: dicionario com valores contextuais
        :return: dicionario com acao para chamada do relatorio
        """
        context = context and context.copy() or {}
        context['titulo_movimentado_vendedor'] = True
        res = super(wizard_titulo_movimentado, self).wiztmo_button_print(cr, uid, ids, context)
        brw_titulo_movimentado = self.browse(cr, uid, ids, context)
        for mov in brw_titulo_movimentado:
            if mov.wiztmo_vendedor_id:
                res['datas']['vendedor'] = mov.wiztmo_vendedor_id.pessoa_id.nome
            if mov.wiztmo_vendedor_externo_id:
                res['datas']['vendedor_externo'] = mov.wiztmo_vendedor_externo_id.pessoa_id.nome
        return res
