# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################


# Funcoes da classe vendas_liberar_desconto
def venauv_lib_desconto_functions(self, cr, uid, ids, name, args, context=None):
    context = context and context.copy() or {}
    fields_funtions = dict(venauv_valor_bruto=0, venauv_valor_liquido=0, venauv_desconto=0)
    res = {}.fromkeys(ids if isinstance(ids, list) else [ids], fields_funtions)
    for i in self._get_restricao_dados(cr, uid, ids if isinstance(ids, list) else [ids], context):
        orcamento_id = i.get('venauv_orcamento_id') and i['venauv_orcamento_id'][0] or False
        pedido_id = i.get('venauv_pedido_id') and i['venauv_pedido_id'][0] or False
        nf_id = i.get('venauv_nf_id') and i['venauv_nf_id'][0] or False
        if orcamento_id or pedido_id or nf_id:
            if nf_id:
                valor_liquido, valor_bruto, desconto = \
                    self.pool.get('vendas.utils').venutl_get_valor_liquido_bruto_desconto(
                        cr, uid, nf_id, 'NFL', context)
            elif pedido_id:
                valor_liquido, valor_bruto, desconto = \
                    self.pool.get('vendas.utils').venutl_get_valor_liquido_bruto_desconto(
                        cr, uid, pedido_id, 'PED', context)
            else:
                valor_liquido, valor_bruto, desconto = \
                    self.pool.get('vendas.utils').venutl_get_valor_liquido_bruto_desconto(
                        cr, uid, orcamento_id, 'ORC', context)

            valor_liquido = float(self._float_persist('venauv_valor_liquido', valor_liquido))
            valor_bruto = float(self._float_persist('venauv_valor_bruto', valor_bruto))
            desconto = float(self._float_persist('venauv_desconto', desconto))
            res[i['id']].update(
                dict(venauv_valor_bruto=valor_bruto, venauv_valor_liquido=valor_liquido,
                     venauv_desconto=desconto))

    return res


# Funcoes da classe venlre_liberar_restricoes
def venlre_get_pessoas_ids(self, cr, uid, docs_pessoas_ids, context=None):
    context = context and context.copy() or {}
    res = []
    if docs_pessoas_ids.get('orcamento'):
        res.extend(map(lambda x: docs_pessoas_ids.get('orcamento').get(x),
                       docs_pessoas_ids.get('orcamento')))

    if docs_pessoas_ids.get('pedido'):
        res.extend(map(lambda x: docs_pessoas_ids.get('pedido').get(x),
                       docs_pessoas_ids.get('pedido')))

    if docs_pessoas_ids.get('nota'):
        res.extend(map(lambda x: docs_pessoas_ids.get('nota').get(x),
                       docs_pessoas_ids.get('nota')))

    return list(set(res))


def venlre_restricao_functions(self, cr, uid, ids, name, args, context=None):
    """OBS: CUIDADO AO ALTERAR QUALQUER FUNCAO UTILIZADA A BAIXO PARA NAO AUMENTAR O TEMPO GASTO 
       ATRAPALHANDO A PERFORMANCE. COMO POR EXEMPLO NAO USAR 'BROWSE', NAO COLOCAR 'SEARCH' E 'READ'
       DENTRO DE COMANDOS DE REPETICAO('FOR', 'WHILE') FELIPE"""
    context = context and context.copy() or {}
    res = dict()
    obj_financeiro_util = self.pool.get('financeiro')
    dados_resticoes = self._get_restricao_dados(cr, uid, ids if isinstance(ids, list) else [ids],
                                                context)
    orcamento_ids = list(set(map(lambda x: x.get('venlre_orcamento_id') or 0, dados_resticoes)))
    if not any(orcamento_ids):
        orcamento_ids = list()
    pedido_ids = list(set(map(lambda x: x.get('venlre_pedido_id') or 0, dados_resticoes)))
    if not any(pedido_ids):
        pedido_ids = list()
    nota_ids = list(set(map(lambda x: x.get('venlre_nf_id') or 0, dados_resticoes)))
    if not any(nota_ids):
        nota_ids = list()
    docs_pessoas_ids = self._get_restricao_pessoa_id(
        cr, uid, orcamento_ids, pedido_ids, nota_ids, context=context)
    docs_valor = self._get_valor_documento(
        cr, uid, orcamento_ids, pedido_ids, nota_ids, context=context)
    pessoa_ids = venlre_get_pessoas_ids(self, cr, uid, docs_pessoas_ids, context=context)
    company_id = self.pool.get('adm.empresa.objeto').getEmpresa(
        cr, uid, 'venlre.liberar.restricoes', context=context)
    context_aux = context.copy()
    context_aux.update({'sig_force_company': True, 'company_id': [company_id]})
    pessoa_valor_atraso = self.pool.get('financeiro').finutl_get_valor_em_atraso(
        cr, uid, pessoa_ids, context_aux)
    obj_fin_cliente = self.pool.get('financeiro.cliente')
    cliente_ids = obj_fin_cliente.search(
        cr, uid, [('pessoa_id', 'in', pessoa_ids)], context=context)
    dados_clientes = obj_fin_cliente.read(
        cr, uid, cliente_ids, ['pessoa_id', 'fincli_total_em_aberto'], context,
        '_classic_write')
    financeiro_pessoa_total_aberto = dict()
    map(lambda x: financeiro_pessoa_total_aberto.update(
        {x.get('pessoa_id'): x.get('fincli_total_em_aberto')}), dados_clientes)
    obj_vendas_utils = self.pool.get('vendas.utils')
    pessoa_total_aberto = obj_vendas_utils.venutl_get_total_debito_cliente(cr, uid,
                venutl_pessoa_ids=map(lambda p: p.get('pessoa_id'), dados_clientes),
                context=context)
    if not pessoa_total_aberto:
        map(lambda x: pessoa_total_aberto.update(
            {x.get('pessoa_id'): x.get('fincli_total_em_aberto')}), dados_clientes)
    if not pessoa_total_aberto:
        pessoa_total_aberto = financeiro_pessoa_total_aberto
    else:
        for pessoa in pessoa_total_aberto:
            if pessoa_total_aberto.get(pessoa):
                continue
            pessoa_total_aberto[pessoa] = financeiro_pessoa_total_aberto.get(pessoa)
    # Valor do debito em notas fiscais, pedidos e orcamentos
    outros_debitos_orc = self.pool.get('vendas.utils').venutl_get_total_debito_orcamento(
        cr, uid, pessoa_ids, context)
    outros_debitos_ped = self.pool.get('vendas.utils').venutl_get_total_debito_pedido(
        cr, uid, pessoa_ids, context)
    outros_debitos_nf = self.pool.get('vendas.utils').venutl_get_total_debito_nota_fiscal(
        cr, uid, pessoa_ids, context)
    limite_credito_pessoas = self.pool.get('vendas.utils').venutl_get_limite_credito_cliente(
                cr, uid, pessoa_ids, context=context)
    bloqueado_por_msg_pessoas = self.pool.get('vendas.utils').venutl_cliente_bloqueado_por_msg(
            cr, uid, pessoa_ids, context=context)
    dict_valor_receber = obj_financeiro_util.finutl_get_valor_a_vencer(cr, uid, pessoa_ids, context)
    for i in dados_resticoes:
        orcamento_id = i.get('venlre_orcamento_id') or False
        pedido_id = i.get('venlre_pedido_id') or False
        nf_id = i.get('venlre_nf_id') or False
        if not any([orcamento_id, pedido_id, nf_id]):
            res[i['id']] = {}
            continue

        pessoa_id = (docs_pessoas_ids.get('nota') or {}).get(nf_id) or \
                    (docs_pessoas_ids.get('pedido') or {}).get(pedido_id) or \
                    (docs_pessoas_ids.get('orcamento') or {}).get(orcamento_id)

        outros_debitos = sum([outros_debitos_nf.get(pessoa_id) or 0,
                              outros_debitos_ped.get(pessoa_id) or 0,
                              outros_debitos_orc.get(pessoa_id) or 0])

        if nf_id:
            valor_debito = docs_valor.get('nota').get(nf_id) or 0
            if outros_debitos_nf.get(pessoa_id):
                outros_debitos -= valor_debito
        elif pedido_id:
            valor_debito = docs_valor.get('pedido').get(pedido_id) or 0
            if outros_debitos_ped.get(pessoa_id):
                outros_debitos -= valor_debito
        else:
            valor_debito = docs_valor.get('orcamento').get(orcamento_id) or 0
            if outros_debitos_orc.get(pessoa_id):
                outros_debitos -= valor_debito

        # Verifica se a pessoa esta bloqueada por msg
        bloqueado_por_msg = bloqueado_por_msg_pessoas.get('pessoa_ids').get(pessoa_id) or False
        if bloqueado_por_msg:
            bloqueado_por_msg = True

        # Verifica se a pessoa esta bloqueada por titulos atrasados
        valor_titulo_em_atraso = pessoa_valor_atraso.get(pessoa_id) or 0
        bloqueado_por_titulo_atraso = True if valor_titulo_em_atraso else False

        # Verifica se esta bloqueado por limite de credito
        limite_credito = limite_credito_pessoas.get('pessoa_ids').get(pessoa_id) or 0

        # Decresce o total do limite de credito em funcao dos valores em aberto
        novo_limite_credito = limite_credito - (pessoa_total_aberto.get(pessoa_id) or 0)
        bloqueado_por_limite_credito = (True if valor_debito > novo_limite_credito else False) or \
            novo_limite_credito == 0
        valor_titulos_a_vencer = dict_valor_receber.get(pessoa_id) or 0
        res[i['id']] = dict(venlre_total_debito=valor_titulos_a_vencer + valor_titulo_em_atraso +
                            outros_debitos,
                            venlre_limite_debito=outros_debitos,
                            venlre_bloqueado_por_msg=bloqueado_por_msg,
                            venlre_valor_documento=valor_debito,
                            venlre_valor_limite_credito=limite_credito,
                            venlre_valor_titulos_atrasados=valor_titulo_em_atraso,
                            venlre_bloqueado_limite_credito=bloqueado_por_limite_credito,
                            venlre_bloqueado_titulo_atrasado=bloqueado_por_titulo_atraso,
                            venlre_titulos_em_aberto=valor_titulos_a_vencer + valor_titulo_em_atraso,
                            venlre_titulos_a_vencer=valor_titulos_a_vencer
                            )

    return res

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
