# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br   
#
##############################################################################

from openerp.osv import osv, fields


class vendas_grupos_produto(osv.Model):
    """
    Tabela de comissoes por grupos de produtos ou por produtos
    Nesta tabela se o tipo de faixa for C, informar a categoria, e for P informar o codigo do produto
    
    """
    _name = 'vendas.grupos.produto'
    _columns = {
        'tipo': fields.selection([('C', 'Categoria'), ('P', 'Produto')], 'Tipo', required=True, size=1),
        'produto_id': fields.many2one("estoque.produto", 'Produto', ondelete="cascade", select=True), # id do produto
        'categoria_id': fields.many2one("estoque.categoria", 'Categoria', ondelete="restrict", select=True),
        'comissao': fields.float('Comissao', digits=(6, 4), required=True), # Percentual de comissao a ser pago
    }
    _defaults = {
        'comissao': lambda *a: 0,
    }
