# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields
import time


class vendas_liberar_desconto(osv.Model):
    from funcoes import venauv_lib_desconto_functions

    _name = 'vendas.liberar.desconto'
    _columns = {
        'venauv_user_id': fields.many2one('res.users', 'Autorizado por', required=1, ondelete="restrict"),
        'venauv_pedido_id': fields.many2one('estoquepedidos.pedido.capa', 'Pedido', ondelete="cascade"),
        'venauv_data': fields.datetime('Data/Hora da autorizacao', required=1, ),
        'venauv_autorizado': fields.boolean('Autorizado'),

        #_____________________fields function ____________________________
        'venauv_valor_bruto': fields.function(venauv_lib_desconto_functions, multi='desconto_functions', digits=(12, 2),
                                              method=True, store=True, oldname='venauv_mensagem_bloqueio', type="float",
                                              string='Valor Bruto', required=0
        ),
        'venauv_valor_liquido': fields.function(venauv_lib_desconto_functions, multi='desconto_functions',
                                                digits=(12, 2),
                                                method=True, store=True, oldname='venauv_mensagem_bloqueio',
                                                type="float", string='Valor Liquido', required=0
        ),
        'venauv_desconto': fields.function(venauv_lib_desconto_functions, multi='desconto_functions', digits=(12, 2),
                                           method=True, store=True, oldname='venauv_mensagem_bloqueio', type="float",
                                           string='Desconto Lancado', required=0
        ),
    }
    _defaults = {
        'venauv_user_id': lambda obj, cr, uid, context: uid,
        'venauv_data': lambda *a: time.strftime('%Y-%m-%d %H:%M:%S'),
        'venauv_autorizado': False,
    }
    _order = 'venauv_data desc'
    _sql_constraints = [
        ( 'venauv_pedido_uniq', 'unique(venauv_pedido_id)', 'Pedido ja cadastrado em outra restricao!' ),
    ]
