# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class vendas_vendedor(osv.Model):
    """
    Tabela de Vendedores

    prefixo: venven_
    """
    _name = 'vendas.vendedor'
    _description = "Cadastro de vendedores"
    _inherits = {
        'adm.pessoa': 'pessoa_id',
    }
    _roteavel = True
    _columns = {
        'id': fields.integer('Codigo'),
        'pessoa_id': fields.many2one("adm.pessoa", 'Pessoa ', ondelete="restrict", required=True, select=True),
        'company_id': fields.many2one("res.company", 'Empresa ', ondelete="cascade", required=True, select=True),
        'percentual': fields.float('Percentual', digits=(6, 3)), # Percentual de comissao a ser pago.
        'active': fields.boolean('Ativo'), # True=Ativo, \nFalse=Inativo
        'tipo': fields.selection([('I', 'Interno'), ('E', 'Externo')], 'Tipo de vendedor', required=True, size=1),
        'supervisor_id': fields.many2one("vendas.vendedor", 'Supervisor ', ondelete="restrict", select=True),
        'vendedor_ids': fields.one2many('vendas.vendedor', 'supervisor_id', 'Vendedor'),
        'financeiro_cliente_ids': fields.one2many('financeiro.cliente', 'vendedor_id', 'Cliente'),
    }
    _defaults = {
        'active': lambda *a: True,
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, s._name, context=c),
        'tipo': lambda *a: 'I',
    }


