# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        title = center_title('', _('Listagem de pedidos de venda'), '')
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Pedido de Venda'))
        listagem.informaTamLinha(160)

        obj_estoquepedidos_pedido_capa = pooler.get_pool(cr.dbname).get('estoquepedidos.pedido.capa')

        vendedor_id = datas.get('vendedor_id')
        vendedor_externo_id = datas.get('vendedor_externo_id')
        data_ini = datas.get('data_ini')
        data_fim = datas.get('data_fim')
        company_id = datas.get('company_id')
        pessoa_id = datas.get('pessoa_id')
        state = datas.get('state')

        args = [('tipo', '=', 'V'), ('company_id', '=', company_id)]
        if vendedor_id:
            args.append(('vendedor_id', '=', vendedor_id), )
        if vendedor_externo_id:
            args.append(('vendedor_externo_id', '=', vendedor_externo_id), )
        if data_ini:
            args.append(('data_emissao', '>=', data_ini), )
        if data_fim:
            args.append(('data_emissao', '<=', data_fim), )
        if pessoa_id:
            args.append(('pessoa_id', '=', pessoa_id), )
        if state:
            args.append(('state', '=', state), )

        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(
            cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        estoquepedidos_pedido_capa_ids = obj_estoquepedidos_pedido_capa.search(
            cr, uid, args, context=context)

        # sql = """
        #     SELECT
        #         epc.id, epc.numero_pedido, epc.data_emissao, epc.state, epc.valor_total,
        #         ap.codigo || ' - ' || ap.name AS pessoa,
        #         apvi.name AS vendedor,
        #         apve.name AS vendedor_externo
        #     FROM
        #         estoquepedidos_pedido_capa epc
        #     LEFT JOIN
        #         vendas_vendedor vvi ON vvi.id = epc.vendedor_id
        #     LEFT JOIN
        #         vendedas_vendedor vve ON vve.id = epc.vendedor_externo_id
        #     LEFT JOIN
        #         adm_pessoa ap ON ap.id = epc.pessoa_id
        #     LEFT JOIN
        #         adm_pessoa apvi ON vvi.pessoa_id = apvi.id
        #     LEFT JOIN
        #         adm_pessoa apve ON vve.pessoa_id = apve.id
        #     WHERE
        #         company_id = {company_id}
        #         AND tipo = 'V'
        #         {vendedor_id}
        #         {vendedor_externo_id}
        #         {data_ini}
        #         {data_fim}
        #         {pessoa_id}
        #         {state}
        #     ORDER BY numero_pedido DESC
        # """.format(company_id=company_id,
        #            vendedor_id=vendedor_id and ('AND epc.vendedor_id = %s' % vendedor_id) or '',
        #            vendedor_externo_id=vendedor_externo_id
        #            and ('AND epc.vendedor_externo_id = %s' % vendedor_externo_id) or '',
        #            data_ini=data_ini and ('epc.data_emissao >= %s' % data_ini) or '',
        #            data_fim=data_fim and ('epc.data_emissao <= %s' % data_fim) or '',
        #            pessoa_id=pessoa_id and ('epc.pessoa_id = %s' % pessoa_id) or '',
        #            state=state and ('epc.state = %s' % state) or ''
        #            )
        # cr.execute(sql)
        # estoquepedidos_pedido_capa_dados = cr.dictfetchall()
        estoquepedidos_pedido_capa_dados = obj_estoquepedidos_pedido_capa.read(
            cr, uid, estoquepedidos_pedido_capa_ids,
            ['numero_pedido', 'data_emissao', 'pessoa_id', 'vendedor_id', 'vendedor_externo_id',
             'state', 'valor_total'], context=context)
        estoquepedidos_pedido_capa_dados = sorted(
            estoquepedidos_pedido_capa_dados, key=lambda x: x.get('numero_pedido'), reverse=True)
        data = time.strftime("%d/%m/%Y")#,time.strptime(read_inv_capa['create_date'][:10],"%Y-%m-%d"))
        docs = center_title(data, nome_empresa, _('Pagina: {{ Page }} '))
        if data_ini:
            data_ini = time.strftime("%d/%m/%Y", time.strptime(data_ini, "%Y-%m-%d"))
        else:
            data_ini = ''
        if data_fim:
            data_fim = time.strftime("%d/%m/%Y", time.strptime(data_fim, "%Y-%m-%d"))
        else:
            data_fim = ''
        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab('  ')
        if data_ini or data_fim:
            if len(data_ini) < 2:
                data_ini = '~'
            if len(data_fim) < 2:
                data_fim = '~'
            listagem.informaCab('             ' + _('Periodo: ') + data_ini + _(' a ') + data_fim + '          ')
        listagem.informaCab(
            '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(
            _('|    NUMERO    |   DATA    |            CLIENTE             |   VALOR     |       VENDEDOR INTERNO       |      VENDEDOR EXTERNO       |    STATUS   |'))
        listagem.informaCab(
            '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(
            _('|              |           |                                |             |                              |                             |             |'))
        listagem.rodapePadrao()
        total_notas = []
        total_valor = []
        for pedido in estoquepedidos_pedido_capa_dados:
            valor_total = pedido.get('valor_total')
            vendedor = pedido.get('vendedor_id')
            if vendedor:
                vendedor = pedido.get('vendedor_id')[1]
            vendedor_externo = pedido.get('vendedor_externo_id')
            if vendedor_externo:
                vendedor_externo = pedido.get('vendedor_externo_id')[1]
            pessoa = pedido.get('pessoa_id')
            if pessoa:
                pessoa = pedido.get('pessoa_id')[1]
            estados = obj_estoquepedidos_pedido_capa.pedcap_fields_selection_state(cr, uid, context=context)
            state = pedido.get('state')
            dict_state = {}
            for x in estados:
                dict_state[x[0]] = x[1]
            state = dict_state.get(state, 'Nao identificado')
            linha = formataString(pedido.get('numero_pedido') or '', 14, ' ', 'D', 'N', 'S') + '|'
            linha += formataString(
                time.strftime("%d/%m/%Y", time.strptime(pedido.get('data_emissao'), "%Y-%m-%d")) or '', 11, ' ', 'D',
                'N', 'S') + '|'
            linha += formataString(pessoa or '', 32, ' ', 'D', 'N', 'S') + '|'
            linha += formataString(getNumeroEditado(valor_total) or 0.0, 13, ' ', 'E', 'N', 'S') + '|'
            linha += formataString(vendedor or '', 30, ' ', 'D', 'N', 'S') + '|'
            linha += formataString(vendedor_externo or '', 29, ' ', 'D', 'N', 'S') + '|'
            linha += formataString(state, 13, ' ', 'D', 'N', 'S') + '|'
            listagem.imprimeLinha('|' + linha)
            total_notas.append(1)
            total_valor.append(valor_total)
        listagem.imprimeLinha(
            '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.imprimeLinha(
            _('TOTAL: ---->  ') + str(len(total_notas)) + '                                               ' + str(
                getNumeroEditado(sum(total_valor))) + '                   ')
        listagem.imprimeLinha(
            '*----------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.imprimeLinha(
            _('                                                                                                                   ** Sig Informatica LTDA **       '))

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')


report_custom('report.pedido_venda')


class relatorio_pedido_venda_osv(osv.TransientModel):
    """
    Heranca da classe ´relatorio_pedido_venda_osv´.
    """

    _inherit = 'relatorio.pedido.venda.osv'

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        relatorio_pedido_venda_osv_dados = self.read(cr, uid, ids, [], context=context)
        for x in relatorio_pedido_venda_osv_dados:
            if x.get('data_ini') > x.get('data_fim'):
                raise osv.except_osv(_('Atencao'), _('Data inicial nao pode ser maior que a data '
                                                     'final'))
            company_id = x.get('company_id')
            if isinstance(company_id, tuple):
                company_id = company_id[0]
            vendedor_id = x.get('vendedor_id')
            if isinstance(vendedor_id, tuple):
                vendedor_id = vendedor_id[0]
            vendedor_externo_id = x.get('vendedor_externo_id')
            if isinstance(vendedor_externo_id, tuple):
                vendedor_externo_id = vendedor_externo_id[0]
            pessoa_id = x.get('pessoa_id')
            if isinstance(pessoa_id, tuple):
                pessoa_id = pessoa_id[0]
            datas = {
                'company_id': company_id,
                'vendedor_id': vendedor_id,
                'vendedor_externo_id': vendedor_externo_id,
                'pessoa_id': pessoa_id,
                'data_ini': x.get('data_ini'),
                'data_fim': x.get('data_fim'),
                'state': x.get('state')
            }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'pedido_venda',
            'datas': datas,
        }
