# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2016 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2016, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""

from openerp.osv import fields, osv


# noinspection PyAbstractClass,PyPep8Naming
class relatorio_pedido_venda_osv(osv.TransientModel):
    """
    Formulario de dados de pedido de venda para elaboracao de relatorio.
    """

    _name = 'relatorio.pedido.venda.osv'

    # noinspection PyMethodMayBeStatic
    def get_pedido_status(self, cr, user, context=None):
        """
        Retorna os estados (´status´) possiveis para o campo ´state´ do relatorio de pedido de
        venda.

        :param cr: a linha atual do cursor do banco de dados
        :param user: o ID do usuario utilizado para a verificacao de perfil
        :param context: um dicionario padrao para valores contextuais
        :type cr: cursor
        :type user: int
        :type context: dict
        :return: lista com os valores possiveis de selecao para o campo ´status´ (estado do pedico).
        :rtype: list

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}
        return [('R', 'Esboco'), ('V', 'Validado'), ('S', 'Em separacao'), ('D', 'Separado'),
                ('F', 'Faturado'), ('C', 'Cancelado')]

    _columns = {
        'company_id': fields.many2one("res.company", 'Empresa ', required=True),
        'vendedor_id': fields.many2one('vendas.vendedor', 'Vendedor', domain="[('tipo','=','I')]"),
        'vendedor_externo_id': fields.many2one('vendas.vendedor', 'Vendedor externo',
                                               domain="[('tipo','=','E')]"),
        'pessoa_id': fields.many2one('adm.pessoa', 'Cliente'),
        'state': fields.selection(get_pedido_status, 'Estado do pedido', size=1),
        'data_ini': fields.date('Data inicial'),
        'data_fim': fields.date('Data final')
    }
    _defaults = {
        'company_id': lambda s, cr, uid, c: s.pool.get('adm.empresa.objeto').getEmpresa(
            cr, uid, s._name, context=c),
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
