# *-* encoding: utf-8 *-*


from openerp.report.interface import report_int
from openerp.report.render import render
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
import StringIO
from openerp import pooler
from datetime import datetime
import time
from SigUtils.formatastring import formataString
from openerp.tools.translate import _

class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def render(self):
        return self.pdf

class report_custom(report_int):
    def create(self, cr, uid, ids, datas, context=None):
        def center_title(E, C, D, T=110):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        title = center_title('', _('RESUMO DE VENDAS'), '', 110)
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao=0)
        listagem.informaNome(pdf_string, _('resumo vendas'))
        listagem.defineMargem(0.5, 0.5, 0.5, 0.5)
        listagem.defineFonte(tam=8.0)

        data_inicial = datas.get('data_inicial')
        data_final = datas.get('data_final')

        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(
            cr, uid, 'wizard.resumo.vendas', context=context)
        nome_empresa = pooler.get_pool(cr.dbname).get('res.company').browse(
            cr, uid, company_id).name
        data = time.strftime("%d/%m/%Y")
        docs = center_title(data, nome_empresa, 'Pagina: {{ Page }}', 110)
        quantidade_vendas = datas.get('quantidade_vendas') or 0
        vr_total = datas.get('vr_total')
        docs1 = center_title('Qtd. de vendas: %s' % (quantidade_vendas if vr_total else 0),
                             'Ticket medio: %s' % getNumeroEditado((vr_total / quantidade_vendas)
                                                                   if quantidade_vendas else 0),
                             'Total: %s' % getNumeroEditado(vr_total),
                             110)
        data_ini = time.strftime('%d/%m/%Y', time.strptime(data_inicial, '%Y-%m-%d'))
        data_fi = time.strftime('%d/%m/%Y', time.strptime(data_final, '%Y-%m-%d'))
        periodo = center_title('', 'PERIODO: %s a %s' % (data_ini, data_fi), '')

        listagem.informaCab(title)
        listagem.informaCab('')
        listagem.informaCab(periodo)
        listagem.informaCab('')
        listagem.informaCab(docs)
        listagem.informaCab('')
        listagem.informaCab(docs1)
        listagem.informaCab('')
        listagem.rodapePadrao()

        if datas.get('modelo_serie_valor'):
            listagem.imprimeLinha('*' + '-' * 58 + '*' + '   ' + '*' + '-' * 47 + '*')
          # listagem.imprimeLinha(_('|      MODELO      |     SERIE     |         VALOR         '
          #                         '|   |      MODELO        |          VALOR           |'))
            listagem.imprimeLinha(_('|MODELO  |SERIE  |  INICIAL|    FINAL|                VALOR'
                                    '|   |      MODELO        |          VALOR           |'))
            listagem.imprimeLinha('*' + '-' * 58 + '*' + '   ' + '*' + '-' * 47 + '*')

        dados = datas.get('modelo_serie_valor')
        modelo_valor =  {}
        for i in dados:
            if modelo_valor.get(i.get('modelo')):
                modelo_valor[i.get('modelo')] += i.get('valor')
            else:
                modelo_valor[i.get('modelo')] = i.get('valor')

        cont_modelo = 0
        list_modelo_valor = modelo_valor.items()
        for i in dados:
            linha = '|'
            linha += formataString(i.get('modelo'), 8, ' ', 'D', 'S', 'S')
            linha += '|'
            linha += formataString(i.get('serie'), 7, ' ', 'D', 'S', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(i.get('inicial') or 0, 0), 9, ' ', 'E', 'S','S')
            linha += '|'
            linha += formataString(getNumeroEditado(i.get('final') or 0, 0), 9, ' ', 'E', 'S','S')
            linha += '|'
            linha += formataString(getNumeroEditado(i.get('valor') or 0.0, 2), 21, ' ', 'E', 'S','S')
            linha += '|'

            if cont_modelo < len(list_modelo_valor):
                modelo = list_modelo_valor[cont_modelo]
                linha += '   '
                linha += '|'
                linha += formataString(modelo[0], 20, ' ', 'D', 'S', 'S')
                linha += '|'
                linha += formataString(getNumeroEditado(modelo[1] or 0.0, 2), 26, ' ', 'E', 'S',
                                       'S')
                linha += '|'
                cont_modelo += 1

            listagem.imprimeLinha(linha)
        if datas.get('modelo_serie_valor'):
            listagem.imprimeLinha('*' + '-' * 110 + '*')
            listagem.imprimeLinha(' ')
            listagem.imprimeLinha(' ')

        if datas.get('pagamento_condicao_valor'):
            listagem.imprimeLinha(
                _(
                    '*---------------------------------------------------------------------*   *------------------------------------*'))
            listagem.imprimeLinha(
                _(
                    '|FORMA DE PAGAMENTO|            CONDICAO            |   VALOR  |% PART|   |SE|FORMA  PAGAMENTO|   VALOR  |%PART|'))
            listagem.imprimeLinha(
                _(
                    '*---------------------------------------------------------------------*   *------------------------------------*'))

        dados = datas.get('pagamento_condicao_valor')

        list_condicao_pagamento = list(set(map(lambda i: i.get('forma_pagto') + '!' + i.get('condicao_forma'), dados)))
        dados1 = []
        for i in list_condicao_pagamento:
            forma_pagamento_dados = (filter(lambda x: x.get('forma_pagto') + '!' + x.get('condicao_forma') == i, dados))
            valor_cond = sum(map(lambda x: x.get('valor_cond'), forma_pagamento_dados))
            participacao = round(valor_cond / vr_total * 100.0, 2)
            dados1.append({'forma_pagto': i.split('!')[0], 'condicao_forma': i.split('!')[1],
                           'valor_cond': valor_cond, 'participacao': participacao})
        dados1 = sorted(dados1, key=lambda c: c.get('participacao'), reverse=True)
        list_forma_pagamento = list(set(map(lambda i: i.get('forma_pagto'), dados)))
        dados2 = []
        for i in list_forma_pagamento:
            forma_dados = (filter(lambda x: x.get('forma_pagto') == i, dados))
            valor_cond = sum(map(lambda x: x.get('valor_cond'), forma_dados))
            participacao = round(valor_cond / vr_total * 100.0, 2)
            dados2.append({'forma_pagto': i, 'valor_cond': valor_cond,
                           'participacao': participacao})
        dados2 = sorted(dados2, key=lambda c: c.get('participacao'), reverse=True)

        list_participacao_1 = map(lambda t: t.get('participacao'), dados1)
        total_participacao_1 = sum(list_participacao_1)
        maior_participacao_1 = max(list_participacao_1)
        list_participacao_2 = map(lambda t: t.get('participacao'), dados2)
        total_participacao_2 = sum(list_participacao_2)
        maior_participacao_2 = max(list_participacao_2)
        se = 0
        for i in dados1:
            p_participacao1 = i.get('participacao') or 0.0
            if total_participacao_1 != 100.0 and p_participacao1 == maior_participacao_1:
                if total_participacao_1 > 100.0:
                    p_participacao1 -= (total_participacao_1 - 100.0)
                if total_participacao_1 < 100.0:
                    p_participacao1 += (100.0 - total_participacao_1)
            linha = '|'
            linha += formataString(i.get('forma_pagto'), 18, ' ', 'D', 'S', 'S')
            linha += '|'
            linha += formataString(i.get('condicao_forma'), 32, ' ', 'D', 'S', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(i.get('valor_cond') or 0.0, 2), 10, ' ', 'E', 'S', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(p_participacao1, 2), 6, ' ', 'E',
                                   'S', 'S')
            linha += '|'
            linha += '   '
            try:
                p_participacao2 = dados2[dados1.index(i)].get('participacao') or 0.0
                if total_participacao_2 != 100.0 and p_participacao2 == maior_participacao_2:
                    if total_participacao_2 > 100.0:
                        p_participacao2 -= (total_participacao_2 - 100.0)
                    if total_participacao_2 < 100.0:
                        p_participacao2 += (100.0 - total_participacao_2)
                se += 1
                linha += '|'
                linha += formataString(getNumeroEditado(se, 0), 2, '0', 'E', 'S', 'S')
                linha += '|'
                linha += formataString(dados2[dados1.index(i)].get('forma_pagto'), 16, ' ', 'D', 'S', 'S')
                linha += '|'
                linha += formataString(getNumeroEditado(dados2[dados1.index(i)].get('valor_cond') or 0.0, 2), 10, ' ', 'E', 'S', 'S')
                linha += '|'
                linha += formataString(getNumeroEditado(p_participacao2, 2), 5, ' ', 'E', 'S', 'S')
                linha += '|'
            except:
                pass
            listagem.imprimeLinha(linha)
        if datas.get('pagamento_condicao_valor'):
            listagem.imprimeLinha('*' + '-' * 110 + '*')
            listagem.imprimeLinha(' ')
            listagem.imprimeLinha(' ')

        if datas.get('cfop_natureza_valor'):
            listagem.imprimeLinha('*' + '-' * 53 + '*' + '   ' + '*' + '-' * 52 + '*')
            listagem.imprimeLinha(_('|           CFOP           |           VALOR          |   '
                                    '|       NATUREZA       |         VALOR        |% PART|'))
            listagem.imprimeLinha('*' + '-' * 53 + '*' + '   ' + '*' + '-' * 52 + '*')

        dados = datas.get('cfop_natureza_valor')
        natureza_valor =  {}
        for i in dados:
            if natureza_valor.get(i.get('natureza_fiscal')):
                natureza_valor[i.get('natureza_fiscal')] += i.get('valor')
            else:
                natureza_valor[i.get('natureza_fiscal')] = i.get('valor')

        cont_natureza = 0
        list_natureza_valor = natureza_valor.items()
        for i in dados:
            linha = '|'
            linha += formataString(i.get('codigo_cfop'), 26, ' ', 'D', 'S', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(i.get('valor') or 0.0, 2), 26, ' ', 'E', 'S',
                                   'S')
            linha += '|'
            if cont_natureza < len(list_natureza_valor):
                natureza = list_natureza_valor[cont_natureza]
                valor_natureza = natureza[1] or 0.0
                participacao = round(valor_natureza / vr_total * 100.0, 2)
                linha += '   '
                linha += '|'
                linha += formataString(natureza[0], 22, ' ', 'D', 'S', 'S')
                linha += '|'
                linha += formataString(getNumeroEditado(valor_natureza, 2), 22, ' ', 'E', 'S', 'S')
                linha += '|'
                linha += formataString(getNumeroEditado(participacao, 2), 6, ' ', 'E', 'S', 'S')
                linha += '|'
                cont_natureza += 1

            listagem.imprimeLinha(linha)
        if datas.get('cfop_natureza_valor'):
            listagem.imprimeLinha('*' + '-' * 110 + '*')
            listagem.imprimeLinha(' ')
            listagem.imprimeLinha(' ')

        if datas.get('devolucao_vendas_valor'):
            listagem.imprimeLinha(center_title('', _('DEVOLUCAO DE VENDAS'), ''))

            listagem.imprimeLinha(' ')

            listagem.imprimeLinha('*' + '-' * 110 + '*')
            listagem.imprimeLinha(_('|                       CLIENTE                        '
                                    '|       NOTA       |      SERIE      |       VALOR      |'))
            listagem.imprimeLinha('*' + '-' * 110 + '*')

        dados = datas.get('devolucao_vendas_valor')

        for i in dados:
            linha = '|'
            linha += formataString(i.get('pessoa'), 54, ' ', 'D', 'S', 'S')
            linha += '|'
            linha += formataString(i.get('nota'), 18, ' ', 'E', 'S', 'S')
            linha += '|'
            linha += formataString(i.get('serie'), 17, ' ', 'E', 'S', 'S')
            linha += '|'
            linha += formataString(getNumeroEditado(i.get('valor') or 0.0, 2), 18, ' ', 'E', 'S', 'S')
            linha += '|'
            listagem.imprimeLinha(linha)

        if datas.get('devolucao_vendas_valor'):
            listagem.imprimeLinha('*' + '-' * 110 + '*')

            vr_total_entrada = sum(map(lambda i: i.get('valor'), dados))
            linha = formataString('TOTAL', 84, ' ', 'D', 'S', 'S')
            linha += formataString(getNumeroEditado(vr_total_entrada, 2), 27, ' ', 'E', 'S', 'S')
            listagem.imprimeLinha(linha)

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

report_custom('report.resumo_vendas')
