# -*- encoding: utf-8 -*-
from SigUtils.formatastring import formataString
from SigUtils.impressao import Impressora
from SigUtils.numero import getNumeroEditado
from openerp.osv import osv, fields
from openerp.report.interface import report_int
from openerp.report.render import render
import StringIO
import time
from openerp import pooler
import calendar
from openerp.tools.translate import _


class external_pdf(render):
    def __init__(self, pdf):
        render.__init__(self)
        self.pdf = pdf
        self.output_type = 'pdf'

    def _render(self):
        return self.pdf


class report_custom(report_int):
    def create(self, cr, uid, ids, datas_filtro, context=None):
        def center_title(E, C, D, T=160):
            title_c = (T - len(C)) / 2
            title = E
            for i in range(title_c - len(E)):
                title += ' '
            title += C
            for i in range(title_c - len(D)):
                title += ' '
            title += D
            return title

        context = context and context.copy() or {}
        title = center_title(_('Contr.Estoque'), _('Rel. Faturamento/Rentabilidade'), _('Est490'))
        pdf_string = StringIO.StringIO()
        listagem = Impressora()
        listagem.defineFormato(orientacao='0')
        listagem.informaNome(pdf_string, _('Faturamento e Rentabilidade'))
        listagem.informaTamLinha(160)

        obj_vendas_previsao_receita = pooler.get_pool(cr.dbname).get('vendas.previsao.receita')
        company_id = pooler.get_pool(cr.dbname).get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                                    'wizard.faturamento.rentabilidade', context=context)
        res_company_dados = pooler.get_pool(cr.dbname).get('res.company').read(cr, uid, company_id, ['name'], context=context)
        nome_empresa = res_company_dados.get('name')
        data = time.strftime("%d/%m/%Y")
        custo = datas_filtro.get('custo')
        if custo == 'M':
            custo_extenso = _('Medio')
        elif custo == 'C':
            custo_extenso = _('Corrigido')
        elif custo == 'U':
            custo_extenso = _('Ultimo')
        else:
            custo_extenso = _('Reposicao')
        custo_titulo = _('Custo: ') + custo_extenso
        mes = datas_filtro.get('mes')
        ano = datas_filtro.get('ano')
        data_titulo = str(mes) + '/' + str(ano)
        docs = center_title(data, custo_titulo, nome_empresa, 100)
        docs += center_title(' ', data_titulo, _('Pagina: {{ Page }} '), 60)

        percentual_rentabilidade = datas_filtro.get('percentual_rentabilidade')

        datas = []
        calendar.setfirstweekday(calendar.SUNDAY)
        dias = calendar.monthcalendar(int(ano), int(mes))
        for semana in dias:
            for dia in range(0, len(semana)):
                if dia != 0 and semana[dia] != 0:
                    datas.append(semana[dia])

        listagem.informaCab('' + title)
        listagem.informaCab('')
        listagem.informaCab('')
        listagem.informaCab('' + docs)
        listagem.informaCab('  ')
        listagem.informaCab(
            '*--------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(
            _('|    ------------------------- F A T U R A M E N T O -------------------------| ------------------------- R E N T A B I L I D A D E ---------------------|'))
        listagem.informaCab(
            '*--------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab(
            _('|Dia   Previsao        Real   Dif. %     Dif. R$      Acum. Dif     Acumulado |    Previsao        Real   Dif. %     Dif. R$      Acum. Dif     Acumulado|'))
        listagem.informaCab(
            '*--------------------------------------------------------------------------------------------------------------------------------------------------------*')
        listagem.informaCab('  ')
        listagem.imprimeLinha(' ')
        listagem.rodapePadrao()

        acum_dif_valor_fat = 0
        acum_dif_valor_rent = 0
        acum_valor_movimento = 0
        acum_valor_rent = 0
        total_valor_previsao = 0
        total_valor_movimento = 0
        total_dif_porc_fat = 0
        total_dif_valor_fat = 0
        total_previsao_rentabilidade = 0
        total_rent_real = 0
        total_dif_porc_rent = 0
        total_dif_valor_rent = 0
        for i in datas:
            previsao_receita_ids = obj_vendas_previsao_receita.search(cr, uid, [
                ('venprc_data', '=', str(ano) + '-' + str(mes) + '-' + str(i))], order='venprc_data ASC',
                                                                      context=context)
            previsao_receita_dados = obj_vendas_previsao_receita.browse(cr, uid, previsao_receita_ids)
            dt_dados = str(ano) + '-' + str(mes) + '-' + str(i).zfill(2)
            movimento_dados = self.get_dados(cr, dt_dados)
            valor_previsao = 0
            valor_movimento = 0
            custo_movimento = 0
            for x in previsao_receita_dados:
                valor_previsao += x.venprc_valor
            for movimento in movimento_dados:
                valor_movimento += movimento.get('vr_total_item')
                quantidade = movimento.get('quantidade') or 1
                if custo == 'M':
                    custo_movimento += (movimento.get('custo_medio_contabil') or 0.00) / quantidade
                elif custo == 'C':
                    custo_movimento += (movimento.get('custo_corrigido') or 0.00) / quantidade
                elif custo == 'U':
                    custo_movimento += (movimento.get('ultimo_custo') or 0.00) / quantidade
                else:
                    custo_movimento += (movimento.get('custo_reposicao') or 0.00) / quantidade
            linha = formataString(i, 4, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(valor_previsao), 11, ' ', 'E', 'N', 'S')
            total_valor_previsao += valor_previsao
            linha += formataString(getNumeroEditado(valor_movimento), 12, ' ', 'E', 'N', 'S')
            total_valor_movimento += valor_movimento
            acum_valor_movimento += valor_movimento
            if not valor_previsao:
                dif_porc_fat = 0
            else:
                dif_porc_fat = (valor_movimento - valor_previsao) * 100 / valor_previsao
            linha += formataString(getNumeroEditado(dif_porc_fat), 9, ' ', 'E', 'N', 'S')
            total_dif_porc_fat += dif_porc_fat
            dif_valor_fat = valor_movimento - valor_previsao
            total_dif_valor_fat += dif_valor_fat
            linha += formataString(getNumeroEditado(dif_valor_fat), 12, ' ', 'E', 'N', 'S')
            acum_dif_valor_fat += dif_valor_fat
            linha += formataString(getNumeroEditado(acum_dif_valor_fat), 15, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(acum_valor_movimento), 14, ' ', 'E', 'N', 'S')
            linha += ' | '
            previsao_rentabilidade = percentual_rentabilidade * valor_previsao / 100
            linha += formataString(getNumeroEditado(previsao_rentabilidade), 11, ' ', 'E', 'N', 'S')
            total_previsao_rentabilidade += previsao_rentabilidade
            rent_real = valor_movimento - custo_movimento
            linha += formataString(getNumeroEditado(rent_real), 12, ' ', 'E', 'N', 'S')
            total_rent_real += rent_real
            acum_valor_rent += rent_real
            if not previsao_rentabilidade:
                dif_porc_rent = 0
            else:
                dif_porc_rent = (rent_real - previsao_rentabilidade) * 100 / previsao_rentabilidade
            linha += formataString(getNumeroEditado(dif_porc_rent), 9, ' ', 'E', 'N', 'S')
            total_dif_porc_rent += dif_porc_rent
            dif_valor_rent = rent_real - previsao_rentabilidade
            linha += formataString(getNumeroEditado(dif_valor_rent), 12, ' ', 'E', 'N', 'S')
            total_dif_valor_rent += dif_valor_rent
            acum_dif_valor_rent += dif_valor_rent
            linha += formataString(getNumeroEditado(acum_dif_valor_rent), 15, ' ', 'E', 'N', 'S')
            linha += formataString(getNumeroEditado(acum_valor_rent), 14, ' ', 'E', 'N', 'S')

            listagem.imprimeLinha(linha)

        listagem.imprimeLinha(
            '*--------------------------------------------------------------------------------------------------------------------------------------------------------*')
        linha = formataString(getNumeroEditado(total_valor_previsao), 15, ' ', 'E', 'N', 'S')
        linha += formataString(getNumeroEditado(total_valor_movimento), 12, ' ', 'E', 'N', 'S')
        linha += formataString(getNumeroEditado(total_dif_porc_fat), 9, ' ', 'E', 'N', 'S')
        linha += formataString(getNumeroEditado(total_dif_valor_fat), 12, ' ', 'E', 'N', 'S')
        linha += formataString(getNumeroEditado(acum_dif_valor_fat), 15, ' ', 'E', 'N', 'S')
        linha += formataString(getNumeroEditado(acum_valor_movimento), 14, ' ', 'E', 'N', 'S')
        linha += ' | '
        linha += formataString(getNumeroEditado(total_previsao_rentabilidade), 11, ' ', 'E', 'N', 'S')
        linha += formataString(getNumeroEditado(total_rent_real), 12, ' ', 'E', 'N', 'S')
        linha += formataString(getNumeroEditado(total_dif_porc_rent), 9, ' ', 'E', 'N', 'S')
        linha += formataString(getNumeroEditado(total_dif_valor_rent), 12, ' ', 'E', 'N', 'S')
        linha += formataString(getNumeroEditado(acum_dif_valor_rent), 15, ' ', 'E', 'N', 'S')
        linha += formataString(getNumeroEditado(acum_valor_rent), 14, ' ', 'E', 'N', 'S')
        listagem.imprimeLinha(linha)

        listagem.imprimeLinha(
            '*--------------------------------------------------------------------------------------------------------------------------------------------------------*')

        listagem.finalizaImpressao()
        self.obj = external_pdf(pdf_string.getvalue())
        self.obj.render()
        pdf_string.close()
        return (self.obj.pdf, 'pdf')

    @staticmethod
    def get_dados(cr, data):
        sql = """
                SELECT mov_capa.data                  AS data,
                       mov_item.vr_total_item         AS vr_total_item,
                       mov_item.quantidade            AS quantidade,
                       mov_item.estmvi_saidas_custo_corrigido_total       AS custo_corrigido,
                       mov_item.estmvi_saidas_custo_medio_contabil_total  AS custo_medio_contabil,
                       mov_item.estmvi_saidas_custo_reposicao_total       AS custo_reposicao,
                       mov_item.estmvi_saidas_ultimo_custo_total          AS ultimo_custo
                FROM   estoque_movimento_itens mov_item
                       INNER JOIN estoque_movimento_capa mov_capa
                               ON mov_capa.id = mov_item.capa_id
                       LEFT JOIN estoque_natureza_operacao eno
                               ON eno.id = mov_capa.estmvc_operacao_id
                       LEFT JOIN estoque_movimento_origem emo
                               ON emo.id = eno.estnto_movimento_origem_id
                WHERE  mov_capa.data = '{data}'
                       AND emo.estmog_codigo IN ( 'C', 'N' )
        """.format(data=data)
        cr.execute(sql)
        return cr.dictfetchall()

report_custom('report.faturamento_rentabilidade')


class wizard_faturamento_rentabilidade(osv.TransientModel):
    _name = 'wizard.faturamento.rentabilidade'
    _columns = {
        'mes': fields.selection([
                                    ('01', 'Janeiro'), ('02', 'Fevereiro'), ('03', 'Marco'),
                                    ('04', 'Abril'), ('05', 'Maio'), ('06', 'Junho'),
                                    ('07', 'Julho'), ('08', 'Agosto'), ('09', 'Setembro'),
                                    ('10', 'Outubro'), ('11', 'Novembro'), ('12', 'Dezembro')],
                                'Mes', required=True),
        'ano': fields.integer('Ano', required=True),
        'percentual_rentabilidade': fields.float('Percentual Rentabilidade', digits=(9, 2), required=True),
        'custo': fields.selection([('M', 'Medio'), ('C', 'Corrigido'), ('U', 'Ultimo'), ('R', 'Reposicao')], 'Custo'),
    }

    _defaults = {
        'custo': 'C',
    }

    def button_print(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        browse_faturamento_rentabilidade = self.browse(cr, uid, ids)
        for x in browse_faturamento_rentabilidade:
            datas = {
                'mes': x.mes,
                'ano': x.ano,
                'percentual_rentabilidade': x.percentual_rentabilidade,
                'custo': x.custo,
            }
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'faturamento_rentabilidade',
            'datas': datas,
        }
