# -*- coding: utf-8 -*-

from openerp.osv import osv, fields
from openerp.tools.translate import _
from datetime import datetime
import psycopg2


class ecf_exportar_osv(osv.TransientModel):
    """
    Wizard de exportacao para ECF.
    """

    _inherit = "ecf.exportar.osv"
    _columns = {
        'gerar_locais': fields.boolean('Gerar locais de producao'),
    }

    def _criar_locais_producao_supervisor_postgres(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        super(ecf_exportar_osv, self)._criar_locais_producao_supervisor_postgres(cr, uid, ids,
                                                                                 context)
        if not self.read(cr, uid, ids, ['gerar_locais'], context=context)[0].get('gerar_locais'):
            return False

        obj_adm_utils = self.pool.get('adm.utils')
        obj_local = self.pool.get('estoque.local')
        context = context and context.copy() or {}
        fields_to_read = ['estpar_super_host', 'estpar_super_db', 'estpar_super_user',
                          'estpar_super_password', 'estpar_super_porta']
        parametro_dados = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque',
                                                                           fields_to_read,
                                                                           context=context)
        host = parametro_dados.get('estpar_super_host')
        porta = parametro_dados.get('estpar_super_porta') or 8069
        user = parametro_dados.get('estpar_super_user')
        password = parametro_dados.get('estpar_super_password') or ''
        db = parametro_dados.get('estpar_super_db')

        if not all([host, user, db, porta]):
            return False
        conn = False
        try:
            # CONEXAO COM O BANCO DE DADOS
            conn = psycopg2.connect(database=db, user=user, password=password, host=host, #SigLuiz
                                    connect_timeout=3)
            _cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
        except Exception as err:
            if conn:
                conn.close()
            msg = _("Host: %s \nPorta: %s\nUsuario: %s \nBanco: %s\n" % (host, porta, user, db))
            raise osv.except_osv(_('Atencao!'),
                                 _('Nao foi possivel conectar ao Postgres do supervisor. \n%s' %
                                   msg + 'Verifique as informacoes nos parametros do estoque.'))

        _cr.execute("SET statement_timeout = '3s'")
        _cr.execute("""SELECT sucloc_codigo FROM supervisor_producao_local""")
        codigo_locais = map(lambda x: x.get('sucloc_codigo'),
                        obj_adm_utils.admutl_converts_fetchall_to_dictfetchall(_cr))
        local_ids = obj_local.search(cr, uid, [('estlcl_local_producao','=',True)], context=context)
        if not local_ids:
            if conn:
                conn.close()
            return False

        data = datetime.now()
        for local in obj_local.read(cr, uid, local_ids, ['numero', 'name'], context=context):
            if local.get('numero') in codigo_locais:
                continue

            sql = """INSERT INTO supervisor_producao_local 
                 (create_date, write_date, create_uid, write_uid, sucloc_codigo, name)
             VALUES ('{data}', '{data}', {uid}, {uid}, '{codigo}', '{nome}');
             COMMIT;
            """.format(data=data, uid=uid, codigo=local.get('numero'), nome=local.get('name'))
            _cr.execute(sql)
        if conn:
            conn.close()
        return True

    def get_left_local_producao(self, context=None):
        context = context and context.copy() or {}
        super(ecf_exportar_osv, self).get_left_local_producao(context)
        sql = 'LEFT JOIN  estoque_local              AS el   ON el.id = ep.estpro_local_producao_id'
        return sql

    def get_camp_local_producao(self, context=None):
        context = context and context.copy() or {}
        super(ecf_exportar_osv, self).get_camp_local_producao(context)
        return """, el.numero                           AS codigo_local_producao"""