# -*- encoding: utf-8 -*-

##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################


from openerp.osv import osv
from openerp import tools

class vendas_externas_departamento(osv.Model):
    _name = 'vendas.externas.departamento'
    _inherit = 'vendas.externas.departamento'

    # VERIFICA SE HÁ ALGUM DEPARTAMENTO QUE NAO PRETENCE MAIS AO MOBILE E RETORNA UMA LISTA COM SEUS IDS
    def vexdep_verifica_departamentos(self, cr, uid, dic_departamento_ids, context=None):
        context = context and context.copy() or {}
        dep_ids = []
        for dep in dic_departamento_ids:
            dep_ids.append(dep.get('Open_id'))
        departamento_ids = self.pool.get('vendas.externas.departamento').search(cr, uid, [('id','in', dep_ids)],
                                                                                context=context)
        if not departamento_ids:
            return dep_ids
        res_ids = []
        for id in dep_ids:
            if not id in departamento_ids:
                res_ids.append(id)
        return res_ids
    # EXPORTA DEPARTAMENTOS PARA O DISPOSITIVO MÓVEL
    def vexdep_busca_departamentos(self, cr, uid, data_sinc_departamento, context=None):
        context = context and context.copy() or {}
        _departamento_ids = self.search(cr, uid, ['|',('create_date', '>=', data_sinc_departamento),
                                                      ('write_date', '>=', data_sinc_departamento)], context=context)
        _data_dep = self.browse(cr, uid, _departamento_ids)
        _lis = []
        for dep in _data_dep:
            if not dep.vexdep_departamento_pai_id.name:
                _lis.append({'codigo':dep.vexdep_codigo,
                             'Open_id': dep.id,
                             'descricao':dep.name,
                             'categoria_pai':u''})
            else:
                _lis.append({'codigo':dep.vexdep_codigo,
                             'descricao':dep.name,
                             'Open_id': dep.id,
                             'categoria_pai':dep.vexdep_departamento_pai_id.vexdep_codigo})
        return _lis

    def sequence_criar(self, cr, uid, context=None):
        context = context and context.copy() or {}
        company_id = 1
        __code = 'numero.departamento'
        __name = 'Numero Departamento'
        vals = {
            'name': __name,
            'code': __code,
            'padding': 3,
            'company_id': company_id,
            'implementation': 'no_gap',
        }
        consulta = self.pool.get('ir.sequence.type').search(cr, uid, [('code', '=', __code)],
                                                            context=context)
        if not consulta:
            self.pool.get('ir.sequence.type').create(cr, uid, {'name': __name, 'code': __code},
                                                     context)
        self.pool.get('ir.sequence').create(cr, uid, vals, context)
        return True

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if vals and vals.get('vexdep_codigo') != 0:
            return
        vals['vexdep_codigo'] = self.pool.get('vendas.externas.utils').get_sequence(cr, uid, self._name,
                                                                     'numero.departamento')
        if 'vexdep_imagem' in vals:
            vals['vexdep_imagem'] = tools.image_resize_image(vals.get('vexdep_imagem'), (150, 150))

        result = super(vendas_externas_departamento, self).create(cr, uid, vals, context)
        return result

    def write(self, cr, uid, id, vals, context=None):
        context = context and context.copy() or {}
        prod_ids = []
        prod_ids_gravados = []
        if vals.get('vexdep_produtos_ids'):
            prod_ids = vals.get('vexdep_produtos_ids')[0][2]
            prod_ids_gravados = self.pool.get('estoque.produto').search(cr, uid,
                                        [('estpro_departamento_ids','=',id[0])],context=context)
        lista_prod_ids = []
        for id_prod in prod_ids:
            if id_prod not in prod_ids_gravados:
                lista_prod_ids.append(id_prod)

        for prod_id in lista_prod_ids:
            self.pool.get('estoque.produto').write(cr, uid, prod_id,
                                                   {'estpro_departamento_ids': id[0]}, context)
        if 'vexdep_imagem' in vals:
            vals['vexdep_imagem'] = tools.image_resize_image(vals.get('vexdep_imagem'), (150, 150))

        result = super(vendas_externas_departamento, self).write(cr, uid, id, vals, context)
        return result

    def name_get(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        if not len(ids):
            return {}
        reads = self.read(cr, uid, ids, ['vexdep_codigo', 'name'], context=context)
        res = []
        for record in reads:
            name = '%03d - %s' % (record['vexdep_codigo'], record['name'])
            res.append((record['id'], name))
        return res