# -*- coding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from openerp.tools.translate import _
import xmlrpclib, socket
import base64


class vendas_externas_dispositivo(osv.Model):

    _inherit = 'vendas.externas.dispositivo'

    def get_cnpj(self, cr, uid, context=None):
        context = context and context.copy() or {}
        context['super_read_adm_pessoa'] = True
        company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, context=None)
        pessoa_id = self.pool.get('res.company').read(cr, uid, company_id, ['rescon_pessoa_id'],
                                     context=context, load='_classic_write').get('rescon_pessoa_id')
        return self.pool.get('adm.pessoa').read(cr, uid, pessoa_id, ['cpf_cnpj'],
                                                context=context).get('cpf_cnpj')

    def vexdis_button_gerar_licenca(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_config_parameter = self.pool.get('ir.config_parameter')
        campos = ['vexdis_marca', 'vexdis_modelo', 'vexdis_nro_serie']
        dados_dispositivo = self.read(cr, uid, ids[0], campos, context=context)
        dados_dispositivo.update({'marca': dados_dispositivo.pop('vexdis_marca'),
                                  'modelo': dados_dispositivo.pop('vexdis_modelo'),
                                  'nro_serie': dados_dispositivo.pop('vexdis_nro_serie'),
                                  'cnpj': self.get_cnpj(cr, uid, context)})
        servidor = obj_config_parameter.get_sig_server(cr, uid, context=context).split(',')
        try:
            host = servidor[0]
            db = servidor[1]
            porta = servidor[2]
            user = servidor[3]
            senha = servidor[4]
            sock_common = xmlrpclib.ServerProxy('http://' + host + ':' + str(porta) +
                                                '/xmlrpc/common')
            socket.setdefaulttimeout(5)
            uid_ = sock_common.login(db, user, senha)
            sock = xmlrpclib.ServerProxy('http://' + host + ':' + str(porta) + '/xmlrpc/object')
            res = sock.execute(db, uid_, senha, 'contrecf.mobile', 'get_mobile_licenca',
                               dados_dispositivo, context)

        except Exception as err:
            raise osv.except_osv(_('Atencao!'), _('Erro comunicando com servidor da SIG!'))

        if not res[0]:
            raise osv.except_osv(_('Atencao!'), res[1])

        licenca = base64.decodestring(res[1])
        vals = {'vexdis_licenca': licenca}
        self.write(cr, uid, ids, vals, context=context)
        return True