# -*- encoding: utf-8 -*-

##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv
from datetime import datetime
from SigUtils.crypto import decrypt
import re

pkey_sig = """-----BEGIN RSA PRIVATE KEY-----
MIICXQIBAAKBgQDNlPEHacb00nIQ7rrZ3U4kL9QAU+vvXbLLHGR45+7zYb2cBE2s
qmnUpSgf2Jp2HL0Dz/paqxpB4pOxU6kEcDs1QOlTjt5rTsKKiw6Of7g1MsrIEQCz
tF+u8xXyl93JB0M2QBQ4PGVQQsHxyd+jdWHCOj/YpJCA/8rJUbhiVoRaQwIDAQAB
AoGBAMnIdUO3eUb4AGnKSLBq3bX7E/U2ag/KQiHGPn/F9u4Ac6FdP/hIVBQZ/2Yy
rnlb/9JsIuk3pFAi2qBk4zKuDg2V57DY+h31SLVjENZHD3M0MGonFzu1uay+s/m0
X0mMbueNXuWAAYkoAPL/wEjP/ciJkqfCUiOJADcf7PJhXfhxAkEA9F1mdw+z+GPu
tHabZ2WJJSb7JnZtAskG/spFye6UUUw53tC7mLZ7Ye3dESa3l9jtRfC4CSKbNJhX
9JyTkzcabQJBANdezxdVg4gbBbdBm6cf59aT7Y1KIrqkDtQpENBJVMXJUIa2CTEc
QvGE3UwOA37zLRFtkSZk0w1590wC7NkwWW8CQBmr+kjF0I1myjwRPdBF/Xt2tenb
hSZGwkJgM6a8Nr63uFitKxgnC51FJPVZUO5V7s9rM5paFV4YJx1ema5cmp0CQQCo
gwgqS8CEqBAK2Qy+8RnnLQt7t3wA6QipPBBpyFbKAsA9BwWeJWzDqJ+2OGjH1eF3
d3FQxybTrpCuKsPDFC+FAkALWOoMA+liEcsz/n7BardljL0BRDuqMaS2iuQ/RTAH
34xfgVdzAN8XNLA+FOAWMxyDxP1vfoa6SwUsTZsdebGa
-----END RSA PRIVATE KEY-----"""

class vendas_externas_utils(osv.Model):
    _name = 'vendas.externas.utils'
    _auto = False

    def get_ajusta_context(self, cr, uid, context=None):
        context = context and context.copy() or {}
        context['sig_agile'] = True
        if context.get('lang'):
            return context

        context_aux = context.copy()
        context_aux['super_read_adm_pessoa'] = True
        pessoa = self.pool.get('adm.pessoa').read(cr, uid, uid, ['lang'], context=context_aux)
        if pessoa.get('lang'):
            context['lang'] = pessoa.get('lang')

        return context

    def get_sequence(self, cr, uid, classe, code):
        valor = self.pool.get('ir.sequence').next_by_code(cr, uid, code)
        if not valor:
            self.pool.get(classe).sequence_criar(cr, uid)
            valor = self.pool.get('ir.sequence').next_by_code(cr, uid, code)
        return valor

    def check_licenca(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        nro_serie = vals.get('serial')
        modelo = vals.get('model')
        marca = vals.get('brand')
        args = [('vexdis_nro_serie', '=', nro_serie),
                ('vexdis_modelo', '=', modelo),
                ('vexdis_marca', '=', marca)]
        obj_dispositivo = self.pool.get('vendas.externas.dispositivo')
        dispositivo_ids = obj_dispositivo.search(cr, uid, args, context=context)
        if not dispositivo_ids:
            vals_disp = {'vexdis_nro_serie': nro_serie,
                         'vexdis_modelo': modelo,
                         'vexdis_marca': marca}
            obj_dispositivo.create(cr, uid, vals_disp, context=context)
            return False

        licenca = obj_dispositivo.read(cr, uid, dispositivo_ids[0], ['vexdis_licenca'],
                                       context=context).get('vexdis_licenca')
        try:
            licenca = decrypt(licenca, pkey_sig).split('#|#')
        except:
            return False

        if len(licenca) != 3 or modelo != licenca[0] or marca != licenca[1] or \
                                                                            nro_serie != licenca[2]:
            return False

        return True

    # RETORNA DATA E HORA DO OPENERP
    def vexdep_busca_data_hora(self, cr, uid):
        dataHora = datetime.now()
        return str(dataHora)

    # VERIFICA SE HÁ LOCAL_ID SETADO NO PARAMETRO DO ESTOQUE EM VENDAS EXTERNAS
    def vexdep_verifica_local_id(self, cr, uid, company_id, context=None):
        context = context and context.copy() or {}
        parametro_id = self.pool.get('estoque.parametro').search(cr, uid, [('company_id', '=', company_id)],
                                                                 context=context)
        local_id = self.pool.get('estoque.parametro').browse(cr, uid, parametro_id)[0].estpar_vendex_local_id.id
        if local_id:
            return True
        else:
            return False

    # VERIFICA SE HÁ ALGUM PRODUTO QUE NAO PRETENCE MAIS AO MOBILE E RETORNA UMA LISTA COM SEUS IDS
    def vexdep_verifica_produtos(self, cr, uid, dic_produto_ids, context=None):
        context = context and context.copy() or {}
        prod_ids = map(lambda x: x.get('Open_id'), dic_produto_ids)
        produtos_ids = filter(lambda x: x in prod_ids,
                              self.pool.get('estoque.produto').search(cr, uid,
                                        [('estpro_departamento_ids', '=', False)], context=context))
        return produtos_ids

    def vexdep_get_precos_alterados(self, cr, uid, data_sic_prod, produto_ids, grade_ids,
                                    context=None, load=''):
        "Devolve um lista contendo o prodo_id e a grade_id dos precos alterados"
        context = context and context.copy() or {}
        obj_automacao = self.pool.get('automacao.precos')
        obj_codigo_barra = self.pool.get('automacao.codigo.barra')
        args = [('grade_id', 'in', grade_ids),
                ('produto_id', 'in', produto_ids)]
        cb_ids = obj_codigo_barra.search(cr, uid, args,  context=context)
        args = [('codigo_barra_id', 'in', cb_ids), '|',
                 ('write_date', '>', data_sic_prod),
                 ('create_date', '>', data_sic_prod)]
        preco_ids = obj_automacao.search(cr, uid, args, context=context)
        alterados = []
        if preco_ids:
            cb_ids = map(lambda x: x.get('codigo_barra_id'),
                         obj_automacao.read(cr, uid, preco_ids, ['codigo_barra_id'],
                                            context=context, load=load))
            for i in obj_codigo_barra.read(cr, uid, cb_ids, ['produto_id', 'grade_id'],
                                           context=context, load=load):
                chave = "%s-%s" % (i.get('produto_id'), i.get('grade_id'))
                alterados.append(chave)
        return alterados

    def vexdep_get_saldos_alterados(self, cr, uid, data_sic_prod, produto_ids, grade_ids, local_id,
                                    context=None, load=''):
        "Devolve um lista contendo o prodo_id e a grade_id dos saldos alterados"
        context = context and context.copy() or {}
        obj_saldo = self.pool.get('estoque.produto.saldo')
        alterados = []
        args = [('grade_id', 'in', grade_ids),
                ('produto_id', 'in', produto_ids),
                ('local_id', '=', local_id), '|',
                ('write_date', '>', data_sic_prod),
                ('create_date', '>', data_sic_prod)]
        saldo_ids = obj_saldo.search(cr, uid, args, context=context)
        if not saldo_ids:
            return alterados

        for i in obj_saldo.read(cr, uid, saldo_ids, ['produto_id', 'grade_id'], context=context,
                                load=load):
            chave = "%s-%s" % (i.get('produto_id'), i.get('grade_id'))
            alterados.append(chave)

        return alterados

    # EXPORTA PRODUTOS PARA O DISPOSITIVO MÓVEL
    def vexdep_busca_produtos(self, cr, uid, company_id, data_sic_prod, foto, context=None):
        context = context and context.copy() or {}
        load = '_classic_write'
        obj_produto = self.pool.get('estoque.produto')
        obj_grade = self.pool.get('estoque.produto.grade')
        parametro_id = self.pool.get('estoque.parametro').search(cr, uid,
                                                                 [('company_id', '=', company_id)],
                                                                 context=context)
        local_id = self.pool.get('estoque.parametro').browse(cr, uid, parametro_id)[0]. \
            estpar_vendex_local_id.id
        if not self.pool.get('vendas.externas.departamento').search(cr, uid, [], context=context):
            return []

        grade_ids = obj_grade.search(cr, uid, [('estpro_departamento_ids', '!=', '')],
                                     context=context.update({'retorno_sem_codigo': True}))
        if not grade_ids:
            return []

        local_locacao_ids = self.pool.get('estoque.local.locacao').search(cr, uid,
                                                  [('grade_id', 'in', grade_ids),
                                                   ('local_id', '=', local_id),
                                                   ('company_id', '=', company_id)],context=context)
        _local_locacao_data = self.pool.get('estoque.local.locacao').read(cr, uid,
                          local_locacao_ids, ['produto_id', 'grade_id'], context=context, load=load)
        lista_grade_ids = []
        produto_ids = []
        grade_ids = []
        for loc_loc in _local_locacao_data:
            produto_ids.append(loc_loc.get('produto_id'))
            grade_ids.append(loc_loc.get('grade_id'))

        dic_produto = {}
        map(lambda x: dic_produto.update({x.get('id'): x}),
            obj_produto.read(cr, uid, produto_ids, ['create_date', 'write_date'],
                             context=context))
        dic_grade = {}
        map(lambda x: dic_grade.update({x.get('id'): x}),
            obj_grade.read(cr, uid, grade_ids, ['create_date', 'write_date'],
                           context=context))
        alterados = self.vexdep_get_precos_alterados(cr, uid, data_sic_prod, produto_ids,
                                                     grade_ids, context, load)
        alterados.extend(self.vexdep_get_saldos_alterados(cr, uid, data_sic_prod, produto_ids,
                                                          grade_ids, local_id, context, load))
        for loc_loc in _local_locacao_data:
            write_date_prod = dic_produto.get(loc_loc.get('produto_id')).get('write_date')
            create_date_prod = dic_produto.get(loc_loc.get('produto_id')).get('create_date')
            write_date_grade = dic_grade.get(loc_loc.get('grade_id')).get('write_date')
            create_date_grade = dic_grade.get(loc_loc.get('grade_id')).get('create_date')
            chave = "%s-%s" % (loc_loc.get('produto_id'), loc_loc.get('grade_id'))
            if max([write_date_prod, create_date_prod, write_date_grade,
                    create_date_grade]) > data_sic_prod or chave in alterados:
                lista_grade_ids.append(loc_loc.get('grade_id'))

        _data_grade = self.pool.get('estoque.produto.grade').browse(cr, uid, lista_grade_ids,
                                                               context={'retorno_sem_codigo': True})
        _list = []
        for grade in _data_grade:
            data = max([grade.produto_id.write_date, grade.produto_id.create_date])
            dic_prod = {'id': grade.produto_id.id,
                        'codigo': grade.produto_id.codigo, 'grade': grade.grade,
                        'descricao': grade.name,
                        'departamento_id': grade.produto_id.estpro_departamento_ids[0].vexdep_codigo,
                        'preco': grade.produto_id.preco_venda,
                        'qtdEmEstoque': grade.saldo,
                        'write_date': data}
            if foto:
                dic_prod['foto'] = grade.produto_id.estpro_foto or ''
            _list.append(dic_prod)
        return _list

    # IMPORTA OS CLIENTES DO DISPOSITIVO MÓVEL PARA O OPENERP
    def vexdep_importa_clientes(self, cr, uid, clientes_data, context=None):
        context = context and context.copy() or {}
        context = self.get_ajusta_context(cr, uid, context=context)
        dic = {}
        for cli in clientes_data:
            cliente_id = self.pool.get('financeiro.cliente').search(cr, uid, [('cpf_cnpj', '=', cli.get('CpfCnpj'))],
                                                                    context=context)
            titulo = ''
            titulo_entrega = ''
            if 'Rua ' in cli.get('Rua'):
                cli['Rua'] = cli.get('Rua')[4:]
                titulo = 'Rua'
            if 'Av. ' in cli.get('Rua'):
                cli['Rua'] = cli.get('Rua')[4:]
                titulo = 'Avenida'
            elif 'Av ' in cli.get('Rua'):
                cli['Rua'] = cli.get('Rua')[3:]
                titulo = 'Avenida'
            elif 'Avenida ' in cli.get('Rua'):
                cli['Rua'] = cli.get('Rua')[8:]
                titulo = 'Avenida'

            if 'Rua ' in cli.get('RuaEntrega'):
                cli['RuaEntrega'] = cli.get('RuaEntrega')[4:]
                titulo_entrega = 'Rua'
            if 'Av. ' in cli.get('RuaEntrega'):
                cli['RuaEntrega'] = cli.get('RuaEntrega')[4:]
                titulo_entrega = 'Avenida'
            elif 'Av ' in cli.get('RuaEntrega'):
                cli['RuaEntrega'] = cli.get('RuaEntrega')[3:]
                titulo_entrega = 'Avenida'
            elif 'Avenida ' in cli.get('RuaEntrega'):
                cli['RuaEntrega'] = cli.get('RuaEntrega')[8:]
                titulo_entrega = 'Avenida'
            telefone_comercial_id = self.pool.get('adm.telefone.tipo').search(cr, uid, [('name', '=', 'Comercial')],
                                                                              context=context)
            telefone_celular_id = self.pool.get('adm.telefone.tipo').search(cr, uid, [('name', '=', 'Celular')],
                                                                            context=context)
            if not telefone_comercial_id:
                telefone_comercial_id = self.pool.get('adm.telefone.tipo').create(cr, uid, {'name': 'Comercial'},
                                                                                  context)
            if not telefone_celular_id:
                telefone_celular_id = self.pool.get('adm.telefone.tipo').create(cr, uid, {'name': 'Celular'},
                                                                                context)

            logradouro_id = self.pool.get('adm.logradouro').search(cr, uid, [('descricao', '=', cli.get('Rua'))],
                                                                   context=context)
            cidade_id = self.pool.get('adm.cidade').search(cr, uid, [('name', 'ilike', cli.get('Cidade'))],
                                                           context=context)
            bairro_id = self.pool.get('adm.bairro').search(cr, uid, [('name', 'ilike', cli.get('Bairro'))],
                                                           context=context)
            uf_id = self.pool.get('adm.uf').search(cr, uid, [('sigla', 'ilike', cli.get('Uf'))],
                                                   context=context)
            pais_id = self.pool.get('adm.utils').admutl_get_id_nome_externo(cr, uid, 'adm', 'adm_pais_brasil')
            uf_entrega_id = self.pool.get('adm.uf').search(cr, uid, [('sigla', 'ilike', cli.get('UfEntrega'))],
                                                           context=context)
            pais_entrega_id = self.pool.get('adm.utils').admutl_get_id_nome_externo(cr, uid, 'adm', 'adm_pais_brasil')
            tipo_end_id = self.pool.get('adm.utils').admutl_get_id_nome_externo(cr, uid, 'adm',
                                                                                'adm_endereco_tipo_normal')
            tipo_end_entrega_id = self.pool.get('adm.utils').admutl_get_id_nome_externo(cr, uid, 'adm',
                                                                                        'adm_endereco_tipo_entrega')
            if not logradouro_id:
                logradouro_id = self.pool.get('adm.logradouro').create(cr, uid, {'descricao': cli.get('Rua'),
                                                                                 'titulo': titulo},
                                                                       context)
            if not cidade_id:
                cidade_id = self.pool.get('adm.cidade').create(cr, uid, {'name': cli.get('Cidade'), 'pais_id': pais_id,
                                                                         'uf_id': uf_id}, context)
            if not bairro_id:
                bairro_id = self.pool.get('adm.bairro').create(cr, uid, {'name': cli.get('Bairro')}, context)
            logradouro_entrega_id = self.pool.get('adm.logradouro').search(cr, uid,
                                         [('descricao', '=',cli.get('RuaEntrega'))],context=context)
            if not logradouro_entrega_id:
                logradouro_entrega_id = self.pool.get('adm.logradouro').create(cr, uid,
                                                                               {'descricao': cli.get('RuaEntrega'),
                                                                                'titulo': titulo_entrega},
                                                                               context)
            cidade_entrega_id = self.pool.get('adm.cidade').search(cr, uid,
                                       [('name', 'ilike',cli.get('CidadeEntrega'))],context=context)
            if not cidade_entrega_id:
                cidade_entrega_id = self.pool.get('adm.cidade').create(cr, uid, {'name': cli.get('CidadeEntrega'),
                                                                                 'pais_id': pais_id,
                                                                                 'uf_id': uf_id}, context)
            bairro_entrega_id = self.pool.get('adm.bairro').search(cr, uid,
                                       [('name', 'ilike',cli.get('BairroEntrega'))],context=context)
            if not bairro_entrega_id:
                bairro_entrega_id = self.pool.get('adm.bairro').create(cr, uid, {'name': cli.get('BairroEntrega')},
                                                                       context)

            if isinstance(logradouro_id, list):
                logradouro_id = logradouro_id[0]
            if isinstance(cidade_id, list):
                cidade_id = cidade_id[0]
            if isinstance(bairro_id, list):
                bairro_id = bairro_id[0]
            if isinstance(uf_id, list):
                uf_id = uf_id[0]
            if isinstance(logradouro_entrega_id, list):
                logradouro_entrega_id = logradouro_entrega_id[0]
            if isinstance(cidade_entrega_id, list):
                cidade_entrega_id = cidade_entrega_id[0]
            if isinstance(bairro_entrega_id, list):
                bairro_entrega_id = bairro_entrega_id[0]
            if isinstance(uf_entrega_id, list):
                uf_entrega_id = uf_entrega_id[0]
            if cli.get('Endereco_open_id') == '':  # Cria um novo end se não houver
                controle = 0
                end_id = False
            else:  # Atualiza o endereço se houver
                controle = 1
                end_id = cli.get('Endereco_open_id')
            if cli.get('End_entrega_open_id') == '':  # Cria um novo end se não houver
                controle_entrega = 0
                end_entrega_id = False
            else:  # Atualiza o endereço se houver
                controle_entrega = 1
                end_entrega_id = cli.get('End_entrega_open_id')
            _dic_cli = {'cpf_cnpj': cli.get('CpfCnpj'), 'name': cli.get('Nome'),
                        'endereco_ids': (
                            (controle, end_id, {'cep': cli.get('Cep'),
                                                'numero': cli.get('Nro'),
                                                'logradouro_id': logradouro_id or None,
                                                'endereco_tipo_id': tipo_end_id,
                                                'pais_id': pais_id,
                                                'uf_id': uf_id or None,
                                                'cidade_id': cidade_id or None,
                                                'bairro_id': bairro_id or None, }),
                            (controle_entrega, end_entrega_id, {'cep': cli.get('Cep'),
                                                                'numero': cli.get('NroEntrega'),
                                                                'logradouro_id': logradouro_entrega_id or None,
                                                                'endereco_tipo_id': tipo_end_entrega_id or None,
                                                                'pais_id': pais_entrega_id or None,
                                                                'uf_id': uf_entrega_id or None,
                                                                'cidade_id': cidade_entrega_id or None,
                                                                'bairro_id': bairro_entrega_id or None, })
                        )
                        }
            if not cliente_id:  # Cria um novo cliente se não houver 'cliente_id'
                id = self.pool.get('financeiro.cliente').create(cr, uid, _dic_cli, context)
                cli_data = self.pool.get('financeiro.cliente').browse(cr, uid, id)
            else:  # Atualiza o cliente se houver 'cliente_id'
                self.pool.get('financeiro.cliente').write(cr, uid, cliente_id, _dic_cli, context)
                cli_data = self.pool.get('financeiro.cliente').browse(cr, uid, cliente_id[0])
            if not cli.get('Telefone') == u'':
                _dic_cli_telefone_comercial = {'pessoa_id': cli_data.pessoa_id.id,
                                               'telefone_tipo_id': telefone_comercial_id[0],
                                               'ddd': cli.get('Telefone')[0:2],
                                               'numero': cli.get('Telefone')[3:],
                                               }
                telefone_id = self.pool.get('adm.pessoa.telefone').search(cr, uid,
                                                                          [('pessoa_id', '=', cli_data.pessoa_id.id), (
                                                                          'telefone_tipo_id', '=',
                                                                          telefone_comercial_id[0])], context=context)
                if not telefone_id:
                    self.pool.get('adm.pessoa.telefone').create(cr, uid, _dic_cli_telefone_comercial, context)
                else:
                    self.pool.get('adm.pessoa.telefone').write(cr, uid, telefone_id[0], _dic_cli_telefone_comercial,
                                                               context)
            if not cli.get('Celular') == u'':
                _dic_cli_telefone_celular = {'pessoa_id': cli_data.pessoa_id.id,
                                             'telefone_tipo_id': telefone_celular_id[0],
                                             'ddd': cli.get('Celular')[0:2],
                                             'numero': cli.get('Celular')[3:],
                                             }
                telefone_id = self.pool.get('adm.pessoa.telefone').search(cr, uid,
                                                                          [('pessoa_id', '=', cli_data.pessoa_id.id), (
                                                                          'telefone_tipo_id', '=',
                                                                          telefone_celular_id[0])], context=context)
                if not telefone_id:
                    self.pool.get('adm.pessoa.telefone').create(cr, uid, _dic_cli_telefone_celular, context)
                else:
                    self.pool.get('adm.pessoa.telefone').write(cr, uid, telefone_id[0], _dic_cli_telefone_celular,
                                                               context)
            end_id = u''
            end_entrega_id = u''
            for end in cli_data.endereco_ids:
                if end.endereco_tipo_id.name == 'Normal':
                    end_id = end.id
                elif end.endereco_tipo_id.name == 'Entrega':
                    end_entrega_id = end.id
            dic[str(cli.get('id'))] = {'codigo': str(cli_data.codigo),
                                       'end_open_id': end_id,
                                       'end_entrega_open_id': end_entrega_id
                                       }
        return dic

    # EXPORTA CLIENTES PARA O DISPOSITIVO MÓVEL
    def vexdep_exporta_clientes(self, cr, uid, data_sinc_cli, context=None):
        context = context and context.copy() or {}
        _pessoa_ids = self.pool.get('adm.pessoa').search(cr, uid,
                                                         ['|', ('create_date', '>=', data_sinc_cli),
                                                          ('write_date', '>=', data_sinc_cli)], context=context)
        _clientes_ids = self.pool.get('financeiro.cliente').search(cr, uid, [
            ('pessoa_id', 'in', _pessoa_ids)])
        _data_cli = self.pool.get('financeiro.cliente').browse(cr, uid, _clientes_ids)
        _lis = []
        for cli in _data_cli:
            celular = u''
            telefone = u''
            for tel in cli.telefones_ids:
                if tel.telefone_tipo_id.name != 'Celular':
                    if tel.ddd:
                        telefone = tel.ddd + ' ' + tel.numero
                    else:
                        telefone = tel.numero
                else:
                    if tel.ddd:
                        celular = tel.ddd + ' ' + tel.numero
                    else:
                        celular = tel.numero
            end_id = u''
            end_entrega_id = u''
            for end in cli.endereco_ids:
                if end.endereco_tipo_id.name == 'Normal':
                    end_id = end.id
                elif end.endereco_tipo_id.name == 'Entrega':
                    end_entrega_id = end.id

            cpf_cnpj = cli.cpf_cnpj if cli.cpf_cnpj else ''
            dic = {'cpfcnpj': re.sub('[^0-9]', '', cpf_cnpj),
                   'nome': cli.pessoa_id.nome,
                   'write_date': cli.write_date,
                   'codigo': cli.codigo or '',
                   'telefone': telefone or '',
                   'celular': celular or '',
                   'endereco_open_id': end_id or '',
                   'end_entrega_open_id': end_entrega_id or ''}

            for end in cli.endereco_ids:
                if end.endereco_tipo_id.name == 'Normal':
                    dic['cep'] = end.cep or ''
                    dic['rua'] = end.logradouro_id.descricao or ''
                    dic['nro'] = end.numero or ''
                    dic['bairro'] = end.bairro_id.name or ''
                    dic['cidade'] = end.cidade_id.name or ''
                    dic['uf'] = end.uf_id.sigla or ''
                if end.endereco_tipo_id.name == 'Entrega':
                    dic['cepEntrega'] = end.cep or ''
                    dic['ruaEntrega'] = end.logradouro_id.descricao or ''
                    dic['nroEntrega'] = end.numero or ''
                    dic['bairroEntrega'] = end.bairro_id.name or ''
                    dic['cidadeEntrega'] = end.cidade_id.name or ''
                    dic['ufEntrega'] = end.uf_id.sigla or ''
            _lis.append(dic)
        return _lis

    # EXPORTA AS FORMAS DE PAGAMENTO
    def vexdep_exporta_fomra_cond_pg(self, cr, uid, data_sinc_forma_condicao, context=None):
        context = context and context.copy() or {}
        _forma_pgto_ids = self.pool.get('adm.forma.pgto').search(cr, uid,
                                                                 ['|', ('create_date', '>=', data_sinc_forma_condicao),
                                                                  ('write_date', '>=', data_sinc_forma_condicao)],
                                                                 context=context)
        _forma_pgto_data = self.pool.get('adm.forma.pgto').browse(cr, uid, _forma_pgto_ids)
        _condicao_ids = self.pool.get('adm.condicao').search(cr, uid,
                                                             ['|', ('create_date', '>=', data_sinc_forma_condicao),
                                                              ('write_date', '>=', data_sinc_forma_condicao)],
                                                             context=context)
        _condicao_data = self.pool.get('adm.condicao').browse(cr, uid, _condicao_ids)
        _cond_forma_ids = self.pool.get('adm.condicao.forma').search(cr, uid, ['|', (
        'create_date', '>=', data_sinc_forma_condicao),
                                                                               ('write_date', '>=',
                                                                                data_sinc_forma_condicao)],
                                                                     context=context)
        _cond_forma_data = self.pool.get('adm.condicao.forma').browse(cr, uid, _cond_forma_ids)
        dic_for_pgto = {}
        dic_condicao = {}
        dic_cond_forma = {}
        for forma_pgto in _forma_pgto_data:
            dic_for_pgto[str(forma_pgto.id)] = {'descricao': forma_pgto.name
                                                }
        for condica in _condicao_data:
            dic_condicao[str(condica.id)] = {'descricao': condica.name
                                             }
        for cond_forma in _cond_forma_data:
            dic_cond_forma[str(cond_forma.id)] = {'forma_pagamento_id': cond_forma.forma_pagamento_id.id,
                                                  'condicao_id': cond_forma.adm_condicao_id.id
                                                  }
        dic = {'forma_pgto': dic_for_pgto,
               'condicao': dic_condicao,
               'cond_forma': dic_cond_forma
               }
        return dic

    # IMPORTA OS PEDIDOS DO MOBILE PARA O OPENERP
    def vexdep_importa_pedidos(self, cr, uid, dic_pedidos_data_company, context=None):
        context = context and context.copy() or {}
        context = self.get_ajusta_context(cr, uid, context=context)
        _dic_res_pedido = {}
        pedidos_data = dic_pedidos_data_company.get('pedidos')
        company_id = dic_pedidos_data_company.get('company_id')
        for ped_id in pedidos_data:
            pedido = pedidos_data.get(ped_id)
            cliente_id = self.pool.get('adm.pessoa').search(cr, uid,
                                                            [('cpf_cnpj', '=', pedido.get('capa').get('cpfcnpj'))],
                                                            context=context)
            pedido_id = self.pool.get('estoquepedidos.pedido.capa').create(cr, uid, {
                'data_emissao': pedido.get('capa').get('data_hora'),
                'vr_desconto': float(pedido.get('capa').get('desconto')),
                'pessoa_id': cliente_id[0],
                'tipo': 'V',
                'vendedor_id': pedido.get('capa').get('cod_vendedor')
                }, context=None)
            for item in pedido.get('itens'):
                produto_id = self.pool.get('estoque.produto').search(cr, uid,
                                                                     [('codigo', '=', item.get('codigo_produto'))],
                                                                     context=context)
                parametro_id = self.pool.get('estoque.parametro').search(cr, uid, [('company_id', '=', company_id)],
                                                                         context=context)
                local_id = self.pool.get('estoque.parametro').browse(cr, uid, parametro_id)[0].estpar_vendex_local_id.id
                grade_id = self.pool.get('estoque.produto.grade').search(cr, uid, [('produto_id', '=', produto_id[0]),
                                                                                   ('grade', '=', item.get('grade'))],
                                                                         context=context)
                local_locacao_id = self.pool.get('estoque.local.locacao').search(cr, uid,
                                                                                 [('produto_id', '=', produto_id[0]),
                                                                                  ('grade_id', '=', grade_id[0]),
                                                                                  ('local_id', '=', local_id),
                                                                                  ('company_id', '=', company_id)],
                                                                                 context=context)
                local_locacao_data = self.pool.get('estoque.local.locacao').browse(cr, uid, local_locacao_id)
                vals = {'pedido_id': pedido_id,
                        'qtde_pedida': item.get('quantidade'),
                        'vr_unitario': item.get('preco'),
                        'produto_id': produto_id[0],
                        'grade_id': grade_id[0],
                        'local_id': local_id,
                        'produto_embalagem_id': local_locacao_data[0].estllc_produto_embalagem_id.id
                        }
                self.pool.get('estoquepedidos.pedido.item').create(cr, uid, vals, context)
            for fecha in pedido.get('fechamento'):
                forma_cond_id = self.pool.get('adm.condicao.forma').search(cr, uid, [
                    ('id', '=', fecha.get('forma_condicao_id'))], context=context)
                forma_pg_id = self.pool.get('adm.condicao.forma').browse(cr, uid, forma_cond_id)[
                    0].forma_pagamento_id.id
                self.pool.get('estoquepedidos.pedido.condicao').create(cr, uid, {'capa_id': pedido_id,
                                                                                 'valor': fecha.get('valor'),
                                                                                 'condicao_forma_id': fecha.get(
                                                                                     'forma_condicao_id'),
                                                                                 'forma_pagto_id': forma_pg_id
                                                                                 }, context)
            self.pool.get('estoquepedidos.pedido.capa').write(cr, uid, pedido_id, {}, context)
            nro_pedido = self.pool.get('estoquepedidos.pedido.capa').browse(cr, uid, [pedido_id])[0].numero_pedido
            _dic_res_pedido[ped_id] = nro_pedido
        return _dic_res_pedido
