# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class estoque_produto(osv.Model):
    _name = 'estoque.produto'
    _inherit = 'estoque.produto'

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}
        self.formata_vals(cr, uid, vals, context)
        return super(estoque_produto, self).write(cr, uid, ids, vals, context=context)

    def create(self, cr, user, vals, context=None):
        context = context and context.copy() or {}
        self.formata_vals(cr, user, vals, context)
        return super(estoque_produto, self).create(cr, user, vals, context=context)

    def formata_vals(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        if vals.get('estpro_departamento_ids') != None:
            if vals.get('estpro_departamento_ids'):
                vals['estpro_departamento_ids'] = [[6, False, [vals.get('estpro_departamento_ids')]]]
            else:
                vals['estpro_departamento_ids'] = [[6, False, []]]

    def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
        context = context and context.copy() or {}
        if context and context.get('departamento_id'):
            load = '_classic_write'
            dados_user = self.pool.get('res.users').read(cr, uid, uid, context=context, load=load)
            company_id = dados_user.get('company_id')
            local_id = self.pool.get('adm.utils').admutl_get_parametros(cr, uid, 'estoque.parametro',
                          ['estpar_vendex_local_id'], context=context).get('estpar_vendex_local_id')
            grade_ids = self.pool.get('estoque.produto.grade').search(cr, uid,
                                                                      [('estpro_departamento_ids', '=', False)],
                                                                      context=context)
            local_locacao_ids = []
            if grade_ids:
                local_locacao_ids = self.pool.get('estoque.local.locacao').search(cr, uid,
                                                                                  [('grade_id', 'in', grade_ids),
                                                                                   ('local_id', '=', local_id),
                                                                                   ('company_id', '=', company_id)],
                                                                                  context=context)
            dados_locacao = self.pool.get('estoque.local.locacao').read(cr, uid, local_locacao_ids,
                                                         ['produto_id'], context=context, load=load)
            if not dados_locacao:
                raise osv.except_osv(('Mensagem:'),
                                     (
                                     'Em: Estoque->Parametro, na aba Vendas_Externas da empresa, nao ha local selecionado'))
            podutos_ids = []
            for local_loc in dados_locacao:
                podutos_ids.append(local_loc.get('produto_id'))

            if context.get('vexdep_produtos_ids'):
                for prod_id in context.get('vexdep_produtos_ids')[0][2]:
                    if prod_id in podutos_ids:
                        podutos_ids.remove(prod_id)

            cont = len(args)
            indice_args = range(0, cont)
            aux_args = [['tipo', '=', 'P'], ['id', 'in', podutos_ids]]
            for indice in indice_args:
                if cont > 3:
                    aux_args.append(args[indice])
                cont -= 1
            args = aux_args
        res = super(estoque_produto, self).search(cr, uid, args, offset, limit, order, context, count)
        return res

    def copy(self, cr, uid, id, default=None, context=None):
        context = context and context.copy() or {}
        if not default:
            default = {}
        default.update({'estpro_departamento_ids': []})
        res = super(estoque_produto, self).copy(cr, uid, id, default, context)
        return res
