#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _
import logging


# noinspection PyAbstractClass,PyAbstractClass,PyPep8Naming
class websig_executor_tela_osv(osv.TransientModel):
    _name = 'websig.executor.tela.osv'
    _inherit = 'websig.executor.tela.osv'

    def websig_exec_0001(self, cr, uid, ids, context):
        """
        Esta funcao apaga todas as tributacoes dos itens no movimento para o periodo selecionado e
        para os encargos selecionados. Apos isto, gera as tributacoes novamente conforme o cadastro
        de cada item
        """
        logger = logging.getLogger('Executor de Funcoes')
        msg = ''
        executor_tela_id = ids[0] if isinstance(ids, list) else ids
        funcao_escolhida = eval(self.browse(cr, uid, executor_tela_id, context).dados)[1]

        # Aqui comeca a parte especifica da funcao
        # Se houver algum erro, muda o ´´state´´ para 4 e informa a mensagem de erro

        # Apagar movimento para os encargos selecionados no periodo selecionado
        _data_inicial = funcao_escolhida.get('campos').get('data_inicial').get('value', False)
        _data_final = funcao_escolhida.get('campos').get('data_final').get('value', False)

        # Interessa so a lista de ids
        _encargos_ids = funcao_escolhida.get('campos').get('encargos').get('value', False)
        _encargos_ids = _encargos_ids[0][2] if _encargos_ids else [0]

        _origem = funcao_escolhida.get('campos').get('origem').get('value', False)
        _operacao = funcao_escolhida.get('campos').get('operacao').get('value', False)
        obj_estoque_movimento_itens = self.pool.get('estoque.movimento.itens')
        sql = """select emc.id from estoque_movimento_capa emc
                    left join estoque_natureza_operacao eno
                        on eno.id = emc.estmvc_operacao_id
                    where emc.data between '%s' and '%s'""" % (_data_inicial, _data_final)
        if _origem == 'T':
            sql += " and emc.estmvc_origem in ('N', 'C')"
        if _origem in ('N', 'C'):
            sql += " and emc.estmvc_origem =  '%s'" % _origem
        if _origem != 'C':
            if _operacao in ('E', 'S'):
                sql += " and eno.estnto_tipo_operacao = '%s'" % _operacao

        cr.execute(sql)
        _capa_ids = map(lambda x: x[0], cr.fetchall())

        if not _capa_ids:
            self.write(cr, uid, ids, {
                'state': '4',
                'mensagem': _('<h1>Nao ha movimento para a selecao informada!</h1>')}, context)

            return False

        msg += _('    Selecionado %s documentos.<br>') % len(_capa_ids)
        obj_fiscal_nf_item_tributacao = self.pool.get('fiscal.nf.item.tributacao')
        sql = """SELECT emi.id,
                        emi.nf_id,
                        emi.cupom_id,
                        emi.produto_id,
                        emi.vr_total_item,
                        fnc.nf_propria, 
                        fnc.tipo, 
                        fnc.destinatario_id, 
                        fnc.natureza_id,
                        cfop.movimento_tipo
                 FROM estoque_movimento_itens   AS emi
                 LEFT JOIN fiscal_nf_capa       AS fnc  ON fnc.id = emi.nf_id
                 LEFT JOIN fiscal_cfop_natureza AS fnat ON fnat.id = fnc.natureza_id
                 LEFT JOIN fiscal_cfop          AS cfop ON cfop.id = fnat.cfop_id
                 WHERE capa_id in %s"""
        sql %= str(_capa_ids).replace('[', '(').replace(']', ')')
        cr.execute(sql)
        _itens = cr.dictfetchall()
        natureza_ids = list(set(map(lambda x: '%s' % x.get('natureza_id'),
                                filter(lambda y: y.get('natureza_id'), _itens))))
        sql = """ SELECT fcne.encargo_id,
                         fcn.id
                  FROM fiscal_cfop_natureza_encargos AS fcne 
                  INNER JOIN fiscal_cfop_natureza    AS fcn ON fcn.id = fcne.natureza_id 
                  WHERE fcn.id IN (%s)
              """ % ','.join(natureza_ids)
        cr.execute(sql)
        nat_encargos = {}
        for i in cr.dictfetchall():
            if not nat_encargos.get(i.get('id')):
                nat_encargos[i.get('id')] = [i.get('encargo_id')]
            else:
                nat_encargos[i.get('id')].append(i.get('encargo_id'))

        if not _itens:
            self.write(cr, uid, ids, {
                'state': '4',
                'mensagem': _('<h1>Nao ha itens para os documentos selecionados!</h1>')}, context)

            return False

        msg += _('    Selecionado %s itens dos documentos<br>') % len(_itens)
        _itens_ids = map(lambda x: '%s' % x.get('id'), _itens)
        sql = """select id from fiscal_nf_item_tributacao
                    where movimento_itens_id in (%s) and encargo_id in %s
                    """ % (','.join(_itens_ids),
                           str(_encargos_ids).replace('[', '(').replace(']', ')')
                           )
        cr.execute(sql)
        _tribut_ids = map(lambda x: x[0], cr.fetchall())
        context['salvar_forcado'] = True

        if not _tribut_ids:
            msg += _('    Nao ha tributacao para os itens selecionados!<br>')
        else:
            obj_fiscal_nf_item_tributacao.unlink(cr, uid, _tribut_ids, context=context)
            msg += _('    Tributacoes excluidas: %s<br>') % len(_tribut_ids)

        # Cria tributacoes para os itens selecionados
        obj_fiscal_utils = self.pool.get('fiscal.utils')
        _qtd = 0


        pessoa_ids = []
        map(lambda x: x.get('destinatario_id') and pessoa_ids.append(x.get('destinatario_id')),
            _itens)
        dict_pessoas = {}
        if pessoa_ids:
            context['super_read_adm_pessoa'] = True
            campos = ['pessoa_tipo', 'admpes_jur_ie', 'admpes_fis_produtor_rural']
            map(lambda x: dict_pessoas.update({x.get('id'): x}),
                self.pool.get('adm.pessoa').read(cr, uid, pessoa_ids, campos, context))
        cont = 0
        porcentagem = 0
        controle = int(len(_itens)/10)
        for item in _itens:
            cont += 1
            _tipo_tributacao = 'T'
            _pessoa_id = False
            context_imposto = {}
            natureza_encargo_ids = []
            if item.get('nf_id'):
                if item.get('nf_propria'):
                    context_imposto.update({'proprio':True})
                else:
                    context_imposto.update({'terceiro':True})
                if item.get('tipo') == 'E':
                    _tipo_tributacao = 'E'
                if item.get('destinatario_id'):
                    _pessoa_id = item.get('destinatario_id')

                if item.get('natureza_id'):
                    context_imposto['dados_natureza'] = {'id': item.get('natureza_id'),
                                          'cfop_id': {'movimento_tipo': item.get('movimento_tipo')}}
                    natureza_encargo_ids = nat_encargos.get(item.get('natureza_id'))

            if item.get('cupom_id'):
                context_imposto.update({'proprio':True})
            context_imposto.update(context)

            for imp in obj_fiscal_utils.calcular_imposto(
                    cr, uid, item.get('produto_id'),
                    dados_destinatario=dict_pessoas.get(_pessoa_id) or {},
                    tipo_tributacao=_tipo_tributacao, vr_produto=item.get('vr_total_item'),
                    encargo_ids=_encargos_ids, context=context_imposto):
                # se o encargo nao estiver no filtro ou na natureza, a trib nao eh criada
                if imp['encargo_id'] not in _encargos_ids or \
                                imp['encargo_id'] not in natureza_encargo_ids:
                    continue

                tot_base_reduzida = imp['valor_base']
                vals = {
                    'encargo_id': imp['encargo_id'],
                    'cst_id': imp['cst_id'],
                    'tributacao_id': imp['tributacao_id'],
                    'vr_base_calculo': imp.get('valor_base'),
                    'vr_encargo': imp.get('valor_imposto'),
                    'vr_reducao_base': tot_base_reduzida,
                    'aliquota': imp.get('aliquota'),
                    'aliquota_venda': imp.get('aliquota_venda'),
                    'fisnit_csosn_id': imp.get('csosn_id'),
                    'modbcst': imp.get('modbcst'),
                    'movimento_itens_id': item.get('id'),
                    'percentual_mva': imp.get('mva')
                }
                obj_fiscal_nf_item_tributacao.create(cr, uid, vals, context=context)
                _qtd += 1
                context_imposto.clear()

            if cont > controle:
                cont = 0
                porcentagem += 10
                logger.info('Funcao 0001 %s%% concluida.' % porcentagem)

        logger.info('Funcao 0001 %s%% concluida.' % 100)
        msg += _('    Tributacoes incluidas: %s<br>') % _qtd

        # Aqui termina a parte especifica da funcao
        msg += _('<h1>Concluido sem erro!</h1>')
        res = self.write(cr, uid, ids, {'state': '3', 'mensagem': msg}, context)

        return res

