#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _
from ..descricao_funcoes import dic_funcoes
from datetime import datetime


class websig_executor_tela_osv(osv.TransientModel):
    _name = 'websig.executor.tela.osv'
    _inherit = 'websig.executor.tela.osv'

    def websig_exec_0003(self, cr, uid, ids, context):
        """
    Esta funcao apaga o saldo de todos os itens a partir da data selecionada, verificando se tem apenas pedidos e notas
de venda nos estados faturado ou cancelado, assim corrige o saldo de acordo com a tabela 'estoque_movimento_itens'.
        @param cr:
        @param uid:
        @param ids:
        @param context:
        @return: True ou False
        """
        msg = ''
        executor_tela_id = ids[0] if isinstance(ids, list) else ids
        funcao_escolhida = eval(self.browse(cr, uid, executor_tela_id, context).dados)[3]

        # Aqui comeca a parte especifica da funcao ####################
        # Se houver algum erro, mude o state para 4 e informe a mensagem de erro
        #--------------------------------------------------------------------------------------

        # verifica se existe pedidos ou notas que nao estao nem faturados nem validados
        company_id = self.pool.get('res.users').browse(cr, uid, uid).company_id.id
        sql_pedido = '''
                            SELECT id
                            FROM estoquepedidos_pedido_capa
                            WHERE state not in ('F', 'C')
                              AND tipo = 'V'
                              AND company_id = %s
                          ''' % company_id
        cr.execute(sql_pedido)
        verifica_pedido = cr.dictfetchall()
        if verifica_pedido:
            msg += _('<h1>Atencao!</h1>')
            msg += _('<h2>Existe(m) pedido(s) que nao esta(estao) faturado(s) ou cancelado(s)!</h2>')
            self.write(cr, uid, ids, {'state': '4',
                                      'mensagem': msg}, context)
            return False
        sql_nota = '''
                            SELECT id
                            FROM fiscal_nf_capa
                            WHERE state not in ('3', 'C', 'D', 'I')
                              AND tipo = 'S'
                              AND fisnfc_tipo_servico = False
                              AND company_id = %s
                          ''' % company_id
        cr.execute(sql_nota)
        verifica_nota = cr.dictfetchall()
        if verifica_nota:
            msg += _('<h1>Atencao!</h1>')
            msg += _('<h2>Existe(m) nota(s) que nao esta(estao) faturada(s), cancelada(s) ou '
                     'inutilizada(s)!</h2>')
            self.write(cr, uid, ids, {'state': '4',
                                      'mensagem': msg}, context)
            return False

        # apaga o saldo de todos os itens a partir da data selecionada
        _data_inicial = funcao_escolhida.get('campos').get('data_inicial').get('value', False)
        sql = '''
                DELETE FROM estoque_produto_saldo
                       WHERE data_movimento >= '%s'
                         AND company_id = %s
              ''' % (_data_inicial, company_id)
        cr.execute(sql)

        # busca os movimentos dos itens com saldo apagados e cria novos saldos
        ecf_instalado = self.pool.get('adm.utils').admutl_check_modulo_instalado(cr, uid, 'ecf', context)
        if ecf_instalado:
            sql_mov_itens = '''
                                SELECT data,
                                       produto_id,
                                       grade_id,
                                       local_id,
                                       estmvc_operacao_id,
                                       quantidade
                                FROM (
                                        SELECT data,
                                               produto_id,
                                               grade_id,
                                               local_id,
                                               estmvc_operacao_id,
                                               sum(quantidade) as quantidade
                                        FROM (  SELECT emc.data,
                                                       emi.produto_id,
                                                       emi.grade_id,
                                                       emi.local_id,
                                                       estmvc_operacao_id,
                                                       sum(emi.quantidade) as quantidade
                                                FROM estoque_movimento_capa        AS emc
                                                INNER JOIN estoque_movimento_itens AS emi ON emi.capa_id = emc.id
                                                WHERE emc.data >= '%s'
                                                  AND emc.company_id = %s
                                                  AND emc.state = 'F'
                                                  AND emi.cupom_id is NULL
                                                GROUP BY emc.data, emi.produto_id, emi.grade_id,emi.local_id, estmvc_operacao_id
                                                ORDER BY emc.data, emi.produto_id, emi.local_id
                                          ) AS tmp
                                        GROUP BY data, produto_id, grade_id, local_id, estmvc_operacao_id
                                        ORDER BY data, produto_id, local_id
                                ) AS tmp2

                                UNION

                                SELECT data,
                                       produto_id,
                                       grade_id,
                                       local_id,
                                       estmvc_operacao_id,
                                       quantidade
                                FROM (
                                        SELECT data,
                                               produto_id,
                                               grade_id,
                                               local_id,
                                               estmvc_operacao_id,
                                               sum(quantidade) as quantidade
                                        FROM (  SELECT emc.data,
                                                       emi.produto_id,
                                                       emi.grade_id,
                                                       emi.local_id,
                                                       estmvc_operacao_id,
                                                       (CASE WHEN emi.item_cancelado = False
                                                             THEN sum(emi.quantidade)
                                                             WHEN emi.item_cancelado = True AND ecc.tipo_cupom = 'C'
                                                             THEN sum(-emi.quantidade)
                                                             ELSE 0
                                                        END) AS quantidade
                                            FROM estoque_movimento_capa        AS emc
                                            INNER JOIN estoque_movimento_itens AS emi ON emi.capa_id = emc.id
                                            LEFT JOIN ecf_cupons_capa          AS ecc ON ecc.id = emc.cupons_capa_id
                                            WHERE emc.data >= '%s'
                                              AND emc.company_id = %s
                                              AND emc.state = 'F'
                                              AND emi.cupom_id is not NULL
                                            GROUP BY emc.data, emi.produto_id, emi.grade_id,emi.local_id, estmvc_operacao_id,
                                                     ecc.tipo_cupom, emi.item_cancelado
                                            ORDER BY emc.data, emi.produto_id, emi.local_id
                                            ) AS tmp3
                                        GROUP BY data, produto_id, grade_id, local_id, estmvc_operacao_id
                                        ORDER BY data, produto_id, local_id
                                ) AS tmp4
                            ''' % (_data_inicial, company_id, _data_inicial, company_id)
        else:
            sql_mov_itens = '''
                                SELECT emc.data,
                                       emi.produto_id,
                                       emi.grade_id,
                                       emi.local_id,
                                       estmvc_operacao_id,
                                       sum(emi.quantidade) as quantidade
                                FROM estoque_movimento_capa AS emc
                                INNER JOIN estoque_movimento_itens AS emi ON emi.capa_id = emc.id
                                INNER JOIN estoque_natureza_operacao AS eno ON eno.id = estmvc_operacao_id
                                WHERE emc.data >= '%s'
                                  AND emc.company_id = %s
                                  AND emi.item_cancelado = False
                                  AND emc.state = 'F'
                                  AND estnto_atualizar_saldo = True
                                GROUP BY emc.data, emi.produto_id, emi.grade_id,emi.local_id, estmvc_operacao_id
                                ORDER BY emc.data, emi.produto_id, emi.local_id
                            ''' % (_data_inicial, company_id)
        cr.execute(sql_mov_itens)
        dados_mov_itens = cr.dictfetchall()
        dados_mov_itens = sorted(dados_mov_itens, key=lambda i: i.get('data'))
        for item in dados_mov_itens:
            produto_id = item.get('produto_id')
            grade_id = item.get('grade_id')
            data_movimento = item.get('data')
            local_id = item.get('local_id')
            quantidade = item.get('quantidade')
            operacao_id = item.get('estmvc_operacao_id')
            sql_tipo_op = '''
                            SELECT estnto_tipo_operacao
                            FROM estoque_natureza_operacao
                            WHERE id = %s
                          ''' % (operacao_id)
            cr.execute(sql_tipo_op)
            tipo_operacao = cr.dictfetchall()
            if tipo_operacao and isinstance(tipo_operacao,list):
                tipo_operacao = tipo_operacao[0].get('estnto_tipo_operacao')
            sql_saldo = '''
                            SELECT saldo
                            FROM estoque_produto_saldo
                            WHERE grade_id = %s
                              AND produto_id = %s
                              AND local_id = %s
                              AND company_id = %s
                            ORDER BY data_movimento DESC
                            limit 1
                        ''' % (grade_id, produto_id, local_id, company_id)
            cr.execute(sql_saldo)
            dados_saldo = cr.dictfetchall()
            if dados_saldo and isinstance(dados_saldo, list):
                dados_saldo = dados_saldo[0]
            if dados_saldo:
                saldo = dados_saldo.get('saldo')
            else:
                saldo = 0
            if tipo_operacao == 'E':
                saldo += quantidade
            else:
                saldo -= quantidade
            sql_saldo_id = '''
                              SELECT id
                              FROM estoque_produto_saldo
                              WHERE data_movimento = '%s'
                                AND grade_id = %s
                                AND produto_id = %s
                                AND local_id = %s
                                AND company_id = %s
                           ''' % (data_movimento, grade_id, produto_id, local_id, company_id)
            cr.execute(sql_saldo_id)
            saldo_id = cr.dictfetchall()
            create_date = write_date = datetime.now()
            create_uid =  write_uid = uid
            if saldo_id:
                saldo_id = saldo_id[0].get('id')
                update_saldo = '''
                                  UPDATE estoque_produto_saldo
                                  SET write_date = '%s',
                                      write_uid = %s,
                                      data_movimento = '%s',
                                      produto_id = %s,
                                      grade_id = %s,
                                      local_id = %s,
                                      company_id = %s,
                                      saldo = %s
                                  WHERE id = %s
                ''' % (write_date, write_uid, data_movimento, produto_id, grade_id, local_id, company_id, saldo, saldo_id)
                cr.execute(update_saldo)
            else:
                insert_saldo = '''
                                  INSERT INTO estoque_produto_saldo( create_uid, create_date, write_uid, write_date,
                                              data_movimento, produto_id, grade_id, local_id, company_id, saldo)
                                  VALUES (%s,'%s',%s,'%s',
                                          '%s', %s, %s, %s, %s, %s)
                ''' % (create_uid, create_date, write_uid, write_date,
                       data_movimento, produto_id, grade_id, local_id, company_id, saldo)
                cr.execute(insert_saldo)
        #--------------------------------------------------------------------------------------
        # Aqui termina a parte especifica da funcao ########################
        msg += _('<h1>Concluido sem erro!</h1>')
        res = self.write(cr, uid, ids, {'state': '3',
                                        'mensagem': msg}, context)

        return res

