#!/usr/bin/python
# -*- coding: utf-8 -*-
"""
Copyright (C) 2009-2015 All Rights Reserved. Luiz Fernando Maciel Franca
              www.siginformatica.com.br <luiz[at]siginformatica.com.br>
                                -------

Copyleft (CC) 2015, Creative Commons
Autor - Pierre Geraldo Moura Barbosa <barbosa.pierre[at]gmail.com>
================================================================================
Atribuicao-Nao Comercial-Compartilhada Igual 3.0 Nao Adaptada (CC BY-NC-SA 3.0)
http://creativecommons.org/licenses/by-nc-sa/3.0/deed.pt_BR
================================================================================
"""
from openerp.osv import osv
from openerp.tools.translate import _


# noinspection PyPep8Naming
class websig_executor_tela_osv(osv.TransientModel):
    _name = 'websig.executor.tela.osv'
    _inherit = 'websig.executor.tela.osv'

    def websig_exec_0004(self, cr, uid, ids, context=None):
        """
        0004-Corrigir natureza da receita PIS/COFINS.
        Esta funcao recupera todos os itens que estejam cadastrados na Categoria e/ou NCM e altera seus respectivos
        valores PIS/COFINS,´´estpro_pis_nat_rec´´ e ´´estpro_cofins_nat_rec´´, conforme informado.

        :param cr: a linha atual do cursor do banco de dados,
        :param uid: ID do usuario utilizado para a verificacao de perfil
        :param ids: lista com os IDs
        :param context: um dicionario padrao para valores contextuais
        :type cr: cursor
        :type uid: integer
        :type ids: long|list[long]
        :type context: dict
        :return: verdadeiro se os produtos sofreram alteracao da natureza ou ncm.
        :rtype: bool

        :author: Pierre Barbosa <pierre.barbosa[at]siginformatica.com.br>
        """

        context = context and context.copy() or {}

        # Recupera as informacoes do formulario (f0004)
        executor_tela_id = ids[0] if isinstance(ids, list) else ids
        funcao_escolhida = eval(self.browse(cr, uid, executor_tela_id, context).dados)[4]

        # __________________________ Objects _________________________________
        obj_estoque_produto = self.pool.get('estoque.produto')

        # Realiza as alteracao da natureza por categoria e/ou NCM
        args = []
        categoria_id = funcao_escolhida.get('campos').get('categoria_id').get('value', False)
        ncm_id = funcao_escolhida.get('campos').get('ncm_id').get('value', False)
        pis_natureza_receita = funcao_escolhida.get('campos').get('pis_natureza_receita').get(
            'value', False)
        cofins_natureza_receita = funcao_escolhida.get('campos').get('cofins_natureza_receita').get(
            'value', False)

        if not any([categoria_id, ncm_id]):
            raise osv.except_osv(_('Atencao'), _('A categoria ou o NCM deve ser informado.'))

        if categoria_id:
            args.extend(([('categoria_id', '=', categoria_id)]))

        if ncm_id:
            args.extend(([('ncm_id', '=', ncm_id)]))

        item_ids = obj_estoque_produto.search(cr, uid, args, context=context)

        if item_ids:
            _sql = "UPDATE estoque_produto SET estpro_pis_nat_rec='%s', estpro_cofins_nat_rec='%s'"
            _sql += " WHERE id IN %s"
            result = cr.execute(_sql % (pis_natureza_receita or '', cofins_natureza_receita or '',
                                        str(item_ids).replace('[', '(').replace(']', ')')
            ))
            msg = _('Quantidade de itens alterados: %s') % item_ids.__len__()
        else:
            msg = _('Nenhuma item foi alterado.')
            result = False

        # Mostra mensagem
        msg = _('<strong>Concluido sem erro.</strong>') + '<br>' + msg
        self.write(cr, uid, ids, {'state': '3', 'mensagem': msg}, context)

        return result

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
