#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _
from datetime import datetime
from openerp.osv.fields import float_round


class websig_executor_tela_osv(osv.TransientModel):
    _name = 'websig.executor.tela.osv'
    _inherit = 'websig.executor.tela.osv'

    def websig_exec_0006(self, cr, uid, ids, context):
        """
Esta funcao seleciona os cupons no intervalo de datas escolhido, apaga os movimentos destes cupons e gera
novamente seus movimentos.
        @param cr:
        @param uid:
        @param ids:
        @param context:
        @return: True ou False
        """
        context = context and context.copy() or {}
        msg = []
        executor_tela_id = ids[0] if isinstance(ids, list) else ids
        funcao_escolhida = eval(self.browse(cr, uid, executor_tela_id, context).dados)[6]

        # Aqui comeca a parte especifica da funcao ####################
        # Se houver algum erro, mude o state para 4 e informe a mensagem de erro
        #--------------------------------------------------------------------------------------
        obj_adm_utils = self.pool.get('adm.utils')
        ecf_instalado = obj_adm_utils.admutl_check_modulo_instalado(cr, uid, 'ecf', context)
        if not ecf_instalado:
            msg.append(_('<h1>Atencao!</h1>'))
            msg.append(_('<h2>Modulo ECF nao esta instalado!</h2>'))
            self.write(cr, uid, ids, {'state': '4', 'mensagem': '\n'.join(msg)}, context)
            return False

        company_id = self.pool.get('res.users').browse(cr, uid, uid).company_id.id
        _data_inicial = funcao_escolhida.get('campos').get('data_inicial').get('value', False)
        _data_final = funcao_escolhida.get('campos').get('data_final').get('value', False)
        if _data_inicial > _data_final:
            msg.append(_('<h1>Atencao!</h1>'))
            msg.append(_('<h2>Data inicial deve ser menor ou igual a data final!</h2>'))
            self.write(cr, uid, ids, {'state': '4', 'mensagem': '\n'.join(msg)}, context)
            return False
        args = [('date_cupom', '>=', _data_inicial),
                ('date_cupom', '<=', _data_final),
                ('tipo_cupom', 'in', ('V', 'C')),
                ('company_id', '=', company_id)]  # cupom valido e divergente
        cupom_ids = self.pool.get('ecf.cupons.capa').search(cr, uid, args, context=context)
        if not cupom_ids:
            msg.append(_('<h1>Concluido!</h1>'))
            msg.append(_('<h2>Nenhum cupom encontrado para este intervalo de data!</h2>'))
            res = self.write(cr, uid, ids, {'state': '3', 'mensagem': '\n'.join(msg)}, context)
            return res

        local_venda_padrao = obj_adm_utils.admutl_get_parametros(cr, uid, 'estoque.parametro',
                                  ['local_venda_padrao_id'], company_id=company_id, context=context)
        if not local_venda_padrao:
            msg.append(_('<h1>Atencao!</h1>'))
            msg.append(_("<h2>O campo 'Local para saídas'  nao encontra-se cadastrado no parametro do estoque!</h2>"))
            res = self.write(cr, uid, ids, {'state': '3', 'mensagem': '\n'.join(msg)}, context)
            return res

        local_id = ''
        if isinstance(local_venda_padrao, dict):
            local_id = local_venda_padrao.get('local_venda_padrao_id')

        # deleta todos os itens dos cupons selecionado do periodo indicado
        sql = '''
                DELETE FROM estoque_movimento_itens
                WHERE cupom_id IN (%s) AND nf_id IS NULL
              ''' % ','.join(map(lambda x: '%s' % x ,cupom_ids))
        cr.execute(sql)
        qtd_itens = 0
        create_date = write_date = str(datetime.now())
        create_uid = write_uid = uid
        sql = """
            SELECT id,
                   codigo
            FROM fiscal_cfop
            WHERE codigo IN ('5102', '5405', '5933')"""
        cr.execute(sql)
        codigo_id_cfop = {}
        map(lambda x: codigo_id_cfop.update({x.get('codigo'): x.get('id')}), cr.dictfetchall())
        automacao_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                          'automacao.codigo.barra', context=context)
        sql = """
            SELECT
                ecc.id                    AS cupom_id,
                ecc.coo,
                ecc.date_cupom,
                ecc.hora_cupom_fim,
                ecc.hora_cupom_inicio,
                ee.caixa,
                eci.item                  AS codigo_barra,
                eci.venda_cancelamento,
                eci.tributacao_retag,
                eci.quantidade,
                eci.preco_total,
                eci.desconto,
                eci.acrescimo,
                eci.ecfcit_cod_vendedor,
                eci.sequencia,
                eci.id                    AS cupom_item_id,
                (SELECT min(id) FROM estoque_movimento_capa
                    WHERE cupons_capa_id = ecc.id)                       AS mov_capa_id,
                (SELECT min(id) FROM estoque_movimento_itens
                    WHERE cupom_id = ecc.id AND acb.grade_id = grade_id) AS mov_item_id,
                (SELECT sum(vr_total_item_rateado) FROM estoque_movimento_itens
                    WHERE cupom_id = ecc.id AND acb.grade_id = grade_id) AS vr_total_item_rateado,
                (SELECT sum(estmvi_saidas_custo_corrigido_total) FROM estoque_movimento_itens
                    WHERE cupom_id = ecc.id AND acb.grade_id = grade_id) AS estmvi_saidas_custo_corrigido_total,
                (SELECT sum(estmvi_saidas_ultimo_custo_total) FROM estoque_movimento_itens
                    WHERE cupom_id = ecc.id AND acb.grade_id = grade_id) AS estmvi_saidas_ultimo_custo_total,
                (SELECT sum(estmvi_saidas_custo_reposicao_total) FROM estoque_movimento_itens
                    WHERE cupom_id = ecc.id AND acb.grade_id = grade_id) AS estmvi_saidas_custo_reposicao_total,
                (SELECT sum(estmvi_saidas_custo_medio_contabil_total) FROM estoque_movimento_itens
                    WHERE cupom_id = ecc.id AND acb.grade_id = grade_id) AS estmvi_saidas_custo_medio_contabil_total,
                (SELECT sum(vr_acrescimos) FROM estoque_movimento_itens
                    WHERE cupom_id = ecc.id AND acb.grade_id = grade_id) AS vr_acrescimos,
                (SELECT sum(vr_desconto) FROM estoque_movimento_itens
                    WHERE cupom_id = ecc.id AND acb.grade_id = grade_id) AS vr_desconto,
                (SELECT sum(vr_despesas_rateado) FROM estoque_movimento_itens
                    WHERE cupom_id = ecc.id AND acb.grade_id = grade_id) AS vr_despesas_rateado,
                (SELECT sum(vr_total_item) FROM estoque_movimento_itens
                    WHERE cupom_id = ecc.id AND acb.grade_id = grade_id) AS vr_total_item,
                (SELECT min(id) FROM fiscal_tributacao
                    WHERE tributacao_ecf = eci.tributacao_retag)         AS tributacao_id,
                (SELECT sigla FROM fiscal_encargo WHERE id IN (SELECT min(encargo_id) FROM fiscal_tributacao
                    WHERE tributacao_ecf = eci.tributacao_retag))        AS encargo_sigla,
                (SELECT tipo FROM fiscal_cst WHERE id IN (SELECT min(cst_id) FROM fiscal_tributacao
                    WHERE tributacao_ecf = eci.tributacao_retag))        AS cst_tipo,
                (SELECT tipo FROM estoque_produto
                    WHERE id = acb.produto_id)                           AS produto_tipo,
                (SELECT quantidade_na_embalagem FROM estoque_embalagem
                    WHERE id IN (SELECT embalagem_id FROM estoque_produto_embalagem
                                WHERE id = acb.produto_embalagem_id))    AS quantidade_embalagem,
                acb.produto_id,
                acb.grade_id,
                acb.produto_embalagem_id

            FROM ecf_cupons_capa               AS ecc
            INNER JOIN ecf_cupons_item         AS eci ON eci.capa_id = ecc.id
            INNER JOIN ecf_ecf                 AS ee  ON ee.id = ecc.ecf_id
            LEFT JOIN automacao_codigo_barra  AS acb ON acb.codigo_barra = eci.item
            WHERE ecc.date_cupom >= '{data_inicial}'
                AND ecc.date_cupom <= '{data_final}'
                AND ecc.tipo_cupom in ('V', 'C') -- Venda e cancelamento
                AND ecc.state = 'V'              -- Validado
                AND ecc.company_id = {company_id}
                AND CASE 
                        WHEN acb.produto_id IS NOT NULL THEN acb.company_id = {acb_company_id} 
                        ELSE TRUE 
                    END
              """.format(data_inicial=_data_inicial,
                         data_final=_data_final,
                         company_id=company_id,
                         acb_company_id=automacao_company_id)
        cr.execute(sql)
        dados_itens = cr.dictfetchall()
        if not dados_itens:
            raise osv.except_osv(_('Atencao'),
                                 _('Nenhum codigo de barras encontrado para os cupons.'))
        data_produto_ids = {} # chave data, valor eh uma lista com os ids dos produtos
        for item in dados_itens:
            data = item.get('date_cupom')
            produto_id = item.get('produto_id')
            if not produto_id:
                continue
            if not data_produto_ids.get(data):
                data_produto_ids[data] = [produto_id]
            else:
                data_produto_ids[data].append(produto_id)

        custo_company_id = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid,
                                                             'estoque.preco.custo', context=context)
        custos_por_data = {}
        custo_id_por_data = {}
        for data, produto_ids in data_produto_ids.items():
            custos_por_data[data] = self.pool.get('estoque.preco.custo').get_custos_do_dia(cr, uid,
                                                       produto_ids, custo_company_id, data, context)
            cr.execute('''SELECT id, produto_id, max(create_date)
                          FROM estoque_preco_custo
                          WHERE produto_id IN (%s)
                            AND create_date <= '%s'
                            AND company_id = %s
                          GROUP BY  produto_id, id''' %
                       (','.join(map(lambda x: '%s' % x, produto_ids)), data, custo_company_id))
            id_produto_custo = {}
            map(lambda x: id_produto_custo.update({x.get('produto_id'): x.get('id')}),
                cr.dictfetchall())
            custo_id_por_data[data] = id_produto_custo

        # cria movimento dos itens dos cupons e suas tributacoes
        vals_itens = {}
        cupom_item_trib = {}
        cupom_item_produto = {}
        msg_codigo_barra = []
        for item in dados_itens:
            cupom_id = item.get('cupom_id')
            date_cupom = item.get('date_cupom')
            coo = item.get('coo')
            ecf = item.get('caixa')
            qtd_itens += 1
            codigo_barra = item.get('codigo_barra')
            if not item.get('produto_id'):
                msg_codigo_barra.append(_("Item %s do cupom %s da ecf %s." % (
                    codigo_barra, coo, ecf)))
                continue

            produto_id = item.get('produto_id')
            grade_id = item.get('grade_id')
            tributacao_id = item.get('tributacao_id')
            if not tributacao_id:
                msg.append(_('<h2>A TRIBUTACAO RETAGUARDA %s no item %s do cupom %s na ecf %s nao '
                         'esta cadastrada ou encontra-se inativa!</h2>' %
                         (item.get('tributacao_retag'), codigo_barra, coo, ecf)))
                continue

            cupom_item_trib[item.get('cupom_item_id')] = tributacao_id
            cupom_item_produto[item.get('cupom_item_id')] = produto_id
            mov_capa_id = item.get('mov_capa_id')

            # Cria movimentação se não houver movimentação p/ o item
            quantidade = float_round((item.get('quantidade') or 0) *
                                     (item.get('quantidade_embalagem') or 0), 3)

            # inicia a transacao para criar ou atualizar movimento dos itens
            # cr.execute(''' BEGIN;
            #                SAVEPOINT criar_movimento_itens; ''')

            chave = '%s-%s-%s-%s' % (cupom_id,
                                     grade_id,
                                     produto_id,
                                     (item.get('venda_cancelamento') == 'C'))

            # caso ja exista o movimento do item, apenas atualiza o movimento
            custos = custos_por_data.get(date_cupom).get(produto_id)
            if vals_itens.get(chave):
                vals_itens[chave]['vr_total_item_rateado'] += item.get('preco_total') +\
                                                             item.get('acrescimo') - \
                                                             item.get('desconto')

                if custos:
                    vals_itens[chave]['custo_corrigido'] += \
                                            (custos.get('estprc_custo_corrigido') or 0) * quantidade
                    vals_itens[chave]['ultimo_custo'] += \
                                               (custos.get('estprc_ultimo_custo') or 0) * quantidade
                    vals_itens[chave]['custo_reposicao'] += \
                                            (custos.get('estprc_custo_reposicao') or 0) * quantidade
                    vals_itens[chave]['custo_medio'] += \
                                       (custos.get('estprc_custo_medio_contabil') or 0) * quantidade

                vals_itens[chave]['vr_acrescimos'] += item.get('acrescimo') or 0
                vals_itens[chave]['vr_desconto'] += item.get('desconto') or 0
                vals_itens[chave]['vr_despesas_rateado'] += item.get('acrescimo') or 0
                vals_itens[chave]['vr_desconto_rateado'] += item.get('desconto') or 0
                vals_itens[chave]['quantidade'] += quantidade
                vals_itens[chave]['vr_total_item'] += item.get('preco_total')

            else:
                icms_substituicao = False
                encargo = item.get('encargo_sigla')
                tipo_cst = item.get('cst_tipo')

                if encargo == 'ICMS' and tipo_cst == 'U':
                    icms_substituicao = True

                tipo_produto = item.get('produto_tipo')

                cfop_id = 'null'
                if tipo_produto == 'S':
                    if codigo_id_cfop.get('5933'):
                        cfop_id = codigo_id_cfop.get('5933')
                elif icms_substituicao:
                    if codigo_id_cfop.get('5405'):
                        cfop_id = codigo_id_cfop.get('5405')
                else:
                    if codigo_id_cfop.get('5102'):
                        cfop_id = codigo_id_cfop.get('5102')

                vr_total_item_rateado = (item.get('preco_total') or 0) + (item.get('acrescimo') or 0) - (item.get('desconto') or 0)
                vr_unitario = item.get('preco_total') / quantidade
                vr_preco_venda = item.get('preco_total') / quantidade
                if item.get('venda_cancelamento') != 'C':
                    item_cancelado = False
                else:
                    item_cancelado = True

                custo_corrigido = ultimo_custo = custo_reposicao = custo_medio = 0
                custo_id = 'null'
                if custos:
                    custo_corrigido = (custos.get('estprc_custo_corrigido') or 0) * quantidade
                    ultimo_custo = (custos.get('estprc_ultimo_custo') or 0) * quantidade
                    custo_reposicao = (custos.get('estprc_custo_reposicao') or 0) * quantidade
                    custo_medio = (custos.get('estprc_custo_medio_contabil') or 0) * quantidade

                    custo_id = custo_id_por_data.get(data).get(produto_id) or 'null'

                cod_vendedor = 'null'
                if item.get('ecfcit_cod_vendedor'):
                    cod_vendedor = item.get('ecfcit_cod_vendedor')


                vals_item = {'create_uid': create_uid,
                             'create_date': create_date,
                             'write_date': write_date,
                             'write_uid': write_uid,
                             'mov_capa_id': mov_capa_id,
                             'produto_id': produto_id,
                             'grade_id': grade_id,
                             'local_id': local_id,
                             'produto_embalagem_id': item.get('produto_embalagem_id'),
                             'quantidade': quantidade,
                             'sequencia': item.get('sequencia') or 0,
                             'vr_unitario': vr_unitario,
                             'vr_preco_venda': vr_preco_venda,
                             'vr_total_item': item.get('preco_total'),
                             'vr_acrescimos': item.get('acrescimo') or 0,
                             'vr_desconto': item.get('desconto') or 0,
                             'vr_total_item_rateado': vr_total_item_rateado,
                             'vr_despesas_rateado': item.get('vr_despesas_rateado') or 0,
                             'vr_desconto_rateado': item.get('vr_desconto_rateado') or 0,
                             'cupom_id': cupom_id,
                             'cupom_item_id': item.get('cupom_item_id'),
                             'item_cancelado': item_cancelado,
                             'cfop_id': cfop_id,
                             'custo_corrigido': custo_corrigido,
                             'ultimo_custo': ultimo_custo,
                             'custo_reposicao': custo_reposicao,
                             'custo_medio': custo_medio,
                             'custo_id': custo_id,
                             'vendedor_id': cod_vendedor}

                vals_itens[chave] = vals_item

        # cr.execute(''' ROLLBACK TO SAVEPOINT criar_movimento_itens; ''')
        # cr.execute(''' COMMIT; ''')

        if msg_codigo_barra:
            raise osv.except_osv(_('Atencao'), 'Os itens a seguir nao possuem codigo de barras '
                                               'cadastrado na tabela automacao_codigo_barras:\n' +
                                 ' \n'.join(msg_codigo_barra))
        insert_itens = []
        parcelas_insert = [] # divide a inserção em parcelas
        count = 0
        for item in vals_itens.values():
            values_insert = '''({create_uid},'{create_date}','{write_date}', {write_uid},
                                {mov_capa_id}, {produto_id},  {grade_id},  {local_id}, {prod_emb_id},
                                {qtd}, {sequencia},  {vr_unitario},  {vr_preco_venda}, {preco_total}, {acrescimo},
                                {vr_desconto}, {tot_item_rat},  {desp_rat},  {desc_rat},
                                {cupom_id}, {cup_item_id}, {item_cancelado}, {cfop_id},
                                {custo_corrigido}, {ultimo_custo}, {custo_reposicao}, {custo_medio},
                                {custo_id}, {vendedor_id})'''.format(
                create_uid = item.get('create_uid'),
                create_date = item.get('create_date'),
                write_date = item.get('write_date'),
                write_uid = item.get('write_uid'),
                mov_capa_id = item.get('mov_capa_id'),
                produto_id = item.get('produto_id'),
                grade_id = item.get('grade_id'),
                local_id = item.get('local_id'),
                prod_emb_id = item.get('produto_embalagem_id'),
                qtd = item.get('quantidade'),
                sequencia = item.get('sequencia') or 0,
                vr_unitario = item.get('vr_unitario'),
                vr_preco_venda = item.get('vr_preco_venda'),
                preco_total = item.get('vr_total_item'),
                acrescimo = item.get('vr_acrescimos') or 0,
                vr_desconto = item.get('vr_desconto') or 0,
                tot_item_rat = item.get('vr_total_item_rateado'),
                desp_rat = item.get('vr_despesas_rateado') or 0,
                desc_rat = item.get('vr_desconto_rateado') or 0,
                cupom_id = item.get('cupom_id'),
                cup_item_id =  item.get('cupom_item_id'),
                item_cancelado =  item.get('item_cancelado'),
                cfop_id =  item.get('cfop_id'),
                custo_corrigido =  item.get('custo_corrigido'),
                ultimo_custo =  item.get('ultimo_custo'),
                custo_reposicao =  item.get('custo_reposicao'),
                custo_medio =  item.get('custo_medio'),
                custo_id =  item.get('custo_id'),
                vendedor_id =  item.get('vendedor_id'))
            insert_itens.append(values_insert)
            count += 1
            if count >= 30000: # restringe em 30000 para nao sobrecarregar o computador
                count = 0
                parcelas_insert.append(insert_itens)
                insert_itens = []

        if insert_itens: # insere os ultimos elementos caso nao alcance 30000
            parcelas_insert.append(insert_itens)

        dados_mov_itens = []
        for parcela in parcelas_insert:
            sql_insert = '''
                    INSERT INTO estoque_movimento_itens(create_uid, create_date, write_date, write_uid,
                                capa_id, produto_id, grade_id, local_id, produto_embalagem_id,
                                quantidade, sequencia, vr_unitario, vr_preco_venda, vr_total_item, vr_acrescimos,
                                vr_desconto, vr_total_item_rateado, vr_despesas_rateado, vr_desconto_rateado,
                                cupom_id, cupom_item_id, item_cancelado , cfop_id, estmvi_saidas_custo_corrigido_total,
                                estmvi_saidas_ultimo_custo_total, estmvi_saidas_custo_reposicao_total,
                                estmvi_saidas_custo_medio_contabil_total, estmvi_entrada_preco_custo_id,
                                vendedor_id)
                    VALUES %s
                    returning id, cupom_item_id''' % ',\n'.join(parcela)

            cr.execute(sql_insert)
            dados_mov_itens.extend(cr.dictfetchall())

        sql = '''
                SELECT id,
                       cupom_id, 
                       produto_id, 
                       grade_id, 
                       produto_embalagem_id,
                       item_cancelado,
                       vendedor_id
                FROM estoque_movimento_itens
                WHERE cupom_id IN (%s) AND nf_id IS NULL
              ''' % ','.join(map(lambda x: '%s' % x ,cupom_ids))
        cr.execute(sql)
        dados_mov_itens = {}
        for i in cr.dictfetchall():
            chave = '%s-%s-%s-%s-%s-%s' % (i.get('cupom_id'),
                                           i.get('produto_id'),
                                           i.get('grade_id'),
                                           i.get('produto_embalagem_id'),
                                           i.get('item_cancelado'),
                                           i.get('vendedor_id') or False)
            dados_mov_itens[chave] = i.get('id')

        args = [('capa_id', 'in', cupom_ids)]
        cupom_item_ids = self.pool.get('ecf.cupons.item').search(cr, uid, args, context=context)
        sql = '''SELECT eci.id, 
                        acb.produto_id,
                        acb.grade_id,
                        acb.produto_embalagem_id
                 FROM ecf_cupons_item              AS eci
                 LEFT JOIN automacao_codigo_barra AS acb ON acb.codigo_barra = eci.item
                 WHERE 
                     eci.id IN (%s)
                     AND CASE 
                             WHEN acb.produto_id IS NOT NULL THEN acb.company_id = %s 
                             ELSE TRUE 
                         END
              ''' % (','.join(map(lambda x: "%s" % x, cupom_item_ids)), automacao_company_id)
        cr.execute(sql)
        itens_produto_grade = {}
        map(lambda x: itens_produto_grade.update({x.get('id'): x}), cr.dictfetchall())
        item_trib_ids = []
        for brw_cupom_item in self.pool.get('ecf.cupons.item').browse(cr, uid, cupom_item_ids,
                                                                      context=context):
            # Grava tributação dos itens do cupom
            chave = '%s-%s-%s-%s-%s-%s' % \
                    (brw_cupom_item.capa_id.id,
                     itens_produto_grade.get(brw_cupom_item.id).get('produto_id'),
                     itens_produto_grade.get(brw_cupom_item.id).get('grade_id'),
                     itens_produto_grade.get(brw_cupom_item.id).get('produto_embalagem_id'),
                     (brw_cupom_item.venda_cancelamento == 'C'),
                     brw_cupom_item.ecfcit_cod_vendedor or False)
            mov_item_id = dados_mov_itens.get(chave)
            if not mov_item_id:
                continue

            cup_item_id = brw_cupom_item.id
            tributacao_id = cupom_item_trib.get(cup_item_id)
            context['funcao_006'] = True
            item_trib_ids = self.pool.get('ecf.cupons.capa').atualiza_fiscal_item_tributacao(cr, uid,
                                cupom_item_produto.get(cup_item_id), tributacao_id, brw_cupom_item,
                                mov_item_id, context)
            if isinstance(item_trib_ids, str) and item_trib_ids.startswith('1'):
                msg.append(_('<h2>O item %s do cupom %s da ecf %s possui o encargo da tributacao diferente do encargo do cadastro</h2>' %
                         (codigo_barra, coo, ecf)))

            elif isinstance(item_trib_ids, str) and item_trib_ids.startswith('2-'):
                msg.append(_("'<h2>Item %s  do cupom %s da ecf %s, %s</h2>") % (codigo_barra, coo,
                                                                  ecf, item_trib_ids.split('-')[1]))

        if item_trib_ids:
            context_trib = context.copy()
            context_trib['fisnit_super_write'] = True
            self.pool.get('fiscal.nf.item.tributacao').write(cr, uid, item_trib_ids,
                                                             {}, context=context_trib)
        #--------------------------------------------------------------------------------------
        # Aqui termina a parte especifica da funcao ########################
        if not msg:
            msg.append(_('<h1>Concluido sem erro!</h1>'))
            res = self.write(cr, uid, ids, {'state': '3',
                                            'mensagem': '\n'.join(msg)}, context)
        else:
            msg = [_('<h1>Concluido mas com os seguintes erros:</h1>')] + msg
            res = self.write(cr, uid, ids, {'state': '3',
                                            'mensagem': '\n'.join(msg)}, context)

        print '--------->Quantidade de itens: ', qtd_itens, '\n'

        return res

