#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv
from openerp.tools.translate import _
from dateutil.relativedelta import relativedelta
from datetime import datetime


class websig_executor_tela_osv(osv.TransientModel):
    _name = 'websig.executor.tela.osv'
    _inherit = 'websig.executor.tela.osv'

    def websig_exec_0009(self, cr, uid, ids, context):
        context = context and context.copy() or {}
        msg = ''
        obj_estinvcont = self.pool.get('estoque.inventario.contagem')
        obj_estprosal = self.pool.get('estoque.produto.saldo')
        executor_tela_id = ids[0] if isinstance(ids, list) else ids
        funcao_escolhida = eval(self.browse(cr, uid, executor_tela_id, context).dados)[9]
        _inventario_id = funcao_escolhida.get('campos').get('inventario_id').get('value', False)
        args_inventario = [('inventario_id', '=', _inventario_id)]
        invitens_ids = obj_estinvcont.search(cr, uid, args_inventario, context=context)
        brw_inv_itens = obj_estinvcont.browse(cr, uid, invitens_ids, context=context)
        if funcao_escolhida.get('campos').get('contagem_com_diferenca').get('value'):
            brw_inv_itens = filter(lambda i: i.saldo_contado != i.saldo_cadastro, brw_inv_itens)
        for item in brw_inv_itens:
            data_anterior_inventario = datetime.strptime(item.inventario_id.create_date[:10],
                                                         '%Y-%m-%d')
            data_anterior_inventario = data_anterior_inventario - relativedelta(days=1)
            data_anterior_inventario = data_anterior_inventario.strftime('%Y-%m-%d')
            saldo_do_dia_do_inventario = obj_estprosal.get_saldo_do_dia(
                cr, uid, item.grade_id.id, data_anterior_inventario,
                eps_local_id=item.local_id.id, context=context)
            obj_estinvcont.write(cr, uid, item.id, {
                'saldo_cadastro': saldo_do_dia_do_inventario.get(item.grade_id.id).get('saldo')})
            _sql = """
                    SELECT CASE
                             WHEN eic.saldo_contado < saldo_cadastro THEN 'S'
                             ELSE 'E'
                           END AS tipo,
                           CASE
                             WHEN eic.saldo_contado = saldo_cadastro THEN eic.saldo_contado
                             ELSE eic.saldo_contado - eic.saldo_cadastro
                           END AS quantidade_movimentada_inventario
                    FROM   estoque_inventario_contagem AS eic
                    WHERE  eic.id = {contagem_id}
            """.format(contagem_id=item.id)
            cr.execute(_sql)
            for novo_item in cr.dictfetchall():
                quantidade_movimentada = novo_item.get('quantidade_movimentada_inventario')
                _sql = """
                    SELECT emi.id AS emi_id
                    FROM   estoque_movimento_itens emi
                           INNER JOIN estoque_movimento_capa emc
                                   ON emc.id = emi.capa_id
                    WHERE  emc.inventario_id = {inventario_id}
                           AND emi.grade_id = {grade_id}
                           AND emc.company_id = {company_id}
                """.format(inventario_id=_inventario_id, grade_id=item.grade_id.id,
                           company_id=item.inventario_id.company_id.id)
                cr.execute(_sql)
                for mov_item in cr.dictfetchall():
                    if quantidade_movimentada != item.saldo_contado:
                        self.pool.get('estoque.movimento.itens').write(
                            cr, uid, mov_item.get('emi_id'), {'quantidade': quantidade_movimentada},
                            context=context)
                    else:
                        self.pool.get('estoque.movimento.itens').unlink(
                            cr, uid, mov_item.get('emi_id'), context=context
                        )
        msg += _('<h1>Concluido sem erro!</h1>')
        res = self.write(cr, uid, ids, {'state': '3', 'mensagem': msg}, context)
        return res
