#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from .descricao_funcoes import dic_funcoes, NOME_FUNCOES


# noinspection PyAbstractClass,PyPep8Naming
class websig_executor_osv(osv.TransientModel):
    _name = 'websig.executor.osv'
    _columns = {
        'websig_exec_funcao': fields.selection(NOME_FUNCOES, 'Funcao a executar', size=7,
                                               required=True),
        'websig_exec_mensagem': fields.text('Mensagem', readonly=True)
    }

    # noinspection PyMethodMayBeStatic,PyMethodMayBeStatic
    def websig_exec_selecionar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        return dict(name='Selecao de valores', view_type='form', view_mode='form', view_id=False,
                    res_model='websig.executor.tela.osv', type='ir.actions.act_window',
                    target='inline')

    # noinspection PyMethodMayBeStatic,PyMethodMayBeStatic
    def websib_exec_onchange_funcao(self, cr, uid, ids, funcao, context=None):
        context = context and context.copy() or {}
        res = {'value': {}}

        if not funcao:
            return res
        try:
            res['value'] = {'websig_exec_mensagem': dic_funcoes.get(int(funcao)).get('obs')}
        except:
            res['value'] = {'websig_exec_mensagem': dic_funcoes.get(funcao).get('obs')}
        return res

    def fields_view_get(self, cr, user, view_id=None, view_type='form', context=None, toolbar=False,
                        submenu=False):
        context = context and context.copy() or {}
        res = super(websig_executor_osv, self).fields_view_get(
            cr, user, view_id, view_type, context, toolbar, submenu)

        return res


# noinspection PyAbstractClass,PyPep8Naming
class websig_executor_tela_osv(osv.TransientModel):
    _name = 'websig.executor.tela.osv'
    _columns = {
        'state': fields.selection([('1', 'Selecao'), ('2', 'Processando'), ('3', 'Concluido'),
                                   ('4', 'Erro')], 'Estado'),
        'mensagem': fields.html('Mensagem de erro', readonly=True),
        'dados': fields.text('Dados funcao'),

    }
    _defaults = {'state': '1'}

    def write(self, cr, uid, ids, vals, context=None):
        context = context and context.copy() or {}

        executor_osv_dados = self.pool.get('websig.executor.osv').read(
            cr, uid, context.get('active_id'), ['websig_exec_funcao'], context=context)
        try:
            funcao = int(executor_osv_dados.get('websig_exec_funcao'))
        except:
            funcao = executor_osv_dados.get('websig_exec_funcao')

        for campo in vals:
            if campo not in ('state', 'mensagem'):
                dic_funcoes.get(funcao)['campos'][campo]['value'] = vals.get(campo)

        vals.update({'dados': str(dic_funcoes)})

        res = super(websig_executor_tela_osv, self).write(cr, uid, ids, vals, context)
        return res

    def create(self, cr, uid, vals, context=None):
        context = context and context.copy() or {}
        executor_osv_dados = self.pool.get('websig.executor.osv').read(
            cr, uid, context.get('active_id'), ['websig_exec_funcao'], context=context)
        try:
            funcao = int(executor_osv_dados.get('websig_exec_funcao'))
        except:
            funcao = executor_osv_dados.get('websig_exec_funcao')

        for campo in vals:
            if campo not in ('state', 'mensagem'):
                dic_funcoes.get(funcao)['campos'][campo]['value'] = vals.get(campo)

        state = '2'
        if funcao == 4 and not any([vals.get('categoria_id'), vals.get('ncm_id')]):
            state = '1'

        vals.update({'state': state, 'dados': str(dic_funcoes)})

        return super(websig_executor_tela_osv, self).create(cr, uid, vals, context=context)

    def read(self, cr, uid, ids, field=None, context=None, load='_classic_read'):
        context = context and context.copy() or {}
        executor_osv_dados = self.pool.get('websig.executor.osv').read(
            cr, uid, context.get('active_id'), ['websig_exec_funcao'], context=context)
        try:
            funcao = int(executor_osv_dados.get('websig_exec_funcao'))
        except:
            funcao = executor_osv_dados.get('websig_exec_funcao')
        res = super(websig_executor_tela_osv, self).read(cr, uid, ids[0], field, context=context, load=load)
        campos = dic_funcoes.get(funcao).get('campos') or {}

        for key in campos.keys():
            res[key] = campos.get(key).get('value', False)

        return [res]

    def websig_exec_botao_processar(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        executor_osv_dados = self.pool.get('websig.executor.osv').read(
            cr, uid, context.get('active_id'), ['websig_exec_funcao'], context=context)
        try:
            funcao = int(executor_osv_dados.get('websig_exec_funcao'))
            eval('self.websig_exec_' + str(funcao).zfill(4) + ' (cr, uid, ids, context)')
        except:
            funcao = executor_osv_dados.get('websig_exec_funcao')
            eval('self.websig_exec_' + funcao + ' (cr, uid, ids, context)')

        return ids

    def default_get(self, cr, uid, field, context=None):
        context = context and context.copy() or {}
        res = super(websig_executor_tela_osv, self).default_get(cr, uid, field, context=context)
        executor_osv_dados = self.pool.get('websig.executor.osv').read(
            cr, uid, context.get('active_id'), ['websig_exec_funcao'], context=context)
        try:
            funcao = int(executor_osv_dados.get('websig_exec_funcao'))
        except:
            funcao = executor_osv_dados.get('websig_exec_funcao')
        campos = dic_funcoes.get(funcao).get('campos') or []

        for campo in campos:
            if campos.get(campo).get('default'):
                res[campo] = campos.get(campo).get('default')

        return res

    def fields_view_get(self, cr, user, view_id=None, view_type='form', context=None, toolbar=False,
                        submenu=False):
        context = context and context.copy() or {}
        res = super(websig_executor_tela_osv, self).fields_view_get(
            cr, user, view_id, view_type, context, toolbar, submenu)

        executor_osv_dados = self.pool.get('websig.executor.osv').read(
            cr, user, context.get('active_id'), ['websig_exec_funcao'], context=context)
        try:
            funcao = int(executor_osv_dados.get('websig_exec_funcao'))
        except:
            funcao = executor_osv_dados.get('websig_exec_funcao')

        res['arch'] = """
            <form string="" version="7.0">
                <group col="4">
                    <h1 colspan="4">
                        <center><label string="%s"/></center>
                    </h1>
                    <separator string=""/>
                    <header colspan="4">
                       <button name="websig_exec_botao_processar"
                                modifiers="{&quot;invisible&quot;: [[&quot;state&quot;, &quot;!=&quot;, &quot;1&quot;]]}"
                                string="Processar" type="object"
                                icon="gtk-execute" help='Processa a funcao'/>
                       <field name="state" widget="statusbar"/>
                    </header>
                    <separator string=""/>
                    <label string="%s" colspan="4"/>
                    <separator string=""/>
                    <newline/>
            """ % (dic_funcoes[funcao].get('name'), dic_funcoes[funcao].get('obs'))

        # Identifica a ordem de exibição dos campos
        _campos = list()
        if dic_funcoes.get(funcao).get('campos'):
            _campos = sorted(dic_funcoes.get(funcao).get('campos').copy(),
                             key=lambda k: dic_funcoes.get(funcao).get('campos').get(k).get('seq'))

        for campo in _campos:
            # prepara campos - chave "fields"
            res['fields'][campo] = {
                'string': dic_funcoes.get(funcao).get('campos').get(campo).get('label'),
                'type': dic_funcoes.get(funcao).get('campos').get(campo).get('tipo')
            }

            # Tipo do campo
            tipo = dic_funcoes.get(funcao).get('campos').get(campo).get('tipo')

            if tipo == 'selection':
                res['fields'][campo]['selection'] = \
                    dic_funcoes.get(funcao).get('campos').get(campo).get('lista')

            if tipo == 'many2many':
                res['fields'][campo]['relation'] = \
                    dic_funcoes.get(funcao).get('campos').get(campo).get('relation')
                res['fields'][campo]['m2m_join_columns'] = \
                    ['id', 'f' + str(funcao).zfill(4) + '_id']
                res['fields'][campo]['m2m_join_table'] = 'websig_m2m_f' + str(funcao).zfill(4)

            if tipo == 'many2one':
                res['fields'][campo]['relation'] = \
                    dic_funcoes.get(funcao).get('campos').get(campo).get('relation')

            if tipo == 'char':
                res['fields'][campo]['size'] = \
                    dic_funcoes.get(funcao).get('campos').get(campo).get('size', 64)

            if dic_funcoes.get(funcao).get('campos').get(campo).get('help'):
                res['fields'][campo]['help'] = \
                    dic_funcoes.get(funcao).get('campos').get(campo).get('help')

            # Prepara linha - Chave "arch"
            linha = '        <field name="%s"' % campo

            # Atributo do campo
            attrs = dic_funcoes.get(funcao).get('campos').get(campo).get('attrs')

            if attrs:
                linha += ' modifiers="{'

                for atributo in attrs if isinstance(attrs, (list, tuple)) else [attrs]:
                    if atributo == 'required':
                        linha += "&quot;required&quot;: true"

                    if atributo and atributo[:8] == 'readonly':
                        _at = atributo.split(',')
                        linha += "&quot;readonly&quot;: "
                        linha += "[[&quot;%s&quot;, &quot;%s&quot;, &quot;%s&quot;]]"
                        linha %= (_at[1], _at[2], _at[3])

                linha += '}"'

            widget = dic_funcoes.get(funcao).get('campos').get(campo).get('widget', False)

            if widget:
                linha += ' widget="%s"' % widget

            # Concatenacao de colunas
            colspan = dic_funcoes.get(funcao).get('campos').get(campo).get('colspan')

            if colspan:
                linha += ' colspan="%s"' % colspan

            linha += """/>
            """

            res['arch'] += linha

        res['arch'] += """
                <newline/>
                <separator string="Mensagens de erro" colspan="4"/>
                <field name="mensagem" colspan="4" nolabel="1"
                modifiers="{&quot;readonly&quot;:true}"/>
                </group>
            </form>
        """

        return res

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
