#!/usr/bin/python
# -*- encoding: utf-8 -*-

from openerp.osv import osv, fields
from ..orm import websig_run_sql


class websig_sql_sentencas(osv.Model):

    _name = 'websig.sql.sentencas'
    _rec_name = 'websig_sql_name'
    _columns = {
        'websig_sql_name': fields.char('Nome', size=100, required=True),
        'websig_sql_obs': fields.text('Informacoes Complementares'),
        'websig_sql_momento': fields.selection([('A', 'Antes'), ('D', 'Depois')], 'Momento', required=True,
                                           help='Momento da execucao da sentenca, Antes ou Depois de atualizar a base'),
        'websig_sql_tabela': fields.char('Tabela', size=64),
        'websig_sql_sentenca': fields.text('Sentenca SQL', required=True),
        'websig_sql_executado': fields.selection([('S', 'Sim'), ('N', 'Nao'), ('E', 'Com erro')], 'Sentenca Executada',
                                char=1, required=True),
        'websig_sql_resultado': fields.text('Resultado da Execucao'),
        'websig_sql_export_xml': fields.text('XML para Arquivo de Data'),
    }
    _defaults = {
        'websig_sql_momento': 'A',
        'websig_sql_executado': 'N',
    }

    def websig_sql_onchange_momento(self, cr, uid, ids, websig_sql_momento, context=None):
        context = context and context.copy() or {}
        res = {}
        if websig_sql_momento == 'A':
            res.update({'websig_sql_tabela': ''})
        return {'value': res}

    def websig_sql_exec_xml(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        obj_websig_sql = self.pool.get('websig.sql.sentencas')
        for id in ids:
            brw_websig_sql_sentencas = self.browse(cr, uid, id, context)
            _data = brw_websig_sql_sentencas.websig_sql_sentenca
            res = websig_run_sql(self, cr, uid, obj_websig_sql, [(id, _data)])
        return res

    def websig_sql_show_xml(self, cr, uid, ids, context=None):
        context = context and context.copy() or {}
        from xml.etree.ElementTree import Element, SubElement, tostring
        from xml.dom.minidom import parseString

        fields_to_read = [
            'websig_sql_name', 'websig_sql_obs', 'websig_sql_momento', 'websig_sql_tabela', 'websig_sql_sentenca',
            'websig_sql_executado',
        ]
        websig_sql_dados = self.read(cr, uid, ids, fields_to_read, context=context)
        if websig_sql_dados and isinstance(websig_sql_dados, list):
            websig_sql_dados = websig_sql_dados[0]
        if isinstance(websig_sql_dados, dict):

            record = Element('record', attrib={'model': 'websig.sql.sentencas', 'id': 'XXX'})

            for i in fields_to_read:
                field = i
                value = websig_sql_dados.get(i)

                if value:
                    filed_name = SubElement(record, 'field', attrib={'name': field})
                    if isinstance(value, bool):
                        filed_name.attrib.update({'eval': str(value)})
                    else:
                        filed_name.text = value

            txt = tostring(record)
            xml = parseString(txt).toprettyxml()
            self.write(cr, uid, ids, {'websig_sql_export_xml': xml}, context)

        return True
