# -*- coding: utf-8 -*-
##############################################################################
#
#    Author: Guewen Baconnier
#    Copyright 2012 Camptocamp SA
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from reportlab.lib.validators import isInstanceOf

from openerp.osv.orm import BaseModel
from openerp.tools.translate import _
from openerp import osv
from SigUtils import sigerp as sigerp
original_search = getattr(BaseModel, 'search')
original_name_search = getattr(BaseModel, 'name_search')
original_create = getattr(BaseModel, 'create')
original_write = getattr(BaseModel, 'write')
original_auto_init = getattr(BaseModel, '_auto_init')
original_copy = getattr(BaseModel, 'copy')


def get_string_delimited(string, delimited_inicio, delimited_fim=None):
    if not delimited_fim:
        delimited_fim = delimited_inicio

    pos_i = string.find(delimited_inicio)

    if pos_i == -1:
        return False

    pos_f = string[pos_i+1:].find(delimited_fim)

    if pos_f == -1:
        return False

    return string[pos_i+1:pos_i+1+pos_f]


def _exec_funcoes(self, cr, uid, funcao, funcao_nome):
    exec funcao

    return eval(funcao_nome)


def websig_run_sql(self, cr, uid, obj_websig_sql, data, context=None):
    context = context and context.copy() or {}
    res = False

    for run_sql in data:
        _id, _sql = run_sql
        values = dict(websig_sql_resultado='Ok', websig_sql_executado='S')

        try:
            cr.execute('SAVEPOINT websig_run_sql')

            if _sql.startswith('write'):
                _tabela = get_string_delimited(_sql, '(', ')')
                ids = self.pool.get(_tabela).search(cr, uid, [], context=context)

                if ids:
                    self.pool.get(_tabela).write(cr, uid, ids, {}, context)
            elif _sql.startswith('metodo:'):
                str_xml = _sql.split(':')[1]
                dados = str_xml.split(';')
                obj = dados[0]
                metodo = dados[1]
                parametros = dados[2]
                str_funct = "self.pool.get('%s').%s%s" % (obj, metodo, parametros)
                eval(str_funct)
            elif _sql.startswith('execute:'):
                try:
                    _comando = _sql[8:].strip()
                    _funcao = get_string_delimited(_sql, ' ', ':').strip()
                    res = _exec_funcoes(self, cr, uid, _comando, _funcao)
                except Exception as e:
                    values['websig_sql_executado'] = 'E'
                    values['websig_sql_resultado'] = e.message
                    raise
                else:
                    values['websig_sql_executado'] = res and 'S' or 'E'
                    values['websig_sql_resultado'] = str(res)
            else:
                try:
                    cr.execute(_sql.encode('utf-8'), log_exceptions=False)
                except Exception as e:
                    values = dict(websig_sql_resultado=e.message, websig_sql_executado='E')
                    raise
                else:
                    values = dict(websig_sql_resultado=cr.statusmessage, websig_sql_executado='S')
        except Exception as e:
            cr.execute('ROLLBACK TO SAVEPOINT websig_run_sql')
        else:
            res = True
        finally:
            obj_websig_sql.write(cr, uid, _id, values, context=context)
            cr.execute('RELEASE SAVEPOINT websig_run_sql')
    return res


def _auto_init(self, cr, context=None):
    context = context and context.copy() or {}

    def websig_get_websig_sql_data(cr, uid, object, ids, context=None):
        context = context and context.copy() or {}

        if object and ids:
            adm_sql_dados = object.read(cr, uid, ids, ['websig_sql_sentenca'], context=context)
            dados_id_sql = map(lambda i: (i['id'], i.get('websig_sql_sentenca')), adm_sql_dados)
            return dados_id_sql
        else:
            return False

    TABELA = 'websig.sql.sentencas'

    res = original_auto_init(self, cr, context)
    table_name = self._name
    uid = 1

    if table_name != TABELA:
        cr.execute("""
            select relname from pg_class where relname = 'websig_sql_sentencas'
        """)

        tabela_websig_criada = cr.fetchall()

        if tabela_websig_criada:
            table_name = table_name.replace('.', '_')
            obj_websig_sql = self.pool.get('websig.sql.sentencas')
            args_all = [('websig_sql_executado', '=', 'N'), ('websig_sql_momento', '=', 'A')]
            args_for_table = [('websig_sql_executado', '=', 'N'), ('websig_sql_momento', '=', 'D'),
                              ('websig_sql_tabela', '=', table_name)]

            if obj_websig_sql:
                sql_for_all_ids = obj_websig_sql.search(cr, uid, args_all, context=context)
                sql_for_table_ids = obj_websig_sql.search(cr, uid, args_for_table, context=context)
                sql_all = websig_get_websig_sql_data(
                    cr, uid, obj_websig_sql, sql_for_all_ids, context)
                sql_table = websig_get_websig_sql_data(
                    cr, uid, obj_websig_sql, sql_for_table_ids, context)

                if sql_all:
                    websig_run_sql(self, cr, uid, obj_websig_sql, sql_all, context)

                if sql_table:
                    websig_run_sql(self, cr, uid, obj_websig_sql, sql_table, context)

    return res

BaseModel._auto_init = _auto_init

def search(self, cr, user, args, offset=0, limit=None, order=None, context=None, count=False):
    args, offset, limit, order, context, count = sigerp.search(
        self, cr, user, args, offset=offset, limit=limit, order=order, context=context, count=count)
    if self._name == 'gerencial.movimento':
        new_args = []
        new_company_id = False
        for x in args:
            if x[0] == 'tesouraria_movimento_id':
                valor = x[2]
                if isinstance(valor, list):
                    valor =  '(%s)' % ','.join(map(lambda x: '%s' % x, valor))
                elif not valor:
                    valor = 'null'

                _sql = """select tc.company_id 
                          from financeiro_tesouraria_movimento tm
                    	  left join financeiro_tesouraria_contas tc on tc.id = tm.conta_id
                    	  where tm.id {op} {valor} """.format(op=x[1],
                                                              valor=valor)
                cr.execute(_sql)
                dados = cr.dictfetchone() or {}
                new_company_id = dados.get('company_id')
                new_args.append(x)
            elif x[0] == 'company_id' and new_company_id:
                if x[1] == 'in':
                    new_args.append(('company_id', 'in', x[2]+[new_company_id]))
                else:
                    new_args.append(('company_id', x[1], new_company_id))
            else:
                new_args.append(x)
        if new_args:
            args = new_args
    record_ids = original_search(
        self, cr, user, args, offset=offset, limit=limit, order=order, context=context, count=count)

    return record_ids

BaseModel.search = search


def name_search(self, cr, user, name='', args=None, operator='ilike', context=None, limit=100):
    name, args, operator, context, limit = sigerp.name_search(self, cr, user, name=name,
                                       args=args, operator=operator, context=context, limit=limit)
    record_ids = original_name_search(self, cr, user, name=name, args=args, operator=operator,
                                      context=context, limit=limit)

    return record_ids

BaseModel.name_search = name_search

def write(self, cr, uid, ids, vals, context=None):
    vals = sigerp.write(self, cr, uid, ids, vals, context=context)
    if self._name == 'financeiro.tesouraria.movimento':
        if vals.get('conta_id'): # esta trocando a conta, trocar a company_id do movimento para a da conta
            dados_conta = self.pool.get('financeiro.tesouraria.contas').read(cr, uid, vals.get('conta_id'),
                                                                             ['company_id', 'gerencial_movimento_ids'],
                                                                             context=context,
                                                                             load='_classic_write')
            vals['company_id'] = dados_conta.get('company_id')
            if dados_conta.get('gerencial_movimento_ids'):
                vals_ger = {'company_id': dados_conta.get('company_id')}
                self.pool.get('gerencial.movimento').write(cr, uid, dados_conta.get('gerencial_movimento_ids'),
                                                           vals_ger, context ={'sig_force_company': True})
    # company de gerencial.movimento deve acompanha a company do movimento da tesouraria(da conta)
    if self._name == 'gerencial.movimento' and vals.get('tesouraria_movimento_id'):
        _sql = """select tc.company_id from financeiro_tesouraria_movimento tm
    	                 left join financeiro_tesouraria_contas tc on tc.id = tm.conta_id
    	                 where tm.id = %s """ % vals.get('tesouraria_movimento_id')
        cr.execute(_sql)
        dados = cr.dictfetchone()
        vals['company_id'] = dados.get('company_id')
    res = original_write(self, cr, uid, ids, vals, context=context)

    return res

BaseModel.write = write


def copy(self, cr, uid, id, default=None, context=None):
    context = context and context.copy() or {}
    context['__copy_translations_seen'] = {self._name: [id]}
    return original_copy(self, cr, uid, id, default, context)


BaseModel.copy = copy


def create(self, cr, uid, vals, context=None):
    vals = sigerp.create(self, cr, uid, vals, context=context)
    # company de gerencial.movimento deve acompanha a company do movimento da tesouraria(da conta)
    if self._name == 'gerencial.movimento' and vals.get('tesouraria_movimento_id'):
        _sql = """select tc.company_id from financeiro_tesouraria_movimento tm
	                 left join financeiro_tesouraria_contas tc on tc.id = tm.conta_id
	                 where tm.id = %s """ % vals.get('tesouraria_movimento_id')
        cr.execute(_sql)
        dados = cr.dictfetchone()
        vals['company_id'] = dados.get('company_id')
    record_id = original_create(self, cr, uid, vals, context=context)
    return record_id

BaseModel.create = create

"""
@api.model
@api.returns('self')
def search(self, args, offset=0, limit=None, order=None, count=False):
    # Quando houver no contexto "sig_force_company", não será feito nenhum tratamento no args
    # liberar apartir da versao 4A
    # if not context.get('install_mode'):
    #     if not (self._name.startswith('ir.') or
    #             self._name.startswith('res.') or
    #             self._name.startswith('base.') or
    #             self._name.startswith('adm.monitor.')):
    #         if not _get_licensa_sig_erp(self, cr, user):
    #             limit = 5
    if not self.with_context.get('sig_force_company'):
        if 'parametro' in self._name and not self._name == 'financeiro.parametros.cobranca':
            if not self._columns.has_key('company_id'):
                return args, offset, limit, order, self.with_context, count

            if 'all' in args:
                args = []
            else:
                # tem que passar o company_id caso o cron esteja executando a importacao de cupom,
                # no caso de multi-empresa para nao pegar o parametro de outra empresa.
                arg_company = filter(lambda x: x[0] == 'company_ids', args)
                user_company_id = arg_company and arg_company[0][2] or False
                company_id = self.pool.get('adm.empresa.objeto').getEmpresa(self.cr, self.uid, self._name,
                                                                            context=self.with_context,
                                                                            user_company_id=user_company_id)
                args = [('company_id', '=', company_id)]
        else:
            tabelas = ['adm.empresa.objeto', 'legado.empresa', 'ir.values', 'res.company', 'res.users', 'ir.sequence']
            if not self._name in tabelas and self._columns.has_key('company_id'):
                company_id = False
                args_temp = filter(lambda i: 'company_id' not in i, args)
                obj_adm_empresa = self.pool.get('adm.empresa.objeto')
                if obj_adm_empresa:
                    company_id = obj_adm_empresa.getEmpresa(self.cr, self.uid, self._name)
                if company_id:
                    # Qdo no contexto tiver "sig_search_sem_filhos", não será feito tratamento para empresas filhas
                    if not self.with_context.get('sig_search_sem_filhos'):
                        company_ids = self.pool.get('res.company')._get_company_children(self.cr, self.uid, company_id)
                        if company_ids:
                            company_ids.append(company_id)
                            args_temp.append(('company_id', 'in', company_ids))
                        else:
                            args_temp.append(('company_id', '=', company_id))

                    else:
                        args_temp.append(('company_id', '=', company_id))
                    args = args_temp
        #
    record_ids = original_search(
            self, self.cr, self.uid, args, offset=offset, limit=limit, order=order, context=self.with_context, count=count)

    return record_ids

BaseModel.search = search

@api.multi
@api.returns('self')
def write(self, cr, uid, ids, vals, context=None):
    vals = sigerp.write(self, cr, uid, ids, vals, context=context)
    res = original_write(self, cr, uid, ids, vals, context=context)

    return res

BaseModel.write = write

@api.model
@api.returns('self')
def create(self, vals):
    # Sig
    #print 'orm.create achei!'
    if isinstance(vals, dict):
        if vals.has_key('create_date'):
            vals.pop('create_date')
        if vals.has_key('create_uid'):
            vals.pop('create_uid')
    tabelas = ['adm.empresa.objeto', 'legado.empresa', 'ir.values','res.company', 'res.users', 'ir.sequence']
    try:
        if not self.with_context('sig_force_company', False):
            if (not (self._name in tabelas)) and self._columns.has_key('company_id'):
                if 'company_id' in vals:
                    vals['company_id'] = self.pool.get('adm.empresa.objeto').getEmpresa(cr, uid, self._name)
    except:
        pass
    #
    return vals
    record_id = original_create(self, cr, uid, vals, context=context)

    return record_id

BaseModel.create = create

"""