openerp.web_sig = function (instance) {
    var _t = instance.web._t;
    instance.web.Sidebar.include({
        init : function(parent, action){
            this._super.apply(this, arguments);
//            this.sections.splice(1, 0, { 'name' : 'sigprint', 'label' : _t('Menu SiG') });
            this.items['print'] = [{
                label: _t("Pesquisa"),
                title: _t("Imprimi a pesquisa atual"),
                callback: parent.on_sidebar_export
            }];
        }
    });

    instance.web.form.FieldMany2One = instance.web.form.FieldMany2One.extend({

        show_error_displayer: function () {
            if (this.last_query != "") {
                this._search_create_popup("form", undefined, this._create_context(this.last_query));
            }
            this.no_ed = false;
        },
        get_search_result: function(search_val) {
            var self = this;

            var dataset = new instance.web.DataSet(this, this.field.relation, self.build_context());
            var blacklist = this.get_search_blacklist();
            this.last_query = search_val;

            return this.orderer.add(dataset.name_search(
                    search_val, new instance.web.CompoundDomain(self.build_domain(), [["id", "not in", blacklist]]),
                    'ilike', this.limit + 1, self.build_context())).then(function(data) {
                self.last_search = data;
                // possible selections for the m2o
                var values = _.map(data, function(x) {
                    x[1] = x[1].split("\n")[0];
                    return {
                        label: _.str.escapeHTML(x[1]),
                        value: x[1],
                        name: x[1],
                        id: x[0],
                    };
                });

                // search more... if more results that max
                if (values.length > self.limit) {
                    values = values.slice(0, self.limit);
                    values.push({
                        label: _t("Search More..."),
                        action: function() {
                            dataset.name_search(search_val, self.build_domain(), 'ilike', 160).done(function(data) {
                                self._search_create_popup("search", data);
                            });
                        },
                        classname: 'oe_m2o_dropdown_option'
                    });
                }

                values.push({
                    label: _t("Create and Edit..."),
                    action: function() {
                        self._search_create_popup("form", undefined, self._create_context(search_val));
                    },
                    classname: 'oe_m2o_dropdown_option'
                });

                return values;
            });
        }
    });

    instance.web_sig.YearMonthDatePicker = instance.web.DateWidget.extend({
        picker: function() {
            var self = this;
            if (typeof(options = arguments[0]) === 'object') {
                options.dateFormat = 'M/yy';
                options.onChangeMonthYear = function(year, month, inst) {
                    strDate = $(this).datepicker('option', 'monthNamesShort')[month-1] + '/' + year;
                    self.$input.val(strDate);
                    self.$input_picker.val(strDate);
                };
                options.onClose = function(text, inst) {
                    var iMonth = $('#ui-datepicker-div .ui-datepicker-month :selected').val();
                    var iYear = $('#ui-datepicker-div .ui-datepicker-year :selected').val();
                    strDate = $(this).datepicker('option', 'monthNamesShort')[iMonth] + '/' + iYear;
                    self.set({'value': new Date(iYear, iMonth, 1).toISOString().substring(0,10)});
                    self.change_datetime();
                    setTimeout(function(){
                        $('html > head style[data-temporary]').remove();
                    },200);
                };
                options.beforeShow = function(input, inst) {
                    $('html > head').append('<style data-temporary="true"> .ui-datepicker-calendar { display:none; } </style>');
                    if ((selDate = $(this).val()).length > 0) {
                        var iYear = selDate.substring(selDate.length - 4, selDate.length);
                        var iMonth = jQuery.inArray(selDate.substring(0, selDate.length - 5), $(this).datepicker('option', 'monthNamesShort'));
                        $(this).datepicker('option', 'defaultDate', new Date(iYear, iMonth, 1));
                        $(this).datepicker('setDate', new Date(iYear, iMonth, 1));
                    }
                };
                options.showButtonPanel = false;
                options.yearRange = '1900:' + new Date().getFullYear();
            }
            return $.fn[this.jqueryui_object].apply(this.$input_picker, arguments);
        },
        on_picker_select: function(text, instance_) {
            var date = this.picker('getDate');
            var strDate = '';
            if (date) {
                strDate = Date.CultureInfo.abbreviatedMonthNames[date.getMonth()] + '/' + date.getFullYear();
            }
            this.$input.val(strDate).change().focus();
        },
        is_valid_: function() {
            var value_ = this.get('value');
            if (value_ === "") {
                return true;
            } else {
                try {
                    this.parse_client(value_);
                    return true;
                } catch(e) {
                    return false;
                }
            }
        },
        parse_client: function(v) {
            if((/\w{3}\/\d{4}/i).test(v)) {
                var year = v.substring(v.length-4, v.length);
                var month = jQuery.inArray(v.substring(0, v.length - 5), this.picker('option', 'monthNamesShort'));
                return new Date(year, month, 1).toISOString().substring(0, 10);
            }
            else if((/\d{2}\/\d{4}/i).test(v)){
                var year = v.substring(v.length - 4, v.length);
                var month  = v.substring(0, v.length -5);
                return new Date(year, month - 1, 1).toISOString().substring(0, 10);
            }
            else
                return instance.web.parse_value(v, {"widget": this.type_of_date});

        }
    });

    instance.web_sig.FieldYearMonth = instance.web.form.FieldDate.extend({
        build_widget: function() {
            return new instance.web_sig.YearMonthDatePicker(this);
        }
    });

    instance.web.form.widgets.add('yearMonth', 'instance.web_sig.FieldYearMonth');
}
