# -*- encoding: utf-8 -*-
from openerp.tools import config
import openerp.addons.web.http as http
from SigUtils import numero
from openerp import pooler
import openerp
import threading
from ...adm.control.utils import admConfiguracao
from datetime import datetime
from openerp.tools.translate import _
import uuid
import logging

logger = logging.getLogger('WebMob')


class webmobTransacao(object):
    def __init__(self, cr, controle=None):
        if controle:
            self.controle = controle
        else:
            self.controle = uuid.uuid4()
        sql_begin = """BEGIN; SAVEPOINT "%s";""" % self.controle
        cr.execute(sql_begin)
        self.cr = cr

    def finalizar(self, operacao='c'):
        """ operacao = 'c' confirmar ou 'r' Recusar """
        if operacao == 'd':
            sql = """ROLLBACK TO SAVEPOINT "%s";""" % self.controle
            self.cr.execute(sql)
            sql = """RELEASE SAVEPOINT "%s";""" % self.controle
            self.cr.execute(sql)
            return True
        elif operacao == 'c':
            sql = """RELEASE SAVEPOINT "%s";
                     COMMIT;""" % self.controle
            self.cr.execute(sql)
            return True
        return False


class WebMobSc(http.Controller):
    _cp_path = '/wmob'
    oeMensagem = ''
    sid = False
    req = False
    kw = {}

    def _webmob_get_session(self, variavel):
        arq = 'wmob_%s' % self.sid
        cfg = admConfiguracao(arq, self.sid, cripto=False, diretorio='/tmp')
        try:
            dado = eval('cfg.%s' % variavel)
        except:
            dado = ''
        # dado = dado.decode('utf-8')
        return dado

    def _webmob_set_session(self, variavel, dado):
        arq = 'wmob_%s' % self.sid
        cfg = admConfiguracao(arq, self.sid, cripto=False, diretorio='/tmp')
        if isinstance(dado, (int, float)):
            dado = unicode(dado)
        # dado = dado.encode('utf-8')
        cfg.addParametro(variavel, dado)
        cfg.addParametro('dataHora', datetime.now().strftime('%Y-%m-%d %H:%M'))
        cfg.gravarConfiguracao()
        return True

    def _get_environ(self, req, **kw):
        self.oeMensagem = ""
        self.req = req
        self.kw = kw
        self.sid = req.httpsession.sid
        self.db = self._webmob_get_session('db') or False
        self.uid = int(self._webmob_get_session('uid') or '0')
        self.tz = self._webmob_get_session('tz')
        if self.db and self.uid:
            self.cr = self._get_cr(self.db)
        else:
            self.cr = False
            return self.logar(self.req, None, **self.kw)
        self.context = {'webmob': True, 'tz': self.tz}
        self.pgp = pooler.get_pool(self.db).get
        return True

    def _get_cr(self, database):
        db = openerp.sql_db.db_connect(database)
        threading.current_thread().dbname = database
        return db.cursor()


    def _wmob_get_arq_html(self, modulo, arquivo):
        _path = '%s/%s/static/src/html/%s.html' % (config.get('addons_path'), modulo, arquivo)
        arq = open(_path, 'rb')
        linhas = ''.join([x.decode('utf-8') for x in arq.readlines()]).replace('\n', '')
        arq.close()
        return linhas

    @staticmethod
    def _wmob_montar_botoes(lista):
        """
        Monta os botoes no rodape do form base
        lista é uma de lista de tres elementos: ((nome_do_botao, label, img),)
        O nome do botão deve ser composto do método a ser chamado e da ação. são separados por '|'
        ex.: wmob_sep|proximo
        """
        _btns = ''
        for item in lista:
            item_nome = item[0]
            item_corpo = item[1] or item[2]
            _btn = ('<td><span">' 
                    '<button type="submit" name="botao" value="%s"/>%s' 
                    '</span></td>') % (item_nome, item_corpo)
            _btns = '%s%s' % (_btns, _btn)
        return _btns

    def _wmob_montar_menu(self):
        _html = '<li><a href="%s">%s</a></li>'
        _menu = ''
        try:
            _menu_ids = pooler.get_pool(self.db).get('webmob.menu').search(self.cr, 1, [], context=self.context)
        except Exception as Err:
            logger.error('Erro ao montar o menu! Erro: %s' % Err)
            return _menu
        for menuBrw in pooler.get_pool(self.db).get('webmob.menu').browse(self.cr, 1, _menu_ids, context=self.context):
            _perm_ids = self._webmob_get_session('upermissoes')
            for permissoesBrw in pooler.get_pool(self.db).get('webmob.permissoes').browse(self.cr, 1, eval(_perm_ids), context=self.context):
                if not permissoesBrw.wmobper_permissao:
                    continue
                if permissoesBrw.wmobper_menu_id.id != menuBrw.id:
                    continue
                _menu += _html % (menuBrw.wmobmnu_url, menuBrw.name+'&nbsp;&nbsp;&nbsp;')
        return _menu

    def _wmob_montar_home(self):
        _menus = self._wmob_montar_menu()
        if not _menus:
            return self.logar(self.req, None, **self.kw)
        empresa = '%s-%s' % (numero.getNumToStr(self._webmob_get_session('company_id'), 3, 0, 'N'),
                             self._webmob_get_session('company_name')[:15])
        lista = self._webmob_get_session('uname').split()
        if len(lista) == 1:
            nomeUsuario = lista[0]
        else:
            nomeUsuario = '%s %s' % (lista[0], lista[1])
        dados_novo = self._wmob_get_arq_html('webmob', 'base')\
            .replace('var_empresa', empresa)\
            .replace('var_usuario', nomeUsuario)\
            .replace('var_mensagem', self.oeMensagem)\
            .replace('var_menu', _menus)
        return dados_novo

    def _wmob_montar_base(self):
        dados_novo = self._wmob_montar_home()\
            .replace('\n', '')\
            .replace('   ', '')
        return dados_novo

    @http.httprequest
    def index(self, req, s_action=None, **kw):
        return self.logar(req, s_action, **kw)

    @http.httprequest
    def logar(self, req, s_action=None, **kw):
        self.sid = req.httpsession.sid
        host = req.httprequest.environ.get('HTTP_HOST')
        self._webmob_set_session('host', host)
        self.req = req
        self.kw = kw
        db = self._webmob_get_session('db')
        _db = ''
        if req.params.get('db'):
            _db = req.params.get('db')
        else:
            h = host.split('.')
            if len(h) > 1:
                try:
                    _db = int(h[0])
                    _db = ''
                except:
                    _db = h[0]
        if _db:
            db = _db

        self._webmob_set_session('db', db)
        dados_novo = self._wmob_get_arq_html('webmob', 'login').replace('db_db_db', db)
        return dados_novo

    @http.httprequest
    def login(self, req, s_action=None, **kw):
        self.context = {'webmob': True}
        self.sid = req.httpsession.sid
        self.req = req
        self.kw = kw
        _email = req.params.get('login').strip()
        _password = req.params.get('password').strip()
        self.db = self._webmob_get_session('db') or req.params.get('db')
        if not self.db:
            return self.logar(self.req, None, **self.kw)
        self.cr = self._get_cr(self.db)
        args = [('login', '=', _email), ('password', '=', _password)]
        self.uid = pooler.get_pool(self.db).get('res.users').search(self.cr, 1, args, context=self.context)
        if not self.uid:
            self.cr.close()
            return self.logar(req, s_action, **kw)
        if isinstance(self.uid, (list, tuple)):
            self.uid = self.uid[0]
        self._webmob_set_session('uid', unicode(self.uid))
        usersBrw = pooler.get_pool(self.db).get('res.users').browse(self.cr, 1, self.uid, context=self.context)
        self._webmob_set_session('uname', usersBrw.partner_id.name)
        self._webmob_set_session("upessoa_id", usersBrw.pessoa_id.id)
        self._webmob_set_session('tz', usersBrw.partner_id.tz)
        self._webmob_set_session("company_id", usersBrw.company_id.id)
        self._webmob_set_session("company_name", usersBrw.company_id.rescon_pessoa_id.nome)
        _perm_ids = [x.id for x in usersBrw.webmob_permissao_ids]
        self._webmob_set_session("upermissoes", str(_perm_ids))
        self.cr.close()
        return self.menu(req, s_action=None, **kw)

    @http.httprequest
    def menu(self, req, s_action=None, **kw):
        self._get_environ(req, **kw)
        if not self.uid:
            if self.cr:
                self.cr.close()
            return self.logar(req, s_action, **kw)
        if req.params.get('botao'):
            lista = req.params.get('botao').split('|')
            ret = eval('self.'+lista[0])(req)
            # self.cr.close()
            return ret
        resp = self._wmob_montar_base().replace('var_titulo', _('Menu'))\
            .replace('var_corpo', '')\
            .replace('var_botoes', '')\
            .replace('var_refresh', '')
        self.cr.close()
        return resp

