# -*- encoding: utf-8 -*-
import openerp.addons.web.http as http
from SigUtils import datas, numero
from ...webmob.controllers import main
from datetime import datetime
from openerp.tools.translate import _
import logging
logger = logging.getLogger('WebMob')
from openerp import SUPERUSER_ID


class WebMobScPedVda(main.WebMobSc):

    def _pedvda_get_ped(self, pagTam=10, pagIni=0):
        lista = []
        try:
            upessoa_id = int(self._webmob_get_session('upessoa_id'))
            pedObj = self.pgp('estoquepedidos.pedido.capa')
            args = [('pessoa_id', '=', upessoa_id), ('tipo', '=', 'V')]
            regQtd = pedObj.search(self.cr, self.uid, args, count=True, context=self.context)
            self._webmob_set_session('regqtd', unicode(regQtd))
            regAtu = (pagIni / pagTam) + 1
            self._webmob_set_session('regatu', unicode(regAtu))
            ped_ids = pedObj.search(self.cr, self.uid, args, order='id desc', offset=pagIni, limit=pagTam, context=self.context)
            if not ped_ids:
                lista = [None]
            for pedBrw in pedObj.browse(self.cr, self.uid, ped_ids, context=self.context):
                lista.append({
                    'numero': pedBrw.numero_pedido,
                    'data': datas.sigDatas(pedBrw.data_emissao).getDataNoFormato('N', 'S', '/'),
                    'valor': numero.getNumeroEditado(pedBrw.valor_total, 2, ',', '.',),
                    'status': pedBrw.state,
                    'pedido_id': pedBrw.id,
                })
        except Exception as err:
            logger.error('Nao consegui pegar a lista de pedidos(_pedvda_get_ped) Erro: %s' % err)
        return lista

    def pedvda_atualizar_pedido(self, pedido_id):
        try:
            ret = self.pgp('estoquepedidos.pedido.capa').write(self.cr, self.uid, pedido_id, {}, context=self.context)
            if not ret:
                return {'status': False, 'mensagem': _('Nao consegui atualizar a capa do pedido!')}
            pedidoBrw = self.pgp('estoquepedidos.pedido.capa').browse(self.cr, SUPERUSER_ID, pedido_id, context=self.context)
            _forma_id = _condicaoForma_id = False
            if pedidoBrw.pessoa_id.cliente_ids:
                _forma_id = pedidoBrw.pessoa_id.cliente_ids[0].fincli_forma_pgto_id.id
                _condicaoForma_id = pedidoBrw.pessoa_id.cliente_ids[0].fincli_condicao_forma_id.id
            if not _forma_id:
                _forma_id = self.pgp('adm.forma.pgto').search(self.cr, self.uid,
                                                                    [('name', '=', 'Dinheiro'), ('sigla', '=', 'DN')],
                                                                             context=self.context)[0]
            if not _condicaoForma_id:
                _condicaoForma_id = self.pgp('adm.condicao.forma').search(
                                    self.cr, self.uid, [('forma_pagamento_id', '=', _forma_id)], context=self.context)[0]
        except Exception as Err:
            return {'status': False,
                    'mensagem': _('Erro: %s' % Err)}
        if pedidoBrw.pedido_condicao_ids:
           vals = {
               'valor': pedidoBrw.valor_total,
           }
           ret = self.pgp('estoquepedidos.pedido.condicao').write(self.cr, self.uid,
                                                              pedidoBrw.pedido_condicao_ids[0].id,
                                                              vals,
                                                              context=self.context)
           if not ret:
               return {'status': False, 'mensagem': _('Nao consegui atualizar as condicoes do pedido!')}
           vals = {
               'vr_parcela': pedidoBrw.valor_total,
           }
           ret = self.pgp('estoquepedidos.pedido.parcela').write(self.cr, self.uid,
                                                             pedidoBrw.pedido_parcela_ids[0].id,
                                                             vals,
                                                             context=self.context)
           if not ret:
               return {'status': False, 'mensagem': _('Nao consegui atualizar as parcelas do pedido!')}
        else:
            vals = {
                'capa_id': pedidoBrw.id,
                'condicao_forma_id': _condicaoForma_id,
                'forma_pagto_id': _forma_id,
                'valor': pedidoBrw.valor_total,
            }
            _cond_id = self.pgp('estoquepedidos.pedido.condicao').create(self.cr, self.uid, vals, context=self.context)
            if not _cond_id:
                return {'status': False, 'mensagem': _('Nao consegui criar o pedido!')}
            condicaoFormaBrw = self.pgp('adm.condicao.forma').browse(self.cr, self.uid, _condicaoForma_id, context=self.context)
            _vencimento = datas.calcVencimento(pedidoBrw.data_emissao,
                                               condicaoFormaBrw.adm_condicao_id.dias_primeira_parcela,
                                               condicaoFormaBrw.adm_condicao_id.tipo_prazo)
            _vencimento = datas.getDataNoFormato(_vencimento, 'I', '-')
            vals = {
                'data_vencimento': _vencimento,
                'pedido_compra_id': pedidoBrw.id,
                'pedido_condicao_id': _cond_id,
                'vr_parcela': pedidoBrw.valor_total,
            }
            ret = self.pgp('estoquepedidos.pedido.parcela').create(self.cr, self.uid,  vals, context=self.context)
            if not ret:
                return {'status': False, 'mensagem': _('Nao consegui criar as parcelas do pedido!')}
        return {'status': True}

    @http.httprequest
    def pedvda_alterar_item(self, req, s_action=None, **kw):
        """
        Permite alterar a quantidade do item do pedido
        Este método pode ser chamado para alterar a quantidade de um item já existente no pedido ou incluir um item novo no pedido
        Qdo houver um _ped_item_id, é alteração, do contrario é inclusao
        """
        def btnRetornar():
            kw['pedido_id'] = _pedido_id
            req.params['botao'] = ''
            self.cr.close()
            if not _pedido_id:
                return self.pedvda_lista(req, s_action=None, **kw)
            return self.pedvda_listar_itens(req, s_action=None, **kw)

        def redigitarQtd():
            req.params['botao'] = ''
            req.params['qtd_item'] = '1'
            kw['mensagem'] = _('Quantidade invalida!')
            self.cr.close()
            return self.pedvda_alterar_item(req, s_action=None, **kw)

        def getQtd():
            try:
                _qtd = int(req.params.get('qtd_item') or _itemBrw.qtde_pedida or '1')
                if _qtd > 10000:
                    return None
            except:
                return None
            return _qtd

        self._get_environ(req, **kw)
        if kw.get('mensagem'):
            self.oeMensagem = kw.get('mensagem')
            kw['mensagem'] = ''
        trans = main.webmobTransacao(self.cr)
        _botao = False
        if req.params.get('botao'):
            lista = req.params.get('botao').split('|')
            _botao = lista[1]

        _ped_item_id = kw.get('peditem_id') or req.params.get('peditem_id') or ''
        if _ped_item_id:
            _ped_item_id = int(_ped_item_id)
            _itemBrw = self.pgp('estoquepedidos.pedido.item').browse(self.cr, self.uid,
                                                                                         int(_ped_item_id),
                                                                                         context=self.context)
            _pedido_id = int(_itemBrw.pedido_id.id)
            _produtoBrw = _itemBrw.produto_id
            _gradeBrw = _itemBrw.grade_id
            _pedido_nro = _itemBrw.pedido_id.numero_pedido
            _pvenda = _itemBrw.vr_unitario
            _qtd = getQtd()
            if not _qtd:
                return redigitarQtd()

        else:
            _pedido_id = kw.get('pedido_id') or req.params.get('pedido_id') or ''
            if _pedido_id:
                try:
                    _pedido_id = int(_pedido_id)
                except:
                    pass
            _produto_id = req.params.get('produto_id')
            _grade_id = req.params.get('grade_id')
            if _produto_id:
                _produto_id = int(_produto_id)
                _produtoBrw = self.pgp('estoque.produto').browse(self.cr, self.uid, _produto_id,
                                                                                     context=self.context)
                _grade_id = int(_grade_id)
                _gradeBrw = self.pgp('estoque.produto.grade').browse(self.cr, self.uid, _grade_id,
                                                                                     context=self.context)
                _pedido_nro = self.pgp('estoquepedidos.pedido.capa').browse(self.cr, self.uid,
                                                                            _pedido_id,
                                                                            context=self.context).numero_pedido or ''
                _pvenda = self._pedvda_get_preco_produto(_produto_id, grade_ids=[_grade_id])
                _qtd = getQtd()
                if not _qtd:
                    return redigitarQtd()
        if _botao:
            if _botao == 'salvar':
                _botao = 'retornar'
                _qtd = getQtd()
                if not _qtd:
                    return redigitarQtd()
                if _ped_item_id:
                    ret = False
                    try:
                        if _qtd == 0:
                            ret = self.pgp('estoquepedidos.pedido.item').unlink(self.cr, self.uid,
                                                                                                _ped_item_id,
                                                                                                context=self.context)
                        else:
                            vals = {
                                'qtde_pedida':_qtd
                            }
                            ret = self.pgp('estoquepedidos.pedido.item').write(self.cr, SUPERUSER_ID,
                                                                                                   _ped_item_id,
                                                                                                   vals,
                                                                                                   context=self.context)
                    except Exception as Err:
                        ret = False
                        logger.error('Nao consegui atualizar os itens do pedido (pedvda_alterar_item) Erro: %s' % Err)
                    finally:
                        if not ret:
                            trans.finalizar('d')
                            kw['mensagem'] = _('Nao consegui atualizar o item!')
                            return btnRetornar()
                else:
                    if not _pedido_id:
                        _company_id = int(self._webmob_get_session('company_id'))
                        id_end = False
                        brwPessoa = self.pgp('adm.pessoa').browse(self.cr, self.uid,
                                                                  int(self._webmob_get_session('upessoa_id')),
                                                                  context=self.context)
                        if brwPessoa:
                            try:
                                id_end = brwPessoa.endereco_nf_id.id
                            except:
                                id_end = brwPessoa.endereco_ids[0].id if brwPessoa.endereco_ids else False
                        vals = {
                            'company_id': _company_id,
                            'data_emissao': datetime.now().strftime('%Y-%m-%d'),
                            'pessoa_id': self._webmob_get_session('upessoa_id'),
                            'pedcap_endereco_id': id_end,
                            'state': 'A',
                            'tipo': 'V',
                            'pedcap_origem': '2'
                        }
                        args = [('pessoa_id', '=', int(self._webmob_get_session('upessoa_id'))),
                                ('company_id', '=', _company_id)]
                        _cliente_ids = self.pgp('financeiro.cliente').search(self.cr, self.uid,
                                                                                                 args,
                                                                                                 context=self.context)
                        if _cliente_ids:
                            _rota = self.pgp('financeiro.cliente').read(self.cr, self.uid,
                                                                        _cliente_ids[0],
                                                                      ['fincli_rota'],
                                                                        context=self.context)['fincli_rota']
                            if _rota:
                                vals['pedcap_rota_entrega'] = _rota[0]
                        try:
                            _pedido_id = self.pgp('estoquepedidos.pedido.capa').create(self.cr, self.uid,
                                                                                       vals,
                                                                                       context=self.context)
                        except Exception as Err:
                            logger.error('Nao consegui criar o pedido(pedvda_alterar_item) Erro:%s' % Err)
                            _pedido_id = False
                        if not _pedido_id:
                            trans.finalizar('d')
                            kw['mensagem'] = _('Nao consegui criar o pedido!')
                            return btnRetornar()

                    if _qtd > 0:
                        dadosPar = self.pgp('adm.utils').admutl_get_parametros(self.cr,
                                                                               self.uid,
                                                                               'estoque',
                                                                               "estpar_vendex_local_id",
                                                                               company_id=self._webmob_get_session('company_id'),
                                                                               context=self.context)
                        vals = {
                            'qtde_pedida': _qtd,
                            'grade_id': _gradeBrw.id,
                            'local_id': dadosPar.get('estpar_vendex_local_id'),
                            'pedido_id': _pedido_id,
                            'vr_unitario': float(req.params.get('pvenda').replace(',','.')),
                            'produto_id': _produtoBrw.id,
                            'produto_embalagem_id': _produtoBrw.produto_embalagem_ids[0].id,
                        }
                        try:
                            ret = self.pgp('estoquepedidos.pedido.item').create(self.cr, self.uid,
                                                                                                vals,
                                                                                                context=self.context)
                        except Exception as Err:
                            logger.error('Nao consegui criar o pedido(pedvda_alterar_item) Erro: %s' % Err)
                            ret = False
                        if not ret:
                            trans.finalizar('d')
                            kw['mensagem'] = _('Nao consegui criar o pedido!')
                            return btnRetornar()

                ret = self.pedvda_atualizar_pedido(_pedido_id)
                if not ret.get('status'):
                    logger.error(_('Nao consegui atualizar o pedido(pedvda_atualizar_pedido) Erro: %s') %
                                 ret.get('mensagem'))
                    kw['mensagem'] = _('Nao consegui salvar o pedido!')
                    trans.finalizar('d')
                    return btnRetornar()

            if _botao == 'menos':
                if _qtd > 0:
                    _qtd -= 1
                req.params['botao'] = ''
            if _botao == 'mais':
                _qtd += 1
                req.params['botao'] = ''
            if _botao == 'removerItem':
                if _ped_item_id:
                    ret = self.pgp('estoquepedidos.pedido.item').unlink(self.cr, self.uid,
                                                                                            _ped_item_id,
                                                                                            context=self.context)
                    if not ret:
                        trans.finalizar('d')
                        kw['mensagem'] = _('Nao consegui remover o item do pedido!')
                        return btnRetornar()
                if _pedido_id:
                    ret = self.pedvda_atualizar_pedido(_pedido_id)
                    if not ret.get('status'):
                        logger.error(_('Nao consegui atualizar o pedido(pedvda_atualizar_pedido) Erro: %s') %
                                     ret.get('mensagem'))
                        trans.finalizar('d')
                        kw['mensagem'] = _('Nao consegui remover o item!')
                        return btnRetornar()
                if not _pedido_id and not _ped_item_id:
                    trans.finalizar('c')
                    self.cr.close()
                    return self.pedvda_lista(req, s_action=None, **kw)
                _botao = 'retornar'

            if _botao == 'retornar':
                trans.finalizar('c')
                return btnRetornar()

        corpo = self._wmob_get_arq_html('webmob_pvenda_portal', 'ped_lista_item_qtd')
        corpo = corpo.replace('var_peditem_id', unicode(_ped_item_id)) \
                     .replace('var_pedido_id', unicode(_pedido_id)) \
                     .replace('var_produto_id', unicode(_produtoBrw.id)) \
                     .replace('var_grade_id', unicode(_gradeBrw.id)) \
                     .replace('var_foto', unicode(_produtoBrw.estpro_foto)) \
                     .replace('var_nro_pedido', _pedido_nro)\
                     .replace('var_descricao', _gradeBrw.name)\
                     .replace('var_preco', numero.getNumeroEditado(_pvenda, 2))\
                     .replace('var_qtd',  numero.getNumeroEditado(unicode(_qtd),0))
        lista_btns = []
        _img_ret = '<img src="/webmob/static/src/img/button_retornar_100x100.png">'
        lista_btns.append(('pedvda_alterar_item|retornar', '', _img_ret))
        _img_ret = '<img src="/webmob/static/src/img/button_lixeira_100x100.png">'
        lista_btns.append(('pedvda_alterar_item|removerItem', '', _img_ret))
        _img_menos = '<img src="/webmob/static/src/img/button_menos_100x100.png">'
        lista_btns.append(('pedvda_alterar_item|menos', '', _img_menos))
        _img_mais = '<img src="/webmob/static/src/img/button_mais_100x100.png">'
        lista_btns.append(('pedvda_alterar_item|mais', '', _img_mais))
        _img_ok = '<img src="/webmob/static/src/img/button_ok_100x100.png">'
        lista_btns.append(('pedvda_alterar_item|salvar', '', _img_ok))
        html_btns = self._wmob_montar_botoes(lista_btns)

        resp = self._wmob_montar_base().replace('var_titulo', _('Alterar a quantidade'))\
            .replace('var_corpo', corpo)\
            .replace('var_botoes', html_btns)
        trans.finalizar()
        self.cr.close()
        return resp

    def _pedvda_get_preco_produto(self, produto_id, grade_ids=[]):
        try:
            _pessoa_id = int(self._webmob_get_session('upessoa_id'))
        except:
            _pessoa_id = self._webmob_get_session('upessoa_id')
        _cliente_ids = self.pgp('financeiro.cliente').search(self.cr, self.uid,
                                                        [('pessoa_id', '=', _pessoa_id)],
                                                         context=self.context)
        if _cliente_ids:
            _cliente_id = _cliente_ids[0]
        else:
            _cliente_id = None
        _pvendas = self.pgp('estoque.preco.venda').get_preco_venda(self.cr, SUPERUSER_ID, [produto_id],
                                                               epc_cliente_id=_cliente_id,
                                                               epc_grade_ids=grade_ids,
                                                               context=self.context)
        if _pvendas.get(produto_id).get(grade_ids[0]):
            _pvenda = _pvendas.get(produto_id).get(grade_ids[0])
        else:
            _pvenda = _pvendas.get(produto_id).get('preco_venda')
        return _pvenda

    @http.httprequest
    def pedvda_selecionar_item(self, req, s_action=None, **kw):
        """
        Monta tela para seleção de itens
        """
        self._get_environ(req, **kw)
        trans = main.webmobTransacao(self.cr)
        _botao = False
        if req.params.get('botao'):
            lista = req.params.get('botao').split('|')
            _botao = lista[1]
        _dep_ids = self.pgp('vendas.externas.departamento').search(self.cr, self.uid, [], order='name', context=self.context)
        if not _dep_ids:
            kw['mensagem'] = _('Nao ha departamentos configurados')
            req.params['botao'] = ''
            trans.finalizar()
            self.cr.close()
            return self.pedvda_lista(req, s_action=None, **kw)

        depsBrw = self.pgp('vendas.externas.departamento').browse(self.cr, self.uid, _dep_ids, context=self.context)
        dep_id = kw.get('dep_id') or req.params.get('dep_id') or _dep_ids[0]
        try:
            dep_id = int(dep_id)
        except:
            pass
        pedido_id = kw.get('pedido_id') or req.params.get('pedido_id') or ''
        if _botao == 'retornar':
            kw['pedido_id'] = pedido_id
            req.params['botao'] = ''
            trans.finalizar()
            self.cr.close()
            if not pedido_id:
                return self.pedvda_lista(req, s_action=None, **kw)
            return self.pedvda_listar_itens(req, s_action=None, **kw)
        _deptos = {}
        _img_esquerda = ('<img src="/webmob/static/src/img/button_esquerda_40x128.png" width="40" height="120" style="border: 1px solid #2764a3;padding: 10px;border-radius: 20px;margin: 0px 5px 0px 5px">')
        _img_direita = ('<img src="/webmob/static/src/img/button_direita_40x128.png" width="40" height="120" style="border: 1px solid #2764a3;padding: 10px;border-radius: 20px;margin: 0px 5px 0px 5px">')
        _img_fixo = ('<img src="data:image;base64,var_foto" width="150" height="120" style="border: 1px solid #2764a3;padding: 10px;border-radius: 20px;margin: 0px 5px 0px 5px">')
        _itens = {}
        _qtdDeps = len(depsBrw)
        _imgPos = int(req.params.get('imgpos') or 1)
        if dep_id and not isinstance(dep_id, int) and dep_id[:1] == 'P':
            if dep_id[:4] == 'P-I-':
                if int(dep_id[4:]) < 4:
                    _imgPos = 1
                else:
                    _imgPos = int(dep_id[4:]) - 3
            elif dep_id[:4] == 'P-F-':
                if int(dep_id[4:]) + 3 > _qtdDeps:
                    _imgPos = _qtdDeps - 3
                else:
                    _imgPos = int(dep_id[4:]) + 3
            dep_id = _imgPos

        _min = _imgPos
        _max = _imgPos + 3
        i = 0
        for debBrw in depsBrw:
            i += 1
            if i < _min:
                continue
            if i > _max:
                continue
            _img = _img_fixo.replace('var_foto', debBrw.vexdep_imagem or '')
            _deptos[i] = {
                'id': debBrw.id,
                'img': _img,
            }
            _lista_itens = []
            for brw_produto in debBrw.vexdep_produtos_ids:
                for brw_grade in brw_produto.produto_grade_ids:
                    _pvenda = self._pedvda_get_preco_produto(brw_produto.id, grade_ids=[brw_grade.id])
                    _lista_itens.append({
                        'id': brw_produto.id,
                        'grade_id': brw_grade.id,
                        'nome': brw_grade.name,
                        'preco': _pvenda,
                        'foto': brw_produto.estpro_foto
                    })
            _itens[debBrw.id] = _lista_itens
        lista_btns = []
        _img_ret = '<img src="/webmob/static/src/img/button_retornar_100x100.png">'
        lista_btns.append(('pedvda_selecionar_item|retornar', '', _img_ret))
        html_btns = self._wmob_montar_botoes(lista_btns)
        linha_depto = self._wmob_get_arq_html('webmob_pvenda_portal', 'ped_lista_selec_prod_depto')
        depto_keys = _deptos.keys()
        linha = ''
        if _qtdDeps > 4:
            pos = 'P-I-%s' % _imgPos
            linha += '<a href="pedvda_selecionar_item?pedido_id=%s&dep_id=%s&imgpos=%s">%s</a>' % (pedido_id,
                                                                                     pos,
                                                                                     _imgPos,
                                                                                     _img_esquerda)
        for i in depto_keys:
            linha += '<a href="pedvda_selecionar_item?pedido_id=%s&dep_id=%s&imgpos=%s">%s</a>' % (pedido_id,
                                                                                        _deptos.get(i).get('id'),
                                                                                        _imgPos,
                                                                                        _deptos.get(i).get('img'))
        if _qtdDeps > 4:
            pos = 'P-F-%s' % (_imgPos + 4)
            linha += '<a href="pedvda_selecionar_item?pedido_id=%s&dep_id=%s&imgpos=%s">%s</a>' % (pedido_id,
                                                                                     pos,
                                                                                     _imgPos,
                                                                                     _img_direita)
        linha_depto = linha_depto.replace('var_lista_dep_imagens', linha)
        itens_fixo = self._wmob_get_arq_html('webmob_pvenda_portal', 'ped_lista_selec_prod_itens')
        linha_itens = ''
        _classe = u"sig-form-group sig-cor-fundo-branco"
        _lista_itens = []
        for x in _itens.keys():
            if x != int(dep_id):
                continue
            _lista_itens = _itens.get(x)
            break
        for x in _lista_itens:
            linha_itens += itens_fixo.replace('var_foto', x.get('foto'))\
                                     .replace('var_nome_produto', x.get('nome'))\
                                     .replace('var_preco_item', numero.getNumeroEditado(unicode(x.get('preco')), 2))\
                                     .replace('var_produto_id', unicode(x.get('id')))\
                                     .replace('var_grade_id', unicode(x.get('grade_id')))\
                                     .replace('var_classe', _classe)
        corpo = linha_depto + linha_itens
        _classe = u"sig-form-group sig-cor-fundo-azure sig-fonte-x-large"
        corpo = corpo.replace('var_classe', _classe)
        resp = self._wmob_montar_base().replace('var_titulo', _('Selecione um item')) \
            .replace('var_corpo', corpo) \
            .replace('var_botoes', html_btns) \
            .replace('var_refresh', '') \
            .replace('var_pedido_id', unicode(pedido_id or ''))
        trans.finalizar()
        self.cr.close()
        return resp

    def pedvda_duplicar_pedido(self, pedido_id):
        pedidoBrw = self.pgp('estoquepedidos.pedido.capa').browse(self.cr, self.uid, int(pedido_id), context=self.context)
        _company_id = self._webmob_get_session('company_id')
        vals = {
            'company_id': _company_id,
            'data_emissao': datetime.now().strftime('%Y-%m-%d'),
            'pessoa_id': self._webmob_get_session('upessoa_id'),
            'state': 'A',
            'tipo': 'V',
            'pedcap_origem': '2'
        }
        args = [('pessoa_id', '=', int(self._webmob_get_session('upessoa_id'))),
                ('company_id', '=', _company_id)]
        _cliente_ids = self.pgp('financeiro.cliente').search(self.cr, self.uid, args, context=self.context)
        if _cliente_ids:
            _rota = self.pgp('financeiro.cliente').read(self.cr, self.uid, _cliente_ids[0],
                                                            ['fincli_rota'], context=self.context)['fincli_rota']
            if _rota:
                vals['pedcap_rota_entrega'] = _rota[0]
        try:
            _novoPedido_id = self.pgp('estoquepedidos.pedido.capa').create(self.cr, self.uid, vals, context=self.context)
        except Exception as Err:
            logger.error('Nao consegui criar o pedido(_pedvda_get_ped) Erro: %s' % Err)
            return {'status': False, 'mensagem': _('Nao consegui duplicar o pedido!')}
        if not _novoPedido_id:
            return {'status': False, 'mensagem': _('Nao consegui duplicar o pedido!')}
        for pedItensBrw in pedidoBrw.pedido_item_ids:
            vals = {
                'qtde_pedida': pedItensBrw.qtde_pedida,
                'grade_id': pedItensBrw.grade_id.id,
                'local_id': pedItensBrw.local_id.id,
                'pedido_id': _novoPedido_id,
                'vr_unitario': pedItensBrw.vr_unitario,
                'produto_id': pedItensBrw.produto_id.id,
                'produto_embalagem_id': pedItensBrw.produto_embalagem_id.id,
            }
            ret = self.pgp('estoquepedidos.pedido.item').create(self.cr, self.uid, vals, context=self.context)
            if not ret:
                return {'status': False, 'mensagem': _('Nao consegui criar os itens do pedido!')}
        for pedCondicaoBrw in pedidoBrw.pedido_condicao_ids:
            vals = {
                'capa_id': _novoPedido_id,
                'condicao_forma_id': pedCondicaoBrw.condicao_forma_id.id,
                'forma_pagto_id': pedCondicaoBrw.forma_pagto_id.id,
                'valor': pedCondicaoBrw.valor,
            }
            _cond_id = self.pgp('estoquepedidos.pedido.condicao').create(self.cr, self.uid, vals, context=self.context)
            if not _cond_id:
                return {'status': False, 'mensagem': _('Nao consegui criar as condicoes do pedido!')}

            for pedParcelaBrw in pedCondicaoBrw.pedido_parcela_ids:
                vals = {
                    'data_vencimento': pedParcelaBrw.data_vencimento,
                    'pedido_compra_id': _novoPedido_id,
                    'pedido_condicao_id': _cond_id,
                    'vr_parcela': pedParcelaBrw.vr_parcela,
                }
                ret = self.pgp('estoquepedidos.pedido.parcela').create(self.cr, self.uid, vals, context=self.context)
                if not ret:
                    return {'status': False, 'mensagem': _('Nao consegui criar as parcelas do pedido!')}
        return {'status': True, 'dados': _novoPedido_id}

    @http.httprequest
    def pedvda_listar_itens(self, req, s_action=None, **kw):
        """
        Monta lista de itens de um pedido
        "Itens do pedido"
        """
        def recarregar():
            req.params['botao'] = ''
            self.cr.close()
            return self.pedvda_listar_itens(req, s_action=None, **kw)

        def botaoRetornar():
            req.params['botao'] = ''
            trans.finalizar()
            self.cr.close()
            return self.pedvda_lista(req, s_action=None, **kw)

        self._get_environ(req, **kw)
        trans = main.webmobTransacao(self.cr)
        if kw.get('mensagem'):
            self.oeMensagem = kw.get('mensagem')
            kw['mensagem'] = ''
        _botao = False
        if req.params.get('botao'):
            lista = req.params.get('botao').split('|')
            _botao = lista[1]
        _pedido_id = kw.get('pedido_id') or req.params.get('pedido_id')
        try:
            _pedido_id = int(_pedido_id)
        except:
            pass
        if _botao == 'adicionarItem':
            trans.finalizar()
            req.params['botao'] = ''
            self.cr.close()
            return self.pedvda_selecionar_item(req, s_action=None, **kw)

        if _botao == 'retornar':
            return botaoRetornar()
        if _botao == 'copiar':
            ret = self.pedvda_duplicar_pedido(_pedido_id)
            if ret.get('status'):
                _pedido_id = ret.get('dados')
            else:
                logger.error(_('Nao consegui atualizar o pedido(pedvda_atualizar_pedido) Erro: %s') %
                             ret.get('mensagem'))
                trans.finalizar('d')
                return recarregar()
            ret = self.pedvda_atualizar_pedido(_pedido_id)
            if not ret.get('status'):
                logger.error(_('Nao consegui atualizar o pedido(pedvda_atualizar_pedido) Erro: %s') %
                             ret.get('mensagem'))
                trans.finalizar('d')
                kw['mensagem'] = _('Nao consegui duplicar o pedido!')
                return recarregar()
            req.params['pedido_id'] = _pedido_id
            kw['pedido_id'] = _pedido_id
            kw['mensagem'] = 'Novo pedido'
            trans.finalizar()
            return recarregar()
        if _botao == 'cancelar':
            vals = {
                'state': 'C',
            }
            self.context.update({'pedcap_write_state': True})
            ret = self.pgp('estoquepedidos.pedido.capa').write(self.cr, self.uid, [_pedido_id],
                                                                        vals,
                                                                        context=self.context)
            if not ret:
                trans.finalizar('d')
                kw['mensagem'] = _('Nao consegui cancelar o pedido!')
                return recarregar()
            kw['mensagem'] = _('Pedido cancelado!')
            trans.finalizar()
            return recarregar()
        if _botao == 'enviarPedido':
            vals = {
                'state': 'R',
            }
            self.context.update({'pedcap_write_state': True})
            ret = self.pgp('estoquepedidos.pedido.capa').write(self.cr, self.uid, [_pedido_id],
                                                                        vals,
                                                                        context=self.context)
            if not ret:
                trans.finalizar('d')
                kw['mensagem'] = _('Nao consegui enviar o pedido!')
                return recarregar()
            trans.finalizar()
            kw['mensagem'] = _('Pedido enviado!')
            return recarregar()

        _dados_pedido = self.pgp('estoquepedidos.pedido.capa').read(self.cr, self.uid, _pedido_id,
                                                                    ['numero_pedido', 'state', 'data_entrega',
                                                                     'pedcap_horario_entrega'],
                                                                    context=self.context)[0]
        _pedido_nro = _dados_pedido.get('numero_pedido')
        _situacoes = self.get_situacoes()
        _situacao = _situacoes.get(_dados_pedido.get('state'))
        _var_href = ""
        if _dados_pedido.get('state') == 'A':
            _var_href = "pedvda_alterar_item?peditem_id=var_peditem_id&pedido_id=var_pedido_id"
        else:
            self.oeMensagem = self.oeMensagem or _('Este pedido nao pode mais ser alterado!')
        _classe = u"sig-form-group sig-cor-fundo-azure sig-fonte-x-large"
        lista_btns = []
        _img_ret = '<img src="/webmob/static/src/img/button_retornar_100x100.png">'
        lista_btns.append(('pedvda_listar_itens|retornar', '', _img_ret))
        if _dados_pedido.get('state') == 'A':
            _img_lixo = '<img src="/webmob/static/src/img/button_lixeira_100x100.png">'
            lista_btns.append(('pedvda_listar_itens|cancelar', '', _img_lixo))
            _img_mais = '<img src="/webmob/static/src/img/button_mais_100x100.png">'
            lista_btns.append(('pedvda_listar_itens|adicionarItem', '', _img_mais))
            _img_enviar = '<img src="/webmob/static/src/img/button_enviar_100x100.png">'
            lista_btns.append(('pedvda_listar_itens|enviarPedido', '', _img_enviar))
        if _dados_pedido.get('state') != 'A':
            _img_cop = '<img src="/webmob/static/src/img/button_copiar_100x100.png">'
            lista_btns.append(('pedvda_listar_itens|copiar', '', _img_cop))
        html_btns = self._wmob_montar_botoes(lista_btns)

        linha_entrega = var_previsao = ''
        if _dados_pedido.get('state') not in ('C',):
            if _dados_pedido.get('data_entrega') or _dados_pedido.get('pedcap_horario_entrega'):
                if _dados_pedido.get('data_entrega'):
                    var_previsao = datas.getDataNoFormato(_dados_pedido.get('data_entrega')) + ' '
                if _dados_pedido.get('pedcap_horario_entrega'):
                    var_previsao += self.pgp('adm.utils').admutl_converte_hora_float_to_str(_dados_pedido.get('pedcap_horario_entrega'))
                linha_entrega = """<div class="sig-esquerda"><b>%s %s</b></div>""" % (_('Previsao de entrega:'),
                                                                                      var_previsao)
        corpo = self._wmob_get_arq_html('webmob_pvenda_portal', 'ped_lista_capa_ped')
        corpo = corpo.replace('var_classe', _classe)\
                     .replace('var_pedido_id', unicode(_pedido_id))\
                     .replace('var_linha_previsao', linha_entrega)
        args = [('pedido_id', '=', _pedido_id)]
        itens_ids = self.pgp('estoquepedidos.pedido.item').search(self.cr, self.uid, args, context=self.context)
        template_lin = self._wmob_get_arq_html('webmob_pvenda_portal', 'ped_lista_itens')
        _bg = 1
        _qtd = _total = 0
        for itemBrw in self.pgp('estoquepedidos.pedido.item').browse(self.cr, self.uid, itens_ids, context=self.context):
            if _bg == 1:
                _bg = 2
                _bgcolor = u"#ffffff"
                _classe = u"sig-form-group sig-cor-fundo-branco"
            else:
                _bg = 1
                _bgcolor = u"#f0f8ff"
                _classe = u"sig-form-group sig-cor-fundo-azure"
            x = template_lin \
                .replace('var_classe', _classe) \
                .replace('var_href', _var_href) \
                .replace('var_peditem_id', unicode(itemBrw.id)) \
                .replace('var_pedido_id', unicode(_pedido_id)) \
                .replace('var_foto', unicode(itemBrw.produto_id.estpro_foto)) \
                .replace('var_nome_produto', unicode(itemBrw.grade_id.name)) \
                .replace('var_qtd',  numero.getNumeroEditado(unicode(itemBrw.qtde_pedida),0)) \
                .replace('var_total', numero.getNumeroEditado(unicode(itemBrw.valor_total), 2))

            corpo += x
            _qtd += itemBrw.qtde_pedida
            _total += itemBrw.valor_total

        resp = self._wmob_montar_base().replace('var_titulo', _('Itens do pedido'))\
            .replace('var_corpo', corpo)\
            .replace('var_botoes', html_btns)\
            .replace('var_refresh', '')\
            .replace('var_qtd', numero.getNumeroEditado(unicode(_qtd),0))\
            .replace('var_total', numero.getNumeroEditado(unicode(_total), 2)) \
            .replace('var_situacao', unicode(_situacao)) \
            .replace('var_nro_pedido', unicode(_pedido_nro))
        self.cr.close()
        return resp

    def get_situacoes(self):
        s = self.pgp('estoquepedidos.pedido.capa').pedcap_fields_selection_state(self.cr, self.uid, context=self.context)
        situacoes = {}
        for x in s:
            situacoes[x[0]] = x[1]
        return situacoes

    @http.httprequest
    def pedvda_lista(self, req, s_action=None, **kw):
        """
        Monta lista de pedidos do cliente
        """
        self._get_environ(req, **kw)
        if kw.get('mensagem'):
            self.oeMensagem = kw.get('mensagem')
            kw['mensagem'] = ''
        _botao = False
        if req.params.get('botao'):
            lista = req.params.get('botao').split('|')
            _botao = lista[1]
        _img_ant = '<img src="/webmob/static/src/img/button_anterior_100x100.png">'
        _img_atu = '<img src="/webmob/static/src/img/button_atualizar_100x100.png">'
        _img_ava = '<img src="/webmob/static/src/img/button_avancar_100x100.png">'
        _img_mais = '<img src="/webmob/static/src/img/button_mais_100x100.png">'

        try:
            pagTam = int(req.params.get('pagTam'))
        except:
            pagTam = 10
        try:
            pagIni = int(req.params.get('pagIni'))
        except:
            pagIni = 0
        if _botao == 'avancar':
            pagIni += pagTam
        if _botao == 'anterior':
            pagIni -= pagTam
        if _botao == 'mais':
            self.cr.close()
            return self.pedvda_selecionar_item(req, s_action=None, **kw)
        template_pag = self._wmob_get_arq_html('webmob_pvenda_portal', 'ped_lista_capa')
        template_lin = self._wmob_get_arq_html('webmob_pvenda_portal', 'ped_lista_linhas')
        lista = self._pedvda_get_ped(pagTam=pagTam, pagIni=pagIni)
        if not lista:
            kw['mensagem'] = self.oeMensagem = _('Nao consegui pegar os pedidos!')
        elif lista[0] == None:
            lista = []
        lista_btns = []
        lista_btns.append(('pedvda_lista|atualizar', '', _img_atu))
        if pagIni > 0:
            lista_btns.append(('pedvda_lista|anterior', '', _img_ant))
        if len(lista) == pagTam:
            lista_btns.append(('pedvda_lista|avancar', '', _img_ava))
        lista_btns.append(('pedvda_lista|mais', '', _img_mais))
        html_btns = self._wmob_montar_botoes(lista_btns)
        corpo = u''
        _bg = 1
        situacoes = self.get_situacoes()
        for linha in lista:
            _situacao = situacoes.get(linha.get('status'))
            if _bg == 1:
                _bg = 2
                _bgcolor = u"#ffffff"
                _classe = u"sig-form-group sig-cor-fundo-branco"
            else:
                _bg = 1
                _bgcolor = u"#f0f8ff"
                _classe = u"sig-form-group sig-cor-fundo-azure"
            x = template_lin\
                    .replace('var_classe', _classe)\
                    .replace('var_nro_pedido', unicode(linha.get('numero')))\
                    .replace('var_situacao', unicode(_situacao))\
                    .replace('var_data', unicode(linha.get('data')))\
                    .replace('var_total', unicode(linha.get('valor')))\
                    .replace('var_pedido_id', unicode(linha.get('pedido_id')))
            corpo += x
        corpo = template_pag.replace('var_table_linhas', corpo)
        _qtdReg = int(self._webmob_get_session('regqtd') or 0) / pagTam
        if (int(self._webmob_get_session('regqtd') or 0) % pagTam) > 0:
            _qtdReg += 1
        resp = self._wmob_montar_base().replace('var_titulo', _('Pedidos'))\
            .replace('var_corpo', corpo)\
            .replace('var_botoes', html_btns)\
            .replace('var_refresh', '')\
            .replace('var_pagAtu', unicode(self._webmob_get_session('regatu')))\
            .replace('var_pagTot', unicode(_qtdReg))\
            .replace('var_pagIni', unicode(pagIni))\
            .replace('var_pagTam', unicode(pagTam))
        self.cr.close()
        return resp
